/*--POSTGRESQL--*/ 



/*-- SEQ 0001 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION QualDono () CASCADE;

/*-- SEQ 0002 --*/
CREATE OR REPLACE FUNCTION QualDono ()
RETURNS VARCHAR AS $$
DECLARE

  c_Totall VARCHAR(10) := 'TOTALL';
  v_Dono VARCHAR(10);
BEGIN
  BEGIN
    SELECT COALESCE(USUADM,c_Totall) INTO v_Dono FROM TT_IDF;

    END;
  RETURN v_Dono;
END;
$$ language 'plpgsql' STABLE;




/*-- SEQ 0003 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Constante (VARCHAR) CASCADE;

/*-- SEQ 0004 --*/
CREATE OR REPLACE FUNCTION Constante (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
nomeConstante ALIAS FOR $1 ;
 -- Constantes usadas em objetos de banco.
BEGIN
   IF    UPPER(nomeConstante) = 'VEM_DE_TGVEN'                    THEN RETURN '1';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGVEN_TT'                 THEN RETURN 'A';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGVEN_TF'                 THEN RETURN 'B';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGVEN_FT'                 THEN RETURN 'C';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGVEN_FF'                 THEN RETURN 'D';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGVEN_DV'                 THEN RETURN 'V';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGCHR'                    THEN RETURN '2';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGIVE'                    THEN RETURN '3';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGICO'                    THEN RETURN '4';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGIOR'                    THEN RETURN '5';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGLAN'                    THEN RETURN '6';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGCOM'                    THEN RETURN '7';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGPED'                    THEN RETURN '8';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGCTR'                    THEN RETURN '9';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGTRC'                    THEN RETURN '0';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGPRO'                    THEN RETURN 'G';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGRTB'                    THEN RETURN '*';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGDFIL'                   THEN RETURN '@';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGCCC'                    THEN RETURN 'G';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_CALCUSMED'                THEN RETURN 'E';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_PCRECCAS'                 THEN RETURN 'F';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_PCREC'                    THEN RETURN 'H';
   ELSIF UPPER(nomeConstante) = 'COMPLEMENTO'                     THEN RETURN ' Operao cancelada.';
   ELSIF UPPER(nomeConstante) = 'WF_LER_PROJETO'                  THEN RETURN '0';
   ELSIF UPPER(nomeConstante) = 'WF_REGISTRAR_TAREFA'             THEN RETURN '1';
   ELSIF UPPER(nomeConstante) = 'WF_RESPONSAVEL'                  THEN RETURN '2';
   ELSIF UPPER(nomeConstante) = 'WF_REVISOR'                      THEN RETURN '3';
   ELSIF UPPER(nomeConstante) = 'WF_EXCLUIR_TAREFA'               THEN RETURN '4';
   ELSIF UPPER(nomeConstante) = 'WF_PROJETAR'                     THEN RETURN '5';
   ELSIF UPPER(nomeConstante) = 'WF_PLANEJAR'                     THEN RETURN '6';
   ELSIF UPPER(nomeConstante) = 'WF_GERENCIAR'                    THEN RETURN '7';
   ELSIF UPPER(nomeConstante) = 'WF_VALIDAR_RAT'                  THEN RETURN '8';
   ELSIF UPPER(nomeConstante) = 'LIMITE'                          THEN RETURN '238';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGPRJ'                    THEN RETURN '1';
   ELSIF UPPER(nomeConstante) = 'TG_REC_VAZIO'                    THEN RETURN 'J';
   ELSIF UPPER(nomeConstante) = 'OLD_VEM_DE_PCRECCAS'             THEN RETURN 'L';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_PCLEX'                    THEN RETURN 'M';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_ESTORNO'                  THEN RETURN 'N';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_CANCELA_NF'               THEN RETURN 'O';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_ATU_RES_PEND'             THEN RETURN 'P';
   ELSIF UPPER(nomeConstante) = 'ALTERA_TIPENT'                   THEN RETURN 'A';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_PC_IVO'                   THEN RETURN 'Q';
   ELSIF UPPER(nomeConstante) = 'UNIAO_PARCEIROS'                 THEN RETURN 'R';
   ELSIF UPPER(nomeConstante) = 'ALT_TITAVU'                      THEN RETURN 'S';
   ELSIF UPPER(nomeConstante) = 'AJUSTE_VAL_PARCELA'              THEN RETURN 'T';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGWCLI'                   THEN RETURN 'U';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGVEN_DV_CMS'             THEN RETURN 'X';
   ELSIF UPPER(nomeConstante) = 'RESGATE_BONUS'                   THEN RETURN 'B';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGACM'                    THEN RETURN 'Y';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGFER'                    THEN RETURN 'Z';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_REMOVEITEMTA'             THEN RETURN '1';
   ELSIF UPPER(nomeConstante) = 'NUMPAR_FIN_VENDAS_CANCELADAS'    THEN RETURN ' 1';
   ELSIF UPPER(nomeConstante) = 'SUBPAR_FIN_VENDAS_CANCELADAS'    THEN RETURN ' 0';
   ELSIF UPPER(nomeConstante) = 'MANTEM_ATU_EM'                   THEN RETURN '1';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGIVEXIPE'                THEN RETURN '2';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_LUCRATIVIDADE'            THEN RETURN 'L';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGORC'                    THEN RETURN '2';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_ANONIMIZACAO'             THEN RETURN 'A';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_TGTRA'                    THEN RETURN '3';
   ELSIF UPPER(nomeConstante) = 'VEM_DE_DESCANCELA_VENDA'         THEN RETURN '%';
   ELSE RAISE EXCEPTION 'PG-20000 No foi encontrada a constante enviada. Operao Cancelada.';
   END IF;
END;
$$ language 'plpgsql';





/*-- SEQ 0005 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TEXT_CONCAT(TEXT,TEXT) CASCADE;

/*-- SEQ 0006 --*/
CREATE OR REPLACE FUNCTION TEXT_CONCAT(TEXT,TEXT) RETURNS TEXT AS $$
  SELECT COALESCE($1 ||chr(13)||chr(10)||$2,$2)
$$ LANGUAGE SQL;

/*-- SEQ 0007 --*/
CREATE AGGREGATE AGREGATXT(
  BASETYPE = TEXT,
  SFUNC    = TEXT_CONCAT,
  STYPE    = TEXT);


/*-- SEQ 0008 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TO_NAME (VARCHAR) CASCADE;

/*-- SEQ 0009 --*/
CREATE OR REPLACE FUNCTION TO_NAME (VARCHAR)
RETURNS NAME AS $$
DECLARE
pNome ALIAS FOR $1 ;
BEGIN

 RETURN pNome::name;

END;
$$ language 'plpgsql';




/*-- SEQ 0010 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TO_PATH (VARCHAR) CASCADE;

/*-- SEQ 0011 --*/
CREATE OR REPLACE FUNCTION TO_PATH (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pPath ALIAS FOR $1 ;
BEGIN
  -- Substitui barra normal por barra invertida
  RETURN replace(pPath, '/', CHR(92)); 
END;
$$ language 'plpgsql' STABLE;




/*-- SEQ 0012 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GetApeUsuAtual () CASCADE;

/*-- SEQ 0013 --*/
CREATE OR REPLACE FUNCTION GetApeUsuAtual ()
RETURNS TT_USU.APEUSU%TYPE AS $$
DECLARE


-- Objetivos:
-- 1. Retorna o apelido do usurio logado

-- Declarao de variveis e cursores
   cAPEUSU                       TT_USU.APEUSU%TYPE;

-- Incio da funo
BEGIN
   BEGIN
      SELECT APEUSU INTO cAPEUSU FROM TMP_UID;
   EXCEPTION
      WHEN OTHERS THEN cAPEUSU := NULL;
   END;
   
   IF ISNULL(cAPEUSU) = 'T' THEN
      cAPEUSU := QualDono();
   END IF;

  RETURN cAPEUSU;

END;
$$ language 'plpgsql' STABLE;





 /*-- SEQ 0014 --*/
/*--IGNORE ERRO--*/
DROP TYPE TRetAuxValida CASCADE;

/*-- SEQ 0015 --*/
/*--IGNORE ERRO--*/
CREATE TYPE TRetAuxValida as (Retorno Numeric,
                   Inicio Timestamp,
                   Fim Timestamp);

 /*-- SEQ 0016 --*/
/*--IGNORE ERRO--*/
DROP TYPE TRetQuemLogou CASCADE;

/*-- SEQ 0017 --*/
/*--IGNORE ERRO--*/
CREATE TYPE TRetQuemLogou as (Encontrou Boolean,
                   FILUSU CHAR(3),
                   CODUSU CHAR(3),
                   FILDIF CHAR(3),
                   SEQDIF CHAR(10),
                   TIPDIF CHAR(1),
                   TemConta Boolean);

 /*-- SEQ 0018 --*/
/*--IGNORE ERRO--*/
DROP TYPE TPC_TIT_Record CASCADE;

/*-- SEQ 0019 --*/
/*--IGNORE ERRO--*/
CREATE TYPE TPC_TIT_Record as (CODBCO CHAR(3),
                   NUMAGE CHAR(5),
                   CTACRR CHAR(10),
                   CODCCB Numeric(5),
                   STATUS CHAR(1),
                   DIGCRR CHAR(1),
                   DIGAGE CHAR(2),
                   NUMAGE_NOSNUM CHAR(5),
                   DIGAGE_NOSNUM CHAR(2));

 /*-- SEQ 0020 --*/
/*--IGNORE ERRO--*/
DROP TYPE TPC_TIT_RecordCFG CASCADE;

/*-- SEQ 0021 --*/
/*--IGNORE ERRO--*/
CREATE TYPE TPC_TIT_RecordCFG as (INT_CAN_TIT Numeric(5),
                   INT_ALT_DAT Numeric(5),
                   INT_ALT_VLR Numeric(5),
                   INT_PAG_CAR Numeric(5),
                   INT_INC_TIT Numeric(5),
                   INT_CON_ABA Numeric(5),
                   COD_ECB_TIT Numeric(5),
                   STATUS CHAR(1));

 /*-- SEQ 0022 --*/
/*--IGNORE ERRO--*/
DROP TYPE TPC_TIT_RecordJur CASCADE;

/*-- SEQ 0023 --*/
/*--IGNORE ERRO--*/
CREATE TYPE TPC_TIT_RecordJur as (DATMOR Timestamp,
                   JURMOR Numeric(15,2),
                   DATDES Timestamp,
                   JURDES Numeric(15,2),
                   CODMOR Numeric(1),
                   CODDES Numeric(1),
                   CODBAI Numeric(1),
                   PRZBAI Numeric(2),
                   CODPRT Numeric(1),
                   PRZPRT Numeric(2),
                   STATUS CHAR(1));

 /*-- SEQ 0024 --*/
/*--IGNORE ERRO--*/
DROP TYPE TPC_TIT_Retorno CASCADE;

/*-- SEQ 0025 --*/
/*--IGNORE ERRO--*/
CREATE TYPE TPC_TIT_Retorno as (NOME VARCHAR(255),
                   NUMERO Numeric,
                   STATUS CHAR(1),
                   CODCNV VARCHAR(20),
                   APECRB VARCHAR(20),
                   CODCED VARCHAR(20),
                   CODMOD VARCHAR(10),
                   CODTRA VARCHAR(20),
                   CODGER VARCHAR(1));

 /*-- SEQ 0026 --*/
/*--IGNORE ERRO--*/
DROP TYPE TPC_IXT_Retorno CASCADE;

/*-- SEQ 0027 --*/
/*--IGNORE ERRO--*/
CREATE TYPE TPC_IXT_Retorno as (REMBCO Numeric(3),
                   INSTR1 Numeric(5),
                   INSTR2 Numeric(5));

 /*-- SEQ 0028 --*/
/*--IGNORE ERRO--*/
DROP TYPE TPC_UID_Retorno CASCADE;

/*-- SEQ 0029 --*/
/*--IGNORE ERRO--*/
CREATE TYPE TPC_UID_Retorno as (CODUID Numeric,
                   ASSINS VARCHAR(1),
                   BLQ_SEM_UID VARCHAR(1));
 
 /*-- SEQ 0030 --*/
/*--IGNORE ERRO--*/
DROP TYPE TRetBuscaParametro CASCADE;

/*-- SEQ 0031 --*/
/*--IGNORE ERRO--*/
CREATE TYPE TRetBuscaParametro as (Encontrou BOOLEAN,
                   VLRNUM Numeric(16,4),
                   VLRINT Numeric(10,0),
                   VLRTXT VARCHAR(100),
                   VLRBOO VARCHAR(1),
                   VLRDAT Timestamp);
 
 /*-- SEQ 0032 --*/
/*--IGNORE ERRO--*/
DROP TYPE TRetAuxTabPrivs CASCADE;

/*-- SEQ 0033 --*/
/*--IGNORE ERRO--*/
CREATE TYPE TRetAuxTabPrivs as (idOwner BIGINT,
                   table_name VARCHAR(255),
                   grantee VARCHAR(255),
                   privilege VARCHAR(255));


 /*-- SEQ 0034 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Equal (Numeric,Numeric) CASCADE;

/*-- SEQ 0035 --*/
CREATE OR REPLACE FUNCTION Equal (Numeric,Numeric)
RETURNS integer AS $$
DECLARE
p_primeiro ALIAS FOR $1 ;
p_segundo ALIAS FOR $2 ;
 BEGIN
   IF (p_primeiro IS NULL) AND (p_segundo IS NULL) THEN
      RETURN 1;
   ELSIF (p_primeiro IS NULL) AND (p_segundo IS NOT NULL) THEN
      RETURN 0;
   ELSIF (p_primeiro IS NOT NULL) AND (p_segundo IS NULL) THEN
      RETURN 0;
   ELSIF (p_primeiro = p_segundo) THEN
      RETURN 1;
   ELSE
      RETURN 0;
   END IF;   
 END;
$$ language 'plpgsql';

 /*-- SEQ 0036 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Equal (VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 0037 --*/
CREATE OR REPLACE FUNCTION Equal (VARCHAR,VARCHAR)
RETURNS integer AS $$
DECLARE
p_primeiro ALIAS FOR $1 ;
p_segundo ALIAS FOR $2 ;
 BEGIN
   
   IF (TRIM(p_primeiro)::VARCHAR = '' AND p_segundo IS NULL) OR
      (p_primeiro IS NULL and TRIM(p_segundo)::VARCHAR = '') THEN     
     
     RAISE NOTICE 'Foi comparado um valor vazio com um valor nulo';
   END IF;
   
   IF (p_primeiro IS NULL) AND (p_segundo IS NULL) THEN
     RETURN 1;
   ELSIF (p_primeiro IS NULL) AND (p_segundo IS NOT NULL) THEN
     RETURN 0;
   ELSIF (p_primeiro IS NOT NULL) AND (p_segundo IS NULL) THEN
     RETURN 0;
   ELSIF (p_primeiro = p_segundo) THEN
     RETURN 1;
   ELSE
     RETURN 0;
   END IF;
 END;
$$ language 'plpgsql';

 /*-- SEQ 0038 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Equal (Timestamp,Timestamp) CASCADE;

/*-- SEQ 0039 --*/
CREATE OR REPLACE FUNCTION Equal (Timestamp,Timestamp)
RETURNS integer AS $$
DECLARE
p_primeiro ALIAS FOR $1 ;
p_segundo ALIAS FOR $2 ;
 BEGIN
   IF (p_primeiro IS NULL) AND (p_segundo IS NULL) THEN
      RETURN 1;
   ELSIF (p_primeiro IS NULL) AND (p_segundo IS NOT NULL) THEN
      RETURN 0;
   ELSIF (p_primeiro IS NOT NULL) AND (p_segundo IS NULL) THEN
      RETURN 0;
   ELSIF (p_primeiro = p_segundo) THEN
      RETURN 1;
   ELSE
      RETURN 0;
   END IF;
 END;
$$ language 'plpgsql';

 /*-- SEQ 0040 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION MaxValue (Numeric,Numeric) CASCADE;

/*-- SEQ 0041 --*/
CREATE OR REPLACE FUNCTION MaxValue (Numeric,Numeric)
RETURNS integer AS $$
DECLARE
p_primeiro ALIAS FOR $1 ;
p_segundo ALIAS FOR $2 ;
 BEGIN
   IF Equal(p_primeiro,p_segundo) = 1 THEN
      RETURN -1; -- Os parametros sao iguais
   ELSIF (p_primeiro > p_segundo) THEN
      RETURN 0;  -- Primeiro parametro e maior
   ELSE
      RETURN 1;  -- Segundo parametro e maior
   END IF;
 END;
$$ language 'plpgsql';

 /*-- SEQ 0042 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION MinValue (Numeric,Numeric) CASCADE;

/*-- SEQ 0043 --*/
CREATE OR REPLACE FUNCTION MinValue (Numeric,Numeric)
RETURNS integer AS $$
DECLARE
p_primeiro ALIAS FOR $1 ;
p_segundo ALIAS FOR $2 ;
 BEGIN
   IF Equal(p_primeiro,p_segundo) = 1 THEN
     RETURN -1; -- Os parametros sao iguais
   ELSIF (p_primeiro < p_segundo) THEN
     RETURN 0;  -- Primeiro parametro e menor
   ELSE
     RETURN 1;  -- Segundo parametro e menor
   END IF;
 END;
$$ language 'plpgsql';

 /*-- SEQ 0044 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Dat2ChrAssina (Timestamp) CASCADE;

/*-- SEQ 0045 --*/
CREATE OR REPLACE FUNCTION Dat2ChrAssina (Timestamp)
RETURNS VARCHAR AS $$
DECLARE
p_Valor ALIAS FOR $1 ;
 BEGIN
   RETURN CASE WHEN p_Valor IS NULL THEN '' ELSE TO_CHAR(p_Valor,'DD/MM/YYYY HH24:MI:SS') END;
 END;
$$ language 'plpgsql'; 
 
 /*-- SEQ 0046 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Chr2ChrAssina (VARCHAR) CASCADE;

/*-- SEQ 0047 --*/
CREATE OR REPLACE FUNCTION Chr2ChrAssina (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
p_Valor ALIAS FOR $1 ;
 BEGIN
   RETURN UPPER(TRIM(COALESCE(p_Valor,'')));
 END;
$$ language 'plpgsql';  
 
 /*-- SEQ 0048 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION NumDec2ChrAssina (Numeric) CASCADE;

/*-- SEQ 0049 --*/
CREATE OR REPLACE FUNCTION NumDec2ChrAssina (Numeric)
RETURNS VARCHAR AS $$
DECLARE
p_Valor ALIAS FOR $1 ;
 BEGIN
   RETURN TRUNC(COALESCE(p_Valor,0) * 10000);
 END;
$$ language 'plpgsql';
 
 /*-- SEQ 0050 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Num2ChrAssina (Numeric) CASCADE;

/*-- SEQ 0051 --*/
CREATE OR REPLACE FUNCTION Num2ChrAssina (Numeric)
RETURNS INTEGER AS $$
DECLARE
p_Valor ALIAS FOR $1 ;
 BEGIN
   RETURN TRUNC(COALESCE(p_Valor,0));
 END;
$$ language 'plpgsql'; 
 
 /*-- SEQ 0052 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION BigNum2ChrAssina (Numeric) CASCADE;

/*-- SEQ 0053 --*/
CREATE OR REPLACE FUNCTION BigNum2ChrAssina (Numeric)
RETURNS Numeric AS $$
DECLARE
p_Valor ALIAS FOR $1 ;
 BEGIN
   RETURN TRUNC(COALESCE(p_Valor,0));
 END;
$$ language 'plpgsql';  
 
 /*-- SEQ 0054 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SenIntPlsql () CASCADE;

/*-- SEQ 0055 --*/
CREATE OR REPLACE FUNCTION SenIntPlsql ()
RETURNS VARCHAR AS $$
DECLARE

 BEGIN
   RETURN '9uuQH980yfUH3Foi980Yf9y8fPHf9y80';
 END;
$$ language 'plpgsql';  
 
 

/*-- SEQ 0056 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GetPrivileges () CASCADE;

/*-- SEQ 0057 --*/
CREATE OR REPLACE FUNCTION GetPrivileges ()
RETURNS SetOF TRetAuxTabPrivs AS $$
DECLARE

  wk_priv       aclitem[];
  wk_relname    name;
  wk_relowner   bigint;
  count      integer;
  vRetorno   TRetAuxTabPrivs%ROWTYPE;
  temp       VARCHAR;
  temp2      VARCHAR;

  Classes CURSOR FOR
    SELECT relname, relowner, relacl
      FROM pg_class;

BEGIN

  OPEN Classes;
  LOOP
    FETCH Classes INTO wk_relname, wk_relowner, wk_priv;
    EXIT WHEN NOT FOUND;

    -- r : SELECT ("read")
    -- w : UPDATE ("write")
    -- a : INSERT ("append")
    -- d : DELETE
    -- R : RULE
    -- x : REFERENCES
    -- t : TRIGGER
    -- arwdRxt : ALL PRIVILEGES

    vRetorno.idOwner = wk_relowner;
    vRetorno.table_name = wk_relname;

    -- Separando o array em linhas
    count := 0;
    LOOP
      IF wk_priv[count] is null then
        Exit;
      END IF;

      temp := wK_priv[count];

      -- Retirar o Quem ou Grantee
      if substr(temp,1,1) = '=' then
       vRetorno.Grantee := 'PUBLIC';
      else
        vRetorno.Grantee := substr(temp,1,InStr(temp,'=')-1);

        -- Verfifica se  um grupo
        temp2 := trim(substr(vRetorno.Grantee,1,InStr(vRetorno.Grantee,' ')));
        if temp2 = 'group' then
           -- ento  um grupo
           vRetorno.Grantee := substr(vRetorno.Grantee,InStr(vRetorno.Grantee,' ')+1,length(vRetorno.Grantee) );
        end if;
      end if;

      temp := substr(temp,InStr(temp,'=')+1,length(temp));

      -- Pegar permisses
      if InStr(temp,'r')>0 then
        vRetorno.Privilege := 'SELECT';
        RETURN NEXT vRetorno;
      end if;
      if InStr(temp,'w')>0 then
        vRetorno.Privilege := 'UPDATE';
        RETURN NEXT vRetorno;
      end if;
      if InStr(temp,'a')>0 then
        vRetorno.Privilege := 'INSERT';
        RETURN NEXT vRetorno;
      end if;
      if InStr(temp,'d')>0 then
        vRetorno.Privilege := 'DELETE';
        RETURN NEXT vRetorno;
      end if;
      if InStr(temp,'R')>0 then
        vRetorno.Privilege := 'RULE';
        RETURN NEXT vRetorno;
      end if;
      if InStr(temp,'x')>0 then
        vRetorno.Privilege := 'REFERENCES';
        RETURN NEXT vRetorno;
      end if;
      if InStr(temp,'t')>0 then
        vRetorno.Privilege := 'TRIGGER';
        RETURN NEXT vRetorno;
      end if;

      count := count + 1;
    END LOOP;
  END LOOP;

  Close Classes;
  RETURN;
END;
$$ language 'plpgsql';




/*-- SEQ 0058 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SomenteNumeros (VARCHAR) CASCADE;

/*-- SEQ 0059 --*/
CREATE OR REPLACE FUNCTION SomenteNumeros (VARCHAR)
RETURNS Numeric AS $$
DECLARE
p_String ALIAS FOR $1 ;

-- Objetivos:
-- 1. Receber uma string e retornar somente os nmeros

-- Incio da funo
   nNumero Numeric;
BEGIN

  nNumero := TO_NUMBER(                     NULLIF(regexp_replace(p_String, '[^0-9]', '', 'gi'), ''));

  Return COALESCE(nNumero, 0);
END;
$$ language 'plpgsql';




/*-- SEQ 0060 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SomenteNumerosVarChar (VARCHAR) CASCADE;

/*-- SEQ 0061 --*/
CREATE OR REPLACE FUNCTION SomenteNumerosVarChar (VARCHAR)
RETURNS Numeric AS $$
DECLARE
p_String ALIAS FOR $1 ;

-- Objetivos:
-- 1. Receber uma string e retornar somente os nmeros

-- Incio da funo
   cNumero VARCHAR(100);
BEGIN

  cNumero :=                      NULLIF(regexp_replace(p_String, '[^0-9]', '', 'gi'), '');

  Return Trim(cNumero);
END;
$$ language 'plpgsql';




/*-- SEQ 0062 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TemFun (TT_FUN.NOMFUN%TYPE) CASCADE;

/*-- SEQ 0063 --*/
CREATE OR REPLACE FUNCTION TemFun (TT_FUN.NOMFUN%TYPE)
RETURNS CHAR AS $$
DECLARE
p_Nomfun ALIAS FOR $1 ;

-- Objetivos:
-- 1. Verificar se existe determinada funcionalidade.

wk_Existe        Numeric(1);

-- Incio da funo
BEGIN

   SELECT COALESCE((SELECT 1 AS OK
                      FROM TT_FUN
                     WHERE NOMFUN = p_Nomfun),0)
     INTO wk_Existe
     FROM DUAL;

   IF wk_Existe = 1 THEN
      RETURN 'T';
   ELSE
      RETURN 'F';
   END IF;

END;
$$ language 'plpgsql';




/*-- SEQ 0064 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TiraAcento (VARCHAR) CASCADE;

/*-- SEQ 0065 --*/
CREATE OR REPLACE FUNCTION TiraAcento (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pString ALIAS FOR $1 ;

-- Objetivos:
-- 1. Retirar acentos das letras para facilitar busca.

-- Declarao de variveis e cursores
   cResultado                    VARCHAR(4000);

-- Incio da funo
BEGIN

   cResultado := TRANSLATE(pString, '',
                                    'AAAAAEEEEIIIIOOOOOUUUUYNCaaaaaeeeeiiiiooooouuuuync');

   RETURN cResultado;

END;
$$ language 'plpgsql';




/*-- SEQ 0066 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ADD_MONTHS (Timestamp,number) CASCADE;

/*-- SEQ 0067 --*/
CREATE OR REPLACE FUNCTION ADD_MONTHS (timestamp,numeric)
RETURNS Timestamp AS $$
DECLARE
pData ALIAS FOR $1 ;
pMeses ALIAS FOR $2 ;
BEGIN
   RETURN trunc(pData) + interval '1 month' * pMeses;
END;
$$ language 'plpgsql' STRICT IMMUTABLE;




/*-- SEQ 0068 --*/
CREATE OR REPLACE FUNCTION Agora ()
RETURNS Timestamp AS '
DECLARE

BEGIN
    RETURN current_timestamp;

END;
' language 'plpgsql' STABLE;




/*-- SEQ 0069 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Aux_TVCUSMED (TR_MOV.CODFIL%TYPE,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,Timestamp,Timestamp) CASCADE;

/*-- SEQ 0070 --*/
CREATE OR REPLACE FUNCTION Aux_TVCUSMED (TR_MOV.CODFIL%TYPE,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,Timestamp,Timestamp)
RETURNS setof record AS $$
DECLARE
pCodfil ALIAS FOR $1 ;
pFilmat ALIAS FOR $2 ;
pCodmat ALIAS FOR $3 ;
pCodcor ALIAS FOR $4 ;
pCodtam ALIAS FOR $5 ;
pDatini ALIAS FOR $6 ;
pDatfim ALIAS FOR $7 ;
   RECMOV RECORD;
   nSALDO       NUMERIC;    
   nGER_FINANC  NUMERIC;
   nFIS_FINANC  NUMERIC;
   Lista CURSOR FOR
  select NATURE,DOCUME,QTDMOV,GER_CUSTO,FIS_CUSTO,TIPMOV,CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,
         DATMOV,ORD_CM,VLRMOV,                                
         cast(COALESCE(TO_CHAR(DATMOV,'DD/MM/YYYY'),'Anterior') as VARCHAR(10)) AS DATA,              
         0.0 AS SALDO,
         0.0 AS GER_FINANC,
         0.0 AS FIS_FINANC
    from (SELECT TO_CHAR(null) AS NATURE,                                               
                 TO_CHAR(null) AS DOCUME,                                               
                 CUSTOMEDIO(CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,1,DATMOV) AS QTDMOV,     
                 CUSTOMEDIO(CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,5,DATMOV)*               
                 CUSTOMEDIO(CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,1,DATMOV) AS GER_CUSTO,  
                 CUSTOMEDIO(CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,3,DATMOV)*               
                 CUSTOMEDIO(CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,1,DATMOV) AS FIS_CUSTO,  
                 TO_CHAR('I') AS TIPMOV,                                              
                 CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,                                    
                 to_date(to_char(null),'dd/mm/yyyy') as DATMOV,                       
                 0 AS ORD_CM,                                                           
                 TO_NUMBER(NULL) AS VLRMOV                                              
            FROM (SELECT pCODFIL AS CODFIL,                                              
                         pFILMAT AS FILMAT,                                              
                         pCODMAT AS CODMAT,                                              
                         pCODCOR AS CODCOR,                                                  
                         pCODTAM AS CODTAM,                                                  
                         ADD_DAY(pdatIni,-1) AS DATMOV           
                    FROM DUAL  ) INT                                                    
            WHERE CUSTOMEDIO(CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,1,DATMOV)>0             
          UNION ALL                                                                     
          SELECT NATURE, DOCUME, QTDMOV, GER_CUSTO, FIS_CUSTO, TIPMOV,                  
                 CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,DATMOV,ORD_CM,VLRMOV                
            FROM tv_cusmed) CM     
  WHERE CODFIL=pCODFIL
    AND FILMAT=pFILMAT
    AND CODMAT=pCODMAT
    AND CODCOR=pCODCOR
    AND CODTAM=pCODTAM
    AND (datmov is null or datmov between pdatIni and pDatFim)
 ORDER BY abs(ord_cm),DATMOV;

BEGIN
   nSALDO:=0;
   nGER_FINANC:=0;
   nFIS_FINANC:=0;
   OPEN LISTA;
   LOOP
      FETCH LISTA INTO RECMOV;
      EXIT WHEN NOT FOUND;
      nSALDO     :=nSALDO+COALESCE(RECMOV.QTDMOV);
      nGER_FINANC:=nGER_FINANC+COALESCE(RECMOV.GER_CUSTO);
      nFIS_FINANC:=nFIS_FINANC+COALESCE(RECMOV.FIS_CUSTO);
      RECMOV.SALDO:=nSALDO;
      RECMOV.GER_FINANC:=nGER_FINANC;
      RECMOV.FIS_FINANC:=nFIS_FINANC;
      RETURN NEXT RECMOV;
   END LOOP;
   CLOSE LISTA;
   RETURN;

END;
$$ language 'plpgsql';

  


CREATE OR REPLACE FUNCTION TrazFuncao(VarChar, VarChar, VarChar, Int2, OidVector, VarChar)
RETURNS VARCHAR AS $$
DECLARE
  pNome     ALIAS FOR $1;
  pLanguage ALIAS FOR $2;
  pRet      ALIAS FOR $3;
  pNumArgs  ALIAS FOR $4;
  pArgs     ALIAS FOR $5;
  pText     ALIAS FOR $6;
  wk_tipo   Varchar;
  i Int2;
  Funcao VarChar;
BEGIN
  Funcao := 'CREATE OR REPLACE FUNCTION ' || pNome || ' ( ';

  FOR i IN 0..pNumArgs-1 LOOP
    SELECT typname into wk_tipo
    from pg_type
    where oid = pArgs[i];

    Funcao := Funcao || wk_tipo;

    if (i != pNumArgs-1) then
      Funcao := Funcao || ',';
    end if;
  END LOOP;

  Funcao := Funcao || ') RETURNS ' || pRet || ' AS ' || chr(39) || pText ;
  Funcao := Funcao || chr(39) || ' language ' || chr(39) || pLanguage ||  chr(39)||';';
  return Funcao;
END;
$$ language 'plpgsql';

CREATE OR REPLACE FUNCTION ValorSequencia(VarChar,VarChar)
RETURNS varchar AS $$
DECLARE
  pNome       ALIAS FOR $1;
  pParametro  ALIAS FOR $2;    
  retorno     RECORD;
  curs1       refcursor;  
BEGIN
  
  OPEN CURS1 FOR EXECUTE 'SELECT * FROM ' || pNome;
  
  LOOP
    FETCH curs1 INTO retorno;
    EXIT WHEN NOT FOUND;
        IF pParametro='min_value' THEN 
           return retorno.min_value;
        ELSIF pParametro='max_value' THEN 
           return retorno.max_value;
        ELSIF pParametro='increment_by' THEN 
           return retorno.increment_by;
        ELSIF pParametro='is_cycled' THEN
           return CASE WHEN retorno.is_cycled THEN 'Y' 
                                              ELSE 'N'
                  END;
        ELSIF pParametro='cache_value' THEN
           return retorno.cache_value;        
        ELSIF pParametro='last_value' THEN
           return retorno.last_value;
        END IF;        
  END LOOP;    
  
END;
$$ language 'plpgsql';  
   

/*-- SEQ 0071 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CAMPOS_COM_VAZIOS (VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 0072 --*/
CREATE OR REPLACE FUNCTION CAMPOS_COM_VAZIOS (VARCHAR,VARCHAR)
RETURNS INTEGER AS $$
DECLARE
   pTabela ALIAS FOR $1 ;
   pCampo ALIAS FOR $2 ;
   vAux integer;
   curs1 refcursor;   
   vQuery VARCHAR(255);
BEGIN       
    vQuery='SELECT count(*) FROM '||quote_ident(pTabela)|| ' WHERE trim('||quote_ident(pCAMPO)||')='||chr(39)||chr(39);    
    --RAISE NOTICE '%,%',pTabela,pCampo;
    OPEN curs1 FOR EXECUTE vQuery;
    FETCH curs1 INTO vAUX ;
    CLOSE curs1;
     
    IF vAUX>0 THEN
       RETURN 1;
    ELSE
       RETURN 0;
    END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 0073 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CONNECTBY_BACK (VARCHAR,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 0074 --*/
CREATE OR REPLACE FUNCTION CONNECTBY_BACK (VARCHAR,VARCHAR,VARCHAR,VARCHAR)
RETURNS setof record AS $$
DECLARE
   pTabela ALIAS FOR $1 ;
   pCampoFilho ALIAS FOR $2 ;
   pCampoPai ALIAS FOR $3 ;
   pStart ALIAS FOR $4 ;
   vCHVPAI VARCHAR(255);
   vCHVFIL VARCHAR(255);       
   curs1 refcursor;   
   vQuery VARCHAR(255);
   rec Record;
   vORDEM integer;
   vNIVEL integer;
   vNroFilhos integer;
   a_vfilhos VARCHAR[];
   i integer;
BEGIN    
    if pStart is null then 
       vQuery='SELECT '||quote_ident(pCampoFilho)||' as FILHO FROM '||pTabela;    
    else
       vQuery='SELECT '||quote_ident(pCampoFilho)||' as FILHO FROM '||pTabela|| ' WHERE '||quote_ident(pCampoFilho)||'='||chr(39)||pStart||chr(39);    
    end if;
    vCHVFIL:=pStart;
    vNroFilhos=0;
    OPEN curs1 FOR EXECUTE vQuery;            
    LOOP
        vNroFilhos:=vNroFilhos+1;
        FETCH curs1 INTO vCHVFIL;
        EXIT WHEN NOT FOUND;
        IF vNroFilhos = 1 THEN
           select ARRAY[coalesce(vCHVFIL,'')] into a_vfilhos;
        ELSE
           select array_append (a_vfilhos,vCHVFIL) into a_vfilhos;
        END IF;                
    END LOOP;    
    CLOSE curs1;        
    vOrdem:=0;
    FOR i IN 1..vNroFilhos-1 LOOP
        vNivel:=0;
        select a_vfilhos[i] into vCHVFIL;
        LOOP
            vQuery='SELECT '||quote_ident(pCampoPai)||' as PAI FROM '||pTabela|| ' WHERE to_char('||quote_ident(pCampoFilho)||')='||chr(39)||coalesce(vCHVFIL,'')||chr(39);
            --raise notice '%',vQuery;
            vNivel:=vNivel+1;
            vOrdem:=vOrdem+1;            
            OPEN curs1 FOR EXECUTE vQuery;            
            FETCH curs1 INTO vCHVPAI ;
            select vCHVFIL as CODIGO, vCHVPAI as CODPAI, vNivel as nivel, vOrdem as ordem into rec;                            
            return next rec;
            vCHVFIL=vCHVPAI;            
            EXIT WHEN vCHVPAI IS NULL;
            CLOSE curs1;
        END LOOP;
        CLOSE curs1;
    END LOOP;  
    RETURN;
END;
$$ language 'plpgsql';
/*-- SEQ 0075 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION droptriggers(varchar) CASCADE;

/*-- SEQ 0076 --*/
CREATE OR REPLACE FUNCTION droptriggers(varchar)
  RETURNS varchar AS
$$
DECLARE
pTable_Name ALIAS FOR $1 ;
  RESULTADO VARCHAR(4000);
  vTrigger   VARCHAR(255);
  Names_Triggers CURSOR FOR
    SELECT FUNCTION_NAME
      FROM ALL_TRIGGERS
     WHERE TABLE_NAME like PTable_Name
       AND OWNER like QUALDONO();
BEGIN  
  RESULTADO:='';  
  OPEN Names_Triggers;
  LOOP
    FETCH Names_Triggers INTO vTrigger;
    EXIT WHEN NOT FOUND;
    vTrigger:='DROP FUNCTION '||vTrigger||'() CASCADE;';
              
    IF ISNULL(RESULTADO)='T' THEN
       RESULTADO:=vTrigger||chr(13)||chr(10);
    ELSE
       RESULTADO:=RESULTADO||vTrigger||chr(13)||chr(10);
    END IF;
  END LOOP;
  CLOSE Names_Triggers;

  RETURN RESULTADO;

END;
$$
  LANGUAGE 'plpgsql' VOLATILE;

/*-- SEQ 0077 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ExecAlteraTipoColuna (VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 0078 --*/
CREATE OR REPLACE FUNCTION ExecAlteraTipoColuna (VARCHAR,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
  pTabela   ALIAS FOR $1 ;
  pCampo    ALIAS FOR $2 ;
  pNovoTipo ALIAS FOR $3 ;
  cComando VARCHAR(255);
   
  cur_views CURSOR (pTabela_ VARCHAR, pCampo_ VARCHAR)  FOR 
    SELECT 'drop view '||viw.relname||' cascade;' AS comando
      FROM pg_attribute att inner join pg_depend dep on dep.refobjsubid = att.attnum 
                            inner join pg_rewrite rew on rew.oid=dep.objid 
                            inner join pg_class viw on viw.oid=rew.ev_class
                            inner join pg_class tab on dep.refobjid=tab.oid and att.attrelid=tab.oid
                            left  join pg_namespace scm  ON scm.oid = tab.relnamespace
         WHERE dep.refclassid=1259 
           AND att.attname=lower(pCampo)
           AND dep.classid='pg_rewrite'::regclass
           AND rew.rulename='_RETURN' 
           AND tab.relname=lower(pTabela)
           AND scm.nspname = current_schema()
     LIMIT 1;
         
BEGIN  
    
    LOOP
       Open cur_views(pTabela, pCAMPO);
       FETCH cur_views INTO cCOMANDO;
       EXIT WHEN NOT FOUND;
       RAISE NOTICE 'Executando %',cCOMANDO;
       EXECUTE cCOMANDO;
       Close cur_views;
    END LOOP;    
     
    EXECUTE 'ALTER TABLE '||pTabela||' alter column '||pCampo||' type '||pNovoTipo||';';
   RETURN NULL;
END;
$$ language 'plpgsql';


/*-- SEQ 0079 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IntervaloDias (Timestamp,Timestamp) CASCADE;

/*-- SEQ 0080 --*/
CREATE OR REPLACE FUNCTION IntervaloDias (Timestamp,Timestamp)
RETURNS integer AS $$
DECLARE
pData1 ALIAS FOR $1 ;
pData2 ALIAS FOR $2 ;
BEGIN
    RETURN date_part('day',(pData1-pData2));

END;
$$ language 'plpgsql';

 

/*-- SEQ 0081 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AlteraTipoColuna (VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 0082 --*/
CREATE OR REPLACE FUNCTION AlteraTipoColuna (VARCHAR,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
  pTabela   ALIAS FOR $1 ;
  pCampo    ALIAS FOR $2 ;
  cTabela   varchar(100) ;
  cCampo    varchar(100) ;
  pNovoTipo ALIAS FOR $3 ;
  RESULTADO VARCHAR(4000);
BEGIN
  cTabela := lower(pTabela);
  cCampo  := lower(pCampo); 
  RESULTADO:='';  
  SELECT coalesce(DropTriggers(cTabela),'')||
       'ALTER TABLE '||TO_CHAR(TABLE_NAME)||' ADD COLUMN NOVA_'||TO_CHAR(COLUMN_NAME)||' '||pNovoTipo||';'||CHR(13)||CHR(10)||
       'UPDATE '||TO_CHAR(TABLE_NAME)||' SET NOVA_'||TO_CHAR(COLUMN_NAME)||' = '||TO_CHAR(COLUMN_NAME)||';'||CHR(13)||CHR(10)||
       'ALTER TABLE '||TO_CHAR(TABLE_NAME)||' DROP COLUMN '||TO_CHAR(COLUMN_NAME)||' CASCADE;'||CHR(13)||CHR(10)||
       'ALTER TABLE '||TO_CHAR(TABLE_NAME)||' RENAME COLUMN NOVA_'||TO_CHAR(COLUMN_NAME)||' TO '||TO_CHAR(COLUMN_NAME)||';'||CHR(13)||CHR(10)||
       CASE WHEN DATA_DEFAULT IS NOT NULL THEN 'ALTER TABLE '||TO_CHAR(TABLE_NAME)||' ALTER COLUMN '||TO_CHAR(COLUMN_NAME)||' SET DEFAULT '||TO_CHAR(DATA_DEFAULT)||';'||CHR(13)||CHR(10)
                                          ELSE '' 
       END ||
       coalesce(getObjetosColuna(TABLE_NAME,COLUMN_NAME),'') INTO RESULTADO
  FROM ALL_TAB_COLUMNS 
 WHERE TABLE_NAME LIKE cTabela
   AND COLUMN_NAME LIKE cCampo
   AND OWNER = qualdono();
   
  RETURN RESULTADO;

END;
$$ language 'plpgsql';


/*-- SEQ 0083 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION getObjetosColuna (VARCHAR,VARCHAR) CASCADE;
    
/*-- SEQ 0084 --*/
CREATE OR REPLACE FUNCTION getObjetosColuna (VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pTabela ALIAS FOR $1 ;
pCampo ALIAS FOR $2 ;
  RESULTADO VARCHAR(4000);
  vTemp     VARCHAR(500);
  ColsObj CURSOR FOR
SELECT 'ALTER TABLE '||TABLE_NAME||
         CASE CONSTRAINT_TYPE WHEN 'p' THEN ' ADD CONSTRAINT '||TO_CHAR(CONSTRAINT_NAME)||' PRIMARY KEY ('||getColunasContraint||');'
                                   WHEN 'c' THEN CASE WHEN CONSTRAINT_NAME like 'nn_%' THEN ' ALTER COLUMN '||pCampo||' SET NOT NULL;'
                                                                                            ELSE ' ADD CONSTRAINT '||TO_CHAR(CONSTRAINT_NAME)||' CHECK  ('||SEARCH_CONDITION||');'
                                                   END
                                   WHEN 'u' THEN ' ADD CONSTRAINT '||CONSTRAINT_NAME||' UNIQUE ('||getColunasContraint||');'
                                   WHEN 'f' THEN ' ADD CONSTRAINT '||CONSTRAINT_NAME||' FOREIGN KEY ('||getColunasContraint||') REFERENCES '||TO_CHAR(REFTABLE_NAME)||' ('||getColunasContraint(REFCONSTRAINT_NAME)||');'
         END AS TEXTO
FROM (
  SELECT CONS.TABLE_NAME,
         CONS.CONSTRAINT_TYPE,
         CONS.CONSTRAINT_NAME,
         getColunasContraint(CONS.CONSTRAINT_NAME) AS getColunasContraint,
         CONS.SEARCH_CONDITION,
         REF.TABLE_NAME AS REFTABLE_NAME,
         REF.CONSTRAINT_NAME AS REFCONSTRAINT_NAME
    FROM ALL_CONSTRAINTS CONS LEFT OUTER JOIN ALL_CONSTRAINTS REF ON CONS.R_OWNER=REF.OWNER AND CONS.R_CONSTRAINT_NAME=REF.CONSTRAINT_NAME
    WHERE CONS.CONSTRAINT_NAME IN 
       (SELECT FKCOL.CONSTRAINT_NAME
         FROM ALL_CONS_COLUMNS FKCOL
        WHERE FKCOL.TABLE_NAME  like CONS.TABLE_NAME
          AND FKCOL.COLUMN_NAME like pCampo
          AND FKCOL.owner LIKE QUALDONO()
       )
      AND CONS.TABLE_NAME LIKE PTabela  
      AND CONS.OWNER = QUALDONO()
) INT
UNION ALL
-- Foreign key de outras tabelas
SELECT 'ALTER TABLE '||TO_CHAR(CONS.TABLE_NAME)||' ADD CONSTRAINT '||TO_CHAR(CONS.CONSTRAINT_NAME)||
       ' FOREIGN KEY ('||getColunasContraint(CONS.CONSTRAINT_NAME)||') REFERENCES '||
       TO_CHAR(REF.TABLE_NAME)||' ('||getColunasContraint(CONS.R_CONSTRAINT_NAME)||');' AS TEXTO
FROM ALL_CONSTRAINTS CONS INNER JOIN ALL_CONSTRAINTS REF ON CONS.R_OWNER=REF.OWNER AND CONS.R_CONSTRAINT_NAME=REF.CONSTRAINT_NAME     
WHERE CONS.R_CONSTRAINT_NAME IN 
   (SELECT FKCOL.CONSTRAINT_NAME
     FROM ALL_CONS_COLUMNS FKCOL
    WHERE FKCOL.TABLE_NAME  like PTabela   
      AND FKCOL.COLUMN_NAME like pCampo
      AND FKCOL.owner LIKE QUALDONO()
   )
AND CONS.CONSTRAINT_TYPE = 'f'
AND CONS.owner LIKE QUALDONO()
UNION ALL
-- Indices
SELECT 'CREATE '||CASE UNIQUENESS WHEN 'unique' THEN 'UNIQUE' 
                                                    ELSE ''
                  END||' INDEX '||TO_CHAR(INDEX_NAME)||' ON '||TO_CHAR(TABLE_NAME)||
       ' ('||getColunasIndices(INDEX_NAME)||');' AS TEXTO
  FROM ALL_INDEXES
 WHERE INDEX_NAME IN
                   (SELECT INDEX_NAME
                     FROM ALL_IND_COLUMNS
                    WHERE TABLE_NAME  like PTabela   
                      AND COLUMN_NAME like pCampo
                      AND TABLE_OWNER like QUALDONO()
                   )
   AND INDEX_NAME NOT IN (SELECT CONSTRAINT_NAME
                             FROM ALL_CONSTRAINTS
                            WHERE TABLE_NAME  like PTabela   
                              AND OWNER like QUALDONO()
                          )
   AND OWNER=QUALDONO();
   
BEGIN  
  RESULTADO:='';  
  OPEN ColsObj;
  LOOP
    FETCH ColsObj INTO vTemp;
    EXIT WHEN NOT FOUND;
    IF ISNULL(RESULTADO)='T' THEN
       RESULTADO:=vTemp;
    ELSE
       RESULTADO:=RESULTADO||chr(13)||chr(10)||vTemp;
    END IF;
  END LOOP;
  CLOSE ColsObj;

  RETURN RESULTADO;

END;
$$ language 'plpgsql';


/*-- SEQ 0085 --*/
/*-- IGNORE ERRO --*/
CREATE OR REPLACE FUNCTION pg_catalog.instr(varchar,varchar,integer,integer) RETURNS integer AS $$
-- 1) As funes precedidas pelos esquemas public ou pg_catalog devem ser criadas diretamente na base template1
-- 2) As funes no precedidas pelo esquema devem assumir o esquema do usurio logado (TOTALL, ANSISYS...)
DECLARE
    string ALIAS FOR $1;
    string_to_search ALIAS FOR $2;
    beg_index ALIAS FOR $3;
    occur_index ALIAS FOR $4;
    pos integer NOT NULL DEFAULT 0;
    occur_number integer NOT NULL DEFAULT 0;
    temp_str varchar;
    beg integer;
    i integer;
    length integer;
    ss_length integer;
BEGIN
    IF string is NULL or string_to_search IS NULL THEN
       RETURN NULL;
    END IF;
    IF beg_index > 0 THEN
        beg := beg_index;
        temp_str := substring(string FROM beg_index);

        FOR i IN 1..occur_index LOOP
            pos := position(string_to_search IN temp_str);

            IF i = 1 THEN
                beg := beg + pos - 1;
            ELSE
                beg := beg + pos;
            END IF;

            temp_str := substring(string FROM beg + 1);
        END LOOP;

        IF pos = 0 THEN
            RETURN 0;
        ELSE
            RETURN beg;
        END IF;
    ELSE
        ss_length := char_length(string_to_search);
        length := char_length(string);
        beg := length + beg_index - ss_length + 2;

        WHILE beg > 0 LOOP
            temp_str := substring(string FROM beg FOR ss_length);
            pos := position(string_to_search IN temp_str);

            IF pos > 0 THEN
                occur_number := occur_number + 1;

                IF occur_number = occur_index THEN
                    RETURN beg;
                END IF;
            END IF;

            beg := beg - 1;
        END LOOP;

        RETURN 0;
    END IF;
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0086 --*/
/*-- IGNORE ERRO --*/
CREATE OR REPLACE FUNCTION pg_catalog.instr(varchar,varchar,integer) RETURNS integer AS $$
DECLARE
    string ALIAS FOR $1;
    string_to_search ALIAS FOR $2;
    beg_index ALIAS FOR $3;
    pos integer NOT NULL DEFAULT 0;
    temp_str varchar;
    beg integer;
    length integer;
    ss_length integer;
BEGIN
    IF string is NULL or string_to_search IS NULL THEN
       RETURN NULL;
    END IF;

    IF beg_index > 0 THEN

       temp_str := substring(string FROM beg_index);
       pos := position(string_to_search IN temp_str);

       IF pos = 0 THEN
          RETURN 0;
      ELSE
          RETURN pos + beg_index - 1;
      END IF;
    ELSE
       ss_length := char_length(string_to_search);
       length := char_length(string);
       beg := length + beg_index - ss_length + 2;

       WHILE beg > 0 LOOP

           temp_str := substring(string FROM beg FOR ss_length);
          pos := position(string_to_search IN temp_str);

          IF pos > 0 THEN
             RETURN beg;
          END IF;

          beg := beg - 1;
       END LOOP;
       RETURN 0;
    END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 0087 --*/
/*-- IGNORE ERRO --*/
CREATE OR REPLACE FUNCTION pg_catalog.instr(varchar,varchar) RETURNS integer AS $$
DECLARE
    pos integer;
BEGIN
    pos:= instr($1,$2,1);
    RETURN pos;
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0088 --*/
/*-- IGNORE ERRO --*/
CREATE OR REPLACE FUNCTION pg_catalog.trunc(timestamptz)
RETURNS Date AS $$
BEGIN
 RETURN date_trunc('day', $1);
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0089 --*/
/*-- IGNORE ERRO --*/
CREATE OR REPLACE FUNCTION trunc(timestamptz)
RETURNS Date AS $$
BEGIN
 RETURN date_trunc('day', $1);
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0090 --*/
/*-- IGNORE ERRO --*/
CREATE OR REPLACE FUNCTION pg_catalog.power(float8, float8)
RETURNS numeric AS $$
BEGIN
 RETURN pow($1::numeric, $2::numeric);
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0091 --*/
/*-- IGNORE ERRO --*/
CREATE OR REPLACE FUNCTION pg_catalog.TO_NUMBER(varchar) RETURNS Integer AS $$
BEGIN
 RETURN TO_NUMBER($1, '9999999999999999'); 
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0092 --*/
/*-- IGNORE ERRO --*/
CREATE OR REPLACE FUNCTION pg_catalog.TO_CHAR(numeric) RETURNS VarChar AS $$
BEGIN
 RETURN CAST($1 AS VARCHAR);
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0093 --*/
/*-- IGNORE ERRO --*/
CREATE OR REPLACE FUNCTION pg_catalog.to_char(varchar) RETURNS varchar AS $$
BEGIN
 RETURN $1;
END
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0094 --*/
CREATE OR REPLACE FUNCTION ttFloatDiv(bigint, bigint)
RETURNS double precision AS $$
-- OPERADOR DE DIVISO DE NMEROS INTEIROS
BEGIN
 RETURN CAST($1 as double precision)/$2;
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0095 --*/
CREATE OR REPLACE FUNCTION ttFloatDiv(integer, integer)
RETURNS double precision AS $$
BEGIN
 RETURN CAST($1 as double precision)/$2;
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0096 --*/
CREATE OR REPLACE FUNCTION ttFloatDiv(smallint, smallint)
RETURNS double precision AS $$
BEGIN
 RETURN CAST($1 as double precision)/$2;
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0097 --*/
CREATE OR REPLACE FUNCTION ttFloatDiv(bigint, integer)
RETURNS double precision AS $$
BEGIN
 RETURN CAST($1 as double precision)/$2;
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0098 --*/
CREATE OR REPLACE FUNCTION ttFloatDiv(bigint, smallint)
RETURNS double precision AS $$
BEGIN
 RETURN CAST($1 as double precision)/$2;
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0099 --*/
CREATE OR REPLACE FUNCTION ttFloatDiv(integer, bigint)
RETURNS double precision AS $$
BEGIN
 RETURN CAST($1 as double precision)/$2;
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0100 --*/
CREATE OR REPLACE FUNCTION ttFloatDiv(integer, smallint)
RETURNS double precision AS $$
BEGIN
 RETURN CAST($1 as double precision)/$2;
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0101 --*/
CREATE OR REPLACE FUNCTION ttFloatDiv(smallint, bigint)
RETURNS double precision AS $$
BEGIN
 RETURN CAST($1 as double precision)/$2;
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0102 --*/
CREATE OR REPLACE FUNCTION ttFloatDiv(smallint, integer)
RETURNS double precision AS $$
BEGIN
 RETURN CAST($1 as double precision)/$2;
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0103 --*/
/*--IGNORE ERRO--*/
CREATE OPERATOR / (PROCEDURE = ttFloatDiv, LEFTARG = bigint, RIGHTARG = bigint);
CREATE OPERATOR / (PROCEDURE = ttFloatDiv, LEFTARG = smallint, RIGHTARG = smallint);
CREATE OPERATOR / (PROCEDURE = ttFloatDiv, LEFTARG = integer, RIGHTARG = integer);
CREATE OPERATOR / (PROCEDURE = ttFloatDiv, LEFTARG = bigint, RIGHTARG = integer);
CREATE OPERATOR / (PROCEDURE = ttFloatDiv, LEFTARG = bigint, RIGHTARG = smallint);
CREATE OPERATOR / (PROCEDURE = ttFloatDiv, LEFTARG = integer, RIGHTARG = bigint);
CREATE OPERATOR / (PROCEDURE = ttFloatDiv, LEFTARG = integer, RIGHTARG = smallint);
CREATE OPERATOR / (PROCEDURE = ttFloatDiv, LEFTARG = smallint, RIGHTARG = bigint);
CREATE OPERATOR / (PROCEDURE = ttFloatDiv, LEFTARG = smallint, RIGHTARG = integer);

/*-- SEQ 0104 --*/
CREATE OR REPLACE FUNCTION LAST_DAY(timestamptz)
RETURNS timestamp AS $$
 SELECT date_trunc('MONTH', date_trunc('MONTH', $1)::date+32)::date-1+to_char($1, 'hh:mm:ss')::time;
$$ language sql STRICT IMMUTABLE;

/*-- SEQ 0105 --*/
CREATE OR REPLACE FUNCTION USERENV(varchar)
RETURNS Integer AS $$
 SELECT pg_backend_pid();
$$ language sql;

/*-- SEQ 0106 --*/
CREATE OR REPLACE FUNCTION SUBSTR(TEXT,INT4,INT4)
RETURNS TEXT AS $$
BEGIN
   IF $3 < 0 THEN
     RETURN '';
   ELSE
     IF  $2>=0 THEN
        RETURN PG_CATALOG.SUBSTR($1,$2,$3);
     ELSE
        RETURN PG_CATALOG.SUBSTR($1, LENGTH($1)+$2+1, $3);
     END IF;
   END IF;
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0107 --*/
CREATE OR REPLACE FUNCTION SUBSTR(TEXT,INT4)
RETURNS TEXT AS $$
BEGIN
   RETURN SUBSTR($1,$2,length($1));
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0108 --*/
CREATE OR REPLACE FUNCTION SUBSTR(TEXT,NUMERIC,NUMERIC)
RETURNS TEXT AS $$
BEGIN
   RETURN SUBSTR($1,CAST($2 AS INTEGER),CAST($3 AS INTEGER));
END;
$$ language 'plpgsql';

/*-- SEQ 0109 --*/
CREATE OR REPLACE FUNCTION SUBSTR(TEXT,NUMERIC)
RETURNS TEXT AS $$
BEGIN
   RETURN SUBSTR($1,CAST($2 AS INTEGER),length($1));
END;
$$ language 'plpgsql';

/*-- SEQ 0110 --*/
/*-- IGNORE ERRO --*/
CREATE OR REPLACE FUNCTION PUBLIC.TO_DATE(text, text) RETURNS TIMESTAMP
AS $$
DECLARE
  dRetorno TIMESTAMP;
BEGIN
 IF (UPPER($2)='DD/MM/YYYY') or ($1 like '%00:00:00') THEN 
    dRetorno:=TRUNC(pg_Catalog.TO_TIMESTAMP($1,UPPER($2)));
 ELSE
    dRetorno:=pg_Catalog.TO_TIMESTAMP($1,UPPER($2));
 END IF;
 RETURN dRetorno;
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0111 --*/
CREATE OR REPLACE FUNCTION MONTHS_BETWEEN(TIMESTAMP, TIMESTAMP) RETURNS NUMERIC AS $$
DECLARE
  pDATFIM ALIAS FOR $1;
  pDATINI ALIAS FOR $2;
  ANOINI INTEGER;
  ANOFIM INTEGER;
  MESINI INTEGER;
  MESFIM INTEGER;
  DIAINI INTEGER;
  DIAFIM INTEGER;
  RETORNO NUMERIC;
  MULT INTEGER;
  DATINI DATE;
  DATFIM DATE;
BEGIN
  IF pDATFIM >= pDATINI THEN
    DATFIM := trunc(pDATFIM);
    DATINI := trunc(pDATINI);
    MULT := 1;
  ELSE
    DATFIM := trunc(pDATINI);
    DATINI := trunc(pDATFIM);
    MULT := -1;
  END IF;

  ANOINI := CAST (TO_CHAR(DATINI,'YYYY') AS INTEGER);
  ANOFIM := CAST (TO_CHAR(DATFIM,'YYYY') AS INTEGER);
  MESINI := CAST (TO_CHAR(DATINI,'MM') AS INTEGER);
  MESFIM := CAST (TO_CHAR(DATFIM,'MM') AS INTEGER);
  DIAINI := CAST (TO_CHAR(DATINI,'DD') AS INTEGER);
  DIAFIM := CAST (TO_CHAR(DATFIM,'DD') AS INTEGER);
  RETORNO := 0;

  -- Desconta anos inteiros
  LOOP
    EXIT WHEN ((ANOINI >= ANOFIM)
                    OR (ANOINI + 1 = ANOFIM AND  MESINI > MESFIM)
                    OR (ANOINI + 1 = ANOFIM AND  MESINI = MESFIM AND DIAINI > DIAFIM) ) ;

    RETORNO := RETORNO + 12;
    ANOINI := ANOINI + 1;
  END LOOP;

  -- Desconta os meses at o fim do ano
  IF ANOINI < ANOFIM THEN
     RETORNO := RETORNO + (13 - MESINI);
     MESINI := 1;
     ANOINI := ANOINI + 1;
  END IF;

  LOOP
    EXIT WHEN (MESINI >= MESFIM);
    RETORNO := RETORNO + 1;
    MESINI := MESINI + 1;
  END LOOP;

  IF MESINI <> MESFIM THEN
     RETORNO := MULT * (RETORNO + ((31-DIAINI) + DIAFIM) * 100/31/100);
  ELSE
     RETORNO := MULT * (RETORNO + ( DIAFIM-DIAINI) * 100/31/100);
  END IF;


  RETURN RETORNO;
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0112 --*/
/*-- IGNORE ERRO --*/
CREATE OR REPLACE FUNCTION LEAST(NUMERIC,NUMERIC)
RETURNS NUMERIC AS $$
BEGIN
   RETURN  NUMERIC_SMALLER($1,$2);
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0113 --*/
/*-- IGNORE ERRO --*/
CREATE OR REPLACE FUNCTION LEAST(timestamp,timestamp)
RETURNS timestamp AS $$
BEGIN
   IF $1 < $2 THEN 
      RETURN  $1;
   ELSE 
      RETURN  $2;
   END IF;
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0114 --*/
/*-- IGNORE ERRO --*/
CREATE OR REPLACE FUNCTION LEAST(VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
BEGIN
   IF $1 < $2 THEN 
      RETURN  $1;
   ELSE 
      RETURN  $2;
   END IF;
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0115 --*/
/*-- IGNORE ERRO --*/
CREATE OR REPLACE FUNCTION GREATEST(NUMERIC,NUMERIC)
RETURNS NUMERIC AS $$
BEGIN
   RETURN  NUMERIC_LARGER($1,$2);
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0116 --*/
/*-- IGNORE ERRO --*/
CREATE OR REPLACE FUNCTION GREATEST(timestamp,timestamp)
RETURNS timestamp AS $$
BEGIN
   IF $1 > $2 THEN 
      RETURN  $1;
   ELSE 
      RETURN  $2;
   END IF;
END;
$$ language 'plpgsql' STRICT IMMUTABLE;

/*-- SEQ 0117 --*/
/*-- IGNORE ERRO --*/
CREATE OR REPLACE FUNCTION GREATEST(VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
BEGIN
   IF $1 > $2 THEN 
      RETURN  $1;
   ELSE 
      RETURN  $2;
   END IF;
END;
$$ language 'plpgsql' STRICT IMMUTABLE;
/*-- SEQ 0118 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION array_find(smallint[],smallint);

/*-- SEQ 0119 --*/
CREATE OR REPLACE FUNCTION array_find(smallint[],smallint)
RETURNS smallint AS $$
DECLARE
 vPos integer := 0;
BEGIN

 -- Objetivo: Localizar um determinado valor em um array, seno devolve -1 

 LOOP
   vPos:=vPos+1;
   IF ($1[vPos] = $2) or ($1[vPos] IS NULL) THEN
      EXIT;
   END IF;
 END LOOP;

 IF $1[vPos] IS NULL THEN
    RETURN -1;
 ELSE
    RETURN vPos;
 END IF;

END;
$$ language 'plpgsql';

/*-- SEQ 0120 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GetParamsFunction(oidvector);

/*-- SEQ 0121 --*/
CREATE OR REPLACE FUNCTION GetParamsFunction(oidvector)
RETURNS bpchar AS $$
DECLARE
 i Integer = 0;
 cTipo varchar;
 cRetorno varchar = '';
BEGIN
 WHILE $1[i] != 0 LOOP
       IF i > 0 THEN
          cRetorno := cRetorno||', ';
       END IF;
       SELECT typname INTO cTipo FROM pg_type WHERE oid = $1[i];
       cRetorno := cRetorno||cTipo;
       i:=i+1;
 END LOOP;
 RETURN cRetorno;
END;
$$ language 'plpgsql';

/*-- SEQ 0122 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION reordene_no_ect(bpchar, bpchar, varchar);

/*-- SEQ 0123 --*/
CREATE OR REPLACE FUNCTION reordene_no_ect(bpchar, bpchar, varchar)
  RETURNS varchar AS $$
     DECLARE
       pFILECT ALIAS FOR $1;
       pSEQECT ALIAS FOR $2;
       pARVORE ALIAS FOR $3;
       cARVORE TT_ECT.ARVORE%TYPE;
       Rec     RECORD;
       iQtd    INTEGER;
       iNum    INTEGER DEFAULT 0;
       cDUMMY  CHAR(1);
     BEGIN

       -- Cristian
       -- Esta funcao ira reordenar alfabeticamente apartir do no passado via parametro

       cARVORE := CASE WHEN pARVORE IS NULL THEN '' ELSE pARVORE||'/' END;

       for rec in select CODFIL,SEQUEN                                           -- Todos os filhos do no
                    from TT_ECT                                                  -- Em ordem alfabetica
                   where (FILECT,SEQECT) = (pFILECT,pSEQECT)
                      or (FILECT is null and SEQECT is null and pSEQECT is null) -- Se no houver pai (Nvel 1)
                order by TITECT LOOP

           select count(*) into iQtd from TT_ECT where (FILECT,SEQECT) = (rec.CODFIL,rec.SEQUEN);

           if COALESCE(iQtd,0) > 0 then
              cDUMMY := REORDENE_NO_ECT(rec.CODFIL,rec.SEQUEN, cARVORE || trim(TO_CHAR(iNum,'0000'))); -- Chamada recursiva
           end if;

           update TT_ECT
              set ARVORE = cARVORE||trim(TO_CHAR(iNum,'0000'))
            where (CODFIL,SEQUEN) = (rec.CODFIL,rec.SEQUEN);

--         GET DIAGNOSTICS TESTE = RESULT_OID;
--         if TESTE is null then
--            RAISE NOTICE 'ERRO';
--         end if;

           iNum:=iNum+1;
       END LOOP;

       RETURN NULL;

     END;
     
 $$ LANGUAGE 'plpgsql' VOLATILE;

/*-- SEQ 0124 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION reordene_no_wcta(bpchar, varchar, numeric);

/*-- SEQ 0125 --*/
CREATE OR REPLACE FUNCTION reordene_no_wcta(bpchar, varchar, numeric)
  RETURNS varchar AS
$$
     DECLARE
       pCHVPAI ALIAS FOR $1;
       pARVORE ALIAS FOR $2;
       pUSERID ALIAS FOR $3;
       cARVORE TW_CTA.ARVORE%TYPE;
       Rec     RECORD;
       iQtd    INTEGER;
       iNum    INTEGER DEFAULT 0;
       cDUMMY  CHAR(1);
     BEGIN

       -- Cristian
       -- Funcao para reordenar descendentes de um determinado no em ordem alfabetica.
       -- Parametros
       -- pFILECT,pSEQECT -> Indica o no pai
       -- pARVORE         -> Arvore do no pai

       raise notice 'inicio %', pARVORE;

       cARVORE := CASE WHEN pARVORE IS NULL THEN '' ELSE pARVORE||'/' END;

       for rec in select CHV_ID                                                  -- Todos os filhos do no
                    from TW_CTA                                                  -- Em ordem alfabetica
                   where ((CHVPAI = pCHVPAI) or
                          (CHVPAI is null and pCHVPAI is null))                    -- Se nao houver pai (Nivel 1)
                     and USERID = pUSERID
                order by TITCTA LOOP
           select count(*) into iQtd from TW_CTA where CHVPAI = rec.CHV_ID;

           if COALESCE(iQtd,0) > 0 then
              cDUMMY := REORDENE_NO_WCTA(rec.CHV_ID, cARVORE || trim(TO_CHAR(iNum,'0000')),pUSERID); -- Chamada recursiva
           end if;

           update TW_CTA
              set ARVORE = cARVORE||trim(TO_CHAR(iNum,'0000'))
            where CHV_ID = rec.CHV_ID
              and USERID = pUSERID;

           raise notice 'update % %', cARVORE, iNum;
--         GET DIAGNOSTICS TESTE = RESULT_OID;
--         if TESTE is null then
--            RAISE NOTICE 'ERRO';
--         end if;

           iNum:=iNum+1;
       END LOOP;

       RETURN NULL;

     END;
     
$$  LANGUAGE 'plpgsql' VOLATILE;
  
/*-- SEQ 0126 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DisableTriggers(NAME);

/*-- SEQ 0127 --*/
CREATE OR REPLACE FUNCTION DisableTriggers(NAME) 
RETURNS BOOLEAN AS $$
DECLARE
  rel ALIAS FOR $1;
BEGIN
      EXECUTE 'ALTER TABLE '||rel||' DISABLE TRIGGER ALL;';
      RETURN TRUE;
END;
$$ language 'plpgsql' STRICT;

/*-- SEQ 0128 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION EnableTriggers(NAME);

/*-- SEQ 0129 --*/
CREATE OR REPLACE FUNCTION EnableTriggers(NAME) 
RETURNS BOOLEAN AS $$
DECLARE
  rel ALIAS FOR $1;
BEGIN
      EXECUTE 'ALTER TABLE '||rel||' ENABLE TRIGGER ALL;';
      RETURN TRUE;
END;
$$ language 'plpgsql' STRICT;
CREATE OR REPLACE FUNCTION TRUNC_DATE (VARCHAR,Timestamp)
RETURNS Timestamp AS $$
DECLARE
pTipo ALIAS FOR $1 ;
pData ALIAS FOR $2 ;
BEGIN

   RETURN DATE_TRUNC(pTipo, pData);
   
END;
$$ language 'plpgsql' STABLE;
/*-- SEQ 0130 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AtualizaData (TT_ATU.DESATU%TYPE,TT_ATU.ATU_EM%TYPE) CASCADE;

/*-- SEQ 0131 --*/
CREATE OR REPLACE FUNCTION AtualizaData (TT_ATU.DESATU%TYPE,TT_ATU.ATU_EM%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pDescricao ALIAS FOR $1 ;
pData ALIAS FOR $2 ;

-- Objetivo:
-- 1. Atualiza a data de controle da tabela/processo

-- Declarao de variveis e cursores
   nResultado                    VARCHAR(2);

-- Incio da funo
BEGIN
   IF ISNULL(pDescricao)='T' THEN
      RAISE EXCEPTION 'PG-20000 Obrigatrio informar a descrio.';
   END IF;

   UPDATE TT_ATU
      SET ATU_EM = COALESCE(pData,Agora())
    WHERE DESATU = pDescricao;

   RETURN 'OK';

END;
$$ language 'plpgsql';




/*-- SEQ 0132 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION BI_VLRMPB (TT_VEN.CODFIL%TYPE,TT_VEN.VLRLIQ%TYPE,TT_VEN.VLRNOT%TYPE,TT_IVE.VLRMOV%TYPE,TT_IVE.QTDMOV%TYPE,TT_IVE.QTDMPB%TYPE,TT_IVE.PERPIS%TYPE,TT_IVE.PERCOF%TYPE) CASCADE;

/*-- SEQ 0133 --*/
CREATE OR REPLACE FUNCTION BI_VLRMPB (TT_VEN.CODFIL%TYPE,TT_VEN.VLRLIQ%TYPE,TT_VEN.VLRNOT%TYPE,TT_IVE.VLRMOV%TYPE,TT_IVE.QTDMOV%TYPE,TT_IVE.QTDMPB%TYPE,TT_IVE.PERPIS%TYPE,TT_IVE.PERCOF%TYPE)
RETURNS Numeric AS $$
DECLARE
pVEN_CODFIL ALIAS FOR $1 ;
pVEN_VLRLIQ ALIAS FOR $2 ;
pVEN_VLRNOT ALIAS FOR $3 ;
pIVE_VLRMOV ALIAS FOR $4 ;
pIVE_QTDMOV ALIAS FOR $5 ;
pIVE_QTDMPB ALIAS FOR $6 ;
pIVE_PERPIS ALIAS FOR $7 ;
pIVE_PERCOF ALIAS FOR $8 ;
/* 
 * Objetivo: Calcular valor do MP do BEM em expresso do BI
 * ("Valor UN" * "PisCof MPBem") * (("% COFINS Venda" + "% PIS Venda") /100)
 */
  wk_ValorUN     Numeric(12,2); 
  wk_PisCofMPBem Numeric(12,2);
  wk_Resultado   Numeric(12,2);
BEGIN
  wk_ValorUN      := COALESCE(pVEN_VLRLIQ,0) * (CASE pVEN_VLRNOT WHEN 0 THEN 0 ELSE pIVE_VLRMOV / pVEN_VLRNOT / pIVE_QTDMOV END);
  wk_PisCofMPBem  := COALESCE(pIVE_QTDMPB,0);
  wk_Resultado    := (wk_ValorUN * wk_PisCofMPBem) * ((COALESCE(pIVE_PERPIS,0)+COALESCE(pIVE_PERCOF,0)) /100);
  RETURN wk_Resultado;
END;
$$ language 'plpgsql' STABLE;




/*-- SEQ 0134 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION BI_VLRPISCOF (TT_VEN.CODFIL%TYPE,TT_VEN.VLRLIQ%TYPE,TT_VEN.VLRNOT%TYPE,TT_IVE.VLRMOV%TYPE,TT_IVE.PERPIS%TYPE,TT_IVE.PERCOF%TYPE) CASCADE;

/*-- SEQ 0135 --*/
CREATE OR REPLACE FUNCTION BI_VLRPISCOF (TT_VEN.CODFIL%TYPE,TT_VEN.VLRLIQ%TYPE,TT_VEN.VLRNOT%TYPE,TT_IVE.VLRMOV%TYPE,TT_IVE.PERPIS%TYPE,TT_IVE.PERCOF%TYPE)
RETURNS Numeric AS $$
DECLARE
pVEN_CODFIL ALIAS FOR $1 ;
pVEN_VLRLIQ ALIAS FOR $2 ;
pVEN_VLRNOT ALIAS FOR $3 ;
pIVE_VLRMOV ALIAS FOR $4 ;
pIVE_PERPIS ALIAS FOR $5 ;
pIVE_PERCOF ALIAS FOR $6 ;
/* 
 * Objetivo: Calcular valor do PIS/COFINS em expressao do BI
 * "Valor Líquido " * (("% PIS Venda" + "% COFINS Venda") / 100)
 */
  wk_ValorLiquido Numeric(12,2);
  wk_Resultado    Numeric(12,2);
BEGIN
  wk_ValorLiquido := COALESCE(pVEN_VLRLIQ,0) * (CASE pVEN_VLRNOT WHEN 0 THEN  0 ELSE pIVE_VLRMOV / pVEN_VLRNOT END);
  wk_Resultado    := wk_ValorLiquido * ((COALESCE(pIVE_PERPIS,0)+COALESCE(pIVE_PERCOF,0)) /100);
  RETURN wk_Resultado;
END;
$$ language 'plpgsql' STABLE;




/*-- SEQ 0136 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION BuscaCodigoParceiroNaoUsado (TT_CLI.FILCLI%TYPE) CASCADE;

/*-- SEQ 0137 --*/
CREATE OR REPLACE FUNCTION BuscaCodigoParceiroNaoUsado (TT_CLI.FILCLI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILCLI ALIAS FOR $1 ;
-- Objetivo:
-- Buscar CODCLI no utilizado 
-- GES-2023077564 - MMC 
   nCODCLI                    VARCHAR(6);
   v_exists                   Numeric;
BEGIN
   nCODCLI := '     2';
   WHILE EXISTS (SELECT 1 
                   FROM TT_CLI 
                  WHERE CODCLI = nCODCLI 
                    AND FILCLI = pFILCLI) 
                    AND nCODCLI <= '999999' LOOP
      nCODCLI := LPAD(CAST(CAST(nCODCLI AS INTEGER) + 1 AS VARCHAR), 6, ' ');
   END LOOP;

   IF nCODCLI <= '999999' THEN
      RETURN nCODCLI;
   ELSE
      RAISE EXCEPTION 'No existem mais valores possveis para o FILCLI %', pfilcli;
      RETURN NULL; 
   END IF;
END;
$$ language 'plpgsql';




/*-- SEQ 0138 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION BuscaCodigoProdutoNaoUsado (TT_PRO.FILMAT%TYPE) CASCADE;

/*-- SEQ 0139 --*/
CREATE OR REPLACE FUNCTION BuscaCodigoProdutoNaoUsado (TT_PRO.FILMAT%TYPE)
RETURNS Numeric AS $$
DECLARE
pFILMAT ALIAS FOR $1 ;
-- Objetivo:
-- Buscar CODMAT no utilizado 
-- GES-2023033563 - MMC 
   nCODMAT                       Numeric(15); 
BEGIN
   SELECT COALESCE(CAST(CAST(TAB.CODMAT_ANT AS VARCHAR(5)) AS Numeric(15)),0) + 1 AS CODMATNAOUSADO
      INTO nCODMAT
      FROM (
         SELECT PRO.FILMAT,
            (SELECT PRO1.CODMAT 
               FROM TT_PRO PRO1 
              WHERE PRO1.FILMAT = PRO.FILMAT
                AND PRO1.CODMAT < PRO.CODMAT 
              ORDER BY PRO1.CODMAT DESC 
              LIMIT 1
           ) CODMAT_ANT, PRO.CODMAT
         FROM TT_PRO PRO 
        ORDER BY PRO.FILMAT, PRO.CODMAT) TAB
   WHERE COALESCE(CAST(CAST(TAB.CODMAT_ANT AS VARCHAR(5)) AS Numeric(15)), 0) <> COALESCE(CAST(CAST(TAB.CODMAT AS VARCHAR(5)) AS Numeric(15)),0) - 1 
     AND TAB.FILMAT = pFILMAT
   LIMIT 1;
           
           
   RETURN COALESCE (nCODMAT,0);
END;
$$ language 'plpgsql';




/*-- SEQ 0140 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalcElast (Numeric,Numeric,TT_PRE.PRECOV%TYPE,TT_PRE.PRECOV%TYPE) CASCADE;

/*-- SEQ 0141 --*/
CREATE OR REPLACE FUNCTION CalcElast (Numeric,Numeric,TT_PRE.PRECOV%TYPE,TT_PRE.PRECOV%TYPE)
RETURNS Numeric AS $$
DECLARE
pQtdP1 ALIAS FOR $1 ;
pQtdP2 ALIAS FOR $2 ;
pPrecoP1 ALIAS FOR $3 ;
pPrecoP2 ALIAS FOR $4 ;
--  ---------------------------------------------------------
--  Função que Calcula a elasticidade através dos parâmetros informados:
--    pQtdP1 Numeric(6): quantidade vendida do primeiro período;
--    pQtdP2 Numeric(6): quantidade vendida do segundo período;
--    pPrecoP1 Numeric(12,4): preço unitário do primeiro período;
--    pPrecoP1 Numeric(12,4): preço unitário do segundo período;
-- 
--    Retorno Numeric(12,2): retorna o valor calculado através dos parametros.
-- 
--  nota: o primeiro período é considerado o período anterior a mudança de preço, 
--        e o segundo período é o período posterior a mudança de preço.
--        Para maiores explicações sobre este cálculo veja o artigo:
--        http://intra.totall.com.br:8080/wiki/index.php/Análise_para_Precificação
--  --------------------------------------------------------- 
--  vars/cursores
    nResult     Numeric(12,2);                                
--  ---------------------------------------------------------
begin
    nResult := abs(((pQtdP2 - pQtdP1) / pQtdP1) / ((pPrecoP2 - pPrecoP1) / pPrecoP1));
    --  retorno da funcao
    return nResult;
exception    
        
    when division_by_zero then return 0;
    --  ---------------------------------------------------------
END;
$$ language 'plpgsql';




/*-- SEQ 0142 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CaracteristicasProduto (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE) CASCADE;

/*-- SEQ 0143 --*/
CREATE OR REPLACE FUNCTION CaracteristicasProduto (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILMAT ALIAS FOR $1 ;
pCODMAT ALIAS FOR $2 ;
pCODCOR ALIAS FOR $3 ;
pCODTAM ALIAS FOR $4 ;
-- Objetivo:
-- 1) Obter o valor do ICMS da venda
  Retorno VARCHAR(4000);
  Buffer  VARCHAR(32767);
BEGIN

	select Replace( '[' ||
           ltrim( agregatxt( ',{"Item":"' || Replace(int.item,'"','''') ||
           '","Descricao":"' || Replace(int.descricao,'"','''') || '"}' ), ',' ) ||
           ']', chr(13)||chr(10), '' ) into Buffer
    from (select *
            from (select 1 as grupo,
                         pai.desdet as pai,
                         det.desdet as detalhe,
                         crt.descrt as item,  car.descrt as descricao
                    from tt_crtXpro car inner join td_crt crt on crt.codtab = car.codcrt
                                        inner join td_det det on det.codtab = crt.coddet
                                        left  join td_det pai on pai.codtab = det.paidet
                   where car.filmat = pFilMat
                     and car.codmat = pCodMat
                     and car.descrt is not null
                   union all
                  select 2 as grupo, pai.desdet as pai, det.desdet as detalhe,
                         crt.descrt as item,  car.descrt as descricao
                    from tt_crtXgra car inner join td_crt crt on crt.codtab = car.codcrt
                                        inner join td_det det on det.codtab = crt.coddet
                                        left  join td_det pai on pai.codtab = det.paidet
                   where car.filmat = pFilMat
                     and car.codmat = pCodMat
                     and car.codcor = pCodCor
                     and car.codtam = pCodTam
                     and car.descrt is not null
                 ) uni
           order by uni.grupo, uni.pai, uni.detalhe, uni.item
         ) int;

  IF Length(Buffer) > 4000 THEN
    Retorno := '[{"Item":"Caracteristicas","Descricao":"Texto muito longo"]';
  ELSE
    Retorno := Buffer;
  END IF;

  RETURN Retorno;
END;
$$ language 'plpgsql';

  


/*-- SEQ 0144 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CFOPGeradorCredito (TD_CFO.CODCFO%TYPE) CASCADE;

/*-- SEQ 0145 --*/
CREATE OR REPLACE FUNCTION CFOPGeradorCredito (TD_CFO.CODCFO%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODCFO ALIAS FOR $1 ;

-- Verifica se o CFOP informado gera crdito
-- Baseado na tabela disponvel no site do SPED Pis Cofins:
-- Tabela CFOP - Operaes Geradoras de Crditos - Verso 1.0.0 
-- (Tabela I: Base de Clculo de Crditos (M105/M505) determinada em funo do CFOP informado no Documento Fiscal)
-- (Tabela II: Adicionados CFOP 1352,2352,3352,1353,2353,3353 (referentes aquisio de servio de transporte)

nRESULTADO VARCHAR(1);


BEGIN

    IF SUBSTR(pCODCFO,1,4) IN 
                  ('1102','1113','1117','1118',
                   '1121','1251','1403','1652',
                   '2102','2113','2117','2118',
                   '2121','2251','2403','2652',
                   '3102','3251','3652','1101',
                   '1111','1116','1120','1122',
                   '1126','1128','1401','1407',
                   '1556','1651','1653','2101',
                   '2111','2116','2120','2122',
                   '2126','2128','2401','2407',
                   '2556','2651','2653','3101',
                   '3126','3128','3556','3651',
                   '3653','1124','1125','1933',
                   '2124','2125','2933','1201',
                   '1202','1203','1204','1410',
                   '1411','1660','1661','1662',
                   '2201','2202','2410','2411',
                   '2660','2661','2662','1922',
                   '2922','1352','2352','3352',
                   '1353','2353','3353','1253') 
    THEN
      nRESULTADO := 'T';                   
    ELSE
      nRESULTADO := 'F';
    END IF;

    RETURN nRESULTADO;

END;
$$ language 'plpgsql';




-- --------------------------------------------------------
-- Objetivos:
-- Consultor..: Luciano
-- Cliente....: Gimba
-- Finalidade.: Credito e Debitos de uma conta correte especifica em um periodo;
-- Ticket.....: 2023036223 
-- Nota: utilize as funo Split_Part_Number() para utilizar o resultado
--        desta funo de maneira mais fcil.
--        http://intra.totall.com.br:8080/wiki/index.php/Split_part
-- 1 - Credito
-- 2 - Debito
/*-- SEQ 0146 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CreditosDebitosCCPeriodo (TT_CCC.FILCLI%TYPE,TT_CCC.CODCLI%TYPE,TT_CCC.TIPCCC%TYPE,TT_CCC.DATOPE%TYPE,TT_CCC.DATOPE%TYPE,TT_CCC.CODFIL%TYPE) CASCADE;

/*-- SEQ 0147 --*/
CREATE OR REPLACE FUNCTION CreditosDebitosCCPeriodo (TT_CCC.FILCLI%TYPE,TT_CCC.CODCLI%TYPE,TT_CCC.TIPCCC%TYPE,TT_CCC.DATOPE%TYPE,TT_CCC.DATOPE%TYPE,TT_CCC.CODFIL%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILCLI ALIAS FOR $1 ;
pCODCLI ALIAS FOR $2 ;
pTIPCCC ALIAS FOR $3 ;
pDATINI ALIAS FOR $4 ;
pDATFIM ALIAS FOR $5 ;
pCODFIL ALIAS FOR $6 ;
 
-- Declarao de variveis e cursores
   --pFILCLI ALIAS FOR $1 ;
   --pCODCLI ALIAS FOR $2 ;
   --pTIPCCC ALIAS FOR $3 ;
   --pDATINI ALIAS FOR $4 ;
   --pDATFIM ALIAS FOR $5 ;
   --pCODFIL ALIAS FOR $6 ;
   
   pVLRCRE  Numeric;
   pVLRDEB  Numeric;
   vResult  VARCHAR(100);
   
-- Incio da funo

BEGIN

SELECT
   SUM(CASE WHEN VLRLAN > 0 THEN VLRLAN ELSE 0 END) AS VLRCRE,
   SUM(CASE WHEN VLRLAN < 0 THEN VLRLAN ELSE 0 END) AS VLRDEB
   INTO pVLRCRE, pVLRDEB
  FROM TT_CCC
 WHERE TIPCCC = pTIPCCC
   AND FILCLI = pFILCLI
   AND CODCLI = pCODCLI
   AND CODFIL = pCODFIL
   AND TRUNC(DATOPE) BETWEEN pDATINI AND pDATFIM;
 
 vResult := TRIM(TO_CHAR(COALESCE(pVLRCRE,0), '999999999.99'));
 vResult := vResult || ';' || TRIM(TO_CHAR(COALESCE(pVLRDEB,0), '999999999.99'));
   
 RETURN vResult;

END;
$$ language 'plpgsql';




/*-- SEQ 0148 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CriaSeparacaoReposicao (TT_PED.CODFIL%TYPE,Numeric,TT_PED.NUMPED%TYPE) CASCADE;

/*-- SEQ 0149 --*/
CREATE OR REPLACE FUNCTION CriaSeparacaoReposicao (TT_PED.CODFIL%TYPE,Numeric,TT_PED.NUMPED%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pDIAS ALIAS FOR $2 ;
pNUMPED ALIAS FOR $3 ;


-- Objetivos:
-- 1) Criar TT_IVO dos pedidos de reposio.

-- Parmetros:
-- pCODFIL: Filial do Pedido.
-- pDIAS: Nmero de Dias Pretritos que Sero Considerados para Encontrar Pedidos.
-- pNUMPED: Nmero do Pedido.

-- Declarao de variveis e cursores

   cTemp                         TT_FUN.NOMFUN%TYPE;
   dDataInicial                  Timestamp;
   cFiltroFilial                 TT_PED.CODFIL%TYPE;
   cFiltroNUMPED                 TT_PED.NUMPED%TYPE;
   vFILVOL                       TT_IVO.FILVOL%TYPE;
   vFLGEST                       TT_IVO.FLGEST%TYPE;
   vFILIPE                       TT_IVO.FILIPE%TYPE;
   vNUMIPE                       TT_IVO.NUMIPE%TYPE;
   vITEIPE                       TT_IVO.ITEIPE%TYPE;

   CursorSeparacaoPelaReposicao CURSOR FOR
   -- Pedidos sem separao
   SELECT IPE.CODFIL,
          IPE.NUMPED,
          IPE.NUMITE
     FROM TT_PED PED INNER JOIN TT_IPE IPE ON IPE.CODFIL = PED.CODFIL
                                          AND IPE.NUMPED = PED.NUMPED
                      LEFT JOIN TT_IVO IVO ON IVO.FILIPE = IPE.CODFIL
                                          AND IVO.NUMIPE = IPE.NUMPED
                                          AND IVO.ITEIPE = IPE.NUMITE
    WHERE PED.CODFOR = '     0' -- Reposio
      AND PED.FLGEST = '2'      -- Autorizados
      AND PED.DATPED >= COALESCE(dDataInicial, PED.DATPED)
      AND PED.CODFIL = COALESCE(cFiltroFilial, PED.CODFIL)
      AND PED.NUMPED = COALESCE(cFiltroNUMPED, PED.NUMPED)
      AND IVO.FILIPE IS NULL
	  AND IPE.FLGEST <> 'C' -- No criar/recriar caso o item do pedido foi cancelado.
   UNION ALL
   -- Pedidos que possuem separao parcial
   SELECT TAB.CODFIL,
          TAB.NUMPED,
          TAB.NUMITE
     FROM (
      SELECT IPE.CODFIL,
             IPE.NUMPED,
             IPE.NUMITE,
             MAX(IPE.QTDITE) AS QTDITE,
             SUM(COALESCE(IVO.CONTEM,0) + IVO.QTDFAL) AS QTDSEP
        FROM TT_PED PED INNER JOIN TT_IPE IPE ON IPE.CODFIL = PED.CODFIL
                                             AND IPE.NUMPED = PED.NUMPED
                        INNER JOIN TT_IVO IVO ON IVO.FILIPE = IPE.CODFIL
                                             AND IVO.NUMIPE = IPE.NUMPED
                                             AND IVO.ITEIPE = IPE.NUMITE
       WHERE PED.CODFOR = '     0' -- Reposio
         AND PED.FLGEST = '2'      -- Autorizados
         AND PED.DATPED >= COALESCE(dDataInicial, PED.DATPED)
         AND PED.CODFIL = COALESCE(cFiltroFilial, PED.CODFIL)
         AND PED.NUMPED = COALESCE(cFiltroNUMPED, PED.NUMPED)
         AND IVO.FLGEST IN ('P','F')
		 AND IPE.FLGEST <> 'C' -- No criar/recriar caso o item do pedido foi cancelado.
       GROUP BY IPE.CODFIL, IPE.NUMPED, IPE.NUMITE
    ) TAB
     WHERE QTDITE > QTDSEP  -- Ainda possui alguma qtd para ser separada
   UNION ALL
   -- Pedidos separao cancelada
   SELECT IPE.CODFIL,
          IPE.NUMPED,
          IPE.NUMITE
     FROM TT_PED PED INNER JOIN TT_IPE IPE ON IPE.CODFIL = PED.CODFIL
                                          AND IPE.NUMPED = PED.NUMPED
    WHERE PED.CODFOR = '     0' -- Reposio
      AND PED.FLGEST = '2'      -- Autorizados
      AND PED.DATPED >= COALESCE(dDataInicial, PED.DATPED)
      AND PED.CODFIL = COALESCE(cFiltroFilial, PED.CODFIL)
      AND PED.NUMPED = COALESCE(cFiltroNUMPED, PED.NUMPED)
      AND EXISTS (SELECT 1 AS OK
                    FROM TT_IVO IVO
                   WHERE IVO.FILIPE = IPE.CODFIL
                     AND IVO.NUMIPE = IPE.NUMPED
                     AND IVO.ITEIPE = IPE.NUMITE
                     AND IVO.FLGEST = 'C')   
      AND NOT EXISTS (SELECT 1 AS OK
                    FROM TT_IVO IVO
                   WHERE IVO.FILIPE = IPE.CODFIL
                     AND IVO.NUMIPE = IPE.NUMPED
                     AND IVO.ITEIPE = IPE.NUMITE
                     AND IVO.FLGEST IN ('A','P','F'))
      AND IPE.FLGEST <> 'C'; -- No recriar caso o item do pedido foi cancelado.

-- Incio da funo
BEGIN
   -- Garantia de exclusividade no processo seguinte
   SELECT NOMFUN INTO cTemp
     FROM TT_FUN
    WHERE NOMFUN = 'LOCK_SEP_R'
      FOR UPDATE;

   IF ISNULL(pCODFIL) = 'T' THEN
      cFiltroFilial := NULL;
   ELSE
      cFiltroFilial := pCODFIL;
   END IF;
   IF ISNULL(pNUMPED) = 'T' THEN
      cFiltroNUMPED := NULL;
   ELSE
      cFiltroNUMPED := pNUMPED;
   END IF;
   -- Somente fora o nmero de dias quando no informado o nmero do pedido.
   IF (NVLZ(pDIAS,0)=0) THEN
      dDataInicial := NULL;
      IF ISNULL(pNUMPED) = 'T' THEN
         dDataInicial := ADD_DAY(TRUNC(Agora()), ABS(NVLZ(pDIAS,7))*-1);
      END IF;
   ELSE
      dDataInicial := ADD_DAY(TRUNC(Agora()), ABS(NVLZ(pDIAS,7))*-1);
   END IF;
   

   -- Cancelar separaes com pedidos cancelados
   UPDATE TT_IVO IVO
      SET FLGEST = CASE WHEN FLGEST = 'P' THEN 'D' ELSE 'C' END,
          FILROM = NULL,
          SEQROM = NULL,
          QTDFAL = 0
    WHERE 1=1
      AND IVO.ATU_EM >= COALESCE(dDataInicial, IVO.ATU_EM)
      AND IVO.FLGEST IN ('A', 'P')
      AND (IVO.FILIPE, IVO.NUMIPE, IVO.ITEIPE) IN
          (SELECT IPE.CODFIL, IPE.NUMPED, IPE.NUMITE
             FROM TT_IPE IPE
             JOIN TT_PED PED ON PED.CODFIL = IPE.CODFIL AND PED.NUMPED = IPE.NUMPED
            WHERE ((IPE.FLGEST = 'C') OR (PED.FLGEST = 'C'))
              AND IPE.CODFIL = COALESCE(cFiltroFilial, IPE.CODFIL)
              AND IPE.NUMPED = COALESCE(cFiltroNUMPED, IPE.NUMPED)
            );

   -- Cancelar separaes com pedidos que no esto mais autorizados antes de serem separados
   UPDATE TT_IVO IVO
      SET FLGEST = 'C',
          FILROM = NULL,
          SEQROM = NULL,
          QTDFAL = 0
    WHERE 1=1
      AND IVO.ATU_EM >= COALESCE(dDataInicial, IVO.ATU_EM)
      AND IVO.FLGEST = 'A'
      AND (IVO.FILIPE, IVO.NUMIPE, IVO.ITEIPE) IN
          (SELECT IPE.CODFIL, IPE.NUMPED, IPE.NUMITE
             FROM TT_IPE IPE INNER JOIN TT_PED PED ON PED.CODFIL = IPE.CODFIL
                                                  AND PED.NUMPED = IPE.NUMPED
            WHERE PED.FLGEST IN ('A','0')
              AND IPE.FLGEST = 'A'
              AND IPE.CODFIL = COALESCE(cFiltroFilial, IPE.CODFIL)
              AND IPE.NUMPED = COALESCE(cFiltroNUMPED, IPE.NUMPED)
              );

   -- Cancelar separaes com pedidos abertos, mas antigos
   /*
     -> Habilitar esse comando se o rastro de separaes abertos ficar muito grande
     -> Ele tem a desvantagem de no ter uma data inicial
   UPDATE TT_IVO IVO
      SET FLGEST = 'C',
          FILROM = NULL,
          SEQROM = NULL,
          QTDFAL = 0
    WHERE 1=1
      AND IVO.FLGEST = 'A'
      AND (IVO.FILIPE, IVO.NUMIPE, IVO.ITEIPE) IN
          (SELECT IPE.CODFIL, IPE.NUMPED, IPE.NUMITE
             FROM TT_IPE IPE INNER JOIN TT_PED PED ON PED.CODFIL = IPE.CODFIL
                                                  AND PED.NUMPED = IPE.NUMPED
            WHERE PED.FLGEST = '2'
              AND IPE.FLGEST = 'A'
              AND PED.DATPED < COALESCE(dDataInicial, PED.DATPED)
              AND IPE.CODFIL = COALESCE(cFiltroFilial, IPE.CODFIL)
              AND IPE.NUMPED = COALESCE(cFiltroNUMPED, IPE.NUMPED)
              );
              */

   OPEN CursorSeparacaoPelaReposicao;
   LOOP
      FETCH CursorSeparacaoPelaReposicao
       INTO vFILIPE, vNUMIPE, vITEIPE;
      EXIT WHEN NOT FOUND;

      vFILVOL := vFILIPE;
      vFLGEST := 'A';

      -- Cria itens de volume
      INSERT INTO TT_IVO
      (FILVOL, FLGEST, FILIPE, NUMIPE, ITEIPE)
      VALUES
      (vFILVOL, vFLGEST, vFILIPE, vNUMIPE, vITEIPE);

   END LOOP;
   CLOSE CursorSeparacaoPelaReposicao;

   RETURN 'OK';

END;
$$ language 'plpgsql';


/*-- SEQ 0150 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CriaSeparacaoReposicao (TT_PED.CODFIL%TYPE,Numeric) CASCADE;

/*-- SEQ 0151 --*/
CREATE OR REPLACE FUNCTION CriaSeparacaoReposicao (TT_PED.CODFIL%TYPE,
                               Numeric) 
RETURNS VARCHAR AS $$
BEGIN
RETURN CriaSeparacaoReposicao($1,$2,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 0152 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DataFimValidadePromocao () CASCADE;

/*-- SEQ 0153 --*/
CREATE OR REPLACE FUNCTION DataFimValidadePromocao ()
RETURNS VARCHAR AS $$
DECLARE


-- Objetivos:
-- 1. Ajustar a Data Final de validade da promoo com base
--    na quantidade disponvel e na quantidade vendida

-- Declarao de variveis e cursores
   cMANUT                  TT_IDF.MANUT%TYPE;
   COMPLEMENTO             CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Incio da funo
BEGIN

   SELECT MANUT INTO cMANUT
     FROM TT_IDF;

   IF cMANUT = 'T' THEN
      RAISE EXCEPTION 'PG-20000 Base em manuteno. %' , COMPLEMENTO;
   END IF;

   UPDATE TT_CPM CPM
      SET DATVAL = Agora()
    WHERE CPM.QTDCPM > 0
      AND ((CPM.DATVAL > Agora()) OR (CPM.DATVAL IS NULL))
      AND ((CPM.DATINI <= Agora()) OR  (CPM.DATINI IS NULL))
      AND ( SELECT SUM(IVE.QTDMOV) 
              FROM TT_IVE IVE
             WHERE CPM.FILCPM = IVE.FILCPM
               AND CPM.SEQUEN = IVE.SEQCPM
           ) >= CPM.QTDCPM
      ;

   RETURN 'OK';

END;
$$ language 'plpgsql';



/*-- SEQ 0154 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_DataFimValidadePromocao (TT_JOB.CODUID%TYPE) CASCADE;

/*-- SEQ 0155 --*/
CREATE OR REPLACE FUNCTION Job_DataFimValidadePromocao (TT_JOB.CODUID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODUID ALIAS FOR $1 ;

-- Objetivos:
-- 1. Executar funo Exemplo.
-- 2. Registrar o resultado na TT_JOB.

-- Declarao de variveis e cursores
  cNOMJOB                  TT_JOB.NOMJOB%TYPE;
  cDESJOB                  TT_JOB.DESJOB%TYPE;
  cDummy                   CHAR(2);

-- Incio da funo
begin
   cNOMJOB := 'JOB_AJTDTFIMVALCPM';
   cDESJOB := 'Ajustar a data final da validade da promoo.';
   BEGIN
      cDummy := DataFimValidadePromocao();
      cDummy := RegistraJob(cNOMJOB, cDESJOB, NULL, pCODUID);
   EXCEPTION
      WHEN OTHERS THEN cDummy := RegistraJob(cNOMJOB, cDESJOB, SQLERRM, pCODUID);
   END;
  RETURN NULL;

END;
$$ language 'plpgsql';



/*-- SEQ 0156 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AjustarDataFinalValidadePromocao () CASCADE;

/*-- SEQ 0157 --*/
CREATE OR REPLACE FUNCTION AjustarDataFinalValidadePromocao ()
RETURNS VARCHAR AS $$
DECLARE


-- Essa funo foi mantida para ter compatibilidade com a GIMBA que j est usando em relatrios 
-- e no cron do linux
  cResult                 CHAR(100);
BEGIN

   SELECT DataFimValidadePromocao()
     INTO cResult
     FROM TT_IDF;
     
   RETURN 'OK';

END;
$$ language 'plpgsql';



/*-- SEQ 0158 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_AjustarDataFinalValidadePromocao (TT_JOB.CODUID%TYPE) CASCADE;

/*-- SEQ 0159 --*/
CREATE OR REPLACE FUNCTION Job_AjustarDataFinalValidadePromocao (TT_JOB.CODUID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODUID ALIAS FOR $1 ;

   cDummy       CHAR(2);
-- Objetivos:
-- 1. Executar funo DataFimValidadePromocao

-- Incio da funo
begin
   
   SELECT Job_DataFimValidadePromocao(pCODUID)
     INTO cDummy
     FROM TT_IDF;   
   
  RETURN NULL;

END;
$$ language 'plpgsql';





/*-- SEQ 0160 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DefinirItemEntregaFutura (TT_IVO.FILVOL%TYPE,TT_IVO.SEQUEN%TYPE) CASCADE;

/*-- SEQ 0161 --*/
CREATE OR REPLACE FUNCTION DefinirItemEntregaFutura (TT_IVO.FILVOL%TYPE,TT_IVO.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILVOL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
-- Objetivo:
-- 1) Altera um item do oramento para "Entrega Futura"
  
  -- Retorno
  Retorno VARCHAR(254);
  
  -- Variveis auxiliares  
  IVE_CODFIL TT_IVE.CODFIL%TYPE;
  IVE_SEQUEN TT_IVE.SEQUEN%TYPE;
  IVE_NUMITE TT_IVE.NUMITE%TYPE;
  IVE_LANEST TT_IVE.LANEST%TYPE;
  
    
BEGIN

   SELECT IVO.FILIVE, IVO.SEQIVE, IVO.NUMIVE
     INTO IVE_CODFIL, IVE_SEQUEN, IVE_NUMITE
     FROM TT_IVO IVO
    WHERE 1=1
      AND IVO.FILVOL = pFILVOL
      AND IVO.SEQUEN = pSEQUEN;
      
   IF (IVE_CODFIL IS NOT NULL) AND (IVE_SEQUEN IS NOT NULL) AND (IVE_NUMITE > 0) THEN
   
      -- Verifica se  Simples Fatura
      SELECT IVE.LANEST
        INTO IVE_LANEST
        FROM TT_IVE IVE
       WHERE 1=1
         AND IVE.CODFIL = IVE_CODFIL
         AND IVE.SEQUEN = IVE_SEQUEN
         AND IVE.NUMITE = IVE_NUMITE;
         
      IF (IVE_LANEST <> 'R') THEN
         Retorno := 'Erro: A alterao do item para Entrega Futura  permitida apenas em vendas do tipo Simples Fatura.';
         Return Retorno;
      END IF;
      
      -- Se estiver certo, faz o UPDATE na IVE
      UPDATE TT_IVE
         SET FLGFUT = 'A',
             QTDPEN = QTDMOV,
             QTDFUT = QTDMOV
       WHERE 1=1
         AND CODFIL = IVE_CODFIL
         AND SEQUEN = IVE_SEQUEN
         AND NUMITE = IVE_NUMITE
         AND LANEST = 'R'; 
         
      -- Se estiver certo, faz o UPDATE na IOR
      UPDATE TT_IOR
         SET TIPENT = 5
       WHERE 1=1 
         AND FILIVE = IVE_CODFIL
         AND SEQIVE = IVE_SEQUEN
         AND NUMIVE = IVE_NUMITE;
             
   END IF;
      
   -- Se no houve erro at aqui, cancela o registro na TT_IVO por ltimo
   IF (Retorno = '') THEN
      UPDATE TT_IVO
         SET FLGEST = 'C' --SIGNAT = -1
       WHERE 1=1
         AND FILVOL = pFILVOL
         AND SEQUEN = pSEQUEN; 
   END IF;
   
   Retorno := 'Alterao realizada com sucesso.';
   RETURN Retorno;
  
END;
$$ language 'plpgsql';

  


/*-- SEQ 0162 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DescricaoDespesasOperacionais (TT_DSP.TABELA%TYPE,TT_DSP.CODTAB%TYPE) CASCADE;

/*-- SEQ 0163 --*/
CREATE OR REPLACE FUNCTION DescricaoDespesasOperacionais (TT_DSP.TABELA%TYPE,TT_DSP.CODTAB%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pTABELA ALIAS FOR $1 ;
pCODTAB ALIAS FOR $2 ;
 
-- Objetivos:
-- 1. Retornar o nome do Departamento ou Classe da Tabela de Despesas Acessrias
 
-- Declarao de variveis e cursores
   cResultado                    VARCHAR(40);
 
-- Incio da funo
BEGIN

   IF ISNULL(pTABELA)='T' THEN 
      RAISE EXCEPTION 'PG-20000 Obrigatrio informar tabela.';
   END IF;
   IF ISNULL(TO_CHAR(pCODTAB))='T' THEN 
      RAISE EXCEPTION 'PG-20000 Obrigatrio informar o Cdigo.';
   END IF;

   IF (pTABELA = 'TD_DEP') THEN
      SELECT DESDEP INTO cResultado FROM TD_DEP WHERE CODTAB = pCODTAB;
   ELSIF (pTABELA = 'TD_CL1') THEN
      SELECT CLASS1 INTO cResultado FROM TD_CL1 WHERE CODTAB = pCODTAB;
   ELSIF (pTABELA = 'TD_CL2') THEN
      SELECT CLASS2 INTO cResultado FROM TD_CL2 WHERE CODTAB = pCODTAB;
   ELSIF (pTABELA = 'TD_CL3') THEN
      SELECT CLASS3 INTO cResultado FROM TD_CL3 WHERE CODTAB = pCODTAB;
   ELSIF (pTABELA = 'TD_CL4') THEN
      SELECT CLASS4 INTO cResultado FROM TD_CL4 WHERE CODTAB = pCODTAB;
   END IF;

   RETURN cResultado;
 
END;
$$ language 'plpgsql';




/*-- SEQ 0164 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DescricaoSubsidioFrete (TT_TSF.TABELA%TYPE,TT_TSF.CODTAB%TYPE) CASCADE;

/*-- SEQ 0165 --*/
CREATE OR REPLACE FUNCTION DescricaoSubsidioFrete (TT_TSF.TABELA%TYPE,TT_TSF.CODTAB%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pTABELA ALIAS FOR $1 ;
pCODTAB ALIAS FOR $2 ;
 
-- Objetivos:
-- 1. Retornar o nome da Categoria, Departamento ou Classe
 
-- Declarao de variveis e cursores
   cResultado                    VARCHAR(40);
 
-- Incio da funo
BEGIN

   IF ISNULL(pTABELA)='T' THEN 
      RAISE EXCEPTION 'PG-20000 Obrigatrio informar tabela.';
   END IF;
   IF ISNULL(TO_CHAR(pCODTAB))='T' THEN 
      RAISE EXCEPTION 'PG-20000 Obrigatrio informar o Cdigo.';
   END IF;

   IF (pTABELA = 'TD_CT1') THEN
      SELECT NOMCT1 INTO cResultado FROM TD_CT1 WHERE CODTAB = pCODTAB;
   ELSIF (pTABELA = 'TD_CT2') THEN
      SELECT NOMCT2 INTO cResultado FROM TD_CT2 WHERE CODTAB = pCODTAB;
   ELSIF (pTABELA = 'TD_CT3') THEN
      SELECT NOMCT3 INTO cResultado FROM TD_CT3 WHERE CODTAB = pCODTAB;
   ELSIF (pTABELA = 'TD_DEP') THEN
      SELECT DESDEP INTO cResultado FROM TD_DEP WHERE CODTAB = pCODTAB;
   ELSIF (pTABELA = 'TD_CL1') THEN
      SELECT CLASS1 INTO cResultado FROM TD_CL1 WHERE CODTAB = pCODTAB;
   ELSIF (pTABELA = 'TD_CL2') THEN
      SELECT CLASS2 INTO cResultado FROM TD_CL2 WHERE CODTAB = pCODTAB;
   ELSIF (pTABELA = 'TD_CL3') THEN
      SELECT CLASS3 INTO cResultado FROM TD_CL3 WHERE CODTAB = pCODTAB;
   ELSIF (pTABELA = 'TD_CL4') THEN
      SELECT CLASS4 INTO cResultado FROM TD_CL4 WHERE CODTAB = pCODTAB;
   END IF;

   RETURN cResultado;
 
END;
$$ language 'plpgsql';




/*-- SEQ 0166 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DespesaOperacional (VARCHAR,TT_DSP.FILPRE%TYPE,TT_DSP.CODPRE%TYPE,TT_DSP.CODTAB%TYPE,TT_DSP.CODTAB%TYPE,TT_DSP.CODTAB%TYPE,TT_DSP.CODTAB%TYPE,TT_DSP.CODTAB%TYPE,TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 0167 --*/
CREATE OR REPLACE FUNCTION DespesaOperacional (VARCHAR,TT_DSP.FILPRE%TYPE,TT_DSP.CODPRE%TYPE,TT_DSP.CODTAB%TYPE,TT_DSP.CODTAB%TYPE,TT_DSP.CODTAB%TYPE,TT_DSP.CODTAB%TYPE,TT_DSP.CODTAB%TYPE,TD_FIL.CODFIL%TYPE)
RETURNS Numeric AS $$
DECLARE
pTipo ALIAS FOR $1 ;
pFILPRE ALIAS FOR $2 ;
pCODPRE ALIAS FOR $3 ;
pCLASS1 ALIAS FOR $4 ;
pCLASS2 ALIAS FOR $5 ;
pCLASS3 ALIAS FOR $6 ;
pCLASS4 ALIAS FOR $7 ;
pDEPART ALIAS FOR $8 ;
pCODFIL ALIAS FOR $9 ;

-- Objetivos:
-- 1. Retornar o percentual de despesa operacional (varivel ou fixa)

-- Declarao de variveis e cursores
   nPercDespFixa                 TT_DSP.PERFIX%TYPE;
   nPercDespVar                  TT_DSP.PERVAR%TYPE;

-- Incio da funo
BEGIN
  nPercDespFixa := -1;
  nPercDespVar  := -1;
  
  -- Primeiro procura por classe/departamento e tabela de preo (TT_DSP)
    SELECT COALESCE(MAX(TAB.PERFIX),-1) AS PERFIX, 
         COALESCE(MAX(TAB.PERVAR),-1) AS PERVAR INTO nPercDespFixa,nPercDespVar
      FROM (
            SELECT DSP.PERFIX, DSP.PERVAR
              FROM TT_DSP DSP
             WHERE DSP.TABELA = 'TD_CL1'
               AND DSP.CODTAB = pCLASS1
               AND DSP.FILPRE = pFILPRE
               AND DSP.CODPRE = pCODPRE
            UNION ALL
            SELECT DSP.PERFIX, DSP.PERVAR
              FROM TT_DSP DSP
             WHERE DSP.TABELA = 'TD_CL2'
               AND DSP.CODTAB = pCLASS2
               AND DSP.FILPRE = pFILPRE
               AND DSP.CODPRE = pCODPRE
            UNION ALL
            SELECT DSP.PERFIX, DSP.PERVAR
              FROM TT_DSP DSP
             WHERE DSP.TABELA = 'TD_CL3'
               AND DSP.CODTAB = pCLASS3
               AND DSP.FILPRE = pFILPRE
               AND DSP.CODPRE = pCODPRE
            UNION ALL
            SELECT DSP.PERFIX, DSP.PERVAR
              FROM TT_DSP DSP
             WHERE DSP.TABELA = 'TD_CL4'
               AND DSP.CODTAB = pCLASS4
               AND DSP.FILPRE = pFILPRE
               AND DSP.CODPRE = pCODPRE
            UNION ALL
            SELECT DSP.PERFIX, DSP.PERVAR
              FROM TT_DSP DSP
             WHERE DSP.TABELA = 'TD_DEP'
               AND DSP.CODTAB = pDEPART
               AND DSP.FILPRE = pFILPRE
               AND DSP.CODPRE = pCODPRE
  ) TAB;
    
  
  -- Se no encontrar, pega da filial
  IF (nPercDespFixa = -1) OR (nPercDespVar = -1) THEN
        SELECT PEROPEFIX, PEROPE INTO nPercDespFixa,nPercDespVar
      FROM TD_FIL
     WHERE CODFIL = pCODFIL;
      
  END IF;
  
  -- F = Fixa
  -- V = Varivel
  IF pTipo = 'F' THEN
    RETURN nPercDespFixa;
  ELSE
    RETURN nPercDespVar;
  END IF;
  
END;
$$ language 'plpgsql';




/*-- SEQ 0168 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DiaFechadoFiscal (TR_ECF.CODFIL%TYPE,TR_ECF.NUMECF%TYPE,TR_ECF.DATOPE%TYPE,TR_ECF.CNT_RO%TYPE) CASCADE;

/*-- SEQ 0169 --*/
CREATE OR REPLACE FUNCTION DiaFechadoFiscal (TR_ECF.CODFIL%TYPE,TR_ECF.NUMECF%TYPE,TR_ECF.DATOPE%TYPE,TR_ECF.CNT_RO%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_Codfil ALIAS FOR $1 ;
p_NumEcf ALIAS FOR $2 ;
p_DatOpe ALIAS FOR $3 ;
p_Cnt_Ro ALIAS FOR $4 ;

-- Objetivos:
-- 1. Fazer consistncias complementares ao DiaFechado e relacionadas s tributaes dos itens de CF.
--
--    a) Somar o valor dos itens cancelados TT_IVE dos CFs que estiverem no cancelados, e somar o VLRLIQ das
--       vendas que estiverem canceladas. Comparar o resultado com total cancelados da TT_ECF.
--       Isso  necessrio porque itens dos CFs cancelados podem no existir.
--
--    b) Somar o valor lquido dos itens VLRLIQRAT que no esto cancelados com cada tipo de tributao da
--       TT_IVE e comparar com os totalizadores da TT_ECF.
--
--    c) Somar o desconto dos itens DESRAT que no esto cancelados de cada CF e comparar com o totalizador de
--       desconto.

-- Declarao de variveis e cursores
wk_Resultado 			VARCHAR(4000);

wk_VlrCancIve	        TT_ECF.VLRBAS%TYPE;
wk_VlrCancVen		    TT_ECF.VLRBAS%TYPE;
wk_VlrCancEcf			TT_ECF.VLRBAS%TYPE;

wk_VlrIsenIve			TT_ECF.VLRBAS%TYPE;
wk_VlrIsenEcf			TT_ECF.VLRBAS%TYPE;

wk_VlrSubsIve			TT_ECF.VLRBAS%TYPE;
wk_VlrSubsEcf			TT_ECF.VLRBAS%TYPE;

wk_VlrNaotIve		    TT_ECF.VLRBAS%TYPE;
wk_VlrNaotEcf		    TT_ECF.VLRBAS%TYPE;

wk_AliTribIve	        TT_ECF.TOTALI%TYPE;
wk_VlrTribIve           TT_ECF.VLRBAS%TYPE;
wk_AliTribEcf	        TT_ECF.TOTALI%TYPE;
wk_VlrTribEcf	        TT_ECF.VLRBAS%TYPE;

wk_VlrDescIve			TT_ECF.VLRBAS%TYPE;
wk_VlrDescIte			TT_ECF.VLRBAS%TYPE;
wk_VlrDescEcf			TT_ECF.VLRBAS%TYPE;

ERR_DifCANC             CONSTANT VARCHAR(100) := 'A soma do total das vendas e itens cancelados diverge do totalizador de cancelamento.';
ERR_DifISEN             CONSTANT VARCHAR(100) := 'A soma total dos itens isentos diverge do totalizador de iseno.';
ERR_DifSUBS             CONSTANT VARCHAR(100) := 'A soma total dos itens com substituio diverge do totalizador de substituio.';
ERR_DifNAOT             CONSTANT VARCHAR(100) := 'A soma total dos itens no tributados diverge do totalizador de no tributados.';
ERR_DifTRIB             CONSTANT VARCHAR(100) := 'A soma total dos itens tributados diverge do totalizador de tributados [Totalizador: %s].';
ERR_SemAliqTRIB         CONSTANT VARCHAR(100) := 'Existem vendas tributadas para totalizador inexistente [Totalizador: %s].';
ERR_SemAliqIveTRIB      CONSTANT VARCHAR(100) := 'Existem totalizadores tributados sem vendas [Totalizador: %s].';
ERR_DifDESC             CONSTANT VARCHAR(100) := 'A soma total dos descontos diverge do totalizador de desconto.';

b_Encontrou             BOOLEAN;

CR_IVE_Tributados CURSOR(pFilial VARCHAR,
           pNumECF VARCHAR,
           pDatOpe Timestamp,
           pCntRO Numeric) IS
SELECT TAB.*
  FROM (
SELECT CAST(LPAD(TO_CHAR(TRUNC(ROUND(IVE.TAXICM * ((100-(COALESCE(IVE.REDITE,0)))/100),2)*100)),4,'0')  AS CHAR(4)) AS TOTALIBCO,
       COALESCE(SUM(IVE.VLRLIQRAT),0) AS VALORBCO
  FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN
 WHERE VEN.CODFIL = pFilial
   AND VEN.NUMECF = pNumEcf
   AND VEN.DATFIS = pDatOpe
   AND VEN.CNT_RO = pCntRO
   AND VEN.CODSER = 'CF'
   AND IVE.ICMTIP = '0'
   AND IVE.SITMOV <> 'C'
   AND IVE.SITKIT IN ('2','3')
   AND IVE.TIPPRO = '0'
 GROUP BY LPAD(TO_CHAR(TRUNC(ROUND(IVE.TAXICM * ((100-(COALESCE(IVE.REDITE,0)))/100),2)*100)),4,'0')
) TAB
ORDER BY TOTALIBCO;

CR_ECF_Tributados CURSOR(pFilial VARCHAR,
           pNumECF VARCHAR,
           pDatOpe Timestamp,
           pCntRO Numeric) IS
SELECT ECF.TOTALI AS TOTALIECF,
       COALESCE(ECF.VLRBAS,0) AS VALORECFO
  FROM TT_ECF ECF
 WHERE ECF.CODFIL = pFilial
   AND ECF.NUMECF = pNumEcf
   AND ECF.DATOPE = pDatOpe
   AND ECF.CNT_RO = pCntRO
   AND ECF.TIPTOT = 'M'
   AND COALESCE(ECF.VLRBAS,0) > 0
 ORDER BY ECF.TOTALI;

-- Incio da funo
BEGIN

   wk_Resultado := '';

   ---------------------------------------------------------------------
   -- Incio da validao de cancelamento (A)
   ---------------------------------------------------------------------

   -- Itens da venda cancelados com a venda no cancelada
   SELECT COALESCE((SELECT SUM(IVE.VLRMOV)
                      FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL
                                                           AND VEN.SEQUEN = IVE.SEQUEN
                     WHERE VEN.CODFIL = p_CodFil
                       AND VEN.NUMECF = p_NumEcf
                       AND VEN.DATFIS = p_DatOpe
                       AND VEN.CNT_RO = p_Cnt_Ro
                       AND VEN.CODSER = 'CF'
                       AND VEN.FLGEST <> 'C'
                       AND IVE.SITKIT IN ('2','3')
                       AND IVE.SITMOV = 'C'
                       AND IVE.TIPPRO = '0'),0)
     INTO wk_VlrCancIve
     FROM DUAL;

   -- Vendas canceladas
   SELECT COALESCE((SELECT SUM(VEN.VLRLIQ)
                      FROM TT_VEN VEN
                     WHERE VEN.CODFIL = p_CodFil
                       AND VEN.NUMECF = p_NumEcf
                       AND VEN.DATFIS = p_DatOpe
                       AND VEN.CNT_RO = p_Cnt_Ro
                       AND VEN.CODSER = 'CF'
                       AND VEN.FLGEST = 'C'),0)
     INTO wk_VlrCancVen
     FROM DUAL;

   -- Totalizador de cancelamento
   SELECT COALESCE((SELECT ECF.VLRTOT
                      FROM TT_ECF ECF
                     WHERE ECF.CODFIL = p_CodFil
                       AND ECF.NUMECF = p_NumEcf
                       AND ECF.DATOPE = p_DatOpe
                       AND ECF.TOTALI = 'CANC'
                       AND ECF.TIPTOT = 'O'),0)
     INTO wk_VlrCancEcf
     FROM DUAL;

   -- Validao de cancelamento
   IF (wk_VlrCancIve + wk_VlrCancVen) <> wk_VlrCancEcf THEN
      wk_Resultado := wk_Resultado || ERR_DifCANC || ' ';
   END IF;

   ---------------------------------------------------------------------
   -- Fim da validao de cancelamento (A)
   ---------------------------------------------------------------------

   ---------------------------------------------------------------------
   -- Incio da validao de iseno (B.1)
   ---------------------------------------------------------------------

   -- Itens da venda isentados
   SELECT COALESCE((SELECT SUM(IVE.VLRLIQRAT)
                      FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL
                                                           AND VEN.SEQUEN = IVE.SEQUEN
                     WHERE VEN.CODFIL = p_CodFil
                       AND VEN.NUMECF = p_NumEcf
                       AND VEN.DATFIS = p_DatOpe
                       AND VEN.CNT_RO = p_Cnt_Ro
                       AND VEN.CODSER = 'CF'
                       AND VEN.FLGEST <> 'C'
                       AND IVE.SITKIT IN ('2','3')
                       AND IVE.SITMOV <> 'C'
                       AND IVE.ICMTIP IN ('2','4')
                       AND IVE.TIPPRO = '0'),0)
   INTO wk_VlrIsenIve
   FROM DUAL;

   -- Totalizador de iseno
   SELECT COALESCE((SELECT ECF.VLRTOT
                      FROM TT_ECF ECF
                     WHERE ECF.CODFIL = p_CodFil
                       AND ECF.NUMECF = p_NumEcf
                       AND ECF.DATOPE = p_DatOpe
                       AND ECF.TOTALI = 'ISEN'
                       AND ECF.TIPTOT = 'O'),0)
   INTO wk_VlrIsenEcf
   FROM DUAL;

  -- Validao de iseno
  IF (wk_VlrIsenIve <> wk_VlrIsenEcf) THEN
     wk_Resultado := wk_Resultado || ERR_DifISEN || ' ';
  END IF;

   ---------------------------------------------------------------------
   -- Fim da validao de iseno (B.1)
   ---------------------------------------------------------------------

   ---------------------------------------------------------------------
   -- Incio da validao de substituio (B.2)
   ---------------------------------------------------------------------

   -- Itens de venda substitudos
   SELECT COALESCE((SELECT SUM(IVE.VLRLIQRAT)
                      FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL
                                                           AND VEN.SEQUEN = IVE.SEQUEN
                     WHERE VEN.CODFIL = p_CodFil
                       AND VEN.NUMECF = p_NumEcf
                       AND VEN.DATFIS = p_DatOpe
                       AND VEN.CNT_RO = p_Cnt_Ro
                       AND VEN.CODSER = 'CF'
                       AND VEN.FLGEST <> 'C'
                       AND IVE.SITKIT IN ('2','3')
                       AND IVE.SITMOV <> 'C'
                       AND IVE.ICMTIP = '3'
                       AND IVE.TIPPRO = '0'),0)
   INTO wk_VlrSubsIve
   FROM DUAL;

   -- Totalizador de substituio
   SELECT COALESCE((SELECT ECF.VLRTOT
                      FROM TT_ECF ECF
                     WHERE ECF.CODFIL = p_CodFil
                       AND ECF.NUMECF = p_NumEcf
                       AND ECF.DATOPE = p_DatOpe
                       AND ECF.TOTALI = 'SUBS'
                       AND ECF.TIPTOT = 'O'),0)
   INTO wk_VlrSubsEcf
   FROM DUAL;

  -- Validao de substituio
  IF (wk_VlrSubsIve <> wk_VlrSubsEcf) THEN
     wk_Resultado := wk_Resultado || ERR_DifSUBS || ' ';
  END IF;

   ---------------------------------------------------------------------
   -- Fim da validao de substituio (B.2)
   ---------------------------------------------------------------------

   ---------------------------------------------------------------------
   -- Incio da validao de no tributado (B.3)
   ---------------------------------------------------------------------

   -- Itens de venda no tributados
   SELECT COALESCE((SELECT SUM(IVE.VLRLIQRAT)
                      FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL
                                                           AND VEN.SEQUEN = IVE.SEQUEN
                     WHERE VEN.CODFIL = p_CodFil
                       AND VEN.NUMECF = p_NumEcf
                       AND VEN.DATFIS = p_DatOpe
                       AND VEN.CNT_RO = p_Cnt_Ro
                       AND VEN.CODSER = 'CF'
                       AND VEN.FLGEST <> 'C'
                       AND IVE.SITKIT IN ('2','3')
                       AND IVE.SITMOV <> 'C'
                       AND IVE.ICMTIP = '1'
                       AND IVE.TIPPRO = '0'),0)
   INTO wk_VlrNaotIve
   FROM DUAL;

   -- Totalizador de no tributados
   SELECT COALESCE((SELECT ECF.VLRTOT
                      FROM TT_ECF ECF
                     WHERE ECF.CODFIL = p_CodFil
                       AND ECF.NUMECF = p_NumEcf
                       AND ECF.DATOPE = p_DatOpe
                       AND ECF.TOTALI = 'NAOT'
                       AND ECF.TIPTOT = 'O'),0)
   INTO wk_VlrNaotEcf
   FROM DUAL;

  -- Validao de no tributados
  IF (wk_VlrNaotIve <> wk_VlrNaotEcf) THEN
     wk_Resultado := wk_Resultado || ERR_DifNAOT || ' ';
  END IF;

   ---------------------------------------------------------------------
   -- Fim da validao de no tributados (B.3)
   ---------------------------------------------------------------------

   ---------------------------------------------------------------------
   -- Incio da validao para tributados (B.4)
   ---------------------------------------------------------------------

   -- Compare itens de venda com totalizadores
   -- Para encontrar vendas sem totalizadores
   -- E tambm divergncia do valor vendido com o totalizado
   OPEN CR_IVE_Tributados(p_CodFil, p_NumEcf, p_DatOpe, p_Cnt_Ro);
   LOOP
      FETCH CR_IVE_Tributados INTO wk_AliTribIve, wk_VlrTribIve;
      EXIT WHEN NOT FOUND;

      b_Encontrou     := FALSE;

      OPEN CR_ECF_Tributados(p_CodFil, p_NumEcf, p_DatOpe, p_Cnt_Ro);
      LOOP
         FETCH CR_ECF_Tributados INTO wk_AliTribEcf, wk_VlrTribEcf;
         EXIT WHEN NOT FOUND;

         IF wk_AliTribIve = wk_AliTribEcf THEN
            b_Encontrou := TRUE;
            EXIT;
         END IF;

      END LOOP;
      CLOSE CR_ECF_Tributados;

      IF b_Encontrou THEN
         IF wk_VlrTribIve = wk_VlrTribEcf THEN
            b_Encontrou := TRUE;
         ELSE
            wk_Resultado := wk_Resultado || REPLACE(ERR_DifTRIB,'%s',wk_AliTribIve) || ' ';
         END IF;
      ELSE
         wk_Resultado := wk_Resultado || REPLACE(ERR_SemAliqTRIB,'%s',wk_AliTribIve) || ' ';
      END IF;

   END LOOP;
   CLOSE CR_IVE_Tributados;


   -- Compara totalizadores com itens de venda
   -- Apenas para encontrar totalizadores que esto sem as vendas
   OPEN CR_ECF_Tributados(p_CodFil, p_NumEcf, p_DatOpe, p_Cnt_Ro);
   LOOP
      FETCH CR_ECF_Tributados INTO wk_AliTribEcf, wk_VlrTribEcf;
      EXIT WHEN NOT FOUND;

      b_Encontrou     := FALSE;

      OPEN CR_IVE_Tributados(p_CodFil, p_NumEcf, p_DatOpe, p_Cnt_Ro);
      LOOP
         FETCH CR_IVE_Tributados INTO wk_AliTribIve, wk_VlrTribIve;
         EXIT WHEN NOT FOUND;

         IF wk_AliTribIve = wk_AliTribEcf THEN
            b_Encontrou := TRUE;
            EXIT;
         END IF;

      END LOOP;
      CLOSE CR_IVE_Tributados;

      IF NOT b_Encontrou THEN
         wk_Resultado := wk_Resultado || REPLACE(ERR_SemAliqIveTRIB,'%s',wk_AliTribEcf) || ' ';
      END IF;

   END LOOP;
   CLOSE CR_ECF_Tributados;

   ---------------------------------------------------------------------
   -- Fim da validao de tributados (B.4)
   ---------------------------------------------------------------------

   ---------------------------------------------------------------------
   -- Incio da validao para descontos (C)
   ---------------------------------------------------------------------

   -- Itens de venda com desconto
   SELECT COALESCE((SELECT SUM(IVE.DESRAT)
                      FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL
                                                           AND VEN.SEQUEN = IVE.SEQUEN
                     WHERE VEN.CODFIL = p_CodFil
                       AND VEN.NUMECF = p_NumEcf
                       AND VEN.DATFIS = p_DatOpe
                       AND VEN.CNT_RO = p_Cnt_Ro
                       AND VEN.CODSER = 'CF'
                       AND VEN.FLGEST <> 'C'
                       AND IVE.SITKIT IN ('2','3')
                       AND IVE.SITMOV <> 'C'
                       AND IVE.TIPPRO = '0'
                       AND COALESCE(IVE.DESRAT,0) < 0),0)
   INTO wk_VlrDescIve
   FROM DUAL;

   -- Itens de venda com desconto no item
   SELECT COALESCE((SELECT SUM(IVE.VLRDES)
                      FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL
                                                           AND VEN.SEQUEN = IVE.SEQUEN
                     WHERE VEN.CODFIL = p_CodFil
                       AND VEN.NUMECF = p_NumEcf
                       AND VEN.DATFIS = p_DatOpe
                       AND VEN.CNT_RO = p_Cnt_Ro
                       AND VEN.CODSER = 'CF'
                       AND VEN.FLGEST <> 'C'
                       AND IVE.SITKIT IN ('2','3')
                       AND IVE.SITMOV <> 'C'
                       AND IVE.TIPPRO = '0'
                       AND COALESCE(IVE.VLRDES,0) < 0),0)
   INTO wk_VlrDescIte
   FROM DUAL;

   -- Totalizador de descontos
   SELECT COALESCE((SELECT ECF.VLRTOT
                      FROM TT_ECF ECF
                     WHERE ECF.CODFIL = p_CodFil
                       AND ECF.NUMECF = p_NumEcf
                       AND ECF.DATOPE = p_DatOpe
                       AND ECF.TOTALI = 'DESC'
                       AND ECF.TIPTOT = 'O'),0)
   INTO wk_VlrDescEcf
   FROM DUAL;

  -- Validao de descontos
  IF (ABS(wk_VlrDescIve)+ABS(wk_VlrDescIte) <> wk_VlrDescEcf) THEN
     wk_Resultado := wk_Resultado || ERR_DifDESC || ' ';
  END IF;

   ---------------------------------------------------------------------
   -- Fim da validao de descontos (C)
   ---------------------------------------------------------------------

  IF LENGTH(wk_Resultado) > 255 THEN
     wk_Resultado := SUBSTR(RTRIM(wk_Resultado),1,252) || '...';
  END IF;

  RETURN RTRIM(wk_Resultado);

END;
$$ language 'plpgsql';




/*-- SEQ 0170 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DiaUtil (TD_FIL.CODFIL%TYPE,Timestamp) CASCADE;

/*-- SEQ 0171 --*/
CREATE OR REPLACE FUNCTION DiaUtil (TD_FIL.CODFIL%TYPE,Timestamp)
RETURNS VARCHAR AS $$
DECLARE
P_FILIAL ALIAS FOR $1 ;
P_DATA ALIAS FOR $2 ;
     WK_CONTA  Numeric(10);
     WK_DIASEM Numeric(1);
BEGIN

  -- VERIFICA SE O DIA E FERIADO.
  SELECT COUNT(*) INTO WK_CONTA FROM TT_FER
  WHERE ((FILFER IS NULL) OR (FILFER=P_FILIAL))
    AND DIAFER = TO_NUMBER(TO_CHAR(P_DATA,'DD'))
    AND MESFER = TO_NUMBER(TO_CHAR(P_DATA,'MM'))
    AND ((ANOFER = TO_NUMBER(TO_CHAR(P_DATA,'YYYY'))) OR (ANOFER IS NULL));

  IF WK_CONTA > 0 THEN
    -- É FERIADO
    RETURN 'F';
  END IF;

  -- NO BANCO O DOMINGO É CODIGO 1, JÁ NO SISTEMA É CÓDIGO 0
  -- DIASEM GUARDA O DIA DA SEMANA, INICIANDO DE 0
  WK_DIASEM := TO_NUMBER(TO_CHAR(P_DATA,'D'))-1;

  -- VERIFICA SE FILIAL POSSUI EXPEDIENTE
  SELECT COUNT(*) INTO WK_CONTA
    FROM TT_EXP
   WHERE CODFIL = P_FILIAL;

  IF WK_CONTA>0 THEN

    -- VERIFICA SE DIA DA SEMANA ESTÁ NO EXPEDIENTE DA FILIAL
    SELECT COUNT(*) INTO WK_CONTA
      FROM TT_EXP
     WHERE CODFIL = P_FILIAL
       AND DIASEM = WK_DIASEM;

     IF WK_CONTA > 0 THEN
       RETURN 'T';
     ELSE
       RETURN 'F';
     END IF;
  ELSE
     -- SE NAO TEM EXPEDIENTE, CONSIDERA DIA UTIL SEGUNDA A SEXTA
     IF WK_DIASEM IN (1,2,3,4,5) THEN
       RETURN 'T';
     ELSE
       RETURN 'F';
     END IF;
  END IF;
END;
$$ language 'plpgsql';




-- Consultor..: Luciano
-- Cliente....: Lycri Malhas
-- Finalidade.: Retornar a diferena gravada aps ajuste de parcela
-- Ticket.....: 2021081193 
/*-- SEQ 0172 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Diferenca_Subpar_Origem (TT_PAG.CODFIL%TYPE,TT_PAG.SEQUEN%TYPE,TT_PAG.NUMPAR%TYPE,TT_PAG.SUBORI%TYPE) CASCADE;

/*-- SEQ 0173 --*/
CREATE OR REPLACE FUNCTION Diferenca_Subpar_Origem (TT_PAG.CODFIL%TYPE,TT_PAG.SEQUEN%TYPE,TT_PAG.NUMPAR%TYPE,TT_PAG.SUBORI%TYPE)
RETURNS Numeric AS $$
DECLARE
p_CodFil ALIAS FOR $1 ;
p_Sequen ALIAS FOR $2 ;
p_NumPar ALIAS FOR $3 ;
p_SubOri ALIAS FOR $4 ;
--Declarao de varievis e cursores --

   r_Vlrdif      Numeric;-- Valor da diferena --

-- Incio da funo --
BEGIN
   SELECT COALESCE(TT_PAG.VLRPAR,0)-COALESCE(TT_PAG.VLRDIF,0) 
     INTO r_Vlrdif
     FROM TT_PAG
    WHERE CODFIL = p_CodFil
      AND SEQUEN = p_Sequen
      AND NUMPAR = p_NumPar
      AND SUBORI = p_SubOri;

   RETURN COALESCE(r_Vlrdif, 0);

END;
$$ language 'plpgsql';




/*-- SEQ 0174 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION EmailTransfAutom (TT_IOR.CODFIL%TYPE,TT_IOR.FILIVE%TYPE,TT_IOR.SEQIVE%TYPE,TT_IOR.FILMAT%TYPE,TT_IOR.CODMAT%TYPE,TT_IOR.CODCOR%TYPE,TT_IOR.CODTAM%TYPE,TT_IVEXIPE.FILICO%TYPE,TT_IVEXIPE.SEQICO%TYPE,TT_IVEXIPE.NUMICO%TYPE) CASCADE;

/*-- SEQ 0175 --*/
CREATE OR REPLACE FUNCTION EmailTransfAutom (TT_IOR.CODFIL%TYPE,TT_IOR.FILIVE%TYPE,TT_IOR.SEQIVE%TYPE,TT_IOR.FILMAT%TYPE,TT_IOR.CODMAT%TYPE,TT_IOR.CODCOR%TYPE,TT_IOR.CODTAM%TYPE,TT_IVEXIPE.FILICO%TYPE,TT_IVEXIPE.SEQICO%TYPE,TT_IVEXIPE.NUMICO%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pFILIVE ALIAS FOR $2 ;
pSEQIVE ALIAS FOR $3 ;
pFILMAT ALIAS FOR $4 ;
pCODMAT ALIAS FOR $5 ;
pCODCOR ALIAS FOR $6 ;
pCODTAM ALIAS FOR $7 ;
pFILICO ALIAS FOR $8 ;
pSEQICO ALIAS FOR $9 ;
pNUMICO ALIAS FOR $10 ;

  -- Objetivos:
  -- 1. Montar o email que  enviado quando no for possvel cancelar o item
  --    da transferncia automtica.

  -- Declarao de variveis e cursores
   cResultado                    VARCHAR(2);
   vComplemento                  constant VARCHAR(100) := constante('complemento');
   cEMAIL                        TT_CFG.E_MAIL_ESTOQUE%TYPE;
   cMAI_FR                       TT_CFG.MAI_FR%TYPE;
   cDOCUME                       VARCHAR(200);
   cNOMPRO                       VARCHAR(255);

BEGIN

  SELECT E_MAIL_ESTOQUE, MAI_FR INTO cEMAIL, cMAI_FR
    FROM TT_CFG;

  IF cEMAIL IS NOT NULL THEN

     IF pFILIVE IS NOT NULL THEN
        SELECT 'Venda Cancelada: '||NUMECF||'-'||CODSER||'/'||NUMNOT
          INTO cDOCUME
          FROM TT_VEN
         WHERE CODFIL = pFILIVE
           AND SEQUEN = pSEQIVE;
     ELSE
        SELECT 'Fornecedor: '||FILFOR||'-'||TRIM(CODFOR)||chr(13)||chr(10)||
               'Compra Cancelada: '||TRIM(CODSER) ||'/'|| CASE WHEN SUBSER IS NULL THEN ''
                                                               ELSE TRIM(SUBSER)||'-'
                                                          END || TRIM(NUMNOT)
          INTO cDOCUME
          FROM TT_COM
         WHERE CODFIL = pFILICO
           AND SEQUEN = pSEQICO;
     END IF;

     SELECT NOMPRO INTO cNOMPRO
       FROM TV_IPR
      WHERE FILMAT = pFILMAT
        AND CODMAT = pCODMAT
        AND CODCOR = pCODCOR
        AND CODTAM = pCODTAM;
     IF (ISNOTNULL(cEMAIL)='T') AND (ISNOTNULL(cMAI_FR)='T') AND (INSTR(cMAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(cEMAIL, UPPER('@sua_empresa.com')) = 0) THEN 
        INSERT INTO TT_MAI (DATSOL,EXCLUI,MAI_TO,MAI_FR,ASSUNT,TEXTOS,CODFIL,TIPMSG) VALUES
          (Agora(),'T',cEMAIL,cMAI_FR,'Item Cancelado',
          'Este  um aviso do sistema para alertar a seguinte situao:'||chr(13)||chr(10)||
          'O item com produto abaixo foi cancelado, porm j foi emitida a nota de transferncia para o mesmo.'||chr(13)||chr(10)||
          cDOCUME||chr(13)||chr(10)||
          'Produto: '||cNOMPRO,pCODFIL,'T');
     END IF;
  END IF;

  cResultado := 'OK';
  RETURN cResultado;

END;
$$ language 'plpgsql';




-- Autor: Luciano Chiqueti
-- Cliente: GIMBA
/*-- SEQ 0176 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ExisteCampanha (TT_IVEXCPR.filive%TYPE,TT_IVEXCPR.seqive%TYPE) CASCADE;

/*-- SEQ 0177 --*/
CREATE OR REPLACE FUNCTION ExisteCampanha (TT_IVEXCPR.filive%TYPE,TT_IVEXCPR.seqive%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCodFil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
 
-- Objetivos:
-- 1. Funo criada para atender ao relatrio de Vendas com Campanhas promocionais
 
-- Declarao de variveis e cursores
   cTeste                        INTEGER;
   cResultado                    VARCHAR(1);
 
-- Incio da funo
BEGIN   
  SELECT COUNT(*)
    INTO cTeste
    FROM TT_IVEXCPR
   WHERE FILIVE = pCodFil
     and SEQIVE = pSequen;
         
   if cTeste > 0 then
     cResultado := 'T';
   else
     cResultado := 'F';
   end if;
   RETURN cResultado;
 
END;
$$ language 'plpgsql';




/*-- SEQ 0178 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ExisteFilialNaUF (TD_FIL.UFLOJA%TYPE) CASCADE;

/*-- SEQ 0179 --*/
CREATE OR REPLACE FUNCTION ExisteFilialNaUF (TD_FIL.UFLOJA%TYPE)
RETURNS BOOLEAN AS $$
DECLARE
pUF ALIAS FOR $1 ;

-- Objetivos:
-- 1. Verificar se existe Filial na UF informada

-- Declarao de variveis e cursores
   cResultado                    INTEGER;

-- Incio da funo
BEGIN

      SELECT COUNT(*)
        INTO cResultado
        FROM TD_FIL
       WHERE UFLOJA = UPPER(pUF);

   RETURN cResultado > 0;

END;
$$ language 'plpgsql';




-- --------------------------------------------------------
-- Objetivos:
-- Consultor..: Luciano
-- Cliente....: Gimba
-- Finalidade.: Verifica se o cleinte esta incluso no troco solidario;
-- Ticket.....: 2023036223 
--  Nota: utilize as funo Split_Part_Number() para utilizar o resultado
--        desta funo de maneira mais fcil.
--        http://intra.totall.com.br:8080/wiki/index.php/Split_part
--
-- 1 - Retorna se ativo.
/*-- SEQ 0180 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION FilialClienteTrocoSolidario (TT_CCC.FILCLI%TYPE,TT_CCC.CODCLI%TYPE,TT_CCC.CODFIL%TYPE) CASCADE;

/*-- SEQ 0181 --*/
CREATE OR REPLACE FUNCTION FilialClienteTrocoSolidario (TT_CCC.FILCLI%TYPE,TT_CCC.CODCLI%TYPE,TT_CCC.CODFIL%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILCLI ALIAS FOR $1 ;
pCODCLI ALIAS FOR $2 ;
pCODFIL ALIAS FOR $3 ;
 
-- Declarao de variveis e cursores
   --pFILCLI ALIAS FOR $1 ;
   --pCODCLI ALIAS FOR $2 ;
   --pCODFIL ALIAS FOR $3 ;
   
   rFLAG   VARCHAR(1);
   
-- Incio da funo

BEGIN

SELECT CAST(case when (DFIL.FILCLIDOA||DFIL.CODCLIDOA) IS NULL 
            THEN 'F' 
            ELSE 'T' 
       END AS VARCHAR(1) )
       INTO rFLAG 
  FROM TD_FIL DFIL
 WHERE DFIL.FILCLIDOA = pFILCLI 
   AND DFIL.CODCLIDOA = pCODCLI
   AND DFIL.CODFIL    = pCODFIL;
 
 RETURN rFLAG;
 
END;
$$ language 'plpgsql';




/*-- SEQ 0182 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ADD_DAY (Timestamp,double precision) CASCADE;

/*-- SEQ 0183 --*/
CREATE OR REPLACE FUNCTION ADD_DAY (Timestamp,double precision)
RETURNS Timestamp AS $$
DECLARE
pData ALIAS FOR $1 ;
pDias ALIAS FOR $2 ;
nDias Integer;
nSeg Numeric;
BEGIN    
   nDias:=trunc(pDias);
   nSeg:=trunc((pdias-trunc(pDias))*86400);
   RETURN ((trunc(pData)+nDias)::Timestamp+to_char(pData, 'hh24:mi:ss')::time)+(nSeg * interval '1 second');
END;
$$ language 'plpgsql' STABLE;




/*-- SEQ 0184 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ADD_SECOND (Timestamp,double precision) CASCADE;

/*-- SEQ 0185 --*/
CREATE OR REPLACE FUNCTION ADD_SECOND (Timestamp,double precision)
RETURNS Timestamp AS $$
DECLARE
pData ALIAS FOR $1 ;
pSeg ALIAS FOR $2 ;
BEGIN      
   RETURN ((trunc(pData))::Timestamp+to_char(pData, 'hh24:mi:ss')::time)+(pSeg * interval '1 second');
END;
$$ language 'plpgsql' STABLE;




/*-- SEQ 0186 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Agenda (TT_AGE.CODFIL%TYPE,TT_AGE.SEQUEN%TYPE,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 0187 --*/
CREATE OR REPLACE FUNCTION Agenda (TT_AGE.CODFIL%TYPE,TT_AGE.SEQUEN%TYPE,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pMes ALIAS FOR $3 ;
pAno ALIAS FOR $4 ;
-- Objetivo:
-- 1) Criar ums String com os dias que tem eventos na agenda
  RESULTADO VARCHAR(31);
  cDIA VARCHAR(2);
  ULTDIA INTEGER;
  DIA    INTEGER;
  vDATINI Timestamp;
  vDATFIM Timestamp;
  DataAgenda CURSOR FOR
    select DATINI,DATFIM
      from tt_iag
     where (datini <= LAST_DAY(TO_DATE('01'||pMes||pAno,'ddmmyyyy'))
            and datfim >= to_date('01'||pMes||pAno,'ddmmyyyy'))
       and CODFIL=pCODFIL
       and SEQUEN=pSEQUEN;
BEGIN
  ULTDIA:=TO_CHAR(LAST_DAY(TO_DATE('01'||pMes||pAno,'ddmmyyyy')),'dd');
  RESULTADO:=LPAD('0',ULTDIA,'0');  
  OPEN DataAgenda;
  LOOP
    FETCH DataAgenda INTO vDATINI,vDATFIM;
    EXIT WHEN NOT FOUND;
    FOR DIA IN 1..ULTDIA LOOP
       cDIA:=lpad(DIA,2,'0');
       IF TO_DATE(cDIA||pMes||pAno,'ddmmyyyy') BETWEEN trunc(vDATINI) AND trunc(vDATFIM) THEN
          RESULTADO:=SUBSTR(RESULTADO,0,DIA-1)||'1'||SUBSTR(RESULTADO,DIA+1);
       END IF;
    END LOOP;
  END LOOP;
  CLOSE DataAgenda;

  RETURN RESULTADO;

END;
$$ language 'plpgsql';





/*-- SEQ 0188 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AuxAlocaTarefa (TT_WOR.CODFIL%TYPE,TT_WOR.SEQUEN%TYPE,Numeric,TT_WOR.FILRES%TYPE,TT_WOR.CODRES%TYPE,TT_PRJ.INIPRJ%TYPE) CASCADE;

/*-- SEQ 0189 --*/
CREATE OR REPLACE FUNCTION AuxAlocaTarefa (TT_WOR.CODFIL%TYPE,TT_WOR.SEQUEN%TYPE,Numeric,TT_WOR.FILRES%TYPE,TT_WOR.CODRES%TYPE,TT_PRJ.INIPRJ%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILWOR ALIAS FOR $1 ;
pSEQWOR ALIAS FOR $2 ;
pTARFAL ALIAS FOR $3 ;
pFILRES ALIAS FOR $4 ;
pCODRES ALIAS FOR $5 ;
dDATDEP ALIAS FOR $6 ;

  i INTEGER;  
  nHorasAVer Numeric;
  dDATREF TW_CROXDAT.DATREF%TYPE;
  nMINLIV TW_CROXDAT.MINLIV%TYPE;
  dDATINI Timestamp;
  dDATFIM Timestamp;
  nCount integer;
  cAux VARCHAR(10); 
         
         
  -- Tempo a ser alocado para tarefa
  cr_Aloca_Tempo CURSOR(pFilusu TT_USU.FILUSU%TYPE,
           pCodusu TT_USU.CODUSU%TYPE) IS
    select datref, minliv
      from tw_croxdat
     where userid=userenv('SESSIONID')
       and filusu=pFilusu
       and codusu=pCodusu
       and datref = ( select min(datref)
                        from tw_croxdat
                       where userid=userenv('SESSIONID')
                         and filusu=pFilusu
                         and codusu=pCodusu
                         and minliv>0
                         and datref>=coalesce(dDATDEP,to_date('01/01/1900','dd/mm/yyyy'))
                     );
         
BEGIN
  nHorasAVer:=pTarfal;
  
  dDATINI:=NULL;
  dDATFIM:=NULL;    
  LOOP
     OPEN CR_ALOCA_TEMPO(pFILRES,pCODRES);
     FETCH CR_ALOCA_TEMPO INTO dDATREF,nMINLIV;
     EXIT WHEN NOT FOUND;        
     
     IF dDATINI IS NULL THEN 
        dDATINI:=dDATREF;
     END IF;
     dDATFIM:=dDATREF;
     
     UPDATE TW_CROXDAT 
        SET MINLIV=CASE WHEN MINLIV-nHorasAVer <0 THEN 0 
                                               ELSE MINLIV-nHorasAVer
                   END
       WHERE userid=userenv('SESSIONID')
         AND filusu=pFILRES
         AND codusu=pCODRES
         and datref=dDATREF;
         
     nHorasAVer:=nHorasAVer-nMINLIV;
     
     EXIT WHEN nHorasAVer<=0;
     CLOSE CR_ALOCA_TEMPO;
  END LOOP;
  CLOSE CR_ALOCA_TEMPO;     
  
       UPDATE TT_WOR 
     SET INIPRT = dDATINI, 
         FIMPRT = dDATFIM
   WHERE CODFIL = pFILWOR
     AND SEQUEN = pSEQWOR;  
     
       UPDATE TW_CROXWOR 
     SET PROCES = 'T'
   WHERE CODFIL = pFILWOR
     AND SEQUEN = pSEQWOR
     AND userid=userenv('SESSIONID'); 
       
  RETURN 'OK';

END;
$$ language 'plpgsql';





/*-- SEQ 0190 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Conecta (INTEGER, VARCHAR) CASCADE;

/*-- SEQ 0191 --*/
/*-- IGNORE ERRO --*/
CREATE OR REPLACE FUNCTION
  Conecta( INTEGER, VARCHAR )
RETURNS
  INTEGER
AS
  'TTSegurPG.dll', 'PGConecta'
LANGUAGE
  C
STRICT;

/*-- SEQ 0192 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AssinaTab( VARCHAR, VARCHAR, INTEGER, 
             VARCHAR, VARCHAR, INTEGER,
             VARCHAR ) CASCADE;

/*-- SEQ 0193 --*/
/*-- IGNORE ERRO --*/
CREATE OR REPLACE FUNCTION
  AssinaTab( VARCHAR, VARCHAR, INTEGER, 
             VARCHAR, VARCHAR, INTEGER,
             VARCHAR )
RETURNS
  VARCHAR
AS
  'TTSegurPG.dll', 'PGAssinaTab'
LANGUAGE
  C
STRICT;

/*-- SEQ 0194 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AssinaTabSessao( VARCHAR, VARCHAR, VARCHAR, 
                   VARCHAR, VARCHAR, VARCHAR ) CASCADE;

/*-- SEQ 0195 --*/
/*-- IGNORE ERRO --*/
CREATE OR REPLACE FUNCTION
  AssinaTabSessao( VARCHAR, VARCHAR, VARCHAR, 
                   VARCHAR, VARCHAR, VARCHAR )
RETURNS
  VARCHAR
AS
  'TTSegurPG.dll', 'PGAssinaTabSessao'
LANGUAGE
  C
STRICT;

/*-- SEQ 0196 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Conecta (INTEGER,VARCHAR) CASCADE;

/*-- SEQ 0197 --*/
CREATE OR REPLACE FUNCTION Conecta (INTEGER,VARCHAR)
RETURNS INTEGER AS $$
DECLARE
pCodemp ALIAS FOR $1 ;
pPathTTSegur ALIAS FOR $2 ;
BEGIN
RETURN 1;
END;
$$ language 'plpgsql';



/*-- SEQ 0198 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConectaUID () CASCADE;

/*-- SEQ 0199 --*/
CREATE OR REPLACE FUNCTION ConectaUID ()
RETURNS INTEGER AS $$
DECLARE

BEGIN
RETURN ProximoCodigo('TT_UID','');
END;
$$ language 'plpgsql';




/*-- SEQ 0200 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AssinaTab (VARCHAR,VARCHAR,INTEGER,VARCHAR,VARCHAR,INTEGER,VARCHAR) CASCADE;

/*-- SEQ 0201 --*/
CREATE OR REPLACE FUNCTION AssinaTab (VARCHAR,VARCHAR,INTEGER,VARCHAR,VARCHAR,INTEGER,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pTabela ALIAS FOR $1 ;
pTexto ALIAS FOR $2 ;
pID ALIAS FOR $3 ;
pHashConexao ALIAS FOR $4 ;
pPathChvPrv ALIAS FOR $5 ;
pCodemp ALIAS FOR $6 ;
pCaminhoTTSegur ALIAS FOR $7 ;
BEGIN                                 
RETURN MD5(pTabela||pTexto||pCodemp||SenIntPlsql());
END;
$$ language 'plpgsql';



/*-- SEQ 0202 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AssinaTabSessao (VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 0203 --*/
CREATE OR REPLACE FUNCTION AssinaTabSessao (VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pTabela ALIAS FOR $1 ;
pUID_Texto ALIAS FOR $2 ;
pUID_Assina ALIAS FOR $3 ;
pTexto ALIAS FOR $4 ;
pPathChvPrv ALIAS FOR $5 ;
pPathTTSegur ALIAS FOR $6 ;
BEGIN                                    
RETURN MD5(pTabela||pUID_Texto||pTexto||SenIntPlsql());
END;
$$ language 'plpgsql';




/*-- SEQ 0204 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AtrasoEmAberto (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE) CASCADE;

/*-- SEQ 0205 --*/
CREATE OR REPLACE FUNCTION AtrasoEmAberto (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE)
RETURNS Numeric AS $$
DECLARE
pFilial ALIAS FOR $1 ;
pCodigo ALIAS FOR $2 ;

   vRESULT Numeric(8);

BEGIN
SELECT SUM(COALESCE(INTERVALODIAS(TRUNC(AGORA()),R.DATVEN),0)) INTO vRESULT
   FROM TT_VEN V INNER JOIN TT_REC R ON V.CODFIL=R.CODFIL 
                                    AND V.SEQUEN=R.SEQUEN  
  WHERE V.FILCLI=pFilial 
    AND V.CODCLI=pCodigo 
    AND R.CARTAO IS NULL 
    AND V.FLGEST='A'
    AND R.SEQCHE IS NULL 
    AND R.DATVEN<AGORA();
   

RETURN vRESULT;
  
END;
$$ language 'plpgsql';




/*-- SEQ 0206 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Atualiza_CTA_FIN (INTEGER) CASCADE;

/*-- SEQ 0207 --*/
CREATE OR REPLACE FUNCTION Atualiza_CTA_FIN (INTEGER)
RETURNS VARCHAR AS $$
DECLARE
pSinal ALIAS FOR $1 ;
BEGIN

    DELETE FROM TW_FIN;
    
    INSERT INTO TW_FIN 
         (FILCTA,SEQCTA,TIPCTA,FLGFLX,FILLAN,DATLAN,VLRLAN)
    (SELECT RFIN.FILCTA, 
            RFIN.SEQCTA, 
            RFIN.TIPCTA,
            RFIN.FLGFLX, 
            RFIN.FILORI AS FILLAN, 
            RFIN.DATLAN,
            RFIN.VLRLAN
       FROM TL_FIN LFIN INNER JOIN TR_FIN RFIN ON RFIN.ORIGEM=LFIN.ORIGEM 
                                              AND RFIN.CODFIL=LFIN.FILORI 
                                              AND RFIN.SEQUEN=LFIN.SEQORI
                                              AND RFIN.NUMPAR=LFIN.PARORI
                                              AND LFIN.FLGEST='P'
                        LEFT JOIN TT_CTAXFIL CXF ON RFIN.FILORI=CXF.CODFIL AND RFIN.FILCTA=CXF.FILCTA AND RFIN.SEQCTA=CXF.SEQCTA
     WHERE (CXF.DATA_INICIAL IS NULL OR RFIN.DATLAN>CXF.DATA_INICIAL)
    );        
    
    INSERT INTO TW_FIN 
    (FILCTA,SEQCTA,TIPCTA,FLGFLX,FILLAN,DATLAN,VLRLAN)
    (SELECT RFIN.FILCRT AS FILCTA, 
            RFIN.SEQCRT AS SEQCTA, 
            RFIN.TIPCRT AS TIPCTA,
            RFIN.FLGFLX, 
            RFIN.FILDES AS FILLAN, 
            RFIN.DATLAN,
            RFIN.VLRLAN * CASE WHEN RFIN.TIPCTA||RFIN.TIPCRT='NN' THEN -1 ELSE 1 END as VLRLAN
       FROM TL_FIN LFIN INNER JOIN TR_FIN RFIN ON RFIN.ORIGEM=LFIN.ORIGEM 
                                              AND RFIN.CODFIL=LFIN.FILORI 
                                              AND RFIN.SEQUEN=LFIN.SEQORI
                                              AND RFIN.NUMPAR=LFIN.PARORI
                                              AND LFIN.FLGEST='P'
                        LEFT JOIN TT_CTAXFIL CXF ON RFIN.FILDES=CXF.CODFIL AND RFIN.FILCRT=CXF.FILCTA AND RFIN.SEQCRT=CXF.SEQCTA
     WHERE (CXF.DATA_INICIAL IS NULL OR RFIN.DATLAN>CXF.DATA_INICIAL)
    );
    
    INSERT INTO TR_CTA 
    (FLGFLX,FILCTA,SEQCTA,TIPCTA,DATLAN,TOTCRE,TOTDEB,VSALDO,FILLAN)
    (SELECT DISTINCT 
            WFIN.FLGFLX,WFIN.FILCTA,WFIN.SEQCTA,WFIN.TIPCTA,WFIN.DATLAN,
            0.00 AS TOTCRE, 0.00 AS TOTDEB, 0.00 AS VSALDO,
            WFIN.FILLAN
      FROM TW_FIN WFIN LEFT JOIN TR_CTA RCTA ON WFIN.FILCTA=RCTA.FILCTA
                                            AND WFIN.SEQCTA=RCTA.SEQCTA
                                            AND WFIN.TIPCTA=RCTA.TIPCTA  
                                            AND WFIN.FLGFLX=RCTA.FLGFLX
                                            AND WFIN.FILLAN=RCTA.FILLAN 
                                            AND WFIN.DATLAN=RCTA.DATLAN         
    WHERE RCTA.FILCTA IS NULL
    );
    
    UPDATE TR_CTA
    SET TOTCRE=COALESCE(TR_CTA.TOTCRE,0)+(COALESCE((
           SELECT SUM(CASE WHEN WFIN.VLRLAN > 0 THEN abs(WFIN.VLRLAN)  ELSE 0 END) AS TOTCRE
             FROM TW_FIN WFIN 
            WHERE WFIN.FILCTA=TR_CTA.FILCTA
              AND WFIN.SEQCTA=TR_CTA.SEQCTA
              AND WFIN.TIPCTA=TR_CTA.TIPCTA  
              AND WFIN.FLGFLX=TR_CTA.FLGFLX
              AND WFIN.FILLAN=TR_CTA.FILLAN 
              AND WFIN.DATLAN=TR_CTA.DATLAN          
            ),0)*pSinal),
    TOTDEB=COALESCE(TR_CTA.TOTDEB,0)+(COALESCE((
           SELECT SUM(CASE WHEN WFIN.VLRLAN < 0 THEN abs(WFIN.VLRLAN)  ELSE 0 END) AS TOTDEB
             from TW_FIN WFIN 
            WHERE WFIN.FILCTA=TR_CTA.FILCTA
              AND WFIN.SEQCTA=TR_CTA.SEQCTA
              AND WFIN.TIPCTA=TR_CTA.TIPCTA  
              AND WFIN.FLGFLX=TR_CTA.FLGFLX
              AND WFIN.FILLAN=TR_CTA.FILLAN 
              AND WFIN.DATLAN=TR_CTA.DATLAN          
            ),0)*pSinal)
    WHERE (TR_CTA.FILCTA,TR_CTA.SEQCTA,TR_CTA.TIPCTA,TR_CTA.FLGFLX,TR_CTA.FILLAN,TR_CTA.DATLAN) IN 
          (SELECT WFIN.FILCTA,WFIN.SEQCTA,WFIN.TIPCTA,WFIN.FLGFLX,WFIN.FILLAN,WFIN.DATLAN
             FROM TW_FIN WFIN
          );               

    UPDATE TT_CTA
             SET ATUREA = CASE FIN.FLGFLX_R WHEN 'T' THEN 'F' ELSE TT_CTA.ATUREA END,
                 ATUARE = CASE FIN.FLGFLX_A WHEN 'T' THEN 'F' ELSE TT_CTA.ATUARE END,
                 DATREA = TRUNC( LEAST( COALESCE(TT_CTA.DATREA, AGORA()), COALESCE(DATLAN_R,TT_CTA.DATREA))),
                 DATARE = TRUNC( LEAST( COALESCE(TT_CTA.DATARE, AGORA()), COALESCE(DATLAN_A,TT_CTA.DATARE)))
      FROM (SELECT WFIN.FILCTA, WFIN.SEQCTA, WFIN.TIPCTA, 
                   MIN(CASE WFIN.FLGFLX WHEN 'A' THEN 'T' END) AS FLGFLX_A, 
                   MIN(CASE WFIN.FLGFLX WHEN 'R' THEN 'T' END) AS FLGFLX_R,
                   MIN(CASE WFIN.FLGFLX WHEN 'A' THEN WFIN.DATLAN END) AS DATLAN_A, 
                   MIN(CASE WFIN.FLGFLX WHEN 'R' THEN WFIN.DATLAN END) AS DATLAN_R
              FROM TW_FIN WFIN
             GROUP BY WFIN.FILCTA, WFIN.SEQCTA, WFIN.TIPCTA
           ) FIN
      WHERE TT_CTA.CODFIL = FIN.FILCTA
        AND TT_CTA.SEQUEN = FIN.SEQCTA
        AND TT_CTA.TIPCTA = FIN.TIPCTA;
             
    DELETE FROM TW_FIN;
        
   RETURN 'OK';

END;
$$ language 'plpgsql';




/*-- SEQ 0208 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Atualiza_TD_IND (TD_IND.CODTAB%TYPE) CASCADE;

/*-- SEQ 0209 --*/
CREATE OR REPLACE FUNCTION Atualiza_TD_IND (TD_IND.CODTAB%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_codtab ALIAS FOR $1 ;
BEGIN
  INSERT INTO TD_IND (CODTAB, ATU_EM) 
    (SELECT COD.CODTAB, AGORA() AS ATU_EM
       FROM (SELECT p_codtab AS CODTAB FROM DUAL) COD LEFT JOIN TD_IND IND ON IND.CODTAB = COD.CODTAB
      WHERE IND.CODTAB IS NULL);
  UPDATE TD_IND SET ATU_EM = AGORA();
  RETURN NULL; 

END;
$$ language 'plpgsql';




/*-- SEQ 0210 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ATUALIZAREGIAO () CASCADE;

/*-- SEQ 0211 --*/
CREATE OR REPLACE FUNCTION ATUALIZAREGIAO ()
RETURNS VARCHAR AS $$
DECLARE

-- Objetivos:
-- 1. Atualizar região do endereço pela faixa de CEP

-- Declaração de variáveis e cursores
   cMANUT                        TT_IDF.MANUT%TYPE;
   cComplemento                  CONSTANT VARCHAR(254) := Constante('Complemento');

   -- Início da função
BEGIN
   SELECT MANUT INTO cMANUT
     FROM TT_IDF;

   IF cMANUT = 'T' THEN
      RAISE EXCEPTION 'PG-20000 Base em manutenção. %' , cComplemento;
   END IF;
   
   BEGIN
      UPDATE TT_END SET REGIAO = (SELECT REG.CODTAB 
                                    FROM TD_REG REG 
                                   WHERE TT_END.CODCEP BETWEEN REG.CEPINI AND REG.CEPFIM);
   EXCEPTION
      WHEN CARDINALITY_VIOLATION THEN RAISE EXCEPTION 'PG-20001 Erro ao atualizar região dos endereços faixa de CEP duplicada. %' , cComplemento;
      WHEN OTHERS THEN RAISE EXCEPTION 'PG-20002 %. %' , SQLERRM,cComplemento;
   END;
   RETURN NULL;
END;
$$ language 'plpgsql';




/*-- SEQ 0212 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AtualizaSaldoContas () CASCADE;

/*-- SEQ 0213 --*/
CREATE OR REPLACE FUNCTION AtualizaSaldoContas ()
RETURNS VARCHAR AS $$
DECLARE

  vSalAnt    Numeric;

  -- Cursor de conta a atualizar os saldo
  Saldos CURSOR FOR
  SELECT I2.*,
         (SELECT RCTA.VSALDO
          FROM TR_CTA RCTA
          WHERE RCTA.FLGFLX = I2.FLGFLX
            AND RCTA.FILCTA = I2.FILCTA
            AND RCTA.SEQCTA = I2.SEQCTA
            AND RCTA.TIPCTA = I2.TIPCTA
            AND RCTA.DATLAN = I2.DATANT               
            AND RCTA.FILLAN = I2.CODFIL) AS SALANT
  FROM (SELECT I1.*, 
              (SELECT MAX(RCTA.DATLAN)
               FROM TR_CTA RCTA
               WHERE RCTA.FLGFLX = I1.FLGFLX
                 AND RCTA.FILCTA = I1.FILCTA
                 AND RCTA.SEQCTA = I1.SEQCTA
                 AND RCTA.TIPCTA = I1.TIPCTA
                 AND RCTA.FILLAN = I1.CODFIL
                 AND RCTA.DATLAN < I1.DATLAN
               GROUP BY RCTA.FLGFLX, RCTA.FILCTA, RCTA.SEQCTA, RCTA.TIPCTA, RCTA.FILLAN) AS DATANT
        FROM (SELECT 'R' AS FLGFLX, 
                     R.CODFIL AS FILCTA, 
                     R.SEQUEN AS SEQCTA, 
                     R.TIPCTA, TRUNC(R.DATREA) AS DATLAN,
                     FIL.CODFIL
              FROM TT_CTA R CROSS JOIN TD_FIL FIL
              WHERE R.ATUREA = 'F'
                AND R.TIPCTA='N'
              UNION ALL
              SELECT 'A' AS FLGFLX, 
                     A.CODFIL AS FILCTA, 
                     A.SEQUEN AS SEQCTA, 
                     A.TIPCTA, TRUNC(A.DATARE) AS DATLAN,
                     FIL.CODFIL
              FROM TT_CTA A CROSS JOIN TD_FIL FIL
              WHERE A.ATUARE = 'F'
                AND A.TIPCTA='N') I1) I2;

  -- Cursor de lanamentos para atualizar os saldos
  Totais CURSOR(pFLGFLX TR_CTA.FLGFLX%TYPE,
           pFILCTA TR_CTA.FILCTA%TYPE,
           pSEQCTA TR_CTA.SEQCTA%TYPE,
           pTIPCTA TR_CTA.TIPCTA%TYPE,
           pDATLAN TR_CTA.DATLAN%TYPE,
           pFILLAN TR_CTA.FILLAN%TYPE) IS
  SELECT RCTA.*
  FROM TR_CTA RCTA
  WHERE RCTA.FLGFLX =  pFLGFLX
    AND RCTA.FILCTA =  pFILCTA
    AND RCTA.SEQCTA =  pSEQCTA
    AND RCTA.TIPCTA =  pTIPCTA
    AND RCTA.FILLAN =  pFILLAN
    AND RCTA.DATLAN >= coalesce(pDATLAN,to_date('01/01/1900','dd/mm/yyyy'))
  ORDER BY RCTA.DATLAN;
    
  tot TR_CTA%ROWTYPE;
  cFLGFLX TR_FIN.FLGFLX%TYPE;
  cFILCTA TR_FIN.FILCTA%TYPE;
  cSEQCTA TR_FIN.SEQCTA%TYPE;
  cTIPCTA TR_FIN.TIPCTA%TYPE;
  cFILLAN TR_FIN.FILORI%TYPE;
  dDATLAN Timestamp;
  dDATANT Timestamp;
  nSALANT TR_FIN.VLRLAN%TYPE;
  -- vFILIAL TD_FIL.CODFIL%TYPE;
BEGIN
   OPEN Saldos;
   LOOP
     FETCH Saldos into cFLGFLX, cFILCTA, cSEQCTA, cTIPCTA, dDATLAN, cFILLAN, dDATANT, nSALANT;
     EXIT WHEN NOT FOUND;

     vSalAnt := COALESCE(nSALANT,0);
     OPEN Totais(cFLGFLX, cFILCTA, cSEQCTA, cTIPCTA, dDATLAN, cFILLAN);
     LOOP

       FETCH Totais into tot;
       EXIT WHEN NOT FOUND;
       vSalAnt := vSalAnt + COALESCE(tot.TOTCRE,0) - COALESCE(tot.TOTDEB,0);

       UPDATE TR_CTA
       SET VSALDO = vSalAnt
       WHERE FLGFLX = tot.FLGFLX
         AND FILCTA = tot.FILCTA
         AND SEQCTA = tot.SEQCTA
         AND TIPCTA = tot.TIPCTA
         AND DATLAN = tot.DATLAN
         AND FILLAN = tot.FILLAN;

     END LOOP;
     CLOSE Totais; 
     
     -- SELECT CODLOJ
     --   INTO vFILIAL
     --   FROM TT_IDF;
        
     UPDATE TT_CTA
     SET SALREA = (SELECT SUM(VSALDO)
                     FROM TR_CTA RCTA
                    WHERE RCTA.FLGFLX = 'R'
                      AND RCTA.FILCTA = cFILCTA
                      AND RCTA.SEQCTA = cSEQCTA
                      AND RCTA.TIPCTA = cTIPCTA
                      AND (RCTA.FILLAN,RCTA.DATLAN) in 
                                        (SELECT IRCTA.FILLAN, MAX(DATLAN)
                                           FROM TR_CTA IRCTA
                                          WHERE IRCTA.FLGFLX = 'R'
                                            AND IRCTA.FILCTA = cFILCTA
                                            AND IRCTA.SEQCTA = cSEQCTA
                                            AND IRCTA.TIPCTA = cTIPCTA
                                          GROUP BY IRCTA.FILLAN
                                         )),
        SALARE = (SELECT SUM(VSALDO)
                     FROM TR_CTA RCTA
                    WHERE RCTA.FLGFLX = 'A'
                      AND RCTA.FILCTA = cFILCTA
                      AND RCTA.SEQCTA = cSEQCTA
                      AND RCTA.TIPCTA = cTIPCTA
                      AND (RCTA.FILLAN,RCTA.DATLAN) in 
                                        (SELECT IRCTA.FILLAN, MAX(DATLAN)
                                           FROM TR_CTA IRCTA
                                          WHERE IRCTA.FLGFLX = 'A'
                                            AND IRCTA.FILCTA = cFILCTA
                                            AND IRCTA.SEQCTA = cSEQCTA
                                            AND IRCTA.TIPCTA = cTIPCTA
                                          GROUP BY IRCTA.FILLAN
                                         )),
        ATUREA = 'T',
        ATUARE = 'T',
        DATREA = (SELECT MAX(DATLAN)
                    FROM TR_CTA IRCTA
                   WHERE IRCTA.FLGFLX = 'R'
                     AND IRCTA.FILCTA = cFILCTA
                     AND IRCTA.SEQCTA = cSEQCTA
                     AND IRCTA.TIPCTA = cTIPCTA
                  ),
        DATARE = (SELECT MAX(DATLAN)
                    FROM TR_CTA IRCTA
                   WHERE IRCTA.FLGFLX = 'A'
                     AND IRCTA.FILCTA = cFILCTA
                     AND IRCTA.SEQCTA = cSEQCTA
                     AND IRCTA.TIPCTA = cTIPCTA
                  )
     WHERE CODFIL = cFILCTA
       AND SEQUEN = cSEQCTA
       AND TIPCTA = cTIPCTA;
   END LOOP;
   CLOSE Saldos;
   
   RETURN 'OK';
END;
$$ language 'plpgsql';




/*-- SEQ 0214 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ATUALIZA_CCC_TIPLAN () CASCADE;

/*-- SEQ 0215 --*/
CREATE OR REPLACE FUNCTION ATUALIZA_CCC_TIPLAN ()
RETURNS VARCHAR AS $$
DECLARE

BEGIN

    update tt_ccc set tiplan = 'C'
    where tiplan is null
       and status <> 'F'
       and comple like 'Pgto ref ao debito:%' 
       and coalesce(numecf,'000')<>'000';
     
    update tt_ccc set tiplan = 'S'
    where tiplan is null
       and status <> 'F'
       and comple like 'Desconto ref ao debito:%'  
       and coalesce(numecf,'000')<>'000';
     
    update tt_ccc set tiplan = 'I'
    where tiplan is null
       and status <> 'F'
       and numdoc = 'RETIRADA'
       and seqven is null 
       and coalesce(numecf,'000')<>'000';
     
    update tt_ccc set tiplan = 'D'
    where tiplan is null
       and status <> 'F'
       and numdoc = 'DEPOSITO' 
       and VLRLAN > 0 
       and seqven is null 
       and coalesce(numecf,'000')<>'000';
     
    update tt_ccc set tiplan = 'M'
    where tiplan is null
       and status <> 'F'
       and numdoc = 'DEPOSITO'
       and VLRLAN < 0 
       and seqven is null 
       and coalesce(numecf,'000')<>'000';
     
    update tt_ccc set tiplan = 'E'
    where tiplan is null
       and status <> 'F'
       and comple like 'Estorno de parcela.%'  
       and coalesce(numecf,'000')<>'000';
    
    update tt_ccc set tiplan = 'V'
    where (codfil,sequen) in
    (select ccc.codfil, ccc.sequen
      from tt_ccc ccc inner join tt_ven ven on ven.codfil=ccc.codven and ven.sequen=ccc.seqven and ven.datfis=ccc.datfis
                      inner join tt_rec rec on rec.codfil=ven.codfil and rec.sequen=ven.sequen and rec.numpar=ccc.numpar and rec.subpar=ccc.subpar
                      inner join td_nat nat on nat.codtab = ven.codnat
     where ccc.tiplan is null
       and trunc(ven.dathor)=rec.datven
       and rec.tipccc is null
       and ccc.vlrlan < 0
       and ccc.numdoc = rpad(ven.codser,2,' ')||ven.numnot
       and nat.tipnat <> 'D')  
       and coalesce(numecf,'000')<>'000'
       and tiplan is null;
     
    -- Troco no confivel, deve-se verificar melhor.
    update tt_ccc set tiplan = 'T'
    where (codfil,sequen) in
    (select ccc.codfil, ccc.sequen
      from tt_ccc ccc inner join tt_ven ven on ven.codfil=ccc.codven and ven.sequen=ccc.seqven and ven.datfis=ccc.datfis
                      inner join tt_rec rec on rec.codfil=ven.codfil and rec.sequen=ven.sequen and rec.numpar=ccc.numpar and rec.subpar=ccc.subpar
                      inner join td_nat nat on nat.codtab = ven.codnat
     where ccc.tiplan is null
       and trunc(ven.dathor)=rec.datven
       and rec.tipccc is null
       and ccc.vlrlan > 0
       and ccc.numdoc = rpad(ven.codser,2,' ')||ven.numnot
       and coalesce(ccc.numecf,'000')<>'000'   
       and nat.tipnat <> 'D') 
       and coalesce(numecf,'000')<>'000'
       and tiplan is null;
     
    
    update tt_ccc set tiplan = 'L'
    where (codfil,sequen) in
    (select ccc.codfil, ccc.sequen
      from tt_ccc ccc inner join tt_ven ven on ven.codfil=ccc.codven and ven.sequen=ccc.seqven and ven.datfis=ccc.datfis
                      inner join tt_rec rec on rec.codfil=ven.codfil and rec.sequen=ven.sequen and rec.numpar=ccc.numpar and rec.subpar=ccc.subpar
                      inner join td_nat nat on nat.codtab = ven.codnat
     where trunc(ven.dathor)=rec.datven
       and rec.tipccc is null
       and ccc.numdoc = rpad(ven.codser,2,' ')||ven.numnot
       and nat.tipnat = 'D'
       and ccc.tiplan is null)  
    and coalesce(numecf,'000')<>'000'
    and tiplan is null;
     
    
    update tt_ccc set tiplan = 'R'
    where (codfil,sequen) in
    (select ccc.codfil, ccc.sequen
      from tt_ccc ccc inner join tt_ven ven on ven.codfil=ccc.codven and ven.sequen=ccc.seqven
                      inner join tt_rec rec on rec.codfil=ven.codfil and rec.sequen=ven.sequen and rec.numpar=ccc.numpar and rec.subpar=ccc.subpar
                      inner join td_nat nat on nat.codtab = ven.codnat
     where ccc.tiplan is null
       and rec.tipccc is null
       and trunc(ven.dathor)<>rec.datven
       and ccc.numdoc = rpad(ven.codser,2,' ')||ven.numnot)
    and coalesce(numecf,'000')<>'000'
    and tiplan is null;
    
    
    ------------------------------------------------------------------------------------
    ----------------------------------   Backoffice   ----------------------------------
    ------------------------------------------------------------------------------------
    
    
     
    -- Faturamento
    update tt_ccc set tiplan = 'G'
    where coalesce(numecf,'000')='000'
    and tiplan is null
    and status='F'
    and vlrlan >0
    ;
    
    -- Estorno Faturamento
    update tt_ccc set tiplan = 'Q'
    where coalesce(numecf,'000')='000'
    and tiplan is null
    and status='F'
    and vlrlan<0
    ;
    
    -- Estorno Conciliao
    update tt_ccc set tiplan = 'Z'
    where numecf is null
    and tiplan is null
    and comple='ESTORNO DE CONCILIACAO';
    
    
    -- Fatura referenta a OS
    update tt_ccc set tiplan = 'O'
    where numecf is null
    and tiplan is null
    and comple='Fatura referente a OS';
    
    -- Estorno de Venda
    update tt_ccc set tiplan = 'N'
    where numecf is null
    and tiplan is null
    and comple='ESTORNO REF. CANCELAMENTO VENDA';
    
    -- Comissao
    update tt_ccc set tiplan = 'J'
    where numecf is null
    and tiplan is null
    and numdoc='COMISSO'
    and comple like 'Comisso de %';
    
    -- Estorno de Venda
    update tt_ccc set tiplan = 'U'
    where numecf is null
    and tiplan is null
    and comple='ESTORNO REF. ESTORNO PARCELA';
    
    -- Carto Prprio 
    update tt_ccc set tiplan = 'P'
    where (codfil,sequen) in
    (select ccc.codfil, ccc.sequen
      from tt_ccc ccc inner join tt_ven ven on ven.codfil=ccc.codven and ven.sequen=ccc.seqven
                      inner join tt_rec rec on rec.codfil=ven.codfil and rec.sequen=ven.sequen and rec.numpar=ccc.numpar and rec.subpar=ccc.subpar                  
                      INNER JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT AND PLA.CODPGT = VEN.CODPGT
     where ccc.tiplan is null
       and rec.tipccc is not null
       AND PLA.USACPP = 'T'       
       and coalesce(ccc.numecf,'000')='000'   
       and rec.datinc<>ccc.datope
       and rec.flgest='P'
       and ccc.numdoc = ven.codser||ven.numnot)
    and coalesce(numecf,'000')='000'
    and tiplan is null;

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 0216 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Aux_CalculaDAC (VARCHAR) CASCADE;

/*-- SEQ 0217 --*/
CREATE OR REPLACE FUNCTION Aux_CalculaDAC (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
p_Campo ALIAS FOR $1 ;
-- Objetivos
-- Calcula os dgitos verificadores
  wk_DAC Char(1);
  wk_total Numeric(10);
  wk_resto Numeric(10);
  wk_mult Numeric (1);
  i Integer;

  WK_VALOR INTEGER;
  wk_calculo INTEGER;

begin
  Wk_TOTAL := 0;
  Wk_Mult := 2;

  i := Length(Trim(p_Campo));
  while i > 0 loop
    wk_Calculo := TO_NUMBER(SUBSTR(Trim(p_Campo),i,1)) * Wk_Mult;
    if wk_Calculo >= 10 then
      wk_Calculo := TO_NUMBER(SUBSTR(TO_CHAR(wk_calculo),1,1)) + TO_NUMBER(SUBSTR(TO_CHAR(wk_calculo),2,1));
    end if;
    i := i - 1;
    if wk_Mult = 2 then
      wk_Mult := 1;
    else
      wk_Mult := 2;
    end if;
    wk_total := wk_total + wk_calculo;
  End Loop;


  if wk_total >= 10 then
    wk_resto := mod(wk_total,10);
    if wk_resto = 0 then
      wk_DAC := '0';
    else
      wk_DAC := TO_CHAR(10 - wk_resto);
    end if;
  else
    if wk_total = 0 then
      wk_DAC := '0';
    else
      wk_DAC := TO_CHAR(10 - wk_total);
    end if;
  end if;

  Return wk_DAC;
END;
$$ language 'plpgsql';




/*-- SEQ 0218 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_INSERE_MEDICAO (TD_BIC.FILBIC%TYPE,TD_BIC.SEQFIL%TYPE,TD_BIC.CODTAB%TYPE,Timestamp) CASCADE;

/*-- SEQ 0219 --*/
CREATE OR REPLACE FUNCTION AUX_INSERE_MEDICAO (TD_BIC.FILBIC%TYPE,TD_BIC.SEQFIL%TYPE,TD_BIC.CODTAB%TYPE,Timestamp)
RETURNS Numeric AS $$
DECLARE
pFILBIC ALIAS FOR $1 ;
pSEQFIL ALIAS FOR $2 ;
pCODBIC ALIAS FOR $3 ;
PDATA ALIAS FOR $4 ;
   vMINIMO Numeric(20,4);
   vMAXIMO Numeric(20,4);
BEGIN

  select max(encerr) as maior INTO vMAXIMO
    from (select (to_number(numext)/1000) as encerr
            from tt_ive ive
           where ive.filbic = pFILBIC
             and ive.seqfil = pSEQFIL
             and ive.ven_dathor BETWEEN add_day(pDATA,-10) AND add_day(pDATA,1)
          union all
          select to_number(abm.encerr)/1000 as encerr
           from tt_abm abm
          where abm.codbic = pCODBIC
            and abm.codfil = pFILBIC
            and abm.datope BETWEEN add_day(pDATA,-10) AND add_day(pDATA,1)
         ) int;

  select min(encerr) as menor INTO vMINIMO
    from (select (to_number(numext)/1000) as encerr
            from tt_ive ive
           where ive.filbic = pFILBIC
             and ive.seqfil = pSEQFIL
             and ive.ven_dathor BETWEEN pDATA AND add_day(pDATA,1)
          union all
          select to_number(abm.encerr)/1000 as encerr
           from tt_abm abm
          where abm.codbic = pCODBIC
            and abm.codfil = pFILBIC
            and abm.datope BETWEEN pDATA AND add_day(pDATA,1)
         ) int;

   IF (vMAXIMO-coalesce(vMINIMO,vMAXIMO))<99999 THEN 
      RETURN vMAXIMO;
   ELSIF vMAXIMO IS NULL THEN
      RETURN NULL;
   ELSE
       select MAX(CASE WHEN ENCERR<(vMAXIMO/2) THEN ENCERR ELSE null END) AS MAX INTO vMAXIMO
         from (select (to_number(numext)/1000) as encerr
                 from tt_ive ive
                where ive.filbic = pFILBIC
                  and ive.seqfil = pSEQFIL
                  and ive.ven_dathor BETWEEN add_day(pDATA,-1) AND add_day(pDATA,1)
               union all
               select to_number(abm.encerr)/1000 as encerr
                 from tt_abm abm
               where abm.codbic = pCODBIC
                 and abm.codfil = pFILBIC
                 and abm.datope BETWEEN add_day(pDATA,-1) AND add_day(pDATA,1)
              ) int;
      RETURN vMAXIMO;
   END IF;

END;
$$ language 'plpgsql';




/*-- SEQ 0220 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_MaiorQueZero (Numeric,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 0221 --*/
CREATE OR REPLACE FUNCTION AUX_MaiorQueZero (Numeric,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
p_Valor ALIAS FOR $1 ;
p_Opcao1 ALIAS FOR $2 ;
p_Opcao2 ALIAS FOR $3 ;
BEGIN
  IF p_Valor > 0 THEN
    RETURN p_Opcao1;
  ELSE
    RETURN p_Opcao2;
  END IF;
END;
$$ language 'plpgsql';





/*-- SEQ 0222 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_Comprado (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 0223 --*/
CREATE OR REPLACE FUNCTION AUX_Comprado (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE)
RETURNS Numeric AS $$
DECLARE
DataIni ALIAS FOR $1 ;
DataFim ALIAS FOR $2 ;
Filial ALIAS FOR $3 ;
Codigo ALIAS FOR $4 ;
Cor ALIAS FOR $5 ;
Tamanho ALIAS FOR $6 ;
Local ALIAS FOR $7 ;
 -- Objetivos
 -- Obtm a quantidade comprada de um item num periodo
	SOMA Numeric;
TotalCompras CURSOR(DataIni Timestamp,
           DataFim Timestamp,
           Filial TT_GRA.FILMAT%TYPE,
           Codigo TT_GRA.CODMAT%TYPE,
           Cor TT_GRA.CODCOR%TYPE,
           Tamanho TT_GRA.CODTAM%TYPE) IS 
	SELECT (SUM(COALESCE(QTDCOM,0))) /* ABS(SUM(COALESCE(QTDCOM,0))) */
	  FROM TR_MOV
	 WHERE FILMAT = Filial
	   AND CODMAT = Codigo
	   AND CODCOR = Cor
	   AND CODTAM = Tamanho
	   AND DATMOV BETWEEN DataIni AND DataFim;

TotalComprasFilial CURSOR(DataIni Timestamp,
           DataFim Timestamp,
           Filial TT_GRA.FILMAT%TYPE,
           Codigo TT_GRA.CODMAT%TYPE,
           Cor TT_GRA.CODCOR%TYPE,
           Tamanho TT_GRA.CODTAM%TYPE,
           LOCAL TD_FIL.CODFIL%TYPE) IS 
	SELECT (SUM(COALESCE(QTDCOM,0))) /* ABS(SUM(COALESCE(QTDCOM,0))) */
	  FROM TR_MOV
	 WHERE FILMAT = Filial
	   AND CODMAT = Codigo
	   AND CODCOR = Cor
	   AND CODTAM = Tamanho
	   AND DATMOV BETWEEN DataIni AND DataFim
	   AND CODFIL = Local;
BEGIN
	IF ISNULL(Local)='T' THEN
		  OPEN TotalCompras(DataIni,DataFim,Filial,Codigo,Cor,Tamanho);
		 FETCH TotalCompras INTO Soma;
	     CLOSE TotalCompras;
        RETURN Soma;
	ELSE
		  OPEN TotalComprasFilial(DataIni,DataFim,Filial,Codigo,Cor,Tamanho,Local);
		 FETCH TotalComprasFilial INTO Soma;
		 CLOSE TotalComprasFilial;
		RETURN Soma;
	END IF;
END;
$$ language 'plpgsql';




/*-- SEQ 0224 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AuxCreditScore_Pontos_D (TT_CRE.COLUNA%TYPE,TT_CRE.CODIGO%TYPE) CASCADE;

/*-- SEQ 0225 --*/
CREATE OR REPLACE FUNCTION AuxCreditScore_Pontos_D (TT_CRE.COLUNA%TYPE,TT_CRE.CODIGO%TYPE)
RETURNS Numeric AS $$
DECLARE
pColuna ALIAS FOR $1 ;
pCodigo ALIAS FOR $2 ;

  vPONTOS Numeric(14,4):=0;

  Pontos_D CURSOR(pColuna TT_CRE.COLUNA%TYPE,
           pCodigo VARCHAR) IS
      select pontos 
        from tt_cre
       where COLUNA=pColuna
         and CODIGO=pCodigo
         and tipdad='D';
BEGIN

Open Pontos_D(pColuna,pCodigo);
Fetch Pontos_D into vPontos;    
Close Pontos_D;

return COALESCE(vPontos,0);         
         
END;
$$ language 'plpgsql';



/*-- SEQ 0226 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AuxCreditScore_Pontos_F (TT_CRE.COLUNA%TYPE,Numeric) CASCADE;

/*-- SEQ 0227 --*/
CREATE OR REPLACE FUNCTION AuxCreditScore_Pontos_F (TT_CRE.COLUNA%TYPE,Numeric)
RETURNS Numeric AS $$
DECLARE
pColuna ALIAS FOR $1 ;
pValor ALIAS FOR $2 ;

  vPONTOS Numeric(14,4):=0;

  Pontos_F CURSOR(pColuna TT_CRE.COLUNA%TYPE,
           pValor Numeric) IS
      select pontos 
        from tt_cre
       where COLUNA=pColuna
         and pValor>=coalesce(FAIINI,0) 
         and pValor<=coalesce(FAIFIM,999)
         and tipdad='F';
BEGIN

Open Pontos_F(pColuna,pValor);
Fetch Pontos_F into vPontos;    
Close Pontos_F;

return COALESCE(vPontos,0);         
         
END;
$$ language 'plpgsql';



/*-- SEQ 0228 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AuxCreditScore_Pontos_V (TT_CRE.COLUNA%TYPE) CASCADE;

/*-- SEQ 0229 --*/
CREATE OR REPLACE FUNCTION AuxCreditScore_Pontos_V (TT_CRE.COLUNA%TYPE)
RETURNS Numeric AS $$
DECLARE
pColuna ALIAS FOR $1 ;

  vPONTOS Numeric(14,4):=0;

  Pontos_V CURSOR(pColuna TT_CRE.COLUNA%TYPE) IS
      select pontos 
        from tt_cre
       where COLUNA=pColuna
         and tipdad='V';
BEGIN

Open Pontos_V(pColuna);
Fetch Pontos_V into vPontos;    
Close Pontos_V;

return COALESCE(vPontos,0);         
         
END;
$$ language 'plpgsql';




/*-- SEQ 0230 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION BuscaExporta (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE) CASCADE;

/*-- SEQ 0231 --*/
CREATE OR REPLACE FUNCTION BuscaExporta (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE)
RETURNS Numeric AS $$
DECLARE
pFILCLI ALIAS FOR $1 ;
pCODCLI ALIAS FOR $2 ;
  RESULTADO Numeric;
BEGIN 

      SELECT SUM(CASE WHEN (REL.TIPPAR = 'C' AND CFG.parc_cartao          = 'T') OR
                           (REL.TIPPAR = 'A' AND CFG.parc_cliente_transp  = 'T') OR
                           (REL.TIPPAR = 'F' AND CFG.parc_fornecedor      = 'T') OR
                           (REL.TIPPAR = 'I' AND CFG.parc_indica_venda    = 'T') OR
                           (REL.TIPPAR = 'M' AND CFG.parc_marca           = 'T') OR
                           (REL.TIPPAR = 'O' AND CFG.parc_motorista       = 'T') OR
                           (REL.TIPPAR = 'R' AND CFG.parc_representante   = 'T') OR
                           (REL.TIPPAR = 'N' AND CFG.parc_tec_interno     = 'T') OR
                           (REL.TIPPAR = 'T' AND CFG.parc_transportador   = 'T') OR
                           (REL.TIPPAR = 'X' AND CFG.parc_tecnico_externo = 'T') OR
                           (USU.FILUSU IS NOT NULL AND CFG.parc_usuario               = 'T')
                           THEN 1 ELSE 0 END)                                               
        INTO RESULTADO                   
        FROM TT_REL REL CROSS JOIN TT_CFG CFG 
                        LEFT  JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR
                                             AND CLI.CODCLI = REL.CODPAR
                        LEFT  JOIN TT_USU USU ON USU.FILCLI = CLI.CODCLI
                                             AND USU.CODCLI = CLI.CODCLI                              
        WHERE REL.FILPAR = pFILCLI
          AND REL.CODPAR = pCODCLI;
          
      RETURN RESULTADO;    

END;
$$ language 'plpgsql';





/*-- SEQ 0232 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalculaCST (CHAR,TT_IUF.SUBTRI%TYPE,TT_IUF.CALSUB%TYPE,TD_NAT.TRIBUT%TYPE,TT_VEN.CODSER%TYPE,TT_VEN.BASUBS%TYPE,TT_VEN.SUBSTT%TYPE,TT_VEN.UFLOJA%TYPE,TT_CLI.TIPDOC%TYPE,TT_CLI.ISENTO%TYPE,TT_CLI.INSEST%TYPE,TT_IVE.REDITE%TYPE,TT_PRO.TIPPRO%TYPE,TT_PRO.ORIPRO%TYPE,TD_FIL.REGTRI%TYPE,TD_FIL.PERCRE%TYPE,TT_VEN.FLGNFE%TYPE,TT_TRA.FILIVE%TYPE) CASCADE;

/*-- SEQ 0233 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalculaCST (CHAR,TT_IUF.SUBTRI%TYPE,TT_IUF.CALSUB%TYPE,TD_NAT.TRIBUT%TYPE,TT_VEN.CODSER%TYPE,TT_VEN.BASUBS%TYPE,TT_VEN.SUBSTT%TYPE,TT_VEN.UFLOJA%TYPE,TT_CLI.TIPDOC%TYPE,TT_CLI.ISENTO%TYPE,TT_CLI.INSEST%TYPE,TT_IVE.REDITE%TYPE,TT_PRO.TIPPRO%TYPE,TT_PRO.ORIPRO%TYPE,TD_FIL.REGTRI%TYPE,TD_FIL.PERCRE%TYPE,TT_VEN.FLGNFE%TYPE,TT_TRA.FILIVE%TYPE,TD_FIL.TRISIM%TYPE) CASCADE;

/*-- SEQ 0234 --*/
CREATE OR REPLACE FUNCTION CalculaCST (CHAR,TT_IUF.SUBTRI%TYPE,TT_IUF.CALSUB%TYPE,TD_NAT.TRIBUT%TYPE,TT_VEN.CODSER%TYPE,TT_VEN.BASUBS%TYPE,TT_VEN.SUBSTT%TYPE,TT_VEN.UFLOJA%TYPE,TT_CLI.TIPDOC%TYPE,TT_CLI.ISENTO%TYPE,TT_CLI.INSEST%TYPE,TT_IVE.REDITE%TYPE,TT_PRO.TIPPRO%TYPE,TT_PRO.ORIPRO%TYPE,TD_FIL.REGTRI%TYPE,TD_FIL.PERCRE%TYPE,TT_VEN.FLGNFE%TYPE,TT_TRA.FILIVE%TYPE,TD_FIL.TRISIM%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pOPCAO ALIAS FOR $1 ;
pSUBTRI ALIAS FOR $2 ;
pCALSUB ALIAS FOR $3 ;
pTRIBUT ALIAS FOR $4 ;
pCODSER ALIAS FOR $5 ;
pBASUBS ALIAS FOR $6 ;
pSUBSTT ALIAS FOR $7 ;
pUFLOJA ALIAS FOR $8 ;
pTIPDOC ALIAS FOR $9 ;
pISENTO ALIAS FOR $10 ;
pINSEST ALIAS FOR $11 ;
pREDITE ALIAS FOR $12 ;
pTIPPRO ALIAS FOR $13 ;
pORIPRO ALIAS FOR $14 ;
pREGTRI ALIAS FOR $15 ;
pPERCRE ALIAS FOR $16 ;
pFLGNFE ALIAS FOR $17 ;
pTRA_FILIVE ALIAS FOR $18 ;
pTRISIM ALIAS FOR $19 ;
-- Objetivo:
-- 1) Calcular o CST baseando-se nos arquivos de parmetro

-- pOPCAO - Opo:
-- 1 - CST
-- 2 - Motivo

-- pSUBTRI - Tipo de Tributao:
-- 0 - Tributado
-- 1 - Nao Tributado
-- 2 - Isento
-- 3 - Substituido
-- 4 - Isento no Estado

-- pTIPPRO - Tipo de Produto:
-- 0 - Material
-- 1 - Servio
-- 2 - Terceirizado

-- pORIPRO - Origem:
-- 0 - Nacional
-- 1 - Estrangeira - Importao direta
-- 2 - Estrangeira - Adquirida no mercado interno

-- CST:
-- 00 - Tributada integralmente
-- 10 - Tributada e com cobrana do ICMS por substituio tributria
-- 20 - Com reduo de base de clculo
-- 30 - Isenta ou no tributada e com cobrana do ICMS por substituio tributria
-- 40 - Isenta
-- 41 - No tributada
-- 50 - Suspenso
-- 51 - Diferimento
-- 60 - ICMS cobrado anteriormente por substituio tributria
-- 70 - Com reduo de base de clculo e cobrana do ICMS por substituio tributria
-- 90 - Outras

-- CSOSN:
-- 101 - Tributada pelo Simples Nacional com permisso de crdito
--     - Classificam-se neste cdigo as operaes que permitem a indicao da alquota do ICMS
--       devido no Simples Nacional e o valor do crdito correspondente.
-- 102 - Tributada pelo Simples Nacional sem permisso de crdito
--     - Classificam-se neste cdigo as operaes que no permitem a indicao da alquota do ICMS
--       devido pelo Simples Nacional e do valor do crdito, e no estejam abrangidas nas hipteses
--       dos cdigos 103, 203, 300, 400, 500 e 900.
-- 103 - Iseno do ICMS no Simples Nacional para faixa de receita bruta
--     - Classificam-se neste cdigo as operaes praticadas por optantes pelo Simples Nacional
--       contemplados com iseno concedida para faixa de receita bruta nos termos da Lei Complementar n 123, de 2006.
-- 201 - Tributada pelo Simples Nacional com permisso de crdito e com cobrana do ICMS por substituio tributria
--     - Classificam-se neste cdigo as operaes que permitem a indicao da alquota do ICMS devido pelo
--       Simples Nacional e do valor do crdito, e com cobrana do ICMS por substituio tributria.
-- 202 - Tributada pelo Simples Nacional sem permisso de crdito e com cobrana do ICMS por substituio tributria
--     - Classificam-se neste cdigo as operaes que no permitem a indicao da alquota do ICMS
--       devido pelo Simples Nacional e do valor do crdito, e no estejam abrangidas nas hipteses
--       dos cdigos 103, 203, 300, 400, 500 e 900, e com cobrana do ICMS por substituio tributria.
-- 203 - Iseno do ICMS no Simples Nacional para faixa de receita bruta e com cobrana
--       do ICMS por substituio tributria
--     - Classificam-se neste cdigo as operaes praticadas por optantes pelo Simples Nacional
--       contemplados com iseno para faixa de receita bruta nos termos da Lei Complementar n 123,
--       de 2006, e com cobrana do ICMS por substituio tributria.
-- 300 - Imune
--     - Classificam-se neste cdigo as operaes praticadas por optantes pelo
--       Simples Nacional contempladas com imunidade do ICMS.
-- 400 - No tributada pelo Simples Nacional
--     - Classificam-se neste cdigo as operaes praticadas por optantes pelo
--       Simples Nacional no sujeitas  tributao pelo ICMS dentro do Simples Nacional.
-- 500 - ICMS cobrado anteriormente por substituio tributria (substitudo) ou por antecipao
--     - Classificam-se neste cdigo as operaes sujeitas exclusivamente ao regime de substituio
--       tributria na condio de substitudo tributrio ou no caso de antecipaes.
-- 900 - Outros
--     - Classificam-se neste cdigo as demais operaes que no se enquadrem nos
--       cdigos 101, 102, 103, 201, 202, 203, 300, 400 e 500.

  WK_CST VARCHAR(3);
  WK_COMPLEMENTO CONSTANT VARCHAR(254) := Constante('complemento');
  WK_MOTIVO VARCHAR(200);
  WK_RETORNO VARCHAR(200);
BEGIN

  WK_CST     := '';
  WK_MOTIVO  := '';
  WK_RETORNO := '';

  --IF pOPCAO NOT IN ('1','2') THEN
  --  RAISE EXCEPTION 'PG-20010 Parmetro "pOPCAO" invlido. %' , WK_COMPLEMENTO;
  --END IF;

  --IF pSUBTRI NOT IN ('0','1','2','3','4') THEN
  --  RAISE EXCEPTION 'PG-20020 Parmetro "pSUBTRI" invlido. %' , WK_COMPLEMENTO;
  --END IF;

  --IF pCALSUB NOT IN ('R','D') THEN
  --  RAISE EXCEPTION 'PG-20030 Parmetro "pCALSUB" invlido. %' , WK_COMPLEMENTO;
  --END IF;

  IF pTIPPRO = '0' THEN -- Material

    IF pTRIBUT = 'F' THEN -- Natureza no tributa (Ex.: Simples Fatura)
      IF pTRA_FILIVE IS NOT NULL THEN -- Transferncia
        IF pSUBTRI = '3' THEN -- Substituido
          WK_CST    := '60';
          WK_MOTIVO := 'Substitudo em transferncia com natureza que no tributa';
        ELSE
          WK_CST    := '51';
          WK_MOTIVO := 'Diferido por ser transferncia no substituda com natureza que no tributa';
        END IF;
      ELSE
        WK_CST    := '90';
        WK_MOTIVO := 'Substitudo com natureza que no tributa';
      END IF;
    ELSE
      IF pSUBTRI = '0' THEN -- Tributado
        WK_CST    := '00';
        WK_MOTIVO := 'Tributado';
      ELSIF pSUBTRI = '1' THEN -- No Tributado
        WK_CST    := '41';
        WK_MOTIVO := 'No tributado';
      ELSIF pSUBTRI = '2' THEN -- Isento
        WK_CST    := '40';
        WK_MOTIVO := 'Isento';
      ELSIF pSUBTRI = '4' THEN -- Isento no Estado
        WK_CST    := '40';
        WK_MOTIVO := 'Isento no estado';
      ELSIF pSUBTRI = '3' THEN -- Substituido

        -- regras gerais
        IF pCODSER = 'CF' THEN -- Cupom Fiscal
          WK_CST    := '60';
          WK_MOTIVO := 'Substitudo porque  CF';
        ELSIF /*COALESCE(pBASUBS,0) <> 0 OR*/ COALESCE(pSUBSTT,0) <> 0 THEN -- Substituiu
          WK_CST    := '10';
          WK_MOTIVO := 'Substituto porque teve valor de substituio';
        ELSIF /*COALESCE(pBASUBS,0) = 0 OR*/ COALESCE(pSUBSTT,0) = 0 THEN -- Substituiu
          WK_CST    := '60';
          WK_MOTIVO := 'Substitudo porque no tem valor de substituio';
        ELSE

          -- regras da planilha de substituio
          IF pCALSUB = 'R' THEN -- Retm
            IF pISENTO = 'T' THEN -- Consumidor Final
              IF pUFLOJA = 'T' THEN -- Dentro do Estado
                WK_CST    := '00';
                WK_MOTIVO := 'Tributado porque retm em venda para consumidor final dentro do estado';
              ELSE
                IF UPPER(COALESCE(pTIPDOC,'  ')) <> 'IE' OR
                   UPPER(COALESCE(pINSEST,'ISENTO')) = 'ISENTO' THEN -- No contribuinte
                  WK_CST    := '00';
                  WK_MOTIVO := 'Tributado porque retm em venda para consumidor final no contribuinte fora do estado';
                ELSE -- Contribuinte
                  WK_CST    := '10';
                  WK_MOTIVO := 'Substituto que retm em venda para consumidor final contribuinte fora do estado';
                END IF;
              END IF;
            ELSE -- Revenda
              IF pUFLOJA = 'T' THEN -- Dentro do Estado
                WK_CST    := '10';
                WK_MOTIVO := 'Substituto que retm em venda para revenda dentro do estado';
              ELSE
                WK_CST    := '10';
                WK_MOTIVO := 'Substituto que retm em venda para revenda fora do estado';
              END IF;
            END IF;
          ELSE -- Destaca
            IF pISENTO = 'T' THEN -- Consumidor Final
              IF pUFLOJA = 'T' THEN -- Dentro do Estado
                WK_CST    := '60';
                WK_MOTIVO := 'Substitudo que destaca em venda para consumidor final dentro do estado';
              ELSE
                IF UPPER(COALESCE(pTIPDOC,'  ')) <> 'IE' OR
                   UPPER(COALESCE(pINSEST,'ISENTO')) = 'ISENTO' THEN -- No contribuinte
                  WK_CST    := '60';
                  WK_MOTIVO := 'Substitudo que destaca em venda para consumidor final no contribuinte fora do estado';
                ELSE -- Contribuinte
                  WK_CST    := '10';
                  WK_MOTIVO := 'Substituto que destaca em venda para consumidor final contribuinte fora do estado';
                END IF;
              END IF;
            ELSE -- Revenda
              IF pUFLOJA = 'T' THEN -- Dentro do Estado
                WK_CST    := '60';
                WK_MOTIVO := 'Substitudo que destaca em venda para revenda dentro do estado';
              ELSE
                WK_CST    := '10';
                WK_MOTIVO := 'Substituto que destaca em venda para revenda fora do estado';
              END IF;
            END IF;
          END IF;

        END IF;

      END IF;

      IF COALESCE(pREDITE,0) <> 0 THEN -- Com reduo de ICMS
        IF WK_CST IN ('00') THEN
          WK_CST    := '20';
          WK_MOTIVO := WK_MOTIVO || ' - com reduo de ICMS';
        ELSIF WK_CST = '10' THEN
          WK_CST    := '70';
          WK_MOTIVO := WK_MOTIVO || ' - com ST e reduo de ICMS';
        END IF;
      END IF;

    END IF;

  ELSE -- Servio
    WK_CST    := '90';
    WK_MOTIVO := 'Servio';
  END IF;

  -- CSOSN
  IF  pREGTRI = 'S'
  AND pFLGNFE IS NOT NULL -- Simples Nacional e NF-e
  AND COALESCE(pTRISIM,'X') <> 'O' THEN -- SIMPLES NACIONAL COM EXCESSO DE SUBLIMITE

    -- 00 -> 101 ou 102
    -- 10 -> 201 ou 202
    -- 30 -> 203
    -- 40 -> 300 ou 103
    -- 41 -> 400
    -- 60 -> 500
    -- 90 -> 900
    -- 70 - No tem equivalncia.

    IF WK_CST = '00' THEN
      IF pPERCRE = 'T' THEN
        WK_CST := '101';
      ELSE
        WK_CST := '102';
      END IF;
    ELSIF WK_CST = '10' THEN
      IF pPERCRE = 'T' THEN
        WK_CST := '201';
      ELSE
        WK_CST := '202';
      END IF;
    ELSIF WK_CST = '30' THEN
      WK_CST := '203';
    ELSIF WK_CST = '40' THEN
      IF pPERCRE = 'T' THEN
        WK_CST := '300';
      ELSE
        WK_CST := '103';
      END IF;
    ELSIF WK_CST = '41' THEN
      WK_CST := '400';
    ELSIF WK_CST = '60' THEN
      WK_CST := '500';
    ELSIF WK_CST = '90' THEN
      WK_CST := '900';
    END IF;

  ELSE

    -- Origem do Produto
    WK_CST := COALESCE(pORIPRO, '0')||WK_CST;

  END IF;

  -- Resultado da funo
  IF pOPCAO = '1' THEN
    WK_RETORNO := WK_CST;
  ELSIF pOPCAO = '2' THEN
    WK_RETORNO := WK_MOTIVO;
  END IF;

  RETURN WK_RETORNO;

END;
$$ language 'plpgsql';




/*-- SEQ 0235 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Cambio (TD_MOE.CODTAB%TYPE,Timestamp) CASCADE;

/*-- SEQ 0236 --*/
CREATE OR REPLACE FUNCTION Cambio (TD_MOE.CODTAB%TYPE,Timestamp)
RETURNS Numeric AS $$
DECLARE
pMOEDA ALIAS FOR $1 ;
pDATA ALIAS FOR $2 ;
-- Objetivo:
-- 1) Obter o valor da cotacao de uma moeda num determinado dia
  COTACAO Numeric;
BEGIN
  -- Moeda corrente do Pais
  IF pMOEDA = 0 THEN
    RETURN 1;
  ELSE
    -- Cria componentes temporarios
    SELECT COALESCE(VLRREF,0)
      INTO COTACAO
      FROM TT_CAM
     WHERE CODMOE = pMOEDA
       AND TO_CHAR(DATREF, 'DD/MM/YYYY' ) = TO_CHAR(pDATA, 'DD/MM/YYYY' );

    RETURN COALESCE(COTACAO,0);
  END IF;
END;
$$ language 'plpgsql';





/*-- SEQ 0237 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CapsLock (VARCHAR) CASCADE;

/*-- SEQ 0238 --*/
CREATE OR REPLACE FUNCTION CapsLock (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pStr ALIAS FOR $1 ;
BEGIN
  RETURN lower(pStr);   
END;
$$ language 'plpgsql' STABLE;




/*-- SEQ 0239 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ComplementoDadosFinanceiros (TR_FIN.ORIGEM%TYPE,TR_FIN.CODFIL%TYPE,TR_FIN.SEQUEN%TYPE,TR_FIN.NUMPAR%TYPE,TR_FIN.SUBPAR%TYPE,Numeric) CASCADE;

/*-- SEQ 0240 --*/
CREATE OR REPLACE FUNCTION ComplementoDadosFinanceiros (TR_FIN.ORIGEM%TYPE,TR_FIN.CODFIL%TYPE,TR_FIN.SEQUEN%TYPE,TR_FIN.NUMPAR%TYPE,TR_FIN.SUBPAR%TYPE,Numeric)
RETURNS VARCHAR AS $$
DECLARE
pORIGEM ALIAS FOR $1 ;
pCODFIL ALIAS FOR $2 ;
pSEQUEN ALIAS FOR $3 ;
pNUMPAR ALIAS FOR $4 ;
pSUBPAR ALIAS FOR $5 ;
pCOLUNA ALIAS FOR $6 ;
--Valores para a o parametro pCOLUNA
--1 - OBSERVACAO
--2 - COMPLEMENTO
--3 - DOCUMENTO
--4 - ESTORNO
--5 - DOCUMENTO EME4
--6 - CHAVE ENDERECO FATURA
--7 - INDICADOR DE EXPORTACAO PARA O EME4
--10 - RETORNA TODOS OS INDICADORES ACIMA SEPARADOS POR PONTO E VIRGULA

WK_RETORNO TT_COM.OBSERV%TYPE;

BEGIN

WK_RETORNO := '';

IF pORIGEM = 'COM' THEN
    SELECT CASE WHEN pCOLUNA = 1 THEN COM.OBSERV
                WHEN pCOLUNA = 2 THEN COM.OBSFAT
                WHEN pCOLUNA = 3 THEN COALESCE(COM.CODSER,'')||'/'||lTrim(COALESCE(COM.SUBSER,''))||'-'||lTrim(COALESCE(COM.NUMNOT,''))
                WHEN pCOLUNA = 4 THEN CAST('F' AS CHAR(1))
                WHEN pCOLUNA = 5 THEN LPAD(COM.NUMNOT, 10, ' ')
                WHEN pCOLUNA = 6 THEN COM.FILEND||TO_CHAR(COM.NUMEND)
                WHEN pCOLUNA = 7 THEN COM.EXPEM4
                WHEN pCOLUNA = 10 THEN REPLACE(TRIM(COALESCE(COM.OBSERV, '')), '<BR>', '') || '<BR>' ||
                                       REPLACE(TRIM(COALESCE(COM.OBSFAT, '')), '<BR>', '') || '<BR>' ||
                                       COALESCE(COM.CODSER,'')||'/'||lTrim(COALESCE(COM.SUBSER,''))||'-'||lTrim(COALESCE(COM.NUMNOT,'')) || '<BR>' ||
                                       'F' || '<BR>' ||
                                       LPAD(COM.NUMNOT, 10, ' ') || '<BR>' ||
                                       COALESCE(COM.FILEND||TO_CHAR(COM.NUMEND), '') || '<BR>' ||
                                       COALESCE(COM.EXPEM4, 'T') || '<BR>'
                ELSE CAST(' ' AS VARCHAR(1))
           END
       INTO WK_RETORNO
       FROM TT_COM COM
      WHERE COM.CODFIL = pCODFIL
        AND COM.SEQUEN = pSEQUEN;
ELSIF pORIGEM = 'TRC' THEN
    SELECT CASE WHEN pCOLUNA = 1 THEN TRC.OBSERV
                WHEN pCOLUNA = 2 THEN CAST(' ' AS VARCHAR(1))
                WHEN pCOLUNA = 3 THEN COALESCE(TRC.CODSER,'')||'-'||lTrim(COALESCE(TRC.NUMNOT,''))
                WHEN pCOLUNA = 4 THEN CAST('F' AS CHAR(1))
                WHEN pCOLUNA = 5 THEN TRC.SEQUEN
                WHEN pCOLUNA = 6 THEN NULL
                WHEN pCOLUNA = 7 THEN TRC.EXPEM4
                WHEN pCOLUNA = 10 THEN REPLACE(TRIM(COALESCE(TRC.OBSERV, '')), '<BR>', '') || '<BR>' ||
                                       ' ' || '<BR>' ||
                                       COALESCE(TRC.CODSER,'')||'-'||lTrim(COALESCE(TRC.NUMNOT,'')) || '<BR>' ||
                                       'F' || '<BR>' ||
                                       TRC.SEQUEN || '<BR>' ||
                                       '' || '<BR>' ||
                                       COALESCE(TRC.EXPEM4, 'T') || '<BR>'
                ELSE CAST(' ' AS VARCHAR(1))
            END
       INTO WK_RETORNO
       FROM TT_TRC TRC
      WHERE TRC.CODFIL = pCODFIL
        AND TRC.SEQUEN = pSEQUEN;
ELSIF pORIGEM = 'VEN' THEN
    SELECT CASE WHEN pCOLUNA = 1 THEN VEN.OBSERV
                WHEN pCOLUNA = 2 THEN CAST(' ' AS VARCHAR(1))
                WHEN pCOLUNA = 3 THEN COALESCE(VEN.CODSER,'')||'/'||lTrim(COALESCE(VEN.NUMECF,''))||'-'||lTrim(COALESCE(VEN.NUMNOT,''))||CASE WHEN COALESCE(VEN.CNT_RO,0)>0 THEN '['||VEN.CNT_RO||']' ELSE '' END
                WHEN pCOLUNA = 4 THEN CAST('F' AS CHAR(1))  
                WHEN pCOLUNA = 5 THEN CASE WHEN VEN.CODSER = 'CF' THEN VEN.SEQUEN
                                           WHEN VEN.CODSER = 'ST' THEN COALESCE(TO_CHAR(VEN.SATCFE), VEN.NUMNOT)
                                           ELSE LPAD(VEN.NUMNOT, 10, ' ') 
                                      END
                WHEN pCOLUNA = 6 THEN VEN.FILFAT||TO_CHAR(VEN.ENDFAT)
                WHEN pCOLUNA = 7 THEN VEN.EXPEM4
                WHEN pCOLUNA = 10 THEN REPLACE(TRIM(COALESCE(VEN.OBSERV, '')), '<BR>', '') || '<BR>' ||
                                       ' ' || '<BR>' ||
                                       COALESCE(VEN.CODSER,'')||'/'||lTrim(COALESCE(VEN.NUMECF,''))||'-'||lTrim(COALESCE(VEN.NUMNOT,''))||CASE WHEN COALESCE(VEN.CNT_RO,0)>0 THEN '['||VEN.CNT_RO||']' ELSE '' END || '<BR>' ||
                                       'F' || '<BR>' ||
                                       CASE WHEN VEN.CODSER = 'CF' THEN VEN.SEQUEN
                                            WHEN VEN.CODSER = 'ST' THEN COALESCE(TO_CHAR(VEN.SATCFE), VEN.NUMNOT)
                                            ELSE LPAD(VEN.NUMNOT, 10, ' ') 
                                       END || '<BR>' ||
                                       COALESCE(VEN.FILFAT, '')||COALESCE(TO_CHAR(VEN.ENDFAT), '') || '<BR>' ||
                                       COALESCE(VEN.EXPEM4, 'T') || '<BR>'
                ELSE CAST(' ' AS VARCHAR(1))
            END
            
       INTO WK_RETORNO
       FROM TT_VEN VEN
      WHERE VEN.CODFIL = pCODFIL
        AND VEN.SEQUEN = pSEQUEN;
ELSIF pORIGEM = 'PTR' THEN
    IF pNUMPAR <> '0' THEN 
       SELECT CASE WHEN pCOLUNA = 1 THEN TRC.OBSERV
                   WHEN pCOLUNA = 2 THEN CAST(' ' AS VARCHAR(1))
                   WHEN pCOLUNA = 3 THEN COALESCE(TRC.CODSER,'')||'-'||lTrim(COALESCE(TRC.NUMNOT,''))||' '||COALESCE(PTR.NUMPAR,'')||'/'||lTrim(COALESCE(PTR.SUBPAR,''))
                   WHEN pCOLUNA = 4 THEN CAST('F' AS CHAR(1))
                   WHEN pCOLUNA = 5 THEN PTR.SEQUEN
                   WHEN pCOLUNA = 6 THEN NULL
                   WHEN pCOLUNA = 7 THEN TRC.EXPEM4
                   WHEN pCOLUNA = 10 THEN REPLACE(TRIM(COALESCE(TRC.OBSERV, '')), '<BR>', '') || '<BR>' ||
                                       ' ' || '<BR>' ||
                                       COALESCE(TRC.CODSER,'')||'-'||lTrim(COALESCE(TRC.NUMNOT,''))||' '||COALESCE(PTR.NUMPAR,'')||'/'||lTrim(COALESCE(PTR.SUBPAR,'')) || '<BR>' ||
                                       'F' || '<BR>' ||
                                       PTR.SEQUEN || '<BR>' ||
                                       '' || '<BR>' ||
                                       COALESCE(TRC.EXPEM4, 'T') || '<BR>'
                   ELSE CAST(' ' AS VARCHAR(1))
              END
          INTO WK_RETORNO
          FROM TT_TRC TRC INNER JOIN TT_PTR PTR ON PTR.CODFIL = TRC.CODFIL AND PTR.SEQUEN = TRC.SEQUEN
         WHERE PTR.CODFIL = pCODFIL
           AND PTR.SEQUEN = pSEQUEN
           AND PTR.NUMPAR = pNUMPAR
           AND PTR.SUBPAR = pSUBPAR;
    ELSE 
       SELECT CASE WHEN pCOLUNA = 1 THEN TRC.OBSERV
                   WHEN pCOLUNA = 2 THEN CAST(' ' AS VARCHAR(1))
                   WHEN pCOLUNA = 3 THEN COALESCE(TRC.CODSER,'')||'-'||lTrim(COALESCE(TRC.NUMNOT,''))||' '||COALESCE(PTR.NUMPAR,'')||'/'||lTrim(COALESCE(PTR.SUBPAR,''))
                   WHEN pCOLUNA = 4 THEN CAST('F' AS CHAR(1))
                   WHEN pCOLUNA = 5 THEN PTR.SEQUEN
                   WHEN pCOLUNA = 6 THEN NULL
                   WHEN pCOLUNA = 7 THEN TRC.EXPEM4
                   WHEN pCOLUNA = 10 THEN REPLACE(TRIM(COALESCE(TRC.OBSERV, '')), '<BR>', '') || '<BR>' ||
                                       ' ' || '<BR>' ||
                                       COALESCE(TRC.CODSER,'')||'-'||lTrim(COALESCE(TRC.NUMNOT,''))||' '||COALESCE(PTR.NUMPAR,'')||'/'||lTrim(COALESCE(PTR.SUBPAR,'')) || '<BR>' ||
                                       'F' || '<BR>' ||
                                       PTR.SEQUEN || '<BR>' ||
                                       '' || '<BR>' ||
                                       COALESCE(TRC.EXPEM4, 'T') || '<BR>'
                   ELSE CAST(' ' AS VARCHAR(1))
              END
          INTO WK_RETORNO
          FROM TT_TRC TRC INNER JOIN TT_PTR PTR ON PTR.CODFIL = TRC.CODFIL AND PTR.SEQUEN = TRC.SEQUEN
         WHERE PTR.CODFIL = pCODFIL
           AND PTR.SEQUEN = pSEQUEN;
    END IF;

ELSIF pORIGEM = 'REC' THEN
    SELECT CASE WHEN pCOLUNA = 1 THEN VEN.OBSERV
                WHEN pCOLUNA = 2 THEN REC.OBSERV 
                WHEN pCOLUNA = 3 THEN COALESCE(VEN.CODSER,'')||'/'||COALESCE(VEN.NUMECF,'')||'-'||LTRIM(COALESCE(VEN.NUMNOT,''))
                WHEN pCOLUNA = 4 THEN CAST('F' AS CHAR(1))
                WHEN pCOLUNA = 5 THEN CASE WHEN VEN.CODSER = 'CF' THEN VEN.SEQUEN
                                           WHEN VEN.CODSER = 'ST' THEN COALESCE(TO_CHAR(VEN.SATCFE), VEN.NUMNOT)
                                           ELSE LPAD(VEN.NUMNOT, 10, ' ') 
                                      END
                WHEN pCOLUNA = 6 THEN VEN.FILFAT||TO_CHAR(VEN.ENDFAT)
                WHEN pCOLUNA = 7 THEN VEN.EXPEM4
                WHEN pCOLUNA = 10 THEN REPLACE(TRIM(COALESCE(VEN.OBSERV, '')), '<BR>', '') || '<BR>' ||
                                       REPLACE(TRIM(COALESCE(REC.OBSERV, '')), '<BR>', '') || '<BR>' ||
                                       COALESCE(VEN.CODSER,'')||'/'||COALESCE(VEN.NUMECF,'')||'-'||LTRIM(COALESCE(VEN.NUMNOT,'')) || '<BR>' ||
                                       'F' || '<BR>' ||
                                       CASE WHEN VEN.CODSER = 'CF' THEN VEN.SEQUEN
                                            WHEN VEN.CODSER = 'ST' THEN COALESCE(TO_CHAR(VEN.SATCFE), VEN.NUMNOT)
                                            ELSE LPAD(VEN.NUMNOT, 10, ' ') 
                                       END || '<BR>' ||
                                       COALESCE(VEN.FILFAT, '')||COALESCE(TO_CHAR(VEN.ENDFAT), '') || '<BR>' ||
                                       COALESCE(VEN.EXPEM4, 'T') || '<BR>'
                ELSE CAST(' ' AS VARCHAR(1))
           END
       INTO WK_RETORNO
       FROM TT_VEN VEN
       INNER JOIN TT_REC REC ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
      WHERE VEN.CODFIL = pCODFIL
        AND VEN.SEQUEN = pSEQUEN
        AND REC.NUMPAR = pNUMPAR
        AND REC.SUBPAR = pSUBPAR;
ELSIF pORIGEM = 'CCC' THEN
    SELECT CASE WHEN pCOLUNA = 1 THEN CCC.COMPLE
                WHEN pCOLUNA = 2 THEN CAST(' ' AS VARCHAR(1))
                WHEN pCOLUNA = 3 THEN CCC.NUMDOC
                WHEN pCOLUNA = 4 THEN CAST('F' AS CHAR(1))
                WHEN pCOLUNA = 5 THEN CCC.SEQUEN
                WHEN pCOLUNA = 6 THEN NULL
                WHEN pCOLUNA = 7 THEN CCC.EXPEM4
                WHEN pCOLUNA = 10 THEN REPLACE(TRIM(COALESCE(CCC.COMPLE, '')), '<BR>', '') || '<BR>' ||
                                       '' || '<BR>' ||
                                       COALESCE(CCC.NUMDOC,'') || '<BR>' ||
                                       'F' || '<BR>' ||
                                       CCC.SEQUEN || '<BR>' ||
                                       '' || '<BR>' ||
                                       COALESCE(CCC.EXPEM4, 'T') || '<BR>'
                ELSE CAST(' ' AS VARCHAR(1))
           END
       INTO WK_RETORNO
       FROM TT_CCC CCC
      WHERE CCC.CODFIL = pCODFIL
        AND CCC.SEQUEN = pSEQUEN;
ELSIF pORIGEM = 'CHR' THEN
    SELECT CASE WHEN pCOLUNA = 1 THEN CAST(' ' AS VARCHAR(1))
                WHEN pCOLUNA = 2 THEN CAST(' ' AS VARCHAR(1))
                WHEN pCOLUNA = 3 THEN RTRIM(LTRIM(COALESCE(CHR.CODBCO,'')))||'-'||
                                      RTRIM(LTRIM(COALESCE(CHR.CODAGE,'')))||'-'||
                                      RTRIM(LTRIM(COALESCE(CHR.NUMCON,'')))||'-'||
                                      RTRIM(LTRIM(COALESCE(CHR.NUMCHE,'')))
                WHEN pCOLUNA = 4 THEN CAST('F' AS CHAR(1))
                WHEN pCOLUNA = 5 THEN CHR.SEQUEN
                WHEN pCOLUNA = 6 THEN NULL
                WHEN pCOLUNA = 7 THEN CHR.EXPEM4
                WHEN pCOLUNA = 10 THEN ' ' || '<BR>' ||
                                       ' ' || '<BR>' ||
                                       RTRIM(LTRIM(COALESCE(CHR.CODBCO,'')))||'-'||
                                       RTRIM(LTRIM(COALESCE(CHR.CODAGE,'')))||'-'||
                                       RTRIM(LTRIM(COALESCE(CHR.NUMCON,'')))||'-'||
                                       RTRIM(LTRIM(COALESCE(CHR.NUMCHE,''))) || '<BR>' ||
                                       'F' || '<BR>' ||
                                       CHR.SEQUEN || '<BR>' ||
                                       '' || '<BR>' ||
                                       COALESCE(CHR.EXPEM4, 'T') || '<BR>'
                ELSE CAST(' ' AS VARCHAR(1))
           END
       INTO WK_RETORNO
       FROM TT_CHR CHR
      WHERE CHR.CODFIL = pCODFIL
        AND CHR.SEQUEN = pSEQUEN;
ELSIF pORIGEM = 'DOP' THEN
    SELECT CASE WHEN pCOLUNA = 1 THEN DOP.OBSERV
                WHEN pCOLUNA = 2 THEN CAST(' ' AS VARCHAR(1))
                WHEN pCOLUNA = 3 THEN DOP.NUMDOC
                WHEN pCOLUNA = 4 THEN CAST('F' AS CHAR(1))
                WHEN pCOLUNA = 5 THEN DOP.SEQUEN
                WHEN pCOLUNA = 6 THEN NULL
                WHEN pCOLUNA = 7 THEN DOP.EXPEM4
                WHEN pCOLUNA = 10 THEN REPLACE(TRIM(COALESCE(DOP.OBSERV, '')), '<BR>', '') || '<BR>' ||
                                       '' || '<BR>' ||
                                       COALESCE(DOP.NUMDOC,'') || '<BR>' ||
                                       'F' || '<BR>' ||
                                       DOP.SEQUEN || '<BR>' ||
                                       '' || '<BR>' ||
                                       COALESCE(DOP.EXPEM4, 'T') || '<BR>'
                ELSE CAST(' ' AS VARCHAR(1))
           END
       INTO WK_RETORNO
       FROM TT_DOP DOP
      WHERE DOP.CODFIL = pCODFIL
        AND DOP.SEQUEN = pSEQUEN;
ELSIF pORIGEM = 'PAG' THEN
    SELECT CASE WHEN pCOLUNA = 1 THEN COALESCE(DOP.OBSERV,COM.OBSERV)
                WHEN pCOLUNA = 2 THEN CAST(' ' AS VARCHAR(1))
                WHEN pCOLUNA = 3 THEN COALESCE(DOP.NUMDOC,COALESCE(COM.CODSER,'')||'/'||lTrim(COALESCE(COM.SUBSER,''))||'-'||lTrim(COALESCE(COM.NUMNOT,'')))
                WHEN pCOLUNA = 4 THEN CAST('F' AS CHAR(1))
                WHEN pCOLUNA = 5 THEN LPAD(COM.NUMNOT, 10, ' ')
                WHEN pCOLUNA = 6 THEN COM.FILEND||TO_CHAR(COM.NUMEND)
                WHEN pCOLUNA = 7 THEN COM.EXPEM4
                WHEN pCOLUNA = 10 THEN REPLACE(TRIM(COALESCE(DOP.OBSERV,COALESCE(COM.OBSERV, ''))), '<BR>', '') || '<BR>' ||
                                       '' || '<BR>' ||
                                       COALESCE(DOP.NUMDOC,COALESCE(COM.CODSER,'')||'/'||lTrim(COALESCE(COM.SUBSER,''))||'-'||lTrim(COALESCE(COM.NUMNOT,''))) || '<BR>' ||
                                       'F' || '<BR>' ||
                                       LPAD(COM.NUMNOT, 10, ' ') || '<BR>' ||
                                       COALESCE(COM.FILEND,'')||COALESCE(TO_CHAR(COM.NUMEND),'') || '<BR>' ||
                                       COALESCE(COM.EXPEM4, 'T') || '<BR>'
                ELSE CAST(' ' AS VARCHAR(1))
           END
       INTO WK_RETORNO
        FROM TT_PAG PAG INNER JOIN TT_COM COM ON PAG.CODFIL=COM.CODFIL AND PAG.SEQUEN=COM.SEQUEN
                     LEFT JOIN (SELECT DOP.CODFIL, DOP.SEQUEN, DOP.FILCTA, DOP.SEQCTA, DOP.TIPCTA, DOP.OBSERV, DOP.NUMDOC
                                  FROM TT_DOP DOP INNER JOIN TT_PAG INT ON INT.FILDOP=DOP.CODFIL AND INT.SEQDOP=DOP.SEQUEN
                                                  LEFT JOIN TD_STD DSTD ON DOP.DOMDOP = DSTD.DOMDOP 
                                                                       AND DOP.STDDOP = DSTD.CODTAB
                                                                       AND DOP.FLGEST = DSTD.USOSTD
                                 WHERE DOP.FLGEST <> 'C'
                                   AND INT.CODFIL = pCODFIL
                                   AND INT.SEQUEN = pSEQUEN
                                   AND INT.NUMPAR = pNUMPAR
                                   AND INT.SUBPAR = pSUBPAR   
                                GROUP BY DOP.CODFIL, DOP.SEQUEN, DOP.FILCTA, DOP.SEQCTA, DOP.TIPCTA, DOP.OBSERV, DOP.NUMDOC
                               HAVING COUNT(*)=1
                               ) DOP ON PAG.FILDOP=DOP.CODFIL AND PAG.SEQDOP=DOP.SEQUEN
      WHERE PAG.CODFIL = pCODFIL
        AND PAG.SEQUEN = pSEQUEN
        AND PAG.NUMPAR = pNUMPAR
        AND PAG.SUBPAR = pSUBPAR;

ELSIF pORIGEM = 'FIN' THEN
    SELECT CASE WHEN pCOLUNA = 1 THEN FIN.OBSERV
                WHEN pCOLUNA = 2 THEN CAST(' ' AS VARCHAR(1))
                WHEN pCOLUNA = 3 THEN FIN.NUMDOC
                WHEN pCOLUNA = 4 THEN
                     CASE WHEN FIN.SEQEST IS NULL THEN
                          CAST('F' AS CHAR(1))
                     ELSE
                          CAST('T' AS CHAR(1))
                     END
                WHEN pCOLUNA = 5 THEN FIN.SEQUEN
                WHEN pCOLUNA = 6 THEN NULL
                WHEN pCOLUNA = 7 THEN FIN.EXPEM4
                WHEN pCOLUNA = 10 THEN REPLACE(TRIM(COALESCE(FIN.OBSERV,'')), '<BR>', '') || '<BR>' ||
                                       '' || '<BR>' ||
                                       COALESCE(FIN.NUMDOC,'') || '<BR>' ||
                                       CASE WHEN FIN.SEQEST IS NULL THEN 'F' ELSE 'T' END || '<BR>' ||
                                       FIN.SEQUEN || '<BR>' ||
                                       '' || '<BR>' ||
                                       COALESCE(FIN.EXPEM4, 'T') || '<BR>'
                ELSE CAST(' ' AS VARCHAR(1))
             END
             
       INTO WK_RETORNO
       FROM TT_FIN FIN
      WHERE FIN.CODFIL = pCODFIL
        AND FIN.SEQUEN = pSEQUEN;
ELSIF pORIGEM = 'TEF' THEN
    SELECT CASE WHEN pCOLUNA = 1 THEN CAST(' ' AS VARCHAR(1))
                WHEN pCOLUNA = 2 THEN CAST(' ' AS VARCHAR(1))
                WHEN pCOLUNA = 3 THEN 
                     (SELECT 'Ref.: '||MIN(VEN.CODFIL)||'-'||MIN(VEN.CODSER)||'/'||MIN(VEN.NUMECF)||'-'||MIN(VEN.NUMNOT)
                        FROM TT_OPE OPE INNER JOIN TT_REC REC ON OPE.FILREC = REC.CODFIL AND OPE.SEQREC = REC.SEQUEN
                                                             AND OPE.NUMPAR = REC.NUMPAR AND OPE.SUBPAR = REC.SUBPAR
                                        INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
                       WHERE OPE.CODFIL = TEF.CODFIL
                         AND OPE.NUMECF = TEF.NUMECF
                         AND OPE.TRN_ID = TEF.TRN_ID
                      HAVING MIN(REC.CODFIL||REC.SEQUEN)=MAX(REC.CODFIL||REC.SEQUEN))
                WHEN pCOLUNA = 4 THEN CAST('F' AS CHAR(1))
                WHEN pCOLUNA = 5 THEN TEF.SEQUEN
                WHEN pCOLUNA = 6 THEN NULL
                WHEN pCOLUNA = 7 THEN TEF.EXPEM4
                WHEN pCOLUNA = 10 THEN ' ' || '<BR>' ||
                                       ' ' || '<BR>' ||
                                       (SELECT 'Ref.: '||MIN(VEN.CODFIL)||'-'||MIN(VEN.CODSER)||'/'||MIN(VEN.NUMECF)||'-'||MIN(VEN.NUMNOT)
                                          FROM TT_OPE OPE INNER JOIN TT_REC REC ON OPE.FILREC = REC.CODFIL AND OPE.SEQREC = REC.SEQUEN
                                                                               AND OPE.NUMPAR = REC.NUMPAR AND OPE.SUBPAR = REC.SUBPAR
                                                          INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
                                         WHERE OPE.CODFIL = TEF.CODFIL
                                           AND OPE.NUMECF = TEF.NUMECF
                                           AND OPE.TRN_ID = TEF.TRN_ID
                                        HAVING MIN(REC.CODFIL||REC.SEQUEN)=MAX(REC.CODFIL||REC.SEQUEN)) || '<BR>' ||
                                       'F' || '<BR>' ||
                                       TEF.SEQUEN || '<BR>' ||
                                       '' || '<BR>' ||
                                       COALESCE(TEF.EXPEM4, 'T') || '<BR>'
                ELSE CAST(' ' AS VARCHAR(1))
           END
       INTO WK_RETORNO
       FROM TT_TEF TEF
      WHERE TEF.CODFIL = pCODFIL
        AND TEF.SEQUEN = pSEQUEN;

END IF;

RETURN WK_RETORNO;

END;
$$ language 'plpgsql';




/*-- SEQ 0241 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ContaDiasUteisNoMes (Timestamp) CASCADE;

/*-- SEQ 0242 --*/
CREATE OR REPLACE FUNCTION ContaDiasUteisNoMes (Timestamp)
RETURNS integer AS $$
DECLARE
p_DATINI ALIAS FOR $1 ;
-- Flvio 65324 - Traz a quantidade de dias teis no ms at a data especificada, desconsiderando dias de feriados
  D INT; -- DIA
  M INT; -- MES
  A INT; -- ANO
  I INT; -- INDICE
  S INT; -- DIA DA SEMANA
  V_DIAS_UTEIS Numeric(2);
begin
  V_DIAS_UTEIS := 0;
  
  A := to_number(to_char(p_DATINI,'yyyy'));
  M := to_number(to_char(p_DATINI,'mm'));
  D := to_number(to_char(p_DATINI,'dd'));

  FOR I IN 1..D LOOP
    S := to_number(to_char(TO_DATE(TO_CHAR(I,'00')||TO_CHAR(M,'00')||TO_CHAR(A,'0000'),'ddmmyyyy'),'D'));
    IF (S > 1) AND (S < 7) THEN
      V_DIAS_UTEIS := V_DIAS_UTEIS + 1;
    END IF;
  END LOOP;

  RETURN V_DIAS_UTEIS;

END;
$$ language 'plpgsql';




/*-- SEQ 0243 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CODIGO_CONTA (TT_ECT.CODFIL%TYPE,TT_ECT.SEQUEN%TYPE,VARCHAR) CASCADE;

/*-- SEQ 0244 --*/
CREATE OR REPLACE FUNCTION CODIGO_CONTA (TT_ECT.CODFIL%TYPE,TT_ECT.SEQUEN%TYPE,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
PCODFIL ALIAS FOR $1 ;
PSEQUEN ALIAS FOR $2 ;
PORICTA ALIAS FOR $3 ;
vCODCTA VARCHAR(30);
vFILPAI CHAR(3);
vSEQPAI CHAR(10);
vORDEM  Numeric(5);
DUMMY VARCHAR(10);
BEGIN
   IF PORICTA = 'E' THEN
       SELECT ORDECT, FILECT, SEQECT
         INTO vORDEM, vFILPAI, vSEQPAI
         FROM TT_ECT
        WHERE CODFIL = PCODFIL
          AND SEQUEN = PSEQUEN;

       IF (vFILPAI IS NOT NULL) AND (vSEQPAI IS NOT NULL) THEN
           IF INSTR(CODIGO_CONTA(vFILPAI, vSEQPAI, 'E')||'.','.',1,3) > 0 THEN
               RETURN CODIGO_CONTA(vFILPAI, vSEQPAI, 'E')||'.'||LPAD(to_char(vORDEM),2,'0');
           ELSE
               RETURN CODIGO_CONTA(vFILPAI, vSEQPAI, 'E')||'.'||vORDEM;
           END IF;
       ELSE
           RETURN TO_CHAR(vORDEM);
       END IF;
   ELSE
       SELECT ORDCTA, FILECT, SEQECT
         INTO vORDEM, vFILPAI, vSEQPAI
         FROM TT_CTA
        WHERE CODFIL = PCODFIL
          AND SEQUEN = PSEQUEN;

      RETURN CODIGO_CONTA(vFILPAI, vSEQPAI, 'E')||'.'||LPAD(to_char(vORDEM),4,'0');

   END IF;
END;
$$ language 'plpgsql';





/*-- SEQ 0245 --*/
/*-- IGNORE ERRO --*/
SELECT * FROM NADA;

-- RFMP 99046
-- Job foi criado para o projeto de Classificao ABC e XYZ. Porm, percebeu-se que 
-- o NUMVEN que ele calcula serve apenas quando contabilizamos as vendas por movimentao de estoque
-- (Nota e Remessa).
-- E para o projeto era necessrio contabilizar pelo financeiro (Nota e Fatura).
-- Alm disso, o job causava dead lock no cliente.
/*
  <BEGINFUNCTION('ContarNumeroVendas','VARCHAR',[''],[''],[''])>

   cMANUT                        TT_IDF.MANUT%TYPE;
   cComplemento                  CONSTANT VARCHAR(254) := Constante('complemento');
   v_DIAS_NUMVEN                 TT_CFG.DIAS_NUMVEN%TYPE;
   v_ULTNUMVEN                   TD_FIL.ULTNUMVEN%TYPE;
   d_DATINI                      Timestamp;
   d_DATFIM                      Timestamp;
   v_DATMOV                      TR_MOV.DATMOV%TYPE;
   v_CODFIL                      TR_MOV.CODFIL%TYPE;

-- Objetivos:
-- 1. Atualiza numero de vendas [TR_MOV.NUMVEN].
-- 2. Atualiza coluna de controle [TD_FIL.ULTNUMVEN].

   CR_RetornaDataVenda CURSOR(pDataInicial Timestamp,
           pDataFinal Timestamp) IS
    SELECT *
      FROM ( SELECT TRUNC(VEN_DATHOR) AS DATMOV
               FROM TT_IVE IVE
              WHERE IVE.DATINC >= pDataInicial
                AND IVE.DATINC <= pDataFinal
                AND IVE.SITMOV = 'N'
              UNION
             SELECT TRUNC(VEN.DATHOR) AS DATMOV
               FROM TT_VEN VEN
              WHERE VEN.ATU_EM >= pDataInicial
                AND VEN.ATU_EM <= pDataFinal
                AND VEN.FLGEST = 'C'
            ) TAB
   ORDER BY TAB.DATMOV;

   CR_Filiais CURSOR FOR
   SELECT CODFIL
     FROM TD_FIL
    ORDER BY CODFIL;

-- Inicio da Funcao
BEGIN

  SELECT MANUT INTO cMANUT
    FROM TT_IDF;

  IF cMANUT = 'T' THEN
     RAISE EXCEPTION 'PG-20010 Base em manutencao %' , cComplemento;
  END IF;

  SELECT COALESCE(DIAS_NUMVEN,0) INTO v_DIAS_NUMVEN
    FROM TT_CFG;

  SELECT MIN(ULTNUMVEN)
    INTO v_ULTNUMVEN
    FROM TD_FIL;

  d_DATINI := LEAST(v_ULTNUMVEN, ADD_DAY(TRUNC(AGORA()), v_DIAS_NUMVEN*-1));
  d_DATFIM := TRUNC(Agora());

  OPEN CR_RetornaDataVenda(d_DATINI, d_DATFIM);
  LOOP
    --FETCH CR_RetornaDataVenda INTO v_DATMOV, v_CODFIL;
    FETCH CR_RetornaDataVenda INTO v_DATMOV;
    EXIT WHEN NOT FOUND;

      OPEN CR_Filiais;
      LOOP
        FETCH CR_Filiais INTO v_CODFIL;
        EXIT WHEN NOT FOUND;

          -- RFMP Ao modificar esse update, verificar tambm ATUALIZAMOV
          UPDATE TR_MOV MOV
             SET NUMVEN = (SELECT COUNT( DISTINCT IVE.SEQUEN )
                             FROM TT_IVE IVE INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL
                                                                  AND VEN.SEQUEN = IVE.SEQUEN
                            WHERE IVE.VEN_DATHOR >= MOV.DATMOV
                              AND IVE.VEN_DATHOR <= ADD_DAY(MOV.DATMOV,1)
                              AND IVE.CODFIL = MOV.CODFIL
                              AND IVE.FILMAT = MOV.FILMAT
                              AND IVE.CODMAT = MOV.CODMAT
                              AND IVE.CODCOR = MOV.CODCOR
                              AND IVE.CODTAM = MOV.CODTAM
                              AND IVE.LANEST IN ('S','C')
                              AND IVE.SITKIT IN ('2','3')
                              AND IVE.SITMOV = 'N'
                              AND VEN.LANVEN = 'T'
                              AND VEN.NUMNOT NOT LIKE '%#%')
           WHERE MOV.CODFIL = v_CODFIL
             AND MOV.CODMUL = 0
             AND MOV.DATMOV = v_DATMOV
             AND COALESCE(MOV.QTDVEN,0) <> 0;

      END LOOP;
      CLOSE CR_Filiais;

  END LOOP;
  CLOSE CR_RetornaDataVenda;

  UPDATE TD_FIL
     SET ULTNUMVEN = d_DATFIM;

  RETURN 'OK';

  <ENDFUNCTION('ContarNumeroVendas','VARCHAR',[''],[''])>  

  <BEGINPROCEDURE('JOB_CONTARNUMEROVENDAS',[''],[''],[''])>  
  vNOME TT_JOB.NOMJOB%TYPE;
  vDESC TT_JOB.DESJOB%TYPE;
  dummy VARCHAR(100);
BEGIN
  vNOME := 'JOB_CONTARNUMEROVENDAS';
  vDESC := 'Rotina para contar numero de vendas.';
  BEGIN
    DUMMY := ContarNumeroVendas();
    DUMMY := RegistraJob(vNOME,vDESC);
  EXCEPTION
    WHEN OTHERS THEN DUMMY := RegistraJob(vNOME,vDESC,SQLERRM);
  END;
  <ENDPROCEDURE('JOB_CONTARNUMEROVENDAS',[''],[''])>
*/


/*-- SEQ 0246 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaRTF (TT_PRO.OBSERV%TYPE,TT_PRO.OBSERV%TYPE) CASCADE;

/*-- SEQ 0247 --*/
CREATE OR REPLACE FUNCTION ConcatenaRTF (TT_PRO.OBSERV%TYPE,TT_PRO.OBSERV%TYPE)
RETURNS VARCHAR AS $$
DECLARE
POLDVALUE ALIAS FOR $1 ;
PNEWVALUE ALIAS FOR $2 ;
  vLOG_n  TT_PRO.OBSERV%TYPE;
  vLOG_o  TT_PRO.OBSERV%TYPE;
  vLOG_t  TT_PRO.OBSERV%TYPE;
BEGIN
  vLOG_o:= REPLACE(POLDVALUE,'{'||chr(92)||'rtf1'||chr(92)||'ansi'||chr(92)||'ansicpg1252'||chr(92)||'deff0','');
  vLOG_o:= REPLACE(vLOG_o,'{'||chr(92)||'rtf1'||chr(92)||'ansi'||chr(92)||'deff0','');
  vLOG_o:= SUBSTR(vLOG_o,1,Length(vLOG_o)-3);
  vLOG_n:= REPLACE(PNEWVALUE,'{'||chr(92)||'rtf1'||chr(92)||'ansi'||chr(92)||'ansicpg1252'||chr(92)||'deff0','');
  vLOG_n:= REPLACE(vLOG_n,'{'||chr(92)||'rtf1'||chr(92)||'ansi'||chr(92)||'deff0','');      
  vLOG_n:= SUBSTR(vLOG_n,1,Length(vLOG_n)-3); 
  vLOG_t:= 'Observacao de:  '||vLOG_o||' para:  '||vLOG_n;
  RETURN '{'||chr(92)||'rtf1'||chr(92)||'ansi'||chr(92)||'ansicpg1252'||chr(92)||'deff0'||vLOG_t||'}';
  
END;
$$ language 'plpgsql';




/*-- SEQ 0248 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaUID (TT_UID.CODUID%TYPE,TT_UID.USEROS%TYPE,TT_UID.DATOPE%TYPE,TT_UID.NOMMAQ%TYPE,TT_UID.VERBAS%TYPE,TT_UID.VERSIS%TYPE,TT_UID.NOMSIS%TYPE,TT_UID.SESSION_ID%TYPE) CASCADE;

/*-- SEQ 0249 --*/
CREATE OR REPLACE FUNCTION ConcatenaUID (TT_UID.CODUID%TYPE,TT_UID.USEROS%TYPE,TT_UID.DATOPE%TYPE,TT_UID.NOMMAQ%TYPE,TT_UID.VERBAS%TYPE,TT_UID.VERSIS%TYPE,TT_UID.NOMSIS%TYPE,TT_UID.SESSION_ID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODUID ALIAS FOR $1 ;
pUSEROS ALIAS FOR $2 ;
pDATOPE ALIAS FOR $3 ;
pNOMMAQ ALIAS FOR $4 ;
pVERBAS ALIAS FOR $5 ;
pVERSIS ALIAS FOR $6 ;
pNOMSIS ALIAS FOR $7 ;
pSESSION_ID ALIAS FOR $8 ;
BEGIN
  RETURN TO_CHAR(Num2ChrAssina(pCODUID))||
         Chr2ChrAssina(pUSEROS)||
         Dat2ChrAssina(pDATOPE)||
         Chr2ChrAssina(pNOMMAQ)||
         TO_CHAR(Num2ChrAssina(pVERBAS))||
         Chr2ChrAssina(pVERSIS)||
         Chr2ChrAssina(pNOMSIS)||
         TO_CHAR(Num2ChrAssina(pSESSION_ID));
END;
$$ language 'plpgsql';



/*-- SEQ 0250 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaDECF (TD_ECF.FILECF%TYPE,TD_ECF.NUMECF%TYPE,TD_ECF.SERECF%TYPE,TD_ECF.ECFMFA%TYPE,TD_ECF.ECFTIP%TYPE,TD_ECF.MARECF%TYPE,TD_ECF.MODECF%TYPE,TD_ECF.VSWECF%TYPE,TD_ECF.DSWECF%TYPE,TD_ECF.CODORI%TYPE) CASCADE;

/*-- SEQ 0251 --*/
CREATE OR REPLACE FUNCTION ConcatenaDECF (TD_ECF.FILECF%TYPE,TD_ECF.NUMECF%TYPE,TD_ECF.SERECF%TYPE,TD_ECF.ECFMFA%TYPE,TD_ECF.ECFTIP%TYPE,TD_ECF.MARECF%TYPE,TD_ECF.MODECF%TYPE,TD_ECF.VSWECF%TYPE,TD_ECF.DSWECF%TYPE,TD_ECF.CODORI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILECF ALIAS FOR $1 ;
pNUMECF ALIAS FOR $2 ;
pSERECF ALIAS FOR $3 ;
pECFMFA ALIAS FOR $4 ;
pECFTIP ALIAS FOR $5 ;
pMARECF ALIAS FOR $6 ;
pMODECF ALIAS FOR $7 ;
pVSWECF ALIAS FOR $8 ;
pDSWECF ALIAS FOR $9 ;
pCODORI ALIAS FOR $10 ;
BEGIN
  RETURN Chr2ChrAssina(pFILECF)||
         Chr2ChrAssina(pNUMECF)||
         Chr2ChrAssina(pSERECF)||
         Chr2ChrAssina(pECFMFA)||
         Chr2ChrAssina(pECFTIP)||
         Chr2ChrAssina(pMARECF)||
         Chr2ChrAssina(pMODECF)||
         Chr2ChrAssina(pVSWECF)||
         Dat2ChrAssina(pDSWECF)||
         Chr2ChrAssina(pCODORI);
END;
$$ language 'plpgsql';



/*-- SEQ 0252 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaECF (TT_ECF.CODFIL%TYPE,TT_ECF.NUMECF%TYPE,TT_ECF.DATOPE%TYPE,TT_ECF.TOTALI%TYPE,TT_ECF.TIPTOT%TYPE,TT_ECF.TOTPAR%TYPE,TT_ECF.CNT_RZ%TYPE,TT_ECF.VLRTOT%TYPE,TT_ECF.VLRBAS%TYPE) CASCADE;

/*-- SEQ 0253 --*/
CREATE OR REPLACE FUNCTION ConcatenaECF (TT_ECF.CODFIL%TYPE,TT_ECF.NUMECF%TYPE,TT_ECF.DATOPE%TYPE,TT_ECF.TOTALI%TYPE,TT_ECF.TIPTOT%TYPE,TT_ECF.TOTPAR%TYPE,TT_ECF.CNT_RZ%TYPE,TT_ECF.VLRTOT%TYPE,TT_ECF.VLRBAS%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pNUMECF ALIAS FOR $2 ;
pDATOPE ALIAS FOR $3 ;
pTOTALI ALIAS FOR $4 ;
pTIPTOT ALIAS FOR $5 ;
pTOTPAR ALIAS FOR $6 ;
pCNT_RZ ALIAS FOR $7 ;
pVLRTOT ALIAS FOR $8 ;
pVLRBAS ALIAS FOR $9 ;
BEGIN
  RETURN Chr2ChrAssina(pCODFIL)||
         Chr2ChrAssina(pNUMECF)||
         Dat2ChrAssina(pDATOPE)||
         Chr2ChrAssina(pTOTALI)||
         Chr2ChrAssina(pTIPTOT)||
         Chr2ChrAssina(pTOTPAR)||
         TO_CHAR(Num2ChrAssina(pCNT_RZ))||
         NumDec2ChrAssina(pVLRTOT)||
         NumDec2ChrAssina(pVLRBAS);
END;
$$ language 'plpgsql';



/*-- SEQ 0254 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaRECF (TR_ECF.CODFIL%TYPE,TR_ECF.NUMECF%TYPE,TR_ECF.DATOPE%TYPE,TR_ECF.CNT_RO%TYPE,TR_ECF.CNT_RZ%TYPE,TR_ECF.INTERV%TYPE,TR_ECF.CUPFIM%TYPE,TR_ECF.DATOPE_PAF%TYPE,TR_ECF.DATFEC%TYPE,TR_ECF.GT_FIM%TYPE,TR_ECF.GT_INI%TYPE) CASCADE;

/*-- SEQ 0255 --*/
CREATE OR REPLACE FUNCTION ConcatenaRECF (TR_ECF.CODFIL%TYPE,TR_ECF.NUMECF%TYPE,TR_ECF.DATOPE%TYPE,TR_ECF.CNT_RO%TYPE,TR_ECF.CNT_RZ%TYPE,TR_ECF.INTERV%TYPE,TR_ECF.CUPFIM%TYPE,TR_ECF.DATOPE_PAF%TYPE,TR_ECF.DATFEC%TYPE,TR_ECF.GT_FIM%TYPE,TR_ECF.GT_INI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pNUMECF ALIAS FOR $2 ;
pDATOPE ALIAS FOR $3 ;
pCNT_RO ALIAS FOR $4 ;
pCNT_RZ ALIAS FOR $5 ;
pINTERV ALIAS FOR $6 ;
pCUPFIM ALIAS FOR $7 ;
pDATOPE_PAF ALIAS FOR $8 ;
pDATFEC ALIAS FOR $9 ;
pGT_FIM ALIAS FOR $10 ;
pGT_INI ALIAS FOR $11 ;
BEGIN
  RETURN Chr2ChrAssina(pCODFIL)||
         Chr2ChrAssina(pNUMECF)||
         Dat2ChrAssina(pDATOPE)||
         TO_CHAR(Num2ChrAssina(pCNT_RO))||
         TO_CHAR(Num2ChrAssina(pCNT_RZ))||
         TO_CHAR(Num2ChrAssina(pINTERV))||
         TO_CHAR(Num2ChrAssina(pCUPFIM))||
         Dat2ChrAssina(pDATOPE_PAF)||
         Dat2ChrAssina(pDATFEC)||
         NumDec2ChrAssina(pGT_FIM)||
         NumDec2ChrAssina(pGT_INI);
END;
$$ language 'plpgsql';



/*-- SEQ 0256 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaLID (TT_LID.CODFIL%TYPE,TT_LID.NUMECF%TYPE,TT_LID.TRN_ID%TYPE,TT_LID.CONCCF%TYPE,TT_LID.CONCOO%TYPE,TT_LID.CONGNF%TYPE,TT_LID.CONCDC%TYPE,TT_LID.TIPDOC%TYPE,TT_LID.DATHOR%TYPE,TT_LID.CONGRG%TYPE,TT_LID.DATFIS%TYPE) CASCADE;

/*-- SEQ 0257 --*/
CREATE OR REPLACE FUNCTION ConcatenaLID (TT_LID.CODFIL%TYPE,TT_LID.NUMECF%TYPE,TT_LID.TRN_ID%TYPE,TT_LID.CONCCF%TYPE,TT_LID.CONCOO%TYPE,TT_LID.CONGNF%TYPE,TT_LID.CONCDC%TYPE,TT_LID.TIPDOC%TYPE,TT_LID.DATHOR%TYPE,TT_LID.CONGRG%TYPE,TT_LID.DATFIS%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pNUMECF ALIAS FOR $2 ;
pTRN_ID ALIAS FOR $3 ;
pCONCCF ALIAS FOR $4 ;
pCONCOO ALIAS FOR $5 ;
pCONGNF ALIAS FOR $6 ;
pCONCDC ALIAS FOR $7 ;
pTIPDOC ALIAS FOR $8 ;
pDATHOR ALIAS FOR $9 ;
pCONGRG ALIAS FOR $10 ;
pDATFIS ALIAS FOR $11 ;
BEGIN
  RETURN Chr2ChrAssina(pCODFIL)||
         Chr2ChrAssina(pNUMECF)||
         TO_CHAR(BigNum2ChrAssina(pTRN_ID))||
         TO_CHAR(Num2ChrAssina(pCONCCF))||
         TO_CHAR(Num2ChrAssina(pCONCOO))||
         TO_CHAR(Num2ChrAssina(pCONGNF))||
         TO_CHAR(Num2ChrAssina(pCONCDC))||
         Chr2ChrAssina(pTIPDOC)||
         Dat2ChrAssina(pDATHOR)||
         TO_CHAR(Num2ChrAssina(pCONGRG))||
         Dat2ChrAssina(pDATFIS);
END;
$$ language 'plpgsql';



/*-- SEQ 0258 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaVEN (TT_VEN.CODFIL%TYPE,TT_VEN.NUMECF%TYPE,TT_VEN.CODSER%TYPE,TT_VEN.NUMNOT%TYPE,TT_VEN.CNT_RO%TYPE,TT_VEN.VLRLIQ%TYPE,TT_VEN.FLGEST%TYPE,TT_VEN.SEREXT%TYPE,TT_VEN.MODNOT%TYPE,TT_VEN.CHAVEA%TYPE,TT_VEN.FILUSU%TYPE,TT_VEN.CODUSU%TYPE,TT_VEN.VLRNOT%TYPE,TT_VEN.DOCNFP%TYPE,TT_VEN.DATHOR%TYPE,TT_VEN.NOTMAN%TYPE) CASCADE;

/*-- SEQ 0259 --*/
CREATE OR REPLACE FUNCTION ConcatenaVEN (TT_VEN.CODFIL%TYPE,TT_VEN.NUMECF%TYPE,TT_VEN.CODSER%TYPE,TT_VEN.NUMNOT%TYPE,TT_VEN.CNT_RO%TYPE,TT_VEN.VLRLIQ%TYPE,TT_VEN.FLGEST%TYPE,TT_VEN.SEREXT%TYPE,TT_VEN.MODNOT%TYPE,TT_VEN.CHAVEA%TYPE,TT_VEN.FILUSU%TYPE,TT_VEN.CODUSU%TYPE,TT_VEN.VLRNOT%TYPE,TT_VEN.DOCNFP%TYPE,TT_VEN.DATHOR%TYPE,TT_VEN.NOTMAN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pNUMECF ALIAS FOR $2 ;
pCODSER ALIAS FOR $3 ;
pNUMNOT ALIAS FOR $4 ;
pCNT_RO ALIAS FOR $5 ;
pVLRLIQ ALIAS FOR $6 ;
pFLGEST ALIAS FOR $7 ;
pSEREXT ALIAS FOR $8 ;
pMODNOT ALIAS FOR $9 ;
pCHAVEA ALIAS FOR $10 ;
pFILUSU ALIAS FOR $11 ;
pCODUSU ALIAS FOR $12 ;
pVLRNOT ALIAS FOR $13 ;
pDOCNFP ALIAS FOR $14 ;
pDATHOR ALIAS FOR $15 ;
pNOTMAN ALIAS FOR $16 ;
BEGIN
  RETURN Chr2ChrAssina(pCODFIL)||
         Chr2ChrAssina(pNUMECF)||
         Chr2ChrAssina(pCODSER)||
         Chr2ChrAssina(pNUMNOT)||
         TO_CHAR(Num2ChrAssina(pCNT_RO))||
         NumDec2ChrAssina(pVLRLIQ)||
         Chr2ChrAssina(pFLGEST)||
         Chr2ChrAssina(pSEREXT)||
         Chr2ChrAssina(pMODNOT)||
         Chr2ChrAssina(pCHAVEA)||
         Chr2ChrAssina(pFILUSU)||
         Chr2ChrAssina(pCODUSU)||
         NumDec2ChrAssina(pVLRNOT)||
         Chr2ChrAssina(pDOCNFP)||
         Dat2ChrAssina(pDATHOR)||
         Chr2ChrAssina(pNOTMAN);
END;
$$ language 'plpgsql';



/*-- SEQ 0260 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaIVE (TT_IVE.VEN_DATHOR%TYPE,TT_IVE.NUMITE%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE,TT_IVE.QTDMOV%TYPE,TT_IVE.VLRORI%TYPE,TT_IVE.VLRMOV%TYPE,TT_IVE.TIPPRO%TYPE,TT_IVE.ICMTIP%TYPE,TT_IVE.TAX001%TYPE,TT_IVE.SITMOV%TYPE,TT_IVE.VLRDES%TYPE) CASCADE;

/*-- SEQ 0261 --*/
CREATE OR REPLACE FUNCTION ConcatenaIVE (TT_IVE.VEN_DATHOR%TYPE,TT_IVE.NUMITE%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE,TT_IVE.QTDMOV%TYPE,TT_IVE.VLRORI%TYPE,TT_IVE.VLRMOV%TYPE,TT_IVE.TIPPRO%TYPE,TT_IVE.ICMTIP%TYPE,TT_IVE.TAX001%TYPE,TT_IVE.SITMOV%TYPE,TT_IVE.VLRDES%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pVEN_DATHOR ALIAS FOR $1 ;
pNUMITE ALIAS FOR $2 ;
pFILMAT ALIAS FOR $3 ;
pCODMAT ALIAS FOR $4 ;
pCODCOR ALIAS FOR $5 ;
pCODTAM ALIAS FOR $6 ;
pQTDMOV ALIAS FOR $7 ;
pVLRORI ALIAS FOR $8 ;
pVLRMOV ALIAS FOR $9 ;
pTIPPRO ALIAS FOR $10 ;
pICMTIP ALIAS FOR $11 ;
pTAX001 ALIAS FOR $12 ;
pSITMOV ALIAS FOR $13 ;
pVLRDES ALIAS FOR $14 ;
BEGIN
  RETURN Dat2ChrAssina(pVEN_DATHOR)||
         TO_CHAR(Num2ChrAssina(pNUMITE))||
         Chr2ChrAssina(pFILMAT)||
         Chr2ChrAssina(pCODMAT)||
         TO_CHAR(Num2ChrAssina(pCODCOR))||
         TO_CHAR(Num2ChrAssina(pCODTAM))||
         NumDec2ChrAssina(pQTDMOV)||
         NumDec2ChrAssina(pVLRORI)||
         NumDec2ChrAssina(pVLRMOV)||
         Chr2ChrAssina(pTIPPRO)||
         Chr2ChrAssina(pICMTIP)||
         NumDec2ChrAssina(pTAX001)||
         Chr2ChrAssina(pSITMOV)||
         NumDec2ChrAssina(pVLRDES);
END;
$$ language 'plpgsql';



/*-- SEQ 0262 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaORC (TT_ORC.CODFIL%TYPE,TT_ORC.TIPPED%TYPE,TT_ORC.NUMPED%TYPE,TT_ORC.NUMPED_PAF%TYPE,TT_ORC.PED_EM%TYPE,TT_ORC.VLRTOT%TYPE,TT_ORC.CODEMP%TYPE,TT_ORC.COOORC%TYPE,TT_ORC.NUMECF%TYPE) CASCADE;

/*-- SEQ 0263 --*/
CREATE OR REPLACE FUNCTION ConcatenaORC (TT_ORC.CODFIL%TYPE,TT_ORC.TIPPED%TYPE,TT_ORC.NUMPED%TYPE,TT_ORC.NUMPED_PAF%TYPE,TT_ORC.PED_EM%TYPE,TT_ORC.VLRTOT%TYPE,TT_ORC.CODEMP%TYPE,TT_ORC.COOORC%TYPE,TT_ORC.NUMECF%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pTIPPED ALIAS FOR $2 ;
pNUMPED ALIAS FOR $3 ;
pNUMPED_PAF ALIAS FOR $4 ;
pPED_EM ALIAS FOR $5 ;
pVLRTOT ALIAS FOR $6 ;
pCODEMP ALIAS FOR $7 ;
pCOOORC ALIAS FOR $8 ;
pNUMECF ALIAS FOR $9 ;
BEGIN
  RETURN Chr2ChrAssina(pCODFIL)||
         Chr2ChrAssina(pTIPPED)||
         Chr2ChrAssina(pNUMPED)||
         Chr2ChrAssina(pNUMPED_PAF)||
         Dat2ChrAssina(pPED_EM)||
         NumDec2ChrAssina(pVLRTOT)||
         TO_CHAR(Num2ChrAssina(pCODEMP))||
         TO_CHAR(Num2ChrAssina(pCOOORC))||
         Chr2ChrAssina(pNUMECF);
END;
$$ language 'plpgsql';



/*-- SEQ 0264 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaIOR (TT_IOR.CODFIL%TYPE,TT_IOR.TIPPED%TYPE,TT_IOR.NUMPED%TYPE,TT_IOR.NUMITE%TYPE,TT_IOR.COOVEN%TYPE,TT_IOR.ECFVEN%TYPE,TT_IOR.QTDITE%TYPE,TT_IOR.VLRITE%TYPE,TT_IOR.DESCON%TYPE,TT_IOR.VLRPGT%TYPE,TT_IOR.FLGEST%TYPE,TT_IOR.NUMITE_PAF%TYPE,TT_IOR.FLGEST_PAF%TYPE,TT_IOR.DATINC%TYPE) CASCADE;

/*-- SEQ 0265 --*/
CREATE OR REPLACE FUNCTION ConcatenaIOR (TT_IOR.CODFIL%TYPE,TT_IOR.TIPPED%TYPE,TT_IOR.NUMPED%TYPE,TT_IOR.NUMITE%TYPE,TT_IOR.COOVEN%TYPE,TT_IOR.ECFVEN%TYPE,TT_IOR.QTDITE%TYPE,TT_IOR.VLRITE%TYPE,TT_IOR.DESCON%TYPE,TT_IOR.VLRPGT%TYPE,TT_IOR.FLGEST%TYPE,TT_IOR.NUMITE_PAF%TYPE,TT_IOR.FLGEST_PAF%TYPE,TT_IOR.DATINC%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pTIPPED ALIAS FOR $2 ;
pNUMPED ALIAS FOR $3 ;
pNUMITE ALIAS FOR $4 ;
pCOOVEN ALIAS FOR $5 ;
pECFVEN ALIAS FOR $6 ;
pQTDITE ALIAS FOR $7 ;
pVLRITE ALIAS FOR $8 ;
pDESCON ALIAS FOR $9 ;
pVLRPGT ALIAS FOR $10 ;
pFLGEST ALIAS FOR $11 ;
pNUMITE_PAF ALIAS FOR $12 ;
pFLGEST_PAF ALIAS FOR $13 ;
pDATINC ALIAS FOR $14 ;
BEGIN
  RETURN Chr2ChrAssina(pCODFIL)||
         Chr2ChrAssina(pTIPPED)||
         Chr2ChrAssina(pNUMPED)||
         TO_CHAR(Num2ChrAssina(pNUMITE))||
         Chr2ChrAssina(pCOOVEN)||
         Chr2ChrAssina(pECFVEN)||
         NumDec2ChrAssina(pQTDITE)||
         NumDec2ChrAssina(pVLRITE)||
         NumDec2ChrAssina(pDESCON)||
         NumDec2ChrAssina(pVLRPGT)||
         Chr2ChrAssina(pFLGEST)||
         TO_CHAR(Num2ChrAssina(pNUMITE_PAF))||
         Chr2ChrAssina(pFLGEST_PAF)||
         Dat2ChrAssina(pDATINC);
END;
$$ language 'plpgsql';



/*-- SEQ 0266 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaLIOR (TL_IOR_PAF.CODFIL%TYPE,TL_IOR_PAF.TIPPED%TYPE,TL_IOR_PAF.NUMPED%TYPE,TL_IOR_PAF.NUMITE%TYPE,TL_IOR_PAF.TIPLOG%TYPE,TL_IOR_PAF.INDCAN%TYPE,TL_IOR_PAF.QTDITE%TYPE,TL_IOR_PAF.VLRITE%TYPE,TL_IOR_PAF.DESCON%TYPE,TL_IOR_PAF.VLRPGT%TYPE,TL_IOR_PAF.DATOPE%TYPE) CASCADE;

/*-- SEQ 0267 --*/
CREATE OR REPLACE FUNCTION ConcatenaLIOR (TL_IOR_PAF.CODFIL%TYPE,TL_IOR_PAF.TIPPED%TYPE,TL_IOR_PAF.NUMPED%TYPE,TL_IOR_PAF.NUMITE%TYPE,TL_IOR_PAF.TIPLOG%TYPE,TL_IOR_PAF.INDCAN%TYPE,TL_IOR_PAF.QTDITE%TYPE,TL_IOR_PAF.VLRITE%TYPE,TL_IOR_PAF.DESCON%TYPE,TL_IOR_PAF.VLRPGT%TYPE,TL_IOR_PAF.DATOPE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pTIPPED ALIAS FOR $2 ;
pNUMPED ALIAS FOR $3 ;
pNUMITE ALIAS FOR $4 ;
pTIPLOG ALIAS FOR $5 ;
pINDCAN ALIAS FOR $6 ;
pQTDITE ALIAS FOR $7 ;
pVLRITE ALIAS FOR $8 ;
pDESCON ALIAS FOR $9 ;
pVLRPGT ALIAS FOR $10 ;
pDT_ALT ALIAS FOR $11 ;
BEGIN
  RETURN Chr2ChrAssina(pCODFIL)||
         Chr2ChrAssina(pTIPPED)||
         Chr2ChrAssina(pNUMPED)||
         TO_CHAR(Num2ChrAssina(pNUMITE))||
         Chr2ChrAssina(pTIPLOG)||
         Chr2ChrAssina(pINDCAN)||
         NumDec2ChrAssina(pQTDITE)||
         NumDec2ChrAssina(pVLRITE)||
         NumDec2ChrAssina(pDESCON)||
         NumDec2ChrAssina(pVLRPGT)||
         Dat2ChrAssina(pDT_ALT);
END;
$$ language 'plpgsql';



/*-- SEQ 0268 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaPRE (TT_PRE.FILPRE%TYPE,TT_PRE.CODPRE%TYPE,TT_PRE.FILMAT%TYPE,TT_PRE.CODMAT%TYPE,TT_PRE.CODCOR%TYPE,TT_PRE.CODTAM%TYPE,TT_PRE.PRECOV%TYPE) CASCADE;

/*-- SEQ 0269 --*/
CREATE OR REPLACE FUNCTION ConcatenaPRE (TT_PRE.FILPRE%TYPE,TT_PRE.CODPRE%TYPE,TT_PRE.FILMAT%TYPE,TT_PRE.CODMAT%TYPE,TT_PRE.CODCOR%TYPE,TT_PRE.CODTAM%TYPE,TT_PRE.PRECOV%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILPRE ALIAS FOR $1 ;
pCODPRE ALIAS FOR $2 ;
pFILMAT ALIAS FOR $3 ;
pCODMAT ALIAS FOR $4 ;
pCODCOR ALIAS FOR $5 ;
pCODTAM ALIAS FOR $6 ;
pPRECOV ALIAS FOR $7 ;
BEGIN
  RETURN Chr2ChrAssina(pFILPRE)||
         TO_CHAR(Num2ChrAssina(pCODPRE))||
         Chr2ChrAssina(pFILMAT)||
         Chr2ChrAssina(pCODMAT)||
         TO_CHAR(Num2ChrAssina(pCODCOR))||
         TO_CHAR(Num2ChrAssina(pCODTAM))||
         NumDec2ChrAssina(pPRECOV);
END;
$$ language 'plpgsql';



/*-- SEQ 0270 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaDFIL (TD_FIL.CODFIL%TYPE,TD_FIL.DATEST%TYPE,TD_FIL.CGCFIL%TYPE,TD_FIL.IE_FIL%TYPE,TD_FIL.INSMUN%TYPE,TD_FIL.RAZSOC%TYPE) CASCADE;

/*-- SEQ 0271 --*/
CREATE OR REPLACE FUNCTION ConcatenaDFIL (TD_FIL.CODFIL%TYPE,TD_FIL.DATEST%TYPE,TD_FIL.CGCFIL%TYPE,TD_FIL.IE_FIL%TYPE,TD_FIL.INSMUN%TYPE,TD_FIL.RAZSOC%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pDATEST ALIAS FOR $2 ;
pCGCFIL ALIAS FOR $3 ;
pIE_FIL ALIAS FOR $4 ;
pINSMUN ALIAS FOR $5 ;
pRAZSOC ALIAS FOR $6 ;
BEGIN
  RETURN Chr2ChrAssina(pCODFIL)||
         Dat2ChrAssina(pDATEST)||
         Chr2ChrAssina(pCGCFIL)||
         Chr2ChrAssina(pIE_FIL)||
         Chr2ChrAssina(pINSMUN)||
         Chr2ChrAssina(pRAZSOC);
END;
$$ language 'plpgsql';



/*-- SEQ 0272 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaSAL (TT_SAL.CODFIL%TYPE,TT_SAL.SEQUEN%TYPE,TT_SAL.QTDEST%TYPE) CASCADE;

/*-- SEQ 0273 --*/
CREATE OR REPLACE FUNCTION ConcatenaSAL (TT_SAL.CODFIL%TYPE,TT_SAL.SEQUEN%TYPE,TT_SAL.QTDEST%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pQTDEST ALIAS FOR $3 ;
BEGIN
  RETURN Chr2ChrAssina(pCODFIL)||
         Chr2ChrAssina(pSEQUEN)||
		 NumDec2ChrAssina(pQTDEST);
END;
$$ language 'plpgsql';



/*-- SEQ 0274 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaPRO (TT_PRO.FILMAT%TYPE,TT_PRO.CODMAT%TYPE,TT_PRO.DESMAT%TYPE,TT_PRO.ARRTRU%TYPE,TT_PRO.IIPTPR%TYPE,TT_PRO.TIPPRO%TYPE) CASCADE;

/*-- SEQ 0275 --*/
CREATE OR REPLACE FUNCTION ConcatenaPRO (TT_PRO.FILMAT%TYPE,TT_PRO.CODMAT%TYPE,TT_PRO.DESMAT%TYPE,TT_PRO.ARRTRU%TYPE,TT_PRO.IIPTPR%TYPE,TT_PRO.TIPPRO%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILMAT ALIAS FOR $1 ;
pCODMAT ALIAS FOR $2 ;
pDESMAT ALIAS FOR $3 ;
pARRTRU ALIAS FOR $4 ;
pIIPTPR ALIAS FOR $5 ;
pTIPPRO ALIAS FOR $6 ;
BEGIN
  RETURN Chr2ChrAssina(pFILMAT)||
         Chr2ChrAssina(pCODMAT)||
         Chr2ChrAssina(pDESMAT)||
         Chr2ChrAssina(pARRTRU)||
         Chr2ChrAssina(pIIPTPR)||
         TO_CHAR(Num2ChrAssina(pTIPPRO));
END;
$$ language 'plpgsql';



/*-- SEQ 0276 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaGRA (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_GRA.REFPRO%TYPE,TT_GRA.CODFIS%TYPE) CASCADE;

/*-- SEQ 0277 --*/
CREATE OR REPLACE FUNCTION ConcatenaGRA (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_GRA.REFPRO%TYPE,TT_GRA.CODFIS%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILMAT ALIAS FOR $1 ;
pCODMAT ALIAS FOR $2 ;
pCODCOR ALIAS FOR $3 ;
pCODTAM ALIAS FOR $4 ;
pREFPRO ALIAS FOR $5 ;
pCODFIS ALIAS FOR $6 ;
BEGIN
  RETURN Chr2ChrAssina(pFILMAT)||
         Chr2ChrAssina(pCODMAT)||
         TO_CHAR(Num2ChrAssina(pCODCOR))||
         TO_CHAR(Num2ChrAssina(pCODTAM))||
         Chr2ChrAssina(pREFPRO)||
         Chr2ChrAssina(pCODFIS);
END;
$$ language 'plpgsql';



/*-- SEQ 0278 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaDICM (TD_ICM.CODTAB%TYPE,TD_ICM.RESICM%TYPE) CASCADE;

/*-- SEQ 0279 --*/
CREATE OR REPLACE FUNCTION ConcatenaDICM (TD_ICM.CODTAB%TYPE,TD_ICM.RESICM%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODTAB ALIAS FOR $1 ;
pRESICM ALIAS FOR $2 ;
BEGIN
  RETURN TO_CHAR(Num2ChrAssina(pCODTAB))||
		 NumDec2ChrAssina(pRESICM);
END;
$$ language 'plpgsql';



/*-- SEQ 0280 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaIUF (TT_IUF.FILMAT%TYPE,TT_IUF.CODMAT%TYPE,TT_IUF.ESTADO%TYPE,TT_IUF.REGESP%TYPE,TT_IUF.SUBTRI%TYPE,TT_IUF.RESICM%TYPE) CASCADE;

/*-- SEQ 0281 --*/
CREATE OR REPLACE FUNCTION ConcatenaIUF (TT_IUF.FILMAT%TYPE,TT_IUF.CODMAT%TYPE,TT_IUF.ESTADO%TYPE,TT_IUF.REGESP%TYPE,TT_IUF.SUBTRI%TYPE,TT_IUF.RESICM%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILMAT ALIAS FOR $1 ;
pCODMAT ALIAS FOR $2 ;
pESTADO ALIAS FOR $3 ;
pREGESP ALIAS FOR $4 ;
pSUBTRI ALIAS FOR $5 ;
pRESICM ALIAS FOR $6 ;
BEGIN
  RETURN Chr2ChrAssina(pFILMAT)||
         Chr2ChrAssina(pCODMAT)||
         Chr2ChrAssina(pESTADO)||
         TO_CHAR(Num2ChrAssina(pREGESP))||
         Chr2ChrAssina(pSUBTRI)||
         TO_CHAR(Num2ChrAssina(pRESICM));
END;
$$ language 'plpgsql';



/*-- SEQ 0282 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaCFG (TT_CFG.CKPAPREDEC%TYPE) CASCADE;

/*-- SEQ 0283 --*/
CREATE OR REPLACE FUNCTION ConcatenaCFG (TT_CFG.CKPAPREDEC%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCKPAPREDEC ALIAS FOR $1 ;
BEGIN
  RETURN TO_CHAR(Num2ChrAssina(pCKPAPREDEC));
END;
$$ language 'plpgsql';



/*-- SEQ 0284 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaDMED (TD_MED.CODTAB%TYPE,TD_MED.UNIMED%TYPE) CASCADE;

/*-- SEQ 0285 --*/
CREATE OR REPLACE FUNCTION ConcatenaDMED (TD_MED.CODTAB%TYPE,TD_MED.UNIMED%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODTAB ALIAS FOR $1 ;
pUNIMED ALIAS FOR $2 ;
BEGIN
  RETURN Chr2ChrAssina(pUNIMED)||
         TO_CHAR(Num2ChrAssina(pCODTAB));
END;
$$ language 'plpgsql';



/*-- SEQ 0286 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaDTAN (TD_TAN.CODTAB%TYPE,TD_TAN.TANQUE%TYPE) CASCADE;

/*-- SEQ 0287 --*/
CREATE OR REPLACE FUNCTION ConcatenaDTAN (TD_TAN.CODTAB%TYPE,TD_TAN.TANQUE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODTAB ALIAS FOR $1 ;
pTANQUE ALIAS FOR $2 ;
BEGIN
  RETURN TO_CHAR(Num2ChrAssina(pTANQUE))||
         TO_CHAR(Num2ChrAssina(pCODTAB));
END;
$$ language 'plpgsql';



/*-- SEQ 0288 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaDBOM (TD_BOM.CODTAB%TYPE,TD_BOM.NUMBOM%TYPE) CASCADE;

/*-- SEQ 0289 --*/
CREATE OR REPLACE FUNCTION ConcatenaDBOM (TD_BOM.CODTAB%TYPE,TD_BOM.NUMBOM%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODTAB ALIAS FOR $1 ;
pNUMBOM ALIAS FOR $2 ;
BEGIN
  RETURN TO_CHAR(Num2ChrAssina(pNUMBOM))||
         TO_CHAR(Num2ChrAssina(pCODTAB));
END;
$$ language 'plpgsql';



/*-- SEQ 0290 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaDBIC (TD_BIC.SEQBOM%TYPE,TD_BIC.SEQFIL%TYPE,TD_BIC.CODTAB%TYPE) CASCADE;

/*-- SEQ 0291 --*/
CREATE OR REPLACE FUNCTION ConcatenaDBIC (TD_BIC.SEQBOM%TYPE,TD_BIC.SEQFIL%TYPE,TD_BIC.CODTAB%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pSEQBOM ALIAS FOR $1 ;
pSEQFIL ALIAS FOR $2 ;
pCODTAB ALIAS FOR $3 ;
BEGIN
  RETURN TO_CHAR(Num2ChrAssina(pSEQBOM))||
         TO_CHAR(Num2ChrAssina(pSEQFIL))||
         TO_CHAR(Num2ChrAssina(pCODTAB));
END;
$$ language 'plpgsql';



/*-- SEQ 0292 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaABA (TT_ABA.CODFIL%TYPE,TT_ABA.CODABA%TYPE,TT_ABA.ENCINI%TYPE,TT_ABA.ENCFIM%TYPE,TT_ABA.FLGEST%TYPE,TT_ABA.CODTAN%TYPE,TT_ABA.CODBOM%TYPE,TT_ABA.CODBIC%TYPE,TT_ABA.VOLABS%TYPE) CASCADE;

/*-- SEQ 0293 --*/
CREATE OR REPLACE FUNCTION ConcatenaABA (TT_ABA.CODFIL%TYPE,TT_ABA.CODABA%TYPE,TT_ABA.ENCINI%TYPE,TT_ABA.ENCFIM%TYPE,TT_ABA.FLGEST%TYPE,TT_ABA.CODTAN%TYPE,TT_ABA.CODBOM%TYPE,TT_ABA.CODBIC%TYPE,TT_ABA.VOLABS%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pCODABA ALIAS FOR $2 ;
pENCINI ALIAS FOR $3 ;
pENCFIM ALIAS FOR $4 ;
pFLGEST ALIAS FOR $5 ;
pCODTAN ALIAS FOR $6 ;
pCODBOM ALIAS FOR $7 ;
pCODBIC ALIAS FOR $8 ;
pVOLABS ALIAS FOR $9 ;
BEGIN
  RETURN Chr2ChrAssina(pCODFIL)||
         Chr2ChrAssina(pCODABA)||
         Chr2ChrAssina(pENCINI)||
         Chr2ChrAssina(pENCFIM)||
         Chr2ChrAssina(pFLGEST)||
         TO_CHAR(Num2ChrAssina(pCODTAN))||
         TO_CHAR(Num2ChrAssina(pCODBOM))||
         TO_CHAR(Num2ChrAssina(pCODBIC))||
         NumDec2ChrAssina(pVOLABS);
END;
$$ language 'plpgsql';



/*-- SEQ 0294 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaASS (TT_ASS.NOMTAB%TYPE,TT_ASS.QTDREG%TYPE) CASCADE;

/*-- SEQ 0295 --*/
CREATE OR REPLACE FUNCTION ConcatenaASS (TT_ASS.NOMTAB%TYPE,TT_ASS.QTDREG%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pNOMTAB ALIAS FOR $1 ;
pQTDREG ALIAS FOR $2 ;
BEGIN
  RETURN Chr2ChrAssina(pNOMTAB)||
         TO_CHAR(Num2ChrAssina(pQTDREG));
END;
$$ language 'plpgsql';



/*-- SEQ 0296 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaCLI (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,TT_CLI.NOMCLI%TYPE,TT_CLI.NUMDOC%TYPE,TT_CLI.ULTNOM%TYPE) CASCADE;

/*-- SEQ 0297 --*/
CREATE OR REPLACE FUNCTION ConcatenaCLI (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,TT_CLI.NOMCLI%TYPE,TT_CLI.NUMDOC%TYPE,TT_CLI.ULTNOM%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILCLI ALIAS FOR $1 ;
pCODCLI ALIAS FOR $2 ;
pNOMCLI ALIAS FOR $3 ;
pNUMDOC ALIAS FOR $4 ;
pULTNOM ALIAS FOR $5 ;
BEGIN
  RETURN Chr2ChrAssina(pFILCLI)||
         Chr2ChrAssina(pCODCLI)||
         Chr2ChrAssina(pNOMCLI)||
         Chr2ChrAssina(pNUMDOC)||
         Chr2ChrAssina(pULTNOM);
END;
$$ language 'plpgsql';



/*-- SEQ 0298 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaEST (TT_EST.CODFIL%TYPE,TT_EST.SEQUEN%TYPE,TT_EST.QTDEST%TYPE) CASCADE;

/*-- SEQ 0299 --*/
CREATE OR REPLACE FUNCTION ConcatenaEST (TT_EST.CODFIL%TYPE,TT_EST.SEQUEN%TYPE,TT_EST.QTDEST%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pQTDEST ALIAS FOR $3 ;
BEGIN
  RETURN Chr2ChrAssina(pCODFIL)||
         Chr2ChrAssina(pSEQUEN)||
         NumDec2ChrAssina(pQTDEST);
END;
$$ language 'plpgsql';



/*-- SEQ 0300 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaIMU (TT_IMU.FILMAT%TYPE,TT_IMU.CODMAT%TYPE,TT_IMU.CODCID%TYPE,TT_IMU.RESISS%TYPE) CASCADE;

/*-- SEQ 0301 --*/
CREATE OR REPLACE FUNCTION ConcatenaIMU (TT_IMU.FILMAT%TYPE,TT_IMU.CODMAT%TYPE,TT_IMU.CODCID%TYPE,TT_IMU.RESISS%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILMAT ALIAS FOR $1 ;
pCODMAT ALIAS FOR $2 ;
pCODCID ALIAS FOR $3 ;
pRESISS ALIAS FOR $4 ;
BEGIN
  RETURN Chr2ChrAssina(pFILMAT)||
         Chr2ChrAssina(pCODMAT)||
         Chr2ChrAssina(pCODCID)||
         TO_CHAR(Num2ChrAssina(pRESISS));
END;
$$ language 'plpgsql';



/*-- SEQ 0302 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaDISS (TD_ISS.CODTAB%TYPE,TD_ISS.RESISS%TYPE) CASCADE;

/*-- SEQ 0303 --*/
CREATE OR REPLACE FUNCTION ConcatenaDISS (TD_ISS.CODTAB%TYPE,TD_ISS.RESISS%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODTAB ALIAS FOR $1 ;
pRESISS ALIAS FOR $2 ;
BEGIN
  RETURN TO_CHAR(Num2ChrAssina(pCODTAB))||
         NumDec2ChrAssina(pRESISS);
END;
$$ language 'plpgsql';



/*-- SEQ 0304 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaMASS (TM_ASS.MASSID%TYPE,TM_ASS.TABELA%TYPE,TM_ASS.FLGEST%TYPE) CASCADE;

/*-- SEQ 0305 --*/
CREATE OR REPLACE FUNCTION ConcatenaMASS (TM_ASS.MASSID%TYPE,TM_ASS.TABELA%TYPE,TM_ASS.FLGEST%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pMASSID ALIAS FOR $1 ;
pTABELA ALIAS FOR $2 ;
pFLGEST ALIAS FOR $3 ;
BEGIN
  RETURN TO_CHAR(Num2ChrAssina(pMASSID))||
         Chr2ChrAssina(pTABELA)||
         Chr2ChrAssina(pFLGEST);
END;
$$ language 'plpgsql';



/*-- SEQ 0306 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaOPE (TT_OPE.CODFIL%TYPE,TT_OPE.NUMECF%TYPE,TT_OPE.TRN_ID%TYPE,TT_OPE.VLROPE%TYPE,TT_OPE.FILREC%TYPE,TT_OPE.SEQREC%TYPE,TT_OPE.FILCCC%TYPE,TT_OPE.SEQCCC%TYPE,TT_OPE.FILCHR%TYPE,TT_OPE.SEQCHR%TYPE,TT_OPE.FILFIN%TYPE,TT_OPE.SEQFIN%TYPE,TT_OPE.FILTEF%TYPE,TT_OPE.SEQTEF%TYPE,TT_OPE.CARTAO%TYPE,TT_OPE.OUTROS%TYPE,TT_OPE.CAMBIO%TYPE,TT_OPE.FILDOP%TYPE,TT_OPE.SEQDOP%TYPE,TT_OPE.DOCTRO%TYPE,TT_OPE.FILUSU%TYPE,TT_OPE.CODUSU%TYPE) CASCADE;

/*-- SEQ 0307 --*/
CREATE OR REPLACE FUNCTION ConcatenaOPE (TT_OPE.CODFIL%TYPE,TT_OPE.NUMECF%TYPE,TT_OPE.TRN_ID%TYPE,TT_OPE.VLROPE%TYPE,TT_OPE.FILREC%TYPE,TT_OPE.SEQREC%TYPE,TT_OPE.FILCCC%TYPE,TT_OPE.SEQCCC%TYPE,TT_OPE.FILCHR%TYPE,TT_OPE.SEQCHR%TYPE,TT_OPE.FILFIN%TYPE,TT_OPE.SEQFIN%TYPE,TT_OPE.FILTEF%TYPE,TT_OPE.SEQTEF%TYPE,TT_OPE.CARTAO%TYPE,TT_OPE.OUTROS%TYPE,TT_OPE.CAMBIO%TYPE,TT_OPE.FILDOP%TYPE,TT_OPE.SEQDOP%TYPE,TT_OPE.DOCTRO%TYPE,TT_OPE.FILUSU%TYPE,TT_OPE.CODUSU%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pNUMECF ALIAS FOR $2 ;
pTRN_ID ALIAS FOR $3 ;
pVLROPE ALIAS FOR $4 ;
pFILREC ALIAS FOR $5 ;
pSEQREC ALIAS FOR $6 ;
pFILCCC ALIAS FOR $7 ;
pSEQCCC ALIAS FOR $8 ;
pFILCHR ALIAS FOR $9 ;
pSEQCHR ALIAS FOR $10 ;
pFILFIN ALIAS FOR $11 ;
pSEQFIN ALIAS FOR $12 ;
pFILTEF ALIAS FOR $13 ;
pSEQTEF ALIAS FOR $14 ;
pCARTAO ALIAS FOR $15 ;
pOUTROS ALIAS FOR $16 ;
pCAMBIO ALIAS FOR $17 ;
pFILDOP ALIAS FOR $18 ;
pSEQDOP ALIAS FOR $19 ;
pDOCTRO ALIAS FOR $20 ;
pFILUSU ALIAS FOR $21 ;
pCODUSU ALIAS FOR $22 ;
BEGIN
  RETURN Chr2ChrAssina(pCODFIL)||
         Chr2ChrAssina(pNUMECF)||
         TO_CHAR(BigNum2ChrAssina(pTRN_ID))||
         NumDec2ChrAssina(pVLROPE)||
         Chr2ChrAssina(pFILREC)||
         Chr2ChrAssina(pSEQREC)||
         Chr2ChrAssina(pFILCCC)||
         Chr2ChrAssina(pSEQCCC)||
         Chr2ChrAssina(pFILCHR)||
         Chr2ChrAssina(pSEQCHR)||
         Chr2ChrAssina(pFILFIN)||
         Chr2ChrAssina(pSEQFIN)||
         Chr2ChrAssina(pFILTEF)||
         Chr2ChrAssina(pSEQTEF)||
         TO_CHAR(Num2ChrAssina(pCARTAO))||
         TO_CHAR(Num2ChrAssina(pOUTROS))||
         TO_CHAR(Num2ChrAssina(pCAMBIO))||
         Chr2ChrAssina(pFILDOP)||
         Chr2ChrAssina(pSEQDOP)||
         Chr2ChrAssina(pDOCTRO)||
         Chr2ChrAssina(pFILUSU)||
         Chr2ChrAssina(pCODUSU);
END;
$$ language 'plpgsql';



/*-- SEQ 0308 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaRCAI (TR_CAI.CODFIL%TYPE,TR_CAI.SEQUEN%TYPE,TR_CAI.FILUSU%TYPE,TR_CAI.CODUSU%TYPE) CASCADE;

/*-- SEQ 0309 --*/
CREATE OR REPLACE FUNCTION ConcatenaRCAI (TR_CAI.CODFIL%TYPE,TR_CAI.SEQUEN%TYPE,TR_CAI.FILUSU%TYPE,TR_CAI.CODUSU%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pFILUSU ALIAS FOR $3 ;
pCODUSU ALIAS FOR $4 ;
BEGIN
  RETURN Chr2ChrAssina(pCODFIL)||
         Chr2ChrAssina(pSEQUEN)||
         Chr2ChrAssina(pFILUSU)||
         Chr2ChrAssina(pCODUSU);
END;
$$ language 'plpgsql';



/*-- SEQ 0310 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ConcatenaRMOV (TR_MOV.CODFIL%TYPE,TR_MOV.SEQUEN%TYPE,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,TR_MOV.DATMOV%TYPE,TR_MOV.SALANT%TYPE,TR_MOV.CODMUL%TYPE,TR_MOV.QTDCOM%TYPE,TR_MOV.QTDVEN%TYPE,TR_MOV.VENFIS%TYPE,TR_MOV.QTDOUT%TYPE) CASCADE;

/*-- SEQ 0311 --*/
CREATE OR REPLACE FUNCTION ConcatenaRMOV (TR_MOV.CODFIL%TYPE,TR_MOV.SEQUEN%TYPE,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,TR_MOV.DATMOV%TYPE,TR_MOV.SALANT%TYPE,TR_MOV.CODMUL%TYPE,TR_MOV.QTDCOM%TYPE,TR_MOV.QTDVEN%TYPE,TR_MOV.VENFIS%TYPE,TR_MOV.QTDOUT%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pFILMAT ALIAS FOR $3 ;
pCODMAT ALIAS FOR $4 ;
pCODCOR ALIAS FOR $5 ;
pCODTAM ALIAS FOR $6 ;
pDATMOV ALIAS FOR $7 ;
pSALANT ALIAS FOR $8 ;
pCODMUL ALIAS FOR $9 ;
pQTDCOM ALIAS FOR $10 ;
pQTDVEN ALIAS FOR $11 ;
pVENFIS ALIAS FOR $12 ;
pQTDOUT ALIAS FOR $13 ;
BEGIN
  RETURN Chr2ChrAssina(pCODFIL)||
         Chr2ChrAssina(pSEQUEN)||
         Chr2ChrAssina(pFILMAT)||
         Chr2ChrAssina(pCODMAT)||
         TO_CHAR(Num2ChrAssina(pCODCOR))||
         TO_CHAR(Num2ChrAssina(pCODTAM))||
         Dat2ChrAssina(pDATMOV)||
         NumDec2ChrAssina(pSALANT)||
         TO_CHAR(Num2ChrAssina(pCODMUL))||
         NumDec2ChrAssina(pQTDCOM)||
         NumDec2ChrAssina(pQTDVEN)||
         NumDec2ChrAssina(pVENFIS)||
         NumDec2ChrAssina(pQTDOUT);
END;
$$ language 'plpgsql';




/*-- SEQ 0312 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CriaLid (TT_OPE.CODFIL%TYPE,TT_OPE.NUMECF%TYPE,TT_OPE.TRN_ID%TYPE) CASCADE;

/*-- SEQ 0313 --*/
CREATE OR REPLACE FUNCTION CriaLid (TT_OPE.CODFIL%TYPE,TT_OPE.NUMECF%TYPE,TT_OPE.TRN_ID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILOPE ALIAS FOR $1 ;
pNUMECF ALIAS FOR $2 ;
pTRN_ID ALIAS FOR $3 ;
  bEXISTE            CHAR(1);

  cr_Lid CURSOR FOR
  SELECT CAST('T' AS CHAR(1))
    FROM TT_LID
   WHERE CODFIL = pFILOPE
     AND NUMECF = pNUMECF
     AND TRN_ID = pTRN_ID;

-- Grava operacao na lid caso nao exista
  
BEGIN
  
  OPEN cr_Lid;
  FETCH cr_Lid INTO bEXISTE;
  IF NOT FOUND THEN
    INSERT INTO TT_LID (
      CODFIL, NUMECF, TRN_ID, CODSER, CUPFIS, DATHOR, TIPOPE, VLROPE 
    )
    VALUES (
      pFILOPE, pNUMECF, pTRN_ID, 'CF', 0,
      Agora(), 'ESTORNO', 0
    );
  END IF;  
  CLOSE cr_Lid;  
     
  RETURN 'OK';
END;
$$ language 'plpgsql';


/*-- SEQ 0314 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CriaLid () CASCADE;

/*-- SEQ 0315 --*/
CREATE OR REPLACE FUNCTION CriaLid () 
RETURNS VARCHAR AS $$
BEGIN
RETURN CriaLid(1);
END;
$$ language 'plpgsql';



/*-- SEQ 0316 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CRIATEF () CASCADE;

/*-- SEQ 0317 --*/
CREATE OR REPLACE FUNCTION CRIATEF ()
RETURNS VARCHAR AS $$
DECLARE

BEGIN

    UPDATE TT_CTM
       SET SEQTEF = LPAD(TO_CHAR(NEXTVAL('SQTEF')), 10, ' ')
     WHERE SEQTEF IS NULL
       AND INVALI='T';
    
    INSERT INTO TT_TEF (CODFIL, SEQUEN,NUMECF,TRN_ID,VLDCAR,NUMAUT,NUMCAR,NSUTRN,TIPOPE,
                        DATTRN,MANUAL,VLROPE,ATU_EM,PORORI,TIPCOB,CARTAO,FILCLI,CODCLI,FILUSU,CODUSU,DATFIS)
    (select COALESCE( REC.FILREC, CTM.CODFIL) AS CODFIL,
            CTM.SEQTEF                        AS SEQUEN,
            REC.NUMECF                        AS NUMECF,
            (SELECT MIN(OPE.TRN_ID)
             FROM TT_OPE OPE
             WHERE OPE.FILREC = REC.CODFIL
               AND OPE.SEQREC = REC.SEQUEN
               AND OPE.NUMPAR = REC.NUMPAR
               AND OPE.SUBPAR = REC.SUBPAR) AS TRN_ID,
            CTM.VLDCAR, CTM.NUMAUT, CTM.NUMCAR, CTM.NSUTRN, CTM.TIPOPE, 
            CTM.DATTRN, CTM.MANUAL,
            CASE WHEN REC.VLRPGT = 0 THEN REC.VLRPAR ELSE REC.VLRPGT + COALESCE(REC.VLRTAX,0) END AS VLROPE,
            COALESCE(REC.PAGAME,REC.ATU_EM) AS ATU_EM,            
            REC.PORTAD AS PORORI,
            CAST (DCOB.TIPCOB AS CHAR(1)) AS TIPCOB,
            REC.CARTAO, 
            CAST (VEN.FILCLI AS CHAR(3)) AS FILCLI, 
            CAST (VEN.CODCLI AS CHAR(6)) AS CODCLI,
            COALESCE(REC.FILUSU, VEN.FILUSU) AS FILUSU, 
            COALESCE(REC.CODUSU, VEN.CODUSU) AS CODUSU,
            REC.DATFIS
       from tt_ctm CTM INNER JOIN TT_REC REC ON REC.CODFIL = CTM.CODFIL
                                            AND REC.SEQUEN = CTM.SEQUEN
                                            AND REC.NUMPAR = CTM.NUMPAR
                                            AND REC.SUBPAR = CTM.SUBPAR
                       INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL
                                            AND VEN.SEQUEN = REC.SEQUEN
                       INNER JOIN TD_COB DCOB ON DCOB.CODTAB=REC.PORTAD
     WHERE REC.FLGEST IN ('P','A')
       AND REC.NUMECF IS NOT NULL
       AND CASE WHEN REC.VLRPGT = 0 THEN REC.VLRPAR ELSE REC.VLRPGT + COALESCE(REC.VLRTAX,0) END  > 0
       AND CTM.INVALI='T'
    );
    
    INSERT INTO TT_ITF (CODFIL, SEQUEN, NUMITE, VLRITE, VLRTAX, FLGEST, DATVEN, ATU_EM)
    (select COALESCE( REC.FILREC, CTM.CODFIL) AS CODFIL,
            CTM.SEQTEF                        AS SEQUEN,
            1 AS NUMITE,
            CASE WHEN REC.VLRPGT = 0 THEN REC.VLRPAR ELSE REC.VLRPGT + COALESCE(REC.VLRTAX,0) END AS VLROPE,
            COALESCE(REC.VLRTAX,0) AS VLRTAX,
            TO_CHAR('A') AS FLGEST,
            REC.DATVEN,
            COALESCE(REC.PAGAME,REC.ATU_EM) AS ATU_EM
       from tt_ctm CTM INNER JOIN TT_REC REC ON REC.CODFIL = CTM.CODFIL
                                            AND REC.SEQUEN = CTM.SEQUEN
                                            AND REC.NUMPAR = CTM.NUMPAR
                                            AND REC.SUBPAR = CTM.SUBPAR
     WHERE REC.FLGEST IN ('P','A')
       AND REC.NUMECF IS NOT NULL
       AND CASE WHEN REC.VLRPGT = 0 THEN REC.VLRPAR ELSE REC.VLRPGT + COALESCE(REC.VLRTAX,0) END  > 0
       AND CTM.INVALI='T'
    );
    
    UPDATE TT_CTM
    SET INVALI = NULL
    WHERE SEQTEF IS NOT NULL
      AND INVALI='T';


   RETURN 'OK';

END;
$$ language 'plpgsql';












/*-- SEQ 0318 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GETCUSTOCMS (TT_VEN.CODFIL%TYPE,TT_VEN.SEQUEN%TYPE) CASCADE;

/*-- SEQ 0319 --*/
CREATE OR REPLACE FUNCTION GETCUSTOCMS (TT_VEN.CODFIL%TYPE,TT_VEN.SEQUEN%TYPE)
RETURNS Numeric AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
  RETORNO     Numeric;

BEGIN

   -- RFMP 88968 - Otimizao da funo
   /*
   SELECT SUM(IVE.QTDMOV *
              CASE WHEN CUSTODATA('1',IVE.VEN_DATHOR, IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM, IVE.CODFIL, IVE.CODMUL) = 0 THEN
                        GRA.CUSREP
              ELSE CUSTODATA('1',IVE.VEN_DATHOR, IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM, IVE.CODFIL, IVE.CODMUL)
				  END)
   */
   SELECT SUM(IVE.QTDMOV *
              NVLZ(CUSTODATA('1',IVE.VEN_DATHOR, IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM, IVE.CODFIL, IVE.CODMUL),
                GRA.CUSREP))
     INTO RETORNO
     FROM TT_IVE IVE INNER JOIN TT_GRA GRA ON GRA.FILMAT = IVE.FILMAT
                                          AND GRA.CODMAT = IVE.CODMAT
                                          AND GRA.CODCOR = IVE.CODCOR
                                          AND GRA.CODTAM = IVE.CODTAM
    WHERE IVE.CODFIL = pCODFIL
      AND IVE.SEQUEN = pSEQUEN
      AND IVE.SITKIT <> '1'
	  AND IVE.SITMOV <> 'C';

   RETURN RETORNO;
END;
$$ language 'plpgsql';




/*-- SEQ 0320 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CustoData (Char,Timestamp,TT_ICO.FILMAT%TYPE,TT_ICO.CODMAT%TYPE,TT_ICO.CODCOR%TYPE,TT_ICO.CODTAM%TYPE,TT_ICO.CODFIL%TYPE,TT_ICO.CODMUL%TYPE) CASCADE;

/*-- SEQ 0321 --*/
CREATE OR REPLACE FUNCTION CustoData (Char,Timestamp,TT_ICO.FILMAT%TYPE,TT_ICO.CODMAT%TYPE,TT_ICO.CODCOR%TYPE,TT_ICO.CODTAM%TYPE,TT_ICO.CODFIL%TYPE,TT_ICO.CODMUL%TYPE)
RETURNS Numeric AS $$
DECLARE
pTipo ALIAS FOR $1 ;
pDatRef ALIAS FOR $2 ;
pFilmat ALIAS FOR $3 ;
pCodMat ALIAS FOR $4 ;
pCodCor ALIAS FOR $5 ;
pCodTam ALIAS FOR $6 ;
pCodFil ALIAS FOR $7 ;
pCodMul ALIAS FOR $8 ;
-- Objetivo:
-- 1) Traz um determinado custo de um produto em determinada data de uma filial
-- pTipo:
-- R - Custo Reposio
-- F - Custo Frete
-- 1 - Custo Total (CUSREP+CUSFRE)
-- 2 - Custo Total Fiscal (CUSREP+FREFIS)

 nSaldo Numeric;
 vCODFIL TR_MOV.CODFIL%TYPE;

-- Principal
BEGIN
  nSaldo :=0;

  IF TRUNC(pDatRef) = TRUNC(Agora()) THEN
    SELECT CASE pTipo WHEN 'F' THEN MAX(ICO.CUSFRE)
                      WHEN 'R' THEN MAX(ICO.CUSREP)
					  WHEN '1' THEN MAX(ICO.CUSREP+COALESCE(ICO.CUSFRE,0))
					  WHEN '2' THEN MAX(ICO.CUSREP+COALESCE(ICO.FREFIS,0))
                      WHEN 'C' THEN MAX(ICO.VLRMOV) / CASE WHEN COALESCE(MAX(ICO.QTDMOV),0) = 0 THEN 1
                                                                      ELSE MAX(ICO.QTDMOV)
                                                                  END
           END
      INTO nSaldo
      FROM TT_GRA GRA INNER JOIN TT_ICO ICO ON ICO.CODFIL = GRA.FILCOM
                                           AND ICO.SEQUEN = GRA.SEQCOM
                                           AND ICO.NUMITE = GRA.ITECOM
					  INNER JOIN TT_COM COM ON COM.CODFIL=ICO.CODFIL AND COM.SEQUEN=ICO.SEQUEN
     WHERE COALESCE(COM.ATUCUS,'T')='T'
       AND COM.FLGEST <> 'D'
	   AND GRA.FILMAT = pFilMat
       AND GRA.CODMAT = pCodMat
       AND GRA.CODCOR = pCodCor
       AND GRA.CODTAM = pCodTam
       AND ICO.CODFIL = COALESCE(pCODFIL, ICO.CODFIL);
  END IF;
  
  IF coalesce(nSaldo,0)=0 THEN
    IF pTipo = 'F' THEN
      SELECT MAX(ICO.CUSFRE), MIN(RMOV.CODFIL)
        INTO nSaldo, vCODFIL
        FROM TR_MOV RMOV LEFT JOIN TT_ICO ICO ON ICO.CODFIL = RMOV.FILFRE
                                              AND ICO.SEQUEN = RMOV.SEQFRE
                                              AND ICO.NUMITE = RMOV.NUMFRE
						 LEFT JOIN TT_COM COM ON COM.CODFIL=ICO.CODFIL AND COM.SEQUEN=ICO.SEQUEN
       WHERE COALESCE(COM.ATUCUS,'T')='T'
         AND COM.FLGEST <> 'D'
	     AND RMOV.FILMAT = pFilMat
         AND RMOV.CODMAT = pCodMat
         AND RMOV.CODCOR = pCodCor
         AND RMOV.CODTAM = pCodTam
         AND RMOV.DATMOV = TRUNC(pDatRef)
         AND RMOV.CODFIL = COALESCE(pCODFIL, RMOV.CODFIL)
         AND ICO.CODFIL = COALESCE(pCODFIL, ICO.CODFIL)
         AND ICO.CODMUL = COALESCE(pCODMUL, ICO.CODMUL);
    ELSE
      SELECT CASE pTipo WHEN 'R' THEN MAX(ICO.CUSREP)
						WHEN '1' THEN MAX(ICO.CUSREP+COALESCE(ICO.CUSFRE,0))
						WHEN '2' THEN MAX(ICO.CUSREP+COALESCE(ICO.FREFIS,0))
                        WHEN 'C' THEN MAX(ICO.VLRMOV) / CASE WHEN COALESCE(MAX(ICO.QTDMOV),0) = 0 THEN 1
                                                                        ELSE MAX(ICO.QTDMOV)
                                                                    END
             END, MIN(RMOV.CODFIL)
        INTO nSaldo, vCODFIL
        FROM TT_ICO ICO INNER JOIN TT_COM COM ON COM.CODFIL = ICO.CODFIL 
                                             AND COM.SEQUEN=ICO.SEQUEN
		                INNER JOIN TR_MOV RMOV ON ICO.CODFIL = RMOV.FILICO
                                              AND ICO.SEQUEN = RMOV.SEQICO
                                              AND ICO.NUMITE = RMOV.NUMICO
       WHERE COALESCE(COM.ATUCUS,'T') = 'T'
         AND COM.FLGEST <> 'D'
	     AND RMOV.FILMAT = pFilMat
         AND RMOV.CODMAT = pCodMat
         AND RMOV.CODCOR = pCodCor
         AND RMOV.CODTAM = pCodTam
         AND RMOV.DATMOV = TRUNC(pDatRef)
         AND RMOV.CODFIL = COALESCE(pCODFIL, RMOV.CODFIL)
         AND ICO.CODFIL = COALESCE(pCODFIL, ICO.CODFIL)
         AND ICO.CODMUL = COALESCE(pCODMUL, ICO.CODMUL);
    END IF;

    IF vCODFIL IS NULL THEN -- se encontrou tr_mov nao adianta mais procurar
      IF COALESCE(nSaldo,0) = 0 THEN
        IF pTipo = 'F' THEN
          SELECT MAX(ICO.CUSFRE)
            INTO nSaldo
            FROM TT_ICO ICO INNER JOIN TT_COM COM ON COM.CODFIL = ICO.CODFIL 
                                                 AND COM.SEQUEN = ICO.SEQUEN
            WHERE COALESCE(COM.ATUCUS,'T') = 'T'
             AND COM.FLGEST <> 'D'
	     AND ICO.FILMAT = pFilMat
             AND ICO.CODMAT = pCodMat
             AND ICO.CODCOR = pCodCor
             AND ICO.CODTAM = pCodTam
             AND ICO.CUSFRE > 0
             AND ICO.CODFIL = COALESCE(pCODFIL, ICO.CODFIL)
             AND ICO.CODMUL = COALESCE(pCODMUL, ICO.CODMUL)
             AND ICO.COM_DATOPE IN (SELECT MAX(IC.COM_DATOPE)
                                      FROM TT_ICO IC
                                     WHERE IC.COM_DATOPE <= TRUNC(pDatRef)
                                       AND IC.FILMAT = pFilMat
                                       AND IC.CODMAT = pCodMat
                                       AND IC.CODCOR = pCodCor
                                       AND IC.CODTAM = pCodTam
                                       AND IC.CODMUL = COALESCE(pCODMUL, IC.CODMUL)
                                       AND IC.CODFIL = COALESCE(pCODFIL, IC.CODFIL)
                                       AND IC.CUSFRE > 0
                                       AND IC.SITMOV = 'N');
        ELSE
          SELECT CASE pTipo WHEN 'R' THEN MAX(ICO.CUSREP)
							WHEN '1' THEN MAX(ICO.CUSREP+COALESCE(ICO.CUSFRE,0))
							WHEN '2' THEN MAX(ICO.CUSREP+COALESCE(ICO.FREFIS,0))
                            WHEN 'C' THEN MAX(ICO.VLRMOV) / CASE WHEN COALESCE(MAX(ICO.QTDMOV),0) = 0 THEN 1
                                                                            ELSE MAX(ICO.QTDMOV)
                                                                       END
                 END
            INTO nSaldo
            FROM TT_ICO ICO INNER JOIN TT_COM COM ON COM.CODFIL = ICO.CODFIL 
                                                 AND COM.SEQUEN = ICO.SEQUEN
            WHERE COALESCE(COM.ATUCUS,'T')='T'
             AND COM.FLGEST <> 'D'
	     AND ICO.FILMAT = pFilMat
             AND ICO.CODMAT = pCodMat
             AND ICO.CODCOR = pCodCor
             AND ICO.CODTAM = pCodTam
             AND ICO.CODMUL = COALESCE(pCODMUL, ICO.CODMUL)
             AND ICO.CODFIL = COALESCE(pCODFIL, ICO.CODFIL)
             AND ICO.COM_ATUCUS = 'T'
             AND ICO.COM_DATOPE IN (SELECT MAX(IC.COM_DATOPE)
                                      FROM TT_ICO IC
                                     WHERE IC.COM_DATOPE <= TRUNC(pDatRef)
                                       AND IC.FILMAT = pFilMat
                                       AND IC.CODMAT = pCodMat
                                       AND IC.CODCOR = pCodCor
                                       AND IC.CODTAM = pCodTam
                                       AND IC.CODMUL = COALESCE(pCODMUL, IC.CODMUL)
                                       AND IC.CODFIL = COALESCE(pCODFIL, IC.CODFIL)
                                       AND IC.COM_ATUCUS = 'T'
                                       AND IC.SITMOV = 'N');
        END IF;
      END IF;
    END IF;
  END IF;

  RETURN COALESCE(nSaldo,0);
EXCEPTION
 WHEN OTHERS THEN RETURN 0;
END;
$$ language 'plpgsql' STABLE;


/*-- SEQ 0322 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CustoData (Char,Timestamp,TT_ICO.FILMAT%TYPE,TT_ICO.CODMAT%TYPE,TT_ICO.CODCOR%TYPE,TT_ICO.CODTAM%TYPE,TT_ICO.CODFIL%TYPE);

/*-- SEQ 0323 --*/
CREATE OR REPLACE FUNCTION CustoData (Char,
                               Timestamp,
                               TT_ICO.FILMAT%TYPE,
                               TT_ICO.CODMAT%TYPE,
                               TT_ICO.CODCOR%TYPE,
                               TT_ICO.CODTAM%TYPE,
                               TT_ICO.CODFIL%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN CustoData($1,$2,$3,$4,$5,$6,$7,$8);
END;
$$ language 'plpgsql' STABLE;


/*-- SEQ 0324 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CustoReposicaoData (Timestamp,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,TR_MOV.CODFIL%TYPE,TR_MOV.CODMUL%TYPE) CASCADE;

/*-- SEQ 0325 --*/
CREATE OR REPLACE FUNCTION CustoReposicaoData (Timestamp,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,TR_MOV.CODFIL%TYPE,TR_MOV.CODMUL%TYPE)
RETURNS Numeric AS $$
DECLARE
pDatRef ALIAS FOR $1 ;
pFilmat ALIAS FOR $2 ;
pCodMat ALIAS FOR $3 ;
pCodCor ALIAS FOR $4 ;
pCodTam ALIAS FOR $5 ;
pCodFil ALIAS FOR $6 ;
pCodMul ALIAS FOR $7 ;
-- Objetivo:
-- 1) Traz o custo de reposicao de um produto em determinada data de uma filial
 nSaldo Numeric;

-- Principal
BEGIN
   Return CustoData('R', pDatRef, pFilmat, pCodMat, pCodCor, pCodTam, pCodFil, pCodMul);
END;
$$ language 'plpgsql';




/*-- SEQ 0326 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CustoSimuladoDia (TT_PRE.FILMAT%TYPE,TT_PRE.CODMAT%TYPE,TT_PRE.CODCOR%TYPE,TT_PRE.CODTAM%TYPE,TL_PRE.DATOPE%TYPE,TT_PRE.FILPRE%TYPE,TT_PRE.CODPRE%TYPE) CASCADE;

/*-- SEQ 0327 --*/
CREATE OR REPLACE FUNCTION CustoSimuladoDia (TT_PRE.FILMAT%TYPE,TT_PRE.CODMAT%TYPE,TT_PRE.CODCOR%TYPE,TT_PRE.CODTAM%TYPE,TL_PRE.DATOPE%TYPE,TT_PRE.FILPRE%TYPE,TT_PRE.CODPRE%TYPE)
RETURNS TT_PRE.CUSREP%TYPE AS $$
DECLARE
pFilMat ALIAS FOR $1 ;
pCodMat ALIAS FOR $2 ;
pCodCor ALIAS FOR $3 ;
pCodTam ALIAS FOR $4 ;
pDatOpe ALIAS FOR $5 ;
pFilPre ALIAS FOR $6 ;
pCodPre ALIAS FOR $7 ;
  nRetorno       TT_PRE.CUSREP%TYPE;
  nCustoNaData   TT_PRE.CUSREP%TYPE;
  nCustoAtual    TT_PRE.CUSREP%TYPE;

-- Objetivo:
-- 1) Calcular qual era o preo de venda do produto em determinada data.

BEGIN
  nRetorno       := NULL;
  nCustoNaData   := NULL;
  nCustoAtual    := NULL;

  IF TRUNC(pDatOpe) <= AGORA() THEN 
    -- procura Custo no log
    BEGIN
      SELECT CUSANT INTO nCustoNaData 
        FROM (
      SELECT LPRE.CUSANT
        FROM TT_PRE PRE INNER JOIN TL_PRE LPRE ON PRE.FILPRE = LPRE.FILPRE
                                              AND PRE.SEQUEN = LPRE.SEQPRE
       WHERE PRE.FILMAT = pFilMat
         AND PRE.CODMAT = pCodMat
         AND PRE.CODCOR = pCodCor
         AND PRE.CODTAM = pCodTam
         AND PRE.FILPRE = pFilPre
         AND PRE.CODPRE = pCodPre
         AND LPRE.DATOPE >= ADD_DAY(TRUNC(pDATOPE),1)
         AND LPRE.PREANT IS NOT NULL              
       ORDER BY LPRE.DATOPE
       ) TAB
       LIMIT 1;
    EXCEPTION
            
      WHEN others THEN NULL;
          END;
  END IF;

  IF nCustoNaData IS NULL THEN
     -- pega o Custo atual
     BEGIN
       SELECT PRE.CUSREP INTO nCustoAtual
         FROM TT_PRE PRE
        WHERE PRE.FILMAT = pFilMat
          AND PRE.CODMAT = pCodMat
          AND PRE.CODCOR = pCodCor
          AND PRE.CODTAM = pCodTam
          AND PRE.FILPRE = pFilPre
          AND PRE.CODPRE = pCodPre;
     EXCEPTION
              
       WHEN others THEN NULL;
            END;
     nRetorno := nCustoAtual;
  ELSIF (nCustoNaData = 0) THEN
     nRetorno := NULL;
  ELSE
     nRetorno := nCustoNaData;
  END IF;

  RETURN nRetorno;
END;
$$ language 'plpgsql' STABLE;




/*-- SEQ 0328 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DadosDopUnica (TT_DOP.CODFIL%TYPE,TT_DOP.SEQUEN%TYPE,Timestamp,VARCHAR) CASCADE;

/*-- SEQ 0329 --*/
CREATE OR REPLACE FUNCTION DadosDopUnica (TT_DOP.CODFIL%TYPE,TT_DOP.SEQUEN%TYPE,Timestamp,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pFILDOP ALIAS FOR $1 ;
pSEQDOP ALIAS FOR $2 ;
pDATPGT ALIAS FOR $3 ;
pCOLUNA ALIAS FOR $4 ;

   vFILCTA TT_DOP.FILCTA%TYPE;
   vSEQCTA TT_DOP.SEQCTA%TYPE; 
   vTIPCTA TT_DOP.TIPCTA%TYPE; 

BEGIN
   SELECT DOP.FILCTA, DOP.SEQCTA, DOP.TIPCTA
     INTO vFILCTA,    vSEQCTA,    vTIPCTA
     FROM TT_DOP DOP INNER JOIN TT_PAG INT ON INT.FILDOP=DOP.CODFIL AND INT.SEQDOP=DOP.SEQUEN
                      LEFT JOIN TD_STD DSTD ON DOP.DOMDOP = DSTD.DOMDOP 
                                           AND DOP.STDDOP = DSTD.CODTAB
                                           AND DOP.FLGEST = DSTD.USOSTD
     WHERE DOP.FLGEST <> 'C'
       AND DSTD.FLGFLX = 'R'
       AND DOP.CODFIL=pFILDOP
       AND DOP.SEQUEN=pSEQDOP
       AND TRUNC(DOP.DATPGT)=TRUNC(pDATPGT)
     GROUP BY DOP.FILCTA, DOP.SEQCTA, DOP.TIPCTA, DSTD.FLGFLX
    HAVING COUNT(*)=1;
   
   IF (pCOLUNA='FILCTA') THEN 
      RETURN vFILCTA;
   ELSIF (pCOLUNA='SEQCTA') THEN 
      RETURN vSEQCTA;
   ELSIF (pCOLUNA='TIPCTA') THEN 
      RETURN vTIPCTA;
   END IF;
     
END;
$$ language 'plpgsql';




/*-- SEQ 0330 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DataPrometidaTarefa (TT_WOR.CODFIL%TYPE,TT_WOR.SEQUEN%TYPE) CASCADE;

/*-- SEQ 0331 --*/
CREATE OR REPLACE FUNCTION DataPrometidaTarefa (TT_WOR.CODFIL%TYPE,TT_WOR.SEQUEN%TYPE)
RETURNS Timestamp AS $$
DECLARE
pCodfil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
-- Objetivo
-- 1) Retornar a nome do cliente associado a uma tarefa

  dDATPRO TT_PRJ.INIPRJ%TYPE;

  Lista CURSOR FOR
    -- Ver detalhes sobre a macro em
-- \\tt2000\Docs\desenv\depto\Manuais\Ansi\connectby.mac
SELECT DATPRO
FROM connectby_back('(select to_char(chvprj) as filho,
                             to_char(chvpai) as pai
                   from tt_prj int) tab', 'filho', 'pai', to_char(pCodfil||pSequen))
AS c (conn_codigo VARCHAR, conn_codpai VARCHAR, level int, ordem int)
INNER JOIN tt_prj t ON c.conn_codigo  = (chvprj)
order by ordem;

-- Principal
begin
  SELECT DATPRO INTO dDATPRO
    FROM TT_WOR
   WHERE CODFIL=pCODFIL
     AND SEQUEN=pSEQUEN;
     
  IF dDATPRO IS NULL THEN        
     OPEN Lista;
     LOOP
        FETCH Lista INTO dDATPRO;
        EXIT WHEN (NOT FOUND) or (dDATPRO IS NOT NULL);
     END LOOP;     
     Close Lista;
  END IF;  
  
  RETURN dDATPRO;

END;
$$ language 'plpgsql';




/*-- SEQ 0332 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CALCULA_DATA_DA_SEMANA_NO_MES (Numeric,Numeric,Numeric,Numeric) CASCADE;

/*-- SEQ 0333 --*/
CREATE OR REPLACE FUNCTION CALCULA_DATA_DA_SEMANA_NO_MES (Numeric,Numeric,Numeric,Numeric)
RETURNS Timestamp AS $$
DECLARE
POCORRENCIA ALIAS FOR $1 ;
PDIASEM ALIAS FOR $2 ;
PMES ALIAS FOR $3 ;
PANO ALIAS FOR $4 ;
-- Flvio - 65324
--Traz uma Data no dia da semana "pDiaSem" da semana "POCORRENCIA"
--Entradas (POCORRENCIA: de 1 a 5; pDiaSem: de 1 a 7; pMes: Ms; pAno: Ano)
--Sada (DataHora Calculada) 
  DT_AUX  Timestamp;
  ENCONTROU Numeric;
-- Principal
BEGIN
  DT_AUX := TO_DATE('01'||TO_CHAR(PMES, '00')||TO_CHAR(PANO, '0000'),'DDMMYYYY'); -- 1 dia do Ms 
  IF (TRUNC(POCORRENCIA) = 1)
  AND (TRUNC(PDIASEM) = to_number(to_char(DT_AUX,'D'))) THEN
    RETURN DT_AUX;
  ELSE
    IF to_number(to_char(DT_AUX,'D')) = TRUNC(PDIASEM) THEN
      ENCONTROU := 1;
    ELSE  
      ENCONTROU := 0;
    END IF;
        
    LOOP
      EXIT WHEN (ENCONTROU = TRUNC(POCORRENCIA));  
      DT_AUX := ADD_DAY(DT_AUX , 1);     
      IF (to_number(to_char(DT_AUX,'D')) = TRUNC(PDIASEM)) THEN
        ENCONTROU := ENCONTROU + 1; 
      END IF;      
    END LOOP;

    RETURN DT_AUX;
  END IF;
 
END;
$$ language 'plpgsql';




/*-- SEQ 0334 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DataEntradaSimples (TD_FIL.CGCFIL%TYPE) CASCADE;

/*-- SEQ 0335 --*/
CREATE OR REPLACE FUNCTION DataEntradaSimples (TD_FIL.CGCFIL%TYPE)
RETURNS TD_FIL.DATSIM%TYPE AS $$
DECLARE
pRadicalCGCFIL ALIAS FOR $1 ;

WK_DFIL_DATSIM TD_FIL.DATSIM%TYPE;
BEGIN
  SELECT MAX(FIL.DATSIM) INTO WK_DFIL_DATSIM
    FROM TD_FIL FIL
   WHERE SUBSTR(FIL.CGCFIL,1,8) = pRadicalCGCFIL
     AND FIL.REGTRI = 'S'
   GROUP BY SUBSTR(FIL.CGCFIL,1,8);
  
  RETURN WK_DFIL_DATSIM; 
  
END;
$$ language 'plpgsql';

   


/*-- SEQ 0336 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DEFINE_VIEW (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,Numeric,TT_PED.CODFIL%TYPE,TT_PED.NUMPED%TYPE) CASCADE;

/*-- SEQ 0337 --*/
CREATE OR REPLACE FUNCTION DEFINE_VIEW (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,Numeric,TT_PED.CODFIL%TYPE,TT_PED.NUMPED%TYPE)
RETURNS VARCHAR AS $$
DECLARE
PFILCLI ALIAS FOR $1 ;
PCODCLI ALIAS FOR $2 ;
PRETORNO ALIAS FOR $3 ;
PCODFIL ALIAS FOR $4 ;
PNUMPED ALIAS FOR $5 ;
-- Objetivo
-- 1) Retornar a view utilizada para exportao de pedidos de um determinado fornecedor.
WK_FIL_GENESIO     TT_CFG.FIL_GENESIO%TYPE;
WK_COD_GENESIO     TT_CFG.COD_GENESIO%TYPE;
WK_FIL_PANARELLO   TT_CFG.FIL_PANARELLO%TYPE;
WK_COD_PANARELLO   TT_CFG.COD_PANARELLO%TYPE;
WK_FIL_PROFARMA    TT_CFG.FIL_PROFARMA%TYPE;
WK_COD_PROFARMA    TT_CFG.COD_PROFARMA%TYPE;
WK_FIL_DIMED       TT_CFG.FIL_DIMED%TYPE;
WK_COD_DIMED       TT_CFG.COD_DIMED%TYPE;
WK_FIL_DIMPER      TT_CFG.FIL_DIMPER%TYPE;
WK_COD_DIMPER      TT_CFG.COD_DIMPER%TYPE;
WK_FIL_SANTACRUZ   TT_CFG.FIL_SANTACRUZ%TYPE;
WK_COD_SANTACRUZ   TT_CFG.COD_SANTACRUZ%TYPE;
WK_FIL_BASF        TT_CFG.FIL_BASF%TYPE;
WK_COD_BASF        TT_CFG.COD_BASF%TYPE;
WK_VIEW            VARCHAR(20);
WK_NOMARQ          VARCHAR(20);
WK_MEUCOD          TT_CLIXFIL.MEUCOD%TYPE;

begin
  SELECT FIL_GENESIO, COD_GENESIO, FIL_PANARELLO, COD_PANARELLO, FIL_PROFARMA, COD_PROFARMA,
         FIL_DIMED, COD_DIMED, FIL_DIMPER, COD_DIMPER, FIL_SANTACRUZ, COD_SANTACRUZ, FIL_BASF, COD_BASF
    INTO WK_FIL_GENESIO, WK_COD_GENESIO, WK_FIL_PANARELLO, WK_COD_PANARELLO, WK_FIL_PROFARMA, WK_COD_PROFARMA,
         WK_FIL_DIMED, WK_COD_DIMED, WK_FIL_DIMPER, WK_COD_DIMPER, WK_FIL_SANTACRUZ, WK_COD_SANTACRUZ,
         WK_FIL_BASF, WK_COD_BASF
    FROM TT_CFG;

  --Pedro E. Braga - 90481  
  --Quando pedido da BASF no deve realizar tratamento para Cdigo da Filial no Fornecedor
  IF ((PFILCLI <> COALESCE(WK_FIL_BASF,'   ')) OR (PCODCLI <> COALESCE(WK_COD_BASF,'      '))) THEN
    SELECT CLI.MEUCOD 
      INTO WK_MEUCOD
      FROM TT_PED PED INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR AND REL.CODPAR = PED.CODFOR
                                           AND REL.TIPPAR = PED.TIPFOR
                      INNER JOIN TT_CLIXFIL CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI = REL.CODPAR
                                               AND CLI.CODFIL = PCODFIL
    WHERE CLI.FILCLI = PFILCLI
      AND CLI.CODCLI = PCODCLI
      AND PED.NUMPED = PNUMPED
      AND PED.CODFIL = PCODFIL;
  END IF;
  
  IF (PFILCLI = WK_FIL_GENESIO) AND (PCODCLI = WK_COD_GENESIO) THEN
      WK_VIEW := 'TV_PED_GENESIO';
      WK_NOMARQ := LOWER('p'||LPAD(WK_MEUCOD,7,'0')||'.TXT');
  ELSIF (PFILCLI = WK_FIL_PANARELLO) AND (PCODCLI = WK_COD_PANARELLO) THEN
      WK_VIEW := 'TV_PED_PANARELLO';
      WK_NOMARQ := LPAD(TRIM(WK_MEUCOD),6,'0')||'.PED';
  ELSIF (PFILCLI = WK_FIL_PROFARMA) AND (PCODCLI = WK_COD_PROFARMA) THEN
      WK_VIEW := 'TV_PED_PROFARMA';
      WK_NOMARQ := 'PED'||PCODFIL||LPAD(TRIM(PNUMPED),8,'0')||'.PED';
  ELSIF (PFILCLI = WK_FIL_DIMED) AND (PCODCLI = WK_COD_DIMED) THEN
      WK_VIEW := 'TV_PED_DIMED';
      WK_NOMARQ := 'PED'||PCODFIL||LPAD(TRIM(PNUMPED),8,'0')||'.TXT';
  ELSIF (PFILCLI = WK_FIL_DIMPER) AND (PCODCLI = WK_COD_DIMPER) THEN
      WK_VIEW := 'TV_PED_DIMPER';
      WK_NOMARQ := 'PED'||LPAD(TRIM(WK_MEUCOD),5,'0')||'.'||LPAD(TO_CHAR(MOD(TO_NUMBER(TRIM(PNUMPED)),999)),3,'0');
  ELSIF (PFILCLI = WK_FIL_SANTACRUZ) AND (PCODCLI = WK_COD_SANTACRUZ) THEN
      WK_VIEW := 'TV_PED_SANTACRUZ';
      WK_NOMARQ := LPAD(WK_MEUCOD,6,'0')||'.TXT';
  ELSIF (PFILCLI = WK_FIL_BASF) AND (PCODCLI = WK_COD_BASF) THEN
      WK_VIEW := 'TV_PED_BASF';
      WK_NOMARQ := PCODFIL||PCODFIL||LPAD(TRIM(PNUMPED),8,'0')||'.001';
  ELSE
      WK_VIEW := 'TV_PED_TOTALL';
      WK_NOMARQ := WK_MEUCOD||'.TXT';  
  END IF;
  IF PRETORNO = 0 THEN
    RETURN TRIM(WK_VIEW);
  ELSE
    RETURN TRIM(WK_NOMARQ);
  END IF;
END;
$$ language 'plpgsql';




/*-- SEQ 0338 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DEPENDENTES_PROJETO (TT_PRJ.CODFIL%TYPE,TT_PRJ.SEQUEN%TYPE) CASCADE;

/*-- SEQ 0339 --*/
CREATE OR REPLACE FUNCTION DEPENDENTES_PROJETO (TT_PRJ.CODFIL%TYPE,TT_PRJ.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCodfil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;

  cr_Projetos_dep CURSOR FOR
   SELECT DEP.CODFIL||'/'||trim(DEP.SEQUEN)
     FROM TT_PRJXPRJ PXP INNER JOIN TT_PRJ DEP ON PXP.FILPRJ=DEP.CODFIL AND PXP.SEQPRJ=DEP.SEQUEN
    WHERE PXP.CODFIL=pCodfil
      AND PXP.SEQUEN=pSequen;

      
  cPROJETOS VARCHAR(4000):='';  
  cRESULT VARCHAR(4000);
  cLINHA VARCHAR(255);

BEGIN

  OPEN cr_Projetos_dep;
  LOOP
     FETCH cr_Projetos_dep INTO cLINHA;
     EXIT WHEN NOT FOUND;
     cPROJETOS:=cPROJETOS||CHR(10)||cLINHA;
  END LOOP;     
  Close cr_Projetos_dep;
  
  IF ISNOTNULL(cPROJETOS)='T' THEN 
     cRESULT:='Projetos:'||cPROJETOS;
  END IF;   
  
  RETURN  cRESULT;

END;
$$ language 'plpgsql';




/*-- SEQ 0340 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DEPENDENTES_TAREFA (TT_WOR.CODFIL%TYPE,TT_WOR.SEQUEN%TYPE,VARCHAR) CASCADE;

/*-- SEQ 0341 --*/
CREATE OR REPLACE FUNCTION DEPENDENTES_TAREFA (TT_WOR.CODFIL%TYPE,TT_WOR.SEQUEN%TYPE,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pCodfil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
pSomenteTarefas ALIAS FOR $3 ;

  cr_Tarefas_dep CURSOR FOR
   SELECT /*+RULE*/ DEP.CODFIL||'/'||trim(DEP.SEQUEN)
     FROM TT_WORXWOR WXW INNER JOIN TT_WOR DEP ON WXW.FILWOR=DEP.CODFIL AND WXW.SEQWOR=DEP.SEQUEN
    WHERE WXW.CODFIL=pCodfil
      AND WXW.SEQUEN=pSequen;

  cr_Projetos_dep CURSOR FOR
   SELECT DEP.CODFIL||'/'||trim(DEP.SEQUEN)
     FROM TT_WOR WOR INNER JOIN TT_PRJXPRJ PXP ON WOR.FILPRJ=PXP.CODFIL AND WOR.SEQPRJ=PXP.SEQUEN
                     INNER JOIN TT_PRJ DEP ON PXP.FILPRJ=DEP.CODFIL AND PXP.SEQPRJ=DEP.SEQUEN
    WHERE WOR.CODFIL=pCodfil
      AND WOR.SEQUEN=pSequen;
      
  cTAREFAS VARCHAR(4000):='';
  cPROJETOS VARCHAR(4000):='';  
  cRESULT VARCHAR(4000);
  cLINHA VARCHAR(255);

BEGIN

  OPEN cr_Tarefas_dep;
  LOOP
     FETCH cr_Tarefas_dep INTO cLINHA;
     EXIT WHEN NOT FOUND;
     cTAREFAS:=cTAREFAS||CHR(10)||cLINHA;
  END LOOP;     
  Close cr_Tarefas_dep;
  
  if pSomenteTarefas='F' THEN
      OPEN cr_Projetos_dep;
      LOOP
         FETCH cr_Projetos_dep INTO cLINHA;
         EXIT WHEN NOT FOUND;
         cPROJETOS:=cPROJETOS||CHR(10)||cLINHA;
      END LOOP;     
      Close cr_Projetos_dep;
  END IF;
  
  IF ISNOTNULL(cTAREFAS)='T' THEN 
     cRESULT:='Tarefas:'||cTAREFAS;
  END IF;
  IF ISNOTNULL(cPROJETOS)='T' THEN 
     cRESULT:=cRESULT||CHR(10)||'Projetos:'||cPROJETOS;
  END IF; 
  
  
  RETURN  cRESULT;

END;
$$ language 'plpgsql';


/*-- SEQ 0342 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DEPENDENTES_TAREFA (TT_WOR.CODFIL%TYPE,TT_WOR.SEQUEN%TYPE) CASCADE;

/*-- SEQ 0343 --*/
CREATE OR REPLACE FUNCTION DEPENDENTES_TAREFA (TT_WOR.CODFIL%TYPE,
                               TT_WOR.SEQUEN%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN DEPENDENTES_TAREFA($1,$2,'F');
END;
$$ language 'plpgsql';


/*-- SEQ 0344 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DescricaoDominio (TT_DOM.CODARQ%TYPE,TT_DOM.NOMCPO%TYPE,VARCHAR) CASCADE;

/*-- SEQ 0345 --*/
CREATE OR REPLACE FUNCTION DescricaoDominio (TT_DOM.CODARQ%TYPE,TT_DOM.NOMCPO%TYPE,VARCHAR)
RETURNS TT_DOM.DESDOM%TYPE AS $$
DECLARE
p_Tabela ALIAS FOR $1 ;
p_Campo ALIAS FOR $2 ;
p_Codigo ALIAS FOR $3 ;

-- Objetivo
-- 1) Retornar a descricao de um dominio
   vSignificado                  TT_DOM.DESDOM%TYPE;
   vRetorno                      TT_DOM.DESDOM%TYPE;

   ListaDescricao CURSOR FOR
   SELECT DESDOM
     FROM TT_DOM DOM INNER JOIN TT_ARQ ARQ ON ARQ.CODTAB = DOM.CODARQ
                     INNER JOIN TT_LAY LAY ON LAY.CODTAB = ARQ.CODTAB
                                          AND LAY.NOMCPO = p_Campo
    WHERE DOM.CODARQ = p_Tabela
      AND DOM.NOMCPO = p_Campo
      AND 1 = CASE WHEN DOM.CODCHR = p_Codigo THEN 1
                   WHEN DOM.CODSTR = p_Codigo THEN 1
                   WHEN (ISDIGIT(p_Codigo) = 1) -- apenas dgitos
                    AND (LAY.TIPCPO IN ('S','N','G','F')) -- tipos numricos
                    AND (DOM.CODINT = TO_NUMBER(p_Codigo)) THEN 1
                   ELSE 0
              END;
-- Principal
BEGIN
   OPEN ListaDescricao;
   LOOP
      FETCH ListaDescricao INTO vSignificado;
      EXIT WHEN NOT FOUND;
      vRetorno:=vSignificado;
   END LOOP;
   CLOSE ListaDescricao;
   Return vRetorno;
END;
$$ language 'plpgsql';




/*-- SEQ 0346 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DescontoParcela (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE) CASCADE;

/*-- SEQ 0347 --*/
CREATE OR REPLACE FUNCTION DescontoParcela (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE)
RETURNS Numeric AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pNUMPAR ALIAS FOR $3 ;
pSUBPAR ALIAS FOR $4 ;
-- Objetivo:
-- 1) Obter o valor do desconto/acrscimo de uma subparcela  
  nAcrescimo TT_REC.VLRDES%TYPE;
  nDesconto TT_REC.VLRDES%TYPE;
  cMaxSubpar integer;
  nParAbe INTEGER;
BEGIN
  
  select VLRDES
      into nDesconto
  from tt_rec sub 
   where pCodfil=sub.codfil 
     and pSequen=sub.sequen
     and pNumpar=sub.numpar
     and sub.subpar=pSubpar
     and sub.flgest IN ('P','C');
     
  return COALESCE(nDesconto,0);
  
END;
$$ language 'plpgsql' STABLE;




/*-- SEQ 0348 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DIASSEMVENDA (TT_IVE.CODFIL%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE,TT_IVE.CODMUL%TYPE) CASCADE;

/*-- SEQ 0349 --*/
CREATE OR REPLACE FUNCTION DIASSEMVENDA (TT_IVE.CODFIL%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE,TT_IVE.CODMUL%TYPE)
RETURNS Numeric AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pFILMAT ALIAS FOR $2 ;
pCODMAT ALIAS FOR $3 ;
pCODCOR ALIAS FOR $4 ;
pCODTAM ALIAS FOR $5 ;
pCODMUL ALIAS FOR $6 ;

-- Objetivos:
-- 1. Calcular h quanto dias um determinado produto est sem vendas.

-- Declarao de variveis e cursores
   nDias                         Numeric;

-- Incio da funo
BEGIN
   BEGIN
      SELECT TRUNC(AGORA()) - MAX(TRUNC(VEN.DATHOR))
        INTO nDias
        FROM TT_IVE IVE
       INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
       WHERE IVE.CODFIL = pCODFIL
         AND IVE.FILMAT = pFILMAT
         AND IVE.CODMAT = pCODMAT
         AND IVE.CODCOR = pCODCOR
         AND IVE.CODTAM = pCODTAM
         AND IVE.CODMUL = pCODMUL
         AND IVE.LANEST IN ('S','R')
         AND VEN.LANVEN = 'T';
      END;

   RETURN COALESCE(nDias,-999);

END;
$$ language 'plpgsql';




/*-- SEQ 0350 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DiasUteis (VARCHAR,Timestamp,Timestamp,TT_UTL.FERABE%TYPE) CASCADE;

/*-- SEQ 0351 --*/
CREATE OR REPLACE FUNCTION DiasUteis (VARCHAR,Timestamp,Timestamp,TT_UTL.FERABE%TYPE)
RETURNS integer AS $$
DECLARE
pFilial ALIAS FOR $1 ;
pDATINI ALIAS FOR $2 ;
pDATFIM ALIAS FOR $3 ;
pFERABE ALIAS FOR $4 ;
   WK_CONTA                      Numeric(10);
BEGIN

   IF (pDATINI > pDATFIM)
   OR (pDATINI IS NULL)
   OR (pDATFIM IS NULL) THEN
      RETURN 0;
   END IF;

   IF pFERABE NOT IN ('T','F') THEN
      RAISE EXCEPTION 'PG-20000 Valor invlido para parmetro p_FERABE.';
   END IF;

   SELECT MAX(TAB.COUNT_UTL) INTO WK_CONTA 
     FROM (SELECT (SELECT COALESCE(COUNT(*),0)
                      FROM TT_UTL UTL
                     WHERE UTL.CODFIL = DFIL.CODFIL 
                       AND UTL.DATOPE BETWEEN TRUNC(pDATINI) AND (pDATFIM)
                       AND 1 = CASE WHEN pFERABE = 'T' THEN 1
                                    ELSE CASE WHEN UTL.FERABE = 'F' THEN 1
                                              ELSE 0
                                         END
                               END
                    ) AS COUNT_UTL
             FROM TD_FIL DFIL
            WHERE INSTR(COALESCE(pFilial, DFIL.CODFIL)||';', DFIL.CODFIL||';') > 0 ) TAB;

   RETURN WK_CONTA;

END;
$$ language 'plpgsql';


/*-- SEQ 0352 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DiasUteis (VARCHAR,Timestamp,Timestamp) CASCADE;

/*-- SEQ 0353 --*/
CREATE OR REPLACE FUNCTION DiasUteis (VARCHAR,
                               Timestamp,
                               Timestamp) 
RETURNS integer AS $$
BEGIN
RETURN DiasUteis($1,$2,$3,'F');
END;
$$ language 'plpgsql';


/*-- SEQ 0354 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Diferenca_Kit (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE,TT_IVE.NUMITE%TYPE) CASCADE;

/*-- SEQ 0355 --*/
CREATE OR REPLACE FUNCTION Diferenca_Kit (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE,TT_IVE.NUMITE%TYPE)
RETURNS Numeric AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pNUMITE ALIAS FOR $3 ;
pKITORI ALIAS FOR $4 ;

vSOMA       Numeric(12, 2);
vSOMAHEAD   Numeric(12, 2);
vMINNUMITE  Numeric(3);
BEGIN
  -- Obtm qual  o menor item do kit
  SELECT MIN(NUMITE), SUM(VLRMOV) INTO vMINNUMITE, vSOMA
    FROM TT_IVE
   WHERE KITORI = pKITORI 
     AND CODFIL = pCODFIL
     AND SEQUEN = pSEQUEN;
  
  IF pNUMITE = vMINNUMITE THEN 
    SELECT VLRMOV INTO vSOMAHEAD
      FROM TT_IVE IVE    
      WHERE NUMITE = pKITORI
      AND CODFIL = pCODFIL
      AND SEQUEN = pSEQUEN;
   
  RETURN vSOMAHEAD - vSOMA;
    
  ELSE 
    RETURN 0;
  END IF;
END;
$$ language 'plpgsql';




/*-- SEQ 0356 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DiferencaRenegociacao (TT_PAG.CODFIL%TYPE,TT_PAG.SEQUEN%TYPE,TT_PAG.RENEGO%TYPE) CASCADE;

/*-- SEQ 0357 --*/
CREATE OR REPLACE FUNCTION DiferencaRenegociacao (TT_PAG.CODFIL%TYPE,TT_PAG.SEQUEN%TYPE,TT_PAG.RENEGO%TYPE)
RETURNS Numeric AS $$
DECLARE
p_CodFil ALIAS FOR $1 ;
p_Sequen ALIAS FOR $2 ;
p_Renego ALIAS FOR $3 ;
   r_VlrOri TT_PAG.VLRPAR%TYPE;
   r_VlrRen TT_PAG.VLRPAR%TYPE;

-- Objetivo:
-- 1) Calcular a diferenca dos valores envolvidos em uma renegociacao de Contas a Pagar

BEGIN
  SELECT SUM(VLRPAR)
    INTO r_VlrOri
	FROM TT_PAG
   WHERE CODFIL = p_CodFil
     AND SEQUEN = p_Sequen
     AND RENEGO = p_Renego;

  SELECT SUM(VLRPAR)
    INTO r_VlrRen
	FROM TT_PAG
   WHERE CODFIL = p_CodFil
     AND SEQUEN = p_Sequen
     AND RENORI = p_Renego;

  RETURN COALESCE(r_VlrRen, 0) - COALESCE(r_VlrOri, 0);
  
END;
$$ language 'plpgsql';




/*-- SEQ 0358 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION EncerranteManual (TT_FCP.FILMED%TYPE,TT_FCP.TANMED%TYPE,TT_FCP.DATMED%TYPE,TT_FCP.CODBIC%TYPE) CASCADE;

/*-- SEQ 0359 --*/
CREATE OR REPLACE FUNCTION EncerranteManual (TT_FCP.FILMED%TYPE,TT_FCP.TANMED%TYPE,TT_FCP.DATMED%TYPE,TT_FCP.CODBIC%TYPE)
RETURNS Numeric AS $$
DECLARE
pFILMED ALIAS FOR $1 ;
pTANMED ALIAS FOR $2 ;
pDATMED ALIAS FOR $3 ;
pCODBIC ALIAS FOR $4 ;
 nRESULTADO TT_FCP.ENCMAN%TYPE;

BEGIN
  
  SELECT MAX(FCP.ENCMAN) 
         INTO nRESULTADO
    FROM TT_FCP FCP
   WHERE FCP.FILMED=pFILMED
     AND FCP.TANMED=pTANMED
     AND FCP.DATMED=pDATMED
     AND FCP.CODBIC=pCODBIC;
     
  RETURN nRESULTADO;   
     
                                      
END;
$$ language 'plpgsql' STABLE;




/*-- SEQ 0360 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION EnderecoCompleto (TT_END.FILCLI%TYPE,TT_END.CODCLI%TYPE,TT_END.CODFIL%TYPE,TT_END.NUMEND%TYPE) CASCADE;

/*-- SEQ 0361 --*/
CREATE OR REPLACE FUNCTION EnderecoCompleto (TT_END.FILCLI%TYPE,TT_END.CODCLI%TYPE,TT_END.CODFIL%TYPE,TT_END.NUMEND%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFilcli ALIAS FOR $1 ;
pCodcli ALIAS FOR $2 ;
pCodfil ALIAS FOR $3 ;
pNumend ALIAS FOR $4 ;
  vResultado VARCHAR(255) := '';
BEGIN
    SELECT SUBSTR(
           CASE WHEN COALESCE(TRIM(DEND.DESEND),' ') = ' ' THEN ''
                ELSE COALESCE(TRIM(DEND.DESEND),'') 
           END||
           CASE WHEN COALESCE(TRIM(ENDE.ENDERE),' ') = ' ' THEN ''
                ELSE '/'||COALESCE(TRIM(ENDE.ENDERE),'') 
           END||
           CASE WHEN COALESCE(TRIM(ENDE.NUMERO),' ') = ' ' THEN ''
                ELSE ', '||COALESCE(TRIM(ENDE.NUMERO),'') 
           END||
           CASE WHEN COALESCE(TRIM(ENDE.NOMCID),' ') = ' ' THEN ''
                ELSE '/'||COALESCE(TRIM(ENDE.NOMCID),'')
           END||
           CASE WHEN COALESCE(TRIM(REG.REGIAO),' ') = ' ' THEN ''
                ELSE '/'||COALESCE(TRIM(REG.REGIAO),'')
           END||
           CASE WHEN COALESCE(TRIM(ENDE.SIGEST),' ') = ' ' THEN ''
                ELSE '/'||COALESCE(TRIM(ENDE.SIGEST),'')
           END||
           CASE WHEN ENDE.SIGNAT >= 0 THEN ''
                ELSE ' - DESATIVADO'
           END, 1, 255)
      INTO vResultado
      FROM TT_END ENDE LEFT JOIN TD_END DEND ON DEND.CODTAB = ENDE.TIPEND
                       LEFT JOIN TD_REG REG ON REG.CODTAB = ENDE.REGIAO
     WHERE ENDE.FILCLI = pFilcli
       AND ENDE.CODCLI = pCodcli
       AND ENDE.CODFIL = pCodfil
       AND ENDE.NUMEND = pNumend;

  RETURN vResultado;
END;
$$ language 'plpgsql';




/*-- SEQ 0362 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION EnviaRemessa (TD_CCB.CODTAB%TYPE) CASCADE;

/*-- SEQ 0363 --*/
CREATE OR REPLACE FUNCTION EnviaRemessa (TD_CCB.CODTAB%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCodtab ALIAS FOR $1 ;
  WK_RESULT CHAR(1);
BEGIN
  SELECT ENVREM
    INTO WK_RESULT
    FROM TD_CCB
   WHERE CODTAB = pCodtab;
  RETURN COALESCE(WK_RESULT,'F');
EXCEPTION
  WHEN NO_DATA_FOUND THEN RETURN 'F';
END;
$$ language 'plpgsql';




/*-- SEQ 0364 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION EstadosValidos (TT_FLW.SITORI%TYPE,CHAR) CASCADE;

/*-- SEQ 0365 --*/
CREATE OR REPLACE FUNCTION EstadosValidos (TT_FLW.SITORI%TYPE,CHAR)
RETURNS VARCHAR AS $$
DECLARE
pSITORI ALIAS FOR $1 ;
pWEB ALIAS FOR $2 ;

  cESTADOS VARCHAR(4000);
  cSITORI  TD_SIT.CODTAB%TYPE;
  cDES     TD_SIT.DESSIT%TYPE;
  cSIT     VARCHAR(2);
  i        Numeric(2);

  CR_ESTADOS CURSOR(pSITORI TD_SIT.CODTAB%TYPE) IS
--  DN - Colocado o estado SITORI=SITDES na TT_FLW para simplificar no Genexus
--  SELECT TO_CHAR(pSITORI) FROM DUAL
--  UNION ALL
  SELECT DISTINCT TO_CHAR(INT.SITDES) FROM (
    SELECT SITDES
      FROM TT_FLW
     WHERE SITORI = pSITORI
     ORDER BY SITDES
  ) INT;

  CR_ESTADOS_INICIAL CURSOR(pSITORI TD_SIT.CODTAB%TYPE) IS
  SELECT DISTINCT TO_CHAR(INT.SITDES) FROM (
    SELECT SITDES
      FROM TT_FLW
     WHERE SITORI IS NULL
     ORDER BY SITDES
  ) INT;
   
BEGIN
  -- davi -  41196 - 24/05/06
  -- atravs da situacao de origem e do tipo da linguagem (delphi ou php), retorna uma string formatada
  -- com as opcoes disponiveis como situacao de destino, para preenchimento do combo usando coluna virtual
  i := 0;
  cESTADOS := ''; 
  IF pSITORI IS NULL THEN
     OPEN CR_ESTADOS_INICIAL(pSITORI);
     LOOP
        FETCH CR_ESTADOS_INICIAL INTO cSIT;
        EXIT WHEN NOT FOUND; 
        SELECT DESSIT INTO cDES FROM TD_SIT WHERE CODTAB = TO_NUMBER(cSIT);
        IF pWEB = 'F' THEN -- SE FOR DELPHI
           cESTADOS := cESTADOS||cDES||CHR(35)||cSIT||CHR(13);
        ELSE
           --SE FOR WEB
           IF i = 0 THEN --PRIMEIRO
              cESTADOS := '<option value="'||cSIT||'" selected>'||cDES||'</option>'||chr(13);
	   ELSE
      	      cESTADOS := cESTADOS||'<option value="'||cSIT||'">'||cDES||'</option>'||chr(13);
	   END IF;
        END IF;
        i := i+1;
     END LOOP;
     CLOSE CR_ESTADOS_INICIAL;
  ELSE
     OPEN CR_ESTADOS(pSITORI);  
     LOOP
        FETCH CR_ESTADOS INTO cSIT;
        EXIT WHEN NOT FOUND; 
        SELECT DESSIT INTO cDES FROM TD_SIT WHERE CODTAB = TO_NUMBER(cSIT);
        IF pWEB = 'F' THEN -- SE FOR DELPHI
           cESTADOS := cESTADOS||cDES||CHR(35)||cSIT||CHR(13);
        ELSE
           --SE FOR WEB
           IF pSITORI = cSIT THEN --Selecionado
              cESTADOS := cESTADOS||'<option value="'||cSIT||'" selected>'||cDES||'</option>'||chr(13);
			ELSE
      	      cESTADOS := cESTADOS||'<option value="'||cSIT||'">'||cDES||'</option>'||chr(13);
			END IF;
        END IF;
        i := i+1;
     END LOOP;
     CLOSE CR_ESTADOS;
  END IF;
     
  cESTADOS := SUBSTR(cESTADOS,1,LENGTH(cESTADOS)-1);
  RETURN (cESTADOS);

END;
$$ language 'plpgsql';




/*-- SEQ 0366 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION FornecedoresAtendidos (TT_IPE.FILORI%TYPE,TT_IPE.PEDORI%TYPE,TT_IPE.ITEORI%TYPE) CASCADE;

/*-- SEQ 0367 --*/
CREATE OR REPLACE FUNCTION FornecedoresAtendidos (TT_IPE.FILORI%TYPE,TT_IPE.PEDORI%TYPE,TT_IPE.ITEORI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILORI ALIAS FOR $1 ;
pPEDORI ALIAS FOR $2 ;
pITEORI ALIAS FOR $3 ;

WK_FILFOR TT_CLI.FILCLI%TYPE;
WK_CODFOR TT_CLI.CODCLI%TYPE;
WK_FILORI TT_IPE.FILORI%TYPE;
WK_PEDORI TT_IPE.PEDORI%TYPE;
WK_ITEORI TT_IPE.ITEORI%TYPE;

BEGIN 
   
  BEGIN
    SELECT PED.FILFOR, PED.CODFOR, IPE.FILORI, IPE.PEDORI, IPE.ITEORI
      INTO WK_FILFOR, WK_CODFOR, WK_FILORI, WK_PEDORI, WK_ITEORI
      FROM TT_PED PED INNER JOIN TT_IPE IPE ON PED.CODFIL = IPE.CODFIL
                                           AND PED.NUMPED = IPE.NUMPED
     WHERE IPE.CODFIL = pFILORI
       AND IPE.NUMPED = pPEDORI
       AND IPE.NUMITE = pITEORI;
  EXCEPTION
        
    WHEN others THEN NULL;
      END;

  RETURN (WK_FILFOR||WK_CODFOR||COALESCE(WK_FILORI,'000')||COALESCE(WK_PEDORI,'00000000')||COALESCE(TO_CHAR(WK_ITEORI),'00000'));

END;
$$ language 'plpgsql';


      


/*-- SEQ 0368 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GetCoduidAtual () CASCADE;

/*-- SEQ 0369 --*/
CREATE OR REPLACE FUNCTION GetCoduidAtual ()
RETURNS TT_UID.CODUID%TYPE AS $$
DECLARE


-- Objetivos:
-- 1. Retorna o CODUID atual do usurio logado

-- Declarao de variveis e cursores

-- Douglas - 79829
   vCODUID                       TT_UID.CODUID%TYPE;

-- Incio da funo
BEGIN
   BEGIN
      SELECT MAX(CODUID) INTO vCODUID FROM TMP_UID;
   EXCEPTION
      WHEN OTHERS THEN vCODUID := NULL;
   END;

/*
      SELECT MAX(TT_UID.CODUID)
      INTO vCODUID
      FROM TT_UID
     WHERE SESSION_ID = USERENV('SESSIONID')
       AND TERMIN='F';
  */

  RETURN vCODUID;

END;
$$ language 'plpgsql';




/*-- SEQ 0370 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GRANDEZAS_CARGA (VARCHAR,TT_ROM.CODFIL%TYPE,TT_ROM.SEQUEN%TYPE) CASCADE;

/*-- SEQ 0371 --*/
CREATE OR REPLACE FUNCTION GRANDEZAS_CARGA (VARCHAR,TT_ROM.CODFIL%TYPE,TT_ROM.SEQUEN%TYPE)
RETURNS Numeric AS $$
DECLARE
p_Tipo ALIAS FOR $1 ;
p_CodFil ALIAS FOR $2 ;
p_Sequen ALIAS FOR $3 ;
   vPESBRU TT_GRA.PESBRU%TYPE;
   vVOLUME TT_GRA.VOLUME%TYPE;
   vVLRITE TT_IOR.VLRITE%TYPE;
   vRESULT Numeric;

-- Tipos:
-- P - Peso
-- V - Volume
-- N - Valor

-- Objetivo:
-- 1) Calcular as grandezas da carga

BEGIN
  SELECT SUM(GRA.PESBRU*IVO.CONTEM) AS PESBRU,
	     SUM(GRA.VOLUME*IVO.CONTEM) AS VOLUME,
	     SUM(IVO.VLRITE*IVO.CONTEM) AS VLRITE
    INTO vPESBRU, vVOLUME, vVLRITE
	  FROM (
	        SELECT IVO.CONTEM,
	               IOR.FILMAT,
	               IOR.CODMAT,
	               IOR.CODCOR,
	               IOR.CODTAM,
	               IOR.VLRITE AS VLRITE
	          FROM TT_IVO IVO INNER JOIN TT_IOR IOR ON IOR.CODFIL = IVO.FILPED
	                                               AND IOR.TIPPED = IVO.TIPPED
	                                               AND IOR.NUMPED = IVO.NUMPED
	                                               AND IOR.NUMITE = IVO.NUMITE
	         WHERE IVO.FILROM = p_CodFil
	           AND IVO.SEQROM = p_Sequen 
	           AND IVO.FLGEST = 'P'
               AND IOR.QTDITE > 0
	        UNION ALL
	        SELECT IVO.CONTEM,
	               IVE.FILMAT,
	               IVE.CODMAT,
	               IVE.CODCOR,
	               IVE.CODTAM,
	               IVE.VLRMOV/IVE.QTDMOV AS VLRITE
	          FROM TT_IVO IVO INNER JOIN TT_IVE IVE ON IVE.CODFIL = IVO.FILIVE
	                                               AND IVE.SEQUEN = IVO.SEQIVE
	                                               AND IVE.NUMITE = IVO.NUMIVE
	         WHERE IVO.FILROM = p_CodFil
	           AND IVO.SEQROM = p_Sequen
	           AND IVO.FLGEST = 'P'
               AND IVE.QTDMOV > 0
	       ) IVO
	                 INNER JOIN TT_GRA GRA ON GRA.FILMAT = IVO.FILMAT
	                                      AND GRA.CODMAT = IVO.CODMAT
	                                      AND GRA.CODCOR = IVO.CODCOR
	                                      AND GRA.CODTAM = IVO.CODTAM;
  
  IF p_Tipo = 'P' THEN
    vRESULT := vPESBRU;
  ELSIF p_Tipo = 'V' THEN
    vRESULT := vVOLUME;
  ELSE 
    vRESULT := vVLRITE;
  END IF;  

  RETURN COALESCE(vRESULT,0);
  
END;
$$ language 'plpgsql';




/*-- SEQ 0372 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GravaVinculosAux (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE) CASCADE;

/*-- SEQ 0373 --*/
CREATE OR REPLACE FUNCTION GravaVinculosAux (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_filcli ALIAS FOR $1 ;
p_codcli ALIAS FOR $2 ;
p_filven ALIAS FOR $3 ;
p_codven ALIAS FOR $4 ;

  r_filcli TT_CLI.FILCLI%TYPE;
  r_codcli TT_CLI.CODCLI%TYPE;
  r_numdoc TT_CLI.NUMDOC%TYPE;
  r_tipreg TW_VRES.TIPREG%TYPE;
  c_dummy VARCHAR(15);

  a_vsalva VARCHAR[];
  a_hsalva VARCHAR[];
  n_conta INTEGER;

FILHOS CURSOR FOR
  select filcli, codcli, numdoc
    from tt_cli
   where filvin = p_filcli
     and codvin = p_codcli;

BEGIN

  n_conta := 0;

 OPEN Filhos;
 LOOP

  n_conta := n_conta + 1;

  FETCH Filhos into r_filcli, r_codcli, r_numdoc;
  EXIT WHEN NOT FOUND;

  c_dummy := r_filcli||','||r_codcli;
  IF n_conta = 1 THEN
    select ARRAY[c_dummy] into a_vsalva;
  ELSE
   select array_append (a_vsalva,c_dummy) into a_vsalva;
  END IF;

  if r_numdoc is not null then
    if (r_filcli = p_filven) and (r_codcli = p_codven) then
     r_tipreg := 'V';
    else
     r_tipreg := 'C';
    end if;
    INSERT INTO TW_VRES (USERID, NUMDOC, TIPREG) VALUES (USERENV( 'SESSIONID' ),r_numdoc, r_tipreg);
  end if;
 END LOOP;
 Close Filhos;

 FOR i IN 1..n_conta-1 LOOP
   select '{'||a_vsalva[i]||'}' into a_hsalva;
   c_dummy := GravaVinculosAux( a_hsalva[1], a_hsalva[2], p_filven, p_codven );
 END LOOP;

  RETURN NULL; 
END;
$$ language 'plpgsql';





/*-- SEQ 0374 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION HaNumeros (VARCHAR) CASCADE;

/*-- SEQ 0375 --*/
CREATE OR REPLACE FUNCTION HaNumeros (VARCHAR)
RETURNS Numeric AS $$
DECLARE
Dado ALIAS FOR $1 ;
  i      Numeric;
  Digito Numeric(1);
begin

  IF ISNULL(Dado) = 'T' THEN
    Digito := -1;
  ELSE
    Digito := 1;
    FOR i IN 1..LENGTH(Dado) LOOP
      IF SUBSTR(Dado,i,1) in ('0','1','2','3','4','5','6','7','8','9') THEN
        Digito := 0;
      END IF;
      EXIT WHEN Digito = 0;
    END LOOP;  
  END IF;
  RETURN Digito;
END;
$$ language 'plpgsql';




/*-- SEQ 0376 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION HORAS_CONTRATADAS (TD_FIL.CODFIL%TYPE,TT_DAT.DATOPE%TYPE,TT_DAT.DATOPE%TYPE) CASCADE;

/*-- SEQ 0377 --*/
CREATE OR REPLACE FUNCTION HORAS_CONTRATADAS (TD_FIL.CODFIL%TYPE,TT_DAT.DATOPE%TYPE,TT_DAT.DATOPE%TYPE)
RETURNS Numeric AS $$
DECLARE
PCODFIL ALIAS FOR $1 ;
PDATINI ALIAS FOR $2 ;
PDATFIN ALIAS FOR $3 ;
WK_HORAS Numeric;
BEGIN
SELECT SUM(CASE TO_NUMBER(TO_CHAR(DIA.DATOPE,'D')) WHEN 1 THEN USU.HORDOM
                                                   WHEN 2 THEN USU.HORSEG
                                                   WHEN 3 THEN USU.HORTER
                                                   WHEN 4 THEN USU.HORQUA
                                                   WHEN 5 THEN USU.HORQUI
                                                   WHEN 6 THEN USU.HORSEX
                                                          ELSE USU.HORSAB END)
INTO WK_HORAS
  FROM TT_DAT DIA,
       (SELECT DISTINCT VEN.FILVEN, VEN.CODVEN
          FROM TT_VEN VEN
         WHERE VEN.CODFIL = PCODFIL
           AND VEN.DATHOR >= PDATINI
           AND VEN.DATHOR <  PDATFIN) VDD INNER JOIN TT_USU USU ON USU.FILUSU = VDD.FILVEN AND USU.CODUSU = VDD.CODVEN
 WHERE DIA.DATOPE >= PDATINI
   AND DIA.DATOPE <= PDATFIN;

RETURN WK_HORAS;
END;
$$ language 'plpgsql';


/*-- SEQ 0378 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION HORAS_CONTRATADAS (TD_FIL.CODFIL%TYPE,TT_DAT.DATOPE%TYPE,TT_DAT.DATOPE%TYPE) CASCADE;

/*-- SEQ 0379 --*/
CREATE OR REPLACE FUNCTION HORAS_CONTRATADAS (TD_FIL.CODFIL%TYPE,
                               TT_DAT.DATOPE%TYPE,
                               TT_DAT.DATOPE%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN HORAS_CONTRATADAS($1,$2,$3);
END;
$$ language 'plpgsql';


/*-- SEQ 0380 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION HORAS_FALTANTES (TD_SIT.TIPSIT%TYPE,TT_WOR.TARPRE%TYPE,TT_WOR.TARREA%TYPE,TT_WOR.CONCLU%TYPE,TT_CFG.USA_PERC_HORFAL%TYPE,TT_WOR.FILRES%TYPE,TT_WOR.CODRES%TYPE,TT_WOR.MODULO%TYPE,TT_WOR.TIPTAR%TYPE) CASCADE;

/*-- SEQ 0381 --*/
CREATE OR REPLACE FUNCTION HORAS_FALTANTES (TD_SIT.TIPSIT%TYPE,TT_WOR.TARPRE%TYPE,TT_WOR.TARREA%TYPE,TT_WOR.CONCLU%TYPE,TT_CFG.USA_PERC_HORFAL%TYPE,TT_WOR.FILRES%TYPE,TT_WOR.CODRES%TYPE,TT_WOR.MODULO%TYPE,TT_WOR.TIPTAR%TYPE)
RETURNS Numeric AS $$
DECLARE
pFLGEST ALIAS FOR $1 ;
pTARPRE ALIAS FOR $2 ;
pTARREA ALIAS FOR $3 ;
pCONCLU ALIAS FOR $4 ;
pUSA_PERC_HORFAL ALIAS FOR $5 ;
pFILRES ALIAS FOR $6 ;
pCODRES ALIAS FOR $7 ;
pMODULO ALIAS FOR $8 ;
pTIPTAR ALIAS FOR $9 ;

cUSA_PERC_HORFAL TT_CFG.USA_PERC_HORFAL%TYPE;
vMEDIA Numeric(14,2);

BEGIN

IF pUSA_PERC_HORFAL IS NULL THEN
   SELECT USA_PERC_HORFAL INTO cUSA_PERC_HORFAL
     FROM TT_CFG;
ELSE 
  cUSA_PERC_HORFAL:=pUSA_PERC_HORFAL;
END IF;

IF pFLGEST in ('C','S','1','X') THEN 
   RETURN 0;
ELSIF cUSA_PERC_HORFAL='F' THEN 
   RETURN GREATEST(pTARPRE-pTARREA,0);
ELSIF (pTARREA = 0 OR pCONCLU <= 20) AND pTARPRE>pTARREA THEN 
   RETURN pTARPRE-pTARREA;
ELSIF pCONCLU = 0 AND pTARPRE > 0 THEN    
   RETURN pTARPRE;
ELSIF pTARREA > 0 AND pCONCLU > 0 THEN
   RETURN (pTARREA*100/pCONCLU)-pTARREA;   
ELSIF pFILRES IS NOT NULL THEN
				select coalesce(round(avg(wor.tarrea),1),0) INTO vMEDIA
				   from tt_wor wor inner join td_sit sit on sit.codtab=wor.flgsit
				  where sit.tipsit in ('1')
					and wor.fimtar > agora()-120
					and wor.modulo = pMODULO
					and wor.filres = pFILRES
					and wor.codres = pCODRES
					and wor.tiptar = pTIPTAR;
			RETURN vMEDIA;
			
	ELSE
	    RETURN 0;
END IF;
END;
$$ language 'plpgsql';




/*-- SEQ 0382 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION HORAS_TRABALHADAS (TD_FIL.CODFIL%TYPE,TT_DAT.DATOPE%TYPE,TT_DAT.DATOPE%TYPE,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE) CASCADE;

/*-- SEQ 0383 --*/
CREATE OR REPLACE FUNCTION HORAS_TRABALHADAS (TD_FIL.CODFIL%TYPE,TT_DAT.DATOPE%TYPE,TT_DAT.DATOPE%TYPE,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE)
RETURNS Numeric AS $$
DECLARE
PCODFIL ALIAS FOR $1 ;
PDATINI ALIAS FOR $2 ;
PDATFIN ALIAS FOR $3 ;
PFILUSU ALIAS FOR $4 ;
PCODUSU ALIAS FOR $5 ;
WK_QTDVENDAS Numeric;
WK_HORAS_TRABALHADAS Numeric;
BEGIN

SELECT COUNT(*) 
  INTO WK_QTDVENDAS
  FROM TT_VEN VEN
 WHERE VEN.CODFIL = PCODFIL
   AND VEN.DATHOR >= PDATINI
   AND VEN.DATHOR <  PDATFIN
   AND VEN.FILVEN = PFILUSU
   AND VEN.CODVEN = PCODUSU;

IF WK_QTDVENDAS = 0  THEN
   RETURN 0;
ELSE
SELECT SUM( COALESCE(CONTRADADA,0) - COALESCE(AUSENCIA,0) ) AS TRABALHADA
  INTO WK_HORAS_TRABALHADAS
  FROM (SELECT DIA.DATOPE,
               CASE TO_NUMBER(TO_CHAR(DIA.DATOPE,'D')) WHEN 1 THEN USU.HORDOM
                                                       WHEN 2 THEN USU.HORSEG
                                                       WHEN 3 THEN USU.HORTER
                                                       WHEN 4 THEN USU.HORQUA
                                                       WHEN 5 THEN USU.HORQUI
                                                       WHEN 6 THEN USU.HORSEX
                                                              ELSE USU.HORSAB END AS CONTRADADA,
               (SELECT SUM(AUS.QTDHOR)
                  FROM TT_AUS AUS
                 WHERE AUS.DATAUS = DIA.DATOPE
                   AND AUS.FILUSU = USU.FILUSU
                   AND AUS.CODUSU = USU.CODUSU
                   AND (AUS.FILAUS IS NULL OR AUS.FILAUS = PCODFIL)
               ) AS AUSENCIA
          FROM  TT_DAT DIA, TT_USU USU
         WHERE USU.FILUSU = PFILUSU
           AND USU.CODUSU = PCODUSU
           AND DIA.DATOPE >= PDATINI
           AND DIA.DATOPE <= PDATFIN) tab;
RETURN WK_HORAS_TRABALHADAS;
END IF;
END;
$$ language 'plpgsql';


/*-- SEQ 0384 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION HORAS_TRABALHADAS (TD_FIL.CODFIL%TYPE,TT_DAT.DATOPE%TYPE,TT_DAT.DATOPE%TYPE,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE) CASCADE;

/*-- SEQ 0385 --*/
CREATE OR REPLACE FUNCTION HORAS_TRABALHADAS (TD_FIL.CODFIL%TYPE,
                               TT_DAT.DATOPE%TYPE,
                               TT_DAT.DATOPE%TYPE,
                               TT_USU.FILUSU%TYPE,
                               TT_USU.CODUSU%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN HORAS_TRABALHADAS($1,$2,$3,$4,$5);
END;
$$ language 'plpgsql';


/*-- SEQ 0386 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ValorICMSVenda (TT_IUF.FILMAT%TYPE,TT_IUF.CODMAT%TYPE,TT_IUF.ESTADO%TYPE) CASCADE;

/*-- SEQ 0387 --*/
CREATE OR REPLACE FUNCTION ValorICMSVenda (TT_IUF.FILMAT%TYPE,TT_IUF.CODMAT%TYPE,TT_IUF.ESTADO%TYPE)
RETURNS Numeric AS $$
DECLARE
pFILMAT ALIAS FOR $1 ;
pCODMAT ALIAS FOR $2 ;
pESTADO ALIAS FOR $3 ;
-- Objetivo:
-- 1) Obter o valor do ICMS da venda
  cRESICM TT_IUF.RESICM%TYPE;
BEGIN
  SELECT (COALESCE(ICM.RESICM,0) * ((100-COALESCE(IRE.ICMSRE,0))/100)) AS RESICM  INTO cRESICM                                    
    FROM TT_IUF IUF LEFT JOIN TD_ICM ICM ON ICM.CODTAB = IUF.RESICM           
                    LEFT JOIN TD_IRE IRE ON IUF.REDALI = IRE.CODTAB 
   WHERE IUF.FILMAT = pFILMAT                                                
     AND IUF.CODMAT = pCODMAT                                                 
     AND IUF.ESTADO = pESTADO                                                 
     AND IUF.REGESP = (SELECT REGESP                                          
                         FROM TD_FIL                                          
                        WHERE CODFIL = COALESCE((SELECT FILCMP FROM TT_CFG),  
                                                (SELECT CODLOJ FROM TT_IDF))); 
  RETURN COALESCE(cRESICM,0);
END;
$$ language 'plpgsql';




/*-- SEQ 0388 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_DIV_NOMDIV_AUX (TI_PRO.ITEDIV%TYPE) CASCADE;

/*-- SEQ 0389 --*/
CREATE OR REPLACE FUNCTION IMPORTA_DIV_NOMDIV_AUX (TI_PRO.ITEDIV%TYPE)
RETURNS VARCHAR AS $$
DECLARE
P_ITEDIV ALIAS FOR $1 ;

-- Objetivos:
-- 1. Definir NOMITE da TT_DIV para incluso de novo registro.
--    Como a coluna tem apenas 10 posies,  necessrio definir um nome nico a partir do
--    NOMEXT que tem 20 posies.

   WK_NOMITE_DIV                 TT_DIV.NOMITE%TYPE;
   WK_QTD_DIV                    INTEGER;
   iSequenciador                 INTEGER;

BEGIN
   SELECT COUNT(*)
     INTO WK_QTD_DIV
     FROM TT_DIV
    WHERE NOMITE = SUBSTR(TRIM(P_ITEDIV),1,10);

   IF WK_QTD_DIV = 0 THEN
      WK_NOMITE_DIV := SUBSTR(P_ITEDIV,1,10);
   ELSE
      SELECT COALESCE(MAX(TO_NUMBER(SUBSTR(NOMITE, INSTR(NOMITE,'#')+1,3))),0) AS SEQ
        INTO iSequenciador
        FROM TT_DIV
       WHERE SUBSTR(NOMITE,1,7) LIKE SUBSTR(P_ITEDIV,1,6)||'#%';

      WK_NOMITE_DIV := SUBSTR(P_ITEDIV,1,6)||'#'||LPAD(TO_CHAR(iSequenciador+1),3,'0');
   END IF;

   RETURN WK_NOMITE_DIV;

END;
$$ language 'plpgsql';



/*-- SEQ 0390 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_DIV (TI_PRO.ITEDIV_CODEXT%TYPE,TI_PRO.ITEDIV%TYPE,TT_DIV.CODDIV%TYPE) CASCADE;

/*-- SEQ 0391 --*/
CREATE OR REPLACE FUNCTION IMPORTA_DIV (TI_PRO.ITEDIV_CODEXT%TYPE,TI_PRO.ITEDIV%TYPE,TT_DIV.CODDIV%TYPE)
RETURNS Numeric AS $$
DECLARE
P_ITEDIV_CODEXT ALIAS FOR $1 ;
P_ITEDIV ALIAS FOR $2 ;
P_CODDIV ALIAS FOR $3 ;

-- Objetivos:
-- 1. Importar TT_DIV pelo cdigo externo.
-- 2. Importar TT_DIV pela descrio (mtodo antigo).

  WK_CODCOR                      Numeric;
  WK_AUX_DIV_NOMEXT              TT_DIV.NOMEXT%TYPE;
  WK_NOMITE_DIV                  TT_DIV.NOMITE%TYPE;

BEGIN
   WK_CODCOR         := NULL;
   WK_AUX_DIV_NOMEXT := NULL;

   --------------------------------------------------------------------------------------
   -- 1. Importa pelo cdigo externo
   --------------------------------------------------------------------------------------
   IF P_ITEDIV_CODEXT IS NOT NULL THEN

      -- Verifica se registro existe
               SELECT CODITE, NOMEXT
           INTO WK_CODCOR, WK_AUX_DIV_NOMEXT
           FROM TT_DIV
          WHERE CODEXT = P_ITEDIV_CODEXT;
      
      -- Se no existe, ento inclui
      IF WK_CODCOR IS NULL THEN
         WK_NOMITE_DIV := IMPORTA_DIV_NOMDIV_AUX(P_ITEDIV);

         SELECT COALESCE((SELECT MAX(CODITE) FROM TT_DIV),0)+1
           INTO WK_CODCOR
           FROM DUAL;

         INSERT INTO TT_DIV
            (CODITE,CODDIV,NOMITE,NOMEXT,CODEXT)
            (SELECT WK_CODCOR,
                    P_CODDIV,
                    WK_NOMITE_DIV,
                    P_ITEDIV,
                    P_ITEDIV_CODEXT
               FROM DUAL);
     ELSE
         IF P_ITEDIV <> WK_AUX_DIV_NOMEXT THEN
            WK_NOMITE_DIV := IMPORTA_DIV_NOMDIV_AUX(P_ITEDIV);

            UPDATE TT_DIV
               SET NOMITE = WK_NOMITE_DIV,
                   NOMEXT = P_ITEDIV
             WHERE CODITE = WK_CODCOR;
         END IF;
     END IF;

     RETURN WK_CODCOR;
     -- Fim da funcao
   END IF;

   --------------------------------------------------------------------------------------
   -- 2. Importa pela descrio
   --------------------------------------------------------------------------------------
         SELECT MIN(DIV.CODITE)
        INTO WK_CODCOR
        FROM TT_DIV DIV
       WHERE DIV.NOMEXT = P_ITEDIV
         AND DIV.CODDIV = P_CODDIV
         AND DIV.CODEXT IS NULL;
   
   -- Se no existe, ento inclui
   IF WK_CODCOR IS NULL THEN
      WK_NOMITE_DIV := IMPORTA_DIV_NOMDIV_AUX(P_ITEDIV);

      SELECT COALESCE((SELECT MAX(CODITE) FROM TT_DIV),0)+1
        INTO WK_CODCOR
        FROM DUAL;

      INSERT INTO TT_DIV
         (CODITE,CODDIV,NOMITE,NOMEXT,CODEXT)
         (SELECT WK_CODCOR,
                 P_CODDIV,
                 WK_NOMITE_DIV,
                 P_ITEDIV,
                 P_ITEDIV_CODEXT
            FROM DUAL);
   END IF;

   RETURN WK_CODCOR;
END;
$$ language 'plpgsql';




/*-- SEQ 0392 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_SUB_NOMSUB_AUX (TI_PRO.ITESUB%TYPE) CASCADE;

/*-- SEQ 0393 --*/
CREATE OR REPLACE FUNCTION IMPORTA_SUB_NOMSUB_AUX (TI_PRO.ITESUB%TYPE)
RETURNS VARCHAR AS $$
DECLARE
P_ITESUB ALIAS FOR $1 ;

-- Objetivos:
-- 1. Definir NOMITE da TT_SUB para incluso de novo registro.
--    Como a coluna tem apenas 10 posies,  necessrio definir um nome nico a partir do
--    NOMEXT que tem 20 posies.

   WK_NOMITE_SUB                 TT_SUB.NOMITE%TYPE;
   WK_QTD_SUB                    INTEGER;
   iSequenciador                 INTEGER;

BEGIN
   SELECT COUNT(*)
     INTO WK_QTD_SUB
     FROM TT_SUB
    WHERE NOMITE = SUBSTR(TRIM(P_ITESUB),1,10);

   IF WK_QTD_SUB = 0 THEN
      WK_NOMITE_SUB := SUBSTR(P_ITESUB,1,10);
   ELSE
      SELECT COALESCE(MAX(TO_NUMBER(SUBSTR(NOMITE, INSTR(NOMITE,'#')+1,3))),0) AS SEQ
        INTO iSequenciador
        FROM TT_SUB
       WHERE SUBSTR(NOMITE,1,7) LIKE SUBSTR(P_ITESUB,1,6)||'#%';

      WK_NOMITE_SUB := SUBSTR(P_ITESUB,1,6)||'#'||LPAD(TO_CHAR(iSequenciador+1),3,'0');
   END IF;

   RETURN WK_NOMITE_SUB;

END;
$$ language 'plpgsql';



/*-- SEQ 0394 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_SUB (TI_PRO.ITESUB_CODEXT%TYPE,TI_PRO.ITESUB%TYPE,TT_SUB.CODSUB%TYPE,TT_SUB.FATCON%TYPE) CASCADE;

/*-- SEQ 0395 --*/
CREATE OR REPLACE FUNCTION IMPORTA_SUB (TI_PRO.ITESUB_CODEXT%TYPE,TI_PRO.ITESUB%TYPE,TT_SUB.CODSUB%TYPE,TT_SUB.FATCON%TYPE)
RETURNS Numeric AS $$
DECLARE
P_ITESUB_CODEXT ALIAS FOR $1 ;
P_ITESUB ALIAS FOR $2 ;
P_CODSUB ALIAS FOR $3 ;
P_FATCON ALIAS FOR $4 ;

-- Objetivos:
-- 1. Importar TT_SUB pelo cdigo externo.
-- 2. Importar TT_SUB pela descrio (mtodo antigo).

   WK_CODTAM                     Numeric;
   WK_AUX_SUB_NOMEXT             TT_SUB.NOMEXT%TYPE;
   WK_NOMITE_SUB                 TT_SUB.NOMITE%TYPE;

BEGIN
   WK_CODTAM         := NULL;
   WK_AUX_SUB_NOMEXT := NULL;

   --------------------------------------------------------------------------------------
   -- 1. Importa pelo cdigo externo
   --------------------------------------------------------------------------------------
   IF P_ITESUB_CODEXT IS NOT NULL THEN

      -- Verifica se registro existe
               SELECT CODITE, NOMEXT
           INTO WK_CODTAM, WK_AUX_SUB_NOMEXT
           FROM TT_SUB
          WHERE CODEXT = P_ITESUB_CODEXT;
      
      -- Se no existe, ento inclui
      IF WK_CODTAM IS NULL THEN
         WK_NOMITE_SUB := IMPORTA_SUB_NOMSUB_AUX(P_ITESUB);

         SELECT COALESCE((SELECT MAX(CODITE) FROM TT_SUB),0)+1
           INTO WK_CODTAM
           FROM DUAL;

         INSERT INTO TT_SUB
            (CODITE,CODSUB,NOMITE,NOMEXT,CODEXT,FATCON)
            (SELECT WK_CODTAM,
                    P_CODSUB,
                    WK_NOMITE_SUB,
                    P_ITESUB,
                    P_ITESUB_CODEXT,
                    NVLZ(P_FATCON,1)
               FROM DUAL);
     ELSE
         IF P_ITESUB <> WK_AUX_SUB_NOMEXT THEN
            WK_NOMITE_SUB := IMPORTA_SUB_NOMSUB_AUX(P_ITESUB);

            UPDATE TT_SUB
               SET NOMITE = WK_NOMITE_SUB,
                   NOMEXT = P_ITESUB,
                   FATCON = NVLZ(P_FATCON,FATCON) -- Atualiza Fator de Converso apenas quando informado valor superior a zero
             WHERE CODITE = WK_CODTAM;
         ELSIF (COALESCE(P_FATCON,0) > 0) THEN
            UPDATE TT_SUB
               SET FATCON = NVLZ(P_FATCON,FATCON) -- Atualiza Fator de Converso apenas quando informado valor superior a zero
             WHERE CODITE = WK_CODTAM;
         END IF;
     END IF;

     RETURN WK_CODTAM;
     -- Fim da funcao
   END IF;

   --------------------------------------------------------------------------------------
   -- 2. Importa pela descrio
   --------------------------------------------------------------------------------------
         SELECT MIN(SUB.CODITE)
        INTO WK_CODTAM
        FROM TT_SUB SUB
       WHERE SUB.NOMEXT = P_ITESUB
         AND SUB.CODSUB = P_CODSUB
         AND SUB.CODEXT IS NULL;
   
   -- Se no existe, ento inclui
   IF WK_CODTAM IS NULL THEN
      WK_NOMITE_SUB := IMPORTA_SUB_NOMSUB_AUX(P_ITESUB);

      SELECT COALESCE((SELECT MAX(CODITE) FROM TT_SUB),0)+1
        INTO WK_CODTAM
        FROM DUAL;

      INSERT INTO TT_SUB
         (CODITE,CODSUB,NOMITE,NOMEXT,CODEXT,FATCON)
         (SELECT WK_CODTAM,
                 P_CODSUB,
                 WK_NOMITE_SUB,
                 P_ITESUB,
                 P_ITESUB_CODEXT,
                 NVLZ(P_FATCON,1)
            FROM DUAL);
   END IF;

   RETURN WK_CODTAM;
END;
$$ language 'plpgsql';




/*-- SEQ 0396 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION InicioProjeto (TT_PRJ.CODFIL%TYPE,TT_PRJ.SEQUEN%TYPE) CASCADE;

/*-- SEQ 0397 --*/
CREATE OR REPLACE FUNCTION InicioProjeto (TT_PRJ.CODFIL%TYPE,TT_PRJ.SEQUEN%TYPE)
RETURNS Timestamp AS $$
DECLARE
pCodfil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
-- Objetivo
-- 1) Retornar a nome do cliente associado a uma tarefa

  dINIPRJ TT_PRJ.INIPRJ%TYPE;

  Lista CURSOR FOR
    -- Ver detalhes sobre a macro em
-- \\tt2000\Docs\desenv\depto\Manuais\Ansi\connectby.mac
SELECT INIPRJ
FROM connectby_back('(select to_char(chvprj) as filho,
                             to_char(chvpai) as pai
                   from tt_prj int) tab', 'filho', 'pai', to_char(pCodfil||pSequen))
AS c (conn_codigo VARCHAR, conn_codpai VARCHAR, level int, ordem int)
INNER JOIN tt_prj t ON c.conn_codigo  = (chvprj)
order by ordem;

-- Principal
begin
     dINIPRJ:=null;
     OPEN Lista;
     LOOP
        FETCH Lista INTO dINIPRJ;
        -- Tratamento para quando o form grava no banco uma data de 1800 ao inves de nulo
        if dINIPRJ < to_date('01/01/1900','dd/mm/yyyy') then 
           dINIPRJ := null;
        end if;
        EXIT WHEN (NOT FOUND) or (dINIPRJ IS NOT NULL);
     END LOOP;        
     Close Lista;
     
     RETURN dINIPRJ;

END;
$$ language 'plpgsql';




/*-- SEQ 0398 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Insere_DW_Log_Produto (DW_Log_Produto.FILMAT%TYPE,DW_Log_Produto.CODMAT%TYPE,DW_Log_Produto.CODCOR%TYPE,DW_Log_Produto.CODTAM%TYPE) CASCADE;

/*-- SEQ 0399 --*/
CREATE OR REPLACE FUNCTION Insere_DW_Log_Produto (DW_Log_Produto.FILMAT%TYPE,DW_Log_Produto.CODMAT%TYPE,DW_Log_Produto.CODCOR%TYPE,DW_Log_Produto.CODTAM%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILMAT ALIAS FOR $1 ;
pCODMAT ALIAS FOR $2 ;
pCODCOR ALIAS FOR $3 ;
pCODTAM ALIAS FOR $4 ;
-- Objetivo:
-- 1) Gerar log de alteraes para a view materializada DW_Produto
-- 2) Permitir que as tabelas envolvidas na view possam registrar rapidamente suas alteraes

BEGIN
  INSERT INTO DW_Log_Produto
  (FILMAT, CODMAT, CODCOR, CODTAM, DW_FLGEST)
  SELECT pFILMAT, pCODMAT, pCODCOR, pCODTAM, 'N'
    FROM DUAL 
   WHERE NOT EXISTS (SELECT 1 AS OK
                       FROM DW_Log_Produto DWL
                      WHERE DWL.FILMAT = pFILMAT
                        AND DWL.CODMAT = pCODMAT
                        AND DWL.CODCOR = pCODCOR
                        AND DWL.CODTAM = pCODTAM);
  RETURN 'OK';
END;
$$ language 'plpgsql';




/*-- SEQ 0400 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Insere_DW_Log_Vendas (DW_Log_Vendas.FILIAL%TYPE,DW_Log_Vendas.COD_UNIDADE%TYPE,DW_Log_Vendas.DATA%TYPE) CASCADE;

/*-- SEQ 0401 --*/
CREATE OR REPLACE FUNCTION Insere_DW_Log_Vendas (DW_Log_Vendas.FILIAL%TYPE,DW_Log_Vendas.COD_UNIDADE%TYPE,DW_Log_Vendas.DATA%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILIAL ALIAS FOR $1 ;
pCOD_UNIDADE ALIAS FOR $2 ;
pDATA ALIAS FOR $3 ;
-- Objetivo:
-- 1) Gerar log de alteraes para a view materializada DW_Vendas
-- 2) Permitir que as tabelas envolvidas na view possam registrar rapidamente suas alteraes

BEGIN
  INSERT INTO DW_Log_Vendas
  (FILIAL, COD_UNIDADE, DATA, DW_FLGEST)
  SELECT pFILIAL, pCOD_UNIDADE, pDATA, 'N'
    FROM DUAL 
   WHERE NOT EXISTS (SELECT 1 AS OK
                       FROM DW_Log_Vendas DWL
                      WHERE DWL.FILIAL      = pFILIAL
                        AND DWL.COD_UNIDADE = pCOD_UNIDADE
                        AND DWL.DATA        = pDATA);
  RETURN 'OK';  
END;
$$ language 'plpgsql';




/*-- SEQ 0402 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Insere_DW_Log_Vendas_Cliente (DW_Log_Vendas_Cliente.FILIAL%TYPE,DW_Log_Vendas_Cliente.FILIAL_CLIENTE%TYPE,DW_Log_Vendas_Cliente.CODIGO_CLIENTE%TYPE,DW_Log_Vendas_Cliente.ANO_MES%TYPE) CASCADE;

/*-- SEQ 0403 --*/
CREATE OR REPLACE FUNCTION Insere_DW_Log_Vendas_Cliente (DW_Log_Vendas_Cliente.FILIAL%TYPE,DW_Log_Vendas_Cliente.FILIAL_CLIENTE%TYPE,DW_Log_Vendas_Cliente.CODIGO_CLIENTE%TYPE,DW_Log_Vendas_Cliente.ANO_MES%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILIAL ALIAS FOR $1 ;
pFILIAL_CLIENTE ALIAS FOR $2 ;
pCODIGO_CLIENTE ALIAS FOR $3 ;
pANO_MES ALIAS FOR $4 ;
-- Objetivo:
-- 1) Gerar log de alteraes para a view materializada DW_Vendas_Cliente
-- 2) Permitir que as tabelas envolvidas na view possam registrar rapidamente suas alteraes

BEGIN
  INSERT INTO DW_Log_Vendas_Cliente
  (FILIAL, FILIAL_CLIENTE, CODIGO_CLIENTE, ANO_MES, DW_FLGEST)
  SELECT pFILIAL, pFILIAL_CLIENTE, pCODIGO_CLIENTE, pANO_MES, 'N'
    FROM DUAL 
   WHERE NOT EXISTS (SELECT 1 AS OK
                       FROM DW_Log_Vendas_Cliente DWL
                      WHERE DWL.FILIAL         = pFILIAL
                        AND DWL.FILIAL_CLIENTE = pFILIAL_CLIENTE
                        AND DWL.CODIGO_CLIENTE = pCODIGO_CLIENTE
                        AND DWL.ANO_MES        = pANO_MES);
  RETURN 'OK';
END;
$$ language 'plpgsql';




/*-- SEQ 0404 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Insere_DW_Log_Vendas_Grupos (DW_Log_Vendas_Grupos.FILIAL%TYPE,DW_Log_Vendas_Grupos.ANO_MES%TYPE) CASCADE;

/*-- SEQ 0405 --*/
CREATE OR REPLACE FUNCTION Insere_DW_Log_Vendas_Grupos (DW_Log_Vendas_Grupos.FILIAL%TYPE,DW_Log_Vendas_Grupos.ANO_MES%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILIAL ALIAS FOR $1 ;
pANO_MES ALIAS FOR $2 ;
-- Objetivo:
-- 1) Gerar log de alteraes para a view materializada DW_Vendas_Grupos
-- 2) Permitir que as tabelas envolvidas na view possam registrar rapidamente suas alteraes

BEGIN
  INSERT INTO DW_Log_Vendas_Grupos
  (FILIAL, ANO_MES, DW_FLGEST)
  SELECT pFILIAL, pANO_MES, 'N'
    FROM DUAL 
   WHERE NOT EXISTS (SELECT 1 AS OK
                       FROM DW_Log_Vendas_Grupos DWL
                      WHERE DWL.FILIAL  = pFILIAL
                        AND DWL.ANO_MES = pANO_MES);
  RETURN 'OK';
END;
$$ language 'plpgsql';




/*-- SEQ 0406 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Insere_DW_Log_Vendas_Hora (DW_Log_Vendas_Hora.FILIAL%TYPE,DW_Log_Vendas_Hora.DATA%TYPE,DW_Log_Vendas_Hora.HORA%TYPE) CASCADE;

/*-- SEQ 0407 --*/
CREATE OR REPLACE FUNCTION Insere_DW_Log_Vendas_Hora (DW_Log_Vendas_Hora.FILIAL%TYPE,DW_Log_Vendas_Hora.DATA%TYPE,DW_Log_Vendas_Hora.HORA%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILIAL ALIAS FOR $1 ;
pDATA ALIAS FOR $2 ;
pHORA ALIAS FOR $3 ;
-- Objetivo:
-- 1) Gerar log de alteraes para a view materializada DW_Vendas_Hora
-- 2) Permitir que as tabelas envolvidas na view possam registrar rapidamente suas alteraes

BEGIN
  INSERT INTO DW_Log_Vendas_Hora
  (FILIAL, DATA, HORA, DW_FLGEST)
  SELECT pFILIAL, pDATA, pHORA, 'N'
    FROM DUAL 
   WHERE NOT EXISTS (SELECT 1 AS OK
                       FROM DW_Log_Vendas_Hora DWL
                      WHERE DWL.FILIAL = pFILIAL
                        AND DWL.DATA   = pDATA
                        AND DWL.HORA   = pHORA);
  RETURN 'OK';
END;
$$ language 'plpgsql';




/*-- SEQ 0408 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Insere_DW_Log_Vendas_Meio (DW_Log_Vendas_Meio.FILIAL%TYPE,DW_Log_Vendas_Meio.COD_UNIDADE%TYPE,DW_Log_Vendas_Meio.ANO_MES%TYPE) CASCADE;

/*-- SEQ 0409 --*/
CREATE OR REPLACE FUNCTION Insere_DW_Log_Vendas_Meio (DW_Log_Vendas_Meio.FILIAL%TYPE,DW_Log_Vendas_Meio.COD_UNIDADE%TYPE,DW_Log_Vendas_Meio.ANO_MES%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILIAL ALIAS FOR $1 ;
pCOD_UNIDADE ALIAS FOR $2 ;
pANO_MES ALIAS FOR $3 ;
-- Objetivo:
-- 1) Gerar log de alteraes para a view materializada DW_Vendas_Meio
-- 2) Permitir que as tabelas envolvidas na view possam registrar rapidamente suas alteraes

BEGIN
  INSERT INTO DW_Log_Vendas_Meio
  (FILIAL, COD_UNIDADE, ANO_MES, DW_FLGEST)
  SELECT pFILIAL, pCOD_UNIDADE, pANO_MES, 'N'
    FROM DUAL 
   WHERE NOT EXISTS (SELECT 1 AS OK
                       FROM DW_Log_Vendas_Meio DWL
                      WHERE DWL.FILIAL      = pFILIAL
                        AND DWL.COD_UNIDADE = pCOD_UNIDADE
                        AND DWL.ANO_MES     = pANO_MES);
  RETURN 'OK';
END;
$$ language 'plpgsql';




/*-- SEQ 0410 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Insere_DW_Log_Vendas_Produto (DW_Log_Vendas_Produto.FILIAL%TYPE,DW_Log_Vendas_Produto.ANO_MES%TYPE) CASCADE;

/*-- SEQ 0411 --*/
CREATE OR REPLACE FUNCTION Insere_DW_Log_Vendas_Produto (DW_Log_Vendas_Produto.FILIAL%TYPE,DW_Log_Vendas_Produto.ANO_MES%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILIAL ALIAS FOR $1 ;
pANO_MES ALIAS FOR $2 ;
-- Objetivo:
-- 1) Gerar log de alteraes para a view materializada DW_Vendas_Produto
-- 2) Permitir que as tabelas envolvidas na view possam registrar rapidamente suas alteraes

BEGIN
  INSERT INTO DW_Log_Vendas_Produto
  (FILIAL, ANO_MES, DW_FLGEST)
  SELECT pFILIAL, pANO_MES, 'N'
    FROM DUAL 
   WHERE NOT EXISTS (SELECT 1 AS OK
                       FROM DW_Log_Vendas_Produto DWL
                      WHERE DWL.FILIAL      = pFILIAL                        
                        AND DWL.ANO_MES     = pANO_MES);
  RETURN 'OK';
END;
$$ language 'plpgsql';




/*-- SEQ 0412 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IntervaloHoras (Timestamp,Timestamp) CASCADE;

/*-- SEQ 0413 --*/
CREATE OR REPLACE FUNCTION IntervaloHoras (Timestamp,Timestamp)
RETURNS INTEGER AS $$
DECLARE
pDataI ALIAS FOR $1 ;
pDataF ALIAS FOR $2 ;
BEGIN
 RETURN abs(CAST(TRUNC(extract(EPOCH FROM (pDataI-pDataF))/60/60) AS INTEGER));
END;
$$ language 'plpgsql' STABLE;




/*-- SEQ 0414 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION InttoHoras (Numeric) CASCADE;

/*-- SEQ 0415 --*/
CREATE OR REPLACE FUNCTION InttoHoras (Numeric)
RETURNS VARCHAR AS $$
DECLARE
QtdMin ALIAS FOR $1 ;
BEGIN 
   return TRIM(TO_CHAR(TRUNC(QtdMin/60),'9999')||':'||SUBSTR(TO_CHAR(QtdMin-(TRUNC(QtdMin/60)*60),'00'),2,2));
END;
$$ language 'plpgsql';




/*-- SEQ 0416 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ISLEAP (Numeric) CASCADE;

/*-- SEQ 0417 --*/
CREATE OR REPLACE FUNCTION ISLEAP (Numeric)
RETURNS Char AS $$
DECLARE
pANO ALIAS FOR $1 ;

  WK_RESULTADO CHAR;
BEGIN
  WK_RESULTADO := 'F';
  
  IF ((MOD(pANO, 4) = 0) AND (MOD(pANO, 100) <> 0)) OR (MOD(pANO, 400) = 0) THEN
      WK_RESULTADO := 'T';
  END IF;
  
  RETURN WK_RESULTADO;

END;
$$ language 'plpgsql';




/*-- SEQ 0418 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ISNOTNULL (VARCHAR) CASCADE;

/*-- SEQ 0419 --*/
CREATE OR REPLACE FUNCTION ISNOTNULL (VARCHAR)
RETURNS Char AS $$
DECLARE
pStr ALIAS FOR $1 ;
BEGIN
 IF (pStr IS NOT NULL) THEN 
        
    IF (pStr = '') THEN
       RETURN 'F';
    ELSE 
       RETURN 'T';
    END IF;
     
 ELSE
    RETURN 'F'; 
 END IF;
END;
$$ language 'plpgsql';




/*-- SEQ 0420 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ISNULL (VARCHAR) CASCADE;

/*-- SEQ 0421 --*/
CREATE OR REPLACE FUNCTION ISNULL (VARCHAR)
RETURNS Char AS $$
DECLARE
pStr ALIAS FOR $1 ;
BEGIN
 IF (pStr IS NULL) or (pStr = '') THEN 
    RETURN 'T';
 ELSE
    RETURN 'F';
 END IF;
END;
$$ language 'plpgsql';




/*-- SEQ 0422 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Lanca_Mail (TT_WOR.CODFIL%TYPE,TT_WOR.SEQUEN%TYPE,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 0423 --*/
CREATE OR REPLACE FUNCTION Lanca_Mail (TT_WOR.CODFIL%TYPE,TT_WOR.SEQUEN%TYPE,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
p_Codfil ALIAS FOR $1 ;
p_Sequen ALIAS FOR $2 ;
p_Exclui ALIAS FOR $3 ;
p_Anexos ALIAS FOR $4 ;
p_Mail_to ALIAS FOR $5 ;
p_Mail_cc ALIAS FOR $6 ;
p_Mail_cb ALIAS FOR $7 ;
p_Mail_fr ALIAS FOR $8 ;
p_Texto ALIAS FOR $9 ;
p_LOG ALIAS FOR $10 ;
p_Avisar ALIAS FOR $11 ;

  c_log VARCHAR(4000);
  c_LF              CHAR(2)            := chr(13)||chr(10);
  BEGIN
    IF  (COALESCE(p_MAIL_FR,'Nulo') <> COALESCE(p_MAIL_TO,'Nulo'))
    AND (p_AVISAR <> 'F' )
    AND (p_MAIL_TO <> 'Nulo')
    AND (p_MAIL_FR <> 'Nulo') THEN
      IF COALESCE(p_log,'#_#') = '#_#' then
        c_log := '';
      ELSE
        c_log := 'Modificaes: '|| c_LF || p_log
        || '------------------------------------------------------------------------' || c_LF;
      END IF;

      IF (ISNOTNULL(p_Mail_to)='T') AND (ISNOTNULL(p_Mail_fr)='T') AND (INSTR(p_Mail_fr, UPPER('@sua_empresa.com')) = 0) AND (INSTR(p_Mail_to, UPPER('@sua_empresa.com')) = 0) THEN
         INSERT into TT_MAI(DATSOL, EXCLUI, ANEXOS, MAI_TO, MAI_CC, MAI_CB, MAI_FR, TEXTOS, ASSUNT)
         VALUES (agora(), p_Exclui, p_Anexos, p_Mail_to, p_Mail_cc, p_Mail_cb, p_Mail_fr,p_Texto||c_log ,
                 '[TT2000-WorkFlow] Referente tarefa: '||p_CODFIL|| '/' || TRIM(p_SEQUEN) );
      END IF;
    END IF;
    RETURN 'OK';
END;
$$ language 'plpgsql';




/*-- SEQ 0424 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Lanca_Mail_Sit (TT_WOR.CODFIL%TYPE,TT_WOR.SEQUEN%TYPE,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 0425 --*/
CREATE OR REPLACE FUNCTION Lanca_Mail_Sit (TT_WOR.CODFIL%TYPE,TT_WOR.SEQUEN%TYPE,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
p_Codfil ALIAS FOR $1 ;
p_Sequen ALIAS FOR $2 ;
p_Exclui ALIAS FOR $3 ;
p_Anexos ALIAS FOR $4 ;
p_Mail_to ALIAS FOR $5 ;
p_Mail_cc ALIAS FOR $6 ;
p_Mail_cb ALIAS FOR $7 ;
p_Mail_fr ALIAS FOR $8 ;
p_Texto ALIAS FOR $9 ;
p_LOG ALIAS FOR $10 ;
p_Avisar ALIAS FOR $11 ;
p_FLGSIT ALIAS FOR $12 ;

  c_log VARCHAR(4000);
  c_LF              CHAR(2)            := chr(13)||chr(10);
  p_Sit VARCHAR(30);            
  BEGIN
    IF  (COALESCE(p_MAIL_FR,'Nulo') <> COALESCE(p_MAIL_TO,'Nulo'))
    AND (p_AVISAR <> 'F' )
    AND (p_MAIL_TO <> 'Nulo')
    AND (p_MAIL_FR <> 'Nulo') THEN
      IF COALESCE(p_log,'#_#') = '#_#' then
        c_log := '';
      ELSE
        c_log := 'Modificaes: '|| c_LF || p_log
        || '------------------------------------------------------------------------' || c_LF;
      END IF;
      p_Sit := p_FLGSIT;
      IF p_Sit = '1' THEN
         p_Sit := 'A Integrar';
      END IF;
      IF p_Sit = '2' THEN
         p_Sit := 'Aberto';
      END IF;
      IF p_Sit = '3' THEN
         p_Sit := 'Cancelado';
      END IF;
      IF p_Sit = '4' THEN
         p_Sit := 'Em Espera';
      END IF;
      IF p_Sit = '5' THEN
         p_Sit := 'Executado';
      END IF;
      IF p_Sit = '6' THEN
         p_Sit := 'Revisado com Erros';
      END IF;
      IF p_Sit = '7' THEN
         p_Sit := 'Revisado e Aprovado';
      END IF;
      IF p_Sit = '8' THEN
         p_Sit := 'Suspenso';
      END IF;
      IF p_Sit = '9' THEN
         p_Sit := 'A Classificar';
      END IF;
      IF p_Sit = '10' THEN
         p_Sit := 'Classificado';
      END IF;
      
      IF (ISNOTNULL(p_Mail_to)='T') AND (ISNOTNULL(p_Mail_fr)='T') AND (INSTR(p_Mail_fr, UPPER('@sua_empresa.com')) = 0) AND (INSTR(p_Mail_to, UPPER('@sua_empresa.com')) = 0) THEN
         INSERT into TT_MAI(DATSOL, EXCLUI, ANEXOS, MAI_TO, MAI_CC, MAI_CB, MAI_FR, TEXTOS, ASSUNT)
         VALUES (agora(), p_Exclui, p_Anexos, p_Mail_to, p_Mail_cc, p_Mail_cb, p_Mail_fr,p_Texto||c_log ,
                 '[WorkFlow] Tarefa: '||p_CODFIL|| '/' || TRIM(p_SEQUEN) || ' foi para situao '||p_Sit);
      END IF;
    END IF;
    RETURN 'OK';
END;
$$ language 'plpgsql';




/*-- SEQ 0426 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION MediaDiasAtraso (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,INTEGER) CASCADE;

/*-- SEQ 0427 --*/
CREATE OR REPLACE FUNCTION MediaDiasAtraso (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,INTEGER)
RETURNS Numeric AS $$
DECLARE
pFilial ALIAS FOR $1 ;
pCodigo ALIAS FOR $2 ;
pNroMeses ALIAS FOR $3 ;

   vRESULT Numeric(8);

BEGIN
SELECT SUM( CASE WHEN TRUNC(REC.DATVEN)-TRUNC(REC.PAGAME)>=0
            THEN TRUNC(REC.DATVEN)-TRUNC(REC.PAGAME)
            ELSE 0
            END)/COUNT(*) INTO vRESULT
  FROM tt_rec rec inner join tt_ven ven on rec.codfil=ven.codfil and rec.sequen=ven.sequen
 WHERE VEN.FILCLI=pFilial
   AND VEN.CODCLI=pCodigo
   AND VEN.FLGEST<>'C'
   AND REC.FLGEST='P' 
   AND VEN.DATHOR >= add_months(agora(),pNroMeses*-1);
   

RETURN vRESULT;
  
END;
$$ language 'plpgsql';




/*-- SEQ 0428 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION MontaEmail (TT_WOR.CODFIL%type,TT_WOR.SEQUEN%type,TD_SIT.TIPSIT%TYPE,TT_WOR.TARPRE%type,TT_WOR.TSTPRE%type,TT_WOR.FILREG%type,TT_WOR.CODREG%type,TT_WOR.FILTST%type,TT_WOR.CODTST%type,TT_WOR.FILRES%type,TT_WOR.CODRES%type,TT_WOR.MODULO%type,TT_WOR.TIPTAR%type,TT_WOR.FILCLI%type,TT_WOR.CODCLI%type,TT_WOR.FILPRJ%type,TT_WOR.SEQPRJ%type,TT_WOR.PRICLI%type,TT_WOR.DESTAR%type,TT_WOR.PRIORI%type,TT_WOR.VERSAO%type,TT_WOR.INIPRT%type,TT_WOR.INIPRR%type,TT_WOR.DATPRO%type,TT_WOR.FIMPRT%type,TT_WOR.FIMPRR%type) CASCADE;

/*-- SEQ 0429 --*/
CREATE OR REPLACE FUNCTION MontaEmail (TT_WOR.CODFIL%type,TT_WOR.SEQUEN%type,TD_SIT.TIPSIT%TYPE,TT_WOR.TARPRE%type,TT_WOR.TSTPRE%type,TT_WOR.FILREG%type,TT_WOR.CODREG%type,TT_WOR.FILTST%type,TT_WOR.CODTST%type,TT_WOR.FILRES%type,TT_WOR.CODRES%type,TT_WOR.MODULO%type,TT_WOR.TIPTAR%type,TT_WOR.FILCLI%type,TT_WOR.CODCLI%type,TT_WOR.FILPRJ%type,TT_WOR.SEQPRJ%type,TT_WOR.PRICLI%type,TT_WOR.DESTAR%type,TT_WOR.PRIORI%type,TT_WOR.VERSAO%type,TT_WOR.INIPRT%type,TT_WOR.INIPRR%type,TT_WOR.DATPRO%type,TT_WOR.FIMPRT%type,TT_WOR.FIMPRR%type)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pTIPSIT ALIAS FOR $3 ;
pTARPRE ALIAS FOR $4 ;
pTSTPRE ALIAS FOR $5 ;
pFILREG ALIAS FOR $6 ;
pCODREG ALIAS FOR $7 ;
pFILTST ALIAS FOR $8 ;
pCODTST ALIAS FOR $9 ;
pFILRES ALIAS FOR $10 ;
pCODRES ALIAS FOR $11 ;
pMODULO ALIAS FOR $12 ;
pTIPTAR ALIAS FOR $13 ;
pFILCLI ALIAS FOR $14 ;
pCODCLI ALIAS FOR $15 ;
pFILPRJ ALIAS FOR $16 ;
pSEQPRJ ALIAS FOR $17 ;
pPRICLI ALIAS FOR $18 ;
pDESTAR ALIAS FOR $19 ;
pPRIORI ALIAS FOR $20 ;
pVERSAO ALIAS FOR $21 ;
pINIPRT ALIAS FOR $22 ;
pINIPRR ALIAS FOR $23 ;
pDATPRO ALIAS FOR $24 ;
pFIMPRT ALIAS FOR $25 ;
pFIMPRR ALIAS FOR $26 ;

  -- Monta o Corpo do E-mail
    WK_MODULO TD_MOD.MODULO%TYPE  := '';  -- MODULO
    WK_TIPTAR TD_CWS.DESCWS%TYPE  := '';  -- TIPO DE TAREFA
    WK_USURES TT_USU.APEUSU%TYPE  := '';  -- RESPONSVEL
    WK_USUREG TT_USU.APEUSU%TYPE  := '';  -- REGISTRADOR
    WK_USUTST TT_USU.APEUSU%TYPE  := '';  -- REVISOR
    WK_USUALT TT_USU.APEUSU%TYPE  := '';  -- ALTEROU/INCLUIU
    WK_TARPRE VARCHAR(20)        := '';  -- HORAS DE TAREFA PREVISTA
    WK_TSTPRE VARCHAR(20)        := '';  -- HORAS DE TAREFA PREVISTA
    WK_FLGEST VARCHAR(20)        := '';  -- SITUAO
    WK_NOMCLI VARCHAR(200)       := '';  -- CLIENTE
    WK_NOMPRJ VARCHAR(4000)      := '';  -- HIERARQUIA DO PROJETO
    WK_PRICLI VARCHAR(20)        := '';  -- PRIORIDADE DO CLIENTE
    c_LF              CHAR(2)            := chr(13)||chr(10);
    filial            TT_USU.FILUSU%TYPE;               -- Usado Para pegar o e-mail do usurio
    usuario           TT_USU.CODUSU%TYPE;               -- Usado Para pegar o e-mail do usurio
    QuemLogou TRetQuemLogou;
    vComplemento CONSTANT VARCHAR(254):= constante('complemento');
  Begin
    -- Pegando o E_mail do usurio Logado!!
    select * into QuemLogou from DadosLogon();
    IF QuemLogou.Encontrou THEN
       filial:=QuemLogou.filusu;
       usuario:=QuemLogou.codusu;
    ELSE
      RAISE EXCEPTION 'PG-20037 Voce nao e um usuario cadastrado no sistema. %' , VComplemento;
    END IF;

    SELECT CASE pTIPSIT WHEN 'A' THEN 'Aberto'
                        WHEN 'C' THEN 'Cancelado'
                        WHEN 'E' THEN 'Em Espera'
                        WHEN 'X' THEN 'Executado'
                        WHEN '1' THEN 'Revisado e Aprovado'
                        WHEN '2' THEN 'Revisado com Erros'
                        WHEN 'I' THEN 'A Integrar'
                        WHEN 'S' THEN 'Suspenso'
          END,
          TRIM(TO_CHAR(TRUNC(PTARPRE/60),'9999')||':'||SUBSTR(TO_CHAR(PTARPRE - (TRUNC(PTARPRE/60)*60),'00'),2,2)),
          TRIM(TO_CHAR(TRUNC(PTSTPRE/60),'9999')||':'||SUBSTR(TO_CHAR(PTSTPRE - (TRUNC(PTSTPRE/60)*60),'00'),2,2))
    INTO wk_FLGEST, WK_TARPRE, WK_TSTPRE FROM DUAL;

    SELECT MIN(APEUSU) INTO WK_USUREG FROM TT_USU
    WHERE FILUSU = PFILREG
      AND CODUSU = PCODREG;

    SELECT MIN(APEUSU) INTO WK_USUTST FROM TT_USU
    WHERE FILUSU = PFILTST
      AND CODUSU = PCODTST;

    SELECT MIN(APEUSU) INTO WK_USURES FROM TT_USU
    WHERE FILUSU = PFILRES
      AND CODUSU = PCODRES;

    SELECT MIN(APEUSU) INTO WK_USUALT FROM TT_USU
    WHERE FILUSU = Filial
      AND CODUSU = Usuario;

    SELECT MIN(MODULO) INTO WK_MODULO FROM TD_MOD
    WHERE CODTAB = PMODULO;

    SELECT MIN(DESCWS) INTO WK_TIPTAR FROM TD_CWS
    WHERE CODTAB = PTIPTAR;

    SELECT MIN(CASE FLGTIP WHEN 0 THEN NOMCLI || ' ' || ULTNOM
                                  ELSE NOMCLI || '/' || ULTNOM
               END) INTO WK_NOMCLI FROM TT_CLI
    WHERE FILCLI = PFILCLI
      AND CODCLI = PCODCLI;

    WK_NOMPRJ := HIERARQUIAPROJETO(PFILPRJ,PSEQPRJ);
    IF LENGTH(WK_NOMPRJ)>1000 THEN
       WK_NOMPRJ:=SUBSTR(WK_NOMPRJ,1,996)||' ...';
    END IF;

    SELECT MIN(CASE WK_TARPRE WHEN '0:00' THEN 'No Identificado'
                                                     ELSE WK_TARPRE
               END) INTO WK_TARPRE FROM DUAL;
    SELECT MIN(CASE WK_TSTPRE WHEN '0:00' THEN 'No Identificado'
                                                     ELSE WK_TSTPRE
               END) INTO WK_TSTPRE FROM DUAL;

    SELECT CASE PPRICLI WHEN 0 THEN 'Imediata'
                            WHEN 1 THEN 'Alta'
                            WHEN 2 THEN 'Mdia'
                            WHEN 3 THEN 'Baixa'
                            ELSE 'Nulo'
           END INTO WK_PRICLI FROM DUAL;

    Return 'Usurio que Alterou/Incluiu: '      || WK_USUALT                         || c_LF
    || '***MSG***'                                                               || c_LF
    || 'Dados: '                                                                 || c_LF
    || '------------------------------------------------------------------------'|| c_LF
    || 'Filial/Cdigo: '                    || TRIM(PCODFIL) || '/' || TRIM(PSEQUEN) || C_LF
    || 'Ttulo da Tarefa: '                 || TRIM(PDESTAR)                 || C_LF
    || 'Prioridade: '                       || TRIM(TO_CHAR(PPRIORI))            || C_LF
    || 'Situao: '                         || TRIM(WK_FLGEST)                   || c_LF
    || 'Mdulo/Verso: '                    || TRIM(WK_MODULO)   || '/' || TRIM(PVERSAO) || C_LF
    || 'Projeto: '                          || TRIM(WK_NOMPRJ)                   || C_LF
    || 'Responsvel: '                      || TRIM(COALESCE(WK_USURES,'No Identificado')) || C_LF
    || 'Revisor: '                          || TRIM(COALESCE(WK_USUTST,'No Identificado')) || C_LF
    || 'Cliente: '                          || TRIM(COALESCE(WK_NOMCLI,'No Identificado')) || C_LF
    || 'Horas previstas para a tarefa: '    || TRIM(WK_TARPRE)                   || C_LF
    || 'Horas previstas para a reviso: '   || TRIM(WK_TSTPRE)                   || C_LF
    || 'Previso do perodo de realizao: '|| TRIM(COALESCE(TO_CHAR(PINIPRT,'DD/MM/YYYY HH24:MI:SS'),'No Identificado') || ' - ' || COALESCE(TO_CHAR(PFIMPRT,'DD/MM/YYYY HH24:MI:SS'),'No Identificado')) || C_LF
    || 'Previso do perodo de reviso: '   || TRIM(COALESCE(TO_CHAR(PINIPRR,'DD/MM/YYYY HH24:MI:SS'),'No Identificado') || ' - ' || COALESCE(TO_CHAR(PFIMPRR,'DD/MM/YYYY HH24:MI:SS'),'No Identificado')) || C_LF
    || 'Data Prometida: '                   || TRIM(COALESCE(TO_CHAR(PDATPRO,'DD/MM/YYYY HH24:MI:SS'),'No Identificado')) || C_LF
    || 'Prioridade do Cliente: '            || TRIM(WK_PRICLI)                   ||c_LF
    || '------------------------------------------------------------------------'|| c_LF;
END;
$$ language 'plpgsql';




/*-- SEQ 0430 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION MovimentaEstoque (TT_SAL.CODFIL%TYPE,TT_SAL.FILMAT%TYPE,TT_SAL.CODMAT%TYPE,TT_SAL.CODCOR%TYPE,TT_SAL.CODTAM%TYPE,TT_SAL.CODMUL%TYPE) CASCADE;

/*-- SEQ 0431 --*/
CREATE OR REPLACE FUNCTION MovimentaEstoque (TT_SAL.CODFIL%TYPE,TT_SAL.FILMAT%TYPE,TT_SAL.CODMAT%TYPE,TT_SAL.CODCOR%TYPE,TT_SAL.CODTAM%TYPE,TT_SAL.CODMUL%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCodfil ALIAS FOR $1 ;
pFilmat ALIAS FOR $2 ;
pCodmat ALIAS FOR $3 ;
pCodcor ALIAS FOR $4 ;
pCodtam ALIAS FOR $5 ;
pCodmul ALIAS FOR $6 ;
   -- RFMP 59685 Verifica se movimenta estoque
   WK_MOVEST                  TT_SAL.MOVEST%TYPE;
BEGIN

    SELECT MOVEST
      INTO WK_MOVEST
      FROM TT_SAL
     WHERE CODFIL = pCodfil
       AND FILMAT = pFilmat
       AND CODMAT = pCodmat
       AND CODCOR = pCodcor
       AND CODTAM = pCodtam
       AND CODMUL = pCodmul;

    RETURN COALESCE(WK_MOVEST, 'T');
END;
$$ language 'plpgsql';




/*-- SEQ 0432 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION NaturezaItemCompra (TT_ICO.CODFIL%TYPE,TT_ICO.SEQUEN%TYPE,TT_ICO.NUMITE%TYPE) CASCADE;

/*-- SEQ 0433 --*/
CREATE OR REPLACE FUNCTION NaturezaItemCompra (TT_ICO.CODFIL%TYPE,TT_ICO.SEQUEN%TYPE,TT_ICO.NUMITE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCodfil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
pNumite ALIAS FOR $3 ;
  wk_Retorno VARCHAR(50);
BEGIN
  SELECT CASE WHEN COM.CODFOR = '0' AND SUBSTR(FIL.CGCFIL,1,8) = SUBSTR(FCLI.CGCFIL,1,8)
              THEN CAST('TRANSFERENCIA DE MERCADORIA' AS VARCHAR(30))
                                  ELSE COALESCE(DCFO_ICO.CODCFO||' - '||DCFO_ICO.DESCFO,DCFO_COM.CODCFO||' - '||DCFO_COM.DESCFO)
         END INTO WK_RETORNO
    FROM TT_ICO ICO INNER JOIN TT_COM COM ON COM.CODFIL = ICO.CODFIL 
                                         AND COM.SEQUEN = ICO.SEQUEN
                     LEFT JOIN TD_CFO DCFO_COM ON DCFO_COM.CODTAB=COM.CODCFO
                     LEFT JOIN TD_CFO DCFO_ICO ON DCFO_ICO.CODTAB=ICO.CODCFO
                    INNER JOIN TD_FIL FIL ON FIL.CODFIL = COM.CODFIL
					INNER JOIN TD_FIL FCLI ON FCLI.CODFIL = COM.FILFOR
   WHERE ICO.CODFIL = pCodFil
     AND ICO.SEQUEN = pSEQUEN
     AND ICO.NUMITE = pNUMITE;
RETURN WK_RETORNO;

END;
$$ language 'plpgsql';





/*-- SEQ 0434 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION NOMEMES (Numeric,Numeric) CASCADE;

/*-- SEQ 0435 --*/
CREATE OR REPLACE FUNCTION NOMEMES (Numeric,Numeric)
RETURNS VARCHAR AS $$
DECLARE
MES ALIAS FOR $1 ;
POSRET ALIAS FOR $2 ;
--Objetivo: Retornar o nome do ms por extenso
--parmetros: Mes numrico - numero de caracteres no resultado
WK_NOMEMES VARCHAR(10);
BEGIN
SELECT CASE MES WHEN 1 THEN 'JANEIRO'
                WHEN 2 THEN 'FEVEREIRO'
                WHEN 3 THEN 'MARO'
                WHEN 4 THEN 'ABRIL'
                WHEN 5 THEN 'MAIO'
                WHEN 6 THEN 'JUNHO'
                WHEN 7 THEN 'JULHO'
                WHEN 8 THEN 'AGOSTO'
                WHEN 9 THEN 'SETEMBRO'
                WHEN 10 THEN 'OUTUBRO'
                WHEN 11 THEN 'NOVEMBRO'
                ELSE 'DEZEMBRO'
        END AS NOMEMES
  INTO WK_NOMEMES
  FROM DUAL;
  RETURN TRIM(SUBSTR(WK_NOMEMES,1,POSRET));
END;
$$ language 'plpgsql';





/*-- SEQ 0436 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION NomeProduto (TT_PRO.DESECF%TYPE,TT_PRO.DESMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_DIV.NOMITE%TYPE,TT_GRA.CODTAM%TYPE,TT_SUB.NOMITE%TYPE,TT_PRO.ESPMAT%TYPE,TT_GRA.DESGRA%TYPE,TT_DIV.NOMEXT%TYPE,TT_SUB.NOMEXT%TYPE) CASCADE;

/*-- SEQ 0437 --*/
CREATE OR REPLACE FUNCTION NomeProduto (TT_PRO.DESECF%TYPE,TT_PRO.DESMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_DIV.NOMITE%TYPE,TT_GRA.CODTAM%TYPE,TT_SUB.NOMITE%TYPE,TT_PRO.ESPMAT%TYPE,TT_GRA.DESGRA%TYPE,TT_DIV.NOMEXT%TYPE,TT_SUB.NOMEXT%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pDESECF ALIAS FOR $1 ;
pDESMAT ALIAS FOR $2 ;
pCODCOR ALIAS FOR $3 ;
pNOMDIV ALIAS FOR $4 ;
pCODTAM ALIAS FOR $5 ;
pNOMSUB ALIAS FOR $6 ;
pESPMAT ALIAS FOR $7 ;
pDESGRA ALIAS FOR $8 ;
pEXTDIV ALIAS FOR $9 ;
pEXTSUB ALIAS FOR $10 ;

-- Objetivo:
-- 1) Padronizar o nome do produto.

 cNOMDIV TT_DIV.NOMEXT%TYPE;
 cNOMSUB TT_SUB.NOMEXT%TYPE;
BEGIN
   -- Retorna apenas a Descrição da Grade, se preenchida.
   IF ISNULL(pDESGRA) = 'F' THEN
      RETURN TRIM(pDESGRA);
   ELSE
      -- MN - Essa primeira parte é por causa de integração, coloca # em nome de produtos iguais para diferenciar o que foi importado
      -- cadastrado pelo sistema.
      
      --Pedro E. Braga - 94425 - Tratamento para quando Tiver # no NOMITE exibir a coluna NOMEXT quando informada,
      -- caso contrario retira o conteudo a partir do caracter #
      --Tabela de Divisão
      cNOMDIV := pNOMDIV;
      IF (INSTR(pNOMDIV, '#') > 0) THEN
        IF (pEXTDIV IS NULL) THEN
            cNOMDIV := TRIM(SUBSTR(pNOMDIV,1,INSTR(pNOMDIV, '#')-1));--Retira Identificador de Integração
        ELSE
            cNOMDIV := TRIM(pEXTDIV);--Exibe Descrição Externa
        END IF;
      END IF;

      --Tabela de Sub-Divisão
      cNOMSUB := pNOMSUB;
      IF (INSTR(pNOMSUB, '#') > 0) THEN
        IF (pEXTSUB IS NULL) THEN
            cNOMSUB := TRIM(SUBSTR(pNOMSUB,1,INSTR(pNOMSUB, '#')-1));--Retira Identificador de Integração
        ELSE
            cNOMSUB := TRIM(pEXTSUB);--Exibe Descrição Externa
        END IF;
      END IF;
      
      RETURN TRIM(CASE WHEN pDESECF IS NULL
                       THEN COALESCE(pDESMAT, '')
                       ELSE pDESECF
                  END) ||
                  CASE WHEN (pESPMAT IS NULL) OR (pDESMAT = COALESCE(pESPMAT,''))
                       THEN ''
                       ELSE ' ' || TRIM(COALESCE(pESPMAT, ''))
                  END ||
                  CASE WHEN (pCODCOR = 0) OR (pNOMDIV = '--') OR (pNOMDIV = '---') OR (pNOMDIV = 'NAO USA')
                       THEN ''
                       ELSE ' ' || TRIM(COALESCE(cNOMDIV, ''))
                  END ||
                  CASE WHEN (pCODTAM = 0) OR (pNOMSUB = '--') OR (pNOMSUB = '---') OR (pNOMSUB = 'NAO USA')
                       THEN ''
                       ELSE ' ' || TRIM(COALESCE(cNOMSUB, ''))
                  END;
   END IF;
END;
$$ language 'plpgsql' STABLE;


/*-- SEQ 0438 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION NomeProduto (TT_PRO.DESECF%TYPE,TT_PRO.DESMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_DIV.NOMITE%TYPE,TT_GRA.CODTAM%TYPE,TT_SUB.NOMITE%TYPE,TT_PRO.ESPMAT%TYPE,TT_GRA.DESGRA%TYPE);

/*-- SEQ 0439 --*/
CREATE OR REPLACE FUNCTION NomeProduto (TT_PRO.DESECF%TYPE,
                               TT_PRO.DESMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_DIV.NOMITE%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               TT_SUB.NOMITE%TYPE,
                               TT_PRO.ESPMAT%TYPE,
                               TT_GRA.DESGRA%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN NomeProduto($1,$2,$3,$4,$5,$6,$7,$8,NULL,NULL);
END;
$$ language 'plpgsql' STABLE;


/*-- SEQ 0440 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PATH_DEFAULT (VARCHAR,VARCHAR,TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 0441 --*/
CREATE OR REPLACE FUNCTION PATH_DEFAULT (VARCHAR,VARCHAR,TD_FIL.CODFIL%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pTabela ALIAS FOR $1 ;
pColuna ALIAS FOR $2 ;
pFilial ALIAS FOR $3 ;
  cRETORNO VARCHAR(100);
BEGIN
  -- retorna o complemento do path padrao para determinada coluna
  cRETORNO := TO_PATH('Arquivos/');
  
  IF Equal(pTabela,'TD_FIL') = 1 THEN 
    IF ISNOTNULL(pFilial) = 'T' THEN 
      cRETORNO := cRETORNO || TRIM(pFilial) || TO_PATH('/'); 
    END IF;
  END IF;

  IF (Equal(pTabela,'TT_CFG') = 1)    AND (Equal(pColuna,'RBPATH') = 1) THEN 
    cRETORNO := cRETORNO || TO_PATH('Path_dos_Arquivos/');
  ELSIF (Equal(pTabela,'TT_CFG') = 1) AND (Equal(pColuna,'PATH_PROJETOS') = 1) THEN 
    cRETORNO := cRETORNO || TO_PATH('Path_dos_Projetos/');
  ELSIF (Equal(pTabela,'TT_CFG') = 1) AND (Equal(pColuna,'PATH_ARQUIVOS') = 1) THEN 
    cRETORNO := cRETORNO || TO_PATH('Path_de_Arquivos/');
  ELSIF (Equal(pTabela,'TT_CFG') = 1) AND (Equal(pColuna,'PATH_ANEXOS') = 1) THEN 
    cRETORNO := cRETORNO || TO_PATH('Path_Anexos/');
  ELSIF (Equal(pTabela,'TT_CFG') = 1) AND (Equal(pColuna,'PDA_PATH_IMPORTACAO') = 1) THEN 
    cRETORNO := cRETORNO || TO_PATH('Caminho_Origem_PDAs/');
  ELSIF (Equal(pTabela,'TT_CFG') = 1) AND (Equal(pColuna,'PDA_PATH_EXPORTACAO') = 1) THEN 
    cRETORNO := cRETORNO || TO_PATH('Caminho_Destino_PDAs/');
  ELSIF (Equal(pTabela,'TT_CFG') = 1) AND (Equal(pColuna,'DADOS_PATH_EXPORTA') = 1) THEN 
    cRETORNO := cRETORNO || TO_PATH('Caminho_Destino_Exp/');
  ELSIF (Equal(pTabela,'TT_CFG') = 1) AND (Equal(pColuna,'DADOS_PATH_IMPORTA') = 1) THEN 
    cRETORNO := cRETORNO || TO_PATH('Caminho_Origem_Imp/');
  ELSIF (Equal(pTabela,'TD_FIL') = 1) AND (Equal(pColuna,'PATCAR') = 1) THEN 
    cRETORNO := cRETORNO || TO_PATH('Path_do_Cartao/');
  ELSIF (Equal(pTabela,'TD_FIL') = 1) AND (Equal(pColuna,'PATPED') = 1) THEN 
    cRETORNO := cRETORNO || TO_PATH('Path_do_Pedido/');
  ELSIF (Equal(pTabela,'TD_FIL') = 1) AND (Equal(pColuna,'PAT_AA') = 1) THEN 
    cRETORNO := cRETORNO || TO_PATH('Path_Requisicoes/');
  ELSIF (Equal(pTabela,'TD_FIL') = 1) AND (Equal(pColuna,'PATNOT') = 1) THEN 
    cRETORNO := cRETORNO || TO_PATH('Path_para_Numeracao_das_Notas/');
  ELSIF (Equal(pTabela,'TD_FIL') = 1) AND (Equal(pColuna,'PATCON') = 1) THEN 
    cRETORNO := cRETORNO || TO_PATH('Path_Con/');
  ELSIF (Equal(pTabela,'TD_FIL') = 1) AND (Equal(pColuna,'PATTKE') = 1) THEN 
    cRETORNO := cRETORNO || TO_PATH('Path_do_TKE/');
  ELSIF (Equal(pTabela,'TT_USU') = 1) AND (Equal(pColuna,'PATNDB') = 1) THEN 
    cRETORNO := cRETORNO || TO_PATH('Path_Consultas/');
  ELSIF (Equal(pTabela,'TD_FIL') = 1) AND (Equal(pColuna,'PATNFE') = 1) THEN 
    cRETORNO := cRETORNO || TO_PATH('Path_de_NFE/');
  END IF;

  RETURN cRETORNO; 
END;
$$ language 'plpgsql';


/*-- SEQ 0442 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PATH_DEFAULT (VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 0443 --*/
CREATE OR REPLACE FUNCTION PATH_DEFAULT (VARCHAR,
                               VARCHAR) 
RETURNS VARCHAR AS $$
BEGIN
RETURN PATH_DEFAULT($1,$2,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 0444 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PegaE_mail (TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE) CASCADE;

/*-- SEQ 0445 --*/
CREATE OR REPLACE FUNCTION PegaE_mail (TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE)
RETURNS VARCHAR AS $$
DECLARE
cFILUSU ALIAS FOR $1 ;
cCODUSU ALIAS FOR $2 ;
  -- Pega o E-mail do Usuario pela filial e codigo
    cE_MAIL TT_USU.E_MAIL%TYPE;
    NULO   CONSTANT CHAR(4) := 'Nulo';
  BEGIN
    SELECT COALESCE(E_MAIL,NULO) INTO cE_MAIL
    FROM TT_USU
    WHERE FILUSU = cFILUSU
      AND CODUSU = cCODUSU;

    RETURN (cE_MAIL);
END;
$$ language 'plpgsql';




/*-- SEQ 0446 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PermiteCancelamento (TT_VEN.CODFIL%TYPE,TT_VEN.NUMECF%TYPE,TT_VEN.CODSER%TYPE,TT_VEN.NUMNOT%TYPE) CASCADE;

/*-- SEQ 0447 --*/
CREATE OR REPLACE FUNCTION PermiteCancelamento (TT_VEN.CODFIL%TYPE,TT_VEN.NUMECF%TYPE,TT_VEN.CODSER%TYPE,TT_VEN.NUMNOT%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCodfil ALIAS FOR $1 ;
pNumecf ALIAS FOR $2 ;
pCodser ALIAS FOR $3 ;
pNumnot ALIAS FOR $4 ;

  cFLGEST               TT_VEN.FLGEST%TYPE;
  nQTDVIN               INTEGER;
  cFILICO               TT_TRA.FILICO%TYPE;
  cSEQICO               TT_TRA.SEQICO%TYPE;
  vCODFIL               TT_VEN.CODFIL%TYPE;
  vSEQUEN               TT_VEN.SEQUEN%TYPE;
  vFUNRUR               TT_VEN.FUNRUR%TYPE;
  vFILCLI               TT_VEN.FILCLI%TYPE;
  vCODCLI               TT_VEN.CODCLI%TYPE;
  vVLRLIQ               TT_VEN.VLRLIQ%TYPE;
  vRESULT               CHAR(1);
  vENTREGA              CHAR(1);
  nQTDDOP               INTEGER;
  vLANEST               TT_IVE.LANEST%TYPE;
  vNUMITE               TT_IVE.NUMITE%TYPE;
  vFILORI               TT_IVE.FILORI%TYPE;
  vNUMORI               TT_IVE.NUMORI%TYPE;
  vITEORI               TT_IVE.ITEORI%TYPE;
  QtdValidacao          INTEGER;
  RetornoItens          VARCHAR(100);
  cSEQFAT               TT_VEN.SEQFAT%TYPE;
  vNUMECF               TT_VEN.NUMECF%TYPE;
  vCODSER               TT_VEN.CODSER%TYPE;
  vNUMNOT               TT_VEN.NUMNOT%TYPE;
  sMensagem             VARCHAR(1000);

 CR_IVE CURSOR(pCODFIL TT_IVE.CODFIL%TYPE,
           pSEQUEN TT_IVE.SEQUEN%TYPE) IS
    SELECT IVE.NUMITE, IVE.LANEST, IVE.FILORI, IVE.NUMORI, IVE.ITEORI
      FROM TT_IVE IVE
     WHERE IVE.CODFIL = pCODFIL
       AND IVE.SEQUEN = pSEQUEN
       AND IVE.SITMOV <> 'C'
       AND IVE.SITKIT IN ('2','3');

BEGIN

   IF pCODSER IN ('CF','TK') THEN
      RETURN 'Venda de cupom fiscal no pode ser cancelada';
   END IF;

    SELECT VEN.FLGEST, TRA.FILICO, TRA.SEQICO, VEN.CODFIL, VEN.SEQUEN, VEN.FUNRUR, VEN.FILCLI, VEN.CODCLI, VEN.VLRLIQ, VEN.SEQFAT,
           (SELECT COUNT(*)
              FROM TT_IVE VIN
             WHERE VIN.FILORI = VEN.CODFIL
               AND VIN.NUMORI = VEN.SEQUEN
               AND VIN.SITMOV <> 'C'
               AND VIN.SITKIT IN ('2','3'))
   	  INTO cFLGEST, cFILICO, cSEQICO, vCODFIL, vSEQUEN, vFUNRUR, vFILCLI, vCODCLI, vVLRLIQ, cSEQFAT, nQTDVIN
      FROM TT_VEN VEN LEFT JOIN TT_TRA TRA ON VEN.CODFIL = TRA.FILIVE AND VEN.SEQUEN = TRA.SEQIVE
     WHERE VEN.CODFIL=pCODFIL
       AND VEN.NUMECF=pNUMECF
       AND VEN.CODSER=pCODSER
       AND VEN.NUMNOT=pNUMNOT
LIMIT 1;

   SELECT CFG.ENVIAR_ENTREGA
     INTO vENTREGA
     FROM TT_CFG CFG;

   -- RFMP 80587 - No permitir cancelar notas com vnculos
   IF vVLRLIQ > 0 THEN
       IF nQTDVIN > 0 THEN
          RETURN 'No  possvel cancelar notas que j tenham vnculos. Para realizar essa operao  necessrio cancelar as notas vinculadas.';
       END IF;
   END IF;

   IF cFLGEST IS NULL THEN
      RETURN 'Venda no encontrada.';
   END IF;

   IF cFLGEST = 'C' THEN
      RETURN 'Venda j cancelada.';
   END IF;

   IF cFILICO IS NOT NULL OR cSEQICO IS NOT NULL THEN
      RETURN 'Nota de transferncia j recebida na filial no pode ser cancelada.';
   END IF;
   
   IF cSEQFAT IS NOT NULL THEN
      SELECT FAT.NUMECF, 
             FAT.CODSER, 
             FAT.NUMNOT
        INTO vNUMECF, vCODSER, vNUMNOT
        FROM TT_VEN FAT
       WHERE FAT.CODFIL = pCODFIL
         AND FAT.SEQUEN = cSEQFAT
         LIMIT 1;
       
      sMensagem := 'No  possvel cancelar nota que tenha vnculo com outra.'|| chr(13) || chr(10) ||
                   'Para realizar essa operao  necessrio cancelar primeiramente a nota vinculada: '|| chr(13) || chr(10) ||
                   'Filial: '|| pCodfil ||', ECF: '|| vNUMECF ||', Srie: '|| vCODSER ||', Nmero: '|| vNUMNOT;
      RETURN sMensagem;
   END IF;

   -- 62085 - Tratamentos para Fundo rural
   IF vFUNRUR <> 0 THEN
	 SELECT COUNT(*)
	   INTO nQTDDOP
	   FROM (SELECT PAG.FILDOP, PAG.SEQDOP
	           FROM TT_COM COM INNER JOIN TT_CLI CLI ON COM.FILFOR = CLI.FILCLI
	                                                AND COM.CODFOR = CLI.CODCLI
	                           INNER JOIN TD_MOE MOE ON COM.CODMOE = MOE.CODTAB
	                           INNER JOIN (SELECT PAG.CODFIL, PAG.SEQUEN, PAG.FLGEST, PAG.FILDOP, PAG.SEQDOP
	                                         FROM TT_PAG PAG INNER JOIN TT_USU USU ON PAG.FILUSU = USU.FILUSU
	                                                                              AND PAG.CODUSU = USU.CODUSU
	                                      ) PAG ON COM.CODFIL = PAG.CODFIL
	                                           AND COM.SEQUEN = PAG.SEQUEN
	          WHERE COM.FLGEST <> 'D'
	            AND PAG.FLGEST = 'P'
	            AND COM.CODFIL = pCodfil
	            AND COM.CODSER = pCodser
	            AND SUBSTR(COM.NUMNOT, 4, 6) = pNumnot
	            AND COM.FILFOR = vFILCLI
	            AND COM.CODFOR = vCODCLI) PAG;
     IF nQTDDOP > 0 THEN
	   RETURN 'Nota possui compromisso de Fundo Rural j pago.';
	 END IF;
   END IF;

   -- RFMP 92583 - Tratamentos de fatura e remessa
   RetornoItens := '';
   
   OPEN CR_IVE(vCODFIL,vSEQUEN);
   LOOP
      FETCH CR_IVE INTO vNUMITE, vLANEST, vFILORI, vNUMORI, vITEORI;
      EXIT WHEN NOT FOUND;

      -- A devolucao de fatura nao possui restricoes para ser cancelada.
      -- A fatura e remessa sao impedidas pelas verificacoes de vinculos logo no inicio dessa funcao.
      -- Apenas eh necessario tratar devolucao de remessa.
      
      -- Devolucao de Remessa
      -- Pode ser cancelada se o item da remessa vinculado, nao estiver
      -- vinculado a um item de fatura devolvido.
      -- Sistema nao permite cancelar uma fatura que tenha uma remessa nao cancelada,
      -- por isso, nao precisamos tratar esse caso.
      -- Esse processo permite a impressao de uma nova devolucao de remessa, ou volta
      -- a considerar a mercadoria entregue ao cliente.
      IF vLANEST = 'C' AND vVLRLIQ < 0 THEN

         SELECT COUNT(*)
           INTO QtdValidacao
           FROM TT_IVE REM INNER JOIN TT_IVE FAT ON FAT.CODFIL = REM.FILORI
                                                AND FAT.SEQUEN = REM.NUMORI
                                                AND FAT.NUMITE = REM.ITEORI
                           INNER JOIN TT_IVE DEV_FAT ON DEV_FAT.FILORI = FAT.CODFIL
                                                    AND DEV_FAT.NUMORI = FAT.SEQUEN
                                                    AND DEV_FAT.ITEORI = FAT.NUMITE
                                                    AND DEV_FAT.SITMOV <> 'C'
                                                    AND DEV_FAT.VLRMOV < 0
          WHERE REM.CODFIL = vFILORI
            AND REM.SEQUEN = vNUMORI
            AND REM.NUMITE = vITEORI;

         IF QtdValidacao > 0 THEN
            RetornoItens := 'Primeiro cancele a devoluo da fatura.';
            EXIT;
         END IF;

      END IF;

   END LOOP;
   CLOSE CR_IVE;

   IF LENGTH(RetornoItens) > 0 THEN
      RETURN RetornoItens;
   END IF;

   RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 0448 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PERMISSOESUSUARIO (TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 0449 --*/
CREATE OR REPLACE FUNCTION PERMISSOESUSUARIO (TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pFilusu ALIAS FOR $1 ;
pCodusu ALIAS FOR $2 ;
pSOHPAP ALIAS FOR $3 ;
pPERAUT ALIAS FOR $4 ;
   PERMIS_ORI                    VARCHAR(1000) := '';
   PERMIS_PAP                    VARCHAR(1000) := '';
   cPERAUT                       VARCHAR(1000) := '';
   PERMIS_USU                    VARCHAR(1000) := '';
   cMesclaPermissoesAutomaticas  VARCHAR(1000) := '';
   I                             INTEGER;
   LETRA_ORI                     VARCHAR(1);
   LETRA_PAP                     VARCHAR(1);

   PAPEIS CURSOR(cFilusu TT_USU.FILUSU%TYPE,
           cCodusu TT_USU.CODUSU%TYPE) IS
   SELECT PAP.PERMIS,
          CAST(RPAD(COALESCE(PAP.PERAUT,'N'),1000,'N') AS VARCHAR(1000)) AS PERAUT
     FROM TT_PAP PAP INNER JOIN TT_PAPXUSU PXU ON PAP.CODFIL = PXU.FILPAP
                                              AND PAP.SEQUEN = PXU.SEQPAP
    WHERE PXU.FILUSU = cFilusu
      AND PXU.CODUSU = cCodusu;

BEGIN
   SELECT PERMIS INTO PERMIS_ORI FROM TT_USU
    WHERE FILUSU = pFilusu
      AND CODUSU = pCodusu;

   IF PSOHPAP = 'T' THEN
      PERMIS_ORI := TRANSLATE(PERMIS_ORI,'S','N');
   END IF;

   -- RFMP 101438
   -- Inicializa as permisses automticas com "N"
   cMesclaPermissoesAutomaticas := RPAD('N',1000,'N');

   OPEN PAPEIS(pFilusu,pCodusu);
   LOOP
      PERMIS_USU := '';
      FETCH PAPEIS INTO PERMIS_PAP, cPERAUT;
      EXIT WHEN NOT FOUND;

      FOR I IN 1..LENGTH(TRIM(PERMIS_ORI)) LOOP
         LETRA_ORI:=SUBSTR(PERMIS_ORI,I,1);
         LETRA_PAP:=SUBSTR(PERMIS_PAP,I,1);
         IF COALESCE(LETRA_ORI,'N') = 'N' AND COALESCE(LETRA_PAP,'N') = 'S' THEN
            PERMIS_USU:=PERMIS_USU||LETRA_PAP;
         ELSIF COALESCE(LETRA_ORI,'N') = 'S' AND COALESCE(LETRA_PAP,'N') = 'N' THEN
            PERMIS_USU:=PERMIS_USU||LETRA_ORI;
         ELSE
            PERMIS_USU:=PERMIS_USU||LETRA_ORI;
         END IF;
      END LOOP;

      -- RFMP 101438
      -- Para cada papel, percorre cada permisso e verifica se ela est ligada.
      -- Se estiver ligada, ento o "N" de cMesclaPermissoesAutomaticas  substitudo por um "S".
      IF pPERAUT = 'T' THEN
         FOR I IN 1..LENGTH(TRIM(cPERAUT)) LOOP
            IF SUBSTR(cPERAUT,I,1) = 'S' AND SUBSTR(cMesclaPermissoesAutomaticas,I,1) = 'N' THEN
               cMesclaPermissoesAutomaticas := SUBSTR(cMesclaPermissoesAutomaticas,1,I-1)||'S'||SUBSTR(cMesclaPermissoesAutomaticas,I+1,9999);
            END IF;
         END LOOP;
      END IF;

      PERMIS_ORI := PERMIS_USU;
   END LOOP;
   CLOSE PAPEIS;

   IF ISNULL(PERMIS_USU) = 'T' THEN
      PERMIS_USU := PERMIS_ORI;
   END IF;

   -- RFMP 101438
   -- Para cada papel, percorre cada permisso e verifica se ela est ligada.
   -- Testa as regras que esto definidas abaixo:
   --
   -- Permisso (PERMIS): S      Permisso (PERMIS): N
   -- Automtica (PERAUT): S     Automtica (PERAUT): N
   -- Resultado: A               Resultado: N
   --
   -- Permisso (PERMIS): N      Permisso (PERMIS): S
   -- Automtica (PERAUT): S     Automtica (PERAUT): N
   -- Resultado: N               Resultado: S

   IF pPERAUT = 'T' THEN
      FOR I IN 1..LENGTH(TRIM(PERMIS_USU)) LOOP
         IF SUBSTR(PERMIS_USU,I,1) = 'S' AND SUBSTR(cMesclaPermissoesAutomaticas,I,1) = 'S' THEN
            PERMIS_USU := SUBSTR(PERMIS_USU,1,I-1)||'A'||SUBSTR(PERMIS_USU,I+1,9999);
         END IF;
      END LOOP;
   END IF;

   RETURN PERMIS_USU;

END;
$$ language 'plpgsql';


/*-- SEQ 0450 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PERMISSOESUSUARIO (TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE,VARCHAR) CASCADE;

/*-- SEQ 0451 --*/
CREATE OR REPLACE FUNCTION PERMISSOESUSUARIO (TT_USU.FILUSU%TYPE,
                               TT_USU.CODUSU%TYPE,
                               VARCHAR) 
RETURNS VARCHAR AS $$
BEGIN
RETURN PERMISSOESUSUARIO($1,$2,$3,'F');
END;
$$ language 'plpgsql';


/*-- SEQ 0452 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PERMISSOESUSUARIO (TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE) CASCADE;

/*-- SEQ 0453 --*/
CREATE OR REPLACE FUNCTION PERMISSOESUSUARIO (TT_USU.FILUSU%TYPE,
                               TT_USU.CODUSU%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN PERMISSOESUSUARIO($1,$2,'F','F');
END;
$$ language 'plpgsql';


/*-- SEQ 0454 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PESO_RATEIO (VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 0455 --*/
CREATE OR REPLACE FUNCTION PESO_RATEIO (VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
  TEM_PESO CHAR(1);
BEGIN
  -- Objetivo:
  -- Verificar se existe na compra algum item sem peso ou com peso zerado. Caso exista o rateio ser feito pelo valor mesmo a configurao estando como rateio pelo peso.
   SELECT CASE WHEN MIN(COALESCE(GRA.PESBRU,0)) = 0 THEN 'V' ELSE 'P' END INTO TEM_PESO
     FROM TT_ICO ICO INNER JOIN TT_GRA GRA ON ICO.FILMAT = GRA.FILMAT
                                          AND ICO.CODMAT = GRA.CODMAT
                                          AND ICO.CODCOR = GRA.CODCOR
                                          AND ICO.CODTAM = GRA.CODTAM
    WHERE ICO.CODFIL = pCODFIL
      AND ICO.SEQUEN = pSEQUEN;
  RETURN TEM_PESO;
END;
$$ language 'plpgsql';




/*-- SEQ 0456 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ParcelasTVFINCOM (TT_COM.CODFIL%TYPE,TT_COM.SEQUEN%TYPE,Numeric,TT_COM.SEQFAT%TYPE) CASCADE;

/*-- SEQ 0457 --*/
CREATE OR REPLACE FUNCTION ParcelasTVFINCOM (TT_COM.CODFIL%TYPE,TT_COM.SEQUEN%TYPE,Numeric,TT_COM.SEQFAT%TYPE)
RETURNS Numeric AS $$
DECLARE
pCodFil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
pValPar ALIAS FOR $3 ;
pSeqFat ALIAS FOR $4 ;
 
  i          Numeric(5);
  nValPar    Numeric(8,2);
  nValParRet Numeric(8,2);        
  nvalTot    Numeric(8,2);
  nSequen    TT_COM.SEQUEN%TYPE;
   bPrimeiro boolean;
  
  crParcelas CURSOR FOR
          select com.Sequen,trunc(com.vlrtot/fat.vlrtot*pValPar,2) as ValPar
            from tt_com com, tt_com fat
           where com.codfil=fat.codfil
             and com.seqfat=fat.sequen
             and fat.sequen=pSeqFat
             and fat.codfil=pCodFil
           order by com.sequen;
   
begin
   i := 0;
   nValPar:=null;
   nValTot:=0;
   bPrimeiro:=false;   
   
   OPEN crParcelas;
   LOOP
   FETCH crParcelas into nSequen,nValPar;
   EXIT WHEN NOT FOUND;     
   
     if (nSequen=pSequen) and (i=0) then
        nValParRet:=nValPar;       
        bPrimeiro:=true;
     end if;     
     
     if bPrimeiro then
        nValTot:=nValTot+nValPar;
     else
        nValParRet:=nValPar;
        EXIT WHEN nSequen=pSequen;
     end if;
        
     i := i + 1;        
   end loop;
   
   CLOSE crParcelas;

   if bPrimeiro then
      return nValParret+(pValPar-nValTot);
   else
      return nValParret;
   end if;

END;
$$ language 'plpgsql';

   


/*-- SEQ 0458 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PrecoVendaProduto (TT_TPR.CODCTR%TYPE,TT_TPR.CODFIL%TYPE,TT_TPR.ESTADO%TYPE,TT_PRE.FILMAT%TYPE,TT_PRE.CODMAT%TYPE,TT_PRE.CODCOR%TYPE,TT_PRE.CODTAM%TYPE) CASCADE;

/*-- SEQ 0459 --*/
CREATE OR REPLACE FUNCTION PrecoVendaProduto (TT_TPR.CODCTR%TYPE,TT_TPR.CODFIL%TYPE,TT_TPR.ESTADO%TYPE,TT_PRE.FILMAT%TYPE,TT_PRE.CODMAT%TYPE,TT_PRE.CODCOR%TYPE,TT_PRE.CODTAM%TYPE)
RETURNS Numeric AS $$
DECLARE
p_codctr ALIAS FOR $1 ;
p_codfil ALIAS FOR $2 ;
p_estado ALIAS FOR $3 ;
p_filmat ALIAS FOR $4 ;
p_codmat ALIAS FOR $5 ;
p_codcor ALIAS FOR $6 ;
p_codtam ALIAS FOR $7 ;
    V_CODFIL  TT_TPR.CODFIL%TYPE;
    V_CODPRE  TT_TPR.CODPRE%TYPE;
    V_PRECOV  TT_PRE.PRECOV%TYPE;
BEGIN
    SELECT INT.CODFIL, INT.CODPRE
      INTO V_CODFIL, V_CODPRE
      FROM (SELECT TPR.CODFIL, TPR.CODPRE
              FROM TT_TPR TPR
             WHERE coalesce(TPR.CATEG1,0) = 0
               AND coalesce(TPR.CATEG2,0) = 0
               AND coalesce(TPR.CATEG3,0) = 0
               AND TPR.CODCTR = P_CODCTR
               AND TPR.FILDES = P_CODFIL
            UNION ALL
            SELECT TPR.CODFIL, TPR.CODPRE
              FROM TT_TPR TPR
             WHERE coalesce(TPR.CATEG1,0) = 0
               AND coalesce(TPR.CATEG2,0) = 0
               AND coalesce(TPR.CATEG3,0) = 0
               AND TPR.CODCTR = P_CODCTR
               AND TPR.FILDES IS NULL
            UNION ALL
            SELECT TPR.CODFIL, TPR.CODPRE
              FROM TT_TPR TPR
             WHERE coalesce(TPR.CATEG1,0) = 0
               AND coalesce(TPR.CATEG2,0) = 0
               AND coalesce(TPR.CATEG3,0) = 0
               AND TPR.CODCTR IS NULL
               AND TPR.FILDES = P_CODFIL
            UNION ALL
            SELECT TPR.CODFIL, TPR.CODPRE
              FROM TT_TPR TPR
             WHERE coalesce(TPR.CATEG1,0) = 0
               AND coalesce(TPR.CATEG2,0) = 0
               AND coalesce(TPR.CATEG3,0) = 0
               AND TPR.ESTADO = P_ESTADO
            UNION ALL
            SELECT TPR.CODFIL, TPR.CODPRE
              FROM TT_TPR TPR CROSS JOIN TT_CFG CFG
             WHERE coalesce(TPR.CATEG1,0) = 0
               AND coalesce(TPR.CATEG2,0) = 0
               AND coalesce(TPR.CATEG3,0) = 0
               AND TPR.ESTADO IS NULL
               AND TPR.FILDES IS NULL
               AND TPR.CODCTR IS NULL
               AND AGORA() BETWEEN TPR.DATMIN AND TPR.DATMAX
               AND CFG.CICLOPRE = 'T'
            UNION ALL
           SELECT FILPRE AS CODFIL, CODPRE AS CODPRE
             FROM TT_CFG) INT
     LIMIT 1;

    SELECT INT.PRECOV
      INTO V_PRECOV
      FROM (SELECT PRE.PRECOV
              FROM TT_PRE PRE
             WHERE PRE.FILPRE = V_CODFIL
               AND PRE.CODPRE = V_CODPRE
               AND PRE.FILMAT = P_FILMAT
               AND PRE.CODMAT = P_CODMAT
               AND PRE.CODCOR = P_CODCOR
               AND PRE.CODTAM = P_CODTAM
            UNION ALL
            SELECT 0.00
              FROM DUAL) INT
     LIMIT 1;

    RETURN V_PRECOV;
END;
$$ language 'plpgsql';




/*-- SEQ 0460 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PrecoDia (TT_PRE.FILMAT%TYPE,TT_PRE.CODMAT%TYPE,TT_PRE.CODCOR%TYPE,TT_PRE.CODTAM%TYPE,TL_PRE.DATOPE%TYPE,TT_PRE.FILPRE%TYPE,TT_PRE.CODPRE%TYPE) CASCADE;

/*-- SEQ 0461 --*/
CREATE OR REPLACE FUNCTION PrecoDia (TT_PRE.FILMAT%TYPE,TT_PRE.CODMAT%TYPE,TT_PRE.CODCOR%TYPE,TT_PRE.CODTAM%TYPE,TL_PRE.DATOPE%TYPE,TT_PRE.FILPRE%TYPE,TT_PRE.CODPRE%TYPE)
RETURNS TT_PRE.PRECOV%TYPE AS $$
DECLARE
pFilMat ALIAS FOR $1 ;
pCodMat ALIAS FOR $2 ;
pCodCor ALIAS FOR $3 ;
pCodTam ALIAS FOR $4 ;
pDatOpe ALIAS FOR $5 ;
pFilPre ALIAS FOR $6 ;
pCodPre ALIAS FOR $7 ;
  nRetorno       TT_PRE.PRECOV%TYPE;
  nPrecoNaData   TT_PRE.PRECOV%TYPE;
  nPrecoAtual    TT_PRE.PRECOV%TYPE;

-- Objetivo:
-- 1) Calcular qual era o preo de venda do produto em determinada data.

BEGIN
  nRetorno       := NULL;
  nPrecoNaData   := NULL;
  nPrecoAtual    := NULL;

  IF TRUNC(pDatOpe) <= AGORA() THEN 
    -- procura preco no log
    BEGIN
      SELECT PREANT INTO nPrecoNaData 
        FROM (
      SELECT LPRE.PREANT
        FROM TT_PRE PRE INNER JOIN TL_PRE LPRE ON PRE.FILPRE = LPRE.FILPRE
                                              AND PRE.SEQUEN = LPRE.SEQPRE
       WHERE PRE.FILMAT = pFilMat
         AND PRE.CODMAT = pCodMat
         AND PRE.CODCOR = pCodCor
         AND PRE.CODTAM = pCodTam
         AND PRE.FILPRE = pFilPre
         AND PRE.CODPRE = pCodPre
         AND LPRE.DATOPE >= ADD_DAY(TRUNC(pDATOPE),1)
         AND LPRE.PREANT IS NOT NULL              
       ORDER BY LPRE.DATOPE
       ) TAB
       LIMIT 1;
    EXCEPTION
            
      WHEN others THEN NULL;
          END;
  END IF;

  IF nPrecoNaData IS NULL THEN
     -- pega o preco atual
     BEGIN
       SELECT PRE.PRECOV INTO nPrecoAtual
         FROM TT_PRE PRE
        WHERE PRE.FILMAT = pFilMat
          AND PRE.CODMAT = pCodMat
          AND PRE.CODCOR = pCodCor
          AND PRE.CODTAM = pCodTam
          AND PRE.FILPRE = pFilPre
          AND PRE.CODPRE = pCodPre;
     EXCEPTION
              
       WHEN others THEN NULL;
            END;
     nRetorno := nPrecoAtual;
  ELSIF (nPrecoNaData = 0) THEN
     nRetorno := NULL;
  ELSE
     nRetorno := nPrecoNaData;
  END IF;

  RETURN nRetorno;
END;
$$ language 'plpgsql';




/*-- SEQ 0462 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PrecoPsicologico (Numeric) CASCADE;

/*-- SEQ 0463 --*/
CREATE OR REPLACE FUNCTION PrecoPsicologico (Numeric)
RETURNS Numeric AS $$
DECLARE
pValor ALIAS FOR $1 ;
  wk_Valor  Numeric;
  wk_Aux    Numeric;
  wk_Menos  Numeric;
  wk_String VARCHAR(20);
  wk_Round  Numeric; 
  wk_Psi  Numeric; 

  Psico CURSOR FOR
    SELECT PRE_PSI_UTILIZA                  AS USA,
           PRE_PSI_1_CENTAVO                AS PSI_UM_CENTAVO,
           PRE_PSI_10_CENTAVOS              AS PSI_DEZ_CENTAVOS,
           PRE_PSI_1_REAL                   AS PSI_UM_REAL,
           PRE_PSI_10_REAIS                 AS PSI_DEZ_REAIS,
           PRE_PSI_100_REAIS                AS PSI_CEM_REAIS,
           PRE_PSI_DIGITO                   AS TERMINA_COM,
           PRE_PSI_PERCENTUAL               AS PERCENTUAL,
           PRE_ARR_1_CENTAVO                AS ARR_UM_CENTAVO,
           PRE_ARR_10_CENTAVOS              AS ARR_DEZ_CENTAVOS,
           PRE_ARR_1_REAL                   AS ARR_UM_REAL,     
           PRE_ARR_10_REAIS                 AS ARR_DEZ_REAIS,   
           PRE_ARR_100_REAIS                AS ARR_CEM_REAIS
    FROM TT_CFG;

  i RECORD;
  j Numeric;

BEGIN
  wk_Valor := TRUNC(ABS(COALESCE(pValor,0)),2);
 
  OPEN Psico;
  LOOP
    FETCH Psico into i;
    EXIT WHEN NOT FOUND;
    
    -- Usa preco psicologico?
    IF i.USA <> 'T' THEN EXIT; END IF;
    
    -- Somente para valores maiores que que zero
    IF wk_Valor <= 0 THEN EXIT; END IF;

    IF WK_VALOR>I.ARR_CEM_REAIS THEN
       wk_Round:=ROUND(WK_VALOR,-3);
    ELSIF WK_VALOR>I.ARR_DEZ_REAIS THEN
       wk_Round:=ROUND(WK_VALOR,-2);
    ELSIF WK_VALOR>I.ARR_UM_REAL THEN
       wk_Round:=ROUND(WK_VALOR,-1);
    ELSIF WK_VALOR>I.ARR_DEZ_CENTAVOS THEN
       wk_Round:=ROUND(WK_VALOR,0);
    ELSIF WK_VALOR>I.ARR_UM_CENTAVO THEN       
       wk_Round:=ROUND(WK_VALOR,1);
    ELSE
       wk_Round:=WK_VALOR;
    END IF;  
    
    IF    wk_Round > i.PSI_CEM_REAIS    THEN wk_Menos := 100.00;
    ELSIF wk_Round > i.PSI_DEZ_REAIS    THEN wk_Menos :=  10.00;
    ELSIF wk_Round > i.PSI_UM_REAL      THEN wk_Menos :=   1.00;
    ELSIF wk_Round > i.PSI_DEZ_CENTAVOS THEN wk_Menos :=   0.10;
    ELSIF wk_Round > i.PSI_UM_CENTAVO   THEN wk_Menos :=   0.01;
    ELSE
      wk_Menos := 0;
    END IF;
    
    wk_Psi := wk_Round - (wk_Menos*10) + (i.TERMINA_COM*wk_Menos);    
    
    -- A reducao nao pode ser maior que x% 
    IF wk_Round <> 0 THEN
      IF (wk_Psi*100/wk_Round)-100 < (i.PERCENTUAL*-1) THEN
        wk_Psi := wk_Valor;
      END IF;
    END IF;    

    EXIT;  
  END Loop;
  CLOSE Psico;

  RETURN wk_Psi;
  
END;
$$ language 'plpgsql';




/*-- SEQ 0464 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PrimeiroDiaAno (Timestamp) CASCADE;

/*-- SEQ 0465 --*/
CREATE OR REPLACE FUNCTION PrimeiroDiaAno (Timestamp)
RETURNS INTEGER AS $$
DECLARE
pData ALIAS FOR $1 ;
  dRETORNO INTEGER;
BEGIN

  select to_number(to_char(to_date('0101'||TO_CHAR(pData,'YYYY'),'ddmmyyyy'),'D'))-1 into dRETORNO
    from dual;

  RETURN dRETORNO;

END;
$$ language 'plpgsql';




/*-- SEQ 0466 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ProximoCodigo (VARCHAR,TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 0467 --*/
CREATE OR REPLACE FUNCTION ProximoCodigo (VARCHAR,TD_FIL.CODFIL%TYPE)
RETURNS VARCHAR AS $$
DECLARE
Tabela ALIAS FOR $1 ;
Filial ALIAS FOR $2 ;
---- Objetivo
-- 1) Obter o proximo valor sequencial de uma tabela
--
   loja                          TT_IDF.CODLOJ%TYPE;
   UnicoServer                   TT_CFG.SRVUNI%TYPE;
   proximo                       Numeric;
   Excecao                       BOOLEAN;

-- Principal
BEGIN
   /*IF Tabela IN ('TT_DIV', 'TT_SUB', 'TT_DOW', 'TM_ASS') THEN
     Excecao := True;
   ELSE
     Excecao := False;

     -- Verifica se ha apenas um servidor para o cliente
     SELECT SRVUNI INTO UnicoServer FROM TT_CFG;

     -- Verifica se a filial e a mesma do servidor
     SELECT CODLOJ INTO loja
     FROM (SELECT 0 AS dummy1 FROM DUAL) d1
          LEFT OUTER JOIN (SELECT 0 AS dummy2,CODLOJ FROM TT_IDF WHERE CODLOJ = Filial) d2
          ON d1.dummy1 = d2.dummy2;
   END IF;*/

   -- Obtem o proximo codigo
   /*IF (Excecao OR (loja IS NOT NULL) OR (UnicoServer = 'T')>%%)) THEN*/
     IF    Tabela = 'TT_BON' THEN SELECT NEXTVAL('sqBON')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_AUT' THEN SELECT NEXTVAL('sqAUT')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_AVI' THEN SELECT NEXTVAL('sqAVI')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TR_CAI' THEN SELECT NEXTVAL('sqRCAI') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CAR' THEN SELECT NEXTVAL('sqCAR')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CPM' THEN SELECT NEXTVAL('sqCPM')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CTA' THEN SELECT NEXTVAL('sqCTA')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CCC' THEN SELECT NEXTVAL('sqCCC')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CHR' THEN SELECT NEXTVAL('sqCHR')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CMT' THEN SELECT NEXTVAL('sqCMT')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_COM' THEN SELECT NEXTVAL('sqCOM')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_COS' THEN SELECT NEXTVAL('sqCOS')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CRE' THEN SELECT NEXTVAL('sqCRE')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CTT' THEN SELECT NEXTVAL('sqCTT')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CXG' THEN SELECT NEXTVAL('sqCXG')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_DIV' THEN SELECT NEXTVAL('sqDIV')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_DOP' THEN SELECT NEXTVAL('sqDOP')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_DOE' THEN SELECT NEXTVAL('sqDOE')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_DOW' THEN SELECT NEXTVAL('sqDOW')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_DRU' THEN SELECT NEXTVAL('sqDRU')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_DXG' THEN SELECT NEXTVAL('sqDXG')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_DXC' THEN SELECT NEXTVAL('sqDXC')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_SUB' THEN SELECT NEXTVAL('sqSUB')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_ETI' THEN SELECT NEXTVAL('sqETI')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_ECT' THEN SELECT NEXTVAL('sqECT')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_FIN' THEN SELECT NEXTVAL('sqFIN')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_GRA' THEN SELECT NEXTVAL('sqGRA')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_HOR' THEN SELECT NEXTVAL('sqHOR')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_INV' THEN SELECT NEXTVAL('sqINV')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_IPE' THEN SELECT NEXTVAL('sqIPE')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_IVO' THEN SELECT NEXTVAL('sqIVO')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_KIT' THEN SELECT NEXTVAL('sqKIT')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_LAN' THEN SELECT NEXTVAL('sqLAN')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_LCF' THEN SELECT NEXTVAL('sqLCF')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_PRE' THEN SELECT NEXTVAL('sqPRE')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_PAP' THEN SELECT NEXTVAL('sqPAP')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_RDP' THEN SELECT NEXTVAL('sqRDP')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_REF' THEN SELECT NEXTVAL('sqREF')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_REG' THEN SELECT NEXTVAL('sqREG')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_RCP' THEN SELECT NEXTVAL('sqRCP')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_RZR' THEN SELECT NEXTVAL('sqRZR')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_REN' THEN SELECT NEXTVAL('sqREN')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_SAL' THEN SELECT NEXTVAL('sqSAL')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_SUP' THEN SELECT NEXTVAL('sqSUP')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_SQL' THEN SELECT NEXTVAL('sqSQL')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_SIM' THEN SELECT NEXTVAL('sqSIM')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_VEN' THEN SELECT NEXTVAL('sqVEN')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_TAR' THEN SELECT NEXTVAL('sqTAR')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_TRC' THEN SELECT NEXTVAL('sqTRC')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_WOR' THEN SELECT NEXTVAL('sqWOR')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_PRJ' THEN SELECT NEXTVAL('sqPRJ')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_MAI' THEN SELECT NEXTVAL('sqMAI')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_MAR' THEN SELECT NEXTVAL('sqMAR')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_VPE' THEN SELECT NEXTVAL('sqVPE')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TM_GRA' THEN SELECT NEXTVAL('sqMGRA') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TM_CLI' THEN SELECT NEXTVAL('sqMCLI') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TR_MOV' THEN SELECT NEXTVAL('sqRMOV') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TW_PRE' THEN SELECT NEXTVAL('sqWPRE') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TW_SAC' THEN SELECT NEXTVAL('sqWSAC') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_HND' THEN SELECT NEXTVAL('sqHND')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_TIT' THEN SELECT NEXTVAL('sqTIT')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_IXT' THEN SELECT NEXTVAL('sqIXT')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_PIV' THEN SELECT NEXTVAL('sqPIV')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_RES' THEN SELECT NEXTVAL('sqRES')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_ANX' THEN SELECT NEXTVAL('sqANX')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_AGE' THEN SELECT NEXTVAL('sqAGE')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_AUS' THEN SELECT NEXTVAL('sqAUS')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_EXP' THEN SELECT NEXTVAL('sqEXP')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_FER' THEN SELECT NEXTVAL('sqFER')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_ENV' THEN SELECT NEXTVAL('sqENV')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_IEN' THEN SELECT NEXTVAL('sqIEN')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_PHO' THEN SELECT NEXTVAL('sqPHO')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_ROM' THEN SELECT NEXTVAL('sqROM')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_MON' THEN SELECT NEXTVAL('sqMON')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_COR' THEN SELECT NEXTVAL('sqCOR')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_COB' THEN SELECT NEXTVAL('sqCOB')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_DEV' THEN SELECT NEXTVAL('sqDEV')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_RAT' THEN SELECT NEXTVAL('sqRAT')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_BAI' THEN SELECT NEXTVAL('sqBAI')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TD_CRT' THEN SELECT NEXTVAL('sqDCRT')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TD_DET' THEN SELECT NEXTVAL('sqDDET')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TD_LCR' THEN SELECT NEXTVAL('sqDLCR')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_MUN' THEN SELECT NEXTVAL('sqMUN')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_AFE' THEN SELECT NEXTVAL('sqAFE')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_FCP' THEN SELECT NEXTVAL('sqFCP')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_LMC' THEN SELECT NEXTVAL('sqLMC')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_PXR' THEN SELECT NEXTVAL('sqPXR')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_AGEXUSU' THEN SELECT NEXTVAL('sqAGEXUSU')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_COM_CANCELAMENTO' THEN SELECT NEXTVAL('sqCOM')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CHR_CANCELAMENTO' THEN SELECT NEXTVAL('sqCHR')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_TRC_CANCELAMENTO' THEN SELECT NEXTVAL('sqTRC')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_IRO_CANCELAMENTO' THEN SELECT NEXTVAL('sqIRO')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_DESXCLI' THEN SELECT NEXTVAL('sqDESXCLI')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_BONXCLI' THEN SELECT NEXTVAL('sqBONXCLI')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_ENP' THEN SELECT NEXTVAL('sqENP')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CAI' THEN SELECT NEXTVAL('sqCAI')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_EXT' THEN SELECT NEXTVAL('sqEXT')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_LEX' THEN SELECT NEXTVAL('sqLEX')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_DEP' THEN SELECT NEXTVAL('sqDEP')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_PREXDIF' THEN SELECT NEXTVAL('sqPREXDIF')  INTO proximo FROM DUAL;
     ELSIF Tabela = 'TW_FLU' THEN SELECT NEXTVAL('sqWFLU') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_ABM' THEN SELECT NEXTVAL('sqABM') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_BICXECF' THEN SELECT NEXTVAL('sqBICXECF') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CLA' THEN SELECT NEXTVAL('sqCLA') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_RCT' THEN SELECT NEXTVAL('sqRCT') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_DOU' THEN SELECT NEXTVAL('sqDOU') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_DESXICO' THEN SELECT NEXTVAL('sqDESXICO') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_TEC' THEN SELECT NEXTVAL('sqTEC') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_FLW' THEN SELECT NEXTVAL('sqFLW') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_AVA' THEN SELECT NEXTVAL('sqAVA') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_TEQ' THEN SELECT NEXTVAL('sqTEQ') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_EQP' THEN SELECT NEXTVAL('sqEQP') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_TEF' THEN SELECT NEXTVAL('SQTEF') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_FILXPLA' THEN SELECT NEXTVAL('SQFILXPLA') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_TCP' THEN SELECT NEXTVAL('SQTCP') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_UID' THEN SELECT NEXTVAL('SQUID') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TW_EXT' THEN SELECT NEXTVAL('sqWEXT') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_OPE' THEN SELECT NEXTVAL('SQ_TRN_ID_EST') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_DIS' THEN SELECT NEXTVAL('SQDIS') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_FIN' THEN SELECT NEXTVAL('SQLFIN') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_IVEXIPE' THEN SELECT NEXTVAL('SQIVEXIPE') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_HRE' THEN SELECT NEXTVAL('SQHRE') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CBP' THEN SELECT NEXTVAL('SQCBP') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_PLAXCAR' THEN SELECT NEXTVAL('SQPLAXCAR') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_CTF' THEN SELECT NEXTVAL('SQLCTF') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_COD' THEN SELECT NEXTVAL('sqCOD') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CTBXCCB' THEN SELECT NEXTVAL('SQTCTBXCCB') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TD_REJ' THEN SELECT NEXTVAL('sqDREJ') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_AGC' THEN SELECT NEXTVAL('SQAGC') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_REQ' THEN SELECT NEXTVAL('SQREQ') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_REQXREQ' THEN SELECT NEXTVAL('SQREQXREQ') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_REQXWOR' THEN SELECT NEXTVAL('SQREQXWOR') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_EAN' THEN SELECT NEXTVAL('SQEAN') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_VDD' THEN SELECT NEXTVAL('SQVDD') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CMS' THEN SELECT NEXTVAL('SQCMS') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_LIMXFIL' THEN SELECT NEXTVAL('SQLIMXFIL') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CBS' THEN SELECT NEXTVAL('SQCBS') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_LAC' THEN SELECT NEXTVAL('SQSEQUEN') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_OBS' THEN SELECT NEXTVAL('SQOBS') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_OIP' THEN SELECT NEXTVAL('SQOIP') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_VRT' THEN SELECT NEXTVAL('SQVRT') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TI_CLI' THEN SELECT NEXTVAL('SQICLI') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_IVO' THEN SELECT NEXTVAL('SQLIVO') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_CCC' THEN SELECT NEXTVAL('SQLCCC') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CORXCOB' THEN SELECT NEXTVAL('SQCORXCOB') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_CLI' THEN SELECT NEXTVAL('SQLCLI') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_GRA' THEN SELECT NEXTVAL('SQLGRA') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_IRO' THEN SELECT NEXTVAL('SQLIRO') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_PRJ' THEN SELECT NEXTVAL('SQLPRJ') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_TEF' THEN SELECT NEXTVAL('SQLTEF') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_DEL' THEN SELECT NEXTVAL('SQDEL') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_DOM' THEN SELECT NEXTVAL('SQDOM') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_CHR' THEN SELECT NEXTVAL('SQLCHR') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_COM' THEN SELECT NEXTVAL('SQLCOM') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_CTT' THEN SELECT NEXTVAL('SQLCTT') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_DOP' THEN SELECT NEXTVAL('SQLDOP') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_ECF' THEN SELECT NEXTVAL('SQLECF') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_EQP' THEN SELECT NEXTVAL('SQLEQP') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_LCF' THEN SELECT NEXTVAL('SQLLCF') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_LOG' THEN SELECT NEXTVAL('SQLOG') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_ROM' THEN SELECT NEXTVAL('SQLROM') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_MON' THEN SELECT NEXTVAL('SQLMON') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_ORC' THEN SELECT NEXTVAL('SQLORC') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_PRE' THEN SELECT NEXTVAL('SQLPRE') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_PRO' THEN SELECT NEXTVAL('SQLPRO') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_PROXNOM' THEN SELECT NEXTVAL('SQPROXNOM') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_RAT' THEN SELECT NEXTVAL('SQLRAT') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_RCP' THEN SELECT NEXTVAL('SQLRCP') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TR_CXG' THEN SELECT NEXTVAL('SQRCXG') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_REG' THEN SELECT NEXTVAL('SQLREG') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TR_FIN' THEN SELECT NEXTVAL('SQRFIN') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_SUP' THEN SELECT NEXTVAL('SQLSUP') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_VEN' THEN SELECT NEXTVAL('SQLVEN') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_WOR' THEN SELECT NEXTVAL('SQLWOR') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_ACR' THEN SELECT NEXTVAL('SQACR') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_ACR' THEN SELECT NEXTVAL('SQLACR') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_PTC' THEN SELECT NEXTVAL('SQPTC') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_PTC' THEN SELECT NEXTVAL('SQLPTC') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CCX' THEN SELECT NEXTVAL('SQCCX') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_INT' THEN SELECT NEXTVAL('SQINT') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_RTT' THEN SELECT NEXTVAL('SQRTT') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_RTT' THEN SELECT NEXTVAL('SQLRTT') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_PPR' THEN SELECT NEXTVAL('SQPPR') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_ITP' THEN SELECT NEXTVAL('SQITP') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_MPR' THEN SELECT NEXTVAL('SQLMPR') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_RDV' THEN SELECT NEXTVAL('SQRDV') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_RDV' THEN SELECT NEXTVAL('SQLRDV') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_IVEXCSG' THEN SELECT NEXTVAL('SQIVEXCSG') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_IVEXIOR' THEN SELECT NEXTVAL('SQIVEXIOR') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_BRU' THEN SELECT NEXTVAL('SQBRU') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_BRU' THEN SELECT NEXTVAL('SQLBRU') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_RPS' THEN SELECT NEXTVAL('SQLRPS') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_MPB' THEN SELECT NEXTVAL('SQMPB') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_ABA' THEN SELECT NEXTVAL('SQABA') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_EST' THEN SELECT NEXTVAL('SQEST') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_GRAXDCAR' THEN SELECT NEXTVAL('SQGRAXDCAR') INTO proximo FROM DUAL;
     ELSIF Tabela = 'GX_LOG' THEN SELECT NEXTVAL('GX_LogId') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TM_ASS' THEN SELECT NEXTVAL('SQMASS') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CEE' THEN SELECT NEXTVAL('SQCEE') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_BSC' THEN SELECT NEXTVAL('SQBSC') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_GRAXSC' THEN SELECT NEXTVAL('SQGRAXSC') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_COMXCOM' THEN SELECT NEXTVAL('SQCOMXCOM') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_SAD' THEN SELECT NEXTVAL('SQSAD') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_ICOXIRC' THEN SELECT NEXTVAL('SQICOXIRC') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_IRCXIPE' THEN SELECT NEXTVAL('SQIRCXIPE') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_SAV' THEN SELECT NEXTVAL('SQSAV') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_SAV_CODAVU' THEN SELECT NEXTVAL('SQCODAVU') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_SAV' THEN SELECT NEXTVAL('SQLSAV') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_INB' THEN SELECT NEXTVAL('SQINB') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_IBP' THEN SELECT NEXTVAL('SQIBP') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_LOT' THEN SELECT NEXTVAL('SQLOT') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_SLT' THEN SELECT NEXTVAL('SQSLT') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_FRP' THEN SELECT NEXTVAL('SQFRP') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_LOT' THEN SELECT NEXTVAL('SQLLOT') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_IFO' THEN SELECT NEXTVAL('SQIFO') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TM_IFC' THEN SELECT NEXTVAL('SQMIFC') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_ACM' THEN SELECT NEXTVAL('SQACM') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_TIN' THEN SELECT NEXTVAL('SQTIN') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_IOR_PAF' THEN SELECT NEXTVAL('SQLIORPAF') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TM_ABA' THEN SELECT NEXTVAL('SQMABA') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_LIS' THEN SELECT NEXTVAL('SQLIS') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_ILI' THEN SELECT NEXTVAL('SQILI') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_SLI' THEN SELECT NEXTVAL('SQSLI') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_VAT' THEN SELECT NEXTVAL('SQVAT') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_TRN' THEN SELECT NEXTVAL('SQTRN') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_INV' THEN SELECT NEXTVAL('SQLINV') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_LID' THEN SELECT NEXTVAL('SQLID') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_IORXDET' THEN SELECT NEXTVAL('SQIORXDET') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TM_ATU' THEN SELECT NEXTVAL('SQMATU') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CRB' THEN SELECT NEXTVAL('SQCRB') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_TSF' THEN SELECT NEXTVAL('SQTSF') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_DSP' THEN SELECT NEXTVAL('SQDSP') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_ERR' THEN SELECT NEXTVAL('SQERR') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CESXNCM' THEN SELECT NEXTVAL('SQCXN') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_CCB' THEN SELECT NEXTVAL('SQLCCB') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_LOI' THEN SELECT NEXTVAL('SQLOI') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_VOT' THEN SELECT NEXTVAL('SQVOT') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_GAB' THEN SELECT NEXTVAL('SQGAB') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_GAB' THEN SELECT NEXTVAL('SQLGAB') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_INU' THEN SELECT NEXTVAL('SQINU') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_PED' THEN SELECT NEXTVAL('SQLPED') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CTF' THEN SELECT NEXTVAL('SQCTF') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_PCS' THEN SELECT NEXTVAL('SQPCS') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_IPC' THEN SELECT NEXTVAL('SQIPC') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_NFE' THEN SELECT NEXTVAL('SQNFE') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_INF' THEN SELECT NEXTVAL('SQINF') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_ICOXLOT' THEN SELECT NEXTVAL('SQICOXLOT') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_AQV' THEN SELECT NEXTVAL('SQAQV') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_TPRXFIL' THEN SELECT NEXTVAL('SQTPRXFIL') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_TPF' THEN SELECT NEXTVAL('SQTPF') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CPF' THEN SELECT NEXTVAL('SQCPF') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_CPF' THEN SELECT NEXTVAL('SQLCPF') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CPR' THEN SELECT NEXTVAL('SQCPR') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CPRXGAT' THEN SELECT NEXTVAL('SQCPRXGAT') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_GATXPRO' THEN SELECT NEXTVAL('SQGATXPRO') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_GATXCLI' THEN SELECT NEXTVAL('SQGATXCLI') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_GATXAPL' THEN SELECT NEXTVAL('SQAPLXPRO') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CUP' THEN SELECT NEXTVAL('SQCUP') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CUP_NUMERO' THEN SELECT NEXTVAL('SQCUPNUM') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CUPXUSO' THEN SELECT NEXTVAL('SQCUPXUSO') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_CPR' THEN SELECT NEXTVAL('SQLCPR') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_CUP' THEN SELECT NEXTVAL('SQLCUP') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_IORXCPR' THEN SELECT NEXTVAL('SQOXC') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_IVEXCPR' THEN SELECT NEXTVAL('SQVXC') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_LAYXLGPD' THEN SELECT NEXTVAL('SQLAYXLGPD') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_LAYXLGPD' THEN SELECT NEXTVAL('SQLLAYXLGPD') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_PLA' THEN SELECT NEXTVAL('SQLPLA') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TL_PRO_SPED' THEN SELECT NEXTVAL('SQLPROSPED') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TI_SLT' THEN SELECT NEXTVAL('SQISLT') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TI_REC' THEN SELECT NEXTVAL('SQIREC') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TI_LOT' THEN SELECT NEXTVAL('SQILOT') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CPRXTPR' THEN SELECT NEXTVAL('SQCPRXTPR') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CPRXPLA' THEN SELECT NEXTVAL('SQCPRXPLA') INTO proximo FROM DUAL;
     ELSIF Tabela = 'TT_CPRXDFIL' THEN SELECT NEXTVAL('SQCPRXDFIL') INTO proximo FROM DUAL;
     END IF;
     IF proximo IS NOT NULL THEN
       -- Tratamento especial
       IF Tabela IN ('TT_DIV', 'TT_SUB', 'TT_DOW', 'TD_REJ') THEN
         RETURN LPAD(RTRIM(TO_CHAR(proximo)),5,' ');
       -- MN - Tabela no elsif abaixo não tem o código formatado com 10 ou 5 a esquerda
       ELSIF Tabela IN ('TT_OPE', 'GX_LOG', 'TM_ASS', 'TT_CRB', 'TT_CESXNCM','TT_CTF','TT_PCS','TT_IPC','TT_NFE','TT_INF','TT_AQV', 
                        'TT_TPF') THEN
         RETURN proximo;
       ELSE
         RETURN LPAD(RTRIM(TO_CHAR(proximo)),10, ' ');
       END IF;
     END IF;
    /*END IF;*/
END;
$$ language 'plpgsql';




/*-- SEQ 0468 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ProximoFornecedor (TI_DES.CODPRO%TYPE,TI_DES.CODFOR%TYPE,TI_DES.NUMPED%TYPE) CASCADE;

/*-- SEQ 0469 --*/
CREATE OR REPLACE FUNCTION ProximoFornecedor (TI_DES.CODPRO%TYPE,TI_DES.CODFOR%TYPE,TI_DES.NUMPED%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODPRO ALIAS FOR $1 ;
pCODFOR ALIAS FOR $2 ;
pNUMPED ALIAS FOR $3 ;

WK_FILMAT TT_GRA.FILMAT%TYPE;
WK_CODMAT TT_GRA.CODMAT%TYPE;
WK_CODCOR TT_GRA.CODCOR%TYPE;
WK_CODTAM TT_GRA.CODTAM%TYPE;
WK_PED_FILFOR TT_CLI.FILCLI%TYPE;
WK_PED_CODFOR TT_CLI.CODCLI%TYPE;
WK_PED_CODFIL TT_PED.CODFIL%TYPE;
WK_PED_NUMPED TT_PED.NUMPED%TYPE;
WK_IPE_NUMITE TT_IPE.NUMITE%TYPE;
WK_NEW_FILFOR TT_CLI.FILCLI%TYPE;
WK_NEW_CODFOR TT_CLI.CODCLI%TYPE;
WK_FORNECEDOR VARCHAR(255);
WK_FORITE VARCHAR(10);
WK_ORIITE VARCHAR(50);
WK_EXISTE Numeric(2);
WK_TEMP VARCHAR(50);
WK_FILORI TT_IPE.FILORI%TYPE;
WK_PEDORI TT_IPE.PEDORI%TYPE;
WK_ITEORI TT_IPE.ITEORI%TYPE;


FORNECEDORES CURSOR(pFORNECEDORES VARCHAR) IS
  SELECT PXF.FILFOR, PXF.CODFOR
    FROM TT_PXF PXF INNER JOIN TT_CLI CLI ON PXF.FILFOR = CLI.FILCLI
                                         AND PXF.CODFOR = CLI.CODCLI
                    INNER JOIN TT_REL REL ON PXF.FILFOR = REL.FILPAR
                                         AND PXF.CODFOR = REL.CODPAR
                                         AND PXF.TIPFOR = REL.TIPPAR
   WHERE PXF.FILMAT = WK_FILMAT
     AND PXF.CODMAT = WK_CODMAT
     AND INSTR(pFORNECEDORES,CLI.FILCLI||CLI.CODCLI) = 0
     AND PXF.ORDPED > 0
  ORDER BY PXF.ORDPED ASC;

BEGIN


  WK_EXISTE := 1;
  
  BEGIN
    SELECT CODFIL, NUMPED, FILFOR, CODFOR
      INTO WK_PED_CODFIL, WK_PED_NUMPED, WK_PED_FILFOR, WK_PED_CODFOR
      FROM TT_PED
     WHERE LPAD(PEDEXT,12,0) = pNUMPED
       AND FILFOR||TRIM(CODFOR) = pCODFOR
       AND DATENV IS NOT NULL
       AND FLGEST IN ('2','1','A');

  EXCEPTION
        
    WHEN others THEN NULL;
      END;
 
  IF ISNOTNULL(WK_PED_NUMPED) = 'T'   THEN 
    BEGIN
      SELECT FILMAT, CODMAT, CODCOR, CODTAM
        INTO WK_FILMAT, WK_CODMAT, WK_CODCOR, WK_CODTAM
        FROM TT_GRA
       WHERE CODEXT = pCODPRO;
    EXCEPTION
              
       WHEN others THEN NULL;
           END;

    BEGIN
      SELECT NUMITE
        INTO WK_IPE_NUMITE
        FROM TT_IPE
       WHERE CODFIL = WK_PED_CODFIL
         AND NUMPED = WK_PED_NUMPED
         AND FILMAT = WK_FILMAT
         AND CODMAT = WK_CODMAT
         AND CODCOR = WK_CODCOR
         AND CODTAM = WK_CODTAM;
    EXCEPTION
            
      WHEN others THEN NULL;
          END;

    --chamada recursiva para verificar fornecedores que j atenderam o item
    WK_FORNECEDOR := CHR(124)||WK_PED_FILFOR||WK_PED_CODFOR||CHR(124);
    WK_TEMP := FornecedoresAtendidos(WK_PED_CODFIL,WK_PED_NUMPED,WK_IPE_NUMITE);

    IF ISNOTNULL(WK_TEMP) = 'T'  THEN
      WK_FORITE := SUBSTR(WK_TEMP,1,9); --dados do fornecedor
      WK_ORIITE := SUBSTR(WK_TEMP,10,LENGTH(WK_TEMP)-8); --dados do item
      WK_FORNECEDOR := WK_FORNECEDOR||WK_FORITE||CHR(124); --string de fornecedores
      WHILE WK_EXISTE < 10 LOOP --iteracoes maximas
	IF ISNOTNULL(WK_ORIITE) = 'T'  THEN 
          WK_FILORI := SUBSTR(WK_ORIITE,1,3);
          WK_PEDORI := SUBSTR(WK_ORIITE,4,8);
          WK_ITEORI := SUBSTR(WK_ORIITE,12,3);
	  --recursividade
          WK_TEMP := FornecedoresAtendidos(WK_FILORI,
                                           WK_PEDORI,
    	    			           WK_ITEORI);	 
          IF ISNOTNULL(WK_TEMP) = 'T' THEN
            WK_FORITE := SUBSTR(WK_TEMP,1,9);
            WK_ORIITE := SUBSTR(WK_TEMP,10,LENGTH(WK_TEMP)-8);
            WK_FORNECEDOR := WK_FORNECEDOR||WK_FORITE||CHR(124);
	  END IF;
        END IF;
	WK_EXISTE := WK_EXISTE+1;
      END LOOP;
    END IF;

    OPEN FORNECEDORES(WK_FORNECEDOR);
    FETCH FORNECEDORES INTO WK_NEW_FILFOR, WK_NEW_CODFOR;
    CLOSE FORNECEDORES;
    

  END IF;

  IF WK_NEW_CODFOR IS NULL THEN
    BEGIN
     SELECT FIL_ESPECIAL, COD_ESPECIAL INTO WK_NEW_FILFOR, WK_NEW_CODFOR
       FROM TT_CFG;
    EXCEPTION
            
      WHEN others THEN NULL;
          END;
  END IF;

  IF WK_NEW_CODFOR IS NULL THEN 
    RAISE EXCEPTION 'PG-20001 NAO FOI POSSIVEL DETERMINAR O PROXIMO FORNECEDOR PARA O PRODUTO!';
  END IF;

  RETURN (WK_NEW_FILFOR||TRIM(WK_NEW_CODFOR));

END;
$$ language 'plpgsql';


      


/*-- SEQ 0470 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION QuantidadeLMCVenda (TT_MDT.DATMED%type,TD_BIC.FILBIC%type,TD_BIC.SEQFIL%type,TT_GRA.FILMAT%type,TT_GRA.CODMAT%type,TT_GRA.CODCOR%type,TT_GRA.CODTAM%type,Numeric,Numeric) CASCADE;

/*-- SEQ 0471 --*/
CREATE OR REPLACE FUNCTION QuantidadeLMCVenda (TT_MDT.DATMED%type,TD_BIC.FILBIC%type,TD_BIC.SEQFIL%type,TT_GRA.FILMAT%type,TT_GRA.CODMAT%type,TT_GRA.CODCOR%type,TT_GRA.CODTAM%type,Numeric,Numeric)
RETURNS Numeric AS $$
DECLARE
pDATMED ALIAS FOR $1 ;
pFILBIC ALIAS FOR $2 ;
pSEQFIL ALIAS FOR $3 ;
pFILMAT ALIAS FOR $4 ;
pCODMAT ALIAS FOR $5 ;
pCODCOR ALIAS FOR $6 ;
pCODTAM ALIAS FOR $7 ;
pENCABE ALIAS FOR $8 ;
pENCFEC ALIAS FOR $9 ;
  nRESULT Numeric;
BEGIN
  nResult := 0;
  
  SELECT (SELECT coalesce(SUM(QTDMOV),0) 
            FROM TT_IVE IVE 
           WHERE IVE.VEN_DATHOR BETWEEN ADD_DAY(pDATMED,-2) AND ADD_DAY(pDATMED,+6) 
             AND IVE.FILBIC=pFILBIC 
             AND IVE.SEQFIL=pSEQFIL
             AND IVE.FILMAT=pFILMAT
             AND IVE.CODMAT=pCODMAT
             AND IVE.CODCOR=pCODCOR
             AND IVE.CODTAM=pCODTAM
             AND 1 = CASE WHEN pENCABE<pENCFEC AND TO_NUMBER(COALESCE(IVE.NUMEXT,'0'))/100 BETWEEN pENCABE+0.01 AND pENCFEC THEN 1
                          WHEN pENCABE>pENCFEC AND (TO_NUMBER(COALESCE(IVE.NUMEXT,'0'))/100 BETWEEN pENCABE+IVE.QTDMOV AND 9999999999999999 OR 
                                                  TO_NUMBER(COALESCE(IVE.NUMEXT,'0'))/100 BETWEEN 0 AND pENCFEC ) THEN 1
                          ELSE 0
                      END
             AND IVE.SITMOV <> 'C'
             AND LANEST='S'
         ) INTO nRESULT
   FROM DUAL;      

  RETURN nRESULT;

END;
$$ language 'plpgsql' STABLE;




/*-- SEQ 0472 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION QtdPendente (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE,TT_IVE.QTDMOV%TYPE) CASCADE;

/*-- SEQ 0473 --*/
CREATE OR REPLACE FUNCTION QtdPendente (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE,TT_IVE.QTDMOV%TYPE)
RETURNS Numeric AS $$
DECLARE
p_CodFil ALIAS FOR $1 ;
p_Sequen ALIAS FOR $2 ;
p_NumIte ALIAS FOR $3 ;
p_QtdMov ALIAS FOR $4 ;
   QTDENT Numeric;    -- Quantidade entregue

-- Objetivo:
-- 1) Calcular a quantidade pendente (no entregue ao cliente) eliminando a quantidade futura.

BEGIN
  SELECT COALESCE(QTDMOV,0)-COALESCE(QTDPEN,0)+COALESCE(QTDFUT,0)
    INTO QTDENT 
    FROM TT_IVE
   WHERE CODFIL = p_CodFil
     AND SEQUEN = p_Sequen
     AND NUMITE = p_NumIte
     AND SITMOV <> 'C';
  
  RETURN p_QtdMov - COALESCE(QTDENT,0);
  
END;
$$ language 'plpgsql';




/*-- SEQ 0474 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION QTD_A_SEPARAR (TT_IVO.FILIVE%TYPE,TT_IVO.SEQIVE%TYPE,TT_IVO.NUMIVE%TYPE,TT_IVO.FILPED%TYPE,TT_IVO.TIPPED%TYPE,TT_IVO.NUMPED%TYPE,TT_IVO.NUMITE%TYPE) CASCADE;

/*-- SEQ 0475 --*/
CREATE OR REPLACE FUNCTION QTD_A_SEPARAR (TT_IVO.FILIVE%TYPE,TT_IVO.SEQIVE%TYPE,TT_IVO.NUMIVE%TYPE,TT_IVO.FILPED%TYPE,TT_IVO.TIPPED%TYPE,TT_IVO.NUMPED%TYPE,TT_IVO.NUMITE%TYPE)
RETURNS Numeric AS $$
DECLARE
p_Filive ALIAS FOR $1 ;
p_Seqive ALIAS FOR $2 ;
p_Numive ALIAS FOR $3 ;
p_Filped ALIAS FOR $4 ;
p_Tipped ALIAS FOR $5 ;
p_Numped ALIAS FOR $6 ;
p_Numite ALIAS FOR $7 ;
   vQTDSEP Numeric;    -- Quantidade a separar
   vTIPENT TT_IOR.TIPENT%TYPE;

-- Objetivo:
-- 1) Calcular a quantidade a ser separada pere este oramento ou venda.

BEGIN
  IF p_Filive IS NULL THEN
    SELECT MAX(COALESCE(IOR.QTDITE,0)) - SUM(CASE IVO.FLGEST WHEN 'F' THEN COALESCE(IVO.QTDFAL,0) ELSE COALESCE(IVO.CONTEM,0) END)
      INTO vQTDSEP
      FROM TT_IOR IOR LEFT JOIN TT_IVO IVO ON IVO.FILPED = IOR.CODFIL
                                          AND IVO.TIPPED = IOR.TIPPED
                                          AND IVO.NUMPED = IOR.NUMPED
                                          AND IVO.NUMITE = IOR.NUMITE
                                          AND IVO.FLGEST IN ('F','N','P','E')
     WHERE IOR.CODFIL = p_Filped
       AND IOR.TIPPED = p_Tipped
       AND IOR.NUMPED = p_Numped
       AND IOR.NUMITE = p_Numite
       AND IOR.FLGEST<>'C'
       AND IOR.FLGEST<>'E';
  ELSE
    SELECT IOR.TIPENT
      INTO vTIPENT
      FROM TT_IOR IOR
     WHERE IOR.FILIVE = p_Filive
       AND IOR.SEQIVE = p_Seqive
       AND IOR.NUMIVE = p_Numive;

    IF vTIPENT='3' THEN
        -- RFMP 95056
        -- Quando  Retira no Depsito e sistema s deve gerar separao se estiver configurado para isso.
        -- Se houver alguma separao equivocada, sistema calcular um vQTDSEP negativo, que depois  zerado.
        -- Por isso, o tratamento est sendo feito apenas na contagem das vendas.
        SELECT max(CASE IVE.LANEST WHEN 'R' THEN --IVE.QTDMOV-COALESCE(IVE.QTDPEN,0)
                                                            CASE WHEN CFG.SEP_FAT_RETIRA_DEPOSITO = 'T'
                                                                 THEN COALESCE(IVE.QTDPEN,0)
                                                                 ELSE 0
                                                            END
                                   ELSE IVE.QTDMOV
               END -
               COALESCE((SELECT SUM(CASE WHEN IVO.FLGEST = 'F' THEN COALESCE(IVO.QTDFAL,0)
                                         WHEN ROM.FLGEST='E' THEN 0
                                         ELSE COALESCE(IVO.CONTEM,0)
                           END)
                  FROM TT_IVO IVO LEFT JOIN TT_ROM ROM ON IVO.FILROM=ROM.CODFIL AND IVO.SEQROM=ROM.SEQUEN
                 WHERE IVO.FILIVE = IVE.CODFIL
                   AND IVO.SEQIVE = IVE.SEQUEN
                   AND IVO.NUMIVE = IVE.NUMITE
                   AND IVO.FLGEST IN ('F','N','P','E')
                   AND IVO.FILIMP IS NULL
               ),0)) INTO vQTDSEP
          FROM TT_IVE IVE CROSS JOIN TT_CFG CFG
         WHERE IVE.CODFIL = p_Filive
           AND IVE.SEQUEN = p_Seqive
           AND IVE.NUMITE = p_Numive
           AND IVE.SITMOV <> 'C';
    ELSE
          SELECT MAX(CASE WHEN VEN.CODSER='CF'
                          THEN IVE.QTDMOV - QtdDevolvida(IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE)
                          ELSE COALESCE(IVE.QTDPEN,IVE.QTDMOV)
                     END)
               - MAX(COALESCE(IVE.QTDFUT,0))
               - SUM(CASE WHEN IVO.FLGEST = 'F' THEN COALESCE(IVO.QTDFAL,0)
                          WHEN ROM.FLGEST='E' THEN 0
                          ELSE COALESCE(IVO.CONTEM,0)
                     END)
          INTO vQTDSEP
          FROM TT_IVE IVE INNER JOIN TT_VEN VEN ON IVE.CODFIL=VEN.CODFIL AND IVE.SEQUEN=VEN.SEQUEN
		                  LEFT JOIN TT_IVO IVO ON IVO.FILIVE = IVE.CODFIL
                                              AND IVO.SEQIVE = IVE.SEQUEN
                                              AND IVO.NUMIVE = IVE.NUMITE
                                              AND IVO.FLGEST IN ('F','N','P','E')
                                              AND IVO.FILIMP IS NULL
                          LEFT JOIN TT_ROM ROM ON IVO.FILROM=ROM.CODFIL AND IVO.SEQROM=ROM.SEQUEN
         WHERE IVE.CODFIL = p_Filive
           AND IVE.SEQUEN = p_Seqive
           AND IVE.NUMITE = p_Numive
           AND IVE.SITMOV <> 'C';
    END IF;
  END IF;

  IF vQTDSEP<0 THEN
     vQTDSEP :=0;
  END IF;

  RETURN COALESCE(vQTDSEP,0);

END;
$$ language 'plpgsql';




/*-- SEQ 0476 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION QtdHorasUteis (td_fil.codfil%type,Timestamp,Timestamp,Numeric) CASCADE;

/*-- SEQ 0477 --*/
CREATE OR REPLACE FUNCTION QtdHorasUteis (td_fil.codfil%type,Timestamp,Timestamp,Numeric)
RETURNS integer AS $$
DECLARE
P_Filial ALIAS FOR $1 ;
p_DATINI ALIAS FOR $2 ;
p_DATFIM ALIAS FOR $3 ;
p_VEZ ALIAS FOR $4 ;
     WK_CONTA  Numeric(10);
     WK_HORINI Numeric(7);
     WK_STRHORINI VARCHAR(10);
     WK_MININI Numeric(7);
     WK_MINFIM Numeric(7);     
     WK_DIASEM Numeric(1);
     WK_DATFIM Timestamp;
     WK_VEZ    Numeric(2);

  begin
    
    WK_VEZ := COALESCE(p_VEZ,0) + 1;
    IF (WK_VEZ > 50)
    OR (p_DATINI IS NULL) 
    OR (p_DATfim IS NULL) THEN
       RETURN NULL;
    END IF;

    IF p_DATINI>p_DATFIM THEN
       RETURN 0;
    END IF;
  
    IF trunc(p_DATINI)=trunc(p_DATFIM) then
       WK_DATFIM := p_DATFIM;
    ELSE
       -- Pega o maior horario do dia
       WK_DATFIM := to_date(to_char(TRUNC(p_DATINI),'dd/mm/yyyy')||' 23:59:59','dd/mm/yyyy HH24:MI:SS'); 
    END IF;
    
    -- Verifica se o dia e feriado.
    SELECT COUNT(*) INTO WK_CONTA FROM TT_FER
    WHERE DIAFER = TO_NUMBER(TO_CHAR(p_DATINI,'DD'))
      AND MESFER = TO_NUMBER(TO_CHAR(p_DATINI,'MM'))
      AND ((FILFER IS NULL) OR (FILFER=P_FILIAL))    
      AND ((ANOFER = TO_NUMBER(TO_CHAR(p_DATINI,'YYYY'))) OR (ANOFER IS NULL));

    if WK_CONTA > 0 then
      --  feriado, tenta no prximo dia.
      return QtdHorasUteis(P_FILIAL,TRUNC(P_DATINI)+1,p_DATFIM, wk_VEZ);
    end if;

    -- no Oracle o Domingo e codigo 1, j no sistema  cdigo 0
    -- DiaSem guarda o dia da semana, iniciando de 0
    WK_DIASEM := TO_CHAR(TO_NUMBER(TO_CHAR(p_datini,'D'))-1);

    -- MinIni guarda o valor dos minutos no formato totall
    WK_MININI := TO_NUMBER(TO_CHAR(p_datini,'HH24')) * 60 + TO_NUMBER(TO_CHAR(p_datini,'MI'));

    -- MinFim guarda o valor dos minutos no formato totall
    WK_MINFIM := TO_NUMBER(TO_CHAR(wk_datfim,'HH24')) * 60 + TO_NUMBER(TO_CHAR(wk_datfim,'MI'));

    -- Verifica as horas teis no dia 
    SELECT SUM( CASE WHEN QTD>0 THEN QTD ELSE 0 END ) INTO WK_CONTA
    FROM (SELECT LEAST(WK_MINFIM,HORFIM)-GREATEST(WK_MININI,HORINI) AS QTD
           FROM TT_EXP
          WHERE DIASEM = WK_DIASEM
            AND CODFIL = P_FILIAL
         ) INT;
       
    IF WK_CONTA<0 THEN
       WK_CONTA:=0;
    END IF;
    
    -- retorna a quantidade de horas
    RETURN COALESCE(WK_CONTA,0)+QtdHorasUteis(P_FILIAL,TRUNC(P_DATINI) + 1,p_DATFIM, wk_VEZ);    
END;
$$ language 'plpgsql';


/*-- SEQ 0478 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION QtdHorasUteis (td_fil.codfil%type,Timestamp,Timestamp) CASCADE;

/*-- SEQ 0479 --*/
CREATE OR REPLACE FUNCTION QtdHorasUteis (td_fil.codfil%type,
                               Timestamp,
                               Timestamp) 
RETURNS integer AS $$
BEGIN
RETURN QtdHorasUteis($1,$2,$3,0);
END;
$$ language 'plpgsql';


/*-- SEQ 0480 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Questionario (TT_RES.FILCLI%TYPE,TT_RES.CODCLI%TYPE,TT_RES.DATHOR%TYPE,TT_RES.DATHOR%TYPE) CASCADE;

/*-- SEQ 0481 --*/
CREATE OR REPLACE FUNCTION Questionario (TT_RES.FILCLI%TYPE,TT_RES.CODCLI%TYPE,TT_RES.DATHOR%TYPE,TT_RES.DATHOR%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_FilCli ALIAS FOR $1 ;
p_CodCli ALIAS FOR $2 ;
p_Inicio ALIAS FOR $3 ;
p_Fim ALIAS FOR $4 ;
  Texto    VARCHAR(4000);
  Resposta VARCHAR(4000);
  i        Numeric;

  Lista CURSOR FOR
    select trim(titper) || ':\par' ||
           SUBSTR(msg, 1, Length(msg)-3) || ':\par' || '-> Resposta: ' || nomopc ||
           case when trim(coment) is null then '' 
  	                                  else ', ' || trim(coment) 
	   end
     from (select REPLACE( REPLACE( per.msgper, CHR(123)||'\rtf1\ansi\ansicpg1252\deff0',''), 
                 CHR(123)||'\rtf1\ansi\deff0','') as msg, per.titper, opc.nomopc, res.coment
             from tt_res res inner join tt_per per on per.filper = res.filper
                                                  and per.codper = res.codper
                             inner join tt_opc opc on opc.filper = res.filper
                                                  and opc.codper = res.codper
                                                  and opc.codopc = res.codopc
            where res.dathor between TO_DATE(TO_CHAR(p_Inicio,'DD/MM/YYYY')||' 00:00:01','DD/MM/YYYY HH24:MI:SS')
	                         and TO_DATE(TO_CHAR(p_Fim,'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
              and res.filcli = p_FilCli
              and res.codcli = p_CodCli
            order by res.filper, res.codper) tab;
begin
  Texto := CHR(123)||'\rtf1\ansi\ansicpg1252\deff0';
  i := 0;
  OPEN Lista;
  LOOP
     FETCH Lista INTO Resposta;
     EXIT WHEN NOT FOUND;
     if (i > 0) then
       Texto := Texto || '\par\par';
     end if;
     if length( Texto || Resposta ) > 3950 then
       Texto := Texto || '\par ** TEXTO MUITO LONGO **';
       exit;
     else
       Texto := Texto || Resposta;
     end if;
     i := i + 1;
  END LOOP;
  Texto := Texto || '}';
  RETURN COALESCE(Texto,'');
END;
$$ language 'plpgsql';




/*-- SEQ 0482 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Rateio_Contas_Compra (TT_COMXCTA.CODFIL%TYPE,TT_COMXCTA.SEQUEN%TYPE,TT_COMXCTA.FILCTA%TYPE,TT_COMXCTA.SEQCTA%TYPE,TT_COMXCTA.TIPCTA%TYPE,TT_COM.VLRLIQ%TYPE,Numeric) CASCADE;

/*-- SEQ 0483 --*/
CREATE OR REPLACE FUNCTION Rateio_Contas_Compra (TT_COMXCTA.CODFIL%TYPE,TT_COMXCTA.SEQUEN%TYPE,TT_COMXCTA.FILCTA%TYPE,TT_COMXCTA.SEQCTA%TYPE,TT_COMXCTA.TIPCTA%TYPE,TT_COM.VLRLIQ%TYPE,Numeric)
RETURNS Numeric AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pFILCTA ALIAS FOR $3 ;
pSEQCTA ALIAS FOR $4 ;
pTIPCTA ALIAS FOR $5 ;
pValorTotal ALIAS FOR $6 ;
pValorASerRateado ALIAS FOR $7 ;

CR_PRIMEIRO CURSOR FOR
SELECT CXC.CODFIL||'-'||CXC.SEQUEN||'-'||CXC.FILCTA||'-'||CXC.SEQCTA||'-'||CXC.TIPCTA
  FROM TT_COMXCTA CXC
 WHERE CXC.CODFIL=pCODFIL
   AND CXC.SEQUEN=pSEQUEN;

nDif Numeric(12,2);
nValor Numeric(12,2);
cCHAVE VARCHAR(200);

BEGIN
    -- Calcula valor rateado individual e diferença entre a soma do valor rateado simples e o valor enviado
    SELECT pValorASerRateado - SUM(RATEADO),
           SUM(CASE WHEN (PCODFIL||'-'||PSEQUEN||'-'||PFILCTA||'-'||PSEQCTA||'-'||PTIPCTA) = 
                         (TAB.CODFIL||'-'||TAB.SEQUEN||'-'||TAB.FILCTA||'-'||TAB.SEQCTA||'-'||TAB.TIPCTA)
                    THEN RATEADO
                    ELSE 0
           END)
           INTO nDif, nValor
    FROM (SELECT CXC.CODFIL, 
                 CXC.SEQUEN,
                 CXC.FILCTA, 
                 CXC.SEQCTA, 
                 CXC.TIPCTA,
                 ROUND((CXC.VLRRAT * pValorASerRateado)/pValorTotal,2) AS RATEADO
           FROM TT_COMXCTA CXC
           WHERE CXC.CODFIL=pCODFIL
             AND CXC.SEQUEN=pSEQUEN
    ) TAB;

    -- Guarda chave do primeiro item    
    OPEN CR_PRIMEIRO;
    FETCH CR_PRIMEIRO INTO cCHAVE;
    CLOSE CR_PRIMEIRO;
    
    -- Joga diferença no primeiro item
    IF (pCODFIL||'-'||pSEQUEN||'-'||pFILCTA||'-'||pSEQCTA||'-'||pTIPCTA) = cCHAVE THEN
       nVALOR := nVALOR+nDIF;
    END IF;       
    
    return nVALOR;

END;
$$ language 'plpgsql';




/*-- SEQ 0484 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Rateio_ICM_Frete (TW_IVE_FIS.CODFIL%TYPE,TW_IVE_FIS.SEQUEN%TYPE,TW_IVE_FIS.NATFIS%TYPE,TW_IVE_FIS.TAX001%TYPE,TW_IVE_FIS.ICMTIP%TYPE) CASCADE;

/*-- SEQ 0485 --*/
CREATE OR REPLACE FUNCTION Rateio_ICM_Frete (TW_IVE_FIS.CODFIL%TYPE,TW_IVE_FIS.SEQUEN%TYPE,TW_IVE_FIS.NATFIS%TYPE,TW_IVE_FIS.TAX001%TYPE,TW_IVE_FIS.ICMTIP%TYPE)
RETURNS Numeric AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pNATFIS ALIAS FOR $3 ;
pTAX001 ALIAS FOR $4 ;
pICMTIP ALIAS FOR $5 ;

CR_PRIMEIRO CURSOR FOR
SELECT IVE.CODFIL||'-'||IVE.SEQUEN||'-'||IVE.NATFIS||'-'||IVE.TAX001||'-'||IVE.ICMTIP
 FROM TW_VEN_FIS VEN INNER JOIN TW_IVE_FIS IVE ON VEN.CODFIL = IVE.CODFIL
                                              AND VEN.SEQUEN = IVE.SEQUEN
                                              AND VEN.CODSER = IVE.CODSER
                                              AND VEN.NUMNOT = IVE.NUMNOT
 WHERE VEN.CODFIL=pCODFIL
   AND VEN.SEQUEN=PSEQUEN
   AND VEN.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
   AND IVE.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
 GROUP BY IVE.CODFIL, IVE.SEQUEN,IVE.NATFIS, IVE.TAX001, IVE.ICMTIP
order by TRUNC(SUM(IVE.VLR001 + COALESCE(IVE.ICMFRE,0) + COALESCE(IVE.ICMSEG,0) + COALESCE(IVE.ICMTAX,0)),2) desc;

nDIF Numeric(12,2);
nVALOR Numeric(12,2);
cCHAVE VARCHAR(200);

BEGIN

    select sum(soma) -  -- SOMA TOTAL
           sum(rateado), -- soma rateado
           SUM(CASE WHEN (pCODFIL||'-'||pSEQUEN||'-'||pNATFIS||'-'||pTAX001||'-'||pICMTIP) = 
                         (tab.CODFIL||'-'||tab.SEQUEN||'-'||tab.NATFIS||'-'||tab.TAX001||'-'||tab.ICMTIP)
                    THEN rateado
                    ELSE 0
           END)
           INTO nDIF, nVALOR
    from (SELECT IVE.CODFIL, IVE.SEQUEN,
                 IVE.NATFIS, IVE.TAX001, IVE.ICMTIP,
                 ROUND(SUM(IVE.VLR001 + COALESCE(IVE.ICMFRE,0) + COALESCE(IVE.ICMSEG,0) + COALESCE(IVE.ICMTAX,0)),2) AS rateado,
                 SUM(IVE.VLR001 + COALESCE(IVE.ICMFRE,0) + COALESCE(IVE.ICMSEG,0) + COALESCE(IVE.ICMTAX,0)) as soma
           FROM TW_VEN_FIS VEN INNER JOIN TW_IVE_FIS IVE ON VEN.CODFIL = IVE.CODFIL
                                                        AND VEN.SEQUEN = IVE.SEQUEN
                                                        AND VEN.CODSER = IVE.CODSER
                                                        AND VEN.NUMNOT = IVE.NUMNOT
           WHERE VEN.CODFIL=pCODFIL
             AND VEN.SEQUEN=PSEQUEN
             AND VEN.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
             AND IVE.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
           GROUP BY IVE.CODFIL, IVE.SEQUEN,IVE.NATFIS, IVE.TAX001, IVE.ICMTIP
    ) tab
    GROUP BY TAB.CODFIL, TAB.SEQUEN;
    
    OPEN CR_PRIMEIRO;
    FETCH CR_PRIMEIRO INTO cCHAVE;
    CLOSE CR_PRIMEIRO;
    
    IF (pCODFIL||'-'||pSEQUEN||'-'||pNATFIS||'-'||pTAX001||'-'||pICMTIP) = cCHAVE THEN
       nVALOR := nVALOR+nDIF;
    END IF;       
    
    return nVALOR;

END;
$$ language 'plpgsql';




/*-- SEQ 0486 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Rateio_ValorLiquido (TW_IVE_FIS.CODFIL%TYPE,TW_IVE_FIS.SEQUEN%TYPE,TW_IVE_FIS.NUMITE%TYPE) CASCADE;

/*-- SEQ 0487 --*/
CREATE OR REPLACE FUNCTION Rateio_ValorLiquido (TW_IVE_FIS.CODFIL%TYPE,TW_IVE_FIS.SEQUEN%TYPE,TW_IVE_FIS.NUMITE%TYPE)
RETURNS Numeric AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pNUMITE ALIAS FOR $3 ;

nDIF Numeric(12,2);
nVALOR Numeric(12,2);
cCHAVE VARCHAR(200);

vMAX_NUMITE TW_IVE_FIS.NUMITE%TYPE;
vCOUNT_ICMTIP Numeric(5);

BEGIN
    SELECT COUNT(*)  
      INTO vCOUNT_ICMTIP
      FROM (SELECT DISTINCT ICMTIP
              FROM TT_IVE 
             WHERE CODFIL = pCODFIL
               AND SEQUEN = pSEQUEN
               AND SITKIT IN ('2',IIF_Char_Char(IMPKIT,'T','3','1'))) A;

    IF vCOUNT_ICMTIP > 1 THEN 
        SELECT MAX(NUMITE) 
          INTO vMAX_NUMITE
          FROM TT_IVE
         WHERE CODFIL = pCODFIL
           AND SEQUEN = pSEQUEN
           AND SITKIT IN ('2',IIF_Char_Char(IMPKIT,'T','3','1'))
           AND ICMTIP = '0';
    ELSE
        SELECT MAX(NUMITE) 
          INTO vMAX_NUMITE
          FROM TT_IVE
         WHERE CODFIL = pCODFIL
           AND SEQUEN = pSEQUEN
           AND SITKIT IN ('2',IIF_Char_Char(IMPKIT,'T','3','1'));
    END IF;

       SELECT MIN(COALESCE(VEN.VLRLIQ,0) - COALESCE(VEN.VLRFRE,0) - COALESCE(VEN.VLRSEG,0) - COALESCE(VEN.OUTTAX,0)) - 
              CASE WHEN MIN(IVE.VLRMOV) > 0 
                   THEN SUM(TRUNC(IVE.VLRMOV + (IVE.VLRMOV * VEN.DESCON / 100),2)) 
                   ELSE SUM(TRUNC(IVE.VLRMOV + (IVE.VLRMOV * VEN.DESCON / 100),2)) * -1
               END AS dif,
              sum(case when ive.Numite=pNumite then TRUNC(IVE.VLRMOV + (IVE.VLRMOV * VEN.DESCON / 100),2) end) as rateio
              into nDif, NValor
         FROM TW_VEN_FIS VEN INNER JOIN TT_IVE IVE ON VEN.CODFIL = IVE.CODFIL
                                                  AND VEN.SEQUEN = IVE.SEQUEN
        WHERE VEN.CODFIL = pCODFIL
          AND VEN.SEQUEN = PSEQUEN
          AND IVE.SITKIT IN ('2',IIF_Char_Char(IVE.IMPKIT,'T','3','1'))
          AND IVE.QTDMOV <> 0 -- RFMP 70845 alteracao de tipo de entrega pode zerar a quantidade de uma ive
          AND VEN.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL);
   
   
    IF pNUMITE = vMAX_NUMITE THEN
      IF nValor > 0 THEN
       nVALOR := nVALOR+nDIF;
      ELSE
        nVALOR := nVALOR-nDIF;
      END IF;
    END IF;       
    
    return nVALOR;

END;
$$ language 'plpgsql';




/*-- SEQ 0488 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Rateio_ValorLiquido_Compra (TW_ICO_FIS.CODFIL%TYPE,TW_ICO_FIS.SEQUEN%TYPE,TW_ICO_FIS.NUMITE%TYPE) CASCADE;

/*-- SEQ 0489 --*/
CREATE OR REPLACE FUNCTION Rateio_ValorLiquido_Compra (TW_ICO_FIS.CODFIL%TYPE,TW_ICO_FIS.SEQUEN%TYPE,TW_ICO_FIS.NUMITE%TYPE)
RETURNS Numeric AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pNUMITE ALIAS FOR $3 ;

nDIF Numeric(12,2);
nVALOR Numeric(12,2);
cCHAVE VARCHAR(200);

vMAX_NUMITE TW_ICO_FIS.NUMITE%TYPE;
vCOUNT_ICMTIP Numeric(5);

BEGIN
    SELECT COUNT(*)
      INTO vCOUNT_ICMTIP
      FROM (SELECT DISTINCT ICMTIP
              FROM TT_ICO
             WHERE CODFIL = pCODFIL
               AND SEQUEN = pSEQUEN) A;

    IF vCOUNT_ICMTIP > 1 THEN
        SELECT MAX(NUMITE)
          INTO vMAX_NUMITE
          FROM TT_ICO
         WHERE CODFIL = pCODFIL
           AND SEQUEN = pSEQUEN
           AND ICMTIP = '0';
    ELSE
        SELECT MAX(NUMITE)
          INTO vMAX_NUMITE
          FROM TT_ICO
         WHERE CODFIL = pCODFIL
           AND SEQUEN = pSEQUEN;
    END IF;

    SELECT MIN(COM.DESCON) - SUM(TRUNC(((ICO.VLRMOV+ICO.VLRIPI) * (COM.DESCON / CASE WHEN COM.VLRTOT = 0 THEN 1 ELSE COM.VLRTOT END)),2)) AS DIF,
           SUM(CASE WHEN ICO.NUMITE = pNUMITE
                    THEN TRUNC((ICO.VLRMOV+ICO.VLRIPI) + ((ICO.VLRMOV+ICO.VLRIPI) * (COM.DESCON / CASE WHEN COM.VLRTOT = 0 THEN 1 ELSE COM.VLRTOT END)),2)
               END) AS RATEIO
           INTO nDIF, nVALOR
      FROM TW_COM_FIS COM INNER JOIN TT_ICO ICO ON COM.CODFIL = ICO.CODFIL
                                               AND COM.SEQUEN = ICO.SEQUEN
     WHERE COM.CODFIL = pCODFIL
       AND COM.SEQUEN = pSEQUEN
       AND COM.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL);

    IF pNUMITE = vMAX_NUMITE THEN
       nVALOR := nVALOR-nDIF;
    END IF;

    return nVALOR;

END;
$$ language 'plpgsql';




/*-- SEQ 0490 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ReferenciaProduto (TI_DES.CODPRO%TYPE,TT_REF.REFFOR%TYPE,TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE) CASCADE;

/*-- SEQ 0491 --*/
CREATE OR REPLACE FUNCTION ReferenciaProduto (TI_DES.CODPRO%TYPE,TT_REF.REFFOR%TYPE,TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODPRO ALIAS FOR $1 ;
pREFFOR ALIAS FOR $2 ;
pFILFOR ALIAS FOR $3 ;
pCODFOR ALIAS FOR $4 ;

 vACHOU BOOLEAN;
 vFILMAT TT_GRA.FILMAT%TYPE;
 vCODMAT TT_GRA.CODMAT%TYPE;
 VCODCOR TT_GRA.CODCOR%TYPE;
 vCODTAM TT_GRA.CODTAM%TYPE; 
 vREFPRO VARCHAR(20);
 vComplemento Constant VARCHAR(100) := Constante('Complemento');
 cCODPRO TI_DES.CODPRO%TYPE;

cREF CURSOR(pREFPRO VARCHAR) IS
SELECT FILMAT, CODMAT, CODCOR, CODTAM  FROM TT_GRA WHERE REFPRO = pREFPRO UNION ALL
SELECT FILMAT, CODMAT, CODCOR, CODTAM  FROM TT_GRA WHERE REFPRO = replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') UNION ALL
SELECT FILMAT, CODMAT, CODCOR, CODTAM  FROM TT_GRA WHERE REFPRO = lpad('0',01,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFPRO = lpad('0',02,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFPRO = lpad('0',03,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFPRO = lpad('0',04,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFPRO = lpad('0',05,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFPRO = lpad('0',06,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFPRO = lpad('0',07,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFPRO = lpad('0',08,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFPRO = lpad('0',09,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFPRO = lpad('0',10,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFPRO = lpad('0',11,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFPRO = lpad('0',12,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFPRO = lpad('0',13,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFPRO = lpad('0',14,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFPRO = lpad('0',15,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFPRO = lpad('0',16,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFPRO = lpad('0',17,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFPRO = lpad('0',18,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFPRO = lpad('0',19,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') UNION ALL
SELECT FILMAT, CODMAT, CODCOR, CODTAM  FROM TT_EAN WHERE CODEAN = pREFPRO UNION ALL
SELECT FILMAT, CODMAT, CODCOR, CODTAM  FROM TT_EAN WHERE CODEAN = replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') UNION ALL
SELECT FILMAT, CODMAT, CODCOR, CODTAM  FROM TT_EAN WHERE CODEAN = lpad('0',01,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         CODEAN = lpad('0',02,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         CODEAN = lpad('0',03,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         CODEAN = lpad('0',04,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         CODEAN = lpad('0',05,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         CODEAN = lpad('0',06,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         CODEAN = lpad('0',07,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         CODEAN = lpad('0',08,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         CODEAN = lpad('0',09,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         CODEAN = lpad('0',10,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         CODEAN = lpad('0',11,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         CODEAN = lpad('0',12,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         CODEAN = lpad('0',13,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         CODEAN = lpad('0',14,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         CODEAN = lpad('0',15,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         CODEAN = lpad('0',16,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         CODEAN = lpad('0',17,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         CODEAN = lpad('0',18,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         CODEAN = lpad('0',19,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') UNION ALL
SELECT FILMAT, CODMAT, TO_NUMBER(NULL) AS CODCOR, TO_NUMBER(NULL) AS CODTAM  FROM TT_PRO WHERE REFBAS = pREFPRO UNION ALL
SELECT FILMAT, CODMAT, TO_NUMBER(NULL) AS CODCOR, TO_NUMBER(NULL) AS CODTAM  FROM TT_PRO WHERE REFBAS = replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') UNION ALL
SELECT FILMAT, CODMAT, TO_NUMBER(NULL) AS CODCOR, TO_NUMBER(NULL) AS CODTAM  FROM TT_PRO 
                                                   WHERE REFBAS = lpad('0',01,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFBAS = lpad('0',02,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFBAS = lpad('0',03,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFBAS = lpad('0',04,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFBAS = lpad('0',05,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFBAS = lpad('0',06,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFBAS = lpad('0',07,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFBAS = lpad('0',08,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFBAS = lpad('0',09,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFBAS = lpad('0',10,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFBAS = lpad('0',11,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFBAS = lpad('0',12,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFBAS = lpad('0',13,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFBAS = lpad('0',14,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0');

cREFFOR CURSOR(pREFPRO VARCHAR,
           pFILFOR TT_CLI.FILCLI%TYPE,
           pCODFOR TT_CLI.CODCLI%TYPE) IS
SELECT FILMAT, CODMAT, CODCOR, CODTAM  FROM TT_REF WHERE FILFOR=pFILFOR AND CODFOR=pCODFOR AND REFFOR = pREFPRO UNION ALL
SELECT FILMAT, CODMAT, CODCOR, CODTAM  FROM TT_REF WHERE FILFOR=pFILFOR AND CODFOR=pCODFOR AND REFFOR = replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') UNION ALL
SELECT FILMAT, CODMAT, CODCOR, CODTAM  FROM TT_REF WHERE FILFOR=pFILFOR AND CODFOR=pCODFOR AND (
                                                         REFFOR = lpad('0',01,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFFOR = lpad('0',02,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFFOR = lpad('0',03,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFFOR = lpad('0',04,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFFOR = lpad('0',05,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFFOR = lpad('0',06,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFFOR = lpad('0',07,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFFOR = lpad('0',08,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFFOR = lpad('0',09,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFFOR = lpad('0',10,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFFOR = lpad('0',11,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFFOR = lpad('0',12,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFFOR = lpad('0',13,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFFOR = lpad('0',14,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFFOR = lpad('0',15,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFFOR = lpad('0',16,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFFOR = lpad('0',17,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFFOR = lpad('0',18,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
                                                         REFFOR = lpad('0',19,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') );

BEGIN
  
  cCODPRO := trim(pCODPRO);
  
  OPEN cREF(cCODPRO);
  vACHOU := TRUE;
  FETCH cREF INTO vFILMAT, vCODMAT, vCODCOR, vCODTAM;
  IF NOT FOUND THEN
     vACHOU := false;
  END IF;
  CLOSE cREF;
  
  IF vACHOU = FALSE THEN
      OPEN cREFFOR(pREFFOR,pFILFOR,pCODFOR);
      vACHOU := TRUE;
      FETCH cREFFOR INTO vFILMAT, vCODMAT, vCODCOR, vCODTAM;
      IF NOT FOUND THEN
         vACHOU := false;
      END IF;
      CLOSE cREFFOR;
  END IF;
  
  
  IF vACHOU = TRUE THEN
     IF vCODCOR IS NOT NULL THEN
       SELECT CODEXT INTO vREFPRO
         FROM TT_GRA 
        WHERE FILMAT = vFILMAT
          AND CODMAT = vCODMAT
          AND CODCOR = vCODCOR
          AND CODTAM = vCODTAM;
      ELSE
         SELECT MIN(CODEXT) INTO vREFPRO
           FROM TT_GRA 
          WHERE FILMAT = vFILMAT
            AND CODMAT = vCODMAT
          GROUP BY FILMAT,CODMAT
         HAVING COUNT(*) = 1;
      END IF;
  END IF;
  
  IF vACHOU = FALSE THEN
   RAISE EXCEPTION 'PG-20000 Produtos "%" e "%" no encontrados. %' , cCODPRO,pREFFOR,vComplemento;
  END IF;
  IF vREFPRO IS NULL THEN
    RAISE EXCEPTION 'PG-20000 Produto "%" sem codigo externo (GRA.CODEXT) cadastrado. %' , cCODPRO,vComplemento;
  END IF;

  RETURN (vREFPRO);

END;
$$ language 'plpgsql' STABLE;


/*-- SEQ 0492 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ReferenciaProduto (TI_DES.CODPRO%TYPE);

/*-- SEQ 0493 --*/
CREATE OR REPLACE FUNCTION ReferenciaProduto (TI_DES.CODPRO%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN ReferenciaProduto($1,null,null,null);
END;
$$ language 'plpgsql' STABLE;


/*-- SEQ 0494 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RegistraJob (TT_JOB.NOMJOB%TYPE,TT_JOB.DESJOB%TYPE,TT_JOB.ULTERR%TYPE,TT_JOB.CODUID%TYPE) CASCADE;

/*-- SEQ 0495 --*/
CREATE OR REPLACE FUNCTION RegistraJob (TT_JOB.NOMJOB%TYPE,TT_JOB.DESJOB%TYPE,TT_JOB.ULTERR%TYPE,TT_JOB.CODUID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pNOME ALIAS FOR $1 ;
pDESC ALIAS FOR $2 ;
pMSG ALIAS FOR $3 ;
pCODUID ALIAS FOR $4 ;
   nACHOU                        INTEGER;
   cNOME                         TT_JOB.NOMJOB%TYPE;
BEGIN
   cNOME := Trim(Upper(pNOME));

   SELECT COUNT(*) INTO nACHOU FROM TT_JOB WHERE NOMJOB = cNOME;

   IF nAchou = 0 THEN
      INSERT INTO TT_JOB (NOMJOB,DESJOB,ULTEXE,QTDERR,ULTERR,CODUID)
      VALUES (cNOME,pDESC,Agora(),0,NULL,pCODUID);
   END IF;

   UPDATE TT_JOB
      SET ULTEXE = Agora(),
          QTDERR = CASE WHEN pMSG IS NULL THEN 0 ELSE QTDERR+1 END,
          ULTERR = pMSG,
          CODUID = pCODUID
    WHERE NOMJOB = cNOME;

   RETURN 'OK';
END;
$$ language 'plpgsql';


/*-- SEQ 0496 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RegistraJob (TT_JOB.NOMJOB%TYPE,TT_JOB.DESJOB%TYPE,TT_JOB.ULTERR%TYPE) CASCADE;

/*-- SEQ 0497 --*/
CREATE OR REPLACE FUNCTION RegistraJob (TT_JOB.NOMJOB%TYPE,
                               TT_JOB.DESJOB%TYPE,
                               TT_JOB.ULTERR%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN RegistraJob($1,$2,$3,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 0498 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RegistraJob (TT_JOB.NOMJOB%TYPE,TT_JOB.DESJOB%TYPE) CASCADE;

/*-- SEQ 0499 --*/
CREATE OR REPLACE FUNCTION RegistraJob (TT_JOB.NOMJOB%TYPE,
                               TT_JOB.DESJOB%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN RegistraJob($1,$2,NULL,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 0500 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ReservaVenda () CASCADE;

/*-- SEQ 0501 --*/
CREATE OR REPLACE FUNCTION ReservaVenda ()
RETURNS VARCHAR AS $$
DECLARE

    -- RFMP 64536 Verifica se deve reservar venda
    WK_RESERV VARCHAR(1);
  BEGIN

    SELECT RESERVA_VENDA INTO WK_RESERV
      FROM TT_CFG;

    RETURN WK_RESERV;
END;
$$ language 'plpgsql';




/*-- SEQ 0502 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RetornaFlag (TD_SIT.TIPSIT%TYPE) CASCADE;

/*-- SEQ 0503 --*/
CREATE OR REPLACE FUNCTION RetornaFlag (TD_SIT.TIPSIT%TYPE)
RETURNS TD_SIT.CODTAB%TYPE AS $$
DECLARE
pTIPSIT ALIAS FOR $1 ;
  cCODTAB TD_SIT.CODTAB%TYPE;
BEGIN
    SELECT MIN(CODTAB)
      INTO cCODTAB
      FROM TD_SIT
     WHERE TIPSIT = pTIPSIT;
     RETURN cCODTAB;
END;
$$ language 'plpgsql';




/*-- SEQ 0504 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RetornaICMS (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE) CASCADE;

/*-- SEQ 0505 --*/
CREATE OR REPLACE FUNCTION RetornaICMS (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE)
RETURNS TT_ICO.ICMITE%TYPE AS $$
DECLARE
pFILMAT ALIAS FOR $1 ;
pCODMAT ALIAS FOR $2 ;
pCODCOR ALIAS FOR $3 ;
pCODTAM ALIAS FOR $4 ;
   cResultado TT_ICO.ICMITE%TYPE;
BEGIN  
   SELECT MAX(ICO.ICMITEDIF) INTO cResultado
     FROM TT_ICO ICO INNER JOIN TT_GRA GRA ON GRA.FILMAT = pFILMAT
                                          AND GRA.CODMAT = pCODMAT
                                          AND GRA.CODCOR = pCODCOR
                                          AND GRA.CODTAM = pCODTAM
                     LEFT JOIN TT_TRA TRA ON ICO.CODFIL = TRA.FILICO 
                                          AND ICO.SEQUEN = TRA.SEQICO
                                          AND ICO.NUMITE = TRA.NUMICO
         WHERE ICO.FILMAT = pFILMAT 
           AND ICO.CODMAT = pCODMAT
           AND ICO.CODCOR = pCODCOR
           AND ICO.CODTAM = pCODTAM
           AND TRA.FILICO IS NULL
           AND ICO.COM_DATOPE >= GRA.DATCOM 
           AND ICO.COM_DATOPE < ADD_DAY(GRA.DATCOM,1);
   RETURN cResultado;
   
END;
$$ language 'plpgsql';




/*-- SEQ 0506 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RetornaSUP (TT_WOR.CODFIL%TYPE,TT_WOR.SEQUEN%TYPE) CASCADE;

/*-- SEQ 0507 --*/
CREATE OR REPLACE FUNCTION RetornaSUP (TT_WOR.CODFIL%TYPE,TT_WOR.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILWOR ALIAS FOR $1 ;
pSEQWOR ALIAS FOR $2 ;
vFILSUP  TT_SUPXWOR.FILSUP%TYPE;
vSEQSUP  TT_SUPXWOR.SEQSUP%TYPE;
vDESSUP  TT_SUP.DESSUP%TYPE;
vSaida   VARCHAR(4000) := '';
c_supxwor CURSOR(pFILWOR TT_WOR.CODFIL%TYPE,
           pSEQWOR TT_WOR.SEQUEN%TYPE) IS
   SELECT SXW.FILSUP,
          SXW.SEQSUP,
          SUP.DESSUP
     FROM TT_SUP SUP,
          TT_SUPXWOR SXW
    WHERE SXW.FILSUP = SUP.CODFIL
      AND SXW.SEQSUP = SUP.SEQUEN
      AND SXW.FILWOR = pFILWOR
      AND SXW.SEQWOR = pSEQWOR;
BEGIN
   OPEN c_supxwor(pFILWOR,pSEQWOR);
   Loop     
     Fetch c_supxwor into vFILSUP, vSEQSUP, vDESSUP;
     Exit when NOT FOUND;
     vSaida := vSaida || vFILSUP ||'/'|| trim(vSEQSUP) ||' ' || vDESSUP ||chr(13)||chr(10);     
   end loop;
   Close c_supxwor;
   Return vSaida;
END;
$$ language 'plpgsql';




/*-- SEQ 0508 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Rtf2txt (VARCHAR) CASCADE;

/*-- SEQ 0509 --*/
CREATE OR REPLACE FUNCTION Rtf2txt (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pTexto ALIAS FOR $1 ;
  cRet VARCHAR(4000);
BEGIN

   cRet:=pTexto;

   if instr(cRet,to_path('/lang1046/f0/fs'))>0 then
      cRet:=ltrim( substr( cRet,instr(cRet,to_path('/lang1046/f0/fs')) + 17) );
   end if;

   if instr(cRet,to_path('/lang1033/f0/fs'))>0 then
      cRet:=ltrim( substr( cRet,instr(cRet,to_path('/lang1033/f0/fs')) + 17) );
   end if;

   cRet:=replace(cRet, CHR(123),''); -- abre chaves {
   cRet:=replace(cRet, to_path('//rtf1'),'');
   cRet:=replace(cRet, to_path('//ansi'),'');
   cRet:=replace(cRet, to_path('//deff0'),'');
   cRet:=replace(cRet, to_path('//fonttbl'),'');
   cRet:=replace(cRet, to_path('//f0'),'');
   cRet:=replace(cRet, to_path('//fcharset0 MS Sans Serif;'),'');
   cRet:=replace(cRet, to_path('//f1'),'');
   cRet:=replace(cRet, to_path('//fnil MS Sans Serif;'),'');
   cRet:=replace(cRet, to_path('//fnil'),'');
   cRet:=replace(cRet, to_path('//viewkind4'),'');
   cRet:=replace(cRet, to_path('//uc1'),'');
   cRet:=replace(cRet, to_path('//pard'),'');
   cRet:=replace(cRet, to_path('//lang1046'),'');
   cRet:=replace(cRet, to_path('//fs16'),'');
   cRet:=replace(cRet, to_path('//par'),'');
   cRet:=replace(cRet, to_path('/rtf1'),'');
   cRet:=replace(cRet, to_path('/fbidis'),'');
   cRet:=replace(cRet, to_path('/ansi'),'');
   cRet:=replace(cRet, to_path('/deff0'),'');
   cRet:=replace(cRet, to_path('/fonttbl'),'');
   cRet:=replace(cRet, to_path('/f0/bullet'),'');
   cRet:=replace(cRet, to_path('/f0'),'');
   cRet:=replace(cRet, to_path('/fswiss'),'');
   cRet:=replace(cRet, to_path('/fprq2'),'');
   cRet:=replace(cRet, to_path('/fcharset0 Arial;'),'');
   cRet:=replace(cRet, to_path('/fcharset0 Calibri;'),'');
   cRet:=replace(cRet, to_path('/f2'),'');
   cRet:=replace(cRet, to_path('/fnil MS Sans Serif;'),'');
   cRet:=replace(cRet, to_path('/colortbl ;'),'');
   cRet:=replace(cRet, to_path('/red79'),'');
   cRet:=replace(cRet, to_path('/green129'),'');
   cRet:=replace(cRet, to_path('/blue189;'),'');
   cRet:=replace(cRet, to_path('/blue255;'),'');
   cRet:=replace(cRet, to_path('/fcharset0 MS Reference Sans Serif;'),'');
   cRet:=replace(cRet, to_path('/red255'),'');
   cRet:=replace(cRet, to_path('/green0'),'');
   cRet:=replace(cRet, to_path('/blue0;'),'');
   cRet:=replace(cRet, to_path('/red0'),'');
   cRet:=replace(cRet, to_path('/stylesheet Normal;'),'');
   cRet:=replace(cRet, to_path('/s1 heading 1;'),'');
   cRet:=replace(cRet, to_path('/s2 heading 2;'),'');
   cRet:=replace(cRet, to_path('/viewkind4'),'');
   cRet:=replace(cRet, to_path('/uc1'),'');
   cRet:=replace(cRet, to_path('/cf2'),'');
   cRet:=replace(cRet, to_path('/fs20'),'');
   cRet:=replace(cRet, to_path('/ltrpar'),'');
   cRet:=replace(cRet, to_path('/keepn'),'');
   cRet:=replace(cRet, to_path('/keep'),'');
   cRet:=replace(cRet, to_path('/s2'),'');
   cRet:=replace(cRet, to_path('/fi-992'),'');
   cRet:=replace(cRet, to_path('/sb200'),'');
   cRet:=replace(cRet, to_path('/sl276'),'');
   cRet:=replace(cRet, to_path('/slmult1'),'');
   cRet:=replace(cRet, to_path('/cf1'),'');
   cRet:=replace(cRet, to_path('/ul'),'');
   cRet:=replace(cRet, to_path('/b'),'');
   cRet:=replace(cRet, to_path('/i'),'');
   cRet:=replace(cRet, to_path('/fs26'),'');
   cRet:=replace(cRet, to_path('/cf20'),'');
   cRet:=replace(cRet, to_path('/cf0none00'),'');
   cRet:=replace(cRet, to_path('/fs22'),'');
   cRet:=replace(cRet, to_path('/fnil'),'');
   cRet:=replace(cRet, to_path('/fcharset0 MS Sans Serif;'),'');
   cRet:=replace(cRet, to_path('/cf3none00'),'');
   cRet:=replace(cRet, to_path('/fs16'),'');
   cRet:=replace(cRet, to_path('/ulnone0'),'');
   cRet:=replace(cRet, to_path('/cf3'),'');
   cRet:=replace(cRet, to_path('/ansicpg1252'),'');
   cRet:=replace(cRet, to_path('/cpg1252'),'');
   cRet:=replace(cRet, to_path('cpg1252'),'');
   cRet:=replace(cRet, to_path('/deflang1046'),'');
   cRet:=replace(cRet, to_path('/tf1ansiansicpg1252deff0deflang1046'),'');
   cRet:=replace(cRet, to_path('tf1ansiansicpg1252deff0deflang1046'),'');
   cRet:=replace(cRet, to_path('/onttbl'),'');
   cRet:=replace(cRet, to_path('onttbl'),'');
   cRet:=replace(cRet, to_path('/nil MS Sans Serif;'),'');
   cRet:=replace(cRet, to_path('nil MS Sans Serif;'),'');
   cRet:=replace(cRet, to_path('/viewkind4uc1pard'),'');
   cRet:=replace(cRet, to_path('viewkind4uc1pard'),'');
   cRet:=replace(cRet, to_path('/tf1ansiansideff0deflang1046'),'');
   cRet:=replace(cRet, to_path('tf1ansiansideff0deflang1046'),'');
   cRet:=replace(cRet, to_path('/tf1ansideff0'),'');
   cRet:=replace(cRet, to_path('tf1ansideff0'),'');
   cRet:=replace(cRet, to_path('/lang1046'),'');
   cRet:=replace(cRet, to_path('lang1046'),'');
   cRet:=replace(cRet, to_path('/s16par'),'');
   cRet:=replace(cRet, to_path('s16par'),'');
   cRet:=replace(cRet, to_path('/abparpar'),'');
   cRet:=replace(cRet, to_path('abparpar'),'');

   cRet:=replace(cRet, to_path('/')||chr(39)||'20', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'21', '!' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'22', '"' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'23', '#' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'24', '$' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'25', '%' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'26', '&' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'27', chr(39) );
   cRet:=replace(cRet, to_path('/')||chr(39)||'28', '(' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'29', ')' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'2a', '*' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'2b', '+' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'2c', ',' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'2d', '-' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'2e', '.' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'2f', '/' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'30', '0' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'31', '1' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'32', '2' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'33', '3' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'34', '4' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'35', '5' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'36', '6' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'37', '7' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'38', '8' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'39', '9' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'3a', ':' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'3b', ';' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'3c', '<' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'3d', '=' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'3e', '>' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'3f', '?' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'40', '@' );
   -- 41 at 5a so letras em maisculo
   cRet:=replace(cRet, to_path('/')||chr(39)||'5b', '[' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'5c', chr(92));
   cRet:=replace(cRet, to_path('/')||chr(39)||'5d', ']' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'5e', '^' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'5f', '_' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'60', '`' );
   -- 61 at 7a so letras em minsculo
   cRet:=replace(cRet, to_path('/')||chr(39)||'7b', '{' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'7c', '|' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'7d', '}' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'7e', '~' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'82', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'83', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'84', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'85', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'86', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'87', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'88', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'89', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'8a', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'8b', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'8c', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'8e', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'91', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'92', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'93', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'94', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'95', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'96', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'97', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'98', '~' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'99', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'9a', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'9b', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'9c', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'9e', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'9f', ' ' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'a1', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'a2', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'a3', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'a4', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'a5', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'a6', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'a7', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'a8', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'a9', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'aa', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'ab', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'ac', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'ad', '-' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'ae', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'af', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'b0', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'b1', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'b2', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'b3', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'b4', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'b5', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'b6', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'b7', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'b8', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'b9', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'ba', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'bb', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'bc', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'bd', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'be', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'bf', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'c0', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'c1', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'c2', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'c3', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'c4', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'c5', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'c6', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'c7', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'c8', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'c9', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'ca', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'cb', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'cc', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'cd', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'ce', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'cf', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'d0', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'d1', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'d2', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'d3', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'d4', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'d5', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'d6', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'d7', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'d8', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'d9', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'da', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'db', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'dc', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'dd', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'de', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'df', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'e0', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'e1', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'e2', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'e3', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'e4', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'e5', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'e6', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'e7', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'e8', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'e9', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'ea', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'eb', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'ec', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'ed', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'ee', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'ef', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'f0', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'f1', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'f2', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'f3', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'f4', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'f5', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'f6', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'f7', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'f8', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'f9', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'fa', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'fb', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'fc', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'fd', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'fe', '' );
   cRet:=replace(cRet, to_path('/')||chr(39)||'ff', '' );

   cRet:=replace(cRet, to_path('/line'), chr(13) );

   cRet:=replace(cRet, to_path('/pard'),'');
   cRet:=replace(cRet, to_path('/par'),'');
   cRet:=replace(cRet, to_path('/f1'),'');
   cRet:=replace(cRet, to_path('/b/f0/fs14'),'');
   cRet:=replace(cRet, to_path('/b0/i'),'');
   cRet:=replace(cRet, to_path('/ul/i0'),'');
   cRet:=replace(cRet, to_path('/cf1/ulnone'),'');
   cRet:=replace(cRet, to_path('/cf2/f3/fs32'),'');
   cRet:=replace(cRet, to_path('/cf0/f4/fs16'),'');
   cRet:=replace(cRet, to_path('/f2/fs24'),'');
   cRet:=replace(cRet, to_path('/fs24'),'');
   cRet:=replace(cRet, to_path('}'),'');
   cRet:=replace(cRet, to_path('/froman'),'');
   cRet:=replace(cRet, to_path('/fcharset0 Times New Roman;'),'');
   cRet:=replace(cRet, to_path('/cf0'),'');
   cRet:=replace(cRet, to_path('/lang1033'),'');
   cRet:=replace(cRet, to_path('/fcharset0 Verdana;'),'');
   cRet:=replace(cRet, to_path('/fcharset0 Tahoma;'),'');
   cRet:=replace(cRet, to_path('/sb100/sa100/qj'),'');
   cRet:=replace(cRet, to_path('/trowd/trbrdrtrdrdbrdrw10 /trbrdrbrdrdbrdrw10 /cellx8445ntbl '),'');
   cRet:=replace(cRet, to_path('/cell/row'),'');
   cRet:=replace(cRet, to_path('/fs10'),'');
   cRet:=replace(cRet, to_path('/fs17'),'');
   cRet:=replace(cRet, to_path('/fs17ullet'),'');
   cRet:=replace(cRet, to_path('/fs18'),'');
   cRet:=replace(cRet, to_path('/tab'),'');
   cRet:=replace(cRet, to_path('/cell'),'');
   cRet:=replace(cRet, to_path('/highlight0'),'');
   cRet:=replace(cRet, to_path('/fs32'),'');
   cRet:=replace(cRet, to_path('/fs23'),'');
   cRet:=replace(cRet, to_path('/fcharset0 HP Simplified;'),'');
   cRet:=replace(cRet, to_path('/fcharset0 FuturaHv;'),'');
   cRet:=replace(cRet, to_path('/fcharset0 FuturaBk;'),'');
   cRet:=replace(cRet, to_path('/fcharset128 MS-Mincho;'),'');
   cRet:=replace(cRet, to_path('/f3'),'');

   return cRet;

END;
$$ language 'plpgsql' STABLE;




/*-- SEQ 0510 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SAC_POS_VENDA  (TT_SUP.PERFIL%TYPE,TT_SUP.FILVEN%TYPE,TT_SUP.SEQVEN%TYPE) CASCADE;

/*-- SEQ 0511 --*/
CREATE OR REPLACE FUNCTION SAC_POS_VENDA  (TT_SUP.PERFIL%TYPE,TT_SUP.FILVEN%TYPE,TT_SUP.SEQVEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pPERFIL ALIAS FOR $1 ;
pFILVEN ALIAS FOR $2 ;
pSEQVEN ALIAS FOR $3 ;
vCODPRI TT_QUE.CODPRI%TYPE;
vQTDDIA TT_QUE.QTDDIA%TYPE;
vCOUNT  Numeric(5);
vFILRES TT_USU.FILUSU%TYPE;
vCODRES TT_USU.CODUSU%TYPE;
BEGIN

SELECT count(*) INTO vCOUNT
  FROM TT_USU USU
 WHERE USU.SIGNAT > 0
   AND USU. FAZENQ = 'T';
               
IF vCOUNT>0 THEN

    SELECT MIN(CODPRI), MIN(QTDDIA), COUNT(*) INTO vCODPRI,vQTDDIA,vCOUNT
    FROM TT_QUE
    WHERE 'T' = CASE pPERFIL WHEN 'V' THEN POSVEN                             
                             WHEN 'E' THEN POSENT
                             WHEN 'M' THEN POSMON
                END;
END IF;
            
IF vCOUNT>0 THEN

    SELECT FILUSU, CODUSU into vFILRES,vCODRES
      FROM (SELECT USU.FILUSU, USU.CODUSU, 1 AS ORDEM
              FROM TT_USU USU
             WHERE USU.SIGNAT > 0
               AND USU.FILUSU||USU.CODUSU > (SELECT COALESCE(ULTSAC_FILUSU||ULTSAC_CODUSU,' ') FROM TT_CFG)
               AND USU. FAZENQ = 'T'
               AND (USU.FILUSU, USU.CODUSU) NOT IN
                   (SELECT AUS.FILUSU, AUS.CODUSU
                      FROM TT_AUS AUS
                     WHERE AUS.FILUSU = USU.FILUSU
                       AND AUS.CODUSU = USU.CODUSU
                       AND AUS.QTDHOR > 0
                       AND AUS.DATAUS = TRUNC(agora()) + 10)
           UNION ALL
           SELECT USU.FILUSU, USU.CODUSU, 2
             FROM TT_USU USU
            WHERE USU.SIGNAT > 0
              AND USU.FILUSU||USU.CODUSU <= (SELECT COALESCE(ULTSAC_FILUSU||ULTSAC_CODUSU,' ') FROM TT_CFG)
              AND USU. FAZENQ = 'T'
              AND (USU.FILUSU, USU.CODUSU) NOT IN
                  (SELECT AUS.FILUSU, AUS.CODUSU
                     FROM TT_AUS AUS
                    WHERE AUS.FILUSU = USU.FILUSU
                      AND AUS.CODUSU = USU.CODUSU
                      AND AUS.QTDHOR > 0
                      AND AUS.DATAUS = TRUNC(agora()) + 10)) tab
     WHERE ROWNUM=1
     ORDER BY ORDEM;
    
    INSERT INTO TT_SUP (CODFIL,FILCLI,CODCLI,FILEND,NUMEND,DATREG,MODULO,VERSAO,SITUAC,
                        FILRES,CODRES,FLGCOB,CODPRI,TIPSUP,TIPCWS,CODFUN,TIPREG,PERFIL,FILVEN,SEQVEN,DESSUP,DATPRO)
       (SELECT VEN.CODFIL,
               VEN.FILCLI,
               VEN.CODCLI,
               ENDE.CODFIL as FILEND,
               ENDE.NUMEND,
               AGORA() AS DATREG,
               0 AS MODULO,
               TO_CHAR('????') AS VERSAO,
               TO_CHAR('A') AS SITUAC,
               vFILRES AS FILRES,
               vCODRES AS CODRES,
               TO_CHAR('A') AS FLGCOB,
               vCODPRI AS CODPRI,
               0 AS TIPSUP,
               TO_CHAR('A') AS TIPCWS,
               0 AS CODFUN,
               TO_CHAR('I') AS TIPREG,
               pPerfil as PERFIL,
               ven.codfil as FILVEN,
               ven.sequen as SEQVEN,
               TO_CHAR('Documento: '|| COALESCE(VEN.NUMECF,'')||'-'||COALESCE(VEN.CODSER,'')||'/'||RTRIM(LTRIM(COALESCE(VEN.NUMNOT,''))) ||' - Telefonar ao cliente e verificar a satisfao') as DESSUP,
               add_day(trunc(agora()),vQTDDIA) as DATPRO
          FROM TT_VEN VEN INNER JOIN TT_CLI CLI ON VEN.FILCLI=CLI.FILCLI AND VEN.CODCLI=CLI.CODCLI
                          INNER JOIN TT_END ENDE ON CLI.FILCLI=ENDE.FILCLI AND CLI.CODCLI=ENDE.CODCLI
                                                AND ENDE.NUMEND=1  
          WHERE VEN.CODFIL = pFILVEN
            AND VEN.SEQUEN = pSEQVEN
        );
        
        UPDATE TT_CFG SET ULTSAC_FILUSU=vFILRES,
                          ULTSAC_CODUSU=vCODRES;
   
END IF;
RETURN null;
         
END;
$$ language 'plpgsql';




/*-- SEQ 0512 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SaldoConta (TR_CTA.FILCTA%TYPE,TR_CTA.SEQCTA%TYPE,TR_CTA.TIPCTA%TYPE,TR_CTA.DATLAN%TYPE,TR_CTA.FLGFLX%TYPE,TR_CTA.FILLAN%TYPE) CASCADE;

/*-- SEQ 0513 --*/
CREATE OR REPLACE FUNCTION SaldoConta (TR_CTA.FILCTA%TYPE,TR_CTA.SEQCTA%TYPE,TR_CTA.TIPCTA%TYPE,TR_CTA.DATLAN%TYPE,TR_CTA.FLGFLX%TYPE,TR_CTA.FILLAN%TYPE)
RETURNS TR_CTA.VSALDO%TYPE AS $$
DECLARE
pFilCta ALIAS FOR $1 ;
pSeqCta ALIAS FOR $2 ;
pTipCta ALIAS FOR $3 ;
pDatLan ALIAS FOR $4 ;
pFlgFlx ALIAS FOR $5 ;
pFilLan ALIAS FOR $6 ;
  nRetorno       TR_CTA.VSALDO%TYPE;
  nSaldoA        TR_CTA.VSALDO%TYPE;
  nSaldoR        TR_CTA.VSALDO%TYPE;
BEGIN
  nRetorno       := NULL;

  -- calcula a realizar
  IF (ISNOTNULL(pFlgFlx) = 'F')
  OR (pFlgFlx = 'A') THEN
    BEGIN
      IF (ISNOTNULL(pFilLan) = 'T') THEN  
        -- com filial de lancamento
        SELECT SUM(CTA.VSALDO) INTO nSaldoA
          FROM TR_CTA CTA
         WHERE CTA.FILCTA = pFilCta
           AND CTA.SEQCTA = pSeqCta
           AND CTA.TIPCTA = pTipCta
           AND CTA.FILLAN = pFilLan
           AND CTA.FLGFLX = 'A'
           AND (CTA.DATLAN, CTA.FILLAN) IN
               (SELECT MAX(RCTA.DATLAN), RCTA.FILLAN
                  FROM TR_CTA RCTA
                 WHERE RCTA.FILCTA = pFilCta
                   AND RCTA.SEQCTA = pSeqCta
                   AND RCTA.TIPCTA = pTipCta
                   AND RCTA.FILLAN = pFilLan
                   AND RCTA.FLGFLX = 'A'
                   AND RCTA.DATLAN <= pDatLan                   
                 GROUP BY RCTA.FILLAN);
      ELSE
        -- sem filial de lancamento
        SELECT SUM(CTA.VSALDO) INTO nSaldoA
          FROM TR_CTA CTA
         WHERE CTA.FILCTA = pFilCta
           AND CTA.SEQCTA = pSeqCta
           AND CTA.TIPCTA = pTipCta
           AND CTA.FLGFLX = 'A'
           AND (CTA.DATLAN, CTA.FILLAN) IN
               (SELECT MAX(RCTA.DATLAN), RCTA.FILLAN
                  FROM TR_CTA RCTA
                 WHERE RCTA.FILCTA = pFilCta
                   AND RCTA.SEQCTA = pSeqCta
                   AND RCTA.TIPCTA = pTipCta
                   AND RCTA.FLGFLX = 'A'
                   AND RCTA.DATLAN <= pDatLan                   
                 GROUP BY RCTA.FILLAN);
      END IF;
    EXCEPTION
            
      WHEN others THEN NULL;
          END;
  END IF;

  -- calcula realizado
  IF (ISNOTNULL(pFlgFlx) = 'F')
  OR (pFlgFlx = 'R') THEN
    BEGIN     
      IF (ISNOTNULL(pFilLan) = 'T') THEN  
        -- com filial de lancamento
        SELECT SUM(CTA.VSALDO) INTO nSaldoR
          FROM TR_CTA CTA
         WHERE CTA.FILCTA = pFilCta
           AND CTA.SEQCTA = pSeqCta
           AND CTA.TIPCTA = pTipCta
           AND CTA.FILLAN = pFilLan
           AND CTA.FLGFLX = 'R'
           AND (CTA.DATLAN, CTA.FILLAN) IN
               (SELECT MAX(RCTA.DATLAN), RCTA.FILLAN
                  FROM TR_CTA RCTA
                 WHERE RCTA.FILCTA = pFilCta
                   AND RCTA.SEQCTA = pSeqCta
                   AND RCTA.TIPCTA = pTipCta
                   AND RCTA.FILLAN = pFilLan
                   AND RCTA.FLGFLX = 'R'
                   AND RCTA.DATLAN <= pDatLan                   
                 GROUP BY RCTA.FILLAN);
      ELSE
        -- sem filial de lancamento
        SELECT SUM(CTA.VSALDO) INTO nSaldoR
          FROM TR_CTA CTA
         WHERE CTA.FILCTA = pFilCta
           AND CTA.SEQCTA = pSeqCta
           AND CTA.TIPCTA = pTipCta
           AND CTA.FLGFLX = 'R'
           AND (CTA.DATLAN, CTA.FILLAN) IN
               (SELECT MAX(RCTA.DATLAN), RCTA.FILLAN
                  FROM TR_CTA RCTA
                 WHERE RCTA.FILCTA = pFilCta
                   AND RCTA.SEQCTA = pSeqCta
                   AND RCTA.TIPCTA = pTipCta
                   AND RCTA.FLGFLX = 'R'
                   AND RCTA.DATLAN <= pDatLan                   
                 GROUP BY RCTA.FILLAN);
      END IF;
    EXCEPTION
            
      WHEN others THEN NULL;
          END;
  END IF;

  IF (ISNOTNULL(pFlgFlx) = 'F') THEN
     nRetorno := COALESCE(nSaldoA,0) + COALESCE(nSaldoR,0);
  ELSIF pFlgFlx = 'A' THEN
     nRetorno := nSaldoA;
  ELSIF pFlgFlx = 'R' THEN
     nRetorno := nSaldoR;
  END IF;

  RETURN COALESCE(nRetorno,0);
END;
$$ language 'plpgsql';




/*-- SEQ 0514 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SALDOKIT (Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_GRA.FILMAT%TYPE,TD_MUL.CODTAB%TYPE) CASCADE;

/*-- SEQ 0515 --*/
CREATE OR REPLACE FUNCTION SALDOKIT (Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_GRA.FILMAT%TYPE,TD_MUL.CODTAB%TYPE)
RETURNS Numeric AS $$
DECLARE
p_DATREF ALIAS FOR $1 ;
p_FILMAT ALIAS FOR $2 ;
p_CODMAT ALIAS FOR $3 ;
p_CODCOR ALIAS FOR $4 ;
p_CODTAM ALIAS FOR $5 ;
p_CODFIL ALIAS FOR $6 ;
p_CODMUL ALIAS FOR $7 ;
-- Objetivo:
-- 1) Obter o saldo de um Kit de produto

/* Este Saldo e virtual, mesmo se estiver negativo o cliente pode vender os itens que
   compoe o kit individualmente, o que se deseja obter aqui, e quantos kits eu consigo
   montar, baseando-se nos itens, por isso eh feito o MIN.*/

  SALDO Numeric;
BEGIN
  SELECT 
    MIN(CASE WHEN trunc(p_DATREF)=TRUNC(AGORA())THEN 
          SAL.QTDEST
        ELSE 
          SaldoDaFilial(p_DATREF, KIT.FILITE, KIT.CODITE, KIT.CORITE,
                        KIT.TAMITE, p_CODFIL, p_CODMUL) END / KIT.QTDITE
       ) INTO SALDO
  FROM TT_KIT KIT 
  INNER JOIN TT_SAL SAL ON SAL.FILMAT = KIT.FILITE AND
                           SAL.CODMAT = KIT.CODITE AND
                           SAL.CODCOR = KIT.CORITE AND
                           SAL.CODTAM = KIT.TAMITE
  WHERE KIT.FILMAT = p_FILMAT
    AND KIT.CODMAT = p_CODMAT
    AND KIT.CODCOR = p_CODCOR
    AND KIT.CODTAM = p_CODTAM
    AND SAL.CODFIL = p_CODFIL
    AND SAL.CODMUL = p_CODMUL;
  
  IF SALDO < 0 THEN
    SALDO := 0;
   END IF;
  
RETURN COALESCE(SALDO,0);
END;
$$ language 'plpgsql';


/*-- SEQ 0516 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SALDOKIT (Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_GRA.FILMAT%TYPE) CASCADE;

/*-- SEQ 0517 --*/
CREATE OR REPLACE FUNCTION SALDOKIT (Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               TT_GRA.FILMAT%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN SALDOKIT($1,$2,$3,$4,$5,$6,0);
END;
$$ language 'plpgsql';


/*-- SEQ 0518 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SaldoEmTransito (TT_SAL.FILMAT%TYPE,TT_SAL.CODMAT%TYPE,TT_SAL.CODCOR%TYPE,TT_SAL.CODTAM%TYPE,TT_SAL.CODMUL%TYPE,TT_SAL.CODFIL%TYPE,TT_SAL.CAL_CM%TYPE) CASCADE;

/*-- SEQ 0519 --*/
CREATE OR REPLACE FUNCTION SaldoEmTransito (TT_SAL.FILMAT%TYPE,TT_SAL.CODMAT%TYPE,TT_SAL.CODCOR%TYPE,TT_SAL.CODTAM%TYPE,TT_SAL.CODMUL%TYPE,TT_SAL.CODFIL%TYPE,TT_SAL.CAL_CM%TYPE)
RETURNS Numeric AS $$
DECLARE
pFilMat ALIAS FOR $1 ;
pCodMat ALIAS FOR $2 ;
pCodCor ALIAS FOR $3 ;
pCodTam ALIAS FOR $4 ;
pCodMul ALIAS FOR $5 ;
pCodFil ALIAS FOR $6 ;
pDatRef ALIAS FOR $7 ;
  wk_Retorno Numeric;
BEGIN
    IF (pDatRef is null) OR TRUNC(pDatRef) = TRUNC( agora() ) then
      SELECT SUM(IVE.QTDMOV) INTO wk_Retorno
        FROM TT_TRA TRA INNER JOIN TT_IVE IVE ON IVE.CODFIL = TRA.FILIVE
                                             AND IVE.SEQUEN = TRA.SEQIVE 
					     AND IVE.NUMITE = TRA.NUMIVE 
       WHERE TRA.FILMAT = pFilMat
         AND TRA.CODMAT = pCodMat
         AND TRA.CODCOR = pCodCor
         AND TRA.CODTAM = pCodTam
         AND (IVE.CODMUL = pCodMul or pCodMul is NULL)
         AND (TRA.FILIVE = pCodFil or pCodFil is NULL)
         AND TRA.NUMICO IS NULL
         AND IVE.SITMOV <> 'C';
    ELSE
      SELECT SUM(IVE.QTDMOV) INTO wk_Retorno
        FROM TT_TRA TRA INNER JOIN TT_IVE IVE ON IVE.CODFIL = TRA.FILIVE 
	                                     AND IVE.SEQUEN = TRA.SEQIVE 
					     AND IVE.NUMITE = TRA.NUMIVE
                         LEFT JOIN TT_ICO ICO ON ICO.CODFIL = TRA.FILICO 
			                     AND ICO.SEQUEN = TRA.SEQICO 
					     AND ICO.NUMITE = TRA.NUMICO
       WHERE TRA.FILMAT = pFilMat
         AND TRA.CODMAT = pCodMat
         AND TRA.CODCOR = pCodCor
         AND TRA.CODTAM = pCodTam
         AND (IVE.CODMUL = pCodMul or pCodMul is NULL)
         AND (TRA.FILIVE = pCodFil or pCodFil is NULL)
         AND TRUNC(IVE.VEN_DATHOR) <= TRUNC(pDatRef)
         AND ( TRUNC(ICO.COM_DATOPE) > TRUNC(pDatRef) OR TRA.NUMICO IS NULL)
         AND IVE.SITMOV <> 'C';
    END IF;

  RETURN COALESCE(wk_Retorno,0);

END;
$$ language 'plpgsql';


/*-- SEQ 0520 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SaldoEmTransito (TT_SAL.FILMAT%TYPE,TT_SAL.CODMAT%TYPE,TT_SAL.CODCOR%TYPE,TT_SAL.CODTAM%TYPE,TT_SAL.CODMUL%TYPE,TT_SAL.CODFIL%TYPE) CASCADE;

/*-- SEQ 0521 --*/
CREATE OR REPLACE FUNCTION SaldoEmTransito (TT_SAL.FILMAT%TYPE,
                               TT_SAL.CODMAT%TYPE,
                               TT_SAL.CODCOR%TYPE,
                               TT_SAL.CODTAM%TYPE,
                               TT_SAL.CODMUL%TYPE,
                               TT_SAL.CODFIL%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN SaldoEmTransito($1,$2,$3,$4,$5,$6,null);
END;
$$ language 'plpgsql';


/*-- SEQ 0522 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SaldoEmTransito (TT_SAL.FILMAT%TYPE,TT_SAL.CODMAT%TYPE,TT_SAL.CODCOR%TYPE,TT_SAL.CODTAM%TYPE,TT_SAL.CODMUL%TYPE) CASCADE;

/*-- SEQ 0523 --*/
CREATE OR REPLACE FUNCTION SaldoEmTransito (TT_SAL.FILMAT%TYPE,
                               TT_SAL.CODMAT%TYPE,
                               TT_SAL.CODCOR%TYPE,
                               TT_SAL.CODTAM%TYPE,
                               TT_SAL.CODMUL%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN SaldoEmTransito($1,$2,$3,$4,$5,null,null);
END;
$$ language 'plpgsql';


/*-- SEQ 0524 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SaldoEmTransito (TT_SAL.FILMAT%TYPE,TT_SAL.CODMAT%TYPE,TT_SAL.CODCOR%TYPE,TT_SAL.CODTAM%TYPE) CASCADE;

/*-- SEQ 0525 --*/
CREATE OR REPLACE FUNCTION SaldoEmTransito (TT_SAL.FILMAT%TYPE,
                               TT_SAL.CODMAT%TYPE,
                               TT_SAL.CODCOR%TYPE,
                               TT_SAL.CODTAM%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN SaldoEmTransito($1,$2,$3,$4,null,null,null);
END;
$$ language 'plpgsql';


/*-- SEQ 0526 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SaldoVinculoFuturo (TT_IVE.CODFIL%TYPE,TT_VEN.CODNAT%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE,TT_IVE.CODMUL%TYPE,TT_VEN.DATHOR%TYPE,TT_IVE.LANEST%TYPE) CASCADE;

/*-- SEQ 0527 --*/
CREATE OR REPLACE FUNCTION SaldoVinculoFuturo (TT_IVE.CODFIL%TYPE,TT_VEN.CODNAT%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE,TT_IVE.CODMUL%TYPE,TT_VEN.DATHOR%TYPE,TT_IVE.LANEST%TYPE)
RETURNS Numeric AS $$
DECLARE
pCodfil ALIAS FOR $1 ;
pCodNat ALIAS FOR $2 ;
pFilMat ALIAS FOR $3 ;
pCodMat ALIAS FOR $4 ;
pCodCor ALIAS FOR $5 ;
pCodTam ALIAS FOR $6 ;
pCodMul ALIAS FOR $7 ;
pDatMov ALIAS FOR $8 ;
pReserv ALIAS FOR $9 ;
  wk_Retorno Numeric;
BEGIN
  IF pDatMov is NULL THEN
     SELECT SUM(COALESCE(QTDPEN,0)) - SUM(COALESCE(QTDFUT,0)) INTO wk_Retorno
     FROM (SELECT /*+INDEX(IVE,I_LC_IVE_GRA_VINCUL)*/
                  IVE.QTDMOV, IVE.QTDFUT,
                  CalculaQTDPendente(IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE,IVE.QTDMOV) AS QTDPEN
           FROM TT_CFG CFG,
                TT_IVE IVE INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL
                                                AND VEN.SEQUEN = IVE.SEQUEN
           WHERE (VEN.CODNAT = pCodNat OR pCodNat IS NULL)
             AND VEN.VINCUL = 'T'
             AND VEN.DATHOR     > COALESCE( CFG.IGNORA_VINCULO, TO_DATE('01/01/1980','DD/MM/YYYY') ) 
             AND IVE.VEN_DATHOR > COALESCE( CFG.IGNORA_VINCULO, TO_DATE('01/01/1980','DD/MM/YYYY') ) 
             AND VEN.FLGEST <> 'C'
             AND IVE.CODFIL = pCodFil
             AND IVE.FILMAT = pFilMat
             AND IVE.CODMAT = pCodMat
             AND IVE.CODCOR = pCodCor
             AND IVE.CODTAM = pCodTam
             AND IVE.CODMUL = pCodMul
             AND IVE.SITMOV <> 'C'
             AND IVE.VINCUL IN ('A','C') ) TAB;
 ELSE
     SELECT SUM( QTDMOV - COALESCE(RETORNO,0) ) - SUM(COALESCE(QTDFUT,0)) INTO wk_Retorno
     FROM (SELECT IVE.QTDMOV, IVE.QTDFUT,
                  (select SUM( ABS( VIN.QTDMOV + COALESCE( (SELECT sum(DEV.QTDMOV)
                                                            FROM TT_IVE DEV 
                                                            WHERE DEV.FILORI = VIN.CODFIL 
                                                              AND DEV.NUMORI = VIN.SEQUEN 
                                	  	                      AND DEV.ITEORI = VIN.NUMITE 
                                                              AND DEV.LANEST IN ('R','C')
                                                              AND DEV.SITMOV <> 'C'
                                                              AND DEV.VEN_DATHOR < ADD_DAY(trunc(pDatMov),1 )),0) 
                                                              ) )
                   from TT_IVE VIN
                   WHERE VIN.FILORI = IVE.CODFIL
                     AND VIN.NUMORI = IVE.SEQUEN
                     AND VIN.ITEORI = IVE.NUMITE
                     AND VIN.SITMOV <> 'C'
                     AND VIN.LANEST IN ('R','C')
                     AND VIN.VEN_DATHOR < ADD_DAY(trunc(pDatMov),1 )) AS RETORNO
           FROM TT_CFG CFG,
                TT_IVE IVE INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL
                                                AND VEN.SEQUEN = IVE.SEQUEN
           WHERE (VEN.CODNAT = pCodNat OR pCodNat IS NULL)
             AND VEN.VINCUL = 'T'
             AND IVE.FILORI IS NULL
             AND IVE.CODFIL = pCodFil
             AND IVE.FILMAT = pFilMat
             AND IVE.CODMAT = pCodMat
             AND IVE.CODCOR = pCodCor
             AND IVE.CODTAM = pCodTam
             AND (IVE.CODMUL = pCodMul or pCodMul is null)
             AND IVE.SITMOV <> 'C'
             AND IVE.VINCUL IN ('A','C')
             AND VEN.DATHOR     > COALESCE( CFG.IGNORA_VINCULO, TO_DATE('01/01/1980','DD/MM/YYYY') )  
             AND IVE.VEN_DATHOR > COALESCE( CFG.IGNORA_VINCULO, TO_DATE('01/01/1980','DD/MM/YYYY') ) 
             AND IVE.VEN_DATHOR < ADD_DAY(trunc(pDatMov),1 ) 
             AND (IVE.LANEST = pReserv or pReserv is null) ) TAB;
  END IF;

  IF wk_Retorno < 0 THEN
     wk_Retorno:=0;
  END IF;
  RETURN COALESCE(wk_Retorno,0);

END;
$$ language 'plpgsql';


/*-- SEQ 0528 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SaldoVinculoFuturo (TT_IVE.CODFIL%TYPE,TT_VEN.CODNAT%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE,TT_IVE.CODMUL%TYPE,TT_VEN.DATHOR%TYPE) CASCADE;

/*-- SEQ 0529 --*/
CREATE OR REPLACE FUNCTION SaldoVinculoFuturo (TT_IVE.CODFIL%TYPE,
                               TT_VEN.CODNAT%TYPE,
                               TT_IVE.FILMAT%TYPE,
                               TT_IVE.CODMAT%TYPE,
                               TT_IVE.CODCOR%TYPE,
                               TT_IVE.CODTAM%TYPE,
                               TT_IVE.CODMUL%TYPE,
                               TT_VEN.DATHOR%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN SaldoVinculoFuturo($1,$2,$3,$4,$5,$6,$7,$8,null);
END;
$$ language 'plpgsql';


/*-- SEQ 0530 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SaldoVinculoFuturo (TT_IVE.CODFIL%TYPE,TT_VEN.CODNAT%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE,TT_IVE.CODMUL%TYPE) CASCADE;

/*-- SEQ 0531 --*/
CREATE OR REPLACE FUNCTION SaldoVinculoFuturo (TT_IVE.CODFIL%TYPE,
                               TT_VEN.CODNAT%TYPE,
                               TT_IVE.FILMAT%TYPE,
                               TT_IVE.CODMAT%TYPE,
                               TT_IVE.CODCOR%TYPE,
                               TT_IVE.CODTAM%TYPE,
                               TT_IVE.CODMUL%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN SaldoVinculoFuturo($1,$2,$3,$4,$5,$6,$7,null,null);
END;
$$ language 'plpgsql';


/*-- SEQ 0532 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SaldoVinculoFuturo (TT_IVE.CODFIL%TYPE,TT_VEN.CODNAT%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE) CASCADE;

/*-- SEQ 0533 --*/
CREATE OR REPLACE FUNCTION SaldoVinculoFuturo (TT_IVE.CODFIL%TYPE,
                               TT_VEN.CODNAT%TYPE,
                               TT_IVE.FILMAT%TYPE,
                               TT_IVE.CODMAT%TYPE,
                               TT_IVE.CODCOR%TYPE,
                               TT_IVE.CODTAM%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN SaldoVinculoFuturo($1,$2,$3,$4,$5,$6,null,null,null);
END;
$$ language 'plpgsql';


/*-- SEQ 0534 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CreditScoreCadastro (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE) CASCADE;

/*-- SEQ 0535 --*/
CREATE OR REPLACE FUNCTION CreditScoreCadastro (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFilial ALIAS FOR $1 ;
pCodigo ALIAS FOR $2 ;
  wk_retorno VARCHAR(500);
BEGIN
   SELECT COALESCE(LINHA1,'')||
          COALESCE(LINHA2,'')||
          COALESCE(LINHA3,'')||
          COALESCE(LINHA4,'')||
          COALESCE(LINHA5,'')||
          COALESCE(LINHA6,'')||
          COALESCE(LINHA7,'')||
          COALESCE(LINHA8,'')||
          COALESCE(LINHA9,'')||
          COALESCE(LINHA10,'')||
          COALESCE(LINHA11,'')||
          COALESCE(LINHA12,'')||
          COALESCE(LINHA13,'')||
          COALESCE(LINHA14,'') AS TEXTO INTO wk_retorno
   FROM (
   SELECT CASE WHEN CLI.ESTCIV = 2 AND COALESCE(SPC.SALBAC,0) = 0 THEN 'Cliente  casado e no informou renda do cnjuge'||CHR(10)
          END AS LINHA1,
          CASE WHEN CLI.FLGTIP = 0 AND TRIM(CLI.NUMDOC) IS NULL THEN 'No informou CPF'||CHR(10)
          END AS LINHA2,
          CASE WHEN CLI.ESTCIV = 2 AND COALESCE(SPC.CASMES,0) = 0 THEN 'Cliente  casado e no informou h quanto tempo'||CHR(10)
          END AS LINHA3,
          CASE WHEN (SELECT MIN(TRIM(RES.NUMFON))
                       FROM TT_END RES
                      WHERE RES.FILCLI = CLI.FILCLI
                        AND RES.CODCLI = CLI.CODCLI
                        AND RES.NUMFON IS NOT NULL) IS NULL THEN 'No informou telefone'||CHR(10)
          END AS LINHA4,
          CASE WHEN COALESCE(SPC.MORMES,0) = 0 THEN 'No informou tempo que reside no endereo'||CHR(10)
          END AS LINHA5,
          CASE WHEN TRIM(SPC.ENDERE) IS NULL THEN 'No informou endereo do trabalho'||CHR(10)
          END AS LINHA6,
          CASE WHEN TRIM(SPC.NUMTEL) IS NULL THEN 'No informou telefone do trabalho'||CHR(10)
          END AS LINHA7,
          CASE WHEN COALESCE(SPC.ATUMES,0) = 0 THEN 'No informou a quanto tempo est neste trabalho'||CHR(10)
          END AS LINHA8,
          CASE WHEN CLI.ESTCIV = 2 AND TRIM(SPC.FIRCON) IS NULL THEN 'Cliente  casado e no informou trabalho do conjuge'||CHR(10)
          END AS LINHA9,          
          CASE WHEN (SELECT MIN(DCON.CLACON)
                       FROM TT_CON CON INNER JOIN TD_CON DCON ON CON.CODREL = DCON.CODTAB
                      WHERE CON.FILCLI = CLI.FILCLI
                        AND CON.CODCLI = CLI.CODCLI
                        AND DCON.CLACON = 'P') IS NULL THEN 'No informou referncias pessoais'||CHR(10)
          END AS LINHA10,
          CASE WHEN (SELECT MIN(DCON.CLACON)
                       FROM TT_CON CON INNER JOIN TD_CON DCON ON CON.CODREL = DCON.CODTAB
                      WHERE CON.FILCLI = CLI.FILCLI
                        AND CON.CODCLI = CLI.CODCLI
                        AND DCON.CLACON = 'F') IS NULL THEN 'No informou referncias familiares'||CHR(10)
          END AS LINHA11,
          CASE WHEN SPC.TEM_TC = 'F' THEN 'No tem talo de cheques'||CHR(10)
          END AS LINHA12,
          CASE WHEN SPC.TEM_CC = 'F' THEN 'No tem carto de crdito'||CHR(10)
          END AS LINHA13,          
          CASE WHEN SPC.TIPRES = 5 THEN 'No informou tipo de residncia'||CHR(10)
          END AS LINHA14
     FROM TT_CLI CLI LEFT OUTER JOIN TT_SPC SPC ON CLI.FILCLI = SPC.FILCLI AND CLI.CODCLI = SPC.CODCLI
    WHERE CLI.FILCLI = pFilial
      AND CLI.CODCLI = pCodigo) CREDITO;
      
    RETURN wk_retorno;
END;
$$ language 'plpgsql';




/*-- SEQ 0536 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CargaCreditScore () CASCADE;

/*-- SEQ 0537 --*/
CREATE OR REPLACE FUNCTION CargaCreditScore ()
RETURNS VARCHAR AS $$
DECLARE

BEGIN
  DELETE FROM TT_CRE;
  DELETE FROM TD_CRE;

  INSERT INTO TD_CRE (COLPAI, DESCRI, DESPON, TIPDAD, COLUNA)
    (SELECT CAST(NULL AS CHARACTER), 'Cliente'                          , CAST(NULL AS CHARACTER)         , 'D', 'DADCLI' FROM DUAL UNION ALL
     SELECT 'DADCLI'               , 'Informou CPF/CNPJ?'               , NULL                            , 'D', 'NUMDOC' FROM DUAL UNION ALL
     SELECT 'DADCLI'               , 'Idade'                            , NULL                            , 'F', 'DATNAS' FROM DUAL UNION ALL
     SELECT 'DADCLI'               , 'Sexo'                             , NULL                            , 'D', 'CODSEX' FROM DUAL UNION ALL
     SELECT 'DADCLI'               , 'Dependentes'                      , NULL                            , 'V', 'CODDEP' FROM DUAL UNION ALL
     SELECT 'DADCLI'               , 'Tempo de casado (meses)'                  , NULL                            , 'F', 'CASADO' FROM DUAL UNION ALL
     SELECT 'DADCLI'               , 'Demais estados civis'             , NULL                            , 'D', 'ESTCIV' FROM DUAL UNION ALL
     SELECT NULL                   , 'Residncia'                       , NULL                            , 'D', 'DADRES' FROM DUAL UNION ALL
     SELECT 'DADRES'               , 'Localizao'                      , NULL                            , 'F', 'CODCEP' FROM DUAL UNION ALL
     SELECT 'DADRES'               , 'Telefone'                         , NULL                            , 'D', 'NUMFON' FROM DUAL UNION ALL
     SELECT 'DADRES'               , 'Residncia'                       , NULL                            , 'D', 'TIPRES' FROM DUAL UNION ALL                                                                                                        
     SELECT 'DADRES'               , 'Tempo de residncia (meses)'              , NULL                            , 'F', 'TEMRES' FROM DUAL UNION ALL                                                                                                        
     SELECT NULL                   , 'Dados profissionais'              , NULL                            , 'D', 'DADPRO' FROM DUAL UNION ALL                                                                                                        
     SELECT 'DADPRO'               , 'Informou endereo de trabalho?'   , NULL                            , 'D', 'ENDTRA' FROM DUAL UNION ALL                                                                                                        
     SELECT 'DADPRO'               , 'Informou telefone de trabalho?'   , NULL                            , 'D', 'TELTRA' FROM DUAL UNION ALL                                                                                                        
     SELECT 'DADPRO'               , 'Salrio do Cargo'                            , NULL                            , 'F', 'CARGO'  FROM DUAL UNION ALL
     SELECT 'DADPRO'               , 'Meses de servio'                 , NULL                            , 'F', 'TEMSER' FROM DUAL UNION ALL                                                                                                        
     SELECT NULL                   , 'Dados do cnjuge'                 , NULL                            , 'D', 'DADCON' FROM DUAL UNION ALL
     SELECT 'DADCON'               , 'Informou endereo de trabalho?'   , NULL                            , 'D', 'INFTRA' FROM DUAL UNION ALL                                                                                                        
     SELECT 'DADCON'               , 'Salrio do Cargo'                            , '% Agregado a renda'            , 'F', 'CARCON' FROM DUAL UNION ALL
     SELECT NULL                   , 'Outros'                           , NULL                            , 'D', 'OUTROS' FROM DUAL UNION ALL                                                                                                        
     SELECT 'OUTROS'               , 'Referncias pessoais'             , NULL                            , 'D', 'REFPES' FROM DUAL UNION ALL                                                                                                        
     SELECT 'OUTROS'               , 'Tem talo de cheques?'            , NULL                            , 'D', 'TEMTAL' FROM DUAL UNION ALL
     SELECT 'OUTROS'               , 'Tem carto de crdito?'           , NULL                            , 'D', 'TEMCRE' FROM DUAL UNION ALL
     SELECT 'OUTROS'               , 'Tem carto da loja?'              , NULL                            , 'D', 'CARLOJ' FROM DUAL UNION ALL
     SELECT 'OUTROS'               , 'Tem automvel?'                   , NULL                            , 'D', 'TEMAUT' FROM DUAL UNION ALL
     SELECT 'OUTROS'               , 'Feita consulta no SERASA/SPC?'    , NULL                            , 'D', 'CONSPC' FROM DUAL UNION ALL
     SELECT NULL                   , 'Histrico compras na empresa'     , NULL                            , 'D', 'HISEMP' FROM DUAL UNION ALL
     SELECT 'HISEMP'               , 'MDA - Mdia de Dias em Atraso'    , NULL                            , 'F', 'VLRMDA' FROM DUAL UNION ALL
     SELECT 'HISEMP'               , 'Meses a considerar no MDA'        , 'Meses'                         , 'V', 'MESMDA' FROM DUAL UNION ALL
     SELECT 'HISEMP'               , 'Limite mximo de parcela'         , '% da parcela'                  , 'V', 'MAXPAR' FROM DUAL UNION ALL
     SELECT 'HISEMP'               , 'Limite mximo'                    , 'Valor'                         , 'V', 'LIMMAX' FROM DUAL UNION ALL
     SELECT 'HISEMP'               , 'Limite mximo na 1 compra'       , 'Valor'                         , 'V', 'MAXPRI' FROM DUAL UNION ALL
     SELECT 'HISEMP'               , 'Limite mximo se atraso'          , 'Valor'                         , 'V', 'LIMATR' FROM DUAL UNION ALL
     SELECT 'HISEMP'               , 'Sem limite se atraso maior que...', 'Dias'                          , 'V', 'SEMLIM' FROM DUAL UNION ALL
     SELECT 'HISEMP'               , 'Parcelas pagas do perodo'        , 'Multiplicar aos pontos do MDA' , 'F', 'PARPAG' FROM DUAL UNION ALL
     SELECT 'HISEMP'               , 'Limite de acordo com a pontuao' , '% sobre a renda'               , 'F', 'LIMITE' FROM DUAL);                                                                                                                

  INSERT INTO TT_CRE (COLUNA, DESCRI, CODIGO, FAIINI, FAIFIM, PONTOS, CODFIL, TIPDAD)                                                                                                                                                                
    (SELECT 'NUMDOC', 'Sim'                                    ,  'S', CAST(NULL AS INTEGER), CAST(NULL AS INTEGER),      1, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'NUMDOC', 'No'                                    ,  'N', NULL                 , NULL                 ,     -1, CODLOJ, 'D' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'DATNAS',  NULL                                    , NULL, NULL                 ,   17                 ,     -3, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'DATNAS',  NULL                                    , NULL,   18                 ,   20                 ,     -1, CODLOJ, 'F' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'DATNAS',  NULL                                    , NULL,   21                 ,   25                 ,      0, CODLOJ, 'F' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'DATNAS',  NULL                                    , NULL,   26                 ,   35                 ,      1, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'DATNAS',  NULL                                    , NULL,   36                 ,   50                 ,      2, CODLOJ, 'F' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'DATNAS',  NULL                                    , NULL,   51                 ,   60                 ,      3, CODLOJ, 'F' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'DATNAS',  NULL                                    , NULL,   61                 ,   70                 ,      1, CODLOJ, 'F' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'DATNAS',  NULL                                    , NULL,   71                 , NULL                 ,     -3, CODLOJ, 'F' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'CODSEX', 'Masculino'                              ,  '1', NULL                 , NULL                 ,     -1, CODLOJ, 'D' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'CODSEX', 'Feminino'                               ,  '2', NULL                 , NULL                 ,      0, CODLOJ, 'D' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'CODDEP', 'Para cada dependente'                   , NULL, NULL                 , NULL                 ,     -2, CODLOJ, 'V' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'CASADO', NULL                                     , NULL, NULL                 ,    2                 ,      1, CODLOJ, 'F' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'CASADO', NULL                                     , NULL,    3                 ,    5                 ,      2, CODLOJ, 'F' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'CASADO', NULL                                     , NULL,    6                 ,   10                 ,      3, CODLOJ, 'F' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'CASADO', NULL                                     , NULL,   10                 , NULL                 ,      4, CODLOJ, 'F' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'ESTCIV', 'Solteiro'                               ,  '1', NULL                 , NULL                 ,      2, CODLOJ, 'D' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'ESTCIV', 'Viuvo'                                  ,  '3', NULL                 , NULL                 ,      3, CODLOJ, 'D' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'ESTCIV', 'Divorciando'                            ,  '4', NULL                 , NULL                 ,      1, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'ESTCIV', 'Amasiado'                               ,  '5', NULL                 , NULL                 ,      2, CODLOJ, 'D' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'ESTCIV', 'Separado'                               ,  '6', NULL                 , NULL                 ,      1, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'CODCEP', 'Obs: Incluir bairros, regies e cidades', NULL,    0                 ,    0                 ,      0, CODLOJ, 'F' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'NUMFON', 'Fixo na residncia'                     ,  '1', NULL                 , NULL                 ,      1, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'NUMFON', 'Para recado'                            ,  '2', NULL                 , NULL                 ,      0, CODLOJ, 'D' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'NUMFON', 'No tem'                                ,  '3', NULL                 , NULL                 ,     -2, CODLOJ, 'D' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'NUMFON', 'Celular'                                ,  '4', NULL                 , NULL                 ,      1, CODLOJ, 'D' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'TIPRES', 'Alugada'                                ,  '0', NULL                 , NULL                 ,     -1, CODLOJ, 'D' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'TIPRES', 'Prpria financiada'                     ,  '1', NULL                 , NULL                 ,      1, CODLOJ, 'D' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'TIPRES', 'Prpria quitada'                        ,  '2', NULL                 , NULL                 ,      2, CODLOJ, 'D' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'TIPRES', 'Mora com parentes, amigos'              ,  '3', NULL                 , NULL                 ,      1, CODLOJ, 'D' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'TIPRES', 'Mora no trabalho'                       ,  '4', NULL                 , NULL                 ,      1, CODLOJ, 'D' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'TIPRES', 'No informada'                          ,  '5', NULL                 , NULL                 ,     -1, CODLOJ, 'D' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'TEMRES', NULL                                     , NULL, NULL                 ,    0                 ,     -3, CODLOJ, 'F' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'TEMRES', NULL                                     , NULL,    1                 ,    1                 ,      0, CODLOJ, 'F' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'TEMRES', NULL                                     , NULL,    2                 ,    2                 ,      1, CODLOJ, 'F' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'TEMRES', NULL                                     , NULL,    3                 ,    5                 ,      2, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'TEMRES', NULL                                     , NULL,    5                 , NULL                 ,      3, CODLOJ, 'F' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'ENDTRA', 'Sim'                                    ,  'S', NULL                 , NULL                 ,      1, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'ENDTRA', 'No'                                    ,  'N', NULL                 , NULL                 ,      0, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'CARGO',  NULL                                    , NULL, NULL                 ,   250                 ,      1, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'CARGO',  NULL                                    , NULL,   250                ,   500                 ,      2, CODLOJ, 'F' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'CARGO',  NULL                                    , NULL,   500                ,  1000                 ,      5, CODLOJ, 'F' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'CARGO',  NULL                                    , NULL,  1000                , NULL                  ,     10, CODLOJ, 'F' FROM TT_IDF UNION ALL                                                                                       
     SELECT 'TEMSER', NULL                                     , NULL, NULL                 ,    5                 ,     -5, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'TEMSER', NULL                                     , NULL,    6                 ,   12                 ,     -2, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'TEMSER', NULL                                     , NULL,   13                 ,   23                 ,      0, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'TEMSER', NULL                                     , NULL,   24                 ,   35                 ,      1, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'TEMSER', NULL                                     , NULL,   36                 ,   47                 ,      2, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'TEMSER', NULL                                     , NULL,   48                 ,   59                 ,      3, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'TEMSER', NULL                                     , NULL,   69                 , NULL                 ,      4, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'INFTRA', 'Sim'                                    ,  'S', NULL                 , NULL                 ,      1, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'INFTRA', 'No'                                    ,  'N', NULL                 , NULL                 ,      0, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'CARCON', 'Obs: % agregado a renda'                , NULL, NULL                 ,    3                 ,     10, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'CARCON', 'Obs: o que  a faixa?'                  , NULL,    4                 ,    9                 ,     30, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'CARCON', NULL                                     , NULL,   10                 , NULL                 ,     50, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'REFPES', 'Parente'                                ,  '1', NULL                 , NULL                 ,      2, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'REFPES', 'Amigo'                                  ,  '2', NULL                 , NULL                 ,      1, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'REFPES', 'Colega de trabalho'                     ,  '3', NULL                 , NULL                 ,      0, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'REFPES', 'Sem referncia'                         ,  '4', NULL                 , NULL                 ,     -3, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'TEMTAL', 'Especial'                               ,  '1', NULL                 , NULL                 ,      2, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'TEMTAL', 'Normal'                                 ,  '2', NULL                 , NULL                 ,      4, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'TEMTAL', 'No tem'                                ,  '3', NULL                 , NULL                 ,      0, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'TEMCRE', 'Sim'                                    ,  'S', NULL                 , NULL                 ,      3, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'TEMCRE', 'No'                                    ,  'N', NULL                 , NULL                 ,      0, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'CARLOJ', 'Sim'                                    ,  'S', NULL                 , NULL                 ,      1, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'CARLOJ', 'No'                                    ,  'N', NULL                 , NULL                 ,      0, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'TEMAUT', 'Sim'                                    ,  'S', NULL                 , NULL                 ,      2, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'TEMAUT', 'No'                                    ,  'N', NULL                 , NULL                 ,      0, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'TELTRA', 'Sim'                                    ,  'S', NULL                 , NULL                 ,      1, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'TELTRA', 'No'                                    ,  'N', NULL                 , NULL                 ,      0, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'CONSPC', 'Sim'                                    ,  'S', NULL                 , NULL                 ,      0, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'CONSPC', 'No'                                    ,  'N', NULL                 , NULL                 ,      0, CODLOJ, 'D' FROM TT_IDF UNION ALL
     SELECT 'VLRMDA', NULL                                     , NULL, NULL                 ,    9                 ,      3, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'VLRMDA', NULL                                     , NULL,   11                 ,   15                 ,      2, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'VLRMDA', NULL                                     , NULL,   16                 ,   25                 ,      1, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'VLRMDA', NULL                                     , NULL,   26                 ,   35                 ,     -1, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'VLRMDA', NULL                                     , NULL,   36                 ,   45                 ,     -2, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'VLRMDA', NULL                                     , NULL,   46                 , NULL                 ,    -32, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'MESMDA', NULL                                     , NULL, NULL                 , NULL                 ,     24, CODLOJ, 'V' FROM TT_IDF UNION ALL
     SELECT 'MAXPAR', NULL                                     , NULL, NULL                 , NULL                 ,     30, CODLOJ, 'V' FROM TT_IDF UNION ALL
     SELECT 'LIMMAX', NULL                                     , NULL, NULL                 , NULL                 , 999999, CODLOJ, 'V' FROM TT_IDF UNION ALL
     SELECT 'MAXPRI', NULL                                     , NULL, NULL                 , NULL                 ,   1500, CODLOJ, 'V' FROM TT_IDF UNION ALL
     SELECT 'LIMATR', NULL                                     , NULL, NULL                 , NULL                 ,   1500, CODLOJ, 'V' FROM TT_IDF UNION ALL
     SELECT 'SEMLIM', NULL                                     , NULL, NULL                 , NULL                 ,     30, CODLOJ, 'V' FROM TT_IDF UNION ALL
     SELECT 'PARPAG', NULL                                     , NULL, NULL                 ,    3                 ,      1, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'PARPAG', NULL                                     , NULL,    4                 ,    6                 ,      2, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'PARPAG', NULL                                     , NULL,    7                 ,  126                 ,      3, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'PARPAG', NULL                                     , NULL,   12                 , NULL                 ,      4, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'LIMITE', NULL                                     , NULL, NULL                 ,    5                 ,      0, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'LIMITE', NULL                                     , NULL,    6                 ,    7                 ,     50, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'LIMITE', NULL                                     , NULL,    8                 ,    9                 ,     60, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'LIMITE', NULL                                     , NULL,   10                 ,   11                 ,     70, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'LIMITE', NULL                                     , NULL,   12                 ,   13                 ,     80, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'LIMITE', NULL                                     , NULL,   14                 ,   15                 ,     90, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'LIMITE', NULL                                     , NULL,   16                 ,   17                 ,    100, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'LIMITE', NULL                                     , NULL,   18                 ,   19                 ,    110, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'LIMITE', NULL                                     , NULL,   20                 ,   21                 ,    120, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'LIMITE', NULL                                     , NULL,   22                 ,   23                 ,    130, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'LIMITE', NULL                                     , NULL,   24                 ,   25                 ,    140, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'LIMITE', NULL                                     , NULL,   26                 ,   27                 ,    150, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'LIMITE', NULL                                     , NULL,   28                 ,   29                 ,    160, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'LIMITE', NULL                                     , NULL,   30                 ,   31                 ,    170, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'LIMITE', NULL                                     , NULL,   32                 ,   33                 ,    180, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'LIMITE', NULL                                     , NULL,   34                 ,   35                 ,    190, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'LIMITE', NULL                                     , NULL,   36                 ,   37                 ,    200, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'LIMITE', NULL                                     , NULL,   38                 ,   39                 ,    210, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'LIMITE', NULL                                     , NULL,   40                 ,   41                 ,    220, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'LIMITE', NULL                                     , NULL,   42                 ,   43                 ,    230, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'LIMITE', NULL                                     , NULL,   44                 ,   45                 ,    240, CODLOJ, 'F' FROM TT_IDF UNION ALL
     SELECT 'LIMITE', NULL                                     , NULL,   45                 , NULL                 ,    250, CODLOJ, 'F' FROM TT_IDF);

  RETURN NULL;
END;
$$ language 'plpgsql';




/*-- SEQ 0538 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DiasSelecionados (Timestamp,Timestamp,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 0539 --*/
CREATE OR REPLACE FUNCTION DiasSelecionados (Timestamp,Timestamp,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pDatIni ALIAS FOR $1 ;
pdatFim ALIAS FOR $2 ;
pMes ALIAS FOR $3 ;
pAno ALIAS FOR $4 ;
-- Objetivo:
-- 1) Criar ums String marcando os dias selecionados
  RESULTADO VARCHAR(31);
  cDIA VARCHAR(2);
  ULTDIA INTEGER;
  DIA    INTEGER;

BEGIN
  ULTDIA:=TO_CHAR(LAST_DAY(TO_DATE('01'||'/'||pMes||'/'||pAno,'dd/mm/yyyy')),'dd');
  RESULTADO:=LPAD('0',ULTDIA,'0');  
  FOR DIA IN 1..ULTDIA LOOP
      cDIA:=lpad(DIA,2,'0');
      IF TO_DATE(cDIA||'/'||pMes||'/'||pAno,'dd/mm/yyyy') BETWEEN trunc(pDATINI) AND trunc(pDATFIM) THEN
         RESULTADO:=SUBSTR(RESULTADO,0,DIA-1)||'1'||SUBSTR(RESULTADO,DIA+1);
      END IF;    
  END LOOP;  

  RETURN RESULTADO;

END;
$$ language 'plpgsql';




/*-- SEQ 0540 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SaldoCCVinculados (TT_LIM.FILCLI%TYPE,TT_LIM.CODCLI%TYPE,TT_LIM.TIPCCC%TYPE,TD_FIL.CODFIL%TYPE,TT_CCC.DATOPE%TYPE,TT_VEN.FILFAT%TYPE,TT_VEN.ENDFAT%TYPE,TT_CCC.CHKFAT%TYPE) CASCADE;

/*-- SEQ 0541 --*/
CREATE OR REPLACE FUNCTION SaldoCCVinculados (TT_LIM.FILCLI%TYPE,TT_LIM.CODCLI%TYPE,TT_LIM.TIPCCC%TYPE,TD_FIL.CODFIL%TYPE,TT_CCC.DATOPE%TYPE,TT_VEN.FILFAT%TYPE,TT_VEN.ENDFAT%TYPE,TT_CCC.CHKFAT%TYPE)
RETURNS Numeric AS $$
DECLARE
pFilCli ALIAS FOR $1 ;
pCodCli ALIAS FOR $2 ;
pTipCCC ALIAS FOR $3 ;
pCodfil ALIAS FOR $4 ;
pDatOpe ALIAS FOR $5 ;
pFilfat ALIAS FOR $6 ;
pEndfat ALIAS FOR $7 ;
pChkfat ALIAS FOR $8 ;

 r_vsaldo TT_LIM.VSALDO%TYPE;
 

  r_linha RECORD;
  a_vsalva VARCHAR[];
  a_hsalva VARCHAR[];
  n_conta INTEGER;
  c_dummy VARCHAR;

FILHOS CURSOR FOR
  select filcli, codcli
    from tt_cli
   where filvin = pfilcli
     and codvin = pcodcli
     and global='G';

SALDO CURSOR FOR
  select sum(ccc.vlrlan) as vsaldo
    from tt_ccc ccc inner join td_ccc dccc on ccc.tipccc=dccc.codtab
                    inner join tt_lim lim on lim.filcli = ccc.filcli and lim.codcli = ccc.codcli 
                                         and lim.tipccc = ccc.tipccc
                    left  join tt_ven ven on ven.codfil = ccc.codven and ven.sequen = ccc.seqven
                    left  join tt_ccc cc2 on cc2.codfil = ccc.filccc
                                         and cc2.sequen = ccc.seqccc                       
   where ccc.filcli = pfilcli
     and ccc.codcli = pcodcli
     and ccc.tipccc = ptipccc     
     and ccc.status in ('A','P')
     and ccc.filfat is null
     and ccc.chkfat = CASE WHEN pChkfat = 'T' THEN pChkfat ELSE ccc.chkfat END
     and ((trunc(ccc.datope)<= COALESCE(trunc(pDatOpe),add_day(trunc(AGORA()),- COALESCE(DCCC.DIARET,0)))) 
     -- MN - Essa funo mostra o saldo de um cliente que deve ser faturado. A condio abaixo, cc2.vlrlan > 0 existe para trazer
     -- o crdito da devoluo de venda em qualquer momento. Exemplo, cliente fatura de 01 a 31/01, se tiver uma devoluo em 10/02, o crdito
     -- dessa devoluo estar presente no faturamento. Quando ocorre um CANCELAMENTO de venda, o sistema no registra o vnculo entre
     -- as ccs, e no caso do cancelamento de venda, ele  processado no ms que ocorreu o cancelamento.
       or ((cc2.vlrlan>0) 
      and (coalesce(cc2.datope,trunc(pDatOpe)) <= trunc(pDatOpe))))
     and ccc.codfil = coalesce(pCodfil,ccc.codfil)
     AND (LIM.FATEND = 'F' OR
          (coalesce(ven.filfat,lim.filcob) = COALESCE(pfilfat,LIM.FILCOB) and
           coalesce(ven.endfat,lim.endcob) = COALESCE(pendfat,LIM.ENDCOB))
         );
     
BEGIN

 OPEN Saldo;
 FETCH Saldo into r_vsaldo;
 IF NOT FOUND THEN
   r_vsaldo := 0;
 end if;
 CLOSE Saldo;

 n_conta := 0;

 OPEN Filhos;
 LOOP

 
 
    n_conta := n_conta + 1;
    FETCH Filhos into r_linha;
    EXIT WHEN NOT FOUND;
    select r_linha.FILCLI||','||r_linha.CODCLI into c_dummy;
    IF n_conta = 1 THEN
      select ARRAY[c_dummy] into a_vsalva;
    ELSE
     select array_append (a_vsalva,c_dummy) into a_vsalva;
    END IF;
  

   END LOOP;
   Close Filhos;

 
 FOR i IN 1..n_conta-1 LOOP
   select '{'||a_vsalva[i]||'}' into a_hsalva;   
   r_vsaldo := coalesce(r_vsaldo,0) + SaldoCCVinculados( a_hsalva[1], lpad(a_hsalva[2],6,' '), ptipccc, pCodfil,pDatope );
 END LOOP;
  

 Return COALESCE(r_vsaldo,0);
END;
$$ language 'plpgsql';


/*-- SEQ 0542 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SaldoCCVinculados (TT_LIM.FILCLI%TYPE,TT_LIM.CODCLI%TYPE,TT_LIM.TIPCCC%TYPE,TD_FIL.CODFIL%TYPE,TT_CCC.DATOPE%TYPE) CASCADE;

/*-- SEQ 0543 --*/
CREATE OR REPLACE FUNCTION SaldoCCVinculados (TT_LIM.FILCLI%TYPE,
                               TT_LIM.CODCLI%TYPE,
                               TT_LIM.TIPCCC%TYPE,
                               TD_FIL.CODFIL%TYPE,
                               TT_CCC.DATOPE%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN SaldoCCVinculados($1,$2,$3,$4,$5,NULL,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 0544 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SaldoCCVinculados (TT_LIM.FILCLI%TYPE,TT_LIM.CODCLI%TYPE,TT_LIM.TIPCCC%TYPE,TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 0545 --*/
CREATE OR REPLACE FUNCTION SaldoCCVinculados (TT_LIM.FILCLI%TYPE,
                               TT_LIM.CODCLI%TYPE,
                               TT_LIM.TIPCCC%TYPE,
                               TD_FIL.CODFIL%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN SaldoCCVinculados($1,$2,$3,$4,NULL,NULL,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 0546 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SaldoCCVinculados (TT_LIM.FILCLI%TYPE,TT_LIM.CODCLI%TYPE,TT_LIM.TIPCCC%TYPE) CASCADE;

/*-- SEQ 0547 --*/
CREATE OR REPLACE FUNCTION SaldoCCVinculados (TT_LIM.FILCLI%TYPE,
                               TT_LIM.CODCLI%TYPE,
                               TT_LIM.TIPCCC%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN SaldoCCVinculados($1,$2,$3,NULL,NULL,NULL,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 0548 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SaldoRazao (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,Timestamp,TT_RZR.SEQUEN%TYPE) CASCADE;

/*-- SEQ 0549 --*/
CREATE OR REPLACE FUNCTION SaldoRazao (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,Timestamp,TT_RZR.SEQUEN%TYPE)
RETURNS Numeric AS $$
DECLARE
pFilcli ALIAS FOR $1 ;
pCodcli ALIAS FOR $2 ;
pDatinc ALIAS FOR $3 ;
pSequen ALIAS FOR $4 ;
-- Objetivo
-- 1) Obter o proximo valor sequencial de uma tabela
--
  WK_VLRSAL Numeric;

-- Principal
begin
    select VLRSAL INTO WK_VLRSAL
    from (
        select VLRSAL
          from tt_rzr
         where filcli=pFILCLI 
           and codcli=pCODCLI 
           and datinc=pDATINC
           and sequen= (select max(sequen)
                         from tt_rzr
                        where datinc=pDATINC
                          and filcli=pFILCLI
                          and codcli=pCODCLI
                          and sequen<pSequen
                      )
        union all
        select VLRSAL
          from tt_rzr
         where filcli=pFILCLI 
           and codcli=pCODCLI 
           and sequen=(select max(sequen)
                         from tt_rzr
                        where datinc=(select max(datinc)
                                        from tt_rzr
                                       where datinc<pDATINC
                                         and filcli=pFILCLI 
                                         and codcli=pCODCLI )
                          and filcli=pFILCLI 
                          and codcli=pCODCLI 
                      )
      ) tab
where 1=1
  LIMIT 1;
     RETURN coalesce(WK_VLRSAL,0);
END;
$$ language 'plpgsql';




/*-- SEQ 0550 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SOMA (Numeric) CASCADE;

/*-- SEQ 0551 --*/
CREATE OR REPLACE FUNCTION SOMA (Numeric)
RETURNS Numeric AS $$
DECLARE
pValor ALIAS FOR $1 ;
nRet Numeric;
BEGIN
   
   UPDATE TW_SUM
      SET VLRSUM=VLRSUM+pValor
    where userid = USERENV( 'SESSIONID' );
   
   SELECT VLRSUM INTO nRet
     FROM TW_SUM
    where userid = USERENV( 'SESSIONID' );
   
   RETURN nRet;
   
END;
$$ language 'plpgsql';




/*-- SEQ 0552 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION STR_TO_NUMBER (VARCHAR) CASCADE;

/*-- SEQ 0553 --*/
CREATE OR REPLACE FUNCTION STR_TO_NUMBER (VARCHAR)
RETURNS Numeric AS $$
DECLARE
pNumero ALIAS FOR $1 ;
  pPonto	Numeric(2);
  pVirgula	Numeric(2);
  vNumero	VARCHAR(20);


BEGIN

  pPonto:= INSTR(pNumero,'.');
  pVirgula:= INSTR(pNumero,',');

  IF (pPonto = 0 and pVirgula > 0) THEN
     vNumero:= pNumero;
  ELSIF
    (pPonto > 0 and pVirgula = 0) THEN
     vNumero:= REPLACE(pNumero,'.',',');
  ELSIF
    (pPonto > 0 and pVirgula > 0) and (pPonto > pVirgula) THEN
     vNumero:= REPLACE(pNumero,',','');
     vNumero:= REPLACE(vNumero,'.',',');
  ELSIF
    (pPonto > 0 and pVirgula > 0) and (pVirgula > pPonto ) THEN
     vNumero:= REPLACE(pNumero,'.','');
  ELSIF
     ISDIGIT(vNumero) = 0 THEN 
     vNumero:= 0;   
  END IF;

  RETURN to_number(vNumero);

END;
$$ language 'plpgsql' STABLE;




/*-- SEQ 0554 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Tem_Encomenda (TT_IVO.FILPED%TYPE,TT_IVO.TIPPED%TYPE,TT_IVO.NUMPED%TYPE) CASCADE;

/*-- SEQ 0555 --*/
CREATE OR REPLACE FUNCTION Tem_Encomenda (TT_IVO.FILPED%TYPE,TT_IVO.TIPPED%TYPE,TT_IVO.NUMPED%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_Filped ALIAS FOR $1 ;
p_Tipped ALIAS FOR $2 ;
p_Numped ALIAS FOR $3 ;

vTEM_ENCOMENDA VARCHAR(1);    -- Tem encomenda
-- Objetivo:
-- 1) Verifica se no orcamento existe algum item com venda sob encomenda
BEGIN

  SELECT MAX(CAST('T' AS CHAR(1)))
    INTO vTEM_ENCOMENDA 
    FROM TT_IOR
   WHERE CODFIL = p_Filped
     AND TIPPED = p_Tipped
     AND NUMPED = p_Numped     
     AND TIPENT = '7'
     AND FLGEST <> 'C';

  RETURN COALESCE(vTEM_ENCOMENDA,'F');
  
END;
$$ language 'plpgsql';




/*-- SEQ 0556 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_IVE_Existe_Lancamento (TT_IVE.CODFIL%tYPE,TT_IVE.FILMAT%tYPE,TT_IVE.CODMAT%tYPE,TT_IVE.CODCOR%tYPE,TT_IVE.CODTAM%tYPE,TT_IVE.CODMUL%tYPE) CASCADE;

/*-- SEQ 0557 --*/
CREATE OR REPLACE FUNCTION TGR_IVE_Existe_Lancamento (TT_IVE.CODFIL%tYPE,TT_IVE.FILMAT%tYPE,TT_IVE.CODMAT%tYPE,TT_IVE.CODCOR%tYPE,TT_IVE.CODTAM%tYPE,TT_IVE.CODMUL%tYPE)
RETURNS BOOLEAN AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pFILMAT ALIAS FOR $2 ;
PCODMAT ALIAS FOR $3 ;
PCODCOR ALIAS FOR $4 ;
PCODTAM ALIAS FOR $5 ;
PCODMUL ALIAS FOR $6 ;
  -- Verifica se ja existe um lancamento para o produto em TT_SAL
  linha INTEGER;
BEGIN
  SELECT COUNT(*) INTO linha
  FROM TT_SAL
  WHERE CODFIL = pCODFIL
    AND FILMAT = pFILMAT
    AND CODMAT = pCODMAT
    AND CODCOR = pCODCOR
    AND CODTAM = pCODTAM
    AND CODMUL = pCODMUL;
  RETURN (linha > 0);
END;
$$ language 'plpgsql';




/*-- SEQ 0558 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TIPO_DESPESA (TT_ECT.FILECT%TYPE,TT_ECT.SEQECT%TYPE) CASCADE;

/*-- SEQ 0559 --*/
CREATE OR REPLACE FUNCTION TIPO_DESPESA (TT_ECT.FILECT%TYPE,TT_ECT.SEQECT%TYPE)
RETURNS VARCHAR AS $$
DECLARE
cFilEct ALIAS FOR $1 ;
cSeqEct ALIAS FOR $2 ;
-- Tarefa 68333
-- Objetivo 
-- 1) Retornar se possui alguma conta pai do tipo Despesa
  vUSOCTA   TT_ECT.USOCTA%TYPE;
  vCODFIL   TT_ECT.CODFIL%TYPE;
  vSEQUEN   TT_ECT.SEQUEN%TYPE;
  vFILECT   TT_ECT.FILECT%TYPE;
  vSEQECT   TT_ECT.SEQECT%TYPE;
BEGIN
  vUSOCTA := 'F';
  vFILECT := cFilEct;
  vSEQECT := cSeqEct;
  LOOP      
    
    SELECT  CODFIL,  SEQUEN,  USOCTA, FILECT, SEQECT
      INTO vCODFIL, vSEQUEN, vUSOCTA, vFILECT, vSEQECT
      FROM TT_ECT
     WHERE CODFIL = vFILECT AND SEQUEN = vSEQECT;

     EXIT WHEN ((vUSOCTA = 'D') or (vFILECT IS NULL AND vSEQECT IS NULL));
    
  END LOOP;

  IF vUSOCTA = 'D' THEN
     return 'T';
  ELSE
     return 'F';
  END IF;

END;
$$ language 'plpgsql';




/*-- SEQ 0560 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TipoVenda (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE) CASCADE;

/*-- SEQ 0561 --*/
CREATE OR REPLACE FUNCTION TipoVenda (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
cCodFil ALIAS FOR $1 ;
cSequen ALIAS FOR $2 ;
  Negativos Integer;
  Positivos Integer;
  QtdReg    Integer;
BEGIN
  Negativos := 0;
  Positivos := 0;

  SELECT COUNT(*) into QtdReg
    FROM TT_IVE IVE
   WHERE IVE.CODFIL = cCodFil
     AND IVE.SEQUEN = cSequen;    

  IF (QtdReg > 0) THEN
    SELECT SUM(CASE WHEN ABS(IVE.QTDMOV) = IVE.QTDMOV THEN 1 ELSE 0 END) AS POS,
           SUM(CASE WHEN ABS(IVE.QTDMOV) = IVE.QTDMOV THEN 0 ELSE 1 END) AS NEG
      INTO Positivos, Negativos
      FROM TT_IVE IVE
     WHERE IVE.CODFIL = cCodFil
       AND IVE.SEQUEN = cSequen
     GROUP BY IVE.CODFIL, IVE.SEQUEN;
  END IF;
     
  Negativos := COALESCE(Negativos,0);
  Positivos := COALESCE(Positivos,0);

  IF (Negativos > 0) AND (Positivos = 0) THEN
    return '-';
  ELSIF (Negativos = 0) AND (Positivos > 0) THEN
    return '+';
  ELSIF (Negativos > 0) AND (Positivos > 0) THEN
    return 'A';
  ELSIF (Negativos = 0) AND (Positivos = 0) THEN
    return NULL;
  END IF;
END;
$$ language 'plpgsql';




/*-- SEQ 0562 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TRATACARACTER (VARCHAR) CASCADE;

/*-- SEQ 0563 --*/
CREATE OR REPLACE FUNCTION TRATACARACTER (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
CAMPO ALIAS FOR $1 ;
   cCampo VARCHAR(4000);
BEGIN 
   cCampo := CAMPO;
   cCampo := REPLACE(cCampo, CHR(39), CHR(39)||CHR(39));
   cCampo := REPLACE(cCampo, CHR(92), CHR(39)||'||CHR(92)||'||CHR(39));
   cCampo := REPLACE(cCampo, CHR(13)||CHR(10), CHR(10));
   cCampo := REPLACE(cCampo, CHR(10)||CHR(13), CHR(10));
   cCampo := REPLACE(cCampo, CHR(13), CHR(10));
   cCampo := REPLACE(cCampo, CHR(10), CHR(13)||CHR(10));
   RETURN cCampo;
END;
$$ language 'plpgsql';




/*-- SEQ 0564 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TEXTO_NO_EMAIL (TT_MAI.CODFIL%TYPE,TT_MAI.SEQUEN%TYPE,VARCHAR) CASCADE;

/*-- SEQ 0565 --*/
CREATE OR REPLACE FUNCTION TEXTO_NO_EMAIL (TT_MAI.CODFIL%TYPE,TT_MAI.SEQUEN%TYPE,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pCodFil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
pTexto ALIAS FOR $3 ;
  RESULTADO VARCHAR(1);
  cTexto TT_MAI.TEXTOS%TYPE;
BEGIN
   SELECT TEXTOS INTO cTexto
     FROM TT_MAI 
    WHERE CODFIL = pCodFil
      AND SEQUEN = pSequen;
IF INSTR( UPPER(cTexto), UPPER(pTexto)) > 0 THEN
  RETURN 'T';
ELSE
  RETURN 'F';
END IF;
END;
$$ language 'plpgsql';





/*-- SEQ 0566 --*/
/*--IGNORE ERRO--*/
drop index I_UQ_CHR;

/*-- SEQ 0567 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION fn_UQ_CHR (tt_chr.CODBCO%type,tt_chr.CODAGE%type,tt_chr.NUMCON%type,tt_chr.NUMCHE%type,tt_chr.SEQCAN%type) CASCADE;

/*-- SEQ 0568 --*/
CREATE OR REPLACE FUNCTION fn_UQ_CHR (tt_chr.CODBCO%type,tt_chr.CODAGE%type,tt_chr.NUMCON%type,tt_chr.NUMCHE%type,tt_chr.SEQCAN%type)
RETURNS char AS $$
DECLARE
pcodbco ALIAS FOR $1 ;
pcodage ALIAS FOR $2 ;
pnumcon ALIAS FOR $3 ;
pnumche ALIAS FOR $4 ;
pseqcan ALIAS FOR $5 ;
 output VARCHAR(1000);
begin
 output := pcodbco||pcodage||pnumcon||pnumche||COALESCE(pseqcan,'AAAAAAA');
 return (output);

end;
$$ language 'plpgsql' IMMUTABLE;

/*-- SEQ 0569 --*/
/*--IGNORE ERRO--*/
create unique index I_UQ_CHR on TT_CHR (fn_UQ_CHR(CODBCO,CODAGE,NUMCON,NUMCHE,SEQCAN))  ;



/*-- SEQ 0570 --*/
/*--IGNORE ERRO--*/
drop index I_UQ_CHR_CDCMC7;

/*-- SEQ 0571 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION fn_UQ_CHR_CDCMC7 (tt_chr.CDCMC7%type,tt_chr.SEQCAN%type) CASCADE;

/*-- SEQ 0572 --*/
CREATE OR REPLACE FUNCTION fn_UQ_CHR_CDCMC7 (tt_chr.CDCMC7%type,tt_chr.SEQCAN%type)
RETURNS char AS $$
DECLARE
pcdcmc7 ALIAS FOR $1 ;
pseqcan ALIAS FOR $2 ;
 output VARCHAR(1000);
begin
 if pcdcmc7 is null AND pseqcan IS NULL THEN
   output := null;
 else
   output := COALESCE(pcdcmc7,REPEAT('A',30))||
             COALESCE(pseqcan,REPEAT('A',10));
 end if;
 return (output);
end;
$$ language 'plpgsql' IMMUTABLE;

/*-- SEQ 0573 --*/
/*--IGNORE ERRO--*/
create unique index I_UQ_CHR_CDCMC7 on TT_CHR (fn_UQ_CHR_CDCMC7(CDCMC7,SEQCAN))  ;



/*-- SEQ 0574 --*/
/*--IGNORE ERRO--*/
drop index I_UQ_COM_NOTA;

/*-- SEQ 0575 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION fn_UQ_COM_NOTA (tt_COM.filfor%type,tt_COM.Codfor%type,tt_COM.Codser%type,VARCHAR,tt_COM.Numnot%type,tt_COM.seqcan%type) CASCADE;

/*-- SEQ 0576 --*/
CREATE OR REPLACE FUNCTION fn_UQ_COM_NOTA (tt_COM.filfor%type,tt_COM.Codfor%type,tt_COM.Codser%type,VARCHAR,tt_COM.Numnot%type,tt_COM.seqcan%type)
RETURNS char AS $$
DECLARE
pfilfor ALIAS FOR $1 ;
pcodfor ALIAS FOR $2 ;
pcodser ALIAS FOR $3 ;
psubser ALIAS FOR $4 ;
pnumnot ALIAS FOR $5 ;
pseqcan ALIAS FOR $6 ;
 output VARCHAR(1000);
begin
 output := pFILFOR||pCODFOR||pCODSER||COALESCE(pSUBSER,'AAAA')||pNUMNOT||COALESCE(pSEQCAN,'AAAAAAA');
 return (output);

end;
$$ language 'plpgsql' IMMUTABLE;


/*-- SEQ 0577 --*/
/*--IGNORE ERRO--*/ 
create unique index i_UQ_COM_NOTA on TT_COM (fn_UQ_COM_NOTA(FILFOR,CODFOR,CODSER,SUBSER,NUMNOT,SEQCAN))  ;



/*-- SEQ 0578 --*/
/*--IGNORE ERRO--*/
drop index I_UQ_RCP_COM;

/*-- SEQ 0579 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION fn_UQ_RCP_COM (tt_rcp.filfor%type,tt_rcp.Codfor%type,tt_rcp.Codser%type,VARCHAR,tt_rcp.Numnot%type) CASCADE;

/*-- SEQ 0580 --*/
CREATE OR REPLACE FUNCTION fn_UQ_RCP_COM (tt_rcp.filfor%type,tt_rcp.Codfor%type,tt_rcp.Codser%type,VARCHAR,tt_rcp.Numnot%type)
RETURNS char AS $$
DECLARE
pfilfor ALIAS FOR $1 ;
pcodfor ALIAS FOR $2 ;
pcodser ALIAS FOR $3 ;
psubser ALIAS FOR $4 ;
pnumnot ALIAS FOR $5 ;
 output VARCHAR(1000);
begin
 output := pfilfor||pcodfor||pcodser||COALESCE(psubser,'AAAAAAA')||pnumnot;
 return (output);

end;
$$ language 'plpgsql' IMMUTABLE;


/*-- SEQ 0581 --*/
/*--IGNORE ERRO--*/
create unique index I_UQ_RCP_COM on TT_RCP (fn_UQ_RCP_COM(FILFOR,CODFOR,CODSER,SUBSER,NUMNOT))  ;



/*-- SEQ 0582 --*/
/*--IGNORE ERRO--*/
drop index I_UQ_RET_RETORNO;

/*-- SEQ 0583 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION fn_UQ_RET_RETORNO (tt_ret.CODBCO%type,tt_ret.CODRET%type,tt_ret.RETBCO%type) CASCADE;

/*-- SEQ 0584 --*/
CREATE OR REPLACE FUNCTION fn_UQ_RET_RETORNO (tt_ret.CODBCO%type,tt_ret.CODRET%type,tt_ret.RETBCO%type)
RETURNS char AS $$
DECLARE
pCODBCO ALIAS FOR $1 ;
pCODRET ALIAS FOR $2 ;
pRETBCO ALIAS FOR $3 ;
 output VARCHAR(1000);
begin
 output := pCODBCO||PCODRET||COALESCE(pRETBCO,-99999);
 return (output); 

end;
$$ language 'plpgsql' IMMUTABLE;


/*-- SEQ 0585 --*/
/*--IGNORE ERRO--*/
create unique index I_UQ_RET_RETORNO on TT_RET (fn_UQ_RET_RETORNO(CODBCO,CODRET,RETBCO))  ;


/*-- SEQ 0586 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION UsaVMDecisor () CASCADE;

/*-- SEQ 0587 --*/
CREATE OR REPLACE FUNCTION UsaVMDecisor ()
RETURNS VARCHAR AS $$
DECLARE

vUSA_VM_DECISOR TT_CFG.USA_VM_DECISOR%TYPE;

-- Objetivo:
-- 1) Indica se utiliza views materializadas para o Decisor

BEGIN

  SELECT USA_VM_DECISOR INTO vUSA_VM_DECISOR
    FROM TT_CFG;

  RETURN vUSA_VM_DECISOR;
END;
$$ language 'plpgsql';




/*-- SEQ 0588 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ValidaFluxoWorkflow (TT_FLW.SITORI%TYPE,TT_FLW.SITDES%TYPE) CASCADE;

/*-- SEQ 0589 --*/
CREATE OR REPLACE FUNCTION ValidaFluxoWorkflow (TT_FLW.SITORI%TYPE,TT_FLW.SITDES%TYPE)
RETURNS CHAR AS $$
DECLARE
pSITORI ALIAS FOR $1 ;
pSITDES ALIAS FOR $2 ;

  cAUX     VARCHAR(1);
BEGIN
   -- davi -  41196 - 24/05/06
   -- identifica se a situacao de origem e destino constam na tabela de fluxo (tt_flw)
   
   SELECT 'T' AS EXISTE INTO cAUX
     FROM TT_FLW 
    WHERE SITORI = pSITORI
      AND SITDES = pSITDES;

  RETURN (cAUX);

END;
$$ language 'plpgsql';




/*-- SEQ 0590 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION QuantidadeItensDiferentesVenda (TT_VEN.CODFIL%TYPE,TT_VEN.SEQUEN%TYPE) CASCADE;

/*-- SEQ 0591 --*/
CREATE OR REPLACE FUNCTION QuantidadeItensDiferentesVenda (TT_VEN.CODFIL%TYPE,TT_VEN.SEQUEN%TYPE)
RETURNS Numeric AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
   RETORNO Numeric;
BEGIN
   select count(*) into retorno
     from (select distinct iive.filmat,iive.codmat,iive.codcor,iive.codtam 
             from tt_ive iive 
            where iive.codfil=pCodfil
              and iive.sequen=pSequen
           ) iint;

   RETURN RETORNO;
END;
$$ language 'plpgsql';




/*-- SEQ 0592 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VePagtoFuncionario (tt_cli.filcli%type,tt_cli.codcli%type) CASCADE;

/*-- SEQ 0593 --*/
CREATE OR REPLACE FUNCTION VePagtoFuncionario (tt_cli.filcli%type,tt_cli.codcli%type)
RETURNS INTEGER AS $$
DECLARE
pFilcli ALIAS FOR $1 ;
pCodcli ALIAS FOR $2 ;
  cPermite VARCHAR(1);
  nQtd integer;
BEGIN

   select SUBSTR(PERMISSOESUSUARIO(FILUSU,CODUSU),147,1) into cPermite
   from tt_usu
   where apeusu = GetApeUsuAtual();

   if (cPermite = 'S') or (GetApeUsuAtual() = QualDono()) then
     -- Usuario pode ver pagamentos a funcionario. Retorna 1 = Sim
     return 1;
   else
     select count(*) into nQtd
     from tt_usu
     where filcli = pFilcli
      and codcli = pCodcli;

     if nQtd=0 then
      -- parceiro nao e funcionario. Retorna 1 = Sim
      return 1;
     else
      -- parceiro e funcionario. Retorna 0 = No
      return 0;
     end if;
   end if;
END;
$$ language 'plpgsql';




/*-- SEQ 0594 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VerificaNULL (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE) CASCADE;

/*-- SEQ 0595 --*/
CREATE OR REPLACE FUNCTION VerificaNULL (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILCLI ALIAS FOR $1 ;
pCODCLI ALIAS FOR $2 ;

  vRetorno VARCHAR(1);

BEGIN
       vRetorno := '1';

       SELECT CASE WHEN CLI.ESTCIV = 0 THEN '0' ELSE '1' END AS ESTCIV 
         INTO vRetorno 
         FROM TT_CLI CLI
        WHERE CLI.FILCLI = pFILCLI
          AND CLI.CODCLI = pCODCLI;
       
       IF vRetorno = '0' THEN 
          RETURN vRetorno;
       END IF;  

       SELECT CASE WHEN CLI.INSEST IS NULL THEN '0' ELSE '1' END AS INSEST 
         INTO vRetorno 
         FROM TT_CLI CLI
        WHERE CLI.FILCLI = pFILCLI
          AND CLI.CODCLI = pCODCLI;

       IF vRetorno = '0' THEN 
          RETURN vRetorno;
       END IF;  

       SELECT CASE WHEN CLI.CATEG1 IS NULL THEN '0' ELSE '1' END AS CATEG1
         INTO vRetorno 
         FROM TT_CLI CLI
        WHERE CLI.FILCLI = pFILCLI
          AND CLI.CODCLI = pCODCLI;

       IF vRetorno = '0' THEN 
          RETURN vRetorno;
       END IF;  

       SELECT CASE WHEN CLI.CATEG2 IS NULL THEN '0' ELSE '1' END AS CATEG2
         INTO vRetorno 
         FROM TT_CLI CLI
        WHERE CLI.FILCLI = pFILCLI
          AND CLI.CODCLI = pCODCLI;

       IF vRetorno = '0' THEN 
          RETURN vRetorno;
       END IF;  

       SELECT CASE WHEN CLI.CATEG3 IS NULL THEN '0' ELSE '1' END AS CATEG3
         INTO vRetorno 
         FROM TT_CLI CLI
        WHERE CLI.FILCLI = pFILCLI
          AND CLI.CODCLI = pCODCLI;

       IF vRetorno = '0' THEN 
          RETURN vRetorno;
       END IF;  

       SELECT CASE WHEN SPC.NUMCEL IS NULL THEN '0' ELSE '1' END AS NUMCEL
         INTO vRetorno 
         FROM TT_SPC SPC
        WHERE SPC.FILCLI = pFILCLI
          AND SPC.CODCLI = pCODCLI;

       IF vRetorno = '0' THEN 
          RETURN vRetorno;
       END IF;  
       
      RETURN vRetorno;   
END;
$$ language 'plpgsql';




/*-- SEQ 0596 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VinculoFuturo (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE,TT_IVE.QTDMOV%TYPE) CASCADE;

/*-- SEQ 0597 --*/
CREATE OR REPLACE FUNCTION VinculoFuturo (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE,TT_IVE.QTDMOV%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_CodFil ALIAS FOR $1 ;
p_Sequen ALIAS FOR $2 ;
p_NumIte ALIAS FOR $3 ;
p_Recurs ALIAS FOR $4 ;
   cFILORI TT_IVE.FILORI%TYPE;
   cNUMORI TT_IVE.NUMORI%TYPE;
   cITEORI TT_IVE.ITEORI%TYPE;
   vComplemento CONSTANT VARCHAR(254):= constante('complemento');
   cRetorno VARCHAR(100);
   
-- Objetivo:
-- 1) retorna a nota de vnculo futuro

BEGIN
  
  IF p_Recurs > 10 THEN 
    RAISE EXCEPTION 'PG-20001 Funcao entrou em looping infinito. %' , vComplemento;
  END IF;
  
  SELECT FILORI, NUMORI, ITEORI
    INTO cFILORI, cNUMORI, cITEORI
    FROM TT_IVE
   WHERE CODFIL = p_CodFil
     AND SEQUEN = p_Sequen
     AND NUMITE = p_NumIte;  
     
  IF ISNULL(cFILORI) <> 'T' THEN
    cRetorno := VinculoFuturo(cFILORI, cNUMORI, cITEORI, p_Recurs+1); 
  ELSE 
    cRetorno := p_CodFil||p_Sequen||p_NumIte;
  END IF;
   
  RETURN cRetorno;
   
END;
$$ language 'plpgsql';




/*-- SEQ 0598 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ValoresComplementares (TT_VEN.CODFIL%TYPE,TT_VEN.SEQUEN%TYPE,TT_VEN.VLRNOT%TYPE,Numeric) CASCADE;

/*-- SEQ 0599 --*/
CREATE OR REPLACE FUNCTION ValoresComplementares (TT_VEN.CODFIL%TYPE,TT_VEN.SEQUEN%TYPE,TT_VEN.VLRNOT%TYPE,Numeric)
RETURNS Numeric AS $$
DECLARE
pCodfil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
pVlrNot ALIAS FOR $3 ;
pTipo ALIAS FOR $4 ;
-- Criada para melhorar a performance da geracao de arquivos do sintegra
-- Objetivo:
-- 1) Valores de reducao de base
-- 2) Valores de Substituicaoo tributaria
-- 3) Valor da base de calculo substituida
  WK_VALOR Numeric;
BEGIN
  -- Moeda corrente do Pais
  IF pTipo = 1 THEN
        SELECT SUM(ABS(ROUND(((I.VLRMOV - (I.VLRMOV * ABS(COALESCE(V.DESCON,0) / 100) *
                                          CASE LEAST(COALESCE(V.DESCON,0),0) WHEN 0 THEN -1
                                                                             ELSE 1
                                           END)) * (I.REDITE / 100)),2)))
          INTO WK_VALOR
          FROM TT_VEN V INNER JOIN TT_IVE I ON I.CODFIL = V.CODFIL AND V.SEQUEN = I.SEQUEN
         WHERE V.CODFIL = pCODFIL
           AND V.SEQUEN = pSEQUEN;
  ELSIF pTIPO = 2 THEN

        SELECT ROUND(COALESCE(V.BASUBS,0),2)
          INTO WK_VALOR
          FROM TT_VEN V 
         WHERE V.CODFIL = pCODFIL
           AND V.SEQUEN = pSEQUEN;
  
  ELSIF pTIPO = 3 THEN

     SELECT ROUND(COALESCE(SUM(CASE WHEN pVlrNot=0 THEN 0
                                    WHEN (SELECT SUM(T.VLRMOV - T.VLR002)
                                            FROM TT_IVE T
                                           WHERE I.CODFIL = T.CODFIL
                                             AND I.SEQUEN = T.SEQUEN
                                             AND T.TIP001 = 'M'
                                             AND T.ICMTIP = '3')=0 THEN 0
                                    ELSE (COALESCE(V.SUBSTT,0) * (I.VLRMOV - COALESCE(I.VLR002,0) )) / (SELECT SUM(T.VLRMOV - T.VLR002)
                                                                                                          FROM TT_IVE T
                                                                                                         WHERE I.CODFIL = T.CODFIL
                                                                                                           AND I.SEQUEN = T.SEQUEN
                                                                                                           AND T.TIP001 = 'M'
                                                                                                           AND T.ICMTIP = '3')
                                END),0),2)
       INTO WK_VALOR
       FROM TT_VEN V INNER JOIN TT_IVE I ON I.CODFIL = V.CODFIL AND V.SEQUEN = I.SEQUEN
      WHERE V.CODFIL = pCODFIL
        AND V.SEQUEN = pSEQUEN
        AND I.TIP001 = 'M'
        AND I.ICMTIP = '3';

  END IF;

  IF WK_VALOR IS NULL THEN
     RETURN 0;
  ELSE RETURN WK_VALOR;
  END IF;
  
END;
$$ language 'plpgsql';





/*-- SEQ 0600 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GETVLRPAGCMS (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE) CASCADE;

/*-- SEQ 0601 --*/
CREATE OR REPLACE FUNCTION GETVLRPAGCMS (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE)
RETURNS Numeric AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pNUMPAR ALIAS FOR $3 ;
pSUBPAR ALIAS FOR $4 ;
--RETORNO Numeric;
vSEQCHE TT_REC.SEQCHE%TYPE;
vVLRPGT TT_REC.VLRPGT%TYPE;
vVLRTAX TT_REC.VLRTAX%TYPE;
vVLRCHE TT_CHR.VLRCHE%TYPE;
BEGIN

         -- RFMP 88968 Otimizao da funo 
         /*
         SELECT CASE WHEN REC.SEQCHE IS NULL THEN
                      REC.VLRPGT + COALESCE(REC.VLRTAX, 0)
                 ELSE   CASE WHEN (SELECT SUM(CHR.VLRCHE)
                                     FROM TT_CHR CHR
                                    WHERE REC.FILREC = CHR.CODFIL
                                      AND REC.SEQCHE = CHR.SEQUEN
                                      AND CHR.FLGEST IN ('C','B')) > REC.VLRPGT THEN
                             REC.VLRPGT
                        ELSE (SELECT SUM(CHR.VLRCHE)
                                 FROM TT_CHR CHR
                                WHERE REC.FILREC = CHR.CODFIL
                                  AND REC.SEQCHE = CHR.SEQUEN
                                  AND CHR.FLGEST IN ('C','B'))
                        END
                END
          INTO RETORNO
          */
        SELECT REC.SEQCHE, REC.VLRPGT, REC.VLRTAX, 
               CASE WHEN REC.SEQCHE IS NULL THEN 0 ELSE 
                 (SELECT SUM(CHR.VLRCHE)
                    FROM TT_CHR CHR
                   WHERE CHR.CODFIL = REC.FILREC
                     AND CHR.SEQUEN = REC.SEQCHE
                     AND CHR.FLGEST IN ('C','B')) END AS VLRCHE        
          INTO vSEQCHE, vVLRPGT, vVLRTAX, vVLRCHE
          FROM TT_REC REC
         WHERE REC.CODFIL = pCODFIL
           AND REC.SEQUEN = pSEQUEN
           AND REC.NUMPAR = pNUMPAR
           AND REC.SUBPAR = pSUBPAR;

         IF vSEQCHE IS NULL THEN
            RETURN vVLRPGT + COALESCE(vVLRTAX, 0);
         ELSIF vVLRCHE > vVLRPGT THEN
            RETURN vVLRPGT;
         ELSE
            RETURN vVLRCHE;         
         END IF;
         
         --RETURN RETORNO;
END;
$$ language 'plpgsql';





/*-- SEQ 0602 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Insere_TT_FIS () CASCADE;

/*-- SEQ 0603 --*/
CREATE OR REPLACE FUNCTION Insere_TT_FIS ()
RETURNS VARCHAR AS $$
DECLARE

BEGIN

 INSERT INTO TT_FIS                                                                                                                              
 (ORIGEM,CODSER,SUBSER,MODNOT,SEREXP,SUBEXP,EXPORT,NOMSER)                                                                                       
    (SELECT ORIGEM,CODSER,SUBSER,MODNOT,SEREXP,SUBEXP,EXPORT,NOMSER                                                                                 
       FROM (SELECT DISTINCT TO_CHAR('C') AS ORIGEM,                                                                                              
                    COM.CODSER,COM.SUBSER,                                                                                                          
                    TO_CHAR('01') AS MODNOT,                                                                                                      
                    RPAD(LTRIM(RTRIM(COALESCE(COM.CODSER,' '))),3,' ') AS SEREXP,                                                               
                    SUBSTR(LPAD(LTRIM(RTRIM(COALESCE(COM.SUBSER,'   '))),3,' '),2,2) AS SUBEXP,                                                 
                    TO_CHAR('F') AS EXPORT,                                                                                                       
                    TO_CHAR('Srie de Compra') AS NOMSER                                                                                          
               FROM (SELECT FILFOR,CODFOR,CODSER,COALESCE(SUBSER,'   ') AS SUBSER                                                                 
                       FROM TV_CMP                                                                                                                  
                      WHERE TIPPAR <> 'T'                                                                                                         
                      GROUP BY FILFOR,CODFOR,CODSER,COALESCE(SUBSER,'   ')                                                                        
                    ) COM                                                                                                                           
              WHERE (TO_CHAR('C'),COM.CODSER,COM.SUBSER) NOT IN (SELECT ORIGEM AS ORIGEM,CODSER AS CODSER ,SUBSER AS SUBSER FROM TT_FIS)          
             UNION ALL                                                                                                                              
             SELECT DISTINCT TO_CHAR('F') AS ORIGEM,                                                                                              
                    COM.CODSER,COM.SUBSER,                                                                                                          
                    TO_CHAR('01') AS MODNOT,                                                                                                      
                    RPAD(LTRIM(RTRIM(COALESCE(COM.CODSER,' '))),3,' ') AS SEREXP,                                                               
                    SUBSTR(LPAD(LTRIM(RTRIM(COALESCE(COM.SUBSER,'   '))),3,' '),2,2) AS SUBEXP,                                                 
                    TO_CHAR('F') AS EXPORT,                                                                                                       
                    TO_CHAR('Srie de Frete') AS NOMSER                                                                                           
               FROM (SELECT FILFOR,CODFOR,CODSER,COALESCE(SUBSER,'   ') AS SUBSER                                                                 
                       FROM TV_CMP                                                                                                                  
                      WHERE TIPPAR = 'T'                                                                                                          
                      GROUP BY FILFOR,CODFOR,CODSER,COALESCE(SUBSER,'   ')                                                                        
                    ) COM                                                                                                                           
              WHERE (TO_CHAR('F'),COM.CODSER,COM.SUBSER) NOT IN (SELECT ORIGEM AS ORIGEM,CODSER AS CODSER ,SUBSER AS SUBSER FROM TT_FIS)          
             UNION ALL                                                                                                                              
             SELECT DISTINCT                                                                                                                        
                    TO_CHAR('V') AS ORIGEM,                                                                                                       
                    REF.CODSER,REF.NUMECF AS SUBSER,                                                                                                
                    LTRIM(TO_CHAR(SER.MODNOT,'00')) AS MODNOT,                                                                                    
                    RPAD(LTRIM(RTRIM(COALESCE(REF.CODSER,' '))),3,' ') AS SEREXP,                                                               
                    CASE LTRIM(RTRIM(REF.CODSER)) WHEN 'CF' THEN NULL                                                                             
                                                            ELSE RPAD(LTRIM(TO_CHAR(TO_NUMBER(COALESCE(REF.NUMECF,'0')),'00')),2,' ')         
                    END AS SUBEXP,                                                                                                                  
                    TO_CHAR('F') AS EXPORT,                                                                                                       
                    SER.DESSER AS NOMSER                                                                                                            
               FROM (SELECT FIL.CODFIL,SER1.CODSER,ECF.NUMECF AS SUBSER FROM TD_SER SER1, TD_ECF ECF, TD_FIL FIL
                                        
                       Except
                                         SELECT FIL.CODFIL,F1.CODSER,F1.SUBSER FROM TT_FIS F1, TD_FIL FIL                                                               
                      WHERE F1.ORIGEM='V'                                                                                                         
                     ) NFIS                                                                                                                         
                     INNER JOIN TT_VEN REF                                                                                                          
                    ON REF.CODFIL=NFIS.CODFIL                                                                                                       
                   AND REF.CODSER=NFIS.CODSER                                                                                                       
                   AND REF.NUMECF=NFIS.SUBSER                                                                                                       
                   INNER JOIN TD_SER SER ON SER.CODSER = REF.CODSER                                                                                 
             ) REF                                                                                                                                  
    );
    

   RETURN 'OK';

END;
$$ language 'plpgsql';




/*-- SEQ 0604 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION FormataAgenciaConta (TT_CTB.CODBCO%TYPE,TT_CTB.NUMAGE%TYPE,TT_CTB.DIGAGE%TYPE,TT_CTB.CTACRR%TYPE,TT_CTB.DIGCRR%TYPE,TT_CTB.DIGA_C%TYPE,TT_CTB.NUMAGE_NOSNUM%TYPE,TT_CTB.DIGAGE_NOSNUM%TYPE,TT_CCB.CODCCB%TYPE,TT_CCB.CARCCB%TYPE,TT_CRB.APECRB%TYPE,TT_CTBXCCB.CODCNV%TYPE) CASCADE;

/*-- SEQ 0605 --*/
CREATE OR REPLACE FUNCTION FormataAgenciaConta (TT_CTB.CODBCO%TYPE,TT_CTB.NUMAGE%TYPE,TT_CTB.DIGAGE%TYPE,TT_CTB.CTACRR%TYPE,TT_CTB.DIGCRR%TYPE,TT_CTB.DIGA_C%TYPE,TT_CTB.NUMAGE_NOSNUM%TYPE,TT_CTB.DIGAGE_NOSNUM%TYPE,TT_CCB.CODCCB%TYPE,TT_CCB.CARCCB%TYPE,TT_CRB.APECRB%TYPE,TT_CTBXCCB.CODCNV%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pBanco ALIAS FOR $1 ;
pAgencia ALIAS FOR $2 ;
pDigitoAgencia ALIAS FOR $3 ;
pConta ALIAS FOR $4 ;
pDigitoConta ALIAS FOR $5 ;
pDigitoAgenciaConta ALIAS FOR $6 ;
pAgenciaNossoNum ALIAS FOR $7 ;
pDigitoAgenciaNossoNum ALIAS FOR $8 ;
pCodigoCarteira ALIAS FOR $9 ;
pCarCarteira ALIAS FOR $10 ;
pApelidoCarteira ALIAS FOR $11 ;
pConvenio ALIAS FOR $12 ;
 
-- Objetivos:
-- 1. Função que formata "Agencia e Conta"
 
-- Declaração de variáveis e cursores
   cAgenciConta                  VARCHAR(2) := '';
 
-- Início da função
BEGIN

   RETURN cAgenciConta;

END;
$$ language 'plpgsql';




/*-- SEQ 0606 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION FormataConvenio (TT_CTBXCCB.CODCNV%TYPE,TT_CCB.CARBCO%TYPE,TT_CRB.APECRB%TYPE,TT_CCB.CODBCO%TYPE) CASCADE;

/*-- SEQ 0607 --*/
CREATE OR REPLACE FUNCTION FormataConvenio (TT_CTBXCCB.CODCNV%TYPE,TT_CCB.CARBCO%TYPE,TT_CRB.APECRB%TYPE,TT_CCB.CODBCO%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pConvenio ALIAS FOR $1 ;
pCarteira ALIAS FOR $2 ;
pApelidoCarteira ALIAS FOR $3 ;
pBanco ALIAS FOR $4 ;
 
-- Objetivos:
-- 1. Funo que formata "Convnio" do Banco
 
-- Declarao de variveis e cursores
   cConvenio                     TT_CTBXCCB.CODCNV%TYPE;
 
-- Incio da funo
BEGIN   

   IF (pBanco = '027') THEN --BESC
      cConvenio := SUBSTR(TRIM(pConvenio),1,5)||'-'||SUBSTR(TRIM(pConvenio),6,2);
   ELSIF (pBanco = '033') THEN -- SANTANDER
      cConvenio :=  LPAD(TRIM(pConvenio), 7, '0');
   ELSIF (pBanco = '237') THEN -- BRADESCO
      cConvenio :=  LPAD(TRIM(pConvenio),15,'0');
   ELSE 
      cConvenio := TRIM(pConvenio);
   END IF;
 
   RETURN cConvenio;
 
END;
$$ language 'plpgsql';




/*-- SEQ 0608 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION FormataLocalizacao (TT_SAL.LOCAL1%TYPE,TT_SAL.LOCAL2%TYPE,TT_SAL.LOCAL3%TYPE,TT_GRA.LOCALI%TYPE) CASCADE;

/*-- SEQ 0609 --*/
CREATE OR REPLACE FUNCTION FormataLocalizacao (TT_SAL.LOCAL1%TYPE,TT_SAL.LOCAL2%TYPE,TT_SAL.LOCAL3%TYPE,TT_GRA.LOCALI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pLocal1 ALIAS FOR $1 ;
pLocal2 ALIAS FOR $2 ;
pLocal3 ALIAS FOR $3 ;
pLocali ALIAS FOR $4 ;

-- Objetivos:
-- 1. Padronizar apresentao das localizaes.
-- 2. Ou usa localizaes do estoque, ou usa localizao da grade.
--
-- Se voc no tem as localizaes utilize a funo BuscaLocalizacao.

-- Declarao de variveis e cursores
   cResultado VARCHAR(32);

-- Incio da funo
begin

   cResultado := NULL;

   IF ISNOTNULL(pLocal1) = 'T' THEN
      cResultado := ','||pLocal1;
   END IF;

   IF ISNOTNULL(pLocal2) = 'T' THEN
      cResultado := cResultado || ','||pLocal2;
   END IF;

   IF ISNOTNULL(pLocal3) = 'T' THEN
      cResultado := cResultado || ','||pLocal3;
   END IF;

   IF ISNOTNULL(cResultado) = 'T' THEN
      cResultado := SUBSTR(cResultado,2);
   END IF;
   
   cResultado := COALESCE(cResultado, pLocali);

   return cResultado;

END;
$$ language 'plpgsql';




/*-- SEQ 0610 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GeraDocEntradaInvRestituicao () CASCADE;

/*-- SEQ 0611 --*/
CREATE OR REPLACE FUNCTION GeraDocEntradaInvRestituicao ()
RETURNS VARCHAR AS $$
DECLARE

 
-- Objetivos:
-- 1. Gerar documentos que deram origem ao Saldo do inventrio dos produtos ST para Sintegra registro 88STITNF

-- Declarao de variveis e cursores
   cResultado                    VARCHAR(4000);

   nSESSIONID                    TW_INV_FIS_PRO_SUB.SESSION_ID%TYPE;
   cCODFIL                       TD_FIL.CODFIL%TYPE;
   cFILMAT                       TT_GRA.FILMAT%TYPE;
   cCODMAT                       TT_GRA.CODMAT%TYPE;
   nCODCOR                       TT_GRA.CODCOR%TYPE;
   nCODTAM                       TT_GRA.CODTAM%TYPE;
   nQTDSAL                       TW_INV_FIS_PRO_SUB.QTDSAL%TYPE;

   dDatIniPer                    Timestamp;
   dDatFimPer                    Timestamp;
   nNumMeses                     Numeric(3) DEFAULT 1;
   dPrimeiroLancto               Timestamp; -- data da primeira movimentao
   dDataInventario               Timestamp;

   cSEQUEN                       TW_INV_FIS_ICO_SUB.SEQUEN%TYPE;
   nNUMITE                       TW_INV_FIS_ICO_SUB.NUMITE%TYPE;
   cFILFOR                       TW_INV_FIS_ICO_SUB.FILFOR%TYPE;
   cCODFOR                       TW_INV_FIS_ICO_SUB.CODFOR%TYPE;
   cFILEND                       TW_INV_FIS_ICO_SUB.FILEND%TYPE;
   nNUMEND                       TW_INV_FIS_ICO_SUB.NUMEND%TYPE;
   cMODNOT                       TW_INV_FIS_ICO_SUB.MODNOT%TYPE;
   cCODSER                       TW_INV_FIS_ICO_SUB.CODSER%TYPE;
   cSUBSER                       TW_INV_FIS_ICO_SUB.SUBSER%TYPE;
   cNUMNOT                       TW_INV_FIS_ICO_SUB.NUMNOT%TYPE;
   dDATCMP                       TW_INV_FIS_ICO_SUB.DATCMP%TYPE;
   dDATOPE                       TW_INV_FIS_ICO_SUB.DATOPE%TYPE;
   nCOM_VLRTOT                   TW_INV_FIS_ICO_SUB.COM_VLRTOT%TYPE;
   nCOM_BASSUB                   TW_INV_FIS_ICO_SUB.COM_BASSUB%TYPE;
   nCOM_SUBSTT                   TW_INV_FIS_ICO_SUB.COM_SUBSTT%TYPE;
   nCOM_BASICM                   TW_INV_FIS_ICO_SUB.COM_BASICM%TYPE;
   nCOM_DESCON                   TW_INV_FIS_ICO_SUB.COM_DESCON%TYPE;
   nEMBORI                       TW_INV_FIS_ICO_SUB.EMBORI%TYPE;
   nEMBQTD                       TW_INV_FIS_ICO_SUB.EMBQTD%TYPE;
   cTIPPRO                       TW_INV_FIS_ICO_SUB.TIPPRO%TYPE;
   cICMTIP                       TW_INV_FIS_ICO_SUB.ICMTIP%TYPE;
   cUNICOM                       TW_INV_FIS_ICO_SUB.UNICOM%TYPE;
   nQTDCOM                       TW_INV_FIS_ICO_SUB.QTDCOM%TYPE;
   nQTDMOV                       TW_INV_FIS_ICO_SUB.QTDMOV%TYPE;
   nQTDMOV_NEW                   TW_INV_FIS_ICO_SUB.QTDMOV%TYPE;
   nVLRMOV                       TW_INV_FIS_ICO_SUB.VLRMOV%TYPE;
   nVLRITE                       TW_INV_FIS_ICO_SUB.VLRITE%TYPE;
   nVLRDES                       TW_INV_FIS_ICO_SUB.VLRDES%TYPE;
   nDESRAT                       TW_INV_FIS_ICO_SUB.DESRAT%TYPE;
   nOUTTAX                       TW_INV_FIS_ICO_SUB.OUTTAX%TYPE;
   nVLRFRE                       TW_INV_FIS_ICO_SUB.VLRFRE%TYPE;
   nBASICM                       TW_INV_FIS_ICO_SUB.BASICM%TYPE;
   nICMITE                       TW_INV_FIS_ICO_SUB.ICMITE%TYPE;
   nTAX001                       TW_INV_FIS_ICO_SUB.TAX001%TYPE;
   nVLRICM                       TW_INV_FIS_ICO_SUB.VLRICM%TYPE;
   nMVACOM                       TW_INV_FIS_ICO_SUB.MVACOM%TYPE;
   nBASSUB                       TW_INV_FIS_ICO_SUB.BASSUB%TYPE;
   nVLR_ST                       TW_INV_FIS_ICO_SUB.VLR_ST%TYPE;
   nICMVEN                       TW_INV_FIS_ICO_SUB.ICMVEN%TYPE;
   nBASRET                       TW_INV_FIS_ICO_SUB.BASRET%TYPE;
   nVLRRET                       TW_INV_FIS_ICO_SUB.VLRRET%TYPE;
   nIPIITE                       TW_INV_FIS_ICO_SUB.IPIITE%TYPE;
   nVLRIPI                       TW_INV_FIS_ICO_SUB.VLRIPI%TYPE;
   nOUTICM                       TW_INV_FIS_ICO_SUB.OUTICM%TYPE;
   nISEICM                       TW_INV_FIS_ICO_SUB.ISEICM%TYPE;
   cRETSUB                       TW_INV_FIS_ICO_SUB.RETSUB%TYPE;
   cNATURE                       TW_INV_FIS_ICO_SUB.NATURE%TYPE;
   cCODCST                       TW_INV_FIS_ICO_SUB.CODCST%TYPE;
   cCODORI                       TW_INV_FIS_ICO_SUB.CODORI%TYPE;
   cCHAVEA                       TW_INV_FIS_ICO_SUB.CHAVEA%TYPE;

   -- Busca procudos do Inventrio
   crProdutosInventario CURSOR FOR
   SELECT INV.SESSION_ID, INV_PRO.CODFIL, TRUNC(LAST_DAY(ADD_MONTHS(INV.DATINI, -1))) AS DATINV, INV_PRO.FILMAT, INV_PRO.CODMAT, INV_PRO.CODCOR, INV_PRO.CODTAM, INV_PRO.QTDSAL
     FROM TW_INV_FIS INV
     JOIN TW_INV_FIS_PRO_SUB INV_PRO ON INV_PRO.SESSION_ID = INV.SESSION_ID AND INV_PRO.CODFIL = INV.CODFIL
    WHERE INV.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL);

   -- Busca a ltimas compras de composio do estoque
   crCOMPRAS CURSOR(pCodFil TD_FIL.CODFIL%TYPE,
           pDatIni Timestamp,
           pDatFim Timestamp,
           pFilMat TT_GRA.FILMAT%TYPE,
           pCodMat TT_GRA.CODMAT%TYPE,
           pCodCor TT_GRA.CODCOR%TYPE,
           pCodTam TT_GRA.CODTAM%TYPE) IS
   SELECT   ICO.SEQUEN, ICO.NUMITE, COM.FILFOR, COM.CODFOR, COM.FILEND, COM.NUMEND,
            CAST(COALESCE(COALESCE(FIS.MODNOT, DCFO_COM.CFOMOD), '01') AS CHAR(2)) AS MODNOT, COM.CODSER, COM.SUBSER, COM.NUMNOT, COM.DATCMP, COM.DATOPE, COM.VLRTOT AS COM_VLRTOT, COM.BASSUB AS COM_BASSUB, COM.SUBSTT AS COM_SUBSTT, COM.BASICM AS COM_BASICM, COM.DESCON AS COM_DESCON,
            ICO.EMBORI, ICO.EMBQTD, ICO.TIPPRO, ICO.ICMTIP, ICO.UNICOM,
            ICO.QTDCOM, ICO.QTDMOV, ICO.VLRMOV, CAST(COALESCE(ICO.VLRITE, ICO.VLRMOV) AS Numeric(12,2)) AS VLRITE,
            CAST(((COALESCE(ICO.VLRITE, ICO.VLRMOV) / ICO.VLRMOV) / ICO.QTDMOV) AS Numeric(14,2)) AS VLRDES, CAST(0.00 AS Numeric(14,2)) AS DESRAT,
            ICO.ICO_OUTTAX AS OUTTAX, ICO.ICO_VLRFRE AS VLRFRE, 
            /* BASE DE CALCULO DE ICMS */
            CAST(CASE WHEN TRA.SEQIVE IS NOT NULL THEN COALESCE(ICO.BASICMDIF, CASE WHEN (COALESCE(IVE.TAX001,0) = 0) OR (VEN.TRIBUT = 'F') THEN 0
                                                                                    ELSE CASE WHEN IUF.REDALI IS NOT NULL THEN IVE.VLRMOV * ((COALESCE(COM.DESCON,0)/COM.VLRTOT)*100) - (IVE.VLRMOV * (IRE.ICMSRE/100)) * ((COALESCE(COM.DESCON,0)/COM.VLRTOT)*100)
                                                                                              ELSE (IVE.VLRMOV - ROUND((IVE.VLRMOV * IVE.REDITE / 100),2))
                                                                                         END
                                                                               END, 0)
                      ELSE CASE WHEN ICO.ICMTIP = '3' THEN 0
                                ELSE COALESCE(ICO.BASICMDIF, 0)
                           END
                 END AS Numeric(14,2)) AS BASICM,
            /* BASE DE CALCULO DE ICMS SUBSTITUIDO */
            CAST(CASE WHEN ICO.ICMTIP = '3' THEN ROUND(COALESCE(ICO.BASSUB, COALESCE(COM.BASSUB,0) * (COALESCE(ICO.VLRMOV,0) + COALESCE(ICO.VLRIPI,0)) / COALESCE(COM.VLRTOT,0)),2)
                      ELSE 0
                 END AS Numeric(14,2)) AS BASSUB,
            /* VALOR DE ICMS SUBSTITUIDO*/
            CAST(CASE WHEN ICO.ICMTIP = '3' THEN ROUND(COALESCE(ICO.VLR_ST, COALESCE(COM.SUBSTT,0) * (COALESCE(ICO.VLRMOV,0) + COALESCE(ICO.VLRIPI,0)) / COALESCE(COM.VLRTOT,0)),2)
                      ELSE 0
                 END AS Numeric(14,2)) AS VLR_ST,
            /* ALIQUOTA DE ICMS SUBSTITUIDO*/
            CAST(CASE WHEN ICO.ICMTIP = '3' THEN ICO.ICMVENDIF
                      ELSE 0
                 END AS Numeric(6,4)) AS ICMVEN,
            /* ALIQUOTA DE ICMS */
            CAST(CASE WHEN ICO.ICMTIP = '3' THEN 0
                      ELSE ICO.ICMITEDIF
                 END AS Numeric(14,2)) AS ICMITE,
            CAST(CASE WHEN ICO.ICMTIP = '3' THEN 0
                      ELSE IVE.TAX001
                 END AS Numeric(7,4)) AS TAX001,
            /* VALOR DE IPI, SOMENTE PARA PRODUTOS TRIBUTADOS */
            CAST(CASE WHEN ICO.TIPPRO = '0' THEN COALESCE(ICO.VLRIPI,0)
                      ELSE 0
                 END AS Numeric(14,2)) AS VLRIPI,
            ICO.VLRICMDIF AS VLRICM, CAST(COALESCE(ICO.MVACOMDIF,0) AS Numeric(14,4)) AS MVACOM, ICO.ICO_BASRET AS BASRET, ICO.ICO_VLRRET AS VLRRET, ICO.IPIITE, ICO.OUTICM,
            ICO.ISEICM, ICO.RETSUB,
            CAST(CASE WHEN TRA.SEQIVE IS NOT NULL THEN CASE WHEN SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, DNAT.NATDEN, DNAT.NATFOR, VEN.SUBSTT)),1,1) = '5'
                                                             THEN '1'||SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, DNAT.NATDEN, DNAT.NATFOR, VEN.SUBSTT)),2,3)
                                                            WHEN SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, DNAT.NATDEN, DNAT.NATFOR, VEN.SUBSTT)),1,1) = '6'
                                                             THEN '2'||SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, DNAT.NATDEN, DNAT.NATFOR, VEN.SUBSTT)),2,3)
                                                            ELSE ''
                                                       END
                      ELSE CASE WHEN SUBSTR(COALESCE(DCFO_ICO.CODCFO, DCFO_COM.CODCFO),1,1) = '5' THEN '1'||SUBSTR(COALESCE(DCFO_ICO.CODCFO, DCFO_COM.CODCFO),2,3)
                                WHEN SUBSTR(COALESCE(DCFO_ICO.CODCFO, DCFO_COM.CODCFO),1,1) = '6' THEN '2'||SUBSTR(COALESCE(DCFO_ICO.CODCFO, DCFO_COM.CODCFO),2,3)
                                ELSE COALESCE(DCFO_ICO.CODCFO, DCFO_COM.CODCFO)
                           END
                 END AS VARCHAR(6)) AS NATURE,
            CAST(CASE WHEN ICO.CODCSTDIF IS NOT NULL THEN CASE WHEN LENGTH(TRIM(ICO.CODCSTDIF)) = 2  THEN TO_CHAR(COALESCE(ICO.CODORI,0))||COALESCE(TRIM(ICO.CODCSTDIF),'00')
                                                               ELSE COALESCE(ICO.CODCSTDIF, '000')
                                                          END
                      ELSE CASE WHEN ICO.ICMTIP = '3' AND ICO.VLRICMDIF > 0 THEN TO_CHAR('010')
                                WHEN ICO.ICMTIP = '3' AND ICO.VLRICMDIF = 0 THEN TO_CHAR('060')
                                WHEN ICO.ICMTIP = '2' THEN TO_CHAR('040')
                                ELSE TO_CHAR('000')
                           END
                 END AS VARCHAR(3)) AS CODCST,
            COALESCE(ICO.CODORI, 0) AS CODORI, COM.CHAVEA
     FROM TT_ICO ICO
     JOIN TT_COM COM ON COM.CODFIL = ICO.CODFIL AND COM.SEQUEN = ICO.SEQUEN
     JOIN TD_FIL DFIL ON DFIL.CODFIL = ICO.CODFIL
     LEFT JOIN TD_CFO DCFO_COM ON DCFO_COM.CODTAB = COM.CODCFO
     LEFT JOIN TD_CFO DCFO_ICO ON DCFO_ICO.CODTAB = ICO.CODCFO
     LEFT JOIN (SELECT DISTINCT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '###' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT, ORIGEM
                 FROM TT_FIS
                WHERE ORIGEM = 'C' AND EXPORT = 'T') FIS ON FIS.CODSER = COM.CODSER AND FIS.SUBSER = COALESCE(COM.SUBSER,'###') AND FIS.ORIGEM = CASE WHEN COALESCE(COM.TIPPAR, 'F') = 'T' THEN 'F' ELSE 'C' END
     /* Dados da Nota de Origem da Transferncia */
     LEFT JOIN TT_TRA TRA ON TRA.FILICO = ICO.CODFIL AND TRA.SEQICO = ICO.SEQUEN AND TRA.NUMICO = ICO.NUMITE
     LEFT JOIN TT_IVE IVE ON IVE.CODFIL = TRA.FILIVE AND IVE.SEQUEN = TRA.SEQIVE AND IVE.NUMITE = TRA.NUMIVE
     LEFT JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
     LEFT JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
     LEFT JOIN TT_IUF IUF ON IUF.FILMAT = ICO.FILMAT AND IUF.CODMAT = ICO.CODMAT AND IUF.REGESP = DFIL.REGESP AND IUF.ESTADO = DFIL.UFLOJA
     LEFT JOIN TD_IRE IRE ON IRE.CODTAB = IUF.REDALI
    WHERE ICO.CODFIL = pCodFil
      AND ICO.FILMAT = pFilMat
      AND ICO.CODMAT = pCodMat
      AND ICO.CODCOR = pCodCor
      AND ICO.CODTAM = pCodTam
      AND ICO.COM_DATOPE BETWEEN pDatIni AND pDatFim
      AND ICO.LANEST = 'S'
      AND ICO.BASSUB > 0
      AND COM.FLGEST <> 'D'
      AND COM.NUMNOT NOT LIKE '%#%'
      AND COALESCE(COM.TIPPAR, 'F') <> 'T'
    ORDER BY ICO.COM_DATOPE DESC;

    -- Busca a Data do primeiro Movimento
   MovtoInicial CURSOR(pFilMatMov TT_GRA.FILMAT%TYPE,
           pCodMatMov TT_GRA.CODMAT%TYPE,
           pCodCorMov TT_GRA.CODCOR%TYPE,
           pCodTamMov TT_GRA.CODTAM%TYPE,
           pCodFilMov VARCHAR) IS
   SELECT MIN( RMOV.DATMOV )
     FROM TR_MOV RMOV
    WHERE RMOV.FILMAT = pFilMatMov
      AND RMOV.CODMAT = pCodMatMov
      AND RMOV.CODCOR = pCodCorMov
      AND RMOV.CODTAM = pCodTamMov
      AND RMOV.CODFIL = pCodFilMov;

-- Incio da funo
BEGIN

   --BEGIN
   /* Inicio - Processamento produtos do Inventrio */
   OPEN crProdutosInventario;
   LOOP
      FETCH crProdutosInventario INTO nSESSIONID, cCODFIL, dDataInventario, cFILMAT, cCODMAT, nCODCOR, nCODTAM, nQTDSAL;
      EXIT WHEN NOT FOUND;

      -- Inicializa nmero de meses a cada produto para buscar sempre iniciando da data do inventrio.
      nNumMeses := 1;

      -- Procura a primeira movimentacao do produto
      OPEN MovtoInicial(cFILMAT, cCODMAT, nCODCOR, nCODTAM, cCODFIL);
      FETCH MovtoInicial INTO dPrimeiroLancto;
      IF NOT FOUND THEN
         dPrimeiroLancto := Agora();
      END IF;
      CLOSE MovtoInicial;

      /* Inicio - Processa Compras */

      /* Inicio - Processa lanamentos mensalmente at atender ao saldo em estoque */
      LOOP
         -- Ajustando o periodo com as horas
         dDatIniPer := TO_DATE(TO_CHAR(TRUNC(ADD_DAY(LAST_DAY(ADD_MONTHS(dDataInventario, nNumMeses * (-1))), 1)), 'DD/MM/YYYY')||' 00:00:00', 'DD/MM/YYYY HH24:MI:SS');
         dDatFimPer := TO_DATE(TO_CHAR(TRUNC(LAST_DAY(dDatIniPer)), 'DD/MM/YYYY')||' 23:59:59', 'DD/MM/YYYY HH24:MI:SS');

         -- Se data da primeira movimentacao do produto superior a data final no tem dados de entradas a serem pesquisadas mesmo que saldo ainda no tenha sido atendido
         IF dPrimeiroLancto > dDatFimPer THEN
            nNumMeses := 999;
         ELSE
            OPEN crCOMPRAS(cCODFIL, dDatIniPer, dDatFimPer, cFILMAT, cCODMAT, nCODCOR, nCODTAM);
            LOOP
               FETCH crCOMPRAS INTO cSEQUEN, nNUMITE,
                                    cFILFOR, cCODFOR, cFILEND, nNUMEND,
                                    cMODNOT, cCODSER, cSUBSER, cNUMNOT, dDATCMP, dDATOPE, nCOM_VLRTOT, nCOM_BASSUB, nCOM_SUBSTT, nCOM_BASICM, nCOM_DESCON,
                                    nEMBORI, nEMBQTD, cTIPPRO, cICMTIP, cUNICOM,
                                    nQTDCOM, nQTDMOV, nVLRMOV, nVLRITE,
                                    nVLRDES, nDESRAT,
                                    nOUTTAX, nVLRFRE, nBASICM, nBASSUB, nVLR_ST, nICMVEN, nICMITE, nTAX001,
                                    nVLRIPI, nVLRICM, nMVACOM, nBASRET, nVLRRET, nIPIITE, nOUTICM,
                                    nISEICM, cRETSUB, cNATURE, cCODCST, cCODORI, cCHAVEA;

               EXIT WHEN NOT FOUND OR (nQTDSAL <= 0);

               -- Recalcula valores com base na quantidade
               IF (COALESCE(nQTDMOV, 0) > nQTDSAL) THEN
                  nQTDMOV_NEW := nQTDSAL;
                  nVLRMOV := ROUND((nVLRMOV / nQTDMOV) * nQTDMOV_NEW, 2);
                  nVLRITE := ROUND((nVLRITE / nQTDMOV) * nQTDMOV_NEW, 2);
                  nVLRDES := ROUND((nVLRDES / nQTDMOV) * nQTDMOV_NEW, 2);
                  nDESRAT := ROUND((nDESRAT / nQTDMOV) * nQTDMOV_NEW, 2);
                  nOUTTAX := ROUND((nOUTTAX / nQTDMOV) * nQTDMOV_NEW, 2);
                  nVLRFRE := ROUND((nVLRFRE / nQTDMOV) * nQTDMOV_NEW, 2);
                  nBASICM := ROUND((nBASICM / nQTDMOV) * nQTDMOV_NEW, 2);
                  nVLRICM := ROUND((nVLRICM / nQTDMOV) * nQTDMOV_NEW, 2);
                  nBASSUB := ROUND((nBASSUB / nQTDMOV) * nQTDMOV_NEW, 2);
                  nVLR_ST := ROUND((nVLR_ST / nQTDMOV) * nQTDMOV_NEW, 2);
                  nBASRET := ROUND((nBASRET / nQTDMOV) * nQTDMOV_NEW, 2);
                  nVLRRET := ROUND((nVLRRET / nQTDMOV) * nQTDMOV_NEW, 2);
                  nVLRIPI := ROUND((nVLRIPI / nQTDMOV) * nQTDMOV_NEW, 2);
                  nOUTICM := ROUND((nOUTICM / nQTDMOV) * nQTDMOV_NEW, 2);
                  nISEICM := ROUND((nISEICM / nQTDMOV) * nQTDMOV_NEW, 2);
               ELSE
                  nQTDMOV_NEW := nQTDMOV;
               END IF;

               -- Retira a quantidade movimentada
               nQTDSAL := nQTDSAL - nQTDMOV_NEW;

               /* Insere registro na TW_INV_FIS_ICO_SUB */
               INSERT INTO TW_INV_FIS_ICO_SUB (SESSION_ID, CODFIL, SEQUEN, NUMITE,
                                                FILFOR, CODFOR, FILEND, NUMEND,
                                                MODNOT, CODSER, SUBSER, NUMNOT, DATCMP, DATOPE, COM_VLRTOT, COM_BASSUB, COM_SUBSTT, COM_BASICM, COM_DESCON,
                                                FILMAT, CODMAT, CODTAM, CODCOR, EMBORI, EMBQTD, TIPPRO, ICMTIP, UNICOM,
                                                QTDCOM, QTDMOV, VLRMOV, VLRITE,
                                                VLRDES, DESRAT,
                                                OUTTAX, VLRFRE, BASICM, ICMITE, TAX001,
                                                VLRICM, MVACOM, BASSUB, VLR_ST, ICMVEN, BASRET, VLRRET, IPIITE, VLRIPI, OUTICM,
                                                ISEICM, RETSUB, NATURE, CODCST, CODORI, CHAVEA )
                                       VALUES  (nSESSIONID, cCODFIL, cSEQUEN, nNUMITE,
                                                cFILFOR, cCODFOR, cFILEND, nNUMEND,
                                                cMODNOT, cCODSER, cSUBSER, cNUMNOT, dDATCMP, dDATOPE, nCOM_VLRTOT, nCOM_BASSUB, nCOM_SUBSTT, nCOM_BASICM, nCOM_DESCON,
                                                cFILMAT, cCODMAT, nCODCOR, nCODTAM, nEMBORI, nEMBQTD, cTIPPRO, cICMTIP, cUNICOM,
                                                nQTDCOM, nQTDMOV_NEW, nVLRMOV, nVLRITE,
                                                nVLRDES, nDESRAT,
                                                nOUTTAX, nVLRFRE, nBASICM, nICMITE, nTAX001,
                                                nVLRICM, nMVACOM, nBASSUB, nVLR_ST, nICMVEN, nBASRET, nVLRRET, nIPIITE, nVLRIPI, nOUTICM,
                                                nISEICM, cRETSUB, cNATURE, cCODCST, cCODORI, cCHAVEA
                                                );

            END LOOP;
            CLOSE crCOMPRAS;

            nNumMeses := nNumMeses + 1;
         END IF;

         EXIT WHEN ((nQTDSAL <= 0) OR (nNumMeses = 999));
      END LOOP;

      /* Fim - Processa lanamentos mensalmente at atender ao saldo em estoque */

      /* Fim - Processa Compras */

         END LOOP;

   CLOSE crProdutosInventario;
   /* Fim - Processamento produtos do Inventrio */

   cResultado := 'OK';
   --EXCEPTION
   --   WHEN OTHERS THEN cResultado := SUBSTR(SQLERRM, 1, 4000);
   --END;

   RETURN cResultado;

END;
$$ language 'plpgsql';




/*-- SEQ 0612 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GeraSaldoLote (TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 0613 --*/
CREATE OR REPLACE FUNCTION GeraSaldoLote (TD_FIL.CODFIL%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;

-- Objetivos:
-- 1. Criar os registros na TT_SLT que estiverem faltando de acordo
-- com a matriz de filiais x subestoques.

-- Declarao de variveis e cursores
   cResultado                    VARCHAR(2);

-- Incio da funo
BEGIN

   INSERT INTO TT_SLT (CODFIL, CODMUL, FILLOT, SEQLOT, QTDEST, RESERV)
      (SELECT /*+ INDEX(FIL,PK_DFIL) INDEX(LOT,PK_LOT)  */
              pCODFIL, MUL.CODTAB, LOT.CODFIL, LOT.SEQUEN, 0, 0
         FROM TT_LOT LOT CROSS JOIN TD_MUL MUL
        WHERE MUL.MULATI = 'T'
          AND NOT EXISTS (SELECT /*+ INDEX(SLT,I_UQ_SLT)  */
                                 SLT.FILLOT, SLT.SEQLOT, SLT.CODFIL, SLT.CODMUL
                            FROM TT_SLT SLT
                           WHERE SLT.CODFIL = pCODFIL
                             AND SLT.CODMUL = MUL.CODTAB
                             AND SLT.FILLOT = LOT.CODFIL
                             AND SLT.SEQLOT = LOT.SEQUEN));

   cResultado := 'OK';
   RETURN cResultado;

END;
$$ language 'plpgsql';




/*-- SEQ 0614 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GetLogNaDataTL_PRO (TL_PRO.FILMAT%TYPE,TL_PRO.CODMAT%TYPE,TL_GRA.DATOPE%TYPE,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 0615 --*/
CREATE OR REPLACE FUNCTION GetLogNaDataTL_PRO (TL_PRO.FILMAT%TYPE,TL_PRO.CODMAT%TYPE,TL_GRA.DATOPE%TYPE,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pFilMat ALIAS FOR $1 ;
pCodMat ALIAS FOR $2 ;
pDatOpe ALIAS FOR $3 ;
pChaveBusca ALIAS FOR $4 ;
pValorPadrao ALIAS FOR $5 ;

   cResultado              VARCHAR(200);
   vMsgLog                 TL_PRO.MSGLOG%TYPE;

BEGIN

   vMsgLog := '';

         SELECT SUBSTR(LPRO.MSGLOG, INSTR(LPRO.MSGLOG,pChaveBusca),LENGTH(LPRO.MSGLOG))
        INTO vMsgLog
        FROM TL_PRO LPRO
       WHERE LPRO.FILMAT = pFilMat
         AND LPRO.CODMAT = pCodMat
         AND LPRO.MSGLOG LIKE '%'||pChaveBusca||'%'
         AND LPRO.DATOPE = (SELECT MIN(SUB.DATOPE)
                              FROM TL_PRO SUB
                             WHERE SUB.FILMAT = pFilMat
                               AND SUB.CODMAT = pCodMat
                               AND SUB.DATOPE > pDatOpe
                               AND SUB.MSGLOG LIKE '%'||pChaveBusca||'%')
       ORDER BY LPRO.CODTAB;
   
   IF vMsgLog = '' OR vMsgLog IS NULL THEN
      cResultado := pValorPadrao;
   ELSE
      vMsgLog    := REPLACE(vMsgLog, pChaveBusca, '');
      cResultado := SUBSTR(vMsgLog, 1, INSTR(vMsgLog, ' para '));
   END IF;

RETURN cResultado;

END;
$$ language 'plpgsql';




/*-- SEQ 0616 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GetUidAtual () CASCADE;

/*-- SEQ 0617 --*/
CREATE OR REPLACE FUNCTION GetUidAtual ()
RETURNS TPC_UID_Retorno AS $$
DECLARE


-- Objetivos:
-- 1. Retorna o CODUID atual do usurio logado

-- Declarao de variveis e cursores
   
   
   Retorno TPC_UID_Retorno%ROWTYPE;
  
-- Incio da funo
BEGIN
   Retorno.CODUID      := NULL;
   Retorno.ASSINS      := NULL;
   Retorno.BLQ_SEM_UID := NULL;

   BEGIN
      SELECT TMP.CODUID, TMP.ASSINS, CFG.BLQ_SEM_UID
        INTO Retorno.CODUID, Retorno.ASSINS, Retorno.BLQ_SEM_UID
        FROM TMP_UID TMP CROSS JOIN TT_CFG CFG;
        
        Retorno.ASSINS := 'F';
   EXCEPTION
      WHEN OTHERS THEN
         Retorno.CODUID      := NULL;
         Retorno.ASSINS      := NULL;
         Retorno.BLQ_SEM_UID := NULL;
   END;

/*
      SELECT TUID.CODUID, TUID.ASSINS, CFG.BLQ_SEM_UID
      INTO Retorno.CODUID, Retorno.ASSINS, Retorno.BLQ_SEM_UID
      FROM TT_UID TUID CROSS JOIN TT_CFG CFG
     WHERE TUID.SESSION_ID = USERENV('SESSIONID')
       AND TUID.TERMIN     = 'F'
       LIMIT 1;
  */

   RETURN Retorno;

END;
$$ language 'plpgsql';





/*-- SEQ 0618 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GXSessionID(Retorno out VARCHAR);

/*-- SEQ 0619 --*/
CREATE FUNCTION GXSessionID(Retorno out VARCHAR) AS $$
BEGIN
  SELECT USERENV('SESSIONID')
    INTO Retorno
    FROM DUAL;
END;
$$ LANGUAGE plpgsql;


/*-- SEQ 0620 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IncluiItemTransfAutom (TT_IOR.CODFIL%TYPE,TT_IOR.FILRES%TYPE,TT_VEN.SEQUEN%TYPE,TT_COM.SEQUEN%TYPE,TT_IOR.FILMAT%TYPE,TT_IOR.CODMAT%TYPE,TT_IOR.CODCOR%TYPE,TT_IOR.CODTAM%TYPE,TT_IOR.QTDITE%TYPE,TT_IOR.VLRITE%TYPE,TT_IOR.CODMUL%TYPE,TT_IOR.FILIVE%TYPE,TT_IOR.SEQIVE%TYPE,TT_IOR.NUMIVE%TYPE,TT_IOR.FILLOT%TYPE,TT_IOR.SEQLOT%TYPE,TT_IVE.NUMEXT%TYPE) CASCADE;

/*-- SEQ 0621 --*/
CREATE OR REPLACE FUNCTION IncluiItemTransfAutom (TT_IOR.CODFIL%TYPE,TT_IOR.FILRES%TYPE,TT_VEN.SEQUEN%TYPE,TT_COM.SEQUEN%TYPE,TT_IOR.FILMAT%TYPE,TT_IOR.CODMAT%TYPE,TT_IOR.CODCOR%TYPE,TT_IOR.CODTAM%TYPE,TT_IOR.QTDITE%TYPE,TT_IOR.VLRITE%TYPE,TT_IOR.CODMUL%TYPE,TT_IOR.FILIVE%TYPE,TT_IOR.SEQIVE%TYPE,TT_IOR.NUMIVE%TYPE,TT_IOR.FILLOT%TYPE,TT_IOR.SEQLOT%TYPE,TT_IVE.NUMEXT%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pFILRES ALIAS FOR $2 ;
pSEQVEN ALIAS FOR $3 ;
pSEQCOM ALIAS FOR $4 ;
pFILMAT ALIAS FOR $5 ;
pCODMAT ALIAS FOR $6 ;
pCODCOR ALIAS FOR $7 ;
pCODTAM ALIAS FOR $8 ;
pQTDITE ALIAS FOR $9 ;
pVLRITE ALIAS FOR $10 ;
pCODMUL ALIAS FOR $11 ;
pFILORI ALIAS FOR $12 ;
pNUMORI ALIAS FOR $13 ;
pITEORI ALIAS FOR $14 ;
pFILLOT ALIAS FOR $15 ;
pSEQLOT ALIAS FOR $16 ;
pNUMEXT ALIAS FOR $17 ;

  -- Objetivos:
  -- 1. Criar sada e entrada de transferncia automtica.

  -- Declarao de variveis e cursores
  c_RESULTADO           VARCHAR(2);
  vComplemento          constant VARCHAR(100) := constante('complemento');
  iCODCFO TT_CFG.TRANSFER_CODCFO%TYPE;
  vNUMIVE TT_IVE.NUMITE%TYPE;
  vNUMICO TT_ICO.NUMITE%TYPE;
  vTIPPRO TT_PRO.TIPPRO%TYPE;
  VVALCON TT_PRO.VALCON%TYPE;
  vUNICOM TT_GRA.UNIFOR%TYPE;
  vUNIVEN TT_GRA.UNIDAD%TYPE;

BEGIN

  SELECT TRANSFER_CODCFO INTO iCODCFO
    FROM TT_CFG;

  SELECT COALESCE(MAX(NUMITE),0)+1 INTO vNUMIVE
    FROM TT_IVE
   WHERE CODFIL=pFILRES
     AND SEQUEN=pSEQVEN;

  INSERT INTO TT_IVE
         (CODFIL,SEQUEN,NUMITE,FILMAT,CODMAT,CODCOR,CODTAM,QTDMOV,VLRMOV,SITKIT,ICMTIP, LANEST,CODMUL,
          FILORI, NUMORI, ITEORI, FILLOT, SEQLOT, NUMEXT)
         VALUES
         (pFILRES,pSEQVEN,vNUMIVE,pFILMAT,pCODMAT,pCODCOR,pCODTAM,pQTDITE,pVLRITE*pQTDITE,2,1,'S',pCODMUL,
          pFILORI, pNUMORI, pITEORI, pFILLOT, pSEQLOT, pNUMEXT);

  SELECT COALESCE(MAX(NUMITE),0)+1 INTO vNUMICO
    FROM TT_ICO
   WHERE CODFIL=pCODFIL
     AND SEQUEN=pSEQCOM;

  SELECT TIPPRO,
         CASE WHEN VALCON<=0 THEN 1
                             ELSE VALCON
         END AS VALCON INTO vTIPPRO,vVALCON
    FROM TT_PRO
   WHERE FILMAT=pFILMAT
     AND CODMAT=pCODMAT;

  SELECT UNIDAD, UNIFOR INTO vUNIVEN,vUNICOM
    FROM TT_GRA
   WHERE FILMAT=pFILMAT
     AND CODMAT=pCODMAT
     AND CODCOR=pCODCOR
     AND CODTAM=pCODTAM;

  INSERT INTO TT_ICO
         (CODFIL,SEQUEN,NUMITE,SITMOV,FILMAT,CODMAT,CODCOR,CODTAM,QTDMOV,VLRMOV,CODMOE,
          LANEST,TIPPRO,QTDCOM,UNICOM,UNIVEN,VALCON,CODMUL,CODCFO, FILLOT, SEQLOT) VALUES
         (pCODFIL,pSEQCOM,vNUMICO,'N',pFILMAT,pCODMAT,pCODCOR,pCODTAM,pQTDITE*vVALCON,pVLRITE*pQTDITE,0,
         'S',vTIPPRO,pQTDITE,vUNICOM,vUNIVEN,vVALCON,pCODMUL,iCODCFO, pFILLOT, pSEQLOT);

  UPDATE TT_TRA
     SET FILICO=pCODFIL,
         SEQICO=pSEQCOM,
         NUMICO=vNUMICO
   WHERE FILIVE=pFILRES
     AND SEQIVE=pSEQVEN
     AND NUMIVE=vNUMIVE;

  c_RESULTADO := 'OK';
  RETURN c_RESULTADO;

END;
$$ language 'plpgsql';




/*-- SEQ 0622 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION InsereAuditoriaPreco (TD_FIL.CODFIL%TYPE,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_PRE.PRECOV%TYPE,TT_PRE.PRECOV%TYPE) CASCADE;

/*-- SEQ 0623 --*/
CREATE OR REPLACE FUNCTION InsereAuditoriaPreco (TD_FIL.CODFIL%TYPE,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_PRE.PRECOV%TYPE,TT_PRE.PRECOV%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCodfil ALIAS FOR $1 ;
pFilmat ALIAS FOR $2 ;
pCodmat ALIAS FOR $3 ;
pCodcor ALIAS FOR $4 ;
pCodtam ALIAS FOR $5 ;
pOldPrecoV ALIAS FOR $6 ;
pNewPrecoV ALIAS FOR $7 ;
-- Registrar auditoria quando o parmetro estiver ativo
-- Se houver auditoria "acrescenta" produto, se no tiver, inclui nova auditoria
  wk_Descricao VARCHAR(150); -- Desmat = 30 e espmat = 30 de tamanho
  wk_PossuiAuditoria Integer;
  wk_QtdProdutosAlterados Integer;
  wk_MsgAuditoria TT_LCF.MSGERR%TYPE;
    
  CRLF CONSTANT CHAR(1)   := CHR(10);
  iNulo CONSTANT Numeric(1) := 0;
BEGIN
  IF LeParametroBoo('AVISA_PRECOEFETIVADO','','','','')='F' THEN
    RETURN NULL;
  END IF;
  
  SELECT DESMAT || '-' || COALESCE(ESPMAT, '')
    INTO wk_Descricao
    FROM TT_PRO
   WHERE FILMAT = pFILMAT
     AND CODMAT = pCODMAT;
  
      SELECT COUNT(*)
      INTO wk_PossuiAuditoria
      FROM TT_LCF
     WHERE TIPOPE = UPPER('PRECONOVO')
       AND COALESCE(FLGEXE, 'F') = 'F';    
    
   IF wk_PossuiAuditoria > 0 THEN 
           SELECT MSGERR
        INTO wk_MsgAuditoria
        FROM TT_LCF
       WHERE TIPOPE = UPPER('PRECONOVO')
         AND COALESCE(FLGEXE, 'F') = 'F'
             LIMIT 1       ;    
        
     
     -- MN - Descobre a quantidade de produtos alterados anteriormente
     wk_QtdProdutosAlterados := TO_NUMBER(SUBSTR(wk_MsgAuditoria, 1, INSTR(wk_MsgAuditoria, ' ') - 1)) ;
     wk_QtdProdutosAlterados := wk_QtdProdutosAlterados + 1;
     wk_MsgAuditoria         := SUBSTR(TO_CHAR(wk_QtdProdutosAlterados) || ' Produtos Alterados.' || CRLF || SUBSTR(wk_MsgAuditoria, INSTR(wk_MsgAuditoria, CRLF)+1, LENGTH(wk_MsgAuditoria))|| CRLF, 1, 32000);
     wk_MsgAuditoria         := SUBSTR(wk_MsgAuditoria || wk_Descricao || '. Preo de '||COALESCE(pOldPrecoV, iNulo)||' para '||COALESCE(pNewPrecoV,iNulo), 1, 32000);
     
     UPDATE TT_LCF   
        SET MSGERR = wk_MsgAuditoria
      WHERE TIPOPE = UPPER('PRECONOVO')
        AND COALESCE(FLGEXE, 'F') = 'F';        
   ELSE
     wk_MsgAuditoria  := '1 Produto Alterado.' || CRLF || wk_Descricao || '. Preo de '||COALESCE(pOldPrecoV, iNulo)||' para '||COALESCE(pNewPrecoV,iNulo);
     
     INSERT INTO TT_LCF (CODFIL, TIPOPE, FLGEST, NUMECF, CUPFIS, DATHOR, MSGERR, CODSER) VALUES
                        (pCodfil, 'PRECONOVO', 'T', 'XXX', 'XX', AGORA(), wk_MsgAuditoria,  'XX');
   END IF;
  
  return null;
END;
$$ language 'plpgsql';




/*-- SEQ 0624 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Insere_MASS (TM_ASS.TABELA%TYPE) CASCADE;

/*-- SEQ 0625 --*/
CREATE OR REPLACE FUNCTION Insere_MASS (TM_ASS.TABELA%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pTABELA ALIAS FOR $1 ;
BEGIN
    
    IF pTABELA IS NULL THEN 
       RAISE EXCEPTION 'PG-20000 Obrigatrio informar tabela.';
    END IF;

    INSERT INTO TM_ASS
         (TABELA, FLGEST) VALUES 
         (pTABELA, 'N');
         
    RETURN 'OK';
    
END;
$$ language 'plpgsql';




/*-- SEQ 0626 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Insere_MATU (TM_ATU.ORITAB%TYPE,TM_ATU.NOMTAB%TYPE,TM_ATU.FILTRO%TYPE) CASCADE;

/*-- SEQ 0627 --*/
CREATE OR REPLACE FUNCTION Insere_MATU (TM_ATU.ORITAB%TYPE,TM_ATU.NOMTAB%TYPE,TM_ATU.FILTRO%TYPE)
RETURNS CHAR AS $$
DECLARE
pTabelaOrigem ALIAS FOR $1 ;
pTabela ALIAS FOR $2 ;
pWhere ALIAS FOR $3 ;
-- Objetivos:
-- 1. Atualizar coluna ATU_EM
   cSQL                          VARCHAR(4000);
-- Início da função
BEGIN
   IF ISNULL(pTabelaOrigem)='T' THEN 
      RAISE EXCEPTION 'PG-20000 Obrigatório informar tabela de origem.';
   END IF;
   IF ISNULL(pTabela)='T' THEN 
      RAISE EXCEPTION 'PG-20000 Obrigatório informar tabela.';
   END IF;
     
   
      cSQL := 'UPDATE ' || pTabela || ' SET ATU_EM = AGORA()';
      IF ISNOTNULL(pWhere) = 'T' THEN
         cSQL := cSQL || ' WHERE ' || pWhere;
      END IF;
      cSQL := cSQL || ';';
      EXECUTE cSQL;
   
   RETURN 'OK';

END;
$$ language 'plpgsql';


/*-- SEQ 0628 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Insere_MATU (TM_ATU.ORITAB%TYPE,TM_ATU.NOMTAB%TYPE) CASCADE;

/*-- SEQ 0629 --*/
CREATE OR REPLACE FUNCTION Insere_MATU (TM_ATU.ORITAB%TYPE,
                               TM_ATU.NOMTAB%TYPE) 
RETURNS CHAR AS $$
BEGIN
RETURN Insere_MATU($1,$2,null);
END;
$$ language 'plpgsql';


/*-- SEQ 0630 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IsFeriadoAberto (TT_FER.FILFER%TYPE,Timestamp) CASCADE;

/*-- SEQ 0631 --*/
CREATE OR REPLACE FUNCTION IsFeriadoAberto (TT_FER.FILFER%TYPE,Timestamp)
RETURNS VARCHAR AS $$
DECLARE
p_Filial ALIAS FOR $1 ;
p_Data ALIAS FOR $2 ;

-- Objetivos:
-- 1. Verifcar se o dia é feriado com loja aberta

-- Declaração de variáveis
c_RESULTADO VARCHAR(1);
WK_CONTA    Numeric(10);

-- Início da função
BEGIN

  SELECT COALESCE(COUNT(*),0) INTO WK_CONTA FROM TT_FER
   WHERE ((FILFER IS NULL) OR (FILFER=p_Filial))
     AND DIAFER = TO_NUMBER(TO_CHAR(p_Data,'DD'))
     AND MESFER = TO_NUMBER(TO_CHAR(p_Data,'MM'))
     AND ((ANOFER = TO_NUMBER(TO_CHAR(p_Data,'YYYY'))) OR (ANOFER IS NULL))
     AND LOJABR = 'T';

  IF WK_CONTA > 0 THEN
    c_RESULTADO := 'T';
  ELSE
    c_RESULTADO := 'F';
  END IF;

  RETURN c_RESULTADO;

END;
$$ language 'plpgsql';




/*-- SEQ 0632 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IVO_TotalmenteSeparada (TT_IVO.ORIGEM%TYPE,TT_IVO.FILPED%TYPE,TT_IVO.TIPPED%TYPE,TT_IVO.NUMPED%TYPE,TT_IVO.FILIVE%TYPE,TT_IVO.SEQIVE%TYPE,TT_IVO.FILIPE%TYPE,TT_IVO.NUMIPE%TYPE) CASCADE;

/*-- SEQ 0633 --*/
CREATE OR REPLACE FUNCTION IVO_TotalmenteSeparada (TT_IVO.ORIGEM%TYPE,TT_IVO.FILPED%TYPE,TT_IVO.TIPPED%TYPE,TT_IVO.NUMPED%TYPE,TT_IVO.FILIVE%TYPE,TT_IVO.SEQIVE%TYPE,TT_IVO.FILIPE%TYPE,TT_IVO.NUMIPE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_Origem ALIAS FOR $1 ;
p_FILPED ALIAS FOR $2 ;
p_TIPPED ALIAS FOR $3 ;
p_NUMPED ALIAS FOR $4 ;
p_FILIVE ALIAS FOR $5 ;
p_SEQIVE ALIAS FOR $6 ;
p_FILIPE ALIAS FOR $7 ;
p_NUMIPE ALIAS FOR $8 ;

-- Declarao das variveis
   cSituacaoSeparacao         VARCHAR(1); -- Resultado da funo -> N - No separado | P - Parcialmente Separado | T - Totalmente Separado
   cItemSeparado              VARCHAR(1);
   cItemEmFaltaOuEntregue     VARCHAR(1);
   cItemEntregue              VARCHAR(1);
   cItemOutrasSituacoes       VARCHAR(1);
   cFLGEST                    TT_IVO.FLGEST%TYPE;


-- Declarao dos cursores
CR_Orcamentos CURSOR FOR
   SELECT DISTINCT FLGEST
     FROM TT_IVO
    WHERE FILPED = p_FILPED
      AND TIPPED = p_TIPPED
      AND NUMPED = p_NUMPED;
      
CR_Pedidos CURSOR FOR
   SELECT DISTINCT FLGEST
     FROM TT_IVO
    WHERE FILIPE = p_FILIPE
      AND NUMIPE = p_NUMIPE;

CR_Vendas CURSOR FOR
   SELECT DISTINCT FLGEST
     FROM TT_IVO
    WHERE FILIVE = p_FILIVE
      AND SEQIVE = p_SEQIVE;
    
-- Objetivo:
-- 1) Verificar se o oramento est parcialmente separado ou totalmente separado
BEGIN
   cSituacaoSeparacao      := 'N';
   cItemSeparado           := 'F';
   cItemEmFaltaOuEntregue  := 'F';
   cItemOutrasSituacoes    := 'F';

   -- MN - A Ideia  identificar se uma separao est no separada, separada parcialmente ou totalmente separada
   --      identifica-se a origem para percorrer pela chave correta (oramento/pedido/venda) depois disso, identifica quais situaes
   --      o oramento/pedido/venda  possui, para determinar a situao da separao
   IF p_Origem = 'O' THEN
      OPEN CR_Orcamentos;
      LOOP
         FETCH CR_Orcamentos INTO cFLGEST;
         EXIT WHEN NOT FOUND;

         IF cFLGEST = 'P' THEN
            cItemSeparado := 'T'; 
         ELSIF cFLGEST = 'F' or cFLGEST = 'E' THEN
            cItemEmFaltaOuEntregue := 'T'; 
         ELSE
            cItemOutrasSituacoes := 'T';
         END IF;
      END LOOP;
      CLOSE CR_Orcamentos; 
   ELSIF p_Origem = 'P' THEN
      OPEN CR_Pedidos;
      LOOP
         FETCH CR_Pedidos INTO cFLGEST;
         EXIT WHEN NOT FOUND;

         IF cFLGEST = 'P' THEN
            cItemSeparado := 'T'; 
         ELSIF cFLGEST = 'F' or cFLGEST = 'E' THEN
            cItemEmFaltaOuEntregue := 'T'; 
         ELSE
            cItemOutrasSituacoes := 'T';
         END IF;
      END LOOP;
      CLOSE CR_Pedidos; 
   ELSIF p_Origem = 'V' THEN
      OPEN CR_Vendas;
      LOOP
         FETCH CR_Vendas INTO cFLGEST;
         EXIT WHEN NOT FOUND;

         IF cFLGEST = 'P' THEN
            cItemSeparado := 'T'; 
         ELSIF cFLGEST = 'F' or cFLGEST = 'E' THEN
            cItemEmFaltaOuEntregue := 'T'; 
         ELSE
            cItemOutrasSituacoes := 'T';
         END IF;
      END LOOP;
      CLOSE CR_Vendas; 
   END IF;

   -- MN - Entrando no IF abaixo significa que temos um oramento parcialmente separado ou Totalmente Separado
   IF cItemSeparado = 'T' THEN
      -- MN - Se entrar no if abaixo significa que teve alguma TT_IVO separada, mas teve alguma outra que no estava em Falta
      -- e no era separada, ou seja, esse oramento/venda/pedido no foi totalmente separado
      IF cItemOutrasSituacoes = 'T' THEN
         cSituacaoSeparacao := 'P';
      ELSE
         cSituacaoSeparacao := 'T';
      END IF;
   END IF;

   RETURN COALESCE(cSituacaoSeparacao, 'N');

END;
$$ language 'plpgsql';




/*-- SEQ 0634 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION limpa_especiais (VARCHAR) CASCADE;

/*-- SEQ 0635 --*/
CREATE OR REPLACE FUNCTION limpa_especiais (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
wTexto ALIAS FOR $1 ;
   pTexto VARCHAR(4000);
BEGIN
   ptexto := wtexto;
   ptexto := REPLACE(pTEXTO, '!', ' ');
   ptexto := REPLACE(pTEXTO, '@', ' ');
   ptexto := REPLACE(pTEXTO, '#', ' ');
   ptexto := REPLACE(pTEXTO, '$', ' ');
   ptexto := REPLACE(pTEXTO, '^', ' ');
   ptexto := REPLACE(pTEXTO, '&', ' ');
   ptexto := REPLACE(pTEXTO, '*', ' ');
   ptexto := REPLACE(pTEXTO, '(', ' ');
   ptexto := REPLACE(pTEXTO, ')', ' ');
   ptexto := REPLACE(pTEXTO, '_', ' ');
   ptexto := REPLACE(pTEXTO, '/', ' ');
   ptexto := REPLACE(pTEXTO, '-', ' ');
   ptexto := REPLACE(pTEXTO, '+', ' ');
   ptexto := REPLACE(pTEXTO, '=', ' ');
   ptexto := REPLACE(pTEXTO, '[', ' ');
   ptexto := REPLACE(pTEXTO, ']', ' ');
   ptexto := REPLACE(pTEXTO, '|', ' ');
   ptexto := REPLACE(pTEXTO, ':', ' ');
   ptexto := REPLACE(pTEXTO, ';', ' ');
   ptexto := REPLACE(pTEXTO, '"', ' ');
   ptexto := REPLACE(pTEXTO, '<', ' ');
   ptexto := REPLACE(pTEXTO, '>', ' ');
   ptexto := REPLACE(pTEXTO, ',', ' ');
   ptexto := REPLACE(pTEXTO, '.', ' ');
   ptexto := REPLACE(pTEXTO, '?', ' ');
   ptexto := REPLACE(pTEXTO, '', ' ');
   ptexto := REPLACE(pTEXTO, '', ' ');
   ptexto := REPLACE(pTEXTO, '', 'C');
   ptexto := REPLACE(pTEXTO, '', ' ');
   ptexto := REPLACE(pTEXTO, '', ' ');
   ptexto := REPLACE(pTEXTO, '`', ' ');
   ptexto := REPLACE(pTEXTO, '', 'A');
   ptexto := REPLACE(pTEXTO, '', 'A');
   ptexto := REPLACE(pTEXTO, '', 'E');
   ptexto := REPLACE(pTEXTO, '', 'E');
   ptexto := REPLACE(pTEXTO, '', 'I');
   ptexto := REPLACE(pTEXTO, '', 'I');
   ptexto := REPLACE(pTEXTO, '', 'O');
   ptexto := REPLACE(pTEXTO, '', 'O');
   ptexto := REPLACE(pTEXTO, '', 'U');
   ptexto := REPLACE(pTEXTO, '', 'U');
   ptexto := REPLACE(pTEXTO, '', 'A');
   ptexto := REPLACE(pTEXTO, '', 'A');
   ptexto := REPLACE(pTEXTO, '', 'O');
   ptexto := REPLACE(pTEXTO, '', 'O');
   ptexto := REPLACE(pTEXTO, '', 'A');
   ptexto := REPLACE(pTEXTO, '', 'A');
   ptexto := REPLACE(pTEXTO, '', 'A');
   ptexto := REPLACE(pTEXTO, '', 'E');
   ptexto := REPLACE(pTEXTO, '', 'E');
   ptexto := REPLACE(pTEXTO, '', 'I');
   ptexto := REPLACE(pTEXTO, '', 'I');
   ptexto := REPLACE(pTEXTO, '', 'O');
   ptexto := REPLACE(pTEXTO, '', 'O');
   ptexto := REPLACE(pTEXTO, '', 'U');
   ptexto := REPLACE(pTEXTO, '', 'U');
   ptexto := REPLACE(pTEXTO, '', 'A');
   ptexto := REPLACE(pTEXTO, '', 'A');
   ptexto := REPLACE(pTEXTO, '', 'E');
   ptexto := REPLACE(pTEXTO, '', 'E');
   ptexto := REPLACE(pTEXTO, '', 'I');
   ptexto := REPLACE(pTEXTO, '', 'I');
   ptexto := REPLACE(pTEXTO, '', 'O');
   ptexto := REPLACE(pTEXTO, '', 'O');
   ptexto := REPLACE(pTEXTO, '', 'U');
   ptexto := REPLACE(pTEXTO, '', 'U');
   ptexto := REPLACE(pTEXTO, '', 'A');
   ptexto := REPLACE(pTEXTO, '', 'A');
   ptexto := REPLACE(pTEXTO, '', 'E');
   ptexto := REPLACE(pTEXTO, '', 'E');
   ptexto := REPLACE(pTEXTO, '', 'I');
   ptexto := REPLACE(pTEXTO, '', 'I');
   ptexto := REPLACE(pTEXTO, '', 'O');
   ptexto := REPLACE(pTEXTO, '', 'O');
   ptexto := REPLACE(pTEXTO, '', 'U');
   ptexto := REPLACE(pTEXTO, '', 'U');
   ptexto := REPLACE(pTEXTO, CHR(39)||(39)||CHR(39)||CHR(39), ' ');
   ptexto := REPLACE(pTEXTO, CHR(13), ' ');
   ptexto := REPLACE(pTEXTO, CHR(10), ' ');
   ptexto := REPLACE(pTEXTO, CHR(92), ' ');
   ptexto := REPLACE(pTEXTO, CHR(39), ' ');
   ptexto := REPLACE(pTEXTO, CHR(123), ' ');
   ptexto := REPLACE(pTEXTO, CHR(125), ' ');

   RETURN(ptexto);
END;
$$ language 'plpgsql';




/*-- SEQ 0636 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION MediaDiasAtrasoPonderado (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,INTEGER) CASCADE;

/*-- SEQ 0637 --*/
CREATE OR REPLACE FUNCTION MediaDiasAtrasoPonderado (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,INTEGER)
RETURNS Numeric AS $$
DECLARE
pFilial ALIAS FOR $1 ;
pCodigo ALIAS FOR $2 ;
pNroMeses ALIAS FOR $3 ;
-- Objetivos:
-- 1. Cálcular a média de atraso ponderado (média de atraso considerando valor do pagamento).

-- Declaração de variáveis e cursores
   nRESULT                       Numeric(8);

-- Início da função
BEGIN
       SELECT SUM(CASE WHEN (TRUNC(REC.DATVEN)-TRUNC(REC.PAGAME))=0 
                       THEN 0 
                       ELSE ((TRUNC(REC.DATVEN)-TRUNC(REC.PAGAME))*REC.VLRPAR) 
                  END) / SUM(REC.VLRPAR) 
         INTO nRESULT
         FROM TT_REC REC 
   INNER JOIN TT_VEN VEN ON REC.CODFIL=VEN.CODFIL AND REC.SEQUEN=VEN.SEQUEN
        WHERE VEN.FILCLI = pFilial
          AND VEN.CODCLI = pCodigo
          AND VEN.FLGEST <> 'C'
          AND REC.FLGEST = 'P' 
          AND VEN.LANVEN = 'T'
          AND VEN.DATHOR >= ADD_MONTHS(Agora(),pNroMeses*-1);

   RETURN nRESULT;

END;
$$ language 'plpgsql';




/*-- SEQ 0638 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION NotaAbertaTransfAutom (CHAR,TT_IOR.CODFIL%TYPE,TT_IOR.FILRES%TYPE) CASCADE;

/*-- SEQ 0639 --*/
CREATE OR REPLACE FUNCTION NotaAbertaTransfAutom (CHAR,TT_IOR.CODFIL%TYPE,TT_IOR.FILRES%TYPE)
RETURNS CHAR AS $$
DECLARE
pTipo ALIAS FOR $1 ;
pCodfil ALIAS FOR $2 ;
pFilres ALIAS FOR $3 ;

  -- Objetivos:
  -- 1. Retornar o SEQUEN da nota de transferncia automtica que est aberta.
  --    Retorna NULL se ainda no existir uma nota aberta.

  -- pTipo:
  -- V - Da nota de sada
  -- C - Da nota de entrada

  -- Declarao de variveis e cursores
  vComplemento          constant VARCHAR(100) := constante('complemento');
  cSEQUEN               TT_VEN.SEQUEN%TYPE;

-- Incio da funo
BEGIN

  cSEQUEN := NULL;

  IF pTipo NOT IN ('V','C') THEN
     RAISE EXCEPTION 'PG-20010 Parmetro pTipo invlido. Deve ser "V" ou "C".%' , vComplemento;
  END IF;

  IF pTipo = 'V' THEN

      -- Verificando se j existe venda para transferncia
      SELECT MAX(SEQUEN) INTO cSEQUEN
        FROM TT_VEN
       WHERE CODFIL = pFilres
         AND FILCLI = pCodfil
         AND CODCLI = '     0'
         AND NUMNOT = ('###'||pCodfil)
         AND COALESCE(NROIMP,0) = 0;

  ELSE

      -- Verificando se j existe compra para transferncia
      SELECT MAX(SEQUEN) INTO cSEQUEN
        FROM TT_COM
       WHERE CODFIL = pCodfil
         AND FILFOR = pFilres
         AND CODFOR = '     0'
         AND NUMNOT = ('###'||pCodfil);

  END IF;

  RETURN cSEQUEN;

END;
$$ language 'plpgsql';




/*-- SEQ 0640 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION NumeroVendas (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TD_MUL.CODTAB%TYPE) CASCADE;

/*-- SEQ 0641 --*/
CREATE OR REPLACE FUNCTION NumeroVendas (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TD_MUL.CODTAB%TYPE)
RETURNS Numeric AS $$
DECLARE
pDatIni ALIAS FOR $1 ;
pDatFim ALIAS FOR $2 ;
pFILMAT ALIAS FOR $3 ;
pCODMAT ALIAS FOR $4 ;
pCODCOR ALIAS FOR $5 ;
pCODTAM ALIAS FOR $6 ;
pCODFIL ALIAS FOR $7 ;
pCODMUL ALIAS FOR $8 ;

-- Objetivos:
-- 1. Conta nmero de vendas em determinado perodo para determinada grade de produto.
--    Baseado em Nota Fiscal e Fatura.

-- Declarao de variveis e cursores
   nCount                        Numeric(9);
   dIni                          Timestamp;               -- data inicial do periodo com as horas
   dFim                          Timestamp;               -- data final do periodo com as horas   

-- Incio da funo
BEGIN

    --  ajustando o periodo com as horas
  dIni := TRUNC(pDatIni);
  dFim := TO_DATE(TO_CHAR(TRUNC(pDatFim), 'DD/MM/YYYY') || ' 23:59:59', 'DD/MM/YYYY HH24:MI:SS');

  SELECT COUNT( DISTINCT IVE.SEQUEN ) INTO nCount
    FROM TT_IVE IVE 
   INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
   WHERE IVE.VEN_DATHOR BETWEEN dIni AND dFim
     AND INSTR(COALESCE(pCodFil, IVE.CODFIL)||';', IVE.CODFIL||';') > 0
     AND IVE.FILMAT = pFilMat
     AND IVE.CODMAT = pCodMat
     AND IVE.CODCOR = pCodCor
     AND IVE.CODTAM = pCodTam
     AND IVE.CODMUL = COALESCE(pCODMUL,IVE.CODMUL)
     AND IVE.LANEST IN ('S','R')
     AND IVE.SITKIT IN ('2','3')
     AND IVE.SITMOV = 'N'
     AND VEN.LANVEN = 'T'
     AND VEN.NUMNOT NOT LIKE '%#%';

   RETURN COALESCE(nCount,0);

END;
$$ language 'plpgsql';




/*-- SEQ 0642 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ParceiroTemVinculoRecursivo (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,TT_CLI.FILVIN%TYPE,TT_CLI.CODVIN%TYPE) CASCADE;

/*-- SEQ 0643 --*/
CREATE OR REPLACE FUNCTION ParceiroTemVinculoRecursivo (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,TT_CLI.FILVIN%TYPE,TT_CLI.CODVIN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_filcli ALIAS FOR $1 ;
p_codcli ALIAS FOR $2 ;
p_filvin ALIAS FOR $3 ;
p_codvin ALIAS FOR $4 ;

-- Objetivo: Funo criada para evitar que exista vinculo recursivo no cadastro de parceiros 

   JaInclusos                    VARCHAR(120);
   TemVinculo                    Numeric;
   r_filcli                      TT_CLI.FILCLI%TYPE;
   r_codcli                      TT_CLI.CODCLI%TYPE;
   r_filvin                      TT_CLI.FILVIN%TYPE;
   r_codvin                      TT_CLI.CODVIN%TYPE;
   vRetorno                      VARCHAR(1);   
BEGIN
   vRetorno   := 'F';
   TemVinculo := 0;
   JaInclusos := p_filcli || p_codcli||';';
   
   TemVinculo := INSTR( JaInclusos, p_filvin || p_codvin );
   
   -- Define o cliente para primeira pesquisa
   r_filcli := p_filvin;
   r_codcli := p_codvin;
   IF (r_codcli IS NOT NULL) THEN
	   WHILE (TemVinculo = 0) LOOP
		  -- Busca cliente vinculado
		  		  SELECT FILVIN, CODVIN INTO r_filvin, r_codvin
			FROM TT_CLI
		   WHERE FILCLI = r_filcli
			 AND CODCLI = r_codcli;
		  			
			IF (r_filvin IS NOT NULL) THEN
			   TemVinculo := INSTR( JaInclusos, r_filvin || r_codvin );
			   -- Verifica se cdigo do cliente vinculado NO existe na lista e insere 
			   IF (TemVinculo = 0) THEN 
			      JaInclusos := JaInclusos || r_filvin || r_codvin || ';';
				  r_filcli := r_filvin;
			      r_codcli := r_codvin;
			   END IF;
			ELSE
				 TemVinculo := -1;
			END IF;
	   END LOOP;
   END IF;
   IF TemVinculo > 0 THEN
     RETURN 'T';
   ELSE
	 RETURN 'F';
   END IF; 

END;
$$ language 'plpgsql';




/*-- SEQ 0644 --*/

      CREATE OR REPLACE FUNCTION PC_SUB_SELECT (TT_SUB.CODITE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODITE ALIAS FOR $1 ;
      
      cod_embalagem            TD_SUB.CODSAL%TYPE;
      cod_subdivisao_auxiliar  TD_GRA.CODSUB%TYPE;
      nome_item_subdivisao     TT_SUB.NOMITE%TYPE;
      nome_subdivisao          TD_SUB.NOMSUB%TYPE;
      nome_subdivisao_auxiliar TD_SUB.NOMSUB%TYPE;
      
      BEGIN
      
      SELECT SUB.NOMITE,SUB.CODSUB,DSUB.NOMSUB, DSUB.CODSAL
         INTO nome_item_subdivisao, cod_subdivisao_auxiliar, nome_subdivisao_auxiliar, cod_embalagem
         FROM TT_SUB SUB,TD_SUB DSUB
        WHERE SUB.CODSUB = DSUB.CODTAB
          AND SUB.CODITE = pCODITE;
          
       IF (cod_embalagem IS NOT NULL) THEN
          RAISE EXCEPTION 'PG-20006 Para a subdivisao "%" as unidades de compra e venda devem ser iguais, bem como o valor de conversao.' , nome_subdivisao;
       END IF;
      
        RETURN NULL;

END;
$$ language 'plpgsql';
      
      



CREATE OR REPLACE FUNCTION PC_PAP_ADD_UPDATES (TT_PAP.CODFIL%TYPE,TT_PAP.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
-- Objetivos:
-- 1. Explicar o objetivo 1 aqui...
-- 2. Explicar o objetivo 2 aqui...
 
-- Declarao de variveis e cursores
      
       l_index   INTEGER;
       -- Simular uma lista de atualizaes com arrays
       V_UPDATE_LIST_CODFIL   INTEGER[] := '{}';
       V_UPDATE_LIST_SEQUEN   INTEGER[] := '{}';
   -- Incio da procedure
BEGIN
   -- Incluir os tratamentos aqui...
      
      l_index := array_length(V_UPDATE_LIST_CODFIL, 1) + 1;
      V_UPDATE_LIST_CODFIL[l_index] := pCODFIL;
      V_UPDATE_LIST_SEQUEN[l_index] := pSEQUEN;
      


  RETURN NULL;

END;
$$ language 'plpgsql';


CREATE OR REPLACE FUNCTION PC_PAP_PROCESSA_UPDATES ()
RETURNS VARCHAR AS $$
DECLARE

-- Objetivos:
-- 1. Explicar o objetivo 1 aqui...
-- 2. Explicar o objetivo 2 aqui...
 
-- Declarao de variveis e cursores
      
      -- Declarao de variveis
      cFILUSU   TT_USU.FILUSU%TYPE;
      cCODUSU   TT_USU.CODUSU%TYPE;

      -- Simular a lista de atualizaes com arrays
      V_UPDATE_LIST_CODFIL   INTEGER[];
      V_UPDATE_LIST_SEQUEN   INTEGER[];
   -- Incio da procedure
BEGIN
   -- Incluir os tratamentos aqui...
      
      -- Limpar a lista de atualizaes (em PostgreSQL no h um equivalente direto para `V_UPDATE_LIST.DELETE`)
      V_UPDATE_LIST_CODFIL := '{}';
      V_UPDATE_LIST_SEQUEN := '{}';
      

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 0645 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PermissaoPeloTipoAutorizacao (Numeric) CASCADE;

/*-- SEQ 0646 --*/
CREATE OR REPLACE FUNCTION PermissaoPeloTipoAutorizacao (Numeric)
RETURNS Numeric AS $$
DECLARE
pTipoAutorizacao ALIAS FOR $1 ;
   nPermissao Numeric;    -- Quantidade entregue

-- Objetivo:
-- 1) Retornar a permisso necessria pelo tipo de autorizao. 
--    Baseado no artigo http://intra.totall.com.br:8080/wiki/index.php/Autoriza%C3%A7%C3%B5es_com_Supervisor

BEGIN
  nPermissao := CASE WHEN pTipoAutorizacao IN (6,7,12,13,16,67,69,70,101,102,103,104) THEN 25
                     WHEN pTipoAutorizacao IN (16)                                    THEN 124
                     WHEN pTipoAutorizacao IN (7)                                     THEN 151
                     WHEN pTipoAutorizacao IN (12,15)                                 THEN 168
                     WHEN pTipoAutorizacao IN (8)                                     THEN 169
                     WHEN pTipoAutorizacao IN (2,3,4,5,9,10,11,14,73)                 THEN 213
                     --WHEN pTipoAutorizacao IN (2)                                     THEN 237
                     WHEN pTipoAutorizacao IN (71)                                    THEN 251
                     WHEN pTipoAutorizacao IN (1)                                     THEN 255
                     WHEN pTipoAutorizacao IN (31)                                    THEN 265
                     WHEN pTipoAutorizacao IN (72)                                    THEN 333
                     WHEN pTipoAutorizacao IN (103)                                   THEN 372
                     WHEN pTipoAutorizacao IN (93)                                    THEN 391
                     WHEN pTipoAutorizacao IN (78)                                    THEN 424
  ELSE 0
  END;

  RETURN nPermissao;
END;
$$ language 'plpgsql';




/*-- SEQ 0647 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PermissoesUsuarioAlteradas (TT_USU.PERMIS%TYPE,TT_USU.PERMIS%TYPE) CASCADE;

/*-- SEQ 0648 --*/
CREATE OR REPLACE FUNCTION PermissoesUsuarioAlteradas (TT_USU.PERMIS%TYPE,TT_USU.PERMIS%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pOldPermissoes ALIAS FOR $1 ;
pNewPermissoes ALIAS FOR $2 ;
-- Objetivos:
-- 1. Funo para retorna das permises que sofreram alteraes.
 
   cRetorno                      TEXT;
   cCRLF                         CONSTANT CHAR(1) := CHR(10);
   I                             INTEGER;
   C                             INTEGER;
-- Incio da funo
BEGIN   
   cRetorno := '';
   
   C := 0;
   FOR I IN 1..LENGTH(TRIM(pNewPermissoes)) LOOP
      IF Equal(SUBSTR(pOldPermissoes,i,1),SUBSTR(pNewPermissoes,i,1)) <> 1 THEN
         C := C+1; 
      END IF;
      
      IF C > 10 THEN
        cRetorno := 'Muitas permisses foram alteradas e o campo no tem tamanho suficiente para registrar cada uma delas individualmente.';
        --cRetorno := cRetorno || cCRLF || 'Antigo:'|| pOldPermissoes || ' Novo:' || pNewPermissoes;
        
        Return cRetorno;
        
        EXIT;
      END IF;
   END LOOP;
   
   --Feito este controle pq na tela de Papeis em alguns casos a PERAUT est vazio.
   IF pOldPermissoes = '' THEN
     cRetorno := 'Incluso Inicial';
     Return cRetorno;
   ELSE
      IF Equal(SUBSTR(pOldPermissoes,1,1),SUBSTR(pNewPermissoes,1,1)) <> 1 THEN
        cRetorno := cRetorno || '"001 - Cadastrar Parceiro." '  || SUBSTR(pOldPermissoes,1,1) || ' para ' || SUBSTR(pNewPermissoes,1,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,2,1),SUBSTR(pNewPermissoes,2,1)) <> 1 THEN
        cRetorno := cRetorno || '"002 - Definir fornecedor, transportador, produtor, indicador, indicador de venda e representante." ' || SUBSTR(pOldPermissoes,2,1) || ' para ' || SUBSTR(pNewPermissoes,2,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,3,1),SUBSTR(pNewPermissoes,3,1)) <> 1 THEN
        cRetorno := cRetorno || '"003 - Cadastrar Produto." ' || SUBSTR(pOldPermissoes,3,1) || ' para ' || SUBSTR(pNewPermissoes,3,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,4,1),SUBSTR(pNewPermissoes,4,1)) <> 1 THEN
        cRetorno := cRetorno || '"004 - Registrar Usurio."' || SUBSTR(pOldPermissoes,4,1) || ' para ' || SUBSTR(pNewPermissoes,4,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,5,1),SUBSTR(pNewPermissoes,5,1)) <> 1 THEN
        cRetorno := cRetorno || '"005 - Registrar Planos e Descontos de C/C." ' || SUBSTR(pOldPermissoes,5,1) || ' para ' || SUBSTR(pNewPermissoes,5,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,6,1),SUBSTR(pNewPermissoes,6,1)) <> 1 THEN
        cRetorno := cRetorno || '"006 - Registrar Listas de Preos." ' || SUBSTR(pOldPermissoes,6,1) || ' para ' || SUBSTR(pNewPermissoes,6,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,7,1),SUBSTR(pNewPermissoes,7,1)) <> 1 THEN
        cRetorno := cRetorno || '"007 -  Registrar Cmbio." ' || SUBSTR(pOldPermissoes,7,1) || ' para ' || SUBSTR(pNewPermissoes,7,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,8,1),SUBSTR(pNewPermissoes,8,1)) <> 1 THEN
        cRetorno := cRetorno || '"008 - Registrar Correspondncia." ' || SUBSTR(pOldPermissoes,8,1) || ' para ' || SUBSTR(pNewPermissoes,8,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,9,1),SUBSTR(pNewPermissoes,9,1)) <> 1 THEN
        cRetorno := cRetorno || '"009 - Receber Parcela." ' || SUBSTR(pOldPermissoes,9,1) || ' para ' || SUBSTR(pNewPermissoes,9,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,10,1),SUBSTR(pNewPermissoes,10,1)) <> 1 THEN
        cRetorno := cRetorno || '"010 - Digitar Nota." ' || SUBSTR(pOldPermissoes,10,1) || ' para ' || SUBSTR(pNewPermissoes,10,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,11,1),SUBSTR(pNewPermissoes,11,1)) <> 1 THEN
        cRetorno := cRetorno || '"011 - Configurar CheckOut." ' || SUBSTR(pOldPermissoes,11,1) || ' para ' || SUBSTR(pNewPermissoes,11,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,12,1),SUBSTR(pNewPermissoes,12,1)) <> 1 THEN
        cRetorno := cRetorno || '"012 - Receber Parcial." ' || SUBSTR(pOldPermissoes,12,1) || ' para ' || SUBSTR(pNewPermissoes,12,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,13,1),SUBSTR(pNewPermissoes,13,1)) <> 1 THEN
        cRetorno := cRetorno || '"013 - Autorizar TEF." ' || SUBSTR(pOldPermissoes,13,1) || ' para ' || SUBSTR(pNewPermissoes,13,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,14,1),SUBSTR(pNewPermissoes,14,1)) <> 1 THEN
        cRetorno := cRetorno || '"014 - Baixa Carto de Crdito." ' || SUBSTR(pOldPermissoes,14,1) || ' para ' || SUBSTR(pNewPermissoes,14,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,15,1),SUBSTR(pNewPermissoes,15,1)) <> 1 THEN
        cRetorno := cRetorno || '"015 - Ver Extrato do Cliente." ' || SUBSTR(pOldPermissoes,15,1) || ' para ' || SUBSTR(pNewPermissoes,15,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,16,1),SUBSTR(pNewPermissoes,16,1)) <> 1 THEN
        cRetorno := cRetorno || '"016 - Alterar Portador." ' || SUBSTR(pOldPermissoes,16,1) || ' para ' || SUBSTR(pNewPermissoes,16,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,17,1),SUBSTR(pNewPermissoes,17,1)) <> 1 THEN
        cRetorno := cRetorno || '"017 - Receber." ' || SUBSTR(pOldPermissoes,17,1) || ' para ' || SUBSTR(pNewPermissoes,17,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,18,1),SUBSTR(pNewPermissoes,18,1)) <> 1 THEN
        cRetorno := cRetorno || '"018 - Estornar." ' || SUBSTR(pOldPermissoes,18,1) || ' para ' || SUBSTR(pNewPermissoes,18,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,19,1),SUBSTR(pNewPermissoes,19,1)) <> 1 THEN
        cRetorno := cRetorno || '"019 - Registrar ttulos a receber." ' || SUBSTR(pOldPermissoes,19,1) || ' para ' || SUBSTR(pNewPermissoes,19,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,20,1),SUBSTR(pNewPermissoes,20,1)) <> 1 THEN
        cRetorno := cRetorno || '"020 - Receber Ttulos." ' || SUBSTR(pOldPermissoes,20,1) || ' para ' || SUBSTR(pNewPermissoes,20,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,21,1),SUBSTR(pNewPermissoes,21,1)) <> 1 THEN
        cRetorno := cRetorno || '"021 - Ajustar." ' || SUBSTR(pOldPermissoes,21,1) || ' para ' || SUBSTR(pNewPermissoes,21,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,22,1),SUBSTR(pNewPermissoes,22,1)) <> 1 THEN
        cRetorno := cRetorno || '"022 - Estornar Ttulos." ' || SUBSTR(pOldPermissoes,22,1) || ' para ' || SUBSTR(pNewPermissoes,22,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,23,1),SUBSTR(pNewPermissoes,23,1)) <> 1 THEN
        cRetorno := cRetorno || '"023 - Aceitar Diferena nas Parcelas." ' || SUBSTR(pOldPermissoes,23,1) || ' para ' || SUBSTR(pNewPermissoes,23,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,24,1),SUBSTR(pNewPermissoes,24,1)) <> 1 THEN 
        cRetorno := cRetorno || '"024 - Estornar Parcelas." ' || SUBSTR(pOldPermissoes,24,1) || ' para ' || SUBSTR(pNewPermissoes,24,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,25,1),SUBSTR(pNewPermissoes,25,1)) <> 1 THEN
        cRetorno := cRetorno || '"025 - Supervisionar a Pr-venda." ' || SUBSTR(pOldPermissoes,25,1) || ' para ' || SUBSTR(pNewPermissoes,25,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,26,1),SUBSTR(pNewPermissoes,26,1)) <> 1 THEN
        cRetorno := cRetorno || '"026 - Consultar Tabelas de Preos." ' || SUBSTR(pOldPermissoes,26,1) || ' para ' || SUBSTR(pNewPermissoes,26,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,27,1),SUBSTR(pNewPermissoes,27,1)) <> 1 THEN
        cRetorno := cRetorno || '"027 - Depositar Cheques." ' || SUBSTR(pOldPermissoes,27,1) || ' para ' || SUBSTR(pNewPermissoes,27,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,28,1),SUBSTR(pNewPermissoes,28,1)) <> 1 THEN 
        cRetorno := cRetorno || '"028 - Alterar Vendedor." ' || SUBSTR(pOldPermissoes,28,1) || ' para ' || SUBSTR(pNewPermissoes,28,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,29,1),SUBSTR(pNewPermissoes,29,1)) <> 1 THEN
        cRetorno := cRetorno || '"029 - Digitar Pr-Vendas." ' || SUBSTR(pOldPermissoes,29,1) || ' para ' || SUBSTR(pNewPermissoes,29,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,30,1),SUBSTR(pNewPermissoes,30,1)) <> 1 THEN
        cRetorno := cRetorno || '"030 - Cancelar Nota no Checkout." ' || SUBSTR(pOldPermissoes,30,1) || ' para ' || SUBSTR(pNewPermissoes,30,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,31,1),SUBSTR(pNewPermissoes,31,1)) <> 1 THEN
        cRetorno := cRetorno || '"031 - Liberar Crdito na Venda." ' || SUBSTR(pOldPermissoes,31,1) || ' para ' || SUBSTR(pNewPermissoes,31,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,32,1),SUBSTR(pNewPermissoes,32,1)) <> 1 THEN
        cRetorno := cRetorno || '"032 - Alterar contato em cliente." ' || SUBSTR(pOldPermissoes,32,1) || ' para ' || SUBSTR(pNewPermissoes,32,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,33,1),SUBSTR(pNewPermissoes,33,1)) <> 1 THEN
        cRetorno := cRetorno || '"033 - Operador de Caixa." ' || SUBSTR(pOldPermissoes,33,1) || ' para ' || SUBSTR(pNewPermissoes,33,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,34,1),SUBSTR(pNewPermissoes,34,1)) <> 1 THEN
        cRetorno := cRetorno || '"034 - Supervisor de Caixa." ' || SUBSTR(pOldPermissoes,34,1) || ' para ' || SUBSTR(pNewPermissoes,34,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,35,1),SUBSTR(pNewPermissoes,35,1)) <> 1 THEN
        cRetorno := cRetorno || '"035 - Digitar Compras." ' || SUBSTR(pOldPermissoes,35,1) || ' para ' || SUBSTR(pNewPermissoes,35,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,36,1),SUBSTR(pNewPermissoes,36,1)) <> 1 THEN
        cRetorno := cRetorno || '"036 - Programar." ' || SUBSTR(pOldPermissoes,36,1) || ' para ' || SUBSTR(pNewPermissoes,36,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,37,1),SUBSTR(pNewPermissoes,37,1)) <> 1 THEN
        cRetorno := cRetorno || '"037 - Ver Extrato de Fornecedor." ' || SUBSTR(pOldPermissoes,37,1) || ' para ' || SUBSTR(pNewPermissoes,37,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,38,1),SUBSTR(pNewPermissoes,38,1)) <> 1 THEN
        cRetorno := cRetorno  || '"038 - Consultar Vendas." ' || SUBSTR(pOldPermissoes,38,1) || ' para ' || SUBSTR(pNewPermissoes,38,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,39,1),SUBSTR(pNewPermissoes,39,1)) <> 1 THEN
        cRetorno := cRetorno || '"039 - Consultar Compras." ' || SUBSTR(pOldPermissoes,39,1) || ' para ' || SUBSTR(pNewPermissoes,39,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,40,1),SUBSTR(pNewPermissoes,40,1)) <> 1 THEN
        cRetorno := cRetorno || '"040 - Consultar Estoque." ' || SUBSTR(pOldPermissoes,40,1) || ' para ' || SUBSTR(pNewPermissoes,40,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,41,1),SUBSTR(pNewPermissoes,41,1)) <> 1 THEN
        cRetorno := cRetorno || '"041 - Operar Mala Direta." ' || SUBSTR(pOldPermissoes,41,1) || ' para ' || SUBSTR(pNewPermissoes,41,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,42,1),SUBSTR(pNewPermissoes,42,1)) <> 1 THEN
        cRetorno := cRetorno || '"042 - Configurar Sistema." ' || SUBSTR(pOldPermissoes,42,1) || ' para ' || SUBSTR(pNewPermissoes,42,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,43,1),SUBSTR(pNewPermissoes,43,1)) <> 1 THEN
        cRetorno := cRetorno || '"043 - Retirada em C/C de Cliente." ' || SUBSTR(pOldPermissoes,43,1) || ' para ' || SUBSTR(pNewPermissoes,43,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,44,1),SUBSTR(pNewPermissoes,44,1)) <> 1 THEN
        cRetorno := cRetorno || '"044 - Autoriza Estouro de C/C." ' || SUBSTR(pOldPermissoes,44,1) || ' para ' || SUBSTR(pNewPermissoes,44,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,45,1),SUBSTR(pNewPermissoes,45,1)) <> 1 THEN
        cRetorno := cRetorno || '"045 - Altera Limite de C/C." ' || SUBSTR(pOldPermissoes,45,1) || ' para ' || SUBSTR(pNewPermissoes,45,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,46,1),SUBSTR(pNewPermissoes,46,1)) <> 1 THEN
        cRetorno := cRetorno || '"046 - Registrar Metas de Vendas." ' || SUBSTR(pOldPermissoes,46,1) || ' para ' || SUBSTR(pNewPermissoes,46,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,47,1),SUBSTR(pNewPermissoes,47,1)) <> 1 THEN
        cRetorno := cRetorno || '"047 - Encerrar Recepo de Produtos." ' || SUBSTR(pOldPermissoes,47,1) || ' para ' || SUBSTR(pNewPermissoes,47,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,48,1),SUBSTR(pNewPermissoes,48,1)) <> 1 THEN
        cRetorno := cRetorno || '"048 - Autorizar." ' || SUBSTR(pOldPermissoes,48,1) || ' para ' || SUBSTR(pNewPermissoes,48,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,49,1),SUBSTR(pNewPermissoes,49,1)) <> 1 THEN
        cRetorno := cRetorno || '"049 - Pagar." ' || SUBSTR(pOldPermissoes,49,1) || ' para ' || SUBSTR(pNewPermissoes,49,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,50,1),SUBSTR(pNewPermissoes,50,1)) <> 1 THEN
        cRetorno := cRetorno || '"050 - Ajustar." ' || SUBSTR(pOldPermissoes,50,1) || ' para ' || SUBSTR(pNewPermissoes,50,1) || cCRLF; 
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,51,1),SUBSTR(pNewPermissoes,51,1)) <> 1 THEN
        cRetorno := cRetorno || '"051 - Estornar." ' || SUBSTR(pOldPermissoes,51,1) || ' para ' || SUBSTR(pNewPermissoes,51,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,52,1),SUBSTR(pNewPermissoes,52,1)) <> 1 THEN
        cRetorno := cRetorno || '"052 - Registrar Contratos." ' || SUBSTR(pOldPermissoes,52,1) || ' para ' || SUBSTR(pNewPermissoes,52,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,53,1),SUBSTR(pNewPermissoes,53,1)) <> 1 THEN
        cRetorno := cRetorno || '"053 - Cancelar Contratos." ' || SUBSTR(pOldPermissoes,53,1) || ' para ' || SUBSTR(pNewPermissoes,53,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,54,1),SUBSTR(pNewPermissoes,54,1)) <> 1 THEN
        cRetorno := cRetorno || '"054 - Alterar Profissional." ' || SUBSTR(pOldPermissoes,54,1) || ' para ' || SUBSTR(pNewPermissoes,54,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,55,1),SUBSTR(pNewPermissoes,55,1)) <> 1 THEN
        cRetorno := cRetorno || '"055 - Alterar." ' || SUBSTR(pOldPermissoes,55,1) || ' para ' || SUBSTR(pNewPermissoes,55,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,56,1),SUBSTR(pNewPermissoes,56,1)) <> 1 THEN
        cRetorno := cRetorno || '"056 - Pesquisar Dados." ' || SUBSTR(pOldPermissoes,56,1) || ' para ' || SUBSTR(pNewPermissoes,56,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,57,1),SUBSTR(pNewPermissoes,57,1)) <> 1 THEN
        cRetorno := cRetorno || '"057 - Imprimir." ' || SUBSTR(pOldPermissoes,57,1) || ' para ' || SUBSTR(pNewPermissoes,57,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,58,1),SUBSTR(pNewPermissoes,58,1)) <> 1 THEN
        cRetorno := cRetorno || '"058 - Registrar Concluses de Tarefas." ' || SUBSTR(pOldPermissoes,58,1) || ' para ' || SUBSTR(pNewPermissoes,58,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,59,1),SUBSTR(pNewPermissoes,59,1)) <> 1 THEN
        cRetorno := cRetorno || '"059 - Pesquisar Informaes." ' || SUBSTR(pOldPermissoes,59,1) || ' para ' || SUBSTR(pNewPermissoes,59,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,60,1),SUBSTR(pNewPermissoes,60,1)) <> 1 THEN
        cRetorno := cRetorno || '"060 - Alterar Ordens Concludas." ' || SUBSTR(pOldPermissoes,60,1) || ' para ' || SUBSTR(pNewPermissoes,60,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,61,1),SUBSTR(pNewPermissoes,61,1)) <> 1 THEN
        cRetorno := cRetorno || '"061 - Concluir Tarefas." ' || SUBSTR(pOldPermissoes,61,1) || ' para ' || SUBSTR(pNewPermissoes,61,1) ||  cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,62,1),SUBSTR(pNewPermissoes,62,1)) <> 1 THEN
        cRetorno := cRetorno || '"062 - Reabrir Tarefas." ' || SUBSTR(pOldPermissoes,62,1) || ' para ' || SUBSTR(pNewPermissoes,62,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,63,1),SUBSTR(pNewPermissoes,63,1)) <> 1 THEN
        cRetorno := cRetorno || '"063 - Alterar Registro/Terminal." ' || SUBSTR(pOldPermissoes,63,1) || ' para ' || SUBSTR(pNewPermissoes,63,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,64,1),SUBSTR(pNewPermissoes,64,1)) <> 1 THEN
        cRetorno := cRetorno || '"064 - Ativar/Desativar Registro/Terminal." ' || SUBSTR(pOldPermissoes,64,1) || ' para ' || SUBSTR(pNewPermissoes,64,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,65,1),SUBSTR(pNewPermissoes,65,1)) <> 1 THEN
        cRetorno := cRetorno || '"065 - Pesquisar Dados." ' || SUBSTR(pOldPermissoes,65,1) || ' para ' || SUBSTR(pNewPermissoes,65,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,66,1),SUBSTR(pNewPermissoes,66,1)) <> 1 THEN
        cRetorno := cRetorno  || '"066 - Acesso ao Totall Tools." ' || SUBSTR(pOldPermissoes,66,1) || ' para ' || SUBSTR(pNewPermissoes,66,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,67,1),SUBSTR(pNewPermissoes,67,1)) <> 1 THEN
        cRetorno := cRetorno || '"067 - Acesso ao Totall SAC/Workflow." ' || SUBSTR(pOldPermissoes,67,1) || ' para ' || SUBSTR(pNewPermissoes,67,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,68,1),SUBSTR(pNewPermissoes,68,1)) <> 1 THEN
        cRetorno := cRetorno || '"068 - Excluir item na ordem de servio." ' || SUBSTR(pOldPermissoes,68,1) || ' para ' || SUBSTR(pNewPermissoes,68,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,69,1),SUBSTR(pNewPermissoes,69,1)) <> 1 THEN
        cRetorno := cRetorno || '"069 - Editar item na ordem de servio." ' || SUBSTR(pOldPermissoes,69,1) || ' para ' || SUBSTR(pNewPermissoes,69,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,70,1),SUBSTR(pNewPermissoes,70,1)) <> 1 THEN
        cRetorno := cRetorno || '"070 - Alterar preos de venda." ' || SUBSTR(pOldPermissoes,70,1) || ' para ' || SUBSTR(pNewPermissoes,70,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,71,1),SUBSTR(pNewPermissoes,71,1)) <> 1 THEN
        cRetorno := cRetorno || '"071 - Fechamento parcial de Caixa." ' || SUBSTR(pOldPermissoes,71,1) || ' para ' || SUBSTR(pNewPermissoes,71,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,72,1),SUBSTR(pNewPermissoes,72,1)) <> 1 THEN
        cRetorno := cRetorno || '"072 - Digitar Pedidos." ' || SUBSTR(pOldPermissoes,72,1) || ' para ' || SUBSTR(pNewPermissoes,72,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,73,1),SUBSTR(pNewPermissoes,73,1)) <> 1 THEN
        cRetorno := cRetorno || '"073 - Autorizar Pedidos." ' || SUBSTR(pOldPermissoes,73,1) || ' para ' || SUBSTR(pNewPermissoes,73,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,74,1),SUBSTR(pNewPermissoes,74,1)) <> 1 THEN
        cRetorno := cRetorno || '"074 - Acesso ao Totall Commerce Checkout Server." ' || SUBSTR(pOldPermissoes,74,1) || ' para ' || SUBSTR(pNewPermissoes,74,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,75,1),SUBSTR(pNewPermissoes,75,1)) <> 1 THEN
        cRetorno := cRetorno || '"075 - Autorizar Reserva." ' || SUBSTR(pOldPermissoes,75,1) || ' para ' || SUBSTR(pNewPermissoes,75,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,76,1),SUBSTR(pNewPermissoes,76,1)) <> 1 THEN
        cRetorno := cRetorno || '"076 - Notas de Nat. sem Movimentao de Estoque." ' || SUBSTR(pOldPermissoes,76,1) || ' para ' || SUBSTR(pNewPermissoes,76,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,77,1),SUBSTR(pNewPermissoes,77,1)) <> 1 THEN
        cRetorno := cRetorno || '"077 - Notas de Nat. sem Dados Financeiros." ' || SUBSTR(pOldPermissoes,77,1) || ' para ' || SUBSTR(pNewPermissoes,77,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,78,1),SUBSTR(pNewPermissoes,78,1)) <> 1 THEN
        cRetorno := cRetorno || '"078 - Notas de Naturezas no Tributadas." ' || SUBSTR(pOldPermissoes,75,1) || ' para ' || SUBSTR(pNewPermissoes,75,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,79,1),SUBSTR(pNewPermissoes,79,1)) <> 1 THEN
        cRetorno := cRetorno || '"079 - Notas de Nat. de Devoluo de Mercadorias." ' || SUBSTR(pOldPermissoes,79,1) || ' para ' || SUBSTR(pNewPermissoes,79,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,80,1),SUBSTR(pNewPermissoes,80,1)) <> 1 THEN
        cRetorno := cRetorno || '"080 - Alterar Portador na Venda." ' || SUBSTR(pOldPermissoes,80,1) || ' para ' || SUBSTR(pNewPermissoes,80,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,81,1),SUBSTR(pNewPermissoes,81,1)) <> 1 THEN
        cRetorno := cRetorno || '"081 - Re-emisso de Notas Fiscais." ' || SUBSTR(pOldPermissoes,81,1) || ' para ' || SUBSTR(pNewPermissoes,81,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,82,1),SUBSTR(pNewPermissoes,82,1)) <> 1 THEN
        cRetorno := cRetorno || '"082 - Alterar a data de recebimento ao receber." ' || SUBSTR(pOldPermissoes,82,1) || ' para ' || SUBSTR(pNewPermissoes,82,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,83,1),SUBSTR(pNewPermissoes,83,1)) <> 1 THEN
        cRetorno := cRetorno || '"083 - Separao." ' || SUBSTR(pOldPermissoes,83,1) || ' para ' || SUBSTR(pNewPermissoes,83,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,84,1),SUBSTR(pNewPermissoes,84,1)) <> 1 THEN
        cRetorno := cRetorno || '"084 - Gerar Volumes." ' || SUBSTR(pOldPermissoes,84,1) || ' para ' || SUBSTR(pNewPermissoes,84,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,85,1),SUBSTR(pNewPermissoes,85,1)) <> 1 THEN
        cRetorno := cRetorno || '"085 - Cancelar Volumes." ' || SUBSTR(pOldPermissoes,82,1) || ' para ' || SUBSTR(pNewPermissoes,82,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,86,1),SUBSTR(pNewPermissoes,86,1)) <> 1 THEN
        cRetorno := cRetorno || '"086 - Gerar Romaneio de Cargas." ' || SUBSTR(pOldPermissoes,86,1) || ' para ' || SUBSTR(pNewPermissoes,86,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,87,1),SUBSTR(pNewPermissoes,87,1)) <> 1 THEN
        cRetorno := cRetorno || '"087 - Cancelar Romaneio de Cargas." ' || SUBSTR(pOldPermissoes,87,1) || ' para ' || SUBSTR(pNewPermissoes,87,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,88,1),SUBSTR(pNewPermissoes,88,1)) <> 1 THEN
        cRetorno := cRetorno || '"088 - Gera Mapa Resumo Dirio." ' || SUBSTR(pOldPermissoes,88,1) || ' para ' || SUBSTR(pNewPermissoes,88,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,89,1),SUBSTR(pNewPermissoes,89,1)) <> 1 THEN
        cRetorno := cRetorno || '"089 - Importar Metadados." ' || SUBSTR(pOldPermissoes,89,1) || ' para ' || SUBSTR(pNewPermissoes,89,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,90,1),SUBSTR(pNewPermissoes,90,1)) <> 1 THEN
        cRetorno := cRetorno || '"090 - Gerar documentos de troco." ' || SUBSTR(pOldPermissoes,90,1) || ' para ' || SUBSTR(pNewPermissoes,90,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,91,1),SUBSTR(pNewPermissoes,91,1)) <> 1 THEN
        cRetorno := cRetorno || '"091 - Inutilizar documentos de troco." ' || SUBSTR(pOldPermissoes,91,1) || ' para ' || SUBSTR(pNewPermissoes,91,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,92,1),SUBSTR(pNewPermissoes,92,1)) <> 1 THEN
        cRetorno := cRetorno || '"092 - Imprimir documentos de troco/cheque." ' || SUBSTR(pOldPermissoes,92,1) || ' para ' || SUBSTR(pNewPermissoes,92,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,93,1),SUBSTR(pNewPermissoes,93,1)) <> 1 THEN
        cRetorno := cRetorno || '"093 - Reimprimir documentos de troco/cheque." ' || SUBSTR(pOldPermissoes,93,1) || ' para ' || SUBSTR(pNewPermissoes,93,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,94,1),SUBSTR(pNewPermissoes,94,1)) <> 1 THEN
        cRetorno := cRetorno || '"094 - Enviar romaneio de documentos." ' || SUBSTR(pOldPermissoes,94,1) || ' para ' || SUBSTR(pNewPermissoes,94,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,95,1),SUBSTR(pNewPermissoes,95,1)) <> 1 THEN
        cRetorno := cRetorno || '"095 - Receber romaneio de documentos." ' || SUBSTR(pOldPermissoes,95,1) || ' para ' || SUBSTR(pNewPermissoes,95,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,96,1),SUBSTR(pNewPermissoes,96,1)) <> 1 THEN
        cRetorno := cRetorno || '"096 - Faz sangria/reforo no identificada." ' || SUBSTR(pOldPermissoes,96,1) || ' para ' || SUBSTR(pNewPermissoes,96,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,97,1),SUBSTR(pNewPermissoes,97,1)) <> 1 THEN
        cRetorno := cRetorno || '"097 - Faturar C/C." ' || SUBSTR(pOldPermissoes,97,1) || ' para ' || SUBSTR(pNewPermissoes,97,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,98,1),SUBSTR(pNewPermissoes,98,1)) <> 1 THEN
        cRetorno := cRetorno || '"098 - Conciliar Documentos." ' || SUBSTR(pOldPermissoes,98,1) || ' para ' || SUBSTR(pNewPermissoes,98,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,99,1),SUBSTR(pNewPermissoes,99,1)) <> 1 THEN
        cRetorno := cRetorno || '"099 - V valores do caixa." ' || SUBSTR(pOldPermissoes,99,1) || ' para ' || SUBSTR(pNewPermissoes,99,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,100,1),SUBSTR(pNewPermissoes,100,1)) <> 1 THEN
        cRetorno := cRetorno || '"100 - Cancelar item de NF e CF." ' || SUBSTR(pOldPermissoes,100,1) || ' para ' || SUBSTR(pNewPermissoes,100,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,101,1),SUBSTR(pNewPermissoes,101,1)) <> 1 THEN
        cRetorno := cRetorno || '"101 - Escriturao Bancria." ' || SUBSTR(pOldPermissoes,101,1) || ' para ' || SUBSTR(pNewPermissoes,101,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,102,1),SUBSTR(pNewPermissoes,102,1)) <> 1 THEN
        cRetorno := cRetorno || '"102 - Gerenciar Plano." ' || SUBSTR(pOldPermissoes,102,1) || ' para ' || SUBSTR(pNewPermissoes,102,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,103,1),SUBSTR(pNewPermissoes,103,1)) <> 1 THEN
        cRetorno := cRetorno || '"103 - Gerar Balancete." ' || SUBSTR(pOldPermissoes,103,1) || ' para ' || SUBSTR(pNewPermissoes,103,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,104,1),SUBSTR(pNewPermissoes,104,1)) <> 1 THEN
        cRetorno := cRetorno || '"104 - Lanar Movimento Financeira." ' || SUBSTR(pOldPermissoes,104,1) || ' para ' || SUBSTR(pNewPermissoes,104,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,105,1),SUBSTR(pNewPermissoes,105,1)) <> 1 THEN
        cRetorno := cRetorno || '"105 - Lanar Transferncias." ' || SUBSTR(pOldPermissoes,105,1) || ' para ' || SUBSTR(pNewPermissoes,105,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,106,1),SUBSTR(pNewPermissoes,106,1)) <> 1 THEN
        cRetorno := cRetorno || '"106 - Gerar Extratos." ' || SUBSTR(pOldPermissoes,106,1) || ' para ' || SUBSTR(pNewPermissoes,106,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,107,1),SUBSTR(pNewPermissoes,107,1)) <> 1 THEN
        cRetorno := cRetorno || '"107 - Lanar Verbas e Metas." ' || SUBSTR(pOldPermissoes,107,1) || ' para ' || SUBSTR(pNewPermissoes,107,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,108,1),SUBSTR(pNewPermissoes,108,1)) <> 1 THEN
        cRetorno := cRetorno || '"108 - Cadastrar Contas Bancrias."' || SUBSTR(pOldPermissoes,108,1) || ' para ' || SUBSTR(pNewPermissoes,108,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,109,1),SUBSTR(pNewPermissoes,109,1)) <> 1 THEN
        cRetorno := cRetorno || '"109 - Registrar Frete." ' || SUBSTR(pOldPermissoes,109,1) || ' para ' || SUBSTR(pNewPermissoes,109,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,110,1),SUBSTR(pNewPermissoes,110,1)) <> 1 THEN
        cRetorno := cRetorno || '"110 - Registrar Fatura." ' || SUBSTR(pOldPermissoes,110,1) || ' para ' || SUBSTR(pNewPermissoes,110,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,111,1),SUBSTR(pNewPermissoes,111,1)) <> 1 THEN
        cRetorno := cRetorno || '"111 - Registrar ttulo a pagar." ' || SUBSTR(pOldPermissoes,111,1) || ' para ' || SUBSTR(pNewPermissoes,111,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,112,1),SUBSTR(pNewPermissoes,112,1)) <> 1 THEN
        cRetorno := cRetorno || '"112 - Visualizar Lucratividade." ' || SUBSTR(pOldPermissoes,112,1) || ' para ' || SUBSTR(pNewPermissoes,112,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,113,1),SUBSTR(pNewPermissoes,113,1)) <> 1 THEN
        cRetorno := cRetorno || '"113 - Administrar projetos e pessoal." ' || SUBSTR(pOldPermissoes,113,1) || ' para ' || SUBSTR(pNewPermissoes,113,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,114,1),SUBSTR(pNewPermissoes,114,1)) <> 1 THEN
        cRetorno := cRetorno || '"114 - Acesso  internet." ' || SUBSTR(pOldPermissoes,114,1) || ' para ' || SUBSTR(pNewPermissoes,114,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,115,1),SUBSTR(pNewPermissoes,115,1)) <> 1 THEN
        cRetorno := cRetorno || '"115 - Associar um produto a um fornecedor." ' || SUBSTR(pOldPermissoes,115,1) || ' para ' || SUBSTR(pNewPermissoes,115,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,116,1),SUBSTR(pNewPermissoes,116,1)) <> 1 THEN
        cRetorno := cRetorno || '"116 - Usar o mesmo mdulo em vrios terminais." ' || SUBSTR(pOldPermissoes,116,1) || ' para ' || SUBSTR(pNewPermissoes,116,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,117,1),SUBSTR(pNewPermissoes,117,1)) <> 1 THEN
        cRetorno := cRetorno || '"117 - Cadastrar Municpios." ' || SUBSTR(pOldPermissoes,117,1) || ' para ' || SUBSTR(pNewPermissoes,117,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,118,1),SUBSTR(pNewPermissoes,118,1)) <> 1 THEN
        cRetorno := cRetorno || '"118 - Verificar scripts de cupom fiscal." ' || SUBSTR(pOldPermissoes,118,1) || ' para ' || SUBSTR(pNewPermissoes,118,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,119,1),SUBSTR(pNewPermissoes,119,1)) <> 1 THEN
        cRetorno := cRetorno || '"119 - Cancelar scripts de cupom fiscal." ' || SUBSTR(pOldPermissoes,119,1) || ' para ' || SUBSTR(pNewPermissoes,119,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,120,1),SUBSTR(pNewPermissoes,120,1)) <> 1 THEN
        cRetorno := cRetorno || '"120 - Submeter scripts de cupom fiscal." ' || SUBSTR(pOldPermissoes,120,1) || ' para ' || SUBSTR(pNewPermissoes,120,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,121,1),SUBSTR(pNewPermissoes,121,1)) <> 1 THEN
        cRetorno := cRetorno || '"121 - Editar scripts de cupom fiscal." ' || SUBSTR(pOldPermissoes,121,1) || ' para ' || SUBSTR(pNewPermissoes,121,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,122,1),SUBSTR(pNewPermissoes,122,1)) <> 1 THEN
        cRetorno := cRetorno || '"122 - Arquivar scripts de cupom fiscal." ' || SUBSTR(pOldPermissoes,122,1) || ' para ' || SUBSTR(pNewPermissoes,122,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,123,1),SUBSTR(pNewPermissoes,123,1)) <> 1 THEN
        cRetorno := cRetorno || '"123 - Liberar Venda com Consulta off-line de Crdito." ' || SUBSTR(pOldPermissoes,123,1) || ' para ' || SUBSTR(pNewPermissoes,123,1) || cCRLF;
      END IF;
         IF Equal(SUBSTR(pOldPermissoes,124,1),SUBSTR(pNewPermissoes,124,1)) <> 1 THEN
        cRetorno := cRetorno || '"124 - No recalcular tabelas de preos." ' || SUBSTR(pOldPermissoes,124,1) || ' para ' || SUBSTR(pNewPermissoes,124,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,125,1),SUBSTR(pNewPermissoes,125,1)) <> 1 THEN
        cRetorno := cRetorno || '"125 - Registrar ausncias de usurios." ' || SUBSTR(pOldPermissoes,125,1) || ' para ' || SUBSTR(pNewPermissoes,125,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,126,1),SUBSTR(pNewPermissoes,126,1)) <> 1 THEN
        cRetorno := cRetorno || '"126 - Registrar tarefas." ' || SUBSTR(pOldPermissoes,126,1) || ' para ' || SUBSTR(pNewPermissoes,126,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,127,1),SUBSTR(pNewPermissoes,127,1)) <> 1 THEN
        cRetorno := cRetorno || '"127 - Registrar chamados." ' || SUBSTR(pOldPermissoes,127,1) || ' para ' || SUBSTR(pNewPermissoes,127,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,128,1),SUBSTR(pNewPermissoes,128,1)) <> 1 THEN
        cRetorno := cRetorno || '"128 - Gerenciar atendimento." ' || SUBSTR(pOldPermissoes,128,1) || ' para ' || SUBSTR(pNewPermissoes,128,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,129,1),SUBSTR(pNewPermissoes,129,1)) <> 1 THEN
        cRetorno := cRetorno || '"129 - Agendamento." ' || SUBSTR(pOldPermissoes,129,1) || ' para ' || SUBSTR(pNewPermissoes,129,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,130,1),SUBSTR(pNewPermissoes,130,1)) <> 1 THEN
        cRetorno := cRetorno || '"130 - Montar questionrios." ' || SUBSTR(pOldPermissoes,130,1) || ' para ' || SUBSTR(pNewPermissoes,130,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,131,1),SUBSTR(pNewPermissoes,131,1)) <> 1 THEN
        cRetorno := cRetorno || '"131 - Acesso ao Totall Mail." ' || SUBSTR(pOldPermissoes,131,1) || ' para ' || SUBSTR(pNewPermissoes,131,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,132,1),SUBSTR(pNewPermissoes,132,1)) <> 1 THEN
        cRetorno := cRetorno || '"132 - Consulta Fechamento." ' || SUBSTR(pOldPermissoes,132,1) || ' para ' || SUBSTR(pNewPermissoes,132,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,133,1),SUBSTR(pNewPermissoes,133,1)) <> 1 THEN
        cRetorno := cRetorno || '"133 - Integrao TKE (Posto Esso)." ' || SUBSTR(pOldPermissoes,133,1) || ' para ' || SUBSTR(pNewPermissoes,133,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,134,1),SUBSTR(pNewPermissoes,134,1)) <> 1 THEN
        cRetorno := cRetorno || '"134 - Exportao de Dados." ' || SUBSTR(pOldPermissoes,134,1) || ' para ' || SUBSTR(pNewPermissoes,134,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,135,1),SUBSTR(pNewPermissoes,135,1)) <> 1 THEN
        cRetorno := cRetorno || '"135 - Exportao para" Checkout." ' || SUBSTR(pOldPermissoes,135,1) || ' para ' || SUBSTR(pNewPermissoes,135,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,136,1),SUBSTR(pNewPermissoes,136,1)) <> 1 THEN
        cRetorno := cRetorno || '"136 - Fiscal (SINTEGRA)." ' || SUBSTR(pOldPermissoes,136,1) || ' para ' || SUBSTR(pNewPermissoes,136,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,137,1),SUBSTR(pNewPermissoes,137,1)) <> 1 THEN
        cRetorno := cRetorno || '"137 - Bancos." ' || SUBSTR(pOldPermissoes,137,1) || ' para ' || SUBSTR(pNewPermissoes,137,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,138,1),SUBSTR(pNewPermissoes,138,1)) <> 1 THEN
        cRetorno := cRetorno || '"138 - Auditoria." ' || SUBSTR(pOldPermissoes,138,1) || ' para ' || SUBSTR(pNewPermissoes,138,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,139,1),SUBSTR(pNewPermissoes,139,1)) <> 1 THEN
        cRetorno := cRetorno || '"139 - Simular Recebimentos." ' || SUBSTR(pOldPermissoes,139,1) || ' para ' || SUBSTR(pNewPermissoes,139,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,140,1),SUBSTR(pNewPermissoes,140,1)) <> 1 THEN
        cRetorno := cRetorno || '"140 - Segmento de Fotografia." ' || SUBSTR(pOldPermissoes,140,1) || ' para ' || SUBSTR(pNewPermissoes,140,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,141,1),SUBSTR(pNewPermissoes,141,1)) <> 1 THEN
        cRetorno := cRetorno || '"141 - Renegociar Contas a Receber." ' || SUBSTR(pOldPermissoes,141,1) || ' para ' || SUBSTR(pNewPermissoes,141,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,142,1),SUBSTR(pNewPermissoes,142,1)) <> 1 THEN
        cRetorno := cRetorno || '"142 - Definir" Credit Score." ' || SUBSTR(pOldPermissoes,142,1) || ' para ' || SUBSTR(pNewPermissoes,142,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,143,1),SUBSTR(pNewPermissoes,143,1)) <> 1 THEN 
        cRetorno := cRetorno || '"143 - Devoluo e Troca sem vnculo anterior." ' || SUBSTR(pOldPermissoes,143,1) || ' para ' || SUBSTR(143,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,144,1),SUBSTR(pNewPermissoes,144,1)) <> 1 THEN
        cRetorno := cRetorno || '"144 - Mudar data de abertura e fechamento." ' || SUBSTR(pOldPermissoes,144,1) || ' para ' || SUBSTR(144,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,145,1),SUBSTR(pNewPermissoes,145,1)) <> 1 THEN
        cRetorno := cRetorno || '"145 - Pedir Reposio." ' || SUBSTR(pOldPermissoes,145,1) || ' para ' || SUBSTR(pNewPermissoes,145,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,146,1),SUBSTR(pNewPermissoes,146,1)) <> 1 THEN
        cRetorno := cRetorno || '"146 - Faz transferncia (sangria/reforo) identificada." ' || SUBSTR(pOldPermissoes,146,1) || ' para ' || SUBSTR(pNewPermissoes,146,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,147,1),SUBSTR(pNewPermissoes,147,1)) <> 1 THEN
        cRetorno := cRetorno || '"147 - Ver pagamentos a funcionarios." ' || SUBSTR(pOldPermissoes,147,1) || ' para ' || SUBSTR(pNewPermissoes,147,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,148,1),SUBSTR(pNewPermissoes,148,1)) <> 1 THEN
        cRetorno := cRetorno || '"148 - Desativar Parceiro." ' || SUBSTR(pOldPermissoes,148,1) || ' para ' || SUBSTR(pNewPermissoes,147,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,149,1),SUBSTR(pNewPermissoes,149,1)) <> 1 THEN
        cRetorno := cRetorno || '"149 - Cancelar vendas de dias j fechados." ' || SUBSTR(pOldPermissoes,149,1) || ' para ' || SUBSTR(pNewPermissoes,149,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,150,1),SUBSTR(pNewPermissoes,150,1)) <> 1 THEN 
        cRetorno := cRetorno || '"150 - Recalcular Saldo." ' || SUBSTR(pOldPermissoes, 150,1) || ' para ' || SUBSTR(pNewPermissoes,150,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,151,1),SUBSTR(pNewPermissoes,151,1)) <> 1 THEN
        cRetorno := cRetorno || '"151 - Autorizar desconto acima do mximo." ' || SUBSTR(pOldPermissoes,151,1) || ' para ' || SUBSTR(pNewPermissoes,151,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,152,1),SUBSTR(pNewPermissoes,152,1)) <> 1 THEN
        cRetorno := cRetorno || '"152 - Definir Parceiro Especial." ' || SUBSTR(pOldPermissoes,152,1) || ' para ' || SUBSTR(pNewPermissoes,152,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,153,1),SUBSTR(pNewPermissoes,153,1)) <> 1 THEN
        cRetorno := cRetorno || '"153 - Re-Imprimir NF Anteriores a ltima." ' || SUBSTR(pOldPermissoes,153,1) || ' para ' || SUBSTR(pNewPermissoes,153,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,154,1),SUBSTR(pNewPermissoes,154,1)) <> 1 THEN
        cRetorno := cRetorno || '"154 - Autoriza venda manual de combustveis." ' || SUBSTR(pOldPermissoes,154,1) || ' para ' || SUBSTR(pNewPermissoes,154,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,155,1),SUBSTR(pNewPermissoes,155,1)) <> 1 THEN
        cRetorno := cRetorno || '"155 - Definir Vnculo." ' || SUBSTR(pOldPermissoes,155,1) || ' para ' || SUBSTR(pNewPermissoes,155,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,156,1),SUBSTR(pNewPermissoes,156,1)) <> 1 THEN
        cRetorno := cRetorno || '"156 - Definir Cdigo Alternativo nico." ' || SUBSTR(pOldPermissoes,156,1) || ' para ' || SUBSTR(pNewPermissoes,156,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,157,1),SUBSTR(pNewPermissoes,157,1)) <> 1 THEN 
        cRetorno := cRetorno || '"157 - Visualizar Endereos de Parceiros Especiais." ' || SUBSTR(pOldPermissoes,157,1) || ' para ' || SUBSTR(pNewPermissoes,157,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,158,1),SUBSTR(pNewPermissoes,158,1)) <> 1 THEN
        cRetorno := cRetorno || '"158 - Visualizar Dados Financeiros e de Conta Corrente." ' ||SUBSTR(pOldPermissoes,158,1) || ' para ' || SUBSTR(pNewPermissoes,158,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,159,1),SUBSTR(pNewPermissoes,159,1)) <> 1 THEN
        cRetorno := cRetorno || '"159 - Alterar Dados Financeiros e de Conta Corrente."' || SUBSTR(pOldPermissoes,159,1) || ' para ' || SUBSTR(pNewPermissoes,159,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,160,1),SUBSTR(pNewPermissoes,160,1)) <> 1 THEN
        cRetorno := cRetorno || '"160 - Alterar Categorias." ' || SUBSTR(pOldPermissoes,160,1) || ' para ' || SUBSTR(pNewPermissoes,160,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,161,1),SUBSTR(pNewPermissoes,161,1)) <> 1 THEN 
        cRetorno := cRetorno || '"161 - Gera Cobrana." ' || SUBSTR(pOldPermissoes,161,1) || ' para ' || SUBSTR(pNewPermissoes,161,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,162,1),SUBSTR(pNewPermissoes,162,1)) <> 1 THEN 
        cRetorno := cRetorno || '"162 - Registra AR." ' || SUBSTR(pOldPermissoes,162,1) || ' para ' || SUBSTR(pNewPermissoes,162,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,163,1),SUBSTR(pNewPermissoes,163,1)) <> 1 THEN
        cRetorno := cRetorno || '"163 - Desmarcar Cancelar entrega." ' || SUBSTR(pOldPermissoes,163,1) || ' para ' || SUBSTR(pNewPermissoes,163,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,164,1),SUBSTR(pNewPermissoes,164,1)) <> 1 THEN 
        cRetorno := cRetorno || '"164 - Definir Prospeco." ' || SUBSTR(pOldPermissoes,164,1) || ' para ' || SUBSTR(pNewPermissoes,164,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,165,1),SUBSTR(pNewPermissoes,165,1)) <> 1 THEN 
        cRetorno := cRetorno || '"165 - Define Plano padro." ' || SUBSTR(pOldPermissoes,165,1) || ' para ' || SUBSTR(pNewPermissoes,165,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,166,1),SUBSTR(pNewPermissoes,166,1)) <> 1 THEN
        cRetorno := cRetorno || '"166 - Define Portador padro." ' || SUBSTR(pOldPermissoes,166,1) || ' para ' || SUBSTR(pNewPermissoes,166,1) || cCRLF;
      END IF; 
      IF Equal(SUBSTR(pOldPermissoes,167,1),SUBSTR(pNewPermissoes,167,1)) <> 1 THEN
        cRetorno := cRetorno || '"167 - Define Vendedor padro." ' || SUBSTR(pOldPermissoes,167,1) || ' para ' || SUBSTR(pNewPermissoes,167,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,168,1),SUBSTR(pNewPermissoes,168,1)) <> 1 THEN
        cRetorno := cRetorno || '"168 - Registrar/Editar Oramentos em Outras Filiais." ' || SUBSTR(pOldPermissoes,168,1) || ' para ' || SUBSTR(pNewPermissoes,168,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,169,1),SUBSTR(pNewPermissoes,169,1)) <> 1 THEN
        cRetorno := cRetorno || '"169 - Autoriza venda sem estoque." ' || SUBSTR(pOldPermissoes,169,1) || ' para ' || SUBSTR(pNewPermissoes,169,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,170,1),SUBSTR(pNewPermissoes,170,1)) <> 1 THEN
        cRetorno := cRetorno || '"170 - Lanamento Avulso no estoque." ' || SUBSTR(pOldPermissoes,170,1) || ' para ' || SUBSTR(pNewPermissoes,170,1) || cCRLF;
      END IF;   
      IF Equal(SUBSTR(pOldPermissoes,171,1),SUBSTR(pNewPermissoes,171,1)) <> 1 THEN 
        cRetorno := cRetorno || '"171 - Inventrio - Apurao." ' || SUBSTR(pOldPermissoes,171,1) || ' para ' || SUBSTR(pNewPermissoes,171,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,172,1),SUBSTR(pNewPermissoes,172,1)) <> 1 THEN
        cRetorno := cRetorno || '"172 - Inventrio - Relatrio Legal." ' || SUBSTR(pOldPermissoes,172,1) || ' para ' || SUBSTR(pNewPermissoes,172,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,173,1),SUBSTR(pNewPermissoes,173,1)) <> 1 THEN
        cRetorno := cRetorno || '"173 - Gerncia de RAT." ' || SUBSTR(pOldPermissoes,173,1) || ' para ' || SUBSTR(pNewPermissoes,173,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,174,1),SUBSTR(pNewPermissoes,174,1)) <> 1 THEN
        cRetorno := cRetorno || '"174 - Integrao Sistema Futura." ' || SUBSTR(pOldPermissoes,174,1) || ' para ' || SUBSTR(pNewPermissoes,174,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,175,1),SUBSTR(pNewPermissoes,175,1)) <> 1 THEN
        cRetorno := cRetorno || '"175 - Cadastro de Caracterizaes." ' || SUBSTR(pOldPermissoes,175,1) || ' para ' || SUBSTR(pNewPermissoes,175,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,176,1),SUBSTR(pNewPermissoes,176,1)) <> 1 THEN
        cRetorno := cRetorno || '"176 - Conferncia com visualizao da quantidade contada." ' || SUBSTR(pOldPermissoes,176,1) || ' para ' || SUBSTR(pNewPermissoes,176,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,177,1),SUBSTR(pNewPermissoes,177,1)) <> 1 THEN
        cRetorno := cRetorno || '"177 - Fazer carga de CheckOut." ' || SUBSTR(pOldPermissoes,177,1) || ' para ' || SUBSTR(pNewPermissoes,177,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,178,1),SUBSTR(pNewPermissoes,178,1)) <> 1 THEN
        cRetorno := cRetorno || '"178 - Abrir caixa." ' || SUBSTR(pOldPermissoes,178,1) || ' para ' || SUBSTR(pNewPermissoes,178,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,179,1),SUBSTR(pNewPermissoes,179,1)) <> 1 THEN 
        cRetorno := cRetorno || '"179 - Fechar caixa." ' || SUBSTR(pOldPermissoes,179,1) || ' para ' || SUBSTR(pNewPermissoes,179,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,180,1),SUBSTR(pNewPermissoes,180,1)) <> 1 THEN
        cRetorno := cRetorno || '"180 - Escolher ou consultar uma tabela de preos diferente da padro num oramento." ' || ' para ' ||SUBSTR(pOldPermissoes,180,1) || ' para ' || SUBSTR(pNewPermissoes,180,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,181,1),SUBSTR(pNewPermissoes,181,1)) <> 1 THEN
        cRetorno := cRetorno || '"181 - Transferir produtos entre sub-estoques." ' || SUBSTR(pOldPermissoes,181,1) || ' para ' || SUBSTR(pNewPermissoes,181,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,182,1),SUBSTR(pNewPermissoes,182,1)) <> 1 THEN
        cRetorno := cRetorno || '"182 - Ignora contagem de" Outros.""' || SUBSTR(pOldPermissoes,182,1) || ' para ' || SUBSTR(pNewPermissoes,182,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,183,1),SUBSTR(pNewPermissoes,183,1)) <> 1 THEN
        cRetorno := cRetorno || '"183 - de Conta Bancria para Conta Caixa." ' || SUBSTR(pOldPermissoes,183,1) || ' para ' || SUBSTR(pNewPermissoes,183,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,184,1),SUBSTR(pNewPermissoes,184,1)) <> 1 THEN
        cRetorno := cRetorno || '"184 - de Conta Caixa para Conta Bancria." ' || SUBSTR(pOldPermissoes,184,1) || ' para ' || SUBSTR(pNewPermissoes,184,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,185,1),SUBSTR(pNewPermissoes,185,1)) <> 1 THEN
        cRetorno := cRetorno || '"185 - de Conta de diferena para Conta de diferena." ' || SUBSTR(pOldPermissoes,185,1) || ' para ' || SUBSTR(pNewPermissoes,185,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,186,1),SUBSTR(pNewPermissoes,186,1)) <> 1 THEN
        cRetorno := cRetorno || '"186 - de Conta Caixa para Conta de diferena." ' || SUBSTR(pOldPermissoes,186,1) || ' para ' || SUBSTR(pNewPermissoes,186,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,187,1),SUBSTR(pNewPermissoes,187,1)) <> 1 THEN
        cRetorno := cRetorno || '"187 - de Conta de diferena para Conta Caixa." ' || SUBSTR(pOldPermissoes,187,1) || ' para ' || SUBSTR(pNewPermissoes,187,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,188,1),SUBSTR(pNewPermissoes,188,1)) <> 1 THEN
        cRetorno := cRetorno || '"188 - de Conta bancria para conta bancria." ' || SUBSTR(pOldPermissoes,188,1) || ' para ' || SUBSTR(pNewPermissoes,188,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,189,1),SUBSTR(pNewPermissoes,189,1)) <> 1 THEN
        cRetorno := cRetorno || '"189 - Acessar Plano de Contas." ' || SUBSTR(pOldPermissoes,189,1) || ' para ' || SUBSTR(pNewPermissoes,189,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,190,1),SUBSTR(pNewPermissoes,190,1)) <> 1 THEN
        cRetorno := cRetorno || '"190 - Acesso ao Resumo de Contas." ' || SUBSTR(pOldPermissoes,190,1) || ' para ' || SUBSTR(pNewPermissoes,190,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,191,1),SUBSTR(pNewPermissoes,191,1)) <> 1 THEN 
        cRetorno := cRetorno || '"191 - Alterar endereo preferencial." ' || SUBSTR(pOldPermissoes,191,1) || ' para ' || SUBSTR(pNewPermissoes,191,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,192,1),SUBSTR(pNewPermissoes,192,1)) <> 1 THEN
        cRetorno := cRetorno || '"192 - Alterar desconto por valor de compra." ' || SUBSTR(pOldPermissoes,192,1) || ' para ' || SUBSTR(pNewPermissoes,192,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,193,1),SUBSTR(pNewPermissoes,193,1)) <> 1 THEN
        cRetorno := cRetorno || '"193 - Cadastrar Veculos." ' || SUBSTR(pOldPermissoes,193,1) || ' para ' || SUBSTR(pNewPermissoes,193,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,194,1),SUBSTR(pNewPermissoes,194,1)) <> 1 THEN 
        cRetorno := cRetorno || '"194 - Configurar preferncias na pr-venda." ' || SUBSTR(pOldPermissoes,194,1) || ' para ' || SUBSTR(pNewPermissoes,194,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,195,1),SUBSTR(pNewPermissoes,195,1)) <> 1 THEN
        cRetorno := cRetorno || '"195 - Alterar o cliente de uma venda." ' || SUBSTR(pOldPermissoes,195,1) || ' para ' || SUBSTR(pNewPermissoes,195,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,196,1),SUBSTR(pNewPermissoes,196,1)) <> 1 THEN
        cRetorno := cRetorno || '"196 - Alterar o tipo de um lanamento de c/c." ' || SUBSTR(pOldPermissoes,196,1) || ' para ' || SUBSTR(pNewPermissoes,196,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,197,1),SUBSTR(pNewPermissoes,197,1)) <> 1 THEN
        cRetorno := cRetorno || '"197 - Mudar o valor de um lanamento de c/c, registrando a diferena para o usurio do caixa." ' || SUBSTR(pOldPermissoes,197,1) || ' para ' || SUBSTR(pNewPermissoes,197,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,198,1),SUBSTR(pNewPermissoes,198,1)) <> 1 THEN
        cRetorno := cRetorno || '"198 - Alterar Bnus." ' || SUBSTR(pOldPermissoes,198,1) || ' para ' || SUBSTR(pNewPermissoes,198,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,199,1),SUBSTR(pNewPermissoes,199,1)) <> 1 THEN
        cRetorno := cRetorno || '"199 - Conciliao Bancaria." ' || SUBSTR(pOldPermissoes,199,1) || ' para ' || SUBSTR(pNewPermissoes,199,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,200,1),SUBSTR(pNewPermissoes,200,1)) <> 1 THEN
        cRetorno := cRetorno || '"200 - Razao Auxiliar." ' || SUBSTR(pOldPermissoes,200,1) || ' para ' || SUBSTR(pNewPermissoes,200,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,201,1),SUBSTR(pNewPermissoes,201,1)) <> 1 THEN
        cRetorno := cRetorno || '"201 - Visualizar dados de produtos." ' || SUBSTR(pOldPermissoes,201,1) || ' para ' || SUBSTR(pNewPermissoes,201,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,202,1),SUBSTR(pNewPermissoes,202,1)) <> 1 THEN
        cRetorno := cRetorno || '"202 - Permitir Execuo do Processo de Importao e Exportao Totall." ' || SUBSTR(pOldPermissoes,202,1) || ' para ' || SUBSTR(pNewPermissoes,202,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,203,1),SUBSTR(pNewPermissoes,203,1)) <> 1 THEN
        cRetorno := cRetorno || '"203 - Emitir Relatrio Separao." ' || SUBSTR(pOldPermissoes,203,1) || ' para ' || SUBSTR(pNewPermissoes,203,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,204,1),SUBSTR(pNewPermissoes,204,1)) <> 1 THEN
        cRetorno := cRetorno || '"204 - V lanamentos em sries restritas." "' || SUBSTR(pOldPermissoes,204,1) || ' para ' || SUBSTR(pNewPermissoes,204,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,205,1),SUBSTR(pNewPermissoes,205,1)) <> 1 THEN
        cRetorno := cRetorno || '"205 - Lana em sries restritas." ' || SUBSTR(pOldPermissoes,205,1) || ' para ' || SUBSTR(pNewPermissoes,205,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,206,1),SUBSTR(pNewPermissoes,206,1)) <> 1 THEN
        cRetorno := cRetorno || '"206 - Operaes com combustveis(somente postos)." ' || SUBSTR(pOldPermissoes,206,1) || ' para ' || SUBSTR(pNewPermissoes,206,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,207,1),SUBSTR(pNewPermissoes,207,1)) <> 1 THEN
        cRetorno := cRetorno || '"207 - Controle do console de bomba." ' || SUBSTR(pOldPermissoes,207,1) || ' para ' || SUBSTR(pNewPermissoes,207,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,208,1),SUBSTR(pNewPermissoes,208,1)) <> 1 THEN
        cRetorno := cRetorno || '"208 - Produtos Controlados." ' || SUBSTR(pOldPermissoes,208,1) || ' para ' || SUBSTR(pNewPermissoes,208,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,209,1),SUBSTR(pNewPermissoes,209,1)) <> 1 THEN
        cRetorno := cRetorno || '"209 - Inventrio - Movimentao." ' || SUBSTR(pOldPermissoes,209,1) || ' para ' || SUBSTR(pNewPermissoes,209,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,210,1),SUBSTR(pNewPermissoes,210,1)) <> 1 THEN
        cRetorno := cRetorno || '"210 - Importao Exportao Integrao." ' || SUBSTR(pOldPermissoes,210,1) || ' para ' || SUBSTR(pNewPermissoes,210,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,211,1),SUBSTR(pNewPermissoes,211,1)) <> 1 THEN
        cRetorno := cRetorno || '"211 - Consulta Cupom Fiscal." ' || SUBSTR(pOldPermissoes,211,1) || ' para ' || SUBSTR(pNewPermissoes,211,1) || cCRLF;
      END IF;  
      IF Equal(SUBSTR(pOldPermissoes,212,1),SUBSTR(pNewPermissoes,212,1)) <> 1 THEN
        cRetorno := cRetorno || '"212 - Fluxo de Caixa." ' || SUBSTR(pOldPermissoes,212,1) || ' para ' || SUBSTR(pNewPermissoes,212,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,213,1),SUBSTR(pNewPermissoes,213,1)) <> 1 THEN
        cRetorno := cRetorno || '"213 - Aceitar Venda Fora do Plano." ' || SUBSTR(pOldPermissoes,213,1) || ' para ' || SUBSTR(pNewPermissoes,213,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,214,1),SUBSTR(pNewPermissoes,214,1)) <> 1 THEN
        cRetorno := cRetorno || '"214 - Utilizar busca de oramentos na pr-venda." ' || SUBSTR(pOldPermissoes,214,1) || ' para ' || SUBSTR(pNewPermissoes,214,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,215,1),SUBSTR(pNewPermissoes,215,1)) <> 1 THEN
        cRetorno := cRetorno || '"215 - Abrir Totall Speed ao entrar no Totall Backoffice." ' || SUBSTR(pOldPermissoes,215,1) || ' para ' || SUBSTR(pNewPermissoes,215,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,216,1),SUBSTR(pNewPermissoes,216,1)) <> 1 THEN
        cRetorno := cRetorno || '"216 - Incluir item de OS." ' || SUBSTR(pOldPermissoes,216,1) || ' para ' || SUBSTR(pNewPermissoes,213,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,217,1),SUBSTR(pNewPermissoes,217,1)) <> 1 THEN
        cRetorno := cRetorno || '"217 - Cancelar item de OS." ' || SUBSTR(pOldPermissoes,217,1) || ' para ' || SUBSTR(pNewPermissoes,217,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,218,1),SUBSTR(pNewPermissoes,218,1)) <> 1 THEN
        cRetorno := cRetorno || '"218 - Concluir item de OS." ' || SUBSTR(pOldPermissoes,218,1) || ' para ' || SUBSTR(pNewPermissoes,218,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,219,1),SUBSTR(pNewPermissoes,219,1)) <> 1 THEN
        cRetorno := cRetorno || '"219 - Editar OS no concluda." ' || SUBSTR(pOldPermissoes,219,1) || ' para ' || SUBSTR(pNewPermissoes,219,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,220,1),SUBSTR(pNewPermissoes,220,1)) <> 1 THEN
        cRetorno := cRetorno || '"220 - " Cadastrar equipamento." ' || SUBSTR(pOldPermissoes,220,1) || ' para ' || SUBSTR(pNewPermissoes,220,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,221,1),SUBSTR(pNewPermissoes,221,1)) <> 1 THEN
        cRetorno := cRetorno || '"221 - Cadastrar tipo de equipamento." ' || SUBSTR(pOldPermissoes,221,1) || ' para ' || SUBSTR(pNewPermissoes,221,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,222,1),SUBSTR(pNewPermissoes,222,1)) <> 1 THEN
        cRetorno := cRetorno || '"222 - Alterar cliente venda ao consumidor." ' || SUBSTR(pOldPermissoes,222,1) || ' para ' || SUBSTR(pNewPermissoes,222,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,223,1),SUBSTR(pNewPermissoes,223,1)) <> 1 THEN 
        cRetorno := cRetorno || '"223 - Acompanhamento de Comandas." ' || SUBSTR(pOldPermissoes,223,1) || ' para ' || SUBSTR(pNewPermissoes,223,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,224,1),SUBSTR(pNewPermissoes,224,1)) <> 1 THEN
        cRetorno := cRetorno || '"224 - Alterar quantidades do oramento na pr-venda." ' || SUBSTR(pOldPermissoes,224,1) || ' para ' || SUBSTR(pNewPermissoes,224,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,225,1),SUBSTR(pNewPermissoes,225,1)) <> 1 THEN 
        cRetorno := cRetorno || '"225 - Fluxo de Caixa." ' || SUBSTR(pOldPermissoes,225,1) || ' para ' || SUBSTR(pNewPermissoes,225,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,226,1),SUBSTR(pNewPermissoes,226,1)) <> 1 THEN
        cRetorno := cRetorno || '"226 - Configurar e Utilizar Servidor de MicroTerminais." ' || SUBSTR(pOldPermissoes,226,1) || ' para ' || SUBSTR(pNewPermissoes,226,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,227,1),SUBSTR(pNewPermissoes,227,1)) <> 1 THEN
        cRetorno := cRetorno || '"227 - Troca de Bobina." ' || SUBSTR(pOldPermissoes,227,1) || ' para ' || SUBSTR(pNewPermissoes,227,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,228,1),SUBSTR(pNewPermissoes,228,1)) <> 1 THEN
        cRetorno := cRetorno || '"228 - Movimentao de produtos ou grade." ' || SUBSTR(pOldPermissoes,228,1) || ' para ' || SUBSTR(pNewPermissoes,228,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,229,1),SUBSTR(pNewPermissoes,229,1)) <> 1 THEN
        cRetorno := cRetorno || '"229 - Faturamento com Desconto." ' || SUBSTR(pOldPermissoes,229,1) || ' para ' || SUBSTR(pNewPermissoes,229,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,230,1),SUBSTR(pNewPermissoes,230,1)) <> 1 THEN
        cRetorno := cRetorno || '"230 - Cancelar nota na Retaguarda." ' || SUBSTR(pOldPermissoes,230,1) || ' para ' || SUBSTR(pNewPermissoes,230,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,231,1),SUBSTR(pNewPermissoes,231,1)) <> 1 THEN
        cRetorno := cRetorno || '"231 - Devoluo de Notas." ' || SUBSTR(pOldPermissoes,231,1) || ' para ' || SUBSTR(pNewPermissoes,231,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,232,1),SUBSTR(pNewPermissoes,232,1)) <> 1 THEN
        cRetorno := cRetorno || '"232 - Cancelamento de Compromissos(Ttulos)." ' || SUBSTR(pOldPermissoes,232,1) || ' para ' || SUBSTR(pNewPermissoes,232,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,233,1),SUBSTR(pNewPermissoes,233,1)) <> 1 THEN 
        cRetorno := cRetorno || '"233 - Atualiza custos na compra." ' || SUBSTR(pOldPermissoes,233,1) || ' para ' || SUBSTR(pNewPermissoes,233,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,234,1),SUBSTR(pNewPermissoes,234,1)) <> 1 THEN
        cRetorno := cRetorno || '"234 - Livro Caixa." ' || SUBSTR(pOldPermissoes,234,1) || ' para ' || SUBSTR(pNewPermissoes,234,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,235,1),SUBSTR(pNewPermissoes,235,1)) <> 1 THEN
        cRetorno := cRetorno || '"235 - Imprimir Etiquetas de Produtos." ' || SUBSTR(pOldPermissoes,235,1) || ' para ' || SUBSTR(pNewPermissoes,235,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,236,1),SUBSTR(pNewPermissoes,236,1)) <> 1 THEN
        cRetorno := cRetorno || '"236 - Cadastrar Papis." ' || SUBSTR(pOldPermissoes,236,1) || ' para ' || SUBSTR(pNewPermissoes,236,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,237,1),SUBSTR(pNewPermissoes,237,1)) <> 1 THEN
        cRetorno := cRetorno || '"237 - Autorizar vendas com desconto acima do valor permitido." ' || SUBSTR(pOldPermissoes,237,1) || ' para ' || SUBSTR(pNewPermissoes,237,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,238,1),SUBSTR(pNewPermissoes,238,1)) <> 1 THEN 
        cRetorno := cRetorno || '"238 - Recebimento de parcela em cheque/carto parcelado." ' || SUBSTR(pOldPermissoes,238,1) || ' para ' || SUBSTR(pNewPermissoes,238,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,239,1),SUBSTR(pNewPermissoes,239,1)) <> 1 THEN
        cRetorno := cRetorno || '"239 - Recepo de compras." ' || SUBSTR(pOldPermissoes,239,1) || ' para ' || SUBSTR(pNewPermissoes,239,1) || cCRLF;
      END IF;
       IF Equal(SUBSTR(pOldPermissoes,240,1),SUBSTR(pNewPermissoes,240,1)) <> 1 THEN
        cRetorno := cRetorno || '"240 - Alterao do cliente da C/C." ' || SUBSTR(pOldPermissoes,240,1) || ' para ' || SUBSTR(pNewPermissoes,240,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,241,1),SUBSTR(pNewPermissoes,241,1)) <> 1 THEN
        cRetorno := cRetorno || '"241 - Acesso ao Totall Backoffice." ' || SUBSTR(pOldPermissoes,241,1) || ' para ' || SUBSTR(pNewPermissoes,241,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,242,1),SUBSTR(pNewPermissoes,242,1)) <> 1 THEN 
        cRetorno := cRetorno || '"242 - Realiza aferio de bombas de combustveis." ' || SUBSTR(pOldPermissoes,242,1) || ' para ' || SUBSTR(pNewPermissoes,242,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,243,1),SUBSTR(pNewPermissoes,243,1)) <> 1 THEN 
        cRetorno := cRetorno || '"243 - Digitar Reduo Z Manual." ' || SUBSTR(pOldPermissoes,243,1) || ' para ' || SUBSTR(pNewPermissoes,243,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,244,1),SUBSTR(pNewPermissoes,244,1)) <> 1 THEN
        cRetorno := cRetorno || '"244 - Permite Cancelar Lanamentos e Transferncias Financeiras." ' || SUBSTR(pOldPermissoes,244,1) || ' para ' || SUBSTR(pNewPermissoes,244,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,245,1),SUBSTR(pNewPermissoes,245,1)) <> 1 THEN 
        cRetorno := cRetorno || '"245 - Permite Alterar Lanamentos Financeiros." ' || SUBSTR(pOldPermissoes,245,1) || ' para ' || SUBSTR(pNewPermissoes,245,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,246,1),SUBSTR(pNewPermissoes,246,1)) <> 1 THEN
        cRetorno := cRetorno || '"246 - Conciliao de Cartes." ' || SUBSTR(pOldPermissoes,246,1) || ' para ' || SUBSTR(pNewPermissoes,246,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,247,1),SUBSTR(pNewPermissoes,247,1)) <> 1 THEN   
        cRetorno := cRetorno || '"247 - Gerao Cheques Avulsos a Fornecedores." ' || SUBSTR(pOldPermissoes,247,1) || ' para ' || SUBSTR(pNewPermissoes,247,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,248,1),SUBSTR(pNewPermissoes,248,1)) <> 1 THEN 
        cRetorno := cRetorno || '"248 - Acessar impresso de contedo de cargas." ' || SUBSTR(pOldPermissoes,248,1) || ' para ' || SUBSTR(pNewPermissoes,248,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,249,1),SUBSTR(pNewPermissoes,249,1)) <> 1 THEN 
        cRetorno := cRetorno || '"249 - Acompanhamento de Oramentos." ' || SUBSTR(pOldPermissoes,249,1) || ' para ' || SUBSTR(pNewPermissoes,249,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,250,1),SUBSTR(pNewPermissoes,250,1)) <> 1 THEN
        cRetorno := cRetorno || '"250 - Efetivar Entrega Futura." ' || SUBSTR(pOldPermissoes,250,1) || ' para ' || SUBSTR(pNewPermissoes,250,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,251,1),SUBSTR(pNewPermissoes,251,1)) <> 1 THEN 
        cRetorno := cRetorno || '"251 - Autorizar Venda sob Encomenda." ' || SUBSTR(pOldPermissoes,251,1) || ' para ' || SUBSTR(pNewPermissoes,251,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,252,1),SUBSTR(pNewPermissoes,252,1)) <> 1 THEN 
        cRetorno := cRetorno || '"252 - Vender com Micro terminais." ' || SUBSTR(pOldPermissoes,252,1) || ' para ' || SUBSTR(pNewPermissoes,252,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,253,1),SUBSTR(pNewPermissoes,253,1)) <> 1 THEN 
        cRetorno := cRetorno || '"253 - Acessar Distribuio de Carga." ' || SUBSTR(pOldPermissoes,253,1) || ' para ' || SUBSTR(pNewPermissoes,253,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,254,1),SUBSTR(pNewPermissoes,254,1)) <> 1 THEN
        cRetorno := cRetorno || '"254 - Acessar Lanamentos de Preos da Concorrncia." ' || SUBSTR(pOldPermissoes,254,1) || ' para ' || SUBSTR(pNewPermissoes,254,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,255,1),SUBSTR(pNewPermissoes,255,1)) <> 1 THEN
        cRetorno := cRetorno || '"255 - Permitir alterar plano padro do cliente." ' || SUBSTR(pOldPermissoes,255,1) || ' para ' || SUBSTR(pNewPermissoes,255,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,256,1),SUBSTR(pNewPermissoes,256,1)) <> 1 THEN 
        cRetorno := cRetorno || '"256 - Logar em Filial Desativada." ' || SUBSTR(pOldPermissoes,256,1) || ' para ' || SUBSTR(pNewPermissoes,256,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,257,1),SUBSTR(pNewPermissoes,257,1)) <> 1 THEN
        cRetorno := cRetorno || '"257 - Gerar de arquivos para Nota Fiscal Paulista." ' || SUBSTR(pOldPermissoes,257,1) || ' para ' || SUBSTR(pNewPermissoes,257,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,258,1),SUBSTR(pNewPermissoes,258,1)) <> 1 THEN
        cRetorno := cRetorno || '"258 - Permitir logar em filial desativada." ' || SUBSTR(pOldPermissoes,258,1) || ' para ' || SUBSTR(pNewPermissoes,258,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,259,1),SUBSTR(pNewPermissoes,259,1)) <> 1 THEN
        cRetorno := cRetorno || '"259 - Registrar Notas sem Pedido." ' || SUBSTR(pOldPermissoes,259,1) || ' para ' || SUBSTR(pNewPermissoes,259,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,260,1),SUBSTR(pNewPermissoes,260,1)) <> 1 THEN 
        cRetorno := cRetorno || '"260 - Realizar Troca de Vendedor." ' || SUBSTR(pOldPermissoes,260,1) || ' para ' || SUBSTR(pNewPermissoes,260,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,261,1),SUBSTR(pNewPermissoes,261,1)) <> 1 THEN 
        cRetorno := cRetorno || '"261 - Desativar Endereo." ' || SUBSTR(pOldPermissoes,261,1) || ' para ' || SUBSTR(pNewPermissoes,261,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,262,1),SUBSTR(pNewPermissoes,262,1)) <> 1 THEN 
        cRetorno := cRetorno || '"262 - Abrir oramentos de outros vendedores." ' || SUBSTR(pOldPermissoes,262,1) || ' para ' || SUBSTR(pNewPermissoes,262,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,263,1),SUBSTR(pNewPermissoes,263,1)) <> 1 THEN 
        cRetorno := cRetorno || '"263 - Reparcelamento de Conta a Pagar." ' || SUBSTR(pOldPermissoes,263,1) || ' para ' || SUBSTR(pNewPermissoes,263,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,264,1),SUBSTR(pNewPermissoes,264,1)) <> 1 THEN 
        cRetorno := cRetorno || '"264 - Autorizar Pedido de Reposio." ' || SUBSTR(pOldPermissoes,264,1) || ' para ' || SUBSTR(pNewPermissoes,264,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,265,1),SUBSTR(pNewPermissoes,265,1)) <> 1 THEN 
        cRetorno := cRetorno || '"265 - Selecionar filial para reserva." ' || SUBSTR(pOldPermissoes,265,1) || ' para ' || SUBSTR(pNewPermissoes,265,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,266,1),SUBSTR(pNewPermissoes,266,1)) <> 1 THEN 
        cRetorno := cRetorno || '"266 - Usar srie diferente da padro." ' || SUBSTR(pOldPermissoes,266,1) || ' para ' || SUBSTR(pNewPermissoes,266,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,267,1),SUBSTR(pNewPermissoes,267,1)) <> 1 THEN 
        cRetorno := cRetorno || '"267 - Ignora contagem de Cheques em Totall Backoffice/Tesouraria." ' || SUBSTR(pOldPermissoes,267,1) || ' para ' || SUBSTR(pNewPermissoes,267,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,268,1),SUBSTR(pNewPermissoes,268,1)) <> 1 THEN 
        cRetorno := cRetorno || '"268 - Tela de Conferncia de Separao." ' || SUBSTR(pOldPermissoes,268,1) || ' para ' || SUBSTR(pNewPermissoes,268,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,269,1),SUBSTR(pNewPermissoes,269,1)) <> 1 THEN 
        cRetorno := cRetorno || '"269 - Configurar Cobre Bem." ' || SUBSTR(pOldPermissoes,269,1) || ' para ' || SUBSTR(pNewPermissoes,269,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,270,1),SUBSTR(pNewPermissoes,270,1)) <> 1 THEN 
        cRetorno := cRetorno || '"270 - Autorizar pagamento a consultor de RAT." ' || SUBSTR(pOldPermissoes,270,1) || ' para ' || SUBSTR(pNewPermissoes,270,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,271,1),SUBSTR(pNewPermissoes,271,1)) <> 1 THEN 
        cRetorno := cRetorno || '"271 - Autoriza Sries no configuradas para o ECF." ' || SUBSTR(pOldPermissoes,271,1) || ' para ' || SUBSTR(pNewPermissoes,271,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,272,1),SUBSTR(pNewPermissoes,272,1)) <> 1 THEN 
        cRetorno := cRetorno || '"272 - Compromissos Repetitivos." ' || SUBSTR(pOldPermissoes,272,1) || ' para ' || SUBSTR(pNewPermissoes,272,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,273,1),SUBSTR(pNewPermissoes,273,1)) <> 1 THEN 
        cRetorno := cRetorno || '"273 - Alterar Valor Comisso." ' || SUBSTR(pOldPermissoes,273,1) || ' para ' || SUBSTR(pNewPermissoes,273,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,274,1),SUBSTR(pNewPermissoes,274,1)) <> 1 THEN 
        cRetorno := cRetorno || '"274 - Autoriza Comisso." ' || SUBSTR(pOldPermissoes,274,1) || ' para ' || SUBSTR(pNewPermissoes,274,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,275,1),SUBSTR(pNewPermissoes,275,1)) <> 1 THEN 
        cRetorno := cRetorno || '"275 - Reimprimir Boleto." ' || SUBSTR(pOldPermissoes,275,1) || ' para ' || SUBSTR(pNewPermissoes,275,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,276,1),SUBSTR(pNewPermissoes,276,1)) <> 1 THEN 
        cRetorno := cRetorno || '"276 - Estorno de Tarefas com Erro." ' || SUBSTR(pOldPermissoes,276,1) || ' para ' || SUBSTR(pNewPermissoes,276,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,277,1),SUBSTR(pNewPermissoes,277,1)) <> 1 THEN 
        cRetorno := cRetorno || '"277 - Gerenciar Comisses." ' || SUBSTR(pOldPermissoes,277,1) || ' para ' || SUBSTR(pNewPermissoes,277,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,278,1),SUBSTR(pNewPermissoes,278,1)) <> 1 THEN 
        cRetorno := cRetorno || '"278 - Venda sob Encomenda." ' || SUBSTR(pOldPermissoes,278,1) || ' para ' || SUBSTR(pNewPermissoes,278,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,279,1),SUBSTR(pNewPermissoes,279,1)) <> 1 THEN 
        cRetorno := cRetorno || '"279 - Configurar combustveis por filial e produto 73457 5.0." ' || SUBSTR(pOldPermissoes,279,1) || ' para ' || SUBSTR(pNewPermissoes,279,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,280,1),SUBSTR(pNewPermissoes,280,1)) <> 1 THEN 
        cRetorno := cRetorno || '"280 - Alterar parceiro." ' || SUBSTR(pOldPermissoes,280,1) || ' para ' || SUBSTR(pNewPermissoes,280,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,281,1),SUBSTR(pNewPermissoes,281,1)) <> 1 THEN 
        cRetorno := cRetorno || '"281 - Acesso a DisponibilidaDe Entrega." ' || SUBSTR(pOldPermissoes,281,1) || ' para ' || SUBSTR(pNewPermissoes,281,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,282,1),SUBSTR(pNewPermissoes,282,1)) <> 1 THEN 
        cRetorno := cRetorno || '"282 - Acesso a Sries Fiscais." ' || SUBSTR(pOldPermissoes,282,1) || ' para ' || SUBSTR(pNewPermissoes,282,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,283,1),SUBSTR(pNewPermissoes,283,1)) <> 1 THEN 
        cRetorno := cRetorno || '"283 - Acesso a Distribuio de Estoque." ' || SUBSTR(pOldPermissoes,283,1) || ' para ' || SUBSTR(pNewPermissoes,283,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,284,1),SUBSTR(pNewPermissoes,284,1)) <> 1 THEN 
        cRetorno := cRetorno || '"284 - Cadastrar Marcas." ' || SUBSTR(pOldPermissoes,284,1) || ' para ' || SUBSTR(pNewPermissoes,284,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,285,1),SUBSTR(pNewPermissoes,285,1)) <> 1 THEN 
        cRetorno := cRetorno || '"285 - Acesso a Sugesto de Compra." ' || SUBSTR(pOldPermissoes,285,1) || ' para ' || SUBSTR(pNewPermissoes,285,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,286,1),SUBSTR(pNewPermissoes,286,1)) <> 1 THEN 
        cRetorno := cRetorno || '"286 - Acesso a Sugesto de Compra." ' || SUBSTR(pOldPermissoes,286,1) || ' para ' || SUBSTR(pNewPermissoes,286,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,287,1),SUBSTR(pNewPermissoes,287,1)) <> 1 THEN 
        cRetorno := cRetorno || '"287 - Acesso a Pr-Faturamento." ' || SUBSTR(pOldPermissoes,287,1) || ' para ' || SUBSTR(pNewPermissoes,287,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,288,1),SUBSTR(pNewPermissoes,288,1)) <> 1 THEN 
        cRetorno := cRetorno || '"288 - Acesso a Sugerir ao Vender." ' || SUBSTR(pOldPermissoes,288,1) || ' para ' || SUBSTR(pNewPermissoes,288,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,289,1),SUBSTR(pNewPermissoes,289,1)) <> 1 THEN 
        cRetorno := cRetorno || '"289 - Acesso a Indisponveis para Venda." ' || SUBSTR(pOldPermissoes,289,1) || ' para ' || SUBSTR(pNewPermissoes,289,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,290,1),SUBSTR(pNewPermissoes,290,1)) <> 1 THEN 
        cRetorno := cRetorno || '"290 - Acesso a Classificao de Produtos." ' || SUBSTR(pOldPermissoes,290,1) || ' para ' || SUBSTR(pNewPermissoes,290,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,291,1),SUBSTR(pNewPermissoes,291,1)) <> 1 THEN 
        cRetorno := cRetorno || '"291 - Acesso a Transferncias Identificadas." ' || SUBSTR(pOldPermissoes,291,1) || ' para ' || SUBSTR(pNewPermissoes,291,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,292,1),SUBSTR(pNewPermissoes,292,1)) <> 1 THEN 
        cRetorno := cRetorno || '"292 - Acesso a Descontos CC." ' || SUBSTR(pOldPermissoes,292,1) || ' para ' || SUBSTR(pNewPermissoes,292,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,293,1),SUBSTR(pNewPermissoes,293,1)) <> 1 THEN 
        cRetorno := cRetorno || '"293 - Acesso a Horrios." ' || SUBSTR(pOldPermissoes,293,1) || ' para ' || SUBSTR(pNewPermissoes,293,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,294,1),SUBSTR(pNewPermissoes,294,1)) <> 1 THEN 
        cRetorno := cRetorno || '"294 - Acesso a Exportao para MT Fiscal." ' || SUBSTR(pOldPermissoes,294,1) || ' para ' || SUBSTR(pNewPermissoes,294,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,295,1),SUBSTR(pNewPermissoes,295,1)) <> 1 THEN 
        cRetorno := cRetorno || '"295 - Acesso a Exportao para Sapiens." ' || SUBSTR(pOldPermissoes,295,1) || ' para ' || SUBSTR(pNewPermissoes,295,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,296,1),SUBSTR(pNewPermissoes,296,1)) <> 1 THEN 
        cRetorno := cRetorno || '"296 - Acesso a Exportao para Nota Fiscal Eletrnica." ' || SUBSTR(pOldPermissoes,296,1) || ' para ' || SUBSTR(pNewPermissoes,296,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,297,1),SUBSTR(pNewPermissoes,297,1)) <> 1 THEN 
        cRetorno := cRetorno || '"297 - Acesso a Exportao para Nota Fiscal Paulista." ' || SUBSTR(pOldPermissoes,297,1) || ' para ' || SUBSTR(pNewPermissoes,297,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,298,1),SUBSTR(pNewPermissoes,298,1)) <> 1 THEN 
        cRetorno := cRetorno || '"298 - Acesso a Exportao para HSBC." ' || SUBSTR(pOldPermissoes,298,1) || ' para ' || SUBSTR(pNewPermissoes,298,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,299,1),SUBSTR(pNewPermissoes,299,1)) <> 1 THEN 
        cRetorno := cRetorno || '"299 - Acesso a Exportao para BESC." ' || SUBSTR(pOldPermissoes,299,1) || ' para ' || SUBSTR(pNewPermissoes,299,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,300,1),SUBSTR(pNewPermissoes,300,1)) <> 1 THEN 
        cRetorno := cRetorno || '"300 - Acesso a Exportao para Balana Filizola." ' || SUBSTR(pOldPermissoes,300,1) || ' para ' || SUBSTR(pNewPermissoes,300,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,301,1),SUBSTR(pNewPermissoes,301,1)) <> 1 THEN 
        cRetorno := cRetorno || '"301 - Acesso a Exportao Contbil." ' || SUBSTR(pOldPermissoes,301,1) || ' para ' || SUBSTR(pNewPermissoes,301,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,302,1),SUBSTR(pNewPermissoes,302,1)) <> 1 THEN 
        cRetorno := cRetorno || '"302 - Acesso a Unio de Grades." ' || SUBSTR(pOldPermissoes,302,1) || ' para ' || SUBSTR(pNewPermissoes,302,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,303,1),SUBSTR(pNewPermissoes,303,1)) <> 1 THEN 
        cRetorno := cRetorno || '"303 - Acesso a Unio de Parceiros." ' || SUBSTR(pOldPermissoes,303,1) || ' para ' || SUBSTR(pNewPermissoes,303,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,304,1),SUBSTR(pNewPermissoes,304,1)) <> 1 THEN 
        cRetorno := cRetorno || '"304 - Acesso a Mtricas." ' || SUBSTR(pOldPermissoes,304,1) || ' para ' || SUBSTR(pNewPermissoes,304,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,305,1),SUBSTR(pNewPermissoes,305,1)) <> 1 THEN 
        cRetorno := cRetorno || '"305 - Acesso ao Calendrio." ' || SUBSTR(pOldPermissoes,305,1) || ' para ' || SUBSTR(pNewPermissoes,305,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,306,1),SUBSTR(pNewPermissoes,306,1)) <> 1 THEN 
        cRetorno := cRetorno || '"306 - Acesso a Conferncia de Mercadorias." ' || SUBSTR(pOldPermissoes,306,1) || ' para ' || SUBSTR(pNewPermissoes,306,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,307,1),SUBSTR(pNewPermissoes,307,1)) <> 1 THEN 
        cRetorno := cRetorno || '"307 - Acesso ao Totall Delivery." ' || SUBSTR(pOldPermissoes,307,1) || ' para ' || SUBSTR(pNewPermissoes,307,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,308,1),SUBSTR(pNewPermissoes,308,1)) <> 1 THEN 
        cRetorno := cRetorno || '"308 - Informar tipo de pagamento na pr-venda." ' || SUBSTR(pOldPermissoes,308,1) || ' para ' || SUBSTR(pNewPermissoes,308,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,309,1),SUBSTR(pNewPermissoes,309,1)) <> 1 THEN 
        cRetorno := cRetorno || '"309 - Acesso a Vendas Perdidas." ' || SUBSTR(pOldPermissoes,309,1) || ' para ' || SUBSTR(pNewPermissoes,309,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,310,1),SUBSTR(pNewPermissoes,310,1)) <> 1 THEN 
        cRetorno := cRetorno || '"310 - Acesso ao Totall Order." ' || SUBSTR(pOldPermissoes,310,1) || ' para ' || SUBSTR(pNewPermissoes,310,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,311,1),SUBSTR(pNewPermissoes,311,1)) <> 1 THEN 
        cRetorno := cRetorno || '"311 - Cadastrar Variaes de Custo." ' || SUBSTR(pOldPermissoes,311,1) || ' para ' || SUBSTR(pNewPermissoes,311,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,312,1),SUBSTR(pNewPermissoes,312,1)) <> 1 THEN 
        cRetorno := cRetorno || '"312 - Cadastrar Produtos Similares." ' || SUBSTR(pOldPermissoes,312,1) || ' para ' || SUBSTR(pNewPermissoes,312,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,313,1),SUBSTR(pNewPermissoes,313,1)) <> 1 THEN 
        cRetorno := cRetorno || '"313 - Cadastrar Kit." ' || SUBSTR(pOldPermissoes,313,1) || ' para ' || SUBSTR(pNewPermissoes,313,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,314,1),SUBSTR(pNewPermissoes,314,1)) <> 1 THEN 
        cRetorno := cRetorno || '"314 - Cadastrar Informaes Nutricionais." ' || SUBSTR(pOldPermissoes,314,1) || ' para ' || SUBSTR(pNewPermissoes,314,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,315,1),SUBSTR(pNewPermissoes,315,1)) <> 1 THEN 
        cRetorno := cRetorno || '"315 - Cadastrar Colunas Personalizadas." ' || SUBSTR(pOldPermissoes,315,1) || ' para ' || SUBSTR(pNewPermissoes,315,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,316,1),SUBSTR(pNewPermissoes,316,1)) <> 1 THEN 
        cRetorno := cRetorno || '"316 - Cancelar Pedidos." ' || SUBSTR(pOldPermissoes,316,1) || ' para ' || SUBSTR(pNewPermissoes,316,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,317,1),SUBSTR(pNewPermissoes,317,1)) <> 1 THEN 
        cRetorno := cRetorno || '"317 - Acesso ao Pedido Eletrnico." ' || SUBSTR(pOldPermissoes,317,1) || ' para ' || SUBSTR(pNewPermissoes,317,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,318,1),SUBSTR(pNewPermissoes,318,1)) <> 1 THEN 
        cRetorno := cRetorno || '"318 - Acesso a Formao de Preo de Venda." ' || SUBSTR(pOldPermissoes,318,1) || ' para ' || SUBSTR(pNewPermissoes,318,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,319,1),SUBSTR(pNewPermissoes,319,1)) <> 1 THEN 
        cRetorno := cRetorno || '"319 - Acesso a Promoes." ' || SUBSTR(pOldPermissoes,319,1) || ' para ' || SUBSTR(pNewPermissoes,319,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,320,1),SUBSTR(pNewPermissoes,320,1)) <> 1 THEN 
        cRetorno := cRetorno || '"320 - Acesso a Preos Diferenciados." ' || SUBSTR(pOldPermissoes,320,1) || ' para ' || SUBSTR(pNewPermissoes,320,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,321,1),SUBSTR(pNewPermissoes,321,1)) <> 1 THEN 
        cRetorno := cRetorno || '"321 - Acesso a Aviso para Motoristas." ' || SUBSTR(pOldPermissoes,321,1) || ' para ' || SUBSTR(pNewPermissoes,321,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,322,1),SUBSTR(pNewPermissoes,322,1)) <> 1 THEN 
        cRetorno := cRetorno || '"322 - Gerncia de SPC." ' || SUBSTR(pOldPermissoes,322,1) || ' para ' || SUBSTR(pNewPermissoes,322,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,323,1),SUBSTR(pNewPermissoes,323,1)) <> 1 THEN 
        cRetorno := cRetorno || '"323 - Visualizar Histrico." ' || SUBSTR(pOldPermissoes,323,1) || ' para ' || SUBSTR(pNewPermissoes,323,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,324,1),SUBSTR(pNewPermissoes,324,1)) <> 1 THEN 
        cRetorno := cRetorno || '"324 - Acesso a Movimentao de DAV." ' || SUBSTR(pOldPermissoes,324,1) || ' para ' || SUBSTR(pNewPermissoes,324,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,325,1),SUBSTR(pNewPermissoes,325,1)) <> 1 THEN 
        cRetorno := cRetorno || '"325 - Acesso a Movimentao de Sada." ' || SUBSTR(pOldPermissoes,325,1) || ' para ' || SUBSTR(pNewPermissoes,325,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,326,1),SUBSTR(pNewPermissoes,326,1)) <> 1 THEN 
        cRetorno := cRetorno || '"326 - Cadastrar Observaes de Venda." ' || SUBSTR(pOldPermissoes,326,1) || ' para ' || SUBSTR(pNewPermissoes,326,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,327,1),SUBSTR(pNewPermissoes,327,1)) <> 1 THEN 
        cRetorno := cRetorno || '"327 - Registrar Lacre." ' || SUBSTR(pOldPermissoes,327,1) || ' para ' || SUBSTR(pNewPermissoes,327,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,328,1),SUBSTR(pNewPermissoes,328,1)) <> 1 THEN 
        cRetorno := cRetorno || '"328 - Escriturao Fiscal Digital." ' || SUBSTR(pOldPermissoes,328,1) || ' para ' || SUBSTR(pNewPermissoes,328,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,329,1),SUBSTR(pNewPermissoes,329,1)) <> 1 THEN 
        cRetorno := cRetorno || '"329 - Alterar Parceiro no Checkout." ' || SUBSTR(pOldPermissoes,329,1) || ' para ' || SUBSTR(pNewPermissoes,329,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,330,1),SUBSTR(pNewPermissoes,330,1)) <> 1 THEN 
        cRetorno := cRetorno || '"330 - Registrar aviso de recebimento." ' || SUBSTR(pOldPermissoes,330,1) || ' para ' || SUBSTR(pNewPermissoes,330,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,331,1),SUBSTR(pNewPermissoes,331,1)) <> 1 THEN 
        cRetorno := cRetorno || '"331 - Alterar Indicador da Venda." ' || SUBSTR(pOldPermissoes,331,1) || ' para ' || SUBSTR(pNewPermissoes,331,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,332,1),SUBSTR(pNewPermissoes,332,1)) <> 1 THEN 
        cRetorno := cRetorno || '"332 - Acesso ao Totall Decisor." ' || SUBSTR(pOldPermissoes,332,1) || ' para ' || SUBSTR(pNewPermissoes,332,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,333,1),SUBSTR(pNewPermissoes,333,1)) <> 1 THEN 
        cRetorno := cRetorno || '"333 - Usar sries no permitidas para o produto(Obs: Verso 4.5C n 279)." ' ||  SUBSTR(pOldPermissoes,333,1) || ' para ' || SUBSTR(pNewPermissoes,333,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,334,1),SUBSTR(pNewPermissoes,334,1)) <> 1 THEN 
        cRetorno := cRetorno || '"334 - Devoluo de Adiantamento em C/C." ' || SUBSTR(pOldPermissoes,334,1) || ' para ' || SUBSTR(pNewPermissoes,334,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,335,1),SUBSTR(pNewPermissoes,335,1)) <> 1 THEN 
        cRetorno := cRetorno || '"335 - Autoriza Transferncia sem Estoque." ' || SUBSTR(pOldPermissoes,335,1) || ' para ' || SUBSTR(pNewPermissoes,335,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,336,1),SUBSTR(pNewPermissoes,336,1)) <> 1 THEN 
        cRetorno := cRetorno || '"336 - Protocolo/Convnio ICMS." ' || SUBSTR(pOldPermissoes,336,1) || ' para ' || SUBSTR(pNewPermissoes,336,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,337,1),SUBSTR(pNewPermissoes,337,1)) <> 1 THEN 
        cRetorno := cRetorno || '"337 - Autorizar alterao de CST na Venda." ' || SUBSTR(pOldPermissoes,337,1) || ' para ' || SUBSTR(pNewPermissoes,337,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,338,1),SUBSTR(pNewPermissoes,338,1)) <> 1 THEN 
        cRetorno := cRetorno || '"338 - Acesso  Central de Crdito." ' || SUBSTR(pOldPermissoes,338,1) || ' para ' || SUBSTR(pNewPermissoes,338,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,339,1),SUBSTR(pNewPermissoes,339,1)) <> 1 THEN 
        cRetorno := cRetorno || '"339 - Acesso a Tela de Mesclagem de DAVs e Pr-Vendas." ' || SUBSTR(pOldPermissoes,339,1) || ' para ' || SUBSTR(pNewPermissoes,339,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,340,1),SUBSTR(pNewPermissoes,340,1)) <> 1 THEN 
        cRetorno := cRetorno || '"340 - Visualizar Anlise de Crdito Assumida por Outro Usurio." ' || SUBSTR(pOldPermissoes,340,1) || ' para ' || SUBSTR(pNewPermissoes,340,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,341,1),SUBSTR(pNewPermissoes,341,1)) <> 1 THEN 
        cRetorno := cRetorno || '"341 - Cadastrar ndice Tcnico de Produo." ' || SUBSTR(pOldPermissoes,341,1) || ' para ' || SUBSTR(pNewPermissoes,341,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,342,1),SUBSTR(pNewPermissoes,342,1)) <> 1 THEN 
        cRetorno := cRetorno || '"342 - Acesso a Produo Prpria." ' || SUBSTR(pOldPermissoes,342,1) || ' para ' || SUBSTR(pNewPermissoes,342,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,343,1),SUBSTR(pNewPermissoes,343,1)) <> 1 THEN 
        cRetorno := cRetorno || '"343 - Acesso a Integrao com Synchro." ' || SUBSTR(pOldPermissoes,343,1) || ' para ' || SUBSTR(pNewPermissoes,343,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,344,1),SUBSTR(pNewPermissoes,344,1)) <> 1 THEN 
        cRetorno := cRetorno || '"344 - Alterao Manual de NF." ' || SUBSTR(pOldPermissoes,344,1) || ' para ' || SUBSTR(pNewPermissoes,344,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,345,1),SUBSTR(pNewPermissoes,345,1)) <> 1 THEN 
        cRetorno := cRetorno || '"345 - Acesso ao Controle de Vendas no E-Commerce." ' || SUBSTR(pOldPermissoes,345,1) || ' para ' || SUBSTR(pNewPermissoes,345,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,346,1),SUBSTR(pNewPermissoes,346,1)) <> 1 THEN 
        cRetorno := cRetorno || '"346 - Definir Horas Cobradas de Projetos." ' || SUBSTR(pOldPermissoes,346,1) || ' para ' || SUBSTR(pNewPermissoes,346,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,347,1),SUBSTR(pNewPermissoes,347,1)) <> 1 THEN 
        cRetorno := cRetorno || '"347 - Autorizao de Alterao de Tributao na Nota Fiscal." ' || SUBSTR(pOldPermissoes,347,1) || ' para ' || SUBSTR(pNewPermissoes,347,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,348,1),SUBSTR(pNewPermissoes,348,1)) <> 1 THEN 
        cRetorno := cRetorno || '"348 - Autorizao de Importao de Nota Fisal Eletrnica." ' || SUBSTR(pOldPermissoes,348,1) || ' para ' || SUBSTR(pNewPermissoes,348,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,349,1),SUBSTR(pNewPermissoes,349,1)) <> 1 THEN 
        cRetorno := cRetorno || '"349 - Permitir Aprovar Receita Bruta da Empresa." ' || SUBSTR(pOldPermissoes,349,1) || ' para ' || SUBSTR(pNewPermissoes,349,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,350,1),SUBSTR(pNewPermissoes,350,1)) <> 1 THEN 
        cRetorno := cRetorno || '"350 - Acesso a Exportao para AC Contbil." ' || SUBSTR(pOldPermissoes,350,1) || ' para ' || SUBSTR(pNewPermissoes,350,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,351,1),SUBSTR(pNewPermissoes,351,1)) <> 1 THEN 
        cRetorno := cRetorno || '"351 - Gerar Recibos Provisrios de Servio (RPS)." ' || SUBSTR(pOldPermissoes,351,1) || ' para ' || SUBSTR(pNewPermissoes,351,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,352,1),SUBSTR(pNewPermissoes,352,1)) <> 1 THEN 
        cRetorno := cRetorno || '"352 - Acesso a Tela de Atualizao de Status de NF-e." ' || SUBSTR(pOldPermissoes,352,1) || ' para ' || SUBSTR(pNewPermissoes,352,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,353,1),SUBSTR(pNewPermissoes,353,1)) <> 1 THEN 
        cRetorno := cRetorno || '"353 - Acesso a Senhas de Servio." ' || SUBSTR(pOldPermissoes,353,1) || ' para ' || SUBSTR(pNewPermissoes,353,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,354,1),SUBSTR(pNewPermissoes,354,1)) <> 1 THEN 
        cRetorno := cRetorno || '"354 - Venda com cheque de conta no cadastrada." ' || SUBSTR(pOldPermissoes,354,1) || ' para ' || SUBSTR(pNewPermissoes,354,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,355,1),SUBSTR(pNewPermissoes,355,1)) <> 1 THEN 
        cRetorno := cRetorno || '"355 - Acesso a Tela de Configuraes de Tipos de Entrega." ' || SUBSTR(pOldPermissoes,355,1) || ' para ' || SUBSTR(pNewPermissoes,355,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,356,1),SUBSTR(pNewPermissoes,356,1)) <> 1 THEN 
        cRetorno := cRetorno || '"356 - Acesso a Tela de Produtos por Cartes de Combustvel." ' || SUBSTR(pOldPermissoes,356,1) || ' para ' || SUBSTR(pNewPermissoes,356,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,357,1),SUBSTR(pNewPermissoes,357,1)) <> 1 THEN 
        cRetorno := cRetorno || '"357 - Ocultar revendas no Totall Checkout." ' || SUBSTR(pOldPermissoes,357,1) || ' para ' || SUBSTR(pNewPermissoes,357,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,358,1),SUBSTR(pNewPermissoes,358,1)) <> 1 THEN 
        cRetorno := cRetorno || '"358 - Acesso ao Custo Mdio Inicial." ' || SUBSTR(pOldPermissoes,358,1) || ' para ' || SUBSTR(pNewPermissoes,358,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,359,1),SUBSTR(pNewPermissoes,359,1)) <> 1 THEN 
        cRetorno := cRetorno || '"359 - Modificar dados da viso do fornecedor na importao de NF-e e edio da compra." ' || SUBSTR(pOldPermissoes,359,1) || ' para ' || SUBSTR(pNewPermissoes,359,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,360,1),SUBSTR(pNewPermissoes,360,1)) <> 1 THEN 
        cRetorno := cRetorno || '"360 - Permitir gravar compra mesmo com inconsistncias." ' || SUBSTR(pOldPermissoes,360,1) || ' para ' || SUBSTR(pNewPermissoes,360,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,361,1),SUBSTR(pNewPermissoes,361,1)) <> 1 THEN 
        cRetorno := cRetorno || '"361 - Permitir cancelar pr-venda nos terminais." ' || SUBSTR(pOldPermissoes,361,1) || ' para ' || SUBSTR(pNewPermissoes,361,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,362,1),SUBSTR(pNewPermissoes,362,1)) <> 1 THEN 
        cRetorno := cRetorno || '"362 - Cadastrar servios adicionais." ' || SUBSTR(pOldPermissoes,362,1) || ' para ' || SUBSTR(pNewPermissoes,362,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,363,1),SUBSTR(pNewPermissoes,363,1)) <> 1 THEN 
        cRetorno := cRetorno || '"363 - Modificar termos dos servios adicionais ao orar e vender." ' || SUBSTR(pOldPermissoes,363,1) || ' para ' || SUBSTR(pNewPermissoes,363,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,364,1),SUBSTR(pNewPermissoes,364,1)) <> 1 THEN 
        cRetorno := cRetorno || '"364 - Acessar tela de venda de servios adicionais avulsos." ' || SUBSTR(pOldPermissoes,364,1) || ' para ' || SUBSTR(pNewPermissoes,364,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,365,1),SUBSTR(pNewPermissoes,365,1)) <> 1 THEN 
        cRetorno := cRetorno || '"365 - Acessar tela de consulta de servios adicionais ps-venda." ' || SUBSTR(pOldPermissoes,365,1) || ' para ' || SUBSTR(pNewPermissoes,365,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,366,1),SUBSTR(pNewPermissoes,366,1)) <> 1 THEN 
        cRetorno := cRetorno || '"366 - Modificar pedido da encomenda." ' || SUBSTR(pOldPermissoes,366,1) || ' para ' || SUBSTR(pNewPermissoes,366,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,367,1),SUBSTR(pNewPermissoes,367,1)) <> 1 THEN 
        cRetorno := cRetorno || '"367 - Acessar manuteno de lotes." ' || SUBSTR(pOldPermissoes,367,1) || ' para ' || SUBSTR(pNewPermissoes,367,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,368,1),SUBSTR(pNewPermissoes,368,1)) <> 1 THEN 
        cRetorno := cRetorno || '"368 - Acessar fretes por regio e peso." ' || SUBSTR(pOldPermissoes,368,1) || ' para ' || SUBSTR(pNewPermissoes,368,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,369,1),SUBSTR(pNewPermissoes,369,1)) <> 1 THEN 
        cRetorno := cRetorno || '"369 - Autorizar vender encomenda com outro tipo de entrega." ' || SUBSTR(pOldPermissoes,369,1) || ' para ' || SUBSTR(pNewPermissoes,369,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,370,1),SUBSTR(pNewPermissoes,370,1)) <> 1 THEN 
        cRetorno := cRetorno || '"370 - Acessar referncias de crdito." ' || SUBSTR(pOldPermissoes,370,1) || ' para ' || SUBSTR(pNewPermissoes,370,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,371,1),SUBSTR(pNewPermissoes,371,1)) <> 1 THEN 
        cRetorno := cRetorno || '"371 - Acessar histrico de vendas simplificado." ' || SUBSTR(pOldPermissoes,371,1) || ' para ' || SUBSTR(pNewPermissoes,371,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,372,1),SUBSTR(pNewPermissoes,372,1)) <> 1 THEN 
        cRetorno := cRetorno || '"372 - Autorizar venda de produto no definido como encomenda." ' || SUBSTR(pOldPermissoes,372,1) || ' para ' || SUBSTR(pNewPermissoes,372,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,373,1),SUBSTR(pNewPermissoes,373,1)) <> 1 THEN 
        cRetorno := cRetorno || '"373 - Autorizar venda de parte do lote." ' || SUBSTR(pOldPermissoes,373,1) || ' para ' || SUBSTR(pNewPermissoes,373,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,374,1),SUBSTR(pNewPermissoes,374,1)) <> 1 THEN 
        cRetorno := cRetorno || '"374 - Acessar resgate de bnus." ' || SUBSTR(pOldPermissoes,374,1) || ' para ' || SUBSTR(pNewPermissoes,374,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,375,1),SUBSTR(pNewPermissoes,375,1)) <> 1 THEN 
        cRetorno := cRetorno || '"375 - Autorizar lanamento avulso de bnus." ' || SUBSTR(pOldPermissoes,375,1) || ' para ' || SUBSTR(pNewPermissoes,375,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,376,1),SUBSTR(pNewPermissoes,376,1)) <> 1 THEN 
        cRetorno := cRetorno || '"376 - Acessar histrico de bnus." ' || SUBSTR(pOldPermissoes,376,1) || ' para ' || SUBSTR(pNewPermissoes,376,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,377,1),SUBSTR(pNewPermissoes,377,1)) <> 1 THEN 
        cRetorno := cRetorno || '"377 - Acessar importao de NF-e prpria." ' || SUBSTR(pOldPermissoes,377,1) || ' para ' || SUBSTR(pNewPermissoes,377,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,378,1),SUBSTR(pNewPermissoes,378,1)) <> 1 THEN 
        cRetorno := cRetorno || '"378 - Alterar limite de crdito." ' || SUBSTR(pOldPermissoes,378,1) || ' para ' || SUBSTR(pNewPermissoes,378,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,379,1),SUBSTR(pNewPermissoes,379,1)) <> 1 THEN 
        cRetorno := cRetorno || '"379 - Definir modelo de impostos por NCM." ' || SUBSTR(pOldPermissoes,379,1) || ' para ' || SUBSTR(pNewPermissoes,379,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,380,1),SUBSTR(pNewPermissoes,380,1)) <> 1 THEN 
        cRetorno := cRetorno || '"380 - Cadastrar margem de tolerncia para custo de reposio." ' || SUBSTR(pOldPermissoes,380,1) || ' para ' || SUBSTR(pNewPermissoes,380,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,381,1),SUBSTR(pNewPermissoes,381,1)) <> 1 THEN 
        cRetorno := cRetorno || '"381 - Autorizar margem de tolerncia para custo de reposio." ' || SUBSTR(pOldPermissoes,381,1) || ' para ' || SUBSTR(pNewPermissoes,381,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,382,1),SUBSTR(pNewPermissoes,382,1)) <> 1 THEN 
        cRetorno := cRetorno || '"382 - Acessar Cobrana, Prospeco e Ps-venda." ' || SUBSTR(pOldPermissoes,382,1) || ' para ' || SUBSTR(pNewPermissoes,382,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,383,1),SUBSTR(pNewPermissoes,383,1)) <> 1 THEN 
        cRetorno := cRetorno || '"383 - Cadastrar NCM." ' || SUBSTR(pOldPermissoes,383,1) || ' para ' || SUBSTR(pNewPermissoes,383,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,384,1),SUBSTR(pNewPermissoes,384,1)) <> 1 THEN 
        cRetorno := cRetorno || '"384 - Acessar Impresso Automtica de DAV." ' || SUBSTR(pOldPermissoes,384,1) || ' para ' || SUBSTR(pNewPermissoes,384,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,385,1),SUBSTR(pNewPermissoes,385,1)) <> 1 THEN 
        cRetorno := cRetorno || '"385 - Acessar Tela de Troca de Cheques no Checkout." ' || SUBSTR(pOldPermissoes,385,1) || ' para ' || SUBSTR(pNewPermissoes,385,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,386,1),SUBSTR(pNewPermissoes,386,1)) <> 1 THEN 
        cRetorno := cRetorno || '"386 - Acessar rea Administrativa do E-commerce." ' || SUBSTR(pOldPermissoes,386,1) || ' para ' || SUBSTR(pNewPermissoes,386,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,387,1),SUBSTR(pNewPermissoes,387,1)) <> 1 THEN 
        cRetorno := cRetorno || '"387 - Cadastrar Lista de Presentes." ' || SUBSTR(pOldPermissoes,387,1) || ' para ' || SUBSTR(pNewPermissoes,387,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,388,1),SUBSTR(pNewPermissoes,388,1)) <> 1 THEN 
        cRetorno := cRetorno || '"388 - Cadastrar Sugestes de Lista de Presentes." ' || SUBSTR(pOldPermissoes,388,1) || ' para ' || SUBSTR(pNewPermissoes,388,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,389,1),SUBSTR(pNewPermissoes,389,1)) <> 1 THEN 
        cRetorno := cRetorno || '"389 - Monitorar Integraes." ' || SUBSTR(pOldPermissoes,389,1) || ' para ' || SUBSTR(pNewPermissoes,389,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,390,1),SUBSTR(pNewPermissoes,390,1)) <> 1 THEN 
        cRetorno := cRetorno || '"390 - Acessar Gabaritos." ' || SUBSTR(pOldPermissoes,390,1) || ' para ' || SUBSTR(pNewPermissoes,390,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,391,1),SUBSTR(pNewPermissoes,391,1)) <> 1 THEN 
        cRetorno := cRetorno || '"391 - Autoriza venda sem estoque do lote." ' || SUBSTR(pOldPermissoes,391,1) || ' para ' || SUBSTR(pNewPermissoes,391,1) || cCRLF;
      END IF;
       IF Equal(SUBSTR(pOldPermissoes,392,1),SUBSTR(pNewPermissoes,392,1)) <> 1 THEN 
        cRetorno := cRetorno || '"392 - DESCONTINUADA." ' ||  SUBSTR(pOldPermissoes,392,1) || ' para ' || SUBSTR(pNewPermissoes,392,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,393,1),SUBSTR(pNewPermissoes,393,1)) <> 1 THEN 
        cRetorno := cRetorno || '"393 - Permitir Editar Observao de Parceiro." ' || SUBSTR(pOldPermissoes,393,1) || ' para ' || SUBSTR(pNewPermissoes,393,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,394,1),SUBSTR(pNewPermissoes,394,1)) <> 1 THEN 
        cRetorno := cRetorno || '"394 - Acessar Tabelas IBPTax." ' || SUBSTR(pOldPermissoes,394,1) || ' para ' || SUBSTR(pNewPermissoes,394,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,395,1),SUBSTR(pNewPermissoes,395,1)) <> 1 THEN 
        cRetorno := cRetorno || '"395 - Permitir Alterar o Cliente da Nota Vinculada." ' || SUBSTR(pOldPermissoes,395,1) || ' para ' || SUBSTR(pNewPermissoes,395,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,396,1),SUBSTR(pNewPermissoes,396,1)) <> 1 THEN 
        cRetorno := cRetorno || '"396 - Informar Saldo do Lote Maior que do Produto em Estoque." ' || SUBSTR(pOldPermissoes,396,1) || ' para ' || SUBSTR(pNewPermissoes,396,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,397,1),SUBSTR(pNewPermissoes,397,1)) <> 1 THEN 
        cRetorno := cRetorno || '"397 - Permitir Alterar Cadastro dos Impostos de Produtos ao Conferir Registro de Compra." ' || SUBSTR(pOldPermissoes,397,1) || ' para ' || SUBSTR(pNewPermissoes,397,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,398,1),SUBSTR(pNewPermissoes,398,1)) <> 1 THEN 
        cRetorno := cRetorno || '"398 - Permitir digitar quantidade de referncias no Order e Checkout (N * Referencia)." ' || SUBSTR(pOldPermissoes,398,1) || ' para ' || SUBSTR(pNewPermissoes,398,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,399,1),SUBSTR(pNewPermissoes,399,1)) <> 1 THEN 
        cRetorno := cRetorno || '"399 - Mudar" Venda Sob Encomenda"para" Apenas Oramento.""' || SUBSTR(pOldPermissoes,399,1) || ' para ' || SUBSTR(pNewPermissoes,399,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,400,1),SUBSTR(pNewPermissoes,400,1)) <> 1 THEN 
        cRetorno := cRetorno || '"400 - Usar Totall BI Browser." ' || SUBSTR(pOldPermissoes,400,1) || ' para ' || SUBSTR(pNewPermissoes,400,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,401,1),SUBSTR(pNewPermissoes,401,1)) <> 1 THEN 
        cRetorno := cRetorno || '"401 - Editar formatos." ' || SUBSTR(pOldPermissoes,401,1) || ' para ' || SUBSTR(pNewPermissoes,401,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,402,1),SUBSTR(pNewPermissoes,402,1)) <> 1 THEN 
        cRetorno := cRetorno || '"402 - Acesso ao Agendador (Totall BI Server)." ' || SUBSTR(pOldPermissoes,402,1) || ' para ' || SUBSTR(pNewPermissoes,402,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,403,1),SUBSTR(pNewPermissoes,403,1)) <> 1 THEN 
        cRetorno := cRetorno || '"403 - Usar Totall BI Config." ' || SUBSTR(pOldPermissoes,403,1) || ' para ' || SUBSTR(pNewPermissoes,403,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,404,1),SUBSTR(pNewPermissoes,404,1)) <> 1 THEN 
        cRetorno := cRetorno || '"404 - Acessar Tela de Tabela de Subsdios de Frete." ' || SUBSTR(pOldPermissoes,404,1) || ' para ' || SUBSTR(pNewPermissoes,404,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,405,1),SUBSTR(pNewPermissoes,405,1)) <> 1 THEN 
        cRetorno := cRetorno || '"405 - Permite Remessa para Filial Diferente da Reserva." ' || SUBSTR(pOldPermissoes,405,1) || ' para ' || SUBSTR(pNewPermissoes,401,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,406,1),SUBSTR(pNewPermissoes,406,1)) <> 1 THEN 
        cRetorno := cRetorno || '"406 - Acessar Tela de Tabela de Despesas Operacionais." ' || SUBSTR(pOldPermissoes,406,1) || ' para ' || SUBSTR(pNewPermissoes,406,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,407,1),SUBSTR(pNewPermissoes,407,1)) <> 1 THEN 
        cRetorno := cRetorno || '"407 - Acessar Tela de Devolues de NF-e no Commerce Web." ' || SUBSTR(pOldPermissoes,407,1) || ' para ' || SUBSTR(pNewPermissoes,407,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,408,1),SUBSTR(pNewPermissoes,408,1)) <> 1 THEN 
        cRetorno := cRetorno || '"408 - Devolver Notas Emitidas em Outras Filiais pelo Totall Commerce Web." ' || SUBSTR(pOldPermissoes,408,1) || ' para ' || SUBSTR(pNewPermissoes,408,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,409,1),SUBSTR(pNewPermissoes,409,1)) <> 1 THEN 
        cRetorno := cRetorno || '"409 - Permite Cancelamento e Restituio de Servio Adicional." ' || SUBSTR(pOldPermissoes,409,1) || ' para ' || SUBSTR(pNewPermissoes,409,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,410,1),SUBSTR(pNewPermissoes,410,1)) <> 1 THEN 
        cRetorno := cRetorno || '"410 - Permite Alterar" ltimo Preo"na Sugesto de Compra." ' || SUBSTR(pOldPermissoes,410,1) || ' para ' || SUBSTR(pNewPermissoes,410,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,411,1),SUBSTR(pNewPermissoes,411,1)) <> 1 THEN 
        cRetorno := cRetorno || '"411 - Permite Cancelamento fora do prazo." ' || SUBSTR(pOldPermissoes,411,1) || ' para ' || SUBSTR(pNewPermissoes,411,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,412,1),SUBSTR(pNewPermissoes,412,1)) <> 1 THEN 
        cRetorno := cRetorno || '"412 - Autoriza lanamento avulso sem estoque." ' || SUBSTR(pOldPermissoes,412,1) || ' para ' || SUBSTR(pNewPermissoes,412,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,413,1),SUBSTR(pNewPermissoes,413,1)) <> 1 THEN 
        cRetorno := cRetorno || '"413 - Autoriza divergncia na Conferncia de DAV." ' || SUBSTR(pOldPermissoes,413,1) || ' para ' || SUBSTR(pNewPermissoes,413,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,414,1),SUBSTR(pNewPermissoes,414,1)) <> 1 THEN 
        cRetorno := cRetorno || '"414 - Autoriza venda em Conta Corrente com saldo negativo." ' || SUBSTR(pOldPermissoes,414,1) || ' para ' || SUBSTR(pNewPermissoes,414,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,415,1),SUBSTR(pNewPermissoes,415,1)) <> 1 THEN 
        cRetorno := cRetorno || '"415 - Devolver Notas Emitidas em Outras Filiais pelo Checkout." ' || SUBSTR(pOldPermissoes,415,1) || ' para ' || SUBSTR(pNewPermissoes,415,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,416,1),SUBSTR(pNewPermissoes,416,1)) <> 1 THEN 
        cRetorno := cRetorno || '"416 - DESCONTINUADA." ' || SUBSTR(pOldPermissoes,416,1) || ' para ' || SUBSTR(pNewPermissoes,416,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,417,1),SUBSTR(pNewPermissoes,417,1)) <> 1 THEN 
        cRetorno := cRetorno || '"417 - Acessar Tela de Recibos Provisrios no Commerce Web." ' || SUBSTR(pOldPermissoes,417,1) || ' para ' || SUBSTR(pNewPermissoes,417,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,418,1),SUBSTR(pNewPermissoes,418,1)) <> 1 THEN 
        cRetorno := cRetorno || '"418 - Acessar a edio de Report de DAV." ' || SUBSTR(pOldPermissoes,418,1) || ' para ' || SUBSTR(pNewPermissoes,418,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,419,1),SUBSTR(pNewPermissoes,419,1)) <> 1 THEN 
        cRetorno := cRetorno || '"419 - Depsito em Conta Corrente." ' || SUBSTR(pOldPermissoes,419,1) || ' para ' || SUBSTR(pNewPermissoes,419,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,420,1),SUBSTR(pNewPermissoes,420,1)) <> 1 THEN 
        cRetorno := cRetorno || '"420 - Retirada em Conta Corrente." ' || SUBSTR(pOldPermissoes,420,1) || ' para ' || SUBSTR(pNewPermissoes,420,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,421,1),SUBSTR(pNewPermissoes,421,1)) <> 1 THEN 
        cRetorno := cRetorno || '"421 - Alterar Contato para Retirar Produtos na Loja." ' || SUBSTR(pOldPermissoes,421,1) || ' para ' || SUBSTR(pNewPermissoes,421,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,422,1),SUBSTR(pNewPermissoes,422,1)) <> 1 THEN 
        cRetorno := cRetorno || '"422 - Acessar Tela de Inutilizao no Commerce Web." ' || SUBSTR(pOldPermissoes,422,1) || ' para ' || SUBSTR(pNewPermissoes,422,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,423,1),SUBSTR(pNewPermissoes,423,1)) <> 1 THEN 
        cRetorno := cRetorno || '"423 - Autorizar uso de palavra imprpria no cadastro de clientes." ' || SUBSTR(pOldPermissoes,423,1) || ' para ' || SUBSTR(pNewPermissoes,423,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,424,1),SUBSTR(pNewPermissoes,424,1)) <> 1 THEN 
        cRetorno := cRetorno || '"424 - Autorizar desconto acima do ideal." ' || SUBSTR(pOldPermissoes,424,1) || ' para ' || SUBSTR(pNewPermissoes,424,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,425,1),SUBSTR(pNewPermissoes,425,1)) <> 1 THEN 
        cRetorno := cRetorno || '"425 - Autorizar Pedido fora do Prazo Mdio." ' || SUBSTR(pOldPermissoes,425,1) || ' para ' || SUBSTR(pNewPermissoes,425,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,426,1),SUBSTR(pNewPermissoes,426,1)) <> 1 THEN 
        cRetorno := cRetorno || '"426 - Antecipao  Fornecedores." ' || SUBSTR(pOldPermissoes,426,1) || ' para ' || SUBSTR(pNewPermissoes,426,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,427,1),SUBSTR(pNewPermissoes,427,1)) <> 1 THEN 
        cRetorno := cRetorno || '"427 - Acessar gerao de XML e PDF de Nfe no Commerce Web." ' || SUBSTR(pOldPermissoes,427,1) || ' para ' || SUBSTR(pNewPermissoes,427,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,428,1),SUBSTR(pNewPermissoes,428,1)) <> 1 THEN 
        cRetorno := cRetorno || '"428 - Acessar Tela de Saldo por Grade." ' || SUBSTR(pOldPermissoes,428,1) || ' para ' || SUBSTR(pNewPermissoes,423,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,429,1),SUBSTR(pNewPermissoes,429,1)) <> 1 THEN 
        cRetorno := cRetorno || '"429 - Acessar Tela de Saldo por Filial no Totall Pos." '|| SUBSTR(pOldPermissoes,429,1) || ' para ' || SUBSTR(pNewPermissoes,429,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,430,1),SUBSTR(pNewPermissoes,430,1)) <> 1 THEN 
        cRetorno := cRetorno || '"430 - Acessar Tela de Saldo por Grade no Totall Pos." ' || SUBSTR(pOldPermissoes,430,1) || ' para ' || SUBSTR(pNewPermissoes,430,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,431,1),SUBSTR(pNewPermissoes,431,1)) <> 1 THEN 
        cRetorno := cRetorno || '"431 - Autorizar Conferncia de Separaes com Diferena no Delivery." ' || SUBSTR(pOldPermissoes,431,1) || ' para ' || SUBSTR(pNewPermissoes,431,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,432,1),SUBSTR(pNewPermissoes,432,1)) <> 1 THEN 
        cRetorno := cRetorno || '"432 - Permite zerar saldo em recebimento parcial no Backoffice." ' || SUBSTR(pOldPermissoes,432,1) || ' para ' || SUBSTR(pNewPermissoes,432,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,433,1),SUBSTR(pNewPermissoes,433,1)) <> 1 THEN 
        cRetorno := cRetorno || '"433 - Alterar valor de frete." ' || SUBSTR(pOldPermissoes,433,1) || ' para ' || SUBSTR(pNewPermissoes,433,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,434,1),SUBSTR(pNewPermissoes,434,1)) <> 1 THEN 
        cRetorno := cRetorno || '"434 - Acessar Tela de Transferncia de Saldo Credor de ICMS no Commerce Web." ' || SUBSTR(pOldPermissoes,434,1) || ' para ' || SUBSTR(pNewPermissoes,434,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,435,1),SUBSTR(pNewPermissoes,435,1)) <> 1 THEN 
        cRetorno := cRetorno || '"435 - Autorizar vendas com desconto/acrscimo diferente do ideal no Totall POS." ' || SUBSTR(pOldPermissoes,435,1) || ' para ' || SUBSTR(pNewPermissoes,435,1) || cCRLF ;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,436,1),SUBSTR(pNewPermissoes,436,1)) <> 1 THEN 
        cRetorno := cRetorno || '"436 - Cadastrar Preos dos Fornecedores." ' || SUBSTR(pOldPermissoes,436,1) || ' para ' || SUBSTR(pNewPermissoes,436,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,437,1),SUBSTR(pNewPermissoes,437,1)) <> 1 THEN 
        cRetorno := cRetorno || '"437 - Descontinuada (duplicidade com permisso 437)." ' || SUBSTR(pOldPermissoes,437,1) || ' para ' || SUBSTR(pNewPermissoes,437,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,438,1),SUBSTR(pNewPermissoes,438,1)) <> 1 THEN 
        cRetorno := cRetorno || '"438 - Permitir troca de Produtos em oramentos de E-commerce." ' || SUBSTR(pOldPermissoes,438,1) || ' para ' || SUBSTR(pNewPermissoes,438,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,440,1),SUBSTR(pNewPermissoes,440,1)) <> 1 THEN 
        cRetorno := cRetorno || '"440 - Digitar Cotao de Preos." ' || SUBSTR(pOldPermissoes,440,1) || ' para ' || SUBSTR(pNewPermissoes,440,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,441,1),SUBSTR(pNewPermissoes,441,1)) <> 1 THEN 
        cRetorno := cRetorno || '"441 - Envio de Cotao a Fornecedores." ' || SUBSTR(pOldPermissoes,441,1) || ' para ' || SUBSTR(pNewPermissoes,441,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,442,1),SUBSTR(pNewPermissoes,442,1)) <> 1 THEN 
        cRetorno := cRetorno || '"442 - Aprovao da Cotao." ' || SUBSTR(pOldPermissoes,442,1) || ' para ' || SUBSTR(pNewPermissoes,442,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,443,1),SUBSTR(pNewPermissoes,443,1)) <> 1 THEN 
        cRetorno := cRetorno || '"443 - Autorizar pedidos abaixo do valor mnimo." ' || SUBSTR(pOldPermissoes,443,1) || ' para ' || SUBSTR(pNewPermissoes,443,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,444,1),SUBSTR(pNewPermissoes,444,1)) <> 1 THEN 
        cRetorno := cRetorno || '"444 - Permite acesso as campanhas." ' || SUBSTR(pOldPermissoes,444,1) || ' para ' || SUBSTR(pNewPermissoes,444,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,445,1),SUBSTR(pNewPermissoes,445,1)) <> 1 THEN 
        cRetorno := cRetorno || '"445 - Permite incluir/alterar campanhas." ' || SUBSTR(pOldPermissoes,445,1) || ' para ' || SUBSTR(pNewPermissoes,445,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,446,1),SUBSTR(pNewPermissoes,446,1)) <> 1 THEN 
        cRetorno := cRetorno || '"446 - Permite acesso a cupom de desconto." ' || SUBSTR(pOldPermissoes,446,1) || ' para ' || SUBSTR(pNewPermissoes,446,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,447,1),SUBSTR(pNewPermissoes,447,1)) <> 1 THEN 
        cRetorno := cRetorno || '"447 - Permite incluir/alterar cupom de desconto." ' || SUBSTR(pOldPermissoes,447,1) || ' para ' || SUBSTR(pNewPermissoes,447,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,448,1),SUBSTR(pNewPermissoes,448,1)) <> 1 THEN 
        cRetorno := cRetorno || '"448 - Permite acesso  Manuteno de Dados da LGPD." ' || SUBSTR(pOldPermissoes,448,1) || ' para ' || SUBSTR(pNewPermissoes,448,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,449,1),SUBSTR(pNewPermissoes,449,1)) <> 1 THEN 
        cRetorno := cRetorno || '"449 - Permite acesso  Consulta de Dados LGPD." ' || SUBSTR(pOldPermissoes,449,1) || ' para ' || SUBSTR(pNewPermissoes,449,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,450,1),SUBSTR(pNewPermissoes,450,1)) <> 1 THEN 
        cRetorno := cRetorno || '"450 - Autorizar diferena de peso da sacola do Auto Atendimento." ' || SUBSTR(pOldPermissoes,450,1) || ' para ' || SUBSTR(pNewPermissoes,450,1) || cCRLF;
      END IF;
      IF Equal(SUBSTR(pOldPermissoes,451,1),SUBSTR(pNewPermissoes,451,1)) <> 1 THEN 
        cRetorno := cRetorno || '"451 - Permitir alterao do Tipo de Custo Mdio na compra." ' || SUBSTR(pOldPermissoes,451,1) || ' para ' || SUBSTR(pNewPermissoes,451,1) || cCRLF;
      END IF;
      
      RETURN SUBSTR(cRetorno,1,4000);
   END IF;
 
END;
$$ language 'plpgsql';





/*-- SEQ 0649 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PC_INIT (VARCHAR,BOOLEAN) CASCADE;

/*-- SEQ 0650 --*/
CREATE OR REPLACE FUNCTION PC_INIT (VARCHAR,BOOLEAN)
RETURNS VARCHAR AS $$
DECLARE
pNamePackage ALIAS FOR $1 ;
pOnOff ALIAS FOR $2 ;
  nPid ALL_PACKAGES.PID%TYPE;
BEGIN
  IF pOnOff IS NULL THEN
    DELETE FROM ALL_PACKAGES
     WHERE package_name = pNamePackage
       AND pid = pg_backend_pid();

    DELETE FROM ALL_VARIABLES
     WHERE package_name = pNamePackage
       AND pid = pg_backend_pid();
  ELSE
    SELECT pid INTO nPid
     FROM ALL_PACKAGES
    WHERE package_name = pNamePackage
       AND pid = pg_backend_pid();
   
    IF nPid IS NULL THEN
      INSERT INTO ALL_PACKAGES (pid,package_name,triggers_enabled,next_group)
                        VALUES (pg_backend_pid(),pNamePackage,pOnOff,0);
    ELSE
      UPDATE ALL_PACKAGES SET triggers_enabled = pOnOff
       WHERE PACKAGE_NAME = pNamePackage
         AND pid = nPid;
    END IF;
  END IF;
  
  RETURN NULL;
END;
$$ language 'plpgsql';


/*-- SEQ 0651 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PC_INIT (VARCHAR) CASCADE;

/*-- SEQ 0652 --*/
CREATE OR REPLACE FUNCTION PC_INIT (VARCHAR) 
RETURNS VARCHAR AS $$
BEGIN
RETURN PC_INIT($1,NULL);
END;
$$ language 'plpgsql';

/*-- SEQ 0653 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PC_TRIGGERS_ENABLED (VARCHAR,BOOLEAN) CASCADE;

/*-- SEQ 0654 --*/
CREATE OR REPLACE FUNCTION PC_TRIGGERS_ENABLED (VARCHAR,BOOLEAN)
RETURNS BOOLEAN AS $$
DECLARE
pNamePackage ALIAS FOR $1 ;
pInit ALIAS FOR $2 ;
  bRetorno boolean;
  cDummy   VARCHAR;
BEGIN
  SELECT triggers_enabled INTO bRetorno
    FROM all_packages
   WHERE package_name = pNamePackage
     AND pid = pg_backend_pid();
     
  IF bRetorno IS NULL THEN
    IF pInit THEN
      cDummy   := PC_INIT(pNamePackage,true);
      bRetorno := true;
    ELSE
      bRetorno := false;
    END IF;  
  END IF;
  RETURN bRetorno;
END;
$$ language 'plpgsql';


/*-- SEQ 0655 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PC_TRIGGERS_ENABLED (VARCHAR) CASCADE;

/*-- SEQ 0656 --*/
CREATE OR REPLACE FUNCTION PC_TRIGGERS_ENABLED (VARCHAR) 
RETURNS BOOLEAN AS $$
BEGIN
RETURN PC_TRIGGERS_ENABLED($1,TRUE);
END;
$$ language 'plpgsql';

/*-- SEQ 0657 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PC_CLEAR_LIST (VARCHAR) CASCADE;

/*-- SEQ 0658 --*/
CREATE OR REPLACE FUNCTION PC_CLEAR_LIST (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pNamePackage ALIAS FOR $1 ;
BEGIN
  DELETE FROM all_variables
    WHERE (pid,package_name) IN (SELECT pid,package_name
                                   FROM all_packages
                                  WHERE package_name = pNamePackage
                                    AND pid = pg_backend_pid());
  RETURN NULL;
END;
$$ language 'plpgsql';



/*-- SEQ 0659 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PC_ADD_LIST (VARCHAR,VARCHAR,BOOLEAN,Numeric,VARCHAR,Timestamp) CASCADE;

/*-- SEQ 0660 --*/
CREATE OR REPLACE FUNCTION PC_ADD_LIST (VARCHAR,VARCHAR,BOOLEAN,Numeric,VARCHAR,Timestamp)
RETURNS VARCHAR AS $$
DECLARE
pNamePackage ALIAS FOR $1 ;
pVariable ALIAS FOR $2 ;
pPrimaryKey ALIAS FOR $3 ;
pNumber ALIAS FOR $4 ;
pVarChar ALIAS FOR $5 ;
pDate ALIAS FOR $6 ;
  nPid   ALL_PACKAGES.PID%TYPE;
  nGroup ALL_PACKAGES.NEXT_GROUP%TYPE;
  nRow   ALL_VARIABLES.Numeric_ROW%TYPE;
BEGIN
  SELECT pid,next_group INTO nPid,nGroup
   FROM ALL_PACKAGES
   WHERE package_name = pNamePackage
     AND pid = pg_backend_pid();
   
  IF nPid IS NOT NULL THEN
    SELECT MAX(Numeric_ROW) INTO nRow
      FROM ALL_VARIABLES
     WHERE package_name = pNamePackage
       AND pid = pg_backend_pid();

    nRow := COALESCE(nRow,0)+1;

    IF pNumber IS NOT NULL THEN
      INSERT INTO ALL_VARIABLES (pid,Numeric_group,package_name,variable_name,Numeric_row,primary_key,value_numeric)
                         VALUES (nPid,nGroup,pNamePackage,pVariable,nRow,pPrimaryKey,pNumber);
    ELSIF pDate IS NOT NULL THEN
      INSERT INTO ALL_VARIABLES (pid,Numeric_group,package_name,variable_name,Numeric_row,primary_key,value_date)
                         VALUES (nPid,nGroup,pNamePackage,pVariable,nRow,pPrimaryKey,pDate);
    ELSIF pVarChar IS NOT NULL THEN
      INSERT INTO ALL_VARIABLES (pid,Numeric_group,package_name,variable_name,Numeric_row,primary_key,value_varchar)
                         VALUES (nPid,nGroup,pNamePackage,pVariable,nRow,pPrimaryKey,pVarChar);
    END IF;
  END IF;
  
  RETURN NULL;
END;
$$ language 'plpgsql';


/*-- SEQ 0661 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PC_ADD_LIST (VARCHAR,VARCHAR,BOOLEAN,Numeric) CASCADE;

/*-- SEQ 0662 --*/
CREATE OR REPLACE FUNCTION PC_ADD_LIST (VARCHAR,
                               VARCHAR,
                               BOOLEAN,
                               Numeric) 
RETURNS VARCHAR AS $$
BEGIN
RETURN PC_ADD_LIST($1,$2,$3,$4,NULL,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 0663 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PC_ADD_LIST (VARCHAR,VARCHAR,BOOLEAN,VARCHAR) CASCADE;

/*-- SEQ 0664 --*/
CREATE OR REPLACE FUNCTION PC_ADD_LIST (VARCHAR,
                               VARCHAR,
                               BOOLEAN,
                               VARCHAR) 
RETURNS VARCHAR AS $$
BEGIN
RETURN PC_ADD_LIST($1,$2,$3,NULL,$4,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 0665 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PC_ADD_LIST (VARCHAR,VARCHAR,BOOLEAN,Timestamp) CASCADE;

/*-- SEQ 0666 --*/
CREATE OR REPLACE FUNCTION PC_ADD_LIST (VARCHAR,
                               VARCHAR,
                               BOOLEAN,
                               Timestamp) 
RETURNS VARCHAR AS $$
BEGIN
RETURN PC_ADD_LIST($1,$2,$3,NULL,NULL,$4);
END;
$$ language 'plpgsql';

/*-- SEQ 0667 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PC_NEXT_GROUP (VARCHAR) CASCADE;

/*-- SEQ 0668 --*/
CREATE OR REPLACE FUNCTION PC_NEXT_GROUP (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pNamePackage ALIAS FOR $1 ;
BEGIN
  UPDATE ALL_PACKAGES SET NEXT_GROUP = COALESCE(NEXT_GROUP + 1,0)
   WHERE PACKAGE_NAME = pNamePackage
     AND pid = pg_backend_pid();
 
  RETURN NULL;
END;
$$ language 'plpgsql';



/*-- SEQ 0669 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PC_FIND_LIST (VARCHAR) CASCADE;

/*-- SEQ 0670 --*/
CREATE OR REPLACE FUNCTION PC_FIND_LIST (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pNamePackage ALIAS FOR $1 ;
BEGIN
  DELETE FROM ALL_VARIABLES
   WHERE package_name = pNamePackage
     AND pid = pg_backend_pid()
     AND (Numeric_group,package_name,pid) NOT IN (SELECT MIN(Numeric_group),package_name,pid
                                                      FROM ALL_VARIABLES
                                                     WHERE package_name = pNamePackage
                                                       AND pid = pg_backend_pid()
                                                       AND primary_key = true
                                                     GROUP BY package_name,pid,variable_name,value_numeric,value_varchar,value_date);
   
  RETURN NULL;
END;
$$ language 'plpgsql';



/*-- SEQ 0671 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PC_EXECUTE (VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 0672 --*/
CREATE OR REPLACE FUNCTION PC_EXECUTE (VARCHAR,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pNamePackage ALIAS FOR $1 ;
pNameFunction ALIAS FOR $2 ;
pParams ALIAS FOR $3 ;
  cLista    VARCHAR(256);
  cAux      VARCHAR(256);
  cExecute  VARCHAR(256);
  nValue    ALL_VARIABLES.VALUE_NUMERIC%TYPE;
  cValue    ALL_VARIABLES.VALUE_VARCHAR%TYPE;
  dValue    ALL_VARIABLES.VALUE_DATE%TYPE;
  nConta    INTEGER;
  nSoma     INTEGER;
  LISTA CURSOR(p1 VARCHAR) IS
  SELECT b.soma,a.value_numeric,a.value_varchar,a.value_date
    FROM ALL_VARIABLES a INNER JOIN (SELECT COUNT(*) AS soma,Numeric_group
                                       FROM ALL_VARIABLES
                                      WHERE package_name = p1
                                        AND pid = pg_backend_pid()
                                      GROUP BY Numeric_group) b ON b.Numeric_group = a.Numeric_group
   WHERE a.package_name = p1
     AND a.pid = pg_backend_pid()
   ORDER BY a.Numeric_group,a.Numeric_row;

BEGIN
  IF pParams IS NOT NULL THEN
    cLista := pParams;
    IF SUBSTR(cLista,LENGTH(cLista),1) <> '','' THEN
      cLista := cLista || '','';
    END IF;
  ELSE
    cLista := '';
  END IF;  
  nConta := 0;
  cAux   := cLista;

  OPEN LISTA(pNamePackage);
  LOOP
    FETCH LISTA INTO nSoma,nValue,cValue,dValue;
    EXIT WHEN NOT FOUND;

    IF nValue IS NOT NULL THEN
      cLista := cLista||nValue::VARCHAR;
    ELSIF cValue IS NOT NULL THEN
      cLista := cLista||chr(39)||cValue||chr(39);
    ELSIF dValue IS NOT NULL THEN
      cLista := cLista||'TO_DATE('||chr(39)||dValue::VARCHAR||chr(39)||','||chr(39)||'DD/MM/YYYY HH24:MI:SS'||chr(39)||')';
    END IF;

    nConta := nConta + 1;
    IF nConta >= nSoma THEN
      cExecute := 'select '||pNameFunction||'('||cLista||');';
      EXECUTE cExecute;
      nConta := 0;
      cLista := cAux;
    ELSE
      cLista := cLista||',';
    END IF;
   END LOOP;
   
  CLOSE LISTA;
  RETURN NULL;
END;
$$ language 'plpgsql';


/*-- SEQ 0673 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PC_EXECUTE (VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 0674 --*/
CREATE OR REPLACE FUNCTION PC_EXECUTE (VARCHAR,
                               VARCHAR) 
RETURNS VARCHAR AS $$
BEGIN
RETURN PC_EXECUTE($1,$2,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 0675 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ALTERA_ENCOMENDA_PEDIDO (TT_IVExIPE.CODFIL%TYPE,TT_IVExIPE.FILPED%TYPE,TT_IVExIPE.TIPPED%TYPE,TT_IVExIPE.NUMPED%TYPE,TT_IVExIPE.NUMITE%TYPE,TT_IVExIPE.QTDENC%TYPE) CASCADE;

/*-- SEQ 0676 --*/
CREATE OR REPLACE FUNCTION ALTERA_ENCOMENDA_PEDIDO (TT_IVExIPE.CODFIL%TYPE,TT_IVExIPE.FILPED%TYPE,TT_IVExIPE.TIPPED%TYPE,TT_IVExIPE.NUMPED%TYPE,TT_IVExIPE.NUMITE%TYPE,TT_IVExIPE.QTDENC%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pFILPED ALIAS FOR $2 ;
pTIPPED ALIAS FOR $3 ;
pNUMPED ALIAS FOR $4 ;
pNUMITE ALIAS FOR $5 ;
pQTDENC ALIAS FOR $6 ;

-- Objetivos:
-- 1) altera quantidade da encomenda alterando tambm o pedido

  vFILIPE                 TT_IPE.CODFIL%TYPE;
  vNUMIPE                 TT_IPE.NUMPED%TYPE;
  vITEIPE                 TT_IPE.NUMITE%TYPE;
  vQTDPEN                 TT_IPE.QTDITE%TYPE;
  vNEW_NUMITE             TT_IPE.NUMITE%TYPE;
  vIPE_QTDITE             TT_IPE.QTDITE%TYPE;
  vIPE_QTDPED             TT_IPE.QTDPED%TYPE;
  vIPE_VALCON             TT_IPE.VALCON%TYPE;
  vIPE_VLRITE             TT_IPE.VLRITE%TYPE;
  vIPE_VLRDES             TT_IPE.VLRDES%TYPE;
  vIPE_BASICM             TT_IPE.BASICM%TYPE;
  vIPE_VLRICM             TT_IPE.VLRICM%TYPE;
  vIPE_OUTICM             TT_IPE.OUTICM%TYPE;
  vIPE_ISEICM             TT_IPE.ISEICM%TYPE;
  vIPE_ICMITE             TT_IPE.ICMITE%TYPE;
  vIPE_VLRIPI             TT_IPE.VLRIPI%TYPE;
  vIPE_VLREMB             TT_IPE.VLREMB%TYPE;
  cTEMP                   TT_IDF.LOCK_C%TYPE; 

BEGIN
  -- Garantia de exclusividade no processo seguinte
  SELECT LOCK_C INTO cTEMP
  FROM TT_IDF 
  FOR UPDATE; 

       
      SELECT ENC.FILIPE, ENC.NUMIPE, ENC.ITEIPE, ENC.QTDENC - pQTDENC,
             IPE.VLRITE, IPE.QTDITE, IPE.VLRDES, IPE.BASICM, IPE.VLRICM, IPE.OUTICM, IPE.ISEICM, IPE.ICMITE, IPE.QTDPED, IPE.VALCON,
             IPE.VLRIPI, IPE.VLREMB
        INTO vFILIPE, vNUMIPE, vITEIPE, vQTDPEN,
             vIPE_VLRITE, vIPE_QTDITE, vIPE_VLRDES, vIPE_BASICM, vIPE_VLRICM, vIPE_OUTICM, vIPE_ISEICM, vIPE_ICMITE, vIPE_QTDPED, vIPE_VALCON,
             vIPE_VLRIPI, vIPE_VLREMB
        FROM TT_IVExIPE ENC INNER JOIN TT_IPE IPE ON IPE.CODFIL = ENC.FILIPE
                                                 AND IPE.NUMPED = ENC.NUMIPE
                                                 AND IPE.NUMITE = ENC.ITEIPE
       WHERE ENC.CODFIL = pCODFIL
         AND ENC.FILPED = pFILPED
         AND ENC.TIPPED = pTIPPED
         AND ENC.NUMPED = pNUMPED
         AND ENC.NUMITE = pNUMITE
         AND ENC.FLGEST <> 'C';
   

  UPDATE TT_IVExIPE 
     SET QTDENC = pQTDENC
   WHERE CODFIL = pCODFIL
     AND FILPED = pFILPED
     AND TIPPED = pTIPPED
     AND NUMPED = pNUMPED
     AND NUMITE = pNUMITE
     AND FLGEST <> 'C';

  IF vFILIPE IS NOT NULL THEN
      UPDATE TT_IPE
         SET QTDITE = pQTDENC,
             QTDPED = (pQTDENC / vIPE_VALCON),
             VLRITE = (vIPE_VLRITE / vIPE_QTDPED) * (pQTDENC / vIPE_VALCON),
             VLRDES = (vIPE_VLRDES / vIPE_QTDPED) * (pQTDENC / vIPE_VALCON),
             BASICM = (vIPE_BASICM / vIPE_QTDPED) * (pQTDENC / vIPE_VALCON),
             VLRICM = (vIPE_BASICM / vIPE_QTDPED) * (pQTDENC / vIPE_VALCON) * (vIPE_ICMITE / 100),
             OUTICM = (vIPE_OUTICM / vIPE_QTDPED) * (pQTDENC / vIPE_VALCON),
             ISEICM = (vIPE_ISEICM / vIPE_QTDPED) * (pQTDENC / vIPE_VALCON),
             VLRIPI = (vIPE_VLRIPI / vIPE_QTDPED) * (pQTDENC / vIPE_VALCON),
             VLREMB = (vIPE_VLREMB / vIPE_QTDPED) * (pQTDENC / vIPE_VALCON)
       WHERE CODFIL = vFILIPE
         AND NUMPED = vNUMIPE
         AND NUMITE = vITEIPE;

      SELECT MAX(NUMITE)+1
        INTO vNEW_NUMITE
        FROM TT_IPE
       WHERE CODFIL = vFILIPE 
         AND NUMPED = vNUMIPE;

      INSERT INTO TT_IPE 
            (CODFIL, NUMPED, NUMITE, FLGEST, 
             FILENT, CODMOE, UNICOM, UNIVEN, 
             FILMAT, CODMAT, CODCOR, CODTAM,
             IPIITE, VLRITE, VLRVEN, QTDITE, 
             FILICO, SEQICO, NUMICO, DATREB, 
             ICMITE, VLRDES, QTDCAN, ATU_EM,
             QTDENT, CODBUS, CODMUL, VALCON, 
             FILIVE, SEQIVE, NUMIVE, BASICM, 
             VLRICM, OUTICM, ISEICM, FILORI, 
             PEDORI, ITEORI, QTDPED, VLRUNI,
             VLRIPI, VLREMB)
      SELECT CODFIL, NUMPED, vNEW_NUMITE, FLGEST, 
             FILENT, CODMOE, UNICOM, UNIVEN, 
             FILMAT, CODMAT, CODCOR, CODTAM,
             IPIITE, 
             (vIPE_VLRITE / vIPE_QTDPED) * (vQTDPEN / vIPE_VALCON), 
             VLRVEN, vQTDPEN, 
             null, null, null, null, 
             ICMITE, 
             (vIPE_VLRDES / vIPE_QTDPED) * (vQTDPEN / vIPE_VALCON), 
             0, Agora(),
             0, CODBUS, CODMUL, VALCON, 
             null, null, null, 
             (vIPE_BASICM / vIPE_QTDPED) * (vQTDPEN / vIPE_VALCON), 
             (vIPE_BASICM / vIPE_QTDPED) * (vQTDPEN / vIPE_VALCON) * (vIPE_ICMITE / 100), 
             (vIPE_OUTICM / vIPE_QTDPED) * (vQTDPEN / vIPE_VALCON), 
             (vIPE_ISEICM / vIPE_QTDPED) * (vQTDPEN / vIPE_VALCON), 
             CODFIL, NUMPED, NUMITE, (vQTDPEN / vIPE_VALCON), VLRUNI,
             (vIPE_VLRIPI / vIPE_QTDPED) * (vQTDPEN / vIPE_VALCON),
             (vIPE_VLREMB / vIPE_QTDPED) * (vQTDPEN / vIPE_VALCON)             
        FROM TT_IPE
       WHERE CODFIL = vFILIPE
         AND NUMPED = vNUMIPE
         AND NUMITE = vITEIPE;
  END IF;

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 0677 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CALCULA_COMISSAO (TT_CMS.CODFIL%TYPE,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 0678 --*/
CREATE OR REPLACE FUNCTION CALCULA_COMISSAO (TT_CMS.CODFIL%TYPE,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pDATINI ALIAS FOR $2 ;
pDATFIM ALIAS FOR $3 ;
-- Objetivo:
-- 1) Calcular comisses populando TT_CMS.

  vComplemento constant VARCHAR(100) := constante('complemento');
  vDataInicial  VARCHAR(200);
  vDataFinal    VARCHAR(200);

BEGIN
  vDataInicial := pDATINI;
  vDataFinal   := pDATFIM;
  IF ISNOTNULL(vDataInicial)<>'T' THEN
     vDataInicial := AGORA();
  END IF; 
  IF ISNOTNULL(vDataFinal)<>'T' THEN
     vDataFinal := AGORA();
  END IF;  
  
  IF ISNOTNULL(pCODFIL)='T' THEN  
    -- Vendedor Principal    
    INSERT INTO TT_CMS
    (TIPCMS,CODFIL,FILREC,SEQREC,NUMPAR,SUBPAR,DATINC,DATPGT,FILCLI,CODCLI,BASCMS,VLRCMS,PERCMS,COMSOB,FLGEST,NROCAN,ATU_EM) 
    (SELECT 'V',pCODFIL,VCMS.CODFIL,VCMS.SEQUEN,VCMS.NUMPAR,VCMS.SUBPAR,agora(),
		    NULL,USU.FILCLI,USU.CODCLI,VCMS.MV_BAS_CMS,VCMS.COMISSAO,VCMS.PERCENTUAL,VCMS.COMSOB,'A',0,Agora()
       FROM TV_CMS VCMS INNER JOIN TT_VEN VEN ON VEN.CODFIL = VCMS.CODFIL
                                            AND VEN.SEQUEN = VCMS.SEQUEN
                       INNER JOIN TT_REC REC ON REC.CODFIL = VCMS.CODFIL
                                            AND REC.SEQUEN = VCMS.SEQUEN
                                            AND REC.NUMPAR = VCMS.NUMPAR
                                            AND REC.SUBPAR = VCMS.SUBPAR
                       INNER JOIN TT_USU USU ON USU.FILUSU = VCMS.FILVEN
                                            AND USU.CODUSU = VCMS.CODVEN
      WHERE VEN.DATHOR >= TO_DATE(vDataInicial,'DD/MM/YYYY HH24:MI:SS')
	    AND VEN.DATHOR <= TO_DATE(vDataFinal,  'DD/MM/YYYY HH24:MI:SS')
       AND NOT EXISTS (SELECT CODFIL 
                         FROM TT_CMS CMS
                        WHERE CMS.FILREC = VCMS.CODFIL 
                          AND CMS.SEQREC = VCMS.SEQUEN
                          AND CMS.TIPCMS = 'V'
                          AND CMS.FLGEST <> 'C' ));
    
	-- Indicador  
    INSERT INTO TT_CMS
    (TIPCMS,CODFIL,FILREC,SEQREC,NUMPAR,SUBPAR,DATINC,DATPGT,FILCLI,CODCLI,BASCMS,VLRCMS,PERCMS,COMSOB,FLGEST,NROCAN,ATU_EM)
    (SELECT 'I',pCODFIL,VCMSIND.CODFIL, VCMSIND.SEQUEN, NULL AS NUMPAR, NULL AS SUBPAR,
            agora(),NULL,VEN.FILGUI, VEN.CODGUI,VCMSIND.VLRLIQ,VCMSIND.COMISSAO,VCMSIND.PERCENTUAL,VCMSIND.COMSOB,'A',0,agora()
       FROM TV_CMS_IND VCMSIND INNER JOIN TT_VEN VEN ON VEN.CODFIL = VCMSIND.CODFIL
                                                   AND VEN.SEQUEN = VCMSIND.SEQUEN
      WHERE VEN.DATHOR >= TO_DATE(vDataInicial,'DD/MM/YYYY HH24:MI:SS')
	    AND VEN.DATHOR <= TO_DATE(vDataFinal,  'DD/MM/YYYY HH24:MI:SS')
       AND NOT EXISTS (SELECT CODFIL 
                         FROM TT_CMS CMS
                        WHERE CMS.FILREC = VCMSIND.CODFIL 
                          AND CMS.SEQREC = VCMSIND.SEQUEN
                          AND CMS.TIPCMS = 'I'
                          AND CMS.FLGEST <> 'C' ));       
	
  ELSE
     RAISE EXCEPTION 'PG-20001 Faltou informar a filial.%' , vComplemento;
  END IF;
  
  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 0679 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RecalcCus (TR_MOV.CODFIL%TYPE,TR_MOV.CODMUL%TYPE,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,TR_MOV.DATMOV%TYPE,TT_ICO.COM_ATUCUS%TYPE) CASCADE;

/*-- SEQ 0680 --*/
CREATE OR REPLACE FUNCTION RecalcCus (TR_MOV.CODFIL%TYPE,TR_MOV.CODMUL%TYPE,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,TR_MOV.DATMOV%TYPE,TT_ICO.COM_ATUCUS%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pCODMUL ALIAS FOR $2 ;
pFILMAT ALIAS FOR $3 ;
pCODMAT ALIAS FOR $4 ;
pCODCOR ALIAS FOR $5 ;
pCODTAM ALIAS FOR $6 ;
pDATMOV ALIAS FOR $7 ;
pATUCUS ALIAS FOR $8 ;
-- Objetivo
-- 1) Recalcular a ultima compra com custo do produto independentemente de filial ou estoque

  bSEM_ANTERIOR   BOOLEAN := False;
  cULT_DATMOV     TR_MOV.DATMOV%TYPE;
  cULT_FILICO     TR_MOV.FILICO%TYPE;
  cULT_SEQICO     TR_MOV.SEQICO%TYPE;
  cULT_NUMICO     TR_MOV.NUMICO%TYPE;
  cNOV_FILICO     TR_MOV.FILICO%TYPE;
  cNOV_SEQICO     TR_MOV.SEQICO%TYPE;
  cNOV_NUMICO     TR_MOV.NUMICO%TYPE;  

BEGIN
      -- obtem a ultima compra anterior
    SELECT TAB.DATMOV, TAB.FILICO, TAB.SEQICO, TAB.NUMICO
      INTO cULT_DATMOV, cULT_FILICO, cULT_SEQICO, cULT_NUMICO
      FROM (SELECT DATMOV, FILICO, SEQICO, NUMICO    
              FROM TR_MOV
             WHERE FILMAT = pFILMAT
               AND CODMAT = pCODMAT
               AND CODCOR = pCODCOR
               AND CODTAM = pCODTAM
               AND DATMOV < Trunc(pDATMOV)
             ORDER BY DATMOV DESC) TAB
          
     LIMIT 1;
         
  -- o anterior so nao tem datmov quando ele nao existe
  IF cULT_DATMOV IS NULL THEN
    bSEM_ANTERIOR := True;
  END IF;  
  
  IF pATUCUS = 'T' THEN
    -- obtem a nova ultima compra
    SELECT FILICO, SEQICO, NUMICO
      INTO cNOV_FILICO, cNOV_SEQICO, cNOV_NUMICO
      FROM TR_MOV
     WHERE CODFIL = pCODFIL
       AND CODMUL = pCODMUL
       AND FILMAT = pFILMAT
       AND CODMAT = pCODMAT
       AND CODCOR = pCODCOR
       AND CODTAM = pCODTAM
       AND DATMOV = Trunc(pDATMOV);
  ELSE
    cNOV_FILICO := cULT_FILICO;
    cNOV_SEQICO := cULT_SEQICO;
    cNOV_NUMICO := cULT_NUMICO;
  END IF;
  
  -- atualiza ultima compra nas movimentacoes 
  IF bSEM_ANTERIOR THEN
    -- para o caso de nao existir a ultima compra
    UPDATE TR_MOV
       SET FILICO = cNOV_FILICO,
           SEQICO = cNOV_SEQICO,
           NUMICO = cNOV_NUMICO
     WHERE FILMAT = pFILMAT
       AND CODMAT = pCODMAT
       AND CODCOR = pCODCOR
       AND CODTAM = pCODTAM
       AND FILICO IS NULL
       AND SEQICO IS NULL
       AND NUMICO IS NULL;
  ELSE
    -- atualiza as movimentacoes com data maior a da ultima compra
    UPDATE TR_MOV
       SET FILICO = cNOV_FILICO,
           SEQICO = cNOV_SEQICO,
           NUMICO = cNOV_NUMICO
     WHERE FILMAT = pFILMAT
       AND CODMAT = pCODMAT
       AND CODCOR = pCODCOR
       AND CODTAM = pCODTAM
       AND DATMOV > cULT_DATMOV
       AND (FILICO = cULT_FILICO OR FILICO IS NULL)
       AND (SEQICO = cULT_SEQICO OR SEQICO IS NULL)
       AND (NUMICO = cULT_NUMICO OR NUMICO IS NULL);
  END IF;
  
  RETURN NULL;

END;
$$ language 'plpgsql';





/*-- SEQ 0681 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RecalcFre (TR_MOV.CODFIL%TYPE,TR_MOV.CODMUL%TYPE,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,TR_MOV.DATMOV%TYPE,TT_ICO.CUSFRE%TYPE) CASCADE;

/*-- SEQ 0682 --*/
CREATE OR REPLACE FUNCTION RecalcFre (TR_MOV.CODFIL%TYPE,TR_MOV.CODMUL%TYPE,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,TR_MOV.DATMOV%TYPE,TT_ICO.CUSFRE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pCODMUL ALIAS FOR $2 ;
pFILMAT ALIAS FOR $3 ;
pCODMAT ALIAS FOR $4 ;
pCODCOR ALIAS FOR $5 ;
pCODTAM ALIAS FOR $6 ;
pDATMOV ALIAS FOR $7 ;
pCUSFRE ALIAS FOR $8 ;
-- Objetivo
-- 1) Recalcular a ultima compra com custo de frete do produto independentemente de filial ou estoque

  bSEM_ANTERIOR   BOOLEAN := False;
  cULT_DATMOV     TR_MOV.DATMOV%TYPE;
  cULT_FILFRE     TR_MOV.FILFRE%TYPE;
  cULT_SEQFRE     TR_MOV.SEQFRE%TYPE;
  cULT_NUMFRE     TR_MOV.NUMFRE%TYPE;
  cNOV_FILFRE     TR_MOV.FILFRE%TYPE;
  cNOV_SEQFRE     TR_MOV.SEQFRE%TYPE;
  cNOV_NUMFRE     TR_MOV.NUMFRE%TYPE;  

BEGIN
      -- obtem a ultima compra anterior
    SELECT TAB.DATMOV, TAB.FILFRE, TAB.SEQFRE, TAB.NUMFRE
      INTO cULT_DATMOV, cULT_FILFRE, cULT_SEQFRE, cULT_NUMFRE
      FROM (SELECT DATMOV, FILFRE, SEQFRE, NUMFRE    
              FROM TR_MOV
             WHERE FILMAT = pFILMAT
               AND CODMAT = pCODMAT
               AND CODCOR = pCODCOR
               AND CODTAM = pCODTAM
               AND DATMOV < Trunc(pDATMOV)
             ORDER BY DATMOV DESC) TAB
          
     LIMIT 1;
        
  
  -- o anterior so nao tem datmov quando ele nao existe
  IF cULT_DATMOV IS NULL THEN
    bSEM_ANTERIOR := True;
  END IF;
  
  IF pCUSFRE > 0 THEN
    -- obtem a nova ultima compra
    SELECT FILFRE, SEQFRE, NUMFRE
      INTO cNOV_FILFRE, cNOV_SEQFRE, cNOV_NUMFRE
      FROM TR_MOV
     WHERE CODFIL = pCODFIL
       AND CODMUL = pCODMUL
       AND FILMAT = pFILMAT
       AND CODMAT = pCODMAT
       AND CODCOR = pCODCOR
       AND CODTAM = pCODTAM
       AND DATMOV = Trunc(pDATMOV);   
  ELSE
    cNOV_FILFRE := cULT_FILFRE;
    cNOV_SEQFRE := cULT_SEQFRE;
    cNOV_NUMFRE := cULT_NUMFRE;
  END IF;
  
  -- atualiza ultima compra nas movimentacoes 
  IF bSEM_ANTERIOR THEN
    -- para o caso de nao existir a ultima compra
    UPDATE TR_MOV
       SET FILFRE = cNOV_FILFRE,
           SEQFRE = cNOV_SEQFRE,
           NUMFRE = cNOV_NUMFRE
     WHERE FILMAT = pFILMAT
       AND CODMAT = pCODMAT
       AND CODCOR = pCODCOR
       AND CODTAM = pCODTAM
       AND FILFRE IS NULL
       AND SEQFRE IS NULL
       AND NUMFRE IS NULL;
  ELSE
    -- atualiza as movimentacoes com data maior a da ultima compra
    UPDATE TR_MOV
       SET FILFRE = cNOV_FILFRE,
           SEQFRE = cNOV_SEQFRE,
           NUMFRE = cNOV_NUMFRE
     WHERE FILMAT = pFILMAT
       AND CODMAT = pCODMAT
       AND CODCOR = pCODCOR
       AND CODTAM = pCODTAM
       AND DATMOV > cULT_DATMOV
       AND (FILFRE = cULT_FILFRE OR FILFRE IS NULL)
       AND (SEQFRE = cULT_SEQFRE OR SEQFRE IS NULL)
       AND (NUMFRE = cULT_NUMFRE OR NUMFRE IS NULL);
  END IF;

  RETURN NULL;

END;
$$ language 'plpgsql';







/*-- SEQ 0683 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION INSERE_IUF (TI_PRO.FILMAT%TYPE,TI_PRO.CODMAT%TYPE,TI_PRO.ESTADO%TYPE,TI_PRO.REGESP%TYPE) CASCADE;

/*-- SEQ 0684 --*/
CREATE OR REPLACE FUNCTION INSERE_IUF (TI_PRO.FILMAT%TYPE,TI_PRO.CODMAT%TYPE,TI_PRO.ESTADO%TYPE,TI_PRO.REGESP%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILMAT ALIAS FOR $1 ;
pCODMAT ALIAS FOR $2 ;
pESTADO ALIAS FOR $3 ;
pREGESP ALIAS FOR $4 ;

BEGIN
    -- Atualiza a TT_IUF
    INSERT INTO TT_IUF
        (FILMAT,CODMAT,ESTADO,REGESP,RESICM,LUCSUB,SUBTRI,INSAGR,CALSUB)
        (SELECT FILMAT, CODMAT, UFLOJA, REGESP, 0 AS RESICM, 0 AS LUCSUB, '0' AS SUBTRI,
                'F' AS INSAGR, 'D' AS CALSUB
           FROM (SELECT PRO.FILMAT,PRO.CODMAT,FIL.*
                   FROM TT_PRO PRO, (SELECT DISTINCT UFLOJA, REGESP
                                       FROM TD_FIL DFIL
                                    ) FIL
                  WHERE PRO.FILMAT = pFILMAT
                    AND PRO.CODMAT = pCODMAT
                    AND (PRO.FILMAT, PRO.CODMAT, FIL.UFLOJA, FIL.REGESP) NOT IN (SELECT FILMAT,CODMAT,ESTADO,REGESP
                                                                                   FROM TT_IUF IUF
                                                                                  WHERE IUF.FILMAT = pFILMAT
                                                                                    AND IUF.CODMAT = pCODMAT
                                                                                    --AND IUF.ESTADO = pESTADO
                                                                                    --AND IUF.REGESP = pREGESP
                                                                                 )
                ) TAB
        );

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 0685 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PROCESSA_ENCOMENDA (TT_IVExIPE.CODFIL%TYPE,TT_IVExIPE.FILPED%TYPE,TT_IVExIPE.TIPPED%TYPE,TT_IVExIPE.NUMPED%TYPE,TT_IVExIPE.NUMITE%TYPE) CASCADE;

/*-- SEQ 0686 --*/
CREATE OR REPLACE FUNCTION PROCESSA_ENCOMENDA (TT_IVExIPE.CODFIL%TYPE,TT_IVExIPE.FILPED%TYPE,TT_IVExIPE.TIPPED%TYPE,TT_IVExIPE.NUMPED%TYPE,TT_IVExIPE.NUMITE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pFILPED ALIAS FOR $2 ;
pTIPPED ALIAS FOR $3 ;
pNUMPED ALIAS FOR $4 ;
pNUMITE ALIAS FOR $5 ;

-- Objetivos:
-- 1) Criar novos itens de oramento para encomendas que estejam vinculadas ao mesmo item

   CR_ENCOMENDAS CURSOR(pCODFIL TT_IVExIPE.CODFIL%TYPE,
           pFILPED TT_IVExIPE.FILPED%TYPE,
           pTIPPED TT_IVExIPE.TIPPED%TYPE,
           pNUMPED TT_IVExIPE.NUMPED%TYPE,
           pNUMITE TT_IVExIPE.NUMITE%TYPE) IS
   SELECT ENC.CODFIL, ENC.SEQUEN, ENC.QTDENC, ENC.NUMITE
     FROM TT_IVEXIPE ENC
    WHERE ENC.CODFIL = pCODFIL
      AND ENC.FILPED = pFILPED
      AND ENC.TIPPED = pTIPPED
      AND ENC.NUMPED = pNUMPED
      AND ENC.NUMITE = NVLZ(pNUMITE,ENC.NUMITE)
      AND ENC.FLGEST <> 'C'
      AND (SELECT COUNT(*)
             FROM TT_IVEXIPE IXI
            WHERE IXI.CODFIL = ENC.CODFIL
              AND IXI.FILPED = ENC.FILPED
              AND IXI.TIPPED = ENC.TIPPED
              AND IXI.NUMPED = ENC.NUMPED
              AND IXI.NUMITE = ENC.NUMITE
              AND IXI.FLGEST <> 'C'
              AND IXI.SEQUEN <> ENC.SEQUEN) > 0
    ORDER BY ENC.CODFIL, ENC.SEQUEN;

   vENC_QTDENC                   TT_IVExIPE.QTDENC%TYPE;
   vENC_CODFIL                   TT_IVEXIPE.CODFIL%TYPE;
   vENC_SEQUEN                   TT_IVEXIPE.SEQUEN%TYPE;
   vENC_NUMITE                   TT_IVEXIPE.NUMITE%TYPE;
   rIOR                          TT_IOR%ROWTYPE;
   vNOVO_NUMITE                  TT_IOR.NUMITE%TYPE;
   vNOVO_ORDITE                  TT_IOR.ORDITE%TYPE;
   cTEMP                         TT_IDF.LOCK_C%TYPE;
   bPrimeiroRegistro             BOOLEAN := TRUE;

BEGIN
   -- Garantia de exclusividade no processo seguinte
   SELECT LOCK_C INTO cTEMP
   FROM TT_IDF
   FOR UPDATE;

   -- verifica se orcamento est em alguma outra encomenda
   OPEN CR_ENCOMENDAS(pCODFIL, pFILPED, pTIPPED, pNUMPED, pNUMITE);
   LOOP
      FETCH CR_ENCOMENDAS INTO vENC_CODFIL, vENC_SEQUEN, vENC_QTDENC, vENC_NUMITE;
      EXIT WHEN NOT FOUND;

      -- item de oramento que est vinculado a uma segunda encomenda
      SELECT TT_IOR.*
        INTO rIOR
        FROM TT_IOR
       WHERE CODFIL = pFILPED
         AND TIPPED = pTIPPED
         AND NUMPED = pNUMPED
         AND NUMITE = vENC_NUMITE;

      -- No primeiro registro apenas atualiza a IOR
      -- Para os demais registros inclui novas IORs
      IF bPrimeiroRegistro THEN

          bPrimeiroRegistro := FALSE;

          UPDATE TT_IOR
             SET VLRCUS = (rIOR.VLRCUS / rIOR.QTDITE) * (vENC_QTDENC),
                 VLRPGT = (rIOR.VLRPGT / rIOR.QTDITE) * (vENC_QTDENC),
                 QTDITE = vENC_QTDENC,
                 FLGIVO = 'A' -- RFMP 98466  necessrio reprocessar as separaes
           WHERE CODFIL = pFILPED
             AND TIPPED = pTIPPED
             AND NUMPED = pNUMPED
             AND NUMITE = vENC_NUMITE;

      ELSE

          SELECT MAX(NUMITE)+1 AS NUMITE
            INTO vNOVO_NUMITE
            FROM TT_IOR
           WHERE CODFIL = pFILPED
             AND TIPPED = pTIPPED
             AND NUMPED = pNUMPED;

          SELECT MAX(ORDITE)+1 AS ORDITE
            INTO vNOVO_ORDITE
            FROM TT_IOR
           WHERE CODFIL = pFILPED
             AND TIPPED = pTIPPED
             AND NUMPED = pNUMPED;

          -- inclui o novo oramento para a nova encomenda
          INSERT INTO TT_IOR
                (CODFIL, TIPPED, NUMPED,
                 NUMITE, ORDITE, FILIVE,
                 SEQIVE, NUMIVE, TIPENT,
                 FILEND, NUMEND, ENTREG,
                 QTDITE, QTDENT, FILRES,
                 ATU_EM, FILMAT, CODMAT,
                 CODCOR, CODTAM, PERIPI,
                 QTDPRE, VLRITE, FILFOR,
                 CODFOR, PREUNI, FLGEST,
                 RESULT, VLRENT, NUMFOR,
                 VLRCUS, VLRPGT, MONTAR,
                 PHOMAR, PHOTIP, PHOISO,
                 PHOOUT, PROMOC, FILPAR,
                 CODPAR, TIPPAR, FILUSU,
                 CODUSU, APLICA, REPETE,
                 PERIOD, DIADUR, CODMUL,
                 CODAMB, FILDOU, SEQDOU,
                 FILEQP, SEQEQP, FILORI,
                 TIPORI, NUMORI, ITEORI,
                 TIPPGT, FILRCT, SEQRCT,
                 FLGENC)
          SELECT CODFIL, TIPPED, NUMPED,
                 vNOVO_NUMITE AS NUMITE,
                 vNOVO_ORDITE AS ORDITE,
                 null AS FILIVE,
                 null AS SEQIVE,
                 null AS NUMIVE,
                 TIPENT, FILEND, NUMEND,
                 null AS ENTREG,
                 vENC_QTDENC AS QTDITE,
                 0 AS QTDENT,
                 FILRES,
                 Agora() AS ATU_EM,
                 FILMAT, CODMAT,
                 CODCOR, CODTAM, PERIPI,
                 QTDPRE, VLRITE, FILFOR,
                 CODFOR, PREUNI, 'A' AS FLGEST,
                 RESULT, VLRENT, NUMFOR,
                 (rIOR.VLRCUS / rIOR.QTDITE) * vENC_QTDENC AS VLRCUS,
                 (rIOR.VLRPGT / rIOR.QTDITE) * vENC_QTDENC AS VLRPGT,
                 MONTAR, PHOMAR, PHOTIP,
                 PHOISO, PHOOUT, PROMOC,
                 FILPAR, CODPAR, TIPPAR,
                 FILUSU, CODUSU, APLICA,
                 REPETE, PERIOD, DIADUR,
                 CODMUL, CODAMB, FILDOU,
                 SEQDOU, FILEQP, SEQEQP,
                 pFILPED, pTIPPED, pNUMPED,
                 vENC_NUMITE, TIPPGT, FILRCT,
                 SEQRCT, 'T'
            FROM TT_IOR
           WHERE CODFIL = pFILPED
             AND TIPPED = pTIPPED
             AND NUMPED = pNUMPED
             AND NUMITE = vENC_NUMITE;

          -- vincula o novo item do oramento com a nova encomenda
          UPDATE TT_IVEXIPE
             SET NUMITE = vNOVO_NUMITE
           WHERE CODFIL = vENC_CODFIL
             AND SEQUEN = vENC_SEQUEN;

      END IF;
   END LOOP;
   CLOSE CR_ENCOMENDAS;

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 0687 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RETIRA_CUSTO_MOV (TT_COM.CODFIL%TYPE,TT_COM.SEQUEN%TYPE) CASCADE;

/*-- SEQ 0688 --*/
CREATE OR REPLACE FUNCTION RETIRA_CUSTO_MOV (TT_COM.CODFIL%TYPE,TT_COM.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
-- Objetivo:
-- 1) retira vinculo da tr_mov (filico, seqico, numico) com a tt_ico (tippar <> T)

  cCODFIL    TT_ICO.CODFIL%TYPE;
  cSEQUEN    TT_ICO.SEQUEN%TYPE;
  cNUMITE    TT_ICO.NUMITE%TYPE;
  
  Movto CURSOR FOR
  SELECT MIN(TAB.DATMOV) AS DATMOV, TAB.FILMAT, TAB.CODMAT, TAB.CODCOR, TAB.CODTAM, 
         TAB.FILICO, TAB.SEQICO, TAB.NUMICO
    FROM (
    SELECT DATMOV, FILMAT, CODMAT, CODCOR, CODTAM, 
           FILICO, SEQICO, NUMICO
      FROM TR_MOV
     WHERE FILICO = pCODFIL
       AND SEQICO = pSEQUEN
     ORDER BY DATMOV
  ) TAB
  GROUP BY TAB.FILMAT, TAB.CODMAT, TAB.CODCOR, TAB.CODTAM, 
           TAB.FILICO, TAB.SEQICO, TAB.NUMICO;

    
  temp record;
  
BEGIN

  OPEN Movto;
  LOOP
    -- para cada item de grade vinculado a compra informada...
    FETCH Movto INTO temp;
    EXIT WHEN NOT FOUND;

         
      -- descobre a ultima compra anterior
      SELECT TAB.FILICO, TAB.SEQICO, TAB.NUMICO
        INTO cCODFIL, cSEQUEN, cNUMITE
        FROM (SELECT DATMOV, FILICO, SEQICO, NUMICO    
                FROM TR_MOV
               WHERE FILMAT = temp.FILMAT
                 AND CODMAT = temp.CODMAT
                 AND CODCOR = temp.CODCOR
                 AND CODTAM = temp.CODTAM
                 AND DATMOV < temp.DATMOV
               ORDER BY DATMOV DESC) TAB
              
       LIMIT 1;
               
    -- atualiza ultima compra nas movimentacoes 
    UPDATE TR_MOV
       SET FILICO = cCODFIL,
           SEQICO = cSEQUEN,
           NUMICO = cNUMITE
     WHERE FILICO = temp.FILICO
       AND SEQICO = temp.SEQICO
       AND NUMICO = temp.NUMICO
       AND FILMAT = temp.FILMAT
       AND CODMAT = temp.CODMAT
       AND CODCOR = temp.CODCOR
       AND CODTAM = temp.CODTAM;    
    
  END LOOP;
  CLOSE Movto;

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 0689 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RETIRA_FRETE_MOV (TT_COM.CODFIL%TYPE,TT_COM.SEQUEN%TYPE) CASCADE;

/*-- SEQ 0690 --*/
CREATE OR REPLACE FUNCTION RETIRA_FRETE_MOV (TT_COM.CODFIL%TYPE,TT_COM.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
-- Objetivo:
-- 1) retira vinculo da tr_mov (filfre, seqfre, numfre) com a tt_ico (tippar = T)

  cCODFIL    TT_ICO.CODFIL%TYPE;
  cSEQUEN    TT_ICO.SEQUEN%TYPE;
  cNUMITE    TT_ICO.NUMITE%TYPE;
  
  Movto CURSOR FOR
  SELECT MIN(TAB.DATMOV) AS DATMOV, TAB.FILMAT, TAB.CODMAT, TAB.CODCOR, TAB.CODTAM, 
         TAB.FILFRE, TAB.SEQFRE, TAB.NUMFRE
    FROM (
    SELECT DATMOV, FILMAT, CODMAT, CODCOR, CODTAM, 
           FILFRE, SEQFRE, NUMFRE
      FROM TR_MOV
     WHERE FILFRE = pCODFIL
       AND SEQFRE = pSEQUEN
     ORDER BY DATMOV
  ) TAB
  GROUP BY TAB.FILMAT, TAB.CODMAT, TAB.CODCOR, TAB.CODTAM, 
           TAB.FILFRE, TAB.SEQFRE, TAB.NUMFRE;

    
  temp record;
  
BEGIN

  OPEN Movto;
  LOOP
    -- para cada item de grade vinculado a compra informada...
    FETCH Movto INTO temp;
    EXIT WHEN NOT FOUND;

         
      -- descobre a ultima compra com frete
      SELECT TAB.FILFRE, TAB.SEQFRE, TAB.NUMFRE
        INTO cCODFIL, cSEQUEN, cNUMITE
        FROM (SELECT DATMOV, FILFRE, SEQFRE, NUMFRE    
                FROM TR_MOV
               WHERE FILMAT = temp.FILMAT
                 AND CODMAT = temp.CODMAT
                 AND CODCOR = temp.CODCOR
                 AND CODTAM = temp.CODTAM
                 AND DATMOV < temp.DATMOV
               ORDER BY DATMOV DESC) TAB
              
       LIMIT 1;
          
        
    -- atualiza ultima compra com frete nas movimentacoes 
    UPDATE TR_MOV
       SET FILFRE = cCODFIL,
           SEQFRE = cSEQUEN,
           NUMFRE = cNUMITE
     WHERE FILFRE = temp.FILFRE
       AND SEQFRE = temp.SEQFRE
       AND NUMFRE = temp.NUMFRE
       AND FILMAT = temp.FILMAT
       AND CODMAT = temp.CODMAT
       AND CODCOR = temp.CODCOR
       AND CODTAM = temp.CODTAM;      
    
  END LOOP;
  CLOSE Movto;

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 0691 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VINCULA_ROMANEIO () CASCADE;

/*-- SEQ 0692 --*/
CREATE OR REPLACE FUNCTION VINCULA_ROMANEIO ()
RETURNS VARCHAR AS $$
DECLARE

  cTEMP TT_FUN.NOMFUN%TYPE; 

-- Objetivo:
-- 1) gera itens de romaneio (TT_IRO) a partir dos romaneios com notas impressas

BEGIN
  -- Garantia de exclusividade no processo seguinte
  SELECT NOMFUN INTO cTEMP 
  FROM TT_FUN
  WHERE NOMFUN = 'LOCK_ROM'
  FOR UPDATE;
  
    UPDATE TT_IVO
     SET FILIMP = FILIVE,
	     SEQIMP = SEQIVE,
		 NUMIMP = NUMIVE
   WHERE (FILVOL, SEQUEN) IN (   
          SELECT IVO.FILVOL, IVO.SEQUEN
            FROM TT_ROM ROM INNER JOIN TT_IVO IVO ON IVO.FILROM = ROM.CODFIL
                                                 AND IVO.SEQROM = ROM.SEQUEN
                             INNER JOIN TT_IVE IVE ON IVO.FILIVE = IVE.CODFIL
                                                  AND IVO.SEQIVE = IVE.SEQUEN
                                                  AND IVO.NUMIVE = IVE.NUMITE
							INNER JOIN TT_VEN VEN ON IVO.FILIVE = VEN.CODFIL
                                                  AND IVO.SEQIVE = VEN.SEQUEN
            WHERE ROM.FLGEST = 'F'
              AND IVO.FLGEST<>'C'
			  AND IVO.FILIMP IS NULL
			  AND VEN.CODSER='CF');
  
  -- cria itens de romaneio
  INSERT INTO TT_IRO
  (
  CODFIL, SEQUEN, FILVEN, SEQVEN, FILCLI, CODCLI, FLGEST, ENTREG   
  )
  (
  SELECT TAB.CODFIL, TAB.SEQUEN, TAB.FILIVE, TAB.SEQIVE, VEN.FILCLI, VEN.CODCLI, 'N' AS FLGEST, 'E' AS ENTREG
    FROM (
          SELECT MAX(ROM.CODFIL) AS CODFIL, MAX(ROM.SEQUEN) AS SEQUEN,
                 case when ven.codfil is not null 
                       and ven.codser = 'CF' 
                      then ive.codfil 
                      else COALESCE(ORI.CODFIL, IOR.FILIVE) 
                  end AS FILIVE,                  
                 case when ven.codfil is not null 
                       and ven.codser = 'CF' 
                      then ive.sequen 
                      else COALESCE(ORI.SEQUEN, IOR.SEQIVE) 
                  end AS SEQIVE
            FROM TT_ROM ROM INNER JOIN TT_IVO IVO ON IVO.FILROM = ROM.CODFIL
                                                 AND IVO.SEQROM = ROM.SEQUEN
                             LEFT JOIN TT_IVE IVE ON IVO.FILIVE = IVE.CODFIL
                                                 AND IVO.SEQIVE = IVE.SEQUEN
                                                 AND IVO.NUMIVE = IVE.NUMITE
							 LEFT JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL
                                                 AND VEN.SEQUEN = IVE.SEQUEN 
                             LEFT JOIN TT_IVE ORI ON ORI.FILORI = IVE.CODFIL
                                                 AND ORI.NUMORI = IVE.SEQUEN
                                                 AND ORI.ITEORI = IVE.NUMITE
                             LEFT JOIN TT_IOR IOR ON IVO.FILPED = IOR.CODFIL
                                                 AND IVO.TIPPED = IOR.TIPPED
                                                 AND IVO.NUMPED = IOR.NUMPED
                                                 AND IVO.NUMITE = IOR.NUMITE
           WHERE ROM.FLGEST = 'F'
             AND IVO.FLGEST<>'C'
             AND (ROM.CODFIL, ROM.SEQUEN) NOT IN
                 (SELECT ROM.CODFIL, ROM.SEQUEN
                    FROM TT_ROM ROM INNER JOIN TT_IVO IVO ON IVO.FILROM = ROM.CODFIL
                                                         AND IVO.SEQROM = ROM.SEQUEN
									 LEFT JOIN TT_VEN VEN ON IVO.FILIVE = VEN.CODFIL
                                                         AND IVO.SEQIVE = VEN.SEQUEN 
                   WHERE ROM.FLGEST = 'F'
                     AND IVO.FLGEST<>'C'
                     AND IVO.FILIMP IS NULL
					 AND COALESCE(VEN.CODSER,'  ') <> 'CF')
         GROUP BY case when ven.codfil is not null 
                       and ven.codser = 'CF' 
                      then ive.codfil 
                      else COALESCE(ORI.CODFIL, IOR.FILIVE) 
                  end, 
                  case when ven.codfil is not null 
                       and ven.codser = 'CF' 
                      then ive.sequen 
                      else COALESCE(ORI.SEQUEN, IOR.SEQIVE) 
                  end
        ) TAB INNER JOIN TT_VEN VEN ON VEN.CODFIL = TAB.FILIVE
                                   AND VEN.SEQUEN = TAB.SEQIVE  
               LEFT JOIN TT_IRO IRO ON TAB.FILIVE = IRO.FILVEN
                                   AND TAB.SEQIVE = IRO.SEQVEN                                   
                                   AND IRO.FLGEST = 'N'
   WHERE IRO.SEQUEN IS NULL     
  );
  
  -- atualiza estado
  UPDATE TT_ROM
     SET FLGEST = 'E'
   WHERE (CODFIL, SEQUEN) IN (   
          SELECT DISTINCT ROM.CODFIL, ROM.SEQUEN
            FROM TT_ROM ROM INNER JOIN TT_IVO IVO ON IVO.FILROM = ROM.CODFIL
                                                 AND IVO.SEQROM = ROM.SEQUEN
                             LEFT JOIN TT_IVE IVE ON IVO.FILIVE = IVE.CODFIL
                                                 AND IVO.SEQIVE = IVE.SEQUEN
                                                 AND IVO.NUMIVE = IVE.NUMITE
                             LEFT JOIN TT_IVE ORI ON ORI.FILORI = IVE.CODFIL
                                                 AND ORI.NUMORI = IVE.SEQUEN
                                                 AND ORI.ITEORI = IVE.NUMITE
                             LEFT JOIN TT_IOR IOR ON IVO.FILPED = IOR.CODFIL
                                                 AND IVO.TIPPED = IOR.TIPPED
                                                 AND IVO.NUMPED = IOR.NUMPED
                                                 AND IVO.NUMITE = IOR.NUMITE
            WHERE ROM.FLGEST = 'F'
              AND IVO.FLGEST<>'C'
              AND (ROM.CODFIL, ROM.SEQUEN) NOT IN
                  (SELECT ROM.CODFIL, ROM.SEQUEN
                     FROM TT_ROM ROM INNER JOIN TT_IVO IVO ON IVO.FILROM = ROM.CODFIL
                                                          AND IVO.SEQROM = ROM.SEQUEN
                                      LEFT JOIN TT_IVE IVE ON IVO.FILIVE = IVE.CODFIL
                                                          AND IVO.SEQIVE = IVE.SEQUEN
                                                          AND IVO.NUMIVE = IVE.NUMITE
									  LEFT JOIN TT_VEN VEN ON IVO.FILIVE = VEN.CODFIL
                                                          AND IVO.SEQIVE = VEN.SEQUEN
                   WHERE ROM.FLGEST = 'F'
                     AND IVO.FLGEST<>'C'
                     AND IVO.FILIMP IS NULL
                     AND COALESCE(IVE.SITMOV,'N') <> 'C'
                     AND (COALESCE(IVE.QTDPEN,0) > 0 OR IVE.QTDPEN IS NULL)
					 AND COALESCE(VEN.CODSER,'  ') <> 'CF')
         GROUP BY ROM.CODFIL, ROM.SEQUEN, COALESCE(ORI.CODFIL, IOR.FILIVE), COALESCE(ORI.SEQUEN, IOR.SEQIVE)   
  );
  
   -- MN - Preenche a informao de impresso de separao. O checkout j fazia isso, mas o processo foi pro commerce web  que no faz.
   -- Essa rotina mexe com romaneios, ento a ideia  que ela faa o vnculo dos oramentos com televendas com o item de venda
   UPDATE TT_IVO
     SET FILIMP = FILIVE,
	      SEQIMP = SEQIVE,
		   NUMIMP = NUMIVE
   WHERE (FILVOL, SEQUEN) IN (   
          SELECT IVO.FILVOL, IVO.SEQUEN
            FROM TT_ROM ROM INNER JOIN TT_IVO IVO ON IVO.FILROM = ROM.CODFIL
                                                 AND IVO.SEQROM = ROM.SEQUEN
                             INNER JOIN TT_IVE IVE ON IVO.FILIVE = IVE.CODFIL
                                                  AND IVO.SEQIVE = IVE.SEQUEN
                                                  AND IVO.NUMIVE = IVE.NUMITE
            WHERE ROM.FLGEST = 'F'
              AND IVO.FLGEST IN ('E')
			     AND IVO.FILIMP IS NULL 
         );  

  -- cancela cargas que contenham somente itens cancelados
  UPDATE TT_ROM
     SET FLGEST = 'C'
   WHERE (CODFIL, SEQUEN) IN (   
          SELECT ROM.CODFIL, ROM.SEQUEN
            FROM TT_ROM ROM
           WHERE ROM.FLGEST = 'F'
             AND NOT EXISTS (SELECT 1
                               FROM TT_IVO IVO 
                              WHERE IVO.FILROM = ROM.CODFIL
                                AND IVO.SEQROM = ROM.SEQUEN
                                AND IVO.FLGEST <> 'C') 
           GROUP BY ROM.CODFIL, ROM.SEQUEN
  );

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 0693 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION QTDCOMPRAPRODUTO (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 0694 --*/
CREATE OR REPLACE FUNCTION QTDCOMPRAPRODUTO (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE)
RETURNS Numeric AS $$
DECLARE
pDATAINI ALIAS FOR $1 ;
pDATAFIM ALIAS FOR $2 ;
pFILMAT ALIAS FOR $3 ;
pCODMAT ALIAS FOR $4 ;
pCODCOR ALIAS FOR $5 ;
pCODTAM ALIAS FOR $6 ;
pCODFIL ALIAS FOR $7 ;
  QCOMQTDMOV Numeric;
BEGIN
  SELECT ROUND(SUM(ICO.QTDCOM),2) 
    INTO QCOMQTDMOV
    FROM TT_COM COM INNER JOIN TT_ICO ICO ON COM.CODFIL = ICO.CODFIL
                                         AND COM.SEQUEN = ICO.SEQUEN
   WHERE ICO.FILMAT = pFILMAT
     AND ICO.CODMAT = pCODMAT
     AND ICO.CODCOR = pCODCOR
     AND ICO.CODTAM = pCODTAM
     AND COM.FLGEST <> 'D'
     AND ICO.SITMOV <> 'C'
     AND ICO.DATINC BETWEEN pDATAINI 
                        AND pDATAFIM
     AND COALESCE(pCODFIL,ICO.CODFIL) = ICO.CODFIL;

  RETURN COALESCE(QCOMQTDMOV,0);

END;
$$ language 'plpgsql';




/*-- SEQ 0695 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION QuantidadeEmTransito (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 0696 --*/
CREATE OR REPLACE FUNCTION QuantidadeEmTransito (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE)
RETURNS TT_IVE.QTDMOV%TYPE AS $$
DECLARE
pFILMAT ALIAS FOR $1 ;
pCODMAT ALIAS FOR $2 ;
pCODCOR ALIAS FOR $3 ;
pCODTAM ALIAS FOR $4 ;
pCODFIL ALIAS FOR $5 ;

-- Objetivos:
-- 1. Conta nmero de vendas em determinado perodo para determinada grade de produto.
--    Baseado em Nota Fiscal e Fatura.

-- Declarao de variveis e cursores
   nCount                        Numeric(9);
   dIni                          Timestamp;               -- data inicial do periodo com as horas
   dFim                          Timestamp;               -- data final do periodo com as horas   
   nQtdEmTransito                TT_IVE.QTDMOV%TYPE;

-- Incio da funo
BEGIN
   nQtdEmTransito := 0;
   
   SELECT COALESCE(SUM(IVE.QTDMOV),0) 
     INTO nQtdEmTransito
     FROM TT_TRA TRA INNER JOIN TT_VEN VEN ON VEN.CODFIL = TRA.FILIVE 
                                          AND VEN.SEQUEN = TRA.SEQIVE
                     INNER JOIN TT_IVE IVE ON IVE.CODFIL = TRA.FILIVE 
                                          AND IVE.SEQUEN = TRA.SEQIVE 
                                          AND IVE.NUMITE = TRA.NUMIVE
    WHERE TRA.NUMICO IS NULL
      AND TRA.FILMAT = pFilMat
      AND TRA.CODMAT = pCodMat
      AND TRA.CODCOR = pCodCor
      AND TRA.CODTAM = pCodTam
      AND VEN.FLGEST <> 'C'
      AND INSTR(COALESCE(pCodFil, VEN.FILCLI)||';', VEN.FILCLI||';') > 0
      AND VEN.CODCLI = LPAD('0', 6, ' ');

   RETURN COALESCE(nQtdEmTransito,0);

END;
$$ language 'plpgsql';




/*-- SEQ 0697 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RateioCustoFrete (VARCHAR,TT_ICO.CODFIL%TYPE,TT_ICO.SEQUEN%TYPE,TT_ICO.NUMITE%TYPE,CHAR) CASCADE;

/*-- SEQ 0698 --*/
CREATE OR REPLACE FUNCTION RateioCustoFrete (VARCHAR,TT_ICO.CODFIL%TYPE,TT_ICO.SEQUEN%TYPE,TT_ICO.NUMITE%TYPE,CHAR)
RETURNS Numeric AS $$
DECLARE
pTipoRetorno ALIAS FOR $1 ;
cFILICO ALIAS FOR $2 ;
cSEQICO ALIAS FOR $3 ;
cNUMICO ALIAS FOR $4 ;
cTipoRateio ALIAS FOR $5 ;
 -- Objetivos
 -- Obtem o custo de frete de um item de compra
 -- pTipoRetorno:
 -- FRETE - Valor do Frete
 -- BASFRE - Base do ICMS do Frete
 -- ICMFRE - ICMS do Frete
 -- OUTTAX - Seguro do Frete
 -- ISEICM - Isento do ICMS do Frete
 -- OUTICM - Outros do ICMS do Frete
 -- 
 -- cTipoRateio: V - VALOR
 --              P - PESO
   nCUSTOFRETE                   Numeric;
   nQTDMOV                       TT_ICO.QTDMOV%TYPE;
   nVALOR                        TT_ICO.VLRMOV%TYPE;
   nPESO                         Numeric(16,4);
   nVLRCOM                       TT_COM.VLRNOT%TYPE;
   nPESCOM                       Numeric(16,4);
   nVLRFRE                       TT_COM.VLRNOT%TYPE;
   nVLRTOTFRE                    TT_COM.VLRNOT%TYPE;
   nTOTPESFRE                    Numeric(16,4);
   nValorRateado                 Numeric(16,4);
   nICMFRE                       TT_COM.ICMFRE%TYPE;
   nOUTTAX                       TT_COM.OUTTAX%TYPE;
   nBASFRE                       TT_COM.BASFRE%TYPE;
   nISEICM                       TT_COM.ISEICM%TYPE;
   nOUTICM                       TT_COM.OUTICM%TYPE;

   CursorTotalFreteValor CURSOR FOR
   SELECT MIN(F.VLRLIQ) AS VLRFRE,
          MIN(F.BASFRE) AS BASFRE,
          MIN(F.ICMFRE) AS ICMFRE,
          MIN(F.OUTTAX) AS OUTTAX,
          MIN(F.ISEICM) AS ISEICM,
          MIN(F.OUTICM) AS OUTICM,
          (SELECT SUM(COM.VLRLIQ-COALESCE(COM.SUBSTT,0)-COALESCE(COM.VLRSRV,0))
             FROM TT_COM COM 
            INNER JOIN TT_FREXCOM FREXCOM ON FREXCOM.FILCOM=COM.CODFIL AND FREXCOM.SEQCOM=COM.SEQUEN
            WHERE FREXCOM.FILFRE=FXC.FILFRE AND FREXCOM.SEQFRE=FXC.SEQFRE) AS VLRTOTFRE
     FROM TT_COM F 
    INNER JOIN TT_FREXCOM FXC ON F.CODFIL=FXC.FILFRE AND F.SEQUEN=FXC.SEQFRE
    INNER JOIN TT_COM C ON FXC.FILCOM=C.CODFIL AND FXC.SEQCOM=C.SEQUEN
    INNER JOIN TT_ICO ICO ON C.CODFIL = ICO.CODFIL AND C.SEQUEN = ICO.SEQUEN
    WHERE ICO.CODFIL=cFILICO
      AND ICO.SEQUEN=cSEQICO
      AND ICO.NUMITE=cNUMICO
	  AND C.FLGEST<>'D'
	  AND F.FLGEST<>'D'
    GROUP BY FXC.FILFRE, FXC.SEQFRE;

   CursorTotalFretePeso CURSOR FOR
   SELECT MIN(F.VLRLIQ) AS VLRFRE,
          MIN(F.BASFRE) AS BASFRE,
          MIN(F.ICMFRE) AS ICMFRE,
          MIN(F.OUTTAX) AS OUTTAX,
          MIN(F.ISEICM) AS ISEICM,
          MIN(F.OUTICM) AS OUTICM,
         (SELECT SUM(ICO.QTDMOV*GRA.PESBRU) 
            FROM TT_COM COM 
           INNER JOIN TT_FREXCOM FREXCOM ON FREXCOM.FILCOM=COM.CODFIL AND FREXCOM.SEQCOM=COM.SEQUEN
           INNER JOIN TT_ICO ICO ON COM.CODFIL = ICO.CODFIL AND COM.SEQUEN = ICO.SEQUEN
           INNER JOIN TT_GRA GRA ON ICO.FILMAT=GRA.FILMAT AND ICO.CODMAT=GRA.CODMAT AND ICO.CODCOR=GRA.CODCOR AND ICO.CODTAM=GRA.CODTAM
           WHERE FREXCOM.FILFRE=FXC.FILFRE AND FREXCOM.SEQFRE=FXC.SEQFRE) AS TOTPES
     FROM TT_COM F 
    INNER JOIN TT_FREXCOM FXC ON F.CODFIL=FXC.FILFRE AND F.SEQUEN=FXC.SEQFRE
    INNER JOIN TT_COM C ON FXC.FILCOM=C.CODFIL AND FXC.SEQCOM=C.SEQUEN
    INNER JOIN TT_ICO ICO ON C.CODFIL = ICO.CODFIL AND C.SEQUEN = ICO.SEQUEN 
    WHERE ICO.CODFIL=cFILICO
      AND ICO.SEQUEN=cSEQICO
      AND ICO.NUMITE=cNUMICO
	  AND F.FLGEST<>'D'
	  AND C.FLGEST<>'D'
    GROUP BY FXC.FILFRE, FXC.SEQFRE;

BEGIN
   
   -- Item de Compra --
   SELECT ICO.QTDMOV, (ICO.VLRMOV+ICO.VLRIPI) AS VALOR, GRA.PESBRU*ICO.QTDMOV AS PESO
     INTO nQTDMOV, nVALOR, nPESO
     FROM TT_ICO ICO 
    INNER JOIN TT_GRA GRA ON ICO.FILMAT=GRA.FILMAT AND ICO.CODMAT=GRA.CODMAT AND ICO.CODCOR=GRA.CODCOR AND ICO.CODTAM=GRA.CODTAM   
    WHERE ICO.CODFIL=cFILICO
      AND ICO.SEQUEN=cSEQICO
      AND ICO.NUMITE=cNUMICO;

   -- Total Compra --
   SELECT SUM(C.VLRLIQ-COALESCE(C.SUBSTT,0)-COALESCE(C.VLRSRV,0)) AS VLRCOM, SUM(ICO.QTDMOV*GRA.PESBRU) AS PESCOM
     INTO nVLRCOM, nPESCOM
     FROM TT_COM C 
    INNER JOIN TT_ICO ICO ON C.CODFIL = ICO.CODFIL AND C.SEQUEN = ICO.SEQUEN
    INNER JOIN TT_GRA GRA ON ICO.FILMAT=GRA.FILMAT AND ICO.CODMAT=GRA.CODMAT AND ICO.CODCOR=GRA.CODCOR AND ICO.CODTAM=GRA.CODTAM
    WHERE ICO.CODFIL=cFILICO
      AND ICO.SEQUEN=cSEQICO
      AND ICO.NUMITE=cNUMICO;
   
   nCUSTOFRETE := 0;
   IF cTipoRateio='P' THEN 
      OPEN CursorTotalFretePeso;
      LOOP
         FETCH CursorTotalFretePeso
            INTO nVLRFRE, nBASFRE, nICMFRE, nOUTTAX, nISEICM, nOUTICM, nTOTPESFRE;
         EXIT WHEN NOT FOUND;

         IF pTipoRetorno='FRETE' THEN
            nValorRateado := nVLRFRE;
         ELSIF pTipoRetorno='BASFRE' THEN
            nValorRateado := nBASFRE;
         ELSIF pTipoRetorno='ICMFRE' THEN
            nValorRateado := nICMFRE;
         ELSIF pTipoRetorno='ICMFREUNI' THEN
            nValorRateado := nICMFRE;
         ELSIF pTipoRetorno='OUTTAX' THEN
            nValorRateado := nOUTTAX;
         ELSIF pTipoRetorno='ISEICM' THEN
            nValorRateado := nISEICM;
         ELSIF pTipoRetorno='OUTICM' THEN
            nValorRateado := nOUTICM;
         END IF;

         IF nTOTPESFRE<>0 AND nPESCOM<>0 THEN
            nCUSTOFRETE := nCUSTOFRETE + (nValorRateado * (nPESO/nTOTPESFRE) * (nPESO / nPESCOM));
         END IF;

         IF pTipoRetorno='ICMFREUNI' AND nPESO<>0 THEN
            nCUSTOFRETE := nCUSTOFRETE / nPESO;
         END IF;

      END LOOP;
      CLOSE CursorTotalFretePeso;
   ELSE
      OPEN CursorTotalFreteValor;
      LOOP
         FETCH CursorTotalFreteValor
            INTO nVLRFRE, nBASFRE, nICMFRE, nOUTTAX, nISEICM, nOUTICM, nVLRTOTFRE;
         EXIT WHEN NOT FOUND;

         IF pTipoRetorno='FRETE' THEN
            nValorRateado := nVLRFRE;
         ELSIF pTipoRetorno='BASFRE' THEN
            nValorRateado := nBASFRE;
         ELSIF pTipoRetorno='ICMFRE' THEN
            nValorRateado := nICMFRE;
         ELSIF pTipoRetorno='ICMFREUNI' THEN
            nValorRateado := nICMFRE;
         ELSIF pTipoRetorno='OUTTAX' THEN
            nValorRateado := nOUTTAX;
         ELSIF pTipoRetorno='ISEICM' THEN
            nValorRateado := nISEICM;
         ELSIF pTipoRetorno='OUTICM' THEN
            nValorRateado := nOUTICM;
         END IF;

         IF nVLRTOTFRE<>0 AND nVLRCOM<>0 THEN
            nCUSTOFRETE := nCUSTOFRETE + (nValorRateado * (nVLRCOM/nVLRTOTFRE) * (nVALOR / nVLRCOM));
         END IF;

         IF pTipoRetorno='ICMFREUNI' AND nQTDMOV<>0 THEN
            nCUSTOFRETE := nCUSTOFRETE / nQTDMOV;
         END IF;

      END LOOP;
      CLOSE CursorTotalFreteValor;
   END IF;

   RETURN round(nCUSTOFRETE,4);

END;
$$ language 'plpgsql';




/*-- SEQ 0699 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Rateio_DESRAT_SAT (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE) CASCADE;

/*-- SEQ 0700 --*/
CREATE OR REPLACE FUNCTION Rateio_DESRAT_SAT (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE)
RETURNS Numeric AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pNUMITE ALIAS FOR $3 ;
   nVEN_VLRNOT                   TT_VEN.VLRNOT%TYPE;
   nVEN_VLRLIQ                   TT_VEN.VLRLIQ%TYPE;
   nVEN_DESRAT                   TT_VEN.DESRAT%TYPE;
   nVEN_SUBSTT                   TT_VEN.SUBSTT%TYPE;
   nVEN_VLRFRE                   TT_VEN.VLRFRE%TYPE;
   nVEN_VLRSEG                   TT_VEN.VLRSEG%TYPE;
   nVEN_OUTTAX                   TT_VEN.OUTTAX%TYPE;
   cVEN_FLGEST                   TT_VEN.FLGEST%TYPE;
   nIVE_VLRMOV                   TT_IVE.VLRMOV%TYPE;
   cIVE_SITKIT                   TT_IVE.SITKIT%TYPE;
   nMAX_NUMITE                   TT_IVE.NUMITE%TYPE;
   nMIN_NUMITE                   TT_IVE.NUMITE%TYPE;
   cIVE_SITMOV                   TT_IVE.SITMOV%TYPE;

   nVLRDIF                       Numeric(12,2);
   nValor                        Numeric(12,2);
   nSoma                         Numeric(12,2);
   bDesconto                     BOOLEAN;
   n_maior_vlrmov                Numeric(14,2);
BEGIN
   -- MN - 104209 - Foi verificado que o rateio do SAT estava sendo feita de maneira incorreta pelo checkout, pois temos regras que no aplica desconto da nota
   -- em itens promocionais, mas isso  regra nossa, e mandamos para o sat o desconto total da nota, quando isso acontece, ele rateia por regra de 3 simples entre todos
   -- os itens, mesmo os promocionais.
   
   -- MN - 104209 - Essa funo poder ser dropada no futuro, quando o checkout for ajustado e ratear corretamente as notas sat, usei como base o script  "T:\totallcommerce\beta\ansi\function\1\Rateio_ValorLiquido_NF.mac"
   -- mas rateando entre desconto
   
   -- MN - 104209 - Nessa tarefa eu deixei o script que recalcula o DESRAT dos itens de SAT novamente
   nVLRDIF   := 0;
   nValor    := 0;
   nSoma     := 0;
   bDesconto := FALSE;

   -- MN - Busca variveis necessrias para o clculo
         SELECT IVE.VLRMOV, IVE.SITKIT,
             VEN.VLRNOT, VEN.VLRLIQ, COALESCE(VEN.SUBSTT,0),
             COALESCE(VEN.VLRFRE,0), COALESCE(VEN.VLRSEG,0), COALESCE(VEN.OUTTAX,0),
             VEN.DESRAT AS VEN_DESRAT,
             VEN.FLGEST, IVE.SITMOV
        INTO nIVE_VLRMOV, cIVE_SITKIT,
             nVEN_VLRNOT, nVEN_VLRLIQ, nVEN_SUBSTT,
             nVEN_VLRFRE, nVEN_VLRSEG, nVEN_OUTTAX,
             nVEN_DESRAT,
             cVEN_FLGEST, cIVE_SITMOV
        FROM TT_IVE IVE
        JOIN TT_VEN VEN ON VEN.CODFIL=IVE.CODFIL AND VEN.SEQUEN=IVE.SEQUEN
       WHERE IVE.CODFIL = pCODFIL
         AND IVE.SEQUEN = pSEQUEN
         AND IVE.NUMITE = pNUMITE;
      
   -- MN - Se no houver desconto, no tem o que ratear
   IF nVEN_DESRAT = 0 THEN
      RETURN 0;
   END IF;
   
   -- MN - Se item  header de kit no precisa ratear.
   IF cIVE_SITKIT NOT IN ('2','3') THEN
      RETURN 0;
   END IF;
   
   -- MN - No rateia para venda cancelada
   IF cVEN_FLGEST = 'C' THEN
      RETURN 0;
   END IF;

   -- MN - Procura o menor numite no cancelado
         
         SELECT MIN(IVE.NUMITE)
           INTO nMIN_NUMITE
           FROM TT_IVE IVE 
          WHERE IVE.CODFIL = pCODFIL
            AND IVE.SEQUEN = pSEQUEN
            AND IVE.SITKIT IN ('2','3')
            AND CASE WHEN IVE.SITMOV = 'N' THEN 1 ELSE 0 END = 1;
      
   -- MN - Procura o item de maior valor no cancelado
            SELECT MAX(IVE.VLRMOV)
           INTO n_maior_vlrmov
           FROM TT_IVE IVE 
          WHERE IVE.CODFIL = pCODFIL
            AND IVE.SEQUEN = pSEQUEN
            AND IVE.SITKIT IN ('2','3')
            AND CASE WHEN IVE.SITMOV = 'N' THEN 1 ELSE 0 END = 1;
      
   -- MN - Se no achar o maior vlrmov no cancelado, significa que a venda no est cancelada, mas os itens esto = Erro!
   IF n_maior_vlrmov = 0 THEN
      RETURN 0;
   END IF;
   
   -- MN - Procura o item de maior valor no cancelado, para jogar diferena de rateio, conforme manual do sped, registros c800/c850
            SELECT MAX(IVE.NUMITE)
           INTO nMAX_NUMITE
           FROM TT_IVE IVE 
          WHERE IVE.CODFIL = pCODFIL
            AND IVE.SEQUEN = pSEQUEN
            AND IVE.SITKIT IN ('2','3')
            AND IVE.VLRMOV = n_maior_vlrmov;
      
   -- Calculo aplicado a coluna TT_IVE.DESRAT
   nValor := ROUND(nIVE_VLRMOV / (nVEN_VLRNOT) * nVEN_DESRAT, 2);

   
      -- Calcula diferena
      IF pNUMITE = nMAX_NUMITE THEN
         SELECT SUM(ROUND(IVE.VLRMOV / (nVEN_VLRNOT) * nVEN_DESRAT,2)) 
           INTO nSoma
           FROM TT_IVE IVE 
          WHERE IVE.CODFIL = pCODFIL
            AND IVE.SEQUEN = pSEQUEN
            AND IVE.SITKIT IN ('2','3')
            AND CASE WHEN cVEN_FLGEST = 'C'
                     THEN 1
                     ELSE CASE WHEN IVE.SITMOV = 'N' THEN 1 ELSE 0 END
                END = 1;

          nVLRDIF := nVEN_DESRAT - nSoma;
      END IF;

   RETURN COALESCE( nValor + nVLRDIF,0);
   

END;
$$ language 'plpgsql' STABLE;




/*-- SEQ 0701 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Rateio_ValorLiquido_ECF (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE,VARCHAR) CASCADE;

/*-- SEQ 0702 --*/
CREATE OR REPLACE FUNCTION Rateio_ValorLiquido_ECF (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE,VARCHAR)
RETURNS Numeric AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pNUMITE ALIAS FOR $3 ;
pTIPO ALIAS FOR $4 ;

-- Declarao de variveis e cursores
-- sadas do cursor CR_Aliquotas
   nQtd                          Numeric(5);
   nVlrBru                       Numeric(16,2);
   cTotali                       VARCHAR(4);

   bPrimeiro                     VARCHAR(1);

   v_Vlrliq                      TT_VEN.VLRLIQ%TYPE;
   v_Vlrnot                      TT_VEN.VLRNOT%TYPE;
   v_Marcef                      TD_ECF.MARECF%TYPE;
   v_Sitmov                      TT_IVE.SITMOV%TYPE;
   v_Vlrmov                      TT_IVE.VLRMOV%TYPE;
   v_Sitkit                      TT_IVE.SITKIT%TYPE;

   n_DescontoTotal_CalcRatDesc   Numeric(12,2);
   n_SubTotal_CalcRatDesc        Numeric(12,2);
   n_PerEfetivo_CalcRatDesc      Numeric(6,2);
   n_DescAliq_CalcRatDesc        Numeric(12,2);
   n_DescAliqTotal_CalcRatDesc   Numeric(12,2);
   n_DescItemTotal_CalcRatDesc   Numeric(18,6);
   n_Residuo_CalcRatDesc         Numeric(12,2);

   c_TotaliMaior                 VARCHAR(4);
   c_TotaliItem                  VARCHAR(4);

   v_Numite_CrItens              TT_IVE.NUMITE%TYPE;
   v_Vlrmov_CrItens              TT_IVE.VLRMOV%TYPE;
   v_SomaItensVlrmov_CrItens     TT_IVE.VLRMOV%TYPE;
   v_Totali_CrItens              VARCHAR(4);

   v_Numite_CrItens_Maior        TT_IVE.NUMITE%TYPE;

   n_SubTotal_CalcRatItem        Numeric(12,2);
   n_DescItem_CalcRatItem        Numeric(12,2);
   n_DescItemTotal_CalcRatItem   Numeric(12,2);
   n_Residuo_CalcRatItem         Numeric(12,2);
   n_PerEfetivo_CalcRatItem      Numeric(10,6);
   pVLRRAT                       Numeric(12,2);

   n_VlrliqRateado               Numeric(12,2);
   n_Residuo_CalcFinal           Numeric(12,2);
   n_Contador                    Numeric(5);

   nVLRSEG                       TT_VEN.VLRSEG%TYPE;
   nVLRFRE                       TT_VEN.VLRFRE%TYPE;
   nOUTTAX                       TT_VEN.OUTTAX%TYPE;
   nDESRAT                       TT_VEN.DESRAT%TYPE;

   aVal Numeric(10)[];
aVal_n_VlrliqRateado_Item Numeric(12,2)[];
aVal_n_VlrbruRateado_Item Numeric(12,2)[];
aVal_v_Numite_CrItens_Item Numeric(5)[];
aVal_v_Totali_CrItens_Item VARCHAR(4)[];

aValCount Numeric(10) := 0;


CR_Aliquotas CURSOR(pMARECF TD_ECF.MARECF%TYPE) IS
SELECT count(*) as qtd,
       SUM(IVE.VLRMOV) as vlrbru,
       CAST(case when ive.icmtip = '3' then 'SUBS'
                 when ive.icmtip in ('2','4') then 'ISEN'
                 when ive.icmtip = '1' then 'NAOT'
                 else lpad(TO_CHAR(trunc(ive.taxicm)*100),4,'0')
             end as char(4)) AS TOTALI
  FROM TT_IVE IVE
 WHERE IVE.SITKIT IN ('2','3')
   AND IVE.SITMOV='N'
   AND IVE.CODFIL=pCODFIL
   AND IVE.SEQUEN=pSEQUEN
 GROUP BY CAST(case when ive.icmtip = '3' then 'SUBS'
                    when ive.icmtip in ('2','4') then 'ISEN'
                    when ive.icmtip = '1' then 'NAOT'
                    else lpad(TO_CHAR(trunc(ive.taxicm)*100),4,'0')
                end as char(4)), IVE.CODFIL, IVE.SEQUEN
 order by sum(IVE.VLRMOV) desc,
          case when upper(pmarecf)='BEMATECH' THEN CAST(case when ive.icmtip = '3' then 'SUBS'
               when ive.icmtip in ('2','4') then 'ISEN'
               when ive.icmtip = '1' then 'NAOT'
               else lpad(TO_CHAR(trunc(ive.taxicm)*100),4,'0')
           end as char(4)) end desc,
          case when coalesce(upper(pmarecf),'')<>'BEMATECH' THEN CAST(case when ive.icmtip = '3' then 'SUBS'
               when ive.icmtip in ('2','4') then 'ISEN'
               when ive.icmtip = '1' then 'NAOT'
               else lpad(TO_CHAR(trunc(ive.taxicm)*100),4,'0')
           end as char(4)) end;

CR_ItensCF CURSOR(pTOTALI VARCHAR) IS
SELECT IVE.NUMITE, IVE.VLRMOV,
       CASE WHEN IVE.ICMTIP = '3' THEN 'SUBS'
            WHEN IVE.ICMTIP IN ('2','4') THEN 'ISEN'
            WHEN IVE.ICMTIP = '1' THEN 'NAOT'
            ELSE LPAD(TO_CHAR(TRUNC(IVE.TAXICM)*100),4,'0')
        END AS TOTALI
  FROM TT_IVE IVE
 WHERE IVE.CODFIL = pCODFIL
   AND IVE.SEQUEN = pSEQUEN
   AND IVE.SITKIT IN ('2','3')
   AND IVE.SITMOV = 'N'
   AND CASE WHEN IVE.ICMTIP = '3' THEN 'SUBS'
            WHEN IVE.ICMTIP IN ('2','4') THEN 'ISEN'
            WHEN IVE.ICMTIP = '1' THEN 'NAOT'
            ELSE LPAD(TO_CHAR(TRUNC(IVE.TAXICM)*100),4,'0')
        END = pTOTALI
 ORDER BY IVE.VLRMOV DESC;

BEGIN
/*
    -- Realiza o clculo do desconto rateado conforme fazem as impressoras fiscais
    -- ref: http://www.desenvolvedoresdaruma.com.br/home/downloads/Site_2011/STKs/Como_a_impressora_faz_o_rateio_de_imposto_nas_aliquotas.pdf
    -- ref: http://partners.bematech.com.br/bemacast/2011/04/edicao-64-rateio-no-ecf/
*/

    SELECT VEN.VLRLIQ,
           VEN.VLRNOT,
           ECF.MARECF,
           VEN.VLRLIQ-COALESCE(VEN.VLRNOT,0) AS DESVEN,
           VEN.VLRSEG,
           VEN.VLRFRE,
           VEN.OUTTAX,
           VEN.DESRAT,
           IVE.SITMOV,
           IVE.VLRMOV,
           CASE WHEN IVE.ICMTIP = '3' THEN 'SUBS'
                WHEN IVE.ICMTIP IN ('2','4') THEN 'ISEN'
                WHEN IVE.ICMTIP = '1' THEN 'NAOT'
                ELSE LPAD(TO_CHAR(TRUNC(IVE.TAXICM)*100),4,'0')
            END AS TOTALI,
           IVE.SITKIT
           INTO v_Vlrliq, v_Vlrnot, v_Marcef, n_DescontoTotal_CalcRatDesc, nVLRSEG, nVLRFRE, nOUTTAX, nDESRAT,
                v_Sitmov, v_Vlrmov, c_TotaliItem, v_Sitkit
      FROM TT_VEN VEN INNER JOIN TD_ECF ECF ON VEN.CODFIL = ECF.FILECF
                                           AND VEN.NUMECF = ECF.NUMECF
                      INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL
                                           AND IVE.SEQUEN = VEN.SEQUEN
     WHERE IVE.CODFIL = pCODFIL
       AND IVE.SEQUEN = pSEQUEN
       AND IVE.NUMITE = pNUMITE;

    -- Se o item for cancelado encerra a funo por aqui.
    if v_Sitmov = 'C' then
       return 0;
    end if;

    -- Se cupom fiscal s tem um item no precisa ratear nada.
    if v_Sitkit not in ('2','3') then
       return 0;
    end if;

    -- Se no houver desconto, o valor do item  o item bruto.
    -- Se cupom fiscal s tem um item no precisa ratear nada.
    if (n_DescontoTotal_CalcRatDesc = 0) or (v_Vlrnot = v_Vlrmov) then
       IF pTIPO='VLRSEG' THEN
          return nVLRSEG;
       ELSIF pTIPO='VLRFRE' THEN
          return nVLRFRE;
       ELSIF pTIPO='OUTTAX' THEN
          return nOUTTAX;
       ELSIF pTIPO='DESRAT' THEN
          return nDESRAT;
       ELSE
          if v_Vlrnot = v_Vlrmov then
             return v_Vlrliq;
          else
             return v_Vlrmov;
          end if;
       END IF;
    end if;

    IF pTIPO='VLRSEG' THEN
       n_DescontoTotal_CalcRatDesc := nVLRSEG;
    ELSIF pTIPO='VLRFRE' THEN
       n_DescontoTotal_CalcRatDesc := nVLRFRE;
    ELSIF pTIPO='OUTTAX' THEN
       n_DescontoTotal_CalcRatDesc := nOUTTAX;
    ELSIF pTIPO='DESRAT' THEN
       n_DescontoTotal_CalcRatDesc := nDESRAT;
    END IF;

    IF n_DescontoTotal_CalcRatDesc=0 THEN
       RETURN 0;
    END IF;

    -- R$ desconto / R$ subtotal = resultado x 100 = % efetivo
    -- R$ 298,82 / R$ 3338,70 = 0,0895~ x 100 = 8,9501~
    n_SubTotal_CalcRatDesc   := v_Vlrnot;
    n_PerEfetivo_CalcRatDesc := Trunc(n_DescontoTotal_CalcRatDesc / n_SubTotal_CalcRatDesc * 100,2);
    n_PerEfetivo_CalcRatItem := n_DescontoTotal_CalcRatDesc / n_SubTotal_CalcRatDesc * 100;

--      RAISE NOTICE ''n_PerEfetivo_CalcRatDesc=%'',n_PerEfetivo_CalcRatDesc;
    bPrimeiro                   := 'T';
    c_TotaliMaior               := '';
    n_DescAliqTotal_CalcRatDesc := 0;
    OPEN CR_Aliquotas(v_Marcef);
      LOOP
        FETCH CR_Aliquotas INTO nQtd, nVlrBru, cTotali;
        EXIT WHEN NOT FOUND;

        -- R$ 2050,27 * 8,95% = 183,499165 => 183,49
        n_DescAliq_CalcRatDesc      := Trunc(nVlrBru * n_PerEfetivo_CalcRatDesc / 100,2);
        n_DescAliqTotal_CalcRatDesc := n_DescAliqTotal_CalcRatDesc + n_DescAliq_CalcRatDesc;

        -- guarda a soma do VLRMOV da alquota do item que se est realizando o rateio
        if cTotali = c_TotaliItem then
           n_SubTotal_CalcRatItem   := n_DescAliq_CalcRatDesc;
           v_SomaItensVlrmov_CrItens := nVlrBru;
        end if;

        -- Order By define quem  o maior
        IF bPrimeiro = 'T' THEN
            c_TotaliMaior := cTotali;
        END IF;

        bPrimeiro := 'F';

    END LOOP;
    CLOSE CR_Aliquotas;

    n_Residuo_CalcRatDesc := n_DescontoTotal_CalcRatDesc - n_DescAliqTotal_CalcRatDesc;

    -- A partir daqui tem o resduo e qual  a maior alquota
    -- c_TotaliMaior
    -- n_Residuo_CalcRatDesc

    n_Contador                  := 0;
    n_DescItemTotal_CalcRatItem := 0;
    n_Residuo_CalcRatItem       := 0;
    n_DescItemTotal_CalcRatDesc := 0;
--    v_SomaItensVlrmov_CrItens   := 0;
    bPrimeiro                   := 'T';
    OPEN CR_ItensCF(c_TotaliItem);
    LOOP
        FETCH CR_ItensCF INTO v_Numite_CrItens, v_Vlrmov_CrItens, v_Totali_CrItens;
        EXIT WHEN NOT FOUND;

        -- Guarda o NUMITE do maior item para uso posterior
        if n_Contador = 0 then
           v_Numite_CrItens_Maior := v_Numite_CrItens;
        end if;

        -- Calcula o desconto rateado truncando o valor final
        n_DescItem_CalcRatItem := trunc(n_SubTotal_CalcRatItem*v_Vlrmov_CrItens/v_SomaItensVlrmov_CrItens,2);

--        n_DescItem_CalcRatItem      := round(v_Vlrmov_CrItens * n_PerEfetivo_CalcRatItem / 100,2);

        -- evita que o item fique zerado
        if v_Vlrmov_CrItens + n_DescItem_CalcRatItem = 0 AND pTIPO is null then
           n_DescItem_CalcRatItem := n_DescItem_CalcRatItem + 0.01;
        end if;

        -- acumula o desconto calculado dos itens
        n_DescItemTotal_CalcRatItem := n_DescItemTotal_CalcRatItem + n_DescItem_CalcRatItem;

        -- diminui o desconto calculado do valor do item
        n_VlrliqRateado := v_Vlrmov_CrItens + n_DescItem_CalcRatItem;

        n_Contador := n_Contador + 1;

        -- add no array
        aValCount := aValCount + 1;
if aValCount = 1 then
   select ARRAY[aValCount] into aVal; 
   select ARRAY[n_VlrliqRateado] into aVal_n_VlrliqRateado_Item;
   select ARRAY[v_Vlrmov_CrItens] into aVal_n_VlrbruRateado_Item;
   select ARRAY[v_Numite_CrItens] into aVal_v_Numite_CrItens_Item;
   select ARRAY[v_Totali_CrItens] into aVal_v_Totali_CrItens_Item;
else
   select array_append(aVal, aValCount) into aVal;
   select array_append(aVal_n_VlrliqRateado_Item, n_VlrliqRateado) into aVal_n_VlrliqRateado_Item;
   select array_append(aVal_n_VlrbruRateado_Item, v_Vlrmov_CrItens) into aVal_n_VlrbruRateado_Item;
   select array_append(aVal_v_Numite_CrItens_Item, v_Numite_CrItens) into aVal_v_Numite_CrItens_Item;
   select array_append(aVal_v_Totali_CrItens_Item, v_Totali_CrItens) into aVal_v_Totali_CrItens_Item;
end if;


    END LOOP;
    CLOSE CR_ItensCF;

--    n_DescItemTotal_CalcRatDesc := round(v_SomaItensVlrmov_CrItens * n_PerEfetivo_CalcRatItem / 100,2);

    -- verifica se h resduo entre o total de desconto da venda com o total de desconto calculado nos itens
    n_Residuo_CalcRatItem := n_SubTotal_CalcRatItem - n_DescItemTotal_CalcRatItem;


--      RAISE NOTICE ''n_DescItemTotal_CalcRatDesc=%'',n_DescItemTotal_CalcRatDesc;--      RAISE NOTICE ''n_DescItemTotal_CalcRatItem=%'',n_DescItemTotal_CalcRatItem;
    if aValCount > 0 then
for aValCount in array_lower(aVal,1) .. array_upper(aVal,1) loop

       -- trata residuo dos itens
       if n_Residuo_CalcRatItem <> 0 then

           -- joga o resduo do desconto no maior item da alquota
           if aVal_v_Numite_CrItens_Item[aValCount] = v_Numite_CrItens_Maior then
              aVal_n_VlrliqRateado_Item[aValCount] := aVal_n_VlrliqRateado_Item[aValCount] + n_Residuo_CalcRatItem;
           end if;

       end if;

       -- trata residuo da aliquota
       if n_Residuo_CalcRatDesc <> 0 then
          if aVal_v_Totali_CrItens_Item[aValCount] = c_TotaliMaior then
               n_DescItem_CalcRatItem := (aVal_n_VlrliqRateado_Item[aValCount]-aVal_n_VlrbruRateado_Item[aValCount]);

               if (n_DescontoTotal_CalcRatDesc>0 and n_DescItem_CalcRatItem+n_Residuo_CalcRatDesc<0) or
                  (n_DescontoTotal_CalcRatDesc<0 and n_DescItem_CalcRatItem+n_Residuo_CalcRatDesc>0) then
                  aVal_n_VlrliqRateado_Item[aValCount] := aVal_n_VlrliqRateado_Item[aValCount]-n_DescItem_CalcRatItem;
                  n_Residuo_CalcRatDesc := n_Residuo_CalcRatDesc+n_DescItem_CalcRatItem;
               ELSIF (aVal_n_VlrliqRateado_Item[aValCount] + n_Residuo_CalcRatDesc) <= 0 then
                    n_Residuo_CalcRatDesc := n_Residuo_CalcRatDesc + aVal_n_VlrliqRateado_Item[aValCount] - 0.01;
                    aVal_n_VlrliqRateado_Item[aValCount] := 0.01;
               else
                  aVal_n_VlrliqRateado_Item[aValCount] := aVal_n_VlrliqRateado_Item[aValCount] + n_Residuo_CalcRatDesc;
                  n_Residuo_CalcRatDesc := 0;
               end if;

          end if;
       end if;

    end loop;
end if;

    if aValCount > 0 then
for aValCount in array_lower(aVal,1) .. array_upper(aVal,1) loop
       if aVal_v_Numite_CrItens_Item[aValCount] = pNUMITE then
          n_VlrliqRateado := aVal_n_VlrliqRateado_Item[aValCount];
          exit;
       end if;
    end loop;
end if;

    IF pTIPO is null THEN
       return n_VlrliqRateado;
    ELSE
       return n_VlrliqRateado-v_Vlrmov;
    END IF;


END;
$$ language 'plpgsql' STABLE;


/*-- SEQ 0703 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Rateio_ValorLiquido_ECF (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE);

/*-- SEQ 0704 --*/
CREATE OR REPLACE FUNCTION Rateio_ValorLiquido_ECF (TT_IVE.CODFIL%TYPE,
                               TT_IVE.SEQUEN%TYPE,
                               TT_IVE.NUMITE%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN Rateio_ValorLiquido_ECF($1,$2,$3,null);
END;
$$ language 'plpgsql' STABLE;


/*-- SEQ 0705 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Rateio_ValorLiquido_NF (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE,VARCHAR) CASCADE;

/*-- SEQ 0706 --*/
CREATE OR REPLACE FUNCTION Rateio_ValorLiquido_NF (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE,VARCHAR)
RETURNS Numeric AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pNUMITE ALIAS FOR $3 ;
pTIPO ALIAS FOR $4 ;

   nVEN_VLRNOT                   TT_VEN.VLRNOT%TYPE;
   nVEN_VLRLIQ                   TT_VEN.VLRLIQ%TYPE;
   nVEN_DESRAT                   TT_VEN.DESRAT%TYPE;
   nVEN_SUBSTT                   TT_VEN.SUBSTT%TYPE;
   nVEN_VLRFRE                   TT_VEN.VLRFRE%TYPE;
   nVEN_VLRSEG                   TT_VEN.VLRSEG%TYPE;
   nVEN_OUTTAX                   TT_VEN.OUTTAX%TYPE;
   cVEN_FLGEST                   TT_VEN.FLGEST%TYPE;
   nIVE_VLRMOV                   TT_IVE.VLRMOV%TYPE;
   cIVE_SITKIT                   TT_IVE.SITKIT%TYPE;
   nMAX_NUMITE                   TT_IVE.NUMITE%TYPE;
   nMIN_NUMITE                   TT_IVE.NUMITE%TYPE;
   cIVE_PROMOC                   TT_IVE.PROMOC%TYPE;
   cIVE_SITMOV                   TT_IVE.SITMOV%TYPE;

   nVLRDIF                       Numeric(12,2);
   nValor                        Numeric(12,2);
   nSoma                         Numeric(12,2);
   nPromoc                       Numeric(12,2);
   bDesconto                     BOOLEAN; -- RFMP 100704

BEGIN

   nVLRDIF   := 0;
   nValor    := 0;
   nSoma     := 0;
   nPromoc   := 0;
   bDesconto := FALSE;

         SELECT IVE.PROMOC, IVE.VLRMOV, IVE.SITKIT,
             VEN.VLRNOT, VEN.VLRLIQ, COALESCE(VEN.SUBSTT,0),
             COALESCE(VEN.VLRFRE,0), COALESCE(VEN.VLRSEG,0), COALESCE(VEN.OUTTAX,0),
             (COALESCE(VEN.VLRLIQ,0) - COALESCE(VEN.VLRSEG,0) - COALESCE(VEN.OUTTAX,0) -
              COALESCE(VEN.VLRFRE,0) - COALESCE(VEN.VLRNOT,0) - COALESCE(VEN.SUBSTT,0)) AS DESRAT,
             VEN.FLGEST, IVE.SITMOV
        INTO cIVE_PROMOC, nIVE_VLRMOV, cIVE_SITKIT,
             nVEN_VLRNOT, nVEN_VLRLIQ, nVEN_SUBSTT,
             nVEN_VLRFRE, nVEN_VLRSEG, nVEN_OUTTAX,
             nVEN_DESRAT,
             cVEN_FLGEST, cIVE_SITMOV
        FROM TT_IVE IVE
        JOIN TT_VEN VEN ON VEN.CODFIL=IVE.CODFIL AND VEN.SEQUEN=IVE.SEQUEN
       WHERE IVE.CODFIL = pCODFIL
         AND IVE.SEQUEN = pSEQUEN
         AND IVE.NUMITE = pNUMITE;
   
   -- Se no houver desconto, o valor do item  o item bruto.
   -- Se nota s tem um item no precisa ratear nada.
   IF (nVEN_DESRAT = 0) OR (nVEN_VLRNOT = nIVE_VLRMOV) THEN
      IF pTIPO='DESRAT' THEN
         RETURN nVEN_DESRAT;
      ELSE
         IF nVEN_VLRNOT = nIVE_VLRMOV THEN
            RETURN nVEN_VLRLIQ;
         /*ELSE                   -- RFMP 100704 No pode ser o item bruto porque o VLRLIQ 
            RETURN nIVE_VLRMOV;*/ --             composto tambm por SUBSTT, VLRFRE, VLRSEG e OUTTAX.
         END IF;
      END IF;
   END IF;

   -- RFMP 100704
   -- Define se o DESRAT  um desconto ou  um acrscimo.
   -- Se for desconto, ento no pode ser rateado entre os itens em promoo [IVE.PROMOC="T"].
   IF nVEN_VLRLIQ > 0 THEN
      IF nVEN_DESRAT < 0 THEN
         bDesconto := TRUE;
      END IF;
   ELSE
      IF nVEN_DESRAT > 0 THEN
         bDesconto := TRUE;
      END IF;
   END IF;

   -- Se item em promoo no permite desconto
   IF (cIVE_PROMOC = 'T') AND (pTIPO='DESRAT') AND (bDesconto) THEN
      RETURN 0;
   END IF;

   -- Se item  header de kit no precisa ratear.
   IF cIVE_SITKIT NOT IN ('2','3') THEN
      RETURN 0;
   END IF;

         IF (pTIPO='DESRAT') AND bDesconto THEN
         SELECT MAX(IVE.NUMITE), MIN(IVE.NUMITE)
           INTO nMAX_NUMITE, nMIN_NUMITE
           FROM TT_IVE IVE 
          WHERE IVE.CODFIL = pCODFIL
            AND IVE.SEQUEN = pSEQUEN
            AND IVE.SITKIT IN ('2','3')
            AND IVE.PROMOC = 'F'
            AND CASE WHEN cVEN_FLGEST = 'C'
                     THEN 1
                     ELSE CASE WHEN IVE.SITMOV = 'N' THEN 1 ELSE 0 END
                END = 1;
      ELSE
         SELECT MAX(IVE.NUMITE), MIN(IVE.NUMITE)
           INTO nMAX_NUMITE, nMIN_NUMITE
           FROM TT_IVE IVE 
          WHERE IVE.CODFIL = pCODFIL
            AND IVE.SEQUEN = pSEQUEN
            AND IVE.SITKIT IN ('2','3')
            AND CASE WHEN cVEN_FLGEST = 'C'
                     THEN 1
                     ELSE CASE WHEN IVE.SITMOV = 'N' THEN 1 ELSE 0 END
                END = 1;
      END IF;

   
   IF bDesconto THEN
               SELECT COALESCE(SUM(IVE.VLRMOV),0)
           INTO nPromoc
           FROM TT_IVE IVE 
          WHERE IVE.CODFIL = pCODFIL
            AND IVE.SEQUEN = pSEQUEN
            AND IVE.SITKIT IN ('2','3')
            AND IVE.PROMOC = 'T'
            AND CASE WHEN cVEN_FLGEST = 'C'
                     THEN 1
                     ELSE CASE WHEN IVE.SITMOV = 'N' THEN 1 ELSE 0 END
                END = 1;
         END IF;

   IF pTIPO = 'DESRAT' THEN

      -- Calculo aplicado a coluna TT_IVE.DESRAT

      -- RFMP 100704
      -- Tratamento do 0,01 foi includo para os casos em que o rateio dava um valor to insignificante
      -- que zerava o campo.

      IF (nVEN_VLRLIQ > 0) THEN
         IF (nVEN_DESRAT < 0) THEN
            IF (cIVE_PROMOC = 'F') THEN
               nValor := ROUND(nIVE_VLRMOV / (nVEN_VLRNOT - nPromoc) * nVEN_DESRAT, 2);
            END IF;
         ELSIF (nVEN_DESRAT > 0) THEN
            nValor := ROUND(nIVE_VLRMOV / nVEN_VLRNOT * nVEN_DESRAT, 2);
         END IF;
      ELSIF (nVEN_VLRLIQ < 0) THEN
         IF (nVEN_DESRAT > 0) THEN
            IF (cIVE_PROMOC = 'F') THEN
               nValor := ROUND(nIVE_VLRMOV / (nVEN_VLRNOT - nPromoc) * nVEN_DESRAT, 2);
            END IF;
         ELSIF (nVEN_DESRAT < 0) THEN
            nValor := ROUND(nIVE_VLRMOV / nVEN_VLRNOT * nVEN_DESRAT, 2);
         END IF;
      END IF;

      IF (cIVE_PROMOC = 'T') AND (bDesconto) AND (COALESCE(nValor,0) = 0) THEN
         RETURN 0;
      ELSE
         -- Calcula diferena
         IF pNUMITE = nMIN_NUMITE THEN
            SELECT CASE WHEN MIN(nVEN_VLRLIQ) > 0
                        THEN CASE WHEN MIN(nVEN_DESRAT) < 0 THEN SUM(CASE WHEN IVE.PROMOC = 'F'
                                                                          THEN ROUND(IVE.VLRMOV / (nVEN_VLRNOT - nPromoc) * nVEN_DESRAT,2)
                                                                          ELSE 0
                                                                     END)
                                  WHEN MIN(nVEN_DESRAT) > 0 THEN SUM(ROUND(IVE.VLRMOV / nVEN_VLRNOT * nVEN_DESRAT,2))
                             END
                        WHEN MIN(nVEN_VLRLIQ) < 0
                        THEN CASE WHEN MIN(nVEN_DESRAT) > 0 THEN SUM(CASE WHEN IVE.PROMOC = 'F'
                                                                          THEN ROUND(IVE.VLRMOV / (nVEN_VLRNOT - nPromoc) * nVEN_DESRAT,2)
                                                                          ELSE 0
                                                                     END)
                                  WHEN MIN(nVEN_DESRAT) < 0 THEN SUM(ROUND(IVE.VLRMOV / nVEN_VLRNOT * nVEN_DESRAT,2))
                             END
                   END AS SOMA
              INTO nSoma
              FROM TT_IVE IVE 
             WHERE IVE.CODFIL = pCODFIL
               AND IVE.SEQUEN = pSEQUEN
               AND IVE.SITKIT IN ('2','3')
               AND CASE WHEN cVEN_FLGEST = 'C'
                        THEN 1
                        ELSE CASE WHEN IVE.SITMOV = 'N' THEN 1 ELSE 0 END
                   END = 1;

             nVLRDIF := nVEN_DESRAT - nSoma;
         END IF;
      END IF;

      RETURN COALESCE( nValor + nVLRDIF,0);
   ELSE
      -- Calculo aplicado a coluna TT_IVE.VLRLIQRAT
      IF (nVEN_VLRLIQ > 0) THEN
         IF (nVEN_DESRAT < 0) THEN
            IF (cIVE_PROMOC = 'F') THEN
               nValor := ROUND((nIVE_VLRMOV / (nVEN_VLRNOT - nPromoc)) * (nVEN_VLRLIQ - nVEN_SUBSTT - nPromoc), 2);
            ELSE
               nValor := nIVE_VLRMOV;
            END IF;
         ELSE
            nValor := ROUND((nIVE_VLRMOV / nVEN_VLRNOT) * (nVEN_VLRLIQ - nVEN_SUBSTT), 2);
         END IF;
      ELSE
         IF (nVEN_DESRAT > 0) THEN
            IF (cIVE_PROMOC = 'F') THEN
               nValor := ROUND((nIVE_VLRMOV / (nVEN_VLRNOT - nPromoc)) * (nVEN_VLRLIQ - nVEN_SUBSTT - nPromoc), 2);
            ELSE
               nValor := nIVE_VLRMOV;
            END IF;
         ELSE
            nValor := ROUND((nIVE_VLRMOV / nVEN_VLRNOT) * (nVEN_VLRLIQ - nVEN_SUBSTT), 2);
         END IF;
      END IF;
      -- Calcula diferena
      SELECT CASE WHEN MIN(nVEN_VLRLIQ) > 0
                  THEN MIN(nVEN_VLRLIQ) -
                          -- Clculo abaixo  para descobrir o desconto rateado da venda
                          (CASE WHEN MIN(nVEN_DESRAT) < 0
                                THEN SUM(CASE WHEN IVE.PROMOC = 'F'
                                              THEN ROUND((IVE.VLRMOV / (nVEN_VLRNOT - nPromoc)) * (nVEN_VLRLIQ - nVEN_SUBSTT - nPromoc),2)
                                              ELSE 0
                                         END) + nPromoc
                                ELSE SUM(ROUND((IVE.VLRMOV / nVEN_VLRNOT) * (nVEN_VLRLIQ - nVEN_SUBSTT),2))
                           END)
                  ELSE MIN(nVEN_VLRLIQ) +
                          -- Clculo abaixo  para descobrir o desconto rateado da venda
                          (CASE WHEN MIN(nVEN_DESRAT) > 0
                                THEN SUM(CASE WHEN IVE.PROMOC = 'F'
                                              THEN ROUND((IVE.VLRMOV / (nVEN_VLRNOT - nPromoc)) * (nVEN_VLRLIQ - nVEN_SUBSTT - nPromoc),2)
                                              ELSE 0
                                         END) + nPromoc
                                ELSE SUM(ROUND((IVE.VLRMOV / nVEN_VLRNOT) * (nVEN_VLRLIQ - nVEN_SUBSTT),2))
                           END)*-1
            END AS DIF
       INTO nVLRDIF
       FROM TT_IVE IVE
      WHERE IVE.CODFIL = pCODFIL
        AND IVE.SEQUEN = PSEQUEN
        AND IVE.SITKIT IN ('2','3')
        AND CASE WHEN cVEN_FLGEST = 'C'
                     THEN 1
                     ELSE CASE WHEN IVE.SITMOV = 'N' THEN 1 ELSE 0 END
                END = 1;

      IF pNUMITE = nMAX_NUMITE THEN
         nVALOR := nVALOR + nVLRDIF;
      END IF;

      RETURN nVALOR;

   END IF;

END;
$$ language 'plpgsql' STABLE;


/*-- SEQ 0707 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Rateio_ValorLiquido_NF (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE);

/*-- SEQ 0708 --*/
CREATE OR REPLACE FUNCTION Rateio_ValorLiquido_NF (TT_IVE.CODFIL%TYPE,
                               TT_IVE.SEQUEN%TYPE,
                               TT_IVE.NUMITE%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN Rateio_ValorLiquido_NF($1,$2,$3,NULL);
END;
$$ language 'plpgsql' STABLE;


/*-- SEQ 0709 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Rateio_ValorLiquido_Notas (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE) CASCADE;

/*-- SEQ 0710 --*/
CREATE OR REPLACE FUNCTION Rateio_ValorLiquido_Notas (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE)
RETURNS Numeric AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pNUMITE ALIAS FOR $3 ;

  nDIF                           Numeric(12,2);
  nValor                         Numeric(12,2);
  vMIN_NUMITE                    TT_IVE.NUMITE%TYPE;
  vCOUNT_ICMTIP                  Numeric(5);
  nPromoc                        Numeric(12,2);
  cPROMOC                        TT_IVE.PROMOC%TYPE;
  cSITMOV                        TT_IVE.SITMOV%TYPE;

BEGIN
  nValor  := 0;
  nPromoc := 0;
  cPROMOC := 'F';

      SELECT IVE.PROMOC, IVE.SITMOV
      INTO cPROMOC, cSITMOV
      FROM TT_IVE IVE
     WHERE IVE.CODFIL = pCODFIL
       AND IVE.SEQUEN = pSEQUEN
       AND IVE.NUMITE = pNUMITE
       AND IVE.SITKIT IN ('2','3');
  
  IF cSITMOV = 'C' THEN
    RETURN 0;
  END IF;

  SELECT COUNT(*)
    INTO vCOUNT_ICMTIP
    FROM (SELECT DISTINCT IVE.ICMTIP
            FROM TT_IVE IVE
           WHERE IVE.CODFIL = pCODFIL
             AND IVE.SEQUEN = pSEQUEN
             AND IVE.SITKIT IN ('2','3')
             AND IVE.SITMOV <> 'C') A;

  IF vCOUNT_ICMTIP > 1 THEN
    SELECT COALESCE(MIN(IVE.NUMITE),1)
      INTO vMIN_NUMITE
      FROM TT_IVE IVE
     WHERE IVE.CODFIL = pCODFIL
       AND IVE.SEQUEN = pSEQUEN
       AND IVE.SITKIT IN ('2','3')
       AND IVE.SITMOV <> 'C'
       AND IVE.ICMTIP = '0';
  ELSE
    SELECT MIN(IVE.NUMITE)
      INTO vMIN_NUMITE
      FROM TT_IVE IVE
     WHERE IVE.CODFIL = pCODFIL
       AND IVE.SEQUEN = pSEQUEN
       AND IVE.SITKIT IN ('2','3')
       AND IVE.SITMOV <> 'C';
  END IF;

      SELECT COALESCE(SUM(IVE.VLRMOV),0)
      INTO nPromoc
      FROM TT_IVE IVE
     WHERE IVE.CODFIL = pCODFIL
       AND IVE.SEQUEN = pSEQUEN
       AND IVE.SITKIT IN ('2','3')
       AND IVE.SITMOV <> 'C'
       AND IVE.PROMOC = 'T';
  
  SELECT CASE WHEN MIN(VEN.VLRLIQ) > 0
              THEN MIN(COALESCE(VEN.VLRLIQ,0) -
                       COALESCE(VEN.SUBSTT,0) -
                       COALESCE(VEN.VLRFRE,0) -
                       COALESCE(VEN.VLRSEG,0) -
                       COALESCE(VEN.OUTTAX,0)) -
                       -- Clculo abaixo  para descobrir o desconto rateado da venda
                       (CASE WHEN MIN(COALESCE(VEN.VLRLIQ,0) -
                                      COALESCE(VEN.VLRSEG,0) -
                                      COALESCE(VEN.OUTTAX,0) -
                                      COALESCE(VEN.VLRFRE,0) -
                                      COALESCE(VEN.VLRNOT,0) -
                                      COALESCE(VEN.SUBSTT,0)) < 0
                             THEN SUM(CASE WHEN IVE.PROMOC = 'F'
                                           THEN ROUND((IVE.VLRMOV / (VEN.VLRNOT - nPromoc)) *
                                                      (VEN.VLRLIQ - VEN.SUBSTT - nPromoc),2)
                                           ELSE 0
                                      END) + nPromoc
                             ELSE SUM(ROUND((IVE.VLRMOV / VEN.VLRNOT) *
                                            (VEN.VLRLIQ - VEN.SUBSTT),2))
                        END)
              ELSE MIN(COALESCE(VEN.VLRLIQ,0) +
                       COALESCE(VEN.SUBSTT,0) +
                       COALESCE(VEN.VLRFRE,0) +
                       COALESCE(VEN.VLRSEG,0) +
                       COALESCE(VEN.OUTTAX,0)) +
                       -- Clculo abaixo  para descobrir o desconto rateado da venda
                       (CASE WHEN MIN(COALESCE(VEN.VLRLIQ,0) -
                                      COALESCE(VEN.VLRSEG,0) -
                                      COALESCE(VEN.OUTTAX,0) -
                                      COALESCE(VEN.VLRFRE,0) -
                                      COALESCE(VEN.VLRNOT,0) -
                                      COALESCE(VEN.SUBSTT,0)) > 0
                             THEN SUM(CASE WHEN IVE.PROMOC = 'F'
                                           THEN ROUND((IVE.VLRMOV / (VEN.VLRNOT - nPromoc)) *
                                                      (VEN.VLRLIQ - VEN.SUBSTT - nPromoc),2)
                                           ELSE 0
                                      END) + nPromoc
                             ELSE SUM(ROUND((IVE.VLRMOV / VEN.VLRNOT) *
                                            (VEN.VLRLIQ - VEN.SUBSTT),2))
                        END)*-1
         END AS DIF
    INTO nDif
    FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON VEN.CODFIL = IVE.CODFIL
                                                           AND VEN.SEQUEN = IVE.SEQUEN
   WHERE VEN.CODFIL = pCODFIL
     AND VEN.SEQUEN = PSEQUEN
     AND IVE.SITKIT IN ('2','3')
     AND IVE.SITMOV <> 'C'
     AND VEN.CODSER <> 'CF'
     AND (VEN.VLRLIQ <> 0 AND VEN.VLRNOT <> 0);

  SELECT CASE WHEN VEN.VLRLIQ > 0
              THEN CASE WHEN (COALESCE(VEN.VLRLIQ,0) -
                              COALESCE(VEN.VLRSEG,0) -
                              COALESCE(VEN.OUTTAX,0) -
                              COALESCE(VEN.VLRFRE,0) -
                              COALESCE(VEN.VLRNOT,0) -
                              COALESCE(VEN.SUBSTT,0)) < 0
                        THEN CASE WHEN cPROMOC = 'F'
                                  THEN ROUND((IVE.VLRMOV / (VEN.VLRNOT - nPromoc)) *
                                             (VEN.VLRLIQ - VEN.SUBSTT - nPromoc),2)
                                  ELSE IVE.VLRMOV
                             END
                        ELSE ROUND((IVE.VLRMOV / VEN.VLRNOT) *
                                   (VEN.VLRLIQ - VEN.SUBSTT),2)
                   END
              ELSE CASE WHEN (COALESCE(VEN.VLRLIQ,0) -
                              COALESCE(VEN.VLRSEG,0) -
                              COALESCE(VEN.OUTTAX,0) -
                              COALESCE(VEN.VLRFRE,0) -
                              COALESCE(VEN.VLRNOT,0) -
                              COALESCE(VEN.SUBSTT,0)) > 0
                        THEN CASE WHEN cPROMOC = 'F'
                                  THEN ROUND((IVE.VLRMOV / (VEN.VLRNOT - nPromoc)) *
                                             (VEN.VLRLIQ - VEN.SUBSTT - nPromoc),2)
                                  ELSE IVE.VLRMOV
                             END
                        ELSE ROUND((IVE.VLRMOV / VEN.VLRNOT) *
                                   (VEN.VLRLIQ - VEN.SUBSTT),2)
                   END
         END AS RATEIO
    INTO nValor
    FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON VEN.CODFIL = IVE.CODFIL
                                                           AND VEN.SEQUEN = IVE.SEQUEN
   WHERE VEN.CODFIL = pCODFIL
     AND VEN.SEQUEN = pSEQUEN
     AND IVE.NUMITE = pNUMITE
     AND IVE.SITKIT IN ('2','3')
     AND IVE.SITMOV <> 'C'
     AND VEN.CODSER <> 'CF'
     AND (VEN.VLRLIQ <> 0 AND VEN.VLRNOT <> 0);

  IF pNUMITE = vMIN_NUMITE THEN
    nVALOR := nVALOR+nDIF;
  END IF;

  RETURN nVALOR;

END;
$$ language 'plpgsql';




/*-- SEQ 0711 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ReferenciaGradeHeaderkit (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE) CASCADE;

/*-- SEQ 0712 --*/
CREATE OR REPLACE FUNCTION ReferenciaGradeHeaderkit (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILMAT ALIAS FOR $1 ;
pCODMAT ALIAS FOR $2 ;
pCODCOR ALIAS FOR $3 ;
pCODTAM ALIAS FOR $4 ;
-- Objetivo:
-- 1) Verificar o status de um Kit de produto
   cReferenciaKit                VARCHAR(20); -- 1 - Header de Kit; 2 - Item normal; 3 - Item de Kit;
BEGIN
   SELECT CASE WHEN HEA.CODMAT IS NOT NULL THEN HEA.REFPRO ELSE '' END
     INTO cReferenciaKit
     FROM TT_GRA GRA LEFT JOIN TT_KIT KIT ON KIT.FILITE = GRA.FILMAT
                                         AND KIT.CODITE = GRA.CODMAT
                                         AND KIT.CORITE = GRA.CODCOR
                                         AND KIT.TAMITE = GRA.CODTAM 
                     LEFT JOIN TT_GRA HEA ON KIT.FILMAT = HEA.FILMAT
                                         AND KIT.CODMAT = HEA.CODMAT
                                         AND KIT.CODCOR = HEA.CODCOR
                                         AND KIT.CODTAM = HEA.CODTAM
    WHERE GRA.FILMAT = pFILMAT
      AND GRA.CODMAT = pCODMAT
      AND GRA.CODCOR = pCODCOR
      AND GRA.CODTAM = pCODTAM
    LIMIT 1
   ;
  
  RETURN cReferenciaKit;
END;
$$ language 'plpgsql';



/*-- SEQ 0713 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RetornaReferenciaGradeHeaderkit (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE) CASCADE;

/*-- SEQ 0714 --*/
CREATE OR REPLACE FUNCTION RetornaReferenciaGradeHeaderkit (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILMAT ALIAS FOR $1 ;
pCODMAT ALIAS FOR $2 ;
pCODCOR ALIAS FOR $3 ;
pCODTAM ALIAS FOR $4 ;
-- Funo declarada em postgre para manter compatibilidade, foi entregue com tamanho maximo de caractere e pode
-- gerar problema em oracle.
   cReferenciaKit                VARCHAR(20); -- 1 - Header de Kit; 2 - Item normal; 3 - Item de Kit;
BEGIN
   SELECT ReferenciaGradeHeaderkit(pFILMAT, pCODMAT, pCODCOR, pCODTAM)
     INTO cReferenciaKit
    FROM DUAL; 
  
  RETURN cReferenciaKit;
END;
$$ language 'plpgsql';




/*-- SEQ 0715 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ReferenciaPrimeiraEmbalagem (TT_GRA.REFPRO%TYPE) CASCADE;

/*-- SEQ 0716 --*/
CREATE OR REPLACE FUNCTION ReferenciaPrimeiraEmbalagem (TT_GRA.REFPRO%TYPE)
RETURNS TT_GRA.REFPRO%TYPE AS $$
DECLARE
pRefpro ALIAS FOR $1 ;
  pRetornoRefpro TT_GRA.REFPRO%TYPE;
  
  pFilmat TT_GRA.FILMAT%TYPE;
  pCodmat TT_GRA.CODMAT%TYPE;
  pCodcor TT_GRA.CODCOR%TYPE;
  pCodtam TT_GRA.CODTAM%TYPE;
  pCodSal TT_GRA.CODTAM%TYPE;
  
  pReferenciaCursor TT_GRA.REFPRO%TYPE;
  pCodSalCursor TT_GRA.CODTAM%TYPE;
  
  -- MN - Traz as referncias de embalagem e os fatores de converso (apenas por informao se precisar no futuro)
  -- Exemplo: 7897892020994,20
  --          7898542885086,40
  --          7899400551938,50
  CR_Referencias CURSOR(pFilmat TT_GRA.FILMAT%TYPE,
           pCodmat TT_GRA.CODMAT%TYPE,
           pCodcor TT_GRA.CODCOR%TYPE) IS
      SELECT TAB.REFPRO, TAB.CODSAL FROM(
        SELECT GRA.REFPRO, DSUB.CODSAL
           FROM TT_GRA GRA INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT
                                                AND PRO.CODMAT = GRA.CODMAT
                           INNER JOIN TT_SUB SUB  ON SUB.CODITE = GRA.CODTAM
                           INNER JOIN TD_SUB DSUB ON DSUB.CODTAB = SUB.CODSUB          
          WHERE GRA.FILMAT = pFilmat
            AND GRA.CODMAT = pCodmat
            AND GRA.CODCOR = pCodcor
            -- MN - Ignora a unidade, a ideia  pegar a primeira embalagem apenas
            AND GRA.CODTAM <> DSUB.CODSAL
            AND PRO.SIGNAT > 0
            AND GRA.GRAATI = 'T'         
           ORDER BY SUB.FATCON
      )TAB 
            
         LIMIT 1;
            
      
BEGIN
   -- MN - GES-2019117978 - A ideia  enviar um produto pra essa funo e a funo retornar a "PRIMEIRA" embalagem daquele produto   
   pRetornoRefpro := '';
   pCodSal        := 0;
   
   IF IsNull(pRefPro) = 'F' THEN
            SELECT FILMAT, CODMAT, CODCOR, CODTAM
         INTO pFilmat, pCodmat, pCodcor, pCodtam
         FROM  TT_GRA
        WHERE REFPRO = pRefPro; 
         
       
        END IF;
   
   OPEN CR_Referencias(pFilmat, pCodmat, pCodcor);
   LOOP
     FETCH CR_Referencias into pReferenciaCursor, pCodSalCursor;
     EXIT WHEN NOT FOUND;
     
       -- MN - Somente na primeira embalagem vai estar vazio 
       IF IsNull(pRetornoRefpro) = 'T' THEN
          pRetornoRefpro := pReferenciaCursor;
          pCodSal := pCodSalCursor;
       END IF;
     
   END LOOP;
   CLOSE CR_Referencias;
   
   -- MN - Se chamar a funo usando referncia de alguma embalagem, resultado volta em branco, deve chamar a funo na unidade (TD_SUB.CODSAL)
   IF pCodtam <> pCodSal THEN
     pRetornoRefpro := '';
   END IF;
   
   RETURN pRetornoRefpro;
END;
$$ language 'plpgsql';




/*-- SEQ 0717 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RefNaData (TL_GRA.FILMAT%TYPE,TL_GRA.CODMAT%TYPE,TL_GRA.CODCOR%TYPE,TL_GRA.CODTAM%TYPE,TL_GRA.DATOPE%TYPE) CASCADE;

/*-- SEQ 0718 --*/
CREATE OR REPLACE FUNCTION RefNaData (TL_GRA.FILMAT%TYPE,TL_GRA.CODMAT%TYPE,TL_GRA.CODCOR%TYPE,TL_GRA.CODTAM%TYPE,TL_GRA.DATOPE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFilMat ALIAS FOR $1 ;
pCodMat ALIAS FOR $2 ;
pCodCor ALIAS FOR $3 ;
pCodTam ALIAS FOR $4 ;
pDatOpe ALIAS FOR $5 ;

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*   Autor: Hugo                                                       */
/*   Finalidade: Trazer a referncia do produto que era utilizada      */
/*   na data informada no parmetro.                                   */
/*   Motivo: O programa TTUValidacoesReducoesZ utiliza a referencia    */
/*   do produdo na Fita detalhe para indeficar seu respectivo item     */
/*   no banco de dados, como o programa foi utilizado para datas       */
/*   muito antigas, ocorre que com o tempo  alterado a a referencia   */
/*   do produto, ento a necessidade desta funo.                     */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
                                        
   vRESULT Numeric(8);
   vMsgLog VARCHAR(4000);
   vAuxLog VARCHAR(254);
BEGIN

  SELECT SUBSTR(MSGLOG, INSTR(MSGLOG,'Referencia: de '),LENGTH(MSGLOG))
    INTO vMsgLog
    FROM TL_GRA
   WHERE FILMAT = pFilMat
     AND CODMAT = pCodMat
     AND CODCOR = pCodCor
     AND CODTAM = pCodTam
     AND DATOPE = (SELECT MIN(DATOPE)
                     FROM TL_GRA
                    WHERE FILMAT = pFilMat
                      AND CODMAT = pCodMat
                      AND CODCOR = pCodCor
                      AND CODTAM = pCodTam
                      AND DATOPE > pDatOpe
                      AND MSGLOG LIKE '%Referencia: de %');

 vMsgLog := REPLACE(vMsgLog,'Referencia: de ','');
 vAuxLog := SUBSTR(vMsgLog , 1,INSTR(vMsgLog,' para '));

RETURN vAuxLog;
  
END;
$$ language 'plpgsql';




/*-- SEQ 0719 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RegraVenPrincViewComiss (TT_VDD.TIPVDD%TYPE,TT_CLI.FILVEN%TYPE,TT_CLI.CODVEN%TYPE,TT_CLI.PERVDD%TYPE,TT_VEN.FILVEN%TYPE,TT_VEN.CODVEN%TYPE) CASCADE;

/*-- SEQ 0720 --*/
CREATE OR REPLACE FUNCTION RegraVenPrincViewComiss (TT_VDD.TIPVDD%TYPE,TT_CLI.FILVEN%TYPE,TT_CLI.CODVEN%TYPE,TT_CLI.PERVDD%TYPE,TT_VEN.FILVEN%TYPE,TT_VEN.CODVEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pTIPVDD ALIAS FOR $1 ;
pFILVDP ALIAS FOR $2 ;
pCODVDP ALIAS FOR $3 ;
pPERVDD ALIAS FOR $4 ;
pFILVEN ALIAS FOR $5 ;
pCODVEN ALIAS FOR $6 ;

-- RFMP 85901
-- Objetivo: 
-- Funo para auxiliar view de comisses (TV_CMS) a tratar o caso do VDP ter sido includo na lista de vendedores
-- evitando que ocorra duplicidade na comisso.

  cRetorno VARCHAR(1); 
         
BEGIN

  -- A princpio trazer todos os vendedores da TV_VDD
  cRetorno := 'T';

  -- No trs o registro de vendedor principal se ele tiver no tiver % de comisso
  IF pTIPVDD = 'P' THEN    
    IF COALESCE(pPERVDD,0) = 0 THEN
       cRetorno := 'F';
    END IF;
  ELSE
    -- Tratamento especial se for um vendedor que j  o principal
    IF (pFILVEN||pCODVEN) = (COALESCE(pFILVDP,'')||COALESCE(pCODVDP,'')) THEN
      -- No trs o registro de outros vendedores se ele j for receber comisso por ser principal
      IF COALESCE(pPERVDD,0) > 0 THEN
         cRetorno := 'F';
      END IF;    
    END IF;
  END IF;

  RETURN cRetorno;

END;
$$ language 'plpgsql' STABLE;




/*-- SEQ 0721 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RemoveItemTransfAutom (TT_IOR.CODFIL%TYPE,TT_IOR.FILRES%TYPE,TT_VEN.SEQUEN%TYPE,TT_COM.SEQUEN%TYPE,TT_IOR.FILMAT%TYPE,TT_IOR.CODMAT%TYPE,TT_IOR.CODCOR%TYPE,TT_IOR.CODTAM%TYPE,TT_IOR.QTDITE%TYPE,TT_IOR.VLRITE%TYPE,TT_IOR.CODMUL%TYPE,TT_IOR.FILIVE%TYPE,TT_IOR.SEQIVE%TYPE,TT_IOR.NUMIVE%TYPE,TT_IOR.FILLOT%TYPE,TT_IOR.SEQLOT%TYPE) CASCADE;

/*-- SEQ 0722 --*/
CREATE OR REPLACE FUNCTION RemoveItemTransfAutom (TT_IOR.CODFIL%TYPE,TT_IOR.FILRES%TYPE,TT_VEN.SEQUEN%TYPE,TT_COM.SEQUEN%TYPE,TT_IOR.FILMAT%TYPE,TT_IOR.CODMAT%TYPE,TT_IOR.CODCOR%TYPE,TT_IOR.CODTAM%TYPE,TT_IOR.QTDITE%TYPE,TT_IOR.VLRITE%TYPE,TT_IOR.CODMUL%TYPE,TT_IOR.FILIVE%TYPE,TT_IOR.SEQIVE%TYPE,TT_IOR.NUMIVE%TYPE,TT_IOR.FILLOT%TYPE,TT_IOR.SEQLOT%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pFILRES ALIAS FOR $2 ;
pSEQVEN ALIAS FOR $3 ;
pSEQCOM ALIAS FOR $4 ;
pFILMAT ALIAS FOR $5 ;
pCODMAT ALIAS FOR $6 ;
pCODCOR ALIAS FOR $7 ;
pCODTAM ALIAS FOR $8 ;
pQTDITE ALIAS FOR $9 ;
pVLRITE ALIAS FOR $10 ;
pCODMUL ALIAS FOR $11 ;
pFILORI ALIAS FOR $12 ;
pNUMORI ALIAS FOR $13 ;
pITEORI ALIAS FOR $14 ;
pFILLOT ALIAS FOR $15 ;
pSEQLOT ALIAS FOR $16 ;

  -- Objetivos:
  -- 1. Criar sada e entrada de transferncia automtica.

  -- Declarao de variveis e cursores
  cResultado            VARCHAR(2);
  vComplemento          CONSTANT VARCHAR(100) := Constante('complemento');
  iCODCFO TT_CFG.TRANSFER_CODCFO%TYPE;
  vNUMIVE TT_IVE.NUMITE%TYPE;
  vNUMICO TT_ICO.NUMITE%TYPE;
  vTIPPRO TT_PRO.TIPPRO%TYPE;
  VVALCON TT_PRO.VALCON%TYPE;
  vUNICOM TT_GRA.UNIFOR%TYPE;
  vUNIVEN TT_GRA.UNIDAD%TYPE;
  vVLRMOV TT_IVE.VLRMOV%TYPE;
  vFILIVE TT_IVE.CODFIL%TYPE;
  vSEQIVE TT_IVE.SEQUEN%TYPE;
  vITEIVE TT_IVE.NUMITE%TYPE;

BEGIN

       SELECT CODFIL, SEQUEN, NUMITE INTO vFILIVE, vSEQIVE, vITEIVE
     FROM (SELECT CODFIL, SEQUEN, NUMITE
       FROM TT_IVE
       WHERE FILORI=pFILORI
         AND NUMORI=pNUMORI
         AND ITEORI=pITEORI
         AND CODFIL=pFILRES
         AND SEQUEN=pSEQVEN
         AND FILMAT=pFILMAT
         AND CODMAT=pCODMAT
         AND CODCOR=pCODCOR
         AND CODTAM=pCODTAM
         AND QTDMOV=pQTDITE
         AND SITMOV<>'C'
       UNION ALL
       SELECT CODFIL,SEQUEN,NUMITE
       FROM TT_IVE
       WHERE CODFIL=pFILRES
         AND SEQUEN=pSEQVEN
         AND FILMAT=pFILMAT
         AND CODMAT=pCODMAT
         AND CODCOR=pCODCOR
         AND CODTAM=pCODTAM
         AND QTDMOV=pQTDITE
         AND SITMOV<>'C') tab
    
       LIMIT 1
       ;
  
  IF (vFILIVE IS NOT NULL) AND (vSEQIVE IS NOT NULL) AND (vITEIVE IS NOT NULL) THEN
      -- Pegando valor original (custo) para estorno
      SELECT VLRMOV INTO vVLRMOV
        FROM TT_IVE
       WHERE CODFIL = vFILIVE
         AND SEQUEN = vSEQIVE
         AND NUMITE = vITEIVE;

      UPDATE TT_IVE
         SET SITMOV='C'
       WHERE CODFIL = vFILIVE
         AND SEQUEN = vSEQIVE
         AND NUMITE = vITEIVE;

      UPDATE TT_VEN
         SET VLRLIQ=VLRLIQ-vVLRMOV,
             VLRNOT=VLRNOT-vVLRMOV
       WHERE CODFIL=pFILRES
         AND SEQUEN=pSEQVEN;

          -- Pegando valor original (custo) para estorno
      SELECT VLRMOV INTO vVLRMOV
        FROM TT_ICO
       WHERE (CODFIL,SEQUEN,NUMITE) IN (SELECT FILICO,SEQICO,NUMICO
                        FROM TT_TRA
                        WHERE FILIVE = vFILIVE
                          AND SEQIVE = vSEQIVE
                          AND NUMIVE = vITEIVE);

      UPDATE TT_ICO
         SET SITMOV='C',
             DUMMY=Constante('VEM_DE_REMOVEITEMTA')
       WHERE (CODFIL,SEQUEN,NUMITE) IN (SELECT FILICO,SEQICO,NUMICO
                        FROM TT_TRA
                        WHERE FILIVE = vFILIVE
                          AND SEQIVE = vSEQIVE
                          AND NUMIVE = vITEIVE);

      DELETE FROM TT_TRA
       WHERE FILIVE = vFILIVE
         AND SEQIVE = vSEQIVE
         AND NUMIVE = vITEIVE;

      UPDATE TT_COM
         SET VLRLIQ=VLRLIQ-vVLRMOV,
             VLRTOT=VLRTOT-vVLRMOV,
             QTDTOT=QTDTOT-pQTDITE
       WHERE CODFIL=pCODFIL
         AND SEQUEN=pSEQCOM;
  END IF;

  cResultado := 'OK';
  RETURN cResultado;

END;
$$ language 'plpgsql';




/*-- SEQ 0723 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RetornaCodserImportaVEN (TD_SER.CODSER%TYPE) CASCADE;

/*-- SEQ 0724 --*/
CREATE OR REPLACE FUNCTION RetornaCodserImportaVEN (TD_SER.CODSER%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODSER ALIAS FOR $1 ;

   -- MN - Retorna o CODSER a ser includo na TT_VEN quando importar uma venda
   -- Se tiver 3 dgitos procura por SEREXT, seno procura por CODSER, se houver mais de um registro na TD_SER
   -- Da preferncia pelo modnot '55'

   n_Count       Numeric(5);
   nRESULTADO    TD_SER.CODSER%TYPE;
BEGIN
   nRESULTADO := '';
   
    
   SELECT COUNT(*)
     INTO n_Count
     FROM TD_SER
    WHERE 1 = 1
      AND CODSER = CASE WHEN LENGTH(TRIM(pCODSER)) <> 3 THEN pCODSER ELSE CODSER END
      AND COALESCE(SEREXT, 'X') = CASE WHEN LENGTH(TRIM(pCODSER)) =  3 THEN pCODSER ELSE COALESCE(SEREXT, 'X') END;
 
   IF n_Count > 0 THEN
      SELECT CODSER
        INTO nResultado
        FROM TD_SER 
       WHERE 1 = 1
         AND CODSER = CASE WHEN LENGTH(TRIM(pCODSER)) <> 3 THEN pCODSER ELSE CODSER END
         AND COALESCE(SEREXT, 'X') = CASE WHEN LENGTH(TRIM(pCODSER)) =  3 THEN pCODSER ELSE COALESCE(SEREXT, 'X') END
         AND MODNOT = CASE WHEN n_Count = 1 THEN MODNOT ELSE 55 END;
        
   END IF;

    RETURN nRESULTADO;

END;
$$ language 'plpgsql';




/*-- SEQ 0725 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RETORNA_NUMNOT_CCC (TT_VEN.CODFIL%TYPE,TT_VEN.SEQUEN%TYPE) CASCADE;

/*-- SEQ 0726 --*/
CREATE OR REPLACE FUNCTION RETORNA_NUMNOT_CCC (TT_VEN.CODFIL%TYPE,TT_VEN.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
 
-- Objetivos:
-- 1. Retornar nmero da nota de venda

-- Declarao de variveis e cursores
   cNUMNOT                       VARCHAR(20);
 
-- Incio da funo
BEGIN 

   SELECT (VEN.CODSER||'/'||LTRIM(VEN.NUMECF)||'-'||LTRIM(VEN.NUMNOT)) 
     INTO cNUMNOT
     FROM TT_VEN VEN
   WHERE VEN.CODFIL = pCODFIL
     AND VEN.SEQUEN = pSEQUEN;
 
   RETURN cNUMNOT;
    
END;
$$ language 'plpgsql';




/*-- SEQ 0727 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RoundABNT (Numeric,INTEGER) CASCADE;

/*-- SEQ 0728 --*/
CREATE OR REPLACE FUNCTION RoundABNT (Numeric,INTEGER)
RETURNS Numeric AS $$
DECLARE
pValor ALIAS FOR $1 ;
pDecimais ALIAS FOR $2 ;
 
-- Objetivos:
-- 1. Realizar o Arredondamento seguindo a Norma ABNT NBR 5891 - https://pt.wikipedia.org/wiki/Arredondamento
 
-- Declarao de variveis e cursores
   cResultado                    Numeric;
   cDecimais                     VARCHAR(100);
   cVlrStr                       VARCHAR(100);
   cDecimalSeparator             VARCHAR(1) DEFAULT '.';
   nSubSequente                  Numeric;
   nPosPonto                     Numeric;
 
-- Incio da funo
BEGIN

   
   cVlrStr := TO_CHAR(pValor,'fm999G999G999G999G990D00999999');
   nPosPonto := INSTR(cVlrStr, cDecimalSeparator);
   cDecimais := SUBSTR(cVlrStr, nPosPonto+1, LENGTH(cVlrStr));
   nSubSequente := pDecimais+1;

   IF (pDecimais < 1) THEN
      cResultado := TRUNC(pValor);
   ELSIF (LENGTH(cDecimais) <= pDecimais) THEN
      cResultado := pValor;
   ELSE
      IF ((CAST(SUBSTR(cDecimais, nSubSequente, 1) AS Numeric) > 5) OR
          (CAST(SUBSTR(cDecimais, nSubSequente, 1) AS Numeric) < 5)) THEN
         cResultado := ROUND(pValor, pDecimais);
      ELSIF (CAST(SUBSTR(cDecimais, nSubSequente, 1) AS Numeric) = 5) THEN
         IF (COALESCE(MOD(CAST(SUBSTR(cDecimais, pDecimais, 1) AS Numeric) ,2), 0) <> 0) THEN
            cResultado := ROUND(pValor, pDecimais);
         ELSIF (COALESCE(CAST(SUBSTR(cDecimais||'0', nSubSequente+1, 1) AS Numeric), 0) > 0) THEN
            cResultado := ROUND(pValor, pDecimais);
         ELSE
            cResultado := TRUNC(pValor, pDecimais);
         END IF;
      END IF;
   END IF;

   RETURN cResultado;
 
END;
$$ language 'plpgsql';




/*-- SEQ 0729 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SaldoContaCorrente (Timestamp,TT_CCC.FILCLI%TYPE,TT_CCC.CODCLI%TYPE,TT_CCC.TIPCCC%TYPE) CASCADE;

/*-- SEQ 0730 --*/
CREATE OR REPLACE FUNCTION SaldoContaCorrente (Timestamp,TT_CCC.FILCLI%TYPE,TT_CCC.CODCLI%TYPE,TT_CCC.TIPCCC%TYPE)
RETURNS Numeric AS $$
DECLARE
pData ALIAS FOR $1 ;
pFilial ALIAS FOR $2 ;
pCodigo ALIAS FOR $3 ;
pTipo ALIAS FOR $4 ;

-- Objetivos:
-- 1. Apresentar saldo da conta corrente de um cliente em uma determinada data.

-- Declarao de variveis e cursores
   nSoma                         Numeric;

-- Incio da funo
BEGIN

   SELECT COALESCE((SELECT SUM(VLRLAN)
                      FROM TT_CCC
                     WHERE FILCLI = pFilial
                       AND CODCLI = pCodigo
                       AND TIPCCC = pTipo
                       AND DATOPE <= pData),0)
     INTO nSoma
     FROM DUAL;

   RETURN nSoma;

END;
$$ language 'plpgsql';




/*-- SEQ 0731 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SituacaoVenda (TT_IOR.CODFIL%TYPE,TT_IOR.TIPPED%TYPE,TT_IOR.NUMPED%TYPE,TT_IOR.NUMITE%TYPE) CASCADE;

/*-- SEQ 0732 --*/
CREATE OR REPLACE FUNCTION SituacaoVenda (TT_IOR.CODFIL%TYPE,TT_IOR.TIPPED%TYPE,TT_IOR.NUMPED%TYPE,TT_IOR.NUMITE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pTIPPED ALIAS FOR $2 ;
pNUMPED ALIAS FOR $3 ;
pNUMITE ALIAS FOR $4 ;
 
-- Objetivos:
-- 1. Trazer a SITUAO da Venda referente ao Oramento 
 
-- Declarao de variveis e cursores
   cFLGEST                       VARCHAR(1);
 
-- Incio da funo
BEGIN

      SELECT (CASE WHEN IOR.FILIVE IS NULL OR IOR.SEQIVE IS NULL OR IOR.NUMIVE IS NULL THEN 'A' 
                   ELSE CASE WHEN ROUND(IOR.QTDITE*SUB.FATCON,2) > ROUND(IVE.QTDMOV,2) THEN 'P' 
                             ELSE 'Q'
                        END 
              END) AS FLGEST
        INTO cFLGEST
        FROM TT_IOR IOR
   LEFT JOIN TT_IVE IVE ON IVE.SEQUEN = IOR.SEQIVE
                       AND IVE.CODFIL = IOR.FILIVE
                       AND IVE.NUMITE = IOR.NUMIVE
  INNER JOIN TT_SUB SUB ON IOR.CODTAM = SUB.CODITE
   WHERE IOR.CODFIL = pCODFIL
     AND IOR.TIPPED = pTIPPED
     AND IOR.NUMPED = pNUMPED
     AND IOR.NUMITE = pNUMITE;

  RETURN cFLGEST;
 
END;
$$ language 'plpgsql';




/*-- SEQ 0733 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION split_part_null (VARCHAR,VARCHAR,Numeric) CASCADE;

/*-- SEQ 0734 --*/
CREATE OR REPLACE FUNCTION split_part_null (VARCHAR,VARCHAR,Numeric)
RETURNS VARCHAR AS $$
DECLARE
pString ALIAS FOR $1 ;
pDelimiter ALIAS FOR $2 ;
pField ALIAS FOR $3 ;
--  --------------------------------------------------------
--  objetivo:
--  1. Função que divide a lista passada no parâmetro "pString" usando como 
--     delimitador o parâmetro "pDelimiter" e retorna somente o item da lista
--     informado no parâmetro "pField".
--
--     Esta função é uma extensão da função "split_part", a principal diferença é que
--     "split_part_null" retorna <null> caso o campo selecionado seja uma string vazia
--     ou caso a string possua somente espaços em branco.
--     Esta diferença é especialmente interessante quando se utiliza o resultado de
--     "split_part" em funções de conversão como "to_date" e "to_number", pois estas
--     funções geram uma exceção caso tentem converter uma string vazia, mas retornam
--     <null> caso tentem converter um <null>.
--
--     Esta função retorna <null> caso não encontre nenhum "pDelimiter" na "pString"
--     ou caso o "pField" esteja fora da lista.
--
--     O primeiro "pField" é o número 1 (um). Caso seja menor que 1 será gerada uma exceção.
--
--     É recomendado utilizar o "pDelimiter" ponto e vírgula ( ; ).
--
--     Para mais informações veja a página desta função do WIKI:
--     http://intra.totall.com.br:8080/wiki/index.php/Split_part
--
--  --------------------------------------------------------
--  variáveis e cursores
    cDummy VARCHAR(1000);
--  --------------------------------------------------------
begin
    --  buscando o campo usando a "split_part" original
        
    cDummy := trim(split_part(cast(pString as text), cast(pDelimiter as text), cast(pField as int)));
        --  retorno da função
    if  cDummy = ''
    or  cDummy is null then
        return null;
    else
        return cDummy;
    end if;
END;
$$ language 'plpgsql';




/*-- SEQ 0735 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Split_Part_Number (VARCHAR,VARCHAR,Numeric) CASCADE;

/*-- SEQ 0736 --*/
CREATE OR REPLACE FUNCTION Split_Part_Number (VARCHAR,VARCHAR,Numeric)
RETURNS Numeric AS $$
DECLARE
pString ALIAS FOR $1 ;
pDelimiter ALIAS FOR $2 ;
pField ALIAS FOR $3 ;
--  --------------------------------------------------------
--  objetivo:
--  1. Funcao que divide a lista passada no parametro "pString" usando como delimitador o
--     parametro "pDelimiter" e retorna somente o item da lista informado no parametro "pField"
--     ja convertido para o tipo Numeric em Oracle e para o tipo Numeric em PostgreSQL.
--
--     Esta funcao e uma extensao da funcao "Split_Part", a principal diferenca e que
--     "Split_Part_Number" retorna <null> caso o campo selecionado seja uma string vazia ou caso a
--     string possua somente espacos em branco, e caso a string esteja preenchida a funcao tenta
--     fazer a conversao para o tipo numerico, tratando os separadores de milhar e decimais,
--     evitando assim o uso de funcoes de conversao como "To_Number".
--
--     Esta funcao retorna <null> caso nao encontre nenhum "pDelimiter" na "pString"
--     ou caso o "pField" esteja fora da lista.
--
--     O primeiro "pField" e o numero 1 (um). Caso seja menor que 1 sera gerada uma excecao.
--
--     É recomendado utilizar o "pDelimiter" ponto e vírgula ( ; ).
--
--     Para mais informacoes veja a pagina desta funcao no WIKI:
--     http://intra.totall.com.br:8080/wiki/index.php/Split_part
--
--  --------------------------------------------------------
    wvDummy         VARCHAR(1000);
    wvDecimal       VARCHAR(1);
    wvGroupSep      VARCHAR(1);
--  --------------------------------------------------------
begin
    --  buscando o campo usando a "split_part" original
        
    wvDummy := trim(split_part(cast(pString as text), cast(pDelimiter as text), cast(pField as int)));
        --  retorno da funcao
    if  wvDummy = ''
    or  wvDummy is null then
        return null;
    else
        --  definindo o separador decimal
        select Trim(To_Char(0, 'FMD'))
          into wvDecimal
          from DUAL;
        --  definindo o separador de grupo (milhar)
        if  wvDecimal = ',' then
            wvGroupSep := '.';
        else
            wvGroupSep := ',';
        end if;
        wvDummy := Replace(wvDummy, wvGroupSep, '');
        return To_Number(wvDummy, '9999999999999999990D9999999999');
    end if;
END;
$$ language 'plpgsql';




/*-- SEQ 0737 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_ABA_Flgest (TM_ABA.CODABA%TYPE,TM_ABA.CODFIL%TYPE,TT_ABA.FLGEST%TYPE) CASCADE;

/*-- SEQ 0738 --*/
CREATE OR REPLACE FUNCTION TGR_ABA_Flgest (TM_ABA.CODABA%TYPE,TM_ABA.CODFIL%TYPE,TT_ABA.FLGEST%TYPE)
RETURNS CHAR AS $$
DECLARE
p_Codfil ALIAS FOR $1 ;
p_Codaba ALIAS FOR $2 ;
p_Flgest ALIAS FOR $3 ;

-- Objetivos:
-- 1. Carregar FLGNEW mais recente da TM_ABA

vMAX_SEQUEN   TM_ABA.SEQUEN%TYPE;
vFLGNEW       TT_ABA.FLGEST%TYPE;

-- Incio da funo
BEGIN

   SELECT (SELECT MAX(SEQUEN)
             FROM TM_ABA
            WHERE CODFIL = p_Codfil
              AND CODABA = p_Codaba)
        INTO vMAX_SEQUEN
        FROM DUAL;

   IF ISNOTNULL(vMAX_SEQUEN) = 'T' THEN
      SELECT FLGNEW
         INTO vFLGNEW
         FROM TM_ABA
        WHERE CODFIL = p_Codfil
          AND SEQUEN = vMAX_SEQUEN;

     DELETE FROM TM_ABA
      WHERE CODFIL = p_Codfil
        AND CODABA = p_Codaba;

   END IF;

   RETURN COALESCE(vFLGNEW, p_Flgest);

END;
$$ language 'plpgsql';




/*-- SEQ 0739 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_CTAXFIL_RecriaRCTA (TT_CTAXFIL.FILCTA%TYPE,TT_CTAXFIL.SEQCTA%TYPE,TT_CTAXFIL.TIPCTA%TYPE,TT_CTAXFIL.CODFIL%TYPE,TT_CTAXFIL.DATA_INICIAL%TYPE,TT_CTAXFIL.SALDO_INICIAL_A%TYPE,TT_CTAXFIL.SALDO_INICIAL_R%TYPE) CASCADE;

/*-- SEQ 0740 --*/
CREATE OR REPLACE FUNCTION TGR_CTAXFIL_RecriaRCTA (TT_CTAXFIL.FILCTA%TYPE,TT_CTAXFIL.SEQCTA%TYPE,TT_CTAXFIL.TIPCTA%TYPE,TT_CTAXFIL.CODFIL%TYPE,TT_CTAXFIL.DATA_INICIAL%TYPE,TT_CTAXFIL.SALDO_INICIAL_A%TYPE,TT_CTAXFIL.SALDO_INICIAL_R%TYPE)
RETURNS CHAR AS $$
DECLARE
p_FILCTA ALIAS FOR $1 ;
p_SEQCTA ALIAS FOR $2 ;
p_TIPCTA ALIAS FOR $3 ;
p_CODFIL ALIAS FOR $4 ;
p_DATA_INICIAL ALIAS FOR $5 ;
p_SALDO_INICIAL_A ALIAS FOR $6 ;
p_SALDO_INICIAL_R ALIAS FOR $7 ;

-- Objetivos:
-- 1. Apagar registros da TR_CTA de uma filial/conta.
-- 2. Recria os registros baseando-se na TR_FIN.

-- Incio da funo
BEGIN

   --limpa tt_cta
   DELETE FROM TR_CTA
    WHERE FILCTA = p_FILCTA
      AND SEQCTA = p_SEQCTA
      AND TIPCTA = p_TIPCTA
      AND FILLAN = p_CODFIL;

   --atualiza tr_cta com lanamentos posteriores a data inicial
   INSERT INTO TR_CTA
      (FLGFLX,FILCTA,SEQCTA,TIPCTA,DATLAN,TOTCRE,TOTDEB,VSALDO,FILLAN)
      (SELECT FLGFLX,FILCTA,SEQCTA,TIPCTA,DATLAN,
              SUM(TOTCRE) AS TOTCRE,
              SUM(TOTDEB) AS TOTDEB,
              SUM(VSALDO) AS VSALDO,
              FILLAN
         FROM (SELECT FLGFLX,
                      FILCTA,
                      SEQCTA,
                      TIPCTA,
                      TRUNC(DATLAN) AS DATLAN,
                      CASE WHEN VLRLAN > 0 THEN abs(VLRLAN)  ELSE 0 END AS TOTCRE,
                      CASE WHEN VLRLAN < 0 THEN abs(VLRLAN)  ELSE 0 END AS TOTDEB,
                      0 AS VSALDO,
                      FILORI AS FILLAN
                 FROM TR_FIN
                UNION ALL
               SELECT FLGFLX,
                      FILCRT AS FILCTA,
                      SEQCRT AS SEQCTA,
                      TIPCRT AS TIPCTA,
                      TRUNC(DATLAN) AS DATLAN,
                      CASE WHEN VLRLAN * CASE WHEN TIPCTA||TIPCRT='NN' THEN -1 ELSE 1 END > 0 THEN abs(VLRLAN) END AS TOTCRE,
                      CASE WHEN VLRLAN * CASE WHEN TIPCTA||TIPCRT='NN' THEN -1 ELSE 1 END < 0 THEN abs(VLRLAN) END AS TOTDEB,
                      0 AS VSALDO,
                      FILDES AS FILLAN
                 FROM TR_FIN) TAB
        WHERE FILCTA = p_FILCTA
          AND SEQCTA = p_SEQCTA
          AND TIPCTA = p_TIPCTA
          AND FILLAN = p_CODFIL
          AND DATLAN > COALESCE(TRUNC(p_DATA_INICIAL),TO_DATE('01/01/1901','DD/MM/YYYY'))
        GROUP BY FLGFLX,FILCTA,SEQCTA,TIPCTA,DATLAN,FILLAN);

   IF p_SALDO_INICIAL_A IS NOT NULL
   OR p_SALDO_INICIAL_R IS NOT NULL THEN
      --saldo inicial..
      INSERT INTO TR_CTA (FLGFLX,FILCTA,SEQCTA,TIPCTA,DATLAN,TOTCRE,TOTDEB,VSALDO,FILLAN)
                    VALUES ('A', p_FILCTA, p_SEQCTA, p_TIPCTA, p_DATA_INICIAL,
                    case when p_SALDO_INICIAL_A>0 then p_SALDO_INICIAL_A else 0 end,
                    case when p_SALDO_INICIAL_A<0 then abs(p_SALDO_INICIAL_A) else 0 end,
                    0, p_CODFIL);

      INSERT INTO TR_CTA (FLGFLX,FILCTA,SEQCTA,TIPCTA,DATLAN,TOTCRE,TOTDEB,VSALDO,FILLAN)
                  VALUES ('R', p_FILCTA, p_SEQCTA, p_TIPCTA, p_DATA_INICIAL,
                  case when p_SALDO_INICIAL_R>0 then p_SALDO_INICIAL_R else 0 end,
                  case when p_SALDO_INICIAL_R<0 then abs(p_SALDO_INICIAL_R) else 0 end
                  ,0, p_CODFIL);
   END IF;

   RETURN 'OK';

END;
$$ language 'plpgsql';




/*-- SEQ 0741 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_RECF_DadosFechamento (TR_ECF.CODFIL%TYPE,TR_ECF.NUMECF%TYPE,TR_ECF.DATOPE%TYPE) CASCADE;

/*-- SEQ 0742 --*/
CREATE OR REPLACE FUNCTION TGR_RECF_DadosFechamento (TR_ECF.CODFIL%TYPE,TR_ECF.NUMECF%TYPE,TR_ECF.DATOPE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_Codfil ALIAS FOR $1 ;
p_NumEcf ALIAS FOR $2 ;
p_DatOpe ALIAS FOR $3 ;

-- Objetivos:
-- 1. Incluir registro na TM_FEC quando no existir.

-- Incio da funo
BEGIN

   INSERT INTO TM_FEC
   (CODFIL, NUMECF, DATOPE, FLGEST)
   (SELECT p_CodFil, p_NumEcf, p_DatOpe, 'A'
      FROM DUAL
     WHERE NOT EXISTS (SELECT 1 AS OK
                         FROM TM_FEC
                        WHERE CODFIL = p_CodFil
                          AND NUMECF = p_NumEcf
                          AND DATOPE = p_DatOpe));

   RETURN 'OK';

END;
$$ language 'plpgsql';




/*-- SEQ 0743 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TotalDevolvida (Timestamp,Timestamp,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE,TT_IVE.CODFIL%TYPE,TT_IVE.CODMUL%TYPE) CASCADE;

/*-- SEQ 0744 --*/
CREATE OR REPLACE FUNCTION TotalDevolvida (Timestamp,Timestamp,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE,TT_IVE.CODFIL%TYPE,TT_IVE.CODMUL%TYPE)
RETURNS Numeric AS $$
DECLARE
pDatIni ALIAS FOR $1 ;
pDatFim ALIAS FOR $2 ;
pFilMat ALIAS FOR $3 ;
pCodMat ALIAS FOR $4 ;
pCodCor ALIAS FOR $5 ;
pCodTam ALIAS FOR $6 ;
pCodFil ALIAS FOR $7 ;
pCodmul ALIAS FOR $8 ;
 
-- Objetivos:
-- 1. Funcao que soma a quantidade total Devolvida.
 
-- Declarao de variveis e cursores
   cResultado                    Numeric;  --  var para calcular o total
   wdIni                         Timestamp;  --  data inicial do periodo com as horas
   wdFim                         Timestamp;  --  data final do periodo com as horas
 
-- Incio da funo
BEGIN   
 
   wdIni := TRUNC(pDatIni);
    wdFim := TO_DATE(TO_CHAR(TRUNC(pDatFim), 'DD/MM/YYYY') || ' 23:59:59', 'DD/MM/YYYY HH24:MI:SS');

      SELECT SUM(IVE.QTDMOV) INTO cResultado
        FROM TT_IVE IVE
       INNER JOIN TT_VEN  VEN ON  VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
       INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
       WHERE VEN.LANVEN = 'F'
         AND IVE.LANEST IN ('S','R')
         AND IVE.SITMOV <> 'C'
         AND IVE.SITKIT <> '1'
         AND IVE.FILMAT = pFilMat
         AND IVE.CODMAT = pCodMat
         AND IVE.CODCOR = pCodCor
         AND IVE.CODTAM = pCodTam
         AND IVE.VEN_DATHOR BETWEEN wdIni AND wdFim
         AND INSTR(COALESCE(pCodFil, IVE.CODFIL)||';', IVE.CODFIL||';') > 0
         AND IVE.CODMUL = COALESCE(pCodMul, IVE.CODMUL)
         AND DNAT.TIPNAT = 'D'; -- Devoluo de Venda

   RETURN COALESCE(cResultado, 0);
 
END;
$$ language 'plpgsql';




/*-- SEQ 0745 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TrazItemReferenciaKit (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE) CASCADE;

/*-- SEQ 0746 --*/
CREATE OR REPLACE FUNCTION TrazItemReferenciaKit (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILMAT ALIAS FOR $1 ;
pCODMAT ALIAS FOR $2 ;
pCODCOR ALIAS FOR $3 ;
pCODTAM ALIAS FOR $4 ;

-- Objetivos:
-- 1. Informar por parmetro FILMAT/CODMAT/CODCOR/CODTAM de um header de kit, devolvendo o REFPRO do item que  referncia desse kit.
--    Item referncia,  o item que faz parte do kit, e que possui a maior quantidade dentro do kit.
   pQtdite            TT_KIT.QTDITE%TYPE;
   pQtditeMax         TT_KIT.QTDITE%TYPE;
   pRefpro            TT_GRA.REFPRO%TYPE;
   pFilmatRetorno     TT_GRA.FILMAT%TYPE;
   pCodmatRetorno     TT_GRA.CODMAT%TYPE;
   pCodcorRetorno     TT_GRA.CODCOR%TYPE;
   pCodtamRetorno     TT_GRA.CODTAM%TYPE;
   pRefproRetorno     TT_GRA.REFPRO%TYPE;
   
   pRetorno           VARCHAR(254);
   -- Declarao de variveis e cursores

   ReferenciaKit CURSOR(pFilmatKit TT_GRA.FILMAT%TYPE,
           pCodmatKit TT_GRA.CODMAT%TYPE,
           pCodcorKit TT_GRA.CODCOR%TYPE,
           pCodtamKit TT_GRA.CODTAM%TYPE) IS
       SELECT KIT.FILITE, KIT.CODITE, KIT.CORITE, KIT.TAMITE, KIT.QTDITE
         FROM TT_KIT KIT INNER JOIN TV_IPR_FAST IPR ON IPR.FILMAT = KIT.FILITE 
                                                   AND IPR.CODMAT = KIT.CODITE
                                                   AND IPR.CODCOR = KIT.CORITE
                                                   AND IPR.CODTAM = KIT.TAMITE
        WHERE KIT.FILMAT = pFilmatKit
          AND KIT.CODMAT = pCodmatKit
          AND KIT.CODCOR = pCodcorKit
          AND KIT.CODTAM = pCodtamKit
        ORDER BY KIT.FILITE, KIT.CODITE, KIT.CORITE, KIT.TAMITE;

-- Incio da funo
BEGIN
   pRetorno       := '';
   pQtditeMax     := 0;  
   pRefproRetorno := '';
  
   OPEN ReferenciaKit(pFilmat, pCodmat, pCodcor, pCodtam);
   LOOP
      FETCH ReferenciaKit into pFilmatRetorno, pCodmatRetorno, pCodcorRetorno, pCodtamRetorno, pQtdite;
      EXIT WHEN NOT FOUND;
     
      -- MN - Somente na primeira embalagem vai estar vazio 
      IF pQtdite > pQtditeMax THEN
         pQtditeMax := pQtdite;
         pRetorno   := pFilmatRetorno || ';' || pCodmatRetorno  || ';' || TO_CHAR(pCodcorRetorno)  || ';' || TO_CHAR(pCodtamRetorno) || ';' || TO_CHAR(COALESCE(pQtdite, 0));
      END IF;
     
   END LOOP;
   CLOSE ReferenciaKit;

   Return pRetorno;

END;
$$ language 'plpgsql';




/*-- SEQ 0747 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION UltimaDataProduzida (TT_PPR.CODFIL%TYPE,TT_PPR.FILMAT%TYPE,TT_PPR.CODMAT%TYPE,TT_PPR.CODCOR%TYPE,TT_PPR.CODTAM%TYPE) CASCADE;

/*-- SEQ 0748 --*/
CREATE OR REPLACE FUNCTION UltimaDataProduzida (TT_PPR.CODFIL%TYPE,TT_PPR.FILMAT%TYPE,TT_PPR.CODMAT%TYPE,TT_PPR.CODCOR%TYPE,TT_PPR.CODTAM%TYPE)
RETURNS Timestamp AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pFILMAT ALIAS FOR $2 ;
pCODMAT ALIAS FOR $3 ;
pCODCOR ALIAS FOR $4 ;
pCODTAM ALIAS FOR $5 ;

-- Objetivo:
-- Funo para Grafipel; Pegar ltima data produzida Produo Prpria.

  vWK_MAXDAT Timestamp; --ltima data produzida

BEGIN

 SELECT MAX(DATINC)
   INTO vWK_MAXDAT
  FROM TT_PPR
  WHERE CODFIL = PCODFIL
    AND FILMAT = PFILMAT
    AND CODMAT = PCODMAT
    AND CODCOR = PCODCOR
    AND CODTAM = PCODTAM;
  
  RETURN vWK_MAXDAT;

END;
$$ language 'plpgsql';




/*-- SEQ 0749 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION UltimaDataVenda (TT_PPR.CODFIL%TYPE,TT_PPR.FILMAT%TYPE,TT_PPR.CODMAT%TYPE,TT_PPR.CODCOR%TYPE,TT_PPR.CODTAM%TYPE) CASCADE;

/*-- SEQ 0750 --*/
CREATE OR REPLACE FUNCTION UltimaDataVenda (TT_PPR.CODFIL%TYPE,TT_PPR.FILMAT%TYPE,TT_PPR.CODMAT%TYPE,TT_PPR.CODCOR%TYPE,TT_PPR.CODTAM%TYPE)
RETURNS TIMESTAMP AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pFILMAT ALIAS FOR $2 ;
pCODMAT ALIAS FOR $3 ;
pCODCOR ALIAS FOR $4 ;
pCODTAM ALIAS FOR $5 ;

-- Objetivo:
-- Pegar ltima data da Venda.
-- GES-2023035393 - MMC -> LUCIANO C

  vVEN_DATHOR TIMESTAMP; 

BEGIN

 SELECT MAX(VEN_DATHOR)
   INTO vVEN_DATHOR
   FROM TT_IVE
  WHERE CODFIL = PCODFIL
    AND FILMAT = PFILMAT
    AND CODMAT = PCODMAT
    AND CODCOR = PCODCOR
    AND CODTAM = PCODTAM;
 RETURN vVEN_DATHOR;

END;
$$ language 'plpgsql';




/*-- SEQ 0751 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ULTIMAENTRADADETRANSFERENCIA (TT_IVE.CODFIL%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE,TT_IVE.VEN_DATHOR%TYPE) CASCADE;

/*-- SEQ 0752 --*/
CREATE OR REPLACE FUNCTION ULTIMAENTRADADETRANSFERENCIA (TT_IVE.CODFIL%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE,TT_IVE.VEN_DATHOR%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCodFil ALIAS FOR $1 ;
pFilMat ALIAS FOR $2 ;
pCodMat ALIAS FOR $3 ;
pCodCor ALIAS FOR $4 ;
pCodTam ALIAS FOR $5 ;
pDatVen ALIAS FOR $6 ;
 
-- Objetivos:
-- 1. Retornar a ltima transferncia recebida em antes de uma determinada Data
-- 2. Retornar a % ICMS da ltima compra anterior a transferncia localizada.
 
--  Return [VARCHAR(500)]
--      Esta funcao retorna uma string com uma lista de varias informacoes, separadas pelo sina de
--      ponto e virgula (;) para serem utilizadas em outros calculos. Caso um valor seja nulo sera
--      retornado como uma string vazia. Seguem abaixo os valores retornados:
--      - Filial de Emisso da Transferncia (cCodFilTra) no formato [ Coluna CODFIL ];
--      - Sequnciador de Emisso da Transferncia (cSequenTra) no formato [ Coluna SEQUEN ];
--      - Nmero do Item de Emisso da Transferncia (nNumIteTra) no formato [ Coluna NUMITE ];
--      - % ICMS da ltima Compra Anterior a Transferncia (nTaxIcmUltCom) no formato [000.0000];
--
--      NOTA: recomenda-se o uso da funcao Split_Part, e suas derivadas, para facilitar a leitura e
--      utilizacao dos valores da lista retornada. Mais informacoes sobre Split_Part em:
--      http://intra.totall.com.br:8080/wiki/index.php/Split_part

--  @pCodFil [char(3)]
--      filial da venda.
--  @pFilMat [char(3)]
--      Codigo da filial do material do produto (TT_GRA);
--  @pCodMat [VARCHAR(5)]
--      Codigo do material do produto (TT_GRA);
--  @pCodCor [Numeric(5)]
--      Codigo da cor do produto (TT_GRA);
--  @pCodTam [Numeric(5)]
--      Codigo do tamanho do produto (TT_GRA);
--  @pDatVen [Timestamp]
--      Data da Venda no formato DD/MM/YYYY HH24:MI:SS.

-- Declarao de variveis e cursores
   cResultado                    VARCHAR(500); -- retorno da funo
   cCodFilTra                    TT_IVE.CODFIL%TYPE;
   cSequenTra                    TT_IVE.SEQUEN%TYPE;
   nNumIteTra                    TT_IVE.NUMITE%TYPE;
   dDatHorTra                    TT_IVE.VEN_DATHOR%TYPE;
   nTaxIcmUltCom                 TT_ICO.ICMITEDIF%TYPE;
 
-- Incio da funo
BEGIN

   -- Traz a chave da ltima transferncia antes da venda
   SELECT TAB.FILIVE, TAB.SEQIVE , TAB.NUMIVE, TAB.VEN_DATHOR
     INTO cCodFilTra, cSequenTra, nNumIteTra, dDatHorTra
     FROM ( SELECT TRA.FILIVE, TRA.SEQIVE, TRA.NUMIVE, IVE.VEN_DATHOR
              FROM ( SELECT MAX(LIVE.VEN_DATHOR) AS DATHOR
                       FROM TT_TRA LTRA
                       JOIN TT_IVE LIVE ON LIVE.CODFIL = LTRA.FILIVE AND LIVE.SEQUEN = LTRA.SEQIVE AND LIVE.NUMITE = LTRA.NUMIVE
                       JOIN TT_VEN LVEN ON LVEN.CODFIL = LIVE.CODFIL AND LVEN.SEQUEN = LIVE.SEQUEN
                      WHERE LVEN.FLGEST <> 'C'    AND LVEN.NUMNOT NOT LIKE '%#%'
                        AND LTRA.FILMAT = pFilMat AND LTRA.CODMAT = pCodMat
                        AND LTRA.CODCOR = pCodCor AND LTRA.CODTAM = pCodTam
                        AND LVEN.FILCLI = pCodFil AND LVEN.CODCLI = LPAD('0', 6, ' ')
                        AND LVEN.DATHOR <= pDatVen ) DAT, TT_TRA TRA
              JOIN TT_IVE IVE ON IVE.CODFIL = TRA.FILIVE AND IVE.SEQUEN = TRA.SEQIVE AND IVE.NUMITE = TRA.NUMIVE
              JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
             WHERE VEN.FLGEST <> 'C'    AND VEN.NUMNOT NOT LIKE '%#%'
               AND TRA.FILMAT = pFilMat AND TRA.CODMAT = pCodMat
               AND TRA.CODCOR = pCodCor AND TRA.CODTAM = pCodTam
               AND VEN.FILCLI = pCodFil AND VEN.CODCLI = LPAD('0', 6, ' ')
               AND IVE.VEN_DATHOR = DAT.DATHOR
             ORDER BY IVE.VEN_DATHOR DESC
          ) TAB
         LIMIT 1     ;
 
   -- Traz o % ICMS da ltima compra na filial de origem da transferncia
   IF (ISNOTNULL(cCodFilTra)='T') THEN
      SELECT TAB.PERICM 
        INTO nTaxIcmUltCom
        FROM (SELECT ICO.CODFIL, ICO.SEQUEN, ICO.SEQUEN,
                     ICO.ICMTIP AS ICO_ICMTIP, ICO.ICMITE AS ICO_ICMITE, ICO.ICMITEDIF AS ICO_ICMITEDIF, ICO.ICMITEDIF AS PERICM
                FROM (SELECT MAX(LICO.COM_DATOPE) AS DATOPE
                        FROM TT_ICO LICO
                        JOIN TT_COM LCOM ON LCOM.CODFIL = LICO.CODFIL AND LCOM.SEQUEN = LICO.SEQUEN
                       WHERE LICO.CODFIL = cCodFilTra 
                         AND LCOM.FLGEST <> 'D'    AND LCOM.NUMNOT NOT LIKE '%#%'
                         AND LICO.FILMAT = pFilMat AND LICO.CODMAT = pCodMat
                         AND LICO.CODCOR = pCodCor AND LICO.CODTAM = pCodTam
                         AND NOT EXISTS(SELECT 1 AS OK FROM TT_TRA TRAICO WHERE TRAICO.FILICO = LICO.CODFIL AND TRAICO.SEQICO = LICO.SEQUEN AND TRAICO.NUMICO = LICO.NUMITE)
                         AND LICO.COM_DATOPE <= dDatHorTra
                     ) DAT, TT_ICO ICO
                JOIN TT_COM COM ON COM.CODFIL = ICO.CODFIL AND COM.SEQUEN = ICO.SEQUEN
               WHERE ICO.CODFIL = cCodFilTra 
                 AND COM.FLGEST <> 'D'    AND COM.NUMNOT NOT LIKE '%#%'
                 AND ICO.FILMAT = pFilMat AND ICO.CODMAT = pCodMat
                 AND ICO.CODCOR = pCodCor AND ICO.CODTAM = pCodTam
                 AND NOT EXISTS(SELECT 1 AS OK FROM TT_TRA TRAICO WHERE TRAICO.FILICO = ICO.CODFIL AND TRAICO.SEQICO = ICO.SEQUEN AND TRAICO.NUMICO = ICO.NUMITE)
                 AND ICO.COM_DATOPE = DAT.DATOPE
               ORDER BY ICO.COM_DATOPE DESC
               ) TAB
             LIMIT 1       ;
   END IF;

   cResultado := -- Filial de Emisso da Transferncia
                TO_CHAR(COALESCE(cCodFilTra, '')) || ';' ||
                -- Sequnciador de Emisso da Transferncia
                TO_CHAR(COALESCE(cSequenTra, '')) || ';' ||
                -- Nmero do Item de Emisso da Transferncia
                TO_CHAR(COALESCE(nNumIteTra, 0)) || ';' ||
                -- % ICMS da ltima Compra Anterior a Transferncia
                TO_CHAR(COALESCE(nTaxIcmUltCom, 0), '000.0000') || ';'
                ;

   RETURN cResultado;
 
END;
$$ language 'plpgsql';




/*-- SEQ 0753 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION UltimaQuantidadeProduzida (TT_PPR.CODFIL%TYPE,TT_PPR.FILMAT%TYPE,TT_PPR.CODMAT%TYPE,TT_PPR.CODCOR%TYPE,TT_PPR.CODTAM%TYPE) CASCADE;

/*-- SEQ 0754 --*/
CREATE OR REPLACE FUNCTION UltimaQuantidadeProduzida (TT_PPR.CODFIL%TYPE,TT_PPR.FILMAT%TYPE,TT_PPR.CODMAT%TYPE,TT_PPR.CODCOR%TYPE,TT_PPR.CODTAM%TYPE)
RETURNS Numeric AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pFILMAT ALIAS FOR $2 ;
pCODMAT ALIAS FOR $3 ;
pCODCOR ALIAS FOR $4 ;
pCODTAM ALIAS FOR $5 ;

--Objetivo:
-- Funo para Grafipel; Pegar ltima quantidade produzida.

  vWK_SEQUEN VARCHAR(10);  --Retornar o sequen para o novo select
  vWK_QTDPRD Numeric(8);    --Retornar a ltima quantidade produzida Produo Prpria

BEGIN

 SELECT MAX(SEQUEN)
   INTO vWK_SEQUEN
  FROM TT_PPR
  WHERE CODFIL = PCODFIL
    AND FILMAT = PFILMAT
    AND CODMAT = PCODMAT
    AND CODCOR = PCODCOR
    AND CODTAM = PCODTAM;
  
  SELECT QTDPRD
   INTO vWK_QTDPRD
  FROM TT_PPR
  WHERE SEQUEN = vWK_SEQUEN
    AND CODFIL = PCODFIL;
  
  RETURN vWK_QTDPRD;

END;
$$ language 'plpgsql';




/*-- SEQ 0755 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ValidaParametro (TT_PCS.NOMPCS%TYPE,TT_PCS.TIPPCS%TYPE) CASCADE;

/*-- SEQ 0756 --*/
CREATE OR REPLACE FUNCTION ValidaParametro (TT_PCS.NOMPCS%TYPE,TT_PCS.TIPPCS%TYPE)
RETURNS BOOLEAN AS $$
DECLARE
pNomeParametro ALIAS FOR $1 ;
pTipo ALIAS FOR $2 ;

-- Objetivos:
-- 1. Validar se o tipo de parmetro solicitado est correto.

-- Declarao de variveis e cursores
   cTIPPCS                       TT_PCS.TIPPCS%TYPE;
   cDescricaoEsperado            VARCHAR(30);
   cDescricaoSolicitado          VARCHAR(30);

 -- Incio da funo
BEGIN
         SELECT PCS.TIPPCS INTO cTIPPCS
        FROM TT_PCS PCS
       WHERE PCS.NOMPCS = pNomeParametro
         AND PCS.PCSATI = 'T'
       GROUP BY PCS.TIPPCS;
   
   IF ISNOTNULL(cTIPPCS) = 'T' THEN
     IF Equal(cTIPPCS,pTipo) = 0 THEN
       cDescricaoEsperado   := DescricaoDominio('PCS','TIPPCS',cTIPPCS);
       cDescricaoSolicitado := DescricaoDominio('PCS','TIPPCS',pTipo);
       RAISE EXCEPTION 'PG-20000 Parmetro [%] solicitado com tipo invlido. Esperado: % / Solicitado: %' , pNomeParametro,cDescricaoEsperado,cDescricaoSolicitado;
     END IF;
   END IF;

   RETURN TRUE;
END;
$$ language 'plpgsql';




/*-- SEQ 0757 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VALORCOMPRAPRODUTO (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 0758 --*/
CREATE OR REPLACE FUNCTION VALORCOMPRAPRODUTO (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE)
RETURNS Numeric AS $$
DECLARE
pDATAINI ALIAS FOR $1 ;
pDATAFIM ALIAS FOR $2 ;
pFILMAT ALIAS FOR $3 ;
pCODMAT ALIAS FOR $4 ;
pCODCOR ALIAS FOR $5 ;
pCODTAM ALIAS FOR $6 ;
pCODFIL ALIAS FOR $7 ;
  VCOMVLRMOV Numeric;
BEGIN
  SELECT ROUND(SUM( CASE WHEN COALESCE(COM.VLRNOT,0) = 0 THEN ICO.VLRMOV ELSE COM.VLRLIQ/COM.VLRNOT*ICO.VLRMOV END ),2)
    INTO VCOMVLRMOV
    FROM TT_COM COM INNER JOIN TT_ICO ICO ON COM.CODFIL = ICO.CODFIL
                                         AND COM.SEQUEN = ICO.SEQUEN
   WHERE ICO.FILMAT = pFILMAT
     AND ICO.CODMAT = pCODMAT
     AND ICO.CODCOR = pCODCOR
     AND ICO.CODTAM = pCODTAM
     AND COM.FLGEST <> 'D'
     AND ICO.SITMOV <> 'C'
     AND ICO.DATINC BETWEEN pDATAINI 
	                    AND pDATAFIM
     AND COALESCE(PCODFIL,ICO.CODFIL) = ICO.CODFIL;

  RETURN COALESCE(VCOMVLRMOV,0);

END;
$$ language 'plpgsql';




/*-- SEQ 0759 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ValoresProdutoTransfAutom (TT_IOR.FILMAT%TYPE,TT_IOR.CODMAT%TYPE,TT_IOR.CODCOR%TYPE,TT_IOR.CODTAM%TYPE,TT_IOR.FILRES%TYPE) CASCADE;

/*-- SEQ 0760 --*/
CREATE OR REPLACE FUNCTION ValoresProdutoTransfAutom (TT_IOR.FILMAT%TYPE,TT_IOR.CODMAT%TYPE,TT_IOR.CODCOR%TYPE,TT_IOR.CODTAM%TYPE,TT_IOR.FILRES%TYPE)
RETURNS Numeric AS $$
DECLARE
pFilmat ALIAS FOR $1 ;
pCodmat ALIAS FOR $2 ;
pCodcor ALIAS FOR $3 ;
pCodtam ALIAS FOR $4 ;
pFilres ALIAS FOR $5 ;

  -- Objetivos:
  -- 1. Retornar valor do produto para transferncia automtica.

  -- Declarao de variveis e cursores
  vComplemento          constant VARCHAR(100) := constante('complemento');
  nCUSREP               TT_GRA.CUSREP%TYPE;
  cValorTransferencia   TT_CFG.ValorTransferencia%type;

-- Incio da funo
BEGIN

  nCusRep := 0;
  
  -- Pegando srie, natureza e cfo
  SELECT VALORTRANSFERENCIA INTO cValorTransferencia
    FROM TT_CFG;  

  -- Pegando Custo Mdio Fiscal
  SELECT coalesce(ValoresProduto(cValorTransferencia, pFilmat, pCodmat, pCodcor, pCodtam, pFilres),0) INTO nCUSREP
   FROM DUAL;
  IF nCusRep = 0 then
     SELECT coalesce(ValoresProduto(cValorTransferencia, pFilmat, pCodmat, pCodcor, pCodtam, CODLOJ),0) INTO nCUSREP
       FROM TT_IDF;
     IF nCusRep = 0 then
        RAISE EXCEPTION 'PG-20000 No foi encontrado o custo do produto para realizar a transferncia.%' , vComplemento;
     END IF;
  END IF;

  RETURN nCusRep;

END;
$$ language 'plpgsql';




/*-- SEQ 0761 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VendasEstoqueMedio (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 0762 --*/
CREATE OR REPLACE FUNCTION VendasEstoqueMedio (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pDataIni ALIAS FOR $1 ;
pDataFim ALIAS FOR $2 ;
pFilMat ALIAS FOR $3 ;
pCodMat ALIAS FOR $4 ;
pCodCor ALIAS FOR $5 ;
pCodTam ALIAS FOR $6 ;
pCodFil ALIAS FOR $7 ;
--  --------------------------------------------------------
--  Objetivos:
--  1. Calcula a quantidade vendida, valor vendido e cmv do período;
--
--  Nota: utilize as funções split_part e split_part_null para utilizar o resultado
--        desta função de maneira mais fácil.
--        http://intra.totall.com.br:8080/wiki/index.php/Split_part
--  --------------------------------------------------------
--  vars e cursores
    nLiqIve Numeric;
    nQtdIve Numeric;
    nVlrCmv Numeric;
    vResult VARCHAR(4000);
--  --------------------------------------------------------
begin   
    --  buscando os dados
    select (Sum(IVE.VLRMOV) + 
             (Sum(IVE.VLRFRE) + 
             (Sum(case when (Coalesce(IVE.DESRAT,0) > 0) then IVE.DESRAT else 0 end)) + 
             (Sum(case when (Coalesce(IVE.DESRAT,0) < 0) then IVE.DESRAT else 0 end)))) - 
             (Sum(IVE.VLRFRE)) - Sum(case when (Coalesce(IVE.DESRAT,0) > 0) then IVE.DESRAT else 0 end),
           Coalesce(Sum(IVE.QTDMOV), 0),
    	   Sum(IVE.QTDMOV * (Coalesce(IVE.TOT_CM,0) / Nvlz(IVE.SAL_CM,1)))	   
      into nLiqIve,
           nQtdIve,
           nVlrCmv
      from TT_VEN VEN
     inner join TT_IVE IVE
             on VEN.CODFIL = IVE.CODFIL
            and VEN.SEQUEN = IVE.SEQUEN
     where IVE.FILMAT  = pFilMat
       and IVE.CODMAT  = pCodMat
       and IVE.CODCOR  = pCodCor
       and IVE.CODTAM  = pCodTam
       and VEN.FLGEST <> 'C'
       and IVE.NATFIS not in ('511700', '611700', '515200', '615200', '540900', '640900', '194901', '294901')
       and IVE.SITMOV <> 'C'
       and IVE.SITKIT <> '1'
       and Trunc(IVE.VEN_DATHOR) between pDataIni and pDataFim
       and Coalesce(pCodFil,IVE.CODFIL) = IVE.CODFIL;
    --  gerando o vResult
    vResult := Trim(to_char(Coalesce(nLiqIve,0), '999999999.99'));
    vResult := vResult || ';' || Trim(to_char(Coalesce(nQtdIve,0), '999999999.99'));
    vResult := vResult || ';' || Trim(to_char(Coalesce(nVlrCmv,0), '999999999.9999'));
    --  --------------------------------------------------------
    return vResult;   
END;
$$ language 'plpgsql';




/*-- SEQ 0763 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VerificaStatusKit (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE) CASCADE;

/*-- SEQ 0764 --*/
CREATE OR REPLACE FUNCTION VerificaStatusKit (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILMAT ALIAS FOR $1 ;
pCODMAT ALIAS FOR $2 ;
pCODCOR ALIAS FOR $3 ;
pCODTAM ALIAS FOR $4 ;
-- Objetivo:
-- 1) Verificar o status de um Kit de produto
   cStatus                       VARCHAR(20); -- 1 - Header de Kit; 2 - Item normal; 3 - Item de Kit;
BEGIN

   SELECT CASE WHEN EXISTS (SELECT 1 FROM TT_KIT KIT 
                             WHERE KIT.FILMAT = GRA.FILMAT 
                               AND KIT.CODMAT = GRA.CODMAT
                               AND KIT.CODCOR = GRA.CODCOR
                               AND KIT.CODTAM = GRA.CODTAM) THEN '1'
               WHEN EXISTS (SELECT 1 FROM TT_KIT KIT
                             WHERE KIT.FILITE = GRA.FILMAT 
                               AND KIT.CODITE = GRA.CODMAT
                               AND KIT.CORITE = GRA.CODCOR
                               AND KIT.TAMITE = GRA.CODTAM) THEN '2' ELSE '3' END
     INTO cStatus
     FROM TT_GRA GRA 
    WHERE GRA.FILMAT = PFILMAT
      AND GRA.CODMAT = PCODMAT
      AND GRA.CODCOR = PCODCOR
      AND GRA.CODTAM = PCODTAM
    LIMIT 1
  ;

   RETURN cStatus;
END;
$$ language 'plpgsql';




/*-- SEQ 0765 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Vlr_Contri (Timestamp,Timestamp,TT_SAL.FILMAT%TYPE,TT_SAL.CODMAT%TYPE,TT_SAL.CODCOR%TYPE,TT_SAL.CODTAM%TYPE,TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 0766 --*/
CREATE OR REPLACE FUNCTION Vlr_Contri (Timestamp,Timestamp,TT_SAL.FILMAT%TYPE,TT_SAL.CODMAT%TYPE,TT_SAL.CODCOR%TYPE,TT_SAL.CODTAM%TYPE,TD_FIL.CODFIL%TYPE)
RETURNS Numeric AS $$
DECLARE
pDataIni ALIAS FOR $1 ;
pDataFim ALIAS FOR $2 ;
pFilMat ALIAS FOR $3 ;
pCodMat ALIAS FOR $4 ;
pCodCor ALIAS FOR $5 ;
pCodTam ALIAS FOR $6 ;
pCodFil ALIAS FOR $7 ;
--  --------------------------------------------------------
--  Objetivos:
--  1. Função que calcula o valor de contribuição do item vendido (produto).
--  --------------------------------------------------------
--  vars e cursores
    nContri Numeric;
--  --------------------------------------------------------
begin
    select Round(Coalesce(Sum(TAB.ICMITE) +
              Sum(TAB.VLRMOV * TAB.VENPIS / 100) +
              Sum(TAB.VLRMOV * TAB.VENCOF / 100) +
              Sum(TAB.VLRMOV * TAB.PERSOC / 100) +
              Sum(TAB.VLRMOV * TAB.PEROPE / 100) +
              Sum(TAB.VLRMOV * TAB.PERIR  / 100), 0), 4) 
              as CONTRI
      into nContri
      from (select IVE.CODFIL,
                   IVE.FILMAT,
                   IVE.CODMAT,
                   IVE.CODCOR,
                   IVE.CODTAM,
                   IVE.NUMITE,
                   IVE.SITKIT,
                   ((IVE.VLRMOV) + (IVE.VLRFRE) + 
                     (case when (Coalesce(IVE.DESRAT,0) > 0) then IVE.DESRAT else 0 end) + 
                     (case when (Coalesce(IVE.DESRAT,0) < 0) then IVE.DESRAT else 0 end) - 
                     (IVE.VLRFRE) - (case when (Coalesce(IVE.DESRAT,0) > 0) then IVE.DESRAT else 0 end))
                     as VLRMOV,
                   IVE.TIP001,
                   IVE.ICMTIP,
                   IVE.SEQUEN,
                   IVE.NATFIS,
                   IVE.BASICM,
                   IVE.SITPIS,
                   IVE.SITCOF,
                   IVE.TAXICM,
                   IVE.CODCST,
                   VEN.VLRLIQ,
                   VEN.VLRNOT,
                   VEN.FLGEST,
                   VEN.LANVEN,
                   IVE.SITMOV,
                   IVE.VEN_DATHOR,
                   Coalesce(CFG.TAXFIN,  0) as TAXFIN,     /* taxa financeira */
                   Coalesce(CFG.PRAFIN,  1) as PRAFIN,     /* prazo divisor da taxa financeira */
                   Coalesce(DFIL.VENPIS, 0) as VENPIS,     /* percentual de contribuicao do pis */
                   Coalesce(DFIL.VENCOF, 0) as VENCOF,     /* percentual de contribuicao do cofins */
                   Coalesce(DFIL.PERSOC, 0) as PERSOC,     /* percentual de contribuicao do contrib. social */
                   Coalesce(DFIL.PEROPE, 0) as PEROPE,     /* percentual médio extra para cobrir o operacional */
                   Coalesce(CFG.PERIR,   0) as PERIR,      /* percentual de contribuicao do i.r. */
                   Coalesce(IVE.COMISS,  0) as COMISSOES,  /* comissao do item */
                   case Coalesce(IVE.TIP001, 'M') when 'M' then 
                      case IVE.ICMTIP when '3' then 0 
                      else case IVE.ICMTIP when '0' then (Coalesce(IVE.BASICM,0) / 100) * IVE.TAXICM 
                      else (Coalesce(IVE.BASICM,0) / 100) * IVE.TAXICM end end else 0 end 
                      as ICMITE
              from TT_VEN VEN 
             cross join TT_CFG CFG           
             inner join TT_IVE IVE  on VEN.CODFIL  = IVE.CODFIL and VEN.SEQUEN = IVE.SEQUEN
             inner join TD_FIL DFIL on DFIL.CODFIL = IVE.CODFIL 
           ) TAB
    where TAB.FILMAT  = pFilMat
      and TAB.CODMAT  = pCodMat
      and TAB.CODCOR  = pCodCor
      and TAB.CODTAM  = pCodTam
      and TAB.FLGEST <> 'C'
      and TAB.NATFIS not in ('511700', '611700', '515200', '615200', '540900', '640900', '194901', '294901')
      and TAB.SITMOV <> 'C'
      and TAB.SITKIT <> '1'
      and TRUNC(TAB.VEN_DATHOR) between pDataIni and pDataFim
      and TAB.CODFIL = pCodFil;
    --  --------------------------------------------------------
    return Coalesce(nContri, 0);
END;
$$ language 'plpgsql';




/*-- SEQ 0767 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VlrCstVda (TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE,TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 0768 --*/
CREATE OR REPLACE FUNCTION VlrCstVda (TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE,TD_FIL.CODFIL%TYPE)
RETURNS Numeric AS $$
DECLARE
pSequen ALIAS FOR $1 ;
pNumIte ALIAS FOR $2 ;
pCodFil ALIAS FOR $3 ;
--  ------------------------------------- 
--  Objetivos:
--  1. Função que calcula a contribuição do produto para demonstrar 
--     na coluna do relatório de Bonificação.
--  -------------------------------------
--  vars e cursores
    nContri Numeric; 
--  -------------------------------------
begin
select Round(Coalesce((Sum(TAB.ICMITE) +
         Sum(TAB.VLRMOV * TAB.VENPIS / 100) +
         Sum(TAB.VLRMOV * TAB.VENCOF / 100) +
         Sum(TAB.VLRMOV * TAB.PERSOC / 100) +
         Sum(TAB.VLRMOV * TAB.PEROPE / 100) +
         Sum(TAB.VLRMOV * TAB.PERIR  / 100)), 
       0), 3) as CONTRI into nContri
  from (select IVE.CODFIL, IVE.FILMAT, IVE.CODMAT,
               IVE.CODCOR, IVE.CODTAM, IVE.NUMITE,
               IVE.TIP001, IVE.ICMTIP, IVE.SEQUEN,
               IVE.NATFIS, IVE.BASICM, IVE.SITPIS,
               IVE.SITCOF, IVE.TAXICM, IVE.CODCST,
               VEN.VLRLIQ, VEN.VLRNOT, VEN.FLGEST,
               VEN.LANVEN, IVE.SITMOV, IVE.VEN_DATHOR,
               -- VLRMOV
               ((IVE.VLRMOV) + Coalesce(IVE.VLRFRE, 0) + 
                 (case when (Coalesce(IVE.DESRAT, 0) > 0) then IVE.DESRAT else 0 end) + 
                 (case when (Coalesce(IVE.DESRAT, 0) < 0) then IVE.DESRAT else 0 end) - 
                 Coalesce(IVE.VLRFRE, 0) - 
                 (case when (Coalesce(IVE.DESRAT, 0) > 0) then IVE.DESRAT else 0 end)
               ) as VLRMOV,
               Coalesce(CFG.TAXFIN , 0) as TAXFIN,     /* taxa financeira */
               Coalesce(CFG.PRAFIN , 1) as PRAFIN,     /* prazo divisor da taxa financeira */
               Coalesce(DFIL.VENPIS, 0) as VENPIS,     /* percentual de contribuicao do pis */
               Coalesce(DFIL.VENCOF, 0) as VENCOF,     /* percentual de contribuicao do cofins */
               Coalesce(DFIL.PERSOC, 0) as PERSOC,     /* percentual de contribuicao do contrib. social */
               Coalesce(DFIL.PEROPE, 0) as PEROPE,     /* percentual médio extra para cobrir o operacional */
               Coalesce(CFG.PERIR,   0) as PERIR,      /* percentual de contribuicao do i.r. */
               Coalesce(IVE.COMISS,  0) as COMISSOES,  /* comissao do item */
               case Coalesce(IVE.TIP001, 'M') when 'M' then 
                    case IVE.ICMTIP when '3' then 0 
                    else case IVE.ICMTIP when '0' then (Coalesce(IVE.BASICM, 0) / 100) * Coalesce(IVE.TAXICM, 0)
                    else (Coalesce(IVE.BASICM, 0) / 100) * Coalesce(IVE.TAXICM, 0) end end else 0
               end as ICMITE
          from TT_VEN VEN 
               cross join TT_CFG CFG           
               inner join TT_IVE IVE  on  VEN.CODFIL = IVE.CODFIL and VEN.SEQUEN = IVE.SEQUEN
               inner join TD_FIL DFIL on DFIL.CODFIL = IVE.CODFIL 
       ) TAB
 where TAB.SEQUEN = pSequen
   and TAB.NUMITE = pNumIte 
   and TAB.CODFIL = pCodFil;
-- retorno da função
return Coalesce(nContri, 0);
   
END;
$$ language 'plpgsql';




/*-- SEQ 0769 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AssinaturasPendentes () CASCADE;

/*-- SEQ 0770 --*/
CREATE OR REPLACE FUNCTION AssinaturasPendentes ()
RETURNS VARCHAR AS $$
DECLARE

-- Objetivos:
-- 1) Conta incluses na TT_ASS de maneira assncrona
    
    rTM_ASS     RECORD;  
     
  
    
    rTT_UID_OLD     RECORD;  
     
  
  crTabelasParaAssinar CURSOR FOR
  SELECT *
    FROM TM_ASS
   WHERE FLGEST = 'P';

BEGIN
  -- Garantia de exclusividade no processo seguinte
  UPDATE TM_ASS
     SET FLGEST = 'P'
   WHERE FLGEST = 'N';

  
  -- Inicializa RECORD
  SELECT TT_UID.*
    INTO rTT_UID_OLD
    FROM TT_UID
   WHERE 1=0;
     
  -- Atualiza nmero de linhas 
  OPEN crTabelasParaAssinar;
  LOOP
    FETCH crTabelasParaAssinar INTO rTM_ASS;
    EXIT WHEN NOT FOUND;    
    
      IF rTT_UID_OLD.CODUID IS NULL OR  
         rTT_UID_OLD.CODUID <> rTM_ASS.CODUID 
      THEN    
             
          SELECT TT_UID.*
            INTO rTT_UID_OLD
            FROM TT_UID
           WHERE CODUID = rTM_ASS.CODUID;
              END IF;
    
      IF  rTT_UID_OLD.CODUID IS NOT NULL 
      AND rTM_ASS.ASSINA = GetAssinaTab('TM_ASS', 
                                        rTT_UID_OLD.CODUID, 
                                        ConcatenaUID(rTT_UID_OLD.CODUID,
                                                     rTT_UID_OLD.USEROS,
                                                     rTT_UID_OLD.DATOPE,
                                                     rTT_UID_OLD.NOMMAQ,
                                                     rTT_UID_OLD.VERBAS,
                                                     rTT_UID_OLD.VERSIS,
                                                     rTT_UID_OLD.NOMSIS,
                                                     rTT_UID_OLD.SESSION_ID),
                                        rTT_UID_OLD.ASSINA,             
                                        ConcatenaMASS(rTM_ASS.MASSID,
                                                      rTM_ASS.TABELA,
                                                      'N')) -- RFMP Foi assinado com "N"
      THEN
        UPDATE TT_ASS
           SET QTDREG = QTDREG + 1
         WHERE NOMTAB = rTM_ASS.TABELA;
      END IF;        
  END LOOP;
  CLOSE crTabelasParaAssinar; 

  -- Libera registros
  DELETE 
    FROM TM_ASS
   WHERE FLGEST = 'P';
  
  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 0771 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Aux_CalculaDACMod11 (VARCHAR,VARCHAR,VARCHAR,VARCHAR,Numeric,VARCHAR) CASCADE;

/*-- SEQ 0772 --*/
CREATE OR REPLACE FUNCTION Aux_CalculaDACMod11 (VARCHAR,VARCHAR,VARCHAR,VARCHAR,Numeric,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pCampo ALIAS FOR $1 ;
pListaInvalidos ALIAS FOR $2 ;
pListaDigitos ALIAS FOR $3 ;
pSomaMenor11 ALIAS FOR $4 ;
pPesoFim ALIAS FOR $5 ;
pTipoResultado ALIAS FOR $6 ;

-- Objetivos:
-- Calcula o dgito verificador usando Mdulo 11.
--
-- Parmetros:
--
-- pCampo                           Campo para clculo (cdigo de barras, cdigo do beneficirio, etc).
--                                  Ignora caracter # em pCampo.
--
-- pListaInvalidos                  Passar os nmeros que no so admitidos como resultado da subtrao separados por ";".
--                                  Ex.: "0;10;11;"
--                                  Nas regras que indicam "> 9" pode passar "10;11;" porque no  possvel
--                                  obter mdulo superior a 11 nesse clculo.
--
-- pListaDigitos                    Valor assumido como DAV para cada respectivo resultado invlido passado em pListaInvalidos.
--                                  Ex.: "1;1;1;"
--                                   obrigatrio passar um dgito para cada nmero de pListaInvalidos.
--
-- pSomaMenor11                     Se "T" executa o PASSO 3 da explicao abaixo.
--                                  Se "F" pula essa etapa (Padro).
--
-- pPesoFim                         Peso limite utilizado no clculo.
--                                  Pode ser "7" ou "9". Padro  calcular de 2 a 9.
--
-- pTipoResultado                   Modifica resultado trazido pela funo.
--                                  "D": Retorna dgito.
--                                  "V": Retorna se resultado  vlido ou no.
--
-- Resultado                        Dgito verificador do campo campo 1 caracter.
--                                  Ex.: "7".
--                                  Ou se o resultado  vlido
--                                  "T": Vlido / "F": Invlido
--
-- Clculo do Mdulo 11:
--
-- PASSO 1
--
-- Aplicar o mdulo 11 aos dados do Cdigo de Barras, o primeiro dgito da direita para a esquerda ser
-- multiplicado por 2, o segundo, por 3 e assim sucessivamente at o 9;
-- Cdigo Beneficirio usado para clculo: 005507
-- 0   0  5  5  0  7      Sentido Clculo             <- direita para esquerda
-- 7   6  5  4  3  2      ndice Multiplicao        2, 3, 4, ...
-- 00 00 25 20 00 14      Resultado Multiplicao     7 x 2 = 14, 0 x 3 = 0, ...
--
-- PASSO 2
--
-- Somar o resultado da multiplicao:
-- 0 + 0 + 25 + 20 + 0 + 14
-- Total da Soma = 59
--
-- PASSO 3
--
-- Quando o Total da Soma for MENOR que o quociente (no caso 11), Total da
-- Soma dever ser diminudo diretamente do quociente, obtendo-se o DV como resultado.
-- Caso contrrio, utilizar resto da diviso do Total da Soma por 11
--
-- PASSO 4
--
-- Subtrair o resto da diviso de 11
-- 11 - 4 = 7
-- Resultado: DV = 7
--
-- PASSO 5
--
-- O resultado no admite alguns valores. Por isso, no final ele pode ser modificado de acordo
-- com as regras abaixo.
--
-- Regra 1: Se o RESULTADO for maior que 9 (nove) o DV ser 0 (zero), caso contrrio o RESULTADO ser o DV.
-- Regra 2: Em nenhuma hiptese poder ser utilizado o dgito igual a 0 (zero) como DV Geral.
--          Se o RESULTADO for igual 0 (zero) ou maior que 9 (nove) o DV ser 1 (um).
--          Regra exclusiva para clculo do DV geral do cdigo de barras que no admite 0 (zero).

   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');
   cDAC                          CHAR(1);
   nDigAux                       Numeric(2);
   nSoma                         Numeric(7);
   nCont                         INTEGER;
   nMult                         Numeric(1);
   cInvalidos                    VARCHAR(250);
   nQtdItens                     Numeric(3);
   nCountListaInvalidos          Numeric(3);
   nCountListaDigitos            Numeric(3);
   nDigLista                     Numeric(2);

BEGIN
   -- Conta a quantidade de nmeros passados por parmetro.
   nCountListaInvalidos := LENGTH(REPLACE(TRANSLATE(pListaInvalidos,'1234567890',' '),' ',''));
   nCountListaDigitos   := LENGTH(REPLACE(TRANSLATE(pListaDigitos,'1234567890A',' '),' ',''));

   -- Validaes para evitar erros de programao.

   -- Verifica se o ltimo dgito  ";".
   IF SUBSTR(pListaInvalidos,LENGTH(pListaInvalidos),1) <> ';' THEN
      RAISE EXCEPTION 'PG-20000 Parmetro pListaInvalidos  invlido. %' , COMPLEMENTO;
   END IF;

   IF SUBSTR(pListaDigitos,LENGTH(pListaDigitos)) <> ';' THEN
      RAISE EXCEPTION 'PG-20001 Parmetro pListaDigitos  invlido. %' , COMPLEMENTO;
   END IF;

   -- Verifica se as duas listas possuem mesma quantidade de caracteres
   IF nCountListaInvalidos <> nCountListaDigitos THEN
      RAISE EXCEPTION 'PG-20002 Quantidade de dgitos informados nos parmetros pListaInvalidos e pListaDigitos no confere. %' , COMPLEMENTO;
   END IF;
   
   -- Verifica tipo de resultado
   IF pTipoResultado NOT IN ('D','V') THEN
      RAISE EXCEPTION 'PG-20003 Parmetro pTipoResultado  invlido. %' , COMPLEMENTO;
   END IF;   

   -- Incio do clculo Mod 11
   nCont := LENGTH(TRIM(pCampo));
   nSoma := 0;
   nMult := 2;
   WHILE (nCont >= 1) LOOP

      -- No considera campo ignorado
      IF SUBSTR(pCampo, nCont, 1) <> '#' THEN

         -- Percorre da direita para esquerda somando
         nSoma := nSoma + (TO_NUMBER (SUBSTR(pCampo, nCont, 1) ) * nMult);
         IF nMult = pPesoFim THEN
            nMult := 2;
         ELSE
            nMult := nMult + 1;
         END IF;

      END IF;
      nCont := nCont -1;
   END LOOP;

   IF pSomaMenor11 = 'T' AND nSoma < 11 THEN
      nDigAux := 11 - nSoma;
   ELSE
      nDigAux := 11 - MOD(nSoma,11);
   END IF;

   -- Valida resultados invlidos
   cDAC := ' ';

   FOR nCont IN 1..nCountListaInvalidos LOOP
      -- Se dgito calculado estiver na lista de invlidos
      nDigLista := Split_Part_Number(pListaInvalidos,';',nCont);

      IF nDigAux = nDigLista THEN
         -- Utilize se respectivo valor padro
         cDAC := SUBSTR(Split_Part(pListaDigitos,';',nCont),1,1);
         EXIT;
      END IF;
   END LOOP;

   -- Se o dgito ainda no foi definido, utiliza o que foi calculado.
   IF cDAC = ' ' THEN
      cDAC := SUBSTR(TO_CHAR(nDigAux),1,1);
   END IF;

   RETURN cDAC;
END;
$$ language 'plpgsql';


/*-- SEQ 0773 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Aux_CalculaDACMod11 (VARCHAR,VARCHAR,VARCHAR,VARCHAR,Numeric) CASCADE;

/*-- SEQ 0774 --*/
CREATE OR REPLACE FUNCTION Aux_CalculaDACMod11 (VARCHAR,
                               VARCHAR,
                               VARCHAR,
                               VARCHAR,
                               Numeric) 
RETURNS VARCHAR AS $$
BEGIN
RETURN Aux_CalculaDACMod11($1,$2,$3,$4,$5,'D');
END;
$$ language 'plpgsql';


/*-- SEQ 0775 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Aux_CalculaDACMod11 (VARCHAR,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 0776 --*/
CREATE OR REPLACE FUNCTION Aux_CalculaDACMod11 (VARCHAR,
                               VARCHAR,
                               VARCHAR,
                               VARCHAR) 
RETURNS VARCHAR AS $$
BEGIN
RETURN Aux_CalculaDACMod11($1,$2,$3,$4,9,'D');
END;
$$ language 'plpgsql';


/*-- SEQ 0777 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION BuscaLocalizacao (TT_SAL.FILMAT%TYPE,TT_SAL.CODMAT%TYPE,TT_SAL.CODCOR%TYPE,TT_SAL.CODTAM%TYPE,TT_SAL.CODFIL%TYPE,TT_SAL.CODMUL%TYPE,TT_GRA.LOCALI%TYPE) CASCADE;

/*-- SEQ 0778 --*/
CREATE OR REPLACE FUNCTION BuscaLocalizacao (TT_SAL.FILMAT%TYPE,TT_SAL.CODMAT%TYPE,TT_SAL.CODCOR%TYPE,TT_SAL.CODTAM%TYPE,TT_SAL.CODFIL%TYPE,TT_SAL.CODMUL%TYPE,TT_GRA.LOCALI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFilmat ALIAS FOR $1 ;
pCodmat ALIAS FOR $2 ;
pCodcor ALIAS FOR $3 ;
pCodtam ALIAS FOR $4 ;
pCodfil ALIAS FOR $5 ;
pCodmul ALIAS FOR $6 ;
pLocali ALIAS FOR $7 ;

-- Objetivos:
-- 1. Carrega as localizaes de um estoque.
-- 2. Retorna localizaes no formato padro.

-- Declarao de variveis e cursores
   cResultado              VARCHAR(32);
   cLocal1                 TT_SAL.LOCAL1%TYPE;
   cLocal2                 TT_SAL.LOCAL2%TYPE;
   cLocal3                 TT_SAL.LOCAL3%TYPE;

-- Incio da funo
begin

   cResultado := NULL;

      
      SELECT LOCAL1, LOCAL2, LOCAL3
        INTO cLocal1, cLocal2, cLocal3
        FROM TT_SAL
       WHERE FILMAT = pFilmat
         AND CODMAT = pCodmat
         AND CODCOR = pCodcor
         AND CODTAM = pCodtam
         AND CODFIL = pCodfil
         AND CODMUL = pCodmul;
         
      
   cResultado := FormataLocalizacao(cLocal1, cLocal2, cLocal3, pLocali);

   return cResultado;

END;
$$ language 'plpgsql';




/*-- SEQ 0779 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION BuscaParametro (TT_PCS.NOMPCS%TYPE,TT_PCS.TIPPCS%TYPE,TT_IPC.FILIPC%TYPE,TT_IPC.FILECF%TYPE,TT_IPC.NUMECF%TYPE,TT_IPC.CODSER%TYPE) CASCADE;

/*-- SEQ 0780 --*/
CREATE OR REPLACE FUNCTION BuscaParametro (TT_PCS.NOMPCS%TYPE,TT_PCS.TIPPCS%TYPE,TT_IPC.FILIPC%TYPE,TT_IPC.FILECF%TYPE,TT_IPC.NUMECF%TYPE,TT_IPC.CODSER%TYPE)
RETURNS TRetBuscaParametro AS $$
DECLARE
pNomeParametro ALIAS FOR $1 ;
pTipo ALIAS FOR $2 ;
pFilial ALIAS FOR $3 ;
pFilialECF ALIAS FOR $4 ;
pNumeroECF ALIAS FOR $5 ;
pSerie ALIAS FOR $6 ;

-- Objetivos:
-- 1. Busca parmetro conforme valores enviados

-- Declarao de variveis e cursores
   rRetorno                      TRetBuscaParametro;

   -- Parmetros Gerais
   crBuscaGeral CURSOR FOR
   SELECT IPC.VLRNUM,
          IPC.VLRINT,
          IPC.VLRTXT,
          IPC.VLRBOO,
          IPC.VLRDAT
     FROM TT_IPC IPC INNER JOIN TT_PCS PCS ON PCS.ID_PCS = IPC.ID_PCS
    WHERE PCS.NOMPCS = pNomeParametro
      AND PCS.PCSGER = 'T'
      AND IPC.IPCATI = 'T'
      AND IPC.FILIPC IS NULL
      AND IPC.FILECF IS NULL
      AND IPC.NUMECF IS NULL
      AND IPC.CODSER IS NULL;

   -- Parmetros por Filial
   crBuscaPorFilial CURSOR(pFilial TT_IPC.FILIPC%TYPE) IS
   SELECT IPC.VLRNUM,
          IPC.VLRINT,
          IPC.VLRTXT,
          IPC.VLRBOO,
          IPC.VLRDAT
     FROM TT_IPC IPC INNER JOIN TT_PCS PCS ON PCS.ID_PCS = IPC.ID_PCS
    WHERE PCS.NOMPCS = pNomeParametro
      AND PCS.PCSFIL = 'T'
      AND IPC.IPCATI = 'T'
      AND IPC.FILIPC = pFilial;

   -- Parmetros por ECF
   crBuscaPorECF CURSOR(pFilialECF TT_IPC.FILECF%TYPE,
           pNumeroECF TT_IPC.NUMECF%TYPE) IS
   SELECT IPC.VLRNUM,
          IPC.VLRINT,
          IPC.VLRTXT,
          IPC.VLRBOO,
          IPC.VLRDAT
     FROM TT_IPC IPC INNER JOIN TT_PCS PCS ON PCS.ID_PCS = IPC.ID_PCS
    WHERE PCS.NOMPCS = pNomeParametro
      AND PCS.PCSECF = 'T'
      AND IPC.IPCATI = 'T'
      AND IPC.FILECF = pFilialECF
      AND IPC.NUMECF = pNumeroECF;

   -- Parmetros por Srie
   crBuscaPorSerie CURSOR(pSerie TT_IPC.CODSER%TYPE) IS
   SELECT IPC.VLRNUM,
          IPC.VLRINT,
          IPC.VLRTXT,
          IPC.VLRBOO,
          IPC.VLRDAT
     FROM TT_IPC IPC INNER JOIN TT_PCS PCS ON PCS.ID_PCS = IPC.ID_PCS
    WHERE PCS.NOMPCS = pNomeParametro
      AND PCS.PCSSER = 'T'
      AND IPC.IPCATI = 'T'
      AND IPC.CODSER = pSerie;

-- Incio da funo
BEGIN
   IF ISNULL(pNomeParametro) = 'T' THEN
      RAISE EXCEPTION 'PG-20000 Nome do parmetro no informado';
   END IF;

   -- Valores default
   rRetorno.Encontrou := FALSE;

   IF ValidaParametro(pNomeParametro,pTipo) THEN

      -- Localiza pela Srie
      IF ISNOTNULL(pSerie) = 'T' THEN
         OPEN crBuscaPorSerie(pSerie);
         FETCH crBuscaPorSerie INTO rRetorno.VLRNUM, rRetorno.VLRINT, rRetorno.VLRTXT, rRetorno.VLRBOO, rRetorno.VLRDAT;
         IF FOUND THEN
            rRetorno.Encontrou := TRUE;
         END IF;
         CLOSE crBuscaPorSerie;
      END IF;

      -- Localiza pelo ECF
      IF (ISNOTNULL(pFilialECF) = 'T') AND (ISNOTNULL(pNumeroECF) = 'T') AND (NOT rRetorno.Encontrou) THEN
         OPEN crBuscaPorECF(pFilialECF, pNumeroECF);
         FETCH crBuscaPorECF INTO rRetorno.VLRNUM, rRetorno.VLRINT, rRetorno.VLRTXT, rRetorno.VLRBOO, rRetorno.VLRDAT;
         IF FOUND THEN
            rRetorno.Encontrou := TRUE;
         END IF;
         CLOSE crBuscaPorECF;
      END IF;

      -- Localiza pela Filial
      IF (ISNOTNULL(pFilial) = 'T') AND (NOT rRetorno.Encontrou) THEN
         OPEN crBuscaPorFilial(pFilial);
         FETCH crBuscaPorFilial INTO rRetorno.VLRNUM, rRetorno.VLRINT, rRetorno.VLRTXT, rRetorno.VLRBOO, rRetorno.VLRDAT;
         IF FOUND THEN
            rRetorno.Encontrou := TRUE;
         END IF;
         CLOSE crBuscaPorFilial;
      END IF;

      -- Localiza Geral
      IF NOT rRetorno.Encontrou THEN
         OPEN crBuscaGeral;
         FETCH crBuscaGeral INTO rRetorno.VLRNUM, rRetorno.VLRINT, rRetorno.VLRTXT, rRetorno.VLRBOO, rRetorno.VLRDAT;
         IF FOUND THEN
            rRetorno.Encontrou := TRUE;
         END IF;
         CLOSE crBuscaGeral;
      END IF;

      -- Valores Default
      IF NOT rRetorno.Encontrou THEN
         rRetorno.VLRNUM := 0;
         rRetorno.VLRINT := 0;
         rRetorno.VLRTXT := '';
         rRetorno.VLRBOO := 'F';
         rRetorno.VLRDAT := NULL;
      END IF;
   END IF;

   RETURN rRetorno;

END;
$$ language 'plpgsql';




/*-- SEQ 0781 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalcElastPre (TT_PRE.FILPRE%TYPE,TT_PRE.SEQUEN%TYPE,TT_PRE.DATINC%TYPE,TT_PRE.PRECOV%TYPE,TT_PRE.ULTELA%TYPE,TT_PRE.DIAELA%TYPE) CASCADE;

/*-- SEQ 0782 --*/
CREATE OR REPLACE FUNCTION CalcElastPre (TT_PRE.FILPRE%TYPE,TT_PRE.SEQUEN%TYPE,TT_PRE.DATINC%TYPE,TT_PRE.PRECOV%TYPE,TT_PRE.ULTELA%TYPE,TT_PRE.DIAELA%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFilPre ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
pDatInc ALIAS FOR $3 ;
pPrecoV ALIAS FOR $4 ;
pUltEla ALIAS FOR $5 ;
pDiaEla ALIAS FOR $6 ;

-- Objetivos:
-- 1. Esta função calcula a elasticidade e a quantidade de dias para a elasticidade
--    do preço passado pelos parametros e retorna as duas informações concatenadas
--    em uma string. 
--
-- Parâmetros:
--    pFilPre char(3): filial de identificação do preço;
--    pSequen char(10): sequencia de identificação do preço;
--    pDatInc Timestamp: data de inclusão do preço;
--    pPrecoV Numeric(12,4): preço de venda atual;
--    pUltEla Numeric(12,2): valor da última elasticidade calculada;
--    pDiaEla Numeric(4): quantidade de dias utilizada no cáculo da última
--      elasticidade;
--
-- Retorno VARCHAR(250): retorna a elasticidade, quantidade de dias usada
--    no cálculo, o preço anterior, a data da ultima alteração do preço, a
--    quantidade vendida no preço atual e a quantidade vendida no preço anterior,
--    respectivamente, concatenadados em uma string e separados por um sinal de
--    ponto e vírgula ( ; ).
--    Utilize a função split_part() para ler este resultado de forma mais
--    amigável.
--
--  nota: Para maiores informações sobre esta função veja o artigo:
--        http://intra.totall.com.br:8080/wiki/index.php/Análise_para_Precificação

-- Declaração de variáveis e cursores
    cResult      VARCHAR(250);                              --  retorno da função
    nVlrEla      TT_PRE.ULTELA%TYPE;                        --  Numeric(12,2): valor da elasticidade calculada
    iDiaEla      TT_PRE.DIAELA%TYPE;                        --  Numeric(4): quantidade de dias usada no calculo da elasticidade
    vAux         VARCHAR(250);                              --  var auxiliar
    cTipDiaElast TT_CFG.TIPDIA_ELASTICIDADE%TYPE;           --  char(1); (C,A) default C
    iDiasVarPre  TT_CFG.DIAS_VARPRE%TYPE;                   --  Numeric(2) default 0
    dAgora       Timestamp;                                      --  guarda a data e hora atuais para ser utilizada em todo o procedimento
    dP1Ini       Timestamp;                                      --  início do P1 (primeiro período)
    dP1Fim       Timestamp;                                      --  fim do P1
    dP2Ini       Timestamp;                                      --  início do P2 (segundo período)
    dP2Fim       Timestamp;                                      --  fim do P2
    iDiasP1      Numeric(4);                                 --  qtd. dias do P1
    iDiasP2      Numeric(4);                                 --  qtd. dias do P2
    nPrecoP1     TT_PRE.PRECOV%TYPE;                        --  preço do P1
    nPrecoP2     TT_PRE.PRECOV%TYPE;                        --  preço do P2
    iQtdP1       Numeric(6);                                 --  qtd. vendida em P1
    iQtdP2       Numeric(6);                                 --  qtd. vendida em P2
    dTmp1        Timestamp;                                      --  Timestamp: var temporária para guardar uma data
    dTmp2        Timestamp;                                      --  Timestamp: var temporária para guardar uma data
    cCodFil      TR_MOV.CODFIL%TYPE;                        --  char(3): esta var é para se quiser separa a função por filial
    --  var para guardar o código do produto (FILPRE, SEQUEN)
    cFilMat      TT_PRE.FILMAT%TYPE;                        --  char(3)
    cCodMat      TT_PRE.CODMAT%TYPE;                        --  char(5)
    iCodCor      TT_PRE.CODCOR%TYPE;                        --  Numeric(5)
    iCodTam      TT_PRE.CODTAM%TYPE;                        --  Numeric(5)
    --  vars para crMovAsc e crMovDesc
    wdDatOpe     TT_DAT.DATOPE%TYPE;                        --  Timestamp
    wdDatMov     TR_MOV.DATMOV%TYPE;                        --  Timestamp
    wnEstoque    TR_MOV.SALANT%TYPE;                        --  Numeric(12,4)
    wcPromoc     TR_MOV.PROMOC%TYPE;                        --  VARCHAR(1)
    --  vars para crLPre
    wcFilPre     TL_PRE.FILPRE%TYPE;                        --  char(3)
    wcSeqPre     TL_PRE.SEQPRE%TYPE;                        --  char(10)
    --wdDatOpe     TL_PRE.DATOPE%TYPE;                        --  Timestamp
    wnPreAnt     TL_PRE.PREANT%TYPE;                        --  Numeric(12,4)
    
    --  cursor usado para buscar as mudanças de preços
    crLPre CURSOR(pcrFilPre TL_PRE.FILPRE%TYPE,
           pcrSeqPre TL_PRE.SEQPRE%TYPE) IS
        select LPRE.FILPRE,
               LPRE.SEQPRE,
               LPRE.DATOPE,
               LPRE.PREANT
          from TL_PRE LPRE
         where LPRE.FILPRE = pcrFilPre
           and LPRE.SEQPRE = pcrSeqPre
           and LPRE.PREANT is not null
      order by LPRE.DATOPE desc;
      
    --  cursor usado para pegar a quantidade vendida por um preço em um determidado período
    crQtdVen CURSOR(pcrFilPre TL_PRE.FILPRE%TYPE,
           pcrSeqPre TL_PRE.SEQPRE%TYPE,
           pcrDatIni Timestamp,
           pcrDatFim Timestamp,
           pcrPreVlr TT_PRE.PRECOV%TYPE) IS
    select sum(TAB.QTDMOV)
      from (
             select VEN.CODFIL,
                    VEN.DATFIS,
                    IVE.FILMAT,
                    IVE.CODMAT,
                    IVE.CODCOR,
                    coalesce(IVE.EMBORI, IVE.CODTAM) as CODTAM,
                    IVE.CODMUL,
                    sum(IVE.QTDMOV) as QTDMOV
               from TT_PRE PRE
              inner join TT_VEN VEN
                      on PRE.FILPRE = VEN.FILPRE
                     and PRE.CODPRE = VEN.CODPRE
              inner join TT_IVE IVE
                      on VEN.CODFIL = IVE.CODFIL
                     and VEN.SEQUEN = IVE.SEQUEN
                     and PRE.FILMAT = IVE.FILMAT
                     and PRE.CODMAT = IVE.CODMAT
                     and PRE.CODCOR = IVE.CODCOR
                     and PRE.CODTAM = coalesce(IVE.EMBORI, IVE.CODTAM)
              where PRE.FILPRE = pcrFilPre
                and PRE.SEQUEN = pcrSeqPre
                and VEN.DATHOR between pcrDatIni and pcrDatFim
                and VEN.LANVEN in ('P', 'T')
                and VEN.NUMNOT not like '%#%'
                and IVE.LANEST in ('S', 'R')
                and IVE.SITMOV = 'N'
                and IVE.SITKIT in ('2', '3')
                and IVE.VLRORI = pcrPreVlr
                and IVE.PROMOC = 'F'
           group by VEN.CODFIL,
                    VEN.DATFIS,
                    IVE.FILMAT,
                    IVE.CODMAT,
                    IVE.CODCOR,
                    coalesce(IVE.EMBORI, IVE.CODTAM),
                    IVE.CODMUL
           order by VEN.CODFIL,
                    VEN.DATFIS
           ) TAB;

           --  cursor usado para pegar a quantidade vendida por um preço em um determidado período
    --  se tiver estoque
    crQtdVenEst CURSOR(pcrFilPre TL_PRE.FILPRE%TYPE,
           pcrSeqPre TL_PRE.SEQPRE%TYPE,
           pcrDatIni Timestamp,
           pcrDatFim Timestamp,
           pcrPreVlr TT_PRE.PRECOV%TYPE) IS
    select sum(TAB.QTDMOV)
      from (
             select VEN.CODFIL,
                    VEN.DATFIS,
                    IVE.FILMAT,
                    IVE.CODMAT,
                    IVE.CODCOR,
                    coalesce(IVE.EMBORI, IVE.CODTAM) as CODTAM,
                    IVE.CODMUL,
                    sum(IVE.QTDMOV) as QTDMOV
               from TT_PRE PRE
              inner join TT_VEN VEN
                      on PRE.FILPRE = VEN.FILPRE
                     and PRE.CODPRE = VEN.CODPRE
              inner join TT_IVE IVE
                      on VEN.CODFIL = IVE.CODFIL
                     and VEN.SEQUEN = IVE.SEQUEN
                     and PRE.FILMAT = IVE.FILMAT
                     and PRE.CODMAT = IVE.CODMAT
                     and PRE.CODCOR = IVE.CODCOR
                     and PRE.CODTAM = coalesce(IVE.EMBORI, IVE.CODTAM)
              where PRE.FILPRE = pcrFilPre
                and PRE.SEQUEN = pcrSeqPre
                and VEN.DATHOR between pcrDatIni and pcrDatFim
                and VEN.LANVEN in ('P', 'T')
                and VEN.NUMNOT not like '%#%'
                and IVE.LANEST in ('S', 'R')
                and IVE.SITMOV = 'N'
                and IVE.SITKIT in ('2', '3')
                and IVE.VLRORI = pcrPreVlr
                and IVE.PROMOC = 'F'
           group by VEN.CODFIL,
                    VEN.DATFIS,
                    IVE.FILMAT,
                    IVE.CODMAT,
                    IVE.CODCOR,
                    coalesce(IVE.EMBORI, IVE.CODTAM),
                    IVE.CODMUL
           order by VEN.CODFIL,
                    VEN.DATFIS
           ) TAB
     where coalesce(
           (select coalesce(MOV.SALANT, 0) +
                   coalesce(MOV.QTDCOM, 0) +
                   coalesce(MOV.QTDOUT, 0)
              from TR_MOV MOV
             where MOV.CODFIL = TAB.CODFIL
               and MOV.FILMAT = TAB.FILMAT
               and MOV.CODMAT = TAB.CODMAT
               and MOV.CODCOR = TAB.CODCOR
               and MOV.CODTAM = TAB.CODTAM
               and MOV.CODMUL = TAB.CODMUL
               and MOV.DATMOV = TAB.DATFIS
               and MOV.PROMOC = 'F'
           ), 0) > 0;

           --  cursor usado para pegar os dias corridos com estoque e sem promoção
    --  DAT.DATOPE asc
    crMovAsc CURSOR(pcrCodFil TR_MOV.CODFIL%TYPE,
           pcrFilMat TR_MOV.FILMAT%TYPE,
           pcrCodMat TR_MOV.CODMAT%TYPE,
           pcrCodCor TR_MOV.CODCOR%TYPE,
           pcrCodTam TR_MOV.CODTAM%TYPE,
           pcrDatIni TR_MOV.DATMOV%TYPE,
           pcrDatFim TR_MOV.DATMOV%TYPE) IS
      select DAT.DATOPE,
             TAB.DATMOV,
             TAB.ESTOQUE,
             TAB.PROMOC
        from (select distinct UTL0.DATOPE
                from TT_UTL UTL0
             ) DAT
        left join (
             select pcrDatIni as DATMOV,
                    coalesce(MOV0.SALANT, 0) as ESTOQUE,
                    cast('F' as VARCHAR(1)) as PROMOC
               from TR_MOV MOV0,
                    (select min(SUB0.DATMOV) as DATMOV
                       from TR_MOV SUB0
                      where SUB0.CODFIL = coalesce(pcrCodFil, SUB0.CODFIL)
                        and SUB0.FILMAT = pcrFilMat
                        and SUB0.CODMAT = pcrCodMat
                        and SUB0.CODCOR = pcrCodCor
                        and SUB0.CODTAM = pcrCodTam
                        and SUB0.DATMOV between pcrDatIni and pcrDatFim
                    ) DAT0
              where MOV0.CODFIL = coalesce(pcrCodFil, MOV0.CODFIL)
                and MOV0.FILMAT = pcrFilMat
                and MOV0.CODMAT = pcrCodMat
                and MOV0.CODCOR = pcrCodCor
                and MOV0.CODTAM = pcrCodTam
                and MOV0.DATMOV = DAT0.DATMOV
                and not exists (
                    select 1 as OK
                      from TR_MOV SUB1
                     where SUB1.CODFIL = coalesce(pcrCodFil, SUB1.CODFIL)
                       and SUB1.FILMAT = pcrFilMat
                       and SUB1.CODMAT = pcrCodMat
                       and SUB1.CODCOR = pcrCodCor
                       and SUB1.CODTAM = pcrCodTam
                       and SUB1.DATMOV = pcrDatIni
                    )
             union all
             select MOV1.DATMOV,
                    coalesce(MOV1.SALANT, 0) + coalesce(MOV1.QTDCOM, 0) + coalesce(MOV1.QTDOUT, 0) as ESTOQUE,
                    MOV1.PROMOC
               from TR_MOV MOV1
              where MOV1.CODFIL = coalesce(pcrCodFil, CODFIL)
                and MOV1.FILMAT = pcrFilMat
                and MOV1.CODMAT = pcrCodMat
                and MOV1.CODCOR = pcrCodCor
                and MOV1.CODTAM = pcrCodTam
                and MOV1.DATMOV between pcrDatIni and pcrDatFim
             union all
             select add_day(pcrDatFim, 1) as DATMOV,
                    coalesce(MOV2.SALANT, 0) - coalesce(MOV2.VENFIS, 0) - coalesce(MOV2.QTDVEN, 0) + coalesce(MOV2.QTDCOM, 0) +
                        coalesce(MOV2.QTDOUT, 0) as ESTOQUE,
                    cast('F' as VARCHAR(1)) as PROMOC
               from TR_MOV MOV2,
                    (select max(SUB2.DATMOV) as DATMOV
                       from TR_MOV SUB2
                      where SUB2.CODFIL = coalesce(pcrCodFil, SUB2.CODFIL)
                        and SUB2.FILMAT = pcrFilMat
                        and SUB2.CODMAT = pcrCodMat
                        and SUB2.CODCOR = pcrCodCor
                        and SUB2.CODTAM = pcrCodTam
                        and SUB2.DATMOV between pcrDatIni and pcrDatFim
                    ) DAT2
              where MOV2.CODFIL = coalesce(pcrCodFil, MOV2.CODFIL)
                and MOV2.FILMAT = pcrFilMat
                and MOV2.CODMAT = pcrCodMat
                and MOV2.CODCOR = pcrCodCor
                and MOV2.CODTAM = pcrCodTam
                and MOV2.DATMOV = DAT2.DATMOV
                and not exists (
                    select 1 as OK
                      from TR_MOV SUB3
                     where SUB3.CODFIL = coalesce(pcrCodFil, SUB3.CODFIL)
                       and SUB3.FILMAT = pcrFilMat
                       and SUB3.CODMAT = pcrCodMat
                       and SUB3.CODCOR = pcrCodCor
                       and SUB3.CODTAM = pcrCodTam
                       and SUB3.DATMOV = pcrDatFim
                    )
             ) TAB
             on TAB.DATMOV = DAT.DATOPE
       where DAT.DATOPE between pcrDatIni and pcrDatFim
    order by DAT.DATOPE asc;

    --  cursor usado para pegar os dias corridos com estoque e sem promoção
    --  DAT.DATOPE desc
    crMovDesc CURSOR(pcrCodFil TR_MOV.CODFIL%TYPE,
           pcrFilMat TR_MOV.FILMAT%TYPE,
           pcrCodMat TR_MOV.CODMAT%TYPE,
           pcrCodCor TR_MOV.CODCOR%TYPE,
           pcrCodTam TR_MOV.CODTAM%TYPE,
           pcrDatIni TR_MOV.DATMOV%TYPE,
           pcrDatFim TR_MOV.DATMOV%TYPE) IS
      select DAT.DATOPE,
             TAB.DATMOV,
             TAB.ESTOQUE,
             TAB.PROMOC
        from (select distinct UTL0.DATOPE
                from TT_UTL UTL0
             ) DAT
        left join (
             select pcrDatIni as DATMOV,
                    coalesce(MOV0.SALANT, 0) as ESTOQUE,
                    cast('F' as VARCHAR(1)) as PROMOC
               from TR_MOV MOV0,
                    (select min(SUB0.DATMOV) as DATMOV
                       from TR_MOV SUB0
                      where SUB0.CODFIL = coalesce(pcrCodFil, SUB0.CODFIL)
                        and SUB0.FILMAT = pcrFilMat
                        and SUB0.CODMAT = pcrCodMat
                        and SUB0.CODCOR = pcrCodCor
                        and SUB0.CODTAM = pcrCodTam
                        and SUB0.DATMOV between pcrDatIni and pcrDatFim
                    ) DAT0
              where MOV0.CODFIL = coalesce(pcrCodFil, MOV0.CODFIL)
                and MOV0.FILMAT = pcrFilMat
                and MOV0.CODMAT = pcrCodMat
                and MOV0.CODCOR = pcrCodCor
                and MOV0.CODTAM = pcrCodTam
                and MOV0.DATMOV = DAT0.DATMOV
                and not exists (
                    select 1 as OK
                      from TR_MOV SUB1
                     where SUB1.CODFIL = coalesce(pcrCodFil, SUB1.CODFIL)
                       and SUB1.FILMAT = pcrFilMat
                       and SUB1.CODMAT = pcrCodMat
                       and SUB1.CODCOR = pcrCodCor
                       and SUB1.CODTAM = pcrCodTam
                       and SUB1.DATMOV = pcrDatIni
                    )
             union all
             select MOV1.DATMOV,
                    coalesce(MOV1.SALANT, 0) + coalesce(MOV1.QTDCOM, 0) + coalesce(MOV1.QTDOUT, 0) as ESTOQUE,
                    MOV1.PROMOC
               from TR_MOV MOV1
              where MOV1.CODFIL = coalesce(pcrCodFil, CODFIL)
                and MOV1.FILMAT = pcrFilMat
                and MOV1.CODMAT = pcrCodMat
                and MOV1.CODCOR = pcrCodCor
                and MOV1.CODTAM = pcrCodTam
                and MOV1.DATMOV between pcrDatIni and pcrDatFim
             union all
             select add_day(pcrDatFim, 1) as DATMOV,
                    coalesce(MOV2.SALANT, 0) - coalesce(MOV2.VENFIS, 0) - coalesce(MOV2.QTDVEN, 0) + coalesce(MOV2.QTDCOM, 0) +
                        coalesce(MOV2.QTDOUT, 0) as ESTOQUE,
                    cast('F' as VARCHAR(1)) as PROMOC
               from TR_MOV MOV2,
                    (select max(SUB2.DATMOV) as DATMOV
                       from TR_MOV SUB2
                      where SUB2.CODFIL = coalesce(pcrCodFil, SUB2.CODFIL)
                        and SUB2.FILMAT = pcrFilMat
                        and SUB2.CODMAT = pcrCodMat
                        and SUB2.CODCOR = pcrCodCor
                        and SUB2.CODTAM = pcrCodTam
                        and SUB2.DATMOV between pcrDatIni and pcrDatFim
                    ) DAT2
              where MOV2.CODFIL = coalesce(pcrCodFil, MOV2.CODFIL)
                and MOV2.FILMAT = pcrFilMat
                and MOV2.CODMAT = pcrCodMat
                and MOV2.CODCOR = pcrCodCor
                and MOV2.CODTAM = pcrCodTam
                and MOV2.DATMOV = DAT2.DATMOV
                and not exists (
                    select 1 as OK
                      from TR_MOV SUB3
                     where SUB3.CODFIL = coalesce(pcrCodFil, SUB3.CODFIL)
                       and SUB3.FILMAT = pcrFilMat
                       and SUB3.CODMAT = pcrCodMat
                       and SUB3.CODCOR = pcrCodCor
                       and SUB3.CODTAM = pcrCodTam
                       and SUB3.DATMOV = pcrDatFim
                    )
             ) TAB
             on TAB.DATMOV = DAT.DATOPE
       where DAT.DATOPE between pcrDatIni and pcrDatFim
    order by DAT.DATOPE desc;

begin

    --  alimentando vars de config.
    select CFG.TIPDIA_ELASTICIDADE,
           CFG.DIAS_VARPRE,
           agora()
      into cTipDiaElast,
           iDiasVarPre,
           dAgora
      from TT_CFG CFG;

    --  var ainda não usada
    cCodFil := null;

    --  buscando o código do produto do TT_PRE
    select PRE.FILMAT,
           PRE.CODMAT,
           PRE.CODCOR,
           PRE.CODTAM
      into cFilMat,
           cCodMat,
           iCodCor,
           iCodTam
      from TT_PRE PRE
     where PRE.FILPRE = pFilPre
       and PRE.SEQUEN = pSequen;

    --  [ BLOCO 0 ]  ---------------------------------------
    --  definindo os períodos e os seus preços
    --  abrindo o cursor somente com o primeiro registro que não teve alteração antes de dAgora
    open crLPre(pFilPre, pSequen);
    fetch crLPre into wcFilPre, wcSeqPre, wdDatOpe, wnPreAnt;
    --  se não encontrou a última alteração de preço (cursor ordenado por DatOpe desc) levanta uma exception e encerra
    if  NOT FOUND then
        --  como não é possível fazer o calculo, retorna todos os valores nulos e encerra a função
        close crLPre;
        cResult := ';;;;;;As informacoes da ultima alteracao de preco nao foram encontradas.';
        return cResult;
    end if;
    dP1Fim   := trunc(wdDatOpe) - 1;
    dP2Ini   := trunc(wdDatOpe);
    dP2Fim   := trunc(dAgora);
    nPrecoP1 := wnPreAnt;
    nPrecoP2 := pPrecoV;
    
    --  carregando  a penúltima alteração de preço (cursor ordenado por DatOpe desc)
    fetch crLPre into  wcFilPre, wcSeqPre, wdDatOpe, wnPreAnt;
    if  NOT FOUND then
        dP1Ini := trunc(pDatInc);
    else
        dP1Ini := trunc(wdDatOpe);
    end if;
    
    --  fechando o cursor
    close crLPre;
    
    if  cTipDiaElast = 'C' then
        --  [ BLOCO 1 ]  -----------------------------------
        --  (C) dias corridos
        --  definindo a quantidade de dias de cada período
        iDiasP1 := IntervaloDias(dP1Fim, dP1Ini);
        if  iDiasP1 > iDiasVarPre then
            iDiasP1 := iDiasVarPre;
        end if;
        iDiasP2 := IntervaloDias(dP2Fim, dP2Ini);
        if  iDiasP2 > iDiasVarPre then
            iDiasP2 := iDiasVarPre;
        end if;
        --  usando a menor quantidade de dias como base
        if  iDiasP2 > iDiasP1 then
            iDiasP2 := iDiasP1;
        elsif iDiasP1 > iDiasP2 then
            iDiasP1 := iDiasP2;
        end if;
        iDiaEla := iDiasP1;
        --  redefinindo os períodos com as novas quantidades de dias
        dP1Ini := add_day(dP1Fim, (iDiasP1 * -1));
        dP2Fim := add_day(dP2Ini, iDiasP2);
        --  ajustando os horários dos períodos (oracle)
        dP1Ini := trunc(dP1Ini); -- 00:00:00
        dP1Fim := add_second(trunc(dP1Fim), ((24 * 60 * 60) - 1)); -- 23:59:59
        dP2Ini := trunc(dP2Ini); -- 00:00:00
        dP2Fim := add_second(trunc(dP2Fim), ((24 * 60 * 60) - 1)); -- 23:59:59
        --  buscando a quantidade vendida para o primeiro período
        open crQtdVen(pFilPre, pSequen, dP1Ini, dP1Fim, nPrecoP1);
        fetch crQtdVen into iQtdP1;
        if  iQtdP1 is null then
            iQtdP1 := 0;
        end if;
        close crQtdVen;
        --  buscando a quantidade vendida para o segundo período
        open crQtdVen(pFilPre, pSequen, dP2Ini, dP2Fim, nPrecoP2);
        fetch crQtdVen into iQtdP2;
        if  iQtdP2 is null then
            iQtdP2 := 0;
        end if;
        close crQtdVen;
    else
        --  [ BLOCO 2 ]  -----------------------------------
        --  (A) dias com a loja aberta e com estoque
        --  calculando o primerio período
        iDiasP1 := 0;
        dTmp1 := null;
        open crMovDesc(cCodFil, cFilMat, cCodMat, iCodCor, iCodTam, dP1Ini, dP1Fim);
        loop
            fetch crMovDesc into wdDatOpe, wdDatMov, wnEstoque, wcPromoc;
            if  NOT FOUND then
                exit;
            end if;
            --  verifica se tem estoque, se não é promoção e se ainda não contou esta data
            if  wnEstoque > 0
            and wcPromoc  = 'F'
            and trunc(wdDatOpe) <> dTmp1 then
                iDiasP1 := iDiasP1 + 1;
            end if;
            --  guarda a data
            dTmp1 := trunc(wdDatOpe);
            --  atingiu a qtd de dias do config
            if  iDiasP1 = iDiasVarPre then
                exit;
            end if;
        end loop;
        close crMovDesc;
        if  dTmp1 is null then
            dTmp1 := dP1Ini;
        end if;
        --  calculando o segundo período
        iDiasP2 := 0;
        dTmp2 := null;
        open crMovAsc(cCodFil, cFilMat, cCodMat, iCodCor, iCodTam, dP2Ini, dP2Fim);
        loop
            fetch crMovAsc into wdDatOpe, wdDatMov, wnEstoque, wcPromoc;
            if  NOT FOUND then
                exit;
            end if;
            --  verifica se tem estoque, se não é promoção e se ainda não contou esta data
            if  wnEstoque > 0
            and wcPromoc  = 'F'
            and trunc(wdDatOpe) <> dTmp2 then
                iDiasP2 := iDiasP2 + 1;
            end if;
            --  guarda a data
            dTmp2 := trunc(wdDatOpe);
            --  atingiu a qtd de dias do config ou atingiu a data inicial
            if  iDiasP2 = iDiasVarPre
            or  iDiasP2 = iDiasP1 then
                exit;
            end if;
        end loop;
        close crMovAsc;
        if  dTmp2 is null then
            dTmp2 := dP2Fim;
        end if;
        --  a quant. dias do P2 for menor que a quant. dias do P1
        --  recalculando o primerio período
        if  iDiasP2 < iDiasP1 then
            iDiasP1 := 0;
            dTmp1 := null;
            open crMovDesc(cCodFil, cFilMat, cCodMat, iCodCor, iCodTam, dP1Ini, dP1Fim);
            loop
                fetch crMovDesc into wdDatOpe, wdDatMov, wnEstoque, wcPromoc;
                if  NOT FOUND then
                    exit;
                end if;
                --  verifica se tem estoque, se não é promoção e se ainda não contou esta data
                if  wnEstoque > 0
                and wcPromoc  = 'F'
                and trunc(wdDatOpe) <> dTmp1 then
                    iDiasP1 := iDiasP1 + 1;
                end if;
                --  guarda a data
                dTmp1 := trunc(wdDatOpe);
                --  atingiu a qtd de dias do config
                if  iDiasP1 = iDiasP2 then
                    exit;
                end if;
            end loop;
            close crMovDesc;
            if  dTmp1 is null then
                dTmp1 := dP1Ini;
            end if;
        end if;
        iDiaEla := iDiasP1;
        --  redefinindo os períodos de acordo com a contagem
        dP1Ini := trunc(dTmp1);
        dP2Fim := trunc(dTmp2);
        --  ajustando os horários dos períodos
        dP1Ini := trunc(dP1Ini); -- 00:00:00
        dP1Fim := add_second(trunc(dP1Fim), ((24 * 60 * 60) - 1)); -- 23:59:59
        dP2Ini := trunc(dP2Ini); -- 00:00:00
        dP2Fim := add_second(trunc(dP2Fim), ((24 * 60 * 60) - 1)); -- 23:59:59
        --  buscando a quantidade vendida para o primeiro período
        open crQtdVenEst(pFilPre, pSequen, dP1Ini, dP1Fim, nPrecoP1);
        fetch crQtdVenEst into iQtdP1;
        if  iQtdP1 is null then
            iQtdP1 := 0;
        end if;
        close crQtdVenEst;
        --  buscando a quantidade vendida para o segundo período
        open crQtdVenEst(pFilPre, pSequen, dP2Ini, dP2Fim, nPrecoP2);
        fetch crQtdVenEst into iQtdP2;
        if  iQtdP2 is null then
            iQtdP2 := 0;
        end if;
        close crQtdVenEst;
    end if;
    --  [ BLOCO 3 ]  ---------------------------------------
    --  calculando a elasticidade
    nVlrEla := CalcElast(coalesce(iQtdP1, 0), iQtdP2, coalesce(nPrecoP1, 0), nPrecoP2);
--  --------------------------------------------------------
--  retorno da funcao
    cResult := --  elasticidade
               to_char(nVlrEla, '000000000000D00') || ';' ||
               --  dias utilizados no calculo da elasticidade
               to_char(iDiaEla, '0000') || ';' ||
               --  preco anterior
               to_char(nPrecoP1, '000000000000D00') || ';' ||
               --  data da ultima alteração de preço
               to_char(dP2Ini, 'DD/MM/YYYY') || ';' ||
               --  quantidade vendida no preço atual
               to_char(iQtdP2, '000000') || ';' ||
               --  quantidade vendida no preço anterior
               to_char(iQtdP1, '000000');
    return cResult;
END;
$$ language 'plpgsql';




/*-- SEQ 0783 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalculaMediaDesvioPadraoPXF () CASCADE;

/*-- SEQ 0784 --*/
CREATE OR REPLACE FUNCTION CalculaMediaDesvioPadraoPXF ()
RETURNS VARCHAR AS $$
DECLARE


-- Objetivos:
-- 1. Calcular a media de recebimento de pedidos por produto/fornecedor
-- 2. Calcular o desvio padrao de recebimento de pedidos por produto/fornecedor

   -- Declaracao de cursores
   CR_FornecedorProduto CURSOR FOR
   SELECT PXF.FILFOR,
          PXF.CODFOR,
          PXF.FILMAT,
          PXF.CODMAT,
          PXF.CODCOR,
          PXF.CODTAM
     FROM TT_PXF PXF
    ORDER BY PXF.FILFOR,PXF.CODFOR,PXF.FILMAT,PXF.CODMAT,PXF.CODCOR,PXF.CODTAM;

   -- Calcula media e desvio padrao do produto/fornecedor
   -- Regras:
   --  1)Considera apenas pedidos dos ultimos "n" dias, conforme TT_CFG.DIAS_REC_PEDIDOS
   --  2)Considera apenas compras que nao estao devolvidas ou canceladas
   --  3)Caso o produto tenha recebimento em mais de uma compra (dentro de um mesmo pedido) considera a menor compra - MIN(DATOPE)
   CR_MediaDesvioPadrao CURSOR(p_FilFor TT_PXF.FILFOR%TYPE,
           p_CodFor TT_PXF.CODFOR%TYPE,
           p_FilMat TT_PXF.FILMAT%TYPE,
           p_CodMat TT_PXF.CODMAT%TYPE,
           p_CodCor TT_PXF.CODCOR%TYPE,
           p_CodTam TT_PXF.CODTAM%TYPE,
           p_Dias TT_CFG.DIAS_REC_PEDIDOS%TYPE) IS
   SELECT COALESCE(CAST(AVG(TAB.DIF_DIAS) AS Numeric(8,4)),0) AS MEDIA,
          COALESCE(CAST(STDDEV(TAB.DIF_DIAS) AS Numeric(8,4)),0) AS DESVIO_PADRAO
     FROM (
           SELECT SUB.*,
                  COALESCE(IntervaloDias(TRUNC(SUB.COM_DATOPE),TRUNC(SUB.DATPED)),0) AS DIF_DIAS
             FROM (
                    SELECT TRUNC(PED.DATPED) AS DATPED,
                           TRUNC(MIN(COM.DATOPE)) AS COM_DATOPE
                      FROM TT_IPE IPE INNER JOIN TT_PED PED ON PED.CODFIL = IPE.CODFIL
                                                           AND PED.NUMPED = IPE.NUMPED
                                      INNER JOIN TT_ICO ICO ON ICO.CODFIL = IPE.FILICO
                                                           AND ICO.SEQUEN = IPE.SEQICO
                                                           AND ICO.NUMITE = IPE.NUMICO
                                      INNER JOIN TT_COM COM ON COM.CODFIL = ICO.CODFIL
                                                           AND COM.SEQUEN = ICO.SEQUEN
                     WHERE PED.FILFOR = p_FilFor
                       AND PED.CODFOR = p_CodFor
                       AND IPE.FILMAT = p_FilMat
                       AND IPE.CODMAT = p_CodMat
                       AND IPE.CODCOR = p_CodCor
                       AND IPE.CODTAM = p_CodTam
                       AND COM.FLGEST <> 'D'
                       AND TRUNC(PED.DATPED) >= ADD_DAY(TRUNC(Agora()),p_Dias*-1)
                     GROUP BY IPE.CODFIL,
                              IPE.NUMPED,
                              PED.DATPED,
                              IPE.FILMAT,
                              IPE.CODMAT,
                              IPE.CODCOR,
                              IPE.CODTAM
                  ) SUB
   ) TAB;

   -- Declaracao de variaveis
   v_MANUT                       TT_IDF.MANUT%TYPE;
   v_Complemento                 CONSTANT VARCHAR(254) := Constante('complemento');

   nDias                         TT_CFG.DIAS_REC_PEDIDOS%TYPE;
   cFilFor                       TT_PXF.FILFOR%TYPE;
   cCodFor                       TT_PXF.CODFOR%TYPE;
   cFilMat                       TT_PXF.FILMAT%TYPE;
   cCodMat                       TT_PXF.CODMAT%TYPE;
   nCodCor                       TT_PXF.CODCOR%TYPE;
   nCodTam                       TT_PXF.CODTAM%TYPE;
   nMedia                        TT_PXF.MEDENT%TYPE;
   nDesvioPadrao                 TT_PXF.DP_ENT%TYPE;

-- Inicio da funcao
BEGIN

   SELECT MANUT INTO v_MANUT
     FROM TT_IDF;

   IF v_MANUT = 'T' THEN
      RAISE EXCEPTION 'PG-20010 Base em manutencao %' , v_Complemento;
   END IF;

   -- Guarda configuracao de dias para recebimento dos pedidos
   SELECT COALESCE(DIAS_REC_PEDIDOS,0) INTO nDias FROM TT_CFG;

   -- Se nao possuir configuracao, nao faz nada
   IF nDias > 0 THEN

      OPEN CR_FornecedorProduto;
      LOOP
         FETCH CR_FornecedorProduto INTO cFilFor,cCodFor,cFilMat,cCodMat,nCodCor,nCodTam;
         EXIT WHEN NOT FOUND;

         OPEN CR_MediaDesvioPadrao(cFilFor,cCodFor,cFilMat,cCodMat,nCodCor,nCodTam,nDias);
         LOOP
            FETCH CR_MediaDesvioPadrao INTO nMedia, nDesvioPadrao;
            EXIT WHEN NOT FOUND;

            -- Valida Media e desvio padrao para não gerar erro
            IF (nMedia < 0) THEN
               nMedia := 0;
            END IF;
            IF (nDesvioPadrao < 0) THEN
               nDesvioPadrao := 0;
            END IF;
            -- Atualiza media e desvio padrao da TT_PXF
            UPDATE TT_PXF SET MEDENT = nMedia,
                              DP_ENT = nDesvioPadrao
             WHERE FILFOR = cFilFor
               AND CODFOR = cCodFor
               AND FILMAT = cFilMat
               AND CODMAT = cCodMat
               AND CODCOR = nCodCor
               AND CODTAM = nCodTam;

         END LOOP;
         CLOSE CR_MediaDesvioPadrao;

      END LOOP;
      CLOSE CR_FornecedorProduto;

   END IF;

   RETURN 'OK';

END;
$$ language 'plpgsql';



/*-- SEQ 0785 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_CalcMediaDesvioPXF (TT_JOB.CODUID%TYPE) CASCADE;

/*-- SEQ 0786 --*/
CREATE OR REPLACE FUNCTION Job_CalcMediaDesvioPXF (TT_JOB.CODUID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODUID ALIAS FOR $1 ;
   vNOME                         TT_JOB.NOMJOB%TYPE;
   vDESC                         TT_JOB.DESJOB%TYPE;
   dummy                         CHAR(2);
BEGIN
   vNOME := 'JOB_CALCMEDIADESVIOPXF';
   vDESC := 'Rotina que calcula media e desvio padrao da TT_PXF';
   BEGIN
      DUMMY := CalculaMediaDesvioPadraoPXF();
      DUMMY := RegistraJob(vNOME, vDESC, NULL, pCODUID);
   EXCEPTION
      WHEN OTHERS THEN DUMMY := RegistraJob(vNOME, vDESC, SQLERRM, pCODUID);
   END;
  RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 0787 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_CalcMediaDesvioPXF () CASCADE;

/*-- SEQ 0788 --*/
CREATE OR REPLACE FUNCTION Job_CalcMediaDesvioPXF () 
RETURNS VARCHAR AS $$
BEGIN
RETURN Job_CalcMediaDesvioPXF(NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 0789 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Insert_TR_SUG (Timestamp,Timestamp,TR_SUG.ANO_MES%TYPE) CASCADE;

/*-- SEQ 0790 --*/
CREATE OR REPLACE FUNCTION Insert_TR_SUG (Timestamp,Timestamp,TR_SUG.ANO_MES%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pDataIni ALIAS FOR $1 ;
pDataFim ALIAS FOR $2 ;
pAnoMes ALIAS FOR $3 ;

-- Objetivos:
--   1) Insere registro do mês na TR_SUG
--      A quantidade prevista é baseada na média de vendas dos últimos 6 meses
--      Se o produto não possuir 6 meses de movimentação, calcula a média apenas do primeiro mês de movimentação em diante
--      A fórmula para cálculo da média de vendas é uma divisão simples: MÉDIA = (TOTAL DE VENDAS / NÚMERO DE MESES)
BEGIN
  INSERT INTO TR_SUG(CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,ANO_MES,FLGEST,QTDPRE,QTDVEN,TRASIG,GRAABC,GRAXYZ)
  SELECT TAB.CODFIL,
         TAB.FILMAT,
         TAB.CODMAT,
         TAB.CODCOR,
         TAB.CODTAM,
         pAnoMes,
         'A',
         CASE WHEN TAB.MESES > 0 THEN CAST(COALESCE(TOTALVENDA(TAB.DATINI,--GREATEST(TAB.MOV_DATINI,TAB.DATINI),
                                                               TAB.DATFIM,
                                                               TAB.FILMAT,
                                                               TAB.CODMAT,
                                                               TAB.CODCOR,
                                                               TAB.CODTAM,
                                                               TAB.CODFIL)/TAB.MESES,0) AS Numeric(12,4)) -- média de vendas dos últimos 6 meses
              ELSE 0
         END AS QTDPRE,
         NULL AS QTDVEN,
         NULL AS TRASIG,
         TAB.GRAABC,
         TAB.GRAXYZ
    FROM (
          SELECT SUB.CODFIL,SUB.FILMAT,SUB.CODMAT,SUB.CODCOR,SUB.CODTAM,NULL AS QTDVEN,NULL AS TRASIG,SUB.GRAABC,SUB.GRAXYZ,
                 GREATEST(TO_DATE('01'||'/'||TO_CHAR(SUB.MOV_DATINI,'MM/YYYY'),'DD/MM/YYYY'),
                          SUB.DATINI) AS DATINI,
                 ADD_DAY(ADD_MONTHS(pDataFim,-1),-1) AS DATFIM,
                 COALESCE(CEIL(MONTHS_BETWEEN(ADD_MONTHS(pDataFim,-1),
                                              GREATEST(SUB.MOV_DATINI,SUB.DATINI))),0) AS MESES
            FROM (
                  SELECT DFIL.CODFIL,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,NULL AS QTDVEN,NULL AS TRASIG,GRA.GRAABC,GRA.GRAXYZ,
                         (SELECT MIN(RMOV.DATMOV) AS MIN_DATMOV
                            FROM TR_MOV RMOV
                           WHERE RMOV.FILMAT = GRA.FILMAT
                             AND RMOV.CODMAT = GRA.CODMAT
                             AND RMOV.CODCOR = GRA.CODCOR
                             AND RMOV.CODTAM = GRA.CODTAM
                             AND RMOV.CODFIL = DFIL.CODFIL
                         ) AS MOV_DATINI,
                         ADD_MONTHS(pDataIni,-6) AS DATINI
                    FROM TT_GRA GRA CROSS JOIN TD_FIL DFIL
                   WHERE GRA.GRAATI = 'T'
                 ) SUB
         ) TAB;

  RETURN 'OK';

END;
$$ language 'plpgsql';



/*-- SEQ 0791 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Update_TR_SUG (Timestamp,Timestamp,TR_SUG.ANO_MES%TYPE) CASCADE;

/*-- SEQ 0792 --*/
CREATE OR REPLACE FUNCTION Update_TR_SUG (Timestamp,Timestamp,TR_SUG.ANO_MES%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pDataIni ALIAS FOR $1 ;
pDataFim ALIAS FOR $2 ;
pAnoMes ALIAS FOR $3 ;

-- Objetivos:
--  1) Atualizar flag e quantidade vendida da TR_SUG
BEGIN
  UPDATE TR_SUG SUG SET FLGEST = 'F',
                        QTDVEN = (SELECT COALESCE(SUM(IVE.QTDMOV),0)
                                    FROM TT_IVE IVE INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL
                                                           AND VEN.SEQUEN = IVE.SEQUEN
                                   WHERE IVE.VEN_DATHOR >= pDataIni
                                     AND IVE.VEN_DATHOR <  pDataFim
                                     AND IVE.CODFIL = SUG.CODFIL
                                     AND IVE.FILMAT = SUG.FILMAT
                                     AND IVE.CODMAT = SUG.CODMAT
                                     AND IVE.CODCOR = SUG.CODCOR
                                     AND IVE.CODTAM = SUG.CODTAM
                                     AND IVE.LANEST IN ('S','R')
                                     AND IVE.SITKIT IN ('2','3')
                                     AND IVE.SITMOV = 'N'
                                     AND VEN.LANVEN = 'T'
                                     AND VEN.NUMNOT NOT LIKE '%#%')
   WHERE SUG.ANO_MES = pAnoMes;

   RETURN 'OK';

END;
$$ language 'plpgsql';



/*-- SEQ 0793 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalculaTrackingSignal () CASCADE;

/*-- SEQ 0794 --*/
CREATE OR REPLACE FUNCTION CalculaTrackingSignal ()
RETURNS VARCHAR AS $$
DECLARE


-- Objetivos:
-- 1. Calcular Tracking Signal (TS) dos produtos
--    O TS é um indicador utilizado para verificar se a demanda Numeric reflete os pressupostos na previsão
--    sobre o nível e talvez tendência no perfil da demanda. É calculado pela razão entre o desvio acumulado
--    e o desvio absoluto médio.
--    http://www.forecastingblog.com/?p=39

-- Declaração de variáveis e cursores
v_MANUT TT_IDF.MANUT%TYPE;
v_Complemento CONSTANT VARCHAR(254) := constante('complemento');

n_Previsao Numeric;
n_Vendas Numeric;
n_Desvio Numeric;
n_DesvioAcumulado Numeric;
n_DesvioAbsoluto Numeric;
n_DesvioAbsolutoAcumulado Numeric;
n_DesvioAbsolutoMedio Numeric;
n_TrackingSignal Numeric;
n_Contador Numeric;

c_CODFIL TD_FIL.CODFIL%TYPE;
c_FILMAT TT_GRA.FILMAT%TYPE;
c_CODMAT TT_GRA.CODMAT%TYPE;
n_CODCOR TT_GRA.CODCOR%TYPE;
n_CODTAM TT_GRA.CODTAM%TYPE;

c_AnoMesSugestao TR_SUG.ANO_MES%TYPE;
c_AnoMesAtual TR_SUG.ANO_MES%TYPE;
c_ANOMES TR_SUG.ANO_MES%TYPE;

d_DataIni Timestamp;
d_DataFim Timestamp;

c_DUMMY VARCHAR(2);

CR_PRODUTOSXFILIAL CURSOR FOR
SELECT DISTINCT DFIL.CODFIL,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM
  FROM TT_GRA GRA CROSS JOIN TD_FIL DFIL
 WHERE GRA.GRAATI = 'T';

CR_PREXVEN CURSOR(pCodFil TD_FIL.CODFIL%TYPE,
           pFilMat TT_GRA.FILMAT%TYPE,
           pCodMat TT_GRA.CODMAT%TYPE,
           pCodCor TT_GRA.CODCOR%TYPE,
           pCodTam TT_GRA.CODTAM%TYPE) IS
SELECT SUG.ANO_MES,                      -- Ano/Mês
       COALESCE(SUG.QTDPRE,0) AS QTDPRE, -- Quantidade Prevista
       COALESCE(SUG.QTDVEN,0) AS QTDVEN  -- Quantidade Vendida
  FROM TR_SUG SUG
 WHERE SUG.CODFIL = pCodFil
   AND SUG.FILMAT = pFilMat
   AND SUG.CODMAT = pCodMat
   AND SUG.CODCOR = pCodCor
   AND SUG.CODTAM = pCodTam
   AND SUG.ANO_MES BETWEEN TO_CHAR(ADD_MONTHS(Agora(),-6),'YYYY-MM') AND TO_CHAR(ADD_MONTHS(Agora(),-1),'YYYY-MM')
 ORDER BY SUG.ANO_MES;

-- Início da função
BEGIN

  SELECT MANUT INTO v_MANUT
    FROM TT_IDF;

  IF v_MANUT = 'T' THEN
     RAISE EXCEPTION 'PG-20010 Base em manutencao %' , v_Complemento;
  END IF;

  SELECT CAST(COALESCE(MAX(ANO_MES),'') AS VARCHAR(7)) AS ANOMES_SUG,
       TO_CHAR(TO_CHAR(Agora(),'YYYY')||'-'||TO_CHAR(Agora(),'MM')) AS ANOMES_ATU
    INTO c_AnoMesSugestao,c_AnoMesAtual
  FROM TR_SUG;

  -- Se não houver registros na TR_SUG, insere os 6 meses anteriores para ter um histórico e conseguir calcular o tracking signal atual
  IF ISNULL(c_AnoMesSugestao)='T' THEN
    -- Loop para inserção e atualização dos registros retroativos
    FOR n_Contador IN 1..6 LOOP
      -- Monta o ano/mês no formato YYYY-MM, diminuindo os meses pelo valor do contador
      c_AnoMesSugestao := TO_CHAR(ADD_MONTHS(Agora(),n_Contador*-1),'YYYY')||'-'||TO_CHAR(ADD_MONTHS(Agora(),n_Contador*-1),'MM');

      -- Monta data inicial e final para atualização da TR_SUG
      SELECT TO_DATE('01'||'/'||SUBSTR(c_AnoMesSugestao,6,2)||'/'||SUBSTR(c_AnoMesSugestao,1,4),'DD/MM/YYYY') AS DATINI,
             TRUNC(ADD_DAY(LAST_DAY(TO_DATE('01'||'/'||SUBSTR(c_AnoMesSugestao,6,2)||'/'||SUBSTR(c_AnoMesSugestao,1,4),'DD/MM/YYYY')),1)) AS DATFIM
      INTO d_DataIni, d_DataFim
      FROM DUAL;

      -- Insere registros do mês na TR_SUG para todos os produtos ativos
      c_DUMMY := Insert_TR_SUG(d_DataIni,d_DataFim,c_AnoMesSugestao);
      -- Atualiza flag e quantidade vendida do mês para todos os produtos ativos
      c_DUMMY := Update_TR_SUG(d_DataIni,d_DataFim,c_AnoMesSugestao);

    END LOOP;

    -- Define a variável para o mês anterior do atual para continuar o processo normal
    c_AnoMesSugestao := TO_CHAR(ADD_MONTHS(Agora(),-1),'YYYY-MM');
  END IF;

  -- Processa Tracking Signal se o mês atual mudou
  IF c_AnoMesAtual > c_AnoMesSugestao THEN

    -- Monta data inicial e final para atualização da TR_SUG
    SELECT TO_DATE('01'||'/'||SUBSTR(c_AnoMesSugestao,6,2)||'/'||SUBSTR(c_AnoMesSugestao,1,4),'DD/MM/YYYY') AS DATINI,
           TRUNC(ADD_DAY(LAST_DAY(TO_DATE('01'||'/'||SUBSTR(c_AnoMesSugestao,6,2)||'/'||SUBSTR(c_AnoMesSugestao,1,4),'DD/MM/YYYY')),1)) AS DATFIM
      INTO d_DataIni, d_DataFim
      FROM DUAL;

    -- Insere previsão para o mês atual
    -- Usa o ADD_MONTHS nas variáveis pois elas possuem a data do mês anterior
    c_DUMMY := Insert_TR_SUG(ADD_MONTHS(d_DataIni,1),ADD_MONTHS(d_DataFim,1),c_AnoMesAtual);
    -- Atualiza mês anterior
    c_DUMMY := Update_TR_SUG(d_DataIni,d_DataFim,c_AnoMesSugestao);

     -- Abre cursor de produtos por filial (TT_GRA X TD_FIL)
     OPEN CR_PRODUTOSXFILIAL;
     LOOP
       FETCH CR_PRODUTOSXFILIAL INTO c_CODFIL,c_FILMAT,c_CODMAT,n_CODCOR,n_CODTAM;
       EXIT WHEN NOT FOUND;

         -- zera variáveis de controle
         n_DesvioAcumulado := 0;
         n_DesvioAbsolutoAcumulado := 0;
         n_Contador := 1;
         -- Abre cursor de previsão por vendas
         OPEN CR_PREXVEN(c_CODFIL,c_FILMAT,c_CODMAT,n_CODCOR,n_CODTAM);
         LOOP
           FETCH CR_PREXVEN INTO c_ANOMES, n_Previsao,n_Vendas;
           EXIT WHEN NOT FOUND;

           -- Calcula Tracking Signal
           n_Desvio := (n_Previsao - n_Vendas);
           n_DesvioAcumulado := (n_DesvioAcumulado + n_Desvio);
           n_DesvioAbsoluto := ABS(n_Desvio);
           n_DesvioAbsolutoAcumulado := n_DesvioAbsolutoAcumulado + n_DesvioAbsoluto;
           n_DesvioAbsolutoMedio := (n_DesvioAbsolutoAcumulado / n_Contador);
           n_TrackingSignal := ROUND(n_DesvioAcumulado / NVLZ(n_DesvioAbsolutoMedio,1),2);

           -- atualiza registro na TR_SUG
           UPDATE TR_SUG SET TRASIG = n_TrackingSignal
            WHERE CODFIL  = c_CODFIL
              AND FILMAT  = c_FILMAT
              AND CODMAT  = c_CODMAT
              AND CODCOR  = n_CODCOR
              AND CODTAM  = n_CODTAM
              AND ANO_MES = c_ANOMES;

           -- incrementa contador (usado para cálculo do desvio médio)
           n_Contador := n_Contador + 1;
         END LOOP;
         CLOSE CR_PREXVEN;

     END LOOP;
     CLOSE CR_PRODUTOSXFILIAL;

  END IF;

  RETURN 'OK';

END;
$$ language 'plpgsql';



/*-- SEQ 0795 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_CalculaTrackingSignal (TT_JOB.CODUID%TYPE) CASCADE;

/*-- SEQ 0796 --*/
CREATE OR REPLACE FUNCTION Job_CalculaTrackingSignal (TT_JOB.CODUID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODUID ALIAS FOR $1 ;
   vNOME                         TT_JOB.NOMJOB%TYPE;
   vDESC                         TT_JOB.DESJOB%TYPE;
   dummy                         CHAR(2);
BEGIN
   vNOME := 'JOB_CALCULATRACKINGSIGNAL';
   vDESC := 'Rotina para calcular Tracking Signal dos produtos';
   BEGIN
      DUMMY := CalculaTrackingSignal();
      DUMMY := RegistraJob(vNOME, vDESC, NULL, pCODUID);
   EXCEPTION
      WHEN OTHERS THEN DUMMY := RegistraJob(vNOME, vDESC, SQLERRM, pCODUID);
   END;
  RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 0797 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_CalculaTrackingSignal () CASCADE;

/*-- SEQ 0798 --*/
CREATE OR REPLACE FUNCTION Job_CalculaTrackingSignal () 
RETURNS VARCHAR AS $$
BEGIN
RETURN Job_CalculaTrackingSignal(NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 0799 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Descancela_Venda (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE) CASCADE;

/*-- SEQ 0800 --*/
CREATE OR REPLACE FUNCTION Descancela_Venda (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
-- Objetivo:
-- 1. Descancelar uma venda, porm, nem sempre isso  muito simples.
--    15/08/2018 - Criao da Funo
--       1 - Descancela vendas com pagamento  vista (TT_REC.SEQCHE IS NULL AND SEQITF IS NULL) e no tem TT_CCC
--       2 - Descancela vendas pagas com carto (TT_REC.SEQCHE IS NULL AND SEQITF IS NOT NULL) e no tem TT_CCC
--       3 - NO descancela ainda vendas pagas com cheque (TT_REC.SEQCHE IS NOT NULL AND SEQITF IS NULL) e no tem TT_CCC
--       4 - Descancela vendas pagas com conta corrente EXISTS (TT_CCC.CODVEN = TT_VEN.CODFIL AND TT_CCC.SEQVEN = TT_VEN.SEQUEN)

-- Declarao de variveis e cursores
   vComplemento                  CONSTANT VARCHAR(100) := Constante('complemento');
   vSituacao                     VARCHAR(1);
   vTipo_Pagamento               VARCHAR(10);
   vQtd                          Numeric;
   -- MN - Variveis utilizadas para recalcular o saldo do produto aps descancelar
   WK_ESTOQUE                    VARCHAR(3);
   WK_FILMAT                     TT_IVE.FILMAT%TYPE;
   WK_CODMAT                     TT_IVE.CODMAT%TYPE;
   WK_CODCOR                     TT_IVE.CODCOR%TYPE;
   WK_CODTAM                     TT_IVE.CODTAM%TYPE;
   WK_CODMUL                     TT_IVE.CODMUL%TYPE;
   WK_SITKIT                     TT_IVE.SITKIT%TYPE;
   WK_NUMITE                     TT_IVE.NUMITE%TYPE;

   vMensagem                     VARCHAR(4000);
   bEhTransf                     INTEGER;

CR_VENDA_CANCELAR CURSOR(pCODFILVenda TT_VEN.CODFIL%TYPE,
           pSEQUENVenda TT_VEN.SEQUEN%TYPE) IS
  SELECT CASE WHEN REC.SEQCHE IS NOT NULL THEN 'CHEQUE'
              WHEN REC.SEQITF IS NOT NULL THEN 'CARTAO'
              WHEN EXISTS (SELECT 'OK' FROM TT_CCC WHERE CODVEN = VEN.CODFIL AND SEQVEN = VEN.SEQUEN) THEN 'CC'
              ELSE 'AVISTA'
              END AS TIPO_PAGAMENTO

    FROM TT_VEN VEN INNER JOIN TT_REC REC ON REC.CODFIL = VEN.CODFIL
                                         AND REC.SEQUEN = VEN.SEQUEN
   WHERE VEN.CODFIL = pCODFILVenda
     AND VEN.SEQUEN = pSEQUENVenda;

CR_ITEM_VENDA CURSOR(pCODFILVenda VARCHAR,
           pSEQUENVenda VARCHAR) IS
     SELECT IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM, IVE.CODMUL, IVE.SITKIT, IVE.NUMITE
       FROM TT_IVE IVE
      WHERE IVE.CODFIL = pCODFILVenda
        AND IVE.SEQUEN = pSEQUENVenda;

-- Incio da funo
BEGIN
   SELECT COALESCE(VEN.FLGEST, 'X')
     INTO vSituacao
     FROM TT_VEN VEN
    WHERE VEN.CODFIL = pCODFIL
      AND VEN.SEQUEN = pSequen;

      SELECT COUNT(*) INTO vQtd
     FROM TT_REC REC
    WHERE REC.CODFIL = pCODFIL
      AND REC.SEQUEN = pSequen
      AND (REC.RENEGO IS NOT NULL OR REC.RENORI IS NOT NULL);
   
   IF vQtd > 0 THEN
      RAISE EXCEPTION 'PG-20054 Funo no prevista para vendas com renegociao.%' , vComplemento;
   END IF;

   -- MN - Se a venda no estiver cancelada, sai da funo
   IF vSituacao = 'C' THEN
      vMensagem := '';

      SELECT COUNT(*)
        INTO bEhTransf
        FROM TT_VEN VEN INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
       CROSS JOIN TT_CFG CFG
       WHERE VEN.CODFIL = pCODFIL
         AND VEN.SEQUEN = pSEQUEN
         AND VEN.CODCLI = '     0'
         AND ((DNAT.TIPNAT IN ('S','R')) OR -- Tipos de Naturezas "Sada via Transferncia" ou "Devolucao de Transferencia"
              ((DNAT.TIPNAT = 'V') AND (DNAT.LANVEN = 'F') AND (DNAT.CODTAB = CFG.TRANSFER_NATCOL)) -- Tipos de Natureza "Venda" e "Lana registro como sendo do tipo Venda?" e "Natureza de Transferncia entre Filiais Coligadas"
             );

      -- MN - Reverte a venda e os itens de vendas, deixa status = "Q" e SITMOV = "N" se todas as parcelas tiverem sido pagas, ou "A" se tiver parcela em aberto
      -- Isso  igual para todas as vendas, carto/cheque/conta corrente/dinheiro
      UPDATE TT_VEN
         SET FLGEST = CASE WHEN EXISTS(SELECT 'OK'
                                         FROM TT_REC REC
                                        WHERE REC.CODFIL = TT_VEN.CODFIL
                                          AND REC.SEQUEN = TT_VEN.SEQUEN
                                          AND REC.PAGAME IS NULL) THEN 'A' ELSE 'Q' END,
             MOTCAN = NULL,
             FLGNFE = CASE WHEN MODNOT IN ('55', '59', '65') AND TT_VEN.CODSER <> 'CF' THEN '0' ELSE NULL END,
             DUMMY = '%'
       WHERE CODFIL = pCodfil
         AND SEQUEN = pSequen;

      -- MN - Infelizmente, no temos como saber, a no ser pelo log, se o item estava aberto ou cancelado antes de a venda ser cancelada
      -- por essa razo, todos os itens so reabertos. A pessoa que descancelar a venda DEVE, obrigatoriamente, verificar se os valores esto fechando
      -- Os valores esto corretos SE: SUM(IVE.VLRMOV + IVE.DESRAT) WHERE SITMOV = 'N' = TT_VEN.VLRNOT.
      -- Quando a venda for um cupom eletrnico ou nota fiscal eletrnica ou SAT, no tem problema, pois os itens cancelados no so enviados para fazenda
      -- pelo POS/Checkout.
      UPDATE TT_IVE
         SET SITMOV = 'N',
             DUMMY = '%'
       WHERE CODFIL = pCodfil
         AND SEQUEN = pSequen;

      -- MN - Percorre os itens da venda para recalcular saldo de estoque
      OPEN CR_ITEM_VENDA(pCodfil, pSequen);
      LOOP

         FETCH CR_ITEM_VENDA INTO WK_FILMAT, WK_CODMAT, WK_CODCOR, WK_CODTAM, WK_CODMUL, WK_SITKIT, WK_NUMITE;
         EXIT WHEN NOT FOUND;

         -- MN - Mtodo que recalcula saldo de estoque do item
         WK_ESTOQUE := ATUALIZAMOV(pCodfil, WK_FILMAT, WK_CODMAT, WK_CODCOR, WK_CODTAM, WK_CODMUL);

         -- Se  uma transferncia, insere a TT_TRA
         IF (bEhTransf > 0) AND (WK_SITKIT <> '1') THEN
            INSERT INTO TT_TRA (FILIVE,SEQIVE,NUMIVE,FILMAT,CODMAT,CODCOR,CODTAM)
            VALUES (pCodfil,pSequen,WK_NUMITE,WK_FILMAT,WK_CODMAT,WK_CODCOR,WK_CODTAM);
         END IF;

      END LOOP;
      CLOSE CR_ITEM_VENDA;

      OPEN CR_VENDA_CANCELAR(pCODFIL, pSequen);
         LOOP
            FETCH CR_VENDA_CANCELAR INTO vTipo_Pagamento;
            EXIT WHEN NOT FOUND;

            -- MN - Reverte parcela, para aberto se no havia sido paga, ou para paga se tem data de pagamento preenchida.

            UPDATE TT_REC
               SET FLGEST = CASE WHEN PAGAME IS NULL THEN 'A' ELSE 'P' END,
                   ESTCAN = NULL,
                   DUMMY = '%'
             WHERE CODFIL = pCodfil
               AND SEQUEN = pSequen;


            IF vTipo_Pagamento = 'AVISTA' THEN
               -- MN - Os procedimentos acima so suficientes para venda paga a vista.
               vMensagem := vMensagem || 'Venda  vista descancelada com sucesso.';
            ELSIF vTipo_Pagamento = 'CARTAO' THEN
               -- MN - Reverte cancelamento da parcela do carto para Aberto/Pago conforme estava antes da venda ser cancelada
               UPDATE TT_ITF
                  SET FLGEST = CASE WHEN DATPGT IS NULL THEN 'A' ELSE 'P' END
                WHERE (CODFIL, SEQUEN, NUMITE) IN (SELECT FILITF, SEQITF, ITEITF
                                                     FROM TT_REC REC
                                                    WHERE REC.CODFIL = pCodfil
                                                      AND REC.SEQUEN = pSequen);

               vMensagem := vMensagem || 'Venda com Carto descancelada com sucesso.';
            ELSIF vTipo_Pagamento = 'CHEQUE' THEN
               -- MN - Provavelmente o cheque deve ser quase igual a carto, quando surgir um caso de descancelar uma venda com pagamento em cheque
               -- deve-se verificar como funciona o pagamento/estorno do cheque, como isso  controlado, mas acho que, PROVAVELMENTE, deve-se apenas
               -- fazer upadte no flgest da tabela TT_CHR
               vMensagem := vMensagem || 'Venda NO foi descancelada, pagamento com cheque, verificar cdigo fonte.';
            ELSIF vTipo_Pagamento = 'CC' THEN
               -- MN - O importante desse insert  entender que o objetivo  fazer o lanamento original, ou seja, se foi uma venda, o lanamento original
               -- foi negativo, pois o cliente ficou devendo e tirou saldo da conta, se o lanamento original era uma devoluo, o lanamento  positivo
               -- pois o cliente devolveu mercadoria e recebeu dinheiro de saldo na CC, por isso  utilizado MIN no insert.
               -- Tambm no faz sentido ter mais do que 2 lanamentos referentes a uma nica venda, pois normalmente vai ter 1 lanamento, e se cancelar o 2
               -- No caso, a nica exceo  quando se descancela o cancelamento, da temos que repor o saldo original.
               -- Outro detalhe importante,  observar que  inserido filfat/seqfat NULOS, de propsito, pois a venda j estava includa em um faturamento
               -- ao descancelar, ela tem que ser considerada no prximo faturamento. (No acho que isso vai acontecer, descancelar uma venda nessa situao)
               -- Mas  bom a funo considerar todas as opes
               INSERT INTO TT_CCC (CODFIL, STATUS, CODUSU, FILCLI, FILUSU, CODCLI, DATOPE, TIPCCC,
                                   VLRLAN, NUMPAR, SUBPAR, CODVEN, FILFAT, SEQFAT, SEQVEN, COMPLE, NUMECF,
                                   NUMDOC, OLDSTT, EXPORT, DUMMY,  DATFIS, PORORI, TIPLAN, CHKFAT, ATULIM)
                 SELECT CODFIL, STATUS, CODUSU, FILCLI, FILUSU, CODCLI, AGORA(), TIPCCC,
                        VLRLAN, NUMPAR, SUBPAR, CODVEN, NULL, NULL, SEQVEN, 'Descancelamento de Venda', NUMECF,
                        NUMDOC, OLDSTT, EXPORT, DUMMY,  DATFIS, PORORI, TIPLAN, CHKFAT, ATULIM
                   FROM TT_CCC
                  WHERE (CODFIL, SEQUEN) IN (SELECT CODFIL, MIN(SEQUEN)
                                               FROM TT_CCC
                                              WHERE CODVEN = pCodfil
                                                AND SEQVEN = pSequen
                                              GROUP BY CODFIL);

               vMensagem := vMensagem || 'Venda com conta corrente descancelada com sucesso.';
            END IF;

         -- FIM DO LOOP do cursor de venda
         END LOOP;
      CLOSE CR_VENDA_CANCELAR;

      RETURN vMensagem;
   ELSE
      RETURN 'Venda no est cancelada.';
   END IF;

END;
$$ language 'plpgsql';




/*-- SEQ 0801 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION FechaDia () CASCADE;

/*-- SEQ 0802 --*/
CREATE OR REPLACE FUNCTION FechaDia ()
RETURNS VARCHAR AS $$
DECLARE

   --Fechamento
   crMFEC CURSOR FOR
    SELECT CODFIL, NUMECF, DATOPE
      FROM TM_FEC
     WHERE FLGEST = 'G';

   --Venda
   crMCF CURSOR(pCODFIL TM_FEC.CODFIL%TYPE,
           pNUMECF TM_FEC.NUMECF%TYPE,
           pDATOPE TM_FEC.DATOPE%TYPE) IS
    SELECT MCF.CODFIL, MCF.NUMECF, MCF.NUMCOO, MCF.DATEMI, MCF.NUMCCF, MCF.VLRSUBTOT, MCF.VLRDES, MCF.FLGDES,
           MCF.VLRACR, MCF.FLGACR, MCF.VLRTOT, MCF.FLGCAN, MCF.VLRCANACR, MCF.ORDDESACR, MCF.NOMECLI, MCF.NUMDOC,
           CAST(LPAD(TO_CHAR(MCF.NUMCOO),6,' ') AS VARCHAR(6)) AS NUMNOT
      FROM TT_MCF MCF
     WHERE MCF.CODFIL = pCODFIL
       AND MCF.NUMECF = pNUMECF
       AND MCF.DATEMI = pDATOPE
       AND MCF.FLGEST = 'A';

   crVenda CURSOR(pCODFIL TT_VEN.CODFIL%TYPE,
           pNUMECF TT_VEN.NUMECF%TYPE,
           pNUMNOT TT_VEN.NUMNOT%TYPE) IS
    SELECT VEN.CODFIL, VEN.SEQUEN, VEN.VLRLIQ, VEN.VLRNOT, VEN.FLGEST, VEN.DESRAT, VEN.DESCON,
           VEN.BASICM, VEN.VLRICM
      FROM TT_VEN VEN
     WHERE VEN.CODFIL = pCODFIL
       AND VEN.NUMECF = pNUMECF
       AND VEN.CODSER = 'CF'
       AND VEN.NUMNOT = pNUMNOT;

   --Item Venda
   crICF CURSOR(pCODFIL TT_MCF.CODFIL%TYPE,
           pNUMECF TT_MCF.NUMECF%TYPE,
           pNUMCOO TT_MCF.NUMCOO%TYPE,
           pDATEMI TT_MCF.DATEMI%TYPE) IS
    SELECT TAB.CODFIL, TAB.NUMECF, TAB.NUMCOO, TAB.DATEMI, TAB.NUMITE, TAB.CODITE, TAB.DESMAT, TAB.UNIDAD,
           TAB.VLRDESC, TAB.VLRACRES, TAB.VLRTOT, TAB.CODTOT, TAB.FLGCAN, TAB.QTDCAN, TAB.VLRCAN,
           TAB.VLRCANACR, TAB.ARRTRU, TAB.DECQTD, TAB.DECUNI, TAB.NUMNOT,
           --Formatar Decimais da quantidade e Valor unitário
           CASE WHEN TAB.ARRTRU = 'A' THEN
              ROUND(TAB.QTDITE / POWER(10, TAB.DECUNI), TAB.DECQTD)
           ELSE
              TRUNC(TAB.QTDITE / POWER(10, TAB.DECUNI), TAB.DECQTD)
           END AS QTDITE,
           CASE WHEN TAB.ARRTRU = 'A' THEN
              ROUND(TAB.VLRUNI / POWER(10, TAB.DECUNI), TAB.DECUNI)
           ELSE
              TRUNC(TAB.VLRUNI / POWER(10, TAB.DECUNI), TAB.DECUNI)
           END AS VLRUNI
    FROM (SELECT ICF.CODFIL, ICF.NUMECF, ICF.NUMCOO, ICF.DATEMI, ICF.NUMITE, ICF.CODITE, ICF.DESMAT, ICF.QTDITE, ICF.UNIDAD,
                 ICF.VLRUNI, ICF.VLRDESC, ICF.VLRACRES, ICF.VLRTOT, ICF.CODTOT, ICF.FLGCAN, ICF.QTDCAN, ICF.VLRCAN,
                 ICF.VLRCANACR, ICF.ARRTRU,
                 CAST(LPAD(TO_CHAR(ICF.NUMCOO),6,' ') AS VARCHAR(6)) AS NUMNOT,
                 TO_NUMBER(COALESCE(ICF.DECQTD,'0')) AS DECQTD,
                 TO_NUMBER(COALESCE(ICF.DECUNI,'0')) AS DECUNI
            FROM TT_ICF ICF
           WHERE ICF.CODFIL = pCODFIL
             AND ICF.NUMECF = pNUMECF
             AND ICF.NUMCOO = pNUMCOO
             AND ICF.DATEMI = pDATEMI
             AND ICF.FLGEST = 'A' ) TAB;

   crItemVenda CURSOR(pCODFIL TT_VEN.CODFIL%TYPE,
           pNUMECF TT_VEN.NUMECF%TYPE,
           pNUMNOT TT_VEN.NUMNOT%TYPE,
           pNUMITE TT_IVE.NUMITE%TYPE) IS
        SELECT IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE, IVE.LANEST, IVE.SITMOV, IVE.QTDMOV, IVE.VLRMOV, IVE.VLRDES,
               IVE.VLRUNI, IVE.DATCAN, IVE.ICMTIP, IVE.NATFIS, IVE.CODCST,
               COALESCE(IVE.REDITE,0) AS REDITE, IVE.BASICM, IVE.VLRICM, COALESCE(IVE.TAXICM,0) AS TAXICM,
               IVE.VLR001, IVE.TAX001,
               IVE.MVAVEN, IVE.BASUBS, IVE.SUBSTT, IVE.CALSUB, IVE.ICMINT
          FROM TT_IVE IVE
    INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
         WHERE VEN.CODFIL = pCODFIL
           AND VEN.NUMECF = pNUMECF
           AND VEN.CODSER = 'CF'
           AND VEN.NUMNOT = pNUMNOT
           AND IVE.NUMITE = pNUMITE;

   cMANUT                        TT_IDF.MANUT%TYPE;
   cCRLF                         CHAR(2) := CHR(13)||CHR(10);
   cMsgErro                      VARCHAR(4000) := '';
   cMsgLog                       VARCHAR(4000) := '';
   cLogAltCupom                  VARCHAR(4000) := '';
   cLogIncCupom                  VARCHAR(4000) := '';
   cLogAltItemCupom              VARCHAR(4000) := '';
   cLogIncItemCupom              VARCHAR(4000) := '';
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   nExiste                       Numeric(1);
   cFLGEST                       CHAR(1) := 'P';
      
   rMFEC                         RECORD;
   rMCF                          RECORD;
   rVenda                        RECORD;
   rICF                          RECORD;
   rItemVenda                    RECORD;
      --Utilizado para Validação de Valores
   nVlrVen                       Numeric(18,2);
   nVlrCal                       Numeric(18,2);
   nVlrLiq                       Numeric(18,2);
   --Utilizado para Calculo temporario de valores a serem atualizados.
   nVlrDes                       Numeric(18,2);
   nPerDes                       Numeric(6,4);
   nVlrAcr                       Numeric(18,2);
   nPerAcr                       Numeric(6,4);
   cTAXICM                       VARCHAR(4);
   nTAXICM                       Numeric(12,2);
   rTT_VEN                       TT_VEN%ROWTYPE;
   rTT_IVE                       TT_IVE%ROWTYPE;

-- Início da função
BEGIN
   SELECT MANUT INTO cMANUT FROM TT_IDF;

   IF cMANUT = 'F' THEN
      --Fechamentos(TM_FEC)
      OPEN crMFEC;
      LOOP
         FETCH crMFEC INTO rMFEC;
         EXIT WHEN NOT FOUND;
         ---------------------------------------------------------------------
         -- Item 4.a - Verificar se a soma do valor líquido das TT_MCF - "Cupom Fiscal" fecham com o GT do dia
         ---------------------------------------------------------------------
         /* Verifica as Vendas efetuadas por Cupom Fiscal */
         SELECT COALESCE(SUM(MCF.VLRTOT),0),
                COALESCE(MAX(ECF.GT_FIM - ECF.GT_INI) - MAX(CAN.VLRTOT) - MAX(DES.VLRTOT),0)
          INTO nVlrVen, nVlrCal
          FROM TR_ECF ECF LEFT OUTER JOIN TT_MCF MCF ON ECF.CODFIL = MCF.CODFIL AND ECF.NUMECF = MCF.NUMECF
                                                     AND MCF.NUMCOO BETWEEN ECF.CUPINI AND ECF.CUPFIM
                                                     AND MCF.VLRTOT > 0
                                                     AND MCF.FLGCAN <> 'S'
                               INNER JOIN TT_ECF CAN ON ECF.CODFIL = CAN.CODFIL AND ECF.NUMECF = CAN.NUMECF AND ECF.DATOPE = CAN.DATOPE AND ECF.CNT_RO = CAN.CNT_RO
                               INNER JOIN TT_ECF DES ON ECF.CODFIL = DES.CODFIL AND ECF.NUMECF = DES.NUMECF AND ECF.DATOPE = DES.DATOPE AND ECF.CNT_RO = DES.CNT_RO
         WHERE ECF.CODFIL = rMFEC.CODFIL
           AND ECF.NUMECF = rMFEC.NUMECF
           AND ECF.DATOPE = rMFEC.DATOPE
           AND CAN.TOTALI = 'CANC'
           AND DES.TOTALI = 'DESC';

         IF (Equal(nVlrVen, nVlrCal) = 0) THEN
            cMsgErro := cMsgErro || 'Soma do valor líquido das vendas não confere com os GTs (venda bruta diária - cancelamento - desconto).' || cCRLF ||
                        ' Soma das vendas: ' || TO_CHAR(COALESCE(nVlrVen,0),'fm99G999G999G999G990D00') || '.' || cCRLF ||
                        ' Calc. dos GTs:   ' || TO_CHAR(COALESCE(nVlrCal,0),'fm99G999G999G999G990D00') || '.' || cCRLF ||
                        ' Verifique redução Z no Backoffice em Menu >> Tesouraria >> Caixa >> Redução Z.' || cCRLF;

            RAISE EXCEPTION 'PG-20000 Erros: %' , cMsgErro;
         END IF;
         ---------------------------------------------------------------------

         --Cupom Fiscal(TT_MCF)
         OPEN crMCF(rMFEC.CODFIL, rMFEC.NUMECF, rMFEC.DATOPE);
         LOOP
            FETCH crMCF INTO rMCF;
            EXIT WHEN NOT FOUND;
            cLogIncCupom := '';
            cLogAltCupom := '';
            ---------------------------------------------------------------------
            -- Item 4.b - Verificar se a soma do valor líquido das TT_ICF - "Item do Cupom Fiscal" confere com a TT_MCF - "Cupom Fiscal"
            ---------------------------------------------------------------------
            SELECT COALESCE(SUM(ICF.VLRTOT),0)
              INTO nVlrLiq
             FROM TT_ICF ICF
            WHERE ICF.CODFIL = rMCF.CODFIL
              AND ICF.NUMECF = rMCF.NUMECF
              AND ICF.NUMCOO = rMCF.NUMCOO
              AND ICF.DATEMI = rMCF.DATEMI;

            IF (Equal(rMCF.VLRSUBTOT, nVlrLiq) = 0) THEN
               cMsgErro := cMsgErro || 'Soma do valor líquido dos Itens não confere com a Venda.' || cCRLF ||
                           ' Soma dos Itens: ' || TO_CHAR(COALESCE(nVlrLiq,0),'fm99G999G999G999G990D00') || '.' || cCRLF ||
                           ' Valor da Venda: ' || TO_CHAR(COALESCE(rMCF.VLRSUBTOT,0),'fm99G999G999G999G990D00') || '.' || cCRLF;

               RAISE EXCEPTION 'PG-20000 Erros: %' , cMsgErro;
            END IF;
            ---------------------------------------------------------------------

            --Verifica Existencia do Cupom na (TT_VEN)
            SELECT COUNT(*)
              INTO nEXISTE
              FROM TT_VEN VEN
             WHERE VEN.CODFIL = rMCF.CODFIL
               AND VEN.NUMECF = rMCF.NUMECF
               AND VEN.CODSER = 'CF'
               AND VEN.NUMNOT = rMCF.NUMNOT;
            IF ( nEXISTE = 0 ) THEN
               cLogIncCupom := cLogIncCupom || 'Venda não Encontrado na TT_VEN.' || cCRLF;
            ELSE
               --Item do Cupom(TT_ICF)
               OPEN crICF(rMCF.CODFIL, rMCF.NUMECF, rMCF.NUMCOO, rMCF.DATEMI);
               LOOP
                  FETCH crICF INTO rICF;
                  EXIT WHEN NOT FOUND;
                  cLogIncItemCupom := '';
                  cLogAltItemCupom := '';
                  ---------------------------------------------------------------------
                  -- 4.d - Comparar os dados da TT_ICF com a TT_IVE e alterar todos os campos possíveis da TT_IVE.
                  ---------------------------------------------------------------------
                      SELECT COUNT(*)
                        INTO nEXISTE
                        FROM TT_IVE IVE
                  INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
                       WHERE VEN.CODFIL = rICF.CODFIL
                         AND VEN.NUMECF = rICF.NUMECF
                         AND VEN.CODSER = 'CF'
                         AND VEN.NUMNOT = rICF.NUMNOT
                         AND IVE.NUMITE = rICF.NUMITE;
                  IF ( nEXISTE = 0 ) THEN
                     cLogIncItemCupom := cLogIncItemCupom || 'Item de Venda não Encontrado na TT_IVE.' || cCRLF;
                  ELSE
                     --Item da Venda(TT_IVE)
                     OPEN crItemVenda(rICF.CODFIL, rICF.NUMECF, rICF.NUMNOT, rICF.NUMITE);
                     LOOP
                        FETCH crItemVenda INTO rItemVenda;
                        EXIT WHEN NOT FOUND;
                        rTT_IVE.DUMMY  := 'A';
                        --Define Default para Colunas de Acordo com dados Atuais da TT_IVE
                        rTT_IVE.SITMOV := rItemVenda.SITMOV;
                        rTT_IVE.QTDMOV := rItemVenda.QTDMOV;
                        rTT_IVE.VLRUNI := rItemVenda.VLRUNI;
                        rTT_IVE.VLRDES := rItemVenda.VLRDES;
                        rTT_IVE.VLRMOV := rItemVenda.VLRMOV;
                        rTT_IVE.ICMTIP := rItemVenda.ICMTIP;
                        rTT_IVE.CODCST := rItemVenda.CODCST;
                        rTT_IVE.REDITE := rItemVenda.REDITE;
                        rTT_IVE.BASICM := rItemVenda.BASICM;
                        rTT_IVE.TAXICM := rItemVenda.TAXICM;
                        rTT_IVE.VLRICM := rItemVenda.VLRICM;
                        rTT_IVE.NATFIS := rItemVenda.NATFIS;
                        rTT_IVE.VLR001 := rItemVenda.VLR001;
                        rTT_IVE.TAX001 := rItemVenda.TAX001;
                        rTT_IVE.CALSUB := rItemVenda.CALSUB;
                        rTT_IVE.DATCAN := rItemVenda.DATCAN;

                        --Atualização da TT_ICF para TT_IVE
                        rTT_IVE.QTDMOV := rICF.QTDITE;
                        rTT_IVE.VLRUNI := rICF.VLRUNI;
                        rTT_IVE.VLRMOV := rICF.VLRTOT;

                        IF (rMCF.FLGCAN = 'S') THEN
                           rTT_IVE.SITMOV := 'C';
                        ELSE
                           IF rItemVenda.SITMOV = 'C' THEN
                              cLogIncItemCupom := cLogIncItemCupom || 'Cancelamento não estornado.' || cCRLF;
                           END IF;
                        END IF;

                        rTT_IVE.VLRDES := rICF.VLRACRES - rICF.VLRDESC;
                        --Zera ICMS
                        IF (SUBSTR(rICF.CODTOT,1,1)='F')
                        OR (SUBSTR(rICF.CODTOT,1,1)='I')
                        OR (SUBSTR(rICF.CODTOT,1,1)='N') THEN
                           rTT_IVE.REDITE := 0;
                           rTT_IVE.BASICM := 0;
                           rTT_IVE.VLRICM := 0;
                           rTT_IVE.TAXICM := 0;
                           rTT_IVE.VLR001 := 0;
                           rTT_IVE.TAX001 := 0;
                           rTT_IVE.CALSUB := 'D';
                        END IF;
                        IF SUBSTR(rICF.CODTOT,1,1)='F' THEN
                           rTT_IVE.ICMTIP := '3';--Substituido
                           rTT_IVE.CODCST := SUBSTR(rItemVenda.CODCST,1,1) || '60';
                           rTT_IVE.NATFIS := '540500';
                        ELSIF SUBSTR(rICF.CODTOT,1,1)='I' THEN
                           rTT_IVE.ICMTIP := '2';--Isento
                           rTT_IVE.CODCST := SUBSTR(rItemVenda.CODCST,1,1) || '40';
                           rTT_IVE.NATFIS := '510200';
                        ELSIF SUBSTR(rICF.CODTOT,1,1)='N' THEN
                           rTT_IVE.ICMTIP := '1';--Não Tributado
                           rTT_IVE.CODCST := SUBSTR(rItemVenda.CODCST,1,1) || '41';
                        ELSIF (SUBSTR(rICF.CODTOT,3,1)='T') OR (SUBSTR(rICF.CODTOT,3,1)='S') THEN
                           rTT_IVE.ICMTIP := '0';--Tributado
                           cTAXICM := SUBSTR(rICF.CODTOT,4,4);
                           rTT_IVE.TAXICM := (TO_NUMBER(cTAXICM) / 100);
                           IF ( rItemVenda.TAXICM > 0 ) THEN
                              nTAXICM := rItemVenda.TAXICM - ROUND((rItemVenda.REDITE / rItemVenda.TAXICM) * 100, 2);
                           ELSE
                              nTAXICM := 0;
                           END IF;
                           IF (Equal(rTT_IVE.TAXICM, nTAXICM) = 1) THEN
                              rTT_IVE.TAXICM := rItemVenda.TAXICM;
                           ELSE
                              rTT_IVE.REDITE := 0;
                           END IF;
                           IF (rTT_IVE.REDITE > 0) THEN
                              rTT_IVE.CODCST := SUBSTR(rItemVenda.CODCST,1,1) || '20';
                           ELSE
                              rTT_IVE.CODCST := SUBSTR(rItemVenda.CODCST,1,1) || '00';
                           END IF;
                           rTT_IVE.BASICM := rTT_IVE.VLRMOV - ((rTT_IVE.VLRMOV * rTT_IVE.REDITE) / 100);
                           rTT_IVE.VLRICM := ((rTT_IVE.BASICM * rTT_IVE.TAXICM) / 100);
                           rTT_IVE.NATFIS := '510200';
                           rTT_IVE.VLR001 := rTT_IVE.VLRICM;
                           rTT_IVE.TAX001 := rTT_IVE.TAXICM;
                        END IF;

                        --Atualiza Diferenças
                        IF (Equal(rTT_IVE.SITMOV, rItemVenda.SITMOV) = 0)
                        OR (Equal(rTT_IVE.QTDMOV, rItemVenda.QTDMOV) = 0)
                        OR (Equal(rTT_IVE.VLRUNI, rItemVenda.VLRUNI) = 0)
                        OR (Equal(rTT_IVE.VLRDES, rItemVenda.VLRDES) = 0)
                        OR (Equal(rTT_IVE.VLRMOV, rItemVenda.VLRMOV) = 0)
                        OR (Equal(rTT_IVE.ICMTIP, rItemVenda.ICMTIP) = 0)
                        OR (Equal(rTT_IVE.CODCST, rItemVenda.CODCST) = 0)
                        OR (Equal(rTT_IVE.REDITE, rItemVenda.REDITE) = 0)
                        OR (Equal(rTT_IVE.BASICM, rItemVenda.BASICM) = 0)
                        OR (Equal(rTT_IVE.TAXICM, rItemVenda.TAXICM) = 0)
                        OR (Equal(rTT_IVE.VLRICM, rItemVenda.VLRICM) = 0)
                        OR (Equal(rTT_IVE.NATFIS, rItemVenda.NATFIS) = 0)
                        OR (Equal(rTT_IVE.VLR001, rItemVenda.VLR001) = 0)
                        OR (Equal(rTT_IVE.TAX001, rItemVenda.TAX001) = 0)
                        OR (Equal(rTT_IVE.CALSUB, rItemVenda.CALSUB) = 0) THEN
                           UPDATE TT_IVE SET
                              SITMOV = rTT_IVE.SITMOV,
                              QTDMOV = rTT_IVE.QTDMOV,
                              VLRUNI = rTT_IVE.VLRUNI,
                              VLRDES = rTT_IVE.VLRDES,
                              VLRMOV = rTT_IVE.VLRMOV,
                              ICMTIP = rTT_IVE.ICMTIP,
                              CODCST = rTT_IVE.CODCST,
                              REDITE = rTT_IVE.REDITE,
                              BASICM = rTT_IVE.BASICM,
                              TAXICM = rTT_IVE.TAXICM,
                              VLRICM = rTT_IVE.VLRICM,
                              NATFIS = rTT_IVE.NATFIS,
                              VLR001 = rTT_IVE.VLR001,
                              TAX001 = rTT_IVE.TAX001,
                              CALSUB = rTT_IVE.CALSUB,
                              DATCAN = rTT_IVE.DATCAN,
                              DUMMY  = rTT_IVE.DUMMY
                            WHERE CODFIL = rItemVenda.CODFIL
                              AND SEQUEN = rItemVenda.SEQUEN
                              AND NUMITE = rItemVenda.NUMITE;
                        END IF;
                        --Log de Alterações
                        IF (Equal(rTT_IVE.SITMOV, rItemVenda.SITMOV) = 0) THEN
                           cLogAltItemCupom := cLogAltItemCupom||'Situação: de '||COALESCE(DescricaoDominio('IVE','SITMOV',rItemVenda.SITMOV),cNulo)||' para '||COALESCE(DescricaoDominio('IVE','SITMOV',rTT_IVE.SITMOV),cNulo) || cCRLF;
                        END IF;
                        IF (Equal(rTT_IVE.QTDMOV, rItemVenda.QTDMOV) = 0) THEN
                           cLogAltItemCupom := cLogAltItemCupom||'Quantidade Movimentada: de '||COALESCE(rItemVenda.QTDMOV,iNulo)||' para '||COALESCE(rTT_IVE.QTDMOV,iNulo) || cCRLF;
                        END IF;
                        IF (Equal(rTT_IVE.VLRUNI, rItemVenda.VLRUNI) = 0) THEN
                           cLogAltItemCupom := cLogAltItemCupom||'Valor unitário líquido: de '||COALESCE(rItemVenda.VLRUNI,iNulo)||' para '||COALESCE(rTT_IVE.VLRUNI,iNulo) || cCRLF;
                        END IF;
                        IF (Equal(rTT_IVE.VLRDES, rItemVenda.VLRDES) = 0) THEN
                           cLogAltItemCupom := cLogAltItemCupom||'Valor Desconto: de '||COALESCE(rItemVenda.VLRDES,iNulo)||' para '||COALESCE(rTT_IVE.VLRDES,iNulo) || cCRLF;
                        END IF;
                        IF (Equal(rTT_IVE.VLRMOV, rItemVenda.VLRMOV) = 0) THEN
                           cLogAltItemCupom := cLogAltItemCupom||'Valor Movimentado: de '||COALESCE(rItemVenda.VLRMOV,iNulo)||' para '||COALESCE(rTT_IVE.VLRMOV,iNulo) || cCRLF;
                        END IF;
                        IF (Equal(rTT_IVE.ICMTIP, rItemVenda.ICMTIP) = 0) THEN
                           cLogAltItemCupom := cLogAltItemCupom||'Tipo de Tributação: de '||COALESCE(DescricaoDominio('IVE','ICMTIP',rItemVenda.ICMTIP),cNulo)||' para '||COALESCE(DescricaoDominio('IVE','ICMTIP',rTT_IVE.ICMTIP),cNulo) || cCRLF;
                        END IF;
                        IF (Equal(rTT_IVE.CODCST, rItemVenda.CODCST) = 0) THEN
                           cLogAltItemCupom := cLogAltItemCupom||'CST ICMS: de '||COALESCE(DescricaoDominio('IVE','CODCST',rItemVenda.CODCST),cNulo)||' para '||COALESCE(DescricaoDominio('IVE','CODCST',rTT_IVE.CODCST),cNulo) || cCRLF;
                        END IF;
                        IF (Equal(rTT_IVE.REDITE, rItemVenda.REDITE) = 0) THEN
                           cLogAltItemCupom := cLogAltItemCupom||'Redução Base de ICMS: de '||COALESCE(rItemVenda.REDITE,iNulo)||' para '||COALESCE(rTT_IVE.REDITE,iNulo) || cCRLF;
                        END IF;
                        IF (Equal(rTT_IVE.BASICM, rItemVenda.BASICM) = 0) THEN
                           cLogAltItemCupom := cLogAltItemCupom||'Base de ICMS: de '||COALESCE(rItemVenda.BASICM,iNulo)||' para '||COALESCE(rTT_IVE.BASICM,iNulo) || cCRLF;
                        END IF;
                        IF (Equal(rTT_IVE.TAXICM, rItemVenda.TAXICM) = 0) THEN
                           cLogAltItemCupom := cLogAltItemCupom||'Taxa de ICMS: de '||COALESCE(rItemVenda.TAXICM,iNulo)||' para '||COALESCE(rTT_IVE.TAXICM,iNulo) || cCRLF;
                        END IF;
                        IF (Equal(rTT_IVE.VLRICM, rItemVenda.VLRICM) = 0) THEN
                           cLogAltItemCupom := cLogAltItemCupom||'Valor do ICMS: de '||COALESCE(rItemVenda.VLRICM,iNulo)||' para '||COALESCE(rTT_IVE.VLRICM,iNulo) || cCRLF;
                        END IF;
                        IF (Equal(rTT_IVE.NATFIS, rItemVenda.NATFIS) = 0) THEN
                           cLogAltItemCupom := cLogAltItemCupom||'Natureza fiscal: de '||COALESCE(rItemVenda.NATFIS,cNulo)||' para '||COALESCE(rTT_IVE.NATFIS,cNulo) || cCRLF;
                        END IF;
                        IF (Equal(rTT_IVE.VLR001, rItemVenda.VLR001) = 0) THEN
                           cLogAltItemCupom := cLogAltItemCupom||'Valor de ICMS / ISS: de '||COALESCE(rItemVenda.VLR001,iNulo)||' para '||COALESCE(rTT_IVE.VLR001,iNulo) || cCRLF;
                        END IF;
                        IF (Equal(rTT_IVE.TAX001, rItemVenda.TAX001) = 0) THEN
                           cLogAltItemCupom := cLogAltItemCupom||'Percentual de ICMS / ISS: de '||COALESCE(rItemVenda.TAX001,iNulo)||' para '||COALESCE(rTT_IVE.TAX001,iNulo) || cCRLF;
                        END IF;
                        IF (Equal(rTT_IVE.CALSUB, rItemVenda.CALSUB) = 0) THEN
                           cLogAltItemCupom := cLogAltItemCupom||'Produto Substituído: de '||COALESCE(rItemVenda.CALSUB,cNulo)||' para '||COALESCE(rTT_IVE.CALSUB,cNulo) || cCRLF;
                        END IF;
                     END LOOP;
                     CLOSE crItemVenda;
                     ---------------------------------------------------------------------
                  END IF;
                  ---------------------------------------------------------------------
                  -- 5.b - Atualiza Inconsistências do Item do Cupom Fiscal
                  ---------------------------------------------------------------------
                  cMsgLog := SUBSTR(cLogIncItemCupom || cLogAltItemCupom, 1, 4000);
                  IF ISNOTNULL(cLogIncItemCupom) = 'T' THEN
                     cFLGEST := 'I';
                  ELSIF ISNOTNULL(cLogAltItemCupom) = 'T' THEN
                     cFLGEST := 'C';
                  ELSE
                     cFLGEST := 'P';
                  END IF;
                  UPDATE TT_ICF SET MSGLOG = cMsgLog, FLGEST = cFLGEST
                   WHERE CODFIL = rICF.CODFIL
                     AND NUMECF = rICF.NUMECF
                     AND NUMCOO = rICF.NUMCOO
                     AND NUMITE = rICF.NUMITE
                     AND DATEMI = rICF.DATEMI;
                  ---------------------------------------------------------------------
               END LOOP;
               CLOSE crICF;

               ---------------------------------------------------------------------
               -- Item 4.c - Comparar os dados da TT_MCF com a TT_VEN e alterar todos os campos possíveis da TT_VEN.
               ---------------------------------------------------------------------
               --Venda(TT_VEN)
               OPEN crVenda(rMCF.CODFIL, rMCF.NUMECF, rMCF.NUMNOT);
               LOOP
                  FETCH crVenda INTO rVenda;
                  EXIT WHEN NOT FOUND;
                  --Define Default para Colunas de Acordo com dados Atuais da TT_VEN
                  rTT_VEN.VLRNOT := rVenda.VLRNOT;
                  rTT_VEN.VLRLIQ := rVenda.VLRLIQ;
                  rTT_VEN.BASICM := rVenda.BASICM;
                  rTT_VEN.VLRICM := rVenda.VLRICM;
                  rTT_VEN.DESCON := rVenda.DESCON;
                  rTT_VEN.DESRAT := rVenda.DESRAT;
                  rTT_VEN.FLGEST := rVenda.FLGEST;

                  --Calculo do Desconto
                  IF (rMCF.FLGDES = 'V') THEN
                     nVlrDes := rMCF.VLRDES;
                     nPerDes := ROUND((rMCF.VLRDES / rMCF.VLRSUBTOT) * 100, 2);
                  ELSE
                     nPerDes := rMCF.VLRDES;
                     nVlrDes := ROUND((rMCF.VLRSUBTOT * rMCF.VLRDES) / 100, 2);
                  END IF;
                  IF (rMCF.FLGACR = 'V') THEN
                     nVlrAcr := rMCF.VLRACR;
                     nPerAcr := ROUND((rMCF.VLRACR / rMCF.VLRSUBTOT) * 100, 2);
                  ELSE
                     nPerAcr := rMCF.VLRACR;
                     nVlrAcr := ROUND((rMCF.VLRSUBTOT * rMCF.VLRACR) / 100, 2);
                  END IF;

                  --Atualiza Valores da TT_MCF para TT_VEN
                  rTT_VEN.VLRNOT := rMCF.VLRSUBTOT;
                  rTT_VEN.VLRLIQ := rMCF.VLRTOT;
                  rTT_VEN.DESRAT := nVlrAcr - nVlrDes;
                  rTT_VEN.DESCON := ROUND((rTT_VEN.DESRAT / rTT_VEN.VLRNOT) * 100, 2);
                  IF (rMCF.FLGCAN = 'S') THEN
                     rTT_VEN.FLGEST := 'C';
                  ELSE
                     IF rVenda.FLGEST = 'C' THEN
                        cLogIncCupom := cLogIncCupom || 'Cancelamento não estornado.' || cCRLF;
                     END IF;
                  END IF;

                  SELECT COALESCE(SUM(IVE.BASICM),rVenda.BASICM), COALESCE(SUM(IVE.VLRICM),rVenda.VLRICM)
                    INTO rTT_VEN.BASICM, rTT_VEN.VLRICM
                    FROM TT_IVE IVE
                   WHERE IVE.CODFIL = rVenda.CODFIL
                     AND IVE.SEQUEN = rVenda.SEQUEN
                     AND IVE.SITMOV = 'N'
                     AND IVE.SITKIT IN ('2', '3');

                  --Aplica Diferenças
                  IF (Equal(rTT_VEN.VLRNOT, rVenda.VLRNOT) = 0)
                  OR (Equal(rTT_VEN.VLRLIQ, rVenda.VLRLIQ) = 0)
                  OR (Equal(rTT_VEN.BASICM, rVenda.BASICM) = 0)
                  OR (Equal(rTT_VEN.VLRICM, rVenda.VLRICM) = 0)
                  OR (Equal(rTT_VEN.DESCON, rVenda.DESCON) = 0)
                  OR (Equal(rTT_VEN.DESRAT, rVenda.DESRAT) = 0)
                  OR (Equal(rTT_VEN.FLGEST, rVenda.FLGEST) = 0) THEN
                     UPDATE TT_VEN SET
                        VLRNOT = rTT_VEN.VLRNOT,
                        VLRLIQ = rTT_VEN.VLRLIQ,
                        DESRAT = rTT_VEN.DESRAT,
                        DESCON = rTT_VEN.DESCON,
                        FLGEST = rTT_VEN.FLGEST,
                        BASICM = rTT_VEN.BASICM,
                        VLRICM = rTT_VEN.VLRICM
                      WHERE CODFIL = rVenda.CODFIL
                        AND SEQUEN = rVenda.SEQUEN;
                  END IF;

                  --Log de Alterações
                  IF (Equal(rTT_VEN.VLRNOT, rVenda.VLRNOT) = 0) THEN
                     cLogAltCupom := cLogAltCupom||'Valor da Nota: de '||COALESCE(rVenda.VLRNOT,iNulo)||' para '||COALESCE(rTT_VEN.VLRNOT,iNulo) || cCRLF;
                  END IF;
                  IF (Equal(rTT_VEN.VLRLIQ, rVenda.VLRLIQ) = 0) THEN
                     cLogAltCupom := cLogAltCupom||'Valor Liquido: de '||COALESCE(rVenda.VLRLIQ,iNulo)||' para '||COALESCE(rTT_VEN.VLRLIQ,iNulo) || cCRLF;
                  END IF;
                  IF (Equal(rTT_VEN.BASICM, rVenda.BASICM) = 0) THEN
                     cLogAltCupom := cLogAltCupom||'Base de ICMS: de '||COALESCE(rVenda.BASICM,iNulo)||' para '||COALESCE(rTT_VEN.BASICM,iNulo) || cCRLF;
                  END IF;
                  IF (Equal(rTT_VEN.VLRICM, rVenda.VLRICM) = 0) THEN
                     cLogAltCupom := cLogAltCupom||'Valor de ICMS: de '||COALESCE(rVenda.VLRICM,iNulo)||' para '||COALESCE(rTT_VEN.VLRICM,iNulo) || cCRLF;
                  END IF;
                  IF (Equal(rTT_VEN.DESCON, rVenda.DESCON) = 0) THEN
                     cLogAltCupom := cLogAltCupom||'Desc/Acréscimo (%): de '||COALESCE(rVenda.DESCON,iNulo)||' para '||COALESCE(rTT_VEN.DESCON,iNulo) || cCRLF;
                  END IF;
                  IF (Equal(rTT_VEN.DESRAT, rVenda.DESRAT) = 0) THEN
                     cLogAltCupom := cLogAltCupom||'Desconto Rateado: de '||COALESCE(rVenda.DESRAT,iNulo)||' para '||COALESCE(rTT_VEN.DESRAT,iNulo) || cCRLF;
                  END IF;
                  IF (Equal(rTT_VEN.FLGEST, rVenda.FLGEST) = 0) THEN
                     cLogAltCupom := cLogAltCupom||'Situação: de '||COALESCE(DescricaoDominio('VEN','FLGEST',rVenda.FLGEST),cNulo)||' para '||COALESCE(DescricaoDominio('VEN','FLGEST',rTT_VEN.FLGEST),cNulo) || cCRLF;
                  END IF;
               END LOOP;
               CLOSE crVenda;
               ---------------------------------------------------------------------
            END IF;
            ---------------------------------------------------------------------
            -- 5.a - Atualiza Inconsistências do Cupom Fiscal
            ---------------------------------------------------------------------
            cMsgLog := SUBSTR(cLogIncCupom || cLogAltCupom, 1, 4000);
            IF ISNOTNULL(cLogIncCupom) = 'T' THEN
               cFLGEST := 'I';
            ELSIF ISNOTNULL(cLogAltCupom) = 'T' THEN
               cFLGEST := 'C';
            ELSE
               cFLGEST := 'P';
            END IF;
            UPDATE TT_MCF SET MSGLOG = cMsgLog, FLGEST = cFLGEST
            WHERE CODFIL = rMCF.CODFIL
              AND NUMECF = rMCF.NUMECF
              AND NUMCOO = rMCF.NUMCOO
              AND DATEMI = rMCF.DATEMI;
            ---------------------------------------------------------------------
         END LOOP;
         CLOSE crMCF;

         ---------------------------------------------------------------------
         -- 4.i - Marca Dia como "P" Processado (Vendas atualizadas).
         ---------------------------------------------------------------------
         UPDATE TM_FEC SET FLGEST = 'P'
          WHERE CODFIL = rMFEC.CODFIL
            AND NUMECF = rMFEC.NUMECF
            AND DATOPE = rMFEC.DATOPE;
         ---------------------------------------------------------------------
      END LOOP;
      CLOSE crMFEC;

      RETURN 'OK';
   END IF;
END;
$$ language 'plpgsql';



/*-- SEQ 0803 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_FechaDia (TT_JOB.CODUID%TYPE) CASCADE;

/*-- SEQ 0804 --*/
CREATE OR REPLACE FUNCTION Job_FechaDia (TT_JOB.CODUID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODUID ALIAS FOR $1 ;
-- Objetivos:
-- 1. Executar função relativa e registrar seu resultado na tabela de jobs.

-- Declaração de variáveis e cursores
   cNomjob                       TT_JOB.NOMJOB%TYPE;
   cDesjob                       TT_JOB.DESJOB%TYPE;
   cDummy                        CHAR(2);

-- Início da função
BEGIN
   cNomjob := 'JOB_FECHADIA';
   cDesjob := 'Rotina para atualizar dados fiscais do ECF';
   BEGIN
      cDummy := FechaDia();
      cDummy := RegistraJob(cNomjob, cDesjob, NULL, pCODUID);
   EXCEPTION
      WHEN OTHERS THEN cDummy := RegistraJob(cNomjob, cDesjob, SQLERRM, pCODUID);
   END;
  RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 0805 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_FechaDia () CASCADE;

/*-- SEQ 0806 --*/
CREATE OR REPLACE FUNCTION Job_FechaDia () 
RETURNS VARCHAR AS $$
BEGIN
RETURN Job_FechaDia(NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 0807 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION FluxoMediaPagamentos (TT_VEN.CODFIL%TYPE,TT_PRO.FILMAR%TYPE,TT_PRO.CODMAR%TYPE,TT_PRO.ITEMAR%TYPE,Timestamp,Timestamp) CASCADE;

/*-- SEQ 0808 --*/
CREATE OR REPLACE FUNCTION FluxoMediaPagamentos (TT_VEN.CODFIL%TYPE,TT_PRO.FILMAR%TYPE,TT_PRO.CODMAR%TYPE,TT_PRO.ITEMAR%TYPE,Timestamp,Timestamp)
RETURNS Numeric AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pFILMAR ALIAS FOR $2 ;
pCODMAR ALIAS FOR $3 ;
pITEMAR ALIAS FOR $4 ;
pDatIni ALIAS FOR $5 ;
pDatFim ALIAS FOR $6 ;

-- Objetivos:
-- 1. Calcular mdia de pagamentos a partir de uma data para ser utilizada na projeo do a pagar do fluxo financeiro.

-- Declarao de variveis e cursores
   dIni                          Timestamp;               -- Data inicial do perodo com as horas
   dFim                          Timestamp;               -- Data final do perodo com as horas
   cCODLOJ                       TT_IDF.CODLOJ%TYPE;
   nNumeroDias                   Numeric(5);
   nSoma                         Numeric(12,4);
   nMedia                        Numeric(12,4);

-- Incio da funo
BEGIN

    -- Validao dos parmetros
   IF pCODFIL IS NULL THEN
      RAISE EXCEPTION 'PG-20000 Valor invlido para parmetro "pCODFIL".';
   END IF;

   IF pFILMAR IS NULL THEN
      RAISE EXCEPTION 'PG-20001 Valor invlido para parmetro "pFILMAR".';
   END IF;

   IF pCODMAR IS NULL THEN
      RAISE EXCEPTION 'PG-20002 Valor invlido para parmetro "pCODMAR".';
   END IF;

   IF pITEMAR IS NULL THEN
      RAISE EXCEPTION 'PG-20003 Valor invlido para parmetro "pITEMAR".';
   END IF;

   IF pDatIni IS NULL THEN
      RAISE EXCEPTION 'PG-20004 Valor invlido para parmetro "pDatIni".';
   END IF;

   IF pDatFim IS NULL THEN
      RAISE EXCEPTION 'PG-20005 Valor invlido para parmetro "pDatFim".';
   END IF;

   -- Ajustando o perodo com as horas
   dIni := TRUNC(pDatIni);
   dFim := TO_DATE(TO_CHAR(TRUNC(pDatFim), 'DD/MM/YYYY') || ' 23:59:59', 'DD/MM/YYYY HH24:MI:SS');

   -- Intervalo de dias (dias teis)
   nNumeroDias := DiasUteis(pCODFIL, dIni, dFim, 'T');

   IF nNumeroDias = 0 THEN
      RAISE EXCEPTION 'PG-20006 Intervalo de dias deve ter pelo menos 1 dia.';
   END IF;

   SELECT SUM(TAB.QTDMOV * TAB.VLRCMG)
     INTO nSoma
     FROM (
      SELECT VEN.CODFIL,
             VEN.SEQUEN,
             IVE.NUMITE,
             IVE.FILMAT,
             IVE.CODMAT,
             IVE.CODCOR,
             IVE.CODTAM,
             PRO.FILMAR,
             PRO.CODMAR,
             PRO.ITEMAR,
             VEN.DATFIS,
             IVE.QTDMOV,
             CASE WHEN COALESCE(IVE.VLRCMG,0) = 0
                  THEN COALESCE(CustoMedio(IVE.CODFIL, IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM, 5, TRUNC(IVE.VEN_DATHOR)),0)
                  ELSE IVE.VLRCMG
             END AS VLRCMG
        FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL
                                             AND IVE.SEQUEN = VEN.SEQUEN
                        INNER JOIN TT_PRO PRO ON PRO.FILMAT = IVE.FILMAT
                                             AND PRO.CODMAT = IVE.CODMAT
       WHERE VEN.FLGEST <> 'C'
         AND VEN.NUMNOT NOT LIKE '%#%'
         AND VEN.FINANC = 'T'
         AND VEN.VLRLIQ > 0
         AND IVE.SITMOV = 'N'
         AND IVE.SITKIT IN ('2','3')
         AND VEN.CODFIL = pCODFIL
         AND VEN.DATFIS BETWEEN dIni AND dFim
         AND PRO.FILMAR = pFILMAR
         AND PRO.CODMAR = pCODMAR
         AND PRO.ITEMAR = pITEMAR
   ) TAB;

   IF nSoma > 0 THEN
      nMedia := nSoma / nNumeroDias;
   ELSE
      -- Quando tem mais parcelas de pedidos do que o custo para repor o estoque, ento a mdia  0.
      nMedia := 0;
   END IF;

   RETURN COALESCE(nMedia,0);

END;
$$ language 'plpgsql';




/*-- SEQ 0809 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION FluxoMediaPedidos (TT_VEN.CODFIL%TYPE,TT_PRO.FILMAR%TYPE,TT_PRO.CODMAR%TYPE,TT_PRO.ITEMAR%TYPE,Timestamp,Timestamp) CASCADE;

/*-- SEQ 0810 --*/
CREATE OR REPLACE FUNCTION FluxoMediaPedidos (TT_VEN.CODFIL%TYPE,TT_PRO.FILMAR%TYPE,TT_PRO.CODMAR%TYPE,TT_PRO.ITEMAR%TYPE,Timestamp,Timestamp)
RETURNS Numeric AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pFILMAR ALIAS FOR $2 ;
pCODMAR ALIAS FOR $3 ;
pITEMAR ALIAS FOR $4 ;
pDatIni ALIAS FOR $5 ;
pDatFim ALIAS FOR $6 ;

-- Objetivos:
-- 1. Calcular mdia do valor dos pedidos a partir de uma data para ser utilizada na projeo do a pagar do fluxo financeiro.

-- Declarao de variveis e cursores
   dIni                          Timestamp;               -- Data inicial do perodo com as horas
   dFim                          Timestamp;               -- Data final do perodo com as horas
   cCODLOJ                       TT_IDF.CODLOJ%TYPE;
   nNumeroDias                   Numeric(5);
   nSoma                         Numeric(12,4);
   nMedia                        Numeric(12,4);

-- Incio da funo
BEGIN

    -- Validao dos parmetros
   IF pCODFIL IS NULL THEN
      RAISE EXCEPTION 'PG-20000 Valor invlido para parmetro "pCODFIL".';
   END IF;

   IF pFILMAR IS NULL THEN
      RAISE EXCEPTION 'PG-20001 Valor invlido para parmetro "pFILMAR".';
   END IF;

   IF pCODMAR IS NULL THEN
      RAISE EXCEPTION 'PG-20002 Valor invlido para parmetro "pCODMAR".';
   END IF;

   IF pITEMAR IS NULL THEN
      RAISE EXCEPTION 'PG-20003 Valor invlido para parmetro "pITEMAR".';
   END IF;

   IF pDatIni IS NULL THEN
      RAISE EXCEPTION 'PG-20004 Valor invlido para parmetro "pDatIni".';
   END IF;

   IF pDatFim IS NULL THEN
      RAISE EXCEPTION 'PG-20005 Valor invlido para parmetro "pDatFim".';
   END IF;

   -- Ajustando o perodo com as horas
   dIni := TRUNC(pDatIni);
   dFim := TO_DATE(TO_CHAR(TRUNC(pDatFim), 'DD/MM/YYYY') || ' 23:59:59', 'DD/MM/YYYY HH24:MI:SS');

   -- Intervalo de dias (dias teis)
   nNumeroDias := DiasUteis(pCODFIL, dIni, dFim, 'T');

   IF nNumeroDias = 0 THEN
      RAISE EXCEPTION 'PG-20100 Intervalo de dias deve ter pelo menos 1 dia.';
   END IF;

   SELECT SUM(TAB.PEDIDOS)
     INTO nSoma
     FROM (
         SELECT TAB.CODFIL, TAB.NUMPED, TAB.DATVEN, PRO.FILMAR, PRO.CODMAR, PRO.ITEMAR,
                SUM(IPE.VLRITE*(1+(IPE.IPIITE/100))) / TAB.VLRTOT * TAB.VLRPAR AS PEDIDOS
           FROM (
                  SELECT PED.CODFIL, PED.NUMPED, CPE.DATVEN, CPE.VLRPAR, PED.VLRTOT
                    FROM TT_PED PED INNER JOIN TT_CPE CPE ON CPE.CODFIL = PED.CODFIL
                                                         AND CPE.NUMPED = PED.NUMPED
                   WHERE PED.FLGEST = '2'
                     ) TAB INNER JOIN TT_IPE IPE ON IPE.CODFIL = TAB.CODFIL
                                                AND IPE.NUMPED = TAB.NUMPED
                           INNER JOIN TT_PRO PRO ON PRO.FILMAT = IPE.FILMAT
                                                AND PRO.CODMAT = IPE.CODMAT
          WHERE IPE.FLGEST <> 'C'
            AND TAB.CODFIL = pCODFIL
            AND TAB.DATVEN BETWEEN dIni AND dFim
            AND PRO.FILMAR = pFILMAR
            AND PRO.CODMAR = pCODMAR
            AND PRO.ITEMAR = pITEMAR
          GROUP BY TAB.CODFIL, TAB.NUMPED, TAB.DATVEN, PRO.FILMAR, PRO.CODMAR, PRO.ITEMAR, TAB.VLRTOT, TAB.VLRPAR
   ) TAB;

   IF nSoma > 0 THEN
      nMedia := nSoma / nNumeroDias;
   ELSE
      -- Quando tem mais parcelas de pedidos do que o custo para repor o estoque, ento a mdia  0.
      nMedia := 0;
   END IF;

   RETURN COALESCE(nMedia,0);

END;
$$ language 'plpgsql';




/*-- SEQ 0811 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION FluxoMediaPrazoPagamentos (TT_VEN.CODFIL%TYPE,TT_PRO.FILMAR%TYPE,TT_PRO.CODMAR%TYPE,TT_PRO.ITEMAR%TYPE,Timestamp,Timestamp) CASCADE;

/*-- SEQ 0812 --*/
CREATE OR REPLACE FUNCTION FluxoMediaPrazoPagamentos (TT_VEN.CODFIL%TYPE,TT_PRO.FILMAR%TYPE,TT_PRO.CODMAR%TYPE,TT_PRO.ITEMAR%TYPE,Timestamp,Timestamp)
RETURNS Numeric AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pFILMAR ALIAS FOR $2 ;
pCODMAR ALIAS FOR $3 ;
pITEMAR ALIAS FOR $4 ;
pDatIni ALIAS FOR $5 ;
pDatFim ALIAS FOR $6 ;

-- Objetivos:
-- 1. Calcular prazo mdio dos pagamentos a fornecedores a partir de uma data para ser utilizada na projeo do a pagar do fluxo financeiro.
-- 2. Resultado  apresentado na forma de nmero de parcelas com intervalo de 30 dias.

-- Declarao de variveis e cursores
   dIni                          Timestamp;               -- Data inicial do perodo com as horas
   dFim                          Timestamp;               -- Data final do perodo com as horas
   cCODLOJ                       TT_IDF.CODLOJ%TYPE;
   nNumeroDias                   Numeric(5);
   nDias                         Numeric(12,4);
   nMedia                        Numeric(2);

-- Incio da funo
BEGIN

    -- Validao dos parmetros
   IF pCODFIL IS NULL THEN
      RAISE EXCEPTION 'PG-20000 Valor invlido para parmetro "pCODFIL".';
   END IF;

   IF pFILMAR IS NULL THEN
      RAISE EXCEPTION 'PG-20001 Valor invlido para parmetro "pFILMAR".';
   END IF;

   IF pCODMAR IS NULL THEN
      RAISE EXCEPTION 'PG-20002 Valor invlido para parmetro "pCODMAR".';
   END IF;

   IF pITEMAR IS NULL THEN
      RAISE EXCEPTION 'PG-20003 Valor invlido para parmetro "pITEMAR".';
   END IF;

   IF pDatIni IS NULL THEN
      RAISE EXCEPTION 'PG-20004 Valor invlido para parmetro "pDatIni".';
   END IF;

   IF pDatFim IS NULL THEN
      RAISE EXCEPTION 'PG-20005 Valor invlido para parmetro "pDatFim".';
   END IF;

   -- Ajustando o perodo com as horas
   dIni := TRUNC(pDatIni);
   dFim := TO_DATE(TO_CHAR(TRUNC(pDatFim), 'DD/MM/YYYY') || ' 23:59:59', 'DD/MM/YYYY HH24:MI:SS');

   -- Intervalo de dias (dias teis)
   nNumeroDias := DiasUteis(pCODFIL, dIni, dFim, 'T');

   IF nNumeroDias = 0 THEN
      RAISE EXCEPTION 'PG-20006 Intervalo de dias deve ter pelo menos 1 dia.';
   END IF;

   SELECT ROUND(AVG(IntervaloDias(COALESCE(TAB.MAX_DATVEN,TAB.DATOPE), TAB.DATOPE)),2) AS DIAS
     INTO nDias
     FROM (
         SELECT COM.CODFIL, COM.SEQUEN, TRUNC(COM.DATOPE) AS DATOPE,
                (SELECT MAX(PAG.DATVEN)
                   FROM TT_PAG PAG
                  WHERE PAG.CODFIL = COM.CODFIL
                    AND PAG.SEQUEN = COM.SEQUEN
                    AND PAG.SUBPAR = ' 0') AS MAX_DATVEN
           FROM TT_COM COM
          WHERE COM.FLGEST <> 'D'
            AND COM.CODFIL = pCODFIL
            AND COM.DATOPE BETWEEN dIni AND dFim
          GROUP BY COM.CODFIL, COM.SEQUEN, COM.DATOPE
    ) TAB INNER JOIN TT_ICO ICO ON ICO.CODFIL = TAB.CODFIL
                               AND ICO.SEQUEN = TAB.SEQUEN
          INNER JOIN TT_PRO PRO ON PRO.FILMAT = ICO.FILMAT
                               AND PRO.CODMAT = ICO.CODMAT
    WHERE PRO.FILMAR = pFILMAR
      AND PRO.CODMAR = pCODMAR
      AND PRO.ITEMAR = pITEMAR
    GROUP BY TAB.CODFIL, PRO.FILMAR, PRO.CODMAR;

   IF COALESCE(nDias,0) > 30 THEN
      nMedia := ROUND(nDias / 30); -- 30 Dias
   ELSE
      nMedia := 1;
   END IF;

   RETURN nMedia;

END;
$$ language 'plpgsql';




/*-- SEQ 0813 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION FluxoMediaRecebimentos (TT_VEN.CODFIL%TYPE,TT_VEN.FILPGT%TYPE,TT_VEN.CODPGT%TYPE,Timestamp,Timestamp) CASCADE;

/*-- SEQ 0814 --*/
CREATE OR REPLACE FUNCTION FluxoMediaRecebimentos (TT_VEN.CODFIL%TYPE,TT_VEN.FILPGT%TYPE,TT_VEN.CODPGT%TYPE,Timestamp,Timestamp)
RETURNS Numeric AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pFILPGT ALIAS FOR $2 ;
pCODPGT ALIAS FOR $3 ;
pDatIni ALIAS FOR $4 ;
pDatFim ALIAS FOR $5 ;

-- Objetivos:
-- 1. Calcular mdia de recebimentos a partir de uma data para ser utilizada na projeo do a receber do fluxo financeiro.

-- Declarao de variveis e cursores
   dIni                          Timestamp;               -- Data inicial do perodo com as horas
   dFim                          Timestamp;               -- Data final do perodo com as horas
   cCODLOJ                       TT_IDF.CODLOJ%TYPE;
   nNumeroDias                   Numeric(5);
   nSoma                         Numeric(12,4);
   nMedia                        Numeric(12,4);

-- Incio da funo
BEGIN

    -- Validao dos parmetros
   IF pCODFIL IS NULL THEN
      RAISE EXCEPTION 'PG-20000 Valor invlido para parmetro "pCODFIL".';
   END IF;

   IF pFILPGT IS NULL THEN
      RAISE EXCEPTION 'PG-20001 Valor invlido para parmetro "pFILPGT".';
   END IF;

   IF pCODPGT IS NULL THEN
      RAISE EXCEPTION 'PG-20002 Valor invlido para parmetro "pCODPGT".';
   END IF;

   IF pDatIni IS NULL THEN
      RAISE EXCEPTION 'PG-20003 Valor invlido para parmetro "pDatIni".';
   END IF;

   IF pDatFim IS NULL THEN
      RAISE EXCEPTION 'PG-20004 Valor invlido para parmetro "pDatFim".';
   END IF;

   -- Ajustando o perodo com as horas
   dIni := TRUNC(pDatIni);
   dFim := TO_DATE(TO_CHAR(TRUNC(pDatFim), 'DD/MM/YYYY') || ' 23:59:59', 'DD/MM/YYYY HH24:MI:SS');

   -- Buscando o codigo da loja
   IF pCODFIL IS NULL THEN
      SELECT CODLOJ
        INTO cCODLOJ
        FROM TT_IDF;
   END IF;

   -- dias uteis
   nNumeroDias := DiasUteis(COALESCE(pCODFIL, cCODLOJ), dIni, dFim, 'T');

   IF nNumeroDias = 0 THEN
      RAISE EXCEPTION 'PG-20005 Intervalo de dias deve ter pelo menos 1 dia.';
   END IF;

   SELECT SUM(VEN.VLRLIQ)
     INTO nSoma
     FROM TT_VEN VEN
    WHERE VEN.CODFIL = pCODFIL
      AND VEN.FILPGT = pFILPGT
      AND VEN.CODPGT = pCODPGT
      AND VEN.DATFIS BETWEEN dIni AND dFim
      AND VEN.FLGEST <> 'C'
      AND VEN.NUMNOT NOT LIKE '%#%'
      AND VEN.FINANC = 'T'
      AND VEN.VLRLIQ > 0;

   nMedia := nSoma / nNumeroDias;

   RETURN COALESCE(nMedia,0);

END;
$$ language 'plpgsql';




/*-- SEQ 0815 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ReabreChamados () CASCADE;

/*-- SEQ 0816 --*/
CREATE OR REPLACE FUNCTION ReabreChamados ()
RETURNS VARCHAR AS $$
DECLARE

  -- Procedimento para reabrir chamados com tarefas em aberto

  cTEMP VARCHAR(1);

BEGIN
  -- Garantia de exclusividade no processo seguinte
  SELECT LOCK_C INTO cTEMP
  FROM TT_IDF
  FOR UPDATE;

  RETURN 'OK';

  UPDATE TT_SUP SET SITUAC = 'A'
  WHERE (CODFIL,SEQUEN) IN
  (SELECT SUP.CODFIL,SUP.SEQUEN
     FROM TT_SUP SUP INNER JOIN TT_SUPxWOR SxW ON SxW.FILSUP = SUP.CODFIL
                                              AND SxW.SEQSUP = SUP.SEQUEN
                     INNER JOIN TT_WOR     WOR ON WOR.CODFIL = SxW.FILWOR
                                              AND WOR.SEQUEN = SxW.SEQWOR
                     INNER JOIN TD_SIT    DSIT ON WOR.FLGSIT = DSIT.CODTAB
                                              AND DSIT.TIPSIT = 'A'
    WHERE SUP.SITUAC IN ('C','R'));

END;
$$ language 'plpgsql';





/*-- SEQ 0817 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AceiteAutomatico () CASCADE;

/*-- SEQ 0818 --*/
CREATE OR REPLACE FUNCTION AceiteAutomatico ()
RETURNS VARCHAR AS $$
DECLARE

  iDiasAceite INTEGER;
BEGIN
  SELECT COALESCE(DIAS_ACEITE_AUTOMATICO,0) INTO iDiasAceite FROM TT_CFG;

  IF iDiasAceite > 0 THEN
    UPDATE TT_SUP
       SET FILACT = NULL,
           CODACT = NULL,
           NUMACT = NULL,
           DATACT = Agora(),
           TIPACT = 'A',
           FLGACT = 'T'
     WHERE SITUAC = 'R'
       AND COALESCE(FLGACT,'F') <> 'T'
       AND ADD_DAY(DATFEC,iDiasAceite) < AGORA();
  END IF;

  RETURN 'OK';
END;
$$ language 'plpgsql';





/*-- SEQ 0819 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Adiciona_TT_DAT (Timestamp,Timestamp) CASCADE;

/*-- SEQ 0820 --*/
CREATE OR REPLACE FUNCTION Adiciona_TT_DAT (Timestamp,Timestamp)
RETURNS Numeric AS $$
DECLARE
pDATINI ALIAS FOR $1 ;
pDATFIM ALIAS FOR $2 ;
 I      Numeric;
 EXISTE INTEGER;
 DIAS   Numeric;
 DATINI Timestamp;
 DATFIM Timestamp;
 QUANDO Timestamp;
 
 nQtd integer;

 DIA CURSOR(pDIA TT_DAT.DATOPE%TYPE) IS
   select count(*) from tt_dat where DATOPE between to_date(to_char(trunc(pDia),'DD/MM/YYYY')||' 00:00:00','DD/MM/YYYY HH24:MI:SS')
                                                and to_date(to_char(trunc(pDia),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');

BEGIN
  DATFIM := TRUNC(GREATEST( coalesce(pDATINI,AGORA()), coalesce(pDATFIM,AGORA()) ));
  DATINI := TRUNC(  LEAST( coalesce(pDATINI,AGORA()), coalesce(pDATFIM,AGORA()) ));
  DIAS   := TRUNC(DATFIM) - TRUNC(DATINI);
  FOR I IN 0..DIAS LOOP
    Open Dia(ADD_DAY(DATINI,I));
    Fetch Dia into Existe;  
    Close Dia;
    IF Existe = 0 THEN
      QUANDO := TRUNC(ADD_DAY(DATINI,I));
      
      SELECT COUNT(*) 
        INTO nQtd
        FROM TT_DAT
       WHERE DATOPE = QUANDO;
      
      if nQtd = 0 then
        INSERT INTO TT_DAT (DATOPE) VALUES (QUANDO);
       end if;
    END IF;
  END LOOP;
  RETURN DIAS;
END;
$$ language 'plpgsql';




/*-- SEQ 0821 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ATUALIZARECEITABRUTA (TD_FIL.CGCFIL%TYPE) CASCADE;

/*-- SEQ 0822 --*/
CREATE OR REPLACE FUNCTION ATUALIZARECEITABRUTA (TD_FIL.CGCFIL%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCGCFIL ALIAS FOR $1 ;
  iMes INTEGER;
  iCount INTEGER;
  iMes_REF INTEGER;
  iAno_REF INTEGER;
  iDiferencaMeses INTEGER;
  
  WK_isLeap CHAR(1);
  
  nVLRLIQ Numeric;  
   
  WK_DFIL_DATSIM TD_FIL.DATSIM%TYPE;
  WK_IDF_CODLOJ TT_IDF.CODLOJ%TYPE;
BEGIN
   WK_DFIL_DATSIM := DataEntradaSimples(pCGCFIL);
   
  -- SE WK_DFIL_DATSIM  NULO ento pega ultimos 12 meses, ou se a data for maior que 1 ano, pega somente ultimos 12 meses
  IF (WK_DFIL_DATSIM IS NULL) OR (WK_DFIL_DATSIM < ADD_DAY(AGORA(), -365)) THEN
    
    -- Tratamento para ano bissexto
    WK_IsLeap := ISLEAP(TO_NUMBER(TO_CHAR(AGORA(), 'YYYY')));
	IF WK_IsLeap = 'T' THEN
	  WK_DFIL_DATSIM := TRUNC(ADD_DAY(AGORA(), - 366));
	ELSE
      WK_DFIL_DATSIM := TRUNC(ADD_DAY(AGORA(), - 365));
	END IF;
    
  ELSE
    WK_DFIL_DATSIM := TRUNC(WK_DFIL_DATSIM);    
  END IF;	
   
  iDiferencaMeses := CEIL(Months_Between( TO_DATE('01' || LPAD(TO_CHAR(AGORA(),'MM'), 2, '0')||TO_CHAR(AGORA(),'YYYY'), 'DDMMYYYY'),
                                          TO_DATE('01' || LPAD(TO_CHAR(WK_DFIL_DATSIM,'MM'), 2, '0')||TO_CHAR(WK_DFIL_DATSIM,'YYYY'), 'DDMMYYYY') -- TRAZ MMYYYY
                                        )
                         );
  
  iMes_REF := TO_NUMBER(TO_CHAR(WK_DFIL_DATSIM, 'MM'));
  iAno_REF := TO_NUMBER(TO_CHAR(WK_DFIL_DATSIM, 'YYYY'));
  
  -- Obtm Filial a ser inserida
  SELECT CODLOJ INTO WK_IDF_CODLOJ
    FROM TT_IDF;
  
  FOR iMes IN 1..iDiferencaMeses LOOP
    -- Obtm a receita bruta do ms   
    SELECT SUM(VLRLIQ) INTO nVLRLIQ
      FROM TT_VEN VEN INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
                      INNER JOIN TD_FIL FIL ON FIL.CODFIL = VEN.CODFIL
     WHERE VEN.TRIBUT = 'T'
       AND VEN.LANVEN = 'T'
       AND TO_CHAR(VEN.DATFIS, 'MMYYYY') = lpad(iMes_REF, 2, '0')||iAno_REF
       AND VEN.FLGEST <> 'C'
       AND NAT.TIPNAT IN ('V', 'F', 'D', 'M')
       AND NOT EXISTS (SELECT 1 AS OK
                         FROM TT_TRA TRA
                        WHERE TRA.FILIVE = VEN.CODFIL
                          AND TRA.SEQIVE = VEN.SEQUEN
                      )
       AND SUBSTR(FIL.CGCFIL, 1, 8) = pCGCFIL;

    -- Garante que sempre haver valor no vlrliq
    IF nVLRLIQ IS NULL THEN
      nVLRLIQ := 0;
    END IF;
	
    -- Verifica se deve inserir ou atualizar o registro na TT_BRU
    SELECT COUNT(*) INTO iCOUNT
	  FROM TT_BRU BRU
	 WHERE BRU.MESREF = iMes_REF	
	   AND BRU.ANOREF = iAno_REF
       AND BRU.NUMDOC = TO_NUMBER(pCGCFIL);   
   
    -- Se existir registro atualiza, seno insere novo registro na TT_BRU   
	IF iCOUNT > 0 THEN
	  UPDATE TT_BRU 
	     SET VLRBRU = nVLRLIQ
	   WHERE MESREF = iMes_REF	
	     AND ANOREF = iAno_REF
         AND NUMDOC = TO_NUMBER(pCGCFIL);
	ELSE
	  INSERT INTO TT_BRU(CODFIL, ANOREF, MESREF, VLRBRU, VLRINF, APROVA, NUMDOC) VALUES
	                    (WK_IDF_CODLOJ, iAno_REF, iMes_REF, nVLRLIQ, 0, 'F', TO_NUMBER(pCGCFIL));
	END IF;
	    
	-- Verifica se deve alterar o ano ou apenas incrementar o ms
	IF iMES_REF = 12 THEN
	  iMes_Ref := 1;
	  iAno_REF := iAno_REF + 1;
	ELSE
	  iMes_Ref := iMes_Ref + 1;
	END IF;
  END LOOP;
						
  RETURN 'OK';
END;
$$ language 'plpgsql';




/*-- SEQ 0823 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AtualizaFinanceiro (TL_FIN.ORIGEM%TYPE,TL_FIN.FILORI%TYPE,TL_FIN.SEQORI%TYPE) CASCADE;

/*-- SEQ 0824 --*/
CREATE OR REPLACE FUNCTION AtualizaFinanceiro (TL_FIN.ORIGEM%TYPE,TL_FIN.FILORI%TYPE,TL_FIN.SEQORI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pTABORI ALIAS FOR $1 ;
pFILORI ALIAS FOR $2 ;
pSEQORI ALIAS FOR $3 ;

CR_Origens CURSOR FOR
    SELECT DISTINCT ORIGEM
      FROM TL_FIN
     WHERE FLGEST = 'P';

cr_lancamentos CURSOR(pOrigem TL_FIN.ORIGEM%TYPE) IS
    SELECT filori, seqori, parori, subori
      FROM TL_FIN
     where flgest='P'
       and origem=pOrigem;

  cFilOri      TL_FIN.FILORI%TYPE;
  cSeqOri      TL_FIN.SEQORI%TYPE;
  cParOri      TL_FIN.PARORI%TYPE;
  cSubOri      TL_FIN.SUBORI%TYPE;

  cOrigem      TL_FIN.ORIGEM%TYPE;
  cCOMANDO     VARCHAR(4000);
  cDUMMY       VARCHAR(10);
  cTabelaFin   VARCHAR(11);
  cMANUT       VARCHAR(1);
  nInicial     Numeric;
  nRestantes   Numeric;
  nProcessados Numeric;
  MAX_REG      Numeric := 500;

BEGIN

  RAISE NOTICE '**** INICIO ****';
  SELECT MANUT INTO cMANUT
    FROM TT_IDF;

  IF cMANUT = 'F' THEN

    IF pTABORI IS NOT NULL THEN
      nInicial := 1;
    ELSE
      SELECT COUNT(*)
        INTO nInicial
        FROM TL_FIN
       WHERE FLGEST = 'N';
    END IF;

    nProcessados := 0;
    LOOP
        -- Para o caso de aparecem novas TL_FINs enquanto processa.
        EXIT WHEN nProcessados >= nInicial;

        -- No precisa repetir o SELECT na primeira vez
        IF nProcessados = 0 THEN
            IF nInicial >= MAX_REG THEN
              nRestantes := MAX_REG;
            ELSE
              nRestantes := nInicial;
            END IF;
        ELSE
          SELECT COUNT(*)
            INTO nRestantes
            FROM TL_FIN
           WHERE FLGEST = 'N'
           LIMIT MAX_REG;
        END IF;

        RAISE NOTICE 'REGISTROS PROCESSADOS=% RESTANTES=% TOTAL=%' , nProcessados,nRestantes,nInicial;

        -- Para o caso de sumirem TL_FINs enquanto processa.
        EXIT WHEN nRestantes = 0;

        RAISE NOTICE 'UPDATE FLGEST PARA P';
        IF pTABORI IS NOT NULL THEN
            UPDATE TL_FIN
               SET FLGEST='P'
             WHERE FLGEST='N'
               AND ORIGEM=pTABORI
               AND FILORI=pFILORI
               AND SEQORI=pSEQORI;
            nProcessados := nProcessados + 1;
        ELSE
            -- Coloca em processamento
            UPDATE TL_FIN LFIN
               SET FLGEST='P'
             WHERE LFIN.FLGEST='N'
               AND (LFIN.ORIGEM, LFIN.FILORI, LFIN.SEQORI, LFIN.PARORI, LFIN.SUBORI) IN (
                   SELECT LFIN2.ORIGEM, LFIN2.FILORI, LFIN2.SEQORI, LFIN2.PARORI, LFIN2.SUBORI
                     FROM TL_FIN LFIN2
                    WHERE LFIN2.FLGEST='N'
                     LIMIT MAX_REG
                    );

            IF nRestantes >= MAX_REG THEN
              nProcessados := nProcessados + MAX_REG;
            ELSE
              nProcessados := nProcessados + nRestantes;
            END IF;
        END IF;

        -- RFMP - Situao vai ser corrigida na tarefa 84489. Ser retirado quando tarefa estiver pronta - Incio
        delete
          from tt_ope ope
         where (ope.codfil, ope.numecf, ope.trn_id) in
         (select sub.codfil, sub.numecf, sub.trn_id
            from tl_fin fin inner join tt_ope sub on sub.filchr = fin.filori
                                                 and sub.seqchr = fin.seqori
           where fin.origem = 'CHR'
             and fin.flgest = 'P')
           and (select count(*)
                  from tt_ope val
                 where val.codfil = ope.codfil
                   and val.numecf = ope.numecf
                   and val.trn_id = ope.trn_id) = 4
           and (select count(*)
                  from tt_ope val
                 where val.codfil = ope.codfil
                   and val.numecf = ope.numecf
                   and val.trn_id = ope.trn_id
                   and val.filchr is not null) = 2
           and (select count(*)
                  from tt_ope val
                 where val.codfil = ope.codfil
                   and val.numecf = ope.numecf
                   and val.trn_id = ope.trn_id
                   and val.cambio is not null
                   and val.meipgt = 'T') = 1
           and ((ope.numite = 2 and ope.vlrope < 0 and ope.cambio is not null and ope.meipgt = 'T') or
                (ope.numite = 3 and ope.vlrope > 0 and ope.filchr is not null and ope.meipgt = 'F'));
        -- RFMP - Situao vai ser corrigida na tarefa 84489. Ser retirado quando tarefa estiver pronta - Fim

        -- DN 59077 - Exclui duplicados
        RAISE NOTICE 'Excluindo registros duplicados na TL_FIN';
        DELETE FROM TL_FIN
         WHERE (FIN_ID) IN (
         select LFIN.FIN_ID
           from tl_fin LFIN inner join (SELECT FIN.ORIGEM, FIN.FILORI, FIN.SEQORI, FIN.PARORI, MAX(FIN_ID) AS FIN_ID
                                          FROM TL_FIN FIN
                                         WHERE FIN.FLGEST = 'P'
                                           AND FIN.ORIGEM IS NOT NULL
                                         GROUP BY FIN.ORIGEM, FIN.FILORI, FIN.SEQORI, FIN.PARORI
                                        HAVING COUNT(*) > 1
                                        ) DUP ON LFIN.ORIGEM=DUP.ORIGEM
                                             AND LFIN.FILORI=DUP.FILORI
                                             AND LFIN.SEQORI=DUP.SEQORI
                                             AND LFIN.PARORI=DUP.PARORI
                                             AND LFIN.FIN_ID<>DUP.FIN_ID
         WHERE LFIN.FLGEST='P'
         );

        RAISE NOTICE 'Tratamento TDs e TT_CFG';
        -- Tratamento TDs e TT_CFG
                
        UPDATE TR_FIN
           SET FILCTA=LFIN.FILCTA,
               SEQCTA=LFIN.SEQCTA,
               TIPCTA=LFIN.TIPCTA,
               ATU_EM=Agora()
          FROM TL_FIN LFIN
         WHERE LFIN.CODTAB=TR_FIN.CODCTA
           AND LFIN.DESTIN=TR_FIN.ORICTA
           AND LFIN.ORIGEM IS NULL
           AND FLGEST='P';

        UPDATE TR_FIN
           SET FILCRT=LFIN.FILCTA,
               SEQCRT=LFIN.SEQCTA,
               TIPCRT=LFIN.TIPCTA,
               ATU_EM=Agora()
          FROM TL_FIN LFIN
         WHERE LFIN.CODTAB=TR_FIN.CODCRT
           AND LFIN.DESTIN=TR_FIN.ORICRT
           AND LFIN.ORIGEM IS NULL
           AND FLGEST='P';

        UPDATE TR_FIN
           SET FILCLI=LFIN.FILCLI,
               CODCLI=LFIN.CODCLI,
               ATU_EM=Agora()
          FROM TL_FIN LFIN
         WHERE LFIN.ORIGEM=TR_FIN.ORIGEM
           AND LFIN.FILORI=TR_FIN.CODFIL
           AND LFIN.SEQORI=TR_FIN.SEQUEN
           AND LFIN.FILCLI IS NOT NULL
           AND FLGEST='P';

        
        RAISE NOTICE 'Atualiza_CTA_FIN(-1)';
        cDUMMY := Atualiza_CTA_FIN(-1);

        RAISE NOTICE 'CR_Origens';
        OPEN CR_Origens;
        LOOP
          FETCH CR_Origens INTO cOrigem;
          EXIT WHEN NOT FOUND;

          RAISE NOTICE 'DELETE TR_FIN';
          -- Excluir Antigos
          DELETE FROM TR_FIN
           WHERE (ORIGEM, CODFIL, SEQUEN, NUMPAR) IN
                 (SELECT ORIGEM, FILORI, SEQORI, PARORI
                    FROM TL_FIN
                   WHERE FLGEST = 'P'
                     AND ORIGEM = cOrigem);

          RAISE NOTICE 'CR_Lancamentos(%)' , cORIGEM;
          OPEN CR_Lancamentos(cOrigem);
          LOOP
            FETCH CR_Lancamentos INTO cFilOri, cSeqOri, cParOri, cSubOri;
            EXIT WHEN NOT FOUND;

            IF cOrigem <> 'REC' OR cPARORI <> '--' THEN

                  -- Incluir Novos
                  RAISE NOTICE 'INSERT INTO TR_FIN % % % % %' , cOrigem,cFilOri,cSeqOri,cParOri,cSubOri;
                  cComando := 'INSERT INTO TR_FIN                                                                        '||
                              '(ORIGEM, CODFIL, SEQUEN, NUMPAR, SUBPAR, DATLAN, VLRLAN, VLRCRT,                          '||
                              ' FILCLI, CODCLI, FLGFLX, TIPLAN, FILCTA, SEQCTA, TIPCTA, ORICTA,                          '||
                              ' CODCTA, FILCRT, SEQCRT, TIPCRT, ORICRT, CODCRT, FILUSU, CODUSU, FILORI, FILDES,          '||
                              ' ATU_EM, DATINCORI )                                                                      '||
                              '      (SELECT RFIN.ORIGEM, RFIN.CODFIL, RFIN.SEQUEN, RFIN.NUMPAR, RFIN.SUBPAR, TRUNC(RFIN.DATLAN), RFIN.VLRLAN, RFIN.VLRCRT,      '||
                              '              RFIN.FILCLI, RFIN.CODCLI, RFIN.FLGFLX, RFIN.TIPLAN, RFIN.FILCTA, RFIN.SEQCTA, RFIN.TIPCTA, RFIN.ORICTA,             '||
                              '              RFIN.CODCTA, RFIN.FILCRT, RFIN.SEQCRT, RFIN.TIPCRT, RFIN.ORICRT, RFIN.CODCRT, RFIN.FILUSU, RFIN.CODUSU,             '||
                              '              COALESCE((SELECT ORI.FILNUM FROM TT_CTA ORI WHERE ORI.CODFIL=RFIN.FILCTA AND ORI.SEQUEN=RFIN.SEQCTA AND ORI.TIPCTA=RFIN.TIPCTA),RFIN.FILORI) AS FILORI, '||
                              '              COALESCE((SELECT DES.FILNUM FROM TT_CTA DES WHERE DES.CODFIL=RFIN.FILCRT AND DES.SEQUEN=RFIN.SEQCRT AND DES.TIPCTA=RFIN.TIPCRT),RFIN.FILDES) AS FILDES, '||
                              '              RFIN.ATU_EM, RFIN.DATINCORI                                                 '||
                              '         FROM TV_RFIN_'||cOrigem||' RFIN '||
                              '         WHERE RFIN.CODFIL = '||CHR(39)||cFilOri||CHR(39)||
                              '           AND RFIN.SEQUEN = '||CHR(39)||cSeqOri||CHR(39)||
                              '           AND RFIN.NUMPAR = '||CHR(39)||cParOri||CHR(39)||
                              '           AND RFIN.TIPLAN<>'||CHR(39)||'NAO'||CHR(39)||
                              '           AND RFIN.VLRLAN<>0'||
                              '           AND RFIN.FILCRT IS NOT NULL'||
                              '      )';
                                    
                    EXECUTE cCOMANDO;
                  
                  -- RFMP 87304
                  -- ERROR:  failed to find unique expression in subplan tlist
                  -- Foram includos os CASTs no subselect da inconsistncia C para evitar erro que ocorre no PostgreSQL 8.2 e em tese foi corrigido na verso 8.3

                  -- Lanamento sem a conta de contrapartida
                  IF cOrigem <> 'EST' THEN
                    RAISE NOTICE 'INCONSISTNCIA C';
                    cComando := 'UPDATE TL_FIN '||
                                'SET FLGEST='||CHR(39)||'I'||CHR(39)||
                                '  , MOTINC='||CHR(39)||'C'||CHR(39)||
                                ' WHERE (ORIGEM,FILORI,SEQORI,PARORI) IN '||
                                '      (SELECT RFIN.ORIGEM, CAST(RFIN.CODFIL AS CHAR(3)), CAST(RFIN.SEQUEN AS CHAR(10)), CAST(RFIN.NUMPAR AS CHAR(2)) '||
                                '         FROM TV_RFIN_'||cOrigem||' RFIN '||
                                '         WHERE rfin.CODFIL = '||CHR(39)||cFilOri||CHR(39)||
                                '           AND rfin.SEQUEN = '||CHR(39)||cSeqOri||CHR(39)||
                                '           AND rfin.NUMPAR = '||CHR(39)||cParOri||CHR(39)||
                                '           AND RFIN.TIPLAN<>'||CHR(39)||'NAO'||CHR(39)||
                                '           AND RFIN.VLRLAN<>0'||
                                '           AND RFIN.FILCRT IS NULL'||
                                '      )';

                                        
                      EXECUTE cCOMANDO;
                                      END IF;
            END IF;
          END LOOP;
          CLOSE CR_Lancamentos;

        END LOOP;
        CLOSE CR_Origens;

        RAISE NOTICE 'Atualiza_CTA_FIN(1)';
        cDUMMY := Atualiza_CTA_FIN(1);

        RAISE NOTICE 'CR_Origens';
        OPEN CR_Origens;
        LOOP
          FETCH CR_Origens INTO cOrigem;
          EXIT WHEN NOT FOUND;

          IF cOrigem = 'PAG' THEN
             cTabelaFin := 'TV_RFIN_'||cOrigem;
          ELSE
             cTabelaFin := 'TR_FIN';
          END IF;

          RAISE NOTICE 'INCONSISTNCIA +';
          cComando := 'UPDATE TL_FIN                                                                                               '||
                      'SET FLGEST='||CHR(39)||'I'||CHR(39)||
                      '  , MOTINC='||CHR(39)||'+'||CHR(39)||
                      'WHERE (ORIGEM,FILORI,SEQORI,PARORI) IN (                                                                           '||
                      'SELECT CAST(ORIGEM AS CHAR(03)) AS ORIGEM,                                                                  '||
                      '       CAST(CODFIL AS CHAR(03)) AS CODFIL,                                                                  '||
                      '       CAST(SEQUEN AS CHAR(10)) AS SEQUEN,                                                                  '||
                      '       CAST(NUMPAR AS CHAR(02)) AS NUMPAR                                                                   '||
                      ' FROM (SELECT FIN.ORIGEM, FIN.CODFIL, FIN.SEQUEN, FIN.NUMPAR, FIN.SUBPAR, FIN.FILCTA, FIN.SEQCTA, FIN.VLRLAN'||
                      '         FROM '||cTabelaFin||' FIN INNER JOIN TT_CTA CTA ON CTA.CODFIL = FIN.FILCTA                              '||
                      '          AND CTA.SEQUEN = FIN.SEQCTA                                                                       '||
                      '          AND CTA.USOCTA IN ('||CHR(39)||'+'||CHR(39)||','||CHR(39)||'-'||CHR(39)||')'||
                      '        WHERE FIN.ORIGEM <> '||CHR(39)||'COM'||CHR(39)||
                      '          AND FIN.ORIGEM <> '||CHR(39)||'RTT'||CHR(39)||
                      '          AND NOT (FIN.ORIGEM='||CHR(39)||'DOP'||CHR(39)||' AND TIPLAN <> '||CHR(39)||'TRO'||CHR(39)||')'||
                      '        UNION ALL                                                                                           '||
                      '       SELECT FIN.ORIGEM, FIN.CODFIL, FIN.SEQUEN, FIN.NUMPAR, FIN.SUBPAR, FIN.FILCRT, FIN.SEQCRT,            '||
                      '              FIN.VLRLAN * CASE WHEN FIN.TIPCTA = '||CHR(39)||'N'||CHR(39)||' THEN -1 ELSE 1 END AS VLRLAN '||
                      '         FROM '||cTabelaFin||' FIN INNER JOIN TT_CTA CTA ON CTA.CODFIL = FIN.FILCRT                              '||
                      '                                              AND CTA.SEQUEN = FIN.SEQCRT                              '||
                      '          AND CTA.USOCTA IN ('||CHR(39)||'+'||CHR(39)||','||CHR(39)||'-'||CHR(39)||')'||
                      '        WHERE NOT (FIN.ORIGEM='||CHR(39)||'PAG'||CHR(39)||' AND TIPLAN = '||CHR(39)||'PAG'||CHR(39)||')'||
                      '          AND FIN.ORIGEM <> '||CHR(39)||'COM'||CHR(39)||
                      '          AND FIN.ORIGEM <> '||CHR(39)||'RTT'||CHR(39)||
                      '          AND NOT (FIN.ORIGEM='||CHR(39)||'DOP'||CHR(39)||' AND TIPLAN <> '||CHR(39)||'TRO'||CHR(39)||')'||
                      '          AND FIN.VLRLAN<>0'||
                      '       ) INT                                                                                                                    '||
                      '  WHERE INT.ORIGEM=TL_FIN.ORIGEM                                                                                                '||
                      '    AND INT.CODFIL=TL_FIN.FILORI                                                                                                '||
                      '    AND INT.SEQUEN=TL_FIN.SEQORI                                                                                                '||
                      '    AND INT.NUMPAR=TL_FIN.PARORI                                                                                                '||
                      ' GROUP BY ORIGEM, CODFIL, SEQUEN, NUMPAR, FILCTA, SEQCTA                                                                        '||
                      'HAVING (SUM(VLRLAN) <> 0) AND (ABS(SUM(VLRLAN)) > 0.02)                                                                         '||
                      ')                                                                                                                               '||
                      '    AND FLGEST = '||CHR(39)||'P'||CHR(39)||
                      '    AND ORIGEM = '||CHR(39)||cOrigem||CHR(39);
                                            
                      EXECUTE cCOMANDO;
                      
          /* 92449 - Desativada inconsistncia "D"
          RAISE NOTICE 'INCONSISTNCIA D';
          cComando := 'UPDATE TL_FIN                                        '||
                      'SET FLGEST='||CHR(39)||'I'||CHR(39)||
                      '  , MOTINC='||CHR(39)||'D'||CHR(39)||
                      'WHERE (ORIGEM,FILORI,SEQORI,PARORI) IN (                    '||
                      '        SELECT ORIGEM,   '||
                      '               CODFIL,   '||
                      '               SEQUEN,   '||
                      '               NUMPAR    '||
                      '          FROM '||cTabelaFin||' FIN                    '||
                      '         WHERE FIN.ORIGEM=TL_FIN.ORIGEM                                '||
                      '           AND FIN.CODFIL=TL_FIN.FILORI                                '||
                      '           AND FIN.SEQUEN=TL_FIN.SEQORI                                '||
                      '           AND FIN.NUMPAR=TL_FIN.PARORI                                '||
                      '           AND CASE WHEN (ORIGEM = '||CHR(39)||'CCC'||CHR(39)||
                      '                          AND TIPLAN='||CHR(39)||'DES'||CHR(39)||
                      '                         ) OR ( ORIGEM = '||CHR(39)||'COM'||CHR(39)||
                      '                          AND TIPLAN in ('||CHR(39)||'JDF'||CHR(39)||','||CHR(39)||'JDP'||CHR(39)||','||CHR(39)||'ICM'||CHR(39)||','||CHR(39)||'ISS'||CHR(39)||','||CHR(39)||'INS'||CHR(39)||','||CHR(39)||'PIS'||CHR(39)||','||CHR(39)||'COF'||CHR(39)||','||CHR(39)||'IRR'||CHR(39)||','||CHR(39)||'CSS'||CHR(39)||','||CHR(39)||'OUT'||CHR(39)||','||CHR(39)||'FNR'||CHR(39)||')'||
                      '                         ) OR ( ORIGEM = '||CHR(39)||'REC'||CHR(39)||
                      '                          AND TIPLAN in ('||CHR(39)||'FNR'||CHR(39)||','||CHR(39)||'VPR'||CHR(39)||')'||
                      '                         )                                             '||
                      '                    THEN 0 ELSE 1                                      '||
                      '               END = 1                                                 '||
                      '           AND FIN.VLRLAN<>0'||
                      '           AND (FIN.TIPCTA='||CHR(39)||'N'||CHR(39)||' or tipcrt='||CHR(39)||'N'||CHR(39)||') '||
                      '         GROUP BY ORIGEM, CODFIL, SEQUEN, NUMPAR                       '||
                      '        HAVING SUM(CASE WHEN TIPCTA='||CHR(39)||'N'||CHR(39)||' THEN 1 ELSE 0 END) > 0'||
                      '           AND COUNT(*) > 1                                            '||
                      '           AND SUM( CASE WHEN TIPCTA = '||CHR(39)||'G'||CHR(39)||' THEN VLRLAN ELSE 0 END) +    '||
                      '                SUM( CASE WHEN TIPCTA = '||CHR(39)||'N'||CHR(39)||' THEN VLRLAN ELSE 0 END) <> 0              '||
                      '           AND SUM( CASE WHEN TIPCTA = '||CHR(39)||'G'||CHR(39)||' OR TIPCRT = '||CHR(39)||'G'||CHR(39)||' THEN VLRLAN ELSE 0 END) <> 0  '||
                      ')                                                                      '||
                      'AND FLGEST = '||CHR(39)||'P'||CHR(39)||
                      'AND ORIGEM = '||CHR(39)||cOrigem||CHR(39);
                                            
                      EXECUTE cCOMANDO;
                                */
          RAISE NOTICE 'INCONSISTNCIA F';
          cComando := 'UPDATE TL_FIN                                        '||
                      'SET FLGEST='||CHR(39)||'I'||CHR(39)||
                      '  , MOTINC='||CHR(39)||'F'||CHR(39)||
                      'WHERE (ORIGEM,FILORI,SEQORI,PARORI) IN               '||
                      '(SELECT ORIGEM, FILORI, SEQORI, PARORI               '||
                      '   FROM '||cTabelaFin||' FIN  '||
                      '  WHERE (FIN.SUBPAR IS NULL OR                       '||
                      '         FIN.TIPLAN IS NULL OR                       '||
                      '         FIN.DATLAN IS NULL OR                       '||
                      '         FIN.FILCLI IS NULL OR                       '||
                      '         FIN.CODCLI IS NULL OR                       '||
                      '         FIN.FLGFLX IS NULL OR                       '||
                      '         FIN.FILCTA IS NULL OR                       '||
                      '         FIN.SEQCTA IS NULL OR                       '||
                      '         FIN.TIPCTA IS NULL OR                       '||
                      '         FIN.ORICTA IS NULL OR                       '||
                      '         FIN.FILCRT IS NULL OR                       '||
                      '         FIN.SEQCRT IS NULL OR                       '||
                      '         FIN.TIPCRT IS NULL OR                       '||
                      '         FIN.ORICRT IS NULL OR                       '||
                      '         FIN.VLRLAN IS NULL OR                       '||
                      '         FIN.FILORI IS NULL OR                       '||
                      '         FIN.FILDES IS NULL OR                       '||
                      '         FIN.FILUSU IS NULL OR                       '||
                      '         FIN.CODUSU IS NULL)                         '||
                      '     AND FIN.ORIGEM=TL_FIN.ORIGEM                    '||
                      '     AND FIN.CODFIL=TL_FIN.FILORI                    '||
                      '     AND FIN.SEQUEN=TL_FIN.SEQORI                    '||
                      '     AND FIN.NUMPAR=TL_FIN.PARORI                    '||
                      ' )                                                   '||
                      'AND FLGEST = '||CHR(39)||'P'||CHR(39)||
                      'AND ORIGEM = '||CHR(39)||cOrigem||CHR(39);
                                            
                      EXECUTE cCOMANDO;
                      
          RAISE NOTICE 'INCONSISTNCIA L';
          cComando := 'UPDATE TL_FIN                                        '||
                      'SET FLGEST='||CHR(39)||'I'||CHR(39)||
                      '  , MOTINC='||CHR(39)||'L'||CHR(39)||
                      'WHERE (ORIGEM,FILORI,SEQORI,PARORI) IN (                    '||
                      '        SELECT CAST(ORIGEM AS CHAR(03)) AS ORIGEM,   '||
                      '               CAST(CODFIL AS CHAR(03)) AS CODFIL,   '||
                      '               CAST(SEQUEN AS CHAR(10)) AS SEQUEN,   '||
                      '               CAST(NUMPAR AS CHAR(02)) AS NUMPAR    '||
                      '          FROM '||cTabelaFin||' FIN  '||
                      '         WHERE FIN.ORIGEM=TL_FIN.ORIGEM                                '||
                      '           AND FIN.CODFIL=TL_FIN.FILORI                                '||
                      '           AND FIN.SEQUEN=TL_FIN.SEQORI                                '||
                      '           AND FIN.NUMPAR=TL_FIN.PARORI                                '||
                      '           AND COALESCE(FIN.VLRLAN,0)<>COALESCE(FIN.VLRCRT,0)          '||
                      '           AND ABS(COALESCE(FIN.VLRLAN,0)-COALESCE(FIN.VLRCRT,0)) > 0.02  '||
                      '           AND FIN.VLRLAN<>0'||
                      ')                                                                      '||
                      'AND FLGEST = '||CHR(39)||'P'||CHR(39)||
                      'AND ORIGEM = '||CHR(39)||cOrigem||CHR(39);
                                            
                      EXECUTE cCOMANDO;
                      
    /* DN 66895
          RAISE NOTICE 'INCONSISTENCIA V';
          -- Tratamento de data minima e maxima de um lancamento financeiro
          UPDATE TL_FIN
                 SET FLGEST = 'I',
                     MOTINC = 'V'
               WHERE EXISTS (SELECT 1 AS OK
                        FROM TR_FIN RFIN INNER JOIN TD_FIL FORI ON FORI.CODFIL = RFIN.FILORI
                                         INNER JOIN TD_FIL FDES ON FDES.CODFIL = RFIN.FILORI
                       WHERE RFIN.FLGFLX = 'R'
                         AND ((RFIN.DATLAN NOT BETWEEN COALESCE(FORI.FINMIN,ADD_DAY(RFIN.DATLAN,-1)) AND COALESCE(FORI.FINMAX,ADD_DAY(RFIN.DATLAN,+1))) OR
                              (RFIN.DATLAN NOT BETWEEN COALESCE(FDES.FINMIN,ADD_DAY(RFIN.DATLAN,-1)) AND COALESCE(FDES.FINMAX,ADD_DAY(RFIN.DATLAN,+1)))
                             )
                         AND TL_FIN.ORIGEM=RFIN.ORIGEM
                         AND TL_FIN.FILORI=RFIN.CODFIL
                         AND TL_FIN.SEQORI=RFIN.SEQUEN
                         AND TL_FIN.PARORI=RFIN.NUMPAR
                         AND TL_FIN.SUBORI=RFIN.SUBPAR
                     )
                  AND FLGEST = 'P';
    */

        END LOOP;
        CLOSE CR_Origens;

        RAISE NOTICE 'DELETE FROM TL_FIN';
        -- Excluir ja Processados
        DELETE FROM TL_FIN
         WHERE FLGEST='P';

        RAISE NOTICE 'AtualizaSaldoContas()';
        -- A trigger de TR_FIN atualizou valores em TR_CTA e a data do ltimo calculo em
        -- TT_CTA. Este processo atualiza os saldos dirios (TR_CTA) e o saldo de TT_CTA
        cDUMMY := AtualizaSaldoContas();

        
    END LOOP;
  END IF;
  RAISE NOTICE '**** FIM ****';
  RETURN 'OK';

END;
$$ language 'plpgsql';


/*-- SEQ 0825 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AtualizaFinanceiro () CASCADE;

/*-- SEQ 0826 --*/
CREATE OR REPLACE FUNCTION AtualizaFinanceiro () 
RETURNS VARCHAR AS $$
BEGIN
RETURN AtualizaFinanceiro(null,null,null);
END;
$$ language 'plpgsql';

/*-- SEQ 0827 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_AtualizaFinanceiro (TT_JOB.CODUID%TYPE) CASCADE;

/*-- SEQ 0828 --*/
CREATE OR REPLACE FUNCTION Job_AtualizaFinanceiro (TT_JOB.CODUID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODUID ALIAS FOR $1 ;
   vNOME                         TT_JOB.NOMJOB%TYPE;
   vDESC                         TT_JOB.DESJOB%TYPE;
   DUMMY                         CHAR(2);
BEGIN
   vNOME := 'JOB_ATUALIZAFINANCEIRO';
   VDESC := 'Rotina para atualizar tabelas financeiras';
   BEGIN
      DUMMY := AtualizaFinanceiro();
      DUMMY := RegistraJob(vNOME, vDESC, NULL, pCODUID);
   EXCEPTION
      WHEN OTHERS THEN DUMMY := RegistraJob(vNOME, vDESC, SQLERRM, pCODUID);
   END;
  RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 0829 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_AtualizaFinanceiro () CASCADE;

/*-- SEQ 0830 --*/
CREATE OR REPLACE FUNCTION Job_AtualizaFinanceiro () 
RETURNS VARCHAR AS $$
BEGIN
RETURN Job_AtualizaFinanceiro(NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 0831 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Atu_ReservaPendente (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE,TT_IVE.QTDMOV%TYPE,TT_IVE.FILRES%TYPE,TT_IVE.DUMMY%TYPE) CASCADE;

/*-- SEQ 0832 --*/
CREATE OR REPLACE FUNCTION Atu_ReservaPendente (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE,TT_IVE.QTDMOV%TYPE,TT_IVE.FILRES%TYPE,TT_IVE.DUMMY%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_CodFil ALIAS FOR $1 ;
p_Sequen ALIAS FOR $2 ;
p_NumIte ALIAS FOR $3 ;
p_QtdMov ALIAS FOR $4 ;
pFilRes ALIAS FOR $5 ;
pDummy ALIAS FOR $6 ;
   cFILORI                       TT_IVE.CODFIL%TYPE;
   cCODFIL                       TT_IVE.CODFIL%TYPE;
   cSEQUEN                       TT_IVE.SEQUEN%TYPE;
   cNUMITE                       TT_IVE.NUMITE%TYPE;
   cLANEST                       TT_IVE.LANEST%TYPE;
   cQTDPEN                       TT_IVE.QTDPEN%TYPE;
   cVINCUL                       VARCHAR(100);
   vVem_de_ATU_RES_PEND          CONSTANT VARCHAR(1) := constante('VEM_DE_ATU_RES_PEND');
   WK_RESERVA_ENT_FUT            TT_CFG.RESERVA_ENT_FUT%TYPE;
-- Objetivo:
-- 1) Atualiza a quantidade pendente (QTDPEN) na nota de vnculo futuro

BEGIN

   -- obtem nota que possui o vinculo futuro
   cVINCUL := VinculoFuturo(COALESCE(pFilRes, p_CodFil),p_Sequen,p_NumIte,0);
   cCODFIL := SUBSTR(cVINCUL,1,3);
   cSEQUEN := SUBSTR(cVINCUL,4,10);
   cNUMITE := TO_NUMBER(TRIM(SUBSTR(cVINCUL,14,5)));

   UPDATE TT_IVE
      SET QTDPEN = COALESCE(QTDPEN,0) + COALESCE(p_QtdMov,0),
          QTDFUT = CASE WHEN pDummy = 'R' AND FLGFUT = 'E' AND QTDFUT IS NOT NULL
                           THEN CASE WHEN COALESCE(QTDFUT,0) + COALESCE(p_QtdMov,0) > 0
                                     THEN COALESCE(QTDFUT,0) + COALESCE(p_QtdMov,0)
                                     ELSE 0
                                END
                        ELSE QTDFUT
                   END,
          DUMMY  = vVem_de_ATU_RES_PEND
    WHERE CODFIL = cCODFIL
      AND SEQUEN = cSEQUEN
      AND NUMITE = cNUMITE
      AND LANEST = 'R';

   -- Limpa vnculo com a fatura. Em Postgres esse processo  feito na trigger da TT_IVE
   
   RETURN 'OK';

END;
$$ language 'plpgsql';




/*-- SEQ 0833 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AtualizaSaldo_RFIN (TR_CTA.FILCTA%TYPE,TR_CTA.SEQCTA%TYPE,TR_CTA.TIPCTA%TYPE,TR_FIN.VLRLAN%TYPE,TR_CTA.FLGFLX%TYPE,TR_CTA.DATLAN%TYPE,TR_CTA.FILLAN%TYPE,TR_CTA.TOTCRE%TYPE) CASCADE;

/*-- SEQ 0834 --*/
CREATE OR REPLACE FUNCTION AtualizaSaldo_RFIN (TR_CTA.FILCTA%TYPE,TR_CTA.SEQCTA%TYPE,TR_CTA.TIPCTA%TYPE,TR_FIN.VLRLAN%TYPE,TR_CTA.FLGFLX%TYPE,TR_CTA.DATLAN%TYPE,TR_CTA.FILLAN%TYPE,TR_CTA.TOTCRE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFilCta ALIAS FOR $1 ;
pSeqCta ALIAS FOR $2 ;
pTipCta ALIAS FOR $3 ;
pValor ALIAS FOR $4 ;
PFlgFlx ALIAS FOR $5 ;
pDatLan ALIAS FOR $6 ;
pFILLAN ALIAS FOR $7 ;
pFator ALIAS FOR $8 ;
  -- Atualiza saldos em TR_CTA e TT_CTA
    ValorCre TR_CTA.TOTCRE%TYPE;
    ValorDeb TR_CTA.TOTDEB%TYPE;
    linha integer;

  BEGIN

     ValorCre := pFator * CASE WHEN pValor > 0 THEN pValor      ELSE 0 END ;
     ValorDeb := pFator * CASE WHEN pValor < 0 THEN pValor * -1 ELSE 0 END ;

     SELECT COUNT(*) INTO linha
     FROM TR_CTA RCTA
     WHERE RCTA.FLGFLX = pFLGFLX
       AND RCTA.FILCTA = pFILCTA
       AND RCTA.SEQCTA = pSEQCTA
       AND RCTA.TIPCTA = pTIPCTA
       AND RCTA.DATLAN = trunc(pDATLAN)
       AND FILLAN = pFILLAN;

     IF linha > 0 THEN

        UPDATE TR_CTA
               SET TOTCRE = TOTCRE + ValorCre,
                   TOTDEB = TOTDEB + ValorDeb
        WHERE FLGFLX = pFLGFLX
          AND FILCTA = pFILCTA
          AND SEQCTA = pSEQCTA
          AND TIPCTA = pTIPCTA
          AND DATLAN = trunc(pDATLAN)
          AND FILLAN = pFILLAN;

     ELSE

        INSERT INTO TR_CTA (FLGFLX, FILCTA, SEQCTA, TIPCTA, DATLAN, FILLAN, TOTCRE, TOTDEB)
        VALUES (pFLGFLX, pFILCTA, pSEQCTA, pTIPCTA, TRUNC(pDATLAN), pFILLAN, ValorCre, ValorDeb);

     END IF;

     UPDATE TT_CTA
            SET ATUREA = CASE WHEN pFLGFLX = 'A' THEN ATUREA ELSE 'F' END,
                ATUARE = CASE WHEN pFLGFLX = 'R' THEN ATUARE ELSE 'F' END,
                DATREA = CASE WHEN pFLGFLX = 'A' THEN DATREA ELSE TRUNC( LEAST( COALESCE(DATREA, AGORA()), pDATLAN)) END,
                DATARE = CASE WHEN pFLGFLX = 'R' THEN DATARE ELSE TRUNC( LEAST( COALESCE(DATARE, AGORA()), pDATLAN)) END
     WHERE CODFIL = pFILCTA
       AND SEQUEN = pSEQCTA
       AND TIPCTA = pTIPCTA;

    return 'OK';

END;
$$ language 'plpgsql';




/*-- SEQ 0835 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_CalcSazonalidade (Timestamp,Timestamp,Numeric[]) CASCADE;

/*-- SEQ 0836 --*/
CREATE OR REPLACE FUNCTION AUX_CalcSazonalidade (Timestamp,Timestamp,Numeric[])
RETURNS INTEGER AS $$
DECLARE
DataIni ALIAS FOR $1 ;
DataFim ALIAS FOR $2 ;
Saz ALIAS FOR $3 ;
 -- Objetivos
 -- Calcula a sazonalidade efetiva
  DiaIni INTEGER;
  MesIni INTEGER;
  AnoIni INTEGER;
  MaxIni INTEGER;
  DiaFim INTEGER;
  MesFim INTEGER;
  AnoFim INTEGER;
  MaxFim INTEGER;
  Indice INTEGER;
  i      INTEGER;
  x      INTEGER;

BEGIN
  -- Extrai Dia, Mes, Ano para calcular Sazonalidade Anterior
  DiaIni := TO_NUMBER(TO_CHAR(DataIni,'DD'));   /* Extrai Dia de DataIni */
  MesIni := TO_NUMBER(TO_CHAR(DataIni,'MM'));   /* Extrai Mes de DataIni */
  AnoIni := TO_NUMBER(TO_CHAR(DataIni,'YYYY')); /* Extrai Ano de DataIni */
  MaxIni := TO_NUMBER(TO_CHAR(LAST_DAY(DataIni),'DD')); /* Numero maximo de dias no mes MesIni/AnoIni */
  DiaFim := TO_NUMBER(TO_CHAR(DataFim,'DD'));   /* Extrai Dia de DataFim */
  MesFim := TO_NUMBER(TO_CHAR(DataFim,'MM'));   /* Extrai Mes de DataFim */
  AnoFim := TO_NUMBER(TO_CHAR(DataFim,'YYYY')); /* Extrai Ano de DataFim */
  MaxFim := TO_NUMBER(TO_CHAR(LAST_DAY(DataFim),'DD')); /* Numero maximo de dias no mes MesFim/AnoFim */

  -- Calcula a proporcao da Sazonalidade do primeiro e ultimo mes
  Indice := trunc(( (MaxIni - DiaIni) * Saz [MesIni] ) / MaxIni);
  Indice := Indice + trunc(DiaFim * Saz [MesFim] / MaxFim);
  MesIni := MesIni + 1;
  MesFim := MesFim - 1;

  if AnoFim > AnoIni then
     MesFim := MesFim + 12;
  end if;

  if (MesFim) >= (MesIni) then
     for i in (MesIni)..(MesFim) loop
       Indice := Indice + trunc(Saz [i]);
     end loop;
  end if;

  -- se ha mais de um ano de intervalo
  if AnoFim > (AnoIni+1) then
     for x in (AnoIni+1)..(AnoFim-1) loop
         for i in (1)..(12) loop
           Indice := Indice + trunc(Saz [i]);
         end loop;
     end loop;
  end if;

  return Indice;
END;
$$ language 'plpgsql';




/*-- SEQ 0837 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_CGCCalculo (VARCHAR,integer,integer) CASCADE;

/*-- SEQ 0838 --*/
CREATE OR REPLACE FUNCTION AUX_CGCCalculo (VARCHAR,integer,integer)
RETURNS Integer AS $$
DECLARE
p_CGC ALIAS FOR $1 ;
p_MTP ALIAS FOR $2 ;
p_DF1 ALIAS FOR $3 ;
  wk_DF1  INTEGER;
  wk_MTP  INTEGER;
  wk_I    INTEGER;
  wk_DIG  INTEGER;
BEGIN
  wk_DF1 := p_DF1;
  wk_MTP := p_MTP;
  IF (LENGTH(p_CGC)<12) OR (ISDIGIT(p_CGC)<>1) THEN
     RETURN -1;
  END IF;
  FOR wk_I IN 1..12 LOOP    
    wk_DIG := CAST(SUBSTR(LTRIM(RTRIM(p_CGC)),wk_i,1) AS INTEGER);
    wk_DF1 := wk_DF1 + (wk_DIG * wk_MTP);
    wk_MTP := wk_MTP - 1;
    IF wk_MTP = 1 THEN
       wk_MTP := 9;
    END IF;
  END LOOP;
  RETURN wk_DF1;
END;
$$ language 'plpgsql';




/*-- SEQ 0839 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_CPFCalculo (VARCHAR,INTEGER,INTEGER) CASCADE;

/*-- SEQ 0840 --*/
CREATE OR REPLACE FUNCTION AUX_CPFCalculo (VARCHAR,INTEGER,INTEGER)
RETURNS Integer AS $$
DECLARE
p_CPF ALIAS FOR $1 ;
p_MTP ALIAS FOR $2 ;
p_DF1 ALIAS FOR $3 ;
  wk_DF1  INTEGER;
  wk_MTP  INTEGER;
  wk_I    INTEGER;
  wk_DIG  INTEGER;
BEGIN
  wk_DF1 := p_DF1;
  wk_MTP := p_MTP;
  IF (LENGTH(p_CPF)<9) OR (ISDIGIT(p_CPF)<>1) THEN
     RETURN -1;
  END IF;
  FOR wk_I IN 1..9 LOOP
    wk_DIG := CAST(SUBSTR(LTRIM(RTRIM(p_CPF)),wk_i,1) AS INTEGER);
    wk_DF1 := wk_DF1 + (wk_DIG * wk_MTP);
    wk_MTP := wk_MTP - 1;
  END LOOP;
  RETURN wk_DF1;
END;
$$ language 'plpgsql';




/*-- SEQ 0841 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_VALORCRT (TD_DET.USODET%TYPE,TD_CRT.CODTAB%TYPE,VARCHAR,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 0842 --*/
CREATE OR REPLACE FUNCTION AUX_VALORCRT (TD_DET.USODET%TYPE,TD_CRT.CODTAB%TYPE,VARCHAR,VARCHAR,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pUSODET ALIAS FOR $1 ;
pCODCRT ALIAS FOR $2 ;
pCOD1 ALIAS FOR $3 ;
pCOD2 ALIAS FOR $4 ;
pCOD3 ALIAS FOR $5 ;
pCOD4 ALIAS FOR $6 ;

CR_CRTxCLI CURSOR FOR
  SELECT DESCRT 
    FROM TT_CRTXCLI 
   WHERE FILCLI=pCOD1
     AND CODCLI=pCOD2
     AND CODCRT=pCODCRT
     AND USODET=pUSODET;

CR_CRTxEND CURSOR FOR
  SELECT DESCRT 
    FROM TT_CRTXEND
   WHERE FILCLI=pCOD1
     AND CODCLI=pCOD2
     AND FILEND=pCOD3
     AND NUMEND=pCOD4
     AND CODCRT=pCODCRT
     AND USODET=pUSODET;

CR_CRTxPRO CURSOR FOR
  SELECT DESCRT 
    FROM TT_CRTXPRO
   WHERE FILMAT=pCOD1
     AND CODMAT=pCOD2
     AND CODCRT=pCODCRT
     AND USODET=pUSODET;

CR_CRTxGRA CURSOR FOR
  SELECT DESCRT 
    FROM TT_CRTXGRA
   WHERE FILMAT=pCOD1
     AND CODMAT=pCOD2
     AND CODCOR=TO_NUMBER(pCOD3)
     AND CODTAM=TO_NUMBER(pCOD4)
     AND CODCRT=pCODCRT
     AND USODET=pUSODET;
   
   cRESP TT_CRTXGRA.DESCRT%TYPE;
   vComplemento CONSTANT VARCHAR(254):= constante('complemento');

BEGIN

    IF pUSODET='C' THEN 
       OPEN CR_CRTxCLI;
       FETCH CR_CRTxCLI INTO cRESP;
       CLOSE CR_CRTxCLI;
    ELSIF pUSODET='E' THEN 
       OPEN CR_CRTxEND;
       FETCH CR_CRTxEND INTO cRESP;
       CLOSE CR_CRTxEND;
    ELSIF pUSODET='P' THEN 
       OPEN CR_CRTxPRO;
       FETCH CR_CRTxPRO INTO cRESP;
       CLOSE CR_CRTxPRO;
    ELSIF pUSODET='G' THEN 
       OPEN CR_CRTxGRA;
       FETCH CR_CRTxGRA INTO cRESP;
       CLOSE CR_CRTxGRA;
    ELSE 
       RAISE EXCEPTION 'PG-20001 USO "%" NO IMPLEMENTADO. %' , pUSODET,vCOMPLEMENTO;   
    END IF;

    RETURN cRESP;

END;
$$ language 'plpgsql';




/*-- SEQ 0843 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AuxDisponivelVenda (TT_PRO.FILMAT%TYPE,TT_PRO.CODMAT%TYPE) CASCADE;

/*-- SEQ 0844 --*/
CREATE OR REPLACE FUNCTION AuxDisponivelVenda (TT_PRO.FILMAT%TYPE,TT_PRO.CODMAT%TYPE)
RETURNS boolean AS $$
DECLARE
pFilial ALIAS FOR $1 ;
pCodigo ALIAS FOR $2 ;
    wk_retorno boolean := true;
    wk_conta   INTEGER;
  BEGIN
      SELECT COUNT(*) INTO wk_conta
        FROM TT_PIV B, TT_PRO A
       WHERE A.FILMAT = pFilial
         AND A.CODMAT = pCodigo
         AND (B.CODCL1 IS NULL OR B.CODCL1 = A.CLASS1)
         AND (B.CODCL2 IS NULL OR B.CODCL2 = A.CLASS2)
         AND (B.CODCL3 IS NULL OR B.CODCL3 = A.CLASS3)
         AND (B.CODCL4 IS NULL OR B.CODCL4 = A.CLASS4);

      IF wk_conta <> 0 THEN
        wk_retorno := false;
      END IF;
     RETURN wk_retorno;
END;
$$ language 'plpgsql';




/*-- SEQ 0845 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_ExtCem (VARCHAR) CASCADE;

/*-- SEQ 0846 --*/
CREATE OR REPLACE FUNCTION AUX_ExtCem (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pCem ALIAS FOR $1 ;

  aCent VARCHAR[9];
  aVint VARCHAR[9];
  aDez  VARCHAR[9];
  aUnit VARCHAR[9];
  aVal INTEGER[3]; 

  Cem  VARCHAR(3);
  text VARCHAR(255);
  temp VARCHAR(20);
  temp2 integer;
BEGIN

   aCent := ' {"CENTO","DUZENTOS","TREZENTOS","QUATROCENTOS","QUINHENTOS","SEISCENTOS","SETECENTOS","OITOCENTOS","NOVECENTOS"} '; 
   aVint := ' {"ONZE","DOZE","TREZE","QUATORZE","QUINZE","DEZESSEIS","DEZESSETE","DEZOITO","DEZENOVE"} '; 
   aDez := ' {"DEZ","VINTE","TRINTA","QUARENTA","CINQUENTA","SESSENTA","SETENTA","OITENTA","NOVENTA"} '; 
   aUnit := ' {"UM","DOIS","TRS","QUATRO","CINCO","SEIS","SETE","OITO","NOVE"} '; 
   aVal := ' {"0","0","0"} '; 

  Cem := LPAD(PCEM,3,'0');

  text := '';

  
    SELECT '{' || CAST( SUBSTR( Cem,1,1) AS Numeric ) ||
           ',' || CAST ( SUBSTR( Cem,2,1) AS Numeric ) ||
           ',' || CAST( SUBSTR( Cem,3,1) AS Numeric ) || '}' INTO temp;
    aVal := temp;
  
  
  IF CAST (trim(Cem) as Numeric) > 0 THEN
    IF cast (trim(Cem)  as Numeric) = 100 THEN
      text := 'CEM';
    ELSE
      IF aVal [1] > 0 THEN
        temp2 := aVal [1];
        text := aCent [temp2] ||  AUX_MaiorQueZero(aVal [2]+aVal [3],' E ',' ');
      END IF;

      IF (aVal [2] = 1) AND (aVal [3] > 0) then
        temp2 := aVal [3];
        text := text || ' ' || aVint [temp2];
      ELSE
        IF aval [2] > 0 THEN
          temp2 := aVal [2];
          text := text || ' ' || aDez [temp2] || AUX_MaiorQueZero(aVal [3], ' E ',' ');
        END IF;

        IF aval [3] > 0 THEN
          temp2 := aVal [3];
          text := text || AUX_MaiorQueZero(aVal [3],' '||aUnit [temp2],' ');
        ELSE
          text := text || ' ';
        END IF;
      END IF;
    END IF;
  END IF;

  text := text || ' ';
  RETURN text;
END;
$$ language 'plpgsql';




/*-- SEQ 0847 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_Feriado (Timestamp,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE) CASCADE;

/*-- SEQ 0848 --*/
CREATE OR REPLACE FUNCTION AUX_Feriado (Timestamp,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE)
RETURNS boolean AS $$
DECLARE
p_quando ALIAS FOR $1 ;
p_filQuem ALIAS FOR $2 ;
p_codQuem ALIAS FOR $3 ;
  wk_achou  INTEGER;
  wk_inicio Timestamp;
  wk_fim    Timestamp;
BEGIN
  wk_inicio := to_date(to_char(p_quando,'DD/MM/YYYY')||' 00:00:00','DD/MM/YYYY HH24:MI:SS');
  wk_fim    := to_date(to_char(p_quando,'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');

  IF ISNULL(p_filQuem)='T' THEN
    SELECT COUNT(*) INTO wk_achou
      FROM TT_AUS
     WHERE DATAUS BETWEEN wk_inicio AND wk_fim AND (FILUSU IS NULL OR CODUSU IS NULL);
  ELSE
    SELECT COUNT(*) INTO wk_achou
      FROM TT_AUS
     WHERE DATAUS BETWEEN wk_inicio AND wk_fim
       AND ((FILUSU = p_filQuem AND CODUSU = p_codQuem) OR
            (FILUSU IS NULL OR CODUSU IS NULL));
  END IF;

  RETURN (wk_achou > 0);
END;
$$ language 'plpgsql';




/*-- SEQ 0849 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ProximaHoraUtil (td_fil.codfil%type,Timestamp) CASCADE;

/*-- SEQ 0850 --*/
CREATE OR REPLACE FUNCTION ProximaHoraUtil (td_fil.codfil%type,Timestamp)
RETURNS Timestamp AS $$
DECLARE
FILIAL ALIAS FOR $1 ;
p_DATINI ALIAS FOR $2 ;
-- Retorna a proxima hora util a partir de uma data
   WK_CONTA  Numeric(10);
   WK_HORINI Numeric(7);
   WK_STRHORINI VARCHAR(10);
   WK_MININI Numeric(7);
   WK_DIASEM Numeric(1);
   vComplemento constant VARCHAR(100) := constante('complemento');
begin

  -- Verifica se existe horas de expediente para esta filial
  SELECT COUNT(*) into WK_CONTA FROM TT_EXP
  WHERE CODFIL = FILIAL;

  If WK_Conta = 0 then
     RAISE EXCEPTION 'PG-20007 Esta filial nao possui horas de expediente cadastradas, portanto impossivel de ser analizada. %' , vComplemento;
  end if;

  -- Verifica se o dia e feriado.
  SELECT COUNT(*) INTO WK_CONTA FROM TT_FER
  WHERE DIAFER = TO_NUMBER(TO_CHAR(p_DATINI,'DD'))
    AND MESFER = TO_NUMBER(TO_CHAR(p_DATINI,'MM'))
    AND ((FILFER IS NULL) OR (FILFER=FILIAL))    
    AND ((ANOFER = TO_NUMBER(TO_CHAR(p_DATINI,'YYYY'))) OR (ANOFER IS NULL));

  if WK_CONTA > 0 then
    -- e feriado, tenta no proximo dia.
    return ProximaHoraUtil(Filial, TRUNC(P_DATINI) + 1);
  end if;

  -- no Oracle o Domingo e codigo 1, ja no sistema e codigo 0
  -- DiaSem guarda o dia da semana, iniciando de 0
  WK_DIASEM := to_number(TO_CHAR(p_datini,'D')) -1;

  -- MinIni guarda o valor dos minutos no formato totall
  WK_MININI := TO_NUMBER(TO_CHAR(p_datini,'HH24')) * 60 + TO_NUMBER(TO_CHAR(p_datini,'MI'));

  -- Verifica se existe no mesmo dia da semana hora util
  -- verificando se a hora atual ja esta contando como util.
  SELECT COUNT(*) into WK_CONTA FROM TT_EXP
  WHERE DIASEM = WK_DIASEM
    AND WK_MININI BETWEEN HORINI AND (HORFIM-1)
    AND CODFIL = FILIAL;

  if WK_CONTA > 0 then
    -- Se a hora passada ja esta dentro de um intervalo de hora util
    -- retorna a hora inicial
    return p_DatIni;
  else

    -- Verifica se para o dia da semana enviado ainda sobrou alguma hora util.
    SELECT COUNT(*) into WK_CONTA FROM TT_EXP
    WHERE DIASEM = WK_DIASEM
      AND HORINI > WK_MININI
      AND CODFIL = FILIAL;

    if Wk_conta > 0 then

      -- Caso tenha sobrado, calcula a data inicial para o inicio dos trabalhos.
      SELECT MIN(HORINI) into WK_HORINI FROM TT_EXP
      WHERE DIASEM = WK_DIASEM
        AND HORINI > WK_MININI
        AND CODFIL = FILIAL;

      -- Transforma a hora para string.
      WK_STRHORINI := TRIM(TO_CHAR(TRUNC(WK_HORINI/60),'00')||':'||SUBSTR(TO_CHAR(WK_HORINI - (TRUNC(WK_HORINI/60)*60),'00'),2,2));

      -- Retorna o dia que inicial, na primeira hora util.
      return TO_DATE(TO_CHAR(P_DATINI,'DD/MM/YYYY') || WK_STRHORINI,'DD/MM/YYYY HH24:MI');

    else

      -- Caso hj nao exista mais hora util, pesquisa o proximo dia.
      return ProximaHoraUtil(Filial, TRUNC(P_DATINI) + 1);
    end if;
  end if;

END;
$$ language 'plpgsql';




/*-- SEQ 0851 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_IgualAUm (Numeric,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 0852 --*/
CREATE OR REPLACE FUNCTION AUX_IgualAUm (Numeric,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
p_Valor ALIAS FOR $1 ;
p_Opcao1 ALIAS FOR $2 ;
p_Opcao2 ALIAS FOR $3 ;
BEGIN
  IF p_valor=1 THEN
    RETURN p_Opcao1;
  ELSE
    RETURN p_Opcao2;
  END IF;
END;
$$ language 'plpgsql';




/*-- SEQ 0853 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_IORCAN (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 0854 --*/
CREATE OR REPLACE FUNCTION AUX_IORCAN (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE)
RETURNS Numeric AS $$
DECLARE
DataIni ALIAS FOR $1 ;
DataFim ALIAS FOR $2 ;
Filial ALIAS FOR $3 ;
Codigo ALIAS FOR $4 ;
Cor ALIAS FOR $5 ;
Tamanho ALIAS FOR $6 ;
Local ALIAS FOR $7 ;
 -- Objetivos
 -- Obtm a quantidade cancelada de um item de um oramento num periodo
  Soma Numeric;
  wk_inicio Timestamp;
  wk_fim    Timestamp;

begin

  wk_inicio := to_date(to_char(DataIni,'DD/MM/YYYY')||' 00:00:00','DD/MM/YYYY HH24:MI:SS');
  wk_fim    := to_date(to_char(DataFim,'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');

  select sum(qtdite) into soma
 from tt_ior
where flgest = 'C'
  and tipped in ('O','P')
  and codfil = Local
  and filmat = Filial
  and codmat = Codigo
  and codcor = Cor
  and codtam = Tamanho
  and datinc between wk_inicio and wk_fim;

  return Soma;
END;
$$ language 'plpgsql';




/*-- SEQ 0855 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_LE_DADO (VARCHAR,Numeric) CASCADE;

/*-- SEQ 0856 --*/
CREATE OR REPLACE FUNCTION AUX_LE_DADO (VARCHAR,Numeric)
RETURNS Numeric AS $$
DECLARE
p_Dado ALIAS FOR $1 ;
p_Peso ALIAS FOR $2 ;
  wk_soma Numeric := 0;
  wk_letra CHAR(1);
  wk_peso Numeric;
BEGIN
  wk_peso := p_Peso;

  FOR idx IN LENGTH(p_Dado)*-1..-1 LOOP
    wk_letra := SUBSTR(p_Dado,ABS(idx),1);

    IF ASCII(wk_letra) BETWEEN 48 AND 57 THEN
      wk_soma := wk_soma + CAST(trim(wk_letra) as Numeric) * wk_peso;
    ELSE
      wk_soma := wk_soma + ASCII(wk_letra) * wk_peso;
    END IF;

    wk_peso := wk_peso - 1;
    IF wk_peso < 2 THEN
      wk_peso := 9;
    END IF;
  END LOOP;

  RETURN wk_soma;
END;
$$ language 'plpgsql';




/*-- SEQ 0857 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_MOD11 (Numeric) CASCADE;

/*-- SEQ 0858 --*/
CREATE OR REPLACE FUNCTION AUX_MOD11 (Numeric)
RETURNS Numeric AS $$
DECLARE
p_Dividendo ALIAS FOR $1 ;
 -- Objetivos
 -- Calcular o Mdulo de 11 para um determinado numero.
 wk_mod Numeric;
BEGIN
 wk_mod := 11 - MOD(p_Dividendo,11);
 IF wk_mod > 9 THEN
   wk_mod := wk_mod - 9;
 END IF;
 RETURN wk_mod;
END;
$$ language 'plpgsql';




/*-- SEQ 0859 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_ProximaData ( TT_DXC.DIASEM%TYPE,TT_DXC.DIAMES%TYPE,Timestamp,TT_DXC.CODCCC%TYPE) CASCADE;

/*-- SEQ 0860 --*/
CREATE OR REPLACE FUNCTION AUX_ProximaData ( TT_DXC.DIASEM%TYPE,TT_DXC.DIAMES%TYPE,Timestamp,TT_DXC.CODCCC%TYPE)
RETURNS Timestamp AS $$
DECLARE
p_DIASEM ALIAS FOR $1 ;
p_DIAMES ALIAS FOR $2 ;
p_DATA ALIAS FOR $3 ;
p_CODCCC ALIAS FOR $4 ;
  wk_retorno  Timestamp;
  wk_mes      Numeric(2);
  wk_bissexto boolean;
  wk_DIAMES   TT_DXC.DIAMES%TYPE;
  wk_diaSem Integer;
BEGIN
  wk_DiaSem := p_DiaSem;

  -- Traz a prxima data para o faturamento do cliente
  IF wk_diasem > 0 THEN
    IF wk_diasem < TO_NUMBER(TO_CHAR(p_DATA,'D')) then
      wk_retorno := ADD_DAY(TRUNC(p_DATA), 7 - CAST(TO_CHAR(p_DATA,'D') AS INTEGER) + wk_diasem);
    ELSE
      wk_retorno := ADD_DAY(TRUNC(p_DATA), wk_diasem - CAST(TO_CHAR(p_DATA,'D') AS INTEGER));
    END IF;

  ELSE
    wk_mes    := TO_CHAR(p_DATA,'MM');
    wk_DIAMES := p_DIAMES;

    if to_number(TO_CHAR(LAST_DAY(TO_DATE('01/02/'||TO_CHAR(p_DATA,'YYYY'),'DD/MM/YYYY')),'DD')) = 29 THEN
      wk_bissexto := true;
    else
      wk_bissexto := false;
    end if;

    IF    (p_DIAMES = 29) THEN
      IF (wk_mes = 2) AND (not wk_bissexto) THEN
        wk_DIAMES := TO_CHAR(LAST_DAY(p_DATA),'DD');
      END IF;
    ELSIF (p_DIAMES = 30) THEN
      IF (wk_mes = 2) THEN
        wk_DIAMES := TO_CHAR(LAST_DAY(p_DATA),'DD');
      END IF;
    ELSIF (p_DIAMES = 31) THEN
      IF (wk_mes IN (2,4,6,9,11)) THEN
        wk_DIAMES := TO_CHAR(LAST_DAY(p_DATA),'DD');
      END IF;
    END IF;

    IF wk_DIAMES < to_number(TO_CHAR(p_DATA,'DD')) then
      wk_retorno := ADD_DAY(LAST_DAY(p_DATA), wk_DIAMES);
    ELSE
      wk_retorno := ADD_DAY(TRUNC(p_DATA),(wk_DIAMES - CAST(TO_CHAR(p_DATA,'DD') AS INTEGER)));
    END IF; 
  END IF;

  RETURN wk_retorno;
END;
$$ language 'plpgsql';




/*-- SEQ 0861 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_StripDouble (VARCHAR) CASCADE;

/*-- SEQ 0862 --*/
CREATE OR REPLACE FUNCTION AUX_StripDouble (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pString ALIAS FOR $1 ;
  String VARCHAR(4000);
BEGIN
  String := pString;
  LOOP
    EXIT WHEN INSTR(String,'  ') <= 0;
    String := REPLACE(String,'  ',' ');
  END LOOP;
  RETURN String;
END;
$$ language 'plpgsql';





/*-- SEQ 0863 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_StrZero (Numeric,Integer,Integer) CASCADE;

/*-- SEQ 0864 --*/
CREATE OR REPLACE FUNCTION AUX_StrZero (Numeric,Integer,Integer)
RETURNS VARCHAR AS $$
DECLARE
Numero ALIAS FOR $1 ;
qtdezeros ALIAS FOR $2 ;
Decimais ALIAS FOR $3 ;
  wk_retorno VARCHAR(30);
  wk_mascara VARCHAR(30);
BEGIN
  wk_mascara := 'fm'||LPAD('0',qtdezeros-decimais,'0')||'.'||LPAD('0',decimais,'0');
  wk_retorno := REPLACE(TO_CHAR(Numero,wk_mascara),'.','');
  RETURN wk_retorno;
END;
$$ language 'plpgsql';




/*-- SEQ 0865 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_TotalizaNoProjeto (TT_WOR.FILPRJ%TYPE,TT_WOR.SEQPRJ%TYPE,TD_SIT.TIPSIT%TYPE,TT_WOR.FLGACT%TYPE,TT_WOR.TARREA%TYPE,TT_WOR.TARPRE%TYPE,TT_WOR.CONCLU%TYPE) CASCADE;

/*-- SEQ 0866 --*/
CREATE OR REPLACE FUNCTION AUX_TotalizaNoProjeto (TT_WOR.FILPRJ%TYPE,TT_WOR.SEQPRJ%TYPE,TD_SIT.TIPSIT%TYPE,TT_WOR.FLGACT%TYPE,TT_WOR.TARREA%TYPE,TT_WOR.TARPRE%TYPE,TT_WOR.CONCLU%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_Filial ALIAS FOR $1 ;
p_Codigo ALIAS FOR $2 ;
p_Status ALIAS FOR $3 ;
p_Aceite ALIAS FOR $4 ;
p_Real ALIAS FOR $5 ;
p_Previsto ALIAS FOR $6 ;
p_Feito ALIAS FOR $7 ;
  wk_filpai TT_PRJ.FILPAI%TYPE;
  wk_codpai TT_PRJ.SEQPAI%TYPE;
  wk_conta  Numeric;
  WK_NADA   VARCHAR(30);
  vUSA_PERC_HORFAL VARCHAR(1);
BEGIN

  select USA_PERC_HORFAL into vUSA_PERC_HORFAL
    from TT_CFG;
    
  UPDATE TT_PRJ SET TOTW_A = COALESCE(TOTW_A,0) + CASE WHEN P_STATUS = 'A' THEN 1 ELSE 0 END,
                    TOTW_C = COALESCE(TOTW_C,0) + CASE WHEN P_STATUS = 'C' THEN 1 ELSE 0 END,
                    TOTW_I = COALESCE(TOTW_I,0) + CASE WHEN P_STATUS = 'I' THEN 1 ELSE 0 END,
                    TOTW_E = COALESCE(TOTW_E,0) + CASE WHEN P_STATUS = 'E' THEN 1 ELSE 0 END,
                    TOTW_X = COALESCE(TOTW_X,0) + CASE WHEN P_STATUS = 'X' THEN 1 ELSE 0 END,
                    TOTW_1 = COALESCE(TOTW_1,0) + CASE WHEN P_STATUS = '1' THEN 1 ELSE 0 END,
                    TOTW_2 = COALESCE(TOTW_2,0) + CASE WHEN P_STATUS = '2' THEN 1 ELSE 0 END,
                    TOTW_S = COALESCE(TOTW_S,0) + CASE WHEN P_STATUS = 'S' THEN 1 ELSE 0 END,
                    TOTA_T = COALESCE(TOTA_T,0) + CASE WHEN P_STATUS = 'T' THEN 1 ELSE 0 END,
                    TOTA_F = COALESCE(TOTA_F,0) + CASE WHEN P_STATUS = 'F' THEN 1 ELSE 0 END,
                    TOTA_N = COALESCE(TOTA_N,0) + CASE WHEN P_STATUS = 'N' THEN 1 ELSE 0 END,
                    HORREA = COALESCE(HORREA,0) + CASE WHEN P_STATUS = 'C' THEN 0 ELSE
                                                  CASE WHEN P_STATUS = 'S' THEN 0 ELSE P_REAL END
                                             END,
                    HORFAL = COALESCE(HORFAL,0) + HORAS_FALTANTES(P_STATUS,P_PREVISTO,P_REAL,p_Feito,vUSA_PERC_HORFAL)                    
   WHERE CODFIL = p_Filial
     AND SEQUEN = p_Codigo;

  -- Atualiza a arvore
  SELECT count(*) INTO wk_conta FROM TT_PRJ WHERE CODFIL = p_Filial AND SEQUEN = p_Codigo;
  if wk_conta > 0 then
    SELECT FILPAI,SEQPAI INTO wk_filpai,wk_codpai FROM TT_PRJ WHERE CODFIL = p_Filial AND SEQUEN = p_Codigo;
  END if;

  IF (wk_filpai IS NOT NULL) AND (wk_codpai IS NOT NULL) THEN
     WK_NADA := AUX_TotalizaNoProjeto(wk_filpai,
                       wk_codpai,
                       p_Status,
                       p_Aceite,
                       p_Real,
                       p_Previsto,
                       p_Feito);
  END IF;

  Return null;
END;
$$ language 'plpgsql';





/*-- SEQ 0867 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Aux_TrazBaixa (TT_TIT.CODBAI%TYPE,Numeric) CASCADE;

/*-- SEQ 0868 --*/
CREATE OR REPLACE FUNCTION Aux_TrazBaixa (TT_TIT.CODBAI%TYPE,Numeric)
RETURNS VARCHAR AS $$
DECLARE
wk_codbai ALIAS FOR $1 ;
wk_przbai ALIAS FOR $2 ;
-- Objetivo
-- Construir uma fraze para colocar no boleto bancrio para Baixa.
  Resultado VARCHAR(100) := '';
    c_LF       char(2)    := chr(13) || chr(10);
    cPRZBAI VARCHAR(20);
begin
  cPRZBAI:= TO_CHAR(wk_przbai);

  if  (wk_przbai > 0)
  and (wk_codbai <> 0)
  and (wk_codbai <> 2) then
    Resultado := 'Baixar aps '||cPRZBAI||' dias.' || c_LF;
  end if;
  Return Resultado;
END;
$$ language 'plpgsql';




/*-- SEQ 0869 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Aux_TrazDesconto (TT_TIT.CODDES%TYPE,Numeric,VARCHAR,VARCHAR,TT_CTB.DIAPRO%TYPE,TT_CTB.PERPRO%TYPE,TT_CTB.NUMPRO%TYPE,Numeric,Timestamp,Timestamp,TT_TIT.CODBCO%TYPE,TT_TIT.NUMAGE%TYPE,TT_TIT.CTACRR%TYPE) CASCADE;

/*-- SEQ 0870 --*/
CREATE OR REPLACE FUNCTION Aux_TrazDesconto (TT_TIT.CODDES%TYPE,Numeric,VARCHAR,VARCHAR,TT_CTB.DIAPRO%TYPE,TT_CTB.PERPRO%TYPE,TT_CTB.NUMPRO%TYPE,Numeric,Timestamp,Timestamp,TT_TIT.CODBCO%TYPE,TT_TIT.NUMAGE%TYPE,TT_TIT.CTACRR%TYPE)
RETURNS VARCHAR AS $$
DECLARE
wk_coddes ALIAS FOR $1 ;
wk_jurdes ALIAS FOR $2 ;
wk_DATDES ALIAS FOR $3 ;
WK_MOEDA ALIAS FOR $4 ;
WK_DIAPRO ALIAS FOR $5 ;
WK_PERPRO ALIAS FOR $6 ;
WK_NUMPRO ALIAS FOR $7 ;
WK_AVISTA ALIAS FOR $8 ;
WK_DATVEN ALIAS FOR $9 ;
WK_DATHOR ALIAS FOR $10 ;
WK_CODBCO ALIAS FOR $11 ;
WK_NUMAGE ALIAS FOR $12 ;
WK_CTACRR ALIAS FOR $13 ;
-- Objetivos
-- Construir uma frase para colocar no boleto bancrio para descontos antecipado.

  cJURDES VARCHAR(20);
  Resultado VARCHAR(255) := '';
    c_LF       char(2)    := chr(13) || chr(10);
    WK_DATPRO Timestamp;
    WK_JURPRO TT_CTB.PERPRO%TYPE;
begin
  cJURDES:= to_char(wk_JURDES);

  if  (wk_JURDES  > 0)
  and (wk_coddes <> 0)
  and (wk_coddes <> 7) then

    Resultado := 'Desconto de ';

    if wk_coddes = 1 then
      Resultado := Resultado || WK_MOEDA || ' ' || cJURDES || ' para pagamentos at ' || wk_DATDES ||'.';
    elsif wk_coddes = 2 then
      Resultado := Resultado || cJURDES || '% para pagamentos at ' || wk_DATDES ||'.';
    elsif wk_coddes = 3 then
      Resultado := Resultado || WK_MOEDA || ' ' || cJURDES || ' por antecipao de dia corrido.';
    elsif wk_coddes = 4 then
      Resultado := Resultado || WK_MOEDA || ' ' || cJURDES || ' por antecipao de dia til.';
    elsif wk_coddes = 5 then
      Resultado := Resultado || cJURDES || '% sobre o valor nominal no dia corrido.';
    elsif wk_coddes = 6 then
      Resultado := Resultado || cJURDES || '% sobre o valor nominal no dia til.';
    end if;
    Resultado := Resultado || c_LF;
    /* Descontos Regressivos*/
    WK_DATPRO := add_day(WK_DATVEN,WK_DIAPRO);
    WK_JURPRO := cJURDES;
    FOR i IN 1..WK_NUMPRO LOOP
       wk_JURPRO := ROUND(WK_JURPRO - (cJURDES * (WK_PERPRO/100)),2);
         if WK_JURPRO > 0 then
             Resultado := Resultado ||'Desconto de '|| TO_CHAR(WK_JURPRO,'fm9990D00') || '% para pagamento at ' || TO_CHAR(WK_DATPRO,'DD/MM/YYYY') ||'.'||c_LF;
         end if;
       WK_DATPRO := add_day(WK_DATPRO,WK_DIAPRO);
    END LOOP;
    end if;
    Return Resultado;
END;
$$ language 'plpgsql';




/*-- SEQ 0871 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Aux_TrazIns () CASCADE;

/*-- SEQ 0872 --*/
CREATE OR REPLACE FUNCTION Aux_TrazIns ()
RETURNS VARCHAR AS $$
DECLARE

-- Objetivos
-- Construir uma frase para colocar no boleto bancrio para instrues configurveis
  Resultado VARCHAR(90) := '';
  wk_inst1 VARCHAR(40);
  wk_inst2 VARCHAR(40);
    c_LF       char(2)       := chr(13) || chr(10);
begin
  -- sempre sero as instrues de remessa
  SELECT COALESCE(INS1.DESINS,'#%#%#'), COALESCE(INS2.DESINS,'#%#%#') INTO WK_INST1, WK_INST2
  FROM TT_REM REM LEFT OUTER JOIN TD_INS INS1 ON REM.INSTR1 = INS1.CODTAB
                  LEFT OUTER JOIN TD_INS INS2 ON REM.INSTR2 = INS2.CODTAB
                       INNER JOIN TT_CFG CFG  ON REM.CODREM = CFG.INT_INC_TIT;

  if wk_inst1 <> '#%#%#' then
    Resultado := Resultado || wk_Inst1 || c_LF;
  end if;
  if wk_inst2 <> '#%#%#' then
    Resultado := Resultado || wk_Inst2 || c_LF;
  end if;

  Return Resultado;
END;
$$ language 'plpgsql';




/*-- SEQ 0873 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Aux_TrazMora (TT_TIT.CODMOR%TYPE,Numeric,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 0874 --*/
CREATE OR REPLACE FUNCTION Aux_TrazMora (TT_TIT.CODMOR%TYPE,Numeric,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
wk_codmor ALIAS FOR $1 ;
wk_jurmor ALIAS FOR $2 ;
wk_DATMOR ALIAS FOR $3 ;
WK_MOEDA ALIAS FOR $4 ;

-- Objetivos
-- Construir uma fraze para colocar no boleto bancario para juros de mora.
  Resultado VARCHAR(100) := '';
    c_LF       char(2)       := chr(13) || chr(10);
    cJURMOR VARCHAR(20);
begin

  cJURMOR:=  TO_CHAR(wk_jurmor,'fm9990D00');

  if  (wk_jurmor  > 0)
  and (wk_codmor <> 0)
  and (wk_codmor <> 3) then
    Resultado := 'Cobrar acrescimo ';

    if wk_codmor = 1 then
      Resultado := Resultado || 'diario ';
      Resultado := Resultado || 'de '|| WK_MOEDA ||' '|| cJURMOR ||' a partir de ' || wk_DATMOR ||'.'||c_LF;
    else
      Resultado := Resultado || 'mensal ';
      Resultado := Resultado || 'de '|| cJURMOR ||'% a partir de ' || wk_DATMOR ||'.'||c_LF;
    end if;
  end if;

  Return Resultado;
END;
$$ language 'plpgsql';




/*-- SEQ 0875 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Aux_TrazProtesto (TT_TIT.CODPRT%TYPE,Numeric) CASCADE;

/*-- SEQ 0876 --*/
CREATE OR REPLACE FUNCTION Aux_TrazProtesto (TT_TIT.CODPRT%TYPE,Numeric)
RETURNS VARCHAR AS $$
DECLARE
wk_codprt ALIAS FOR $1 ;
wk_przprt ALIAS FOR $2 ;
-- Objetivos
-- Construir uma fraze para colocar no boleto bancrio para Protesto.
  Resultado VARCHAR(100) := '';
    c_LF       char(2)       := chr(13) || chr(10);
    cPRZPRT VARCHAR(20);
begin

  cPRZPRT:= TO_CHAR(wk_przprt);

  if  (wk_przprt  > 0)
  and (wk_codprt <> 0)
  and (wk_codprt <> 3) then

    Resultado := 'Protestar aps '||cPRZPRT||' dias ';

    if wk_codprt = 1 then
      Resultado := Resultado || 'corridos.';
    else
      Resultado := Resultado || 'teis.';
    end if;

    Resultado := Resultado || c_LF;
  end if;

  Return Resultado;
END;
$$ language 'plpgsql';




/*-- SEQ 0877 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_Validade (VARCHAR,TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 0878 --*/
CREATE OR REPLACE FUNCTION AUX_Validade (VARCHAR,TD_FIL.CODFIL%TYPE)
RETURNS TRetAuxValida AS $$
DECLARE
Tabela ALIAS FOR $1 ;
Quem ALIAS FOR $2 ;
-- Objetivos
-- Retorna a data valida
  first Timestamp;
  last  Timestamp;
  inicio Timestamp;
  fim    Timestamp;
  autoriza char(1);
  Retorno TRetAuxValida%ROWTYPE;
begin
  if    Upper(Ltrim(Rtrim(Tabela))) = 'TT_VOL'  then select INIFIL,EXP_SD,case when HOM_SD IS NULL THEN 'F' ELSE 'T' END into first,last,autoriza from td_fil where codfil = quem;
  elsif Upper(Ltrim(Rtrim(Tabela))) = 'TT_SUP'  then select INIFIL,EXP_SW,case when HOM_SW IS NULL THEN 'F' ELSE 'T' END into first,last,autoriza from td_fil where codfil = quem;
  elsif Upper(Ltrim(Rtrim(Tabela))) = 'TT_PTR'  then select INIFIL,EXP_BO,case when HOM_BO IS NULL THEN 'F' ELSE 'T' END into first,last,autoriza from td_fil where codfil = quem;
  elsif Upper(Ltrim(Rtrim(Tabela))) = 'TT_LID'  then select INIFIL,EXP_CS,case when HOM_CS IS NULL THEN 'F' ELSE 'T' END into first,last,autoriza from td_fil where codfil = quem;
  elsif Upper(Ltrim(Rtrim(Tabela))) = 'TT_ORC'  then select INIFIL,EXP_OR,case when HOM_OR IS NULL THEN 'F' ELSE 'T' END into first,last,autoriza from td_fil where codfil = quem;
  elsif Upper(Ltrim(Rtrim(Tabela))) = 'TT_ORC*' then select INIFIL,EXP_SE,case when HOM_SE IS NULL THEN 'F' ELSE 'T' END into first,last,autoriza from td_fil where codfil = quem;
  elsif Upper(Ltrim(Rtrim(Tabela))) = 'TT_COM'  then select INIFIL,EXP_BO,case when HOM_BO IS NULL THEN 'F' ELSE 'T' END into first,last,autoriza from td_fil where codfil = quem;
  elsif Upper(Ltrim(Rtrim(Tabela))) = 'TT_VEN'  then select INIFIL,EXP_BO,case when HOM_BO IS NULL THEN 'F' ELSE 'T' END into first,last,autoriza from td_fil where codfil = quem;
  elsif Upper(Ltrim(Rtrim(Tabela))) = 'TT_FIN'  then select INIFIL,EXP_BO,case when HOM_BO IS NULL THEN 'F' ELSE 'T' END into first,last,autoriza from td_fil where codfil = quem;
  else
    -- No precisa fazer o teste se nao for uma das tabelas esperadas
    Retorno.Retorno := 0;
    Return Retorno;
  end if;

  Retorno.Inicio := first;

  -- Atribui carencia de 10 dias para quem ja possui autorizacao
  -- e 30 dias para quem esta em processo de obtencao
  if autoriza = 'T' then
    Retorno.Fim := trunc(last) + 10;
  else
    Retorno.Fim := trunc(last) + 30;
  end if;

  Retorno.Retorno := 1;
  Return Retorno;
END;
$$ language 'plpgsql';







/*-- SEQ 0879 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CRIA_BALANCETE_ANALITICO (TT_CTA.CODFIL%TYPE,TT_DAT.DATOPE%TYPE,TT_DAT.DATOPE%TYPE) CASCADE;

/*-- SEQ 0880 --*/
CREATE OR REPLACE FUNCTION CRIA_BALANCETE_ANALITICO (TT_CTA.CODFIL%TYPE,TT_DAT.DATOPE%TYPE,TT_DAT.DATOPE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pDATINI ALIAS FOR $2 ;
pDATFIM ALIAS FOR $3 ;

  -- cria balancete analitico

BEGIN
  
  INSERT INTO TW_CTA ( VLRTO1, VLRTO2, VLRTO3, VLRTO4,
                       USERID, CHV_ID, CHVPAI, TIPCTA, FILCTA, SEQCTA, TITCTA  ,ARVORE              
)
       SELECT COALESCE( TO1.SALDO_INICIAL, 0 ) AS VLRTO1,
              COALESCE( TO1.CREDITO, 0 )       AS VLRTO2,
              COALESCE( TO1.DEBITO, 0 )        AS VLRTO3,
              COALESCE( TO1.SALDO_FINAL, 0 )   AS VLRTO4,
              ECT.USERID,
              ECT.CHV_ID,
              ECT.CHVPAI,
              ECT.TIPCTA,
              ECT.FILCTA,
              ECT.SEQCTA,
              ECT.TITCTA
                 ,substr(ECT.TITCTA, 1, instr(titcta,' ')-1) as ARVORE  
         FROM TW_ECT ECT
         LEFT OUTER JOIN
              (SELECT INTE.*, CASE WHEN TIPCTA = 'G'
                                  THEN CREDITO - DEBITO
                                  ELSE (SALDO_INICIAL + CREDITO - DEBITO)
                             END AS SALDO_FINAL
                FROM (SELECT CTA.TIPCTA, CTA.CODFIL as FILCTA, CTA.SEQUEN AS SEQCTA,
                             CASE WHEN CTA.TIPCTA = 'G'
                                  THEN 0.00
                                  ELSE SaldoConta( CTA.CODFIL, CTA.SEQUEN, CTA.TIPCTA,
                                                   ADD_DAY(INI.DATOPE,-1),'R',pCODFIL)
                             END AS SALDO_INICIAL,
                            (SELECT COALESCE(SUM(RES.TOTCRE),0.00)                                      
                               FROM TR_CTA RES                                                          
                              WHERE RES.FILCTA = CTA.CODFIL                                             
                                AND RES.SEQCTA = CTA.SEQUEN                                             
                                AND RES.TIPCTA = CTA.TIPCTA                                             
                                AND RES.FLGFLX = 'R'
                                AND RES.FILLAN = COALESCE(pCODFIL,RES.FILLAN)
                                AND RES.DATLAN >= INI.DATOPE                                            
                                AND RES.DATLAN <= FIM.DATOPE) AS CREDITO,                               
                            (SELECT COALESCE(SUM(RES.TOTDEB),0.00)                                      
                               FROM TR_CTA RES                                                          
                              WHERE RES.FILCTA = CTA.CODFIL                                             
                                AND RES.SEQCTA = CTA.SEQUEN                                             
                                AND RES.TIPCTA = CTA.TIPCTA                                             
                                AND RES.FLGFLX = 'R'
                                AND RES.FILLAN = COALESCE(pCODFIL,RES.FILLAN)
                                AND RES.DATLAN >= INI.DATOPE                                            
                                AND RES.DATLAN <= FIM.DATOPE) AS DEBITO                                 
                        FROM TT_DAT INI, TT_DAT FIM,                                
                                TT_CTA CTA INNER JOIN TT_ECT ECT ON ECT.CODFIL = CTA.FILECT                
                                                                AND ECT.SEQUEN = CTA.SEQECT
                    WHERE INI.DATOPE = pDATINI
                      AND FIM.DATOPE = pDATFIM) INTE                                               
                  WHERE SALDO_INICIAL <> 0
                     OR CREDITO <> 0                                                                       
                     OR DEBITO <> 0        ) TO1                                                           
              ON ECT.TIPCTA = TO1.TIPCTA AND ECT.FILCTA = TO1.FILCTA AND ECT.SEQCTA = TO1.SEQCTA
           WHERE ECT.USERID = USERENV('SESSIONID') ORDER BY ECT.TITCTA;
    
   RETURN 'OK';
END;
$$ language 'plpgsql';


/*-- SEQ 0881 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CRIA_BALANCETE_ANALITICO () CASCADE;

/*-- SEQ 0882 --*/
CREATE OR REPLACE FUNCTION CRIA_BALANCETE_ANALITICO () 
RETURNS VARCHAR AS $$
BEGIN
RETURN CRIA_BALANCETE_ANALITICO(1);
END;
$$ language 'plpgsql';


/*-- SEQ 0883 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalcSaldoRazao (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,Timestamp,TT_RZR.SEQUEN%TYPE) CASCADE;

/*-- SEQ 0884 --*/
CREATE OR REPLACE FUNCTION CalcSaldoRazao (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,Timestamp,TT_RZR.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFilcli ALIAS FOR $1 ;
pCodcli ALIAS FOR $2 ;
pDatInc ALIAS FOR $3 ;
pSequen ALIAS FOR $4 ;
-- Objetivo
-- 1) Recalcular a movimentacao diaria de um produto a partir de uma data

  TotQtd   TR_MOV.SALANT%TYPE;  
  Primeiro boolean default true;
  
  Movto CURSOR FOR
  select *
    from (
        select *
          from tt_rzr
         where filcli =pFilCli
           and codcli =pCodCli
           and datinc =pDatInc
           and sequen>=pSequen
        union all
        select *
          from tt_rzr
         where filcli=pFilCli  
           and codcli=pCodCli  
       and datinc>pDatInc
) tab
order by datinc,sequen;
  temp TT_RZR%ROWTYPE;

-- Principal
begin
  OPEN MovTo;
  LOOP
    FETCH MovTo into temp;
    EXIT WHEN NOT FOUND;
    
    if Primeiro then
      TotQtd := SaldoRazao(pFilcli,pCodcli,pDatInc,pSequen);
    end if;    
    
    -- Acumula para o proximo
    TotQtd := TotQtd + COALESCE(temp.VLRLAN,0);    
    
    update TT_RZR set VLRSAL = TOTQTD
     where CODFIL = temp.CODFIL
       and SEQUEN = temp.SEQUEN;    
    
    Primeiro := false;
  END LOOP;
  CLOSE MovTo; 

  RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 0885 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalcSaldoRazao (TR_MOV.CODFIL%TYPE,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,TR_MOV.DATMOV%TYPE) CASCADE;

/*-- SEQ 0886 --*/
CREATE OR REPLACE FUNCTION CalcSaldoRazao (TR_MOV.CODFIL%TYPE,
                               TR_MOV.FILMAT%TYPE,
                               TR_MOV.CODMAT%TYPE,
                               TR_MOV.CODCOR%TYPE,
                               TR_MOV.CODTAM%TYPE,
                               TR_MOV.DATMOV%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN CalcSaldoRazao($1,$2,$3,$4,$5,$6,0);
END;
$$ language 'plpgsql';



/*-- SEQ 0887 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CancelaItensExpirados () CASCADE;

/*-- SEQ 0888 --*/
CREATE OR REPLACE FUNCTION CancelaItensExpirados ()
RETURNS VARCHAR AS $$
DECLARE

  dQuando           TT_PED.DATPED%TYPE;
  cDias             TT_CFG.DIAS_EXPIRAR_PEDIDO%TYPE;

  crPEDIDOS_EXPIRADOS CURSOR(p_Dias TT_CFG.DIAS_EXPIRAR_PEDIDO%TYPE,
           p_Quando TT_PED.DATPED%TYPE) IS
  SELECT IPE.CODFIL, IPE.NUMPED, IPE.NUMITE
    FROM TT_IPE IPE
   WHERE FLGEST = 'A'
     AND (CODFIL, NUMPED) IN (SELECT PED.CODFIL, PED.NUMPED
                                FROM TT_PED PED
                               INNER JOIN TT_IPE IIPE ON PED.CODFIL=IIPE.CODFIL AND PED.NUMPED=IIPE.NUMPED
                               WHERE PED.CODFIL = IPE.CODFIL
                                 AND PED.NUMPED = IPE.NUMPED
                                 AND IIPE.FLGEST = 'E'
                                 AND p_Quando > ADD_DAY(PED.DATPED, p_Dias));

  Detalhe     record;

BEGIN
  SELECT COALESCE(DIAS_EXPIRAR_PEDIDO, 0) INTO cDias FROM TT_CFG;

  IF cDias > 0 THEN
    dQuando := Agora();

    -- Carrega para memrias pedidos que sero cancelados
    OPEN crPEDIDOS_EXPIRADOS(cDias,dQuando);
    LOOP
        FETCH crPEDIDOS_EXPIRADOS INTO Detalhe;
        EXIT WHEN NOT FOUND;

        -- Cancelar Itens de Pedido de Compra Parcial, que expiraram o prazo definido em TT_CFG.DIAS_EXPIRAR_PEDIDO
        UPDATE TT_IPE IPE SET FLGEST = 'C'
         WHERE FLGEST = 'A'
           AND CODFIL = Detalhe.CODFIL
           AND NUMPED = Detalhe.NUMPED
           AND NUMITE = Detalhe.NUMITE;

        -- RFMP 75328
        UPDATE TT_PED
           SET FLGEST = 'Y'
         WHERE CODFIL = Detalhe.CODFIL
           AND NUMPED = Detalhe.NUMPED;
    END LOOP;
    CLOSE crPEDIDOS_EXPIRADOS;

  END IF;

  RETURN 'OK';
END;
$$ language 'plpgsql';



/*-- SEQ 0889 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_CancelaItensExpirados (TT_JOB.CODUID%TYPE) CASCADE;

/*-- SEQ 0890 --*/
CREATE OR REPLACE FUNCTION Job_CancelaItensExpirados (TT_JOB.CODUID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODUID ALIAS FOR $1 ;
   vNOME                         TT_JOB.NOMJOB%TYPE;
   vDESC                         TT_JOB.DESJOB%TYPE;
   DUMMY                         CHAR(2);
BEGIN
   vNOME := 'JOB_CANCELAITENSEXPIRADOS';
   vDESC := 'Rotina para cancelar itens no recebidos na compra';
   BEGIN
      DUMMY := CancelaItensExpirados();
      DUMMY := RegistraJob(vNOME, vDESC, NULL, pCODUID);
   EXCEPTION
      WHEN OTHERS THEN DUMMY := RegistraJob(vNOME, vDESC, SQLERRM, pCODUID);
   END;
  RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 0891 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_CancelaItensExpirados () CASCADE;

/*-- SEQ 0892 --*/
CREATE OR REPLACE FUNCTION Job_CancelaItensExpirados () 
RETURNS VARCHAR AS $$
BEGIN
RETURN Job_CancelaItensExpirados(NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 0893 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CancelaReserva () CASCADE;

/*-- SEQ 0894 --*/
CREATE OR REPLACE FUNCTION CancelaReserva ()
RETURNS VARCHAR AS $$
DECLARE

  cCancela CHAR(1);
  dQuando  Timestamp;
BEGIN
  SELECT CANCELA_RESERVA INTO cCancela FROM TT_CFG;

  IF cCancela = 'T' THEN
    dQuando := Trunc(Agora());

    UPDATE TT_IOR SET FLGEST = 'A'
     WHERE FLGEST = 'R'
       AND (CODFIL,NUMPED,TIPPED) IN (SELECT CODFIL,NUMPED,TIPPED
                                       FROM TT_ORC
                                      WHERE FLGEST IN ('A','E')
                                        AND TIPPED IN ('O','P')
                                        AND DATVAL < dQuando);

    UPDATE TT_ORC SET RESERV = 'F', NUMRES=NULL
     WHERE RESERV = 'T'
       AND FLGEST IN ('A','E')
       AND TIPPED IN ('O','P')
       AND DATVAL < dQuando;
  END IF;

  RETURN 'OK';
END;
$$ language 'plpgsql';



/*-- SEQ 0895 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_CancelaReserva (TT_JOB.CODUID%TYPE) CASCADE;

/*-- SEQ 0896 --*/
CREATE OR REPLACE FUNCTION Job_CancelaReserva (TT_JOB.CODUID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODUID ALIAS FOR $1 ;
   vNOME                         TT_JOB.NOMJOB%TYPE;
   vDESC                         TT_JOB.DESJOB%TYPE;
   dummy                         CHAR(2);
BEGIN
   vNOME := 'JOB_CANCELARESERVA';
   vDESC := 'Rotina para cancelar reservas nao confirmadas';
   BEGIN
      dummy := CancelaReserva();
      DUMMY := RegistraJob(vNOME, vDESC, NULL, pCODUID);
   EXCEPTION
      WHEN OTHERS THEN DUMMY := RegistraJob(vNOME, vDESC, SQLERRM, pCODUID);
   END;
  RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 0897 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_CancelaReserva () CASCADE;

/*-- SEQ 0898 --*/
CREATE OR REPLACE FUNCTION Job_CancelaReserva () 
RETURNS VARCHAR AS $$
BEGIN
RETURN Job_CancelaReserva(NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 0899 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION InsereCartasCobranca () CASCADE;

/*-- SEQ 0900 --*/
CREATE OR REPLACE FUNCTION InsereCartasCobranca ()
RETURNS VARCHAR AS $$
DECLARE

 -- Objetivo: Inserir cartas de cobranca a partir de TT_REC e TT_CHR
   vCodfil                       tt_car.filcar%type;
   vSequen                       tt_car.sequen%type;
   vFilRec                       tt_rec.codfil%type;
   vSeqRec                       tt_rec.sequen%type;
   vNumPar                       tt_rec.numpar%type;
   vSubPar                       tt_rec.subpar%type;
   vFilCli                       tt_ven.filcli%type;
   vCodCli                       tt_ven.codcli%type;
   vFilEnd                       tt_ven.filcob%type;
   vNumEnd                       tt_ven.endcob%type;
   vFilChr                       tt_chr.codfil%type;
   vSeqChr                       tt_chr.sequen%type;
   vDatVen                       tt_rec.datven%type;

   nPasso                        INTEGER;
   vTipCor                       TT_COR.TIPCOR%TYPE;
   nCount                        INTEGER;
   LF                            CHAR(2):=CHR(13)||CHR(10);
   cFILIAL                       TD_FIL.CODFIL%TYPE;

   cEMAIL                        TT_CFG.COB_E_MAIL_CARTAS%TYPE;
   cMAI_FR                       TT_CFG.MAI_FR%TYPE;

PARCELAS CURSOR(pTipCor TT_COR.TIPCOR%TYPE) IS
 SELECT REC.CODFIL AS FILREC,
        REC.SEQUEN AS SEQREC,
        REC.NUMPAR,
        REC.SUBPAR,
        VEN.FILCLI,
        VEN.CODCLI,
        VEN.FILCOB,
        VEN.ENDCOB,
        CAST('' AS CHAR(3))  AS FILCHR,
        CAST('' AS CHAR(10)) AS CODCHR,
        REC.DATVEN
   FROM TT_REC REC INNER JOIN TT_VEN     VEN ON VEN.CODFIL = REC.CODFIL AND
                                                VEN.SEQUEN = REC.SEQUEN
                   INNER JOIN TT_CFG CFG ON (VEN.FILCLI||VEN.CODCLI) <> (CFG.VC_FILCLI||CFG.VC_CODCLI)
                    LEFT JOIN TT_CORxCOB CXC ON CXC.FILREC = REC.CODFIL AND
                                                CXC.SEQREC = REC.SEQUEN AND
                                                CXC.NUMPAR = REC.NUMPAR AND
                                                CXC.SUBPAR = REC.SUBPAR
                    LEFT JOIN TT_COR     COR ON COR.CODFIL = CXC.FILCOR AND
                                                COR.SEQUEN = CXC.SEQCOR AND
                                                COR.TIPCOR = pTipCor
  WHERE case when pTipCor = '1' then CFG.COB_MOD_CODCOR1
             else CFG.COB_MOD_CODCOR2
        end IS NOT NULL
    AND REC.FLGEST = 'A'
    AND REC.DATVEN <= add_day(TRUNC(AGORA()), - case when pTipCor = '1' then CFG.COB_DIAS_CARTA1_REC
                                            else CFG.COB_DIAS_CARTA2_REC
                                       end)
    AND REC.CARTAO IS NULL
    AND REC.SEQCHE IS NULL
    AND CXC.SEQCOR IS NULL
    AND case when pTipCor = '1' then CFG.COB_DIAS_CARTA1_REC
             else CFG.COB_DIAS_CARTA2_REC
        end > 0
 UNION ALL
 SELECT CAST('' AS CHAR(3))  AS FILREC,
        CAST('' AS CHAR(10)) AS SEQREC,
        CAST('' AS CHAR(2))  AS NUMPAR,
        CAST('' AS CHAR(2))  AS SUBPAR,
        VEN.FILCLI,
        VEN.CODCLI,
        VEN.FILCOB,
        VEN.ENDCOB,
        CHR.CODFIL AS FILCHR,
        CHR.SEQUEN AS CODCHR,
        CHR.PAGAME
 FROM TT_CHR CHR INNER JOIN TT_REC     REC ON REC.FILREC = CHR.CODFIL AND
                                              REC.SEQCHE = CHR.SEQUEN
                 INNER JOIN TT_VEN     VEN ON VEN.CODFIL = REC.CODFIL AND
                                              VEN.SEQUEN = REC.SEQUEN
                 INNER JOIN TT_CFG CFG ON (VEN.FILCLI||VEN.CODCLI) <> (CFG.VC_FILCLI||CFG.VC_CODCLI)
                  LEFT JOIN TT_CORxCOB CXC ON CXC.FILCHR = CHR.CODFIL AND
                                              CXC.SEQCHR = CHR.SEQUEN
                  LEFT JOIN TT_COR     COR ON COR.CODFIL = CXC.FILCOR AND
                                              COR.SEQUEN = CXC.SEQCOR AND
                                              COR.TIPCOR = pTipCor
  WHERE case when pTipCor = '1' then CFG.COB_MOD_CODCOR1
             else CFG.COB_MOD_CODCOR2
        end IS NOT NULL
    AND CHR.FLGEST = 'D'
    AND CHR.PAGAME <= add_day(TRUNC(AGORA()),- CFG.COB_DIAS_CARTA1_CHR)
    AND CXC.SEQCOR IS NULL
    AND case when pTipCor = '1' then CFG.COB_DIAS_CARTA1_CHR
             else CFG.COB_DIAS_CARTA2_CHR
        end > 0;

CARTAS CURSOR(pFilCli TT_CLI.FILCLI%TYPE,
           pCodCli TT_CLI.CODCLI%TYPE) IS
 SELECT COR.CODFIL, COR.SEQUEN
   FROM TT_COR COR
  WHERE COR.FILCLI = pFilCli
    AND COR.CODCLI = pCodCli
    AND COR.DATIMP IS NULL;

ENDERECO CURSOR(pFilCli TT_CLI.FILCLI%TYPE,
           pCodCli TT_CLI.CODCLI%TYPE) IS
  SELECT LOC.CODFIL,
         LOC.NUMEND
    FROM TT_CLI CLI INNER JOIN TT_END LOC ON LOC.FILCLI = CLI.FILCLI AND
                                             LOC.CODCLI = CLI.CODCLI
   WHERE CLI.FILCLI = pFilCli
     AND CLI.CODCLI = pCodCli
   ORDER BY  CASE WHEN LOC.ENDCOB = 'T' AND LOC.NUMDOC = CLI.NUMDOC THEN 0
              WHEN LOC.ENDCOB = 'T' THEN 1
              WHEN LOC.ENDCOR = 'T' AND LOC.NUMDOC = CLI.NUMDOC THEN 2
              ELSE 3 END;

BEGIN

 nCount:=0;
 FOR nPasso IN 1..2 LOOP
   SELECT CAST(nPasso AS CHAR(1)) INTO vTipCor FROM DUAL;
   OPEN Parcelas(vTipCor);
   LOOP
     FETCH Parcelas INTO vFilRec, vSeqRec, vNumpar,
                         vSubPar, vFilCli, vCodCli,
                         vFilEnd, vNumEnd, vFilChr,
                         vSeqChr, vDatVen;
     EXIT WHEN NOT FOUND;
     OPEN Cartas(vFilCli,vCodcli);
     FETCH Cartas INTO vCodfil, vSequen;
     IF NOT FOUND THEN

       -- Se o endereco nao foi informado na venda, procura por um.
       IF vFilEnd IS NULL THEN
         OPEN Endereco(vFilCli,vCodCli);
         FETCH Endereco INTO vFilEnd, vNumEnd;
         CLOSE Endereco;
       END IF;

       nCount:=nCount+1;
       INSERT INTO TT_COR (CODFIL, TIPCOR, FILCLI,
                           CODCLI, FILEND, NUMEND,
                           DATOPE, CODCOR)
                   (SELECT IDF.CODLOJ, vTipCor, vFilcli,
                           vCodCli, vFilEnd, vNumEnd,
                           AGORA(),
                           case when vTipCor = '1' then CFG.COB_MOD_CODCOR1
                                else CFG.COB_MOD_CODCOR2 end
                      FROM TT_IDF IDF, TT_CFG CFG);
       CLOSE Cartas;
       OPEN Cartas(vFilcli,vCodcli);
       FETCH Cartas INTO vCodfil, vSequen;
     END IF;

     INSERT INTO TT_CORxCOB (FILCOR, SEQCOR, FILREC,
                             SEQREC, NUMPAR, SUBPAR,
                             FILCHR, SEQCHR)
                     values (vCodFil, vSequen, vFilRec,
                             vSeqRec, vNumPar, vSubPar,
                             vFilChr, vSeqChr);
     CLOSE Cartas;
   END LOOP;
   CLOSE Parcelas;
 END LOOP;

 SELECT CFG.COB_E_MAIL_CARTAS, CFG.MAI_FR, IDF.CODLOJ INTO cEMAIL,cMAI_FR,cFILIAL
  FROM TT_CFG CFG, TT_IDF IDF;

  IF (ISNOTNULL(cEMAIL)='T') AND (ISNOTNULL(cMAI_FR)='T') AND (INSTR(cMAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(cEMAIL, UPPER('@sua_empresa.com')) = 0) AND (nCount>0) THEN
      INSERT INTO TT_MAI
        (CODFIL,MAI_TO,MAI_FR,ASSUNT,TEXTOS,EXCLUI,TIPMSG,DATSOL) VALUES
        (cFILIAL,cEMAIL,cMAI_FR,to_char('Relatorio de cartas enviadas para cobranca'),
         'Novas Cartas Enviadas :'||nCount,
         'F',
         'T',
         AGORA()
        );
  END IF;

 RETURN 'OK';
END;
$$ language 'plpgsql';





/*-- SEQ 0901 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CLIENTEDAHORA (TT_HOR.CODFIL%TYPE,TT_HOR.SEQUEN%TYPE) CASCADE;

/*-- SEQ 0902 --*/
CREATE OR REPLACE FUNCTION CLIENTEDAHORA (TT_HOR.CODFIL%TYPE,TT_HOR.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
PCODFIL ALIAS FOR $1 ;
PSEQUEN ALIAS FOR $2 ;
-- Objetivo
-- 1) Retornar o cliente da hora trabalhada.
CNOMECLI TT_CLI.NOMCLI%TYPE;
-- Principal
BEGIN
 SELECT (CASE WHEN((HOR.FILSUP IS NOT NULL) AND (HOR.SEQSUP IS NOT NULL))THEN CLIS.NOMCLI
       WHEN (HOR.SEQWOR IS NOT NULL) THEN CLIW.NOMCLI  END) INTO cNOMECLI
   FROM TT_HOR HOR
        LEFT OUTER JOIN TT_SUP SPT ON HOR.FILSUP = SPT.CODFIL AND HOR.SEQSUP = SPT.SEQUEN
        LEFT OUTER JOIN TT_WOR WOR ON HOR.CODFIL = WOR.CODFIL AND HOR.SEQWOR = WOR.SEQUEN
        LEFT OUTER JOIN TT_CLI CLIS ON CLIS.FILCLI = SPT.FILCLI AND CLIS.CODCLI = SPT.CODCLI
        LEFT OUTER JOIN TT_CLI CLIW ON CLIW.FILCLI = WOR.FILCLI AND CLIW.CODCLI = WOR.CODCLI
   WHERE HOR.CODFIL=pCodfil
     AND HOR.SEQUEN=pSequen;
   RETURN CNOMECLI;
END;
$$ language 'plpgsql';




/*-- SEQ 0903 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ClienteProjeto (TT_PRJ.CODFIL%TYPE,TT_PRJ.SEQUEN%TYPE) CASCADE;

/*-- SEQ 0904 --*/
CREATE OR REPLACE FUNCTION ClienteProjeto (TT_PRJ.CODFIL%TYPE,TT_PRJ.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCodfil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
-- Objetivo
-- 1) Retornar a nome do cliente associado a uma tarefa

  cFILCLI TT_CLI.FILCLI%TYPE;
  cCODCLI TT_CLI.CODCLI%TYPE;

  Lista CURSOR FOR
    -- Ver detalhes sobre a macro em
-- \\tt2000\Docs\desenv\depto\Manuais\Ansi\connectby.mac
SELECT filcli,codcli
FROM connectby_back('(select to_char(chvprj) as filho,
                             to_char(chvpai) as pai
                   from tt_prj int) tab', 'filho', 'pai', to_char(pCodfil||pSequen))
AS c (conn_codigo VARCHAR, conn_codpai VARCHAR, level int, ordem int)
INNER JOIN tt_prj t ON c.conn_codigo  = (chvprj)
order by ordem;

-- Principal
begin

  OPEN Lista;
  LOOP
     FETCH Lista INTO cFILCLI,cCODCLI;
     EXIT WHEN (NOT FOUND) or (cCODCLI IS NOT NULL);
  END LOOP;     
  Close Lista;
  
  RETURN cFILCLI||cCODCLI;
  
END;
$$ language 'plpgsql';




/*-- SEQ 0905 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ClienteTarefa (TT_WOR.CODFIL%TYPE,TT_WOR.SEQUEN%TYPE,Numeric) CASCADE;

/*-- SEQ 0906 --*/
CREATE OR REPLACE FUNCTION ClienteTarefa (TT_WOR.CODFIL%TYPE,TT_WOR.SEQUEN%TYPE,Numeric)
RETURNS VARCHAR AS $$
DECLARE
pCodfil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
pTipo ALIAS FOR $3 ;
-- Objetivo
-- 1) Retornar a nome do cliente associado a uma tarefa
-- Parametro pTipo:
-- 1 - Nome
-- 2 - Código
-- 3 - Fidelização 

  cNomeCli TT_CLI.NOMCLI%TYPE;
  cChaveCli VARCHAR(20);
  cDESFID TD_FID.DESFID%TYPE;  
  cFILCLI TT_CLI.FILCLI%TYPE;
  cCODCLI TT_CLI.CODCLI%TYPE;
  cFILPRJ TT_WOR.FILPRJ%TYPE;
  cSEQPRJ TT_WOR.SEQPRJ%TYPE;  

  Lista CURSOR(pFilprj TT_WOR.FILPRJ%TYPE,
           pSeqprj TT_WOR.SEQPRJ%TYPE) IS
    -- Ver detalhes sobre a macro em
-- \\tt2000\Docs\desenv\depto\Manuais\Ansi\connectby.mac
SELECT filcli,codcli
FROM connectby_back('(select to_char(chvprj) as filho,
                             to_char(chvpai) as pai
                   from tt_prj int) tab', 'filho', 'pai', to_char(pfilprj||pseqprj))
AS c (conn_codigo VARCHAR, conn_codpai VARCHAR, level int, ordem int)
INNER JOIN tt_prj t ON c.conn_codigo  = (chvprj)
order by ordem
;

-- Principal
begin
  SELECT FILCLI,CODCLI,FILPRJ,SEQPRJ INTO cFILCLI,cCODCLI,cFILPRJ,cSEQPRJ
    FROM TT_WOR
   WHERE CODFIL=pCODFIL
     AND SEQUEN=pSEQUEN;
     
  IF cCODCLI IS NULL THEN        
     OPEN Lista(cFILPRJ,cSEQPRJ);
     LOOP
        FETCH Lista INTO cFILCLI,cCODCLI;
        EXIT WHEN (NOT FOUND) or (cCODCLI IS NOT NULL);
     END LOOP;     
     Close Lista;
  END IF;
  IF cCODCLI IS NOT NULL THEN        
     SELECT CLI.NOMCLI, 
            CLI.FILCLI||CLI.CODCLI AS ChaveCli,
            FID.DESFID AS DESFID  INTO cNomeCLI, cChaveCli, cDESFID
       FROM TT_CLI CLI LEFT JOIN TD_FID FID ON CLI.CODFID=FID.CODTAB
      WHERE CLI.FILCLI=cFILCLI
        AND CLI.CODCLI=cCODCLI;
     IF pTIPO=1 THEN 
        Return cNomeCLI;
     ELSIF pTIPO=2 THEN 
        Return cChaveCli;
     ELSE
        Return cDESFID;
     END IF;       
     
   ELSE
     RETURN NULL; 
   END IF;  
END;
$$ language 'plpgsql';




/*-- SEQ 0907 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION getColunasContraint (VARCHAR) CASCADE;

/*-- SEQ 0908 --*/
CREATE OR REPLACE FUNCTION getColunasContraint (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pConstraint_Name ALIAS FOR $1 ;
  RESULTADO VARCHAR(4000);
  vColuna   VARCHAR(50);
  ColsConstraint CURSOR FOR
    SELECT PKTCOL.COLUMN_NAME
      FROM ALL_CONS_COLUMNS PKCOL,              
           ALL_TAB_COLUMNS PKTCOL       
     WHERE PKCOL.COLUMN_NAME     = PKTCOL.COLUMN_NAME
       AND PKCOL.TABLE_NAME      = PKTCOL.TABLE_NAME
       AND PKCOL.OWNER           = PKTCOL.OWNER
       AND PKCOL.owner LIKE QUALDONO() 
       AND PKCOL.CONSTRAINT_NAME like pConstraint_Name;       
BEGIN  
  RESULTADO:='';  
  OPEN ColsConstraint;
  LOOP
    FETCH ColsConstraint INTO vColuna;
    EXIT WHEN NOT FOUND;
    IF ISNULL(RESULTADO)='T' THEN
       RESULTADO:=vColuna;
    ELSE
       RESULTADO:=RESULTADO||','||vColuna;
    END IF;
  END LOOP;
  CLOSE ColsConstraint;

  RETURN RESULTADO;

END;
$$ language 'plpgsql';





/*-- SEQ 0909 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CustoCompraData (Timestamp,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,TR_MOV.CODFIL%TYPE,TR_MOV.CODMUL%TYPE) CASCADE;

/*-- SEQ 0910 --*/
CREATE OR REPLACE FUNCTION CustoCompraData (Timestamp,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,TR_MOV.CODFIL%TYPE,TR_MOV.CODMUL%TYPE)
RETURNS Numeric AS $$
DECLARE
pDatRef ALIAS FOR $1 ;
pFilmat ALIAS FOR $2 ;
pCodMat ALIAS FOR $3 ;
pCodCor ALIAS FOR $4 ;
pCodTam ALIAS FOR $5 ;
pCodFil ALIAS FOR $6 ;
pCodMul ALIAS FOR $7 ;
-- Objetivo:
-- 1) Traz o custo de compra de um produto em determinada data de uma filial
 nSaldo Numeric;

-- Principal
BEGIN
   Return CustoData('C', pDatRef, pFilmat, pCodMat, pCodCor, pCodTam, pCodFil, pCodMul);
END;
$$ language 'plpgsql';


/*-- SEQ 0911 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CustoCompraData (Timestamp,TR_MOV.FILMAT%TYPE,IN TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,TR_MOV.CODFIL%TYPE) CASCADE;

/*-- SEQ 0912 --*/
CREATE OR REPLACE FUNCTION CustoCompraData (Timestamp,
                               TR_MOV.FILMAT%TYPE,
                               IN TR_MOV.CODMAT%TYPE,
                               TR_MOV.CODCOR%TYPE,
                               TR_MOV.CODTAM%TYPE,
                               TR_MOV.CODFIL%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN CustoCompraData($1,$2,$3,$4,$5,$6,0);
END;
$$ language 'plpgsql';


/*-- SEQ 0913 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CustoFreteData (Timestamp,TT_ICO.FILMAT%TYPE,TT_ICO.CODMAT%TYPE,TT_ICO.CODCOR%TYPE,TT_ICO.CODTAM%TYPE,TT_ICO.CODFIL%TYPE,TT_ICO.CODMUL%TYPE) CASCADE;

/*-- SEQ 0914 --*/
CREATE OR REPLACE FUNCTION CustoFreteData (Timestamp,TT_ICO.FILMAT%TYPE,TT_ICO.CODMAT%TYPE,TT_ICO.CODCOR%TYPE,TT_ICO.CODTAM%TYPE,TT_ICO.CODFIL%TYPE,TT_ICO.CODMUL%TYPE)
RETURNS Numeric AS $$
DECLARE
pDatRef ALIAS FOR $1 ;
pFilmat ALIAS FOR $2 ;
pCodMat ALIAS FOR $3 ;
pCodCor ALIAS FOR $4 ;
pCodTam ALIAS FOR $5 ;
pCodFil ALIAS FOR $6 ;
pCodMul ALIAS FOR $7 ;
-- Objetivo:
-- 1) Traz o custo de frete de um produto em determinada data de uma filial
 nSaldo Numeric;
-- Principal
BEGIN
   Return CustoData('F', pDatRef, pFilmat, pCodMat, pCodCor, pCodTam, pCodFil, pCodMul);
END;
$$ language 'plpgsql';


/*-- SEQ 0915 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CustoFreteData (Timestamp,TT_ICO.FILMAT%TYPE,TT_ICO.CODMAT%TYPE,TT_ICO.CODCOR%TYPE,TT_ICO.CODTAM%TYPE,TT_ICO.CODFIL%TYPE) CASCADE;

/*-- SEQ 0916 --*/
CREATE OR REPLACE FUNCTION CustoFreteData (Timestamp,
                               TT_ICO.FILMAT%TYPE,
                               TT_ICO.CODMAT%TYPE,
                               TT_ICO.CODCOR%TYPE,
                               TT_ICO.CODTAM%TYPE,
                               TT_ICO.CODFIL%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN CustoFreteData($1,$2,$3,$4,$5,$6,0);
END;
$$ language 'plpgsql';


/*-- SEQ 0917 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DESCRICAO_AGENDAMENTO (TT_AGC.CODFIL%TYPE,TT_AGC.SEQUEN%TYPE,Timestamp) CASCADE;

/*-- SEQ 0918 --*/
CREATE OR REPLACE FUNCTION DESCRICAO_AGENDAMENTO (TT_AGC.CODFIL%TYPE,TT_AGC.SEQUEN%TYPE,Timestamp)
RETURNS VARCHAR AS $$
DECLARE
PCODFIL ALIAS FOR $1 ;
PSEQUEN ALIAS FOR $2 ;
PDATOPE ALIAS FOR $3 ;
-- Flvio - 65324
-- Objetivo:
-- Mostrar um descritivo da Tela do Sistema de Agendar Compromisso configurado para o Agendamento passado por parmetro
  DETALHES    VARCHAR(80);
  CDIAS       VARCHAR(40);
  CSEPARA     VARCHAR(2);
  D           Numeric;
  M           Numeric;
  A           Numeric;
  IDIASEMANA  Numeric;
  V_LINHA     TT_AGC%ROWTYPE;
-- Principal
BEGIN
   DETALHES := '';
   SELECT * INTO V_LINHA FROM TT_AGC 
    WHERE CODFIL = PCODFIL 
      AND SEQUEN = PSEQUEN;

   A := to_number(to_char(PDATOPE,'YYYY'));
   M := to_number(to_char(PDATOPE,'MM'));
   D := to_number(to_char(PDATOPE,'DD'));

   IF (V_LINHA.REPETE = 'M') THEN -- mensal
     DETALHES := 'Mensal, ';

     IF V_LINHA.MESTIP = 0 THEN
        DETALHES := DETALHES || 'dia ' || V_LINHA.REPMES;
     ELSIF V_LINHA.MESTIP = 1 THEN -- somente    
       DETALHES := DETALHES || V_LINHA.REPMES || ' ';
       IF V_LINHA.REPSEG = 'T' THEN
         DETALHES := DETALHES || 'Segunda - Feira';
       ELSIF V_LINHA.REPTER = 'T' THEN
         DETALHES := DETALHES || 'Tera - Feira';
       ELSIF V_LINHA.REPQUA = 'T' THEN
         DETALHES := DETALHES || 'Quarta - Feira';
       ELSIF V_LINHA.REPQUI = 'T' THEN
         DETALHES := DETALHES || 'Quinta - Feira';
       ELSIF V_LINHA.REPSEX = 'T' THEN
         DETALHES := DETALHES || 'Sexta - Feira';
       ELSIF V_LINHA.REPSAB = 'T' THEN
         DETALHES := DETALHES || 'Sbado';
       ELSIF V_LINHA.REPDOM = 'T' THEN
         DETALHES := DETALHES || 'Domingo';
       END IF;
     ELSIF V_LINHA.MESTIP = 2 THEN
       -- Mesmo dia do Ms
       DETALHES := DETALHES || 'dia ' || D;                        
     ELSIF V_LINHA.MESTIP = 3 THEN -- Verificar Dia til       
       DETALHES := DETALHES || TO_CHAR(ContaDiasUteisNoMes(PDATOPE)) || ' Dia til';
     END IF;

   ELSE -- semanal
     DETALHES  := 'Semanal, ';
     CDIAS     := '';
     CSEPARA   := '';

     IF (V_LINHA.REPDOM = 'T') THEN
        CDIAS := 'Dom';
        CSEPARA := ', ';
     END IF;

     IF (V_LINHA.REPSEG = 'T') THEN
       CDIAS := CDIAS || CSEPARA || '2';
       CSEPARA := ', ';
     END IF;

     IF (V_LINHA.REPTER = 'T') THEN     
       CDIAS := CDIAS || CSEPARA ||  '3';
       CSEPARA := ', ';
     END IF;

     IF (V_LINHA.REPQUA = 'T') THEN
       CDIAS := CDIAS || CSEPARA || '4';
       CSEPARA := ', ';
     END IF;

     IF (V_LINHA.REPQUI = 'T') THEN
       CDIAS := CDIAS || CSEPARA || '5';
       CSEPARA := ', ';
     END IF;

     IF (V_LINHA.REPSEX = 'T') THEN 
       CDIAS := CDIAS || CSEPARA || '6';
       CSEPARA := ', ';
     END IF;

     IF (V_LINHA.REPSAB = 'T') THEN 
       CDIAS := CDIAS || CSEPARA || 'Sb';       
     END IF;

     IF V_LINHA.NROREP = 1 THEN
        DETALHES := DETALHES || CDIAS || '.';
     ELSE
        DETALHES := DETALHES || 'a cada ' || TO_CHAR(V_LINHA.NROREP) ||
                     ' semanas, ' || CDIAS || '.';
     END IF;
     
   END IF; -- SEMANAL 
   
   RETURN DETALHES;

END;
$$ language 'plpgsql';




/*-- SEQ 0919 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DiasDeEstoque (CHAR,Timestamp,Timestamp,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,TR_MOV.CODFIL%TYPE,TR_MOV.CODMUL%TYPE) CASCADE;

/*-- SEQ 0920 --*/
CREATE OR REPLACE FUNCTION DiasDeEstoque (CHAR,Timestamp,Timestamp,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,TR_MOV.CODFIL%TYPE,TR_MOV.CODMUL%TYPE)
RETURNS Numeric AS $$
DECLARE
pTipo ALIAS FOR $1 ;
pDatIni ALIAS FOR $2 ;
pDatFim ALIAS FOR $3 ;
pFilmat ALIAS FOR $4 ;
pCodMat ALIAS FOR $5 ;
pCodCor ALIAS FOR $6 ;
pCodTam ALIAS FOR $7 ;
pCodFil ALIAS FOR $8 ;
pCodMul ALIAS FOR $9 ;
-- Objetivo:
-- 1) Traz o numero de dias que o produto tinha ou que nao tinha estoque,
--    de acordo com o parametro Tipo
--
--    Tipos: "C" = Dias Com Estoque
--           "S" = Dias Sem Estoque
--           "-" = Dias Negativos

   nComEstoque                   Numeric;
   nSemEstoque                   Numeric;
   nNegativo                     Numeric;
   nQuantidade                   Numeric;
   nSaldoAnterior                Numeric;

-- Principal
BEGIN
   -- Soma um dia nas datas que tem valor para considerar o dia inicial.
   -- Ex: Se todos os dias entre 01/07 e 31/07 tiveram estoque maior que zero, retorna 31 dias na coluna DIAS_COM ao invs de 30,
   -- pois deve considerar tambm o dia 01 como um dia com estoque.
   SELECT CASE WHEN TAB.DIAS_ZERO > 0 THEN TAB.DIAS_ZERO + 1 ELSE TAB.DIAS_ZERO END,
          CASE WHEN TAB.DIAS_COM > 0 THEN TAB.DIAS_COM + 1 ELSE TAB.DIAS_COM END,
          CASE WHEN COALESCE(TAB.DIAS_SEM,0) > 0 THEN TAB.DIAS_SEM + 1 ELSE TAB.DIAS_SEM END,
          TAB.C
     INTO nSemEstoque, nComEstoque, nNegativo, nQuantidade
   FROM(
         SELECT SUM( CASE WHEN COALESCE(SALANT,0) = 0 THEN TRUNC(ATE)-TRUNC(DESDE) ELSE 0 END) AS DIAS_ZERO,
                SUM( CASE WHEN COALESCE(SALANT,0) > 0 THEN TRUNC(ATE)-TRUNC(DESDE) ELSE 0 END) AS DIAS_COM,
                SUM( CASE WHEN COALESCE(SALANT,0) < 0 THEN TRUNC(ATE)-TRUNC(DESDE) ELSE 0 END) AS DIAS_SEM,
                COUNT(*) AS C
           FROM (SELECT CASE WHEN MAX(ANT.DATMOV) IS NULL
                             THEN MOV.DATMOV
                             ELSE MAX(TIMESTAMPTZ_LARGER(ANT.DATMOV,pDatIni))
                         END AS DESDE,
                        MOV.DATMOV AS ATE,
                        MIN(MOV.SALANT) AS SALANT
                   FROM TR_MOV MOV LEFT OUTER JOIN TR_MOV ANT ON ANT.CODFIL = MOV.CODFIL
                                                             AND ANT.FILMAT = MOV.FILMAT
                                                             AND ANT.CODMAT = MOV.CODMAT
                                                             AND ANT.CODCOR = MOV.CODCOR
                                                             AND ANT.CODTAM = MOV.CODTAM
                                                             AND ANT.CODMUL = MOV.CODMUL
                                                             AND ANT.DATMOV < MOV.DATMOV
                  WHERE MOV.CODFIL = pCodFil
                    AND MOV.FILMAT = pFilMat
                    AND MOV.CODMAT = pCodMat
                    AND MOV.CODCOR = pCodCor
                    AND MOV.CODTAM = pCodTam
                    AND MOV.CODMUL = pCodMul
                    AND MOV.DATMOV BETWEEN TRUNC(pDatIni) AND TRUNC(pDatFim)
                    GROUP BY MOV.DATMOV
                 UNION ALL
                 SELECT DATMOV AS DESDE,
                        TRUNC(pDatFim) AS ATE,
                        COALESCE(EXT.SALANT,0)-COALESCE(EXT.QTDVEN,0)+COALESCE(EXT.QTDCOM,0)+COALESCE(EXT.QTDOUT,0)-COALESCE(EXT.VENFIS,0) AS SALANT
                   FROM TR_MOV EXT
                  WHERE (EXT.CODFIL, EXT.FILMAT, EXT.CODMAT, EXT.CODCOR, EXT.CODTAM, EXT.CODMUL, EXT.DATMOV)
                     IN (SELECT MOV.CODFIL, MOV.FILMAT, MOV.CODMAT, MOV.CODCOR, MOV.CODTAM, MOV.CODMUL, MAX(MOV.DATMOV)
                           FROM TR_MOV MOV
                          WHERE MOV.CODFIL = pCodFil
                            AND MOV.FILMAT = pFilMat
                            AND MOV.CODMAT = pCodMat
                            AND MOV.CODCOR = pCodCor
                            AND MOV.CODTAM = pCodTam
                            AND MOV.CODMUL = pCodMul
                            AND MOV.DATMOV BETWEEN TRUNC(pDatIni) AND TRUNC(pDatFim)
                  GROUP BY MOV.CODFIL, MOV.FILMAT, MOV.CODMAT, MOV.CODCOR, MOV.CODTAM, MOV.CODMUL)) EST
         ) TAB;

   -- Quantidade zero significa que no houve movimentao no perodo informado. Nesse caso, busca o saldo anterior  data inicial.
   IF nQuantidade = 0 THEN
      nSaldoAnterior := SALDODAFILIAL(pDatIni, pFilMat, pCodMat, pCodCor, pCodTam, pCodFil, pCodMul);

      IF nSaldoAnterior = 0 THEN
         nSemEstoque := TRUNC(pDatFim)-TRUNC(pDatIni)+1;
         nComEstoque := 0;
         nNegativo   := 0;
      ELSIF nSaldoAnterior > 0 THEN
         nSemEstoque := 0;
         nComEstoque := TRUNC(pDatFim)-TRUNC(pDatIni)+1;
         nNegativo   := 0;
      ELSE
         nSemEstoque := 0;
         nComEstoque := 0;
         nNegativo   := TRUNC(pDatFim)-TRUNC(pDatIni)+1;
      END IF;
   END IF;

   RETURN CASE UPPER(pTipo) WHEN 'C' THEN COALESCE(nComEstoque,0)
                            WHEN 'S' THEN COALESCE(nSemEstoque,0)
                            WHEN '-' THEN COALESCE(nNegativo,0)
                            ELSE 0
           END;
END;
$$ language 'plpgsql';


/*-- SEQ 0921 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DiasDeEstoque (CHAR,Timestamp,Timestamp,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,TR_MOV.CODFIL%TYPE) CASCADE;

/*-- SEQ 0922 --*/
CREATE OR REPLACE FUNCTION DiasDeEstoque (CHAR,
                               Timestamp,
                               Timestamp,
                               TR_MOV.FILMAT%TYPE,
                               TR_MOV.CODMAT%TYPE,
                               TR_MOV.CODCOR%TYPE,
                               TR_MOV.CODTAM%TYPE,
                               TR_MOV.CODFIL%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN DiasDeEstoque($1,$2,$3,$4,$5,$6,$7,$8,0);
END;
$$ language 'plpgsql';


/*-- SEQ 0923 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DigitoModulo11 (Numeric,Numeric) CASCADE;

/*-- SEQ 0924 --*/
CREATE OR REPLACE FUNCTION DigitoModulo11 (Numeric,Numeric)
RETURNS Numeric AS $$
DECLARE
pNumero ALIAS FOR $1 ;
pRetorno ALIAS FOR $2 ;
 -- Calcula digito, modulo 11
 cod   CHAR(12);
 dig   Numeric;
 div   Numeric;
 sobra Numeric;
BEGIN
 cod := substr(TO_CHAR(pNumero,'000000000000'),2,12);
 div := (to_number(SUBSTR(cod,01,1)) * 7) +
        (to_number(SUBSTR(cod,02,1)) * 6) +
        (to_number(SUBSTR(cod,03,1)) * 5) +
        (to_number(SUBSTR(cod,04,1)) * 4) +
        (to_number(SUBSTR(cod,05,1)) * 3) +
        (to_number(SUBSTR(cod,06,1)) * 2) +
        (to_number(SUBSTR(cod,07,1)) * 7) + 
        (to_number(SUBSTR(cod,08,1)) * 6) +
        (to_number(SUBSTR(cod,09,1)) * 5) +
        (to_number(SUBSTR(cod,10,1)) * 4) +
        (to_number(SUBSTR(cod,11,1)) * 3) +
        (to_number(SUBSTR(cod,12,1)) * 2);

 sobra := Mod(div, 11);

 if sobra = 1 OR sobra = 0 then
   dig := 0;
 else
   dig := 11 - sobra;
 end if;

 if pRetorno = 0 then
   RETURN dig;
 else
   RETURN (pNumero*10)+dig;
 end if;
END;
$$ language 'plpgsql';


/*-- SEQ 0925 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DigitoModulo11 (Numeric) CASCADE;

/*-- SEQ 0926 --*/
CREATE OR REPLACE FUNCTION DigitoModulo11 (Numeric) 
RETURNS Numeric AS $$
BEGIN
RETURN DigitoModulo11($1,0);
END;
$$ language 'plpgsql';



/*-- SEQ 0927 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CALCULA_DATA_PREVISTA (TT_AGC.CODFIL%TYPE,TT_AGC.SEQUEN%TYPE,Timestamp) CASCADE;

/*-- SEQ 0928 --*/
CREATE OR REPLACE FUNCTION CALCULA_DATA_PREVISTA (TT_AGC.CODFIL%TYPE,TT_AGC.SEQUEN%TYPE,Timestamp)
RETURNS Timestamp AS $$
DECLARE
PCODFIL ALIAS FOR $1 ;
PSEQUEN ALIAS FOR $2 ;
PDATOPE ALIAS FOR $3 ;
-- Flvio - 65324
-- Calcular Data Prevista para o Agendamento passado por parmetro
  D          Numeric;
  M          Numeric;
  A          Numeric;
  DIA        Numeric;
  MES        Numeric;
  ANO        Numeric;
  IDIASEMANA Numeric;
  IDIASEMANA_ATUAL Numeric;
  V_LINHA    TT_AGC%ROWTYPE;
  FLGOK      Numeric;
  V_MESES    CHAR(12);
  DT_INCL    Timestamp;
-- Principal
BEGIN
   
   SELECT * INTO V_LINHA FROM TT_AGC 
    WHERE CODFIL = PCODFIL 
      AND SEQUEN = PSEQUEN;

   V_MESES := COALESCE(V_LINHA.REPJAN, 'F')||COALESCE(V_LINHA.REPFEV, 'F')||COALESCE(V_LINHA.REPMAR, 'F')||
              COALESCE(V_LINHA.REPABR, 'F')||COALESCE(V_LINHA.REPMAI, 'F')||COALESCE(V_LINHA.REPJUN, 'F')||
              COALESCE(V_LINHA.REPJUL, 'F')||COALESCE(V_LINHA.REPAGO, 'F')||COALESCE(V_LINHA.REPSET, 'F')||
              COALESCE(V_LINHA.REPOUT, 'F')||COALESCE(V_LINHA.REPNOV, 'F')||COALESCE(V_LINHA.REPDEZ, 'F');

   DT_INCL := PDATOPE;
   A := to_number(to_char(PDATOPE,'YYYY'));
   M := to_number(to_char(PDATOPE,'MM'));
   D := to_number(to_char(PDATOPE,'DD'));

   IF (V_LINHA.REPETE = 'M') THEN -- Mensal
     IF M < 12 THEN 
        Mes := M + 1;
        Ano := A;
     ELSE 
        Mes := 1;
        Ano := A + 1;
     END IF;     
    
     -- AJUSTA PARA UM MS VLIDO
     IF (substr(V_MESES, MES, 1) <> 'T') AND (
       V_LINHA.REPJAN = 'T' OR V_LINHA.REPFEV = 'T' OR V_LINHA.REPMAR = 'T'
       OR V_LINHA.REPABR = 'T' OR V_LINHA.REPMAI = 'T' OR V_LINHA.REPJUN = 'T'
       OR V_LINHA.REPJUL = 'T' OR V_LINHA.REPAGO = 'T' OR V_LINHA.REPSET = 'T'
       OR V_LINHA.REPOUT = 'T' OR V_LINHA.REPNOV = 'T' OR V_LINHA.REPDEZ = 'T') THEN
        FLGOK := 0;
        LOOP
          EXIT WHEN FLGOK = 1;
          IF MES < 12 THEN 
            MES := MES + 1;      
          ELSE 
            MES := 1;
            ANO := ANO + 1;
          END IF;        
          IF substr(V_MESES, MES, 1) = 'T' THEN
            FLGOK := 1;      
          END IF;
        END LOOP;
     END IF;        

     IF V_LINHA.MESTIP = 0 THEN
        DIA := COALESCE(V_LINHA.REPMES, 1);
        
        IF to_number(to_char(LAST_DAY(TO_DATE('01'||TO_CHAR(MES, '00')||TO_CHAR(ANO, '0000'),'DDMMYYYY')),'dd')) < DIA THEN
          -- se o ltiMo dia do prx. Ms  Menor que o Dia Escolhido
          DIA := to_number(to_char(LAST_DAY(TO_DATE('01'||TO_CHAR(MES, '00')||TO_CHAR(ANO, '0000'),'DDMMYYYY')),'dd')); -- Traz ltimo dia prx. Ms 
        END IF;
        DT_INCL := TO_DATE(TO_CHAR(DIA, '00')||TO_CHAR(MES, '00')||TO_CHAR(ANO, '0000'),'DDMMYYYY');

     ELSIF V_LINHA.MESTIP = 1 THEN -- Somente    
       -- REPMES de 1 a 5
       DIA := COALESCE(V_LINHA.REPMES, 1); -- Dia Recebe a ocorrncia da Semana
       IF V_LINHA.REPSEG = 'T' THEN
          DT_INCL := CALCULA_DATA_DA_SEMANA_NO_MES(DIA, 2, MES, ANO);
       ELSIF V_LINHA.REPTER = 'T' THEN
          DT_INCL := CALCULA_DATA_DA_SEMANA_NO_MES(DIA, 3, MES, ANO);
       ELSIF V_LINHA.REPQUA = 'T' THEN
          DT_INCL := CALCULA_DATA_DA_SEMANA_NO_MES(DIA, 4, MES, ANO);
       ELSIF V_LINHA.REPQUI = 'T' THEN
          DT_INCL := CALCULA_DATA_DA_SEMANA_NO_MES(DIA, 5, MES, ANO);
       ELSIF V_LINHA.REPSEX = 'T' THEN
          DT_INCL := CALCULA_DATA_DA_SEMANA_NO_MES(DIA, 6, MES, ANO);
       ELSIF V_LINHA.REPSAB = 'T' THEN
          DT_INCL := CALCULA_DATA_DA_SEMANA_NO_MES(DIA, 7, MES, ANO);
       ELSIF V_LINHA.REPDOM = 'T' THEN
          DT_INCL := CALCULA_DATA_DA_SEMANA_NO_MES(DIA, 1, MES, ANO);
       END IF;

     ELSIF V_LINHA.MESTIP = 2 THEN
       -- MesMo dia do Ms
       DIA := D;
       IF to_number(to_char(LAST_DAY(TO_DATE('01'||TO_CHAR(MES, '00')||TO_CHAR(ANO, '0000'),'DDMMYYYY')), 'dd')) < DIA THEN  
           -- se o ltiMo dia do prx. Ms  Menor que o Dia Escolhido 
          DIA := to_number(to_char(LAST_DAY(TO_DATE('01'||TO_CHAR(MES, '00')||TO_CHAR(ANO, '0000'),'DDMMYYYY')),'dd')); -- Traz ltiMo dia prx. Ms
       END IF;
       DT_INCL := TO_DATE(TO_CHAR(DIA, '00')||TO_CHAR(MES, '00')||TO_CHAR(ANO, '0000'),'DDMMYYYY');
   
     ELSIF V_LINHA.MESTIP = 3 THEN -- Verificar Dia til
       IDIASEMANA := ContaDiasUteisNoMes(PDATOPE); -- Saber qual posio do dia til
       DT_INCL := ADD_DAY(TO_DATE('01'||TO_CHAR(MES, '00')||TO_CHAR(ANO, '0000'),'DDMMYYYY') , (IDIASEMANA - 1));
       LOOP
         EXIT WHEN ContaDiasUteisNoMes(DT_INCL) = IDIASEMANA;
           DT_INCL := ADD_DAY(DT_INCL , 1);  
       END LOOP;
     END IF;

   ELSE -- semanal
     IDIASEMANA_ATUAL := to_number(to_char(DT_INCL,'D'));
     IDIASEMANA  := 0;
     
     IF (V_LINHA.REPSEG = 'T') AND (IDIASEMANA_ATUAL < 2) THEN
       IDIASEMANA := 2; 
     ELSIF (V_LINHA.REPTER = 'T') AND (IDIASEMANA_ATUAL < 3) THEN
       IDIASEMANA := 3; 
     ELSIF (V_LINHA.REPQUA = 'T') AND (IDIASEMANA_ATUAL < 4) THEN
       IDIASEMANA := 4;
     ELSIF (V_LINHA.REPQUI = 'T') AND (IDIASEMANA_ATUAL < 5) THEN
       IDIASEMANA := 5;
     ELSIF (V_LINHA.REPSEX = 'T') AND (IDIASEMANA_ATUAL < 6) THEN
       IDIASEMANA := 6;
     ELSIF (V_LINHA.REPSAB = 'T') AND (IDIASEMANA_ATUAL < 7) THEN
       IDIASEMANA := 7;
     ELSE
       -- PRXIMA SEMANA * MULTIPLICADOR
       DT_INCL := ADD_DAY(DT_INCL, 7 * COALESCE(V_LINHA.NROREP, 1)); -- Posiciona na semana certa
       IDIASEMANA_ATUAL := to_number(to_char(DT_INCL,'D'));

       IF (V_LINHA.REPDOM = 'T') THEN
         IDIASEMANA := 1; 
       ELSIF (V_LINHA.REPSEG = 'T') THEN
         IDIASEMANA := 2; 
       ELSIF (V_LINHA.REPTER = 'T') THEN
         IDIASEMANA := 3; 
       ELSIF (V_LINHA.REPQUA = 'T') THEN
         IDIASEMANA := 4;
       ELSIF (V_LINHA.REPQUI = 'T') THEN
         IDIASEMANA := 5;
       ELSIF (V_LINHA.REPSEX = 'T') THEN
         IDIASEMANA := 6;
       ELSIF (V_LINHA.REPSAB = 'T') THEN
         IDIASEMANA := 7;
       END IF;
     END IF;

     IF IDIASEMANA <> 0 THEN
        IF IDIASEMANA < IDIASEMANA_ATUAL  THEN           
           DT_INCL := ADD_DAY(DT_INCL, (to_number(to_char(DT_INCL,'D')) - IDIASEMANA) * -1); 
        ELSIF IDIASEMANA > IDIASEMANA_ATUAL THEN
           DT_INCL := ADD_DAY(DT_INCL, IDIASEMANA - IDIASEMANA_ATUAL); 
        END IF;
     END IF;   
     
   END IF; -- SEMANAL 

  RETURN DT_INCL;  

END;
$$ language 'plpgsql';




/*-- SEQ 0929 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION EAN (VARCHAR) CASCADE;

/*-- SEQ 0930 --*/
CREATE OR REPLACE FUNCTION EAN (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
Ref ALIAS FOR $1 ;
  Cod    VARCHAR(15);
  Di1Aux char(3);
  Di1    Numeric;
  A      Numeric;
  B      Numeric;
  C      Numeric;
  D      Numeric;
  E      Numeric;
  F      Numeric;
  G      Numeric;
  H      Numeric;
  I      Numeric;
  J      Numeric;
  K      Numeric;
  L      Numeric;
begin
  Cod := LPAD(LTRIM(RTRIM(Ref)),12,'0');

  A := TO_NUMBER( SUBSTR( Cod,01,1 ) );
  B := TO_NUMBER( SUBSTR( Cod,02,1 ) );
  C := TO_NUMBER( SUBSTR( Cod,03,1 ) );
  D := TO_NUMBER( SUBSTR( Cod,04,1 ) );
  E := TO_NUMBER( SUBSTR( Cod,05,1 ) );
  F := TO_NUMBER( SUBSTR( Cod,06,1 ) );
  G := TO_NUMBER( SUBSTR( Cod,07,1 ) );
  H := TO_NUMBER( SUBSTR( Cod,08,1 ) );
  I := TO_NUMBER( SUBSTR( Cod,09,1 ) );
  J := TO_NUMBER( SUBSTR( Cod,10,1 ) );
  K := TO_NUMBER( SUBSTR( Cod,11,1 ) );
  L := TO_NUMBER( SUBSTR( Cod,12,1 ) );

  Di1    := 1000 - ((( B + D + F + H + J + L ) *3 ) + A + C + E + G + I + K );
  -- O ultimo caractere representa o sinal.
  -- Sem o "S" apareceria um branco quando positivo e "-" quando negativo.
  -- Acredita-se que assim fica mais claro.
  Di1Aux := SUBSTR( TO_CHAR( DI1, '009S' ) , 1, 3 );

  Cod    :=  Cod || SUBSTR( Di1Aux, 3, 1 ) ;

  Return Cod;
END;
$$ language 'plpgsql';




/*-- SEQ 0931 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Encerrante (TT_FCP.FILMED%TYPE,TT_FCP.TANMED%TYPE,TT_FCP.DATMED%TYPE,TT_FCP.CODBIC%TYPE,VARCHAR) CASCADE;

/*-- SEQ 0932 --*/
CREATE OR REPLACE FUNCTION Encerrante (TT_FCP.FILMED%TYPE,TT_FCP.TANMED%TYPE,TT_FCP.DATMED%TYPE,TT_FCP.CODBIC%TYPE,VARCHAR)
RETURNS Numeric AS $$
DECLARE
pFILMED ALIAS FOR $1 ;
pTANMED ALIAS FOR $2 ;
pDATMED ALIAS FOR $3 ;
pCODBIC ALIAS FOR $4 ;
pVERABE ALIAS FOR $5 ;
 nRESULTADO TT_FCP.VLRENC%TYPE;

BEGIN
  
  SELECT CASE WHEN pVERABE = 'T'
              THEN MAX(FCP.ENCABE) 
              ELSE MAX(FCP.VLRENC) 
          END INTO nRESULTADO
    FROM TT_FCP FCP
   WHERE FCP.FILMED=pFILMED
     AND FCP.TANMED=pTANMED
     AND FCP.DATMED=pDATMED
     AND FCP.CODBIC=pCODBIC;
     
  RETURN nRESULTADO;   
     
                                      
END;
$$ language 'plpgsql' STABLE;




/*-- SEQ 0933 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION EnvolvidosAgenda (TT_CHR.CODFIL%TYPE,TT_CHR.SEQUEN%TYPE) CASCADE;

/*-- SEQ 0934 --*/
CREATE OR REPLACE FUNCTION EnvolvidosAgenda (TT_CHR.CODFIL%TYPE,TT_CHR.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
 linha VARCHAR(4000);
 retorno VARCHAR(4000);
 buffer VARCHAR(32767);
 c_LF CHAR(2) := chr(13)||chr(10);
 i  Numeric;
 
 Funcao CURSOR FOR
 select distinct apeusu 
 from (select usu.apeusu
   from tt_agexusu age inner join tt_usu usu on usu.filusu = age.filusu and usu.codusu = age.codusu
   where age.filage = pCodFil
   and age.seqage = pSequen
   union all
   select usu.apeusu
   from tt_agexusu age inner join tt_papxusu pap on pap.filpap = age.filpap and pap.seqpap = age.seqpap
        inner join tt_usu  usu on usu.filusu = pap.filusu and usu.codusu = pap.codusu
   where age.filage = pCodFil
   and age.seqage = pSequen ) tab;
 
BEGIN
 buffer := '';
 retorno := '';
 i := 0;
 OPEN funcao;
 LOOP
 FETCH funcao into linha;
 EXIT WHEN funcao%NOTFOUND;
 IF i > 0 THEN
  buffer := buffer || ', ';
 END IF;
 I := I + 1;
 buffer := buffer || COALESCE(linha,'');
 END LOOP;
 Close Funcao;
 
 IF Length(buffer) > 4000 THEN
 retorno := Substr(buffer,1,3980)||C_lf||'** muito longo **';
 ELSE
 retorno := buffer;
 END IF;
 
 Return retorno;
END;
$$ language 'plpgsql';




/*-- SEQ 0935 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ALTERA_DAV (TT_ORC.CODEXT%TYPE,TT_ORC.CODSER%TYPE,TT_ORC.DOCNFP%TYPE,TT_ORC.DATAPR%TYPE,TT_ORC.CODFIL%TYPE,TT_ORC.TIPPED%TYPE,TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,TT_ORC.VLRTOT%TYPE,TT_ORC.VLRPAR%TYPE,TT_ORC.VLRDES%TYPE,TT_ORC.QTDPAR%TYPE,TT_ORC.FILFAT%TYPE,TT_ORC.NUMFAT%TYPE,TT_ORC.FILENT%TYPE,TT_ORC.NUMENT%TYPE,TT_ORC.FILCOB%TYPE,TT_ORC.NUMCOB%TYPE,TT_ORC.DATVAL%TYPE,TT_ORC.DATPRI%TYPE,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE,TT_PLA.FILPGT%TYPE,TT_PLA.CODPGT%TYPE,TT_ORC.FILPRE%TYPE,TT_ORC.CODPRE%TYPE,TT_ORC.RESERV%TYPE,TT_ORC.EMIDES%TYPE,TT_ORC.PESLIQ%TYPE,TT_ORC.PESBRU%TYPE,TT_ORC.VLRSEG%TYPE,TT_ORC.VLRFRE%TYPE,TT_ORC.SINAL%TYPE,TT_ORC.OBSERV%TYPE,TT_ORC.NUMBLO%TYPE,TT_ORC.OBSORC%TYPE,TT_ORC.DATSEG%TYPE,TT_ORC.APROVA%TYPE,TT_ORC.APRCLI%TYPE,TT_ORC.PLACAS%TYPE,TT_ORC.QTD_KM%TYPE,TT_ORC.CODSEQ%TYPE,TT_ORC.NUMPED%TYPE,TT_ORC.CHVAPR%TYPE,TT_ORC.CODEMP%TYPE,TT_ORC.ASSINA%TYPE,TT_ORC.ORCIMP%TYPE) CASCADE;

/*-- SEQ 0936 --*/
CREATE OR REPLACE FUNCTION ALTERA_DAV (TT_ORC.CODEXT%TYPE,TT_ORC.CODSER%TYPE,TT_ORC.DOCNFP%TYPE,TT_ORC.DATAPR%TYPE,TT_ORC.CODFIL%TYPE,TT_ORC.TIPPED%TYPE,TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,TT_ORC.VLRTOT%TYPE,TT_ORC.VLRPAR%TYPE,TT_ORC.VLRDES%TYPE,TT_ORC.QTDPAR%TYPE,TT_ORC.FILFAT%TYPE,TT_ORC.NUMFAT%TYPE,TT_ORC.FILENT%TYPE,TT_ORC.NUMENT%TYPE,TT_ORC.FILCOB%TYPE,TT_ORC.NUMCOB%TYPE,TT_ORC.DATVAL%TYPE,TT_ORC.DATPRI%TYPE,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE,TT_PLA.FILPGT%TYPE,TT_PLA.CODPGT%TYPE,TT_ORC.FILPRE%TYPE,TT_ORC.CODPRE%TYPE,TT_ORC.RESERV%TYPE,TT_ORC.EMIDES%TYPE,TT_ORC.PESLIQ%TYPE,TT_ORC.PESBRU%TYPE,TT_ORC.VLRSEG%TYPE,TT_ORC.VLRFRE%TYPE,TT_ORC.SINAL%TYPE,TT_ORC.OBSERV%TYPE,TT_ORC.NUMBLO%TYPE,TT_ORC.OBSORC%TYPE,TT_ORC.DATSEG%TYPE,TT_ORC.APROVA%TYPE,TT_ORC.APRCLI%TYPE,TT_ORC.PLACAS%TYPE,TT_ORC.QTD_KM%TYPE,TT_ORC.CODSEQ%TYPE,TT_ORC.NUMPED%TYPE,TT_ORC.CHVAPR%TYPE,TT_ORC.CODEMP%TYPE,TT_ORC.ASSINA%TYPE,TT_ORC.ORCIMP%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODEXT ALIAS FOR $1 ;
pCODSER ALIAS FOR $2 ;
pDOCNFP ALIAS FOR $3 ;
pDATAPR ALIAS FOR $4 ;
pCODFIL ALIAS FOR $5 ;
pTIPPED ALIAS FOR $6 ;
pFILCLI ALIAS FOR $7 ;
pCODCLI ALIAS FOR $8 ;
pVLRTOT ALIAS FOR $9 ;
pVLRPAR ALIAS FOR $10 ;
pVLRDES ALIAS FOR $11 ;
pQTDPAR ALIAS FOR $12 ;
pFILFAT ALIAS FOR $13 ;
pNUMFAT ALIAS FOR $14 ;
pFILENT ALIAS FOR $15 ;
pNUMENT ALIAS FOR $16 ;
pFILCOB ALIAS FOR $17 ;
pNUMCOB ALIAS FOR $18 ;
pDATVAL ALIAS FOR $19 ;
pDATPRI ALIAS FOR $20 ;
pFILVEN ALIAS FOR $21 ;
pCODVEN ALIAS FOR $22 ;
pFILPGT ALIAS FOR $23 ;
pCODPGT ALIAS FOR $24 ;
pFILPRE ALIAS FOR $25 ;
pCODPRE ALIAS FOR $26 ;
pRESERV ALIAS FOR $27 ;
pEMIDES ALIAS FOR $28 ;
pPESLIQ ALIAS FOR $29 ;
pPESBRU ALIAS FOR $30 ;
pVLRSEG ALIAS FOR $31 ;
pVLRFRE ALIAS FOR $32 ;
pSINAL ALIAS FOR $33 ;
pOBSERV ALIAS FOR $34 ;
pNUMBLO ALIAS FOR $35 ;
pOBSORC ALIAS FOR $36 ;
pDATSEG ALIAS FOR $37 ;
pAPROVA ALIAS FOR $38 ;
pAPRCLI ALIAS FOR $39 ;
pPLACAS ALIAS FOR $40 ;
pQTD_KM ALIAS FOR $41 ;
pCODSEQ ALIAS FOR $42 ;
pNUMPED ALIAS FOR $43 ;
pCHVAPR ALIAS FOR $44 ;
pCODEMP ALIAS FOR $45 ;
pASSINA ALIAS FOR $46 ;
pORCIMP ALIAS FOR $47 ;

   vComplemento                  CONSTANT VARCHAR(254):= constante('complemento');
   WK_QTDIOR                     Numeric;

BEGIN

   IF pCODEXT IS NOT NULL THEN

      SELECT COUNT(*)
        INTO WK_QTDIOR
        FROM TT_IOR IOR INNER JOIN TT_ORC ORC ON ORC.CODFIL = IOR.CODFIL
                                             AND ORC.TIPPED = IOR.TIPPED
                                             AND ORC.NUMPED = IOR.NUMPED
       WHERE (IOR.FLGEST = 'E' OR
              IOR.ECFVEN IS NOT NULL) 
         AND ORC.CODEXT = pCODEXT;

       IF WK_QTDIOR > 0  THEN
          RAISE EXCEPTION 'PG-20000 No  permitido alterar oramento com itens vendidos ou estar com o nmero de ECF preenchido. %' , VComplemento;
       ELSE
          UPDATE TT_ORC
             SET CODSER = pCODSER,
                 DOCNFP = pDOCNFP,
                 DATAPR = pDATAPR,
                 TIPPED = pTIPPED,
                 FILCLI = pFILCLI,
                 CODCLI = pCODCLI,
                 VLRTOT = pVLRTOT,
                 VLRPAR = pVLRPAR,
                 VLRDES = pVLRDES,
                 QTDPAR = pQTDPAR,
                 FILFAT = pFILFAT,
                 NUMFAT = pNUMFAT,
                 FILENT = pFILENT,
                 NUMENT = pNUMENT,
                 FILCOB = pFILCOB,
                 NUMCOB = pNUMCOB,
                 DATVAL = pDATVAL,
                 DATPRI = pDATPRI,
                 FILVEN = pFILVEN,
                 CODVEN = pCODVEN,
                 FILPGT = pFILPGT,
                 CODPGT = pCODPGT,
                 FILPRE = pFILPRE,
                 CODPRE = pCODPRE,
                 RESERV = pRESERV,
                 EMIDES = pEMIDES,
                 PESLIQ = pPESLIQ,
                 PESBRU = pPESBRU,
                 VLRSEG = pVLRSEG,
                 VLRFRE = pVLRFRE,
                 SINAL  = pSINAL,
                 OBSERV = pOBSERV,
                 NUMBLO = pNUMBLO,
                 OBSORC = pOBSORC,
                 DATSEG = pDATSEG,
                 APROVA = pAPROVA,
                 APRCLI = pAPRCLI,
                 PLACAS = pPLACAS,
                 QTD_KM = pQTD_KM,
                 CODSEQ = pCODSEQ,
                 CHVAPR = pCHVAPR,
                 CODEMP = pCODEMP,
                 ASSINA = pASSINA,
                 ORCIMP = pORCIMP,
                 DATENT = TRUNC(Agora())
           WHERE CODEXT = pCODEXT;
      END IF;
   END IF;

   IF ISNOTNULL(pNUMPED)='T' THEN

      SELECT COUNT(*)
         INTO WK_QTDIOR
         FROM TT_IOR IOR
        WHERE (IOR.FLGEST = 'E' OR
               IOR.ECFVEN IS NOT NULL) AND
               IOR.NUMPED = pNUMPED    AND
               IOR.TIPPED = pTIPPED    AND
               IOR.CODFIL = pCODFIL;

      IF WK_QTDIOR > 0  THEN
         RAISE EXCEPTION 'PG-20000 No  permitido alterar oramento com itens vendidos ou estar com o nmero de ECF preenchido. %' , VComplemento;
      ELSE
         UPDATE TT_ORC
            SET CODSER = pCODSER,
                DOCNFP = pDOCNFP,
                DATAPR = pDATAPR,
                TIPPED = pTIPPED,
                FILCLI = pFILCLI,
                CODCLI = pCODCLI,
                VLRTOT = pVLRTOT,
                VLRPAR = pVLRPAR,
                VLRDES = pVLRDES,
                QTDPAR = pQTDPAR,
                FILFAT = pFILFAT,
                NUMFAT = pNUMFAT,
                FILENT = pFILENT,
                NUMENT = pNUMENT,
                FILCOB = pFILCOB,
                NUMCOB = pNUMCOB,
                DATVAL = pDATVAL,
                DATPRI = pDATPRI,
                FILVEN = pFILVEN,
                CODVEN = pCODVEN,
                FILPGT = pFILPGT,
                CODPGT = pCODPGT,
                FILPRE = pFILPRE,
                CODPRE = pCODPRE,
                RESERV = pRESERV,
                EMIDES = pEMIDES,
                PESLIQ = pPESLIQ,
                PESBRU = pPESBRU,
                VLRSEG = pVLRSEG,
                VLRFRE = pVLRFRE,
                SINAL  = pSINAL,
                OBSERV = pOBSERV,
                NUMBLO = pNUMBLO,
                OBSORC = pOBSORC,
                DATSEG = pDATSEG,
                APROVA = pAPROVA,
                APRCLI = pAPRCLI,
                PLACAS = pPLACAS,
                QTD_KM = pQTD_KM,
                CODSEQ = pCODSEQ,
                CHVAPR = pCHVAPR,
                CODEMP = pCODEMP,
                ASSINA = pASSINA,
                ORCIMP = pORCIMP,
                DATENT = TRUNC(Agora())
          WHERE NUMPED = pNUMPED
            AND TIPPED = pTIPPED
            AND CODFIL = pCODFIL;
      END IF;
   END IF;

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 0937 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ENVIA_DAV (TT_ORC.CODEXT%TYPE,TT_ORC.CODSER%TYPE,TT_ORC.DOCNFP%TYPE,TT_ORC.DATAPR%TYPE,TT_ORC.CODFIL%TYPE,TT_ORC.TIPPED%TYPE,TT_CLI.CODEXT%TYPE,TT_ORC.VLRTOT%TYPE,TT_ORC.VLRPAR%TYPE,TT_ORC.VLRDES%TYPE,TT_ORC.QTDPAR%TYPE,TT_ORC.FILFAT%TYPE,TT_ORC.NUMFAT%TYPE,TT_ORC.FILENT%TYPE,TT_ORC.NUMENT%TYPE,TT_ORC.FILCOB%TYPE,TT_ORC.NUMCOB%TYPE,TT_ORC.DATVAL%TYPE,TT_ORC.DATPRI%TYPE,TT_USU.APEUSU%TYPE,TT_PLA.APEPGT%TYPE,TT_TPR.DESPRE%TYPE,TT_ORC.RESERV%TYPE,TT_ORC.EMIDES%TYPE,TT_ORC.PESLIQ%TYPE,TT_ORC.PESBRU%TYPE,TT_ORC.VLRSEG%TYPE,TT_ORC.VLRFRE%TYPE,TT_ORC.SINAL%TYPE,TT_ORC.OBSERV%TYPE,TT_ORC.NUMBLO%TYPE,TT_ORC.OBSORC%TYPE,TT_ORC.DATSEG%TYPE,TT_ORC.APROVA%TYPE,TT_ORC.APRCLI%TYPE,TT_ORC.PLACAS%TYPE,TT_ORC.QTD_KM%TYPE,TT_ORC.CODSEQ%TYPE,TT_ORC.CODEMP%TYPE,TT_ORC.ASSINA%TYPE,TT_ORC.NUMPED%TYPE,TT_ORC.ORCIMP%TYPE) CASCADE;

/*-- SEQ 0938 --*/
CREATE OR REPLACE FUNCTION ENVIA_DAV (TT_ORC.CODEXT%TYPE,TT_ORC.CODSER%TYPE,TT_ORC.DOCNFP%TYPE,TT_ORC.DATAPR%TYPE,TT_ORC.CODFIL%TYPE,TT_ORC.TIPPED%TYPE,TT_CLI.CODEXT%TYPE,TT_ORC.VLRTOT%TYPE,TT_ORC.VLRPAR%TYPE,TT_ORC.VLRDES%TYPE,TT_ORC.QTDPAR%TYPE,TT_ORC.FILFAT%TYPE,TT_ORC.NUMFAT%TYPE,TT_ORC.FILENT%TYPE,TT_ORC.NUMENT%TYPE,TT_ORC.FILCOB%TYPE,TT_ORC.NUMCOB%TYPE,TT_ORC.DATVAL%TYPE,TT_ORC.DATPRI%TYPE,TT_USU.APEUSU%TYPE,TT_PLA.APEPGT%TYPE,TT_TPR.DESPRE%TYPE,TT_ORC.RESERV%TYPE,TT_ORC.EMIDES%TYPE,TT_ORC.PESLIQ%TYPE,TT_ORC.PESBRU%TYPE,TT_ORC.VLRSEG%TYPE,TT_ORC.VLRFRE%TYPE,TT_ORC.SINAL%TYPE,TT_ORC.OBSERV%TYPE,TT_ORC.NUMBLO%TYPE,TT_ORC.OBSORC%TYPE,TT_ORC.DATSEG%TYPE,TT_ORC.APROVA%TYPE,TT_ORC.APRCLI%TYPE,TT_ORC.PLACAS%TYPE,TT_ORC.QTD_KM%TYPE,TT_ORC.CODSEQ%TYPE,TT_ORC.CODEMP%TYPE,TT_ORC.ASSINA%TYPE,TT_ORC.NUMPED%TYPE,TT_ORC.ORCIMP%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODEXT ALIAS FOR $1 ;
pCODSER ALIAS FOR $2 ;
pDOCNFP ALIAS FOR $3 ;
pDATAPR ALIAS FOR $4 ;
pCODFIL ALIAS FOR $5 ;
pTIPPED ALIAS FOR $6 ;
pCLIEXT ALIAS FOR $7 ;
pVLRTOT ALIAS FOR $8 ;
pVLRPAR ALIAS FOR $9 ;
pVLRDES ALIAS FOR $10 ;
pQTDPAR ALIAS FOR $11 ;
pFILFAT ALIAS FOR $12 ;
pNUMFAT ALIAS FOR $13 ;
pFILENT ALIAS FOR $14 ;
pNUMENT ALIAS FOR $15 ;
pFILCOB ALIAS FOR $16 ;
pNUMCOB ALIAS FOR $17 ;
pDATVAL ALIAS FOR $18 ;
pDATPRI ALIAS FOR $19 ;
pAPEVEN ALIAS FOR $20 ;
pPLANO ALIAS FOR $21 ;
pDESPRE ALIAS FOR $22 ;
pRESERV ALIAS FOR $23 ;
pEMIDES ALIAS FOR $24 ;
pPESLIQ ALIAS FOR $25 ;
pPESBRU ALIAS FOR $26 ;
pVLRSEG ALIAS FOR $27 ;
pVLRFRE ALIAS FOR $28 ;
pSINAL ALIAS FOR $29 ;
pOBSERV ALIAS FOR $30 ;
pNUMBLO ALIAS FOR $31 ;
pOBSORC ALIAS FOR $32 ;
pDATSEG ALIAS FOR $33 ;
pAPROVA ALIAS FOR $34 ;
pAPRCLI ALIAS FOR $35 ;
pPLACAS ALIAS FOR $36 ;
pQTD_KM ALIAS FOR $37 ;
pCODSEQ ALIAS FOR $38 ;
pCODEMP ALIAS FOR $39 ;
pASSINA ALIAS FOR $40 ;
pNUMPED ALIAS FOR $41 ;
pORCIMP ALIAS FOR $42 ;


   WK_NUMPED                     TT_ORC.NUMPED%TYPE;
   WK_CODEXT                     TT_ORC.CODEXT%TYPE;

   WK_FILPRE                     TT_TPR.CODFIL%TYPE;
   WK_CODPRE                     TT_TPR.CODPRE%TYPE;

   WK_FILVEN                     TT_USU.FILUSU%TYPE;
   WK_CODVEN                     TT_USU.CODUSU%TYPE;

   WK_FILUSU                     TT_USU.FILUSU%TYPE;
   WK_CODUSU                     TT_USU.CODUSU%TYPE;

   WK_FILCLI                     TT_CLI.FILCLI%TYPE;
   WK_CODCLI                     TT_CLI.CODCLI%TYPE;

   WK_FILPGT                     TT_PLA.FILPGT%TYPE;
   WK_CODPGT                     TT_PLA.CODPGT%TYPE;
   nPRAIDE                       TT_PLA.PRAIDE%TYPE;

   WK_CHVAPR                     TT_ORC.CHVAPR%TYPE;

   WK_CODIGO                     TT_COD.CODTAB%TYPE;

   cDUMMY                        VARCHAR(10);
   vComplemento                  CONSTANT VARCHAR(254):= constante('complemento');
   vErro                         VARCHAR(4000);
   CRLF                          CONSTANT CHAR(1) := CHR(10);
   QuemLogou                     TRetQuemLogou;
   nQtdLinha                     Numeric(10);
   dDataParcela                  Timestamp;
   nParcela                      Numeric(2);
   nQtdParcelas                  Numeric(2);
   nValorParcela                 Numeric(12,2);
   --nSomaParcelas                 Numeric(12,2);
   nValorEntrada                 Numeric(12,2);

BEGIN
   IF pTIPPED='S' THEN
      RAISE EXCEPTION 'PG-20010 Oramento do tipo "DAV-OS" no pode ser includo ou alterado. %' , VComplemento;
   END IF;

   -- Valida parmetros.
   vErro := '';

   IF ISNULL(pCODFIL) = 'T' THEN
      vErro := vErro || 'CODFIL- Filial.'||CRLF;
   END IF;
   IF ISNULL(pTIPPED) = 'T' THEN
      vErro := vErro || 'TIPPED- Tipo de Pedido/OS.'||CRLF;
   END IF;
   IF ISNULL(pCLIEXT) = 'T' THEN
      vErro := vErro || 'CLIEXT - Cdigo externo do Cliente.'||CRLF;
   END IF;
   IF ISNULL(pPLANO) = 'T' THEN
      vErro := vErro || 'PLANO - Plano.'||CRLF;
   END IF;
   IF ISNULL(pAPEVEN) = 'T' THEN
      vErro := vErro || 'APEVEN- Apelido Vendedor.'||CRLF;
   END IF;
   IF pDATPRI IS NULL THEN
      vErro := vErro || 'DATPRI- 1 Parcela.'||CRLF;
   END IF;
   IF pDATVAL IS NULL THEN
      vErro := vErro || 'DATVAL- Validade.'||CRLF;
   END IF;
   IF ISNULL(pFILCOB) = 'T' THEN
      vErro := vErro || 'FILCOB- Filial. End Cobrana.'||CRLF;
   END IF;
   IF pNUMCOB IS NULL THEN
      vErro := vErro || 'NUMCOB- Nm. End Cobrana.'||CRLF;
   END IF;
   IF pNUMENT IS NULL THEN
      vErro := vErro || 'NUMENT- Nm. End. Entrega.'||CRLF;
   END IF;
   IF ISNULL(pFILENT) = 'T' THEN
      vErro := vErro || 'FILENT - Filial. End. Entrega.'||CRLF;
   END IF;
   IF ISNULL(pFILFAT) = 'T' THEN
      vErro := vErro || 'FILFAT- Filial. End. Fatura.'||CRLF;
   END IF;
   IF pNUMFAT IS NULL THEN
      vErro := vErro || 'NUMFAT- Nm. End. Fatura.'||CRLF;
   END IF;
   IF pQTDPAR IS NULL THEN
      vErro := vErro || 'QTDPAR- Qtd. de Parcelas.'||CRLF;
   END IF;
   IF pVLRDES IS NULL THEN
      vErro := vErro || 'VLRDES- Valor do Desconto.'||CRLF;
   END IF;
   IF pVLRPAR IS NULL THEN
      vErro := vErro || 'VLRPAR- Valor da Parcela.'||CRLF;
   END IF;
   IF pQTDPAR > 0 THEN
      IF pVLRPAR <= 0 THEN
         vErro := vErro || 'VLRPAR- Valor da Parcela.'||CRLF;
      END IF;
   END IF;
   IF pVLRTOT IS NULL THEN
      vErro := vErro || 'VLRTOT- Valor Total.'||CRLF;
   END IF;
   IF ISNULL(pEMIDES) = 'T' THEN
      vErro := vErro || 'EMIDES- Frete pelo Emitente?'||CRLF;
   END IF;
   IF ISNULL(pRESERV) = 'T' THEN
      vErro := vErro || 'RESERV- Reserva?'||CRLF;
   END IF;
   IF ISNULL(pAPROVA) = 'T' THEN
      vErro := vErro || 'APROVA- Tipo Aprovao.'||CRLF;
   END IF;
   IF ISNULL(pAPRCLI) = 'T' THEN
      vErro := vErro || 'APRCLI- Aprovao Cliente.'||CRLF;
   END IF;
   IF pCODEMP IS NULL THEN
      vErro := vErro || 'CODEMP - Cdigo do Parceiro.'||CRLF;
   END IF;
   IF (pORCIMP <> 'T') AND (pORCIMP <> 'F') THEN
      vErro := vErro || 'ORCIMP - Oramento Impresso.'||CRLF;
   END IF;
   -- RFMP 80493
   -- No deve ser obrigado a mandar a assinatura porque esta  mandada pelo ASSINA_DAV
   --IF pASSINA IS NULL THEN
   --  vErro := vErro || 'ASSINA - Assinatura.'||CRLF;
   --END IF;

   IF ISNOTNULL(vErro)='T' THEN
      RAISE EXCEPTION 'PG-20011 Os seguintes campos no foram informados e gerou inconsistncias: %' , vErro;
   END IF;

   -- Inicializao das variveis.
   select * into QuemLogou from DadosLogon();
   IF QuemLogou.Encontrou THEN
      WK_FILUSU := QuemLogou.filusu;
      WK_CODUSU := QuemLogou.codusu;
   ELSE
      RAISE EXCEPTION 'PG-20012 Voc no  um usurio cadastrado no sistema. %' , VComplemento;
   END IF;

         SELECT NUMPED INTO WK_NUMPED
        FROM TT_ORC
       WHERE NUMPED = pNUMPED
         AND TIPPED = pTIPPED
         AND CODFIL = pCODFIL;
   
   BEGIN
      SELECT CODEXT, NUMPED INTO WK_CODEXT, WK_NUMPED
        FROM TT_ORC
       WHERE CODEXT = pCODEXT;
   EXCEPTION
      
      WHEN others THEN WK_CODEXT := NULL;
      END;

   BEGIN
      SELECT FILPGT, CODPGT, PRAIDE
        INTO WK_FILPGT, WK_CODPGT, nPRAIDE
        FROM TT_PLA
       WHERE UPPER(APEPGT) = UPPER(pPLANO);
   EXCEPTION
      
      WHEN others THEN NULL;
      END;
   IF WK_FILPGT IS NULL THEN
      RAISE EXCEPTION 'PG-20013 Plano no existe. %' , VComplemento;
   END IF;

   BEGIN
      SELECT FILCLI, CODCLI INTO WK_FILCLI, WK_CODCLI
        FROM TT_CLI
       WHERE CODEXT = pCLIEXT;
   EXCEPTION
      
      WHEN others THEN NULL;
      END;
   IF WK_FILCLI IS NULL THEN
      RAISE EXCEPTION 'PG-20014 Cliente no existe. %' , VComplemento;
   END IF;

   BEGIN
      SELECT FILUSU, CODUSU INTO WK_FILVEN, WK_CODVEN
        FROM TT_USU
       WHERE UPPER(APEUSU) = UPPER(pAPEVEN);
   EXCEPTION
      
      WHEN others THEN NULL;
      END;
   IF WK_FILVEN IS NULL THEN
      RAISE EXCEPTION 'PG-20015 Vendedor no existe. %' , VComplemento;
   END IF;

   IF pDESPRE IS NOT NULL THEN
      BEGIN
         SELECT CODFIL, CODPRE INTO WK_FILPRE, WK_CODPRE
           FROM TT_TPR
          WHERE DESPRE = pDESPRE;
      EXCEPTION
            
         WHEN others THEN NULL;
            END;
      IF WK_FILPRE IS NULL THEN
         RAISE EXCEPTION 'PG-20016 Tabela de preos % no existe. %' , pDESPRE,VComplemento;
      END IF;
   ELSE
      SELECT FILPRE, CODPRE INTO WK_FILPRE, WK_CODPRE
        FROM TT_CFG;
   END IF;

   --Alteraes ou incluso no oramento.
   IF WK_CODEXT IS NULL THEN
      IF ISNULL(WK_NUMPED) = 'T' THEN
         IF pTIPPED = 'P' THEN
            WK_CODIGO := 'PRE';
         ELSE
            WK_CODIGO := 'ORC';
         END IF;

         SELECT COUNT(*) INTO nQtdLinha
           FROM TT_COD
          WHERE CODTAB = WK_CODIGO
            AND FILCOD = pCODFIL;

         IF nQTDLinha=0 THEN
            WK_NUMPED := '00000001';
            INSERT INTO TT_COD (CODTAB,ULTCOD,FILCOD) VALUES (WK_CODIGO,1,pCODFIL);
         ELSE
            SELECT LPAD(TO_CHAR(ULTCOD + 1),8,'0') INTO WK_NUMPED
              FROM TT_COD
             WHERE CODTAB = WK_CODIGO
               AND FILCOD = pCODFIL;

            UPDATE TT_COD
               SET ULTCOD = ULTCOD + 1
             WHERE CODTAB = WK_CODIGO
               AND FILCOD = pCODFIL;
         END IF;

         INSERT INTO TT_ORC
         (CODEXT, CODSER, DOCNFP, DATAPR, PESLIQ, PESBRU,
          VLRSEG, VLRFRE,  SINAL, OBSERV, NUMBLO, OBSORC, DATSEG, PLACAS, QTD_KM,
          CODSEQ,
          CODFIL,TIPPED,NUMPED,FLGEST,NATURE,TIPENT,CODPGT,CODUSU,CODVEN,FILCLI,
          FILPGT,FILPRE,FILUSU,FILVEN,CODCLI,ATU_EM,DATPRI,DATVAL,PED_EM,VLRDES,
          VLRPAR,VLRTOT,NUMCOB,NUMENT,NUMFAT,CODFIN,CODPRE,QTDPAR,DESCLI,EMIDES,
          RESERV,FILCOB,FILENT,FILFAT,FILALC,APROVA,APRCLI,SEPARA,COMAND,CHVAPR,
          CODEMP,CODUID,ASSINA,ORCIMP,DATENT)
         (SELECT pCODEXT, pCODSER, pDOCNFP, COALESCE(agora(),pDATAPR), pPESLIQ, pPESBRU,
                 pVLRSEG, pVLRFRE, pSINAL, pOBSERV, pNUMBLO,
                 pOBSORC, pDATSEG, pPLACAS, pQTD_KM, pCODSEQ,
                 pCODFIL, pTIPPED, WK_NUMPED, 'A', 0, 6, WK_CODPGT,
                 WK_CODUSU, WK_CODVEN, WK_FILCLI, WK_FILPGT, WK_FILPRE,
                 WK_FILUSU, WK_FILVEN, WK_CODCLI, agora(), COALESCE(pDATPRI, agora()), COALESCE(pDATVAL,add_day(agora(),1)), agora(), pVLRDES,
                 pVLRPAR, pVLRTOT, pNUMCOB, pNUMENT, pNUMFAT, 0, WK_CODPRE, pQTDPAR,
                 'F','F',
                 pRESERV, pFILCOB, pFILENT, pFILFAT, pCODFIL, pAPROVA, pAPRCLI,'F','F',0,
                 pCODEMP, NULL, pASSINA, pORCIMP, TRUNC(Agora())
            FROM DUAL);

         UPDATE TT_ORC
            SET TIPENT = '6'
          WHERE NUMPED = WK_NUMPED
            AND TIPPED = pTIPPED
            AND CODFIL = pCODFIL;
      ELSE
         IF pAPROVA = 'A' THEN
            WK_CHVAPR := 0;
         END IF;
         cDummy := ALTERA_DAV(WK_CODEXT, pCODSER, pDOCNFP, pDATAPR, pCODFIL, pTIPPED,
                                       WK_FILCLI, WK_CODCLI, pVLRTOT, pVLRPAR, pVLRDES, pQTDPAR, pFILFAT,
                                       pNUMFAT, pFILENT, pNUMENT, pFILCOB, pNUMCOB, pDATVAL,
                                       pDATPRI, WK_FILVEN, WK_CODVEN, WK_FILPGT, WK_CODPGT,
                                       wk_FILPRE, wk_CODPRE, pRESERV,
                                       pEMIDES, pPESLIQ, pPESBRU, pVLRSEG, pVLRFRE,  pSINAL,
                                       pOBSERV, pNUMBLO, pOBSORC, pDATSEG, pAPROVA, pAPRCLI,
                                       pPLACAS, pQTD_KM, pCODSEQ, WK_NUMPED, WK_CHVAPR,
                                       pCODEMP, pASSINA, pORCIMP);

         UPDATE TT_ORC
            SET TIPENT = '6'
          WHERE NUMPED = WK_NUMPED
            AND TIPPED = pTIPPED
            AND CODFIL = pCODFIL;
      END IF;
   ELSE
      IF pAPROVA = 'A' THEN
         WK_CHVAPR := 0;
      END IF;

      cDummy := ALTERA_DAV(WK_CODEXT, pCODSER, pDOCNFP, pDATAPR, pCODFIL, pTIPPED,
                                    WK_FILCLI, WK_CODCLI, pVLRTOT, pVLRPAR, pVLRDES, pQTDPAR, pFILFAT,
                                    pNUMFAT, pFILENT, pNUMENT, pFILCOB, pNUMCOB, pDATVAL,
                                    pDATPRI, WK_FILVEN, WK_CODVEN, WK_FILPGT, WK_CODPGT,
                                    wk_FILPRE, wk_CODPRE, pRESERV,
                                    pEMIDES, pPESLIQ, pPESBRU, pVLRSEG, pVLRFRE,  pSINAL,
                                    pOBSERV, pNUMBLO, pOBSORC, pDATSEG, pAPROVA, pAPRCLI,
                                    pPLACAS, pQTD_KM, pCODSEQ, WK_NUMPED, WK_CHVAPR,
                                    pCODEMP, pASSINA, pORCIMP);

      UPDATE TT_ORC
         SET TIPENT = '6'
       WHERE CODEXT = WK_CODEXT;
   END IF;


   -- RFMP 100651
   -- Aqui j incluiu ou alterou a DAV
   --  hora de tratar as parcelas
   dDataParcela := Agora();
	dDataParcela := ADD_DAY(TRUNC(dDataParcela), nPRAIDE);
   nQtdParcelas := pQTDPAR + 1;

   IF nQtdParcelas > 1 THEN
      --nValorParcela := ROUND(pVLRTOT / nQtdParcelas, 2);
      --nSomaParcelas := ROUND(nValorParcela * nQtdParcelas, 2);
      --nValorEntrada := nValorParcela + (pVLRTOT - nSomaParcelas);
      nValorParcela := pVLRPAR;
      nValorEntrada := COALESCE(pSINAL,0);
   ELSE
      nValorParcela := 0;
      --nSomaParcelas := 0;
      nValorEntrada := pVLRTOT;
   END IF;

   DELETE FROM TT_POR
    WHERE CODFIL = pCODFIL
      AND TIPPED = pTIPPED
      AND NUMPED = WK_NUMPED;

   FOR nParcela IN 1..nQtdParcelas LOOP

      INSERT INTO TT_POR
      (CODFIL, TIPPED, NUMPED, NUMPAR, DATORI, DATVEN, VLRPAR, JURPAR)
      SELECT pCODFIL,
             pTIPPED,
             WK_NUMPED,
             LPAD(TO_CHAR(nParcela), 2, ' '),
             dDataParcela,
             dDataParcela,
             CASE WHEN nParcela=1 THEN nValorEntrada ELSE nValorParcela END,
             0
        FROM DUAL;

      dDataParcela := ADD_MONTHS(dDataParcela, 1);
   END LOOP;

   
   RETURN WK_NUMPED;
   
   

END;
$$ language 'plpgsql';




/*-- SEQ 0939 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ENVIA_IND_TEC_PRODUCAO (TT_GRA.CODEXT%TYPE,TT_GRA.CODEXT%TYPE,TT_ITP.QTDINS%TYPE,TT_ITP.CODFIL%TYPE) CASCADE;

/*-- SEQ 0940 --*/
CREATE OR REPLACE FUNCTION ENVIA_IND_TEC_PRODUCAO (TT_GRA.CODEXT%TYPE,TT_GRA.CODEXT%TYPE,TT_ITP.QTDINS%TYPE,TT_ITP.CODFIL%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODEXT ALIAS FOR $1 ;
pINSEXT ALIAS FOR $2 ;
pQTDINS ALIAS FOR $3 ;
pCODFIL ALIAS FOR $4 ;

  WK_FILMAT    TT_GRA.FILMAT%TYPE;
  WK_CODMAT    TT_GRA.CODMAT%TYPE;
  WK_CODCOR    TT_GRA.CODCOR%TYPE;
  WK_CODTAM    TT_GRA.CODTAM%TYPE;
  WK_FILINS    TT_GRA.FILMAT%TYPE;
  WK_CODINS    TT_GRA.CODMAT%TYPE;
  WK_CORINS    TT_GRA.CODCOR%TYPE;
  WK_TAMINS    TT_GRA.CODTAM%TYPE;  
  WK_EXISTE    Numeric(10); 
  
BEGIN

  IF ISNULL(pCODEXT) = 'T' THEN
    RAISE EXCEPTION 'PG-20010 Cdigo externo do produto prprio no informado.';
  END IF;
  
  IF ISNULL(pINSEXT) = 'T' THEN
    RAISE EXCEPTION 'PG-20010 Cdigo externo do insumo no informado.';
  END IF;

  IF pQTDINS IS NULL THEN
    RAISE EXCEPTION 'PG-20010 Quantidade do Insumo no informada.';
  END IF;

  IF ISNULL(pCODFIL) = 'T' THEN
    RAISE EXCEPTION 'PG-20010 Filial no informada.';
  END IF;

  IF pQTDINS < 1 THEN
    RAISE EXCEPTION 'PG-20010 Quantidade do Insumo deve ser positiva.';
  END IF;
  
  BEGIN
    SELECT FILMAT, CODMAT, CODCOR, CODTAM
      INTO WK_FILMAT, WK_CODMAT, WK_CODCOR, WK_CODTAM
      FROM TT_GRA
     WHERE CODEXT = pCODEXT;
  EXCEPTION    
        
    WHEN others THEN WK_FILMAT := NULL;
	                 WK_CODMAT := NULL;
					 WK_CODCOR := NULL;
					 WK_CODTAM := NULL;
      END; 

  IF (WK_FILMAT IS NULL) OR
	 (WK_CODMAT IS NULL) OR
	 (WK_CODCOR IS NULL) OR 
	 (WK_CODTAM IS NULL) THEN
     RAISE EXCEPTION 'PG-20011 Produto Prprio no encontrado com este cdigo externo.';
  END IF;  
  
  BEGIN
    SELECT FILMAT, CODMAT, CODCOR, CODTAM 
      INTO WK_FILINS ,WK_CODINS, WK_CORINS, WK_TAMINS 
      FROM TT_GRA
     WHERE CODEXT = pINSEXT;
  EXCEPTION    
        
    WHEN others THEN WK_FILINS := NULL;
	                 WK_CODINS := NULL;
					 WK_CORINS := NULL;
					 WK_TAMINS := NULL;
        
  END;   
  
  IF (WK_FILINS IS NULL) OR
	 (WK_CODINS IS NULL) OR
	 (WK_CORINS IS NULL) OR 
	 (WK_TAMINS IS NULL) THEN
     RAISE EXCEPTION 'PG-20011 Insumo no encontrado com este cdigo externo.';
  END IF;
  
  BEGIN
    SELECT COUNT(*) INTO WK_EXISTE 
      FROM TT_ITP
     WHERE FILMAT = WK_FILMAT
       AND CODMAT = WK_CODMAT 
	   AND CODCOR = WK_CODCOR
	   AND CODTAM = WK_CODTAM
       AND FILINS = WK_FILINS
       AND CODINS = WK_CODINS
	   AND CORINS = WK_CORINS
	   AND TAMINS = WK_TAMINS;
  EXCEPTION    
        
    WHEN others THEN NULL;
        RAISE EXCEPTION 'PG-20011 ndice Tcnico de Produo no encontrado.';
  END;  
	  
  IF WK_EXISTE > 0 THEN
    RAISE EXCEPTION 'PG-20010 J existe este ndice Tcnico de Produo.';
  END IF;	 
  
  IF (WK_FILMAT = WK_FILINS) AND 
     (WK_CODMAT = WK_CODINS) AND
     (WK_CODCOR = WK_CORINS) AND
     (WK_CODTAM = WK_TAMINS) THEN
     RAISE EXCEPTION 'PG-20010 No  permitido produto prprio ser usado como o prprio insumo.';
  END IF;

  --incluso do ndice Tcnicos de Produo.                 
  INSERT INTO TT_ITP
    (CODFIL, FILMAT, CODMAT, CODCOR, CODTAM, FILINS, CODINS, CORINS, TAMINS, QTDINS)
    VALUES
	(pCODFIL, WK_FILMAT, WK_CODMAT, WK_CODCOR, WK_CODTAM, WK_FILINS, WK_CODINS, WK_CORINS, WK_TAMINS, pQTDINS);    
		
  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 0941 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION EXCLUI_IND_TEC_PRODUCAO (TT_GRA.CODEXT%TYPE) CASCADE;

/*-- SEQ 0942 --*/
CREATE OR REPLACE FUNCTION EXCLUI_IND_TEC_PRODUCAO (TT_GRA.CODEXT%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODEXT ALIAS FOR $1 ;

  WK_FILMAT    TT_GRA.FILMAT%TYPE;
  WK_CODMAT    TT_GRA.CODMAT%TYPE;
  WK_CODCOR    TT_GRA.CODCOR%TYPE;
  WK_CODTAM    TT_GRA.CODTAM%TYPE; 
  WK_EXISTE    Numeric(10); 
  
BEGIN
  
  IF ISNULL(pCODEXT) = 'T' THEN
    RAISE EXCEPTION 'PG-20010 Cdigo externo do produto prprio no informado.';
  END IF;
  
  BEGIN
    SELECT FILMAT, CODMAT, CODCOR, CODTAM
      INTO WK_FILMAT, WK_CODMAT, WK_CODCOR, WK_CODTAM
      FROM TT_GRA
     WHERE CODEXT = pCODEXT;
  EXCEPTION    
        
    WHEN others THEN WK_FILMAT := NULL;
					 WK_CODMAT := NULL;
					 WK_CODCOR := NULL;
					 WK_CODTAM := NULL;
      END;

  IF (WK_FILMAT IS NULL) OR
	 (WK_CODMAT IS NULL) OR
	 (WK_CODCOR IS NULL) OR 
	 (WK_CODTAM IS NULL) THEN
     RAISE EXCEPTION 'PG-20011 Produto Prprio no encontrado com este cdigo externo.';
  END IF;    

  --excluso do ndice Tcnicos de Produo.                 
  DELETE FROM TT_ITP
   WHERE FILMAT = WK_FILMAT
     AND CODMAT = WK_CODMAT
	 AND CODCOR = WK_CODCOR
	 AND CODTAM = WK_CODTAM;

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 0943 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION FaturaClienteGlobal (TT_CCC.CODFIL%TYPE,TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE,TT_LIM.TIPCCC%TYPE,TT_VEN.SEQUEN%TYPE,VARCHAR,TT_CCC.DATOPE%TYPE,TT_CCC.CODFIL%TYPE,TT_VEN.FILFAT%TYPE,TT_VEN.ENDFAT%TYPE,TT_CCC.CHKFAT%TYPE) CASCADE;

/*-- SEQ 0944 --*/
CREATE OR REPLACE FUNCTION FaturaClienteGlobal (TT_CCC.CODFIL%TYPE,TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE,TT_LIM.TIPCCC%TYPE,TT_VEN.SEQUEN%TYPE,VARCHAR,TT_CCC.DATOPE%TYPE,TT_CCC.CODFIL%TYPE,TT_VEN.FILFAT%TYPE,TT_VEN.ENDFAT%TYPE,TT_CCC.CHKFAT%TYPE)
RETURNS VARCHAR AS $$
DECLARE
PCODFIL ALIAS FOR $1 ;
PFILCLI ALIAS FOR $2 ;
PCODCLI ALIAS FOR $3 ;
PFILUSU ALIAS FOR $4 ;
PCODUSU ALIAS FOR $5 ;
PTIPCCC ALIAS FOR $6 ;
pSEQVEN ALIAS FOR $7 ;
pSEQUEN ALIAS FOR $8 ;
pDATOPE ALIAS FOR $9 ;
pFILIALFILTRO ALIAS FOR $10 ;
pFILFAT ALIAS FOR $11 ;
pENDFAT ALIAS FOR $12 ;
pCHKFAT ALIAS FOR $13 ;

cFilGlo TT_CLI.FILCLI%TYPE;
cCodGlo TT_CLI.CODCLI%TYPE;
cNUMDOC TT_CCC.NUMDOC%TYPE;
cSEQUEN TT_CCC.SEQUEN%TYPE;
cTEMP VARCHAR(255);
nVSALDO TT_LIM.VSALDO%TYPE;
nCODCOB TT_LIM.CODCOB%TYPE; 
vComplemento CONSTANT VARCHAR(100) := constante('complemento');


  r_linha RECORD;
  a_vsalva VARCHAR[];
  a_hsalva VARCHAR[];
  n_conta INTEGER;
  c_dummy VARCHAR;

 dDiaRet  Timestamp;


VINCULADOS CURSOR FOR
SELECT FILCLI, CODCLI
  FROM TT_CLI
 WHERE FILVIN=pFILCLI
   AND CODVIN=pCODCLI
   AND GLOBAL='G';
   
BEGIN

   IF LENGTH(pSEQUEN)>10 THEN
      RAISE EXCEPTION 'PG-20036 Executavel esta em versao inferior a do banco. %' , vComplemento;
   END IF;
    
   select LPAD(TO_CHAR(NEXTVAL('SQCCC')), 10, ' ') INTO cSEQUEN
     from tt_cfg;
     
   select NUMNOT INTO cNUMDOC
     from tt_ven 
    where codfil=pCODFIL
      and sequen=pSEQVEN;
     
   select sum(ccc.vlrlan)*-1, coalesce(pDatOpe,add_day(trunc(AGORA()),- COALESCE(min(DCCC.DIARET),0)))  into nVSALDO, dDiaRet
     from tt_ccc ccc inner join td_ccc dccc on ccc.tipccc=dccc.codtab
                     inner join tt_lim lim on lim.filcli = ccc.filcli and lim.codcli = ccc.codcli and lim.tipccc = ccc.tipccc
                     left  join tt_ven ven on ven.codfil = ccc.codven and ven.sequen = ccc.seqven
                     left  join tt_ccc cc2 on cc2.codfil = ccc.filccc
                                          and cc2.sequen = ccc.seqccc                     
    where ccc.filcli = pfilcli
      and ccc.codcli = pcodcli
      and ccc.tipccc = ptipccc
      and ccc.status in ('A','P')
      and ccc.filfat is null
      and ccc.chkfat = CASE WHEN pChkfat = 'T' THEN pChkfat ELSE ccc.chkfat END
      and ((ccc.SEQUEN <= pSEQUEN AND trunc(ccc.datope)<= coalesce(pDatOpe,add_day(trunc(AGORA()),- COALESCE(DCCC.DIARET,0)))) 
      -- MN - Essa funo mostra o saldo de um cliente que deve ser faturado. A condio abaixo, cc2.vlrlan > 0 existe para trazer
     -- o crdito da devoluo de venda em qualquer momento. Exemplo, cliente fatura de 01 a 31/01, se tiver uma devoluo em 10/02, o crdito
     -- dessa devoluo estar presente no faturamento. Quando ocorre um CANCELAMENTO de venda, o sistema no registra o vnculo entre
     -- as ccs, e no caso do cancelamento de venda, ele  processado no ms que ocorreu o cancelamento.
       or ((cc2.vlrlan>0) 
      and (coalesce(cc2.datope,trunc(pDatOpe)) <= trunc(pDatOpe))))
      AND ccc.CODFIL=CASE when ISNULL(TRIM(pFILIALFILTRO))='T' THEN CCC.CODFIL 
                                                                         ELSE pFILIALFILTRO
                     END
      AND (LIM.FATEND = 'F' OR
          (coalesce(ven.filfat,lim.filcob) = COALESCE(pfilfat,LIM.FILCOB) and
           coalesce(ven.endfat,lim.endcob) = COALESCE(pendfat,LIM.ENDCOB))
          );

    IF nVSALDO>0 THEN

        -- portador
        SELECT COALESCE(LXF.CODCOB,LIM.CODCOB) INTO nCODCOB
          FROM TT_LIM LIM LEFT JOIN TT_LIMXFIL LXF ON LIM.FILCLI=LXF.FILCLI
                                                  AND LIM.CODCLI=LXF.CODCLI
                                                  AND LIM.TIPCCC=LXF.TIPCCC
                                                  AND LXF.CODFIL = pCODFIL
         WHERE LIM.FILCLI = pFILCLI
           AND LIM.CODCLI = pCODCLI
           AND LIM.TIPCCC = pTIPCCC;

        INSERT INTO TT_CCC
        (CODFIL, SEQUEN, FILCLI, CODCLI, DATOPE, NUMDOC, FILUSU, CODUSU, VLRLAN, TIPCCC, STATUS, FILFAT, SEQFAT, PORORI,TIPLAN)
        VALUES
        (pCODFIL, cSEQUEN, pFILCLI, pCODCLI, greatest(pDATOPE,agora()), cNUMDOC, pFILUSU, pCODUSU, nVSALDO, pTIPCCC, 'F', pCODFIL, pSEQVEN, nCODCOB, 'G');
    END IF;

   UPDATE TT_CCC set
      FILFAT = pCODFIL,
      SEQFAT = pSEQVEN
   WHERE FILCLI = pFILCLI
     AND CODCLI = pCODCLI
     AND TIPCCC = pTIPCCC
     AND FILFAT IS NULL  AND SEQFAT IS NULL
     AND CHKFAT = CASE WHEN pCHKFAT = 'T' THEN pCHKFAT ELSE CHKFAT END
     AND SEQUEN <= pSEQUEN
     AND ((trunc(DATOPE) <= dDiaRet) OR (VLRLAN >= 0))
     AND status <> 'S'
     AND CODFIL=CASE when ISNULL(TRIM(pFILIALFILTRO))='T' THEN CODFIL
                                                                     ELSE pFILIALFILTRO
                END
     and (codfil, sequen) in (   select ccc.codfil, ccc.sequen
                                   from tt_ccc ccc inner join td_ccc dccc on ccc.tipccc=dccc.codtab
                                                   inner join tt_lim lim on lim.filcli = ccc.filcli and lim.codcli = ccc.codcli
                                                                        and lim.tipccc = ccc.tipccc
                                                   left  join tt_ven ven on ven.codfil = ccc.codven and ven.sequen = ccc.seqven
                                                   left  join tt_ccc cc2 on cc2.codfil = ccc.filccc
                                                                        and cc2.sequen = ccc.seqccc                                                    
                                  where ccc.filcli = pfilcli
                                    and ccc.codcli = pcodcli
                                    and ccc.tipccc = ptipccc
                                    and ccc.status in ('A','P')
                                    and ccc.filfat is null
                                    and ccc.chkfat = CASE WHEN pChkfat = 'T' THEN pChkfat ELSE ccc.chkfat END
                                    and ((ccc.SEQUEN <= pSEQUEN AND trunc(ccc.datope)<= coalesce(pDatOpe,add_day(trunc(AGORA()),- COALESCE(DCCC.DIARET,0)))) 
                                    -- MN - Essa funo mostra o saldo de um cliente que deve ser faturado. A condio abaixo, cc2.vlrlan > 0 existe para trazer
                                    -- o crdito da devoluo de venda em qualquer momento. Exemplo, cliente fatura de 01 a 31/01, se tiver uma devoluo em 10/02, o crdito
                                    -- dessa devoluo estar presente no faturamento. Quando ocorre um CANCELAMENTO de venda, o sistema no registra o vnculo entre
                                    -- as ccs, e no caso do cancelamento de venda, ele  processado no ms que ocorreu o cancelamento.
                                    or ((cc2.vlrlan>0) 
                                    and (coalesce(cc2.datope,trunc(pDatOpe)) <= trunc(pDatOpe))))
                                    AND ccc.CODFIL=CASE when ISNULL(TRIM(pFILIALFILTRO))='T' THEN CCC.CODFIL
                                                                                              ELSE pFILIALFILTRO
                                                    END
                                    AND (LIM.FATEND = 'F' OR
                                        (coalesce(ven.filfat,lim.filcob) = COALESCE(pfilfat,LIM.FILCOB) and
                                         coalesce(ven.endfat,lim.endcob) = COALESCE(pendfat,LIM.ENDCOB))));


     
  
    n_conta := 0;
    
  OPEN Vinculados;
  LOOP
  
 
 
    n_conta := n_conta + 1;
    FETCH Vinculados INTO r_linha;
    EXIT WHEN NOT FOUND;
    c_dummy := r_linha.FILCLI||','||r_linha.CODCLI;
    IF n_conta = 1 THEN
      select ARRAY[c_dummy] into a_vsalva;
    ELSE
     select array_append (a_vsalva,c_dummy) into a_vsalva;
    END IF;
              
    
  END LOOP;
  CLOSE Vinculados;
  
 
 FOR i IN 1..n_conta-1 LOOP
   select '{'||a_vsalva[i]||'}' into a_hsalva;
   cTEMP:=FaturaClienteGlobal(PCODFIL,a_hsalva[1], lpad(a_hsalva[2],6,' '),PFILUSU,PCODUSU,PTIPCCC,pSEQVEN,pSEQUEN,pDATOPE,pFILIALFILTRO,NULL,NULL,pCHKFAT);
 END LOOP;
  
  
  RETURN 'OK';
  
END;
$$ language 'plpgsql';


/*-- SEQ 0945 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION FaturaClienteGlobal (TT_CCC.CODFIL%TYPE,TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE,TT_LIM.TIPCCC%TYPE,TT_VEN.SEQUEN%TYPE,VARCHAR,TT_CCC.DATOPE%TYPE,TT_CCC.CODFIL%TYPE) CASCADE;

/*-- SEQ 0946 --*/
CREATE OR REPLACE FUNCTION FaturaClienteGlobal (TT_CCC.CODFIL%TYPE,
                               TT_CLI.FILCLI%TYPE,
                               TT_CLI.CODCLI%TYPE,
                               TT_USU.FILUSU%TYPE,
                               TT_USU.CODUSU%TYPE,
                               TT_LIM.TIPCCC%TYPE,
                               TT_VEN.SEQUEN%TYPE,
                               VARCHAR,
                               TT_CCC.DATOPE%TYPE,
                               TT_CCC.CODFIL%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN FaturaClienteGlobal($1,$2,$3,$4,$5,$6,$7,$8,$9,$10,NULL,NULL,'F');
END;
$$ language 'plpgsql';


/*-- SEQ 0947 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION FaturaClienteGlobal (TT_CCC.CODFIL%TYPE,TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE,TT_LIM.TIPCCC%TYPE,TT_VEN.SEQUEN%TYPE,VARCHAR,TT_CCC.DATOPE%TYPE,TT_CCC.CODFIL%TYPE,TT_VEN.FILFAT%TYPE,TT_VEN.ENDFAT%TYPE) CASCADE;

/*-- SEQ 0948 --*/
CREATE OR REPLACE FUNCTION FaturaClienteGlobal (TT_CCC.CODFIL%TYPE,
                               TT_CLI.FILCLI%TYPE,
                               TT_CLI.CODCLI%TYPE,
                               TT_USU.FILUSU%TYPE,
                               TT_USU.CODUSU%TYPE,
                               TT_LIM.TIPCCC%TYPE,
                               TT_VEN.SEQUEN%TYPE,
                               VARCHAR,
                               TT_CCC.DATOPE%TYPE,
                               TT_CCC.CODFIL%TYPE,
                               TT_VEN.FILFAT%TYPE,
                               TT_VEN.ENDFAT%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN FaturaClienteGlobal($1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,$12,'F');
END;
$$ language 'plpgsql';


/*-- SEQ 0949 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION FilialPadrao () CASCADE;

/*-- SEQ 0950 --*/
CREATE OR REPLACE FUNCTION FilialPadrao ()
RETURNS TD_FIL.CODFIL%TYPE AS $$
DECLARE

  -- Objetivos
  -- traz a filial padro.
  wk_Retorno TD_FIL.CODFIL%TYPE;
begin
  select codloj into wk_Retorno from tt_idf ;
  Return wk_Retorno;
END;
$$ language 'plpgsql';




/*-- SEQ 0951 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION FinanceiroEstoque (TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 0952 --*/
CREATE OR REPLACE FUNCTION FinanceiroEstoque (TD_FIL.CODFIL%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;

vDATEST Timestamp;
BEGIN

  INSERT INTO TL_FIN
   (ORIGEM, FILORI, SEQORI, PARORI, SUBORI, DATINC)
   (SELECT 'EST', FIL.CODFIL, TO_CHAR(DAT.DATOPE,'DD/MM/YYYY'), '--', '--', agora()
      FROM TT_DAT DAT INNER JOIN TD_FIL FIL ON DAT.DATOPE BETWEEN COALESCE(FIL.DATFINEST,TO_DATE('01/01/2010','DD/MM/YYYY'))
                                                              AND ADD_DAY(TRUNC(AGORA()),-1)
     WHERE FIL.CODFIL = pCODFIL);

  UPDATE TD_FIL SET DATFINEST=TRUNC(Agora())
   WHERE CODFIL = pCODFIL
     AND COALESCE(DATFINEST,TO_DATE('01/01/1900','DD/MM/YYYY')) < TRUNC(Agora());

  RETURN NULL;

END;
$$ language 'plpgsql';



/*-- SEQ 0953 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_FinanceiroEstoque (TT_JOB.CODUID%TYPE) CASCADE;

/*-- SEQ 0954 --*/
CREATE OR REPLACE FUNCTION Job_FinanceiroEstoque (TT_JOB.CODUID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODUID ALIAS FOR $1 ;
   cCODFIL                       TT_SAL.CODFIL%TYPE;
   cNome                         TT_JOB.NOMJOB%TYPE;
   vDesc                         TT_JOB.DESJOB%TYPE;
   cDummy                        CHAR(2);

   CursorFiliais CURSOR FOR
   SELECT CODFIL
     FROM TD_FIL
    WHERE FILATI = 'T';

BEGIN
   cNome := 'JOB_FINANCEIROESTOQUE';
   vDesc := 'Materializar o financeiro do estoque';
   BEGIN
      OPEN CursorFiliais;
      LOOP
         FETCH CursorFiliais INTO cCODFIL;
         EXIT WHEN NOT FOUND;
         cDummy := FinanceiroEstoque(cCODFIL);
      END LOOP;
      CLOSE CursorFiliais;

      cDummy := RegistraJob(cNome, vDesc, NULL, pCODUID);
   EXCEPTION
      WHEN OTHERS THEN cDummy := RegistraJob(cNome, vDesc, SQLERRM, pCODUID);
   END;
  RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 0955 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_FinanceiroEstoque () CASCADE;

/*-- SEQ 0956 --*/
CREATE OR REPLACE FUNCTION Job_FinanceiroEstoque () 
RETURNS VARCHAR AS $$
BEGIN
RETURN Job_FinanceiroEstoque(NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 0957 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GeraCobrancas (TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 0958 --*/
CREATE OR REPLACE FUNCTION GeraCobrancas (TD_FIL.CODFIL%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
  -- Procedimento para gerar e baixar Cobrancas

   cULTIMA_SEQUEN                TT_COB.SEQUEN%TYPE;
   cTEMP                         VARCHAR(1);
   LF                            CHAR(2):=CHR(13)||CHR(10);
   cEMAIL                        TT_CFG.COB_E_MAIL_SAC%TYPE;
   cMAI_FR                       TT_CFG.MAI_FR%TYPE;
   cSEQFIN                       TT_COB.SEQUEN%TYPE;
   vDATA                         Timestamp;
   i_INS_SUP                     INTEGER;
   i_NLIDO_SUP                   INTEGER;
   i_RESOLV_SUP                  INTEGER;
   i_COBRANCAS                   INTEGER;

BEGIN
  -- Garantia de exclusividade no processo seguinte
  SELECT LOCK_C INTO cTEMP
  FROM TT_IDF
  FOR UPDATE;

  vDATA:=agora();

  INSERT INTO TT_SUP
  (FILCLI, CODCLI, CODFIL, DATREG, MODULO,
   VERSAO, SITUAC, FILRES, CODRES, FLGCOB,
   CODPRI, TIPSUP, TIPCWS, CODFUN, PERFIL,
   DESSUP, FILEND, NUMEND )
  (SELECT /*+ INDEX(VEN,PK_VEN) INDEX(CLI,PK_CLI) */
          DISTINCT
          VEN.FILCLI, VEN.CODCLI,
           pCodFil AS CODFIL,
          AGORA() AS DATREG,
          0 AS MODULO,
          '-X-' AS VERSAO,
          'N' AS SITUAC,
          CFG.COB_FIL_GERENTE AS FILRES,
          CFG.COB_COD_GERENTE AS CODRES,
          'S' AS FLGCOB, -- Ver flag
          1 AS CODPRI,
          0 AS TIPSUP,   -- Ver flag
          'A' AS TIPCWS, -- Ver flag
          0 AS CODFUN,
          'C' AS PERFIL,
          'Cobranca de ' || CLI.NOMCLI ||
          case when CLI.FLGTIP='0' then ' ' || CLI.ULTNOM
                                   else ''
          end AS DESSUP,
          COALESCE(VEN.FILCOB,(SELECT SUBSTR(MIN(ENDE.CODFIL||ENDE.NUMEND),1,3)
                                 FROM TT_END ENDE
                                WHERE CLI.FILCLI = ENDE.FILCLI
                                  AND CLI.CODCLI = ENDE.CODCLI
								  AND ENDE.ENDCOB = 'T')) AS FILEND,
          COALESCE(VEN.ENDCOB,(SELECT TO_NUMBER(SUBSTR(MIN(ENDE.CODFIL||ENDE.NUMEND),4,10))
                                 FROM TT_END ENDE
                                WHERE CLI.FILCLI = ENDE.FILCLI
                                  AND CLI.CODCLI = ENDE.CODCLI
								  AND ENDE.ENDCOB = 'T')) AS NUMEND
     FROM (SELECT COB_USA_SAC,
                  COB_FIL_GERENTE,
                  COB_COD_GERENTE,
                  COB_DIAS_VENCTO,
                  VC_FILCLI,
                  VC_CODCLI
             FROM TT_CFG) CFG,
          TT_REC REC LEFT OUTER JOIN (select COB.FILREC,COB.SEQREC,COB.NUMPAR,COB.SUBPAR
                                      from TT_SUP SUP INNER JOIN TT_COB COB ON SUP.CODFIL = COB.FILSUP
                                                                                AND SUP.SEQUEN = COB.SEQSUP
                                      where SUP.SITUAC NOT IN ('A','N')) COB
                                                ON COB.FILREC = REC.CODFIL
                                               AND COB.SEQREC = REC.SEQUEN
                                               AND COB.NUMPAR = REC.NUMPAR
                                               AND COB.SUBPAR = REC.SUBPAR
                          INNER JOIN TT_VEN VEN ON REC.CODFIL = VEN.CODFIL
                                               AND REC.SEQUEN = VEN.SEQUEN
                          INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI
                                               AND CLI.CODCLI = VEN.CODCLI
                     LEFT OUTER JOIN TT_SUP OUT ON OUT.FILCLI = VEN.FILCLI
                                               AND OUT.CODCLI = VEN.CODCLI
                                               AND OUT.PERFIL = 'C'
                                               AND OUT.SITUAC IN ('A','N')
  WHERE CFG.COB_USA_SAC = 'T'
    AND (VEN.FILCLI||VEN.CODCLI) <> (CFG.VC_FILCLI||CFG.VC_CODCLI)
    AND REC.DATVEN <= add_day(TRUNC(AGORA()), - CFG.COB_DIAS_VENCTO)
    AND REC.FLGEST = 'A'
    AND REC.CARTAO IS NULL
    AND REC.SEQCHE IS NULL
    AND COB.FILREC IS NULL   -- Se esta parcela nao esta em suporte aberto
    AND OUT.FILCLI IS NULL); -- Se nao existe outro suporte para este cliente


  INSERT INTO TT_SUP
  (FILCLI, CODCLI, CODFIL, DATREG, MODULO,
   VERSAO, SITUAC, FILRES, CODRES, FLGCOB,
   CODPRI, TIPSUP, TIPCWS, CODFUN, PERFIL,
   DESSUP, FILEND, NUMEND)
  (SELECT DISTINCT
          CHE.FILCLI, CHE.CODCLI,
           PCODFIL AS CODFIL,
          AGORA() AS DATREG,
          0 AS MODULO,
          '-X-' AS VERSAO,
          'N' AS SITUAC,
          CFG.COB_FIL_GERENTE AS FILRES,
          CFG.COB_COD_GERENTE AS CODRES,
          'S' AS FLGCOB, -- Ver flag
          1 AS CODPRI,
          0 AS TIPSUP,   -- Ver flag
          'A' AS TIPCWS, -- Ver flag
          0 AS CODFUN,
          'C' AS PERFIL,
          'Cobranca de ' || CLI.NOMCLI ||
          case when CLI.FLGTIP='0' then ' ' || CLI.ULTNOM
                                   else ''
          end AS DESSUP,
          (SELECT SUBSTR(MIN(ENDE.CODFIL||ENDE.NUMEND),1,3)
                                 FROM TT_END ENDE
                                WHERE CLI.FILCLI = ENDE.FILCLI
                                  AND CLI.CODCLI = ENDE.CODCLI
								  AND ENDE.ENDCOB = 'T') AS FILEND,
          (SELECT TO_NUMBER(SUBSTR(MIN(ENDE.CODFIL||ENDE.NUMEND),4,10))
                                 FROM TT_END ENDE
                                WHERE CLI.FILCLI = ENDE.FILCLI
                                  AND CLI.CODCLI = ENDE.CODCLI
								  AND ENDE.ENDCOB = 'T') AS NUMEND
    FROM TT_CFG CFG,
         (SELECT DISTINCT FILCLI,CODCLI
            FROM (SELECT CHR.FILCLI,
                         CHR.CODCLI
                   FROM TT_CHR CHR LEFT OUTER JOIN TT_COB COB ON COB.FILCHR = CHR.CODFIL AND COB.SEQCHR = CHR.SEQUEN
                                   LEFT OUTER JOIN TT_SUP SUP ON SUP.CODFIL = COB.FILSUP AND SUP.SEQUEN = COB.SEQSUP
                  WHERE CHR.PAGAME <= add_day(TRUNC(AGORA()),-(SELECT COB_DIAS_DEVOLUCAO1 FROM TT_CFG))
                    AND CHR.FLGEST = 'V' AND COALESCE(CHR.NUMDEP,1) = 1
                    AND (COB.FILCHR IS NULL OR (SUP.SITUAC NOT IN ('A','N')))
                 UNION ALL
                 SELECT CHR.FILCLI, CHR.CODCLI
                  FROM TT_CHR CHR LEFT OUTER JOIN TT_COB COB ON COB.FILCHR = CHR.CODFIL
                                                            AND COB.SEQCHR = CHR.SEQUEN
                                  LEFT OUTER JOIN TT_SUP SUP ON SUP.CODFIL = COB.FILSUP
                                                            AND SUP.SEQUEN = COB.SEQSUP
                 WHERE CHR.PAGAME <= add_day(TRUNC(AGORA()) ,- (SELECT COB_DIAS_DEVOLUCAO2 FROM TT_CFG))
                   AND CHR.FLGEST = 'V' AND COALESCE(CHR.NUMDEP,1) = 2
                   AND (COB.FILCHR IS NULL OR (SUP.SITUAC NOT IN ('A','N')))
                 ) UNI
        ) CHE  LEFT OUTER JOIN TT_SUP OUT ON OUT.FILCLI = CHE.FILCLI
                                         AND OUT.CODCLI = CHE.CODCLI
                                         AND OUT.PERFIL = 'C'
                                         AND OUT.SITUAC in  ('A','N')
               INNER JOIN TT_CLI CLI ON CLI.FILCLI = CHE.FILCLI
                                    AND CLI.CODCLI = CHE.CODCLI
   WHERE OUT.FILCLI IS NULL
    AND (CHE.FILCLI||CHE.CODCLI) <> (CFG.VC_FILCLI||CFG.VC_CODCLI)
    AND CFG.COB_USA_SAC = 'T' ); -- Se nao existe outro suporte para este cliente


  SELECT COUNT(*) INTO i_INS_SUP
    FROM TT_SUP
   WHERE ATU_EM>=vDATA;

  -- Salva o numero da ultima sequencia de TT_COB
  SELECT COALESCE(MAX(SEQUEN),'0') INTO cULTIMA_SEQUEN
    FROM TT_COB
   WHERE CODFIL = pCodFil;


  vDATA:=agora();

  INSERT INTO TT_COB
    (FILCLI, CODCLI, FILREC, SEQREC, NUMPAR, SUBPAR, CODFIL, DATVEN, FILSUP, SEQSUP)
    (SELECT FILCLI, CODCLI, FILREC, SEQREC,
            NUMPAR, SUBPAR, CODFIL, DATVEN,
            SUBSTR(CHVSUP,1,03) AS FILSUP,
            SUBSTR(CHVSUP,4,10) AS SEQSUP
    FROM (SELECT /*+ INDEX(VEN,PK_VEN) */
                   VEN.FILCLI, VEN.CODCLI,
                   REC.DATVEN,
                   REC.CODFIL AS FILREC,
                   REC.SEQUEN AS SEQREC,
                   REC.NUMPAR AS NUMPAR,
                   REC.SUBPAR AS SUBPAR,
                   pCodfil AS CODFIL,
                   (SELECT MAX(CODFIL||SEQUEN)
                      FROM TT_SUP OUT
                     WHERE OUT.FILCLI = VEN.FILCLI
                       AND OUT.CODCLI = VEN.CODCLI
                       AND OUT.PERFIL = 'C'
                       AND OUT.SITUAC IN ('A','N')) AS CHVSUP
              FROM TT_CFG CFG,
                   TT_REC REC INNER JOIN TT_VEN VEN ON REC.CODFIL = VEN.CODFIL
                                                        AND REC.SEQUEN = VEN.SEQUEN
     WHERE CFG.COB_USA_SAC = 'T'
       AND (VEN.FILCLI||VEN.CODCLI) <> (CFG.VC_FILCLI||CFG.VC_CODCLI)
       AND REC.DATVEN <= add_day(TRUNC(AGORA()), - CFG.COB_DIAS_VENCTO)
       AND REC.FLGEST = 'A'
       AND REC.CARTAO IS NULL
       AND REC.SEQCHE IS NULL
       AND NOT EXISTS -- Se esta parcela nao esta em suporte aberto
             (SELECT *
                FROM TT_COB COB INNER JOIN TT_SUP SUP ON SUP.CODFIL = COB.FILSUP
                                                     AND SUP.SEQUEN = COB.SEQSUP
               WHERE SUP.SITUAC IN ('A','N')
                 AND COB.FILREC = REC.CODFIL
                 AND COB.SEQREC = REC.SEQUEN
                 AND COB.NUMPAR = REC.NUMPAR
                 AND COB.SUBPAR = REC.SUBPAR
             )
       ) tab
  where CHVSUP is not null   );

 INSERT INTO TT_COB (FILCLI, CODCLI, FILCHR, SEQCHR, CODFIL, DATVEN, FILSUP, SEQSUP)
 (SELECT FILCLI, CODCLI, FILCHR, SEQCHR, CODFIL, DATVEN,
         SUBSTR(CHVSUP,1,03) AS FILSUP,
         SUBSTR(CHVSUP,4,10) AS SEQSUP
    FROM (SELECT CHR.FILCLI,
                 CHR.CODCLI,
                 CHR.CODFIL AS FILCHR,
                 CHR.SEQUEN AS SEQCHR,
                 CHR.DATVEN,
                 pCodfil AS CODFIL,
                 (SELECT MAX(CODFIL||SEQUEN)
                    FROM TT_SUP OUT
                   WHERE OUT.FILCLI = CHR.FILCLI
                     AND OUT.CODCLI = CHR.CODCLI
                     AND OUT.PERFIL = 'C'
                     AND OUT.SITUAC IN ('A','N')) AS CHVSUP
           FROM TT_CFG CFG,
                TT_CHR CHR
          WHERE CFG.COB_USA_SAC = 'T'
            AND (CHR.FILCLI||CHR.CODCLI) <> (CFG.VC_FILCLI||CFG.VC_CODCLI)
            AND CHR.PAGAME <= add_day(TRUNC(AGORA()), - CFG.COB_DIAS_DEVOLUCAO1 )
            AND CHR.FLGEST = 'V' AND COALESCE(CHR.NUMDEP,1) = 1
            AND NOT EXISTS (SELECT CH2.CODFIL,CH2.SEQUEN
                              FROM TT_CHR CH2 INNER JOIN TT_COB COB ON COB.FILCHR = CH2.CODFIL AND COB.SEQCHR = CH2.SEQUEN
                                              INNER JOIN TT_SUP SUP ON SUP.CODFIL = COB.FILSUP AND SUP.SEQUEN = COB.SEQSUP
                              WHERE SUP.SITUAC IN ('A','N')
                                AND CH2.CODFIL=CHR.CODFIL
                                AND CH2.SEQUEN=CHR.SEQUEN
                           )
         UNION ALL
         SELECT CHR.FILCLI, CHR.CODCLI,
                CHR.CODFIL AS FILCHR,
                CHR.SEQUEN AS SEQCHR,
                CHR.DATVEN,
                pCodfil AS CODFIL,
                (SELECT MAX(CODFIL||SEQUEN)
                   FROM TT_SUP OUT
                  WHERE OUT.FILCLI = CHR.FILCLI
                    AND OUT.CODCLI = CHR.CODCLI
                    AND OUT.PERFIL = 'C'
                    AND OUT.SITUAC IN ('A','N')) AS CHVSUP
          FROM TT_CFG CFG, TT_CHR CHR
         WHERE CFG.COB_USA_SAC = 'T'
           AND (CHR.FILCLI||CHR.CODCLI) <> (CFG.VC_FILCLI||CFG.VC_CODCLI)
           AND CHR.PAGAME <= add_day(TRUNC(AGORA()), - CFG.COB_DIAS_DEVOLUCAO2)
           AND CHR.FLGEST = 'V' AND COALESCE(CHR.NUMDEP,1) = 2
            AND NOT EXISTS (SELECT CH2.CODFIL,CH2.SEQUEN
                              FROM TT_CHR CH2 INNER JOIN TT_COB COB ON COB.FILCHR = CH2.CODFIL AND COB.SEQCHR = CH2.SEQUEN
                                              INNER JOIN TT_SUP SUP ON SUP.CODFIL = COB.FILSUP AND SUP.SEQUEN = COB.SEQSUP
                              WHERE SUP.SITUAC IN ('A','N')
                                AND CH2.CODFIL=CHR.CODFIL
                                AND CH2.SEQUEN=CHR.SEQUEN
                            )
     ) TAB
     where CHVSUP is not null );

  SELECT COUNT(*) INTO i_COBRANCAS
    FROM TT_COB
   WHERE DATOPE>=vDATA;

   vDATA:=AGORA();
   -- Marca os chamados do tipo cobranca como resolvidos se todas as parcelas e cheques estao pagos
   UPDATE TT_SUP
      SET SITUAC = 'R'
    WHERE (CODFIL, SEQUEN) IN
          (SELECT SUP.CODFIL, SUP.SEQUEN
             FROM TT_SUP SUP INNER JOIN TT_COB COB ON COB.FILSUP = SUP.CODFIL
                                                  AND COB.SEQSUP = SUP.SEQUEN
                        LEFT OUTER JOIN TT_REC REC ON REC.CODFIL = COB.FILREC
                                                  AND REC.SEQUEN = COB.SEQREC
                                                  AND REC.NUMPAR = COB.NUMPAR
                                                  AND REC.SUBPAR = COB.SUBPAR
                        LEFT OUTER JOIN TT_CHR CHR ON CHR.CODFIL = REC.FILREC
                                                  AND CHR.SEQUEN = REC.SEQCHE
            WHERE SUP.SITUAC IN ('A','N')
              AND SUP.PERFIL = 'C'
            GROUP BY SUP.CODFIL, SUP.SEQUEN
           HAVING SUM( CASE WHEN COB.FILREC IS NOT NULL THEN
                          CASE WHEN REC.FLGEST = 'A' THEN 1
                                                     ELSE 0
                          END
                       ELSE CASE WHEN CHR.FLGEST = 'V' THEN 1
                                                       ELSE 0
                            END
                       END) = 0
          );

  SELECT COUNT(*) INTO i_RESOLV_SUP
    FROM TT_SUP
   WHERE ATU_EM>=vDATA;


  vDATA:=AGORA();
  -- Marca os chamados como nao lidos, para os que receberam novos lancamentos em TT_COB
  UPDATE TT_SUP
     SET SITUAC = 'N'
   WHERE (CODFIL, SEQUEN) IN
         (SELECT COB.FILSUP, COB.SEQSUP
            FROM TT_COB COB
           WHERE COB.CODFIL = pCodFil
             AND COB.SEQUEN > cULTIMA_SEQUEN );

  SELECT COUNT(*) INTO i_NLIDO_SUP
    FROM TT_SUP
   WHERE ATU_EM>=vDATA;

  SELECT CFG.COB_E_MAIL_SAC, CFG.MAI_FR,
         (SELECT MAX(SEQUEN) FROM TT_COB) INTO cEMAIL,cMAI_FR,cSEQFIN
  FROM TT_CFG CFG;

  IF (ISNOTNULL(cEMAIL)='T') AND (ISNOTNULL(cMAI_FR)='T') AND (INSTR(cMAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(cEMAIL, UPPER('@sua_empresa.com')) = 0) 
      AND (i_INS_SUP+i_NLIDO_SUP+i_RESOLV_SUP+i_COBRANCAS>0) THEN
      INSERT INTO TT_MAI
        (CODFIL,MAI_TO,MAI_FR,ASSUNT,TEXTOS,EXCLUI,TIPMSG,DATSOL) VALUES
        (pCodFil,cEMAIL,cMAI_FR,to_char('Relatrio de novos chamados referentes a cobrana'),
         'Nmero de novo suportes          :'||i_INS_SUP||LF||
         'Nmero de suportes reabertos     :'||i_NLIDO_SUP||LF||
         'Nmero de suportes resolvidos    :'||i_RESOLV_SUP||LF||
         'Nmero de novas cobranas geradas:'||i_COBRANCAS,
         'F',
         'T',
         AGORA()
        );
  END IF;

  RETURN 'OK';

END;
$$ language 'plpgsql';





/*-- SEQ 0959 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GERA_COMISSAO_DIARIA () CASCADE;

/*-- SEQ 0960 --*/
CREATE OR REPLACE FUNCTION GERA_COMISSAO_DIARIA ()
RETURNS VARCHAR AS $$
DECLARE


-- Objetivos:
-- 1. Gerar Comisso diariamente para Todas as Filiais.

-- Declarao de variveis e cursores
    c_RESULTADO   VARCHAR(20);
    v_MANUT       TT_IDF.MANUT%TYPE;
    cFilial       TD_FIL.CODFIL%TYPE;
    cDATINI       VARCHAR(30);
    cDATFIM       VARCHAR(30);

    Filial CURSOR FOR
         SELECT CODFIL
           FROM TD_FIL
       ORDER BY CODFIL;

-- Incio da funo
BEGIN

  SELECT MANUT INTO v_MANUT
    FROM TT_IDF;

  IF v_MANUT = 'T' THEN
    RETURN 'BASE EM MANUTENCAO';
  END IF;

  -- Pega Data do dia anterior para processamento.
  cDATINI := TO_CHAR(TRUNC(ADD_DAY( Agora(),-1)),'DD/MM/YYYY') || ' 00:00:00';
  cDATFIM := TO_CHAR(TRUNC(ADD_DAY( Agora(),-1)),'DD/MM/YYYY') || ' 23:59:59';

  -- Busca o Filiais
  OPEN Filial;
  LOOP
    FETCH Filial INTO cFilial;
    EXIT WHEN NOT FOUND;

    --Chama Funo para incluso da comisso.
        
        c_RESULTADO := CALCULA_COMISSAO( cFilial, cDATINI, cDATFIM );
    
  END LOOP;
  CLOSE Filial;

  c_RESULTADO := 'OK';

  RETURN c_RESULTADO;

END;
$$ language 'plpgsql';



/*-- SEQ 0961 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_GeraComissaoDiaria (TT_JOB.CODUID%TYPE) CASCADE;

/*-- SEQ 0962 --*/
CREATE OR REPLACE FUNCTION Job_GeraComissaoDiaria (TT_JOB.CODUID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODUID ALIAS FOR $1 ;
   vNOME                         TT_JOB.NOMJOB%TYPE;
   vDESC                         TT_JOB.DESJOB%TYPE;
   DUMMY                         CHAR(20);
BEGIN
   vNOME := 'JOB_GERACOMISSAODIARIA';
   vDESC := 'Gerar Comisso do Dia Anterior';
   BEGIN
      --Chama Funo para incluso da comisso.
      DUMMY := GERA_COMISSAO_DIARIA();
      DUMMY := RegistraJob(vNOME, vDESC, NULL, pCODUID);
   EXCEPTION
      WHEN OTHERS THEN DUMMY := RegistraJob(vNOME, vDESC, SQLERRM, pCODUID);
   END;
  RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 0963 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_GeraComissaoDiaria () CASCADE;

/*-- SEQ 0964 --*/
CREATE OR REPLACE FUNCTION Job_GeraComissaoDiaria () 
RETURNS VARCHAR AS $$
BEGIN
RETURN Job_GeraComissaoDiaria(NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 0965 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GetAssinaTab (VARCHAR,TT_UID.CODUID%TYPE,VARCHAR,TT_UID.ASSINA%TYPE,VARCHAR) CASCADE;

/*-- SEQ 0966 --*/
CREATE OR REPLACE FUNCTION GetAssinaTab (VARCHAR,TT_UID.CODUID%TYPE,VARCHAR,TT_UID.ASSINA%TYPE,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pTabela ALIAS FOR $1 ;
pUID_Coduid ALIAS FOR $2 ;
pUID_Texto ALIAS FOR $3 ;
pUID_Assina ALIAS FOR $4 ;
pTexto ALIAS FOR $5 ;

 vRetorno      VARCHAR(256); 
 vComplemento CONSTANT VARCHAR(254):= constante('complemento');
 
BEGIN

  vRetorno := NULL;
   
  BEGIN      
    vRetorno := AssinaTabSessao(pTabela,
                                pUID_Texto,
                                pUID_Assina,
                                pTexto,
                                '',
                                COALESCE('','') );
  EXCEPTION
    WHEN OTHERS THEN RAISE EXCEPTION 'PG-20090 Erro ao acessar rotina de assinatura da registros. %' , vComplemento;      
  END;

  RETURN vRetorno;
END;
$$ language 'plpgsql';




/*-- SEQ 0967 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GravaFluxo () CASCADE;

/*-- SEQ 0968 --*/
CREATE OR REPLACE FUNCTION GravaFluxo ()
RETURNS VARCHAR AS $$
DECLARE

-- Gravar alteracoes feitas em tw_flu para suas tabelas correspondentes

cr_fluxo CURSOR FOR
SELECT datpre, vlrpre, codfil, seqori, numpar, subpar, tabori
  FROM TW_FLU
 where gravar='T'
   and userid=userenv('SESSIONID');

  vDatpre TW_FLU.DATPRE%TYPE;
  vVlrpre TW_FLU.VLRPRE%TYPE;
  vCodfil TW_FLU.CODFIL%TYPE;
  vSeqori TW_FLU.SEQORI%TYPE;
  vNumpar TW_FLU.NUMPAR%TYPE;
  vSubpar TW_FLU.SUBPAR%TYPE;
  vTabori TW_FLU.TABORI%TYPE;

BEGIN

  OPEN cr_fluxo;
  LOOP
    FETCH cr_fluxo INTO vDatpre, vVlrpre, vCodfil, vSeqori, vNumpar, vSubpar, vTabori;
    EXIT WHEN NOT FOUND;
    IF vTABORI='PAG' THEN
       UPDATE TT_PAG SET DATPRE=vDatpre,
                         VLRPRE=vVlrpre
        WHERE CODFIL=vCODFIL
          AND SEQUEN=vSEQORI
          AND NUMPAR=vNUMPAR
          AND SUBPAR=vSUBPAR;
    ELSIF vTABORI='CHR' THEN
       UPDATE TT_CHR SET DATPRE=vDatpre,
                         VLRPRE=vVlrpre
        WHERE CODFIL=vCODFIL
          AND SEQUEN=vSEQORI;
    ELSIF vTABORI='REC' THEN
       UPDATE TT_REC SET DATPRE=vDatpre,
                         VLRPRE=vVlrpre
        WHERE CODFIL=vCODFIL
          AND SEQUEN=vSEQORI
          AND NUMPAR=vNUMPAR
          AND SUBPAR=vSUBPAR;
    END IF;
  END LOOP;

  RETURN 'OK';

END;
$$ language 'plpgsql';




/*-- SEQ 0969 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GravaVinculos (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE) CASCADE;

/*-- SEQ 0970 --*/
CREATE OR REPLACE FUNCTION GravaVinculos (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_filcli ALIAS FOR $1 ;
p_codcli ALIAS FOR $2 ;
 JaInclusos  VARCHAR(4000);
 Tem Numeric(1);
 r_filcli TT_CLI.FILCLI%TYPE;
 r_codcli TT_CLI.CODCLI%TYPE;
 r_numdoc TT_CLI.NUMDOC%TYPE;
 r_filvin TT_CLI.FILCLI%TYPE;
 r_codvin TT_CLI.CODCLI%TYPE;
 c_dummy VARCHAR(15);
BEGIN
 Tem := 1;
 JaInclusos := ';';
 r_filcli := p_filcli;
 r_codcli := p_codcli;

 while (Tem = 1) loop
   select filvin, codvin, numdoc into r_filvin, r_codvin, r_numdoc
   from tt_cli
   where filcli = r_filcli
    and codcli = r_codcli;
   if (r_filvin is not null) then
    if (InStr( JaInclusos, r_filvin || r_codvin ) = 0) then
      JaInclusos := JaInclusos || r_filvin || r_codvin || ';' ;
      r_filcli := r_filvin;
      r_codcli := r_codvin;
    else
      Tem := 0;
    end if;
   else
    Tem := 0;
   end if;
 End Loop;
 DELETE FROM TW_VRES WHERE USERID = USERENV( 'SESSIONID' );
 if r_numdoc is not null then
   INSERT INTO TW_VRES (USERID, NUMDOC, TIPREG) VALUES (USERENV( 'SESSIONID' ), r_numdoc, 'M');
 end if;
  c_dummy := GravaVinculosAux( r_filcli, r_codcli, p_filcli, p_codcli ); 

  RETURN r_filcli||r_codcli; 
END;
$$ language 'plpgsql';




/*-- SEQ 0971 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION HorasCobradasProjeto (TT_PRJ.CODFIL%TYPE,TT_PRJ.SEQUEN%TYPE) CASCADE;

/*-- SEQ 0972 --*/
CREATE OR REPLACE FUNCTION HorasCobradasProjeto (TT_PRJ.CODFIL%TYPE,TT_PRJ.SEQUEN%TYPE)
RETURNS Numeric AS $$
DECLARE
pCodfil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
-- Objetivo
-- 1) Retornar as horas contratadas do projeto
  nCOBRAR TT_PRJ.COBRAR%TYPE;
  Lista CURSOR FOR
    -- Ver detalhes sobre a macro em
-- \\tt2000\Docs\desenv\depto\Manuais\Ansi\connectby.mac
SELECT COBRAR
FROM connectby_back('(select to_char(chvprj) as filho,
                             to_char(chvpai) as pai
                   from tt_prj int) tab', 'filho', 'pai', to_char(pCodfil||pSequen))
AS c (conn_codigo VARCHAR, conn_codpai VARCHAR, level int, ordem int)
INNER JOIN tt_prj t ON c.conn_codigo  = (chvprj)
order by ordem;
-- Principal
begin
  OPEN Lista;
  LOOP
     FETCH Lista INTO nCOBRAR;
     EXIT WHEN (NOT FOUND) or (NCOBRAR>0);
  END LOOP;
  Close Lista;
  RETURN NCOBRAR;
END;
$$ language 'plpgsql';




/*-- SEQ 0973 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IIF_INT (boolean,integer,integer) CASCADE;

/*-- SEQ 0974 --*/
CREATE OR REPLACE FUNCTION IIF_INT (boolean,integer,integer)
RETURNS Integer AS $$
DECLARE
pBooCondicao ALIAS FOR $1 ;
pExp1 ALIAS FOR $2 ;
pExp2 ALIAS FOR $3 ;
BEGIN
  IF pBooCondicao THEN
     RETURN pExp1;
  ELSE
     RETURN pExp2;
  END IF;
END;
$$ language 'plpgsql';




/*-- SEQ 0975 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION getColunasIndices (VARCHAR) CASCADE;

/*-- SEQ 0976 --*/
CREATE OR REPLACE FUNCTION getColunasIndices (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pIndex_Name ALIAS FOR $1 ;
  RESULTADO VARCHAR(4000);
  vColuna   VARCHAR(50);
  ColsIndexes CURSOR FOR
    SELECT COLUMN_NAME 
      FROM ALL_IND_COLUMNS
     WHERE INDEX_NAME like pIndex_Name  
       AND INDEX_OWNER LIKE QUALDONO()
     ORDER BY COLUMN_POSITION;
BEGIN  
  RESULTADO:='';  
  OPEN ColsIndexes;
  LOOP
    FETCH ColsIndexes INTO vColuna;
    EXIT WHEN NOT FOUND;
    IF ISNULL(RESULTADO)='T' THEN
       RESULTADO:=vColuna;
    ELSE
       RESULTADO:=RESULTADO||','||vColuna;
    END IF;
  END LOOP;
  CLOSE ColsIndexes;

  RETURN RESULTADO;

END;
$$ language 'plpgsql';




/*-- SEQ 0977 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION INSERE_LFIN_CLI (TL_FIN.ORIGEM%TYPE,TL_FIN.FILORI%TYPE,TL_FIN.SEQORI%TYPE,TL_FIN.FILCLI%TYPE,TL_FIN.CODCLI%TYPE) CASCADE;

/*-- SEQ 0978 --*/
CREATE OR REPLACE FUNCTION INSERE_LFIN_CLI (TL_FIN.ORIGEM%TYPE,TL_FIN.FILORI%TYPE,TL_FIN.SEQORI%TYPE,TL_FIN.FILCLI%TYPE,TL_FIN.CODCLI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pORIGEM ALIAS FOR $1 ;
pFILORI ALIAS FOR $2 ;
pSEQORI ALIAS FOR $3 ;
pFILCLI ALIAS FOR $4 ;
pCODCLI ALIAS FOR $5 ;
  nREG INTEGER;
BEGIN
    
    IF pFILCLI IS NULL THEN 
       RAISE EXCEPTION 'PG-20000 Obrigatorio informar codigo do cliente.';
    END IF;

    SELECT COUNT(*) INTO nREG
      FROM TL_FIN
     WHERE FILORI=pFILORI
       AND SEQORI=pSEQORI
       AND PARORI='--'
       AND SUBORI='--'
       AND ORIGEM=pORIGEM
       AND FILCLI IS NOT NULL;

    IF nREG=0 THEN
       INSERT INTO TL_FIN 
         (ORIGEM, FILORI, SEQORI, PARORI, SUBORI, FILCLI, CODCLI, DATINC) VALUES 
         (pORIGEM, pFILORI, pSEQORI, '--', '--', pFILCLI, pCODCLI, agora());
    ELSIF nREG>0 THEN
       UPDATE TL_FIN 
          SET FILCLI=pFILCLI,
              CODCLI=pCODCLI,
              FLGEST='N'
         WHERE ORIGEM=pORIGEM
           AND FILORI=pFILORI
           AND SEQORI=pSEQORI
           and PARORI='--'
           AND SUBORI='--';       
    END IF;
    
    RETURN 'OK';     
    
END;
$$ language 'plpgsql';




/*-- SEQ 0979 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION INSERE_LFIN_DOM (TL_FIN.FILCTA%TYPE,TL_FIN.SEQCTA%TYPE,TL_FIN.TIPCTA%TYPE,TL_FIN.CODTAB%TYPE,TL_FIN.DESTIN%TYPE) CASCADE;

/*-- SEQ 0980 --*/
CREATE OR REPLACE FUNCTION INSERE_LFIN_DOM (TL_FIN.FILCTA%TYPE,TL_FIN.SEQCTA%TYPE,TL_FIN.TIPCTA%TYPE,TL_FIN.CODTAB%TYPE,TL_FIN.DESTIN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILCTA ALIAS FOR $1 ;
pSEQCTA ALIAS FOR $2 ;
pTIPCTA ALIAS FOR $3 ;
pCODTAB ALIAS FOR $4 ;
pDESTIN ALIAS FOR $5 ;
  nREG INTEGER;
BEGIN
    
    SELECT COUNT(*) INTO nREG
      FROM TL_FIN
     WHERE CODTAB=pCODTAB
       AND DESTIN=pDESTIN
       AND ORIGEM IS NULL;

    IF nREG=0 THEN
       INSERT INTO TL_FIN 
         (DESTIN, CODTAB, FILCTA, SEQCTA, TIPCTA, DATINC) VALUES 
         (pDESTIN, pCODTAB, pFILCTA, pSEQCTA, pTIPCTA, agora());
    ELSIF nREG>0 THEN
       UPDATE TL_FIN 
          SET FILCTA=pFILCTA,
              SEQCTA=pSEQCTA,
              TIPCTA=pTIPCTA,
              FLGEST='N'
         WHERE ORIGEM IS NULL
           AND CODTAB=pCODTAB
           AND DESTIN=pDESTIN;
    END IF;
         
END;
$$ language 'plpgsql';




/*-- SEQ 0981 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION INSERE_LFIN_LAN (TL_FIN.ORIGEM%TYPE,TL_FIN.FILORI%TYPE,TL_FIN.SEQORI%TYPE,TL_FIN.PARORI%TYPE,TL_FIN.SUBORI%TYPE) CASCADE;

/*-- SEQ 0982 --*/
CREATE OR REPLACE FUNCTION INSERE_LFIN_LAN (TL_FIN.ORIGEM%TYPE,TL_FIN.FILORI%TYPE,TL_FIN.SEQORI%TYPE,TL_FIN.PARORI%TYPE,TL_FIN.SUBORI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pORIGEM ALIAS FOR $1 ;
pFILORI ALIAS FOR $2 ;
pSEQORI ALIAS FOR $3 ;
pPARORI ALIAS FOR $4 ;
pSUBORI ALIAS FOR $5 ;
  nREG INTEGER;
BEGIN

    INSERT INTO TL_FIN 
         (ORIGEM, FILORI, SEQORI, PARORI, SUBORI, DATINC) VALUES 
         (pORIGEM, pFILORI, pSEQORI, pPARORI, pSUBORI, agora());

    IF pORIGEM='DOP' THEN
       INSERT INTO TL_FIN 
         (ORIGEM, FILORI, SEQORI, PARORI, SUBORI, DATINC) 
         (SELECT 'PAG', PAG.CODFIL, PAG.SEQUEN, PAG.NUMPAR, PAG.SUBPAR, agora() AS DATINC
           FROM TT_PAG PAG LEFT JOIN TL_FIN FIN ON FIN.ORIGEM='PAG' AND FIN.FILORI=PAG.CODFIL AND FIN.SEQORI=PAG.SEQUEN AND FIN.PARORI=PAG.NUMPAR AND FIN.SUBORI=PAG.SUBPAR
          WHERE FIN.ORIGEM IS NULL
            AND PAG.FILDOP=pFILORI
            AND PAG.SEQDOP=pSEQORI);
    END IF;
    
    RETURN 'OK';     
    
END;
$$ language 'plpgsql';




/*-- SEQ 0983 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION INSERE_MEDICAO (Timestamp,Timestamp) CASCADE;

/*-- SEQ 0984 --*/
CREATE OR REPLACE FUNCTION INSERE_MEDICAO (Timestamp,Timestamp)
RETURNS VARCHAR AS $$
DECLARE
PDATINI ALIAS FOR $1 ;
pDATFIM ALIAS FOR $2 ;
BEGIN
INSERT INTO TT_MDT (CODFIL,NUMTAN,DATMED,FILLEI,CODLEI,DATLEI,FILREG,CODREG,DATREG,ATU_EM,QTDLTS)
(SELECT TAN.FILTAN AS CODFIL,
        TAN.TANQUE AS NUMTAN,
        DAT.DATOPE AS DATMED,
        USU.FILUSU AS FILLEI,
        USU.CODUSU AS CODLEI,
        TO_DATE(TO_CHAR(DAT.DATOPE,'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS') AS DATLEI,
        USU.FILUSU AS FILLEI,
        USU.CODUSU AS CODLEI,
        AGORA() AS DATREG,
        AGORA() AS ATU_EM,
        0 AS QTDLIS
   FROM TD_TAN TAN CROSS JOIN TT_DAT DAT
                   CROSS JOIN TT_USU USU
                   LEFT  JOIN TT_MDT MDT ON MDT.CODFIL=TAN.FILTAN AND MDT.NUMTAN=TAN.TANQUE AND MDT.DATMED=DAT.DATOPE
  WHERE USU.APEUSU=QUALDONO()
    AND DAT.DATOPE BETWEEN pDATINI AND 
                           PDATFIM 
    AND MDT.DATMED IS NULL
);    

INSERT INTO TT_FCP
(CODFIL,FILMED,TANMED,DATMED,CODBIC,FILLEI,CODLEI,FILREG,CODREG,DATREG,DATFEC,ATU_EM,VLRENC,ORIGEM)
(select *
from (
SELECT MDT.CODFIL AS CODFIL,
        MDT.CODFIL AS FILMED,
        MDT.NUMTAN AS TANMED,
        MDT.DATMED AS DATMED,
        BIC.CODTAB AS CODBIC,
        MDT.FILLEI AS FILLEI,
        MDT.CODLEI AS CODLEI,
        MDT.FILREG AS FILREG,
        MDT.CODREG AS CODREG,
        MDT.DATREG AS DATREG,
        TO_DATE(TO_CHAR(MDT.DATMED,'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS') AS DATFEC,             
        AGORA() AS ATU_EM,
        aux_insere_medicao(bic.filbic,bic.seqfil,bic.codtab,mdt.datmed) as vlrenc,
        to_char('B') as origem
   FROM TT_MDT MDT INNER JOIN TD_TAN TAN ON MDT.NUMTAN=TAN.TANQUE
                   INNER JOIN TD_BIC BIC ON BIC.CODTAN=TAN.CODTAB
                   LEFT  JOIN TT_FCP FCP ON FCP.FILMED=MDT.CODFIL AND FCP.TANMED=MDT.NUMTAN AND FCP.DATMED=MDT.DATMED AND FCP.CODBIC=BIC.CODTAB
  WHERE FCP.CODFIL IS NULL
    AND MDT.DATMED BETWEEN pDATINI AND 
                           PDATFIM 
) tab
where vlrenc is not null
);

  RETURN 'OK';   

END;
$$ language 'plpgsql';

                    


/*-- SEQ 0985 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION INSERE_MIFC (TM_IFC.ORIGEM%TYPE,TM_IFC.REGIST%TYPE,TM_IFC.FLGEST%TYPE) CASCADE;

/*-- SEQ 0986 --*/
CREATE OR REPLACE FUNCTION INSERE_MIFC (TM_IFC.ORIGEM%TYPE,TM_IFC.REGIST%TYPE,TM_IFC.FLGEST%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_ORIGEM ALIAS FOR $1 ;
p_REGIST ALIAS FOR $2 ;
p_FLGEST ALIAS FOR $3 ;  
-- Objetivo
-- 1) Registrar Pendências para Atualizar os Impostos de Fornecedores Calculados                 
    nUSERID TM_IFC.USERID%TYPE;
BEGIN
    nUSERID := USERENV( 'SESSIONID' );
    
    INSERT INTO TM_IFC 
        (ORIGEM, REGIST, FLGEST, USERID) VALUES
        (p_ORIGEM, p_REGIST, p_FLGEST, nUSERID);

    RETURN 'OK';     
    
END;
$$ language 'plpgsql';


/*-- SEQ 0987 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION INSERE_MIFC (TM_IFC.ORIGEM%TYPE,TM_IFC.REGIST%TYPE) CASCADE;

/*-- SEQ 0988 --*/
CREATE OR REPLACE FUNCTION INSERE_MIFC (TM_IFC.ORIGEM%TYPE,
                               TM_IFC.REGIST%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN INSERE_MIFC($1,$2,'N');
END;
$$ language 'plpgsql';


/*-- SEQ 0989 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION INSERE_MTIT (TM_TIT.CODFIL%TYPE,TM_TIT.SEQUEN%TYPE,TM_TIT.NUMPAR%TYPE,TM_TIT.FLGEST%TYPE) CASCADE;

/*-- SEQ 0990 --*/
CREATE OR REPLACE FUNCTION INSERE_MTIT (TM_TIT.CODFIL%TYPE,TM_TIT.SEQUEN%TYPE,TM_TIT.NUMPAR%TYPE,TM_TIT.FLGEST%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pNUMPAR ALIAS FOR $3 ;
pFLGEST ALIAS FOR $4 ;
  nREG INTEGER;
BEGIN

    SELECT COUNT(*) INTO nREG
      FROM TM_TIT
     WHERE CODFIL=pCODFIL
       AND SEQUEN=pSEQUEN
       AND NUMPAR=pNUMPAR;

    IF nREG=0 THEN
       INSERT INTO TM_TIT
         (CODFIL,SEQUEN,NUMPAR,DATINC) VALUES 
         (pCODFIL,pSEQUEN,pNUMPAR,AGORA());
    END IF;
    
    RETURN 'OK';
    
END;
$$ language 'plpgsql';




/*-- SEQ 0991 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IsDigit (VARCHAR) CASCADE;

/*-- SEQ 0992 --*/
CREATE OR REPLACE FUNCTION IsDigit (VARCHAR)
RETURNS Numeric AS $$
DECLARE
Dado ALIAS FOR $1 ;
  i      Numeric;
  Digito Numeric(1);
begin

  IF ISNULL(DADO)='T' THEN
    Digito := -1;
  ELSE
    Digito := 1;

    FOR i IN 1..LENGTH(Dado) LOOP
      IF SUBSTR(Dado,i,1) not in ('0','1','2','3','4','5','6','7','8','9') THEN
        Digito := 0;
      END IF;

      EXIT WHEN Digito = 0;
    END LOOP;  

  END IF;

  RETURN Digito;
END;
$$ language 'plpgsql';




/*-- SEQ 0993 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Atraso (Numeric,VARCHAR,Numeric,Numeric) CASCADE;

/*-- SEQ 0994 --*/
CREATE OR REPLACE FUNCTION Atraso (Numeric,VARCHAR,Numeric,Numeric)
RETURNS Numeric AS $$
DECLARE
Periodo ALIAS FOR $1 ;
INTPJU ALIAS FOR $2 ;
VLRLAN ALIAS FOR $3 ;
VLTXJU ALIAS FOR $4 ;
  JUROS   Numeric;
BEGIN
-- Objetivo:
-- 1) Calcular juros

  IF INTPJU in  ('0', 'S') THEN
    -- JUROS Simples
    JUROS := VLRLAN + (VLRLAN * VLTXJU * PERIODO / 100);
  ELSIF INTPJU in ('1', 'C') THEN
    -- JUROS Compostos
    JUROS := VLRLAN * Power((1 + VLTXJU / 100) , PERIODO);
  ELSIF INTPJU =  'F'  THEN
    -- Taxa Fixa
    JUROS := VLRLAN + (PERIODO * VLTXJU);
  ELSE
    -- Erro no tipo de juros do documento!
    JUROS := 0;
  END IF;

  RETURN JUROS;

END;
$$ language 'plpgsql';





/*-- SEQ 0995 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CARGAPERSONALIZADO () CASCADE;

/*-- SEQ 0996 --*/
CREATE OR REPLACE FUNCTION CARGAPERSONALIZADO ()
RETURNS VARCHAR AS $$
DECLARE

-- Objetivo:
-- 1) Registrar na tabela do Totall BI (TT_LAY) uma linha em TT_LAY para cada registro de TD_CRT

-- Principal
BEGIN

DELETE FROM TT_DOM WHERE CODARQ IN ('VCRP','VCRG','VCRC','VCRE');

DELETE FROM TT_LAY WHERE CODTAB IN ('VCRP','VCRG','VCRC','VCRE');

DELETE FROM TT_GRU WHERE CODTAB IN ('VCRP','VCRG','VCRC','VCRE');

DELETE FROM TT_ARQ WHERE CODTAB IN ('VCRP','VCRG','VCRC','VCRE');

DELETE FROM TT_SQL WHERE CODORI IN ('VCRP','VCRG','VCRC','VCRE');

INSERT INTO tt_arq
(codtab,codfis,formul,geral,nomtab,apelid,path,unico,paleta,secun1,secun2,descri,primar,filbas,id_uni,observ,parame,subsql,person,expnet)
VALUES
('VCRC', 'VCRC', 'T', 'T', 'Caracterizao x Cli', 'TOTALL', 'TV_CRTXCLI', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F', 'F');

INSERT INTO tt_arq
(codtab,codfis,formul,geral,nomtab,apelid,path,unico,paleta,secun1,secun2,descri,primar,filbas,id_uni,observ,parame,subsql,person,expnet)
VALUES
('VCRE', 'VCRE', 'T', 'T', 'Caracterizao End.', 'TOTALL', 'TV_CRTXEND', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F', 'F');

INSERT INTO tt_arq
(codtab,codfis,formul,geral,nomtab,apelid,path,unico,paleta,secun1,secun2,descri,primar,filbas,id_uni,observ,parame,subsql,person,expnet)
VALUES
('VCRP', 'VCRP', 'T', 'T', 'Caracterizao Prod.', 'TOTALL', 'TV_CRTXPRO', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F', 'F');

INSERT INTO tt_arq
(codtab,codfis,formul,geral,nomtab,apelid,path,unico,paleta,secun1,secun2,descri,primar,filbas,id_uni,observ,parame,subsql,person,expnet)
VALUES
('VCRG', 'VCRG', 'T', 'T', 'Caracterizao Grade', 'TOTALL', 'TV_CRTXGRA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'F', 'F');

INSERT INTO tt_gru
(CODTAB,CODGRU,DESGRU) VALUES
('VCRP','01','Identificao');

INSERT INTO tt_gru
(CODTAB,CODGRU,DESGRU) VALUES
('VCRG','01','Identificao');

INSERT INTO tt_gru
(CODTAB,CODGRU,DESGRU) VALUES
('VCRC','01','Identificao');

INSERT INTO tt_gru
(CODTAB,CODGRU,DESGRU) VALUES
('VCRE','01','Identificao');

INSERT INTO tt_lay
(codtab,codgru,sequen,tamcpo,tipcpo,nomcpo,expres,arqlis,origem,codigo,numdec,numdom,oldseq,netdat,oujoin,tipdad,tipfil,totalizado,velho ,nomusu,descpo,clafil,usocpo,codlis,deslis)
VALUES ('VCRP', '01', 10.00, 3.00, 'A', 'FILMAT', 'FILMAT', NULL, NULL, NULL, 0.00, NULL, NULL, 'F', 'F', 'N', 'I', NULL, NULL, 'Filial Material', 'Filial Material', NULL, NULL, NULL, NULL);

INSERT INTO tt_lay
(codtab,codgru,sequen,tamcpo,tipcpo,nomcpo,expres,arqlis,origem,codigo,numdec,numdom,oldseq,netdat,oujoin,tipdad,tipfil,totalizado,velho ,nomusu,descpo,clafil,usocpo,codlis,deslis)
VALUES ('VCRP', '01', 20.00, 5.00, 'A', 'CODMAT', 'CODMAT', NULL, NULL, NULL, 0.00, NULL, NULL, 'F', 'F', 'A', 'A', NULL, NULL, 'Cdigo Material', 'Cdigo Material', NULL, NULL, NULL, NULL);

INSERT INTO tt_lay
(codtab,codgru,sequen,tamcpo,tipcpo,nomcpo,expres,arqlis,origem,codigo,numdec,numdom,oldseq,netdat,oujoin,tipdad,tipfil,totalizado,velho ,nomusu,descpo,clafil,usocpo,codlis,deslis)
VALUES ('VCRG', '01', 10.00, 3.00, 'A', 'FILMAT', 'FILMAT', NULL, NULL, NULL, 0.00, NULL, NULL, 'F', 'F', 'N', 'I', NULL, NULL, 'Filial Material', 'Filial Material', NULL, NULL, NULL, NULL);

INSERT INTO tt_lay
(codtab,codgru,sequen,tamcpo,tipcpo,nomcpo,expres,arqlis,origem,codigo,numdec,numdom,oldseq,netdat,oujoin,tipdad,tipfil,totalizado,velho ,nomusu,descpo,clafil,usocpo,codlis,deslis)
VALUES ('VCRG', '01', 20.00, 5.00, 'A', 'CODMAT', 'CODMAT', NULL, NULL, NULL, 0.00, NULL, NULL, 'F', 'F', 'A', 'A', NULL, NULL, 'Cdigo Material', 'Cdigo Material', NULL, NULL, NULL, NULL);

INSERT INTO tt_lay
(codtab,codgru,sequen,tamcpo,tipcpo,nomcpo,expres,arqlis,origem,codigo,numdec,numdom,oldseq,netdat,oujoin,tipdad,tipfil,totalizado,velho ,nomusu,descpo,clafil,usocpo,codlis,deslis)
VALUES ('VCRG', '01', 30.00, 5.00, 'S', 'CODCOR', 'CODCOR', 'DIV ', NULL, NULL, 0.00, NULL, NULL, 'F', 'T', 'N', 'V', 'F', NULL, 'Diviso', 'Diviso do produto', NULL, NULL, 'DIV.CODITE (+) = VCRG.CODCOR', 'DIV.NOMITE');

INSERT INTO tt_lay
(codtab,codgru,sequen,tamcpo,tipcpo,nomcpo,expres,arqlis,origem,codigo,numdec,numdom,oldseq,netdat,oujoin,tipdad,tipfil,totalizado,velho ,nomusu,descpo,clafil,usocpo,codlis,deslis)
VALUES ('VCRG', '01', 40.00, 5.00, 'S', 'CODTAM', 'CODTAM', 'SUB ', NULL, NULL, 0.00, NULL, NULL, 'F', 'T', 'N', 'V', 'F', NULL, 'Sub-Diviso', 'Sub-Diviso do produto', NULL, NULL, 'SUB.CODITE (+) = VCRG.CODTAM', 'SUB.NOMITE');

INSERT INTO tt_lay
(codtab,codgru,sequen,tamcpo,tipcpo,nomcpo,expres,arqlis,origem,codigo,numdec,numdom,oldseq,netdat,oujoin,tipdad,tipfil,totalizado,velho ,nomusu,descpo,clafil,usocpo,codlis,deslis)
VALUES ('VCRC', '01', 10.00, 3.00, 'A', 'FILCLI', 'FILCLI', NULL, NULL, NULL, 0.00, NULL, NULL, 'F', 'F', 'N', 'I', NULL, NULL, 'Filial Cliente', 'Filial Cliente', NULL, NULL, NULL, NULL);

INSERT INTO tt_lay
(codtab,codgru,sequen,tamcpo,tipcpo,nomcpo,expres,arqlis,origem,codigo,numdec,numdom,oldseq,netdat,oujoin,tipdad,tipfil,totalizado,velho ,nomusu,descpo,clafil,usocpo,codlis,deslis)
VALUES ('VCRC', '01', 20.00, 6.00, 'A', 'CODCLI', 'CODCLI', NULL, NULL, NULL, 0.00, NULL, NULL, 'F', 'F', '9', 'I', NULL, NULL, 'Cdigo do Cliente', 'Cdigo do Cliente', NULL, NULL, NULL, NULL);

INSERT INTO tt_lay
(codtab,codgru,sequen,tamcpo,tipcpo,nomcpo,expres,arqlis,origem,codigo,numdec,numdom,oldseq,netdat,oujoin,tipdad,tipfil,totalizado,velho ,nomusu,descpo,clafil,usocpo,codlis,deslis)
VALUES ('VCRE', '01', 10.00, 3.00, 'A', 'FILCLI', 'FILCLI', NULL, NULL, NULL, 0.00, NULL, NULL, 'F', 'F', 'N', 'I', NULL, NULL, 'Filial Cliente', 'Filial Cliente', NULL, NULL, NULL, NULL);

INSERT INTO tt_lay
(codtab,codgru,sequen,tamcpo,tipcpo,nomcpo,expres,arqlis,origem,codigo,numdec,numdom,oldseq,netdat,oujoin,tipdad,tipfil,totalizado,velho ,nomusu,descpo,clafil,usocpo,codlis,deslis)
VALUES ('VCRE', '01', 20.00, 6.00, 'A', 'CODCLI', 'CODCLI', NULL, NULL, NULL, 0.00, NULL, NULL, 'F', 'F', '9', 'I', NULL, NULL, 'Cdigo do Cliente', 'Cdigo do Cliente', NULL, NULL, NULL, NULL);

INSERT INTO tt_lay
(codtab,codgru,sequen,tamcpo,tipcpo,nomcpo,expres,arqlis,origem,codigo,numdec,numdom,oldseq,netdat,oujoin,tipdad,tipfil,totalizado,velho ,nomusu,descpo,clafil,usocpo,codlis,deslis)
VALUES ('VCRE', '01', 30.00, 3.00, 'A', 'FILEND', 'FILEND', NULL, NULL, NULL, 0.00, NULL, NULL, 'F', 'F', 'A', 'A', NULL, NULL, 'Filial Endereo', 'Filial Endereo', NULL, NULL, NULL, NULL);

INSERT INTO tt_lay
(codtab,codgru,sequen,tamcpo,tipcpo,nomcpo,expres,arqlis,origem,codigo,numdec,numdom,oldseq,netdat,oujoin,tipdad,tipfil,totalizado,velho ,nomusu,descpo,clafil,usocpo,codlis,deslis)
VALUES ('VCRE', '01', 40.00, 4.00, 'S', 'NUMEND', 'NUMEND', NULL, NULL, NULL, 0.00, NULL, NULL, 'F', 'F', NULL, 'I', NULL, NULL, 'Nmero Endereo', 'Nmero Endereo', NULL, NULL, NULL, NULL);

-- Criando Grupos
INSERT INTO tt_gru
(CODTAB,CODGRU,DESGRU)
(SELECT 'VCR'||DET.USODET AS CODTAB,
        DET.CODTAB,
        SUBSTR(DET.desdet,1,72) AS DESDET
   FROM td_crt CRT INNER JOIN TD_DET DET ON CRT.CODDET=DET.CODTAB
  WHERE DET.USODET IN ('P','G','C','E')
  GROUP BY DET.USODET,DET.CODTAB,DET.desdet);

ALTER SEQUENCE SQLAY1 RESTART WITH 1;
ALTER SEQUENCE SQLAY2 RESTART WITH 1;

-- Criando registros em TT_LAY
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,DESCPO,EXPRES,NETDAT,NOMCPO,NOMUSU,NUMDEC,OUJOIN,TAMCPO,TIPCPO,TIPDAD,TIPFIL,TOTALIZADO,ARQLIS,CODLIS,DESLIS,NUMDOM)
(SELECT 'VCR'||DET.USODET AS CODTAB,
        DET.CODTAB AS CODGRU,
        NEXTVAL('SQLAY1')*100 AS SEQUEN,
        descrt AS DESCPO,
        CASE TIPCRT WHEN 'D' THEN 'VALORCRT_DATA'
                    WHEN 'N' THEN 'VALORCRT_NUMBER'
                                        ELSE 'VALORCRT_STRING'
        END || '(' ||
        CHR(39) || CRT.USODET ||CHR(39) || ',' ||
        CRT.CODTAB || ',' ||
        CASE CRT.USODET WHEN 'P' THEN 'VCRP.FILMAT,VCRP.CODMAT'
                        WHEN 'G' THEN 'VCRG.FILMAT,VCRG.CODMAT,to_char(VCRG.CODCOR),to_char(VCRG.CODTAM)'
                        WHEN 'C' THEN 'VCRC.FILCLI,VCRC.CODCLI'
                        WHEN 'E' THEN 'VCRE.FILCLI,VCRE.CODCLI,VCRE.FILEND,to_char(VCRE.NUMEND)'
        END || ')' AS EXPRES,
        'T' AS NETDAT,
        'CAMPO'||CRT.CODTAB AS NOMCPO,
        SUBSTR(crt.descrt,1,20) AS NOMUSU,
        crt.deccrt AS NUMDEC,
        CASE TIPCRT WHEN 'C' THEN 'T'
                             ELSE 'F'
        END AS OUJOIN,
        CASE TIPCRT WHEN 'N' THEN 14
                    WHEN 'D' THEN 8
                    ELSE 254
        END AS TAMCPO,
        CASE TIPCRT WHEN 'D' THEN '@'
                    WHEN 'N' THEN 'F'
                    WHEN 'L' THEN 'L'
                    ELSE 'A'
        END AS TIPCPO,
        CASE TIPCRT WHEN 'D' THEN '@'
                    WHEN 'N' THEN 'N'
                    ELSE 'A'
        END AS TIPDAD,
        CASE TIPCRT WHEN 'D' THEN 'I'
                    WHEN 'N' THEN 'I'
                    WHEN 'L' THEN 'Y'
                    WHEN 'C' THEN 'D'
                    ELSE 'A'
        END AS TIPFIL,
        CASE TIPCRT WHEN 'N' THEN 'T'
                             ELSE 'F'
        END AS TOTALIZADO,
        TO_CHAR(NULL) AS ARQLIS,
        TO_CHAR(NULL) AS CODLIS,
        TO_CHAR(NULL) AS DESLIS,
        CASE TIPCRT WHEN 'C' THEN 254
        END AS NUMDOM
   FROM td_crt CRT INNER JOIN TD_DET DET ON CRT.CODDET=DET.CODTAB
  WHERE DET.USODET IN ('P','G','C','E')
);

INSERT INTO TT_DOM
(CODARQ,NOMCPO,DESDOM,SEQUEN,CODSTR,CODINT,CODCHR)
(
SELECT 'VCR'||CRT.USODET,
       'CAMPO'||CRT.CODTAB,
       LCR.DESLES,
       LCR.ORDLIS*10,
       LCR.DESLES,
       0 AS CODINT,
       ' ' AS CODCHR
  FROM TD_LCR LCR INNER JOIN TD_CRT CRT ON LCR.CODCRT=CRT.CODTAB
 WHERE CRT.USODET IN ('P','G','C','E')
);

INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 58192,
       'PRO ',
       'VCRP',
       '1 ',
       '1 ',
       '',
       '',
       'VCRP.FILMAT = PRO.FILMAT and
VCRP.CODMAT = PRO.CODMAT ',
       '',
       '' FROM DUAL
);

INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 58193,
       'GRA ',
       'VCRG',
       '1 ',
       '1 ',
       '',
       '',
       'GRA.FILMAT = VCRG.FILMAT and
GRA.CODMAT = VCRG.CODMAT and
GRA.CODCOR = VCRG.CODCOR and
GRA.CODTAM = VCRG.CODTAM',
       '',
       '' FROM DUAL
);


INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 58194,
       'CLI ',
       'VCRC',
       '1 ',
       '1 ',
       '',
       '',
       'VCRC.FILCLI = CLI.FILCLI and
VCRC.CODCLI = CLI.CODCLI ',
       '',
       '' FROM DUAL
);

INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 58195,
       'EDE ',
       'VCRE',
       '1 ',
       '1 ',
       '',
       '',
       'EDE.FILCLI = VCRE.FILCLI AND
EDE.CODCLI = VCRE.CODCLI AND
EDE.CODFIL = VCRE.FILEND AND
EDE.NUMEND = VCRE.NUMEND',
       '',
       '' FROM DUAL
);


UPDATE TT_IDF SET VERMET=TRUNC(VERMET)+MOD(VERMET+0.01,1);

RETURN 'OK';

END;
$$ language 'plpgsql';




/*-- SEQ 0997 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION LCF_MSGERR (TT_MAI.CODFIL%TYPE,TT_MAI.SEQUEN%TYPE,VARCHAR) CASCADE;

/*-- SEQ 0998 --*/
CREATE OR REPLACE FUNCTION LCF_MSGERR (TT_MAI.CODFIL%TYPE,TT_MAI.SEQUEN%TYPE,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pCodFil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
pTexto ALIAS FOR $3 ;
 RESULTADO VARCHAR(1);
 cTexto TT_MAI.TEXTOS%TYPE;
BEGIN
  SELECT MSGERR INTO cTexto
   FROM TT_LCF 
  WHERE CODFIL = pCodFil
   AND SEQUEN = pSequen;
  IF INSTR( UPPER(cTexto), UPPER(pTexto)) > 0 THEN
   RETURN 'T';
  ELSE
   RETURN 'F';
  END IF;
END;
$$ language 'plpgsql';




/*-- SEQ 0999 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION MtoM (TD_MOE.CODTAB%TYPE,TD_MOE.CODTAB%TYPE,Timestamp,Numeric) CASCADE;

/*-- SEQ 1000 --*/
CREATE OR REPLACE FUNCTION MtoM (TD_MOE.CODTAB%TYPE,TD_MOE.CODTAB%TYPE,Timestamp,Numeric)
RETURNS Numeric AS $$
DECLARE
ORIGEM ALIAS FOR $1 ;
DESTINO ALIAS FOR $2 ;
DATA ALIAS FOR $3 ;
VALOR ALIAS FOR $4 ;
-- Objetivo:
-- 1) Converter da moeda corrente para outra moeda e vice-versa

  TEM_CAMBIO boolean;
  VALOR_DIA  Numeric;
  VALOR_TOT  Numeric;
BEGIN
  TEM_CAMBIO := true;
  VALOR_TOT  := VALOR;
  IF ORIGEM <> DESTINO THEN
  
    -- Converte valor para moeda padrao
    IF ORIGEM <> 0 THEN
       VALOR_DIA := Cambio(ORIGEM,DATA);
       IF VALOR_DIA = 0 THEN
          TEM_CAMBIO := false;
       ELSE
          VALOR_TOT := VALOR_TOT * VALOR_DIA;
       END IF;
    END IF;

    -- Converte o VALOR para a moeda DESTINO
    IF DESTINO <> 0 THEN
       VALOR_DIA := Cambio(DESTINO,DATA);

       IF VALOR_DIA = 0 THEN
         TEM_CAMBIO := false;
       ELSE
         VALOR_TOT := (VALOR_TOT / VALOR_DIA);
       END IF;
    END IF;
  END IF;

  IF TEM_CAMBIO THEN
     RETURN VALOR_TOT;
  ELSE
     -- Problema na conversao de moeda!
     RETURN 0;
  END IF;
END;
$$ language 'plpgsql';






/*-- SEQ 1001 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Nomes (VARCHAR,Numeric,Numeric,Numeric) CASCADE;

/*-- SEQ 1002 --*/
CREATE OR REPLACE FUNCTION Nomes (VARCHAR,Numeric,Numeric,Numeric)
RETURNS SETOF obj_nomes AS $$
DECLARE
pTexto ALIAS FOR $1 ;
pLike ALIAS FOR $2 ;
pHifen ALIAS FOR $3 ;
bIgnoraConcat ALIAS FOR $4 ;

   
   out_rec                        obj_nomes%ROWTYPE;
   rec                            RECORD;
   low                            integer := 0; 
   high                           integer := 0;
         wk_Texto                      VARCHAR(8000) := '';
   wk_palavra                    VARCHAR(4000);
   wk2_palavra                   VARCHAR(4000);
   wk_incluso                    VARCHAR(8000) := ',';
   wk_espaco                     Numeric := 0;
   wk_ini                        Numeric := 1;
   wk_vez                        Numeric := 0;
   wk2_espaco                    Numeric := 0;
   wk2_ini                       Numeric := 1;
   wk_tam                        Numeric := 0;

BEGIN
 -- Retira espaos no inicio e fim
 WK_TEXTO := TRIM(UPPER( pTexto ))||' ';
 IF length(wk_texto) < 3 THEN
    return;
 END IF;
 -- Formata e "limpa" o texto
 wk_texto := REPLACE( WK_TEXTO, '!', ' ');
 wk_texto := REPLACE( WK_TEXTO, '@', ' ');
 wk_texto := REPLACE( WK_TEXTO, '#', ' ');
 wk_texto := REPLACE( WK_TEXTO, '$', ' ');
 if pLike = 0 then -- S retira o "%" quando no se est localizando para us-lo no LIKE
    wk_texto := REPLACE( WK_TEXTO, '%', ' ');
 end if;
 wk_texto := REPLACE( WK_TEXTO, '^', ' ');
 wk_texto := REPLACE( WK_TEXTO, '&', ' ');
 wk_texto := REPLACE( WK_TEXTO, '*', ' ');
 wk_texto := REPLACE( WK_TEXTO, '(', ' ');
 wk_texto := REPLACE( WK_TEXTO, ')', ' ');
 wk_texto := REPLACE( WK_TEXTO, '_', ' ');
 wk_texto := REPLACE( WK_TEXTO, '+', ' ');
 wk_texto := REPLACE( WK_TEXTO, '=', ' ');
 wk_texto := REPLACE( WK_TEXTO, '[', ' ');
 wk_texto := REPLACE( WK_TEXTO, ']', ' ');
 wk_texto := REPLACE( WK_TEXTO, '|', ' ');
 wk_texto := REPLACE( WK_TEXTO, ':', ' ');
 wk_texto := REPLACE( WK_TEXTO, ';', ' ');
 wk_texto := REPLACE( WK_TEXTO, '"', ' ');
 wk_texto := REPLACE( WK_TEXTO, '<', ' ');
 wk_texto := REPLACE( WK_TEXTO, '>', ' ');
 wk_texto := REPLACE( WK_TEXTO, ',', ' ');
 wk_texto := REPLACE( WK_TEXTO, '.', ' ');
 wk_texto := REPLACE( WK_TEXTO, '?', ' ');
 wk_texto := REPLACE( WK_TEXTO, '', ' ');
 wk_texto := REPLACE( WK_TEXTO, '', ' ');
 wk_texto := REPLACE( WK_TEXTO, '', 'C');
 wk_texto := REPLACE( WK_TEXTO, '', ' ');
 wk_texto := REPLACE( WK_TEXTO, '', ' ');
 wk_texto := REPLACE( WK_TEXTO, '`', ' ');

 wk_texto := REPLACE( WK_TEXTO, '', 'A');
 wk_texto := REPLACE( WK_TEXTO, '', 'E');
 wk_texto := REPLACE( WK_TEXTO, '', 'I');
 wk_texto := REPLACE( WK_TEXTO, '', 'O');
 wk_texto := REPLACE( WK_TEXTO, '', 'U');

 wk_texto := REPLACE( WK_TEXTO, '', 'A');
 wk_texto := REPLACE( WK_TEXTO, '', 'E');

 wk_texto := REPLACE( WK_TEXTO, '', 'A');

 wk_texto := REPLACE( WK_TEXTO, '', 'A');
 wk_texto := REPLACE( WK_TEXTO, '', 'E');
 wk_texto := REPLACE( WK_TEXTO, '', 'I');
 wk_texto := REPLACE( WK_TEXTO, '', 'O');
 wk_texto := REPLACE( WK_TEXTO, '', 'U');

 wk_texto := REPLACE( WK_TEXTO, '', 'A');
 wk_texto := REPLACE( WK_TEXTO, '', 'E');
 wk_texto := REPLACE( WK_TEXTO, '', 'I');
 wk_texto := REPLACE( WK_TEXTO, '', 'O');
 wk_texto := REPLACE( WK_TEXTO, '', 'U');

 wk_texto := REPLACE( WK_TEXTO, '', 'A');
 wk_texto := REPLACE( WK_TEXTO, '', 'E');
 wk_texto := REPLACE( WK_TEXTO, '', 'I');
 wk_texto := REPLACE( WK_TEXTO, '', 'O');
 wk_texto := REPLACE( WK_TEXTO, '', 'U');

 wk_texto := REPLACE( WK_TEXTO, CHR(39)||(39)||CHR(39)||CHR(39), ' '); -- ''''
 wk_texto := REPLACE( WK_TEXTO, CHR(13), ' ');
 wk_texto := REPLACE( WK_TEXTO, CHR(10), ' ');
 wk_texto := REPLACE( WK_TEXTO, CHR(92), ' '); -- ''/''
 wk_texto := REPLACE( WK_TEXTO, CHR(39), ' '); -- aspa simples

 wk_texto := REPLACE( WK_TEXTO, CHR(123), ' '); -- ''{''
 wk_texto := REPLACE( WK_TEXTO, CHR(125), ' '); -- ''}''

 -- Retira duplo espaco
 LOOP
   WK_ESPACO := INSTR (wk_Texto, '  ');
   EXIT WHEN WK_Espaco = 0;
   wk_texto := REPLACE( WK_TEXTO, '  ', ' ');
 END LOOP;

 -- Retira duplo ifem
 LOOP
   WK_ESPACO := INSTR (wk_Texto, '--');
   EXIT WHEN WK_Espaco = 0;
   wk_texto := REPLACE( WK_TEXTO, '--', '-');
 END LOOP;

 -- Retira dupla barrs
 LOOP
   WK_ESPACO := INSTR (wk_Texto, '//');
   EXIT WHEN WK_Espaco = 0;
   wk_texto := REPLACE( WK_TEXTO, '//', '/');
 END LOOP;

 -- Retira duplo percentual
 if pLike <> 0 then
    LOOP
      WK_ESPACO := INSTR (wk_Texto, '%%');
      EXIT WHEN WK_Espaco = 0;
      wk_texto := REPLACE( WK_TEXTO, '%%', '%');
    END LOOP;
 end if;

 -- Separa o texto em palavras
 wk_Tam := length( wk_Texto );
 WK_ESPACO := INSTR (wk_Texto, ' ');
  
  high := length(wk_Texto);
  FOR rec in low..high LOOP 
    EXIT WHEN WK_Espaco = 0 or wk_vez > 2000;
   wk_palavra := substr( wk_Texto, wk_ini, wk_espaco-wk_ini);

   -- Tratamento de ifem contido na palavra
   if (InStr(wk_palavra, '-') > 0)
   and (pHifen <> 0) then 
      -- Caso o ifem seja o primeiro caracter, retira-lo
      if substr(wk_palavra,1,1) = '-' then
         wk_palavra := substr(wk_palavra,2);
      end if;
      -- Caso o ifem seja o ultimo caracter, retira-lo
      if substr(wk_palavra,length(wk_palavra),1) = '-' then
         wk_palavra := substr(wk_palavra,1,length(wk_palavra)-1);
      end if;
      -- Verifica se ficou ifem dentro da palavra
      if (InStr(wk_palavra, '-') > 0) and (wk_ini <= wk_tam) then 
         -- Adciona a palavra sem o ifem na string para ser inclusa como nova palavra
         WK_Texto := WK_Texto || REPLACE( WK_Palavra, '-', ' ') || ' ' ;
         WK_Texto := WK_Texto || REPLACE( WK_Palavra, '-', '')  || ' ' ;
      end if;
   end if;

   -- Tratamento de barra contido na palavra
   if (InStr(wk_palavra, '/') > 0)
   and (pHifen <> 0) then 
      -- Caso a barra seja o primeiro caracter, retira-lo
      if substr(wk_palavra,1,1) = '/' then
         wk_palavra := substr(wk_palavra,2);
      end if;
      -- Caso a barra seja o ultimo caracter, retira-lo
      if substr(wk_palavra,length(wk_palavra),1) = '/' then
         wk_palavra := substr(wk_palavra,1,length(wk_palavra)-1);
      end if;
      -- Verifica se ficou barra dentro da palavra
      if (InStr(wk_palavra, '/') > 0) and (wk_ini <= wk_tam) then 
         -- Adciona a palavra sem a barra na string para ser inclusa como nova palavra
         WK_Texto := WK_Texto || REPLACE( WK_Palavra, '/', ' ') || ' ' ;
         WK_Texto := WK_Texto || REPLACE( WK_Palavra, '/', '')  || ' ' ;
      end if;
   end if;

   -- Truca em 25 caracteres no maximo
   if length(wk_palavra) > 25 then
      wk_palavra := substr( wk_palavra, 1, 25 );
   end if;     

    wk_palavra := trim(wk_palavra);
    
    -- Verifica se o valor de ignorar concatenao entre nmeros e letras est habilitado ou no;
    -- 0(false)  o valor padro, signifia que no est habilitado, no ir ignorar a concatenao.
   if (bIgnoraConcat = 0 ) then
      -- Caso seja um numero, opcao para tambem uni-lo a proxima palavra. Ex.: ''1 KG'' = ''1KG''
      if (HaNumeros( substr(wk_palavra, 1, length(wk_palavra) ) ) = 0)
      and (pHifen <> 0) then
         wk2_ini := wk_Espaco + 1;
                  
         wk2_espaco := INSTR (WK_Texto::VARCHAR, ' '::VARCHAR, wk2_ini::int);
                  --Verifica se resultado  maior que zero pois gera erro no PG quando executado o substr com quantidade de caracter negativo
         --Erro encontrado na tarefa 98227
         if ((wk2_espaco-wk2_ini) > 0) then
            wk2_palavra := substr( wk_Texto, wk2_ini, wk2_espaco-wk2_ini);
         end if;
         
         if (WK2_Espaco > 0) and (wk2_ini <= wk_tam ) then
            WK_Texto := WK_Texto || WK_Palavra || wk2_palavra || ' ';
         end if;
      end if;
   end if;
   
   -- Inclui palavra na lista
   if  ISNOTNULL(wk_palavra) = 'T' then
      -- Somente inclui caso a palavra j no tenha sido inclusa
      if InStr( wk_incluso, ',' || wk_palavra || ',' ) = 0 then 
         wk_incluso := wk_incluso || wk_palavra || ',' ;
         out_rec.desnom := trim(wk_palavra);
	          
         RETURN NEXT out_rec;
	       end if;
   end if;

   wk_ini := wk_Espaco + 1;
      
   wk_espaco := INSTR (WK_Texto::VARCHAR, ' '::VARCHAR, wk_ini::int);
      wk_vez := wk_vez + 1;
   
   high := high-length(wk_palavra);
    END LOOP;
 return;
END;
$$ language 'plpgsql';




/*-- SEQ 1003 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Nvlz (Numeric,Numeric) CASCADE;

/*-- SEQ 1004 --*/
CREATE OR REPLACE FUNCTION Nvlz (Numeric,Numeric)
RETURNS Numeric AS $$
DECLARE
Valor ALIAS FOR $1 ;
Retorno ALIAS FOR $2 ;
begin
  if COALESCE(Valor,0) = 0 then
     return Retorno;
  else
     return Valor;
  end if;
END;
$$ language 'plpgsql';



/*-- SEQ 1005 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Nvlz (Float,Float) CASCADE;

/*-- SEQ 1006 --*/
CREATE OR REPLACE FUNCTION Nvlz (Float,Float)
RETURNS Float AS $$
DECLARE
Valor ALIAS FOR $1 ;
Retorno ALIAS FOR $2 ;
begin
  if COALESCE(Valor,0) = 0 then
     return Retorno;
  else
     return Valor;
  end if;
END;
$$ language 'plpgsql';




/*-- SEQ 1007 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION OperacaoCaixa (VARCHAR,TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE) CASCADE;

/*-- SEQ 1008 --*/
CREATE OR REPLACE FUNCTION OperacaoCaixa (VARCHAR,TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pTIPO ALIAS FOR $1 ;
pCODFIL ALIAS FOR $2 ;
pSEQUEN ALIAS FOR $3 ;
pNUMPAR ALIAS FOR $4 ;
pSUBPAR ALIAS FOR $5 ;

CR_OPERACAO_REC CURSOR FOR
   SELECT CODFIL||'-'||NUMECF||'/'||TRN_ID||'-'||TRIM(CUPFIS)
     FROM TT_OPE
    WHERE FILREC=pCODFIL
      AND SEQREC=pSEQUEN
      AND NUMPAR=pNUMPAR
      AND SUBPAR=pSUBPAR;

CR_OPERACAO_CHR CURSOR FOR
   SELECT CODFIL||'-'||NUMECF||'/'||TRN_ID||'-'||TRIM(CUPFIS)
     FROM TT_OPE
    WHERE FILCHR=pCODFIL
      AND SEQCHR=pSEQUEN;

CR_OPERACAO_CCC CURSOR FOR
   SELECT CODFIL||'-'||NUMECF||'/'||TRN_ID||'-'||TRIM(CUPFIS)
     FROM TT_OPE
    WHERE FILCCC=pCODFIL
      AND SEQCCC=pSEQUEN;

CR_OPERACAO_FIN CURSOR FOR
   SELECT CODFIL||'-'||NUMECF||'/'||TRN_ID||'-'||TRIM(CUPFIS)
     FROM TT_OPE
    WHERE FILFIN=pCODFIL
      AND SEQFIN=pSEQUEN;
      
CR_OPERACAO_DOP CURSOR FOR
   SELECT CODFIL||'-'||NUMECF||'/'||TRN_ID||'-'||TRIM(CUPFIS)
     FROM TT_OPE
    WHERE FILDOP=pCODFIL
      AND SEQDOP=pSEQUEN;            

   vLINHA VARCHAR(255);
   vRESULT VARCHAR(32000);

BEGIN
   vRESULT:='';

   IF pTIPO='REC' THEN
      OPEN CR_OPERACAO_REC;
      LOOP
          FETCH CR_OPERACAO_REC INTO vLINHA;
          EXIT WHEN NOT FOUND;
          vRESULT:=vRESULT||vLINHA||CHR(13)||CHR(10);
      END LOOP;
      CLOSE CR_OPERACAO_REC;
   ELSIF pTIPO='CHR' THEN
      OPEN CR_OPERACAO_CHR;
      LOOP
          FETCH CR_OPERACAO_CHR INTO vLINHA;
          EXIT WHEN NOT FOUND;
          vRESULT:=vRESULT||vLINHA||CHR(13)||CHR(10);
      END LOOP;
      CLOSE CR_OPERACAO_CHR;
   ELSIF pTIPO='CCC' THEN
      OPEN CR_OPERACAO_CCC;
      LOOP
          FETCH CR_OPERACAO_CCC INTO vLINHA;
          EXIT WHEN NOT FOUND;
          vRESULT:=vRESULT||vLINHA||CHR(13)||CHR(10);
      END LOOP;
      CLOSE CR_OPERACAO_CCC;
   ELSIF pTIPO='FIN' THEN
      OPEN CR_OPERACAO_FIN;
      LOOP
          FETCH CR_OPERACAO_FIN INTO vLINHA;
          EXIT WHEN NOT FOUND;
          vRESULT:=vRESULT||vLINHA||CHR(13)||CHR(10);
      END LOOP;
      CLOSE CR_OPERACAO_FIN;
   ELSIF pTIPO='DOP' THEN
      OPEN CR_OPERACAO_DOP;
      LOOP
          FETCH CR_OPERACAO_DOP INTO vLINHA;
          EXIT WHEN NOT FOUND;
          vRESULT:=vRESULT||vLINHA||CHR(13)||CHR(10);
      END LOOP;
      CLOSE CR_OPERACAO_DOP;
   END IF;
   
   RETURN substr(vRESULT,1,4000);

END;
$$ language 'plpgsql';




/*-- SEQ 1009 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ORDENADIVISAO (Numeric) CASCADE;

/*-- SEQ 1010 --*/
CREATE OR REPLACE FUNCTION ORDENADIVISAO (Numeric)
RETURNS VARCHAR AS $$
DECLARE
pCODDIV ALIAS FOR $1 ;

vNUMERO Numeric;
vCODITE TT_DIV.CODITE%TYPE;

ORDEM CURSOR FOR
  SELECT NEXTVAL('SQ_TEMP_DIV')*10 AS NUMERO, INT.CODITE FROM 
  (SELECT CODITE FROM TT_DIV
    WHERE CODDIV = pCODDIV
   ORDER BY NOMITE) INT;

BEGIN

CREATE TEMPORARY SEQUENCE SQ_TEMP_DIV INCREMENT 1 START 1 MINVALUE 1;

  OPEN ORDEM;
  LOOP
    FETCH ORDEM INTO vNUMERO, vCODITE;
    EXIT WHEN NOT FOUND;
    UPDATE TT_DIV SET ORDDIV = vNUMERO
     WHERE CODITE = vCODITE
       AND CODDIV = pCODDIV;
  END LOOP;

DROP SEQUENCE SQ_TEMP_DIV;

RETURN 'OK';

END;
$$ language 'plpgsql';




/*-- SEQ 1011 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ParcelasCheque (TT_CHR.CODFIL%TYPE,TT_CHR.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1012 --*/
CREATE OR REPLACE FUNCTION ParcelasCheque (TT_CHR.CODFIL%TYPE,TT_CHR.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
  linha   VARCHAR(4000);
  retorno VARCHAR(4000);
  buffer  VARCHAR(32767);
  i       Numeric;
  c_LF    CHAR(2) := chr(13)||chr(10);
 
  Funcao CURSOR FOR
    SELECT 'Filial ' || VEN.CODFIL || 
           ', Documento ' || trim(VEN.CODSER) || '/' || VEN.NUMECF || '-' || trim(VEN.NUMNOT) ||
           ', Parcela ' || trim(REC.NUMPAR) || '-' || trim(REC.SUBPAR) ||
           ', Valor ' || trim(to_char(REC.VLRPGT, '9999999999.99' )) as parcela
    FROM TT_REC REC INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
    WHERE REC.FILREC = pCODFIL
      AND REC.SEQCHE = pSEQUEN
    ORDER BY VEN.CODFIL, VEN.CODSER, VEN.NUMECF, VEN.NUMNOT, REC.NUMPAR, REC.SUBPAR;
 
BEGIN
  buffer  := '';
  retorno := '';
  i := 0;
  OPEN funcao;
  LOOP
    FETCH funcao into linha;
    EXIT WHEN NOT FOUND;
    IF i > 0 THEN
       buffer := buffer || c_LF;
    END IF;
    I := I + 1;
    buffer := buffer || linha;
  END LOOP;
  Close Funcao;
 
  IF Length(buffer) > 4000 THEN
    retorno := Substr(buffer,1,3980)||C_lf||'** muito longo **';
  ELSE
    retorno := buffer;
  END IF;
 
  Return retorno;
END;
$$ language 'plpgsql';





/*-- SEQ 1013 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PathAnexoProjeto (TT_PRJ.CODFIL%TYPE,TT_PRJ.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1014 --*/
CREATE OR REPLACE FUNCTION PathAnexoProjeto (TT_PRJ.CODFIL%TYPE,TT_PRJ.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCodfil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
-- Objetivo
-- 1) Retornar a nome do cliente associado a uma tarefa

  cPathPrj VARCHAR(255):='';
  cFILPRJ TT_WOR.FILPRJ%TYPE;
  cSEQPRJ TT_WOR.SEQPRJ%TYPE;  
  cAuxFILPRJ TT_WOR.FILPRJ%TYPE;
  cAuxSEQPRJ TT_WOR.SEQPRJ%TYPE;    
  cAuxPath VARCHAR(4000):='';

  Lista CURSOR(pFilprj TT_PRJ.CODFIL%TYPE,
           pSeqprj TT_PRJ.SEQUEN%TYPE) IS
    -- Ver detalhes sobre a macro em
-- \\tt2000\Docs\desenv\depto\Manuais\Ansi\connectby.mac
SELECT codfil,sequen,patdoc
FROM connectby_back('(select to_char(chvprj) as filho,
                             to_char(chvpai) as pai
                   from tt_prj int) tab', 'filho', 'pai', to_char(pfilprj||pseqprj))
AS c (conn_codigo VARCHAR, conn_codpai VARCHAR, level int, ordem int)
INNER JOIN tt_prj t ON c.conn_codigo  = (chvprj)
order by ordem;

-- Principal
begin

   OPEN Lista(pCodfil,pSequen);
   LOOP      
      FETCH Lista INTO cAuxFilPrj,cAuxSeqPrj,cPathPrj;
      EXIT WHEN (NOT FOUND) or (cPathPrj IS NOT NULL);
      cFilPrj :=cAuxFilPrj;
      cSeqPrj :=cAuxSeqPrj;
      cAuxPath:=trim(cFilprj)||'-'||trim(cSeqPrj)||TO_PATH('/')||cAuxPath;
   END LOOP;     
   Close Lista;
   
   if isnull(cPathPrj)='T' then 
      Return null;
   else 
     Return cPathPrj||coalesce(cAuxPath,'');
   end if;

END;
$$ language 'plpgsql';




/*-- SEQ 1015 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PERMISSAO (TT_USU.APEUSU%TYPE,INTEGER) CASCADE;

/*-- SEQ 1016 --*/
CREATE OR REPLACE FUNCTION PERMISSAO (TT_USU.APEUSU%TYPE,INTEGER)
RETURNS INTEGER AS $$
DECLARE
pNome ALIAS FOR $1 ;
pCodigo ALIAS FOR $2 ;
  wk_retorno INTEGER;
BEGIN
    SELECT CASE WHEN QUALDONO() = APEUSU OR substr(PERMISSOESUSUARIO(FILUSU,CODUSU),pCodigo,1) = 'S' THEN 1 ELSE 0 END INTO wk_retorno
      FROM TT_USU
     WHERE APEUSU = UPPER(pNome);

  RETURN COALESCE(wk_retorno,0);
END;
$$ language 'plpgsql';






/*-- SEQ 1017 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PrecoPromocional (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_PLA.FILPGT%TYPE,TT_PLA.CODPGT%TYPE,TT_PRE.FILPRE%TYPE,TT_PRE.SEQUEN%TYPE,Timestamp,TT_CPM.FILPRO%TYPE) CASCADE;

/*-- SEQ 1018 --*/
CREATE OR REPLACE FUNCTION PrecoPromocional (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_PLA.FILPGT%TYPE,TT_PLA.CODPGT%TYPE,TT_PRE.FILPRE%TYPE,TT_PRE.SEQUEN%TYPE,Timestamp,TT_CPM.FILPRO%TYPE)
RETURNS TT_CPM.PRECOP%TYPE AS $$
DECLARE
pFilMat ALIAS FOR $1 ;
pCodMat ALIAS FOR $2 ;
pCodCor ALIAS FOR $3 ;
pCodTam ALIAS FOR $4 ;
pFilPgt ALIAS FOR $5 ;
pCodPgt ALIAS FOR $6 ;
pFilPre ALIAS FOR $7 ;
pSeqPre ALIAS FOR $8 ;
pData ALIAS FOR $9 ;
pFilPro ALIAS FOR $10 ;
   nRetorno  TT_CPM.PRECOP%TYPE;
BEGIN
  nRetorno := 0;
    SELECT MIN(CPM.PRECOP) INTO nRetorno
      FROM TT_CPM CPM INNER JOIN TT_PRE PRE ON PRE.FILPRE = CPM.FILPRE
                                           AND PRE.SEQUEN = CPM.SEQPRE
                                           AND PRE.FILMAT = pFilMat
                                           AND PRE.CODMAT = pCodMat
                                           AND PRE.CODCOR = pCodCor
                                           AND PRE.CODTAM = pCodTam
       AND ((CPM.FILPGT = pFilPgt AND CPM.CODPGT = pCodPgt) OR CPM.FILPGT IS NULL)
       AND CPM.FILPRE = pFilPre
       AND CPM.SEQPRE = pSeqPre
       AND CPM.DATVAL >= TRUNC(pData)
       AND COALESCE(CPM.DATINI, TO_DATE('01/01/1900','DD/MM/YYYY')) <= TRUNC(pData)
       AND ((CPM.FILPRO = pFilPro) OR CPM.FILPRO IS NULL)
       AND CPM.FILLOT IS NULL
       AND ((CPM.QTDCPM IS NULL) OR CPM.QTDCPM = 0)
       AND ((CPM.QTDMIN IS NULL) OR CPM.QTDMIN = 0)
       AND CPM.CLILEV = 'F';
  RETURN COALESCE(nRetorno,0);
END;
$$ language 'plpgsql';


/*-- SEQ 1019 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PrecoPromocional (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_PLA.FILPGT%TYPE,TT_PLA.CODPGT%TYPE,TT_PRE.FILPRE%TYPE,TT_PRE.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1020 --*/
CREATE OR REPLACE FUNCTION PrecoPromocional (TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               TT_PLA.FILPGT%TYPE,
                               TT_PLA.CODPGT%TYPE,
                               TT_PRE.FILPRE%TYPE,
                               TT_PRE.SEQUEN%TYPE) 
RETURNS TT_CPM.PRECOP%TYPE AS $$
BEGIN
RETURN PrecoPromocional($1,$2,$3,$4,$5,$6,$7,$8,AGORA(),null);
END;
$$ language 'plpgsql';


/*-- SEQ 1021 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PrecoPromocional (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_PLA.FILPGT%TYPE,TT_PLA.CODPGT%TYPE,TT_PRE.FILPRE%TYPE,TT_PRE.SEQUEN%TYPE,Timestamp) CASCADE;

/*-- SEQ 1022 --*/
CREATE OR REPLACE FUNCTION PrecoPromocional (TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               TT_PLA.FILPGT%TYPE,
                               TT_PLA.CODPGT%TYPE,
                               TT_PRE.FILPRE%TYPE,
                               TT_PRE.SEQUEN%TYPE,
                               Timestamp) 
RETURNS TT_CPM.PRECOP%TYPE AS $$
BEGIN
RETURN PrecoPromocional($1,$2,$3,$4,$5,$6,$7,$8,$9,null);
END;
$$ language 'plpgsql';


/*-- SEQ 1023 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PrecoPromocionalPorIve (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE) CASCADE;

/*-- SEQ 1024 --*/
CREATE OR REPLACE FUNCTION PrecoPromocionalPorIve (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE)
RETURNS TT_CPM.PRECOP%TYPE AS $$
DECLARE
pCodFil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
pFilMat ALIAS FOR $3 ;
pCodMat ALIAS FOR $4 ;
pCodCor ALIAS FOR $5 ;
pCodTam ALIAS FOR $6 ;
  vFilpre TT_VEN.FILPRE%TYPE;
  vCodpre TT_VEN.CODPRE%TYPE;
  vFilpgt TT_VEN.FILPGT%TYPE;
  vCodpgt TT_VEN.CODPGT%TYPE;
  vDathor TT_VEN.DATHOR%TYPE;
  vPrecop TT_CPM.PRECOP%TYPE;
  vSEQPRE TT_PRE.SEQUEN%TYPE;
BEGIN  

    SELECT FILPRE, CODPRE, FILPGT, CODPGT, DATHOR INTO vFilpre, vCodpre, vFilpgt, vCodpgt, vDathor
      FROM TT_VEN 
    WHERE CODFIL = pCodFil 
      AND SEQUEN = pSequen;   

    SELECT SEQUEN INTO vSEQPRE
      FROM TT_PRE
     WHERE FILMAT=pFILMAT
       AND CODMAT=pCODMAT
       AND CODCOR=pCODCOR
       AND CODTAM=pCODTAM
       AND FILPRE=vFilpre
       AND CODPRE=vCodpre;

    
  
  
  -- encontra o preco promocional do produto na data da venda
  vPrecop := PrecoPromocional(pFilMat,pCodMat,pCodCor,pCodTam,vFilpgt,vCodpgt,vFilpre,vSEQPRE,vDathor);

  RETURN COALESCE(vPrecop,0);
END;
$$ language 'plpgsql';




/*-- SEQ 1025 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PRECO_ANTERIOR (TT_ICO.FILMAT%TYPE,TT_ICO.CODMAT%TYPE,TT_ICO.CODCOR%TYPE,TT_ICO.CODTAM%TYPE,TT_ICO.COM_DATOPE%TYPE,TT_PRE.FILPRE%TYPE,TT_PRE.CODPRE%TYPE) CASCADE;

/*-- SEQ 1026 --*/
CREATE OR REPLACE FUNCTION PRECO_ANTERIOR (TT_ICO.FILMAT%TYPE,TT_ICO.CODMAT%TYPE,TT_ICO.CODCOR%TYPE,TT_ICO.CODTAM%TYPE,TT_ICO.COM_DATOPE%TYPE,TT_PRE.FILPRE%TYPE,TT_PRE.CODPRE%TYPE)
RETURNS Numeric AS $$
DECLARE
pFILMAT ALIAS FOR $1 ;
pCODMAT ALIAS FOR $2 ;
pCODCOR ALIAS FOR $3 ;
pCODTAM ALIAS FOR $4 ;
pDATOPE ALIAS FOR $5 ;
pFILPRE ALIAS FOR $6 ;
pCODPRE ALIAS FOR $7 ;
 vULTCOM Timestamp;
 vPREANT TT_PRE.PRECOV%TYPE;
BEGIN
  SELECT COM_DATOPE
    INTO vULTCOM
    FROM TT_ICO 
   WHERE FILMAT = pFILMAT
     AND CODMAT = pCODMAT
     AND CODCOR = pCODCOR
     AND CODTAM = pCODTAM
     AND COM_DATOPE < pDATOPE;
   
  SELECT COALESCE(PRECODIA(pFILMAT, pCODMAT, pCODCOR, pCODTAM, vULTCOM, pFILPRE, pCODPRE),0) AS PREANT
    INTO vPREANT
    FROM DUAL;

   RETURN coalesce(vPREANT,0);


END;
$$ language 'plpgsql';




/*-- SEQ 1027 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PrecoVendaBomba (VARCHAR,TD_CTR.CODTAB%TYPE,TD_FIL.CODFIL%TYPE,TT_TPR.ESTADO%TYPE,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_GRA.DESMAX%TYPE) CASCADE;

/*-- SEQ 1028 --*/
CREATE OR REPLACE FUNCTION PrecoVendaBomba (VARCHAR,TD_CTR.CODTAB%TYPE,TD_FIL.CODFIL%TYPE,TT_TPR.ESTADO%TYPE,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_GRA.DESMAX%TYPE)
RETURNS Numeric AS $$
DECLARE
pTipo ALIAS FOR $1 ;
pCODCTR ALIAS FOR $2 ;
pFILIAL ALIAS FOR $3 ;
pUfLoja ALIAS FOR $4 ;
pFILMAT ALIAS FOR $5 ;
pCODMAT ALIAS FOR $6 ;
pCODCOR ALIAS FOR $7 ;
pCODTAM ALIAS FOR $8 ;
pDESMAX ALIAS FOR $9 ;
  Vlr Numeric;
  Valores CURSOR FOR
  SELECT INT.* FROM
     (SELECT CASE WHEN (PRE.FLGEST = 'T' AND TPR.CODCTR = pCodCtr AND TPR.FILDES = pFilial) THEN 5
                          WHEN (PRE.FLGEST = 'T' AND TPR.CODCTR = pCodCtr                         ) THEN 4
                          WHEN (PRE.FLGEST = 'T' AND TPR.FILDES = pFilial                         ) THEN 3
                          WHEN (PRE.FLGEST = 'T' AND TPR.ESTADO = pUfLoja                         ) THEN 2
                          WHEN (PRE.FILPRE || PRE.CODPRE = CFG.FILPRE || CFG.CODPRE               ) THEN 1
                                                                                            ELSE 0
             END AS ORDEM,
             CASE pTipo WHEN 'P' THEN PRE.PRECOV
                        WHEN 'D' THEN CASE WHEN COALESCE(PRE.DESMAX,0) = 0 THEN pDESMAX ELSE PRE.DESMAX END
                        WHEN 'M' THEN PRE.CODMOE
                        WHEN 'F' THEN CASE WHEN PRE.FLGEST = 'T' THEN 1 ELSE 0 END
             END AS VALOR
      FROM TT_CFG CFG,
           TT_PRE PRE INNER JOIN TT_TPR TPR ON TPR.CODFIL = PRE.FILPRE
                                           AND TPR.CODPRE = PRE.CODPRE
      WHERE PRE.FILMAT = pFilmat
        AND PRE.CODMAT = pCodMat
        AND PRE.CODCOR = pCodCor
        AND PRE.CODTAM = pCodTam
        AND COALESCE(TPR.CATEG1,0) = 0
        AND COALESCE(TPR.CATEG2,0) = 0
        AND COALESCE(TPR.CATEG3,0) = 0
        AND PRE.FLGEST = 'T'
      UNION ALL
      SELECT 0 AS ORDEM, 0.00 AS VALOR FROM DUAL) INT
  ORDER BY ORDEM DESC;
  
  nOrdem Integer;
  nValor Numeric;

begin
  Vlr:=0;
  OPEN Valores;
  FETCH Valores into nOrdem, nValor;
  IF nORDEM = 0 THEN
     Vlr := 0;
  ELSE
     Vlr := nVALOR;
  END IF;
  CLOSE Valores;
  RETURN Vlr;
END;
$$ language 'plpgsql';




/*-- SEQ 1029 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ProjetoCliente (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE) CASCADE;

/*-- SEQ 1030 --*/
CREATE OR REPLACE FUNCTION ProjetoCliente (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pfilcli ALIAS FOR $1 ;
pcodcli ALIAS FOR $2 ;
-- Objetivo
-- 1) Retornar a nome do Projeto ASSOCIADO A UM Cliente
  CCLIENTE VARCHAR(9);
 -- Principal
BEGIN
  SELECT CLI.FILCLI||CLI.CODCLI INTO CCLIENTE
    FROM TT_PRJ PRJ INNER JOIN TT_CLI CLI ON PRJ.FILCLI=CLI.FILCLI AND PRJ.CODCLI=CLI.CODCLI
  WHERE PRJ.FILCLI = PFILCLI
    AND PRJ.CODCLI = PCODCLI
    AND PRJ.SEQPAI IS NULL
    AND PRJ.FILPAI IS NULL
  GROUP BY CLI.FILCLI||CLI.CODCLI;
 RETURN CCLIENTE;
END;
$$ language 'plpgsql';





/*-- SEQ 1031 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Produtos_Nomes (Numeric,VARCHAR,Numeric) CASCADE;

/*-- SEQ 1032 --*/
CREATE OR REPLACE FUNCTION Produtos_Nomes (Numeric,VARCHAR,Numeric)
RETURNS SETOF obj_proxnom AS $$
DECLARE
nSoundex ALIAS FOR $1 ;
pTexto ALIAS FOR $2 ;
bIgnoraConcat ALIAS FOR $3 ;

cur0         refcursor;
cur1         refcursor;
out_rec      obj_proxnom%ROWTYPE;
Expressao    VARCHAR(4000);
Nome         VARCHAR(25);
cQuery       VARCHAR(4000);
cWhere       VARCHAR(4000);
Qtd          Numeric(3);
LF           CHAR(1) := chr(10);

BEGIN
  Qtd := 0;
  cQuery := 'select n1.filmat, n1.codmat, n1.codcor, n1.codtam' || lf ||
            'from ';
  cWhere := lf ||'where ';
  
  OPEN cur0 FOR EXECUTE 'SELECT * FROM Nomes('||chr(39)||pTexto||chr(39)||', 0, 1,'|| bIgnoraConcat ||')';  
        
  LOOP
      FETCH cur0 INTO Nome;
      EXIT WHEN NOT FOUND;
      Qtd := Qtd + 1;
      if Qtd = 1 then
         cQuery := cQuery || 'tt_proxnom n' || Qtd;
      else
         cQuery := cQuery || lf || '     inner join tt_proxnom n' || Qtd || ' on n' || Qtd || '.filmat = n1.filmat' ||
                             lf || '                       and n' || Qtd || '.codmat = n1.codmat' ||
                             lf || '                       and n' || Qtd || '.codcor = n1.codcor' ||
                             lf || '                       and n' || Qtd || '.codtam = n1.codtam';
         cWhere := cWhere || lf || '  and ';
      end if;
      if (nSoundex = 0) 
      or (instr(Nome,'%')<>0) 
      or (substr( Soundex( Nome ), 2 ) = '000')
      or (HaNumeros(Nome)=0) then
         cWhere := cWhere || 'n' || Qtd || '.DESNOM like ' || chr(39) || Nome || chr(39) ;
      else
         cWhere := cWhere || 'n' || Qtd || '.CODSOM = SOUNDEX(' || chr(39) || Nome || chr(39) || ')';
      end if;
  END LOOP;
  CLOSE cur0;

  IF Qtd = 0 THEN
            
      RETURN NEXT out_rec;
            RETURN;
  END IF;

  Expressao := cQuery || cWhere;
  
   OPEN cur1 FOR EXECUTE Expressao;  
       

  LOOP
      FETCH cur1 INTO out_rec.filmat, out_rec.codmat, out_rec.codcor, out_rec.codtam;
      EXIT WHEN NOT FOUND;
            
      RETURN NEXT out_rec;
        END LOOP;
  CLOSE cur1;
  RETURN ;
END;
$$ language 'plpgsql';






/*-- SEQ 1033 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ProximaSubparcela (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE) CASCADE;

/*-- SEQ 1034 --*/
CREATE OR REPLACE FUNCTION ProximaSubparcela (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE)
RETURNS TT_REC.SUBPAR%TYPE AS $$
DECLARE
p_chave1 ALIAS FOR $1 ;
p_chave2 ALIAS FOR $2 ;
p_chave3 ALIAS FOR $3 ;
  wk_retorno TT_REC.SUBPAR%TYPE;
BEGIN
     SELECT LPAD( COALESCE(TRIM(to_char(to_number(MAX(SUBPAR))+1)),'0'),2,' ')
       INTO wk_retorno
       FROM TT_REC
      WHERE CODFIL = p_chave1
        AND SEQUEN = p_chave2
        AND NUMPAR = p_chave3;

     RETURN wk_retorno;
END;
$$ language 'plpgsql';







/*-- SEQ 1035 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION QTD_A_DEVOLVER (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE) CASCADE;

/*-- SEQ 1036 --*/
CREATE OR REPLACE FUNCTION QTD_A_DEVOLVER (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE)
RETURNS Numeric AS $$
DECLARE
p_CodFil ALIAS FOR $1 ;
p_Sequen ALIAS FOR $2 ;
p_NumIte ALIAS FOR $3 ;
   QTDDEV Numeric;    -- Quantidade a ser devolvida

-- Objetivo:
-- 1) Calcular a quantidade a ser devolvida

BEGIN
  SELECT MAX(CASE WHEN IOR.TIPENT = '3' 
                  THEN IVE.QTDMOV
                  ELSE QtdPendente(IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE, IVE.QTDMOV) 
              END) - SUM(CASE WHEN ROM.FLGEST='E' THEN 0 ELSE COALESCE(IVO.CONTEM,0) END) - SUM(COALESCE(IVO.QTDFAL,0))
    INTO QTDDEV 
   FROM TT_IVE IVE INNER JOIN TT_IOR IOR ON IOR.FILIVE = IVE.CODFIL
                                        AND IOR.SEQIVE = IVE.SEQUEN
                                        AND IOR.NUMIVE = IVE.NUMITE
                   INNER JOIN TT_IVO IVO ON IVO.FILIVE = IVE.CODFIL 
                                        AND IVO.SEQIVE = IVE.SEQUEN 
                                        AND IVO.NUMIVE = IVE.NUMITE                                                                                                   
                   LEFT JOIN TT_ROM ROM ON IVO.FILROM=ROM.CODFIL AND IVO.SEQROM=ROM.SEQUEN
   WHERE IVE.CODFIL = p_CodFil
     AND IVE.SEQUEN = p_Sequen
     AND IVE.NUMITE = p_NumIte     
     AND IVO.FILIMP IS NULL
     AND IVO.FLGEST IN ('P','F','N');
  
  RETURN COALESCE(QTDDEV,0);
  
END;
$$ language 'plpgsql';





/*-- SEQ 1037 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION REFERENCIA (VARCHAR(20)) CASCADE;

/*-- SEQ 1038 --*/
CREATE OR REPLACE FUNCTION REFERENCIA (VARCHAR(20))
RETURNS VARCHAR AS $$
DECLARE
pREFERENCIA ALIAS FOR $1 ;
BEGIN
  IF LENGTH(ltrim(replace(pREFERENCIA,'0',' '))) IN (8,13) THEN
    RETURN pREFERENCIA;
  ELSE
    RETURN replace(ltrim(replace(pREFERENCIA,'0',' ')),' ','0');
  END IF;
END;
$$ language 'plpgsql' IMMUTABLE;

/*-- SEQ 1039 --*/
/*-- IGNORE ERRO --*/
CREATE INDEX I_LC_GRA_REFERENCIA ON TT_GRA(REFERENCIA(REFPRO));

/*-- SEQ 1040 --*/
/*-- IGNORE ERRO --*/
CREATE INDEX I_LC_PRO_REFERENCIA ON TT_PRO(REFERENCIA(REFBAS));

/*-- SEQ 1041 --*/
/*-- IGNORE ERRO --*/
CREATE INDEX I_LC_EAN_REFERENCIA ON TT_EAN(REFERENCIA(CODEAN));


/*-- SEQ 1042 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RetencaoCofins (TD_FIL.CODFIL%TYPE,TT_CLI.NUMDOC%TYPE,TT_VEN.VLRCOF%TYPE) CASCADE;

/*-- SEQ 1043 --*/
CREATE OR REPLACE FUNCTION RetencaoCofins (TD_FIL.CODFIL%TYPE,TT_CLI.NUMDOC%TYPE,TT_VEN.VLRCOF%TYPE)
RETURNS Numeric AS $$
DECLARE
p_Codfil ALIAS FOR $1 ;
p_Numdoc ALIAS FOR $2 ;
pValorAtual ALIAS FOR $3 ;

/*
 * Esta funo continua existindo para manter compatibilidade com os Checkouts anteriores  4.7m - RFMP 75423
 */

-- Objetivo
-- Retornar o valor do confins a reter de um determinado cliente
  WK_FLGTIP TT_CLI.FLGTIP%TYPE;
  WK_SIMPLE TT_CLI.SIMPLE%TYPE;
  WK_LIMCOF TD_FIL.LIMCOF%TYPE;
  WK_ALIQTA TD_FIL.PERCOF%TYPE;
  WK_TOTSER TT_IVE.VLRMOV%TYPE;
  WK_TOTRET TT_VEN.VLRCOF%TYPE;
  WK_TOTRETER TT_VEN.VLRCOF%TYPE;

begin

   SELECT FLGTIP, SIMPLE
     INTO WK_FLGTIP, WK_SIMPLE
     FROM TT_CLI
    WHERE NUMDOC = p_NUMDOC;

   SELECT LIMCOF
     INTO WK_LIMCOF
     FROM TD_FIL
    WHERE CODFIL = p_CODFIL;

   SELECT (COALESCE(PERSOC,0) + COALESCE(PERCOF,0) + COALESCE(PERPIS,0))
     INTO WK_ALIQTA
     FROM TD_FIL
    WHERE CODFIL = p_CODFIL;

   IF WK_FLGTIP = 1 AND WK_SIMPLE = 'F'  THEN

       SELECT COALESCE(SUM(IVE.VLRMOV),0)
         INTO WK_TOTSER
         FROM TT_CLI CLI INNER JOIN TT_VEN VEN ON VEN.FILCLI = CLI.FILCLI AND VEN.CODCLI = CLI.CODCLI
                         INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN
                         INNER JOIN TT_PRO PRO ON PRO.FILMAT = IVE.FILMAT AND PRO.CODMAT = IVE.CODMAT
                          LEFT JOIN TT_VEN FAT ON FAT.CODFIL = VEN.CODFIL AND FAT.SEQFAT = VEN.SEQUEN
        WHERE VEN.FLGEST <> 'C'
          AND IVE.SITMOV <> 'C'
          AND CLI.NUMDOC = p_NUMDOC
          AND VEN.DATHOR BETWEEN TO_DATE('01'||SUBSTR(TO_CHAR(TRUNC(AGORA()),'DD/MM/YYYY'),3,8)||' '||'00:00:00','DD/MM/YYYY HH24:MI:SS') AND ADD_DAY(AGORA(),1)
          AND PRO.RETCOF = 'T'
          AND PRO.TIPPRO <> 0
          AND FAT.SEQUEN IS NULL;

       IF (WK_TOTSER + pValorAtual) <= WK_LIMCOF THEN
         RETURN 0;
       END IF;

       SELECT COALESCE(SUM(VEN.VLRCOF),0)
         INTO WK_TOTRET
         FROM TT_CLI CLI INNER JOIN TT_VEN VEN ON VEN.FILCLI = CLI.FILCLI AND VEN.CODCLI = CLI.CODCLI
        WHERE FLGEST <> 'C'
          AND CLI.NUMDOC = p_NUMDOC
          AND VEN.DATHOR BETWEEN TO_DATE('01'||SUBSTR(TO_CHAR(TRUNC(AGORA()),'DD/MM/YYYY'),3,8)||' '||'00:00:00','DD/MM/YYYY HH24:MI:SS') AND ADD_DAY(AGORA(),1);

       WK_TOTRETER := (COALESCE(WK_TOTSER, 0) + pValorAtual ) * (WK_ALIQTA/100);

       IF WK_TOTRETER - WK_TOTRET < 0 THEN
         RETURN 0;
       ELSE
         RETURN WK_TOTRETER - WK_TOTRET;
       END IF;
   ELSE
      RETURN 0;
   END IF;
END;
$$ language 'plpgsql';




/*-- SEQ 1044 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RetencaoImpostos (TD_FIL.CODFIL%TYPE,TT_CLI.NUMDOC%TYPE,TT_VEN.VLRCFI%TYPE,INTEGER) CASCADE;

/*-- SEQ 1045 --*/
CREATE OR REPLACE FUNCTION RetencaoImpostos (TD_FIL.CODFIL%TYPE,TT_CLI.NUMDOC%TYPE,TT_VEN.VLRCFI%TYPE,INTEGER)
RETURNS Numeric AS $$
DECLARE
p_Codfil ALIAS FOR $1 ;
p_Numdoc ALIAS FOR $2 ;
pValorAtual ALIAS FOR $3 ;
p_Tipo ALIAS FOR $4 ;

-- Obs.: 
--  Parmetro pTipo:
--  0 -> PIS
--  1 -> COFINS
--  2 -> Contribuio Social

-- Objetivo
-- Retornar o valor do confins a reter de um determinado cliente
  WK_FLGTIP TT_CLI.FLGTIP%TYPE;
  WK_SIMPLE TT_CLI.SIMPLE%TYPE;
  WK_LIMCOF TD_FIL.LIMCOF%TYPE;
  WK_ALIQTA TD_FIL.PERCOF%TYPE;
  WK_TOTSER TT_IVE.VLRMOV%TYPE;
  WK_TOTRET TT_VEN.VLRCFI%TYPE;
  WK_TOTRETER TT_VEN.VLRCFI%TYPE;

begin

   SELECT FLGTIP, SIMPLE
     INTO WK_FLGTIP, WK_SIMPLE
     FROM TT_CLI
    WHERE NUMDOC = p_NUMDOC;

   SELECT LIMCOF
     INTO WK_LIMCOF
     FROM TD_FIL
    WHERE CODFIL = p_CODFIL;

   SELECT CASE WHEN p_Tipo = 0 THEN COALESCE(PERPIS,0)
               WHEN p_Tipo = 1 THEN COALESCE(PERCOF,0)
               WHEN p_Tipo = 2 THEN COALESCE(PERSOC,0)
          END
     INTO WK_ALIQTA
     FROM TD_FIL
    WHERE CODFIL = p_CODFIL;

   IF WK_FLGTIP = 1 AND WK_SIMPLE = 'F' THEN

       SELECT COALESCE(SUM(IVE.VLRMOV),0)
         INTO WK_TOTSER
         FROM TT_CLI CLI INNER JOIN TT_VEN VEN ON VEN.FILCLI = CLI.FILCLI AND VEN.CODCLI = CLI.CODCLI
                         INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN
                         INNER JOIN TT_PRO PRO ON PRO.FILMAT = IVE.FILMAT AND PRO.CODMAT = IVE.CODMAT
                          LEFT JOIN TT_VEN FAT ON FAT.CODFIL = VEN.CODFIL AND FAT.SEQFAT = VEN.SEQUEN
        WHERE VEN.FLGEST <> 'C'
          AND IVE.SITMOV <> 'C'
          AND CLI.NUMDOC LIKE SUBSTR(p_NUMDOC,1,8)||'%'
          AND VEN.DATHOR BETWEEN TO_DATE('01'||SUBSTR(TO_CHAR(TRUNC(AGORA()),'DD/MM/YYYY'),3,8)||' '||'00:00:00','DD/MM/YYYY HH24:MI:SS') AND ADD_DAY(AGORA(),1)
          AND PRO.RETCOF = 'T'
          AND PRO.TIPPRO <> 0
          AND FAT.SEQUEN IS NULL;

       IF (WK_TOTSER + pValorAtual) <= WK_LIMCOF THEN
         RETURN 0;
       END IF;

       SELECT CASE WHEN p_Tipo = 0 THEN COALESCE(SUM(VEN.VLRPIS),0)
                   WHEN p_Tipo = 1 THEN COALESCE(SUM(VEN.VLRCFI),0)
                   WHEN p_Tipo = 2 THEN COALESCE(SUM(VEN.VLRCSL),0)
              END 
         INTO WK_TOTRET
         FROM TT_CLI CLI INNER JOIN TT_VEN VEN ON VEN.FILCLI = CLI.FILCLI AND VEN.CODCLI = CLI.CODCLI
        WHERE FLGEST <> 'C'
          AND CLI.NUMDOC LIKE SUBSTR(p_NUMDOC,1,8)||'%'
          AND VEN.DATHOR BETWEEN TO_DATE('01'||SUBSTR(TO_CHAR(TRUNC(AGORA()),'DD/MM/YYYY'),3,8)||' '||'00:00:00','DD/MM/YYYY HH24:MI:SS') AND ADD_DAY(AGORA(),1);
          
       WK_TOTRETER := (COALESCE(WK_TOTSER, 0) + pValorAtual ) * (WK_ALIQTA/100);

       IF WK_TOTRETER - WK_TOTRET < 0 THEN
         RETURN 0;
       ELSE
         RETURN WK_TOTRETER - WK_TOTRET;
       END IF;
   ELSE
      RETURN 0;
   END IF;
END;
$$ language 'plpgsql';




/*-- SEQ 1046 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RevisaREC () CASCADE;

/*-- SEQ 1047 --*/
CREATE OR REPLACE FUNCTION RevisaREC ()
RETURNS VARCHAR AS $$
DECLARE

BEGIN
  INSERT INTO TM_REC
  (CODFIL, SEQUEN, NUMPAR, SUBPAR, ATU_EM, DATVEN, CODMOE, FLGEST, 
   VLRPAR, SIGNAT, PORTAD, CARTAO, CODUSU, FILREC, FILUSU, VLRPGT, 
   VLRDES, SEQCHE, PAGAME, NUMECF, CUPFIS, DUMMY , TIPCCC, CODEXT, 
   FLGREC, OBSERV)
  (select REC.CODFIL, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR, REC.ATU_EM, 
          REC.DATVEN, REC.CODMOE, REC.FLGEST, REC.VLRPAR, REC.SIGNAT, 
          REC.PORTAD, REC.CARTAO, REC.CODUSU, REC.FILREC, REC.FILUSU, 
          REC.VLRPGT, REC.VLRDES, REC.SEQCHE, REC.PAGAME, REC.NUMECF, 
          REC.CUPFIS, REC.DUMMY , REC.TIPCCC, REC.CODEXT, 'C',
          'Cancelamento - Subparcelas em TT_REC alem do valor total da venda'
   from tt_rec rec,  tt_rec ori,  tt_ven ven
   where ven.codfil = rec.codfil
     and ven.sequen = rec.sequen
     and ori.codfil = rec.codfil
     and ori.sequen = rec.sequen
     and ori.numpar = rec.numpar
     and trunc(ven.dathor) = trunc(rec.atu_em)
     and ori.subpar = ' 0'
     and ori.cartao is not null
     and ven.vlrliq = ori.vlrpar
     and ori.vlrpar = (COALESCE(ori.vlrpgt,0) + COALESCE(ori.vlrdes,0) )
     and rec.flgest = 'A'
     and rec.cartao is null
     and rec.seqche is null
     and rec.subpar = ' 1');
  
  UPDATE TT_REC SET FLGEST='C'
  WHERE (CODFIL, SEQUEN, NUMPAR, SUBPAR) IN 
   (SELECT CODFIL, SEQUEN, NUMPAR, SUBPAR 
    FROM TM_REC
    WHERE FLGREC = 'C'
      AND DATOPE IS NULL);
  
  INSERT INTO TM_REC
  (CODFIL, SEQUEN, NUMPAR, SUBPAR, ATU_EM, DATVEN, CODMOE, FLGEST, 
   VLRPAR, SIGNAT, PORTAD, CARTAO, CODUSU, FILREC, FILUSU, VLRPGT, 
   VLRDES, SEQCHE, PAGAME, NUMECF, CUPFIS, DUMMY , TIPCCC, CODEXT, 
   FLGREC, OBSERV)
  (select REC.CODFIL, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR, REC.ATU_EM, 
          REC.DATVEN, REC.CODMOE, REC.FLGEST, REC.VLRPAR, REC.SIGNAT, 
          REC.PORTAD, REC.CARTAO, REC.CODUSU, REC.FILREC, REC.FILUSU, 
          REC.VLRPGT, REC.VLRDES, REC.SEQCHE, REC.PAGAME, REC.NUMECF, 
          REC.CUPFIS, REC.DUMMY , REC.TIPCCC, REC.CODEXT, 'P',
          'Pagamento - Subparcelas que efetivamente fazem parte do pagamento parcial'
   from tt_rec rec,  tt_rec ori,  tt_ven ven
   where ven.codfil = rec.codfil
     and ven.sequen = rec.sequen
     and ori.codfil = rec.codfil
     and ori.sequen = rec.sequen
     and ori.numpar = rec.numpar
     and trunc(ven.dathor) = trunc(rec.atu_em)
     and ori.subpar = ' 0'
     and ori.cartao is not null
     and ori.vlrpar + rec.vlrpar = ven.vlrliq
     and rec.flgest = 'A'
     and rec.cartao is null
     and rec.seqche is null
     and rec.subpar = ' 1');
  
  UPDATE TT_REC
  SET FLGEST='P', 
      PAGAME=(SELECT VEN.DATHOR 
              FROM TT_VEN VEN
              WHERE VEN.CODFIL = TT_REC.CODFIL
                AND VEN.SEQUEN = TT_REC.SEQUEN)
  WHERE (CODFIL, SEQUEN, NUMPAR, SUBPAR) IN 
   (SELECT CODFIL, SEQUEN, NUMPAR, SUBPAR 
    FROM TM_REC
    WHERE FLGREC = 'P'
      AND DATOPE IS NULL);
  
  INSERT INTO TM_REC
  (CODFIL, SEQUEN, NUMPAR, SUBPAR, ATU_EM, DATVEN, CODMOE, FLGEST, 
   VLRPAR, SIGNAT, PORTAD, CARTAO, CODUSU, FILREC, FILUSU, VLRPGT, 
   VLRDES, SEQCHE, PAGAME, NUMECF, CUPFIS, DUMMY , TIPCCC, CODEXT, 
   FLGREC, OBSERV)
  (select REC.CODFIL, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR, REC.ATU_EM, 
          REC.DATVEN, REC.CODMOE, REC.FLGEST, REC.VLRPAR, REC.SIGNAT, 
          REC.PORTAD, REC.CARTAO, REC.CODUSU, REC.FILREC, REC.FILUSU, 
          REC.VLRPGT, REC.VLRDES, REC.SEQCHE, REC.PAGAME, REC.NUMECF, 
          REC.CUPFIS, REC.DUMMY , REC.TIPCCC, REC.CODEXT, 'P',
          'Pagamento - Parcelas para Venda ao Consumidor ja pagas'
   from tt_rec rec, tt_ven ven
   where ven.codfil = rec.codfil
     and ven.sequen = rec.sequen
     and (ven.filcli, ven.codcli) = (select vc_filcli, vc_codcli from tt_cfg)
     and rec.flgest = 'A'
     and rec.pagame is not null
     and rec.cartao is null
     and rec.seqche is null
     and rec.tipccc is null
     and rec.vlrpgt = ven.vlrliq );
  
  UPDATE TT_REC
  SET FLGEST='P', 
      PAGAME=(SELECT VEN.DATHOR 
              FROM TT_VEN VEN
              WHERE VEN.CODFIL = TT_REC.CODFIL
                AND VEN.SEQUEN = TT_REC.SEQUEN)
  WHERE (CODFIL, SEQUEN, NUMPAR, SUBPAR) IN 
   (SELECT CODFIL, SEQUEN, NUMPAR, SUBPAR 
    FROM TM_REC
    WHERE FLGREC = 'P'
      AND DATOPE IS NULL);
  
  UPDATE TT_VEN SET FLGEST = 'Y'
  WHERE (CODFIL,SEQUEN) IN 
        (SELECT DISTINCT CODFIL,SEQUEN
         FROM TM_REC
         WHERE DATOPE IS NULL);
  
  UPDATE TM_REC SET DATOPE = agora()
  WHERE DATOPE IS NULL;

  RETURN 'OK';
END;
$$ language 'plpgsql';




/*-- SEQ 1048 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SaldoAberturaDia (TD_FIL.CODFIL%TYPE,TD_ECF.NUMECF%TYPE,Timestamp) CASCADE;

/*-- SEQ 1049 --*/
CREATE OR REPLACE FUNCTION SaldoAberturaDia (TD_FIL.CODFIL%TYPE,TD_ECF.NUMECF%TYPE,Timestamp)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pNUMECF ALIAS FOR $2 ;
pDATEST ALIAS FOR $3 ;

dDATEST TD_FIL.DATEST%TYPE;

BEGIN

SELECT DATEST INTO dDATEST
  FROM TD_FIL
  WHERE CODFIL=pCODFIL
FOR UPDATE;

IF COALESCE(dDATEST,TO_DATE('01/01/2001','DD/MM/YYYY')) < TRUNC(AGORA()) THEN 
	
	/*
    DELETE FROM TT_EST
	WHERE CODFIL = pCODFIL;
	
	INSERT INTO TT_EST (CODFIL, FILMAT, CODMAT, CODCOR, CODTAM, QTDEST)
	(SELECT CODFIL, FILMAT, CODMAT, CODCOR, CODTAM, SUM(QTDEST)
	 FROM TT_SAL
	 WHERE CODFIL = pCODFIL
	 GROUP BY CODFIL, FILMAT, CODMAT, CODCOR, CODTAM);
    */
    
    INSERT INTO TT_EST (CODFIL, FILMAT, CODMAT, CODCOR, CODTAM, QTDEST)
        (SELECT SAL.CODFIL, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, 0
         FROM TT_SAL SAL LEFT JOIN TT_EST EST ON SAL.CODFIL=EST.CODFIL AND SAL.FILMAT=EST.FILMAT AND SAL.CODMAT=EST.CODMAT AND SAL.CODCOR=EST.CODCOR AND SAL.CODTAM=EST.CODTAM
            WHERE EST.CODFIL IS NULL
              AND SAL.CODFIL=pCODFIL
              AND SAL.CODMUL=0
    );


    UPDATE TT_EST EST
    set QTDEST = (SELECT SUM(SAL.QTDEST)
         FROM TT_SAL SAL
         WHERE SAL.CODFIL = EST.CODFIL
               AND SAL.FILMAT=EST.FILMAT
               AND SAL.CODMAT=EST.CODMAT
               AND SAL.CODCOR=EST.CODCOR
               AND SAL.CODTAM=EST.CODTAM)
    where EST.codfil=pCODFIL;

    IF ExisteFilialNaUF('SC') THEN
       UPDATE TT_ASS
          SET QTDREG = (SELECT COUNT(*) FROM TT_EST)
        WHERE NOMTAB = 'TT_EST';
    END IF;
     
	UPDATE TD_FIL
	 SET DATEST = pDATEST,
	     ECFEST = pNUMECF
	 WHERE CODFIL = pCODFIL;

END IF;

RETURN 'OK';

END;
$$ language 'plpgsql';




/*-- SEQ 1050 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SALDOATIVO (TT_SAL.FILMAT%TYPE,TT_SAL.CODMAT%TYPE,TT_SAL.CODCOR%TYPE,TT_SAL.CODTAM%TYPE,TT_SAL.CODMUL%TYPE,TT_SAL.CODFIL%TYPE,TT_SAL.CAL_CM%TYPE) CASCADE;

/*-- SEQ 1051 --*/
CREATE OR REPLACE FUNCTION SALDOATIVO (TT_SAL.FILMAT%TYPE,TT_SAL.CODMAT%TYPE,TT_SAL.CODCOR%TYPE,TT_SAL.CODTAM%TYPE,TT_SAL.CODMUL%TYPE,TT_SAL.CODFIL%TYPE,TT_SAL.CAL_CM%TYPE)
RETURNS Numeric AS $$
DECLARE
PFILMAT ALIAS FOR $1 ;
PCODMAT ALIAS FOR $2 ;
PCODCOR ALIAS FOR $3 ;
PCODTAM ALIAS FOR $4 ;
PCODMUL ALIAS FOR $5 ;
PCODFIL ALIAS FOR $6 ;
PDATREF ALIAS FOR $7 ;
  -- RETORNO 1 = PRODUTO DESATIVADO
  -- RETORNO 0 = PRODUTO ATIVO
  WK_RETORNO Numeric(1);
  WK_NUMREG  Numeric;
BEGIN
  BEGIN
    SELECT CASE WHEN SIGNAT >= 0 THEN 1 ELSE 0 END INTO WK_RETORNO
    FROM TT_PRO 
    WHERE FILMAT = PFILMAT 
      AND CODMAT = PCODMAT; 
                      
       IF NOT FOUND THEN WK_RETORNO := 1;
       END IF;   
      END;

  IF WK_RETORNO = 0 THEN
    SELECT COUNT(*) INTO WK_NUMREG
    FROM TR_MOV MOV 
    WHERE MOV.CODFIL = PCODFIL
      AND MOV.FILMAT = PFILMAT
      AND MOV.CODMAT = PCODMAT
      AND MOV.CODCOR = PCODCOR
      AND MOV.CODTAM = PCODTAM
      AND MOV.CODMUL = PCODMUL
      AND MOV.DATMOV >= TRUNC( PDATREF )
      AND ROWNUM = 1;
    IF WK_NUMREG > 0 THEN
      WK_RETORNO := 1;
    ELSE 
      WK_RETORNO := 0;
    END IF;
  END IF;
  RETURN COALESCE(WK_RETORNO,1);
END;
$$ language 'plpgsql';




/*-- SEQ 1052 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CreditScore_Pontos (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,TT_CRE.COLUNA%TYPE) CASCADE;

/*-- SEQ 1053 --*/
CREATE OR REPLACE FUNCTION CreditScore_Pontos (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,TT_CRE.COLUNA%TYPE)
RETURNS Numeric AS $$
DECLARE
pFilial ALIAS FOR $1 ;
pCodigo ALIAS FOR $2 ;
pColuna ALIAS FOR $3 ;

vCARLOJ VARCHAR(1):=NULL;
vDADCLI VARCHAR(1):=NULL;
vDADCON VARCHAR(1):=NULL;
vDADPRO VARCHAR(1):=NULL;
vDADRES VARCHAR(1):=NULL;
vENDTRA VARCHAR(1):=NULL;
vHISEMP VARCHAR(1):=NULL;
vINFTRA VARCHAR(1):=NULL;
vNUMDOC VARCHAR(1):=NULL;
vTELTRA VARCHAR(1):=NULL;
vTEMAUT VARCHAR(1):=NULL;
vTEMCRE VARCHAR(1):=NULL;
vTEMTAL VARCHAR(1):=NULL;
vTIPRES VARCHAR(1):=NULL;
vCODCEP VARCHAR(5):=NULL;

vCODSEX Numeric(5):=0;
vESTCIV Numeric(5):=0;
vNUMFON Numeric(10):=0;
vCASADO Numeric(5):=0;
vDATNAS Numeric(5):=0;
vTEMRES Numeric(5):=0;
vTEMSER Numeric(5):=0;
VNUMDEP Numeric(5):=0;
vREFPES Numeric(5):=0;
vCARCON Numeric(14,4):=0;
vCARGO  Numeric(14,4):=0;
vALUFIN Numeric(14,4):=0;
vOUTREND Numeric(14,4):=0;

VMDA Numeric(14,4):=0;
VPARPAG Numeric(14,4):=0;
vVLRMDA Numeric(14,4):=0;
vPontosPARPAG  Numeric(5):=0;
VLIMITE Numeric(14,4):=0;
vPerSobreRenda Numeric(14,4):=0;
vRendaFamiliar Numeric(14,4):=0;

vMesesMDA Numeric(5):=0;
vPONTOS Numeric(5):=0;
vTOTAL Numeric(5):=0;
vPerRenCon Numeric(5,2):=0;

vTodos BOOLEAN;

BEGIN

select case when cli.numdoc is not null then 'S'
                                    else 'N' 
       end as numdoc,                                                    --Informou CPF/CNPJ
       coalesce(trunc((trunc(agora())-trunc(cli.datnas))/365),0) as idade,--Idade
       cli.codsex,                                                        --Sexo
       spc.NUMDEP,                                                        --Dependentes
       CASE CLI.ESTCIV WHEN 2 THEN spc.CASMES/12 
                              ELSE 0
       END as CASADO,                                                     --Tempo de casado
       cli.ESTCIV,                                                        --Demais estados civis
       ende.codcep,                                                       --Localizao       
       CASE WHEN SPC.NUMTEL IS NOT NULL THEN 1 ELSE
          CASE WHEN SPC.NUMCEL IS NOT NULL THEN 4 ELSE    
             CASE WHEN  CLI.TELCON IS NOT NULL OR CLI.CELCON IS NOT NULL
                     OR (SELECT MAX(CON.TELCON)                      
                           FROM TT_CON CON
                          WHERE CON.FILCLI=CLI.FILCLI 
                            AND CON.CODCLI=CLI.CODCLI) IS NOT NULL THEN 2
                                               ELSE 3
             END
          END
       END AS NUMFON,                                                      --Tipo de Telefone 
       spc.TIPRES,                                                         --Tipo de Residncia
       spc.MORMES/12 as TEMRES,                                            --Tempo de residncia
       CASE when isnull(TRIM(spc.endere))='T' then 'N'
                                              else 'S'
       END as ENDTRA,                                                      --Informou endereo de trabalho
       least(coalesce(ocu.basocu,9999999),spc.salbas) AS CARGO,
       spc.atumes as TEMSER,                                               --Meses de servio
       CASE when isnull(TRIM(spc.FIRCON))='T' then 'N'
                                              else 'S'
       END as INFTRA,                                                      --Informou endereo de trabalho do conjuge
       least(coalesce(ocuc.basocu,9999999),spc.salbac) AS CARCON,
       (SELECT CASE WHEN PARENT>1 THEN 1 ELSE
           CASE WHEN AMIGO>1 THEN 2 ELSE
               CASE WHEN TRABAL>1 THEN 3 ELSE 4
               END
           END
       END
          FROM (SELECT sum(CASE CLACON WHEN 'F' THEN 1 ELSE 0
                           END) AS PARENT,
                       sum(CASE CLACON WHEN 'P' THEN 1 ELSE 0
                           END) AS AMIGO,
                       sum(CASE CLACON WHEN 'O' THEN 1 ELSE 0
                           END) AS TRABAL,
                       sum(CASE WHEN CLACON <> 'D' THEN 1 ELSE 0
                           END) AS REFERE
                 FROM TT_CON CON INNER JOIN TD_CON DCON ON CON.CODREL=DCON.CODTAB
                WHERE CON.FILCLI=pFILIAL
                  AND CON.CODCLI=pCODIGO
                  AND DCON.TIPCON='F'
               ) TAB
       ) AS REFPES,
       case spc.TEM_TC when 'T' then '2'
                       when 'E' then '1'
                                else '3'
       end as TEMTAL,                                                 --Tem talo de cheques
       case spc.TEM_CC when 'T' then 'S'
                                else 'N'
       end as TEMCRE,                                                 --Tem carto de credito
       case spc.CARLOJ when 'T' then 'S'
                                else 'N'
       end as CARLOJ,                                                 --Tem carto da loja
       case spc.TEMAUT when 'T' then 'S'
                                else 'N'
       end as TEMAUT,                                                 --Tem automovel
       case when isnull(TRIM(spc.NUMTEL))='T' then 'N'
                                         else 'S'
       END as TELTRA,                                                 --Informou telefone de trabalho?       
       CASE TIPRES WHEN 2 THEN 0
                          ELSE ALUFIN
       END as ALUFIN,
       VLRRED as OUTREND
       INTO vNUMDOC,vDATNAS,vCODSEX,vNUMDEP,vCASADO,vESTCIV,vCODCEP,vNUMFON,vTIPRES,vTEMRES,
            vENDTRA,vCARGO,vTEMSER,vINFTRA,vCARCON,vREFPES,vTEMTAL,vTEMCRE,vCARLOJ,vTEMAUT,vTELTRA,vALUFIN,vOUTREND
FROM TT_CLI CLI LEFT OUTER JOIN TT_SPC SPC ON CLI.FILCLI=SPC.FILCLI AND CLI.CODCLI=SPC.CODCLI
                LEFT OUTER JOIN TT_END ENDE ON CLI.FILCLI=ENDE.FILCLI 
                                           AND CLI.CODCLI=ENDE.CODCLI 
                                           AND CLI.FILCLI = ENDE.CODFIL
                                           AND ENDE.NUMEND=1
                LEFT OUTER JOIN TD_OCU OCU ON SPC.CODOCU=OCU.CODTAB
                LEFT OUTER JOIN TD_OCU OCUC ON SPC.CONOCU=OCUC.CODTAB
WHERE CLI.FILCLI=pFilial
  AND CLI.CODCLI=pCodigo;

vPontos:=0;
vTotal:=0;

vTodos:=(pCOLUNA='TOTAL') or (pCOLUNA='LIMITE');

IF pCOLUNA='NUMDOC' or vTodos THEN
    vTotal:=vTotal+Auxcreditscore_pontos_d('NUMDOC',vNUMDOC);    
END IF;

IF pCOLUNA='CODSEX' or vTodos THEN
    vTotal:=vTotal+Auxcreditscore_pontos_f('CODSEX',vCODSEX);    
END IF;

IF pCOLUNA='ESTCIV' or vTodos THEN
    vTotal:=vTotal+Auxcreditscore_pontos_f('ESTCIV',vESTCIV);    
END IF;

IF pCOLUNA='NUMFON' or vTodos THEN
    vTotal:=vTotal+Auxcreditscore_pontos_f('NUMFON',vNUMFON);    
END IF;

IF pCOLUNA='TIPRES' or vTodos THEN
    vTotal:=vTotal+Auxcreditscore_pontos_d('TIPRES',vTIPRES);    
END IF;

IF pCOLUNA='ENDTRA' or vTodos THEN
    vTotal:=vTotal+Auxcreditscore_pontos_d('ENDTRA',vENDTRA);    
END IF;

IF pCOLUNA='TELTRA' or vTodos THEN
    vTotal:=vTotal+Auxcreditscore_pontos_d('TELTRA',vTELTRA);    
END IF;

IF pCOLUNA='CARGO' or vTodos THEN
    vTotal:=vTotal+Auxcreditscore_pontos_F('CARGO',vCARGO);        
END IF;

IF pCOLUNA='INFTRA' or vTodos THEN
    vTotal:=vTotal+Auxcreditscore_pontos_d('INFTRA',vINFTRA);    
END IF;

IF pCOLUNA='REFPES' or vTodos THEN
    vTotal:=vTotal+Auxcreditscore_pontos_f('REFPES',COALESCE(vREFPES,4));    
END IF;

IF pCOLUNA='TEMTAL' or vTodos THEN
    vTotal:=vTotal+Auxcreditscore_pontos_d('TEMTAL',vTEMTAL);        
END IF;

IF pCOLUNA='TEMCRE' or vTodos THEN
    vTotal:=vTotal+Auxcreditscore_pontos_d('TEMCRE',vTEMCRE);        
END IF;

IF pCOLUNA='CARLOJ' or vTodos THEN
    vTotal:=vTotal+Auxcreditscore_pontos_d('CARLOJ',vCARLOJ);        
END IF;

IF pCOLUNA='TEMAUT' or vTodos THEN
    vTotal:=vTotal+Auxcreditscore_pontos_d('TEMAUT',vTEMAUT);        
END IF;

IF pCOLUNA='DATNAS' or vTodos THEN
    vTotal:=vTotal+Auxcreditscore_pontos_F('DATNAS',vDATNAS);        
END IF;

IF pCOLUNA='CASADO' or vTodos THEN
    vTotal:=vTotal+Auxcreditscore_pontos_F('CASADO',vCASADO);
END IF;

IF pCOLUNA='CODCEP' or vTodos THEN
    vTotal:=vTotal+Auxcreditscore_pontos_d('CODCEP',vCODCEP);  
END IF;

IF pCOLUNA='TEMRES' or vTodos THEN
    vTotal:=vTotal+Auxcreditscore_pontos_F('TEMRES',vTEMRES);  
END IF;

IF pCOLUNA='TEMSER' or vTodos THEN
    vTotal:=vTotal+Auxcreditscore_pontos_F('TEMSER',vTEMSER);  
END IF;

IF pCOLUNA='CODDEP' or vTodos THEN
    vTotal:=vTotal+(Auxcreditscore_pontos_V('CODDEP')*coalesce(vNUMDEP,0));  
END IF;

IF pCOLUNA='CARCON' or vTodos THEN
    vPerRenCon:=Auxcreditscore_pontos_F('CARCON',vCARCON)/100;   -- busca o percentual
END IF;

IF pCOLUNA='MESMDA' or 
   pCOLUNA='PARPAG' or 
   pCOLUNA='VLRMDA' or 
   pCOLUNA='TOTAL'THEN
    vMesesMDA:=Auxcreditscore_pontos_V('MESMDA');    
END IF;

IF pCOLUNA='MESMDA' THEN
   Return vMesesMDA;
END IF;

IF pCOLUNA='PARPAG' or pCOLUNA='VLRMDA' or vTodos THEN
    
    SELECT COUNT(*), AVG(TRUNC(REC.PAGAME)-TRUNC(REC.DATVEN)) INTO vPARPAG, vVLRMDA
  FROM tt_rec rec inner join tt_ven ven on rec.codfil=ven.codfil and rec.sequen=ven.sequen
 WHERE VEN.FILCLI=pFilial
   AND VEN.CODCLI=pCodigo
   AND VEN.FLGEST<>'C'
   AND REC.FLGEST='P' 
   AND VEN.DATHOR >= add_months(agora(),vMesesMDA*-1);
    
   vPontosPARPAG:=Auxcreditscore_pontos_F('PARPAG',vPARPAG);
   
   IF pCOLUNA='PARPAG' THEN
      vTotal:=vTotal+vPontosPARPAG;
   END IF;
    
END IF;

IF pCOLUNA='VLRMDA' or vTodos THEN
    vTotal:=vTotal+Auxcreditscore_pontos_F('VLRMDA',vVLRMDA)*vPontosPARPAG;
END IF;

IF pCOLUNA='MAXPAR' THEN  
   Return round(coalesce(vCARGO,0)*Auxcreditscore_pontos_V('MAXPAR')/100,2);
END IF;

IF pCOLUNA='LIMMAX' THEN  
   Return Auxcreditscore_pontos_V('LIMMAX');
END IF;

IF pCOLUNA='MAXPRI' THEN  
   Return Auxcreditscore_pontos_V('MAXPRI');
END IF;

IF pCOLUNA='LIMATR' THEN  
   Return Auxcreditscore_pontos_V('LIMATR');
END IF;

IF pCOLUNA='SEMLIM' THEN  
   Return Auxcreditscore_pontos_V('SEMLIM');
END IF;

IF pCOLUNA='LIMITE' THEN        
    vPerSobreRenda:=Auxcreditscore_pontos_F('LIMITE',vTotal);
    vRendaFamiliar:=coalesce(vCARGO,0)+
                    coalesce(vOUTREND,0)+
                    (coalesce(vCARCON,0)*vPerRenCon)-
                    coalesce(vALUFIN,0);
    vLimite:=round(vPerSobreRenda*vRendaFamiliar/100,2);
    IF vLimite<0 THEN 
       vLimite:=0;
    END IF;
    return vLimite;
ELSE 
    Return vTotal;
END IF;
  
END;
$$ language 'plpgsql';




/*-- SEQ 1054 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SeparaNomes (VARCHAR,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1055 --*/
CREATE OR REPLACE FUNCTION SeparaNomes (VARCHAR,VARCHAR,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pTexto ALIAS FOR $1 ;
pUltimoNome ALIAS FOR $2 ;
pVerifica ALIAS FOR $3 ;
pSeparador ALIAS FOR $4 ;
  Palavras VARCHAR [];

  Posicoes INTEGER [];
  Tamanhos INTEGER [];
  Temp VARCHAR [];

  j           INTEGER;
  i           INTEGER;
  x           INTEGER;
  y           INTEGER;
  bTemFilho   BOOLEAN;
  bUltimoNome BOOLEAN;
  bVerifica   BOOLEAN;
  cTexto      VARCHAR(255);
  cPedaco     VARCHAR(255);
  cRetorno    VARCHAR(255);
  cVerdade    CHAR(27);
BEGIN
  if pTexto is null then
    RETURN NULL;   
  end if;

  for iarray in 1..20 loop
  if iarray = 1 then
    select array [0] into Posicoes;
    select array [0] into Tamanhos;
    select array [''] into Palavras;
    select array [''] into Temp;
  else
    select array_append(Posicoes,0) into Posicoes;
    select array_append(Tamanhos,0) into Tamanhos;
    select array_append(Palavras,'') into Palavras;
    select array_append(Temp,'') into Temp;
  end if;
end loop;

  j := 0;
  i := 0;
  cVerdade := 'YES/TRUE/SIM/Y/S/V/T/.T./1/';

  if instr(cVerdade,upper(trim(pUltimoNome))||'/') <> 0 then
    bUltimoNome := True;
  else
    bUltimoNome := False;
  end if;

  if instr(cVerdade,upper(trim(pVerifica))||'/') <> 0 then
    bVerifica := True;
  else
    bVerifica := False;
  end if;

  cRetorno := '';

  cTexto := ' '||trim(pTexto)||' ';
  for i in 1..length(cTexto) loop
    if SUBSTR(cTexto,i,1) = pSeparador then
      j := j + 1;
      Posicoes [j] := i;

    end if;
  end loop;

  for i in 1..j loop
    y := ((Posicoes [i+1] + 1) - Posicoes [i]) - 1;
    Tamanhos [i] := y;

  end loop;

  for i in 1..j loop
    cPedaco := SUBSTR(cTexto,Posicoes [i],Tamanhos [i]);
    Palavras [i] := cPedaco;

  end loop;

  x := 0;

  for i in 1..j loop
    cPedaco := Palavras [i];
    if (cPedaco IS NULL) or (cPedaco <> ' ') then
      Temp [i-x] := cPedaco;

    else
      x := x + 1;
    end if;
  end loop;

  j := j - x;
 
  for i in 1..j loop
    cPedaco := trim(Temp [i]);
    Palavras [i] := cPedaco;

  end loop;

  cRetorno := Upper(Palavras [j-1]);

  if (cRetorno = 'FILHO')    or
     (cRetorno = 'FILHA')    or
     (cRetorno = 'NETO')     or
     (cRetorno = 'NETA')     or
     (cRetorno = 'SOBRINHO') or
     (cRetorno = 'SOBRINHA') or
     (cRetorno = 'JUNIOR')   or
     (cRetorno = 'JNIOR')   or
     (cRetorno = 'JR.')      or
     (cRetorno = 'JR') then
     bTemFilho := true;
  else
     bTemFilho := false;
  end if;

  cRetorno := '';

  if bUltimoNome then
    if bTemFilho then
      if j >= 4 then
        cRetorno := Palavras [j-2]||' '||Palavras [j-1];
      else
        cRetorno := '';
      end if;
    else
      cRetorno := Palavras [j-1];
    end if;
  else
    if bTemFilho then
      if j >= 4 then
        for i in 1..(j-3) loop
          cRetorno := cRetorno||' '||Palavras [i];
        end loop;
      else
        cRetorno := '';
      end if;
    else
      for i in 1..(j-2) loop
        cRetorno := cRetorno||' '||Palavras [i];
      end loop;
    end if;
    cRetorno := trim(cRetorno);
  end if;

  if (j <= 2) and (bVerifica) then
    cRetorno := '';
  end if;

  RETURN cRetorno;
END;
$$ language 'plpgsql';


/*-- SEQ 1056 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SeparaNomes (VARCHAR) CASCADE;

/*-- SEQ 1057 --*/
CREATE OR REPLACE FUNCTION SeparaNomes (VARCHAR) 
RETURNS VARCHAR AS $$
BEGIN
RETURN SeparaNomes($1,'T','T',' ');
END;
$$ language 'plpgsql';


/*-- SEQ 1058 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SeparaNomes (VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1059 --*/
CREATE OR REPLACE FUNCTION SeparaNomes (VARCHAR,
                               VARCHAR) 
RETURNS VARCHAR AS $$
BEGIN
RETURN SeparaNomes($1,$2,'T',' ');
END;
$$ language 'plpgsql';


/*-- SEQ 1060 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SeparaNomes (VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1061 --*/
CREATE OR REPLACE FUNCTION SeparaNomes (VARCHAR,
                               VARCHAR,
                               VARCHAR) 
RETURNS VARCHAR AS $$
BEGIN
RETURN SeparaNomes($1,$2,$3,' ');
END;
$$ language 'plpgsql';


/*-- SEQ 1062 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CriaSubparTitulo (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE,TT_TIT.CODBCO%TYPE,TT_TIT.NUMAGE%TYPE,TT_TIT.CTACRR%TYPE,TT_TIT.JURDES%TYPE,TT_TIT.CODDES%TYPE,TT_TIT.DATDES%TYPE,TT_TIT.VLRORI%TYPE) CASCADE;

/*-- SEQ 1063 --*/
CREATE OR REPLACE FUNCTION CriaSubparTitulo (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE,TT_TIT.CODBCO%TYPE,TT_TIT.NUMAGE%TYPE,TT_TIT.CTACRR%TYPE,TT_TIT.JURDES%TYPE,TT_TIT.CODDES%TYPE,TT_TIT.DATDES%TYPE,TT_TIT.VLRORI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
vFILREC ALIAS FOR $1 ;
VSEQREC ALIAS FOR $2 ;
vPARREC ALIAS FOR $3 ;
vSUBREC ALIAS FOR $4 ;
vCODBCO ALIAS FOR $5 ;
vNUMAGE ALIAS FOR $6 ;
vCTACRR ALIAS FOR $7 ;
vJURDES ALIAS FOR $8 ;
vCODDES ALIAS FOR $9 ;
vDATDES ALIAS FOR $10 ;
vVLRORI ALIAS FOR $11 ;

   vTOLERANCIA                   TT_REC.VLRPAR%TYPE;
   vVALOR_COM_DESCONTO           TT_REC.VLRPAR%TYPE;
   vVLRPAGAR                     TT_REC.VLRPAR%TYPE;
   WK_DIAPRO                     TT_CTB.DIAPRO%TYPE;
   WK_PERPRO                     TT_CTB.PERPRO%TYPE;
   WK_NUMPRO                     TT_CTB.NUMPRO%TYPE;
   vACHOU                        BOOLEAN;
   WK_DATPRO                     Timestamp;
   WK_JURPRO                     TT_CTB.PERPRO%TYPE;
   WK_REC                        TT_REC%ROWTYPE;
   vVEM_DE_TGRTB                 CONSTANT VARCHAR(100) := constante('vem_de_tgrtb');
   WK_FERIADOS                   Numeric(10);
   WK_DATDES                     Timestamp;
   WK_COBPAD                     TT_REC.PORTAD%TYPE;
   
BEGIN
   WK_DATDES:= VDATDES;

   SELECT CODFIL,SEQUEN,NUMPAR,FLGEST,ATU_EM,DATVEN,VLRPAR,CODMOE,PORTAD,SIGNAT,SEQCHE,CODUSU,
            FILREC,FILUSU,NUMECF,CUPFIS,PAGAME,VLRDES,VLRPGT,CARTAO,DUMMY,TIPCCC,SUBPAR,VLRTAX 
     INTO WK_REC.CODFIL,WK_REC.SEQUEN,WK_REC.NUMPAR,WK_REC.FLGEST,WK_REC.ATU_EM,WK_REC.DATVEN,
            WK_REC.VLRPAR,WK_REC.CODMOE,WK_REC.PORTAD,WK_REC.SIGNAT,WK_REC.SEQCHE,WK_REC.CODUSU,
            WK_REC.FILREC,WK_REC.FILUSU,WK_REC.NUMECF,WK_REC.CUPFIS,WK_REC.PAGAME,WK_REC.VLRDES,
            WK_REC.VLRPGT,WK_REC.CARTAO,WK_REC.DUMMY,WK_REC.TIPCCC,WK_REC.SUBPAR,WK_REC.VLRTAX
    FROM TT_REC
   WHERE VFILREC =  CODFIL
     AND VSEQREC =  SEQUEN
     AND VPARREC =  NUMPAR
     AND VSUBREC =  SUBPAR;

   SELECT COALESCE(DIAPRO,0), COALESCE(PERPRO,0), COALESCE(NUMPRO,0)
     INTO WK_DIAPRO, WK_PERPRO, WK_NUMPRO
     FROM TT_CTB
    WHERE CODBCO = VCODBCO
      AND NUMAGE = VNUMAGE
      AND CTACRR = VCTACRR;


   IF  (VJURDES  > 0)
   AND (VCODDES in (1,2) ) THEN--sero tratados somente 1 e 2
      vVALOR_COM_DESCONTO:= 0;
      vACHOU:= FALSE;
      IF VCODDES = 1 THEN --1 - valor fixo at data informada  
         vVALOR_COM_DESCONTO := WK_REC.VLRPAR - VJURDES;  
      ELSIF VCODDES = 2 THEN --2 - percentual at data informada
         vVALOR_COM_DESCONTO := WK_REC.VLRPAR - (WK_REC.VLRPAR * (VJURDES/100));  
      END IF;

      --41809 verificar se data para desconto  feriado e acrescentar 1 dia
      SELECT COUNT(*) INTO WK_FERIADOS FROM TT_FER
       WHERE DIAFER = TO_NUMBER(TO_CHAR(WK_DATDES,'DD'))
         AND MESFER = TO_NUMBER(TO_CHAR(WK_DATDES,'MM'))
         AND ((FILFER IS NULL) OR (FILFER = WK_REC.CODFIL))    
         AND ((ANOFER = TO_NUMBER(TO_CHAR(WK_DATDES,'YYYY'))) OR (ANOFER IS NULL));

      IF WK_FERIADOS > 0 THEN  WK_DATDES:= add_day(WK_DATDES,1); END IF; --FERIADO

      --41809 verificar se data para desconto  sabado ou domingo e acrescenta 1 ou 2 dias para PAGAMEnto
      IF TO_CHAR(WK_DATDES,'D') = '7' THEN  WK_DATDES:= add_day(WK_DATDES,2); END IF; --sabado
      IF TO_CHAR(WK_DATDES,'D') = '1' THEN  WK_DATDES:= add_day(WK_DATDES,1); END IF; --domingo


      IF WK_REC.PAGAME <= WK_DATDES THEN--pagamento antes da data definida para Desconto 
         vACHOU:= TRUE;
      END IF;

      /* Descontos Regressivos*/
      WK_DATPRO := add_day(WK_REC.DATVEN,WK_DIAPRO);
      WK_JURPRO := VJURDES;
      FOR i IN 1..WK_NUMPRO LOOP
         wk_JURPRO := ROUND(WK_JURPRO - (VJURDES * (WK_PERPRO/100)),2);
         IF WK_JURPRO > 0 THEN
            IF (WK_REC.PAGAME <= WK_DATPRO ) AND (vACHOU = FALSE) THEN--DIA DO PAGAMENTO = p_PAGAME
               vVALOR_COM_DESCONTO := WK_REC.VLRPAR - (WK_REC.VLRPAR * (WK_JURPRO/100));  
               vACHOU:= true;
            END IF;
         END IF;
         WK_DATPRO := add_day(WK_DATPRO,WK_DIAPRO);
      END LOOP;
   ELSE
      vVALOR_COM_DESCONTO:= WK_REC.VLRPAR ;
   END IF;

   SELECT COALESCE(VALORTOLERANCIA,0) INTO vTOLERANCIA FROM TT_CFG;

   SELECT COALESCE(COBPAD,0) into WK_COBPAD FROM TD_COB
    WHERE CODTAB = WK_REC.PORTAD;

   IF ((WK_REC.VLRPGT + COALESCE(WK_REC.VLRTAX,0)) < vVALOR_COM_DESCONTO) THEN
      IF (WK_REC.VLRPGT + COALESCE(WK_REC.VLRTAX,0)) < (vVALOR_COM_DESCONTO - vTOLERANCIA) THEN
         -- DN - CALCULAR O VALOR QUE ATUALIZADO DARA O VALOR QUE FALTOU PAGAR
         -- EX.
         -- VALOR DA PARCELA 1000
         -- VALOR COM JUROS 1300
         -- VALOR PAGO 1100
         -- FALTA ENTAO 200
         -- POREM TEM QUE SER CRIADA UMA PARCELA QUE CORRIGIDA DA O VALOR DE 200 HOJE
         -- ASSIM O VALOR DA PARCELA DEVERA SER 153.85 QUE CORRIGIDO DAH HOJE 200
         vVLRPAGAR:=  (vVALOR_COM_DESCONTO - (WK_REC.VLRPGT + COALESCE(WK_REC.VLRTAX,0)))/(vVALOR_COM_DESCONTO/WK_REC.VLRPAR);
            
         UPDATE TT_REC SET VLRDES=0, DUMMY  = Constante('VEM_DE_TGRTB')
          WHERE CODFIL=vFILREC
            AND SEQUEN=vSEQREC
            AND NUMPAR=vPARREC
            AND SUBPAR=vSUBREC;
         
         INSERT INTO TT_REC (CODFIL,SEQUEN,NUMPAR,FLGEST,ATU_EM,DATVEN,VLRPAR,CODMOE,PORTAD,SIGNAT,SUBPAR,SUBORI,DUMMY)
            (SELECT WK_REC.CODFIL,WK_REC.SEQUEN,WK_REC.NUMPAR,'A',agora(),WK_REC.DATVEN,vVLRPAGAR,
    					  WK_REC.CODMOE,WK_COBPAD,WK_REC.SIGNAT,LPAD(TO_CHAR(to_number(WK_REC.SUBPAR)+1),2),WK_REC.SUBPAR,vVEM_DE_TGRTB FROM DUAL);
    					  
      END IF;
   END IF;

   RETURN 'OK';

END;
$$ language 'plpgsql';





/*-- SEQ 1064 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_Aux_ExisteTitulo (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE) CASCADE;

/*-- SEQ 1065 --*/
CREATE OR REPLACE FUNCTION TGR_Aux_ExisteTitulo (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE)
RETURNS boolean AS $$
DECLARE
p_CODFIL ALIAS FOR $1 ;
p_SEQUEN ALIAS FOR $2 ;
p_NUMPAR ALIAS FOR $3 ;
  wk_DUMMY INTEGER;
BEGIN
  SELECT COUNT(*)
    INTO wk_DUMMY
    FROM TT_TIT
   WHERE FILREC = p_CODFIL
     and SEQREC = p_SEQUEN
     and PARREC = p_NUMPAR
     and SEQCAN IS NULL;

    RETURN (wk_DUMMY > 0);

END;
$$ language 'plpgsql';




/*-- SEQ 1066 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_CalculaBonus (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE) CASCADE;

/*-- SEQ 1067 --*/
CREATE OR REPLACE FUNCTION TGR_CalculaBonus (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE)
RETURNS TT_CLI.SALBON%TYPE AS $$
DECLARE
pFILCLI ALIAS FOR $1 ;
pCODCLI ALIAS FOR $2 ;
-- Objetivos
-- Calculo de bonus
  Saldo TT_CLI.SALBON%TYPE;
BEGIN
  SELECT SUM(COALESCE(VLRLAN,0)) INTO Saldo
  FROM TT_BON
  WHERE FILCLI = pFILCLI
    AND CODCLI = pCODCLI;

  RETURN Saldo;
END;
$$ language 'plpgsql';




/*-- SEQ 1068 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_ConsistirTitulos (TT_TIT.CODFIL%TYPE,TT_TIT.SEQUEN%TYPE,TT_TIT.FILREC%TYPE,TT_TIT.SEQREC%TYPE,TT_TIT.PARREC%TYPE,TT_TIT.SUBREC%TYPE,TT_TIT.CODBCO%TYPE,TT_TIT.NUMAGE%TYPE,TT_TIT.CTACRR%TYPE,TT_TIT.CODECB%TYPE,TT_TIT.CODCCB%TYPE,TT_TIT.NOSNUM%TYPE,TT_TIT.CODREM%TYPE) CASCADE;

/*-- SEQ 1069 --*/
CREATE OR REPLACE FUNCTION TGR_ConsistirTitulos (TT_TIT.CODFIL%TYPE,TT_TIT.SEQUEN%TYPE,TT_TIT.FILREC%TYPE,TT_TIT.SEQREC%TYPE,TT_TIT.PARREC%TYPE,TT_TIT.SUBREC%TYPE,TT_TIT.CODBCO%TYPE,TT_TIT.NUMAGE%TYPE,TT_TIT.CTACRR%TYPE,TT_TIT.CODECB%TYPE,TT_TIT.CODCCB%TYPE,TT_TIT.NOSNUM%TYPE,TT_TIT.CODREM%TYPE)
RETURNS VARCHAR AS $$
DECLARE
PCODFIL ALIAS FOR $1 ;
PSEQUEN ALIAS FOR $2 ;
PFILREC ALIAS FOR $3 ;
PSEQREC ALIAS FOR $4 ;
PPARREC ALIAS FOR $5 ;
PSUBREC ALIAS FOR $6 ;
PCODBCO ALIAS FOR $7 ;
PNUMAGE ALIAS FOR $8 ;
PCTACRR ALIAS FOR $9 ;
PCODECB ALIAS FOR $10 ;
PCODCCB ALIAS FOR $11 ;
PNOSNUM ALIAS FOR $12 ;
PCODREM ALIAS FOR $13 ;
   -- dominio dos erros.
   -- A -> CGC da filial nula.
   -- B -> Conta bancaria invalida
   -- C -> Banco invalido
   -- D -> Carteira inexistente ou invalida
   -- E -> Especie inexistente ou invalida
   -- F -> Moeda inexistente ou invalida
   -- G -> Remessa invalida ou nao cadastrada para este banco.
   -- H -> Retornos com erro
   -- I -> Nosso numero em branco
   -- J -> Instrucao padrao de Cancelamento de Titulo esta em branco
   -- K -> Instrucao padrao de Alteracao de Data esta em branco
   -- L -> Instrucao padrao de Alteracao de Outros Valores esta em branco
   -- M -> Instrucao padrao de Pagamento em Carteira esta em branco
   -- N -> Instrucao padrao de Inclusao de Titulo esta em branco
   -- O -> Instrucao padrao de Concessao de desconto esta em branco
   -- P -> Instrucao padrao de cancelamento de desconto esta em branco
   -- Q -> Instrucao padrao de Protesto de titulo esta em branco
   -- R -> Instrucao padrao de Sustar e baixar protesto esta em branco
   -- S -> Instrucao padrao de Sustar e Manter o protesto em carteira esta em branco

   WK_CONTA Numeric(10);
   wk_rem record;

   wk_erro VARCHAR(2);

   WK_CGCFIL TD_FIL.CGCFIL%TYPE;
   WK_ENVREM          CHAR(1);
   WK_CONTA_P Numeric(10);
   

   
 Begin
   WK_ENVREM := 'F';

   select INT_CAN_TIT, INT_ALT_DAT, INT_ALT_VLR,
          INT_PAG_CAR, INT_INC_TIT, INT_CON_DES,
          INT_CAN_DES, INT_PRT_TIT, INT_S_B_PRT,
          INT_S_C_PRT
   into   wk_Rem
   from tt_cfg;

   wk_erro := NULL;

    -- CGC da filial nula.
   SELECT CGCFIL into WK_CGCFIL
     FROM TD_FIL FIL
   WHERE PCODFIL = FIL.CODFIL
     AND FIL.CGCFIL IS NOT NULL;

   IF (ISNULL(TRIM(WK_CGCFIL)) = 'T')
   OR (WK_CGCFIL IS NULL) THEN
     wk_erro := 'A';
   END IF;

   -- Conta bancaria invalida
   IF  ISNULL(wk_erro)='T' THEN
     SELECT COUNT(*) INTO WK_CONTA FROM TT_CTB CTB
     WHERE PNUMAGE = CTB.NUMAGE
       AND PCODBCO = CTB.CODBCO
       AND PCTACRR = CTB.CTACRR;

     IF WK_CONTA = 0 THEN
       wk_erro := 'B';
     END IF;
   END IF;

   -- Banco invalido
   IF ISNULL(wk_erro)='T' THEN
     SELECT COUNT(*) INTO WK_CONTA FROM TD_BCO BCO
     WHERE PCODBCO = BCO.CBANCO;

     IF WK_CONTA = 0 THEN
       wk_erro := 'C';
     END IF;
   END IF;

   -- Carteira inexistente ou invalida
   IF ISNULL(wk_erro)='T' THEN
     SELECT COUNT(*) INTO WK_CONTA FROM TT_CCB CCB
     WHERE PCODBCO = CCB.CODBCO
       AND PCODCCB = CCB.CODCCB
       AND  CCB.CARBCO IS NOT NULL
       AND PCODCCB IS NOT NULL;

     SELECT COALESCE(ENVREM,'F') INTO WK_ENVREM FROM TD_CCB CCB
     WHERE pCODCCB = CCB.CODTAB
       AND pCODCCB IS NOT NULL;

     IF WK_CONTA = 0 THEN
       wk_erro := 'D';
     END IF;
   END IF;

   -- Especie inexistente ou invalida
   IF ISNULL(wk_erro)='T' THEN
     SELECT COUNT(*) INTO WK_CONTA FROM TT_ECB ECB
     WHERE PCODBCO = ECB.CODBCO
       AND PCODECB = ECB.CODECB
       AND  ECB.ECBBCO IS NOT NULL
       AND PCODECB IS NOT NULL;

     IF WK_CONTA = 0 THEN
       wk_erro := 'E';
     END IF;
   END IF;


   -- Ocorrencia Invalida ou nao cadastrada para este banco.
   IF ISNULL(wk_erro)='T' THEN
     SELECT COUNT(*) INTO WK_CONTA FROM TT_REM REM
     WHERE PCODBCO = REM.CODBCO
       AND  REM.OCOBCO IS NOT NULL
       AND (PCODREM = REM.CODREM OR PCODREM IS NULL);

     IF WK_CONTA = 0 THEN
       wk_erro := 'G';
     END IF;
   END IF;

   -- Retornos com erro
   IF ISNULL(wk_erro)='T' THEN
    
         SELECT COUNT(*)
           INTO WK_CONTA
           FROM TT_RTB
          WHERE TRIM(IDEEMP) = TRIM(PCODFIL||'/'||TRIM(PSEQUEN))
           AND FLGEST = 'E';

         SELECT COUNT(*)
           INTO WK_CONTA_P
           FROM TT_RTB
          WHERE TRIM(IDEEMP) = TRIM(PCODFIL||'/'||TRIM(PSEQUEN))
           AND FLGEST = 'P';

   
         IF (WK_CONTA > 0)  AND (WK_CONTA_P = 0)  THEN
            wk_erro := 'H';
         END IF;
    
        
   END IF;

   -- Nosso numero em branco
   IF  (ISNULL(wk_erro)='T')
   AND (ISNULL(PNOSNUM)='T') THEN
     wk_erro := 'I';
   END IF;

   -- instrucao padrao de Cancelamento de Titulo esta em branco
   IF (ISNULL(wk_erro)='T')
   AND (wk_rem.INT_CAN_TIT IS NULL) THEN
     wk_erro := 'J';
   END IF;

   -- instrucao padrao de Alteracao de Data esta em branco
   IF (ISNULL(wk_erro)='T')
   AND (wk_rem.INT_ALT_DAT IS NULL) THEN
     wk_erro := 'K';
   END IF;

   -- instrucao padrao de Alteracao de Outros Valores esta em branco
   IF (ISNULL(wk_erro)='T')
   AND (wk_rem.INT_ALT_VLR IS NULL) THEN
     wk_erro := 'L';
   END IF;

   -- instrucao padrao de Pagamento em Carteira esta em branco
   IF (ISNULL(wk_erro)='T')
   AND (wk_rem.INT_PAG_CAR IS NULL) THEN
     wk_erro := 'M';
   END IF;

   -- instrucao padrao de Inclusao de Titulo esta em branco
   IF (ISNULL(wk_erro)='T')
   AND (wk_rem.INT_INC_TIT IS NULL) THEN
     wk_erro := 'N';
   END IF;

   -- instrucao padrao de Concessao de desconto esta em branco
   IF  (ISNULL(wk_erro)='T')
   AND (wk_rem.INT_CON_DES IS NULL) THEN
     wk_erro := 'O';
   END IF;

   -- instrucao padrao de cancelamento de desconto esta em branco
   IF (ISNULL(wk_erro)='T')
   AND (wk_rem.INT_CAN_DES IS NULL) THEN
     wk_erro := 'P';
   END IF;

   -- instrucao padrao de Protesto de titulo esta em branco
   IF (ISNULL(wk_erro)='T')
   AND (wk_rem.INT_PRT_TIT IS NULL) THEN
     wk_erro := 'Q';
   END IF;

   -- instrucao padrao de Sustar e baixar protesto esta em branco
   IF (ISNULL(wk_erro)='T')
   AND (wk_rem.INT_S_B_PRT IS NULL) THEN
     wk_erro := 'R';
   END IF;

   -- instrucao padrao de Sustar e Manter o protesto em carteira esta em branco
   IF (ISNULL(wk_erro)='T')
   AND (wk_rem.INT_S_C_PRT IS NULL) THEN
     wk_erro := 'S';
   END IF;

   -- Neste caso (nehuma inconsistencia encontrada) eh gerado o retorno false com U pois o F
   -- j esta sendo utilizado acima!  
   IF (ISNULL(wk_erro)<>'T') THEN
     return wk_erro;
   ELSE wk_erro := 'U';
   END IF;

   return wk_erro||WK_ENVREM;
END;
$$ language 'plpgsql';




/*-- SEQ 1070 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_CorpoEmail (TT_SUP.CODFIL%TYPE,TT_SUP.SEQUEN%TYPE,TT_CON.FILCLI%TYPE,TT_CON.CODCLI%TYPE,TT_CON.NUMCON%TYPE,TT_MSG.MSGSUP%TYPE,TT_CFG.SAC_HOME_PAGE%TYPE) CASCADE;

/*-- SEQ 1071 --*/
CREATE OR REPLACE FUNCTION TGR_CorpoEmail (TT_SUP.CODFIL%TYPE,TT_SUP.SEQUEN%TYPE,TT_CON.FILCLI%TYPE,TT_CON.CODCLI%TYPE,TT_CON.NUMCON%TYPE,TT_MSG.MSGSUP%TYPE,TT_CFG.SAC_HOME_PAGE%TYPE)
RETURNS Text AS $$
DECLARE
pFILSUP ALIAS FOR $1 ;
pSEQSUP ALIAS FOR $2 ;
pFILCLI ALIAS FOR $3 ;
pCODCLI ALIAS FOR $4 ;
pNUMCON ALIAS FOR $5 ;
pMSGSUP ALIAS FOR $6 ;
pHOMEPAGE ALIAS FOR $7 ;
   TEMP TEXT;
   wk_MSGSUP VARCHAR(4000);
   WK_CONTA Numeric(5);
  cLF           char(6)            := to_path('/par')||chr(13)||chr(10);
  Nulo CONSTANT char(1)            := '0';
  cE            char(1)            := chr(38);

  wk_contat     TT_CON.CONTAT%TYPE;
  wk_numdoc     TT_CLI.NUMDOC%TYPE;

  -- Flags utilizadas na transformao feita pelo TTSMTP para HTML
  cRecomecar    char(25)               := to_path('/RECOMECAR23464611717')||chr(13)||chr(10); -- Utilizada como flag para recomear o processamento do RTF
  -- O Recomecar ir unir vrios textos RTF, fazendo com que zere-se o cadastro de fontes e cores que ele tem entre outros itens.

  cAbreLink     char(10)               := to_path('/LINK28300');
  cFechaLink    char(10)               := to_path('/LINK28301');
  -- Para utilizar um Link faa:
  -- cAbreLink || Endereo entre aspas || nome a ficar visvel || cFechaLink
  -- Ex: cAbreLink || ' "www.totall.com.br" ' || 'TOTALL.COM S.A.' || cFechaLink;

     cr_workflows CURSOR FOR
     SELECT wor.CODFIL, wor.SEQUEN, wor.TAREFA, wor.DESTAR FROM TT_WOR WOR, TT_SUPXWOR SXW
     WHERE WOR.CODFIL = SXW.FILWOR
       AND WOR.SEQUEN = SXW.SEQWOR
       AND SXW.FILSUP = pFILSUP
       AND SXW.SEQSUP = pSEQSUP;
  WF             Record;
  
  
BEGIN
  -- Traz o NUMDOC e o contato para o link para o site
  SELECT COALESCE(min(CON.CONTAT),'###'), TRIM(min(CLI.NUMDOC)) INTO WK_CONTAT, WK_NUMDOC
  FROM TT_CLI CLI, TT_CON CON, (select Pfilcli as filcli,
                                       Pcodcli as codcli,
                                       PNumcon as numcon from dual) int
  WHERE CLI.FILCLI = CON.FILCLI
    AND CLI.CODCLI = CON.CODCLI
    AND CON.FILCLI = INT.FILCLI
    AND CON.CODCLI = INT.CODCLI
    AND CON.NUMCON = INT.NUMCON;

  SELECT count(*) into WK_CONTA FROM TT_WOR WOR, TT_SUPXWOR SXW
  WHERE WOR.CODFIL = SXW.FILWOR
     AND WOR.SEQUEN = SXW.SEQWOR
     AND SXW.FILSUP = PFILSUP
     AND SXW.SEQSUP = PSEQSUP;

  temp := '';

  -- Inicia um e-mail RTF
  temp := COALESCE(temp,'') || to_path('{/rtf1/ansi/deff0{/fonttbl{/f0/fnil/fcharset0 Times New Roman;}{/f1/fnil MS Sans Serif;}}');
  temp := temp || to_path('/viewkind4/uc1/pard/lang1046/f0/fs16 ');

  TEMP := TEMP || to_path('/f1/b Foi adicionada a seguinte mensagem sobre o CHAMADO: ')||COALESCE(pFILSUP,'')||'/'||ltrim(rtrim(COALESCE(pSEQSUP,'')))||to_path('/f0/b0 ')||clf;

  -- Link para a pgina
  TEMP := TEMP || to_path('/f1 Para ver os detalhes desta mensagem ');
  TEMP := TEMP || cAbreLink||' "'||COALESCE(phomePage,'')||'?';
  TEMP := TEMP || 'numdoc='||trim(COALESCE(wk_numdoc,''))||cE||'usuario='||trim(replace(wk_contat,' ','%20'));
  TEMP := TEMP || COALESCE(cE,'')||'tipo=Cliente'||COALESCE(cE,'') ||'flgreg=C'||COALESCE(cE,'') ||'codfil='||COALESCE(pfilsup,'') ||COALESCE(cE,'') ||'sequen='||Replace(COALESCE(pseqsup,'') ,' ','%20')||'"';
  TEMP := TEMP || ' clique aqui '||cFechaLink||to_path(' /f0')||cLF;

  -- colocando o texto da mensagem
  if pmsgsup like to_path('{/rtf1/ansi%') then
    temp := temp || to_path('/f1/par} ')|| COALESCE(cRecomecar,'') ;
    TEMP := TEMP || COALESCE(Pmsgsup,'') ||to_path('\par  ')||cLF;
    temp := temp || COALESCE(cRecomecar,'') ;
    temp := temp || to_path('{/rtf1/ansi/deff0{/fonttbl{/f0/fnil/fcharset0 Times New Roman;}{/f1/fnil MS Sans Serif;}}');
    temp := temp || to_path('/viewkind4/uc1/pard/lang1046/f0/fs16 ');
  else
    temp := temp || cLF;
    TEMP := TEMP || REPLACE(COALESCE(Pmsgsup,'') ,chr(13)||chr(10),cLF)||cLF;
    temp := temp || cLF;
  end if;

  if WK_CONTA > 0 then
    -- Enviando registro de workflow junto
    TEMP := TEMP || chr(13)||chr(10);
    TEMP := TEMP || to_path('/f1/b As seguintes tarefas esto relacionadas com esta mensagem. ')||cLF;

    -- Tarefas relacionadas ao chamado
    OPEN cr_workflows;
    LOOP
      FETCH cr_workflows into WF;
      EXIT WHEN NOT FOUND;    
      TEMP := TEMP || to_path('/f1/b ------------------------------------------------------------------------------- ')||cLF;
      TEMP := TEMP || to_path(' Atividade: /b0 ');

      -- Criando o Link para a pgina
      if wk_contat = '###' then -- = Null
        TEMP := TEMP || COALESCE(WF.CODFIL ,'')||'/'||trim(COALESCE(WF.SEQUEN,''))||to_path('/f0')||cLF;
      else
        TEMP := TEMP || COALESCE(cAbreLink,'') ||' "'||COALESCE(PhomePage,'') ||'?';
        TEMP := TEMP || 'numdoc='||trim(COALESCE(wk_numdoc,'') )||cE||'usuario='||trim(replace(COALESCE(wk_contat,'') ,' ','%20'));
        TEMP := TEMP || cE||'tipo=Cliente'||cE||'flgreg=T'||cE||'codfil='||COALESCE(wf.codfil,'')|| COALESCE(cE,'') ||'sequen='||Replace(wf.sequen,' ','%20')||'"';
        TEMP := TEMP || ' '||WF.CODFIL||'/'||trim(WF.SEQUEN)||' '|| COALESCE(cFechaLink,'') ||to_path(' /f0')||cLF;
      end if;

      -- Ttulo e descrio
      TEMP := TEMP || to_path('/f1/b Ttulo: /b0 ')||COALESCE(wf.destar,'')||to_path('/f0')||cLF;
      TEMP := TEMP || to_path('/f1/b Descrio: /b0 ')||cLF;

      if WF.TAREFA like to_path('{/rtf1/ansi%')  then
        temp := temp || to_path('/f1/par} ')|| COALESCE(cRecomecar,'') ;
        TEMP := TEMP || COALESCE(WF.TAREFA,'')||cLF;
        temp := temp || COALESCE(cRecomecar,'') ;
        temp := temp || to_path('{/rtf1/ansi/deff0{/fonttbl{/f0/fnil/fcharset0 Times New Roman;}{/f1/fnil MS Sans Serif;}}');
        temp := temp || to_path('/viewkind4/uc1/pard/lang1046/fs16/f0/b0')||cLF;
      else
        TEMP := TEMP ||REPLACE(COALESCE(WF.TAREFA,''),chr(13)||chr(10),cLF)||cLF;
      end if;
    END LOOP;
  CLOSE CR_WORKFLOWS;
  END if;

  temp := temp || to_path('/f1/par}');

  Return Temp;
END;
$$ language 'plpgsql';




/*-- SEQ 1072 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_Carga_Existe (TT_VOL.FILCAR%TYPE,TT_VOL.SEQCAR%TYPE) CASCADE;

/*-- SEQ 1073 --*/
CREATE OR REPLACE FUNCTION TGR_Carga_Existe (TT_VOL.FILCAR%TYPE,TT_VOL.SEQCAR%TYPE)
RETURNS Integer AS $$
DECLARE
pFILCAR ALIAS FOR $1 ;
pSEQCAR ALIAS FOR $2 ;
-- Checa a existencia da carga
  dummy1     TT_VOL.FILCAR%TYPE;
  dummy2     TT_VOL.SEQCAR%TYPE;
  achou      INTEGER;
  carga CURSOR(onde TT_VOL.FILCAR%TYPE,
           quem TT_VOL.SEQCAR%TYPE) IS
    SELECT FILCAR,SEQUEN
    FROM TT_CAR
    WHERE FILCAR = onde
      AND SEQUEN = quem;
BEGIN
  achou := -1;  /* o "default"  que algum erro pode vir a ocorrer ("mutating table") */
  -- Faz o papel da "foreign key" verificando se a carga existe
  OPEN carga (pFILCAR,pSEQCAR);
  FETCH carga INTO dummy1,dummy2;
  IF (NOT FOUND) THEN
     achou := 0;
  ELSE
     achou := 1;
  END IF;
  CLOSE carga;
  Return Achou;
END;
$$ language 'plpgsql';




/*-- SEQ 1074 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_Chamado_Existe (TL_SUP.CODFIL%TYPE,TL_SUP.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1075 --*/
CREATE OR REPLACE FUNCTION TGR_Chamado_Existe (TL_SUP.CODFIL%TYPE,TL_SUP.SEQUEN%TYPE)
RETURNS Integer AS $$
DECLARE
PCODFIL ALIAS FOR $1 ;
PSEQUEN ALIAS FOR $2 ;
-- Checa a existencia da tarefa
  dummy1  TL_SUP.CODFIL%TYPE;
  dummy2  TL_SUP.SEQUEN%TYPE;
    achou   INTEGER;

  Chamado CURSOR(onde TL_SUP.CODFIL%TYPE,
           quem TL_SUP.SEQUEN%TYPE) IS
    SELECT CODFIL, SEQUEN
    FROM TT_SUP
    WHERE CODFIL = onde
      AND SEQUEN = quem;
BEGIN
  -- Faz o papel da "foreign key" verificando se a tarefa existe
  achou := -1;    /* o "default"  que algum erro pode vir a ocorrer ("mutating table") */
  OPEN Chamado (PCODFIL,PSEQUEN);
  FETCH Chamado INTO dummy1,dummy2;
  IF (NOT FOUND) THEN
     achou := 0;
  ELSE
     achou := 1;
  END IF;
  CLOSE Chamado;
  RETURN ACHOU;
END;
$$ language 'plpgsql';




/*-- SEQ 1076 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_Cliente_Existe (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE) CASCADE;

/*-- SEQ 1077 --*/
CREATE OR REPLACE FUNCTION TGR_Cliente_Existe (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE)
RETURNS Integer AS $$
DECLARE
pFILCLI ALIAS FOR $1 ;
pCODCLI ALIAS FOR $2 ;
-- Checa a existencia do cliente
  ACHOU INTEGER;
BEGIN
  -- Faz o papel da "foreign key" verificando se o cliente existe
  SELECT COUNT(*) INTO ACHOU
    FROM TT_CLI
   WHERE FILCLI = pFILCLI
     AND CODCLI = pCODCLI;
  RETURN ACHOU;
END;
$$ language 'plpgsql';




/*-- SEQ 1078 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_Contrato_Existe (TL_CTT.CODFIL%TYPE,TL_CTT.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1079 --*/
CREATE OR REPLACE FUNCTION TGR_Contrato_Existe (TL_CTT.CODFIL%TYPE,TL_CTT.SEQUEN%TYPE)
RETURNS integer AS $$
DECLARE
PCODFIL ALIAS FOR $1 ;
PSEQUEN ALIAS FOR $2 ;
-- Checa a existencia do Contrato
  dummy1  TL_CTT.CODFIL%TYPE;
  dummy2  TL_CTT.SEQUEN%TYPE;
  achou   INTEGER;
  
  contrato CURSOR(onde TL_CTT.CODFIL%TYPE,
           quem TL_CTT.SEQUEN%TYPE) IS
    SELECT CODFIL,SEQUEN
    FROM TT_CTT
    WHERE CODFIL = onde
      AND SEQUEN = quem;
BEGIN
  achou := -1;    /* o "default"  que algum erro pode vir a ocorrer ("mutating table") */
  -- Faz o papel da "foreign key" verificando se o contrato existe
  OPEN contrato (pCODFIL,pSEQUEN);
  FETCH contrato INTO dummy1,dummy2;
  IF (NOT FOUND) THEN
     achou := 0;
  ELSE
     achou := 1;
  END IF;
  CLOSE contrato;
  Return achou;
END;
$$ language 'plpgsql';




/*-- SEQ 1080 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_Existe_Filial (TT_USU.FILUSU%TYPE) CASCADE;

/*-- SEQ 1081 --*/
CREATE OR REPLACE FUNCTION TGR_Existe_Filial (TT_USU.FILUSU%TYPE)
RETURNS boolean AS $$
DECLARE
filial ALIAS FOR $1 ;
  linha INTEGER;
BEGIN
  SELECT COUNT(*) INTO linha FROM TD_FIL WHERE CODFIL = filial;
  RETURN (linha > 0);
END;
$$ language 'plpgsql';





/*-- SEQ 1082 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_Grade_Existe (TL_GRA.FILMAT%TYPE,TL_GRA.CODMAT%TYPE,TL_GRA.CODCOR%TYPE,TL_GRA.CODTAM%TYPE) CASCADE;

/*-- SEQ 1083 --*/
CREATE OR REPLACE FUNCTION TGR_Grade_Existe (TL_GRA.FILMAT%TYPE,TL_GRA.CODMAT%TYPE,TL_GRA.CODCOR%TYPE,TL_GRA.CODTAM%TYPE)
RETURNS Integer AS $$
DECLARE
PFILMAT ALIAS FOR $1 ;
PCODMAT ALIAS FOR $2 ;
PCODCOR ALIAS FOR $3 ;
PCODTAM ALIAS FOR $4 ;
-- Checa a existencia da grade
  achou   INTEGER;
BEGIN

  -- Faz o papel da "foreign key" verificando se a grade existe
  SELECT COUNT(*)
    INTO achou
    FROM TT_GRA
   WHERE FILMAT = PFILMAT
     AND CODMAT = PCODMAT
     AND CODCOR = PCODCOR
     AND CODTAM = PCODTAM;

  RETURN ACHOU;

END;
$$ language 'plpgsql';




/*-- SEQ 1084 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_ItemRomaneio_Existe (TL_IRO.CODFIL%TYPE,TL_IRO.SEQUEN%TYPE,TL_IRO.FILVEN%TYPE,TL_IRO.SEQVEN%TYPE,TL_IRO.SEQCAN%TYPE) CASCADE;

/*-- SEQ 1085 --*/
CREATE OR REPLACE FUNCTION TGR_ItemRomaneio_Existe (TL_IRO.CODFIL%TYPE,TL_IRO.SEQUEN%TYPE,TL_IRO.FILVEN%TYPE,TL_IRO.SEQVEN%TYPE,TL_IRO.SEQCAN%TYPE)
RETURNS Integer AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pFILVEN ALIAS FOR $3 ;
pSEQVEN ALIAS FOR $4 ;
pSEQCAN ALIAS FOR $5 ;
-- Checa a existencia do itemromaneio
  dummy1  TL_IRO.CODFIL%TYPE;
  dummy2  TL_IRO.SEQUEN%TYPE;
  dummy3  TL_IRO.FILVEN%TYPE;
  dummy4  TL_IRO.SEQVEN%TYPE;
  dummy5  TL_IRO.SEQCAN%TYPE;
  achou   INTEGER;

  itemromaneio CURSOR(p1 TL_IRO.CODFIL%TYPE,
           p2 TL_IRO.SEQUEN%TYPE,
           p3 TL_IRO.FILVEN%TYPE,
           p4 TL_IRO.SEQVEN%TYPE,
           p5 TL_IRO.SEQCAN%TYPE) IS
    SELECT CODFIL,SEQUEN,FILVEN,SEQVEN,SEQCAN
    FROM TT_IRO
    WHERE CODFIL = p1
      AND SEQUEN = p2
      AND FILVEN = p3
      AND SEQVEN = p4
      AND SEQCAN = p5;
BEGIN
  achou := -1;  /* o "default"  que algum erro pode vir a ocorrer ("mutating table") */
  -- Faz o papel da "foreign key" verificando se o itemromaneio existe
  OPEN itemromaneio (pCODFIL,pSEQUEN,pFILVEN,pSEQVEN,pSEQCAN);
  FETCH itemromaneio INTO dummy1,dummy2,dummy3,dummy4,dummy5;
  IF (NOT FOUND) THEN
     achou := 0;
  ELSE
     achou := 1;
  END IF;
  CLOSE itemromaneio;
  RETURN Achou;
END;
$$ language 'plpgsql';




/*-- SEQ 1086 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_ExisteLimite (TT_LIM.FILCLI%TYPE,TT_LIM.CODCLI%TYPE,TT_LIM.TIPCCC%TYPE) CASCADE;

/*-- SEQ 1087 --*/
CREATE OR REPLACE FUNCTION TGR_ExisteLimite (TT_LIM.FILCLI%TYPE,TT_LIM.CODCLI%TYPE,TT_LIM.TIPCCC%TYPE)
RETURNS boolean AS $$
DECLARE
p_Filial ALIAS FOR $1 ;
p_Codigo ALIAS FOR $2 ;
p_tipccc ALIAS FOR $3 ;
  wk_Achou INTEGER;
begin
  SELECT COUNT(*) INTO wk_Achou FROM TT_LIM
   WHERE FILCLI = p_Filial
     AND CODCLI = p_Codigo
     AND TIPCCC = p_tipccc;

  RETURN (wk_Achou > 0);
END;
$$ language 'plpgsql';




/*-- SEQ 1088 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_Montagem_Existe (TL_MON.CODFIL%TYPE,TL_MON.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1089 --*/
CREATE OR REPLACE FUNCTION TGR_Montagem_Existe (TL_MON.CODFIL%TYPE,TL_MON.SEQUEN%TYPE)
RETURNS Integer AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
-- Checa a existencia do montagem
  dummy1  TL_MON.CODFIL%TYPE;
  dummy2  TL_MON.SEQUEN%TYPE;
  achou   INTEGER;

  montagem CURSOR(onde TL_MON.CODFIL%TYPE,
           quem TL_MON.SEQUEN%TYPE) IS
    SELECT CODFIL,SEQUEN
    FROM TT_MON
    WHERE CODFIL = onde
      AND SEQUEN = quem;
BEGIN
  achou := -1;  /* o "default"  que algum erro pode vir a ocorrer ("mutating table") */
  -- Faz o papel da "foreign key" verificando se o montagem existe
  OPEN montagem (pCODFIL,pSEQUEN);
  FETCH montagem INTO dummy1,dummy2;
  IF (NOT FOUND) THEN
     achou := 0;
  ELSE
     achou := 1;
  END IF;
  CLOSE montagem;
  RETURN Achou;
END;
$$ language 'plpgsql';




/*-- SEQ 1090 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_Orcamento_Existe (TL_ORC.CODFIL%TYPE,TL_ORC.TIPPED%TYPE,TL_ORC.NUMPED%TYPE) CASCADE;

/*-- SEQ 1091 --*/
CREATE OR REPLACE FUNCTION TGR_Orcamento_Existe (TL_ORC.CODFIL%TYPE,TL_ORC.TIPPED%TYPE,TL_ORC.NUMPED%TYPE)
RETURNS Integer AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pTIPPED ALIAS FOR $2 ;
pNUMPED ALIAS FOR $3 ;
-- Checa a existencia do orcamento
  dummy1  TL_ORC.CODFIL%TYPE;
  dummy2  TL_ORC.TIPPED%TYPE;
  dummy3  TL_ORC.NUMPED%TYPE;
  achou   INTEGER;

  orcamento CURSOR(filial TL_ORC.CODFIL%TYPE,
           tipo TL_ORC.TIPPED%TYPE,
           codigo TL_ORC.NUMPED%TYPE) IS
    SELECT CODFIL,TIPPED,NUMPED
    FROM TT_ORC
    WHERE CODFIL = filial
      AND TIPPED = tipo
      AND NUMPED = codigo;
BEGIN
  achou := -1;  /* o "default"  que algum erro pode vir a ocorrer ("mutating table") */
  -- Faz o papel da "foreign key" verificando se o orcamento existe
  OPEN orcamento (pCODFIL,pTIPPED,pNUMPED);
  FETCH orcamento INTO dummy1,dummy2,dummy3;
  IF (NOT FOUND) THEN
     achou := 0;
  ELSE
     achou := 1;
  END IF;
  CLOSE orcamento;
  RETURN Achou;
END;
$$ language 'plpgsql';




/*-- SEQ 1092 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_Preco_Existe (TL_PRE.FILPRE%TYPE,TL_PRE.SEQPRE%TYPE) CASCADE;

/*-- SEQ 1093 --*/
CREATE OR REPLACE FUNCTION TGR_Preco_Existe (TL_PRE.FILPRE%TYPE,TL_PRE.SEQPRE%TYPE)
RETURNS Integer AS $$
DECLARE
pFILPRE ALIAS FOR $1 ;
pSEQPRE ALIAS FOR $2 ;
-- Checa a existencia do preco
  dummy1  TL_PRE.FILPRE%TYPE;
  dummy2  TL_PRE.SEQPRE%TYPE;
  achou   INTEGER;

  preco CURSOR(onde TL_PRE.FILPRE%TYPE,
           quem TL_PRE.SEQPRE%TYPE) IS
    SELECT FILPRE,SEQUEN
    FROM TT_PRE
    WHERE FILPRE = onde
      AND SEQUEN = quem;
BEGIN
  achou := -1;  /* o "default"  que algum erro pode vir a ocorrer ("mutating table") */
  -- Faz o papel da "foreign key" verificando se o preco existe
  OPEN preco (pFILPRE,pSEQPRE);
  FETCH preco INTO dummy1,dummy2;
  IF (NOT FOUND) THEN
     achou := 0;
  ELSE
     achou := 1;
  END IF;
  CLOSE preco;
  RETURN Achou;
END;
$$ language 'plpgsql';




/*-- SEQ 1094 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_Projeto_Existe (TL_PRJ.CODFIL%TYPE,TL_PRJ.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1095 --*/
CREATE OR REPLACE FUNCTION TGR_Projeto_Existe (TL_PRJ.CODFIL%TYPE,TL_PRJ.SEQUEN%TYPE)
RETURNS Integer AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
-- Checa a existencia do cliente
  dummy1  TL_PRJ.CODFIL%TYPE;
  dummy2  TL_PRJ.SEQUEN%TYPE;
  achou   INTEGER;

  projeto CURSOR(onde TL_PRJ.CODFIL%TYPE,
           quem TL_PRJ.SEQUEN%TYPE) IS
    SELECT CODFIL,SEQUEN
    FROM TT_PRJ
    WHERE CODFIL = onde
      AND SEQUEN = quem;
BEGIN
  achou := -1;    /* o "default"  que algum erro pode vir a ocorrer ("mutating table") */
  -- Faz o papel da "foreign key" verificando se o cliente existe
  OPEN projeto (pCODFIL,pSEQUEN);
  FETCH projeto INTO dummy1,dummy2;
  IF (NOT FOUND) THEN
     achou := 0;
  ELSE
     achou := 1;
  END IF;
  CLOSE projeto;
  RETURN achou;
END;
$$ language 'plpgsql';




/*-- SEQ 1096 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_Produto_Existe (TL_PRO.FILMAT%TYPE,TL_PRO.CODMAT%TYPE) CASCADE;

/*-- SEQ 1097 --*/
CREATE OR REPLACE FUNCTION TGR_Produto_Existe (TL_PRO.FILMAT%TYPE,TL_PRO.CODMAT%TYPE)
RETURNS Integer AS $$
DECLARE
PFILMAT ALIAS FOR $1 ;
PCODMAT ALIAS FOR $2 ;
-- Checa a existencia do produto
  dummy1  TL_PRO.FILMAT%TYPE;
  dummy2  TL_PRO.CODMAT%TYPE;
  achou   INTEGER;

  produto CURSOR(onde TL_PRO.FILMAT%TYPE,
           quem TL_PRO.CODMAT%TYPE) IS
    SELECT FILMAT,CODMAT
    FROM TT_PRO
    WHERE FILMAT = onde
      AND CODMAT = quem;
BEGIN
  achou := -1;  /* o "default"  que algum erro pode vir a ocorrer ("mutating table") */
  -- Faz o papel da "foreign key" verificando se o produto existe
  OPEN produto (PFILMAT,PCODMAT);
  FETCH produto INTO dummy1,dummy2;
  IF (NOT FOUND) THEN
     achou := 0;
  ELSE
     achou := 1;
  END IF;
  CLOSE produto;
  RETURN ACHOU;
END;
$$ language 'plpgsql';




/*-- SEQ 1098 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_Referencia_Existe (TT_GRA.REFPRO%TYPE) CASCADE;

/*-- SEQ 1099 --*/
CREATE OR REPLACE FUNCTION TGR_Referencia_Existe (TT_GRA.REFPRO%TYPE)
RETURNS VARCHAR AS $$
DECLARE
ReferenciaProduto ALIAS FOR $1 ;
  -- Objetivos
  -- Verifica se ha exclusividade no codigo da referencia
  RefBasica     TT_PRO.REFBAS%TYPE;
  produto       TT_PRO.DESMAT%TYPE;
  especificacao TT_PRO.ESPMAT%TYPE;
BEGIN
  -- Retorna detalhes do produto que ja possui o mesmo codigo na referencia basica
  -- Nota: foi preciso montar o select desta maneira para que ele
  --       sempre traga um dado. Caso contrario poderia ocorrer o
  --       erro "ORA-01403: no data found". Outra maneira possivel
  --       e fazer dois selects: um "select count(*)..." para testar
  --       a existencia e o segundo (executado apenas se count(*) for
  --       diferente de zero) apenas para obter os detalhes que farao
  --       parte da mensagem de erro.
  SELECT REFBAS,DESMAT,ESPMAT
  INTO RefBasica,produto,especificacao
  FROM (SELECT 0 AS dummy1 FROM dual) d1
        LEFT OUTER JOIN 
       (SELECT 0 AS dummy2,PRO.REFBAS,PRO.DESMAT,PRO.ESPMAT
          FROM TT_PRO PRO
         WHERE PRO.REFBAS = ReferenciaProduto) d2
       ON d1.dummy1 = d2.dummy2;


  IF ISNOTNULL(RefBasica) = 'T' THEN
    RETURN 'A referencia '||COALESCE(RefBasica,' ')||
               ' ja e utilizada pelo produto "'||
               COALESCE(LTRIM(RTRIM(produto)),' ')||'". Especificacao "'||
               COALESCE(LTRIM(RTRIM(especificacao)),' ')||'"';

  ELSE
    RETURN NULL;
  END IF;
END;
$$ language 'plpgsql';




/*-- SEQ 1100 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_Registro_Existe (TL_REG.CODFIL%TYPE,TL_REG.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1101 --*/
CREATE OR REPLACE FUNCTION TGR_Registro_Existe (TL_REG.CODFIL%TYPE,TL_REG.SEQUEN%TYPE)
RETURNS Integer AS $$
DECLARE
PCODFIL ALIAS FOR $1 ;
PSEQUEN ALIAS FOR $2 ;
-- Checa a existencia do registro
  dummy1  TL_REG.CODFIL%TYPE;
  dummy2  TL_REG.SEQUEN%TYPE;
  achou   INTEGER;

  registro CURSOR(onde TL_REG.CODFIL%TYPE,
           quem TL_REG.SEQUEN%TYPE) IS
    SELECT CODFIL,SEQUEN
    FROM TT_REG
    WHERE CODFIL = onde
      AND SEQUEN = quem;
BEGIN
  achou := -1;    /* o "default"  que algum erro pode vir a ocorrer ("mutating table") */
  -- Faz o papel da "foreign key" verificando se o registro existe
  OPEN registro (PCODFIL,PSEQUEN);
  FETCH registro INTO dummy1,dummy2;
  IF (NOT FOUND) THEN
     achou := 0;
  ELSE
     achou := 1;
  END IF;
  CLOSE registro;
  RETURN ACHOU;
END;
$$ language 'plpgsql';




/*-- SEQ 1102 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_Tarefa_Existe (TL_WOR.CODFIL%TYPE,TL_WOR.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1103 --*/
CREATE OR REPLACE FUNCTION TGR_Tarefa_Existe (TL_WOR.CODFIL%TYPE,TL_WOR.SEQUEN%TYPE)
RETURNS Integer AS $$
DECLARE
Pcodfil ALIAS FOR $1 ;
Psequen ALIAS FOR $2 ;
-- Checa a existencia da tarefa
  dummy1  TL_WOR.CODFIL%TYPE;
  dummy2  TL_WOR.SEQUEN%TYPE;
  achou   INTEGER;

  Tarefa CURSOR(onde TL_WOR.CODFIL%TYPE,
           quem TL_WOR.SEQUEN%TYPE) IS
    SELECT CODFIL, SEQUEN
    FROM TT_WOR
    WHERE CODFIL = onde
      AND SEQUEN = quem;
BEGIN
  achou := -1;    /* o "default"  que algum erro pode vir a ocorrer ("mutating table") */
  -- Faz o papel da "foreign key" verificando se a tarefa existe
  OPEN Tarefa (pCODFIL,pSEQUEN);
  FETCH Tarefa INTO dummy1,dummy2;
  IF (NOT FOUND) THEN
     achou := 0;
  ELSE
     achou := 1;
  END IF;
  CLOSE Tarefa;
  Return Achou;
END;
$$ language 'plpgsql';




/*-- SEQ 1104 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_ExisteTitulo (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE) CASCADE;

/*-- SEQ 1105 --*/
CREATE OR REPLACE FUNCTION TGR_ExisteTitulo (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE)
RETURNS boolean AS $$
DECLARE
p_CODFIL ALIAS FOR $1 ;
p_SEQUEN ALIAS FOR $2 ;
p_NUMPAR ALIAS FOR $3 ;
p_SUBPAR ALIAS FOR $4 ;
  wk_DUMMY INTEGER;
BEGIN
  SELECT COUNT(*)
    INTO wk_DUMMY
    FROM TT_TIT
   WHERE FILREC = p_CODFIL
     and SEQREC = p_SEQUEN
     and PARREC = p_NUMPAR
     and SUBREC = p_SUBPAR     
     and SEQCAN IS NULL;
    RETURN (wk_DUMMY > 0);
END;
$$ language 'plpgsql';




/*-- SEQ 1106 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_GeraTitulo (TT_REC.PORTAD%TYPE) CASCADE;

/*-- SEQ 1107 --*/
CREATE OR REPLACE FUNCTION TGR_GeraTitulo (TT_REC.PORTAD%TYPE)
RETURNS boolean AS $$
DECLARE
Chave ALIAS FOR $1 ;
  wk_DUMMY INTEGER;
BEGIN
  SELECT COUNT(*)
    INTO wk_DUMMY
    FROM TD_COB
   WHERE CODTAB = Chave
     AND GERTIT = 'T';
  RETURN (wk_DUMMY > 0);
END;
$$ language 'plpgsql';




/*-- SEQ 1108 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_PegaE_mail (TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE) CASCADE;

/*-- SEQ 1109 --*/
CREATE OR REPLACE FUNCTION TGR_PegaE_mail (TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE)
RETURNS VARCHAR AS $$
DECLARE
cFILUSU ALIAS FOR $1 ;
cCODUSU ALIAS FOR $2 ;
-- Pega o E-mail do Usurio pela filial e cdigo
  vE_MAIL TT_USU.E_MAIL%TYPE;
  NULO   CONSTANT CHAR(4) := 'Nulo';
BEGIN
  SELECT COALESCE(E_MAIL,NULO) INTO vE_MAIL
  FROM TT_USU USU
  WHERE FILUSU = cFILUSU
    AND CODUSU = cCODUSU;

  RETURN (vE_MAIL);
END;
$$ language 'plpgsql';




/*-- SEQ 1110 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_Grava_EAN (TT_GRA.REFPRO%TYPE) CASCADE;

/*-- SEQ 1111 --*/
CREATE OR REPLACE FUNCTION TGR_Grava_EAN (TT_GRA.REFPRO%TYPE)
RETURNS TT_GRA.REFPRO%TYPE AS $$
DECLARE
SEQ ALIAS FOR $1 ;
-- Grava a proxima sequencia livre em TT_COD
  achou   INTEGER;
  cComplemento VARCHAR(100);
  proximo TT_COD.ULTCOD%TYPE;
  Loja    TT_COD.FILCOD%TYPE;
  SEQUENCIA TT_COD.ULTCOD%TYPE;
BEGIN
  SEQUENCIA:=SEQ;
  SELECT COALESCE(LINHAS,0),ULTCOD INTO achou,proximo
  FROM (SELECT 0 AS DUMMY1 FROM DUAL) d1 
       LEFT OUTER JOIN
       (SELECT 0 AS DUMMY2, COUNT(*) AS LINHAS,ULTCOD
        FROM TT_COD
        WHERE CODTAB='EAN'
        GROUP BY ULTCOD) d2
       ON d1.dummy1 = d2.dummy2;

  IF achou = 0 THEN
    -- Retorna a filial corrente
    SELECT CODLOJ INTO Loja FROM TT_IDF;
    IF SEQUENCIA IS NULL THEN
      INSERT INTO TT_COD (CODTAB,FILCOD,ULTCOD) VALUES ('EAN',Loja,1);
      SEQUENCIA := 1;
    ELSE
      INSERT INTO TT_COD (CODTAB,FILCOD,ULTCOD) VALUES ('EAN',Loja,SEQUENCIA);
    END IF;
  ELSIF achou = 1 THEN
    IF SEQUENCIA IS NULL THEN
      UPDATE TT_COD SET ULTCOD = PROXIMO+1 WHERE CODTAB='EAN';
      SEQUENCIA := PROXIMO+1;
    ELSE
      UPDATE TT_COD SET ULTCOD = SEQUENCIA WHERE CODTAB='EAN';
    END IF;
  ELSE
    cComplemento:=constante('COMPLEMENTO');
    RAISE EXCEPTION 'PG-20001 Inconsistencia na tabela de codigos disponiveis.%' , cComplemento; 
  END IF;

  Return Sequencia;   
END;
$$ language 'plpgsql';





/*-- SEQ 1112 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_IOR_Item_Existe (TT_IOR.FILIVE%TYPE,TT_IOR.SEQIVE%TYPE,TT_IOR.NUMIVE%TYPE) CASCADE;

/*-- SEQ 1113 --*/
CREATE OR REPLACE FUNCTION TGR_IOR_Item_Existe (TT_IOR.FILIVE%TYPE,TT_IOR.SEQIVE%TYPE,TT_IOR.NUMIVE%TYPE)
RETURNS Integer AS $$
DECLARE
pFILIVE ALIAS FOR $1 ;
pSEQIVE ALIAS FOR $2 ;
pNUMIVE ALIAS FOR $3 ;
-- Checa a existencia do item de venda
  achou  INTEGER;
  dummy1 TT_IVE.CODFIL%TYPE;
  dummy2 TT_IVE.SEQUEN%TYPE;
  dummy3 TT_IVE.NUMITE%TYPE;

  item CURSOR(onde TT_IVE.CODFIL%TYPE,
           quem TT_IVE.SEQUEN%TYPE,
           numero TT_IVE.NUMITE%TYPE) IS
    SELECT CODFIL,SEQUEN,NUMITE
    FROM TT_IVE
    WHERE CODFIL = onde
      AND SEQUEN = quem
      AND NUMITE = numero;
BEGIN
  -- Faz o papel da "foreign key" verificando se a venda existe
  achou := -1; /* o "default"  que algum erro pode vir a ocorrer ("mutating table") */
  OPEN item (pFILIVE,pSEQIVE,pNUMIVE);
  FETCH item INTO dummy1,dummy2,dummy3;
  IF (NOT FOUND) THEN
     achou := 0;
  ELSE
     achou := 1;
  END IF;
  CLOSE item;
  Return Achou;
END;
$$ language 'plpgsql';




/*-- SEQ 1114 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_IPE_Item_Existe (TT_ICO.CODFIL%TYPE,TT_ICO.SEQUEN%TYPE,TT_ICO.NUMITE%TYPE) CASCADE;

/*-- SEQ 1115 --*/
CREATE OR REPLACE FUNCTION TGR_IPE_Item_Existe (TT_ICO.CODFIL%TYPE,TT_ICO.SEQUEN%TYPE,TT_ICO.NUMITE%TYPE)
RETURNS Integer AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pNUMICO ALIAS FOR $3 ;
-- Checa a existencia do item de compra


  dummy1 TT_ICO.CODFIL%TYPE;
  dummy2 TT_ICO.SEQUEN%TYPE;
  dummy3 TT_ICO.NUMITE%TYPE;
  achou  INTEGER;

  item CURSOR(onde TT_ICO.CODFIL%TYPE,
           quem TT_ICO.SEQUEN%TYPE,
           numero TT_ICO.NUMITE%TYPE) IS
    SELECT CODFIL,SEQUEN,NUMITE
    FROM TT_ICO
    WHERE CODFIL = onde
      AND SEQUEN = quem
      AND NUMITE = numero;
BEGIN
  achou := -1; /* o "default"  que algum erro pode vir a ocorrer ("mutating table") */
  -- Faz o papel da "foreign key" verificando se a compra existe
  OPEN item (pCODFIL,pSEQUEN,pNUMICO);
  FETCH item INTO dummy1,dummy2,dummy3;
  IF (NOT FOUND) THEN
     achou := 0;
  ELSE
     achou := 1;
  END IF;
  CLOSE item;
  Return Achou;
END;
$$ language 'plpgsql';





/*-- SEQ 1116 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_Itens_Vinculados (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_PRO.CODGRA%TYPE) CASCADE;

/*-- SEQ 1117 --*/
CREATE OR REPLACE FUNCTION TGR_Itens_Vinculados (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_PRO.CODGRA%TYPE)
RETURNS VARCHAR AS $$
DECLARE
PFILMAT ALIAS FOR $1 ;
PCODMAT ALIAS FOR $2 ;
PCODGRA ALIAS FOR $3 ;
  -- Verifica se ja nao existe um item de grade para o produto atual
  linha INTEGER;
  grade TD_GRA.NOMGRA%TYPE;
BEGIN
  SELECT COUNT(*) INTO linha FROM TT_GRA WHERE FILMAT = PFILMAT AND CODMAT = PCODMAT;
  IF linha > 0 THEN
    SELECT NOMGRA INTO grade FROM TD_GRA WHERE CODTAB = PCODGRA;
    RETURN 'Ha itens vinculados a grade ' || grade;
  ELSE
    RETURN NULL;
  END IF;
END;
$$ language 'plpgsql';





/*-- SEQ 1118 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_Tem_Cheque_Pendente (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1119 --*/
CREATE OR REPLACE FUNCTION TGR_Tem_Cheque_Pendente (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE)
RETURNS Boolean AS $$
DECLARE
PCODFIL ALIAS FOR $1 ;
PSEQUEN ALIAS FOR $2 ;
  linha Numeric;
BEGIN
  SELECT COUNT(*)
  INTO linha
  FROM TT_REC REC, TT_CHR CHR
  WHERE REC.CODFIL = PCODFIL
    AND REC.SEQUEN = PSEQUEN
    AND REC.FILREC = CHR.CODFIL
    AND REC.SEQCHE = CHR.SEQUEN
    AND CHR.FLGEST NOT IN ('A','S','I','V','X');

  RETURN (linha > 0);
END;
$$ language 'plpgsql';





/*-- SEQ 1120 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_TemDocumento (TT_CHR.CODBCO%TYPE,TT_CHR.CODAGE%TYPE,TT_CHR.NUMCON%TYPE,TT_CHR.NUMCHE%TYPE) CASCADE;

/*-- SEQ 1121 --*/
CREATE OR REPLACE FUNCTION TGR_TemDocumento (TT_CHR.CODBCO%TYPE,TT_CHR.CODAGE%TYPE,TT_CHR.NUMCON%TYPE,TT_CHR.NUMCHE%TYPE)
RETURNS Boolean AS $$
DECLARE
PCODBCO ALIAS FOR $1 ;
PCODAGE ALIAS FOR $2 ;
PNUMCON ALIAS FOR $3 ;
PNUMCHE ALIAS FOR $4 ;
-- Verificar se um cheque possui DOP
  achou INTEGER;
BEGIN
  SELECT COUNT(*) INTO achou
  FROM TT_CFG CFG, TT_DOP DOP, TT_CTB CTB
  WHERE CTB.FILCTA = DOP.FILCTA
    AND CTB.SEQCTA = DOP.SEQCTA
    AND CTB.TIPCTA = DOP.TIPCTA
    AND DOP.DOMDOP = CFG.CHEQUE
    AND DOP.CHETRO = CFG.CHETRO
    AND trim(CTB.CODBCO) = trim(pCODBCO)
    AND trim(CTB.NUMAGE) = trim(PCODAGE)
    AND trim(CTB.CTACRR) = trim(PNUMCON)
    AND trim(DOP.NUMDOC) = trim(PNUMCHE);

  RETURN (achou <> 0);
END;
$$ language 'plpgsql';




/*-- SEQ 1122 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_Tem_Faturamento_CC (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_VEN.CODSER%TYPE) CASCADE;

/*-- SEQ 1123 --*/
CREATE OR REPLACE FUNCTION TGR_Tem_Faturamento_CC (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_VEN.CODSER%TYPE)
RETURNS TT_CCC.TIPCCC%TYPE AS $$
DECLARE
PCODFIL ALIAS FOR $1 ;
PSEQUEN ALIAS FOR $2 ;
PCODSER ALIAS FOR $3 ;
-- Se for faturamento, retorna o tipo de conta corrente. Caso contrario, retorna nulo.
  linha   Numeric;
  tipo    TT_CCC.TIPCCC%TYPE;
BEGIN
  SELECT COUNT(*) INTO linha
  FROM TT_CFG
  WHERE SERIE_FAT_CC = PCODSER;

  IF (linha > 0) THEN
    SELECT MIN(TIPCCC) INTO tipo
    FROM TT_CCC
    WHERE FILFAT = PCODFIL
      AND SEQFAT = PSEQUEN;

    RETURN tipo;
  ELSE
    RETURN NULL;
  END IF;
END;
$$ language 'plpgsql';




/*-- SEQ 1124 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_Tem_Vinculo (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1125 --*/
CREATE OR REPLACE FUNCTION TGR_Tem_Vinculo (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE)
RETURNS Boolean AS $$
DECLARE
PCODFIL ALIAS FOR $1 ;
PSEQUEN ALIAS FOR $2 ;
  linha Numeric;
BEGIN
  SELECT COUNT(*)
    INTO linha
    FROM TT_IVE
   WHERE FILORI = PCODFIL
     AND NUMORI = PSEQUEN
     AND SITMOV <> 'C'
     AND VINCUL <> 'N';
  RETURN linha > 0;
END;
$$ language 'plpgsql';





/*-- SEQ 1126 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_WUSU_ProximoCodigo (TT_COD.CODTAB%TYPE,TT_COD.FILCOD%TYPE,TT_COD.ULTCOD%TYPE) CASCADE;

/*-- SEQ 1127 --*/
CREATE OR REPLACE FUNCTION TGR_WUSU_ProximoCodigo (TT_COD.CODTAB%TYPE,TT_COD.FILCOD%TYPE,TT_COD.ULTCOD%TYPE)
RETURNS TT_COD.ULTCOD%TYPE AS $$
DECLARE
Tabela ALIAS FOR $1 ;
Filial ALIAS FOR $2 ;
Compara ALIAS FOR $3 ;
  UltimoCod TT_COD.ULTCOD%TYPE;

  Codigo CURSOR(pTabela TT_COD.CODTAB%TYPE,
           pFilial TT_COD.FILCOD%TYPE) IS
  select ULTCOD
  from TT_COD
  where CODTAB = pTabela
    and FILCOD = pFilial;
BEGIN
   OPEN Codigo (Tabela,Filial);
   FETCH Codigo INTO UltimoCod;
   IF NOT FOUND THEN
      UltimoCod := null;
   END IF;
   CLOSE Codigo;

   -- Se nao ha registro em TT_COD, insere
   IF (UltimoCod is null) THEN
      insert into TT_COD (CODTAB, FILCOD, ULTCOD)
      values (Tabela, Filial, COALESCE(Compara,1));
      UltimoCod := COALESCE(Compara,1);
   ELSE
      -- Atualiza TT_COD
      IF (Compara is null) THEN
        update TT_COD set ULTCOD = UltimoCod + 1
        where CODTAB = Tabela
          and FILCOD = Filial;

        UltimoCod := UltimoCod + 1;
      ELSIF (Compara > UltimoCod) THEN
        update TT_COD set ULTCOD = Compara
        where CODTAB = Tabela
          and FILCOD = Filial;

        UltimoCod := Compara;
      ELSE
        UltimoCod := Compara;
      END IF;
   END IF;

   RETURN UltimoCod;
END;
$$ language 'plpgsql';




/*-- SEQ 1128 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION COD_TITCTA (TT_CTA.CODFIL%TYPE,TT_CTA.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1129 --*/
CREATE OR REPLACE FUNCTION COD_TITCTA (TT_CTA.CODFIL%TYPE,TT_CTA.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
PCODFIL ALIAS FOR $1 ;
PSEQUEN ALIAS FOR $2 ;
vTITCTA TT_CTA.TITCTA%TYPE;
vCODFIL TT_CTA.CODFIL%TYPE;
vSEQUEN TT_CTA.SEQUEN%TYPE;

BEGIN  
       SELECT CODFIL, SEQUEN, TITCTA
         INTO vCODFIL, vSEQUEN, vTITCTA
         FROM TT_CTA
        WHERE CODFIL = PCODFIL
          AND SEQUEN = PSEQUEN;

      RETURN SUBSTR(vTITCTA||' ('||COALESCE(CODIGO_CONTA(vCODFIL, vSEQUEN, 'X'), '+')||')',1,255);

END;
$$ language 'plpgsql';




/*-- SEQ 1130 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TRG_Produtos_Nomes (TT_PRO.TERASS%TYPE,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE) CASCADE;

/*-- SEQ 1131 --*/
CREATE OR REPLACE FUNCTION TRG_Produtos_Nomes (TT_PRO.TERASS%TYPE,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pWhere ALIAS FOR $1 ;
pFilMat ALIAS FOR $2 ;
pCodMat ALIAS FOR $3 ;
pCodCor ALIAS FOR $4 ;
pCodTam ALIAS FOR $5 ;
Expressao    VARCHAR(4000);
cur0         refcursor;
CurPro       refcursor;
Nome         VARCHAR(25);
cFILMAT TT_GRA.FILMAT%TYPE;
cCODMAT TT_GRA.CODMAT%TYPE;
cCODCOR TT_GRA.CODCOR%TYPE;
cCODTAM TT_GRA.CODTAM%TYPE;
cTexto       VARCHAR(4000);

BEGIN
  Expressao := 'select ipr.filmat, ipr.codmat, ipr.codcor, ipr.codtam, '                          ||
               '       CASE WHEN ipr.desgra IS NOT NULL '                                         ||
               '            THEN ipr.desgra || chr(32) || '                                       ||
               '                 CAST(NomeProduto(ipr.desecf, ipr.desmat, ipr.codcor, div.nomite, ipr.codtam, sub.nomite, ipr.espmat, null, div.nomext, sub.nomext) AS VARCHAR(254)) || chr(32) || '||
               '                 CASE WHEN ipr.desecf IS NOT NULL THEN ipr.desmat ELSE '''' END ' ||
               '            ELSE ipr.nompro || chr(32) || '                                       ||
               '                 CASE WHEN ipr.desecf IS NOT NULL THEN ipr.desmat ELSE '''' END ' ||
               '       END as nome, ipr.nompro '                                                  ||
               'from tv_ipr_fast ipr inner join tt_div div on ipr.codcor = div.codite '           ||
               '                     inner join tt_sub sub on ipr.codtam = sub.codite '           ||
               'where ';

  if pWhere is not null then
     Expressao := Expressao || pWhere;
  else
     Expressao := Expressao || ' ipr.filmat = '||chr(39)||pFilMat||chr(39)||' and ipr.codmat = '||chr(39)||pCodMat||chr(39);
     if (pCodCor is not null) and (pCodTam is not null) then
        Expressao := Expressao || ' and ipr.codcor = ' || pCodCor || ' and ipr.codtam = ' || pCodTam ;
     end if;
  end if;

   
    OPEN curPro FOR EXECUTE Expressao;
      
  LOOP
    FETCH CurPro INTO CFILMAT, CCODMAT, CCODCOR, CCODTAM, cTexto;
    EXIT WHEN NOT FOUND;

    -- Elimina nomes atuais
    DELETE FROM TT_PROxNOM
    WHERE FILMAT = cFilMat
      AND CODMAT = cCodMat
      AND CODCOR = cCodCor
      AND CODTAM = cCodTam;

    -- Inclui novos nomes
   cTexto := REPLACE( cTexto, CHR(39), ' '); -- aspa simples
   cTexto := REPLACE( cTexto, CHR(39)||(39)||CHR(39)||CHR(39), ' '); -- aspa dupla
   
    OPEN cur0 FOR EXECUTE 'SELECT * FROM Nomes('||chr(39)||cTexto||chr(39)||', 0, 1, 0)';
          LOOP
      FETCH cur0 INTO Nome;
      EXIT WHEN NOT FOUND;
      INSERT INTO TT_PROxNOM (DESNOM, CODSOM, FILMAT, CODMAT, CODCOR, CODTAM)
             VALUES (Nome, Soundex(Nome), CFilMat, cCodMat, cCodCor, cCodTam);
    END LOOP;
    CLOSE cur0;
  END LOOP;
  CLOSE CurPro;
 return null;
END;
$$ language 'plpgsql';




/*-- SEQ 1132 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TRAZ_DATA_DESCONTO (TT_TIT.CODFIL%TYPE,TT_TIT.SEQUEN%TYPE,Numeric) CASCADE;

/*-- SEQ 1133 --*/
CREATE OR REPLACE FUNCTION TRAZ_DATA_DESCONTO (TT_TIT.CODFIL%TYPE,TT_TIT.SEQUEN%TYPE,Numeric)
RETURNS Timestamp AS $$
DECLARE
P_CODFIL ALIAS FOR $1 ;
P_SEQUEN ALIAS FOR $2 ;
P_NUMBER ALIAS FOR $3 ;
-- Objetivos
  WK_DATPRO TT_REC.DATVEN%TYPE;
  WK_CODBCO TT_CTB.CODBCO%TYPE;
  WK_NUMAGE TT_CTB.NUMAGE%TYPE;
  WK_CTACRR TT_CTB.CTACRR%TYPE;
  WK_PERPRO TT_CTB.PERPRO%TYPE;
  WK_NUMPRO TT_CTB.NUMPRO%TYPE;
  WK_DATVEN TT_REC.DATVEN%TYPE;
  WK_DIAPRO TT_CTB.DIAPRO%TYPE;
begin
    SELECT TIT.CODBCO, LPAD(TIT.NUMAGE,5,'0'), LPAD(TIT.CTACRR,10,'0'),
           REC.DATVEN
      INTO WK_CODBCO, WK_NUMAGE, WK_CTACRR, WK_DATVEN
      FROM TT_TIT TIT INNER JOIN TT_REC REC ON REC.CODFIL = TIT.FILREC AND REC.SEQUEN = TIT.SEQREC
                                           AND REC.NUMPAR = TIT.PARREC AND REC.SUBPAR = TIT.SUBREC
     WHERE TIT.CODFIL = P_CODFIL
       AND TIT.SEQUEN = P_SEQUEN;

    SELECT COALESCE(DIAPRO,0), COALESCE(NUMPRO,0)
      INTO WK_DIAPRO, WK_NUMPRO
      FROM TT_CTB
     WHERE CODBCO = WK_CODBCO
       AND NUMAGE = WK_NUMAGE
       AND CTACRR = WK_CTACRR;

    IF P_NUMBER <= WK_NUMPRO THEN
      WK_DATPRO := WK_DATVEN;
      FOR i IN 1..P_NUMBER LOOP
         WK_DATPRO := WK_DATPRO + WK_DIAPRO;
      END LOOP;
    END IF;
    Return WK_DATPRO;
END;
$$ language 'plpgsql';





/*-- SEQ 1134 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TRAZ_DATPRO (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE) CASCADE;

/*-- SEQ 1135 --*/
CREATE OR REPLACE FUNCTION TRAZ_DATPRO (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE)
RETURNS Timestamp AS $$
DECLARE
P_CODFIL ALIAS FOR $1 ;
P_SEQUEN ALIAS FOR $2 ;
P_NUMPAR ALIAS FOR $3 ;
P_SUBPAR ALIAS FOR $4 ;
VDATPRO TT_SUP.DATPRO%TYPE;  
begin
  SELECT COALESCE(MAX(COB.DATPRO),MAX(SUP.DATPRO)) INTO VDATPRO
  FROM TT_VEN VEN INNER JOIN TT_REC REC ON REC.CODFIL = VEN.CODFIL 
                                       AND REC.SEQUEN = VEN.SEQUEN
                  INNER JOIN TT_CLI CLI ON VEN.FILCLI = CLI.FILCLI 
		                       AND VEN.CODCLI = CLI.CODCLI
                  INNER JOIN TT_COB COB ON REC.SEQUEN = COB.SEQREC 
		                       AND REC.CODFIL = COB.FILREC 
				       AND REC.NUMPAR = COB.NUMPAR 
				       AND REC.SUBPAR = COB.SUBPAR
                  INNER JOIN TT_SUP SUP ON SUP.CODFIL = COB.FILSUP 
		                       AND SUP.SEQUEN = COB.SEQSUP
  WHERE REC.CODFIL = P_CODFIL
    AND REC.SEQUEN = P_SEQUEN
    AND REC.NUMPAR = P_NUMPAR 
    AND REC.SUBPAR = P_SUBPAR
    AND SUP.PERFIL = 'C'
    AND SUP.SITUAC IN ('A','N');    
  Return VDATPRO;
END;
$$ language 'plpgsql';




/*-- SEQ 1136 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TRAZ_PERC_DESCONTO (TT_TIT.CODFIL%TYPE,TT_TIT.CODFIL%TYPE,Numeric) CASCADE;

/*-- SEQ 1137 --*/
CREATE OR REPLACE FUNCTION TRAZ_PERC_DESCONTO (TT_TIT.CODFIL%TYPE,TT_TIT.CODFIL%TYPE,Numeric)
RETURNS Numeric AS $$
DECLARE
P_CODFIL ALIAS FOR $1 ;
P_SEQUEN ALIAS FOR $2 ;
P_NUMBER ALIAS FOR $3 ;
-- Objetivos
  WK_JURPRO TT_CTB.PERPRO%TYPE;
  WK_JURDES TT_TIT.JURDES%TYPE;
  WK_CODBCO TT_CTB.CODBCO%TYPE;
  WK_NUMAGE TT_CTB.NUMAGE%TYPE;
  WK_CTACRR TT_CTB.CTACRR%TYPE;
  WK_PERPRO TT_CTB.PERPRO%TYPE;
  WK_NUMPRO TT_CTB.NUMPRO%TYPE;
begin
    SELECT COALESCE(JURDES,0), CODBCO, LPAD(NUMAGE,5,'0'), LPAD(CTACRR,10,'0')
      INTO WK_JURDES, WK_CODBCO, WK_NUMAGE, WK_CTACRR
      FROM TT_TIT
     WHERE CODFIL = P_CODFIL
       AND SEQUEN = P_SEQUEN;

    SELECT COALESCE(PERPRO,0), COALESCE(NUMPRO,0)
      INTO WK_PERPRO, WK_NUMPRO
      FROM TT_CTB
     WHERE CODBCO = WK_CODBCO
       AND NUMAGE = WK_NUMAGE
       AND CTACRR = WK_CTACRR;

   /* Descontos Regressivos*/
    wk_jurpro := 0;
    IF P_NUMBER <= WK_NUMPRO THEN
        WK_JURPRO := WK_JURDES;
        FOR i IN 1..P_NUMBER LOOP
           wk_JURPRO := ROUND(WK_JURPRO - (WK_JURDES * (WK_PERPRO/100)),2);
        END LOOP;
    ELSE
        wk_JURPRO := 0;
    END IF;
    Return wk_JURPRO;
END;
$$ language 'plpgsql';




/*-- SEQ 1138 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TRAZ_QTDFLGACT (TT_SUP.FILCLI%TYPE,TT_SUP.CODCLI%TYPE,TT_SUP.SITUAC%TYPE,TT_SUP.FLGACT%TYPE) CASCADE;

/*-- SEQ 1139 --*/
CREATE OR REPLACE FUNCTION TRAZ_QTDFLGACT (TT_SUP.FILCLI%TYPE,TT_SUP.CODCLI%TYPE,TT_SUP.SITUAC%TYPE,TT_SUP.FLGACT%TYPE)
RETURNS Numeric AS $$
DECLARE
PFILCLI ALIAS FOR $1 ;
PCODCLI ALIAS FOR $2 ;
PSITUAC ALIAS FOR $3 ;
PFLGACT ALIAS FOR $4 ;
VQTDFLGACT Numeric;  
begin
  SELECT COUNT(*) INTO VQTDFLGACT from tt_sup sup 
  where SUP.SITUAC = PSITUAC
    AND SUP.FLGACT = PFLGACT 
    AND SUP.FILCLI = PFILCLI 
    AND SUP.CODCLI = PCODCLI;    
  Return VQTDFLGACT;
END;
$$ language 'plpgsql';




/*-- SEQ 1140 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TRAZ_QTDSUP (TT_SUP.FILCLI%TYPE,TT_SUP.CODCLI%TYPE,TT_SUP.SITUAC%TYPE) CASCADE;

/*-- SEQ 1141 --*/
CREATE OR REPLACE FUNCTION TRAZ_QTDSUP (TT_SUP.FILCLI%TYPE,TT_SUP.CODCLI%TYPE,TT_SUP.SITUAC%TYPE)
RETURNS Numeric AS $$
DECLARE
PFILCLI ALIAS FOR $1 ;
PCODCLI ALIAS FOR $2 ;
PSITUAC ALIAS FOR $3 ;
VQTDSUP Numeric;  
begin
  SELECT COUNT(*) INTO VQTDSUP from tt_sup sup 
  where SUP.SITUAC = PSITUAC
    AND SUP.FILCLI = PFILCLI 
    AND SUP.CODCLI = PCODCLI;    
  Return VQTDSUP;
END;
$$ language 'plpgsql';




/*-- SEQ 1142 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION UNEPLACAS (TT_VEN.CODFIL%TYPE,TT_VEN.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1143 --*/
CREATE OR REPLACE FUNCTION UNEPLACAS (TT_VEN.CODFIL%TYPE,TT_VEN.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
PCODFIL ALIAS FOR $1 ;
PSEQUEN ALIAS FOR $2 ;
VSAIDA VARCHAR(255) := '';
vPLACAS TT_VXP.PLACAS%TYPE;
DSCPLACAS CURSOR(pCODFIL TT_VEN.CODFIL%TYPE,
           pSEQUEN TT_VEN.SEQUEN%TYPE) IS
   select vxp.placas 
    From TT_VXP VXP left outer JOIN TT_VEN VEN ON  ven.CODFIL = VXP.CODFIL  and ven.SEQUEN = VXP.SEQUEN      
    where VEN.CODFIL = PCODFIL
      AND VEN.SEQUEN = PSEQUEN;       
BEGIN 
   OPEN DSCPLACAS(PCODFIL,PSEQUEN); 
   LOOP
    FETCH DSCPLACAS INTO VPLACAS;
    Exit when NOT FOUND;        
    VSAIDA := VSAIDA || VPLACAS ||'  ';
   END LOOP;    
   CLOSE DSCPLACAS; 
   RETURN VSAIDA;
END;
$$ language 'plpgsql';





/*-- SEQ 1144 --*/
/*--IGNORE ERRO--*/
drop index I_UQ_TIT_REC_SEQCAN;

/*-- SEQ 1145 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION fn_UQ_TIT_REC_SEQCAN (tt_TIT.FILREC%type,tt_TIT.SEQREC%type,tt_TIT.PARREC%type,VARCHAR) CASCADE;

/*-- SEQ 1146 --*/
CREATE OR REPLACE FUNCTION fn_UQ_TIT_REC_SEQCAN (tt_TIT.FILREC%type,tt_TIT.SEQREC%type,tt_TIT.PARREC%type,VARCHAR)
RETURNS char AS $$
DECLARE
pFILREC ALIAS FOR $1 ;
pSEQREC ALIAS FOR $2 ;
pPARREC ALIAS FOR $3 ;
pSEQCAN ALIAS FOR $4 ;
output VARCHAR(1000);

begin
 output := pFILREC||pSEQREC||pPARREC||COALESCE(pSEQCAN,'AAAAAAA');
 return (output);
end;
$$ language 'plpgsql' IMMUTABLE;



/*-- SEQ 1147 --*/
/*--IGNORE ERRO--*/
create unique index I_UQ_TIT_REC_SEQCAN on TT_TIT (fn_UQ_TIT_REC_SEQCAN(FILREC,SEQREC,PARREC,SEQCAN))  ;


/*-- SEQ 1148 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ValorLMCVenda (Numeric,TT_MDT.DATMED%type,TD_BIC.FILBIC%type,TD_BIC.SEQFIL%type,TT_GRA.FILMAT%type,TT_GRA.CODMAT%type,TT_GRA.CODCOR%type,TT_GRA.CODTAM%type,TD_BIC.CODTAB%type,Numeric,Numeric) CASCADE;

/*-- SEQ 1149 --*/
CREATE OR REPLACE FUNCTION ValorLMCVenda (Numeric,TT_MDT.DATMED%type,TD_BIC.FILBIC%type,TD_BIC.SEQFIL%type,TT_GRA.FILMAT%type,TT_GRA.CODMAT%type,TT_GRA.CODCOR%type,TT_GRA.CODTAM%type,TD_BIC.CODTAB%type,Numeric,Numeric)
RETURNS Numeric AS $$
DECLARE
pVLRMOV ALIAS FOR $1 ;
pDATMED ALIAS FOR $2 ;
pFILBIC ALIAS FOR $3 ;
pSEQFIL ALIAS FOR $4 ;
pFILMAT ALIAS FOR $5 ;
pCODMAT ALIAS FOR $6 ;
pCODCOR ALIAS FOR $7 ;
pCODTAM ALIAS FOR $8 ;
pCODBIC ALIAS FOR $9 ;
pENCABE ALIAS FOR $10 ;
pENCFEC ALIAS FOR $11 ;
  nRESULT Numeric;
BEGIN
  IF COALESCE(pVLRMOV,0) <> 0 THEN 
     nRESULT := pVLRMOV;
  ELSE 
      SELECT (SELECT /*+INDEX(IVE,I_FK_IVE_DBIC)*/
                     coalesce(SUM(VLRMOV),0) 
                FROM TT_IVE IVE 
               WHERE IVE.VEN_DATHOR BETWEEN ADD_DAY(pDATMED,-2) AND ADD_DAY(pDATMED,+6) 
                 AND IVE.FILBIC=pFILBIC 
                 AND IVE.SEQFIL=pSEQFIL
                 AND IVE.FILMAT=pFILMAT
                 AND IVE.CODMAT=pCODMAT
                 AND IVE.CODCOR=pCODCOR
                 AND IVE.CODTAM=pCODTAM
                 AND 1 = CASE WHEN pENCABE<pENCFEC AND TO_NUMBER(COALESCE(IVE.NUMEXT,'0'))/1000 BETWEEN pENCABE+0.01 AND pENCFEC THEN 1
        	                  WHEN pENCABE>pENCFEC AND (TO_NUMBER(COALESCE(IVE.NUMEXT,'0'))/1000 BETWEEN pENCABE+IVE.QTDMOV AND 9999999999999999 OR 
        	                                          TO_NUMBER(COALESCE(IVE.NUMEXT,'0'))/1000 BETWEEN 0 AND pENCFEC ) THEN 1
                              ELSE 0
        	              END
                 AND IVE.SITMOV <> 'C'
                 AND LANEST='S'
             )+(SELECT coalesce(SUM(VLRMOV),0)
                FROM TT_ABM abm
               WHERE ABM.DATOPE BETWEEN ADD_DAY(pDATMED,-2) AND ADD_DAY(pDATMED,+6)
                 AND ABM.CODBIC=pCODBIC
                 AND ABM.CODFIL=pFILBIC
                 AND 1 = CASE WHEN pENCABE<pENCFEC AND TO_NUMBER(COALESCE(ABM.ENCERR,'0'))/1000 BETWEEN pENCABE+0.01 AND pENCFEC THEN 1
        	                  WHEN pENCABE>pENCFEC AND (TO_NUMBER(COALESCE(ABM.ENCERR,'0'))/1000 BETWEEN pENCABE+ABM.QTDMOV AND 9999999999999999 OR 
        	                                          TO_NUMBER(COALESCE(ABM.ENCERR,'0'))/1000 BETWEEN 0 AND pENCFEC ) THEN 1
                              ELSE 0
        	             END
                 ) INTO nRESULT
       FROM DUAL;       
  END IF;

  RETURN nRESULT;

END;
$$ language 'plpgsql' STABLE;




/*-- SEQ 1150 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GeraTransfAutom (TT_IOR.CODFIL%TYPE,TT_IOR.FILMAT%TYPE,TT_IOR.CODMAT%TYPE,TT_IOR.CODCOR%TYPE,TT_IOR.CODTAM%TYPE,TT_IOR.FILRES%TYPE,TT_IVEXIPE.QTDENC%TYPE,TT_GRA.CUSREP%TYPE) CASCADE;

/*-- SEQ 1151 --*/
CREATE OR REPLACE FUNCTION GeraTransfAutom (TT_IOR.CODFIL%TYPE,TT_IOR.FILMAT%TYPE,TT_IOR.CODMAT%TYPE,TT_IOR.CODCOR%TYPE,TT_IOR.CODTAM%TYPE,TT_IOR.FILRES%TYPE,TT_IVEXIPE.QTDENC%TYPE,TT_GRA.CUSREP%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCodfil ALIAS FOR $1 ;
pFilmat ALIAS FOR $2 ;
pCodmat ALIAS FOR $3 ;
pCodcor ALIAS FOR $4 ;
pCodtam ALIAS FOR $5 ;
pFilres ALIAS FOR $6 ;
pQtdite ALIAS FOR $7 ;
pCusrep ALIAS FOR $8 ;
   -- Objetivos:
   -- 1. Criar sada e entrada de transferncia automtica.

   -- Declarao de variveis e cursores
   c_RESULTADO                    VARCHAR(2);
   vComplemento                   CONSTANT VARCHAR(100) := Constante('complemento');
   cCODSER                        TT_VEN.CODSER%TYPE;
   cCODNAT                        TD_NAT.CODTAB%TYPE;
   iCODCFO                        TT_CFG.TRANSFER_CODCFO%TYPE;
   cFILUSU                        TT_USU.FILUSU%TYPE;
   cCODUSU                        TT_USU.CODUSU%TYPE;
   cFILPGT                        TT_PLA.FILPGT%TYPE;
   cCODPGT                        TT_PLA.CODPGT%TYPE;
   cFILPRE                        TT_CFG.FILPRE%TYPE;
   cCODPRE                        TT_CFG.CODPRE%TYPE;
   cSEQVEN                        TT_VEN.SEQUEN%TYPE;
   vUFLOJA                        TT_VEN.UFLOJA%TYPE;
   vNUMEND                        TT_END.NUMEND%TYPE; -- RFMP 83353
   cSEQCOM                        TT_COM.SEQUEN%TYPE;
   vFILCTA                        TT_COM.FILCTA%TYPE;
   vSEQCTA                        TT_COM.SEQCTA%TYPE;
   vTIPCTA                        TT_COM.TIPCTA%TYPE;
   --cTIPCOM                        TD_FIL.TIPCOM%TYPE;
-- Incio da funo
BEGIN
   IF LeParametroBoo('USA_TRANS_AUTOMATICA', '', '', '', '') = 'T' THEN
      -- Pegando srie, natureza e cfo
      SELECT TRANSFER_SER, TRANSFER_NAT, TRANSFER_CODCFO, VC_FILPGT, VC_CODPGT, FILPRE, CODPRE
        INTO cCODSER, cCODNAT, iCODCFO, cFILPGT, cCODPGT, cFILPRE, cCODPRE
        FROM TT_CFG;

      -- cdigo cfop da entrada via transferncia no pode ser null
      IF ISNULL(TO_CHAR(iCODCFO)) = 'T' THEN
         RAISE EXCEPTION 'PG-20019 Cadastrar CFOP para transferncia automtica em TTConfig: OUTROS >> AMBIENTE >> N.F. Emitidas > Cdigo CFOP da entrada via transferncia.%' , vComplemento;
      END IF;

      -- srie da entrada via transferncia no pode ser null
      IF cCODSER IS NULL THEN
         RAISE EXCEPTION 'PG-20025 Transferncia Automtica: Cdigo de srie para nota no cadastrada(Cadastrar novo cdigo de srie em: VENDA >> SRIE >> ABA>DADOS).%' , vComplemento;
      END IF;

      -- natureza da entrada via transferncia no pode ser null
      IF cCODNAT IS NULL THEN
         RAISE EXCEPTION 'PG-20026 Transferncia Automtica: Natureza no cadastrada(Cadastrar natureza em: VENDA >> NATUREZA >> ABA>IDENTIFICAO >> CDIGO).%' , vComplemento;
      END IF;
      
      -- GES-2022061590 - Erro ao faturar pedidos do site quando filial de reserva  Atacadista, Sistema no permite gerar Transferncia Automtica
      -- Verificado processo com Pedro/Carla e a restrio de no permitir gerar a Transferncia automtica no faz sentido visto que no checkout no foram encontrados restries.
      -- Sendo assim estaremos liberando a gerao da Transferncia automtica para filial do tipo "Atacado/Equiparado a Indstria"
      --SELECT DFIL.TIPCOM INTO cTIPCOM 
      --  FROM TD_FIL DFIL
      -- WHERE DFIL.CODFIL=pFilres;
      -- No  permitido realizar transferncia para Filial do Tipo "Atacado/Equiparado a Indstria"
      --IF cTIPCOM = 'A' THEN
      --   RAISE EXCEPTION 'PG-20027 No  permitido realizar transferncia automtica a partir de uma filial atacadista. Desfaa essa operao e finalize o processo na mesma filial que foi feito o oramento.%' , vComplemento;
      --END IF;
      
      -- Pegando usurio
      SELECT FILUSU,CODUSU into cFILUSU,cCODUSU
        FROM TT_USU
       WHERE APEUSU = QUALDONO();

      cSEQVEN := NotaAbertaTransfAutom('V', pCodfil, pFilres);   
      
      IF cSEQVEN IS NULL THEN

         SELECT ProximoCodigo('TT_VEN',pFilres)
           INTO cSEQVEN
           FROM DUAL;

         SELECT CASE ORI.UFLOJA WHEN DES.UFLOJA THEN 'T'
                                      ELSE 'F'
                END into vUFLOJA
           FROM TD_FIL ORI CROSS JOIN TD_FIL DES
          WHERE ORI.CODFIL=pFilres
            AND DES.CODFIL=pCodfil;

         -- RFMP 83353
         SELECT MIN(NUMEND)
           INTO vNUMEND
           FROM TT_END
          WHERE FILCLI = pCodfil
            AND CODCLI = '     0'
            AND CODFIL = pCodfil;

         INSERT INTO TT_VEN (CODFIL,SEQUEN,NUMECF,CODSER,NUMNOT,FILCLI,CODCLI,DATHOR,FILUSU,CODUSU,FILVEN,CODVEN,
                             FILPGT,CODPGT,VLRNOT,VLRLIQ,CODNAT,FILPRE,CODPRE,PRAMED,LANVEN,DUMMY,UFLOJA,
                             FILCOB, FILENT, FILFAT, ENDCOB, ENDENT, ENDFAT)
             VALUES
             (pFilres,cSEQVEN,'000',cCODSER,
              '###'||pCodfil,pCodfil,'     0',TRUNC(agora()), cFILUSU,cCODUSU,cFILUSU,cCODUSU,
              cFILPGT,cCODPGT,pCusrep*pQtdite,pCusrep*pQtdite,cCODNAT,cFILPRE,cCODPRE,0,'F','I',vUFLOJA,
              pCodfil,pCodfil,pCodfil,vNUMEND,vNUMEND,vNUMEND);
      ELSE
         UPDATE TT_VEN
            SET VLRNOT=VLRNOT+(pCusrep*pQtdite),
                VLRLIQ=VLRLIQ+(pCusrep*pQtdite)
          WHERE CODFIL = pFilres
            AND SEQUEN = cSEQVEN;
      END IF;

      cSEQCOM := NotaAbertaTransfAutom('C', pCodfil, pFilres);

      IF cSEQCOM IS NULL THEN

         SELECT ProximoCodigo('TT_COM',pCodfil),
                FILCTA,SEQCTA,TIPCTA
           INTO cSEQCOM, vFILCTA, vSEQCTA, vTIPCTA
           FROM TD_CTA
          WHERE CFGCOL='TIPCTA_MER_REV';

         INSERT INTO TT_COM (DATCMP,DATOPE,DESCON,VLRTOT,VLRLIQ,QTDTOT,CODFIL,SEQUEN,FILFOR,CODFOR,
                             CODSER,SUBSER,NUMNOT,TIPNOT,CODMOE,MOEJUR,FLGEST,OUTTAX,SUBSTT,
                             SIGNAT,FILCTA,SEQCTA,TIPCTA,FILUSU,CODUSU,CODCFO, TIPPAR)
             VALUES
             (TRUNC(AGORA()),TRUNC(AGORA()),0,pCusrep*pQtdite,pCusrep*pQtdite,pQtdite,
              pCodfil,cSEQCOM,pFilres,'     0',cCODSER,NULL,'###'||pCodfil,
              'A',0, 0,'A',0,0,0,vFILCTA, vSEQCTA, vTIPCTA,
              cFILUSU,cCODUSU,iCODCFO, 'F');

      ELSE
         UPDATE TT_COM
            SET VLRLIQ=VLRLIQ+(pCusrep*pQtdite),
                VLRTOT=VLRTOT+(pCusrep*pQtdite),
                QTDTOT=QTDTOT+pQtdite
          WHERE CODFIL = pCodfil
            AND SEQUEN = cSEQCOM;
      END IF;
   END IF;

   c_RESULTADO := 'OK';
   RETURN c_RESULTADO;

END;
$$ language 'plpgsql';




/*-- SEQ 1152 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_DIRE (TD_IRE.ICMSRE%TYPE,TD_IRE.REDTRA%TYPE,TD_IRE.REDCON%TYPE,TD_IRE.APLCON%TYPE) CASCADE;

/*-- SEQ 1153 --*/
CREATE OR REPLACE FUNCTION IMPORTA_DIRE (TD_IRE.ICMSRE%TYPE,TD_IRE.REDTRA%TYPE,TD_IRE.REDCON%TYPE,TD_IRE.APLCON%TYPE)
RETURNS Numeric AS $$
DECLARE
pICMSRE ALIAS FOR $1 ;
pREDTRA ALIAS FOR $2 ;
pREDCON ALIAS FOR $3 ;
pAPLCON ALIAS FOR $4 ;

   cCOMANDO                         VARCHAR(255);
   nQTD                             Numeric;
   nCODIGO                          Numeric;
   cAPLCON                          TD_IRE.APLCON%TYPE;
   
   curs1                            refcursor;
   
BEGIN

   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20026 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

   -- Define um Valor Padro
   cAPLCON := pAPLCON;
   IF ISNULL(cAPLCON)='T' THEN
      cAPLCON := 'T';
   END IF;
   -- Valida se o valor  aceito conforme definio do Domnio
   SELECT COUNT(*) 
     INTO nQTD
     FROM TT_DOM 
    WHERE CODARQ = 'DIRE' AND NOMCPO = 'APLCON' AND CODCHR = cAPLCON;
   IF (nQTD = 0) THEN
      RAISE EXCEPTION 'PG-20010 Valor informado para coluna "APLCON - Aplica a consumidor final"  invlido.';
   END IF;

   cCOMANDO := 'SELECT COUNT(*), MAX( CODTAB ) FROM TD_IRE  WHERE ICMSRE = '|| TO_CHAR( pICMSRE );
   IF (pREDTRA IS NOT NULL) THEN 
      cCOMANDO := cCOMANDO ||' AND COALESCE(REDTRA, 0) = ' || TO_CHAR( pREDTRA );
   END IF;
   IF (pREDCON IS NOT NULL) THEN
      cCOMANDO := cCOMANDO ||' AND REDCON = ' || TO_CHAR( pREDCON );
   END IF;
   IF (cAPLCON IS NOT NULL) THEN
      cCOMANDO := cCOMANDO ||' AND APLCON = ' || chr(39)||cAPLCON||chr(39);
   END IF;

      
      OPEN CURS1 FOR EXECUTE cCOMANDO;
      FETCH curs1 INTO nQTD, nCODIGO;
      CLOSE curs1;
   
   --------------------------------------------------------------------------------------
   -- 1. Incluso de novo registro
   --------------------------------------------------------------------------------------
   IF (nQTD = 0) OR (nQTD IS NULL) THEN
      cCOMANDO := 'SELECT MAX( CODTAB ) FROM TD_IRE';
            
         OPEN CURS1 FOR EXECUTE cCOMANDO;
         FETCH curs1 INTO nCODIGO;
         CLOSE curs1;
            IF nCODIGO IS NULL THEN
         nCODIGO := 0;
      END IF;
      cCOMANDO := 'INSERT INTO TD_IND (CODTAB) (SELECT D.PROXIMO FROM (SELECT '|| TO_CHAR( nCODIGO+1 ) || ' AS PROXIMO FROM DUAL) D LEFT JOIN TD_IND I ON I.CODTAB = D.PROXIMO WHERE I.CODTAB IS NULL)';
            
         EXECUTE cCOMANDO;
            nCODIGO := nCODIGO + 1;

      cCOMANDO := 'INSERT INTO TD_IRE (CODTAB, RE_ATI, ICMSRE ' ||
                    CASE WHEN pREDTRA IS NOT NULL THEN ', REDTRA' ELSE '' END ||
                    CASE WHEN pREDCON IS NOT NULL THEN ', REDCON' ELSE '' END ||
                    CASE WHEN cAPLCON IS NOT NULL THEN ', APLCON' ELSE '' END ||
                    ') ' ||
                    'VALUES (' || TO_CHAR(nCODIGO) || ', ' || chr(39)||'T'||chr(39) || ', '|| TO_CHAR( pICMSRE) ||
                    CASE WHEN pREDTRA IS NOT NULL THEN ', ' || TO_CHAR( pREDTRA) ELSE '' END ||
                    CASE WHEN pREDCON IS NOT NULL THEN ', ' || TO_CHAR( pREDCON) ELSE '' END ||
                    CASE WHEN cAPLCON IS NOT NULL THEN ', ' || chr(39)||cAPLCON||chr(39) ELSE '' END ||
                    ')';
                  
            EXECUTE cCOMANDO;
         
   -- No faz sentido tratar a alterao da tabela TD_IRE, pois atualmente todos os campos so utilizados como regra para pesquisa.
   /*
   --------------------------------------------------------------------------------------
   -- 2. Alterao do registro
   --------------------------------------------------------------------------------------
   ELSE

      cCOMANDO := 'UPDATE TD_IRE SET ' ||
                 '       ICMSRE = '|| TO_CHAR( pICMSRE) || 
                 CASE WHEN pREDTRA IS NOT NULL THEN ', REDTRA = ' || TO_CHAR( pREDTRA) ELSE '' END ||
                 CASE WHEN pREDCON IS NOT NULL THEN ', REDCON = ' || TO_CHAR( pREDCON) ELSE '' END ||
                 CASE WHEN cAPLCON IS NOT NULL THEN ', APLCON = ' || chr(39)||cAPLCON||chr(39) ELSE '' END ||
                 ' WHERE CODTAB = ' || TO_CHAR( nCODIGO );

            
      EXECUTE cCOMANDO;
         */

   END IF;

   RETURN nCODIGO;

END;
$$ language 'plpgsql';




/*-- SEQ 1154 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION InsereDiasUteisFilial (TT_UTL.CODFIL%TYPE,TT_UTL.DATOPE%TYPE,TT_UTL.DATOPE%TYPE,TT_UTL.FERABE%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1155 --*/
CREATE OR REPLACE FUNCTION InsereDiasUteisFilial (TT_UTL.CODFIL%TYPE,TT_UTL.DATOPE%TYPE,TT_UTL.DATOPE%TYPE,TT_UTL.FERABE%TYPE,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
p_Filial ALIAS FOR $1 ;
p_DataIni ALIAS FOR $2 ;
p_DataFim ALIAS FOR $3 ;
p_FERABE ALIAS FOR $4 ;
p_DUMMY ALIAS FOR $5 ;

-- Objetivos:
-- 1. Inserir dias úteis para uma filial

-- Declaração de variáveis
c_RESULTADO VARCHAR(2);
d_DATAINI TT_UTL.DATOPE%TYPE;
d_DATAFIM TT_UTL.DATOPE%TYPE;
b_Insere BOOLEAN;

-- Início da função
BEGIN

  -- Se não vier parâmetro de data, elimina tudo da filial e insere novamente
  -- Senão, refaz só o período solicitado
  IF p_DataIni IS NULL THEN
    SELECT MIN(DATOPE), MAX(DATOPE) INTO d_DATAINI, d_DATAFIM
      FROM TT_DAT;
  ELSE
    d_DATAINI := p_DataIni;
    d_DATAFIM := p_DataFim;
  END IF;

  DELETE FROM TT_UTL
   WHERE CODFIL = p_Filial
     AND DATOPE BETWEEN TRUNC(d_DATAINI) AND TRUNC(d_DATAFIM);

  -- se vier da trigger da TT_FER, basta inserir a data sem fazer nenhuma verificação
  -- isso evita mutante em Oracle
  IF COALESCE(p_Dummy,'XX') <> Constante('VEM_DE_TGFER') THEN
    INSERT INTO TT_UTL
      SELECT TAB.DATOPE,TAB.CODFIL,TAB.FERABE
        FROM
      (
        SELECT DAT.DATOPE,
               CAST(p_Filial AS CHAR(3)) AS CODFIL,
               CAST(TO_CHAR(TO_NUMBER(TO_CHAR(DAT.DATOPE,'D'))-1) AS CHAR(1)) AS DIASEM,
               CAST(IsFeriadoAberto(p_Filial,DAT.DATOPE) AS VARCHAR(1)) AS FERABE
          FROM TT_DAT DAT
         WHERE DAT.DATOPE BETWEEN TRUNC(d_DATAINI) AND TRUNC(d_DATAFIM)
      ) TAB
       WHERE (DiaUtil(TAB.CODFIL,TAB.DATOPE) = 'T') OR (TAB.FERABE = 'T');
  ELSE
    b_Insere := TRUE;
    
    IF p_FERABE = 'F' THEN
        IF DiaUtil(p_Filial,d_DATAINI) = 'F' THEN
            b_Insere := FALSE;
        END IF;
    END IF;
    
    IF b_Insere THEN
        INSERT INTO TT_UTL
        SELECT d_DATAINI,p_Filial,p_FERABE
          FROM DUAL
         WHERE NOT EXISTS (SELECT 1 AS OK
                             FROM TT_UTL
                            WHERE DATOPE = d_DATAINI
                              AND CODFIL = p_Filial); 
    END IF;
  END IF;

  RETURN 'OK';

END;
$$ language 'plpgsql';


/*-- SEQ 1156 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION InsereDiasUteisFilial (TT_UTL.CODFIL%TYPE) CASCADE;

/*-- SEQ 1157 --*/
CREATE OR REPLACE FUNCTION InsereDiasUteisFilial (TT_UTL.CODFIL%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN InsereDiasUteisFilial($1,NULL,NULL,'T',NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1158 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ZeraLimiteDeCredito () CASCADE;

/*-- SEQ 1159 --*/
CREATE OR REPLACE FUNCTION ZeraLimiteDeCredito ()
RETURNS VARCHAR AS $$
DECLARE


-- Objetivos:
-- 1. Zerar o limite de crdito quando cliente no tiver mais feito compras.

-- Declarao de variveis e cursores
   cMANUT                  TT_IDF.MANUT%TYPE;
   COMPLEMENTO             CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');
   iLIMDIA                 TT_CFG.LIMDIA%TYPE;
   cFILCLI                 TT_CLI.FILCLI%TYPE;
   cCODCLI                 TT_CLI.CODCLI%TYPE;

-- Incio da funo
BEGIN

   SELECT MANUT INTO cMANUT
     FROM TT_IDF;

   IF cMANUT = 'T' THEN
      RAISE EXCEPTION 'PG-20000 Base em manuteno. %' , COMPLEMENTO;
   END IF;

   SELECT LIMDIA INTO iLIMDIA
     FROM TT_CFG;

   IF COALESCE(iLIMDIA,0) > 0 THEN

      UPDATE TT_CLI
         SET VALOR1 = 0
       WHERE ADD_DAY(TRUNC(COALESCE(ULTCOM, DATOPE)), iLIMDIA) < TRUNC(Agora())
         AND COALESCE(VALOR1,0) <> 0;

   END IF;

   RETURN 'OK';

END;
$$ language 'plpgsql';



/*-- SEQ 1160 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_ZeraLimiteDeCredito () CASCADE;

/*-- SEQ 1161 --*/
CREATE OR REPLACE FUNCTION Job_ZeraLimiteDeCredito ()
RETURNS VARCHAR AS $$
DECLARE


-- Objetivos:
-- 1. Executar funo ZeraLimiteDeCredito.
-- 2. Registrar o resultado na TT_JOB.

-- Declarao de variveis e cursores
  cNOMJOB                  TT_JOB.NOMJOB%TYPE;
  cDESJOB                  TT_JOB.DESJOB%TYPE;
  cDummy                   CHAR(2);

-- Incio da funo
begin
   cNOMJOB := 'JOB_ZERALIMITEDECREDITO';
   cDESJOB := 'Zera limite de crdito expirados';
   BEGIN
      cDummy := ZeraLimiteDeCredito();
      cDummy := RegistraJob(cNOMJOB, cDESJOB);
   EXCEPTION
      WHEN OTHERS THEN cDummy := RegistraJob(cNOMJOB, cDESJOB, SQLERRM);
   END;
  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1162 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION NumeroVendasKIT (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TD_MUL.CODTAB%TYPE) CASCADE;

/*-- SEQ 1163 --*/
CREATE OR REPLACE FUNCTION NumeroVendasKIT (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TD_MUL.CODTAB%TYPE)
RETURNS Numeric AS $$
DECLARE
pDatIni ALIAS FOR $1 ;
pDatFim ALIAS FOR $2 ;
pFILMAT ALIAS FOR $3 ;
pCODMAT ALIAS FOR $4 ;
pCODCOR ALIAS FOR $5 ;
pCODTAM ALIAS FOR $6 ;
pCODFIL ALIAS FOR $7 ;
pCODMUL ALIAS FOR $8 ;

-- Objetivos:
-- 1. Conta nmero de vendas em determinado perodo para determinada grade de produto.
--    Baseado em Nota Fiscal e Fatura.

-- Declarao de variveis e cursores
   nCount                        Numeric(9);
   cRetorno                      VARCHAR(254);
   nQtdIte                       TT_KIT.QTDITE%TYPE;
   cFilmat                       TT_GRA.FILMAT%TYPE;
   cCodmat                       TT_GRA.CODMAT%TYPE;
   nCodcor                       TT_GRA.CODCOR%TYPE;
   nCodtam                       TT_GRA.CODTAM%TYPE;
-- Incio da funo
BEGIN
   nCount  := 0;

   -- MN - Essa funo  destinada para headers de kit, como o POS no vende headers, somente os itens, deve-se procurar um item de "referncia"
   -- para verificar quantas vendas o item de "referncia" teve e inferir a quantidade de vendas do header do kit.
   SELECT TrazItemReferenciaKit(pFILMAT, pCODMAT, pCODCOR, pCODTAM)
     INTO cRetorno
     FROM DUAL;

   IF COALESCE(cRetorno, 'X') <> 'X' THEN
      cFilmat := Split_Part(cRetorno, ';', 1);
      cCodmat := Split_Part(cRetorno, ';', 2);
      nCodcor := Split_Part_Number(cRetorno, ';', 3);
      nCodtam := Split_Part_Number(cRetorno, ';', 4);
      nQtdIte := Split_Part_Number(cRetorno, ';', 5);
      
      SELECT NumeroVendas(pDatIni, pDatFim, cFilmat, cCodmat, nCodcor, nCodtam, pCODFIL, pCODMUL)
        INTO nCount
        FROM DUAL;

      -- MN - A ideia dessa diviso,  que o item referncia,  o item com maior quantidade dentro do kit, ento primeiros
      -- pegamos quantos itens foram vendidos, por exemplo, 2000 unidades do item referncia, agora para sabermos quantos KITS
      -- foram vendidos, devemos dividir a quantidade vendida, pela quantidade necessria para montar UM nico kit.
      IF nQtdIte > 0 THEN
         nCount := nCount / nQtdIte;
      END IF;
   END IF;
  
   RETURN COALESCE(nCount,0);

END;
$$ language 'plpgsql';





CREATE OR REPLACE FUNCTION PC_CLI_Vinculado_Update (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,TT_CLI.FILVIN%TYPE,TT_CLI.CODVIN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILCLI ALIAS FOR $1 ;
pCODCLI ALIAS FOR $2 ;
pFILVIN ALIAS FOR $3 ;
pCODVIN ALIAS FOR $4 ;
-- Objetivos:
-- 1. Explicar o objetivo 1 aqui...
-- 2. Explicar o objetivo 2 aqui...
 
-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');
   cTemVinculoRecursivo          VARCHAR(1);
      
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
      vMensagem                     VARCHAR(500);
-- Incio da procedure
BEGIN
   -- Incluir os tratamentos aqui...
   cTemVinculoRecursivo := ParceiroTemVinculoRecursivo(pFILCLI, pCODCLI, pFILVIN, pCODVIN );
    IF (cTemVinculoRecursivo = 'T') THEN
        vMensagem := 'No  possvel atribuir o parceiro "'||pFILVIN||'-'||pCODVIN||'" informado em "Financeiro >> Geral >> Vinculado a:".'||CRLF||
                     'Essa atribuio cria uma referncia circular o que impede o faturamento.'||CRLF||
                     'Para evitar a referncia circular, verifique o cadastro do parceiro e seu vnculo financeiro.';
                
           RAISE EXCEPTION 'PG-20023 %', vMensagem;
                
    END IF;

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1164 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AceiteChamados () CASCADE;

/*-- SEQ 1165 --*/
CREATE OR REPLACE FUNCTION AceiteChamados ()
RETURNS VARCHAR AS $$
DECLARE

    vCOMPENSA VARCHAR(1);
    VDIAS_COMP_AUT Numeric(2);
  BEGIN
    update tt_sup set omisso = 'T', flgact = 'T'
     where coalesce(flgact,'F') <> 'T'
       and omisso is null
       and situac = 'R'
       and datfec < add_day(trunc( agora()), - 8)
       and (filcli,codcli) not in (select filcli,codcli from tt_cli where nomcli like 'COMERCIAL SINUELO%')
       ;

  RETURN 'OK';
END;
$$ language 'plpgsql';





/*-- SEQ 1166 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ASSINA_DAV (TT_ORC.CODFIL%TYPE,TT_ORC.NUMPED%TYPE,TT_ORC.TIPPED%TYPE,TT_ORC.ASSINA%TYPE) CASCADE;

/*-- SEQ 1167 --*/
CREATE OR REPLACE FUNCTION ASSINA_DAV (TT_ORC.CODFIL%TYPE,TT_ORC.NUMPED%TYPE,TT_ORC.TIPPED%TYPE,TT_ORC.ASSINA%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pNUMPED ALIAS FOR $2 ;
pTIPPED ALIAS FOR $3 ;
pASSINA ALIAS FOR $4 ;
  
  vComplemento CONSTANT VARCHAR(254):= constante('complemento');
  vErro        VARCHAR(4000);
  CRLF         CONSTANT CHAR(1) := CHR(10);

BEGIN
  -- Valida parmetros.
  vErro := '';

  IF ISNULL(pCODFIL) = 'T' THEN
    vErro := 'CODFIL- Filialda DAV.'||CRLF;
  END IF;
  IF ISNULL(pNUMPED) = 'T' THEN
    vErro := vErro || 'NUMPED - Nmeroda DAV ou Pr-Venda.'||CRLF;
  END IF;
  IF ISNULL(pTIPPED) = 'T' THEN
    vErro := vErro || 'TIPPED- Tipo Pedido/OS.'||CRLF;
  END IF;

  IF ISNOTNULL(vErro)='T' THEN
    RAISE EXCEPTION 'PG-20010 Os seguintes campos no foram informados e gerou inconsistncias : %' , vErro;
  END IF;
     
 UPDATE TT_ORC
    SET ASSINA = pASSINA,
        CODUID = NULL
  WHERE CODFIL = pCODFIL
    AND NUMPED = pNUMPED
    AND TIPPED = pTIPPED;

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1168 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CANCELAITEM_DAV (TT_IOR.CODFIL%TYPE,TT_IOR.TIPPED%TYPE,TT_IOR.NUMPED%TYPE,TT_IOR.NUMITE%TYPE) CASCADE;

/*-- SEQ 1169 --*/
CREATE OR REPLACE FUNCTION CANCELAITEM_DAV (TT_IOR.CODFIL%TYPE,TT_IOR.TIPPED%TYPE,TT_IOR.NUMPED%TYPE,TT_IOR.NUMITE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pTIPPED ALIAS FOR $2 ;
pNUMPED ALIAS FOR $3 ;
pNUMITE ALIAS FOR $4 ;

  WK_NUMPED    TT_IOR.NUMPED%TYPE;
  WK_NUMITE    TT_IOR.NUMITE%TYPE;
  WK_FLGEST    TT_IOR.FLGEST%TYPE;

  vComplemento CONSTANT VARCHAR(254):= constante('complemento');
  vErro        VARCHAR(4000);
  CRLF         CONSTANT CHAR(1) := CHR(10);
  WK_QTDIOR    Numeric;

BEGIN  
  -- Valida parmetros.
  vErro := '';

  IF ISNULL(pCODFIL) = 'T' THEN
    vErro := 'CODFIL- Filialda DAV.'||CRLF;
  END IF;
  IF ISNULL(pTIPPED) = 'T' THEN
    vErro := vErro || 'TIPPED - Tipo da DAV ou Pr-Venda.'||CRLF;
  END IF;  
  IF ISNULL(pNUMPED) = 'T' THEN
    vErro := vErro || 'NUMPED - Nmeroda DAV ou Pr-Venda.'||CRLF;
  END IF;
  IF pNUMITE IS NULL THEN
    vErro := vErro || 'NUMITE- Item(nmero sequencial por DAV).'||CRLF;
  END IF;

  IF ISNOTNULL(vErro)='T' THEN
    RAISE EXCEPTION 'PG-20010 Os seguintes campos no foram informados e gerou inconsistncias : %' , vErro;
  END IF;
  
  BEGIN
    SELECT NUMPED INTO WK_NUMPED
      FROM TT_ORC
     WHERE CODFIL = pCODFIL
	   AND TIPPED = pTIPPED
       AND NUMPED = pNUMPED;
  EXCEPTION
        
    WHEN others THEN NULL;
        RAISE EXCEPTION 'PG-20011 Oraamento "%" nao presente na base de dados. %' , pNUMPED,VComplemento;
  END;
  
  BEGIN
  SELECT NUMITE, FLGEST INTO WK_NUMITE, WK_FLGEST
    FROM TT_IOR
   WHERE CODFIL = pCODFIL 
     AND TIPPED = pTIPPED
     AND NUMPED = WK_NUMPED
     AND NUMITE = pNUMITE;
  EXCEPTION    
        
    WHEN others THEN WK_NUMITE := NULL;                    
        RAISE EXCEPTION 'PG-20012 Item no encontrado. %' , VComplemento;
  END; 
  
  SELECT COUNT(*) 
    INTO WK_QTDIOR
    FROM TT_IOR IOR
   WHERE (IOR.FLGEST = 'E'        OR
          IOR.ECFVEN IS NOT NULL) AND
          IOR.NUMPED = WK_NUMPED  AND
          IOR.TIPPED = pTIPPED    AND
          IOR.CODFIL = pCODFIL;	  
		  
    IF WK_QTDIOR > 0  THEN
       RAISE EXCEPTION 'PG-20000 No  permitido cancelar um oramento com itens vendidos ou estar com o nmero de ECF preenchido. %' , VComplemento;
	ELSE
       IF (ISNOTNULL(WK_NUMPED)='T') AND (WK_NUMITE IS NOT NULL) THEN
          UPDATE TT_IOR
             SET FLGEST = 'C'
           WHERE CODFIL = pCODFIL
	         AND TIPPED = pTIPPED
             AND NUMPED = pNUMPED
			 AND NUMITE = pNUMITE;
			 
	     UPDATE TT_IOR
            SET TIPENT = '6'
          WHERE CODFIL = pCODFIL
 	      AND TIPPED = pTIPPED
          AND NUMPED = pNUMPED;
    
         UPDATE TT_ORC
            SET TIPENT = '6'
          WHERE CODFIL = pCODFIL
	      AND TIPPED = pTIPPED	 
          AND NUMPED = pNUMPED;
		  
	   END IF; 		 
    END IF;


  RETURN NULL;

END;
$$ language 'plpgsql';





/*-- SEQ 1170 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CANCELA_DAV (TT_ORC.CODFIL%TYPE,TT_ORC.NUMPED%TYPE) CASCADE;

/*-- SEQ 1171 --*/
CREATE OR REPLACE FUNCTION CANCELA_DAV (TT_ORC.CODFIL%TYPE,TT_ORC.NUMPED%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pNUMPED ALIAS FOR $2 ;
  
  WK_NUMPED    TT_ORC.NUMPED%TYPE;
  WK_PREDAV    TT_ORC.PREDAV%TYPE;
  WK_TIPPED    TT_ORC.TIPPED%TYPE;

  vComplemento CONSTANT VARCHAR(254):= constante('complemento');
  vErro        VARCHAR(4000);
  CRLF         CONSTANT CHAR(1) := CHR(10);

BEGIN
  -- Valida parmetros.
  vErro := '';
  WK_TIPPED := 'O';

  IF ISNULL(pCODFIL) = 'T' THEN
    vErro := 'CODFIL- Filialda DAV.'||CRLF;
  END IF;
  IF ISNULL(pNUMPED) = 'T' THEN
    vErro := vErro || 'NUMPED - Nmeroda DAV ou Pr-Venda.'||CRLF;
  END IF;  

  IF ISNOTNULL(vErro)='T' THEN
    RAISE EXCEPTION 'PG-20010 Os seguintes campos no foram informados e gerou inconsistncias : %' , vErro;
  END IF;

  BEGIN
    SELECT NUMPED, PREDAV INTO WK_NUMPED, WK_PREDAV
      FROM TT_ORC
     WHERE CODFIL = pCODFIL
       AND NUMPED = pNUMPED
       AND TIPPED = WK_TIPPED;       
  EXCEPTION
        
    WHEN others THEN NULL;
        RAISE EXCEPTION 'PG-20011 Oramento "%" no presente na base de dados. %' , pNUMPED,VComplemento;
  END;

  IF (ISNOTNULL(WK_NUMPED)='T') AND (WK_PREDAV='D') THEN
    UPDATE TT_ORC
       SET FLGEST = 'C'
     WHERE CODFIL = pCODFIL
       AND NUMPED = WK_NUMPED
       AND TIPPED = WK_TIPPED;
  ELSE
    RAISE EXCEPTION 'PG-20012 Somente DAVs podem ser canceladas. %' , VComplemento;
  END IF;

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1172 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GeraCCCartaoProprio () CASCADE;

/*-- SEQ 1173 --*/
CREATE OR REPLACE FUNCTION GeraCCCartaoProprio ()
RETURNS VARCHAR AS $$
DECLARE


CR_PARCELAS CURSOR(PDATA Timestamp) IS
    select REC.CODFIL, REC.SEQUEN,REC.NUMPAR, REC.SUBPAR, REC.VLRPAR, REC.TIPCCC, VEN.FILCLI, VEN.CODCLI, VEN.CODSER, VEN.NUMNOT, REC.PORTAD,
           REC.DATINC
      from tt_rec REC INNER JOIN TT_VEN VEN ON REC.CODFIL=VEN.CODFIL AND REC.SEQUEN=VEN.SEQUEN
                      INNER JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT AND PLA.CODPGT = VEN.CODPGT
                 LEFT OUTER JOIN TR_ECF ECF ON (ECF.CODFIL = VEN.CODFIL AND ECF.NUMECF = VEN.NUMECF)
                                                and VEN.NUMNOT NOT LIKE '%#%'
                                               and TO_NUMBER(REPLACE(VEN.NUMNOT,'#','')) BETWEEN ECF.CUPINI AND ECF.CUPFIM
                                               AND VEN.CNT_RO = ECF.CNT_RO, TT_CFG CFG
     where PLA.USACPP = 'T'
       AND REC.FLGEST = 'A'
       AND REC.TIPCCC IS NOT NULL
       and VEN.VLRLIQ > 0
       and VEN.FLGEST <> 'C'
       AND VEN.LANVEN = 'T'
       AND REC.DATVEN <= PDATA
       and not exists (SELECT 1 AS OK
                          FROM TT_VEN VDD LEFT JOIN TR_ECF RECF ON (RECF.CODFIL = VDD.CODFIL AND RECF.NUMECF = VDD.NUMECF)
                                               and VDD.NUMNOT NOT LIKE '%#%'
                                               and TO_NUMBER(REPLACE(VDD.NUMNOT,'#','')) BETWEEN RECF.CUPINI AND RECF.CUPFIM
                                               AND VDD.CNT_RO = RECF.CNT_RO
                        WHERE VDD.CODFIL = VEN.CODFIL
                          and VDD.DATFIS = Ven.datfis
                          and Recf.diafec is null
                          and VDD.CODSER in ('CF','TK')
                          and COALESCE(CFG.LOJA_FECHADA,'T') = 'T');

  vCODFIL TT_REC.CODFIL%TYPE;
  vSEQUEN TT_REC.SEQUEN%TYPE;
  vNUMPAR TT_REC.NUMPAR%TYPE;
  vSUBPAR TT_REC.SUBPAR%TYPE;
  vVLRPAR TT_REC.VLRPAR%TYPE;
  vTIPCCC TT_REC.TIPCCC%TYPE;
  vPORTAD TT_REC.PORTAD%TYPE;
  vFILCLI TT_VEN.FILCLI%TYPE;
  vCODCLI TT_VEN.CODCLI%TYPE;
  vCODSER TT_VEN.CODSER%TYPE;
  vNUMNOT TT_VEN.NUMNOT%TYPE;
  VFILUSU TT_USU.FILUSU%TYPE;
  VCODUSU TT_USU.CODUSU%TYPE;
  vDATVEN TT_REC.DATVEN%TYPE;
  vDATINC TT_REC.DATINC%TYPE;
  vEXP_REC_DATA_VENDA TT_CFG.EXP_REC_DATA_VENDA%TYPE;
  WK_COUNT  Numeric(5);

BEGIN

   select filusu,codusu into vFILUSU,vCODUSU
     from tt_usu
    where apeusu=qualdono();

   SELECT EXP_REC_DATA_VENDA INTO vEXP_REC_DATA_VENDA FROM TT_CFG;

   IF vEXP_REC_DATA_VENDA = 'F' THEN
      vDATVEN := AGORA();
   ELSE
      vDATVEN := TO_DATE('31/12/2500','DD/MM/YYYY');
   END IF;

   OPEN CR_PARCELAS(vDATVEN);
   LOOP
      FETCH CR_PARCELAS INTO vCODFIL, vSEQUEN, vNUMPAR, vSUBPAR, vVLRPAR, vTIPCCC,
                             vFILCLI, vCODCLI, vCODSER, vNUMNOT, vPORTAD, vDATINC;

      EXIT WHEN NOT FOUND;

      SELECT COUNT(*)
        INTO WK_COUNT
        FROM (SELECT REC.CODFIL, REC.SEQUEN,REC.NUMPAR, REC.SUBPAR
                FROM TT_REC REC INNER JOIN TT_VEN VEN ON REC.CODFIL=VEN.CODFIL AND REC.SEQUEN=VEN.SEQUEN
                                INNER JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT AND PLA.CODPGT = VEN.CODPGT
                           LEFT OUTER JOIN TR_ECF ECF ON (ECF.CODFIL = VEN.CODFIL AND ECF.NUMECF = VEN.NUMECF)
                                                     AND VEN.NUMNOT NOT LIKE '%#%' AND TO_NUMBER(REPLACE(VEN.NUMNOT,'#','')) BETWEEN ECF.CUPINI AND ECF.CUPFIM
                                                     AND VEN.CNT_RO = ECF.CNT_RO
               WHERE PLA.USACPP = 'T'
                 AND REC.FLGEST = 'A'
                 AND REC.TIPCCC IS NOT NULL
                 AND VEN.VLRLIQ > 0
                 AND VEN.FLGEST <> 'C'
                 AND REC.DATVEN <= vDATVEN
                 AND REC.CODFIL = vCODFIL
                 AND REC.SEQUEN = vSEQUEN
                 AND REC.NUMPAR = vNUMPAR
                 AND REC.SUBPAR = vSUBPAR
             ) A;
      IF WK_COUNT = 1 THEN
          UPDATE TT_REC
             SET FLGEST = 'P',
                 PAGAME = AGORA(),
                 ATU_EM = AGORA(),
                 NUMECF = '000',
                 VLRPGT = VLRPAR,
                 FILUSU = vFILUSU,
                 CODUSU = vCODUSU,
                 VLRDES = 0,
                 FILREC = CODFIL
           WHERE SEQUEN = vSEQUEN
             and CODFIL = vCODFIL
             and NUMPAR = vNUMPAR
             and SUBPAR = vSUBPAR;

          UPDATE TT_VEN
             SET FLGEST = '?'
           WHERE CODFIL = vCODFIL
             and SEQUEN = vSEQUEN;

          INSERT INTO TT_CCC
           (CODVEN, SEQVEN ,NUMPAR, SUBPAR, CODFIL, FILCLI, CODCLI, DATOPE, NUMDOC,
            FILUSU, CODUSU,  VLRLAN, TIPCCC, NUMECF, PORORI, TIPLAN)
          VALUES
            (vCODFIL,
             vSEQUEN,
             vNUMPAR,
             vSUBPAR,
             vCODFIL,
             vFILCLI, vCODCLI,
             vDATINC,
             vCODSER||vNUMNOT,
             vFILUSU,
             vCODUSU,
             vVLRPAR*-1,
             vTIPCCC,
             '000',
             vPORTAD,
             'P');
      END IF;

   END LOOP;
   CLOSE CR_PARCELAS;


  RETURN 'OK';

END;
$$ language 'plpgsql';





/*-- SEQ 1174 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION EXPORTA_CHR () CASCADE;

/*-- SEQ 1175 --*/
CREATE OR REPLACE FUNCTION EXPORTA_CHR ()
RETURNS VARCHAR AS $$
DECLARE

-- Objetivo:
-- 1) Exportao de cheques
WK_QTDEXP Numeric;
WK_EXPORT TT_IED.EXPORT%TYPE;
WK_MANTEM TT_IED.MANTEM%TYPE;
WK_CNTEXP TT_IED.CNTEXP%TYPE;
WK_MAI_FR TT_CFG.MAI_FR%TYPE;
WK_MAI_TO TT_CFG.MAI_TO%TYPE;
WK_MOTREJ TI_CLI.MOTREJ%TYPE;
WK_SAC_E_MAIL TT_CFG.SAC_E_MAIL%TYPE;
WK_DIALIM     TT_IED.DIALIM%TYPE;

BEGIN

   SELECT COALESCE(EXPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTEXP,0), COALESCE(DIALIM,0)
     INTO WK_EXPORT, WK_MANTEM, WK_CNTEXP, WK_DIALIM
     FROM TT_IED
    WHERE TABELA = 'CHR';

   IF WK_EXPORT = 'T' THEN

   WK_CNTEXP := WK_CNTEXP + 1;
   WK_QTDEXP := 0;
   WK_MOTREJ := '';

           INSERT INTO TE_CHR (TIPOPE,ALINEA,ATU_EM,AUTORI,CDCMC7,CODAGE,CODBCO,DOCCLI,CODFIL,CODUSU,DATOPE,DATVEN,
                               FLGEST,NUMCHE,NUMCON,NUMDEP,NUMDOC,NUMECF,OBSLOG,PAGAME,PORTAD,SERCHE,VLRCHE,VLRDIF,
                               VLRORI,DATEXP)
                              (SELECT 'I' AS TIPOPE,
                                      CHR.ALINEA AS ALINEA,
                                      AGORA() AS ATU_EM,
                                      CHR.AUTORI AS AUTORI,
                                      CHR.CDCMC7 AS CDCMC7,
                                      CHR.CODAGE AS CODAGE,
                                      CHR.CODBCO AS CODBCO,
                                      CLI.NUMDOC AS DOCCLI,
                                      CHR.CODFIL AS CODFIL,
                                      USU.CODEXT AS CODUSU,
                                      CHR.DATOPE AS DATOPE,
                                      CHR.DATVEN AS DATVEN,
                                      CHR.FLGEST AS FLGEST,
                                      CHR.NUMCHE AS NUMCHE,
                                      CHR.NUMCON AS NUMCON,
                                      CHR.NUMDEP AS NUMDEP,
                                      CHR.NUMDOC AS NUMDOC,
                                      CHR.NUMECF AS NUMECF,
                                      CHR.OBSLOG AS OBSLOG,
                                      CHR.PAGAME AS PAGAME,
                                      CHR.PORTAD AS PORTAD,
                                      CHR.SERCHE AS SERCHE,
                                      CHR.VLRCHE AS VLRCHE,
                                      CHR.VLRDIF AS VLRDIF,
                                      CHR.VLRORI AS VLRORI,
                                      AGORA()
                                 FROM TT_CHR CHR INNER JOIN TT_CLI CLI ON CLI.FILCLI = CHR.FILCLI AND CLI.CODCLI = CHR.CODCLI
                                                 INNER JOIN TT_USU USU ON USU.FILUSU = CHR.FILUSU AND USU.CODUSU = CHR.CODUSU
                                WHERE COALESCE(CHR.EXPORT,'F') = 'F'
                                  AND CHR.FLGEST <> 'X');

           SELECT COUNT(*)
            INTO WK_QTDEXP
            FROM TT_CHR CHR INNER JOIN TT_CLI CLI ON CLI.FILCLI = CHR.FILCLI AND CLI.CODCLI = CHR.CODCLI
                           INNER JOIN TT_USU USU ON USU.FILUSU = CHR.FILUSU AND USU.CODUSU = CHR.CODUSU
           WHERE COALESCE(CHR.EXPORT,'F') = 'F'
             AND CHR.FLGEST <> 'X';


             UPDATE TT_CHR SET EXPORT = 'T'
              WHERE COALESCE(EXPORT,'F') = 'F'
                AND FLGEST <> 'X';



   IF WK_MOTREJ <> '' THEN
      SELECT MAI_FR, MAI_TO, SAC_E_MAIL
        INTO WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL
        FROM TT_CFG;
      IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
         INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO, MAI_CC,
                             TEXTOS,TIPMSG)
                     VALUES ('001','F',AGORA(),'ERRO NA EXPORTAO DE CHEQUES',WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL,
                             'Problema na exportao de cheques. Verifique!','T');
      END IF;
    END IF;

   IF WK_MANTEM = 'F' THEN
        IF WK_DIALIM > 0 THEN
           DELETE FROM TE_CHR
            WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1);
        ELSE
           DELETE FROM TE_CHR;
        END IF;
   END IF;



   UPDATE TT_IED SET ULTEXP = AGORA(), QTDEXP = WK_QTDEXP, CNTEXP = WK_CNTEXP, TOTEXP = COALESCE(TOTEXP,0) + WK_QTDEXP
    WHERE TABELA = 'CHR';
   ELSE RAISE NOTICE 'EXPORTAO DE CHEQUES NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1176 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION EXPORTA_ECF (TR_ECF.CODFIL%TYPE,TR_ECF.NUMECF%TYPE,TR_ECF.DATOPE%TYPE,TR_ECF.CNT_RO%TYPE) CASCADE;

/*-- SEQ 1177 --*/
CREATE OR REPLACE FUNCTION EXPORTA_ECF (TR_ECF.CODFIL%TYPE,TR_ECF.NUMECF%TYPE,TR_ECF.DATOPE%TYPE,TR_ECF.CNT_RO%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
PNUMECF ALIAS FOR $2 ;
pDATOPE ALIAS FOR $3 ;
pCNT_RO ALIAS FOR $4 ;
-- Objetivo:
-- 1) Exportao de cheques
WK_QTDEXP Numeric;
WK_EXPORT TT_IED.EXPORT%TYPE;
WK_MANTEM TT_IED.MANTEM%TYPE;
WK_CNTEXP TT_IED.CNTEXP%TYPE;
WK_MAI_FR TT_CFG.MAI_FR%TYPE; 
WK_MAI_TO TT_CFG.MAI_TO%TYPE;
WK_MOTREJ TI_CLI.MOTREJ%TYPE;
WK_SAC_E_MAIL TT_CFG.SAC_E_MAIL%TYPE;
WK_DIALIM     TT_IED.DIALIM%TYPE;


BEGIN

   SELECT COALESCE(EXPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTEXP,0), COALESCE(DIALIM,0)
     INTO WK_EXPORT, WK_MANTEM, WK_CNTEXP, WK_DIALIM
     FROM TT_IED
    WHERE TABELA = 'ECF';

   IF WK_EXPORT = 'T' THEN 

   WK_CNTEXP := WK_CNTEXP + 1;
   WK_QTDEXP := 0;
   WK_MOTREJ := '';
     
           INSERT INTO TE_ECF (CODFIL, NUMECF, DATOPE, CNTOPE, NUMSER, TIPTOT, TOTALI, VLRBAS, VLR_GT, VLRTOT, CNT_RO, DATEXP)
                              (SELECT ECF.CODFIL,
                                      ECF.NUMECF,
                                      ECF.DATOPE,
                                      ECF.CNTOPE,
                                      ECF.NUMSER,
                                      ECF.TIPTOT,
                                      ECF.TOTALI,
                                      ECF.VLRBAS,
                                      ECF.VLR_GT,
                                      ECF.VLRTOT,
                                      ECF.CNT_RO,
                                      AGORA()
                                 FROM TT_ECF ECF INNER JOIN TR_ECF RECF ON RECF.CODFIL = ECF.CODFIL AND RECF.NUMECF = ECF.NUMECF
                                                                       AND RECF.DATOPE = ECF.DATOPE AND RECF.CNT_RO = ECF.CNT_RO
                                WHERE COALESCE(RECF.DIAFEC,'N') <> 'N'
                                  AND COALESCE(RECF.EXPORT,'F') = 'F'
                                  AND RECF.CODFIL=pCODFIL
                                  AND RECF.NUMECF=pNUMECF
                                  AND RECF.DATOPE=pDATOPE
                                  AND RECF.CNT_RO=pCNT_RO);
           SELECT COUNT(*)
             INTO WK_QTDEXP
             FROM TT_ECF ECF INNER JOIN TR_ECF RECF ON RECF.CODFIL = ECF.CODFIL AND RECF.NUMECF = ECF.NUMECF
                                                   AND RECF.DATOPE = ECF.DATOPE AND RECF.CNT_RO = ECF.CNT_RO
            WHERE COALESCE(RECF.DIAFEC,'N') <> 'N'
              AND COALESCE(RECF.EXPORT,'F') = 'F'              
              AND RECF.CODFIL=pCODFIL
              AND RECF.NUMECF=pNUMECF
              AND RECF.DATOPE=pDATOPE
              AND RECF.CNT_RO=pCNT_RO;
           
/*           UPDATE TT_ECF SET EXPORT = 'T'
            WHERE (CODFIL, NUMECF, CNT_RO, DATOPE, TOTALI, TIPTOT) IN (SELECT ECF.CODFIL, ECF.NUMECF, ECF.CNT_RO, ECF.DATOPE, ECF.TOTALI, ECF.TIPTOT
                                                                 FROM TT_ECF ECF INNER JOIN TR_ECF RECF ON RECF.CODFIL = ECF.CODFIL AND RECF.NUMECF = ECF.NUMECF
                                                                                                       AND RECF.DATOPE = ECF.DATOPE AND RECF.CNT_RO = ECF.CNT_RO
                                                                WHERE COALESCE(RECF.DIAFEC,'N') <> 'N'
                                                                  AND COALESCE(RECF.EXPORT,'F') = 'F'                                                                  
                                                                  AND RECF.CODFIL=pCODFIL
                                                                  AND RECF.NUMECF=pNUMECF
                                                                  AND RECF.DATOPE=pDATOPE
                                                                  AND RECF.CNT_RO=pCNT_RO);*/


   IF WK_MOTREJ <> '' THEN
      SELECT MAI_FR, MAI_TO, SAC_E_MAIL
        INTO WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL
        FROM TT_CFG;
      IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
         INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO, MAI_CC,
                             TEXTOS,TIPMSG)
                     VALUES ('001','F',AGORA(),'ERRO NA EXPORTAO LEITURA Z',WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL,
                             'Problema na exportao de leitura Z do ECF. Verifique!','T');
      END IF;
    END IF;

   IF WK_MANTEM = 'F' THEN
        IF WK_DIALIM > 0 THEN
           DELETE FROM TE_ECF
            WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1);
        ELSE
           DELETE FROM TE_ECF;
        END IF;
   END IF;


   UPDATE TT_IED SET ULTEXP = AGORA(), QTDEXP = WK_QTDEXP, CNTEXP = WK_CNTEXP, TOTEXP = COALESCE(TOTEXP,0) + WK_QTDEXP 
    WHERE TABELA = 'ECF';
   ELSE RAISE NOTICE 'EXPORTAO LEITURA Z NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;

  RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 1178 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION EXPORTA_ECF (TR_ECF.CODFIL%TYPE,TR_ECF.NUMECF%TYPE,TR_ECF.DATOPE%TYPE) CASCADE;

/*-- SEQ 1179 --*/
CREATE OR REPLACE FUNCTION EXPORTA_ECF (TR_ECF.CODFIL%TYPE,
                               TR_ECF.NUMECF%TYPE,
                               TR_ECF.DATOPE%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN EXPORTA_ECF($1,$2,$3,0);
END;
$$ language 'plpgsql';


/*-- SEQ 1180 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION EXPORTA_MOV () CASCADE;

/*-- SEQ 1181 --*/
CREATE OR REPLACE FUNCTION EXPORTA_MOV ()
RETURNS VARCHAR AS $$
DECLARE

-- Objetivo:
-- 1) Exportao de Movimentaes
WK_EXPORT_MOV TT_IED.EXPORT%TYPE;
WK_TABELA_MOV TT_IED.TABELA%TYPE;

WK_EXPORT_MLA TT_IED.EXPORT%TYPE;
WK_TABELA_MLA TT_IED.TABELA%TYPE;
WK_QTDEXP_MLA Numeric;

WK_EXPORT_MIV TT_IED.EXPORT%TYPE;
WK_TABELA_MIV TT_IED.TABELA%TYPE;
WK_QTDEXP_MIV Numeric;

WK_EXPORT_MIC TT_IED.EXPORT%TYPE;
WK_TABELA_MIC TT_IED.TABELA%TYPE;
WK_QTDEXP_MIC Numeric;

WK_QTDEXP Numeric;
WK_MANTEM TT_IED.MANTEM%TYPE;
WK_CNTEXP TT_IED.CNTEXP%TYPE;
WK_DIALIM TT_IED.DIALIM%TYPE;

WK_MAI_FR TT_CFG.MAI_FR%TYPE;
WK_MAI_TO TT_CFG.MAI_TO%TYPE;
WK_MOTREJ TI_CLI.MOTREJ%TYPE;
wk_SAC_E_MAIL TT_CFG.SAC_E_MAIL%TYPE;

BEGIN

   SELECT TABELA, COALESCE(EXPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTEXP,0), COALESCE(DIALIM,0)
     INTO WK_TABELA_MOV, WK_EXPORT_MOV, WK_MANTEM, WK_CNTEXP, WK_DIALIM
     FROM TT_IED
    WHERE TABELA = 'MOV';

   IF WK_EXPORT_MOV = 'T' THEN
   
       
        SELECT TABELA, COALESCE(EXPORT,'T')
          INTO WK_TABELA_MIV, WK_EXPORT_MIV
          FROM TT_IED
         WHERE TABELA = 'MIV';
      
             
        SELECT TABELA, COALESCE(EXPORT,'T')
          INTO WK_TABELA_MIC, WK_EXPORT_MIC
          FROM TT_IED
         WHERE TABELA = 'MIC';
              

               
        SELECT TABELA, COALESCE(EXPORT,'T')
          INTO WK_TABELA_MLA, WK_EXPORT_MLA
          FROM TT_IED
         WHERE TABELA = 'MLA';
              

   WK_CNTEXP := WK_CNTEXP + 1;
   WK_QTDEXP := 0;
   WK_MOTREJ := '';

           IF WK_TABELA_MIV IS NOT NULL AND (WK_EXPORT_MIV = 'T') THEN
              LOCK TABLE TT_IVE IN EXCLUSIVE MODE;
              INSERT INTO TE_MOV (SEQUEN, NUMITE, SITMOV,
                                  EXTPRO, CODFIL, CODMUL, DATMOV, DOCUME, NUMEXT, QTDMOV, TIPLAN, TIPMOV, VLRMOV, OBSERV,DATEXP)
                                 (SELECT IVE.SEQUEN, IVE.NUMITE, IVE.SITMOV,
                                         GRA.CODEXT,
                                         VEN.CODFIL,
                                         IVE.CODMUL,
                                         TRUNC(VEN.DATHOR) AS DATMOV,
                                         COALESCE(VEN.CODSER,'')||'/'||lTrim(COALESCE(VEN.NUMECF,''))||'-'||lTrim(COALESCE(VEN.NUMNOT,''))||'/'||IVE.NUMITE AS DOCUME,
                                         IVE.NUMEXT,
                                         IVE.QTDMOV * -1,
                                         3 AS TIPLAN,
                                         'V' AS TIPMOV,
                                         IVE.VLRMOV,
                                         VEN.OBSERV,
                                         AGORA()
                                    FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN
                                                    INNER JOIN TT_GRA GRA ON GRA.FILMAT = IVE.FILMAT AND GRA.CODMAT = IVE.CODMAT
                                                                         AND GRA.CODCOR = IVE.CODCOR AND GRA.CODTAM = IVE.CODTAM
                                   WHERE ((IVE.SITMOV = 'N' AND IVE.EXPORT = 'F')
                                      OR (IVE.SITMOV = 'C' AND IVE.EXPORT = 'R')));
             SELECT COUNT(*)
              INTO WK_QTDEXP_MIV
              FROM (SELECT VEN.CODFIL
                      FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN
                     WHERE COALESCE(VEN.EXPORT,'F') = 'F') tab;

             UPDATE TT_IVE SET EXPORT = CASE WHEN SITMOV='C' THEN 'C' ELSE 'T' END
              WHERE ((SITMOV = 'N' AND EXPORT = 'F')
                  OR (SITMOV = 'C' AND EXPORT = 'R'));

           END IF;
           IF WK_TABELA_MIC IS NOT NULL AND (WK_EXPORT_MIC = 'T') THEN

              LOCK TABLE TT_ICO IN EXCLUSIVE MODE;
              INSERT INTO TE_MOV (SEQUEN, NUMITE, SITMOV,
                                  EXTPRO, CODFIL, CODMUL, DATMOV, DOCUME, NUMEXT, QTDMOV, TIPLAN, TIPMOV, VLRMOV, OBSERV,DATEXP)
                                (SELECT ICO.SEQUEN, ICO.NUMITE, ICO.SITMOV,
                                       GRA.CODEXT,
                                       COM.CODFIL,
                                       ICO.CODMUL,
                                       TRUNC(COM.DATOPE),
                                       COALESCE(COM.CODSER,'')||'/'||lTrim(COALESCE(COM.SUBSER,''))||'-'||lTrim(COALESCE(COM.NUMNOT,''))||'/'||ICO.NUMITE AS DOCUME ,
                                       NULL,
                                       ICO.QTDMOV,
                                       2 AS TIPLAN,
                                       'C' AS TIPMOV,
                                       ICO.VLRMOV,
                                       COM.OBSERV,
                                       AGORA()
                                  FROM TT_COM COM INNER JOIN TT_ICO ICO ON ICO.CODFIL = COM.CODFIL AND ICO.SEQUEN = COM.SEQUEN
                                                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = ICO.FILMAT AND GRA.CODMAT = ICO.CODMAT
                                                                       AND GRA.CODCOR = ICO.CODCOR AND GRA.CODTAM = ICO.CODTAM
                                 WHERE ((ICO.SITMOV = 'N' AND ICO.EXPORT = 'F')
                                     OR (ICO.SITMOV = 'C' AND ICO.EXPORT = 'R')));
             SELECT COUNT(*)
              INTO WK_QTDEXP_MIC
              FROM (SELECT COM.CODFIL
                      FROM TT_COM COM INNER JOIN TT_ICO ICO ON ICO.CODFIL = COM.CODFIL AND ICO.SEQUEN = COM.SEQUEN
                     WHERE COALESCE(COM.EXPORT,'F') = 'F') tab;

            UPDATE TT_ICO SET EXPORT = CASE WHEN SITMOV='C' THEN 'C' ELSE 'T' END
             WHERE ((SITMOV = 'N' AND EXPORT = 'F')
                 OR (SITMOV = 'C' AND EXPORT = 'R'));


           END IF;
           IF WK_TABELA_MLA IS NOT NULL AND (WK_EXPORT_MLA = 'T') THEN

              LOCK TABLE TT_LAN IN EXCLUSIVE MODE;
              INSERT INTO TE_MOV (SEQUEN, NUMITE, SITMOV,
                                  EXTPRO, CODFIL, CODMUL, DATMOV, DOCUME, NUMEXT, QTDMOV, TIPLAN, TIPMOV, VLRMOV, OBSERV,DATEXP)
                                (SELECT LAN.SEQUEN, 0, LAN.SITMOV,
                                       GRA.CODEXT,
                                       LAN.CODFIL,
                                       LAN.CODMUL,
                                       LAN.DATMOV,
                                       LAN.DOCUME,
                                       LAN.NUMEXT,
                                       LAN.QTDMOV,
                                       LAN.TIPLAN,
                                       LAN.TIPMOV,
                                       LAN.VLRMOV,
                                       LAN.OBSERV,
                                       AGORA()
                                  FROM TT_LAN LAN INNER JOIN TT_GRA GRA ON GRA.FILMAT = LAN.FILMAT AND GRA.CODMAT = LAN.CODMAT
                                                                       AND GRA.CODCOR = LAN.CODCOR AND GRA.CODTAM = LAN.CODTAM
                                 WHERE ((LAN.SITMOV = 'N' AND LAN.EXPORT = 'F')
                                     OR (LAN.SITMOV = 'C' AND LAN.EXPORT = 'R')));

             SELECT COUNT(*)
              INTO WK_QTDEXP_MLA
              FROM (SELECT LAN.CODFIL
                      FROM TT_LAN LAN INNER JOIN TT_GRA GRA ON GRA.FILMAT = LAN.FILMAT AND GRA.CODMAT = LAN.CODMAT
                                                           AND GRA.CODCOR = LAN.CODCOR AND GRA.CODTAM = LAN.CODTAM
                     WHERE COALESCE(LAN.EXPORT,'F') = 'F') tab;
            UPDATE TT_LAN SET EXPORT = CASE WHEN SITMOV='C' THEN 'C' ELSE 'T' END
             WHERE ((SITMOV = 'N' AND EXPORT = 'F')
                 OR (SITMOV = 'C' AND EXPORT = 'R'));

           END IF;

           WK_QTDEXP := COALESCE(WK_QTDEXP_MLA,0) + COALESCE(WK_QTDEXP_MIV,0) + COALESCE(WK_QTDEXP_MIC,0);


   IF WK_MOTREJ <> '' THEN
      SELECT MAI_FR, MAI_TO, SAC_E_MAIL
        INTO WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL
        FROM TT_CFG;
      IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') THEN
         INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO, MAI_CC,
                             TEXTOS,TIPMSG)
                     VALUES ('001','F',AGORA(),'ERRO NA EXPORTAO MOVIMENTAES',WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL,
                             'Problema na exportao de movimentaes. Verifique!','T');
      END IF;
    END IF;

   IF WK_MANTEM = 'F' THEN
        IF WK_DIALIM > 0 THEN
           DELETE FROM TE_MOV
            WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1);
        ELSE
           DELETE FROM TE_MOV;
        END IF;
   END IF;

   UPDATE TT_IED SET ULTEXP = AGORA(), QTDEXP = WK_QTDEXP, CNTEXP = WK_CNTEXP, TOTEXP = COALESCE(TOTEXP,0) + WK_QTDEXP
    WHERE TABELA = 'MOV';
   ELSE RAISE NOTICE 'EXPORTAO DE MOVIMENTAES NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1182 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION EXPORTA_RECF () CASCADE;

/*-- SEQ 1183 --*/
CREATE OR REPLACE FUNCTION EXPORTA_RECF ()
RETURNS VARCHAR AS $$
DECLARE

-- Objetivo:
-- 1) Exportao de cheques
WK_QTDEXP Numeric;
WK_EXPORT TT_IED.EXPORT%TYPE;
WK_MANTEM TT_IED.MANTEM%TYPE;
WK_CNTEXP TT_IED.CNTEXP%TYPE;
WK_MAI_FR TT_CFG.MAI_FR%TYPE; 
WK_MAI_TO TT_CFG.MAI_TO%TYPE;
WK_MOTREJ TI_CLI.MOTREJ%TYPE;
WK_SAC_E_MAIL TT_CFG.SAC_E_MAIL%TYPE;
WK_CODFIL TR_ECF.CODFIL%TYPE;
WK_NUMECF TR_ECF.NUMECF%TYPE;
WK_DATOPE TR_ECF.DATOPE%TYPE;
cDUMMY VARCHAR(5);
WK_DIALIM     TT_IED.DIALIM%TYPE;

cr_ecf CURSOR FOR
SELECT RECF.CODFIL,RECF.NUMECF,RECF.DATOPE
FROM TR_ECF RECF
WHERE COALESCE(RECF.DIAFEC,'N') <> 'N'
  AND COALESCE(RECF.EXPORT,'F') = 'F';

BEGIN

   SELECT COALESCE(EXPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTEXP,0), COALESCE(DIALIM,0)
     INTO WK_EXPORT, WK_MANTEM, WK_CNTEXP, WK_DIALIM
     FROM TT_IED
    WHERE TABELA = 'ECF';

   IF WK_EXPORT = 'T' THEN 

   WK_CNTEXP := WK_CNTEXP + 1;
   WK_QTDEXP := 0;
   WK_MOTREJ := '';
     
           INSERT INTO TE_RECF (CNT_RZ, CODFIL, CUPFIM, CUPINI, DATFEC, DATOPE, DIAFEC, GT_FIM, GT_INI, NUMECF, QTD_NF, CNT_RO, DATEXP)
                               (SELECT RECF.CNT_RZ,
                                       RECF.CODFIL,
                                       RECF.CUPFIM,
                                       RECF.CUPINI,
                                       RECF.DATFEC,
                                       RECF.DATOPE,
                                       RECF.DIAFEC,
                                       RECF.GT_FIM,
                                       RECF.GT_INI,
                                       RECF.NUMECF,
                                       RECF.QTD_NF,
                                       RECF.CNT_RO,
                                       AGORA()
                                  FROM TR_ECF RECF
                                 WHERE COALESCE(RECF.DIAFEC,'N') <> 'N'
                                   AND COALESCE(RECF.EXPORT,'F') = 'F');
           OPEN cr_ecf;
           LOOP
              FETCH cr_ecf INTO WK_CODFIL,WK_NUMECF,WK_DATOPE;
              EXIT WHEN NOT FOUND;
              cDummy := EXPORTA_ECF(WK_CODFIL,WK_NUMECF,WK_DATOPE);
           END LOOP; 
           CLOSE cr_ecf;

           SELECT COUNT(*)
             INTO WK_QTDEXP
             FROM TR_ECF RECF
            WHERE COALESCE(RECF.DIAFEC,'N') <> 'N'
              AND COALESCE(RECF.EXPORT,'F') = 'F';


           UPDATE TR_ECF SET EXPORT = 'T'
            WHERE COALESCE(EXPORT,'F') = 'F'
              AND COALESCE(DIAFEC,'N') <> 'N';



   IF WK_MOTREJ <> '' THEN
      SELECT MAI_FR, MAI_TO, SAC_E_MAIL
        INTO WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL
        FROM TT_CFG;
      IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
         INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO, MAI_CC,
                             TEXTOS,TIPMSG)
                     VALUES ('001','F',AGORA(),'ERRO NA EXPORTAO DE RESUMO DO ECF',WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL,
                             'Problema na exportao de resumo do ECF. Verifique!','T');
      END IF;
    END IF;

   IF WK_MANTEM = 'F' THEN
        IF WK_DIALIM > 0 THEN
           DELETE FROM TE_RECF
            WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1);
        ELSE
           DELETE FROM TE_RECF;
        END IF;
   END IF;

   UPDATE TT_IED SET ULTEXP = AGORA(), QTDEXP = WK_QTDEXP, CNTEXP = WK_CNTEXP, TOTEXP = COALESCE(TOTEXP,0) + WK_QTDEXP 
    WHERE TABELA = 'ECF';
   ELSE RAISE NOTICE 'EXPORTAO DO RESUMO DE ECF NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1184 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION EXPORTA_SAL () CASCADE;

/*-- SEQ 1185 --*/
CREATE OR REPLACE FUNCTION EXPORTA_SAL ()
RETURNS VARCHAR AS $$
DECLARE

-- Objetivo:
-- 1) Exportao de Movimentaes
WK_QTDEXP Numeric;
WK_EXPORT TT_IED.EXPORT%TYPE;
WK_MANTEM TT_IED.MANTEM%TYPE;
WK_CNTEXP TT_IED.CNTEXP%TYPE;
WK_MAI_FR TT_CFG.MAI_FR%TYPE; 
WK_MAI_TO TT_CFG.MAI_TO%TYPE;
WK_MOTREJ TI_CLI.MOTREJ%TYPE;
wk_SAC_E_MAIL TT_CFG.SAC_E_MAIL%TYPE;
WK_DIALIM     TT_IED.DIALIM%TYPE;

BEGIN

   SELECT COALESCE(EXPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTEXP,0), COALESCE(DIALIM,0)
     INTO WK_EXPORT, WK_MANTEM, WK_CNTEXP, WK_DIALIM
     FROM TT_IED
    WHERE TABELA = 'MOV';

   IF WK_EXPORT = 'T' THEN 

   WK_CNTEXP := WK_CNTEXP + 1;
   WK_QTDEXP := 0;
   WK_MOTREJ := '';
     
           INSERT INTO TE_MOV (EXTPRO, CODFIL, CODMUL, DATMOV, DOCUME, NUMEXT, QTDMOV, TIPLAN, TIPMOV, VLRMOV, OBSERV)
                              (SELECT GRA.CODEXT,
                                      VEN.CODFIL,
                                      IVE.CODMUL,
                                      TRUNC(VEN.DATHOR),
                                      VEN.NUMNOT,
                                      IVE.NUMEXT,
                                      IVE.QTDMOV,
                                      NULL,
                                      NULL,
                                      IVE.VLRMOV,
                                      VEN.OBSERV
                                 FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN
                                                 INNER JOIN TT_GRA GRA ON GRA.FILMAT = IVE.FILMAT AND GRA.CODMAT = IVE.CODMAT
                                                                      AND GRA.CODCOR = IVE.CODCOR AND GRA.CODTAM = IVE.CODTAM
                                WHERE COALESCE(VEN.EXPORT,'F') = 'F');

            SELECT COUNT(*)
              INTO WK_QTDEXP
              FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN
             WHERE COALESCE(VEN.EXPORT,'F') = 'F'; 

            UPDATE TT_VEN SET EXPORT = 'T'
             WHERE (CODFIL, SEQUEN) IN (SELECT VEN.CODFIL, VEN.SEQUEN
                                          FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN
                                         WHERE COALESCE(VEN.EXPORT,'F') = 'F');


   IF WK_MOTREJ <> '' THEN
      SELECT MAI_FR, MAI_TO, SAC_E_MAIL
        INTO WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL
        FROM TT_CFG;
      IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
      INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO, MAI_CC,
                          TEXTOS,TIPMSG)
                  VALUES ('001','F',AGORA(),'ERRO NA EXPORTAO MOVIMENTAES',WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL,
                          'Problema na exportao de movimentaes. Verifique!','T');
      END IF;
    END IF;

   IF WK_MANTEM = 'F' THEN
        IF WK_DIALIM > 0 THEN
           DELETE FROM TE_MOV
            WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1);
        ELSE
           DELETE FROM TE_MOV;
        END IF;
   END IF;

   UPDATE TT_IED SET ULTEXP = AGORA(), QTDEXP = WK_QTDEXP, CNTEXP = WK_CNTEXP, TOTEXP = COALESCE(TOTEXP,0) + WK_QTDEXP 
    WHERE TABELA = 'MOV';
   ELSE RAISE NOTICE 'EXPORTAO CONTA-CORRENTE NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;

  RETURN NULL;

END;
$$ language 'plpgsql';





/*-- SEQ 1186 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_CFP () CASCADE;

/*-- SEQ 1187 --*/
CREATE OR REPLACE FUNCTION IMPORTA_CFP ()
RETURNS VARCHAR AS $$
DECLARE


WK_CFPATI     TI_CFP.CFPATI%TYPE;
WK_DESCFP     TI_CFP.DESCFP%TYPE;
WK_VENCON     TI_CFP.VENCON%TYPE;
WK_VENREV     TI_CFP.VENREV%TYPE;
WK_DEVCON     TI_CFP.DEVCON%TYPE;
WK_DEVREV     TI_CFP.DEVREV%TYPE;
WK_SAICON     TI_CFP.SAICON%TYPE;
WK_SAIREV     TI_CFP.SAIREV%TYPE;
WK_ENTCON     TI_CFP.ENTCON%TYPE;
WK_ENTREV     TI_CFP.ENTREV%TYPE;
WK_COMCON     TI_CFP.COMCON%TYPE;
WK_COMREV     TI_CFP.COMREV%TYPE;
WK_DVCCON     TI_CFP.DVCCON%TYPE;
WK_DVCREV     TI_CFP.DVCREV%TYPE;
WK_INTCON     TI_CFP.INTCON%TYPE;
WK_INTREV     TI_CFP.INTREV%TYPE;
WK_STATUS     TI_CFP.STATUS%TYPE;
WK_MOTREJ     TI_CFP.MOTREJ%TYPE;
WK_DATIMP     TI_CFP.DATIMP%TYPE;
WK_IMPORT     TT_IED.IMPORT%TYPE;
WK_MANTEM     TT_IED.MANTEM%TYPE;
WK_CNTIMP     TT_IED.CNTIMP%TYPE;
WK_NROERR     Numeric;
WK_QTDIMP     Numeric;
WK_MAI_FR     TT_CFG.MAI_FR%TYPE;
WK_MAI_TO     TT_CFG.MAI_TO%TYPE;
WK_AUX_CODTAB TD_CFP.CODTAB%TYPE;
WK_DIALIM     TT_IED.DIALIM%TYPE;
WK_DATCRI     TI_CFP.DATCRI%TYPE;

CR_CFOP_PRODUTO CURSOR(pDATCRI TI_CFP.DATCRI%TYPE) IS
--Status => 0 no processado
--       => 1 processado com sucesso
--       => 2 processado com erro
  SELECT * FROM (
                 SELECT /*+INDEX(TI_CFP, I_LC_ICFP_STATUS)*/
                        CFPATI, DESCFP, VENCON, VENREV, DEVCON, DEVREV, SAICON, SAIREV, ENTCON, ENTREV,
                        COMCON, COMREV, DVCCON, DVCREV, INTCON, INTREV, STATUS, MOTREJ, DATIMP
                   FROM TI_CFP
                  WHERE STATUS = 0
                    AND DATCRI BETWEEN TRUNC(pDATCRI)
                                   AND ADD_DAY(TRUNC(pDATCRI),1)
                  ORDER BY DATCRI
                ) TAB
   LIMIT 1;

BEGIN
   -- RFMP 80113
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20025 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

   SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
     INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
     FROM TT_IED
   WHERE TABELA = 'CFP';

   IF WK_IMPORT = 'T' THEN
    WK_CNTIMP := WK_CNTIMP + 1;
    WK_NROERR := 0;
    WK_QTDIMP := 0;

    LOOP
       SELECT MIN(DATCRI)
         INTO WK_DATCRI
         FROM TI_CFP
        WHERE STATUS = 0;

       OPEN CR_CFOP_PRODUTO(wk_datcri);
       FETCH CR_CFOP_PRODUTO INTO WK_CFPATI, WK_DESCFP, WK_VENCON, WK_VENREV, WK_DEVCON,
                                  WK_DEVREV, WK_SAICON, WK_SAIREV, WK_ENTCON, WK_ENTREV,
                                  WK_COMCON, WK_COMREV, WK_DVCCON, WK_DVCREV, WK_INTCON,
                                  WK_INTREV, WK_STATUS, WK_MOTREJ, WK_DATIMP;
       IF NOT FOUND THEN
           CLOSE CR_CFOP_PRODUTO;
           EXIT;
       END IF;

       WK_MOTREJ     := 'OK';

       WK_AUX_CODTAB := NULL;
         SELECT CODTAB INTO WK_AUX_CODTAB
           FROM TD_CFP
          WHERE DESCFP = WK_DESCFP;
       IF WK_AUX_CODTAB IS NULL THEN --registro novo
         BEGIN
           SELECT COALESCE(MAX(CODTAB),0) + 1
           INTO WK_AUX_CODTAB
           FROM TD_CFP;
            INSERT INTO TD_CFP(CODTAB, CFPATI, DESCFP, VENCON, VENREV,
                               DEVCON, DEVREV, SAICON, SAIREV, ENTCON,
                               ENTREV, COMCON, COMREV, DVCCON, DVCREV,
                               INTCON, INTREV)
                        VALUES(WK_AUX_CODTAB, WK_CFPATI, WK_DESCFP, WK_VENCON, WK_VENREV,
                               WK_DEVCON, WK_DEVREV, WK_SAICON, WK_SAIREV, WK_ENTCON,
                               WK_ENTREV, WK_COMCON, WK_COMREV, WK_DVCCON, WK_DVCREV,
                               WK_INTCON, WK_INTREV);

         EXCEPTION
	   
	   WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR CFOP_PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	   WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR CFOP_PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	   WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR CFOP_PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	   WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR CFOP_PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR CFOP_PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	   WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR CFOP_PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
  	   WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR CFOP_PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                               END;
       ELSE
         BEGIN
           UPDATE TD_CFP
              SET CFPATI = WK_CFPATI,
                  DESCFP = WK_DESCFP,
                  VENCON = WK_VENCON,
                  VENREV = WK_VENREV,
                  DEVCON = WK_DEVCON,
                  DEVREV = WK_DEVREV,
                  SAICON = WK_SAICON,
                  SAIREV = WK_SAIREV,
                  ENTCON = WK_ENTCON,
                  ENTREV = WK_ENTREV,
                  COMCON = WK_COMCON,
                  COMREV = WK_COMREV,
                  DVCCON = WK_DVCCON,
                  DVCREV = WK_DVCREV,
                  INTCON = WK_INTCON,
                  INTREV = WK_INTREV
            WHERE CODTAB = WK_AUX_CODTAB;
         EXCEPTION
	   
	   WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE CFOP_PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	   WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE CFOP_PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	   WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE CFOP_PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	   WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE CFOP_PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE CFOP_PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	   WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE CFOP_PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
  	   WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE CFOP_PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                               END;
       END IF;

       IF NOT WK_MOTREJ = 'OK' THEN
         WK_STATUS := 4;
         WK_NROERR := WK_NROERR + 1;
       ELSE
         WK_STATUS := 3;
       END IF;

       UPDATE TI_CFP
          SET STATUS = WK_STATUS,
              DATIMP = AGORA(),
              MOTREJ = WK_MOTREJ
        WHERE DESCFP = WK_DESCFP
          AND DATIMP IS NULL;
              WK_QTDIMP := WK_QTDIMP + 1;
       CLOSE CR_CFOP_PRODUTO;
     END LOOP;

     IF WK_NROERR <> 0 THEN
       SELECT MAI_FR, MAI_TO
         INTO WK_MAI_FR, WK_MAI_TO
         FROM TT_CFG;
       IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
          INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO,
                              TEXTOS,TIPMSG)
                       VALUES ('001','F',AGORA(),'IMPORTAO DE CFOP_PRODUTO',WK_MAI_FR, WK_MAI_TO,
                               'Problema na importao de '||wk_nroerr||' CFOP de Produto. Verifique!','T');
       END IF;
     END IF;

     UPDATE TI_CFP SET STATUS = CASE WHEN STATUS = 3
                                     THEN 1
                                     ELSE 2
                                 END
     WHERE STATUS IN (3,4);


     IF WK_MANTEM = 'F' THEN
        IF WK_DIALIM > 0 THEN
           DELETE FROM TI_CFP
            WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
	      AND STATUS = 1;
        ELSE
           DELETE FROM TI_CFP
	    WHERE STATUS = 1;
        END IF;
     END IF;

     UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = WK_QTDIMP, CNTIMP = WK_CNTIMP, TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP WHERE TABELA = 'CFP';
      ELSE RAISE EXCEPTION 'PG-20001 IMPORTAO DE CFOP_PRODUTO NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;
   
     RETURN 'OK';
   
END;
$$ language 'plpgsql';





/*-- SEQ 1188 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_DES () CASCADE;

/*-- SEQ 1189 --*/
CREATE OR REPLACE FUNCTION IMPORTA_DES ()
RETURNS VARCHAR AS $$
DECLARE

-- Objetivo:
-- 1) Importao das tabelas referentes a retorno de pedidos no processo de pedido eletrnico para farmcias
-- davi - 31/03/06 - 41960
   WK_CODFOR                     TI_DES.CODFOR%TYPE;
   WK_CODPRO                     TI_DES.CODPRO%TYPE;
   WK_PRXFOR                     TI_DES.CODFOR%TYPE;
   WK_AUX_PRXFOR                 TI_DES.CODFOR%TYPE;
   WK_QTDFAL                     TI_DES.QTDFAL%TYPE;
   WK_STATUS                     TI_DES.STATUS%TYPE;
   WK_MOTREJ                     TI_DES.MOTREJ%TYPE;
   WK_IMPORT                     TT_IED.IMPORT%TYPE;
   WK_MANTEM                     TT_IED.MANTEM%TYPE;
   WK_CNTIMP                     TT_IED.CNTIMP%TYPE;
   WK_ULTCOD                     TT_COD.ULTCOD%TYPE;
   WK_AUX_FILUSU                 TT_PED.FILUSU%TYPE;
   WK_AUX_CODUSU                 TT_PED.CODUSU%TYPE;
   WK_AUX_CODFIL                 TT_PED.CODFIL%TYPE;
   WK_AUX_CODMOE                 TT_PED.CODMOE%TYPE;
   WK_AUX_VLRLIQ                 TT_PED.VLRLIQ%TYPE;
   WK_AUX_VLRTOT                 TT_PED.VLRTOT%TYPE;
   WK_AUX_QTDTOT                 TT_PED.QTDTOT%TYPE;
   WK_AUX_FILFOR                 TT_PED.FILFOR%TYPE;
   WK_AUX_CODFOR                 TT_PED.CODFOR%TYPE;
   WK_NEW_NUMPED                 TT_PED.NUMPED%TYPE;
   WK_NEW_NUMITE                 TT_IPE.NUMITE%TYPE;
   WK_AUX_FILMAT                 TT_IPE.FILMAT%TYPE;
   WK_AUX_CODMAT                 TT_IPE.CODMAT%TYPE;
   WK_AUX_CODCOR                 TT_IPE.CODCOR%TYPE;
   WK_AUX_CODTAM                 TT_IPE.CODTAM%TYPE;
   WK_AUX_VLRITE                 TT_IPE.VLRITE%TYPE;
   WK_AUX_VLRUNI                 TT_IPE.VLRUNI%TYPE;
   WK_AUX_QTDITE                 TT_IPE.QTDITE%TYPE;
   WK_AUX_QTDPED                 TT_IPE.QTDPED%TYPE;
   WK_AUX_UNICOM                 TT_IPE.UNICOM%TYPE;
   WK_AUX_UNIVEN                 TT_IPE.UNIVEN%TYPE;
   WK_AUX_VALCON                 TT_IPE.VALCON%TYPE;
   WK_AUX_VLRICM                 TT_IPE.VLRICM%TYPE;
   WK_AUX_OUTICM                 TT_IPE.OUTICM%TYPE;
   WK_AUX_CODBUS                 TT_IPE.CODBUS%TYPE;
   WK_AUX_FILORI                 TT_IPE.FILORI%TYPE;
   WK_AUX_PEDORI                 TT_IPE.PEDORI%TYPE;
   WK_AUX_ITEORI                 TT_IPE.ITEORI%TYPE;
   WK_AUX_IPIITE                 TT_PXF.PERIPI%TYPE;
   WK_AUX_ICMITE                 TT_PXF.PERICM%TYPE;
   WK_AUX_BASICM                 TT_PXF.BASICM%TYPE;
   WK_AUX_VLRITE_CALC            TT_IPE.VLRITE%TYPE;
   WK_AUX_BASICM_CALC            TT_IPE.BASICM%TYPE;
   WK_DIALIM                     TT_IED.DIALIM%TYPE;


   WK_DES_CODFOR TI_DES.CODFOR%TYPE;
   WK_DES_NUMPED TI_DES.NUMPED%TYPE;
   WK_DES_CODPRO TI_DES.CODPRO%TYPE;
   WK_DES_QTDFAL TI_DES.QTDFAL%TYPE;

   WK_NEW_VLRDES TT_IPE.VLRDES%TYPE;
   WK_NEW_ISEICM TT_IPE.VLRDES%TYPE;

   WK_ABE_CODFIL TT_PED.CODFIL%TYPE;
   WK_ABE_NUMPED TT_PED.NUMPED%TYPE;

   
   WK_RESTO  Numeric;
   WK_NUMREG Numeric = 500;
      WK_NROERR Numeric;
   WK_QTDIMP Numeric;
   Logon     TRetQuemLogou%ROWTYPE;
   vComplemento  VARCHAR(254);
   
    IpeRow  Record;
      
   WK_CFG_TIPFAR TT_CFG.TIPFAR%TYPE;
   WK_IPE_CODFIL TT_IPE.CODFIL%TYPE;
   WK_IPE_NUMPED TT_IPE.NUMPED%TYPE;
   WK_IPE_NUMITE TT_IPE.NUMITE%TYPE;
   WK_IPE_QTDITE TT_IPE.QTDITE%TYPE;

   -- fornecedores para os produtos com descarte
   CR_FORNECEDORES CURSOR FOR
     SELECT INT.PRXFOR, INT.CODFIL FROM (
       SELECT DISTINCT CAST(ProximoFornecedor(CODPRO,CODFOR,NUMPED) AS VARCHAR(10)) AS PRXFOR,
              (SELECT DISTINCT CODFIL
                 FROM TT_PED
                WHERE LPAD(PEDEXT,12,0) = TI_DES.NUMPED
                  AND FILFOR||TRIM(CODFOR) = TI_DES.CODFOR
                ) AS CODFIL
         FROM TI_DES
        WHERE STATUS = 0
         AND QTDFAL > 0
     ) INT
      WHERE INT.PRXFOR IS NOT NULL;

   -- descartes, juntamente com itens de pedido que os originaram
   CR_DESCARTES CURSOR(pCODFOR TI_DES.CODFOR%TYPE) IS
     SELECT INT.* FROM (
       SELECT DES.CODPRO, DES.QTDFAL, CAST(ProximoFornecedor(DES.CODPRO,DES.CODFOR,DES.NUMPED) AS VARCHAR(10)) AS PRXFOR,
              IPE.CODFIL AS FILORI, IPE.NUMPED AS PEDORI, IPE.NUMITE AS ITEORI
         FROM TI_DES DES INNER JOIN TT_PED PED ON PED.FILFOR||TRIM(PED.CODFOR) = DES.CODFOR
                         INNER JOIN TT_IPE IPE ON IPE.CODFIL = PED.CODFIL
                                              AND IPE.NUMPED = PED.NUMPED
                   AND IPE.FLGEST <> 'C'
        WHERE LPAD(PED.PEDEXT,12,0) = DES.NUMPED
          AND PED.DATENV IS NOT NULL
          AND IPE.CODBUS = (SELECT REFPRO FROM TT_GRA WHERE CODEXT = DES.CODPRO)
          AND DES.STATUS = 0
          AND DES.QTDFAL > 0
     ) INT
      WHERE INT.PRXFOR = pCODFOR
      ORDER BY INT.PRXFOR;

   -- itens do pedido antigo, que precisam ser atualizados
   CR_ITENS_OK CURSOR FOR
     SELECT CODFOR, NUMPED, CODPRO, QTDFAL
       FROM TI_DES
      WHERE MOTREJ = 'OK'
        AND QTDFAL > 0
        AND STATUS = 1
        AND DATIMP IS NOT NULL
      ORDER BY NUMPED;

   -- itens a serem descartados
   CR_DESCARTES_SIMPLES CURSOR FOR
     SELECT SUBSTR(NUMPED,1, 3) AS CODFIL,
            LPAD(SUBSTR(NUMPED,4, 8),8, ' ') AS NUMPED,
            NUMITE,
            QTDFAL
       FROM TI_DES
      WHERE QTDFAL > 0
        AND STATUS = 0;

BEGIN
   -- RFMP 80113
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20024 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

   vComplemento := constante('complemento');
        SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
       INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
       FROM TT_IED
      WHERE TABELA = 'DES';
   
   IF WK_IMPORT = 'T' THEN
     WK_CNTIMP := WK_CNTIMP + 1;
     WK_QTDIMP := 0;

     BEGIN
       UPDATE TI_DES
          SET STATUS = 6,
              MOTREJ = 'QUANTIDADE FALTANTE IGUAL A ZERO',
              DATIMP = AGORA()
        WHERE QTDFAL = 0
          AND STATUS = 0;
     EXCEPTION
       
       WHEN plpgsql_error THEN RAISE EXCEPTION 'PG-20001 ERRO AO ATUALIZAR ITENS COM QUANTIDADE IGUAL A ZERO. %' , vComplemento;
                   END;

     SELECT TIPFAR
       INTO WK_CFG_TIPFAR
       FROM TT_CFG;

     IF WK_CFG_TIPFAR = 'T' THEN
       -- Para farmacia:
       -- Trata arquivo de descarte que nao tem numite e que tem fornecedor e produto
       -- Tambem trata processo para gerar pedido para o proximo fornecedor
       BEGIN
         UPDATE TI_DES
            SET STATUS = 7,
                MOTREJ = (SELECT 'PRODUTO JA PROCESSADO NO DIA: '||TO_CHAR(MIN(TRUNC(INT.DATIMP)),'DD/MM/YYYY')
                            FROM TI_DES INT
                           WHERE INT.CODFOR = TI_DES.CODFOR
                             AND INT.NUMPED = TI_DES.NUMPED
                             AND INT.CODPRO = TI_DES.CODPRO
                             AND INT.QTDFAL = TI_DES.QTDFAL
                             AND INT.STATUS <> 0),
                DATIMP = AGORA()
          WHERE (CODFOR, NUMPED, CODPRO, QTDFAL) IN (SELECT INT.CODFOR, INT.NUMPED, INT.CODPRO, INT.QTDFAL
                                                       FROM TI_DES INT
                                                      WHERE INT.CODFOR = TI_DES.CODFOR
                                                        AND INT.NUMPED = TI_DES.NUMPED
                                                        AND INT.CODPRO = TI_DES.CODPRO
                                                        AND INT.QTDFAL = TI_DES.QTDFAL
                                                        AND INT.STATUS <> 0)
            AND STATUS = 0;
       EXCEPTION
         
         WHEN plpgsql_error THEN RAISE EXCEPTION 'PG-20002 ERRO AO ATUALIZAR ITENS JA PROCESSADOS. %' , vComplemento;
                         END;


       OPEN CR_FORNECEDORES;
       LOOP
         FETCH CR_FORNECEDORES INTO WK_AUX_PRXFOR, WK_AUX_CODFIL;
         EXIT WHEN NOT FOUND;
         --insere pedido
         WK_MOTREJ     := 'OK';
         select * into Logon from DadosLogon();
         IF Logon.Encontrou THEN
           WK_AUX_FILUSU := Logon.FILUSU;
           WK_AUX_CODUSU := Logon.CODUSU;
         ELSE
           WK_MOTREJ := 'Voce nao e um usuario cadastrado no sistema.';
         END IF;

         IF NOT WK_MOTREJ = 'OK' THEN
           WK_STATUS := 4;
           WK_NROERR := WK_NROERR + 1;
         ELSE
           WK_STATUS := 3;
         END IF;

         WK_AUX_FILFOR := SUBSTR(WK_AUX_PRXFOR,1,3);
         WK_AUX_CODFOR := LPAD(RTRIM(SUBSTR(WK_AUX_PRXFOR,4,6)),6,' ');
         WK_NEW_NUMPED := NULL;
         WK_ABE_CODFIL := NULL;
         WK_ABE_NUMPED := NULL;

         -- verificar se j existe pedido em aberto para o fornecedor
                    SELECT MAX(CODFIL), MAX(NUMPED)
             INTO WK_ABE_CODFIL, WK_ABE_NUMPED
             FROM TT_PED
            WHERE FLGEST = 'A'
              AND FILFOR = WK_AUX_FILFOR
              AND CODFOR = WK_AUX_CODFOR
  	 	        AND CODFIL = WK_AUX_CODFIL
  	 	        AND DATENV IS NULL;
         
         IF ISNOTNULL(WK_ABE_NUMPED) = 'F' THEN
           -- gerao de novo cdigo para o pedido
                        SELECT ULTCOD+1
               INTO WK_ULTCOD
               FROM TT_COD
              WHERE CODTAB = 'PED'
                AND FILCOD = WK_AUX_CODFIL;
           
           WK_NEW_NUMPED := LPAD(RTRIM(WK_ULTCOD),8,' ');

           BEGIN
             UPDATE TT_COD
                SET ULTCOD = WK_ULTCOD
              WHERE CODTAB = 'PED'
                AND FILCOD = WK_AUX_CODFIL;
           EXCEPTION
         	   
           WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := 'ERRO AO ALTERAR TABELA TT_COD: P0000 PLPGSQL ERROR'; ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                     END;

           IF NOT WK_MOTREJ = 'OK' THEN
             WK_STATUS := 4;
             WK_NROERR := WK_NROERR + 1;
           ELSE
             WK_STATUS := 3;
           END IF;

           --dados do pedido
           WK_AUX_CODMOE := 0;
           WK_AUX_VLRTOT := 0;
           WK_AUX_VLRLIQ := 0;

           BEGIN
   	 	       INSERT INTO TT_PED (CODFIL, NUMPED, FLGEST, TIPFOR, FILUSU, CODUSU,
  	 	                           FILFOR, CODFOR, CODMOE, ATU_EM, DATPED,DESCON, QTDTOT, VLRLIQ,
                                 VLRTOT, SIGNAT, EXPORT, VENENT)
                         VALUES (WK_AUX_CODFIL, WK_NEW_NUMPED, 'A', 'F', WK_AUX_FILUSU, WK_AUX_CODUSU,
   	 		                         WK_AUX_FILFOR, WK_AUX_CODFOR, 0, AGORA(), AGORA(),0, WK_AUX_QTDTOT, 1,
  			                        1,1, 'F', 'F');
           EXCEPTION
            
	    WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PEDIDO DE DESCARTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	    WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PEDIDO DE DESCARTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	    WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PEDIDO DE DESCARTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	    WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PEDIDO DE DESCARTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
            WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PEDIDO DE DESCARTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	    WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PEDIDO DE DESCARTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
            WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PEDIDO DE DESCARTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                     END;

           WK_AUX_CODMOE := 0;
           WK_AUX_VLRTOT := 0;
           WK_AUX_VLRLIQ := 0;

           IF NOT WK_MOTREJ = 'OK' THEN
              WK_STATUS := 4;
              WK_NROERR := WK_NROERR + 1;
           ELSE
              WK_STATUS := 3;
           END IF;
         ELSE
  	 	     WK_AUX_CODFIL := WK_ABE_CODFIL;
           WK_NEW_NUMPED := WK_ABE_NUMPED;

  	 	     -- numite do pedido existente
           SELECT MAX(NUMITE)
  	 	       INTO WK_NEW_NUMITE
      	     FROM TT_IPE
      	    WHERE CODFIL = WK_AUX_CODFIL
  	 	        AND NUMPED = WK_NEW_NUMPED;

           -- valores do pedido existente
           SELECT VLRLIQ, QTDTOT, VLRTOT
  	 	       INTO WK_AUX_VLRLIQ, WK_AUX_QTDTOT, WK_AUX_VLRTOT
      	     FROM TT_PED
      	    WHERE CODFIL = WK_AUX_CODFIL
  	 	        AND NUMPED = WK_NEW_NUMPED;
         END IF; -- fim da insero do novo pedido

         OPEN CR_DESCARTES(WK_AUX_PRXFOR);
         LOOP
           FETCH CR_DESCARTES INTO WK_CODPRO, WK_QTDFAL, WK_PRXFOR, WK_AUX_FILORI, WK_AUX_PEDORI, WK_AUX_ITEORI;
           EXIT WHEN NOT FOUND;
           --insere itens do pedido
           WK_MOTREJ     := 'OK';
  	 	     WK_NEW_NUMITE := COALESCE(WK_NEW_NUMITE,0)+1;

  	 	     --localizao dos dados do produto

         	 BEGIN
               SELECT FILMAT, CODMAT, CODCOR, CODTAM
          	 	   INTO WK_AUX_FILMAT, WK_AUX_CODMAT, WK_AUX_CODCOR, WK_AUX_CODTAM
              	 FROM TT_GRA
              	WHERE CODEXT = WK_CODPRO;
           EXCEPTION
                          
           WHEN others THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := 'PRODUTO NAO ENCONTRADO'; ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                        END;

           IF NOT WK_MOTREJ = 'OK' THEN
             WK_STATUS := 4;
             WK_NROERR := WK_NROERR + 1;
           ELSE
             WK_STATUS := 3;
           END IF;

         	 IF ISNOTNULL(WK_AUX_FILMAT) = 'T' THEN
             -- encontrou pedido, gera ipe
             SELECT COALESCE(PERICM,0), COALESCE(PERIPI,0), COALESCE(BASICM,0)
               INTO WK_AUX_ICMITE, WK_AUX_IPIITE, WK_AUX_BASICM
               FROM TT_PXF
              WHERE FILFOR = WK_AUX_FILFOR
                AND CODFOR = WK_AUX_CODFOR
                AND FILMAT = WK_AUX_FILMAT
                AND CODMAT = WK_AUX_CODMAT;

             SELECT UNIDAD, UNIFOR, VALCON, REFPRO
               INTO WK_AUX_UNIVEN, WK_AUX_UNICOM, WK_AUX_VALCON, WK_AUX_CODBUS
         	 	   FROM TT_GRA
              WHERE FILMAT = WK_AUX_FILMAT
                AND CODMAT = WK_AUX_CODMAT
                AND CODCOR = WK_AUX_CODCOR
                AND CODTAM = WK_AUX_CODTAM;

             --calculo de impostos do item
             WK_AUX_VALCON := NVLZ(WK_AUX_VALCON,1);
             WK_AUX_QTDITE := WK_QTDFAL;
             WK_AUX_QTDPED := WK_QTDFAL/WK_AUX_VALCON;
             WK_AUX_VLRUNI := ValoresProduto('C',WK_AUX_FILMAT,WK_AUX_CODMAT,WK_AUX_CODCOR,WK_AUX_CODTAM);
             WK_AUX_VLRITE := WK_AUX_VLRUNI * WK_QTDFAL;
             WK_AUX_BASICM_CALC := WK_AUX_VLRITE * (COALESCE(WK_AUX_BASICM,0)/100);
             WK_AUX_VLRICM := COALESCE(WK_AUX_BASICM_CALC,0) * (COALESCE(WK_AUX_ICMITE,0)/100);
             WK_AUX_OUTICM := WK_AUX_VLRITE - COALESCE(WK_AUX_BASICM_CALC,0);
             --WK_AUX_VLRITE_CALC := WK_AUX_VLRITE + (WK_AUX_VLRITE * (WK_AUX_IPIITE/100));

             BEGIN
               INSERT INTO TT_IPE (CODFIL, NUMPED, NUMITE, FLGEST, FILENT,
                                   FILMAT, CODMAT, CODCOR, CODTAM, ATU_EM,
                                   IPIITE, QTDITE, VLRITE, CODMOE, QTDCAN, QTDENT, ICMITE,
                                   VLRDES, CODBUS, UNICOM, UNIVEN, VALCON, CODMUL,
                                   BASICM, VLRICM, OUTICM, VLRVEN, ISEICM,
                                   QTDPED, VLRUNI,
                                   FILORI, PEDORI, ITEORI)
                           VALUES (WK_AUX_CODFIL, WK_NEW_NUMPED, WK_NEW_NUMITE, 'A', WK_AUX_CODFIL,
                                   WK_AUX_FILMAT, WK_AUX_CODMAT, WK_AUX_CODCOR, WK_AUX_CODTAM, AGORA(),
                                   COALESCE(WK_AUX_IPIITE,0), WK_AUX_QTDITE, WK_AUX_VLRITE, COALESCE(WK_AUX_CODMOE,0), 0, 0, COALESCE(WK_AUX_ICMITE,0),
                                   0, WK_AUX_CODBUS, WK_AUX_UNICOM, WK_AUX_UNIVEN, WK_AUX_VALCON, 0,
                                   COALESCE(WK_AUX_BASICM_CALC,0), COALESCE(WK_AUX_VLRICM,0), COALESCE(WK_AUX_OUTICM,0), 0, 0,
                                   WK_AUX_QTDPED, WK_AUX_VLRUNI,
                                   WK_AUX_FILORI,WK_AUX_PEDORI,WK_AUX_ITEORI);
             EXCEPTION
               
              WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ITEM DE INSERIR PEDIDO DE DESCARTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
              WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ITEM DE INSERIR PEDIDO DE DESCARTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
              WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ITEM DE INSERIR PEDIDO DE DESCARTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
              WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ITEM DE INSERIR PEDIDO DE DESCARTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
              WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ITEM DE INSERIR PEDIDO DE DESCARTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
              WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ITEM DE INSERIR PEDIDO DE DESCARTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
              WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ITEM DE INSERIR PEDIDO DE DESCARTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                           END;

             -- acumula totais do pedido
             WK_AUX_VLRLIQ := COALESCE(WK_AUX_VLRLIQ,0) + WK_AUX_VLRITE;
         	 	 WK_AUX_QTDTOT := COALESCE(WK_AUX_QTDTOT,0) + WK_QTDFAL;
             WK_AUX_VLRTOT := COALESCE(WK_AUX_VLRTOT,0) + WK_AUX_VLRITE; --como no h descontos/acrescimos
           END IF;

           IF NOT WK_MOTREJ = 'OK' THEN
             WK_STATUS := 4;
             WK_NROERR := WK_NROERR + 1;
           ELSE
             WK_STATUS := 3;
           END IF;

           UPDATE TI_DES
              SET STATUS = WK_STATUS,
                  DATIMP = AGORA(),
                  MOTREJ = WK_MOTREJ
            WHERE CODPRO = WK_CODPRO
    	        AND CODFOR IN (SELECT CODFOR
     	                         FROM TI_DES
                              WHERE CODPRO = WK_CODPRO
                                AND ProximoFornecedor(CODPRO,CODFOR,NUMPED) = WK_PRXFOR);
         END LOOP;
         CLOSE CR_DESCARTES;

         BEGIN
           --atualiza dados do pedido aps insero dos itens
           UPDATE TT_PED
              SET VLRTOT = WK_AUX_VLRTOT,
  	 	            VLRLIQ = WK_AUX_VLRLIQ,
  	 	            QTDTOT = WK_AUX_QTDTOT,
  			         ATU_EM = AGORA()
            WHERE CODFIL = WK_AUX_CODFIL
      	      AND NUMPED = WK_NEW_NUMPED;
         EXCEPTION
           
              WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PEDIDO DE DESCARTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
              WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PEDIDO DE DESCARTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
              WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PEDIDO DE DESCARTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
              WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PEDIDO DE DESCARTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
              WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PEDIDO DE DESCARTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
              WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PEDIDO DE DESCARTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
              WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PEDIDO DE DESCARTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                               END;

  	 	   WK_NEW_NUMITE := NULL;
         WK_AUX_VLRTOT := NULL;
         WK_AUX_QTDTOT := NULL;
         WK_AUX_VLRLIQ := NULL;

       END LOOP;
       CLOSE CR_FORNECEDORES;

       UPDATE TI_DES
          SET STATUS = CASE WHEN STATUS = 3
                            THEN 1
                            ELSE 2
                       END,
              DATIMP = AGORA()
        WHERE STATUS IN (3,4);

       -- atualizar pedidos processados
       OPEN CR_ITENS_OK;
       LOOP
         FETCH CR_ITENS_OK INTO WK_DES_CODFOR, WK_DES_NUMPED, WK_DES_CODPRO, WK_DES_QTDFAL;
         EXIT WHEN NOT FOUND;

    	   WK_MOTREJ := 'OK';

         -- pegar linha a ser atualizada
    	   SELECT IPE.*
    	     INTO IpeRow
           FROM TT_IPE IPE INNER JOIN TT_PED PED ON IPE.CODFIL = PED.CODFIL
                                                AND IPE.NUMPED = PED.NUMPED
          WHERE LPAD(PED.PEDEXT,12,0) = WK_DES_NUMPED
            AND PED.FILFOR||TRIM(PED.CODFOR) = WK_DES_CODFOR
            AND PED.DATENV IS NOT NULL
            AND IPE.CODBUS = (SELECT REFPRO FROM TT_GRA WHERE CODEXT = WK_DES_CODPRO);

         -- se foi atendido parcialmente, gera nova linha, se no foi, cancela item
         IF (IpeRow.QTDITE-WK_DES_QTDFAL) > 0 THEN
           SELECT MAX(NUMITE)+1
    	       INTO WK_NEW_NUMITE
    	       FROM TT_IPE
    	      WHERE NUMPED = IpeRow.NUMPED
    	        AND CODFIL = IpeRow.CODFIL;

           WK_AUX_FILFOR := SUBSTR(WK_DES_CODFOR,1,3);
           WK_AUX_CODFOR := LPAD(RTRIM(SUBSTR(WK_DES_CODFOR,4,6)),6,' ');

           SELECT COALESCE(PERICM,0), COALESCE(PERIPI,0), COALESCE(BASICM,0)
             INTO WK_AUX_ICMITE, WK_AUX_IPIITE, WK_AUX_BASICM
             FROM TT_PXF
            WHERE FILFOR = WK_AUX_FILFOR
              AND CODFOR = WK_AUX_CODFOR
              AND FILMAT = IpeRow.FILMAT
              AND CODMAT = IpeRow.CODMAT;

           -- calcula dados da nova linha, baseado na quantidade restante
           WK_AUX_VALCON := NVLZ(IpeRow.VALCON,1);
           WK_AUX_QTDITE := IpeRow.QTDITE-WK_DES_QTDFAL;
           WK_AUX_QTDPED := IpeRow.QTDPED-(WK_DES_QTDFAL/WK_AUX_VALCON);           
           WK_AUX_VLRITE := IpeRow.VLRUNI*WK_AUX_QTDPED;           
           WK_AUX_BASICM_CALC := WK_AUX_VLRITE * (WK_AUX_BASICM/100);
           WK_AUX_VLRICM := WK_AUX_BASICM_CALC * (WK_AUX_ICMITE/100);
           WK_AUX_OUTICM := WK_AUX_VLRITE - WK_AUX_BASICM_CALC;
           --WK_AUX_VLRITE_CALC := WK_AUX_VLRITE + (WK_AUX_VLRITE * (WK_AUX_IPIITE/100));
           WK_NEW_VLRDES := (IpeRow.VLRDES/IpeRow.QTDPED)*(IpeRow.QTDPED-WK_DES_QTDFAL);
           WK_NEW_ISEICM := (IpeRow.ISEICM/IpeRow.QTDPED)*(IpeRow.QTDPED-WK_DES_QTDFAL);

           -- insere nova linha, descontando quantidades no atendidas
           BEGIN
             INSERT INTO TT_IPE (CODFIL, NUMPED, NUMITE, FLGEST, FILENT,
                                 FILMAT, CODMAT, ATU_EM, CODMOE, CODCOR, CODTAM,
                                 UNICOM, UNIVEN, IPIITE, VLRITE, VLRVEN,
                                 QTDITE, ICMITE, VLRDES, QTDCAN,
                                 QTDENT, CODBUS, CODMUL, VALCON, BASICM,
                                 VLRICM, OUTICM, ISEICM,
                                 QTDPED, VLRUNI)
                         VALUES (IpeRow.CODFIL, IpeRow.NUMPED, WK_NEW_NUMITE, 'A', IpeRow.FILENT,
                                 IpeRow.FILMAT, IpeRow.CODMAT, AGORA(), IpeRow.CODMOE, IpeRow.CODCOR, IpeRow.CODTAM,
                                 IpeRow.UNICOM, IpeRow.UNIVEN, IpeRow.IPIITE, WK_AUX_VLRITE, IpeRow.VLRVEN,
                                 WK_AUX_QTDITE, IpeRow.ICMITE, WK_NEW_VLRDES, IpeRow.QTDCAN,
                                 IpeRow.QTDENT, IpeRow.CODBUS, IpeRow.CODMUL, WK_AUX_VALCON, WK_AUX_BASICM_CALC,
                                 WK_AUX_VLRICM, WK_AUX_OUTICM, WK_NEW_ISEICM,
                                 WK_AUX_QTDPED, IpeRow.VLRUNI);
           EXCEPTION
             
              WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR NOVO ITEM DE PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
              WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR NOVO ITEM DE PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
              WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR NOVO ITEM DE PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
              WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR NOVO ITEM DE PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
              WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR NOVO ITEM DE PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
              WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR NOVO ITEM DE PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
              WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR NOVO ITEM DE PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                     END;
         END IF;

         BEGIN
    	   -- cancela anterior
           UPDATE TT_IPE SET FLGEST = 'C', ATU_EM = AGORA()
    	      WHERE CODFIL = IpeRow.CODFIL
    	        AND NUMPED = IpeRow.NUMPED
       	        AND NUMITE = IpeRow.NUMITE;
         EXCEPTION
       	   
           WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR TABELA TT_IPE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                               END;
         BEGIN
    	   -- RFMP 75328
           UPDATE TT_PED
              SET FLGEST = 'Y'
    	    WHERE CODFIL = IpeRow.CODFIL
    	      AND NUMPED = IpeRow.NUMPED;
         EXCEPTION
       	   
           WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR TABELA TT_PED: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                               END;

         IF NOT WK_MOTREJ = 'OK' THEN
           WK_STATUS := 4;
           WK_NROERR := WK_NROERR + 1;
         ELSE
           WK_STATUS := 5;
         END IF;

       	 UPDATE TI_DES
       	    SET STATUS = WK_STATUS,
       	        DATIMP = AGORA(),
       	        MOTREJ = WK_MOTREJ
          WHERE CODPRO = WK_DES_CODPRO
       	    AND NUMPED = WK_DES_NUMPED
       	    AND CODPRO = WK_DES_CODPRO
            AND DATIMP IS NULL;
       END LOOP;
       CLOSE CR_ITENS_OK;

       WK_QTDIMP := WK_QTDIMP + 1;

       IF WK_MANTEM = 'F' THEN
         IF WK_DIALIM > 0 THEN
           DELETE FROM TI_DES
            WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
			  AND STATUS = 1;
         ELSE
           DELETE FROM TI_DES
		    WHERE STATUS = 1;
         END IF;
       END IF;

       UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = WK_QTDIMP, CNTIMP = WK_CNTIMP, TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP WHERE TABELA = 'DES';

            ELSE
       -- Processo simples
       -- Em caso de descarte total cancela o pedido
       -- Em caso de descarte parcial cancela o item original e cria um novo parcial

       OPEN CR_DESCARTES_SIMPLES;
       LOOP
         FETCH CR_DESCARTES_SIMPLES INTO WK_IPE_CODFIL, WK_IPE_NUMPED, WK_IPE_NUMITE, WK_DES_QTDFAL;
         EXIT WHEN NOT FOUND;

         WK_MOTREJ := 'OK';

         -- cancela item
         BEGIN
           UPDATE TT_IPE
              SET FLGEST = 'C',
                  ATU_EM = AGORA()
    	      WHERE CODFIL = WK_IPE_CODFIL
    	        AND NUMPED = WK_IPE_NUMPED
       	        AND NUMITE = WK_IPE_NUMITE;
         EXCEPTION
       	   
           WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR TABELA TT_IPE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                               END;
         BEGIN
    	   -- RFMP 75328
           UPDATE TT_PED
              SET FLGEST = 'Y'
    	    WHERE CODFIL = WK_IPE_CODFIL
    	      AND NUMPED = WK_IPE_NUMPED;
         EXCEPTION
       	   
           WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR TABELA TT_PED: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                               END;

         SELECT QTDITE
           INTO WK_IPE_QTDITE
    	 	   FROM TT_IPE
    	 	  WHERE CODFIL = WK_IPE_CODFIL
    	 	    AND NUMPED = WK_IPE_NUMPED
    	 	    AND NUMITE = WK_IPE_NUMITE;

    	 	 IF WK_IPE_QTDITE > WK_DES_QTDFAL THEN
           -- em caso de descarte parcial gerar um novo item com o restante
           SELECT COALESCE(MAX(NUMITE),0)+1
    	 	     INTO WK_NEW_NUMITE
        	   FROM TT_IPE
        	  WHERE CODFIL = WK_IPE_CODFIL
    	 	      AND NUMPED = WK_IPE_NUMPED;

           -- cria novo item com o total do item antigo - total descartado
           BEGIN
             INSERT INTO TT_IPE
                    (CODFIL, NUMPED, NUMITE,
                     FLGEST, FILENT, FILMAT,
                     CODMAT, ATU_EM, CODMOE,
                     CODCOR, CODTAM, UNICOM,
                     UNIVEN, IPIITE, VLRITE,
                     VLRVEN, QTDITE, ICMITE,
                     VLRDES, QTDCAN, QTDENT,
                     CODBUS, CODMUL, VALCON,
                     BASICM, VLRICM, OUTICM,
                     ISEICM, FILORI, PEDORI,
                     ITEORI, QTDPED, VLRUNI)
             (SELECT CODFIL, NUMPED, WK_NEW_NUMITE,
                     'A', FILENT, FILMAT,
                     CODMAT, AGORA(), CODMOE,
                     CODCOR, CODTAM, UNICOM,
                     UNIVEN, IPIITE,
                     (VLRITE/QTDPED)*(QTDPED-(WK_DES_QTDFAL/NVLZ(VALCON,1))),
                     VLRVEN,
                     QTDITE-WK_DES_QTDFAL,
                     ICMITE,
                     (VLRDES/QTDPED)*(QTDPED*(WK_DES_QTDFAL/NVLZ(VALCON,1))),
                     QTDCAN, QTDENT,
                     CODBUS, CODMUL,
                     NVLZ(VALCON,1),
                     (BASICM/QTDPED)*(QTDPED-(WK_DES_QTDFAL/NVLZ(VALCON,1))),
                     (VLRICM/QTDPED)*(QTDPED-(WK_DES_QTDFAL/NVLZ(VALCON,1))),
                     (OUTICM/QTDPED)*(QTDPED-(WK_DES_QTDFAL/NVLZ(VALCON,1))),
                     (ISEICM/QTDPED)*(QTDPED-(WK_DES_QTDFAL/NVLZ(VALCON,1))),
                     CODFIL, NUMPED, NUMITE,
                     QTDPED-(WK_DES_QTDFAL/NVLZ(VALCON,1)), VLRUNI
                FROM TT_IPE
               WHERE CODFIL = WK_IPE_CODFIL
                 AND NUMPED = WK_IPE_NUMPED
                 AND NUMITE = WK_IPE_NUMITE
             );
             
           EXCEPTION
             
             WHEN restrict_violation    THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := 'ERRO AO INSERIR NOVO ITEM DE PEDIDO: 23001 RESTRICT VIOLATION'; ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN not_null_violation    THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := 'ERRO AO INSERIR NOVO ITEM DE PEDIDO: 23502 NOT NULL VIOLATION'; ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := 'ERRO AO INSERIR NOVO ITEM DE PEDIDO: 23503 FOREIGN KEY VIOLATION'; ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN unique_violation      THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := 'ERRO AO INSERIR NOVO ITEM DE PEDIDO: 23505 UNIQUE VIOLATION'; ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN check_violation       THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := 'ERRO AO INSERIR NOVO ITEM DE PEDIDO: 23514 CHECK VIOLATION'; ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := 'ERRO AO INSERIR NOVO ITEM DE PEDIDO: 23000 INTEGRITY CONSTRAINT VIOLATION'; ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN plpgsql_error         THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := 'ERRO AO INSERIR NOVO ITEM DE PEDIDO: P0000 PLPGSQL ERROR'; ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                     END;
         END IF;

         IF WK_MOTREJ = 'OK' THEN
            WK_STATUS := 1;
         ELSE
            WK_STATUS := 2;
         END IF;

         UPDATE TI_DES
            SET STATUS = WK_STATUS,
                DATIMP = AGORA(),
                MOTREJ = WK_MOTREJ
          WHERE NUMPED = WK_IPE_CODFIL||TRIM(WK_IPE_NUMPED)
            AND NUMITE = WK_IPE_NUMITE;

       END LOOP;
       CLOSE CR_DESCARTES_SIMPLES;

     END IF;
   ELSE
     RAISE EXCEPTION 'PG-20001 IMPORTAO DE DESCARTES NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;

   
   SELECT COUNT(*)
     INTO WK_RESTO
     FROM TI_DES
    WHERE STATUS = 0;

   IF WK_RESTO > 0 THEN
     RETURN 'EXISTEM '||WK_RESTO||' DESCARTES NO IMPORTADOS';
   ELSE
     RETURN 'OK';
   END IF;
   
END;
$$ language 'plpgsql';




/*-- SEQ 1190 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_LOT () CASCADE;

/*-- SEQ 1191 --*/
CREATE OR REPLACE FUNCTION IMPORTA_LOT ()
RETURNS VARCHAR AS $$
DECLARE

-- 1) Importação das tabelas referentes a lote (TT_LOT)
-- TI_LOT
WK_CODEXT      TI_LOT.CODEXT%TYPE;
WK_CODFIL      TI_LOT.CODFIL%TYPE;
WK_GRA_CODEXT  TI_LOT.GRA_CODEXT%TYPE;
WK_FOR_CODEXT  TI_LOT.FOR_CODEXT%TYPE;
WK_NUMLOT      TI_LOT.NUMLOT%TYPE;
WK_TONALI      TI_LOT.TONALI%TYPE;
WK_TAMANH      TI_LOT.TAMANH%TYPE;
WK_DATVAL      TI_LOT.DATVAL%TYPE;
WK_QTDINI      TI_LOT.QTDINI%TYPE;
WK_FLGPON      TI_LOT.FLGPON%TYPE;
WK_DATCRI      TI_LOT.DATCRI%TYPE;
WK_STATUS      TI_LOT.STATUS%TYPE;
WK_MOTREJ      TI_LOT.MOTREJ%TYPE;
WK_DATIMP      TI_LOT.DATIMP%TYPE;
WK_PERABA      TI_LOT.PERABA%TYPE;
WK_CODALT      TI_LOT.CODALT%TYPE;
-- TT_GRA
WK_AUX_CODMAT  TT_GRA.CODMAT%TYPE;
WK_AUX_FILMAT  TT_GRA.FILMAT%TYPE;
WK_AUX_CODCOR  TT_GRA.CODCOR%TYPE;
WK_AUX_CODTAM  TT_GRA.CODTAM%TYPE;
WK_CODEXT_GRA  TT_GRA.CODEXT%TYPE;
-- TT_CLI
WK_AUX_FILFOR  TT_CLI.FILCLI%TYPE;
WK_AUX_CODFOR  TT_CLI.CODCLI%TYPE;
WK_CODEXT_CLI  TT_CLI.CODEXT%TYPE;
-- TT_IED
WK_DIALIM TT_IED.DIALIM%TYPE;
WK_IMPORT TT_IED.IMPORT%TYPE;
WK_MANTEM TT_IED.MANTEM%TYPE;
WK_CNTIMP TT_IED.CNTIMP%TYPE;
-- TT_CFG
WK_MAI_FR      TT_CFG.MAI_FR%TYPE;
WK_MAI_TO      TT_CFG.MAI_TO%TYPE;
WK_SAC_E_MAIL  TT_CFG.SAC_E_MAIL%TYPE;
-- Outras variáveis
WK_CADASTRADO  Numeric;
WK_QTDIMP      Numeric;
WK_NROERR      Numeric;

-- RFMP 101993
-- Controle de limite de execução para PG.
-- Feito conforme a IMPORTA_PRO.
  iNumReg                        Numeric = 500;
-- RFMP 96855
-- QTDINI foi removido da tela e da integração
CR_LOTE CURSOR(pDATCRI TI_LOT.DATCRI%TYPE) IS
  SELECT *
    FROM (SELECT /*+INDEX(TI_LOT, I_LC_ILOT_STATUS)*/
                 CODEXT, CODFIL, GRA_CODEXT, FOR_CODEXT, NUMLOT, TONALI,
                 TAMANH, DATVAL, 0, FLGPON, DATCRI, STATUS, MOTREJ, DATIMP, PERABA, CODALT
            FROM TI_LOT
           WHERE STATUS = 0
             AND DATCRI BETWEEN TRUNC(pDATCRI)
                        AND ADD_DAY(TRUNC(pDATCRI),1)
           ORDER BY DATCRI
         ) TAB
  LIMIT 1;

BEGIN
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e não existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20023 Execução de fora do sistema não permitida. Utilize a tela de Integração do Totali Backoffice ou o Totali Import.';
   END IF;

         SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
        INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
        FROM TT_IED
       WHERE TABELA = 'LOT';
   
   IF WK_IMPORT = 'T' THEN
   WK_CNTIMP := WK_CNTIMP + 1;
   WK_QTDIMP := 0;
   LOOP
     SELECT MIN(DATCRI)
       INTO WK_DATCRI
       FROM TI_LOT
      WHERE STATUS = 0;

      OPEN CR_LOTE(WK_DATCRI);
      FETCH CR_LOTE INTO WK_CODEXT, WK_CODFIL, WK_GRA_CODEXT, WK_FOR_CODEXT, WK_NUMLOT, WK_TONALI,
                         WK_TAMANH, WK_DATVAL, WK_QTDINI, WK_FLGPON, WK_DATCRI, WK_STATUS, WK_MOTREJ, WK_DATIMP, WK_PERABA, WK_CODALT;

      IF NOT FOUND THEN
         CLOSE CR_LOTE;
         EXIT;
      END IF;

      
      IF iNumReg = 0 THEN
        CLOSE CR_LOTE;
        EXIT;
      END IF;
      
     WK_MOTREJ     := 'OK';

     -- TD_FIL.
              SELECT F.CODFIL
           INTO WK_CODFIL
           FROM TD_FIL F
           WHERE TRIM(F.CODFIL) = TRIM(WK_CODFIL);
          IF WK_MOTREJ = 'OK' THEN
       IF WK_CODFIL IS NULL THEN
         WK_MOTREJ := 'ERRO AO INSERIR LOTE: Filial não encontrada';
       END IF;
     END IF;

     -- TT_GRA.
             SELECT G.FILMAT, G.CODMAT, G.CODCOR, G.CODTAM, G.CODEXT
          INTO WK_AUX_FILMAT, WK_AUX_CODMAT, WK_AUX_CODCOR, WK_AUX_CODTAM, WK_CODEXT_GRA
          FROM TT_GRA G
         WHERE G.CODEXT = WK_GRA_CODEXT;
          IF WK_MOTREJ = 'OK' THEN
       IF WK_AUX_FILMAT IS NULL THEN
         WK_MOTREJ := 'ERRO AO INSERIR LOTE: Grade não encontrada';
       END IF;
     END IF;

     -- TT_CLI.
            SELECT C.FILCLI, C.CODCLI, C.CODEXT
         INTO WK_AUX_FILFOR, WK_AUX_CODFOR, WK_CODEXT_CLI
         FROM TT_CLI C
        WHERE C.CODEXT = WK_FOR_CODEXT;
          IF WK_MOTREJ = 'OK' THEN
       IF WK_AUX_FILFOR IS NULL THEN
         WK_MOTREJ := 'ERRO AO INSERIR LOTE: Fornecedor não encontrado';
       END IF;
     END IF;

     SELECT COUNT(*)
       INTO WK_CADASTRADO
       FROM TT_LOT
      WHERE CODEXT = WK_CODEXT;

     -- Se for um LOTE que ainda nao esta cadastrada
     IF WK_MOTREJ = 'OK'
     AND WK_CADASTRADO = 0 THEN
        -- verifica se existe na TT_LOT CODMAT, CODFOR, NUMLOT e com CODEXT <> WK_CODEXT da TI_LOT
        SELECT COUNT(*)
             INTO WK_CADASTRADO
             FROM TT_LOT TLOT INNER JOIN TT_GRA GRA ON GRA.FILMAT = TLOT.FILMAT AND GRA.CODMAT = TLOT.CODMAT AND GRA.CODCOR = TLOT.CODCOR AND GRA.CODTAM = TLOT.CODTAM
                              INNER JOIN TT_CLI CLI ON CLI.FILCLI = TLOT.FILFOR AND CLI.CODCLI = TLOT.CODFOR
             WHERE GRA.CODEXT   = WK_CODEXT_GRA
               AND CLI.CODEXT   = WK_CODEXT_CLI
               AND TLOT.NUMLOT  = WK_NUMLOT
               AND TLOT.CODEXT <> WK_CODEXT;
        IF WK_CADASTRADO = 0 THEN
          BEGIN
             --IF WK_QTDINI IS NULL THEN
             --  RAISE EXCEPTION 'PG-20100 A coluna QTDINI deve ser preenchida';
             --END IF;
             INSERT INTO TT_LOT (CODFIL, SEQUEN, FILMAT, CODMAT, CODCOR, CODTAM, FILFOR, CODFOR,
                 NUMLOT, DATINC, ATU_EM, TONALI, TAMANH, DATVAL, QTDINI, QTDCOM,
                 QTDEST, FLGPON, CODEXT, PERABA, CODALT)
                  VALUES (WK_CODFIL, NULL, WK_AUX_FILMAT, WK_AUX_CODMAT, WK_AUX_CODCOR, WK_AUX_CODTAM, WK_AUX_FILFOR, WK_AUX_CODFOR,
                  WK_NUMLOT, AGORA(), AGORA(), WK_TONALI, WK_TAMANH, WK_DATVAL, WK_QTDINI, 0,
                  0, WK_FLGPON, WK_CODEXT, WK_PERABA, WK_CODALT);
          EXCEPTION
	         
	         WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR LOTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	         WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR LOTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	         WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR LOTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	         WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR LOTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR LOTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR LOTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR LOTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                    END;
          IF NOT WK_MOTREJ = 'OK' THEN
             WK_STATUS := 4;
             WK_NROERR := WK_NROERR + 1;
          ELSE
             WK_STATUS := 3;
          END IF; -- Fim da inclusao da TT_LOT
        ELSE
          WK_MOTREJ := 'ERRO AO INSERIR LOTE: Já existe registo com esse GRA_CODEXT, FOR_CODEXT, NUMLOT e CODEXT Diferente!';
        END IF;
     ELSE
        -- Tratamento para lote cadastrado
        -- Atualiza TT_LOT
        BEGIN
           UPDATE TT_LOT
              SET NUMLOT = COALESCE(WK_NUMLOT,NUMLOT),
	              ATU_EM = AGORA(),
                  TONALI = COALESCE(WK_TONALI,TONALI),
                  TAMANH = COALESCE(WK_TAMANH,TAMANH),
                  DATVAL = COALESCE(WK_DATVAL,DATVAL),
                  --QTDINI = CASE WHEN QTDINI IS NOT NULL
                  --                             THEN COALESCE(WK_QTDINI,QTDINI)
                  --                          END,
                  FLGPON = COALESCE(WK_FLGPON,FLGPON),
                  PERABA = COALESCE(WK_PERABA,PERABA),
                  CODALT = COALESCE(WK_CODALT,CODALT)
                WHERE CODEXT = WK_CODEXT;

        EXCEPTION
           
           WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR LOTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR LOTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR LOTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR LOTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR LOTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR LOTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR LOTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                              END;
     END IF;  -- Fim do tratamento de lote cadastrado
     IF NOT WK_MOTREJ = 'OK' THEN
       WK_STATUS := 4;
       WK_NROERR := WK_NROERR + 1;
     ELSE
       WK_STATUS := 3;
     END IF;

     UPDATE TI_LOT SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
      WHERE DATIMP IS NULL
        AND DATCRI = WK_DATCRI
        AND CODEXT = WK_CODEXT;
            WK_QTDIMP := WK_QTDIMP + 1;

      
      iNumReg := iNumReg - 1;
      
     CLOSE CR_LOTE;
   END LOOP;

   IF WK_NROERR <> 0 THEN
      SELECT MAI_FR, MAI_TO, SAC_E_MAIL
        INTO WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL
        FROM TT_CFG;
      IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
         INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO, MAI_CC,
                             TEXTOS,TIPMSG)
                     VALUES ('001','F',AGORA(),'IMPORTAÇÃO DE LOTES',WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL,
                             'Problema na importação de '||wk_nroerr||' lotes. Verifique!','T');
      END IF;
    END IF;

   UPDATE TI_LOT SET STATUS = CASE WHEN STATUS = 3
                                   THEN 1
                                   ELSE 2
                               END
    WHERE STATUS IN (3,4);
    IF WK_MANTEM = 'F' THEN
       IF WK_DIALIM > 0 THEN
         DELETE FROM TI_LOT
          WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
		    AND STATUS = 1;
      ELSE
         DELETE FROM TI_LOT
		  WHERE STATUS = 1;
      END IF;
   END IF;
   UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = WK_QTDIMP, CNTIMP = WK_CNTIMP, TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP WHERE TABELA = 'LOT';
      ELSE RAISE EXCEPTION 'PG-20001 IMPORTAÇÃO DE LOTES NÃO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1192 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DepositaCheques () CASCADE;

/*-- SEQ 1193 --*/
CREATE OR REPLACE FUNCTION DepositaCheques ()
RETURNS VARCHAR AS $$
DECLARE

  vCOMPENSA VARCHAR(1);
  VDIAS_COMP_AUT Numeric(2);
BEGIN
  UPDATE TT_CHR SET FLGEST = 'D',PAGAME = agora()
  WHERE FLGEST = 'U'
    AND agora() >= (SELECT TRUNC(TT_CHR.DATVEN) +
                           CAST(TRUNC(CASE GREATEST(C.VLRLIM,TT_CHR.VLRCHE) WHEN C.VLRLIM THEN C.MINDIA
                                                                       ELSE C.MAXDIA
                                 END) AS INTEGER)
                      FROM TT_CTB C,TD_COB B
                     WHERE B.CODTAB = TT_CHR.PORTAD
                       AND B.TIPCOB = TT_CHR.TIPCOB
                       AND B.FILCTA = C.FILCTA
                       AND B.SEQCTA = C.SEQCTA
                       AND B.TIPCTA = C.TIPCTA
                       AND B.TIPCTB = C.TIPCTB);


  SELECT COMPENSACAO_AUTOMATICA INTO vCOMPENSA
    FROM TT_CFG;

  SELECT DIAS_COMPENSACAO_AUTOMATICA INTO VDIAS_COMP_AUT
    FROM TT_CFG;

  IF vCOMPENSA='T' THEN
     UPDATE TT_CHR
        SET FLGEST = 'C',
            FILUSU = USU.FILUSU,
            CODUSU = USU.CODUSU,
            PAGAME = TRUNC(AGORA()),
            ATU_EM = AGORA()
  FROM TT_USU USU
 WHERE USU.APEUSU=QUALDONO()
--   AND DATOPE <= ADD_DAY(TRUNC(agora()), -1)
     AND DATOPE <= ADD_DAY(TRUNC(agora()), - VDIAS_COMP_AUT)
   AND FLGEST = 'D';
  END IF;
  RETURN 'OK';
END;
$$ language 'plpgsql';



/*-- SEQ 1194 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_DepositaCheques (TT_JOB.CODUID%TYPE) CASCADE;

/*-- SEQ 1195 --*/
CREATE OR REPLACE FUNCTION Job_DepositaCheques (TT_JOB.CODUID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODUID ALIAS FOR $1 ;
   vNOME                         TT_JOB.NOMJOB%TYPE;
   vDESC                         TT_JOB.DESJOB%TYPE;
   DUMMY                         CHAR(2);
BEGIN
   vNOME := 'JOB_DEPOSITACHEQUES';
   VDESC := 'Rotina para deposito e compensacao de cheques';
   BEGIN
      DUMMY := DepositaCheques();
      DUMMY := RegistraJob(vNOME, vDESC, NULL, pCODUID);
   EXCEPTION
      WHEN OTHERS THEN DUMMY := RegistraJob(vNOME, vDESC, SQLERRM, pCODUID);
   END;
  RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 1196 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_DepositaCheques () CASCADE;

/*-- SEQ 1197 --*/
CREATE OR REPLACE FUNCTION Job_DepositaCheques () 
RETURNS VARCHAR AS $$
BEGIN
RETURN Job_DepositaCheques(NULL);
END;
$$ language 'plpgsql';


-- Autor: Manoel - 2020095738
-- Cliente(s): Gimba
-- Finalidade(s):
-- 1) Funo criada para ser utilizada na TV_GERTEC_EAN, objetivo de trazer o preo do produto ou preo promocional por filial
--    utilizando a mesma lgica que o POS faz: 1 - Verifica FILDES da TT_TPR, depois o estado da filial e por ltimo pega a tabela de preos
--    da TT_CFG
/*-- SEQ 1198 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PrecoPorFilial (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1199 --*/
CREATE OR REPLACE FUNCTION PrecoPorFilial (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE,VARCHAR)
RETURNS TT_PRE.PRECOV%TYPE AS $$
DECLARE
pFilMat ALIAS FOR $1 ;
pCodMat ALIAS FOR $2 ;
pCodCor ALIAS FOR $3 ;
pCodTam ALIAS FOR $4 ;
pFilial ALIAS FOR $5 ;
pPrecoPromocional ALIAS FOR $6 ;
   nFILPRE                       TT_TPR.CODFIL%TYPE;
   nCODPRE                       TT_TPR.CODPRE%TYPE;
   nRetorno                      TT_PRE.PRECOV%TYPE;
BEGIN
   nRetorno := 0;

   -- MN -  obtido o preo promocional/preo de venda conforme o POS, o POS verifica a tabela por FILDES, depois ESTADO e por ltimo pega da TT_CFG
         SELECT MIN(TPR.CODFIL) AS CODFIL, MIN(TPR.CODPRE) AS CODPRE INTO nFILPRE, nCODPRE
        FROM TT_TPR TPR 
       WHERE TPR.FILDES = pFilial
         AND TPR.SIGNAT >= 0;
     
   IF ISNOTNULL(nFILPRE) = 'F' THEN
               SELECT MIN(TPR.CODFIL) AS CODFIL, MIN(TPR.CODPRE) AS CODPRE INTO nFILPRE, nCODPRE
           FROM TT_TPR TPR INNER JOIN TD_FIL DFIL ON DFIL.UFLOJA = TPR.ESTADO
          WHERE DFIL.CODFIL = pFilial
            AND TPR.SIGNAT >= 0;
         END IF;
  
   IF ISNOTNULL(nFILPRE) = 'F' THEN
               SELECT MIN(FILPRE) AS CODFIL, MIN(CODPRE) AS CODPRE INTO nFILPRE, nCODPRE
           FROM TT_CFG;
         END IF;

   IF ISNOTNULL(nFILPRE) = 'T' THEN
      IF pPrecoPromocional = 'F' THEN
                    SELECT MIN(PRE.PRECOV) INTO nRetorno
             FROM TT_PRE PRE 
            WHERE PRE.FILPRE = nFILPRE
              AND PRE.CODPRE = nCODPRE
              AND PRE.FILMAT = pFilMat
              AND PRE.CODMAT = pCodMat
              AND PRE.CODCOR = pCodCor
              AND PRE.CODTAM = pCodTam;
               ELSE
                    -- MN - Esse  o preo que ser lido nas maquinas, igual supermercado, por isso tira preos exclusivos que envolvem um lote especfico
           SELECT MIN(CPM.PRECOP) INTO nRetorno
             FROM TT_CPM CPM INNER JOIN TT_PRE PRE ON PRE.FILPRE = CPM.FILPRE
                                                  AND PRE.SEQUEN = CPM.SEQPRE
                                                  AND PRE.FILMAT = pFilMat
                                                  AND PRE.CODMAT = pCodMat
                                                  AND PRE.CODCOR = pCodCor
                                                  AND PRE.CODTAM = pCodTam
                              CROSS JOIN TT_CFG CFG
             WHERE COALESCE(CPM.DATINI, TO_DATE('01/01/1900','DD/MM/YYYY')) <= TRUNC(AGORA())
               AND CPM.DATVAL >= TRUNC(AGORA())
               AND ((CPM.FILPRO = pFilial) OR CPM.FILPRO IS NULL)
               AND ((CPM.FILPGT = CFG.VC_FILPGT AND CPM.CODPGT = VC_CODPGT) OR CPM.FILPGT IS NULL)
               AND PRE.FILPRE = nFILPRE
               AND PRE.CODPRE = nCODPRE
               AND CPM.FILLOT IS NULL
               AND COALESCE(CPM.QTDCPM, 0) = 0
               AND COALESCE(CPM.QTDMIN, 0) = 0
               AND CPM.CLILEV = 'F';
               END IF;
   END IF;

   RETURN COALESCE(nRetorno,0);
END;
$$ language 'plpgsql';




/*-- SEQ 1200 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ALTERAITEM_DAV (TT_IOR.CODFIL%TYPE,TT_IOR.TIPPED%TYPE,TT_IOR.NUMPED%TYPE,TT_IOR.NUMITE%TYPE,TT_IOR.VLRCUS%TYPE,TT_IOR.VLRPGT%TYPE,TT_IOR.QTDITE%TYPE,TT_IOR.VLRITE%TYPE,TT_IOR.VLRENT%TYPE,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_IOR.PROMOC%TYPE,TT_IOR.PREUNI%TYPE,TT_IOR.CODMUL%TYPE,TT_IOR.OBSERV%TYPE,TT_IOR.PERIPI%TYPE,TT_IOR.ASSINA%TYPE,TT_IOR.FLGEST%TYPE,TT_IOR.FILLOT%TYPE,TT_IOR.SEQLOT%TYPE) CASCADE;

/*-- SEQ 1201 --*/
CREATE OR REPLACE FUNCTION ALTERAITEM_DAV (TT_IOR.CODFIL%TYPE,TT_IOR.TIPPED%TYPE,TT_IOR.NUMPED%TYPE,TT_IOR.NUMITE%TYPE,TT_IOR.VLRCUS%TYPE,TT_IOR.VLRPGT%TYPE,TT_IOR.QTDITE%TYPE,TT_IOR.VLRITE%TYPE,TT_IOR.VLRENT%TYPE,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_IOR.PROMOC%TYPE,TT_IOR.PREUNI%TYPE,TT_IOR.CODMUL%TYPE,TT_IOR.OBSERV%TYPE,TT_IOR.PERIPI%TYPE,TT_IOR.ASSINA%TYPE,TT_IOR.FLGEST%TYPE,TT_IOR.FILLOT%TYPE,TT_IOR.SEQLOT%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pTIPPED ALIAS FOR $2 ;
pNUMPED ALIAS FOR $3 ;
pNUMITE ALIAS FOR $4 ;
pVLRCUS ALIAS FOR $5 ;
pVLRPGT ALIAS FOR $6 ;
pQTDITE ALIAS FOR $7 ;
pVLRITE ALIAS FOR $8 ;
pVLRENT ALIAS FOR $9 ;
pFILMAT ALIAS FOR $10 ;
pCODMAT ALIAS FOR $11 ;
pCODCOR ALIAS FOR $12 ;
pCODTAM ALIAS FOR $13 ;
pPROMOC ALIAS FOR $14 ;
pPREUNI ALIAS FOR $15 ;
pCODMUL ALIAS FOR $16 ;
pOBSERV ALIAS FOR $17 ;
pPERIPI ALIAS FOR $18 ;
pASSINA ALIAS FOR $19 ;
pFLGEST ALIAS FOR $20 ;
pFILLOT ALIAS FOR $21 ;
pSEQLOT ALIAS FOR $22 ;
                                    
BEGIN    
   
   IF (ISNOTNULL(pCODFIL)='T') AND
      (ISNOTNULL(pNUMPED)='T') AND
      (pNUMITE IS NOT NULL) THEN
     UPDATE TT_IOR 
        SET CODFIL = pCODFIL,
            TIPPED = pTIPPED,
            NUMPED = pNUMPED,
            NUMITE = pNUMITE,
            VLRCUS = pVLRCUS,
            VLRPGT = pVLRPGT,
            QTDITE = pQTDITE,
            VLRITE = pVLRITE,
            VLRENT = pVLRENT,
            FILMAT = pFILMAT,
            CODMAT = pCODMAT,
            CODCOR = pCODCOR,
            CODTAM = pCODTAM,
            PROMOC = pPROMOC,
            PREUNI = pPREUNI,
            CODMUL = pCODMUL,
            OBSERV = pOBSERV,
            PERIPI = pPERIPI,
			ASSINA = pASSINA,
			FLGEST = pFLGEST,
            FILLOT = pFILLOT,
            SEQLOT = pSEQLOT
      WHERE CODFIL = pCODFIL
        AND NUMPED = pNUMPED
        AND NUMITE = pNUMITE
        AND TIPPED = pTIPPED;
    ELSE    
      RAISE EXCEPTION 'PG-20010 No foi possvel atualizar o item do oramento.';
    END IF;

  RETURN NULL;

END;
$$ language 'plpgsql';

  

/*-- SEQ 1202 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ENVIAITEM_DAV (TT_IOR.CODFIL%TYPE,TT_IOR.TIPPED%TYPE,TT_IOR.NUMPED%TYPE,TT_IOR.NUMITE%TYPE,TT_IOR.VLRCUS%TYPE,TT_IOR.VLRPGT%TYPE,TT_IOR.QTDITE%TYPE,TT_IOR.VLRITE%TYPE,TT_IOR.VLRENT%TYPE,TT_GRA.CODEXT%TYPE,TT_IOR.PROMOC%TYPE,TT_IOR.PREUNI%TYPE,TD_MUL.DESMUL%TYPE,TT_IOR.OBSERV%TYPE,TT_IOR.PERIPI%TYPE,TT_IOR.ASSINA%TYPE,TT_IOR.FLGEST%TYPE,TT_LOT.CODEXT%TYPE) CASCADE;

/*-- SEQ 1203 --*/
CREATE OR REPLACE FUNCTION ENVIAITEM_DAV (TT_IOR.CODFIL%TYPE,TT_IOR.TIPPED%TYPE,TT_IOR.NUMPED%TYPE,TT_IOR.NUMITE%TYPE,TT_IOR.VLRCUS%TYPE,TT_IOR.VLRPGT%TYPE,TT_IOR.QTDITE%TYPE,TT_IOR.VLRITE%TYPE,TT_IOR.VLRENT%TYPE,TT_GRA.CODEXT%TYPE,TT_IOR.PROMOC%TYPE,TT_IOR.PREUNI%TYPE,TD_MUL.DESMUL%TYPE,TT_IOR.OBSERV%TYPE,TT_IOR.PERIPI%TYPE,TT_IOR.ASSINA%TYPE,TT_IOR.FLGEST%TYPE,TT_LOT.CODEXT%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pTIPPED ALIAS FOR $2 ;
pNUMPED ALIAS FOR $3 ;
pNUMITE ALIAS FOR $4 ;
pVLRCUS ALIAS FOR $5 ;
pVLRPGT ALIAS FOR $6 ;
pQTDITE ALIAS FOR $7 ;
pVLRITE ALIAS FOR $8 ;
pVLRENT ALIAS FOR $9 ;
pPROEXT ALIAS FOR $10 ;
pPROMOC ALIAS FOR $11 ;
pPREUNI ALIAS FOR $12 ;
pDESMUL ALIAS FOR $13 ;
pOBSERV ALIAS FOR $14 ;
pPERIPI ALIAS FOR $15 ;
pASSINA ALIAS FOR $16 ;
pFLGEST ALIAS FOR $17 ;
pLOTEXT ALIAS FOR $18 ;
  
  WK_NUMPED    TT_ORC.NUMPED%TYPE;    
  WK_CODMUL    TT_IOR.CODMUL%TYPE;
  WK_NUMITE    TT_IOR.NUMITE%TYPE;
  WK_QTDITE    TT_IOR.QTDITE%TYPE;
  
  WK_FILMAT    TT_GRA.FILMAT%TYPE;
  WK_CODMAT    TT_GRA.CODMAT%TYPE;
  WK_CODCOR    TT_GRA.CODCOR%TYPE;
  WK_CODTAM    TT_GRA.CODTAM%TYPE;   
  WK_QTDIOR Numeric;   
  
  cDUMMY       VARCHAR(10);    
  vComplemento CONSTANT VARCHAR(254):= constante('complemento');
  vErro        VARCHAR(4000);
  CRLF         CONSTANT CHAR(1) := CHR(10);  

  WK_RESERV    TT_ORC.RESERV%TYPE;   
  WK_FLGEST    TT_IOR.FLGEST%TYPE;   
  
  WK_FILLOT    TT_LOT.CODFIL%TYPE;
  WK_SEQLOT    TT_LOT.SEQUEN%TYPE;  

BEGIN
  -- Valida parmetros.  
  vErro := '';
  
  IF ISNULL(pCODFIL) = 'T' THEN
    vErro := 'CODFIL- Filialda DAV.'||CRLF;
  END IF;
  IF ISNULL(pNUMPED) = 'T' THEN
    vErro := vErro || 'NUMPED - Nmeroda DAV ou Pr-Venda.'||CRLF;
  END IF;
  IF ISNULL(pTIPPED) = 'T' THEN
    vErro := vErro || 'TIPPED- Tipo de Pedido/OS.'||CRLF;
  END IF;  
  IF pVLRCUS IS NULL OR pVLRCUS = 0 THEN
    vErro := vErro || 'VLRCUS - Valor total.'||CRLF;
  END IF;
  IF pVLRPGT IS NULL OR pVLRPGT = 0 THEN
    vErro := vErro || 'VLRPGT - Valor Total Sem Desc/Acres.'||CRLF;
  END IF;
  IF pQTDITE IS NULL OR pQTDITE = 0 THEN
    vErro := vErro || 'QTDITE- Quantidade.'||CRLF;
  END IF;
  IF pVLRITE IS NULL OR pVLRITE = 0 THEN
    vErro := vErro || 'VLRITE -Vlr. Unitrio.'||CRLF;
  END IF;
  IF pVLRENT IS NULL OR pVLRENT = 0 THEN
    vErro := vErro || 'VLRENT -Vlr. Unitrio Sem desconto/Acres.'||CRLF;
  END IF;
  IF ISNULL(pPROEXT) = 'T' THEN
    vErro := vErro || 'PROEXT - Cdigo externo do Produto.'||CRLF;
  END IF;
  IF ISNULL(pPROMOC) = 'T' THEN
    vErro := vErro || 'PROMOC - Promoo.'||CRLF;
  END IF;   
  IF (pFLGEST <> 'A') AND (pFLGEST <> 'R') AND (pFLGEST IS NOT NULL) THEN
    vErro := vErro || 'FLGEST - Situao do Item.'||CRLF;
  END IF;
    
  IF ISNOTNULL(vErro)='T' THEN
    RAISE EXCEPTION 'PG-20010 Os seguintes campos no foram informados e gerou inconsistncias : %' , vErro;
  END IF;

  BEGIN
    SELECT NUMPED, RESERV INTO WK_NUMPED, WK_RESERV
      FROM TT_ORC
     WHERE CODFIL = pCODFIL 
       AND NUMPED = pNUMPED
       AND TIPPED = pTIPPED;
  EXCEPTION    
        
    WHEN others THEN NULL;
        RAISE EXCEPTION 'PG-20011 Oramento no presente na base de dados. %' , VComplemento;
  END;
  IF WK_NUMPED IS NULL THEN 
     RAISE EXCEPTION 'PG-20011 Oramento no presente na base de dados. %' , VComplemento;
  END IF;
  
  BEGIN
  SELECT NUMITE, QTDITE INTO WK_NUMITE, WK_QTDITE           
    FROM TT_IOR
   WHERE CODFIL = pCODFIL 
     AND NUMPED = WK_NUMPED  
     AND NUMITE = pNUMITE
     AND TIPPED = pTIPPED;
  EXCEPTION    
        
    WHEN others THEN WK_NUMITE := NULL;
        
  END;   
  
  IF WK_NUMITE <> NULL THEN
    IF WK_QTDITE <> pQTDITE THEN 
	   RAISE EXCEPTION 'PG-10000 No  permitido alterar a quantidade do oramento. %' , VComplemento;
    END IF;
  END IF;
  
  BEGIN 
  SELECT FILMAT, CODMAT, CODCOR, CODTAM INTO WK_FILMAT, WK_CODMAT, WK_CODCOR, WK_CODTAM
    FROM TT_GRA
   WHERE CODEXT = pPROEXT;    
  EXCEPTION    
        
    WHEN others THEN NULL;
      
    RAISE EXCEPTION 'PG-20012 Produto no encontrado. %' , VComplemento;    	
  END;
  IF WK_FILMAT IS NULL THEN
     RAISE EXCEPTION 'PG-20012 Produto no encontrado. %' , VComplemento; 
  END IF;
  
  BEGIN  
    SELECT CODTAB INTO WK_CODMUL
      FROM TD_MUL
     WHERE UPPER(DESMUL) = UPPER(pDESMUL)
       AND MULATI = 'T'; 
  EXCEPTION
        
    WHEN others THEN WK_CODMUL := NULL;
          
  END;
  IF WK_CODMUL IS NULL THEN
     RAISE EXCEPTION 'PG-20012 Sub-Estoque no encontrado. %' , VComplemento;    
  END IF;
  
  SELECT COUNT(*) 
    INTO WK_QTDIOR
    FROM TT_IOR IOR
   WHERE (IOR.FLGEST = 'E'        OR
          IOR.ECFVEN IS NOT NULL) AND
          IOR.NUMPED = WK_NUMPED  AND
          IOR.TIPPED = pTIPPED    AND
          IOR.CODFIL = pCODFIL;

    IF WK_QTDIOR > 0  THEN
       RAISE EXCEPTION 'PG-20000 No  permitido alterar oramento com itens vendidos ou estar com o nmero de ECF preenchido. %' , VComplemento;
    END IF;

    IF pFLGEST IS NULL THEN
        IF WK_RESERV = 'T'  THEN 
            WK_FLGEST:= 'R'; 
        ELSE 
            WK_FLGEST:= 'A'; 
        END IF;
    ELSE
        WK_FLGEST:= pFLGEST;
    END IF;
    
   IF pLOTEXT IS NOT NULL THEN
        SELECT CODFIL, SEQUEN
      INTO WK_FILLOT, WK_SEQLOT
      FROM TT_LOT LOT
      WHERE LOT.CODEXT = pLOTEXT;
       END IF;  

   IF (WK_FILLOT IS NULL) AND (pLOTEXT IS NOT NULL) THEN
     RAISE EXCEPTION 'PG-20012 Lote nao encontrado. %' , VComplemento;    
   END IF;
  
    IF ISNOTNULL(WK_NUMPED)='T' THEN
    IF WK_NUMITE IS NOT NULL THEN  
		
       cDummy := ALTERAITEM_DAV(pCODFIL,pTIPPED,WK_NUMPED,pNUMITE,pVLRCUS,pVLRPGT,
                                         pQTDITE,pVLRITE,pVLRENT,WK_FILMAT,WK_CODMAT,WK_CODCOR,
                                         WK_CODTAM,pPROMOC,pPREUNI,WK_CODMUL,pOBSERV,pPERIPI,pASSINA,WK_FLGEST,
                                         WK_FILLOT,WK_SEQLOT);
       
       UPDATE TT_IOR
          SET TIPENT = '6'       
        WHERE CODFIL = pCODFIL 
          AND NUMPED = WK_NUMPED
          AND NUMITE = WK_NUMITE
          AND TIPPED = pTIPPED;
    ELSE  
   
       INSERT INTO TT_IOR (CODFIL, TIPPED, NUMPED, NUMITE, FLGEST, PROMOC,
                           FILMAT, FILRES, CODMAT, ATU_EM, ORDITE, CODTAM,
                           VLRCUS, VLRENT, VLRITE, VLRPGT, QTDENT, QTDITE,
                           MONTAR, CODMUL, CODCOR, DATINC, PERIPI, CODUID, ASSINA,
                           OBSERV, FILLOT, SEQLOT)
                          (SELECT pCODFIL, COALESCE(pTIPPED,'O'), WK_NUMPED, pNUMITE,
                                  WK_FLGEST,COALESCE(pPROMOC,'N'),WK_FILMAT, pCODFIL,
                                  WK_CODMAT, AGORA(), pNUMITE, WK_CODTAM,
                                  pVLRCUS, pVLRENT, pVLRITE, 
                                  pVLRPGT, 0, pQTDITE,
                                  'F', COALESCE(WK_CODMUL,0), WK_CODCOR, AGORA(),pPERIPI,NULL,pASSINA,
                                  pOBSERV, WK_FILLOT, WK_SEQLOT
                             FROM DUAL);

       UPDATE TT_IOR
          SET TIPENT = '6'       
        WHERE CODFIL = pCODFIL 
          AND NUMPED = WK_NUMPED
          AND NUMITE = WK_NUMITE
          AND TIPPED = pTIPPED;
    END IF;     
  END IF;

  RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 1204 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ENVIAITEM_DAV (TT_IOR.CODFIL%TYPE,TT_IOR.TIPPED%TYPE,TT_IOR.NUMPED%TYPE,TT_IOR.NUMITE%TYPE,TT_IOR.VLRCUS%TYPE,TT_IOR.VLRPGT%TYPE,TT_IOR.QTDITE%TYPE,TT_IOR.VLRITE%TYPE,TT_IOR.VLRENT%TYPE,TT_GRA.CODEXT%TYPE,TT_IOR.PROMOC%TYPE,TT_IOR.PREUNI%TYPE,TD_MUL.DESMUL%TYPE,TT_IOR.OBSERV%TYPE,TT_IOR.PERIPI%TYPE,TT_IOR.ASSINA%TYPE,TT_IOR.FLGEST%TYPE) CASCADE;

/*-- SEQ 1205 --*/
CREATE OR REPLACE FUNCTION ENVIAITEM_DAV (TT_IOR.CODFIL%TYPE,
                               TT_IOR.TIPPED%TYPE,
                               TT_IOR.NUMPED%TYPE,
                               TT_IOR.NUMITE%TYPE,
                               TT_IOR.VLRCUS%TYPE,
                               TT_IOR.VLRPGT%TYPE,
                               TT_IOR.QTDITE%TYPE,
                               TT_IOR.VLRITE%TYPE,
                               TT_IOR.VLRENT%TYPE,
                               TT_GRA.CODEXT%TYPE,
                               TT_IOR.PROMOC%TYPE,
                               TT_IOR.PREUNI%TYPE,
                               TD_MUL.DESMUL%TYPE,
                               TT_IOR.OBSERV%TYPE,
                               TT_IOR.PERIPI%TYPE,
                               TT_IOR.ASSINA%TYPE,
                               TT_IOR.FLGEST%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN ENVIAITEM_DAV($1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,$12,$13,$14,$15,$16,$17,NULL);
END;
$$ language 'plpgsql';



CREATE OR REPLACE FUNCTION GX_AGORA (OUT Timestamp) AS '
DECLARE
pAgora ALIAS FOR $1 ;
BEGIN
  pAgora:=agora();
END;
' language 'plpgsql';



/*-- SEQ 1206 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GXProximoCodigo(Tabela in VARCHAR, Filial in VARCHAR, Retorno out VARCHAR);

/*-- SEQ 1207 --*/
CREATE FUNCTION GXProximoCodigo(Tabela in VARCHAR, Filial in VARCHAR, Retorno out VARCHAR) AS $$
BEGIN
  Retorno := ProximoCodigo(Tabela, Filial);
END;
$$ LANGUAGE plpgsql;


/*-- SEQ 1208 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VALIDA_DAV (TT_ORC.CODFIL%TYPE,TT_ORC.NUMPED%TYPE,TT_ORC.TIPPED%TYPE) CASCADE;

/*-- SEQ 1209 --*/
CREATE OR REPLACE FUNCTION VALIDA_DAV (TT_ORC.CODFIL%TYPE,TT_ORC.NUMPED%TYPE,TT_ORC.TIPPED%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pNUMPED ALIAS FOR $2 ;
pTIPPED ALIAS FOR $3 ;
  
  WK_NUMPED    TT_ORC.NUMPED%TYPE;  
  WK_APRCLI    TT_ORC.APRCLI%TYPE;
  WK_TIPENT    TT_ORC.TIPENT%TYPE;
  WK_APROVA    TT_ORC.APROVA%TYPE;
  WK_FLGEST    TT_ORC.FLGEST%TYPE;
  WK_TELEVE    TT_ORC.TELEVE%TYPE;
  WK_VLRTOT    TT_ORC.VLRTOT%TYPE;
  WK_NUMITE    TT_IOR.NUMITE%TYPE;

  vComplemento CONSTANT VARCHAR(254):= constante('complemento');
  vErro        VARCHAR(4000);
  CRLF         CONSTANT CHAR(1) := CHR(10);
  TOTAL_ITENS  TT_ORC.VLRTOT%TYPE;  
  
  cWK_VLRTOT   VARCHAR(100);
  cTOTAL_ITENS VARCHAR(100);  

BEGIN
  -- Valida parmetros.
  vErro := '';

  IF ISNULL(pCODFIL) = 'T' THEN
    vErro := 'CODFIL- Filialda DAV.'||CRLF;
  END IF;
  IF ISNULL(pNUMPED) = 'T' THEN
    vErro := vErro || 'NUMPED - Nmeroda DAV ou Pr-Venda.'||CRLF;
  END IF;
  IF ISNULL(pTIPPED) = 'T' THEN
    vErro := vErro || 'TIPPED- Tipo Pedido/OS.'||CRLF;
  END IF;

  IF ISNOTNULL(vErro)='T' THEN
    RAISE EXCEPTION 'PG-20010 Os seguintes campos no foram informados e gerou inconsistncias : %' , vErro;
  END IF;

  BEGIN
    SELECT NUMPED, APRCLI, TIPENT, APROVA, FLGEST, TELEVE, VLRTOT-VLRDES-COALESCE(VLRFRE,0) AS VLRTOT
      INTO WK_NUMPED, WK_APRCLI, WK_TIPENT, WK_APROVA, WK_FLGEST, WK_TELEVE, WK_VLRTOT
      FROM TT_ORC
     WHERE CODFIL = pCODFIL
       AND NUMPED = pNUMPED
       AND TIPPED = pTIPPED;
  EXCEPTION
        
    WHEN others THEN NULL;
        RAISE EXCEPTION 'PG-20011 Oramento "%" no presente na base de dados. %' , pNUMPED,VComplemento;
  END;
  
  BEGIN  
   SELECT SUM(VLRCUS) INTO TOTAL_ITENS
    FROM TT_IOR
   WHERE CODFIL = pCODFIL
     AND NUMPED = pNUMPED
     AND TIPPED = pTIPPED
     AND FLGEST<>'C';
  EXCEPTION
    
  WHEN others THEN NULL;
    
  END;
  
  IF TOTAL_ITENS IS NULL THEN
    RAISE EXCEPTION 'PG-20012 O oramento "%" precisa ter ao menos um item de oramento. %' , pNUMPED,VComplemento;
  END IF;
  
  IF round(TOTAL_ITENS,2) <> round(WK_VLRTOT,2) THEN
    cWK_VLRTOT := replace(to_char(WK_VLRTOT),',','.');
    cTOTAL_ITENS := replace(to_char(TOTAL_ITENS),',','.');
    RAISE EXCEPTION 'PG-20013 Soma do valor dos itens (%) no confere com o valor total do oramento (%). %' , cTOTAL_ITENS,cWK_VLRTOT,VComplemento;
  END IF;
  
  IF WK_APRCLI <> '1' THEN
    RAISE EXCEPTION 'PG-20014 O oramento no esta aprovado pelo cliente. %' , VComplemento;
  END IF;
  
  IF WK_FLGEST = 'C' THEN
    RAISE EXCEPTION 'PG-20015 O oramento esta cancelado. %' , VComplemento;
  END IF;
    
  IF (WK_APRCLI='1') AND     
     (WK_FLGEST<>'C') THEN
     
     UPDATE TT_ORC
        SET TIPENT='0',
            APROVA='A',
            CHVAPR=0
      WHERE CODFIL = pCODFIL
        AND NUMPED = pNUMPED
        AND TIPPED = pTIPPED;
        
     UPDATE TT_IOR
        SET TIPENT='0'
      WHERE CODFIL = pCODFIL
        AND NUMPED = pNUMPED
        AND TIPPED = pTIPPED;
  
  END IF;

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1210 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION QuantidadeEmTransitoKIT (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 1211 --*/
CREATE OR REPLACE FUNCTION QuantidadeEmTransitoKIT (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE)
RETURNS TT_IVE.QTDMOV%TYPE AS $$
DECLARE
pFILMAT ALIAS FOR $1 ;
pCODMAT ALIAS FOR $2 ;
pCODCOR ALIAS FOR $3 ;
pCODTAM ALIAS FOR $4 ;
pCODFIL ALIAS FOR $5 ;

-----------------------------------------------------------------------------------------------------------------------------------
   --Objetivos: 1 - Realizar a chamada da funo de nvel 1, "QuantidadeEmTransito" para headers de kit. 
-----------------------------------------------------------------------------------------------------------------------------------

   nQtdEmTransito                TT_IVE.QTDMOV%TYPE;
   cRetorno                      VARCHAR(254);
   nQtdIte                       TT_KIT.QTDITE%TYPE;
   cFilmat                       TT_GRA.FILMAT%TYPE;
   cCodmat                       TT_GRA.CODMAT%TYPE;
   nCodcor                       TT_GRA.CODCOR%TYPE;
   nCodtam                       TT_GRA.CODTAM%TYPE;
-- Incio da funo
BEGIN
   nQtdEmTransito := 0;

   -- MN - Essa funo  destinada para headers de kit, como o POS no vende headers, somente os itens, deve-se procurar um item de "referncia"
   -- para verificar quantas vendas o item de "referncia" teve e inferir a quantidade de vendas do header do kit.
   SELECT TrazItemReferenciaKit(pFILMAT, pCODMAT, pCODCOR, pCODTAM)
     INTO cRetorno
     FROM DUAL;

   IF COALESCE(cRetorno, 'X') <> 'X' THEN
      cFilmat := Split_Part(cRetorno, ';', 1);
      cCodmat := Split_Part(cRetorno, ';', 2);
      nCodcor := Split_Part_Number(cRetorno, ';', 3);
      nCodtam := Split_Part_Number(cRetorno, ';', 4);
      nQtdIte := Split_Part_Number(cRetorno, ';', 5);

      SELECT COALESCE(SUM(IVE.QTDMOV),0) 
        INTO nQtdEmTransito
        FROM TT_TRA TRA INNER JOIN TT_VEN VEN ON VEN.CODFIL = TRA.FILIVE 
                                             AND VEN.SEQUEN = TRA.SEQIVE
                        INNER JOIN TT_IVE IVE ON IVE.CODFIL = TRA.FILIVE 
                                             AND IVE.SEQUEN = TRA.SEQIVE 
                                             AND IVE.NUMITE = TRA.NUMIVE
       WHERE TRA.NUMICO IS NULL
         AND TRA.FILMAT = cFilmat
         AND TRA.CODMAT = cCodmat
         AND TRA.CODCOR = nCodcor
         AND TRA.CODTAM = nQtdIte
         AND VEN.FLGEST <> 'C'
         AND INSTR(COALESCE(pCodFil, VEN.FILCLI)||';', VEN.FILCLI||';') > 0
         AND VEN.CODCLI = LPAD('0', 6, ' ');
   END IF;

   RETURN COALESCE(nQtdEmTransito,0);

END;
$$ language 'plpgsql';




/*-- SEQ 1212 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SALDOGERAL (Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TD_MUL.CODTAB%TYPE) CASCADE;

/*-- SEQ 1213 --*/
CREATE OR REPLACE FUNCTION SALDOGERAL (Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TD_MUL.CODTAB%TYPE)
RETURNS Numeric AS $$
DECLARE
p_DatRef ALIAS FOR $1 ;
p_FilMat ALIAS FOR $2 ;
p_CodMat ALIAS FOR $3 ;
p_CodCor ALIAS FOR $4 ;
p_CodTam ALIAS FOR $5 ;
p_CodFil ALIAS FOR $6 ;
p_CodMul ALIAS FOR $7 ;
-- Objetivo:
-- 1) Calcular o saldo de estoque de um determinado produto na data especificada
-- 2) Opção de filtrar por apenas uma filial
-- 3) Opção de filtrar por apenas um subestoque
  n_Saldo Numeric;

-- Principal
begin
  SELECT SUM(SALDODAFILIAL(p_DatRef,p_FilMat,p_CodMat,p_CodCor,p_CodTam,DFIL.CODFIL,DMUL.CODTAB)) AS SALDO INTO n_Saldo
    FROM DUAL CROSS JOIN TD_FIL DFIL
              CROSS JOIN TD_MUL DMUL
   WHERE INSTR(COALESCE(p_CodFil, DFIL.CODFIL)||';', DFIL.CODFIL||';') > 0
     AND 1 = CASE WHEN p_CodMul IS NULL THEN 1
                  ELSE CASE WHEN p_CodMul = DMUL.CODTAB THEN 1 ELSE 0 END
             END;

  RETURN COALESCE(n_Saldo,0);
END;
$$ language 'plpgsql';


/*-- SEQ 1214 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SALDOGERAL (Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1215 --*/
CREATE OR REPLACE FUNCTION SALDOGERAL (Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN SALDOGERAL($1,$2,$3,$4,$5,$6,null);
END;
$$ language 'plpgsql';


/*-- SEQ 1216 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SALDOGERAL (Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE) CASCADE;

/*-- SEQ 1217 --*/
CREATE OR REPLACE FUNCTION SALDOGERAL (Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN SALDOGERAL($1,$2,$3,$4,$5,null,null);
END;
$$ language 'plpgsql';





/*-- SEQ 1218 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VinculaDevolucaoCompra (TT_VEN.CODFIL%TYPE,TT_VEN.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1219 --*/
CREATE OR REPLACE FUNCTION VinculaDevolucaoCompra (TT_VEN.CODFIL%TYPE,TT_VEN.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;

-- Objetivos:
-- 1. Vincular devoluo [TT_IVE] com a compra original [TT_ICO] enquanto o Checkout ainda no faz isso.

-- Declarao de variveis e cursores
v_FILCLI                TT_VEN.FILCLI%TYPE;
v_CODCLI                TT_VEN.CODCLI%TYPE;
v_VLRLIQ                TT_VEN.VLRLIQ%TYPE;
v_TIPNAT                TD_NAT.TIPNAT%TYPE;
v_OBSERV                TT_VEN.OBSERV%TYPE;
v_OBSFIS                TT_VEN.OBSFIS%TYPE;
v_OBSERV_BUSCA          TT_VEN.OBSFIS%TYPE;
i_QtdVinculosCompra     INTEGER;
i_BuscaCompra           INTEGER;

-- Dados extrados da observao
v_COM_CODFIL            TT_COM.CODFIL%TYPE;
v_COM_SEQUEN            TT_COM.SEQUEN%TYPE;
v_COM_VLRLIQ            TT_COM.VLRLIQ%TYPE;

-- Extrao dos dados da compra da observao
c_NOTORI_OBS            VARCHAR(8);
c_DATORI_OBS            VARCHAR(10);
c_VLRORI_OBS            VARCHAR(15);

-- array [
n_Contador              Numeric(5);

v_Codfil_Item         CHAR(3)[];
v_Sequen_Item         CHAR(10)[];
v_Numite_Item         Numeric(5)[];
v_Qtdmov_Item         Numeric(12,4)[];
v_Filmat_Item         CHAR(3)[];
v_Codmat_Item         CHAR(5)[];
v_Codcor_Item         Numeric(5)[];
v_Codtam_Item         Numeric(5)[];
v_FilicoOri_Item      CHAR(3)[];
v_SeqicoOri_Item      CHAR(10)[];
v_NumicoOri_Item      Numeric(5)[];
-- ] array

-- cursores
CR_ItensDev CURSOR FOR
SELECT IVE.*
  FROM TT_IVE IVE
 WHERE IVE.CODFIL = pCODFIL
   AND IVE.SEQUEN = pSEQUEN
   AND IVE.SITKIT IN ('2','3')
   AND IVE.SITMOV <> 'C'
 ORDER BY IVE.NUMITE DESC;

    
  cr_ive record;
  
CR_Com CURSOR(pCrCom_Filcli TT_COM.FILFOR%TYPE,
           pCrCom_Codcli TT_COM.CODFOR%TYPE,
           pCrCom_Notori VARCHAR,
           pCrCom_Datori VARCHAR) IS
SELECT CODFIL, SEQUEN, VLRLIQ
  FROM (
SELECT CODFIL, SEQUEN, VLRLIQ
  FROM TT_COM
 WHERE FILFOR = pCrCom_Filcli
   AND CODFOR = pCrCom_Codcli
   AND NUMNOT = pCrCom_Notori
   AND DATCMP between TO_DATE(pCrCom_Datori,'DD/MM/YYYY')
                  and TO_DATE(pCrCom_Datori||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
   AND FLGEST <> 'D'
UNION
SELECT CODFIL, SEQUEN, VLRLIQ
  FROM TT_COM
 WHERE FILFOR = pCrCom_Filcli
   AND CODFOR = pCrCom_Codcli
   AND NUMNOT = pCrCom_Notori
   AND DATOPE between TO_DATE(pCrCom_Datori,'DD/MM/YYYY')
                  and TO_DATE(pCrCom_Datori||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
   AND FLGEST <> 'D'
 ) TAB
 ORDER BY SEQUEN DESC;

CR_ItensCom CURSOR(pCr_Codfil TT_COM.CODFIL%TYPE,
           pCr_Sequen TT_COM.SEQUEN%TYPE) IS
SELECT ICO.*
  FROM TT_ICO ICO
 WHERE ICO.CODFIL = pCr_Codfil
   AND ICO.SEQUEN = pCr_Sequen
   AND ICO.SITMOV <> 'C'
 ORDER BY ICO.NUMITE DESC;

    
  cr_ico record;
  
-- Incio da funo
BEGIN

  -- Verifica a natureza da venda.
    SELECT VEN.FILCLI, VEN.CODCLI, VEN.VLRLIQ, NAT.TIPNAT, VEN.OBSERV, VEN.OBSFIS
    INTO v_FILCLI, v_CODCLI, v_VLRLIQ, v_TIPNAT, v_OBSERV, v_OBSFIS
    FROM TT_VEN VEN INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
   WHERE VEN.CODFIL = pCODFIL
     AND VEN.SEQUEN = pSEQUEN;
  
  IF v_TIPNAT <> 'M' THEN
    RETURN 'Documento emitido no  devoluo de compra.';
  END IF;

  -- Verificar se algum item da venda j est vinculado.
  SELECT COUNT(*)
    INTO i_QtdVinculosCompra
    FROM TT_IVE
   WHERE CODFIL = pCODFIL
     AND SEQUEN = pSEQUEN
     AND FILICOORI IS NOT NULL;

  IF i_QtdVinculosCompra > 0 THEN
    RETURN 'Devoluo j vinculada.';
  END IF;

  -- Descobre se vnculo est em OBSFIS ou OBSERV
  IF INSTR(v_OBSFIS,'Nota Origem',1) > 0 THEN
    v_OBSERV_BUSCA := UPPER(rtf2txt(v_OBSFIS));
  ELSE
    IF INSTR(v_OBSERV,'Nota Origem',1) > 0 THEN
      v_OBSERV_BUSCA := UPPER(rtf2txt(v_OBSERV));
    ELSE
      RETURN 'Devoluo no possui vnculo com a compra na observao.';
    END IF;
  END IF;

  -- Cria lista de itens de venda ordenada sem vnculo com itens de compra
  n_Contador := 0;
  OPEN CR_ItensDev;
  LOOP
      FETCH CR_ItensDev INTO cr_ive;
      EXIT WHEN NOT FOUND;

      -- array
      n_Contador := n_Contador + 1;
            
      if n_Contador = 1 then
          select ARRAY[cr_ive.CODFIL]  into v_Codfil_Item;
          select ARRAY[cr_ive.SEQUEN]  into v_Sequen_Item;
          select ARRAY[cr_ive.NUMITE]  into v_Numite_Item;
          select ARRAY[cr_ive.QTDMOV]  into v_Qtdmov_Item;
          select ARRAY[cr_ive.FILMAT]  into v_Filmat_Item;
          select ARRAY[cr_ive.CODMAT]  into v_Codmat_Item;
          select ARRAY[cr_ive.CODCOR]  into v_Codcor_Item;
          select ARRAY[cr_ive.CODTAM]  into v_Codtam_Item;
          select ARRAY[NULL]           into v_FilicoOri_Item;
          select ARRAY[NULL]           into v_SeqicoOri_Item;
          select ARRAY[NULL]           into v_NumicoOri_Item;
      else
          select array_append(v_Codfil_Item,    cr_ive.CODFIL)   into v_Codfil_Item;
          select array_append(v_Sequen_Item,    cr_ive.SEQUEN)   into v_Sequen_Item;
          select array_append(v_Numite_Item,    cr_ive.NUMITE)   into v_Numite_Item;
          select array_append(v_Qtdmov_Item,    cr_ive.QTDMOV)   into v_Qtdmov_Item;
          select array_append(v_Filmat_Item,    cr_ive.FILMAT)   into v_Filmat_Item;
          select array_append(v_Codmat_Item,    cr_ive.CODMAT)   into v_Codmat_Item;
          select array_append(v_Codcor_Item,    cr_ive.CODCOR)   into v_Codcor_Item;
          select array_append(v_Codtam_Item,    cr_ive.CODTAM)   into v_Codtam_Item;
          select array_append(v_FilicoOri_Item, NULL         )   into v_FilicoOri_Item;
          select array_append(v_SeqicoOri_Item, NULL         )   into v_SeqicoOri_Item;
          select array_append(v_NumicoOri_Item, NULL         )   into v_NumicoOri_Item;
      end if;
            -- array

  END LOOP;
  CLOSE CR_ItensDev;

  -- Analisa observao, jogando cada texto da compra em uma linha do array.
  i_BuscaCompra := 1;
  WHILE i_BuscaCompra > 0
  LOOP

    IF INSTR(v_OBSERV_BUSCA,'NOTA ORIGEM: ',i_BuscaCompra) > 0 THEN
      c_NOTORI_OBS := LPAD(TRIM(SUBSTR(v_OBSERV_BUSCA,INSTR(v_OBSERV_BUSCA,'NOTA ORIGEM: ',i_BuscaCompra)+13,INSTR(v_OBSERV_BUSCA,'DATA: ',i_BuscaCompra)-INSTR(v_OBSERV_BUSCA,'NOTA ORIGEM: ',i_BuscaCompra)-14)), 8, ' ');
      c_DATORI_OBS := SUBSTR(v_OBSERV_BUSCA,INSTR(v_OBSERV_BUSCA,'DATA: ',i_BuscaCompra)+6,INSTR(v_OBSERV_BUSCA,'VALOR: ',i_BuscaCompra)-INSTR(v_OBSERV_BUSCA,'DATA: ',i_BuscaCompra)-7);
      c_VLRORI_OBS := SUBSTR(v_OBSERV_BUSCA,INSTR(v_OBSERV_BUSCA,'VALOR: ',i_BuscaCompra)+7,INSTR(v_OBSERV_BUSCA,',',INSTR(v_OBSERV_BUSCA,'VALOR: ',i_BuscaCompra)+7,i_BuscaCompra)+5-INSTR(v_OBSERV_BUSCA,'VALOR: ',i_BuscaCompra)-8);
    ELSE
      c_NOTORI_OBS := LPAD(TRIM(SUBSTR(v_OBSERV_BUSCA,INSTR(v_OBSERV_BUSCA,'NOTA ORIGEM:',i_BuscaCompra)+12,INSTR(v_OBSERV_BUSCA,'DATA:',i_BuscaCompra)-INSTR(v_OBSERV_BUSCA,'NOTA ORIGEM:',i_BuscaCompra)-13)), 8, ' ');
      c_DATORI_OBS := SUBSTR(v_OBSERV_BUSCA,INSTR(v_OBSERV_BUSCA,'DATA:',i_BuscaCompra)+5,INSTR(v_OBSERV_BUSCA,'VALOR:',i_BuscaCompra)-INSTR(v_OBSERV_BUSCA,'DATA:',i_BuscaCompra)-6);
      c_VLRORI_OBS := SUBSTR(v_OBSERV_BUSCA,INSTR(v_OBSERV_BUSCA,'VALOR:',i_BuscaCompra)+6,INSTR(v_OBSERV_BUSCA,',',INSTR(v_OBSERV_BUSCA,'VALOR:',i_BuscaCompra)+6,i_BuscaCompra)+4-INSTR(v_OBSERV_BUSCA,'VALOR:',i_BuscaCompra)-7);
    END IF;

    -- Pega compra mais recente do fornecedor com o nmero e data da observao
    v_COM_CODFIL := NULL;
	OPEN CR_Com(v_FILCLI, v_CODCLI, c_NOTORI_OBS, c_DATORI_OBS);
      LOOP
        FETCH CR_Com INTO v_COM_CODFIL, v_COM_SEQUEN, v_COM_VLRLIQ;
        EXIT WHEN NOT FOUND OR v_COM_CODFIL IS NOT NULL;
      END LOOP;
    CLOSE CR_Com;

    -- Pega os itens da compra
	OPEN CR_ItensCom(v_COM_CODFIL, v_COM_SEQUEN);
      LOOP
        FETCH CR_ItensCom INTO cr_ico;
        EXIT WHEN NOT FOUND;

                
        for n_Contador in array_lower(v_Codfil_Item,1) .. array_upper(v_Codfil_Item,1) loop

           IF  v_FilicoOri_Item[n_Contador] IS NULL
           AND v_Filmat_Item[n_Contador] = cr_ico.FILMAT
           AND v_Codmat_Item[n_Contador] = cr_ico.CODMAT
           AND v_Codcor_Item[n_Contador] = cr_ico.CODCOR
           AND v_Codtam_Item[n_Contador] = cr_ico.CODTAM THEN

             v_FilicoOri_Item[n_Contador] := cr_ico.CODFIL;
             v_SeqicoOri_Item[n_Contador] := cr_ico.SEQUEN;
             v_NumicoOri_Item[n_Contador] := cr_ico.NUMITE;

           END IF;

        end loop;
        
      END LOOP;
    CLOSE CR_ItensCom;

    i_BuscaCompra := INSTR(v_OBSERV_BUSCA,'NOTA ORIGEM:',i_BuscaCompra+1);
  END LOOP;

  -- Grava os vnculos encontrados
  
  
  for n_Contador in array_lower(v_Codfil_Item,1) .. array_upper(v_Codfil_Item,1) loop

    IF  v_FilicoOri_Item[n_Contador] IS NOT NULL THEN

       UPDATE TT_IVE
          SET FILICOORI = v_FilicoOri_Item[n_Contador],
              SEQICOORI = v_SeqicoOri_Item[n_Contador],
              NUMICOORI = v_NumicoOri_Item[n_Contador],
              DUMMY = '%'
        WHERE CODFIL = v_Codfil_Item[n_Contador]
          AND SEQUEN = v_Sequen_Item[n_Contador]
          AND NUMITE = v_Numite_Item[n_Contador]
          AND FILICOORI IS NULL;

    END IF;

  end loop;
  
  RETURN 'OK';

END;
$$ language 'plpgsql';



/*-- SEQ 1220 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ProcessaVinculaDevolucaoCompra () CASCADE;

/*-- SEQ 1221 --*/
CREATE OR REPLACE FUNCTION ProcessaVinculaDevolucaoCompra ()
RETURNS VARCHAR AS $$
DECLARE

-- Objetivos:
-- 1. Processar vnculos de compra do passado.

-- Declarao de variveis e cursores
c_Resultado             VARCHAR(200);

-- Controle de lock
cTEMP                   TT_FUN.NOMFUN%TYPE;

-- cursores
CR_Vendas CURSOR FOR
select ven.codfil,
       ven.sequen
  from tt_ven ven inner join td_nat nat on nat.codtab = ven.codnat
 where nat.tipnat = 'M'
   and ven.flgest <> 'C'
   and ven.datfis >= add_day(Agora(),-365)
   and (select count(*)
          from tt_ive ive
         where ive.codfil = ven.codfil
           and ive.sequen = ven.sequen
           and ive.filicoori is not null) = 0;

    
  cr_ven record;
  
-- Incio da funo
BEGIN
  -- Garantia de exclusividade no processo seguinte
    SELECT NOMFUN INTO cTEMP
    FROM TT_FUN
   WHERE NOMFUN = 'FILICOORI'
     FOR UPDATE;
  
  OPEN CR_Vendas;
  LOOP
      FETCH CR_Vendas INTO cr_ven;
      EXIT WHEN NOT FOUND;
      
      c_Resultado := VinculaDevolucaoCompra(cr_ven.CODFIL, cr_ven.SEQUEN);
      
            
      
  END LOOP;
  CLOSE CR_Vendas;      

  RETURN 'OK';

END;
$$ language 'plpgsql';




/*-- SEQ 1222 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ZeraLimiteDeCreditoVencido () CASCADE;

/*-- SEQ 1223 --*/
CREATE OR REPLACE FUNCTION ZeraLimiteDeCreditoVencido ()
RETURNS VARCHAR AS $$
DECLARE


-- 1. Zerar o limite de crédito quando a validade do limite estiver vencida, ignorando se o cliente está ativo ou não
-- Declaração de variáveis e cursores
   cMANUT                  TT_IDF.MANUT%TYPE;
   v_Complemento           CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');
   cFILCLI                 TT_CLI.FILCLI%TYPE;
   cCODCLI                 TT_CLI.CODCLI%TYPE;
BEGIN
   SELECT MANUT INTO cMANUT
     FROM TT_IDF;

   IF cMANUT = 'T' THEN
      RAISE EXCEPTION 'PG-20010 Base em manutencao %' , v_Complemento;
   END IF;

   UPDATE TT_CLI
      SET VALOR1 = 0
    WHERE VALLIM < TRUNC(Agora())
      AND COALESCE(VALOR1, 0) <> 0;

   RETURN 'OK';

END;
$$ language 'plpgsql';



/*-- SEQ 1224 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_ZeraLimiteDeCreditoVencido (TT_JOB.CODUID%TYPE) CASCADE;

/*-- SEQ 1225 --*/
CREATE OR REPLACE FUNCTION Job_ZeraLimiteDeCreditoVencido (TT_JOB.CODUID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODUID ALIAS FOR $1 ;
-- Objetivos:
-- 1. Executar função zeralimitedecreditovencido.
-- 2. Registrar o resultado na TT_JOB.
-- Declaração de variáveis e cursores
   vNOME                         TT_JOB.NOMJOB%TYPE;
   vDESC                         TT_JOB.DESJOB%TYPE;
   dummy                         CHAR(2);
BEGIN
   vNOME := 'Job_ZeraLimiteDeCreditoVencido';

   vDESC := 'Zera limite de crédito se estiver vencido';
   BEGIN
      DUMMY := ZeraLimiteDeCreditoVencido();
      DUMMY := RegistraJob(vNOME, vDESC, NULL, pCODUID);
   EXCEPTION
      WHEN OTHERS THEN DUMMY := RegistraJob(vNOME, vDESC, SQLERRM, pCODUID);
   END;
  RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 1226 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_ZeraLimiteDeCreditoVencido () CASCADE;

/*-- SEQ 1227 --*/
CREATE OR REPLACE FUNCTION Job_ZeraLimiteDeCreditoVencido () 
RETURNS VARCHAR AS $$
BEGIN
RETURN Job_ZeraLimiteDeCreditoVencido(NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1228 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalcCodBarrasCK4G (VARCHAR,TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 1229 --*/
CREATE OR REPLACE FUNCTION CalcCodBarrasCK4G (VARCHAR,TD_FIL.CODFIL%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pDigitos ALIAS FOR $1 ;
pFilial ALIAS FOR $2 ;

-- Objetivos:
-- 1. Calcular o cdigo de barras para o Checkout 4G

-- Declarao de variveis e cursores
   cResultado                    VARCHAR(24);
   cChaveEmpresa                 VARCHAR(4);
   cParte1                       VARCHAR(11);
   cParte2                       VARCHAR(11);
   iMetade                       INTEGER;

-- Incio da funo
BEGIN
   -- A chave da empresa so os quatro dgitos, a partir do quarto, do nmero de srie da filial
   SELECT (SELECT TRIM(SUBSTR(NUMSER,4,4))
             FROM TD_FIL
            WHERE CODFIL = pFilial)
     INTO cChaveEmpresa
     FROM DUAL;

   -- Pega a posio da metade dos dgitos
   iMetade := TRUNC(LENGTH(pDigitos)/2);

   -- Divide os dgitos em duas partes
   cParte1 := SUBSTR(pDigitos,1, iMetade);
   cParte2 := SUBSTR(pDigitos, iMetade+1, LENGTH(pDigitos) - iMetade);

   -- O resultado  formado pelos dgitos originais mais o DV de cada uma das partes, juntando-se a cada uma a chave da empresa
   cResultado := pDigitos ||
                 Aux_CalculaDACMod11(cParte1||cChaveEmpresa,'10;11;','0;0;','F') ||
                 Aux_CalculaDACMod11(cParte2||cChaveEmpresa,'10;11;','0;0;','F');

   RETURN cResultado;

END;
$$ language 'plpgsql';




/*-- SEQ 1230 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DigitoDuploBanrisul (VARCHAR,Numeric) CASCADE;

/*-- SEQ 1231 --*/
CREATE OR REPLACE FUNCTION DigitoDuploBanrisul (VARCHAR,Numeric)
RETURNS VARCHAR AS $$
DECLARE
pBase ALIAS FOR $1 ;
pPeso ALIAS FOR $2 ;

-- Objetivos:
-- 1. Calcular dgito verificador (DAC) mdulo 11 do Banrisul.
--    O clculo  mais complexo do que em outros bancos.

-- Declarao de variveis e cursores
   cResultado                    VARCHAR(2);

   bDigitoValido                 BOOLEAN;

   cBaseModulo10                 VARCHAR(100);
   cDigitoModulo10               VARCHAR(1);
   cBaseModulo11                 VARCHAR(100);
   cDigitoModulo11               VARCHAR(1);

   iAuxDigito                    Numeric(2);
   iLoop                         INTEGER;

-- Incio da funo
BEGIN

   cBaseModulo10   := pBase;
   cDigitoModulo10 := Aux_CalculaDAC(cBaseModulo10);
   cBaseModulo11   := cBaseModulo10||cDigitoModulo10;
   cDigitoModulo11 := ' ';
   iLoop           := 0;

   bDigitoValido   := FALSE;
   LOOP
      IF bDigitoValido OR iLoop > 10 THEN
         EXIT;
      END IF;

      -- No aceita resto = 1
      -- 11 - 1 = 10
      -- Validar 10,  validar o resto 1
      IF Aux_CalculaDACMod11(cBaseModulo11,'10;','A;','F',pPeso) = 'A' THEN
         iAuxDigito       := TO_NUMBER(cDigitoModulo10)+1;
         IF iAuxDigito > 9 THEN
            iAuxDigito := 0;
         END IF;
         cDigitoModulo10  := TO_CHAR(iAuxDigito);
         cBaseModulo11    := cBaseModulo10||cDigitoModulo10;
      ELSE
         cDigitoModulo11  := Aux_CalculaDACMod11(cBaseModulo11,'11;','0;','F',pPeso);
         bDigitoValido := TRUE;
      END IF;

      iLoop := iLoop + 1;
   END LOOP;

   cResultado := cDigitoModulo10||cDigitoModulo11;

   RETURN cResultado;

END;
$$ language 'plpgsql';




-- Autor: Luciano Chiqueti 
-- Cliente(s): JRA
-- Finalidade(s):
-- 1) Retornar a estrutura uma conta
/*-- SEQ 1232 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION EstruturaDeContasNivel (TT_CTA.CODFIL%TYPE,TT_CTA.SEQUEN%TYPE,Numeric) CASCADE;

/*-- SEQ 1233 --*/
CREATE OR REPLACE FUNCTION EstruturaDeContasNivel (TT_CTA.CODFIL%TYPE,TT_CTA.SEQUEN%TYPE,Numeric)
RETURNS VARCHAR AS $$
DECLARE
pCodFil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
pNivel ALIAS FOR $3 ;
  cTITECT1 TT_ECT.TITECT%TYPE;
  cTITECT2 TT_ECT.TITECT%TYPE;
  cTITECT3 TT_ECT.TITECT%TYPE;
  cTITECT4 TT_ECT.TITECT%TYPE;
  
  cCODFIL  TT_ECT.CODFIL%TYPE;
  cSEQUEN  TT_ECT.SEQUEN%TYPE;
  cCODFIL1 TT_ECT.CODFIL%TYPE;
  cSEQUEN1 TT_ECT.SEQUEN%TYPE;  
  cCODFIL2 TT_ECT.CODFIL%TYPE;
  cSEQUEN2 TT_ECT.SEQUEN%TYPE;
  cCODFIL3 TT_ECT.CODFIL%TYPE;
  cSEQUEN3 TT_ECT.SEQUEN%TYPE;
  cCODFIL4 TT_ECT.CODFIL%TYPE;
  cSEQUEN4 TT_ECT.SEQUEN%TYPE;
BEGIN
  SELECT FILECT,SEQECT 
    INTO cCODFIL1,cSEQUEN1
    FROM TT_CTA
   WHERE CODFIL = pCODFIL
     AND SEQUEN = pSEQUEN;
	 
  SELECT FILECT,SEQECT,TITECT
    INTO cCODFIL2,cSEQUEN2, cTITECT1
    FROM TT_ECT
   WHERE CODFIL = cCODFIL1
     AND SEQUEN = cSEQUEN1;

  SELECT FILECT,SEQECT,TITECT
    INTO cCODFIL3,cSEQUEN3, cTITECT2
    FROM TT_ECT
   WHERE CODFIL = cCODFIL2
     AND SEQUEN = cSEQUEN2;	 
   
  SELECT FILECT,SEQECT,TITECT
    INTO cCODFIL4,cSEQUEN4, cTITECT3
    FROM TT_ECT
   WHERE CODFIL = cCODFIL3
     AND SEQUEN = cSEQUEN3;  
  
  SELECT TITECT
    INTO cTITECT4
    FROM TT_ECT
   WHERE CODFIL = cCODFIL4
     AND SEQUEN = cSEQUEN4;

   IF pNivel = 1 THEN
      RETURN cTITECT1;
   END IF;
     
   IF pNivel = 2 THEN
      RETURN cTITECT2;
   END IF;

   IF pNivel = 3 THEN
      RETURN cTITECT3;
   END IF;         
          
   IF pNivel = 4 THEN
      RETURN cTITECT4;
   END IF;

END;
$$ language 'plpgsql';




/*-- SEQ 1234 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AssinaTabela (VARCHAR,VARCHAR,tt_uid.coduid%type,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1235 --*/
CREATE OR REPLACE FUNCTION AssinaTabela (VARCHAR,VARCHAR,tt_uid.coduid%type,VARCHAR,VARCHAR)
RETURNS TT_UID.ASSINA%TYPE AS $$
DECLARE
pTabela ALIAS FOR $1 ;
pTextoConcatenado ALIAS FOR $2 ;
pCoduidOld ALIAS FOR $3 ;
pTextoConcatenadoOld ALIAS FOR $4 ;
pAssinaOld ALIAS FOR $5 ;
 -- Douglas - 79829 
    
    rTT_UID     RECORD;  
    
    
    rTT_UID_OLD     RECORD;  
    
  
  vASSINA TT_UID.ASSINA%TYPE;
  vCODUID TT_UID.CODUID%TYPE;
  bValidou_assinatura_anterior boolean;
BEGIN
    SELECT GetCoduidAtual() INTO vCODUID
	FROM DUAL;	
	
	     
    SELECT TT_UID.*
      INTO rTT_UID
      FROM TT_UID
     WHERE CODUID = vCODUID;
   

  vASSINA := NULL;
  
  IF rTT_UID.CODUID IS NOT NULL THEN

    bValidou_assinatura_anterior := true;

    IF pTextoConcatenadoOld IS NOT NULL THEN -- RFMP Verifica se  UPDATE
    
           
        SELECT TT_UID.*
          INTO rTT_UID_OLD
          FROM TT_UID
         WHERE CODUID = pCoduidOld;
       
	  
      IF pAssinaOld <> GetAssinaTab(pTabela, 
                            pCoduidOld, 
                            ConcatenaUID(rTT_UID_OLD.CODUID,
                                         rTT_UID_OLD.USEROS,
                                         rTT_UID_OLD.DATOPE,
                                         rTT_UID_OLD.NOMMAQ,
                                         rTT_UID_OLD.VERBAS,
                                         rTT_UID_OLD.VERSIS,
                                         rTT_UID_OLD.NOMSIS,
                                         rTT_UID_OLD.SESSION_ID),
                            rTT_UID_OLD.ASSINA,             
                            pTextoConcatenadoOld) 
      THEN
        bValidou_assinatura_anterior := false;
      END IF;
    END IF;      

    IF bValidou_assinatura_anterior THEN  
      vASSINA := GetAssinaTab(pTabela, 
                            rTT_UID.CODUID, 
                            ConcatenaUID(rTT_UID.CODUID,
                                         rTT_UID.USEROS,
                                         rTT_UID.DATOPE,
                                         rTT_UID.NOMMAQ,
                                         rTT_UID.VERBAS,
                                         rTT_UID.VERSIS,
                                         rTT_UID.NOMSIS,
                                         rTT_UID.SESSION_ID),
                            rTT_UID.ASSINA,             
                            pTextoConcatenado); 
    END IF;    
  END IF;      
  
  IF vASSINA IS NULL THEN 
	vASSINA := MD5(Dat2ChrAssina(Agora()));
  END IF;  
  RETURN vASSINA;  
END;
$$ language 'plpgsql';


/*-- SEQ 1236 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AssinaTabela (VARCHAR,VARCHAR,tt_uid.coduid%type,VARCHAR) CASCADE;

/*-- SEQ 1237 --*/
CREATE OR REPLACE FUNCTION AssinaTabela (VARCHAR,
                               VARCHAR,
                               tt_uid.coduid%type,
                               VARCHAR) 
RETURNS TT_UID.ASSINA%TYPE AS $$
BEGIN
RETURN AssinaTabela($1,$2,$3,$4,null);
END;
$$ language 'plpgsql';


/*-- SEQ 1238 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AssinaTabela (VARCHAR,VARCHAR,tt_uid.coduid%type) CASCADE;

/*-- SEQ 1239 --*/
CREATE OR REPLACE FUNCTION AssinaTabela (VARCHAR,
                               VARCHAR,
                               tt_uid.coduid%type) 
RETURNS TT_UID.ASSINA%TYPE AS $$
BEGIN
RETURN AssinaTabela($1,$2,$3,null,null);
END;
$$ language 'plpgsql';


/*-- SEQ 1240 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AssinaTabela (VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1241 --*/
CREATE OR REPLACE FUNCTION AssinaTabela (VARCHAR,
                               VARCHAR) 
RETURNS TT_UID.ASSINA%TYPE AS $$
BEGIN
RETURN AssinaTabela($1,$2,null,null,null);
END;
$$ language 'plpgsql';	  


/*-- SEQ 1242 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalculaQTDPendente (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE,TT_IVE.QTDMOV%TYPE) CASCADE;

/*-- SEQ 1243 --*/
CREATE OR REPLACE FUNCTION CalculaQTDPendente (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE,TT_IVE.QTDMOV%TYPE)
RETURNS Numeric AS $$
DECLARE
p_CodFil ALIAS FOR $1 ;
p_Sequen ALIAS FOR $2 ;
p_NumIte ALIAS FOR $3 ;
p_QtdMov ALIAS FOR $4 ;
   QTDENT Numeric;    -- Quantidade entregue
   VINCUL CHAR(1); -- Indica se e uma venda com vinculo
   vESTPEN TT_IVE.ESTPEN%TYPE; -- Estorno da quantidade pendente. RFMP 75399 

-- Objetivo:
-- 1) Calcular a quantidade pendente para as notas com vinculo

begin

   -- verificar se e uma venda com vinculo
   SELECT CASE WHEN IVE.FILORI IS NOT NULL 
                 OR VEN.FLGEST = 'C'
                 OR IVE.SITMOV = 'C'
                 OR COALESCE( CFG.IGNORA_VINCULO, TO_DATE('01/01/1980','DD/MM/YYYY') ) > VEN.DATHOR
               THEN 'F' 
          ELSE COALESCE(VEN.VINCUL,'F')          
          END,
          IVE.ESTPEN 
     INTO VINCUL, vESTPEN
     FROM TT_CFG CFG,
          TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL
                                          AND IVE.SEQUEN = VEN.SEQUEN
    WHERE IVE.CODFIL = p_CodFil
      AND IVE.SEQUEN = p_Sequen
      AND IVE.NUMITE = p_Numite;

   IF VINCUL = 'T' THEN
      SELECT SUM( ABS(QTDMOV) - ABS(COALESCE(QTDDEV,0)) ) into QTDENT
      FROM (SELECT IVE.QTDMOV,
                   (SELECT sum(DEV.QTDMOV)
                    FROM TT_IVE DEV 
                    WHERE DEV.FILORI = IVE.CODFIL 
                      AND DEV.NUMORI = IVE.SEQUEN 
	  	              AND DEV.ITEORI = IVE.NUMITE 
                      --AND DEV.DEVVIN = 'F'
                      AND DEV.SITMOV <> 'C'
                      AND DEV.LANEST IN ('R','C')) AS QTDDEV
            FROM TT_IVE IVE 
            WHERE IVE.FILORI = p_CodFil
              AND IVE.NUMORI = p_Sequen
              AND IVE.ITEORI = p_NumIte
              AND IVE.SITMOV <> 'C'
              AND IVE.LANEST IN ('R','C')) INT;
      RETURN p_QtdMov - COALESCE(QTDENT,0) + COALESCE(vESTPEN,0);
   ELSE
      RETURN Null;
   END IF;
END;
$$ language 'plpgsql';




/*-- SEQ 1244 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CompensaChequesConciliados (TT_CHR.FILDEP%TYPE,TT_CHR.SEQDEP%TYPE,TT_CHR.PORTAD%TYPE,TT_CHR.TIPCOB%TYPE) CASCADE;

/*-- SEQ 1245 --*/
CREATE OR REPLACE FUNCTION CompensaChequesConciliados (TT_CHR.FILDEP%TYPE,TT_CHR.SEQDEP%TYPE,TT_CHR.PORTAD%TYPE,TT_CHR.TIPCOB%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILDEP ALIAS FOR $1 ;
pSEQDEP ALIAS FOR $2 ;
pPORTAD ALIAS FOR $3 ;
pTIPCOB ALIAS FOR $4 ;
                                            
-- Objetivo: Colocar como compensados os cheques conciliados

WK_MAXSEQ TT_VEN.SEQUEN%TYPE;
WK_FATURA Numeric;

-- Principal
BEGIN
 
  UPDATE TT_CHR
     SET FLGEST='C',
         PORTAD=pPORTAD,
         TIPCOB=pTIPCOB,
         PAGAME=AGORA(),
         ATU_EM = AGORA()
   WHERE FLGEST IN ('A','B','I','U','D','G','P')
     AND FILDEP=pFILDEP
     AND SEQDEP=pSEQDEP;

  RETURN 'OK';
  
END;
$$ language 'plpgsql';




/*-- SEQ 1246 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CheckCGC (VARCHAR) CASCADE;

/*-- SEQ 1247 --*/
CREATE OR REPLACE FUNCTION CheckCGC (VARCHAR)
RETURNS INTEGER AS $$
DECLARE
p_CGC ALIAS FOR $1 ;
  wk_DF1    INTEGER;
  wk_Resto  INTEGER;
  wk_PriDig INTEGER;
  wk_SegDig INTEGER;
  wk_Dig1   INTEGER;
  wk_Dig2   INTEGER;
/*  
  retornos:  1 - OK
             0 - CNPJ incorreto
            -1 - (formato invalido)
*/
BEGIN
  wk_DF1 := -1;

  IF LENGTH(LTRIM(RTRIM(p_CGC))) = 14 THEN
     wk_DF1 := AUX_CGCCalculo(p_CGC, 5, 0);
  END IF;

  IF wk_DF1 <> -1 THEN
    wk_Resto  := MOD(wk_DF1,11);
    IF wk_Resto < 2 THEN
      wk_PriDig := 0;
    ELSE
      wk_PriDig := 11 - wk_Resto;
    END IF;

    wk_DF1 := -1;
    wk_DF1 := AUX_CGCCalculo(p_CGC, 6, 0);
    IF wk_DF1 <> -1 THEN
      wk_DF1 := wk_DF1 + (wk_PriDig * 2);

      wk_Resto := MOD(wk_DF1,11);
      IF wk_Resto < 2 THEN
        wk_SegDig := 0;
      ELSE
        wk_SegDig := 11 - wk_Resto;
      END IF;
        wk_Dig1 := CAST(SUBSTR(LTRIM(RTRIM(p_CGC)),13,1) AS INTEGER);
        wk_Dig2 := CAST(SUBSTR(LTRIM(RTRIM(p_CGC)),14,1) AS INTEGER);

        IF (wk_PriDig <> wk_Dig1) OR (wk_SegDig <> wk_Dig2) THEN
          RETURN 0;
        ELSE
          RETURN 1;
        END IF;
    ELSE
      RETURN -1;
    END IF;
  ELSE
    RETURN - 1;
  END IF;
END;
$$ language 'plpgsql';




/*-- SEQ 1248 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CheckCPF (VARCHAR) CASCADE;

/*-- SEQ 1249 --*/
CREATE OR REPLACE FUNCTION CheckCPF (VARCHAR)
RETURNS INTEGER AS $$
DECLARE
p_CPF ALIAS FOR $1 ;
  wk_DF1    INTEGER;
  wk_Resto  INTEGER;
  wk_PriDig INTEGER;
  wk_SegDig INTEGER;
  wk_Dig1   INTEGER;
  wk_Dig2   INTEGER;
/*  
  retornos:  1 - OK
             0 - CPF incorreto
            -1 - (formato invalido)
*/
BEGIN

  wk_DF1 := -1;
  IF LENGTH(LTRIM(RTRIM(p_CPF))) = 11 THEN
     wk_DF1 := AUX_CPFCalculo(p_CPF, 10, 0);
  END IF;
  
  IF wk_DF1 <> -1 THEN
    wk_Resto  := MOD(wk_DF1,11);
    IF wk_Resto < 2 THEN
      wk_PriDig := 0;
    ELSE
      wk_PriDig := 11 - wk_Resto;
    END IF;

    wk_DF1 := -1;
    wk_DF1 := AUX_CPFCalculo(p_CPF, 11, 0);

    IF wk_DF1 <> -1 THEN
      wk_DF1 := wk_DF1 + (wk_PriDig * 2);

      wk_Resto := MOD(wk_DF1,11);
      IF wk_Resto < 2 THEN
        wk_SegDig := 0;
      ELSE
        wk_SegDig := 11 - wk_Resto;
      END IF;
        wk_Dig1 := CAST(SUBSTR(LTRIM(RTRIM(p_CPF)),10,1) AS INTEGER);
        wk_Dig2 := CAST(SUBSTR(LTRIM(RTRIM(p_CPF)),11,1) AS INTEGER);

        IF (wk_PriDig <> wk_Dig1) OR (wk_SegDig <> wk_Dig2) THEN
          RETURN 0;
        ELSE
          RETURN 1;
        END IF;
    ELSE
      RETURN -1;
    END IF;
  ELSE
    RETURN -1;
  END IF;
END;
$$ language 'plpgsql';




/*-- SEQ 1250 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalcPag (TD_MOE.CODTAB%TYPE,Numeric,Timestamp,Numeric,VARCHAR,VARCHAR,Numeric,VARCHAR,Timestamp,integer) CASCADE;

/*-- SEQ 1251 --*/
CREATE OR REPLACE FUNCTION CalcPag (TD_MOE.CODTAB%TYPE,Numeric,Timestamp,Numeric,VARCHAR,VARCHAR,Numeric,VARCHAR,Timestamp,integer)
RETURNS Numeric AS $$
DECLARE
CODMOE ALIAS FOR $1 ;
VLRLAN ALIAS FOR $2 ;
DATVEN ALIAS FOR $3 ;
VLTXJU ALIAS FOR $4 ;
INCOJU ALIAS FOR $5 ;
INTPJU ALIAS FOR $6 ;
VLTXMU ALIAS FOR $7 ;
INTPMU ALIAS FOR $8 ;
DATCAL ALIAS FOR $9 ;
ABANDONA ALIAS FOR $10 ;
-- Objetivo:
-- 1) Calcular o valor Numeric de uma prestacao considerando juros e multa
-- Obs.: sempre retorna o valor na moeda corrente no pais (0)
-- Parametros
-- CODMOE  : Codigo da moeda ref. valor do lancamento
-- VLRLAN  : Valor do lancamento
-- DATVEN  : Data de vencimento
-- VLTXJU  : Valor da taxa de juros
-- INCOJU  : Tipo correcao do juro (diaria, mensal, anual, moeda)
-- INTPJU  : Tipo de calculo dos juros
-- VLTXMU  : Valor da taxa de multa
-- INTPMU  : Tipo de multa (%/$)
-- DATCAL  : Data de pagamento
-- ABANDONA: Se deve (> 0) ou nao (= 0) interromper no caso de haver um erro no calculo

  JUROS    Numeric;
  VALOR    Numeric;
  RETORNO  Numeric;
  DIAVEN   Numeric (2);
  MESVEN   Numeric (2);
  ANOVEN   Numeric (4);
  DIACAL   Numeric (2);
  MESCAL   Numeric (2);
  ANOCAL   Numeric (4);
BEGIN
  JUROS   := 0;
  VALOR   := VLRLAN;
  RETORNO := 0;
  -- Obtem dia, mes e ano
  ANOVEN := TO_CHAR(DATVEN, 'YYYY' );
  MESVEN := TO_CHAR(DATVEN, 'MM' );
  DIAVEN := TO_CHAR(DATVEN, 'DD' );
  ANOCAL := TO_CHAR(DATCAL, 'YYYY' );
  MESCAL := TO_CHAR(DATCAL, 'MM' );
  DIACAL := TO_CHAR(DATCAL, 'DD' );

  -- Valor corrigido
  IF (DATVEN < DATCAL) AND (INTPMU =  '@' ) THEN
     VALOR := VALOR + VLTXMU;
  END IF;

  IF CODMOE <> 0 THEN
     VALOR := MtoM(CODMOE,0,DATCAL,VALOR);
  END IF;

  IF VALOR = 0 THEN
     IF CODMOE = 0 THEN
        RETURN 0;
     END IF;
     IF ABANDONA > 0 THEN
        RAISE EXCEPTION 'PG-20020 Nao existe cambio para a moeda % no dia % ' , CODMOE,DATCAL;
     ELSE
        RETURN RETORNO;
     END IF;
  END IF;

  -- Calcula Multas e Juros
  IF (DATVEN < DATCAL) THEN
     -- Multa por Percentual Corrigido
     IF INTPMU =  '#'  THEN
        VALOR := VALOR + (VALOR * VLTXMU) / 100;
     END IF;

     -- Juros por Moedas
     IF INCOJU IN ( '1' , '2' , '3' , '4' , '5' , '6' , '7' , '8' , '9' ) THEN
        JUROS := MtoM(0,INCOJU,DATVEN,VALOR);
        VALOR := 0;
        
        IF JUROS = 0 THEN
           IF ABANDONA > 0 THEN
              RAISE EXCEPTION 'PG-20021 Nao existe cambio para a moeda % no dia %' , INCOJU,DATVEN;
           ELSE
              RETURN RETORNO;
           END IF;
        END IF;
        
        JUROS := MtoM(INCOJU,0,DATCAL,JUROS);
        IF JUROS = 0 THEN
           IF ABANDONA > 0 THEN
              RAISE EXCEPTION 'PG-20022 Nao existe cambio para a moeda % no dia %' , INCOJU,DATCAL;
           ELSE
              RETURN RETORNO;
           END IF;
        END IF;
     ELSE
        -- Nao tem Juros
        IF VLTXJU = 0 THEN
           JUROS := 0;
        ELSE
           IF INCOJU =  'D'  THEN
              -- Juros diarios
              JUROS := Atraso(Trunc(DATCAL)-Trunc(DATVEN),INTPJU,VALOR,VLTXJU) - VALOR;
           ELSIF INCOJU =  'M'  THEN
              -- Juros Mensais
              JUROS := Atraso((12-MESVEN) + ((ANOCAL - (ANOVEN + 1)) * 12) +
                                      MESCAL + iif_Int(DIACAL>DIAVEN,1,0),INTPJU,VALOR,
                                      VLTXJU) - VALOR;
           ELSIF INCOJU =  'A'  THEN
              -- Juros Anuais
              JUROS := Atraso (1 + ANOCAL - ANOVEN +
                               iif_int(CAST(MESCAL AS CHARACTER)||CAST(DIACAL AS CHARACTER) >
                                       CAST(MESVEN AS CHARACTER)||CAST(DIAVEN AS CHARACTER),0,-1),
                                       INTPJU,VALOR,VLTXJU) - VALOR;
           END IF;
        END IF;
     END IF;
   
     -- Multa Valor Fixo
     IF (DATVEN < DATCAL) AND (INTPMU =  '$' ) THEN
        VALOR := VALOR + VLTXMU;
     END IF;
   
     -- Juros
     IF INTPMU =  '%'  THEN
        VALOR := VALOR + (VALOR * VLTXMU) / 100;
     END IF;
   
     IF JUROS < 0 THEN
        RETORNO := VALOR;
     ELSE
        RETORNO := VALOR + JUROS;
     END IF;
  END IF;

  IF DATVEN >= DATCAL THEN
     RETORNO := VALOR;
  END IF;

  RETURN RETORNO;
END;
$$ language 'plpgsql';


/*-- SEQ 1252 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalcPag (TD_MOE.CODTAB%TYPE,Numeric,Timestamp,Numeric,VARCHAR,VARCHAR,Numeric,VARCHAR,Timestamp) CASCADE;

/*-- SEQ 1253 --*/
CREATE OR REPLACE FUNCTION CalcPag (TD_MOE.CODTAB%TYPE,
                               Numeric,
                               Timestamp,
                               Numeric,
                               VARCHAR,
                               VARCHAR,
                               Numeric,
                               VARCHAR,
                               Timestamp) 
RETURNS Numeric AS $$
BEGIN
RETURN CalcPag($1,$2,$3,$4,$5,$6,$7,$8,$9,0);
END;
$$ language 'plpgsql';


/*-- SEQ 1254 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalcTransf (TT_FIN.DATOPE%TYPE,TT_FIN.VLRMOV%TYPE,TT_FIN.NUMDOC%TYPE,INTEGER) CASCADE;

/*-- SEQ 1255 --*/
CREATE OR REPLACE FUNCTION CalcTransf (TT_FIN.DATOPE%TYPE,TT_FIN.VLRMOV%TYPE,TT_FIN.NUMDOC%TYPE,INTEGER)
RETURNS VARCHAR AS $$
DECLARE
p_Data ALIAS FOR $1 ;
p_Valor ALIAS FOR $2 ;
p_Doc ALIAS FOR $3 ;
p_Modulo ALIAS FOR $4 ;
  wk_calc  Numeric;
  wk_calc1 Numeric;
  wk_calc2 Numeric;
  wk_calc3 Numeric;
  wk_calc4 Numeric;
  wk_dig   Numeric; 

BEGIN
  wk_calc1 := (CAST(TO_CHAR(p_Data,'HH24') AS INTEGER) * 9) +
	      (CAST(TO_CHAR(P_DATA,'MI'  ) AS INTEGER) * 8) +
	      (CAST(TO_CHAR(P_DATA,'SS'  ) AS INTEGER) * 7);

  wk_calc2 := (CAST(TO_CHAR(p_Data,'DD'  ) AS INTEGER) * 6) +
	      (CAST(TO_CHAR(p_Data,'MM'  ) AS INTEGER) * 5) +
	      (CAST(TO_CHAR(p_Data,'YY'  ) AS INTEGER) * 4);

  wk_calc3 := AUX_LE_DADO(TO_CHAR(ABS(p_Valor),'fm9999999990.00'),3);

  wk_calc4 := AUX_LE_DADO('3'||p_Doc,2);
  
  IF p_Modulo = 2 THEN
    wk_calc := TRUNC((wk_calc1 / CASE WHEN wk_calc2 = 0 THEN 3 ELSE wk_calc2 END *
    wk_calc4 / CASE WHEN wk_calc3 = 0 THEN 3 ELSE wk_calc3 END) * 10000);
  ELSE
    wk_calc := wk_calc1 + wk_calc2 + wk_calc3 + wk_calc4;
  END IF;

  wk_calc           :=  SQRT(wk_calc) + wk_calc;
  wk_calc           :=  TRUNC( mod( wk_Calc/10, 1 )* POWER(10,4) ) ;
  wk_dig            :=  Aux_Mod11( wk_calc ) ;  
  
  RETURN LPAD(TO_CHAR(wk_calc),4,'0')||wk_dig;

END;
$$ language 'plpgsql';




/*-- SEQ 1256 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalcPagAtu (TT_PAG.CODFIL%TYPE,TT_PAG.SEQUEN%TYPE,TT_PAG.NUMPAR%TYPE,TT_PAG.SUBPAR%TYPE,INTEGER,TT_PAG.DATPGT%TYPE) CASCADE;

/*-- SEQ 1257 --*/
CREATE OR REPLACE FUNCTION CalcPagAtu (TT_PAG.CODFIL%TYPE,TT_PAG.SEQUEN%TYPE,TT_PAG.NUMPAR%TYPE,TT_PAG.SUBPAR%TYPE,INTEGER,TT_PAG.DATPGT%TYPE)
RETURNS Numeric AS $$
DECLARE
vCODFIL ALIAS FOR $1 ;
vSEQUEN ALIAS FOR $2 ;
vNUMPAR ALIAS FOR $3 ;
vSUBPAR ALIAS FOR $4 ;
ABANDONA ALIAS FOR $5 ;
vDATCAL ALIAS FOR $6 ;
  -- variaveis novas
  CODMOE  TT_COM.CODMOE%TYPE;
  VLRLAN  TT_PAG.VLRPAR%TYPE;
  DATVEN  TT_PAG.DATVEN%TYPE;
  VLTXJU  TT_COM.VLTXJU%TYPE;
  INCOJU  TT_COM.INCOJU%TYPE;
  INTPJU  TT_COM.INTPJU%TYPE;
  VLTXMU  TT_COM.VLTXMU%TYPE;
  INTPMU  TT_COM.INTPMU%TYPE;
  DATCAL  TT_PAG.DATPGT%TYPE;
  -- variaveis antigas
  JUROS   Numeric;
  VALOR   Numeric;
  RETORNO Numeric;
  DIAVEN  Numeric(2);
  MESVEN  Numeric(2);
  ANOVEN  Numeric(4);
  DIACAL  Numeric(2);
  MESCAL  Numeric(2);
  ANOCAL  Numeric(4);
  ATRAZO  Numeric(6);
BEGIN

-- Objetivo:
-- 1) Calcular o valor Numeric de uma prestacao considerando juros e multa
-- Obs.: sempre retorna o valor na moeda corrente no pais (0)
-- Variaveis abaixo...
-- CODMOE  : Codigo da moeda ref. valor do lancamento
-- VLRLAN  : Valor do lancamento
-- DATVEN  : Data de vencimento
-- VLTXJU  : Valor da taxa de juros
-- INCOJU  : Tipo correcao do juro (diaria, mensal, anual, moeda)
-- INTPJU  : Tipo de calculo dos juros
-- VLTXMU  : Valor da taxa de multa
-- INTPMU  : Tipo de multa (%/$)
-- DATCAL  : Data de pagamento
-- ABANDONA: Se deve (> 0) ou nao (= 0) interromper no caso de haver um erro no calculo


  -- efetua seleo
  SELECT COM.CODMOE, PAG.VLRPAR , PAG.DATVEN, COM.VLTXJU, COM.INCOJU,
         COM.INTPJU, COM.VLTXMU, COM.INTPMU, COALESCE(CASE PAG.FLGEST WHEN 'A' THEN NULL
                                                                 ELSE PAG.DATPGT
                                                 END,COALESCE(vDATCAL,agora()))
    INTO CODMOE, VLRLAN, DATVEN, VLTXJU, INCOJU, INTPJU, VLTXMU, INTPMU, DATCAL
    FROM TT_PAG PAG, TT_COM COM
   WHERE PAG.SEQUEN = COM.SEQUEN
     AND PAG.CODFIL = COM.CODFIL
     AND PAG.CODFIL = VCODFIL
     AND PAG.SEQUEN = VSEQUEN
     AND PAG.NUMPAR = VNUMPAR
     AND PAG.SUBPAR = VSUBPAR;
     
  -- inicializaes
  JUROS   := 0;
  VALOR   := VLRLAN;
  ATRAZO  := 0;
  RETORNO := 0;
  -- Obtem dia, mes e ano
  ANOVEN := TO_CHAR(DATVEN,'YYYY');
  MESVEN := TO_CHAR(DATVEN,'MM');
  DIAVEN := TO_CHAR(DATVEN,'DD');
  ANOCAL := TO_CHAR(DATCAL,'YYYY');
  MESCAL := TO_CHAR(DATCAL,'MM');
  DIACAL := TO_CHAR(DATCAL,'DD');

  -- Valor corrigido
  if (DATVEN < DATCAL) and (INTPMU = '@') then
    VALOR := VALOR + VLTXMU;
  end if;

  if CODMOE <> 0 then
    VALOR := MtoM(CODMOE,0,DATCAL,VALOR);
  end if;

  if VALOR = 0 then
    if ABANDONA > 0 then
      RAISE EXCEPTION 'PG-20020 Nao existe cambio para a moeda % no dia %' , CODMOE,DATCAL;
    else
      return RETORNO;
    end if;
  end if;

  -- Calcula Multas e Juros
  if (DATVEN < DATCAL) then
    -- Multa por Percentual Corrigido
    if INTPMU = '#' then
      VALOR := VALOR + (VALOR * VLTXMU) / 100;
    end if;

    -- Juros por Moedas
    if INCOJU in ('1','2','3','4','5','6','7','8','9') then
      JUROS := MtoM(0,INCOJU,DATVEN,VALOR);
      VALOR := 0;

      if JUROS = 0 then
        if ABANDONA > 0 then
         RAISE EXCEPTION 'PG-20020 Nao existe cambio para a moeda % no dia %' , INCOJU,DATVEN;
        else
          return RETORNO;
        end if;
      end if;

      JUROS := MtoM(INCOJU,0,DATCAL,JUROS);
      if JUROS = 0 then
        if ABANDONA > 0 then
         RAISE EXCEPTION 'PG-20020 Nao existe cambio para a moeda % no dia %' , INCOJU,DATCAL;
        else
          Return RETORNO;
        end if;
      end if;
    else
      -- Nao tem Juros
      if VLTXJU = 0 then
        JUROS := 0;
      else
        if INCOJU = 'D' then
          -- Juros diarios
          ATRAZO := Trunc(DATCAL)-Trunc(DATVEN);
          /* se DATCAL for hoje e hoje for segunda... */
          if (TO_CHAR(DATCAL,'D')='2') and (ATRAZO < 2) then
             ATRAZO := 0;
          end if;
          JUROS := Atraso(ATRAZO,INTPJU,VALOR,VLTXJU) - VALOR;
        elsif INCOJU = 'M' then
          -- Juros Mensais
          JUROS := Atraso((12-MESVEN) + ((ANOCAL - (ANOVEN + 1)) * 12) +
                   MESCAL + iif_Int(DIACAL>DIAVEN,1,0),INTPJU,VALOR,
                   VLTXJU) - VALOR;
        elsif INCOJU = 'A' then
          -- Juros Anuais
          JUROS := Atraso (1 + ANOCAL - ANOVEN +
                   iif_int(TO_CHAR(MESCAL)||TO_CHAR(DIACAL) >
                           TO_CHAR(MESVEN)||TO_CHAR(DIAVEN),0,-1),
                                             INTPJU,VALOR,VLTXJU) - VALOR;
        end if;
      end if;
    end if;

    -- Multa Valor Fixo
    if (DATVEN < DATCAL) and (INTPMU = '$') then
       VALOR := VALOR + COALESCE(VLTXMU,0);
    end if;

    -- Juros
    if INTPMU = '%' then
      VALOR := VALOR + (VALOR * COALESCE(VLTXMU,0)) / 100;
    end if;

    if JUROS < 0 then
      RETORNO := VALOR;
    else
      RETORNO := VALOR + COALESCE(JUROS,0);
    end if;
  end if;

  if DATVEN >= DATCAL then
    RETORNO := VALOR;
  end if;

  Return RETORNO;
END;
$$ language 'plpgsql';


/*-- SEQ 1258 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalcPagAtu (TT_PAG.CODFIL%TYPE,TT_PAG.SEQUEN%TYPE,TT_PAG.NUMPAR%TYPE,TT_PAG.SUBPAR%TYPE,INTEGER) CASCADE;

/*-- SEQ 1259 --*/
CREATE OR REPLACE FUNCTION CalcPagAtu (TT_PAG.CODFIL%TYPE,
                               TT_PAG.SEQUEN%TYPE,
                               TT_PAG.NUMPAR%TYPE,
                               TT_PAG.SUBPAR%TYPE,
                               INTEGER) 
RETURNS Numeric AS $$
BEGIN
RETURN CalcPagAtu($1,$2,$3,$4,$5,agora());
END;
$$ language 'plpgsql';


/*-- SEQ 1260 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalcPagAtu (TT_PAG.CODFIL%TYPE,TT_PAG.SEQUEN%TYPE,TT_PAG.NUMPAR%TYPE,TT_PAG.SUBPAR%TYPE) CASCADE;

/*-- SEQ 1261 --*/
CREATE OR REPLACE FUNCTION CalcPagAtu (TT_PAG.CODFIL%TYPE,
                               TT_PAG.SEQUEN%TYPE,
                               TT_PAG.NUMPAR%TYPE,
                               TT_PAG.SUBPAR%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN CalcPagAtu($1,$2,$3,$4,0,agora());
END;
$$ language 'plpgsql';



/*-- SEQ 1262 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalcRecAtu (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE,INTEGER,Timestamp) CASCADE;

/*-- SEQ 1263 --*/
CREATE OR REPLACE FUNCTION CalcRecAtu (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE,INTEGER,Timestamp)
RETURNS Numeric AS $$
DECLARE
vCODFIL ALIAS FOR $1 ;
vSEQUEN ALIAS FOR $2 ;
vNUMPAR ALIAS FOR $3 ;
vSUBPAR ALIAS FOR $4 ;
vABANDONA ALIAS FOR $5 ;
vDATPGT ALIAS FOR $6 ;
  -- variaveis novas          /* os campos comentados abaixo, hoje sao fixados pela funcao */
  vCODMOE  TT_REC.CODMOE%TYPE;
  vVLRLAN  TT_REC.VLRPAR%TYPE;
  vDATVEN  TT_REC.DATVEN%TYPE;
  vVLTXJU  TT_PLA.ACRDIA%TYPE;
  vINCOJU  TT_COM.INCOJU%TYPE; /* futuramente tera implantacao em TT_PLA, TT_REC ou TT_VEN */
  vINTPJU  TT_PLA.FLGJUR%TYPE;
  vVLTXMU  TT_PLA.VLTXMU%TYPE;
  vINTPMU  TT_PLA.INTPMU%TYPE;
  vDATCAL  TT_REC.PAGAME%TYPE;
  vDIAANT  TT_PLA.DIAANT%TYPE;
  vDESANT  TT_PLA.DESANT%TYPE;
  vDOCUME  TT_PLA.DESPGT%TYPE;

  WK_PORTAD TT_REC.PORTAD%TYPE;
  WK_FILTIT TT_TIT.CODFIL%TYPE;
  WK_SEQTIT TT_TIT.SEQUEN%TYPE;
  WK_GERTIT TD_COB.GERTIT%TYPE;
  WK_DIAPRO TT_CTB.DIAPRO%TYPE;
  WK_PERPRO TT_CTB.PERPRO%TYPE;
  WK_NUMPRO TT_CTB.NUMPRO%TYPE;

  wk_numero_desconto Numeric;
  wk_desconto        Numeric;
  wk_data            Numeric;
  
  wk_carencia     TT_CFG.CARENCIA%TYPE;

  -- variaveis antigas
  vJUROS     Numeric;
  vVALOR     Numeric;
  vRETORNO   Numeric;
  vDIAVEN    Numeric(2);
  vMESVEN    Numeric(2);
  vANOVEN    Numeric(4);
  vDIACAL    Numeric(2);
  vMESCAL    Numeric(2);
  vANOCAL    Numeric(4);
  WK_ATRASO Numeric(6);
begin

-- Objetivo:
-- 1) Calcular o valor Numeric de uma prestacao considerando juros e multa
-- Obs.: sempre retorna o valor na moeda corrente no pais (0)
-- Variaveis abaixo...
-- VCODMOE  : Codigo da moeda ref. valor do lancamento
-- VVLRLAN  : Valor do lancamento
-- VDATVEN  : Data de vencimento
-- VLTXJU  : Valor da taxa de juros
-- INCOJU  : Tipo correcao do juro (diaria, mensal, anual, moeda)
-- INTPJU  : Tipo de calculo dos juros
-- VLTXMU  : Valor da taxa de multa
-- INTPMU  : Tipo de multa (%/$)
-- DATCAL  : Data de pagamento
-- ABANDONA: Se deve (> 0) ou nao (= 0) interromper no caso de haver um erro no calculo

    SELECT COALESCE(CARENCIA,0) INTO WK_CARENCIA FROM TT_CFG;

  -- efetua seleo
    SELECT Rec.CODMOE, Rec.VLRPAR, Rec.DATVEN, Pla.ACRDIA, Rec.PORTAD,
           Pla.FLGJUR, COALESCE(vDATPGT,Rec.PAGAME,agora()),
           Pla.VLTXMU, Pla.INTPMU, Pla.DIAANT, Pla.DESANT,
       '('||VEN.CODFIL||')'||
       LTRIM(COALESCE(VEN.CODSER,'')) || '/' || LTRIM(COALESCE(VEN.NUMECF,'')) || '-' || LTRIM(COALESCE(VEN.NUMNOT,'')) AS DOCUME
      INTO VCODMOE, VVLRLAN, VDATVEN, vVLTXJU, WK_PORTAD,
           vINTPJU, vDATCAL,
           vVLTXMU, vINTPMU,vDIAANT,vDESANT,vDOCUME
      FROM TT_PLA Pla, TT_VEN Ven, TT_REC Rec
     WHERE Rec.CODFIL = vCODFIL
       AND Rec.SEQUEN = CAST(LPAD(vSEQUEN,10,' ') AS VARCHAR(10)) -- Colocado o cast para desempenho no PostgreSQL
       AND Rec.NUMPAR = CAST(LPAD(vNUMPAR,2,' ') AS VARCHAR(2))
       AND Rec.SUBPAR = CAST(LPAD(vSUBPAR,2,' ') AS VARCHAR(2))
       AND Ven.CODFIL = Rec.CODFIL
       AND Ven.SEQUEN = Rec.SEQUEN
       AND Pla.FILPGT = Ven.FILPGT
       AND Pla.CODPGT = Ven.CODPGT;
  SELECT TIT.CODFIL, TIT.SEQUEN, COALESCE(COB.GERTIT,'F'), CTB.DIAPRO, CTB.PERPRO, CTB.NUMPRO
    INTO WK_FILTIT, WK_SEQTIT, WK_GERTIT, WK_DIAPRO, WK_PERPRO, WK_NUMPRO
    FROM TT_REC REC INNER JOIN TT_TIT TIT ON TIT.FILREC = REC.CODFIL AND TIT.SEQREC = REC.SEQUEN
                                         AND TIT.PARREC = REC.NUMPAR AND TIT.SUBREC = REC.SUBPAR                                         
                    INNER JOIN TD_COB COB ON REC.PORTAD = COB.CODTAB
                    INNER JOIN TT_CTB CTB ON COB.FILCTA = CTB.FILCTA AND COB.SEQCTA = CTB.SEQCTA
   WHERE REC.PORTAD = WK_PORTAD
     AND Rec.CODFIL = vCODFIL
     AND Rec.SEQUEN = CAST(LPAD(vSEQUEN,10,' ') AS VARCHAR(10)) 
     AND Rec.NUMPAR = CAST(LPAD(vNUMPAR,2,' ') AS VARCHAR(2))  
     AND Rec.SUBPAR = CAST(LPAD(vSUBPAR,2,' ') AS VARCHAR(2))  
     AND TIT.SEQCAN IS NULL;
     
  -- inicializaes
  vJUROS     := 0;
  vVALOR     := vVLRLAN;
  vINCOJU    := 'D';  /* implementacao futura para dominio */
  WK_ATRASO := 0;
  vRETORNO   := 0;
  -- Obtem dia, mes e ano
  vANOVEN := TO_CHAR(vDATVEN,'YYYY');
  vMESVEN := TO_CHAR(vDATVEN,'MM');
  vDIAVEN := TO_CHAR(vDATVEN,'DD');
  vANOCAL := TO_CHAR(vDATCAL,'YYYY');
  vMESCAL := TO_CHAR(vDATCAL,'MM');
  vDIACAL := TO_CHAR(vDATCAL,'DD');

  -- Valor corrigido
  if (ADD_DAY(vDATVEN,WK_CARENCIA) < vDATCAL) and (vINTPMU = '@') then
    vVALOR := vVALOR + vVLTXMU;
  else 
    vRETORNO := vVALOR;
  end if;

  if vCODMOE <> 0 then
    vVALOR := MtoM(vCODMOE,0,vDATCAL,vVALOR);
  end if;

  if vVALOR = 0 then
    if vCODMOE = 0 then
       return 0;
    end if;
    if vABANDONA > 0 then
      RAISE EXCEPTION 'PG-20020 Nao existe cambio para a moeda % no dia % para converter nota %' , vCODMOE,vDATCAL,vDOCUME;
    else
      return COALESCE(ROUND(vRETORNO,2),0);
    end if;
  end if;

  -- Calcula Multas e Juros
  if (ADD_DAY(vDATVEN,WK_CARENCIA) < vDATCAL) then
    -- Multa por Percentual Corrigido
    if vINTPMU = '#' then
      vVALOR := vVALOR + (vVALOR * vVLTXMU) / 100;
    end if;

    -- Juros por Moedas
    if vINCOJU in ('1','2','3','4','5','6','7','8','9') then
      vJUROS := MtoM(0,vINCOJU,vDATVEN,vVALOR);
      vVALOR := 0;

      if vJUROS = 0 then
        if vABANDONA > 0 then
          RAISE EXCEPTION 'PG-20021 Nao existe cambio para a moeda % no dia % para converter nota %' , vINCOJU,vDATVEN,vDOCUME;
        else
          return COALESCE(ROUND(vRETORNO,2),0);
        end if;
      end if;

      vJUROS := MtoM(vINCOJU,0,vDATCAL,vJUROS);
      if vJUROS = 0 then
        if vABANDONA > 0 then

          RAISE EXCEPTION 'PG-20022 Nao existe cambio para a moeda % no dia % para converter nota %' , vINCOJU,vDATCAL,vDOCUME;
        else
          return COALESCE(ROUND(vRETORNO,2),0);
        end if;
      end if;
    else
      -- Nao tem Juros
      if vVLTXJU = 0 then
        vJUROS := 0;
      else
        if vINCOJU = 'D' then
          -- Juros diarios
          WK_ATRASO := Trunc(vDATCAL)-Trunc(vDATVEN);
          /* se DATCAL for hoje e hoje for segunda... */
          if (TO_CHAR(vDATCAL,'D')='2') and (WK_ATRASO < 2) then
             WK_ATRASO := 0;
          end if;
          
          if (DiaUtil(vCODFIL,vDATVEN) = 'F') and (WK_ATRASO < 2) then
             WK_ATRASO := 0;
          end if;
          
          vJUROS := Atraso(WK_ATRASO,TO_CHAR(vINTPJU),vVALOR,vVLTXJU) - vVALOR;
        elsif vINCOJU = 'M' then
          -- Juros Mensais
          vJUROS := Atraso((12-vMESVEN) + ((vANOCAL - (vANOVEN + 1)) * 12) +
                   vMESCAL + iif_Int(vDIACAL>vDIAVEN,1,0),TO_CHAR(vINTPJU),vVALOR,
                   vVLTXJU) - vVALOR;
        elsif vINCOJU = 'A' then
          -- Juros Anuais
          vJUROS := Atraso(1 + vANOCAL - vANOVEN +
                   iif_int(TO_CHAR(vMESCAL)||TO_CHAR(vDIACAL) >
                           TO_CHAR(vMESVEN)||TO_CHAR(vDIAVEN),0,-1),
                                             TO_CHAR(vINTPJU),vVALOR,vVLTXJU) - vVALOR;
        end if;
      end if;
    end if;

    -- Multa Valor Fixo
    if (ADD_DAY(vDATVEN,WK_CARENCIA) < vDATCAL) and (vINTPMU = '$') then
       vVALOR := vVALOR + vVLTXMU;
    end if;

    -- Juros
    if vINTPMU = '%' then
      vVALOR := vVALOR + (vVALOR * vVLTXMU) / 100;
    end if;

    if vJUROS < 0 then
      vRETORNO := vVALOR;
    else
      vRETORNO := vVALOR + vJUROS;
    end if;
  end if;

  if vDATVEN >= vDATCAL then
    vRETORNO := vVALOR;
    -- calcula desconto antecipado
     wk_data := trunc(vDATCAL) - trunc(vDATVEN);

     if wk_data <=0 and  abs(wk_data) >= vDIAANT then
        vRETORNO := (VVLRLAN - ROUND(VVLRLAN * vDESANT * (ABS(wk_data)/100),2)) ;
     end if;
  end if;
  if wk_gertit = 'T' and WK_DIAPRO > 0  and WK_PERPRO > 0  and  WK_NUMPRO > 0 then
        wk_data := trunc(vDATCAL) - trunc(vDATVEN);
        if wk_data <= 0 then
          wk_numero_desconto := 0;
        elsif mod(wk_data,wk_diapro) = 0 then
          wk_numero_desconto := (wk_data/wk_diapro);
        else
          wk_numero_desconto := (wk_data / wk_diapro) + 1;
        end if;
        wk_desconto := TRAZ_PERC_DESCONTO(wk_filtit, wk_seqtit,trunc(wk_numero_desconto));
        vRETORNO := vRETORNO - (vRETORNO * WK_DESCONTO) / 100;
  end if;

  Return COALESCE(ROUND(vRETORNO,2),0);
  
END;
$$ language 'plpgsql';


/*-- SEQ 1264 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalcRecAtu (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE,INTEGER) CASCADE;

/*-- SEQ 1265 --*/
CREATE OR REPLACE FUNCTION CalcRecAtu (TT_REC.CODFIL%TYPE,
                               TT_REC.SEQUEN%TYPE,
                               TT_REC.NUMPAR%TYPE,
                               TT_REC.SUBPAR%TYPE,
                               INTEGER) 
RETURNS Numeric AS $$
BEGIN
RETURN CalcRecAtu($1,$2,$3,$4,$5,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1266 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalcRecAtu (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE) CASCADE;

/*-- SEQ 1267 --*/
CREATE OR REPLACE FUNCTION CalcRecAtu (TT_REC.CODFIL%TYPE,
                               TT_REC.SEQUEN%TYPE,
                               TT_REC.NUMPAR%TYPE,
                               TT_REC.SUBPAR%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN CalcRecAtu($1,$2,$3,$4,0,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1268 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CALCPTRATU (TT_PTR.CODFIL%TYPE,TT_PTR.SEQUEN%TYPE,TT_PTR.NUMPAR%TYPE,TT_PTR.SUBPAR%TYPE,INTEGER,TT_PTR.DATPGT%TYPE) CASCADE;

/*-- SEQ 1269 --*/
CREATE OR REPLACE FUNCTION CALCPTRATU (TT_PTR.CODFIL%TYPE,TT_PTR.SEQUEN%TYPE,TT_PTR.NUMPAR%TYPE,TT_PTR.SUBPAR%TYPE,INTEGER,TT_PTR.DATPGT%TYPE)
RETURNS Numeric AS $$
DECLARE
vCODFIL ALIAS FOR $1 ;
vSEQUEN ALIAS FOR $2 ;
vNUMPAR ALIAS FOR $3 ;
vSUBPAR ALIAS FOR $4 ;
ABANDONA ALIAS FOR $5 ;
vDATCAL ALIAS FOR $6 ;
  -- variaveis novas
  CODMOE  TT_TRC.CODMOE%TYPE;
  VLRLAN  TT_PTR.VLRPAR%TYPE;
  DATVEN  TT_PTR.DATVEN%TYPE;
  VLTXJU  TT_TRC.VLTXJU%TYPE;
  INCOJU  TT_TRC.INCOJU%TYPE;
  INTPJU  TT_TRC.INTPJU%TYPE;
  VLTXMU  TT_TRC.VLTXMU%TYPE;
  INTPMU  TT_TRC.INTPMU%TYPE;
  DATCAL  TT_PTR.DATPGT%TYPE;
  -- variaveis antigas
  JUROS   Numeric;
  VALOR   Numeric;
  RETORNO Numeric;
  DIAVEN  Numeric(2);
  MESVEN  Numeric(2);
  ANOVEN  Numeric(4);
  DIACAL  Numeric(2);
  MESCAL  Numeric(2);
  ANOCAL  Numeric(4);
  ATRAZO  Numeric(6);

begin

  -- Objetivo:
  -- 1) Calcular o valor Numeric de uma prestacao considerando juros e multa
  -- Obs.: sempre retorna o valor na moeda corrente no pais (0)
  -- Variaveis abaixo...
  -- CODMOE  : Codigo da moeda ref. valor do lancamento
  -- VLRLAN  : Valor do lancamento
  -- DATVEN  : Data de vencimento
  -- VLTXJU  : Valor da taxa de juros
  -- INCOJU  : Tipo correcao do juro (diaria, mensal, anual, moeda)
  -- INTPJU  : Tipo de calculo dos juros
  -- VLTXMU  : Valor da taxa de multa
  -- INTPMU  : Tipo de multa (%/$)
  -- DATCAL  : Data de pagamento
  -- ABANDONA: Se deve (> 0) ou nao (= 0) interromper no caso de haver um erro no calculo


  -- efetua seleo
  SELECT TRC.CODMOE, PTR.VLRPAR , PTR.DATVEN, TRC.VLTXJU, TRC.INCOJU,
         TRC.INTPJU, TRC.VLTXMU, TRC.INTPMU, COALESCE(CASE PTR.FLGEST WHEN 'A' THEN NULL
                                                                 ELSE PTR.DATPGT
                                                 END,COALESCE(vDATCAL,agora()))
    INTO CODMOE, VLRLAN, DATVEN, VLTXJU, INCOJU, INTPJU, VLTXMU, INTPMU, DATCAL
    FROM TT_PTR PTR, TT_TRC TRC
   WHERE PTR.SEQUEN = TRC.SEQUEN
     AND PTR.CODFIL = TRC.CODFIL
     AND PTR.CODFIL = VCODFIL
     AND PTR.SEQUEN = VSEQUEN
     AND PTR.NUMPAR = VNUMPAR
     AND PTR.SUBPAR = VSUBPAR;

  -- inicializaes
  JUROS   := 0;
  VALOR   := VLRLAN;
  ATRAZO  := 0;
  RETORNO := 0;
  -- Obtem dia, mes e ano
  ANOVEN := TO_CHAR(DATVEN,'YYYY');
  MESVEN := TO_CHAR(DATVEN,'MM');
  DIAVEN := TO_CHAR(DATVEN,'DD');
  ANOCAL := TO_CHAR(DATCAL,'YYYY');
  MESCAL := TO_CHAR(DATCAL,'MM');
  DIACAL := TO_CHAR(DATCAL,'DD');

  -- Valor corrigido
  if (DATVEN < DATCAL) and (INTPMU = '@') then
    VALOR := VALOR + VLTXMU;
  end if;

  if CODMOE <> 0 then
    VALOR := MtoM(CODMOE,0,DATCAL,VALOR);
  end if;

  if VALOR = 0 then
    if ABANDONA > 0 then
      RAISE EXCEPTION 'PG-20020 Nao existe cambio para a moeda % no dia %' , CODMOE,DATCAL;
    else
      return RETORNO;
    end if;
  end if;

  -- Calcula Multas e Juros
  if (DATVEN < DATCAL) then
    -- Multa por Percentual Corrigido
    if INTPMU = '#' then
      VALOR := VALOR + (VALOR * VLTXMU) / 100;
    end if;

    -- Juros por Moedas
    if INCOJU in ('1','2','3','4','5','6','7','8','9') then
      JUROS := MtoM(0,INCOJU,DATVEN,VALOR);
      VALOR := 0;

      if JUROS = 0 then
        if ABANDONA > 0 then
          RAISE EXCEPTION 'PG-20020 Nao existe cambio para a moeda % no dia %' , INCOJU,DATVEN;
        else
          return RETORNO;
        end if;
      end if;

      JUROS := MtoM(INCOJU,0,DATCAL,JUROS);
      if JUROS = 0 then
        if ABANDONA > 0 then
          RAISE EXCEPTION 'PG-20020 Nao existe cambio para a moeda % no dia %' , INCOJU,DATCAL;
        else
          Return RETORNO;
        end if;
      end if;
    else
      -- Nao tem Juros
      if VLTXJU = 0 then
        JUROS := 0;
      else
        if INCOJU = 'D' then
          -- Juros diarios
          ATRAZO := Trunc(DATCAL)-Trunc(DATVEN);
          /* se DATCAL for hoje e hoje for segunda... */
          if (TO_CHAR(DATCAL,'D')='2') and (ATRAZO < 2) then
             ATRAZO := 0;
          end if;
          JUROS := Atraso(ATRAZO,INTPJU,VALOR,VLTXJU) - VALOR;
        elsif INCOJU = 'M' then
          -- Juros Mensais
          JUROS := Atraso((12-MESVEN) + ((ANOCAL - (ANOVEN + 1)) * 12) +
                   MESCAL + iif_Int(DIACAL>DIAVEN,1,0),INTPJU,VALOR,
                   VLTXJU) - VALOR;
        elsif INCOJU = 'A' then
          -- Juros Anuais
          JUROS := Atraso (1 + ANOCAL - ANOVEN +
                   iif_int(TO_CHAR(MESCAL)||TO_CHAR(DIACAL) >
                           TO_CHAR(MESVEN)||TO_CHAR(DIAVEN),0,-1),
                                             INTPJU,VALOR,VLTXJU) - VALOR;
        end if;
      end if;
    end if;

    -- Multa Valor Fixo
    if (DATVEN < DATCAL) and (INTPMU = '$') then
       VALOR := VALOR + COALESCE(VLTXMU,0);
    end if;

    -- Juros
    if INTPMU = '%' then
      VALOR := VALOR + (VALOR * COALESCE(VLTXMU,0)) / 100;
    end if;

    if JUROS < 0 then
      RETORNO := VALOR;
    else
      RETORNO := VALOR + COALESCE(JUROS,0);
    end if;
  end if;

  if DATVEN >= DATCAL then
    RETORNO := VALOR;
  end if;

  Return RETORNO;
END;
$$ language 'plpgsql';


/*-- SEQ 1270 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CALCPTRATU (TT_PTR.CODFIL%TYPE,TT_PTR.SEQUEN%TYPE,TT_PTR.NUMPAR%TYPE,TT_PTR.SUBPAR%TYPE,INTEGER) CASCADE;

/*-- SEQ 1271 --*/
CREATE OR REPLACE FUNCTION CALCPTRATU (TT_PTR.CODFIL%TYPE,
                               TT_PTR.SEQUEN%TYPE,
                               TT_PTR.NUMPAR%TYPE,
                               TT_PTR.SUBPAR%TYPE,
                               INTEGER) 
RETURNS Numeric AS $$
BEGIN
RETURN CALCPTRATU($1,$2,$3,$4,$5,agora());
END;
$$ language 'plpgsql';


/*-- SEQ 1272 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CALCPTRATU (TT_PTR.CODFIL%TYPE,TT_PTR.SEQUEN%TYPE,TT_PTR.NUMPAR%TYPE,TT_PTR.SUBPAR%TYPE) CASCADE;

/*-- SEQ 1273 --*/
CREATE OR REPLACE FUNCTION CALCPTRATU (TT_PTR.CODFIL%TYPE,
                               TT_PTR.SEQUEN%TYPE,
                               TT_PTR.NUMPAR%TYPE,
                               TT_PTR.SUBPAR%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN CALCPTRATU($1,$2,$3,$4,0,agora());
END;
$$ language 'plpgsql';


/*-- SEQ 1274 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION UsaCodSal (TT_GRA.CODTAM%TYPE) CASCADE;

/*-- SEQ 1275 --*/
CREATE OR REPLACE FUNCTION UsaCodSal (TT_GRA.CODTAM%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_CodTam ALIAS FOR $1 ;
  Retorno Char(1);
begin

  SELECT CASE WHEN TD_SUB.CODSAL IS NULL THEN 'S' 
              ELSE CASE TD_SUB.CODSAL WHEN TT_SUB.CODITE THEN 'S'
                                      ELSE 'N' 
                   END 
         END into Retorno
    FROM TT_SUB, TD_SUB
   WHERE TD_SUB.CODTAB = TT_SUB.CODSUB
     AND TT_SUB.CODITE = p_CodTam;

  return Retorno;

END;
$$ language 'plpgsql';






/*-- SEQ 1276 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Combustiveis (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1277 --*/
CREATE OR REPLACE FUNCTION Combustiveis (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE)
RETURNS Numeric AS $$
DECLARE
p_CodFil ALIAS FOR $1 ;
p_Sequen  ALIAS FOR $2 ;
  QTDLIT Numeric;    -- Quantidade Litros

-- Objetivo 
-- Retornar a quantidade de litros de combustiveis foi vendida

begin

       select SUM(CASE CL1.COMBUS WHEN 'T' THEN IVE.QTDMOV
                                  ELSE 0
                  END) into QTDLIT
       from tt_ive ive INNER JOIN tt_pro pro ON pro.filmat = ive.filmat and pro.codmat = ive.codmat
                       INNER JOIN TD_CL1 CL1 ON PRO.CLASS1 = CL1.CODTAB
       where ive.codfil = p_CodFil
         and ive.sequen = p_Sequen
         and ive.sitmov<>'C';
         
      RETURN COALESCE(QTDLIT,0);
END;
$$ language 'plpgsql';




/*-- SEQ 1278 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Combustiveis_Cliente (TT_VEN.FILCLI%TYPE,TT_VEN.CODCLI%TYPE,TT_VEN.DATHOR%TYPE,TT_VEN.DATHOR%TYPE,TT_VEN.CODFIL%TYPE) CASCADE;

/*-- SEQ 1279 --*/
CREATE OR REPLACE FUNCTION Combustiveis_Cliente (TT_VEN.FILCLI%TYPE,TT_VEN.CODCLI%TYPE,TT_VEN.DATHOR%TYPE,TT_VEN.DATHOR%TYPE,TT_VEN.CODFIL%TYPE)
RETURNS Numeric AS $$
DECLARE
p_FilCli ALIAS FOR $1 ;
p_CodCli ALIAS FOR $2 ;
p_DatIni ALIAS FOR $3 ;
p_DatFim ALIAS FOR $4 ;
p_CodFil ALIAS FOR $5 ;
   QTDLIT Numeric;    -- Quantidade Litros

-- Objetivo
-- Retornar a quantidade de litros de combustiveis foi vendida para um cliente
-- Verifica todas as filiais ou uma especifica

begin

       select SUM(CASE CL1.COMBUS WHEN 'T' THEN IVE.QTDMOV
                                           ELSE 0
                            END) into QTDLIT
       from tt_ive ive INNER JOIN tt_pro pro ON pro.filmat = ive.filmat and pro.codmat = ive.codmat
                       INNER JOIN TD_CL1 CL1 ON PRO.CLASS1 = CL1.CODTAB
                       INNER JOIN TT_VEN VEN ON ive.codfil = ven.codfil and ive.sequen = ven.sequen
       where ven.flgest <> 'C'
         and ive.lanest in ('S','C')
         and ven.filcli = p_FilCli
         and ven.codcli = p_CodCli
         and ven.codser in ('TK', 'CF')
         and ven.dathor between p_DatIni and p_DatFim
         and (ven.codfil = p_CodFil or p_CodFil is null)
         and ive.sitmov<>'C';
      RETURN COALESCE(QTDLIT,0);
END;
$$ language 'plpgsql';




/*-- SEQ 1280 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION COMISSOES (TT_VEN.COMSOB%TYPE,TT_PLA.FORMUL%TYPE,TT_VEN.PERCOM%TYPE,TT_VEN.PERENT%TYPE,TT_USU.PERCOM%TYPE,TT_GRA.PERCOM%TYPE,TT_VEN.VLRLIQ%TYPE,TT_VEN.VLRLIQ%TYPE,TT_VEN.VLRLIQ%TYPE,TT_VEN.VLRNOT%TYPE,TT_IVE.VLRMOV%TYPE,TT_GRA.CUSREP%TYPE) CASCADE;

/*-- SEQ 1281 --*/
CREATE OR REPLACE FUNCTION COMISSOES (TT_VEN.COMSOB%TYPE,TT_PLA.FORMUL%TYPE,TT_VEN.PERCOM%TYPE,TT_VEN.PERENT%TYPE,TT_USU.PERCOM%TYPE,TT_GRA.PERCOM%TYPE,TT_VEN.VLRLIQ%TYPE,TT_VEN.VLRLIQ%TYPE,TT_VEN.VLRLIQ%TYPE,TT_VEN.VLRNOT%TYPE,TT_IVE.VLRMOV%TYPE,TT_GRA.CUSREP%TYPE)
RETURNS Numeric AS $$
DECLARE
pComsob ALIAS FOR $1 ;
pFormul ALIAS FOR $2 ;
pPerCom ALIAS FOR $3 ;
pPerEnt ALIAS FOR $4 ;
pPerUsu ALIAS FOR $5 ;
pPerGra ALIAS FOR $6 ;
pVlrPar ALIAS FOR $7 ;
pVlrEnt ALIAS FOR $8 ;
pVlrLiq ALIAS FOR $9 ;
pVlrNot ALIAS FOR $10 ;
pVlrIte ALIAS FOR $11 ;
pCusRep ALIAS FOR $12 ;
  nComiss  Numeric;
  nValor   Numeric;
  nPercent Numeric;
  nPerPla  Numeric;
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*                                                               */
/* Calcula a Comissao total paga pela pre-venda do produto       */
/*                                                               */
/* Parametros:                                                   */
/* pComsob - Comissao sobre (tt_pla)                             */
/* pFormul - Formula da Comissao, onde:                          */
/*           0 - Venda x Vendedor                                */
/*           1 - Venda x Plano                                   */
/*           2 - Venda x Produto                                 */
/*           3 - Venda x (Vendedor + Plano)                      */
/*           4 - Venda x (Vendedor + Produto)                    */
/*           5 - Venda x (Plano + Produto)                       */
/*           6 - Venda x (Vendedor + Plano + Produto)            */
/* pPerCom - %Comissao sobre as parcelas (tt_pla)                */
/* pPerEnt - %Comissao sobre a entrada (tt_pla)                  */
/* pPerUsu - %Comissao do Vendedor (tt_usu)                      */
/* pPerGra - %Comissao sobre o Produto (tt_gra)                  */
/* pVlrPar - Valor das parcelas (var-num-parc * var-val-parc)    */
/* pVlrEnt - Valor da entrada  (var-val-ent)                     */
/* pVlrLiq - Valor liquido da venda  (var-val-liq)               */
/* pVlrNot - Valor de nota (bruto)  (var-val-bru)                */
/* pVlrIte - Valor do item de venda (loop var-val-item ate  eof) */
/* pCusRep - Valor total do custo de reposio                   */
/*                                                               */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
begin

  -- Se ComSob (Comissao Sobre) = 1, entao e calculada sobre valor bruto
  IF (pComSob = 1) THEN
    nValor := pVlrIte;
  ELSE
    nValor := (pVlrLiq / pVlrNot) * pVlrIte;
  END IF;

  -- Se ComSob (Comissao Sobre) = 7, descontar custo de reposicao
  IF (pComSob IN (7, 8)) THEN
    nValor := nValor - pCusRep;
  END IF;

  nPerPla := (pVlrEnt * pPerEnt / 100);           -- Comissao sobre entrada
  nPerPla := (pVlrPar * pPerCom / 100) + nPerPla; -- Somado a comisso sobre as parcelas
  nPerPla := nPerPla * 100 / pVlrLiq;

  if pFormul = 0 then
   nPercent := pPerUsu;
  elsif pFormul = 1 then
   nPercent := nPerPla;
  elsif pFormul = 2 then
   nPercent := pPerGra;
  elsif pFormul = 3 then
   nPercent := pPerUsu + nPerPla;
  elsif pFormul = 4 then
   nPercent := pPerUsu + pPerGra;
  elsif pFormul = 5 then
   nPercent := nPerPla + pPerGra;
  elsif pFormul = 6 then
   nPercent := pPerUsu + nPerPla + pPerGra;
  else
   nPercent := 0;
  end if;

  nComiss  := nValor * nPercent / 100;

  return nComiss;

END;
$$ language 'plpgsql';




/*-- SEQ 1282 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VALORCRT_DATA (TD_DET.USODET%TYPE,TD_CRT.CODTAB%TYPE,VARCHAR,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1283 --*/
CREATE OR REPLACE FUNCTION VALORCRT_DATA (TD_DET.USODET%TYPE,TD_CRT.CODTAB%TYPE,VARCHAR,VARCHAR,VARCHAR,VARCHAR)
RETURNS Timestamp AS $$
DECLARE
pUSODET ALIAS FOR $1 ;
pCODCRT ALIAS FOR $2 ;
pCOD1 ALIAS FOR $3 ;
pCOD2 ALIAS FOR $4 ;
pCOD3 ALIAS FOR $5 ;
pCOD4 ALIAS FOR $6 ;
   
   cRESP VARCHAR(20);

   vComplemento CONSTANT VARCHAR(254):= constante('complemento');

BEGIN

    cRESP:=AUX_VALORCRT(pUSODET,pCODCRT,pCOD1,pCOD2,pCOD3,pCOD4);

    RETURN TO_DATE(cRESP,'DD/MM/YYYY HH24:MI:SS');

END;
$$ language 'plpgsql';


/*-- SEQ 1284 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VALORCRT_DATA (TD_DET.USODET%TYPE,TD_CRT.CODTAB%TYPE,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1285 --*/
CREATE OR REPLACE FUNCTION VALORCRT_DATA (TD_DET.USODET%TYPE,
                               TD_CRT.CODTAB%TYPE,
                               VARCHAR,
                               VARCHAR,
                               VARCHAR) 
RETURNS Timestamp AS $$
BEGIN
RETURN VALORCRT_DATA($1,$2,$3,$4,$5,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1286 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VALORCRT_DATA (TD_DET.USODET%TYPE,TD_CRT.CODTAB%TYPE,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1287 --*/
CREATE OR REPLACE FUNCTION VALORCRT_DATA (TD_DET.USODET%TYPE,
                               TD_CRT.CODTAB%TYPE,
                               VARCHAR,
                               VARCHAR) 
RETURNS Timestamp AS $$
BEGIN
RETURN VALORCRT_DATA($1,$2,$3,$4,NULL,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1288 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VALORCRT_DATA (TD_DET.USODET%TYPE,TD_CRT.CODTAB%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1289 --*/
CREATE OR REPLACE FUNCTION VALORCRT_DATA (TD_DET.USODET%TYPE,
                               TD_CRT.CODTAB%TYPE,
                               VARCHAR) 
RETURNS Timestamp AS $$
BEGIN
RETURN VALORCRT_DATA($1,$2,$3,NULL,NULL,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1290 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VALORCRT_NUMBER (TD_DET.USODET%TYPE,TD_CRT.CODTAB%TYPE,VARCHAR,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1291 --*/
CREATE OR REPLACE FUNCTION VALORCRT_NUMBER (TD_DET.USODET%TYPE,TD_CRT.CODTAB%TYPE,VARCHAR,VARCHAR,VARCHAR,VARCHAR)
RETURNS Numeric AS $$
DECLARE
pUSODET ALIAS FOR $1 ;
pCODCRT ALIAS FOR $2 ;
pCOD1 ALIAS FOR $3 ;
pCOD2 ALIAS FOR $4 ;
pCOD3 ALIAS FOR $5 ;
pCOD4 ALIAS FOR $6 ;
   
   cRESP VARCHAR(20);

   vComplemento CONSTANT VARCHAR(254):= constante('complemento');

BEGIN

    cRESP:=AUX_VALORCRT(pUSODET,pCODCRT,pCOD1,pCOD2,pCOD3,pCOD4);

    RETURN TO_NUMBER(cRESP);

END;
$$ language 'plpgsql';


/*-- SEQ 1292 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VALORCRT_NUMBER (TD_DET.USODET%TYPE,TD_CRT.CODTAB%TYPE,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1293 --*/
CREATE OR REPLACE FUNCTION VALORCRT_NUMBER (TD_DET.USODET%TYPE,
                               TD_CRT.CODTAB%TYPE,
                               VARCHAR,
                               VARCHAR,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN VALORCRT_NUMBER($1,$2,$3,$4,$5,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1294 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VALORCRT_NUMBER (TD_DET.USODET%TYPE,TD_CRT.CODTAB%TYPE,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1295 --*/
CREATE OR REPLACE FUNCTION VALORCRT_NUMBER (TD_DET.USODET%TYPE,
                               TD_CRT.CODTAB%TYPE,
                               VARCHAR,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN VALORCRT_NUMBER($1,$2,$3,$4,NULL,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1296 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VALORCRT_NUMBER (TD_DET.USODET%TYPE,TD_CRT.CODTAB%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1297 --*/
CREATE OR REPLACE FUNCTION VALORCRT_NUMBER (TD_DET.USODET%TYPE,
                               TD_CRT.CODTAB%TYPE,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN VALORCRT_NUMBER($1,$2,$3,NULL,NULL,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1298 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VALORCRT_STRING (TD_DET.USODET%TYPE,TD_CRT.CODTAB%TYPE,VARCHAR,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1299 --*/
CREATE OR REPLACE FUNCTION VALORCRT_STRING (TD_DET.USODET%TYPE,TD_CRT.CODTAB%TYPE,VARCHAR,VARCHAR,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pUSODET ALIAS FOR $1 ;
pCODCRT ALIAS FOR $2 ;
pCOD1 ALIAS FOR $3 ;
pCOD2 ALIAS FOR $4 ;
pCOD3 ALIAS FOR $5 ;
pCOD4 ALIAS FOR $6 ;
   
   cRESP TT_CRTXGRA.DESCRT%TYPE;

   vComplemento CONSTANT VARCHAR(254):= constante('complemento');

BEGIN

    cRESP:=AUX_VALORCRT(pUSODET,pCODCRT,pCOD1,pCOD2,pCOD3,pCOD4);

    RETURN cRESP;

END;
$$ language 'plpgsql';


/*-- SEQ 1300 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VALORCRT_STRING (TD_DET.USODET%TYPE,TD_CRT.CODTAB%TYPE,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1301 --*/
CREATE OR REPLACE FUNCTION VALORCRT_STRING (TD_DET.USODET%TYPE,
                               TD_CRT.CODTAB%TYPE,
                               VARCHAR,
                               VARCHAR,
                               VARCHAR) 
RETURNS VARCHAR AS $$
BEGIN
RETURN VALORCRT_STRING($1,$2,$3,$4,$5,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1302 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VALORCRT_STRING (TD_DET.USODET%TYPE,TD_CRT.CODTAB%TYPE,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1303 --*/
CREATE OR REPLACE FUNCTION VALORCRT_STRING (TD_DET.USODET%TYPE,
                               TD_CRT.CODTAB%TYPE,
                               VARCHAR,
                               VARCHAR) 
RETURNS VARCHAR AS $$
BEGIN
RETURN VALORCRT_STRING($1,$2,$3,$4,NULL,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1304 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VALORCRT_STRING (TD_DET.USODET%TYPE,TD_CRT.CODTAB%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1305 --*/
CREATE OR REPLACE FUNCTION VALORCRT_STRING (TD_DET.USODET%TYPE,
                               TD_CRT.CODTAB%TYPE,
                               VARCHAR) 
RETURNS VARCHAR AS $$
BEGIN
RETURN VALORCRT_STRING($1,$2,$3,NULL,NULL,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1306 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CUSTO_AQUISICAO (TT_GRA.CUSREP%TYPE,TT_GRA.CUSFRE%TYPE,TT_GRA.VALCON%TYPE) CASCADE;

/*-- SEQ 1307 --*/
CREATE OR REPLACE FUNCTION CUSTO_AQUISICAO (TT_GRA.CUSREP%TYPE,TT_GRA.CUSFRE%TYPE,TT_GRA.VALCON%TYPE)
RETURNS Numeric AS $$
DECLARE
pCusRep ALIAS FOR $1 ;
pCusFre ALIAS FOR $2 ;
pValCon ALIAS FOR $3 ;
  nCusAqs Numeric;
/* * * * * * * * * * * * * * * * * * * * * * * * */
/*                                               */
/* Calcula o Custo final de aquisiCAo do produto */
/*                                               */
/* * * * * * * * * * * * * * * * * * * * * * * * */
begin

  nCusAqs := 0;
  IF COALESCE(pValCon,0) <> 0 THEN
     nCusAqs := (COALESCE(pCusRep,0)/pValCon)+COALESCE(pCusFre,0);
  END IF;

  return nCusAqs;

END;
$$ language 'plpgsql';





/*-- SEQ 1308 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CUSTO_FINANCEIRO (TT_VEN.VLRLIQ%TYPE,TT_VEN.VLRNOT%TYPE,TT_IVE.VLRMOV%TYPE,TT_VEN.PRAMED%TYPE,TT_CFG.TAXFIN%TYPE,TT_CFG.PRAFIN%TYPE) CASCADE;

/*-- SEQ 1309 --*/
CREATE OR REPLACE FUNCTION CUSTO_FINANCEIRO (TT_VEN.VLRLIQ%TYPE,TT_VEN.VLRNOT%TYPE,TT_IVE.VLRMOV%TYPE,TT_VEN.PRAMED%TYPE,TT_CFG.TAXFIN%TYPE,TT_CFG.PRAFIN%TYPE)
RETURNS Numeric AS $$
DECLARE
pVlrLiq ALIAS FOR $1 ;
pVlrNot ALIAS FOR $2 ;
pVlrMov ALIAS FOR $3 ;
pPraMed ALIAS FOR $4 ;
pTaxFin ALIAS FOR $5 ;
pPraFin ALIAS FOR $6 ;
  nCusto Numeric;
/* * * * * * * * * * * * * * * * * * * */
/*                                     */
/* Calcula o Custo financeiro da venda */
/*                                     */
/* * * * * * * * * * * * * * * * * * * */
begin

  nCusto := 0;
  IF ((COALESCE(pPraFin,0) <> 0)) THEN 
     nCusto := COALESCE(pVlrLiq,0)*(((COALESCE(pTaxFin,0)/100)/pPraFin)*COALESCE(pPraMed,0))*(COALESCE(pVlrMov,0)/pVlrNot);
  END IF;

  return nCusto;

END;
$$ language 'plpgsql';





/*-- SEQ 1310 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION REPFREPREMOV (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_VEN.DATHOR%TYPE) CASCADE;

/*-- SEQ 1311 --*/
CREATE OR REPLACE FUNCTION REPFREPREMOV (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_VEN.DATHOR%TYPE)
RETURNS CHAR AS $$
DECLARE
P_FILMAT ALIAS FOR $1 ;
P_CODMAT ALIAS FOR $2 ;
P_CODCOR ALIAS FOR $3 ;
P_CODTAM ALIAS FOR $4 ;
P_DATHOR ALIAS FOR $5 ;
   WK_RESULTADO                  CHAR(42);
   WK_DATA                       Timestamp;
   WK_DATHORTEMP                 Timestamp;
BEGIN
   -- Construcao para nao quebrar o indice
   WK_DATHORTEMP := TO_DATE(TO_CHAR(P_DATHOR,'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');

         SELECT MAX(ICO.COM_DATOPE) INTO WK_DATA 
        FROM TT_ICO ICO
       WHERE ICO.FILMAT=P_FILMAT
         AND ICO.CODMAT=P_CODMAT
         AND ICO.CODCOR=P_CODCOR
         AND ICO.CODTAM=P_CODTAM
         AND ICO.COM_DATOPE <= WK_DATHORTEMP
         AND COALESCE(ICO.CUSREP,0)>0
         AND ICO.QTDMOV <> 0;
   
         SELECT LPAD( TO_CHAR( TRUNC( COALESCE(ICO.CUSREP,0)*100 ) ),14,'0') ||
             LPAD( TO_CHAR( TRUNC( COALESCE(COALESCE(ICO.CUSFRE,GRA.CUSFRE),0)*100 ) ),14,'0') ||
             LPAD( TO_CHAR( TRUNC( COALESCE(ICO.VLRMOV/ICO.QTDMOV,0)*100 ) ),14,'0') INTO WK_RESULTADO
        FROM TT_ICO ICO, TT_GRA GRA
       WHERE ICO.FILMAT=GRA.FILMAT
         AND ICO.CODMAT=GRA.CODMAT
         AND ICO.CODCOR=GRA.CODCOR
         AND ICO.CODTAM=GRA.CODTAM
         AND ICO.FILMAT=P_FILMAT 
         AND ICO.CODMAT=P_CODMAT 
         AND ICO.CODCOR=P_CODCOR 
         AND ICO.CODTAM=P_CODTAM 
         AND ICO.COM_DATOPE = WK_DATA
         AND ICO.QTDMOV <> 0
         LIMIT 1;
   
   RETURN WK_RESULTADO;

END;
$$ language 'plpgsql';




/*-- SEQ 1312 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DatafaturamentoCartao (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE) CASCADE;

/*-- SEQ 1313 --*/
CREATE OR REPLACE FUNCTION DatafaturamentoCartao (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE)
RETURNS Timestamp AS $$
DECLARE
pCodFil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
pCodpar ALIAS FOR $3 ;
pSubpar ALIAS FOR $4 ;
/*
* Exibe e data estimada para o faturamento quando a venda for realizado com 
* cartao proprio.
*/


   cr_Rec CURSOR FOR
    select ven.filcli,ven.codcli,rec.datven, dccc.diaret, rec.flgest, rec.tipccc, 
           CASE COALESCE(LIM.CARENC,0) WHEN 0 THEN COALESCE(PLA.CARFAT,0)
                                              ELSE LIM.CARENC 
           END AS CARENC, 
           lim.DIAFIX, PLA.usacpp
      from tt_rec rec inner join tt_ven ven on ven.codfil=rec.codfil and ven.sequen=rec.sequen
                      inner join tt_pla pla on ven.filpgt=pla.filpgt and ven.codpgt=pla.codpgt
                       left join td_ccc dccc on rec.tipccc=dccc.codtab
                       left join tt_lim lim on ven.filcli=lim.filcli and ven.codcli=lim.codcli and rec.tipccc=lim.tipccc
     where rec.codfil=pCodFil
       and rec.sequen=pSequen
       and rec.numpar=pCodpar
       and rec.subpar=pSubpar;
       
AFaturar CURSOR(p_filial TT_LIM.FILCLI%TYPE,
           p_codigo TT_LIM.CODCLI%TYPE,
           p_conta TT_LIM.TIPCCC%TYPE) IS  
    SELECT A.DIASEM,
           CASE WHEN A.DIAMES IS NOT NULL THEN A.DIAMES ELSE
                CASE WHEN A.DIASEM IS NOT NULL THEN A.DIAMES 
                                               ELSE TO_NUMBER(TO_CHAR(agora(),'DD'))
                END
           END AS DIAMES,
           B.TIPCCC AS CODCCC
      FROM (select p_filial as filcli, 
                   p_codigo as codcli,
                   p_conta as tipccc 
                   from dual) B
           LEFT OUTER JOIN TT_DXC A ON A.FILCLI = B.FILCLI AND A.CODCLI = B.CODCLI AND A.CODCCC = B.TIPCCC;   
   
   vFilCli tt_cli.filcli%type;
   vCodCli tt_cli.codcli%type;  
   VTIPCCC tt_lim.tipccc%type;  
   vDatven tt_rec.datven%type;
   vDiaret td_ccc.diaret%type;
   vFlgest tt_rec.flgest%type;
   Tipccc  tt_rec.tipccc%type;
   vCARENC tt_lim.CARENC%type;
   vDIAFIX tt_lim.DIAFIX%type;
   vUsacpp tt_pla.Usacpp%type;
   
   wk_data_calc  Timestamp;
   
   
  i             Record;
   

BEGIN

 -- Traz dados da parcela
 OPEN cr_Rec;
 FETCH cr_Rec into vFilCli,vCodcli,vDatven,vDiaret,vFlgest,vTipccc,vCARENC,vDIAFIX,vUsacpp;
 IF NOT FOUND THEN
    return null;
 end if;  
 CLOSE cr_Rec;
 
 -- Se parcela e de carto proprio
 IF vFlgest='A' AND 
    vTipccc IS NOT NULL AND 
    vUsacpp = 'T' then 
    
    -- verifica dados de fatura deste cliente
    OPEN AFaturar(vFilCli,vCodcli,vTipccc);
    FETCH AFaturar into i;    
    IF NOT FOUND THEN 
       RETURN NULL;
    END IF;
    CLOSE AFaturar;
    
    -- calcula proxima data valida
    wk_data_calc := TRUNC(Aux_ProximaData(i.DIASEM,i.DIAMES, vDatven,i.CODCCC));
    
    IF vCARENC > 0 THEN -- Se possui carencia adiciona a mesma
       RETURN ADD_DAY(wk_data_calc,vCARENC);
    ELSIF vDIAFIX > 0 THEN -- Se possui dia para vencimento fixo coloca neste dia
       RETURN Aux_ProximaData(NULL,vDIAFIX, wk_data_calc,i.CODCCC);    
    ELSE -- Senao retorna a data encontrada
       RETURN wk_data_calc;
    END IF;
    
 ELSE -- Seno retorna data de vencimento da rec
    RETURN vDatven; 
 END IF;    

END;
$$ language 'plpgsql';






/*-- SEQ 1314 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CALCULA_DATA_PARCELA_AGC (TT_AGC.CODFIL%TYPE,TT_AGC.SEQUEN%TYPE,Timestamp,Timestamp,Timestamp) CASCADE;

/*-- SEQ 1315 --*/
CREATE OR REPLACE FUNCTION CALCULA_DATA_PARCELA_AGC (TT_AGC.CODFIL%TYPE,TT_AGC.SEQUEN%TYPE,Timestamp,Timestamp,Timestamp)
RETURNS Timestamp AS $$
DECLARE
PCODFIL ALIAS FOR $1 ;
PSEQUEN ALIAS FOR $2 ;
PDATOPE ALIAS FOR $3 ;
POLDDATOPE ALIAS FOR $4 ;
POLDDATPAR ALIAS FOR $5 ;
/* Flvio - 65324
Objetivo
  Devolver Data da Parcela Calculada
Parmetros
  Cd. Filial Agendamento (PCODFIL)
  Sequenciador Agendamento (PSEQUEN)
  Data Operao Calculada               
  Data Operao Antiga
  Data Parcela Antiga  
*/
  D          Numeric;
  M          Numeric;
  A          Numeric;
  DIA        Numeric;
  MES        Numeric;
  ANO        Numeric;
  V_LINHA    TT_AGC%ROWTYPE;
  DT_VENC    Timestamp;
  DIF_DIAS   Numeric;
  DIF_DIAS_DATOPE Numeric;
  DIF_MESES  Numeric;
  DIF_ANOS   Numeric;
  DIF_MESES_DATPAR  Numeric;
  DIF_ANOS_DATPAR   Numeric;
-- Principal
BEGIN
   
   SELECT * INTO V_LINHA FROM TT_AGC 
    WHERE CODFIL = PCODFIL 
      AND SEQUEN = PSEQUEN;

   DIF_DIAS  := to_number(to_char(POLDDATPAR,'DD')) - to_number(to_char(POLDDATOPE,'DD'));
   DIF_DIAS_DATOPE := to_number(to_char(PDATOPE,'DD')) - to_number(to_char(POLDDATOPE,'DD'));

   DIF_ANOS  := to_number(to_char(PDATOPE,'YYYY')) - to_number(to_char(POLDDATOPE,'YYYY'));
   DIF_MESES := 0;
   IF DIF_ANOS = 0 THEN 
     DIF_MESES := to_number(to_char(PDATOPE,'MM')) - to_number(to_char(POLDDATOPE,'MM'));
   ELSE 
     IF to_number(to_char(PDATOPE,'MM')) < to_number(to_char(POLDDATOPE,'MM')) THEN
       DIF_MESES := ((DIF_ANOS - 1) * 12) + (12 - to_number(to_char(POLDDATOPE,'MM'))) + to_number(to_char(PDATOPE,'MM'));
     ELSE 
       DIF_MESES := (DIF_ANOS * 12) + (to_number(to_char(PDATOPE,'MM')) - to_number(to_char(POLDDATOPE,'MM')));
     END IF;
   END IF;

   DIF_ANOS_DATPAR  := to_number(to_char(POLDDATPAR,'YYYY')) - to_number(to_char(POLDDATOPE,'YYYY'));
   DIF_MESES_DATPAR := 0;
   IF DIF_ANOS_DATPAR = 0 THEN 
     DIF_MESES_DATPAR := to_number(to_char(POLDDATPAR,'MM')) - to_number(to_char(POLDDATOPE,'MM'));
   ELSE 
     IF to_number(to_char(POLDDATPAR,'MM')) < to_number(to_char(POLDDATOPE,'MM')) THEN
       DIF_MESES_DATPAR := ((DIF_ANOS_DATPAR - 1) * 12) + (12 - to_number(to_char(POLDDATOPE,'MM'))) + to_number(to_char(POLDDATPAR,'MM'));
     ELSE 
       DIF_MESES_DATPAR := (DIF_ANOS_DATPAR * 12) + (to_number(to_char(POLDDATPAR,'MM')) - to_number(to_char(POLDDATOPE,'MM')));
     END IF;
   END IF;

   DT_VENC := PDATOPE;
   A := to_number(to_char(POLDDATPAR,'YYYY'));
   M := to_number(to_char(POLDDATPAR,'MM'));
   D := to_number(to_char(POLDDATPAR,'DD'));

   IF (V_LINHA.REPETE = 'M') THEN -- Mensal
     IF (V_LINHA.MESTIP = 0) OR (V_LINHA.MESTIP = 2) THEN
        Mes := MOD(M + DIF_MESES, 12);
        IF MES = 0 THEN 
           MES := 12;
        END IF;
        
        Ano := to_number(to_char(POLDDATOPE,'YYYY')) + 
                  FLOOR((DIF_MESES + DIF_MESES_DATPAR) / 12);
        IF (to_number(to_char(POLDDATOPE,'MM')) + (DIF_MESES + DIF_MESES_DATPAR) > 12)
        AND ((DIF_MESES + DIF_MESES_DATPAR) < 12) THEN
          Ano := Ano + 1;
        END IF;
        Dia := to_number(to_char(POLDDATPAR,'DD'));        
        IF to_number(to_char(LAST_DAY(TO_DATE('01'||TO_CHAR(MES, '00')||TO_CHAR(ANO, '0000'),'DDMMYYYY')),'dd')) < DIA THEN
          DIA := to_number(to_char(LAST_DAY(TO_DATE('01'||TO_CHAR(MES, '00')||TO_CHAR(ANO, '0000'),'DDMMYYYY')),'dd')); -- Traz ltimo dia prx. Ms 
        END IF;
        DT_VENC := TO_DATE(TO_CHAR(DIA, '00')||TO_CHAR(MES, '00')||TO_CHAR(ANO, '0000'),'DDMMYYYY');
     ELSIF (V_LINHA.MESTIP = 1) OR (V_LINHA.MESTIP = 3) THEN 
        Mes := MOD(M + DIF_MESES, 12);
        IF MES = 0 THEN 
           MES := 12;
        END IF;
        Ano := to_number(to_char(POLDDATOPE,'YYYY')) + 
                  FLOOR((DIF_MESES + DIF_MESES_DATPAR) / 12);
        IF (to_number(to_char(POLDDATOPE,'MM')) + (DIF_MESES + DIF_MESES_DATPAR) > 12)
        AND ((DIF_MESES + DIF_MESES_DATPAR) < 12) THEN
          Ano := Ano + 1;
        END IF;
        Dia := DIF_DIAS + to_number(to_char(PDATOPE,'DD'));        
        IF DIA < 1 THEN 
           DIA := 1;
        END IF;
        IF to_number(to_char(LAST_DAY(TO_DATE('01'||TO_CHAR(MES, '00')||TO_CHAR(ANO, '0000'),'DDMMYYYY')),'dd')) < DIA THEN
          DIA := to_number(to_char(LAST_DAY(TO_DATE('01'||TO_CHAR(MES, '00')||TO_CHAR(ANO, '0000'),'DDMMYYYY')),'dd')); -- Traz ltimo dia prx. Ms 
        END IF;
        DT_VENC := TO_DATE(TO_CHAR(DIA, '00')||TO_CHAR(MES, '00')||TO_CHAR(ANO, '0000'),'DDMMYYYY');       
     END IF;
   ELSE -- semanal
      Mes := MOD(M + DIF_MESES, 12);
      IF MES = 0 THEN 
         MES := 12;
      END IF;
      Ano := to_number(to_char(POLDDATOPE,'YYYY')) + 
                  FLOOR((DIF_MESES + DIF_MESES_DATPAR) / 12);
      IF (to_number(to_char(POLDDATOPE,'MM')) + (DIF_MESES + DIF_MESES_DATPAR) > 12)
      AND ((DIF_MESES + DIF_MESES_DATPAR) < 12) THEN
        Ano := Ano + 1;
      END IF;
      Dia := DIF_DIAS + to_number(to_char(PDATOPE,'DD'));     
      IF DIA < 1 THEN 
         DIA := 1;
      END IF;
      IF to_number(to_char(LAST_DAY(TO_DATE('01'||TO_CHAR(MES, '00')||TO_CHAR(ANO, '0000'),'DDMMYYYY')),'dd')) < DIA THEN
        DIA := to_number(to_char(LAST_DAY(TO_DATE('01'||TO_CHAR(MES, '00')||TO_CHAR(ANO, '0000'),'DDMMYYYY')),'dd')); -- Traz ltimo dia prx. Ms 
      END IF;
      DT_VENC := TO_DATE(TO_CHAR(DIA, '00')||TO_CHAR(MES, '00')||TO_CHAR(ANO, '0000'),'DDMMYYYY');       
   END IF;

  RETURN DT_VENC;  

END;
$$ language 'plpgsql';




/*-- SEQ 1316 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DadosLogon () CASCADE;

/*-- SEQ 1317 --*/
CREATE OR REPLACE FUNCTION DadosLogon ()
RETURNS TRetQuemLogou AS $$
DECLARE

-- Objetivo:
-- 1) Retornar a filial e o codigo do usuario logado no momento

  Retorno TRetQuemLogou%ROWTYPE;

  V_APEUSU VARCHAR(30);
  cFILUSU TT_USU.FILUSU%TYPE;
  cCODUSU TT_USU.CODUSU%TYPE;
  cFILDIF TT_USU.FILDIF%TYPE;
  cSEQDIF TT_USU.SEQDIF%TYPE;
  cTIPDIF TT_USU.TIPDIF%TYPE;

  usuario CURSOR(pAPEUSU TT_USU.APEUSU%TYPE) IS 
    SELECT FILUSU,CODUSU,FILDIF,SEQDIF,TIPDIF
      FROM TT_USU
     WHERE APEUSU = pAPEUSU;
BEGIN

  V_APEUSU := UPPER(GetApeUsuAtual());
  IF V_APEUSU = 'TT2000_INTERNET' THEN
     V_APEUSU := 'TOTALL';
  ELSIF V_APEUSU = 'ADMTOTALL' THEN
     V_APEUSU := 'TOTALL';
  END IF;

  Retorno.Encontrou := True;
  Retorno.TemConta  := False;
  OPEN usuario(V_APEUSU);
  FETCH usuario INTO cFILUSU,cCODUSU,cFILDIF,cSEQDIF,cTIPDIF;
  Retorno.FILUSU:=cFILUSU;
  Retorno.CODUSU:=cCODUSU;
  Retorno.FILDIF:=cFILDIF;
  Retorno.SEQDIF:=cSEQDIF;
  Retorno.TIPDIF:=cTIPDIF;
  IF  cFILDIF IS NOT NULL
  AND cSEQDIF IS NOT NULL
  AND cTIPDIF IS NOT NULL THEN
    Retorno.TemConta  := True; 
  END IF;
  IF NOT FOUND THEN
    Retorno.Encontrou := False;
  END IF;
  CLOSE usuario;
  RETURN Retorno;
END;
$$ language 'plpgsql';




/*-- SEQ 1318 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DiaFechado (TR_ECF.CODFIL%TYPE,TR_ECF.NUMECF%TYPE,TR_ECF.DATOPE%TYPE,TR_ECF.CNT_RO%TYPE,CHAR) CASCADE;

/*-- SEQ 1319 --*/
CREATE OR REPLACE FUNCTION DiaFechado (TR_ECF.CODFIL%TYPE,TR_ECF.NUMECF%TYPE,TR_ECF.DATOPE%TYPE,TR_ECF.CNT_RO%TYPE,CHAR)
RETURNS VARCHAR AS $$
DECLARE
p_Codfil ALIAS FOR $1 ;
p_NumEcf ALIAS FOR $2 ;
p_DatOpe ALIAS FOR $3 ;
p_Cnt_Ro ALIAS FOR $4 ;
p_RetornaMotivo ALIAS FOR $5 ;
  wk_VlrVen Numeric(18,2);
  wk_VlrCal Numeric(18,2);
  wk_VlrECF Numeric(18,2);
  wk_Return VARCHAR(4000);
  wk_PriNot TT_VEN.NUMNOT%TYPE;
  wk_Gt_ini TR_ECF.GT_INI%TYPE;
  wk_Gt_fim TR_ECF.GT_FIM%TYPE;  
  WK_COUNT  Numeric;
  LF        CHAR(2) := chr(13)||chr(10);
BEGIN

  IF p_RetornaMotivo = 'F' THEN
  wk_RETURN := 'S';
  ELSE
     wk_RETURN := '';
  END IF;  

  /* Verifica as Vendas efetuadas por Cupom Fiscal */
  SELECT COALESCE(SUM(VEN.VLRLIQ),0), 
         COALESCE(MAX(ECF.GT_FIM - ECF.GT_INI) - MAX(CAN.VLRTOT) - MAX(DES.VLRTOT),0),
         MIN(ECF.GT_INI), MIN(ECF.GT_FIM)
    INTO wk_VlrVen, wk_VlrCal,wk_gt_ini, wk_gt_fim
    FROM TR_ECF ECF LEFT OUTER JOIN TT_VEN VEN ON (ECF.CODFIL = VEN.CODFIL AND ECF.NUMECF = VEN.NUMECF AND ECF.CNT_RO = VEN.CNT_RO)
                                               and VEN.NUMNOT NOT LIKE '%#%'
                                               and TO_NUMBER(REPLACE(VEN.NUMNOT,'#','')) BETWEEN ECF.CUPINI AND ECF.CUPFIM
                                               and VEN.VLRLIQ > 0
                                               and VEN.CODSER IN ('CF','TK')
                                               and VEN.FLGEST <> 'C'
                         INNER JOIN TT_ECF CAN ON (ECF.CODFIL = CAN.CODFIL AND ECF.NUMECF = CAN.NUMECF AND ECF.DATOPE = CAN.DATOPE AND ECF.CNT_RO = CAN.CNT_RO)
                         INNER JOIN TT_ECF DES ON (ECF.CODFIL = DES.CODFIL AND ECF.NUMECF = DES.NUMECF AND ECF.DATOPE = DES.DATOPE AND ECF.CNT_RO = DES.CNT_RO)
   WHERE ECF.CODFIL = p_CodFil
     AND ECF.NUMECF = p_NumEcf
     AND ECF.DATOPE = p_DatOpe
     AND ECF.CNT_RO = p_Cnt_Ro
     AND CAN.TOTALI = 'CANC'
     AND DES.TOTALI = 'DESC';
   
   IF wk_gt_ini is null THEN
      IF p_RetornaMotivo = 'F' THEN
         wk_RETURN := 'N';
	  ELSE
	     wk_RETURN := wk_RETURN || 'GT inicial est vazio. Verifique reduo Z no Backoffice em Menu >> Tesouraria >> Caixa >> Reduo Z.' || LF;
      END IF; 
   END IF;   
   IF wk_gt_fim is null THEN
      IF p_RetornaMotivo = 'F' THEN
         wk_RETURN := 'N';
	  ELSE
	     wk_RETURN := wk_RETURN || 'GT final est vazio. Verifique reduo Z no Backoffice em Menu >> Tesouraria >> Caixa >> Reduo Z.' || LF;
      END IF; 
   END IF;      
   -- Compara redues com as vendas
   IF wk_VlrVen <> wk_VlrCal THEN
      IF p_RetornaMotivo = 'F' THEN
      wk_Return := 'N';
	  ELSE
	     wk_RETURN := wk_RETURN || 'Soma do valor lquido das vendas no confere com os GTs (venda bruta diria - cancelamento - desconto). Soma das vendas: ' || wk_VlrVen || '. Calc. dos GTs: ' || wk_VlrCal || '.  Verifique reduo Z no Backoffice em Menu >> Tesouraria >> Caixa >> Reduo Z.' || LF;
      END IF;
   END IF;   
   
   --Verifica se possui algum script que ainda no subiu
   SELECT COUNT(*)
     INTO WK_COUNT
    FROM TT_LCF 
   WHERE (FLGEST = 'T' OR FLGPRO = 'T')
     AND CODFIL = p_CODFIL
     AND NUMECF = p_NUMECF
     AND TRUNC(DATHOR) = p_DATOPE
     AND TIPOPE IN ('CAN','VEN');
     
   -- Verifica se existe transaes invlidas	 
   IF (wk_count <> 0) THEN
      IF p_RetornaMotivo = 'F' THEN
      wk_Return := 'N';
	  ELSE
	     wk_RETURN := wk_RETURN || 'Existem transaes invlidas. Entre em contato com o suporte.' || LF;
      END IF;
   END IF;

   SELECT SUM(CASE WHEN ECF.TIPTOT = 'O' THEN ECF.VLRTOT ELSE ECF.VLRBAS END) INTO wk_VlrECF
     FROM TT_ECF ECF
    WHERE ECF.CODFIL = p_CodFil
      AND ECF.NUMECF = p_NumEcf
      AND ECF.DATOPE = p_DatOpe
      AND ECF.CNT_RO = p_Cnt_Ro
      AND ECF.TOTALI <> 'ACRE'; -- Valor de acrscimo j  imbutido nos outros totalizadores
    
	-- Verifica se os totalizadores batem com o GT
    IF wk_VlrECF <> (Coalesce(wk_gt_fim, 0) - Coalesce(wk_gt_ini, 0)) THEN           
       IF p_RetornaMotivo = 'F' THEN
          wk_Return := 'N';
	   ELSE
	      wk_RETURN := wk_RETURN || 'Soma dos totalizadores no confere com o valor de venda bruta diria. Verifique reduo Z no Backoffice em Menu >> Tesouraria >> Caixa >> Reduo Z.' || LF;
       END IF;
    END IF; 
     
  IF LENGTH(wk_Return) > 255 THEN
     wk_Return := substr(wk_Return,1,252) || '...';
  END IF;
     
  Return wk_Return;
  
END;
$$ language 'plpgsql';




/*-- SEQ 1320 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DIAFIXPROXIMOFATURAMENTO (TT_LIM.FILCLI%TYPE,TT_LIM.CODCLI%TYPE,TT_LIM.TIPCCC%TYPE,TT_LIM.DIAFIX%TYPE,TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 1321 --*/
CREATE OR REPLACE FUNCTION DIAFIXPROXIMOFATURAMENTO (TT_LIM.FILCLI%TYPE,TT_LIM.CODCLI%TYPE,TT_LIM.TIPCCC%TYPE,TT_LIM.DIAFIX%TYPE,TD_FIL.CODFIL%TYPE)
RETURNS Numeric AS $$
DECLARE
p_FILCLI ALIAS FOR $1 ;
p_CODCLI ALIAS FOR $2 ;
p_CODCCC ALIAS FOR $3 ;
p_DiaFix ALIAS FOR $4 ;
p_Codfil ALIAS FOR $5 ;
-- Objetivo: Retornar do dia fixo do proximo Faturamento
-- Ateno: Quando realizar alterao aplicar caso necessrio no processo da function "PROXIMOFATURAMENTO"

  wk_data_menor Timestamp;
  wk_data_calc  Timestamp;
  wk_ult_data   Timestamp;
  wk_data       Timestamp;
  cFILCLI TT_LIM.FILCLI%TYPE;
  cCODCLI TT_LIM.CODCLI%TYPE;
  nDIAFIX TT_DXC.DIAFIX%TYPE;

-- Duplicado por questoes de otimizacao  
Clientes CURSOR FOR  
SELECT FILCLI,CODCLI
FROM connectby('(select cast(filcli||codcli as VARCHAR(9)) as filho,
                        cast(filvin||codvin as VARCHAR(9)) as pai,
                        0 as ordem
                   from TT_CLI int) tab', 'filho', 'pai', 'ordem', p_Filcli||p_Codcli, 0, '~')
AS c (conn_codigo VARCHAR, conn_codpai VARCHAR, level int, arvore text, ordem int)
INNER JOIN TT_CLI t ON c.conn_codigo  = (filcli||codcli)
where global='I';
   

AFaturar CURSOR(p_filial TT_LIM.FILCLI%TYPE,
           p_codigo TT_LIM.CODCLI%TYPE,
           p_conta TT_LIM.TIPCCC%TYPE) IS  
    SELECT A.DIASEM,
           CASE WHEN A.DIAMES IS NOT NULL THEN A.DIAMES ELSE
                CASE WHEN A.DIASEM IS NOT NULL THEN A.DIAMES 
                                               ELSE TO_NUMBER(TO_CHAR(agora(),'DD'))
                END
           END AS DIAMES,
           B.TIPCCC AS CODCCC, A.DIAFIX 
      FROM (select p_filial as filcli, 
                   p_codigo as codcli,
                   p_conta as tipccc 
                   from dual) B
           LEFT OUTER JOIN TT_DXC A ON A.FILCLI = B.FILCLI AND A.CODCLI = B.CODCLI AND A.CODCCC = B.TIPCCC;   

  i             Record;

-- Principal
BEGIN
  wk_data_menor:=agora();
  nDIAFIX:=p_DiaFix;
  
  OPEN Clientes;
  LOOP
    FETCH Clientes into cFILCLI,cCODCLI;
    EXIT WHEN NOT FOUND;

    IF p_Codfil <> NULL THEN	
       SELECT MIN(DATOPE) AS DATOPE into wk_Data
            FROM (SELECT FILCLI, CODCLI, TIPCCC, MIN(DATOPE) AS DATOPE
                  FROM TT_CCC
                  WHERE STATUS IN('A')
                    AND FILCLI = p_FILCLI
                    AND CODCLI = p_CODCLI
                    AND TIPCCC = p_CODCCC
		    AND CODFIL = p_Codfil
                  GROUP BY FILCLI, CODCLI, TIPCCC, CODFIL) TAB;

    ELSE
       SELECT MIN(DATOPE) AS DATOPE into wk_Data
            FROM (SELECT FILCLI, CODCLI, TIPCCC, MIN(DATOPE) AS DATOPE
                  FROM TT_CCC
                  WHERE STATUS IN('A')
                    AND FILCLI = p_FILCLI
                    AND CODCLI = p_CODCLI
                    AND TIPCCC = p_CODCCC
                  GROUP BY FILCLI, CODCLI, TIPCCC) TAB;
    END IF;
       
       wk_data_menor := least(coalesce(wk_data_menor,agora()),coalesce(wk_data,agora()));
       
  END LOOP;
  Close Clientes;

  wk_data  := trunc(wk_data_menor);
  wk_data_menor := null;
  OPEN AFaturar(p_FILCLI,p_CODCLI,p_CODCCC);
  LOOP
    FETCH AFaturar into i;
    EXIT WHEN NOT FOUND;    
    wk_data_calc := Aux_ProximaData(i.DIASEM,i.DIAMES, wk_data,i.CODCCC);
  
    if (wk_data_menor is null) or (wk_data_menor > wk_data_calc) then
       wk_data_menor := wk_data_calc;
       if (i.DIAFIX >= 1 ) and (i.DIAFIX <= 31 )then
         nDIAFIX := i.DIAFIX;
       end if;
    end if;
    
  END LOOP;
  CLOSE AFaturar;    
 
  RETURN nDIAFIX;
  
END;
$$ language 'plpgsql';


/*-- SEQ 1322 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DIAFIXPROXIMOFATURAMENTO (TT_LIM.FILCLI%TYPE,TT_LIM.CODCLI%TYPE,TT_LIM.TIPCCC%TYPE,TT_LIM.DIAFIX%TYPE) CASCADE;

/*-- SEQ 1323 --*/
CREATE OR REPLACE FUNCTION DIAFIXPROXIMOFATURAMENTO (TT_LIM.FILCLI%TYPE,
                               TT_LIM.CODCLI%TYPE,
                               TT_LIM.TIPCCC%TYPE,
                               TT_LIM.DIAFIX%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN DIAFIXPROXIMOFATURAMENTO($1,$2,$3,$4,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1324 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Dominios (TT_LAY.CODTAB%TYPE,TT_LAY.NOMCPO%TYPE,TT_LAY.TIPCPO%TYPE) CASCADE;

/*-- SEQ 1325 --*/
CREATE OR REPLACE FUNCTION Dominios (TT_LAY.CODTAB%TYPE,TT_LAY.NOMCPO%TYPE,TT_LAY.TIPCPO%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_Tabela ALIAS FOR $1 ;
p_Campo ALIAS FOR $2 ;
p_Tipo ALIAS FOR $3 ;

-- Objetivo
-- 1) Retornar string com dominios de uma coluna

 Texto VARCHAR(253);
 vSignificado VARCHAR(253);
 i Numeric;

 Lista CURSOR FOR
 select case p_Tipo when 'S' then rtrim(ltrim(to_char(dom.codint,'9999')))
               else coalesce(dom.codchr,' ')
    end || ' - ' || rtrim(ltrim(coalesce(dom.desdom,''))) as Significado
 from tt_dom dom
 where dom.codarq = p_Tabela
  and dom.nomcpo = p_Campo
 order by dom.desdom;
-- Principal
begin
 Texto := '';
 i := 0;
 OPEN Lista;
 LOOP
    FETCH Lista INTO vSignificado;
    EXIT WHEN NOT FOUND;
   if (i = 0) then
     Texto := vSignificado;
  else
   if length( Texto || '; ' || vSignificado ) > 253 then
    Texto := '** MUITO LONGO **';
    exit;
   else
    Texto := Texto || '; ' || vSignificado;
   end if;
  end if;
   i := i + 1;
 END LOOP;
 CLOSE Lista;
 Return texto;
END;
$$ language 'plpgsql';




/*-- SEQ 1326 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION EAN8 (VARCHAR) CASCADE;

/*-- SEQ 1327 --*/
CREATE OR REPLACE FUNCTION EAN8 (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
Ref ALIAS FOR $1 ;
  Cod    VARCHAR(15);
begin
  Cod := SUBSTR( Ean(Ref), 6, 8 );
  Return Cod;
END;
$$ language 'plpgsql';




/*-- SEQ 1328 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION EstruturaDeContas (TT_CTA.CODFIL%TYPE,TT_CTA.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1329 --*/
CREATE OR REPLACE FUNCTION EstruturaDeContas (TT_CTA.CODFIL%TYPE,TT_CTA.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCodFil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
-- Objetivo
-- 1) Retornar a estrutura uma conta

  cTITECT TT_ECT.TITECT%TYPE;  
  cCODFIL TT_ECT.CODFIL%TYPE;
  cSEQUEN TT_ECT.SEQUEN%TYPE;
BEGIN

  SELECT FILECT,SEQECT
    INTO cCODFIL,cSEQUEN
    FROM TT_CTA
   WHERE CODFIL = pCODFIL
     AND SEQUEN = pSEQUEN;

    
    SELECT TITECT
      INTO cTITECT
      FROM TT_ECT
     WHERE CODFIL = cCODFIL
       AND SEQUEN = cSEQUEN; 
  
  
  RETURN cTITECT;

END;
$$ language 'plpgsql';




/*-- SEQ 1330 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION FATURAMENTORETROATIVO (TT_LIM.FILCLI%TYPE,TT_LIM.CODCLI%TYPE,TT_LIM.TIPCCC%TYPE,Timestamp) CASCADE;

/*-- SEQ 1331 --*/
CREATE OR REPLACE FUNCTION FATURAMENTORETROATIVO (TT_LIM.FILCLI%TYPE,TT_LIM.CODCLI%TYPE,TT_LIM.TIPCCC%TYPE,Timestamp)
RETURNS Numeric AS $$
DECLARE
pFILCLI ALIAS FOR $1 ;
pCODCLI ALIAS FOR $2 ;
pCODCCC ALIAS FOR $3 ;
pDATFIM ALIAS FOR $4 ;
                                            
-- Objetivo: Retornar soma de valores a faturar para um cliente dentro de uma determinada data

WK_MAXSEQ TT_VEN.SEQUEN%TYPE;
WK_FATURA Numeric;
vIDAEVOLTA TT_CFG.CC_CHECKOUT%TYPE;

-- Principal
BEGIN
  -- davi - 50107 - 30/11/06 - sinuelo
  --SELECT CC_CHECKOUT INTO vIDAEVOLTA FROM TT_CFG;
    
  --IF pCODCCC=vIDAEVOLTA THEN 
  --   RETURN 0;
  --END IF; 
 
  SELECT COALESCE(MAX(CCC.SEQFAT),'         0') INTO WK_MAXSEQ
    FROM TT_CCC CCC INNER JOIN TT_VEN VEN ON CCC.FILFAT = VEN.CODFIL AND CCC.SEQFAT = VEN.SEQUEN
   WHERE VEN.DATFIS < TO_DATE(TO_CHAR(TRUNC(pDATFIM), 'DD/MM/YYYY') || ' 23:59:59', 'DD/MM/YYYY HH24:MI:SS')
     AND CCC.FILCLI = pFILCLI
     AND CCC.CODCLI = pCODCLI
     AND CCC.TIPCCC = pCODCCC;
 
  WK_FATURA := 0;

  SELECT COALESCE(SUM(VLRLAN),0) INTO WK_FATURA
    FROM TT_CCC CCC
   WHERE CCC.FILCLI = pFILCLI
     AND CCC.CODCLI = pCODCLI
     AND COALESCE(CCC.DATFIS,CCC.DATOPE) < pDATFIM
     AND CCC.TIPCCC = pCODCCC
     AND ((CCC.SEQFAT > WK_MAXSEQ) OR (CCC.SEQFAT IS NULL))
     AND CCC.STATUS NOT IN ('S','F');

  RETURN WK_FATURA;
  
END;
$$ language 'plpgsql';




/*-- SEQ 1332 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TO_PHONE (TT_END.NUMFON%TYPE,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1333 --*/
CREATE OR REPLACE FUNCTION TO_PHONE (TT_END.NUMFON%TYPE,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
Fone ALIAS FOR $1 ;
Forca ALIAS FOR $2 ;
Tipo ALIAS FOR $3 ;
  AuxFone VARCHAR(10);
  Tam INTEGER;
  Prossegue BOOLEAN;

BEGIN
  -- Consiste parametro
  IF Upper(Forca) = 'FORCE' THEN
    Prossegue := True;
  ELSIF Upper(FORCA) = 'NOFORCE' THEN
    Prossegue := False;
  ELSE
    RETURN NULL;
  END IF;

  -- Consiste parametro
  IF Upper(Tipo) = 'BIG' THEN
    Tam := 10;
  ELSIF Upper(Tipo) = 'TEXT' THEN
    Tam :=  9;
  ELSIF Upper(Tipo) = 'SHORT' THEN
    Tam :=  2;
  ELSE
    RETURN NULL;
  END IF;

  FOR i IN 1..Tam LOOP
    -- Pula
    IF NOT((Substr(Fone,i,1) = ' ') OR
           (Substr(Fone,i,1) = '-') OR
           (Substr(Fone,i,1) = '(') OR
           (Substr(Fone,i,1) = ')')) THEN

       IF IsDigit(Substr(Fone,i,1)) <> 1 THEN
         IF NOT Prossegue THEN
           RETURN NULL;
         END IF;
       ELSE
         AuxFone := COALESCE(AuxFone,'') || COALESCE(Substr(Fone,i,1),'');
       END IF;
    END IF;
  END LOOP;
  RETURN LPAD(AuxFone,Tam,' ');
END;
$$ language 'plpgsql';


/*-- SEQ 1334 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TO_PHONE (TT_END.NUMFON%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1335 --*/
CREATE OR REPLACE FUNCTION TO_PHONE (TT_END.NUMFON%TYPE,
                               VARCHAR) 
RETURNS VARCHAR AS $$
BEGIN
RETURN TO_PHONE($1,$2,TEXT);
END;
$$ language 'plpgsql';


/*-- SEQ 1336 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TO_PHONE (TT_END.NUMFON%TYPE) CASCADE;

/*-- SEQ 1337 --*/
CREATE OR REPLACE FUNCTION TO_PHONE (TT_END.NUMFON%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN TO_PHONE($1,'FORCE','TEXT');
END;
$$ language 'plpgsql';


/*-- SEQ 1338 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GeraSaldo (TD_FIL.CODFIL%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE) CASCADE;

/*-- SEQ 1339 --*/
CREATE OR REPLACE FUNCTION GeraSaldo (TD_FIL.CODFIL%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFilial ALIAS FOR $1 ;
pCodMat ALIAS FOR $2 ;
pCodCor ALIAS FOR $3 ;
pCodTam ALIAS FOR $4 ;
  vComplemento integer := 1;
BEGIN
  IF ISNULL(pCodMat)='T' THEN
    INSERT INTO TT_SAL (CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,CODMUL,DUMMY)
      (SELECT /*+ INDEX(FIL,PK_DFIL) INDEX(GRA,PK_GRA)  */
              FIL.CODFIL,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,MUL.CODTAB,vComplemento
         FROM TT_GRA GRA, TD_FIL FIL, TD_MUL MUL
        WHERE FIL.CODFIL = pFilial
          AND MUL.MULATI = 'T'
          AND NOT EXISTS (SELECT /*+ INDEX(SAL,AK_SAL)  */
                                 CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,CODMUL
                            FROM TT_SAL SAL
                           WHERE SAL.CODFIL = FIL.CODFIL
                             AND SAL.CODMUL = MUL.CODTAB
                             AND SAL.FILMAT = GRA.FILMAT
                             AND SAL.CODMAT = GRA.CODMAT
                             AND SAL.CODCOR = GRA.CODCOR
                             AND SAL.CODTAM = GRA.CODTAM));
  ELSE
    INSERT INTO TT_SAL (CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,CODMUL)
      (SELECT /*+ INDEX(FIL,PK_DFIL) INDEX(GRA,PK_GRA)  */
              FIL.CODFIL,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM, MUL.CODTAB
         FROM TT_GRA GRA, TD_FIL FIL, TD_MUL MUL
        WHERE GRA.FILMAT = pFilial
          AND GRA.CODMAT = pCodMat
          AND GRA.CODCOR = pCodCor
          AND GRA.CODTAM = pCodTam
          AND MUL.MULATI = 'T'
          AND NOT EXISTS (SELECT /*+ INDEX(SAL,AK_SAL)  */
                                 CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,CODMUL
                            FROM TT_SAL SAL
                           WHERE SAL.CODFIL = FIL.CODFIL
                             AND SAL.CODMUL = MUL.CODTAB
                             AND SAL.FILMAT = GRA.FILMAT
                             AND SAL.CODMAT = GRA.CODMAT
                             AND SAL.CODCOR = GRA.CODCOR
                             AND SAL.CODTAM = GRA.CODTAM));
  END IF;  
  RETURN 'OK';
END;
$$ language 'plpgsql';


/*-- SEQ 1340 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GeraSaldo (TD_FIL.CODFIL%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE) CASCADE;

/*-- SEQ 1341 --*/
CREATE OR REPLACE FUNCTION GeraSaldo (TD_FIL.CODFIL%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN GeraSaldo($1,$2,$3,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1342 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GeraSaldo (TD_FIL.CODFIL%TYPE,TT_GRA.CODMAT%TYPE) CASCADE;

/*-- SEQ 1343 --*/
CREATE OR REPLACE FUNCTION GeraSaldo (TD_FIL.CODFIL%TYPE,
                               TT_GRA.CODMAT%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN GeraSaldo($1,$2,NULL,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1344 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GeraSaldo (TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 1345 --*/
CREATE OR REPLACE FUNCTION GeraSaldo (TD_FIL.CODFIL%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN GeraSaldo($1,NULL,NULL,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1346 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GetDigit (VARCHAR) CASCADE;

/*-- SEQ 1347 --*/
CREATE OR REPLACE FUNCTION GetDigit (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
Dado ALIAS FOR $1 ;
  i     Numeric;
  Valor VARCHAR(20);
begin
  IF DADO IS NOT NULL THEN
    Valor := '';
    FOR i IN 1..LENGTH(Dado) LOOP
      IF SUBSTR(Dado,i,1) in ('0','1','2','3','4','5','6','7','8','9') THEN
        Valor := COALESCE(Valor,'')||SUBSTR(Dado,i,1);
      END IF;
    END LOOP;  
  END IF;

  RETURN Valor;
END;
$$ language 'plpgsql';




/*-- SEQ 1348 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GetMax (Numeric,Numeric) CASCADE;

/*-- SEQ 1349 --*/
CREATE OR REPLACE FUNCTION GetMax (Numeric,Numeric)
RETURNS Numeric AS $$
DECLARE
vlr1 ALIAS FOR $1 ;
vlr2 ALIAS FOR $2 ;
  maximo Numeric;
begin

  if vlr1 is null then
    maximo := vlr2;
  elsif vlr2 is null then
    maximo := vlr1;
  elsif  vlr1 > vlr2 then
    maximo := vlr1;  
  else
    maximo := vlr2;
  end if;

  RETURN maximo;
END;
$$ language 'plpgsql';




/*-- SEQ 1350 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GetMin (Numeric,Numeric,INTEGER) CASCADE;

/*-- SEQ 1351 --*/
CREATE OR REPLACE FUNCTION GetMin (Numeric,Numeric,INTEGER)
RETURNS Numeric AS $$
DECLARE
vlr1 ALIAS FOR $1 ;
vlr2 ALIAS FOR $2 ;
AceitaNegativo ALIAS FOR $3 ;
  minimo Numeric;
begin

  if    vlr1 is null then
    minimo := vlr2;
  elsif vlr2 is null then
    minimo := vlr1;
  elsif vlr1 < vlr2 then
    minimo := vlr1;  
  else
    minimo := vlr2;
  end if;

  -- Desconsidera numeros negativos se for o caso
  if (minimo is not null) and (minimo < 0) and (AceitaNegativo = 0) then
    minimo := 0;
  end if;

  RETURN minimo;
END;
$$ language 'plpgsql';


/*-- SEQ 1352 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GetMin (Numeric,Numeric) CASCADE;

/*-- SEQ 1353 --*/
CREATE OR REPLACE FUNCTION GetMin (Numeric,
                               Numeric) 
RETURNS Numeric AS $$
BEGIN
RETURN GetMin($1,$2,0);
END;
$$ language 'plpgsql';


/*-- SEQ 1354 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GetOrigem (TT_IVE.FILORI%TYPE,TT_IVE.NUMORI%TYPE,TT_IVE.ITEORI%TYPE) CASCADE;

/*-- SEQ 1355 --*/
CREATE OR REPLACE FUNCTION GetOrigem (TT_IVE.FILORI%TYPE,TT_IVE.NUMORI%TYPE,TT_IVE.ITEORI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_FilOri ALIAS FOR $1 ;
p_Numori ALIAS FOR $2 ;
p_IteOri ALIAS FOR $3 ;
 cORIGEM VARCHAR(30); -- Indica a venda origem
-- Objetivo:
-- 1) Buscar a venda origem
begin

 IF p_NumOri is NOT NULL THEN
    SELECT COALESCE(VEN.CODSER,'')||'/'||COALESCE(VEN.NUMECF,'')||'-'||ltrim(COALESCE(VEN.NUMNOT,''))||'-'||COALESCE(TO_CHAR(IVE.NUMITE) ,'') into cORIGEM
      FROM TT_VEN VEN, TT_IVE IVE
     WHERE IVE.CODFIL = p_FilOri
       AND IVE.SEQUEN = p_NumOri
       AND IVE.NUMITE = p_IteOri
       AND VEN.CODFIL = IVE.CODFIL
       AND VEN.SEQUEN = IVE.SEQUEN;
    RETURN cORIGEM;
 ELSE
    RETURN NULL;
 END IF;
END;
$$ language 'plpgsql';




/*-- SEQ 1356 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION HierarquiaProjeto (TT_PRJ.CODFIL%TYPE,TT_PRJ.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1357 --*/
CREATE OR REPLACE FUNCTION HierarquiaProjeto (TT_PRJ.CODFIL%TYPE,TT_PRJ.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_CodFil ALIAS FOR $1 ;
p_Sequen ALIAS FOR $2 ;

  Hierarquia VARCHAR(4000);
BEGIN
  select prj.nomprj into Hierarquia
    from TT_PRJ prj
   where prj.codfil = p_codfil
     and prj.sequen = p_sequen;

  Return Hierarquia;
END;
$$ language 'plpgsql';





/*-- SEQ 1358 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION HorasNoDia (Timestamp,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE) CASCADE;

/*-- SEQ 1359 --*/
CREATE OR REPLACE FUNCTION HorasNoDia (Timestamp,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE)
RETURNS Numeric AS $$
DECLARE
P_Data ALIAS FOR $1 ;
P_FILUSU ALIAS FOR $2 ;
P_CODUSU ALIAS FOR $3 ;
-- Objetivo
-- Retornar a quantidade de horas que o usurio trabalha naquele dia da semana;
  Semana Numeric(1);
  Horas Numeric(10);
BEGIN
  SELECT TO_CHAR(p_Data, 'D') INTO SEMANA FROM DUAL;
  if SEMANA = 1 then
    Select HORDOM into Horas from TT_USU WHERE FILUSU = P_FILUSU AND CODUSU = P_CODUSU;
  elsif SEMANA = 2 then
    Select HORSEG into Horas from TT_USU WHERE FILUSU = P_FILUSU AND CODUSU = P_CODUSU;
  elsif SEMANA = 3 then
    Select HORTER into Horas from TT_USU WHERE FILUSU = P_FILUSU AND CODUSU = P_CODUSU;
  elsif SEMANA = 4 then
    Select HORQUA into Horas from TT_USU WHERE FILUSU = P_FILUSU AND CODUSU = P_CODUSU;
  elsif SEMANA = 5 then
    Select HORQUI into Horas from TT_USU WHERE FILUSU = P_FILUSU AND CODUSU = P_CODUSU;
  elsif SEMANA = 6 then
    Select HORSEX into Horas from TT_USU WHERE FILUSU = P_FILUSU AND CODUSU = P_CODUSU;
  elsif SEMANA = 7 then
    Select HORSAB into Horas from TT_USU WHERE FILUSU = P_FILUSU AND CODUSU = P_CODUSU;
  End if;
  Return Horas / 60;
END;
$$ language 'plpgsql';




/*-- SEQ 1360 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION HorasUteis (td_fil.codfil%type,Timestamp,Numeric) CASCADE;

/*-- SEQ 1361 --*/
CREATE OR REPLACE FUNCTION HorasUteis (td_fil.codfil%type,Timestamp,Numeric)
RETURNS Timestamp AS $$
DECLARE
Filial ALIAS FOR $1 ;
Inicial ALIAS FOR $2 ;
QtdMin ALIAS FOR $3 ;
  WK_DATFIM Timestamp;
  WK_QTDMIN Numeric(7);
  WK_MININI Numeric(7);
  WK_HORFIM Numeric(7);
  WK_DIASEM Numeric(1);
  WK_STRHORINI VARCHAR(10);
  WK_CONTA  Numeric(10);
  vComplemento constant VARCHAR(100) := constante('complemento');

begin
  -- Verifica se existe horas de expediente para esta filial
  SELECT COUNT(*) into WK_CONTA FROM TT_EXP
  WHERE CODFIL = FILIAL;

  If WK_Conta = 0 then
     RAISE EXCEPTION 'PG-20007 Esta filial nao possui horas de expediente cadastradas, portanto impossivel de ser analizada. %' , vComplemento;
  end if;

  -- Armazena os minutos restantes.
  WK_QTDMIN := QtdMin;
  WK_DATFIM := Inicial;

  -- Enquanto ainda existir minutos a serem gastos
  LOOP
      -- Sai do loop quando nao houver mais minutos para distribuir
      EXIT WHEN (WK_QTDMIN = 0);

      -- Retorna a primeira hora util.
      WK_DATFIM := ProximaHoraUtil(Filial, WK_DATFIM);

      -- no Oracle o Domingo e codigo 1, ja no sistema e codigo 0
      -- DiaSem guarda o dia da semana, iniciando de 0
      WK_DIASEM := TO_CHAR(WK_DATFIM ,'D') -1;

      -- MinIni guarda o valor dos minutos no formato totall
      WK_MININI := TO_NUMBER(TO_CHAR(WK_DATFIM ,'HH24')) * 60 + TO_NUMBER(TO_CHAR(WK_DATFIM ,'MI'));

      -- Verifica se existe no mesmo dia da semana hora util
      -- verificando se a hora atual ja esta contando como util.
      SELECT HORFIM INTO WK_HORFIM FROM TT_EXP
      WHERE DIASEM = WK_DIASEM
        AND WK_MININI BETWEEN HORINI AND HORFIM
        AND CODFIL = FILIAL;

      IF (WK_QTDMIN >= (WK_HORFIM - WK_MININI)) THEN
        -- Se os minutos restantes sao maiores do que os minutos deste intervalo
        WK_QTDMIN := WK_QTDMIN - (WK_HORFIM - WK_MININI);
      ELSE
        -- Se os minutos restantes, nao ocuparao todo o intervalos, entao...
        WK_HORFIM := WK_MININI + WK_QTDMIN;
        WK_QTDMIN := 0;
      END if;

      -- Transforma a hora final para string.
      WK_STRHORINI := TRIM(TO_CHAR(TRUNC(WK_HORFIM/60),'00')||':'||SUBSTR(TO_CHAR( WK_HORFIM - (TRUNC(WK_HORFIM/60)*60),'00'),2,2));

      -- Atualiza a Data fim.
      WK_DATFIM := TO_DATE(TO_CHAR(WK_DATFIM,'DD/MM/YYYY') || WK_STRHORINI,'DD/MM/YYYY HH24:MI');
  END LOOP;

  return wk_datfim;

END;
$$ language 'plpgsql';




/*-- SEQ 1362 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ICM_RETIDO (TT_VEN.VLRNOT%TYPE,TT_VEN.RETIDO%TYPE,TT_IVE.VLRMOV%TYPE,TT_IVE.ICMTIP%TYPE,TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1363 --*/
CREATE OR REPLACE FUNCTION ICM_RETIDO (TT_VEN.VLRNOT%TYPE,TT_VEN.RETIDO%TYPE,TT_IVE.VLRMOV%TYPE,TT_IVE.ICMTIP%TYPE,TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE)
RETURNS Numeric AS $$
DECLARE
pVlrNot ALIAS FOR $1 ;
pRetido ALIAS FOR $2 ;
pVlrMov ALIAS FOR $3 ;
pIcmTip ALIAS FOR $4 ;
pCodFil ALIAS FOR $5 ;
pSequen ALIAS FOR $6 ;
  nRetido Numeric;
  nVlrProporcional Numeric;
/* * * * * * * * * * * * * * * * * * * * * * * */
/*                                             */
/* Calcula o ICMS RETIDO NA FONTE Proporcional */
/*                                             */
/* * * * * * * * * * * * * * * * * * * * * * * */
begin

  nRetido := 0;
  nVlrProporcional := 0;
  IF ((COALESCE(pIcmTip,'0') = '3') AND    /* se Produto Substituido */
      (COALESCE(pVlrNot,0) <> 0)) THEN   
     SELECT SUM(VLRMOV) INTO nVlrProporcional
     FROM TT_IVE
     WHERE CODFIL = pCodFil
       AND SEQUEN = pSequen
       AND ICMTIP = '3';   
     IF COALESCE(nVlrProporcional,0) > 0 THEN
        nRetido := (COALESCE(pVlrMov,0)/nVlrProporcional)*COALESCE(pRetido,0);
     ELSE
        nRetido := 0;
     END IF;
     /* nRetido := (COALESCE(pVlrMov,0)/pVlrNot)*COALESCE(pRetido,0); */  /* Forma Antiga */
  END IF;

  return nRetido;
END;
$$ language 'plpgsql';




/*-- SEQ 1364 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IIF_Char_Char (VARCHAR,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1365 --*/
CREATE OR REPLACE FUNCTION IIF_Char_Char (VARCHAR,VARCHAR,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
Cond1 ALIAS FOR $1 ;
Cond2 ALIAS FOR $2 ;
Exp1 ALIAS FOR $3 ;
Exp2 ALIAS FOR $4 ;
begin
  if (Cond1 = Cond2) then
     Return Exp1;
  else
     Return Exp2;
  end if;
END;
$$ language 'plpgsql';




/*-- SEQ 1366 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IIF_Char_number (VARCHAR,VARCHAR,Numeric,Numeric) CASCADE;

/*-- SEQ 1367 --*/
CREATE OR REPLACE FUNCTION IIF_Char_number (VARCHAR,VARCHAR,Numeric,Numeric)
RETURNS Numeric AS $$
DECLARE
Cond1 ALIAS FOR $1 ;
Cond2 ALIAS FOR $2 ;
Exp1 ALIAS FOR $3 ;
Exp2 ALIAS FOR $4 ;
begin
  if (Cond1 = Cond2) then
     return Exp1;
  else
     return Exp2;
  end if;
END;
$$ language 'plpgsql';





/*-- SEQ 1368 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IIF_number (boolean,Numeric,Numeric) CASCADE;

/*-- SEQ 1369 --*/
CREATE OR REPLACE FUNCTION IIF_number (boolean,Numeric,Numeric)
RETURNS Numeric AS $$
DECLARE
Condicao ALIAS FOR $1 ;
Exp1 ALIAS FOR $2 ;
Exp2 ALIAS FOR $3 ;
begin
  if Condicao then
     return Exp1;
  else
     return Exp2;
  end if;
END;
$$ language 'plpgsql';




/*-- SEQ 1370 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPOSTOS (TT_IVE.VLR001%TYPE,TT_IVE.VLR001%TYPE,TT_IVE.VLR002%TYPE) CASCADE;

/*-- SEQ 1371 --*/
CREATE OR REPLACE FUNCTION IMPOSTOS (TT_IVE.VLR001%TYPE,TT_IVE.VLR001%TYPE,TT_IVE.VLR002%TYPE)
RETURNS Numeric AS $$
DECLARE
pIcmIte ALIAS FOR $1 ;
pIssIte ALIAS FOR $2 ;
pIpiIte ALIAS FOR $3 ;
  nImpostos Numeric;
/* * * * * * * * * * * * * * */
/*                           */
/* Soma os Impostos da venda */
/*                           */
/* * * * * * * * * * * * * * */
begin

  nImpostos := COALESCE(pIcmIte,0)+COALESCE(pIssIte,0)+COALESCE(pIpiIte,0);

  return nImpostos;

END;
$$ language 'plpgsql';




/*-- SEQ 1372 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_TDS (VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,Numeric,Numeric,VARCHAR,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1373 --*/
CREATE OR REPLACE FUNCTION IMPORTA_TDS (VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,Numeric,Numeric,VARCHAR,VARCHAR,VARCHAR,VARCHAR)
RETURNS Numeric AS $$
DECLARE
TABELA ALIAS FOR $1 ;
COLATI ALIAS FOR $2 ;
COLTIT ALIAS FOR $3 ;
COLCHV ALIAS FOR $4 ;
TITULO ALIAS FOR $5 ;
DIVISA ALIAS FOR $6 ;
SUBDIV ALIAS FOR $7 ;
PTIPDOC ALIAS FOR $8 ;
COLTIT2 ALIAS FOR $9 ;
TITULO2 ALIAS FOR $10 ;
p_CODEXT ALIAS FOR $11 ;

   COMANDO                          VARCHAR(255);
   WK_QTD                           Numeric;
   WK_COD                           Numeric;
   WK_COUNT                         Numeric;
   WK_ATIVO                         CHAR(1);
   WK_RETURN                        Numeric;
   wk_usoina                        CHAR(1);
   WK_USOEND                        CHAR(1);
   WK_DUPEND                        CHAR(1);
   wk_seqcta                        TT_CTA.SEQUEN%TYPE;
   WK_TIPCCC                        TD_CCC.TIPCCC%TYPE;
   WK_CLILIV                        TD_CCC.CLILIV%TYPE;
   WK_COMCCC                        TD_CCC.COMCCC%TYPE;
   WK_CTACCC                        TD_CCC.CTACCC%TYPE;
   WK_CTRTIP                        TD_CTR.CTRTIP%TYPE;
   WK_CTRUSO                        TD_CTR.CTRUSO%TYPE;
   WK_CTRSEQ                        TD_CTR.CTRSEQ%TYPE;
   WK_MED_COUNT                     Numeric;
   WK_MED_CODTAB                    Numeric;
   
     curs1                          refcursor;
      VALOR_STR                        VARCHAR(40);
   cTitulo                          VARCHAR(4000);
   cTitulo2                         VARCHAR(4000);

BEGIN

   cTitulo  := Replace(Titulo,chr(39), chr(39)||chr(39));
   cTitulo2 := Replace(Titulo2,chr(39), chr(39)||chr(39));

   -- RFMP 80113
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20022 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

   WK_ATIVO := 'T';
   WK_USOEND := 'A';
   WK_DUPEND := 'T';
   if divisa = -1 then
     wk_usoina := 'C';
   elsif divisa = -2 then
     wk_usoina := 'P';
   else
     wk_usoina := 'Q';
   end if;

   IF TABELA IN ('TD_ICM','TD_IPI','TD_IME','TD_IRR','TD_IR1','TD_IR2','TD_IRE','TD_IES', 'TD_ISS') THEN
       COMANDO := 'SELECT count(*), MAX('|| colchv ||') FROM '|| tabela ||' WHERE '|| coltit ||' = '|| titulo;
   ELSIF TABELA IN ('TD_GRA','TD_DIV','TD_SUB', 'TD_CCC', 'TD_CT1', 'TD_CT2', 'TD_CT3') THEN
       IF p_CODEXT IS NOT NULL THEN
         COMANDO := 'SELECT count(*), MAX('|| colchv ||') '||
                    '  FROM '|| tabela;
         -- Comando para pegar pelo cdigo externo
         IF (TABELA = 'TD_CCC') THEN 
            COMANDO := COMANDO ||
                       ' WHERE CODEXT_DCCC = ' || chr(39)||p_CODEXT||chr(39);
         ELSIF (TABELA = 'TD_CT1') THEN
            COMANDO := COMANDO ||
                       ' WHERE CODEXT_DCT1 = ' || chr(39)||p_CODEXT||chr(39);
         ELSIF (TABELA = 'TD_CT2') THEN
            COMANDO := COMANDO ||
                       ' WHERE CODEXT_DCT2 = ' || chr(39)||p_CODEXT||chr(39);
         ELSIF (TABELA = 'TD_CT3') THEN
            COMANDO := COMANDO ||
                       ' WHERE CODEXT_DCT3 = ' || chr(39)||p_CODEXT||chr(39);
         ELSE
            COMANDO := COMANDO ||
                       ' WHERE CODEXT = TRIM(' || chr(39)||p_CODEXT||chr(39)||')';
         END IF;
       ELSE
         COMANDO := 'SELECT count(*), MAX('|| colchv ||') '||
                    '  FROM '|| tabela;
         -- Comando para pegar pela descrio, desconsiderando registros que tenham cdigo externo em algumas tabelas
         IF (TABELA IN ('TD_CCC', 'TD_CT1', 'TD_CT2', 'TD_CT3')) THEN 
            COMANDO := COMANDO ||
                       ' WHERE 1=1 ';
         ELSE
            COMANDO := COMANDO ||
                       ' WHERE CODEXT IS NULL ';
         END IF;
         COMANDO := COMANDO || 
                    '   AND trim('|| coltit ||') = trim('||chr(39)|| cTitulo ||chr(39)||')';
       END IF;
   ELSE
       COMANDO := 'SELECT count(*), MAX('|| colchv ||') FROM '|| tabela ||' WHERE trim('|| coltit ||') = trim('||chr(39)|| cTitulo ||chr(39)||')';
   END IF;

      
      OPEN CURS1 FOR EXECUTE COMANDO;
      FETCH curs1 INTO wk_qtd, wk_cod;
      CLOSE curs1;
   
   --------------------------------------------------------------------------------------
   -- 1. Incluso de novo registro
   --------------------------------------------------------------------------------------
   IF (WK_QTD = 0) OR (WK_QTD IS NULL) THEN
      COMANDO := 'SELECT MAX('|| colchv ||') FROM '|| tabela ;
            
      OPEN CURS1 FOR EXECUTE COMANDO;
      FETCH curs1 INTO wk_cod;
      CLOSE curs1;
            IF WK_COD IS NULL THEN
         WK_COD := 1;
      END IF;
--      IF WK_COD > 100 THEN
         COMANDO := 'INSERT INTO TD_IND (CODTAB) (SELECT D.PROXIMO FROM (SELECT '|| TO_CHAR(WK_COD+1)||' AS PROXIMO FROM DUAL) D LEFT JOIN TD_IND I ON I.CODTAB = D.PROXIMO WHERE I.CODTAB IS NULL)';
                  
            EXECUTE COMANDO;
         --      END IF;
      WK_COD := WK_COD + 1;

      IF tabela IN ('TD_DIV', 'TD_SUB') THEN
         IF p_CODEXT IS NOT NULL THEN
            COMANDO := 'INSERT INTO '|| tabela || ' (CODTAB,' || colati || ',' || coltit || ', CODEXT) ' ||
                       'VALUES (' || TO_CHAR(WK_COD) ||','||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)||cTitulo||chr(39)||', '|| chr(39)||p_CODEXT||chr(39) ||')';
         ELSE
            COMANDO := 'INSERT INTO '|| tabela || ' (CODTAB,' || colati || ',' || coltit || ') ' ||
                       'VALUES (' || TO_CHAR(WK_COD) ||','||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)||cTitulo||chr(39)||')';
         END IF;
                  
            EXECUTE COMANDO;
         
      ELSIF tabela = 'TD_GRA' THEN
         IF p_CODEXT IS NOT NULL THEN
            COMANDO := 'INSERT INTO '|| tabela || ' (CODTAB,'|| colati || ',' || coltit || ', CODDIV, CODSUB ' || ', CODEXT) ' ||
                       'VALUES (' || TO_CHAR(WK_COD) ||','||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)|| cTitulo||chr(39)|| ', '|| divisa || ',' || subdiv || ', TRIM('|| chr(39)||p_CODEXT||chr(39) ||'))';
         ELSE
            COMANDO := 'INSERT INTO '|| tabela || ' (CODTAB,'|| colati || ',' || coltit || ', CODDIV, CODSUB ' || ') ' ||
                       'VALUES (' || TO_CHAR(WK_COD) ||','||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)|| cTitulo||chr(39)|| ', '|| divisa || ',' || subdiv || ')';
         END IF;
                  
            EXECUTE COMANDO;
         
      ELSIF tabela = 'TD_INA' THEN
         COMANDO := 'INSERT INTO '|| tabela || ' (CODTAB,' || colati ||',' || coltit || ',USOINA) ' ||
                           'VALUES (' || TO_CHAR(WK_COD) ||','||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)||cTitulo||chr(39)||', '||chr(39)||wk_usoina||chr(39)||')';
                  
            EXECUTE COMANDO;
               ELSIF tabela = 'TD_DOC' THEN
         COMANDO := 'INSERT INTO '|| tabela || ' (TIPDOC, CODTAB,' || colati ||',' || coltit || ') ' ||
                           'VALUES (' ||chr(39)||PTIPDOC||chr(39)||', '||TO_CHAR(WK_COD) ||','||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)||cTitulo||chr(39)||')';
                  
            EXECUTE COMANDO;
               ELSIF tabela = 'TD_MED' THEN
         SELECT count(*), MAX(CODTAB)
           INTO WK_MED_COUNT, WK_MED_CODTAB
           FROM TD_MED
          WHERE UNIMED = TITULO;
         IF WK_MED_COUNT <> 0 THEN
            WK_COD := WK_MED_CODTAB;
         ELSE
         COMANDO := 'INSERT INTO '|| tabela || ' (CODTAB,' || colati ||',' || coltit ||  ',' || COLTIT2 ||') ' ||
                           'VALUES (' || TO_CHAR(WK_COD) ||','||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)||cTitulo||chr(39)||', '||chr(39)||cTitulo2||chr(39)||')';
                  
            EXECUTE COMANDO;
                  END IF;
      ELSIF tabela = 'TD_ETI' THEN
         SELECT count(*), MAX(CODTAB)
           INTO WK_MED_COUNT, WK_MED_CODTAB
           FROM TD_ETI
          WHERE DESETI = TITULO;
         IF WK_MED_COUNT <> 0 THEN
            WK_COD := WK_MED_CODTAB;
         ELSE
         COMANDO := 'INSERT INTO '|| tabela || ' (CODTAB,' || colati ||',' || coltit || ') ' ||
                           'VALUES (' || TO_CHAR(WK_COD) ||','||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)||cTitulo||chr(39)||')';
                  
            EXECUTE COMANDO;
                  END IF;
      ELSIF tabela = 'TD_CL2' THEN
         SELECT count(*), MAX(CODTAB)
           INTO WK_MED_COUNT, WK_MED_CODTAB
           FROM TD_CL2
          WHERE CLASS2 = TITULO;
         IF WK_MED_COUNT <> 0 THEN
            WK_COD := WK_MED_CODTAB;
         ELSE
         COMANDO := 'INSERT INTO '|| tabela || ' (CODTAB,' || colati ||',' || coltit || ') ' ||
                           'VALUES (' || TO_CHAR(WK_COD) ||','||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)||cTitulo||chr(39)||')';
                  
            EXECUTE COMANDO;
                  END IF;
      ELSIF tabela = 'TD_CCC' THEN
         wk_seqcta := ProximaConta(lpad(trim(ptipdoc),3,'0'),titulo,'N','L','N');
         WK_TIPCCC := 'N';
         WK_CLILIV := 'F';
         WK_COMCCC := 'F';
         WK_CTACCC := 'L';
         IF p_CODEXT IS NOT NULL THEN 
            COMANDO := 'INSERT INTO '|| tabela || ' (TIPCCC, CODTAB,' || colati ||',' || coltit || ',SEQCCC, FILCCC, CLILIV, COMCCC, CTACCC, CODEXT_DCCC) ' ||
                           'VALUES (' ||chr(39)||WK_TIPCCC||chr(39)||', '||TO_CHAR(WK_COD) ||','||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)||cTitulo||chr(39)||', '||chr(39)||wk_seqcta||chr(39)||', '||chr(39)||lpad(trim(ptipdoc),3,'0')||chr(39)||', '||chr(39)||wk_cliliv||chr(39)||', '||chr(39)||wk_comccc||chr(39)||', '||chr(39)||wk_ctaccc||chr(39)||', ' || chr(39)||p_CODEXT||chr(39) ||')';
         ELSE
            COMANDO := 'INSERT INTO '|| tabela || ' (TIPCCC, CODTAB,' || colati ||',' || coltit || ',SEQCCC, FILCCC, CLILIV, COMCCC, CTACCC) ' ||
                           'VALUES (' ||chr(39)||WK_TIPCCC||chr(39)||', '||TO_CHAR(WK_COD) ||','||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)||cTitulo||chr(39)||', '||chr(39)||wk_seqcta||chr(39)||', '||chr(39)||lpad(trim(ptipdoc),3,'0')||chr(39)||', '||chr(39)||wk_cliliv||chr(39)||', '||chr(39)||wk_comccc||chr(39)||', '||chr(39)||wk_ctaccc||chr(39)||')';
         END IF;
                  
            EXECUTE COMANDO;
               ELSIF tabela = 'TD_END' THEN
         COMANDO := 'INSERT INTO '|| tabela || ' (USOEND, DUPEND, CODTAB,' || colati ||',' || coltit || ') ' ||
                           'VALUES ('||chr(39)||WK_USOEND||chr(39)||','||chr(39)||WK_DUPEND||chr(39)||','|| TO_CHAR(WK_COD) ||','||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)||cTitulo||chr(39)||')';
                  
            EXECUTE COMANDO;
               ELSIF tabela = 'TD_CFO' THEN
         COMANDO := 'INSERT INTO '|| tabela || ' (CODTAB,' ||COLTIT2||','|| colati ||',' || coltit || ') ' ||
                    'VALUES (' || TO_CHAR(WK_COD) ||','||chr(39)||coalesce(cTITULO2,cTitulo)||chr(39)||','||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)||cTitulo||chr(39)||')';
                  
            EXECUTE COMANDO;
               ELSIF tabela = 'TD_LPC' THEN
         COMANDO := 'INSERT INTO '|| tabela || ' (CODTAB,' || colati ||',' || coltit || ',' || coltit2 || ') ' ||
                    'VALUES (' || TO_CHAR(WK_COD) ||','||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)||cTitulo||chr(39)||', '||chr(39)||ctitulo2||chr(39)||')';
                  
            EXECUTE COMANDO;
               ELSIF tabela = 'TD_SAZ' THEN
         COMANDO := 'INSERT INTO '|| tabela || ' (CODTAB,SAZ001,' || colati ||',' || coltit || ') ' ||
                    'VALUES (' || TO_CHAR(WK_COD) ||',100,'||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)||ctitulo||chr(39)||')';
                  
            EXECUTE COMANDO;
               ELSIF tabela = 'TD_IRE' THEN
         /* Importao da tabela foi descontinuado da funo pois foi implementado uma funo especifica "IMPORTA_DIRE" mantido apenas para evitar erros de quebra que compatibilidade */
         COMANDO := 'INSERT INTO '|| tabela || ' (CODTAB,' || colati ||',' || coltit ||
                    CASE WHEN ISNOTNULL(TITULO2) = 'T'
                         THEN ',' || coltit2
                         ELSE ''
                    END ||
                    ') ' ||
                    'VALUES (' || TO_CHAR(WK_COD) ||', '||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)||ctitulo||chr(39)||
                    CASE WHEN ISNOTNULL(TITULO2) = 'T'
                         THEN ', ' || titulo2
                         ELSE ''
                    END ||
                    ')';
                  
            EXECUTE COMANDO;
               ELSIF tabela = 'TD_CTR' THEN
         WK_CTRTIP := 'G';
         WK_CTRUSO := 'L';
         wk_seqcta := ProximaConta(lpad(trim(ptipdoc),3,WK_CTRUSO),titulo,WK_CTRTIP,WK_CTRUSO,null);
         COMANDO := 'INSERT INTO '|| tabela || ' (CODTAB,CTRTIP,CTRUSO,CTRFIL,CTRSEQ,TIPPRA,FILPRA,SEQPRA,' || colati ||',' || coltit || ') ' ||
                    'VALUES (' || TO_CHAR(WK_COD)||','||chr(39)||WK_CTRTIP||chr(39)||','||chr(39)||WK_CTRUSO||chr(39)||','||chr(39)||ptipdoc||chr(39)||',' ||chr(39)||wk_seqcta||chr(39)||
                                          ','||chr(39)||WK_CTRTIP||chr(39)||','||chr(39)||ptipdoc||chr(39)||',' ||chr(39)||wk_seqcta||chr(39)||','||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)||ctitulo||chr(39)||')';
                  

            EXECUTE COMANDO;
               ELSIF tabela = 'TD_CT1' THEN
         IF p_CODEXT IS NOT NULL THEN
            COMANDO := 'INSERT INTO '|| tabela || ' (CODTAB,' || colati || ',' || coltit || ', CODEXT_DCT1) ' ||
                       'VALUES (' || TO_CHAR(WK_COD) ||','||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)||cTitulo||chr(39)||', '|| chr(39)||p_CODEXT||chr(39) ||')';
         ELSE
            COMANDO := 'INSERT INTO '|| tabela || ' (CODTAB,' || colati || ',' || coltit || ') ' ||
                       'VALUES (' || TO_CHAR(WK_COD) ||','||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)||cTitulo||chr(39)||')';
         END IF;
                  
            EXECUTE COMANDO;
               ELSIF tabela = 'TD_CT2' THEN
         IF p_CODEXT IS NOT NULL THEN
            COMANDO := 'INSERT INTO '|| tabela || ' (CODTAB,' || colati || ',' || coltit || ', CODEXT_DCT2) ' ||
                       'VALUES (' || TO_CHAR(WK_COD) ||','||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)||cTitulo||chr(39)||', '|| chr(39)||p_CODEXT||chr(39) ||')';
         ELSE
            COMANDO := 'INSERT INTO '|| tabela || ' (CODTAB,' || colati || ',' || coltit || ') ' ||
                       'VALUES (' || TO_CHAR(WK_COD) ||','||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)||cTitulo||chr(39)||')';
         END IF;
                  
            EXECUTE COMANDO;
               ELSIF tabela = 'TD_CT3' THEN
         IF p_CODEXT IS NOT NULL THEN
            COMANDO := 'INSERT INTO '|| tabela || ' (CODTAB,' || colati || ',' || coltit || ', CODEXT_DCT3) ' ||
                       'VALUES (' || TO_CHAR(WK_COD) ||','||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)||cTitulo||chr(39)||', '|| chr(39)||p_CODEXT||chr(39) ||')';
         ELSE
            COMANDO := 'INSERT INTO '|| tabela || ' (CODTAB,' || colati || ',' || coltit || ') ' ||
                       'VALUES (' || TO_CHAR(WK_COD) ||','||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)||cTitulo||chr(39)||')';
         END IF;
                  
            EXECUTE COMANDO;
               ELSE
         COMANDO := 'INSERT INTO '|| tabela || ' (CODTAB,' || colati ||',' || coltit || ') ' ||
                    'VALUES (' || TO_CHAR(WK_COD) ||','||chr(39)||WK_ATIVO||chr(39)||', '||chr(39)||ctitulo||chr(39)||')';
                  
            EXECUTE COMANDO;
               END IF;
   --------------------------------------------------------------------------------------
   -- 2. Alterao da descrio para registros que usam CODEXT
   --------------------------------------------------------------------------------------
   ELSE

      -- RFMP 93998
      IF p_CODEXT IS NOT NULL THEN
         IF TABELA IN ('TD_GRA','TD_DIV','TD_SUB') THEN
            COMANDO := 'UPDATE '|| tabela ||
                       '   SET '|| coltit ||' = '|| chr(39)||ctitulo||chr(39) ||' ' ||
                       ' WHERE CODEXT = TRIM(' || chr(39)||p_CODEXT||chr(39) ||') '||
                       '   AND '|| coltit ||' <> '|| chr(39)||ctitulo||chr(39) ||' ';
                        
            EXECUTE COMANDO;
                     ELSIF tabela = 'TD_CCC' THEN
            COMANDO := 'UPDATE '|| tabela ||
                       '   SET '|| coltit ||' = '|| chr(39)||ctitulo||chr(39) ||' ' ||
                       ' WHERE CODEXT_DCCC = ' || chr(39)||p_CODEXT||chr(39) ||
                       '   AND '|| coltit ||' <> '|| chr(39)||ctitulo||chr(39) ||' ';
                        
            EXECUTE COMANDO;
                     ELSIF tabela = 'TD_CT1' THEN
            IF (cTitulo IS NOT NULL) THEN
               COMANDO := 'UPDATE '|| tabela ||
                          '   SET '|| coltit ||' = '|| chr(39)||ctitulo||chr(39) ||' ' ||
                          ' WHERE CODEXT_DCT1 = ' || chr(39)||p_CODEXT||chr(39) ||
                          '   AND '|| coltit ||' <> '|| chr(39)||ctitulo||chr(39) ||' ';
                              
               EXECUTE COMANDO;
                           END IF;
         ELSIF tabela = 'TD_CT2' THEN
            IF (cTitulo IS NOT NULL) THEN
               COMANDO := 'UPDATE '|| tabela ||
                          '   SET '|| coltit ||' = '|| chr(39)||ctitulo||chr(39) ||' ' ||
                          ' WHERE CODEXT_DCT2 = ' || chr(39)||p_CODEXT||chr(39) ||
                          '   AND '|| coltit ||' <> '|| chr(39)||ctitulo||chr(39) ||' ';
                              
               EXECUTE COMANDO;
                           END IF;
         ELSIF tabela = 'TD_CT3' THEN
            IF (cTitulo IS NOT NULL) THEN
               COMANDO := 'UPDATE '|| tabela ||
                          '   SET '|| coltit ||' = '|| chr(39)||ctitulo||chr(39) ||' ' ||
                          ' WHERE CODEXT_DCT3 = ' || chr(39)||p_CODEXT||chr(39) ||
                          '   AND '|| coltit ||' <> '|| chr(39)||ctitulo||chr(39) ||' ';
                              
               EXECUTE COMANDO;
                           END IF;
         END IF;
      END IF;

   END IF;
   RETURN WK_COD;
END;
$$ language 'plpgsql';


/*-- SEQ 1374 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_TDS (VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,Numeric,Numeric,VARCHAR) CASCADE;

/*-- SEQ 1375 --*/
CREATE OR REPLACE FUNCTION IMPORTA_TDS (VARCHAR,
                               VARCHAR,
                               VARCHAR,
                               VARCHAR,
                               VARCHAR,
                               Numeric,
                               Numeric,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN IMPORTA_TDS($1,$2,$3,$4,$5,$6,$7,$8,NULL,NULL,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1376 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_TDS (VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,Numeric,Numeric,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1377 --*/
CREATE OR REPLACE FUNCTION IMPORTA_TDS (VARCHAR,
                               VARCHAR,
                               VARCHAR,
                               VARCHAR,
                               VARCHAR,
                               Numeric,
                               Numeric,
                               VARCHAR,
                               VARCHAR,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN IMPORTA_TDS($1,$2,$3,$4,$5,$6,$7,$8,$9,$10,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1378 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION JurosDescontos (VARCHAR,TT_PAG.CODFIL%TYPE,TT_PAG.SEQUEN%TYPE,TT_PAG.NUMPAR%TYPE,TT_PAG.SUBPAR%TYPE,TT_PAG.FLGEST%TYPE) CASCADE;

/*-- SEQ 1379 --*/
CREATE OR REPLACE FUNCTION JurosDescontos (VARCHAR,TT_PAG.CODFIL%TYPE,TT_PAG.SEQUEN%TYPE,TT_PAG.NUMPAR%TYPE,TT_PAG.SUBPAR%TYPE,TT_PAG.FLGEST%TYPE)
RETURNS Numeric AS $$
DECLARE
cTabela ALIAS FOR $1 ;
cCodfil ALIAS FOR $2 ;
cSequen ALIAS FOR $3 ;
nNumpar ALIAS FOR $4 ;
nSubPar ALIAS FOR $5 ;
cTipo ALIAS FOR $6 ;
  nJurDesAteAtual Numeric;
  nJurDesAteAnterior Numeric;
  nJurDes Numeric;
  nMaxSubPar Numeric;

begin

  nJurDesAteAtual := 0;
  nJurDesAteAnterior := 0;
  nMaxSubPar := 0;

  IF cTabela = 'PAG' THEN 
     SELECT SUM(CASE PAG.FLGEST WHEN 'P' THEN PAG.VLRPGT
                                ELSE PAG.VLRPAR
                END) - MIN(ORI.VLRPAR) INTO nJurDesAteAtual
       FROM TT_PAG ORI, TT_PAG PAG
      WHERE PAG.FLGEST NOT IN ('X','C')
        AND ORI.FLGEST NOT IN ('X','C') ---42374
        AND ORI.CODFIL = PAG.CODFIL
        AND ORI.SEQUEN = PAG.SEQUEN
        AND ORI.NUMPAR = PAG.NUMPAR
        AND ORI.SUBPAR =  ' 0'
        AND PAG.CODFIL = cCodFil
        AND PAG.SEQUEN = cSequen
        AND PAG.NUMPAR = nNumPar
        AND PAG.SUBPAR <= nSubPar;    
     SELECT SUM(CASE PAG.FLGEST WHEN 'P' THEN PAG.VLRPGT
                                ELSE PAG.VLRPAR
                END) - MIN(ORI.VLRPAR) INTO nJurDesAteAnterior
       FROM TT_PAG ORI, TT_PAG PAG
      WHERE PAG.FLGEST NOT IN ('X','C')
        AND ORI.FLGEST NOT IN ('X','C') ---42374
        AND ORI.CODFIL = PAG.CODFIL
        AND ORI.SEQUEN = PAG.SEQUEN
        AND ORI.NUMPAR = PAG.NUMPAR
        AND ORI.SUBPAR =  ' 0'
        AND PAG.CODFIL = cCodFil
        AND PAG.SEQUEN = cSequen
        AND PAG.NUMPAR = nNumPar
        AND PAG.SUBPAR < nSubPar;    
     SELECT MAX(PAG.SUBPAR) INTO nMaxSubPar
       FROM TT_PAG PAG
      WHERE PAG.FLGEST NOT IN ('X','C')
        AND PAG.CODFIL = cCodFil
        AND PAG.SEQUEN = cSequen
        AND PAG.NUMPAR = nNumPar;

  ELSIF cTabela = 'REC' THEN

     -- No form de ajuste de parcelas, quando se dividia a parcela em mais de uma, nao gerava nova parcela e sim uma sub-parcela.
     -- Isto foi corrigido, porem ha casos onde a base nao havia como alterar. Para que isto nao fosse considerado juros, tratou-se]
     -- especificamente o caso onde se divide o valor original em 2 sub-parcelas (que era a maioria) como nao sendo juros.
     -- Este  o unico motivo que se l a parcela anterior e se verifica se a mesma esta cancelada, e se o valor corresponde a soma
     -- das duas sub-parcelas seguintes (TT_REC atual e sub-parcela imediata).

     nJurDesAteAnterior := 0;

--     select case when rec.flgest not in ('X','C')
--                 then case when coalesce(round(ant.vlrpar),0) = round(rec.vlrpar,0) + coalesce(round(sub.vlrpar,0),0)
--                           then rec.vlrpar-rec.vlrpgt
--                           else rec.vlrpar-coalesce(sub.vlrpar,0)-rec.vlrpgt 
--                      end
--                 else 0
--            end * -1 into nJurDesAteAtual
--     from tt_ven ven inner join tt_rec rec on rec.codfil = ven.codfil
--                                          and rec.sequen = ven.sequen
--                           left join tt_rec sub on sub.codfil = rec.codfil 
--                                               and sub.sequen = rec.sequen
--                                               and sub.numpar = rec.numpar 
----                                               and sub.subpar = substr(to_char(to_number(rec.subpar)+1,'99'),2)
--                           left join tt_rec ant on ant.codfil = rec.codfil 
--                                               and ant.sequen = rec.sequen
--                                               and ant.numpar = rec.numpar 
--                                               and ant.subpar = substr(to_char(to_number(rec.subpar)-1,'99'),2)
--                                               and ant.flgest = 'C'
--      WHERE REC.CODFIL = cCodFil
--        AND REC.SEQUEN = cSequen
--        AND REC.NUMPAR = nNumPar
--        AND REC.SUBPAR = nSubPar;    

     SELECT REC.VLRDES INTO nJurDesAteAtual   --41735
       FROM TT_REC REC
      WHERE REC.CODFIL = cCodFil
        AND REC.SEQUEN = cSequen
        AND REC.NUMPAR = nNumPar
        AND REC.SUBPAR = nSubPar;


  ELSIF cTabela = 'CAR' THEN
     SELECT SUM(CASE REC.FLGEST WHEN 'P' THEN REC.VLRPGT
                                ELSE REC.VLRDES
     END) - MIN(CASE REC.FLGEST WHEN 'P' THEN ORI.VLRPAR
                                ELSE 0
                END) INTO nJurDesAteAtual
       FROM TT_REC ORI, TT_REC REC
      WHERE REC.FLGEST NOT IN ('X','C')
        AND ORI.CODFIL = REC.CODFIL
        AND ORI.SEQUEN = REC.SEQUEN
        AND ORI.NUMPAR = REC.NUMPAR
        AND ORI.SUBPAR =  ' 0'
        AND REC.CODFIL = cCodFil
        AND REC.SEQUEN = cSequen
        AND REC.NUMPAR = nNumPar
        AND REC.SUBPAR <= nSubPar;
     SELECT SUM(CASE REC.FLGEST WHEN 'P' THEN REC.VLRPGT
                                ELSE REC.VLRDES
     END) - MIN(CASE REC.FLGEST WHEN 'P' THEN ORI.VLRPAR
                                ELSE 0
                END) INTO nJurDesAteAnterior
       FROM TT_REC ORI, TT_REC REC
      WHERE REC.FLGEST NOT IN ('X','C')
        AND ORI.CODFIL = REC.CODFIL
        AND ORI.SEQUEN = REC.SEQUEN
        AND ORI.NUMPAR = REC.NUMPAR
        AND ORI.SUBPAR =  ' 0'
        AND REC.CODFIL = cCodFil
        AND REC.SEQUEN = cSequen
        AND REC.NUMPAR = nNumPar
        AND REC.SUBPAR < nSubPar;
     SELECT MAX(REC.SUBPAR) INTO nMaxSubPar
       FROM TT_REC REC
      WHERE REC.FLGEST NOT IN ('X','C')
        AND REC.CODFIL = cCodFil
        AND REC.SEQUEN = cSequen
        AND REC.NUMPAR = nNumPar;

  ELSIF cTabela = 'PTR' THEN 
     SELECT SUM(CASE PTR.FLGEST WHEN 'P' THEN PTR.VLRPGT 
                                ELSE PTR.VLRPAR
                END) - MIN(ORI.VLRPAR) INTO nJurDesAteAtual
       FROM TT_PTR ORI, TT_PTR PTR
      WHERE PTR.FLGEST NOT IN ('X','C')
        AND ORI.CODFIL = PTR.CODFIL
        AND ORI.SEQUEN = PTR.SEQUEN
        AND ORI.NUMPAR = PTR.NUMPAR
        AND ORI.SUBPAR =  ' 0'
        AND PTR.CODFIL = cCodFil
        AND PTR.SEQUEN = cSequen
        AND PTR.NUMPAR = nNumPar
        AND PTR.SUBPAR <= nSubPar;    
     SELECT SUM(CASE PTR.FLGEST WHEN 'P' THEN PTR.VLRPGT
                                ELSE PTR.VLRPAR
                END) - MIN(ORI.VLRPAR) INTO nJurDesAteAnterior
       FROM TT_PTR ORI, TT_PTR PTR
      WHERE PTR.FLGEST NOT IN ('X','C')
        AND ORI.CODFIL = PTR.CODFIL
        AND ORI.SEQUEN = PTR.SEQUEN
        AND ORI.NUMPAR = PTR.NUMPAR
        AND ORI.SUBPAR =  ' 0'
        AND PTR.CODFIL = cCodFil
        AND PTR.SEQUEN = cSequen
        AND PTR.NUMPAR = nNumPar
        AND PTR.SUBPAR < nSubPar;    
     SELECT MAX(PTR.SUBPAR) INTO nMaxSubPar
       FROM TT_PTR PTR
      WHERE PTR.FLGEST NOT IN ('X','C')
        AND PTR.CODFIL = cCodFil
        AND PTR.SEQUEN = cSequen
        AND PTR.NUMPAR = nNumPar;
  END IF;
  
  nJurDesAteAtual    := COALESCE(nJurDesAteAtual,0);
  nJurDesAteAnterior := COALESCE(nJurDesAteAnterior,0);

  IF nJurDesAteAnterior < 0 THEN
     nJurDesAteAnterior := 0;
  END IF;
  IF (nJurDesAteAtual < 0) AND (TO_NUMBER(nSubPar) < nMaxSubPar) THEN
     nJurDesAteAtual := 0;
     nJurDesAteAnterior := 0;
  END IF;

  IF cTabela = 'PAG' THEN
     nJurDes := (nJurDesAteAtual-nJurDesAteAnterior)*-1;
     IF ((cTipo = 'D') and (nJurDes < 0))
     OR ((cTipo = 'J') and (nJurDes > 0)) THEN
        nJurDes := 0;
     END IF;
  ELSIF cTabela in ('REC','PTR') THEN
     nJurDes := (nJurDesAteAtual-nJurDesAteAnterior);
     IF ((cTipo = 'D') and (nJurDes > 0))
     OR ((cTipo = 'J') and (nJurDes < 0)) THEN
        nJurDes := 0;
     END IF;
  ELSIF cTabela = 'CAR' THEN
     nJurDes := ABS(nJurDesAteAtual-nJurDesAteAnterior)*-1;
     IF ((cTipo = 'D') and (nJurDes < 0))
     OR ((cTipo = 'J') and (nJurDes > 0)) THEN
        nJurDes := 0;
     END IF;
  END IF;
  return nJurDes;
END;
$$ language 'plpgsql';


/*-- SEQ 1380 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION JurosDescontos (VARCHAR,TT_PAG.CODFIL%TYPE,TT_PAG.SEQUEN%TYPE,TT_PAG.NUMPAR%TYPE,TT_PAG.SUBPAR%TYPE) CASCADE;

/*-- SEQ 1381 --*/
CREATE OR REPLACE FUNCTION JurosDescontos (VARCHAR,
                               TT_PAG.CODFIL%TYPE,
                               TT_PAG.SEQUEN%TYPE,
                               TT_PAG.NUMPAR%TYPE,
                               TT_PAG.SUBPAR%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN JurosDescontos($1,$2,$3,$4,$5,'A');
END;
$$ language 'plpgsql';


/*-- SEQ 1382 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ListaDOP (TT_DOP.CODFIL%TYPE,TT_DOP.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1383 --*/
CREATE OR REPLACE FUNCTION ListaDOP (TT_DOP.CODFIL%TYPE,TT_DOP.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
  linha   VARCHAR(4000);
  retorno VARCHAR(4000);
  buffer  VARCHAR(32767);
  c_LF    CHAR(2) := chr(13)||chr(10);
 
  Funcao CURSOR FOR
  SELECT  'Filial da Compra: ' || COALESCE(COM.CODFIL,'') || '   '
           || '  Filial/Codigo do Parceiro: ' || COALESCE(COM.FILFOR,'') || '/' || lTrim(COALESCE(COM.CODFOR,''))
           || '   Documento: ' || COALESCE(COM.CODSER,'') || '/' || lTrim(COALESCE(COM.SUBSER,'')) || '-' || lTrim(COALESCE(COM.NUMNOT,''))
           || '  -  Parcela: ' || COALESCE(PAG.NUMPAR,'')
           || '  -  SubParcela: '  || COALESCE(PAG.SUBPAR,'')
           || '  -  Valor:  ' || LPAD( LTRIM(REPLACE(REPLACE(REPLACE(TO_CHAR(PAG.VLRPAR, '999,999,999,999.99'),',','X'),'.',','),'X','.')) , 18)
           AS DOCUME
      FROM TT_PAG PAG INNER JOIN TT_COM COM ON COM.CODFIL = PAG.CODFIL AND COM.SEQUEN = PAG.SEQUEN
     WHERE PAG.FILDOP = PCODFIL
       AND PAG.SEQDOP = PSEQUEN;

 
BEGIN
  buffer  := '';
  retorno := '';
  OPEN funcao;
  LOOP
    FETCH funcao into linha;
    EXIT WHEN NOT FOUND;
    buffer := buffer || linha ||c_LF;
  END LOOP;
  Close Funcao;
 
  IF Length(buffer) > 4000 THEN
    retorno := Substr(buffer,1,3977)||C_lf||'** Vrias parcelas **';
  ELSE
    retorno := buffer;
  END IF;
 
  Return retorno;
END;
$$ language 'plpgsql';





/*-- SEQ 1384 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Livre (TD_FIL.CODFIL%TYPE,VARCHAR,Timestamp) CASCADE;

/*-- SEQ 1385 --*/
CREATE OR REPLACE FUNCTION Livre (TD_FIL.CODFIL%TYPE,VARCHAR,Timestamp)
RETURNS Numeric AS $$
DECLARE
Filial ALIAS FOR $1 ;
tabela ALIAS FOR $2 ;
Quando ALIAS FOR $3 ;
-- Objetivo:
-- 1) Informar se a tabela pode sofrer lancamentos de
--   acordo com o que consta no Totall 2000 License
--
-- Principal
begin
  -- Utiliza o PROTEQ
  Return 1;
END;
$$ language 'plpgsql';




/*-- SEQ 1386 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION LocalDado () CASCADE;

/*-- SEQ 1387 --*/
CREATE OR REPLACE FUNCTION LocalDado ()
RETURNS VARCHAR AS $$
DECLARE

  c_Data constant CHAR(11) := '';
  v_Onde VARCHAR(30);
  v_Qtd  INTEGER;
BEGIN
  SELECT Count(*) INTO v_Qtd FROM TT_IDF;
  IF v_Qtd=1 THEN
    SELECT COALESCE(TBSDAT,c_Data) INTO v_Onde FROM TT_IDF;
  ELSE
    v_Onde := c_Data;
  END IF;
  RETURN v_Onde;
END;
$$ language 'plpgsql';




/*-- SEQ 1388 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION LocalIndice () CASCADE;

/*-- SEQ 1389 --*/
CREATE OR REPLACE FUNCTION LocalIndice ()
RETURNS VARCHAR AS $$
DECLARE

  c_Indice constant CHAR(12) := '';
  v_Onde VARCHAR(30);
  v_Qtd  INTEGER;
BEGIN
  SELECT Count(*) INTO v_Qtd FROM TT_IDF;
  IF v_Qtd=1 THEN
    SELECT COALESCE(TBSIND,c_Indice) INTO v_Onde FROM TT_IDF;
  ELSE
    v_Onde := c_Indice;
  END IF;
  RETURN v_Onde;
END;
$$ language 'plpgsql';




/*-- SEQ 1390 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION MensagensTitulo (TT_TIT.CODFIL%TYPE,TT_TIT.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1391 --*/
CREATE OR REPLACE FUNCTION MensagensTitulo (TT_TIT.CODFIL%TYPE,TT_TIT.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_CODFIL ALIAS FOR $1 ;
p_SEQUEN ALIAS FOR $2 ;
-- Objetivo
-- Retornar um campo memo, onde estaro todas as mensagens para serem impressas nos
-- Ttulos Bancrios.
  wk_codbai TT_TIT.CODBAI%TYPE;
  wk_przbai Numeric(2);
  wk_codprt TT_TIT.CODPRT%TYPE;
  wk_przprt Numeric(2);
  wk_coddes TT_TIT.CODDES%TYPE;
  wk_datdes VARCHAR(10);
  wk_jurdes Numeric(15,2);
  wk_codmor TT_TIT.CODMOR%TYPE;
  wk_datmor CHAR(10);
  wk_jurmor Numeric(15,2);
  WK_MOEDA  TD_MOE.DESMOE%TYPE;
  WK_CODBCO TT_TIT.CODBCO%TYPE;
  WK_NUMAGE TT_TIT.NUMAGE%TYPE;
  WK_CTACRR TT_TIT.CTACRR%TYPE;
  WK_DIAPRO TT_CTB.DIAPRO%TYPE;
  WK_JDIAPRO TT_CTB.DIAPRO%TYPE;
  WK_PERPRO TT_CTB.PERPRO%TYPE;
  WK_JPERPRO TT_CTB.PERPRO%TYPE;
  WK_NUMPRO TT_CTB.NUMPRO%TYPE;
  I         Numeric;
  WK_DATVEN char(10);
  WK_DATHOR char(10);
  WK_AVISTA Numeric;

begin
  SELECT CODBAI, COALESCE(PRZBAI,0),
         CODPRT, COALESCE(PRZPRT,0),
         CODDES, TO_CHAR(DATDES,'DD/MM/YYYY'), JURDES,
         CODMOR, TO_CHAR(DATMOR,'DD/MM/YYYY'), JURMOR,
         CODBCO, LPAD(NUMAGE,5,'0'), LPAD(CTACRR,10,'0')
  INTO   WK_CODBAI, WK_PRZBAI,
         WK_CODPRT, WK_PRZPRT,
         WK_CODDES, WK_DATDES, WK_JURDES,
         WK_CODMOR, WK_DATMOR, WK_JURMOR,
         WK_CODBCO, WK_NUMAGE, WK_CTACRR
  FROM TT_TIT
  WHERE CODFIL = P_CODFIL
    AND SEQUEN = P_SEQUEN;

  SELECT COALESCE(MOE.DESMOE,'R$'),TO_CHAR(REC.DATVEN,'DD/MM/YYYY'),
         TO_CHAR(VEN.DATHOR,'DD/MM/YYYY')
    INTO WK_MOEDA, WK_DATVEN, WK_DATHOR
  FROM TT_TIT TIT INNER JOIN TT_REC REC ON TIT.FILREC = REC.CODFIL
                                       AND TIT.SEQREC = REC.SEQUEN
                                       AND TIT.PARREC = REC.NUMPAR
                                       AND TIT.SUBREC = REC.SUBPAR
                  INNER JOIN TD_MOE MOE ON MOE.CODTAB = REC.CODMOE
                  INNER JOIN TT_VEN VEN ON VEN.SEQUEN = REC.SEQUEN
                                       AND VEN.CODFIL = REC.CODFIL
  WHERE TIT.CODFIL = P_CODFIL
    AND TIT.SEQUEN = P_SEQUEN;

  SELECT COALESCE(DIAPRO,0), COALESCE(PERPRO,0), COALESCE(NUMPRO,0), COALESCE(AVISTA,0)
    INTO WK_DIAPRO, WK_PERPRO, WK_NUMPRO, WK_AVISTA
    FROM TT_CTB
   WHERE CODBCO = WK_CODBCO
     AND NUMAGE = WK_NUMAGE
     AND CTACRR = WK_CTACRR;
  return Aux_TrazDesconto(WK_CODDES, WK_JURDES, WK_DATDES, WK_MOEDA, WK_DIAPRO, WK_PERPRO, WK_NUMPRO, WK_AVISTA, TO_DATE(WK_DATVEN,'DD/MM/YYYY'), TO_DATE(WK_DATHOR,'DD/MM/YYYY'), WK_CODBCO, WK_NUMAGE, WK_CTACRR) ||
         Aux_TrazMora(WK_CODMOR, WK_JURMOR, WK_DATMOR, WK_MOEDA)     ||
         Aux_TrazProtesto(WK_CODPRT, WK_PRZPRT) ||
         Aux_TrazBaixa(WK_CODBAI, WK_PRZBAI)    ||
         Aux_TrazIns();
END;
$$ language 'plpgsql';




/*-- SEQ 1392 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION NaturezaVenda (TT_VEN.UFLOJA%TYPE,TT_IVE.ICMTIP%TYPE,TD_NAT.NATDEN%TYPE,TD_NAT.NATFOR%TYPE,TT_VEN.SUBSTT%TYPE) CASCADE;

/*-- SEQ 1393 --*/
CREATE OR REPLACE FUNCTION NaturezaVenda (TT_VEN.UFLOJA%TYPE,TT_IVE.ICMTIP%TYPE,TD_NAT.NATDEN%TYPE,TD_NAT.NATFOR%TYPE,TT_VEN.SUBSTT%TYPE)
RETURNS CHAR AS $$
DECLARE
p_UfLoja ALIAS FOR $1 ;
p_IcmTip ALIAS FOR $2 ;
p_NatDen ALIAS FOR $3 ;
p_NatFor ALIAS FOR $4 ;
p_VlrSub ALIAS FOR $5 ;
   cNature                       CHAR(6);
BEGIN 
   IF p_UfLoja = 'T' THEN
      IF p_IcmTip = '3' THEN
         IF SUBSTR( p_NatDen,1,4) = '5102' THEN
            IF P_VlrSub <> 0 THEN
               cNature := '5403';
            ELSE
               cNature := '5405';
            END IF;
         ELSIF SUBSTR( p_NatDen,1,4) = '1202' THEN
            cNature := '1411';
         ELSIF SUBSTR( p_NatDen,1,4) = '5152' THEN
            cNature := '5409';
         ELSIF SUBSTR( p_NatDen,1,4) = '5101' THEN
            cNature := '5401';
         ELSE
            cNature := p_NatDen;
         END IF;
      ELSE
         cNature := p_NatDen;
      END IF;
   ELSIF p_IcmTip = '3' THEN
      IF SUBSTR( p_NatFor,1,4 ) = '6102' THEN
         IF p_VlrSub <> 0 THEN
            cNature := '6403';
         ELSE
            cNature := '6404';
         END IF;
      ELSIF SUBSTR( p_NatDen,1,4) = '2202' THEN
         cNature := '2411';
      ELSIF SUBSTR( p_NatDen,1,4) = '6152' THEN
         cNature := '6409';
      ELSIF SUBSTR( p_NatDen,1,4) = '6101' THEN
         cNature := '6401';
      ELSE
         cNature := p_NatFor;
      END IF;
   ELSE
      cNature := p_NatFor;
   END IF;
   RETURN RPAD( SUBSTR(cNature,1,4),4,' ');
END;
$$ language 'plpgsql' STABLE;


/*-- SEQ 1394 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION NaturezaVenda (TT_VEN.UFLOJA%TYPE,TT_IVE.ICMTIP%TYPE,TD_NAT.NATDEN%TYPE,TD_NAT.NATFOR%TYPE);

/*-- SEQ 1395 --*/
CREATE OR REPLACE FUNCTION NaturezaVenda (TT_VEN.UFLOJA%TYPE,
                               TT_IVE.ICMTIP%TYPE,
                               TD_NAT.NATDEN%TYPE,
                               TD_NAT.NATFOR%TYPE) 
RETURNS CHAR AS $$
BEGIN
RETURN NaturezaVenda($1,$2,$3,$4,0);
END;
$$ language 'plpgsql' STABLE;


/*-- SEQ 1396 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION NotasVinculadas (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE) CASCADE;

/*-- SEQ 1397 --*/
CREATE OR REPLACE FUNCTION NotasVinculadas (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_CodFil ALIAS FOR $1 ;
p_Sequen ALIAS FOR $2 ;
p_NumIte ALIAS FOR $3 ;

-- Objetivo
-- 1) Retornar as vNotas vinculas a um item de vNota

  vVinculos VARCHAR(4000);
  vNota VARCHAR(100);
  i Numeric;

  Lista CURSOR FOR
   SELECT DISTINCT COALESCE(VEN.CODSER,'')||'/'||
                     COALESCE(VEN.NUMECF,'')||'-'||TRIM(COALESCE(VEN.NUMNOT,'')) AS Nota
   FROM TT_IVE IVE, TT_VEN VEN
   WHERE VEN.CODFIL = IVE.CODFIL
     AND VEN.SEQUEN = IVE.SEQUEN
     AND IVE.FILORI = p_CodFil
     AND IVE.NUMORI = p_Sequen
     AND IVE.ITEORI = p_NumIte
     AND IVE.SITMOV <> 'C';

-- Principal
begin
  vVinculos := '';
  i := 0;
  OPEN Lista;
  LOOP
     FETCH Lista INTO vNota;
     EXIT WHEN NOT FOUND;
     if (i = 0) then
        vVinculos := COALESCE(vNota,'');
     else
        vVinculos := COALESCE(vNota,'') || ', ' || vVinculos;
     end if;
     i := i + 1;          
        
  END LOOP;
  CLOSE Lista;    
  
  Return vVinculos;
END;
$$ language 'plpgsql';




/*-- SEQ 1398 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ObservacaoDOP (TT_DOP.CODFIL%TYPE,TT_DOP.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1399 --*/
CREATE OR REPLACE FUNCTION ObservacaoDOP (TT_DOP.CODFIL%TYPE,TT_DOP.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
  linha   VARCHAR(4000);
  retorno VARCHAR(4000);
  buffer  VARCHAR(32767);
  c_LF    CHAR(2) := chr(13)||chr(10);
 
  Funcao CURSOR FOR
    SELECT DISTINCT COM.OBSFAT
      FROM TT_PAG PAG INNER JOIN TT_COM COM ON COM.CODFIL = PAG.CODFIL AND COM.SEQUEN = PAG.SEQUEN
     WHERE PAG.FILDOP = PCODFIL
       AND PAG.SEQDOP = PSEQUEN;

 
BEGIN
  buffer  := '';
  retorno := '';
  OPEN funcao;
  LOOP
    FETCH funcao into linha;
    EXIT WHEN NOT FOUND;
    buffer := buffer || linha;
  END LOOP;
  Close Funcao;
 
  IF Length(buffer) > 4000 THEN
    retorno := Substr(buffer,1,3980)||C_lf||'** Vrias parcelas **';
  ELSE
    retorno := buffer;
  END IF;
 
  Return retorno;
END;
$$ language 'plpgsql';





/*-- SEQ 1400 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VALORPARCELAABERTA (TT_REC.FLGEST%TYPE,TT_REC.CARTAO%TYPE,TT_REC.SEQCHE%TYPE,TT_REC.VLRPAR%TYPE,VARCHAR,TT_REC.FILREC%TYPE) CASCADE;

/*-- SEQ 1401 --*/
CREATE OR REPLACE FUNCTION VALORPARCELAABERTA (TT_REC.FLGEST%TYPE,TT_REC.CARTAO%TYPE,TT_REC.SEQCHE%TYPE,TT_REC.VLRPAR%TYPE,VARCHAR,TT_REC.FILREC%TYPE)
RETURNS Numeric AS $$
DECLARE
pFLGEST ALIAS FOR $1 ;
pCARTAO ALIAS FOR $2 ;
pSEQCHE ALIAS FOR $3 ;
pVLRPAR ALIAS FOR $4 ;
pFUNCAO ALIAS FOR $5 ;
pCODFIL ALIAS FOR $6 ;

vFLGEST TT_CHR.FLGEST%TYPE;

BEGIN
   
   IF (ISNOTNULL(LTRIM(RTRIM(pCODFIL)))='T')  AND (ISNOTNULL(LTRIM(RTRIM(pSEQCHE)))='T')  THEN
     SELECT FLGEST
       INTO vFLGEST
       FROM TT_CHR
      WHERE CODFIL = pCODFIL
        AND SEQUEN = pSEQCHE;
   END IF;  

   IF (pFUNCAO = 'CARTAO') THEN
      IF (pFLGEST = 'A') AND (pCARTAO IS NOT NULL) AND (ISNULL(LTRIM(RTRIM(pSEQCHE)))='T' OR ISNULL(LTRIM(RTRIM(pSEQCHE)))='T') THEN
         RETURN COALESCE(pVLRPAR,0);
      END IF;
   ELSIF (pFUNCAO = 'CHEQUE') THEN
      IF (vFLGEST IN ('A', 'D', 'V', 'P' )) AND 
         (pCARTAO IS NULL) AND 
         (ISNOTNULL(LTRIM(RTRIM(pSEQCHE)))='T') THEN
         RETURN COALESCE(pVLRPAR,0);
      END IF;
   ELSIF (pFUNCAO = 'CARTAO_E_CHEQUE') THEN
      IF (pFLGEST = 'A') AND (pCARTAO IS NOT NULL) AND (ISNOTNULL(LTRIM(RTRIM(pSEQCHE)))='T' ) THEN
         RETURN COALESCE(pVLRPAR,0);
      END IF;
   ELSIF (pFUNCAO = 'OUTROS') THEN
      IF (pFLGEST = 'A') AND (pCARTAO IS NULL) AND (ISNULL(LTRIM(RTRIM(pSEQCHE)))='T' OR ISNULL(LTRIM(RTRIM(pSEQCHE)))='T') THEN
         RETURN COALESCE(pVLRPAR,0);
      END IF;
   ELSE
      -- improvvel, mas...
      RETURN 0;
   END IF;

   RETURN 0; /* se tudo mais falhar */
END;
$$ language 'plpgsql';




/*-- SEQ 1402 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PermissaoProjeto (TT_PRJ.CODFIL%TYPE,TT_PRJ.SEQUEN%TYPE,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1403 --*/
CREATE OR REPLACE FUNCTION PermissaoProjeto (TT_PRJ.CODFIL%TYPE,TT_PRJ.SEQUEN%TYPE,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
p_Filial ALIAS FOR $1 ;
p_Codigo ALIAS FOR $2 ;
p_Quem ALIAS FOR $3 ;
p_Onde ALIAS FOR $4 ;
BEGIN
  RETURN 1;
END;
$$ language 'plpgsql';


/*-- SEQ 1404 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PermissaoProjeto (TT_PRJ.CODFIL%TYPE,TT_PRJ.SEQUEN%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1405 --*/
CREATE OR REPLACE FUNCTION PermissaoProjeto (TT_PRJ.CODFIL%TYPE,
                               TT_PRJ.SEQUEN%TYPE,
                               VARCHAR) 
RETURNS VARCHAR AS $$
BEGIN
RETURN PermissaoProjeto($1,$2,$3,null);
END;
$$ language 'plpgsql';


/*-- SEQ 1406 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PermissaoProjeto (TT_PRJ.CODFIL%TYPE,TT_PRJ.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1407 --*/
CREATE OR REPLACE FUNCTION PermissaoProjeto (TT_PRJ.CODFIL%TYPE,
                               TT_PRJ.SEQUEN%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN PermissaoProjeto($1,$2,null,null);
END;
$$ language 'plpgsql';



/*-- SEQ 1408 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PONTODEPEDIDO (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_GRA.GRAABC%TYPE,TT_GRA.GRAXYZ%TYPE,TD_NIV.FATNIV%TYPE,TT_PXF.MEDENT%TYPE,TT_PXF.DP_ENT%TYPE,VARCHAR,Timestamp,Timestamp,Timestamp,INTEGER) CASCADE;

/*-- SEQ 1409 --*/
CREATE OR REPLACE FUNCTION PONTODEPEDIDO (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_GRA.GRAABC%TYPE,TT_GRA.GRAXYZ%TYPE,TD_NIV.FATNIV%TYPE,TT_PXF.MEDENT%TYPE,TT_PXF.DP_ENT%TYPE,VARCHAR,Timestamp,Timestamp,Timestamp,INTEGER)
RETURNS VARCHAR AS $$
DECLARE
pFilMat ALIAS FOR $1 ;
pCodMat ALIAS FOR $2 ;
pCodCor ALIAS FOR $3 ;
pCodTam ALIAS FOR $4 ;
pGraABC ALIAS FOR $5 ;
pGraXYZ ALIAS FOR $6 ;
pFatniv ALIAS FOR $7 ;
pMedent ALIAS FOR $8 ;
pDp_ent ALIAS FOR $9 ;
pCodFil ALIAS FOR $10 ;
pDatIni ALIAS FOR $11 ;
pDatFim ALIAS FOR $12 ;
pDatEst ALIAS FOR $13 ;
pTipoProjecao ALIAS FOR $14 ;
--  --------------------------------------------------------
--  Funcao que retorna Ponto de Pedido do periodo informado para um determinado produto, como:
--      periodo de vendas a ser avaliado, dia para manter estoque, Prazo ABCXYZ da Filial e 
--      Estoque de Segurança.
--      Estas informacoes sao uteis e comuns para calculos do ponto de pedido, etc.,
--      e por isso foram centralizadas aqui, de forma a reaproveitar e centralizar os codigos,
--      facilitando a manutencao.
--
--  Return [VARCHAR(500)] 
--      Esta funcao retorna uma string com uma lista de varias informacoes, separadas pelo sina de
--      ponto e virgula (;) para serem utilizadas em outros calculos. Caso um valor seja nulo sera
--      retornado como uma string vazia. Seguem abaixo os valores retornados:
--
--      - Data Inicial do Periodo (wdIni) no formato [DD/MM/YYYY HH24:MI:SS];
--      - Data Final do Periodo (wdFim) no formato [DD/MM/YYYY HH24:MI:SS];
--      - Data para Manter Estoque (wdEstoque) no formato [DD/MM/YYYY];
--      - Prazo ABCXYZ da Filial (wiPrazo_Compra_ABCXYZ) no formato [000];
--      - Estoque de Segurança (wfEstSeg) no formato [000000000000000.0000];
--
--      NOTA: recomenda-se o uso da funcao Split_Part, e suas derivadas, para facilitar a leitura e
--      utilizacao dos valores da lista retornada. Mais informacoes sobre Split_Part em:
--      http://intra.totall.com.br:8080/wiki/index.php/Split_part
--
--  @pFilMat [char(3)]
--      Codigo da filial do material do produto (TT_GRA);
--  @pCodMat [VARCHAR(5)]
--      Codigo do material do produto (TT_GRA);
--  @pCodCor [Numeric(5)]
--      Codigo da cor do produto (TT_GRA);
--  @pCodTam [Numeric(5)]
--      Codigo do tamanho do produto (TT_GRA);
--  @pGraABC
--      Classificação ABC do produto (TT_GRA);
--  @pGraXYZ
--      Classificação XYA do produto (TT_GRA);
--  @pFatniv
--      Fator de serviço cadastrado para o produto (TD_NIV);
--  @pMedent
--      Tempo de ressuprimento do Fornecedor (TT_PXF);
--  @pDp_ent
--      Desvio padrão do recebimento da mercadoria do Fornecedor (TT_PXF);
--  @pCodFil [VARCHAR]
--      Lista de filial (TD_FIL);
--  @pDatIni [Timestamp]
--      Data inicial do periodo no formato DD/MM/YYYY. As horas serao desprezadas e redefinidas como 00:00:00;
--  @pDatFim [Timestamp]
--      Data final do periodo no formato DD/MM/YYYY. As horas serao desprezadas e redefinidas como 23:59:59;
--  @pDatEst [Timestamp]
--      Data para Manter Estoque no formato DD/MM/YYYY.
--  @pTipoProjecao [INTEGER]
--      0 - Estoque Mínimo, 1 - Ponto de Pedido, 2 - Média do Período Anterior, 3 - Mesmo Período do Ano Anterior, 
--      4 - Sazonalidade, 5 - Estoque Gôndola, 6 - Estoque Máximo
--  --------------------------------------------------------
   wvResult                      VARCHAR(500);       -- Retorno da Função
   wdIni                         Timestamp;               -- data inicial do periodo com as horas
   wdFim                         Timestamp;               -- data final do periodo com as horas
   wdEstoque                     Timestamp;               -- data manter estoque até  

   wcCodDep                      TT_IDF.CODDEP%TYPE; -- Filial de Deposito
   wcRegra_Media_Vendas          TT_CFG.REGRA_MEDIA_VENDAS%TYPE; --Regra para Calcular a Média de Vendas no Ponto de Pedido    
   wfEstSeg                      Numeric;               -- Calculo do Estoque de Segurança     
   wfFil_XA                      TD_FIL.PRAZO_COMPRA_XA%TYPE; -- Prazo XA da Filial
   wfFil_XB                      TD_FIL.PRAZO_COMPRA_XB%TYPE; -- Prazo XB da Filial
   wfFil_XC                      TD_FIL.PRAZO_COMPRA_XC%TYPE; -- Prazo XC da Filial    
   wfFil_YA                      TD_FIL.PRAZO_COMPRA_YA%TYPE; -- Prazo YA da Filial
   wfFil_YB                      TD_FIL.PRAZO_COMPRA_YB%TYPE; -- Prazo YB da Filial
   wfFil_YC                      TD_FIL.PRAZO_COMPRA_YC%TYPE; -- Prazo YC da Filial    
   wfFil_ZA                      TD_FIL.PRAZO_COMPRA_ZA%TYPE; -- Prazo ZA da Filial
   wfFil_ZB                      TD_FIL.PRAZO_COMPRA_ZB%TYPE; -- Prazo ZB da Filial
   wfFil_ZC                      TD_FIL.PRAZO_COMPRA_ZC%TYPE; -- Prazo ZC da Filial
   wiPrazo_Compra_ABCXYZ         TD_FIL.PRAZO_COMPRA_XA%TYPE; -- Prazo ABCXYZ da Filial    
    
--  --------------------------------------------------------
BEGIN     
   -- ajustando o periodo com as horas
   wdIni     := TO_DATE(TO_CHAR(TRUNC(pDatIni), 'DD/MM/YYYY')||' 00:00:00', 'DD/MM/YYYY HH24:MI:SS');
   wdFim     := TO_DATE(TO_CHAR(TRUNC(pDatFim), 'DD/MM/YYYY')||' 23:59:59', 'DD/MM/YYYY HH24:MI:SS');
   -- Inicializa Data para manter estoque
   wdEstoque := pDatEst;
   
   -- buscando o codigo da loja
   SELECT CODDEP INTO wcCodDep FROM TT_IDF;
   -- buscando a Regra para Calcular a Média de Vendas no Ponto de Pedido
   SELECT REGRA_MEDIA_VENDAS INTO wcRegra_Media_Vendas FROM TT_CFG;
   
   --Calcular Ponto de Pedido e Estoque Máximo 
   IF (pTipoProjecao = 6) THEN
      --Ajusta Periodo
      IF (wcRegra_Media_Vendas = '2') THEN --Mesmo Período no Ano Anterior (Ano Anterior)
         wdIni := ADD_MONTHS(TO_DATE(TO_CHAR(TRUNC(AGORA()), 'DD/MM/YYYY')||' 00:00:00', 'DD/MM/YYYY HH24:MI:SS'),-12);
         wdFim := ADD_DAY(ADD_MONTHS(TO_DATE(TO_CHAR(TRUNC(AGORA()), 'DD/MM/YYYY')||' 23:59:59', 'DD/MM/YYYY HH24:MI:SS'),-12),pMedent-1);
      ELSIF (wcRegra_Media_Vendas = '1') THEN--Período Anterior 
         wdIni := ADD_DAY(TO_DATE(TO_CHAR(TRUNC(AGORA()), 'DD/MM/YYYY')||' 00:00:00', 'DD/MM/YYYY HH24:MI:SS'),pMedent*-1);
         wdFim := ADD_DAY(TO_DATE(TO_CHAR(TRUNC(AGORA()), 'DD/MM/YYYY')||' 23:59:59', 'DD/MM/YYYY HH24:MI:SS'),-1);
      END IF;
      -- Data para manter estoque
      wdEstoque := ADD_DAY(TRUNC(AGORA()), pMedent);

      -- Estoque de Segurança
      wfEstSeg := pFatniv * pDp_ent * SQRT(pMedent);
   END IF;
    
   -- buscanco Prazo ABCXYZ da Filial
   SELECT AVG(DFIL.PRAZO_COMPRA_XA) AS PRAZO_COMPRA_XA, AVG(DFIL.PRAZO_COMPRA_XB) AS PRAZO_COMPRA_XB, AVG(DFIL.PRAZO_COMPRA_XC) AS PRAZO_COMPRA_XC,
          AVG(DFIL.PRAZO_COMPRA_YA) AS PRAZO_COMPRA_YA, AVG(DFIL.PRAZO_COMPRA_YB) AS PRAZO_COMPRA_YB, AVG(DFIL.PRAZO_COMPRA_YC) AS PRAZO_COMPRA_YC,
          AVG(DFIL.PRAZO_COMPRA_ZA) AS PRAZO_COMPRA_ZA, AVG(DFIL.PRAZO_COMPRA_ZB) AS PRAZO_COMPRA_ZB, AVG(DFIL.PRAZO_COMPRA_ZC) AS PRAZO_COMPRA_ZC
    INTO wfFil_XA, wfFil_XB, wfFil_XC, 
         wfFil_YA, wfFil_YB, wfFil_YC,
         wfFil_ZA, wfFil_ZB, wfFil_ZC
    FROM TD_FIL DFIL
   WHERE INSTR(COALESCE(pCODFIL, wcCodDep)||';', DFIL.CODFIL||';') > 0;

   IF (pGraXYZ = 'X') THEN
      IF (pGraABC = 'A') THEN
         wiPrazo_Compra_ABCXYZ := wfFil_XA;
      ELSIF (pGraABC = 'B') THEN
         wiPrazo_Compra_ABCXYZ := wfFil_XB;
      ELSIF (pGraABC = 'C') THEN
         wiPrazo_Compra_ABCXYZ := wfFil_XC;
      END IF;
   ELSIF (pGraXYZ = 'Y') THEN
      IF (pGraABC = 'A') THEN
         wiPrazo_Compra_ABCXYZ := wfFil_YA;
      ELSIF (pGraABC = 'B') THEN
         wiPrazo_Compra_ABCXYZ := wfFil_YB;
      ELSIF (pGraABC = 'C') THEN
         wiPrazo_Compra_ABCXYZ := wfFil_YC;
      END IF;
   ELSIF (pGraXYZ = 'Z') THEN
      IF (pGraABC = 'A') THEN
         wiPrazo_Compra_ABCXYZ := wfFil_ZA;
      ELSIF (pGraABC = 'B') THEN
         wiPrazo_Compra_ABCXYZ := wfFil_ZB;
      ELSIF (pGraABC = 'C') THEN
         wiPrazo_Compra_ABCXYZ := wfFil_ZC;
      END IF;
   END IF;

   wvResult := -- data inicial do periodo com as horas
               TO_CHAR(wdIni, 'DD/MM/YYYY HH24:MI:SS') || ';' ||
               -- data final do periodo com as horas  
               TO_CHAR(wdFim, 'DD/MM/YYYY HH24:MI:SS') || ';' ||
               -- data manter estoque até 
               TO_CHAR(wdEstoque, 'DD/MM/YYYY') || ';' ||
               -- Prazo ABCXYZ da Filial
               TO_CHAR(COALESCE(wiPrazo_Compra_ABCXYZ, 0), '000') || ';' ||
               -- Estoque de Segurança
               TO_CHAR(COALESCE(wfEstSeg, 0), '000000000000000.0000') || ';'
               ;

   return wvResult;

END;
$$ language 'plpgsql';




/*-- SEQ 1410 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PRECO_VENDA (TT_VEN.VLRNOT%TYPE,TT_VEN.VLRLIQ%TYPE,TT_IVE.VLRMOV%TYPE,TT_IVE.VLR002%TYPE) CASCADE;

/*-- SEQ 1411 --*/
CREATE OR REPLACE FUNCTION PRECO_VENDA (TT_VEN.VLRNOT%TYPE,TT_VEN.VLRLIQ%TYPE,TT_IVE.VLRMOV%TYPE,TT_IVE.VLR002%TYPE)
RETURNS Numeric AS $$
DECLARE
pVlrNot ALIAS FOR $1 ;
pVlrLiq ALIAS FOR $2 ;
pVlrMov ALIAS FOR $3 ;
pIpiIte ALIAS FOR $4 ;
  nPreVen Numeric;
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*                                                                               */
/* Calcula o Preco de venda porporcinal ao valor da Nota, Acrescimos e Descontos */
/*                                                                               */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
begin

  nPreVen := 0.000001;
  IF (COALESCE(pVlrNot,0) <> 0) THEN
     nPreVen := ((COALESCE(pVlrMov,0)-COALESCE(pIpiIte,0)))*(COALESCE(pVlrLiq,0)/pVlrNot);
  END IF;
  IF (nPreVen < 0.00001) and (nPreVen >= 0) THEN
     nPreVen := 0.00001;
  END IF;

  return nPreVen;

END;
$$ language 'plpgsql';




/*-- SEQ 1412 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ProximaCobranca (TD_COB.DESCOB%TYPE,TD_COB.TIPCOB%TYPE,TD_COB.SEQCTA%TYPE) CASCADE;

/*-- SEQ 1413 --*/
CREATE OR REPLACE FUNCTION ProximaCobranca (TD_COB.DESCOB%TYPE,TD_COB.TIPCOB%TYPE,TD_COB.SEQCTA%TYPE)
RETURNS TD_COB.CODTAB%TYPE AS $$
DECLARE
p_Titulo ALIAS FOR $1 ;
p_Tipo ALIAS FOR $2 ;
p_Conta ALIAS FOR $3 ;
  wk_retorno TD_COB.CODTAB%TYPE;
BEGIN
  -- Obtem o maior indice disponivel
  SELECT MAX(CODTAB)+1 INTO wk_retorno 
  FROM TD_COB;

  -- Cria um novo indice se preciso
  INSERT INTO TD_IND (CODTAB)
  SELECT wk_retorno
    FROM DUAL
   WHERE wk_retorno not in (SELECT CODTAB FROM TD_IND);

  INSERT INTO TD_COB (CODTAB,COBATI,DESCOB,FILCTA,TIPCTA,TIPCOB,SEQCTA)
  SELECT wk_retorno,'T',p_Titulo,CODLOJ,'N',p_Tipo,p_Conta FROM TT_IDF;

  RETURN wk_retorno;
END;
$$ language 'plpgsql';


/*-- SEQ 1414 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ProximaCobranca (TD_COB.DESCOB%TYPE,TD_COB.TIPCOB%TYPE) CASCADE;

/*-- SEQ 1415 --*/
CREATE OR REPLACE FUNCTION ProximaCobranca (TD_COB.DESCOB%TYPE,
                               TD_COB.TIPCOB%TYPE) 
RETURNS TD_COB.CODTAB%TYPE AS $$
BEGIN
RETURN ProximaCobranca($1,$2,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1416 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ProximaConta (TT_CTA.CODFIL%TYPE,TT_CTA.TITCTA%TYPE,TT_CTA.TIPCTA%TYPE,TT_CTA.USOCTA%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1417 --*/
CREATE OR REPLACE FUNCTION ProximaConta (TT_CTA.CODFIL%TYPE,TT_CTA.TITCTA%TYPE,TT_CTA.TIPCTA%TYPE,TT_CTA.USOCTA%TYPE,VARCHAR)
RETURNS TT_CTA.SEQUEN%TYPE AS $$
DECLARE
p_Filial ALIAS FOR $1 ;
p_Titulo ALIAS FOR $2 ;
p_Tipo ALIAS FOR $3 ;
p_Uso ALIAS FOR $4 ;
p_AplNum ALIAS FOR $5 ;
  wk_retorno    TT_CTA.SEQUEN%TYPE;
  wk_ECT_CODFIL TT_ECT.CODFIL%TYPE;
  wk_ECT_SEQUEN TT_ECT.SEQUEN%TYPE;
  wk_Filial     TT_CTA.CODFIL%TYPE;
  wk_AplNum     VARCHAR(1);
  vComplemento      constant VARCHAR(100) := constante('complemento');
  wk_ordcta     TT_CTA.ORDCTA%TYPE;

-- Principal
BEGIN
  -- Cria uma nova conta
  SELECT LPAD(RTRIM(TO_CHAR(NEXTVAL('SQCTA'))),10,' ') INTO wk_retorno FROM DUAL;

  -- Obtem a estrutura de contas padrao
    SELECT A.CODFIL, A.SEQUEN
      INTO wk_ECT_CODFIL, wk_ECT_SEQUEN
      FROM TT_IDF B, TT_ECT A
     WHERE A.CODFIL = B.CODLOJ
       AND A.SEQUEN = '         1';
--     AND A.TITECT LIKE 'NAO CLASSIFICAD%';
  IF ISNULL(wk_ECT_SEQUEN)='T' THEN
      RAISE EXCEPTION 'PG-20001 Na estrutura de contas nao foi localizado a conta generica "NAO CLASSIFICADO".%' , vComplemento;
      RETURN NULL;
  END IF;
  if p_Filial is null then
        
    SELECT FilialPadrao() into wk_Filial;
      else
    wk_Filial := p_Filial;
  end if;

  IF p_AplNum = 'D' THEN
    wk_AplNum := 'D';
  ELSE
    IF p_Tipo = 'G' THEN 
      wk_AplNum := 'G';
    ELSE 
      wk_AplNum := 'N';
    END IF;
  END IF;

  IF ISNULL(wk_ECT_SEQUEN)='T' THEN
     SELECT MAX(COALESCE(ORDCTA,0)) + 1
       INTO WK_ORDCTA
       FROM TT_CTA
      WHERE FILECT IS NULL
        AND SEQECT IS NULL;
  else
     SELECT MAX(COALESCE(ORDCTA,0)) + 1
       INTO WK_ORDCTA
       FROM TT_CTA
      WHERE FILECT = wk_ECT_CODFIL
        AND SEQECT = wk_ECT_SEQUEN;
  end if;
      
  WK_ORDCTA:=COALESCE(WK_ORDCTA,1);

  INSERT INTO TT_CTA (CODFIL,SEQUEN,TITCTA,FILECT,SEQECT,TIPCTA,USOCTA,APLNUM,ORDCTA)
              VALUES (wk_Filial,wk_retorno,p_titulo,wk_ECT_CODFIL,wk_ECT_SEQUEN,p_Tipo,p_Uso,wk_AplNum,wk_ordcta);

  RETURN wk_retorno;
END;
$$ language 'plpgsql';




/*-- SEQ 1418 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ProximoDiaUtilBanco (Timestamp) CASCADE;

/*-- SEQ 1419 --*/
CREATE OR REPLACE FUNCTION ProximoDiaUtilBanco (Timestamp)
RETURNS Timestamp AS $$
DECLARE
p_DATA ALIAS FOR $1 ;
     WK_CONTA  Numeric(10);
     WK_DIASEM Numeric(1);
     WK_PROXIMODIA Timestamp;
  begin
    
    WK_PROXIMODIA := add_day(p_DATA,1); 
    
    --Verifica se o dia e Sabado(7) ou Domingo(1)
    IF TO_CHAR(WK_PROXIMODIA,'D') = '7' THEN  WK_PROXIMODIA:= add_day(WK_PROXIMODIA,2); END IF; --sabado

    IF TO_CHAR(WK_PROXIMODIA,'D') = '1' THEN  WK_PROXIMODIA:= add_day(WK_PROXIMODIA,1); END IF; --domingo


  
    -- Verifica se o dia e feriado.
    SELECT COUNT(*) INTO WK_CONTA FROM TT_FER
    WHERE DIAFER = TO_NUMBER(TO_CHAR(WK_PROXIMODIA,'DD'))
      AND MESFER = TO_NUMBER(TO_CHAR(WK_PROXIMODIA,'MM'))
      AND ((ANOFER = TO_NUMBER(TO_CHAR(WK_PROXIMODIA,'YYYY'))) OR (ANOFER IS NULL));

    --  feriado, tenta no prximo dia.
    if WK_CONTA > 0 then
      WK_PROXIMODIA:= ProximoDiaUtilBanco(WK_PROXIMODIA);
    end if;

    RETURN WK_PROXIMODIA; 


END;
$$ language 'plpgsql';




/*-- SEQ 1420 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PROXIMOFATURAMENTO (TT_LIM.FILCLI%TYPE,TT_LIM.CODCLI%TYPE,TT_LIM.TIPCCC%TYPE,TT_CLI.DATOPE%TYPE,TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 1421 --*/
CREATE OR REPLACE FUNCTION PROXIMOFATURAMENTO (TT_LIM.FILCLI%TYPE,TT_LIM.CODCLI%TYPE,TT_LIM.TIPCCC%TYPE,TT_CLI.DATOPE%TYPE,TD_FIL.CODFIL%TYPE)
RETURNS Timestamp AS $$
DECLARE
p_FILCLI ALIAS FOR $1 ;
p_CODCLI ALIAS FOR $2 ;
p_CODCCC ALIAS FOR $3 ;
p_DATCAD ALIAS FOR $4 ;
p_Codfil ALIAS FOR $5 ;
-- Objetivo: Retornar a proxima data que se deve faturar
-- Atenção: Quando realizar alteração aplicar caso necessário no processo da function "DIAFIXPROXIMOFATURAMENTO"
--
-- O parametro p_DATCAD nao eh mais utilizado, pois em versao anteriores
-- utilizava-se este parametro para ser considerado a como ultima data de faturamento,
-- caso nao houvesse faturamento. Atualmente, isto foi alterado, sendo que o cursor
-- "AFaturar" utiliza a menor data de lancamento em C/C em aberto como sendo a ultima data.
-- Isto eh necessario para quando o cliente NAO tem lancamentos num periodo, e tem no
-- seguinte. Assim nao se gera um faturamento para o periodo sem lancamento.

  wk_data_menor Timestamp;
  wk_data_calc  Timestamp;
  wk_ult_data   Timestamp;
  wk_data       Timestamp;
  cFILCLI TT_LIM.FILCLI%TYPE;
  cCODCLI TT_LIM.CODCLI%TYPE;

-- Duplicado por questoes de otimizacao  
Clientes CURSOR FOR  
SELECT FILCLI,CODCLI
FROM connectby('(select cast(filcli||codcli as VARCHAR(9)) as filho,
                        cast(filvin||codvin as VARCHAR(9)) as pai,
                        0 as ordem
                   from TT_CLI int) tab', 'filho', 'pai', 'ordem', p_Filcli||p_Codcli, 0, '~')
AS c (conn_codigo VARCHAR, conn_codpai VARCHAR, level int, arvore text, ordem int)
INNER JOIN TT_CLI t ON c.conn_codigo  = (filcli||codcli)
where global='I';
   

AFaturar CURSOR(p_filial TT_LIM.FILCLI%TYPE,
           p_codigo TT_LIM.CODCLI%TYPE,
           p_conta TT_LIM.TIPCCC%TYPE) IS  
    SELECT A.DIASEM,
           CASE WHEN A.DIAMES IS NOT NULL THEN A.DIAMES ELSE
                CASE WHEN A.DIASEM IS NOT NULL THEN A.DIAMES 
                                               ELSE TO_NUMBER(TO_CHAR(agora(),'DD'))
                END
           END AS DIAMES,
           B.TIPCCC AS CODCCC
      FROM (select p_filial as filcli, 
                   p_codigo as codcli,
                   p_conta as tipccc 
                   from dual) B
           LEFT OUTER JOIN TT_DXC A ON A.FILCLI = B.FILCLI AND A.CODCLI = B.CODCLI AND A.CODCCC = B.TIPCCC;   

  i             Record;


-- Principal
BEGIN
  wk_data_menor:=agora();
  
  OPEN Clientes;
  LOOP
    FETCH Clientes into cFILCLI,cCODCLI;
    EXIT WHEN NOT FOUND;

    IF p_Codfil <> NULL THEN	
       SELECT MIN(DATOPE) AS DATOPE into wk_Data
            FROM (SELECT FILCLI, CODCLI, TIPCCC, MIN(DATOPE) AS DATOPE
                  FROM TT_CCC
                  WHERE STATUS IN('A')
                    AND FILCLI = p_FILCLI
                    AND CODCLI = p_CODCLI
                    AND TIPCCC = p_CODCCC
		    AND CODFIL = p_Codfil
                  GROUP BY FILCLI, CODCLI, TIPCCC, CODFIL) TAB;

    ELSE
       SELECT MIN(DATOPE) AS DATOPE into wk_Data
            FROM (SELECT FILCLI, CODCLI, TIPCCC, MIN(DATOPE) AS DATOPE
                  FROM TT_CCC
                  WHERE STATUS IN('A')
                    AND FILCLI = p_FILCLI
                    AND CODCLI = p_CODCLI
                    AND TIPCCC = p_CODCCC
                  GROUP BY FILCLI, CODCLI, TIPCCC) TAB;
    END IF;
       
       wk_data_menor := least(coalesce(wk_data_menor,agora()),coalesce(wk_data,agora()));
       
  END LOOP;
  Close Clientes;

  wk_data  := trunc(wk_data_menor);
  wk_data_menor := null;
  OPEN AFaturar(p_FILCLI,p_CODCLI,p_CODCCC);
  LOOP
    FETCH AFaturar into i;
    EXIT WHEN NOT FOUND;    
    wk_data_calc := Aux_ProximaData(i.DIASEM,i.DIAMES, wk_data,i.CODCCC);
  
    if (wk_data_menor is null) or (wk_data_menor > wk_data_calc) then
       wk_data_menor := wk_data_calc;
    end if;
    
  END LOOP;
  CLOSE AFaturar;    
 
  RETURN trunc(wk_data_menor);
  
END;
$$ language 'plpgsql';


/*-- SEQ 1422 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PROXIMOFATURAMENTO (TT_LIM.FILCLI%TYPE,TT_LIM.CODCLI%TYPE,TT_LIM.TIPCCC%TYPE,TT_CLI.DATOPE%TYPE) CASCADE;

/*-- SEQ 1423 --*/
CREATE OR REPLACE FUNCTION PROXIMOFATURAMENTO (TT_LIM.FILCLI%TYPE,
                               TT_LIM.CODCLI%TYPE,
                               TT_LIM.TIPCCC%TYPE,
                               TT_CLI.DATOPE%TYPE) 
RETURNS Timestamp AS $$
BEGIN
RETURN PROXIMOFATURAMENTO($1,$2,$3,$4,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1424 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PrazoMedio (Numeric,Numeric,Numeric,Numeric) CASCADE;

/*-- SEQ 1425 --*/
CREATE OR REPLACE FUNCTION PrazoMedio (Numeric,Numeric,Numeric,Numeric)
RETURNS Numeric AS $$
DECLARE
pInterv ALIAS FOR $1 ;
pQtdPar ALIAS FOR $2 ;
pVlrPar ALIAS FOR $3 ;
pVlrEnt ALIAS FOR $4 ;

  wk_SomaSequen Numeric;
  wk_QtdPar     Numeric;
  wk_TotDias    Numeric;
  wk_TotVal     Numeric;
BEGIN
  IF pVlrEnt = 0 AND (pQtdPar = 0 OR pVlrPar = 0) THEN
    RETURN 0; 
  ELSE
    -- Evita decimais   
    wk_QtdPar := Trunc(pQtdPar);

    -- wk_SomaSequen usa uma formula que produz o efeito da somatoria de toda a
    -- sequencia de numeros que existem entre 1 e a quantidade de parcelas.
    -- Veja o exemplo: 4 parcelas, entao o resultado sera 1+2+3+4 = 10
    IF wk_QtdPar/2 = trunc(wk_QtdPar/2) THEN
      wk_SomaSequen := (wk_QtdPar * (wk_QtdPar/2)) + (wk_QtdPar/2);
    ELSE
      wk_SomaSequen := wk_QtdPar * ((wk_QtdPar/2) + 0.5);
    END IF;
          
    wk_TotDias := wk_SomaSequen * pInterv * pVlrPar;
    wk_TotVal  := pVlrEnt + (wk_QtdPar * pVlrPar);
    
    -- Retorna o prazo medio calculado
    RETURN (wk_TotDias / wk_TotVal);   
  END IF;
END;
$$ language 'plpgsql';


/*-- SEQ 1426 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PrazoMedio (Numeric,Numeric,Numeric) CASCADE;

/*-- SEQ 1427 --*/
CREATE OR REPLACE FUNCTION PrazoMedio (Numeric,
                               Numeric,
                               Numeric) 
RETURNS Numeric AS $$
BEGIN
RETURN PrazoMedio($1,$2,$3,0);
END;
$$ language 'plpgsql';


/*-- SEQ 1428 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION QtdConvertida (TT_GRA.CODTAM%TYPE,TT_IVE.QTDMOV%TYPE) CASCADE;

/*-- SEQ 1429 --*/
CREATE OR REPLACE FUNCTION QtdConvertida (TT_GRA.CODTAM%TYPE,TT_IVE.QTDMOV%TYPE)
RETURNS Numeric AS $$
DECLARE
p_CodTam ALIAS FOR $1 ;
p_Qtdade ALIAS FOR $2 ;
  Retorno Numeric default 0;
begin

  SELECT CASE COALESCE( FATCON, 0 ) WHEN 0 THEN 1
                               ELSE FATCON 
         END * p_Qtdade into Retorno
  FROM TT_SUB 
  WHERE CODITE = p_CodTam;

  return Retorno;

END;
$$ language 'plpgsql';






/*-- SEQ 1430 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION QtdDevolvida (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE) CASCADE;

/*-- SEQ 1431 --*/
CREATE OR REPLACE FUNCTION QtdDevolvida (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE)
RETURNS Numeric AS $$
DECLARE
p_CodFil ALIAS FOR $1 ;
p_Sequen ALIAS FOR $2 ;
p_NumIte ALIAS FOR $3 ;
   QTDENT Numeric;    -- Quantidade devolvida
-- Objetivo:
-- 1) Calcular a quantidade devolvida das notas com vinculo
BEGIN
  SELECT ABS(SUM(IVE.QTDMOV)) INTO QTDENT
  FROM TT_IVE IVE
  WHERE IVE.FILORI = p_CodFil
    AND IVE.NUMORI = p_Sequen
    AND IVE.ITEORI = p_NumIte
    AND IVE.QTDMOV < 0
    AND IVE.SITMOV <> 'C';
   
  RETURN COALESCE(QTDENT, 0);
END;
$$ language 'plpgsql';




/*-- SEQ 1432 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION QtdEntregue (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE) CASCADE;

/*-- SEQ 1433 --*/
CREATE OR REPLACE FUNCTION QtdEntregue (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE)
RETURNS Numeric AS $$
DECLARE
p_CodFil ALIAS FOR $1 ;
p_Sequen ALIAS FOR $2 ;
p_NumIte ALIAS FOR $3 ;
   QTDENT                        Numeric;    -- Quantidade entregue
   
-- Objetivo:
-- 1) Calcular a quantidade entregue as notas com vinculo

BEGIN

   SELECT SUM( ABS(TAB.QTDMOV) - ABS(COALESCE(TAB.QTDDEV,0)) ) INTO QTDENT
     FROM (SELECT IVE.QTDMOV,
                  (SELECT SUM(DEV.QTDMOV)
                     FROM TT_IVE DEV 
                    WHERE DEV.FILORI = IVE.CODFIL 
                      AND DEV.NUMORI = IVE.SEQUEN 
                      AND DEV.ITEORI = IVE.NUMITE 
                      AND DEV.SITMOV <> 'C'
                      AND DEV.QTDMOV < 0) AS QTDDEV
             FROM TT_IVE IVE 
            WHERE IVE.FILORI = p_CodFil
              AND IVE.NUMORI = p_Sequen
              AND IVE.ITEORI = p_NumIte
              AND IVE.LANEST = 'C'
              AND IVE.SITMOV <> 'C'
              AND IVE.QTDMOV > 0) TAB;

   RETURN COALESCE(QTDENT, 0);
         
END;
$$ language 'plpgsql';




/*-- SEQ 1434 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION QtdEstornada (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE) CASCADE;

/*-- SEQ 1435 --*/
CREATE OR REPLACE FUNCTION QtdEstornada (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE)
RETURNS Numeric AS $$
DECLARE
p_CodFil ALIAS FOR $1 ;
p_Sequen ALIAS FOR $2 ;
p_NumIte ALIAS FOR $3 ;

QTDEST Numeric;    -- Quantidade estornada
-- Objetivo:
-- 1) Calcular a quantidade estornada as notas com vnculo
begin
  SELECT SUM(IVE.QTDMOV*-1) into QTDEST
  FROM TT_IVE IVE
  WHERE IVE.CODFIL = p_CodFil
    AND IVE.NUMORI = p_Sequen
    AND IVE.ITEORI = p_NumIte
    AND IVE.LANEST = 'R'
    AND IVE.SITMOV <> 'C';
  RETURN COALESCE(QTDEST,0);
EXCEPTION
  WHEN OTHERS THEN RETURN 0;
END;
$$ language 'plpgsql';




/*-- SEQ 1436 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION QuantosDias (Timestamp,Numeric,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE,Numeric) CASCADE;

/*-- SEQ 1437 --*/
CREATE OR REPLACE FUNCTION QuantosDias (Timestamp,Numeric,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE,Numeric)
RETURNS Numeric AS $$
DECLARE
p_inicio ALIAS FOR $1 ;
p_tothor ALIAS FOR $2 ;
p_filial ALIAS FOR $3 ;
p_codigo ALIAS FOR $4 ;
p_horas_dia ALIAS FOR $5 ;
  wk_dias   INTEGER;
  wk_inicio Timestamp;
  wk_fim    Timestamp;

BEGIN
  wk_dias   := COALESCE(ROUND(p_tothor / p_horas_dia),0);
  wk_inicio := TRUNC(p_inicio);
  wk_fim    := wk_inicio;

  LOOP
    EXIT WHEN wk_dias = 0 OR wk_inicio IS NULL;
    IF TO_CHAR(wk_fim,'D') IN ('1','7') THEN
    ELSIF AUX_Feriado(wk_fim,p_filial,p_codigo) THEN
    ELSE
      wk_dias := wk_dias - 1;
    END IF;

    IF wk_dias > 0 THEN
      wk_fim := trunc(wk_fim) + 1;
    END IF;
  END LOOP;

  RETURN trunc(wk_fim) - trunc(wk_inicio);
END;
$$ language 'plpgsql';


/*-- SEQ 1438 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION QuantosDias (Timestamp,Numeric,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE) CASCADE;

/*-- SEQ 1439 --*/
CREATE OR REPLACE FUNCTION QuantosDias (Timestamp,
                               Numeric,
                               TT_USU.FILUSU%TYPE,
                               TT_USU.CODUSU%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN QuantosDias($1,$2,$3,$4,8);
END;
$$ language 'plpgsql';


/*-- SEQ 1440 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION QuantosDias (Timestamp,Numeric,TT_USU.FILUSU%TYPE) CASCADE;

/*-- SEQ 1441 --*/
CREATE OR REPLACE FUNCTION QuantosDias (Timestamp,
                               Numeric,
                               TT_USU.FILUSU%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN QuantosDias($1,$2,$3,null,8);
END;
$$ language 'plpgsql';


/*-- SEQ 1442 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION QuantosDias (Timestamp,Numeric) CASCADE;

/*-- SEQ 1443 --*/
CREATE OR REPLACE FUNCTION QuantosDias (Timestamp,
                               Numeric) 
RETURNS Numeric AS $$
BEGIN
RETURN QuantosDias($1,$2,null,null,8);
END;
$$ language 'plpgsql';


/*-- SEQ 1444 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION QuemLogou (TT_USU.APEUSU%TYPE) CASCADE;

/*-- SEQ 1445 --*/
CREATE OR REPLACE FUNCTION QuemLogou (TT_USU.APEUSU%TYPE)
RETURNS TRetQuemLogou AS $$
DECLARE
p_Usuario_Nome ALIAS FOR $1 ;
  wk_Achou INTEGER;
  Retorno TRetQuemLogou%ROWTYPE;
  v_Qtd    INTEGER;
  V_APEUSU TT_USU.APEUSU%TYPE; 
BEGIN
  
  V_APEUSU := UPPER(p_Usuario_Nome);
  IF V_APEUSU = 'TT2000_INTERNET' THEN 
     V_APEUSU := 'TOTALL';
  ELSIF V_APEUSU = 'ADMTOTALL' THEN 
     V_APEUSU := 'TOTALL';
  END IF;

  SELECT Count(*) INTO v_Qtd
    FROM TT_USU
   WHERE APEUSU = V_APEUSU;


  IF v_Qtd > 0 then
     SELECT FILUSU,CODUSU INTO Retorno.Filusu,Retorno.Codusu
       FROM TT_USU
      WHERE APEUSU = p_Usuario_Nome;
     Retorno.Encontrou := True;
     Return Retorno;
   ELSE
    Retorno.Encontrou := False;
    Return Retorno;
   END IF;
END;
$$ language 'plpgsql';




/*-- SEQ 1446 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RFP_ATRASO (Timestamp,Numeric) CASCADE;

/*-- SEQ 1447 --*/
CREATE OR REPLACE FUNCTION RFP_ATRASO (Timestamp,Numeric)
RETURNS Numeric AS $$
DECLARE
Vence ALIAS FOR $1 ;
Valor ALIAS FOR $2 ;
begin
  if (Vence < agora()) then
     return Valor;
  else
     return 0;
  end if;
END;
$$ language 'plpgsql';




/*-- SEQ 1448 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RFP_AVENCER (Timestamp,Numeric) CASCADE;

/*-- SEQ 1449 --*/
CREATE OR REPLACE FUNCTION RFP_AVENCER (Timestamp,Numeric)
RETURNS Numeric AS $$
DECLARE
Vence ALIAS FOR $1 ;
Valor ALIAS FOR $2 ;
begin
  if (Vence >= agora()) then
     return Valor;
  else
     return 0;
  end if;
END;
$$ language 'plpgsql';




/*-- SEQ 1450 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SALDOCOMPRAVENDA (Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_GRA.FILMAT%TYPE) CASCADE;

/*-- SEQ 1451 --*/
CREATE OR REPLACE FUNCTION SALDOCOMPRAVENDA (Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_GRA.FILMAT%TYPE)
RETURNS Numeric AS $$
DECLARE
p_DatRef ALIAS FOR $1 ;
p_FilMat ALIAS FOR $2 ;
p_CodMat ALIAS FOR $3 ;
p_CodCor ALIAS FOR $4 ;
p_CodTam ALIAS FOR $5 ;
p_CodFil ALIAS FOR $6 ;
-- Objetivo:
-- 1) Calcular o Saldo de estoque de um determinado produto na data especificada
-- 2) O Calculo e somente de uma filial especifica
  Saldo Numeric;

-- Principal
begin
  SELECT COALESCE( MOV.SALANT, 0 ) -
         COALESCE( MOV.VENFIS, 0 ) -
         COALESCE( MOV.QTDVEN, 0 ) +
         COALESCE( MOV.QTDCOM, 0 ) into Saldo
  FROM TR_MOV MOV,
       ( SELECT MAX(DATMOV) AS DATMOV
         FROM TR_MOV
         WHERE CODFIL = p_CodFil
           AND FILMAT = p_FilMat
           AND CODMAT = p_CodMat
           AND CODCOR = p_CodCor
           AND CODTAM = p_CodTam
           AND DATMOV <= trunc(p_DatRef) ) DAT
  WHERE MOV.CODFIL = p_CodFil
    AND MOV.FILMAT = p_FilMat
    AND MOV.CODMAT = p_CodMat
    AND MOV.CODCOR = p_CodCor
    AND MOV.CODTAM = p_CodTam
    AND MOV.DATMOV = DAT.DATMOV
    AND (MOV.QTDVEN <> 0 OR MOV.QTDCOM <> 0);
    RETURN Saldo;
END;
$$ language 'plpgsql';




/*-- SEQ 1452 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SALDODAFILIAL (Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_GRA.FILMAT%TYPE,TD_MUL.CODTAB%TYPE) CASCADE;

/*-- SEQ 1453 --*/
CREATE OR REPLACE FUNCTION SALDODAFILIAL (Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_GRA.FILMAT%TYPE,TD_MUL.CODTAB%TYPE)
RETURNS Numeric AS $$
DECLARE
p_DatRef ALIAS FOR $1 ;
p_Filmat ALIAS FOR $2 ;
p_CodMat ALIAS FOR $3 ;
p_CodCor ALIAS FOR $4 ;
p_CodTam ALIAS FOR $5 ;
p_CodFil ALIAS FOR $6 ;
p_CodMul ALIAS FOR $7 ;
-- Objetivo:
-- 1) Calcular o Saldo de estoque de um determinado produto na data especificada
-- 2) O Calculo  somente de uma filial especfica
  Saldo Numeric;

-- Principal
begin
  SELECT COALESCE( COALESCE( MOV.SALANT, 0 ) -
         COALESCE( MOV.VENFIS, 0 ) -
         COALESCE( MOV.QTDVEN, 0 ) +
         COALESCE( MOV.QTDCOM, 0 ) +
         COALESCE( MOV.QTDOUT, 0 ) ,0) into Saldo
  FROM TR_MOV MOV,
       ( SELECT MAX(DATMOV) AS DATMOV
         FROM TR_MOV
         WHERE CODFIL = p_CodFil
           AND FILMAT = p_FilMat
           AND CODMAT = p_CodMat
           AND CODCOR = p_CodCor
           AND CODTAM = p_CodTam
           AND CODMUL = p_CodMul
           AND DATMOV <= trunc(p_DatRef) ) DAT
  WHERE MOV.CODFIL = p_CodFil
    AND MOV.FILMAT = p_FilMat
    AND MOV.CODMAT = p_CodMat
    AND MOV.CODCOR = p_CodCor
    AND MOV.CODTAM = p_CodTam
    AND MOV.CODMUL = p_CodMul
    AND MOV.DATMOV = DAT.DATMOV;

  RETURN COALESCE(Saldo,0);
END;
$$ language 'plpgsql';


/*-- SEQ 1454 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SALDODAFILIAL (Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_GRA.FILMAT%TYPE) CASCADE;

/*-- SEQ 1455 --*/
CREATE OR REPLACE FUNCTION SALDODAFILIAL (Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               TT_GRA.FILMAT%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN SALDODAFILIAL($1,$2,$3,$4,$5,$6,0);
END;
$$ language 'plpgsql';


/*-- SEQ 1456 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SALDOPERIODO (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,Timestamp,Timestamp) CASCADE;

/*-- SEQ 1457 --*/
CREATE OR REPLACE FUNCTION SALDOPERIODO (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,Timestamp,Timestamp)
RETURNS Numeric AS $$
DECLARE
pFILMAT ALIAS FOR $1 ;
pCODMAT ALIAS FOR $2 ;
pCODCOR ALIAS FOR $3 ;
pCODTAM ALIAS FOR $4 ;
pDatIni ALIAS FOR $5 ;
pDatFin ALIAS FOR $6 ;

vSALDO Numeric;
BEGIN

-- Objetivo:
-- Retornar o Saldo em um determinado perodo

 SELECT SUM(COALESCE( MOV.QTDCOM, 0 ) +
            COALESCE( MOV.QTDOUT, 0 ) -
            COALESCE( MOV.VENFIS, 0 ) -
            COALESCE( MOV.QTDVEN, 0 )) INTO vSALDO
   FROM TR_MOV MOV
  WHERE MOV.CODFIL in (SELECT CODFIL FROM TD_FIL)
    AND MOV.FILMAT = pFILMAT
    AND MOV.CODMAT = pCODMAT
    AND MOV.CODCOR = pCODCOR
    AND MOV.CODTAM = pCODTAM
    AND MOV.DATMOV BETWEEN pDatIni AND pDatFin;

 RETURN COALESCE(vSALDO,0);
END;
$$ language 'plpgsql';




/*-- SEQ 1458 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION statusProjeto (TT_PRJ.CODFIL%TYPE,TT_PRJ.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1459 --*/
CREATE OR REPLACE FUNCTION statusProjeto (TT_PRJ.CODFIL%TYPE,TT_PRJ.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_CodFil ALIAS FOR $1 ;
p_Sequen ALIAS FOR $2 ;
-- Objetivo
-- 1) Percentual de conclusao e status do projeto
 projeto CURSOR(p_Filial TT_PRJ.CODFIL%TYPE,
           p_Codigo TT_PRJ.SEQUEN%TYPE) IS
   SELECT * FROM TT_PRJ
    WHERE CODFIL = p_Filial
      AND SEQUEN = p_Codigo;
  detalhe record;

  status      CHAR(1);
  retorno     VARCHAR(7);
  SomenteSC   Boolean;
  ExisteF     Boolean;
  SomenteC    Boolean;
  SomenteS    Boolean;
  Somente1CSX Boolean;
  SomenteT    Boolean;

-- Principal
BEGIN
  retorno := '';

  OPEN projeto(p_CodFil,p_Sequen);
  FETCH projeto INTO detalhe;
  IF NOT FOUND THEN
    retorno := '';
  ELSE

    SomenteSC := LEAST(COALESCE(detalhe.TOTW_S,0)+
                       COALESCE(detalhe.TOTW_C,0),-1.0)+
                       COALESCE(detalhe.TOTW_A,0)+COALESCE(detalhe.TOTW_I,0)+
                       COALESCE(detalhe.TOTW_E,0)+COALESCE(detalhe.TOTW_E,0)+
                       COALESCE(detalhe.TOTW_1,0)+COALESCE(detalhe.TOTW_2,0) = -1;

    ExisteF := COALESCE(detalhe.TOTA_F,0) > 0;

    SomenteC := LEAST(COALESCE(detalhe.TOTW_C,0),-1.0)+
                      COALESCE(detalhe.TOTW_A,0)+COALESCE(detalhe.TOTW_I,0)+
                      COALESCE(detalhe.TOTW_E,0)+COALESCE(detalhe.TOTW_X,0)+
                      COALESCE(detalhe.TOTW_1,0)+COALESCE(detalhe.TOTW_2,0)+
                      COALESCE(detalhe.TOTW_S,0) = -1;

    SomenteS := LEAST(COALESCE(detalhe.TOTW_S,0),-1.0)+
                      COALESCE(detalhe.TOTW_A,0)+COALESCE(detalhe.TOTW_E,0)+
                      COALESCE(detalhe.TOTW_I,0)+COALESCE(detalhe.TOTW_X,0)+
                      COALESCE(detalhe.TOTW_1,0)+COALESCE(detalhe.TOTW_2,0)+
                      COALESCE(detalhe.TOTW_C,0) = -1;

    Somente1CSX := LEAST(COALESCE(detalhe.TOTW_1,0)+
                         COALESCE(detalhe.TOTW_C,0)+
                         COALESCE(detalhe.TOTW_S,0)+
                         COALESCE(detalhe.TOTW_X,0),-1.0)+
                         COALESCE(detalhe.TOTW_A,0)+COALESCE(detalhe.TOTW_I,0)+
                         COALESCE(detalhe.TOTW_E,0)+COALESCE(detalhe.TOTW_2,0) = -1;

    SomenteT := LEAST(COALESCE(detalhe.TOTA_T,0),-1.0)+
                      COALESCE(detalhe.TOTA_N,0)+COALESCE(detalhe.TOTA_F,0) = -1;

    IF SomenteC THEN                            -- Somente tarefas "Canceladas"
      status := 'C';   /* Projeto Cancelado */
    ELSIF SomenteS THEN                         -- Somente tarefas "Suspensas"
      status := 'S';   /* Projeto Suspenso */
    ELSIF Somente1CSX THEN                      -- Somente tarefas "Revisadas e Aprovadas", "Canceladas", "Suspensas" e "Executadas" entao
      IF SomenteT THEN                        -- Somente tarefas "Aprovadas"
        status := 'T'; /* Projeto Aprovado */
      ELSIF ExisteF THEN                        -- Existe alguma tarefa "Rejeitada"
        status := 'F'; /* Projeto Rejeitado */
      ELSE
        status := 'X'; /* Projeto Executado */
      END IF;
    ELSIF SomenteSC THEN                        -- Somente tarefas "Suspensas" e "Canceladas"
      status := 'S';   /* Projeto Suspenso */
    ELSE
      status := 'A';   /* Projeto em Aberto */
    END IF;

    /*Formatando*/
    IF COALESCE(detalhe.HORREA,0)+COALESCE(detalhe.HORFAL,0) = 0 THEN
      retorno := '   0';
    ELSE
      retorno := TO_CHAR( TRUNC(COALESCE(detalhe.HORREA,0) * 100 / 
                               (COALESCE(detalhe.HORREA,0) +COALESCE(detalhe.HORFAL,0) )),
                         '9999');
    END IF;

    retorno := retorno || '%' || status;
  END IF;
  CLOSE projeto;

  RETURN retorno;
END;
$$ language 'plpgsql';




/*-- SEQ 1460 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TotComFre (TT_COM.FILFRE%TYPE,TT_COM.SEQFRE%TYPE) CASCADE;

/*-- SEQ 1461 --*/
CREATE OR REPLACE FUNCTION TotComFre (TT_COM.FILFRE%TYPE,TT_COM.SEQFRE%TYPE)
RETURNS Numeric AS $$
DECLARE
cCodFil ALIAS FOR $1 ;
cSequen ALIAS FOR $2 ;
  nVlrTot Numeric;

begin

  SELECT COALESCE(SUM(COALESCE(COM.VLRLIQ,0)-COALESCE(COM.SUBSTT,0)),0) INTO nVlrTot
  FROM TT_COM COM INNER JOIN TT_FREXCOM FXC ON COM.CODFIL=FXC.FILCOM AND COM.SEQUEN=FXC.SEQCOM
  WHERE FXC.FILFRE = cCodFil
    AND FXC.SEQFRE = cSequen
    AND FLGEST <> 'C';

  return nVlrTot;
END;
$$ language 'plpgsql';




/*-- SEQ 1462 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TotIcmIpiCom (TT_ICO.CODFIL%TYPE,TT_ICO.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1463 --*/
CREATE OR REPLACE FUNCTION TotIcmIpiCom (TT_ICO.CODFIL%TYPE,TT_ICO.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
cCodFil ALIAS FOR $1 ;
cSequen ALIAS FOR $2 ;
  nTotIcmCom Numeric;
  nTotIpiCom Numeric;
begin

  SELECT COALESCE(SUM(VLRICMDIF),0),
         COALESCE(SUM(COALESCE(ICO.VLRMOV,0)*COALESCE(ICO.IPIITE,0)/100),0) 
    INTO nTotIcmCom, nTotIpiCom
    FROM TT_ICO ICO, TT_CFG CFG
   WHERE ICO.CODFIL = cCodFil
     AND ICO.SEQUEN = cSequen;

  IF nTotIcmCom > 9999990.99 THEN
     nTotIcmCom := 9999990.99;
  END IF; 
  IF nTotIpiCom > 9999990.99 THEN
     nTotIpiCom := 9999990.99;
  END IF; 


  return TO_CHAR(nTotIcmCom,'9999990.99')||TO_CHAR(nTotIpiCom,'9999990.99');
END;
$$ language 'plpgsql';




/*-- SEQ 1464 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TipoParceiro (TT_REL.FILPAR%TYPE,TT_REL.CODPAR%TYPE,TT_REL.TIPPAR%TYPE) CASCADE;

/*-- SEQ 1465 --*/
CREATE OR REPLACE FUNCTION TipoParceiro (TT_REL.FILPAR%TYPE,TT_REL.CODPAR%TYPE,TT_REL.TIPPAR%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_FILPAR ALIAS FOR $1 ;
p_CODPAR ALIAS FOR $2 ;
p_TIPPAR ALIAS FOR $3 ;
  cRet VARCHAR(1);
BEGIN
   SELECT CASE WHEN VER.TIPPAR IS NULL THEN 'F' 
                                       ELSE 'T' 
          END INTO cRet
   FROM (SELECT P_TIPPAR AS TIPPAR FROM DUAL) FAL
        LEFT OUTER JOIN 
        (SELECT TIPPAR FROM TT_REL
         WHERE FILPAR = P_FILPAR
           AND CODPAR = P_CODPAR
           AND TIPPAR = P_TIPPAR) VER
        ON FAL.TIPPAR = VER.TIPPAR;
  RETURN cret;
END;
$$ language 'plpgsql';




/*-- SEQ 1466 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TotalContaAdm (TW_CTA.CHV_ID%TYPE,TW_CTA.USERID%TYPE,INTEGER,VARCHAR) CASCADE;

/*-- SEQ 1467 --*/
CREATE OR REPLACE FUNCTION TotalContaAdm (TW_CTA.CHV_ID%TYPE,TW_CTA.USERID%TYPE,INTEGER,VARCHAR)
RETURNS Numeric AS $$
DECLARE
p_Chave ALIAS FOR $1 ;
p_User ALIAS FOR $2 ;
p_Total ALIAS FOR $3 ;
p_Tipo ALIAS FOR $4 ;
  wk_Resultado Numeric DEFAULT 0;
 
  wk_ArvorePai TW_CTA.ARVORE%TYPE;
 --
-- p_Tipo IS NULL
-- Esta funcao retorna o total da conta titulo
-- p_Tipo = V
-- Esta funcao retorna o total previsto para conta (TT_VER.VLRVER)
--
BEGIN

  
   SELECT ARVORE||'%'                -- Mascara para localizar todos os registros filhos dentro da arvore
     INTO wk_ArvorePai
     FROM TW_CTA
    WHERE CHV_ID = p_Chave
      AND USERID = p_USER;
  
   SELECT CASE WHEN MIN(CASE CTA.TIPCTA WHEN 'T' THEN NULL ELSE CTA.TIPCTA END) = MAX(CASE CTA.TIPCTA WHEN 'T' THEN NULL ELSE CTA.TIPCTA END) 
               THEN SUM(CASE p_Total WHEN 1  THEN CASE WHEN p_Tipo IS NULL THEN VLRTO1 ELSE VLRV01 END
                                     WHEN 2  THEN CASE WHEN p_Tipo IS NULL THEN VLRTO2 ELSE VLRV02 END
                                     WHEN 3  THEN CASE WHEN p_Tipo IS NULL THEN VLRTO3 ELSE VLRV03 END
                                     WHEN 4  THEN CASE WHEN p_Tipo IS NULL THEN VLRTO4 ELSE VLRV04 END
                                     WHEN 5  THEN CASE WHEN p_Tipo IS NULL THEN VLRTO5 ELSE VLRV05 END
                                     WHEN 6  THEN CASE WHEN p_Tipo IS NULL THEN VLRTO6 ELSE VLRV06 END
                                     WHEN 7  THEN CASE WHEN p_Tipo IS NULL THEN VLRTO7 ELSE VLRV07 END
                                     WHEN 8  THEN CASE WHEN p_Tipo IS NULL THEN VLRTO8 ELSE VLRV08 END
                                     WHEN 9  THEN CASE WHEN p_Tipo IS NULL THEN VLRTO9 ELSE VLRV09 END
                                     WHEN 10 THEN CASE WHEN p_Tipo IS NULL THEN VLRT10 ELSE VLRV10 END
                                     WHEN 11 THEN CASE WHEN p_Tipo IS NULL THEN VLRT11 ELSE VLRV11 END
                                     WHEN 12 THEN CASE WHEN p_Tipo IS NULL THEN VLRT12 ELSE VLRV12 END
                                     ELSE 0                                                        
                        END)
               ELSE 0
          END
     INTO wk_Resultado
     FROM TW_CTA CTA
    WHERE USERID = p_User
             
      AND ARVORE LIKE wk_ArvorePai;
   
   RETURN COALESCE(wk_Resultado,0);

END;
$$ language 'plpgsql';


/*-- SEQ 1468 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TotalContaAdm (TW_CTA.CHV_ID%TYPE,TW_CTA.USERID%TYPE,INTEGER) CASCADE;

/*-- SEQ 1469 --*/
CREATE OR REPLACE FUNCTION TotalContaAdm (TW_CTA.CHV_ID%TYPE,
                               TW_CTA.USERID%TYPE,
                               INTEGER) 
RETURNS Numeric AS $$
BEGIN
RETURN TotalContaAdm($1,$2,$3,null);
END;
$$ language 'plpgsql';


/*-- SEQ 1470 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TotPesoCom (TT_COM.FILFRE%TYPE,TT_COM.SEQFRE%TYPE) CASCADE;

/*-- SEQ 1471 --*/
CREATE OR REPLACE FUNCTION TotPesoCom (TT_COM.FILFRE%TYPE,TT_COM.SEQFRE%TYPE)
RETURNS Numeric AS $$
DECLARE
cCodFil ALIAS FOR $1 ;
cSequen ALIAS FOR $2 ;
  nVlrTot Numeric;
BEGIN
  SELECT SUM(GRA.PESBRU*NVLZ(ICO.QTDMOV,1)) INTO nVlrTot
    FROM TT_COM COM INNER JOIN TT_FREXCOM FXC ON COM.CODFIL=FXC.FILCOM AND COM.SEQUEN=FXC.SEQCOM
	                INNER JOIN TT_ICO ICO ON COM.CODFIL = ICO.CODFIL AND COM.SEQUEN = ICO.SEQUEN
                    INNER JOIN TT_GRA GRA ON ICO.FILMAT = GRA.FILMAT
                                         AND ICO.CODMAT = GRA.CODMAT
                                         AND ICO.CODCOR = GRA.CODCOR
                                         AND ICO.CODTAM = GRA.CODTAM
   WHERE FXC.FILFRE = cCodFil
     AND FXC.SEQFRE = cSequen
     AND COM.FLGEST <> 'C';

  return nVlrTot;
END;
$$ language 'plpgsql';




/*-- SEQ 1472 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TotSubsttCompra (TT_ICO.CODFIL%TYPE,TT_ICO.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1473 --*/
CREATE OR REPLACE FUNCTION TotSubsttCompra (TT_ICO.CODFIL%TYPE,TT_ICO.SEQUEN%TYPE)
RETURNS Numeric AS $$
DECLARE
cCodFil ALIAS FOR $1 ;
cSequen ALIAS FOR $2 ;
  nTotSubstt Numeric;

begin

  SELECT SUM(ICO.VLRMOV) INTO nTotSubstt 
    FROM  TT_ICO ICO
   WHERE ICO.CODFIL = cCodFil
     AND ICO.SEQUEN = cSequen 
     AND ICO.ICMTIP = '3'
   GROUP BY ICO.CODFIL,ICO.SEQUEN;

  return nTotSubstt;
END;
$$ language 'plpgsql';




/*-- SEQ 1474 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TOTALTRANSFERENCIA (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TD_MUL.CODTAB%TYPE) CASCADE;

/*-- SEQ 1475 --*/
CREATE OR REPLACE FUNCTION TOTALTRANSFERENCIA (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TD_MUL.CODTAB%TYPE)
RETURNS Numeric AS $$
DECLARE
dDataIni ALIAS FOR $1 ;
dDataFim ALIAS FOR $2 ;
pFilMat ALIAS FOR $3 ;
pCodMat ALIAS FOR $4 ;
pCodCor ALIAS FOR $5 ;
pCodTam ALIAS FOR $6 ;
pCodFil ALIAS FOR $7 ;
pCodmul ALIAS FOR $8 ;
   nQtdTra Numeric;
   wdIni   Timestamp; --  data inicial do periodo com as horas
   wdFim   Timestamp; --  data final do periodo com as horas
begin

   --  ajustando o periodo com as horas
   wdIni := TRUNC(dDataIni);
   wdFim := TO_DATE(TO_CHAR(TRUNC(dDataFim), 'DD/MM/YYYY') || ' 23:59:59', 'DD/MM/YYYY HH24:MI:SS');

   SELECT COALESCE(SUM(IVE.QTDMOV),0) INTO nQtdTra
     FROM TT_IVE IVE
    WHERE EXISTS (SELECT TRA.FILIVE, TRA.SEQIVE
                    FROM TT_TRA TRA
                   WHERE TRA.FILIVE = IVE.CODFIL AND TRA.SEQIVE = IVE.SEQUEN AND TRA.NUMIVE = IVE.NUMITE) 
      AND IVE.FILMAT = pFilMat
      AND IVE.CODMAT = pCodMat
      AND IVE.CODCOR = pCodCor
      AND IVE.CODTAM = pCodTam
      AND INSTR(COALESCE(pCodFil, IVE.CODFIL)||';', IVE.CODFIL||';') > 0
      AND IVE.CODMUL = COALESCE(pCodMul, IVE.CODMUL)
      AND IVE.LANEST <> 'C'
      AND IVE.VEN_DATHOR BETWEEN wdIni AND wdFim;

   RETURN COALESCE(nQtdTra,0);

END;
$$ language 'plpgsql';


/*-- SEQ 1476 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TOTALTRANSFERENCIA (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1477 --*/
CREATE OR REPLACE FUNCTION TOTALTRANSFERENCIA (Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN TOTALTRANSFERENCIA($1,$2,$3,$4,$5,$6,$7,null);
END;
$$ language 'plpgsql';


/*-- SEQ 1478 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TotalVenda (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TD_MUL.CODTAB%TYPE,TT_PLA.FILPGT%TYPE,TT_PLA.CODPGT%TYPE,VARCHAR,TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE) CASCADE;

/*-- SEQ 1479 --*/
CREATE OR REPLACE FUNCTION TotalVenda (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TD_MUL.CODTAB%TYPE,TT_PLA.FILPGT%TYPE,TT_PLA.CODPGT%TYPE,VARCHAR,TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE)
RETURNS Numeric AS $$
DECLARE
pDatIni ALIAS FOR $1 ;
pDatFim ALIAS FOR $2 ;
pFilMat ALIAS FOR $3 ;
pCodMat ALIAS FOR $4 ;
pCodCor ALIAS FOR $5 ;
pCodTam ALIAS FOR $6 ;
pCodFil ALIAS FOR $7 ;
pCodmul ALIAS FOR $8 ;
pFilPgt ALIAS FOR $9 ;
pCodPgt ALIAS FOR $10 ;
pTipDia ALIAS FOR $11 ;
pFilCli ALIAS FOR $12 ;
pCodCli ALIAS FOR $13 ;
--  --------------------------------------------------------
--  Funcao que soma a quantidade total vendida do produto no periodo e plano de pagamento informados.
--
--  Return [Numeric]
--      Esta funcao retorna um numero Numeric. Caso do calculo gere <null>, a funcao altera o resultado
--      para 0 (zero);
--
--  @pDatIni [Timestamp]
--      Data inicial do periodo no formato DD/MM/YYYY. As horas serao desprezadas e redefinidas como
--      00:00:00;
--  @pDatFim [Timestamp]
--      Data final do periodo no formato DD/MM/YYYY. As horas serao desprezadas e redefinidas como
--      23:59:59;
--  @pFilMat [char(3)]
--      Codigo da filial do material do produto (TT_GRA);
--  @pCodMat [char(5)]
--      Codigo do material do produto (TT_GRA);
--  @pCodCor [Numeric(5)]
--      Codigo da cor do produto (TT_GRA);
--  @pCodTam [Numeric(5)]
--      Codigo do tamanho do produto (TT_GRA);
--  @pCodFil [VARCHAR]
--      Lista de filial da venda. Caso nao informado serao listadas as vendas de todas as filiais;
--  @pCodMul [Numeric(5)] default <null>
--      Codigo do subestoque do item da venda. Caso nao seja informado, opcao padrao, serao listados
--      todos os subestoques da loja;
--  @pFilPgt [char(3)] default <null>
--      Codigo da filial do plano de pagamento utilizado na venda. Caso nao seja informado, opcao
--      padrao, serao somados todos as vendas de todos os planos de pagamento;
--  @pCodPgt [char(3)] default <null>
--      Codigo do plano de pagamento utilizado na venda. Caso nao seja informado, opcao padrao,
--      serao somados todos as vendas de todos os planos de pagamento;
--  @pTipDia [VARCHAR(1)] default <null>
--      Tipo do dia utilizado no calculo da media. As opcoes validas sao:
--      [C] dias corridos;
--      [A] dias com a loja aberta e com estoque;
--      Se este parametro receber qualquer valor difente de C ou A, ele e ajustado para o valor C.
--  @pFilCli [char(3)] default <null> 
--      Filial do cliente utilizado na venda. Caso nao seja informado, opção
--      padrao, serao somados todos as vendas de todos os clientes;
--  @pCodCli [char(6)] default <null> 
--      Código do cliente utilizado na venda. Caso nao seja informado, opção
--      padrao, serao somados todos as vendas de todos os clientes;
--  --------------------------------------------------------
    nQtdVen         Numeric;               --  var para calcular o total
    wdIni           Timestamp;               --  data inicial do periodo com as horas
    wdFim           Timestamp;               --  data final do periodo com as horas
    wcTipDia        CHAR(1);            --  trata o parametro pTipDia
--  --------------------------------------------------------
begin
-- Pedro E. Braga - 92655 - Função Atualizada para pegar quantidade vendida através da TT_IVE, devido a TR_MOV não gravar a Venda quando realizada
-- por Simples Fatura a qual não movimenta o estoque devido a ser realizada quando tipo de entrega Futura.

    --  tratando o parametro pTipDia
    wcTipDia := pTipDia;
    IF wcTipDia NOT IN ('A','C')
    OR ISNULL(wcTipDia)='T' THEN
        wcTipDia := 'C';
    END IF;
    --  ajustando o periodo com as horas
    wdIni := TRUNC(pDatIni);
    wdFim := TO_DATE(TO_CHAR(TRUNC(pDatFim), 'DD/MM/YYYY') || ' 23:59:59', 'DD/MM/YYYY HH24:MI:SS');

   --
   IF wcTipDia = 'C' then
      --  dias corridos (padrao)
      SELECT SUM(IVE.QTDMOV) INTO nQtdVen
        FROM TT_IVE IVE
       INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
       INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
       WHERE VEN.LANVEN = 'T'
          AND VEN.FILPGT = COALESCE(pFilPgt, VEN.FILPGT)
          AND VEN.CODPGT = COALESCE(pCodPgt, VEN.CODPGT)
          AND VEN.FILCLI = COALESCE(pFilCli, VEN.FILCLI)
          AND VEN.CODCLI = COALESCE(pCodCli, VEN.CODCLI)                  
          AND IVE.LANEST IN ('S','R')
          AND IVE.SITMOV <> 'C'
          AND IVE.SITKIT <> '1'
          AND IVE.FILMAT = pFilMat
          AND IVE.CODMAT = pCodMat
          AND IVE.CODCOR = pCodCor
          AND IVE.CODTAM = pCodTam
          AND IVE.VEN_DATHOR BETWEEN wdIni AND wdFim
          AND INSTR(COALESCE(pCodFil, IVE.CODFIL)||';', IVE.CODFIL||';') > 0
          AND IVE.CODMUL = COALESCE(pCodMul, IVE.CODMUL)
          AND DNAT.TIPNAT <> 'M'; -- Devolução de Compra
   ELSE
      --  dias com a loja aberta e com estoque
     SELECT SUM(IVE.QTDMOV) INTO nQtdVen
       FROM TT_IVE IVE
      INNER JOIN TT_VEN VEN ON IVE.CODFIL = VEN.CODFIL AND  IVE.SEQUEN = VEN.SEQUEN
      INNER JOIN TR_MOV RMOV ON IVE.FILMAT = RMOV.FILMAT AND IVE.CODMAT = RMOV.CODMAT
                            AND IVE.CODCOR = RMOV.CODCOR AND IVE.CODTAM = RMOV.CODTAM
                            AND TRUNC(IVE.VEN_DATHOR) = RMOV.DATMOV
                            AND IVE.CODFIL = RMOV.CODFIL AND IVE.CODMUL = RMOV.CODMUL
      INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
      WHERE VEN.LANVEN = 'T'
        AND VEN.FILPGT = COALESCE(pFilPgt, VEN.FILPGT)
        AND VEN.CODPGT = COALESCE(pCodPgt, VEN.CODPGT)
        AND VEN.FILCLI = COALESCE(pFilCli, VEN.FILCLI)
        AND VEN.CODCLI = COALESCE(pCodCli, VEN.CODCLI)        
        AND IVE.LANEST IN ('S','R')
        AND IVE.SITMOV <> 'C'
        AND IVE.SITKIT <> '1'
        AND IVE.FILMAT = pFilMat
        AND IVE.CODMAT = pCodMat
        AND IVE.CODCOR = pCodCor
        AND IVE.CODTAM = pCodTam
        AND IVE.VEN_DATHOR BETWEEN wdIni AND wdFim
        AND INSTR(COALESCE(pCodFil, IVE.CODFIL)||';', IVE.CODFIL||';') > 0
        AND IVE.CODMUL = COALESCE(pCodMul, IVE.CODMUL)
        AND (COALESCE(RMOV.SALANT, 0) - COALESCE(RMOV.QTDCOM, 0) +
             COALESCE(RMOV.QTDOUT, 0)) > 0
        AND DNAT.TIPNAT <> 'M'; -- Devolução de Compra
   END IF;
--  --------------------------------------------------------
   RETURN COALESCE(nQtdVen, 0);
END;
$$ language 'plpgsql';


/*-- SEQ 1480 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TotalVenda (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1481 --*/
CREATE OR REPLACE FUNCTION TotalVenda (Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN TotalVenda($1,$2,$3,$4,$5,$6,$7,null,null,null,null,null,null);
END;
$$ language 'plpgsql';


/*-- SEQ 1482 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TotalVenda (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TD_MUL.CODTAB%TYPE) CASCADE;

/*-- SEQ 1483 --*/
CREATE OR REPLACE FUNCTION TotalVenda (Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR,
                               TD_MUL.CODTAB%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN TotalVenda($1,$2,$3,$4,$5,$6,$7,$8,null,null,null,null,null);
END;
$$ language 'plpgsql';


/*-- SEQ 1484 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TotalVenda (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TD_MUL.CODTAB%TYPE,TT_PLA.FILPGT%TYPE,TT_PLA.CODPGT%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1485 --*/
CREATE OR REPLACE FUNCTION TotalVenda (Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR,
                               TD_MUL.CODTAB%TYPE,
                               TT_PLA.FILPGT%TYPE,
                               TT_PLA.CODPGT%TYPE,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN TotalVenda($1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,null,null);
END;
$$ language 'plpgsql';

 
 
 
 
 


/*-- SEQ 1486 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION UPDATCFG () CASCADE;

/*-- SEQ 1487 --*/
CREATE OR REPLACE FUNCTION UPDATCFG ()
RETURNS VARCHAR AS $$
DECLARE

BEGIN

-- Esta funcao e usada apenas pelo config para atualizar a tabela TT_CFG a partir da TW_CFG.
-- Respeite a organizao dos campos nas 7 colunas.
--Col1....................|Col2....................|Col3....................|Col4....................|Col5....................|Col6....................|Col7....................

UPDATE TT_CFG
   SET PORTKE = W.PORTKE,
        DEPOSITA_CHETRO = W.DEPOSITA_CHETRO,
        NOMEMP = W.NOMEMP,
        VC_FILCLI = W.VC_FILCLI,
        VC_CODCLI = W.VC_CODCLI,
        VC_CLIENTE = W.VC_CLIENTE,
        VC_FILPGT = W.VC_FILPGT,
        VC_CODPGT = W.VC_CODPGT,
        VC_PLANO = W.VC_PLANO,
        VC_SERIE = W.VC_SERIE,
        REDICMFRE = W.REDICMFRE,
        ARREDONDAC = W.ARREDONDAC,
        PCOONLINE = W.PCOONLINE,
        CDCO = W.CDCO,
        PEDCOMPDE = W.PEDCOMPDE,
        PEDCOMPATE = W.PEDCOMPATE,
        DATA1 = W.DATA1,
        DATA2 = W.DATA2,
        DATA3 = W.DATA3,
        SINGULINT = W.SINGULINT,
        PLURALINT = W.PLURALINT,
        SINGULDEC = W.SINGULDEC,
        PLURALDEC = W.PLURALDEC,
        TAXMES = W.TAXMES,
        EXTENSMALA = W.EXTENSMALA,
        PATIPOREF = W.PATIPOREF,
        AU_IMPRESS = W.AU_IMPRESS,
        AU_INIC = W.AU_INIC,
        AU_ENTREL = W.AU_ENTREL,
        AU_ENTRELC = W.AU_ENTRELC,
        AU_IMPRIM = W.AU_IMPRIM,
        AU_VEZES = W.AU_VEZES,
        AU_TAMVLR = W.AU_TAMVLR,
        AU_HABLIN = W.AU_HABLIN,
        AU_DESLIN = W.AU_DESLIN,
        AU_AUTENT = W.AU_AUTENT,
        AU_DESAUT = W.AU_DESAUT,
        AU_LNFEED = W.AU_LNFEED,
        ABCQA = W.ABCQA,
        ABCVA = W.ABCVA,
        ABCQB = W.ABCQB,
        ABCVB = W.ABCVB,
        ABCQC = W.ABCQC,
        ABCVC = W.ABCVC,
        CATEG1 = W.CATEG1,
        CATEG2 = W.CATEG2,
        CATEG3 = W.CATEG3,
        CLASS1 = W.CLASS1,
        CLASS2 = W.CLASS2,
        CLASS3 = W.CLASS3,
        CLASS4 = W.CLASS4,
        DESVEN = W.DESVEN,
        NUMVEN = W.NUMVEN,
        ATU_EM = W.ATU_EM,
        CLICODEXT = W.CLICODEXT,
        NOMNUMSER = W.NOMNUMSER,
        NOMNUMREG = W.NOMNUMREG,
        NOMCODSAC = W.NOMCODSAC,
        NOMLSTSAC = W.NOMLSTSAC,
        PERCOM = W.PERCOM,
        SUBCODSAC = W.SUBCODSAC,
        MASK_LOCALI = W.MASK_LOCALI,
        PERIR = W.PERIR,
        RBPATH = W.RBPATH,
        CHEQUEMINIMO = W.CHEQUEMINIMO,
        VLDORC = W.VLDORC,
        DESPAP_DIRETORIA = W.DESPAP_DIRETORIA,
        MAXPER = W.MAXPER,
        CHEQUE = W.CHEQUE,
        MAI_FR = W.MAI_FR,
        MAI_TO = W.MAI_TO,
        CONTATO_FINANCEIRO = W.CONTATO_FINANCEIRO,
        CHESTD = W.CHESTD,
        USOSTD = W.USOSTD,
        USADOC = W.USADOC,
        TIPPOS = W.TIPPOS,
        TIPFAR = W.TIPFAR,
        TAXFIN = W.TAXFIN,
        PRAFIN = W.PRAFIN,
        SERIE_FAT_CC = W.SERIE_FAT_CC,
        CC_CHECKOUT = W.CC_CHECKOUT,
        NAT_FAT_CC = W.NAT_FAT_CC,
        LIM_SAQUE_CC = W.LIM_SAQUE_CC,
        PATH_ANEXOS = W.PATH_ANEXOS,
        FILCTA_TRN = W.FILCTA_TRN,
        SEQCTA_TRN = W.SEQCTA_TRN,
        TIPCTA_TRN = W.TIPCTA_TRN,
        CARENCIA = W.CARENCIA,
        VLDCLIEXT = W.VLDCLIEXT,
        CARENCIAMEDICAMENTO = W.CARENCIAMEDICAMENTO,
        TIPSOFT = W.TIPSOFT,
        FMTREQ = W.FMTREQ,
        FMTDOC = W.FMTDOC,
        CODNAT_REIMP_CF = W.CODNAT_REIMP_CF,
        MOVEST_REIMP_CF = W.MOVEST_REIMP_CF,
        FINANC_REIMP_CF = W.FINANC_REIMP_CF,
        TRIBUT_REIMP_CF = W.TRIBUT_REIMP_CF,
        LANVEN_REIMP_CF = W.LANVEN_REIMP_CF,
        VLDESTEXT = W.VLDESTEXT,
        VALIDA_NUMDOC = W.VALIDA_NUMDOC,
        FILPRE = W.FILPRE,
        CODPRE = W.CODPRE,
        CHETRO = W.CHETRO,
        PATH_PROJETOS = W.PATH_PROJETOS,
        INT_CAN_TIT = W.INT_CAN_TIT,
        INT_ALT_DAT = W.INT_ALT_DAT,
        INT_ALT_VLR = W.INT_ALT_VLR,
        INT_PAG_CAR = W.INT_PAG_CAR,
        INT_INC_TIT = W.INT_INC_TIT,
        INT_CON_DES = W.INT_CON_DES,
        INT_CAN_DES = W.INT_CAN_DES,
        INT_PRT_TIT = W.INT_PRT_TIT,
        INT_S_B_PRT = W.INT_S_B_PRT,
        INT_S_C_PRT = W.INT_S_C_PRT,
        COD_ECB_TIT = W.COD_ECB_TIT,
        VENDE_DESATIVADOS = W.VENDE_DESATIVADOS,
        CKBEMVINDO = W.CKBEMVINDO,
        CKNOMATEND = W.CKNOMATEND,
        CKVLRINFUN = W.CKVLRINFUN,
        CKUSABALAN = W.CKUSABALAN,
        CKNUMEXTDP = W.CKNUMEXTDP,
        CKPANUMEXT = W.CKPANUMEXT,
        CKPAOBRVEN = W.CKPAOBRVEN,
        CKPAQTDDEC = W.CKPAQTDDEC,
        CKPAPREDEC = W.CKPAPREDEC,
        CKPADIASAT = W.CKPADIASAT,
        CKPAAGRUPA = W.CKPAAGRUPA,
        CKPACONSFI = W.CKPACONSFI,
        CKUSADEBAP = W.CKUSADEBAP,
        CKPAPAGIRR = W.CKPAPAGIRR,
        CKPAVLRIRR = W.CKPAVLRIRR,
        CKPRECOSUB = W.CKPRECOSUB,
        CKPASAICHE = W.CKPASAICHE,
        CKPAMFIMPP = W.CKPAMFIMPP,
        CKPADIGCHE = W.CKPADIGCHE,
        CKPAPREDOC = W.CKPAPREDOC,
        CKPAVLRAPR = W.CKPAVLRAPR,
        CKPASAICAI = W.CKPASAICAI,
        CKPAUNICAI = W.CKPAUNICAI,
        CKPAQTDAUT = W.CKPAQTDAUT,
        CKPATXTPRE = W.CKPATXTPRE,
        CKPAVENITE = W.CKPAVENITE,
        CKPATOTVEN = W.CKPATOTVEN,
        CKPADESCIT = W.CKPADESCIT,
        CKPADESCTO = W.CKPADESCTO,
        CKFTXTSUB1 = W.CKFTXTSUB1,
        CKFTXTSUB2 = W.CKFTXTSUB2,
        CKFTXTSUB3 = W.CKFTXTSUB3,
        CKFTXTSUB4 = W.CKFTXTSUB4,
        CKFORCOMIT = W.CKFORCOMIT,
        CKFORCOMV1 = W.CKFORCOMV1,
        CKFORCOMV2 = W.CKFORCOMV2,
        CKFORCOMS1 = W.CKFORCOMS1,
        CKFORCOMS2 = W.CKFORCOMS2,
        CKFORCOMS3 = W.CKFORCOMS3,
        CKFORCOMS4 = W.CKFORCOMS4,
        CKPACOML1 = W.CKPACOML1,
        CKPACOML2 = W.CKPACOML2,
        CKPACOML3 = W.CKPACOML3,
        CKPACOML4 = W.CKPACOML4,
        CICLOPRE = W.CICLOPRE,
        SAC_MAIL_FILUSU = W.SAC_MAIL_FILUSU,
        SAC_MAIL_CODUSU = W.SAC_MAIL_CODUSU,
        CLI_CODSEX = W.CLI_CODSEX,
        CLI_ESTCIV = W.CLI_ESTCIV,
        CLI_CATEG1 = W.CLI_CATEG1,
        CLI_CATEG2 = W.CLI_CATEG2,
        CLI_CATEG3 = W.CLI_CATEG3,
        CLI_DATNAS = W.CLI_DATNAS,
        CLI_DOCCON = W.CLI_DOCCON,
        CLI_NASCON = W.CLI_NASCON,
        CLI_CONJUG = W.CLI_CONJUG,
        CLI_INSEST = W.CLI_INSEST,
        CLI_NUMFON = W.CLI_NUMFON,
        CLI_ENDERE = W.CLI_ENDERE,
        CLI_CODCEP = W.CLI_CODCEP,
        DAT_CHRPRE = W.DAT_CHRPRE,
        DAT_CHRDEP = W.DAT_CHRDEP,
        DAT_CHRDES = W.DAT_CHRDES,
        DAT_CHRDEV1 = W.DAT_CHRDEV1,
        DAT_CHRDEV2 = W.DAT_CHRDEV2,
        DAT_RESERV = W.DAT_RESERV,
        CC_WORKFLOW = W.CC_WORKFLOW,
        PaTipoDesconto = W.PaTipoDesconto,
        CREDIT_SCORE = W.CREDIT_SCORE,
        PaPhoto = W.PaPhoto,
        PaPhoDuplo = W.PaPhoDuplo,
        PaPhoAmplia = W.PaPhoAmplia,
        PaPhoTempo = W.PaPhoTempo,
        PaPhoEtiqueta = W.PaPhoEtiqueta,
        PaPhoFor1 = W.PaPhoFor1,
        PaPhoForS = W.PaPhoForS,
        PaPhoVar1 = W.PaPhoVar1,
        PaPhoVar2 = W.PaPhoVar2,
        PaPhoVar3 = W.PaPhoVar3,
        PaPhoFilRevela = W.PaPhoFilRevela,
        PaPhoFilAmplia = W.PaPhoFilAmplia,
        PaPhoFilRevAmp = W.PaPhoFilRevAmp,
        PaPhoCodRevela = W.PaPhoCodRevela,
        PaPhoCodAmplia = W.PaPhoCodAmplia,
        PaPhoCodRevAmp = W.PaPhoCodRevAmp,
        PaPhoObsPadrao = W.PaPhoObsPadrao,
        PRE_PSI_UTILIZA = W.PRE_PSI_UTILIZA,
        PRE_PSI_1_CENTAVO = W.PRE_PSI_1_CENTAVO,
        PRE_PSI_10_CENTAVOS = W.PRE_PSI_10_CENTAVOS,
        PRE_PSI_1_REAL = W.PRE_PSI_1_REAL,
        PRE_PSI_10_REAIS = W.PRE_PSI_10_REAIS,
        PRE_PSI_100_REAIS = W.PRE_PSI_100_REAIS,
        PRE_PSI_DIGITO = W.PRE_PSI_DIGITO,
        PRE_PSI_PERCENTUAL = W.PRE_PSI_PERCENTUAL,
        ULTSAC_FILUSU = W.ULTSAC_FILUSU,
        PLANO_PGT_WOR_PROP = W.PLANO_PGT_WOR_PROP,
        ULTSAC_CODUSU = W.ULTSAC_CODUSU,
        FATURA_CC_POR_FILIAL = W.FATURA_CC_POR_FILIAL,
        PaListaDebitos = W.PaListaDebitos,
        E_MAIL_FINANC = W.E_MAIL_FINANC,
        PATH_ARQUIVOS = W.PATH_ARQUIVOS,
        CC_DEVOLUCAO = W.CC_DEVOLUCAO,
        MEIO_TAXASERVICO = W.MEIO_TAXASERVICO,
        PAPREDATARCONSUMIDOR = W.PAPREDATARCONSUMIDOR,
        ACAO_DEVOLUCAO = W.ACAO_DEVOLUCAO,
        SAC_POS_VENDA = W.SAC_POS_VENDA,
        RESTRICAO_VINCULO = W.RESTRICAO_VINCULO,
        Une_Nome_SobreNome = W.Une_Nome_SobreNome,
        RECPAR_DEVOLUCAO = W.RECPAR_DEVOLUCAO,
        FILPRJ = W.FILPRJ,
        SEQPRJ = W.SEQPRJ,
        CLIENTE_POR_DOC = W.CLIENTE_POR_DOC,
        E_MAIL_ESTOQUE = W.E_MAIL_ESTOQUE,
        PAPHOTIPLAN = W.PAPHOTIPLAN,
        COB_USA_SAC = W.COB_USA_SAC,
        COB_DIAS_VENCTO = W.COB_DIAS_VENCTO,
        COB_DIAS_DEVOLUCAO1 = W.COB_DIAS_DEVOLUCAO1,
        COB_DIAS_DEVOLUCAO2 = W.COB_DIAS_DEVOLUCAO2,
        COB_DIAS_SPC_REC = W.COB_DIAS_SPC_REC,
        COB_DIAS_SPC_CHR = W.COB_DIAS_SPC_CHR,
        COB_DIAS_CARTA1_REC = W.COB_DIAS_CARTA1_REC,
        COB_DIAS_CARTA1_CHR = W.COB_DIAS_CARTA1_CHR,
        COB_DIAS_CARTA2_REC = W.COB_DIAS_CARTA2_REC,
        COB_DIAS_CARTA2_CHR = W.COB_DIAS_CARTA2_CHR,
        COB_MOD_CODCOR1 = W.COB_MOD_CODCOR1,
        COB_MOD_CODCOR2 = W.COB_MOD_CODCOR2,
        COB_FORMA_REGISTRO = W.COB_FORMA_REGISTRO,
        COB_OUTROS_PAGTOS = W.COB_OUTROS_PAGTOS,
        COB_E_MAIL_SAC = W.COB_E_MAIL_SAC,
        COB_E_MAIL_CARTAS = W.COB_E_MAIL_CARTAS,
        COB_E_MAIL_SPC = W.COB_E_MAIL_SPC,
        COB_FIL_GERENTE = W.COB_FIL_GERENTE,
        COB_COD_GERENTE = W.COB_COD_GERENTE,
        PRE_ARR_1_CENTAVO = W.PRE_ARR_1_CENTAVO,
        PRE_ARR_10_CENTAVOS = W.PRE_ARR_10_CENTAVOS,
        PRE_ARR_1_REAL = W.PRE_ARR_1_REAL,
        PRE_ARR_10_REAIS = W.PRE_ARR_10_REAIS,
        PRE_ARR_100_REAIS = W.PRE_ARR_100_REAIS,
        E_MAIL_ERRO = W.E_MAIL_ERRO,
        CKDESCECF = W.CKDESCECF,
        TAMANHO_OBSERVACAO = W.TAMANHO_OBSERVACAO,
        CANCELA_RESERVA = W.CANCELA_RESERVA,
        USA_RENEGOCIACAO_SAC = W.USA_RENEGOCIACAO_SAC,
        CLI_CALL_C = W.CLI_CALL_C,
        COMPENSACAO_AUTOMATICA = W.COMPENSACAO_AUTOMATICA,
        VALORTRANSFERENCIA = W.VALORTRANSFERENCIA,
        EXPORTA_ESCRITA = W.EXPORTA_ESCRITA,
        MESES_CARTEIRA_MIN = W.MESES_CARTEIRA_MIN,
        MESES_CARTEIRA_MAX = W.MESES_CARTEIRA_MAX,
        CkPaMFL1 = W.CkPaMFL1,
        CkPaMFL2 = W.CkPaMFL2,
        CkPaMFL3 = W.CkPaMFL3,
        CkPaMFL4 = W.CkPaMFL4,
        EXPORTA_TODOS_CLIENTES = W.EXPORTA_TODOS_CLIENTES,
        PDA_PATH_IMPORTACAO = W.PDA_PATH_IMPORTACAO,
        PDA_PATH_EXPORTACAO = W.PDA_PATH_EXPORTACAO,
        PDA_INTEGRACAO = W.PDA_INTEGRACAO,
        PDA_FILPRE = W.PDA_FILPRE,
        PDA_CODPRE = W.PDA_CODPRE,
        PaEstoqueVenda = W.PaEstoqueVenda,
        CC_CredFornecedor = W.CC_CredFornecedor,
        USA_PLACA_ORCAMENTO = W.USA_PLACA_ORCAMENTO,
        VINCULO_PLACA_ORCAMENTO = W.VINCULO_PLACA_ORCAMENTO,
        HOR_SEPARA = W.HOR_SEPARA,
        CLI_NOMCID = W.CLI_NOMCID,
        CLI_BAIRRO = W.CLI_BAIRRO,
        NAT_CREICM = W.NAT_CREICM,
        TRANSFER_NAT = W.TRANSFER_NAT,
        TRANSFER_SER = W.TRANSFER_SER,
        BASE_MARKUP = W.BASE_MARKUP,
        PDA_GRUPO = W.PDA_GRUPO,
        PDA_SUBGRUPO = W.PDA_SUBGRUPO,
        CLI_REGIAO = W.CLI_REGIAO,
        SAC_EXIGE_CODFUN = W.SAC_EXIGE_CODFUN,
        SAC_EXIGE_CODCWS = W.SAC_EXIGE_CODCWS,
        DIAS_ACEITE_AUTOMATICO = W.DIAS_ACEITE_AUTOMATICO,
        EXPIRAR_SENHA = W.EXPIRAR_SENHA,
        DIAS_COMPENSACAO_AUTOMATICA = W.DIAS_COMPENSACAO_AUTOMATICA,
        FILSRV = W.FILSRV,
        CODSRV = W.CODSRV,
        TIPSRV = W.TIPSRV,
        MEIO_ABATIMENTO = W.MEIO_ABATIMENTO,
        USA_PERC_HORFAL = W.USA_PERC_HORFAL,
        ARREDONPAR = W.ARREDONPAR,
        SUGERE_SERVICOS = W.SUGERE_SERVICOS,
        DADOS_PATH_EXPORTA = W.DADOS_PATH_EXPORTA,
        DADOS_PATH_IMPORTA = W.DADOS_PATH_IMPORTA,
        GERA_CODEXT_INTEGRACAO = W.GERA_CODEXT_INTEGRACAO,
        VALORTOLERANCIA = W.VALORTOLERANCIA,
        LIMCREDITO_SOMALIM = W.LIMCREDITO_SOMALIM,
        ENVIADATFATURAMENTO = W.ENVIADATFATURAMENTO,
        CKFORDES = W.CKFORDES,
        SOLICITA_END_CF = W.SOLICITA_END_CF,
        IMP_CF_NF = W.IMP_CF_NF,
        CUSTO_POR_FILIAL = W.CUSTO_POR_FILIAL,
        PARC_CARTAO = W.PARC_CARTAO,
        PARC_CLIENTE_TRANSP = W.PARC_CLIENTE_TRANSP,
        PARC_FORNECEDOR = W.PARC_FORNECEDOR,
        PARC_INDICA_VENDA = W.PARC_INDICA_VENDA,
        PARC_MARCA = W.PARC_MARCA,
        PARC_MOTORISTA = W.PARC_MOTORISTA,
        PARC_REPRESENTANTE = W.PARC_REPRESENTANTE,
        PARC_TEC_INTERNO = W.PARC_TEC_INTERNO,
        PARC_TRANSPORTADOR = W.PARC_TRANSPORTADOR,
        PARC_TECNICO_EXTERNO = W.PARC_TECNICO_EXTERNO,
        PARC_USUARIO = W.PARC_USUARIO,
        IMPEDE_ORC_MAIOR_LIMITE = W.IMPEDE_ORC_MAIOR_LIMITE,
        SAC_EXIGE_MODULO = W.SAC_EXIGE_MODULO,
        CKPAPESQIDENT = W.CKPAPESQIDENT,
        IMPEDE_ALTERACAO_PEDIDO = W.IMPEDE_ALTERACAO_PEDIDO,
        TIPCTA_ECF = W.TIPCTA_ECF,
        SUP_APROVA_RESTRICAO = W.SUP_APROVA_RESTRICAO,
        OBRIG_ICMS_PED = W.OBRIG_ICMS_PED,
        SPC_PARCELA = W.SPC_PARCELA,
        TRANSFER_CODCFO = W.TRANSFER_CODCFO,
        CLI_CONTAT = W.CLI_CONTAT,
        AVISA_ESTOQUE_NEG = W.AVISA_ESTOQUE_NEG,
        SAC_CODFUN = W.SAC_CODFUN,
        SAC_TIPSUP = W.SAC_TIPSUP,
        SAC_CODPRI = W.SAC_CODPRI,
        SAC_TIPREG = W.SAC_TIPREG,
        SAC_FLGSIT = W.SAC_FLGSIT,
        NOME_CLASSIFICACAO = W.NOME_CLASSIFICACAO,
        MAXDIAREC = W.MAXDIAREC,
        CFOPPERDAS = W.CFOPPERDAS,
        TIPCCC_PMI = W.TIPCCC_PMI,
        FIL_DIMED = W.FIL_DIMED,
        COD_DIMED = W.COD_DIMED,
        FIL_PANARELLO = W.FIL_PANARELLO,
        COD_PANARELLO = W.COD_PANARELLO,
        FIL_DIMPER = W.FIL_DIMPER,
        COD_DIMPER = W.COD_DIMPER,
        FIL_PROFARMA = W.FIL_PROFARMA,
        COD_PROFARMA = W.COD_PROFARMA,
        FIL_GENESIO = W.FIL_GENESIO,
        COD_GENESIO = W.COD_GENESIO,
        FIL_SANTACRUZ = W.FIL_SANTACRUZ,
        COD_SANTACRUZ = W.COD_SANTACRUZ,
        PRO_CODLPC = W.PRO_CODLPC,
        PRO_CONTRO = W.PRO_CONTRO,
        CL4WEB = W.CL4WEB,
        IGNORA_RESERVA = W.IGNORA_RESERVA,
        IGNORA_VINCULO = W.IGNORA_VINCULO,
        PENAUT = W.PENAUT,
        FILCMP = W.FILCMP,
        ATUPED = W.ATUPED,
        BONUS_ONLINE = W.BONUS_ONLINE,
        VALIDA_ESTOQUE_ORDER = W.VALIDA_ESTOQUE_ORDER,
        MOSTRA_REPASSE = W.MOSTRA_REPASSE,
        ENVIAR_ENTREGA = W.ENVIAR_ENTREGA,
        NATFAT = W.NATFAT,
        NATVEN = W.NATVEN,
        MULT_VENDEDORES = W.MULT_VENDEDORES,
        ARECEBER_PASSA_ECF = W.ARECEBER_PASSA_ECF,
        CFOP_COM_ECF = W.CFOP_COM_ECF,
        LOGOBOLETO = W.LOGOBOLETO,
        DOPCCC = W.DDOP_CCC,
        OBRIGA_CODEAN = W.OBRIGA_CODEAN,
        REUTILIZA_REFERENCIA = W.REUTILIZA_REFERENCIA,
        TIPCCC_RAT = W.TIPCCC_RAT,
        FILIAL_CONTRATO = W.FILIAL_CONTRATO,
        CARENCIA_RESTRI = W.CARENCIA_RESTRI,
        PER_CPMF = W.PER_CPMF,
        CUSTO_LIGACAO = W.CUSTO_LIGACAO,
        TROCO_TEF = W.TROCO_TEF,
        VENDA_CC_E_OUTROS = W.VENDA_CC_E_OUTROS,
        TAXA_TEF_NO_PRECO = W.TAXA_TEF_NO_PRECO,
        LOJA_FECHADA = W.LOJA_FECHADA,
        CC_CARTAFRETE = W.CC_CARTAFRETE,
        USA_PREATENDIMENTO = W.USA_PREATENDIMENTO,
        CUSTO_LUCRO_MARKUP = W.CUSTO_LUCRO_MARKUP,
        CUSTOFINMENSAL = W.CUSTOFINMENSAL,
        DIAS_TEF_NO_PRECO = W.DIAS_TEF_NO_PRECO,
        ALTERA_PRECO_ORC_SEPARADO = W.ALTERA_PRECO_ORC_SEPARADO,
        VLRMIN_WOR_PROP = W.VLRMIN_WOR_PROP,
        FILPGT_WOR_PROP = W.FILPGT_WOR_PROP,
        CODPGT_WOR_PROP = W.CODPGT_WOR_PROP,
        CC_WOR_PROP = W.CC_WOR_PROP,
        PERURG_PROP = W.PERURG_PROP,
        FILPAP_DIRETORIA = W.FILPAP_DIRETORIA,
        SEQPAP_DIRETORIA = W.SEQPAP_DIRETORIA,
        PER_TROCA_CHEQUE = W.PER_TROCA_CHEQUE,
        MIN_ABASTEC_CHEQUE = W.MIN_ABASTEC_CHEQUE,
        CC_VALE_PRESENTE = W.CC_VALE_PRESENTE,
        CKBLOQREFBAS = W.CKBLOQREFBAS,
        RATEIO_FRETE = W.RATEIO_FRETE,
        PATH_BASE = W.PATH_BASE,
        DIAS_EXPIRAR_PEDIDO = W.DIAS_EXPIRAR_PEDIDO,
        TAXCRE_PREATEND = W.TAXCRE_PREATEND,
        DIACRE_PREATEND = W.DIACRE_PREATEND,
        TAXDEB_PREATEND = W.TAXDEB_PREATEND,
        DIADEB_PREATEND = W.DIADEB_PREATEND,
        USA_VM_DECISOR = W.USA_VM_DECISOR,
        DEVTRA_NAT = W.DEVTRA_NAT,
        DEVTRA_CFO = W.DEVTRA_CFO,
        HOR_SERASA = W.HOR_SERASA,
        DIAS_ULTCOM = W.DIAS_ULTCOM,
        ROMANEIO_FILIAL = W.ROMANEIO_FILIAL,
        RESERVA_ENT_FUT = W.RESERVA_ENT_FUT,
        TIPLAN_PPR = W.TIPLAN_PPR,
        TIPLAN_INS = W.TIPLAN_INS,
        PATH_TTSEGUR = W.PATH_TTSEGUR,
        PORMTV = W.PORMTV,
        TIPRTT_AGENC = W.TIPRTT_AGENC,
        TIPRTT_ESTAC = W.TIPRTT_ESTAC,
        NAT_CONSIGNACAO = W.NAT_CONSIGNACAO,
        MEIO_ESTAC = W.MEIO_ESTAC,
        CKPANUMEXT_NAO_DAV = W.CKPANUMEXT_NAO_DAV,
        CKPANUMEXT_DEP = W.CKPANUMEXT_DEP,
        BRU_APROVADA = W.BRU_APROVADA,
        ECOM_VISA = W.ECOM_VISA,
        ECOM_MASTER = W.ECOM_MASTER,
        ECOM_AMEX = W.ECOM_AMEX,
        ENTREGA_CF = W.ENTREGA_CF,
        DEST_ST_DEV = W.DEST_ST_DEV,
        LIMDIA = W.LIMDIA,
        PERCOM_FPV = W.PERCOM_FPV,
        DSER_NFCOMPL = W.DSER_NFCOMPL,
        GRAVALOG = W.GRAVALOG,
        TOTALLECBASE = W.TOTALLECBASE,
        TOTALLECHOST = W.TOTALLECHOST,
        TOTALLECPORT = W.TOTALLECPORT,
        SUBSTT_CONSFI = W.SUBSTT_CONSFI,
        ST_NO_FRETE = W.ST_NO_FRETE,
        CKGRADEPESAVEL = W.CKGRADEPESAVEL,
        DEV_FATVIN = W.DEV_FATVIN,
        USA_CTA_TRANSITO_TRANSF_IDENT = W.USA_CTA_TRANSITO_TRANSF_IDENT,
        VENDA_ESTRANGEIRO = W.VENDA_ESTRANGEIRO,
        METCLI = W.METCLI,
        DIAVEN = W.DIAVEN,
        CKPAVALABE = W.CKPAVALABE,
        VARIACAO_CUSTO = W.VARIACAO_CUSTO,
        BAIPED = W.BAIPED,
        CKPAFILDAV = W.CKPAFILDAV,
        SEPARAR_ENTREGA = W.SEPARAR_ENTREGA,
        GIRO_ESTOQUE = W.GIRO_ESTOQUE,
        FILTRA_FORNEC_PEDIDO = W.FILTRA_FORNEC_PEDIDO,
        VEI_ORC = W.VEI_ORC,
        CKPACONFERE_DAV = W.CKPACONFERE_DAV,
        CKPAAUT_DEV_FRETE = W.CKPAAUT_DEV_FRETE,
        ARREDONDAM = W.ARREDONDAM,
        TRANSPICM = W.TRANSPICM,
        FILCOB = W.FILCOB,
        FILENT = W.FILENT,
        FIL_BASF = W.FIL_BASF,
        COD_BASF = W.COD_BASF,
        VALOR_BON = W.VALOR_BON,
        DATA_BONUS = W.DATA_BONUS,
        DIAS_BONUS = W.DIAS_BONUS,
        NATBON = W.NATBON,
        CLI_VLRVEN_BON = W.CLI_VLRVEN_BON,
        CLI_QTDBON = W.CLI_QTDBON,
        LIM_TIPTOL = W.LIM_TIPTOL,
        LIM_PERTOL = W.LIM_PERTOL,
        LIM_VALTOL = W.LIM_VALTOL,
        VDD_CKPAVENITE = W.VDD_CKPAVENITE,
        VDD_CKPATOTVEN = W.VDD_CKPATOTVEN,
        IND_CKPAVENITE = W.IND_CKPAVENITE,
        IND_CKPATOTVEN = W.IND_CKPATOTVEN,
        VDD_VLRVEN_BON = W.VDD_VLRVEN_BON,
        VDD_QTDBON = W.VDD_QTDBON,
        IND_VLRVEN_BON = W.IND_VLRVEN_BON,
        IND_QTDBON = W.IND_QTDBON,
        TIPRTT_RCEL = W.TIPRTT_RCEL,
        USA_DCAI_0 = W.USA_DCAI_0,
        VALOR_AQUISICAO = W.VALOR_AQUISICAO,
        BLQ_CF_RETIRA_DEPOSITO = W.BLQ_CF_RETIRA_DEPOSITO,
        DIAS_ABC_XYZ = W.DIAS_ABC_XYZ,
        DIAS_NUMVEN = W.DIAS_NUMVEN,
        PER_A = W.PER_A,
        PER_B = W.PER_B,
        PER_C = W.PER_C,
        PER_X = W.PER_X,
        PER_Y = W.PER_Y,
        PER_Z = W.PER_Z,
        FPV_PRECO_SIMULADO = W.FPV_PRECO_SIMULADO,
        FILMAT_TIN = W.FILMAT_TIN,
        CODMAT_TIN = W.CODMAT_TIN,
        CODCOR_TIN = W.CODCOR_TIN,
        CODTAM_TIN = W.CODTAM_TIN,
        REGRA_CLSABC = W.REGRA_CLSABC,
        REGRA_CLSXYZ = W.REGRA_CLSXYZ,
        TIPDIA_FLUXO = W.TIPDIA_FLUXO,
        PRAZO_ENT_PEDIDO = W.PRAZO_ENT_PEDIDO,
        PARC_PEDIDO = W.PARC_PEDIDO,
        TIPDIA_ELASTICIDADE = W.TIPDIA_ELASTICIDADE,
        DIAS_VARPRE = W.DIAS_VARPRE,
        DEVCOMPRANFEIMPOSTO = W.DEVCOMPRANFEIMPOSTO,
        NATRESSARCIMENTOST = W.NATRESSARCIMENTOST,
        NATADJUDICACAOICMS = W.NATADJUDICACAOICMS,
        REGRA_MEDIA_VENDAS = W.REGRA_MEDIA_VENDAS,
        DIAS_REC_PEDIDOS = W.DIAS_REC_PEDIDOS,
        CLIREVSEMIE = W.CLIREVSEMIE,
        TIPDIA_VDU_PP = W.TIPDIA_VDU_PP,
        FILMAT_AUX = W.FILMAT_AUX,
        CODMAT_AUX = W.CODMAT_AUX,
        CODCOR_AUX = W.CODCOR_AUX,
        CODTAM_AUX = W.CODTAM_AUX,
        NATDEVCOMP = W.NATDEVCOMP,
        CK4G_VERSAO_HOMOL = W.CK4G_VERSAO_HOMOL,
        CK4G_DETVER_HOMOL = W.CK4G_DETVER_HOMOL,
        CK4G_RELEAS_HOMOL = W.CK4G_RELEAS_HOMOL,
        CK4G_VERSAO_PRODU = W.CK4G_VERSAO_PRODU,
        CK4G_DETVER_PRODU = W.CK4G_DETVER_PRODU,
        CK4G_RELEAS_PRODU = W.CK4G_RELEAS_PRODU,
        CK4G_REGRA_ATUALIZACAO = W.CK4G_REGRA_ATUALIZACAO,
        CFG_LIMITESANGRIACHEQUE = W.CFG_LIMITESANGRIACHEQUE,
        CFG_SANGRIAFECHAMENTO = W.CFG_SANGRIAFECHAMENTO,
        CFG_REFORCOABERTURA = W.CFG_REFORCOABERTURA,
        CFG_TAMANHOMATRICULA = W.CFG_TAMANHOMATRICULA,
        SEMESTLOTE = W.SEMESTLOTE,
        TAMCODLOTE = W.TAMCODLOTE,
        CFG_PARCEIRO = W.CFG_PARCEIRO,
        TIPSUGPRO = W.TIPSUGPRO,
        SEP_FAT_RETIRA_DEPOSITO = W.SEP_FAT_RETIRA_DEPOSITO,
        CKNEGATIVO = W.CKNEGATIVO,
        PERIPITRA = W.PERIPITRA,
        PERIPIATA = W.PERIPIATA,
        FILMAT_RAT = W.FILMAT_RAT,
        CODMAT_RAT = W.CODMAT_RAT,
        CODCOR_RAT = W.CODCOR_RAT,
        CODTAM_RAT = W.CODTAM_RAT,
        DEVFIL = W.DEVFIL,
        PREZER = W.PREZER,
        IMPPREVENT = W.IMPPREVENT,
        SERSAT = W.SERSAT,
        PERPARICM = W.PERPARICM,
        ST_PRIPAR = W.ST_PRIPAR,
        REGRA_CODFIS = W.REGRA_CODFIS,
        NATIMP = W.NATIMP,
        TIPRTT_VGAS = W.TIPRTT_VGAS,
        TIPRTT_VPRE = W.TIPRTT_VPRE,
        SISDFE = W.SISDFE,
        NATRECIBO = W.NATRECIBO,
        NATNFRECI = W.NATNFRECI,
        CC_PENDENCIA = W.CC_PENDENCIA,
        RECEBE_CC_INDIVIDUAL = W.RECEBE_CC_INDIVIDUAL,
        DEST_ST_INFFISCO = W.DEST_ST_INFFISCO,
        OBRPESO = W.OBRPESO,
        OBRVOL = W.OBRVOL,
        DISPOR = W.DISPOR,
        VARCUS = W.VARCUS,
        CC_RESTSAV = W.CC_RESTSAV,
        ORICRE = W.ORICRE,
        DESCPMORD = W.DESCPMORD,
        FILMAT_TRA = W.FILMAT_TRA,
        CODMAT_TRA = W.CODMAT_TRA,
        CODCOR_TRA = W.CODCOR_TRA,
        CODTAM_TRA = W.CODTAM_TRA,
        TRANSFER_ICM_NAT = W.TRANSFER_ICM_NAT,
        CKSANGRIANEGATIVA = W.CKSANGRIANEGATIVA,
        TRANSFER_SERCOL = W.TRANSFER_SERCOL,
        TRANSFER_NATCOL = W.TRANSFER_NATCOL,
        ENT_FILCLI = W.ENT_FILCLI,
        ENT_CODCLI = W.ENT_CODCLI,
        INT_CON_ABA = W.INT_CON_ABA,
        LIBERASESSAOMIN = W.LIBERASESSAOMIN,
        CC_DOACAOTROCO = W.CC_DOACAOTROCO,
        NATDECTRA = W.NATDECTRA,
        NUM_ITENS_DISTR_EST = W.NUM_ITENS_DISTR_EST,
        AGRUPADOR_ITENS_DISTR_EST = W.AGRUPADOR_ITENS_DISTR_EST,
        CC_VENDACONJUNTA = W.CC_VENDACONJUNTA
  FROM TW_CFG W;

-- Respeite a organizao dos campos nas 7 colunas.
--Col1....................|Col2....................|Col3....................|Col4....................|Col5....................|Col6....................|Col7....................

 RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1488 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION UPDGRAIPE (TT_IPE.CODFIL%TYPE,TT_IPE.NUMPED%TYPE,TT_IPE.NUMITE%TYPE) CASCADE;

/*-- SEQ 1489 --*/
CREATE OR REPLACE FUNCTION UPDGRAIPE (TT_IPE.CODFIL%TYPE,TT_IPE.NUMPED%TYPE,TT_IPE.NUMITE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCodfil ALIAS FOR $1 ;
pNumped ALIAS FOR $2 ;
pNumite ALIAS FOR $3 ;
BEGIN
  -- 1) Update na TT_GRA com os valores da TT_IPE
  -- Busca na TT_IPE os valores para popular as colunas DACCUS, AFICUS, ICMTIP, ORICUS, OUTCUS, ICMCUS, IPICUS, PERFRE  na TT_GRA
  

UPDATE TT_GRA            
   SET ORICUS = 'P', 
       DACCUS = ((IPE.VLRDES*100)/IPE.VLRITE), 
       AFICUS = 0, 
       ICMTIP = IPE.SUBTRI, 
       OUTCUS = 0, 
       ICMCUS = IPE.ICMITE, 
       IPICUS = IPE.IPIITE, 
       PERFRE = 0, 
       ATU_EM = AGORA(),
       PRECOM = (IPE.VLRITE/IPE.QTDPED),
       FILPED = IPE.CODFIL, 
       NUMPED = IPE.NUMPED, 
       ITEPED = IPE.NUMITE
  FROM ( SELECT IPE.FILMAT,IPE.CODMAT,IPE.CODCOR,IPE.CODTAM, MAX(IPE.CODFIL) AS CODFIL, MAX(IPE.NUMPED) AS NUMPED, 
                MAX(IPE.NUMITE) AS NUMITE,
                MAX(IPE.VLRDES) AS VLRDES,  
                MAX(IPE.VLRITE) AS VLRITE,
                MAX(IPE.QTDPED) AS QTDPED,
                MAX(IUF.SUBTRI) AS SUBTRI,                     
                MAX(IPE.ICMITE) AS ICMITE,
		MAX(IPE.IPIITE) AS IPIITE
           FROM TT_IPE IPE, TT_IUF IUF               
      WHERE IPE.CODFIL = pCODFIL
        AND IPE.NUMPED = pNUMPED
        AND IPE.NUMITE = CASE WHEN pNumite <> 0 THEN pNumite ELSE IPE.NUMITE END
	AND IPE.FILMAT = IUF.FILMAT
	AND IPE.CODMAT = IUF.CODMAT
        GROUP BY IPE.CODFIL,IPE.NUMPED,IPE.FILMAT,IPE.CODMAT,IPE.CODCOR,IPE.CODTAM
        ) IPE 
 WHERE IPE.FILMAT = TT_GRA.FILMAT               
   AND IPE.CODMAT = TT_GRA.CODMAT               
   AND IPE.CODCOR = TT_GRA.CODCOR               
   AND IPE.CODTAM = TT_GRA.CODTAM;


UPDATE TT_PXF          
   SET ORICUS = 'P', 
       OUTCUS = 0, 
       DACCUS = ((IPE.VLRDES*100)/IPE.VLRITE), 
       AFICUS = 0, 
       PRECOM = (IPE.VLRITE/IPE.QTDPED), 
       PERFRE = 0, 
       ICMCUS = IPE.ICMITE,
       IPICUS = IPE.IPIITE,
       PERICM = IPE.ICMITE,
       PERIPI = IPE.IPIITE,
       ICMTIP = IPE.SUBTRI,
       ATU_EM = AGORA()
  FROM ( SELECT IPE.FILMAT,IPE.CODMAT,IPE.CODCOR,IPE.CODTAM,MAX(PED.FILFOR) AS FILFOR,MAX(PED.CODFOR) AS CODFOR,
                MAX(IPE.VLRDES) AS VLRDES,   
                MAX(IPE.VLRITE) AS VLRITE,
                MAX(IPE.QTDPED) AS QTDPED,
                MAX(IPE.IPIITE) AS IPIITE,
                MAX(IPE.ICMITE) AS ICMITE,
                MAX(IUF.SUBTRI) AS SUBTRI
           FROM TT_IPE IPE LEFT JOIN TT_IUF IUF ON IPE.FILMAT = IUF.FILMAT AND IPE.CODMAT = IUF.CODMAT
                          INNER JOIN TT_PED PED ON IPE.CODFIL = PED.CODFIL AND IPE.NUMPED = PED.NUMPED
      WHERE IPE.CODFIL = pCODFIL
        AND IPE.NUMPED = pNUMPED
        AND IPE.NUMITE = CASE WHEN pNumite <> 0 THEN pNumite ELSE IPE.NUMITE END
        GROUP BY IPE.CODFIL,IPE.NUMPED,IPE.FILMAT,IPE.CODMAT,IPE.CODCOR,IPE.CODTAM
        ) IPE 
 WHERE IPE.FILMAT = TT_PXF.FILMAT               
   AND IPE.CODMAT = TT_PXF.CODMAT               
   AND IPE.CODCOR = TT_PXF.CODCOR               
   AND IPE.CODTAM = TT_PXF.CODTAM
   AND IPE.FILFOR = TT_PXF.FILFOR
   AND IPE.CODFOR = TT_PXF.CODFOR;

      
       RETURN NULL;
       
END;
$$ language 'plpgsql';





/*-- SEQ 1490 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION UPDGRAICO (TT_COM.CODFIL%TYPE,TT_COM.SEQUEN%TYPE,TT_ICO.NUMITE%TYPE) CASCADE;

/*-- SEQ 1491 --*/
CREATE OR REPLACE FUNCTION UPDGRAICO (TT_COM.CODFIL%TYPE,TT_COM.SEQUEN%TYPE,TT_ICO.NUMITE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCodfil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
pNumite ALIAS FOR $3 ;
BEGIN
  -- 1) Update na TT_GRA com os valores da TT_ICO
  -- Busca na TT_ICO os valores para popular as colunas CUSREP, PRECOM,  DATCOM, QTDCOM na TT_GRA

  -- [DANIEL]
  -- Tentei fazer utilizando a macro para update form select
  -- so que ficou muito complexo e ilegivel devido a complexidade do select
  -- Por isso ache melho colocar com IFDEF

UPDATE TT_GRA
   SET CUSREP=CASE WHEN COALESCE(ICO.CUSREP,TT_GRA.CUSREP) > 9999999999.99 THEN 9999999999.99
              ELSE COALESCE(ICO.CUSREP,TT_GRA.CUSREP) 
              END,
       PRECOM=CASE WHEN (CASE WHEN ICO.CUSREP IS NULL THEN TT_GRA.PRECOM
                        ELSE ICO.VLRMOV / ICO.QTDMOV
                        END)  > 9999999999.9999 THEN 9999999999.9999 
              ELSE (CASE WHEN ICO.CUSREP IS NULL THEN TT_GRA.PRECOM
                        ELSE ICO.VLRMOV / ICO.QTDMOV
                        END)
              END,
       DATCOM=ICO.COM_DATOPE,
       QTDCOM=CASE WHEN ICO.QTDMOV > 9999999999.99 THEN 9999999999.99 ELSE ICO.QTDMOV END,
       FILCOM=ICO.CODFIL,
       SEQCOM=ICO.SEQUEN,
       ITECOM=ICO.NUMITE,
       ICMCOM=CASE WHEN ICO.VLRICM  > 9999999999.99 THEN 9999999999.99 ELSE ICO.VLRICM END,
       IPICOM=CASE WHEN ICO.IPICOM > 9999999999.99 THEN 9999999999.99 ELSE ICO.IPICOM END,
       DESCOM=CASE WHEN ICO.DESCOM  > 9999999999.99 THEN 9999999999.99 ELSE ICO.DESCOM END,
       TAXCOM=CASE WHEN ICO.TAXCOM > 9999999999.99 THEN 9999999999.99 ELSE ICO.TAXCOM END,
       DESICO=CASE WHEN ICO.VLRDES > 9999999999.99 THEN 9999999999.99 ELSE ICO.VLRDES END,
       ORICUS='C',
       IPIFRE=CASE WHEN ICO.IPIFRE > 99999999.99 THEN 99999999.99 ELSE ICO.IPIFRE END,
       ICMFRE=CASE WHEN  ICO.ICMFRE > 9999999999.99 THEN 9999999999.99 ELSE ICO.ICMFRE END,
       ULTBAS=CASE WHEN ICO.REDITE  > 999.99 THEN 999.99 ELSE ICO.REDITE END,
       MVACOM=CASE WHEN ICO.MVACOM  > 9999999999.9999 THEN 9999999999.9999 ELSE ICO.MVACOM END
  FROM ( SELECT ICO.FILMAT,ICO.CODMAT,ICO.CODCOR,ICO.CODTAM,
                MAX(ICO.CUSREP) AS CUSREP,
                MAX(ICO.VLRMOV) AS VLRMOV,
                MAX(ICO.COM_DATOPE) AS COM_DATOPE,
                MAX(ICO.QTDMOV) AS QTDMOV,
                ICO.CODFIL AS CODFIL,
                ICO.SEQUEN AS SEQUEN,
                MAX(ICO.NUMITE) AS NUMITE,
                MAX(ICO.VLRICMDIF) AS VLRICM,
                MAX((COALESCE(ICO.IPIITE,0)*ICO.VLRMOV)/100) AS IPICOM,
                MAX((( COM.DESCON * ( (ICO.VLRMOV * (1+(COALESCE(ICO.IPIITE,0)/100))) / Nvlz(COM.VLRTOT,1))) / ICO.QTDMOV)) AS DESCOM,
                MAX((( COM.OUTTAX * ( (ICO.VLRMOV * (1+(COALESCE(ICO.IPIITE,0)/100))) / Nvlz(COM.VLRTOT,1))) / ICO.QTDMOV)) AS TAXCOM,
	            MAX(ICO.VLRDES/ICO.QTDMOV) AS VLRDES,
                MAX(COALESCE(ICO.IPIFRE,0)/ICO.QTDMOV) AS IPIFRE,
                MAX((( COM.ICMFRE * ( (ICO.VLRMOV * (1+(COALESCE(ICO.IPIITE,0)/100))) / Nvlz(COM.VLRTOT,1))) / ICO.QTDMOV)) AS ICMFRE,
                MAX(ICO.REDITEDIF) AS REDITE,
                MAX(ICO.MVACOMDIF) AS MVACOM
      FROM TT_ICO ICO, TT_COM COM
      WHERE ICO.CODFIL = COM.CODFIL
        AND ICO.SEQUEN = COM.SEQUEN
        AND ICO.CODFIL = pCODFIL
        AND ICO.SEQUEN = pSEQUEN
        AND ICO.NUMITE = CASE WHEN pNumite <> 0 THEN pNumite ELSE ICO.NUMITE END
        AND ICO.QTDMOV <> 0
        GROUP BY ICO.CODFIL,ICO.SEQUEN,ICO.FILMAT,ICO.CODMAT,ICO.CODCOR,ICO.CODTAM
        ) ICO
 WHERE ICO.FILMAT = TT_GRA.FILMAT
   AND ICO.CODMAT = TT_GRA.CODMAT
   AND ICO.CODCOR = TT_GRA.CODCOR
   AND ICO.CODTAM = TT_GRA.CODTAM;


UPDATE TT_SAL
   SET REPCMP=CASE WHEN COALESCE(ICO.CUSREP,TT_SAL.REPCMP) > 9999999999.9999 THEN 9999999999.9999 ELSE COALESCE(ICO.CUSREP,TT_SAL.REPCMP) END,
       PRECMP=CASE WHEN (CASE WHEN ICO.CUSREP IS NULL THEN TT_SAL.PRECMP
                              ELSE ICO.VLRMOV / ICO.QTDMOV
              END )  > 9999999999.9999 THEN 9999999999.9999 ELSE (CASE WHEN ICO.CUSREP IS NULL THEN TT_SAL.PRECMP
                                                                   ELSE ICO.VLRMOV / ICO.QTDMOV
              END ) END,
       DATCMP=ICO.COM_DATOPE,
       QTDCMP=ICO.QTDMOV,
       SEQCMP=ICO.SEQUEN,
       ITECMP=ICO.NUMITE,
       ICMCMP=CASE WHEN ICO.VLRICM > 9999999999.99 THEN 9999999999.99 ELSE ICO.VLRICM END,
       IPICMP=CASE WHEN (CASE WHEN ICO.ATUCUS = 'T' THEN ICO.IPICOM ELSE TT_SAL.IPICMP END)  > 9999999999.99 THEN 9999999999.99 ELSE (CASE WHEN ICO.ATUCUS = 'T' THEN ICO.IPICOM ELSE TT_SAL.IPICMP END) END,
       DESCMP=CASE WHEN ICO.DESCOM > 9999999999.99 THEN 9999999999.99 ELSE ICO.DESCOM END,
       TAXCMP=CASE WHEN ICO.TAXCOM > 9999999999.99 THEN 9999999999.99 ELSE ICO.TAXCOM END,
       FRECMP=CASE WHEN (CASE WHEN ICO.ATUCUS = 'T' THEN ICO.CUSFRE ELSE TT_SAL.FRECMP END ) > 9999999999.99 THEN 9999999999.99 ELSE  (CASE WHEN ICO.ATUCUS = 'T' THEN ICO.CUSFRE ELSE TT_SAL.FRECMP END ) END
  FROM ( SELECT ICO.FILMAT,ICO.CODMAT,ICO.CODCOR,ICO.CODTAM, COM.ATUCUS,
             MAX(ICO.CUSREP) AS CUSREP,
             MAX(ICO.VLRMOV) AS VLRMOV,
             MAX(ICO.COM_DATOPE) AS COM_DATOPE,
             MAX(ICO.QTDMOV) AS QTDMOV,
             ICO.CODFIL AS CODFIL,
             ICO.SEQUEN AS SEQUEN,
             MAX(ICO.NUMITE) AS NUMITE,
             MAX(ICO.VLRICMDIF) AS VLRICM,
             MAX((COALESCE(ICO.IPIITE,0)*ICO.VLRMOV)/100) AS IPICOM,
             MAX((( COM.DESCON * ( (ICO.VLRMOV * (1+(COALESCE(ICO.IPIITE,0)/100))) / Nvlz(COM.VLRTOT,1))) / ICO.QTDMOV)) AS DESCOM,
             MAX((( COM.OUTTAX * ( (ICO.VLRMOV * (1+(COALESCE(ICO.IPIITE,0)/100))) / Nvlz(COM.VLRTOT,1))) / ICO.QTDMOV)) AS TAXCOM,
             MAX(ICO.CUSFRE) AS CUSFRE
      FROM TT_ICO ICO INNER JOIN TT_COM COM ON ICO.CODFIL = COM.CODFIL AND ICO.SEQUEN = COM.SEQUEN
      WHERE ICO.CODFIL = pCODFIL
        AND ICO.SEQUEN = pSEQUEN
        AND ICO.NUMITE = CASE WHEN pNumite <> 0 THEN pNumite ELSE ICO.NUMITE END
        AND ICO.QTDMOV <> 0
        GROUP BY ICO.CODFIL,ICO.SEQUEN,ICO.FILMAT,ICO.CODMAT,ICO.CODCOR,ICO.CODTAM, COM.ATUCUS
        ) ICO
 WHERE ICO.CODFIL = TT_SAL.CODFIL
   AND ICO.FILMAT = TT_SAL.FILMAT
   AND ICO.CODMAT = TT_SAL.CODMAT
   AND ICO.CODCOR = TT_SAL.CODCOR
   AND ICO.CODTAM = TT_SAL.CODTAM;

--54149


UPDATE TT_GRA
   SET ORICUS = 'C',
       DACCUS = CASE WHEN (((ICO.VLRMOV/Nvlz(ICO.VLRITE,1))*100)-100) > 999.99 THEN 999.99 ELSE (((ICO.VLRMOV/Nvlz(ICO.VLRITE,1))*100)-100) END,
       AFICUS = 0,
       ICMTIP = ICO.ICMTIP,
       OUTCUS = 0,
       ICMCUS = CASE WHEN ICO.ICMITE > 999.99 THEN 999.99 ELSE ICO.ICMITE END,
       IPICUS = CASE WHEN( CASE WHEN ICO.ATUCUS = 'T' THEN ICO.IPIITE ELSE TT_GRA.IPICUS END) > 999.99 THEN 999.99 ELSE ( CASE WHEN ICO.ATUCUS = 'T' THEN ICO.IPIITE ELSE TT_GRA.IPICUS END) END,
       PERFRE = CASE WHEN ((ICO.CUSFRE*100)/Nvlz(ICO.VLRITE,1)) > 999.99 THEN 999.99 ELSE  ((ICO.CUSFRE*100)/Nvlz(ICO.VLRITE,1)) END,
       ATU_EM = AGORA(),
       FILPED = NULL,
       NUMPED = NULL,
       ITEPED = NULL,
       CUSFRE = CASE WHEN  (CASE WHEN ICO.ATUCUS = 'T' THEN ICO.CUSFRE ELSE TT_GRA.CUSFRE END) > 9999999999.99 THEN 9999999999.99 ELSE  (CASE WHEN ICO.ATUCUS = 'T' THEN ICO.CUSFRE ELSE TT_GRA.CUSFRE END) END
  FROM ( SELECT ICO.FILMAT,ICO.CODMAT,ICO.CODCOR,ICO.CODTAM, COM.ATUCUS,
             MAX(ICO.VLRMOV) AS VLRMOV,
             MAX(ICO.CUSFRE) AS CUSFRE,
             MAX(ICO.VLRITE) AS VLRITE,
             MAX(ICO.ICMITEDIF) AS ICMITE,
             MAX(ICO.IPIITE) AS IPIITE,
             MAX(ICO.ICMTIP) AS ICMTIP
      FROM TT_ICO ICO, TT_COM COM
      WHERE ICO.CODFIL = COM.CODFIL
        AND ICO.SEQUEN = COM.SEQUEN
        AND ICO.CODFIL = pCODFIL
        AND ICO.SEQUEN = pSEQUEN
        AND ICO.NUMITE = CASE WHEN pNumite <> 0 THEN pNumite ELSE ICO.NUMITE END
        AND ICO.QTDMOV <> 0
        GROUP BY ICO.CODFIL,ICO.SEQUEN,ICO.FILMAT,ICO.CODMAT,ICO.CODCOR,ICO.CODTAM, COM.ATUCUS
        ) ICO
 WHERE ICO.FILMAT = TT_GRA.FILMAT
   AND ICO.CODMAT = TT_GRA.CODMAT
   AND ICO.CODCOR = TT_GRA.CODCOR
   AND ICO.CODTAM = TT_GRA.CODTAM;





UPDATE TT_PXF          
   SET ORICUS = 'C', 
       OUTCUS = 0, 
       DACCUS = CASE WHEN (((ICO.VLRMOV/Nvlz(ICO.VLRITE,1))*100)-100) > 999.99 THEN 999.99 ELSE (((ICO.VLRMOV/Nvlz(ICO.VLRITE,1))*100)-100) END,
       AFICUS = 0, 
       PRECOM = CASE WHEN (ICO.VLRMOV / ICO.QTDMOV) > 9999999999.99 THEN 9999999999.99 ELSE (ICO.VLRMOV / ICO.QTDMOV) END,
       PERFRE = CASE WHEN  ((ICO.CUSFRE*100)/Nvlz(ICO.VLRITE,1)) > 999.99 THEN 999.99 ELSE ((ICO.CUSFRE*100)/Nvlz(ICO.VLRITE,1))  END, 
       ICMCUS = CASE WHEN ICO.ICMITE > 999.99 THEN 999.99 ELSE ICO.ICMITE END,
       IPICUS = CASE WHEN ICO.IPIITE > 999.99 THEN 999.99 ELSE ICO.IPIITE END,
       ICMTIP = ICO.ICMTIP,
       ATU_EM = AGORA(),
       MVACOM = ICO.MVACOM
  FROM ( SELECT ICO.FILMAT,ICO.CODMAT,ICO.CODCOR,ICO.CODTAM,MAX(COM.FILFOR) AS FILFOR,MAX(COM.CODFOR) AS CODFOR,
             MAX(ICO.VLRMOV) AS VLRMOV,  
             MAX(ICO.QTDMOV) AS QTDMOV,  
             MAX(ICO.CUSFRE) AS CUSFRE,
             MAX(ICO.VLRITE) AS VLRITE,  
             MAX(ICO.ICMITEDIF) AS ICMITE,
             MAX(ICO.IPIITE) AS IPIITE,
             MAX(ICO.ICMTIP) AS ICMTIP,
             MAX(ICO.MVACOMDIF) AS MVACOM
      FROM TT_ICO ICO, TT_COM COM               
      WHERE ICO.CODFIL = COM.CODFIL               
        AND ICO.SEQUEN = COM.SEQUEN               
        AND ICO.CODFIL = pCODFIL
        AND ICO.SEQUEN = pSEQUEN
        AND ICO.NUMITE = CASE WHEN pNumite <> 0 THEN pNumite ELSE ICO.NUMITE END
        AND ICO.QTDMOV <> 0
        GROUP BY ICO.CODFIL,ICO.SEQUEN,ICO.FILMAT,ICO.CODMAT,ICO.CODCOR,ICO.CODTAM
        ) ICO 
 WHERE ICO.FILMAT = TT_PXF.FILMAT               
   AND ICO.CODMAT = TT_PXF.CODMAT               
   AND ICO.CODCOR = TT_PXF.CODCOR               
   AND ICO.CODTAM = TT_PXF.CODTAM
   AND ICO.FILFOR = TT_PXF.FILFOR               
   AND ICO.CODFOR = TT_PXF.CODFOR;

      
       RETURN NULL;
       
END;
$$ language 'plpgsql';




/*-- SEQ 1492 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VencimentoPromocao (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_PLA.FILPGT%TYPE,TT_PLA.CODPGT%TYPE,TT_PRE.FILPRE%TYPE,TT_PRE.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1493 --*/
CREATE OR REPLACE FUNCTION VencimentoPromocao (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_PLA.FILPGT%TYPE,TT_PLA.CODPGT%TYPE,TT_PRE.FILPRE%TYPE,TT_PRE.SEQUEN%TYPE)
RETURNS TT_CPM.DATVAL%TYPE AS $$
DECLARE
pFilMat ALIAS FOR $1 ;
pCodMat ALIAS FOR $2 ;
pCodCor ALIAS FOR $3 ;
pCodTam ALIAS FOR $4 ;
pFilPgt ALIAS FOR $5 ;
pCodPgt ALIAS FOR $6 ;
pFilPre ALIAS FOR $7 ;
pSeqPre ALIAS FOR $8 ;
  dRetorno TT_CPM.DATVAL%TYPE;
BEGIN
  dRetorno := NULL;
    SELECT MIN(CPM.DATVAL) INTO dRetorno
      FROM TT_CPM CPM INNER JOIN TT_PRE PRE ON PRE.FILPRE = CPM.FILPRE
                                           AND PRE.SEQUEN = CPM.SEQPRE
                                           AND PRE.FILMAT = pFilMat
                                           AND PRE.CODMAT = pCodMat
                                           AND PRE.CODCOR = pCodCor
                                           AND PRE.CODTAM = pCodTam
       AND ((CPM.FILPGT = pFilPgt AND CPM.CODPGT = pCodPgt) OR CPM.FILPGT IS NULL)
       AND CPM.PRECOP = PrecoPromocional(pFilmat,pCodmat,pCodcor,pCodTam,pFilPgt,pCodPgt,pFilPre,pSeqPre);
  RETURN dRetorno;
END;
$$ language 'plpgsql';




/*-- SEQ 1494 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Extenso (Numeric) CASCADE;

/*-- SEQ 1495 --*/
CREATE OR REPLACE FUNCTION Extenso (Numeric)
RETURNS VARCHAR AS $$
DECLARE
pValor ALIAS FOR $1 ;


  CifraSingular VARCHAR[6];
  CifraPlural   VARCHAR[6];

  tStr      VARCHAR(100);
  tExtenso  VARCHAR(1000);
  tSubs     VARCHAR(100);
  tX        INTEGER;
  tCentavos Numeric;
  Negativo  INTEGER;
  nValor    Numeric;  

BEGIN
   CifraSingular := ' {"TRILHO","BILHO","MILHO","MIL","    ","CENTAVO"} '; 
   CifraPlural := ' {"TRILHES","BILHES","MILHES","MIL","    ","CENTAVOS"} '; 

  tSubs           := ' ';
  tExtenso        := ' ';
  
  nValor     := pValor;
  if nValor < 0 then
    nValor := nValor * -1;
    Negativo := 1;
  else
    Negativo := 0;
  end if;
  
  tStr            := AUX_StrZero(nValor,18,2);
  tCentavos       := CAST( SUBSTR(tStr,17,2) AS Numeric);

  IF tCentavos > 0 THEN
    tExtenso := AUX_ExtCem( AUX_StrZero( tCentavos,3,0 )) || AUX_IgualAUm(tCentavos,CifraSingular [6],
                                                                                    CifraPlural [6]);
  END IF;

  IF TRUNC( nValor ) > 0 THEN
    tExtenso := AUX_IgualAUm(TRUNC(nValor),'Numeric',' REAIS') || AUX_MaiorQueZero(tCentavos, ' E   ','') || tExtenso;
  END IF;

  FOR i IN 1..5 LOOP
    tX := 6 - i;
    tSubs := SUBSTR(tStr,(tX*3)-1,3);
    IF cast( trim(tSubs) as Numeric ) > 0 THEN
      tExtenso := AUX_ExtCem( tSubs ) || AUX_IgualAUm(cast(trim(tSubs) as Numeric), 
                                                      CifraSingular [tX] || '    ',
                                                      CifraPlural [tX]) || '    ' || tExtenso;
    END IF;
  END LOOP;
  
  IF (Negativo = 1) then
     tExtenso := ' MENOS '|| tExtenso;
  END IF;    

  RETURN AUX_StripDouble(tExtenso);

END;
$$ language 'plpgsql';


/*-- SEQ 1496 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Extenso (VARCHAR) CASCADE;

/*-- SEQ 1497 --*/
CREATE OR REPLACE FUNCTION Extenso (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pValor ALIAS FOR $1 ;
BEGIN
  RETURN Extenso(REPLACE(pValor,',','.')::Numeric);
END;
$$ language 'plpgsql';




/*-- SEQ 1498 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION VALORVENDAPRODUTO (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 1499 --*/
CREATE OR REPLACE FUNCTION VALORVENDAPRODUTO (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE)
RETURNS Numeric AS $$
DECLARE
DDATAINI ALIAS FOR $1 ;
DDATAFIM ALIAS FOR $2 ;
PFILMAT ALIAS FOR $3 ;
PCODMAT ALIAS FOR $4 ;
PCODCOR ALIAS FOR $5 ;
PCODTAM ALIAS FOR $6 ;
PCODFIL ALIAS FOR $7 ;
  NLIQIVE Numeric;
BEGIN
    SELECT ROUND(SUM(VEN.VLRLIQ * IVE.VLRMOV / VEN.VLRNOT),2) INTO NLIQIVE
      FROM TT_VEN VEN, TT_IVE IVE
     WHERE VEN.CODFIL  = IVE.CODFIL
       AND VEN.SEQUEN  = IVE.SEQUEN
       AND IVE.FILMAT  = PFILMAT
       AND IVE.CODMAT  = PCODMAT
       AND IVE.CODCOR  = PCODCOR
       AND IVE.CODTAM  = PCODTAM
       AND VEN.FLGEST != 'C'
       AND VEN.LANVEN  = 'T'
       AND IVE.SITMOV <> 'C'
       AND IVE.VEN_DATHOR BETWEEN DDATAINI AND DDATAFIM
       AND COALESCE(PCODFIL,IVE.CODFIL) = IVE.CODFIL;

   RETURN COALESCE(NLIQIVE,0);

END;
$$ language 'plpgsql';


  


/*-- SEQ 1500 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION FnCalcElast () CASCADE;

/*-- SEQ 1501 --*/
CREATE OR REPLACE FUNCTION FnCalcElast ()
RETURNS VARCHAR AS $$
DECLARE


-- Objetivos:
-- 1. Calcula elasticidade dos preços.

-- Declaração de variáveis e cursores
   cResultado                    VARCHAR(200);
   cManut                        TT_IDF.MANUT%TYPE;
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('complemento');
   dDatIni                       TT_PRE.ATU_EM%TYPE;
   dAgora                        TT_PRE.ATU_EM%TYPE;

   crPre CURSOR(pDatIni TT_PRE.ATU_EM%TYPE) IS
     SELECT DISTINCT
            PRE.FILPRE, --  PK
            PRE.SEQUEN, --  PK
            PRE.DATINC,
            PRE.PRECOV,
            PRE.ULTELA,
            PRE.DIAELA
       FROM TT_PRE PRE
      INNER JOIN TL_PRE LPRE
              ON PRE.FILPRE = LPRE.FILPRE
             AND PRE.SEQUEN = LPRE.SEQPRE
             AND LPRE.PREANT IS NOT NULL
      WHERE PRE.ATU_EM >= pDatIni;

   --  vars do crPre
   wcFilPre                      TT_PRE.FILPRE%TYPE;          --  char(3)
   wcSequen                      TT_PRE.SEQUEN%TYPE;          --  char(10)
   wdDatInc                      TT_PRE.DATINC%TYPE;          --  Timestamp
   wnPrecoV                      TT_PRE.PRECOV%TYPE;          --  Numeric(12,4)
   wnUltEla                      TT_PRE.ULTELA%TYPE;          --  Numeric(12,2)
   wiDiaEla                      TT_PRE.DIAELA%TYPE;          --  Numeric(4)

   aPrecos Numeric(10)[];
aPrecos_cFilPre char(3)[];
aPrecos_cSequen char(10)[];
aPrecos_dDatInc Timestamp[];
aPrecos_nPrecoV Numeric(12,4)[];
aPrecos_nUltEla Numeric(12,2)[];
aPrecos_iDiaEla Numeric(4)[];

aPrecosCount Numeric(10) := 0;

   cDummy                        VARCHAR(250);                 --  usada para executar o procedimento/função (o resultado é desprezado)
   nUltEla                       TT_PRE.ULTELA%TYPE;           --  Numeric(12,2): verificar se o cálculo da elasticidade foi alterado
   iDiaEla                       TT_PRE.DIAELA%TYPE;           --  Numeric(4): verificar se o cálculo da elasticidade foi alterado

-- Início da função
BEGIN

   SELECT MANUT INTO cManut
     FROM TT_IDF;

   IF cManut = 'T' THEN
      RAISE EXCEPTION 'PG-20010 Base em manutenção. %' , COMPLEMENTO;
   END IF;

   -- Pega a data inicial
   SELECT COALESCE((SELECT ATU_EM
                      FROM TT_FUN
                     WHERE NOMFUN = 'PRIELA'), Add_day(Agora(),-30))
     INTO dDatIni
     FROM DUAL;

   -- Pega a data atual
   dAgora := Agora();

   -- Percorre registros com preços modificados a partir da data inicial
   -- e move para um array.
   -- Isso é necessário porque esses registros poderão ser alterados.
   OPEN crPre(dDatIni);
   LOOP
      FETCH crPre INTO wcFilPre, wcSequen, wdDatInc, wnPrecoV, wnUltEla, wiDiaEla;
      EXIT WHEN NOT FOUND;

      -- add no array
      aPrecosCount := aPrecosCount + 1;
if aPrecosCount = 1 then
   select ARRAY[aPrecosCount] into aPrecos; 
   select ARRAY[wcFilPre] into aPrecos_cFilPre;
   select ARRAY[wcSequen] into aPrecos_cSequen;
   select ARRAY[wdDatInc] into aPrecos_dDatInc;
   select ARRAY[wnPrecoV] into aPrecos_nPrecoV;
   select ARRAY[wnUltEla] into aPrecos_nUltEla;
   select ARRAY[wiDiaEla] into aPrecos_iDiaEla;
else
   select array_append(aPrecos, aPrecosCount) into aPrecos;
   select array_append(aPrecos_cFilPre, wcFilPre) into aPrecos_cFilPre;
   select array_append(aPrecos_cSequen, wcSequen) into aPrecos_cSequen;
   select array_append(aPrecos_dDatInc, wdDatInc) into aPrecos_dDatInc;
   select array_append(aPrecos_nPrecoV, wnPrecoV) into aPrecos_nPrecoV;
   select array_append(aPrecos_nUltEla, wnUltEla) into aPrecos_nUltEla;
   select array_append(aPrecos_iDiaEla, wiDiaEla) into aPrecos_iDiaEla;
end if;

   END LOOP;
   CLOSE crPre;

   -- Percorre os itens do array
   if aPrecosCount > 0 then
for aPrecosCount in array_lower(aPrecos,1) .. array_upper(aPrecos,1) loop
      wcFilPre := aPrecos_cFilPre[aPrecosCount];
      wcSequen := aPrecos_cSequen[aPrecosCount];
      wdDatInc := aPrecos_dDatInc[aPrecosCount];
      wnPrecoV := aPrecos_nPrecoV[aPrecosCount];
      wnUltEla := aPrecos_nUltEla[aPrecosCount];
      wiDiaEla := aPrecos_iDiaEla[aPrecosCount];

      --  calculando a elasticidade
      cDummy  := CalcElastPre(wcFilPre, wcSequen, wdDatInc, wnPrecoV, wnUltEla, wiDiaEla);
      iDiaEla := Split_Part_Number(cDummy, ';', 2);
      nUltEla := Split_Part_Number(cDummy, ';', 1);

      --  se o calculo da elasticidade não pode ser realizado (nUltEla = 0) mantém os valores atuais
      IF COALESCE(nUltEla,0) = 0 THEN
         nUltEla := wnUltEla;
         iDiaEla := wiDiaEla;
      END IF;

      --  gravando o resultado na TT_PRE
      --  (sempre tem que gravar, mesmo sem alteração, para remover o registro do cursor)
      UPDATE TT_PRE
         SET ULTELA = nUltEla,
             DIAELA = iDiaEla,
             ATU_EM = dAgora
       WHERE FILPRE = wcFilPre
         AND SEQUEN = wcSequen;

      
   end loop;
end if;

   IF TemFun('PRIELA') = 'T' THEN
      UPDATE tt_fun
         SET atu_em = dAgora
       WHERE nomfun = 'PRIELA';
   ELSE
      INSERT INTO tt_fun
         (nomfun, datfun, atu_em)
         VALUES
         ('PRIELA', dAgora, dAgora);
   END IF;

   
   RETURN cResultado;

END;
$$ language 'plpgsql';



/*-- SEQ 1502 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_CalcElast (TT_JOB.CODUID%TYPE) CASCADE;

/*-- SEQ 1503 --*/
CREATE OR REPLACE FUNCTION Job_CalcElast (TT_JOB.CODUID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODUID ALIAS FOR $1 ;
-- Declaração de variáveis e cursores
   cDummy                        VARCHAR(250);
   vNome                         TT_JOB.NOMJOB%TYPE;
   vDesc                         TT_JOB.DESJOB%TYPE;
-- Início da função
BEGIN
   vNome  := 'JOB_CALCELAST';
   vDesc  := 'Rotina para calcular a elasticidade dos precos';
   BEGIN
      cDummy := FnCalcElast();
      cDummy := RegistraJob(vNome, vDesc, NULL, pCODUID);
   EXCEPTION
      --  gravando o erro do resultado
      WHEN OTHERS THEN cDummy := RegistraJob(vNome, vDesc, SQLERRM, pCODUID);
   END;
  RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 1504 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_CalcElast () CASCADE;

/*-- SEQ 1505 --*/
CREATE OR REPLACE FUNCTION Job_CalcElast () 
RETURNS VARCHAR AS $$
BEGIN
RETURN Job_CalcElast(NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1506 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION LeParametroBoo (TT_PCS.NOMPCS%TYPE,TT_IPC.FILIPC%TYPE,TT_IPC.FILECF%TYPE,TT_IPC.NUMECF%TYPE,TT_IPC.CODSER%TYPE) CASCADE;

/*-- SEQ 1507 --*/
CREATE OR REPLACE FUNCTION LeParametroBoo (TT_PCS.NOMPCS%TYPE,TT_IPC.FILIPC%TYPE,TT_IPC.FILECF%TYPE,TT_IPC.NUMECF%TYPE,TT_IPC.CODSER%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pNomeParametro ALIAS FOR $1 ;
pFilial ALIAS FOR $2 ;
pFilialECF ALIAS FOR $3 ;
pNumeroECF ALIAS FOR $4 ;
pSerie ALIAS FOR $5 ;

-- Objetivos:
-- 1. Ler parmetros do tipo booleano da tabela TT_PCS

-- Declarao de variveis e cursores
   bValorDefault                 VARCHAR(1) := 'F';
   rRetornoBusca                 TRetBuscaParametro;

-- Incio da funo
BEGIN
   -- Tratar aqui valor padro especfico para o parmetro (se necessrio)
   IF pNomeParametro = 'NOVO_TIT_PAG_AJ_PARC' THEN
      bValorDefault := 'T';
   END IF;

   rRetornoBusca := BuscaParametro(pNomeParametro,'B',pFilial,pFilialECF,pNumeroECF,pSerie);

   IF rRetornoBusca.Encontrou THEN
      RETURN rRetornoBusca.VLRBOO;
   ELSE
      RETURN bValorDefault;
   END IF;

END;
$$ language 'plpgsql';




/*-- SEQ 1508 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION LeParametroDat (TT_PCS.NOMPCS%TYPE,TT_IPC.FILIPC%TYPE,TT_IPC.FILECF%TYPE,TT_IPC.NUMECF%TYPE,TT_IPC.CODSER%TYPE) CASCADE;

/*-- SEQ 1509 --*/
CREATE OR REPLACE FUNCTION LeParametroDat (TT_PCS.NOMPCS%TYPE,TT_IPC.FILIPC%TYPE,TT_IPC.FILECF%TYPE,TT_IPC.NUMECF%TYPE,TT_IPC.CODSER%TYPE)
RETURNS Timestamp AS $$
DECLARE
pNomeParametro ALIAS FOR $1 ;
pFilial ALIAS FOR $2 ;
pFilialECF ALIAS FOR $3 ;
pNumeroECF ALIAS FOR $4 ;
pSerie ALIAS FOR $5 ;

-- Objetivos:
-- 1. Ler parmetros do tipo data da tabela TT_PCS

-- Declarao de variveis e cursores
   dValorDefault                 Timestamp := NULL;
   rRetornoBusca                 TRetBuscaParametro;

-- Incio da funo
BEGIN
   /*
   Tratar aqui valor padro especfico para o parmetro (se necessrio)
   Ex:
   IF pNomeParametro = 'XPTO' THEN
      dValorDefault := TO_DATE('12/06/2018','DD/MM/YYYY');
   END IF;
   */

   rRetornoBusca := BuscaParametro(pNomeParametro,'D',pFilial,pFilialECF,pNumeroECF,pSerie);

   IF rRetornoBusca.Encontrou THEN
      RETURN rRetornoBusca.VLRDAT;
   ELSE
      RETURN dValorDefault;
   END IF;

END;
$$ language 'plpgsql';




/*-- SEQ 1510 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION LeParametroInt (TT_PCS.NOMPCS%TYPE,TT_IPC.FILIPC%TYPE,TT_IPC.FILECF%TYPE,TT_IPC.NUMECF%TYPE,TT_IPC.CODSER%TYPE) CASCADE;

/*-- SEQ 1511 --*/
CREATE OR REPLACE FUNCTION LeParametroInt (TT_PCS.NOMPCS%TYPE,TT_IPC.FILIPC%TYPE,TT_IPC.FILECF%TYPE,TT_IPC.NUMECF%TYPE,TT_IPC.CODSER%TYPE)
RETURNS Numeric AS $$
DECLARE
pNomeParametro ALIAS FOR $1 ;
pFilial ALIAS FOR $2 ;
pFilialECF ALIAS FOR $3 ;
pNumeroECF ALIAS FOR $4 ;
pSerie ALIAS FOR $5 ;

-- Objetivos:
-- 1. Ler parmetros do tipo inteiro da tabela TT_PCS

-- Declarao de variveis e cursores
   nValorDefault                 Numeric(10,0) := 0;
   rRetornoBusca                 TRetBuscaParametro;

-- Incio da funo
BEGIN
   /*
   Tratar aqui valor padro especfico para o parmetro (se necessrio)
   Ex:
   IF pNomeParametro = 'XPTO' THEN
      nValorDefault := 10;
   END IF;
   */

   rRetornoBusca := BuscaParametro(pNomeParametro,'I',pFilial,pFilialECF,pNumeroECF,pSerie);

   IF rRetornoBusca.Encontrou THEN
      RETURN rRetornoBusca.VLRINT;
   ELSE
      RETURN nValorDefault;
   END IF;

END;
$$ language 'plpgsql';




/*-- SEQ 1512 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION LeParametroNum (TT_PCS.NOMPCS%TYPE,TT_IPC.FILIPC%TYPE,TT_IPC.FILECF%TYPE,TT_IPC.NUMECF%TYPE,TT_IPC.CODSER%TYPE) CASCADE;

/*-- SEQ 1513 --*/
CREATE OR REPLACE FUNCTION LeParametroNum (TT_PCS.NOMPCS%TYPE,TT_IPC.FILIPC%TYPE,TT_IPC.FILECF%TYPE,TT_IPC.NUMECF%TYPE,TT_IPC.CODSER%TYPE)
RETURNS Numeric AS $$
DECLARE
pNomeParametro ALIAS FOR $1 ;
pFilial ALIAS FOR $2 ;
pFilialECF ALIAS FOR $3 ;
pNumeroECF ALIAS FOR $4 ;
pSerie ALIAS FOR $5 ;

-- Objetivos:
-- 1. Ler parmetros do tipo numrico da tabela TT_PCS

-- Declarao de variveis e cursores
   nValorDefault                 Numeric(16,4) := 0;
   rRetornoBusca                 TRetBuscaParametro;

-- Incio da funo
BEGIN
   /*
   Tratar aqui valor padro especfico para o parmetro (se necessrio)
   Ex:
   IF pNomeParametro = 'XPTO' THEN
      nValorDefault := 10.25;
   END IF;
   */

   rRetornoBusca := BuscaParametro(pNomeParametro,'N',pFilial,pFilialECF,pNumeroECF,pSerie);

   IF rRetornoBusca.Encontrou THEN
     RETURN rRetornoBusca.VLRNUM;
   ELSE
     RETURN nValorDefault;
   END IF;

END;
$$ language 'plpgsql';




/*-- SEQ 1514 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION LeParametroTxt (TT_PCS.NOMPCS%TYPE,TT_IPC.FILIPC%TYPE,TT_IPC.FILECF%TYPE,TT_IPC.NUMECF%TYPE,TT_IPC.CODSER%TYPE) CASCADE;

/*-- SEQ 1515 --*/
CREATE OR REPLACE FUNCTION LeParametroTxt (TT_PCS.NOMPCS%TYPE,TT_IPC.FILIPC%TYPE,TT_IPC.FILECF%TYPE,TT_IPC.NUMECF%TYPE,TT_IPC.CODSER%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pNomeParametro ALIAS FOR $1 ;
pFilial ALIAS FOR $2 ;
pFilialECF ALIAS FOR $3 ;
pNumeroECF ALIAS FOR $4 ;
pSerie ALIAS FOR $5 ;

-- Objetivos:
-- 1. Ler parmetros do tipo texto da tabela TT_PCS

-- Declarao de variveis e cursores
   cValorDefault                 VARCHAR(100) := '';
   rRetornoBusca                 TRetBuscaParametro;

-- Incio da funo
BEGIN
   /*
   Tratar aqui valor padro especfico para o parmetro (se necessrio)
   Ex:
   IF pNomeParametro = 'XPTO' THEN
      cValorDefault := 'Teste';
   END IF;
   */

   rRetornoBusca := BuscaParametro(pNomeParametro,'T',pFilial,pFilialECF,pNumeroECF,pSerie);

   IF rRetornoBusca.Encontrou THEN
      RETURN rRetornoBusca.VLRTXT;
   ELSE
      RETURN cValorDefault;
   END IF;

END;
$$ language 'plpgsql';





/*-- SEQ 1516 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_PRO () CASCADE;

/*-- SEQ 1517 --*/
CREATE OR REPLACE FUNCTION IMPORTA_PRO ()
RETURNS VARCHAR AS $$
DECLARE

--Objetivo: Importar tabelas relacionadas ao cadastro de produtos:
--(TT_PRO, TT_GRA, TT_DIV, TD_DIV, TT_SUB, TD_SUB, TD_GRA, TT_IUF, TD_DEP, TD_CL1, TD_CL2, TD_CL3, TD_CL4, TT_PRE, TT_MAR)

-- TI_PRO
   WK_CODEXT                     TI_PRO.CODEXT%TYPE;
   WK_FILMAT                     TI_PRO.FILMAT%TYPE;
   WK_FILMAT_TMP                 TI_PRO.FILMAT%TYPE;
   WK_CODMAT                     TI_PRO.CODMAT%TYPE;
   WK_REFBAS                     TI_PRO.REFBAS%TYPE;
   WK_DESMAT                     TI_PRO.DESMAT%TYPE;
   WK_ESPMAT                     TI_PRO.ESPMAT%TYPE;
   WK_CODCTR                     TI_PRO.CODCTR%TYPE;
   WK_CONTRA                     TI_PRO.CONTRA%TYPE;
   WK_CONTRO                     TI_PRO.CONTRO%TYPE;
   WK_DESECF                     TI_PRO.DESECF%TYPE;
   WK_CODFAB                     TI_PRO.CODFAB%TYPE;
   WK_DESMAR                     TI_PRO.DESMAR%TYPE;
   WK_ENTREG                     TI_PRO.ENTREG%TYPE;
   WK_ATIVO                      TI_PRO.ATIVO%TYPE;
   WK_DESINA                     TI_PRO.DESINA%TYPE;
   WK_CLASS1                     TI_PRO.CLASS1%TYPE;
   WK_CLASS2                     TI_PRO.CLASS2%TYPE;
   WK_CLASS3                     TI_PRO.CLASS3%TYPE;
   WK_CLASS4                     TI_PRO.CLASS4%TYPE;
   WK_DEPART                     TI_PRO.DEPART%TYPE;
   WK_SAZONA                     TI_PRO.SAZONA%TYPE;
   WK_TIPPRO                     TI_PRO.TIPPRO%TYPE;
   WK_CLSXYZ                     TI_PRO.CLSXYZ%TYPE;
   WK_DATCAD                     TI_PRO.DATCAD%TYPE;
   WK_DECIMA                     TI_PRO.DECIMA%TYPE;
   WK_ETIQUE                     TI_PRO.ETIQUE%TYPE;
   WK_NUMEXT                     TI_PRO.NUMEXT%TYPE;
   WK_OBSERV                     TI_PRO.OBSERV%TYPE;
   WK_BRINDE                     TI_PRO.BRINDE%TYPE;
   WK_DESGRA                     TI_PRO.DESGRA%TYPE;
   WK_MONTAR                     TI_PRO.MONTAR%TYPE;
   WK_NUMITE                     TI_PRO.NUMITE%TYPE;
   WK_RETCOF                     TI_PRO.RETCOF%TYPE;
   WK_NOMDIV                     TI_PRO.NOMDIV%TYPE;
   WK_ITEDIV                     TI_PRO.ITEDIV%TYPE;
   WK_NOMSUB                     TI_PRO.NOMSUB%TYPE;
   WK_ITESUB                     TI_PRO.ITESUB%TYPE;
   WK_TIPVAL                     TI_PRO.TIPVAL%TYPE;
   WK_VALIDA                     TI_PRO.VALIDA%TYPE;
   WK_VOLUNI                     TI_PRO.VOLUNI%TYPE;
   WK_REFPRO                     TI_PRO.REFPRO%TYPE;
   WK_MINQTD                     TI_PRO.MINQTD%TYPE;
   WK_PTOQTD                     TI_PRO.PTOQTD%TYPE;
   WK_QTDREP                     TI_PRO.QTDREP%TYPE;
   WK_PESLIQ                     TI_PRO.PESLIQ%TYPE;
   WK_PESBRU                     TI_PRO.PESBRU%TYPE;
   WK_PROMOC                     TI_PRO.PROMOC%TYPE;
   WK_PRECOM                     TI_PRO.PRECOM%TYPE;
   WK_DATCOM                     TI_PRO.DATCOM%TYPE;
   WK_CUSREP                     TI_PRO.CUSREP%TYPE;
   WK_TEMREP                     TI_PRO.TEMREP%TYPE;
   WK_DESMAX                     TI_PRO.DESMAX%TYPE;
   WK_DESIDE                     TI_PRO.DESIDE%TYPE;
   WK_PERLUC                     TI_PRO.PERLUC%TYPE;
   WK_PERCOM                     TI_PRO.PERCOM%TYPE;
   WK_LOCALI                     TI_PRO.LOCALI%TYPE;
   WK_UNIDAD                     TI_PRO.UNIDAD%TYPE;
   WK_UNIFOR                     TI_PRO.UNIFOR%TYPE;
   WK_VALCON                     TI_PRO.VALCON%TYPE;
   WK_CUSFRE                     TI_PRO.CUSFRE%TYPE;
   WK_CONAPL                     TI_PRO.CONAPL%TYPE;
   WK_QTDEMB                     TI_PRO.QTDEMB%TYPE;
   WK_UNIAPL                     TI_PRO.UNIAPL%TYPE;
   WK_UNIEMB                     TI_PRO.UNIEMB%TYPE;
   WK_DESCOM                     TI_PRO.DESCOM%TYPE;
   WK_FORLIN                     TI_PRO.FORLIN%TYPE;
   WK_ICMCOM                     TI_PRO.ICMCOM%TYPE;
   WK_ICMFRE                     TI_PRO.ICMFRE%TYPE;
   WK_IPICOM                     TI_PRO.IPICOM%TYPE;
   WK_MARKUP                     TI_PRO.MARKUP%TYPE;
   WK_OBSGRA                     TI_PRO.OBSGRA%TYPE;
   WK_PREPSI                     TI_PRO.PREPSI%TYPE;
   WK_QTDCOM                     TI_PRO.QTDCOM%TYPE;
   WK_SEGFRE                     TI_PRO.SEGFRE%TYPE;
   WK_SUBCOM                     TI_PRO.SUBCOM%TYPE;
   WK_TAXCOM                     TI_PRO.TAXCOM%TYPE;
   WK_CAL_CM                     TI_PRO.CAL_CM%TYPE;
   WK_PRECOV                     TI_PRO.PRECOV%TYPE;
   WK_ESTADO                     TI_PRO.ESTADO%TYPE;
   WK_CODFIS                     TI_PRO.CODFIS%TYPE;
   WK_RESICM                     TI_PRO.RESICM%TYPE;
   WK_REDESP                     TI_PRO.REDESP%TYPE;
   WK_REDUME                     TI_PRO.REDUME%TYPE;
   WK_REDALI                     TI_PRO.REDALI%TYPE;
   WK_REDUC1                     TI_PRO.REDUC1%TYPE;
   WK_REDUC2                     TI_PRO.REDUC2%TYPE;
   WK_LUCSUB                     TI_PRO.LUCSUB%TYPE;
   WK_SUBTRI                     TI_PRO.SUBTRI%TYPE;
   WK_INSAGR                     TI_PRO.INSAGR%TYPE;
   WK_CALSUB                     TI_PRO.CALSUB%TYPE;
   WK_CODTRI                     TI_PRO.CODTRI%TYPE;
   WK_REGESP                     TI_PRO.REGESP%TYPE;
   WK_PERSRV                     TI_PRO.PERSRV%TYPE;
   WK_RESIPI                     TI_PRO.RESIPI%TYPE;
   WK_RESIRR                     TI_PRO.RESIRR%TYPE;
   WK_SUBFED                     TI_PRO.SUBFED%TYPE;
   WK_NOMIMG                     TI_PRO.NOMIMG%TYPE;
   WK_STATUS                     TI_PRO.STATUS%TYPE;
   WK_MOTREJ                     TI_PRO.MOTREJ%TYPE;
   WK_DATIMP                     TI_PRO.DATIMP%TYPE;
   WK_CODMON                     TI_PRO.CODMON%TYPE;
   WK_CODLPC                     TI_PRO.CODLPC%TYPE;
   WK_TIPRCE                     TI_PRO.TIPRCE%TYPE;
   WK_DESCFP                     TI_PRO.DESCFP%TYPE;
   WK_DATCRI                     TI_PRO.DATCRI%TYPE;
   WK_SUGSER                     TI_PRO.SUGSER%TYPE;
   WK_PERSER                     TI_PRO.PERSER%TYPE;
   WK_BALSIM                     TI_PRO.BALSIM%TYPE;
   WK_TERASS                     TI_PRO.TERASS%TYPE;
   WK_FLGSER                     TI_PRO.FLGSER%TYPE;
   WK_VALEST                     TI_PRO.VALEST%TYPE;
   WK_DESICO                     TI_PRO.DESICO%TYPE;
   WK_ORICUS                     TI_PRO.ORICUS%TYPE;
   WK_IPICUS                     TI_PRO.IPICUS%TYPE;
   WK_ICMCUS                     TI_PRO.ICMCUS%TYPE;
   WK_OUTCUS                     TI_PRO.OUTCUS%TYPE;
   WK_GRAATI                     TI_PRO.GRAATI%TYPE;
   WK_DACCUS                     TI_PRO.DACCUS%TYPE;
   WK_AFICUS                     TI_PRO.AFICUS%TYPE;
   WK_ICMTIP                     TI_PRO.ICMTIP%TYPE;
   WK_PERFRE                     TI_PRO.PERFRE%TYPE;
   WK_ALIFRE                     TI_PRO.ALIFRE%TYPE;
   WK_VOLUME                     TI_PRO.VOLUME%TYPE;
   WK_REDTRA                     TI_PRO.REDTRA%TYPE;
   WK_REDCON                     TI_PRO.REDCON%TYPE;
   WK_APLCON                     TI_PRO.APLCON%TYPE;
   WK_SITCOF                     TI_PRO.SITCOF%TYPE;
   WK_SITPIS                     TI_PRO.SITPIS%TYPE;
   WK_CODFPS                     TI_PRO.CODFPS%TYPE;
   WK_SITIPI                     TI_PRO.SITIPI%TYPE;
   WK_CODNCM                     TI_PRO.CODNCM%TYPE;
   WK_DESNCM                     TI_PRO.DESNCM%TYPE;
   WK_TIPDOC                     TI_PRO.TIPDOC%TYPE;
   WK_MVACOM                     TI_PRO.MVACOM%TYPE;
   WK_ALTURA                     TI_PRO.ALTURA%TYPE;
   WK_LARGUR                     TI_PRO.LARGUR%TYPE;
   WK_PROFUN                     TI_PRO.PROFUN%TYPE;
   WK_ISEPIS                     TI_PRO.ISEPIS%TYPE;
   WK_ICMFED                     TI_PRO.ICMFED%TYPE;
   WK_ARRTRU                     TI_PRO.ARRTRU%TYPE;
   WK_IIPTPR                     TI_PRO.IIPTPR%TYPE;
   WK_CODANP                     TI_PRO.CODANP%TYPE;
   WK_COD_EX                     TI_PRO.COD_EX%TYPE;
   WK_IMPKIT                     TI_PRO.IMPKIT%TYPE;
   WK_ORIPRO                     TI_PRO.ORIPRO%TYPE;
   WK_DESDET                     TI_PRO.DESDET%TYPE;
   WK_NATBCC                     TI_PRO.NATBCC%TYPE;
   WK_MVAVEN                     TI_PRO.MVAVEN%TYPE;
   WK_MVAC07                     TI_PRO.MVAC07%TYPE;
   WK_MVAC12                     TI_PRO.MVAC12%TYPE;
   WK_MVAC04                     TI_PRO.MVAC04%TYPE;
   WK_ICMISE                     TI_PRO.ICMISE%TYPE;
   WK_REDSIM                     TI_PRO.REDSIM%TYPE;
   --WK_AUX_REFBAS                 TI_PRO.REFBAS%TYPE;
   WK_AUX_RESICM                 TI_PRO.RESICM%TYPE;
   WK_AUX_RESIPI                 TI_PRO.RESIPI%TYPE;
   WK_AUX_RESIRR                 TI_PRO.RESIRR%TYPE;
   WK_AUX_CODTRI                 TI_PRO.CODTRI%TYPE;
   WK_AUX_REDALI                 TI_PRO.REDALI%TYPE;
   WK_AUX_REDTRA                 TI_PRO.REDTRA%TYPE;
   WK_AUX_REDCON                 TI_PRO.REDCON%TYPE;
   WK_AUX_APLCON                 TI_PRO.APLCON%TYPE;
   WK_AUX_REDESP                 TI_PRO.REDESP%TYPE;
   WK_AUX_REDUME                 TI_PRO.REDUME%TYPE;
   WK_AUX_REDUC1                 TI_PRO.REDUC1%TYPE;
   WK_AUX_REDUC2                 TI_PRO.REDUC2%TYPE;
   WK_AUX_ETIQUE                 TI_PRO.ETIQUE%TYPE;
   WK_AUX_DESGRA                 TI_PRO.DESGRA%TYPE;
   WK_AUX_NOMGRA_CODEXT          TI_PRO.NOMGRA_CODEXT%TYPE;
   WK_AUX_DESINA                 TI_PRO.DESINA%TYPE;
   WK_AUX_DEPART                 TI_PRO.DEPART%TYPE;
   WK_AUX_CLASS1                 TI_PRO.CLASS1%TYPE;
   WK_AUX_CLASS2                 TI_PRO.CLASS2%TYPE;
   WK_AUX_CLASS3                 TI_PRO.CLASS3%TYPE;
   WK_AUX_CLASS4                 TI_PRO.CLASS4%TYPE;
   WK_AUX_SAZONA                 TI_PRO.SAZONA%TYPE;
   WK_AUX_UNIDAD                 TI_PRO.UNIDAD%TYPE;
   WK_AUX_UNIFOR                 TI_PRO.UNIFOR%TYPE;
   WK_AUX_UNIAPL                 TI_PRO.UNIAPL%TYPE;
   WK_AUX_UNIEMB                 TI_PRO.UNIEMB%TYPE;
   WK_AUX_CODFIS                 TI_PRO.CODFIS%TYPE;
   WK_AUX_NOMDIV                 TI_PRO.NOMDIV%TYPE;
   WK_AUX_NOMDIV_CODEXT          TI_PRO.NOMDIV_CODEXT%TYPE;
   WK_AUX_NOMSUB                 TI_PRO.NOMSUB%TYPE;
   WK_AUX_NOMSUB_CODEXT          TI_PRO.NOMSUB_CODEXT%TYPE;
   WK_AUX_CODMON                 TI_PRO.CODMON%TYPE;
   WK_AUX_CODLPC                 TI_PRO.CODLPC%TYPE;
   WK_NEW_DESMAT                 TI_PRO.DESMAT%TYPE;
   WK_DESWEB                     TI_PRO.DESWEB%TYPE;
   WK_NOMDIV_CODEXT              TI_PRO.NOMDIV_CODEXT%TYPE;
   WK_NOMSUB_CODEXT              TI_PRO.NOMSUB_CODEXT%TYPE;
   WK_NOMGRA_CODEXT              TI_PRO.NOMGRA_CODEXT%TYPE;
   WK_ITEDIV_CODEXT              TI_PRO.ITEDIV_CODEXT%TYPE;
   WK_ITESUB_CODEXT              TI_PRO.ITESUB_CODEXT%TYPE;
   WK_USALOT                     TI_PRO.USALOT%TYPE;
   WK_LOTONL                     TI_PRO.LOTONL%TYPE;
   WK_VLRPIS                     TI_PRO.VLRPIS%TYPE;
   WK_VLRCOF                     TI_PRO.VLRCOF%TYPE;
   WK_CODENQ                     TI_PRO.CODENQ%TYPE;
   WK_CODCES                     TI_PRO.CODCES%TYPE;
   WK_DESCES                     TI_PRO.DESCES%TYPE;   
   WK_TIPMPB                     TI_PRO.TIPMPB%TYPE;
   WK_NOMSUB_CODSAL              TI_PRO.NOMSUB_CODSAL%TYPE;
   WK_ITESUB_FATCON              TI_PRO.ITESUB_FATCON%TYPE;
   WK_ESTCHE                     TI_PRO.ESTCHE%TYPE;
   WK_QTDLIM_PJ                  TI_PRO.QTDLIM_PJ%TYPE;
   WK_QTDLIM_PF                  TI_PRO.QTDLIM_PF%TYPE;
   WK_CODBEN_00                  TI_PRO.CODBEN_00%TYPE;
   WK_CODBEN_10                  TI_PRO.CODBEN_10%TYPE;
   WK_CODBEN_20                  TI_PRO.CODBEN_20%TYPE;
   WK_CODBEN_30                  TI_PRO.CODBEN_30%TYPE;
   WK_CODBEN_40                  TI_PRO.CODBEN_40%TYPE;
   WK_CODBEN_41                  TI_PRO.CODBEN_41%TYPE;
   WK_CODBEN_50                  TI_PRO.CODBEN_50%TYPE;
   WK_CODBEN_51                  TI_PRO.CODBEN_51%TYPE;
   WK_CODBEN_60                  TI_PRO.CODBEN_60%TYPE;
   WK_CODBEN_70                  TI_PRO.CODBEN_70%TYPE;
   WK_CODBEN_90                  TI_PRO.CODBEN_90%TYPE;
   WK_PERDIF                     TI_PRO.PERDIF%TYPE;
   WK_ALIDIF                     TI_PRO.ALIDIF%TYPE;
   WK_AUX_ALIDIF                 TI_PRO.ALIDIF%TYPE;
   WK_REGDIF                     TI_PRO.REGDIF%TYPE;
   WK_IMGGRU                     TI_PRO.IMGGRU%TYPE;
   WK_FIL_EXISTE                 TI_PRO.STATUS%TYPE;
   
-- TT_PRO
   WK_COD_CODMON                 TT_PRO.CODMON%TYPE;
   WK_COD_CODLPC                 TT_PRO.CODLPC%TYPE;
   WK_SIGNAT                     TT_PRO.SIGNAT%TYPE;
   WK_ITEMAR                     TT_PRO.ITEMAR%TYPE;
   WK_EXISTE_MAR                 TT_PRO.ITEMAR%TYPE;
   WK_REFBAS_REP                 TT_PRO.REFBAS%TYPE;
   WK_PROCON                     TT_PRO.PROCON%TYPE;

   -- TT_GRA
   WK_CODEXT_GRA                 TT_GRA.CODEXT%TYPE;
   WK_CODCOR                     TT_GRA.CODCOR%TYPE;
   WK_CODTAM                     TT_GRA.CODTAM%TYPE;
   WK_REFPRO_REP                 TT_GRA.REFPRO%TYPE;
   WK_NEW_GRAATI                 TT_GRA.GRAATI%TYPE;
   WK_MAXPAR                     TT_GRA.MAXPAR%TYPE;
   WK_GRA_DESGRA                 TT_GRA.DESGRA%TYPE;

-- TT_IED
   WK_DIALIM                     TT_IED.DIALIM%TYPE;
   WK_IMPORT                     TT_IED.IMPORT%TYPE;
   WK_MANTEM                     TT_IED.MANTEM%TYPE;
   WK_CNTIMP                     TT_IED.CNTIMP%TYPE;

-- TT_REL
   WK_FILPAR                     TT_REL.FILPAR%TYPE;
   WK_CODPAR                     TT_REL.CODPAR%TYPE;
   WK_TIPPAR                     TT_REL.TIPPAR%TYPE;

-- TT_CFG
   WK_CFG_CODPRE                 TT_CFG.CODPRE%TYPE;
   WK_CFG_FILPRE                 TT_CFG.FILPRE%TYPE;
   WK_MAI_FR                     TT_CFG.MAI_FR%TYPE;
   WK_MAI_TO                     TT_CFG.MAI_TO%TYPE;
   WK_SAC_E_MAIL                 TT_CFG.SAC_E_MAIL%TYPE;
   WK_REUTILIZA_REFERENCIA       TT_CFG.REUTILIZA_REFERENCIA%TYPE;

-- TDs
   WK_COD_CODGRA                 TD_GRA.CODTAB%TYPE;
   WK_COD_RESICM                 TD_ICM.CODTAB%TYPE;
   WK_COD_RESIPI                 TD_IPI.CODTAB%TYPE;
   WK_COD_RESIRR                 TD_IRR.CODTAB%TYPE;
   WK_COD_CODTRI                 TD_TRI.CODTAB%TYPE;
   WK_COD_REDALI                 TD_IRE.CODTAB%TYPE;
   WK_COD_REDESP                 TD_IES.CODTAB%TYPE;
   WK_COD_REDUME                 TD_IME.CODTAB%TYPE;
   WK_COD_REDUC1                 TD_IR1.CODTAB%TYPE;
   WK_COD_REDUC2                 TD_IR2.CODTAB%TYPE;
   WK_COD_ETIQUE                 TD_ETI.CODTAB%TYPE;
   WK_COD_CODINA                 TD_INA.CODTAB%TYPE;
   WK_COD_DEPART                 TD_DEP.CODTAB%TYPE;
   WK_COD_CLASS1                 TD_CL1.CODTAB%TYPE;
   WK_COD_CLASS2                 TD_CL2.CODTAB%TYPE;
   WK_COD_CLASS3                 TD_CL3.CODTAB%TYPE;
   WK_COD_CLASS4                 TD_CL4.CODTAB%TYPE;
   WK_COD_CODSAZ                 TD_SAZ.CODTAB%TYPE;
   WK_COD_UNIDAD                 TD_MED.CODTAB%TYPE;
   WK_COD_UNIFOR                 TD_MED.CODTAB%TYPE;
   WK_COD_UNIAPL                 TD_MED.CODTAB%TYPE;
   WK_COD_UNIEMB                 TD_MED.CODTAB%TYPE;
   WK_COD_CODFIS                 TD_FIS.CODTAB%TYPE;
   WK_CODCFP                     TD_CFP.CODTAB%TYPE;
   WK_COD_ALIDIF                 TD_ICM.CODTAB%TYPE;

-- Outras variveis
   WK_COD_DIVISA                 Numeric;
   WK_COD_SUBDIV                 Numeric;
   WK_IUF_COUNT                  Numeric;
   WK_CADASTRADO                 Numeric;
   WK_COUNT                      Numeric;
   WK_COUNT_REFBAS               Numeric;
   WK_COUNT_PRO                  Numeric;
   WK_ERRO                       Numeric;
   WK_QTDIMP                     Numeric;
   WK_NROERR                     Numeric;
   WK_CONTADOR                   Numeric;
   WK_EXISTE                     CHAR(1);
   WK_FILPRE                     TT_CFG.FILPRE%TYPE;
   WK_CODPRE                     TT_CFG.CODPRE%TYPE;
   WK_NIVNCM                     TT_NCM.NIVNCM%TYPE;

   WK_RESTO                      Numeric;
   WK_NUMREG                     Numeric = 500;
   WK_IMP_CFP                    VARCHAR(2);
   cDUMMY                        VARCHAR(2);

   WK_QTD_DIV                    INTEGER;
   WK_NOMITE_DIV                 TT_DIV.NOMITE%TYPE;
   WK_QTD_SUB                    INTEGER;
   WK_NOMITE_SUB                 TT_SUB.NOMITE%TYPE;
   WK_ULTCODATU                  TT_COD.ULTCOD%TYPE;
   WK_AUX_DIV_NOMEXT             TT_DIV.NOMEXT%TYPE;
   WK_AUX_SUB_NOMEXT             TT_SUB.NOMEXT%TYPE;
   WK_QTD_INTEG_AGRU             INTEGER; --DN-103326
   WK_SUB_CODSAL                 TT_SUB.CODITE%TYPE;
   WK_SUB_FATCON                 TT_SUB.FATCON%TYPE;
   iREGRA_CODFIS                 TT_CFG.REGRA_CODFIS%TYPE;

   WK_CODMATNAOUSADO             TI_PRO.CODMAT%TYPE;
   WK_EXISTE_CODMAT              Numeric;

CR_REFBAS CURSOR FOR
   SELECT FILMAT, CODMAT FROM TT_PRO WHERE REFBAS = WK_REFBAS;

CR_PRODUTOS CURSOR(pDATCRI TI_PRO.DATCRI%TYPE) IS
/*Status => 0 no processado
         => 1 processado com sucesso
         => 2 processado com erro*/
   SELECT *
     FROM (SELECT /*+INDEX(TI_PRO, I_LC_IPRO_STATUS)*/
                  CODEXT,FILMAT,CODMAT,REFBAS,TRIM(DESMAT),TRIM(ESPMAT),CODCTR,CONTRA,CONTRO,DESECF,CODFAB,DESMAR,
                  ENTREG,ATIVO,DESINA,COALESCE(CLASS1,'NAO USA') AS CLASS1,
                  COALESCE(CLASS2,'NAO USA') AS CLASS2,COALESCE(CLASS3,'NAO USA') AS CLASS3,COALESCE(CLASS4,'NAO USA') AS CLASS4,
                  COALESCE(DEPART,'NAO USA') AS DEPART,COALESCE(SAZONA,'Sem Variao') AS SAZONA,TIPPRO,CLSXYZ,DATCAD,DECIMA,
                  COALESCE(ETIQUE,'NAO USA') AS ETIQUE,NUMEXT,OBSERV,BRINDE,COALESCE(DESGRA,'NAO USA') AS DESGRA,MONTAR,NUMITE,RETCOF,/*COALESCE(NOMDIV,'DIVISAO') AS*/ NOMDIV,/*COALESCE(NOMSUB,'SUB DIVISAO') AS*/ NOMSUB,TIPVAL,VALIDA,
                  VOLUNI,TRIM(REFPRO),MINQTD,PTOQTD,QTDREP,PESLIQ,PESBRU,PROMOC,PRECOM,DATCOM,CUSREP,TEMREP,
                  DESMAX,DESIDE,PERLUC,PERCOM,LOCALI,UNIDAD,UNIFOR,VALCON,CUSFRE,CONAPL,QTDEMB,UNIAPL,
                  UNIEMB,DESCOM,FORLIN,ICMCOM,ICMFRE,IPICOM,MARKUP,OBSGRA,PREPSI,QTDCOM,SEGFRE,SUBCOM,
                  TAXCOM,CAL_CM,PRECOV,ESTADO,CODFIS,RESICM,REDESP,REDUME,REDALI,REDUC1,REDUC2,LUCSUB,
                  SUBTRI,INSAGR,CALSUB,CODTRI,REGESP,PERSRV,RESIPI,RESIRR,
                  DATIMP,/*COALESCE(ITEDIV,'--') AS*/ ITEDIV,/*COALESCE(ITESUB,'--') AS*/ ITESUB,SUBFED,NOMIMG,DESCFP,CODMON,CODLPC,TIPRCE,COALESCE(SUGSER,'F') AS SUGSER,PERSER,COALESCE(BALSIM,'F') AS BALSIM,TERASS,FLGSER,COALESCE(VALEST,'T') AS VALEST,
                  DESICO,ORICUS,IPICUS,ICMCUS,OUTCUS,GRAATI,DACCUS,AFICUS,ICMTIP,PERFRE,ALIFRE,VOLUME,REDTRA,REDCON,APLCON,
                  SITCOF,SITPIS,CODFPS,SITIPI,CODNCM,DESNCM,  TIPDOC,ISEPIS,ICMFED,ARRTRU,IIPTPR,CODANP,COD_EX,
                  IMPKIT,ORIPRO,DESDET,NATBCC,MVAVEN,MVAC07,MVAC12,ICMISE,REDSIM, MVACOM,ALTURA,LARGUR,PROFUN,
                  DESWEB,NOMDIV_CODEXT,NOMSUB_CODEXT,NOMGRA_CODEXT,ITEDIV_CODEXT,ITESUB_CODEXT,USALOT,LOTONL,
                  VLRPIS,VLRCOF, CODENQ, CODCES, DESCES,TIPMPB, MVAC04, MAXPAR, NOMSUB_CODSAL, ITESUB_FATCON,
                  TRIM(GRA_DESGRA), ESTCHE, PROCON, QTDLIM_PJ, QTDLIM_PF,
                  CODBEN_00, CODBEN_10, CODBEN_20, CODBEN_30, CODBEN_40, CODBEN_41, CODBEN_50, CODBEN_51, CODBEN_60, CODBEN_70, CODBEN_90,
                  PERDIF, COALESCE(ALIDIF, 0) AS ALIDIF, COALESCE(REGDIF, 'C') AS REGDIF, IMGGRU
             FROM TI_PRO
            WHERE STATUS = 0
              AND DATCRI BETWEEN TRUNC(pDATCRI)
                             AND ADD_DAY(TRUNC(pDATCRI),1)
            ORDER BY DATCRI) TAB
      
   LIMIT 1;
   
BEGIN
   -- RFMP 80113
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20021 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

         SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
        INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
        FROM TT_IED
       WHERE TABELA = 'PRO';
   
   IF WK_IMPORT = 'T' THEN
      WK_CNTIMP     := WK_CNTIMP + 1;
      WK_QTDIMP     := 0;
      WK_NROERR     := 0;

      SELECT COALESCE(REUTILIZA_REFERENCIA,'F'), REGRA_CODFIS
        INTO WK_REUTILIZA_REFERENCIA, iREGRA_CODFIS
        FROM TT_CFG;
        
            
      SELECT IMPORTA_CFP() INTO WK_IMP_CFP;
      
      LOOP
         SELECT MIN(DATCRI)
           INTO WK_DATCRI
           FROM TI_PRO
          WHERE STATUS = 0;

         OPEN CR_PRODUTOS(WK_DATCRI);
         FETCH CR_PRODUTOS INTO WK_CODEXT,WK_FILMAT,WK_CODMAT,WK_REFBAS,WK_DESMAT,WK_ESPMAT,WK_CODCTR,WK_CONTRA,WK_CONTRO,WK_DESECF,WK_CODFAB,WK_DESMAR,
                                WK_ENTREG,WK_ATIVO,WK_DESINA,WK_CLASS1,WK_CLASS2,WK_CLASS3,WK_CLASS4,WK_DEPART,WK_SAZONA,WK_TIPPRO,WK_CLSXYZ,WK_DATCAD,WK_DECIMA,
                                WK_ETIQUE,WK_NUMEXT,WK_OBSERV,WK_BRINDE,WK_DESGRA,WK_MONTAR,WK_NUMITE,WK_RETCOF,WK_NOMDIV,WK_NOMSUB,WK_TIPVAL,WK_VALIDA,
                                WK_VOLUNI,WK_REFPRO,WK_MINQTD,WK_PTOQTD,WK_QTDREP,WK_PESLIQ,WK_PESBRU,WK_PROMOC,WK_PRECOM,WK_DATCOM,WK_CUSREP,WK_TEMREP,
                                WK_DESMAX,WK_DESIDE,WK_PERLUC,WK_PERCOM,WK_LOCALI,WK_UNIDAD,WK_UNIFOR,WK_VALCON,WK_CUSFRE,WK_CONAPL,WK_QTDEMB,WK_UNIAPL,
                                WK_UNIEMB,WK_DESCOM,WK_FORLIN,WK_ICMCOM,WK_ICMFRE,WK_IPICOM,WK_MARKUP,WK_OBSGRA,WK_PREPSI,WK_QTDCOM,WK_SEGFRE,WK_SUBCOM,
                                WK_TAXCOM,WK_CAL_CM,WK_PRECOV,WK_ESTADO,WK_CODFIS,WK_RESICM,WK_REDESP,WK_REDUME,WK_REDALI,WK_REDUC1,WK_REDUC2,WK_LUCSUB,
                                WK_SUBTRI,WK_INSAGR,WK_CALSUB,WK_CODTRI,WK_REGESP,WK_PERSRV,WK_RESIPI,WK_RESIRR,
                                WK_DATIMP,WK_ITEDIV,WK_ITESUB,WK_SUBFED,WK_NOMIMG,WK_DESCFP,WK_CODMON,WK_CODLPC,WK_TIPRCE,
                                WK_SUGSER,WK_PERSER,WK_BALSIM,WK_TERASS,WK_FLGSER,WK_VALEST,
                                WK_DESICO,WK_ORICUS,WK_IPICUS,WK_ICMCUS,WK_OUTCUS,WK_GRAATI,WK_DACCUS,WK_AFICUS,WK_ICMTIP,WK_PERFRE,WK_ALIFRE,WK_VOLUME,WK_REDTRA,WK_REDCON,WK_APLCON,
                                WK_SITCOF,WK_SITPIS,WK_CODFPS,WK_SITIPI,WK_CODNCM,WK_DESNCM, WK_TIPDOC,WK_ISEPIS,WK_ICMFED,WK_ARRTRU,WK_IIPTPR,WK_CODANP,WK_COD_EX,
                                WK_IMPKIT,WK_ORIPRO,WK_DESDET,WK_NATBCC,WK_MVAVEN,WK_MVAC07,WK_MVAC12,WK_ICMISE,WK_REDSIM,WK_MVACOM,WK_ALTURA,WK_LARGUR,WK_PROFUN,
                                WK_DESWEB,WK_NOMDIV_CODEXT,WK_NOMSUB_CODEXT,WK_NOMGRA_CODEXT,WK_ITEDIV_CODEXT,WK_ITESUB_CODEXT,WK_USALOT,WK_LOTONL,
                                WK_VLRPIS,WK_VLRCOF, WK_CODENQ, WK_CODCES, WK_DESCES, WK_TIPMPB, WK_MVAC04, WK_MAXPAR, WK_NOMSUB_CODSAL, WK_ITESUB_FATCON,
                                WK_GRA_DESGRA, WK_ESTCHE, WK_PROCON, WK_QTDLIM_PJ, WK_QTDLIM_PF,
                                WK_CODBEN_00, WK_CODBEN_10, WK_CODBEN_20, WK_CODBEN_30, WK_CODBEN_40, WK_CODBEN_41, WK_CODBEN_50, WK_CODBEN_51, WK_CODBEN_60, WK_CODBEN_70, WK_CODBEN_90,
                                WK_PERDIF, WK_ALIDIF, WK_REGDIF, WK_IMGGRU
                                ;

         IF NOT FOUND THEN
            CLOSE CR_PRODUTOS;
            EXIT;
         END IF;

         
         IF WK_NUMREG = 0 THEN
            CLOSE CR_PRODUTOS;
            EXIT;
         END IF;
         
         WK_MOTREJ := 'OK';

         IF WK_CODEXT IS NULL THEN
            WK_MOTREJ := '20100 - A coluna CODEXT deve ser preenchida';
         END IF;

         IF WK_NOMDIV IS NULL THEN
            WK_MOTREJ := '20101 - A coluna NOMDIV deve ser preenchida';
         END IF;

         IF WK_NOMSUB IS NULL THEN
            WK_MOTREJ := '20102 - A coluna NOMSUB deve ser preenchida';
         END IF;

         IF WK_DESGRA IS NULL THEN
            WK_MOTREJ := '20103 - A coluna DESGRA deve ser preenchida';
         END IF;

         IF WK_ITEDIV IS NULL THEN
            WK_MOTREJ := '20104 - A coluna ITEDIV deve ser preenchida';
         END IF;

         IF WK_ITESUB IS NULL THEN
            WK_MOTREJ := '20105 - A coluna ITESUB deve ser preenchida';
         END IF;

         IF WK_ORIPRO IS NULL THEN
            WK_MOTREJ := '20106 - A coluna ORIPRO deve ser preenchida';
         END IF;
       
		  SELECT count(*) 
			INTO WK_QTD_INTEG_AGRU
			FROM TT_FUN
		   WHERE NOMFUN='INTEG_AGRU';

		 --DN-103326
		 IF WK_QTD_INTEG_AGRU>0 THEN
			WK_GRAATI := 'F';
			WK_REFBAS := SUBSTR(WK_CODEXT,1,15);
		 END IF;

         --WK_AUX_REFBAS := 'NOVO';
         WK_AUX_RESICM := 100;
         WK_AUX_ALIDIF := 100;
         WK_AUX_RESIPI := 100;
         WK_AUX_RESIRR := 100;
         WK_AUX_CODTRI := 'CODTRI';
         WK_AUX_REDALI := 100;
         WK_AUX_REDTRA := 99.9999;
         WK_AUX_REDCON := 100;
         WK_AUX_APLCON := 'T';
         WK_AUX_REDESP := 100;
         WK_AUX_REDUME := 100;
         WK_AUX_REDUC1 := 100;
         WK_AUX_REDUC2 := 100;
         WK_AUX_ETIQUE := 'IMPORTA_PRO';
         WK_AUX_CODMON := 'IMPORTA_PRO';
         WK_AUX_CODLPC := 'IMPORTA_PRO';
         WK_AUX_DESGRA := 'IMPORTA_PRO';
         WK_AUX_NOMGRA_CODEXT := 'IMPORTA_PRO';
         WK_AUX_DESINA := 'IMPORTA_PRO';
         WK_AUX_DEPART := 'IMPORTA_PRO';
         WK_AUX_CLASS1 := 'IMPORTA_PRO';
         WK_AUX_CLASS2 := 'IMPORTA_PRO';
         WK_AUX_CLASS3 := 'IMPORTA_PRO';
         WK_AUX_CLASS4 := 'IMPORTA_PRO';
         WK_AUX_SAZONA := 'IMPORTA_PRO';
         WK_AUX_UNIDAD := 'TT';
         WK_AUX_UNIFOR := 'TT';
         WK_AUX_UNIAPL := 'TT';
         WK_AUX_UNIEMB := 'TT';
         WK_AUX_CODFIS := 'IMPORTA_PRO';
         WK_AUX_NOMDIV := 'IMPORTA_PRO';
         WK_AUX_NOMDIV_CODEXT := 'IMPORTA_PRO';
         WK_AUX_NOMSUB := 'IMPORTA_PRO';
         WK_AUX_NOMSUB_CODEXT := 'IMPORTA_PRO';

         
         -- Guarda o GRAATI original
         WK_NEW_GRAATI := WK_GRAATI;
         IF (WK_REUTILIZA_REFERENCIA = 'T') AND (WK_MOTREJ = 'OK') THEN

            --REFPRO
            WK_REFPRO_REP := 'T';
                        SELECT REFPRO
              INTO WK_REFPRO_REP
              FROM TT_GRA
             WHERE REFPRO = WK_REFPRO
               AND CODEXT <> WK_CODEXT;
            
            IF (COALESCE(WK_REFPRO_REP,'T') <> 'T') THEN
               --UPDATE TT_GRA SET REFPRO = CASE WHEN INSTR(REFPRO,'#') > 0
               --                                THEN TO_NUMBER(SUBSTR(REFPRO,1,INSTR(REFPRO,'#')-1)) + 1||'#'||SUBSTR(REFPRO,INSTR(REFPRO,'#')+1,LENGTH(REFPRO))
               --                                ELSE '1#'||TRIM(REFPRO)
               --                            END, GRAATI = 'F'
               -- RFMP 81140 Mudana realizada para atender a importacao de produtos da Marisol
               UPDATE TT_GRA GRA SET REFPRO = COALESCE((SELECT TO_NUMBER(MAX(SUBSTR(INT.REFPRO,1,INSTR(INT.REFPRO,'#')-1))) +1
                                                          FROM TT_GRA INT
                                                         WHERE INT.REFPRO LIKE '%#'||GRA.REFPRO),1)||'#'||GRA.REFPRO,
                                     GRAATI = 'F',
                                     ATU_EM = Agora(),
                                     DUMMY = Constante('MANTEM_ATU_EM') -- Pedro E. Braga - 104287 - Marca para no atualizar tabela pai pois processo de importao j faz isso e estava causando lentido
                WHERE REFPRO = WK_REFPRO_REP;
              WK_GRAATI := 'F';
            END IF;

            --REFBAS
            WK_REFBAS_REP := 'T';
                        SELECT PRO.REFBAS
              INTO WK_REFBAS_REP
              FROM TT_PRO PRO INNER JOIN TT_GRA GRA ON GRA.FILMAT = PRO.FILMAT AND GRA.CODMAT = PRO.CODMAT
             WHERE PRO.REFBAS <> WK_REFBAS
               AND GRA.CODEXT = WK_CODEXT;
            
            IF (COALESCE(WK_REFBAS_REP,'T') <> 'T') THEN
               SELECT COUNT(*)
                 INTO WK_COUNT_REFBAS
                 FROM TT_PRO
                WHERE REFBAS = WK_REFBAS;
               IF WK_COUNT_REFBAS = 0 THEN
                  UPDATE TT_PRO SET REFBAS = WK_REFBAS,
                                    ATU_EM = Agora(),
                                    DUMMY = Constante('MANTEM_ATU_EM') -- Pedro E. Braga - 104287 - Marca para no atualizar tabela de preo pois processo de importao j faz isso quando informado o preo e estava causando lentido
                   WHERE REFBAS = WK_REFBAS_REP;
               END IF;
            END IF;
         END IF; -- Reutiliza referencia

         WK_FIL_EXISTE := 0;

         -- Select para verificar se filial existe na base
                     SELECT 1 AS EXIST 
              INTO WK_FIL_EXISTE
              FROM TD_FIL DFIL 
             WHERE DFIL.CODFIL = WK_FILMAT;
          
         
         IF (WK_FIL_EXISTE IS NULL) THEN
            WK_FIL_EXISTE := 0;
         END IF;
      
         -- Valida se filial existe na base de dados
         IF (WK_MOTREJ = 'OK') AND (WK_FIL_EXISTE <> 1) THEN
            WK_MOTREJ := 'Filial no localizada: "' || COALESCE(WK_FILMAT, '') || '".';
         END IF;  


         -- Inicio da busca pelo codmat
         -- Se o CODMAT no foi informado na TI_PRO, busca ele da TT_PRO, pesquisando por REFBAS. 
         -- Se no encontrou, busca nos "GAPs" dos CODMAT no usados atravs da funo BUSCACODIGOPRODUTONAOUSADO
         -- Se mesmo assim no encontrou, busca em TT_COD e se l no existir, inicia em 1 e grava na TT_COD
         IF (WK_MOTREJ = 'OK') AND (WK_CODMAT IS NULL) THEN
         
            WK_FILMAT_TMP := WK_FILMAT;

                        SELECT GRA.FILMAT, GRA.CODMAT
              INTO WK_FILMAT, WK_CODMAT
              FROM TT_GRA GRA
             WHERE GRA.CODEXT = WK_CODEXT;
            
            IF WK_FILMAT IS NULL THEN
               WK_FILMAT := WK_FILMAT_TMP;
            END IF;

            IF WK_CODMAT IS NOT NULL THEN
               BEGIN
                  UPDATE TT_PRO
                     SET REFBAS = WK_REFBAS,
                         ATU_EM = Agora(),
                         DUMMY = Constante('MANTEM_ATU_EM') -- Pedro E. Braga - 104287 - Marca para no atualizar tabela de preo pois processo de importao j faz isso quando informado o preo e estava causando lentido
                   WHERE FILMAT = WK_FILMAT
                     AND CODMAT = WK_CODMAT;
               EXCEPTION
                  
                  WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR REFERENCIA BASICA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR REFERENCIA BASICA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR REFERENCIA BASICA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR REFERENCIA BASICA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR REFERENCIA BASICA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR REFERENCIA BASICA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR REFERENCIA BASICA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                   END;
            ELSE
               IF WK_REFBAS IS NOT NULL THEN
                   WK_FILMAT_TMP := WK_FILMAT;

                   Open cr_RefBas;
                   FETCH cr_RefBas into WK_FILMAT, WK_CODMAT;
                   IF NOT FOUND THEN
                      WK_FILMAT := NULL;
                      WK_CODMAT := NULL;
                   END IF;
                   Close cr_RefBas;

                   IF WK_FILMAT IS NULL THEN
                     WK_FILMAT := WK_FILMAT_TMP;
                   END IF;
               END IF;
            END IF;

            -- Gera novo codmat
            IF (WK_MOTREJ = 'OK') AND (WK_CODMAT IS NULL) THEN
               BEGIN
                  -- Verifica registro de controle
                  SELECT COUNT(*) INTO WK_COUNT
                    FROM TT_COD
                   WHERE CODTAB = 'PRO'
                     AND FILCOD = WK_FILMAT;

                  IF WK_COUNT > 0 THEN
                     -- Obtem cdigo atual
                     SELECT ULTCOD INTO WK_ULTCODATU
                       FROM TT_COD
                      WHERE CODTAB = 'PRO'
                        AND FILCOD = WK_FILMAT
                        FOR UPDATE;
                        
                     -- Somente busca pela Lacuna aps atingir o limite
                     IF ((WK_ULTCODATU + 1) > 99999) THEN
                        -- Busca por cdigo do produto (CODMAT) no utilizado e se no encontrar, gera um novo cdigo a partir da TT_COD (GES-2023033563)
                        SELECT BUSCACODIGOPRODUTONAOUSADO(WK_FILMAT) INTO WK_CODMATNAOUSADO FROM DUAL;
                     ELSE
                        WK_CODMATNAOUSADO := NULL;
                     END IF;

                     -- Verifica se o WK_CODMATNAOUSADO  menor que WK_ULTCODATU, se sim, utiliza o WK_CODMATNAOUSADO
                     IF (WK_CODMATNAOUSADO IS NOT NULL) AND (TO_NUMBER(COALESCE(WK_CODMATNAOUSADO, '0')) > 0) AND (TO_NUMBER(COALESCE(WK_CODMATNAOUSADO, '0')) < (WK_ULTCODATU + 1)) THEN
                        WK_CODMAT := LPAD(TO_CHAR(WK_CODMATNAOUSADO),5,' ');
                     ELSE
                        -- Controle do limite mximo do campo
                        IF ((WK_ULTCODATU + 1) > 99999) THEN
                           WK_MOTREJ := 'Limite mximo do CODMAT atingido.';
                        ELSE
                           WK_CODMAT := LPAD(TO_CHAR(WK_ULTCODATU + 1),5,' ');
                           -- Verifica se o WK_CODMAT retornado no WK_ULTCODATU + 1, no est atribuido a outro parceiro
                           SELECT COUNT(*) INTO WK_EXISTE_CODMAT FROM TT_PRO WHERE FILMAT = WK_FILMAT AND CODMAT = WK_CODMAT;
                           -- se existe_codmat j atribudo ento, considera o WK_CODMATNAOUSADO
                           IF (WK_EXISTE_CODMAT > 0) THEN
                              -- Busca por cdigo do produto (CODMAT) no utilizado e se no encontrar, gera um novo cdigo a partir da TT_COD (GES-2023033563)
                              SELECT BUSCACODIGOPRODUTONAOUSADO(WK_FILMAT) INTO WK_CODMATNAOUSADO FROM DUAL;

                              WK_CODMAT := LPAD(TO_CHAR(WK_CODMATNAOUSADO),5,' ');

                              -- Precisa definir como Null para que possa atualizar valor na TT_COD
                              WK_CODMATNAOUSADO := NULL;
                           END IF;
                        END IF;
                     END IF;

                     IF WK_MOTREJ = 'OK' THEN 
                        -- Atualiza cdigo de controle
                        UPDATE TT_COD SET ULTCOD = CASE WHEN (WK_CODMATNAOUSADO IS NOT NULL) AND (TO_NUMBER(COALESCE(WK_CODMATNAOUSADO, '0')) > 0) AND
                                                             (TO_NUMBER(COALESCE(WK_CODMATNAOUSADO, '0')) < (WK_ULTCODATU + 1)) THEN ULTCOD
                                                        WHEN (TO_NUMBER(TRIM(WK_CODMAT)) > ULTCOD) THEN TO_NUMBER(TRIM(WK_CODMAT))
                                                        ELSE ULTCOD
                                                   END
                         WHERE CODTAB = 'PRO'
                           AND FILCOD = WK_FILMAT;
                     END IF;
                  ELSE
                     INSERT INTO TT_COD (CODTAB,ULTCOD,FILCOD) VALUES ('PRO',1,WK_FILMAT);
                     WK_CODMAT := '    1';
                  END IF;
               EXCEPTION
                  
                  WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO CONSULTAR PROXIMO CODIGO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                   END;
            END IF;
         END IF; -- Fim da busca para definir codmat

         -- rfmp 68351
         IF WK_REFBAS IS NULL THEN
            WK_REFBAS := WK_CODEXT;
         END IF;

         IF (WK_MOTREJ = 'OK') THEN
            BEGIN
               -- Zera as variveis das tabelas de domnio
               WK_COD_RESICM := NULL;
               WK_COD_RESIPI := NULL;
               WK_COD_RESIRR := NULL;
               WK_COD_CODTRI := NULL;
               WK_COD_REDALI := NULL;
               WK_COD_REDESP := NULL;
               WK_COD_REDUME := NULL;
               WK_COD_REDUC1 := NULL;
               WK_COD_REDUC2 := NULL;
               WK_COD_ETIQUE := NULL;
               WK_COD_CODINA := NULL;
               WK_COD_DEPART := NULL;
               WK_COD_CLASS1 := NULL;
               WK_COD_CLASS2 := NULL;
               WK_COD_CLASS3 := NULL;
               WK_COD_CLASS4 := NULL;
               WK_COD_CODSAZ := NULL;
               WK_COD_UNIDAD := NULL;
               WK_COD_CODMON := NULL;
               WK_COD_CODLPC := NULL;
               WK_COD_UNIFOR := NULL;
               WK_COD_UNIAPL := NULL;
               WK_COD_UNIEMB := NULL;

               IF (WK_RESICM IS NOT NULL) AND (WK_RESICM <> WK_AUX_RESICM) THEN
                  WK_COD_RESICM := IMPORTA_TDS( 'TD_ICM', 'ICMATI', 'RESICM', 'CODTAB', TO_CHAR(WK_RESICM), NULL, NULL, NULL );
                  WK_AUX_RESICM := WK_RESICM;
               END IF;
               IF (WK_ALIDIF IS NOT NULL) AND (WK_ALIDIF <> WK_AUX_ALIDIF) THEN
                  WK_COD_ALIDIF := IMPORTA_TDS( 'TD_ICM', 'ICMATI', 'RESICM', 'CODTAB', TO_CHAR(WK_ALIDIF), NULL, NULL, NULL );
                  WK_AUX_ALIDIF := WK_ALIDIF;
               END IF;
               IF (WK_RESIPI IS NOT NULL) AND (WK_RESIPI <> WK_AUX_RESIPI) THEN
                  WK_COD_RESIPI := IMPORTA_TDS( 'TD_IPI', 'IPIATI', 'RESIPI', 'CODTAB', TO_CHAR(WK_RESIPI), NULL, NULL, NULL );
                  WK_AUX_RESIPI := WK_RESIPI;
               END IF;
               IF (WK_RESIRR IS NOT NULL) AND (WK_RESIRR <> WK_AUX_RESIRR) THEN
                  WK_COD_RESIRR := IMPORTA_TDS( 'TD_IRR', 'IRRATI', 'RESIRR', 'CODTAB', TO_CHAR(WK_RESIRR), NULL, NULL, NULL );
                  WK_AUX_RESIRR := WK_RESIRR;
               END IF;
               IF (WK_CODTRI IS NOT NULL) AND (WK_CODTRI <> WK_AUX_CODTRI) THEN
                  WK_COD_CODTRI := IMPORTA_TDS( 'TD_TRI', 'TRIATI', 'CODTRI', 'CODTAB', TRIM(WK_CODTRI), NULL, NULL, NULL );
                  WK_AUX_CODTRI := WK_CODTRI;
               END IF;
               IF (WK_REDALI IS NOT NULL) AND ((WK_REDALI <> WK_AUX_REDALI) OR (WK_REDTRA <> WK_AUX_REDTRA) OR (WK_REDCON <> WK_AUX_REDCON) OR (WK_APLCON <> WK_AUX_APLCON)) THEN
                  WK_COD_REDALI := IMPORTA_DIRE( WK_REDALI, WK_REDTRA, WK_REDCON, WK_APLCON );
                  WK_AUX_REDALI := WK_REDALI;
                  WK_AUX_REDTRA := WK_REDTRA;
                  WK_AUX_REDCON := WK_REDCON;
                  WK_AUX_APLCON := WK_APLCON;
               END IF;
               IF (WK_REDESP IS NOT NULL) AND (WK_REDESP <> WK_AUX_REDESP) THEN
                  WK_COD_REDESP := IMPORTA_TDS( 'TD_IES', 'ES_ATI', 'ICMSES', 'CODTAB', TO_CHAR(WK_REDESP), NULL, NULL, NULL );
                  WK_AUX_REDESP := WK_REDESP;
               END IF;
               IF (WK_REDUME IS NOT NULL) AND (WK_REDUME <> WK_AUX_REDUME) THEN
                  WK_COD_REDUME := IMPORTA_TDS( 'TD_IME', 'ME_ATI', 'ICMSME', 'CODTAB', TO_CHAR(WK_REDUME), NULL, NULL, NULL );
                  WK_AUX_REDUME := WK_REDUME;
               END IF;
               IF (WK_REDUC1 IS NOT NULL) AND (WK_REDUC1 <> WK_AUX_REDUC1) THEN
                  WK_COD_REDUC1 := IMPORTA_TDS( 'TD_IR1', 'R1_ATI', 'ICMSR1', 'CODTAB', TO_CHAR(WK_REDUC1), NULL, NULL, NULL );
                  WK_AUX_REDUC1 := WK_REDUC1;
               END IF;
               IF (WK_REDUC2 IS NOT NULL) AND (WK_REDUC2 <> WK_AUX_REDUC2) THEN
                  WK_COD_REDUC2 := IMPORTA_TDS( 'TD_IR2', 'R2_ATI', 'ICMSR2', 'CODTAB', TO_CHAR(WK_REDUC2), NULL, NULL, NULL );
                  WK_AUX_REDUC2 := WK_REDUC2;
               END IF;
               IF (WK_ETIQUE IS NOT NULL) AND (WK_ETIQUE <> WK_AUX_ETIQUE) THEN
                  WK_COD_ETIQUE := IMPORTA_TDS( 'TD_ETI', 'ETIATI', 'DESETI', 'CODTAB', WK_ETIQUE, NULL, NULL, NULL );
                  WK_AUX_ETIQUE := WK_ETIQUE;
               END IF;
               IF (WK_DESINA IS NOT NULL) AND (WK_DESINA <> WK_AUX_DESINA) THEN
                  WK_COD_CODINA := IMPORTA_TDS( 'TD_INA', 'INAATI', 'DESINA', 'CODTAB', WK_DESINA, -2, NULL, NULL );
                  WK_AUX_DESINA := WK_DESINA;
               END IF;
               IF (WK_DEPART IS NOT NULL) AND (WK_DEPART <> WK_AUX_DEPART) THEN
                  WK_COD_DEPART := IMPORTA_TDS( 'TD_DEP', 'DEPATI', 'DESDEP', 'CODTAB', WK_DEPART, NULL, NULL, NULL );
                  WK_AUX_DEPART := WK_DEPART;
               END IF;
               IF (WK_CLASS1 IS NOT NULL) AND (WK_CLASS1 <> WK_AUX_CLASS1) THEN
                  WK_COD_CLASS1 := IMPORTA_TDS( 'TD_CL1', 'CL1ATI', 'CLASS1', 'CODTAB', SUBSTR(WK_CLASS1,1,40), NULL, NULL, NULL );
                  WK_AUX_CLASS1 := WK_CLASS1;
               END IF;
               IF (WK_CLASS2 IS NOT NULL) AND (WK_CLASS2 <> WK_AUX_CLASS2) THEN
                  WK_COD_CLASS2 := IMPORTA_TDS( 'TD_CL2', 'CL2ATI', 'CLASS2', 'CODTAB', SUBSTR(WK_CLASS2,1,40), NULL, NULL, NULL );
                  WK_AUX_CLASS2 := WK_CLASS2;
               END IF;
               IF (WK_CLASS3 IS NOT NULL) AND (WK_CLASS3 <> WK_AUX_CLASS3) THEN
                  WK_COD_CLASS3 := IMPORTA_TDS( 'TD_CL3', 'CL3ATI', 'CLASS3', 'CODTAB', SUBSTR(WK_CLASS3,1,40), NULL, NULL, NULL );
                  WK_AUX_CLASS3 := WK_CLASS3;
               END IF;
               IF (WK_CLASS4 IS NOT NULL) AND (WK_CLASS4 <> WK_AUX_CLASS4) THEN
                  WK_COD_CLASS4 := IMPORTA_TDS( 'TD_CL4', 'CL4ATI', 'CLASS4', 'CODTAB', SUBSTR(WK_CLASS4,1,40), NULL, NULL, NULL );
                  WK_AUX_CLASS4 := WK_CLASS4;
               END IF;
               IF (WK_SAZONA IS NOT NULL) AND (WK_SAZONA <> WK_AUX_SAZONA) THEN
                  WK_COD_CODSAZ := IMPORTA_TDS( 'TD_SAZ', 'SAZATI', 'DESSAZ', 'CODTAB', WK_SAZONA, NULL, NULL, NULL );
                  WK_AUX_SAZONA := WK_SAZONA;
               END IF;
               IF (WK_UNIDAD IS NOT NULL) AND (WK_UNIDAD <> WK_AUX_UNIDAD) THEN
                  WK_COD_UNIDAD := IMPORTA_TDS( 'TD_MED', 'MEDATI', 'UNIMED', 'CODTAB', WK_UNIDAD, NULL, NULL, NULL, 'DESMED', WK_UNIDAD||' (importada)' );
                  WK_AUX_UNIDAD := WK_UNIDAD;
               END IF;
               IF (WK_CODMON IS NOT NULL) AND (WK_CODMON <> WK_AUX_CODMON) THEN
                  WK_COD_CODMON := IMPORTA_TDS( 'TD_MON', 'MONATI', 'DESMON', 'CODTAB', WK_CODMON, NULL, NULL, NULL );
                  WK_AUX_CODMON := WK_CODMON;
               END IF;
               IF (WK_CODLPC IS NOT NULL) AND (WK_CODLPC <> WK_AUX_CODLPC) THEN
                  WK_COD_CODLPC := IMPORTA_TDS( 'TD_LPC', 'LPCATI', 'DESLPC', 'CODTAB', WK_CODLPC, NULL, NULL, NULL, 'TIPRCE', COALESCE(WK_TIPRCE,'F') );
                  WK_AUX_CODLPC := WK_CODLPC;
               END IF;
               IF (WK_UNIFOR IS NOT NULL) AND (WK_UNIFOR <> WK_AUX_UNIFOR) THEN
                  WK_COD_UNIFOR := IMPORTA_TDS( 'TD_MED', 'MEDATI', 'UNIMED', 'CODTAB', WK_UNIFOR, NULL, NULL, NULL, 'DESMED', WK_UNIFOR||' (importada)' );
                  WK_AUX_UNIFOR := WK_UNIFOR;
               END IF;
               IF (WK_UNIAPL IS NOT NULL) AND (WK_UNIAPL <> WK_AUX_UNIAPL) THEN
                  WK_COD_UNIAPL := IMPORTA_TDS( 'TD_MED', 'MEDATI', 'UNIMED', 'CODTAB', WK_UNIAPL, NULL, NULL, NULL, 'DESMED', WK_UNIAPL||' (importada)' );
                  WK_AUX_UNIAPL := WK_UNIAPL;
               END IF;
               IF (WK_UNIEMB IS NOT NULL) AND (WK_UNIEMB <> WK_AUX_UNIEMB) THEN
                  WK_COD_UNIEMB := IMPORTA_TDS( 'TD_MED', 'MEDATI', 'UNIMED', 'CODTAB', WK_UNIEMB, NULL, NULL, NULL, 'DESMED', WK_UNIEMB||' (importada)' );
                  WK_AUX_UNIEMB := WK_UNIEMB;
               END IF;

               -- Incio dos tratamentos para TD_DIV
               IF WK_NOMDIV_CODEXT IS NOT NULL THEN
                  -- Por cdigo externo
                  IF (WK_NOMDIV_CODEXT <> WK_AUX_NOMDIV_CODEXT) THEN
                     WK_COD_DIVISA        := IMPORTA_TDS( 'TD_DIV', 'DIVATI', 'NOMDIV', 'CODTAB', WK_NOMDIV, NULL, NULL, NULL, NULL, NULL, WK_NOMDIV_CODEXT );
                     WK_AUX_NOMDIV        := NULL;
                     WK_AUX_NOMDIV_CODEXT := WK_NOMDIV_CODEXT;
                  END IF;
               ELSE
                  -- Por descrio
                  IF (WK_NOMDIV <> WK_AUX_NOMDIV) THEN
                     WK_COD_DIVISA        := IMPORTA_TDS( 'TD_DIV', 'DIVATI', 'NOMDIV', 'CODTAB', WK_NOMDIV, NULL, NULL, NULL );
                     WK_AUX_NOMDIV        := WK_NOMDIV;
                     WK_AUX_NOMDIV_CODEXT := NULL;
                  END IF;
               END IF;

               -- Incio dos tratamentos para TD_SUB
               IF WK_NOMSUB_CODEXT IS NOT NULL THEN
                  -- Por cdigo externo
                  IF (WK_NOMSUB_CODEXT <> WK_AUX_NOMSUB_CODEXT) THEN
                     WK_COD_SUBDIV        := IMPORTA_TDS( 'TD_SUB', 'SUBATI', 'NOMSUB', 'CODTAB', WK_NOMSUB, NULL, NULL, NULL, NULL, NULL, WK_NOMSUB_CODEXT );
                     WK_AUX_NOMSUB        := NULL;
                     WK_AUX_NOMSUB_CODEXT := WK_NOMSUB_CODEXT;
                  END IF;
               ELSE
                  -- Por descrio
                  IF (WK_NOMSUB <> WK_AUX_NOMSUB) THEN
                     WK_COD_SUBDIV        := IMPORTA_TDS( 'TD_SUB', 'SUBATI', 'NOMSUB', 'CODTAB', WK_NOMSUB, NULL, NULL, NULL );
                     WK_AUX_NOMSUB        := WK_NOMSUB;
                     WK_AUX_NOMSUB_CODEXT := NULL;
                  END IF;
               END IF;

               -- Incio dos tratamentos para TD_GRA
               IF WK_NOMGRA_CODEXT IS NOT NULL THEN
                  -- Por cdigo externo
                  IF (WK_NOMGRA_CODEXT <> WK_AUX_NOMGRA_CODEXT) THEN
                     WK_COD_CODGRA        := IMPORTA_TDS( 'TD_GRA', 'GRAATI', 'NOMGRA', 'CODTAB', WK_DESGRA, WK_COD_DIVISA, WK_COD_SUBDIV, NULL, NULL, NULL, WK_NOMGRA_CODEXT );
                     WK_AUX_DESGRA        := NULL;
                     WK_AUX_NOMGRA_CODEXT := WK_NOMGRA_CODEXT;
                  END IF;
               ELSE
                  -- Por descrio
                  IF (WK_DESGRA <> WK_AUX_DESGRA) THEN
                     WK_COD_CODGRA        := IMPORTA_TDS( 'TD_GRA', 'GRAATI', 'NOMGRA', 'CODTAB', WK_DESGRA, WK_COD_DIVISA, WK_COD_SUBDIV, NULL );
                     WK_AUX_DESGRA        := WK_DESGRA;
                     WK_AUX_NOMGRA_CODEXT := NULL;
                  END IF;
               END IF;

            EXCEPTION
               
               WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE PRODUTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE PRODUTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE PRODUTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE PRODUTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE PRODUTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE PRODUTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE PRODUTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                          END;

            IF (WK_MOTREJ = 'OK') AND (COALESCE(WK_REGDIF, 'C') NOT IN ('C','J','R')) THEN
               WK_MOTREJ := 'REGRA PARA ALQUOTA DIFERENCIADA INVLIDA. CONSULTE OS VALORES VLIDOS NA DOCUMENTAO.';
            END IF;

            IF NOT WK_MOTREJ = 'OK' THEN
               WK_STATUS := 4;
               WK_NROERR := WK_NROERR + 1;
            ELSE
               WK_STATUS := 3;
            END IF;
         END IF;

         IF WK_ATIVO = 'T' THEN
            WK_SIGNAT := 1;
         ELSE
            WK_SIGNAT := -1;
         END IF;

        --Inserir NCM na TT_NCM, caso no existe na mesma o NCM importado
        IF (WK_MOTREJ = 'OK') AND (WK_CODNCM IS NOT NULL) THEN
            SELECT COUNT(*)
              INTO WK_CONTADOR
              FROM TT_NCM
             WHERE CODNCM = WK_CODNCM;

            IF WK_CONTADOR = 0 THEN
               WK_NIVNCM := TRUNC(LENGTH(WK_CODNCM)/2);
               
               -- MN - Quando no encontra registro do ncm, insere
               BEGIN
                  INSERT INTO TT_NCM (CODNCM, NOMNCM, NIVNCM, FLGATI, DATINC, ATU_EM)
                  VALUES(WK_CODNCM, CASE WHEN (ISNOTNULL(WK_DESNCM)='T') THEN WK_DESNCM ELSE WK_CODNCM || ' (importado)' END,  WK_NIVNCM, 'T', AGORA(), AGORA() );
                  
                  EXCEPTION
                     
                     WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR NCM: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR NCM: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR NCM: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR NCM: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR NCM: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR NCM: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR NCM: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                         END;
               IF NOT WK_MOTREJ = 'OK' THEN
                      WK_STATUS := 4;
                      WK_NROERR := WK_NROERR + 1;
                  ELSE
                      WK_STATUS := 3;
               END IF;
            ELSE
               -- MN - Quando  encontra registro do ncm, atualiza descrio se for diferente da atual
               IF (ISNOTNULL(WK_DESNCM)='T') THEN
                  BEGIN
                     UPDATE TT_NCM 
                        SET NOMNCM = WK_DESNCM
                      WHERE CODNCM = WK_CODNCM
                        AND NOMNCM <> WK_DESNCM;
                  EXCEPTION
                     
                     WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR NCM: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                            END;
                  IF NOT WK_MOTREJ = 'OK' THEN
                         WK_STATUS := 4;
                         WK_NROERR := WK_NROERR + 1;
                     ELSE
                         WK_STATUS := 3;
                  END IF;
               END IF;
            END IF;
         END IF;
         
         IF (WK_MOTREJ = 'OK') AND (WK_CODCES IS NOT NULL) THEN
            SELECT COUNT(*)
              INTO WK_CONTADOR
              FROM TT_CES
             WHERE CODCES = WK_CODCES;
            
            IF WK_CONTADOR = 0 THEN
               -- MN - Quando no encontra registro do CEST, insere
               BEGIN
                  INSERT INTO TT_CES (CODCES, DESCES, CESATI, DATINC)
                              VALUES (WK_CODCES, CASE WHEN (ISNOTNULL(WK_DESCES)='T') THEN WK_DESCES ELSE WK_CODCES || ' (importado)' END, 'T', AGORA() );
               EXCEPTION
                  
                  WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR CEST: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR CEST: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR CEST: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR CEST: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR CEST: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR CEST: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR CEST: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                   END;
               IF NOT WK_MOTREJ = 'OK' THEN
                      WK_STATUS := 4;
                      WK_NROERR := WK_NROERR + 1;
                  ELSE
                      WK_STATUS := 3;
               END IF;
            ELSE
              -- MN - Quando  encontra registro do CES, atualiza descrio se for diferente da atual
               IF (ISNOTNULL(WK_DESCES)='T') THEN
                  BEGIN
                     UPDATE TT_CES 
                        SET DESCES = WK_DESCES
                      WHERE CODCES = WK_CODCES
                        AND DESCES <> WK_DESCES;
                  EXCEPTION
                     
                     WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR CEST: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                            END;
                  IF NOT WK_MOTREJ = 'OK' THEN
                         WK_STATUS := 4;
                         WK_NROERR := WK_NROERR + 1;
                     ELSE
                         WK_STATUS := 3;
                  END IF;
               END IF;
            END IF;
         END IF;

        -- MN - Validao para incluir relacionamento entre CEST e NCM
         IF (WK_MOTREJ = 'OK') AND (WK_CODCES IS NOT NULL) AND (WK_CODNCM IS NOT NULL) THEN
            SELECT COUNT(*)
              INTO WK_CONTADOR
              FROM TT_CESXNCM
             WHERE CODCES = WK_CODCES
               AND CODNCM = WK_CODNCM;

            IF WK_CONTADOR = 0 THEN
               -- MN - Quando no encontra registro do CEST, insere
               BEGIN
                  INSERT INTO TT_CESXNCM (CODCES, CODNCM)
                                  VALUES (WK_CODCES, WK_CODNCM);
               EXCEPTION
                  
                  WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR RELACAO ENTRE CEST E NCM: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR RELACAO ENTRE CEST E NCM: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR RELACAO ENTRE CEST E NCM: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR RELACAO ENTRE CEST E NCM: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR RELACAO ENTRE CEST E NCM: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR RELACAO ENTRE CEST E NCM: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR RELACAO ENTRE CEST E NCM: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                   END;
               
               IF NOT WK_MOTREJ = 'OK' THEN
                  WK_STATUS := 4;
                  WK_NROERR := WK_NROERR + 1;
               ELSE
                  WK_STATUS := 3;
               END IF; 
            END IF;
         END IF;

         IF (WK_MOTREJ = 'OK') AND (WK_ESTADO IS NULL) THEN
            SELECT UFLOJA
              INTO WK_ESTADO
              FROM TD_FIL
             WHERE CODFIL = WK_FILMAT;

            UPDATE TI_PRO SET ESTADO = WK_ESTADO
             WHERE CODEXT = WK_CODEXT
               AND ESTADO IS NULL;
         END IF;

         IF (WK_MOTREJ = 'OK') THEN
            SELECT COUNT(*)
              INTO WK_CADASTRADO
              FROM TT_PRO
             WHERE REFBAS = WK_REFBAS;
         END IF;

         -- Se for uma REFBAS que ainda nao esta cadastrada na TT_PRO
         --IF (COALESCE(WK_REFBAS,'0') <> COALESCE(WK_AUX_REFBAS,'0')) AND (WK_CADASTRADO = 0) THEN
         IF (WK_MOTREJ = 'OK') AND (WK_CADASTRADO = 0) THEN
            --WK_AUX_REFBAS := WK_REFBAS;

            SELECT COUNT(*)
              INTO WK_COUNT_PRO
              FROM TT_PRO
             WHERE FILMAT = WK_FILMAT
               AND CODMAT = WK_CODMAT;

            IF WK_COUNT_PRO = 0 THEN
               WK_EXISTE := 'F';
            ELSE
               WK_EXISTE := 'T';
            END IF;

                           SELECT REL.FILPAR, REL.CODPAR, REL.TIPPAR
                 INTO WK_FILPAR, WK_CODPAR, WK_TIPPAR
                 FROM TT_REL REL INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI = REL.CODPAR
                WHERE CLI.CODEXT = WK_CODFAB
                  AND REL.TIPPAR = 'M';
            
            -- Inclui produto, se nao existe
            IF (WK_EXISTE = 'F') THEN
                                 SELECT ITEMAR
                    INTO WK_EXISTE_MAR
                    FROM TT_MAR
                   WHERE DESMAR = WK_DESMAR
                     AND FILMAR = WK_FILPAR
                     AND CODMAR = WK_CODPAR
                     AND TIPMAR = WK_TIPPAR;
               
               IF WK_EXISTE_MAR IS NULL THEN
                  WK_EXISTE_MAR := 0;
               END IF;

               -- Inclui marca, se nao existe
               IF (WK_FILPAR IS NOT NULL) AND (WK_EXISTE_MAR = 0) THEN
                  SELECT COALESCE(MAX(ITEMAR),0) + 1
                    INTO WK_ITEMAR
                    FROM TT_MAR
                   WHERE FILMAR = WK_FILPAR
                     AND CODMAR = WK_CODPAR
                     AND TIPMAR = WK_TIPPAR;

                  WK_EXISTE_MAR := NULL;

                  BEGIN
                     INSERT INTO TT_MAR (FILMAR,CODMAR,TIPMAR,ITEMAR,DESMAR) VALUES (WK_FILPAR, WK_CODPAR, WK_TIPPAR, WK_ITEMAR, WK_DESMAR);
                  EXCEPTION
                     
                     WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR MARCA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR MARCA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR MARCA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR MARCA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR MARCA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR MARCA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR MARCA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                            END;

                  IF NOT WK_MOTREJ = 'OK' THEN
                     WK_STATUS := 4;
                     WK_NROERR := WK_NROERR + 1;
                  ELSE
                     WK_STATUS := 3;
                  END IF;
               END IF; -- Fim da inclusao da marca

               BEGIN
                  INSERT INTO TT_PRO (FILMAT,CODMAT,CONTRA,ATU_EM,VALCON,BRINDE,CLASS1,CLASS2,CLASS3,CLASS4,CLSXYZ,CODGRA,
                                      CODSAZ,ETIQUE,TIPPRO,UNIDAD,UNIFOR,DECIMA,MONTAR,NUMEXT,REFBAS,DESMAT,TIPMAR,FILMAR,
                                      CODMAR,DATCAD,CODTRI,DEPART,NUMITE,RESIPI,RESIRR,SIGNAT,DESECF,ESPMAT,NOMIMG,OBSERV,
                                      CONTRO,CODCTR,ITEMAR,ENTREG,RETCOF,CODINA,SUBFED,CODMON,CODLPC,SUGSER,PERSER,BALSIM,
                                      TERASS,FLGSER,VALEST,SITCOF,SITPIS,CODFPS,SITIPI,TIPDOC,ISEPIS,ICMFED,ARRTRU,IIPTPR,
                                      CODANP,COD_EX,IMPKIT,ORIPRO,DESDET,NATBCC,DESWEB,CODNCM,USALOT,LOTONL,VLRPIS,VLRCOF,
                                      CODENQ, CODCES, TIPMPB, PROCON, ESTCHE)
                              VALUES (WK_FILMAT, WK_CODMAT, COALESCE(WK_CONTRA,'F'), AGORA(), WK_VALCON, COALESCE(WK_BRINDE,0), WK_COD_CLASS1, WK_COD_CLASS2, WK_COD_CLASS3, WK_COD_CLASS4, COALESCE(WK_CLSXYZ,1), WK_COD_CODGRA,
                                      WK_COD_CODSAZ, WK_COD_ETIQUE, WK_TIPPRO, WK_COD_UNIDAD, WK_COD_UNIFOR, WK_DECIMA, COALESCE(WK_MONTAR,'F'), COALESCE(WK_NUMEXT,'F'), WK_REFBAS, WK_DESMAT, WK_TIPPAR, WK_FILPAR,
                                      WK_CODPAR, WK_DATCAD, WK_COD_CODTRI, WK_COD_DEPART, WK_NUMITE, COALESCE(WK_COD_RESIPI,0), COALESCE(WK_COD_RESIRR,0), WK_SIGNAT, WK_DESECF, WK_ESPMAT, WK_NOMIMG, WK_OBSERV,
                                      COALESCE(WK_CONTRO,'F'), COALESCE(WK_CODCTR,0), COALESCE(WK_EXISTE_MAR,WK_ITEMAR), COALESCE(WK_ENTREG,'F'),  COALESCE(WK_RETCOF,'F'), WK_COD_CODINA, WK_SUBFED, WK_COD_CODMON,WK_COD_CODLPC,
                                      WK_SUGSER,WK_PERSER,WK_BALSIM,WK_TERASS,WK_FLGSER,WK_VALEST,WK_SITCOF,WK_SITPIS,WK_CODFPS,WK_SITIPI,WK_TIPDOC,WK_ISEPIS,WK_ICMFED,WK_ARRTRU,WK_IIPTPR,
                                      WK_CODANP,WK_COD_EX,WK_IMPKIT,WK_ORIPRO,WK_DESDET,WK_NATBCC,WK_DESWEB,WK_CODNCM,WK_USALOT,WK_LOTONL,
                                      WK_VLRPIS,WK_VLRCOF, WK_CODENQ, WK_CODCES, WK_TIPMPB, COALESCE(WK_PROCON,'F'), COALESCE(WK_ESTCHE,0));
               EXCEPTION
                  
                  WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                   END;
               IF NOT WK_MOTREJ = 'OK' THEN
                  WK_STATUS := 4;
                  WK_NROERR := WK_NROERR + 1;
               ELSE
                  WK_STATUS := 3;
               END IF; -- Fim da inclusao da TT_PRO

               IF (WK_MOTREJ = 'OK') THEN
                  BEGIN
                     IF ISNULL(WK_DESCFP)='F' THEN
                        SELECT CODTAB INTO WK_CODCFP
                          FROM TD_CFP DCFP INNER JOIN TI_PRO IPRO ON DCFP.DESCFP = IPRO.DESCFP
                         WHERE IPRO.CODEXT = WK_CODEXT;
                     END IF;
                     INSERT INTO TT_IUF (FILMAT,
                                         CODMAT,
                                         ESTADO,
                                         CODFIS,
                                         RESICM,
                                         REDESP,
                                         REDUME,
                                         REDALI,
                                         REDUC1,
                                         REDUC2,
                                         LUCSUB,
                                         SUBTRI,
                                         INSAGR,
                                         CALSUB,
                                         CODTRI,
                                         REGESP,
                                         PERSRV,
                                         CODCFP,
                                         MVAVEN,
                                         MVAC07,
                                         MVAC12,
                                         ICMISE,
                                         REDSIM,
                                         MVAC04,
                                         DUMMY,
                                         CODBEN_00, CODBEN_10, CODBEN_20, CODBEN_30, CODBEN_40, CODBEN_41, CODBEN_50, CODBEN_51, CODBEN_60, CODBEN_70, CODBEN_90,
                                         PERDIF, ALIDIF, REGDIF
                                         )
                                 VALUES (WK_FILMAT,
                                         WK_CODMAT,
                                         WK_ESTADO,
                                         WK_COD_CODFIS,
                                         WK_COD_RESICM,
                                         WK_COD_REDESP,
                                         WK_COD_REDUME,
                                         WK_COD_REDALI,
                                         WK_COD_REDUC1,
                                         WK_COD_REDUC2,
                                         COALESCE(WK_LUCSUB,0),
                                         COALESCE(WK_SUBTRI,0),
                                         COALESCE(WK_INSAGR,'F'),
                                         WK_CALSUB,
                                         WK_COD_CODTRI,
                                         COALESCE(WK_REGESP,0),
                                         COALESCE(WK_PERSRV,0),
                                         WK_CODCFP,
                                         COALESCE(WK_MVAVEN,0),
                                         COALESCE(WK_MVAC07,0),
                                         COALESCE(WK_MVAC12,0),
                                         COALESCE(WK_ICMISE,'F'),
                                         COALESCE(WK_REDSIM,0),
                                         COALESCE(WK_MVAC04,0),
                                         Constante('MANTEM_ATU_EM'),
                                         WK_CODBEN_00, WK_CODBEN_10, WK_CODBEN_20, WK_CODBEN_30, WK_CODBEN_40, WK_CODBEN_41, WK_CODBEN_50, WK_CODBEN_51, WK_CODBEN_60, WK_CODBEN_70, WK_CODBEN_90,
                                         WK_PERDIF, WK_COD_ALIDIF, WK_REGDIF
                                         );
                  EXCEPTION
                     
                     WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TRIBUTACOES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TRIBUTACOES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TRIBUTACOES: '||SQLERRM,1,255);  ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TRIBUTACOES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TRIBUTACOES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TRIBUTACOES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TRIBUTACOES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                            END; -- Fim da inclusao da TT_IUF
               END IF;

               IF NOT WK_MOTREJ = 'OK' THEN
                  WK_STATUS := 4;
                  WK_NROERR := WK_NROERR + 1;
               ELSE
                  WK_STATUS := 3;
               END IF;
            ELSE
               -- RFMP
               -- Ele deveria atualizar o registro da TI_PRO, ja que ele encontrou a TT_PRO correspondente.
               -- Entretanto, o REFBAS nao correspondem ao do produto encontrado.
               IF NOT WK_MOTREJ = 'OK' THEN
                  WK_MOTREJ := 'REFBAS '||WK_REFBAS||' NAO CORRESPONDE AO CADASTRADO NO PRODUTO '||WK_FILMAT||'-'||COALESCE(WK_CODMAT,'');
               END IF;

               IF NOT WK_MOTREJ = 'OK' THEN
                  WK_STATUS := 4;
                  WK_NROERR := WK_NROERR + 1;
               ELSE
                  WK_STATUS := 3;
               END IF;

            END IF; -- Fim da inclusao do produto
         ELSE
            -- Tratamento para refbas cadastrado
            IF (WK_MOTREJ = 'OK') THEN
                                 SELECT REL.FILPAR, REL.CODPAR, REL.TIPPAR
                    INTO WK_FILPAR, WK_CODPAR, WK_TIPPAR
                    FROM TT_REL REL INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI = REL.CODPAR
                   WHERE CLI.CODEXT = WK_CODFAB
                     AND REL.TIPPAR = 'M';
               
                                 SELECT ITEMAR
                    INTO WK_EXISTE_MAR
                    FROM TT_MAR
                   WHERE DESMAR = WK_DESMAR
                     AND FILMAR = WK_FILPAR
                     AND CODMAR = WK_CODPAR
                     AND TIPMAR = WK_TIPPAR;
               
               IF WK_EXISTE_MAR IS NULL THEN
                  WK_EXISTE_MAR := 0;
               ELSE
                  WK_ITEMAR := WK_EXISTE_MAR;
               END IF;

               -- Inclui marca, se nao existe
               IF (WK_FILPAR IS NOT NULL) AND (WK_EXISTE_MAR = 0) THEN
                  SELECT COALESCE(MAX(ITEMAR),0) + 1
                    INTO WK_ITEMAR
                    FROM TT_MAR
                   WHERE FILMAR = WK_FILPAR
                     AND CODMAR = WK_CODPAR
                     AND TIPMAR = WK_TIPPAR;

                  WK_EXISTE_MAR := NULL;

                  BEGIN
                     INSERT INTO TT_MAR (FILMAR,CODMAR,TIPMAR,ITEMAR,DESMAR) VALUES (WK_FILPAR, WK_CODPAR, WK_TIPPAR, WK_ITEMAR, WK_DESMAR);
                  EXCEPTION
                     
                     WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR MARCA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR MARCA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR MARCA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR MARCA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR MARCA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR MARCA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR MARCA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                            END;

                  IF NOT WK_MOTREJ = 'OK' THEN
                     WK_STATUS := 4;
                     WK_NROERR := WK_NROERR + 1;
                  ELSE
                     WK_STATUS := 3;
                  END IF;
               END IF; -- Fim da inclusao da marca
            END IF;

            IF WK_MOTREJ = 'OK' THEN
               -- Atualiza TT_PRO
               BEGIN
                  UPDATE TT_PRO
                     SET CONTRA = COALESCE(WK_CONTRA,CONTRA),
                         ATU_EM = AGORA(),
                         VALCON = COALESCE(WK_VALCON,VALCON),
                         BRINDE = COALESCE(WK_BRINDE,BRINDE),
                         CLASS1 = COALESCE(WK_COD_CLASS1,CLASS1),
                         CLASS2 = COALESCE(WK_COD_CLASS2,CLASS2),
                         CLASS3 = COALESCE(WK_COD_CLASS3,CLASS3),
                         CLASS4 = COALESCE(WK_COD_CLASS4,CLASS4),
                         CLSXYZ = COALESCE(WK_CLSXYZ,CLSXYZ),
                         CODGRA = COALESCE(WK_COD_CODGRA,CODGRA),
                         CODSAZ = COALESCE(WK_COD_CODSAZ,CODSAZ),
                         ETIQUE = COALESCE(WK_COD_ETIQUE,ETIQUE),
                         TIPPRO = COALESCE(WK_TIPPRO,TIPPRO),
                         UNIDAD = COALESCE(WK_COD_UNIDAD,UNIDAD),
                         UNIFOR = COALESCE(WK_COD_UNIFOR,UNIFOR),
                         DECIMA = COALESCE(WK_DECIMA,DECIMA),
                         MONTAR = COALESCE(WK_MONTAR,MONTAR),
                         NUMEXT = COALESCE(WK_NUMEXT,NUMEXT),
                         REFBAS = COALESCE(WK_REFBAS,REFBAS),
                         DESMAT = COALESCE(WK_DESMAT,DESMAT),
                         TIPMAR = COALESCE(WK_TIPPAR,TIPMAR),
                         FILMAR = COALESCE(WK_FILPAR,FILMAR),
                         CODMAR = COALESCE(WK_CODPAR,CODMAR),
                         DATCAD = COALESCE(WK_DATCAD,DATCAD),
                         CODTRI = COALESCE(WK_COD_CODTRI,CODTRI),
                         DEPART = COALESCE(WK_COD_DEPART,DEPART),
                         NUMITE = COALESCE(WK_NUMITE,NUMITE),
                         RESIPI = COALESCE(WK_COD_RESIPI,0),
                         RESIRR = COALESCE(WK_COD_RESIRR,RESIRR),
                         SIGNAT = COALESCE(WK_SIGNAT,SIGNAT),
                         DESECF = COALESCE(WK_DESECF,DESECF),
                         ESPMAT = COALESCE(WK_ESPMAT,ESPMAT),
                         NOMIMG = COALESCE(WK_NOMIMG,NOMIMG),
                         OBSERV = COALESCE(WK_OBSERV,OBSERV),
                         CONTRO = COALESCE(WK_CONTRO,CONTRO),
                         CODCTR = COALESCE(WK_CODCTR,CODCTR),
                         ITEMAR = COALESCE(WK_ITEMAR,ITEMAR),
                         ENTREG = COALESCE(WK_ENTREG,ENTREG),
                         RETCOF = COALESCE(WK_RETCOF,RETCOF),
                         CODINA = COALESCE(WK_COD_CODINA,CODINA),
                         SUBFED = COALESCE(WK_SUBFED,SUBFED),
                         CODMON = COALESCE(WK_COD_CODMON,CODMON),
                         CODLPC = COALESCE(WK_COD_CODLPC,CODLPC),
                         SUGSER = COALESCE(WK_SUGSER,SUGSER),
                         PERSER = COALESCE(WK_PERSER,PERSER),
                         BALSIM = COALESCE(WK_BALSIM,BALSIM),
                         TERASS = COALESCE(WK_TERASS,TERASS),
                         FLGSER = COALESCE(WK_FLGSER,FLGSER),
                         VALEST = COALESCE(WK_VALEST,VALEST),
                         SITCOF = COALESCE(WK_SITCOF,SITCOF),
                         SITPIS = COALESCE(WK_SITPIS,SITPIS),
                         CODFPS = COALESCE(WK_CODFPS,CODFPS),
                         SITIPI = COALESCE(WK_SITIPI,SITIPI),
                         TIPDOC = COALESCE(WK_TIPDOC,TIPDOC),
                         ISEPIS = COALESCE(WK_ISEPIS,ISEPIS),
                         ICMFED = COALESCE(WK_ICMFED,ICMFED),
                         ARRTRU = COALESCE(WK_ARRTRU,ARRTRU),
                         IIPTPR = COALESCE(WK_IIPTPR,IIPTPR),
                         CODANP = COALESCE(WK_CODANP,CODANP),
                         COD_EX = COALESCE(WK_COD_EX,COD_EX),
                         IMPKIT = COALESCE(WK_IMPKIT,IMPKIT),
                         ORIPRO = COALESCE(WK_ORIPRO,ORIPRO),
                         DESDET = COALESCE(WK_DESDET,DESDET),
                         NATBCC = COALESCE(WK_NATBCC,NATBCC),
                         DESWEB = COALESCE(WK_DESWEB,DESWEB),
                         CODNCM = COALESCE(WK_CODNCM,CODNCM),
                         USALOT = COALESCE(WK_USALOT,USALOT),
                         LOTONL = COALESCE(WK_LOTONL,LOTONL),
                         VLRPIS = COALESCE(WK_VLRPIS,VLRPIS),
                         VLRCOF = COALESCE(WK_VLRCOF,VLRCOF),
                         CODENQ = COALESCE(WK_CODENQ, CODENQ),
                         CODCES = COALESCE(WK_CODCES, CODCES),
                         TIPMPB = COALESCE(WK_TIPMPB, TIPMPB),
                         PROCON = COALESCE(WK_PROCON, PROCON),
                         ESTCHE = COALESCE(WK_ESTCHE, ESTCHE),
                         DUMMY = Constante('MANTEM_ATU_EM') -- Pedro E. Braga - 104287 - Marca para no atualizar tabela de preo pois processo de importao j faz isso quando informado o preo e estava causando lentido
                   WHERE FILMAT = WK_FILMAT
                     AND CODMAT = WK_CODMAT;
               EXCEPTION
                  
                  WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                   END;
            END IF;

            IF NOT WK_MOTREJ = 'OK' THEN
               WK_STATUS := 4;
               WK_NROERR := WK_NROERR + 1;
            ELSE
               WK_STATUS := 3;
            END IF;

            -- Atualiza TT_IUF
            WK_IUF_COUNT := 0;

            IF (WK_MOTREJ = 'OK') THEN
               SELECT COUNT(*)
                 INTO WK_IUF_COUNT
                 FROM TT_IUF
                WHERE FILMAT = WK_FILMAT
                  AND CODMAT = WK_CODMAT
                  AND ESTADO = WK_ESTADO
                  AND REGESP = COALESCE(WK_REGESP,0);

               -- Existe a TT_IUF, entao apenas atualiza
               IF WK_IUF_COUNT > 0 THEN
                  BEGIN
                     IF ISNULL(WK_DESCFP)='F' THEN
                        SELECT CODTAB INTO WK_CODCFP
                          FROM TD_CFP DCFP INNER JOIN TI_PRO IPRO ON DCFP.DESCFP = IPRO.DESCFP
                         WHERE IPRO.CODEXT = WK_CODEXT;
                     END IF;
                     UPDATE TT_IUF
                        SET CODFIS = COALESCE(WK_COD_CODFIS,CODFIS),
                            RESICM = COALESCE(WK_COD_RESICM,RESICM),
                            REDESP = COALESCE(WK_COD_REDESP,REDESP),
                            REDUME = COALESCE(WK_COD_REDUME,REDUME),
                            REDALI = COALESCE(WK_COD_REDALI,REDALI),
                            REDUC1 = COALESCE(WK_COD_REDUC1,REDUC1),
                            REDUC2 = COALESCE(WK_COD_REDUC2,REDUC2),
                            LUCSUB = COALESCE(WK_LUCSUB,LUCSUB),
                            SUBTRI = COALESCE(TO_CHAR(WK_SUBTRI),SUBTRI),
                            INSAGR = COALESCE(WK_INSAGR,INSAGR),
                            CALSUB = COALESCE(WK_CALSUB,CALSUB),
                            CODTRI = COALESCE(WK_COD_CODTRI,CODTRI),
                            CODCFP = COALESCE(WK_CODCFP,CODCFP),
                            REGESP = COALESCE(WK_REGESP,REGESP),
                            PERSRV = COALESCE(WK_PERSRV,PERSRV),
                            MVAVEN = COALESCE(WK_MVAVEN,MVAVEN),
                            MVAC07 = COALESCE(WK_MVAC07,MVAC07),
                            MVAC12 = COALESCE(WK_MVAC12,MVAC12),
                            ICMISE = COALESCE(WK_ICMISE,ICMISE),
                            REDSIM = COALESCE(WK_REDSIM, REDSIM),
                            MVAC04 = COALESCE(WK_MVAC04, MVAC04),
                            ATU_EM = Agora(),
                            DUMMY = Constante('MANTEM_ATU_EM'), -- Pedro E. Braga - 104287 - Marca para no atualizar tabela pai pois processo de importao j faz isso e estava causando lentido
                            CODBEN_00 = COALESCE(WK_CODBEN_00, CODBEN_00),
                            CODBEN_10 = COALESCE(WK_CODBEN_10, CODBEN_10),
                            CODBEN_20 = COALESCE(WK_CODBEN_20, CODBEN_20),
                            CODBEN_30 = COALESCE(WK_CODBEN_30, CODBEN_30),
                            CODBEN_40 = COALESCE(WK_CODBEN_40, CODBEN_40),
                            CODBEN_41 = COALESCE(WK_CODBEN_41, CODBEN_41),
                            CODBEN_50 = COALESCE(WK_CODBEN_50, CODBEN_50),
                            CODBEN_51 = COALESCE(WK_CODBEN_51, CODBEN_51),
                            CODBEN_60 = COALESCE(WK_CODBEN_60, CODBEN_60),
                            CODBEN_70 = COALESCE(WK_CODBEN_70, CODBEN_70),
                            CODBEN_90 = COALESCE(WK_CODBEN_90, CODBEN_90),
                            PERDIF = COALESCE(WK_PERDIF, PERDIF),
                            ALIDIF = COALESCE(WK_COD_ALIDIF, ALIDIF),
                            REGDIF = COALESCE(WK_REGDIF, REGDIF)
                      WHERE FILMAT = WK_FILMAT
                        AND CODMAT = WK_CODMAT
                        AND ESTADO = WK_ESTADO;
                  EXCEPTION
                     
                     WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TRIBUTACOES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TRIBUTACOES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TRIBUTACOES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TRIBUTACOES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TRIBUTACOES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TRIBUTACOES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TRIBUTACOES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                            END;
               ELSE
                  -- Nao existe a TT_IUF, entao inclui
                  BEGIN
                     INSERT INTO TT_IUF (FILMAT,
                                         CODMAT,
                                         ESTADO,
                                         CODFIS,
                                         RESICM,
                                         REDESP,
                                         REDUME,
                                         REDALI,
                                         REDUC1,
                                         REDUC2,
                                         LUCSUB,
                                         SUBTRI,
                                         INSAGR,
                                         CALSUB,
                                         CODTRI,
                                         REGESP,
                                         PERSRV,
                                         MVAVEN,
                                         MVAC07,
                                         MVAC12,
                                         ICMISE,
                                         REDSIM,
                                         MVAC04,
                                         DUMMY,
                                         CODBEN_00, CODBEN_10, CODBEN_20, CODBEN_30, CODBEN_40, CODBEN_41, CODBEN_50, CODBEN_51, CODBEN_60, CODBEN_70, CODBEN_90,
                                         PERDIF, ALIDIF, REGDIF
                                         )
                                 VALUES (WK_FILMAT,
                                         WK_CODMAT,
                                         WK_ESTADO,
                                         WK_COD_CODFIS,
                                         WK_COD_RESICM,
                                         WK_COD_REDESP,
                                         WK_COD_REDUME,
                                         WK_COD_REDALI,
                                         WK_COD_REDUC1,
                                         WK_COD_REDUC2,
                                         COALESCE(WK_LUCSUB,0),
                                         COALESCE(WK_SUBTRI,0),
                                         COALESCE(WK_INSAGR,'F'),
                                         WK_CALSUB,
                                         WK_COD_CODTRI,
                                         COALESCE(WK_REGESP,0),
                                         coalesce(WK_PERSRV,0),
                                         COALESCE(WK_MVAVEN,0),
                                         COALESCE(WK_MVAC07,0),
                                         COALESCE(WK_MVAC12,0),
                                         COALESCE(WK_ICMISE,'F'),
                                         COALESCE(WK_REDSIM,0),
                                         COALESCE(WK_MVAC04,0),
                                         Constante('MANTEM_ATU_EM'),
                                         WK_CODBEN_00, WK_CODBEN_10, WK_CODBEN_20, WK_CODBEN_30, WK_CODBEN_40, WK_CODBEN_41, WK_CODBEN_50, WK_CODBEN_51, WK_CODBEN_60, WK_CODBEN_70, WK_CODBEN_90,
                                         WK_PERDIF, WK_COD_ALIDIF, WK_REGDIF
                                         );
                  EXCEPTION
                     
                     WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TRIBUTACOES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TRIBUTACOES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TRIBUTACOES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TRIBUTACOES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TRIBUTACOES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TRIBUTACOES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TRIBUTACOES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                            END;
               END IF; -- Fim do tratamento se inclui ou altera TT_IUF
               IF NOT WK_MOTREJ = 'OK' THEN
                  WK_STATUS := 4;
                  WK_NROERR := WK_NROERR + 1;
               ELSE
                  WK_STATUS := 3;
               END IF;
            END IF;
         END IF; -- Fim do tratamento de refbas cadastrado

         -- Continuacao do processo principal do loop
         -- Ate aqui tratou TT_PRO e TT_IUF

         -- Incio dos tratamentos para TT_DIV
         IF (WK_MOTREJ = 'OK') THEN
            BEGIN
               WK_CODCOR := IMPORTA_DIV(WK_ITEDIV_CODEXT, WK_ITEDIV, WK_COD_DIVISA);
            EXCEPTION
               
               WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR ITEM DE DIVISO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR ITEM DE DIVISO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR ITEM DE DIVISO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR ITEM DE DIVISO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR ITEM DE DIVISO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR ITEM DE DIVISO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR ITEM DE DIVISO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                          END;
            IF NOT WK_MOTREJ = 'OK' THEN
               WK_STATUS := 4;
               WK_NROERR := WK_NROERR + 1;
            ELSE
               WK_STATUS := 3;
            END IF;
         END IF;
         
         IF (WK_MOTREJ = 'OK') THEN
            -- Incio dos tratamentos para TT_SUB
            BEGIN
               WK_CODTAM := IMPORTA_SUB(WK_ITESUB_CODEXT, WK_ITESUB, WK_COD_SUBDIV, WK_ITESUB_FATCON);
            EXCEPTION
               
               WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR ITEM DE SUB-DIVISO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR ITEM DE SUB-DIVISO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR ITEM DE SUB-DIVISO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR ITEM DE SUB-DIVISO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR ITEM DE SUB-DIVISO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR ITEM DE SUB-DIVISO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR ITEM DE SUB-DIVISO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                          END;
            IF NOT WK_MOTREJ = 'OK' THEN
               WK_STATUS := 4;
               WK_NROERR := WK_NROERR + 1;
            ELSE
               WK_STATUS := 3;
            END IF;
         END IF;

         IF (WK_MOTREJ = 'OK') THEN
            -- Incio dos tratamentos para Incluso/Alterao da Sub-Diviso do Salto de Estoque TD_SUB.CODSAL
            BEGIN
               IF (WK_NOMSUB_CODSAL IS NOT NULL) AND (WK_MOTREJ = 'OK') THEN
                  -- Busca Sub-Divio de Saldo
                                    SELECT SUB.CODITE, SUB.FATCON
                    INTO WK_SUB_CODSAL, WK_SUB_FATCON
                    FROM TT_SUB SUB
                   WHERE SUB.CODSUB = WK_COD_SUBDIV
                     AND SUB.CODEXT = WK_NOMSUB_CODSAL;
                  
                  IF WK_SUB_CODSAL IS NOT NULL THEN
                     -- Sub-Divio de Saldo deve possuir fator de converso de 1 para 1.
                     IF (WK_SUB_FATCON > 1) THEN
                        IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := 'FATOR DE CONVERSO NO  1 PARA 1.'; END IF;
                     END IF;
                     IF (WK_MOTREJ = 'OK') THEN
                        -- Atualiza cdigo da Sub-Divio de Saldo
                        UPDATE TD_SUB SET CODSAL = WK_SUB_CODSAL
                         WHERE CODTAB = WK_COD_SUBDIV
                           AND COALESCE(CODSAL,-1) <> WK_SUB_CODSAL;
                     END IF;
                  END IF;
               ELSE
                  WK_SUB_CODSAL := NULL;
                  WK_SUB_FATCON := NULL;
               END IF;
            EXCEPTION
               
               WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR SUB-DIVISO DO SALDO DE ESTOQUE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR SUB-DIVISO DO SALDO DE ESTOQUE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR SUB-DIVISO DO SALDO DE ESTOQUE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR SUB-DIVISO DO SALDO DE ESTOQUE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR SUB-DIVISO DO SALDO DE ESTOQUE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR SUB-DIVISO DO SALDO DE ESTOQUE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ALTERAR SUB-DIVISO DO SALDO DE ESTOQUE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                          END;
            IF NOT WK_MOTREJ = 'OK' THEN
               WK_STATUS := 4;
               WK_NROERR := WK_NROERR + 1;
            ELSE
               WK_STATUS := 3;
            END IF;
         END IF;

         IF (WK_MOTREJ = 'OK') THEN
            -- Procura pela TT_GRA agora que tem a chave completa da grade
            SELECT COUNT(*), MIN(CODEXT)
              INTO WK_COUNT, WK_CODEXT_GRA
              FROM TT_GRA
             WHERE FILMAT = WK_FILMAT
               AND CODMAT = WK_CODMAT
               AND CODCOR = WK_CODCOR
               AND CODTAM = WK_CODTAM;

            IF WK_COUNT = 0 THEN
               WK_EXISTE := 'F';
            ELSE
               WK_EXISTE := 'T';
            END IF;

            -- Tratamento para caso nao encontre a grade
            IF WK_EXISTE = 'F' THEN
               BEGIN
                  IF WK_REUTILIZA_REFERENCIA = 'T' THEN
                     --REFPRO
                     WK_REFPRO_REP := 'T';
                                             SELECT REFPRO
                          INTO WK_REFPRO_REP
                          FROM TT_GRA
                         WHERE REFPRO = WK_REFPRO
                           AND CODEXT = WK_CODEXT;
                                           IF COALESCE(WK_REFPRO_REP,'T') <> 'T' THEN
                        UPDATE TT_GRA SET REFPRO = CASE WHEN INSTR(REFPRO,'#') > 0
                                                        THEN TO_NUMBER(SUBSTR(REFPRO,1,INSTR(REFPRO,'#')-1)) + 1||'#'||SUBSTR(REFPRO,INSTR(REFPRO,'#')+1,LENGTH(REFPRO))
                                                        ELSE '1#'||TRIM(REFPRO)
                                                    END,
                                          GRAATI = 'F',
                                          CODEXT = CASE WHEN INSTR(CODEXT,'#') > 0
                                                        THEN TO_NUMBER(SUBSTR(CODEXT,1,INSTR(CODEXT,'#')-1)) + 1||'#'||SUBSTR(CODEXT,INSTR(CODEXT,'#')+1,LENGTH(CODEXT))
                                                        ELSE '1#'||TRIM(CODEXT)
                                                    END,
                                          ATU_EM = Agora(),
                                          DUMMY = Constante('MANTEM_ATU_EM') -- Pedro E. Braga - 104287 - Marca para no atualizar tabela pai pois processo de importao j faz isso e estava causando lentido
                         WHERE (CODEXT = WK_CODEXT OR CODEXT  LIKE '%#'||TRIM(WK_CODEXT));

                        WK_GRAATI := 'F';
                     END IF;
                  END IF; -- Fim de reutiliza referencia

                  INSERT INTO TT_GRA (FILMAT,CODMAT,CODCOR,CODTAM,UNIDAD,UNIFOR,VALCON,PROMOC,VOLUNI,
                                      REFPRO,DATCOM,CUSREP,DESIDE,DESMAX,MINQTD,PERCOM,PERLUC,PESBRU,PESLIQ,
                                      PRECOM,PTOQTD,QTDREP,TIPVAL,TEMREP,VALIDA,CUSFRE,LOCALI,UNIEMB,UNIAPL,
                                      QTDEMB,CONAPL,OBSERV,QTDCOM,ICMCOM,IPICOM,TAXCOM,
                                      DESCOM,SUBCOM,SEGFRE,ICMFRE,FORLIN,MARKUP,PREPSI,CODEXT,
                                      DESICO,ORICUS,IPICUS,ICMCUS,OUTCUS,GRAATI,DACCUS,AFICUS,ICMTIP,PERFRE,
                                      ALIFRE,VOLUME,MVACOM,ALTURA,LARGUR,PROFUN, MAXPAR, DUMMY, DESGRA, IMGGRU)
                              VALUES (WK_FILMAT, WK_CODMAT,WK_CODCOR,WK_CODTAM,WK_COD_UNIDAD,WK_COD_UNIFOR,WK_VALCON,COALESCE(WK_PROMOC,'F'),COALESCE(WK_VOLUNI,'T'),
                                      WK_REFPRO, WK_DATCOM,WK_CUSREP,WK_DESIDE,WK_DESMAX,WK_MINQTD,WK_PERCOM,WK_PERLUC,WK_PESBRU,WK_PESLIQ,
                                      WK_PRECOM, WK_PTOQTD, WK_QTDREP, WK_TIPVAL, WK_TEMREP, WK_VALIDA, WK_CUSFRE, WK_LOCALI, WK_COD_UNIEMB, WK_COD_UNIAPL,
                                      WK_QTDEMB, WK_CONAPL, WK_OBSGRA, WK_QTDCOM, WK_ICMCOM, WK_IPICOM, WK_TAXCOM,
                                      WK_DESCOM, WK_SUBCOM, WK_SEGFRE, WK_ICMFRE, COALESCE(WK_FORLIN,'F'), WK_MARKUP, COALESCE(WK_PREPSI,'F'),TRIM(WK_CODEXT),
                                      WK_DESICO, WK_ORICUS, WK_IPICUS, WK_ICMCUS, WK_OUTCUS, COALESCE(WK_NEW_GRAATI,'T'), WK_DACCUS, WK_AFICUS, WK_ICMTIP, WK_PERFRE,
                                      WK_ALIFRE, WK_VOLUME, WK_MVACOM, WK_ALTURA, WK_LARGUR, WK_PROFUN, WK_MAXPAR, Constante('MANTEM_ATU_EM'),
                                      WK_GRA_DESGRA, WK_IMGGRU);
               EXCEPTION
                  
                  WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR ITENS DE GRADE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR ITENS DE GRADE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR ITENS DE GRADE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR ITENS DE GRADE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR ITENS DE GRADE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR ITENS DE GRADE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR ITENS DE GRADE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                   END;
               IF NOT WK_MOTREJ = 'OK' THEN
                  WK_STATUS := 4;
                  WK_NROERR := WK_NROERR + 1;
               ELSE
                  WK_STATUS := 3;
               END IF;
            ELSIF (WK_CODEXT_GRA = WK_CODEXT) OR (WK_CODEXT_GRA LIKE '%#'||TRIM(WK_CODEXT)) THEN -- RFMP 70018
               -- Existe grade e requer simplesmente a atualizacao dos campos
               -- Achou a grade, e o CODEXT corresponde ao da TI_PRO
               BEGIN
                  UPDATE TT_GRA
                     SET CODEXT = COALESCE(WK_CODEXT,CODEXT),
                         UNIDAD = COALESCE(WK_COD_UNIDAD,UNIDAD),
                         UNIFOR = COALESCE(WK_COD_UNIFOR,UNIFOR),
                         VALCON = COALESCE(WK_VALCON,VALCON),
                         PROMOC = COALESCE(WK_PROMOC,PROMOC),
                         VOLUNI = COALESCE(WK_VOLUNI,VOLUNI),
                         REFPRO = COALESCE(WK_REFPRO,REFPRO),
                         DATCOM = COALESCE(WK_DATCOM,DATCOM),
                         CUSREP = COALESCE(WK_CUSREP,CUSREP),
                         DESIDE = COALESCE(WK_DESIDE,DESIDE),
                         DESMAX = COALESCE(WK_DESMAX,DESMAX),
                         MINQTD = COALESCE(WK_MINQTD,MINQTD),
                         PERCOM = COALESCE(WK_PERCOM,PERCOM),
                         PERLUC = COALESCE(WK_PERLUC,PERLUC),
                         PESBRU = COALESCE(WK_PESBRU,PESBRU),
                         PESLIQ = COALESCE(WK_PESLIQ,PESLIQ),
                         PRECOM = COALESCE(WK_PRECOM,PRECOM),
                         PTOQTD = COALESCE(WK_PTOQTD,PTOQTD),
                         QTDREP = COALESCE(WK_QTDREP,QTDREP),
                         TIPVAL = COALESCE(WK_TIPVAL,TIPVAL),
                         TEMREP = COALESCE(WK_TEMREP,TEMREP),
                         VALIDA = COALESCE(WK_VALIDA,VALIDA),
                         CUSFRE = COALESCE(WK_CUSFRE,CUSFRE),
                         LOCALI = COALESCE(WK_LOCALI,LOCALI),
                         UNIEMB = COALESCE(WK_COD_UNIEMB,UNIEMB),
                         UNIAPL = COALESCE(WK_COD_UNIAPL,UNIAPL),
                         QTDEMB = COALESCE(WK_QTDEMB,QTDEMB),
                         CONAPL = COALESCE(WK_CONAPL,CONAPL),
                         OBSERV = COALESCE(WK_OBSGRA,OBSERV),
                         QTDCOM = COALESCE(WK_QTDCOM,QTDCOM),
                         ICMCOM = COALESCE(WK_ICMCOM,ICMCOM),
                         IPICOM = COALESCE(WK_IPICOM,IPICOM),
                         TAXCOM = COALESCE(WK_TAXCOM,TAXCOM),
                         DESCOM = COALESCE(WK_DESCOM,DESCOM),
                         SUBCOM = COALESCE(WK_SUBCOM,SUBCOM),
                         SEGFRE = COALESCE(WK_SEGFRE,SEGFRE),
                         ICMFRE = COALESCE(WK_ICMFRE,ICMFRE),
                         FORLIN = COALESCE(WK_FORLIN,FORLIN),
                         MARKUP = COALESCE(WK_MARKUP,MARKUP),
                         PREPSI = COALESCE(WK_PREPSI,PREPSI),
                         DESICO = COALESCE(WK_DESICO,DESICO),
                         ORICUS = COALESCE(WK_ORICUS,ORICUS),
                         IPICUS = COALESCE(WK_IPICUS,IPICUS),
                         ICMCUS = COALESCE(WK_ICMCUS,ICMCUS),
                         OUTCUS = COALESCE(WK_OUTCUS,OUTCUS),
                         GRAATI = COALESCE(WK_GRAATI,GRAATI),
                         DACCUS = COALESCE(WK_DACCUS,DACCUS),
                         AFICUS = COALESCE(WK_AFICUS,AFICUS),
                         ICMTIP = COALESCE(WK_ICMTIP,ICMTIP),
                         PERFRE = COALESCE(WK_PERFRE,PERFRE),
                         ALIFRE = COALESCE(WK_ALIFRE,ALIFRE),
                         VOLUME = COALESCE(WK_VOLUME,VOLUME),
                         --CODNCM = COALESCE(WK_CODNCM,CODNCM),
                         MVACOM = COALESCE(WK_MVACOM,MVACOM),
                         ALTURA = COALESCE(WK_ALTURA,ALTURA),
                         LARGUR = COALESCE(WK_LARGUR,LARGUR),
                         PROFUN = COALESCE(WK_PROFUN,PROFUN),
                         MAXPAR = COALESCE(WK_MAXPAR,MAXPAR),
                         ATU_EM = Agora(),
                         DUMMY = Constante('MANTEM_ATU_EM'), -- Pedro E. Braga - 104287 - Marca para no atualizar tabela pai pois processo de importao j faz isso e estava causando lentido
                         DESGRA = COALESCE(WK_GRA_DESGRA,DESGRA),
                         CODFIS = CASE WHEN iREGRA_CODFIS = 3 -- Ticket 2021068445 - Se regra for por Referncia de Venda, sempre altera o CODFIS para o REFPRO atual
                                       THEN COALESCE(WK_REFPRO,REFPRO)
                                       ELSE CODFIS
                                  END,
                         IMGGRU = COALESCE(WK_IMGGRU, IMGGRU)
                   WHERE CODEXT = WK_CODEXT_GRA;
               EXCEPTION
                  
                  WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR ITENS DE GRADE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR ITENS DE GRADE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR ITENS DE GRADE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR ITENS DE GRADE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR ITENS DE GRADE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR ITENS DE GRADE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR ITENS DE GRADE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                   END;
               IF NOT WK_MOTREJ = 'OK' THEN
                  WK_STATUS := 4;
                  WK_NROERR := WK_NROERR + 1;
               ELSE
                  WK_STATUS := 3;
               END IF;
            ELSE
               -- Casos onde muda o CODEXT, mas que a chave FILMAT, CODMAT, CODCOR e CODTAM j existem,
               -- nesse caso, atualiza o CODEXT, REFPRO e o GRAATI pois anteriormente desativava essa
               -- grade e colocava o REFPRO para '1#'||REFPRO
               BEGIN
                  UPDATE TT_GRA
                     SET CODEXT = COALESCE(WK_CODEXT,CODEXT),
                         UNIDAD = COALESCE(WK_COD_UNIDAD,UNIDAD),
                         UNIFOR = COALESCE(WK_COD_UNIFOR,UNIFOR),
                         VALCON = COALESCE(WK_VALCON,VALCON),
                         PROMOC = COALESCE(WK_PROMOC,PROMOC),
                         VOLUNI = COALESCE(WK_VOLUNI,VOLUNI),
                         REFPRO = COALESCE(WK_REFPRO,REFPRO),
                         DATCOM = COALESCE(WK_DATCOM,DATCOM),
                         CUSREP = COALESCE(WK_CUSREP,CUSREP),
                         DESIDE = COALESCE(WK_DESIDE,DESIDE),
                         DESMAX = COALESCE(WK_DESMAX,DESMAX),
                         MINQTD = COALESCE(WK_MINQTD,MINQTD),
                         PERCOM = COALESCE(WK_PERCOM,PERCOM),
                         PERLUC = COALESCE(WK_PERLUC,PERLUC),
                         PESBRU = COALESCE(WK_PESBRU,PESBRU),
                         PESLIQ = COALESCE(WK_PESLIQ,PESLIQ),
                         PRECOM = COALESCE(WK_PRECOM,PRECOM),
                         PTOQTD = COALESCE(WK_PTOQTD,PTOQTD),
                         QTDREP = COALESCE(WK_QTDREP,QTDREP),
                         TIPVAL = COALESCE(WK_TIPVAL,TIPVAL),
                         TEMREP = COALESCE(WK_TEMREP,TEMREP),
                         VALIDA = COALESCE(WK_VALIDA,VALIDA),
                         CUSFRE = COALESCE(WK_CUSFRE,CUSFRE),
                         LOCALI = COALESCE(WK_LOCALI,LOCALI),
                         UNIEMB = COALESCE(WK_COD_UNIEMB,UNIEMB),
                         UNIAPL = COALESCE(WK_COD_UNIAPL,UNIAPL),
                         QTDEMB = COALESCE(WK_QTDEMB,QTDEMB),
                         CONAPL = COALESCE(WK_CONAPL,CONAPL),
                         OBSERV = COALESCE(WK_OBSGRA,OBSERV),
                         QTDCOM = COALESCE(WK_QTDCOM,QTDCOM),
                         ICMCOM = COALESCE(WK_ICMCOM,ICMCOM),
                         IPICOM = COALESCE(WK_IPICOM,IPICOM),
                         TAXCOM = COALESCE(WK_TAXCOM,TAXCOM),
                         DESCOM = COALESCE(WK_DESCOM,DESCOM),
                         SUBCOM = COALESCE(WK_SUBCOM,SUBCOM),
                         SEGFRE = COALESCE(WK_SEGFRE,SEGFRE),
                         ICMFRE = COALESCE(WK_ICMFRE,ICMFRE),
                         FORLIN = COALESCE(WK_FORLIN,FORLIN),
                         MARKUP = COALESCE(WK_MARKUP,MARKUP),
                         PREPSI = COALESCE(WK_PREPSI,PREPSI),
                         DESICO = COALESCE(WK_DESICO,DESICO),
                         ORICUS = COALESCE(WK_ORICUS,ORICUS),
                         IPICUS = COALESCE(WK_IPICUS,IPICUS),
                         ICMCUS = COALESCE(WK_ICMCUS,ICMCUS),
                         OUTCUS = COALESCE(WK_OUTCUS,OUTCUS),
                         GRAATI = COALESCE(WK_NEW_GRAATI,GRAATI),
                         DACCUS = COALESCE(WK_DACCUS,DACCUS),
                         AFICUS = COALESCE(WK_AFICUS,AFICUS),
                         ICMTIP = COALESCE(WK_ICMTIP,ICMTIP),
                         PERFRE = COALESCE(WK_PERFRE,PERFRE),
                         ALIFRE = COALESCE(WK_ALIFRE,ALIFRE),
                         VOLUME = COALESCE(WK_VOLUME,VOLUME),
                         --CODNCM = COALESCE(WK_CODNCM,CODNCM),
                         MVACOM = COALESCE(WK_MVACOM,MVACOM),
                         ALTURA = COALESCE(WK_ALTURA,ALTURA),
                         LARGUR = COALESCE(WK_LARGUR,LARGUR),
                         PROFUN = COALESCE(WK_PROFUN,PROFUN),
                         MAXPAR = COALESCE(WK_MAXPAR,MAXPAR),
                         ATU_EM = Agora(),
                         DUMMY = Constante('MANTEM_ATU_EM'), -- Pedro E. Braga - 104287 - Marca para no atualizar tabela pai pois processo de importao j faz isso e estava causando lentido
                         DESGRA = COALESCE(WK_GRA_DESGRA,DESGRA),
                         IMGGRU = COALESCE(WK_IMGGRU, IMGGRU)
                   WHERE CODEXT = WK_CODEXT_GRA;
               EXCEPTION
                  
                  WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR ITENS DE GRADE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR ITENS DE GRADE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR ITENS DE GRADE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR ITENS DE GRADE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR ITENS DE GRADE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR ITENS DE GRADE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR ITENS DE GRADE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                   END;
               IF NOT WK_MOTREJ = 'OK' THEN
                  WK_STATUS := 4;
                  WK_NROERR := WK_NROERR + 1;
               ELSE
                  WK_STATUS := 3;
               END IF;
            END IF; -- Fim do tratamento que verifica se grade existe
         END IF;
         
         -- DN - Alterando preo do varejo
         IF (WK_MOTREJ = 'OK') THEN
            SELECT FILPRE, CODPRE
              INTO WK_FILPRE, WK_CODPRE
              FROM TT_CFG CFG;

             SELECT COUNT(*)
               INTO WK_COUNT
               FROM TT_PRE PRE
              WHERE FILPRE = WK_FILPRE
                AND FILMAT = WK_FILMAT
                AND CODMAT = WK_CODMAT
                AND CODCOR = WK_CODCOR
                AND CODTAM = WK_CODTAM
                AND CODPRE = WK_CODPRE;

            -- Incluir preco se nao existe
            IF WK_COUNT = 0 THEN
               BEGIN
                  INSERT INTO TT_PRE (FILPRE, FLGEST, FILMAT, CODMAT, CODCOR, CODPRE, CODTAM, CODMOE, PRECOV)
                       VALUES (WK_FILPRE,'T',WK_FILMAT, WK_CODMAT, WK_CODCOR, WK_CODPRE, WK_CODTAM, 0, WK_PRECOV);

               EXCEPTION
                  
                  WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                   END;
               IF NOT WK_MOTREJ = 'OK' THEN
                 WK_STATUS := 4;
                 WK_NROERR := WK_NROERR + 1;
               ELSE
                 WK_STATUS := 3;
               END IF;

            ELSE

               IF WK_PRECOV IS NOT NULL THEN
                  -- Altera o preco
                  BEGIN

                     UPDATE TT_PRE SET PRECOV = WK_PRECOV
                      WHERE FILPRE = WK_FILPRE
                        AND FILMAT = WK_FILMAT
                        AND CODMAT = WK_CODMAT
                        AND CODCOR = WK_CODCOR
                        AND CODTAM = WK_CODTAM
                        AND CODPRE = WK_CODPRE;

                  EXCEPTION
                     
                     WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                            END;
                  IF NOT WK_MOTREJ = 'OK' THEN
                    WK_STATUS := 4;
                    WK_NROERR := WK_NROERR + 1;
                  ELSE
                    WK_STATUS := 3;
                  END IF;
               END IF; -- Precov nulo
            END IF;
         END IF;

         --  Atualizar TT_NCM
         IF (WK_MOTREJ = 'OK') THEN
             SELECT COUNT(*)
               INTO WK_COUNT
               FROM TT_NCM
              WHERE CODNCM = WK_CODNCM;

            -- Atualiza NCM caso exista
            IF WK_COUNT > 0 THEN
               BEGIN
                  UPDATE TT_NCM
                     SET QTDLIM_PJ = WK_QTDLIM_PJ,
                         QTDLIM_PF = WK_QTDLIM_PF
                   WHERE CODNCM = WK_CODNCM;

               EXCEPTION
                  
                  WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TABELA NCM: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TABELA NCM: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TABELA NCM: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TABELA NCM: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TABELA NCM: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TABELA NCM: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TABELA NCM: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                   END;
            END IF;
         END IF;
         
         IF NOT WK_MOTREJ = 'OK' THEN
           WK_STATUS := 4;
           WK_NROERR := WK_NROERR + 1;
         ELSE
           WK_STATUS := 3;
         END IF;

         -- Serve para garantir que os registros tenham as TT_IUFs de todas as filiais
         IF WK_MOTREJ = 'OK' THEN
            cDummy := INSERE_IUF(WK_FILMAT, WK_CODMAT, WK_ESTADO, COALESCE(WK_REGESP,0));
         END IF;

         UPDATE TI_PRO SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
          WHERE CODEXT = WK_CODEXT
            AND ESTADO = WK_ESTADO
            AND DATIMP IS NULL;

         
         WK_QTDIMP := WK_QTDIMP + 1;

         
         WK_NUMREG := WK_NUMREG - 1;
         
         CLOSE CR_PRODUTOS;
      END LOOP;

      -- Se ocorreu erros, notificar por email
      IF WK_NROERR <> 0 THEN
         SELECT MAI_FR, MAI_TO, SAC_E_MAIL
           INTO WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL
           FROM TT_CFG;
         IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
            INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO,MAI_CC,
                                TEXTOS,TIPMSG)
                        VALUES ('001','F',AGORA(),'IMPORTAO DE PRODUTOS',WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL,
                                'Problema na importao de '||wk_nroerr||' produtos. Verifique!','T');
         END IF;
      END IF;

      -- Converte status temporarios de execucao para o status final
      UPDATE TI_PRO SET STATUS = CASE WHEN STATUS = 3
                                      THEN 1
                                      ELSE 2
                                 END
       WHERE STATUS IN (3,4);

      -- Tratamento para eliminar registros da TI_PRO apos importacao
      IF WK_MANTEM = 'F' THEN
         IF WK_DIALIM > 0 THEN
            DELETE FROM TI_PRO
             WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
               AND STATUS = 1;
         ELSE
            DELETE FROM TI_PRO
             WHERE STATUS = 1;
         END IF;
      END IF;

      -- Atualiza tabela de importacoes com o resultado dessa importacao
      UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = WK_QTDIMP, CNTIMP = WK_CNTIMP, TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP WHERE TABELA = 'PRO';

         ELSE
      RAISE EXCEPTION 'PG-20001 IMPORTAO DE PRODUTOS NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;

   -- Se sobrou algum registro para ser processado, deve retornar isso na funcao.
   
   SELECT /*+INDEX(ti_pro,I_TI_PRO)*/ COUNT(*) INTO WK_RESTO FROM TI_PRO WHERE STATUS = 0;
   IF WK_RESTO > 0 THEN
      RETURN 'EXISTEM '||WK_RESTO||' PRODUTOS NO IMPORTADOS';
   ELSE
      RETURN 'OK';
   END IF;
  
END;
$$ language 'plpgsql';





/*-- SEQ 1518 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CRIA_SEPARACAO (CHAR) CASCADE;

/*-- SEQ 1519 --*/
CREATE OR REPLACE FUNCTION CRIA_SEPARACAO (CHAR)
RETURNS VARCHAR AS $$
DECLARE
pProcessoCompleto ALIAS FOR $1 ;
BEGIN
 -- No faz nada
 -- Somente para compatibilidade 5.0C
  RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 1520 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CRIA_SEPARACAO () CASCADE;

/*-- SEQ 1521 --*/
CREATE OR REPLACE FUNCTION CRIA_SEPARACAO () 
RETURNS VARCHAR AS $$
BEGIN
RETURN CRIA_SEPARACAO('F');
END;
$$ language 'plpgsql';

/*-- SEQ 1522 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CRIA_SEPARACAO_FULL (CHAR) CASCADE;

/*-- SEQ 1523 --*/
CREATE OR REPLACE FUNCTION CRIA_SEPARACAO_FULL (CHAR)
RETURNS VARCHAR AS $$
DECLARE
pProcessoCompleto ALIAS FOR $1 ;
  cTEMP TT_FUN.NOMFUN%TYPE;

-- Objetivos:
-- 1) cria os itens de volumes para orcamentos nao vendidos e vendas nao entregues
-- 2) cria os itens de volumes para devolver vendas separadas ou cancelar vendas em falta ou nao separadas

-- Declarao de variveis e cursores

CR_SEPARACAO CURSOR FOR
  -- RFMP 80324
  -- Sistema no precisa filtrar se tem encomenda.
  -- Filtro existia, provavelmente, porque no havia possibilidade de se fazer Venda sob Encomenda diretamente em oramento.
  -- Atualmente essa possibilidade existe para os casos por Televendas.
  SELECT TAB.CODFIL,
         CAST('A' AS CHAR(1)),
         TAB.CODFIL,
         TAB.TIPPED,
         TAB.NUMPED,
         TAB.NUMITE,
         CAST(NULL AS VARCHAR(3)),
         CAST(NULL AS VARCHAR(10)),
         CAST(NULL AS Numeric(5)),
         CAST('F' AS CHAR(1)) -- IMP_CF = FALSE
    FROM (SELECT IOR.CODFIL,
                 IOR.TIPPED,
                 IOR.NUMPED,
                 IOR.NUMITE,
                 QTD_A_SEPARAR(Null, Null, Null, IOR.CODFIL, IOR.TIPPED, IOR.NUMPED, IOR.NUMITE) AS QTDSEP
            FROM TT_IOR IOR INNER JOIN TT_ORC ORC ON IOR.CODFIL = ORC.CODFIL
                                                 AND IOR.TIPPED = ORC.TIPPED
                                                 AND IOR.NUMPED = ORC.NUMPED
                             LEFT JOIN TT_IVO IVO ON IVO.FILPED = IOR.CODFIL
                                                 AND IVO.TIPPED = IOR.TIPPED
                                                 AND IVO.NUMPED = IOR.NUMPED
                                                 AND IVO.NUMITE = IOR.NUMITE
                                                 AND IVO.FLGEST IN ('A','N')
           WHERE IOR.TIPENT IN ('1','2','3')
             AND ((LeParametroBoo('SEPARAR_TIP_1','','','','')='T' and IOR.TIPENT='1') or
                 (LeParametroBoo('SEPARAR_TIP_3','','','','')='T' and IOR.TIPENT='3') or
                 (IOR.TIPENT not in ('1','3')))
             AND IOR.FLGEST IN ('A','R')
             AND IOR.FLGIVO = 'A'
             AND ORC.TELEVE = 'T'
             AND ORC.APROVA = 'A'
             --AND Tem_Encomenda(IOR.CODFIL, IOR.TIPPED, IOR.NUMPED) = 'F'
             AND IVO.FILVOL IS NULL
         ) TAB
   WHERE TAB.QTDSEP > 0
  UNION ALL
  SELECT TAB.CODFIL,
         CAST('A' AS CHAR(1)),
         TAB.CODFIL,
         TAB.TIPPED,
         TAB.NUMPED,
         TAB.NUMITE,
         NULL,
         NULL,
         NULL,
         CAST('F' AS CHAR(1)) -- IMP_CF = FALSE
    FROM (SELECT IOR.CODFIL,
                 IOR.TIPPED,
                 IOR.NUMPED,
                 IOR.NUMITE,
                 QTD_A_SEPARAR(Null, Null, Null, IOR.CODFIL, IOR.TIPPED, IOR.NUMPED, IOR.NUMITE) AS QTDSEP
            FROM TT_IOR IOR INNER JOIN TT_ORC ORC ON IOR.CODFIL = ORC.CODFIL
                                                 AND IOR.TIPPED = ORC.TIPPED
                                                 AND IOR.NUMPED = ORC.NUMPED
                            INNER JOIN TT_IVEXIPE ENC ON ENC.FILPED = IOR.CODFIL
                                                     AND ENC.TIPPED = IOR.TIPPED
                                                     AND ENC.NUMPED = IOR.NUMPED
                                                     AND ENC.NUMITE = IOR.NUMITE
                                                     AND ENC.FLGEST <> 'C'
                            INNER JOIN TT_IPE IPE ON IPE.CODFIL = ENC.FILIPE
                                                 AND IPE.NUMPED = ENC.NUMIPE
                                                 AND IPE.NUMITE = ENC.ITEIPE
                            INNER JOIN TT_ICO ICO ON ICO.CODFIL = IPE.FILICO
                                                 AND ICO.SEQUEN = IPE.SEQICO
                                                 AND ICO.NUMITE = IPE.NUMICO
                             LEFT JOIN TT_IVO IVO ON IVO.FILPED = IOR.CODFIL
                                                 AND IVO.TIPPED = IOR.TIPPED
                                                 AND IVO.NUMPED = IOR.NUMPED
                                                 AND IVO.NUMITE = IOR.NUMITE
                                                 AND IVO.FLGEST IN ('A','N')
           WHERE IOR.TIPENT IN ('7')
             AND IOR.FLGEST IN ('A','R')
             AND IOR.FLGIVO = 'A'
             AND ORC.TELEVE = 'T'
             AND ORC.APROVA = 'A'
             AND IVO.FILVOL IS NULL
         ) TAB
   WHERE TAB.QTDSEP > 0
  UNION ALL
  SELECT COALESCE(TAB.FILRES,TAB.CODFIL) AS CODFIL,
         CAST('A' AS CHAR(1)),
         NULL,
         NULL,
         NULL,
         NULL,
         TAB.CODFIL,
         TAB.SEQUEN,
         TAB.NUMITE,
         CAST('F' AS CHAR(1)) -- IMP_CF = FALSE
    FROM (SELECT CASE WHEN IOR.TIPENT = '3'
                      THEN IVE.QTDMOV
                      ELSE QtdPendente(IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE, IVE.QTDMOV)
                 END AS PENDEN,
                 QTD_A_SEPARAR(IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE, Null, Null, Null, Null) AS QTDSEP,
                 IVE.CODFIL,
                 IVE.SEQUEN,
                 IVE.NUMITE,
                 IOR.TIPENT,
                 IVE.FILRES
            FROM TT_IVE IVE INNER JOIN TT_IOR IOR ON IOR.FILIVE = IVE.CODFIL
                                                 AND IOR.SEQIVE = IVE.SEQUEN
                                                 AND IOR.NUMIVE = IVE.NUMITE
                            INNER JOIN TT_ORC ORC ON ORC.CODFIL = IOR.CODFIL
                                                 AND ORC.TIPPED = IOR.TIPPED
                                                 AND ORC.NUMPED = IOR.NUMPED
                             LEFT JOIN TT_IVO IVO ON IVO.FILIVE = IVE.CODFIL
                                                 AND IVO.SEQIVE = IVE.SEQUEN
                                                 AND IVO.NUMIVE = IVE.NUMITE
                                                 AND IVO.FLGEST IN ('A','N')
           WHERE IVE.SITMOV <> 'C'
             AND IOR.FLGEST = 'E'
             AND IOR.FLGIVO = 'A'
             AND (IOR.TIPENT <>'3' or (LeParametroBoo('SEPARAR_TIP_3','','','','')='F') or (ORC.TELEVE = 'F'))
             AND IVO.FILIVE IS NULL
         ) TAB
   WHERE TAB.QTDSEP > 0
     AND TAB.PENDEN > 0
  -- Manoel - 19/05/2011 - 81809
  UNION ALL
  SELECT COALESCE(IVE.FILRES,IVE.CODFIL) AS FILTAB,
         CAST('A' AS CHAR(1)),
         NULL,
         NULL,
         NULL,
         NULL,
         IVE.CODFIL,
         IVE.SEQUEN,
         IVE.NUMITE,
         'T' -- Sempre vai ser IMP_CF = True aqui
    FROM TT_IVE IVE INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL
                                         AND VEN.SEQUEN = IVE.SEQUEN
                    INNER JOIN TT_IOR IOR ON IOR.FILIVE = IVE.CODFIL
                                         AND IOR.SEQIVE = IVE.SEQUEN
                                         AND IOR.NUMIVE = IVE.NUMITE
                    INNER JOIN TT_ORC ORC ON ORC.CODFIL = IOR.CODFIL
                                         AND ORC.TIPPED = IOR.TIPPED
                                         AND ORC.NUMPED = IOR.NUMPED
                     LEFT JOIN TT_IVO IVO ON IVO.FILIVE = IVE.CODFIL
                                         AND IVO.SEQIVE = IVE.SEQUEN
                                         AND IVO.NUMIVE = IVE.NUMITE
                                         AND IVO.FLGEST <> 'C'
                     --CROSS JOIN TT_CFG CFG
   WHERE IVE.SITMOV <> 'C'
     --AND CFG.ENTREGA_CF = 'T'
     AND ((VEN.CODSER = 'CF') OR (VEN.MODNOT IN ('65','59')))
     AND IOR.FLGEST = 'E'
     AND IOR.FLGIVO = 'A'
     AND IVO.FILIVE IS NULL
     AND IOR.TIPENT = '2' -- Loja Entrega
     AND ORC.TELEVE = 'F' -- Sem Televendas
     AND (QTDMOV - QtdDevolvida(IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE) > 0);

CR_DEVOLUCAO CURSOR FOR
  SELECT TAB.CHAVE,
         TAB.FILIVE,
         TAB.SEQIVE,
         TAB.NUMIVE,
         TAB.FILPED,
         TAB.TIPPED,
         TAB.NUMPED,
         TAB.NUMITE,
         CAST(CASE WHEN TAB.FLGEST = 'P' THEN 'D' ELSE 'C' END AS CHAR(1)) AS FLGEST,
         TAB.CONTEM,
         TAB.QTDFAL,
         TAB.QTDDEV,
         TAB.FILIVO,
         TAB.SEQIVO
    FROM (
            SELECT * FROM (
            SELECT CAST(IVO.ORIGEM||IVO.FILIVE||IVO.SEQIVE||IVO.NUMIVE AS VARCHAR(19)) AS CHAVE,
                   IVO.FILIVE,
                   IVO.SEQIVE,
                   IVO.NUMIVE,
                   IVO.FILPED,
                   IVO.TIPPED,
                   IVO.NUMPED,
                   IVO.NUMITE,
                   IVO.CONTEM,
                   IVO.QTDFAL,
                   QTD_A_DEVOLVER(IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE) AS QTDDEV,
                   IVO.FLGEST,
                   IVO.FILVOL AS FILIVO,
                   IVO.SEQUEN AS SEQIVO
              FROM TT_IVE IVE INNER JOIN TT_IOR IOR ON IOR.FILIVE = IVE.CODFIL
                                                   AND IOR.SEQIVE = IVE.SEQUEN
                                                   AND IOR.NUMIVE = IVE.NUMITE
                              INNER JOIN TT_IVO IVO ON IVO.FILIVE = IVE.CODFIL
                                                   AND IVO.SEQIVE = IVE.SEQUEN
                                                   AND IVO.NUMIVE = IVE.NUMITE
                                                   AND IVO.FLGEST IN ('P','F','N')
             WHERE IVE.PENATU = 'P'
               AND IVE.SITMOV <> 'C'
               AND IOR.FLGEST = 'E'
               AND IOR.FLGIVO = 'P'
               AND IVO.ORIGEM = 'V') A WHERE A.QTDDEV < 0
             UNION
            SELECT * FROM (
            SELECT CAST(IVO.ORIGEM||IVO.FILIVE||IVO.SEQIVE||IVO.NUMIVE AS VARCHAR(19)) AS CHAVE,
                   IVO.FILIVE,
                   IVO.SEQIVE,
                   IVO.NUMIVE,
                   IVO.FILPED,
                   IVO.TIPPED,
                   IVO.NUMPED,
                   IVO.NUMITE,
                   IVO.CONTEM, IVO.QTDFAL,
                   IVE.QTDMOV-IVO.CONTEM+DEV.QTDMOV AS QTDDEV,
                   IVO.FLGEST,
                   IVO.FILVOL AS FILIVO,
                   IVO.SEQUEN AS SEQIVO
              FROM TT_IVO IVO INNER JOIN TT_IVE IVE ON IVO.FILIMP=IVE.CODFIL
                                                   AND IVO.SEQIMP=IVE.SEQUEN
                                                   AND IVO.NUMIMP=IVE.NUMITE
                              INNER JOIN TT_IVE DEV ON IVO.FILIMP=DEV.FILORI
                                                   AND IVO.SEQIMP=DEV.NUMORI
                                                   AND IVO.NUMIMP=DEV.ITEORI
             WHERE IVO.FLGEST = 'P'
               AND IVO.ORIGEM = 'V'
               AND IVO.TEMROM = 'T') B WHERE B.QTDDEV < 0
             UNION
            SELECT * FROM (
            SELECT CAST(IVO.ORIGEM||IVO.FILIVE||IVO.SEQIVE||IVO.NUMIVE AS VARCHAR(19)) AS CHAVE,
                   IVO.FILIVE,
                   IVO.SEQIVE,
                   IVO.NUMIVE,
                   IVO.FILPED,
                   IVO.TIPPED,
                   IVO.NUMPED,
                   IVO.NUMITE,
                   IVO.CONTEM, IVO.QTDFAL,
                   (IVO.CONTEM-(IVE.QTDPEN-COALESCE(IVE.QTDFUT,0)))*-1 AS QTDDEV,
                   IVO.FLGEST,
                   IVO.FILVOL AS FILIVO,
                   IVO.SEQUEN AS SEQIVO
              FROM TT_IVO IVO INNER JOIN TT_IVE IVE ON IVO.FILIVE=IVE.CODFIL
                                                   AND IVO.SEQIVE=IVE.SEQUEN
                                                   AND IVO.NUMIVE=IVE.NUMITE
                              INNER JOIN TT_IVE REM ON IVE.CODFIL=REM.FILORI
                                                   AND IVE.SEQUEN=REM.NUMORI
                                                   AND IVE.NUMITE=REM.ITEORI
             WHERE IVO.FLGEST = 'P'
               AND IVO.ORIGEM = 'V'
               AND IVO.FILIMP IS NULL
               ) B WHERE B.QTDDEV < 0
            UNION
            SELECT * FROM (
              SELECT CAST(IVO.ORIGEM||IVO.FILIVE||IVO.SEQIVE||IVO.NUMIVE AS VARCHAR(19)) AS CHAVE,
                     IVO.FILIVE,
                     IVO.SEQIVE,
                     IVO.NUMIVE,
                     IVO.FILPED,
                     IVO.TIPPED,
                     IVO.NUMPED,
                     IVO.NUMITE,
                     IVO.CONTEM,
                     IVO.QTDFAL,
                     DEV.QTDMOV AS QTDDEV,
                     IVO.FLGEST,
                     IVO.FILVOL AS FILIVO,
                     IVO.SEQUEN AS SEQIVO
                FROM TT_IVE IVE INNER JOIN TT_IOR IOR ON IOR.FILIVE = IVE.CODFIL
                                                     AND IOR.SEQIVE = IVE.SEQUEN
                                                     AND IOR.NUMIVE = IVE.NUMITE
                                INNER JOIN TT_ORC ORC ON IOR.CODFIL = ORC.CODFIL
                                                     AND IOR.TIPPED = ORC.TIPPED
                                                     AND IOR.NUMPED = ORC.NUMPED
                                INNER JOIN TT_IVO IVO ON IVO.FILIVE = IVE.CODFIL
                                                     AND IVO.SEQIVE = IVE.SEQUEN
                                                     AND IVO.NUMIVE = IVE.NUMITE
                                                     AND IVO.FLGEST IN ('P','F','N')
                                INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL
                                                     AND VEN.SEQUEN = IVE.SEQUEN
                                INNER JOIN TT_IVE DEV ON IVE.CODFIL = DEV.FILORI
                                                     AND IVE.SEQUEN = DEV.NUMORI
                                                     AND IVE.NUMITE = DEV.ITEORI
                                --CROSS JOIN TT_CFG CFG
               WHERE IVE.SITMOV <> 'C'
               --AND CFG.ENTREGA_CF = 'T'
                 AND IOR.FLGEST = 'E'
                 AND IVO.ORIGEM = 'V'
--                 AND IOR.TIPENT = '2'
                 AND IOR.TIPENT IN ('1','2','3')
                 AND ((LeParametroBoo('SEPARAR_TIP_1','','','','')='T' and IOR.TIPENT='1') or
                      (LeParametroBoo('SEPARAR_TIP_3','','','','')='T' and IOR.TIPENT='3') or
                      (IOR.TIPENT not in ('1','3')))
                 AND ((VEN.CODSER = 'CF') OR (VEN.MODNOT IN ('65','59')))
            ) F WHERE F.QTDDEV < 0
             UNION
            SELECT * FROM (
            SELECT CAST(IVO.ORIGEM||IVO.FILPED||IVO.TIPPED||IVO.NUMPED||IVO.NUMITE AS VARCHAR(19)) AS CHAVE,
                   IVO.FILIVE,
                   IVO.SEQIVE,
                   IVO.NUMIVE,
                   IVO.FILPED,
                   IVO.TIPPED,
                   IVO.NUMPED,
                   IVO.NUMITE,
                   IVO.CONTEM,
                   IVO.QTDFAL,
                   IVO.CONTEM*-1 AS QTDDEV,
                   IVO.FLGEST,
                   IVO.FILVOL AS FILIVO,
                   IVO.SEQUEN AS SEQIVO
              FROM TT_IVO IVO INNER JOIN TT_IOR IOR ON IOR.CODFIL = IVO.FILPED
                                                   AND IOR.TIPPED = IVO.TIPPED
                                                   AND IOR.NUMPED = IVO.NUMPED
                                                   AND IOR.NUMITE = IVO.NUMITE
             WHERE IVO.ORIGEM = 'O'
               AND IVO.FLGEST = 'P'
               AND IOR.TIPENT = '7'
               AND IVO.FILIMP IS NULL
               AND IOR.FLGENC = 'F') C WHERE C.QTDDEV < 0
             UNION
	        SELECT * FROM (
            SELECT CAST(IVO.ORIGEM||IVO.FILPED||IVO.TIPPED||IVO.NUMPED||IVO.NUMITE AS VARCHAR(19)) AS CHAVE,
                   IVO.FILIVE,
                   IVO.SEQIVE,
                   IVO.NUMIVE,
                   IVO.FILPED,
                   IVO.TIPPED,
                   IVO.NUMPED,
                   IVO.NUMITE,
                   IVO.CONTEM,
                   IVO.QTDFAL,
                   IVO.CONTEM*-1 AS QTDDEV,
                   IVO.FLGEST,
                   IVO.FILVOL AS FILIVO,
                   IVO.SEQUEN AS SEQIVO
              FROM TT_IVO IVO INNER JOIN TT_IOR IOR ON IOR.CODFIL = IVO.FILPED
                                                   AND IOR.TIPPED = IVO.TIPPED
                                                   AND IOR.NUMPED = IVO.NUMPED
                                                   AND IOR.NUMITE = IVO.NUMITE
             WHERE IVO.ORIGEM = 'O'
               AND IVO.FLGEST = 'P'
               AND IOR.TIPENT = '7'
               AND IVO.FILIMP IS NULL
               AND IOR.FLGENC = 'T'
               AND IOR.FLGEST = 'C') D WHERE D.QTDDEV < 0
             UNION
           -- RFMP 98466
           -- Devolve o item separado se a encomenda no estiver mais recebida.
           -- Especificamente criado para o caso explicado na sequncia abaixo:
           -- 1. Registrou a compra e liberou a mercadoria para separao.
           -- 2. Separou.
           -- 3. Desativou a compra antes de emitir a remessa. Isso fez com que o sistema
           --    mudasse a encomenda de recebida para encomendada.
           -- 4. Para ficar igual ao processo sem televendas, o sistema devolve a separao.
	        SELECT * FROM (
            SELECT CAST(IVO.ORIGEM||IVO.FILPED||IVO.TIPPED||IVO.NUMPED||IVO.NUMITE AS VARCHAR(19)) AS CHAVE,
                   IVO.FILIVE,
                   IVO.SEQIVE,
                   IVO.NUMIVE,
                   IVO.FILPED,
                   IVO.TIPPED,
                   IVO.NUMPED,
                   IVO.NUMITE,
                   IVO.CONTEM,
                   IVO.QTDFAL,
                   IVO.CONTEM*-1 AS QTDDEV,
                   IVO.FLGEST,
                   IVO.FILVOL AS FILIVO,
                   IVO.SEQUEN AS SEQIVO
              FROM TT_IVO IVO INNER JOIN TT_IOR IOR ON IOR.CODFIL = IVO.FILPED
                                                   AND IOR.TIPPED = IVO.TIPPED
                                                   AND IOR.NUMPED = IVO.NUMPED
                                                   AND IOR.NUMITE = IVO.NUMITE
             WHERE IVO.ORIGEM = 'O'
               AND IVO.FLGEST = 'P'
               AND IOR.TIPENT = '7'
               AND IVO.FILIMP IS NULL
               AND IOR.FLGENC = 'T'
               AND IOR.FLGEST <> 'C'
               AND COALESCE((SELECT SUM(ENC.QTDENC)
                               FROM TT_IVEXIPE ENC
                              WHERE ENC.FILPED = IVO.FILPED
                                AND ENC.TIPPED = IVO.TIPPED
                                AND ENC.NUMPED = IVO.NUMPED
                                AND ENC.NUMITE = IVO.NUMITE
                                AND ENC.FLGEST = 'R'),0) = 0
               ) D WHERE D.QTDDEV < 0
           ) TAB
   ORDER BY TAB.CHAVE, TAB.FLGEST;

-- RFMP 88441
-- Tratamento para diminuir a quantidade separada de acordo com o que foi entregue.
-- RFMP 98398
-- DAV no tem embalagem, por isso,  necessrio comparar a separao baseada em DAV com a quantidade original da embalagem.
CR_AJUSTE_IMP CURSOR FOR
   SELECT IVO.FILVOL, IVO.SEQUEN, COALESCE(IVO.CONTEM,0) AS CONTEM, IVE.QTDMOV
     FROM TT_IVO IVO INNER JOIN TT_IVE IVE ON IVE.CODFIL = IVO.FILIMP
                                          AND IVE.SEQUEN = IVO.SEQIMP
                                          AND IVE.NUMITE = IVO.NUMIMP
    WHERE IVO.FLGEST = 'E'
      AND IVO.DATHOR >= ADD_DAY(AGORA(),-7)
      AND COALESCE(IVO.CONTEM,0) > IVE.QTDMOV
      AND IVO.ORIGEM = 'V'
    UNION ALL
   SELECT IVO.FILVOL, IVO.SEQUEN, COALESCE(IVO.CONTEM,0) AS CONTEM, COALESCE(IVE.EMBQTD,IVE.QTDMOV)
     FROM TT_IVO IVO INNER JOIN TT_IVE IVE ON IVE.CODFIL = IVO.FILIMP
                                          AND IVE.SEQUEN = IVO.SEQIMP
                                          AND IVE.NUMITE = IVO.NUMIMP
    WHERE IVO.FLGEST = 'E'
      AND IVO.DATHOR >= ADD_DAY(AGORA(),-7)
      AND COALESCE(IVO.CONTEM,0) > COALESCE(IVE.EMBQTD,IVE.QTDMOV)
      AND IVO.ORIGEM = 'O';

CR_SEPARACAO_INCONSISTENTE CURSOR FOR
   SELECT FILVOL, SEQUEN
     FROM TT_IVO
    WHERE (
           (
            (FLGEST = 'F') AND (COALESCE(QTDFAL,0) <= 0)
           ) OR
          (
           (FLGEST IN ('A','N')) AND (COALESCE(QTD_A_SEPARAR(null,null,null,FILPED,TIPPED,NUMPED,NUMITE),0) <= 0))
          )
      AND ORIGEM='O'
      AND FILIMP IS NULL
   UNION ALL
   SELECT IVO.FILVOL, IVO.SEQUEN
     FROM TT_IVO IVO INNER JOIN TT_IVE IVE ON IVE.CODFIL = IVO.FILIVE 
                                          AND IVE.SEQUEN = IVO.SEQIVE
                                          AND IVE.NUMITE = IVO.NUMIVE
                     INNER JOIN TT_IOR IOR ON IOR.FILIVE = IVE.CODFIL
                                          AND IOR.SEQIVE = IVE.SEQUEN
                                          AND IOR.NUMIVE = IVE.NUMITE
                     CROSS JOIN (SELECT LeParametroBoo('SEPARAR_TIP_3','','','','') AS SEPARAR_TIP_3 FROM DUAL) PAR 
    WHERE IVO.FLGEST = 'A'
      AND IVO.ORIGEM = 'V'
      AND PAR.SEPARAR_TIP_3 = 'F'
      AND IOR.TIPENT = '3'
      AND IVO.FILIMP IS NULL;

   vFILVOL                       TT_IVO.FILVOL%type;
   vFLGEST                       TT_IVO.FLGEST%type;
   vFILPED                       TT_IVO.FILPED%type;
   vTIPPED                       TT_IVO.TIPPED%type;
   vNUMPED                       TT_IVO.NUMPED%type;
   vNUMITE                       TT_IVO.NUMITE%type;
   vFILIVE                       TT_IVO.FILIVE%type;
   vSEQIVE                       TT_IVO.SEQIVE%type;
   vNUMIVE                       TT_IVO.NUMIVE%type;
   vIMP_CF                       TT_IVO.IMP_CF%type;

   vCONTEM                       TT_IVO.CONTEM%type;
   vQTDFAL                       TT_IVO.CONTEM%type;
   vQTDDEV                       TT_IVO.CONTEM%type;
   vSEQIVO                       TT_IVO.SEQUEN%type;

   vDEV_FILVOL                   TT_IVO.FILVOL%type;
   vDEV_SEQUEN                   TT_IVO.SEQUEN%type;

   vCHAVE                        VARCHAR(19);
   vLAST_CHAVE                   VARCHAR(19);
   vRetorno                      VARCHAR(100);
   vTOTAL_A_DEVOLVER             TT_IVO.CONTEM%type; -- acumula por ivo a quantidade que ainda falta a ser devolvida
   vQTD_DEVOLVIDA                TT_IVO.CONTEM%type; -- eh a quantidade que precisa ser devolvida para aquela ivo
   vSEPARADO                     TT_IVO.CONTEM%type; -- eh a quantidade separada ou em falta ou nao separada de uma ivo

   vSEPARAR_ENTREGA              TT_CFG.SEPARAR_ENTREGA%type;

   vIMP_FILVOL                   TT_IVO.FILVOL%type;
   vIMP_SEQUEN                   TT_IVO.SEQUEN%type;
   vIMP_CONTEM                   TT_IVO.CONTEM%type;
   vIMP_QTDMOV                   TT_IVE.QTDMOV%type;

   cFILVOL                       TT_IVO.FILVOL%TYPE;
   cSEQUEN                       TT_IVO.SEQUEN%TYPE;

-- Principal
BEGIN
  -- Garantia de exclusividade no processo seguinte
  -- Usado tambm na PC_IVE_IVO
  SELECT NOMFUN INTO cTEMP
  FROM TT_FUN
  WHERE NOMFUN = 'LOCK_SEP'
  FOR UPDATE;

  SELECT SEPARAR_ENTREGA
    INTO vSEPARAR_ENTREGA
    FROM TT_CFG;

  -- Tratamento para cancelar oramentos que esto em aprovao e para separar.
  UPDATE TT_IVO IVO
     SET FLGEST = 'C',
         FILROM = NULL,
         SEQROM = NULL,
         QTDFAL = 0
   WHERE (IVO.FILPED, IVO.TIPPED, IVO.NUMPED) IN
         (SELECT ORC.CODFIL, ORC.TIPPED, ORC.NUMPED
            FROM TT_ORC ORC
           WHERE(ORC.APROVA = 'E' OR ORC.TELEVE = 'F')
             AND ORC.FLGEST <> 'C'
         )
     AND IVO.FILIMP IS NULL
     AND IVO.FLGEST IN ('A','N','F');

  IF pProcessoCompleto = 'T' THEN
    
    SELECT VINCULA_ROMANEIO()
      INTO vRetorno
      FROM DUAL;
          
    -- Tratamento para devolver oramentos que esto em aprovao e separados.
    UPDATE TT_IVO IVO
       SET FLGEST = 'D'
     WHERE EXISTS
           (SELECT 1 AS OK
              FROM TT_ORC ORC
             WHERE IVO.FILPED=ORC.CODFIL
               AND IVO.TIPPED=ORC.TIPPED
               AND IVO.NUMPED=ORC.NUMPED
               AND (ORC.APROVA = 'E' OR ORC.TELEVE = 'F' OR ORC.FLGEST = 'C')
           )
       AND IVO.FLGEST IN ('P')
       AND IVO.FILIMP IS NULL;

    -- Tratamento para cancelar ivos que nao fazem sentido
    OPEN CR_SEPARACAO_INCONSISTENTE;
    LOOP
      FETCH CR_SEPARACAO_INCONSISTENTE INTO cFILVOL, cSEQUEN;
      EXIT WHEN NOT FOUND;
         UPDATE TT_IVO
            SET FLGEST = 'C'
          WHERE FILVOL = cFILVOL
            AND SEQUEN = cSEQUEN;
    END LOOP;
    CLOSE CR_SEPARACAO_INCONSISTENTE;

    -- Tratamento para cancelar ivos do tipo venda sob encomenda que estao vinculadas a orcamento e que nao estejam separadas
    UPDATE TT_IVO
       SET FLGEST = 'C',
           FILROM = NULL,
           SEQROM = NULL,
           QTDFAL = 0
     WHERE ORIGEM = 'O'
       AND (FILPED, TIPPED, NUMPED, NUMITE) IN
           (SELECT IOR.CODFIL, IOR.TIPPED, IOR.NUMPED, IOR.NUMITE
              FROM TT_IOR IOR
             WHERE IOR.FLGENC = 'F'
               AND IOR.TIPENT = '7'
            UNION
            SELECT IOR.CODFIL, IOR.TIPPED, IOR.NUMPED, IOR.NUMITE
              FROM TT_IOR IOR
             WHERE IOR.FLGENC = 'T'
               AND IOR.TIPENT = '7'
               AND IOR.FLGEST = 'C')
       AND FILIMP IS NULL
       AND FLGEST IN ('A','N','F');

    -- RFMP 90939
    -- Cancelar IVOs de faturas que j foram totalmente devolvidas
    
    UPDATE TT_IVO IVO
       SET FLGEST = 'C'
      FROM TT_IVE IVE
     WHERE IVE.CODFIL = IVO.FILIVE
       AND IVE.SEQUEN = IVO.SEQIVE
       AND IVE.NUMITE = IVO.NUMIVE
       AND IVO.FLGEST = 'A'
       AND IVE.QTDMOV - QtdDevolvida(IVO.FILIVE,IVO.SEQIVE,IVO.NUMIVE) = 0
       AND IVO.ORIGEM = 'V'
       AND IVO.FILIMP IS NULL;
          END IF;

  OPEN CR_SEPARACAO;
  LOOP
    FETCH CR_SEPARACAO INTO vFILVOL, vFLGEST, vFILPED,
                          vTIPPED, vNUMPED, vNUMITE,
                          vFILIVE, vSEQIVE, vNUMIVE, vIMP_CF;
    EXIT WHEN NOT FOUND;

    -- Utiliza separao
    IF vSEPARAR_ENTREGA = 'T' THEN
        -- cria itens de volume
        INSERT INTO TT_IVO
        (FILVOL, FLGEST, FILPED, TIPPED, NUMPED, NUMITE, FILIVE, SEQIVE, NUMIVE, IMP_CF)
        VALUES
        (vFILVOL, vFLGEST, vFILPED, vTIPPED, vNUMPED, vNUMITE, vFILIVE, vSEQIVE, vNUMIVE, vIMP_CF);
    END IF;

  END LOOP;
  CLOSE CR_SEPARACAO;

  UPDATE TT_IOR
     SET FLGIVO = 'P'
   WHERE (CODFIL, TIPPED, NUMPED, NUMITE) IN (
         SELECT IOR.CODFIL,
                IOR.TIPPED,
                IOR.NUMPED,
                IOR.NUMITE
           FROM TT_IOR IOR INNER JOIN TT_IVO IVO ON IOR.CODFIL = IVO.FILPED
                                               AND IOR.TIPPED = IVO.TIPPED
                                               AND IOR.NUMPED = IVO.NUMPED
                                               AND IOR.NUMITE = IVO.NUMITE
          WHERE IOR.TIPENT IN ('1','2','3','7')
            AND IOR.FLGEST <> 'C'
            AND IOR.FLGIVO = 'A');

  UPDATE TT_IOR
     SET FLGIVO = 'P'
   WHERE (CODFIL, TIPPED, NUMPED, NUMITE) IN (
         SELECT TAB.CODFIL,
                TAB.TIPPED,
                TAB.NUMPED,
                TAB.NUMITE
           FROM (SELECT CASE WHEN IOR.TIPENT = '3'
                             THEN IVE.QTDMOV
                             ELSE QtdPendente(IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE, IVE.QTDMOV)
                        END AS PENDEN,
                        IOR.CODFIL,
                        IOR.TIPPED,
                        IOR.NUMPED,
                        IOR.NUMITE,
                        IOR.TIPENT
                   FROM TT_IVE IVE INNER JOIN TT_IVO IVO ON IVE.CODFIL = IVO.FILIVE
                                                        AND IVE.SEQUEN = IVO.SEQIVE
                                                        AND IVE.NUMITE = IVO.NUMIVE
                                   INNER JOIN TT_IOR IOR ON IOR.FILIVE = IVE.CODFIL
                                                        AND IOR.SEQIVE = IVE.SEQUEN
                                                        AND IOR.NUMIVE = IVE.NUMITE
                  WHERE IVE.SITMOV <> 'C'
                    AND IOR.FLGEST <> 'C'
                    AND IOR.FLGIVO = 'A'
                ) TAB
          WHERE TAB.PENDEN > 0
          );

  IF pProcessoCompleto = 'T' THEN
    vLAST_CHAVE := '';

    UPDATE TT_IVE
       SET PENATU = 'P'
     WHERE PENATU = 'T';

    OPEN CR_DEVOLUCAO;
    LOOP
      FETCH CR_DEVOLUCAO INTO vCHAVE,
                              vFILIVE, vSEQIVE, vNUMIVE,
                              vFILPED, vTIPPED, vNUMPED, vNUMITE,
                              vFLGEST, vCONTEM, vQTDFAL,
                              vQTDDEV, vFILVOL, vSEQIVO;
      EXIT WHEN NOT FOUND;

      -- o total a ser devolvido e o mesmo para as varias ivos de uma mesma nota
      -- portanto deve-se carregar o total a ser devolvido somente a cada nova ivo
      IF (Equal(vCHAVE,vLAST_CHAVE) <> 1) THEN
        vLAST_CHAVE       := vCHAVE;
        vTOTAL_A_DEVOLVER := vQTDDEV*-1;
      END IF;

      IF  vFLGEST = 'C' THEN
          vSEPARADO := COALESCE(vQTDFAL,0);
      ELSE
          vSEPARADO := COALESCE(vCONTEM,0);
      END IF;

      -- se o total que ainda falta para ser separado for maior ou igual a quantidade da ivo,
      -- devolve toda a ivo e subtrai seu valor do total a ser devolvido
      IF  vTOTAL_A_DEVOLVER >= vSEPARADO THEN

          vTOTAL_A_DEVOLVER := vTOTAL_A_DEVOLVER - vSEPARADO;
          vQTD_DEVOLVIDA    := vSEPARADO;

          -- cancela a ivo
          UPDATE TT_IVO
             SET FLGEST = 'C',
                 CONTEM = 0,
                 QTDFAL = 0,
                 FILIMP = NULL,
                 SEQIMP = NULL,
                 NUMIMP = NULL
           WHERE FILVOL = vFILVOL
             AND SEQUEN = vSEQIVO;

      ELSE -- senao, diminui da quantidade da ivo o que falta ainda para devolver

          vQTD_DEVOLVIDA    := vTOTAL_A_DEVOLVER;
          vTOTAL_A_DEVOLVER := 0;

          -- atualiza os valores separados
          UPDATE TT_IVO
             SET QTDFAL = COALESCE(QTDFAL,0) - CASE vFLGEST WHEN  'C' THEN vQTD_DEVOLVIDA ELSE 0 END,
                 CONTEM = COALESCE(CONTEM,0) - CASE vFLGEST WHEN  'D' THEN vQTD_DEVOLVIDA ELSE 0 END
           WHERE FILVOL = vFILVOL
             AND SEQUEN = vSEQIVO;

      END IF;

      -- devolver o que foi cancelado e estava separado
      IF  vFLGEST = 'D'
      AND vQTD_DEVOLVIDA > 0 THEN

          IF vFILIVE IS NOT NULL THEN
            SELECT MAX(FILVOL), MAX(SEQUEN)
              INTO vDEV_FILVOL, vDEV_SEQUEN
              FROM TT_IVO
             WHERE FLGEST = 'D'
               AND FILIVE = vFILIVE
               AND SEQIVE = vSEQIVE
               AND NUMIVE = vNUMIVE;
          ELSE
            SELECT MAX(FILVOL), MAX(SEQUEN)
              INTO vDEV_FILVOL, vDEV_SEQUEN
              FROM TT_IVO
             WHERE FLGEST = 'D'
               AND FILPED = vFILPED
               AND TIPPED = vTIPPED
               AND NUMPED = vNUMPED
               AND NUMITE = vNUMITE;
          END IF;

          IF vDEV_SEQUEN IS NULL THEN
            -- Utiliza separao
            IF vSEPARAR_ENTREGA = 'T' THEN
              INSERT INTO TT_IVO
              (FILVOL, FLGEST, FILPED, TIPPED, NUMPED, NUMITE, FILIVE, SEQIVE, NUMIVE, CONTEM)
              VALUES
              (vFILVOL, 'D', vFILPED, vTIPPED, vNUMPED, vNUMITE, vFILIVE, vSEQIVE, vNUMIVE, vQTD_DEVOLVIDA);
            END IF;
          ELSE
            UPDATE TT_IVO
               SET CONTEM = COALESCE(CONTEM,0) + vQTD_DEVOLVIDA
             WHERE FILVOL = vDEV_FILVOL
               AND SEQUEN = vDEV_SEQUEN;
          END IF;
      END IF;

    END LOOP;
    CLOSE CR_DEVOLUCAO;

    UPDATE TT_IVE
       SET PENATU = NULL
     WHERE PENATU = 'P';

    -- RFMP 88441
    -- Tratamento para diminuir a quantidade separada de acordo com o que foi entregue.
    OPEN CR_AJUSTE_IMP;
    LOOP
      FETCH CR_AJUSTE_IMP INTO vIMP_FILVOL, vIMP_SEQUEN, vIMP_CONTEM, vIMP_QTDMOV;
      EXIT WHEN NOT FOUND;

          UPDATE TT_IVO
             SET CONTEM = vIMP_QTDMOV
           WHERE FILVOL = vIMP_FILVOL
             AND SEQUEN = vIMP_SEQUEN;

          INSERT INTO TT_IVO
          (FILVOL, FLGEST, FILPED, TIPPED, NUMPED, NUMITE, FILIVE, SEQIVE, NUMIVE, CONTEM)
          SELECT FILVOL, 'D', FILPED, TIPPED, NUMPED, NUMITE, FILIVE, SEQIVE, NUMIVE, vIMP_CONTEM - vIMP_QTDMOV
            FROM TT_IVO
           WHERE FILVOL = vIMP_FILVOL
             AND SEQUEN = vIMP_SEQUEN;

    END LOOP;
    CLOSE CR_AJUSTE_IMP;
  END IF;

  RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 1524 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CRIA_SEPARACAO_FULL () CASCADE;

/*-- SEQ 1525 --*/
CREATE OR REPLACE FUNCTION CRIA_SEPARACAO_FULL () 
RETURNS VARCHAR AS $$
BEGIN
RETURN CRIA_SEPARACAO_FULL('F');
END;
$$ language 'plpgsql';


/*-- SEQ 1526 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GERA_RAZ_AUX_CTA_REC (TT_REC.DATFIS%TYPE) CASCADE;

/*-- SEQ 1527 --*/
CREATE OR REPLACE FUNCTION GERA_RAZ_AUX_CTA_REC (TT_REC.DATFIS%TYPE)
RETURNS VARCHAR AS $$
DECLARE
PDATFIS ALIAS FOR $1 ;

WK_SEQUEN TT_RZR.SEQUEN%TYPE;
WK_CODFIL TT_VEN.CODFIL%TYPE;
WK_SEQREC TT_REC.SEQUEN%TYPE;
WK_FILCLI TT_VEN.FILCLI%TYPE;
WK_CODCLI TT_VEN.CODCLI%TYPE;
WK_CODSER TT_VEN.CODSER%TYPE;
WK_NUMNOT TT_VEN.NUMNOT%TYPE;
WK_VLRLAN TT_RZR.VLRLAN%TYPE;
WK_DATVEN TT_RZR.DATVEN%TYPE;
WK_DATPGT TT_RZR.DATPGT%TYPE;
WK_VLRSAL TT_RZR.VLRSAL%TYPE;
WK_DATINC TT_RZR.DATINC%TYPE;
WK_CODCAR TT_RZR.CODCAR%TYPE;
WK_PROCES TT_REC.PROCES%TYPE;
WK_FLGEST TT_REC.FLGEST%TYPE;
WK_CARTAO TT_REC.CARTAO%TYPE;
WK_NUMPAR TT_REC.NUMPAR%TYPE;
WK_SUBPAR TT_REC.SUBPAR%TYPE;
WK_VLR_CARTAO TT_REC.VLRPAR%TYPE;
WK_PAR_CARTAO TT_REC.VLRPAR%TYPE;
WK_AUX_DATINC TT_REC.DATFIS%TYPE;
WK_DIADEB TD_CAR.DIADEB%TYPE;
WK_DIACAR TD_CAR.DIACAR%TYPE;
WK_FILADM TD_CAR.FILADM%TYPE;
WK_CODADM TD_CAR.CODADM%TYPE;
WK_ATU_EM TT_REC.ATU_EM%TYPE;
WK_AUX_FILADM TD_CAR.FILADM%TYPE;
WK_AUX_CODADM TD_CAR.CODADM%TYPE;
WK_AUX_CARTAO Numeric;
WK_VLRPGT_REC Numeric;
WK_MESCRE Numeric;
WK_PROXIMOMES Numeric;
WK_ANOCRE Numeric;
WK_VLRPGT Numeric;
WK_DESACR Numeric;
WK_MINPAR TT_REC.SUBPAR%TYPE;
WK_ESTCAN TT_REC.DATINC%TYPE;
vAUX VARCHAR(2);
WK_SERIE_FAT_CC TT_CFG.SERIE_FAT_CC%TYPE;

CR_PARCELAS CURSOR FOR
SELECT VEN.CODFIL, VEN.SEQUEN, VEN.FILCLI, VEN.CODCLI, VEN.CODSER, VEN.NUMNOT,
       REC.NUMPAR, REC.SUBPAR,
       REC.VLRPAR, --WK_VLRLAN
       REC.DATVEN, --WK_DATVEN
       TRUNC(REC.PAGAME) AS PAGAME, --WK_DATPGT
       REC.DATINC, --WK_DATINC
       COALESCE(REC.PROCES,0), --WK_PROCES
       TRUNC(REC.ATU_EM), --WK_ATU_EM
       REC.FLGEST, --WK_FLGEST
       REC.CARTAO, --WK_CARTAO
       REC.VLRPAR, --WK_PAR_CARTAO
       CAR.DIADEB, --WK_DIADEB
       CAR.DIACAR, --WK_DIACAR
       CAR.FILADM, --WK_FILADM
       CAR.CODADM, --WK_CODADM
       REC.VLRPGT-REC.VLRDES AS VLRPGT, --WK_VLRPGT
       REC.VLRPGT, --WK_VLRPGT_REC
       (SELECT MIN(SUBPAR)
          FROM TT_REC INT
         WHERE REC.CODFIL = INT.CODFIL
           AND REC.SEQUEN = INT.SEQUEN
           AND REC.NUMPAR=INT.NUMPAR
           AND INT.FLGEST NOT IN ('C')
           AND INT.VLRPAR = (SELECT MAX(VAL.VLRPAR)
                               FROM TT_REC VAL
                              WHERE VAL.CODFIL = INT.CODFIL
                                AND VAL.SEQUEN = INT.SEQUEN
                                AND VAL.NUMPAR = INT.NUMPAR
                                AND VAL.FLGEST NOT IN ('C')
                             )
        ) AS MINPAR, --WK_MINPAR
       REC.ESTCAN --WK_ESTCAN
FROM TT_VEN VEN INNER JOIN TT_REC REC ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
                 LEFT JOIN TD_CAR CAR ON CAR.CODTAB = REC.CARTAO
                 LEFT JOIN TT_REC SUB ON REC.CODFIL = SUB.CODFIL AND REC.SEQUEN = SUB.SEQUEN AND REC.NUMPAR=SUB.NUMPAR
                                     AND SUB.SUBPAR = SUBSTR(TO_CHAR(TO_NUMBER(trim(REC.SUBPAR))+1,'99'),2)
 WHERE VEN.CODCLI NOT IN ('     1','     0')
   AND VEN.CODSER <> 'TK'
   AND (REC.PROCES IN (0,1) OR (REC.PROCES = 2 AND REC.FLGEST  = 'X'))
   AND VEN.DATHOR <= PDATFIS
   --AND VEN.FILCLI='001' AND VEN.CODCLI='  2553'
   --a linha abaixo foi incluida pois antigamente, havia um erro no checkout q bagunava o valor das subparcelas
   AND exists
   ( select 1 AS EXISTE
       FROM TT_VEN ven2 INNER JOIN tt_rec rec2 ON REC2.CODFIL = VEN2.CODFIL AND REC2.SEQUEN = VEN2.SEQUEN
      WHERE ven2.codfil=rec.codfil
        AND ven2.sequen=rec.sequen
        AND COALESCE(rec2.PAGAME,AGORA()) >= to_date('01/01/2005','dd/mm/yyyy')
        AND (REC2.DATVEN > ADD_DAY(TRUNC(VEN2.DATFIS),1) OR
             VEN.CODSER = (SELECT SERIE_FAT_CC FROM TT_CFG))
        AND COALESCE(REC2.TIPCCC,-999) <> (SELECT CC_CHECKOUT FROM TT_CFG)
   )
   --AND VEN.DATHOR >= to_date('01/01/2005','dd/mm/yyyy')
ORDER BY VEN.FILCLI, VEN.CODCLI, TRUNC(VEN.DATFIS),VEN.CODFIL,VEN.CODSER,VEN.NUMNOT,REC.NUMPAR,REC.SUBPAR;

BEGIN

   SELECT SERIE_FAT_CC INTO WK_SERIE_FAT_CC FROM TT_CFG;

   WK_VLR_CARTAO := 0;
   OPEN CR_PARCELAS;
   LOOP

      FETCH CR_PARCELAS INTO WK_CODFIL, WK_SEQREC, WK_FILCLI, WK_CODCLI, WK_CODSER, WK_NUMNOT,
                             WK_NUMPAR, WK_SUBPAR, WK_VLRLAN, WK_DATVEN, WK_DATPGT, WK_DATINC,
                             WK_PROCES, WK_ATU_EM, WK_FLGEST, WK_CARTAO, WK_PAR_CARTAO, WK_DIADEB,
                             WK_DIACAR, WK_FILADM, WK_CODADM, WK_VLRPGT, WK_VLRPGT_REC, WK_MINPAR,
                             WK_ESTCAN;
      EXIT WHEN NOT FOUND;
--      RAISE_APPLICATION_ERROR(-20001,WK_CODFIL);

      WK_DESACR := COALESCE(WK_VLRPGT-WK_VLRPGT_REC,0);

      IF (WK_PROCES IN (0,1,2)) AND
         (WK_CARTAO IS NULL OR WK_CODSER = WK_SERIE_FAT_CC) THEN
           IF WK_PROCES=0 AND (WK_SUBPAR = WK_MINPAR OR WK_FLGEST IN ('C')) THEN
               WK_SEQUEN := ProximoCodigo('TT_RZR',WK_CODFIL);
               INSERT INTO TT_RZR (CODFIL, SEQUEN, DATINC, FILCLI, CODCLI, CODSER, NUMNOT,
                                   DATVEN, DATPGT, VLRSAL, VLRLAN, DESACR, FILREC,SEQREC,NUMREC,SUBREC)
                           VALUES (WK_CODFIL, WK_SEQUEN, WK_DATINC, WK_FILCLI, WK_CODCLI, WK_CODSER, WK_NUMNOT,
                                   WK_DATVEN, null, 0, WK_VLRLAN, 0, WK_CODFIL, WK_SEQREC, WK_NUMPAR, WK_SUBPAR);
               vAUX:=CalcSaldoRazao(WK_FILCLI, WK_CODCLI, WK_DATINC, WK_SEQUEN);
               WK_PROCES := 1;
           END IF;
           IF WK_PROCES in (0,1) AND (WK_FLGEST IN ('P','C','X') OR (WK_CARTAO IS NOT NULL)) THEN
              WK_SEQUEN:=ProximoCodigo('TT_RZR',WK_CODFIL);
              INSERT INTO TT_RZR (CODFIL, SEQUEN, DATINC, FILCLI, CODCLI, CODSER, NUMNOT,
                                  DATVEN, DATPGT, VLRSAL, VLRLAN, DESACR, FILREC,SEQREC,NUMREC,SUBREC)
                          VALUES (WK_CODFIL,
                                  WK_SEQUEN,
                                  CASE WHEN WK_FLGEST IN ('C') THEN COALESCE(WK_ESTCAN,GREATEST(coalesce(WK_DATPGT,to_date('01/01/1800','dd/mm/yyyy')),WK_DATINC))
                                                                                         ELSE GREATEST(coalesce(WK_DATPGT,to_date('01/01/1800','dd/mm/yyyy')),WK_DATINC)
                                  END, -- DATINC
                                  WK_FILCLI, WK_CODCLI, WK_CODSER, WK_NUMNOT,
                                  WK_DATVEN,
                                  case WHEN WK_FLGEST = 'P' THEN WK_DATPGT
                                                                       ELSE NULL



                                  END, -- DATPGT
                                  0,   -- VLRSAL
                                  CASE WHEN WK_FLGEST NOT IN ('C') THEN
                                       WK_VLRPGT
                                  ELSE
                                       WK_VLRLAN
                                  END * -1, -- VLRLAN
                                  COALESCE(WK_DESACR,0),
                                  WK_CODFIL, WK_SEQREC, WK_NUMPAR, WK_SUBPAR);
              vAUX:=CalcSaldoRazao(WK_FILCLI, WK_CODCLI,
                                  CASE WHEN WK_FLGEST IN ('C') THEN COALESCE(WK_ESTCAN,GREATEST(coalesce(WK_DATPGT,to_date('01/01/1800','dd/mm/yyyy')),WK_DATINC))



                                                                           ELSE GREATEST(coalesce(WK_DATPGT,to_date('01/01/1800','dd/mm/yyyy')),WK_DATINC)
                                  END,
                                  WK_SEQUEN);
              WK_PROCES := 2;
           END IF;
           IF WK_PROCES=2 AND (WK_FLGEST = 'X') THEN
              WK_SEQUEN:=ProximoCodigo('TT_RZR',WK_CODFIL);
              INSERT INTO TT_RZR (CODFIL, SEQUEN, DATINC, FILCLI, CODCLI, CODSER, NUMNOT,
                                  DATVEN, DATPGT, VLRSAL, VLRLAN, DESACR, FILREC,SEQREC,NUMREC,SUBREC)
                          VALUES (WK_CODFIL,
                                  WK_SEQUEN,



                                  COALESCE(WK_ESTCAN,
                                           GREATEST(coalesce(WK_DATPGT,
                                                             to_date('01/01/1800','dd/mm/yyyy'))
                                                    ,WK_DATINC)), -- DATINC
                                  WK_FILCLI, WK_CODCLI, WK_CODSER, WK_NUMNOT,
                                  WK_DATVEN,
                                  NULL, -- DATPGT
                                  0,   -- VLRSAL
                                  WK_VLRPGT, -- VLRLAN
                                  0, -- DESACR
                                  WK_CODFIL, WK_SEQREC, WK_NUMPAR, WK_SUBPAR);
              vAUX:=CalcSaldoRazao(WK_FILCLI, WK_CODCLI,
                                  COALESCE(WK_ESTCAN,GREATEST(coalesce(WK_DATPGT,to_date('01/01/1800','dd/mm/yyyy')),WK_DATINC)),
                                  WK_SEQUEN);
              WK_PROCES := 3;
           END IF;
      END IF;
      IF WK_CARTAO IS NOT NULL THEN
         WK_VLR_CARTAO := COALESCE(WK_VLR_CARTAO,0) + WK_PAR_CARTAO;
         WK_PROCES := 2;
      END IF;
      IF (WK_VLR_CARTAO <> 0) AND (WK_DATINC <> COALESCE(WK_AUX_DATINC,TO_DATE('01/01/1900','DD/MM/YYYY')))
         AND ((COALESCE(WK_FILADM,'000') <> COALESCE(WK_AUX_FILADM,'000')) OR (COALESCE(WK_CODADM,'000000') <> COALESCE(WK_AUX_CODADM,'000000'))) THEN
           WK_AUX_DATINC := WK_DATINC;
           WK_AUX_CARTAO := WK_CARTAO;

           WK_SEQUEN:=ProximoCodigo('TT_RZR',WK_CODFIL);
           INSERT INTO TT_RZR (CODFIL, SEQUEN, DATINC, FILCLI, CODCLI, CODCAR,
                               DATVEN, DATPGT, VLRSAL, VLRLAN, DESACR, FILREC,SEQREC,NUMREC,SUBREC)
                       VALUES (WK_CODFIL, WK_SEQUEN, WK_DATINC, WK_FILADM, WK_CODADM, WK_CARTAO,
                               WK_DATVEN, WK_DATPGT, 0, WK_VLR_CARTAO, 0, WK_CODFIL, WK_SEQREC, WK_NUMPAR, WK_SUBPAR);
           vAUX:=CalcSaldoRazao(WK_FILCLI, WK_CODCLI, WK_DATINC, WK_SEQUEN);

           WK_MESCRE := TO_NUMBER(TO_CHAR(WK_DATINC,'MM'));
           WK_ANOCRE := TO_NUMBER(TO_CHAR(WK_DATINC,'YYYY'));

           WK_PROXIMOMES := WK_MESCRE + 1;

           IF NVLZ(WK_DIACAR,WK_DIADEB) < TO_NUMBER(TO_CHAR(WK_DATINC,'DD')) THEN
              IF WK_MESCRE = 12 THEN
                 WK_DATINC := TO_DATE(TO_CHAR(NVLZ(WK_DIACAR,WK_DIADEB))||'/'||'01'||'/'||TO_CHAR(WK_ANOCRE + 1),'DD/MM/YYYY');
              ELSE
                 IF (NVLZ(WK_DIACAR,WK_DIADEB) > 28) AND (WK_MESCRE = 2) THEN
                   WK_DATINC := TO_DATE(TO_CHAR(28)||'/'||'01'||'/'||TO_CHAR(WK_ANOCRE + 1),'DD/MM/YYYY');
                 ELSE
                   IF (NVLZ(WK_DIACAR,WK_DIADEB) > 30) AND (WK_MESCRE IN (4, 6, 9, 11)) THEN
                     WK_DATINC := TO_DATE(TO_CHAR(30)||'/'||TO_CHAR(WK_PROXIMOMES)||'/'||TO_CHAR(WK_ANOCRE),'DD/MM/YYYY');
                   ELSE
                     IF (WK_PROXIMOMES = 2) AND (NVLZ(WK_DIACAR,WK_DIADEB) > 28) THEN
                        WK_DATINC := TO_DATE(TO_CHAR(28)||'/'||TO_CHAR(WK_PROXIMOMES)||'/'||TO_CHAR(WK_ANOCRE),'DD/MM/YYYY');
                     ELSE
                        IF (WK_PROXIMOMES IN (4, 6, 9, 11)) AND (NVLZ(WK_DIACAR,WK_DIADEB) > 30) THEN
                           WK_DATINC := TO_DATE(TO_CHAR(30)||'/'||TO_CHAR(WK_PROXIMOMES)||'/'||TO_CHAR(WK_ANOCRE),'DD/MM/YYYY');
                        ELSE
                           WK_DATINC := TO_DATE(TO_CHAR(NVLZ(WK_DIACAR,WK_DIADEB))||'/'||TO_CHAR(WK_PROXIMOMES)||'/'||TO_CHAR(WK_ANOCRE),'DD/MM/YYYY');
                        END IF;
                     END IF;
                   END IF;
                 END IF;
              END IF;
           ELSE
            IF (NVLZ(WK_DIACAR,WK_DIADEB) > 28) AND (WK_MESCRE = 2) THEN
                WK_DATINC := TO_DATE(TO_CHAR(28)||'/'||'01'||'/'||TO_CHAR(WK_ANOCRE + 1),'DD/MM/YYYY');
            ELSE
               IF (NVLZ(WK_DIACAR,WK_DIADEB) > 30) AND (WK_MESCRE IN (4, 6, 9, 11)) THEN
                 WK_DATINC := TO_DATE(TO_CHAR(30)||'/'||TO_CHAR(WK_MESCRE)||'/'||TO_CHAR(WK_ANOCRE),'DD/MM/YYYY');
               ELSE
                 WK_DATINC := TO_DATE(TO_CHAR(NVLZ(WK_DIACAR,WK_DIADEB))||'/'||TO_CHAR(WK_MESCRE)||'/'||TO_CHAR(WK_ANOCRE),'DD/MM/YYYY');
               END IF;
            END IF;
           END IF;

           WK_SEQUEN:=ProximoCodigo('TT_RZR',WK_CODFIL);
           INSERT INTO TT_RZR (CODFIL, SEQUEN, DATINC, FILCLI, CODCLI, CODCAR,
                               DATVEN, DATPGT, VLRSAL, VLRLAN, DESACR, FILREC,SEQREC,NUMREC,SUBREC)
                       VALUES (WK_CODFIL, WK_SEQUEN, WK_DATINC, WK_FILADM, WK_CODADM, WK_CARTAO,
                               WK_DATVEN, WK_DATPGT, 0, WK_VLR_CARTAO * -1, COALESCE(WK_DESACR,0), WK_CODFIL, WK_SEQREC, WK_NUMPAR, WK_SUBPAR);
           vAUX:=CalcSaldoRazao(WK_FILCLI, WK_CODCLI, WK_DATINC, WK_SEQUEN);

           WK_VLR_CARTAO := 0;
      END IF;
      UPDATE TT_REC SET PROCES = GREATEST(WK_PROCES,PROCES),
                        DUMMY = 'R'
       WHERE CODFIL = WK_CODFIL
         AND SEQUEN = WK_SEQREC
         AND NUMPAR = WK_NUMPAR
         AND SUBPAR = WK_SUBPAR;
   END LOOP;
   CLOSE CR_PARCELAS;

   RETURN '0K';
END;
$$ language 'plpgsql';





/*-- SEQ 1528 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ResumoVenPro (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TT_CFG.GIRO_ESTOQUE%TYPE,TR_MOV.PROMOC%TYPE) CASCADE;

/*-- SEQ 1529 --*/
CREATE OR REPLACE FUNCTION ResumoVenPro (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TT_CFG.GIRO_ESTOQUE%TYPE,TR_MOV.PROMOC%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pDatIni ALIAS FOR $1 ;
pDatFim ALIAS FOR $2 ;
pFilMat ALIAS FOR $3 ;
pCodMat ALIAS FOR $4 ;
pCodCor ALIAS FOR $5 ;
pCodTam ALIAS FOR $6 ;
pCodFil ALIAS FOR $7 ;
pTipDia ALIAS FOR $8 ;
pPromoc ALIAS FOR $9 ;
--  --------------------------------------------------------
--  Funcao que retorna um resumo das vendas do periodo informado para um determinado produto, como:
--      quantidade de vendas, quantidade de dias (uteis ou corridos). Estas informacoes sao uteis e
--      comuns para calculos de media, giro estoque, etc., e por isso foram centralizadas aqui, de
--      forma a reaproveitar e centralizar os codigos, facilitando a manutencao. Esta funcao retorna
--      estas informacoes de varias formas, como: dias corridos ou dias uteis com estoque, e dias
--      fora da promocao, dependendo dos parametros informados.
--
--  Return [VARCHAR(500)]
--      Esta funcao retorna uma string com uma lista de varias informacoes, separadas pelo sinal de
--      ponto e virgula (;) para serem utilizadas em outros calculos. Caso um valor seja nulo sera
--      retornado como uma string vazia. Seguem abaixo os valores retornados:
--      - Quantide Total de Dias do periodo (wiTotDia) no formato [000000];
--      - Quantidade Total Vendida (wfTotQtdVen) no formato [000000000000000.0000];
--      - Saldo do Estoque do Dia (para o giro do estoque) (wfTotSalDia) no formato [000000000000000.0000];
--      - Quantidade Total de Dias de Promocao do periodo (wiTotDiaPromoc) no formato [000000];
--      - Quantidade Total de Dias Sem Estoque do periodo (wiTotDiaSemEst) no formato [000000];
--      - Saldo do Custo Médio (wfSaldoCustoMedio) no formato [000000000000000.0000];
--      - Valor do Custo Médio (wfValorCustoMedio) no formato [000000000000000.0000];
--      - Valor do Custo Médio Gerencial (wfValorCustoMedioGerencial) no formato [000000000000000.0000];
--
--      NOTA: recomenda-se o uso da funcao Split_Part, e suas derivadas, para facilitar a leitura e
--      utilizacao dos valores da lista retornada. Mais informacoes sobre Split_Part em:
--      http://intra.totall.com.br:8080/wiki/index.php/Split_part
--
--  @pDatIni [Timestamp]
--      Data inicial do periodo no formato DD/MM/YYYY. as horas serao desprezadas e redefinidas como
--      00:00:00;
--  @pDatFim [Timestamp]
--      Data final do periodo no formato DD/MM/YYYY. as horas serao desprezadas e redefinidas como
--      23:59:59;
--  @pFilMat [char(3)]
--      Codigo da filial do material do produto (TT_GRA);
--  @pCodMat [char(5)]
--      Codigo do material do produto (TT_GRA);
--  @pCodCor [Numeric(5)]
--      Codigo da cor do produto (TT_GRA);
--  @pCodTam [Numeric(5)]
--      Codigo do tamanho do produto (TT_GRA);
--  @pCodFil [VARCHAR]
--      Codigo da filial do movimento. Caso nao informado serao listados os movimentos de todas as
--      filiais;
--  @pTipDia [char(1)] default [C]
--      Tipo do dia utilizado na leitura dos dados. as opcoes validas sao:
--      [C] dias corridos;
--      [A] dias com a loja aberta e com estoque;
--      Se este parametro receber qualquer valor difente de C ou A, uma excessao e levantada.
--  @pPromoc [VARCHAR(1)] default [T]
--      Indica se somente os dias em promocao serao consideradas. as opcoes validas sao:
--      [T] true/verdadeiro: somente dias em promocao;
--      [F] false/falso: todos os dias;
--      Se este parametro receber qualquer valor difente de T ou F, uma excessao e levantada.
--  --------------------------------------------------------
   wvResult                      VARCHAR(500);                 --  retorno da função
   wcCodLoj                      TT_IDF.CODLOJ%TYPE;           --  char(3): cod. loja, em algumas situacoes substitui o cod. filial
   wdIni                         Timestamp;                         --  data inicial do periodo com as horas
   wdFim                         Timestamp;                         --  data final do periodo com as horas
   wdAnt                         Timestamp;                         --  data (do registro) anterior
   wvPromocAnt                   TR_MOV.PROMOC%TYPE;           --  VARCHAR(1): promocao (do registro) anterior
   wbRegValido                   BOOLEAN;                      --  indicador de registro valido
   wfTotSalDia                   Numeric;                         --  totalizador do saldo do dia
   wfTotQtdVen                   Numeric;                         --  totalizador da quant. vendida
   wiIntDia                      INTEGER;                      --  totalizador da quant. de dias do intervalo usado no loop
   wiTotDia                      INTEGER;                      --  totalizador da quant. de dias
   wiTotDiaPromoc                INTEGER;                      --  totalizador da quant. de dias em promocao
   wiTotDiaSemEst                INTEGER;                      --  totalizador da quant. de dias sem estoque
   wdPrimeiroLancto              Timestamp;                         --  data da primeira movimentação
   wfSaldoCustoMedio             Numeric;                         --  saldo do custo médio
   wfValorCustoMedio             Numeric;                         --  valor do custo médio
   wfValorCustoMedioGerencial    Numeric;                         --  valor do custo médio gerencial
   --  vars para leitura do crMov
   fdDatMov                      TR_MOV.DATMOV%TYPE;           --  Timestamp:
   ffSalAnt                      TR_MOV.SALANT%TYPE;           --  Numeric(12,4):
   ffSalEst                      TR_MOV.SALANT%TYPE;           --  Numeric(12,4):
   ffQtdVen                      TR_MOV.QTDVEN%TYPE;           --  Numeric(12,4);
   fvPromoc                      TR_MOV.PROMOC%TYPE;           --  VARCHAR(1):
   ffSaldoCustoMedio             TR_MOV.SAL_CM%TYPE;           --  Numeric(16,4);
   ffValorCustoMedio             TR_MOV.VLR_CM%TYPE;           --  Numeric(16,4);
   ffValorCustoMedioGerencial    TR_MOV.VLRCMG%TYPE;           --  Numeric(16,4);
    
    --  cursor para listar os movimentos do produtos no periodo de acordo com os parametros:
    crMov CURSOR(pcDatIni Timestamp,
           pcDatFim Timestamp) IS
    select pcDatIni as DATMOV,
           0 as SALANT,
           0 as SALEST,
           0 as QTDVEN,
           'F' as PROMOC,
           0 as SAL_CM,
           0 as VLR_CM,
           0 as VLRCMG
      from DUAL
     where pcDatIni < 
           (select Min(RMOV.DATMOV)
              from TR_MOV RMOV
             where INSTR(COALESCE(pCodFil, RMOV.CODFIL)||';', RMOV.CODFIL||';') > 0
               and RMOV.FILMAT = pFilMat
               and RMOV.CODMAT = pCodMat
               and RMOV.CODCOR = pCodCor
               and RMOV.CODTAM = pCodTam
               and RMOV.DATMOV between pcDatIni and pcDatFim
           ) 
    union  all
    select TAB1.DATMOV,
           TAB1.SALANT,
           (TAB1.SALANT + TAB1.QTDENT) as SALEST,
           TAB1.QTDVEN,
           case
               when TAB1.QTD_PROMOC > TAB1.QTD_NORMAL then 'T' 
               else 'F' 
           end as PROMOC,
           TAB1.SAL_CM,
           TAB1.VLR_CM,
           TAB1.VLRCMG
      from (select RMOV.DATMOV,
                   Min(SaldoGeral(Add_Day(RMOV.DATMOV, -1), RMOV.FILMAT, RMOV.CODMAT, RMOV.CODCOR, RMOV.CODTAM, pCodFil)) as SALANT,
                   Sum(Coalesce(RMOV.QTDCOM, 0) + Coalesce(RMOV.QTDOUT, 0)) as QTDENT,
                   Sum(Coalesce(RMOV.QTDVEN, 0)) as QTDVEN,
                   Sum(case when RMOV.PROMOC = 'T' then Coalesce(RMOV.QTDVEN, 0) else 0 end) as QTD_PROMOC,
                   Sum(case when RMOV.PROMOC = 'F' then Coalesce(RMOV.QTDVEN, 0) else 0 end) as QTD_NORMAL,
                   Sum(Coalesce(RMOV.SAL_CM, 0)) as SAL_CM,
                   Sum(Coalesce(RMOV.VLR_CM, 0)) as VLR_CM,
                   Sum(Coalesce(RMOV.VLRCMG, 0)) as VLRCMG
              from TR_MOV RMOV
             where INSTR(COALESCE(pCodFil, RMOV.CODFIL)||';', RMOV.CODFIL||';') > 0
               and RMOV.FILMAT = pFilMat
               and RMOV.CODMAT = pCodMat
               and RMOV.CODCOR = pCodCor
               and RMOV.CODTAM = pCodTam
               and RMOV.DATMOV between pcDatIni and pcDatFim
             group by RMOV.DATMOV
           ) TAB1
    union  all
    select TAB2.DATMOV,
           TAB2.SALANT,
           TAB2.SALANT as SALEST, -- mesmo valor que SALANT pois e um registro virtual que mostra o saldo final do produto no periodo
           0 as QTDVEN,
           case when TAB2.QTD_PROMOC > TAB2.QTD_NORMAL then 'T' else 'F' end as PROMOC,
           0 as SAL_CM,--TAB2.SAL_CM,
           0 as VLR_CM,--TAB2.VLR_CM,
           0 as VLRCMG --TAB2.VLRCMG
      from (select Add_Day(pcDatFim, 1) as DATMOV,
                   Min(SaldoGeral(pcDatFim, FILMAT, CODMAT, CODCOR, CODTAM, pCodFil)) as SALANT,
                   Sum(case when PROMOC = 'T' then Coalesce(QTDVEN,0) else 0 end) as QTD_PROMOC,
                   Sum(case when PROMOC = 'F' then Coalesce(QTDVEN,0) else 0 end) as QTD_NORMAL--,
                   --Sum(Coalesce(RMOV.SAL_CM, 0)) as SAL_CM,
                   --Sum(Coalesce(RMOV.VLR_CM, 0)) as VLR_CM,
                   --Sum(Coalesce(RMOV.VLRCMG, 0)) as VLRCMG
              from TR_MOV RMOV, 
                   (select Max(LMOV.DATMOV) as DATMOV
                      from TR_MOV LMOV
                     where INSTR(COALESCE(pCodFil, LMOV.CODFIL)||';', LMOV.CODFIL||';') > 0
                       and LMOV.FILMAT = pFilMat
                       and LMOV.CODMAT = pCodMat
                       and LMOV.CODCOR = pCodCor
                       and LMOV.CODTAM = pCodTam
                       and LMOV.DATMOV BETWEEN pcDatIni and pcDatFim
                   ) DAT
             where INSTR(COALESCE(pCodFil, RMOV.CODFIL)||';', RMOV.CODFIL||';') > 0
               and RMOV.FILMAT = pFilMat
               and RMOV.CODMAT = pCodMat
               and RMOV.CODCOR = pCodCor
               and RMOV.CODTAM = pCodTam
               and RMOV.DATMOV = DAT.DATMOV
             group by Add_Day(pcDatFim, 1)
             order by DATMOV
           ) TAB2
    ;

   -- Busca a Data do primeiro Movimento
   MovtoInicial CURSOR(pFilMatMov TT_GRA.FILMAT%TYPE,
           pCodMatMov TT_GRA.CODMAT%TYPE,
           pCodCorMov TT_GRA.CODCOR%TYPE,
           pCodTamMov TT_GRA.CODTAM%TYPE,
           pCodFilMov VARCHAR) IS
   SELECT MIN( RMOV.DATMOV )
     FROM TR_MOV RMOV
    WHERE RMOV.FILMAT = pFilMatMov
      AND RMOV.CODMAT = pCodMatMov
      AND RMOV.CODCOR = pCodCorMov
      AND RMOV.CODTAM = pCodTamMov
      AND INSTR(COALESCE(pCodFilMov, RMOV.CODFIL)||';', RMOV.CODFIL||';') > 0;
--  --------------------------------------------------------
begin
    --  tratando o parametro pTipDia
    if  pTipDia not in ('C','A') then
        RAISE EXCEPTION 'PG-20000 Valor inválido para parâmetro "pTipDia".';
    end if;
    --  tratando o parametro pPromoc
    if  pPromoc not in ('T','F') then
        RAISE EXCEPTION 'PG-20000 Valor inválido para parâmetro "pPromoc".';
    end if;

    --  ajustando o periodo com as horas
    wdIni := To_Date(To_Char(Trunc(pDatIni), 'DD/MM/YYYY')||' 00:00:00', 'dd/mm/yyyy HH24:MI:SS');
    wdFim := To_Date(To_Char(Trunc(pDatFim), 'DD/MM/YYYY')||' 23:59:59', 'dd/mm/yyyy HH24:MI:SS');

   -- Procura a primeira movimentacao do produto
   -- (Caso um produto seja incluso apos a DataIni, ajusta-se a DataIni evitando distorcoes)
   -- Utilizado no calculo do intevalo de dias
   Open MovtoInicial(pFilMat, pCodMat, pCodCor, pCodTam, pCodFil);
   Fetch MovtoInicial into wdPrimeiroLancto;
   IF NOT NOT FOUND THEN
      IF wdPrimeiroLancto > wdIni THEN
         wdIni := wdPrimeiroLancto;
      END IF;
   END IF;
   Close MovtoInicial;

    --  buscando o codigo da loja
    select CODLOJ
      into wcCodLoj
      from TT_IDF;
    --  buscando o total de dias do periodo
    if  pTipDia = 'C' then
        --  dias corridos
        wiTotDia := IntervaloDias(Trunc(wdFim), Trunc(wdIni)) + 1;
    else
        --  dias uteis
        wiTotDia := DiasUteis(Coalesce(pCodFil, wcCodLoj), wdIni, wdFim, 'T');
    end if;
    --  inicializando vars
    wdAnt                      := null;
    wfTotSalDia                := 0;
    wfTotQtdVen                := 0;
    wiTotDiaPromoc             := 0;
    wiTotDiaSemEst             := 0;
    wfSaldoCustoMedio          := 0;
    wfValorCustoMedio          := 0;
    wfValorCustoMedioGerencial := 0;
    --  abrindo e percorrendo os registros do cursor
    open crMov(Trunc(wdIni), Trunc(wdFim));  --  o Trunc e porque a TR_MOV nao tem horas
    loop
        fetch crMov into fdDatMov, ffSalAnt, ffSalEst, ffQtdVen, fvPromoc, ffSaldoCustoMedio, ffValorCustoMedio, ffValorCustoMedioGerencial;
        exit when NOT FOUND;
        wbRegValido := true;
        if  ffSalAnt < 0 then
            ffSalAnt := 0;
        end if;

         --  desconsidera registro se o dia e promocao e se o parametro de promocao for false
         if  ( fvPromoc = 'T' )
         and ( pPromoc  = 'F' ) then
             wbRegValido := false;
         end if;
         --  soma a quantidade vendida
         if  ( wbRegValido ) then
              wfTotQtdVen := wfTotQtdVen + ffQtdVen;
         end if;

        if  pTipDia = 'C' then
            --  [C] dias corridos
            wiIntDia := Coalesce(IntervaloDias(Trunc(fdDatMov), Trunc(wdAnt)), 0);
            --  a partir do segundo registro do cursor
            if ( wdAnt is not null ) then
               if  wiIntDia <= 0 then
                   wiIntDia := 1;
               end if;
               --  se for dia em promocao e deve considerar apenas dias fora da promocao
               if  ( wvPromocAnt = 'T' )
               and ( pPromoc     = 'F' ) then
                   wiTotDiaPromoc := wiTotDiaPromoc + wiIntDia;
               end if;

               if  ( wiIntDia > 0 ) then
                   --  soma saldo do dia multiplicado pelos dias sem TR_MOV
                   --  soma saldo se dia anterior nao era promocional ou se parametro de promocao e true
                   --  soma valores de Custo Médio
                   if  ( wvPromocAnt = 'F' )
                   or  ( pPromoc     = 'T' ) then
                       wfTotSalDia                := wfTotSalDia + (ffSalAnt * wiIntDia);
                       wfSaldoCustoMedio          := wfSaldoCustoMedio          + (ffSaldoCustoMedio * wiIntDia);
                       wfValorCustoMedio          := wfValorCustoMedio          + (ffValorCustoMedio * wiIntDia);
                       wfValorCustoMedioGerencial := wfValorCustoMedioGerencial + (ffValorCustoMedioGerencial * wiIntDia);
                   end if;
               end if;
            else
               -- No caso do Custo Médio, o cálculo é feito de toda forma
               if ( wbRegValido ) then
                  wfSaldoCustoMedio           := wfSaldoCustoMedio          + ffSaldoCustoMedio;
                  wfValorCustoMedio           := wfValorCustoMedio          + ffValorCustoMedio;
                  wfValorCustoMedioGerencial  := wfValorCustoMedioGerencial + ffValorCustoMedioGerencial;	
               end if;
            end if;
        else
            --  [A] dias com a loja aberta e com estoque
            wiIntDia := Coalesce(DiasUteis(Coalesce(pCodFil, wcCodLoj), wdAnt, Add_Day(fdDatMov, -1), 'T'), 0);
            --  a partir do segundo registro do cursor
            if ( wdAnt is not null ) then
               if  wiIntDia <= 0 then
                   wiIntDia := 1;
               end if;
               if  ( wiIntDia > 0 ) then
                   --  se o saldo anterior estiver zerado, considera o intervalo de dias uteis como sendo "sem estoque" e acumula
                   if  ffSalAnt <= 0 then
                       wiTotDiaSemEst := wiTotDiaSemEst + wiIntDia;
                   --  se o dia anterior era promocao, considera o intervalo de dias uteis como sendo promocionais e acumula
                   elsif ( wvPromocAnt = 'T' )
                   and   ( pPromoc     = 'F' ) then
                       wiTotDiaPromoc := wiTotDiaPromoc + wiIntDia;
                   end if;
                   
                   --  soma saldo do dia multiplicado pelos dias sem TR_MOV 
                   --  soma saldo se dia anterior nao era promocional ou se parametro de promocao e true
                   --  soma valores de Custo Médio
                   if  ( wvPromocAnt = 'F' )
                   or  ( pPromoc     = 'T' ) then
                       wfTotSalDia                :=  wfTotSalDia + (ffSalAnt * wiIntDia);
                       wfSaldoCustoMedio          := wfSaldoCustoMedio          + (ffSaldoCustoMedio * wiIntDia);
                       wfValorCustoMedio          := wfValorCustoMedio          + (ffValorCustoMedio * wiIntDia);
                       wfValorCustoMedioGerencial := wfValorCustoMedioGerencial + (ffValorCustoMedioGerencial * wiIntDia);
                   end if;
               end if;
            else
               -- No caso do Custo Médio, o cálculo é feito de toda forma
               if ( wbRegValido ) then
                  wfSaldoCustoMedio           := wfSaldoCustoMedio          + ffSaldoCustoMedio;
                  wfValorCustoMedio           := wfValorCustoMedio          + ffValorCustoMedio;
                  wfValorCustoMedioGerencial  := wfValorCustoMedioGerencial + ffValorCustoMedioGerencial;	
               end if;
            end if;
        end if;
        --  guardando a data e a promocao do registro atual
        wdAnt := fdDatMov;
        wvPromocAnt := fvPromoc;
    end loop;
    close crMov;
    --  subtrai os dias em promocao e sem estoque do total de dias
    wiTotDia    := wiTotDia - wiTotDiaPromoc - wiTotDiaSemEst;
    /*  Usado para "debug" em Postgres - Retirar comentario apenas para testes
    
    raise notice ''wiTotDiaPromoc=%'',wiTotDiaPromoc;
    raise notice ''wiTotDiaSemEst=%'',wiTotDiaSemEst;
    raise notice ''wfTotQtdVen=%'',wfTotQtdVen;
    raise notice ''wiTotDia=%'',wiTotDia;
    raise notice ''wfTotSalDia=%'',wfTotSalDia;
    raise notice ''wfSaldoCustoMedio=%'', wfSaldoCustoMedio;
    raise notice ''wfValorCustoMedio=%'', wfValorCustoMedio;
    raise notice ''wfValorCustoMedioGerencial=%'', wfValorCustoMedioGerencial;
        */ 
--  --------------------------------------------------------
    wvResult := --'OK';
        --  total de dias do periodo
        to_char(wiTotDia, '000000')                                     || ';' ||
        --  total vendido
        to_char(wfTotQtdVen, '000000000000000.0000')                    || ';' ||
        --  saldo do dia (para o giro do estoque)
        to_char(wfTotSalDia, '000000000000000.0000')                    || ';' ||
        --  total de dias de promocao do periodo
        to_char(wiTotDiaPromoc, '000000')                               || ';' ||
        --  total de dias sem estoque do periodo
        to_char(wiTotDiaSemEst, '000000')                               || ';' ||
        -- total saldo custo médio
        to_char(wfSaldoCustoMedio, '000000000000000.0000')              || ';' ||
        -- total valor custo médio
        to_char(wfValorCustoMedio, '000000000000000.0000')              || ';' ||
        -- total valor custo médio gerencial
        to_Char(wfValorCustoMedioGerencial, '000000000000000.0000');
    return wvResult;
END;
$$ language 'plpgsql';


/*-- SEQ 1530 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ResumoVenPro (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1531 --*/
CREATE OR REPLACE FUNCTION ResumoVenPro (Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR) 
RETURNS VARCHAR AS $$
BEGIN
RETURN ResumoVenPro($1,$2,$3,$4,$5,$6,$7,'C','T');
END;
$$ language 'plpgsql';


/*-- SEQ 1532 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_FER_AtualizaUTL (TT_FER.DIAFER%TYPE,TT_FER.MESFER%TYPE,TT_FER.ANOFER%TYPE,TT_FER.FILFER%TYPE,TT_FER.LOJABR%TYPE,CHAR) CASCADE;

/*-- SEQ 1533 --*/
CREATE OR REPLACE FUNCTION TGR_FER_AtualizaUTL (TT_FER.DIAFER%TYPE,TT_FER.MESFER%TYPE,TT_FER.ANOFER%TYPE,TT_FER.FILFER%TYPE,TT_FER.LOJABR%TYPE,CHAR)
RETURNS CHAR AS $$
DECLARE
p_DIAFER ALIAS FOR $1 ;
p_MESFER ALIAS FOR $2 ;
p_ANOFER ALIAS FOR $3 ;
p_FILFER ALIAS FOR $4 ;
p_LOJABR ALIAS FOR $5 ;
p_Operacao ALIAS FOR $6 ;

-- Objetivos:
-- 1. Atualizar TT_UTL conforme configuração do feriado e operação solicitada
-- D - DELETE
-- I - INSERT
-- U - UPDATE

cDUMMY VARCHAR(2);
cCODFIL TD_FIL.CODFIL%TYPE;
dDATOPE TT_UTL.DATOPE%TYPE;
vVem_de_TGFER CONSTANT VARCHAR(1) := Constante('VEM_DE_TGFER');

CR_Filiais CURSOR FOR
SELECT CODFIL
  FROM TD_FIL
 ORDER BY CODFIL;

CR_DiaMes CURSOR(pDia TT_FER.DIAFER%TYPE,
           pMes TT_FER.MESFER%TYPE) IS
SELECT DATOPE
  FROM TT_DAT
 WHERE TO_CHAR(DATOPE,'DDMM') = TO_CHAR(LPAD(TO_CHAR(pDia),2,'00')||LPAD(TO_CHAR(pMes),2,'00'));
 
-- Início da função
BEGIN
  IF p_Operacao = 'D' THEN
    -- exclui de todas as filiais
    IF ISNULL(p_FILFER) = 'T' THEN
      OPEN CR_Filiais;
      LOOP
        FETCH CR_Filiais INTO cCODFIL;
        EXIT WHEN NOT FOUND;
    
        -- procura pelo dia/mês
        IF COALESCE(p_ANOFER,0) = 0 THEN
          OPEN CR_DiaMes(p_DIAFER,p_MESFER);
          LOOP
            FETCH CR_DiaMes INTO dDATOPE;
            EXIT WHEN NOT FOUND;
    
            -- elimina data da posição atual do cursor
            DELETE FROM TT_UTL
             WHERE CODFIL = cCODFIL
               AND DATOPE = dDATOPE;
    
          END LOOP;
          CLOSE CR_DiaMes;
        -- exclui pela data completa
        ELSE
          dDATOPE := TO_DATE(LPAD(TO_CHAR(p_DIAFER),2,'0')||'/'||LPAD(TO_CHAR(p_MESFER),2,'0')||'/'||LPAD(TO_CHAR(p_ANOFER),4,'0'),'DD/MM/YYYY');
    
          DELETE FROM TT_UTL
           WHERE CODFIL = cCODFIL
             AND DATOPE = dDATOPE;
        END IF;
    
      END LOOP;
      CLOSE CR_Filiais;
    -- exclui apenas a filial informada
    ELSE
      cCODFIL := p_FILFER;
      -- procura pelo dia/mês
      IF COALESCE(p_ANOFER,0) = 0 THEN
        OPEN CR_DiaMes(p_DIAFER,p_MESFER);
        LOOP
          FETCH CR_DiaMes INTO dDATOPE;
          EXIT WHEN NOT FOUND;
    
          DELETE FROM TT_UTL
           WHERE CODFIL = cCODFIL
             AND DATOPE = dDATOPE;
    
        END LOOP;
        CLOSE CR_DiaMes;
      -- exclui pela data completa
      ELSE
        dDATOPE := TO_DATE(LPAD(TO_CHAR(p_DIAFER),2,'0')||'/'||LPAD(TO_CHAR(p_MESFER),2,'0')||'/'||LPAD(TO_CHAR(p_ANOFER),4,'0'),'DD/MM/YYYY');
        DELETE FROM TT_UTL
           WHERE CODFIL = cCODFIL
             AND DATOPE = dDATOPE;
      END IF;
    END IF;  
  ELSE
    -- insere para todas as filiais
    IF ISNULL(p_FILFER) = 'T' THEN
      OPEN CR_Filiais;
      LOOP
        FETCH CR_Filiais INTO cCODFIL;
        EXIT WHEN NOT FOUND;

        -- procura pelo dia/mês
        IF COALESCE(p_ANOFER,0) = 0 THEN
          OPEN CR_DiaMes(p_DIAFER,p_MESFER);
          LOOP
            FETCH CR_DiaMes INTO dDATOPE;
            EXIT WHEN NOT FOUND;

            cDUMMY := InsereDiasUteisFilial(cCODFIL,dDATOPE,dDATOPE,p_LOJABR,vVem_de_TGFER);

          END LOOP;
          CLOSE CR_DiaMes;
        -- insere pela data completa
        ELSE
          dDATOPE := TO_DATE(LPAD(TO_CHAR(p_DIAFER),2,'0')||'/'||LPAD(TO_CHAR(p_MESFER),2,'0')||'/'||LPAD(TO_CHAR(p_ANOFER),4,'0'),'DD/MM/YYYY');
          cDUMMY := InsereDiasUteisFilial(cCODFIL,dDATOPE,dDATOPE,p_LOJABR,vVem_de_TGFER);
        END IF;

      END LOOP;
      CLOSE CR_Filiais;
    -- insere apenas para a filial informada
    ELSE
      cCODFIL := p_FILFER;
      -- procura pelo dia/mês
      IF COALESCE(p_ANOFER,0) = 0 THEN
        OPEN CR_DiaMes(p_DIAFER,p_MESFER);
        LOOP
          FETCH CR_DiaMes INTO dDATOPE;
          EXIT WHEN NOT FOUND;

          cDUMMY := InsereDiasUteisFilial(cCODFIL,dDATOPE,dDATOPE,p_LOJABR,vVem_de_TGFER);

        END LOOP;
        CLOSE CR_DiaMes;
      -- insere pela data completa
      ELSE
        dDATOPE := TO_DATE(LPAD(TO_CHAR(p_DIAFER),2,'0')||'/'||LPAD(TO_CHAR(p_MESFER),2,'0')||'/'||LPAD(TO_CHAR(p_ANOFER),4,'0'),'DD/MM/YYYY');                            
        cDUMMY := InsereDiasUteisFilial(cCODFIL,dDATOPE,dDATOPE,p_LOJABR,vVem_de_TGFER);
      END IF;
    END IF;   
  END IF;
  
  RETURN 'OK';

END;
$$ language 'plpgsql';




/*-- SEQ 1534 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Classifica_ABC_XYZ () CASCADE;

/*-- SEQ 1535 --*/
CREATE OR REPLACE FUNCTION Classifica_ABC_XYZ ()
RETURNS VARCHAR AS $$
DECLARE


/*
-- Objetivos:

  1. Classificar produtos pelas regras ABC e XYZ, que podem ser:
   a) Custo x Quantidade
   b) Número de Vendas

  Pela regra Custo x Quantidade, a classificação será a multiplicação do custo médio fiscal pela quantidade vendida.
  A = Custo mais alto
  B = Custo intermediário
  C = Custo mais baixo

  A outra regra é pelo Número de Vendas.
  X = Mais vendido
  Y = Intermediário
  Z = Menos vendido
*/
/*
-- Declaração de variáveis e cursores
   cMANUT                        TT_IDF.MANUT%TYPE;
   cComplemento                  CONSTANT VARCHAR(254) := Constante('complemento');
   c_Classificacao               TT_GRA.GRAABC%TYPE;

   n_REGRA_CLSABC                TT_CFG.REGRA_CLSABC%TYPE; -- Código da regra ABC
   n_REGRA_CLSXYZ                TT_CFG.REGRA_CLSXYZ%TYPE; -- Código da regra XYZ

   n_DIAS_ABC_XYZ                Numeric(10); -- Dias para análise das curvas ABC/XYZ
   n_QTD_A                       Numeric(14,4); -- Quantidade de itens "A"
   n_QTD_B                       Numeric(14,4); -- Quantidade de itens "B"
   n_QTD_C                       Numeric(14,4); -- Quantidade de itens "C"
   n_QTD_X                       Numeric(14,4); -- Quantidade de itens "X"
   n_QTD_Y                       Numeric(14,4); -- Quantidade de itens "Y"
   n_QTD_Z                       Numeric(14,4); -- Quantidade de itens "Z"
   n_QTD_TOT                     Numeric(14,4); -- Quantidade total de itens
   n_Contador                    Numeric(14,4); -- Contador para classificação dos registros

   n_SomaABC                     Numeric(5,2); -- Soma dos percentuais ABC
   n_SomaXYZ                     Numeric(5,2); -- Soma dos percentuais XYZ

   c_FILMAT                      TT_GRA.FILMAT%TYPE;
   c_CODMAT                      TT_GRA.CODMAT%TYPE;
   n_CODCOR                      TT_GRA.CODCOR%TYPE;
   n_CODTAM                      TT_GRA.CODTAM%TYPE;
   nQtdItem                      Numeric(14,4);

-- Retorna o total de itens e participação de cada fator da regra "Custo x Quantidade" do período configurado
   CR_CustoxQuantidade_Total CURSOR FOR
   SELECT TAB.C,                                 -- QUANTIDADE TOTAL DE ITENS
          ROUND((TAB.C*CFG.PER_A/100)) AS QTD_A, -- PARTICIPACAO DE A
          ROUND((TAB.C*CFG.PER_B/100)) AS QTD_B, -- PARTICIPACAO DE B
          ROUND((TAB.C*CFG.PER_C/100)) AS QTD_C, -- PARTICIPACAO DE C
          ROUND((TAB.C*CFG.PER_X/100)) AS QTD_X, -- PARTICIPACAO DE X
          ROUND((TAB.C*CFG.PER_Y/100)) AS QTD_Y, -- PARTICIPACAO DE Y
          ROUND((TAB.C*CFG.PER_Z/100)) AS QTD_Z  -- PARTICIPACAO DE Z
     FROM (
         SELECT SUM(TOTAL) AS C
           FROM (
            SELECT SUB.FILMAT,SUB.CODMAT,SUB.CODCOR,SUB.CODTAM,ROUND(COALESCE(SUM(SUB.CUSMED*SUB.VENFIS),0),4) AS TOTAL
              FROM (
                     SELECT SAL.FILMAT,
                            SAL.CODMAT,
                            SAL.CODCOR,
                            SAL.CODTAM,
                            DAT.DATOPE,
                            COALESCE(MAX(CUSTOMEDIO(SAL.CODFIL, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, 3, DAT.DATOPE)),0) AS CUSMED,
                            SUM(TotalVenda(DAT.DATOPE, DAT.DATOPE, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, SAL.CODFIL, 0)) AS VENFIS
                       FROM TT_SAL SAL CROSS JOIN TT_DAT DAT
                      WHERE DAT.DATOPE >= ADD_DAY(TRUNC(Agora()),n_DIAS_ABC_XYZ*-1)
                        AND DAT.DATOPE <= TRUNC(Agora())
                        AND TotalVenda(DAT.DATOPE, DAT.DATOPE, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, SAL.CODFIL, 0) > 0
                        AND SAL.CODMUL = 0
                      GROUP BY SAL.CODFIL,
                               SAL.FILMAT,
                               SAL.CODMAT,
                               SAL.CODCOR,
                               SAL.CODTAM,
                               DAT.DATOPE
                   ) SUB
             WHERE SUB.CUSMED > 0
             GROUP BY SUB.FILMAT,SUB.CODMAT,SUB.CODCOR,SUB.CODTAM
         ) SUB2
   ) TAB CROSS JOIN TT_CFG CFG;

-- Retorna a regra Custo x Quantidade por produto, ordenado do maior para o menor
   CR_CustoxQuantidade_Detalhe CURSOR FOR
   SELECT TAB.FILMAT,TAB.CODMAT,TAB.CODCOR,TAB.CODTAM,TAB.TOTAL
     FROM(
         SELECT SUB.FILMAT,SUB.CODMAT,SUB.CODCOR,SUB.CODTAM,ROUND(COALESCE(SUM(SUB.CUSMED*SUB.VENFIS),0),4) AS TOTAL,
                SUB.DATCAD
           FROM (
                  SELECT SAL.FILMAT,
                         SAL.CODMAT,
                         SAL.CODCOR,
                         SAL.CODTAM,
                         DAT.DATOPE,
                         COALESCE(MAX(CUSTOMEDIO(SAL.CODFIL, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, 3, DAT.DATOPE)),0) AS CUSMED,
                         SUM(TotalVenda(DAT.DATOPE, DAT.DATOPE, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, SAL.CODFIL, 0)) AS VENFIS,
                         PRO.DATCAD
                    FROM TT_SAL SAL INNER JOIN TT_PRO PRO ON PRO.FILMAT = SAL.FILMAT
                                                         AND PRO.CODMAT = SAL.CODMAT
                                    CROSS JOIN TT_DAT DAT
                   WHERE DAT.DATOPE >= ADD_DAY(TRUNC(Agora()),n_DIAS_ABC_XYZ*-1)
                     AND DAT.DATOPE <= TRUNC(Agora())
                     AND TotalVenda(DAT.DATOPE, DAT.DATOPE, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, SAL.CODFIL, 0) > 0
                     AND SAL.CODMUL = 0
                   GROUP BY SAL.CODFIL,
                            SAL.FILMAT,
                            SAL.CODMAT,
                            SAL.CODCOR,
                            SAL.CODTAM,
                            DAT.DATOPE,
                            PRO.DATCAD
                ) SUB
          WHERE SUB.CUSMED > 0
          GROUP BY SUB.FILMAT,SUB.CODMAT,SUB.CODCOR,SUB.CODTAM,SUB.DATCAD
          ) TAB
    ORDER BY TAB.TOTAL DESC, TAB.DATCAD, TAB.FILMAT, TAB.CODMAT, TAB.CODCOR, TAB.CODTAM;

-- Retorna o total de itens e participação de cada fator da regra "Número de Vendas" do período configurado
   CR_NumeroVendas_Total CURSOR FOR
   SELECT TAB.C,                                 -- QUANTIDADE TOTAL DE ITENS
          ROUND((TAB.C*CFG.PER_A/100)) AS QTD_A, -- PARTICIPACAO DE A
          ROUND((TAB.C*CFG.PER_B/100)) AS QTD_B, -- PARTICIPACAO DE B
          ROUND((TAB.C*CFG.PER_C/100)) AS QTD_C, -- PARTICIPACAO DE C
          ROUND((TAB.C*CFG.PER_X/100)) AS QTD_X, -- PARTICIPACAO DE X
          ROUND((TAB.C*CFG.PER_Y/100)) AS QTD_Y, -- PARTICIPACAO DE Y
          ROUND((TAB.C*CFG.PER_Z/100)) AS QTD_Z  -- PARTICIPACAO DE Z
     FROM (
           SELECT SUM(NUMVEN) AS C
             FROM (
                   SELECT NumeroVendas(ADD_DAY(TRUNC(Agora()),n_DIAS_ABC_XYZ*-1), TRUNC(Agora()), SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, NULL, 0) AS NUMVEN
                     FROM TT_SAL SAL
                    WHERE SAL.CODMUL = 0
                      AND SAL.CODFIL = (SELECT IDF.CODLOJ FROM TT_IDF IDF) -- Cursor baseado na SAL para poder fazer update na GRA sem problema
                      AND NumeroVendas(ADD_DAY(TRUNC(Agora()),n_DIAS_ABC_XYZ*-1), TRUNC(Agora()), SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, NULL, 0) > 0
           ) SUB
   ) TAB CROSS JOIN TT_CFG CFG;

-- Retorna o Número de Vendas por produto, ordenado do maior para o menor
   CR_NumeroVendas_Detalhe CURSOR FOR
   SELECT TAB.FILMAT,TAB.CODMAT,TAB.CODCOR,TAB.CODTAM,TAB.NUMVEN
     FROM (
           SELECT SAL.FILMAT,
                  SAL.CODMAT,
                  SAL.CODCOR,
                  SAL.CODTAM,
                  NumeroVendas(ADD_DAY(TRUNC(Agora()),n_DIAS_ABC_XYZ*-1), TRUNC(Agora()), SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, NULL, 0) AS NUMVEN,
                  PRO.DATCAD
             FROM TT_SAL SAL INNER JOIN TT_PRO PRO ON PRO.FILMAT = SAL.FILMAT
                                                  AND PRO.CODMAT = SAL.CODMAT
            WHERE SAL.CODMUL = 0
              AND SAL.CODFIL = (SELECT IDF.CODLOJ FROM TT_IDF IDF) -- Cursor baseado na SAL para poder fazer update na GRA sem problema
              AND NumeroVendas(ADD_DAY(TRUNC(Agora()),n_DIAS_ABC_XYZ*-1), TRUNC(Agora()), SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, NULL, 0) > 0
          ) TAB
    ORDER BY TAB.NUMVEN DESC, TAB.DATCAD, TAB.FILMAT, TAB.CODMAT, TAB.CODCOR, TAB.CODTAM;
*/
-- Início da função
BEGIN
/*
  SELECT MANUT INTO cMANUT
    FROM TT_IDF;

  IF cMANUT = 'T' THEN
     RAISE EXCEPTION 'PG-20010 Base em manutencao %' , cComplemento;
  END IF;

  SELECT REGRA_CLSABC, REGRA_CLSXYZ, DIAS_ABC_XYZ,
         (PER_A+PER_B+PER_C),
         (PER_X+PER_Y+PER_Z)
    INTO n_REGRA_CLSABC, n_REGRA_CLSXYZ, n_DIAS_ABC_XYZ,
         n_SomaABC, n_SomaXYZ FROM TT_CFG;

  -- Se Regra ABC for "0 - NAO USA" e
  -- Se Regra XYZ for "0 - NAO USA" não precisa calcular
  -- Não calcula se soma dos percentuais for diferente de 100%
  IF ((n_REGRA_CLSABC > 0) OR (n_REGRA_CLSXYZ > 0)) AND
     ((n_SomaABC = 100) AND (n_SomaXYZ = 100))  THEN

    -- Antes de reclassificar, limpa informações da grade
    UPDATE TT_GRA SET GRAABC = NULL,
                      GRAXYZ = NULL;

    -- Regra Custo x Quantidade
    IF (n_REGRA_CLSABC = 1) OR (n_REGRA_CLSXYZ = 1) THEN

      -- Calcula total geral
      OPEN CR_CustoxQuantidade_Total;
      FETCH CR_CustoxQuantidade_Total INTO n_QTD_TOT, n_QTD_A, n_QTD_B, n_QTD_C, n_QTD_X, n_QTD_Y, n_QTD_Z;
      IF NOT FOUND THEN
        n_QTD_TOT := 0;
      END IF;
      CLOSE CR_CustoxQuantidade_Total;

      n_Contador := 0;
      OPEN CR_CustoxQuantidade_Detalhe;
      LOOP
        FETCH CR_CustoxQuantidade_Detalhe INTO c_FILMAT, c_CODMAT, n_CODCOR, n_CODTAM, nQtdItem;
        EXIT WHEN NOT FOUND;

        IF n_REGRA_CLSABC = 1 THEN
          -- Classifica conforme participações definidas em ABC
          IF n_Contador <= n_QTD_A THEN
            c_Classificacao := 'A';
          ELSIF n_Contador <= (n_QTD_B + n_QTD_A) THEN
            c_Classificacao := 'B';
          ELSE
            c_Classificacao := 'C';
          END IF;

          -- Atualiza ABC da grade
          UPDATE TT_GRA SET GRAABC = c_Classificacao
           WHERE FILMAT = c_FILMAT
             AND CODMAT = c_CODMAT
             AND CODCOR = n_CODCOR
             AND CODTAM = n_CODTAM;

        END IF;

        IF n_REGRA_CLSXYZ = 1 THEN
          -- Classifica conforme participações definidas em XYZ
          IF n_Contador <= n_QTD_X THEN
            c_Classificacao := 'X';
          ELSIF n_Contador <= (n_QTD_Y + n_QTD_X) THEN
            c_Classificacao := 'Y';
          ELSE
            c_Classificacao := 'Z';
          END IF;

          -- Atualiza XYZ da grade
          UPDATE TT_GRA SET GRAXYZ = c_Classificacao
           WHERE FILMAT = c_FILMAT
             AND CODMAT = c_CODMAT
             AND CODCOR = n_CODCOR
             AND CODTAM = n_CODTAM;

        END IF;

        -- incrementa contador
        n_Contador := n_Contador + nQtdItem;
      END LOOP;
      CLOSE CR_CustoxQuantidade_Detalhe;

    END IF;

    -- Regra Número de Vendas
    IF (n_REGRA_CLSABC = 2) OR (n_REGRA_CLSXYZ = 2) THEN

      -- Calcula total geral
      OPEN CR_NumeroVendas_Total;
      FETCH CR_NumeroVendas_Total INTO n_QTD_TOT, n_QTD_A, n_QTD_B, n_QTD_C, n_QTD_X, n_QTD_Y, n_QTD_Z;
      IF NOT FOUND THEN
        n_QTD_TOT := 0;
      END IF;
      CLOSE CR_NumeroVendas_Total;

      n_Contador := 0;
      OPEN CR_NumeroVendas_Detalhe;
      LOOP
        FETCH CR_NumeroVendas_Detalhe INTO c_FILMAT, c_CODMAT, n_CODCOR, n_CODTAM, nQtdItem;
        EXIT WHEN NOT FOUND;

        IF n_REGRA_CLSABC = 2 THEN
          -- Classifica conforme participações definidas em ABC
          IF n_Contador <= n_QTD_A THEN
            c_Classificacao := 'A';
          ELSIF n_Contador <= (n_QTD_B + n_QTD_A) THEN
            c_Classificacao := 'B';
          ELSE
            c_Classificacao := 'C';
          END IF;

          -- Atualiza ABC da grade
          UPDATE TT_GRA SET GRAABC = c_Classificacao
           WHERE FILMAT = c_FILMAT
             AND CODMAT = c_CODMAT
             AND CODCOR = n_CODCOR
             AND CODTAM = n_CODTAM;

        END IF;

        IF n_REGRA_CLSXYZ = 2 THEN
          -- Classifica conforme participações definidas em XYZ
          IF n_Contador <= n_QTD_X THEN
            c_Classificacao := 'X';
          ELSIF n_Contador <= (n_QTD_Y + n_QTD_X) THEN
            c_Classificacao := 'Y';
          ELSE
            c_Classificacao := 'Z';
          END IF;

          UPDATE TT_GRA SET GRAXYZ = c_Classificacao
           WHERE FILMAT = c_FILMAT
             AND CODMAT = c_CODMAT
             AND CODCOR = n_CODCOR
             AND CODTAM = n_CODTAM;

        END IF;

        -- incrementa contador
        n_Contador := n_Contador + nQtdItem;
      END LOOP;
      CLOSE CR_NumeroVendas_Detalhe;

    END IF;
  END IF;
*/
  RETURN 'OK';

END;
$$ language 'plpgsql';



/*-- SEQ 1536 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_ClassificaABCXYZ (TT_JOB.CODUID%TYPE) CASCADE;

/*-- SEQ 1537 --*/
CREATE OR REPLACE FUNCTION Job_ClassificaABCXYZ (TT_JOB.CODUID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODUID ALIAS FOR $1 ;
/*
   vNOME                         TT_JOB.NOMJOB%TYPE;
   vDESC                         TT_JOB.DESJOB%TYPE;
*/   
   dummy                         CHAR(2);
BEGIN
/*
   vNOME := 'JOB_CLASSIFICAABCXYZ';
   vDESC := 'Rotina para classificar produtos por ABC e XYZ';
   BEGIN
      DUMMY := Classifica_ABC_XYZ();
      DUMMY := RegistraJob(vNOME, vDESC, NULL, pCODUID);
   EXCEPTION
      WHEN OTHERS THEN DUMMY := RegistraJob(vNOME, vDESC, SQLERRM, pCODUID);
   END;
*/
   dummy := 'OK';
  RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 1538 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_ClassificaABCXYZ () CASCADE;

/*-- SEQ 1539 --*/
CREATE OR REPLACE FUNCTION Job_ClassificaABCXYZ () 
RETURNS VARCHAR AS $$
BEGIN
RETURN Job_ClassificaABCXYZ(NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1540 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DevolvidaIntegral (TT_VEN.CODFIL%TYPE,TT_VEN.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1541 --*/
CREATE OR REPLACE FUNCTION DevolvidaIntegral (TT_VEN.CODFIL%TYPE,TT_VEN.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;

-- Objetivos:
-- 1. Retorna se a venda (ou CF) est completamente devolvido.
-- 2. Permite que a rotina de Reimpresso de CF em Fatura (Checkout) possa excluir os CFs j devolvidos.

-- Declarao de variveis e cursores
   cResultado                    VARCHAR(2);
   nTotalQTDMOV                  TT_IVE.QTDMOV%TYPE;
   nTotalQtdDevolvida            TT_IVE.QTDMOV%TYPE;

-- Incio da funo
BEGIN

   SELECT SUM(IVE.QTDMOV), SUM(QtdDevolvida(IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE))
     INTO nTotalQTDMOV, nTotalQtdDevolvida
     FROM TT_IVE IVE
    WHERE IVE.CODFIL = pCODFIL
      AND IVE.SEQUEN = pSEQUEN
      AND IVE.SITMOV <> 'C'
      AND IVE.SITKIT <> '1';

   IF nTotalQtdDevolvida > 0 AND
      nTotalQtdDevolvida >= nTotalQTDMOV THEN
      cResultado := 'T';
   ELSE
      cResultado := 'F';
   END IF;

   RETURN cResultado;

END;
$$ language 'plpgsql';




/*-- SEQ 1542 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Aux_TrazCodBarra (TT_TIT.CODBCO%TYPE,TT_TIT.NUMAGE%TYPE,TT_TIT.CTACRR%TYPE,TT_TIT.NOSNUM%TYPE,TT_CCB.CARBCO%TYPE,TT_CRB.APECRB%TYPE,TT_MOE.MOEBCO%TYPE,TT_REC.VLRPAR%TYPE,TT_REC.DATVEN%TYPE,TT_CTB.AVISTA%TYPE,TT_CTB.APRAZO%TYPE,TT_CTB.DIGA_C%TYPE,TT_CTBXCCB.CODCNV%TYPE,TT_CTBXCCB.CODCED%TYPE,TT_REC.NUMPAR%TYPE) CASCADE;

/*-- SEQ 1543 --*/
CREATE OR REPLACE FUNCTION Aux_TrazCodBarra (TT_TIT.CODBCO%TYPE,TT_TIT.NUMAGE%TYPE,TT_TIT.CTACRR%TYPE,TT_TIT.NOSNUM%TYPE,TT_CCB.CARBCO%TYPE,TT_CRB.APECRB%TYPE,TT_MOE.MOEBCO%TYPE,TT_REC.VLRPAR%TYPE,TT_REC.DATVEN%TYPE,TT_CTB.AVISTA%TYPE,TT_CTB.APRAZO%TYPE,TT_CTB.DIGA_C%TYPE,TT_CTBXCCB.CODCNV%TYPE,TT_CTBXCCB.CODCED%TYPE,TT_REC.NUMPAR%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODBCO ALIAS FOR $1 ;
pNUMAGE ALIAS FOR $2 ;
pCTACRR ALIAS FOR $3 ;
pNOSNUM ALIAS FOR $4 ;
pCCBBCO ALIAS FOR $5 ;
pAPECRB ALIAS FOR $6 ;
pMOEBCO ALIAS FOR $7 ;
pVLRTIT ALIAS FOR $8 ;
pDATVEN ALIAS FOR $9 ;
pAVISTA ALIAS FOR $10 ;
pAPRAZO ALIAS FOR $11 ;
pDIGA_C ALIAS FOR $12 ;
pCODCNV ALIAS FOR $13 ;
pCODCED ALIAS FOR $14 ;
pNUMPAR ALIAS FOR $15 ;
-- Objetivo
-- Traz o Codigo para confeccionar o Codigo de Barras de um boleto bancario
   wk_DAC                        Numeric(5);
   wk_Soma                       Numeric(7);
   wk_Cont                       INTEGER;
   wk_FatorVenc                  Numeric(4);
   wk_FatorSYSDATE               Numeric(4);
   wk_codbar                     VARCHAR(44);
   wk_mult                       Numeric(5);
   wk_teste                      CHAR(2);
   wk_codcnv                     VARCHAR(20);
   wk_campo_livre                VARCHAR(24);

   wk_104_benef                  CHAR(06);
   wk_104_digito_benef           CHAR(01);
   wk_104_campo_livre            CHAR(24);
   wk_104_digito_campo_livre     CHAR(01);

   cCampoLivre748                CHAR(24);
   cDigitoCampoLivre748          CHAR(01);
   cDIGAGE                       TT_CTB.DIGAGE%TYPE;

   -- Variveis genricas
   cCampoLivre                   VARCHAR(100);
   cNossoNumero                  VARCHAR(20);

begin
  -- Fator de Vencimento

  --  o resultado da subtrao entre a data do vencimento do ttulo e a DATA BASE, fixada em 07.10.1997
  -- (03.07.2000 retrocedidos 1000 dias do incio do processo);
  -- Trata-se de um referencial numrico de 4 dgitos, situado nas quatro primeiras posies do campo valor, que
  -- representa a quantidade de dias decorridos da data base  data de vencimento do ttulo;
  -- Os boletos de cobrana emitidos a partir de 1 de setembro de 2000 devem conter essas caractersticas, para
  -- que quando forem capturados pela rede bancria, os sistemas faam a operao inversa, ou seja, adicionar 
  -- data base o fator de vencimento capturado, obtendo, dessa forma, a data do vencimento do boleto.

  wk_FatorVenc := LPAD(TO_CHAR(mod(IntervaloDias(Trunc( pDATVEN), to_date('03/07/2000','DD/MM/YYYY')), 9000) + 1000),4,'0');
  wk_FatorSYSDATE := LPAD(TO_CHAR(mod(IntervaloDias(Trunc(agora()) , to_date('03/07/2000','DD/MM/YYYY')), 9000) + 1000),4,'0');
  --Realiza essa verificacao para titulos gerados com a data de hoje.
  if wk_FatorVenc = wk_FatorSYSDATE then
     wk_FatorVenc := wk_FatorVenc + pAVISTA;
  elsif (pAPRAZO is not null) and (pAPRAZO > 0) then
     wk_FatorVenc := wk_FatorVenc + pAPRAZO;
  end if;

  --ITAU
  if pCODBCO = '341' then

      wk_codbar :=    LPAD(COALESCE( pCODBCO,'0'),03,'0')        -- Banco
                   || LPAD(TO_CHAR(COALESCE( pMOEBCO,0)),01,'0')            -- Codigo da moeda para o Banco
                   || '#' -- Digito Verificador
                   || LPAD(TO_CHAR(COALESCE(wk_FatorVenc ,0)),04,'0')      -- Fator de vencimento calculado acima
                   || LPAD(TO_CHAR(COALESCE(TRUNC(pVLRTIT*100),0)),10,'0'); -- Valor do titulo

      -- formando o codigo de barras
      wk_codbar := TRIM(wk_codbar) || LPAD(TO_CHAR(COALESCE(pCCBBCO,0)),3,'0')             -- Carteira para o Banco
                                   || LPAD(COALESCE(SubStr(TRIM(pNosNum),1,8),'0'),08,'0')     -- Nosso Numero
                                   || LPAD(COALESCE(SubStr(TRIM(pNosNum),9,1),'0'),01,'0')     --dac NOSNUM
                                   || LPAD(COALESCE(SubStr(TRIM(pNUMAGE),2,4),'0'),04,'0')  -- Agencia
                                   || LPAD(COALESCE(TRIM(pCTACRR),'0'),05,'0')
                                   || LPAD(TO_CHAR(to_number(COALESCE(pDIGA_C,'0'))),01,'0')             -- DAC AG CC
                                   || '000';

      -- Calculo do Digito Verificador
      wk_cont := Length(TRIM(wk_codbar));
      wk_Soma := 0;
      wk_Mult := 2;
      while (wk_Cont >= 1) loop
        -- Nao considera a posicao do digito
        if substr(wk_codbar, wk_Cont, 1) <> '#' then -- pula a posicao do DAC

          wk_Soma := wk_Soma + (TO_NUMBER (substr(wk_codbar, wk_Cont, 1) ) * wk_Mult);
          if wk_Mult = 9 then
            wk_Mult := 2;
          else
            wk_Mult := wk_Mult + 1;
          end if;

        end if;
        wk_Cont := wk_Cont -1;
      End loop;

      wk_DAC := 11 - mod(wk_soma,11);

      if (wk_DAC = 0) or (wk_DAC = 1) or (wk_DAC = 10) or (wk_DAC = 11)then
        wk_DAC := 1;
      end if;

      -- Coloca o digito verificador no Codigo de Barras
      Select replace(wk_Codbar,'#',TO_CHAR (wk_DAC) ) into wk_CODBAR from DUAL;

  --HSBC
  elsif pCODBCO = '399' then

      wk_codbar :=    LPAD(COALESCE(pCODBCO,'0'),03,'0')         -- Banco
                   || LPAD(TO_CHAR(COALESCE(pMOEBCO,0)),01,'0')             -- Codigo da moeda para o Banco
                   || '#' -- Digito Verificador
                   || LPAD(TO_CHAR(COALESCE(wk_FatorVenc ,0)),04,'0')      -- Fator de vencimento calculado acima
                   || LPAD(TO_CHAR(COALESCE(TRUNC(pVLRTIT*100),0)),10,'0'); -- Valor do titulo

      -- formando o codigo de barras
      wk_codbar := TRIM(wk_codbar) || LPAD(COALESCE(TRIM(pNosNum),'0'), 11,'0') -- Nosso Numero
                             || LPAD(TO_CHAR(COALESCE(TO_NUMBER(pNUMAGE),0)), 4,'0') -- Agencia
                             || LPAD(TO_CHAR(to_number(COALESCE(pCTACRR,'0'))),07,'0')             -- Conta Corrente
                             || LPAD(TO_CHAR(COALESCE(pCCBBCO,0)),2,'0') -- Carteira para o Banco
                             || '1';

      -- Calculo do Digito Verificador
      wk_cont := Length(TRIM(wk_codbar));
      wk_Soma := 0;
      wk_Mult := 2;
      while (wk_Cont >= 1) loop
        -- Nao considera a posicao do digito
        if substr(trim(wk_codbar), wk_Cont, 1) <> '#' then -- pula a posicao do DAC

          wk_Soma := wk_Soma + CAST (substr(trim(wk_codbar), wk_Cont, 1) as Numeric) * wk_Mult;
          if wk_Mult = 9 then
            wk_Mult := 2;
          else
            wk_Mult := wk_Mult + 1;
          end if;

        end if;
        wk_Cont := wk_Cont -1;
      End loop;

      wk_DAC := 11 - mod(wk_soma,11);

      if (wk_DAC = 0) or (wk_DAC = 1) or (wk_DAC = 10) or (wk_DAC = 11)then
        wk_DAC := 1;
      end if;

      -- Coloca o digito verificador no Codigo de Barras
      Select replace(wk_Codbar,'#',to_CHAR(wk_DAC) ) into wk_CODBAR from DUAL;

  --SICOOB
  elsif pCODBCO = '756' then

      wk_codbar :=    LPAD(COALESCE(pCODBCO,'0'),03,'0')         -- Banco
                   || LPAD(TO_CHAR(COALESCE(pMOEBCO,0)),01,'0')             -- Codigo da moeda para o Banco
                   || '#' -- Digito Verificador
                   || LPAD(TO_CHAR(COALESCE(wk_FatorVenc ,0)),04,'0')      -- Fator de vencimento calculado acima
                   || LPAD(TO_CHAR(COALESCE(TRUNC(pVLRTIT*100),0)),10,'0'); -- Valor do titulo

      -- formando o codigo de barras
      wk_codbar := TRIM(wk_codbar) || '1'
                                   || LPAD(TO_CHAR(COALESCE(TO_NUMBER(pNUMAGE),0)), 4,'0') -- Agencia
                                   || LPAD(TO_CHAR(COALESCE(pCCBBCO,0)),2,'0') -- Carteira para o Banco
                                   || LPAD(TO_CHAR(to_number(COALESCE(pCODCED,'0'))),07,'0') -- Conta Corrente
                                   || LPAD(COALESCE(TRIM(pNosNum),'0'), 8,'0') -- Nosso Numero
                                   || LPAD(TO_CHAR(to_number(COALESCE(pNUMPAR,'1'))), 3,'0') -- Numero Parcela
                                    ;

      -- Calculo do Digito Verificador
      wk_cont := Length(TRIM(wk_codbar));
      wk_Soma := 0;
      wk_Mult := 2;
      while (wk_Cont >= 1) loop
        -- Nao considera a posicao do digito
        if substr(trim(wk_codbar), wk_Cont, 1) <> '#' then -- pula a posicao do DAC

          wk_Soma := wk_Soma + CAST (substr(trim(wk_codbar), wk_Cont, 1) as Numeric) * wk_Mult;
          if wk_Mult = 9 then
            wk_Mult := 2;
          else
            wk_Mult := wk_Mult + 1;
          end if;

        end if;
        wk_Cont := wk_Cont -1;
      End loop;

      wk_DAC := 11 - mod(wk_soma,11);

      if (wk_DAC = 0) or (wk_DAC = 1) or (wk_DAC = 10) or (wk_DAC = 11)then
        wk_DAC := 1;
      end if;

      -- Coloca o digito verificador no Codigo de Barras
      Select replace(wk_Codbar,'#',to_CHAR(wk_DAC) ) into wk_CODBAR from DUAL;

  -- Bradesco
  elsif pCODBCO = '237' then

      wk_codbar :=    LPAD(COALESCE(pCODBCO,'0'),03,'0')        -- Banco
                   || LPAD(TO_CHAR(COALESCE(pMOEBCO,0)),01,'0')            -- Codigo da moeda para o Banco
                   || '#' -- Digito Verificador
                   || LPAD(TO_CHAR(COALESCE(wk_FatorVenc ,0)),04,'0')      -- Fator de vencimento calculado acima
                   || LPAD(TO_CHAR(COALESCE(TRUNC(pVLRTIT*100),0)),10,'0'); -- Valor do titulo

      wk_codbar := TRIM(wk_codbar) || LPAD(COALESCE(TO_CHAR(to_number(TRIM(pNUMAGE))),'0'), 4,'0')      -- Agencia
                             || LPAD(TO_CHAR(COALESCE(pCCBBCO,0)), 2,'0')            -- Carteira para o Banco
                             --|| LPAD(TO_CHAR(agora(),'YY'),2,'0')            -- Ano do nosso numero
                             || LPAD(COALESCE(substr(pNOSNUM,1,11),'0'),11,'0')             -- Nosso Numero
                             || LPAD(TO_CHAR(to_number(COALESCE(pCTACRR,'0'))),07,'0')             -- Conta do Cedente
                             || '0';

      -- Calculo do Digito Verificador
      wk_cont := Length(TRIM(wk_codbar));
      wk_Soma := 0;
      wk_Mult := 2;
      while (wk_Cont >= 1) loop
        -- Nao considera a posicao do digito
        if substr(wk_codbar, wk_Cont, 1) <> '#' then -- pula a posicao do DAC

          wk_Soma := wk_Soma + TO_NUMBER(substr(wk_codbar, wk_Cont, 1) ) * wk_Mult;
          if wk_Mult = 9 then
            wk_Mult := 2;
          else
            wk_Mult := wk_Mult + 1;
          end if;

        end if;
        wk_Cont := wk_Cont -1;
      End loop;

      wk_DAC := 11 - mod(wk_soma,11);


      if (wk_DAC > 9) or (wk_DAC = 0) then
        wk_DAC := 1;
      end if;

      -- Coloca o digito verificador no Codigo de Barras
      Select replace(wk_Codbar,'#',to_CHAR(wk_DAC) ) into wk_CODBAR from DUAL;

  --Banco do Brasil
  elsif pCODBCO = '001' then

      IF LENGTH(TRIM(COALESCE(pCODCNV,''))) = 6 THEN

        wk_codbar :=    LPAD(COALESCE(pCODBCO,'0'),03,'0') -- Banco
                     || LPAD(TO_CHAR(COALESCE(pMOEBCO,0)),01,'0') -- Codigo da moeda para o Banco
                     || '#' -- Digito Verificador
                     || LPAD(TO_CHAR(COALESCE(wk_FatorVenc ,0)),04,'0')      -- Fator de vencimento calculado acima
                     || LPAD(TO_CHAR(COALESCE(TRUNC(pVLRTIT*100),0)),10,'0'); -- Valor do titulo


        -- RFMP 81294 PAVIN
        IF LPAD(TO_CHAR(COALESCE(pCCBBCO,0)),03,'0') = '017' THEN

          -- Convenio de 6 posicoes e nosso numero de 11 posicoes
           wk_codbar := TRIM(wk_codbar)|| LPAD(COALESCE(TRIM(pNOSNUM),'0'),11,'0')             -- Nosso Numero
                        || LPAD(TO_CHAR(COALESCE(TO_NUMBER(pNUMAGE),0)),04,'0')  -- Codigo da Agencia
                        || LPAD(TO_CHAR(COALESCE(TO_NUMBER(pCTACRR),0)),08,'0')  -- Codigo do Cedente         -- 42358
                        || LPAD(TO_CHAR(COALESCE(pCCBBCO,0)),02,'0');  -- Carteira para banco

        ELSE

          -- A utilizacao do campo Nosso Numero com 17 posicoes livres somente pode ser utilizada por
          -- clientes cadastrados com convenio de cobranca de 6 posicoes, nas Modalidades de Cobranca
          -- Sem Registro  Carteira 16 e 18.
          -- O Nosso Numero, neste caso, nao possui digito verificador.
          -- e obrigatorio a impostacao do Codigo 21 na posicao 43 a 44 do Codigo de Barras para indicar
          -- a utilizacao do NossoNumero com 17 posicoes livres.
          -- Se o codigo 21 nao for informado, o Sistema de Cobranca interpretara o Codigo de
          -- BarrasLinha Digitavel como nossonumero de 11 posicoes.

          wk_codbar := TRIM(wk_codbar)||TRIM(COALESCE(pCODCNV,''))      -- Convenio
                                 || LPAD(COALESCE(TRIM(pNOSNUM),'0'),17,'0')  -- Nosso Numero
                                 || '21';

        END IF;

      ELSE
          wk_codbar :=    LPAD(COALESCE(pCODBCO,'0'),03,'0')        -- Banco
                       || LPAD(TO_CHAR(COALESCE(pMOEBCO,0)),01,'0')            -- Codigo da moeda para o Banco
                       || '#' -- Digito Verificador
                       || LPAD(TO_CHAR(COALESCE(wk_FatorVenc ,0)),04,'0')      -- Fator de vencimento calculado acima
                       || LPAD(TO_CHAR(COALESCE(TRUNC(pVLRTIT*100),0)),10,'0'); -- Valor do titulo

          --44847
          wk_codbar := TRIM(wk_codbar)||'000000'                            -- zeros
	               || LPAD(COALESCE(TRIM(pNOSNUM),'0'),17,'0')    -- Nosso Numero
                       || LPAD(TO_CHAR(COALESCE(pCCBBCO,0)),02,'0')          -- Carteira para banco
                       ;

      END IF;

      -- Calculo do Digito Verificador
      wk_cont := Length(TRIM(wk_codbar));
      wk_Soma := 0;
      wk_Mult := 2;
          while (wk_Cont >= 1) loop
            -- Nao considera a posicao do digito
            if substr(wk_codbar, wk_Cont, 1) <> '#' then -- pula a posicao do DAC
              wk_Soma := wk_Soma + TO_NUMBER(substr(wk_codbar, wk_Cont, 1) ) * wk_Mult;
              if wk_Mult = 9 then
                wk_Mult := 2;
              else
                wk_Mult := wk_Mult + 1;
              end if;

            end if;
            wk_Cont := wk_Cont -1;
          End loop;

      wk_DAC := 11 - mod(wk_soma,11);


    if (wk_DAC > 9) or (wk_DAC = 0) then
      wk_DAC := 1;
    end if;

    -- Coloca o digito verificador no Codigo de Barras
    Select replace(wk_Codbar,'#',to_CHAR(wk_DAC) ) into wk_CODBAR from DUAL;


  -- Manoel 88170 servico adicional avulso
  elsif pCODBCO = '000' then

      wk_codbar :=    LPAD(COALESCE(pCODBCO,'0'),03,'0')
                   || LPAD(TO_CHAR(COALESCE(pMOEBCO,0)),01,'0')
                   || '#'
                   || LPAD(TO_CHAR(COALESCE(wk_FatorVenc ,0)),04,'0')
                   || LPAD(TO_CHAR(COALESCE(TRUNC(pVLRTIT*100),0)),10,'0'); -- Valor do titulo

      -- CodBarras Servico avulso
      wk_codbar := TRIM(wk_codbar)|| LPAD(COALESCE(TRIM(pNOSNUM),'0'),15,'0') -- CodigoAvulso
                   || LPAD(TO_CHAR(COALESCE(TO_NUMBER(pNUMAGE),0)),05,'0')  -- TDSAD CODRTT
                   || LPAD(TO_CHAR(COALESCE(TO_NUMBER(pCTACRR),0)),05,'0');  -- TDSAD CODTAB

      wk_cont := Length(TRIM(wk_codbar));
      wk_Soma := 0;
      wk_Mult := 2;
                while (wk_Cont >= 1) loop
            if substr(wk_codbar, wk_Cont, 1) <> '#' then
              wk_Soma := wk_Soma + TO_NUMBER(substr(wk_codbar, wk_Cont, 1) ) * wk_Mult;
              if wk_Mult = 9 then
                wk_Mult := 2;
              else
                wk_Mult := wk_Mult + 1;
              end if;

            end if;
            wk_Cont := wk_Cont -1;
          End loop;
     
      wk_DAC := 11 - mod(wk_soma,11);

      if (wk_DAC > 9) or (wk_DAC = 0) then
        wk_DAC := 1;
      end if;

      -- Coloca o digito verificador no Codigo de Barras
      Select replace(wk_Codbar,'#',to_CHAR(wk_DAC) ) into wk_CODBAR from DUAL;

  -- Caixa
  elsif pCODBCO = '104' then
     IF COALESCE(pAPECRB,'') = 'SIG14' THEN
        wk_104_benef        := LPAD(TO_CHAR(TO_NUMBER(COALESCE(pCODCNV,'0'))),6,'0');
        wk_104_digito_benef := Aux_CalculaDACMod11(wk_104_benef,'10;11;','0;0;','T');

        wk_104_campo_livre := wk_104_benef                                        -- Cdigo do Beneficirio
                              || wk_104_digito_benef                              -- DV do Cdigo do Beneficirio
                              || LPAD(COALESCE(SUBSTR(TRIM(pNosNum),3,3),'0'),3,'0')    -- 3 a 5 posio do Nosso Nmero
                              || LPAD(COALESCE(SUBSTR(TRIM(pNosNum),1,1),'0'),1,'0')    -- 1 posio do Nosso Numero - Tipo de Cobrana (1-Registrada / 2-Sem Registro)
                              || LPAD(COALESCE(SUBSTR(TRIM(pNosNum),6,3),'0'),3,'0')    -- 6 a 8 posio do Nosso Nmero
                              || LPAD(COALESCE(SUBSTR(TRIM(pNosNum),2,1),'0'),1,'0')    -- 2 posio do Nosso Nmero - Identificador de Emisso do Boleto (4-Beneficirio)
                              || LPAD(COALESCE(SUBSTR(TRIM(pNosNum),9,9),'0'),9,'0');   -- 9 a 17 posio do Nosso Nmero

        wk_104_digito_campo_livre := Aux_CalculaDACMod11(wk_104_campo_livre,'10;11;','0;0;','T');

        wk_codbar := LPAD(COALESCE(pCODBCO,'0'),3,'0')       -- Banco
                     || LPAD(TO_CHAR(COALESCE(pMOEBCO,9)),1,'0')        -- Codigo da moeda para o Banco
                     || '#'                                            -- Digito Verificador
                     || LPAD(TO_CHAR(COALESCE(wk_FatorVenc,0)),4,'0')  -- Fator de vencimento
                     || LPAD(TO_CHAR(COALESCE(TRUNC(pVLRTIT*100),0)),10,'0') -- Valor do titulo
                     || wk_104_campo_livre                                        -- Campo livre
                     || wk_104_digito_campo_livre;                                -- DV do Campo Livre

        wk_DAC := Aux_CalculaDACMod11(wk_codbar,'0;10;11;','1;1;1;','F');

        -- Coloca o digito verificador no Codigo de Barras
        SELECT REPLACE(wk_Codbar,'#',TO_CHAR(wk_DAC)) INTO wk_CODBAR FROM DUAL;

     ELSE

        -- RFMP 96958
        -- Para a Carteira 12 (Rpida/CR):

        IF COALESCE(pCCBBCO,0) = 12 THEN

            -- Se Carteira Rpida: Nosso Nmero com 10 posies e Cdigo do Cedente, ambos sem o DV.
            -- Ex.: 9NNNNNNNNNAAAAYYYXXXXXXXX

            -- Onde: 9 - Identificador da carteira Rpida
            -- NNNNNNNNN - Nosso nmero do Cliente
            -- AAAA - CNPJ da Agncia Cedente
            -- YYY - Operao Cdigo
            -- XXXXXXXX - Cdigo fornecido pela Agncia

           cCampoLivre := LPAD(COALESCE(SUBSTR(TRIM(pNosNum),1,10),'0'),10,'0')       -- Nosso Nmero (sem DV)
                          || LPAD(SUBSTR(TRIM(COALESCE(pCODCNV,'')),1,15),15,'0');    -- Cdigo do Cedente (sem o DV)

           wk_codbar := LPAD(COALESCE(pCODBCO,'0'),3,'0')                             -- Banco
                        || LPAD(TO_CHAR(COALESCE(pMOEBCO,9)),1,'0')                   -- Codigo da moeda para o Banco
                        || '#'                                                       -- Digito Verificador
                        || LPAD(TO_CHAR(COALESCE(wk_FatorVenc,0)),4,'0')             -- Fator de vencimento
                        || LPAD(TO_CHAR(COALESCE(TRUNC(pVLRTIT*100),0)),10,'0')       -- Valor do titulo
                        || cCampoLivre;                                              -- Campo livre


           -- Em nenhuma hiptese poder ser utilizado o dgito igual a 0 (zero).
           -- Se o resultado da subtrao for igual a 0 (zero), 1 (um) ou maior que 9 (nove), assumir o dgito igual a 1 (um).
           -- Regra exclusiva para clculo do DV geral do cdigo de barras que no admite 0 (zero).
           wk_DAC := Aux_CalculaDACMod11(wk_codbar,'0;10;11;','1;1;1;','F');

           -- Coloca o digito verificador no Codigo de Barras
           SELECT REPLACE(wk_Codbar,'#',TO_CHAR(wk_DAC)) INTO wk_CODBAR FROM DUAL;

        ELSE

           wk_codBAR := '00000000000000000000000000000000000000000000';

        END IF;
     END IF;

  -- SICREDI (RFMP 96710)
  ELSIF pCODBCO = '748' THEN

     SELECT COALESCE((SELECT CTB.DIGAGE
                        FROM TT_CTB CTB
                       WHERE CTB.CODBCO = LPAD(pCODBCO,3,'0')
                         AND CTB.NUMAGE = LPAD(pNUMAGE,5,'0')
                         AND CTB.CTACRR = LPAD(pCTACRR,10,'0')),'  ')
       INTO cDIGAGE
       FROM DUAL;

     cCampoLivre748 := '1'                                                       -- Tipo de cobrana: "1"  Com Registro "3"  Sem Registro.
                       || '1'                                                    -- Tipo de carteira: "1" - carteira simples
                       || LPAD(COALESCE(SUBSTR(TRIM(pNOSNUM),1,9),'0'),9,'0')    -- Nosso Nmero
                       || SUBSTR(LPAD(TRIM(pNUMAGE),5,'0'),2,4)                  -- Cooperativa de crdito/agncia beneficiria (aaaa)
                       || LPAD(TRIM(cDIGAGE),2,' ')                              -- Posto da cooperativa de crdito/agncia beneficiria (pp)
                       || LPAD(TO_CHAR(TO_NUMBER(COALESCE(pCODCNV,'0'))),5,'0')  -- Cdigo do beneficirio
                       || '1'                                                    -- Ser 1 (um) quando houver valor expresso no campo "valor do documento"
                       || '0';                                                   -- Filler  zeros "0"

     -- Mdulo 11 do Campo Livre
     -- DV do campo livre calculado por mdulo 11 com aproveitamento total (resto igual a 0 ou 1 DV cai para 0)
     -- Apesar da documentao desse dgito mencionar tratamento para resto, a verificao pelo resultado
     -- final funciona igual.
     -- Se resultado do MOD for 0, 11 - 0 d valor > 9, ento funo utiliza valor default.
     -- Se resultado do MOD for 1, 11 - 1 d valor > 9, ento funo utiliza valor default.
     -- Se resultado do MOD for 10 (maior resto possvel), 11 - 10, d 1, que  um valor vlido.
     cDigitoCampoLivre748 := Aux_CalculaDACMod11(cCampoLivre748,'10;11;','0;0;','F');

     wk_codbar := LPAD(COALESCE(pCODBCO,'0'),3,'0')                        -- Identificao do banco
                  || LPAD(TO_CHAR(COALESCE(pMOEBCO,9)),1,'0')              -- Codigo da moeda para o Banco
                  || '#'                                                   -- Dgito Verificador
                  || LPAD(TO_CHAR(COALESCE(wk_FatorVenc,0)),4,'0')         -- Fator de vencimento
                  || LPAD(TO_CHAR(COALESCE(TRUNC(pVLRTIT*100),0)),10,'0')  -- Valor do ttulo
                  || cCampoLivre748                                        -- Campo Livre
                  || cDigitoCampoLivre748;                                 -- Dgito Campo Livre

     -- Mdulo 11 Geral
     -- No aceita 0 ou maior que 9.
     -- Assume 1 quando for invlido.
     -- No especifica tratamento quando resultado da soma for menor que 11.
     wk_DAC := Aux_CalculaDACMod11(wk_codbar,'0;10;11;','1;1;1;','F');

     -- Coloca o digito verificador no Codigo de Barras
     SELECT REPLACE(wk_codbar,'#',TO_CHAR(wk_DAC))
       INTO wk_codbar
       FROM DUAL;

  -- CECRED (RFMP 97014)
  ELSIF pCODBCO = '085' THEN
     --
     wk_codbar := LPAD(COALESCE(pCODBCO,'0'),3,'0')                         -- Identificao do banco
                  || LPAD(TO_CHAR(COALESCE(pMOEBCO,9)),1,'0')               -- Codigo da moeda para o Banco
                  || '#'                                                   -- Dgito Verificador
                  || LPAD(TO_CHAR(COALESCE(wk_FatorVenc,0)),4,'0')         -- Fator de vencimento
                  || LPAD(TO_CHAR(COALESCE(TRUNC(pVLRTIT*100),0)),10,'0')   -- Valor do ttulo
                  || LPAD(TRIM(COALESCE(pCODCNV,'')),6,'0')                 -- N convnio da Cooperativa
                  || LPAD(COALESCE(SUBSTR(TRIM(pNosNum),1,8),'0'),8,'0')    -- N conta corrente
                  || LPAD(COALESCE(SUBSTR(TRIM(pNosNum),9,9),'0'),9,'0')    -- Nmero do Boleto
                  || LPAD(TO_CHAR(COALESCE(pCCBBCO,0)),2,'0');              -- Cdigo da carteira

     -- RFMP 100519
     -- Banco mudou a regra do dgito verificador.
     -- Mdulo 11
     -- Quando o resto da diviso for igual 0,10 ou 11, atribui-se ao dgito verificador o dgito "1".
     wk_DAC := Aux_CalculaDACMod11(wk_codbar,'1;10;11;','1;1;1;','F');

     -- Coloca o digito verificador no Codigo de Barras
     SELECT REPLACE(wk_codbar,'#',TO_CHAR(wk_DAC))
       INTO wk_codbar
       FROM DUAL;

       -- BANRISUL (RFMP 97988)
  ELSIF pCODBCO = '041' THEN

     -- Campo livre
     -- Posies 20 a 20 Produto:
     --                  1 Cobrana Normal, Fichrio emitido pelo BANRISUL.
     --                  2 Cobrana Direta, Fichrio emitido pelo CLIENTE.
     -- Posio 21 a 21  Constante 1
     -- Posio 22 a 25  Cdigo da Agncia, com quatro dgitos, sem o Nmero de Controle.
     -- Posio 26 a 32  Cdigo de Cedente do Beneficirio sem Nmero de Controle.
     -- Posio 33 a 40  Nosso Nmero sem Nmero de Controle.
     -- Posio 41 a 42  Constante 40.
     -- Posio 43 a 44  Duplo Dgito referente s posies 20 a 42 (mdulos 10 e 11).

     -- Cdigo de Cedente
     -- Informe AAAACCCCCCCCC em que:
     -- AAAA  o cdigo da agncia (Ex.: para 100  Agncia Central, informe 0100).
     -- CCCCCCCCC  o cdigo de cedente propriamente dito.

     cNossoNumero := LPAD(COALESCE(SUBSTR(TRIM(pNOSNUM),1,10),'0'),10,'0');

     cCampoLivre := '2' -- TODO Precisaria ser TT_CCB.EMIBLQ
                    || '1'
                    || SUBSTR(LPAD(pCODCNV,13,'0'),1,11)
                    || SUBSTR(cNossoNumero,1,8)
                    || '40';

     cCampoLivre := cCampoLivre||DigitoDuploBanrisul(cCampoLivre, 7);

     -- Posies 01 a 03 Constante 041
     -- Posies 04 a 04 Moeda de Emisso: 9 Numeric .
     -- Posies 05 a 05 DAC (dgito de autoconferncia).
     -- Posies 06 a 09 Fator de Vencimento.
     -- Posies 10 a 19 Valor Nominal (zeros se for moeda varivel).
     -- Posies 20 a 44 Campo Livre.

     wk_codbar := LPAD(COALESCE(pCODBCO,'0'),3,'0')
                  || LPAD(TO_CHAR(COALESCE(pMOEBCO,9)),1,'0')
                  || '#'
                  || LPAD(TO_CHAR(COALESCE(wk_FatorVenc,0)),4,'0')
                  || LPAD(TO_CHAR(COALESCE(TRUNC(pVLRTIT*100),0)),10,'0')
                  || cCampoLivre;

     -- O clculo padronizado do DAC  o mdulo 11,
     -- com peso de 2 a 9, utilizando o dgito 1 (hum)
     -- para os restos 0, 10 e 1 (zero, dez ou um);
     -- Resto 10 gera dgito  1
     -- Resto  0 gera dgito 11
     -- Resto  1 gera dgito 10
     wk_DAC := Aux_CalculaDACMod11(wk_codbar,'0;10;11;','1;1;1;','F',9);

     -- Coloca o digito verificador no Codigo de Barras
     SELECT REPLACE(wk_codbar,'#',TO_CHAR(wk_DAC))
       INTO wk_codbar
       FROM DUAL;

  -- Outros Bancos
  else
    wk_codBAR := '00000000000000000000000000000000000000000000';

  end IF;

  Return wk_CODBAR;
END;
$$ language 'plpgsql';




/*-- SEQ 1544 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_Vendido (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 1545 --*/
CREATE OR REPLACE FUNCTION AUX_Vendido (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE)
RETURNS Numeric AS $$
DECLARE
DataIni ALIAS FOR $1 ;
DataFim ALIAS FOR $2 ;
Filial ALIAS FOR $3 ;
Codigo ALIAS FOR $4 ;
Cor ALIAS FOR $5 ;
Tamanho ALIAS FOR $6 ;
Local ALIAS FOR $7 ;
/*          ATENO          */
--Funo descontinuada. Utilizar funo TotalVenda. 
--Assinatura foi mantida apenas para compatibilidade em possveis relatrios de BI utilizado por cliente.

-- Objetivos
-- Obtm a quantidade vendida de um item num periodo
   
BEGIN
   
   RETURN COALESCE(TotalVenda(DataIni, DataFim, Filial, Codigo, Cor, Tamanho, Local), 0);
   
END;
$$ language 'plpgsql';




/*-- SEQ 1546 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AvaliacaoTarefa (TD_SIT.CODTAB%TYPE,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE) CASCADE;

/*-- SEQ 1547 --*/
CREATE OR REPLACE FUNCTION AvaliacaoTarefa (TD_SIT.CODTAB%TYPE,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE)
RETURNS CHAR AS $$
DECLARE
pCODSIT ALIAS FOR $1 ;
pFILREG ALIAS FOR $2 ;
pCODREG ALIAS FOR $3 ;
pFILRES ALIAS FOR $4 ;
pCODRES ALIAS FOR $5 ;
pFILREV ALIAS FOR $6 ;
pCODREV ALIAS FOR $7 ;
pFILMOD ALIAS FOR $8 ;
pCODMOD ALIAS FOR $9 ;
  cPodeAvaliar VARCHAR(1);
  cUSUREV      VARCHAR(1);
  cUSUREG      VARCHAR(1);
  cUSURES      VARCHAR(1);
  cUSUMOD      VARCHAR(1);
  cTIPADO      TD_SIT.TIPADO%TYPE;
  cFLGRES      TD_SIT.FLGRES%TYPE;
  cFLGREV      TD_SIT.FLGREV%TYPE;
  cFLGREG      TD_SIT.FLGREG%TYPE;
  CFLGMOD      TD_SIT.FLGMOD%TYPE;  
  
  Quemlogou TRetQuemLogou%ROWTYPE;
    
BEGIN
   -- retorna se o usuario pode ou nao dar nota para a tarefa
   /* pTIPADO
   1 - Revisor
   2 - Registrador
   3 - Responsvel
   4 - Gerente de Mdulo
   */

  cPodeAvaliar := 'F';

  -- situacao deve ter antescessora
  IF ISNULL(pCODSIT) = 'T' THEN
     return cPodeAvaliar;
  END IF;
   
  select * into QuemLogou from DadosLogon(); 
  
  -- quem eh o usuario (avaliador)
  cUSUREV := 'F';
  cUSUREG := 'F';
  cUSURES := 'F';
  cUSUMOD := 'F';
  IF Equal(QuemLogou.FILUSU||QuemLogou.CODUSU,pFILREV||pCODREV) = 1 THEN
     cUSUREV := 'T';
  END IF;
  IF Equal(QuemLogou.FILUSU||QuemLogou.CODUSU,pFILREG||pCODREG) = 1 THEN
     cUSUREG := 'T';
  END IF;
  IF Equal(QuemLogou.FILUSU||QuemLogou.CODUSU,pFILRES||pCODRES) = 1 THEN
     cUSURES := 'T';
  END IF;
  IF Equal(QuemLogou.FILUSU||QuemLogou.CODUSU,pFILMOD||pCODMOD) = 1 THEN
     cUSUMOD := 'T';
  END IF; 
   
  SELECT TIPADO, FLGREV, FLGREG, FLGRES, FLGMOD 
    INTO cTIPADO, cFLGREV, cFLGREG, cFLGRES, cFLGMOD 
    FROM TD_SIT 
   WHERE CODTAB = pCODSIT;

  -- quem eh o avaliado
  -- cTIPADO

  -- avaliado precisa ser valido
  IF ISNULL(cTIPADO) = 'T' THEN
     return cPodeAvaliar;
  END IF;

  -- avaliado nao pode ser usuario (avaliador)
  IF (cTIPADO = 1 AND cUSUREV = 'T')
  OR (cTIPADO = 2 AND cUSUREG = 'T') 
  OR (cTIPADO = 3 AND cUSURES = 'T') 
  OR (cTIPADO = 4 AND cUSUMOD = 'T') THEN
     return cPodeAvaliar;
  END IF;

  -- usuario eh avaliador?
  IF cFLGREV = 'T'       -- se avaliador for revisor
  AND cUSUREV = 'T' THEN -- e usuario for revisor
     cPodeAvaliar := 'T';      
  END IF; 
  IF cFLGREG = 'T'       -- se avaliador for registrador
  AND cUSUREG = 'T' THEN -- e usuario for registrador  
     cPodeAvaliar := 'T';      
  END IF; 
  IF cFLGRES = 'T'       -- se avaliador for responsavel
  AND cUSURES = 'T' THEN -- e usuario for responsavel  
     cPodeAvaliar := 'T';      
  END IF; 
  IF cFLGMOD = 'T'       -- se avaliador for gerente
  AND cUSUMOD = 'T' THEN -- e usuario for gerente  
     cPodeAvaliar := 'T';      
  END IF; 

  RETURN cPodeAvaliar;
END;
$$ language 'plpgsql';




/*-- SEQ 1548 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalcDifPag (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE) CASCADE;

/*-- SEQ 1549 --*/
CREATE OR REPLACE FUNCTION CalcDifPag (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE)
RETURNS Numeric AS $$
DECLARE
vCODFIL ALIAS FOR $1 ;
vSEQUEN ALIAS FOR $2 ;
vNUMPAR ALIAS FOR $3 ;
vSUBPAR ALIAS FOR $4 ;
  -- variaveis novas
  nDIFPAG  TT_REC.VLRPAR%TYPE;
  cFLGEST  TT_REC.FLGEST%TYPE;
BEGIN

   SELECT CALCRECATU(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR,0,REC.PAGAME)-
           COALESCE((SELECT min(CALCRECATU(SUB.CODFIL,SUB.SEQUEN,SUB.NUMPAR,SUB.SUBPAR,0,REC.PAGAME))
                       FROM TT_REC SUB 
                      WHERE REC.CODFIL=SUB.CODFIL
                        AND REC.SEQUEN=SUB.SEQUEN
                        AND REC.NUMPAR=SUB.NUMPAR
                        AND REC.SUBPAR=SUB.SUBORI),0)-
             REC.VLRPGT AS DIFPAG,
             REC.FLGEST
             INTO nDIFPAG, cFLGEST
     FROM TT_REC REC
    WHERE CODFIL = vCODFIL
      AND SEQUEN = vSEQUEN
      AND NUMPAR = vNUMPAR
      AND SUBPAR = vSUBPAR;

  IF cFLGEST NOT IN ('C','X') THEN
       Return nDIFPAG;
  ELSE 
       Return 0;
  END IF;
  

END;
$$ language 'plpgsql';




/*-- SEQ 1550 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalculaDivLinhaDigitalSicoob (VARCHAR) CASCADE;

/*-- SEQ 1551 --*/
CREATE OR REPLACE FUNCTION CalculaDivLinhaDigitalSicoob (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pNUMERO ALIAS FOR $1 ;
   WK_Resultado  Numeric;
   WK_soma       Numeric := 0;
   WK_peso       Numeric := 2;
   WK_i          Numeric;
   WK_digito     VARCHAR(1);
begin
    FOR WK_i IN reverse length(pNUMERO)..1 LOOP
        WK_digito := substr(pNUMERO, WK_i, 1);
        WK_resultado := (CAST(WK_digito AS INT) * WK_peso);
        IF WK_resultado > 9 THEN
           WK_resultado := WK_resultado - 9;
        END IF;
        WK_soma := WK_soma + WK_resultado;
        WK_peso := CASE WHEN WK_peso = 2 THEN 1 ELSE 2 END;
    END LOOP;
    WK_resultado := (10 - (WK_soma % 10)) % 10;  
  Return WK_Resultado;
  
        
END;
$$ language 'plpgsql';





/*-- SEQ 1552 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CALCULAPONTODEPEDIDO (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,Numeric,TT_PXF.MEDENT%TYPE,Numeric,INTEGER,TD_MUL.CODTAB%TYPE,VARCHAR,TT_IVE.PROMOC%TYPE) CASCADE;

/*-- SEQ 1553 --*/
CREATE OR REPLACE FUNCTION CALCULAPONTODEPEDIDO (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,Numeric,TT_PXF.MEDENT%TYPE,Numeric,INTEGER,TD_MUL.CODTAB%TYPE,VARCHAR,TT_IVE.PROMOC%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pDatIni ALIAS FOR $1 ;
pDatFim ALIAS FOR $2 ;
pFilMat ALIAS FOR $3 ;
pCodMat ALIAS FOR $4 ;
pCodCor ALIAS FOR $5 ;
pCodTam ALIAS FOR $6 ;
pCodFil ALIAS FOR $7 ;
pEstSeg ALIAS FOR $8 ;
pMedent ALIAS FOR $9 ;
pABCXYZ ALIAS FOR $10 ;
pTipoProjecao ALIAS FOR $11 ;
pCodmul ALIAS FOR $12 ;
pTipDia ALIAS FOR $13 ;
pPromoc ALIAS FOR $14 ;
--  --------------------------------------------------------
--  Funcao que retorna Ponto de Pedido do periodo informado para um determinado produto, como:
--      quantidade minima de vendas, quantidade máxima de vendas, média de vendas, desvio de venda. 
--      Estas informacoes sao uteis e comuns para calculos do ponto de pedido, etc.,
--      e por isso foram centralizadas aqui, de forma a reaproveitar e centralizar os codigos,
--      facilitando a manutencao. Esta funcao retorna estas informacoes de varias formas,
--      como: dias corridos ou dias uteis com estoque, e dias fora da promocao, dependendo dos parametros informados.
--
--  Return [VARCHAR(500)]
--      Esta funcao retorna uma string com uma lista de varias informacoes, separadas pelo sina de
--      ponto e virgula (;) para serem utilizadas em outros calculos. Caso um valor seja nulo sera
--      retornado como uma string vazia. Seguem abaixo os valores retornados:
--      - Quantidade Minima Vendida no periodo (wfQtdMinVen) no formato [000000000000000.0000];
--      - Quantidade Máxima Vendida no periodo (wfQtdMaxVen) no formato [000000000000000.0000];
--      - Quantidade Total Vendida no periodo (wfQtdTotVen) no formato [000000000000000.0000];
--      - Quantidade Média Vendida no periodo (wfMedVen) no formato [000000000000000.0000];
--      - Quantidade Desvio Venda no periodo (wfDesVen) no formato [000000000000000.0000];
--      - Quantidade Cálculo do Ponto do pedido (wfPonPed) no formato [000000000000000.0000]; 
--      - Quantidade Cálculo do Lote de Compra (wfLotCom) no formato [000000000000000.0000]; 
--      - Quantidade Cálculo da Quantidade Máxima (wfQtdMax) no formato [000000000000000.0000]; 
--      - Quantidade Total de Dias do periodo (wiTotDia) no formato [000000];
--
--      NOTA: recomenda-se o uso da funcao Split_Part, e suas derivadas, para facilitar a leitura e
--      utilizacao dos valores da lista retornada. Mais informacoes sobre Split_Part em:
--      http://intra.totall.com.br:8080/wiki/index.php/Split_part
--
--  @pDatIni [Timestamp]
--      Data inicial do periodo no formato DD/MM/YYYY. As horas serao desprezadas e redefinidas como
--      00:00:00;
--  @pDatFim [Timestamp]
--      Data final do periodo no formato DD/MM/YYYY. As horas serao desprezadas e redefinidas como
--      23:59:59;
--  @pFilMat [char(3)]
--      Codigo da filial do material do produto (TT_GRA);
--  @pCodMat [VARCHAR(5)]
--      Codigo do material do produto (TT_GRA);
--  @pCodCor [Numeric(5)]
--      Codigo da cor do produto (TT_GRA);
--  @pCodTam [Numeric(5)]
--      Codigo do tamanho do produto (TT_GRA);
--  @pCodFil [VARCHAR]
--      Lista de filial da venda. Caso nao informado serao listadas as vendas de todas as filiais;
--  @pEstSeg
--      Estoque de Segurança 
--  @pMedent
--      Tempo de ressuprimento do Fornecedor (TT_PXF);
--  @pABCXYZ
--      Prazo ABCXYZ da Filial
--  @pTipoProjecao [INTEGER]
--      0 - Estoque Mínimo, 1 - Ponto de Pedido, 2 - Média do Período Anterior, 3 - Mesmo Período do Ano Anterior, 
--      4 - Sazonalidade, 5 - Estoque Gôndola, 6 - Estoque Máximo
--  @pCodMul [Numeric(5)] default <null>
--      Codigo do subestoque do item da venda. Caso nao seja informado, opcao padrao, serao listados
--      todos os subestoques da loja;
--  @pTipDia [VARCHAR(1)] default <null>
--      Tipo do dia utilizado no calculo da media. As opcoes validas sao:
--      [C] dias corridos;
--      [A] dias com a loja aberta e com estoque;
--      Se este parametro receber qualquer valor difente de C ou A, ele e ajustado para o valor C.
--  @pPromoc [VARCHAR(1)] default [T]
--      Indica se somente os dias em promocao serao consideradas. as opcoes validas sao:
--      [T] true/verdadeiro: todos os dias;
--      [F] false/falso: somente dias em promocao;
--      Se este parametro receber qualquer valor difente de T ou F, uma excessao e levantada.
--  --------------------------------------------------------
   wvResult                      VARCHAR(500);       -- retorno da função
   wcCodDep                      TT_IDF.CODDEP%TYPE; -- var para Filial de Deposito
   wfQtdMinVen                   TT_IVE.QTDMOV%TYPE; -- var para quantidade minima diária vendida
   wfQtdMaxVen                   TT_IVE.QTDMOV%TYPE; -- var para quantidade máxima diária vendida    
   wfQtdTotVen                   TT_IVE.QTDMOV%TYPE; -- var para Total de vendas
   wfMedVen                      Numeric;               -- var para Média de vendas
   wfDesVen                      Numeric;               -- var para Desvio de Vendas
   wfPonPed                      Numeric;               -- var para Ponto do pedido 
   wfLotCom                      Numeric;               -- var para Lote de Compra
   wfQtdMax                      Numeric;               -- var para Quantidade Máxima

   wdIni                         Timestamp;               -- data inicial do periodo com as horas
   wdFim                         Timestamp;               -- data final do periodo com as horas
   wcTipDia                      CHAR(1);            -- trata o parametro pTipDia
   wcPromoc                      CHAR(1);            -- trata o parametro pPromoc
   wiQtdDia                      INTEGER;            -- totalizador da quant. de dias media
   wiTotDia                      INTEGER;            -- totalizador da quant. de dias 
   wvAux                         VARCHAR(500);       -- auxliar para buscar o resultado de ResumoVenPro
   wdPrimeiroLancto              Timestamp;               --  data da primeira movimentação
   
      -- Busca a Data do primeiro Movimento
   MovtoInicial CURSOR(pFilMatMov TT_GRA.FILMAT%TYPE,
           pCodMatMov TT_GRA.CODMAT%TYPE,
           pCodCorMov TT_GRA.CODCOR%TYPE,
           pCodTamMov TT_GRA.CODTAM%TYPE,
           pCodFilMov VARCHAR) IS
   SELECT MIN( RMOV.DATMOV )
     FROM TR_MOV RMOV
    WHERE RMOV.FILMAT = pFilMatMov
      AND RMOV.CODMAT = pCodMatMov
      AND RMOV.CODCOR = pCodCorMov
      AND RMOV.CODTAM = pCodTamMov
      AND INSTR(COALESCE(pCodFilMov, RMOV.CODFIL)||';', RMOV.CODFIL||';') > 0;
--  --------------------------------------------------------
BEGIN
    
    -- tratando o parametro 
    -- pTipDia
    wcTipDia := pTipDia;
    IF wcTipDia NOT IN ('A','C')
    OR ISNULL(wcTipDia)='T' THEN 
        wcTipDia := 'C';
    END IF;
    -- pPromoc
    wcPromoc := pPromoc;
    IF wcPromoc NOT IN ('T','F')
    OR ISNULL(wcPromoc)='T' THEN 
        wcPromoc := 'T';
    END IF;        
    --

    --  ajustando o periodo com as horas
    wdIni := TO_DATE(TO_CHAR(TRUNC(pDatIni), 'DD/MM/YYYY')||' 00:00:00', 'DD/MM/YYYY HH24:MI:SS');
    wdFim := TO_DATE(TO_CHAR(TRUNC(pDatFim), 'DD/MM/YYYY')||' 23:59:59', 'DD/MM/YYYY HH24:MI:SS');

   -- Procura a primeira movimentacao do produto
   -- (Caso um produto seja incluso apos a DataIni, ajusta-se a DataIni evitando distorcoes)
   -- Utilizado no calculo do intevalo de dias
   Open MovtoInicial(pFilMat, pCodMat, pCodCor, pCodTam, pCodFil);
   Fetch MovtoInicial into wdPrimeiroLancto;
   IF NOT NOT FOUND THEN
      IF wdPrimeiroLancto > wdIni THEN
         wdIni := wdPrimeiroLancto;
      END IF;
   END IF;
   Close MovtoInicial;

    --  buscando o codigo da loja
    SELECT CODDEP
      INTO wcCodDep
      FROM TT_IDF;
     
    --  calculando por "dias com a loja aberta e com estoque"
    wvAux := ResumoVenPro(wdIni, wdFim, pFilMat, pCodMat, pCodCor, pCodTam, pCodFil, wcTipDia, wcPromoc);
    --  "dias com a loja aberta e com estoque"
    wiTotDia := Split_Part_Number(wvAux, ';', 1);
    IF wcPromoc = 'T' THEN 
        wcPromoc := null;
    END IF;
    --
    
    if  wcTipDia = 'C' then
        --  dias corridos (padrao)
        SELECT T_2.QTDMOV,
               T_2.QTDMINDIA, 
               T_2.QTDMAXDIA, 
               T_2.QTDMEDDIA, 
               T_2.QTDDEVDIA,
               T_2.DIAS               
          INTO wfQtdTotVen, wfQtdMinVen, wfQtdMaxVen, wfMedVen, wfDesVen, wiQtdDia
          FROM (SELECT SUM(T_1.QTDMOV) AS QTDMOV,
                       MIN(T_1.QTDMOV) As QTDMINDIA, 
                       MAX(T_1.QTDMOV) AS QTDMAXDIA, 
                       AVG(T_1.QTDMOV) AS QTDMEDDIA, 
                       STDDEV(T_1.QTDMOV) AS QTDDEVDIA,
                       COUNT(*) AS DIAS
                  FROM (
                       SELECT TRUNC(IVE.VEN_DATHOR) AS VEN_DATHOR, 
                              COALESCE(SUM(IVE.QTDMOV),0) AS QTDMOV
                          FROM TT_IVE IVE 
                         INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL 
                                              AND VEN.SEQUEN = IVE.SEQUEN
                         INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT                     
                         WHERE IVE.FILMAT = pFilMat 
                           AND IVE.CODMAT = pCodMat
                           AND IVE.CODCOR = pCodCor
                           AND IVE.CODTAM = pCodTam
                           AND IVE.VEN_DATHOR BETWEEN wdIni AND wdFim
                           AND INSTR(COALESCE(pCodFil, IVE.CODFIL)||';', IVE.CODFIL||';') > 0
                           AND IVE.CODMUL = COALESCE(pCodMul, IVE.CODMUL)
                           AND IVE.PROMOC = COALESCE(wcPromoc, IVE.PROMOC)
                           AND VEN.LANVEN = 'T' 
                           AND IVE.LANEST IN ('S','R')
                           AND IVE.SITMOV <> 'C'
                           AND IVE.SITKIT <> '1'
                           AND DNAT.TIPNAT <> 'M' -- Devolução de Compra
                      GROUP BY TRUNC(IVE.VEN_DATHOR) 
                      ) T_1
               ) T_2;           
    ELSE
        --  dias com a loja aberta e com estoque
        SELECT T_2.QTDMOV,
               T_2.QTDMINDIA, 
               T_2.QTDMAXDIA, 
               T_2.QTDMEDDIA, 
               T_2.QTDDEVDIA,
               T_2.DIAS               
          INTO wfQtdTotVen, wfQtdMinVen, wfQtdMaxVen, wfMedVen, wfDesVen, wiQtdDia
          FROM (SELECT SUM(T_1.QTDMOV) AS QTDMOV,
                       MIN(T_1.QTDMOV) As QTDMINDIA, 
                       MAX(T_1.QTDMOV) AS QTDMAXDIA, 
                       AVG(T_1.QTDMOV) AS QTDMEDDIA, 
                       STDDEV(T_1.QTDMOV) AS QTDDEVDIA,
                       COUNT(*) AS DIAS
                  FROM (
                       SELECT TRUNC(IVE.VEN_DATHOR) AS VEN_DATHOR,
                              COALESCE(SUM(IVE.QTDMOV),0) AS QTDMOV
                          FROM TT_IVE IVE 
                         INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL
                                              AND VEN.SEQUEN = IVE.SEQUEN
                         INNER JOIN TR_MOV RMOV ON IVE.FILMAT = RMOV.FILMAT
                                               AND IVE.CODMAT = RMOV.CODMAT
                                               AND IVE.CODCOR = RMOV.CODCOR
                                               AND IVE.CODTAM = RMOV.CODTAM
                                               AND TRUNC(IVE.VEN_DATHOR) = RMOV.DATMOV
                                               AND IVE.CODFIL = RMOV.CODFIL
                                               AND IVE.CODMUL = RMOV.CODMUL
                         INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT                      
                         WHERE IVE.FILMAT = pFilMat 
                           AND IVE.CODMAT = pCodMat
                           AND IVE.CODCOR = pCodCor
                           AND IVE.CODTAM = pCodTam
                           AND IVE.VEN_DATHOR BETWEEN wdIni AND wdFim
                           AND INSTR(COALESCE(pCodFil, IVE.CODFIL)||';', IVE.CODFIL||';') > 0
                           AND IVE.CODMUL = COALESCE(pCodMul, IVE.CODMUL)
                           AND VEN.LANVEN = 'T' 
                           AND IVE.LANEST IN ('S','R')   
                           AND IVE.SITMOV <> 'C'  
                           AND IVE.SITKIT <> '1' 
                           AND RMOV.PROMOC = COALESCE(wcPromoc, RMOV.PROMOC)
                           AND DNAT.TIPNAT <> 'M' -- Devolução de Compra
                      GROUP BY TRUNC(IVE.VEN_DATHOR) 
                      ) T_1
               ) T_2;        
    END IF; 

    IF (pTipoProjecao = 6) THEN
        IF (wiQtdDia <> wiTotDia) THEN
            wfMedVen := TO_NUMBER(TO_CHAR(COALESCE(wfQtdTotVen / wiTotDia, 0), '000000000000000.0000'), '999999999999990D9999');    
        END IF;
            
        --Calcula Ponto de Pedido
        wfPonPed := COALESCE(wfMedVen, 0) * COALESCE(pMedent, 0) * COALESCE(pEstSeg, 0);
        --Calcula Lote de Compra
        wfLotCom := COALESCE(pABCXYZ, 0) * COALESCE(wfMedVen, 0);
        --Calcula Quantidade Máxima
        wfQtdMax := COALESCE(pEstSeg, 0) + COALESCE(wfLotCom, 0);
    END IF;
    
    wvResult := -- quantidade minima vendida
                TO_CHAR(COALESCE(wfQtdMinVen, 0), '000000000000000.0000') || ';' ||
                -- quantidade máxima vendida
                TO_CHAR(COALESCE(wfQtdMaxVen, 0), '000000000000000.0000') || ';' ||
                -- quantidade de Total de vendas
                TO_CHAR(COALESCE(wfQtdTotVen, 0), '000000000000000.0000') || ';' ||
                -- média de vendas
                TO_CHAR(COALESCE(wfMedVen, 0), '000000000000000.0000') || ';' ||
                -- desvio de Vendas
                TO_CHAR(COALESCE(wfDesVen, 0), '000000000000000.0000') || ';' ||
                -- Ponto do pedido
                TO_CHAR(COALESCE(wfPonPed, 0), '000000000000000.0000') || ';' ||
                -- Lote de Compra
                TO_CHAR(COALESCE(wfLotCom, 0), '000000000000000.0000') || ';' ||
                -- Quantidade Máxima
                TO_CHAR(COALESCE(wfQtdMax, 0), '000000000000000.0000') || ';' ||
                -- total de dias do periodo
                TO_CHAR(COALESCE(wiTotDia, 0), '000000') || ';'
                ;
    return wvResult;

END;
$$ language 'plpgsql';


/*-- SEQ 1554 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CALCULAPONTODEPEDIDO (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,Numeric(14,4),TT_PXF.MEDENT%TYPE,Numeric(3),INTEGER) CASCADE;

/*-- SEQ 1555 --*/
CREATE OR REPLACE FUNCTION CALCULAPONTODEPEDIDO (Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR,
                               Numeric(14,4),
                               TT_PXF.MEDENT%TYPE,
                               Numeric(3),
                               INTEGER) 
RETURNS VARCHAR AS $$
BEGIN
RETURN CALCULAPONTODEPEDIDO($1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,null,'C','T');
END;
$$ language 'plpgsql';


/*-- SEQ 1556 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalculaCustoMedio (TR_MOV.CODFIL%TYPE,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,Numeric) CASCADE;

/*-- SEQ 1557 --*/
CREATE OR REPLACE FUNCTION CalculaCustoMedio (TR_MOV.CODFIL%TYPE,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,Numeric)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pFILMAT ALIAS FOR $2 ;
pCODMAT ALIAS FOR $3 ;
pCODCOR ALIAS FOR $4 ;
pCODTAM ALIAS FOR $5 ;
pNUMERODIAS ALIAS FOR $6 ;
   vDatIni Timestamp;
   vDatMov Timestamp;
   vUltDatMov Timestamp := NULL;
   vATUALIZADO CHAR(1) := NULL;

   vVLREST Numeric:=0;
   vVLRESTG Numeric:=0;
   vVLRMOV TR_MOV.VLR_CM%TYPE:=0;
   vVLRCMG TR_MOV.VLRCMG%TYPE:=0;
   vQTDEST TR_MOV.SAL_CM%TYPE:=0;
   VQTDMOV TR_MOV.SAL_CM%TYPE:=0;
   vCODFIL TT_IVE.CODFIL%TYPE;
   vSEQUEN TT_IVE.SEQUEN%TYPE;
   vNUMITE TT_IVE.NUMITE%TYPE;
   vdummy   Numeric(5);
   vCM      TR_MOV.VLR_CM%TYPE:=0;
   vCMG     TR_MOV.VLR_CM%TYPE:=0;
   vOrdem  Numeric(10):=0;
   vTIPMOV VARCHAR(1);
   vORDEMLAN Numeric(1);
   vINI_CM TT_SAL.INI_CM%TYPE;

   vAux_INI_CM  TT_SAL.INI_CM%TYPE;
   vAux_VLREST  TR_MOV.VLR_CM%TYPE:=0;
   vAux_VLRESTG TR_MOV.VLR_CM%TYPE:=0;
   vAux_QTDEST  TR_MOV.SAL_CM%TYPE:=0;

   vTEMSALDOINI BOOLEAN;

   vNaoAchou BOOLEAN;

   vVem_de_CALCUSME  constant VARCHAR(1) := constante('vem_de_calcusmed');

   -- Variavel para guardar se a filial do fornecedor da transferencia
   -- e substituta.
   -- Para compras, vendas ou lancamentos avulso seu valor e nulo.
   -- RFMP 92293
   vSUBSTITUTA                   TD_FIL.SUBSTITUTA%TYPE;
   vUSACM_BASE_IMP_TRANS         VARCHAR(1);

   -- Rhuan 95317
   -- Variveis para guardar se  uma devoluo de transferncia
   -- e os valores de ST e ICMS da transferncia original
   vSUBSTITUTA_ORI               TD_FIL.SUBSTITUTA%TYPE;
   vDEVTRA                       VARCHAR(1);
   --Campos para obter os valores da nota de origem
   vVLR_STDIF_ORI                TT_ICO.VLR_STDIF%TYPE:=0;
   vVLRICM_ORI                   TT_ICO.VLRICM%TYPE:=0;
   nVLR_CM_ORI                   TR_MOV.VLR_CM%TYPE;
   nVLR_CMG_ORI                  TR_MOV.VLRCMG%TYPE;
   nQTD_CM_ORI                   TR_MOV.SAL_CM%TYPE;
   nBASICM_CM_NEW                TT_ICO.BASICM_CM%TYPE; 
   nVLRICM_CM_NEW                TT_ICO.VLRICM_CM%TYPE; 
   nBAS_ST_CM_NEW                TT_ICO.BAS_ST_CM%TYPE;
   nVLR_ST_CM_NEW                TT_ICO.VLR_ST_CM%TYPE;
   nREDITE_ORI                   TT_IVE.REDITE%TYPE;
   nTAXICM_ORI                   TT_IVE.TAXICM%TYPE;
   nMVAVEN_ORI                   TT_IVE.MVAVEN%TYPE;
   nREDSUB_ORI                   TT_IVE.REDSUB%TYPE;
   nICMINT_ORI                   TT_IVE.ICMINT%TYPE;
   sICMTIP_ORI                   TT_IVE.ICMTIP%TYPE;
   

-- Cursor para percorrer os lancamentos
Lancamento CURSOR(pDATINI Timestamp,
           pDatFim Timestamp) IS
SELECT CODFIL,SEQUEN,NUMITE,DATMOV,QTD_CM,VLR_CM,VLRCMG,TIPMOV,ORDEM_LAN,SUBSTITUTA,
       SUBSTITUTA_ORI,DEVTRA,VLR_STDIF_ORI,VLRICM_ORI,
       REDITE,TAXICM, MVAVEN, REDSUB, ICMINT, ICMTIP
  FROM (
    -- Compras
    SELECT ICO.CODFIL, ICO.SEQUEN, ICO.NUMITE,
           ICO.COM_DATOPE AS DATMOV,
           ICO.QTD_CM, ICO.VLR_CM, ICO.VLRCMG,
           to_char('C') AS TIPMOV,
           CASE WHEN COM.CODFOR = '     0' THEN 2 
                WHEN ICO.LANESt='N' THEN 3 
                ELSE 1 
           END AS ORDEM_LAN,
           CASE WHEN COM.CODFOR = '     0' THEN COM.FILFOR ELSE ICO.CODFIL END AS ORDEM_FIL,
           TO_CHAR('COMPRA') AS NATFIS,
           CASE WHEN COM.CODFOR = '     0' THEN FIL_FOR.SUBSTITUTA ELSE CAST(NULL AS VARCHAR(1)) END AS SUBSTITUTA,
           CASE WHEN COM.CODFOR = '     0' THEN FIL_ORI.SUBSTITUTA
                                           ELSE CAST(NULL AS VARCHAR(1)) END AS SUBSTITUTA_ORI,
           CAST(CASE WHEN COM.CODFOR = '     0' 
                     THEN CASE WHEN (SELECT 1 AS OK 
                                       FROM TT_TRA TRA  
                                       JOIN TT_VEN DEV ON DEV.CODFIL = TRA.FILIVE AND DEV.SEQUEN = TRA.SEQIVE
                                       JOIN TD_NAT DNAT ON DNAT.CODTAB = DEV.CODNAT AND DNAT.TIPNAT = 'R'
                                      WHERE TRA.FILICO=ICO.CODFIL AND TRA.SEQICO = ICO.SEQUEN AND TRA.NUMICO = ICO.NUMITE
                                    ) = 1 THEN 'T' -- Retorna True quando operao for uma Entrada de Devoluo de Transferencia
                               ELSE NULL
                          END
                     ELSE NULL
                END AS VARCHAR(1)) AS DEVTRA,
           CASE WHEN COM.CODFOR = '     0' AND FIL_FOR.SUBSTITUTA = 'T' THEN COALESCE(ROUND((CASE WHEN LeParametroBoo('USACM_BASE_IMP_TRANS', ICO.CODFIL, null, null, null)='T' 
			                                                                                         THEN COALESCE(ICO.VLR_ST_CM, ICO.VLR_STDIF)
																																  ELSE ICO.VLR_STDIF
																															END * ICO.QTD_CM)/ICO.QTD_CM,2),0)
                                                      ELSE 0 END AS VLR_STDIF_ORI,
           CASE WHEN COM.CODFOR = '     0' AND FIL_FOR.SUBSTITUTA = 'T' THEN COALESCE(ROUND((CASE WHEN LeParametroBoo('USACM_BASE_IMP_TRANS', ICO.CODFIL, null, null, null)='T' 
			                                                                                         THEN COALESCE(ICO.VLRICM_CM, ICO.VLRICM)
																																  ELSE ICO.VLRICM
																															END * ICO.QTD_CM)/ICO.QTD_CM,2),0)
                                                      ELSE 0 END AS VLRICM_ORI,
           0 AS REDITE,
           0 AS TAXICM,
           0 AS MVAVEN,
           0 AS REDSUB,
           0 AS ICMINT,
           ICO.ICMTIP
      FROM TT_ICO ICO INNER JOIN TT_COM COM ON COM.CODFIL = ICO.CODFIL AND COM.SEQUEN = ICO.SEQUEN
                      INNER JOIN TD_FIL FIL_FOR ON FIL_FOR.CODFIL = COM.FILFOR
                       LEFT JOIN TD_FIL FIL_ORI ON FIL_ORI.CODFIL = COM.CODFIL
     WHERE ICO.SITMOV<>'C'
       AND (
            (ICO.LANEST NOT IN ('R','N') AND (COALESCE(ICO.QTD_CM,0) <> 0))
            OR
            ((LeParametroBoo('CM_SEM_MOVEST', ICO.CODFIL, null, null, null)='T') and (COALESCE(COM.TIPCCM,'C')='C')/*(COM.ATUCUS='T')*/)
            OR
            (COALESCE(COM.TIPCCM,'C') IN ('M', 'Z'))
           )
       AND COALESCE(COM.FINNFE,'X') <> '2'
       AND ICO.CODFIL=pCODFIL
       AND ICO.FILMAT=pFILMAT
       AND ICO.CODMAT=pCODMAT
       AND ICO.CODCOR=pCODCOR
       AND ICO.CODTAM=pCODTAM
       AND ICO.COM_DATOPE>=CASE WHEN pDatIni IS NULL THEN TO_DATE('01/01/1800','DD/MM/YYYY')
                                                     ELSE ADD_DAY(pDatIni,1)
                           END
       AND ICO.COM_DATOPE<=CASE WHEN pDatFim IS NULL THEN ADD_DAY(Agora(),1)
                                                     ELSE ADD_DAY(pDatFim,1)
                           END
    UNION ALL
    -- Nota Complementar
    SELECT ICO.CODFIL, ICO.SEQUEN, ICO.NUMITE,
           ICO.COM_DATOPE AS DATMOV,
           ICO.QTD_CM, ICO.VLR_CM, ICO.VLRCMG,
           to_char('N') AS TIPMOV,
           3 AS ORDEM_LAN,
           CASE WHEN COM.CODFOR = '     0' THEN COM.FILFOR ELSE ICO.CODFIL END AS ORDEM_FIL,
           TO_CHAR('COMPLEMENTAR') AS NATFIS,
           CAST(NULL AS VARCHAR(1)) AS SUBSTITUTA,
           CAST(NULL AS VARCHAR(1)) AS SUBSTITUTA_ORI,
           CAST(NULL AS VARCHAR(1)) AS DEVTRA,
           0 AS VLR_STDIF_ORI,
           0 AS VLRICM_ORI,
           0 AS REDITE,
           0 AS TAXICM,
           0 AS MVAVEN,
           0 AS REDSUB,
           0 AS ICMINT,
           ICO.ICMTIP
      FROM TT_ICO ICO INNER JOIN TT_COM COM ON COM.CODFIL = ICO.CODFIL AND COM.SEQUEN = ICO.SEQUEN
     WHERE ICO.SITMOV<>'C'
       --AND ICO.LANEST = 'N'--Independente da operao de estoque nota complementar sempre entra no Custo
       AND COALESCE(COM.FINNFE,'X') = '2'
       AND ICO.CODFIL=pCODFIL
       AND ICO.FILMAT=pFILMAT
       AND ICO.CODMAT=pCODMAT
       AND ICO.CODCOR=pCODCOR
       AND ICO.CODTAM=pCODTAM
       AND ICO.COM_DATOPE >= CASE WHEN pDatIni IS NULL THEN TO_DATE('01/01/1800','DD/MM/YYYY')
                                                       ELSE ADD_DAY(pDatIni,1)
                             END
       AND ICO.COM_DATOPE <= CASE WHEN pDatFim IS NULL THEN ADD_DAY(Agora(),1)
                                                       ELSE ADD_DAY(pDatFim,1)
                             END
    UNION ALL
    -- Entradas de Importao e Devoluo de Transferncia
    SELECT IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE,
           IVE.VEN_DATHOR AS DATMOV,
           IVE.QTD_CM * -1 AS QTD_CM,
           IVE.VLR_CM * CASE WHEN DNAT.TIPNAT = 'I' THEN 1 ELSE -1 END,
           IVE.VLRCMG * CASE WHEN DNAT.TIPNAT = 'I' THEN 1 ELSE -1 END,
           TO_CHAR( CASE WHEN DNAT.TIPNAT = 'I' THEN 'I' ELSE 'R' END) AS TIPMOV,
           CASE WHEN DNAT.TIPNAT = 'I' THEN 1 ELSE 2 END AS ORDEM_LAN,
           IVE.CODFIL AS ORDEM_FIL,
           TO_CHAR(CASE WHEN DNAT.TIPNAT = 'I' THEN 'IMPORTACAO' ELSE 'DEVOLUO TRANSFERNCIA' END) AS NATFIS,
           CAST(NULL AS VARCHAR(1)) AS SUBSTITUTA,
           CAST(NULL AS VARCHAR(1)) AS SUBSTITUTA_ORI,
           CAST(NULL AS VARCHAR(1)) AS DEVTRA,
           0 AS VLR_STDIF_ORI,
           0 AS VLRICM_ORI,
           IVE.REDITE,
           IVE.TAXICM,
           IVE.MVAVEN,
           IVE.REDSUB,
           CASE WHEN (IVE.ICMINT>1) AND (IVE.ICMINT<2) THEN ((IVE.ICMINT - 1) * 100) ELSE IVE.ICMINT END AS ICMINT, -- TODO: O Checkout atual grava essa alquota na forma decimal
           IVE.ICMTIP
      FROM TT_IVE IVE INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
                      INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
     WHERE IVE.SITMOV<>'C'
       AND IVE.LANEST = 'S'
       AND IVE.SITKIT<>'1'
       AND IVE.CODFIL=pCODFIL
       AND IVE.FILMAT=pFILMAT
       AND IVE.CODMAT=pCODMAT
       AND IVE.CODCOR=pCODCOR
       AND IVE.CODTAM=pCODTAM
       AND IVE.VEN_DATHOR >= CASE WHEN pDatIni IS NULL THEN TO_DATE('01/01/1800','DD/MM/YYYY')
                                  ELSE ADD_DAY(pDatIni,1)
                             END
       AND IVE.VEN_DATHOR <= CASE WHEN pDatFim IS NULL THEN ADD_DAY(Agora(),1)
                                  ELSE ADD_DAY(pDatFim,1)
                             END
       AND DNAT.TIPNAT IN ('R','I') --Considera as notas de Devoluo de Transferncia\Importao como objetos de Compra
    UNION ALL
    -- Vendas/Transferncia/Devoluo de Venda e Outros Documentos Emitidos
    SELECT IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE,
           IVE.VEN_DATHOR  AS DATMOV,
           IVE.QTD_CM * -1 AS QTD_CM,
           0      AS VLR_CM,
           0      AS VLRCMG,
           to_char('V') AS TIPMOV,
           CASE WHEN ven.codser IN ('CF','TK') AND ven.datfis<trunc(ive.ven_dathor) THEN 0
                WHEN VEN.CODCLI = '     0' THEN 2
                                                       ELSE 3
           END AS ORDEM_LAN,
           IVE.CODFIL AS ORDEM_FIL,
           IVE.NATFIS,
           CASE WHEN VEN.CODCLI = '     0' THEN FIL_FOR.SUBSTITUTA ELSE CAST(NULL AS VARCHAR(1)) END AS SUBSTITUTA,
           CASE WHEN VEN.CODCLI = '     0' AND FIL_ORI.CODFIL IS NOT NULL THEN FIL_ORI.SUBSTITUTA
                                                                                     ELSE CAST(NULL AS VARCHAR(1)) END AS SUBSTITUTA_ORI,
           CASE WHEN VEN.CODCLI = '     0' AND IVE.FILICOORI IS NOT NULL THEN TO_CHAR('T')
                                                                                    ELSE CAST(NULL AS VARCHAR(1)) END AS DEVTRA,
           CASE WHEN VEN.CODCLI = '     0' THEN COALESCE(ROUND((CASE WHEN LeParametroBoo('USACM_BASE_IMP_TRANS', ORI.CODFIL, null, null, null)='T' 
																						   THEN COALESCE(ORI.VLR_ST_CM, ORI.VLR_STDIF)
																					 	   ELSE ORI.VLR_STDIF
																					 END * IVE.QTD_CM)/ORI.QTD_CM,2),0)
                                                      ELSE 0 END AS VLR_STDIF_ORI,
           CASE WHEN VEN.CODCLI = '     0' THEN COALESCE(ROUND((CASE WHEN LeParametroBoo('USACM_BASE_IMP_TRANS', ORI.CODFIL, null, null, null)='T' 
																						   THEN COALESCE(ORI.VLRICM_CM, ORI.VLRICM)
																					 	   ELSE ORI.VLRICM
																					 END * IVE.QTD_CM)/ORI.QTD_CM,2),0)
                                                      ELSE 0 END AS VLRICM_ORI,
           IVE.REDITE,
           IVE.TAXICM,
           IVE.MVAVEN,
           IVE.REDSUB,
           CASE WHEN (IVE.ICMINT>1) AND (IVE.ICMINT<2) THEN ((IVE.ICMINT - 1) * 100) ELSE IVE.ICMINT END AS ICMINT, -- TODO: O Checkout atual grava essa alquota na forma decimal
           IVE.ICMTIP
      FROM TT_IVE IVE INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
                      INNER JOIN TD_FIL FIL_FOR ON FIL_FOR.CODFIL = VEN.CODFIL
                      INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
                       LEFT JOIN TT_ICO ORI ON ORI.CODFIL = IVE.FILICOORI
                                           AND ORI.SEQUEN = IVE.SEQICOORI
                                           AND ORI.NUMITE = IVE.NUMICOORI
                       LEFT JOIN TT_COM COM_ORI ON COM_ORI.CODFIL = ORI.CODFIL
                                               AND COM_ORI.SEQUEN = ORI.SEQUEN
                       LEFT JOIN TD_FIL FIL_ORI ON FIL_ORI.CODFIL = COM_ORI.FILFOR
     WHERE IVE.SITMOV<>'C'
       AND IVE.LANEST NOT IN ('R','N')
       --AND COALESCE(IVE.QTD_CM,0) <> 0 -- DN 59550
       AND IVE.SITKIT<>'1'
       AND IVE.CODFIL=pCODFIL
       AND IVE.FILMAT=pFILMAT
       AND IVE.CODMAT=pCODMAT
       AND IVE.CODCOR=pCODCOR
       AND IVE.CODTAM=pCODTAM
       AND IVE.VEN_DATHOR >= CASE WHEN pDatIni IS NULL THEN TO_DATE('01/01/1800','DD/MM/YYYY')
                                  ELSE ADD_DAY(pDatIni,1)
                             END
       AND IVE.VEN_DATHOR <= CASE WHEN pDatFim IS NULL THEN ADD_DAY(Agora(),1)
                                  ELSE ADD_DAY(pDatFim,1)
                             END
       AND DNAT.TIPNAT NOT IN ('R','I') --Desconsidera as notas de Devoluo de Transferncia\Importao como objetos de Vendas
    UNION ALL
    -- Lanamento Avulso
    SELECT LAN.CODFIL, LAN.SEQUEN, 0 AS NUMITE,
           LAN.DATMOV,
           LAN.QTD_CM AS QTD_CM,
           ABS(VLRMOV) AS VLR_CM,
           ABS(VLRMOV) AS VLRCMG,
           to_char('L') AS TIPMOV,
           CASE WHEN LAN.QTD_CM<0 THEN 4 ELSE 0 END AS ORDEM_LAN,
           LAN.CODFIL AS ORDEM_FIL,
           TO_CHAR('LANCAMENTO') AS NATFIS,
           CAST(NULL AS VARCHAR(1)) AS SUBSTITUTA,
           CAST(NULL AS VARCHAR(1)) AS SUBSTITUTA_ORI,
           CAST(NULL AS VARCHAR(1)) AS DEVTRA,
           0 AS VLR_STDIF_ORI,
           0 AS VLRICM_ORI,
           0 AS REDITE,
           0 AS TAXICM,
           0 AS MVAVEN,
           0 AS REDSUB,
           0 AS ICMINT,
           CAST(NULL AS VARCHAR(1)) AS ICMTIP
      FROM TT_LAN LAN INNER JOIN TD_LAN DLAN ON LAN.TIPLAN=DLAN.CODTAB
     WHERE LAN.SITMOV<>'C'
       AND DLAN.MOVLEG='T'
       AND LAN.CODFIL=pCODFIL
       AND LAN.FILMAT=pFILMAT
       AND LAN.CODMAT=pCODMAT
       AND LAN.CODCOR=pCODCOR
       AND LAN.CODTAM=pCODTAM
       AND LAN.DATMOV >= CASE WHEN pDatIni IS NULL THEN TO_DATE('01/01/1800','DD/MM/YYYY')
                              ELSE ADD_DAY(pDatIni,1)
                         END
       AND LAN.DATMOV <= CASE WHEN pDatFim IS NULL THEN ADD_DAY(Agora(),1)
                              ELSE ADD_DAY(pDatFim,1)
                         END
    UNION ALL
    -- Ajustes de Custo Mdio
    SELECT ACM.CODFIL, ACM.SEQUEN, 0 AS NUMITE,
           ACM.DATAJU AS DATMOV,
           0 AS QTD_CM,
           VLRAJU AS VLR_CM,
           VLRAJU AS VLRCMG,
           to_char('A') AS TIPMOV,
           0 AS ORDEM_LAN,
           ACM.CODFIL AS ORDEM_FIL,
           TO_CHAR('AJUSTE') AS NATFIS,
           CAST(NULL AS VARCHAR(1)) AS SUBSTITUTA,
           CAST(NULL AS VARCHAR(1)) AS SUBSTITUTA_ORI,
           CAST(NULL AS VARCHAR(1)) AS DEVTRA,
           0 AS VLR_STDIF_ORI,
           0 AS VLRICM_ORI,
           0 AS REDITE,
           0 AS TAXICM,
           0 AS MVAVEN,
           0 AS REDSUB,
           0 AS ICMINT,
           CAST(NULL AS VARCHAR(1)) AS ICMTIP
      FROM TT_ACM ACM
     WHERE ACM.SITMOV<>'C'
       AND ACM.CODFIL=pCODFIL
       AND ACM.FILMAT=pFILMAT
       AND ACM.CODMAT=pCODMAT
       AND ACM.CODCOR=pCODCOR
       AND ACM.CODTAM=pCODTAM
       AND ACM.DATAJU >= CASE WHEN pDatIni IS NULL THEN TO_DATE('01/01/1800','DD/MM/YYYY')
                              ELSE ADD_DAY(pDatIni,1)
                         END
       AND ACM.DATAJU <= CASE WHEN pDatFim IS NULL THEN ADD_DAY(Agora(),1)
                              ELSE ADD_DAY(pDatFim,1)
                         END
   ) TAB
-- Dentro de um dia, coloca-se por tipo: 1 = compras, 2 = entradas e saidas de transferencias, 3 = vendas
-- Os lanamentos de uma mesma data e tipo so ordenados por hora
-- Em caso de hora iqual, pega-se pela filial de origem do lanamento
ORDER BY Trunc(DATMOV), ORDEM_LAN, DATMOV, ORDEM_FIL, NATFIS;

-- Cursor para estoque inicial
EstoqueInicial CURSOR FOR
SELECT INI_CM, VLR_CM, VLRCMG, QTD_CM
  FROM TT_SAL
 WHERE CODFIL=pCODFIL
   AND FILMAT=pFILMAT
   AND CODMAT=pCODMAT
   AND CODCOR=pCODCOR
   AND CODTAM=pCODTAM
   AND CODMUL=0;

BEGIN

  -- Garante exclusividade para execucao de um produto
   SELECT ATU_CM INTO vATUALIZADO
     FROM TT_SAL
    WHERE CODFIL=pCODFIL
      AND FILMAT=pFILMAT
      AND CODMAT=pCODMAT
      AND CODCOR=pCODCOR
      AND CODTAM=pCODTAM
      AND CODMUL=0
;

   IF COALESCE(vATUALIZADO,'T')='T' THEN
      RETURN NULL;
   END IF;

   SELECT CASE WHEN COUNT(*)>0 THEN 'T'
                               ELSE 'F'
          END INTO vATUALIZADO
     FROM TT_KIT
    WHERE FILMAT=pFILMAT
      AND CODMAT=pCODMAT
      AND CODCOR=pCODCOR
      AND CODTAM=pCODTAM;

   IF vATUALIZADO='T' THEN
      -- Atualiza a data na TT_SAL para nao precisar recalcular novamente
      UPDATE TT_SAL SET CAL_CM=add_day(TRUNC(agora()),1),
                        ATU_CM='T',
                        DUMMY=vVem_de_CALCUSME,
                        EST_CM=NULL,
                        TOT_CM=NULL,
                        TOTCMG=NULL
       WHERE CODFIL=pCODFIL
         AND FILMAT=pFILMAT
         AND CODMAT=pCODMAT
         AND CODCOR=pCODCOR
         AND CODTAM=pCODTAM;
      RETURN NULL;
   END IF;

  -- Zera valores nas colunas para evitar que fique lixo
  UPDATE TR_MOV MOV SET VLR_CM=NULL,
                        VLRCMG=NULL,
                        SAL_CM=NULL
   WHERE MOV.CODFIL=pCODFIL
     AND MOV.FILMAT=pFILMAT
     AND MOV.CODMAT=pCODMAT
     AND MOV.CODCOR=pCODCOR
     AND MOV.CODTAM=pCODTAM
     AND MOV.DATMOV>=(SELECT COALESCE(SAL.CAL_CM,TO_DATE('01/01/1900','DD/MM/YYYY'))
                        FROM TT_SAL SAL
                       WHERE SAL.CODFIL=pCODFIL
                         AND SAL.FILMAT=pFILMAT
                         AND SAL.CODMAT=pCODMAT
                         AND SAL.CODCOR=pCODCOR
                         AND SAL.CODTAM=pCODTAM
                         AND SAL.CODMUL=0);

  -- Pega a data inicial para o saldo e valor inicial
  SELECT TRUNC(MAX(MOV.DATMOV)),COUNT(*) INTO vDatIni, vdummy
    FROM TR_MOV MOV INNER JOIN TT_SAL SAL ON MOV.CODFIL=SAL.CODFIL
                                        AND MOV.FILMAT=SAL.FILMAT
                                        AND MOV.CODMAT=SAL.CODMAT
                                        AND MOV.CODCOR=SAL.CODCOR
                                        AND MOV.CODTAM=SAL.CODTAM
                                        AND SAL.CODMUL=0
                                        AND MOV.DATMOV<SAL.CAL_CM
                                        AND MOV.DATMOV>COALESCE(SAL.INI_CM,to_date('01/01/1900','DD/MM/YYYY'))
   WHERE MOV.CODFIL=pCODFIL
     AND MOV.FILMAT=pFILMAT
     AND MOV.CODMAT=pCODMAT
     AND MOV.CODCOR=pCODCOR
     AND MOV.CODTAM=pCODTAM
     AND SAL.CODFIL=pCODFIL
     AND SAL.FILMAT=pFILMAT
     AND SAL.CODMAT=pCODMAT
     AND SAL.CODCOR=pCODCOR
     AND SAL.CODTAM=pCODTAM
     AND (MOV.QTDVEN<>0 OR MOV.QTDCOM<>0 OR MOV.VENFIS<>0 OR MOV.SAL_CM>0 OR (SELECT COUNT(*)
                                                                                FROM TT_LAN LAN INNER JOIN TD_LAN DLAN ON LAN.TIPLAN=DLAN.CODTAB
                                                                               WHERE LAN.CODFIL = pCODFIL
                                                                                 AND LAN.FILMAT = pFILMAT
                                                                                 AND LAN.CODMAT = pCODMAT
                                                                                 AND LAN.CODCOR = pCODCOR
                                                                                 AND LAN.CODTAM = pCODTAM
                                                                                 AND LAN.DATMOV >= MOV.DATMOV
                                                                                 AND LAN.DATMOV < ADD_DAY(MOV.DATMOV,1)
                                                                                 AND LAN.SITMOV<>'C'
                                                                                 AND DLAN.MOVLEG='T')>0);

   -- Pega o saldo e valor inicial
   vTEMSALDOINI:=false;
   OPEN EstoqueInicial;
   LOOP
      FETCH EstoqueInicial INTO vAux_INI_CM, vAux_VLREST,vAux_VLRESTG,vAux_QTDEST;
      EXIT WHEN NOT FOUND;
      vINI_CM :=vAux_INI_CM ;
      vVLREST :=vAux_VLREST ;
      vVLRESTG:=vAux_VLRESTG;
      vQTDEST :=vAux_QTDEST ;
      IF (vINI_CM IS NOT NULL) THEN
         vTEMSALDOINI:=TRUE;
      END IF;
   END LOOP;
   CLOSE EstoqueInicial;

   IF (vTEMSALDOINI) AND (COALESCE(vDatIni,to_date('01/01/1900','DD/MM/YYYY'))<vINI_CM) THEN
      vDatIni:=vINI_CM;
      IF vQTDEST<>0 THEN
         vCM:=abs(vVLREST / vQTDEST);
         vCMG:=abs(vVLRESTG / vQTDEST);
      ELSE
         vCM:=abs(vVLREST);
         vCMG:=abs(vVLRESTG);
      END IF;
      vORDEM:=0;
   ELSIF vDatIni IS NOT NULL THEN
      -- Pega o saldo e valor inicial
      SELECT COALESCE(MAX(MOV.VLR_CM),0),COALESCE(MAX(MOV.VLRCMG),0), COALESCE(MAX(MOV.SAL_CM),0) INTO vVLREST,vVLRESTG,vQTDEST
        FROM TR_MOV MOV
       WHERE MOV.CODFIL=pCODFIL
         AND MOV.FILMAT=pFILMAT
         AND MOV.CODMAT=pCODMAT
         AND MOV.CODCOR=pCODCOR
         AND MOV.CODTAM=pCODTAM
         AND DATMOV=vDatIni;

      -- Pega a ultima ordem
      SELECT MAX(ORD_CM) INTO vORDEM
      FROM(
          SELECT /*+INDEX(IVE,I_FK_IVE_GRA_DATHOR_CODFIL)*/
                 COALESCE(MAX(ABS(IVE.ORD_CM)),0) AS ORD_CM
            FROM TT_IVE IVE
           WHERE IVE.CODFIL=pCODFIL
             AND IVE.FILMAT=pFILMAT
             AND IVE.CODMAT=pCODMAT
             AND IVE.CODCOR=pCODCOR
             AND IVE.CODTAM=pCODTAM
             AND IVE.VEN_DATHOR >= TRUNC( vDatIni )
             AND IVE.VEN_DATHOR <= TO_DATE( TO_CHAR(TRUNC( vDatIni ), 'DD/MM/YYYY') || ' 23:59:59', 'DD/MM/YYYY HH24:MI:SS')
             AND IVE.SITKIT<>'1'
          UNION ALL
          SELECT COALESCE(MAX(ABS(ICO.ORD_CM)),0) AS ORD_CM
            FROM TT_ICO ICO
           WHERE ICO.CODFIL=pCODFIL
             AND ICO.FILMAT=pFILMAT
             AND ICO.CODMAT=pCODMAT
             AND ICO.CODCOR=pCODCOR
             AND ICO.CODTAM=pCODTAM
             AND ICO.COM_DATOPE >= TRUNC( vDatIni )
             AND ICO.COM_DATOPE <= TO_DATE( TO_CHAR(TRUNC( vDatIni ), 'DD/MM/YYYY') || ' 23:59:59', 'DD/MM/YYYY HH24:MI:SS')
      )TAB ;

      IF vQTDEST<>0 THEN
        vCM:=abs(vVLREST / vQTDEST);
        vCMG:=abs(vVLRESTG / vQTDEST);
      ELSE
        vCM:=abs(vVLREST);
        vCMG:=abs(vVLRESTG);
      END IF;

   END IF;   

   -- Pega a ultima movimentacao valida
   vDATMOV:=vDatIni;

   OPEN Lancamento(vDatIni, CASE WHEN pNUMERODIAS>0 THEN ADD_DAY(vDatIni, pNUMERODIAS) ELSE NULL END);
   LOOP
      FETCH Lancamento INTO vCODFIL,vSEQUEN,vNUMITE,vDATMOV,vQTDMOV,vVLRMOV,vVLRCMG,vTIPMOV,vORDEMLAN,vSUBSTITUTA,
                            vSUBSTITUTA_ORI,vDEVTRA,vVLR_STDIF_ORI,vVLRICM_ORI,
                            nREDITE_ORI, nTAXICM_ORI, nMVAVEN_ORI, nREDSUB_ORI, nICMINT_ORI, sICMTIP_ORI
                            ;                           

      IF vORDEM>=0 THEN
         vORDEM:=vORDEM+1;
      ELSE
         vORDEM:=vORDEM-1;
      END IF;

      vNaoAchou:=NOT FOUND;
      
               SELECT LeParametroBoo('USACM_BASE_IMP_TRANS', vCODFIL, null, null, null) 
           INTO vUSACM_BASE_IMP_TRANS
           FROM DUAL;
      
      -- Se o dia mudou grava os valores do dia anterior em TR_MOV
      IF (vNaoAchou) OR (TRUNC(vDATMOV)<>vULTDATMOV) THEN
         IF (vNaoAchou) AND (vTEMSALDOINI) THEN
            vULTDATMOV:=TRUNC(vDatIni);
         END IF;

         UPDATE TR_MOV SET VLR_CM=vVLREST,
                           VLRCMG=vVLRESTG,
                           SAL_CM=vQTDEST
          WHERE CODFIL=pCODFIL
            AND FILMAT=pFILMAT
            AND CODMAT=pCODMAT
            AND CODCOR=pCODCOR
            AND CODTAM=pCODTAM
            AND DATMOV=TRUNC(vULTDATMOV);

      END IF;

      vTEMSALDOINI:=false;

      EXIT WHEN vNaoAchou;

      -- Calcula quantidade em estoque
      vQTDEST := COALESCE(vQTDEST,0) + vQTDMOV;

      IF vQTDEST<0 THEN
         vORDEM:=ABS(vORDEM)*-1;
      ELSE
         vORDEM:=ABS(vORDEM);
      END IF;

      -- Calcula o custo medio para entradas e saidas
      -- Atualiza a ordem na TT_IVE ou na TT_ICO
      IF (vTIPMOV = 'V') OR (vTIPMOV = 'L' AND vQTDMOV <= 0) THEN
         IF vQTDEST=0 THEN
            vVLREST := vCM;
            vVLRESTG := vCMG;
         ELSIF (vQTDEST-vQTDMOV)=0 THEN
            vVLREST := ROUND(vQTDMOV * vCM, 4);
            vVLRESTG := ROUND(vQTDMOV * vCMG, 4);
         ELSE
            vVLREST := ROUND(vQTDEST * vCM, 4);
            vVLRESTG := ROUND(vQTDEST * vCMG, 4);
         END IF;

         --43827 estoura tamanho maximo
         IF vVLREST < -9999999999.9999 THEN
            vVLREST:= 0;
         END IF;
         IF vVLRESTG < -9999999999.9999 THEN
            vVLRESTG:= 0;
         END IF;

         IF (vTIPMOV = 'V') THEN
            --Operaes no implementadas no recalculo de impostos
            -- Definio do Valor unitrio da operao com base em Frmula

            IF (vORDEMLAN = 2) AND (vTIPMOV = 'V') THEN -- Transferncia
               -- Gera o Calculo dos novos impostos
               nBASICM_CM_NEW := ABS(CASE WHEN vQTDEST = 0 
                                       THEN ROUND(vCM,4)*vQTDMOV
                                       ELSE ROUND((vVLREST / nvlz(ROUND(vQTDEST,3), 0.01)),4)*vQTDMOV
                                  END); -- Define o Valor Base
               nBAS_ST_CM_NEW := ABS(CASE WHEN vQTDEST = 0 
                                       THEN ROUND(vCM,4)*vQTDMOV
                                        ELSE ROUND((vVLREST / nvlz(ROUND(vQTDEST,3), 0.01)),4)*vQTDMOV
                                  END); -- Define o Valor Base
               -- Majorar Valor de Item Substitudos em Transferncia?
               IF ((LeParametroBoo('TRANSF_VLRITE_ST_MAJ', vCODFIL, null, null, null)='T') AND (COALESCE(nICMINT_ORI,0) > 0) AND (sICMTIP_ORI = '3')) THEN
                  nBASICM_CM_NEW := nBASICM_CM_NEW / (1 - (COALESCE(nICMINT_ORI,0) / 100)); -- Define o Valor Base
                  nBAS_ST_CM_NEW := nBAS_ST_CM_NEW / (1 - (COALESCE(nICMINT_ORI,0) / 100)); -- Define o Valor Base
               END IF;
               -- Calculo do Novo ICMS
               nBASICM_CM_NEW := ROUND(COALESCE(nBASICM_CM_NEW, 0) - (COALESCE(nBASICM_CM_NEW, 0) * (COALESCE(nREDITE_ORI,0) / 100)), 4); -- Aplica Reduo de Base de ICMS
               nVLRICM_CM_NEW := ROUND(COALESCE(nBASICM_CM_NEW, 0) * (COALESCE(nTAXICM_ORI,0) / 100), 4); -- Calcula Valor do ICMS
               -- Calculo do Novo ICMS ST
               nBAS_ST_CM_NEW := (COALESCE(nBAS_ST_CM_NEW, 0) + (COALESCE(nBAS_ST_CM_NEW, 0) * (COALESCE(nMVAVEN_ORI,0) / 100))); -- Adiciona o MVA
               nBAS_ST_CM_NEW := ROUND(COALESCE(nBAS_ST_CM_NEW, 0) - (COALESCE(nBAS_ST_CM_NEW, 0) * (COALESCE(nREDSUB_ORI,0)/100) ),4); -- Aplica Reduo da Base de ICMS ST
               nVLR_ST_CM_NEW := ROUND((COALESCE(nBAS_ST_CM_NEW, 0) * (COALESCE(nICMINT_ORI,0) / 100)) - COALESCE(nVLRICM_CM_NEW, 0), 4); -- Calcula Valor do ICMS ST
            ELSE
               nBASICM_CM_NEW := NULL;
               nVLRICM_CM_NEW := NULL;
               nBAS_ST_CM_NEW := NULL;
               nVLR_ST_CM_NEW := NULL;
            END IF;

            UPDATE TT_IVE
               SET TOT_CM = CASE WHEN vQTDEST = 0 THEN vCM
                                 WHEN vQTDEST < 0 THEN vCM*vQTDEST
                                                  ELSE vVLREST
                            END,
                   TOTCMG = CASE WHEN vQTDEST = 0 THEN vCMG
                                 WHEN vQTDEST < 0 THEN vCMG*vQTDEST
                                                  ELSE vVLRESTG
                            END,
                  SAL_CM = vQTDEST,
                   ORD_CM = vORDEM,
                   -- Verificar controles nessa atualizao
                   VLR_CM = (CASE WHEN vQTDEST = 0 
                                 THEN ROUND(vCM,4)*vQTDMOV
                                  ELSE ROUND((vVLREST / nvlz(ROUND(vQTDEST,3), 0.01)),4)*vQTDMOV
                             END),
                   VLRCMG = (CASE WHEN vQTDEST = 0 
                                 THEN ROUND(vCMG,4)*vQTDMOV
                                  ELSE ROUND((vVLRESTG / nvlz(ROUND(vQTDEST,3), 0.01)),4)*vQTDMOV
                             END),
                   -- Calculo do Novo ICMS
                   BASICM_CM = CASE WHEN (vUSACM_BASE_IMP_TRANS='F') THEN BASICM_CM ELSE nBASICM_CM_NEW END,
                   VLRICM_CM = CASE WHEN (vUSACM_BASE_IMP_TRANS='F') THEN VLRICM_CM ELSE nVLRICM_CM_NEW END,
                   -- Calculo do Novo ICMS ST
                   BAS_ST_CM = CASE WHEN (vUSACM_BASE_IMP_TRANS='F') THEN BAS_ST_CM ELSE nBAS_ST_CM_NEW END,
                   VLR_ST_CM = CASE WHEN (vUSACM_BASE_IMP_TRANS='F') THEN VLR_ST_CM ELSE nVLR_ST_CM_NEW END,
                   DUMMY  = vVem_de_CALCUSME
             WHERE CODFIL=vCODFIL
               AND SEQUEN=vSEQUEN
               AND NUMITE=vNUMITE;
         END IF;

         IF vTIPMOV = 'L' THEN
            UPDATE TT_LAN
               SET TOT_CM = CASE WHEN vQTDEST = 0 THEN vCM
                                 WHEN vQTDEST < 0 THEN vCM*vQTDEST
                                                  ELSE vVLREST
                            END,
                   TOTCMG = CASE WHEN vQTDEST = 0 THEN vCMG
                                 WHEN vQTDEST < 0 THEN vCMG*vQTDEST
                                                  ELSE vVLRESTG
                            END,
                   SAL_CM = vQTDEST,
                   ORD_CM = vORDEM
             WHERE CODFIL=vCODFIL
               AND SEQUEN=vSEQUEN;
         END IF;

       -- Transferencia
         IF (vORDEMLAN = 2) AND (vTIPMOV = 'V') THEN
            -- Se no for devoluo de transferncia recalcula os custos 
            IF (COALESCE(vDEVTRA,'F') <> 'T') THEN
               -- RFMP 92293
               -- Quando a origem e uma filial substituta, a transferencia deve ter o custo
               -- acrescido com o valor de ST e o valor de ICMS interno porque a filial
               -- de destino nao podera obter esse credito de volta

               -- RFMP 93816
               -- Correo das divergncias entre essa funo e o clculo da CustoMedio
               -- Substituio do Round pelo Trunc.

               -- Rhuan 95317
               -- Tratamento para diminuir o valor de ST e o valor de ICMS do custo
               -- quando for uma devoluo de transferncia para uma filial substituta
               UPDATE TT_ICO
                  SET VLR_CM = ABS(QTD_CM * CASE WHEN vQTDEST = 0 THEN ROUND(vCM,4)
                                              ELSE ROUND(vVLREST / nvlz(ROUND(vQTDEST,3), 0.01),4)
                                         END) +
                                 -- ICMS ST retido na fonte (campo antigo)
                                 COALESCE(ICO_VLRRET,0) +
                                 -- ICMS ST + ICMS interno
                                 CASE WHEN vDEVTRA='T' AND vSUBSTITUTA_ORI='T' AND COALESCE(vVLR_STDIF_ORI,0) > 0
                                      THEN (COALESCE(vVLR_STDIF_ORI,0)+COALESCE(vVLRICM_ORI,0))*-1
                                 ELSE
                                    CASE WHEN vSUBSTITUTA='T' AND COALESCE(VLR_STDIF,0) > 0 THEN 
                                       CASE WHEN (vUSACM_BASE_IMP_TRANS='F') THEN 
                                          COALESCE(VLR_STDIF,0)+COALESCE(VLRICM,0)
                                       ELSE
                                          COALESCE(nVLR_ST_CM_NEW,0)+COALESCE(nVLRICM_CM_NEW,0)
                                       END
                                    ELSE 0
                                    END
                                 END,
                      VLRCMG = ABS(QTD_CM * CASE WHEN vQTDEST = 0 THEN ROUND(vCMG,4)
                                              ELSE ROUND(vVLRESTG / nvlz(ROUND(vQTDEST,3), 0.01),4)
                                         END) +
                              -- ICMS ST retido na fonte (campo antigo)
                              COALESCE(ICO_VLRRET,0) +
                              -- ICMS ST + ICMS interno
                              CASE WHEN vDEVTRA='T' AND vSUBSTITUTA_ORI='T' AND COALESCE(vVLR_STDIF_ORI,0) > 0 THEN (COALESCE(vVLR_STDIF_ORI,0)+COALESCE(vVLRICM_ORI,0))*-1
                              ELSE
                                 CASE WHEN vSUBSTITUTA='T' AND COALESCE(VLR_STDIF,0) > 0 THEN 
                                    CASE WHEN (vUSACM_BASE_IMP_TRANS='F') THEN 
                                       COALESCE(VLR_STDIF,0)+COALESCE(VLRICM,0)
                                    ELSE
                                       COALESCE(nVLR_ST_CM_NEW,0)+COALESCE(nVLRICM_CM_NEW,0)
                                    END
                                 ELSE 0
                                 END
                              END,
                      -- Calculo do Novo ICMS
                      BASICM_CM = CASE WHEN (vUSACM_BASE_IMP_TRANS='F') THEN BASICM_CM ELSE nBASICM_CM_NEW END,
                      VLRICM_CM = CASE WHEN (vUSACM_BASE_IMP_TRANS='F') THEN VLRICM_CM ELSE nVLRICM_CM_NEW END,
                      -- Calculo do Novo ICMS ST
                      BAS_ST_CM = CASE WHEN (vUSACM_BASE_IMP_TRANS='F') THEN BAS_ST_CM ELSE nBAS_ST_CM_NEW END,
                      VLR_ST_CM = CASE WHEN (vUSACM_BASE_IMP_TRANS='F') THEN VLR_ST_CM ELSE nVLR_ST_CM_NEW END,
                      DUMMY=vVem_de_CALCUSME
                 WHERE (CODFIL, SEQUEN, NUMITE) IN
                      (SELECT TRA.FILICO, TRA.SEQICO, TRA.NUMICO
                       FROM TT_TRA TRA
                       WHERE TRA.FILIVE = vCODFIL
                         AND TRA.SEQIVE = vSEQUEN
                         AND TRA.NUMIVE = vNUMITE);
            END IF;
         END IF;
      ELSE
         IF vTIPMOV = 'A' THEN -- Ajustes de Custo Mdio (apenas altera valor do estoque)
            -- vVLRMOV pode ser tanto positivo como negativo
            vVLREST := vVLREST + vVLRMOV;
            vVLRESTG := vVLRESTG + vVLRMOV;
         ELSIF vTIPMOV = 'C' AND vQTDMOV=0 THEN -- Nota sem movimento de estoque mas com credito/debito no CM
            vVLREST := vVLREST + vVLRMOV;
            vVLRESTG := vVLRESTG + vVLRCMG;
         ELSIF vTIPMOV = 'N' THEN -- Nota Complementar de Custo Mdio (apenas altera valor do estoque)
            vVLREST := vVLREST + vVLRMOV;
            vVLRESTG := vVLRESTG + vVLRCMG;
         ELSE -- vTIPMOV='C', 'I', 'R' ou 'L' com quantidade positiva
            -- Quando Tipo for "Entrada" e for uma devoluo de Transferncia deve-se consultar o Valor do CM atual da Movimentao de Origem e Atualizar os valor Base da operao
            IF ((vTIPMOV='C') AND (vDEVTRA='T')) THEN
                                 SELECT TAB.VLR_CM, TAB.VLR_CMG, TAB.QTD_CM, TAB.BASICM_CM, TAB.VLRICM_CM, TAB.BAS_ST_CM, TAB.VLR_ST_CM
                    INTO nVLR_CM_ORI, nVLR_CMG_ORI, nQTD_CM_ORI, nBASICM_CM_NEW, nVLRICM_CM_NEW, nBAS_ST_CM_NEW, nVLR_ST_CM_NEW
                    FROM (
                           SELECT ABS(IVE.VLR_CM / CASE WHEN IVE.QTD_CM IS NULL OR IVE.QTD_CM = 0 THEN 1 ELSE IVE.QTD_CM END ) AS VLR_CM,
                                  ABS(IVE.VLRCMG / CASE WHEN IVE.QTD_CM IS NULL OR IVE.QTD_CM = 0 THEN 1 ELSE IVE.QTD_CM END ) AS VLR_CMG,
                                  ABS(IVE.BASICM_CM / CASE WHEN IVE.QTD_CM IS NULL OR IVE.QTD_CM = 0 THEN 1 ELSE IVE.QTD_CM END ) AS BASICM_CM,
                                  ABS(IVE.VLRICM_CM / CASE WHEN IVE.QTD_CM IS NULL OR IVE.QTD_CM = 0 THEN 1 ELSE IVE.QTD_CM END ) AS VLRICM_CM,
                                  ABS(IVE.BAS_ST_CM / CASE WHEN IVE.QTD_CM IS NULL OR IVE.QTD_CM = 0 THEN 1 ELSE IVE.QTD_CM END ) AS BAS_ST_CM,
                                  ABS(IVE.VLR_ST_CM / CASE WHEN IVE.QTD_CM IS NULL OR IVE.QTD_CM = 0 THEN 1 ELSE IVE.QTD_CM END ) AS VLR_ST_CM,
                                  ABS(IVEDEV.QTD_CM) AS QTD_CM
                             FROM TT_TRA TRADEV
                             JOIN TT_IVE IVEDEV ON TRADEV.FILIVE = IVEDEV.CODFIL  AND TRADEV.SEQIVE = IVEDEV.SEQUEN  AND TRADEV.NUMIVE = IVEDEV.NUMITE -- Nota de Devoluo
                             JOIN TT_TRA TRAENT ON TRAENT.FILICO=IVEDEV.FILICOORI AND TRAENT.SEQICO =IVEDEV.SEQICOORI AND TRAENT.NUMICO = IVEDEV.NUMICOORI -- Identificao para obter nota de Origem
                             JOIN TT_IVE IVE ON TRAENT.FILIVE = IVE.CODFIL AND TRAENT.SEQIVE = IVE.SEQUEN AND TRAENT.NUMIVE = IVE.NUMITE -- Nota de Origem da Devoluo
                            WHERE TRADEV.FILICO = vCODFIL
                              AND TRADEV.SEQICO = vSEQUEN
                              AND TRADEV.NUMICO = vNUMITE) TAB;
               
               IF (COALESCE(nVLR_CM_ORI,0) <> 0) THEN
                  vVLRMOV 	:= (nVLR_CM_ORI * vQTDMOV);
                  vVLRCMG 	:= (nVLR_CMG_ORI * vQTDMOV);

                  UPDATE TT_ICO
                     SET VLR_CM = (nVLR_CM_ORI * vQTDMOV),
                         VLRCMG = (nVLR_CMG_ORI * vQTDMOV),
                         BASICM_CM = (nBASICM_CM_NEW * vQTDMOV),
                         VLRICM_CM = (nVLRICM_CM_NEW * vQTDMOV),
                         BAS_ST_CM = (nBAS_ST_CM_NEW * vQTDMOV),
                         VLR_ST_CM = (nVLR_ST_CM_NEW * vQTDMOV),
                         DUMMY = vVem_de_CALCUSME
                   WHERE CODFIL=vCODFIL
                     AND SEQUEN=vSEQUEN
                     AND NUMITE=vNUMITE;
               END IF;
            -- Quando Tipo for "Sada" e for uma devoluo de Transferncia deve-se consultar o Valor do CM atual da Movimentao de Origem e Atualizar os valor Base da operao
            ELSIF (vTIPMOV='R') THEN
                                 SELECT TAB.VLR_CM, TAB.VLR_CMG, TAB.QTD_CM, TAB.BASICM_CM, TAB.VLRICM_CM, TAB.BAS_ST_CM, TAB.VLR_ST_CM
                    INTO nVLR_CM_ORI, nVLR_CMG_ORI, nQTD_CM_ORI, nBASICM_CM_NEW, nVLRICM_CM_NEW, nBAS_ST_CM_NEW, nVLR_ST_CM_NEW
                    FROM (
                           SELECT ABS(ICO.VLR_CM / CASE WHEN ICO.QTD_CM IS NULL OR ICO.QTD_CM = 0 THEN 1 ELSE ICO.QTD_CM END ) AS VLR_CM,
                                  ABS(ICO.VLRCMG / CASE WHEN ICO.QTD_CM IS NULL OR ICO.QTD_CM = 0 THEN 1 ELSE ICO.QTD_CM END ) AS VLR_CMG,
                                  ABS(ICO.BASICM_CM / CASE WHEN ICO.QTD_CM IS NULL OR ICO.QTD_CM = 0 THEN 1 ELSE ICO.QTD_CM END ) AS BASICM_CM,
                                  ABS(ICO.VLRICM_CM / CASE WHEN ICO.QTD_CM IS NULL OR ICO.QTD_CM = 0 THEN 1 ELSE ICO.QTD_CM END ) AS VLRICM_CM,
                                  ABS(ICO.BAS_ST_CM / CASE WHEN ICO.QTD_CM IS NULL OR ICO.QTD_CM = 0 THEN 1 ELSE ICO.QTD_CM END ) AS BAS_ST_CM,
                                  ABS(ICO.VLR_ST_CM / CASE WHEN ICO.QTD_CM IS NULL OR ICO.QTD_CM = 0 THEN 1 ELSE ICO.QTD_CM END ) AS VLR_ST_CM,
                                  ABS(IVEDEV.QTD_CM) AS QTD_CM
                             FROM TT_ICO ICO
                             JOIN TT_IVE IVEDEV ON ICO.CODFIL = IVEDEV.FILICOORI  AND ICO.SEQUEN = IVEDEV.SEQICOORI  AND ICO.NUMITE = IVEDEV.NUMICOORI -- Nota de Origem da Devoluo
                            WHERE IVEDEV.CODFIL = vCODFIL
                              AND IVEDEV.SEQUEN = vSEQUEN
                              AND IVEDEV.NUMITE = vNUMITE) TAB;
               
               IF (COALESCE(nVLR_CM_ORI,0) <> 0) THEN
                  vVLRMOV 	:= ((nVLR_CM_ORI * ABS(vQTDMOV)) * (-1));
                  vVLRCMG 	:= ((nVLR_CMG_ORI * ABS(vQTDMOV)) * (-1));

                  UPDATE TT_IVE
                     SET VLR_CM = (nVLR_CM_ORI * ABS(vQTDMOV)),
                         VLRCMG = (nVLR_CMG_ORI * ABS(vQTDMOV)),
                         BASICM_CM = (nBASICM_CM_NEW * ABS(vQTDMOV)),
                         VLRICM_CM = (nVLRICM_CM_NEW * ABS(vQTDMOV)),
                         BAS_ST_CM = (nBAS_ST_CM_NEW * ABS(vQTDMOV)),
                         VLR_ST_CM = (nVLR_ST_CM_NEW * ABS(vQTDMOV)),
                         DUMMY = vVem_de_CALCUSME
                   WHERE CODFIL=vCODFIL
                     AND SEQUEN=vSEQUEN
                     AND NUMITE=vNUMITE;
               END IF;
            END IF;
            -- Fim da atualizao do CM base da devoluo de Transferncia
         
         
            IF ((vQTDEST-vQTDMOV)<0) AND (vQTDEST<>0) THEN -- Saldo era negativo e no zerou
               vVLREST := (vVLRMOV/vQTDMOV)*vQTDEST;
               vVLRESTG := (vVLRCMG/vQTDMOV)*vQTDEST;
            ELSIF (vQTDEST=0) THEN -- ficou zero
               vVLREST := vVLRMOV/vQTDMOV;
               vVLRESTG := vVLRCMG/vQTDMOV;
            ELSIF ((vQTDEST-vQTDMOV)=0) THEN -- Saldo era zero
               vVLREST := vVLRMOV;
               vVLRESTG := vVLRCMG;
            ELSE
               vVLREST := COALESCE(vVLREST,0) + vVLRMOV;
               vVLRESTG := COALESCE(vVLRESTG,0) + vVLRCMG;
            END IF;
         END IF;

         -- Atualiza Valor Unitrio do CM com Base no Valor do CM aps Operao
         IF vQTDEST=0 THEN
            vCM   := abs(vVLREST);
            vCMG  := abs(vVLRESTG);
         ELSE
            vCM  := abs(vVLREST / vQTDEST);
            vCMG := abs(vVLRESTG / vQTDEST);
         END IF;

         IF vCM<0 THEN
            vCM:=0;
         END IF;

         IF vCMG<0 THEN
            vCMG:=0;
         END IF;

         -- Atualiza Custo Total no lanamento de origem
         IF vTIPMOV = 'L' THEN
            UPDATE TT_LAN
               SET ORD_CM = vORDEM,
                   TOT_CM = vVLREST,
                   TOTCMG = vVLRESTG,
                   SAL_CM = vQTDEST
             WHERE CODFIL=vCODFIL
               AND SEQUEN=vSEQUEN;
         ELSIF vTIPMOV = 'A' THEN
            UPDATE TT_ACM
               SET ORD_CM = vORDEM,
                   TOT_CM = vVLREST,
                   TOTCMG = vVLRESTG,
                   SAL_CM = vQTDEST
             WHERE CODFIL=vCODFIL
               AND SEQUEN=vSEQUEN;
         ELSIF vTIPMOV = 'C' THEN
            UPDATE TT_ICO
               SET ORD_CM=vORDEM,
                   TOT_CM = vVLREST,
                   TOTCMG = vVLRESTG,
                   SAL_CM = vQTDEST,
                   DUMMY=vVem_de_CALCUSME
             WHERE CODFIL=vCODFIL
               AND SEQUEN=vSEQUEN
               AND NUMITE=vNUMITE;
         ELSIF vTIPMOV = 'I' OR vTIPMOV = 'R' THEN
            UPDATE TT_IVE
               SET TOT_CM = vVLREST,
                   TOTCMG = vVLRESTG,			   
                   SAL_CM = vQTDEST,
                   ORD_CM = vORDEM,
                   DUMMY  = vVem_de_CALCUSME
             WHERE CODFIL=vCODFIL
               AND SEQUEN=vSEQUEN
               AND NUMITE=vNUMITE;
         ELSIF vTIPMOV = 'N' THEN
            UPDATE TT_ICO
               SET ORD_CM=vORDEM,
                   TOT_CM = vVLREST,
                   TOTCMG = vVLRESTG,
                   SAL_CM = vQTDEST,
                   DUMMY=vVem_de_CALCUSME
             WHERE CODFIL=vCODFIL
               AND SEQUEN=vSEQUEN
               AND NUMITE=vNUMITE;
         END IF;
      END IF;

      -- Atualiza data do ltimo movimento para controle de atualizao para TR_MOV
      vULTDATMOV:=TRUNC(vDATMOV);

   END LOOP;

   -- Atualiza a data na TT_SAL para nao precisar recalcular novamente
   UPDATE TT_SAL SET CAL_CM=add_day(TRUNC(agora()),1),
                     ATU_CM='T',
                     DUMMY=vVem_de_CALCUSME,
                     EST_CM=vQTDEST,
                     TOT_CM=trunc(vVLREST,2),
                     TOTCMG=trunc(vVLRESTG,2)
   WHERE CODFIL=pCODFIL
     AND FILMAT=pFILMAT
     AND CODMAT=pCODMAT
     AND CODCOR=pCODCOR
     AND CODTAM=pCODTAM;

   CLOSE Lancamento;

   RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 1558 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalculaCustoMedio (TR_MOV.CODFIL%TYPE,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE) CASCADE;

/*-- SEQ 1559 --*/
CREATE OR REPLACE FUNCTION CalculaCustoMedio (TR_MOV.CODFIL%TYPE,
                               TR_MOV.FILMAT%TYPE,
                               TR_MOV.CODMAT%TYPE,
                               TR_MOV.CODCOR%TYPE,
                               TR_MOV.CODTAM%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN CalculaCustoMedio($1,$2,$3,$4,$5,0);
END;
$$ language 'plpgsql';


/*-- SEQ 1560 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ChecaPermissao (TT_WOR.FILPRJ%TYPE,TT_WOR.SEQPRJ%TYPE,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1561 --*/
CREATE OR REPLACE FUNCTION ChecaPermissao (TT_WOR.FILPRJ%TYPE,TT_WOR.SEQPRJ%TYPE,TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
p_prj_filial ALIAS FOR $1 ;
p_prj_codigo ALIAS FOR $2 ;
p_usu_filial ALIAS FOR $3 ;
p_usu_codigo ALIAS FOR $4 ;
p_Oque ALIAS FOR $5 ;

MeuNome CURSOR(p_FILUSU TT_USU.FILUSU%TYPE,
           p_CODUSU TT_USU.CODUSU%TYPE) IS
    SELECT APEUSU AS NOME
    FROM TT_USU
    WHERE FILUSU = p_FILUSU
      AND CODUSU = p_CODUSU;
  
    Detalhe     record;  
    wk_Retorno  INTEGER;  
  BEGIN
    wk_Retorno := 1;
    
    IF NOT ((p_usu_filial is null) OR (p_usu_codigo is null)) THEN
      OPEN MeuNome(p_usu_filial,p_usu_codigo);    
      FETCH MeuNome INTO Detalhe;
      IF FOUND THEN
        wk_Retorno := PermissaoProjeto(p_prj_filial,p_prj_codigo,
                                       Detalhe.Nome,p_Oque);
      ELSE
        wk_Retorno := 0;
      END IF;
      CLOSE MeuNome;
    END IF;  
    RETURN wk_Retorno;
END;
$$ language 'plpgsql';




/*-- SEQ 1562 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RecalcPrj () CASCADE;

/*-- SEQ 1563 --*/
CREATE OR REPLACE FUNCTION RecalcPrj ()
RETURNS VARCHAR AS $$
DECLARE

  workflow CURSOR FOR
    SELECT WOR.FILPRJ,WOR.SEQPRJ,
           DSIT.TIPSIT,
           COALESCE(WOR.FLGACT,'N') AS FLGACT,
           COALESCE(WOR.TARREA,0)   AS TARREA,
           COALESCE(WOR.TARPRE,0)   AS TARPRE,
           COALESCE(WOR.CONCLU,0)   AS CONCLU
    FROM TT_WOR WOR INNER JOIN TD_SIT DSIT ON WOR.FLGSIT = DSIT.CODTAB;

  detalhe record;
  nulo VARCHAR(1);
                                                  
-- Principal                                       
BEGIN

  UPDATE TT_PRJ SET TOTW_A = NULL,
                    TOTW_C = NULL,
                    TOTW_I = NULL,
                    TOTW_E = NULL,
                    TOTW_X = NULL,
                    TOTW_1 = NULL,
                    TOTW_2 = NULL,
                    TOTW_S = NULL,
                    TOTA_T = NULL,
                    TOTA_F = NULL,
                    TOTA_N = NULL,
                    HORREA = NULL,
                    HORFAL = NULL;

  OPEN workflow;
  LOOP
    FETCH workflow INTO detalhe;
    EXIT WHEN NOT FOUND;

    nulo:=AUX_TotalizaNoProjeto(detalhe.FILPRJ,
                      detalhe.SEQPRJ,
                      detalhe.TIPSIT,
                      detalhe.FLGACT,
                      detalhe.TARREA,
                      detalhe.TARPRE,
                      detalhe.CONCLU);
  END LOOP;

  CLOSE workflow;
  RETURN NULL;
END;
$$ language 'plpgsql';




/*-- SEQ 1564 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CustoMedio (TT_IVE.CODFIL%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE,INTEGER,Timestamp,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1565 --*/
CREATE OR REPLACE FUNCTION CustoMedio (TT_IVE.CODFIL%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE,INTEGER,Timestamp,VARCHAR,VARCHAR)
RETURNS TR_MOV.VLR_CM%TYPE AS $$
DECLARE
p_CodFil ALIAS FOR $1 ;
p_FilMat ALIAS FOR $2 ;
p_CodMat ALIAS FOR $3 ;
p_CodCor ALIAS FOR $4 ;
p_CodTam ALIAS FOR $5 ;
p_Tipo ALIAS FOR $6 ;
p_DatRef ALIAS FOR $7 ;
p_UltimoPositivo ALIAS FOR $8 ;
pDiaFiscal ALIAS FOR $9 ;

-- Objetivo
-- 1) Retornar dados referentes ao custo medio de um produto num determinado dia

-- Obs.:
--  Parmetro pTipo:
--  1 -> Quantidade
--  2 -> Custo Mdio Fiscal Total
--  3 -> Custo Mdio Fiscal Unitrio
--  4 -> Custo Mdio Gerencial Total
--  5 -> Custo Mdio Gerencial Unitrio

-- Declarao de variveis e cursores
   nQtd                          TR_MOV.SAL_CM%TYPE;
   nValor                        TR_MOV.VLR_CM%TYPE;
   nValorG                       TR_MOV.VLRCMG%TYPE;
   dDATMOV                       TR_MOV.DATMOV%TYPE;
   dCAL_CM                       TT_SAL.CAL_CM%TYPE;
   dINI_CM                       TT_SAL.INI_CM%TYPE;
   nINI_VLREST                   TR_MOV.VLR_CM%TYPE:=0;
   nINI_VLRESTG                  TR_MOV.VLRCMG%TYPE:=0;
   nINI_QTDEST                   TR_MOV.SAL_CM%TYPE:=0;
   nQtdFiscalAnterior            TT_IVE.QTDMOV%TYPE:=0;
   cCD                           TT_IDF.CODLOJ%TYPE;

-- Cursor para pager data do movimento
-- Esta query foi separada da de movimento por questo de performance no PostgreSQL
DataMovimento CURSOR(pDataIni Timestamp) IS
  SELECT MAX(DATMOV) AS DATMOV
    FROM TR_MOV
   WHERE CODFIL = p_CodFil
     AND FILMAT = p_FilMat
     AND CODMAT = p_CodMat
     AND CODCOR = p_CodCor
     AND CODTAM = p_CodTam
     AND DATMOV <= TRUNC(p_DatRef)
     AND DATMOV > COALESCE(pDataIni,TO_DATE('01/01/1900','DD/MM/YYYY'))
     AND 1 = CASE WHEN p_Tipo=1 THEN 1
                  WHEN (p_UltimoPositivo = 'T')
                         AND ((SAL_CM>=0 AND p_Tipo=3 AND VLR_CM>0) OR
                              (SAL_CM>=0 AND p_Tipo=5 AND VLRCMG>0)) THEN 1
                  ELSE CASE WHEN ((p_UltimoPositivo = 'F') OR (not p_Tipo in (3,5))) THEN 1
                            ELSE 0
                       END
             END
     AND (QTDVEN<>0 OR QTDCOM<>0 OR VENFIS<>0 OR SAL_CM > 0 OR (SELECT COUNT(*)
                                                               FROM TT_LAN LAN INNER JOIN TD_LAN DLAN ON LAN.TIPLAN=DLAN.CODTAB
                                                              WHERE LAN.CODFIL = p_CodFil
                                                                AND LAN.FILMAT = p_FilMat
                                                                AND LAN.CODMAT = p_CodMat
                                                                AND LAN.CODCOR = p_CodCor
                                                                AND LAN.CODTAM = p_CodTam
                                                                AND LAN.DATMOV >= tr_mov.datmov
                                                                AND LAN.DATMOV < add_day(tr_mov.datmov,1)
                                                                AND LAN.SITMOV<>'C'
                                                                AND DLAN.MOVLEG='T')>0
                                                                );

-- Cursor para percorrer os lancamentos
Movimento CURSOR(pDataIni Timestamp,
           PDataMov Timestamp) IS
SELECT SAL_CM, VLR_CM, VLRCMG
  FROM TR_MOV MOV
 WHERE MOV.CODFIL = p_CodFil
   AND MOV.FILMAT = p_FilMat
   AND MOV.CODMAT = p_CodMat
   AND MOV.CODCOR = p_CodCor
   AND MOV.CODTAM = p_CodTam
   AND MOV.DATMOV = pDataMov
   AND 1 = CASE WHEN p_Tipo=1 THEN 1
               WHEN (p_UltimoPositivo = 'T')
                          AND ((SAL_CM>=0 AND p_Tipo=3 AND VLR_CM>0) OR
                               (SAL_CM>=0 AND p_Tipo=5 AND VLRCMG>0)) THEN 1
                   ELSE CASE WHEN ((p_UltimoPositivo = 'F') OR (not p_Tipo in (3,5))) THEN 1
                             ELSE 0
                        END
              END
  AND (QTDVEN<>0 OR QTDCOM<>0 OR VENFIS<>0 OR SAL_CM > 0 OR (SELECT COUNT(*)
                                                               FROM TT_LAN LAN INNER JOIN TD_LAN DLAN ON LAN.TIPLAN=DLAN.CODTAB
                                                              WHERE LAN.CODFIL = p_CodFil
                                                                AND LAN.FILMAT = p_FilMat
                                                                AND LAN.CODMAT = p_CodMat
                                                                AND LAN.CODCOR = p_CodCor
                                                                AND LAN.CODTAM = p_CodTam
                                                                AND LAN.DATMOV >= pDataMov
                                                                AND LAN.DATMOV < add_day(pDataMov,1)
                                                                AND LAN.SITMOV<>'C'
                                                                AND DLAN.MOVLEG='T')>0
                                                                );

-- Cursor para estoque inicial
EstoqueInicial CURSOR FOR
SELECT INI_CM, VLR_CM, VLRCMG, QTD_CM, CAL_CM
  FROM TT_SAL
 WHERE CODFIL=p_CodFil
   AND FILMAT=p_FilMat
   AND CODMAT=p_CodMat
   AND CODCOR=p_CodCor
   AND CODTAM=p_CodTam
   AND CODMUL=0;

-- Cursor para tratar vendas no dia anterior pertencentes a este dia fiscal
QtdFiscalAnterior CURSOR FOR
SELECT SUM(CASE WHEN IVE.VEN_DATHOR > TRUNC(p_DatRef)
                 AND IVE.VEN_DATHOR < ADD_DAY(TRUNC(p_DatRef),1)
                 AND TRUNC(VEN.DATFIS) = ADD_DAY(TRUNC(p_DatRef),1) THEN IVE.QTDMOV
                WHEN IVE.VEN_DATHOR > ADD_DAY(TRUNC(p_DatRef),1)
                 AND IVE.VEN_DATHOR < ADD_DAY(TRUNC(p_DatRef),2)
                 AND TRUNC(VEN.DATFIS) = TRUNC(p_DatRef)            THEN IVE.QTDMOV*-1
           END)
  FROM TT_IVE IVE INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
                  INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
 WHERE IVE.CODFIL=p_CodFil
   AND IVE.FILMAT=p_FilMat
   AND IVE.CODMAT=p_CodMat
   AND IVE.CODCOR=p_CodCor
   AND IVE.CODTAM=p_CodTam
   AND IVE.VEN_DATHOR > TRUNC(p_DatRef)
   AND IVE.VEN_DATHOR < ADD_DAY(TRUNC(p_DatRef),2)
   AND VEN.CODSER IN ('CF','TK')
   AND DNAT.TIPNAT <> 'I'; --Desconsidera as notas de Importao como objetos de Venda

-- Rhuan 96784 - Cursor para pegar o custo da ltima compra
-- F - Fiscal ou G - Gerencial
CustoUltimaCompra CURSOR(pTipo CHAR) IS
    SELECT TAB.VLR_CM
      FROM ( SELECT CASE WHEN pTipo = 'F' THEN MIN(ICO.VLR_CM/NVLZ(ICO.QTD_CM,1))
                         WHEN pTipo = 'G' THEN MIN(ICO.VLRCMG/NVLZ(ICO.QTD_CM,1))
                         ELSE 0
                    END AS VLR_CM, ICO.COM_DATOPE AS DATOPE
               FROM TT_ICO ICO LEFT JOIN TT_TRA TRA ON ICO.CODFIL=TRA.FILICO AND ICO.SEQUEN=TRA.SEQICO AND ICO.NUMITE=TRA.NUMICO
              WHERE ICO.COM_DATOPE<= p_DatRef
                AND ICO.FILMAT=p_FilMat
                AND ICO.CODMAT=p_CodMat
                AND ICO.CODCOR=p_CodCor
                AND ICO.CODTAM=p_CodTam
                AND TRA.FILICO IS NULL
                AND ICO.SITMOV <> 'C'
           GROUP BY ICO.COM_DATOPE
             UNION ALL
             -- Entradas de Importao
             SELECT CASE WHEN pTipo = 'F' THEN MIN(IVE.VLR_CM/ABS(NVLZ(IVE.QTD_CM,1)))
                         WHEN pTipo = 'G' THEN MIN(IVE.VLRCMG/ABS(NVLZ(IVE.QTD_CM,1)))
                         ELSE 0
                    END AS VLR_CM, IVE.VEN_DATHOR AS DATOPE
               FROM TT_IVE IVE
               INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
               INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
              WHERE IVE.SITMOV<>'C'
                AND IVE.LANEST = 'S'
                AND IVE.SITKIT<>'1'
                AND IVE.FILMAT=p_FilMat
                AND IVE.CODMAT=p_CodMat
                AND IVE.CODCOR=p_CodCor
                AND IVE.CODTAM=p_CodTam
                AND IVE.VEN_DATHOR<= p_DatRef
                AND DNAT.TIPNAT = 'I' --Considera as notas de Importao como objetos de Compra
           GROUP BY IVE.VEN_DATHOR
           ) TAB
     WHERE TAB.DATOPE = (SELECT MAX(TMP.DATOPE)
                           FROM (   SELECT MAX(DAT.COM_DATOPE) AS DATOPE
                                      FROM TT_ICO DAT LEFT JOIN TT_TRA TRA ON DAT.CODFIL=TRA.FILICO AND DAT.SEQUEN=TRA.SEQICO AND DAT.NUMITE=TRA.NUMICO
                                     WHERE DAT.FILMAT = p_FilMat
                                       AND DAT.CODMAT = p_CodMat
                                       AND DAT.CODCOR = p_CodCor
                                       AND DAT.CODTAM = p_CodTam
                                       AND DAT.SITMOV <> 'C'
                                       AND TRA.FILICO IS NULL
                                       AND DAT.COM_DATOPE <= p_DatRef
                                 UNION ALL
                                    SELECT MAX(DAT.VEN_DATHOR) AS DATOPE
                                      FROM TT_IVE DAT
                                INNER JOIN TT_VEN VEN ON VEN.CODFIL = DAT.CODFIL AND VEN.SEQUEN = DAT.SEQUEN
                                INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
                                     WHERE DAT.FILMAT = p_FilMat
                                       AND DAT.CODMAT = p_CodMat
                                       AND DAT.CODCOR = p_CodCor
                                       AND DAT.CODTAM = p_CodTam
                                       AND DAT.SITMOV <> 'C'
                                       AND DNAT.TIPNAT = 'I'  --Considera as notas de Importao como objetos de Compra
                                       AND DAT.VEN_DATHOR <= p_DatRef) TMP );
BEGIN

   OPEN EstoqueInicial;
   FETCH EstoqueInicial INTO dINI_CM, nINI_VLREST,nINI_VLRESTG, nINI_QTDEST, dCAL_CM;
   CLOSE EstoqueInicial;

   IF (p_DatRef < dINI_CM) /*or (dCAL_CM is null)*/ THEN
      RETURN 0;
   END IF;

   IF pDiaFiscal='T' THEN
      OPEN QtdFiscalAnterior;
      FETCH QtdFiscalAnterior INTO nQtdFiscalAnterior;
      CLOSE QtdFiscalAnterior;
   END IF;

   OPEN DataMovimento(dINI_CM);
   FETCH DataMovimento INTO dDATMOV;
   IF NOT FOUND THEN
      nQtd   := nINI_QTDEST;
      nValor := nINI_VLREST;
      nValorG:= nINI_VLRESTG;
      CLOSE DataMovimento;
   ELSE
      CLOSE DataMovimento;
      OPEN Movimento(dINI_CM,dDATMOV);
      FETCH Movimento INTO nQtd, nValor, nValorG;
      IF (NOT FOUND) OR
         (p_UltimoPositivo = 'T' AND
          ((p_Tipo = 3 AND COALESCE(ROUND(nValor,2),0)<=0 AND nINI_VLREST>=0) OR
           (p_Tipo = 5 AND COALESCE(ROUND(nValorG,2),0)<=0 AND nINI_VLRESTG>=0))) THEN
         nQtd   := nINI_QTDEST;
         nValor := nINI_VLREST;
         nValorG:= nINI_VLRESTG;
      END IF;
      Close Movimento;
   END IF;


   IF p_Tipo = 1 THEN
      RETURN TRUNC(nQtd,3) + COALESCE(nQtdFiscalAnterior,0);
   END IF;

   IF COALESCE(nQtd,0)=0  THEN
      IF (p_Tipo IN (2,4)) OR ((LeParametroBoo('CM_ZERO_SEMEST', null, null, null, null)='T')) THEN
         RETURN 0;
      ELSIF p_Tipo = 3 THEN
         IF COALESCE(nValor,0)=0 THEN
            SELECT CODLOJ INTO cCD
              FROM TT_IDF;
            IF cCD<>p_CODFIL THEN
               RETURN CustoMedio(cCD,p_filmat,p_codmat,p_codcor,p_codtam,3,p_DatRef);
            ELSIF p_UltimoPositivo= 'T' THEN
               RETURN CustoMedio(cCD,p_filmat,p_codmat,p_codcor,p_codtam,3,p_DatRef,'F');
            END IF;
         END IF;

         -- Rhuan - 96784 - Pega o custo da ltima compra caso no tenha conseguido calcular o valor
         IF COALESCE(nValor,0)=0 THEN
            OPEN CustoUltimaCompra('F');
            FETCH CustoUltimaCompra INTO nValor;
            CLOSE CustoUltimaCompra;

            RETURN round(nValor,4);
         END IF;
      ELSIF p_Tipo = 5 THEN
         IF COALESCE(nValorG,0)=0 THEN
            SELECT CODLOJ INTO cCD
              FROM TT_IDF;
            IF cCD<>p_CODFIL THEN
               RETURN CustoMedio(cCD,p_filmat,p_codmat,p_codcor,p_codtam,5,p_DatRef);
            ELSIF p_UltimoPositivo= 'T' THEN
               RETURN CustoMedio(cCD,p_filmat,p_codmat,p_codcor,p_codtam,5,p_DatRef,'F');
            END IF;
         END IF;

         -- Rhuan - 96784 - Pega o custo da ltima compra caso no tenha conseguido calcular o valor
         IF COALESCE(nValorG,0)=0 THEN
            OPEN CustoUltimaCompra('G');
            FETCH CustoUltimaCompra INTO nValorG;
            CLOSE CustoUltimaCompra;

            RETURN round(nValorG,4);
         END IF;
      END IF;
   END IF;

   IF COALESCE(nQTD,0)<0  AND p_Tipo IN (2,4) THEN
      RETURN 0;
   END IF;

   IF p_Tipo = 2 THEN
      RETURN ROUND(nValor,2) + ROUND((ROUND(nValor,2) / nvlz(ROUND(nQtd,3), 0.01))*COALESCE(nQtdFiscalAnterior,0),2);
   ELSIF p_Tipo = 3 THEN
      IF COALESCE(nValor,0)=0 THEN
         -- Rhuan - 96784 - Pega o custo da ltima compra caso no tenha conseguido calcular o valor
         OPEN CustoUltimaCompra('F');
         FETCH CustoUltimaCompra INTO nValor;
         CLOSE CustoUltimaCompra;

         RETURN ROUND(nValor,4);
      ELSE
         IF ROUND(nQtd,3) = 0 THEN
            RETURN ROUND(nValor,4);
         ELSE
            RETURN ROUND(ROUND(nValor,2) / nvlz(ROUND(nQtd,3), 0.01),4);
         END IF;
      END IF;
      RETURN ROUND(ROUND(nValor,2) / nvlz(ROUND(nQtd,3), 0.01),4);
   ELSIF p_Tipo = 4 THEN
      RETURN ROUND(nValorG,2) + ROUND((ROUND(nValorG,2) / nvlz(ROUND(nQtd,3), 0.01))*COALESCE(nQtdFiscalAnterior,0),2);
   ELSIF p_Tipo = 5 THEN
      IF COALESCE(nValorG,0)=0 THEN
         -- Rhuan - 96784 - Pega o custo da ltima compra caso no tenha conseguido calcular o valor
         OPEN CustoUltimaCompra('G');
         FETCH CustoUltimaCompra INTO nValorG;
         CLOSE CustoUltimaCompra;

         RETURN ROUND(nValorG,4);
      ELSE
         IF ROUND(nQtd,3) = 0 THEN
            RETURN ROUND(nValorG,4);
         ELSE
            RETURN ROUND(ROUND(nValorG,2) / nvlz(ROUND(nQtd,3), 0.01),4);
         END IF;
      END IF;
   ELSE
      RETURN Null; /* Erro: parametro invalido */
   END IF;

   END;
$$ language 'plpgsql';


/*-- SEQ 1566 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CustoMedio (TT_IVE.CODFIL%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE,INTEGER,Timestamp,VARCHAR) CASCADE;

/*-- SEQ 1567 --*/
CREATE OR REPLACE FUNCTION CustoMedio (TT_IVE.CODFIL%TYPE,
                               TT_IVE.FILMAT%TYPE,
                               TT_IVE.CODMAT%TYPE,
                               TT_IVE.CODCOR%TYPE,
                               TT_IVE.CODTAM%TYPE,
                               INTEGER,
                               Timestamp,
                               VARCHAR) 
RETURNS TR_MOV.VLR_CM%TYPE AS $$
BEGIN
RETURN CustoMedio($1,$2,$3,$4,$5,$6,$7,$8,'F');
END;
$$ language 'plpgsql';


/*-- SEQ 1568 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CustoMedio (TT_IVE.CODFIL%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE,INTEGER,Timestamp) CASCADE;

/*-- SEQ 1569 --*/
CREATE OR REPLACE FUNCTION CustoMedio (TT_IVE.CODFIL%TYPE,
                               TT_IVE.FILMAT%TYPE,
                               TT_IVE.CODMAT%TYPE,
                               TT_IVE.CODCOR%TYPE,
                               TT_IVE.CODTAM%TYPE,
                               INTEGER,
                               Timestamp) 
RETURNS TR_MOV.VLR_CM%TYPE AS $$
BEGIN
RETURN CustoMedio($1,$2,$3,$4,$5,$6,$7,'T','F');
END;
$$ language 'plpgsql';


/*-- SEQ 1570 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CustoMedio (TT_IVE.CODFIL%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE,INTEGER) CASCADE;

/*-- SEQ 1571 --*/
CREATE OR REPLACE FUNCTION CustoMedio (TT_IVE.CODFIL%TYPE,
                               TT_IVE.FILMAT%TYPE,
                               TT_IVE.CODMAT%TYPE,
                               TT_IVE.CODCOR%TYPE,
                               TT_IVE.CODTAM%TYPE,
                               INTEGER) 
RETURNS TR_MOV.VLR_CM%TYPE AS $$
BEGIN
RETURN CustoMedio($1,$2,$3,$4,$5,$6,agora(),'T','F');
END;
$$ language 'plpgsql';


/*-- SEQ 1572 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CustoMedio (TT_IVE.CODFIL%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE) CASCADE;

/*-- SEQ 1573 --*/
CREATE OR REPLACE FUNCTION CustoMedio (TT_IVE.CODFIL%TYPE,
                               TT_IVE.FILMAT%TYPE,
                               TT_IVE.CODMAT%TYPE,
                               TT_IVE.CODCOR%TYPE,
                               TT_IVE.CODTAM%TYPE) 
RETURNS TR_MOV.VLR_CM%TYPE AS $$
BEGIN
RETURN CustoMedio($1,$2,$3,$4,$5,0,agora(),'T','F');
END;
$$ language 'plpgsql';


/*-- SEQ 1574 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TRAZDESCRICAOFATURAMENTO (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE) CASCADE;

/*-- SEQ 1575 --*/
CREATE OR REPLACE FUNCTION TRAZDESCRICAOFATURAMENTO (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILCLI ALIAS FOR $1 ;
pCODCLI ALIAS FOR $2 ;

DATAS CURSOR FOR
SELECT DESCCC, OBSERV, TIPO
 FROM (SELECT DCCC.DESCCC, 
              LIM.OBSERV, 
              99 AS DIAMES, 99 AS DIASEM, 1 AS TIPO
       FROM TT_LIM LIM inner join td_ccc dccc on lim.tipccc = dccc.codtab 
       WHERE LIM.FILCLI = pFILCLI
         AND LIM.CODCLI = pCODCLI
         AND LIM.OBSERV IS NOT NULL
       UNION ALL
       SELECT DCCC.DESCCC, 
              CASE WHEN DIAMES <> 0 
                   THEN TO_CHAR(DIAMES)
                   ELSE CASE  WHEN DIASEM = 1 THEN 'Seg'
                              WHEN DIASEM = 2 THEN 'Ter'
                              WHEN DIASEM = 3 THEN 'Qua'
                              WHEN DIASEM = 4 THEN 'Qui'
                              WHEN DIASEM = 5 THEN 'Sex'
                              WHEN DIASEM = 6 THEN 'Sb'
                              WHEN DIASEM = 7 THEN 'Dom' END    
              END AS observ, 
              DIAMES, DIASEM, 2 AS TIPO
       FROM TT_dxc dxc inner join td_ccc dccc on dxc.codccc = dccc.codtab 
                       inner join tt_lim lim  on dxc.filcli = lim.filcli and dxc.codcli = lim.codcli 
		                             and dxc.codCCC = lim.TIPCCC , TT_CFG CFG
       WHERE DXC.FILCLI = pFILCLI
         AND DXC.CODCLI = pCODCLI
         AND CFG.ENVIADATFATURAMENTO = 'T') INT
ORDER BY TIPO, DESCCC, DIAMES, DIASEM;

 cDESCCC   TD_CCC.DESCCC%TYPE;
 oldDESCCC TD_CCC.DESCCC%TYPE;
 cOBSERV TT_LIM.OBSERV%TYPE;
 cTIPO   Numeric(1);
 cQUAL   Numeric(1);
 RESULTADO VARCHAR(4000);

BEGIN

  RESULTADO :=''; 
  oldDESCCC := '*! LIXO !*';
  cQual := 0;
  OPEN DATAS;
  LOOP
    FETCH DATAS INTO cDESCCC, cOBSERV, cTIPO;
    EXIT WHEN NOT FOUND;
    IF cTIPO = 1 THEN
       RESULTADO := RESULTADO || cDESCCC || ': ' || cOBSERV || CHR(13) || CHR(10);
    ELSE
       IF cQUAL = 0 THEN
          RESULTADO := RESULTADO || 'VENCIMENTOS:';
          cQUAL := 1;
       END IF;
       IF oldDESCCC <> cDESCCC THEN
          oldDESCCC := cDESCCC;
          RESULTADO := RESULTADO || CHR(13) || CHR(10) || '- ' || cDESCCC || ' - ' || cOBSERV;
       ELSE
          RESULTADO := RESULTADO || '/' || cOBSERV;
       END IF;
    END IF;
  END LOOP;
  CLOSE DATAS;
  RETURN RESULTADO;
  
END;
$$ language 'plpgsql';






/*-- SEQ 1576 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TO_DDD (TT_END.CODDDD%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1577 --*/
CREATE OR REPLACE FUNCTION TO_DDD (TT_END.CODDDD%TYPE,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
FONE ALIAS FOR $1 ;
FORCA ALIAS FOR $2 ;
BEGIN
  RETURN TO_PHONE(Fone,Forca,'SHORT');
END;
$$ language 'plpgsql';


/*-- SEQ 1578 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TO_DDD (TT_END.CODDDD%TYPE) CASCADE;

/*-- SEQ 1579 --*/
CREATE OR REPLACE FUNCTION TO_DDD (TT_END.CODDDD%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN TO_DDD($1,'FORCE');
END;
$$ language 'plpgsql';


/*-- SEQ 1580 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GeraWFPREXDIF () CASCADE;

/*-- SEQ 1581 --*/
CREATE OR REPLACE FUNCTION GeraWFPREXDIF ()
RETURNS VARCHAR AS $$
DECLARE


VENDAS CURSOR FOR
SELECT IPXD.FILAPL AS APLICA,
       CASE WHEN PERIOD > DIAACP THEN '1' ELSE '2' END AS SITUACAO,
       CASE WHEN TRUNC(AGORA()) >= ADD_DAY(COALESCE(DATULT,DATINI),PERIOD) THEN 'F' ELSE 'T' END AS PARCIAL,
       PXD.*
  FROM TT_PREXDIF PXD LEFT OUTER JOIN TT_IPREXDIF IPXD ON PXD.CODFIL = IPXD.CODFIL AND PXD.SEQUEN = IPXD.SEQUEN
 WHERE SIGNAT > -1
   AND FILACP IS NOT NULL AND CODACP IS NOT NULL			 --USUARIO ACOMPANHAMENTO
   AND FILCLI IS NOT NULL AND CODCLI IS NOT NULL
   AND COALESCE(DIAACP,0) > 0
   AND AGORA() BETWEEN DATINI AND DATFIM
   AND ADD_DAY(COALESCE(DATPAR,DATINI),DIAACP) <= TRUNC(AGORA())	 --AVISOS PARCIAIS SITUACAO 1
   AND ADD_DAY(COALESCE(DATULT,DATINI),DIAACP) <= TRUNC(AGORA());         --AVISOS GERAIS   SITUACAO 2

pVOLUME Numeric(10);
pCONSUMO_MINIMO Numeric(10);
pCONSUMO_MINIMO_PARCIAL Numeric(10);
pPRAZO_INI   Timestamp;
pPRAZO_FIM   Timestamp;
pTIPTAR_CFG TD_CWS.CODTAB%TYPE;
pTIPCWS_CFG TD_CWS.TIPCWS%TYPE;
vFILN2  TT_PRJ.CODFIL%TYPE;
vSEQN2  TT_PRJ.SEQUEN%TYPE;
vFILPRJ TT_PRJ.CODFIL%TYPE;
vSEQPRJ TT_PRJ.SEQUEN%TYPE;
vNOMPRJ TT_PRJ.NOMPRJ%TYPE;
vFILUSU TT_USU.FILUSU%TYPE;
vCODUSU TT_USU.CODUSU%TYPE;
vTAREFA    VARCHAR(4000);
vPRODUTO   VARCHAR(100);
vPERIODO   VARCHAR(50);
vCLIENTE   VARCHAR(50);
vDESCRI    VARCHAR(8);
c_LF    CHAR(2) := chr(13)||chr(10);
vComplemento CONSTANT VARCHAR(254):= constante('complemento');
vCODIGO       TT_PAP.CODFIL%TYPE;
vSEQUENCIA    TT_PAP.SEQUEN%TYPE;
  QuemLogou TRetQuemLogou%ROWTYPE;


i RECORD;

BEGIN


  select * into QuemLogou from DadosLogon();
  IF not QuemLogou.Encontrou THEN
    RAISE EXCEPTION 'PG-20050 Voce nao e um usuario cadastrado no sistema %' , vComplemento;
  END IF;

  OPEN VENDAS;
  LOOP
    FETCH VENDAS INTO i;
    EXIT WHEN NOT FOUND;

	pVOLUME:=0;

	-- VERIFICA PRAZOS
	IF i.SITUACAO = '1' THEN    --PERIOD > DIAACP
		IF i.PARCIAL = 'T' THEN
		   --Parcial
		   SELECT COALESCE(DATULT,DATINI), ADD_DAY(COALESCE(DATPAR,DATINI),DIAACP) INTO pPRAZO_INI, pPRAZO_FIM from TT_PREXDIF
		    WHERE CODFIL = i.CODFIL
		      AND SEQUEN = i.SEQUEN;
		ELSE
		   --Completo
		   SELECT COALESCE(DATULT,DATINI), ADD_DAY(COALESCE(DATULT,DATINI),PERIOD) INTO pPRAZO_INI, pPRAZO_FIM from TT_PREXDIF
		    WHERE CODFIL = i.CODFIL
		      AND SEQUEN = i.SEQUEN;
		END IF;
	ELSE   --DIAACP > PERIOD   --NO EXISTE PARCIAL PARA ESTA SITUAO
 	   --Completo
	   SELECT COALESCE(DATULT,DATINI), ADD_DAY(COALESCE(DATULT,DATINI),DIAACP) INTO pPRAZO_INI, pPRAZO_FIM from TT_PREXDIF
	    WHERE CODFIL = i.CODFIL
	      AND SEQUEN = i.SEQUEN;

	END IF;


	-- CALCULA VOLUME DE VENDAS PARA O PRODUTO xxx , FEITO PELO CLIENTE xxx
	IF i.APLICA <> '' THEN
		SELECT COALESCE(SUM(QTDMOV),0) INTO pVOLUME
		  FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
		 WHERE IVE.FILMAT = i.FILMAT
		   AND IVE.CODMAT = i.CODMAT
		   AND IVE.CODCOR = i.CODCOR
		   AND IVE.CODTAM = i.CODTAM
		   AND VEN.FILCLI = i.FILCLI
		   AND VEN.CODCLI = i.CODCLI
		   AND IVE.VEN_DATHOR BETWEEN TO_DATE(TO_CHAR(TRUNC(pPRAZO_INI),'DD/MM/YYYY') ||' 00:00:00', 'DD/MM/YYYY HH24:MI:SS') AND
					      TO_DATE(TO_CHAR(TRUNC(pPRAZO_FIM),'DD/MM/YYYY') ||' 23:59:59', 'DD/MM/YYYY HH24:MI:SS')
		   AND VEN.CODFIL = i.APLICA;


	ELSE
		SELECT COALESCE(SUM(QTDMOV),0) INTO pVOLUME
		  FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
		 WHERE IVE.FILMAT = i.FILMAT
		   AND IVE.CODMAT = i.CODMAT
		   AND IVE.CODCOR = i.CODCOR
		   AND IVE.CODTAM = i.CODTAM
		   AND VEN.FILCLI = i.FILCLI
		   AND VEN.CODCLI = i.CODCLI
		   AND IVE.VEN_DATHOR BETWEEN TO_DATE(TO_CHAR(TRUNC(pPRAZO_INI),'DD/MM/YYYY') ||' 00:00:00', 'DD/MM/YYYY HH24:MI:SS') AND
					      TO_DATE(TO_CHAR(TRUNC(pPRAZO_FIM),'DD/MM/YYYY') ||' 23:59:59', 'DD/MM/YYYY HH24:MI:SS');

	END IF;



        pCONSUMO_MINIMO := 0;
	pCONSUMO_MINIMO_PARCIAL := 0;

	IF i.SITUACAO = '1' THEN    --PERIOD > DIAACP
		   --Consumo minimo estimado para o periodo completo
		   SELECT ((PERIOD/DIAACP)* QTDMIN) INTO pCONSUMO_MINIMO FROM TT_PREXDIF
		    WHERE CODFIL = i.CODFIL
		      AND SEQUEN = i.SEQUEN;

		IF i.PARCIAL = 'T' THEN
		   --Consumo minimo estimado para o periodo parcial at o momento
		   SELECT TRUNC(TRUNC(AGORA() - COALESCE(DATULT,DATINI)) / DIAACP) * QTDMIN INTO pCONSUMO_MINIMO_PARCIAL FROM TT_PREXDIF
		    WHERE CODFIL = i.CODFIL
		     AND SEQUEN = i.SEQUEN;
		END IF;


	ELSE   --DIAACP > PERIOD   --NO EXISTE PARCIAL PARA ESTA SITUAO
	   --Consumo minimo estimado para o periodo completo acompanhamento
	   SELECT ((DIAACP/PERIOD)* QTDMIN) INTO pCONSUMO_MINIMO FROM TT_PREXDIF
	    WHERE CODFIL = i.CODFIL
	      AND SEQUEN = i.SEQUEN;
	END IF;


--       RAISE_APPLICATION_ERROR( '-20001', FORMATASTRING('  % - % - % ' , i.SEQUEN||','||pVOLUME||','||pCONSUMO_MINIMO));

	-- CASO O VOLUME SEJA MENOR QUE A QUANTIDADE MINIMA, CRIAR TAREFA
        IF (pVOLUME < pCONSUMO_MINIMO) OR (pVOLUME < pCONSUMO_MINIMO_PARCIAL) THEN

		SELECT FILPRJ_PXD, SEQPRJ_PXD INTO vFILPRJ,vSEQPRJ FROM TT_CFG;

		--Se vier vazio, no existe ainda na TT_CFG, ento criar projeto padro e gravar na TT_CFG
		IF (COALESCE(vFILPRJ,0) = 0) AND (COALESCE(vSEQPRJ,0) = 0) THEN

		   vNOMPRJ:= 'Preos Diferenciados';
		   vFILUSU := QuemLogou.FILUSU;
		   vCODUSU := QuemLogou.CODUSU;

		   SELECT CODLOJ, PROXIMOCODIGO('TT_PRJ',CODLOJ) INTO vFILN2,vSEQN2 FROM TT_IDF;


		   INSERT INTO TT_PRJ (CODFIL,SEQUEN,NOMPRJ,DATREG,ATU_EM   ,FILREG,CODREG,FILATU,CODATU    ) VALUES
                                      (vFILN2,vSEQN2,vNOMPRJ,AGORA(),AGORA(),vFILUSU,vCODUSU,vFILUSU,vCODUSU);

                   INSERT INTO TT_PAP (CODFIL,DESPAP) VALUES
		                      (vFILN2,'Preo Diferenciado');

                   SELECT CODFIL,SEQUEN INTO vCODIGO,vSEQUENCIA FROM TT_PAP WHERE DESPAP LIKE 'Preo Diferenciado';

		   INSERT INTO TT_PRJXPAP (FILPRJ,SEQPRJ,FILPAP,SEQPAP) VALUES
		                          (vFILN2,vSEQN2,vCODIGO,vSEQUENCIA);

                   UPDATE TT_CFG SET FILPRJ_PXD = vFILN2, SEQPRJ_PXD = vSEQN2;

		END IF;

 		SELECT FILPRJ_PXD, SEQPRJ_PXD INTO vFILPRJ,vSEQPRJ FROM TT_CFG;
                SELECT CODFIL,SEQUEN INTO vCODIGO,vSEQUENCIA FROM TT_PAP WHERE DESPAP LIKE 'Preo Diferenciado';

   	        SELECT CODTAB,TIPCWS INTO pTIPTAR_CFG,pTIPCWS_CFG
		  FROM TD_CWS CWS
	         WHERE CWS.codtab= 0;

		 --Pega produto e referencia para descrio da tarefa
		 SELECT TRIM(DESMAT)||' - Referncia: '||GRA.REFPRO INTO vPRODUTO
                   FROM TT_PRO PRO INNER JOIN TT_GRA GRA ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
		  WHERE PRO.FILMAT = i.FILMAT
		    AND PRO.CODMAT = i.CODMAT;

		 --Pega cliente para descrio da tarefa
		 SELECT TRIM(NOMCLI)  INTO vCLIENTE FROM TT_CLI
		  WHERE FILCLI = i.FILCLI
		    AND CODCLI = i.CODCLI;

		 --Pega datas para descrio da tarefa
		 SELECT TRUNC(DATINI)||' AT '|| TRUNC(DATFIM) INTO vPERIODO FROM TT_PREXDIF
                  WHERE CODFIL = i.CODFIL
                    AND SEQUEN = i.SEQUEN;


                 --Monta descrio da tarefa
		 vTAREFA := 'O volume de vendas est abaixo do valor negociado para o produto: ' || vPRODUTO || c_LF
		          ||'Cliente: '|| vCLIENTE || c_LF
			  ||'Perdo de validade para preos diferenciados: '|| vPERIODO || c_LF
			  ||'Perdo acompanhado de '|| TO_CHAR(pPRAZO_INI) ||' at '|| TO_CHAR(pPRAZO_FIM) || c_LF
			  ||'Consumo mnimo acordado para o perodo : '|| TO_CHAR(pCONSUMO_MINIMO) || c_LF ;

		 IF i.PARCIAL = 'T' THEN
			  vTAREFA := vTAREFA
		          ||'Consumo mnimo acordado para o perodo de acompanhamento : '|| TO_CHAR(i.QTDMIN) || c_LF
		          ||'Consumo mnimo acordado para o perodo de acompanhamento at '|| TO_CHAR(pPRAZO_FIM) ||' : '|| TO_CHAR(pCONSUMO_MINIMO_PARCIAL) || c_LF
			  ||'Quantidade consumida de '|| TO_CHAR(pPRAZO_INI) ||' at '|| TO_CHAR(pPRAZO_FIM) ||' : '|| TO_CHAR(pVOLUME) || c_LF ;

			  vDESCRI:= 'PARCIAL';
		 ELSE
			  vTAREFA := vTAREFA
			  ||'Quantidade consumida de '|| TO_CHAR(pPRAZO_INI) ||' at '|| TO_CHAR(pPRAZO_FIM) ||' : '|| TO_CHAR(pVOLUME);

			  vDESCRI:= 'COMPLETA';
		 END IF;


                IF ChecaPermissao(vFILPRJ,vSEQPRJ,i.FILACP,i.CODACP,CONSTANTE('wf_ler_projeto')) = 0 THEN
   		   INSERT INTO TT_PAPXUSU (FILPAP,SEQPAP,FILUSU,CODUSU) VALUES (vCODIGO,vSEQUENCIA,i.FILACP,i.CODACP);
                END IF;

                insert into tt_wor
                       (codfil, sequen, destar, modulo, versao, tiptar, tipcws, flgsit, fatura,
                        tarpre, cobrar, filprj, seqprj, conclu, filres, codres, filtst, codtst,
                        filcli, codcli, priori, reserv, pricli, tarefa)
                ( select IDF.CODLOJ AS CODFIL,
                         PROXIMOCODIGO('TT_WOR',IDF.CODLOJ) AS SEQUEN,
                         'Quantidade vendida inferior a Quantidade mnima negociada - '||vDESCRI as DESTAR,
                         0 as MODULO,
                         '???' as VERSAO,
                         pTIPTAR_CFG AS TIPTAR,
                         pTIPCWS_CFG as TIPCWS,
                         (SELECT CODTAB FROM TD_SIT WHERE TIPSIT = 'A') as flgsit,
                         TO_CHAR('A') AS FATURA,
                         0 AS TARPRE,
                         0 AS COBRAR,
                         vFILPRJ AS FILPRJ,
                         vSEQPRJ AS SEQPRJ,
                         0 AS CONCLU,
                         i.FILACP AS FILRES,
                         i.CODACP AS CODRES,
                         i.FILREG AS FILTST,
                         i.CODREG AS CODTST,
                         i.FILCLI AS FILCLI,
                         i.CODCLI AS CODCLI,
                         2 AS PRIORI,
                         TO_CHAR('F') AS RESERV,
                         2 AS PRICLI,
                         vTAREFA AS TAREFA
                    FROM TT_IDF IDF
                );


	END IF;


	IF i.SITUACAO = '1' THEN    --PERIOD > DIAACP
		IF i.PARCIAL = 'T' THEN
		  UPDATE TT_PREXDIF SET DATPAR = AGORA()
		   WHERE CODFIL = i.CODFIL
		     AND SEQUEN = i.SEQUEN;
		ELSE
		  UPDATE TT_PREXDIF SET DATULT = AGORA(), DATPAR = AGORA()
		   WHERE CODFIL = i.CODFIL
		     AND SEQUEN = i.SEQUEN;
		END IF;
	ELSE   --DIAACP > PERIOD   --NO EXISTE PARCIAL PARA ESTA SITUAO
	  UPDATE TT_PREXDIF SET DATULT = AGORA()
	   WHERE CODFIL = i.CODFIL
	     AND SEQUEN = i.SEQUEN;
	END IF;


  END LOOP;
  CLOSE VENDAS;

  RETURN 'OK';
END;
$$ language 'plpgsql';





/*-- SEQ 1582 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GiroEstoque (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TT_CFG.GIRO_ESTOQUE%TYPE,TR_MOV.PROMOC%TYPE,TT_CFG.GIRO_ESTOQUE%TYPE) CASCADE;

/*-- SEQ 1583 --*/
CREATE OR REPLACE FUNCTION GiroEstoque (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TT_CFG.GIRO_ESTOQUE%TYPE,TR_MOV.PROMOC%TYPE,TT_CFG.GIRO_ESTOQUE%TYPE)
RETURNS Numeric AS $$
DECLARE
pDatIni ALIAS FOR $1 ;
pDatFim ALIAS FOR $2 ;
pFilMat ALIAS FOR $3 ;
pCodMat ALIAS FOR $4 ;
pCodCor ALIAS FOR $5 ;
pCodTam ALIAS FOR $6 ;
pCodFil ALIAS FOR $7 ;
pTipoDeDia ALIAS FOR $8 ;
pPromocao ALIAS FOR $9 ;
pTipoDeGiro ALIAS FOR $10 ;
/* Objetivo:
   Calcular o Giro de estoque de um determinado produto no periodo
   O Calculo eh somente por filial, ja que TR_MOV tem saldos por filial

   A função calcula as seguintes formas de giro:
   1) Considerando dias corridos.
   2) Fora da promoção considerando dias corridos.
   3) Considerando dias úteis com estoque.
   4) Fora da promoção considerando dias úteis com estoque.
*/
    wvAux            VARCHAR(500);                --  var auxiliar (leitura dos dados de ResumoVenPro)
    vQTD_GIRO        Numeric;
    fTOT_SALDIA      Numeric;
    fTOT_QTDVEN      Numeric;
    iTOT_DIAS        INTEGER;
    iTOT_DIAS_PROMOC INTEGER;
    iTOT_DIAS_SEMEST INTEGER;
    fTOT_SALDO_CM    Numeric;
    fTOT_VALOR_CM    Numeric;
    fTOT_VALOR_CMG   Numeric;
  
--  --------------------------------------------------------
begin

    IF pTipoDeDia NOT IN ('C','A') THEN
      RAISE EXCEPTION 'PG-20000 Valor inválido para parâmetro "pTipoDeDia".';
    END IF;

    IF pPromocao NOT IN ('T','F') THEN
      RAISE EXCEPTION 'PG-20000 Valor inválido para parâmetro "pPromocao".';
    END IF;

    /*
      E - ESTOQUE (PADRÃO)
      S - SALDO DO CUSTO MÉDIO
      V - VALOR DO CUSTO MÉDIO
      G - CUSTO MÉDIO GERENCIAL
    */
    IF pTipoDeGiro NOT IN ('E', 'S', 'V', 'G') THEN
      RAISE EXCEPTION 'PG-20000 Valor inválido para parâmetro "pTipoDeGiro".';
    END IF;

    --  o codigo anterior foi removido e foi chamada a funcao que centraliza a codificacao comum (ResumoVenPro)
    wvAux := ResumoVenPro(pDatIni, pDatFim, pFilMat, pCodMat, pCodCor, pCodTam, pCodFil, pTipoDeDia, pPromocao);
    iTOT_DIAS        := Split_Part_Number(wvAux,';', 1);
    fTOT_QTDVEN      := Split_Part_Number(wvAux,';', 2);
    fTOT_SALDIA      := Split_Part_Number(wvAux,';', 3);
    fTOT_SALDO_CM    := Split_Part_Number(wvAux,';', 6);
    fTOT_VALOR_CM    := Split_Part_Number(wvAux,';', 7);
    fTOT_VALOR_CMG   := Split_Part_Number(wvAux,';', 8);

    -- Usado para "debug" em Postgres - Retirar comentário apenas para testes
    /*
      RAISE NOTICE ''wvAux=%'',wvAux;      RAISE NOTICE ''iTOT_DIAS_PROMOC=%'',iTOT_DIAS_PROMOC;      RAISE NOTICE ''iTOT_DIAS_SEMEST=%'',iTOT_DIAS_SEMEST;      RAISE NOTICE ''fTOT_QTDVEN=%'',fTOT_QTDVEN;      RAISE NOTICE ''iTOT_DIAS=%'',iTOT_DIAS;      RAISE NOTICE ''fTOT_SALDIA=%'',fTOT_SALDIA;      RAISE NOTICE ''fTOT_SALDO_CM=%'',fTOT_SALDO_CM;      RAISE NOTICE ''fTOT_VALOR_CM=%'',fTOT_VALOR_CM;      RAISE NOTICE ''fTOT_VALOR_CMG=%'',fTOT_VALOR_CMG;    */
    
   IF (pTipoDeGiro = 'E') THEN
     vQTD_GIRO := CASE WHEN NVLZ(fTOT_SALDIA, 0) = 0 OR NVLZ(iTOT_DIAS, 0) = 0 
                       THEN 0
                       ELSE COALESCE(fTOT_QTDVEN / (fTOT_SALDIA / iTOT_DIAS), 0) 
                  END; 
   END IF;

   IF (pTipoDeGiro = 'S') THEN
     vQTD_GIRO :=  COALESCE(fTOT_SALDO_CM / NVLZ(fTOT_SALDIA, 1), 0);
   END IF;

   IF (pTipoDeGiro = 'V') THEN
     vQTD_GIRO :=  COALESCE(fTOT_VALOR_CM / NVLZ(fTOT_SALDIA, 1), 0);
   END IF;

   IF (pTipoDeGiro = 'G') THEN
      vQTD_GIRO :=  COALESCE(fTOT_VALOR_CMG / NVLZ(fTOT_SALDIA, 1), 0);
   END IF;

   IF vQTD_GIRO > 99.99 THEN
      vQTD_GIRO := 99.99;
   END IF;
   IF vQTD_GIRO < -99.99 THEN
      vQTD_GIRO := -99.99;
   END IF;
   
--  --------------------------------------------------------
   RETURN TRUNC(vQTD_GIRO*1000)/1000;

END;
$$ language 'plpgsql';


/*-- SEQ 1584 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GiroEstoque (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1585 --*/
CREATE OR REPLACE FUNCTION GiroEstoque (Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN GiroEstoque($1,$2,$3,$4,$5,$6,$7,'C','T','E');
END;
$$ language 'plpgsql';


/*-- SEQ 1586 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GiroEstoque (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TT_CFG.GIRO_ESTOQUE%TYPE,TR_MOV.PROMOC%TYPE) CASCADE;

/*-- SEQ 1587 --*/
CREATE OR REPLACE FUNCTION GiroEstoque (Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR,
                               TT_CFG.GIRO_ESTOQUE%TYPE,
                               TR_MOV.PROMOC%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN GiroEstoque($1,$2,$3,$4,$5,$6,$7,$8,$9,'E');
END;
$$ language 'plpgsql';


/*-- SEQ 1588 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION LogExclusao (BOOLEAN,TT_DEL.TABELA%TYPE,TT_DEL.CHAVE1%TYPE,TT_DEL.CHAVE2%TYPE) CASCADE;

/*-- SEQ 1589 --*/
CREATE OR REPLACE FUNCTION LogExclusao (BOOLEAN,TT_DEL.TABELA%TYPE,TT_DEL.CHAVE1%TYPE,TT_DEL.CHAVE2%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_Delete ALIAS FOR $1 ;
p_Tabela ALIAS FOR $2 ;
p_Chave1 ALIAS FOR $3 ;
p_Chave2 ALIAS FOR $4 ;
  vComplemento CONSTANT VARCHAR(254):= constante('complemento');   
  v_FilUsu  TT_USU.FILUSU%TYPE;
  v_CodUsu  TT_USU.CODUSU%TYPE;
  Quemlogou TRetQuemLogou%ROWTYPE;
BEGIN
    IF p_Delete THEN
       select * into QuemLogou from DadosLogon(); 
       IF QuemLogou.Encontrou THEN
          v_FilUsu:=QuemLogou.filusu;
          v_CodUsu:=QuemLogou.codusu;
       ELSE
         RAISE EXCEPTION 'PG-20004 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
       END IF;

       INSERT INTO TT_DEL (TABELA, ATU_EM, FILUSU, CODUSU, CHAVE1, CHAVE2, OSUSER, COMPUT, RE_INC) VALUES
       (p_Tabela, agora(), v_FilUsu, v_CodUsu, p_Chave1, p_Chave2,
              
        current_user, 
        cast(inet_client_addr() as VARCHAR),
              'F');       

    ELSE
       UPDATE TT_DEL SET RE_INC = 'T'
        WHERE TABELA = p_Tabela
          AND CHAVE1 = p_CHAVE1
          AND CHAVE2 = p_CHAVE2
          AND RE_INC = 'F';
    END IF;
  RETURN NULL; 
END;
$$ language 'plpgsql';




/*-- SEQ 1590 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION MantemSPC () CASCADE;

/*-- SEQ 1591 --*/
CREATE OR REPLACE FUNCTION MantemSPC ()
RETURNS VARCHAR AS $$
DECLARE

   I_BAIXA                       INTEGER;
   I_INCLU                       INTEGER;
   VDATA                         Timestamp;
   CFILIAL                       TT_IDF.CODLOJ%TYPE;
   cEMAIL                        TT_CFG.COB_E_MAIL_SPC%TYPE;
   cMAI_FR                       TT_CFG.MAI_FR%TYPE;
   LF                            CHAR(2):=CHR(13)||CHR(10);
   CSPC_PARCELA                  TT_CFG.SPC_PARCELA%TYPE;

   VCODFIL                       TD_FIL.CODFIL%TYPE;
   VCGCFIL                       TD_FIL.CGCFIL%TYPE;
   VBAISPC                       TD_FIL.BAISPC%TYPE;
   VMATRIZ                       TD_FIL.CODFIL%TYPE;

CR_FILIAIS CURSOR FOR
  SELECT DISTINCT BAISPC
    FROM TD_FIL;

CR_FILIAIS_CGC CURSOR FOR
  SELECT DISTINCT SUBSTR(CGCFIL,1,8)
    FROM TD_FIL
   WHERE BAISPC = 'E';


BEGIN

  SELECT CODLOJ INTO CFILIAL FROM TT_IDF;

  SELECT SPC_PARCELA INTO CSPC_PARCELA FROM TT_CFG;

  VDATA:=AGORA();
  IF CSPC_PARCELA='T' THEN
     -- BAIXA OS REGISTROS DE SPC DOS CLIENTES QUE PAGARAM AS PARCELAS QUE ESTAVAM NO SPC
     UPDATE TT_DEV
        SET REGEXC = AGORA()
      WHERE REGEXC IS NULL
        AND (FILREC,SEQREC,NUMPAR,SUBPAR) IN (SELECT REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR
                                                FROM TT_REC REC INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
                                                                INNER JOIN TT_DEV DEV ON DEV.FILREC = REC.CODFIL AND DEV.SEQREC = REC.SEQUEN
                                                                                     AND DEV.NUMPAR = REC.NUMPAR AND DEV.SUBPAR = REC.SUBPAR
                                                                                     AND DEV.REGEXC IS NULL
                                                                CROSS JOIN TT_CFG CFG
                                               WHERE (REC.FLGEST <> 'A'
                                                      OR REC.CARTAO IS NOT NULL
                                                      OR REC.DATVEN >= ADD_DAY(TRUNC(AGORA()), - CFG.COB_OUTROS_PAGTOS)
                                                      OR VEN.FILCLI<>DEV.FILCLI
                                                      OR VEN.CODCLI<>DEV.CODCLI)
                                             );
     UPDATE TT_DEV SET REGEXC = AGORA()
      WHERE REGEXC IS NULL
         AND (FILCHR,SEQCHR) IN (SELECT CHR.CODFIL,CHR.SEQUEN
                                   FROM TT_CHR CHR CROSS JOIN TT_CFG CFG
                                                   INNER JOIN TT_DEV DEV ON CHR.CODFIL=DEV.FILCHR AND CHR.SEQUEN=DEV.SEQCHR AND DEV.REGEXC IS NULL
                                  WHERE (CHR.FLGEST IN ('X','B','C','S')
                                          OR CHR.AUTORI IS NOT NULL
                                          OR CHR.DATVEN >= ADD_DAY(TRUNC(AGORA()), - CFG.COB_OUTROS_PAGTOS)
                                          OR CHR.FILCLI<>DEV.FILCLI
                                          OR CHR.CODCLI<>DEV.CODCLI)
                                );

  ELSE
   -- BAIXA OS REGISTROS DE SPC DOS CLIENTES QUE NO TEM NOVAS DIVIDAS ACIMA DOS DIAS CONFIGURADOS
     UPDATE TT_DEV SET REGEXC = AGORA()
      WHERE (CODFIL, SEQUEN) IN (SELECT CODFIL, SEQUEN
                                   FROM (SELECT DEV.CODFIL, DEV.SEQUEN,
                                                (SELECT SUM(REC.VLRPAR)
                                                   FROM TT_VEN VEN INNER JOIN TT_REC REC ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
                                                  WHERE REC.FLGEST = 'A'
                                                    AND REC.CARTAO IS NULL
                                                    AND REC.DATVEN < ADD_DAY(TRUNC(AGORA()), - CFG.COB_OUTROS_PAGTOS)
                                                    AND VEN.FLGEST = 'A'
                                                    AND VEN.FILCLI = DEV.FILCLI
                                                    AND VEN.CODCLI = DEV.CODCLI) AS DIVIDAREC,
                                                (SELECT SUM(CHR.VLRCHE)
                                                   FROM TT_CHR CHR
                                                  WHERE CHR.FLGEST IN ('A','D','G','P','R','U','V')
                                                    AND CHR.AUTORI IS NULL
                                                    AND CHR.DATVEN < ADD_DAY(TRUNC(AGORA()), - CFG.COB_OUTROS_PAGTOS)
                                                    AND CHR.FILCLI = DEV.FILCLI
                                                    AND CHR.CODCLI = DEV.CODCLI) AS DIVIDACHR
                                           FROM TT_DEV DEV, TT_CFG CFG
                                          WHERE REGEXC IS NULL) TAB
                                  WHERE COALESCE( DIVIDAREC, 0 ) + COALESCE( DIVIDACHR, 0 ) = 0);

  END IF;
  -- BAIXA OS CHEQUES DE SPC DOS CLIENTES CUJO INFORMACAO DE NAOSPC FOR SUPERIOR A HOJE:
  UPDATE TT_DEV SET REGEXC = AGORA()
   WHERE (CODFIL, SEQUEN) IN (SELECT DEV.CODFIL, DEV.SEQUEN
                                FROM TT_DEV DEV INNER JOIN TT_COB COB ON COB.FILREC = DEV.FILREC AND COB.SEQREC = DEV.SEQREC
                                                                     AND COB.NUMPAR = DEV.NUMPAR AND COB.SUBPAR = DEV.SUBPAR
                               WHERE COB.NAOSPC > AGORA()
                                 AND COB.FILREC IS NOT NULL
                                 AND DEV.REGEXC IS NULL
                               UNION ALL
                              SELECT DEV.CODFIL, DEV.SEQUEN
                                FROM TT_DEV DEV INNER JOIN TT_COB COB ON COB.FILCHR = DEV.FILCHR AND COB.SEQCHR = DEV.SEQCHR
                               WHERE COB.NAOSPC > AGORA()
                                 AND COB.FILCHR IS NOT NULL
                                 AND DEV.REGEXC IS NULL);
  SELECT COUNT(*) INTO I_BAIXA
    FROM TT_DEV
   WHERE REGEXC>=VDATA;

  VDATA:=AGORA();

  OPEN CR_FILIAIS;
  LOOP
      FETCH CR_FILIAIS INTO VBAISPC;
      EXIT WHEN NOT FOUND;

      IF vBAISPC = 'G' THEN

          -- INSERE REGISTROS DE DEVEDORES NO SPC PARA OS CLIENTES QUE TEM PARCELAS EM ATRASO
          -- ACIMA DO NUMERO DE DIAS MAXIMO, GERANDO UM REGISTRO PARA CADA PARCELA, DESDE QUE
          -- ASSIM ESTEJA CONFIGURADO:
          INSERT INTO TT_DEV (CODFIL, FILCLI, CODCLI, FILREC, SEQREC, NUMPAR, SUBPAR, REGINC)
                             (SELECT /*+ INDEX(VEN,PK_VEN) INDEX(CLI,PK_CLI) INDEX(COB,I_FK_COB_REC) */
                                     CFILIAL AS CODFIL, VEN.FILCLI, VEN.CODCLI, REC.CODFIL, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR, AGORA()
                                FROM TT_CFG CFG, TT_REC REC LEFT JOIN TT_DEV DEV ON DEV.FILREC = REC.CODFIL AND DEV.SEQREC = REC.SEQUEN
                                                                                AND DEV.NUMPAR = REC.NUMPAR AND DEV.SUBPAR = REC.SUBPAR
                                                                                AND DEV.REGEXC IS NULL
                                                           INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
                                                           INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                                                           LEFT  JOIN TT_COB COB ON COB.FILREC = REC.CODFIL AND COB.SEQREC = REC.SEQUEN
                                                                                AND COB.NUMPAR = REC.NUMPAR AND COB.SUBPAR = REC.SUBPAR
                                                           INNER JOIN TD_FIL FIL ON FIL.CODFIL = REC.CODFIL
                               WHERE CFG.COB_FORMA_REGISTRO = 'T'
                                 AND REC.FLGEST = 'A'
                                 AND REC.DATVEN <= ADD_DAY(TRUNC(AGORA()), - CFG.COB_DIAS_SPC_REC)
                                 AND REC.CARTAO IS NULL
                                 AND REC.SEQCHE IS NULL
                                 AND CLI.NAOSPC = 'F'
                                 AND (COB.FILREC IS NULL  OR COB.NAOSPC IS NULL OR COB.NAOSPC < AGORA())
                                 AND DEV.CODFIL IS NULL
                                 AND FIL.BAISPC = 'G');

          -- INSERE REGISTROS DE DEVEDORES NO SPC PARA OS CLIENTES QUE TEM PARCELAS EM ATRASO
          -- ACIMA DO NUMERO DE DIAS MAXIMO, GERANDO UM REGISTRO PARA CADA CLIENTE, DESDE QUE
          -- ASSIM ESTEJA CONFIGURADO:
          INSERT INTO TT_DEV (CODFIL, FILCLI, CODCLI, FILREC, SEQREC, NUMPAR, SUBPAR, REGINC)
                             (SELECT CFILIAL AS CODFIL, FILCLI, CODCLI,
                                     SUBSTR(PARCELA, 9, 3) AS CODFIL,
                                     SUBSTR(PARCELA,12,10) AS SEQUEN,
                                     SUBSTR(PARCELA,22, 2) AS NUMPAR,
                                     SUBSTR(PARCELA,24, 2) AS SUBPAR, AGORA()
                                FROM (SELECT /*+ INDEX(VEN,PK_VEN) INDEX(CLI,PK_CLI) INDEX(COB,I_FK_COB_REC) */
                                             VEN.FILCLI, VEN.CODCLI,
                                             MIN( TO_CHAR( REC.DATVEN, 'YYYYMMDD' ) || REC.CODFIL || REC.SEQUEN || REC.NUMPAR || REC.SUBPAR ) AS PARCELA
                                        FROM TT_CFG CFG, TT_REC REC INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
                                                                     LEFT JOIN TT_DEV DEV ON DEV.FILCLI = VEN.FILCLI AND DEV.CODCLI = VEN.CODCLI
                                                                                         AND DEV.REGEXC IS NULL
                                                                    INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                                                                     LEFT JOIN TT_COB COB ON COB.FILREC = REC.CODFIL AND COB.SEQREC = REC.SEQUEN
                                                                                         AND COB.NUMPAR = REC.NUMPAR AND COB.SUBPAR = REC.SUBPAR
                                                                    INNER JOIN TD_FIL FIL ON FIL.CODFIL = REC.CODFIL
                                       WHERE CFG.COB_FORMA_REGISTRO = '1'
                                         AND REC.FLGEST = 'A'
                                         AND REC.DATVEN <= ADD_DAY(TRUNC(AGORA()), - CFG.COB_DIAS_SPC_REC)
                                         AND CLI.NAOSPC = 'F'
                                         AND (COB.FILREC IS NULL OR COB.NAOSPC IS NULL OR COB.NAOSPC < AGORA())
                                         AND REC.CARTAO IS NULL
                                         AND REC.SEQCHE IS NULL
                                         AND DEV.CODFIL IS NULL
                                         AND FIL.BAISPC = 'G'
                                       GROUP BY VEN.FILCLI, VEN.CODCLI) DADOS);

          -- INSERE REGISTROS DE DEVEDORES NO SPC PARA OS CLIENTES QUE TEM CHEQUES DEVOLVIDOS
          -- ACIMA DO NUMERO DE DIAS MAXIMO, GERANDO UM REGISTRO PARA CADA CHEQUE, DESDE QUE
          -- ASSIM ESTEJA CONFIGURADO:
          INSERT INTO TT_DEV (CODFIL, FILCLI, CODCLI, FILCHR, SEQCHR, REGINC)
                             (SELECT CFILIAL AS CODFIL, CHR.FILCLI, CHR.CODCLI, CHR.CODFIL, CHR.SEQUEN, AGORA()
                                FROM TT_CFG CFG, TT_CHR CHR  LEFT JOIN TT_DEV DEV ON DEV.FILCHR = CHR.CODFIL AND DEV.SEQCHR = CHR.SEQUEN
                                                                                 AND DEV.REGEXC IS NULL
                                                            INNER JOIN TT_CLI CLI ON CLI.FILCLI = CHR.FILCLI AND CLI.CODCLI = CHR.CODCLI
                                                             LEFT JOIN TT_COB COB ON COB.FILCHR = CHR.CODFIL AND COB.SEQCHR = CHR.SEQUEN
                                                            INNER JOIN TD_FIL FIL ON FIL.CODFIL = CHR.CODFIL
                               WHERE CFG.COB_FORMA_REGISTRO = 'T'
                                 AND CHR.FLGEST = 'V'
                                 AND CHR.DATVEN <= ADD_DAY(TRUNC(AGORA()), - CFG.COB_DIAS_SPC_CHR)
                                 AND COALESCE(CHR.NUMDEP,1) > 1
                                 AND CLI.NAOSPC = 'F'
                                 AND (COB.FILCHR IS NULL OR COB.NAOSPC IS NULL OR COB.NAOSPC < AGORA())
                                 AND DEV.CODFIL IS NULL
                                 AND FIL.CODFIL = 'G');

          -- INSERE REGISTROS DE DEVEDORES NO SPC PARA OS CLIENTES QUE TEM CHEQUES DEVOLVIDOS
          -- ACIMA DO NUMERO DE DIAS MAXIMO, GERANDO UM REGISTRO PARA CADA CLIENTE, DESDE QUE
          -- ASSIM ESTEJA CONFIGURADO:
          INSERT INTO TT_DEV (CODFIL, FILCLI, CODCLI, FILCHR, SEQCHR, REGINC)
                             (SELECT CFILIAL AS CODFIL, FILCLI, CODCLI,
                                     SUBSTR(PARCELA, 9, 3) AS FILCHR,
                                     SUBSTR(PARCELA,12,10) AS SEQCHR, AGORA()
                                FROM (SELECT CHR.FILCLI, CHR.CODCLI,
                                             MIN( TO_CHAR( CHR.DATVEN, 'YYYYMMDD' ) || CHR.CODFIL || CHR.SEQUEN ) AS PARCELA
                                        FROM TT_CFG CFG, TT_CHR CHR LEFT JOIN TT_DEV DEV ON DEV.FILCLI = CHR.FILCLI AND DEV.CODCLI = CHR.CODCLI
                                                                                        AND DEV.REGEXC IS NULL
                                                                   INNER JOIN TT_CLI CLI ON CLI.FILCLI = CHR.FILCLI AND CLI.CODCLI = CHR.CODCLI
                                                                    LEFT JOIN TT_COB COB ON COB.FILCHR = CHR.CODFIL AND COB.SEQCHR = CHR.SEQUEN
                                                                   INNER JOIN TD_FIL FIL ON FIL.CODFIL = CHR.CODFIL
                                       WHERE CFG.COB_FORMA_REGISTRO = '1'
                                         AND CHR.FLGEST = 'V'
                                         AND CHR.DATVEN <= ADD_DAY(TRUNC(AGORA()), - CFG.COB_DIAS_SPC_CHR)
                                         AND COALESCE(CHR.NUMDEP,1) > 1
                                         AND CLI.NAOSPC = 'F'
                                         AND (COB.FILCHR IS NULL OR COB.NAOSPC IS NULL OR COB.NAOSPC < AGORA())
                                         AND DEV.CODFIL IS NULL
                                         AND FIL.BAISPC = 'G'
                                       GROUP BY CHR.FILCLI, CHR.CODCLI) DADOS);

          SELECT COUNT(*) INTO I_INCLU
            FROM TT_DEV
           WHERE REGINC>=VDATA;

          SELECT CFG.COB_E_MAIL_SPC, CFG.MAI_FR INTO cEMAIL,cMAI_FR
            FROM TT_CFG CFG;

          IF (ISNOTNULL(cEMAIL)='T') AND (ISNOTNULL(cMAI_FR)='T') AND (INSTR(cMAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(cEMAIL, UPPER('@sua_empresa.com')) = 0)
             AND (i_INCLU+i_BAIXA>0) THEN
             INSERT INTO TT_MAI (CODFIL,MAI_TO,MAI_FR,ASSUNT,TEXTOS,EXCLUI,TIPMSG,DATSOL) VALUES
                                (cFilial,cEMAIL,cMAI_FR,to_char('Relatorio de clientes enviados/retirados do SPC (filial: '||cFilial||')'),
                                 'Clientes inclusos no SPC :'||i_INCLU||LF||
                                 'Clientes retirados do SPC:'||i_BAIXA,
                                 'F',
                                 'T',
                                 AGORA());
          END IF;
      END IF; --G
      IF vBAISPC = 'I' THEN
          -- INSERE REGISTROS DE DEVEDORES NO SPC PARA OS CLIENTES QUE TEM PARCELAS EM ATRASO
          -- ACIMA DO NUMERO DE DIAS MAXIMO, GERANDO UM REGISTRO PARA CADA PARCELA, DESDE QUE
          -- ASSIM ESTEJA CONFIGURADO:
          INSERT INTO TT_DEV (CODFIL, FILCLI, CODCLI, FILREC, SEQREC, NUMPAR, SUBPAR, REGINC)
                             (SELECT /*+ INDEX(VEN,PK_VEN) INDEX(CLI,PK_CLI) INDEX(COB,I_FK_COB_REC) */
                                     FIL.CODFIL AS CODFIL, VEN.FILCLI, VEN.CODCLI, REC.CODFIL, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR, AGORA()
                                FROM TT_CFG CFG, TT_REC REC LEFT JOIN TT_DEV DEV ON DEV.FILREC = REC.CODFIL AND DEV.SEQREC = REC.SEQUEN
                                                                                AND DEV.NUMPAR = REC.NUMPAR AND DEV.SUBPAR = REC.SUBPAR
                                                                                AND DEV.REGEXC IS NULL
                                                           INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
                                                           INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                                                           LEFT  JOIN TT_COB COB ON COB.FILREC = REC.CODFIL AND COB.SEQREC = REC.SEQUEN
                                                                                AND COB.NUMPAR = REC.NUMPAR AND COB.SUBPAR = REC.SUBPAR
                                                           INNER JOIN TD_FIL FIL ON FIL.CODFIL = REC.CODFIL
                               WHERE CFG.COB_FORMA_REGISTRO = 'T'
                                 AND REC.FLGEST = 'A'
                                 AND REC.DATVEN <= ADD_DAY(TRUNC(AGORA()), - CFG.COB_DIAS_SPC_REC)
                                 AND REC.CARTAO IS NULL
                                 AND REC.SEQCHE IS NULL
                                 AND CLI.NAOSPC = 'F'
                                 AND (COB.FILREC IS NULL  OR COB.NAOSPC IS NULL OR COB.NAOSPC < AGORA())
                                 AND DEV.CODFIL IS NULL
                                 AND FIL.BAISPC = 'I');

          -- INSERE REGISTROS DE DEVEDORES NO SPC PARA OS CLIENTES QUE TEM PARCELAS EM ATRASO
          -- ACIMA DO NUMERO DE DIAS MAXIMO, GERANDO UM REGISTRO PARA CADA CLIENTE, DESDE QUE
          -- ASSIM ESTEJA CONFIGURADO:
          INSERT INTO TT_DEV (CODFIL, FILCLI, CODCLI, FILREC, SEQREC, NUMPAR, SUBPAR, REGINC)
                             (SELECT CODFIL, FILCLI, CODCLI,
                                     SUBSTR(PARCELA, 9, 3) AS CODFIL,
                                     SUBSTR(PARCELA,12,10) AS SEQUEN,
                                     SUBSTR(PARCELA,22, 2) AS NUMPAR,
                                     SUBSTR(PARCELA,24, 2) AS SUBPAR, AGORA()
                                FROM (SELECT /*+ INDEX(VEN,PK_VEN) INDEX(CLI,PK_CLI) INDEX(COB,I_FK_COB_REC) */
                                             FIL.CODFIL, VEN.FILCLI, VEN.CODCLI,
                                             MIN( TO_CHAR( REC.DATVEN, 'YYYYMMDD' ) || REC.CODFIL || REC.SEQUEN || REC.NUMPAR || REC.SUBPAR ) AS PARCELA
                                        FROM TT_CFG CFG, TT_REC REC INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
                                                                     LEFT JOIN TT_DEV DEV ON DEV.FILCLI = VEN.FILCLI AND DEV.CODCLI = VEN.CODCLI
                                                                                         AND DEV.REGEXC IS NULL
                                                                    INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                                                                     LEFT JOIN TT_COB COB ON COB.FILREC = REC.CODFIL AND COB.SEQREC = REC.SEQUEN
                                                                                         AND COB.NUMPAR = REC.NUMPAR AND COB.SUBPAR = REC.SUBPAR
                                                                    INNER JOIN TD_FIL FIL ON FIL.CODFIL = REC.CODFIL
                                       WHERE CFG.COB_FORMA_REGISTRO = '1'
                                         AND REC.FLGEST = 'A'
                                         AND REC.DATVEN <= ADD_DAY(TRUNC(AGORA()), - CFG.COB_DIAS_SPC_REC)
                                         AND CLI.NAOSPC = 'F'
                                         AND (COB.FILREC IS NULL OR COB.NAOSPC IS NULL OR COB.NAOSPC < AGORA())
                                         AND REC.CARTAO IS NULL
                                         AND REC.SEQCHE IS NULL
                                         AND DEV.CODFIL IS NULL
                                         AND FIL.BAISPC = 'I'
                                       GROUP BY FIL.CODFIL,VEN.FILCLI, VEN.CODCLI) DADOS);

          -- INSERE REGISTROS DE DEVEDORES NO SPC PARA OS CLIENTES QUE TEM CHEQUES DEVOLVIDOS
          -- ACIMA DO NUMERO DE DIAS MAXIMO, GERANDO UM REGISTRO PARA CADA CHEQUE, DESDE QUE
          -- ASSIM ESTEJA CONFIGURADO:
          INSERT INTO TT_DEV (CODFIL, FILCLI, CODCLI, FILCHR, SEQCHR, REGINC)
                             (SELECT FIL.CODFIL AS CODFIL, CHR.FILCLI, CHR.CODCLI, CHR.CODFIL, CHR.SEQUEN, AGORA()
                                FROM TT_CFG CFG, TT_CHR CHR  LEFT JOIN TT_DEV DEV ON DEV.FILCHR = CHR.CODFIL AND DEV.SEQCHR = CHR.SEQUEN
                                                                                 AND DEV.REGEXC IS NULL
                                                            INNER JOIN TT_CLI CLI ON CLI.FILCLI = CHR.FILCLI AND CLI.CODCLI = CHR.CODCLI
                                                             LEFT JOIN TT_COB COB ON COB.FILCHR = CHR.CODFIL AND COB.SEQCHR = CHR.SEQUEN
                                                            INNER JOIN TD_FIL FIL ON FIL.CODFIL = CHR.CODFIL
                               WHERE CFG.COB_FORMA_REGISTRO = 'T'
                                 AND CHR.FLGEST = 'V'
                                 AND CHR.DATVEN <= ADD_DAY(TRUNC(AGORA()), - CFG.COB_DIAS_SPC_CHR)
                                 AND COALESCE(CHR.NUMDEP,1) > 1
                                 AND CLI.NAOSPC = 'F'
                                 AND (COB.FILCHR IS NULL OR COB.NAOSPC IS NULL OR COB.NAOSPC < AGORA())
                                 AND DEV.CODFIL IS NULL
                                 AND FIL.CODFIL = 'I');

          -- INSERE REGISTROS DE DEVEDORES NO SPC PARA OS CLIENTES QUE TEM CHEQUES DEVOLVIDOS
          -- ACIMA DO NUMERO DE DIAS MAXIMO, GERANDO UM REGISTRO PARA CADA CLIENTE, DESDE QUE
          -- ASSIM ESTEJA CONFIGURADO:
          INSERT INTO TT_DEV (CODFIL, FILCLI, CODCLI, FILCHR, SEQCHR, REGINC)
                             (SELECT CODFIL, FILCLI, CODCLI,
                                     SUBSTR(PARCELA, 9, 3) AS FILCHR,
                                     SUBSTR(PARCELA,12,10) AS SEQCHR, AGORA()
                                FROM (SELECT FIL.CODFIL, CHR.FILCLI, CHR.CODCLI,
                                             MIN( TO_CHAR( CHR.DATVEN, 'YYYYMMDD' ) || CHR.CODFIL || CHR.SEQUEN ) AS PARCELA
                                        FROM TT_CFG CFG, TT_CHR CHR LEFT JOIN TT_DEV DEV ON DEV.FILCLI = CHR.FILCLI AND DEV.CODCLI = CHR.CODCLI
                                                                                        AND DEV.REGEXC IS NULL
                                                                   INNER JOIN TT_CLI CLI ON CLI.FILCLI = CHR.FILCLI AND CLI.CODCLI = CHR.CODCLI
                                                                    LEFT JOIN TT_COB COB ON COB.FILCHR = CHR.CODFIL AND COB.SEQCHR = CHR.SEQUEN
                                                                   INNER JOIN TD_FIL FIL ON FIL.CODFIL = CHR.CODFIL
                                       WHERE CFG.COB_FORMA_REGISTRO = '1'
                                         AND CHR.FLGEST = 'V'
                                         AND CHR.DATVEN <= ADD_DAY(TRUNC(AGORA()), - CFG.COB_DIAS_SPC_CHR)
                                         AND COALESCE(CHR.NUMDEP,1) > 1
                                         AND CLI.NAOSPC = 'F'
                                         AND (COB.FILCHR IS NULL OR COB.NAOSPC IS NULL OR COB.NAOSPC < AGORA())
                                         AND DEV.CODFIL IS NULL
                                         AND FIL.BAISPC = 'I'
                                       GROUP BY FIL.CODFIL,CHR.FILCLI, CHR.CODCLI) DADOS);


          SELECT CFG.COB_E_MAIL_SPC, CFG.MAI_FR INTO cEMAIL,cMAI_FR
            FROM TT_CFG CFG;

          IF cEMAIL IS NOT NULL AND (i_INCLU+i_BAIXA>0) THEN
             INSERT INTO TT_MAI (CODFIL,MAI_TO,MAI_FR,ASSUNT,TEXTOS,EXCLUI,TIPMSG,DATSOL)
                                (SELECT FIL.CODFIL,cEMAIL,cMAI_FR,to_char('Relatorio de clientes enviados/retirados do SPC (filial: '||FIL.CODFIL||')'),
                                        'Clientes inclusos no SPC :'||COUNT(*)||LF||
                                        'Clientes retirados do SPC:'||(SELECT COUNT(*)
                                                                                    FROM TT_DEV DEV
                                                                                   WHERE DEV.REGEXC >= VDATA
                                                                                     AND DEV.CODFIL = FIL.CODFIL),
                                        'F',
                                        'T',
                                        AGORA()
                                   FROM TT_DEV DEV INNER JOIN TD_FIL FIL ON FIL.CODFIL = DEV.CODFIL
                                  WHERE FIL.BAISPC = 'I'
                                 GROUP BY FIL.CODFIL);
          END IF;


      END IF; --I
      IF vBAISPC = 'E' THEN
         OPEN CR_FILIAIS_CGC;
         LOOP
             FETCH CR_FILIAIS_CGC INTO VCGCFIL;
             EXIT WHEN NOT FOUND;

             SELECT CODFIL
               INTO vMATRIZ
               FROM TD_FIL
              WHERE SUBSTR(CGCFIL,1,8) = vCGCFIL
                AND SUBSTR(CGCFIL,9,4) = '0001';
             IF vMATRIZ IS NULL THEN
                SELECT MIN(CODFIL)
                  INTO vMATRIZ
                  FROM TD_FIL
                 WHERE SUBSTR(CGCFIL,1,8) = vCGCFIL;
             END IF;

              -- INSERE REGISTROS DE DEVEDORES NO SPC PARA OS CLIENTES QUE TEM PARCELAS EM ATRASO
              -- ACIMA DO NUMERO DE DIAS MAXIMO, GERANDO UM REGISTRO PARA CADA PARCELA, DESDE QUE
              -- ASSIM ESTEJA CONFIGURADO:
             INSERT INTO TT_DEV (CODFIL, FILCLI, CODCLI, FILREC, SEQREC, NUMPAR, SUBPAR, REGINC)
                                (SELECT /*+ INDEX(VEN,PK_VEN) INDEX(CLI,PK_CLI) INDEX(COB,I_FK_COB_REC) */
                                        vMATRIZ AS CODFIL, VEN.FILCLI, VEN.CODCLI, REC.CODFIL, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR, AGORA()
                                   FROM TT_CFG CFG, TT_REC REC LEFT JOIN TT_DEV DEV ON DEV.FILREC = REC.CODFIL AND DEV.SEQREC = REC.SEQUEN
                                                                                   AND DEV.NUMPAR = REC.NUMPAR AND DEV.SUBPAR = REC.SUBPAR
                                                                                   AND DEV.REGEXC IS NULL
                                                              INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
                                                              INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                                                              LEFT  JOIN TT_COB COB ON COB.FILREC = REC.CODFIL AND COB.SEQREC = REC.SEQUEN
                                                                                   AND COB.NUMPAR = REC.NUMPAR AND COB.SUBPAR = REC.SUBPAR
                                                              INNER JOIN TD_FIL FIL ON FIL.CODFIL = REC.CODFIL
                                  WHERE CFG.COB_FORMA_REGISTRO = 'T'
                                    AND REC.FLGEST = 'A'
                                    AND REC.DATVEN <= ADD_DAY(TRUNC(AGORA()), - CFG.COB_DIAS_SPC_REC)
                                    AND REC.CARTAO IS NULL
                                    AND REC.SEQCHE IS NULL
                                    AND CLI.NAOSPC = 'F'
                                    AND (COB.FILREC IS NULL  OR COB.NAOSPC IS NULL OR COB.NAOSPC < AGORA())
                                    AND DEV.CODFIL IS NULL
                                    AND FIL.BAISPC = 'E'
                                    AND SUBSTR(FIL.CGCFIL,1,8) = vCGCFIL);
             -- INSERE REGISTROS DE DEVEDORES NO SPC PARA OS CLIENTES QUE TEM PARCELAS EM ATRASO
             -- ACIMA DO NUMERO DE DIAS MAXIMO, GERANDO UM REGISTRO PARA CADA CLIENTE, DESDE QUE
             -- ASSIM ESTEJA CONFIGURADO:
             INSERT INTO TT_DEV (CODFIL, FILCLI, CODCLI, FILREC, SEQREC, NUMPAR, SUBPAR, REGINC)
                                (SELECT CODFIL, FILCLI, CODCLI,
                                        SUBSTR(PARCELA, 9, 3) AS CODFIL,
                                        SUBSTR(PARCELA,12,10) AS SEQUEN,
                                        SUBSTR(PARCELA,22, 2) AS NUMPAR,
                                        SUBSTR(PARCELA,24, 2) AS SUBPAR, AGORA()
                                   FROM (SELECT /*+ INDEX(VEN,PK_VEN) INDEX(CLI,PK_CLI) INDEX(COB,I_FK_COB_REC) */
                                                vMATRIZ AS CODFIL, VEN.FILCLI, VEN.CODCLI,
                                                MIN( TO_CHAR( REC.DATVEN, 'YYYYMMDD' ) || REC.CODFIL || REC.SEQUEN || REC.NUMPAR || REC.SUBPAR ) AS PARCELA
                                           FROM TT_CFG CFG, TT_REC REC INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
                                                                        LEFT JOIN TT_DEV DEV ON DEV.FILCLI = VEN.FILCLI AND DEV.CODCLI = VEN.CODCLI
                                                                                            AND DEV.REGEXC IS NULL
                                                                       INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                                                                        LEFT JOIN TT_COB COB ON COB.FILREC = REC.CODFIL AND COB.SEQREC = REC.SEQUEN
                                                                                            AND COB.NUMPAR = REC.NUMPAR AND COB.SUBPAR = REC.SUBPAR
                                                                       INNER JOIN TD_FIL FIL ON FIL.CODFIL = REC.CODFIL
                                          WHERE CFG.COB_FORMA_REGISTRO = '1'
                                            AND REC.FLGEST = 'A'
                                            AND REC.DATVEN <= ADD_DAY(TRUNC(AGORA()), - CFG.COB_DIAS_SPC_REC)
                                            AND CLI.NAOSPC = 'F'
                                            AND (COB.FILREC IS NULL OR COB.NAOSPC IS NULL OR COB.NAOSPC < AGORA())
                                            AND REC.CARTAO IS NULL
                                            AND REC.SEQCHE IS NULL
                                            AND DEV.CODFIL IS NULL
                                            AND FIL.BAISPC = 'E'
                                            AND SUBSTR(FIL.CGCFIL,1,8) = vCGCFIL
                                          GROUP BY VEN.FILCLI, VEN.CODCLI) DADOS);

             -- INSERE REGISTROS DE DEVEDORES NO SPC PARA OS CLIENTES QUE TEM CHEQUES DEVOLVIDOS
             -- ACIMA DO NUMERO DE DIAS MAXIMO, GERANDO UM REGISTRO PARA CADA CHEQUE, DESDE QUE
             -- ASSIM ESTEJA CONFIGURADO:
             INSERT INTO TT_DEV (CODFIL, FILCLI, CODCLI, FILCHR, SEQCHR, REGINC)
                                (SELECT vMATRIZ AS CODFIL, CHR.FILCLI, CHR.CODCLI, CHR.CODFIL, CHR.SEQUEN, AGORA()
                                   FROM TT_CFG CFG, TT_CHR CHR  LEFT JOIN TT_DEV DEV ON DEV.FILCHR = CHR.CODFIL AND DEV.SEQCHR = CHR.SEQUEN
                                                                                    AND DEV.REGEXC IS NULL
                                                               INNER JOIN TT_CLI CLI ON CLI.FILCLI = CHR.FILCLI AND CLI.CODCLI = CHR.CODCLI
                                                                LEFT JOIN TT_COB COB ON COB.FILCHR = CHR.CODFIL AND COB.SEQCHR = CHR.SEQUEN
                                                               INNER JOIN TD_FIL FIL ON FIL.CODFIL = CHR.CODFIL
                                  WHERE CFG.COB_FORMA_REGISTRO = 'T'
                                    AND CHR.FLGEST = 'V'
                                    AND CHR.DATVEN <= ADD_DAY(TRUNC(AGORA()), - CFG.COB_DIAS_SPC_CHR)
                                    AND COALESCE(CHR.NUMDEP,1) > 1
                                    AND CLI.NAOSPC = 'F'
                                    AND (COB.FILCHR IS NULL OR COB.NAOSPC IS NULL OR COB.NAOSPC < AGORA())
                                    AND DEV.CODFIL IS NULL
                                    AND FIL.CODFIL = 'E'
                                    AND SUBSTR(FIL.CGCFIL,1,8) = vCGCFIL);

             -- INSERE REGISTROS DE DEVEDORES NO SPC PARA OS CLIENTES QUE TEM CHEQUES DEVOLVIDOS
             -- ACIMA DO NUMERO DE DIAS MAXIMO, GERANDO UM REGISTRO PARA CADA CLIENTE, DESDE QUE
             -- ASSIM ESTEJA CONFIGURADO:
             INSERT INTO TT_DEV (CODFIL, FILCLI, CODCLI, FILCHR, SEQCHR, REGINC)
                                (SELECT CODFIL, FILCLI, CODCLI,
                                        SUBSTR(PARCELA, 9, 3) AS FILCHR,
                                        SUBSTR(PARCELA,12,10) AS SEQCHR, AGORA()
                                   FROM (SELECT vMATRIZ AS CODFIL, CHR.FILCLI, CHR.CODCLI,
                                                MIN( TO_CHAR( CHR.DATVEN, 'YYYYMMDD' ) || CHR.CODFIL || CHR.SEQUEN ) AS PARCELA
                                           FROM TT_CFG CFG, TT_CHR CHR LEFT JOIN TT_DEV DEV ON DEV.FILCLI = CHR.FILCLI AND DEV.CODCLI = CHR.CODCLI
                                                                                           AND DEV.REGEXC IS NULL
                                                                      INNER JOIN TT_CLI CLI ON CLI.FILCLI = CHR.FILCLI AND CLI.CODCLI = CHR.CODCLI
                                                                       LEFT JOIN TT_COB COB ON COB.FILCHR = CHR.CODFIL AND COB.SEQCHR = CHR.SEQUEN
                                                                      INNER JOIN TD_FIL FIL ON FIL.CODFIL = CHR.CODFIL
                                          WHERE CFG.COB_FORMA_REGISTRO = '1'
                                            AND CHR.FLGEST = 'V'
                                            AND CHR.DATVEN <= ADD_DAY(TRUNC(AGORA()), - CFG.COB_DIAS_SPC_CHR)
                                            AND COALESCE(CHR.NUMDEP,1) > 1
                                            AND CLI.NAOSPC = 'F'
                                            AND (COB.FILCHR IS NULL OR COB.NAOSPC IS NULL OR COB.NAOSPC < AGORA())
                                            AND DEV.CODFIL IS NULL
                                            AND FIL.BAISPC = 'E'
                                            AND SUBSTR(FIL.CGCFIL,1,8) = vCGCFIL
                                          GROUP BY CHR.FILCLI, CHR.CODCLI) DADOS);


             SELECT CFG.COB_E_MAIL_SPC, CFG.MAI_FR INTO cEMAIL,cMAI_FR
               FROM TT_CFG CFG;

             IF cEMAIL IS NOT NULL AND (i_INCLU+i_BAIXA>0) THEN
                INSERT INTO TT_MAI (CODFIL,MAI_TO,MAI_FR,ASSUNT,TEXTOS,EXCLUI,TIPMSG,DATSOL)
                                   (SELECT vMATRIZ,cEMAIL,cMAI_FR,to_char('Relatorio de clientes enviados/retirados do SPC (filial: '||vMATRIZ||')'),
                                           'Clientes inclusos no SPC :'||COUNT(*)||LF||
                                           'Clientes retirados do SPC:'||(SELECT COUNT(*)
                                                                                       FROM TT_DEV DEV
                                                                                      WHERE DEV.REGEXC >= VDATA
                                                                                        AND DEV.CODFIL = FIL.CODFIL),
                                           'F',
                                           'T',
                                           AGORA()
                                      FROM TT_DEV DEV INNER JOIN TD_FIL FIL ON FIL.CODFIL = DEV.CODFIL
                                     WHERE FIL.BAISPC = 'E'
                                       AND SUBSTR(FIL.CGCFIL,1,8) = vCGCFIL);
             END IF;
          END LOOP;
          CLOSE CR_FILIAIS_CGC;
      END IF; -- E
  END LOOP;
  CLOSE CR_FILIAIS;
  RETURN 'OK';

END;
$$ language 'plpgsql';





/*-- SEQ 1592 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION MEDIA_VENDAS_PRODUTO (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE,TT_IVE.CODMUL%TYPE,Timestamp,Timestamp,VARCHAR,VARCHAR,TT_PLA.FILPGT%TYPE,TT_PLA.CODPGT%TYPE) CASCADE;

/*-- SEQ 1593 --*/
CREATE OR REPLACE FUNCTION MEDIA_VENDAS_PRODUTO (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE,TT_IVE.CODMUL%TYPE,Timestamp,Timestamp,VARCHAR,VARCHAR,TT_PLA.FILPGT%TYPE,TT_PLA.CODPGT%TYPE)
RETURNS Numeric AS $$
DECLARE
pFilMat ALIAS FOR $1 ;
pCodMat ALIAS FOR $2 ;
pCodCor ALIAS FOR $3 ;
pCodTam ALIAS FOR $4 ;
pCodFil ALIAS FOR $5 ;
pCodMul ALIAS FOR $6 ;
pDatIni ALIAS FOR $7 ;
pDatFim ALIAS FOR $8 ;
pTipPer ALIAS FOR $9 ;
pTipDia ALIAS FOR $10 ;
pFilPgt ALIAS FOR $11 ;
pCodPgt ALIAS FOR $12 ;

-- Objetivos:
-- 1. Funcao que calcula a media de vendas do produto no periodo informado, em dias, meses ou anos,
--      utilizando como base dias corridos ou dias com a loja aberta e com estoque. Opcionalmente
--      pode-se definir a media para um determinado plano de pagamento.
--
--  Return [Numeric]
--      Esta funcao retorna um numero Numeric com quatro casas decimais. Caso do calculo gere <null>,
--      a funcao altera o resultado para 0 (zero);
--
--  @pFilMat [char(3)]
--      Codigo da filial do material do produto (TT_GRA);
--  @pCodMat [char(5)]
--      Codigo do material do produto (TT_GRA);
--  @pCodCor [Numeric(5)]
--      Codigo da cor do produto (TT_GRA);
--  @pCodTam [Numeric(5)]
--      Codigo do tamanho do produto (TT_GRA);
--  @pCodFil [char(3)] default <null>
--      Codigo da filial da venda. Caso nao informado, opcao padrao, serao listadas as vendas de
--      todas as filiais;
--  @pCodMul [Numeric(5)]
--      Codigo do subestoque do item da venda;
--  @pDatIni [Timestamp]
--      Data inicial do periodo no formato DD/MM/YYYY. As horas serao desprezadas e redefinidas como
--      00:00:00;
--  @pDatFim [Timestamp]
--      Data final do periodo no formato DD/MM/YYYY. As horas serao desprezadas e redefinidas como
--      23:59:59;
--  @pTipPer [VARCHAR]
--      Tipo do periodo para o calculo da media de vendas. As opcoes validas sao:
--      [D] diario;
--      [M] mensal;
--      [A] anual;
--  @pTipDia [VARCHAR(1)] default C
--      Tipo do dia utilizado no calculo da media. As opcoes validas sao:
--      [C] dias corridos (opcao padrao);
--      [A] dias com a loja aberta e com estoque;
--      Se este parametro receber qualquer valor difente de C ou A, ele e ajustado para o valor C.
--  @pFilPgt [char(3)] default <null>
--      Codigo da filial do plano de pagamento utilizado na venda. Caso nao seja informado, opcao
--      padrao, serao utilizados todos os planos de pagamento;
--  @pCodPgt [char(3)] default <null>
--      Codigo do plano de pagamento utilizado na venda. Caso nao seja informado, opcao padrao,
--      serao utilizados todos os planos de pagamento;

   nMed                          Numeric;             --  var para calcular a media
   dIni                          Timestamp;               --  data inicial do periodo com as horas
   dFim                          Timestamp;               --  data final do periodo com as horas
   cTipDia                       CHAR(1);            --  trata o parametro pTipDia
   nQtdPro                       Numeric;             --  var para calcular a quantidade vendida do produto
   nDiv                          Numeric;             --  var para calcular o divisor da media
   cAux                          VARCHAR(500);       --  var auxliar para buscar o resultado de ResumoVenPro
   wdPrimeiroLancto              Timestamp;               --  data da primeira movimentação

   -- Busca a Data do primeiro Movimento
   MovtoInicial CURSOR(pFilMatMov TT_GRA.FILMAT%TYPE,
           pCodMatMov TT_GRA.CODMAT%TYPE,
           pCodCorMov TT_GRA.CODCOR%TYPE,
           pCodTamMov TT_GRA.CODTAM%TYPE,
           pCodFilMov VARCHAR) IS
   SELECT MIN( RMOV.DATMOV )
     FROM TR_MOV RMOV
    WHERE RMOV.FILMAT = pFilMatMov
      AND RMOV.CODMAT = pCodMatMov
      AND RMOV.CODCOR = pCodCorMov
      AND RMOV.CODTAM = pCodTamMov
      AND INSTR(COALESCE(pCodFilMov, RMOV.CODFIL)||';', RMOV.CODFIL||';') > 0;
      
BEGIN
   -- Tratando o parametro pTipDia
   IF pTipDia = 'C' THEN
      cTipDia := 'C';
   ELSIF pTipDia = 'A' THEN
      cTipDia := 'A';
   ELSE
      cTipDia := 'C';
   END IF;
   
   -- Ajustando o periodo com as horas
   dIni := TO_DATE(TO_CHAR(TRUNC(pDatIni), 'DD/MM/YYYY')||' 00:00:00', 'DD/MM/YYYY HH24:MI:SS');
   dFim := TO_DATE(TO_CHAR(TRUNC(pDatFim), 'DD/MM/YYYY')||' 23:59:59', 'DD/MM/YYYY HH24:MI:SS');

   -- Procura a primeira movimentacao do produto
   -- (Caso um produto seja incluso apos a DataIni, ajusta-se a DataIni evitando distorcoes)
   -- Utilizado no calculo do intevalo de dias
   Open MovtoInicial(pFilMat, pCodMat, pCodCor, pCodTam, pCodFil);
   Fetch MovtoInicial into wdPrimeiroLancto;
   IF NOT NOT FOUND THEN
      IF wdPrimeiroLancto > dIni THEN
         dIni := wdPrimeiroLancto;
      END IF;
   END IF;
   Close MovtoInicial;

   -- Buscando a quantidade de produtos vendidos no periodo
   IF cTipDia = 'A' THEN
      -- Calculando por "dias com a loja aberta e com estoque"
      cAux := ResumoVenPro(dIni, dFim, pFilMat, pCodMat, pCodCor, pCodTam, pCodFil, cTipDia, 'F');
      IF pFilPgt IS NULL
      OR pCodPgt IS NULL THEN
          nQtdPro := Split_Part_Number(cAux, ';', 2);
      ELSE
          nQtdPro := TotalVenda(dIni, dFim, pFilMat, pCodMat, pCodCor, pCodTam, pCodFil, pCodMul, pFilPgt, pCodPgt, cTipDia);
      END IF;
   ELSE
      -- Calculo padrao por "dias corridos"
      IF pFilPgt IS NULL
      OR pCodPgt IS NULL THEN
          nQtdPro := TotalVenda(dIni, dFim, pFilMat, pCodMat, pCodCor, pCodTam, pCodFil, pCodMul, NULL, NULL, cTipDia);
      ELSE
          nQtdPro := TotalVenda(dIni, dFim, pFilMat, pCodMat, pCodCor, pCodTam, pCodFil, pCodMul, pFilPgt, pCodPgt, cTipDia);
      END IF;
   END IF;
   
   -- Calculando o divisor baseado no periodo e no tipo do periodo
   IF pTipPer = 'D' THEN
      --  diario
      IF cTipDia = 'A' THEN
         --  "dias com a loja aberta e com estoque"
         nDiv := Split_Part_Number(cAux, ';', 1);
      ELSE
         --  "dias corridos"
         nDiv := IntervaloDias(dFim, dIni) + 1;
      END IF;
   ELSIF pTipPer = 'M' THEN
      --  mensal
      nDiv := Months_Between(dFim, dIni);
   ELSIF pTipPer = 'A' THEN
      --  anual
      nDiv := TO_NUMBER(TO_CHAR(dFim, 'YYYY')) - TO_NUMBER(TO_CHAR(dIni, 'YYYY'));
   ELSE
      --  nao definido
      nDiv := 1;
   END IF;
   --  ajustando o divisor (se necessario)
   IF nDiv < 1 THEN
       nDiv := 1;
   END IF;
   --  calculando a media
   nMed := nQtdPro / nDiv;

   RETURN ROUND(COALESCE(nMed, 0), 4);
   
END;
$$ language 'plpgsql';


/*-- SEQ 1594 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION MEDIA_VENDAS_PRODUTO (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE,TT_IVE.CODMUL%TYPE,Timestamp,Timestamp,VARCHAR) CASCADE;

/*-- SEQ 1595 --*/
CREATE OR REPLACE FUNCTION MEDIA_VENDAS_PRODUTO (TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               TD_FIL.CODFIL%TYPE,
                               TT_IVE.CODMUL%TYPE,
                               Timestamp,
                               Timestamp,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN MEDIA_VENDAS_PRODUTO($1,$2,$3,$4,$5,$6,$7,$8,$9,'C',null,null);
END;
$$ language 'plpgsql';


/*-- SEQ 1596 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION MeioDePagamento (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE,Numeric) CASCADE;

/*-- SEQ 1597 --*/
CREATE OR REPLACE FUNCTION MeioDePagamento (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE,Numeric)
RETURNS VARCHAR AS $$
DECLARE
cCodFil ALIAS FOR $1 ;
cSequen ALIAS FOR $2 ;
nNumPar ALIAS FOR $3 ;
nSubPar ALIAS FOR $4 ;
nTipo ALIAS FOR $5 ;

  nResultado VARCHAR(4000);
  i          Numeric(5);
  REC_TEXTO  VARCHAR(4000);
  Resultado2 VARCHAR(254);
  cFILFAT    TT_VEN.CODFIL%TYPE;
  cSEQFAT    TT_VEN.SEQUEN%TYPE;
  nTIPCCC    TT_CCC.TIPCCC%TYPE;
  nCC_PENDENCIA TT_CFG.CC_PENDENCIA%TYPE;
  cPENCODFIL TT_REC.CODFIL%TYPE;
  cPENSEQUEN TT_REC.SEQUEN%TYPE;
  cPENNUMPAR TT_REC.NUMPAR%TYPE;
  cPENSUBPAR TT_REC.SUBPAR%TYPE;
  cMEIO      VARCHAR(4000);
  iQtdRDV    Numeric(5,0);
  
--
-- Esta funcao retorna o meio de pagamento da parcela, baseado
-- em TT_REC (parcelas) e TT_CHR (cheques) atraves de REC.CARTAO (pag.
-- com cartao), TD_CCC (conta corrente) e CHR.FLGEST (pag. em cheque) 
--
-- Necessita ser documentacao no TT_LAY da forma abaixo
-- rtrim(substr(MeioDePagamento(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR,0)1,250))
--
  crParcelas CURSOR FOR
   SELECT CASE WHEN COALESCE(TRUNC(LID.DATEXE), VEN.DATFIS) > VEN.DATFIS AND LeParametroBoo('REL_TRA_PENDENTE','','','','') = 'T' 
                 THEN '(Pend.)' ELSE '' 
           END || CASE WHEN DEV.FILREC IS NOT NULL THEN 'Abatimento por Devolucao'
               WHEN LEX.FILREC IS NOT NULL THEN 'Depsito'
          ELSE
               CASE WHEN CHR.FLGEST IS NULL THEN
                    CASE WHEN REC.CARTAO IS NULL THEN
                         CASE WHEN CCC.SEQUEN IS NULL THEN
                              CASE WHEN BON.FILREC IS NULL THEN
                                   CASE WHEN DOUT.DESCAR IS NULL THEN
                                        CASE WHEN DCOB.GERTIT = 'T' THEN 'Boleto'
                                             ELSE CASE WHEN REC.FLGEST = 'A' AND LeParametroBoo('EXIBEMEIOCOMOABERTO','','','','') = 'T' THEN 'Aberto'
                                                       ELSE 'Dinheiro'
                                                  END
                                        END
                                   ELSE DOUT.DESCAR
                                   END
                              ELSE 'Bonus'
                              END
                         ELSE 'C/C '||coalesce(TRIM(DCCC.DESCCC),'')||'  '||'Situao: '||CASE CCC.STATUS WHEN 'A' THEN 'Aberto'
                                                                                                    WHEN 'F' THEN 'Faturamento'
                                                                                                    WHEN 'P' THEN 'Pagamento'
                                                                                                    WHEN 'S' THEN 'Suspensos'
                                                                                    END
                                                                                  ||'- Documento: '||coalesce(CCC.NUMDOC,'')
                                                                                  ||coalesce(CASE WHEN FAT.CODFIL IS NOT NULL THEN '- Fatura: '
                                                                                                                     ||COALESCE(FAT.CODFIL,'')||'-'||COALESCE(FAT.CODSER,'')||'/'||COALESCE(FAT.NUMECF,'')||'-'||LTRIM(COALESCE(FAT.NUMNOT,''))
                                                                                    END,'')
                         END
               ELSE 'Carto '||COALESCE(TRIM(CAR.DESOUT),'')
                             ||CASE WHEN REC.FILITF IS NOT NULL
                                    THEN (SELECT CASE MIN(TEF.TIPOPE)
                                                    WHEN 'C' THEN ' - Crdito'
                                                    WHEN 'D' THEN ' - Dbito'
                                                    ELSE ''
                                                 END
                                            FROM TT_TEF TEF
                                           WHERE TEF.CODFIL = REC.FILITF
                                             AND TEF.SEQUEN = REC.SEQITF)
                                    ELSE (SELECT CASE MIN(TEF.TIPOPE)
                                                    WHEN 'C' THEN ' - Crdito'
                                                    WHEN 'D' THEN ' - Dbito'
                                                    ELSE ''
                                                 END
                                            FROM TT_TEF TEF INNER JOIN TT_OPE OPE ON OPE.CODFIL = TEF.CODFIL
                                                                                 AND OPE.NUMECF = TEF.NUMECF
                                                                                 AND OPE.TRN_ID = TEF.TRN_ID
                                           WHERE OPE.FILREC = REC.CODFIL
                                             AND OPE.SEQREC = REC.SEQUEN
                                             AND OPE.NUMPAR = REC.NUMPAR
                                             AND OPE.SUBPAR = REC.SUBPAR
                                             AND TEF.CARTAO = REC.CARTAO)
                               END                   
                    END
               ELSE CASE CHR.FLGEST WHEN 'A' THEN 'Cheque a Depositar ('||CODBCO||'.'||CODAGE||'.'||CHR.NUMCON||'.'||NUMCHE||' '||TO_CHAR(VLRCHE,'FM999990D00')||')'||CASE WHEN TRUNC(chr.datope)=TRUNC(chr.datven) THEN ' - A Vista' ELSE ' - A Prazo' END
                                    WHEN 'U' THEN 'Cheque Custodiado ('||CODBCO||'.'||CODAGE||'.'||CHR.NUMCON||'.'||NUMCHE||' '||TO_CHAR(VLRCHE,'FM999990D00')||')'||CASE WHEN TRUNC(chr.datope)=TRUNC(chr.datven) THEN ' - A Vista' ELSE ' - A Prazo' END
                                    WHEN 'B' THEN 'Cheque Cobrado ('||CODBCO||'.'||CODAGE||'.'||CHR.NUMCON||'.'||NUMCHE||' '||TO_CHAR(VLRCHE,'FM999990D00')||')'||CASE WHEN TRUNC(chr.datope)=TRUNC(chr.datven) THEN ' - A Vista' ELSE ' - A Prazo' END
                                    WHEN 'C' THEN 'Cheque Compensado ('||CODBCO||'.'||CODAGE||'.'||CHR.NUMCON||'.'||NUMCHE||' '||TO_CHAR(VLRCHE,'FM999990D00')||')'||CASE WHEN TRUNC(chr.datope)=TRUNC(chr.datven) THEN ' - A Vista' ELSE ' - A Prazo' END
                                    WHEN 'D' THEN 'Cheque Depositado ('||CODBCO||'.'||CODAGE||'.'||CHR.NUMCON||'.'||NUMCHE||' '||TO_CHAR(VLRCHE,'FM999990D00')||')'||CASE WHEN TRUNC(chr.datope)=TRUNC(chr.datven) THEN ' - A Vista' ELSE ' - A Prazo' END
                                    WHEN 'P' THEN 'Cheque Pre-Descontado ('||CODBCO||'.'||CODAGE||'.'||CHR.NUMCON||'.'||NUMCHE||' '||TO_CHAR(VLRCHE,'FM999990D00')||')'||CASE WHEN TRUNC(chr.datope)=TRUNC(chr.datven) THEN ' - A Vista' ELSE ' - A Prazo' END
                                    WHEN 'S' THEN 'Cheque Substituido ('||CODBCO||'.'||CODAGE||'.'||CHR.NUMCON||'.'||NUMCHE||' '||TO_CHAR(VLRCHE,'FM999990D00')||')'||CASE WHEN TRUNC(chr.datope)=TRUNC(chr.datven) THEN ' - A Vista' ELSE ' - A Prazo' END
                                    WHEN 'V' THEN 'Cheque Devolvido ('||CODBCO||'.'||CODAGE||'.'||CHR.NUMCON||'.'||NUMCHE||' '||TO_CHAR(VLRCHE,'FM999990D00')||')'||CASE WHEN TRUNC(chr.datope)=TRUNC(chr.datven) THEN ' - A Vista' ELSE ' - A Prazo' END
                                    WHEN 'X' THEN 'Cheque Cancelado ('||CODBCO||'.'||CODAGE||'.'||CHR.NUMCON||'.'||NUMCHE||' '||TO_CHAR(VLRCHE,'FM999990D00')||')'||CASE WHEN TRUNC(chr.datope)=TRUNC(chr.datven) THEN ' - A Vista' ELSE ' - A Prazo' END
                                    WHEN 'I' THEN 'Cheque Incobrvel ('||CODBCO||'.'||CODAGE||'.'||CHR.NUMCON||'.'||NUMCHE||' '||TO_CHAR(VLRCHE,'FM999990D00')||')'||CASE WHEN TRUNC(chr.datope)=TRUNC(chr.datven) THEN ' - A Vista' ELSE ' - A Prazo' END
                                    ELSE 'Cheque (' ||CODBCO||'.'||CODAGE||'.'||CHR.NUMCON||'.'||NUMCHE||' '||TO_CHAR(VLRCHE,'FM999990D00')||')'||CASE WHEN TRUNC(chr.datope)=TRUNC(chr.datven) THEN ' - A Vista' ELSE ' - A Prazo' END
                    END
               END
          END,
		  FAT.CODFIL, FAT.SEQUEN, CCC.TIPCCC
   FROM TT_REC REC LEFT OUTER JOIN TT_CHR CHR ON CHR.CODFIL = REC.FILREC AND CHR.SEQUEN = REC.SEQCHE
                   LEFT OUTER JOIN TT_BON BON ON BON.FILREC = REC.CODFIL AND BON.SEQREC = REC.SEQUEN AND BON.NUMPAR = REC.NUMPAR AND BON.SUBPAR = REC.SUBPAR
                   LEFT OUTER JOIN TD_CAR CAR ON CAR.CODTAB = REC.CARTAO
                   LEFT OUTER JOIN TT_CCC CCC ON CCC.CODFIL = REC.FILCCC AND CCC.SEQUEN = REC.SEQCCC
                   LEFT OUTER JOIN TT_VEN FAT ON CCC.FILFAT = FAT.CODFIL AND CCC.SEQFAT = FAT.SEQUEN
                   LEFT OUTER JOIN TD_CCC DCCC ON DCCC.CODTAB = CCC.TIPCCC
                   LEFT OUTER JOIN TT_DEVxREC DEV ON DEV.FILREC = REC.CODFIL AND DEV.SEQREC = REC.SEQUEN AND DEV.PARREC = REC.NUMPAR AND DEV.SUBREC = REC.SUBPAR
                   LEFT OUTER JOIN TT_LEX LEX ON LEX.FILREC = REC.CODFIL AND LEX.SEQREC = REC.SEQUEN AND LEX.NUMPAR = REC.NUMPAR AND LEX.SUBPAR = REC.SUBPAR
                   LEFT OUTER JOIN TD_OUT DOUT ON DOUT.CODTAB = REC.CODOUT
                   INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
                   LEFT JOIN TT_LID LID ON LID.CODFIL = VEN.CODFIL                                            
                                        AND LID.CODSER = VEN.CODSER                                            
                                        AND LID.CUPFIS = VEN.NUMNOT                                            
                                        AND LID.NUMECF = VEN.NUMECF                                            
                                        AND LID.TIPOPE = 'VEN' 
                   INNER JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD
   WHERE REC.CODFIL = cCodFil
     AND REC.SEQUEN = cSequen
     AND REC.NUMPAR = nNumPar
     AND REC.SUBPAR = nSubPar;

  crParcelas2 CURSOR FOR
    SELECT CASE WHEN COALESCE(TRUNC(LID.DATEXE), VEN.DATFIS) > VEN.DATFIS AND LeParametroBoo('REL_TRA_PENDENTE','','','','') = 'T' 
                 THEN '(Pend.)' ELSE '' 
           END || CASE WHEN DEV.FILREC IS NOT NULL THEN 'Abatimento por Devolucao'
                WHEN LEX.FILREC IS NOT NULL THEN 'Depsito'
           ELSE
               CASE WHEN REC.SEQCHE IS NULL THEN
                    CASE WHEN REC.CARTAO IS NULL THEN
                         CASE WHEN CCC.SEQUEN IS NULL THEN
                              CASE WHEN BON.FILREC IS NULL THEN
                                   CASE WHEN DOUT.DESCAR IS NULL THEN
                                        CASE WHEN DCOB.GERTIT = 'T' THEN 'Boleto'
                                             ELSE CASE WHEN REC.FLGEST = 'A' AND LeParametroBoo('EXIBEMEIOCOMOABERTO','','','','') = 'T' THEN 'Aberto'
                                                       ELSE 'Dinheiro'
                                                  END
                                        END
                                   ELSE DOUT.DESCAR
                                   END
                              ELSE 'Bonus'
                              END
                         ELSE 'C/C '||LTRIM(RTRIM(DCCC.DESCCC))
                         END
                    ELSE 'Carto '||COALESCE(TRIM(CAR.DESOUT),'')
                                  ||CASE WHEN REC.FILITF IS NOT NULL
                                         THEN (SELECT CASE MIN(TEF.TIPOPE)
                                                          WHEN 'C' THEN ' - Crdito'
                                                          WHEN 'D' THEN ' - Dbito'
                                                          ELSE ''
                                                      END
                                                 FROM TT_TEF TEF
                                                WHERE TEF.CODFIL = REC.FILITF
                                                  AND TEF.SEQUEN = REC.SEQITF)
                                         ELSE (SELECT CASE MIN(TEF.TIPOPE)
                                                          WHEN 'C' THEN ' - Crdito'
                                                          WHEN 'D' THEN ' - Dbito'
                                                          ELSE ''
                                                      END
                                                 FROM TT_TEF TEF INNER JOIN TT_OPE OPE ON OPE.CODFIL = TEF.CODFIL
                                                                                      AND OPE.NUMECF = TEF.NUMECF
                                                                                      AND OPE.TRN_ID = TEF.TRN_ID
                                                WHERE OPE.FILREC = REC.CODFIL
                                                  AND OPE.SEQREC = REC.SEQUEN
                                                  AND OPE.NUMPAR = REC.NUMPAR
                                                  AND OPE.SUBPAR = REC.SUBPAR
                                                  AND TEF.CARTAO = REC.CARTAO)
                                    END
                    END
               ELSE 'Cheque ' ||
                    CASE WHEN nTipo = 1 THEN ''
                    ELSE case when chr.datven >= trunc(ven.dathor) + 35 then '> 35d      '
                    else case when chr.datven >= trunc(ven.dathor) + 28 then 'de 28 a 34d'
                    else case when chr.datven >= trunc(ven.dathor) + 21 then 'de 21 a 27d'
                    else case when chr.datven >= trunc(ven.dathor) + 14 then 'de 14 a 20d'
                    else case when chr.datven >= trunc(ven.dathor) + 07 then 'de 07 a 13d'
                    else 'de 01 a 06d' end end end end end
                    END
               END
           END
   FROM TT_REC REC LEFT OUTER JOIN TT_BON BON ON BON.FILREC = REC.CODFIL AND BON.SEQREC = REC.SEQUEN AND BON.NUMPAR = REC.NUMPAR AND BON.SUBPAR = REC.SUBPAR
                        INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
                   LEFT OUTER JOIN TD_CAR CAR ON CAR.CODTAB = REC.CARTAO
                   LEFT OUTER JOIN TT_CCC CCC ON CCC.CODFIL = REC.FILCCC AND CCC.SEQUEN = REC.SEQCCC
                   LEFT OUTER JOIN TD_CCC DCCC ON DCCC.CODTAB = CCC.TIPCCC
                   LEFT OUTER JOIN TT_CHR CHR ON CHR.CODFIL = REC.FILREC AND CHR.SEQUEN = REC.SEQCHE
                   LEFT OUTER JOIN TT_DEVxREC DEV ON DEV.FILREC = REC.CODFIL AND DEV.SEQREC = REC.SEQUEN AND DEV.PARREC = REC.NUMPAR AND DEV.SUBREC = REC.SUBPAR
                   LEFT OUTER JOIN TT_LEX LEX ON LEX.FILREC = REC.CODFIL AND LEX.SEQREC = REC.SEQUEN AND LEX.NUMPAR = REC.NUMPAR AND LEX.SUBPAR = REC.SUBPAR
                   LEFT OUTER JOIN TD_OUT DOUT ON DOUT.CODTAB = REC.CODOUT
                   LEFT JOIN TT_LID LID ON LID.CODFIL = VEN.CODFIL                                            
                                        AND LID.CODSER = VEN.CODSER                                            
                                        AND LID.CUPFIS = VEN.NUMNOT                                            
                                        AND LID.NUMECF = VEN.NUMECF                                            
                                        AND LID.TIPOPE = 'VEN' 
                   INNER JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD
   WHERE REC.CODFIL = cCodFil
     AND REC.SEQUEN = cSequen
     AND REC.NUMPAR = nNumPar
     AND REC.SUBPAR = nSubPar;

	 
  crParcelas3 CURSOR FOR
    SELECT CASE WHEN COALESCE(TRUNC(LID.DATEXE), VEN.DATFIS) > VEN.DATFIS AND LeParametroBoo('REL_TRA_PENDENTE','','','','') = 'T' 
                 THEN '(Pend.)' ELSE '' 
           END || CASE WHEN DEV.FILREC IS NOT NULL THEN 'Abatimento por Devolucao'
                WHEN LEX.FILREC IS NOT NULL THEN 'Depsito'
           ELSE
               CASE WHEN REC.SEQCHE IS NULL THEN
                    CASE WHEN REC.CARTAO IS NULL THEN
                         CASE WHEN CCC.SEQUEN IS NULL THEN
                              CASE WHEN BON.FILREC IS NULL THEN
                                   CASE WHEN DOUT.DESCAR IS NULL THEN
                                        CASE WHEN DCOB.GERTIT = 'T' THEN 'Boleto'
                                             ELSE CASE WHEN REC.FLGEST = 'A' AND LeParametroBoo('EXIBEMEIOCOMOABERTO','','','','') = 'T' THEN 'Aberto'
                                                       ELSE 'Dinheiro'
                                                  END
                                        END
                                   ELSE DOUT.DESCAR
                                   END
                              ELSE 'Bonus'
                              END
                         ELSE 'C/C '||LTRIM(RTRIM(DCCC.DESCCC))
                         END
                    ELSE 'Carto '||CASE WHEN REC.FILITF IS NOT NULL
                                         THEN (SELECT CASE MIN(TEF.TIPOPE)
                                                         WHEN 'C' THEN ' - Crdito'
                                                         WHEN 'D' THEN ' - Dbito'
                                                         ELSE ''
                                                      END
                                                 FROM TT_TEF TEF
                                                WHERE TEF.CODFIL = REC.FILITF
                                                  AND TEF.SEQUEN = REC.SEQITF)
                                         ELSE (SELECT CASE MIN(TEF.TIPOPE)
                                                         WHEN 'C' THEN ' - Crdito'
                                                         WHEN 'D' THEN ' - Dbito'
                                                         ELSE ''
                                                      END
                                                 FROM TT_TEF TEF INNER JOIN TT_OPE OPE ON OPE.CODFIL = TEF.CODFIL
                                                                                      AND OPE.NUMECF = TEF.NUMECF
                                                                                      AND OPE.TRN_ID = TEF.TRN_ID
                                                WHERE OPE.FILREC = REC.CODFIL
                                                  AND OPE.SEQREC = REC.SEQUEN
                                                  AND OPE.NUMPAR = REC.NUMPAR
                                                  AND OPE.SUBPAR = REC.SUBPAR
                                                  AND TEF.CARTAO = REC.CARTAO)
                                    END
                    END
               ELSE 'Cheque ' ||
                    CASE WHEN trunc(chr.datven) = trunc(ven.dathor) then 'a Vista'
                    else 'Pre'
                    END
               END
           END
   FROM TT_REC REC LEFT OUTER JOIN TT_BON BON ON BON.FILREC = REC.CODFIL AND BON.SEQREC = REC.SEQUEN AND BON.NUMPAR = REC.NUMPAR AND BON.SUBPAR = REC.SUBPAR
                        INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
                   LEFT OUTER JOIN TD_CAR CAR ON CAR.CODTAB = REC.CARTAO
                   LEFT OUTER JOIN TT_CCC CCC ON CCC.CODFIL = REC.FILCCC AND CCC.SEQUEN = REC.SEQCCC
                   LEFT OUTER JOIN TD_CCC DCCC ON DCCC.CODTAB = CCC.TIPCCC
                   LEFT OUTER JOIN TT_CHR CHR ON CHR.CODFIL = REC.FILREC AND CHR.SEQUEN = REC.SEQCHE
                   LEFT OUTER JOIN TT_DEVxREC DEV ON DEV.FILREC = REC.CODFIL AND DEV.SEQREC = REC.SEQUEN AND DEV.PARREC = REC.NUMPAR AND DEV.SUBREC = REC.SUBPAR
                   LEFT OUTER JOIN TT_LEX LEX ON LEX.FILREC = REC.CODFIL AND LEX.SEQREC = REC.SEQUEN AND LEX.NUMPAR = REC.NUMPAR AND LEX.SUBPAR = REC.SUBPAR
                   LEFT OUTER JOIN TD_OUT DOUT ON DOUT.CODTAB = REC.CODOUT
                   LEFT JOIN TT_LID LID ON LID.CODFIL = VEN.CODFIL                                            
                                        AND LID.CODSER = VEN.CODSER                                            
                                        AND LID.CUPFIS = VEN.NUMNOT                                            
                                        AND LID.NUMECF = VEN.NUMECF                                            
                                        AND LID.TIPOPE = 'VEN' 
                   INNER JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD
   WHERE REC.CODFIL = cCodFil
     AND REC.SEQUEN = cSequen
     AND REC.NUMPAR = nNumPar
     AND REC.SUBPAR = nSubPar;
begin
   iQtdRDV := 0;
   
   IF LeParametroBoo('NF_APOS_SEPARACAO_EC','', '', '', '') = 'T' THEN
	   BEGIN
			cMEIO := null;
			select min(cast('Pagamento Externo: '||
			 case rdv.tiprdv when '1' then 'Banco Brasil'
							 when '2' then 'Bradesco'
							 when '3' then 'Banrisul'
							 when '4' then 'HSBC'
							 when '5' then 'Itau'
							 when '9' then 'Pagamento Digital'
							 when 'A' then 'Carto Amex'
							 when 'B' then 'Boleto'
							 when 'C' then 'PagSeguro Carto'
							 when 'D' then 'Dinners'
							 when 'E' then 'Elo'
							 when 'H' then 'HiperCard'
							 when 'M' then 'MasterCard' 
							 when 'O' then 'Outros'
							 when 'P' then 'PagSeguro Boleto'
							 when 'S' then 'PagSeguro'
							 when 'U' then 'Aura'
							 when 'V' then 'Visa'
							 when 'X' then 'Oramento'
							 when 'W' then 'Boleto a prazo'
			 end as VARCHAR(100))), COUNT(*) AS C 
         INTO cMEIO, iQtdRDV
			from tt_orc orc inner join tt_ior ior on orc.codfil=ior.codfil and orc.tipped=ior.tipped and orc.numped=ior.numped
							inner join tt_rdv rdv on rdv.codfil=orc.codfil and rdv.tipped=orc.tipped and rdv.numped=orc.numped
			where orc.flgeco is not null
			and rdv.tiprdv<>'W' -- No considerar quando for boleto a prazo
			and ior.filive=cCodFil
			and ior.seqive=cSequen;

	  	  END;
     
     IF COALESCE(iQtdRDV,0) > 1 THEN
       cMEIO := NULL;
     END IF; 
	  
	  IF cMEIO IS NOT NULL THEN 
        RETURN cMEIO;
	  END IF;
	  
   END IF;
   
   if nTipo = 0 then
       nResultado := '';
       i := 0;
       OPEN crParcelas;
       LOOP
       FETCH crParcelas into REC_TEXTO, cFILFAT, cSEQFAT, nTIPCCC;
       EXIT WHEN NOT FOUND;
 		  if cFILFAT IS NOT NULL then
				
				SELECT CC_PENDENCIA INTO nCC_PENDENCIA
				FROM TT_CFG;
				
				if nCC_PENDENCIA = nTIPCCC and (cCodFil<>cFILFAT or cSequen<>cSEQFAT) then
					
					-- 105665 -  Chamada recursiva para pegar o meio de pagamento da pendencia
					SELECT  RECF.CODFIL, RECF.SEQUEN, RECF.NUMPAR, RECF.SUBPAR
					  INTO cPENCODFIL, cPENSEQUEN, cPENNUMPAR, cPENSUBPAR
					  FROM TT_VEN FAT LEFT JOIN TT_REC RECF ON FAT.CODFIL=RECF.CODFIL AND FAT.SEQUEN = RECF.SEQUEN AND RECF.NUMPAR=' 1' AND RECF.SUBPAR=' 0'                       
					 WHERE FAT.CODFIL = cFILFAT
					   AND FAT.SEQUEN = cSEQFAT; 
				
				end if;
		   else
			 if i = 0 then
				nResultado := REC_TEXTO;
			 else
				nResultado := LTRIM(RTRIM(COALESCE(nResultado,''))) || chr(13) || chr(10) || COALESCE(REC_TEXTO,'');
			 end if;		 
			 i := i + 1;
		   end if; 	
       end loop;
       CLOSE crParcelas;
	   
	   -- 105665 -  Chamada recursiva para pegar o meio de pagamento da pendencia
	   if cPENCODFIL IS NOT NULL then 
		  nResultado := MEIODEPAGAMENTO(cPENCODFIL, cPENSEQUEN, cPENNUMPAR, cPENSUBPAR, nTipo);
	   end if;
      
      IF COALESCE(iQtdRDV,0) > 1 THEN
         return 'Pagamento Externo: ' || nResultado;
      ELSE
         return nResultado;
      END IF;
   elsif nTipo = 1 then 
      Resultado2 := '';
      OPEN crParcelas2;
      FETCH crParcelas2 into Resultado2;
      CLOSE crParcelas2;
            
      IF COALESCE(iQtdRDV,0) > 1 THEN
         return 'Pagamento Externo: ' || Resultado2;
      ELSE
         return Resultado2;
      END IF;
   else
	  nResultado := '';
      OPEN crParcelas3;
      FETCH crParcelas3 into nResultado;
      CLOSE crParcelas3;
      
      IF COALESCE(iQtdRDV,0) > 1 THEN
         return 'Pagamento Externo: ' || nResultado;
      ELSE
         return nResultado;
      END IF;
   end if;

END;
$$ language 'plpgsql' STABLE;


/*-- SEQ 1598 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION MeioDePagamento (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE);

/*-- SEQ 1599 --*/
CREATE OR REPLACE FUNCTION MeioDePagamento (TT_REC.CODFIL%TYPE,
                               TT_REC.SEQUEN%TYPE,
                               TT_REC.NUMPAR%TYPE,
                               TT_REC.SUBPAR%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN MeioDePagamento($1,$2,$3,$4,0);
END;
$$ language 'plpgsql' STABLE;


/*-- SEQ 1600 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PedidoPendente (VARCHAR,TT_IPE.FILMAT%TYPE,TT_IPE.CODMAT%TYPE,TT_IPE.CODCOR%TYPE,TT_IPE.CODTAM%TYPE,VARCHAR,VARCHAR,VARCHAR,TT_IPE.CODMUL%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1601 --*/
CREATE OR REPLACE FUNCTION PedidoPendente (VARCHAR,TT_IPE.FILMAT%TYPE,TT_IPE.CODMAT%TYPE,TT_IPE.CODCOR%TYPE,TT_IPE.CODTAM%TYPE,VARCHAR,VARCHAR,VARCHAR,TT_IPE.CODMUL%TYPE,VARCHAR)
RETURNS Numeric AS $$
DECLARE
pCodFil ALIAS FOR $1 ;
pFilMat ALIAS FOR $2 ;
pCodMat ALIAS FOR $3 ;
pCodCor ALIAS FOR $4 ;
pCodTam ALIAS FOR $5 ;
pTipo ALIAS FOR $6 ;
pEncomenda ALIAS FOR $7 ;
pConsideraPedRepos ALIAS FOR $8 ;
pCodMul ALIAS FOR $9 ;
pConsideraDeposito ALIAS FOR $10 ;
   QTDPEN                        Numeric; -- Quantidade Pendente
   cPedidosDeFilial              VARCHAR(4000);

-- Objetivo:
-- 1) Calcular a quantidade pendente de pedidos nao recebidos 
--
-- p_Tipo =
-- T - Todos
-- R - Reposicao entre filiais
-- C - Pedido de compra aos fornecedores
-- F - Pedido de compra aos fornecedores (usado na tela de Sugestão de Compra no Grid de Saldos)

-- pConsideraPedRepos =
-- E - Pedidos de reposição de entrada (Padrão)
-- S - Pedido de reposição de saída

-- pConsideraDeposito = 
-- T - Considera Saldo de Depósito no Cálculo do Saldo / Saldo Numeric 
-- F - Não considera Saldo de Depósito no Cálculo do Saldo / Saldo Numeric 

BEGIN
   cPedidosDeFilial := pCodFil;
   IF (pTipo='C') THEN
      -- Considerar Pedidos Pendentes de todas as filiais quando ativo parâmetro
      IF (LeParametroBoo('PEDIDO_TODAS_FILIAIS', NULL, NULL, NULL, NULL) = 'T') THEN
         cPedidosDeFilial := NULL;
      END IF;
   END IF;

   IF pConsideraPedRepos = 'S' THEN
      IF pEncomenda = 'F' THEN
         SELECT SUM(COALESCE(IPE.QTDITE,0)-COALESCE(IPE.QTDCAN,0)) INTO QTDPEN
           FROM TT_CLI PAR, TT_PED PED, TT_IPE IPE, TT_CFG CFG
          WHERE PED.CODFIL = IPE.CODFIL
            AND PED.NUMPED = IPE.NUMPED
            AND PAR.FILCLI = PED.FILFOR
            AND PAR.CODCLI = PED.CODFOR
            AND IPE.FILMAT = pFilMat
            AND IPE.CODMAT = pCodMat
            AND IPE.CODCOR = pCodCor
            AND IPE.CODTAM = pCodTam
            AND IPE.CODMUL = CASE WHEN pCodMul = -1 THEN IPE.CODMUL ELSE pCodMul END
            AND ((INSTR(COALESCE(cPedidosDeFilial, PED.FILFOR)||';', PED.FILFOR||';') > 0) OR 
            -- MN - A ideia desse OR é que se passar PEDIDOPENDENTE ('R') da filial de depósito, traz todas as reposições
            -- que o depósito deve fazer ainda. Não precisa fazer a lógida de cima porque com parâmetro funciona para uma filial apenas
                  (pTipo = 'R' AND pConsideraDeposito = 'T' AND PED.FILFOR IN (SELECT CODFIL FROM TD_FIL WHERE CODDEP = cPedidosDeFilial))
                )
            AND ((pTipo = 'T') 
              OR (pTipo = 'R' AND PAR.FLGTIP =  5)
              OR (pTipo IN ('C','F') AND PAR.FLGTIP <> 5))
            AND IPE.FLGEST = 'A'
            -- RFMP - 53182 - 05/06/07
            AND PED.FLGEST IN (CASE CFG.PENAUT WHEN 'T' THEN '2' ELSE 'A' END, '2' );
       ELSE
         SELECT SUM((COALESCE(IPE.QTDITE,0)
                     - COALESCE((SELECT SUM(QTDENC) 
                                    FROM TT_IVEXIPE VXP 
                                   WHERE VXP.FILIPE = IPE.CODFIL AND VXP.NUMIPE = IPE.NUMPED
                                     AND VXP.ITEIPE = IPE.NUMITE AND VXP.FLGEST <> 'C'),0)
                     - COALESCE(IPE.QTDCAN,0))) INTO QTDPEN
           FROM TT_CLI PAR, TT_PED PED, TT_IPE IPE, TT_CFG CFG
          WHERE PED.CODFIL = IPE.CODFIL
            AND PED.NUMPED = IPE.NUMPED
            AND PAR.FILCLI = PED.FILFOR
            AND PAR.CODCLI = PED.CODFOR
            AND IPE.FILMAT = pFilMat
            AND IPE.CODMAT = pCodMat
            AND IPE.CODCOR = pCodCor
            AND IPE.CODTAM = pCodTam
            AND IPE.CODMUL = CASE WHEN pCodMul = -1 THEN IPE.CODMUL ELSE pCodMul END
            AND ((INSTR(COALESCE(cPedidosDeFilial, PED.FILFOR)||';', PED.FILFOR||';') > 0) OR
            -- MN - A ideia desse OR é que se passar PEDIDOPENDENTE ('R') da filial de depósito, traz todas as reposições
            -- que o depósito deve fazer ainda. Não precisa fazer a lógida de cima porque com parâmetro funciona para uma filial apenas
                  (pTipo = 'R' AND pConsideraDeposito = 'T' AND PED.FILFOR IN (SELECT CODFIL FROM TD_FIL WHERE CODDEP = cPedidosDeFilial))
                )  
            AND ((pTipo = 'T') 
              OR (pTipo = 'R' AND PAR.FLGTIP =  5)
              OR (pTipo IN ('C','F') AND PAR.FLGTIP <> 5))
            AND IPE.FLGEST = 'A'
            -- RFMP - 53182 - 05/06/07
            AND PED.FLGEST IN (CASE CFG.PENAUT WHEN 'T' THEN '2' ELSE 'A' END, '2' );
       END IF;
     ELSE
      IF pEncomenda = 'F' THEN
         SELECT SUM(COALESCE(IPE.QTDITE,0)-COALESCE(IPE.QTDCAN,0)) INTO QTDPEN
           FROM TT_CLI PAR, TT_PED PED, TT_IPE IPE, TT_CFG CFG
          WHERE PED.CODFIL = IPE.CODFIL
            AND PED.NUMPED = IPE.NUMPED
            AND PAR.FILCLI = PED.FILFOR
            AND PAR.CODCLI = PED.CODFOR
            AND IPE.FILMAT = pFilMat
            AND IPE.CODMAT = pCodMat
            AND IPE.CODCOR = pCodCor
            AND IPE.CODTAM = pCodTam
            AND IPE.CODMUL = CASE WHEN pCodMul = -1 THEN IPE.CODMUL ELSE pCodMul END
            AND ((INSTR(COALESCE(cPedidosDeFilial, IPE.FILENT)||';', IPE.FILENT||';') > 0) OR
                -- MN - A ideia desse OR é que se passar PEDIDOPENDENTE ('R') da filial de depósito, traz todas as reposições
                -- que o depósito deve fazer ainda. Não precisa fazer a lógida de cima porque com parâmetro funciona para uma filial apenas
                  (pTipo = 'R' AND pConsideraDeposito = 'T' AND PED.FILFOR IN (SELECT CODFIL FROM TD_FIL WHERE CODDEP = cPedidosDeFilial))
                )
            AND ((pTipo = 'T') 
              OR (pTipo = 'R' AND PAR.FLGTIP =  5)
              OR (pTipo IN ('C','F') AND PAR.FLGTIP <> 5))
            AND IPE.FLGEST = 'A'
            -- RFMP - 53182 - 05/06/07
            AND PED.FLGEST IN (CASE CFG.PENAUT WHEN 'T' THEN '2' ELSE 'A' END, '2' );
       ELSE
         SELECT SUM((COALESCE(IPE.QTDITE,0)
                     - COALESCE((SELECT SUM(QTDENC) 
                                    FROM TT_IVEXIPE VXP 
                                   WHERE VXP.FILIPE = IPE.CODFIL AND VXP.NUMIPE = IPE.NUMPED
                                     AND VXP.ITEIPE = IPE.NUMITE AND VXP.FLGEST <> 'C'),0)
                     - COALESCE(IPE.QTDCAN,0))) INTO QTDPEN
           FROM TT_CLI PAR, TT_PED PED, TT_IPE IPE, TT_CFG CFG
          WHERE PED.CODFIL = IPE.CODFIL
            AND PED.NUMPED = IPE.NUMPED
            AND PAR.FILCLI = PED.FILFOR
            AND PAR.CODCLI = PED.CODFOR
            AND IPE.FILMAT = pFilMat
            AND IPE.CODMAT = pCodMat
            AND IPE.CODCOR = pCodCor
            AND IPE.CODTAM = pCodTam
            AND IPE.CODMUL = CASE WHEN pCodMul = -1 THEN IPE.CODMUL ELSE pCodMul END
            AND ((INSTR(COALESCE(cPedidosDeFilial, IPE.FILENT)||';', IPE.FILENT||';') > 0) OR
                -- MN - A ideia desse OR é que se passar PEDIDOPENDENTE ('R') da filial de depósito, traz todas as reposições
                -- que o depósito deve fazer ainda. Não precisa fazer a lógida de cima porque com parâmetro funciona para uma filial apenas
                  (pTipo = 'R' AND pConsideraDeposito = 'T' AND PED.FILFOR IN (SELECT CODFIL FROM TD_FIL WHERE CODDEP = cPedidosDeFilial))
                )
            AND ((pTipo = 'T') 
              OR (pTipo = 'R' AND PAR.FLGTIP =  5)
              OR (pTipo IN ('C','F') AND PAR.FLGTIP <> 5))
            AND IPE.FLGEST = 'A'
            -- RFMP - 53182 - 05/06/07
            AND PED.FLGEST IN (CASE CFG.PENAUT WHEN 'T' THEN '2' ELSE 'A' END, '2' );
       END IF;     
     END IF;
         
    RETURN COALESCE(QTDPEN,0);
END;
$$ language 'plpgsql';


/*-- SEQ 1602 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PedidoPendente (VARCHAR,TT_IPE.FILMAT%TYPE,TT_IPE.CODMAT%TYPE,TT_IPE.CODCOR%TYPE,TT_IPE.CODTAM%TYPE) CASCADE;

/*-- SEQ 1603 --*/
CREATE OR REPLACE FUNCTION PedidoPendente (VARCHAR,
                               TT_IPE.FILMAT%TYPE,
                               TT_IPE.CODMAT%TYPE,
                               TT_IPE.CODCOR%TYPE,
                               TT_IPE.CODTAM%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN PedidoPendente($1,$2,$3,$4,$5,'T','F','E','-1','T');
END;
$$ language 'plpgsql';


/*-- SEQ 1604 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PedidoPendente (VARCHAR,TT_IPE.FILMAT%TYPE,TT_IPE.CODMAT%TYPE,TT_IPE.CODCOR%TYPE,TT_IPE.CODTAM%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1605 --*/
CREATE OR REPLACE FUNCTION PedidoPendente (VARCHAR,
                               TT_IPE.FILMAT%TYPE,
                               TT_IPE.CODMAT%TYPE,
                               TT_IPE.CODCOR%TYPE,
                               TT_IPE.CODTAM%TYPE,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN PedidoPendente($1,$2,$3,$4,$5,$6,'F','E','-1','T');
END;
$$ language 'plpgsql';


/*-- SEQ 1606 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PedidoPendente (VARCHAR,TT_IPE.FILMAT%TYPE,TT_IPE.CODMAT%TYPE,TT_IPE.CODCOR%TYPE,TT_IPE.CODTAM%TYPE,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1607 --*/
CREATE OR REPLACE FUNCTION PedidoPendente (VARCHAR,
                               TT_IPE.FILMAT%TYPE,
                               TT_IPE.CODMAT%TYPE,
                               TT_IPE.CODCOR%TYPE,
                               TT_IPE.CODTAM%TYPE,
                               VARCHAR,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN PedidoPendente($1,$2,$3,$4,$5,$6,$7,'E','-1','T');
END;
$$ language 'plpgsql';


/*-- SEQ 1608 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PedidoPendente (VARCHAR,TT_IPE.FILMAT%TYPE,TT_IPE.CODMAT%TYPE,TT_IPE.CODCOR%TYPE,TT_IPE.CODTAM%TYPE,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1609 --*/
CREATE OR REPLACE FUNCTION PedidoPendente (VARCHAR,
                               TT_IPE.FILMAT%TYPE,
                               TT_IPE.CODMAT%TYPE,
                               TT_IPE.CODCOR%TYPE,
                               TT_IPE.CODTAM%TYPE,
                               VARCHAR,
                               VARCHAR,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN PedidoPendente($1,$2,$3,$4,$5,$6,$7,$8,'-1','T');
END;
$$ language 'plpgsql';


/*-- SEQ 1610 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PedidoPendente (VARCHAR,TT_IPE.FILMAT%TYPE,TT_IPE.CODMAT%TYPE,TT_IPE.CODCOR%TYPE,TT_IPE.CODTAM%TYPE,VARCHAR,VARCHAR,VARCHAR,TT_IPE.CODMUL%TYPE) CASCADE;

/*-- SEQ 1611 --*/
CREATE OR REPLACE FUNCTION PedidoPendente (VARCHAR,
                               TT_IPE.FILMAT%TYPE,
                               TT_IPE.CODMAT%TYPE,
                               TT_IPE.CODCOR%TYPE,
                               TT_IPE.CODTAM%TYPE,
                               VARCHAR,
                               VARCHAR,
                               VARCHAR,
                               TT_IPE.CODMUL%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN PedidoPendente($1,$2,$3,$4,$5,$6,$7,$8,$9,'T');
END;
$$ language 'plpgsql';


/*-- SEQ 1612 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RegistraAcesso (INTEGER,VARCHAR,TT_UID.CODUID%TYPE,TT_UID.USEROS%TYPE,TT_UID.DATOPE%TYPE,TT_UID.NOMMAQ%TYPE,TT_UID.VERBAS%TYPE,TT_UID.VERSIS%TYPE,TT_UID.NOMSIS%TYPE,TT_UID.SESSION_ID%TYPE) CASCADE;

/*-- SEQ 1613 --*/
CREATE OR REPLACE FUNCTION RegistraAcesso (INTEGER,VARCHAR,TT_UID.CODUID%TYPE,TT_UID.USEROS%TYPE,TT_UID.DATOPE%TYPE,TT_UID.NOMMAQ%TYPE,TT_UID.VERBAS%TYPE,TT_UID.VERSIS%TYPE,TT_UID.NOMSIS%TYPE,TT_UID.SESSION_ID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCodemp ALIAS FOR $1 ;
pHashConexao ALIAS FOR $2 ;
pCODUID ALIAS FOR $3 ;
pUSEROS ALIAS FOR $4 ;
pDATOPE ALIAS FOR $5 ;
pNOMMAQ ALIAS FOR $6 ;
pVERBAS ALIAS FOR $7 ;
pVERSIS ALIAS FOR $8 ;
pNOMSIS ALIAS FOR $9 ;
pSESSION_ID ALIAS FOR $10 ;
 vComplemento CONSTANT VARCHAR(254):= constante('complemento');
 cTextoConcatenado VARCHAR(254);
 cAssinatura TT_UID.ASSINA%TYPE;
 pCODUIDAux TT_UID.CODUID%TYPE;
 BEGIN

   update tt_uid
      set termin = 'T'
    where termin='F'
      and not session_id in (SELECT PROCPID FROM TV_PG_STAT_ACTIVITY);

  --IF NOT pCodemp > 0 THEN
  --  RAISE EXCEPTION 'PG-2001 Somente parceiros podem utilizar esta funo.%' , vComplemento;
  --END IF;

  cTextoConcatenado := ConcatenaUID(pCODUID,
                                    pUSEROS,
                                    pDATOPE,
                                    pNOMMAQ,
                                    pVERBAS,
                                    pVERSIS,
                                    pNOMSIS,
                                    pSESSION_ID) || Coalesce(pHashConexao, '');

  IF cTextoConcatenado IS NULL THEN
    RAISE EXCEPTION 'PG-2002 No foi possvel concatenar campos da TT_UID.%' , vComplemento;
  END IF;

  cAssinatura := AssinaTab('TT_UID', cTextoConcatenado, 0, pHashConexao, '', pCodemp, '');

  IF cAssinatura IS NULL THEN
    RAISE EXCEPTION 'PG-2003 No foi possvel assinar TT_UID.%' , vComplemento;
  END IF;

  INSERT INTO TT_UID (USEROS, DATOPE, NOMMAQ, VERBAS, VERSIS, NOMSIS, SESSION_ID, CODUID, ASSINA, CODEMP) VALUES(
                      pUSEROS, pDATOPE, pNOMMAQ, pVERBAS, pVERSIS, pNOMSIS, pSESSION_ID, pCODUID, cAssinatura, pCodemp);

  CREATE TEMPORARY TABLE IF NOT EXISTS TMP_UID (CODUID Numeric, APEUSU VARCHAR(10), ASSINS VARCHAR(1) DEFAULT 'T');

  INSERT INTO TMP_UID (CODUID) VALUES (pCODUID);

  SELECT CODUID INTO pCODUIDAux FROM TT_UID WHERE CODUID = pCODUID;

  IF pCODUIDAux IS NULL THEN
    RAISE EXCEPTION 'PG-2004 Acesso no registrado na TT_UID.%' , vComplemento;
  END IF;

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1614 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RevisaTRO () CASCADE;

/*-- SEQ 1615 --*/
CREATE OR REPLACE FUNCTION RevisaTRO ()
RETURNS VARCHAR AS $$
DECLARE

-- INSERE as novas vendas.
-- O tipo da natureza da venda deve ser somente VENDA ou somente DEVOLUCAO.
-- A natureza deve ter alguma natureza reversa definida.
wk_ret char(1);
BEGIN

SELECT DISABLETRIGGERS('TT_VEN') INTO wk_ret;
SELECT DISABLETRIGGERS('TT_REC') INTO wk_ret;
ALTER TABLE TT_IOR DROP CONSTRAINT FK_IOR_IVE ;

--FAZ O UPDATE PARA ACERTAR O TIPTRO DAS VENDAS ATUAIS
UPDATE TT_VEN
   SET TIPTRO = TIPOVENDA(CODFIL,SEQUEN)
 WHERE TIPTRO IS NULL;


-- ALIMENTA A TABELA TEMPORARIA DE TROCA
INSERT INTO TM_TRO
(CODFIL, NUMNOT, CODSER, NUMECF, SEQUEN, NEWNOT, VLRLIQ, VLRPOS, VLRNEG, TIPNAT, NEWNAT)
(select VEN.CODFIL, VEN.NUMNOT, VEN.CODSER, VEN.NUMECF,MIN(VEN.SEQUEN) AS SEQUEN,
       LPAD(TO_CHAR(TO_NUMBER(VEN.NUMNOT)+1),6) AS NEWNOT, MIN(VEN.VLRLIQ) AS VLRLIQ,
       SUM(CASE WHEN ABS(IVE.VLRMOV) = IVE.VLRMOV THEN IVE.VLRMOV ELSE 0 END) AS VLRPOS,
       SUM(CASE WHEN ABS(IVE.VLRMOV) = IVE.VLRMOV THEN 0 ELSE IVE.VLRMOV END) AS VLRNEG,
       MIN(NAT.TIPNAT) AS TIPNAT, MIN((SELECT CODTAB FROM TD_NAT WHERE NATDEN = NAT.NATRED)) AS NEWNAT
  FROM TT_VEN VEN inner join TT_IVE IVE on ive.codfil = ven.codfil and ive.sequen=ven.sequen
                  inner join TD_NAT NAT on nat.codtab = ven.codnat
                  left  join TT_VEN TEM on TEM.CODFIL = VEN.CODFIL AND TEM.NUMECF = VEN.NUMECF
                                       AND TEM.CODSER = VEN.CODSER AND LPAD(TO_CHAR(TO_NUMBER(TEM.NUMNOT)+1),6) = VEN.NUMNOT
                  left  join TM_TRO TRO on TRO.CODFIL = VEN.CODFIL AND TRO.SEQUEN = VEN.SEQUEN
WHERE VEN.FLGEST <> 'C'
  AND VEN.TIPTRO = 'A'
  AND IVE.SITMOV <> 'C'
  AND NAT.TIPNAT in ('D','V')
  AND NAT.NATRED is not null
  AND TEM.SEQUEN is null
  AND (TRO.NUMNOT is null OR TRO.DATOPE is not null)
group by VEN.CODFIL, VEN.NUMNOT, VEN.CODSER, VEN.NUMECF);

-- INSERE AS NOVAS VENDAS
INSERT INTO TT_VEN
      (SEQUEN, CODFIL, NUMECF, CODSER, NUMNOT, FILCLI, CODCLI, DATHOR, FLGEST, FILUSU, CODUSU,
       FILVEN, CODVEN, FILPGT, CODPGT, VLRNOT, VLRLIQ, PERCOM, PERENT,
       COMSOB, CODNAT, PRAMED, ESPECI, OBSERV, NROIMP, AUTENT, DESCON, FILGUI,
       CODGUI, SIGNAT, DATSAI, NUMVOL, MARCAS, VLRSEG, VLRFRE, PESBRU, PESLIQ, NUMCON, CODPRE,
       SINAL,  FINANC, TRIBUT, SEQFAT, FILPRE, PROPGT, EMIDES, FILTRA, CODTRA, TIPNOT,
       TIPTRA, FILFAT, ENDFAT, FILENT, ENDENT, FILCOB, ENDCOB, CODFIN, BASUBS, SUBSTT,
       RETIDO, CONSFI, VINCUL, UFLOJA, FLGTIP, LANVEN, CODEXT, CODCTR, EXPORT, TIPTRO,
       CODDEV, VLRCOF, QTDREN, ATU_EM,DUMMY)   -- SO VERSAO 4.1B, PLAFRE, UF_FRE)
(SELECT ProximoCodigo('TT_VEN',VEN.CODFIL) AS SEQUEN,
       VEN.CODFIL, VEN.NUMECF, VEN.CODSER, TRO.NEWNOT AS NUMNOT, FILCLI, CODCLI, DATHOR, 'Q' AS FLGEST,
       FILUSU, CODUSU, FILVEN, CODVEN, FILPGT, CODPGT,
       (CASE TRO.TIPNAT WHEN 'D' THEN TRO.VLRPOS ELSE TRO.VLRNEG END) AS VLRNOT,
       (CASE TRO.TIPNAT WHEN 'D' THEN TRO.VLRPOS ELSE TRO.VLRNEG END) AS VLRLIQ,
       PERCOM, PERENT,
       COMSOB, TRO.NEWNAT AS CODNAT, PRAMED, ESPECI,
       OBSERV, NROIMP, AUTENT, 0 AS DESCON, FILGUI,
       CODGUI, SIGNAT, DATSAI, NUMVOL, MARCAS, VLRSEG, VLRFRE, PESBRU, PESLIQ, NUMCON, CODPRE,
       SINAL, FINANC, TRIBUT, SEQFAT, FILPRE, PROPGT, EMIDES, FILTRA, CODTRA, TIPNOT,
       TIPTRA, FILFAT, ENDFAT, FILENT, ENDENT, FILCOB, ENDCOB, CODFIN, BASUBS, SUBSTT,
       RETIDO, CONSFI, VINCUL, UFLOJA, FLGTIP, LANVEN, CODEXT, CODCTR, EXPORT, TO_CHAR('2') AS TIPTRO,
       CODDEV, VLRCOF, QTDREN, AGORA(),'I' AS DUMMY  -- SO VERSAS 4.1B, PLAFRE, UF_FRE
FROM TT_VEN VEN INNER JOIN TM_TRO TRO ON TRO.CODFIL = VEN.CODFIL AND TRO.SEQUEN = VEN.SEQUEN
 WHERE (VEN.CODFIL, VEN.NUMECF, VEN.CODSER, TRO.NEWNOT) NOT IN (SELECT CODFIL, NUMECF, CODSER, NUMNOT FROM TT_VEN)
   AND TRO.DATOPE IS NULL
);


--UPDATE NOS ITENS PARA VINCULAR A NOVA VENDA.
UPDATE TT_IVE
   SET SEQUEN = COALESCE((SELECT VEN.SEQUEN
                            FROM TM_TRO TRO INNER JOIN TT_VEN VEN ON VEN.CODFIL = TRO.CODFIL
                                                                 AND VEN.NUMECF = TRO.NUMECF
                                                                 AND VEN.CODSER = TRO.CODSER
                                                                 AND VEN.NUMNOT = TRO.NEWNOT
                  WHERE TRO.CODFIL = TT_IVE.CODFIL
                    AND TRO.SEQUEN = TT_IVE.SEQUEN
                    AND (CASE WHEN ABS(TT_IVE.QTDMOV)=TT_IVE.QTDMOV THEN 1 ELSE -1 END) = (CASE WHEN TRO.TIPNAT='D' THEN 1 ELSE -1 END)) ,
               TT_IVE.SEQUEN ),
       NATFIS = COALESCE((SELECT NaturezaVenda( VEN.UFLOJA, TT_IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR,VEN.SUBSTT)
                            FROM TM_TRO TRO INNER JOIN TT_VEN VEN ON VEN.CODFIL = TRO.CODFIL
                                                                 AND VEN.NUMECF = TRO.NUMECF
                                                                 AND VEN.CODSER = TRO.CODSER
                                                                 AND VEN.NUMNOT = TRO.NEWNOT
                                            INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
                  WHERE TRO.CODFIL = TT_IVE.CODFIL
                    AND TRO.SEQUEN = TT_IVE.SEQUEN
                    AND (CASE WHEN ABS(TT_IVE.QTDMOV)=TT_IVE.QTDMOV THEN 1 ELSE -1 END) = (CASE WHEN TRO.TIPNAT='D' THEN 1 ELSE -1 END)) ,
               TT_IVE.NATFIS )
 WHERE (TT_IVE.CODFIL,TT_IVE.SEQUEN) IN (SELECT CODFIL, SEQUEN FROM TM_TRO WHERE DATOPE IS NULL);


--UPDATE NOS ITENS DE ORCAMENTO AOS ITENS DA NOVA VENDA.
UPDATE TT_IOR
   SET SEQIVE = COALESCE((SELECT VEN.SEQUEN
                            FROM TM_TRO TRO INNER JOIN TT_VEN VEN ON VEN.CODFIL = TRO.CODFIL
                                                                 AND VEN.NUMECF = TRO.NUMECF
                                                                 AND VEN.CODSER = TRO.CODSER
                                                                 AND VEN.NUMNOT = TRO.NEWNOT
                                            INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL
                                                                 AND IVE.SEQUEN = VEN.SEQUEN
                  WHERE TRO.CODFIL = TT_IOR.FILIVE
                    AND TRO.SEQUEN = TT_IOR.SEQIVE
                    AND IVE.NUMITE = TT_IOR.NUMIVE), TT_IOR.SEQIVE )
 WHERE (TT_IOR.FILIVE,TT_IOR.SEQIVE) IN (SELECT CODFIL, SEQUEN FROM TM_TRO WHERE DATOPE IS NULL);


--UPDATE NA VENDA ORIGINAL PARA CORRIGIR OS VALORES.
UPDATE TT_VEN
   SET TIPTRO = '2',
       VLRNOT = COALESCE(
                (SELECT (CASE TRO.TIPNAT WHEN 'D' THEN TRO.VLRNEG ELSE TRO.VLRPOS END) AS VLRNOT
                   FROM TM_TRO TRO
                  WHERE TRO.CODFIL = TT_VEN.CODFIL
                    AND TRO.SEQUEN = TT_VEN.SEQUEN), TT_VEN.VLRNOT),
       VLRLIQ = COALESCE(
                (SELECT TRO.VLRLIQ + (CASE TRO.TIPNAT WHEN 'D' THEN TRO.VLRPOS ELSE TRO.VLRNEG END * -1) AS VLRNOT
                   FROM TM_TRO TRO
                  WHERE TRO.CODFIL = TT_VEN.CODFIL
                    AND TRO.SEQUEN = TT_VEN.SEQUEN), TT_VEN.VLRLIQ)
WHERE (TT_VEN.CODFIL, TT_VEN.SEQUEN) IN (SELECT CODFIL, SEQUEN FROM TM_TRO WHERE DATOPE IS NULL);


--FAZ O UPDATE DO DESCONTO SEPARADO PARA DEIXAR O CODIGO MAIS LIMPO.
UPDATE TT_VEN
   SET DESCON = ROUND((1 - (TT_VEN.VLRLIQ/TT_VEN.VLRNOT))*100,2)
WHERE (TT_VEN.CODFIL, TT_VEN.SEQUEN) IN (SELECT CODFIL, SEQUEN FROM TM_TRO WHERE DATOPE IS NULL);


-- INSERE AS PARCELAS DA VENDA ORIGINAL
INSERT INTO TT_REC
(CODFIL, SEQUEN, NUMPAR, SUBPAR, DATVEN, CODMOE, FLGEST, VLRPAR,
 PORTAD, CODUSU, FILREC, FILUSU, VLRPGT, PAGAME, NUMECF, SIGNAT,
 ATU_EM, DATINC)
(SELECT TRO.CODFIL, TRO.SEQUEN,
      COALESCE((SELECT LPAD(TO_CHAR(MAX(to_number(NUMPAR))+1),2) FROM TT_REC WHERE CODFIL=TRO.CODFIL AND SEQUEN=TRO.SEQUEN),' 1') AS NUMPAR,
      ' 0' AS SUBPAR, TRUNC(VEN.DATHOR) AS DATVEN, 0 AS CODMOE, TO_CHAR('P') AS FLGEST,
      ((CASE TRO.TIPNAT WHEN 'D' THEN TRO.VLRPOS ELSE TRO.VLRNEG END) * -1) AS VLRPAR,
      0 AS PORTAD, VEN.CODUSU AS CODUSU, TRO.CODFIL AS FILREC, VEN.FILUSU AS FILUSU,
      ((CASE TRO.TIPNAT WHEN 'D' THEN TRO.VLRPOS ELSE TRO.VLRNEG END) * -1) AS VLRPGT,
      TRUNC(VEN.DATHOR) AS PAGAME, VEN.NUMECF AS NUMECF, 0 AS SIGNAT,
      AGORA() AS ATU_EM, AGORA() AS DATINC
  FROM TM_TRO TRO INNER JOIN TT_VEN VEN ON VEN.CODFIL = TRO.CODFIL AND VEN.SEQUEN = TRO.SEQUEN
   AND VEN.FINANC = 'T'
 WHERE TRO.DATOPE IS NULL);


--INSERE AS PARCELAS DA NOVA VENDA
INSERT INTO TT_REC
(CODFIL, SEQUEN, NUMPAR, SUBPAR, DATVEN, CODMOE, FLGEST, VLRPAR,
 PORTAD, CODUSU, FILREC, FILUSU, VLRPGT, PAGAME, NUMECF, SIGNAT,
 ATU_EM, DATINC)
(SELECT VEN.CODFIL, VEN.SEQUEN, ' 1' AS NUMPAR, ' 0' AS SUBPAR,
      TRUNC(VEN.DATHOR) AS DATVEN, 0 AS CODMOE, TO_CHAR('P') AS FLGEST,
      (CASE TRO.TIPNAT WHEN 'D' THEN TRO.VLRPOS ELSE TRO.VLRNEG END) AS VLRPAR,
      0 AS PORTAD, VEN.CODUSU AS CODUSU, TRO.CODFIL AS FILREC, VEN.FILUSU AS FILUSU,
      (CASE TRO.TIPNAT WHEN 'D' THEN TRO.VLRPOS ELSE TRO.VLRNEG END) AS VLRPGT,
      TRUNC(VEN.DATHOR) AS PAGAME, VEN.NUMECF AS NUMECF, 0 AS SIGNAT,
      AGORA() AS ATU_EM, AGORA() AS DATINC
  FROM TM_TRO TRO INNER JOIN TT_VEN VEN ON VEN.CODFIL = TRO.CODFIL AND VEN.NUMECF = TRO.NUMECF
                                       AND VEN.CODSER = TRO.CODSER AND VEN.NUMNOT = TRO.NEWNOT
 WHERE TRO.DATOPE IS NULL
   AND VEN.FINANC = 'T');


-- FAZ O UPDATE NA TM_TRO DA DATA DE EXECUCAO.
UPDATE TM_TRO SET DATOPE = agora()
 WHERE DATOPE IS NULL
   AND (CODFIL,NUMECF,CODSER,NEWNOT) IN (SELECT CODFIL,NUMECF,CODSER,NUMNOT FROM TT_VEN);


SELECT ENABLETRIGGERS('TT_VEN') INTO wk_ret;
SELECT ENABLETRIGGERS('TT_REC') INTO wk_ret;
ALTER TABLE TT_IOR ADD CONSTRAINT FK_IOR_IVE FOREIGN KEY (FILIVE,SEQIVE,NUMIVE) REFERENCES TT_IVE (CODFIL,SEQUEN,NUMITE) ;


RETURN 'OK';

END;
$$ language 'plpgsql';




/*-- SEQ 1616 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TotalizaNoProjeto (TT_WOR.FILPRJ%TYPE,TT_WOR.SEQPRJ%TYPE,TD_SIT.TIPSIT%TYPE,TT_WOR.FLGACT%TYPE,TT_WOR.TARREA%TYPE,TT_WOR.TARPRE%TYPE,TT_WOR.CONCLU%TYPE,boolean,boolean,boolean) CASCADE;

/*-- SEQ 1617 --*/
CREATE OR REPLACE FUNCTION TotalizaNoProjeto (TT_WOR.FILPRJ%TYPE,TT_WOR.SEQPRJ%TYPE,TD_SIT.TIPSIT%TYPE,TT_WOR.FLGACT%TYPE,TT_WOR.TARREA%TYPE,TT_WOR.TARPRE%TYPE,TT_WOR.CONCLU%TYPE,boolean,boolean,boolean)
RETURNS VARCHAR AS $$
DECLARE
p_Filial ALIAS FOR $1 ;
p_Codigo ALIAS FOR $2 ;
p_Status ALIAS FOR $3 ;
p_Aceite ALIAS FOR $4 ;
p_Real ALIAS FOR $5 ;
p_Previsto ALIAS FOR $6 ;
p_Feito ALIAS FOR $7 ;
p_Menos ALIAS FOR $8 ;
p_NovoStatus ALIAS FOR $9 ;
p_NovoAceite ALIAS FOR $10 ;
  -- Totaliza os tipos de tarefas no projeto
    wk_menos INTEGER;
    
    wk_filpai TT_PRJ.FILPAI%TYPE;
    wk_codpai TT_PRJ.SEQPAI%TYPE;
    vDummy VARCHAR(20);
    vUSA_PERC_HORFAL VARCHAR(1);    
  BEGIN
    IF p_Menos THEN
      wk_menos := -1;
    ELSE
      wk_menos := 1;
    END IF;
 
    IF p_NovoStatus THEN
    
      select USA_PERC_HORFAL into vUSA_PERC_HORFAL
        from TT_CFG;
    
      UPDATE TT_PRJ SET TOTW_A = GREATEST( COALESCE(TOTW_A,0) + CASE p_Status WHEN 'A' THEN 1 * wk_menos
                                                                                  ELSE 0
                                                           END, 0 ),
                        TOTW_C = GREATEST( COALESCE(TOTW_C,0) + CASE p_Status WHEN 'C' THEN 1 * wk_menos
                                                                                  ELSE 0
                                                           END, 0 ),
                        TOTW_I = GREATEST( COALESCE(TOTW_I,0) + CASE p_Status WHEN 'I' THEN 1 * wk_menos
                                                                                  ELSE 0
                                                           END, 0 ),
                        TOTW_E = GREATEST( COALESCE(TOTW_E,0) + CASE p_Status WHEN 'E' THEN 1 * wk_menos
                                                                                  ELSE 0
                                                           END, 0 ),
                        TOTW_X = GREATEST( COALESCE(TOTW_X,0) + CASE p_Status WHEN 'X' THEN 1 * wk_menos
                                                                                  ELSE 0
                                                           END, 0 ),
                        TOTW_1 = GREATEST( COALESCE(TOTW_1,0) + CASE p_Status WHEN '1' THEN 1 * wk_menos
                                                                                  ELSE 0
                                                           END, 0 ),
                        TOTW_2 = GREATEST( COALESCE(TOTW_2,0) + CASE p_Status WHEN '2' THEN 1 * wk_menos
                                                                                  ELSE 0
                                                           END, 0 ),
                        TOTW_S = GREATEST( COALESCE(TOTW_S,0) + CASE p_Status WHEN 'S' THEN 1 * wk_menos
                                                                                  ELSE 0
                                                           END, 0 ),
                        HORREA = GREATEST( COALESCE(HORREA,0) + GREATEST(CASE p_Status WHEN 'C' THEN 0
                                                                                  WHEN 'S' THEN 0
                                                                                           ELSE p_Real
                                                                    END,0) * wk_menos, 0 ),
                        HORFAL = GREATEST( COALESCE(HORFAL,0) + GREATEST(HORAS_FALTANTES(P_STATUS,P_PREVISTO,P_REAL,p_Feito,vUSA_PERC_HORFAL),0) * wk_menos, 0 )
       WHERE CODFIL = p_Filial
         AND SEQUEN = p_Codigo;
    END IF;

    IF p_NovoAceite THEN
      UPDATE TT_PRJ SET TOTA_T = GREATEST( COALESCE(TOTA_T,0) +  CASE p_Aceite WHEN 'T' THEN 1 * wk_menos
                                                                                   ELSE 0
                                                            END, 0 ),
                        TOTA_F = GREATEST( COALESCE(TOTA_F,0) +  CASE p_Aceite WHEN 'F' THEN 1 * wk_menos
                                                                                   ELSE 0
                                                            END, 0 ),
                        TOTA_N = GREATEST( COALESCE(TOTA_N,0) +  CASE p_Aceite WHEN 'N' THEN 1 * wk_menos
                                                                                   ELSE 0
                                                            END, 0 )
       WHERE CODFIL = p_Filial
         AND SEQUEN = p_Codigo;
    END IF;

      SELECT FILPAI,SEQPAI INTO wk_filpai,wk_codpai FROM TT_PRJ WHERE  CODFIL = p_Filial AND SEQUEN = p_Codigo;

    IF (wk_filpai IS NOT NULL) AND (wk_codpai IS NOT NULL) THEN
       vDummy:=TotalizaNoProjeto(wk_filpai,
                                 wk_codpai,
                                 p_Status,
                                 p_Aceite,
                                 p_Real,
                                 p_Previsto,
                                 p_Feito,
                                 p_Menos,
                                 p_NovoStatus,
                                 p_NovoAceite);
    END IF;
    RETURN 'OK';
END;
$$ language 'plpgsql';







/*-- SEQ 1618 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_KIT () CASCADE;

/*-- SEQ 1619 --*/
CREATE OR REPLACE FUNCTION IMPORTA_KIT ()
RETURNS VARCHAR AS $$
DECLARE

-- Objetivo:
-- 1) Importao da tabela TT_KIT

-- TI_KIT
   nID_IKIT            TI_KIT.ID_IKIT%TYPE;
   dDATCRI_IKIT        TI_KIT.DATCRI%TYPE;
   dDATIMP_IKIT        TI_KIT.DATIMP%TYPE;
   cMOTREJ_IKIT        TI_KIT.MOTREJ%TYPE;
   cTIPOPE_IKIT        TI_KIT.TIPOPE%TYPE;
   cCODPRO_IKIT        TI_KIT.CODPRO%TYPE;
   cCODITE_IKIT        TI_KIT.CODITE%TYPE;
   nQTDITE_IKIT        TI_KIT.QTDITE%TYPE;
   cBRINDE_IKIT        TI_KIT.BRINDE%TYPE;
   cFLGIMP_IKIT        TI_KIT.FLGIMP%TYPE;
   nSTATUS_IKIT        TI_KIT.STATUS%TYPE;

-- TT_GRA
   cFILMAT_GRA        TT_GRA.FILMAT%TYPE;
   cCODMAT_GRA        TT_GRA.CODMAT%TYPE;
   nCODCOR_GRA        TT_GRA.CODCOR%TYPE;
   nCODTAM_GRA        TT_GRA.CODTAM%TYPE;
   cFILITE_GRA        TT_GRA.FILMAT%TYPE;
   cCODITE_GRA        TT_GRA.CODMAT%TYPE;
   nCORITE_GRA        TT_GRA.CODCOR%TYPE;
   nTAMITE_GRA        TT_GRA.CODTAM%TYPE;

-- TT_KIT
   cFILMAT_KIT        TT_KIT.FILMAT%TYPE;
   cSEQUEN_KIT        TT_KIT.SEQUEN%TYPE;

-- TT_IED
   nDIALIM_IED        TT_IED.DIALIM%TYPE;
   cIMPORT_IED        TT_IED.IMPORT%TYPE;
   cMANTEM_IED        TT_IED.MANTEM%TYPE;
   nCNTIMP_IED        TT_IED.CNTIMP%TYPE;

-- TT_CFG
   cMAI_FR                     TT_CFG.MAI_FR%TYPE;
   cMAI_TO                     TT_CFG.MAI_TO%TYPE;

-- Outras Variveis
   nQTDIMP                     Numeric;
   nNROERR                     Numeric;
   nCOUNT                      Numeric;
   nRESTO                      Numeric;

   
   cIMP_PRO                    VARCHAR(4000);
   
CR_KIT CURSOR(pDATCRI TI_KIT.DATCRI%TYPE) IS
/*Status => 0 no processado
         => 1 processado com sucesso
         => 2 processado com erro*/
  SELECT *
    FROM (SELECT ID_IKIT, DATCRI, DATIMP, STATUS, COALESCE(TIPOPE, 'T') AS TIPOPE, CODPRO,
                 CODITE, QTDITE, BRINDE, FLGIMP
            FROM TI_KIT
           WHERE STATUS = 0
             AND DATCRI BETWEEN TRUNC(pDATCRI)
             AND ADD_DAY(TRUNC(pDATCRI),1)
           ORDER BY DATCRI
         ) TAB
   LIMIT 1;

BEGIN

   -- RFMP 80113
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20020 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

   SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
     INTO cIMPORT_IED, cMANTEM_IED, nCNTIMP_IED, nDIALIM_IED
     FROM TT_IED
   WHERE TABELA = 'KIT';

   -- MN - Garante a importao dos produtos antes dos kits
      
   
   SELECT IMPORTA_PRO() INTO cIMP_PRO;
   

   IF cIMPORT_IED = 'T' THEN
      nCNTIMP_IED := nCNTIMP_IED + 1;
      nNROERR := 0;
      nQTDIMP := 0;


      LOOP
         cMOTREJ_IKIT := '';

         SELECT MIN(DATCRI)
           INTO dDATCRI_IKIT
           FROM TI_KIT
          WHERE STATUS = 0;

         OPEN CR_KIT(dDATCRI_IKIT);
         FETCH CR_KIT INTO nID_IKIT, dDATCRI_IKIT, dDATIMP_IKIT, nSTATUS_IKIT, cTIPOPE_IKIT, cCODPRO_IKIT,
                           cCODITE_IKIT, nQTDITE_IKIT, cBRINDE_IKIT, cFLGIMP_IKIT;

         -- MN - Se no achar registro finaliza importao
         IF NOT FOUND THEN
            CLOSE CR_KIT;
            EXIT;
         END IF;

         IF ISNULL(cCODPRO_IKIT) = 'T' THEN
            cMOTREJ_IKIT := cMOTREJ_IKIT || 'O campo "CODPRO"  de preenchimento obrigatrio, no pode ser nulo; ';
         END IF;

         IF ISNULL(cCODITE_IKIT) = 'T' THEN
            cMOTREJ_IKIT := cMOTREJ_IKIT || 'O campo "CODITE"  de preenchimento obrigatrio, no pode ser nulo; ';
         END IF;

         IF (cTIPOPE_IKIT <> 'E' ) THEN
            IF (COALESCE(nQTDITE_IKIT, 0) < 1) THEN
               cMOTREJ_IKIT := cMOTREJ_IKIT || 'O campo QTDITE  obrigatrio e deve ser preenchido, com valor igual ou superior a 1, quando a operao for diferente de Excluso; ';
            END IF;

            IF (cBRINDE_IKIT <> 'F') AND (cBRINDE_IKIT <> 'T')  THEN
               cMOTREJ_IKIT := cMOTREJ_IKIT || 'A coluna BRINDE deve ser preenchida com T ou F; ';
            END IF;

            IF (cFLGIMP_IKIT <> 'F') AND (cFLGIMP_IKIT <> 'T')  THEN
               cMOTREJ_IKIT := cMOTREJ_IKIT || 'A coluna FLGIMP deve ser preenchida com T ou F; ';
            END IF;
         END IF;

         -- MN - Obtm chave do Header
                     SELECT FILMAT, CODMAT, CODCOR, CODTAM
              INTO cFILMAT_GRA, cCODMAT_GRA, nCODCOR_GRA, nCODTAM_GRA
              FROM TT_GRA GRA 
             WHERE TRIM(GRA.CODEXT) = TRIM(cCODPRO_IKIT);
         
         IF (ISNULL(cFILMAT_GRA) = 'T') AND (ISNULL(cCODPRO_IKIT) = 'F')  THEN
            cMOTREJ_IKIT := cMOTREJ_IKIT || 'Produto no encontrado "' || COALESCE(cCODPRO_IKIT, '') || '" (CODPRO); ';
         END IF;

         -- MN - Obtm chave do Item do Kit
                     SELECT FILMAT, CODMAT, CODCOR, CODTAM
              INTO cFILITE_GRA, cCODITE_GRA, nCORITE_GRA, nTAMITE_GRA
              FROM TT_GRA GRA
             WHERE TRIM(GRA.CODEXT) = TRIM(cCODITE_IKIT);
         
         IF (ISNULL(cFILITE_GRA) = 'T') AND (ISNULL(cCODITE_IKIT) = 'F') THEN
            cMOTREJ_IKIT := cMOTREJ_IKIT ||'Produto no encontrado "' || COALESCE(cCODITE_IKIT, '') || '" (CODITE); ';
         END IF;

         IF cMOTREJ_IKIT = '' THEN
            -- MN - Verifica se o KIT j existe no banco
                           SELECT KIT.FILMAT, KIT.SEQUEN
                 INTO cFILMAT_KIT, cSEQUEN_KIT
                 FROM TT_KIT KIT INNER JOIN TT_GRA GRA ON GRA.FILMAT = KIT.FILMAT
                                                      AND GRA.CODMAT = KIT.CODMAT
                                                      AND GRA.CODCOR = KIT.CODCOR
                                                      AND GRA.CODTAM = KIT.CODTAM
                                 INNER JOIN TT_GRA GRAITE ON GRAITE.FILMAT = KIT.FILITE
                                                         AND GRAITE.CODMAT = KIT.CODITE
                                                         AND GRAITE.CODCOR = KIT.CORITE
                                                         AND GRAITE.CODTAM = KIT.TAMITE
                WHERE TRIM(GRA.CODEXT)    = TRIM(cCODPRO_IKIT)
                  AND TRIM(GRAITE.CODEXT) = TRIM(cCODITE_IKIT)
                                    
                     LIMIT 1;
                              
            -- MN - Se o KIT no existe no sistema, trata como incluso
            IF (ISNULL(cFILMAT_KIT) = 'T') THEN --registro novo
               IF (cTIPOPE_IKIT IN ('T', 'I')) THEN
                  BEGIN
                     INSERT INTO TT_KIT(FILMAT, CODMAT, CODCOR, CODTAM, FILITE, CODITE, CORITE, TAMITE, QTDITE, BRINDE, FLGIMP)
                                        VALUES
                                       (cFILMAT_GRA, cCODMAT_GRA, nCODCOR_GRA, nCODTAM_GRA, cFILITE_GRA, cCODITE_GRA, nCORITE_GRA, nTAMITE_GRA, nQTDITE_IKIT, COALESCE(cBRINDE_IKIT, 'F'), COALESCE(cFLGIMP_IKIT, 'F'));
                  EXCEPTION
                     
                     WHEN restrict_violation THEN IF cMOTREJ_IKIT = 'OK' THEN cMOTREJ_IKIT = SUBSTR('ERRO AO IMPORTAR KITs: '||SQLERRM,1,255); ELSE cMOTREJ_IKIT := cMOTREJ_IKIT; END IF;
                     WHEN not_null_violation THEN IF cMOTREJ_IKIT = 'OK' THEN cMOTREJ_IKIT = SUBSTR('ERRO AO IMPORTAR KITs: '||SQLERRM,1,255); ELSE cMOTREJ_IKIT := cMOTREJ_IKIT; END IF;
                     WHEN foreign_key_violation THEN IF cMOTREJ_IKIT = 'OK' THEN cMOTREJ_IKIT = SUBSTR('ERRO AO IMPORTAR KITs: '||SQLERRM,1,255); ELSE cMOTREJ_IKIT := cMOTREJ_IKIT; END IF;
                     WHEN unique_violation THEN IF cMOTREJ_IKIT = 'OK' THEN cMOTREJ_IKIT = SUBSTR('ERRO AO IMPORTAR KITs: '||SQLERRM,1,255); ELSE cMOTREJ_IKIT := cMOTREJ_IKIT; END IF;
                     WHEN check_violation THEN IF cMOTREJ_IKIT = 'OK' THEN cMOTREJ_IKIT = SUBSTR('ERRO AO IMPORTAR KITs: '||SQLERRM,1,255); ELSE cMOTREJ_IKIT := cMOTREJ_IKIT; END IF;
                     WHEN integrity_constraint_violation THEN IF cMOTREJ_IKIT = 'OK' THEN cMOTREJ_IKIT = SUBSTR('ERRO AO IMPORTAR KITs: '||SQLERRM,1,255); ELSE cMOTREJ_IKIT := cMOTREJ_IKIT; END IF;
                     WHEN plpgsql_error THEN IF cMOTREJ_IKIT = 'OK' THEN cMOTREJ_IKIT := SUBSTR('ERRO AO IMPORTAR KITs: '||SQLERRM,1,255); ELSE cMOTREJ_IKIT := cMOTREJ_IKIT; END IF;   
                                                            END;
               ELSE
                  cMOTREJ_IKIT := SUBSTR('Operao de alterao ou excluso no permitida. Registro CODPRO -> "'||COALESCE(cCODPRO_IKIT, '')|| '", no existe no sistema. Verifique o tipo de operao e informe uma das opes (I-Incluso, T-Todas).', 1, 255);
               END IF; -- Fim IF (cTIPOPE_IKIT IN ('T', 'I'))
            ELSE -- Entra no else se achou registro na TT_KIT, ento se trata de alterao do KIT
               -- MN - Registro existe na base, trata alterao ou excluso do KIT 
               IF (cTIPOPE_IKIT IN ('E', 'A', 'T')) THEN
                  IF cTIPOPE_IKIT IN ('A', 'T') THEN 
                     BEGIN
                        UPDATE TT_KIT SET QTDITE = COALESCE(nQTDITE_IKIT, QTDITE),
                                          BRINDE = COALESCE(cBRINDE_IKIT, BRINDE),
                                          FLGIMP = COALESCE(cFLGIMP_IKIT, FLGIMP)
                         WHERE FILMAT = cFILMAT_KIT
                           AND SEQUEN = cSEQUEN_KIT;
                     EXCEPTION
                     
                     WHEN restrict_violation THEN IF cMOTREJ_IKIT = 'OK' THEN cMOTREJ_IKIT = SUBSTR('ERRO AO IMPORTAR KITs: '||SQLERRM,1,255); ELSE cMOTREJ_IKIT := cMOTREJ_IKIT; END IF;
                     WHEN not_null_violation THEN IF cMOTREJ_IKIT = 'OK' THEN cMOTREJ_IKIT = SUBSTR('ERRO AO IMPORTAR KITs: '||SQLERRM,1,255); ELSE cMOTREJ_IKIT := cMOTREJ_IKIT; END IF;
                     WHEN foreign_key_violation THEN IF cMOTREJ_IKIT = 'OK' THEN cMOTREJ_IKIT = SUBSTR('ERRO AO IMPORTAR KITs: '||SQLERRM,1,255); ELSE cMOTREJ_IKIT := cMOTREJ_IKIT; END IF;
                     WHEN unique_violation THEN IF cMOTREJ_IKIT = 'OK' THEN cMOTREJ_IKIT = SUBSTR('ERRO AO IMPORTAR KITs: '||SQLERRM,1,255); ELSE cMOTREJ_IKIT := cMOTREJ_IKIT; END IF;
                     WHEN check_violation THEN IF cMOTREJ_IKIT = 'OK' THEN cMOTREJ_IKIT = SUBSTR('ERRO AO IMPORTAR KITs: '||SQLERRM,1,255); ELSE cMOTREJ_IKIT := cMOTREJ_IKIT; END IF;
                     WHEN integrity_constraint_violation THEN IF cMOTREJ_IKIT = 'OK' THEN cMOTREJ_IKIT = SUBSTR('ERRO AO IMPORTAR KITs: '||SQLERRM,1,255); ELSE cMOTREJ_IKIT := cMOTREJ_IKIT; END IF;
                     WHEN plpgsql_error THEN IF cMOTREJ_IKIT = 'OK' THEN cMOTREJ_IKIT := SUBSTR('ERRO AO IMPORTAR KITs: '||SQLERRM,1,255); ELSE cMOTREJ_IKIT := cMOTREJ_IKIT; END IF;
                                                               END;
                  ELSE -- MN - Operao de excluso do item do kit
                     BEGIN
                        DELETE FROM TT_KIT 
                         WHERE FILMAT = cFILMAT_KIT
                           AND SEQUEN = cSEQUEN_KIT;
                     EXCEPTION
                     
                     WHEN restrict_violation THEN IF cMOTREJ_IKIT = 'OK' THEN cMOTREJ_IKIT = SUBSTR('ERRO AO IMPORTAR KITs: '||SQLERRM,1,255); ELSE cMOTREJ_IKIT := cMOTREJ_IKIT; END IF;
                     WHEN not_null_violation THEN IF cMOTREJ_IKIT = 'OK' THEN cMOTREJ_IKIT = SUBSTR('ERRO AO IMPORTAR KITs: '||SQLERRM,1,255); ELSE cMOTREJ_IKIT := cMOTREJ_IKIT; END IF;
                     WHEN foreign_key_violation THEN IF cMOTREJ_IKIT = 'OK' THEN cMOTREJ_IKIT = SUBSTR('ERRO AO IMPORTAR KITs: '||SQLERRM,1,255); ELSE cMOTREJ_IKIT := cMOTREJ_IKIT; END IF;
                     WHEN unique_violation THEN IF cMOTREJ_IKIT = 'OK' THEN cMOTREJ_IKIT = SUBSTR('ERRO AO IMPORTAR KITs: '||SQLERRM,1,255); ELSE cMOTREJ_IKIT := cMOTREJ_IKIT; END IF;
                     WHEN check_violation THEN IF cMOTREJ_IKIT = 'OK' THEN cMOTREJ_IKIT = SUBSTR('ERRO AO IMPORTAR KITs: '||SQLERRM,1,255); ELSE cMOTREJ_IKIT := cMOTREJ_IKIT; END IF;
                     WHEN integrity_constraint_violation THEN IF cMOTREJ_IKIT = 'OK' THEN cMOTREJ_IKIT = SUBSTR('ERRO AO IMPORTAR KITs: '||SQLERRM,1,255); ELSE cMOTREJ_IKIT := cMOTREJ_IKIT; END IF;
                     WHEN plpgsql_error THEN IF cMOTREJ_IKIT = 'OK' THEN cMOTREJ_IKIT := SUBSTR('ERRO AO IMPORTAR KITs: '||SQLERRM,1,255); ELSE cMOTREJ_IKIT := cMOTREJ_IKIT; END IF;
                                                               END;
                  END IF;
               ELSE
                  cMOTREJ_IKIT := SUBSTR('Operao de incluso no permitida. Registro "'||COALESCE(cCODPRO_IKIT, '')|| '", j existe no sistema. Verifique o tipo de operao e informe uma das opes (A-Alterao, E-Excluso, T-Todas).', 1, 255);
               END IF; -- Fim IF (cTIPOPE_IKIT IN ('E', 'A', 'T'))
            END IF; -- Final (COALESCE(cFILMAT_KIT, '') = '')
         END IF; -- Final if cMOTREJ_IKIT = 'OK'


         IF ISNULL(cMOTREJ_IKIT) = 'T' THEN
            cMOTREJ_IKIT := 'OK';
         END IF;
        
         -- MN - Define o status do KIT
         IF NOT cMOTREJ_IKIT = 'OK' THEN
            nSTATUS_IKIT := 4;
            nNROERR := nNROERR + 1;
         ELSE
            nSTATUS_IKIT := 3;
         END IF;

         UPDATE TI_KIT SET STATUS = nSTATUS_IKIT, DATIMP = AGORA(), MOTREJ = SUBSTR(cMOTREJ_IKIT, 1, 255)
          WHERE ID_IKIT = nID_IKIT
            AND DATIMP IS NULL;

         
         nQTDIMP := nQTDIMP + 1;

         CLOSE CR_KIT;
      END LOOP;

      -- MN - Se houver erro na importao de KITs, notifica por e-mail
      IF nNROERR <> 0 THEN
         SELECT MAI_FR, MAI_TO INTO cMAI_FR, cMAI_TO
           FROM TT_CFG;
         IF (ISNOTNULL(cMAI_FR)='T') AND (ISNOTNULL(cMAI_TO)='T') AND (INSTR(cMAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(cMAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
            INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO,
                                TEXTOS,TIPMSG)
                        VALUES ('001', 'F', AGORA(), 'IMPORTAO KITs', cMAI_FR, cMAI_TO,
                                'Problema na importao de '||TO_CHAR(nNROERR)||' KITs. Verifique!', 'T');
         END IF;
      END IF;

      -- MN - Altera o status temporrio da importao, para o status definitivo
      UPDATE TI_KIT SET STATUS = CASE WHEN STATUS = 3
                                      THEN 1
                                      ELSE 2
                                  END
       WHERE STATUS IN (3, 4);

      -- MN - Controle para manter ou no os registros na TI_KIT aps importao
      IF cMANTEM_IED = 'F' THEN
         IF nDIALIM_IED > 0 THEN
            DELETE FROM TI_KIT
             WHERE DATIMP <= ADD_DAY(AGORA(), nDIALIM_IED * -1)
                AND STATUS = 1;
         ELSE
            DELETE FROM TI_KIT
             WHERE STATUS = 1;
         END IF;
      END IF;

      UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = nQTDIMP, CNTIMP = nCNTIMP_IED, TOTIMP = COALESCE(TOTIMP,0) + nQTDIMP WHERE TABELA = 'KIT';
         ELSE
      RAISE EXCEPTION 'PG-20001 Importao de KITs no permitida! Verifique a tabela de controle de importao (TT_IED)!';
   END IF;

   -- Se sobrou algum registro para ser processado, deve retornar isso na funcao.
   
   SELECT COUNT(*) INTO nRESTO FROM TI_KIT WHERE STATUS = 0;

   IF nRESTO > 0 THEN
      RETURN 'Existem '||TO_CHAR(nRESTO)||' KITs no Importados.';
   ELSE
      RETURN 'OK';
   END IF;
   
END;
$$ language 'plpgsql';




/*-- SEQ 1620 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION EXPORTA_CCC () CASCADE;

/*-- SEQ 1621 --*/
CREATE OR REPLACE FUNCTION EXPORTA_CCC ()
RETURNS VARCHAR AS $$
DECLARE

-- Objetivo:
-- 1) Exportao de cheques 
  WK_QTDEXP                      Numeric;
  WK_EXPORT                      TT_IED.EXPORT%TYPE;
  WK_MANTEM                      TT_IED.MANTEM%TYPE;
  WK_CNTEXP                      TT_IED.CNTEXP%TYPE;
  WK_MAI_FR                      TT_CFG.MAI_FR%TYPE;
  WK_MAI_TO                      TT_CFG.MAI_TO%TYPE;
  WK_MOTREJ                      TI_CLI.MOTREJ%TYPE;
  wk_SAC_E_MAIL                  TT_CFG.SAC_E_MAIL%TYPE;
  wk_EXP_REC_DATA_VENDA          TT_CFG.EXP_REC_DATA_VENDA%TYPE;
  wk_AGRUPA_LCTOS_TE_CCC         TT_CFG.AGRUPA_LCTOS_TE_CCC%TYPE;
  WK_DATVEN                      TT_REC.DATVEN%TYPE;
  AUX                            VARCHAR(3);
  WK_DIALIM                      TT_IED.DIALIM%TYPE;

BEGIN

   SELECT COALESCE(EXPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTEXP,0), COALESCE(DIALIM,0)
     INTO WK_EXPORT, WK_MANTEM, WK_CNTEXP, WK_DIALIM
     FROM TT_IED
    WHERE TABELA = 'CCC';

   IF WK_EXPORT = 'T' THEN

   WK_CNTEXP := WK_CNTEXP + 1;
   WK_QTDEXP := 0;
   WK_MOTREJ := '';

   SELECT EXP_REC_DATA_VENDA, AGRUPA_LCTOS_TE_CCC INTO wk_EXP_REC_DATA_VENDA, wk_AGRUPA_LCTOS_TE_CCC FROM TT_CFG;

   IF wk_EXP_REC_DATA_VENDA = 'T' THEN
      WK_DATVEN := TRUNC(AGORA());
   ELSE
      WK_DATVEN := TO_DATE('31/12/2500','DD/MM/YYYY');
   END IF;

           LOCK TABLE TT_CCC IN EXCLUSIVE MODE;

           AUX := GERACCCARTAOPROPRIO;

           IF COALESCE(wk_AGRUPA_LCTOS_TE_CCC,'F') = 'F' THEN

               INSERT INTO TE_CCC (EXTCLI, CODFIL, COMPLE, DATOPE, NUMDOC, NUMECF, NUMPAR, SUBPAR, TIPCCC, VLRLAN, DATHOR, MAXPAR, DATEXP, FILPGT, CODPGT)
                                  (SELECT CASE WHEN (CLI.GLOBAL = 'G') AND (CLI.CODVIN IS NOT NULL)
                                               THEN VIN.CODEXT
                                               ELSE CLI.CODEXT
                                           END AS CODCLI,
                                          CCC.CODFIL,
                                          CCC.COMPLE,
                                          CCC.DATOPE,
                                          CCC.NUMDOC,
                                          VEN.NUMECF,
                                          CCC.NUMPAR,
                                          CCC.SUBPAR,
                                          CCC.TIPCCC,
                                          CCC.VLRLAN * -1,
                                          VEN.DATHOR,
                                          (SELECT LPAD(TO_CHAR(MAX(TO_NUMBER(TRIM(NUMPAR)))),2,' ')
                                             FROM TT_REC
                                            WHERE CODFIL = VEN.CODFIL
                                              AND SEQUEN = VEN.SEQUEN) AS MAXPAR,
                                          AGORA(),
                                          VEN.FILPGT,
                                          VEN.CODPGT
                                     FROM TT_CCC CCC INNER JOIN TT_CLI CLI ON CLI.FILCLI = CCC.FILCLI AND CLI.CODCLI = CCC.CODCLI
                                                LEFT OUTER JOIN TT_VEN VEN ON VEN.CODFIL = CCC.CODVEN AND VEN.SEQUEN = CCC.SEQVEN
                                                LEFT OUTER JOIN TT_CLI VIN ON VIN.FILCLI = CLI.FILVIN AND VIN.CODCLI = CLI.CODVIN
                                    WHERE CCC.EXPORT = 'F'
                                      AND (COALESCE(VIN.CODEXT,CLI.CODEXT), CCC.CODFIL, CCC.NUMDOC, CCC.NUMPAR) NOT IN (SELECT EXTCLI, CODFIL, NUMDOC, NUMPAR FROM TE_CCC));

                          UPDATE TT_CCC SET EXPORT = 'I'
                           WHERE (CODFIL, SEQUEN) IN (SELECT CCC.CODFIL, CCC.SEQUEN
                                                        FROM TT_CCC CCC INNER JOIN TT_CLI CLI ON CLI.FILCLI = CCC.FILCLI AND CLI.CODCLI = CCC.CODCLI
                                                                   LEFT OUTER JOIN TT_VEN VEN ON VEN.CODFIL = CCC.CODVEN AND VEN.SEQUEN = CCC.SEQVEN
                                                                   LEFT OUTER JOIN TT_CLI VIN ON VIN.FILCLI = CLI.FILVIN AND VIN.CODCLI = CLI.CODVIN
                                                       WHERE CCC.EXPORT = 'F'
                                                         AND (COALESCE(VIN.CODEXT,CLI.CODEXT), CCC.CODFIL, CCC.NUMDOC, CCC.NUMPAR) NOT IN (SELECT EXTCLI, CODFIL, NUMDOC, NUMPAR FROM TE_CCC));
           ELSE
               INSERT INTO TE_CCC (EXTCLI, CODFIL, COMPLE, DATOPE, NUMDOC, NUMECF, NUMPAR, SUBPAR, TIPCCC, VLRLAN, DATHOR, MAXPAR, DATEXP, FILPGT, CODPGT)
                                  (SELECT CASE WHEN (CLI.GLOBAL = 'G') AND (CLI.CODVIN IS NOT NULL)
                                               THEN VIN.CODEXT
                                               ELSE CLI.CODEXT
                                           END AS CODCLI,
                                          CCC.CODFIL,
                                          CCC.COMPLE,
                                          TRUNC(CCC.DATOPE),
                                          CCC.NUMDOC,
                                          VEN.NUMECF,
                                          'XX' AS NUMPAR,
                                          ' 0' AS SUBPAR,
                                          CCC.TIPCCC,
                                          SUM(CCC.VLRLAN * -1),
                                          VEN.DATHOR,
                                          (SELECT LPAD(TO_CHAR(MAX(TO_NUMBER(TRIM(NUMPAR)))),2,' ')
                                             FROM TT_REC
                                            WHERE CODFIL = VEN.CODFIL
                                              AND SEQUEN = VEN.SEQUEN) AS MAXPAR,
                                          AGORA(),
                                          VEN.FILPGT,
                                          VEN.CODPGT
                                     FROM TT_CCC CCC INNER JOIN TT_CLI CLI ON CLI.FILCLI = CCC.FILCLI AND CLI.CODCLI = CCC.CODCLI
                                                LEFT OUTER JOIN TT_VEN VEN ON VEN.CODFIL = CCC.CODVEN AND VEN.SEQUEN = CCC.SEQVEN
                                                LEFT OUTER JOIN TT_CLI VIN ON VIN.FILCLI = CLI.FILVIN AND VIN.CODCLI = CLI.CODVIN
                                    WHERE CCC.EXPORT = 'F'
                                      AND (COALESCE(VIN.CODEXT,CLI.CODEXT), CCC.CODFIL, CCC.NUMDOC, CCC.NUMPAR) NOT IN (SELECT EXTCLI, CODFIL, NUMDOC, NUMPAR FROM TE_CCC)
                                      AND TRUNC(VEN.DATHOR) < TRUNC(AGORA())
                                      AND DIAFECHADO(VEN.CODFIL,VEN.NUMECF,TRUNC(VEN.DATHOR)) IN ('S','F')
                                    GROUP BY CLI.GLOBAL, CLI.CODVIN, CLI.CODEXT, VIN.CODEXT, CCC.CODFIL, CCC.COMPLE, TRUNC(CCC.DATOPE), CCC.NUMDOC,
                                             VEN.NUMECF, CCC.TIPCCC, VEN.DATHOR, VEN.CODFIL, VEN.SEQUEN, VEN.FILPGT, VEN.CODPGT);

                          UPDATE TT_CCC SET EXPORT = 'I'
                           WHERE (CODFIL, SEQUEN) IN (SELECT CCC.CODFIL, CCC.SEQUEN
                                                        FROM TT_CCC CCC INNER JOIN TT_CLI CLI ON CLI.FILCLI = CCC.FILCLI AND CLI.CODCLI = CCC.CODCLI
                                                                        INNER JOIN TT_VEN VEN ON VEN.CODFIL = CCC.CODVEN AND VEN.SEQUEN = CCC.SEQVEN
                                                                        INNER JOIN TR_ECF ECF ON ECF.CODFIL = VEN.CODFIL AND ECF.NUMECF = VEN.NUMECF AND ECF.DATOPE = TRUNC(VEN.DATHOR)
                                                                   LEFT OUTER JOIN TT_CLI VIN ON VIN.FILCLI = CLI.FILVIN AND VIN.CODCLI = CLI.CODVIN
                                                       WHERE CCC.EXPORT = 'F'
                                                         AND (COALESCE(VIN.CODEXT,CLI.CODEXT), CCC.CODFIL, CCC.NUMDOC, CCC.NUMPAR) NOT IN (SELECT EXTCLI, CODFIL, NUMDOC, NUMPAR FROM TE_CCC)
                                                         AND TRUNC(VEN.DATHOR) < TRUNC(AGORA())
                                                         AND ECF.DIAFEC IN ('S','F'));  -- 82203
                                                         --AND DIAFECHADO(VEN.CODFIL,VEN.NUMECF,TRUNC(VEN.DATHOR)) IN ('S','F'));



           END IF;


           SELECT COUNT(*)
             INTO WK_QTDEXP
             FROM TT_CLI CLI INNER JOIN TT_CCC CCC ON CCC.FILCLI = CLI.FILCLI AND CCC.CODCLI = CLI.CODCLI
                        LEFT OUTER JOIN TT_VEN VEN ON VEN.SEQUEN = CCC.SEQVEN
            WHERE CCC.EXPORT = 'I'
              AND (CLI.CODEXT, CCC.CODFIL, CCC.NUMDOC, CCC.NUMPAR) NOT IN (SELECT EXTCLI, CODFIL, NUMDOC, NUMPAR FROM TE_CCC);


            INSERT INTO TT_CCC (CODFIL, CODUSU, FILCLI, FILUSU, CODCLI, NUMDOC, DATOPE, TIPCCC, VLRLAN, NUMPAR, SUBPAR,
                                CODVEN, FILFAT, PLACAS, SEQFAT, SEQVEN, COMPLE, STATUS, NUMECF, FILMAT, CODMAT, CODCOR,
                                CODTAM, QTDLAN, EXPORT, PORORI, TIPLAN)
                               (SELECT /*+INDEX(CCC,I_LC_CCC_STATUS)+INDEX(REC,PK_REC)*/
                                       CCC.CODFIL,
                                       '  1',
                                       CCC.FILCLI,
                                       '001',
                                       CCC.CODCLI,
                                       CCC.NUMDOC,
                                       CCC.DATOPE,
                                       CCC.TIPCCC,
                                       CCC.VLRLAN * -1,
                                       CCC.NUMPAR,
                                       CCC.SUBPAR,
                                       CCC.CODVEN,
                                       CCC.FILFAT,
                                       CCC.PLACAS,
                                       CCC.SEQFAT,
                                       CCC.SEQVEN,
                                       CCC.COMPLE,
                                       'P',
                                       CCC.NUMECF,
                                       CCC.FILMAT,
                                       CCC.CODMAT,
                                       CCC.CODCOR,
                                       CCC.CODTAM,
                                       CCC.QTDLAN,
                                       'T',
                                       CCC.PORORI,
                                       'X'
                                 FROM TT_CCC CCC INNER JOIN TT_REC REC ON CCC.CODFIL = REC.FILCCC 
                                                                      AND CCC.SEQUEN = REC.SEQCCC
                                                                     AND REC.DATVEN <= WK_DATVEN
                               WHERE CCC.STATUS = 'A'
                                 AND (CCC.CODVEN, CCC.SEQVEN, CCC.NUMPAR, CCC.SUBPAR) NOT IN (SELECT CODVEN, SEQVEN, NUMPAR, SUBPAR
                                                                                                FROM TT_CCC
                                                                                               WHERE STATUS = 'P'
                                                                                                 AND CODVEN = CCC.CODVEN
                                                                                                 AND SEQVEN = CCC.SEQVEN
                                                                                                 AND NUMPAR = CCC.NUMPAR
                                                                                                 AND SUBPAR = CCC.SUBPAR)
                              );

            UPDATE TT_CCC SET STATUS = 'P'
             WHERE (CODFIL, SEQUEN) IN (SELECT CCC.CODFIL, CCC.SEQUEN
                                          FROM TT_CCC CCC INNER JOIN TT_REC REC ON CCC.CODFIL = REC.FILCCC 
                                                                               AND CCC.SEQUEN = REC.SEQCCC
                                                                               AND REC.DATVEN <= WK_DATVEN
                                         WHERE CCC.STATUS = 'A');

            UPDATE TT_CCC SET EXPORT = 'T'
             WHERE EXPORT = 'I';



   IF WK_MOTREJ <> '' THEN
      SELECT MAI_FR, MAI_TO, SAC_E_MAIL
        INTO WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL
        FROM TT_CFG;
      IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
         INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO, MAI_CC,
                             TEXTOS,TIPMSG)
                     VALUES ('001','F',AGORA(),'ERRO NA EXPORTAO DE CONTA-CORRENTE',WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL,
                             'Problema na exportao de conta-corrente. Verifique!','T');
      END IF;
    END IF;

   IF WK_MANTEM = 'F' THEN
        IF WK_DIALIM > 0 THEN
           DELETE FROM TE_CCC
            WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1);
        ELSE
           DELETE FROM TE_CCC;
        END IF;
   END IF;


   UPDATE TT_IED SET ULTEXP = AGORA(), QTDEXP = WK_QTDEXP, CNTEXP = WK_CNTEXP, TOTEXP = COALESCE(TOTEXP,0) + WK_QTDEXP
    WHERE TABELA = 'CCC';
   ELSE RAISE NOTICE 'EXPORTAO CONTA-CORRENTE NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1622 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_CAM () CASCADE;

/*-- SEQ 1623 --*/
CREATE OR REPLACE FUNCTION IMPORTA_CAM ()
RETURNS VARCHAR AS $$
DECLARE

-- Objetivo:
-- 1) Importao das tabelas referentes a cambio (TD_MOE e TT_CAM)
WK_DESMOE TI_CAM.DESMOE%TYPE;
WK_DATREF TI_CAM.DATREF%TYPE;
WK_VLRREF TI_CAM.VLRREF%TYPE;
WK_STATUS TI_CAM.STATUS%TYPE;
WK_MOTREJ TI_CAM.MOTREJ%TYPE;
WK_DATIMP TI_CAM.DATIMP%TYPE;
WK_DIALIM     TT_IED.DIALIM%TYPE;
WK_COD_CODMOE TD_MOE.CODTAB%TYPE;
WK_QTDIMP Numeric;
WK_IMPORT TT_IED.IMPORT%TYPE;
WK_MANTEM TT_IED.MANTEM%TYPE;
WK_CNTIMP TT_IED.CNTIMP%TYPE;
WK_NROERR Numeric;
WK_MAI_FR     TT_CFG.MAI_FR%TYPE;
WK_MAI_TO     TT_CFG.MAI_TO%TYPE;
WK_SAC_E_MAIL TT_CFG.SAC_E_MAIL%TYPE;
WK_DATCRI     TI_CAM.DATCRI%TYPE;

CR_CAMBIO CURSOR(pDATCRI TI_CAM.DATCRI%TYPE) IS
  SELECT *
    FROM (SELECT /*+INDEX(TI_CAM, I_LC_ICA_STATUS)*/
                 DESMOE, DATREF, VLRREF, STATUS
            FROM TI_CAM
           WHERE STATUS = 0
             AND DATCRI BETWEEN TRUNC(pDATCRI)
                            AND ADD_DAY(TRUNC(pDATCRI),1)
           ORDER BY DATCRI
         ) TAB
   LIMIT 1;
BEGIN
   -- RFMP 80113
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20019 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

   SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
     INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
     FROM TT_IED
    WHERE TABELA = 'CAM';

   IF WK_IMPORT = 'T' THEN
   WK_CNTIMP := WK_CNTIMP + 1;
   WK_QTDIMP := 0;
   LOOP
     SELECT MIN(DATCRI)
       INTO WK_DATCRI
       FROM TI_CAM
      WHERE STATUS = 0;

     OPEN CR_CAMBIO(WK_DATCRI);
     FETCH CR_CAMBIO INTO WK_DESMOE, WK_DATREF, WK_VLRREF, WK_STATUS;

     IF NOT FOUND THEN
        CLOSE CR_CAMBIO;
        EXIT;
     END IF;

     WK_MOTREJ     := 'OK';

     IF WK_DESMOE IS NOT NULL THEN
	WK_COD_CODMOE := IMPORTA_TDS( 'TD_MOE', 'MOEATI', 'DESMOE', 'CODTAB', WK_DESMOE, NULL, NULL, NULL );
     END IF;

     BEGIN
        INSERT INTO TT_CAM (CODMOE,DATREF,VLRREF) VALUES (WK_COD_CODMOE, WK_DATREF, WK_VLRREF);
     EXCEPTION
	
	WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR CAMBIO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR CAMBIO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR CAMBIO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR CAMBIO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
        WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR CAMBIO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR CAMBIO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
        WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR CAMBIO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                     END;

     IF NOT WK_MOTREJ = 'OK' THEN
       WK_STATUS := 4;
       WK_NROERR := WK_NROERR + 1;
     ELSE
        WK_STATUS := 3;
     END IF;

     UPDATE TI_CAM SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
      WHERE DESMOE = WK_DESMOE
        AND DATREF = WK_DATREF
        AND VLRREF = WK_VLRREF
        AND DATIMP IS NULL;
     WK_QTDIMP := WK_QTDIMP + 1;
     CLOSE CR_CAMBIO;
   END LOOP;
   IF WK_NROERR <> 0 THEN
      SELECT MAI_FR, MAI_TO, SAC_E_MAIL
        INTO WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL
        FROM TT_CFG;
      IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
         INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO, MAI_CC,
                             TEXTOS,TIPMSG)
                     VALUES ('001','F',AGORA(),'IMPORTAO DE CAMBIOS',WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL,
                             'Problema na importao de '||wk_nroerr||' cambios. Verifique!','T');
      END IF;
    END IF;


   UPDATE TI_CAM SET STATUS = CASE WHEN STATUS = 3
                                   THEN 1
                                   ELSE 2
                               END
    WHERE STATUS IN (3,4);
   IF WK_MANTEM = 'F' THEN
      IF WK_DIALIM > 0 THEN
         DELETE FROM TI_CAM
          WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
		    AND STATUS = 1;
      ELSE
         DELETE FROM TI_CAM
		  WHERE STATUS = 1;
      END IF;
   END IF;
   UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = WK_QTDIMP, CNTIMP = WK_CNTIMP, TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP WHERE TABELA = 'CAM';
   ELSE RAISE EXCEPTION 'PG-20001 IMPORTAO DE CAMBIOS NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;

  RETURN NULL;

END;
$$ language 'plpgsql';





/*-- SEQ 1624 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_CCC () CASCADE;

/*-- SEQ 1625 --*/
CREATE OR REPLACE FUNCTION IMPORTA_CCC ()
RETURNS VARCHAR AS $$
DECLARE


-- Objetivo:
-- 1) Importao das tabelas referentes a lanamentos de conta corrente (TD_CCC e TT_CC)

-- Declarao de variveis e cursores
   cIMPORT                       TT_IED.IMPORT%TYPE;
   cMANTEM                       TT_IED.MANTEM%TYPE;
   nCNTIMP                       TT_IED.CNTIMP%TYPE;
   nDIALIM                       TT_IED.DIALIM%TYPE;
   
   cMAI_FR                       TT_CFG.MAI_FR%TYPE;
   cMAI_TO                       TT_CFG.MAI_TO%TYPE;
   cSAC_E_MAIL                   TT_CFG.SAC_E_MAIL%TYPE;

      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
   nRESTO                        Numeric;
   nNUMREG                       Numeric = 500;
      nQTDIMP                       Numeric;
   nNROERR                       Numeric;

   cFILIAL                       TD_FIL.CODFIL%TYPE;
   nTIPCCC                       TD_CCC.CODTAB%TYPE;
   cDESCCC_DCCC                  TD_CCC.DESCCC%TYPE;
   nPORORI                       TD_COB.CODTAB%TYPE;
   cFILUSU                       TT_USU.FILUSU%TYPE;
   cCODUSU                       TT_USU.CODUSU%TYPE;
   cFILCLI                       TT_CLI.FILCLI%TYPE;
   cCODCLI                       TT_CLI.CODCLI%TYPE;

   nID_ICCC                      TI_CCC.ID_ICCC%TYPE;
   dDATCRI                       TI_CCC.DATCRI%TYPE;
   dMINDATCRI                    TI_CCC.DATCRI%TYPE;
   nSTATUS                       TI_CCC.STATUS%TYPE;
   cMOTREJ                       TI_CCC.MOTREJ%TYPE;
   dDATIMP                       TI_CCC.DATIMP%TYPE;
   cCODFIL                       TI_CCC.CODFIL%TYPE;
   cCODEXT_CLI                   TI_CCC.CODCLI%TYPE;
   cNUMDOC                       TI_CCC.NUMDOC%TYPE;
   dDATOPE                       TI_CCC.DATOPE%TYPE;
   cCODCCC                       TI_CCC.CODCCC%TYPE;
   cDESCCC                       TI_CCC.DESCCC%TYPE;
   nVLRLAN                       TI_CCC.VLRLAN%TYPE;
   cCOMPLE                       TI_CCC.COMPLE%TYPE;
   cCODCOB                       TI_CCC.CODCOB%TYPE;
   cTIPLAN                       TI_CCC.TIPLAN%TYPE;
   cATULIM                       TI_CCC.ATULIM%TYPE;

   CR_CCC CURSOR(pDATCRI TI_CCC.DATCRI%TYPE) IS
     SELECT *
       FROM (SELECT /*+INDEX(ICCC, I_LC_ICCC_STATUS)*/
                    CLI.FILCLI AS CLI_FILCLI, CLI.CODCLI AS CLI_CODCLI,
                    DCCC.CODTAB AS DCCC_CODTAB, DCCC.DESCCC AS DCCC_DESCCC,
                    DCOB.CODTAB AS DCOB_CODTAB,
                    DFIL.CODFIL AS DFIL_CODFIL,
                    ICCC.ID_ICCC, ICCC.DATCRI, ICCC.CODFIL AS ICCC_CODFIL, ICCC.CODCLI AS ICCC_CODCLI,
                    ICCC.DATOPE AS ICCC_DATOPE, COALESCE(ICCC.VLRLAN, 0) AS ICCC_VLRLAN, ICCC.NUMDOC AS ICCC_NUMDOC, ICCC.COMPLE AS ICCC_COMPLE,
                    COALESCE(ICCC.TIPLAN, '0') AS ICCC_TIPLAN, COALESCE(ICCC.ATULIM, 'T') AS ICCC_ATULIM, ICCC.CODCCC AS ICCC_CODCCC, ICCC.DESCCC AS ICCC_DESCCC,
                    ICCC.CODCOB AS ICCC_CODCOB,
                    ICCC.STATUS, ICCC.MOTREJ, ICCC.DATIMP
               FROM TI_CCC ICCC 
               LEFT JOIN TD_FIL DFIL ON DFIL.CODFIL = ICCC.CODFIL
               LEFT JOIN TT_CLI CLI ON CLI.CODEXT = ICCC.CODCLI
               LEFT JOIN TD_CCC DCCC ON DCCC.CODEXT_DCCC = ICCC.CODCCC
               LEFT JOIN TD_COB DCOB ON DCOB.CODEXT_DCOB = ICCC.CODCOB
              WHERE ICCC.STATUS = 0
                AND ICCC.DATCRI BETWEEN TRUNC(pDATCRI) AND ADD_DAY(TRUNC(pDATCRI),1)
              ORDER BY ICCC.DATCRI
            ) TAB
            
      LIMIT 1;
      
-- Incio da procedure
BEGIN

   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20019 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

      SELECT COALESCE(IMPORT ,'T'), COALESCE(MANTEM, 'T'), COALESCE(CNTIMP, 0), COALESCE(DIALIM, 0)
     INTO cIMPORT, cMANTEM, nCNTIMP, nDIALIM
     FROM TT_IED
    WHERE TABELA = 'CCC';
   
   IF cIMPORT = 'T' THEN

      nCNTIMP := nCNTIMP + 1;
      nQTDIMP := 0;
      nNROERR := 0;
      LOOP
         -- Caso tenha atingindo o nmero de importaes por lote fecha processamento
         
         IF nNUMREG = 0 THEN
            EXIT;
         END IF;
                  
         -- Busca a data do primeiro lanamento a ser processado
         SELECT MIN(DATCRI)
           INTO dMINDATCRI
           FROM TI_CCC
          WHERE STATUS = 0;

         -- Abre Tabela para processamento
         OPEN CR_CCC(dMINDATCRI);
         FETCH CR_CCC INTO cFILCLI, cCODCLI, nTIPCCC, cDESCCC_DCCC, nPORORI, cFILIAL, nID_ICCC, dDATCRI, cCODFIL, cCODEXT_CLI, dDATOPE, nVLRLAN, cNUMDOC, cCOMPLE, cTIPLAN, cATULIM, cCODCCC, cDESCCC, cCODCOB, nSTATUS, cMOTREJ, dDATIMP;

         -- Caso no exista registro finaliza o processo
         IF NOT FOUND THEN
            CLOSE CR_CCC;
            EXIT;
         END IF;

         cMOTREJ := 'OK';

         -- Realiza Pr-Validaes
         IF cMOTREJ = 'OK' THEN
            IF (ISNULL(cFILIAL)='T') THEN
               cMOTREJ := 'ERRO AO VERIFICAR LANAMENTOS DE CONTA-CORRENTE: "CDIGO DA FILIAL" NO INFORMADO OU NO LOCALIZADO.';
            END IF;
         END IF;

         IF cMOTREJ = 'OK' THEN
            IF (ISNULL(cCODCCC)='T') THEN
               cMOTREJ := 'ERRO AO VERIFICAR LANAMENTOS DE CONTA-CORRENTE: "CDIGO DA CONTA-CORRENTE" NO INFORMADO.';
            END IF;
         END IF;

         -- Valida Conta Corrente a ser realizada o Lanamento
         IF cMOTREJ = 'OK' THEN
            IF nTIPCCC IS NULL AND (ISNULL(cDESCCC)='T') THEN
               cMOTREJ := 'ERRO AO VERIFICAR LANAMENTOS DE CONTA-CORRENTE: CONTA-CORRENTE NO LOCALIZADO PARA O CDIGO: ' || cCODCCC || ' E DESCRIO NO INFORMADA.';
            END IF;
         END IF;

         IF cMOTREJ = 'OK' THEN
            IF (ISNOTNULL(cDESCCC)='T') AND (nTIPCCC IS NULL OR (cDESCCC_DCCC <> cDESCCC)) THEN
               nTIPCCC := IMPORTA_TDS( 'TD_CCC', 'CCCATI', 'DESCCC', 'CODTAB', cDESCCC, NULL, NULL, cFILIAL, NULL, NULL, cCODCCC);
            END IF;
         END IF;

         IF cMOTREJ = 'OK' THEN
            IF (cATULIM NOT IN ('F','T')) THEN
               cMOTREJ := 'ERRO AO VERIFICAR LANAMENTOS DE CONTA-CORRENTE: "ATUALIZA LIMITE DE SALDO?" INVLIDO.';
            END IF;
         END IF;

         IF cMOTREJ = 'OK' THEN
            IF (ISNULL(cNUMDOC)='T') THEN
               cMOTREJ := 'ERRO AO VERIFICAR LANAMENTOS DE CONTA-CORRENTE: "NUMERO DOCUMENTO" NO INFORMADO.';
            END IF;
         END IF;

         IF cMOTREJ = 'OK' THEN
            IF (cTIPLAN  NOT IN ('0'))THEN
               cMOTREJ := 'ERRO AO VERIFICAR LANAMENTOS DE CONTA-CORRENTE: "TIPO DE LANAMENTO" INVLIDO.';
            END IF;
         END IF;
         
         IF cMOTREJ = 'OK' THEN
            IF (nVLRLAN = 0) THEN
               cMOTREJ := 'ERRO AO VERIFICAR LANAMENTOS DE CONTA-CORRENTE:"VALOR LANAMENTO" INVLIDO.';
            END IF;
         END IF;

         IF cMOTREJ = 'OK' THEN
            IF dDATOPE IS NULL THEN
               cMOTREJ := 'ERRO AO VERIFICAR LANAMENTOS DE CONTA-CORRENTE: "DATA DA OPERAO" NO INFORMADA.';
            END IF;
         END IF;

         IF cMOTREJ = 'OK' THEN
            IF cFILCLI IS NULL
            OR cCODCLI IS NULL THEN
               cMOTREJ := 'ERRO AO VERIFICAR LANAMENTOS DE CONTA-CORRENTE: "CLIENTE" NO LOCALIZADO PARA O CDIGO: ' || cCODEXT_CLI || '.';
            END IF;
         END IF;

         IF cMOTREJ = 'OK' THEN
            IF nTIPCCC IS NULL THEN
               cMOTREJ := 'ERRO AO VERIFICAR LANAMENTOS DE CONTA-CORRENTE: "C/C CLIENTE" NO LOCALIZADO PARA O CDIGO: ' || cCODCCC || '.';
            END IF;
         END IF;

         IF cMOTREJ = 'OK' THEN
            IF nPORORI IS NULL THEN
               cMOTREJ := 'ERRO AO VERIFICAR LANAMENTOS DE CONTA-CORRENTE: "PORTADOR" NO LOCALIZADO PARA O CDIGO: ' || cCODCOB || '.';
            END IF;
         END IF;

         -- Realiza processo de Incluso de lanamento na Conta Corrente
         IF cMOTREJ = 'OK' THEN
            BEGIN
              select * into QuemLogou from DadosLogon();

              INSERT INTO TT_CCC (CODFIL, FILUSU, CODUSU, FILCLI, CODCLI, NUMDOC, DATOPE, TIPCCC, VLRLAN, VLRORI,
                                  COMPLE, PORORI, TIPLAN, ATULIM, INDEXP)
                          VALUES (cCODFIL, QuemLogou.FILUSU, QuemLogou.CODUSU, cFILCLI, cCODCLI, cNUMDOC, dDATOPE, nTIPCCC, nVLRLAN, nVLRLAN,
                                  cCOMPLE, nPORORI, cTIPLAN, cATULIM, 'I');

            EXCEPTION
              
              WHEN restrict_violation THEN IF cMOTREJ = 'OK' THEN cMOTREJ := SUBSTR('ERRO AO INSERIR LANAMENTOS DE CONTA-CORRENTE: '||SQLERRM,1,255); ELSE cMOTREJ := cMOTREJ; END IF;
              WHEN not_null_violation THEN IF cMOTREJ = 'OK' THEN cMOTREJ := SUBSTR('ERRO AO INSERIR LANAMENTOS DE CONTA-CORRENTE: '||SQLERRM,1,255); ELSE cMOTREJ := cMOTREJ; END IF;
              WHEN foreign_key_violation THEN IF cMOTREJ = 'OK' THEN cMOTREJ := SUBSTR('ERRO AO INSERIR LANAMENTOS DE CONTA-CORRENTE: '||SQLERRM,1,255); ELSE cMOTREJ := cMOTREJ; END IF;
              WHEN unique_violation THEN IF cMOTREJ = 'OK' THEN cMOTREJ := SUBSTR('ERRO AO INSERIR LANAMENTOS DE CONTA-CORRENTE: '||SQLERRM,1,255); ELSE cMOTREJ := cMOTREJ; END IF;
              WHEN check_violation THEN IF cMOTREJ = 'OK' THEN cMOTREJ := SUBSTR('ERRO AO INSERIR LANAMENTOS DE CONTA-CORRENTE: '||SQLERRM,1,255); ELSE cMOTREJ := cMOTREJ; END IF;
              WHEN integrity_constraint_violation THEN IF cMOTREJ = 'OK' THEN cMOTREJ := SUBSTR('ERRO AO INSERIR LANAMENTOS DE CONTA-CORRENTE: '||SQLERRM,1,255); ELSE cMOTREJ := cMOTREJ; END IF;
              WHEN plpgsql_error THEN IF cMOTREJ = 'OK' THEN cMOTREJ := SUBSTR('ERRO AO INSERIR LANAMENTOS DE CONTA-CORRENTE: '||SQLERRM,1,255); ELSE cMOTREJ := cMOTREJ; END IF;
                                        END;
         END IF;

         -- Verifica e marca registros com erros
         IF NOT cMOTREJ = 'OK' THEN
            nSTATUS := 4;
            nNROERR := nNROERR + 1;
         ELSE
            nSTATUS := 3;
         END IF;

         UPDATE TI_CCC SET STATUS = nSTATUS, DATIMP = AGORA(), MOTREJ = cMOTREJ
          WHERE ID_ICCC = nID_ICCC
            AND DATIMP IS NULL;

         
         nQTDIMP := nQTDIMP + 1;

         
         nNUMREG := nNUMREG - 1;
         
         CLOSE CR_CCC;
      END LOOP;

      IF nNROERR <> 0 THEN
         SELECT MAI_FR, MAI_TO, SAC_E_MAIL
           INTO cMAI_FR, cMAI_TO, cSAC_E_MAIL
           FROM TT_CFG;
         IF (ISNOTNULL(cMAI_FR)='T') AND (ISNOTNULL(cMAI_TO)='T') AND (INSTR(cMAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(cMAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
            INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO, MAI_CC,
                                TEXTOS,TIPMSG)
                        VALUES ('001','F',AGORA(),'IMPORTAO DE LANAMENTOS DE CONTA-CORRENTE',cMAI_FR, cMAI_TO, cSAC_E_MAIL,
                                'Problema na importao de '||nNROERR||' lanamentos de conta-corrente. Verifique!','T');
         END IF;
       END IF;

      -- Marca registros como importados
      UPDATE TI_CCC SET STATUS = CASE WHEN STATUS = 3 THEN 1 ELSE 2 END WHERE STATUS IN (3, 4);

      -- Realiza tratamento para exluso de registros aps processamento quando configurado
      IF cMANTEM = 'F' THEN
         IF nDIALIM > 0 THEN
            DELETE FROM TI_CCC WHERE DATIMP <= ADD_DAY(AGORA(), nDIALIM * -1) AND STATUS = 1;
         ELSE
            DELETE FROM TI_CCC WHERE STATUS = 1;
         END IF;
      END IF;

      -- Atualiza informaes da ltima integrao na tabela de controle
      UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = nQTDIMP, CNTIMP = nCNTIMP, TOTIMP = COALESCE(TOTIMP, 0) + nQTDIMP WHERE TABELA = 'CCC';

         ELSE 
      RAISE EXCEPTION 'PG-20001 IMPORTAO DE LANAMENTOS DE CONTA-CORRENTE NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;

   
   SELECT COUNT(*) INTO nRESTO FROM TI_CCC WHERE STATUS = 0;
   IF nRESTO > 0 THEN
      RETURN 'EXISTEM '||nRESTO||' LIMITES DE CONTA-CORRENTE NO IMPORTADOS';
   ELSE
      RETURN 'OK';
   END IF;
      
END;
$$ language 'plpgsql';





/*-- SEQ 1626 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_COM () CASCADE;

/*-- SEQ 1627 --*/
CREATE OR REPLACE FUNCTION IMPORTA_COM ()
RETURNS VARCHAR AS $$
DECLARE


-- Objetivo:
-- 1) Importao da tabela TT_COM
   WK_CODFIL                     TI_COM.CODFIL%TYPE;
   WK_FLGEST                     TI_COM.FLGEST%TYPE;
   WK_INCOJU                     TI_COM.INCOJU%TYPE;
   WK_INTPJU                     TI_COM.INTPJU%TYPE;
   WK_INTPMU                     TI_COM.INTPMU%TYPE;
   WK_TIPCTA                     TI_COM.TIPCTA%TYPE;
   WK_TIPNOT                     TI_COM.TIPNOT%TYPE;
   WK_CODSER                     TI_COM.CODSER%TYPE;
   WK_CODUSU                     TI_COM.CODUSU%TYPE;
   WK_CODFOR                     TI_COM.CODFOR%TYPE;
   WK_NUMNOT                     TI_COM.NUMNOT%TYPE;
   WK_ATU_EM                     TI_COM.ATU_EM%TYPE;
   WK_DATCMP                     TI_COM.DATCMP%TYPE;
   WK_DATOPE                     TI_COM.DATOPE%TYPE;
   WK_ACRESC                     TI_COM.ACRESC%TYPE;
   WK_DESCON                     TI_COM.DESCON%TYPE;
   WK_OUTTAX                     TI_COM.OUTTAX%TYPE;
   WK_QTDTOT                     TI_COM.QTDTOT%TYPE;
   WK_VLRLIQ                     TI_COM.VLRLIQ%TYPE;
   WK_VLRTOT                     TI_COM.VLRTOT%TYPE;
   WK_VLRNOT                     TI_COM.VLRNOT%TYPE;
   WK_CODMOE                     TI_COM.CODMOE%TYPE;
   WK_MOEJUR                     TI_COM.MOEJUR%TYPE;
   WK_CODSET                     TI_COM.CODSET%TYPE;
   WK_NOTESP                     TI_COM.NOTESP%TYPE;
   WK_VLRRET                     TI_COM.VLRRET%TYPE;
   WK_ICMFRE                     TI_COM.ICMFRE%TYPE;
   WK_TIPPAR                     TI_COM.TIPPAR%TYPE;
   WK_TIPTRP                     TI_COM.TIPTRP%TYPE;
   WK_STATUS                     TI_COM.STATUS%TYPE;
   WK_MOTREJ                     TI_COM.MOTREJ%TYPE;
   WK_DATIMP                     TI_COM.DATIMP%TYPE;
   WK_SIGNAT                     TI_COM.SIGNAT%TYPE;
   WK_UFNOTA                     TI_COM.UFNOTA%TYPE;
   WK_FILCTA                     TI_COM.FILCTA%TYPE;
   WK_SUBSER                     TI_COM.SUBSER%TYPE;
   WK_VLTXJU                     TI_COM.VLTXJU%TYPE;
   WK_VLTXMU                     TI_COM.VLTXMU%TYPE;
   WK_NUMVOL                     TI_COM.NUMVOL%TYPE;
   WK_SUBSTT                     TI_COM.SUBSTT%TYPE;
   WK_VLRBON                     TI_COM.VLRBON%TYPE;
   WK_ESPDOC                     TI_COM.ESPDOC%TYPE;
   WK_CONPGT                     TI_COM.CONPGT%TYPE;
   WK_OBSERV                     TI_COM.OBSERV%TYPE;
   WK_FILEND                     TI_COM.FILEND%TYPE;
   WK_NUMEND                     TI_COM.NUMEND%TYPE;
   WK_OBSFAT                     TI_COM.OBSFAT%TYPE;
   WK_RETCOF                     TI_COM.RETCOF%TYPE;
   WK_CODCFO                     TI_COM.CODCFO%TYPE;
   WK_ATUCUS                     TI_COM.ATUCUS%TYPE;
   WK_EXPORT                     TI_COM.EXPORT%TYPE;
   WK_VLRFRE                     TI_COM.VLRFRE%TYPE;
   WK_BASFRE                     TI_COM.BASFRE%TYPE;
   WK_PERFRE                     TI_COM.PERFRE%TYPE;
   WK_PERIRR                     TI_COM.PERIRR%TYPE;
   WK_PERISS                     TI_COM.PERISS%TYPE;
   WK_PERINS                     TI_COM.PERINS%TYPE;
   WK_PERCSS                     TI_COM.PERCSS%TYPE;
   WK_PERICM                     TI_COM.PERICM%TYPE;
   WK_VLRIRR                     TI_COM.VLRIRR%TYPE;
   WK_VLRISS                     TI_COM.VLRISS%TYPE;
   WK_VLRINS                     TI_COM.VLRINS%TYPE;
   WK_VLRCSS                     TI_COM.VLRCSS%TYPE;
   WK_VLRICM                     TI_COM.VLRICM%TYPE;
   WK_FLGINS                     TI_COM.FLGINS%TYPE;
   WK_FLGCSS                     TI_COM.FLGCSS%TYPE;
   WK_FLGPIS                     TI_COM.FLGPIS%TYPE;
   WK_FLGCOF                     TI_COM.FLGCOF%TYPE;
   WK_FILFRE                     TT_COM.CODFIL%TYPE;
   WK_SERFRE                     TI_COM.CODSER%TYPE;
   WK_FORFRE                     TI_COM.CODFOR%TYPE;
   WK_NUMFRE                     TI_COM.NUMNOT%TYPE;
   WK_FILFAT                     TT_COM.CODFIL%TYPE;
   WK_SERFAT                     TI_COM.CODSER%TYPE;
   WK_FORFAT                     TI_COM.CODFOR%TYPE;
   WK_NUMFAT                     TI_COM.NUMNOT%TYPE;
   WK_TITCTA                     TI_COM.TITCTA%TYPE;
   WK_USOCTA                     TI_COM.USOCTA%TYPE;
   WK_NROERR                     Numeric;
   WK_QTDIMP                     Numeric;
   WK_IMPORT                     TT_IED.IMPORT%TYPE;
   WK_MANTEM                     TT_IED.MANTEM%TYPE;
   WK_CNTIMP                     TT_IED.CNTIMP%TYPE;
   WK_MAI_FR                     TT_CFG.MAI_FR%TYPE;
   WK_MAI_TO                     TT_CFG.MAI_TO%TYPE;
   WK_AUX_FILUSU                 TT_USU.FILUSU%TYPE;
   WK_AUX_CODUSU                 TT_USU.CODUSU%TYPE;
   WK_AUX_FILFOR                 TT_CLI.FILCLI%TYPE;
   WK_AUX_CODFOR                 TT_CLI.CODCLI%TYPE;
   WK_AUX_SEQCTA                 TT_COM.SEQCTA%TYPE;
   WK_FRE_CODFIL                 TT_COM.CODFIL%TYPE;
   WK_FRE_SEQUEN                 TT_COM.SEQUEN%TYPE;
   WK_FAT_SEQUEN                 TT_COM.SEQUEN%TYPE;
   WK_COD_CODSET                 TT_COM.CODSET%TYPE;
   WK_COD_CODCFO                 TT_COM.CODCFO%TYPE;
   WK_COD_CODMOE                 TT_COM.CODMOE%TYPE;
   WK_COD_MOEJUR                 TT_COM.MOEJUR%TYPE;
   WK_DIALIM                     TT_IED.DIALIM%TYPE;
   WK_DATCRI                     TI_COM.DATCRI%TYPE;
   WK_DESCFO                     TI_COM.DESCFO%TYPE;
   WK_ISEICM                     TI_COM.ISEICM%TYPE;
   WK_OUTICM                     TI_COM.OUTICM%TYPE;
   WK_TIPEMP                     TI_COM.TIPEMP%TYPE;
   WK_POREMP                     TI_COM.POREMP%TYPE;
   WK_BASSUB                     TI_COM.BASSUB%TYPE;
   WK_VLRIPI                     TI_COM.VLRIPI%TYPE;
   WK_RETIRR                     TI_COM.RETIRR%TYPE;
   WK_RETCSS                     TI_COM.RETCSS%TYPE;
   WK_VLRPIS                     TI_COM.VLRPIS%TYPE;
   WK_VLRCOF                     TI_COM.VLRCOF%TYPE;
   WK_OUTDES                     TI_COM.OUTDES%TYPE;
   WK_DESPAR                     TI_COM.DESPAR%TYPE;
   WK_FLGICM                     TI_COM.FLGICM%TYPE;
   WK_FLGISS                     TI_COM.FLGISS%TYPE;
   WK_CHAVEA                     TI_COM.CHAVEA%TYPE;
   cTIPCCM                       TT_COM.TIPCCM%TYPE;
   	
	WK_BASICM							TI_COM.BASICM%TYPE;
   WK_BASRET							TI_COM.BASRET%TYPE;
	WK_BSTFRE							TI_COM.BSTFRE%TYPE;
	WK_CODAVU							TI_COM.CODAVU%TYPE;
	WK_CODDAR							TI_COM.CODDAR%TYPE;
	WK_CODDOP							TI_COM.CODDOP%TYPE;
	WK_CODFCE							TI_COM.CODFCE%TYPE;
	WK_CODFPS							TI_COM.CODFPS%TYPE;
	WK_CODIBG							TI_COM.CODIBG%TYPE;
	WK_CODSRV							TI_COM.CODSRV%TYPE;
	WK_CODTRI							TI_COM.CODTRI%TYPE;
	WK_DATSTR							TI_COM.DATSTR%TYPE;
	WK_FILAGC							TI_COM.FILAGC%TYPE;
	WK_FINNFE							TI_COM.FINNFE%TYPE;
	WK_NATBCC							TI_COM.NATBCC%TYPE;
	WK_NATFRE							TI_COM.NATFRE%TYPE;
	WK_RATEIO_FRETE					TI_COM.RATEIO_FRETE%TYPE;
	WK_SEQAGC							TI_COM.SEQAGC%TYPE;
	WK_SITCOF							TI_COM.SITCOF%TYPE;
	WK_SITPIS							TI_COM.SITPIS%TYPE;
	WK_ST_FRE							TI_COM.ST_FRE%TYPE;
	WK_TIPFRE							TI_COM.TIPFRE%TYPE;
	WK_VLRBONFUT						TI_COM.VLRBONFUT%TYPE;
	WK_VLRSRV							TI_COM.VLRSRV%TYPE;
	WK_XMLNFE							TI_COM.XMLNFE%TYPE;

   WK_EXISTE_CTA                 Numeric;
   W_EXISTE                      Numeric(1);
   WK_FOR_EXISTE                 Numeric(1);
   
   WK_RESTO                      Numeric;
   WK_NUMREG                     Numeric = 500;
   

CR_COMPRAS CURSOR(pDATCRI TI_COM.DATCRI%TYPE) IS
/*Status => 0 no processado
         => 1 processado com sucesso
         => 2 processado com erro*/

    --Implementado com sub-select, garantindo assim rownum = 1, ordenado por DATCMP.
    ---> Necessidade de importar em ordem de data, para amarrao com frete/faturamento.
    SELECT *
      FROM (SELECT CODFIL,FLGEST,INCOJU,INTPJU,INTPMU,TIPCTA,TIPNOT,CODSER,CODUSU,CODFOR,
                   NUMNOT,ATU_EM,DATCMP,DATOPE,ACRESC,DESCON,OUTTAX,QTDTOT,VLRLIQ,VLRTOT, VLRNOT,
                   CODMOE,MOEJUR,CODSET,NOTESP,VLRRET,ICMFRE,TIPPAR,TIPTRP,MOTREJ,
                   DATIMP,SIGNAT,UFNOTA,FILCTA,SUBSER,VLTXJU,VLTXMU,NUMVOL,SUBSTT,
                   VLRBON,ESPDOC,CONPGT,OBSERV,FILEND,NUMEND,OBSFAT,RETCOF,CODCFO,ATUCUS,
                   EXPORT,VLRFRE,BASFRE,PERFRE,PERIRR,PERISS,PERINS,PERCSS,PERICM,VLRIRR,
                   VLRISS,VLRINS,VLRCSS,VLRICM,FLGINS,FLGCSS,FLGPIS,FLGCOF,FILFRE,SERFRE,
                   FORFRE,NUMFRE,FILFAT,SERFAT,FORFAT,NUMFAT,TITCTA,USOCTA,DESCFO,ISEICM,
                   OUTICM,TIPEMP,POREMP,BASSUB,VLRIPI,RETIRR,RETCSS,VLRPIS,VLRCOF,OUTDES,
                   DESPAR,FLGICM,FLGISS,CHAVEA,BASICM,BASRET,BSTFRE,CODAVU,CODDAR,CODDOP,
						 CODFCE,CODFPS,CODIBG,CODSRV,CODTRI,DATSTR,FILAGC,FINNFE,NATBCC,NATFRE,
						 RATEIO_FRETE,SEQAGC,SITCOF,SITPIS,ST_FRE,TIPFRE,VLRBONFUT,VLRSRV,XMLNFE		
              FROM (SELECT CODFIL,FLGEST,INCOJU,INTPJU,INTPMU,TIPCTA,TIPNOT,CODSER,CODUSU,CODFOR,
                           NUMNOT,ATU_EM,DATCMP,DATOPE,ACRESC,DESCON,OUTTAX,QTDTOT,VLRLIQ,VLRTOT, VLRNOT,
                           COALESCE(CODMOE,'R$') AS CODMOE,COALESCE(MOEJUR,'R$') AS MOEJUR,CODSET,NOTESP,VLRRET,ICMFRE,TIPPAR,TIPTRP,MOTREJ,
                           DATIMP,SIGNAT,UFNOTA,FILCTA,SUBSER,VLTXJU,VLTXMU,NUMVOL,SUBSTT,
                           VLRBON,ESPDOC,CONPGT,OBSERV,FILEND,NUMEND,OBSFAT,RETCOF,CODCFO,ATUCUS,
                           EXPORT,VLRFRE,BASFRE,PERFRE,PERIRR,PERISS,PERINS,PERCSS,PERICM,VLRIRR,
                           VLRISS,VLRINS,VLRCSS,VLRICM,FLGINS,FLGCSS,FLGPIS,FLGCOF,FILFRE,SERFRE,
                           FORFRE,NUMFRE,FILFAT,SERFAT,FORFAT,NUMFAT,TITCTA,USOCTA,DATCRI,DESCFO,
                           ISEICM,OUTICM,TIPEMP,POREMP,BASSUB,VLRIPI,RETIRR,RETCSS,VLRPIS,VLRCOF,
                           OUTDES,DESPAR,FLGICM,FLGISS,CHAVEA,BASICM,BASRET,BSTFRE,CODAVU,CODDAR,
									CODDOP,CODFCE,CODFPS,CODIBG,CODSRV,CODTRI,DATSTR,FILAGC,FINNFE,NATBCC,
									NATFRE,RATEIO_FRETE,SEQAGC,SITCOF,SITPIS,ST_FRE,TIPFRE,VLRBONFUT,VLRSRV,XMLNFE	
                      FROM TI_COM
                     WHERE STATUS = 0
                     ORDER BY DATCMP) TABELA_ORDENADA
               WHERE DATCRI BETWEEN TRUNC(pDATCRI)
                                AND ADD_DAY(TRUNC(pDATCRI),1)
               ORDER BY DATCRI
               ) TAB
   LIMIT 1;
BEGIN
   -- RFMP 80113
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20018 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

   SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
     INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
     FROM TT_IED
    WHERE TABELA = 'COM';

   IF WK_IMPORT = 'T' THEN
     WK_CNTIMP := WK_CNTIMP + 1;
     WK_NROERR := 0;
     WK_QTDIMP := 0;

     LOOP
       WK_AUX_FILUSU := NULL;
       WK_AUX_CODUSU := NULL;
       WK_AUX_FILFOR := NULL;
       WK_AUX_CODFOR := NULL;
       WK_FRE_CODFIL := NULL;
       WK_FRE_SEQUEN := NULL;
       WK_FAT_SEQUEN := NULL;
       WK_COD_CODSET := NULL;
       WK_COD_CODCFO := NULL;
       WK_AUX_SEQCTA := NULL;
       WK_COD_CODMOE := NULL;
       WK_COD_MOEJUR := NULL;

       SELECT MIN(DATCRI)
         INTO WK_DATCRI
         FROM TI_COM
        WHERE STATUS = 0;

       OPEN CR_COMPRAS(WK_DATCRI);
       FETCH CR_COMPRAS INTO WK_CODFIL,WK_FLGEST,WK_INCOJU,WK_INTPJU,WK_INTPMU,WK_TIPCTA,
                             WK_TIPNOT,WK_CODSER,WK_CODUSU,WK_CODFOR,WK_NUMNOT,WK_ATU_EM,
                             WK_DATCMP,WK_DATOPE,WK_ACRESC,WK_DESCON,WK_OUTTAX,WK_QTDTOT,
                             WK_VLRLIQ,WK_VLRTOT,WK_VLRNOT,WK_CODMOE,WK_MOEJUR,WK_CODSET,WK_NOTESP,
                             WK_VLRRET,WK_ICMFRE,WK_TIPPAR,WK_TIPTRP,WK_MOTREJ,
                             WK_DATIMP,WK_SIGNAT,WK_UFNOTA,WK_FILCTA,WK_SUBSER,
                             WK_VLTXJU,WK_VLTXMU,WK_NUMVOL,WK_SUBSTT,WK_VLRBON,WK_ESPDOC,
                             WK_CONPGT,WK_OBSERV,WK_FILEND,WK_NUMEND,WK_OBSFAT,WK_RETCOF,
                             WK_CODCFO,WK_ATUCUS,WK_EXPORT,WK_VLRFRE,WK_BASFRE,WK_PERFRE,
                             WK_PERIRR,WK_PERISS,WK_PERINS,WK_PERCSS,WK_PERICM,WK_VLRIRR,
                             WK_VLRISS,WK_VLRINS,WK_VLRCSS,WK_VLRICM,WK_FLGINS,WK_FLGCSS,
                             WK_FLGPIS,WK_FLGCOF,WK_FILFRE,WK_SERFRE,WK_FORFRE,WK_NUMFRE,
                             WK_FILFAT,WK_SERFAT,WK_FORFAT,WK_NUMFAT,WK_TITCTA,WK_USOCTA,
                             WK_DESCFO,WK_ISEICM,WK_OUTICM,WK_TIPEMP,WK_POREMP,WK_BASSUB,
                             WK_VLRIPI,WK_RETIRR,WK_RETCSS,WK_VLRPIS,WK_VLRCOF,WK_OUTDES,
                             WK_DESPAR,WK_FLGICM,WK_FLGISS,WK_CHAVEA,WK_BASICM,WK_BASRET,
									  WK_BSTFRE,WK_CODAVU,WK_CODDAR,WK_CODDOP,WK_CODFCE,WK_CODFPS,
									  WK_CODIBG,WK_CODSRV,WK_CODTRI,WK_DATSTR,WK_FILAGC,WK_FINNFE,
									  WK_NATBCC,WK_NATFRE,WK_RATEIO_FRETE,
									  WK_SEQAGC,WK_SITCOF,WK_SITPIS,WK_ST_FRE,WK_TIPFRE,WK_VLRBONFUT,
									  WK_VLRSRV,WK_XMLNFE;

       IF NOT FOUND THEN
          CLOSE CR_COMPRAS;
          EXIT;
       END IF;

       
       IF WK_NUMREG = 0 THEN
          CLOSE CR_COMPRAS;
          EXIT;
       END IF;
       
       WK_MOTREJ     := 'OK';

       IF WK_CODSET IS NOT NULL THEN
          WK_COD_CODSET := IMPORTA_TDS( 'TD_SET', 'SETATI', 'DESSET', 'CODTAB', WK_CODSET, NULL, NULL, NULL );
       END IF;
       IF WK_CODMOE IS NOT NULL THEN
          WK_COD_CODMOE := IMPORTA_TDS( 'TD_MOE', 'MOEATI', 'DESMOE', 'CODTAB', WK_CODMOE, NULL, NULL, NULL );
       END IF;
       IF WK_MOEJUR IS NOT NULL THEN
          WK_COD_MOEJUR := IMPORTA_TDS( 'TD_MOE', 'MOEATI', 'DESMOE', 'CODTAB', WK_MOEJUR, NULL, NULL, NULL );
       END IF;
       IF WK_CODCFO IS NOT NULL THEN
          WK_COD_CODCFO := IMPORTA_TDS( 'TD_CFO', 'CFOATI', 'CODCFO', 'CODTAB', WK_CODCFO, NULL, NULL, NULL, 'DESCFO', WK_DESCFO );

          -- Obtem o Tipo de Calculo de Custo Mdio conforme definio do CFOP
                      SELECT TIPCCM
              INTO cTIPCCM
              FROM TD_CFO
             WHERE CODTAB = WK_COD_CODCFO;
                 END IF;
       
         SELECT U.FILUSU, U.CODUSU
         INTO WK_AUX_FILUSU, WK_AUX_CODUSU
         FROM TT_USU U
         WHERE U.CODEXT = WK_CODUSU;
      IF WK_MOTREJ = 'OK' THEN
         IF (WK_AUX_FILUSU IS NULL) THEN
            WK_MOTREJ := 'ERRO ao processar o Documento: Usurio no encontrado para cdigo "' || WK_CODUSU || '".';
         END IF;
      END IF;

         SELECT C.FILCLI, C.CODCLI
         INTO WK_AUX_FILFOR, WK_AUX_CODFOR
         FROM TT_CLI C
         WHERE TRIM(C.CODEXT) = TRIM(WK_CODFOR);
      IF WK_AUX_FILFOR IS NULL THEN
            SELECT E.FILCLI, E.CODCLI
              INTO WK_AUX_FILFOR, WK_AUX_CODFOR
              FROM TT_END E
             WHERE TRIM(E.NUMDOC) = TRIM(WK_CODFOR);
      END IF;

      IF WK_AUX_FILFOR IS NULL THEN
         WK_MOTREJ := 'ERRO ao processar o Documento: Fornecedor no econtrado com o cdigo externo: '|| TRIM(WK_CODFOR) ||' ou CNPJ/CPF: ' || TRIM(WK_CODFOR);
      END IF;
      
      WK_FOR_EXISTE := 0;
      
      IF WK_MOTREJ = 'OK' THEN
          -- Select para verificar se esta definido como fornecedor
                     SELECT 1 AS EXIST 
              INTO WK_FOR_EXISTE
              FROM TT_REL
             WHERE FILPAR = WK_AUX_FILFOR 
               AND CODPAR = WK_AUX_CODFOR;
          
    
         IF (WK_MOTREJ = 'OK') AND (coalesce(WK_FOR_EXISTE,0) <> 1) THEN
            WK_MOTREJ := 'ERRO ao processar o Documento: Parceiro no definido como Fornecedor com o cdigo externo: '|| TRIM(WK_CODFOR) ||' ou CNPJ/CPF: ' || TRIM(WK_CODFOR);
         END IF;  
      END IF;
      
      IF WK_MOTREJ = 'OK' THEN

       IF WK_FILFRE IS NOT NULL THEN
       --TEM FRETE ASSOCIADO
           SELECT T.CODFIL, T.SEQUEN
           INTO WK_FRE_CODFIL, WK_FRE_SEQUEN
           FROM TT_COM T
           WHERE T.CODFIL = WK_FILFRE
             AND T.NUMNOT = LPAD(TRIM(WK_NUMFRE),9, ' ')
             AND T.CODSER = WK_SERFRE
             AND T.FLGEST <> 'D'
             AND ((T.CODFOR,T.FILFOR) IN (SELECT C.CODCLI,C.FILCLI
                             FROM TT_CLI C
                             WHERE C.CODEXT = WK_FORFRE));
       END IF;

       IF WK_FILFAT IS NOT NULL THEN
       --TEM FATURA ASSOCIADA
           SELECT T.SEQUEN
           INTO WK_FAT_SEQUEN
           FROM TT_COM T
           WHERE T.CODFIL = WK_FILFAT
             AND T.NUMNOT = LPAD(TRIM(WK_NUMFAT),9, ' ')
             AND T.CODSER = WK_SERFAT
             AND T.FLGEST <> 'D'
             AND ((T.CODFOR,T.FILFOR) IN (SELECT C.CODCLI,C.FILCLI
                             FROM TT_CLI C
                             WHERE C.CODEXT = WK_FORFAT));
       END IF;

      -- Paulo - 80203 : Select para verificar se a conta j existe na TT_CTA.
            SELECT COUNT(*) INTO WK_EXISTE_CTA
	    FROM TT_CTA
	   WHERE UPPER(TITCTA) = UPPER(WK_TITCTA);
      
      -- Paulo - 80203 : Estava inserindo contas j existentes.
	  IF WK_EXISTE_CTA = 0 THEN
	     IF ((WK_FILCTA IS NOT NULL) AND
		     (WK_TITCTA IS NOT NULL) AND
			 (WK_TIPCTA IS NOT NULL) AND
			 (WK_USOCTA IS NOT NULL)) THEN
           WK_AUX_SEQCTA := PROXIMACONTA(WK_FILCTA,WK_TITCTA,WK_TIPCTA,WK_USOCTA,WK_TIPCTA);
       END IF;
	  ELSE
	              SELECT CAST(MIN(SEQUEN) AS CHAR(10)) INTO WK_AUX_SEQCTA
	       FROM TT_CTA
	      WHERE UPPER(TITCTA) = UPPER(WK_TITCTA);
         	  END IF;

       W_EXISTE := 0;
         SELECT 1 INTO W_EXISTE
         FROM TT_COM TC
         WHERE TC.CODFIL = WK_CODFIL
           AND TC.CODSER = WK_CODSER
           AND TC.FILFOR = WK_AUX_FILFOR
           AND TC.CODFOR = WK_AUX_CODFOR
           AND TC.NUMNOT = LPAD(TRIM(WK_NUMNOT),9, ' ')
           AND TC.FLGEST <> 'D';
       IF W_EXISTE IS NULL THEN
           W_EXISTE := 0;
       END IF;

       IF W_EXISTE = 0 THEN --registro novo

         BEGIN
           INSERT INTO TT_COM(CODFIL,FLGEST,INCOJU,INTPJU,INTPMU,TIPCTA,TIPNOT,CODSER,CODUSU,
                              FILFOR,FILUSU,CODFOR,NUMNOT,ATU_EM,DATCMP,DATOPE,DESCON,OUTTAX,QTDTOT,
                              VLRLIQ,VLRTOT,VLRNOT,CODMOE,MOEJUR,CODSET,SIGNAT,NOTESP,TIPPAR,UFNOTA,FILCTA,
                              SUBSER,SEQCTA,SEQFAT,FILFRE,SEQFRE,VLTXJU,VLTXMU,NUMVOL,SUBSTT,VLRBON,ESPDOC,
                              CONPGT,SEQCAN,OBSERV,FILEND,NUMEND,OBSFAT,VLRRET,ICMFRE,TIPTRP,RETCOF,
                              CODCFO,ATUCUS,EXPORT,VLRFRE,BASFRE,PERFRE,PERIRR,PERISS,PERINS,PERCSS,
                              PERICM,VLRIRR,VLRISS,VLRINS,VLRCSS,VLRICM,FLGINS,FLGCSS,FLGPIS,FLGCOF,
                              ISEICM,OUTICM,TIPEMP,POREMP,BASSUB,VLRIPI,RETIRR,RETCSS,VLRPIS,VLRCOF,OUTDES,DESPAR,FLGICM,FLGISS, CHAVEA, TIPCCM,
										BASICM,BASRET,BSTFRE,CODAVU,CODDAR,CODDOP,CODFCE,CODFPS,CODIBG,CODSRV,CODTRI,FINNFE,NATBCC,
										NATFRE,SITCOF,SITPIS,ST_FRE,TIPFRE,VLRBONFUT,VLRSRV,XMLNFE)
                       VALUES(WK_CODFIL,WK_FLGEST,WK_INCOJU,WK_INTPJU,WK_INTPMU,WK_TIPCTA,WK_TIPNOT,WK_CODSER,WK_AUX_CODUSU,
                              WK_AUX_FILFOR,WK_AUX_FILUSU,WK_AUX_CODFOR,LPAD(TRIM(WK_NUMNOT),9, ' '),WK_ATU_EM,WK_DATCMP,WK_DATOPE,CASE WHEN COALESCE(WK_DESCON,0) > 0 THEN (COALESCE(WK_DESCON,0) * -1) ELSE COALESCE(WK_ACRESC,0) END,WK_OUTTAX,WK_QTDTOT,
                              WK_VLRLIQ,WK_VLRTOT,WK_VLRNOT,COALESCE(WK_COD_CODMOE,0),COALESCE(WK_COD_MOEJUR,0),COALESCE(WK_COD_CODSET,0),COALESCE(WK_SIGNAT,0),WK_NOTESP,WK_TIPPAR,WK_UFNOTA,WK_FILCTA,
                              WK_SUBSER,WK_AUX_SEQCTA,WK_FAT_SEQUEN,WK_FRE_CODFIL,WK_FRE_SEQUEN,WK_VLTXJU,WK_VLTXMU,WK_NUMVOL,WK_SUBSTT,WK_VLRBON,WK_ESPDOC,
                              WK_CONPGT,NULL,WK_OBSERV,WK_FILEND,WK_NUMEND,WK_OBSFAT,COALESCE(WK_VLRRET,0),WK_ICMFRE,WK_TIPTRP,WK_RETCOF,
                              WK_COD_CODCFO,COALESCE(WK_ATUCUS,'T'),COALESCE(WK_EXPORT,'F'),COALESCE(WK_VLRFRE,0),COALESCE(WK_BASFRE,0),COALESCE(WK_PERFRE,0),WK_PERIRR,WK_PERISS,WK_PERINS,WK_PERCSS,
                              WK_PERICM,COALESCE(WK_VLRIRR,0),WK_VLRISS,WK_VLRINS,WK_VLRCSS,WK_VLRICM,WK_FLGINS,WK_FLGCSS,WK_FLGPIS,WK_FLGCOF,WK_ISEICM,WK_OUTICM,WK_TIPEMP,WK_POREMP,WK_BASSUB,
                              WK_VLRIPI,COALESCE(WK_RETIRR,'F'),COALESCE(WK_RETCSS,'F'),WK_VLRPIS,WK_VLRCOF,WK_OUTDES,WK_DESPAR,WK_FLGICM,WK_FLGISS, WK_CHAVEA, cTIPCCM,
										COALESCE(WK_BASICM,0),COALESCE(WK_BASRET,0),WK_BSTFRE,WK_CODAVU,WK_CODDAR,WK_CODDOP,WK_CODFCE,WK_CODFPS,WK_CODIBG,WK_CODSRV,WK_CODTRI,WK_FINNFE,
										WK_NATBCC,WK_NATFRE,WK_SITCOF,WK_SITPIS,WK_ST_FRE,WK_TIPFRE,WK_VLRBONFUT,WK_VLRSRV,WK_XMLNFE);

         EXCEPTION
           WHEN OTHERS THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PEDIDOS DE COMPRAS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
         END;

       ELSE
         BEGIN
           UPDATE TT_COM SET FLGEST = WK_FLGEST,INCOJU = WK_INCOJU,INTPJU = WK_INTPJU,INTPMU = WK_INTPMU,
                             TIPCTA = COALESCE(WK_TIPCTA,TIPCTA),TIPNOT = WK_TIPNOT,CODUSU = WK_AUX_CODUSU,FILFOR = WK_AUX_FILFOR,
                             FILUSU = WK_AUX_FILUSU,ATU_EM = WK_ATU_EM,DATCMP = WK_DATCMP,DATOPE = WK_DATOPE,
                             DESCON = CASE WHEN COALESCE(WK_DESCON,0) > 0 THEN (COALESCE(WK_DESCON,0) * -1) ELSE COALESCE(WK_ACRESC,0) END,
                             OUTTAX = WK_OUTTAX,QTDTOT = WK_QTDTOT,VLRLIQ = WK_VLRLIQ,VLRTOT = WK_VLRTOT, VLRNOT = WK_VLRNOT,
                             CODMOE = COALESCE(WK_COD_CODMOE,0),MOEJUR = COALESCE(WK_COD_MOEJUR,0),CODSET = COALESCE(WK_COD_CODSET,0),
                             SIGNAT = COALESCE(WK_SIGNAT,0),NOTESP = WK_NOTESP,TIPPAR = WK_TIPPAR,
                             UFNOTA = WK_UFNOTA,FILCTA = COALESCE(WK_FILCTA,FILCTA),SUBSER = WK_SUBSER,SEQCTA = COALESCE(WK_AUX_SEQCTA,SEQCTA),
                             SEQFAT = WK_FAT_SEQUEN, FILFRE = WK_FRE_CODFIL, SEQFRE = WK_FRE_SEQUEN,VLTXJU = WK_VLTXJU,VLTXMU = WK_VLTXMU,
                             NUMVOL = WK_NUMVOL,SUBSTT = WK_SUBSTT,VLRBON = WK_VLRBON,ESPDOC = WK_ESPDOC,
                             CONPGT = WK_CONPGT,SEQCAN = NULL,OBSERV = WK_OBSERV,FILEND = WK_FILEND,
                             NUMEND = WK_NUMEND,OBSFAT = WK_OBSFAT,VLRRET = COALESCE(WK_VLRRET,0),ICMFRE = WK_ICMFRE,
                             TIPTRP = WK_TIPTRP,RETCOF = WK_RETCOF,CODCFO = WK_COD_CODCFO,
                             ATUCUS = COALESCE(WK_ATUCUS,'T'),EXPORT = COALESCE(WK_EXPORT,'F'),
                             VLRFRE = COALESCE(WK_VLRFRE,0),BASFRE = COALESCE(WK_BASFRE,0),PERFRE = COALESCE(WK_PERFRE,0),
                             PERIRR = WK_PERIRR,PERISS = WK_PERISS,PERINS = WK_PERINS,PERCSS = WK_PERCSS,
                             PERICM = WK_PERICM,VLRIRR = COALESCE(WK_VLRIRR,0),VLRISS = WK_VLRISS,VLRINS = WK_VLRINS,
                             VLRCSS = WK_VLRCSS,VLRICM = WK_VLRICM,FLGINS = WK_FLGINS,FLGCSS = WK_FLGCSS,
                             FLGPIS = WK_FLGPIS,FLGCOF = WK_FLGCOF,
                             ISEICM = WK_ISEICM,OUTICM = WK_OUTICM,TIPEMP = WK_TIPEMP,POREMP = WK_POREMP,
                             BASSUB = WK_BASSUB,VLRIPI = WK_VLRIPI,RETIRR = COALESCE(WK_RETIRR,'F'),RETCSS = COALESCE(WK_RETCSS,'F'),
                             VLRPIS = WK_VLRPIS,VLRCOF = WK_VLRCOF,OUTDES = WK_OUTDES,DESPAR = WK_DESPAR,
                             FLGICM = WK_FLGICM,FLGISS = WK_FLGISS,CHAVEA = WK_CHAVEA,TIPCCM = cTIPCCM,
									  BASICM = COALESCE(WK_BASICM,0),BASRET = COALESCE(WK_BASRET, 0),BSTFRE = WK_BSTFRE,CODAVU = WK_CODAVU,
									  CODDAR = WK_CODDAR,CODDOP = WK_CODDOP,CODFCE = WK_CODFCE,CODFPS = WK_CODFPS,
									  CODIBG = WK_CODIBG,CODSRV = WK_CODSRV,CODTRI = WK_CODTRI,
									  FINNFE = WK_FINNFE,NATBCC = WK_NATBCC,NATFRE = WK_NATFRE, SITCOF = WK_SITCOF,
									  SITPIS = WK_SITPIS,ST_FRE = WK_ST_FRE,TIPFRE = WK_TIPFRE,VLRBONFUT = WK_VLRBONFUT,
									  VLRSRV = WK_VLRSRV,XMLNFE = WK_XMLNFE
         WHERE CODFIL = WK_CODFIL
           AND CODSER = WK_CODSER
           AND FILFOR = WK_AUX_FILFOR
           AND CODFOR = WK_AUX_CODFOR
           AND NUMNOT = LPAD(TRIM(WK_NUMNOT),9, ' ')
           AND FLGEST <> 'D';

         EXCEPTION
           WHEN OTHERS THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO PEDIDOS DE COMPRAS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
         END;
       END IF;
      END IF;

        IF NOT WK_MOTREJ = 'OK' THEN
           WK_STATUS := 4;
           WK_NROERR := WK_NROERR + 1;
        ELSE
          WK_STATUS := 3;
        END IF;

        UPDATE TI_COM SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
         WHERE CODFIL = WK_CODFIL
           AND CODSER = WK_CODSER
           AND CODFOR = WK_CODFOR
           AND NUMNOT = WK_NUMNOT
           AND DATIMP IS NULL;

        WK_QTDIMP := WK_QTDIMP + 1;
  
        WK_NUMREG := WK_NUMREG - 1;
          CLOSE CR_COMPRAS;
     END LOOP;

     IF WK_NROERR <> 0 THEN
        SELECT MAI_FR, MAI_TO
          INTO WK_MAI_FR, WK_MAI_TO
          FROM TT_CFG;
        IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
           INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO,
                               TEXTOS,TIPMSG)
                       VALUES ('001','F',AGORA(),'IMPORTAO DE PEDIDOS DE COMPRAS',WK_MAI_FR, WK_MAI_TO,
                               'Problema na importao de '||wk_nroerr||' pedidos de compras. Verifique!','T');
        END IF;
     END IF;

     UPDATE TI_COM SET STATUS = CASE WHEN STATUS = 3
                                     THEN 1
                                     ELSE 2
                                 END
     WHERE STATUS IN (3,4);


     IF WK_MANTEM = 'F' THEN
        IF WK_DIALIM > 0 THEN
           DELETE FROM TI_COM
            WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
			  AND STATUS = 1;
        ELSE
           DELETE FROM TI_COM
		    WHERE STATUS = 1;
        END IF;
     END IF;

     UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = WK_QTDIMP, CNTIMP = WK_CNTIMP, TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP WHERE TABELA = 'COM';
   ELSE RAISE EXCEPTION 'PG-20001 IMPORTAO DE COMPRAS NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;
   
   SELECT COUNT(*) INTO WK_RESTO FROM TI_COM WHERE STATUS = 0;
   IF WK_RESTO > 0 THEN
     RETURN 'EXISTEM '||WK_RESTO||' COMPRAS NO IMPORTADAS';
   ELSE
     RETURN 'OK';
   END IF;
   
END;
$$ language 'plpgsql';





/*-- SEQ 1628 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_EAN () CASCADE;

/*-- SEQ 1629 --*/
CREATE OR REPLACE FUNCTION IMPORTA_EAN ()
RETURNS VARCHAR AS $$
DECLARE


-- Objetivo:
-- 1) Importao das tabelas referentes a referncia de produtos (TD_EAN e TT_EAN)

-- Variveis TI_EAN
WK_CODEXT TI_EAN.CODEXT%TYPE;
WK_CODFIL TI_EAN.CODFIL%TYPE;
WK_CODEAN TI_EAN.CODEAN%TYPE;
WK_REFATI TI_EAN.REFATI%TYPE;
WK_STATUS TI_EAN.STATUS%TYPE;
WK_MOTREJ TI_EAN.MOTREJ%TYPE;
WK_DATIMP TI_EAN.DATIMP%TYPE;


-- Variveis TT_EAN
WK_USOEAN TT_EAN.USOEAN%TYPE;

-- Variveis TT_IED
WK_IMPORT TT_IED.IMPORT%TYPE;
WK_MANTEM TT_IED.MANTEM%TYPE;
WK_CNTIMP TT_IED.CNTIMP%TYPE;
WK_DIALIM TT_IED.DIALIM%TYPE;

-- Variveis TT_GRA
WK_FILMAT TT_GRA.FILMAT%TYPE;
WK_CODMAT TT_GRA.CODMAT%TYPE;
WK_CODCOR TT_GRA.CODCOR%TYPE;
WK_CODTAM TT_GRA.CODTAM%TYPE;

WK_CODEXT_EAN TT_GRA.CODEXT%TYPE;

-- Outras Variveis
WK_COUNT       Numeric;
WK_QTDIMP      Numeric;


WK_RESTO      Numeric;
WK_NUMREG     Numeric = 500;
cDUMMY      VARCHAR(10);

CR_IEAN CURSOR FOR
    SELECT *
      FROM (SELECT /*+INDEX(IEAN, I_LC_IEAN_STATUS)*/
                   IEAN.CODEXT, IEAN.CODFIL, IEAN.CODEAN, IEAN.REFATI, IEAN.STATUS, IEAN.MOTREJ, IEAN.DATIMP
              FROM TI_EAN IEAN
             WHERE IEAN.STATUS = 0
             ORDER BY IEAN.CODEXT) TAB
        
    LIMIT 1;
    

-- Incio Procedure
BEGIN
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20017 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

        SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
      INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
      FROM TT_IED
     WHERE TABELA = 'EAN';
    
    IF WK_IMPORT = 'T' THEN
        WK_CNTIMP := WK_CNTIMP + 1;
        WK_QTDIMP := 0;

        LOOP
            WK_FILMAT := null;
            WK_CODMAT := null;
            WK_CODCOR := null;
            WK_CODTAM := null;

            OPEN CR_IEAN;
            FETCH CR_IEAN INTO WK_CODEXT, WK_CODFIL, WK_CODEAN, WK_REFATI, WK_STATUS, WK_MOTREJ, WK_DATIMP;
            IF NOT FOUND THEN
               CLOSE CR_IEAN;
               EXIT;
            END IF;
            
            IF WK_NUMREG = 0 THEN
               CLOSE CR_IEAN;
               EXIT;
            END IF;
            
            WK_MOTREJ := 'OK';

            IF WK_CODEXT IS NULL THEN
                RAISE EXCEPTION 'PG-20100 A coluna CODEXT deve ser preenchida';
            END IF;

            IF WK_CODEAN IS NULL THEN
                RAISE EXCEPTION 'PG-20110 A coluna CODEAN deve ser preenchida';
            END IF;

            IF WK_CODFIL IS NULL THEN
                RAISE EXCEPTION 'PG-20120 A coluna CODFIL deve ser preenchida';
            END IF;

            WK_USOEAN := IMPORTA_TDS( 'TD_EAN', 'EANATI', 'DESEAN', 'CODTAB',
                                      'GERAL', NULL, NULL, NULL );
                        SELECT GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM
              INTO WK_FILMAT, WK_CODMAT, WK_CODCOR, WK_CODTAM
              FROM TT_GRA GRA
             WHERE CODEXT = WK_CODEXT;
            
            IF WK_FILMAT IS NULL THEN
                IF WK_MOTREJ = 'OK' THEN
                    WK_MOTREJ := 'ERRO AO INSERIR CDIGO EAN: PRODUTO NO ENCONTRADO';
                ELSE
                    WK_MOTREJ := WK_MOTREJ;
                END IF;
            ELSE
                IF WK_REFATI = 'F' THEN
                    DELETE FROM TT_EAN
                     WHERE CODEAN = WK_CODEAN;
                ELSE
                    -- Localiza outro item j existente em TT_PRO ou TT_GRA.
                                            SELECT min(CODEXT)
                          INTO WK_CODEXT_EAN
                          FROM TT_GRA
                         WHERE REFPRO = WK_CODEAN;
                        IF WK_CODEXT_EAN IS NULL THEN
                            SELECT min(GRA.CODEXT)
                              INTO WK_CODEXT_EAN
                              FROM TT_PRO PRO INNER JOIN TT_GRA GRA ON PRO.FILMAT = GRA.FILMAT
                                                                   AND PRO.CODMAT = GRA.CODMAT
                             WHERE PRO.REFBAS = WK_CODEAN;
                        END IF;
                    
                    -- No havendo inclui novo TT_EAN.
                    IF WK_CODEXT_EAN IS NULL THEN
                        -- Atualiza Registro TT_PRO para gerao de Carga para o POS
                        BEGIN
                           UPDATE TT_PRO SET ATU_EM = Agora(),
                                             DUMMY = Constante('MANTEM_ATU_EM') -- Pedro E. Braga - 104326 - Marca para no atualizar tabela de preo pois no processo de importao estava causando lentido
                            WHERE FILMAT = WK_FILMAT
                              AND CODMAT = WK_CODMAT;
                        EXCEPTION
                            WHEN OTHERS THEN
                                IF WK_MOTREJ = 'OK' THEN
                                    WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PRODUTO: '||SQLERRM,1,255);
                                ELSE
                                    WK_MOTREJ := WK_MOTREJ;
                                END IF;
                        END;
                        -- Atualiza Registro TT_GRA para gerao de Carga para o POS
                        BEGIN
                           UPDATE TT_GRA SET ATU_EM = Agora(),
                                             DUMMY = Constante('MANTEM_ATU_EM') -- Pedro E. Braga - 104326 - Marca para no atualizar produto pois no processo de importao estava causando lentido
                            WHERE FILMAT = WK_FILMAT
                              AND CODMAT = WK_CODMAT
                              AND CODCOR = WK_CODCOR
                              AND CODTAM = WK_CODTAM;
                        EXCEPTION
                            WHEN OTHERS THEN
                                IF WK_MOTREJ = 'OK' THEN
                                    WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR GRADE: '||SQLERRM,1,255);
                                ELSE
                                    WK_MOTREJ := WK_MOTREJ;
                                END IF;
                        END;
                        
                        BEGIN
                            INSERT INTO TT_EAN(CODEAN, FILMAT, CODMAT, CODCOR, CODTAM, USOEAN, CODFIL, ATU_EM, DUMMY)
                                        VALUES(WK_CODEAN, WK_FILMAT, WK_CODMAT, WK_CODCOR, WK_CODTAM, WK_USOEAN, WK_CODFIL, AGORA(), Constante('MANTEM_ATU_EM'));
                        EXCEPTION
                            WHEN OTHERS THEN
                                IF WK_MOTREJ = 'OK' THEN
                                    WK_MOTREJ := SUBSTR('ERRO AO INSERIR CDIGO EAN: '||SQLERRM,1,255);
                                ELSE
                                    WK_MOTREJ := WK_MOTREJ;
                                END IF;
                        END;
                    ELSE
                        IF WK_MOTREJ = 'OK' THEN
                            WK_MOTREJ := 'ERRO AO INSERIR CDIGO EAN: REFERNCIA J UTILIZADA: CODEXT: '||WK_CODEXT_EAN||'.';
                        ELSE
                            WK_MOTREJ := WK_MOTREJ;
                        END IF;
                    END IF;
                END IF;
            END IF;

            IF NOT WK_MOTREJ = 'OK' THEN
                WK_STATUS := 4;
            ELSE
                WK_STATUS := 3;
            END IF;

            UPDATE TI_EAN SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
             WHERE CODFIL = WK_CODFIL
               AND CODEXT = WK_CODEXT
               AND CODEAN = WK_CODEAN;

                           WK_QTDIMP := WK_QTDIMP + 1;
            
            WK_NUMREG := WK_NUMREG - 1;
                        CLOSE CR_IEAN;
        END LOOP;

        UPDATE TI_EAN
           SET STATUS = CASE WHEN STATUS = 3 THEN
                            1
                        ELSE
                            2
                        END
         WHERE STATUS IN (3,4);

        IF WK_MANTEM = 'F' THEN
            IF WK_DIALIM > 0 THEN
                DELETE FROM TI_EAN
                 WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
                   AND STATUS = 1;
            ELSE
                DELETE FROM TI_EAN
                 WHERE STATUS = 1;
            END IF;
        END IF;

        UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = WK_QTDIMP, CNTIMP = WK_CNTIMP, TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP WHERE TABELA = 'EAN';
        
    ELSE
        RAISE EXCEPTION 'PG-20300 IMPORTAO DE PRODUTOS NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
    END IF;
    
    SELECT COUNT(*) INTO WK_RESTO FROM TI_EAN WHERE STATUS = 0;
    IF WK_RESTO > 0 THEN
        RETURN 'EXISTEM '||WK_RESTO||' REFERNCIAS EAN NO IMPORTADAS';
    ELSE
        RETURN 'OK';
    END IF;
    
END;
$$ language 'plpgsql';





/*-- SEQ 1630 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_ICO () CASCADE;

/*-- SEQ 1631 --*/
CREATE OR REPLACE FUNCTION IMPORTA_ICO ()
RETURNS VARCHAR AS $$
DECLARE


-- Objetivo:
-- 1) Importao da tabela TT_ICO
   WK_CODFIL                     TI_ICO.CODFIL%TYPE;
   WK_NUMNOT                     TI_ICO.NUMNOT%TYPE;
   WK_CODSER                     TI_ICO.CODSER%TYPE;
   WK_CODFOR                     TI_ICO.CODFOR%TYPE;
   WK_NUMITE                     TI_ICO.NUMITE%TYPE;
   WK_BASICM                     TI_ICO.BASICM%TYPE;
   WK_CODCFO                     TI_ICO.CODCFO%TYPE;
   WK_CODMAT                     TI_ICO.CODMAT%TYPE;
   WK_CODMOE                     TI_ICO.CODMOE%TYPE;
   WK_CUSFRE                     TI_ICO.CUSFRE%TYPE;
   WK_FREFIS                     TI_ICO.FREFIS%TYPE;
   WK_ICMITE                     TI_ICO.ICMITE%TYPE;
   WK_IPIITE                     TI_ICO.IPIITE%TYPE;
   WK_VLRIPI                     TI_ICO.VLRIPI%TYPE;
   WK_BASIPI                     TI_ICO.BASIPI%TYPE;
   WK_ISEICM                     TI_ICO.ISEICM%TYPE;
   WK_OUTICM                     TI_ICO.OUTICM%TYPE;
   WK_QTDMOV                     TI_ICO.QTDMOV%TYPE;
   WK_SITMOV                     TI_ICO.SITMOV%TYPE;
   WK_TIPPRO                     TI_ICO.TIPPRO%TYPE;
   WK_UNICOM                     TI_ICO.UNICOM%TYPE;
   WK_UNIVEN                     TI_ICO.UNIVEN%TYPE;
   WK_VALCON                     TI_ICO.VALCON%TYPE;
   WK_VLRICM                     TI_ICO.VLRICM%TYPE;
   WK_VLRMOV                     TI_ICO.VLRMOV%TYPE;
   WK_VLRITE                     TI_ICO.VLRITE%TYPE;
   WK_VLRDES                     TI_ICO.VLRDES%TYPE;
   WK_CODORI                     TI_ICO.CODORI%TYPE;
   WK_CODCST                     TI_ICO.CODCST%TYPE;
   WK_STATUS                     TI_ICO.STATUS%TYPE;
   WK_MOTREJ                     TI_ICO.MOTREJ%TYPE;
   WK_DATIMP                     TI_ICO.DATIMP%TYPE;
   WK_AUX_SEQUEN                 TT_COM.SEQUEN%TYPE;
   WK_AUX_CODMAT                 TT_GRA.CODMAT%TYPE;
   WK_AUX_FILMAT                 TT_GRA.FILMAT%TYPE;
   WK_AUX_CODCOR                 TT_GRA.CODCOR%TYPE;
   WK_AUX_CODTAM                 TT_GRA.CODTAM%TYPE;
   WK_AUX_CODMUL                 TT_ICO.CODMUL%TYPE;
   WK_NROERR                     Numeric;
   WK_QTDIMP                     Numeric;
   WK_MAI_FR                     TT_CFG.MAI_FR%TYPE;
   WK_MAI_TO                     TT_CFG.MAI_TO%TYPE;
   WK_LANEST                     TI_ICO.LANEST%TYPE;
   WK_COM_DATOPE                 TI_ICO.COM_DATOPE%TYPE;
   WK_QTDCOM                     TI_ICO.QTDCOM%TYPE;
   WK_DATANT                     TI_ICO.DATANT%TYPE;
   WK_CUSANT                     TI_ICO.CUSANT%TYPE;
   WK_CUSREP                     TI_ICO.CUSREP%TYPE;
   WK_PERLUC                     TI_ICO.PERLUC%TYPE;
   WK_PREANT                     TI_ICO.PREANT%TYPE;
   WK_PREATU                     TI_ICO.PREATU%TYPE;
   WK_VLRCAL                     TI_ICO.VLRCAL%TYPE;
   WK_EMBORI                     TI_ICO.EMBORI%TYPE;
   WK_EMBQTD                     TI_ICO.EMBQTD%TYPE;
   WK_CODBUS                     TI_ICO.CODBUS%TYPE;
   WK_CODMUL                     TI_ICO.CODMUL%TYPE;
   WK_ORD_CM                     TI_ICO.ORD_CM%TYPE;
   WK_QTD_CM                     TI_ICO.QTD_CM%TYPE;
   WK_DATINC                     TI_ICO.DATINC%TYPE;
   WK_IMPORT                     TT_IED.IMPORT%TYPE;
   WK_MANTEM                     TT_IED.MANTEM%TYPE;
   WK_CNTIMP                     TT_IED.CNTIMP%TYPE;
   WK_COD_CODCFO                 TT_COM.CODCFO%TYPE;
   WK_COD_CODMOE                 TD_MOE.CODTAB%TYPE;
   WK_COD_UNICOM                 TT_ICO.UNICOM%TYPE;
   WK_COD_UNIVEN                 TT_ICO.UNIVEN%TYPE;
   WK_ICMTIP                     TI_ICO.ICMTIP%TYPE;
   WK_DIALIM                     TT_IED.DIALIM%TYPE;
   WK_DATCRI                     TI_ICO.DATCRI%TYPE;
   WK_DESCFO                     TI_ICO.DESCFO%TYPE;
   WK_AUX_COUNT_ICO              TI_ICO.NUMITE%TYPE;
   cATUCUS                       TT_ICO.COM_ATUCUS%TYPE;
   cTIPCCM                       TT_ICO.COM_TIPCCM%TYPE;

   WK_FILPED                     TI_ICO.CODFIL%TYPE;
   WK_NUMPED                     TI_ICO.NUMPED%TYPE;
   WK_ITEPED                     TI_ICO.ITEPED%TYPE;

   WK_QTDPED                     TT_IPE.QTDPED%TYPE;
   WK_QTDPED_OLD                 TT_IPE.QTDPED%TYPE;
   WK_QTDPED_NEW                 TT_IPE.QTDPED%TYPE;
   WK_QTDITE_NEW                 TT_IPE.QTDITE%TYPE;

   WK_QTDITE_IPE                 TT_IPE.QTDITE%TYPE;
   WK_QTDCAN_IPE                 TT_IPE.QTDCAN%TYPE;
   WK_VALCON_IPE                 TT_IPE.VALCON%TYPE;
   WK_VLRITE_IPE                 TT_IPE.VLRITE%TYPE;
   WK_BASICM_IPE                 TT_IPE.BASICM%TYPE;
   WK_VLRICM_IPE                 TT_IPE.VLRICM%TYPE;
   WK_OUTICM_IPE                 TT_IPE.OUTICM%TYPE;
   WK_ISEICM_IPE                 TT_IPE.ISEICM%TYPE;
   WK_VLRDES_IPE                 TT_IPE.VLRDES%TYPE;
   WK_FILENT_IPE                 TT_IPE.FILENT%TYPE;
   WK_CODBUS_IPE                 TT_IPE.CODBUS%TYPE;
   WK_FILMAT_IPE                 TT_IPE.FILMAT%TYPE;
   WK_CODMAT_IPE                 TT_IPE.CODMAT%TYPE;
   WK_CODCOR_IPE                 TT_IPE.CODCOR%TYPE;
   WK_CODTAM_IPE                 TT_IPE.CODTAM%TYPE;
   WK_VLRUNI_IPE                 TT_IPE.VLRUNI%TYPE;
   WK_VLRVEN_IPE                 TT_IPE.VLRVEN%TYPE;
   WK_IPIITE_IPE                 TT_IPE.IPIITE%TYPE;
   WK_ICMITE_IPE                 TT_IPE.ICMITE%TYPE;
   WK_CODMOE_IPE                 TT_IPE.CODMOE%TYPE;
   WK_UNICOM_IPE                 TT_IPE.UNICOM%TYPE;
   WK_UNIVEN_IPE                 TT_IPE.UNIVEN%TYPE;
   WK_CODMUL_IPE                 TT_IPE.CODMUL%TYPE;
   WK_VLREMB_IPE                 TT_IPE.VLREMB%TYPE;
   WK_VLRIPI_IPE                 TT_IPE.VLRIPI%TYPE;
   WK_FILICO_IPE                 TT_IPE.FILICO%TYPE;
   WK_SEQICO_IPE                 TT_IPE.SEQICO%TYPE;
   WK_NUMICO_IPE                 TT_IPE.NUMICO%TYPE;

   WK_SALDO                      TT_IPE.QTDITE%TYPE;
   WK_MAX_NUMITE                 TT_IPE.NUMITE%TYPE;
   WK_MAX_ORDITE                 TT_IPE.ORDITE%TYPE;

   --Almir R Borges 95176
   WK_LOT_CODEXT                 TI_ICO.LOT_CODEXT%TYPE;
   WK_FILLOT                     TT_LOT.CODFIL%TYPE;
   WK_SEQLOT                     TT_LOT.SEQUEN%TYPE;
	
	WK_ALIICMAGR						TI_ICO.ALIICMAGR%TYPE;
	WK_APRBON							TI_ICO.APRBON%TYPE;
	WK_BASCOF							TI_ICO.BASCOF%TYPE;
	WK_BASFCP							TI_ICO.BASFCP%TYPE;
	WK_BASFCP_RET						TI_ICO.BASFCP_RET%TYPE;
	WK_BASFCP_ST						TI_ICO.BASFCP_ST%TYPE;
	WK_BASICMAGR						TI_ICO.BASICMAGR%TYPE;
	WK_BASICMDIF						TI_ICO.BASICMDIF%TYPE;
	WK_BASIPICAL						TI_ICO.BASIPICAL%TYPE;
	WK_BASISS							TI_ICO.BASISS%TYPE;
	WK_BASPIS							TI_ICO.BASPIS%TYPE;
	WK_BASSUB							TI_ICO.BASSUB%TYPE;
	WK_BASSUBDIF						TI_ICO.BASSUBDIF%TYPE;
	WK_BSTFRE							TI_ICO.BSTFRE%TYPE;
	WK_CODBEN							TI_ICO.CODBEN%TYPE;
	WK_CODCSTDIF						TI_ICO.CODCSTDIF%TYPE;
	WK_CODFCI							TI_ICO.CODFCI%TYPE;
	WK_CSTXML							TI_ICO.CSTXML%TYPE;
	WK_ICMITEDIF						TI_ICO.ICMITEDIF%TYPE;
	WK_ICMVEN							TI_ICO.ICMVEN%TYPE;
	WK_ICMVENDIF						TI_ICO.ICMVENDIF%TYPE;
	WK_ICO_BASRET						TI_ICO.ICO_BASRET%TYPE;
	WK_ICO_OUTTAX						TI_ICO.ICO_OUTTAX%TYPE;
	WK_ICO_VLRFRE						TI_ICO.ICO_VLRFRE%TYPE;
	WK_ICO_VLRRET						TI_ICO.ICO_VLRRET%TYPE;
	WK_IPIFRE							TI_ICO.IPIFRE%TYPE;
	WK_IPITRA							TI_ICO.IPITRA%TYPE;
	WK_ISEICMDIF						TI_ICO.ISEICMDIF%TYPE;
	WK_MOTDESON							TI_ICO.MOTDESON%TYPE;
	WK_MVACOM							TI_ICO.MVACOM%TYPE;
	WK_MVACOMDIF						TI_ICO.MVACOMDIF%TYPE;
	WK_NATBCC							TI_ICO.NATBCC%TYPE;
	WK_OUTDES							TI_ICO.OUTDES%TYPE;
	WK_OUTICMDIF						TI_ICO.OUTICMDIF%TYPE;
	WK_PAUTAF							TI_ICO.PAUTAF%TYPE;
	WK_PERCOF							TI_ICO.PERCOF%TYPE;
	WK_PERCRESN							TI_ICO.PERCRESN%TYPE;
	WK_PERDIF							TI_ICO.PERDIF%TYPE;
	WK_PERDIFICM						TI_ICO.PERDIFICM%TYPE;
	WK_PERDIFICMDIF					TI_ICO.PERDIFICMDIF%TYPE;
	WK_PERFCP							TI_ICO.PERFCP%TYPE;
	WK_PERFCP_RET						TI_ICO.PERFCP_RET%TYPE;
	WK_PERFCP_ST						TI_ICO.PERFCP_ST%TYPE;
	WK_PERICMDEV						TI_ICO.PERICMDEV%TYPE;
	WK_PERISS							TI_ICO.PERISS%TYPE;
	WK_PERPIS							TI_ICO.PERPIS%TYPE;
	WK_RED_ST							TI_ICO.RED_ST%TYPE;
	WK_RED_STDIF						TI_ICO.RED_STDIF%TYPE;
	WK_REDITE							TI_ICO.REDITE%TYPE;
	WK_REDITEDIF						TI_ICO.REDITEDIF%TYPE;
	WK_RETSUB							TI_ICO.RETSUB%TYPE;
	WK_SITCOF							TI_ICO.SITCOF%TYPE;
	WK_SITIPI							TI_ICO.SITIPI%TYPE;
	WK_SITPIS							TI_ICO.SITPIS%TYPE;
	WK_ST_FRE							TI_ICO.ST_FRE%TYPE;
	WK_TAXIPICAL						TI_ICO.TAXIPICAL%TYPE;
	WK_VLR_ST							TI_ICO.VLR_ST%TYPE;
	WK_VLR_STDIF						TI_ICO.VLR_STDIF%TYPE;
	WK_VLRCOF							TI_ICO.VLRCOF%TYPE;
	WK_VLRCRESN							TI_ICO.VLRCRESN%TYPE;
	WK_VLRDESON							TI_ICO.VLRDESON%TYPE;
	WK_VLRDIF							TI_ICO.VLRDIF%TYPE;
	WK_VLRDIFICM						TI_ICO.VLRDIFICM%TYPE;
	WK_VLRDIFICMDIF					TI_ICO.VLRDIFICMDIF%TYPE;
	WK_VLRFCP							TI_ICO.VLRFCP%TYPE;
	WK_VLRFCP_RET						TI_ICO.VLRFCP_RET%TYPE;
	WK_VLRFCP_ST						TI_ICO.VLRFCP_ST%TYPE;
	WK_VLRFILDES						TI_ICO.VLRFILDES%TYPE;
	WK_VLRICM_CRE						TI_ICO.VLRICM_CRE%TYPE;
	WK_VLRICM_EST						TI_ICO.VLRICM_EST%TYPE;
	WK_VLRICMAGR						TI_ICO.VLRICMAGR%TYPE;
	WK_VLRICMDEV						TI_ICO.VLRICMDEV%TYPE;
	WK_VLRICMDIF						TI_ICO.VLRICMDIF%TYPE;
	WK_VLRICMOP							TI_ICO.VLRICMOP%TYPE;
	WK_VLRICMOPDIF						TI_ICO.VLRICMOPDIF%TYPE;
	WK_VLRIPICAL						TI_ICO.VLRIPICAL%TYPE;
	WK_VLRISS							TI_ICO.VLRISS%TYPE;
	WK_VLRPIS							TI_ICO.VLRPIS%TYPE;


   
   WK_RESTO                      Numeric;
   WK_NUMREG                     Numeric = 500;
      
   cDUMMY                        VARCHAR(100);

CR_ITEM_COMPRA CURSOR(pDATCRI TI_ICO.DATCRI%TYPE) IS
/*Status => 0 no processado
         => 1 processado com sucesso
         => 2 processado com erro*/
    SELECT *
      FROM (SELECT /*+INDEX(TI_ICO, I_LC_IICO_STATUS)*/
                   CODFIL,NUMNOT,CODSER,CODFOR,NUMITE,BASICM,CODCFO,CODMAT,COALESCE(CODMOE,'R$') AS CODMOE,CUSFRE,
                   FREFIS,ICMITE,IPIITE,VLRIPI,BASIPI,ISEICM,OUTICM,QTDMOV,SITMOV,COALESCE(TIPPRO,'0') AS TIPPRO,COALESCE(UNICOM,'UN') AS UNICOM,COALESCE(UNIVEN,'UN') AS UNIVEN,
                   VALCON,VLRICM,VLRMOV,VLRITE,MOTREJ,DATIMP,LANEST,COM_DATOPE,QTDCOM,DATANT,
                   CUSANT,CUSREP,PERLUC,PREANT,PREATU,VLRCAL,EMBORI,EMBQTD,CODBUS,CODMUL,
                   ORD_CM,QTD_CM,DATINC,ICMTIP,DESCFO,LOT_CODEXT,VLRDES,CODORI,CODCST,
                   NUMPED,ITEPED,ALIICMAGR,APRBON,BASCOF,BASFCP,BASFCP_RET,BASFCP_ST,
						 BASICMAGR,BASICMDIF,BASIPICAL,BASISS,BASPIS,BASSUB,BASSUBDIF,BSTFRE,CODBEN,
						 CODCSTDIF,CODFCI,CSTXML,ICMITEDIF,ICMVEN,ICMVENDIF,ICO_BASRET,
						 ICO_OUTTAX,ICO_VLRFRE,ICO_VLRRET,IPIFRE,IPITRA,ISEICMDIF,MOTDESON,MVACOM,MVACOMDIF,
						 NATBCC,OUTDES,OUTICMDIF,PAUTAF,PERCOF,PERCRESN,PERDIF,PERDIFICM,PERDIFICMDIF,PERFCP,
						 PERFCP_RET,PERFCP_ST,PERICMDEV,PERISS,PERPIS,RED_ST,RED_STDIF,REDITE,REDITEDIF,RETSUB,
						 SITCOF,SITIPI,SITPIS,ST_FRE,TAXIPICAL,VLR_ST,VLR_STDIF,VLRCOF,VLRCRESN,
						 VLRDESON,VLRDIF,VLRDIFICM,VLRDIFICMDIF,VLRFCP,VLRFCP_RET,VLRFCP_ST,VLRFILDES,VLRICM_CRE,VLRICM_EST,
						 VLRICMAGR,VLRICMDEV,VLRICMDIF,VLRICMOP,VLRICMOPDIF,VLRIPICAL,VLRISS,VLRPIS		
              FROM TI_ICO
             WHERE STATUS = 0
               AND DATCRI BETWEEN TRUNC(pDATCRI)
                              AND ADD_DAY(TRUNC(pDATCRI),1)
             ORDER BY DATCRI
           ) TAB
   LIMIT 1;

BEGIN
   -- RFMP 80113
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20016 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

   SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
     INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
     FROM TT_IED
    WHERE TABELA = 'ICO';

   IF WK_IMPORT = 'T' THEN
     WK_CNTIMP := WK_CNTIMP + 1;
     WK_NROERR := 0;
     WK_QTDIMP := 0;

   LOOP
     WK_AUX_SEQUEN := NULL;
     WK_AUX_CODMAT := NULL;
     WK_AUX_FILMAT := NULL;
     WK_AUX_CODCOR := NULL;
     WK_AUX_CODTAM := NULL;
     WK_COD_CODCFO := NULL;
     WK_AUX_CODMUL := NULL;
     WK_COD_CODMOE := NULL;

     SELECT MIN(DATCRI)
       INTO WK_DATCRI
       FROM TI_ICO
      WHERE STATUS = 0;

     OPEN CR_ITEM_COMPRA(WK_DATCRI);
     FETCH CR_ITEM_COMPRA INTO WK_CODFIL,WK_NUMNOT,WK_CODSER,WK_CODFOR,WK_NUMITE,WK_BASICM,
                               WK_CODCFO,WK_CODMAT,WK_CODMOE,WK_CUSFRE,WK_FREFIS,WK_ICMITE,
                               WK_IPIITE,WK_VLRIPI,WK_BASIPI,WK_ISEICM,WK_OUTICM,WK_QTDMOV,WK_SITMOV,WK_TIPPRO,
                               WK_UNICOM,WK_UNIVEN,WK_VALCON,WK_VLRICM,WK_VLRMOV,WK_VLRITE,
                               WK_MOTREJ,WK_DATIMP,WK_LANEST,WK_COM_DATOPE,WK_QTDCOM,WK_DATANT,
                               WK_CUSANT,WK_CUSREP,WK_PERLUC,WK_PREANT,WK_PREATU,WK_VLRCAL,
                               WK_EMBORI,WK_EMBQTD,WK_CODBUS,WK_CODMUL,WK_ORD_CM,WK_QTD_CM,
                               WK_DATINC,WK_ICMTIP,WK_DESCFO,WK_LOT_CODEXT,WK_VLRDES, WK_CODORI,
                               WK_CODCST,WK_NUMPED,WK_ITEPED,WK_ALIICMAGR,WK_APRBON,WK_BASCOF,
										 WK_BASFCP,WK_BASFCP_RET,WK_BASFCP_ST,WK_BASICMAGR,WK_BASICMDIF,WK_BASIPICAL,
										 WK_BASISS,WK_BASPIS,WK_BASSUB,WK_BASSUBDIF,WK_BSTFRE,WK_CODBEN,WK_CODCSTDIF,
										 WK_CODFCI,WK_CSTXML,WK_ICMITEDIF,WK_ICMVEN,WK_ICMVENDIF,
										 WK_ICO_BASRET,WK_ICO_OUTTAX,WK_ICO_VLRFRE,WK_ICO_VLRRET,WK_IPIFRE,WK_IPITRA,
										 WK_ISEICMDIF,WK_MOTDESON,WK_MVACOM,WK_MVACOMDIF,WK_NATBCC,WK_OUTDES,WK_OUTICMDIF,
										 WK_PAUTAF,WK_PERCOF,WK_PERCRESN,WK_PERDIF,WK_PERDIFICM,WK_PERDIFICMDIF,WK_PERFCP,
										 WK_PERFCP_RET,WK_PERFCP_ST,WK_PERICMDEV,WK_PERISS,WK_PERPIS,WK_RED_ST,WK_RED_STDIF,
										 WK_REDITE,WK_REDITEDIF,WK_RETSUB,WK_SITCOF,WK_SITIPI,WK_SITPIS,WK_ST_FRE,
										 WK_TAXIPICAL,WK_VLR_ST,WK_VLR_STDIF,WK_VLRCOF,WK_VLRCRESN,WK_VLRDESON,
										 WK_VLRDIF,WK_VLRDIFICM,WK_VLRDIFICMDIF,WK_VLRFCP,WK_VLRFCP_RET,WK_VLRFCP_ST,WK_VLRFILDES,
										 WK_VLRICM_CRE,WK_VLRICM_EST,WK_VLRICMAGR,WK_VLRICMDEV,WK_VLRICMDIF,WK_VLRICMOP,WK_VLRICMOPDIF,
										 WK_VLRIPICAL,WK_VLRISS,WK_VLRPIS;
     IF NOT FOUND THEN
        CLOSE CR_ITEM_COMPRA;
        EXIT;
     END IF;

     
     IF WK_NUMREG = 0 THEN
        CLOSE CR_ITEM_COMPRA;
        EXIT;
     END IF;
     
     WK_MOTREJ     := 'OK';

     IF WK_CODCFO IS NOT NULL THEN
        WK_COD_CODCFO := IMPORTA_TDS( 'TD_CFO', 'CFOATI', 'CODCFO', 'CODTAB', WK_CODCFO, NULL, NULL, NULL, 'DESCFO', WK_DESCFO );
     END IF;
     IF WK_CODMUL IS NOT NULL THEN
        WK_AUX_CODMUL := IMPORTA_TDS( 'TD_MUL', 'MULATI', 'DESMUL', 'CODTAB', WK_CODMUL, NULL, NULL, NULL );
     ELSE 
        WK_AUX_CODMUL := 0;
     END IF;
     IF WK_CODMOE IS NOT NULL THEN
        WK_COD_CODMOE := IMPORTA_TDS( 'TD_MOE', 'MOEATI', 'DESMOE', 'CODTAB', WK_CODMOE, NULL, NULL, NULL );
     END IF;
     IF WK_UNICOM IS NOT NULL THEN
        WK_COD_UNICOM := IMPORTA_TDS( 'TD_MED', 'MEDATI', 'UNIMED', 'CODTAB', WK_UNICOM, NULL, NULL, NULL );
     END IF;
     IF WK_UNIVEN IS NOT NULL THEN
        WK_COD_UNIVEN := IMPORTA_TDS( 'TD_MED', 'MEDATI', 'UNIMED', 'CODTAB', WK_UNIVEN, NULL, NULL, NULL );
     END IF;

       SELECT C.SEQUEN, C.DATOPE, C.ATUCUS, C.TIPCCM
         INTO WK_AUX_SEQUEN, WK_COM_DATOPE, cATUCUS, cTIPCCM
         FROM TT_COM C
        WHERE C.CODFIL = WK_CODFIL
          AND C.CODSER = CAST(RPAD(TRIM(WK_CODSER), 2, ' ') AS CHAR(2))
          AND C.NUMNOT = LPAD(TRIM(WK_NUMNOT),9, ' ')
          AND C.FLGEST <> 'D'
          AND (C.FILFOR, C.CODFOR) IN (SELECT CLI.FILCLI, CLI.CODCLI
                                         FROM TT_CLI CLI
                                        WHERE TRIM(CLI.CODEXT) = TRIM(WK_CODFOR)
                                        UNION
                                        SELECT ENDE.FILCLI, ENDE.CODCLI
                                         FROM TT_END ENDE
                                        WHERE TRIM(ENDE.NUMDOC) = TRIM(WK_CODFOR));
     -- rfmp - 64042 - 27/08/08
     IF WK_MOTREJ = 'OK' THEN
       IF WK_AUX_SEQUEN IS NULL THEN
         WK_MOTREJ := 'ERRO AO IMPORTAR ITEM DE COMPRA: DOCUMENTO NAO ENCONTRADO';
       END IF;
     END IF;
       SELECT G.CODMAT, G.FILMAT, G.CODCOR, G.CODTAM
         INTO WK_AUX_CODMAT, WK_AUX_FILMAT, WK_AUX_CODCOR, WK_AUX_CODTAM
         FROM TT_GRA G
         WHERE TRIM(G.CODEXT) = TRIM(WK_CODMAT);

-- rfmp - 64042 - 27/08/08
IF WK_MOTREJ = 'OK' THEN
  IF WK_AUX_FILMAT IS NULL THEN
     WK_MOTREJ := 'ERRO ao processar o Item de Compra: Item de Grade no encontrado para o cdigo "' || WK_CODMAT || '".';
  END IF;
END IF;

IF WK_MOTREJ = 'OK' THEN
   IF WK_TIPPRO NOT IN ('0','1','2','3') THEN
      WK_MOTREJ := 'ERRO ao processar o Item de Compra: Tipo Produto no informado ou invlido para o cdigo "' || WK_CODMAT || '".';
   END IF;
END IF;

     /*Almir R Borges 95176
     validar se existe o registro na TT_LOT.*/
          IF (WK_MOTREJ = 'OK') AND (WK_LOT_CODEXT IS NOT NULL) THEN
         SELECT L.CODFIL, L.SEQUEN
         INTO WK_FILLOT, WK_SEQLOT
         FROM TT_LOT L
         WHERE TRIM(L.CODEXT) = TRIM(WK_LOT_CODEXT);
     END IF;
     
     IF WK_MOTREJ = 'OK' THEN
       IF (WK_FILLOT IS NULL) AND (WK_LOT_CODEXT IS NOT NULL) THEN
         WK_MOTREJ := 'ERRO ao processar o Item de Compra: Lote no encontrado para cdigo "' || WK_LOT_CODEXT || '".';
       END IF;
     END IF;

   -- RFMP Verificar se j no existe ICO
     IF WK_MOTREJ = 'OK' THEN
       SELECT COUNT(*)
         INTO WK_AUX_COUNT_ICO
         FROM TT_ICO ICO
        WHERE ICO.CODFIL = WK_CODFIL
          AND ICO.SEQUEN = WK_AUX_SEQUEN
          AND ICO.NUMITE = WK_NUMITE;
     END IF;


     IF WK_MOTREJ = 'OK'
     AND WK_AUX_COUNT_ICO = 0 THEN
       BEGIN
         INSERT INTO TT_ICO (CODFIL,SEQUEN,NUMITE,LANEST,SITMOV,TIPPRO,FILMAT,
                             CODMAT,COM_DATOPE,QTDMOV,VLRMOV,VLRITE,CODMOE,CODCOR,CODTAM,
                             UNICOM,UNIVEN,VALCON,QTDCOM,DATANT,CUSANT,CUSREP,
                             ICMITE,IPIITE,VLRIPI,BASIPI,PERLUC,PREANT,PREATU,VLRCAL,EMBORI,
                             EMBQTD,DUMMY ,CODBUS,CODMUL,CUSFRE,ORD_CM,QTD_CM,
                             /*VLR_CM -> atualizado pela trigger*/CODCFO,BASICM,VLRICM,OUTICM,ISEICM,
                             /*VLRCMG -> atualizado pela trigger*/FREFIS,DATINC,ICMTIP,FILLOT,SEQLOT,
                             VLRDES, CODORI, CODCST, COM_ATUCUS, COM_TIPCCM,
									  ALIICMAGR, APRBON, BASCOF, BASFCP, BASFCP_RET, BASFCP_ST, BASICMAGR, BASICMDIF,
									  BASIPICAL, BASISS, BASPIS, BASSUB, BASSUBDIF, BSTFRE, CODBEN, CODCSTDIF, CODFCI, CSTXML,
									  ICMITEDIF, ICMVEN, ICMVENDIF, ICO_BASRET, ICO_OUTTAX, ICO_VLRFRE, ICO_VLRRET,
									  IPIFRE, IPITRA, ISEICMDIF, MOTDESON, MVACOM, MVACOMDIF, NATBCC, OUTDES, OUTICMDIF, PAUTAF,
									  PERCOF, PERCRESN, PERDIF, PERDIFICM, PERDIFICMDIF, PERFCP, PERFCP_RET, PERFCP_ST, PERICMDEV,
									  PERISS, PERPIS, RED_ST, RED_STDIF, REDITE, REDITEDIF, RETSUB, SITCOF, SITIPI, SITPIS,
									  ST_FRE, TAXIPICAL, VLR_ST, VLR_STDIF, VLRCOF, VLRCRESN, VLRDESON, VLRDIF, VLRDIFICM,
									  VLRDIFICMDIF, VLRFCP, VLRFCP_RET, VLRFCP_ST, VLRFILDES, VLRICM_CRE, VLRICM_EST, VLRICMAGR, VLRICMDEV,
									  VLRICMDIF, VLRICMOP, VLRICMOPDIF, VLRIPICAL, VLRISS, VLRPIS)
                      VALUES(WK_CODFIL,WK_AUX_SEQUEN,WK_NUMITE,WK_LANEST,WK_SITMOV,WK_TIPPRO,WK_AUX_FILMAT,
                             WK_AUX_CODMAT,WK_COM_DATOPE,WK_QTDMOV,WK_VLRMOV,WK_VLRITE,WK_COD_CODMOE,WK_AUX_CODCOR,WK_AUX_CODTAM,
                             WK_COD_UNICOM,WK_COD_UNIVEN,WK_VALCON,WK_QTDCOM,WK_DATANT,WK_CUSANT,WK_CUSREP,
                             WK_ICMITE,WK_IPIITE,WK_VLRIPI,WK_BASIPI,WK_PERLUC,WK_PREANT,WK_PREATU,WK_VLRCAL,WK_EMBORI,
                             WK_EMBQTD,NULL,WK_CODBUS,COALESCE(WK_AUX_CODMUL,0),WK_CUSFRE,WK_ORD_CM,WK_QTD_CM,
                             /*VLR_CM -> atualizado pela trigger*/WK_COD_CODCFO,COALESCE(WK_BASICM,0),COALESCE(WK_VLRICM,0),COALESCE(WK_OUTICM,0),COALESCE(WK_ISEICM,0),
                             /*VLRCMG -> atualizado pela trigger*/WK_FREFIS,COALESCE(WK_DATINC,AGORA()),WK_ICMTIP,WK_FILLOT,WK_SEQLOT,
                             WK_VLRDES, WK_CODORI, WK_CODCST, cATUCUS, cTIPCCM,
									  WK_ALIICMAGR, WK_APRBON, WK_BASCOF, WK_BASFCP, WK_BASFCP_RET, WK_BASFCP_ST, WK_BASICMAGR,
									  COALESCE(WK_BASICMDIF,0), WK_BASIPICAL, WK_BASISS, WK_BASPIS, WK_BASSUB, COALESCE(WK_BASSUBDIF,0), WK_BSTFRE, WK_CODBEN,
									  WK_CODCSTDIF, WK_CODFCI, WK_CSTXML, WK_ICMITEDIF, WK_ICMVEN, WK_ICMVENDIF,
									  COALESCE(WK_ICO_BASRET,0), COALESCE(WK_ICO_OUTTAX,0), COALESCE(WK_ICO_VLRFRE,0), COALESCE(WK_ICO_VLRRET,0), WK_IPIFRE, WK_IPITRA, COALESCE(WK_ISEICMDIF,0), WK_MOTDESON,
									  WK_MVACOM, WK_MVACOMDIF, WK_NATBCC, WK_OUTDES, COALESCE(WK_OUTICMDIF,0), WK_PAUTAF, WK_PERCOF, WK_PERCRESN, WK_PERDIF,
									  WK_PERDIFICM, WK_PERDIFICMDIF, WK_PERFCP, WK_PERFCP_RET, WK_PERFCP_ST, WK_PERICMDEV, WK_PERISS, WK_PERPIS,
									  WK_RED_ST, WK_RED_STDIF, WK_REDITE, WK_REDITEDIF, COALESCE(WK_RETSUB,'F'), WK_SITCOF, WK_SITIPI, WK_SITPIS,
									  WK_ST_FRE, WK_TAXIPICAL, WK_VLR_ST, WK_VLR_STDIF, WK_VLRCOF, WK_VLRCRESN, WK_VLRDESON,
									  WK_VLRDIF, WK_VLRDIFICM, WK_VLRDIFICMDIF, WK_VLRFCP, WK_VLRFCP_RET, WK_VLRFCP_ST, WK_VLRFILDES, WK_VLRICM_CRE,
									  WK_VLRICM_EST, WK_VLRICMAGR, WK_VLRICMDEV, WK_VLRICMDIF, WK_VLRICMOP, WK_VLRICMOPDIF, WK_VLRIPICAL, WK_VLRISS, WK_VLRPIS);
       EXCEPTION
         WHEN OTHERS THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ITEM DE COMPRA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
       END;
     END IF;

     IF (WK_MOTREJ = 'OK') AND (ISNULL(WK_NUMPED) = 'F') AND (WK_ITEPED IS NULL) THEN
        SELECT CODFIL, NUMPED, NUMITE, QTDITE, QTDPED, COALESCE(QTDCAN, 0) AS QTDCAN,
               CASE WHEN VALCON = 0 THEN 1 ELSE VALCON END AS VALCON,
               VLRITE, BASICM, VLRICM, OUTICM, ISEICM, VLRDES,
               FILENT, CODBUS, FILMAT, CODMAT, CODCOR, CODTAM,
               VLRUNI, VLRVEN, IPIITE, ICMITE, CODMOE, UNICOM,
               UNIVEN, CODMUL, VLREMB, VLRIPI,
               FILICO, SEQICO, NUMICO
          INTO WK_FILPED, WK_NUMPED, WK_ITEPED, WK_QTDITE_IPE, WK_QTDPED, WK_QTDCAN_IPE, WK_VALCON_IPE,
               WK_VLRITE_IPE, WK_BASICM_IPE, WK_VLRICM_IPE, WK_OUTICM_IPE, WK_ISEICM_IPE, WK_VLRDES_IPE,
               WK_FILENT_IPE, WK_CODBUS_IPE, WK_FILMAT_IPE, WK_CODMAT_IPE, WK_CODCOR_IPE, WK_CODTAM_IPE,
               WK_VLRUNI_IPE, WK_VLRVEN_IPE, WK_IPIITE_IPE, WK_ICMITE_IPE, WK_CODMOE_IPE, WK_UNICOM_IPE,
               WK_UNIVEN_IPE, WK_CODMUL_IPE, WK_VLREMB_IPE, WK_VLRIPI_IPE,
               WK_FILICO_IPE, WK_SEQICO_IPE, WK_NUMICO_IPE
          FROM TT_IPE
         WHERE CODFIL = WK_CODFIL
           AND NUMPED = WK_NUMPED
           AND NUMITE = WK_ITEPED;

        IF ISNULL(WK_FILPED) = 'T' THEN
           WK_MOTREJ := 'ERRO AO IMPORTAR ITEM DE COMPRA: ITEM DO PEDIDO NAO ENCONTRADO';
        ELSE
           -- Vnculo com compra j est preenchido
           IF ISNULL(WK_SEQICO_IPE) = 'F' THEN
             WK_MOTREJ := 'ERRO AO IMPORTAR ITEM DE COMPRA: ITEM DO PEDIDO INFORMADO J EST VINCULADO A UM ITEM DE COMPRA. ' ||
                          'FILIAL: ' || WK_FILICO_IPE || ' / ' || 'SEQUENCIADOR: ' || WK_SEQICO_IPE || ' / ' ||
                          'ITEM: ' || TO_CHAR(WK_NUMICO_IPE);
           END IF;

           IF WK_MOTREJ = 'OK' THEN
              WK_SALDO := COALESCE(WK_QTDITE_IPE,0) - COALESCE(WK_QTDCAN_IPE,0) - COALESCE(WK_QTDMOV,0);

              -- Se a quantidade da compra  menor que a do item do pedido, faz a "quebra"
              IF WK_SALDO > 0 THEN
                 WK_QTDPED_OLD := WK_QTDPED;
                 WK_QTDITE_NEW := WK_QTDITE_IPE - WK_SALDO;
                 WK_QTDPED_NEW := (WK_QTDITE_NEW / WK_VALCON_IPE);

                 BEGIN
                    -- Atualiza item do pedido atual
                    UPDATE TT_IPE
                       SET FILICO = WK_CODFIL,
                           SEQICO = WK_AUX_SEQUEN,
                           NUMICO = WK_NUMITE,
                           QTDENT = WK_QTDMOV,
                           QTDITE = WK_QTDITE_NEW,
                           QTDPED = WK_QTDPED_NEW,
                           VLRITE = (WK_VLRITE_IPE / WK_QTDPED_OLD) * WK_QTDPED_NEW,
                           BASICM = (WK_BASICM_IPE / WK_QTDPED_OLD) * WK_QTDPED_NEW,
                           VLRICM = (WK_VLRICM_IPE / WK_QTDPED_OLD) * WK_QTDPED_NEW,
                           OUTICM = (WK_OUTICM_IPE / WK_QTDPED_OLD) * WK_QTDPED_NEW,
                           ISEICM = (WK_ISEICM_IPE / WK_QTDPED_OLD) * WK_QTDPED_NEW,
                           VLRDES = (WK_VLRDES_IPE / WK_QTDPED_OLD) * WK_QTDPED_NEW,
                           VLREMB = (WK_VLREMB_IPE / WK_QTDPED_OLD) * WK_QTDPED_NEW,
                           VLRIPI = (WK_VLRIPI_IPE / WK_QTDPED_OLD) * WK_QTDPED_NEW,
                           FLGEST = 'E',
                           ATU_EM = Agora()
                     WHERE CODFIL = WK_CODFIL
                       AND NUMPED = WK_NUMPED
                       AND NUMITE = WK_ITEPED;

                    -- Busca maior NUMITE e ORDITE
                    SELECT MAX(NUMITE) AS NUMITE, MAX(ORDITE) AS ORDITE
                      INTO WK_MAX_NUMITE, WK_MAX_ORDITE
                      FROM TT_IPE
                     WHERE CODFIL = WK_CODFIL
                       AND NUMPED = WK_NUMPED;

                    WK_QTDPED_NEW := (WK_SALDO/WK_VALCON_IPE);

                    -- Insere novo item com a sobra

                    INSERT INTO TT_IPE
                    (
                      CODFIL, NUMPED, NUMITE, ORDITE, FILORI, PEDORI, ITEORI, FILENT, CODBUS, FILMAT, CODMAT, CODCOR, CODTAM,
                      FLGEST, ATU_EM, QTDPED, QTDITE, VALCON, QTDCAN, QTDENT, VLRITE, VLRUNI, VLRVEN, IPIITE, ICMITE, BASICM,
                      VLRICM, OUTICM, ISEICM, CODMOE, UNICOM, UNIVEN, CODMUL, VLRDES, VLREMB, VLRIPI
                    )
                    VALUES
                    (
                      WK_CODFIL, WK_NUMPED, (WK_MAX_NUMITE+1), (WK_MAX_ORDITE+1), WK_CODFIL, WK_NUMPED, WK_ITEPED, WK_FILENT_IPE, WK_CODBUS_IPE,
                      WK_FILMAT_IPE, WK_CODMAT_IPE, WK_CODCOR_IPE, WK_CODTAM_IPE,
                      CAST('A' AS CHAR(1)), Agora(), WK_QTDPED_NEW, WK_SALDO, WK_VALCON_IPE, 0, 0,
                      (WK_VLRITE_IPE/WK_QTDPED) * WK_QTDPED_NEW,
                      WK_VLRUNI_IPE, WK_VLRVEN_IPE, WK_IPIITE_IPE, WK_ICMITE_IPE,
                      (WK_BASICM_IPE/WK_QTDPED) * WK_QTDPED_NEW,
                      (WK_BASICM_IPE/WK_QTDPED) * WK_QTDPED_NEW * (WK_ICMITE_IPE/100),
                      (WK_OUTICM_IPE/WK_QTDPED) * WK_QTDPED_NEW,
                      (WK_ISEICM_IPE/WK_QTDPED) * WK_QTDPED_NEW,
                      WK_CODMOE_IPE, WK_UNICOM_IPE, WK_UNIVEN_IPE, WK_CODMUL_IPE,
                      (WK_VLRDES_IPE/WK_QTDPED) * WK_QTDPED_NEW,
                      (WK_VLREMB_IPE/WK_QTDPED) * WK_QTDPED_NEW,
                      (WK_VLRIPI_IPE/WK_QTDPED) * WK_QTDPED_NEW
                    );
                 EXCEPTION
                    WHEN OTHERS THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO VINCULAR ITEM DE COMPRA COM PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                 END;
              ELSE
                 BEGIN
                    -- Vnculo sem sobras
                    UPDATE TT_IPE
                       SET FILICO = WK_CODFIL,
                           SEQICO = WK_AUX_SEQUEN,
                           NUMICO = WK_NUMITE,
                           QTDENT = WK_QTDMOV,
                           FLGEST = 'E',
                           ATU_EM = Agora()
                     WHERE CODFIL = WK_CODFIL
                       AND NUMPED = WK_NUMPED
                       AND NUMITE = WK_ITEPED;
                 EXCEPTION
                    WHEN OTHERS THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO VINCULAR ITEM DE COMPRA COM PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                 END;
              END IF;

              -- Atualiza status do Pedido de Compra
              UPDATE TT_PED
                 SET FLGEST = 'Y'
               WHERE CODFIL = WK_CODFIL
                 AND NUMPED = WK_NUMPED;
           END IF; -- MOTREJ


        END IF;
     END IF;
     
     -- Realiza custo de reposio quando indicado na operao
     IF (WK_MOTREJ = 'OK') AND (COALESCE(cATUCUS, 'F') = 'T') THEN
        cDUMMY := UPDGRAICO(WK_CODFIL,WK_AUX_SEQUEN,WK_NUMITE);
     END IF;

       IF NOT WK_MOTREJ = 'OK' THEN
          WK_STATUS := 4;
          WK_NROERR := WK_NROERR + 1;
       ELSE
          WK_STATUS := 3;
       END IF;

       UPDATE TI_ICO
          SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
        WHERE CODFIL = WK_CODFIL
          AND CODSER = WK_CODSER
          AND CODFOR = WK_CODFOR
          AND NUMNOT = WK_NUMNOT
          AND NUMITE = WK_NUMITE
          AND DATIMP IS NULL;

        WK_QTDIMP := WK_QTDIMP + 1;
  
        WK_NUMREG := WK_NUMREG - 1;
          CLOSE CR_ITEM_COMPRA;
   END LOOP;

     IF WK_NROERR <> 0 THEN
        SELECT MAI_FR, MAI_TO
          INTO WK_MAI_FR, WK_MAI_TO
          FROM TT_CFG;
        IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
           INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO,
                               TEXTOS,TIPMSG)
                       VALUES ('001','F',AGORA(),'IMPORTAO ITENS DE COMPRAS',WK_MAI_FR, WK_MAI_TO,
                               'Problema na importao de '||wk_nroerr||' itens de compras. Verifique!','T');
        END IF;
     END IF;

     UPDATE TI_ICO SET STATUS = CASE WHEN STATUS = 3
                                     THEN 1
                                     ELSE 2
                                 END
      WHERE STATUS IN (3,4);


     IF WK_MANTEM = 'F' THEN
        IF WK_DIALIM > 0 THEN
           DELETE FROM TI_ICO
            WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
			  AND STATUS = 1;
        ELSE
           DELETE FROM TI_ICO
		    WHERE STATUS = 1;
        END IF;
     END IF;

     UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = WK_QTDIMP, CNTIMP = WK_CNTIMP, TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP WHERE TABELA = 'ICO';
   ELSE RAISE EXCEPTION 'PG-20001 IMPORTAO DE ITENS DE COMPRA NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;
   
   SELECT COUNT(*) INTO WK_RESTO FROM TI_ICO WHERE STATUS = 0;
   IF WK_RESTO > 0 THEN
     RETURN 'EXISTEM '||WK_RESTO||' ITENS DE COMPRA NO IMPORTADOS';
   ELSE
     RETURN 'OK';
   END IF;
   
END;
$$ language 'plpgsql';





/*-- SEQ 1632 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_IMU () CASCADE;

/*-- SEQ 1633 --*/
CREATE OR REPLACE FUNCTION IMPORTA_IMU ()
RETURNS VARCHAR AS $$
DECLARE

-- Objetivo:
-- 1)Importação da tabela (TT_IMU)

-- Declaração de variáveis e cursores
   WK_IDIIMU                     TI_IMU.ID_IIMU%TYPE; 
   WK_CODEXT                     TI_IMU.CODEXT%TYPE;
   WK_RESISS                     TI_IMU.RESISS%TYPE;
   WK_SITTRI                     TI_IMU.SITTRI%TYPE;
   WK_CODIBG                     TI_IMU.CODIBG%TYPE;
   WK_EXIISS                     TI_IMU.EXIISS%TYPE;
   WK_DESRPS                     TI_IMU.DESRPS%TYPE;
   WK_NATNFS                     TI_IMU.NATNFS%TYPE;
   WK_TRINFS                     TI_IMU.TRINFS%TYPE;
   WK_CODSRV                     TI_IMU.CODSRV%TYPE;
   WK_DESSRV                     TI_IMU.DESSRV%TYPE; 
   WK_DATCRI                     TI_IMU.DATCRI%TYPE;
   WK_STATUS                     TI_IMU.STATUS%TYPE;
   WK_MOTREJ                     TI_IMU.MOTREJ%TYPE; 
   WK_DATIMP                     TI_IMU.DATIMP%TYPE; 

-- TT_IED
   WK_IMPORT                     TT_IED.IMPORT%TYPE;
   WK_MANTEM                     TT_IED.MANTEM%TYPE;
   WK_CNTIMP                     TT_IED.CNTIMP%TYPE;
   WK_DIALIM                     TT_IED.DIALIM%TYPE;
   
-- TD_ISS
   WK_COD_ISS                    TD_ISS.CODTAB%TYPE;
   
-- Outros
   WK_CODCID                     TD_FIL.CODCID%TYPE;
   WK_FILMAT                     TT_PRO.FILMAT%TYPE;
   WK_CODMAT                     TT_PRO.CODMAT%TYPE;

   WK_MAI_FR                     TT_CFG.MAI_FR%TYPE;
   WK_MAI_TO                     TT_CFG.MAI_TO%TYPE;
   WK_SAC_E_MAIL                 TT_CFG.SAC_E_MAIL%TYPE;

   WK_QTDIMP                     Numeric;
   WK_NROERR                     Numeric;
   WK_MUNICIPIO                  Numeric;
   
   WK_RESTO                      Numeric;
   WK_NUMREG                     Numeric = 500;
   cDUMMY                        VARCHAR(100);

   CR_IMPMUN CURSOR(pDATCRI TI_IMU.DATCRI%TYPE) IS
     SELECT *
       FROM (SELECT IIMU.ID_IIMU, IIMU.CODEXT, IIMU.RESISS, IIMU.SITTRI, IIMU.CODIBG, IIMU.EXIISS, IIMU.DESRPS, IIMU.NATNFS,
                    IIMU.TRINFS, IIMU.CODSRV, IIMU.DESSRV, IIMU.DATCRI, IIMU.MOTREJ, IIMU.DATIMP, GRA.FILMAT, GRA.CODMAT
               FROM TI_IMU IIMU
               LEFT JOIN TT_GRA GRA ON (GRA.CODEXT = IIMU.CODEXT)
              WHERE IIMU.STATUS = 0
                AND IIMU.DATCRI BETWEEN TRUNC(pDATCRI)
                                    AND ADD_DAY(TRUNC(pDATCRI),1)) TAB
      
      LIMIT 1;
   
-- Início da procedure
BEGIN
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e não existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20015 Execução de fora do sistema não permitida. Utilize a tela de Integração do Totali Backoffice ou o Totali Import.';
   END IF;

         SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
        INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
        FROM TT_IED
       WHERE TABELA = 'IMU';
   
   IF WK_IMPORT <> 'T' THEN
      RAISE EXCEPTION 'PG-20001 IMPORTAÇÃO DE IMPOSTOS MUNICIPAIS NÃO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;

   WK_CNTIMP := WK_CNTIMP + 1;
   WK_QTDIMP := 0;

   LOOP
      -- Busca a data do primeiro lançamento a ser processado
      SELECT MIN(DATCRI)
        INTO WK_DATCRI
        FROM TI_IMU
       WHERE STATUS = 0;

      -- Abre Tabela para processamento
      OPEN CR_IMPMUN(WK_DATCRI);
      FETCH CR_IMPMUN INTO WK_IDIIMU, WK_CODEXT, WK_RESISS, WK_SITTRI, WK_CODIBG, WK_EXIISS, WK_DESRPS, WK_NATNFS,
                           WK_TRINFS, WK_CODSRV, WK_DESSRV, WK_DATCRI, WK_MOTREJ, WK_DATIMP, WK_FILMAT, WK_CODMAT;

      IF NOT FOUND THEN
         CLOSE CR_IMPMUN;
         EXIT;
      END IF;

      -- Caso tenha atingindo o número de importações por lote fecha processamento
      
      IF WK_NUMREG = 0 THEN
         CLOSE CR_IMPMUN;
         EXIT;
      END IF;
      
      WK_MOTREJ := 'OK';

      -- Realiza Pré-Validações
      IF WK_CODIBG IS NULL THEN
         WK_MOTREJ := 'O Código IBGE do município não foi informado';
      END IF;

      IF WK_MOTREJ = 'OK' THEN
         IF WK_RESISS IS NULL THEN
            WK_MOTREJ := 'Alíquota de ISS não foi definida';
         END IF;
      END IF;

      IF WK_MOTREJ = 'OK' THEN
         IF (WK_CODEXT IS NULL) THEN
            WK_MOTREJ := 'Código Externo não foi definido';
         ELSE
            IF (WK_FILMAT IS NULL) OR (WK_CODMAT IS NULL) THEN
               WK_MOTREJ := 'Não encontrou produto com o código externo: %' || 'WK_CODEXT';
            END IF;
         END IF;
      END IF;

      IF WK_MOTREJ = 'OK' THEN
         IF (WK_SITTRI IS NOT NULL) AND (WK_SITTRI NOT IN ('N','R','S','I')) THEN
            WK_MOTREJ := 'ERRO AO VERIFICAR OS IMPOSTOS MUNICIPAIS: "Código de Tributação do ISSQN" INVÁLIDO.';
         END IF;
      END IF;

      IF WK_MOTREJ = 'OK' THEN
         IF (WK_EXIISS IS NOT NULL) AND (WK_EXIISS NOT IN (0,1,2,3,4,5,6,7)) THEN
            WK_MOTREJ := 'ERRO AO VERIFICAR OS IMPOSTOS MUNICIPAIS: "Exigibilidade ISS para NFSe" INVÁLIDO.';
         END IF;
      END IF;

      IF WK_MOTREJ = 'OK' THEN
         IF (WK_NATNFS IS NOT NULL) AND (WK_NATNFS NOT IN (0,1,2,3,4)) THEN
            WK_MOTREJ := 'ERRO AO VERIFICAR OS IMPOSTOS MUNICIPAIS: "Natureza ou Operação da NFSe" INVÁLIDO.';
         END IF;
      END IF;

      IF WK_MOTREJ = 'OK' THEN
         IF (WK_TRINFS IS NOT NULL) AND (WK_TRINFS NOT IN (0,1,2,3,4,5,6,7,8)) THEN
            WK_MOTREJ := 'ERRO AO VERIFICAR OS IMPOSTOS MUNICIPAIS: "Tipo de Tributação" INVÁLIDO.';
         END IF;
      END IF;

      -- Realiza Inclusão da Aliquota de ISS caso não encontrada
      IF (WK_MOTREJ = 'OK') THEN
         IF WK_RESISS IS NOT NULL THEN
            WK_COD_ISS := IMPORTA_TDS('TD_ISS', 'ISSATI', 'RESISS', 'CODTAB', TO_CHAR(WK_RESISS), NULL, NULL, NULL );
         END IF;
      END IF;

      -- Valida se Município está definido para alguma filial
      BEGIN
         SELECT MIN(FIL.CODCID) AS CIDADE
           INTO WK_CODCID
           FROM TT_MUN MUN 
          INNER JOIN TD_FIL FIL ON MUN.CODIGO = FIL.CODCID
          WHERE MUN.CODIBG = WK_CODIBG;
      EXCEPTION
                  
         WHEN others THEN WK_MOTREJ := 'Não existe municipio cadastrado para o código IBGE: '|| TO_CHAR(WK_CODIBG);
               END;

      IF WK_CODCID IS NULL THEN
         IF WK_MOTREJ = 'OK' THEN 
            WK_MOTREJ := SUBSTR('NÃO ENCONTROU FILIAL CADASTRADA PARA O CÓDIGO DE IBGE: '|| TO_CHAR(WK_CODIBG),1,255); 
         END IF;
      END IF;

      -- Realiza processo de Inclusão/Alteração
      IF WK_MOTREJ = 'OK' THEN 
         IF (WK_FILMAT IS NOT NULL) AND (WK_CODMAT IS NOT NULL) THEN 
            BEGIN
               SELECT COUNT(IMU.CODMAT)
                 INTO WK_MUNICIPIO
                 FROM TT_IMU IMU 
                WHERE IMU.CODCID = WK_CODCID 
                  AND IMU.FILMAT = WK_FILMAT
                  AND IMU.CODMAT = WK_CODMAT;
            EXCEPTION
                              
               WHEN others THEN WK_MUNICIPIO := NULL;
                           END;   
         END IF;
         
         IF WK_MUNICIPIO > 0 THEN
            BEGIN
               UPDATE TT_IMU
                  SET RESISS = WK_COD_ISS,
                      ATU_EM = AGORA(),
                      SITTRI = COALESCE(WK_SITTRI, 'N'),
                      CODIBG = WK_CODIBG,
                      EXIISS = WK_EXIISS,
                      NATNFS = WK_NATNFS,
                      TRINFS = WK_TRINFS,
                      DESRPS = WK_DESRPS, 
                      CODSRV = WK_CODSRV,
                      DESSRV = WK_DESSRV
                WHERE CODCID = WK_CODCID
                  AND FILMAT = WK_FILMAT
                  AND CODMAT = WK_CODMAT;
            EXCEPTION
               
               WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TABELA DE IMPOSTOS MUNICIPAIS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TABELA DE IMPOSTOS MUNICIPAIS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TABELA DE IMPOSTOS MUNICIPAIS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TABELA DE IMPOSTOS MUNICIPAIS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TABELA DE IMPOSTOS MUNICIPAIS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TABELA DE IMPOSTOS MUNICIPAIS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TABELA DE PREÇOS DO TABELA DE IMPOSTOS MUNICIPAIS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                          END;
         ELSE
            BEGIN
               INSERT INTO TT_IMU (FILMAT, CODMAT, CODCID, RESISS, ATU_EM, SITTRI, 
                                   CODIBG, EXIISS, NATNFS, TRINFS, DESRPS, CODSRV, DESSRV)
                           VALUES (WK_FILMAT, WK_CODMAT, WK_CODCID, WK_COD_ISS, AGORA(), COALESCE(WK_SITTRI, 'N'), 
                                   WK_CODIBG, WK_EXIISS, WK_NATNFS, WK_TRINFS, WK_DESRPS, WK_CODSRV, WK_DESSRV);
            EXCEPTION
               
               WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR IMPOSTOS MUNICIPAIS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR IMPOSTOS MUNICIPAIS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR IMPOSTOS MUNICIPAIS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR IMPOSTOS MUNICIPAIS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR IMPOSTOS MUNICIPAIS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR IMPOSTOS MUNICIPAIS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR IMPOSTOS MUNICIPAIS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                          END;
         END IF;
      END IF;

      -- Verifica e marca registros com erros
      IF NOT WK_MOTREJ = 'OK' THEN
         WK_STATUS := 4;
         WK_NROERR := WK_NROERR + 1;
      ELSE
         WK_STATUS := 3;
      END IF;

      -- Marca registros importados
      UPDATE TI_IMU
         SET STATUS = WK_STATUS,
             DATIMP = AGORA(),
             MOTREJ = WK_MOTREJ
       WHERE ID_IIMU = WK_IDIIMU
         AND DATIMP IS NULL;

      
      WK_QTDIMP := WK_QTDIMP + 1;

      
      WK_NUMREG := WK_NUMREG - 1;
            CLOSE CR_IMPMUN;
   END LOOP;

   IF WK_NROERR <> 0 THEN

      SELECT MAI_FR, MAI_TO, SAC_E_MAIL
        INTO WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL
        FROM TT_CFG;
      IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
         INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO,MAI_CC,
                             TEXTOS,TIPMSG)
                     VALUES ('001','F',AGORA(),'IMPORTAÇÃO DE IMPOSTOS MUNICIPAIS',WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL,
                             'Problema na importação de '||wk_nroerr||' impostos municipais . Verifique!','T');
      END IF;
   END IF;

   -- Marca registros como importados
   UPDATE TI_IMU
      SET STATUS = CASE WHEN STATUS = 3
                        THEN 1
                        ELSE 2
                   END
    WHERE STATUS IN (3,4);

    -- Realiza tratamento para exlusão de registros após processamento quando configurado
   IF WK_MANTEM = 'F' THEN
      IF WK_DIALIM > 0 THEN
         DELETE FROM TI_IMU
          WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
            AND STATUS = 1;
      ELSE
         DELETE FROM TI_IMU
          WHERE STATUS = 1;
      END IF;
   END IF;

   -- Atualiza informações da última integração na tabela de controle
   UPDATE TT_IED
      SET ULTIMP = AGORA(),
          QTDIMP = WK_QTDIMP,
          CNTIMP = WK_CNTIMP,
          TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP
    WHERE TABELA = 'IMU';

   
   
   IF WK_NUMREG=0 THEN

      SELECT COUNT(*)
        INTO WK_RESTO
        FROM TI_IMU
       WHERE STATUS = 0;

      IF WK_RESTO > 0 THEN
         RETURN 'EXISTEM '||WK_RESTO||' IMPOSTOS MUNICIPAIS AINDA NÃO IMPORTADOS. EXECUTE NOVAMENTE.';
      END IF;
   END IF;

   SELECT COUNT(*)
     INTO WK_RESTO
     FROM TI_IMU
    WHERE STATUS = 2;

   IF WK_RESTO > 0 THEN
      RETURN 'EXISTEM '||WK_RESTO||' IMPOSTOS MUNICIPAIS NÃO IMPORTADOS VERIFIQUE';
   ELSE
      RETURN 'OK';
   END IF;
   
END;
$$ language 'plpgsql';





/*-- SEQ 1634 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_IVE () CASCADE;

/*-- SEQ 1635 --*/
CREATE OR REPLACE FUNCTION IMPORTA_IVE ()
RETURNS VARCHAR AS $$
DECLARE


-- Objetivo:
-- 1) Importao da tabela TT_IVE
WK_CODFIL     TI_IVE.CODFIL%TYPE;
WK_NUMNOT     TI_IVE.NUMNOT%TYPE;
WK_NUMECF     TI_IVE.NUMECF%TYPE;
WK_CODSER     TI_IVE.CODSER%TYPE;
WK_NUMITE     TI_IVE.NUMITE%TYPE;
WK_LANEST     TI_IVE.LANEST%TYPE;
WK_CODMAT     TI_IVE.CODMAT%TYPE;
WK_VEN_DATHOR TI_IVE.VEN_DATHOR%TYPE;
WK_QTDMOV     TI_IVE.QTDMOV%TYPE;
WK_VLRMOV     TI_IVE.VLRMOV%TYPE;
WK_ICMTIP     TI_IVE.ICMTIP%TYPE;
WK_SITMOV     TI_IVE.SITMOV%TYPE;
WK_TIP001     TI_IVE.TIP001%TYPE;
WK_PERICM     TI_IVE.PERICM%TYPE;
WK_VLRICM     TI_IVE.VLRICM%TYPE;
WK_PERIPI     TI_IVE.PERIPI%TYPE;
WK_VLRIPI     TI_IVE.VLRIPI%TYPE;
WK_TAXISS     TI_IVE.TAXISS%TYPE;
WK_VLRISS     TI_IVE.VLRISS%TYPE;
WK_TAXIRR     TI_IVE.TAXIRR%TYPE;
WK_VLRIRR     TI_IVE.VLRIRR%TYPE;
WK_NATFIS     TI_IVE.NATFIS%TYPE;
WK_TIPPRO     TI_IVE.TIPPRO%TYPE;
WK_VINCUL     TI_IVE.VINCUL%TYPE;
WK_SITKIT     TI_IVE.SITKIT%TYPE;
WK_EMBORI     TI_IVE.EMBORI%TYPE;
WK_REDITE     TI_IVE.REDITE%TYPE;
WK_EMBQTD     TI_IVE.EMBQTD%TYPE;
WK_NUMEXT     TI_IVE.NUMEXT%TYPE;
WK_COMISS     TI_IVE.COMISS%TYPE;
WK_EXPORT     TI_IVE.EXPORT%TYPE;
WK_CODMUL     TI_IVE.CODMUL%TYPE;
WK_ORD_CM     TI_IVE.ORD_CM%TYPE;
WK_QTD_CM     TI_IVE.QTD_CM%TYPE;
WK_CODVDD     TI_IVE.CODVDD%TYPE;
WK_FILBIC     TI_IVE.FILBIC%TYPE;
WK_SEQFIL     TI_IVE.SEQFIL%TYPE;
WK_DATINC     TI_IVE.DATINC%TYPE;
WK_STATUS     TI_IVE.STATUS%TYPE;
WK_MOTREJ     TI_IVE.MOTREJ%TYPE;
WK_DATIMP     TI_IVE.DATIMP%TYPE;
WK_DIALIM     TT_IED.DIALIM%TYPE;
WK_NROERR     Numeric;
WK_QTDIMP     Numeric;
WK_IMPORT     TT_IED.IMPORT%TYPE;
WK_MANTEM     TT_IED.MANTEM%TYPE;
WK_CNTIMP     TT_IED.CNTIMP%TYPE;
WK_MAI_FR     TT_CFG.MAI_FR%TYPE;
WK_MAI_TO     TT_CFG.MAI_TO%TYPE;
WK_AUX_SEQUEN TT_VEN.SEQUEN%TYPE;
WK_AUX_CODMAT TT_GRA.CODMAT%TYPE;
WK_AUX_FILMAT TT_GRA.FILMAT%TYPE;
WK_AUX_CODCOR TT_GRA.CODCOR%TYPE;
WK_AUX_CODTAM TT_GRA.CODTAM%TYPE;
WK_AUX_CODVDD TT_IVE.CODVDD%TYPE;
WK_AUX_FILVDD TT_IVE.FILVDD%TYPE;
WK_COD_CODMUL TT_IVE.CODMUL%TYPE;
WK_COD_SITTRI TT_IVE.SITTRI%TYPE;
WK_FILORI TI_IVE.FILORI%TYPE;
WK_ECFORI TI_IVE.ECFORI%TYPE;
WK_NOTORI TI_IVE.NOTORI%TYPE;
WK_SERORI TI_IVE.SERORI%TYPE;
WK_ITEORI TI_IVE.ITEORI%TYPE;
WK_AUX_FILORI TT_IVE.FILORI%TYPE;
WK_AUX_NUMORI TT_IVE.NUMORI%TYPE;
WK_AUX_ITEORI TT_IVE.ITEORI%TYPE;
WK_DATCRI     TI_IVE.DATCRI%TYPE;

WK_VLRDES    TI_IVE.VLRDES%TYPE;
WK_CALSUB    TI_IVE.CALSUB%TYPE;
WK_SITTRI     TI_IVE.SITTRI%TYPE;
WK_AUX_SITTRI TI_IVE.SITTRI%TYPE;
WK_DEVVIN    TI_IVE.DEVVIN%TYPE;
WK_FILRCT    TI_IVE.FILRCT%TYPE;
WK_SEQRCT    TT_IVE.SEQRCT%TYPE;
WK_NUMRCT    TI_IVE.NUMRCT%TYPE;
WK_DATRCT    TI_IVE.DATRCT%TYPE;
WK_NOMPAC    TI_IVE.NOMPAC%TYPE;
WK_RG_PAC    TI_IVE.RG_PAC%TYPE;

WK_QTDPRE    TI_IVE.QTDPRE%TYPE;
WK_CODCRM    TI_IVE.CODCRM%TYPE;
WK_FILDOU    TI_IVE.FILDOU%TYPE;
WK_NOMDOU    TI_IVE.NOMDOU%TYPE;
WK_UF_CRM    TI_IVE.UF_CRM%TYPE;
WK_BASICM    TI_IVE.BASICM%TYPE;
WK_QTDFUT    TI_IVE.QTDFUT%TYPE;
WK_QTDPEN    TI_IVE.QTDPEN%TYPE;
WK_FLGFUT    TI_IVE.FLGFUT%TYPE;
WK_SEQDOU    TT_IVE.SEQDOU%TYPE;
WK_VLRUNI    TI_IVE.VLRUNI%TYPE;

--Almir R Borges 95176
WK_LOT_CODEXT TI_IVE.LOT_CODEXT%TYPE;
WK_FILLOT     TT_LOT.CODFIL%TYPE;   
WK_SEQLOT     TT_LOT.SEQUEN%TYPE;

WK_RESTO      Numeric;
WK_NUMREG     Numeric = 500;

CR_ITEM CURSOR(pDATCRI TI_IVE.DATCRI%TYPE) IS
--Status => 0 no processado
--       => 1 processado com sucesso
--       => 2 processado com erro
  SELECT * FROM (
                 SELECT /*+INDEX(TI_IVE, I_LC_IIVE_STATUS)*/
                        CODFIL,NUMNOT,NUMECF,CODSER,NUMITE,LANEST,CODMAT,VEN_DATHOR,QTDMOV,VLRMOV,
                        ICMTIP,SITMOV,TIP001,PERICM,VLRICM,PERIPI,VLRIPI,TAXISS,VLRISS,TAXIRR,
                        VLRIRR,NATFIS,MOTREJ,DATIMP,TIPPRO,VINCUL,SITKIT,EMBORI,
                        REDITE,EMBQTD,NUMEXT,COMISS,EXPORT,CODMUL,ORD_CM,QTD_CM,
                        CODVDD,FILBIC,SEQFIL,DATINC,FILORI,ECFORI,NOTORI,SERORI,ITEORI,
                        VLRDES,CALSUB,SITTRI,DEVVIN,FILRCT,NUMRCT,DATRCT,NOMPAC,RG_PAC,QTDPRE,
                        CODCRM,FILDOU,NOMDOU,UF_CRM,BASICM,QTDFUT,QTDPEN,FLGFUT,VLRUNI,LOT_CODEXT
                  FROM TI_IVE
                 WHERE STATUS = 0
                   AND DATCRI BETWEEN TRUNC(pDATCRI)
                                  AND ADD_DAY(TRUNC(pDATCRI),1)
                 ORDER BY DATCRI
                ) TAB
   LIMIT 1;
BEGIN
   -- RFMP 80113
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20014 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

   SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
     INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
     FROM TT_IED
    WHERE TABELA = 'IVE';

   IF WK_IMPORT = 'T' THEN
     WK_CNTIMP := WK_CNTIMP + 1;
     WK_NROERR := 0;
     WK_QTDIMP := 0;
     LOOP
       WK_AUX_CODMAT := NULL;
       WK_AUX_FILMAT := NULL;
       WK_AUX_CODCOR := NULL;
       WK_AUX_CODTAM := NULL;
       WK_AUX_CODVDD := NULL;
       WK_AUX_FILVDD := NULL;
       WK_COD_CODMUL := NULL;
       WK_SEQDOU     := NULL;

       SELECT MIN(DATCRI)
         INTO WK_DATCRI
         FROM TI_IVE
        WHERE STATUS = 0;

       OPEN CR_ITEM(WK_DATCRI);
       FETCH CR_ITEM INTO WK_CODFIL,WK_NUMNOT,WK_NUMECF,WK_CODSER,WK_NUMITE,WK_LANEST,WK_CODMAT,WK_VEN_DATHOR,WK_QTDMOV,WK_VLRMOV,
                          WK_ICMTIP,WK_SITMOV,WK_TIP001,WK_PERICM,WK_VLRICM,WK_PERIPI,WK_VLRIPI,WK_TAXISS,WK_VLRISS,WK_TAXIRR,
                          WK_VLRIRR,WK_NATFIS,WK_MOTREJ,WK_DATIMP,WK_TIPPRO,WK_VINCUL,WK_SITKIT,WK_EMBORI,
                          WK_REDITE,WK_EMBQTD,WK_NUMEXT,WK_COMISS,WK_EXPORT,WK_CODMUL,WK_ORD_CM,WK_QTD_CM,
                          WK_CODVDD,WK_FILBIC,WK_SEQFIL,WK_DATINC,WK_FILORI,WK_ECFORI,WK_NOTORI,WK_SERORI,WK_ITEORI,
                          WK_VLRDES,WK_CALSUB,WK_SITTRI,WK_DEVVIN,WK_FILRCT,WK_NUMRCT,WK_DATRCT,WK_NOMPAC,WK_RG_PAC,WK_QTDPRE,
                          WK_CODCRM,WK_FILDOU,WK_NOMDOU,WK_UF_CRM,WK_BASICM,WK_QTDFUT,WK_QTDPEN,WK_FLGFUT,WK_VLRUNI,WK_LOT_CODEXT;

       IF NOT FOUND THEN
          CLOSE CR_ITEM;
          EXIT;
       END IF;

       
       IF WK_NUMREG = 0 THEN
          CLOSE CR_ITEM;
          EXIT;
       END IF;
       
       WK_MOTREJ     := 'OK';

       IF WK_CODMUL IS NOT NULL THEN
          WK_COD_CODMUL := IMPORTA_TDS( 'TD_MUL', 'MULATI', 'DESMUL', 'CODTAB', WK_CODMUL, NULL, NULL, NULL );
       ELSE 
          WK_COD_CODMUL := 0;
       END IF;

       IF (WK_SITTRI IS NOT NULL) AND (WK_SITTRI <> WK_AUX_SITTRI) THEN
          WK_COD_SITTRI := IMPORTA_TDS( 'TD_TRI', 'TRIATI', 'CODTRI', 'CODTAB', TRIM(WK_SITTRI), NULL, NULL, NULL );
          WK_AUX_SITTRI := WK_SITTRI;
       END IF;
         SELECT G.CODMAT, G.FILMAT, G.CODCOR, G.CODTAM
         INTO WK_AUX_CODMAT, WK_AUX_FILMAT, WK_AUX_CODCOR, WK_AUX_CODTAM
         FROM TT_GRA G
         WHERE TRIM(G.CODEXT) = WK_CODMAT;

/*Almir R Borges 95176 
  validar se existe o registro na TT_LOT.*/
       IF (WK_MOTREJ = 'OK') AND (WK_LOT_CODEXT IS NOT NULL) THEN
         SELECT L.CODFIL, L.SEQUEN
           INTO WK_FILLOT, WK_SEQLOT
           FROM TT_LOT L
           WHERE TRIM(L.CODEXT) = TRIM(WK_LOT_CODEXT);
       END IF;    

IF WK_MOTREJ = 'OK' THEN
   IF (WK_FILLOT IS NULL) AND (WK_LOT_CODEXT IS NOT NULL) THEN
      WK_MOTREJ := 'ERRO AO IMPORTAR ITEM DE VENDA: LOTE NAO ENCONTRADO';
   END IF;
END IF; 

         SELECT V.SEQUEN
         INTO WK_AUX_SEQUEN
         FROM TT_VEN V
         WHERE V.CODFIL = WK_CODFIL
           AND V.CODSER = WK_CODSER
           AND V.NUMECF = WK_NUMECF
           AND V.NUMNOT = WK_NUMNOT;

       --TEM VENDEDOR ASSOCIADO
         SELECT USU.FILUSU, USU.CODUSU
         INTO WK_AUX_FILVDD, WK_AUX_CODVDD
         FROM TT_USU USU
         WHERE TRIM(USU.CODEXT) = WK_CODVDD;

         SELECT IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE
           INTO WK_AUX_FILORI, WK_AUX_NUMORI, WK_AUX_ITEORI
           FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN
          WHERE VEN.CODFIL = WK_FILORI
            AND VEN.NUMNOT = WK_NOTORI
            AND VEN.CODSER = WK_SERORI
            AND VEN.NUMECF = WK_ECFORI
            AND IVE.NUMITE = WK_ITEORI;

       IF (WK_FILDOU IS NOT NULL) AND (WK_NOMDOU IS NOT NULL) AND (WK_CODCRM IS NOT NULL) AND (WK_UF_CRM IS NOT NULL) THEN
          BEGIN
             INSERT INTO TT_DOU (CODFIL, CODCRM, NOMDOU, UF_CRM)
                         VALUES (WK_FILDOU, WK_CODCRM, WK_NOMDOU, WK_UF_CRM);

             SELECT SEQUEN
               INTO WK_SEQDOU
               FROM TT_DOU
              WHERE CODFIL = WK_FILDOU
                AND CODCRM = WK_CODCRM
                AND NOMDOU = WK_NOMDOU
                AND UF_CRM = WK_UF_CRM;
          EXCEPTION
             
             WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR MEDICOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR MEDICOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR MEDICOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR MEDICOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR MEDICOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR MEDICOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
      	     WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR MEDICOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                    END;
          IF NOT WK_MOTREJ = 'OK' THEN
             WK_STATUS := 4;
             WK_NROERR := WK_NROERR + 1;
          ELSE
             WK_STATUS := 3;
          END IF;
       END IF;

       IF (WK_FILRCT IS NOT NULL) AND (WK_NUMRCT IS NOT NULL) AND (WK_DATRCT IS NOT NULL) AND (WK_NOMPAC IS NOT NULL) AND (WK_RG_PAC IS NOT NULL) THEN
          BEGIN
             INSERT INTO TT_RCT (CODFIL,NUMRCT,DATRCT,NOMPAC,RG_PAC)
                         VALUES (WK_FILRCT,WK_NUMRCT,WK_DATRCT,WK_NOMPAC,WK_RG_PAC);

             SELECT SEQUEN
               INTO WK_SEQRCT
               FROM TT_RCT
              WHERE CODFIL = WK_FILRCT
                AND NUMRCT = WK_NUMRCT
                AND DATRCT = WK_DATRCT
                AND NOMPAC = WK_NOMPAC
                AND RG_PAC = WK_RG_PAC;
          EXCEPTION
             
             WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR RECEITAS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR RECEITAS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR RECEITAS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR RECEITAS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR RECEITAS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR RECEITAS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
      	     WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR RECEITAS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                    END;
          IF NOT WK_MOTREJ = 'OK' THEN
             WK_STATUS := 4;
             WK_NROERR := WK_NROERR + 1;
          ELSE
             WK_STATUS := 3;
          END IF;
       END IF;

       IF WK_MOTREJ = 'OK' THEN
       BEGIN
         INSERT INTO TT_IVE(CODFIL,SEQUEN,NUMITE,LANEST,TIPPRO,VINCUL,FILMAT,CODMAT,
                            VEN_DATHOR,QTDMOV,CODCOR,CODTAM,VLRMOV,ICMTIP,SITKIT,SITMOV,
                            TIP001,NUMORI,TAX001,TAX002,EMBORI,ITEORI,REDITE,VLR001,
                            VLR002,EMBQTD,DUMMY,NUMEXT,COMISS,EXPORT,CODMUL,ORD_CM,QTD_CM,
                            FILVDD,CODVDD,FILBIC,SEQFIL,NATFIS,FILORI,
                            --VLR_CM,VLRCMG -> atualizado pela trigger
                            VLRISS,VLRIRR,DATINC, FILDOU, SEQDOU, SITTRI,
                            TAXISS,TAXIRR,VLRDES,CALSUB,BASICM,QTDFUT,QTDPEN,FLGFUT,FILRCT,SEQRCT,DEVVIN,QTDPRE,VLRUNI,FILLOT,SEQLOT)
                       VALUES(WK_CODFIL,WK_AUX_SEQUEN,WK_NUMITE,WK_LANEST,COALESCE(WK_TIPPRO,'0'),COALESCE(WK_VINCUL,'N'),WK_AUX_FILMAT,WK_AUX_CODMAT,
                            WK_VEN_DATHOR,WK_QTDMOV,WK_AUX_CODCOR,WK_AUX_CODTAM,WK_VLRMOV,WK_ICMTIP,COALESCE(WK_SITKIT,'0'),WK_SITMOV,
                            WK_TIP001,WK_AUX_NUMORI,CASE WHEN WK_TIP001 ='0' THEN WK_PERICM ELSE 0 END,CASE WHEN WK_TIP001 = '1' THEN WK_PERIPI ELSE 0 END,WK_EMBORI,WK_AUX_ITEORI,WK_REDITE,CASE WHEN WK_TIP001 = '0' THEN WK_VLRICM ELSE 0 END,
                            CASE WHEN WK_TIP001 ='1' THEN WK_VLRIPI ELSE 0 END,WK_EMBQTD,NULL,WK_NUMEXT,WK_COMISS,COALESCE(WK_EXPORT,'F'),COALESCE(WK_COD_CODMUL,0),WK_ORD_CM,WK_QTD_CM,
                            WK_AUX_FILVDD,WK_AUX_CODVDD,NULL /*WK_FILBIC -> no utilizado*/,NULL /*WK_SEQFIL -> no utilizado*/,WK_NATFIS,WK_AUX_FILORI,
                            --,VLR_CM,VLRCMG -> atualizado pela trigger
                            WK_VLRISS,WK_VLRIRR,COALESCE(WK_DATINC,WK_VEN_DATHOR), WK_FILDOU, WK_SEQDOU, WK_COD_SITTRI,
                            WK_TAXISS, WK_TAXIRR, WK_VLRDES, WK_CALSUB, WK_BASICM, WK_QTDFUT, WK_QTDPEN, WK_FLGFUT,WK_FILRCT,WK_SEQRCT,WK_DEVVIN,WK_QTDPRE,WK_VLRUNI,WK_FILLOT,WK_SEQLOT);

         EXCEPTION
          
          WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ITEM DE VENDA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ITEM DE VENDA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ITEM DE VENDA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ITEM DE VENDA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ITEM DE VENDA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ITEM DE VENDA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	  WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ITEM DE VENDA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
   	                     END;
       END IF;
       IF NOT WK_MOTREJ = 'OK' THEN
          WK_STATUS := 4;
          WK_NROERR := WK_NROERR + 1;
       ELSE
         WK_STATUS := 3;
       END IF;


       UPDATE TI_IVE SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
       WHERE CODFIL = WK_CODFIL
         AND CODSER = WK_CODSER
         AND NUMECF = WK_NUMECF
         AND NUMNOT = WK_NUMNOT
         AND NUMITE = WK_NUMITE
         AND DATIMP IS NULL;


        WK_QTDIMP := WK_QTDIMP + 1;
  
        WK_NUMREG := WK_NUMREG - 1;
          CLOSE CR_ITEM;
     END LOOP;

     IF WK_NROERR <> 0 THEN
        SELECT MAI_FR, MAI_TO
          INTO WK_MAI_FR, WK_MAI_TO
          FROM TT_CFG;
        IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
           INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO,
                               TEXTOS,TIPMSG)
                       VALUES ('001','F',AGORA(),'IMPORTAO DE TENS DO PEDIDOS',WK_MAI_FR, WK_MAI_TO,
                               'Problema na importao de '||wk_nroerr||' tens do pedido. Verifique!','T');
        END IF;
     END IF;

     UPDATE TI_IVE SET STATUS = CASE WHEN STATUS = 3
                                     THEN 1
                                     ELSE 2
                                 END
       WHERE STATUS IN (3,4);


     IF WK_MANTEM = 'F' THEN
        IF WK_DIALIM > 0 THEN
           DELETE FROM TI_IVE
            WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
			  AND STATUS = 1;
        ELSE
           DELETE FROM TI_IVE
		    WHERE STATUS = 1;
        END IF;
     END IF;

     UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = WK_QTDIMP, CNTIMP = WK_CNTIMP, TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP WHERE TABELA = 'IVE';
   ELSE RAISE EXCEPTION 'PG-20001 IMPORTAO DE ITENS DE VENDA NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;
   
   SELECT COUNT(*) INTO WK_RESTO FROM TI_IVE WHERE STATUS = 0;
   IF WK_RESTO > 0 THEN
     RETURN 'EXISTEM '||WK_RESTO||' ITENS DE VENDA NO IMPORTADOS';
   ELSE
     RETURN 'OK';
   END IF;
   
END;
$$ language 'plpgsql';





/*-- SEQ 1636 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_LIM () CASCADE;

/*-- SEQ 1637 --*/
CREATE OR REPLACE FUNCTION IMPORTA_LIM ()
RETURNS VARCHAR AS $$
DECLARE


-- Objetivo:
-- 1) Importao das tabelas referentes a limites de conta corrente (TD_CCC e TT_LIM)
   WK_FILCLI                     TT_CLI.FILCLI%TYPE;
   WK_CODCLI                     TT_CLI.CODCLI%TYPE;
   WK_CODEXT                     TI_LIM.CODEXT%TYPE;
   WK_LIMCCC                     TI_LIM.LIMCCC%TYPE;
   WK_TIPCCC                     TI_LIM.TIPCCC%TYPE;
   WK_OBSERV                     TI_LIM.OBSERV%TYPE;
   WK_STATUS                     TI_LIM.STATUS%TYPE;
   WK_MOTREJ                     TI_CAM.MOTREJ%TYPE;
   WK_DATIMP                     TI_CAM.DATIMP%TYPE;
   WK_NUMEND                     TT_END.NUMEND%TYPE;
   WK_COD_TIPCCC                 TD_CCC.CODTAB%TYPE;
   cDESCCC_DCCC                  TD_CCC.DESCCC%TYPE;
   cCODCCC                       TI_LIM.CODCCC%TYPE;
   WK_FILPGT                     TT_CFG.VC_FILPGT%TYPE;
   WK_CODPGT                     TT_CFG.VC_CODPGT%TYPE;
   WK_QTDIMP                     Numeric;
   WK_IMPORT                     TT_IED.IMPORT%TYPE;
   WK_MANTEM                     TT_IED.MANTEM%TYPE;
   WK_CNTIMP                     TT_IED.CNTIMP%TYPE;
   WK_VLR_LIMCCC                 TT_LIM.LIMCCC%TYPE;
   WK_NROERR                     Numeric;
   WK_MAI_FR                     TT_CFG.MAI_FR%TYPE;
   WK_MAI_TO                     TT_CFG.MAI_TO%TYPE;
   WK_SAC_E_MAIL                 TT_CFG.SAC_E_MAIL%TYPE;
   WK_TIPCOB                     TD_COB.TIPCOB%TYPE;
   WK_DIALIM                     TT_IED.DIALIM%TYPE;
   WK_DATCRI                     TI_LIM.DATCRI%TYPE;
   WK_DESPGT                     TI_LIM.DESPGT%TYPE;
   WK_COD_FILPGT                 TT_PLA.FILPGT%TYPE;
   WK_COD_CODPGT                 TT_PLA.CODPGT%TYPE;
   WK_CARENC                     TI_LIM.CARENC%TYPE;
   WK_DESCON                     TI_LIM.DESCON%TYPE;
   WK_DIAFIX                     TI_LIM.DIAFIX%TYPE;
   WK_FATEND                     TI_LIM.FATEND%TYPE;

   WK_RESTO                      Numeric;
   WK_NUMREG                     Numeric = 500;

CR_LIMITE CURSOR(pDATCRI TI_LIM.DATCRI%TYPE) IS
  SELECT *
    FROM (SELECT /*+INDEX(ILIM, I_LC_ILIM_STATUS)*/
                 CLI.FILCLI, CLI.CODCLI, ILIM.CODEXT, ILIM.LIMCCC,ILIM.TIPCCC,ILIM.OBSERV,
                 ILIM.MOTREJ, ILIM.DATIMP, ENDE.NUMEND,ILIM.FILPGT,ILIM.DESPGT, ILIM.CARENC, ILIM.DESCON, ILIM.DIAFIX, ILIM.FATEND,
                 ILIM.CODCCC, DCCC.CODTAB AS DCCC_CODTAB, DCCC.DESCCC AS DCCC_DESCCC
            FROM TI_LIM ILIM LEFT JOIN TT_CLI CLI ON CLI.CODEXT = ILIM.CODEXT
                             LEFT JOIN TT_END ENDE ON ENDE.FILCLI = CLI.FILCLI AND ENDE.CODCLI = CLI.CODCLI
                             LEFT JOIN TD_CCC DCCC ON DCCC.CODEXT_DCCC = ILIM.CODCCC
           WHERE ILIM.STATUS = 0
             AND ILIM.DATCRI BETWEEN TRUNC(pDATCRI)
                                 AND ADD_DAY(TRUNC(pDATCRI),1)
           ORDER BY ILIM.DATCRI
         ) TAB
   LIMIT 1;
BEGIN
   -- RFMP 80113
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20013 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

   SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
     INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
     FROM TT_IED
    WHERE TABELA = 'LIM';

   IF WK_IMPORT = 'T' THEN

     WK_CNTIMP := WK_CNTIMP + 1;
     WK_QTDIMP := 0;
   SELECT TIPCOB INTO WK_TIPCOB FROM TD_COB WHERE CODTAB = 0;
   LOOP
     SELECT MIN(DATCRI)
       INTO WK_DATCRI
       FROM TI_LIM
      WHERE STATUS = 0;

     OPEN CR_LIMITE(WK_DATCRI);
     FETCH CR_LIMITE INTO WK_FILCLI, WK_CODCLI, WK_CODEXT, WK_LIMCCC, WK_TIPCCC, WK_OBSERV, WK_MOTREJ, WK_DATIMP, WK_NUMEND, WK_FILPGT, WK_DESPGT, WK_CARENC, WK_DESCON, WK_DIAFIX, WK_FATEND, cCODCCC, WK_COD_TIPCCC, cDESCCC_DCCC;

     IF NOT FOUND THEN
        CLOSE CR_LIMITE;
        EXIT;
     END IF;

     
     IF WK_NUMREG = 0 THEN
        CLOSE CR_LIMITE;
        EXIT;
     END IF;
     
     WK_MOTREJ := 'OK';

      -- Realiza Pr-Validaes
      -- Valida Conta Corrente a ser realizada o Lanamento
      IF WK_MOTREJ = 'OK' THEN
         IF WK_COD_TIPCCC IS NULL AND (ISNULL(WK_TIPCCC)='T') THEN
            WK_MOTREJ := 'ERRO AO VERIFICAR LANAMENTOS DE CONTA-CORRENTE: CONTA-CORRENTE NO LOCALIZADO PARA O CDIGO: ' || cCODCCC || ' E DESCRIO NO INFORMADA.';
         END IF;
      END IF;

      IF WK_MOTREJ = 'OK' THEN
         IF (ISNOTNULL(WK_TIPCCC)='T') AND (WK_COD_TIPCCC IS NULL OR (cDESCCC_DCCC <> WK_TIPCCC)) THEN
            WK_COD_TIPCCC := IMPORTA_TDS( 'TD_CCC', 'CCCATI', 'DESCCC', 'CODTAB', WK_TIPCCC, NULL, NULL, WK_FILCLI, NULL, NULL, cCODCCC);
         END IF;
      END IF;

            SELECT FILPGT, CODPGT INTO WK_COD_FILPGT, WK_COD_CODPGT
         FROM TT_PLA
        WHERE FILPGT = WK_FILPGT
          AND DESPGT = WK_DESPGT;
          IF WK_DESPGT IS NULL THEN
        SELECT VC_FILPGT, VC_CODPGT INTO WK_COD_FILPGT, WK_COD_CODPGT FROM TT_CFG;
     END IF;

     SELECT count(*)
       INTO WK_VLR_LIMCCC
       FROM TT_LIM
      WHERE FILCLI = WK_FILCLI
        AND CODCLI = WK_CODCLI
        AND TIPCCC = WK_COD_TIPCCC;

     IF WK_FILCLI IS NULL
     OR WK_CODCLI IS NULL THEN
       WK_MOTREJ := 'ERRO AO VERIFICAR LIMITES DE CONTA-CORRENTE: CLIENTE NO INFORMADO';
     END IF;

     IF WK_MOTREJ = 'OK' THEN
       IF WK_NUMEND IS NULL THEN
         WK_MOTREJ := 'ERRO AO VERIFICAR LIMITES DE CONTA-CORRENTE: ENDEREO NO INFORMADO';
       END IF;
     END IF;

     IF WK_MOTREJ = 'OK' THEN
       IF (WK_VLR_LIMCCC = 0) AND (WK_LIMCCC > 0) THEN
         BEGIN
           INSERT INTO TT_LIM (FILCLI, CODCLI, TIPCCC, CODPGT, FILCOB, FILPGT, ENDCOB, LIMCCC, VSALDO, OBSERV, CODCOB, TIPCOB,
                               CARENC, DESCON, DIAFIX, FATEND)
                       VALUES (WK_FILCLI, WK_CODCLI, WK_COD_TIPCCC, WK_COD_CODPGT, WK_FILCLI, WK_COD_FILPGT, WK_NUMEND, WK_LIMCCC, 0, WK_OBSERV, 0, WK_TIPCOB,
                               WK_CARENC, WK_DESCON, WK_DIAFIX, WK_FATEND);
         EXCEPTION
           
           WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR LIMITES DE CONTA-CORRENTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR LIMITES DE CONTA-CORRENTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR LIMITES DE CONTA-CORRENTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR LIMITES DE CONTA-CORRENTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR LIMITES DE CONTA-CORRENTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR LIMITES DE CONTA-CORRENTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR LIMITES DE CONTA-CORRENTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                               END;
       ELSE
         BEGIN
           UPDATE TT_LIM SET CODPGT = COALESCE(WK_COD_CODPGT,CODPGT),
                             FILCOB = COALESCE(WK_FILCLI,FILCOB),
                             FILPGT = COALESCE(WK_COD_FILPGT,FILPGT),
                             ENDCOB = COALESCE(WK_NUMEND,ENDCOB),
                             LIMCCC = COALESCE(WK_LIMCCC,LIMCCC),
                             OBSERV = COALESCE(WK_OBSERV,OBSERV),
                             TIPCOB = COALESCE(WK_TIPCOB,TIPCOB),
                             CARENC = COALESCE(WK_CARENC,CARENC),
                             DESCON = COALESCE(WK_DESCON,DESCON),
                             DIAFIX = COALESCE(WK_DIAFIX,DIAFIX),
                             FATEND = COALESCE(WK_FATEND,FATEND)
                   WHERE FILCLI = WK_FILCLI
                     AND CODCLI = WK_CODCLI
                     AND TIPCCC = WK_COD_TIPCCC;
         EXCEPTION
           
           WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR LIMITES DE CONTA-CORRENTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR LIMITES DE CONTA-CORRENTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR LIMITES DE CONTA-CORRENTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR LIMITES DE CONTA-CORRENTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR LIMITES DE CONTA-CORRENTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR LIMITES DE CONTA-CORRENTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR LIMITES DE CONTA-CORRENTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                               END;
       END IF;
     END IF;

     IF NOT WK_MOTREJ = 'OK' THEN
       WK_STATUS := 4;
       WK_NROERR := WK_NROERR + 1;
     ELSE
       WK_STATUS := 3;
     END IF;

     UPDATE TI_LIM SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
      WHERE CODEXT = WK_CODEXT
        AND DATIMP IS NULL;
     WK_QTDIMP := WK_QTDIMP + 1;
  
     WK_NUMREG := WK_NUMREG - 1;
       CLOSE CR_LIMITE;
   END LOOP;

   IF WK_NROERR <> 0 THEN
      SELECT MAI_FR, MAI_TO, SAC_E_MAIL
        INTO WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL
        FROM TT_CFG;
      IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
         INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO, MAI_CC,
                             TEXTOS,TIPMSG)
                     VALUES ('001','F',AGORA(),'IMPORTAO DE LIMITES DE CONTA-CORRENTE',WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL,
                             'Problema na importao de '||wk_nroerr||' limites de conta-corrente. Verifique!','T');
      END IF;
    END IF;


   UPDATE TI_LIM SET STATUS = CASE WHEN STATUS = 3
                                   THEN 1
                                   ELSE 2
                               END
    WHERE STATUS IN (3,4);

   IF WK_MANTEM = 'F' THEN
        IF WK_DIALIM > 0 THEN
           DELETE FROM TI_LIM
            WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
			  AND STATUS = 1;
        ELSE
           DELETE FROM TI_LIM
		    WHERE STATUS = 1;
        END IF;
   END IF;
   UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = WK_QTDIMP, CNTIMP = WK_CNTIMP, TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP WHERE TABELA = 'LIM';
   ELSE RAISE EXCEPTION 'PG-20001 IMPORTAO DE LIMITES DE CONTA-CORRENTE NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;
   
   SELECT COUNT(*) INTO WK_RESTO FROM TI_LIM WHERE STATUS = 0;
   IF WK_RESTO > 0 THEN
     RETURN 'EXISTEM '||WK_RESTO||' LIMITES DE CONTA-CORRENTE NO IMPORTADOS';
   ELSE
     RETURN 'OK';
   END IF;
   
END;
$$ language 'plpgsql';





/*-- SEQ 1638 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_MOV () CASCADE;

/*-- SEQ 1639 --*/
CREATE OR REPLACE FUNCTION IMPORTA_MOV ()
RETURNS VARCHAR AS $$
DECLARE


-- Objetivo:
-- 1) Importao das tabelas referentes a limites de conta corrente (TD_CCC e TT_LIM)
WK_FILMAT   TT_GRA.FILMAT%TYPE;
WK_CODMAT   TT_GRA.CODMAT%TYPE;
WK_CODCOR   TT_GRA.CODCOR%TYPE;
WK_CODTAM   TT_GRA.CODTAM%TYPE;
WK_CODEXT   TI_LAN.CODEXT%TYPE;
WK_CODFIL   TI_LAN.CODFIL%TYPE;
WK_DESEST   TI_LAN.DESEST%TYPE;
WK_DATMOV   TI_LAN.DATMOV%TYPE;
WK_DOCUME   TI_LAN.DOCUME%TYPE;
WK_NUMEXT   TI_LAN.NUMEXT%TYPE;
WK_QTDMOV   TI_LAN.QTDMOV%TYPE;
WK_TIPLAN   TI_LAN.TIPLAN%TYPE;
WK_TIPMOV   TI_LAN.TIPMOV%TYPE;
WK_VLRMOV   TI_LAN.VLRMOV%TYPE;
WK_OBSERV   TI_LAN.OBSERV%TYPE;
WK_STATUS   TI_LAN.STATUS%TYPE;
WK_MOTREJ   TI_LAN.MOTREJ%TYPE;
WK_DATIMP   TI_LAN.DATIMP%TYPE;
WK_COD_CODMUL TD_MUL.CODTAB%TYPE;
WK_COD_CODLAN TD_LAN.CODTAB%TYPE;
WK_QTDIMP Numeric;
WK_IMPORT TT_IED.IMPORT%TYPE;
WK_MANTEM TT_IED.MANTEM%TYPE;
WK_CNTIMP TT_IED.CNTIMP%TYPE;
WK_NROERR Numeric;
WK_MAI_FR     TT_CFG.MAI_FR%TYPE;
WK_MAI_TO     TT_CFG.MAI_TO%TYPE;
WK_SAC_E_MAIL TT_CFG.SAC_E_MAIL%TYPE;
WK_DIALIM     TT_IED.DIALIM%TYPE;
WK_DATCRI     TI_LAN.DATCRI%TYPE;
WK_COD_FILUSU     TT_USU.FILUSU%TYPE;
WK_COD_CODUSU     TT_USU.CODUSU%TYPE;
WK_CODUSU    TI_LAN.CODUSU%TYPE;
WK_SITMOV    TI_LAN.SITMOV%TYPE;
WK_EMBQTD    TI_LAN.EMBQTD%TYPE;
WK_DATINC    TI_LAN.DATINC%TYPE;
WK_EXPORT    TI_LAN.EXPORT%TYPE;

--Almir R Borges 95176
WK_LOT_CODEXT TI_LAN.LOT_CODEXT%TYPE;
WK_FILLOT     TT_LOT.CODFIL%TYPE;   
WK_SEQLOT     TT_LOT.SEQUEN%TYPE;

WK_RESTO      Numeric;
WK_NUMREG     Numeric = 500;
cDUMMY      VARCHAR(10);

CR_LANCAMENTOS CURSOR(pDATCRI TI_LAN.DATCRI%TYPE) IS
  SELECT *
    FROM (SELECT /*+INDEX(ILAN, I_LC_ILAN_STATUS)*/
                GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, ILAN.CODEXT, ILAN.CODFIL, ILAN.DESEST, ILAN.DATMOV,
                ILAN.DOCUME, ILAN.NUMEXT, ILAN.QTDMOV, ILAN.TIPLAN, ILAN.TIPMOV, ILAN.VLRMOV, ILAN.OBSERV,
                ILAN.MOTREJ, ILAN.DATIMP, ILAN.CODUSU, ILAN.SITMOV, ILAN.EMBQTD, ILAN.DATINC, COALESCE(ILAN.EXPORT,'F') AS EXPORT, LOT_CODEXT
           FROM TI_LAN ILAN LEFT JOIN TT_GRA GRA ON ILAN.CODEXT = GRA.CODEXT
          WHERE ILAN.STATUS = 0
            AND ILAN.DATCRI BETWEEN TRUNC(pDATCRI)
                                AND ADD_DAY(TRUNC(pDATCRI),1)
          ORDER BY ILAN.DATCRI) TAB
   LIMIT 1;
BEGIN
   -- RFMP 80113
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20012 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

   SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
     INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
     FROM TT_IED
    WHERE TABELA = 'LAN';

   cDummy := IMPORTA_PRO();

   IF WK_IMPORT = 'T' THEN
   WK_CNTIMP := WK_CNTIMP + 1;
   WK_QTDIMP := 0;
   LOOP
       SELECT MIN(DATCRI)
         INTO WK_DATCRI
         FROM TI_LAN
        WHERE STATUS = 0;

     OPEN CR_LANCAMENTOS(WK_DATCRI);
     FETCH CR_LANCAMENTOS INTO WK_FILMAT, WK_CODMAT, WK_CODCOR, WK_CODTAM, WK_CODEXT, WK_CODFIL, WK_DESEST, WK_DATMOV,
                               WK_DOCUME, WK_NUMEXT, WK_QTDMOV, WK_TIPLAN, WK_TIPMOV, WK_VLRMOV, WK_OBSERV,
                               WK_MOTREJ, WK_DATIMP, WK_CODUSU, WK_SITMOV, WK_EMBQTD, WK_DATINC, WK_EXPORT, WK_LOT_CODEXT;

     IF NOT FOUND THEN
        CLOSE CR_LANCAMENTOS;
        EXIT;
     END IF;

     
     IF WK_NUMREG = 0 THEN
        CLOSE CR_LANCAMENTOS;
        EXIT;
     END IF;
     
      WK_MOTREJ     := 'OK';

      IF ISNULL(WK_CODEXT) = 'T' THEN
         RAISE EXCEPTION 'PG-20100 A coluna CODEXT deve ser preenchida';
      END IF;

      IF WK_MOTREJ = 'OK' THEN
        IF WK_FILMAT IS NULL THEN
          WK_MOTREJ := 'ERRO ao processar o Lanamento de Estoque: Item de Grade no encontrado para o cdigo "' || WK_CODEXT || '".';
        END IF;
      END IF;
      IF WK_MOTREJ = 'OK' THEN
        IF WK_DESEST IS NOT NULL THEN
           WK_COD_CODMUL := IMPORTA_TDS( 'TD_MUL', 'MULATI', 'DESMUL', 'CODTAB', WK_DESEST, NULL, NULL, NULL );
        ELSE
           WK_COD_CODMUL := 0;
        END IF;

        IF WK_TIPLAN IS NOT NULL THEN
          WK_COD_CODLAN := IMPORTA_TDS( 'TD_LAN', 'LANATI', 'DESLAN', 'CODTAB', WK_TIPLAN, NULL, NULL, NULL );
        END IF;

        IF WK_COD_CODLAN IS NULL THEN
           IF WK_QTDMOV < 0 THEN
              WK_COD_CODLAN := 3;
           ELSE
              WK_COD_CODLAN := 2;
           END IF;
        END IF;

               SELECT FILUSU, CODUSU
              INTO WK_COD_FILUSU, WK_COD_CODUSU
              FROM TT_USU
             WHERE CODEXT = WK_CODUSU;
         IF WK_MOTREJ = 'OK' THEN
         IF (WK_COD_FILUSU IS NULL) THEN
            WK_MOTREJ := 'ERRO ao processar o Lanamento de Estoque: Usurio no encontrado para cdigo "' || WK_CODUSU || '".';
         END IF;
      END IF;

   /*Almir R Borges 95176 
     validar se existe o registro na TT_LOT.*/
             IF (WK_MOTREJ = 'OK') AND (WK_LOT_CODEXT IS NOT NULL) THEN
            SELECT L.CODFIL, L.SEQUEN
              INTO WK_FILLOT, WK_SEQLOT
              FROM TT_LOT L
              WHERE TRIM(L.CODEXT) = TRIM(WK_LOT_CODEXT);
          END IF;    
            IF WK_MOTREJ = 'OK' THEN
            IF (WK_FILLOT IS NULL) AND (WK_LOT_CODEXT IS NOT NULL) THEN
               WK_MOTREJ := 'ERRO ao processar o Lanamento de Estoque: Lote no encontrado para cdigo "' || WK_LOT_CODEXT || '".';
            END IF;
         END IF; 

         IF WK_MOTREJ = 'OK' THEN
            BEGIN

                 INSERT INTO TT_LAN (CODFIL,SITMOV,TIPMOV,CODUSU,FILMAT,FILUSU,CODMAT,DOCUME,ATU_EM,DATMOV,
                                     QTDMOV,CODCOR,CODTAM,TIPLAN,VLRMOV,OBSERV,CODMUL,DATINC,NUMEXT,EXPORT,EMBQTD,FILLOT,SEQLOT)
                             VALUES (WK_CODFIL, WK_SITMOV, WK_TIPMOV, WK_COD_CODUSU, WK_FILMAT, WK_COD_FILUSU, WK_CODMAT, WK_DOCUME, AGORA(), WK_DATMOV,
                                     WK_QTDMOV, WK_CODCOR, WK_CODTAM, WK_COD_CODLAN, WK_VLRMOV, WK_OBSERV, WK_COD_CODMUL, WK_DATINC,WK_NUMEXT,WK_EXPORT, WK_EMBQTD,WK_FILLOT,WK_SEQLOT);

              EXCEPTION
            
            WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR MOVIMENTAO DE ESTOQUE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
            WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR MOVIMENTAO DE ESTOQUE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
            WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR MOVIMENTAO DE ESTOQUE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
            WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR MOVIMENTAO DE ESTOQUE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                 WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR MOVIMENTAO DE ESTOQUE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
            WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR MOVIMENTAO DE ESTOQUE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                 WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR MOVIMENTAO DE ESTOQUE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                END;
         END IF;
      END IF;

     IF NOT WK_MOTREJ = 'OK' THEN
        WK_STATUS := 4;
        WK_NROERR := WK_NROERR + 1;
     ELSE
        WK_STATUS := 3;
     END IF;

    UPDATE TI_LAN SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
     WHERE CODEXT = WK_CODEXT
       AND DOCUME = WK_DOCUME
       AND CODFIL = WK_CODFIL
       AND COALESCE(NUMEXT,'') = COALESCE(WK_NUMEXT,'')
       AND DATMOV = WK_DATMOV
       AND DATIMP IS NULL;
     WK_QTDIMP := WK_QTDIMP + 1;
  
     WK_NUMREG := WK_NUMREG - 1;
       CLOSE CR_LANCAMENTOS;
   END LOOP;
   IF WK_NROERR <> 0 THEN
      SELECT MAI_FR, MAI_TO, SAC_E_MAIL
        INTO WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL
        FROM TT_CFG;
      IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
         INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO,MAI_CC,
                             TEXTOS,TIPMSG)
                     VALUES ('001','F',AGORA(),'IMPORTAO DE MOVIMENTOS DE ESTOQUE',WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL,
                             'Problema na importao de '||wk_nroerr||' movimentos de estoque. Verifique!','T');
      END IF;
    END IF;

   UPDATE TI_LAN SET STATUS = CASE WHEN STATUS = 3
                                   THEN 1
                                   ELSE 2
                               END
    WHERE STATUS IN (3,4);
   IF WK_MANTEM = 'F' THEN
        IF WK_DIALIM > 0 THEN
           DELETE FROM TI_LAN
            WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
			  AND STATUS = 1;
        ELSE
           DELETE FROM TI_LAN
		    WHERE STATUS = 1;
        END IF;
   END IF;
   UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = WK_QTDIMP, CNTIMP = WK_CNTIMP, TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP WHERE TABELA = 'LAN';
   ELSE RAISE EXCEPTION 'PG-20001 IMPORTAO DE MOVIMENTAO DE ESTOQUE NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;
   
   SELECT COUNT(*) INTO WK_RESTO FROM TI_LAN WHERE STATUS = 0;
   IF WK_RESTO > 0 THEN
     RETURN 'EXISTEM '||WK_RESTO||' LANAMENTOS NO IMPORTADOS';
   ELSE
     RETURN 'OK';
   END IF;
   
END;
$$ language 'plpgsql';




/*-- SEQ 1640 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_NAT () CASCADE;

/*-- SEQ 1641 --*/
CREATE OR REPLACE FUNCTION IMPORTA_NAT ()
RETURNS VARCHAR AS $$
DECLARE


WK_TIPNAT     TI_NAT.TIPNAT%TYPE;
WK_FINANC     TI_NAT.FINANC%TYPE;
WK_MOVEST     TI_NAT.MOVEST%TYPE;
WK_NATATI     TI_NAT.NATATI%TYPE;
WK_NATOLN     TI_NAT.NATOLN%TYPE;
WK_TRIBUT     TI_NAT.TRIBUT%TYPE;
WK_USACUS     TI_NAT.USACUS%TYPE;
WK_NATRED     TI_NAT.NATRED%TYPE;
WK_NATREF     TI_NAT.NATREF%TYPE;
WK_LIMITE     TI_NAT.LIMITE%TYPE;
WK_USAICM     TI_NAT.USAICM%TYPE;
WK_USAIPI     TI_NAT.USAIPI%TYPE;
WK_LANVEN     TI_NAT.LANVEN%TYPE;
WK_SERVIN     TI_NAT.SERVIN%TYPE;
WK_NATDEN     TI_NAT.NATDEN%TYPE;
WK_NATFOR     TI_NAT.NATFOR%TYPE;
WK_NATFUD     TI_NAT.NATFUD%TYPE;
WK_NATFUF     TI_NAT.NATFUF%TYPE;
WK_NATURE     TI_NAT.NATURE%TYPE;
WK_COMENT     TI_NAT.COMENT%TYPE;
WK_OBSERV     TI_NAT.OBSERV%TYPE;
WK_EXTDEM     TI_NAT.EXTDEM%TYPE;
WK_EXTFOR     TI_NAT.EXTFOR%TYPE;
WK_NATMUL     TI_NAT.NATMUL%TYPE;
WK_CONSFI     TI_NAT.CONSFI%TYPE;
WK_MOTREJ     TI_NAT.MOTREJ%TYPE;
WK_IMPORT     TT_IED.IMPORT%TYPE;
WK_STATUS     TI_NAT.STATUS%TYPE;
WK_MANTEM     TT_IED.MANTEM%TYPE;
WK_CNTIMP     TT_IED.CNTIMP%TYPE;
WK_NROERR     Numeric;
WK_QTDIMP     Numeric;
WK_MAI_FR     TT_CFG.MAI_FR%TYPE;
WK_MAI_TO     TT_CFG.MAI_TO%TYPE;
WK_AUX_CODTAB TD_NAT.CODTAB%TYPE;
W_EXISTE      Numeric(1);
WK_DIALIM     TT_IED.DIALIM%TYPE;
WK_DATCRI     TI_NAT.DATCRI%TYPE;
WK_DEVVIN     TI_NAT.DEVVIN%TYPE;
WK_ERRIMP     VARCHAR(200);

CR_NATUREZA CURSOR(pDATCRI TI_NAT.DATCRI%TYPE) IS
--Status => 0 no processado
--       => 1 processado com sucesso
--       => 2 processado com erro
  SELECT *
    FROM (SELECT TIPNAT,FINANC,MOVEST,NATATI,NATOLN,TRIBUT,USACUS,NATRED,NATREF,LIMITE,USAICM,USAIPI,
                 LANVEN,SERVIN,NATDEN,NATFOR,NATFUD,NATFUF,NATURE,COMENT,OBSERV,EXTDEM,EXTFOR,NATMUL,CONSFI,DEVVIN
            FROM TI_NAT
           WHERE STATUS = 0
             AND DATCRI BETWEEN TRUNC(pDATCRI)
                            AND ADD_DAY(TRUNC(pDATCRI),1)
           ORDER BY DATCRI) TAB
   LIMIT 1;

BEGIN
   -- RFMP 80113
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20011 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

   SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
     INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
     FROM TT_IED
   WHERE TABELA = 'NAT';

   IF WK_IMPORT = 'T' THEN
    WK_CNTIMP := WK_CNTIMP + 1;
    WK_NROERR := 0;
    WK_QTDIMP := 0;
	WK_ERRIMP := '';

    LOOP
       SELECT MIN(DATCRI)
         INTO WK_DATCRI
         FROM TI_NAT
        WHERE STATUS = 0;

       OPEN CR_NATUREZA(WK_DATCRI);
       FETCH CR_NATUREZA INTO WK_TIPNAT,WK_FINANC,WK_MOVEST,WK_NATATI,WK_NATOLN,
                              WK_TRIBUT,WK_USACUS,WK_NATRED,WK_NATREF,WK_LIMITE,WK_USAICM,
                              WK_USAIPI,WK_LANVEN,WK_SERVIN,WK_NATDEN,WK_NATFOR,WK_NATFUD,
                              WK_NATFUF,WK_NATURE,WK_COMENT,WK_OBSERV,WK_EXTDEM,WK_EXTFOR,
                              WK_NATMUL,WK_CONSFI,WK_DEVVIN;

       IF NOT FOUND THEN
          CLOSE CR_NATUREZA;
          EXIT;
       END IF;

       WK_MOTREJ     := 'OK';

	   -- Trata campos obrigatrios - Incio
	   IF WK_NATDEN IS NULL THEN
          WK_ERRIMP := ', NATDEN';
	   END IF;
       IF WK_NATFOR IS NULL	THEN
          WK_ERRIMP := WK_ERRIMP + ', NATFOR';
	   END IF;
	   IF WK_ERRIMP <> '' THEN
	      WK_ERRIMP:= SUBSTR(WK_ERRIMP,3);
 	       RAISE EXCEPTION 'PG-20100  obrigatrio o preenchimento da(s) coluna(s) %' , WK_ERRIMP;
	   END IF;
	   -- Trata campos obrigatrios - Fim

       W_EXISTE := 0;
         SELECT 1 INTO W_EXISTE
         FROM TD_NAT TN
         WHERE TN.NATDEN = WK_NATDEN
           AND TN.NATFOR = WK_NATFOR;
       IF W_EXISTE IS NULL THEN
          W_EXISTE := 0;
       END IF;
       IF W_EXISTE = 0 THEN --registro novo

         BEGIN
           SELECT MAX(CODTAB) + 1
           INTO WK_AUX_CODTAB
           FROM TD_NAT;
            INSERT INTO TD_NAT(CODTAB,TIPNAT,FINANC,MOVEST,NATATI,NATOLN,TRIBUT,USACUS,NATRED,NATREF,
                              LIMITE,USAICM,USAIPI,LANVEN,SERVIN,NATDEN,NATFOR,NATFUD,NATFUF,NATURE,
                              COMENT,OBSERV,EXTDEM,EXTFOR,NATMUL,CONSFI,DEVVIN)
                       VALUES(WK_AUX_CODTAB,WK_TIPNAT,WK_FINANC,WK_MOVEST,WK_NATATI,WK_NATOLN,WK_TRIBUT,WK_USACUS,WK_NATRED,WK_NATREF,
                              WK_LIMITE,WK_USAICM,WK_USAIPI,WK_LANVEN,WK_SERVIN,WK_NATDEN,WK_NATFOR,WK_NATFUD,WK_NATFUF,WK_NATURE,
                              WK_COMENT,WK_OBSERV,WK_EXTDEM,WK_EXTFOR,WK_NATMUL,WK_CONSFI,WK_DEVVIN);

         EXCEPTION
	   
	   WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR NATUREZA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	   WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR NATUREZA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	   WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR NATUREZA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	   WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR NATUREZA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR NATUREZA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	   WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR NATUREZA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
  	   WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR NATUREZA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                               END;

       ELSE

         BEGIN
           UPDATE TD_NAT SET TIPNAT = WK_TIPNAT,FINANC = WK_FINANC,MOVEST = WK_MOVEST,
                             NATATI = WK_NATATI,NATOLN = WK_NATOLN,TRIBUT = WK_TRIBUT,USACUS = WK_USACUS,
                             NATRED = WK_NATRED,NATREF = WK_NATREF,LIMITE = WK_LIMITE,USAICM = WK_USAICM,
                             USAIPI = WK_USAIPI,LANVEN = WK_LANVEN,SERVIN = WK_SERVIN,NATFUD = WK_NATFUD,
                             NATFUF = WK_NATFUF,NATURE = WK_NATURE,COMENT = WK_COMENT,OBSERV = WK_OBSERV,
                             EXTDEM = WK_EXTDEM,EXTFOR = WK_EXTFOR,NATMUL = WK_NATMUL,CONSFI = WK_CONSFI,
                             DEVVIN = WK_DEVVIN
           WHERE NATDEN = WK_NATDEN
             AND NATFOR = WK_NATFOR;
         EXCEPTION
	   
	   WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE NATUREZA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	   WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE NATUREZA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	   WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE NATUREZA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	   WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE NATUREZA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE NATUREZA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	   WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE NATUREZA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
  	   WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE NATUREZA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                               END;
       END IF;

       IF NOT WK_MOTREJ = 'OK' THEN
         WK_STATUS := 4;
         WK_NROERR := WK_NROERR + 1;
       ELSE
         WK_STATUS := 3;
       END IF;

       UPDATE TI_NAT SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
        WHERE NATDEN = WK_NATDEN
          AND NATFOR = WK_NATFOR
          AND DATIMP IS NULL;
       WK_QTDIMP := WK_QTDIMP + 1;
       CLOSE CR_NATUREZA;
     END LOOP;

     IF WK_NROERR <> 0 THEN
       SELECT MAI_FR, MAI_TO
         INTO WK_MAI_FR, WK_MAI_TO
         FROM TT_CFG;
       IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
          INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO,
                              TEXTOS,TIPMSG)
                       VALUES ('001','F',AGORA(),'IMPORTAO DE NATUREZA',WK_MAI_FR, WK_MAI_TO,
                               'Problema na importao de '||wk_nroerr||' natureza. Verifique!','T');
       END IF;
     END IF;

     UPDATE TI_NAT SET STATUS = CASE WHEN STATUS = 3
                                     THEN 1
                                     ELSE 2
                                 END
      WHERE STATUS IN (3,4);


     IF WK_MANTEM = 'F' THEN
        IF WK_DIALIM > 0 THEN
           DELETE FROM TI_NAT
            WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
			  AND STATUS = 1;
        ELSE
           DELETE FROM TI_NAT
		    WHERE STATUS = 1;
        END IF;
     END IF;

     UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = WK_QTDIMP, CNTIMP = WK_CNTIMP, TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP WHERE TABELA = 'NAT';
   ELSE RAISE EXCEPTION 'PG-20001 IMPORTAO DE NATUREZA NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;

  RETURN NULL;

END;
$$ language 'plpgsql';





/*-- SEQ 1642 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_PAG () CASCADE;

/*-- SEQ 1643 --*/
CREATE OR REPLACE FUNCTION IMPORTA_PAG ()
RETURNS VARCHAR AS $$
DECLARE


   WK_CODFIL                     TI_PAG.CODFIL%TYPE;
   WK_NUMNOT                     TI_PAG.NUMNOT%TYPE;
   WK_CODSER                     TI_PAG.CODSER%TYPE;
   WK_CODFOR                     TI_PAG.CODFOR%TYPE;
   WK_NUMPAR                     TI_PAG.NUMPAR%TYPE;
   WK_SUBPAR                     TI_PAG.SUBPAR%TYPE;
   WK_FLGEST                     TI_PAG.FLGEST%TYPE;
   WK_DATVEN                     TI_PAG.DATVEN%TYPE;
   WK_CODAUT                     TI_PAG.CODAUT%TYPE;
   WK_CODUSU                     TI_PAG.CODUSU%TYPE;
   WK_CODPRO                     TI_PAG.CODPRO%TYPE;
   WK_ATU_EM                     TI_PAG.ATU_EM%TYPE;
   WK_DATPGT                     TI_PAG.DATPGT%TYPE;
   WK_VLRPAR                     TI_PAG.VLRPAR%TYPE;
   WK_VLRPGT                     TI_PAG.VLRPGT%TYPE;
   WK_DATINC                     TI_PAG.DATINC%TYPE;
   WK_STATUS                     TI_PAG.STATUS%TYPE;
   WK_MOTREJ                     TI_PAG.MOTREJ%TYPE;
   WK_DATIMP                     TI_PAG.DATIMP%TYPE;
   WK_FILDOP                     TI_PAG.FILDOP%TYPE;
   WK_SEQDOP                     TI_PAG.SEQDOP%TYPE;
   cDOP_CODEXT                   TI_PAG.DOP_CODEXT%TYPE; -- RFMP 101203
   WK_DATPRX                     TI_PAG.DATPRX%TYPE;
   WK_VLRDES                     TI_PAG.VLRDES%TYPE;
   WK_VLRDIF                     TI_PAG.VLRDIF%TYPE;
   WK_CODBCO                     TI_PAG.CODBCO%TYPE;
   WK_SIGNAT                     TI_PAG.SIGNAT%TYPE;
   WK_CONPGT                     TI_PAG.CONPGT%TYPE;
   WK_DOCPGT                     TI_PAG.DOCPGT%TYPE;
   WK_NROERR                     Numeric;
   WK_NROERR_DOP                 Numeric;
   WK_QTDIMP                     Numeric;
   WK_QTDIMP_DOP                 Numeric;
   WK_IMPORT                     TT_IED.IMPORT%TYPE;
   WK_MANTEM                     TT_IED.MANTEM%TYPE;
   WK_CNTIMP                     TT_IED.CNTIMP%TYPE;
   WK_CNTIMP_DOP                 TT_IED.CNTIMP%TYPE;
   WK_MAI_FR                     TT_CFG.MAI_FR%TYPE;
   WK_MAI_TO                     TT_CFG.MAI_TO%TYPE;
   WK_AUX_FILUSU                 TT_USU.FILUSU%TYPE;
   WK_AUX_CODUSU                 TT_USU.CODUSU%TYPE;
   WK_AUX_FILPRO                 TT_USU.FILUSU%TYPE;
   WK_AUX_CODPRO                 TT_USU.CODUSU%TYPE;
   WK_AUX_FILAUT                 TT_USU.FILUSU%TYPE;
   WK_AUX_CODAUT                 TT_USU.CODUSU%TYPE;
   WK_AUX_DATINC                 TT_PAG.DATINC%TYPE;
   WK_AUX_SEQUEN                 TT_VEN.SEQUEN%TYPE;
   W_EXISTE                      Numeric(1);
   WK_CTA_CODFIL                 TT_CTA.CODFIL%TYPE;
   WK_CTA_SEQUEN                 TT_CTA.SEQUEN%TYPE;
   WK_CTA_TIPCTA                 TT_CTA.TIPCTA%TYPE;
   WK_DOP_FILCLI                 TT_CLI.FILCLI%TYPE;
   WK_DOP_CODCLI                 TT_CLI.CODCLI%TYPE;
   WK_DOP_FILUSU                 TT_USU.FILUSU%TYPE;
   WK_DOP_CODUSU                 TT_USU.CODUSU%TYPE;
   WK_COM_FLGEST                 TT_COM.FLGEST%TYPE;
   WK_DIALIM                     TT_IED.DIALIM%TYPE;
   WK_DATCRI                     TI_PAG.DATCRI%TYPE;
   WK_RENEGO                     TT_PAG.RENEGO%TYPE;
   WK_RENORI                     TT_PAG.RENORI%TYPE;
   WK_FLGFLU                     TI_PAG.FLGFLU%TYPE;
   WK_DATPRE                     TI_PAG.DATPRE%TYPE;
   WK_VLRPRE                     TI_PAG.VLRPRE%TYPE;
   WK_SUBORI                     TI_PAG.SUBORI%TYPE;
   WK_ERRIMP                     VARCHAR(200);
   WK_COM_STATUS                 TI_COM.STATUS%TYPE;
   
   WK_RESTO                      Numeric;
   WK_NUMREG                     Numeric = 500;
      cDOP_CODFIL_PagouParcela      TT_DOP.CODFIL%TYPE;
   cDOP_SEQUEN_PagouParcela      TT_DOP.SEQUEN%TYPE;

   CR_PAGAMENTOS CURSOR(pDATCRI TI_PAG.DATCRI%TYPE) IS
   --Status => 0 no processado
   --       => 1 processado com sucesso
   --       => 2 processado com erro
   SELECT *
     FROM (SELECT /*+INDEX(PAG, I_LC_IPAG_STATUS)*/
                  PAG.CODFIL, PAG.NUMNOT, PAG.CODSER, PAG.CODFOR, 
                  CAST(LPAD(TO_CHAR(TO_NUMBER(TRIM(PAG.NUMPAR))), 2,' ') AS CHAR(2)) AS NUMPAR, CAST(LPAD(TO_CHAR(TO_NUMBER(TRIM(PAG.SUBPAR))), 2,' ') AS CHAR(2)) AS SUBPAR,
                  PAG.FLGEST, PAG.DATVEN, PAG.CODAUT, PAG.CODUSU,
                  PAG.CODPRO, PAG.ATU_EM, PAG.DATPGT, PAG.VLRPAR, PAG.VLRPGT, PAG.DATINC, PAG.MOTREJ, PAG.DATIMP, PAG.FILDOP,
                  PAG.SEQDOP, PAG.DATPRX, PAG.VLRDES, PAG.VLRDIF, PAG.CODBCO, PAG.SIGNAT, PAG.CONPGT, PAG.DOCPGT, PAG.RENEGO,
                  PAG.RENORI, PAG.FLGFLU, PAG.DATPRE, PAG.VLRPRE, PAG.SUBORI, COALESCE(COM.STATUS,0) AS COM_STATUS,
                  PAG.DOP_CODEXT
             FROM TI_PAG PAG LEFT JOIN TI_COM COM ON COM.CODFIL = PAG.CODFIL AND COM.NUMNOT = PAG.NUMNOT
                                                 AND COM.CODSER = PAG.CODSER AND COM.CODFOR = PAG.CODFOR
            WHERE PAG.STATUS = 0
              AND PAG.DATCRI BETWEEN TRUNC(pDATCRI)
                                 AND ADD_DAY(TRUNC(pDATCRI),1)
            ORDER BY PAG.DATCRI) TAB
      
    LIMIT 1;
   
BEGIN
   -- RFMP 80113
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20010 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

   SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
     INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
     FROM TT_IED
   WHERE TABELA = 'PAG';

   SELECT COALESCE(CNTIMP,0)
     INTO WK_CNTIMP_DOP
     FROM TT_IED
   WHERE TABELA = 'DOP';

   IF WK_IMPORT = 'T' THEN
      WK_CNTIMP := WK_CNTIMP + 1;
      WK_NROERR_DOP := 0;
      WK_NROERR := 0;
      WK_QTDIMP := 0;
      WK_QTDIMP_DOP := 0;
      WK_ERRIMP := '';

      LOOP

         WK_AUX_FILUSU := NULL;
         WK_AUX_CODUSU := NULL;
         WK_AUX_FILPRO := NULL;
         WK_AUX_CODPRO := NULL;
         WK_AUX_FILAUT := NULL;
         WK_AUX_CODAUT := NULL;
         WK_AUX_DATINC := NULL;

         SELECT MIN(DATCRI)
           INTO WK_DATCRI
           FROM TI_PAG
          WHERE STATUS = 0;

         OPEN CR_PAGAMENTOS(WK_DATCRI);
         FETCH CR_PAGAMENTOS INTO WK_CODFIL, WK_NUMNOT, WK_CODSER, WK_CODFOR, WK_NUMPAR, WK_SUBPAR,
                                  WK_FLGEST, WK_DATVEN, WK_CODAUT, WK_CODUSU, WK_CODPRO, WK_ATU_EM,
                                  WK_DATPGT, WK_VLRPAR, WK_VLRPGT, WK_DATINC, WK_MOTREJ, WK_DATIMP,
                                  WK_FILDOP, WK_SEQDOP, WK_DATPRX, WK_VLRDES, WK_VLRDIF, WK_CODBCO,
                                  WK_SIGNAT, WK_CONPGT, WK_DOCPGT, WK_RENEGO, WK_RENORI, WK_FLGFLU,
                                  WK_DATPRE, WK_VLRPRE, WK_SUBORI, WK_COM_STATUS,
                                  cDOP_CODEXT;

         IF NOT FOUND THEN
            CLOSE CR_PAGAMENTOS;
            EXIT;
         END IF;

         
         IF WK_NUMREG = 0 THEN
            CLOSE CR_PAGAMENTOS;
            EXIT;
         END IF;
         
         WK_MOTREJ     := 'OK';

         -- Trata campos obrigatrios - Incio
         IF WK_COM_STATUS = 0 THEN
            RAISE EXCEPTION 'PG-20101 Compra deve ser importada. Filial: % - Nmero Nota: % - Srie: % - Cd.For.: %' , WK_CODFIL,WK_NUMNOT,WK_CODSER,WK_CODFOR;
         END IF;
         IF WK_CODFIL IS NULL THEN
            WK_ERRIMP := ', CODFIL';
         END IF;
         IF WK_NUMNOT IS NULL	THEN
            WK_ERRIMP := WK_ERRIMP || ', NUMNOT';
         END IF;
         IF WK_CODSER IS NULL	THEN
            WK_ERRIMP := WK_ERRIMP || ', CODSER';
         END IF;
         IF WK_CODFOR IS NULL	THEN
            WK_ERRIMP := WK_ERRIMP || ', CODFOR';
         END IF;
         IF WK_FLGEST = 'P' THEN
            IF cDOP_CODEXT IS NULL AND WK_FILDOP IS NULL AND WK_SEQDOP IS NULL THEN
               WK_ERRIMP := WK_ERRIMP || ', DOP_CODEXT';
            END IF;
         END IF;
         IF WK_ERRIMP <> '' THEN
            WK_ERRIMP:= SUBSTR(WK_ERRIMP,3);
            RAISE EXCEPTION 'PG-20100  obrigatrio o preenchimento da(s) coluna(s) %' , WK_ERRIMP;
         END IF;
         -- Trata campos obrigatrios - Fim

                     SELECT U.FILUSU, U.CODUSU
              INTO WK_AUX_FILUSU, WK_AUX_CODUSU
              FROM TT_USU U
             WHERE U.CODEXT = WK_CODUSU;
         
                     SELECT U.FILUSU, U.CODUSU
              INTO WK_AUX_FILPRO, WK_AUX_CODPRO
              FROM TT_USU U
             WHERE U.CODEXT = WK_CODPRO;
         
                     SELECT U.FILUSU, U.CODUSU
              INTO WK_AUX_FILAUT, WK_AUX_CODAUT
              FROM TT_USU U
             WHERE U.CODEXT = WK_CODAUT;
         
         IF WK_DATINC IS NOT NULL THEN
            WK_AUX_DATINC := WK_DATINC;
         ELSE
                           SELECT max(C.DATOPE)
                 INTO WK_AUX_DATINC
                 FROM TI_COM C
                WHERE C.CODFIL = WK_CODFIL
                  AND C.NUMNOT  = WK_NUMNOT
                  AND C.CODSER  = WK_CODSER
                  AND C.CODFOR  = WK_CODFOR;
                     END IF;

                     SELECT C.SEQUEN
              INTO WK_AUX_SEQUEN
              FROM TT_COM C
             WHERE C.CODFIL = WK_CODFIL
               AND C.CODSER = WK_CODSER
               AND C.NUMNOT = LPAD(TRIM(WK_NUMNOT),9, ' ')
               AND C.FLGEST <> 'D'
               AND (C.FILFOR, C.CODFOR) IN (SELECT C.FILCLI, C.CODCLI
                                              FROM TT_CLI C
                                             WHERE TRIM(C.CODEXT) = TRIM(WK_CODFOR)
                                             UNION
                                            SELECT ENDE.FILCLI, ENDE.CODCLI
                                              FROM TT_END ENDE
                                             WHERE TRIM(ENDE.NUMDOC) = TRIM(WK_CODFOR));
         
         cDOP_CODFIL_PagouParcela := NULL;
         cDOP_SEQUEN_PagouParcela := NULL;

         IF WK_FLGEST = 'P' THEN --> Parcela paga

            --Verifica se j existe registro em TT_DOP
            W_EXISTE := 0;

                           IF cDOP_CODEXT IS NOT NULL THEN
                  SELECT 1, TD.CODFIL, TD.SEQUEN
                    INTO W_EXISTE, cDOP_CODFIL_PagouParcela, cDOP_SEQUEN_PagouParcela
                    FROM TT_DOP TD
                   WHERE TD.CODEXT = cDOP_CODEXT;
               ELSE
                  SELECT 1, TD.CODFIL, TD.SEQUEN
                    INTO W_EXISTE, cDOP_CODFIL_PagouParcela, cDOP_SEQUEN_PagouParcela
                    FROM TT_DOP TD
                   WHERE TD.CODFIL = WK_FILDOP
                     AND TD.SEQUEN = WK_SEQDOP;
               END IF;
            
            IF W_EXISTE IS NULL THEN
               W_EXISTE := 0;
            END IF;

            IF W_EXISTE = 0 THEN --> Importa da TI_DOP

                                 IF cDOP_CODEXT IS NOT NULL THEN
                     SELECT FILCLI, CODCLI
                       INTO WK_DOP_FILCLI, WK_DOP_CODCLI
                       FROM TT_CLI
                      WHERE TRIM(CODEXT) = (SELECT CODCLI
                                              FROM TI_DOP
                                             WHERE CODEXT = cDOP_CODEXT
                                               AND STATUS = 0
                                                                                            
                                              LIMIT 1);
                                                                ELSE
                     SELECT FILCLI, CODCLI
                       INTO WK_DOP_FILCLI, WK_DOP_CODCLI
                       FROM TT_CLI
                      WHERE TRIM(CODEXT) = (SELECT CODCLI
                                              FROM TI_DOP
                                             WHERE CODFIL = WK_FILDOP
                                               AND SEQUEN = WK_SEQDOP
                                               AND STATUS = 0
                                                                                            
                                              LIMIT 1);
                                              
                  END IF;
                                 IF cDOP_CODEXT IS NOT NULL THEN
                     SELECT FILUSU, CODUSU
                       INTO WK_DOP_FILUSU, WK_DOP_CODUSU
                       FROM TT_USU
                      WHERE CODEXT = (SELECT CODUSU
                                        FROM TI_DOP
                                       WHERE CODEXT = cDOP_CODEXT
                                         AND STATUS = 0
                                                                                
                                        LIMIT 1);
                                                          ELSE
                     SELECT FILUSU, CODUSU
                       INTO WK_DOP_FILUSU, WK_DOP_CODUSU
                       FROM TT_USU
                      WHERE CODEXT = (SELECT CODUSU
                                        FROM TI_DOP
                                       WHERE CODFIL = WK_FILDOP
                                         AND SEQUEN = WK_SEQDOP
                                         AND STATUS = 0
                                                                                
                                        LIMIT 1);
                                        
                  END IF;
                                 IF cDOP_CODEXT IS NOT NULL THEN
                     SELECT CODFIL, SEQUEN, TIPCTA
                       INTO WK_CTA_CODFIL, WK_CTA_SEQUEN, WK_CTA_TIPCTA
                       FROM TT_CTA
                      WHERE (CODFIL, TITCTA, TIPCTA, USOCTA) IN (SELECT FILCTA, TITCTA, TIPCTA, USOCTA
                                                                   FROM TI_DOP
                                                                  WHERE CODEXT = cDOP_CODEXT
                                                                    AND STATUS = 0);
                  ELSE
                     SELECT CODFIL, SEQUEN, TIPCTA
                       INTO WK_CTA_CODFIL, WK_CTA_SEQUEN, WK_CTA_TIPCTA
                       FROM TT_CTA
                      WHERE (CODFIL, TITCTA, TIPCTA, USOCTA) IN (SELECT FILCTA, TITCTA, TIPCTA, USOCTA
                                                                   FROM TI_DOP
                                                                  WHERE CODFIL = WK_FILDOP
                                                                    AND SEQUEN = WK_SEQDOP
                                                                    AND STATUS = 0);

                  END IF;
               
               BEGIN
                  IF cDOP_CODEXT IS NOT NULL THEN
                     INSERT INTO TT_DOP(CODFIL,SEQUEN,FLGEST,TIPCTA,CODUSU,FILCTA,FILUSU,SEQCTA,ATU_EM,DATPGT,
                                        NUMIMP,DOMDOP,STDDOP,VLRDOC,FILDES,FILRDP,SEQRDP,CHETRO,NUMDOC,OBSERV,
                                        FILCLI,CODCLI,OBSINT,CODEXT)
                                 SELECT CODFIL,SEQUEN,FLGEST,WK_CTA_TIPCTA,WK_DOP_CODUSU,WK_CTA_CODFIL,WK_DOP_FILUSU,WK_CTA_SEQUEN,ATU_EM,DATPGT,
                                        NUMIMP,DOMDOP,STDDOP,VLRDOC,FILDES,FILRDP,SEQRDP,CHETRO,NUMDOC,OBSERV,
                                        WK_DOP_FILCLI, WK_DOP_CODCLI, OBSINT, cDOP_CODEXT
                                   FROM TI_DOP
                                  WHERE CODEXT = cDOP_CODEXT
                                    AND STATUS = 0;
                  ELSE
                     INSERT INTO TT_DOP(CODFIL,SEQUEN,FLGEST,TIPCTA,CODUSU,FILCTA,FILUSU,SEQCTA,ATU_EM,DATPGT,
                                        NUMIMP,DOMDOP,STDDOP,VLRDOC,FILDES,FILRDP,SEQRDP,CHETRO,NUMDOC,OBSERV,
                                        FILCLI,CODCLI,OBSINT,CODEXT)
                                 SELECT CODFIL,SEQUEN,FLGEST,WK_CTA_TIPCTA,WK_DOP_CODUSU,WK_CTA_CODFIL,WK_DOP_FILUSU,WK_CTA_SEQUEN,ATU_EM,DATPGT,
                                        NUMIMP,DOMDOP,STDDOP,VLRDOC,FILDES,FILRDP,SEQRDP,CHETRO,NUMDOC,OBSERV,
                                        WK_DOP_FILCLI, WK_DOP_CODCLI, OBSINT, cDOP_CODEXT
                                   FROM TI_DOP
                                  WHERE CODFIL = WK_FILDOP
                                    AND SEQUEN = WK_SEQDOP
                                    AND STATUS = 0;
                  END IF;

               EXCEPTION
                  
                  WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR DOCUMENTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR DOCUMENTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR DOCUMENTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR DOCUMENTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR DOCUMENTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR DOCUMENTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR DOCUMENTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                   END;

               IF WK_MOTREJ = 'OK' THEN
                  IF cDOP_CODEXT IS NOT NULL THEN
                                             SELECT CODFIL, SEQUEN
                          INTO cDOP_CODFIL_PagouParcela, cDOP_SEQUEN_PagouParcela
                          FROM TT_DOP
                         WHERE CODEXT = cDOP_CODEXT;
                                       ELSE
                     cDOP_CODFIL_PagouParcela := WK_FILDOP;
                     cDOP_SEQUEN_PagouParcela := WK_SEQDOP;
                  END IF;
               END IF;

               IF WK_MOTREJ = 'OK' THEN
                  IF cDOP_CODFIL_PagouParcela IS NULL
                  OR cDOP_SEQUEN_PagouParcela IS NULL THEN
                     WK_MOTREJ := 'No foi possvel encontrar o Documento de Pagamento.';
                  END IF;
               END IF;

               IF NOT WK_MOTREJ = 'OK' THEN
                  WK_STATUS := 4;
                  WK_NROERR_DOP := WK_NROERR_DOP + 1;
               ELSE
                  WK_STATUS := 3;
               END IF;

               IF cDOP_CODEXT IS NOT NULL THEN
                  UPDATE TI_DOP SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
                   WHERE CODEXT = cDOP_CODEXT
                     AND STATUS = 0;
               ELSE
                  UPDATE TI_DOP SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
                   WHERE CODFIL = WK_FILDOP
                     AND SEQUEN = WK_SEQDOP
                     AND STATUS = 0;
               END IF;

               
               WK_QTDIMP_DOP := WK_QTDIMP_DOP + 1;

            END IF; -- Fim de Importa da TI_DOP

         END IF; -- Fim de Parcela paga

         IF WK_MOTREJ = 'OK' THEN

            W_EXISTE  := 0;

                           SELECT 1 INTO W_EXISTE
                 FROM TT_PAG TP
                WHERE TP.CODFIL = WK_CODFIL
                  AND TP.SEQUEN = WK_AUX_SEQUEN
                  AND TP.NUMPAR = WK_NUMPAR
                  AND TP.SUBPAR = WK_SUBPAR;
            
            IF W_EXISTE IS NULL THEN
               W_EXISTE := 0;
            END IF;

            IF W_EXISTE = 0 THEN -- Registro novo

               BEGIN
                  INSERT INTO TT_PAG(CODFIL,SEQUEN,NUMPAR,SUBPAR,FLGEST,DATVEN,CODAUT,CODPRO,CODUSU,FILAUT,
                                   FILDOP,FILPRO,FILUSU,SEQDOP,ATU_EM,DATPGT,DATPRX,VLRDES,VLRDIF,VLRPAR,
                                   VLRPGT,CODBCO,SIGNAT,DUMMY,CONPGT,DOCPGT,DATINC,RENEGO,RENORI,FLGFLU,
                                   DATPRE,VLRPRE,SUBORI)
                            VALUES(WK_CODFIL,WK_AUX_SEQUEN,WK_NUMPAR,WK_SUBPAR,WK_FLGEST,WK_DATVEN,WK_AUX_CODAUT,WK_AUX_CODPRO,WK_AUX_CODUSU,WK_AUX_FILAUT,
                                   cDOP_CODFIL_PagouParcela,WK_AUX_FILPRO,WK_AUX_FILUSU,cDOP_SEQUEN_PagouParcela,AGORA(),WK_DATPGT,WK_DATPRX,WK_VLRDES,WK_VLRDIF,WK_VLRPAR,
                                   WK_VLRPGT,WK_CODBCO,WK_SIGNAT,NULL,WK_CONPGT,WK_DOCPGT,WK_AUX_DATINC,WK_RENEGO,WK_RENORI,WK_FLGFLU,
                                   WK_DATPRE, WK_VLRPRE, WK_SUBORI);
               EXCEPTION
                  
                  WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PAGAMENTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PAGAMENTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PAGAMENTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PAGAMENTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PAGAMENTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PAGAMENTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PAGAMENTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                   END;

            ELSE -- Alterao

               BEGIN
                  SELECT FLGEST
                    INTO WK_COM_FLGEST
                    FROM TT_COM
                   WHERE CODFIL = WK_CODFIL
                     AND SEQUEN = WK_AUX_SEQUEN;

                  IF WK_COM_FLGEST NOT IN ('C','D','Q') THEN
                     UPDATE TT_PAG SET FLGEST = WK_FLGEST,DATVEN = WK_DATVEN,CODAUT = WK_AUX_CODAUT,CODPRO = WK_AUX_CODPRO,
                                       CODUSU = WK_AUX_CODUSU,FILAUT = WK_AUX_FILAUT,FILDOP = cDOP_CODFIL_PagouParcela,FILPRO = WK_AUX_FILPRO,
                                       FILUSU = WK_AUX_FILUSU,SEQDOP = cDOP_SEQUEN_PagouParcela,ATU_EM = AGORA(),DATPGT = WK_DATPGT,
                                       DATPRX = WK_DATPRX,VLRDES = WK_VLRDES,VLRDIF = WK_VLRDIF,VLRPAR = WK_VLRPAR,
                                       VLRPGT = WK_VLRPGT,CODBCO = WK_CODBCO,SIGNAT = 9999,DUMMY  = NULL,CONPGT = WK_CONPGT,
                                       DOCPGT = WK_DOCPGT,DATINC = WK_AUX_DATINC,
                                       RENEGO = WK_RENEGO,
                                       RENORI = WK_RENORI,
                                       FLGFLU = WK_FLGFLU,
                                       DATPRE = WK_DATPRE,
                                       VLRPRE = WK_VLRPRE,
                                       SUBORI = WK_SUBORI
                                 WHERE CODFIL = WK_CODFIL
                                   AND SEQUEN = WK_AUX_SEQUEN
                                   AND NUMPAR = WK_NUMPAR
                                   AND SUBPAR = WK_SUBPAR;
                  END IF;

               EXCEPTION
                  
                  WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PAGAMENTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PAGAMENTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PAGAMENTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PAGAMENTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PAGAMENTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PAGAMENTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PAGAMENTOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                   END;

            END IF; -- Fim Incluso ou Alterao
         END IF;


         IF NOT WK_MOTREJ = 'OK' THEN
            WK_STATUS := 4;
            WK_NROERR := WK_NROERR + 1;
         ELSE
            WK_STATUS := 3;
         END IF;

         UPDATE TI_PAG SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
          WHERE CODFIL = WK_CODFIL
            AND CODSER = WK_CODSER
            AND NUMNOT = WK_NUMNOT
            AND NUMPAR = WK_NUMPAR
            AND SUBPAR = WK_SUBPAR
            AND DATIMP IS NULL;

         
         WK_QTDIMP := WK_QTDIMP + 1;
         
         WK_NUMREG := WK_NUMREG - 1;
         
         CLOSE CR_PAGAMENTOS;
      END LOOP;

      IF WK_NROERR <> 0 OR WK_NROERR_DOP <> 0 THEN

         SELECT MAI_FR, MAI_TO
           INTO WK_MAI_FR, WK_MAI_TO
           FROM TT_CFG;

         IF (WK_NROERR <> 0) AND (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
            INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO,
                                TEXTOS,TIPMSG)
                        VALUES ('001','F',AGORA(),'IMPORTAO PAGAMENTOS',WK_MAI_FR, WK_MAI_TO,
                                'Problema na importao de '||wk_nroerr||' pagamentos. Verifique!','T');
         END IF;

         IF (WK_NROERR_DOP <> 0) AND (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
            INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO,
                                TEXTOS,TIPMSG)
                        VALUES ('001','F',AGORA(),'IMPORTAO DOCUMENTOS',WK_MAI_FR, WK_MAI_TO,
                                'Problema na importao de '||wk_nroerr_dop||' documentos. Verifique!','T');
         END IF;

      END IF;

      UPDATE TI_PAG SET STATUS = CASE WHEN STATUS = 3
                                      THEN 1
                                      ELSE 2
                                  END
       WHERE STATUS IN (3,4);

      UPDATE TI_DOP SET STATUS = CASE WHEN STATUS = 3
                                      THEN 1
                                      ELSE 2
                                  END
       WHERE STATUS IN (3,4);

      IF WK_MANTEM = 'F' THEN
         IF WK_DIALIM > 0 THEN
            DELETE
              FROM TI_PAG
             WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
               AND STATUS = 1;
            DELETE
              FROM TI_DOP
             WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
               AND STATUS = 1;
         ELSE
            DELETE FROM TI_PAG
             WHERE STATUS = 1;
            DELETE FROM TI_DOP
             WHERE STATUS = 1;
         END IF;
      END IF;

      UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = WK_QTDIMP, CNTIMP = WK_CNTIMP, TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP WHERE TABELA = 'PAG';
      UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = WK_QTDIMP_DOP, CNTIMP = WK_CNTIMP_DOP, TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP_DOP WHERE TABELA = 'DOP';
         ELSE
      RAISE EXCEPTION 'PG-20001 IMPORTAO DE PAGAMENTOS NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;
   
   SELECT COUNT(*) INTO WK_RESTO FROM TI_PAG WHERE STATUS = 0;
   IF WK_RESTO > 0 THEN
      RETURN 'EXISTEM '||WK_RESTO||' PAGAMENTOS NO IMPORTADOS';
   ELSE
      RETURN 'OK';
   END IF;
   
END;
$$ language 'plpgsql';





/*-- SEQ 1644 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_PAR () CASCADE;

/*-- SEQ 1645 --*/
CREATE OR REPLACE FUNCTION IMPORTA_PAR ()
RETURNS VARCHAR AS $$
DECLARE


-- Objetivo:
-- 1) Importao das tabelas referentes a Parceiros (TDs e TT_CLI, TT_END, TT_REL, TT_CON, TT_MAR, TT_SPC)

  WK_CODEXT                      TI_CLI.CODEXT%TYPE;
  WK_CODEXT_CLI                  TT_CLI.CODEXT%TYPE;
  WK_FILCLI                      TI_CLI.FILCLI%TYPE;
  WK_CODCLI                      TI_CLI.CODCLI%TYPE;
  WK_DATOPE                      TI_CLI.DATOPE%TYPE;
  WK_NOMCLI                      TI_CLI.NOMCLI%TYPE;
  WK_ULTNOM                      VARCHAR(100); -- Tratamento para evitar Numeric overflow em nomes grandes 
  WK_CTIPDOC                     TI_CLI.CTIPDOC%TYPE;
  WK_DTIPDOC                     TI_CLI.DTIPDOC%TYPE;
  WK_INSEST                      TI_CLI.INSEST%TYPE;
  WK_NUMDOC                      TI_CLI.NUMDOC%TYPE;
  WK_DATNAS                      TI_CLI.DATNAS%TYPE;
  WK_ESTCIV                      TI_CLI.ESTCIV%TYPE;
  WK_FLGTIP                      TI_CLI.FLGTIP%TYPE;
  WK_CODSEX                      TI_CLI.CODSEX%TYPE;
  WK_CATEG1                      TI_CLI.CATEG1%TYPE;
  WK_CATEG2                      TI_CLI.CATEG2%TYPE;
  WK_CATEG3                      TI_CLI.CATEG3%TYPE;
  WK_OBSERV                      TI_CLI.OBSERV%TYPE;
  WK_ATIVO                       TI_CLI.ATIVO%TYPE;
  WK_DESINA                      TI_CLI.DESINA%TYPE;
  WK_ICM_CF                      TI_CLI.ICM_CF%TYPE;
  WK_ISENTO                      TI_CLI.ISENTO%TYPE;
  WK_CALL_C                      TI_CLI.CALL_C%TYPE;
  WK_PORPAD                      TI_CLI.PORPAD%TYPE;
  WK_CONJUG                      TI_CLI.CONJUG%TYPE;
  WK_NASCON                      TI_CLI.NASCON%TYPE;
  WK_SEXCON                      TI_CLI.SEXCON%TYPE;
  WK_DOCCON                      TI_CLI.DOCCON%TYPE;
  WK_DDTCON                      TI_CLI.DDTCON%TYPE;
  WK_TELCON                      TI_CLI.TELCON%TYPE;
  WK_DDCCON                      TI_CLI.DDCCON%TYPE;
  WK_CELUCO                      TI_CLI.CELUCO%TYPE;
  WK_E_MCON                      TI_CLI.E_MCON%TYPE;
  WK_E_MFIN                      TI_CLI.E_MFIN%TYPE;
  WK_NOMTRA                      TI_CLI.NOMTRA%TYPE;
  WK_ID_ORG                      TI_CLI.ID_ORG%TYPE;
  WK_ID_EST                      TI_CLI.ID_EST%TYPE;
  WK_ID_DAT                      TI_CLI.ID_DAT%TYPE;
  WK_LIMCRE                      TI_CLI.LIMCRE%TYPE;
  WK_CODPLA                      TI_CLI.CODPLA%TYPE;
  WK_APEVEN                      TI_CLI.APEVEN%TYPE;
  WK_CODCON                      TI_CLI.CODCON%TYPE;
  WK_NAOSPC                      TI_CLI.NAOSPC%TYPE;
  WK_CONBOL                      TI_CLI.CONBOL%TYPE;
  WK_CODVIN                      TI_CLI.CODVIN%TYPE;
  WK_FILVIN                      TT_CLI.FILVIN%TYPE;
  WK_VINCOD                      TT_CLI.CODVIN%TYPE;
  WK_OBSOUT                      TI_CLI.OBSOUT%TYPE;
  WK_SIMPLE                      TI_CLI.SIMPLE%TYPE;
  WK_HOMPGE                      TI_CLI.HOMPGE%TYPE;
  WK_DATA01                      TI_CLI.DATA01%TYPE;
  WK_DATA02                      TI_CLI.DATA02%TYPE;
  WK_DATA03                      TI_CLI.DATA03%TYPE;
  WK_NUMCON                      TI_CLI.NUMCON%TYPE;
  WK_NCONTA                      TI_CLI.NCONTA%TYPE;
  WK_FILECO                      TI_CLI.FILECO%TYPE;
  WK_NUMECO                      TI_CLI.NUMECO%TYPE;
  WK_TRACON                      TI_CLI.TRACON%TYPE;
  WK_NASCNT                      TI_CLI.NASCNT%TYPE;
  WK_SEXOCO                      TI_CLI.SEXOCO%TYPE;
  WK_TIPCON                      TI_CLI.TIPCON%TYPE;
  WK_TIPPES                      TI_CLI.TIPPES%TYPE;
  WK_DDDCON                      TI_CLI.DDDCON%TYPE;
  WK_CONTEL                      TI_CLI.CONTEL%TYPE;
  WK_DDDCEL                      TI_CLI.DDDCEL%TYPE;
  WK_CELCON                      TI_CLI.CELCON%TYPE;
  WK_DDDFXC                      TI_CLI.DDDFXC%TYPE;
  WK_NUMFXC                      TI_CLI.NUMFXC%TYPE;
  WK_E_MAIL                      TI_CLI.E_MAIL%TYPE;
  WK_FILEND                      TI_CLI.FILEND%TYPE;
  WK_NUMEND                      TI_CLI.NUMEND%TYPE;
  WK_ENDERE                      TI_CLI.ENDERE%TYPE;
  WK_CONTAT                      TI_CLI.CONTAT%TYPE;
  WK_NUMERO                      TI_CLI.NUMERO%TYPE;
  WK_BAIRRO                      TI_CLI.BAIRRO%TYPE;
  WK_SIGEST                      TI_CLI.SIGEST%TYPE;
  WK_NOMCID                      TI_CLI.NOMCID%TYPE;
  WK_CODIBG                      TI_CLI.CODIBG%TYPE;
  WK_MUN_CODCID                  TT_MUN.CODIGO%TYPE;
  WK_MUN_CODIBG                  TT_MUN.CODIBG%TYPE;
  WK_MUN_NOMCID                  TT_MUN.NOMCID%TYPE;
  WK_MUN_SIGEST                  TT_MUN.SIGEST%TYPE;
  WK_CODLOG                      TI_CLI.CODLOG%TYPE;
  WK_REGIAO                      TI_CLI.REGIAO%TYPE;
  WK_FLGNAC                      TI_CLI.FLGNAC%TYPE;
  WK_ESTRAN                      TI_CLI.ESTRAN%TYPE;
  WK_USA_NF                      TI_CLI.USA_NF%TYPE;
  WK_ENDCOB                      TI_CLI.ENDCOB%TYPE;
  WK_ENDCOR                      TI_CLI.ENDCOR%TYPE;
  WK_TIPEND                      TI_CLI.TIPEND%TYPE;
  WK_COMPLE                      TI_CLI.COMPLE%TYPE;
  WK_CODCEP                      TI_CLI.CODCEP%TYPE;
  WK_LOCTRA                      TI_CLI.LOCTRA%TYPE;
  WK_CODDDD                      TI_CLI.CODDDD%TYPE;
  WK_NUMFON                      TI_CLI.NUMFON%TYPE;
  WK_DDDFAX                      TI_CLI.DDDFAX%TYPE;
  WK_NUMFAX                      TI_CLI.NUMFAX%TYPE;
  WK_DOCEND                      TI_CLI.DOCEND%TYPE;
  WK_IE_END                      TI_CLI.IE_END%TYPE;
  WK_NACION                      TI_CLI.NACION%TYPE;
  WK_CIDNAS                      TI_CLI.CIDNAS%TYPE;
  WK_CELDDD                      TI_CLI.CELDDD%TYPE;
  WK_CELNUM                      TI_CLI.CELNUM%TYPE;
  WK_MAISPC                      TI_CLI.MAISPC%TYPE;
  WK_ATUMES                      TI_CLI.ATUMES%TYPE;
  WK_CASMES                      TI_CLI.CASMES%TYPE;
  WK_FIRATU                      TI_CLI.FIRATU%TYPE;
  WK_NUMCOD                      TI_CLI.NUMCOD%TYPE;
  WK_NUMTEL                      TI_CLI.NUMTEL%TYPE;
  WK_NOMSUP                      TI_CLI.NOMSUP%TYPE;
  WK_ENDSPC                      TI_CLI.ENDSPC%TYPE;
  WK_COMSPC                      TI_CLI.COMSPC%TYPE;
  WK_SALBAS                      TI_CLI.SALBAS%TYPE;
  WK_DESOCU                      TI_CLI.DESOCU%TYPE;
  WK_FIRANT                      TI_CLI.FIRANT%TYPE;
  WK_ANTMES                      TI_CLI.ANTMES%TYPE;
  WK_CARPRO                      TI_CLI.CARPRO%TYPE;
  WK_SERCAR                      TI_CLI.SERCAR%TYPE;
  WK_NOMLO1                      TI_CLI.NOMLO1%TYPE;
  WK_ENDLO1                      TI_CLI.ENDLO1%TYPE;
  WK_NOMLO2                      TI_CLI.NOMLO2%TYPE;
  WK_ENDLO2                      TI_CLI.ENDLO2%TYPE;
  WK_TIPRES                      TI_CLI.TIPRES%TYPE;
  WK_ALUFIN                      TI_CLI.ALUFIN%TYPE;
  WK_MORMES                      TI_CLI.MORMES%TYPE;
  WK_CON_TC                      TI_CLI.CON_TC%TYPE;
  WK_CONSPC                      TI_CLI.CONSPC%TYPE;
  WK_CON_LT                      TI_CLI.CON_LT%TYPE;
  WK_CON_LR                      TI_CLI.CON_LR%TYPE;
  WK_CARLOJ                      TI_CLI.CARLOJ%TYPE;
  WK_TEMAUT                      TI_CLI.TEMAUT%TYPE;
  WK_TEM_CC                      TI_CLI.TEM_CC%TYPE;
  WK_TEM_TC                      TI_CLI.TEM_TC%TYPE;
  WK_NUMDEP                      TI_CLI.NUMDEP%TYPE;
  WK_ORIRED                      TI_CLI.ORIRED%TYPE;
  WK_VLRRED                      TI_CLI.VLRRED%TYPE;
  WK_RGCONJ                      TI_CLI.RGCONJ%TYPE;
  WK_CONOCU                      TI_CLI.CONOCU%TYPE;
  WK_NUMCOC                      TI_CLI.NUMCOC%TYPE;
  WK_TELSPC                      TI_CLI.TELSPC%TYPE;
  WK_FIRCON                      TI_CLI.FIRCON%TYPE;
  WK_ENDCO1                      TI_CLI.ENDCO1%TYPE;
  WK_ENDCO2                      TI_CLI.ENDCO2%TYPE;
  WK_CANMES                      TI_CLI.CANMES%TYPE;
  WK_SALBAC                      TI_CLI.SALBAC%TYPE;
  WK_CARPRC                      TI_CLI.CARPRC%TYPE;
  WK_SERCAC                      TI_CLI.SERCAC%TYPE;
  WK_STATUS                      TI_CLI.STATUS%TYPE;
  WK_MOTREJ                      TI_CLI.MOTREJ%TYPE;
  WK_DATIMP                      TI_CLI.DATIMP%TYPE;
  WK_TIPCLI1                     TI_CLI.TIPCLI1%TYPE;
  WK_TIPCLI2                     TI_CLI.TIPCLI2%TYPE;
  WK_TIPCLI3                     TI_CLI.TIPCLI3%TYPE;
  WK_TIPCLI4                     TI_CLI.TIPCLI4%TYPE;
  WK_TIPCLI5                     TI_CLI.TIPCLI5%TYPE;
  WK_TIPCLI6                     TI_CLI.TIPCLI6%TYPE;
  WK_TIPCLI7                     TI_CLI.TIPCLI7%TYPE;
  WK_TIPCLI8                     TI_CLI.TIPCLI8%TYPE;
  WK_TIPCLI9                     TI_CLI.TIPCLI9%TYPE;
  WK_TIPCLI10                    TI_CLI.TIPCLI10%TYPE;
  WK_ENDATI                      TI_CLI.ENDATI%TYPE;
  WK_CODDDI                      TI_CLI.CODDDI%TYPE;
  WK_DDICON                      TI_CLI.DDICON%TYPE;
  WK_MAI_FR                      TT_CFG.MAI_FR%TYPE;
  WK_MAI_TO                      TT_CFG.MAI_TO%TYPE;
  WK_SAC_E_MAIL                  TT_CFG.SAC_E_MAIL%TYPE;
  WK_DIALIM                      TT_IED.DIALIM%TYPE;
  WK_END_SIGNAT                  TT_END.SIGNAT%TYPE;
  WK_END_CODPAI                  TT_END.CODPAI%TYPE;
  WK_CON_DOCCON                  TI_CLI.CON_DOCCON%TYPE;
  WK_CON_RETPRO                  TI_CLI.CON_RETPRO%TYPE;

  WK_NROERR                      Numeric;

  WK_COUNT                       Numeric;
  WK_SIGNAT                      TT_CLI.SIGNAT%TYPE;
  WK_COD_CATEG1                  Numeric;
  WK_COD_CATEG2                  Numeric;
  WK_COD_CATEG3                  Numeric;
  WK_COD_CODINA                  Numeric;
  WK_COD_TIPDOC                  TD_DOC.TIPDOC%TYPE;

  WK_AUX_FILCLI                  TI_CLI.FILCLI%TYPE;
  WK_AUX_CODCLI                  TI_CLI.CODCLI%TYPE;
  WK_AUX_NUMEND                  TT_END.NUMEND%TYPE;
  WK_NUMDOC_CLI                  TT_CLI.NUMDOC%TYPE;

  WK_END_FILCLI                  TI_CLI.FILCLI%TYPE;
  WK_END_CODCLI                  TI_CLI.CODCLI%TYPE;
  WK_END_NUMEND                  TT_END.NUMEND%TYPE;

  WK_CON_FILCLI                  TI_CLI.FILCLI%TYPE;
  WK_CON_CODCLI                  TI_CLI.CODCLI%TYPE;
  WK_CON_NUMCON                  TT_CON.NUMCON%TYPE;
  WK_AUX_FILPLA                  TT_PLA.FILPGT%TYPE;
  WK_AUX_CODPLA                  TT_PLA.CODPGT%TYPE;
  WK_COD_FILUSU                  TT_USU.FILUSU%TYPE;
  WK_COD_CODUSU                  TT_USU.CODUSU%TYPE;
  WK_COD_CODCON                  TT_CLI.CODCON%TYPE;
  WK_COD_FILCON                  TT_CLI.FILCON%TYPE;
  WK_COD_TIPEND                  TT_END.TIPEND%TYPE;
  WK_COD_REGIAO                  TT_END.REGIAO%TYPE;
  WK_GLOBAL                      TI_CLI.GLOBAL%TYPE;
  WK_FILCON                      TT_CLI.FILCON%TYPE;
  WK_QTDIMP                      Numeric;
  WK_IMPORT                      TT_IED.IMPORT%TYPE;
  WK_MANTEM                      TT_IED.MANTEM%TYPE;
  WK_CNTIMP                      TT_IED.CNTIMP%TYPE;
  MAX_NUMEND                     Numeric;
  MAX_NUMCON                     Numeric;
  WK_SEQUEN                      TI_CLI.SEQUEN%TYPE;
  WK_EXISTE                      CHAR(1);
  WK_EXISTE_SPC                  CHAR(1);
  WK_EXISTE_END                  CHAR(1);
  WK_EXISTE_CAR                  Numeric(1);

  WK_CLIREVSEMIE                 TT_CFG.CLIREVSEMIE%TYPE;

  WK_NOMREC                      TT_END.NOMREC%TYPE;
  WK_CODCT1                      TI_CLI.CODCT1%TYPE;
  WK_CODCT2                      TI_CLI.CODCT2%TYPE;
  WK_CODCT3                      TI_CLI.CODCT3%TYPE;

  WK_END_CODEXT                  TI_CLI.END_CODEXT%TYPE;
  WK_END_CODEXT_AUX              TI_CLI.END_CODEXT%TYPE;

  WK_CODCLINAOUSADO              TI_CLI.CODCLI%TYPE;
  WK_ULTCODATU                   TT_COD.ULTCOD%TYPE;
  WK_EXISTE_CODCLI               Numeric;
  
  FK_ERRO                        VARCHAR(1000);

  WK_RESTO                       Numeric;
  WK_NUMREG                      Numeric = 100;

CR_PARCEIRO CURSOR(pSEQUEN TI_CLI.SEQUEN%TYPE) IS
  SELECT *
    FROM (SELECT /*+INDEX(TI_CLI, I_LC_ICLI_STATUS)*/
                 TRIM(CODEXT), FILCLI, CODCLI, DATOPE, NOMCLI, ULTNOM, CTIPDOC, DTIPDOC, INSEST, GetDigit(LTRIM(RTRIM(NUMDOC))) AS NUMDOC, 
                 DATNAS, ESTCIV, FLGTIP, CODSEX, CATEG1, CATEG2, CATEG3, OBSERV, ATIVO, DESINA, ICM_CF, CALL_C, PORPAD, CONJUG, NASCON, 
                 SEXCON, DOCCON, DDTCON, TELCON, DDCCON, CELUCO, E_MCON, E_MFIN, NOMTRA, ID_ORG, ID_EST, ID_DAT, LIMCRE, CODPLA, APEVEN, 
                 CODCON, NAOSPC, CONBOL, CODVIN, OBSOUT, SIMPLE, HOMPGE, DATA01, DATA02, DATA03, TIPCLI1, TIPCLI2, TIPCLI3, TIPCLI4, 
                 TIPCLI5, TIPCLI6, TIPCLI7, TIPCLI8, TIPCLI9, TIPCLI10, NUMCON, NCONTA, FILECO, NUMECO, TRACON, NASCNT, SEXOCO, TIPCON, 
                 TIPPES, DDDCON, CONTEL, DDDCEL, CELCON, DDDFXC, NUMFXC, E_MAIL, FILEND, NUMEND, ENDERE, CONTAT, NUMERO, BAIRRO, SIGEST, 
                 NOMCID, GetDigit(LTRIM(RTRIM(CODLOG))) AS CODLOG, REGIAO, FLGNAC, ESTRAN, USA_NF, ENDCOB, ENDCOR, TIPEND, COMPLE, 
                 GetDigit(LTRIM(RTRIM(CODCEP))) AS CODCEP, LOCTRA, CODDDD, NUMFON, DDDFAX, NUMFAX, GetDigit(LTRIM(RTRIM(DOCEND))) AS DOCEND, 
                 IE_END, NACION, CIDNAS, CELDDD, CELNUM, COALESCE(MAISPC, E_MAIL), ATUMES, CASMES, FIRATU, NUMCOD, NUMTEL, NOMSUP, ENDSPC, 
                 COMSPC, SALBAS, DESOCU, FIRANT, ANTMES, CARPRO, SERCAR, NOMLO1, ENDLO1, NOMLO2, ENDLO2, TIPRES, ALUFIN, MORMES, CON_TC, 
                 CONSPC, CON_LT, CON_LR, CARLOJ, TEMAUT, TEM_CC, TEM_TC, NUMDEP, ORIRED, VLRRED, RGCONJ, CONOCU, NUMCOC, TELSPC, FIRCON, 
                 ENDCO1, ENDCO2, CANMES, SALBAC, CARPRC, SERCAC, MOTREJ, DATIMP, GLOBAL, ENDATI, CODDDI, DDICON, ISENTO, CODPAI, CODIBG, 
                 CON_DOCCON, CON_RETPRO, NOMREC, CODCT1, CODCT2, CODCT3, END_CODEXT 
            FROM TI_CLI
           WHERE STATUS = 0
             AND SEQUEN = pSEQUEN
           ORDER BY CODEXT, FILCLI, CODCLI, FILEND, NUMEND
             ) TAB
   LIMIT 1;
BEGIN
   -- RFMP 80113
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20009 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

   WK_END_CODCLI := '';
   WK_END_NUMEND := 0;
   WK_END_FILCLI := '';
   WK_CON_CODCLI := '';
   WK_CON_NUMCON := 0;
   WK_CON_FILCLI := '';
   SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
     INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
     FROM TT_IED
    WHERE TABELA = 'CLI';

   IF WK_IMPORT = 'T' THEN
   WK_CNTIMP := WK_CNTIMP + 1;
   WK_QTDIMP := 0;
   WK_NROERR := 0;

   --UPDATE TT_CLI SET CODEXT = 'VENDAAOCONSUMIDOR'
   -- WHERE (FILCLI, CODCLI) IN (SELECT VC_FILCLI, VC_CODCLI FROM TT_CFG);

   UPDATE TI_CLI SET MOTREJ = ' obrigatrio o preenchimento do campo CODEXT para importao do cliente.', STATUS = 4, DATIMP = AGORA()
    WHERE CODEXT IS NULL;

   UPDATE TI_CLI SET NUMEND = 0
    WHERE NUMEND IS NULL;

   UPDATE TI_CLI SET NUMCON = 0
    WHERE NUMCON IS NULL;

   SELECT CLIREVSEMIE
     INTO WK_CLIREVSEMIE
     FROM TT_CFG
    LIMIT 1;

   LOOP

     SELECT LPAD(MIN(TRIM(SEQUEN)),10,' ')
       INTO WK_SEQUEN
       FROM TI_CLI
      WHERE STATUS = 0;

     OPEN CR_PARCEIRO(WK_SEQUEN);
     FETCH CR_PARCEIRO INTO WK_CODEXT, WK_FILCLI, WK_CODCLI, WK_DATOPE, WK_NOMCLI, WK_ULTNOM, WK_CTIPDOC, WK_DTIPDOC, WK_INSEST, WK_NUMDOC, WK_DATNAS,
                            WK_ESTCIV, WK_FLGTIP, WK_CODSEX, WK_CATEG1, WK_CATEG2, WK_CATEG3, WK_OBSERV, WK_ATIVO, WK_DESINA, WK_ICM_CF, WK_CALL_C,
                            WK_PORPAD, WK_CONJUG, WK_NASCON, WK_SEXCON, WK_DOCCON, WK_DDTCON, WK_TELCON, WK_DDCCON, WK_CELUCO, WK_E_MCON, WK_E_MFIN, WK_NOMTRA,
                            WK_ID_ORG, WK_ID_EST, WK_ID_DAT, WK_LIMCRE, WK_CODPLA, WK_APEVEN, WK_CODCON, WK_NAOSPC, WK_CONBOL, WK_CODVIN,
                            WK_OBSOUT, WK_SIMPLE, WK_HOMPGE, WK_DATA01, WK_DATA02, WK_DATA03, WK_TIPCLI1, WK_TIPCLI2, WK_TIPCLI3, WK_TIPCLI4,
                            WK_TIPCLI5, WK_TIPCLI6, WK_TIPCLI7, WK_TIPCLI8, WK_TIPCLI9, WK_TIPCLI10, WK_NUMCON, WK_NCONTA, WK_FILECO, WK_NUMECO,
                            WK_TRACON, WK_NASCNT, WK_SEXOCO, WK_TIPCON, WK_TIPPES, WK_DDDCON, WK_CONTEL, WK_DDDCEL, WK_CELCON, WK_DDDFXC, WK_NUMFXC,
                            WK_E_MAIL, WK_FILEND, WK_NUMEND, WK_ENDERE, WK_CONTAT, WK_NUMERO, WK_BAIRRO, WK_SIGEST, WK_NOMCID, WK_CODLOG, WK_REGIAO,
                            WK_FLGNAC, WK_ESTRAN, WK_USA_NF, WK_ENDCOB, WK_ENDCOR, WK_TIPEND, WK_COMPLE, WK_CODCEP, WK_LOCTRA, WK_CODDDD, WK_NUMFON,
                            WK_DDDFAX, WK_NUMFAX, WK_DOCEND, WK_IE_END, WK_NACION, WK_CIDNAS, WK_CELDDD, WK_CELNUM, WK_MAISPC, WK_ATUMES, WK_CASMES,
                            WK_FIRATU, WK_NUMCOD, WK_NUMTEL, WK_NOMSUP, WK_ENDSPC, WK_COMSPC, WK_SALBAS, WK_DESOCU, WK_FIRANT, WK_ANTMES,
                            WK_CARPRO, WK_SERCAR, WK_NOMLO1, WK_ENDLO1, WK_NOMLO2, WK_ENDLO2, WK_TIPRES, WK_ALUFIN, WK_MORMES, WK_CON_TC, WK_CONSPC,
                            WK_CON_LT, WK_CON_LR, WK_CARLOJ, WK_TEMAUT, WK_TEM_CC, WK_TEM_TC, WK_NUMDEP, WK_ORIRED, WK_VLRRED, WK_RGCONJ, WK_CONOCU,
                            WK_NUMCOC, WK_TELSPC, WK_FIRCON, WK_ENDCO1, WK_ENDCO2, WK_CANMES, WK_SALBAC, WK_CARPRC, WK_SERCAC,
                            WK_MOTREJ, WK_DATIMP, WK_GLOBAL, WK_ENDATI, WK_CODDDI, WK_DDICON, WK_ISENTO, WK_END_CODPAI, WK_CODIBG,
                            WK_CON_DOCCON, WK_CON_RETPRO, WK_NOMREC, WK_CODCT1, WK_CODCT2, WK_CODCT3, WK_END_CODEXT;
     IF NOT FOUND THEN
        CLOSE CR_PARCEIRO;
        EXIT;
     END IF;

     
     IF WK_NUMREG = 0 THEN
        CLOSE CR_PARCEIRO;
        EXIT;
     END IF;
     
     WK_MOTREJ := 'OK';
     WK_AUX_FILCLI := WK_FILCLI;
     WK_AUX_CODCLI := WK_CODCLI;
     WK_CODEXT_CLI := NULL;

     -- MN - O cliente  sempre achado pelo nmero do documento
     SELECT CODEXT, GetDigit(LTRIM(RTRIM(NUMDOC)))
       INTO WK_CODEXT_CLI, WK_NUMDOC_CLI
       FROM TT_CLI
      WHERE NUMDOC = WK_NUMDOC;

      
     IF WK_CODEXT_CLI IS NOT NULL AND WK_CODEXT <> WK_CODEXT_CLI THEN
        -- MN - Atualiza o CODEXT do cliente quando  detectada diferena entre TI_CLI e TT_CLI
        BEGIN
        UPDATE TT_CLI 
           SET CODEXT = WK_CODEXT, 
               INDEXP = 'I'
         WHERE CODEXT = WK_CODEXT_CLI;
        EXCEPTION
          WHEN OTHERS THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO TROCAR CODEXT '||WK_NUMCON||' DO PARCEIRO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
        END;
         IF NOT WK_MOTREJ = 'OK' THEN
             WK_STATUS := 4;
             WK_NROERR := WK_NROERR + 1;
         ELSE
             WK_STATUS := 3;
         END IF;
     ELSIF WK_CODEXT_CLI IS NULL AND TRIM(WK_NUMDOC) = TRIM(WK_NUMDOC_CLI) THEN
        -- MN - Quando o CODEXT est nulo na TT_CLI e achou o cliente pelo documento, atualiza com o CODEXT que veio na TI_CLI
        BEGIN
        UPDATE TT_CLI 
           SET CODEXT = WK_CODEXT,
               INDEXP = 'I'
         WHERE NUMDOC = WK_NUMDOC;
        EXCEPTION
         WHEN OTHERS THEN WK_MOTREJ := SUBSTR('ERRO AO INFORMAR CODEXT '||WK_NUMCON||' DO PARCEIRO: '||SQLERRM,1,255);
         END;
         IF NOT WK_MOTREJ = 'OK' THEN
             WK_STATUS := 4;
             WK_NROERR := WK_NROERR + 1;
         ELSE
             WK_STATUS := 3;
         END IF;
     END IF;

     -- TRATAMENTO DO PARAMETRO DE CONFIGURAO TT_CFG.CLIREVSEMIE
     -- "Permite cadastrar revenda sem Inscrio Estadual"
     IF ( WK_CLIREVSEMIE = 'F' ) THEN
        IF  ( WK_ISENTO <> 'T' )
        AND ( ( ISNULL(WK_INSEST) = 'T' ) OR ( WK_INSEST = '' ) OR ( WK_INSEST = 'ISENTO' ) ) THEN
            IF WK_MOTREJ = 'OK' THEN
               WK_MOTREJ := 'Para cliente revenda (TI_CLI.ISENTO)  preciso informar a inscrio estadual (TI_CLI.INSEST).';
            ELSE
               WK_MOTREJ := WK_MOTREJ;
            END IF;
        END IF;

        IF NOT WK_MOTREJ = 'OK' THEN
            WK_STATUS := 4;
            WK_NROERR := WK_NROERR + 1;
        ELSE
            WK_STATUS := 3;
        END IF;
     END IF;

        -- MN - A busca  sempre feita por NUMDOC, mas nesse ponto, o sistema j atualizou o CODEXT do Cliente 
        SELECT FILCLI, CODCLI
          INTO WK_FILCLI, WK_CODCLI
          FROM TT_CLI
         WHERE CODEXT = WK_CODEXT;
       IF ((ISNULL(WK_AUX_FILCLI) = 'F') AND (ISNULL(WK_FILCLI) = 'T')) OR
          ((ISNULL(WK_AUX_CODCLI) = 'F') AND (ISNULL(WK_CODCLI) = 'T')) THEN
         WK_FILCLI := WK_AUX_FILCLI;
         WK_CODCLI := WK_AUX_CODCLI;
       END IF;

       IF WK_CODVIN IS NOT NULL THEN

        SELECT FILCLI, CODCLI
          INTO WK_FILVIN, WK_VINCOD
          FROM TT_CLI
         WHERE CODEXT = TRIM(WK_CODVIN);
       END IF;


       WK_AUX_FILCLI := '';
       WK_AUX_CODCLI := '';

       IF ((WK_FILCLI IS NULL) OR (WK_CODCLI IS NULL)) AND (WK_NUMDOC IS NOT NULL) THEN
          SELECT FILCLI, WK_CODCLI
            INTO WK_AUX_FILCLI, WK_AUX_CODCLI
            FROM TT_CLI
           WHERE NUMDOC = WK_NUMDOC;


           IF (ISNOTNULL(WK_AUX_FILCLI) = 'T')  THEN
               WK_FILCLI := WK_AUX_FILCLI;
           END IF;
           IF (ISNOTNULL(WK_AUX_CODCLI) = 'T')  THEN
               WK_CODCLI := WK_AUX_CODCLI;
           END IF;

           WK_AUX_FILCLI := '';
           WK_AUX_CODCLI := '';


          IF (WK_FILCLI IS NOT NULL) AND (WK_CODCLI IS NOT NULL) THEN
             UPDATE TT_CLI SET CODEXT = WK_CODEXT
              WHERE NUMDOC = WK_NUMDOC;
          END IF;

       END IF;

      IF (WK_MOTREJ = 'OK') AND (WK_CODCLI IS NULL) THEN
         SELECT COUNT(*)
           INTO WK_COUNT
           FROM TT_COD
          WHERE CODTAB = 'CLI'
            AND FILCOD = WK_FILCLI;

            IF WK_COUNT = 0 THEN
                 BEGIN
                    INSERT INTO TT_COD (CODTAB,FILCOD,ULTCOD)
                                VALUES ('CLI',WK_FILCLI,2);
                 EXCEPTION
                   WHEN others THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR CODIGO DO PARCEIRO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                 END;
                 IF NOT WK_MOTREJ = 'OK' THEN
                    WK_STATUS := 4;
                    WK_NROERR := WK_NROERR + 1;
                 ELSE
                   WK_STATUS := 3;
                 END IF;

--                 UPDATE TI_CLI SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
--                  WHERE CODEXT = WK_CODEXT
--                    AND COALESCE(NUMEND,0) = COALESCE(WK_NUMEND,0)
--                    AND COALESCE(NUMCON,0) = COALESCE(WK_NUMCON,0);

               WK_CODCLI := '     2';

            ELSE
              SELECT MAX(ULTCOD)
                INTO WK_ULTCODATU
                FROM TT_COD
               WHERE CODTAB = 'CLI'
                 AND FILCOD = WK_FILCLI;

              BEGIN
                 -- Somente busca pela Lacuna aps atingir o limite
                 IF ((WK_ULTCODATU + 1) > 999999) THEN
                    -- Busca por cdigo do parceiro (CODCLI) no utilizado e se no encontrar, gera um novo cdigo a partir da TT_COD
                    SELECT BuscaCodigoParceiroNaoUsado(WK_FILCLI) INTO WK_CODCLINAOUSADO FROM DUAL;
                 ELSE
                    WK_CODCLINAOUSADO := NULL;
                 END IF;

                 -- Verifica se o WK_CODCLINAOUSADO  menor que WK_ULTCODATU, se sim, utiliza o WK_CODCLINAOUSADO
                 IF (WK_CODCLINAOUSADO IS NOT NULL) AND (TO_NUMBER(COALESCE(WK_CODCLINAOUSADO, '0')) > 0) AND (TO_NUMBER(COALESCE(WK_CODCLINAOUSADO, '0')) < (WK_ULTCODATU + 1)) THEN
                    WK_CODCLI := LPAD(TO_CHAR(WK_CODCLINAOUSADO),6,' ');
                 ELSE
                    -- Controle do limite mximo do campo
                    IF ((WK_ULTCODATU + 1) > 999999) THEN
                       WK_MOTREJ := 'Limite mximo do CODCLI atingido.';
                    ELSE
                       WK_CODCLI := LPAD(TO_CHAR(WK_ULTCODATU + 1),6,' ');
                       -- Verifica se o WK_CODCLI retornado no WK_ULTCODATU + 1, no est atribuido a outro parceiro
                       SELECT COUNT(*) INTO WK_EXISTE_CODCLI FROM TT_CLI WHERE FILCLI = WK_FILCLI AND CODCLI = WK_CODCLI;
                       -- se existe_codcli j atribudo ento, considera o WK_CODCLINAOUSADO
                       IF (WK_EXISTE_CODCLI > 0) THEN
                           -- Busca por cdigo do parceiro (CODCLI) no utilizado e se no encontrar, gera um novo cdigo a partir da TT_COD
                           SELECT BuscaCodigoParceiroNaoUsado(WK_FILCLI) INTO WK_CODCLINAOUSADO FROM DUAL;

                           WK_CODCLI := LPAD(TO_CHAR(WK_CODCLINAOUSADO),6,' ');

                           -- Precisa definir como Null para que possa atualizar valor na TT_COD
                           WK_CODCLINAOUSADO := NULL;
                       END IF;
                    END IF;
                 END IF;

                 IF WK_MOTREJ = 'OK' THEN 
                    WK_CODCLI := LPAD(TO_CHAR(WK_CODCLI),6,' ');
                    -- Atualiza cdigo de controle
                    UPDATE TT_COD SET ULTCOD = CASE WHEN (WK_CODCLINAOUSADO IS NOT NULL) AND (TO_NUMBER(COALESCE(WK_CODCLINAOUSADO, '0')) > 0) AND (TO_NUMBER(COALESCE(WK_CODCLINAOUSADO, '0')) < (WK_ULTCODATU + 1)) THEN ULTCOD
                                                    WHEN (TO_NUMBER(TRIM(WK_CODCLI)) > ULTCOD) THEN TO_NUMBER(TRIM(WK_CODCLI))
                                                    ELSE ULTCOD
                                               END
                     WHERE CODTAB = 'CLI'
                       AND FILCOD = WK_FILCLI;
                  END IF;
              EXCEPTION
                 WHEN OTHERS THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR CODIGO DO PARCEIRO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
              END;
              IF NOT WK_MOTREJ = 'OK' THEN
                 WK_STATUS := 4;
                 WK_NROERR := WK_NROERR + 1;
              ELSE
                  WK_STATUS := 3;
              END IF;

--             UPDATE TI_CLI SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
--              WHERE CODEXT = WK_CODEXT
--                AND COALESCE(NUMEND,0) = COALESCE(WK_NUMEND,0)
--                AND COALESCE(NUMCON,0) = COALESCE(WK_NUMCON,0);
         END IF;
      END IF;
     SELECT CASE WHEN FILCLI IS NOT NULL THEN 'T' ELSE 'F' END
       INTO WK_EXISTE
       FROM TT_CLI
      WHERE CODEXT = WK_CODEXT;
    IF WK_EXISTE IS NULL THEN
       WK_EXISTE := 'F';
    END IF;

    IF WK_ATIVO = 'T' THEN
      WK_SIGNAT := 1;
    ELSE
      WK_SIGNAT := -1;
    END IF;
    IF WK_ENDATI IS NULL THEN
       WK_END_SIGNAT := 0;
    ELSE
       IF WK_ENDATI = 'T' THEN
          WK_END_SIGNAT := 1;
       ELSE
          WK_END_SIGNAT := -1;
       END IF;
    END IF;
    IF ((WK_CATEG1 IS NOT NULL) OR (WK_CODCT1 IS NOT NULL)) THEN
       WK_COD_CATEG1 := IMPORTA_TDS( 'TD_CT1', 'CT1ATI', 'NOMCT1', 'CODTAB', WK_CATEG1, NULL, NULL, NULL, NULL, NULL, WK_CODCT1 );
    END IF;
    IF ((WK_CATEG2 IS NOT NULL) OR (WK_CODCT2 IS NOT NULL)) THEN
       WK_COD_CATEG2 := IMPORTA_TDS( 'TD_CT2', 'CT2ATI', 'NOMCT2', 'CODTAB', WK_CATEG2, NULL, NULL, NULL, NULL, NULL, WK_CODCT2 );
    END IF;
    IF ((WK_CATEG3 IS NOT NULL) OR (WK_CODCT3 IS NOT NULL)) THEN
       WK_COD_CATEG3 := IMPORTA_TDS( 'TD_CT3', 'CT3ATI', 'NOMCT3', 'CODTAB', WK_CATEG3, NULL, NULL, NULL, NULL, NULL, WK_CODCT3 );
    END IF;
    IF (WK_CTIPDOC IS NOT NULL) AND (WK_DTIPDOC IS NOT NULL) THEN
       WK_COD_TIPDOC := IMPORTA_TDS( 'TD_DOC', 'DOCATV', 'DESDOC', 'CODTAB', WK_DTIPDOC, NULL, NULL, WK_CTIPDOC );
    END IF;
    IF WK_DESINA IS NOT NULL THEN
       WK_COD_CODINA := IMPORTA_TDS( 'TD_INA', 'INAATI', 'DESINA', 'CODTAB', WK_DESINA, -1, NULL, NULL );
    END IF;
    IF (WK_TIPEND IS NOT NULL) THEN
       WK_COD_TIPEND := IMPORTA_TDS( 'TD_END', 'ENDATV', 'DESEND', 'CODTAB', WK_TIPEND, NULL, NULL, NULL );
    END IF;

    IF (COALESCE(WK_FILCLI,'000') <> COALESCE(WK_AUX_FILCLI,'000')) OR (COALESCE(WK_CODCLI,'      ') <> COALESCE(WK_AUX_CODCLI,'      ')) THEN

       WK_AUX_FILCLI := WK_FILCLI;
       WK_AUX_CODCLI := WK_CODCLI;

       SELECT FILUSU, CODUSU
         INTO WK_COD_FILUSU, WK_COD_CODUSU
         FROM TT_USU
        WHERE APEUSU = WK_APEVEN;

       SELECT FILCLI, CODCLI
         INTO WK_FILCON, WK_COD_CODCON
         FROM TT_CLI
        WHERE CODEXT = WK_CODCON;

       SELECT FILPGT, CODPGT
         INTO WK_AUX_FILPLA, WK_AUX_CODPLA
         FROM TT_PLA
        WHERE CODEXT = WK_CODPLA;

      WK_EXISTE_CAR:= 0;
      
      IF (WK_EXISTE = 'T') and (WK_MOTREJ = 'OK') and (WK_TIPCLI10 <> 'T') THEN
          -- Select para verificar se tem cartes cadastrados e est mudando a definio do cliente
                     SELECT 1 AS EXIST 
              INTO WK_EXISTE_CAR
              FROM TD_CAR
             WHERE FILADM  = WK_FILCLI 
               AND CODADM = WK_CODCLI;
          
    
         IF  (coalesce(WK_EXISTE_CAR,0) = 1) THEN
            WK_MOTREJ := 'ERRO AO ATUALIZAR PARCEIRO: Parceiro associado como Administradora de cartes, no pode ser redefinido.';
         END IF;
      END IF;

      IF ((COALESCE(WK_END_CODPAI, 1058) <> 1058) AND (COALESCE(WK_ESTRAN,'F')='F')) OR ((COALESCE(WK_END_CODPAI, 1058) = 1058) AND (COALESCE(WK_ESTRAN,'F')='T')) THEN
         IF WK_MOTREJ =  'OK' THEN
            WK_MOTREJ := 'Para cliente extrangeiro  preciso informar o cdigo do pas (TI_CLI.CODPAI<>1058) e Endereo Estrangeiro (TI_CLI.ESTRAN = T).';
         ELSE
            WK_MOTREJ := WK_MOTREJ;
         END IF;

         IF NOT WK_MOTREJ = 'OK' THEN
            WK_STATUS := 4;
            WK_NROERR := WK_NROERR + 1;
         ELSE
            WK_STATUS := 3;
         END IF;
      END IF;

      IF WK_MOTREJ =  'OK' THEN
        IF WK_EXISTE = 'F' THEN
          BEGIN
          INSERT INTO TT_CLI (FILCLI, CODCLI, DATOPE, CODSEX, ESTCIV, FLGTIP, SEXCON, SIGNAT, NOMCLI, TIPDOC,
                              CODPLA, CODVEN, FILPLA, FILVEN, CODEXT, DOCCON, NUMDOC, ATU_EM, DATA01, DATA02,
                              DATA03, DATNAS, NASCON, CATEG1, CATEG2, CATEG3, PORPAD, VALOR1, INSEST, ULTNOM,
                              HOMPGE, CONJUG, OBSERV, ICM_CF, CALL_C, OBSOUT, DDTCON, TELCON, DDCCON, CELCON,
                              E_MCON, E_MFIN, NOMTRA, ID_ORG, ID_EST, ID_DAT, CODINA, SIMPLE, NAOSPC, FILCON, CODCON,
                              FILVIN, CODVIN, GLOBAL, ISENTO, CODPAI, ESTRAN, INDEXP, 
                              DETTIP)
                      VALUES (WK_FILCLI, WK_CODCLI, WK_DATOPE, WK_CODSEX, WK_ESTCIV, WK_FLGTIP, COALESCE(WK_SEXCON,0), WK_SIGNAT, WK_NOMCLI, WK_CTIPDOC,
                              WK_AUX_CODPLA, WK_COD_CODUSU, WK_AUX_FILPLA, WK_COD_FILUSU, WK_CODEXT, WK_DOCCON, WK_NUMDOC, AGORA(), WK_DATA01, WK_DATA02,
                              WK_DATA03, WK_DATNAS, WK_NASCON, WK_COD_CATEG1, WK_COD_CATEG2, WK_COD_CATEG3, WK_PORPAD, WK_LIMCRE, WK_INSEST, WK_ULTNOM,
                              WK_HOMPGE, WK_CONJUG, WK_OBSERV, WK_ICM_CF, WK_CALL_C, WK_OBSOUT, WK_DDTCON, WK_TELCON, WK_DDCCON, WK_CELUCO,
                              WK_E_MCON, WK_E_MFIN, WK_NOMTRA, WK_ID_ORG, WK_ID_EST, WK_ID_DAT, WK_COD_CODINA, COALESCE(WK_SIMPLE,'F'), COALESCE(WK_NAOSPC,'F'), WK_FILCON, WK_COD_CODCON,
                              WK_FILVIN, WK_VINCOD, COALESCE(WK_GLOBAL,'I'), WK_ISENTO, COALESCE(WK_END_CODPAI, 1058), COALESCE(WK_ESTRAN, 'F'), 'I',
                              CASE WHEN WK_FLGTIP = '2' THEN 'M' ELSE NULL END);
          EXCEPTION
            
            WHEN check_violation THEN
                 IF INSTR(UPPER(SQLERRM), 'CK_CLI_CODCLI')>0 THEN
                   IF WK_MOTREJ = 'OK' THEN
                      WK_MOTREJ := SUBSTR('ERRO AO INSERIR PARCEIRO: Codigo do cliente "'||WK_CODCLI||'" esta invalido. ',1,255);
                   END IF;
                 ELSIF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PARCEIRO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ;
                 END IF;
            WHEN unique_violation THEN
               IF INSTR(UPPER(SQLERRM), 'AK_CLI_NUMDOC')>0 THEN
                  IF WK_MOTREJ = 'OK' THEN
                     WK_MOTREJ := SUBSTR('ERRO AO INSERIR PARCEIRO: Numero do documento ' ||WK_NUMDOC||' ja cadastrado em outro parceiro. ',1,255);
                  END IF;
               ELSIF INSTR(UPPER(SQLERRM), 'PK_CLI')>0 THEN
                  IF WK_MOTREJ = 'OK' THEN
                     WK_MOTREJ := SUBSTR('ERRO AO INSERIR PARCEIRO: Codigo do cliente ' ||WK_CODCLI||' ja cadastrado em outro parceiro. ',1,255);
                  END IF;
               ELSIF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PARCEIRO: '||SQLERRM,1,255);
               END IF;
            WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR PARCEIRO: '||SQLERRM,1,255); END IF;
                                  END;
          IF NOT WK_MOTREJ = 'OK' THEN
              WK_STATUS := 4;
              WK_NROERR := WK_NROERR + 1;
          ELSE
              WK_STATUS := 3;
          END IF;

--          UPDATE TI_CLI SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
--           WHERE CODEXT = WK_CODEXT
--             AND COALESCE(NUMEND,0) = COALESCE(WK_NUMEND,0)
--             AND COALESCE(NUMCON,0) = COALESCE(WK_NUMCON,0);
       ELSE
          -- RFMP 86068
          IF WK_CODCLI = '     0' AND COALESCE(WK_FLGTIP,0) <> 5 THEN
            WK_MOTREJ := 'PARA PARCEIRO FILIAL FLGTIP DEVE SER 5.';
          ELSE
            BEGIN
            UPDATE TT_CLI SET CODSEX = COALESCE(WK_CODSEX,CODSEX), ESTCIV = COALESCE(WK_ESTCIV,ESTCIV), FLGTIP = COALESCE(WK_FLGTIP,FLGTIP), 
                              SEXCON = COALESCE(WK_SEXCON,SEXCON), SIGNAT = COALESCE(WK_SIGNAT,SIGNAT), NOMCLI = COALESCE(WK_NOMCLI,NOMCLI), TIPDOC = COALESCE(WK_CTIPDOC,TIPDOC),
                              CODPLA = COALESCE(WK_AUX_CODPLA,CODPLA), CODVEN = COALESCE(WK_COD_CODUSU,CODVEN), FILPLA = COALESCE(WK_AUX_FILPLA,FILPLA), 
                              FILVEN = COALESCE(WK_COD_FILUSU,FILVEN), CODEXT = COALESCE(WK_CODEXT,CODEXT), DOCCON = COALESCE(WK_DOCCON,DOCCON), 
                              NUMDOC = COALESCE(WK_NUMDOC,NUMDOC), ATU_EM = AGORA(), DATA01 = COALESCE(WK_DATA01,DATA01), DATA02 = COALESCE(WK_DATA02,DATA02),
                              DATA03 = COALESCE(WK_DATA03,DATA03), DATNAS = COALESCE(WK_DATNAS,DATNAS), NASCON = COALESCE(WK_NASCON,NASCON), 
                              CATEG1 = COALESCE(WK_COD_CATEG1,CATEG1), CATEG2 = COALESCE(WK_COD_CATEG2,CATEG2), CATEG3 = COALESCE(WK_COD_CATEG3,CATEG3), 
                              PORPAD = COALESCE(WK_PORPAD,PORPAD), VALOR1 = COALESCE(WK_LIMCRE,VALOR1), INSEST = COALESCE(WK_INSEST,INSEST), ULTNOM = COALESCE(WK_ULTNOM,ULTNOM),
                              HOMPGE = COALESCE(WK_HOMPGE,HOMPGE), CONJUG = COALESCE(WK_CONJUG,CONJUG), OBSERV = COALESCE(WK_OBSERV,OBSERV), ICM_CF = COALESCE(WK_ICM_CF,ICM_CF), 
                              CALL_C = COALESCE(WK_CALL_C,CALL_C), OBSOUT = COALESCE(WK_OBSOUT,OBSOUT), DDTCON = COALESCE(WK_DDTCON,DDTCON), TELCON = COALESCE(WK_TELCON,TELCON), 
                              DDCCON = COALESCE(WK_DDCCON,DDCCON), CELCON = COALESCE(WK_CELUCO,CELCON),
                              E_MCON = COALESCE(WK_E_MCON,E_MCON), E_MFIN = COALESCE(WK_E_MFIN,E_MFIN), NOMTRA = COALESCE(WK_NOMTRA,NOMTRA), ID_ORG = COALESCE(WK_ID_ORG,ID_ORG), 
                              ID_EST = COALESCE(WK_ID_EST,ID_EST), ID_DAT = COALESCE(WK_ID_DAT,ID_DAT), CODINA = COALESCE(WK_COD_CODINA,CODINA), SIMPLE = COALESCE(WK_SIMPLE,SIMPLE), 
                              NAOSPC = COALESCE(WK_NAOSPC,NAOSPC), FILCON = COALESCE(WK_FILCON,FILCON), CODCON = COALESCE(WK_COD_CODCON,CODCON),
                              FILVIN = COALESCE(WK_FILVIN,FILVIN), CODVIN = COALESCE(WK_VINCOD,CODVIN), GLOBAL = COALESCE(WK_GLOBAL,GLOBAL), ISENTO = COALESCE(WK_ISENTO,ISENTO), 
                              CODPAI = COALESCE(WK_END_CODPAI, CODPAI), ESTRAN = COALESCE(WK_ESTRAN, ESTRAN), INDEXP = 'I', DETTIP = CASE WHEN WK_FLGTIP = '2' THEN DETTIP ELSE NULL END
                         WHERE FILCLI = WK_FILCLI
                           AND CODCLI = WK_CODCLI;
            EXCEPTION
            
            WHEN check_violation THEN
                 IF INSTR(UPPER(SQLERRM), 'CK_CLI_CODCLI')>0 THEN
                   IF WK_MOTREJ = 'OK' THEN
                      WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PARCEIRO: Codigo do cliente "'||WK_CODCLI||'" esta invalido. ',1,255);
                   END IF;
                 ELSIF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PARCEIRO: '||SQLERRM,1,255);
                 END IF;
            WHEN unique_violation THEN
               IF INSTR(UPPER(SQLERRM), 'AK_CLI_NUMDOC')>0 THEN
                  IF WK_MOTREJ = 'OK' THEN
                     WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PARCEIRO: Numero do documento ' ||WK_NUMDOC||' ja cadastrado em outro parceiro. ',1,255);
                  END IF;
               ELSIF INSTR(UPPER(SQLERRM), 'PK_CLI')>0 THEN
                  IF WK_MOTREJ = 'OK' THEN
                     WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PARCEIRO: Codigo do cliente ' ||WK_CODCLI||' ja cadastrado em outro parceiro. ',1,255);
                  END IF;
               ELSIF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PARCEIRO: '||SQLERRM,1,255);
               END IF;
            WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PARCEIRO: '||SQLERRM,1,255); END IF;
                                     END;
          END IF;

          IF NOT WK_MOTREJ = 'OK' THEN
              WK_STATUS := 4;
              WK_NROERR := WK_NROERR + 1;
          ELSE
              WK_STATUS := 3;
          END IF;

--          UPDATE TI_CLI SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
--           WHERE CODEXT = WK_CODEXT
--             AND COALESCE(NUMEND,0) = COALESCE(WK_NUMEND,0)
--             AND COALESCE(NUMCON,0) = COALESCE(WK_NUMCON,0);
         END IF;
       END IF;

       IF (WK_MOTREJ = 'OK') AND (COALESCE(WK_FLGTIP,0) = 0) THEN

                         SELECT CASE WHEN FILCLI IS NOT NULL THEN 'T' ELSE 'F' END
                INTO WK_EXISTE_SPC
                FROM TT_SPC
               WHERE FILCLI = WK_FILCLI
                 AND CODCLI = WK_CODCLI;
           
           IF WK_EXISTE_SPC IS NULL THEN
              WK_EXISTE_SPC := 'F';
           END IF;


           IF (WK_EXISTE = 'F') OR (WK_EXISTE_SPC = 'F') THEN

               BEGIN
               INSERT INTO TT_SPC (FILCLI, CODCLI, TIPRES, CONSPC, CON_LR, CON_LT, CON_TC, ALUFIN, SALBAC, SALBAS, ANTMES, ATUMES, CANMES, MORMES,
                                   NUMCOC, NUMCOD, CIDNAS, CARPRC, CARPRO, SERCAC, SERCAR, NUMCEL, NUMTEL, TELCON, NOMLO1, NOMLO2, RGCONJ, NACION,
                                   ENDCO1, ENDCO2, FIRANT, FIRATU, FIRCON, NOMSUP, ENDLO1, ENDLO2, ENDERE, COMPLE, VLRRED,
                                   ORIRED, NUMDEP, TEM_TC, TEM_CC, CARLOJ, TEMAUT, CASMES, DDDCEL, CONOCU, E_MAIL)
                           VALUES (WK_FILCLI, WK_CODCLI, COALESCE(WK_TIPRES, 5), COALESCE(WK_CONSPC, 'F'), COALESCE(WK_CON_LR, 'F'), COALESCE(WK_CON_LT, 'F'),
                                   COALESCE(WK_CON_TC, 'F'), WK_ALUFIN, WK_SALBAC, WK_SALBAS, WK_ANTMES, WK_ATUMES, WK_CANMES, WK_MORMES,
                                   WK_NUMCOC, WK_NUMCOD, WK_CIDNAS, WK_CARPRC, WK_CARPRO, WK_SERCAC, WK_SERCAR, WK_CELNUM, WK_NUMTEL, WK_TELSPC, WK_NOMLO1, WK_NOMLO2, WK_RGCONJ, WK_NACION,
                                   WK_ENDCO1, WK_ENDCO2, WK_FIRANT, WK_FIRATU, WK_FIRCON, WK_NOMSUP, WK_ENDLO1, WK_ENDLO2, WK_ENDSPC, WK_COMSPC, WK_VLRRED,
                                   WK_ORIRED, WK_NUMDEP, COALESCE(WK_TEM_TC, 'F'), COALESCE(WK_TEM_CC, 'F'), COALESCE(WK_CARLOJ, 'F'), COALESCE(WK_TEMAUT, 'F'), WK_CASMES, WK_CELDDD, WK_CONOCU, WK_MAISPC);
               EXCEPTION
                 WHEN OTHERS THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR DADOS DE SPC DO PARCEIRO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               END;

               IF NOT WK_MOTREJ = 'OK' THEN
                  WK_STATUS := 4;
                  WK_NROERR := WK_NROERR + 1;
               ELSE
                  WK_STATUS := 3;
               END IF;

--         UPDATE TI_CLI SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
--                WHERE CODEXT = WK_CODEXT
--                  AND COALESCE(NUMEND,0) = COALESCE(WK_NUMEND,0)
--                  AND COALESCE(NUMCON,0) = COALESCE(WK_NUMCON,0);
           ELSE
               BEGIN
               UPDATE TT_SPC SET TIPRES = COALESCE(WK_TIPRES,TIPRES), CONSPC = COALESCE(WK_CONSPC,CONSPC), CON_LR = COALESCE(WK_CON_LR,CON_LR), CON_LT = COALESCE(WK_CON_LT,CON_LT), 
                                 CON_TC = COALESCE(WK_CON_TC,CON_TC), ALUFIN = COALESCE(WK_ALUFIN,ALUFIN), SALBAC = COALESCE(WK_SALBAC,SALBAC), SALBAS = COALESCE(WK_SALBAS,SALBAS), 
                                 ANTMES = COALESCE(WK_ANTMES,ANTMES), ATUMES = COALESCE(WK_ATUMES,ATUMES), CANMES = COALESCE(WK_CANMES,CANMES), MORMES = COALESCE(WK_MORMES,MORMES),
                                 NUMCOC = WK_NUMCOC, NUMCOD = COALESCE(WK_NUMCOD,NUMCOD), CIDNAS = COALESCE(WK_CIDNAS,CIDNAS), CARPRC = COALESCE(WK_CARPRC,CARPRC), 
                                 CARPRO = COALESCE(WK_CARPRO,CARPRO), SERCAC = COALESCE(WK_SERCAC,SERCAC), SERCAR = COALESCE(WK_SERCAR,SERCAR), NUMCEL = COALESCE(WK_CELNUM,NUMCEL), 
                                 NUMTEL = COALESCE(WK_NUMTEL,NUMTEL), TELCON = WK_TELSPC, NOMLO1 = COALESCE(WK_NOMLO1,NOMLO1), NOMLO2 = COALESCE(WK_NOMLO2,NOMLO2), 
                                 RGCONJ = COALESCE(WK_RGCONJ,RGCONJ), NACION = COALESCE(WK_NACION,NACION),
                                 ENDCO1 = COALESCE(WK_ENDCO1,ENDCO1), ENDCO2 = COALESCE(WK_ENDCO2,ENDCO2), FIRANT = COALESCE(WK_FIRANT,FIRANT), FIRATU = COALESCE(WK_FIRATU,FIRATU), 
                                 FIRCON = COALESCE(WK_FIRCON,FIRCON), NOMSUP = COALESCE(WK_NOMSUP,NOMSUP), ENDLO1 = COALESCE(WK_ENDLO1,ENDLO1), ENDLO2 = COALESCE(WK_ENDLO2,ENDLO2), 
                                 ENDERE = COALESCE(WK_ENDSPC,ENDERE), COMPLE = COALESCE(WK_COMSPC,COMPLE), VLRRED = COALESCE(WK_VLRRED,VLRRED),
                                 ORIRED = COALESCE(WK_ORIRED,ORIRED), NUMDEP = COALESCE(WK_NUMDEP,NUMDEP), TEM_TC = COALESCE(WK_TEM_TC,TEM_TC), TEM_CC = COALESCE(WK_TEM_CC, 'F'), 
                                 CARLOJ = COALESCE(WK_CARLOJ,CARLOJ), TEMAUT = COALESCE(WK_TEMAUT,TEMAUT), CASMES = COALESCE(WK_CASMES,CASMES), DDDCEL = COALESCE(WK_CELDDD,DDDCEL), 
                                 CONOCU = COALESCE(WK_CONOCU,CONOCU), E_MAIL = COALESCE(WK_MAISPC,E_MAIL)
                           WHERE FILCLI = WK_FILCLI
                             AND CODCLI = WK_CODCLI;
               EXCEPTION
                 WHEN OTHERS THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR DADOS DE SPC DO PARCEIRO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
               END;

               IF NOT WK_MOTREJ = 'OK' THEN
                  WK_STATUS := 4;
                  WK_NROERR := WK_NROERR + 1;
               ELSE
                  WK_STATUS := 3;
               END IF;

--         UPDATE TI_CLI SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
--                WHERE CODEXT = WK_CODEXT
--                  AND COALESCE(NUMEND,0) = COALESCE(WK_NUMEND,0)
--                  AND COALESCE(NUMCON,0) = COALESCE(WK_NUMCON,0);
           END IF;
       END IF;
       
       IF WK_MOTREJ =  'OK' THEN
          BEGIN
            FK_ERRO := ''; -- Inicializa a varivel FK_ERRO
            IF ISNOTNULL(WK_TIPCLI1) = 'T' THEN
               BEGIN
                  IF WK_TIPCLI1 = 'T' THEN
                     INSERT INTO TT_REL (FILPAR, CODPAR, TIPPAR)
                     SELECT WK_FILCLI, WK_CODCLI, 'M'
                       FROM DUAL
                      WHERE NOT EXISTS (SELECT 1 AS OK
                                          FROM TT_REL
                                         WHERE FILPAR = WK_FILCLI
                                           AND CODPAR = WK_CODCLI
                                           AND TIPPAR = 'M');
                  ELSE
                     DELETE FROM TT_REL
                      WHERE FILPAR = WK_FILCLI
                        AND CODPAR = WK_CODCLI
                        AND TIPPAR = 'M';
                  END IF;
               EXCEPTION
                
                  WHEN foreign_key_violation THEN
                       IF INSTR(UPPER(SQLERRM), 'CK_REL_TIPPAR')>0 THEN
                          IF WK_MOTREJ = 'OK' THEN
                             FK_ERRO := FK_ERRO || 'Marca/';  
                          END IF;
                       ELSIF WK_MOTREJ = 'OK' THEN 
                          FK_ERRO := FK_ERRO || 'Marca/'; 
                       END IF;
                                               END;
            END IF;

            IF ISNOTNULL(WK_TIPCLI2) = 'T' THEN
               BEGIN
                  IF WK_TIPCLI2 = 'T' THEN
                     INSERT INTO TT_REL (FILPAR, CODPAR, TIPPAR)
                     SELECT WK_FILCLI, WK_CODCLI, 'F'
                       FROM DUAL
                      WHERE NOT EXISTS (SELECT 1 AS OK
                                          FROM TT_REL
                                         WHERE FILPAR = WK_FILCLI
                                           AND CODPAR = WK_CODCLI
                                           AND TIPPAR = 'F');
                  ELSE
                     DELETE FROM TT_REL
                      WHERE FILPAR = WK_FILCLI
                        AND CODPAR = WK_CODCLI
                        AND TIPPAR = 'F';
                  END IF;
               EXCEPTION
                
                  WHEN foreign_key_violation THEN
                     IF INSTR(UPPER(SQLERRM), 'CK_REL_TIPPAR')>0 THEN  --'FK_COM_REL'
                        IF WK_MOTREJ = 'OK' THEN
                            FK_ERRO := FK_ERRO || 'Fornecedor/'; 
                        END IF;
                        ELSIF WK_MOTREJ = 'OK' THEN 
                           FK_ERRO := FK_ERRO || 'Fornecedor/'; 
                     END IF;
                                               END;
            END IF;

            IF ISNOTNULL(WK_TIPCLI3) = 'T' THEN
--               FK_ERRO := FK_ERRO || 'Transportador';
               BEGIN
                  IF WK_TIPCLI3 = 'T' THEN
                     INSERT INTO TT_REL (FILPAR, CODPAR, TIPPAR)
                     SELECT WK_FILCLI, WK_CODCLI, 'T'
                       FROM DUAL
                      WHERE NOT EXISTS (SELECT 1 AS OK
                                          FROM TT_REL
                                         WHERE FILPAR = WK_FILCLI
                                           AND CODPAR = WK_CODCLI
                                           AND TIPPAR = 'T');
                  ELSE
                     DELETE FROM TT_REL
                      WHERE FILPAR = WK_FILCLI
                        AND CODPAR = WK_CODCLI
                        AND TIPPAR = 'T';
                  END IF;
               EXCEPTION
                
                  WHEN foreign_key_violation THEN
                     IF INSTR(UPPER(SQLERRM), 'CK_REL_TIPPAR')>0 THEN  --'FK_COM_REL'
                        IF WK_MOTREJ = 'OK' THEN
                            FK_ERRO := FK_ERRO || 'Transportador/'; 
                        END IF;
                        ELSIF WK_MOTREJ = 'OK' THEN 
                           FK_ERRO := FK_ERRO || 'Transportador/'; 
                     END IF;
                                               END;
            END IF;
            
            IF ISNOTNULL(WK_TIPCLI4) = 'T' THEN
--             FK_ERRO := FK_ERRO || 'Cliente Transportadora';
               BEGIN
                  IF WK_TIPCLI4 = 'T' THEN
                     INSERT INTO TT_REL (FILPAR, CODPAR, TIPPAR)
                     SELECT WK_FILCLI, WK_CODCLI, 'A'
                       FROM DUAL
                      WHERE NOT EXISTS (SELECT 1 AS OK
                                          FROM TT_REL
                                         WHERE FILPAR = WK_FILCLI
                                           AND CODPAR = WK_CODCLI
                                           AND TIPPAR = 'A');
                  ELSE
                     DELETE FROM TT_REL
                      WHERE FILPAR = WK_FILCLI
                        AND CODPAR = WK_CODCLI
                        AND TIPPAR = 'A';
                  END IF;
               EXCEPTION
                
                  WHEN foreign_key_violation THEN
                     IF INSTR(UPPER(SQLERRM), 'CK_REL_TIPPAR')>0 THEN  --'FK_COM_REL'
                        IF WK_MOTREJ = 'OK' THEN
                            FK_ERRO := FK_ERRO || 'Cliente Transportadora/'; 
                        END IF;
                        ELSIF WK_MOTREJ = 'OK' THEN 
                           FK_ERRO := FK_ERRO || 'Cliente Transportadora/'; 
                     END IF;
                                               END;
            END IF;
            IF ISNOTNULL(WK_TIPCLI5) = 'T' THEN
--               FK_ERRO := FK_ERRO || 'Representante';
               BEGIN
                  IF WK_TIPCLI5 = 'T' THEN
                     INSERT INTO TT_REL (FILPAR, CODPAR, TIPPAR)
                     SELECT WK_FILCLI, WK_CODCLI, 'R'
                       FROM DUAL
                      WHERE NOT EXISTS (SELECT 1 AS OK
                                          FROM TT_REL
                                         WHERE FILPAR = WK_FILCLI
                                           AND CODPAR = WK_CODCLI
                                           AND TIPPAR = 'R');
                  ELSE
                     DELETE FROM TT_REL
                      WHERE FILPAR = WK_FILCLI
                        AND CODPAR = WK_CODCLI
                        AND TIPPAR = 'R';
                  END IF;
               EXCEPTION
                
                  WHEN foreign_key_violation THEN
                     IF INSTR(UPPER(SQLERRM), 'CK_REL_TIPPAR')>0 THEN  --'FK_COM_REL'
                        IF WK_MOTREJ = 'OK' THEN
                            FK_ERRO := FK_ERRO || 'Representante/'; 
                        END IF;
                        ELSIF WK_MOTREJ = 'OK' THEN 
                           FK_ERRO := FK_ERRO || 'Representante/'; 
                     END IF;
                                               END;
            END IF;
            IF ISNOTNULL(WK_TIPCLI6) = 'T' THEN 
--               FK_ERRO := FK_ERRO || 'Indicador Venda';
               BEGIN
                  IF WK_TIPCLI6 = 'T' THEN
                     INSERT INTO TT_REL (FILPAR, CODPAR, TIPPAR)
                     SELECT WK_FILCLI, WK_CODCLI, 'I'
                       FROM DUAL
                      WHERE NOT EXISTS (SELECT 1 AS OK
                                          FROM TT_REL
                                         WHERE FILPAR = WK_FILCLI
                                           AND CODPAR = WK_CODCLI
                                           AND TIPPAR = 'I' );
                  ELSE
                     DELETE FROM TT_REL
                      WHERE FILPAR = WK_FILCLI
                        AND CODPAR = WK_CODCLI
                        AND TIPPAR = 'I' ;
                  END IF;
               EXCEPTION
                
                  WHEN foreign_key_violation THEN
                     IF INSTR(UPPER(SQLERRM), 'CK_REL_TIPPAR')>0 THEN  --'FK_COM_REL'
                        IF WK_MOTREJ = 'OK' THEN
                            FK_ERRO := FK_ERRO || 'Indicador Venda/'; 
                        END IF;
                        ELSIF WK_MOTREJ = 'OK' THEN 
                           FK_ERRO := FK_ERRO || 'Indicador Venda/'; 
                     END IF;
                                               END;
            END IF;
            IF ISNOTNULL(WK_TIPCLI7) = 'T' THEN
--               FK_ERRO := FK_ERRO || 'Motorista';
               BEGIN
                  IF WK_TIPCLI7 = 'T' THEN
                     INSERT INTO TT_REL (FILPAR, CODPAR, TIPPAR)
                     SELECT WK_FILCLI, WK_CODCLI, 'O'
                       FROM DUAL
                      WHERE NOT EXISTS (SELECT 1 AS OK
                                          FROM TT_REL
                                         WHERE FILPAR = WK_FILCLI
                                           AND CODPAR = WK_CODCLI
                                           AND TIPPAR = 'O');
                  ELSE
                     DELETE FROM TT_REL
                      WHERE FILPAR = WK_FILCLI
                        AND CODPAR = WK_CODCLI
                        AND TIPPAR = 'O';
                  END IF;
               EXCEPTION
                
                  WHEN foreign_key_violation THEN
                     IF INSTR(UPPER(SQLERRM), 'CK_REL_TIPPAR')>0 THEN  --'FK_COM_REL'
                        IF WK_MOTREJ = 'OK' THEN
                            FK_ERRO := FK_ERRO || 'Motorista/'; 
                        END IF;
                        ELSIF WK_MOTREJ = 'OK' THEN 
                           FK_ERRO := FK_ERRO || 'Motorista/'; 
                     END IF;
                                               END;
            END IF; 
            IF ISNOTNULL(WK_TIPCLI8) = 'T' THEN
--               FK_ERRO := FK_ERRO || 'Tec. Interno';
               BEGIN
                  IF WK_TIPCLI8 = 'T' THEN
                     INSERT INTO TT_REL (FILPAR, CODPAR, TIPPAR)
                     SELECT WK_FILCLI, WK_CODCLI, 'N'
                       FROM DUAL
                      WHERE NOT EXISTS (SELECT 1 AS OK
                                          FROM TT_REL
                                         WHERE FILPAR = WK_FILCLI
                                           AND CODPAR = WK_CODCLI
                                           AND TIPPAR = 'N');
                  ELSE
                     DELETE FROM TT_REL
                      WHERE FILPAR = WK_FILCLI
                        AND CODPAR = WK_CODCLI
                        AND TIPPAR = 'N';
                  END IF;
               EXCEPTION
                
                  WHEN foreign_key_violation THEN
                     IF INSTR(UPPER(SQLERRM), 'CK_REL_TIPPAR')>0 THEN  --'FK_COM_REL'
                        IF WK_MOTREJ = 'OK' THEN
                            FK_ERRO := FK_ERRO || 'Tec. Interno/'; 
                        END IF;
                        ELSIF WK_MOTREJ = 'OK' THEN 
                           FK_ERRO := FK_ERRO || 'Tec. Interno/'; 
                     END IF;
                                               END;
            END IF;
            IF ISNOTNULL(WK_TIPCLI9) = 'T' THEN
--               FK_ERRO := FK_ERRO || 'Tcnico Externo';
               BEGIN
                  IF WK_TIPCLI9 = 'T' THEN
                     INSERT INTO TT_REL (FILPAR, CODPAR, TIPPAR)
                     SELECT WK_FILCLI, WK_CODCLI, 'X'
                       FROM DUAL
                      WHERE NOT EXISTS (SELECT 1 AS OK
                                          FROM TT_REL
                                         WHERE FILPAR = WK_FILCLI
                                           AND CODPAR = WK_CODCLI
                                           AND TIPPAR = 'X');
                  ELSE
                     DELETE FROM TT_REL
                      WHERE FILPAR = WK_FILCLI
                        AND CODPAR = WK_CODCLI
                        AND TIPPAR = 'X';
                  END IF;
               EXCEPTION
                
                  WHEN foreign_key_violation THEN
                     IF INSTR(UPPER(SQLERRM), 'CK_REL_TIPPAR')>0 THEN  --'FK_COM_REL'
                        IF WK_MOTREJ = 'OK' THEN
                            FK_ERRO := FK_ERRO || 'Tcnico Externo/'; 
                        END IF;
                        ELSIF WK_MOTREJ = 'OK' THEN 
                           FK_ERRO := FK_ERRO || 'Tcnico Externo/'; 
                     END IF;
                                               END;
            END IF;
            IF ISNOTNULL(WK_TIPCLI10) = 'T' THEN
--               FK_ERRO := FK_ERRO || 'Cartes';
               BEGIN
                  IF WK_TIPCLI10 = 'T' THEN
                     INSERT INTO TT_REL (FILPAR, CODPAR, TIPPAR)
                     SELECT WK_FILCLI, WK_CODCLI, 'C'
                       FROM DUAL
                      WHERE NOT EXISTS (SELECT 1 AS OK
                                          FROM TT_REL
                                         WHERE FILPAR = WK_FILCLI
                                           AND CODPAR = WK_CODCLI
                                           AND TIPPAR = 'C');
                  ELSE
                     DELETE FROM TT_REL
                      WHERE FILPAR = WK_FILCLI
                        AND CODPAR = WK_CODCLI
                        AND TIPPAR = 'C';
                  END IF;
               EXCEPTION
                
                  WHEN foreign_key_violation THEN
                     IF INSTR(UPPER(SQLERRM), 'CK_REL_TIPPAR')>0 THEN  --'FK_COM_REL'
                        IF WK_MOTREJ = 'OK' THEN
                            FK_ERRO := FK_ERRO || 'Cartes/'; 
                        END IF;
                        ELSIF WK_MOTREJ = 'OK' THEN 
                           FK_ERRO := FK_ERRO || 'Cartes/'; 
                     END IF;
                                               END;
            END IF;
            
            IF (ISNOTNULL(FK_ERRO) = 'T') THEN
                --RAISE NOTICE 'Erros: %', FK_ERRO;
                
                  IF RIGHT(FK_ERRO, 1) = '/' THEN
                     FK_ERRO := LEFT(FK_ERRO, LENGTH(FK_ERRO) - 1);
                  END IF;
                                            END IF;
            
            IF (WK_MOTREJ = 'OK') AND (ISNOTNULL(FK_ERRO) = 'T') THEN
                WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR: Parceiro definido como "'||FK_ERRO||'" possui lanamentos relacionados. ',1,255);
            END IF;
           
          EXCEPTION
            WHEN OTHERS THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TABELA DE DADOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          END;
       END IF;

       IF NOT WK_MOTREJ = 'OK' THEN
           WK_STATUS := 4;
           WK_NROERR := WK_NROERR + 1;
       ELSE
           WK_STATUS := 3;
       END IF;

--       UPDATE TI_CLI SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
--        WHERE CODEXT = WK_CODEXT
--          AND COALESCE(NUMEND,0) = COALESCE(WK_NUMEND,0)
--          AND COALESCE(NUMCON,0) = COALESCE(WK_NUMCON,0);

    END IF;
    
    -- Trazendo a validao do municipio para fora pois em alguns casos no estava validando por conta da valida abaixo 
    -- IF ((COALESCE(WK_FILCLI,'000') <> COALESCE(WK_END_FILCLI,'000')) OR (COALESCE(WK_CODCLI,'      ') <> COALESCE(WK_END_CODCLI,'      ')) OR (COALESCE(WK_NUMEND,0) <> COALESCE(WK_END_NUMEND,0)) OR (COALESCE(WK_END_CODEXT,'') <> COALESCE(WK_END_CODEXT_AUX,''))) AND (WK_MOTREJ = 'OK') THEN
    IF WK_MOTREJ = 'OK' THEN    
    
        SELECT INT.CODIGO, INT.CODIBG, INT.NOMCID, INT.SIGEST
          INTO WK_MUN_CODCID, WK_MUN_CODIBG, WK_MUN_NOMCID, WK_MUN_SIGEST
          FROM (SELECT 1 AS ORDITE, MUN.CODIGO, MUN.CODIBG, MUN.NOMCID, MUN.SIGEST
                  FROM TT_MUN MUN
                 WHERE MUN.CODIBG = COALESCE(WK_CODIBG,-1)
                UNION ALL
                SELECT 2 AS ORDITE, MUN.CODIGO, MUN.CODIBG, MUN.NOMCID, MUN.SIGEST
                  FROM TT_MUN MUN
                 WHERE MUN.NOMCID LIKE CAST(UPPER(TRIM(WK_NOMCID)) AS VARCHAR(35)) AND SIGEST = CAST(TRIM(WK_SIGEST) AS VARCHAR(2))
                --UNION ALL
                --SELECT 3 AS ORDITE, MUN.CODIGO, MUN.CODIBG, MUN.NOMCID, MUN.SIGEST
                --  FROM TT_MUN MUN
                -- WHERE WK_CODCEP BETWEEN MUN.CEPINI AND MUN.CODCEP
                ) INT

         ORDER BY ORDITE
         LIMIT 1;

      IF ((COALESCE(WK_END_CODPAI, 1058) = 1058) AND (COALESCE(WK_ESTRAN,'F')='F')) THEN
         IF WK_MUN_CODCID IS NULL THEN
            WK_MOTREJ := 'MUNICPIO NO ENCONTRADO.';
         ELSIF WK_MUN_CODIBG IS NULL AND WK_CODIBG IS NULL THEN
            WK_MOTREJ := 'CDIGO DO IBGE DO MUNICPIO NO ENCONTRADO.';
         END IF;
      END IF;    
      
    END IF;          
    
    

    IF ((COALESCE(WK_FILCLI,'000') <> COALESCE(WK_END_FILCLI,'000')) OR (COALESCE(WK_CODCLI,'      ') <> COALESCE(WK_END_CODCLI,'      ')) OR (COALESCE(WK_NUMEND,0) <> COALESCE(WK_END_NUMEND,0)) OR (COALESCE(WK_END_CODEXT,'') <> COALESCE(WK_END_CODEXT_AUX,''))) AND (WK_MOTREJ = 'OK') THEN
       
       WK_END_FILCLI     := WK_FILCLI;
       WK_END_CODCLI     := WK_CODCLI;
       WK_END_NUMEND     := WK_NUMEND;
       WK_END_CODEXT_AUX := WK_END_CODEXT;

       -- Busca o maior cdigo de endereo
       SELECT MAX(NUMEND)
         INTO MAX_NUMEND
         FROM TT_END
        WHERE FILCLI = WK_FILCLI
          AND CODCLI = WK_CODCLI;

       WK_EXISTE_END := 'F';

       -- Busca o Cdigo do Endereo pelo Cdigo Externo
       IF ISNULL(WK_END_CODEXT) = 'F' THEN
                   SELECT NUMEND, CASE WHEN FILCLI IS NOT NULL THEN 'T' ELSE 'F' END
            INTO WK_NUMEND, WK_EXISTE_END
            FROM TT_END
           WHERE FILCLI = WK_FILCLI
             AND CODCLI = WK_CODCLI
             AND CODEXT = WK_END_CODEXT;
         
          IF COALESCE(WK_EXISTE_END,'F') = 'F' THEN

                          -- Podem existir cadastros enviados pela integrao mas o CODEXT da TT_END est vazio.
             -- Essa busca  apenas para evitar que seja inserido um endereo duplicado, devido ao fato do END_CODEXT da TI_CLI ter sido criado recentemente.
             -- A soluo encontrada foi comparar se existe um logradouro+numero+bairro igual ao que j foi inserido anteriormente. Se encontrar, atualiza este ao invs de inserir um novo.
             SELECT NUMEND, CASE WHEN FILCLI IS NOT NULL THEN 'T' ELSE 'F' END
               INTO WK_NUMEND, WK_EXISTE_END
               FROM TT_END
              WHERE FILCLI = WK_FILCLI
                AND CODCLI = WK_CODCLI
                AND CODEXT IS NULL
                AND ENDERE = TRIM(WK_ENDERE)
                AND NUMERO = TRIM(WK_NUMERO)
                AND BAIRRO = TRIM(WK_BAIRRO);
                       ELSE
             MAX_NUMEND := WK_NUMEND;
          END IF;

          IF COALESCE(WK_NUMEND,0) = 0 THEN
                          -- Busca o maior cdigo de endereo
             SELECT MAX(NUMEND)
               INTO MAX_NUMEND
               FROM TT_END
              WHERE FILCLI = WK_FILCLI
                AND CODCLI = WK_CODCLI;
             
             WK_NUMEND := COALESCE(MAX_NUMEND,0) + 1;
          END IF;

       ELSE
                   SELECT CASE WHEN FILCLI IS NOT NULL THEN 'T' ELSE 'F' END
            INTO WK_EXISTE_END
            FROM TT_END
           WHERE FILCLI = WK_FILCLI
             AND CODCLI = WK_CODCLI
             AND NUMEND = WK_NUMEND;
                END IF;

       IF WK_EXISTE_END IS NULL THEN
          WK_EXISTE_END := 'F';
       END IF;

      IF (LENGTH(WK_CODLOG) <> 3) THEN
         WK_CODLOG := LPAD(TO_CHAR(WK_CODLOG),3,'0');  
         --WK_MOTREJ := 'TAMANHO DO CDIGO DO LOGRADOURO INVLIDO. TAMANHO ESPERADO: 3 POSIES.';
      END IF;

      IF (LENGTH(WK_CODCEP) <> 5) THEN
         WK_CODCEP := LPAD(TO_CHAR(WK_CODCEP),5,'0');
         --WK_MOTREJ := 'TAMANHO DO CDIGO DO CEP INVLIDO. TAMANHO ESPERADO: 5 POSIES.';
      END IF;

      --Validar se o CODLOG foi informado
      IF ( ISNULL(WK_CODLOG) = 'T' ) THEN
         WK_MOTREJ := 'CDIGO DA LOCALIDADE NO INFORMADO.';
      END IF;

      --Validar se o CODCEP foi informado
      IF ( ISNULL(WK_CODCEP) = 'T' ) THEN
         WK_MOTREJ := 'CDIGO DO CEP NO INFORMADO.';
      END IF;

      IF (WK_MOTREJ = 'OK') THEN
         IF WK_REGIAO IS NOT NULL THEN
            WK_COD_REGIAO := IMPORTA_TDS( 'TD_REG', 'REGATI', 'REGIAO', 'CODTAB', WK_REGIAO, NULL, NULL, NULL );
         END IF;

         IF (WK_EXISTE = 'F') OR (WK_EXISTE_END = 'F') OR (WK_NUMEND > COALESCE(MAX_NUMEND,0)) THEN
           BEGIN
           INSERT INTO TT_END (FILCLI, CODCLI, CODFIL, NUMEND, ENDCOB, ENDCOR, FLGNAC, CODLOG, CODDDD, NUMFAX, NUMFON,
                               NUMDOC, REGIAO, CODCEP, INSEST, NUMERO, BAIRRO, COMPLE, ESTRAN, CONTAT, LOCTRA, ENDERE,
                               NOMCID, SIGEST, DDDFAX, USA_NF, TIPEND,CODCID, SIGNAT, CODDDI,
                               CODPAI, CODIBG, NOMREC, CODEXT)
                       VALUES (WK_FILCLI, WK_CODCLI, WK_FILCLI, WK_NUMEND, COALESCE(WK_ENDCOB,'F'), COALESCE(WK_ENDCOR,'F'), COALESCE(WK_FLGNAC,'F'), WK_CODLOG, SUBSTR(WK_CODDDD,1,2), WK_NUMFAX, WK_NUMFON,
                               WK_DOCEND, WK_COD_REGIAO, WK_CODCEP, WK_IE_END, WK_NUMERO, WK_BAIRRO, WK_COMPLE, WK_ESTRAN, WK_CONTAT, WK_LOCTRA, WK_ENDERE,
                               COALESCE(WK_MUN_NOMCID, WK_NOMCID), COALESCE(WK_MUN_SIGEST, WK_SIGEST), WK_DDDFAX, COALESCE(WK_USA_NF,'T'), COALESCE(WK_COD_TIPEND,2),WK_MUN_CODCID, WK_END_SIGNAT, WK_CODDDI,
                               COALESCE(WK_END_CODPAI,1058), COALESCE(WK_MUN_CODIBG, WK_CODIBG), WK_NOMREC, WK_END_CODEXT);
           EXCEPTION
             WHEN OTHERS THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR ENDERECO '||WK_NUMEND||' DO PARCEIRO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           END;
         ELSE
           BEGIN
            UPDATE TT_END SET ENDCOB = COALESCE(WK_ENDCOB,ENDCOB), ENDCOR = COALESCE(WK_ENDCOR,ENDCOR), FLGNAC = COALESCE(WK_FLGNAC,FLGNAC), CODLOG = COALESCE(WK_CODLOG,CODLOG), 
                              CODDDD = COALESCE(SUBSTR(WK_CODDDD,1,2),CODDDD), NUMFAX = COALESCE(WK_NUMFAX,NUMFAX), NUMFON = COALESCE(WK_NUMFON,NUMFON),
                              NUMDOC = COALESCE(WK_DOCEND,NUMDOC), REGIAO = COALESCE(WK_COD_REGIAO,REGIAO), CODCEP = COALESCE(WK_CODCEP,CODCEP), INSEST = COALESCE(WK_IE_END,INSEST), 
                              NUMERO = COALESCE(WK_NUMERO,NUMERO), BAIRRO = COALESCE(WK_BAIRRO,BAIRRO), COMPLE = COALESCE(WK_COMPLE,COMPLE), ESTRAN = COALESCE(WK_ESTRAN,ESTRAN), 
                              CONTAT = COALESCE(WK_CONTAT,CONTAT), LOCTRA = COALESCE(WK_LOCTRA,LOCTRA), ENDERE = COALESCE(WK_ENDERE,ENDERE),
                              NOMCID = COALESCE(WK_MUN_NOMCID, NOMCID), SIGEST = COALESCE(WK_MUN_SIGEST, WK_SIGEST), DDDFAX = COALESCE(WK_DDDFAX,DDDFAX), USA_NF = COALESCE(WK_USA_NF,USA_NF), 
                              TIPEND = COALESCE(WK_COD_TIPEND,TIPEND), CODCID = COALESCE(WK_MUN_CODCID,CODCID),
                              SIGNAT = COALESCE(WK_END_SIGNAT,SIGNAT), CODDDI = COALESCE(WK_CODDDI,CODDDI), CODPAI = COALESCE(WK_END_CODPAI,CODPAI), CODIBG = COALESCE(WK_MUN_CODIBG, WK_CODIBG),
                              NOMREC = COALESCE(WK_NOMREC,NOMREC), CODEXT = COALESCE(WK_END_CODEXT,CODEXT)
                        WHERE FILCLI = WK_FILCLI
                          AND CODCLI = WK_CODCLI
                          AND NUMEND = WK_NUMEND;

           EXCEPTION
             WHEN OTHERS THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR ENDERECO '||WK_NUMEND||' DO PARCEIRO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           END;
         END IF;

         IF NOT WK_MOTREJ = 'OK' THEN
           WK_STATUS := 4;
           WK_NROERR := WK_NROERR + 1;
         ELSE
           WK_STATUS := 3;
         END IF;
      ELSE
         WK_STATUS := 4;
         WK_NROERR := WK_NROERR + 1;
      END IF;
    END IF;

    IF ((COALESCE(WK_FILCLI,'000') <> COALESCE(WK_CON_FILCLI,'000')) OR (COALESCE(WK_CODCLI,'      ') <> COALESCE(WK_CON_CODCLI,'      ')) OR (COALESCE(WK_NUMCON,0) <> COALESCE(WK_CON_NUMCON,0)))
       AND (WK_MOTREJ = 'OK') THEN
       WK_CON_FILCLI := WK_FILCLI;
       WK_CON_CODCLI := WK_CODCLI;
       WK_CON_NUMCON := WK_NUMCON;
     SELECT CASE WHEN COUNT(*) > 0 THEN 'T' ELSE 'F' END
       INTO WK_EXISTE
       FROM TT_CON
      WHERE FILCLI = WK_FILCLI
        AND CODCLI = WK_CODCLI
        AND NUMCON = WK_NUMCON;
       IF (WK_EXISTE = 'F') AND  (WK_NCONTA IS NOT NULL) THEN

           BEGIN
           INSERT INTO TT_CON (FILCLI, CODCLI, NUMCON, SEXCON, DATNAS, DDDCON, CELCON, TELCON, E_MAIL, CONTAT, DDDCEL,
                               DDDFAX, NUMFAX, NOMTRA, CODDDI, DOCCON, RETPRO)
                       VALUES (WK_FILCLI, WK_CODCLI, WK_NUMCON, COALESCE(WK_SEXOCO, 0), WK_NASCNT, WK_DDDCON, WK_CELCON, WK_TELCON, WK_E_MAIL, WK_NCONTA, WK_DDDCEL,
                               WK_DDDFXC, WK_NUMFXC, WK_TRACON, WK_DDICON, WK_CON_DOCCON, COALESCE(WK_CON_RETPRO,'F'));

           EXCEPTION
             WHEN OTHERS THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR CONTATO '||WK_NUMCON||' DO PARCEIRO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           END;

           IF NOT WK_MOTREJ = 'OK' THEN
              WK_STATUS := 4;
              WK_NROERR := WK_NROERR + 1;
           ELSE
              WK_STATUS := 3;
           END IF;

--     UPDATE TI_CLI SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
--            WHERE CODEXT = WK_CODEXT
--              AND COALESCE(NUMEND,0) = COALESCE(WK_NUMEND,0)
--              AND COALESCE(NUMCON,0) = COALESCE(WK_NUMCON,0);

       ELSE

           BEGIN

           UPDATE TT_CON SET SEXCON = COALESCE(WK_SEXOCO, SEXCON),
                             DATNAS = COALESCE(WK_NASCNT,DATNAS),
                             DDDCON = COALESCE(WK_DDDCON,DDDCON),
                             CELCON = COALESCE(WK_CELCON,CELCON),
                             TELCON = COALESCE(WK_TELCON,TELCON),
                             E_MAIL = COALESCE(WK_E_MAIL,E_MAIL),
                             CONTAT = COALESCE(WK_NCONTA,CONTAT),
                             DDDCEL = COALESCE(WK_DDDCEL,DDDCEL),
                             DDDFAX = COALESCE(WK_DDDFXC,DDDFAX),
                             NUMFAX = COALESCE(WK_NUMFXC,NUMFAX),
                             NOMTRA = COALESCE(WK_TRACON,NOMTRA),
                             CODDDI = COALESCE(WK_DDICON,CODDDI),
                             DOCCON = COALESCE(WK_CON_DOCCON,DOCCON),
                             RETPRO = coalesce(WK_CON_RETPRO,RETPRO)
                       WHERE FILCLI = WK_FILCLI
                         AND CODCLI = WK_CODCLI
                         AND NUMCON = WK_NUMCON;

           EXCEPTION
             WHEN OTHERS THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR CONTATO '||WK_NUMCON||' DO PARCEIRO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           END;

           IF NOT WK_MOTREJ = 'OK' THEN
              WK_STATUS := 4;
              WK_NROERR := WK_NROERR + 1;
           ELSE
              WK_STATUS := 3;
           END IF;

--           UPDATE TI_CLI SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
--            WHERE CODEXT = WK_CODEXT
--              AND COALESCE(NUMEND,0) = COALESCE(WK_NUMEND,0)
--              AND COALESCE(NUMCON,0) = COALESCE(WK_NUMCON,0);

       END IF;
    END IF;

    -- Controle do indicador de Exportao - foi necessrio a execuo nesse ponto pois todas as atualizaoes nas partes "TT_SPC, TT_END, TT_CON e TT_REL" geram um update na TT_CLI o qual ir mudar a flag.
    UPDATE TT_CLI SET INDEXP = 'I'
     WHERE FILCLI = WK_FILCLI
       AND CODCLI = WK_CODCLI;

     UPDATE TI_CLI SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
      WHERE SEQUEN = WK_SEQUEN;

     WK_QTDIMP := WK_QTDIMP + 1;
  
        WK_NUMREG := WK_NUMREG - 1;
       CLOSE CR_PARCEIRO;
   END LOOP;
   IF WK_NROERR <> 0 THEN
      SELECT MAI_FR, MAI_TO, SAC_E_MAIL
        INTO WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL
        FROM TT_CFG;
      IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
         INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO, MAI_CC,
                             TEXTOS,TIPMSG)
                     VALUES ('001','F',AGORA(),'IMPORTAO DE PARCEIROS',WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL,
                             'Problema na importao de '||wk_nroerr||' parceiros. Verifique!','T');
      END IF;
    END IF;

   UPDATE TI_CLI SET STATUS = CASE WHEN STATUS = 3
                                   THEN 1
                                   ELSE 2
                               END
    WHERE STATUS IN (3,4);
   IF WK_MANTEM = 'F' THEN
      IF WK_DIALIM > 0 THEN
         DELETE FROM TI_CLI
          WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
            AND STATUS = 1;
      ELSE
         DELETE FROM TI_CLI
          WHERE STATUS = 1;
      END IF;
   END IF;
   UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = WK_QTDIMP, CNTIMP = WK_CNTIMP, TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP WHERE TABELA = 'CLI';
   ELSE RAISE EXCEPTION 'PG-20001 IMPORTAO DE PARCEIROS NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;
   
   SELECT COUNT(*) INTO WK_RESTO FROM TI_CLI WHERE STATUS = 0;
   IF WK_RESTO > 0 THEN
     RETURN 'EXISTEM '||WK_RESTO||' PARCEIROS NO IMPORTADOS';
   ELSE
     RETURN 'OK';
   END IF;
   
END;
$$ language 'plpgsql';





/*-- SEQ 1646 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_PLA () CASCADE;

/*-- SEQ 1647 --*/
CREATE OR REPLACE FUNCTION IMPORTA_PLA ()
RETURNS VARCHAR AS $$
DECLARE


-- Declarao de variveis e cursores
   WK_FILPGT                     TI_PLA.FILPGT%TYPE;
   WK_PREINF                     TI_PLA.PREINF%TYPE;
   WK_ATU_EM                     TI_PLA.ATU_EM%TYPE;
   WK_DATMAX                     TI_PLA.DATMAX%TYPE;
   WK_DATMIN                     TI_PLA.DATMIN%TYPE;
   WK_ABAMAX                     TI_PLA.ABAMAX%TYPE;
   WK_ABAMIN                     TI_PLA.ABAMIN%TYPE;
   WK_ACRDIA                     TI_PLA.ACRDIA%TYPE;
   WK_DE1IDE                     TI_PLA.DE1IDE%TYPE;
   WK_DE1MAX                     TI_PLA.DE1MAX%TYPE;
   WK_DE1MIN                     TI_PLA.DE1MIN%TYPE;
   WK_DESANT                     TI_PLA.DESANT%TYPE;
   WK_PERCOM                     TI_PLA.PERCOM%TYPE;
   WK_PERENT                     TI_PLA.PERENT%TYPE;
   WK_VLRMAX                     TI_PLA.VLRMAX%TYPE;
   WK_VLRMIN                     TI_PLA.VLRMIN%TYPE;
   WK_APLICA                     TI_PLA.APLICA%TYPE;
   WK_CODMOE                     TI_PLA.CODMOE%TYPE;
   WK_MOECOR                     TI_PLA.MOECOR%TYPE;
   WK_ATRMAX                     TI_PLA.ATRMAX%TYPE;
   WK_CARMAX                     TI_PLA.CARMAX%TYPE;
   WK_CODCOB                     TI_PLA.CODCOB%TYPE;
   WK_COMSOB                     TI_PLA.COMSOB%TYPE;
   WK_DIAANT                     TI_PLA.DIAANT%TYPE;
   WK_FLGJUR                     TI_PLA.FLGJUR%TYPE;
   WK_FORMUL                     TI_PLA.FORMUL%TYPE;
   WK_MEDMAX                     TI_PLA.MEDMAX%TYPE;
   WK_NIVUSU                     TI_PLA.NIVUSU%TYPE;
   WK_NROMES                     TI_PLA.NROMES%TYPE;
   WK_PARIDE                     TI_PLA.PARIDE%TYPE;
   WK_PARMAX                     TI_PLA.PARMAX%TYPE;
   WK_PARMIN                     TI_PLA.PARMIN%TYPE;
   WK_PARVEN                     TI_PLA.PARVEN%TYPE;
   WK_PERIOD                     TI_PLA.PERIOD%TYPE;
   WK_PORDEM                     TI_PLA.PORDEM%TYPE;
   WK_PORENT                     TI_PLA.PORENT%TYPE;
   WK_PRAIDE                     TI_PLA.PRAIDE%TYPE;
   WK_PRAMAX                     TI_PLA.PRAMAX%TYPE;
   WK_PRAMIN                     TI_PLA.PRAMIN%TYPE;
   WK_PRIIDE                     TI_PLA.PRIIDE%TYPE;
   WK_PRIMAX                     TI_PLA.PRIMAX%TYPE;
   WK_PRIMIN                     TI_PLA.PRIMIN%TYPE;
   WK_PZOIDE                     TI_PLA.PZOIDE%TYPE;
   WK_PZOMAX                     TI_PLA.PZOMAX%TYPE;
   WK_PZOMIN                     TI_PLA.PZOMIN%TYPE;
   WK_SIGNAT                     TI_PLA.SIGNAT%TYPE;
   WK_TIPPLA                     TI_PLA.TIPPLA%TYPE;
   WK_TOTLIM                     TI_PLA.TOTLIM%TYPE;
   WK_CARONL                     TI_PLA.CARONL%TYPE;
   WK_ENTVLR                     TI_PLA.ENTVLR%TYPE;
   WK_FATURA                     TI_PLA.FATURA%TYPE;
   WK_FLGESP                     TI_PLA.FLGESP%TYPE;
   WK_JURTOT                     TI_PLA.JURTOT%TYPE;
   WK_APEPGT                     TI_PLA.APEPGT%TYPE;
   WK_DESPGT                     TI_PLA.DESPGT%TYPE;
   WK_DATPRE                     TI_PLA.DATPRE%TYPE;
   WK_CLASS1                     TI_PLA.CLASS1%TYPE;
   WK_CLASS2                     TI_PLA.CLASS2%TYPE;
   WK_CLASS3                     TI_PLA.CLASS3%TYPE;
   WK_CLASS4                     TI_PLA.CLASS4%TYPE;
   WK_CODEXT                     TI_PLA.CODEXT%TYPE;
   WK_TIPCOB                     TI_PLA.TIPCOB%TYPE;
   WK_USACAM                     TI_PLA.USACAM%TYPE;
   WK_USACRE                     TI_PLA.USACRE%TYPE;
   WK_USAOUT                     TI_PLA.USAOUT%TYPE;
   WK_USACHE                     TI_PLA.USACHE%TYPE;
   WK_USADIN                     TI_PLA.USADIN%TYPE;
   WK_USATEF                     TI_PLA.USATEF%TYPE;
   WK_USAC_C                     TI_PLA.USAC_C%TYPE;
   WK_PROPOR                     TI_PLA.PROPOR%TYPE;
   WK_CODPRT                     TI_PLA.CODPRT%TYPE;
   WK_PRZPRT                     TI_PLA.PRZPRT%TYPE;
   WK_CODBAI                     TI_PLA.CODBAI%TYPE;
   WK_PRZBAI                     TI_PLA.PRZBAI%TYPE;
   WK_CHRREC                     TI_PLA.CHRREC%TYPE;
   WK_DESREC                     TI_PLA.DESREC%TYPE;
   WK_RENEGO                     TI_PLA.RENEGO%TYPE;
   WK_JURREN                     TI_PLA.JURREN%TYPE;
   WK_RENSOB                     TI_PLA.RENSOB%TYPE;
   WK_DESJUR                     TI_PLA.DESJUR%TYPE;
   WK_DIATIT                     TI_PLA.DIATIT%TYPE;
   WK_VLTXMU                     TI_PLA.VLTXMU%TYPE;
   WK_INTPMU                     TI_PLA.INTPMU%TYPE;
   WK_USACPP                     TI_PLA.USACPP%TYPE;
   WK_BONPGT                     TI_PLA.BONPGT%TYPE;
   WK_DATIMP                     TI_PLA.DATIMP%TYPE;
   WK_STATUS                     TI_PLA.STATUS%TYPE;
   WK_MOTREJ                     TI_PLA.MOTREJ%TYPE;
   WK_NATDEN                     TI_PLA.NATDEN%TYPE;
   WK_NATFOR                     TI_PLA.NATFOR%TYPE;
   WK_NROERR                     Numeric;
   WK_QTDIMP                     Numeric;
   WK_IMPORT                     TT_IED.IMPORT%TYPE;
   WK_MANTEM                     TT_IED.MANTEM%TYPE;
   WK_CNTIMP                     TT_IED.CNTIMP%TYPE;
   WK_MAI_FR                     TT_CFG.MAI_FR%TYPE;
   WK_MAI_TO                     TT_CFG.MAI_TO%TYPE;
   WK_COD_CODMOE                 TT_PLA.CODMOE%TYPE;
   WK_COD_MOECOR                 TT_PLA.MOECOR%TYPE;
   WK_COD_CODNAT                 TT_PLA.CODNAT%TYPE;
   WK_COD_CODPGT                 TT_PLA.CODPGT%TYPE;
   WK_COD_CLASS1                 TT_PLA.CLASS1%TYPE;
   WK_COD_CLASS2                 TT_PLA.CLASS2%TYPE;
   WK_COD_CLASS3                 TT_PLA.CLASS3%TYPE;
   WK_COD_CLASS4                 TT_PLA.CLASS4%TYPE;
   WK_COUNT                      Numeric;
   WK_DIALIM                     TT_IED.DIALIM%TYPE;
   WK_DATCRI                     TI_PLA.DATCRI%TYPE;

   WK_CARFAT                     TI_PLA.CARFAT%TYPE;
   WK_CATEG1                     TI_PLA.CATEG1%TYPE;
   WK_CATEG2                     TI_PLA.CATEG2%TYPE;
   WK_CATEG3                     TI_PLA.CATEG3%TYPE;
   WK_TIPCCC                     TI_PLA.TIPCCC%TYPE;

   WK_COD_CATEG1                 TT_PLA.CATEG1%TYPE;
   WK_COD_CATEG2                 TT_PLA.CATEG2%TYPE;
   WK_COD_CATEG3                 TT_PLA.CATEG3%TYPE;
   WK_COD_TIPCCC                 TT_PLA.TIPCCC%TYPE;
   WK_SOBNEG                     TT_PLA.SOBNEG%TYPE;
   WK_MINPAR                     TT_PLA.MINPAR%TYPE;

   W_EXISTE      Numeric(1);


CR_PLANOS CURSOR(pDATCRI TI_PLA.DATCRI%TYPE) IS
--Status => 0 no processado
--       => 1 processado com sucesso
--       => 2 processado com erro
  SELECT *
    FROM (SELECT FILPGT,PREINF,ATU_EM,DATMAX,DATMIN,ABAMAX,ABAMIN,ACRDIA,DE1IDE,DE1MAX,DE1MIN,DESANT,
                 PERCOM,PERENT,VLRMAX,VLRMIN,APLICA,CODMOE,MOECOR,ATRMAX,CARMAX,CODCOB,COMSOB,DIAANT,FLGJUR,
                 FORMUL,MEDMAX,NIVUSU,NROMES,PARIDE,PARMAX,PARMIN,PARVEN,PERIOD,PORDEM,PORENT,PRAIDE,PRAMAX,
                 PRAMIN,PRIIDE,PRIMAX,PRIMIN,PZOIDE,PZOMAX,PZOMIN,SIGNAT,TIPPLA,TOTLIM,CARONL,ENTVLR,FATURA,
                 FLGESP,JURTOT,APEPGT,DESPGT,DATPRE,CLASS1,CLASS2,CLASS3,CLASS4,CODEXT,TIPCOB,USACAM,
                 USACRE,USAOUT,USACHE,USADIN,USATEF,USAC_C,PROPOR,CODPRT,PRZPRT,CODBAI,PRZBAI,CHRREC,DESREC,
                 RENEGO,JURREN,RENSOB,DESJUR,DIATIT,VLTXMU,INTPMU,USACPP,BONPGT,NATDEN,NATFOR,
                 CARFAT,CATEG1,CATEG2,CATEG3,TIPCCC,SOBNEG,MINPAR
            FROM TI_PLA
           WHERE STATUS = 0
             AND DATCRI BETWEEN TRUNC(pDATCRI)
                            AND ADD_DAY(TRUNC(pDATCRI),1)
           ORDER BY DATCRI
         ) TAB
   LIMIT 1;

-- Incio da funo
BEGIN
   -- RFMP 80113
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20008 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

   SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
     INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
     FROM TT_IED
   WHERE TABELA = 'PLA';

   IF WK_IMPORT = 'T' THEN
     WK_CNTIMP := WK_CNTIMP + 1;
     WK_NROERR := 0;
     WK_QTDIMP := 0;

     LOOP
       WK_COD_CODMOE := NULL;
       WK_COD_MOECOR := NULL;
       WK_COD_CODPGT := NULL;
       WK_COD_CODNAT := NULL;
       WK_COD_CLASS1 := NULL;
       WK_COD_CLASS2 := NULL;
       WK_COD_CLASS3 := NULL;
       WK_COD_CLASS4 := NULL;

       SELECT MIN(DATCRI)
         INTO WK_DATCRI
         FROM TI_PLA
        WHERE STATUS = 0;

       OPEN CR_PLANOS(WK_DATCRI);
       FETCH CR_PLANOS INTO WK_FILPGT,WK_PREINF,WK_ATU_EM,WK_DATMAX,WK_DATMIN,WK_ABAMAX,
                            WK_ABAMIN,WK_ACRDIA,WK_DE1IDE,WK_DE1MAX,WK_DE1MIN,WK_DESANT,WK_PERCOM,
                            WK_PERENT,WK_VLRMAX,WK_VLRMIN,WK_APLICA,WK_CODMOE,WK_MOECOR,WK_ATRMAX,
                            WK_CARMAX,WK_CODCOB,WK_COMSOB,WK_DIAANT,WK_FLGJUR,WK_FORMUL,WK_MEDMAX,
                            WK_NIVUSU,WK_NROMES,WK_PARIDE,WK_PARMAX,WK_PARMIN,WK_PARVEN,WK_PERIOD,
                            WK_PORDEM,WK_PORENT,WK_PRAIDE,WK_PRAMAX,WK_PRAMIN,WK_PRIIDE,WK_PRIMAX,
                            WK_PRIMIN,WK_PZOIDE,WK_PZOMAX,WK_PZOMIN,WK_SIGNAT,WK_TIPPLA,WK_TOTLIM,
                            WK_CARONL,WK_ENTVLR,WK_FATURA,WK_FLGESP,WK_JURTOT,WK_APEPGT,WK_DESPGT,
                            WK_DATPRE,WK_CLASS1,WK_CLASS2,WK_CLASS3,WK_CLASS4,WK_CODEXT,
                            WK_TIPCOB,WK_USACAM,WK_USACRE,WK_USAOUT,WK_USACHE,WK_USADIN,WK_USATEF,
                            WK_USAC_C,WK_PROPOR,WK_CODPRT,WK_PRZPRT,WK_CODBAI,WK_PRZBAI,WK_CHRREC,
                            WK_DESREC,WK_RENEGO,WK_JURREN,WK_RENSOB,WK_DESJUR,WK_DIATIT,WK_VLTXMU,
                            WK_INTPMU,WK_USACPP,WK_BONPGT,WK_NATDEN,WK_NATFOR,WK_CARFAT,WK_CATEG1,
                            WK_CATEG2,WK_CATEG3,WK_TIPCCC,WK_SOBNEG,WK_MINPAR;

       IF NOT FOUND THEN
          CLOSE CR_PLANOS;
          EXIT;
       END IF;

       WK_MOTREJ     := 'OK';
       IF WK_CODMOE IS NOT NULL THEN
          WK_COD_CODMOE := IMPORTA_TDS( 'TD_MOE', 'MOEATI', 'DESMOE', 'CODTAB', WK_CODMOE, NULL, NULL, NULL );
       END IF;
       IF WK_MOECOR IS NOT NULL THEN
          WK_COD_MOECOR := IMPORTA_TDS( 'TD_MOE', 'MOEATI', 'DESMOE', 'CODTAB', WK_MOECOR, NULL, NULL, NULL );
       END IF;
       IF WK_CLASS1 IS NOT NULL THEN
          WK_COD_CLASS1 := IMPORTA_TDS( 'TD_CL1', 'CL1ATI', 'CLASS1', 'CODTAB', WK_CLASS1, NULL, NULL, NULL );
       ELSE
          WK_COD_CLASS1 := 0;
       END IF;
       IF WK_CLASS2 IS NOT NULL THEN
          WK_COD_CLASS2 := IMPORTA_TDS( 'TD_CL2', 'CL2ATI', 'CLASS2', 'CODTAB', WK_CLASS2, NULL, NULL, NULL );
       ELSE
          WK_COD_CLASS2 := 0;
       END IF;
       IF WK_CLASS3 IS NOT NULL THEN
          WK_COD_CLASS3 := IMPORTA_TDS( 'TD_CL3', 'CL3ATI', 'CLASS3', 'CODTAB', WK_CLASS3, NULL, NULL, NULL );
       ELSE
          WK_COD_CLASS3 := 0;
       END IF;
       IF WK_CLASS4 IS NOT NULL THEN
          WK_COD_CLASS4 := IMPORTA_TDS( 'TD_CL4', 'CL4ATI', 'CLASS4', 'CODTAB', WK_CLASS4, NULL, NULL, NULL );
       ELSE
          WK_COD_CLASS4 := 0;
       END IF;

       IF WK_CATEG1 IS NOT NULL THEN
          WK_COD_CATEG1 := IMPORTA_TDS( 'TD_CT1', 'CT1ATI', 'NOMCT1', 'CODTAB', WK_CATEG1, NULL, NULL, NULL );
       ELSE
          WK_COD_CATEG1 := 0;
       END IF;

       IF WK_CATEG2 IS NOT NULL THEN
          WK_COD_CATEG2 := IMPORTA_TDS( 'TD_CT2', 'CT2ATI', 'NOMCT2', 'CODTAB', WK_CATEG2, NULL, NULL, NULL );
       ELSE
          WK_COD_CATEG2 := 0;
       END IF;
       IF WK_CATEG3 IS NOT NULL THEN
          WK_COD_CATEG3 := IMPORTA_TDS( 'TD_CT3', 'CT3ATI', 'NOMCT3', 'CODTAB', WK_CATEG3, NULL, NULL, NULL );
       ELSE
          WK_COD_CATEG3 := 0;
       END IF;

       W_EXISTE := 0;
       SELECT 1 INTO W_EXISTE
         FROM TT_PLA TP
        WHERE TP.FILPGT = WK_FILPGT
          AND TP.DESPGT = WK_DESPGT;
       IF W_EXISTE IS NULL THEN
           W_EXISTE := 0;
       END IF;


       SELECT CODTAB
         INTO WK_COD_TIPCCC
         FROM TD_CCC
        WHERE DESCCC = WK_TIPCCC;

       IF WK_NATDEN IS NULL AND WK_NATFOR IS NULL THEN
         WK_COD_CODNAT := 0;
       ELSE
         SELECT TN.CODTAB
         INTO WK_COD_CODNAT
         FROM TD_NAT TN
         WHERE TN.NATDEN = WK_NATDEN
           AND TN.NATFOR = WK_NATFOR;
       END IF;


       IF W_EXISTE = 0 THEN --registro novo

          SELECT LPAD(TO_CHAR(TC.ULTCOD + 1),3,' ')
            INTO WK_COD_CODPGT
            FROM TT_COD TC
           WHERE TC.CODTAB = 'PLA'
             AND TC.FILCOD = WK_FILPGT;

          IF WK_COD_CODPGT IS NULL THEN
             SELECT COUNT(*)
               INTO WK_COUNT
               FROM TT_COD
              WHERE CODTAB = 'PLA'
                AND FILCOD = WK_FILPGT;

             IF WK_COUNT = 0 THEN
                INSERT INTO TT_COD (CODTAB,FILCOD,ULTCOD) VALUES ('PLA',WK_FILPGT,0);
             END IF;

             WK_COD_CODPGT := COALESCE(WK_COD_CODPGT,'1');
          END IF;

          UPDATE TT_COD SET ULTCOD = TO_NUMBER(WK_COD_CODPGT)
           WHERE CODTAB = 'PLA'
             AND FILCOD = WK_FILPGT;

          BEGIN
            INSERT INTO TT_PLA(FILPGT,CODPGT,PREINF,ATU_EM,DATMAX,DATMIN,ABAMAX,ABAMIN,ACRDIA,DE1IDE,DE1MAX,DE1MIN,DESANT,
                               PERCOM,PERENT,VLRMAX,VLRMIN,APLICA,CODMOE,MOECOR,ATRMAX,CARMAX,CODCOB,COMSOB,DIAANT,FLGJUR,
                               FORMUL,MEDMAX,NIVUSU,NROMES,PARIDE,PARMAX,PARMIN,PARVEN,PERIOD,PORDEM,PORENT,PRAIDE,PRAMAX,
                               PRAMIN,PRIIDE,PRIMAX,PRIMIN,PZOIDE,PZOMAX,PZOMIN,SIGNAT,TIPPLA,TOTLIM,CARONL,ENTVLR,FATURA,
                               FLGESP,JURTOT,APEPGT,DESPGT,DATPRE,CLASS1,CLASS2,CLASS3,CLASS4,CODNAT,CODEXT,TIPCOB,USACAM,
                               USACRE,USAOUT,USACHE,USADIN,USATEF,USAC_C,PROPOR,CODPRT,PRZPRT,CODBAI,PRZBAI,CHRREC,DESREC,
                               RENEGO,JURREN,RENSOB,DESJUR,DIATIT,VLTXMU,INTPMU,USACPP,BONPGT,CARFAT,CATEG1,CATEG2,CATEG3,TIPCCC,
                               SOBNEG,MINPAR)
                        VALUES(WK_FILPGT,WK_COD_CODPGT,WK_PREINF,WK_ATU_EM,WK_DATMAX,WK_DATMIN,WK_ABAMAX,
                               WK_ABAMIN,WK_ACRDIA,WK_DE1IDE,WK_DE1MAX,WK_DE1MIN,WK_DESANT,WK_PERCOM,
                               WK_PERENT,WK_VLRMAX,WK_VLRMIN,WK_APLICA,WK_COD_CODMOE,WK_COD_MOECOR,WK_ATRMAX,
                               WK_CARMAX,WK_CODCOB,WK_COMSOB,WK_DIAANT,WK_FLGJUR,WK_FORMUL,WK_MEDMAX,
                               WK_NIVUSU,WK_NROMES,WK_PARIDE,WK_PARMAX,WK_PARMIN,WK_PARVEN,WK_PERIOD,
                               WK_PORDEM,WK_PORENT,WK_PRAIDE,WK_PRAMAX,WK_PRAMIN,WK_PRIIDE,WK_PRIMAX,
                               WK_PRIMIN,WK_PZOIDE,WK_PZOMAX,WK_PZOMIN,WK_SIGNAT,WK_TIPPLA,WK_TOTLIM,
                               WK_CARONL,COALESCE(WK_ENTVLR,'F'),WK_FATURA,COALESCE(WK_FLGESP,'F'),COALESCE(WK_JURTOT,'F'),
                               WK_APEPGT,WK_DESPGT,
                               WK_DATPRE,WK_COD_CLASS1,WK_COD_CLASS2,WK_COD_CLASS3,WK_COD_CLASS4,WK_COD_CODNAT,WK_CODEXT,
                               WK_TIPCOB,COALESCE(WK_USACAM,'F'),COALESCE(WK_USACRE,'F'),COALESCE(WK_USAOUT,'F'),
                               COALESCE(WK_USACHE,'F'),COALESCE(WK_USADIN,'F'),COALESCE(WK_USATEF,'F'),
                               COALESCE(WK_USAC_C,'F'),COALESCE(WK_PROPOR,'F'),WK_CODPRT,WK_PRZPRT,WK_CODBAI,WK_PRZBAI,WK_CHRREC,
                               COALESCE(WK_DESREC,'F'),WK_RENEGO,WK_JURREN,WK_RENSOB,WK_DESJUR,WK_DIATIT,WK_VLTXMU,
                               WK_INTPMU,COALESCE(WK_USACPP,'F'),WK_BONPGT,WK_CARFAT,WK_COD_CATEG1,WK_COD_CATEG2,WK_COD_CATEG3,WK_COD_TIPCCC,
                               WK_SOBNEG,WK_MINPAR);

          EXCEPTION
                          
             WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PLANOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PLANOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PLANOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PLANOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PLANOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PLANOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PLANOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                       END;
       ELSE
          SELECT TP.CODPGT
            INTO WK_COD_CODPGT
            FROM TT_PLA TP
           WHERE TP.FILPGT = WK_FILPGT
             AND TP.DESPGT = WK_DESPGT;

       BEGIN
          UPDATE TT_PLA SET PREINF = WK_PREINF,
                            ATU_EM = WK_ATU_EM,
                            DATMAX = WK_DATMAX,
                            DATMIN = WK_DATMIN,
                            ABAMAX = WK_ABAMAX,
                            ABAMIN = WK_ABAMIN,
                            ACRDIA = WK_ACRDIA,
                            DE1IDE = WK_DE1IDE,
                            DE1MAX = WK_DE1MAX,
                            DE1MIN = WK_DE1MIN,
                            DESANT = WK_DESANT,
                            PERCOM = WK_PERCOM,
                            PERENT = WK_PERENT,
                            VLRMAX = WK_VLRMAX,
                            VLRMIN = WK_VLRMIN,
                            APLICA = WK_APLICA,
                            CODMOE = WK_COD_CODMOE,
                            MOECOR = WK_COD_MOECOR,
                            ATRMAX = WK_ATRMAX,
                            CARMAX = WK_CARMAX,
                            CODCOB = WK_CODCOB,
                            COMSOB = WK_COMSOB,
                            DIAANT = WK_DIAANT,
                            FLGJUR = WK_FLGJUR,
                            FORMUL = WK_FORMUL,
                            MEDMAX = WK_MEDMAX,
                            NIVUSU = WK_NIVUSU,
                            NROMES = WK_NROMES,
                            PARIDE = WK_PARIDE,
                            PARMAX = WK_PARMAX,
                            PARMIN = WK_PARMIN,
                            PARVEN = WK_PARVEN,
                            PERIOD = WK_PERIOD,
                            PORDEM = WK_PORDEM,
                            PORENT = WK_PORENT,
                            PRAIDE = WK_PRAIDE,
                            PRAMAX = WK_PRAMAX,
                            PRAMIN = WK_PRAMIN,
                            PRIIDE = WK_PRIIDE,
                            PRIMAX = WK_PRIMAX,
                            PRIMIN = WK_PRIMIN,
                            PZOIDE = WK_PZOIDE,
                            PZOMAX = WK_PZOMAX,
                            PZOMIN = WK_PZOMIN,
                            SIGNAT = WK_SIGNAT,
                            TIPPLA = WK_TIPPLA,
                            TOTLIM = WK_TOTLIM,
                            CARONL = WK_CARONL,
                            ENTVLR = COALESCE(WK_ENTVLR,'F'),
                            FATURA = WK_FATURA,
                            FLGESP = COALESCE(WK_FLGESP,'F'),
                            JURTOT = COALESCE(WK_JURTOT,'F'),
                            APEPGT = WK_APEPGT,
                            DESPGT = WK_DESPGT,
                            DATPRE = WK_DATPRE,
                            CLASS1 = WK_COD_CLASS1,
                            CLASS2 = WK_COD_CLASS2,
                            CLASS3 = WK_COD_CLASS3,
                            CLASS4 = WK_COD_CLASS4,
                            CODNAT = WK_COD_CODNAT,
                            CODEXT = WK_CODEXT,
                            TIPCOB = WK_TIPCOB,
                            USACAM = COALESCE(WK_USACAM,'F'),
                            USACRE = COALESCE(WK_USACRE,'F'),
                            USAOUT = COALESCE(WK_USAOUT,'F'),
                            USACHE = COALESCE(WK_USACHE,'F'),
                            USADIN = COALESCE(WK_USADIN,'F'),
                            USATEF = COALESCE(WK_USATEF,'F'),
                            USAC_C = COALESCE(WK_USAC_C,'F'),
                            PROPOR = COALESCE(WK_PROPOR,'F'),
                            CODPRT = WK_CODPRT,
                            PRZPRT = WK_PRZPRT,
                            CODBAI = WK_CODBAI,
                            PRZBAI = WK_PRZBAI,
                            CHRREC = WK_CHRREC,
                            DESREC = COALESCE(WK_DESREC,'F'),
                            RENEGO = WK_RENEGO,
                            JURREN = WK_JURREN,
                            RENSOB = WK_RENSOB,
                            DESJUR = WK_DESJUR,
                            DIATIT = WK_DIATIT,
                            VLTXMU = WK_VLTXMU,
                            INTPMU = WK_INTPMU,
                            USACPP = COALESCE(WK_USACPP,'F'),
                            BONPGT = WK_BONPGT,
                            CARFAT = WK_CARFAT,
                            CATEG1 = WK_COD_CATEG1,
                            CATEG2 = WK_COD_CATEG2,
                            CATEG3 = WK_COD_CATEG3,
                            TIPCCC = WK_COD_TIPCCC,
                            SOBNEG = WK_SOBNEG,
                            MINPAR = WK_MINPAR
           WHERE FILPGT = WK_FILPGT
             AND CODPGT = WK_COD_CODPGT;
       EXCEPTION
                    
          WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PLANOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PLANOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PLANOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PLANOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PLANOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PLANOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PLANOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                   END;
       END IF;

       IF NOT WK_MOTREJ = 'OK' THEN
          WK_STATUS := 4;
          WK_NROERR := WK_NROERR + 1;
       ELSE
         WK_STATUS := 3;
       END IF;

       UPDATE TI_PLA SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
        WHERE FILPGT = WK_FILPGT
          AND DESPGT = WK_DESPGT
          AND DATIMP IS NULL;

       WK_QTDIMP := WK_QTDIMP + 1;
       CLOSE CR_PLANOS;
     END LOOP;

     IF WK_NROERR <> 0 THEN
       SELECT MAI_FR, MAI_TO
         INTO WK_MAI_FR, WK_MAI_TO
         FROM TT_CFG;
       IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
          INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO,
                              TEXTOS,TIPMSG)
                      VALUES ('001','F',AGORA(),'IMPORTAO PLANOS',WK_MAI_FR, WK_MAI_TO,
                              'Problema na importao de '||wk_nroerr||' planos. Verifique!','T');
       END IF;
     END IF;

     UPDATE TI_PLA SET STATUS = CASE WHEN STATUS = 3
                                     THEN 1
                                     ELSE 2
                                 END
      WHERE STATUS IN (3,4);

     IF WK_MANTEM = 'F' THEN
        IF WK_DIALIM > 0 THEN
           DELETE FROM TI_PLA
            WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
              AND STATUS = 1;
        ELSE
           DELETE FROM TI_PLA
            WHERE STATUS = 1;
        END IF;
     END IF;

     UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = WK_QTDIMP, CNTIMP = WK_CNTIMP, TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP WHERE TABELA = 'PLA';
   ELSE RAISE EXCEPTION 'PG-20001 IMPORTAO DE PLANOS NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;

  RETURN NULL;

END;
$$ language 'plpgsql';





/*-- SEQ 1648 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_PRE () CASCADE;

/*-- SEQ 1649 --*/
CREATE OR REPLACE FUNCTION IMPORTA_PRE ()
RETURNS VARCHAR AS $$
DECLARE


-- Objetivo:
-- 1) Importao das tabelas referentes a limites de conta corrente (TD_CCC e TT_LIM)
   WK_CODFIL                     TI_PRE.CODFIL%TYPE;
   WK_CATEG1                     TI_PRE.CATEG1%TYPE;
   WK_CATEG2                     TI_PRE.CATEG2%TYPE;
   WK_CATEG3                     TI_PRE.CATEG3%TYPE;
   WK_CODEXT                     TI_PRE.CODEXT%TYPE;
   WK_FILMAT                     TT_GRA.FILMAT%TYPE;
   WK_CODMAT                     TT_GRA.CODMAT%TYPE;
   WK_CODCOR                     TT_GRA.CODCOR%TYPE;
   WK_CODTAM                     TT_GRA.CODTAM%TYPE;
   WK_STATUS                     TI_PRE.STATUS%TYPE;
   WK_DATIMP                     TI_PRE.DATIMP%TYPE;
   WK_MOTREJ                     TI_PRE.MOTREJ%TYPE;
   WK_COD_CATEG1                 Numeric;
   WK_COD_CATEG2                 Numeric;
   WK_COD_CATEG3                 Numeric;
   WK_QTDIMP                     Numeric;
   WK_IMPORT                     TT_IED.IMPORT%TYPE;
   WK_MANTEM                     TT_IED.MANTEM%TYPE;
   WK_CNTIMP                     TT_IED.CNTIMP%TYPE;
   WK_VLR_LIMCCC                 TT_LIM.LIMCCC%TYPE;
   WK_NROERR                     Numeric;
   WK_MAI_FR                     TT_CFG.MAI_FR%TYPE;
   WK_MAI_TO                     TT_CFG.MAI_TO%TYPE;
   WK_SAC_E_MAIL                 TT_CFG.SAC_E_MAIL%TYPE;
   WK_TIPCOB                     TD_COB.TIPCOB%TYPE;
   WK_COUNT                      Numeric;
   WK_FILPRE                     TT_TPR.CODFIL%TYPE;
   WK_CODPRE                     TT_TPR.CODPRE%TYPE;
   WK_PRECOV                     TT_PRE.PRECOV%TYPE;
   WK_DIALIM                     TT_IED.DIALIM%TYPE;
   WK_DATCRI                     TI_PRE.DATCRI%TYPE;
   WK_ULTREA                     TI_PRE.ULTREA%TYPE;
   WK_MULTIP                     TI_PRE.MULTIP%TYPE;
   WK_DESMAX                     TI_PRE.DESMAX%TYPE;
   WK_CODMOE                     TI_PRE.CODMOE%TYPE;
   WK_DESPRE                     TT_TPR.DESPRE%TYPE;
   WK_FLGEST                     TI_PRE.FLGEST%TYPE;
   WK_COD_CODMOE                 Numeric;
   WK_FILDES                     TT_TPR.FILDES%TYPE;
   WK_ID_IPRE                    TI_PRE.ID_IPRE%TYPE;
   WK_DESPRE_CODEXT              TI_PRE.DESPRE_CODEXT%TYPE;
   WK_FIL_EXISTE                 Numeric;


   WK_RESTO                      Numeric;
   WK_NUMREG                     Numeric = 500;
   cDUMMY                        VARCHAR(100);

CR_PRECOS CURSOR(pDATCRI TI_PRE.DATCRI%TYPE) IS
  SELECT *
    FROM (SELECT /*+INDEX(IPRE, I_LC_IPRE_STATUS)+INDEX(GRA,I_LC_GRA_CODEXT)+INDEX(PRO,PK_PRO)*/
                 IPRE.CODFIL, IPRE.CATEG1, IPRE.CATEG2, IPRE.CATEG3, IPRE.CODEXT, IPRE.PRECOV,
                 IPRE.MOTREJ, IPRE.DATIMP, IPRE.ULTREA, IPRE.MULTIP, IPRE.DESMAX, IPRE.CODMOE,
                 IPRE.DESPRE, IPRE.FLGEST, GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM,
                 IPRE.ID_IPRE, IPRE.DESPRE_CODEXT
            FROM TI_PRE IPRE  LEFT JOIN TT_GRA GRA ON GRA.CODEXT = IPRE.CODEXT
           WHERE IPRE.STATUS = 0
             AND IPRE.DATCRI BETWEEN TRUNC(pDATCRI)
                                 AND ADD_DAY(TRUNC(pDATCRI),1)
           ORDER BY IPRE.DATCRI) TAB
   LIMIT 1;

BEGIN
   -- RFMP 80113
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20007 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

      SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
        INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
        FROM TT_IED
       WHERE TABELA = 'PRE';

   IF WK_IMPORT = 'T' THEN
      WK_CNTIMP := WK_CNTIMP + 1;
      WK_QTDIMP := 0;

      cDummy := IMPORTA_PRO();

      LOOP
         SELECT MIN(DATCRI)
           INTO WK_DATCRI
           FROM TI_PRE
          WHERE STATUS = 0;

         WK_FILMAT := null;
         WK_CODMAT := null;
         WK_CODCOR := null;
         WK_CODTAM := null;
         WK_FILPRE := null;
         WK_CODPRE := null;

         OPEN CR_PRECOS(WK_DATCRI);
         FETCH CR_PRECOS INTO WK_CODFIL, WK_CATEG1, WK_CATEG2, WK_CATEG3, WK_CODEXT, WK_PRECOV,
                              WK_MOTREJ, WK_DATIMP, WK_ULTREA, WK_MULTIP, WK_DESMAX, WK_CODMOE,
                              WK_DESPRE, WK_FLGEST, WK_FILMAT, WK_CODMAT, WK_CODCOR, WK_CODTAM,
                              WK_ID_IPRE, WK_DESPRE_CODEXT;

         IF NOT FOUND THEN
            CLOSE CR_PRECOS;
            EXIT;
         END IF;

         
         IF WK_NUMREG = 0 THEN
            CLOSE CR_PRECOS;
            EXIT;
         END IF;
         
         WK_MOTREJ := 'OK';

         IF WK_MOTREJ = 'OK' THEN
            IF WK_CODFIL IS NULL THEN
               WK_STATUS := 4;
               WK_MOTREJ := 'A coluna CODFIL deve ser preenchida';
               WK_NROERR := WK_NROERR + 1;
            END IF;
         END IF;

         IF WK_MOTREJ = 'OK' THEN
            IF WK_CODEXT IS NULL THEN
               WK_STATUS := 4;
               WK_MOTREJ := 'A coluna CODEXT deve ser preenchida';
               WK_NROERR := WK_NROERR + 1;
            END IF;
         END IF;

         IF WK_MOTREJ = 'OK' THEN
            IF WK_DESPRE IS NULL AND WK_CATEG1 IS NULL AND WK_CATEG2 IS NULL AND WK_CATEG3 IS NULL AND WK_DESPRE_CODEXT IS NULL THEN
               WK_STATUS := 4;
               WK_MOTREJ := 'Obrigatrio preencher DESPRE, DESPRE_CODEXT ou uma das categorias (CATEG1, CATEG2 e CATEG3)';
               WK_NROERR := WK_NROERR + 1;
            END IF;
         END IF;

         IF WK_MOTREJ = 'OK' THEN
            IF WK_FILMAT IS NULL THEN
               WK_STATUS := 4;
               WK_MOTREJ := 'PRODUTO AINDA NAO CADASTRADO';
               WK_NROERR := WK_NROERR + 1;
            END IF;
         END IF;

         WK_FIL_EXISTE := 0;
            
         -- Select para verificar se filial existe na base
               
            SELECT 1 AS EXIST 
              INTO WK_FIL_EXISTE
              FROM TD_FIL DFIL 
             WHERE DFIL.CODFIL = WK_CODFIL;
          
         
         IF (WK_FIL_EXISTE IS NULL) THEN
            WK_FIL_EXISTE := 0;
         END IF;
      
         -- Valida se filial existe na base de dados
         IF (WK_MOTREJ = 'OK') AND (WK_FIL_EXISTE <> 1) THEN
            WK_STATUS := 4;
            WK_MOTREJ := 'Filial no localizada: "' || COALESCE(WK_CODFIL, '') || '".';
            WK_NROERR := WK_NROERR + 1;
         END IF;  


         IF (WK_MOTREJ = 'OK') THEN

            IF WK_CATEG1 IS NOT NULL THEN
               WK_COD_CATEG1 := IMPORTA_TDS( 'TD_CT1', 'CT1ATI', 'NOMCT1', 'CODTAB', WK_CATEG1, NULL, NULL, NULL );
            END IF;
            IF WK_CATEG2 IS NOT NULL THEN
               WK_COD_CATEG2 := IMPORTA_TDS( 'TD_CT2', 'CT2ATI', 'NOMCT2', 'CODTAB', WK_CATEG2, NULL, NULL, NULL );
            END IF;
            IF WK_CATEG3 IS NOT NULL THEN
               WK_COD_CATEG3 := IMPORTA_TDS( 'TD_CT3', 'CT3ATI', 'NOMCT3', 'CODTAB', WK_CATEG3, NULL, NULL, NULL );
            END IF;
            IF WK_CODMOE IS NOT NULL THEN
               WK_COD_CODMOE := IMPORTA_TDS( 'TD_MOE', 'MOEATI', 'DESMOE', 'CODTAB', WK_CODMOE, NULL, NULL, NULL );
            END IF;

            IF WK_MULTIP IS NULL THEN
               WK_MULTIP := 1;
            END IF;
            
             /* Inicio - Processo de Incluso/Alterao da Tabela de Preo TT_TPR */
            IF (WK_DESPRE_CODEXT IS NOT NULL) THEN
               BEGIN
                  SELECT CODFIL, CODPRE
                    INTO WK_FILPRE, WK_CODPRE
                    FROM TT_TPR
                   WHERE CODEXT = WK_DESPRE_CODEXT;
               EXCEPTION
                                    
                  WHEN others THEN NULL;
                                 END;
            ELSE
               IF (WK_DESPRE IS NOT NULL) THEN
                  BEGIN
                     SELECT CODFIL, CODPRE
                       INTO WK_FILPRE, WK_CODPRE
                       FROM TT_TPR
                      WHERE DESPRE = WK_DESPRE;
                  EXCEPTION
                                          
                     WHEN others THEN NULL;
                                       END;
               ELSE
                  BEGIN
                     SELECT CODFIL, COALESCE(CODPRE,1)
                       INTO WK_FILPRE, WK_CODPRE
                       FROM TT_TPR
                      WHERE FILDES = WK_CODFIL
                        AND COALESCE(CATEG1,0) = COALESCE(WK_COD_CATEG1,0)
                        AND COALESCE(CATEG2,0) = COALESCE(WK_COD_CATEG2,0)
                        AND COALESCE(CATEG3,0) = COALESCE(WK_COD_CATEG3,0);
                  EXCEPTION
                                          
                     WHEN others THEN NULL;
                                       END;
               END IF;
            END IF;

            IF WK_CODPRE IS NULL THEN

               IF WK_DESPRE IS NULL THEN
                  WK_FILDES := WK_CODFIL;
               ELSE
                  WK_FILDES := NULL;
               END IF;

               SELECT COALESCE(MAX(CODPRE),0) + 1
                 INTO WK_CODPRE
                 FROM TT_TPR
                WHERE CODFIL = WK_CODFIL;

               BEGIN
                  INSERT INTO TT_TPR (CODFIL, CODPRE, VAREJO, DATMAX, DATMIN,
                                      CATEG1, CATEG2, CATEG3, SIGNAT, MULTIP, DESPRE, FILDES, ATU_EM, CODEXT)
                              VALUES (WK_CODFIL, WK_CODPRE, 1, TO_DATE('31/12/2099','DD/MM/YYYY'), TO_DATE('01/01/1900','DD/MM/YYYY'),
                                      WK_COD_CATEG1, WK_COD_CATEG2, WK_COD_CATEG3, 3, WK_MULTIP, COALESCE(WK_DESPRE,WK_CATEG1,COALESCE(WK_CATEG2,WK_CATEG3)), WK_FILDES, AGORA(), WK_DESPRE_CODEXT);
               EXCEPTION
                  
                  WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TABELA DE PREOS DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TABELA DE PREOS DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TABELA DE PREOS DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TABELA DE PREOS DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TABELA DE PREOS DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TABELA DE PREOS DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TABELA DE PREOS DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                   END;
               IF WK_MOTREJ = 'OK' THEN
                  WK_STATUS := 3;
               ELSE
                  WK_STATUS := 4;
                  WK_NROERR := WK_NROERR + 1;
               END IF;

            ELSE
               BEGIN
                  UPDATE TT_TPR SET DESPRE = COALESCE(WK_DESPRE, DESPRE),
                                    CATEG1 = WK_COD_CATEG1,
                                    CATEG2 = WK_COD_CATEG2,
                                    CATEG3 = WK_COD_CATEG3,
                                    MULTIP = WK_MULTIP
                   WHERE CODFIL = WK_FILPRE
                     AND CODPRE = WK_CODPRE;
               EXCEPTION
                  
                  WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TABELA DE PREOS DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TABELA DE PREOS DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TABELA DE PREOS DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TABELA DE PREOS DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TABELA DE PREOS DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TABELA DE PREOS DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR TABELA DE PREOS DO TABELA DE PREOS DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                   END;
            END IF;
            /* Fim - Processo de Incluso/Alterao da Tabela de Preo TT_TPR */

             BEGIN
               SELECT COUNT(*)
                 INTO WK_COUNT
                 FROM TT_PRE
                WHERE FILPRE = COALESCE(WK_FILPRE, WK_CODFIL)
                  AND FILMAT = WK_FILMAT
                  AND CODMAT = WK_CODMAT
                  AND CODCOR = WK_CODCOR
                  AND CODTAM = WK_CODTAM
                  AND CODPRE = WK_CODPRE;
            EXCEPTION
                              
               WHEN others THEN NULL;
                           END;

            IF WK_COUNT = 0 THEN
               BEGIN
                  INSERT INTO TT_PRE (FILPRE, FLGEST, FILMAT, CODMAT, CODCOR, CODPRE, CODTAM, CODMOE, PRECOV, ULTREA, MULTIP, DESMAX)
                              VALUES (COALESCE(WK_FILPRE, WK_CODFIL), WK_FLGEST, WK_FILMAT, WK_CODMAT, WK_CODCOR, WK_CODPRE, WK_CODTAM, COALESCE(WK_COD_CODMOE,0), WK_PRECOV, WK_ULTREA, WK_MULTIP, WK_DESMAX);
               EXCEPTION
                  
                  WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                   END;
               IF NOT WK_MOTREJ = 'OK' THEN
                  WK_STATUS := 4;
                  WK_NROERR := WK_NROERR + 1;
               ELSE
                  WK_STATUS := 3;
               END IF;
            ELSE
               BEGIN
                  UPDATE TT_PRE SET PRECOV = WK_PRECOV,
                                    ULTREA = WK_ULTREA,
                                    MULTIP = WK_MULTIP,
                                    DESMAX = WK_DESMAX,
                                    FLGEST = WK_FLGEST
                   WHERE FILPRE = COALESCE(WK_FILPRE, WK_CODFIL)
                     AND FILMAT = WK_FILMAT
                     AND CODMAT = WK_CODMAT
                     AND CODCOR = WK_CODCOR
                     AND CODTAM = WK_CODTAM
                     AND CODPRE = WK_CODPRE;
               EXCEPTION
                  
                  WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO ATUALIZAR PREO DO PRODUTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                   END;
               IF NOT WK_MOTREJ = 'OK' THEN
                  WK_STATUS := 4;
                  WK_NROERR := WK_NROERR + 1;
               ELSE
                  WK_STATUS := 3;
               END IF;
            END IF;
         END IF;

         UPDATE TI_PRE SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
          WHERE ID_IPRE = WK_ID_IPRE
            AND DATIMP IS NULL;

                  WK_QTDIMP := WK_QTDIMP + 1;
         
         WK_NUMREG := WK_NUMREG - 1;
                  CLOSE CR_PRECOS;
      END LOOP;

      IF WK_NROERR <> 0 THEN
         SELECT MAI_FR, MAI_TO, SAC_E_MAIL
           INTO WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL
           FROM TT_CFG;
         IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
            INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO, MAI_CC,
                                TEXTOS,TIPMSG)
                        VALUES ('001','F',AGORA(),'IMPORTAO DE PREOS',WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL,
                                'Problema na importao de '||wk_nroerr||' preos de produtos. Verifique!','T');
         END IF;
      END IF;

      UPDATE TI_PRE SET STATUS = CASE WHEN STATUS = 3
                                      THEN 1
                                      ELSE 2
                                  END
       WHERE STATUS IN (3,4);

      IF WK_MANTEM = 'F' THEN
         IF WK_DIALIM > 0 THEN
            DELETE FROM TI_PRE
             WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
               AND STATUS = 1;
         ELSE
            DELETE FROM TI_PRE
             WHERE STATUS = 1;
         END IF;
      END IF;
      UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = WK_QTDIMP, CNTIMP = WK_CNTIMP, TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP WHERE TABELA = 'PRE';
         ELSE
      RAISE EXCEPTION 'PG-20001 IMPORTAO DE PREOS NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;

   
   SELECT COUNT(*) INTO WK_RESTO FROM TI_PRE WHERE STATUS = 0;
   IF WK_RESTO > 0 THEN
      RETURN 'EXISTEM '||WK_RESTO||' PREOS NO IMPORTADOS';
   ELSE
      RETURN 'OK';
   END IF;
   
END;
$$ language 'plpgsql';





/*-- SEQ 1650 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_REC () CASCADE;

/*-- SEQ 1651 --*/
CREATE OR REPLACE FUNCTION IMPORTA_REC ()
RETURNS VARCHAR AS $$
DECLARE


-- Objetivo:
-- 1) Importao das tabelas TT_REC

WK_CODFIL     TI_REC.CODFIL%TYPE;
WK_NUMNOT     TI_REC.NUMNOT%TYPE;
WK_NUMECF     TI_REC.NUMECF%TYPE;
WK_CODSER     TI_REC.CODSER%TYPE;
WK_NUMPAR     TI_REC.NUMPAR%TYPE;
WK_SUBPAR     TI_REC.SUBPAR%TYPE;
WK_SUBPAR_ORI TI_REC.SUBPAR%TYPE;
WK_FLGEST     TI_REC.FLGEST%TYPE;
WK_ATU_EM     TI_REC.ATU_EM%TYPE;
WK_DATVEN     TI_REC.DATVEN%TYPE;
WK_VLRPAR     TI_REC.VLRPAR%TYPE;
WK_CODMOE     TI_REC.CODMOE%TYPE;
WK_CODUSU     TI_REC.CODUSU%TYPE;
WK_FILREC     TI_REC.FILREC%TYPE;
WK_ECFREC     TI_REC.ECFREC%TYPE;
WK_CUPFIS     TI_REC.CUPFIS%TYPE;
WK_PAGAME     TI_REC.PAGAME%TYPE;
WK_VLRPGT     TI_REC.VLRPGT%TYPE;
WK_PORTAD     TI_REC.PORTAD%TYPE;
WK_DATINC     TI_REC.DATINC%TYPE;
WK_VLRDES     TI_REC.VLRDES%TYPE;
WK_DATFIS     TI_REC.DATFIS%TYPE;
WK_CODEXT     TI_REC.CODEXT%TYPE;
WK_CARTAO     TI_REC.CARTAO%TYPE;
WK_CODBCO     TI_REC.CODBCO%TYPE;
WK_CODAGE     TI_REC.CODAGE%TYPE;
WK_NUMCHE     TI_REC.NUMCHE%TYPE;
WK_NUMCON     TI_REC.NUMCON%TYPE;
WK_STATUS     TI_REC.STATUS%TYPE;
WK_MOTREJ     TI_REC.MOTREJ%TYPE;
WK_DATIMP     TI_REC.DATIMP%TYPE;
WK_TIPCCC     TI_REC.TIPCCC%TYPE;
WK_RENEGO     TI_REC.RENEGO%TYPE;
WK_RENORI     TI_REC.RENORI%TYPE;
WK_AUX_CODMOE TD_MOE.CODTAB%TYPE;
WK_NROERR     Numeric;
WK_QTDIMP     Numeric;
WK_IMPORT     TT_IED.IMPORT%TYPE;
WK_MANTEM     TT_IED.MANTEM%TYPE;
WK_CNTIMP     TT_IED.CNTIMP%TYPE;
WK_MAI_FR     TT_CFG.MAI_FR%TYPE;
WK_MAI_TO     TT_CFG.MAI_TO%TYPE;
WK_AUX_FILUSU TT_USU.FILUSU%TYPE;
WK_AUX_CODUSU TT_USU.CODUSU%TYPE;
WK_AUX_SEQCHE TT_CHR.SEQUEN%TYPE;
WK_AUX_PORTAD TI_REC.PORTAD%TYPE;
WK_AUX_SEQUEN TT_VEN.SEQUEN%TYPE;
W_EXISTE      Numeric(1);
WK_AUX_CLICHE TI_CHR.CODCLI%TYPE;
WK_AUX_USUCHE TI_CHR.CODUSU%TYPE;
WK_FIL_CLICHE TT_CHR.FILCLI%TYPE;
WK_COD_CLICHE TT_CHR.CODCLI%TYPE;
WK_FIL_USUCHE TT_USU.FILUSU%TYPE;
WK_COD_USUCHE TT_USU.CODUSU%TYPE;
WK_CHE_EXISTE CHAR(1);
WK_DIALIM     TT_IED.DIALIM%TYPE;
WK_DATCRI     TI_REC.DATCRI%TYPE;
WK_RESTO      Numeric;
WK_NUMREG     Numeric = 500;
WK_VLRTAX     TI_REC.VLRTAX%TYPE;
WK_ESTCAN     TI_REC.ESTCAN%TYPE;
WK_FLGFLU     TI_REC.FLGFLU%TYPE;
WK_DATPRE     TI_REC.DATPRE%TYPE;
WK_VLRPRE     TI_REC.VLRPRE%TYPE;
WK_SUBORI     TI_REC.SUBORI%TYPE;
cDUMMY        VARCHAR(100);
WK_AUX_VLRPAR TI_REC.VLRPAR%TYPE;
WK_AUX_SUBPAR TI_REC.SUBPAR%TYPE;
WK_AUX_VLRPGT TI_REC.VLRPGT%TYPE;

WK_VEN_STATUS TI_VEN.STATUS%TYPE;
WK_NUMPAR_TI VARCHAR(2);
WK_SUBPAR_TI VARCHAR(2);

CR_PARCELA CURSOR(pDATCRI TI_REC.DATCRI%TYPE) IS
--Status => 0 no processado
--       => 1 processado com sucesso
--       => 2 processado com erro*/
  SELECT *
    FROM (SELECT /*+INDEX(REC, I_LC_IREC_STATUS)*/
                 REC.CODFIL,REC.NUMNOT,REC.NUMECF,REC.CODSER,
                 REC.NUMPAR AS NUMPAR_TI, REC.SUBPAR AS SUBPAR_TI,
                 CAST(LPAD(TO_CHAR(TO_NUMBER(TRIM(REC.NUMPAR))), 2,' ') AS CHAR(2)) AS NUMPAR, CAST(CASE WHEN REC.SUBPAR='PG' THEN REC.SUBPAR ELSE LPAD(TO_CHAR(TO_NUMBER(TRIM(REC.SUBPAR))), 2,' ') END AS CHAR(2)) AS SUBPAR,
                 REC.FLGEST,REC.ATU_EM,REC.DATVEN,REC.VLRPAR,
                 REC.CODMOE,REC.CODUSU,REC.FILREC,REC.ECFREC,REC.CUPFIS,REC.PAGAME,REC.VLRPGT,REC.PORTAD,REC.DATINC,REC.VLRDES,
                 REC.DATFIS,REC.CODEXT,REC.CARTAO,REC.CODBCO,REC.CODAGE,REC.NUMCHE,REC.NUMCON,REC.MOTREJ,REC.DATIMP,
                 REC.TIPCCC,REC.RENEGO,REC.RENORI,REC.VLRTAX,REC.ESTCAN,REC.FLGFLU,REC.DATPRE,REC.VLRPRE,REC.SUBORI
            FROM TI_REC REC 
           WHERE REC.STATUS = 0
             AND REC.DATCRI BETWEEN TRUNC(pDATCRI)
                                AND ADD_DAY(TRUNC(pDATCRI),1)
           ORDER BY REC.DATCRI) TAB
   LIMIT 1;
BEGIN
   -- RFMP 80113
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20006 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

   SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
     INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
     FROM TT_IED
    WHERE TABELA = 'REC';

   IF WK_IMPORT = 'T' THEN
     WK_CNTIMP := WK_CNTIMP + 1;
     WK_NROERR := 0;
     WK_QTDIMP := 0;

     -- Processar as vendas antes de procecssar as parcelas
     cDummy := IMPORTA_VEN();

	 LOOP

       WK_AUX_FILUSU := NULL;
       WK_AUX_CODUSU := NULL;
       WK_AUX_SEQCHE := NULL;

       SELECT MIN(REC.DATCRI)
         INTO WK_DATCRI
         FROM TI_REC REC
        WHERE REC.STATUS = 0;

       OPEN CR_PARCELA(WK_DATCRI);
       FETCH CR_PARCELA INTO WK_CODFIL,WK_NUMNOT,WK_NUMECF,WK_CODSER,
                             WK_NUMPAR_TI,WK_SUBPAR_TI,
                             WK_NUMPAR,WK_SUBPAR,WK_FLGEST,
                             WK_ATU_EM,WK_DATVEN,WK_VLRPAR,WK_CODMOE,WK_CODUSU,WK_FILREC,WK_ECFREC,
                             WK_CUPFIS,WK_PAGAME,WK_VLRPGT,WK_PORTAD,WK_DATINC,WK_VLRDES,WK_DATFIS,
                             WK_CODEXT,WK_CARTAO,WK_CODBCO,WK_CODAGE,WK_NUMCHE,WK_NUMCON,
                             WK_MOTREJ,WK_DATIMP,WK_TIPCCC,WK_RENEGO,WK_RENORI,WK_VLRTAX,WK_ESTCAN,WK_FLGFLU,
                             WK_DATPRE,WK_VLRPRE,WK_SUBORI;

       IF NOT FOUND THEN
          CLOSE CR_PARCELA;
          EXIT;
       END IF;

       
       IF WK_NUMREG = 0 THEN
          CLOSE CR_PARCELA;
          EXIT;
       END IF;
       
      WK_MOTREJ := 'OK';
       
      IF COALESCE(WK_CODSER,'.') = '.' THEN
        WK_MOTREJ := ' obrigatrio informar o campo CODSER.';
      END IF;

      
      SELECT 1 AS EXIST 
         INTO WK_VEN_STATUS
         FROM TT_VEN TVEN 
        WHERE TVEN.CODFIL = WK_CODFIL AND TVEN.NUMECF = WK_NUMECF
          AND TVEN.CODSER = WK_CODSER AND TVEN.NUMNOT = WK_NUMNOT;
      IF (WK_VEN_STATUS IS NULL) THEN
         WK_VEN_STATUS := 0;
      END IF;

      -- Realiza Tentativa de importao da Venda quando encontrado Registro na TI_VEN
      IF (WK_MOTREJ = 'OK') AND (WK_VEN_STATUS <> 1) THEN
                     SELECT 1 AS EXIST 
               INTO WK_VEN_STATUS
               FROM TI_VEN IVEN 
              WHERE IVEN.CODFIL = WK_CODFIL AND IVEN.NUMECF = WK_NUMECF
                AND IVEN.CODSER = WK_CODSER AND IVEN.NUMNOT = WK_NUMNOT
                AND IVEN.STATUS = '0';
                   IF (WK_VEN_STATUS IS NULL) THEN
            WK_VEN_STATUS := 0;
         END IF;

         IF (WK_VEN_STATUS = 1) THEN
            cDummy := IMPORTA_VEN();
         END IF;
       END IF;

      -- MN - Valida se venda existe na base de dados
      IF (WK_MOTREJ = 'OK') AND (WK_VEN_STATUS <> 1) THEN
         WK_MOTREJ := 'Venda deve ser importada. Filial: ' || COALESCE(WK_CODFIL, '') || ' - Nmero Nota: ' || COALESCE(WK_NUMNOT, '') || ' - Srie: ' || COALESCE(WK_CODSER, '') || '- ECF: ' || COALESCE(WK_NUMECF, '');
      END IF;


         SELECT U.FILUSU, U.CODUSU
           INTO WK_AUX_FILUSU, WK_AUX_CODUSU
           FROM TT_USU U
          WHERE U.CODEXT = WK_CODUSU;

       IF WK_CODMOE IS NOT NULL THEN
         WK_AUX_CODMOE := IMPORTA_TDS( 'TD_MOE', 'MOEATI', 'DESMOE', 'CODTAB', WK_CODMOE, NULL, NULL, NULL );
       END IF;

       IF WK_MOTREJ = 'OK' AND (WK_NUMCHE IS NULL) AND (WK_VLRPGT IS NULL) AND (WK_CARTAO IS NOT NULL) THEN
         WK_MOTREJ := ' obrigatrio informar Cheque |NUMCHE| ou Valor de pagamento |VLRPGT| quando Carto |CARTAO| for informado.';
       END IF;
       
       IF WK_NUMCHE IS NOT NULL THEN

            SELECT 'T' AS EXISTE
              INTO WK_CHE_EXISTE
              FROM TT_CHR C
             WHERE C.CODFIL = WK_CODFIL
               AND C.CODBCO = WK_CODBCO
               AND C.CODAGE = WK_CODAGE
               AND C.NUMCHE = WK_NUMCHE
               AND C.NUMCON = WK_NUMCON;

         IF ISNULL(WK_CHE_EXISTE) = 'T' THEN
                 SELECT CODCLI, CODUSU
              INTO WK_AUX_CLICHE, WK_AUX_USUCHE
              FROM TI_CHR C
             WHERE C.CODFIL = WK_CODFIL
               AND C.CODBCO = WK_CODBCO
               AND C.CODAGE = WK_CODAGE
               AND C.NUMCHE = WK_NUMCHE
               AND C.NUMCON = WK_NUMCON;
     
                   SELECT U.FILUSU, U.CODUSU
              INTO WK_FIL_USUCHE, WK_COD_USUCHE
              FROM TT_USU U
              WHERE U.CODEXT = WK_CODUSU;
     
                   SELECT FILCLI, CODCLI
              INTO WK_FIL_CLICHE, WK_COD_CLICHE
              FROM TT_CLI
              WHERE TRIM(CODEXT) = WK_AUX_CLICHE;
     
      BEGIN
           INSERT INTO TT_CHR (CODFIL,FLGEST,CODBCO,CODUSU,FILUSU,CODAGE,NUMCHE,
                               NUMCON,NUMDOC,ATU_EM,DATVEN,VLRCHE,PORTAD,PAGAME,VLRDIF,
                               NUMDEP,ALINEA,AUTORI,TIPCOB,OBSLOG,DATOPE,NUMECF,
                               CDCMC7,FILCLI,CODCLI,VLRORI,PLACAS,SERCHE)
                               SELECT CODFIL, FLGEST, CODBCO, WK_COD_USUCHE, WK_FIL_USUCHE, CODAGE, NUMCHE,
                                      NUMCON, NUMDOC, ATU_EM, DATVEN, VLRCHE, 0, PAGAME, VLRDIF,
                                      NUMDEP, ALINEA, AUTORI, 'P', OBSLOG, DATOPE, NUMECF,
                                      CDCMC7, WK_FIL_CLICHE, WK_COD_CLICHE, VLRORI, PLACAS, SERCHE
                                 FROM TI_CHR
                                WHERE CODFIL = WK_CODFIL
                                  AND CODBCO = WK_CODBCO
                                  AND CODAGE = WK_CODAGE
                                  AND NUMCHE = WK_NUMCHE
                                  AND NUMCON = WK_NUMCON;
      EXCEPTION
           
           WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR CHEQUE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR CHEQUE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR CHEQUE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR CHEQUE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR CHEQUE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR CHEQUE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR CHEQUE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                            END;

      IF NOT WK_MOTREJ = 'OK' THEN
        WK_STATUS := 4;
        WK_NROERR := WK_NROERR + 1;
      ELSE
         WK_STATUS := 3;
      END IF;
		
      UPDATE TI_REC SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
      WHERE CODFIL = WK_CODFIL
        AND COALESCE(CODSER,'.') = COALESCE(WK_CODSER, '.')
        AND NUMECF = WK_NUMECF
        AND NUMNOT = WK_NUMNOT
        AND NUMPAR = WK_NUMPAR_TI
        AND SUBPAR = WK_SUBPAR_TI;
    END IF;
            SELECT SEQUEN
              INTO WK_AUX_SEQCHE
              FROM TT_CHR C
             WHERE C.CODFIL = WK_CODFIL
               AND C.CODBCO = WK_CODBCO
               AND C.CODAGE = WK_CODAGE
               AND C.NUMCHE = WK_NUMCHE
               AND C.NUMCON = WK_NUMCON;

        END IF;
         SELECT V.SEQUEN
         INTO WK_AUX_SEQUEN
         FROM TT_VEN V
         WHERE V.CODFIL = WK_CODFIL
           AND V.CODSER = WK_CODSER
           AND V.NUMECF = WK_NUMECF
           AND V.NUMNOT = WK_NUMNOT;

    -- MN - Se no tratar aqui, gera erro da  ck_rec_renego. S pode ter renegociao com parcela cancelada, sem carto e cheque preenchido
    IF WK_MOTREJ = 'OK' AND (WK_RENEGO IS NOT NULL)  AND ((WK_FLGEST) <> 'C'  OR (WK_NUMCHE IS NOT NULL) OR (WK_CARTAO IS NOT NULL) ) THEN
      WK_MOTREJ := 'Renegociao |RENEGO| s pode ser informada para parcela cancelada e os campos carto |CARTAO| e cheque |NUMCHE| nulos.';
    END IF;
    
       W_EXISTE := 0;
   WK_SUBPAR_ORI := WK_SUBPAR;
   IF WK_SUBPAR = 'PG' THEN
      W_EXISTE      := 0;
      WK_AUX_VLRPGT := 0;
      IF WK_FLGEST = 'P' THEN
         SELECT VLRPAR, SUBPAR, 1 
           INTO WK_AUX_VLRPAR, WK_AUX_SUBPAR, W_EXISTE
           FROM TT_REC TR
          WHERE TR.CODFIL = WK_CODFIL
            AND TR.SEQUEN = WK_AUX_SEQUEN
            AND TR.NUMPAR = WK_NUMPAR
            AND TR.FLGEST = 'A';

         SELECT SUM(VLRPGT)
           INTO WK_AUX_VLRPGT
           FROM TT_REC TR
          WHERE TR.CODFIL = WK_CODFIL
            AND TR.SEQUEN = WK_AUX_SEQUEN
            AND TR.NUMPAR = WK_NUMPAR
            AND TR.FLGEST = 'P';

         IF ((WK_AUX_VLRPAR + COALESCE(WK_VLRDES,0)) < COALESCE(WK_VLRPGT,0)) THEN 
            WK_MOTREJ := 'VALOR PAGO INFORMADO ACIMA DO SALDO DISPONVEL PARA BAIXA.';
         END IF;

      ELSIF WK_FLGEST = 'X' THEN
         SELECT VLRPAR, SUBPAR, 1 
           INTO WK_AUX_VLRPAR, WK_AUX_SUBPAR, W_EXISTE
           FROM TT_REC TR
          WHERE TR.CODFIL = WK_CODFIL
            AND TR.SEQUEN = WK_AUX_SEQUEN
            AND TR.NUMPAR = WK_NUMPAR
            AND TR.VLRPGT = WK_VLRPGT
            AND TR.FLGEST = 'P';
      END IF;

      IF (W_EXISTE = 1) THEN
         -- Somente realizar o Corte do Valor Pago quando o Valor Pago Vier integra o qual ocorre na reexportao do EME4
         IF (WK_AUX_VLRPGT > 0) AND (COALESCE(WK_VLRPGT, 0) >= WK_VLRPAR) THEN
            WK_VLRPGT := (COALESCE(WK_VLRPGT, 0) - COALESCE(WK_AUX_VLRPGT, 0));

            IF (COALESCE(WK_VLRPGT, 0) <= 0) THEN 
               WK_MOTREJ := 'VALOR PAGO ACUMULADO MENOR QUE VALOR PAGO ATUAL.';
            END IF;
         END IF;

         WK_VLRPAR := WK_AUX_VLRPAR;
         WK_SUBPAR := WK_AUX_SUBPAR;
      END IF;
   ELSE 
      SELECT 1 INTO W_EXISTE
        FROM TT_REC TR
       WHERE TR.CODFIL = WK_CODFIL
         AND TR.SEQUEN = WK_AUX_SEQUEN
         AND TR.NUMPAR = WK_NUMPAR
         AND TR.SUBPAR = WK_SUBPAR;
   END IF;
    IF W_EXISTE IS NULL THEN
      W_EXISTE := 0;
      -- Quando no Localizado fora SubPar Zero para realizar a Importao da Parcela j Paga
      IF WK_SUBPAR = 'PG' THEN
         WK_SUBPAR := ' 0';
      END IF;
    END IF;

    IF W_EXISTE = 0 THEN --registro novo
       BEGIN
         IF (WK_MOTREJ = 'OK') AND (WK_SUBPAR <> 'PG') THEN
           INSERT INTO TT_REC(CODFIL,SEQUEN,NUMPAR,SUBPAR,FLGEST,ATU_EM,DATVEN,VLRPAR,CODMOE,
                              SIGNAT,CODUSU,FILREC,FILUSU,NUMECF,CUPFIS,SEQCHE,PAGAME,VLRDES,
                              VLRPGT,CARTAO,PORTAD,DUMMY,TIPCCC,CODEXT,RENEGO,RENORI,DATINC,VLRTAX,
                              ESTCAN,FLGFLU,DATPRE,VLRPRE,SUBORI,INDEXP)
                       VALUES(WK_CODFIL,WK_AUX_SEQUEN,WK_NUMPAR,WK_SUBPAR,WK_FLGEST,WK_ATU_EM,WK_DATVEN,WK_VLRPAR,WK_AUX_CODMOE,
                              2,WK_AUX_CODUSU,WK_FILREC,WK_AUX_FILUSU,WK_ECFREC,WK_CUPFIS,WK_AUX_SEQCHE,WK_PAGAME,WK_VLRDES,
                              WK_VLRPGT,WK_CARTAO,WK_PORTAD,'I',WK_TIPCCC,WK_CODEXT,WK_RENEGO,WK_RENORI,WK_DATINC,
                              WK_VLRTAX,WK_ESTCAN,WK_FLGFLU,WK_DATPRE,WK_VLRPRE,WK_SUBORI,'I');
         END IF;
        EXCEPTION
          
          WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PARCELAS DO PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PARCELAS DO PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PARCELAS DO PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PARCELAS DO PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PARCELAS DO PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PARCELAS DO PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PARCELAS DO PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                            END;
     ELSE
       BEGIN
         IF WK_MOTREJ = 'OK' THEN
            UPDATE TT_REC SET FLGEST = WK_FLGEST,ATU_EM = COALESCE(WK_ATU_EM,AGORA()),DATVEN = WK_DATVEN,VLRPAR = WK_VLRPAR,
                              CODMOE = WK_AUX_CODMOE,SIGNAT = 2,CODUSU = WK_AUX_CODUSU,FILREC = WK_FILREC,
                              FILUSU = WK_AUX_FILUSU,NUMECF = WK_ECFREC,CUPFIS = WK_CUPFIS,SEQCHE = WK_AUX_SEQCHE,
                              PAGAME = WK_PAGAME,VLRDES = WK_VLRDES,VLRPGT = WK_VLRPGT,CARTAO = WK_CARTAO,
                              PORTAD = WK_PORTAD,DUMMY  = 'I',TIPCCC = WK_TIPCCC,CODEXT = CASE WHEN WK_SUBPAR_ORI='PG' THEN CODEXT ELSE WK_CODEXT END,
                              RENEGO = WK_RENEGO,RENORI = WK_RENORI,
                              VLRTAX = WK_VLRTAX,
                              ESTCAN = WK_ESTCAN,
                              FLGFLU = WK_FLGFLU,
                              DATPRE = WK_DATPRE,
                              VLRPRE = WK_VLRPRE,
                              SUBORI = WK_SUBORI,
                              INDEXP = 'I'
             WHERE CODFIL = WK_CODFIL
               AND SEQUEN = WK_AUX_SEQUEN
               AND NUMPAR = WK_NUMPAR
               AND SUBPAR = WK_SUBPAR;
         END IF; 
        EXCEPTION
          
          WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO PARCELAS DO PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO PARCELAS DO PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO PARCELAS DO PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO PARCELAS DO PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO PARCELAS DO PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO PARCELAS DO PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO PARCELAS DO PEDIDO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
   	                    END;
     END IF;

     BEGIN
        IF (WK_SUBPAR_ORI = 'PG') AND (WK_FLGEST = 'P') AND ((COALESCE(WK_VLRPGT, 0) + COALESCE(WK_VLRDES,0) + COALESCE(WK_VLRTAX,0)) < WK_VLRPAR) THEN
              -- Incluiso registro de Baixa Parcial
          INSERT INTO TT_REC (CODFIL, SEQUEN, NUMPAR, SUBPAR, FLGEST, DATVEN, CODMOE,
                              SIGNAT,  CODUSU, FILREC, FILUSU, NUMECF, CUPFIS, PAGAME,
                              PORTAD, VLRDES, SUBORI, VLRPAR, VLRPGT, DATINC, DATFIS, AVISTA, EXPORT)
                              SELECT CODFIL, SEQUEN, NUMPAR, LPAD(TO_CHAR(TO_NUMBER(TRIM(NUMPAR))), 2,' '), 'A', DATVEN, CODMOE,
                                     0, CODUSU, FILREC, FILUSU, NULL, NULL, NULL,
                                     PORTAD, NULL, SUBPAR, VLRPAR - COALESCE(VLRPGT, 0), NULL, AGORA(), DATFIS, AVISTA, 'F' EXPORT
                                FROM TT_REC
                               WHERE CODFIL = WK_CODFIL
                                 AND SEQUEN = WK_AUX_SEQUEN
                                 AND NUMPAR = WK_NUMPAR
                                 AND SUBPAR = WK_SUBPAR;
        END IF;
     EXCEPTION
       
          WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PARCELAS COM BAIXA PARCIAL: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PARCELAS COM BAIXA PARCIAL: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PARCELAS COM BAIXA PARCIAL: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PARCELAS COM BAIXA PARCIAL: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PARCELAS COM BAIXA PARCIAL: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PARCELAS COM BAIXA PARCIAL: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO COM BAIXA PARCIAL: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                 END;

     IF NOT WK_MOTREJ = 'OK' THEN
        WK_STATUS := 4;
        WK_NROERR := WK_NROERR + 1;
     ELSE
       WK_STATUS := 3;
     END IF;

     UPDATE TI_REC SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
     WHERE CODFIL = WK_CODFIL
       AND COALESCE(CODSER, '.') = COALESCE(WK_CODSER, '.')
       AND NUMECF = WK_NUMECF
       AND NUMNOT = WK_NUMNOT
       AND NUMPAR = WK_NUMPAR_TI
       AND SUBPAR = WK_SUBPAR_TI
       AND DATIMP IS NULL;
      WK_QTDIMP := WK_QTDIMP + 1;
  
        WK_NUMREG := WK_NUMREG - 1;
        CLOSE CR_PARCELA;
    END LOOP;

     IF WK_NROERR <> 0 THEN
        SELECT MAI_FR, MAI_TO
          INTO WK_MAI_FR, WK_MAI_TO
          FROM TT_CFG;
        IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
           INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO,
                               TEXTOS,TIPMSG)
                       VALUES ('001','F',AGORA(),'IMPORTAO DE PARCELAS DO PEDIDO',WK_MAI_FR, WK_MAI_TO,
                               'Problema na importao de '||wk_nroerr||' parcelas do pedidos. Verifique!','T');
        END IF;
     END IF;

     UPDATE TI_REC SET STATUS = CASE WHEN STATUS = 3
                                     THEN 1
                                     ELSE 2
                                 END
      WHERE STATUS IN (3,4);


     IF WK_MANTEM = 'F' THEN
        IF WK_DIALIM > 0 THEN
           DELETE FROM TI_REC
            WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
			  AND STATUS = 1;
        ELSE
           DELETE FROM TI_REC
		    WHERE STATUS = 1;
        END IF;
     END IF;

     UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = WK_QTDIMP, CNTIMP = WK_CNTIMP, TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP WHERE TABELA = 'REC';
   ELSE RAISE EXCEPTION 'PG-20001 IMPORTAO DE PARCELAS DE VENDA NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;
   
   SELECT COUNT(*) INTO WK_RESTO FROM TI_REC WHERE STATUS = 0;
   IF WK_RESTO > 0 THEN
     RETURN 'EXISTEM '||WK_RESTO||' PARCELAS DE VENDA NO IMPORTADAS';
   ELSE
     RETURN 'OK';
   END IF;
   
END;
$$ language 'plpgsql';





/*-- SEQ 1652 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_SAL () CASCADE;

/*-- SEQ 1653 --*/
CREATE OR REPLACE FUNCTION IMPORTA_SAL ()
RETURNS VARCHAR AS $$
DECLARE


-- Objetivo:
-- 1) Importao das tabelas referentes a limites de conta corrente (TD_CCC e TT_LIM)
   WK_FILMAT                     TT_GRA.FILMAT%TYPE;
   WK_CODMAT                     TT_GRA.CODMAT%TYPE;
   WK_CODCOR                     TT_GRA.CODCOR%TYPE;
   WK_CODTAM                     TT_GRA.CODTAM%TYPE;
   WK_CODEXT                     TI_SAL.CODEXT%TYPE;
   WK_CODFIL                     TI_SAL.CODFIL%TYPE;
   WK_DESEST                     TI_SAL.DESEST%TYPE;
   WK_TIPLAN                     TI_SAL.TIPLAN%TYPE;
   WK_INI_CM                     TI_SAL.INI_CM%TYPE;
   WK_PTOPED                     TI_SAL.PTOPED%TYPE;
   WK_QTD_CM                     TI_SAL.QTD_CM%TYPE;
   WK_QTDEST                     TI_SAL.QTDEST%TYPE;
   WK_QTDMOV                     TI_SAL.QTDEST%TYPE;
   WK_QTDMIN                     TI_SAL.QTDMIN%TYPE;
   WK_QTDREP                     TI_SAL.QTDREP%TYPE;
   WK_VLR_CM                     TI_SAL.VLR_CM%TYPE;
   WK_STATUS                     TI_SAL.STATUS%TYPE;
   WK_MOTREJ                     TI_SAL.MOTREJ%TYPE;
   WK_DATIMP                     TI_SAL.DATIMP%TYPE;
   WK_COD_CODMUL                 TD_MUL.CODTAB%TYPE;
   WK_COD_CODLAN                 TD_LAN.CODTAB%TYPE;
   WK_QTDIMP                     Numeric;
   WK_IMPORT                     TT_IED.IMPORT%TYPE;
   WK_MANTEM                     TT_IED.MANTEM%TYPE;
   WK_CNTIMP                     TT_IED.CNTIMP%TYPE;
   WK_NROERR                     Numeric;
   WK_MAI_FR                     TT_CFG.MAI_FR%TYPE;
   WK_MAI_TO                     TT_CFG.MAI_TO%TYPE;
   WK_SAL_QTDEST                 TT_SAL.QTDEST%TYPE;
   WK_SAC_E_MAIL                 TT_CFG.SAC_E_MAIL%TYPE;
   WK_DIALIM                     TT_IED.DIALIM%TYPE;
   WK_DATCRI                     TI_SAL.DATCRI%TYPE;
   WK_COUNT                      Numeric;
   WK_ID_ISAL                    TI_SAL.ID_ISAL%TYPE;
   WK_FLGATI                     TI_SAL.FLGATI%TYPE;
   WK_RESTO      Numeric;
   WK_NUMREG     Numeric = 500;

CR_SALDOS CURSOR(pDATCRI TI_SAL.DATCRI%TYPE) IS
  SELECT *
    FROM (SELECT /*+INDEX(ISAL, I_LC_ISAL_STATUS)*/
                 ISAL.CODEXT, ISAL.CODFIL,
                 ISAL.DESEST, ISAL.INI_CM, ISAL.PTOPED, ISAL.QTD_CM, ISAL.QTDEST, ISAL.QTDMIN,
                 ISAL.QTDREP, ISAL.VLR_CM, ISAL.TIPLAN, ISAL.ID_ISAL, UPPER(ISAL.FLGATI)
            FROM TI_SAL ISAL
           WHERE ISAL.STATUS = 0
             AND ISAL.DATCRI BETWEEN TRUNC(pDATCRI)
                                 AND ADD_DAY(TRUNC(pDATCRI),1)
           ORDER BY ISAL.DATCRI) TAB
   LIMIT 1;
BEGIN
   -- RFMP 80113
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20005 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

         SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
        INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
        FROM TT_IED
       WHERE TABELA = 'SAL';
   
   IF WK_IMPORT <> 'T' THEN
      RAISE EXCEPTION 'PG-20001 IMPORTAO DE SALDO DE ESTOQUE NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;

   WK_CNTIMP := WK_CNTIMP + 1;
   WK_QTDIMP := 0;
   LOOP
      SELECT MIN(DATCRI)
        INTO WK_DATCRI
        FROM TI_SAL
       WHERE STATUS = 0;

      OPEN CR_SALDOS(WK_DATCRI);
      FETCH CR_SALDOS INTO WK_CODEXT, WK_CODFIL,
                           WK_DESEST, WK_INI_CM, WK_PTOPED, WK_QTD_CM, WK_QTDEST, WK_QTDMIN,
                           WK_QTDREP, WK_VLR_CM, WK_TIPLAN, WK_ID_ISAL, WK_FLGATI;

      IF NOT FOUND THEN
         CLOSE CR_SALDOS;
         EXIT;
      END IF;

      
      IF WK_NUMREG = 0 THEN
         CLOSE CR_SALDOS;
         EXIT;
      END IF;
      
      WK_MOTREJ := 'OK';

      IF WK_CODEXT IS NULL THEN
         RAISE EXCEPTION 'PG-20100 A coluna CODEXT deve ser preenchida';
      END IF;

      -- Busca grade
               SELECT FILMAT, CODMAT, CODCOR, CODTAM
           INTO WK_FILMAT, WK_CODMAT, WK_CODCOR, WK_CODTAM
           FROM TT_GRA
          WHERE CODEXT = WK_CODEXT;
      
      IF WK_MOTREJ = 'OK' THEN
        IF WK_FILMAT IS NULL THEN
          WK_MOTREJ := 'ERRO ao processar o Saldo: Item de Grade no encontrado para o cdigo "' || WK_CODEXT || '".';
        END IF;
      END IF;

      IF WK_MOTREJ = 'OK' THEN
         IF WK_DESEST IS NOT NULL THEN
            WK_COD_CODMUL := IMPORTA_TDS( 'TD_MUL', 'MULATI', 'DESMUL', 'CODTAB', WK_DESEST, NULL, NULL, NULL );
         ELSE 
            WK_COD_CODMUL := 0;
         END IF;

         IF WK_TIPLAN IS NOT NULL THEN
            WK_COD_CODLAN := IMPORTA_TDS( 'TD_LAN', 'LANATI', 'DESLAN', 'CODTAB', WK_TIPLAN, NULL, NULL, NULL );
         END IF;

         IF WK_COD_CODLAN IS NULL THEN
            WK_COD_CODLAN:= 1;
         END IF;

         BEGIN
            SELECT COALESCE(QTDEST,0)
              INTO WK_SAL_QTDEST
              FROM TT_SAL
             WHERE CODFIL = WK_CODFIL
               AND FILMAT = WK_FILMAT
               AND CODMAT = WK_CODMAT
               AND CODCOR = WK_CODCOR
               AND CODTAM = WK_CODTAM
               AND CODMUL = WK_COD_CODMUL;
         EXCEPTION
                        
            WHEN others THEN NULL;
                     END;

         -- MN - Quando FLGATI est preenchido, indica se o produto est ativo na filial
         IF COALESCE(WK_FLGATI, '') <> '' THEN 
            IF (WK_FLGATI <> 'T') and (WK_FLGATI <> 'F') THEN
               WK_MOTREJ := 'Campo "FLGATI" com valor invlido, favor informar "T" ou "F", indicando que o produto est ativo ou no na filial em questo.';
            ELSE 
               UPDATE TT_SAL 
                  SET FLGATI = WK_FLGATI
                WHERE FILMAT = WK_FILMAT
                  AND CODMAT = WK_CODMAT
                  AND CODCOR = WK_CODCOR
                  AND CODTAM = WK_CODTAM
                  AND CODFIL = WK_CODFIL                   
                  AND CODMUL = WK_COD_CODMUL;
            END IF;
         END IF;

         IF WK_MOTREJ = 'OK' THEN
            WK_QTDMOV := 0;

            IF (COALESCE(WK_SAL_QTDEST, 0) <> WK_QTDEST) THEN
               WK_QTDMOV := (COALESCE(WK_SAL_QTDEST, 0) - WK_QTDEST) * -1;
            END IF;

            IF WK_QTDMOV <> 0 THEN
               BEGIN
                   INSERT INTO TT_LAN (CODFIL,SITMOV,TIPMOV,CODUSU,FILMAT,FILUSU,CODMAT,DOCUME,ATU_EM,DATMOV,
                                       QTDMOV,CODCOR,CODTAM,TIPLAN,VLRMOV,CODMUL,DATINC,EXPORT)
                               VALUES (WK_CODFIL, 'N', 'I', '  1', WK_FILMAT, '001', WK_CODMAT, 'IMPORTACAO', AGORA(), AGORA(),
                                       WK_QTDMOV, WK_CODCOR, WK_CODTAM, WK_COD_CODLAN, WK_QTDMOV * COALESCE(WK_VLR_CM,1), WK_COD_CODMUL, AGORA(), 'T');
               EXCEPTION
                  
                  WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR LANAMENTO: 23001 RESTRICT VIOLATION'||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR LANAMENTO: 23502 NOT NULL VIOLATION'||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR LANAMENTO: 23503 FOREIGN KEY VIOLATION'||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR LANAMENTO: 23505 UNIQUE VIOLATION'||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR LANAMENTO: 23514 CHECK VIOLATION'||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                  WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR LANAMENTO: 23000 INTEGRITY CONSTRAINT VIOLATION'||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                   WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR LANAMENTO: P0000 PLPGSQL ERROR'||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                                   END;
            ELSE
               WK_STATUS := 3;
            END IF;
         END IF;
      END IF;

      IF WK_MOTREJ = 'OK' THEN
         WK_STATUS := 3;
      ELSE
         WK_STATUS := 4;
         WK_NROERR := WK_NROERR + 1;
      END IF;

      UPDATE TI_SAL
         SET STATUS = WK_STATUS,
             DATIMP = AGORA(),
             MOTREJ = WK_MOTREJ
       WHERE ID_ISAL = WK_ID_ISAL
         AND DATIMP IS NULL;

      
      WK_QTDIMP := WK_QTDIMP + 1;

      
      WK_NUMREG := WK_NUMREG - 1;
            CLOSE CR_SALDOS;
   END LOOP;

   IF WK_NROERR <> 0 THEN

      SELECT MAI_FR, MAI_TO, SAC_E_MAIL
        INTO WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL
        FROM TT_CFG;
      IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
         INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO,MAI_CC,
                             TEXTOS,TIPMSG)
                     VALUES ('001','F',AGORA(),'IMPORTAO DE SALDOS DE ESTOQUE',WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL,
                             'Problema na importao de '||wk_nroerr||' saldos de estoque. Verifique!','T');
      END IF;
   END IF;

   UPDATE TI_SAL SET STATUS = CASE WHEN STATUS = 3
                                   THEN 1
                                   ELSE 2
                              END
    WHERE STATUS IN (3,4);

   IF WK_MANTEM = 'F' THEN
      IF WK_DIALIM > 0 THEN
         DELETE FROM TI_SAL
          WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
            AND STATUS = 1;
      ELSE
         DELETE FROM TI_SAL
          WHERE STATUS = 1;
      END IF;
   END IF;

   UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = WK_QTDIMP, CNTIMP = WK_CNTIMP, TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP WHERE TABELA = 'SAL';

   
   
   IF WK_NUMREG=0 THEN

      SELECT COUNT(*)
        INTO WK_RESTO
        FROM TI_SAL
       WHERE STATUS = 0;

      IF WK_RESTO > 0 THEN
         RETURN 'EXISTEM '||WK_RESTO||' SALDOS DE ESTOQUE AINDA NO IMPORTADOS. EXECUTE NOVAMENTE.';
      END IF;
   END IF;

   SELECT COUNT(*)
     INTO WK_RESTO
     FROM TI_SAL
     WHERE STATUS = 2;

   IF WK_RESTO > 0 THEN
      RETURN 'EXISTEM '||WK_RESTO||' SALDOS DE ESTOQUE NO IMPORTADOS VERIFIQUE';
   ELSE
      RETURN 'OK';
   END IF;
   
END;
$$ language 'plpgsql';




/*-- SEQ 1654 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_SER () CASCADE;

/*-- SEQ 1655 --*/
CREATE OR REPLACE FUNCTION IMPORTA_SER ()
RETURNS VARCHAR AS $$
DECLARE

-- Objetivo:
-- 1) Importao da tabela TD_SER
WK_CODSER     TI_SER.CODSER%TYPE;
WK_DIVTRO     TI_SER.DIVTRO%TYPE;
WK_IMPNOT     TI_SER.IMPNOT%TYPE;
WK_RESTRI     TI_SER.RESTRI%TYPE;
WK_SERATI     TI_SER.SERATI%TYPE;
WK_SERMAN     TI_SER.SERMAN%TYPE;
WK_SERFIM     TI_SER.SERFIM%TYPE;
WK_SERINI     TI_SER.SERINI%TYPE;
WK_MODNOT     TI_SER.MODNOT%TYPE;
WK_OBSCOL     TI_SER.OBSCOL%TYPE;
WK_OBSLIN     TI_SER.OBSLIN%TYPE;
WK_EXTNOT     TI_SER.EXTNOT%TYPE;
WK_QTDITP     TI_SER.QTDITP%TYPE;
WK_QTDITS     TI_SER.QTDITS%TYPE;
WK_DESSER     TI_SER.DESSER%TYPE;
WK_DISSAI     TI_SER.DISSAI%TYPE;
WK_TXTENT     TI_SER.TXTENT%TYPE;
WK_TXTFIM     TI_SER.TXTFIM%TYPE;
WK_TXTINI     TI_SER.TXTINI%TYPE;
WK_TXTITE     TI_SER.TXTITE%TYPE;
WK_TXTSER     TI_SER.TXTSER%TYPE;
WK_STATUS     TI_SER.STATUS%TYPE;
WK_MOTREJ     TI_SER.MOTREJ%TYPE;
WK_DATIMP     TI_SER.DATIMP%TYPE;
WK_IMPORT     TT_IED.IMPORT%TYPE;
WK_MANTEM     TT_IED.MANTEM%TYPE;
WK_CNTIMP     TT_IED.CNTIMP%TYPE;
WK_NROERR     Numeric;
WK_QTDIMP     Numeric;
WK_MAI_FR     TT_CFG.MAI_FR%TYPE;
WK_MAI_TO     TT_CFG.MAI_TO%TYPE;
WK_AUX_CODTAB TD_SER.CODTAB%TYPE;
W_EXISTE      Numeric(1);
WK_DIALIM     TT_IED.DIALIM%TYPE;
WK_DATCRI     TI_SER.DATCRI%TYPE;

CR_SERIE CURSOR(pDATCRI TI_SER.DATCRI%TYPE) IS
--Status => 0 no processado
--       => 1 processado com sucesso
--       => 2 processado com erro
  SELECT *
    FROM (SELECT CODSER,DIVTRO,IMPNOT,RESTRI,SERATI,SERMAN,SERFIM,SERINI,MODNOT,
                 OBSCOL,OBSLIN,EXTNOT,QTDITP,QTDITS,DESSER,DISSAI,TXTENT,TXTFIM,
                 TXTINI,TXTITE,TXTSER
            FROM TI_SER
           WHERE STATUS = 0
             AND DATCRI BETWEEN TRUNC(pDATCRI)
                            AND ADD_DAY(TRUNC(pDATCRI),1)
           ORDER BY DATCRI
         ) TAB
   LIMIT 1;
BEGIN
   -- RFMP 80113
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20004 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

   SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
     INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
     FROM TT_IED
   WHERE TABELA = 'SER';

   IF WK_IMPORT = 'T' THEN
     WK_CNTIMP := WK_CNTIMP + 1;
     WK_NROERR := 0;
     WK_QTDIMP := 0;

     LOOP
       WK_AUX_CODTAB := NULL;

       SELECT MIN(DATCRI)
         INTO WK_DATCRI
         FROM TI_SER
        WHERE STATUS = 0;

       OPEN CR_SERIE(WK_DATCRI);
       FETCH CR_SERIE INTO WK_CODSER,WK_DIVTRO,WK_IMPNOT,WK_RESTRI,WK_SERATI,WK_SERMAN,WK_SERFIM,
                           WK_SERINI,WK_MODNOT,WK_OBSCOL,WK_OBSLIN,WK_EXTNOT,WK_QTDITP,WK_QTDITS,
                           WK_DESSER,WK_DISSAI,WK_TXTENT,WK_TXTFIM,WK_TXTINI,WK_TXTITE,WK_TXTSER;

       IF NOT FOUND THEN
          CLOSE CR_SERIE;
          EXIT;
       END IF;

       WK_MOTREJ     := 'OK';

       SELECT MAX(TI.CODTAB) + 1
       INTO WK_AUX_CODTAB
       FROM TD_IND TI;
         INSERT INTO TD_IND (CODTAB) VALUES (WK_AUX_CODTAB);

       W_EXISTE := 0;
         SELECT 1 INTO W_EXISTE
         FROM TD_SER TS
         WHERE TS.CODSER = WK_CODSER;
       IF W_EXISTE IS NULL THEN
           W_EXISTE := 0;
       END IF;

       IF W_EXISTE = 0 THEN --registro novo

         BEGIN
           INSERT INTO TD_SER(CODSER,CODTAB,DIVTRO,IMPNOT,RESTRI,SERATI,SERMAN,SERFIM,SERINI,MODNOT,
                              OBSCOL,OBSLIN,EXTNOT,QTDITP,QTDITS,DESSER,DISSAI,TXTENT,TXTFIM,TXTINI,
                              TXTITE,TXTSER)
                       VALUES(WK_CODSER,WK_AUX_CODTAB,COALESCE(WK_DIVTRO,'F'),COALESCE(WK_IMPNOT,'F'),
                              COALESCE(WK_RESTRI,'F'),COALESCE(WK_SERATI,'F'),COALESCE(WK_SERMAN,'F'),
                              WK_SERFIM,WK_SERINI,WK_MODNOT,WK_OBSCOL,WK_OBSLIN,WK_EXTNOT,WK_QTDITP,
                              WK_QTDITS,WK_DESSER,WK_DISSAI,WK_TXTENT,WK_TXTFIM,WK_TXTINI,WK_TXTITE,
                              WK_TXTSER);
         EXCEPTION
           
           WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR DADOS DAS SERIES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR DADOS DAS SERIES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR DADOS DAS SERIES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR DADOS DAS SERIES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR DADOS DAS SERIES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR DADOS DAS SERIES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	   WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR DADOS DAS SERIES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	                       END;
       ELSE

         BEGIN
           UPDATE TD_SER SET CODSER = WK_CODSER,CODTAB = WK_AUX_CODTAB,DIVTRO = COALESCE(WK_DIVTRO,'F'),
                             IMPNOT = COALESCE(WK_IMPNOT,'F'),RESTRI = COALESCE(WK_RESTRI,'F'),
                             SERATI = COALESCE(WK_SERATI,'F'),SERMAN = COALESCE(WK_SERMAN,'F'),
                             SERFIM = WK_SERFIM,SERINI = WK_SERINI,MODNOT = WK_MODNOT,OBSCOL = WK_OBSCOL,
                             OBSLIN = WK_OBSLIN,EXTNOT = WK_EXTNOT,QTDITP = WK_QTDITP,QTDITS = WK_QTDITS,
                             DESSER = WK_DESSER,DISSAI = WK_DISSAI,TXTENT = WK_TXTENT,TXTFIM = WK_TXTFIM,
                             TXTINI = WK_TXTINI,TXTITE = WK_TXTITE,TXTSER = WK_TXTSER
                        WHERE CODSER = WK_CODSER;

         EXCEPTION
           
           WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE DADOS DAS SERIES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE DADOS DAS SERIES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE DADOS DAS SERIES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE DADOS DAS SERIES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE DADOS DAS SERIES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
           WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE DADOS DAS SERIES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	   WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE DADOS DAS SERIES: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                               END;
       END IF;

       IF NOT WK_MOTREJ = 'OK' THEN
          WK_STATUS := 4;
          WK_NROERR := WK_NROERR + 1;
       ELSE
         WK_STATUS := 3;
       END IF;

       UPDATE TI_SER SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
        WHERE CODSER = WK_CODSER
          AND DATIMP IS NULL;
        WK_QTDIMP := WK_QTDIMP + 1;

        CLOSE CR_SERIE;
     END LOOP;

     IF WK_NROERR <> 0 THEN
        SELECT MAI_FR, MAI_TO
          INTO WK_MAI_FR, WK_MAI_TO
          FROM TT_CFG;
        IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
           INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO,
                               TEXTOS,TIPMSG)
                       VALUES ('001','F',AGORA(),'IMPORTAO DE DADOS DA SERIES',WK_MAI_FR, WK_MAI_TO,
                               'Problema na importao de '||wk_nroerr||' pedidos das sries. Verifique!','T');
        END IF;
     END IF;

     UPDATE TI_SER SET STATUS = CASE WHEN STATUS = 3
                                     THEN 1
                                     ELSE 2
                                 END
      WHERE STATUS IN (3,4);

     IF WK_MANTEM = 'F' THEN
        IF WK_DIALIM > 0 THEN
           DELETE FROM TI_SER
            WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
			  AND STATUS = 1;
        ELSE
           DELETE FROM TI_SER
		    WHERE STATUS = 1;
        END IF;
     END IF;

     UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = WK_QTDIMP, CNTIMP = WK_CNTIMP, TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP WHERE TABELA = 'SER';
   ELSE RAISE EXCEPTION 'PG-20001 IMPORTAO DE SRIES NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;
  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1656 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_SLT () CASCADE;

/*-- SEQ 1657 --*/
CREATE OR REPLACE FUNCTION IMPORTA_SLT ()
RETURNS VARCHAR AS $$
DECLARE

-- 1) Importação das tabelas referentes a lote (TT_SLT, TT_LOT)
-- TI_SLT
WK_CODEXT       TI_SLT.CODEXT%TYPE;
WK_CODFIL       TI_SLT.CODFIL%TYPE;
WK_DESEST       TI_SLT.DESEST%TYPE;
WK_LANENT       TI_SLT.LANENT%TYPE;
WK_LANSAI       TI_SLT.LANSAI%TYPE;
WK_QTDEST       TI_SLT.QTDEST%TYPE;
WK_DATCRI       TI_SLT.DATCRI%TYPE;
WK_STATUS       TI_SLT.STATUS%TYPE;
WK_MOTREJ       TI_SLT.MOTREJ%TYPE;
WK_DATIMP       TI_SLT.DATIMP%TYPE;
-- TT_SLT
WK_QTDMOV       TI_SLT.QTDEST%TYPE;
WK_SLT_QTDEST   TT_SLT.QTDEST%TYPE;
--TT_LOT
WK_CODFIL_TLOT  TT_LOT.CODFIL%TYPE;
WK_SEQLOT_TLOT  TT_LOT.SEQUEN%TYPE;
WK_NUMLOT_TLOT  TT_LOT.NUMLOT%TYPE;
WK_FILMAT_TLOT  TT_LOT.FILMAT%TYPE;
WK_CODMAT_TLOT  TT_LOT.CODMAT%TYPE;
WK_CODCOR_TLOT  TT_LOT.CODCOR%TYPE;
WK_CODTAM_TLOT  TT_LOT.CODTAM%TYPE;
-- TD_FIL
WK_CODFIL_FIL   TI_SLT.CODFIL%TYPE;
-- TD_MUL
WK_CODMUL_MUL  TD_MUL.CODTAB%TYPE;
-- TT_IED
WK_DIALIM      TT_IED.DIALIM%TYPE;
WK_IMPORT      TT_IED.IMPORT%TYPE;
WK_MANTEM      TT_IED.MANTEM%TYPE;
WK_CNTIMP      TT_IED.CNTIMP%TYPE;
-- TT_CFG
WK_MAI_FR      TT_CFG.MAI_FR%TYPE;
WK_MAI_TO      TT_CFG.MAI_TO%TYPE;
WK_SAC_E_MAIL  TT_CFG.SAC_E_MAIL%TYPE;
-- TD_LAN
WK_COD_CODENT  TD_LAN.CODTAB%TYPE;
WK_COD_CODSAI  TD_LAN.CODTAB%TYPE;
WK_COD_CODLAN  TD_LAN.CODTAB%TYPE;
-- Outras variáveis
WK_CADASTRADO  Numeric;
WK_QTDIMP      Numeric;
WK_NROERR      Numeric;
WK_RESTO      Numeric;
WK_NUMREG     Numeric = 500;

CR_SALDOSLOTES CURSOR(pDATCRI TI_SLT.DATCRI%TYPE) IS
  SELECT *
    FROM (SELECT /*+INDEX(TI_SLT, I_LC_ISLT_STATUS*/
                 CODEXT, CODFIL, DESEST, LANENT, LANSAI, QTDEST, DATCRI,
                 STATUS, MOTREJ, DATIMP
            FROM TI_SLT
           WHERE STATUS = 0
             AND DATCRI BETWEEN TRUNC(pDATCRI)
                            AND ADD_DAY(TRUNC(pDATCRI),1)
           ORDER BY DATCRI) TAB
   LIMIT 1;
BEGIN
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e não existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20003 Execução de fora do sistema não permitida. Utilize a tela de Integração do Totali Backoffice ou o Totali Import.';
   END IF;

         SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
        INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
        FROM TT_IED
       WHERE TABELA = 'SLT';
   
   IF WK_IMPORT <> 'T' THEN
      RAISE EXCEPTION 'PG-20001 IMPORTAÇÃO DE SALDO DE ESTOQUE NÃO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;

   WK_CNTIMP := WK_CNTIMP + 1;
   WK_QTDIMP := 0;
   LOOP
      SELECT MIN(DATCRI)
        INTO WK_DATCRI
        FROM TI_SLT
       WHERE STATUS = 0;

      OPEN CR_SALDOSLOTES(WK_DATCRI);
      FETCH CR_SALDOSLOTES INTO WK_CODEXT, WK_CODFIL, WK_DESEST, WK_LANENT, WK_LANSAI, WK_QTDEST, WK_DATCRI,
                                WK_STATUS, WK_MOTREJ, WK_DATIMP;

      IF NOT FOUND THEN
         CLOSE CR_SALDOSLOTES;
         EXIT;
      END IF;

      
      IF WK_NUMREG = 0 THEN
         CLOSE CR_SALDOSLOTES;
         EXIT;
      END IF;
      
      WK_MOTREJ     := 'OK';

      -- TT_LOT
               SELECT L.CODFIL, L.SEQUEN, L.FILMAT, L.CODMAT, L.CODCOR, L.CODTAM
           INTO WK_CODFIL_TLOT, WK_SEQLOT_TLOT, WK_FILMAT_TLOT, WK_CODMAT_TLOT, WK_CODCOR_TLOT, WK_CODTAM_TLOT
           FROM TT_LOT L
          WHERE L.CODEXT = WK_CODEXT;
            IF WK_MOTREJ = 'OK' THEN
         IF WK_CODFIL_TLOT IS NULL THEN
            WK_MOTREJ := 'ERRO AO INSERIR SALDO DE LOTE: Número do Lote não encontrado';
         END IF;
      END IF;
            

      -- TD_FIL
               SELECT F.CODFIL
           INTO WK_CODFIL_FIL
           FROM TD_FIL F
          WHERE TRIM(F.CODFIL) = TRIM(WK_CODFIL);
            IF WK_MOTREJ = 'OK' THEN
         IF WK_CODFIL_FIL IS NULL THEN
            WK_MOTREJ := 'ERRO AO INSERIR SALDO DE LOTE: Filial não encontrada';
         END IF;
      END IF;

      -- TD_MUL
               IF WK_DESEST IS NOT NULL THEN
            SELECT M.CODTAB
              INTO WK_CODMUL_MUL
              FROM TD_MUL M
             WHERE TRIM(M.DESMUL) = TRIM(WK_DESEST);
         ELSE 
            WK_CODMUL_MUL := 0;
         END IF;
            IF WK_MOTREJ = 'OK' THEN
         IF WK_CODMUL_MUL IS NULL THEN
            WK_MOTREJ := 'ERRO AO INSERIR SALDO DE LOTE: Sub-Estoque do Lote não encontrado';
         END IF;
      END IF;

      -- Lançamentos SLT
      SELECT COUNT(*)
        INTO WK_CADASTRADO
        FROM TT_SLT TSLT INNER JOIN TT_LOT LOT ON LOT.CODFIL = TSLT.FILLOT
                                              AND LOT.SEQUEN = TSLT.SEQLOT
       WHERE TSLT.CODFIl = WK_CODFIL
         AND LOT.CODEXT = WK_CODEXT
         AND TSLT.CODMUL = WK_CODMUL_MUL;

      IF WK_MOTREJ = 'OK'
      AND WK_CADASTRADO = 0 THEN
         BEGIN
            IF WK_QTDEST IS NULL THEN
               RAISE EXCEPTION 'PG-20100 A coluna QTDEST deve ser preenchida';
            END IF;
            INSERT INTO TT_SLT (CODFIL, SEQUEN, CODMUL, FILLOT, SEQLOT, QTDEST, RESERV, ATU_EM)
                        VALUES (WK_CODFIL, NULL, WK_CODMUL_MUL, WK_CODFIL_TLOT, WK_SEQLOT_TLOT, 0, 0, AGORA());
         EXCEPTION
	         WHEN OTHERS THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR SALDO DE LOTE: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
         END;
      END IF; -- Fim Lançamentos TT_SLT
      IF NOT WK_MOTREJ = 'OK' THEN
         WK_STATUS := 4;
         WK_NROERR := WK_NROERR + 1;
      ELSE
         WK_STATUS := 3;
      END IF;

      --Lançamentos avulsos --
               SELECT TSLT.QTDEST
           INTO WK_SLT_QTDEST
           FROM TT_SLT TSLT INNER JOIN TT_LOT LOT ON LOT.CODFIL = TSLT.FILLOT
                                                 AND LOT.SEQUEN = TSLT.SEQLOT
                            INNER JOIN TT_GRA GRA ON GRA.FILMAT = LOT.FILMAT
                                                 AND GRA.CODMAT = LOT.CODMAT
                                                 AND GRA.CODCOR = LOT.CODCOR
                                                 AND GRA.CODTAM = LOT.CODTAM
          WHERE TSLT.CODFIL = WK_CODFIL
            AND LOT.CODEXT = WK_CODEXT
            AND TSLT.CODMUL = WK_CODMUL_MUL;
      
      WK_QTDMOV := 0;
      IF WK_SLT_QTDEST <> WK_QTDEST THEN
         WK_QTDMOV := (WK_SLT_QTDEST - WK_QTDEST) * -1;
      ELSE 
        IF WK_CADASTRADO = 0 THEN
          WK_QTDMOV := WK_QTDEST;
        END IF;
      END IF;

      IF WK_QTDMOV <> 0 THEN
         BEGIN
            IF WK_QTDMOV < 0 THEN
               WK_COD_CODSAI := IMPORTA_TDS( 'TD_LAN', 'LANATI', 'DESLAN', 'CODTAB', WK_LANSAI, NULL, NULL, NULL );
               WK_COD_CODLAN := WK_COD_CODSAI;
            ELSE
               WK_COD_CODENT := IMPORTA_TDS( 'TD_LAN', 'LANATI', 'DESLAN', 'CODTAB', WK_LANENT, NULL, NULL, NULL );
               WK_COD_CODLAN := WK_COD_CODENT;
            END IF;
            INSERT INTO TT_LAN (CODFIL,SITMOV,TIPMOV,CODUSU,FILMAT,FILUSU,CODMAT,DOCUME,ATU_EM,DATMOV,
                                QTDMOV,CODCOR,CODTAM,TIPLAN,VLRMOV,CODMUL,DATINC,EXPORT,FILLOT,SEQLOT)
                        VALUES (WK_CODFIL, 'N', 'I', '  1', WK_FILMAT_TLOT, '001', WK_CODMAT_TLOT, 'IMPORTACAO', AGORA(), AGORA(),
                                WK_QTDMOV, WK_CODCOR_TLOT, WK_CODTAM_TLOT, WK_COD_CODLAN, WK_QTDMOV * COALESCE(NULL,1),WK_CODMUL_MUL, AGORA(), 'T',WK_CODFIL_TLOT, WK_SEQLOT_TLOT);

         EXCEPTION
            WHEN OTHERS THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR LANÇAMENTO: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
         END;
      ELSE
         WK_STATUS := 3;
      END IF; -- Final Lançamentos avuslos --

      IF NOT WK_MOTREJ = 'OK' THEN
         WK_STATUS := 4;
         WK_NROERR := WK_NROERR + 1;
      ELSE
         WK_STATUS := 3;
      END IF;

      UPDATE TI_SLT
         SET STATUS = WK_STATUS,
             DATIMP = AGORA(),
             MOTREJ = WK_MOTREJ
       WHERE CODEXT = WK_CODEXT
         AND CODFIL = WK_CODFIL
         AND DATCRI = WK_DATCRI
         AND ((DESEST = WK_DESEST) OR (DESEST IS NULL AND WK_DESEST IS NULL))
         AND DATIMP IS NULL;

      
      WK_QTDIMP := WK_QTDIMP + 1;

      
      WK_NUMREG := WK_NUMREG - 1;
            CLOSE CR_SALDOSLOTES;
   END LOOP;

   
   IF WK_NUMREG>0 THEN
         UPDATE TI_SLT
         SET STATUS = 2,
             MOTREJ = 'SALDOS DE LOTES NÃO IMPORTADOS'
       WHERE STATUS = 0;
   
   END IF;
   
   IF WK_NROERR <> 0 THEN

      SELECT MAI_FR, MAI_TO, SAC_E_MAIL
        INTO WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL
        FROM TT_CFG;
      IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
         INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO,MAI_CC,
                             TEXTOS,TIPMSG)
                     VALUES ('001','F',AGORA(),'IMPORTAÇÃO DE SALDOS DE ESTOQUE',WK_MAI_FR, WK_MAI_TO, WK_SAC_E_MAIL,
                             'Problema na importação de '||wk_nroerr||' saldos de estoque. Verifique!','T');
      END IF;
   END IF;

   UPDATE TI_SLT
      SET STATUS = CASE WHEN STATUS = 3
                        THEN 1
                        ELSE 2
                   END
    WHERE STATUS IN (3,4);

   IF WK_MANTEM = 'F' THEN
      IF WK_DIALIM > 0 THEN
         DELETE FROM TI_SLT
          WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
            AND STATUS = 1;
      ELSE
         DELETE FROM TI_SLT
		    WHERE STATUS = 1;
      END IF;
   END IF;

   UPDATE TT_IED
      SET ULTIMP = AGORA(),
          QTDIMP = WK_QTDIMP,
          CNTIMP = WK_CNTIMP,
          TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP
    WHERE TABELA = 'SLT';

   
   
   IF WK_NUMREG=0 THEN

      SELECT COUNT(*)
        INTO WK_RESTO
        FROM TI_SLT
       WHERE STATUS = 0;

      IF WK_RESTO > 0 THEN
         RETURN 'EXISTEM '||WK_RESTO||' SALDOS DE LOTES AINDA NÃO IMPORTADOS. EXECUTE NOVAMENTE.';
      END IF;
   END IF;

   SELECT COUNT(*)
     INTO WK_RESTO
     FROM TI_SLT
    WHERE STATUS = 2;

   IF WK_RESTO > 0 THEN
      RETURN 'EXISTEM '||WK_RESTO||' SALDOS DE LOTES NÃO IMPORTADOS VERIFIQUE';
   ELSE
      RETURN 'OK';
   END IF;
     RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1658 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_USU () CASCADE;

/*-- SEQ 1659 --*/
CREATE OR REPLACE FUNCTION IMPORTA_USU ()
RETURNS VARCHAR AS $$
DECLARE

-- Objetivo:
-- 1) Importao da tabela TT_USU


WK_FILUSU     TI_USU.FILUSU%TYPE;
WK_CODSUP     TI_USU.CODSUP%TYPE;
WK_FILCLI     TI_USU.FILCLI%TYPE;
WK_FILSUP     TI_USU.FILSUP%TYPE;
WK_CODCLI     TI_USU.CODCLI%TYPE;
WK_CODEXT     TI_USU.CODEXT%TYPE;
WK_SENHA1     TI_USU.SENHA1%TYPE;
WK_SENHA2     TI_USU.SENHA2%TYPE;
WK_PERMIS     TI_USU.PERMIS%TYPE;
WK_ATU_EM     TI_USU.ATU_EM%TYPE;
WK_PERCOM     TI_USU.PERCOM%TYPE;
WK_HORDOM     TI_USU.HORDOM%TYPE;
WK_HORQUA     TI_USU.HORQUA%TYPE;
WK_HORQUI     TI_USU.HORQUI%TYPE;
WK_HORSAB     TI_USU.HORSAB%TYPE;
WK_HORSEG     TI_USU.HORSEG%TYPE;
WK_HORSEX     TI_USU.HORSEX%TYPE;
WK_HORTER     TI_USU.HORTER%TYPE;
WK_CODCTR     TI_USU.CODCTR%TYPE;
WK_MAIDAT     TI_USU.MAIDAT%TYPE;
WK_MENDAT     TI_USU.MENDAT%TYPE;
WK_NIVUSU     TI_USU.NIVUSU%TYPE;
WK_SIGNAT     TI_USU.SIGNAT%TYPE;
WK_AGENDB     TI_USU.AGENDB%TYPE;
WK_EDINDB     TI_USU.EDINDB%TYPE;
WK_USANDB     TI_USU.USANDB%TYPE;
WK_USANDC     TI_USU.USANDC%TYPE;
WK_APEUSU     TI_USU.APEUSU%TYPE;
WK_NOMUSU     TI_USU.NOMUSU%TYPE;
WK_FILATV     TI_USU.FILATV%TYPE;
WK_TABATU     TI_USU.TABATU%TYPE;
WK_MAXDAT     TI_USU.MAXDAT%TYPE;
WK_MINDAT     TI_USU.MINDAT%TYPE;
WK_VISSE1     TI_USU.VISSE1%TYPE;
WK_VISSE2     TI_USU.VISSE2%TYPE;
WK_LIMCOM     TI_USU.LIMCOM%TYPE;
WK_E_MAIL     TI_USU.E_MAIL%TYPE;
WK_VISPER     TI_USU.VISPER%TYPE;
WK_PATNDB     TI_USU.PATNDB%TYPE;
WK_GRUPOS     TI_USU.GRUPOS%TYPE;
WK_INDPRO     TI_USU.INDPRO%TYPE;
WK_CODSET     TI_USU.CODSET%TYPE;
WK_FAZENQ     TI_USU.FAZENQ%TYPE;
WK_FUNCAO     TI_USU.FUNCAO%TYPE;
WK_FAZMON     TI_USU.FAZMON%TYPE;
WK_USUCOB     TI_USU.USUCOB%TYPE;
WK_NUMPAL     TI_USU.NUMPAL%TYPE;
WK_COMIMP     TI_USU.COMIMP%TYPE;
WK_VALSEN     TI_USU.VALSEN%TYPE;
WK_FILINI     TI_USU.FILINI%TYPE;
WK_CODINI     TI_USU.CODINI%TYPE;
WK_CFGINI     TI_USU.CFGINI%TYPE;
WK_VISWOR     TI_USU.VISWOR%TYPE;
WK_STATUS     TI_USU.STATUS%TYPE;
WK_MOTREJ     TI_USU.MOTREJ%TYPE;
WK_DATIMP     TI_USU.DATIMP%TYPE;
WK_CSENHA     TI_USU.CSENHA%TYPE;
WK_TIPOPE     TI_USU.TIPOPE%TYPE;
WK_DOCPAR     TI_USU.DOCPAR%TYPE;
WK_NROERR     Numeric;
WK_QTDIMP     Numeric;
WK_IMPORT     TT_IED.IMPORT%TYPE;
WK_MANTEM     TT_IED.MANTEM%TYPE;
WK_CNTIMP     TT_IED.CNTIMP%TYPE;
WK_COD_CODUSU TT_USU.CODUSU%TYPE;
WK_COD_CODSUP TT_USU.CODSUP%TYPE;
WK_COD_CODCTR TT_USU.CODCTR%TYPE;
WK_COD_CODCLI TT_CLI.CODCLI%TYPE;
WK_COD_FILCLI TT_CLI.FILCLI%TYPE;
WK_MAI_FR     TT_CFG.MAI_FR%TYPE;
WK_MAI_TO     TT_CFG.MAI_TO%TYPE;
WK_COD_CODSET TD_SET.CODTAB%TYPE;
WK_COD_FILSUP TT_USU.FILUSU%TYPE;
W_EXISTE      Numeric;
WK_DIALIM     TT_IED.DIALIM%TYPE;
WK_DATCRI     TI_USU.DATCRI%TYPE;
WK_HORRATCOR  TT_USU.HORRATCOR%TYPE;
WK_PERRATCOB  TT_USU.PERRATCOB%TYPE;
WK_MINRATCOB  TT_USU.MINRATCOB%TYPE;


CR_USUARIO CURSOR(pDATCRI TI_USU.DATCRI%TYPE) IS
/*Status => 0 no processado
         => 1 processado com sucesso
         => 2 processado com erro*/
  SELECT *
    FROM (SELECT FILUSU,CODSUP,FILCLI,FILSUP,CODCLI,CODEXT,SENHA1,SENHA2,PERMIS,ATU_EM,PERCOM,HORDOM,
                 HORQUA,HORQUI,HORSAB,HORSEG,HORSEX,HORTER,CODCTR,MAIDAT,MENDAT,NIVUSU,SIGNAT,AGENDB,
                 EDINDB,USANDB,USANDC,APEUSU,NOMUSU,FILATV,TABATU,MAXDAT,MINDAT,VISSE1,VISSE2,LIMCOM,
                 E_MAIL,VISPER,PATNDB,GRUPOS,INDPRO,CODSET,FAZENQ,FUNCAO,FAZMON,USUCOB,NUMPAL,COMIMP,
                 VALSEN,FILINI,CODINI,CFGINI,VISWOR,CSENHA,HORRATCOR,PERRATCOB,MINRATCOB, COALESCE(TIPOPE, 'T') AS TIPOPE, DOCPAR
            FROM TI_USU
           WHERE STATUS = 0
             AND DATCRI BETWEEN TRUNC(pDATCRI)
                            AND ADD_DAY(TRUNC(pDATCRI),1)
           ORDER BY DATCRI
         ) TAB
   LIMIT 1;

BEGIN
 
   -- RFMP 80113
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20002 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

   SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
     INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
     FROM TT_IED
   WHERE TABELA = 'USU';

   IF WK_IMPORT = 'T' THEN
     WK_CNTIMP := WK_CNTIMP + 1;
     WK_NROERR := 0;
     WK_QTDIMP := 0;

     LOOP

       WK_COD_CODUSU := NULL;
       WK_COD_CODSUP := NULL;
       WK_COD_CODCTR := NULL;
       WK_COD_CODCLI := NULL;
       WK_COD_FILCLI := NULL;
       WK_COD_CODSET := NULL;
       WK_COD_FILSUP := NULL;

       SELECT MIN(DATCRI)
         INTO WK_DATCRI
         FROM TI_USU
        WHERE STATUS = 0;

       OPEN CR_USUARIO(WK_DATCRI);
       FETCH CR_USUARIO INTO WK_FILUSU,WK_CODSUP,WK_FILCLI,WK_FILSUP,WK_CODCLI,WK_CODEXT,
                             WK_SENHA1,WK_SENHA2,WK_PERMIS,WK_ATU_EM,WK_PERCOM,WK_HORDOM,
                             WK_HORQUA,WK_HORQUI,WK_HORSAB,WK_HORSEG,WK_HORSEX,WK_HORTER,
                             WK_CODCTR,WK_MAIDAT,WK_MENDAT,WK_NIVUSU,WK_SIGNAT,WK_AGENDB,
                             WK_EDINDB,WK_USANDB,WK_USANDC,WK_APEUSU,WK_NOMUSU,WK_FILATV,
                             WK_TABATU,WK_MAXDAT,WK_MINDAT,WK_VISSE1,WK_VISSE2,WK_LIMCOM,
                             WK_E_MAIL,WK_VISPER,WK_PATNDB,WK_GRUPOS,WK_INDPRO,WK_CODSET,
                             WK_FAZENQ,WK_FUNCAO,WK_FAZMON,WK_USUCOB,WK_NUMPAL,WK_COMIMP,
                             WK_VALSEN,WK_FILINI,WK_CODINI,WK_CFGINI,WK_VISWOR,WK_CSENHA,
                             WK_HORRATCOR,WK_PERRATCOB,WK_MINRATCOB, WK_TIPOPE, WK_DOCPAR;

       IF NOT FOUND THEN
          CLOSE CR_USUARIO;
          EXIT;
       END IF;
       
       

       IF WK_CODSET IS NOT NULL THEN
          WK_COD_CODSET := IMPORTA_TDS( 'TD_SET', 'SETATI', 'DESSET', 'CODTAB', WK_CODSET, NULL, NULL, NULL );
       END IF;
       IF WK_COD_CODSET IS NULL THEN
          WK_COD_CODSET := 0;
       END IF;

       WK_COD_CODCTR := 0;--IMPORTA_TDS( 'TD_CTR', 'CTRATI', 'DESCTR', 'CODTAB', WK_CODCTR, NULL, NULL, NULL );

       WK_MOTREJ     := 'OK';

       SELECT MAX(TO_NUMBER(TU.CODUSU))+1
         INTO WK_COD_CODUSU
         FROM TT_USU TU;

         SELECT TU.CODUSU, TU.FILUSU INTO WK_COD_CODSUP, WK_COD_FILSUP
           FROM TT_USU TU
          WHERE TRIM(TU.FILUSU) = TRIM(WK_FILSUP)
            AND TRIM(TU.CODEXT) = TRIM(WK_CODSUP);
      IF (ISNULL(WK_COD_CODSUP)='T') THEN
          WK_MOTREJ := SUBSTR('Supervisor '|| COALESCE(WK_FILSUP,'') || ' - ' || COALESCE(WK_CODSUP,'') ||' no localizado: ',1,255);
       END IF;
       IF (ISNULL(WK_DOCPAR)='T') AND (ISNULL(WK_CODCLI)='T') THEN
          WK_MOTREJ := SUBSTR('Parceiro no informado, preencha um dos campos "DOCPAR" ou "CODCLI": ', 1,255);
       END IF;

       IF WK_MOTREJ = 'OK' THEN --continua a importao

          
         SELECT C.CODCLI, C.FILCLI
           INTO WK_COD_CODCLI,WK_COD_FILCLI
           FROM TT_CLI C
          WHERE TRIM(C.CODEXT) = TRIM(WK_CODCLI);
         IF (ISNULL(WK_COD_CODCLI)='T') OR (ISNULL(WK_COD_FILCLI)='T')THEN
             SELECT C.CODCLI, C.FILCLI
               INTO WK_COD_CODCLI,WK_COD_FILCLI
               FROM TT_CLI C
              WHERE TRIM(C.NUMDOC) = TRIM(WK_DOCPAR);
         END IF;
         

       IF (ISNULL(WK_COD_CODCLI)='T') AND (ISNULL(WK_COD_FILCLI)='T')THEN
         WK_MOTREJ := SUBSTR('Parceiro '|| COALESCE(WK_CODCLI,'') || ' - ' || COALESCE(WK_DOCPAR,'') ||' no localizado: ',1,255);  
       END IF;  

       IF WK_MOTREJ = 'OK' THEN 
           W_EXISTE := 0;

         SELECT 1 INTO W_EXISTE
         FROM TT_USU TU
         WHERE TU.CODEXT = WK_CODEXT;

       IF W_EXISTE IS NULL THEN
           W_EXISTE := 0;
       END IF;


       IF W_EXISTE = 0 THEN --registro novo
         IF (WK_TIPOPE IN ('T', 'I')) THEN
          BEGIN
              INSERT INTO TT_USU(FILUSU,CODUSU,CODSUP,FILCLI,FILSUP,CODCLI,CODEXT,SENHA1,
                                 SENHA2,PERMIS,ATU_EM,PERCOM,HORDOM,HORQUA,HORQUI,HORSAB,
                                 HORSEG,HORSEX,HORTER,CODCTR,MAIDAT,MENDAT,NIVUSU,SIGNAT,
                                 AGENDB,EDINDB,USANDB,USANDC,APEUSU,NOMUSU,FILATV,TABATU,
                                 MAXDAT,MINDAT,VISSE1,VISSE2,LIMCOM,E_MAIL,VISPER,PATNDB,
                                 GRUPOS,INDPRO,CODSET,FAZENQ,FUNCAO,FAZMON,USUCOB,NUMPAL,
                                 COMIMP,VALSEN,FILINI,CODINI,CFGINI,VISWOR,CSENHA,
                                 HORRATCOR,PERRATCOB,MINRATCOB)
                          VALUES(WK_FILUSU,LPAD(TRIM(WK_COD_CODUSU),3,' '),COALESCE(LPAD(TRIM(WK_COD_CODSUP),3,' '),LPAD(TRIM(WK_COD_CODUSU),3,' ')),
                                 WK_COD_FILCLI,COALESCE(WK_COD_FILSUP,WK_FILUSU),WK_COD_CODCLI,WK_CODEXT,WK_SENHA1,
                                 WK_SENHA2,SUBSTR(WK_PERMIS,1,1000),WK_ATU_EM,WK_PERCOM,WK_HORDOM,WK_HORQUA,WK_HORQUI,WK_HORSAB,
                                 WK_HORSEG,WK_HORSEX,WK_HORTER,WK_COD_CODCTR,WK_MAIDAT,WK_MENDAT,WK_NIVUSU,WK_SIGNAT,
                                 WK_AGENDB,WK_EDINDB,WK_USANDB,WK_USANDC,WK_APEUSU,WK_NOMUSU,WK_FILATV,WK_TABATU,
                                 WK_MAXDAT,WK_MINDAT,WK_VISSE1,WK_VISSE2,WK_LIMCOM,WK_E_MAIL,WK_VISPER,WK_PATNDB,
                                 WK_GRUPOS,WK_INDPRO,WK_COD_CODSET,WK_FAZENQ,WK_FUNCAO,WK_FAZMON,WK_USUCOB,WK_NUMPAL,
                                 WK_COMIMP,WK_VALSEN,WK_FILINI,WK_CODINI,WK_CFGINI,WK_VISWOR,WK_CSENHA,
                                 WK_HORRATCOR,WK_PERRATCOB,WK_MINRATCOB);

          EXCEPTION
          
          WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ = SUBSTR('ERRO AO IMPORTAR USUARIOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ = SUBSTR('ERRO AO IMPORTAR USUARIOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ = SUBSTR('ERRO AO IMPORTAR USUARIOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ = SUBSTR('ERRO AO IMPORTAR USUARIOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ = SUBSTR('ERRO AO IMPORTAR USUARIOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ = SUBSTR('ERRO AO IMPORTAR USUARIOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR USUARIOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;   
                              END;
         ELSE
           IF WK_MOTREJ = 'OK' THEN
              WK_MOTREJ := SUBSTR('Operao de incluso no permitida. Registro "'||WK_CODEXT|| ' - '||WK_NOMUSU||'", no existe no sistema. Verifique o tipo de operao e informe uma das opes (I-Incluso, T-Todas).',1,255);
           END IF;
         END IF;
       ELSE
         IF (WK_TIPOPE IN ('A', 'T')) THEN
            IF (LENGTH(TRIM(WK_PERMIS))<1000) THEN 
               WK_PERMIS := NULL;
            ELSE 
               WK_PERMIS := SUBSTR(WK_PERMIS,1,1000);
            END IF;
         
             BEGIN
                 UPDATE TT_USU SET CODSUP = WK_COD_CODSUP,
                                   FILCLI = WK_COD_FILCLI,FILSUP = WK_COD_FILSUP,CODCLI = WK_COD_CODCLI,
                                   SENHA1 = WK_SENHA1,SENHA2 = WK_SENHA2,PERMIS = COALESCE(WK_PERMIS, PERMIS),ATU_EM = WK_ATU_EM,
                                   PERCOM = WK_PERCOM,HORDOM = WK_HORDOM,HORQUA = WK_HORQUA,HORQUI = WK_HORQUI,
                                   HORSAB = WK_HORSAB,HORSEG = WK_HORSEG,HORSEX = WK_HORSEX,HORTER = WK_HORTER,
                                   CODCTR = WK_COD_CODCTR,MAIDAT = WK_MAIDAT,MENDAT = WK_MENDAT,NIVUSU = WK_NIVUSU,
                                   SIGNAT = WK_SIGNAT,AGENDB = WK_AGENDB,EDINDB = WK_EDINDB,USANDB = WK_USANDB,
                                   USANDC = WK_USANDC,APEUSU = WK_APEUSU,NOMUSU = WK_NOMUSU,FILATV = WK_FILATV,
                                   TABATU = WK_TABATU,MAXDAT = WK_MAXDAT,MINDAT = WK_MINDAT,VISSE1 = WK_VISSE1,
                                   VISSE2 = WK_VISSE2,LIMCOM = WK_LIMCOM,E_MAIL = WK_E_MAIL,VISPER = WK_VISPER,
                                   PATNDB = WK_PATNDB,GRUPOS = WK_GRUPOS,INDPRO = WK_INDPRO,CODSET = WK_COD_CODSET,
                                   FAZENQ = WK_FAZENQ,FUNCAO = WK_FUNCAO,FAZMON = WK_FAZMON,USUCOB = WK_USUCOB,
                                   NUMPAL = WK_NUMPAL,COMIMP = WK_COMIMP,VALSEN = WK_VALSEN,FILINI = WK_FILINI,
                                   CODINI = WK_CODINI,CFGINI = WK_CFGINI,VISWOR = WK_VISWOR,CSENHA = WK_CSENHA,
                                   HORRATCOR = WK_HORRATCOR,PERRATCOB = WK_PERRATCOB,MINRATCOB = WK_MINRATCOB
                 WHERE CODEXT = WK_CODEXT;
             EXCEPTION
             
             WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ = SUBSTR('ERRO AO IMPORTAR ALTERACAO DE USUARIOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ = SUBSTR('ERRO AO IMPORTAR ALTERACAO DE USUARIOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ = SUBSTR('ERRO AO IMPORTAR ALTERACAO DE USUARIOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ = SUBSTR('ERRO AO IMPORTAR ALTERACAO DE USUARIOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ = SUBSTR('ERRO AO IMPORTAR ALTERACAO DE USUARIOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ = SUBSTR('ERRO AO IMPORTAR ALTERACAO DE USUARIOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
             WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO DE USUARIOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                                       END;
         ELSE
           IF WK_MOTREJ = 'OK' THEN 
              WK_MOTREJ := SUBSTR('Operao de alterao no permitida. Registro "'||WK_CODEXT|| ' - '||WK_NOMUSU||'", j existe no sistema. Verifique o tipo de operao e informe uma das opes (A-Alterao, T-Todas).',1,255);
           END IF;
         END IF;
       END IF;
      END IF;
     END IF; --continua a importao
      
        IF NOT WK_MOTREJ = 'OK' THEN
           WK_STATUS := 4;
           WK_NROERR := WK_NROERR + 1;
        ELSE
          WK_STATUS := 3;
        END IF;

        UPDATE TI_USU SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
        WHERE CODEXT = WK_CODEXT
          AND DATIMP IS NULL;

        WK_QTDIMP := WK_QTDIMP + 1;
        CLOSE CR_USUARIO;
     END LOOP;

     IF WK_NROERR <> 0 THEN
        SELECT MAI_FR, MAI_TO
          INTO WK_MAI_FR, WK_MAI_TO
          FROM TT_CFG;
        IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
           INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO,
                               TEXTOS,TIPMSG)
                       VALUES ('001','F',AGORA(),'IMPORTAO USUARIOS',WK_MAI_FR, WK_MAI_TO,
                              'Problema na importao de '||wk_nroerr||' usuarios. Verifique!','T');
        END IF;

     END IF;

     UPDATE TI_USU SET STATUS = CASE WHEN STATUS = 3
                                     THEN 1
                                     ELSE 2
                                 END
      WHERE STATUS IN (3,4);
     IF WK_MANTEM = 'F' THEN
        IF WK_DIALIM > 0 THEN
           DELETE FROM TI_USU
            WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
			  AND STATUS = 1;
        ELSE
           DELETE FROM TI_USU
		    WHERE STATUS = 1;
        END IF;
     END IF;

     UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = WK_QTDIMP, CNTIMP = WK_CNTIMP, TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP WHERE TABELA = 'USU';
   ELSE RAISE EXCEPTION 'PG-20001 IMPORTAO DE USURIOS NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;
   
  RETURN NULL;

END;
$$ language 'plpgsql';





/*-- SEQ 1660 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION IMPORTA_VEN () CASCADE;

/*-- SEQ 1661 --*/
CREATE OR REPLACE FUNCTION IMPORTA_VEN ()
RETURNS VARCHAR AS $$
DECLARE


WK_CODFIL     TI_VEN.CODFIL%TYPE;
WK_FLGEST     TI_VEN.FLGEST%TYPE;
WK_FLGTIP     TI_VEN.FLGTIP%TYPE;
WK_TIPNOT     TI_VEN.TIPNOT%TYPE;
WK_CODSER     TI_VEN.CODSER%TYPE;
WK_CODUSU     TI_VEN.CODUSU%TYPE;
WK_CODVEN     TI_VEN.CODVEN%TYPE;
WK_CODCLI     TI_VEN.CODCLI%TYPE;
WK_NUMECF     TI_VEN.NUMECF%TYPE;
WK_NUMNOT     TI_VEN.NUMNOT%TYPE;
WK_ATU_EM     TI_VEN.ATU_EM%TYPE;
WK_DATHOR     TI_VEN.DATHOR%TYPE;
WK_VLRLIQ     TI_VEN.VLRLIQ%TYPE;
WK_VLRNOT     TI_VEN.VLRNOT%TYPE;
WK_CODCTR     TI_VEN.CODCTR%TYPE;
WK_COMSOB     TI_VEN.COMSOB%TYPE;
WK_AUTENT     TI_VEN.AUTENT%TYPE;
WK_CONSFI     TI_VEN.CONSFI%TYPE;
WK_EMIDES     TI_VEN.EMIDES%TYPE;
WK_FINANC     TI_VEN.FINANC%TYPE;
WK_TRIBUT     TI_VEN.TRIBUT%TYPE;
WK_UFLOJA     TI_VEN.UFLOJA%TYPE;
WK_DATSAI     TI_VEN.DATSAI%TYPE;
WK_DESCON     TI_VEN.DESCON%TYPE;
WK_ACRESC     TI_VEN.ACRESC%TYPE;
WK_PESBRU     TI_VEN.PESBRU%TYPE;
WK_PESLIQ     TI_VEN.PESLIQ%TYPE;
WK_VLRFRE     TI_VEN.VLRFRE%TYPE;
WK_VLRSEG     TI_VEN.VLRSEG%TYPE;
WK_NROIMP     TI_VEN.NROIMP%TYPE;
WK_CODPRE     TI_VEN.CODPRE%TYPE;
WK_CODDEV     TI_VEN.CODDEV%TYPE;
WK_OBSERV     TI_VEN.OBSERV%TYPE;
WK_LANVEN     TI_VEN.LANVEN%TYPE;
WK_DATFIS     TI_VEN.DATFIS%TYPE;
WK_NUMVOL     TI_VEN.NUMVOL%TYPE;
WK_VLRCOF     TI_VEN.VLRCOF%TYPE;
WK_STATUS     TI_VEN.STATUS%TYPE;
WK_MOTREJ     TI_VEN.MOTREJ%TYPE;
WK_DATIMP     TI_VEN.DATIMP%TYPE;
WK_CODPGT     TI_VEN.CODPGT%TYPE;
WK_FILCOB     TI_VEN.FILCOB%TYPE;
WK_FILENT     TI_VEN.FILENT%TYPE;
WK_FILFAT     TI_VEN.FILFAT%TYPE;
WK_COD_FILGUI     TT_VEN.FILGUI%TYPE;
WK_COD_CODGUI     TT_VEN.CODGUI%TYPE;
WK_CODGUI     TI_VEN.CODGUI%TYPE;
WK_CODTRA     TI_VEN.CODTRA%TYPE;
WK_NUMCON     TI_VEN.NUMCON%TYPE;
WK_PROPGT     TI_VEN.PROPGT%TYPE;
WK_PERCOM     TI_VEN.PERCOM%TYPE;
WK_PERENT     TI_VEN.PERENT%TYPE;
WK_SINAL      TI_VEN.SINAL%TYPE;
WK_ENDCOB     TI_VEN.ENDCOB%TYPE;
WK_ENDENT     TI_VEN.ENDENT%TYPE;
WK_ENDFAT     TI_VEN.ENDFAT%TYPE;
WK_CODFIN     TI_VEN.CODFIN%TYPE;
WK_ESPECI     TI_VEN.ESPECI%TYPE;
WK_PRAMED     TI_VEN.PRAMED%TYPE;
WK_SIGNAT     TI_VEN.SIGNAT%TYPE;
WK_BASUBS     TI_VEN.BASUBS%TYPE;
WK_RETIDO     TI_VEN.RETIDO%TYPE;
WK_SUBSTT     TI_VEN.SUBSTT%TYPE;
WK_CODEXT     TI_VEN.CODEXT%TYPE;
WK_VINCUL     TI_VEN.VINCUL%TYPE;
WK_MARCAS     TI_VEN.MARCAS%TYPE;
WK_EXPORT     TI_VEN.EXPORT%TYPE;
WK_TIPTRO     TI_VEN.TIPTRO%TYPE;
WK_QTDREN     TI_VEN.QTDREN%TYPE;
WK_PLAFRE     TI_VEN.PLAFRE%TYPE;
WK_UF_FRE     TI_VEN.UF_FRE%TYPE;
WK_ECFFAT     TI_VEN.ECFFAT%TYPE;
WK_SERFAT     TI_VEN.SERFAT%TYPE;
WK_NUMFAT     TI_VEN.NUMFAT%TYPE;
WK_FILPGT     TI_VEN.FILPGT%TYPE;
WK_NATDEN     TI_VEN.NATDEN%TYPE;
WK_NATFOR     TI_VEN.NATFOR%TYPE;
WK_NROERR     Numeric;
WK_QTDIMP     Numeric;
WK_IMPORT     TT_IED.IMPORT%TYPE;
WK_MANTEM     TT_IED.MANTEM%TYPE;
WK_CNTIMP     TT_IED.CNTIMP%TYPE;
WK_MAI_FR     TT_CFG.MAI_FR%TYPE;
WK_MAI_TO     TT_CFG.MAI_TO%TYPE;
WK_AUX_CODCTR TD_CTR.CODTAB%TYPE;
WK_COD_CODDEV TD_DEV.CODTAB%TYPE;
WK_COD_CODPRE TT_PRE.CODPRE%TYPE;
WK_AUX_CODPRE TT_PRE.CODPRE%TYPE;
WK_AUX_FILUSU TT_USU.FILUSU%TYPE;
WK_AUX_CODUSU TT_USU.CODUSU%TYPE;
WK_AUX_CODCLI TT_CLI.CODCLI%TYPE;
WK_AUX_CODVEN TT_USU.CODUSU%TYPE;
WK_AUX_FILCLI TT_CLI.FILCLI%TYPE;
WK_AUX_TIPTRA TT_VEN.TIPTRA%TYPE;
WK_AUX_FILTRA TT_VEN.FILTRA%TYPE;
WK_AUX_CODTRA TT_VEN.CODTRA%TYPE;
WK_AUX_FILVEN TT_VEN.FILVEN%TYPE;
WK_AUX_FILFAT TT_VEN.FILFAT%TYPE;
WK_AUX_SEQFAT TT_VEN.SEQFAT%TYPE;
WK_AUX_FILPGT TT_VEN.FILPGT%TYPE;
WK_AUX_CODPGT TT_VEN.CODPGT%TYPE;
WK_COD_CODNAT TT_VEN.CODNAT%TYPE;
WK_CODLOJ     TT_IDF.CODLOJ%TYPE;
WK_DIALIM     TT_IED.DIALIM%TYPE;
WK_UFFILIAL   TD_FIL.UFLOJA%TYPE;
WK_DATCRI     TI_VEN.DATCRI%TYPE;
WK_IMPRIM     TI_VEN.IMPRIM%TYPE;
WK_AUTINT     TI_VEN.AUTINT%TYPE;
WK_ORIVEN     TI_VEN.ORIVEN%TYPE;
WK_AVISTA     TI_VEN.AVISTA%TYPE;
WK_CODNSU     TI_VEN.CODNSU%TYPE;
WK_CNT_RO     TI_VEN.CNT_RO%TYPE;
WK_FUNRUR     TI_VEN.FUNRUR%TYPE;
WK_OUTTAX     TI_VEN.OUTTAX%TYPE;
WK_DOCNFP     TI_VEN.DOCNFP%TYPE;
WK_ID_IVEN    TI_VEN.ID_IVEN%TYPE;
WK_EXISTESERIE Numeric;
WK_AUX_FLGEST  TT_VEN.FLGEST%TYPE;
WK_AUX_SEQUEN  TT_VEN.SEQUEN%TYPE;
WK_FIL_EXISTE  TI_VEN.STATUS%TYPE;
WK_FLGNFE      TI_VEN.FLGNFE%TYPE;
WK_CHAVEA      TI_VEN.CHAVEA%TYPE;
WK_NUMDOC      TI_VEN.NUMDOC%TYPE;

W_EXISTE      Numeric(1);
WK_FILPRE     TI_VEN.FILPRE%TYPE;
WK_RESTO      Numeric;
WK_NUMREG     Numeric = 500;

CR_VENDAS CURSOR(pDATCRI TI_VEN.DATCRI%TYPE) IS
--Status => 0 no processado
--       => 1 processado com sucesso
--       => 2 processado com erro
  SELECT *
    FROM (SELECT /*+INDEX(TI_VEN, I_LC_IVEN_STATUS)*/
                 CODFIL,FLGEST,FLGTIP,TIPNOT,CODSER,CODUSU,CODVEN,CODCLI,NUMECF,NUMNOT,
                 ATU_EM,DATHOR,VLRLIQ,VLRNOT,CODCTR,COMSOB,AUTENT,CONSFI,EMIDES,
                 FINANC,TRIBUT,UFLOJA,DATSAI,DESCON,ACRESC,PESBRU,PESLIQ,VLRFRE,VLRSEG,
                 NROIMP,CODPRE,CODDEV,OBSERV,LANVEN,DATFIS,NUMVOL,VLRCOF,MOTREJ,
                 DATIMP,CODPGT,FILCOB,FILENT,FILFAT,ECFFAT,SERFAT,NUMFAT,
                 CODGUI,CODTRA,NUMCON,PROPGT,PERCOM,PERENT,SINAL,
                 ENDCOB,ENDENT,ENDFAT,CODFIN,ESPECI,PRAMED,SIGNAT,BASUBS,RETIDO,SUBSTT,
                 CODEXT,VINCUL,MARCAS,EXPORT,TIPTRO,QTDREN,PLAFRE,UF_FRE,FILPGT,NATDEN,NATFOR,FILPRE,
                 IMPRIM,AUTINT,ORIVEN,AVISTA,CODNSU,CNT_RO,FUNRUR,OUTTAX,DOCNFP,ID_IVEN, FLGNFE, CHAVEA,
                 NUMDOC
             FROM TI_VEN
            WHERE STATUS = 0
              AND DATCRI BETWEEN TRUNC(pDATCRI)
                             AND ADD_DAY(TRUNC(pDATCRI),1)
            ORDER BY DATCRI
         ) TAB
   LIMIT 1;
BEGIN
   -- RFMP 80113
   -- Rhuan/MN - 103065 - Permite importar sem registrar acesso, exceto se a filial for de SC e no existir funcionalidade de ignorar assinatura
   IF (GetCoduidAtual() IS NULL) AND (ExisteFilialNaUF('SC')) AND (TemFun('IGNORA_ASS') = 'F')  THEN
      RAISE EXCEPTION 'PG-20001 Execuo de fora do sistema no permitida. Utilize a tela de Integrao do Totali Backoffice ou o Totali Import.';
   END IF;

   SELECT COALESCE(IMPORT,'T'), COALESCE(MANTEM,'T'), COALESCE(CNTIMP,0), COALESCE(DIALIM,0)
     INTO WK_IMPORT, WK_MANTEM, WK_CNTIMP, WK_DIALIM
     FROM TT_IED
   WHERE TABELA = 'VEN';

   IF WK_IMPORT = 'T' THEN
     WK_CNTIMP := WK_CNTIMP + 1;
     WK_NROERR := 0;
     WK_QTDIMP := 0;

     LOOP
       WK_COD_CODDEV := NULL;
       WK_COD_CODPRE := NULL;
       WK_AUX_FILUSU := NULL;
       WK_AUX_CODUSU := NULL;
       WK_AUX_CODVEN := NULL;
       WK_AUX_CODCLI := NULL;
       WK_AUX_FILCLI := NULL;
       WK_AUX_TIPTRA := NULL;
       WK_AUX_FILTRA := NULL;
       WK_AUX_CODTRA := NULL;
       WK_AUX_FILVEN := NULL;
       WK_AUX_FILFAT := NULL;
       WK_AUX_SEQFAT := NULL;
       WK_AUX_FILPGT := NULL;
       WK_AUX_CODPGT := NULL;
       WK_COD_CODNAT := NULL;
       WK_AUX_CODPRE := NULL;
       WK_COD_FILGUI := NULL;
       WK_COD_CODGUI := NULL;

       SELECT MIN(DATCRI)
         INTO WK_DATCRI
         FROM TI_VEN
        WHERE STATUS = 0;

       OPEN CR_VENDAS(WK_DATCRI);
       FETCH CR_VENDAS INTO WK_CODFIL,WK_FLGEST,WK_FLGTIP,WK_TIPNOT,WK_CODSER,WK_CODUSU,WK_CODVEN,
                            WK_CODCLI,WK_NUMECF,WK_NUMNOT,WK_ATU_EM,WK_DATHOR,WK_VLRLIQ,WK_VLRNOT,
                            WK_CODCTR,WK_COMSOB,WK_AUTENT,WK_CONSFI,WK_EMIDES,WK_FINANC,
                            WK_TRIBUT,WK_UFLOJA,WK_DATSAI,WK_DESCON,WK_ACRESC,WK_PESBRU,WK_PESLIQ,
                            WK_VLRFRE,WK_VLRSEG,WK_NROIMP,WK_CODPRE,WK_CODDEV,WK_OBSERV,WK_LANVEN,
                            WK_DATFIS,WK_NUMVOL,WK_VLRCOF,WK_MOTREJ,WK_DATIMP,WK_CODPGT,
                            WK_FILCOB,WK_FILENT,WK_FILFAT,WK_ECFFAT,WK_SERFAT,WK_NUMFAT,
                            WK_CODGUI,WK_CODTRA,WK_NUMCON,WK_PROPGT,WK_PERCOM,WK_PERENT,WK_SINAL,
                            WK_ENDCOB,WK_ENDENT,WK_ENDFAT,WK_CODFIN,WK_ESPECI,WK_PRAMED,WK_SIGNAT,
                            WK_BASUBS,WK_RETIDO,WK_SUBSTT,WK_CODEXT,WK_VINCUL,WK_MARCAS,WK_EXPORT,
                            WK_TIPTRO,WK_QTDREN,WK_PLAFRE,WK_UF_FRE,WK_FILPGT,WK_NATDEN,WK_NATFOR,WK_FILPRE,
                            WK_IMPRIM,WK_AUTINT,WK_ORIVEN,WK_AVISTA,WK_CODNSU,WK_CNT_RO,WK_FUNRUR,WK_OUTTAX,
                            WK_DOCNFP,WK_ID_IVEN,WK_FLGNFE,WK_CHAVEA,WK_NUMDOC;

       IF NOT FOUND THEN
          CLOSE CR_VENDAS;
          EXIT;
       END IF;

       
       IF WK_NUMREG = 0 THEN
          CLOSE CR_VENDAS;
          EXIT;
       END IF;
              

       WK_MOTREJ     := 'OK';

       IF WK_CODDEV IS NOT NULL THEN
          WK_COD_CODDEV := IMPORTA_TDS( 'TD_DEV', 'DEVATI', 'DESDEV', 'CODTAB', WK_CODDEV, NULL, NULL, NULL );
       END IF;
       IF WK_CODPRE IS NOT NULL THEN
          WK_COD_CODPRE := IMPORTA_TDS( 'TD_PRE', 'PREATI', 'DESPRE', 'CODTAB', WK_CODPRE, NULL, NULL, NULL );
       END IF;
       IF WK_CODCTR IS NOT NULL THEN
          SELECT CODLOJ INTO WK_CODLOJ FROM TT_IDF;
          WK_AUX_CODCTR := IMPORTA_TDS( 'TD_CTR', 'CTRATI', 'DESCTR', 'CODTAB', WK_CODCTR, NULL, NULL, WK_CODLOJ );
       END IF;

       --Verifica se existe CODPRE em TT_TPR. Caso negativo, insere uma linha.
         SELECT CODPRE
           INTO WK_AUX_CODPRE
           FROM TT_TPR T
          WHERE T.CODFIL = WK_FILPRE
            AND T.DESPRE = WK_CODPRE;

      
      SELECT 1 AS EXIST 
         INTO WK_FIL_EXISTE
         FROM TD_FIL DFIL 
        WHERE DFIL.CODFIL = WK_CODFIL;
      
      IF (WK_FIL_EXISTE IS NULL) THEN
         WK_FIL_EXISTE := 0;
      END IF;
      
      -- Valida se filial existe na base de dados
      IF (WK_MOTREJ = 'OK') AND (WK_FIL_EXISTE <> 1) THEN
         WK_MOTREJ := 'Filial no localizada: "' || COALESCE(WK_CODFIL, '') || '".';
       END IF;  

       IF WK_AUX_CODPRE IS NULL THEN
       --No encontrou -> insere um registro na tabela

         SELECT COALESCE(MAX(CODPRE),0) + 1
           INTO WK_COD_CODPRE
           FROM TT_TPR
          WHERE CODFIL = WK_FILPRE;
	 BEGIN
          INSERT INTO TT_TPR (CODFIL,CODPRE,VAREJO,ATU_EM,DATMAX,
                              DATMIN,SIGNAT,MULTIP,DESPRE)
                       VALUES(WK_CODFIL,WK_COD_CODPRE,0,AGORA(),TO_DATE('10/01/2029','DD/MM/YYYY'),
                              TO_DATE('10/01/2029','DD/MM/YYYY'),4,1,WK_CODPRE);
         EXCEPTION
          
          WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TABELA DE PREOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TABELA DE PREOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TABELA DE PREOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TABELA DE PREOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TABELA DE PREOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TABELA DE PREOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
	  WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO INSERIR TABELA DE PREOS: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
   	                      END;
          IF NOT WK_MOTREJ = 'OK' THEN
            WK_STATUS := 4;
	    WK_NROERR := WK_NROERR + 1;
          ELSE
            WK_STATUS := 3;
          END IF;
       END IF;

         SELECT U.FILUSU, U.CODUSU
         INTO WK_AUX_FILUSU, WK_AUX_CODUSU
         FROM TT_USU U
         WHERE U.CODEXT = WK_CODUSU;
       IF ((WK_AUX_FILUSU IS NULL) OR (WK_AUX_CODUSU IS NULL)) AND (WK_MOTREJ = 'OK') THEN
         WK_MOTREJ := 'Usurio no localizado com cdigo externo: "' || WK_CODUSU || '".';
       END IF;

         SELECT U.CODUSU, U.FILUSU
         INTO WK_AUX_CODVEN, WK_AUX_FILVEN
         FROM TT_USU U
         WHERE U.CODEXT = WK_CODVEN;
      IF ((WK_AUX_CODVEN IS NULL) OR (WK_AUX_FILVEN IS NULL)) AND (WK_MOTREJ = 'OK') THEN
         WK_MOTREJ := 'Vendedor no localizado com cdigo externo: "' || WK_CODVEN || '".';
      END IF;

               SELECT C.FILCLI, C.CODCLI
            INTO WK_AUX_FILCLI, WK_AUX_CODCLI
            FROM TT_CLI C
            WHERE	C.NUMDOC = GetDigit(TRIM(WK_NUMDOC));
   
      IF (WK_MOTREJ = 'OK') AND (WK_AUX_FILCLI IS NULL) THEN
               SELECT C.FILCLI, C.CODCLI
            INTO WK_AUX_FILCLI, WK_AUX_CODCLI
            FROM TT_CLI C
            WHERE	C.CODEXT = WK_CODCLI;
         END IF;
      
      IF (WK_MOTREJ = 'OK') AND (WK_AUX_FILCLI IS NULL) AND (WK_DOCNFP IS NOT NULL) THEN
               SELECT C.FILCLI, C.CODCLI
            INTO WK_AUX_FILCLI, WK_AUX_CODCLI
            FROM TT_CLI C
            WHERE	C.NUMDOC = WK_DOCNFP;
         END IF;

      IF ((WK_AUX_FILCLI IS NULL) OR (WK_AUX_CODCLI IS NULL)) AND (WK_MOTREJ = 'OK') THEN
         WK_MOTREJ := 'Participante no localizado com cdigo externo: "' || WK_CODCLI || '".'; 
      END IF;

         SELECT TR.FILPAR, TR.CODPAR, TR.TIPPAR
           INTO WK_AUX_FILTRA, WK_AUX_CODTRA, WK_AUX_TIPTRA
           FROM TT_CLI CL
         INNER JOIN TT_REL TR
                 ON TR.FILPAR = CL.FILCLI
                AND TR.CODPAR = CL.CODCLI
                AND TR.TIPPAR = 'T'
         WHERE CL.CODEXT = WK_CODTRA;
      IF ((WK_AUX_CODTRA IS NULL) OR (WK_AUX_FILTRA IS NULL)) AND (WK_MOTREJ = 'OK') AND (WK_CODTRA IS NOT NULL) THEN
         WK_MOTREJ := 'Participante no localizado com cdigo externo: "' || WK_CODTRA || '".';
      END IF;

         SELECT TV.CODFIL, TV.SEQUEN
           INTO WK_AUX_FILFAT, WK_AUX_SEQFAT
           FROM TT_VEN TV
          WHERE TV.CODFIL = WK_FILFAT
            AND TV.NUMECF = WK_ECFFAT
            AND TV.CODSER = WK_SERFAT
            AND TV.NUMNOT = WK_NUMFAT;

    W_EXISTE := 0;
      SELECT FLGEST, SEQUEN, 1 INTO WK_AUX_FLGEST, WK_AUX_SEQUEN, W_EXISTE
      FROM TT_VEN TT
        WHERE TT.CODFIL = WK_CODFIL
          AND TT.CODSER = RetornaCodserImportaVEN(WK_CODSER)
          AND TT.NUMECF = WK_NUMECF
          AND TT.NUMNOT = WK_NUMNOT;
   IF W_EXISTE IS NULL THEN
     W_EXISTE := 0;
   END IF;

   IF WK_NATDEN IS NULL AND WK_NATFOR IS NULL THEN
     WK_COD_CODNAT := 0;
   ELSE
           SELECT TN.CODTAB
        INTO WK_COD_CODNAT
        FROM TD_NAT TN
        WHERE TN.NATDEN = WK_NATDEN
          AND TN.NATFOR = WK_NATFOR;
         IF (WK_COD_CODNAT IS NULL) AND (WK_MOTREJ = 'OK') THEN
         WK_MOTREJ := 'Natureza no localizada para: Quando dentro do estado: "' || WK_NATDEN || '", Quando fora do estado: "' || WK_NATFOR || '".';
      END IF;
   END IF;

  IF (WK_UFLOJA IS NOT NULL) AND (WK_UFLOJA NOT IN ('F','T')) THEN
     SELECT UFLOJA
       INTO WK_UFFILIAL
       FROM TD_FIL
      WHERE CODFIL = WK_CODFIL;
     IF WK_UFFILIAL = WK_UFLOJA THEN
        WK_UFLOJA := 'T';
     ELSE
        WK_UFLOJA := 'F';
     END IF;
  END IF;


   SELECT TP.CODPGT, TP.FILPGT
     INTO WK_AUX_CODPGT,WK_AUX_FILPGT
     FROM TT_PLA TP
    WHERE TP.CODEXT = WK_CODPGT;

IF (WK_AUX_CODPGT IS NULL) AND (WK_AUX_FILPGT IS NULL) THEN
         SELECT TP.CODPGT, TP.FILPGT
        INTO WK_AUX_CODPGT,WK_AUX_FILPGT
        FROM TT_PLA TP
       WHERE TP.APEPGT = WK_CODPGT;
   END IF;

   IF ((WK_AUX_CODPGT IS NULL) OR (WK_AUX_FILPGT IS NULL)) AND (WK_MOTREJ = 'OK') THEN
      WK_MOTREJ := 'Plano no localizado com cdigo externo: "' || WK_CODPGT || '".';
   END IF;

   SELECT FILCLI, CODCLI
     INTO WK_COD_FILGUI,WK_COD_CODGUI
     FROM TT_CLI
    WHERE CODEXT = WK_CODGUI;
   IF ((WK_COD_FILGUI IS NULL) OR (WK_COD_CODGUI IS NULL)) AND (WK_MOTREJ = 'OK') AND (WK_CODGUI IS NOT NULL) THEN
      WK_MOTREJ := 'Participante no localizado com cdigo externo: "' || WK_CODGUI || '".';
   END IF;

WK_EXISTESERIE := 0;

   SELECT CASE WHEN RetornaCodserImportaVEN(WK_CODSER) <> '' THEN 1 ELSE 0 END
     INTO WK_EXISTESERIE
     FROM DUAL;

   IF (WK_EXISTESERIE = 0) and  (WK_MOTREJ = 'OK') THEN 
     WK_MOTREJ := 'Srie no cadastrada: "' || WK_CODSER || '".' ;
   END IF;

   IF (W_EXISTE = 0) AND (WK_MOTREJ = 'OK') THEN --registro novo

      BEGIN
         INSERT INTO TT_VEN(CODFIL,FLGEST,FLGTIP,TIPNOT,CODSER,CODPGT,CODUSU,CODVEN,
                            FILCLI,FILPGT,FILUSU,FILVEN,NUMECF,CODCLI,NUMNOT,ATU_EM,DATHOR,
                            VLRLIQ,VLRNOT,CODCTR,CODNAT,COMSOB,AUTENT,CONSFI,EMIDES,FINANC,
                            TRIBUT,UFLOJA,TIPTRA,FILCOB,FILENT,FILFAT,FILGUI,FILPRE,FILTRA,
                            CODGUI,CODTRA,NUMCON,SEQFAT,DATSAI,PROPGT,DESCON,NUMVOL,PERCOM,
                            PERENT,PESBRU,PESLIQ,SINAL,VLRFRE,VLRSEG,NROIMP,ENDCOB,ENDENT,
                            ENDFAT,CODFIN,CODPRE,ESPECI,PRAMED,SIGNAT,BASUBS,RETIDO,SUBSTT,
                            CODEXT,LANVEN,VINCUL,MARCAS,OBSERV,EXPORT,TIPTRO,CODDEV,VLRCOF,
                            QTDREN,PLAFRE,UF_FRE,DUMMY,IMPRIM,AUTINT,ORIVEN,AVISTA,CODNSU,CNT_RO,
                            FUNRUR,OUTTAX,DOCNFP,FLGNFE,CHAVEA, SEREXT)
                     VALUES(WK_CODFIL,WK_FLGEST,WK_FLGTIP,WK_TIPNOT, RetornaCodserImportaVEN(WK_CODSER),
                            COALESCE(WK_AUX_CODPGT,'  1'),WK_AUX_CODUSU,WK_AUX_CODVEN,
                            COALESCE(WK_AUX_FILCLI,'0'),COALESCE(WK_AUX_FILPGT,'001'),WK_AUX_FILUSU,COALESCE(WK_AUX_FILVEN,'0'),WK_NUMECF,WK_AUX_CODCLI,WK_NUMNOT,WK_ATU_EM,WK_DATHOR,
                            WK_VLRLIQ,WK_VLRNOT,WK_AUX_CODCTR,WK_COD_CODNAT,WK_COMSOB,WK_AUTENT,WK_CONSFI,WK_EMIDES,WK_FINANC,
                            WK_TRIBUT,WK_UFLOJA,WK_AUX_TIPTRA,WK_FILCOB,WK_FILENT,WK_AUX_FILFAT,WK_COD_FILGUI,COALESCE(WK_FILPRE,WK_CODFIL),WK_AUX_FILTRA,
                            WK_COD_CODGUI,WK_AUX_CODTRA,WK_NUMCON,WK_AUX_SEQFAT,WK_DATSAI,WK_PROPGT,CASE WHEN COALESCE(WK_DESCON,0) > 0 THEN (WK_DESCON * -1) ELSE WK_ACRESC END ,WK_NUMVOL,WK_PERCOM,
                            WK_PERENT,WK_PESBRU,WK_PESLIQ,WK_SINAL,WK_VLRFRE,WK_VLRSEG,WK_NROIMP,WK_ENDCOB,WK_ENDENT,
                            WK_ENDFAT,WK_CODFIN,COALESCE(WK_AUX_CODPRE,WK_COD_CODPRE),WK_ESPECI,WK_PRAMED,WK_SIGNAT,WK_BASUBS,WK_RETIDO,WK_SUBSTT,
                            WK_CODEXT,WK_LANVEN,WK_VINCUL,WK_MARCAS,WK_OBSERV,COALESCE(WK_EXPORT,'F'),WK_TIPTRO,COALESCE(WK_COD_CODDEV,0),WK_VLRCOF,
                            WK_QTDREN,WK_PLAFRE,WK_UF_FRE,'I',COALESCE(WK_IMPRIM,'T'),WK_AUTINT,WK_ORIVEN,COALESCE(WK_AVISTA,'T'),WK_CODNSU,WK_CNT_RO,
                            WK_FUNRUR,WK_OUTTAX,WK_DOCNFP,WK_FLGNFE,WK_CHAVEA,
                            -- MN - Incluso da coluna SEREXT
                             (SELECT RetornaCodserImportaVEN(WK_CODSER)
                                FROM DUAL
                               WHERE 1 = CASE WHEN LENGTH(TRIM(WK_CODSER)) = 3 THEN 1 ELSE 0 END -- MN - S busca quando o campo tem 3 posies
                              )
                             );
                           --WK_DATFIS -> VERSO NOVA
        EXCEPTION
          
          WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PEDIDO DE VENDA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PEDIDO DE VENDA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PEDIDO DE VENDA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PEDIDO DE VENDA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PEDIDO DE VENDA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PEDIDO DE VENDA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR PEDIDO DE VENDA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
   	                    END;
      -- Registro de Venda est Aberto ou Quitado e est sendo enviado o cancelamento do registro
      ELSIF (WK_MOTREJ = 'OK') AND (WK_FLGEST = 'C') AND (WK_AUX_FLGEST <> 'C') THEN
         BEGIN
            UPDATE TT_VEN SET FLGEST = WK_FLGEST,
                              ATU_EM = COALESCE(WK_ATU_EM,AGORA()),
                              FLGNFE = WK_FLGNFE
             WHERE CODFIL = WK_CODFIL
               AND SEQUEN = WK_AUX_SEQUEN;
        EXCEPTION
          
          WHEN restrict_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO PEDIDO DE VENDA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN not_null_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO PEDIDO DE VENDA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN foreign_key_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO PEDIDO DE VENDA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN unique_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO PEDIDO DE VENDA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN check_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO PEDIDO DE VENDA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN integrity_constraint_violation THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO PEDIDO DE VENDA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
          WHEN plpgsql_error THEN IF WK_MOTREJ = 'OK' THEN WK_MOTREJ := SUBSTR('ERRO AO IMPORTAR ALTERACAO PEDIDO DE VENDA: '||SQLERRM,1,255); ELSE WK_MOTREJ := WK_MOTREJ; END IF;
                            END;
      END IF; -- MN - Fim if w_existe = 0
       IF NOT WK_MOTREJ = 'OK' THEN
          WK_STATUS := 4;
          WK_NROERR := WK_NROERR + 1;
       ELSE
         WK_STATUS := 3;
       END IF;

       -- Marca registro como Importado
       UPDATE TI_VEN SET STATUS = WK_STATUS, DATIMP = AGORA(), MOTREJ = WK_MOTREJ
        WHERE ID_IVEN = WK_ID_IVEN
          AND DATIMP IS NULL;

      -- Marca Parcelas para serem Importadas caso o Erro seja devido a Venda Inexistente e processo atual importar a venda
      IF (WK_MOTREJ = 'OK') THEN
         UPDATE TI_REC SET STATUS='0', DATIMP=NULL, MOTREJ=NULL
          WHERE CODFIL = WK_CODFIL
            AND NUMECF = WK_NUMECF
            AND CODSER = WK_CODSER
            AND NUMNOT = WK_NUMNOT
            AND STATUS = '2'
            AND LOWER( MOTREJ ) LIKE '%venda deve ser importada%';
      END IF;

  
        WK_NUMREG := WK_NUMREG - 1;
          WK_QTDIMP := WK_QTDIMP + 1;
        CLOSE CR_VENDAS;
     END LOOP;

     IF WK_NROERR <> 0 THEN
        SELECT MAI_FR, MAI_TO
          INTO WK_MAI_FR, WK_MAI_TO
          FROM TT_CFG;
        IF (ISNOTNULL(WK_MAI_FR)='T') AND (ISNOTNULL(WK_MAI_TO)='T') AND (INSTR(WK_MAI_FR, UPPER('@sua_empresa.com')) = 0) AND (INSTR(WK_MAI_TO, UPPER('@sua_empresa.com')) = 0) THEN
           INSERT INTO TT_MAI (CODFIL,EXCLUI,DATSOL,ASSUNT,MAI_FR,MAI_TO,
                               TEXTOS,TIPMSG)
                       VALUES ('001','F',AGORA(),'IMPORTAO DE PEDIDOS DE VENDA',WK_MAI_FR, WK_MAI_TO,
                               'Problema na importao de '||wk_nroerr||' pedidos de venda. Verifique!','T');
        END IF;
     END IF;

     UPDATE TI_VEN SET STATUS = CASE WHEN WK_STATUS = 3
                                     THEN 1
                                     ELSE 2
                                 END
      WHERE STATUS IN (3,4);

     IF WK_MANTEM = 'F' THEN
        IF WK_DIALIM > 0 THEN
           DELETE FROM TI_VEN
            WHERE DATIMP <= ADD_DAY(AGORA(),WK_DIALIM * -1)
              AND STATUS = 1;
        ELSE
           DELETE FROM TI_VEN
            WHERE STATUS = 1;
        END IF;
     END IF;

     UPDATE TT_IED SET ULTIMP = AGORA(), QTDIMP = WK_QTDIMP, CNTIMP = WK_CNTIMP, TOTIMP = COALESCE(TOTIMP,0) + WK_QTDIMP WHERE TABELA = 'VEN';
   ELSE RAISE EXCEPTION 'PG-20001 IMPORTAO DE PEDIDOS DE VENDA NO PERMITIDA! VERIFIQUE TABELA DE CONTROLE!';
   END IF;
   
   SELECT COUNT(*) INTO WK_RESTO FROM TI_VEN WHERE STATUS = 0;
   IF WK_RESTO > 0 THEN
     RETURN 'EXISTEM '||WK_RESTO||' VENDAS NO IMPORTADAS';
   ELSE
     RETURN 'OK';
   END IF;
   
END;
$$ language 'plpgsql';






/*-- SEQ 1662 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RecalcMov (TR_MOV.CODFIL%TYPE,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,TR_MOV.DATMOV%TYPE,TR_MOV.CODMUL%TYPE) CASCADE;

/*-- SEQ 1663 --*/
CREATE OR REPLACE FUNCTION RecalcMov (TR_MOV.CODFIL%TYPE,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,TR_MOV.DATMOV%TYPE,TR_MOV.CODMUL%TYPE)
RETURNS VARCHAR AS $$
DECLARE
Filial ALIAS FOR $1 ;
ProFil ALIAS FOR $2 ;
ProCod ALIAS FOR $3 ;
Cor ALIAS FOR $4 ;
Tamanho ALIAS FOR $5 ;
Quando ALIAS FOR $6 ;
Subestoque ALIAS FOR $7 ;
-- Objetivo
-- 1) Recalcular a movimentacao diaria de um produto a partir de uma data

  TotQtd   TR_MOV.SALANT%TYPE;  
  Primeiro boolean default true;
  
  Movto CURSOR FOR
  select *
  from (select *
       from TR_MOV
       where (DATMOV,CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,CODMUL)
          in (select MAX(DATMOV) AS DATMOV,CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,CODMUL
              from TR_MOV
              where CODFIL = Filial
                and FILMAT = ProFil
                and CODMAT = ProCod
                and CODCOR = Cor
                and CODTAM = Tamanho
                and CODMUL = Subestoque
                and DATMOV < Trunc(Quando)
              group by CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,CODMUL)
       UNION ALL
       select * from TR_MOV
        where CODFIL = Filial
          and FILMAT = ProFil
          and CODMAT = ProCod
          and CODCOR = Cor
          and CODTAM = Tamanho
          and CODMUL = Subestoque
          and DATMOV >= Trunc(Quando)) tab
  order by DATMOV;
  temp record;

-- Principal
begin
  OPEN MovTo;
  LOOP
    FETCH MovTo into temp;
    EXIT WHEN NOT FOUND;
    if Primeiro then
      TotQtd := COALESCE(temp.SALANT,0);
    else
      update TR_MOV set SALANT = TOTQTD
       where CODFIL = temp.CODFIL
         and FILMAT = temp.FILMAT
         and CODMAT = temp.CODMAT
         and CODCOR = temp.CODCOR
         and CODTAM = temp.CODTAM
         and CODMUL = temp.CODMUL
         and DATMOV = Trunc(temp.DATMOV);
    end if;

    -- Acumula para o proximo
    TotQtd := TotQtd - COALESCE(temp.QTDVEN,0) 
                     - COALESCE(temp.VENFIS,0) 
                     + COALESCE(temp.QTDCOM,0) 
                     + COALESCE(temp.QTDOUT,0);
    Primeiro := false;
  END LOOP;
  CLOSE MovTo; 

  RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 1664 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RecalcMov (TR_MOV.CODFIL%TYPE,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,TR_MOV.DATMOV%TYPE) CASCADE;

/*-- SEQ 1665 --*/
CREATE OR REPLACE FUNCTION RecalcMov (TR_MOV.CODFIL%TYPE,
                               TR_MOV.FILMAT%TYPE,
                               TR_MOV.CODMAT%TYPE,
                               TR_MOV.CODCOR%TYPE,
                               TR_MOV.CODTAM%TYPE,
                               TR_MOV.DATMOV%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN RecalcMov($1,$2,$3,$4,$5,$6,0);
END;
$$ language 'plpgsql';



/*-- SEQ 1666 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_AcrescentaIndicador (TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE) CASCADE;

/*-- SEQ 1667 --*/
CREATE OR REPLACE FUNCTION TGR_AcrescentaIndicador (TT_USU.FILUSU%TYPE,TT_USU.CODUSU%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFilUsu ALIAS FOR $1 ;
pCodusu ALIAS FOR $2 ;
-- Acrescenta ao cliente o status de indicador
  Registro Integer;
  Filial TT_CLI.FILCLI%TYPE;
  Codigo TT_CLI.CODCLI%TYPE;

  Parceiro CURSOR(aFilUsu TT_USU.FILUSU%TYPE,
           aCodUsu TT_USU.CODUSU%TYPE) IS
     select CLI.FILCLI, CLI.CODCLI
     from TT_CLI CLI, TT_USU USU
     where USU.FILCLI = CLI.FILCLI
       and USU.CODCLI = CLI.CODCLI
       and USU.FILUSU = aFilUsu
       and USU.CODUSU = aCodUsu
       and USU.FILCLI IS NOT NULL;

BEGIN
  -- Procura o Parceiro
  OPEN Parceiro (pFilUsu, pCodUsu);
  FETCH Parceiro INTO Filial, Codigo;
  IF NOT (NOT FOUND) THEN

    -- Checa se nao existe mesmo?
    select count(*) into Registro
    from TT_REL
    where FILPAR = Filial
      and CODPAR = Codigo
      and TIPPAR = 'I';

    -- Atualiza
    IF Registro = 0 then
       insert into TT_REL (FILPAR, CODPAR, TIPPAR)
         values (Filial, Codigo, 'I');
    END IF;

  END IF;
  CLOSE Parceiro;
  RETURN NULL;
END;
$$ language 'plpgsql';






/*-- SEQ 1668 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_Atualiza_Custos (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_GRA.FILCOM%TYPE,TT_GRA.DATCOM%TYPE,TT_GRA.CUSREP%TYPE,TT_GRA.PRECOM%TYPE,TT_GRA.CUSFRE%TYPE,TT_GRA.DESICO%TYPE) CASCADE;

/*-- SEQ 1669 --*/
CREATE OR REPLACE FUNCTION TGR_Atualiza_Custos (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_GRA.FILCOM%TYPE,TT_GRA.DATCOM%TYPE,TT_GRA.CUSREP%TYPE,TT_GRA.PRECOM%TYPE,TT_GRA.CUSFRE%TYPE,TT_GRA.DESICO%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFilmat ALIAS FOR $1 ;
pCodmat ALIAS FOR $2 ;
pCodcor ALIAS FOR $3 ;
pCodtam ALIAS FOR $4 ;
pFilcom ALIAS FOR $5 ;
pDatcom ALIAS FOR $6 ;
pCusrep ALIAS FOR $7 ;
pPreCom ALIAS FOR $8 ;
pCusFre ALIAS FOR $9 ;
pDESICO ALIAS FOR $10 ;
-- Atualizar custos na TR_MOV
  wk_Onde TT_IDF.CODDEP%TYPE;

BEGIN
  SELECT CODDEP into wk_Onde FROM TT_IDF;
  UPDATE TR_MOV SET --CUSREP = COALESCE(pCUSREP,CUSREP),
                    --PRECOM = COALESCE(pPRECOM,PRECOM),
                    --CUSFRE = COALESCE(pCUSFRE,CUSFRE),
                    DESCOM = COALESCE(pDESICO,DESCOM)
  WHERE CODFIL = COALESCE(pFILCOM,wk_Onde)
    AND FILMAT = pFILMAT
    AND CODMAT = pCODMAT
    AND CODCOR = pCODCOR
    AND CODTAM = pCODTAM
    AND DATMOV BETWEEN TRUNC(pDATCOM) AND (TRUNC(pDATCOM) + ('23:59:59')::TIME );
  return null;
END;
$$ language 'plpgsql';




/*-- SEQ 1670 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_ICO_Atualiza_Movimento (TT_LAN.QTDMOV%TYPE,TT_LAN.VLRMOV%TYPE,TT_ICO.CODFIL%TYPE,TT_ICO.SEQUEN%TYPE,TT_ICO.NUMITE%TYPE,TT_ICO.FILMAT%TYPE,TT_ICO.CODMAT%TYPE,TT_ICO.CODCOR%TYPE,TT_ICO.CODTAM%TYPE,TT_ICO.CODMUL%TYPE,TT_ICO.COM_DATOPE%TYPE,TT_ICO.COM_ATUCUS%TYPE,TT_ICO.CUSFRE%TYPE) CASCADE;

/*-- SEQ 1671 --*/
CREATE OR REPLACE FUNCTION TGR_ICO_Atualiza_Movimento (TT_LAN.QTDMOV%TYPE,TT_LAN.VLRMOV%TYPE,TT_ICO.CODFIL%TYPE,TT_ICO.SEQUEN%TYPE,TT_ICO.NUMITE%TYPE,TT_ICO.FILMAT%TYPE,TT_ICO.CODMAT%TYPE,TT_ICO.CODCOR%TYPE,TT_ICO.CODTAM%TYPE,TT_ICO.CODMUL%TYPE,TT_ICO.COM_DATOPE%TYPE,TT_ICO.COM_ATUCUS%TYPE,TT_ICO.CUSFRE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
quantidade ALIAS FOR $1 ;
valor ALIAS FOR $2 ;
pCODFIL ALIAS FOR $3 ;
pSEQUEN ALIAS FOR $4 ;
pNUMITE ALIAS FOR $5 ;
pFILMAT ALIAS FOR $6 ;
PCODMAT ALIAS FOR $7 ;
PCODCOR ALIAS FOR $8 ;
PCODTAM ALIAS FOR $9 ;
pCODMUL ALIAS FOR $10 ;
PDATA ALIAS FOR $11 ;
pATUCUS ALIAS FOR $12 ;
pCUSFRE ALIAS FOR $13 ;
  -- Atualiza TR_MOV
  -- Nota: Como so e permitido mudar o valor da coluna SITMOV, usamos sempre
  --       NEW.<coluna chave> para o SELECT, INSERT e UPDATE abaixo

  linha     Numeric;
  data      Timestamp;
  wk_nada   VARCHAR(1);
  cFILICO TT_ICO.CODFIL%TYPE;
  cSEQICO TT_ICO.SEQUEN%TYPE;
  cNUMICO TT_ICO.NUMITE%TYPE;
  cFILFRE TT_ICO.CODFIL%TYPE;
  cSEQFRE TT_ICO.SEQUEN%TYPE;
  cNUMFRE TT_ICO.NUMITE%TYPE;
  
BEGIN
  -- Nota: a) Em TT_IVE a quantidade e sempre negativa mas e gravada sem sinal
  --       b) Em TT_ICO a quantidade e sempre positiva
  --       c) Em TT_LAN a quantidade tanto e negativa quanto positiva

  -- Data para comparacao
  data := Trunc(PData);

  -- Verifica se ja existe uma movimentacao
  SELECT COUNT(*) INTO linha
  FROM TR_MOV
  WHERE CODFIL = pCODFIL
    AND FILMAT = pFILMAT
    AND CODMAT = pCODMAT
    AND CODCOR = pCODCOR
    AND CODTAM = pCODTAM
    AND CODMUL = pCODMUL
    AND DATMOV = data;

  IF linha > 0 THEN
    UPDATE TR_MOV SET QTDCOM = (COALESCE(QTDCOM,0) + quantidade),
                      VLRCOM = (COALESCE(VLRCOM,0) + valor)
    WHERE CODFIL = pCODFIL
      AND FILMAT = pFILMAT
      AND CODMAT = pCODMAT
      AND CODCOR = pCODCOR
      AND CODTAM = pCODTAM
      AND CODMUL = pCODMUL
      AND DATMOV = data;
    IF pATUCUS = 'T' THEN 
      UPDATE TR_MOV 
         SET FILICO = pCODFIL,
             SEQICO = pSEQUEN,
             NUMICO = pNUMITE
       WHERE CODFIL = pCODFIL
         AND FILMAT = pFILMAT
         AND CODMAT = pCODMAT
         AND CODCOR = pCODCOR
         AND CODTAM = pCODTAM
         AND DATMOV = data;    
    END IF;
    IF pCUSFRE > 0 THEN 
      UPDATE TR_MOV 
         SET FILFRE = pCODFIL,
             SEQFRE = pSEQUEN,
             NUMFRE = pNUMITE
       WHERE CODFIL = pCODFIL
         AND FILMAT = pFILMAT
         AND CODMAT = pCODMAT
         AND CODCOR = pCODCOR
         AND CODTAM = pCODTAM
         AND DATMOV = data;    
    END IF;    
  ELSE
    IF pATUCUS = 'T' THEN 
       cFILICO := pCODFIL;
       cSEQICO := pSEQUEN;
       cNUMICO := pNUMITE; 
    ELSE
       cFILICO := NULL;
       cSEQICO := NULL;
       cNUMICO := NULL;
    END IF;
    IF pCUSFRE > 0 THEN 
       cFILFRE := pCODFIL;
       cSEQFRE := pSEQUEN;
       cNUMFRE := pNUMITE; 
    ELSE
       cFILFRE := NULL;
       cSEQFRE := NULL;
       cNUMFRE := NULL;
    END IF;    
    INSERT INTO TR_MOV (CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,CODMUL,DATMOV,QTDCOM,VLRCOM,FILICO,SEQICO,NUMICO,FILFRE,SEQFRE,NUMFRE)
    VALUES (pCODFIL,pFILMAT,pCODMAT,pCODCOR,pCODTAM,pCODMUL,data,quantidade,valor,cFILICO,cSEQICO,cNUMICO,cFILFRE,cSEQFRE,cNUMFRE);   
  END IF;

  wk_nada := RecalcCus(pCODFIL,pCODMUL,pFILMAT,pCODMAT,pCODCOR,pCODTAM,data,pATUCUS);
  wk_nada := RecalcFre(pCODFIL,pCODMUL,pFILMAT,pCODMAT,pCODCOR,pCODTAM,data,pCUSFRE);    
  wk_nada := RecalcMov(pCODFIL,pFILMAT,pCODMAT,pCODCOR,pCODTAM,data,pCODMUL);
  return null;
END;
$$ language 'plpgsql';




/*-- SEQ 1672 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_ICO_Atualiza_Saldo (TT_ICO.QTDMOV%TYPE,TT_ICO.CODFIL%tYPE,TT_ICO.FILMAT%tYPE,TT_ICO.CODMAT%tYPE,TT_ICO.CODCOR%tYPE,TT_ICO.CODTAM%tYPE,TD_MUL.CODTAB%tYPE) CASCADE;

/*-- SEQ 1673 --*/
CREATE OR REPLACE FUNCTION TGR_ICO_Atualiza_Saldo (TT_ICO.QTDMOV%TYPE,TT_ICO.CODFIL%tYPE,TT_ICO.FILMAT%tYPE,TT_ICO.CODMAT%tYPE,TT_ICO.CODCOR%tYPE,TT_ICO.CODTAM%tYPE,TD_MUL.CODTAB%tYPE)
RETURNS VARCHAR AS $$
DECLARE
quantidade ALIAS FOR $1 ;
pCODFIL ALIAS FOR $2 ;
pFILMAT ALIAS FOR $3 ;
PCODMAT ALIAS FOR $4 ;
PCODCOR ALIAS FOR $5 ;
PCODTAM ALIAS FOR $6 ;
PCODMUL ALIAS FOR $7 ;
  --Objetivos
  -- Atualiza TT_SAL
  -- Nota: a) O valor diferente de null para TT_SAL.DUMMY e para impedir
  --          que a "trigger" TGSAL realize um recalculo
  --       b) Como so e permitido mudar o valor da coluna SITMOV, usamos sempre
  --          NEW.<coluna chave> para o SELECT, INSERT e UPDATE abaixo
  linha Numeric;
  vComplemento  VARCHAR(254);   
  vQTDEST TT_SAL.QTDEST%TYPE;  
BEGIN
  -- Nota: a) Em TT_IVE a quantidade e sempre negativa mas e gravada sem sinal
  --       b) Em TT_ICO a quantidade e sempre positiva
  --       c) Em TT_LAN a quantidade tanto e negativa quanto positiva

  -- Verifica se ja existe um saldo
  vComplemento  := constante('complemento');
  
  SELECT COUNT(*) INTO linha
  FROM TT_SAL
  WHERE CODFIL = pCODFIL
    AND FILMAT = pFILMAT
    AND CODMAT = pCODMAT
    AND CODCOR = pCODCOR
    AND CODTAM = pCODTAM
    AND CODMUL = pCODMUL;

  IF linha > 0 THEN
     vQTDEST := 0;
     
     SELECT COALESCE(QTDEST,0)
       INTO vQTDEST
       FROM TT_SAL
      WHERE CODFIL = pCODFIL
        AND FILMAT = pFILMAT
       AND CODMAT = pCODMAT
        AND CODCOR = pCODCOR
        AND CODTAM = pCODTAM
        AND CODMUL = pCODMUL;
      
     IF (vQTDEST + quantidade) > 99999999 THEN 
         RAISE EXCEPTION 'PG-20056 Valor mximo de quantidade em estoque passou do limite (R$99.999.99). %' , vComplemento;
     ELSE
       UPDATE TT_SAL SET DUMMY = Constante('vem_de_TGICO'), QTDEST = (COALESCE(QTDEST,0) + quantidade)
        WHERE CODFIL = pCODFIL
          AND FILMAT = pFILMAT
          AND CODMAT = pCODMAT
          AND CODCOR = pCODCOR
          AND CODTAM = pCODTAM
          AND CODMUL = pCODMUL;
     END IF;
  ELSE
    INSERT INTO TT_SAL (DUMMY,CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,CODMUL,QTDEST)
    VALUES (Constante('vem_de_TGICO'),pCODFIL,pFILMAT,pCODMAT,pCODCOR,pCODTAM,pCODMUL,quantidade);
  END IF;  
 
  return null;
END;
$$ language 'plpgsql';





/*-- SEQ 1674 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_ICO_Atualiza_Saldo_Lote (TT_ICO.QTDMOV%TYPE,TT_ICO.CODFIL%TYPE,TD_MUL.CODTAB%TYPE,TT_LOT.CODFIL%TYPE,TT_LOT.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1675 --*/
CREATE OR REPLACE FUNCTION TGR_ICO_Atualiza_Saldo_Lote (TT_ICO.QTDMOV%TYPE,TT_ICO.CODFIL%TYPE,TD_MUL.CODTAB%TYPE,TT_LOT.CODFIL%TYPE,TT_LOT.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pQuantidade ALIAS FOR $1 ;
pCODFIL ALIAS FOR $2 ;
PCODMUL ALIAS FOR $3 ;
PFILLOT ALIAS FOR $4 ;
PSEQLOT ALIAS FOR $5 ;

-- Objetivos
-- Atualiza o saldo do lote na TT_SLT : Compra.

-- Declarao de variveis e cursores
   nRegSaldo                     Numeric;

-- Incio da funo
BEGIN
   /* Verifica se ja possui saldo de lote */
   SELECT COUNT(*) INTO nRegSaldo
     FROM TT_SLT
    WHERE CODFIL = pCODFIL
      AND CODMUL = pCODMUL
      AND FILLOT = pFILLOT
      AND SEQLOT = pSEQLOT;

   IF nRegSaldo > 0 THEN
      UPDATE TT_SLT
         SET QTDEST = (COALESCE(QTDEST,0) + pQuantidade)
       WHERE CODFIL = pCODFIL
         AND CODMUL = pCODMUL
         AND FILLOT = pFILLOT
         AND SEQLOT = pSEQLOT;
   ELSE
      /* Se nao houver saldo insere um registro */
      INSERT INTO TT_SLT
      (CODFIL,CODMUL,FILLOT,SEQLOT,QTDEST)
      VALUES
      (pCODFIL,pCODMUL,pFILLOT,pSEQLOT,pQuantidade);
   END IF;

   RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1676 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_IncluiLimite (TT_CCC.FILCLI%TYPE,TT_CCC.CODCLI%TYPE,TT_CCC.VLRLAN%TYPE,TT_CCC.TIPCCC%TYPE) CASCADE;

/*-- SEQ 1677 --*/
CREATE OR REPLACE FUNCTION TGR_IncluiLimite (TT_CCC.FILCLI%TYPE,TT_CCC.CODCLI%TYPE,TT_CCC.VLRLAN%TYPE,TT_CCC.TIPCCC%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_Filial ALIAS FOR $1 ;
p_Codigo ALIAS FOR $2 ;
p_Valor ALIAS FOR $3 ;
p_Tipo ALIAS FOR $4 ;

-- Declarao de variveis e cursores
   wk_CC                         TT_CCC.TIPCCC%TYPE;
   wk_Placa                      TT_VXP.PLACAS%TYPE;
   wk_PlanoFilial                TT_LIM.FILPGT%TYPE;
   wk_PlanoCodigo                TT_LIM.CODPGT%TYPE;
   wk_EnderecoFilial             TT_LIM.FILCOB%TYPE;
   wk_EnderecoCodigo             TT_LIM.ENDCOB%TYPE;
   WK_CONTA                      Numeric;

-- Incio da funo
BEGIN
   -- Obtem o plano
   SELECT COALESCE(CLI.FILPLA,CFG.VC_FILPGT),
          COALESCE(CLI.CODPLA,CFG.VC_CODPGT)
     INTO wk_PlanoFilial,wk_PlanoCodigo
     FROM TT_CLI CLI, TT_CFG CFG
    WHERE CLI.FILCLI = p_Filial
      AND CLI.CODCLI = p_Codigo;

   -- Obtem o endereco
   wk_EnderecoFilial := p_Filial;
   wk_EnderecoCodigo := 1;

   SELECT COUNT(*) INTO WK_CONTA
     FROM TT_END
    WHERE FILCLI = p_Filial
      AND CODCLI = p_Codigo;

   IF WK_CONTA > 0 THEN

     SELECT CODFIL, NUMEND
       INTO wk_EnderecoFilial,wk_EnderecoCodigo
       FROM TT_END
      WHERE FILCLI = p_Filial
        AND CODCLI = p_Codigo
      LIMIT 1;
   ELSE
     -- Cria um endereco padrao
     SELECT MAX(COALESCE(COB.NUMEND,0)) + 1 AS NUMEND
       INTO WK_ENDERECOCODIGO
       FROM TT_CLI CLI LEFT OUTER JOIN TT_END COB ON CLI.FILCLI = COB.FILCLI AND CLI.CODCLI = COB.CODCLI
      WHERE CLI.FILCLI = P_FILIAL
        AND CLI.CODCLI = P_CODIGO;

      INSERT INTO TT_END
        (FILCLI,CODCLI,CODFIL,NUMEND,ENDCOB,ENDCOR)
      VALUES
        (p_Filial,p_Codigo,wk_EnderecoFilial,wk_EnderecoCodigo,'T','T');
   END IF;

   -- Inclusao
   INSERT INTO TT_LIM (FILCLI,CODCLI,TIPCCC,VSALDO,FILPGT,CODPGT,FILCOB,ENDCOB,CODCOB,TIPCOB,CARENC,DESCON)
               VALUES (p_Filial,p_Codigo,p_Tipo,p_Valor,wk_PlanoFilial,wk_PlanoCodigo,wk_EnderecoFilial,wk_EnderecoCodigo,0,'P',0,0);

   RETURN null;
END;
$$ language 'plpgsql';




/*-- SEQ 1678 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_IOR_Atualiza_Reserva (TT_IOR.QTDITE%TYPE,TT_IOR.CODFIL%TYPE,TT_IOR.FILMAT%TYPE,TT_IOR.CODMAT%TYPE,TT_IOR.CODCOR%TYPE,TT_IOR.CODTAM%TYPE,TT_IOR.CODMUL%TYPE) CASCADE;

/*-- SEQ 1679 --*/
CREATE OR REPLACE FUNCTION TGR_IOR_Atualiza_Reserva (TT_IOR.QTDITE%TYPE,TT_IOR.CODFIL%TYPE,TT_IOR.FILMAT%TYPE,TT_IOR.CODMAT%TYPE,TT_IOR.CODCOR%TYPE,TT_IOR.CODTAM%TYPE,TT_IOR.CODMUL%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_qtdite ALIAS FOR $1 ;
p_codfil ALIAS FOR $2 ;
p_filmat ALIAS FOR $3 ;
p_codmat ALIAS FOR $4 ;
p_codcor ALIAS FOR $5 ;
p_codtam ALIAS FOR $6 ;
p_codmul ALIAS FOR $7 ;
-- Atualiza a reserva em TT_SAL
-- Nota: o valor diferente de null para TT_SAL.DUMMY e para impedir
--       que a "trigger" TGSAL realize um recalculo

  cr_Kit CURSOR FOR
    select filite,codite,corite,tamite,qtdite
      from tt_kit
     where filmat=p_filmat
      and codmat=p_codmat
      and codcor=p_codcor
      and codtam=p_codtam;
      
  cFILMAT TT_GRA.FILMAT%type;
  cCODMAT TT_GRA.CODMAT%type;
  cCODCOR TT_GRA.CODCOR%type;
  cCODTAM TT_GRA.CODTAM%type; 
  BPRODKIT BOOLEAN;
  bNOTFOUND BOOLEAN; 
  nQTDKIT Numeric;
      
BEGIN
  -- Define o valor
  -- Nota: a) Em TT_IVE a quantidade e sempre negativa mas e gravada sem sinal
  --       b) Em TT_ICO a quantidade e sempre positiva
  --       c) Em TT_LAN a quantidade tanto e negativa quanto positiva
  --       d) Em TT_IOR a quantidade e sempre positiva
  
  bPRODKIT:=False;  
  
  OPEN cr_Kit;
  
  LOOP    
  
     FETCH cr_Kit INTO cFILMAT,cCODMAT,cCODCOR,cCODTAM,nQTDKIT;   
     
     bNOTFOUND:=NOT FOUND;
     
     IF bNOTFOUND AND (NOT bPRODKIT) THEN
        cFILMAT:=p_FILMAT;
        cCODMAT:=p_CODMAT;
        cCODCOR:=p_CODCOR;
        cCODTAM:=p_CODTAM;
        nQTDKIT:=1;
     END IF;
     
     IF (NOT bNOTFOUND) OR (NOT bPRODKIT) THEN
     
         IF TGR_IVE_Existe_Lancamento(p_codfil,
                                      cfilmat,
                                      ccodmat,
                                      ccodcor,
                                      ccodtam,
                                      p_codmul) THEN
           UPDATE TT_SAL 
              SET DUMMY = Constante('vem_de_TGIVE'), 
                  RESERV = (COALESCE(RESERV,0) + (p_qtdite*nQTDKIT))
           WHERE CODFIL = p_CODFIL
             AND FILMAT = cFILMAT
             AND CODMAT = cCODMAT
             AND CODCOR = cCODCOR
             AND CODTAM = cCODTAM
             AND CODMUL = p_CODMUL;
         ELSE
           INSERT INTO TT_SAL (DUMMY,CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,CODMUL,RESERV)
           VALUES (Constante('vem_de_TGIVE'),p_CODFIL,cFILMAT,cCODMAT,cCODCOR,cCODTAM,p_CODMUL,(P_QTDITE*nQTDKIT));
         END IF;
         
     END IF;
     
     EXIT WHEN bNOTFOUND;
     
     bPRODKIT:=True;
     
  END LOOP;
  CLOSE cr_Kit;  
  return null;
END;
$$ language 'plpgsql';




/*-- SEQ 1680 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_IOR_Atualiza_Reserva_Lote (TT_IOR.QTDITE%TYPE,TT_IOR.CODFIL%TYPE,TT_IOR.CODMUL%TYPE,TT_LOT.CODFIL%TYPE,TT_LOT.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1681 --*/
CREATE OR REPLACE FUNCTION TGR_IOR_Atualiza_Reserva_Lote (TT_IOR.QTDITE%TYPE,TT_IOR.CODFIL%TYPE,TT_IOR.CODMUL%TYPE,TT_LOT.CODFIL%TYPE,TT_LOT.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pQTDITE ALIAS FOR $1 ;
pCODFIL ALIAS FOR $2 ;
pCODMUL ALIAS FOR $3 ;
pFILLOT ALIAS FOR $4 ;
pSEQLOT ALIAS FOR $5 ;

-- Objetivo:
-- 1. Atualiza a reserva do lote na TT_SLT pelo orçamento.

-- Declaração de variáveis e cursores
   nRegSaldo                     Numeric;

  --Pedro E. Braga - 91066 - Retirado pois estava gerando Acess Violation no controle de promoção quantidade.
  --nRESERV Numeric;

-- Início da função  
BEGIN
  /* Atualiza Reserva do Lote */
  --Pedro E. Braga - 91066 - Retirado pois estava gerando Acess Violation no controle de promoção quantidade.
  --Processo realizar um orçamento com lote com promoção no plano de pagamento padrão,
  -- ao alterar o plano de pagamento o sistema permitia alteração contudo na hora de finalizar a DAV gerava erro na
  -- execução da função "PersisteItem" da tela de DAV.
  --Erro retornado pelo Banco de Dados na execução.
  --ORA-01403: dados não encontrados
  --ORA-06512: em "TOTALL154.TGR_IOR_ATUALIZA_RESERVA_LOTE", line 12
  --ORA-06512: em "TOTALL154.TGIOR2", line 495
  --ORA-04088: erro durante a execução do gatilho "TOTALL154.TGIOR2"
  /*
  SELECT COALESCE(RESERV,0)
    INTO nRESERV
    FROM TT_SLT
   WHERE CODFIL = pCODFIL
     AND CODMUL = pCODMUL
     AND FILLOT = pFILLOT
    AND SEQLOT = pSEQLOT;
  */

   SELECT COUNT(*) INTO nRegSaldo
     FROM TT_SLT
    WHERE CODFIL = pCODFIL
      AND CODMUL = pCODMUL
      AND FILLOT = pFILLOT
      AND SEQLOT = pSEQLOT;

   IF nRegSaldo > 0 THEN
      UPDATE TT_SLT
         SET RESERV = COALESCE(RESERV,0) + pQTDITE
       WHERE CODFIL = pCODFIL
         AND CODMUL = pCODMUL
         AND FILLOT = pFILLOT
         AND SEQLOT = pSEQLOT;
   ELSE
      -- RFMP 90843
      -- Se entrou aqui é porque vendeu sem dar entrada no lote.
      INSERT INTO TT_SLT
         (CODFIL, CODMUL, FILLOT, SEQLOT, QTDEST, RESERV)
      VALUES
         (pCODFIL, pCODMUL, pFILLOT, pSEQLOT, 0, pQTDITE);
   END IF;

  RETURN NULL;
END;
$$ language 'plpgsql';




/*-- SEQ 1682 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_IVE_Atualiza_Movimento (TT_IVE.QTDMOV%TYPE,TT_IVE.VLRMOV%TYPE,TT_IVE.CODFIL%tYPE,TT_IVE.SEQUEN%tYPE,TT_IVE.FILMAT%tYPE,TT_IVE.CODMAT%tYPE,TT_IVE.CODCOR%tYPE,TT_IVE.CODTAM%tYPE,TT_IVE.CODMUL%tYPE,TT_IVE.VEN_DATHOR%TYPE,TT_IVE.DUMMY%TYPE,TT_IVE.PROMOC%TYPE) CASCADE;

/*-- SEQ 1683 --*/
CREATE OR REPLACE FUNCTION TGR_IVE_Atualiza_Movimento (TT_IVE.QTDMOV%TYPE,TT_IVE.VLRMOV%TYPE,TT_IVE.CODFIL%tYPE,TT_IVE.SEQUEN%tYPE,TT_IVE.FILMAT%tYPE,TT_IVE.CODMAT%tYPE,TT_IVE.CODCOR%tYPE,TT_IVE.CODTAM%tYPE,TT_IVE.CODMUL%tYPE,TT_IVE.VEN_DATHOR%TYPE,TT_IVE.DUMMY%TYPE,TT_IVE.PROMOC%TYPE)
RETURNS VARCHAR AS $$
DECLARE
quantidade ALIAS FOR $1 ;
valor ALIAS FOR $2 ;
pCODFIL ALIAS FOR $3 ;
pSEQUEN ALIAS FOR $4 ;
pFILMAT ALIAS FOR $5 ;
PCODMAT ALIAS FOR $6 ;
PCODCOR ALIAS FOR $7 ;
PCODTAM ALIAS FOR $8 ;
PCODMUL ALIAS FOR $9 ;
pDATHOR ALIAS FOR $10 ;
pDUMMY ALIAS FOR $11 ;
pPROMOC ALIAS FOR $12 ;
-- Atualiza a movimentacao diaria em TR_MOV
  linha   INTEGER;
  eLanVen TT_VEN.LANVEN%TYPE;
  eFinanc TT_VEN.FINANC%TYPE;
  data    Timestamp;
  WK_NADA Numeric;
  
BEGIN
  -- Define o valor
  -- Nota: a) Em TT_IVE a quantidade e sempre negativa mas e gravada sem sinal
  --       b) Em TT_ICO a quantidade e sempre positiva
  --       c) Em TT_LAN a quantidade tanto e negativa quanto positiva
  -- Data para comparacao
  data := Trunc(PDATHOR);

  SELECT COUNT(*) INTO linha
  FROM TR_MOV
  WHERE CODFIL = PCODFIL
    AND FILMAT = PFILMAT
    AND CODMAT = PCODMAT
    AND CODCOR = PCODCOR
    AND CODTAM = PCODTAM
    AND CODMUL = pCODMUL
    AND DATMOV = data;

  -- Novo tratamento para evitar "mutating table"
  IF    pDUMMY = Constante('vem_de_TGVEN_TT') THEN eLanVen := 'T'; eFinanc := 'T';
  ELSIF pDUMMY = Constante('vem_de_TGVEN_TF') THEN eLanVen := 'T'; eFinanc := 'F';
  ELSIF pDUMMY = Constante('vem_de_TGVEN_FT') THEN eLanVen := 'F'; eFinanc := 'T';
  ELSIF pDUMMY = Constante('vem_de_TGVEN_FF') THEN eLanVen := 'F'; eFinanc := 'F';
  ELSE
    SELECT CASE LANVEN WHEN 'P' THEN 'T' ELSE LANVEN END AS LANVEN, FINANC
      INTO eLanVen,eFinanc
    FROM TT_VEN
    WHERE CODFIL = pCODFIL
      AND SEQUEN = pSEQUEN;
  END IF;

  IF linha > 0 THEN
    UPDATE TR_MOV SET QTDVEN = COALESCE(QTDVEN,0) + CASE eLanVen WHEN 'T' THEN quantidade ELSE 0 END,
                      VLRVEN = COALESCE(VLRVEN,0) + CASE eLanVen WHEN 'T' THEN valor ELSE 0 END,
                      VENFIS = COALESCE(VENFIS,0) + CASE eLanVen WHEN 'F' THEN quantidade ELSE 0 END,
                      VENFIN = COALESCE(VENFIN,0) + CASE eLanVen WHEN 'F' THEN valor ELSE 0 END,
                      PROMOC = CASE PROMOC WHEN 'T' THEN PROMOC ELSE pPROMOC END
    WHERE CODFIL = pCODFIL
      AND FILMAT = pFILMAT
      AND CODMAT = pCODMAT
      AND CODCOR = pCODCOR
      AND CODTAM = pCODTAM
      AND CODMUL = pCODMUL
      AND DATMOV = data;
  ELSE    
    INSERT INTO TR_MOV (CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,CODMUL,
                        DATMOV,QTDVEN,VLRVEN,VENFIS,VENFIN, PROMOC)
    VALUES (pCODFIL,pFILMAT,pCODMAT,pCODCOR,pCODTAM,pCODMUL,
            data,
            CASE eLanVen WHEN 'T' THEN quantidade ELSE 0 END,
            CASE eLanVen WHEN 'T' THEN valor ELSE 0 END,
            CASE eLanVen WHEN 'F' THEN quantidade ELSE 0 END,
            CASE eLanVen WHEN 'F' THEN valor ELSE 0 END, 
            pPROMOC);
  END IF;
  WK_NADA := RecalcCus(pCODFIL,pCODMUL,pFILMAT,pCODMAT,pCODCOR,pCODTAM,data,'F');
  WK_NADA := RecalcFre(pCODFIL,pCODMUL,pFILMAT,pCODMAT,pCODCOR,pCODTAM,data,0);
  WK_NADA := RecalcMov(pCODFIL,pFILMAT,pCODMAT,pCODCOR,pCODTAM,data,pCODMUL);
  Return null;
END;
$$ language 'plpgsql';




/*-- SEQ 1684 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_IVE_Atualiza_Reserva (TT_IVE.QTDMOV%TYPE,TT_IVE.CODFIL%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE,TT_IVE.CODMUL%TYPE,TT_IVE.FILRES%TYPE) CASCADE;

/*-- SEQ 1685 --*/
CREATE OR REPLACE FUNCTION TGR_IVE_Atualiza_Reserva (TT_IVE.QTDMOV%TYPE,TT_IVE.CODFIL%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE,TT_IVE.CODMUL%TYPE,TT_IVE.FILRES%TYPE)
RETURNS VARCHAR AS $$
DECLARE
quantidade ALIAS FOR $1 ;
pCODFIL ALIAS FOR $2 ;
pFILMAT ALIAS FOR $3 ;
PCODMAT ALIAS FOR $4 ;
PCODCOR ALIAS FOR $5 ;
PCODTAM ALIAS FOR $6 ;
PCODMUL ALIAS FOR $7 ;
pFILRES ALIAS FOR $8 ;
-- Atualiza a reserva em TT_SAL
-- Nota: o valor diferente de null para TT_SAL.DUMMY e para impedir
--       que a "trigger" TGSAL realize um recalculo 

BEGIN
  -- Define o valor
  -- Nota: a) Em TT_IVE a quantidade e sempre negativa mas e gravada sem sinal
  --       b) Em TT_ICO a quantidade e sempre positiva
  --       c) Em TT_LAN a quantidade tanto e negativa quanto positiva
  --       d) Em TT_IOR a quantidade e sempre positiva
  IF TGR_IVE_Existe_Lancamento(COALESCE(pFILRES, pCODFIL),pFILMAT,PCODMAT,PCODCOR,PCODTAM,PCODMUL) THEN
    UPDATE TT_SAL SET DUMMY = Constante('vem_de_TGIVE'), RESERV = (COALESCE(RESERV,0) + quantidade)
    WHERE CODFIL = COALESCE(pFILRES, pCODFIL)
      AND FILMAT = pFILMAT
      AND CODMAT = pCODMAT
      AND CODCOR = pCODCOR
      AND CODTAM = pCODTAM
      AND CODMUL = pCODMUL;
  ELSE
    INSERT INTO TT_SAL (DUMMY,CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,CODMUL,RESERV)
    VALUES (Constante('vem_de_TGIVE'),COALESCE(pFILRES, pCODFIL),pFILMAT,pCODMAT,pCODCOR,pCODTAM,pCODMUL,quantidade);
  END IF;
  return null;
END;
$$ language 'plpgsql';




/*-- SEQ 1686 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_IVE_Atualiza_Reserva_Lote (TT_IVE.QTDMOV%TYPE,TT_IVE.CODFIL%TYPE,TT_IVE.CODMUL%TYPE,TT_LOT.CODFIL%TYPE,TT_LOT.SEQUEN%TYPE,TT_IVE.FILRES%TYPE) CASCADE;

/*-- SEQ 1687 --*/
CREATE OR REPLACE FUNCTION TGR_IVE_Atualiza_Reserva_Lote (TT_IVE.QTDMOV%TYPE,TT_IVE.CODFIL%TYPE,TT_IVE.CODMUL%TYPE,TT_LOT.CODFIL%TYPE,TT_LOT.SEQUEN%TYPE,TT_IVE.FILRES%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pQTDITE ALIAS FOR $1 ;
pCODFIL ALIAS FOR $2 ;
pCODMUL ALIAS FOR $3 ;
pFILLOT ALIAS FOR $4 ;
pSEQLOT ALIAS FOR $5 ;
pFILRES ALIAS FOR $6 ;

-- Objetivo:
-- 1. Atualiza a reserva do lote na TT_SLT pela venda.

-- Declarao de variveis e cursores
   nRegSaldo                     Numeric;
   --nRESERV Numeric;

-- Incio da funo
BEGIN
  /* Atualiza Reserva do Lote */
  --SELECT COALESCE(RESERV,0)
  --  INTO nRESERV
  --  FROM TT_SLT
  -- WHERE CODFIL = COALESCE(pFILRES, pCODFIL)
  --   AND CODMUL = pCODMUL
  --   AND FILLOT = pFILLOT
  --  AND SEQLOT = pSEQLOT;

   SELECT COUNT(*) INTO nRegSaldo
     FROM TT_SLT
    WHERE CODFIL = COALESCE(pFILRES, pCODFIL)
      AND CODMUL = pCODMUL
      AND FILLOT = pFILLOT
      AND SEQLOT = pSEQLOT;

   IF nRegSaldo > 0 THEN
      UPDATE TT_SLT
         SET RESERV = COALESCE(RESERV,0) + pQTDITE
       WHERE CODFIL = COALESCE(pFILRES, pCODFIL)
         AND CODMUL = pCODMUL
         AND FILLOT = pFILLOT
         AND SEQLOT = pSEQLOT;
   ELSE
      -- RFMP 90843
      -- Se entrou aqui  porque vendeu sem dar entrada no lote.
      INSERT INTO TT_SLT
         (CODFIL, CODMUL, FILLOT, SEQLOT, QTDEST, RESERV)
      VALUES
         (COALESCE(pFILRES, pCODFIL), pCODMUL, pFILLOT, pSEQLOT, 0, pQTDITE);
   END IF;

   RETURN NULL;
END;
$$ language 'plpgsql';




/*-- SEQ 1688 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_IVE_Atualiza_Saldo (TT_IVE.QTDMOV%TYPE,TT_IVE.CODFIL%tYPE,TT_IVE.FILMAT%tYPE,TT_IVE.CODMAT%tYPE,TT_IVE.CODCOR%tYPE,TT_IVE.CODTAM%tYPE,TT_IVE.CODMUL%tYPE) CASCADE;

/*-- SEQ 1689 --*/
CREATE OR REPLACE FUNCTION TGR_IVE_Atualiza_Saldo (TT_IVE.QTDMOV%TYPE,TT_IVE.CODFIL%tYPE,TT_IVE.FILMAT%tYPE,TT_IVE.CODMAT%tYPE,TT_IVE.CODCOR%tYPE,TT_IVE.CODTAM%tYPE,TT_IVE.CODMUL%tYPE)
RETURNS VARCHAR AS $$
DECLARE
quantidade ALIAS FOR $1 ;
pCODFIL ALIAS FOR $2 ;
pFILMAT ALIAS FOR $3 ;
PCODMAT ALIAS FOR $4 ;
PCODCOR ALIAS FOR $5 ;
PCODTAM ALIAS FOR $6 ;
PCODMUL ALIAS FOR $7 ;
-- Atualiza o estoque em TT_SAL
-- Nota: o valor diferente de null para TT_SAL.DUMMY e para impedir
--       que a "trigger" TGSAL realize um recalculo
BEGIN
  -- Define o valor
  -- Nota: a) Em TT_IVE a quantidade e sempre negativa mas e gravada sem sinal
  --       b) Em TT_ICO a quantidade e sempre positiva
  --       c) Em TT_LAN a quantidade tanto e negativa quanto positiva
  IF TGR_IVE_Existe_Lancamento(pCODFIL,pFILMAT,PCODMAT,PCODCOR,PCODTAM,PCODMUL) THEN
    UPDATE TT_SAL SET DUMMY = Constante('vem_de_TGIVE'), QTDEST = (COALESCE(QTDEST,0) + quantidade)
    WHERE CODFIL = pCODFIL
      AND FILMAT = pFILMAT
      AND CODMAT = pCODMAT
      AND CODCOR = pCODCOR
      AND CODTAM = pCODTAM
      AND CODMUL = pCODMUL;
  ELSE
    INSERT INTO TT_SAL (DUMMY,CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,CODMUL,QTDEST)
    VALUES (Constante('vem_de_TGIVE'),pCODFIL,pFILMAT,pCODMAT,pCODCOR,pCODTAM,pCODMUL,quantidade);
  END IF;
  
  RETURN null;
END;
$$ language 'plpgsql';




/*-- SEQ 1690 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_IVE_Atualiza_Saldo_Lote (TT_IVE.QTDMOV%TYPE,TT_IVE.CODFIL%TYPE,TD_MUL.CODTAB%TYPE,TT_LOT.CODFIL%TYPE,TT_LOT.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1691 --*/
CREATE OR REPLACE FUNCTION TGR_IVE_Atualiza_Saldo_Lote (TT_IVE.QTDMOV%TYPE,TT_IVE.CODFIL%TYPE,TD_MUL.CODTAB%TYPE,TT_LOT.CODFIL%TYPE,TT_LOT.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pQuantidade ALIAS FOR $1 ;
pCODFIL ALIAS FOR $2 ;
PCODMUL ALIAS FOR $3 ;
PFILLOT ALIAS FOR $4 ;
PSEQLOT ALIAS FOR $5 ;

-- Objetivos
-- Atualiza o saldo do lote na TT_SLT : Venda.

-- Declarao de variveis e cursores
   nRegSaldo                     Numeric;

-- Incio da funo
BEGIN
   /* Verifica se ja possui saldo de lote */
   SELECT COUNT(*) INTO nRegSaldo
     FROM TT_SLT
    WHERE CODFIL = pCODFIL
      AND CODMUL = pCODMUL
      AND FILLOT = pFILLOT
      AND SEQLOT = pSEQLOT;

   IF nRegSaldo > 0 THEN
      UPDATE TT_SLT
         SET QTDEST = (COALESCE(QTDEST,0) + pQuantidade)
       WHERE CODFIL = pCODFIL
         AND CODMUL = pCODMUL
         AND FILLOT = pFILLOT
         AND SEQLOT = pSEQLOT;
   ELSE
      /* Se nao houver saldo insere um registro */
      INSERT INTO TT_SLT
      (CODFIL,CODMUL,FILLOT,SEQLOT,QTDEST)
      VALUES
      (pCODFIL,pCODMUL,pFILLOT,pSEQLOT,pQuantidade);
   END IF;

   RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1692 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_LAN_Atualiza_Movimento (TT_LAN.QTDMOV%TYPE,TT_LAN.VLRMOV%TYPE,TT_LAN.CODFIL%tYPE,TT_LAN.FILMAT%tYPE,TT_LAN.CODMAT%tYPE,TT_LAN.CODCOR%tYPE,TT_LAN.CODTAM%tYPE,TT_LAN.CODMUL%tYPE,TT_ICO.COM_DATOPE%TYPE,TD_LAN.MOVLEG%TYPE) CASCADE;

/*-- SEQ 1693 --*/
CREATE OR REPLACE FUNCTION TGR_LAN_Atualiza_Movimento (TT_LAN.QTDMOV%TYPE,TT_LAN.VLRMOV%TYPE,TT_LAN.CODFIL%tYPE,TT_LAN.FILMAT%tYPE,TT_LAN.CODMAT%tYPE,TT_LAN.CODCOR%tYPE,TT_LAN.CODTAM%tYPE,TT_LAN.CODMUL%tYPE,TT_ICO.COM_DATOPE%TYPE,TD_LAN.MOVLEG%TYPE)
RETURNS VARCHAR AS $$
DECLARE
quantidade ALIAS FOR $1 ;
valor ALIAS FOR $2 ;
pCODFIL ALIAS FOR $3 ;
pFILMAT ALIAS FOR $4 ;
PCODMAT ALIAS FOR $5 ;
PCODCOR ALIAS FOR $6 ;
PCODTAM ALIAS FOR $7 ;
PCODMUL ALIAS FOR $8 ;
PDATA ALIAS FOR $9 ;
pMOVLEG ALIAS FOR $10 ;
-- Atualiza TR_MOV
  linha Numeric;
  data  Timestamp;
  WK_NADA Numeric;
  
BEGIN
  -- Define o valor
  -- Nota: a) Em TT_IVE a quantidade e sempre negativa mas e gravada sem sinal
  --       b) Em TT_ICO a quantidade e sempre positiva
  --       c) Em TT_LAN a quantidade tanto e negativa quanto positiva

  -- Data de comparacao
  data := Trunc(PData);

  -- Verifica se ja existe uma movimentacao
  SELECT COUNT(*) INTO linha
  FROM TR_MOV
  WHERE CODFIL = pCODFIL
    AND FILMAT = pFILMAT
    AND CODMAT = pCODMAT
    AND CODCOR = pCODCOR
    AND CODTAM = pCODTAM
    AND CODMUL = pCODMUL
    AND DATMOV = data;
  
  IF pMOVLEG='T' THEN
	  IF linha > 0 THEN
		UPDATE TR_MOV SET QTDCOM = (COALESCE(QTDCOM,0) + quantidade),
						  VLRCOM = (COALESCE(VLRCOM,0) + valor)
		WHERE CODFIL = pCODFIL
		  AND FILMAT = pFILMAT
		  AND CODMAT = pCODMAT
		  AND CODCOR = pCODCOR
		  AND CODTAM = pCODTAM
		  AND CODMUL = pCODMUL
		  AND DATMOV = data;
	  ELSE
		INSERT INTO TR_MOV (CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,CODMUL,DATMOV,QTDCOM,VLRCOM)
		VALUES (pCODFIL,pFILMAT,pCODMAT,pCODCOR,pCODTAM,pCODMUL,data,quantidade,valor);
	  END IF;  
  ELSE
	  IF linha > 0 THEN
		UPDATE TR_MOV SET QTDOUT = (COALESCE(QTDOUT,0) + quantidade),
						  VLROUT = (COALESCE(VLROUT,0) + valor)
		WHERE CODFIL = pCODFIL
		  AND FILMAT = pFILMAT
		  AND CODMAT = pCODMAT
		  AND CODCOR = pCODCOR
		  AND CODTAM = pCODTAM
		  AND CODMUL = pCODMUL
		  AND DATMOV = data;
	  ELSE
		INSERT INTO TR_MOV (CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,CODMUL,DATMOV,QTDOUT,VLROUT)
		VALUES (pCODFIL,pFILMAT,pCODMAT,pCODCOR,pCODTAM,pCODMUL,data,quantidade,valor);
	  END IF;
  END IF; 
  WK_NADA := RecalcCus(pCODFIL,pCODMUL,pFILMAT,pCODMAT,pCODCOR,pCODTAM,data,'F');
  WK_NADA := RecalcFre(pCODFIL,pCODMUL,pFILMAT,pCODMAT,pCODCOR,pCODTAM,data,0);
  WK_NADA := RecalcMov(pCODFIL,pFILMAT,pCODMAT,pCODCOR,pCODTAM,data,pCODMUL);
  return null;
END;
$$ language 'plpgsql';




/*-- SEQ 1694 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_LAN_Atualiza_Saldo (TT_LAN.QTDMOV%TYPE,TT_LAN.CODFIL%tYPE,TT_lan.FILMAT%tYPE,TT_lan.CODMAT%tYPE,TT_lan.CODCOR%tYPE,TT_lan.CODTAM%tYPE,TT_lan.CODMUL%tYPE) CASCADE;

/*-- SEQ 1695 --*/
CREATE OR REPLACE FUNCTION TGR_LAN_Atualiza_Saldo (TT_LAN.QTDMOV%TYPE,TT_LAN.CODFIL%tYPE,TT_lan.FILMAT%tYPE,TT_lan.CODMAT%tYPE,TT_lan.CODCOR%tYPE,TT_lan.CODTAM%tYPE,TT_lan.CODMUL%tYPE)
RETURNS VARCHAR AS $$
DECLARE
quantidade ALIAS FOR $1 ;
pCODFIL ALIAS FOR $2 ;
pFILMAT ALIAS FOR $3 ;
PCODMAT ALIAS FOR $4 ;
PCODCOR ALIAS FOR $5 ;
PCODTAM ALIAS FOR $6 ;
PCODMUL ALIAS FOR $7 ;
-- Atualiza TT_SAL
-- Nota: o valor diferente de null para TT_SAL.DUMMY e para impedir
--          que a "trigger" TGSAL realize um recalculo
  linha Numeric;
BEGIN
  -- Define o valor
  -- Nota: a) Em TT_IVE a quantidade e sempre negativa mas e gravada sem sinal
  --       b) Em TT_ICO a quantidade e sempre positiva
  --       c) Em TT_LAN a quantidade tanto e negativa quanto positiva

  -- Verifica se ja existe um saldo
  SELECT COUNT(*) INTO linha
  FROM TT_SAL
  WHERE CODFIL = PCODFIL
    AND FILMAT = PFILMAT
    AND CODMAT = PCODMAT
    AND CODCOR = PCODCOR
    AND CODTAM = PCODTAM
    AND CODMUL = PCODMUL;

  IF linha > 0 THEN
    UPDATE TT_SAL set DUMMY = Constante('vem_de_TGLAN'), QTDEST = (COALESCE(QTDEST,0) + quantidade)
    WHERE CODFIL = PCODFIL
      AND FILMAT = PFILMAT
      AND CODMAT = PCODMAT
      AND CODCOR = PCODCOR
      AND CODTAM = PCODTAM
      AND CODMUL = PCODMUL;
  ELSE
    INSERT INTO TT_SAL (DUMMY,CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,CODMUL,QTDEST)
    VALUES (Constante('vem_de_TGLAN'),PCODFIL,PFILMAT,PCODMAT,PCODCOR,PCODTAM,PCODMUL,quantidade);
  END IF;
  
  Return null;
END;
$$ language 'plpgsql';




/*-- SEQ 1696 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_LAN_Atualiza_Saldo_Lote (TT_LAN.QTDMOV%TYPE,TT_LAN.CODFIL%tYPE,TD_MUL.CODTAB%tYPE,TT_LOT.CODFIL%tYPE,TT_LOT.SEQUEN%tYPE) CASCADE;

/*-- SEQ 1697 --*/
CREATE OR REPLACE FUNCTION TGR_LAN_Atualiza_Saldo_Lote (TT_LAN.QTDMOV%TYPE,TT_LAN.CODFIL%tYPE,TD_MUL.CODTAB%tYPE,TT_LOT.CODFIL%tYPE,TT_LOT.SEQUEN%tYPE)
RETURNS VARCHAR AS $$
DECLARE
pQuantidade ALIAS FOR $1 ;
pCODFIL ALIAS FOR $2 ;
PCODMUL ALIAS FOR $3 ;
PFILLOT ALIAS FOR $4 ;
PSEQLOT ALIAS FOR $5 ;

-- Objetivos
-- Atualiza o saldo do lote na TT_SLT : Lancamentos

-- Declarao de variveis e cursores
   nRegSaldo                     Numeric;

-- Incio da funo
BEGIN
   /* Verifica se ja possui saldo de lote */
   SELECT COUNT(*) INTO nRegSaldo
     FROM TT_SLT
    WHERE CODFIL = pCODFIL
      AND CODMUL = pCODMUL
      AND FILLOT = pFILLOT
      AND SEQLOT = pSEQLOT;

   IF nRegSaldo > 0 THEN
      UPDATE TT_SLT
         SET QTDEST = (COALESCE(QTDEST,0) + pQuantidade)
       WHERE CODFIL = pCODFIL
         AND CODMUL = pCODMUL
         AND FILLOT = pFILLOT
         AND SEQLOT = pSEQLOT;
   ELSE
      /* Se nao houver saldo insere um registro */
      INSERT INTO TT_SLT
      (CODFIL,CODMUL,FILLOT,SEQLOT,QTDEST)
      VALUES
      (pCODFIL,pCODMUL,pFILLOT,pSEQLOT,pQuantidade);
   END IF;

   RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1698 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_PopulaTabelaPersonalizada (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE) CASCADE;

/*-- SEQ 1699 --*/
CREATE OR REPLACE FUNCTION TGR_PopulaTabelaPersonalizada (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_Filial ALIAS FOR $1 ;
p_Codigo ALIAS FOR $2 ;
  wk_achou INTEGER;
BEGIN
  SELECT COUNT(*) INTO wk_achou
    FROM TT_CFG WHERE POPULA_TP_CLI = 'T';

  IF wk_achou > 0 THEN
    BEGIN
      SELECT COUNT(*) INTO wk_achou
        FROM TP_CLI WHERE FILCLI = p_Filial AND CODCLI = p_Codigo;
    END;

    IF wk_achou = 0 THEN
      INSERT INTO TP_CLI (FILCLI,CODCLI) VALUES (p_Filial, p_Codigo);
    END IF;
  END IF;
  Return null;
END;
$$ language 'plpgsql';





/*-- SEQ 1700 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_PopulaSPC (TT_SPC.FILCLI%TYPE,TT_SPC.CODCLI%TYPE,TT_SPC.E_MAIL%TYPE,TT_SPC.DDDCEL%TYPE,TT_SPC.NUMCEL%TYPE) CASCADE;

/*-- SEQ 1701 --*/
CREATE OR REPLACE FUNCTION TGR_PopulaSPC (TT_SPC.FILCLI%TYPE,TT_SPC.CODCLI%TYPE,TT_SPC.E_MAIL%TYPE,TT_SPC.DDDCEL%TYPE,TT_SPC.NUMCEL%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_Filial ALIAS FOR $1 ;
p_codigo ALIAS FOR $2 ;
p_Email ALIAS FOR $3 ;
p_DDDCel ALIAS FOR $4 ;
p_NumCel ALIAS FOR $5 ;
  wk_achou INTEGER;
BEGIN
  SELECT COUNT(*) INTO wk_achou
    FROM TT_SPC
   WHERE FILCLI = p_Filial
     AND CODCLI = p_Codigo;

  IF wk_achou > 0 THEN
    UPDATE TT_SPC 
       SET E_MAIL = COALESCE(p_EMail,E_MAIL),
           DDDCEL = COALESCE(p_DDDCel, DDDCEL),
           NUMCEL = COALESCE(p_NumCel, NUMCEL)
     WHERE FILCLI = p_Filial AND CODCLI = p_Codigo;
  ELSE
    --IF p_EMail IS NOT NULL THEN
      INSERT INTO TT_SPC (FILCLI,CODCLI,E_MAIL,DDDCEL,NUMCEL) VALUES (p_Filial, p_Codigo, p_EMail, p_DDDCel, p_NumCel);
    --END IF;
  END IF;
  Return null;
END;
$$ language 'plpgsql';





/*-- SEQ 1702 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_AtualizaSaldoNoVeiculo (TT_CCC.PLACAS%TYPE,TT_CCC.CODFIL%TYPE,TT_CCC.SEQUEN%TYPE,TT_CCC.VLRLAN%TYPE,TT_CCC.TIPCCC%TYPE) CASCADE;

/*-- SEQ 1703 --*/
CREATE OR REPLACE FUNCTION TGR_AtualizaSaldoNoVeiculo (TT_CCC.PLACAS%TYPE,TT_CCC.CODFIL%TYPE,TT_CCC.SEQUEN%TYPE,TT_CCC.VLRLAN%TYPE,TT_CCC.TIPCCC%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_Placas ALIAS FOR $1 ;
p_Filial ALIAS FOR $2 ;
p_Codigo ALIAS FOR $3 ;
p_Valor ALIAS FOR $4 ;
p_Tipo ALIAS FOR $5 ;
  wk_CC    TT_CCC.TIPCCC%TYPE;
begin
  SELECT CFG.CC_CHECKOUT INTO wk_CC
    FROM TT_CFG CFG;

  IF (wk_CC = p_Tipo) THEN
    IF p_Valor > 0 /* CREDITO */ THEN
      UPDATE TT_VEI SET VLRCCC = COALESCE(VLRCCC,0) + p_Valor
       WHERE PLACAS = p_Placas;
    ELSE /* DEBITO */
      UPDATE TT_VEI
         SET FILCCC = CASE  COALESCE(VLRCCC,0) WHEN 0 THEN p_Filial ELSE FILCCC END,
             SEQCCC = CASE  COALESCE(VLRCCC,0) WHEN 0 THEN p_Codigo ELSE SEQCCC END,
             VLRCCC = COALESCE(VLRCCC,0) + p_Valor
      WHERE PLACAS = p_Placas;
    END IF;
  END IF;
  Return null;
END;
$$ language 'plpgsql';




/*-- SEQ 1704 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_TotalizaNoProjeto (TT_WOR.FILPRJ%TYPE,TT_WOR.SEQPRJ%TYPE,TD_SIT.TIPSIT%TYPE,TT_WOR.FLGACT%TYPE,TT_WOR.TARREA%TYPE,TT_WOR.TARPRE%TYPE,TT_WOR.CONCLU%TYPE,boolean,boolean,boolean) CASCADE;

/*-- SEQ 1705 --*/
CREATE OR REPLACE FUNCTION TGR_TotalizaNoProjeto (TT_WOR.FILPRJ%TYPE,TT_WOR.SEQPRJ%TYPE,TD_SIT.TIPSIT%TYPE,TT_WOR.FLGACT%TYPE,TT_WOR.TARREA%TYPE,TT_WOR.TARPRE%TYPE,TT_WOR.CONCLU%TYPE,boolean,boolean,boolean)
RETURNS VARCHAR AS $$
DECLARE
p_Filial ALIAS FOR $1 ;
p_Codigo ALIAS FOR $2 ;
p_Status ALIAS FOR $3 ;
p_Aceite ALIAS FOR $4 ;
p_Real ALIAS FOR $5 ;
p_Previsto ALIAS FOR $6 ;
p_Feito ALIAS FOR $7 ;
p_Menos ALIAS FOR $8 ;
p_NovoStatus ALIAS FOR $9 ;
p_NovoAceite ALIAS FOR $10 ;
-- Totaliza os tipos de tarefas no projeto

  wk_menos INTEGER;
  wk_filpai TT_PRJ.FILPAI%TYPE;
  wk_codpai TT_PRJ.SEQPAI%TYPE;
  wk_nada  VARCHAR(4000);
  wk_conta Numeric;
  vUSA_PERC_HORFAL VARCHAR(1);      
BEGIN
  IF p_Menos THEN
    wk_menos := -1;
  ELSE
    wk_menos := 1;
  END IF;

  IF p_NovoStatus THEN
  
  select USA_PERC_HORFAL into vUSA_PERC_HORFAL
    from TT_CFG;  
  
    UPDATE TT_PRJ SET TOTW_A = COALESCE(TOTW_A,0) + CASE p_Status WHEN 'A' THEN 1 * wk_menos ELSE 0 END,
                      TOTW_C = COALESCE(TOTW_C,0) + CASE p_Status WHEN 'C' THEN 1 * wk_menos ELSE 0 END,
                      TOTW_I = COALESCE(TOTW_I,0) + CASE p_Status WHEN 'I' THEN 1 * wk_menos ELSE 0 END,
                      TOTW_E = COALESCE(TOTW_E,0) + CASE p_Status WHEN 'E' THEN 1 * wk_menos ELSE 0 END,
                      TOTW_X = COALESCE(TOTW_X,0) + CASE p_Status WHEN 'X' THEN 1 * wk_menos ELSE 0 END,
                      TOTW_1 = COALESCE(TOTW_1,0) + CASE p_Status WHEN '1' THEN 1 * wk_menos ELSE 0 END,
                      TOTW_2 = COALESCE(TOTW_2,0) + CASE p_Status WHEN '2' THEN 1 * wk_menos ELSE 0 END,
                      TOTW_S = COALESCE(TOTW_S,0) + CASE p_Status WHEN 'S' THEN 1 * wk_menos ELSE 0 END,
                      HORREA = COALESCE(HORREA,0) + GREATEST(CASE p_Status WHEN 'C' THEN 0
                                                                      WHEN 'S' THEN 0
                                                                      ELSE p_Real
                                                        END,0) * wk_menos,
                      HORFAL = COALESCE(HORFAL,0) + GREATEST(HORAS_FALTANTES(P_STATUS,P_PREVISTO,P_REAL,p_Feito,vUSA_PERC_HORFAL),0) * wk_menos
     WHERE CODFIL = p_Filial
       AND SEQUEN = p_Codigo;
  END IF;

  IF p_NovoAceite THEN
    UPDATE TT_PRJ SET TOTA_T = COALESCE(TOTA_T,0) +  CASE p_Aceite WHEN 'T' THEN 1 * wk_menos ELSE 0 END,
                      TOTA_F = COALESCE(TOTA_F,0) +  CASE p_Aceite WHEN 'F' THEN 1 * wk_menos ELSE 0 END,
                      TOTA_N = COALESCE(TOTA_N,0) +  CASE p_Aceite WHEN 'N' THEN 1 * wk_menos ELSE 0 END
     WHERE CODFIL = p_Filial
       AND SEQUEN = p_Codigo;
  END IF;

  -- Atualiza a arvore
  BEGIN
    SELECT count(*) INTO wk_Conta FROM TT_PRJ 
    WHERE  CODFIL = p_Filial AND SEQUEN = p_Codigo;

    if wk_conta > 0 then
      SELECT FILPAI,SEQPAI INTO wk_filpai,wk_codpai FROM TT_PRJ WHERE  CODFIL = p_Filial AND SEQUEN = p_Codigo;    
    end if;
  END;

  IF (wk_filpai IS NOT NULL) AND (wk_codpai IS NOT NULL) THEN
     wk_nada := TGR_TotalizaNoProjeto(wk_filpai,
                       wk_codpai,
                       p_Status,
                       p_Aceite,
                       p_Real,
                       p_Previsto,
                       p_Feito,
                       p_Menos,
                       p_NovoStatus,
                       p_NovoAceite);
  END IF;
  Return null;
END;
$$ language 'plpgsql';


/*-- SEQ 1706 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_TotalizaNoProjeto (TT_WOR.FILPRJ%TYPE,TT_WOR.SEQPRJ%TYPE,TD_SIT.TIPSIT%TYPE,TT_WOR.FLGACT%TYPE,TT_WOR.TARREA%TYPE,TT_WOR.TARPRE%TYPE,TT_WOR.CONCLU%TYPE,boolean,boolean) CASCADE;

/*-- SEQ 1707 --*/
CREATE OR REPLACE FUNCTION TGR_TotalizaNoProjeto (TT_WOR.FILPRJ%TYPE,
                               TT_WOR.SEQPRJ%TYPE,
                               TD_SIT.TIPSIT%TYPE,
                               TT_WOR.FLGACT%TYPE,
                               TT_WOR.TARREA%TYPE,
                               TT_WOR.TARPRE%TYPE,
                               TT_WOR.CONCLU%TYPE,
                               boolean,
                               boolean) 
RETURNS VARCHAR AS $$
BEGIN
RETURN TGR_TotalizaNoProjeto($1,$2,$3,$4,$5,$6,$7,$8,$9,TRUE);
END;
$$ language 'plpgsql';


/*-- SEQ 1708 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_TotalizaNoProjeto (TT_WOR.FILPRJ%TYPE,TT_WOR.SEQPRJ%TYPE,TD_SIT.TIPSIT%TYPE,TT_WOR.FLGACT%TYPE,TT_WOR.TARREA%TYPE,TT_WOR.TARPRE%TYPE,TT_WOR.CONCLU%TYPE,boolean) CASCADE;

/*-- SEQ 1709 --*/
CREATE OR REPLACE FUNCTION TGR_TotalizaNoProjeto (TT_WOR.FILPRJ%TYPE,
                               TT_WOR.SEQPRJ%TYPE,
                               TD_SIT.TIPSIT%TYPE,
                               TT_WOR.FLGACT%TYPE,
                               TT_WOR.TARREA%TYPE,
                               TT_WOR.TARPRE%TYPE,
                               TT_WOR.CONCLU%TYPE,
                               boolean) 
RETURNS VARCHAR AS $$
BEGIN
RETURN TGR_TotalizaNoProjeto($1,$2,$3,$4,$5,$6,$7,$8,TRUE,TRUE);
END;
$$ language 'plpgsql';


/*-- SEQ 1710 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_TotalizaNoProjeto (TT_WOR.FILPRJ%TYPE,TT_WOR.SEQPRJ%TYPE,TD_SIT.TIPSIT%TYPE,TT_WOR.FLGACT%TYPE,TT_WOR.TARREA%TYPE,TT_WOR.TARPRE%TYPE,TT_WOR.CONCLU%TYPE) CASCADE;

/*-- SEQ 1711 --*/
CREATE OR REPLACE FUNCTION TGR_TotalizaNoProjeto (TT_WOR.FILPRJ%TYPE,
                               TT_WOR.SEQPRJ%TYPE,
                               TD_SIT.TIPSIT%TYPE,
                               TT_WOR.FLGACT%TYPE,
                               TT_WOR.TARREA%TYPE,
                               TT_WOR.TARPRE%TYPE,
                               TT_WOR.CONCLU%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN TGR_TotalizaNoProjeto($1,$2,$3,$4,$5,$6,$7,FALSE,TRUE,TRUE);
END;
$$ language 'plpgsql';


/*-- SEQ 1712 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_TotalizaNoProjeto (TT_WOR.FILPRJ%TYPE,TT_WOR.SEQPRJ%TYPE,TD_SIT.TIPSIT%TYPE,TT_WOR.FLGACT%TYPE,TT_WOR.TARREA%TYPE,TT_WOR.TARPRE%TYPE) CASCADE;

/*-- SEQ 1713 --*/
CREATE OR REPLACE FUNCTION TGR_TotalizaNoProjeto (TT_WOR.FILPRJ%TYPE,
                               TT_WOR.SEQPRJ%TYPE,
                               TD_SIT.TIPSIT%TYPE,
                               TT_WOR.FLGACT%TYPE,
                               TT_WOR.TARREA%TYPE,
                               TT_WOR.TARPRE%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN TGR_TotalizaNoProjeto($1,$2,$3,$4,$5,$6,0,FALSE,TRUE,TRUE);
END;
$$ language 'plpgsql';


/*-- SEQ 1714 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_TotalizaNoProjeto (TT_WOR.FILPRJ%TYPE,TT_WOR.SEQPRJ%TYPE,TD_SIT.TIPSIT%TYPE,TT_WOR.FLGACT%TYPE,TT_WOR.TARREA%TYPE) CASCADE;

/*-- SEQ 1715 --*/
CREATE OR REPLACE FUNCTION TGR_TotalizaNoProjeto (TT_WOR.FILPRJ%TYPE,
                               TT_WOR.SEQPRJ%TYPE,
                               TD_SIT.TIPSIT%TYPE,
                               TT_WOR.FLGACT%TYPE,
                               TT_WOR.TARREA%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN TGR_TotalizaNoProjeto($1,$2,$3,$4,$5,0,0,FALSE,TRUE,TRUE);
END;
$$ language 'plpgsql';


/*-- SEQ 1716 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_TotalizaNoProjeto (TT_WOR.FILPRJ%TYPE,TT_WOR.SEQPRJ%TYPE,TD_SIT.TIPSIT%TYPE,TT_WOR.FLGACT%TYPE) CASCADE;

/*-- SEQ 1717 --*/
CREATE OR REPLACE FUNCTION TGR_TotalizaNoProjeto (TT_WOR.FILPRJ%TYPE,
                               TT_WOR.SEQPRJ%TYPE,
                               TD_SIT.TIPSIT%TYPE,
                               TT_WOR.FLGACT%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN TGR_TotalizaNoProjeto($1,$2,$3,$4,0,0,0,FALSE,TRUE,TRUE);
END;
$$ language 'plpgsql';


/*-- SEQ 1718 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_TotalizaNoProjeto (TT_WOR.FILPRJ%TYPE,TT_WOR.SEQPRJ%TYPE,TD_SIT.TIPSIT%TYPE) CASCADE;

/*-- SEQ 1719 --*/
CREATE OR REPLACE FUNCTION TGR_TotalizaNoProjeto (TT_WOR.FILPRJ%TYPE,
                               TT_WOR.SEQPRJ%TYPE,
                               TD_SIT.TIPSIT%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN TGR_TotalizaNoProjeto($1,$2,$3,'N',0,0,0,FALSE,TRUE,TRUE);
END;
$$ language 'plpgsql';


/*-- SEQ 1720 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_VEN_Acumula_Bonus (VARCHAR,TT_VEN.FILCLI%TYPE,TT_VEN.FILCLI%TYPE,TT_VEN.CODCLI%TYPE,TT_VEN.CODCLI%TYPE,TT_BON.TIPBON%TYPE,TT_VEN.LANVEN%TYPE,TT_VEN.LANVEN%TYPE,TT_VEN.FINANC%TYPE,TT_VEN.FINANC%TYPE,TT_VEN.FLGEST%TYPE,TT_VEN.FLGEST%TYPE,TT_VEN.VLRNOT%TYPE,TT_VEN.VLRNOT%TYPE,TT_VEN.DATFIS%TYPE,TT_VEN.DATFIS%TYPE,TT_VEN.CODFIL%TYPE,TT_VEN.CODFIL%TYPE,TT_VEN.FILUSU%TYPE,TT_VEN.FILUSU%TYPE,TT_VEN.CODUSU%TYPE,TT_VEN.CODUSU%TYPE) CASCADE;

/*-- SEQ 1721 --*/
CREATE OR REPLACE FUNCTION TGR_VEN_Acumula_Bonus (VARCHAR,TT_VEN.FILCLI%TYPE,TT_VEN.FILCLI%TYPE,TT_VEN.CODCLI%TYPE,TT_VEN.CODCLI%TYPE,TT_BON.TIPBON%TYPE,TT_VEN.LANVEN%TYPE,TT_VEN.LANVEN%TYPE,TT_VEN.FINANC%TYPE,TT_VEN.FINANC%TYPE,TT_VEN.FLGEST%TYPE,TT_VEN.FLGEST%TYPE,TT_VEN.VLRNOT%TYPE,TT_VEN.VLRNOT%TYPE,TT_VEN.DATFIS%TYPE,TT_VEN.DATFIS%TYPE,TT_VEN.CODFIL%TYPE,TT_VEN.CODFIL%TYPE,TT_VEN.FILUSU%TYPE,TT_VEN.FILUSU%TYPE,TT_VEN.CODUSU%TYPE,TT_VEN.CODUSU%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pSituacao ALIAS FOR $1 ;
pFILPARNew ALIAS FOR $2 ;
pFILPAROld ALIAS FOR $3 ;
pCODPARNew ALIAS FOR $4 ;
pCODPAROld ALIAS FOR $5 ;
pTIPBON ALIAS FOR $6 ;
pLANVENNew ALIAS FOR $7 ;
pLANVENOld ALIAS FOR $8 ;
pFINANCNew ALIAS FOR $9 ;
pFINANCOld ALIAS FOR $10 ;
pFLGESTNew ALIAS FOR $11 ;
pFLGESTOld ALIAS FOR $12 ;
pVLRNOTNew ALIAS FOR $13 ;
pVLRNOTOld ALIAS FOR $14 ;
pDATFISNew ALIAS FOR $15 ;
pDATFISOld ALIAS FOR $16 ;
pCODFILNew ALIAS FOR $17 ;
pCODFILOld ALIAS FOR $18 ;
pFILUSUNew ALIAS FOR $19 ;
pFILUSUOld ALIAS FOR $20 ;
pCODUSUNew ALIAS FOR $21 ;
pCODUSUOld ALIAS FOR $22 ;
-- Pedro E. Braga - 92163 / 92188 
          
-- Objetivo:
-- 1) Gera Bônus por Valor Acumulado de Vendas para Cliente         
-- 2) Gera Bônus por Valor Acumulado de Vendas para Vendedor 
-- 3) Gera Bônus por Valor Acumulado de Vendas para Indicador 

  dDataBonus    TT_CFG.DATA_BONUS%TYPE; 
  nCLIVlrVenBon TT_CFG.CLI_VLRVEN_BON%TYPE;   
  nCLIQtdBon    TT_CFG.CLI_QTDBON%TYPE;
  nVDDVlrVenBon TT_CFG.VDD_VLRVEN_BON%TYPE;   
  nVDDQtdBon    TT_CFG.VDD_QTDBON%TYPE;
  nINDVlrVenBon TT_CFG.IND_VLRVEN_BON%TYPE;   
  nINDQtdBon    TT_CFG.IND_QTDBON%TYPE;  
  nCFGVlrVenBon Numeric(12,2); 
  nCFGQtdBon    Numeric(12,2);
  nVenBonNew    TT_CLI.VENBON%TYPE;
  nVenBonOld    TT_CLI.VENBON%TYPE;
  nQtdBon       TT_CFG.CLI_QTDBON%TYPE;  
BEGIN
    
  -- Carrega configurações para controle
  SELECT CFG.DATA_BONUS, CFG.CLI_VLRVEN_BON, CFG.CLI_QTDBON, CFG.VDD_VLRVEN_BON, CFG.VDD_QTDBON, CFG.IND_VLRVEN_BON, CFG.IND_QTDBON
    INTO dDataBonus, nCLIVlrVenBon, nCLIQtdBon, nVDDVlrVenBon, nVDDQtdBon, nINDVlrVenBon, nINDQtdBon
    FROM TT_CFG CFG;
    
  nCFGVlrVenBon := 0;  
  nCFGQtdBon := 0;  
  --Atribuir Valor de Bônus a Considerar
  IF (pTIPBON = 'X') THEN
    nCFGVlrVenBon := nCLIVlrVenBon;  
    nCFGQtdBon := nCLIQtdBon;      
  END IF;
  IF (pTIPBON = 'V') THEN
    nCFGVlrVenBon := nVDDVlrVenBon;  
    nCFGQtdBon := nVDDQtdBon;            
  END IF;
  IF (pTIPBON = 'I') THEN
    nCFGVlrVenBon := nINDVlrVenBon;  
    nCFGQtdBon := nINDQtdBon;                      
  END IF;
  
  IF  (( pDATFISNew >= dDataBonus ) OR ( pDATFISOld >= dDataBonus )) -- Apenas se data da Venda estiver dentro da Validade
  AND (( nCFGVlrVenBon > 0 ) AND ( nCFGQtdBon > 0 ))   THEN          -- Apenas se existir parametros configurados  
         
    -- Acumula Valor da Venda ao Saldo do Parceiro
    IF  ( pSituacao = 'INS' ) 
    AND ( ( pLANVENNew = 'T' ) AND ( pFINANCNew = 'T' ) OR ( pVLRNOTNew < 0 ) )
    AND ( pFLGESTNew <> 'C' )
    AND ( pCODPARNew <> '     0' ) THEN -- Parceiro que não seja Filial
        UPDATE TT_CLI
           SET VENBON = COALESCE(VENBON,0) + pVLRNOTNew
         WHERE FILCLI = pFILPARNew
           AND CODCLI = pCODPARNew;          
    END IF;
    IF ( pSituacao = 'UPD' ) THEN
        IF  ( pFILPARNew = pFILPAROld ) AND ( pCODPARNew = pCODPAROld ) 
        AND ( pCODPARNew <> '     0' ) THEN -- Parceiro que não seja Filial
            IF  ((    (( pLANVENNew = 'T' ) AND ( pLANVENNew <> pLANVENOld ))
                  AND (( pFINANCNew = 'T' ) AND ( pFINANCNew <> pFINANCOld )))
                 OR (( pVLRNOTNew < 0 ) AND ( pVLRNOTNew <> pVLRNOTOld )))
            AND ( pFLGESTNew <> 'C' ) THEN
                UPDATE TT_CLI
                   SET VENBON = COALESCE(VENBON,0) + pVLRNOTNew
                 WHERE FILCLI = pFILPARNew
                   AND CODCLI = pCODPARNew; 
            ELSE
                IF (((    (( pLANVENOld = 'T' ) AND ( pLANVENNew <> pLANVENOld ))
                      AND (( pFINANCOld = 'T' ) AND ( pFINANCNew <> pFINANCOld )))
                     OR (( pVLRNOTOld < 0 ) AND ( pVLRNOTNew <> pVLRNOTOld )))
                    AND ( pFLGESTNew <> 'C' ))
                OR (    ( pFLGESTNew = 'C' ) AND ( pFLGESTNew <> pFLGESTOld )
                    AND ( pLANVENOld = 'T' ) AND ( pFINANCOld = 'T' ) )  THEN
                    UPDATE TT_CLI
                       SET VENBON = COALESCE(VENBON,0) - pVLRNOTNew
                     WHERE FILCLI = pFILPARNew
                       AND CODCLI = pCODPARNew;  
                END IF;
            END IF;
        ELSE
            IF  (( pLANVENNew = 'T' ) AND ( pFINANCNew = 'T' ) OR  ( pVLRNOTNew < 0 ) )
            AND ( pFLGESTNew <> 'C' ) 
            AND ( pCODPARNew <> '     0' ) THEN -- Parceiro que não seja Filial
                UPDATE TT_CLI
                   SET VENBON = COALESCE(VENBON,0) + pVLRNOTNew
                 WHERE FILCLI = pFILPARNew
                   AND CODCLI = pCODPARNew; 
            END IF;
            IF  (( pLANVENOld = 'T' ) AND ( pFINANCOld = 'T' ) OR ( pVLRNOTOld < 0 ) )
            AND ( pFLGESTOld <> 'C' ) 
            AND ( pCODPAROld <> '     0' ) THEN -- Parceiro que não seja Filial
                UPDATE TT_CLI
                   SET VENBON = COALESCE(VENBON,0) - pVLRNOTOld
                 WHERE FILCLI = pFILPAROld
                   AND CODCLI = pCODPAROld;  
            END IF;            
        END IF;
    END IF;
    IF  ( pSituacao = 'DEL' )
    AND ( ( pLANVENOld = 'T' ) AND ( pFINANCOld = 'T' ) OR ( pVLRNOTOld < 0 ) )
    AND ( pFLGESTOld <> 'C' )
    AND ( pCODPAROld <> '     0' ) THEN -- Parceiro que não seja Filial
        UPDATE TT_CLI
           SET VENBON = COALESCE(VENBON,0) - pVLRNOTOld
         WHERE FILCLI = pFILPAROld
           AND CODCLI = pCODPAROld;           
    END IF; 

    --Pegar Saldo Acumulado do Parceiro
    IF (((( pLANVENNew = 'T' ) AND ( pFINANCNew = 'T' ) OR ( pVLRNOTNew < 0 ))    
         AND ( pFLGESTNew <> 'C' )) 
        OR (    ( pFLGESTNew = 'C' ) AND ( pFLGESTNew <> pFLGESTOld ) 
            AND ( pLANVENNew = 'T' ) AND ( pFINANCNew = 'T' ) )) 
    AND ( pCODPARNew <> '     0' ) THEN -- Parceiro que não seja Filial  
        SELECT COALESCE(VENBON,0)
          INTO nVenBonNew
          FROM TT_CLI
         WHERE FILCLI = pFILPARNew
           AND CODCLI = pCODPARNew;
    ELSE
        nVenBonNew := 0;
    END IF;
    IF (((( pLANVENOld = 'T' ) AND ( pFINANCOld = 'T' ) OR ( pVLRNOTOld < 0 ))    
         AND ( pFLGESTOld <> 'C' )) 
        OR (    ( pFLGESTOld = 'C' ) AND ( pFLGESTNew <> pFLGESTOld ) 
            AND ( pLANVENOld = 'T' ) AND ( pFINANCOld = 'T' ) OR ( pSituacao = 'DEL' ))) 
    AND ( pCODPAROld <> '     0' ) THEN -- Parceiro que não seja Filial
        SELECT COALESCE(VENBON,0)
          INTO nVenBonOld
          FROM TT_CLI
         WHERE FILCLI = pFILPAROld
           AND CODCLI = pCODPAROld;
    ELSE
        nVenBonOld := 0;
    END IF;   
    
    -- Realizar lançamento de Bônus    
    IF  ( pSituacao = 'INS' ) 
    AND (( pLANVENNew = 'T' ) AND ( pFINANCNew = 'T' ) OR ( pVLRNOTNew < 0 ))
    AND ( pFLGESTNew <> 'C' )
    AND ( pCODPARNew <> '     0' ) THEN -- Parceiro que não seja Filial        
        --Gerar Crédito de Bônus caso o Valor Acumulado de Venda  utrapasse o Valor para Crédito Configurado
        IF ( nVenBonNew >= nCFGVlrVenBon ) THEN 
            nQtdBon := nCFGQtdBon * TRUNC(nVenBonNew / nCFGVlrVenBon);
            INSERT INTO TT_BON ( CODFIL, FILUSU, CODUSU, FILCLI, CODCLI, DATOPE, VLRLAN, TIPBON)
                 VALUES        ( pCODFILNew, pFILUSUNew, pCODUSUNew, pFILPARNew, pCODPARNew, pDATFISNew, nQtdBon, pTIPBON );
                 
            nVenBonNew := nVenBonNew - ( nCFGVlrVenBon * TRUNC(nVenBonNew / nCFGVlrVenBon));
            UPDATE TT_CLI
               SET VENBON = nVenBonNew
             WHERE FILCLI = pFILPARNew
               AND CODCLI = pCODPARNew;  
        ELSE
            -- Gerar Abatimento dos Bônus caso o Valor Acumulado de Venda fique negativo devido a cancelamento/exclusão/devolução
            IF (nVenBonNew < 0 ) THEN 
                nVenBonNew := nVenBonNew*(-1);
                nQtdBon := TRUNC(nVenBonNew / nCFGVlrVenBon);
                IF ( MOD(nVenBonNew , nCFGVlrVenBon) > 0 ) THEN
                    nQtdBon := nQtdBon + 1;
                END IF;
                nVenBonNew := (nCFGVlrVenBon * nQtdBon) + (nVenBonNew *(-1));
                nQtdBon := (nCFGQtdBon * nQtdBon)*(-1);                
                INSERT INTO TT_BON ( CODFIL, FILUSU, CODUSU, FILCLI, CODCLI, DATOPE, VLRLAN, TIPBON)
                     VALUES        ( pCODFILNew, pFILUSUNew, pCODUSUNew, pFILPARNew, pCODPARNew, pDATFISNew, nQtdBon, pTIPBON );
                            
                UPDATE TT_CLI
                   SET VENBON = nVenBonNew
                 WHERE FILCLI = pFILPARNew
                   AND CODCLI = pCODPARNew;  
            END IF;
        END IF;                
    END IF;
        
    IF ( pSituacao = 'UPD' ) THEN
        IF  ( pFILPARNew = pFILPAROld ) AND ( pCODPARNew = pCODPAROld ) 
        AND ( pCODPARNew <> '     0' ) THEN -- Parceiro que não seja Filial
            IF  ((    (( pLANVENNew = 'T' ) AND ( pLANVENNew <> pLANVENOld )) 
                  AND (( pFINANCNew = 'T' ) AND ( pFINANCNew <> pFINANCOld )))
                 OR  (( pVLRNOTNew < 0 ) AND ( pVLRNOTNew <> pVLRNOTOld )))
            AND ( pFLGESTNew <> 'C' )  THEN
                --Gerar Crédito de Bônus caso o Valor Acumulado de Venda  utrapasse o Valor para Crédito Configurado
                IF ( nVenBonNew >= nCFGVlrVenBon ) THEN 
                    nQtdBon := nCFGQtdBon * TRUNC(nVenBonNew / nCFGVlrVenBon);
                    INSERT INTO TT_BON ( CODFIL, FILUSU, CODUSU, FILCLI, CODCLI, DATOPE, VLRLAN, TIPBON)
                         VALUES        ( pCODFILNew, pFILUSUNew, pCODUSUNew, pFILPARNew, pCODPARNew, pDATFISNew, nQtdBon, pTIPBON );                
                         
                    nVenBonNew := nVenBonNew - ( nCFGVlrVenBon * TRUNC(nVenBonNew / nCFGVlrVenBon));
                    UPDATE TT_CLI
                       SET VENBON = nVenBonNew
                     WHERE FILCLI = pFILPARNew
                       AND CODCLI = pCODPARNew;  
                ELSE
                    -- Gerar Abatimento dos Bônus caso o Valor Acumulado de Venda fique negativo devido a cancelamento/exclusão/devolução
                    IF (nVenBonNew < 0 ) THEN 
                        nVenBonNew := nVenBonNew*(-1);
                        nQtdBon := TRUNC(nVenBonNew / nCFGVlrVenBon);
                        IF ( MOD(nVenBonNew , nCFGVlrVenBon) > 0 ) THEN
                            nQtdBon := nQtdBon + 1;
                        END IF;
                        nVenBonNew := (nCFGVlrVenBon * nQtdBon) + (nVenBonNew *(-1));
                        nQtdBon := (nCFGQtdBon * nQtdBon)*(-1); 
                        INSERT INTO TT_BON ( CODFIL, FILUSU, CODUSU, FILCLI, CODCLI, DATOPE, VLRLAN, TIPBON)
                             VALUES        ( pCODFILNew, pFILUSUNew, pCODUSUNew, pFILPARNew, pCODPARNew, pDATFISNew, nQtdBon, pTIPBON );
                                    
                        UPDATE TT_CLI
                           SET VENBON = nVenBonNew
                         WHERE FILCLI = pFILPARNew
                           AND CODCLI = pCODPARNew;  
                    END IF;
                END IF;
            ELSE
                IF (((    (( pLANVENOld = 'T' ) AND ( pLANVENOld <> pLANVENNew ))
                      AND (( pFINANCOld = 'T' ) AND ( pFINANCOld <> pFINANCNew )))
                     OR  (( pVLRNOTOld < 0 ) AND ( pVLRNOTNew <> pVLRNOTOld ))) 
                   AND ( pFLGESTOld <> 'C' ) ) 
                OR (( pFLGESTNew = 'C' ) AND ( pFLGESTNew <> pFLGESTOld ) ) THEN
                    --Gerar Crédito de Bônus caso o Valor Acumulado de Venda  utrapasse o Valor para Crédito Configurado
                    IF ( nVenBonOld >= nCFGVlrVenBon ) THEN 
                        nQtdBon := nCFGQtdBon * TRUNC(nVenBonOld / nCFGVlrVenBon);
                        INSERT INTO TT_BON ( CODFIL, FILUSU, CODUSU, FILCLI, CODCLI, DATOPE, VLRLAN, TIPBON)
                             VALUES        ( pCODFILOld, pFILUSUOld, pCODUSUOld, pFILPAROld, pCODPAROld, pDATFISOld, nQtdBon, pTIPBON );                
                             
                        nVenBonOld := nVenBonOld - ( nCFGVlrVenBon * TRUNC(nVenBonOld / nCFGVlrVenBon));
                        UPDATE TT_CLI
                           SET VENBON = nVenBonOld
                         WHERE FILCLI = pFILPAROld
                           AND CODCLI = pCODPAROld;  
                    ELSE
                        -- Gerar Abatimento dos Bônus caso o Valor Acumulado de Venda fique negativo devido a cancelamento/exclusão/devolução
                        IF (nVenBonOld < 0 ) THEN  
                            nVenBonOld := nVenBonOld*(-1);
                            nQtdBon := TRUNC(nVenBonOld / nCFGVlrVenBon);
                            IF ( MOD(nVenBonOld , nCFGVlrVenBon) > 0 ) THEN
                                nQtdBon := nQtdBon + 1;
                            END IF;
                            nVenBonOld := (nCFGVlrVenBon * nQtdBon) + (nVenBonOld *(-1));
                            nQtdBon := (nCFGQtdBon * nQtdBon)*(-1);                             
                            INSERT INTO TT_BON ( CODFIL, FILUSU, CODUSU, FILCLI, CODCLI, DATOPE, VLRLAN, TIPBON)
                                 VALUES        ( pCODFILOld, pFILUSUOld, pCODUSUOld, pFILPAROld, pCODPAROld, pDATFISOld, nQtdBon, pTIPBON );
                                        
                            UPDATE TT_CLI
                               SET VENBON = nVenBonOld
                             WHERE FILCLI = pFILPAROld
                               AND CODCLI = pCODPAROld;  
                        END IF;
                    END IF;    
                END IF;
            END IF;    
        ELSE
            IF  (( pLANVENNew = 'T' ) AND ( pFINANCNew = 'T' ) OR ( pVLRNOTNew < 0 ))
            AND ( pFLGESTNew <> 'C' )
            AND ( pCODPARNew <> '     0' ) THEN -- Parceiro que não seja Filial
                --Gerar Crédito de Bônus caso o Valor Acumulado de Venda  utrapasse o Valor para Crédito Configurado
                IF ( nVenBonNew >= nCFGVlrVenBon ) THEN 
                    nQtdBon := nCFGQtdBon * TRUNC(nVenBonNew / nCFGVlrVenBon);
                    INSERT INTO TT_BON ( CODFIL, FILUSU, CODUSU, FILCLI, CODCLI, DATOPE, VLRLAN, TIPBON)
                         VALUES        ( pCODFILNew, pFILUSUNew, pCODUSUNew, pFILPARNew, pCODPARNew, pDATFISNew, nQtdBon, pTIPBON );                
                         
                    nVenBonNew := nVenBonNew - ( nCFGVlrVenBon * TRUNC(nVenBonNew / nCFGVlrVenBon));
                    UPDATE TT_CLI
                       SET VENBON = nVenBonNew
                     WHERE FILCLI = pFILPARNew
                       AND CODCLI = pCODPARNew;  
                ELSE
                    -- Gerar Abatimento dos Bônus caso o Valor Acumulado de Venda fique negativo devido a cancelamento/exclusão/devolução
                    IF (nVenBonNew < 0 ) THEN 
                        nVenBonNew := nVenBonNew*(-1);
                        nQtdBon := TRUNC(nVenBonNew / nCFGVlrVenBon);
                        IF ( MOD(nVenBonNew , nCFGVlrVenBon) > 0 ) THEN
                            nQtdBon := nQtdBon + 1;
                        END IF;
                        nVenBonNew := (nCFGVlrVenBon * nQtdBon) + (nVenBonNew *(-1));
                        nQtdBon := (nCFGQtdBon * nQtdBon)*(-1);                         
                        INSERT INTO TT_BON ( CODFIL, FILUSU, CODUSU, FILCLI, CODCLI, DATOPE, VLRLAN, TIPBON)
                             VALUES        ( pCODFILNew, pFILUSUNew, pCODUSUNew, pFILPARNew, pCODPARNew, pDATFISNew, nQtdBon, pTIPBON );
                                    
                        UPDATE TT_CLI
                           SET VENBON = nVenBonNew
                         WHERE FILCLI = pFILPARNew
                           AND CODCLI = pCODPARNew;  
                    END IF;
                END IF;
            END IF;
            IF  (( pLANVENOld = 'T' ) AND ( pFINANCOld = 'T' ) OR ( pVLRNOTOld < 0 ))
            AND ( pFLGESTOld <> 'C' )
            AND ( pCODPAROld <> '     0' ) THEN -- Parceiro que não seja Filial
                --Gerar Crédito de Bônus caso o Valor Acumulado de Venda  utrapasse o Valor para Crédito Configurado
                IF ( nVenBonOld >= nCFGVlrVenBon ) THEN 
                    nQtdBon := nCFGQtdBon * TRUNC(nVenBonOld / nCFGVlrVenBon);
                    INSERT INTO TT_BON ( CODFIL, FILUSU, CODUSU, FILCLI, CODCLI, DATOPE, VLRLAN, TIPBON)
                         VALUES        ( pCODFILOld, pFILUSUOld, pCODUSUOld, pFILPAROld, pCODPAROld, pDATFISOld, nQtdBon, pTIPBON );                
                         
                    nVenBonOld := nVenBonOld - ( nCFGVlrVenBon * TRUNC(nVenBonOld / nCFGVlrVenBon));
                    UPDATE TT_CLI
                       SET VENBON = nVenBonOld
                     WHERE FILCLI = pFILPAROld
                       AND CODCLI = pCODPAROld;  
                ELSE
                    -- Gerar Abatimento dos Bônus caso o Valor Acumulado de Venda fique negativo devido a cancelamento/exclusão/devolução
                    IF (nVenBonOld < 0 ) THEN 
                        nVenBonOld := nVenBonOld*(-1);
                        nQtdBon := TRUNC(nVenBonOld / nCFGVlrVenBon);
                        IF ( MOD(nVenBonOld , nCFGVlrVenBon) > 0 ) THEN
                            nQtdBon := nQtdBon + 1;
                        END IF;
                        nVenBonOld := (nCFGVlrVenBon * nQtdBon) + (nVenBonOld *(-1));
                        nQtdBon := (nCFGQtdBon * nQtdBon)*(-1);                        
                        INSERT INTO TT_BON ( CODFIL, FILUSU, CODUSU, FILCLI, CODCLI, DATOPE, VLRLAN, TIPBON)
                             VALUES        ( pCODFILOld, pFILUSUOld, pCODUSUOld, pFILPAROld, pCODPAROld, pDATFISOld, nQtdBon, pTIPBON );
                                    
                        UPDATE TT_CLI
                           SET VENBON = nVenBonOld
                         WHERE FILCLI = pFILPAROld
                           AND CODCLI = pCODPAROld;  
                    END IF;
                END IF;    
            END IF;
        END IF;
    END IF;
    
    IF  ( pSituacao = 'DEL' )
    AND (( pLANVENOld = 'T' ) AND ( pFINANCOld = 'T' ) OR ( pVLRNOTOld < 0 ))
    AND ( pFLGESTOld <> 'C' )
    AND ( pCODPAROld <> '     0' ) THEN -- Parceiro que não seja Filial
        --Gerar Crédito de Bônus caso o Valor Acumulado de Venda  utrapasse o Valor para Crédito Configurado
        IF ( nVenBonOld >= nCFGVlrVenBon ) THEN 
            nQtdBon := nCFGQtdBon * TRUNC(nVenBonOld / nCFGVlrVenBon);
            INSERT INTO TT_BON ( CODFIL, FILUSU, CODUSU, FILCLI, CODCLI, DATOPE, VLRLAN, TIPBON)
                 VALUES        ( pCODFILOld, pFILUSUOld, pCODUSUOld, pFILPAROld, pCODPAROld, pDATFISOld, nQtdBon, pTIPBON );                
                 
            nVenBonOld := nVenBonOld - ( nCFGVlrVenBon * TRUNC(nVenBonOld / nCFGVlrVenBon));
            UPDATE TT_CLI
               SET VENBON = nVenBonOld
             WHERE FILCLI = pFILPAROld
               AND CODCLI = pCODPAROld;  
        ELSE
            -- Gerar Abatimento dos Bônus caso o Valor Acumulado de Venda fique negativo devido a cancelamento/exclusão/devolução
            IF (nVenBonOld < 0 ) THEN 
                nVenBonOld := nVenBonOld*(-1);
                nQtdBon := TRUNC(nVenBonOld / nCFGVlrVenBon);
                IF ( MOD(nVenBonOld , nCFGVlrVenBon) > 0 ) THEN
                    nQtdBon := nQtdBon + 1;
                END IF;
                nVenBonOld := (nCFGVlrVenBon * nQtdBon) + (nVenBonOld *(-1));
                nQtdBon := (nCFGQtdBon * nQtdBon)*(-1);                
                INSERT INTO TT_BON ( CODFIL, FILUSU, CODUSU, FILCLI, CODCLI, DATOPE, VLRLAN, TIPBON)
                     VALUES        ( pCODFILOld, pFILUSUOld, pCODUSUOld, pFILPAROld, pCODPAROld, pDATFISOld, nQtdBon, pTIPBON );
                            
                UPDATE TT_CLI
                   SET VENBON = nVenBonOld
                 WHERE FILCLI = pFILPAROld
                   AND CODCLI = pCODPAROld;  
            END IF;
        END IF;        
    END IF;    
    
  END IF;    
  RETURN null;
END;
$$ language 'plpgsql';




/*-- SEQ 1722 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_WOR_Lanca_Log (tt_wor.codfil%type,tt_wor.sequen%type,VARCHAR,char) CASCADE;

/*-- SEQ 1723 --*/
CREATE OR REPLACE FUNCTION TGR_WOR_Lanca_Log (tt_wor.codfil%type,tt_wor.sequen%type,VARCHAR,char)
RETURNS VARCHAR AS $$
DECLARE
PCodfil ALIAS FOR $1 ;
PSequen ALIAS FOR $2 ;
Mensagem ALIAS FOR $3 ;
Mudanca ALIAS FOR $4 ;
-- Inclui uma linha em TL_WOR
BEGIN
  INSERT into TL_WOR (CODFIL,SEQUEN,MSGLOG,FLGMUD)
  VALUES (pCODFIL,pSEQUEN,mensagem,Mudanca);
  return null;
END;
$$ language 'plpgsql';





/*-- SEQ 1724 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_WOR_Lanca_Mail (TT_WOR.CODFIL%TYPE,TT_WOR.SEQUEN%TYPE,TT_WOR.AVISAR%TYPE,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1725 --*/
CREATE OR REPLACE FUNCTION TGR_WOR_Lanca_Mail (TT_WOR.CODFIL%TYPE,TT_WOR.SEQUEN%TYPE,TT_WOR.AVISAR%TYPE,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
p_CODFIL ALIAS FOR $1 ;
p_SEQUEN ALIAS FOR $2 ;
P_AVISAR ALIAS FOR $3 ;
p_Exclui ALIAS FOR $4 ;
p_Anexos ALIAS FOR $5 ;
p_Mail_to ALIAS FOR $6 ;
p_Mail_cc ALIAS FOR $7 ;
p_Mail_cb ALIAS FOR $8 ;
p_Mail_fr ALIAS FOR $9 ;
p_Texto ALIAS FOR $10 ;
p_LOG ALIAS FOR $11 ;
-- Inclui uma linha em TT_MAI
  c_LF              CHAR(2)            := chr(13)||chr(10);
  c_log VARCHAR(4000);
BEGIN
  IF  (COALESCE(p_MAIL_FR,'Nulo') <> COALESCE(p_MAIL_TO,'Nulo'))
  AND (P_AVISAR <> 'F' )
  AND (p_MAIL_TO <> 'Nulo')
  AND (p_MAIL_FR <> 'Nulo') THEN
    IF COALESCE(p_log,'#_#') = '#_#' then
      c_log := ' ';
    ELSE
      c_log := 'Modificacoes: '|| c_LF || p_log
      || '------------------------------------------------------------------------' || c_LF;
    END IF;
    IF (ISNOTNULL(p_Mail_fr)='T') AND (ISNOTNULL(p_Mail_to)='T') AND (INSTR(p_Mail_fr, UPPER('@sua_empresa.com')) = 0) AND (INSTR(p_Mail_to, UPPER('@sua_empresa.com')) = 0) THEN
       INSERT into TT_MAI(DATSOL, EXCLUI, ANEXOS, MAI_TO, MAI_CC, MAI_CB, MAI_FR, TEXTOS, ASSUNT)
       VALUES (agora(), p_Exclui, p_Anexos, p_Mail_to, p_Mail_cc, p_Mail_cb, p_Mail_fr,p_Texto||c_log ,
               '[TT2000-WorkFlow] Referente tarefa: '||P_CODFIL|| '/' || TRIM(P_SEQUEN) );
    END IF;
  END IF;
  return null;
END;
$$ language 'plpgsql';





/*-- SEQ 1726 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_ZeraSaldoDoVeiculo (TT_LIM.FILCLI%TYPE,TT_LIM.CODCLI%TYPE,TT_LIM.TIPCCC%TYPE) CASCADE;

/*-- SEQ 1727 --*/
CREATE OR REPLACE FUNCTION TGR_ZeraSaldoDoVeiculo (TT_LIM.FILCLI%TYPE,TT_LIM.CODCLI%TYPE,TT_LIM.TIPCCC%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_Filial ALIAS FOR $1 ;
p_Codigo ALIAS FOR $2 ;
p_Tipo ALIAS FOR $3 ;
-- "Zera"
  wk_CC  TT_LIM.TIPCCC%TYPE;
BEGIN
  SELECT CFG.CC_CHECKOUT INTO wk_CC
    FROM TT_CFG CFG;

  IF (wk_CC = p_Tipo) THEN
    UPDATE TT_VEI SET VLRCCC = 0
     WHERE FILCLI = p_Filial
       AND CODCLI = p_Codigo
       AND VLRCCC != 0;
  END IF;
  Return Null;
END;
$$ language 'plpgsql';




/*-- SEQ 1728 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TotalTransferenciaKIT (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TD_MUL.CODTAB%TYPE) CASCADE;

/*-- SEQ 1729 --*/
CREATE OR REPLACE FUNCTION TotalTransferenciaKIT (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TD_MUL.CODTAB%TYPE)
RETURNS Numeric AS $$
DECLARE
dDataIni ALIAS FOR $1 ;
dDataFim ALIAS FOR $2 ;
pFilMat ALIAS FOR $3 ;
pCodMat ALIAS FOR $4 ;
pCodCor ALIAS FOR $5 ;
pCodTam ALIAS FOR $6 ;
pCodFil ALIAS FOR $7 ;
pCodmul ALIAS FOR $8 ;

-----------------------------------------------------------------------------------------------------------------------------------
   --Objetivos: 1 - Realizar a chamada da funo de nvel 3, "TotalTransferencia" para headers de kit. 
-----------------------------------------------------------------------------------------------------------------------------------
   nQtdTra                       Numeric;
   cRetorno                      VARCHAR(254);
   nQtdIte                       TT_KIT.QTDITE%TYPE;
   cFilmat                       TT_GRA.FILMAT%TYPE;
   cCodmat                       TT_GRA.CODMAT%TYPE;
   nCodcor                       TT_GRA.CODCOR%TYPE;
   nCodtam                       TT_GRA.CODTAM%TYPE;
-- Incio da funo
BEGIN
   nQtdTra := 0;

   -- MN - Essa funo  destinada para headers de kit, como o POS no vende headers, somente os itens, deve-se procurar um item de "referncia"
   -- para verificar quantas vendas o item de "referncia" teve e inferir a quantidade de vendas do header do kit.
   SELECT TrazItemReferenciaKit(pFILMAT, pCODMAT, pCODCOR, pCODTAM)
     INTO cRetorno
     FROM DUAL;

   IF COALESCE(cRetorno, 'X') <> 'X' THEN
      cFilmat := Split_Part(cRetorno, ';', 1);
      cCodmat := Split_Part(cRetorno, ';', 2);
      nCodcor := Split_Part_Number(cRetorno, ';', 3);
      nCodtam := Split_Part_Number(cRetorno, ';', 4);
      nQtdIte := Split_Part_Number(cRetorno, ';', 5);

      -- MN - Busca o total de venda pelo item de referncia, depois ainda deve dividir o total, pela quantidade necessria do item de referncia
      -- para formar um kit nico.
      SELECT TotalTransferencia(dDataIni, dDataFim, cFilmat, cCodmat, nCodcor, nCodtam, pCodFil, pCodmul)
        INTO nQtdTra
        FROM DUAL;

      -- MN - A ideia dessa diviso,  que o item referncia,  o item com maior quantidade dentro do kit, ento primeiros
      -- pegamos quantos itens foram vendidos, por exemplo, 2000 unidades do item referncia, agora para sabermos quantos KITS
      -- foram vendidos, devemos dividir a quantidade vendida, pela quantidade necessria para montar UM nico kit.
      IF nQtdIte > 0 THEN
         nQtdTra := nQtdTra / nQtdIte;
      END IF;
   END IF;

   RETURN COALESCE(nQtdTra, 0);

END;
$$ language 'plpgsql';


/*-- SEQ 1730 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TotalTransferenciaKIT (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1731 --*/
CREATE OR REPLACE FUNCTION TotalTransferenciaKIT (Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN TotalTransferenciaKIT($1,$2,$3,$4,$5,$6,$7,null);
END;
$$ language 'plpgsql';


/*-- SEQ 1732 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TotalVendaKIT (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TD_MUL.CODTAB%TYPE,TT_PLA.FILPGT%TYPE,TT_PLA.CODPGT%TYPE,VARCHAR,TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE) CASCADE;

/*-- SEQ 1733 --*/
CREATE OR REPLACE FUNCTION TotalVendaKIT (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TD_MUL.CODTAB%TYPE,TT_PLA.FILPGT%TYPE,TT_PLA.CODPGT%TYPE,VARCHAR,TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE)
RETURNS Numeric AS $$
DECLARE
pDatIni ALIAS FOR $1 ;
pDatFim ALIAS FOR $2 ;
pFilMat ALIAS FOR $3 ;
pCodMat ALIAS FOR $4 ;
pCodCor ALIAS FOR $5 ;
pCodTam ALIAS FOR $6 ;
pCodFil ALIAS FOR $7 ;
pCodmul ALIAS FOR $8 ;
pFilPgt ALIAS FOR $9 ;
pCodPgt ALIAS FOR $10 ;
pTipDia ALIAS FOR $11 ;
pFilCli ALIAS FOR $12 ;
pCodCli ALIAS FOR $13 ;
   -----------------------------------------------------------------------------------------------------------------------------------
   --Objetivos: 1 - Realizar a chamada da funo de nvel 3, "TotalVenda" para headers de kit. 
    -----------------------------------------------------------------------------------------------------------------------------------
   nQtdVen                       Numeric;
   cRetorno                      VARCHAR(254);
   nQtdIte                       TT_KIT.QTDITE%TYPE;
   cFilmat                       TT_GRA.FILMAT%TYPE;
   cCodmat                       TT_GRA.CODMAT%TYPE;
   nCodcor                       TT_GRA.CODCOR%TYPE;
   nCodtam                       TT_GRA.CODTAM%TYPE;
-- Incio da funo
BEGIN
   nQtdVen := 0;

   -- MN - Essa funo  destinada para headers de kit, como o POS no vende headers, somente os itens, deve-se procurar um item de "referncia"
   -- para verificar quantas vendas o item de "referncia" teve e inferir a quantidade de vendas do header do kit.
   SELECT TrazItemReferenciaKit(pFILMAT, pCODMAT, pCODCOR, pCODTAM)
     INTO cRetorno
     FROM DUAL;

   IF COALESCE(cRetorno, 'X') <> 'X' THEN
      cFilmat := Split_Part(cRetorno, ';', 1);
      cCodmat := Split_Part(cRetorno, ';', 2);
      nCodcor := Split_Part_Number(cRetorno, ';', 3);
      nCodtam := Split_Part_Number(cRetorno, ';', 4);
      nQtdIte := Split_Part_Number(cRetorno, ';', 5);

      -- MN - Busca o total de venda pelo item de referncia, depois ainda deve dividir o total, pela quantidade necessria do item de referncia
      -- para formar um kit nico.
      SELECT TotalVenda(pDatIni, pDatFim, cFilmat, cCodmat, nCodcor, nCodtam, pCODFIL, pCODMUL, pFilPgt, pCodPgt, pTipDia, pFilCli, pCodCli)
        INTO nQtdVen
        FROM DUAL;

      -- MN - A ideia dessa diviso,  que o item referncia,  o item com maior quantidade dentro do kit, ento primeiros
      -- pegamos quantos itens foram vendidos, por exemplo, 2000 unidades do item referncia, agora para sabermos quantos KITS
      -- foram vendidos, devemos dividir a quantidade vendida, pela quantidade necessria para montar UM nico kit.
      IF nQtdIte > 0 THEN
         nQtdVen := nQtdVen / nQtdIte;
      END IF;
   END IF;

   RETURN COALESCE(nQtdVen, 0);
END;
$$ language 'plpgsql';


/*-- SEQ 1734 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TotalVendaKIT (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1735 --*/
CREATE OR REPLACE FUNCTION TotalVendaKIT (Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN TotalVendaKIT($1,$2,$3,$4,$5,$6,$7,null,null,null,null,null,null);
END;
$$ language 'plpgsql';


/*-- SEQ 1736 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TotalVendaKIT (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TD_MUL.CODTAB%TYPE) CASCADE;

/*-- SEQ 1737 --*/
CREATE OR REPLACE FUNCTION TotalVendaKIT (Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR,
                               TD_MUL.CODTAB%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN TotalVendaKIT($1,$2,$3,$4,$5,$6,$7,$8,null,null,null,null,null);
END;
$$ language 'plpgsql';


/*-- SEQ 1738 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TotalVendaKIT (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TD_MUL.CODTAB%TYPE,TT_PLA.FILPGT%TYPE,TT_PLA.CODPGT%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1739 --*/
CREATE OR REPLACE FUNCTION TotalVendaKIT (Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR,
                               TD_MUL.CODTAB%TYPE,
                               TT_PLA.FILPGT%TYPE,
                               TT_PLA.CODPGT%TYPE,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN TotalVendaKIT($1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,null,null);
END;
$$ language 'plpgsql';


/*-- SEQ 1740 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AjustaEstoqueLegal (Timestamp,TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 1741 --*/
CREATE OR REPLACE FUNCTION AjustaEstoqueLegal (Timestamp,TD_FIL.CODFIL%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pDataEstoqueInicial ALIAS FOR $1 ;
pCODFIL ALIAS FOR $2 ;
-- Objetivo:
-- 1) Ajustar o estoque legal de acordo com os dados da tabela de saldo (TT_SAL).

-- Parmetros:
-- pDataEstoqueInicial: Data DD/MM/YYYY a ser considerada como data inicial do estoque
-- pCODFIL: Cdigo da filial. Se for nulo ele executa para todas as filiais

  WK_RETORNO    VARCHAR(200);
  WK_DATA_INI   Timestamp;
  WK_USERID     Numeric;
  cTEMP         TT_FUN.NOMFUN%TYPE;
  WK_CODFIL     TD_FIL.CODFIL%TYPE;
BEGIN

  -- Inicializa
  WK_RETORNO          := '';
  WK_DATA_INI         := TRUNC(pDataEstoqueInicial);
  WK_USERID           := USERENV('SESSIONID');
  IF ISNULL(pCODFIL) = 'T' THEN
    WK_CODFIL := NULL;
  ELSE
    WK_CODFIL := pCODFIL;
  END IF;

  -- Garantia de exclusividade para este processo
  SELECT NOMFUN INTO cTEMP
    FROM TT_FUN
   WHERE NOMFUN = 'LOCK_SAL'
     FOR UPDATE;

  -- Insere dados temporrios de custo mdio, custo de reposio e saldo na data
  INSERT INTO TW_SAL
    (USERID, CODFIL, SEQUEN, FILMAT, CODMAT, CODCOR, CODTAM, CODMUL, VLR_CM_UNI, VLRCMG_UNI, CUSREP, SALDO)
  SELECT WK_USERID AS USERID,
         SAL.CODFIL, SAL.SEQUEN, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, SAL.CODMUL,
         COALESCE(CustoMedio(SAL.CODFIL, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, '3', WK_DATA_INI),0) AS VLR_CM_UNI,
         --CASE WHEN COALESCE(SAL.QTD_CM,0) = 0 THEN 0 ELSE COALESCE(SAL.VLR_CM/SAL.QTD_CM,0) END AS VLR_CM_UNI,
         COALESCE(CustoMedio(SAL.CODFIL, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, '5', WK_DATA_INI),0) AS VLRCMG_UNI,
         --CASE WHEN COALESCE(SAL.QTD_CM,0) = 0 THEN 0 ELSE COALESCE(SAL.VLRCMG/SAL.QTD_CM,0) END AS VLRCMG_UNI,
         COALESCE((SELECT GRA.CUSREP
                     FROM TT_GRA GRA
                    WHERE GRA.FILMAT = SAL.FILMAT
                      AND GRA.CODMAT = SAL.CODMAT
                      AND GRA.CODCOR = SAL.CODCOR
                      AND GRA.CODTAM = SAL.CODTAM),0) AS CURREP,
         COALESCE(SaldoDaFilial(WK_DATA_INI, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, SAL.CODFIL, SAL.CODMUL),0) AS SALDO
    FROM TT_SAL SAL
   WHERE SAL.CODMUL = 0
     AND SAL.CODFIL = COALESCE(WK_CODFIL,SAL.CODFIL)
     AND COALESCE(SAL.INI_CM,WK_DATA_INI) <= WK_DATA_INI;

  -- Atualiza a SAL em Oracle (UPDATE COM nRETORNOS)
  
   -- Atualiza a SAL em PostgreSQL (UPDATE FROM)
  
  UPDATE TT_SAL SAL
     SET CAL_CM = NULL,
         ATU_CM = 'F',
         QTD_CM = WRK.SALDO,
         VLR_CM = CASE WHEN WRK.VLR_CM_UNI = 0 THEN WRK.CUSREP ELSE WRK.VLR_CM_UNI END * WRK.SALDO,
         INI_CM = WK_DATA_INI,
         VLRCMG = CASE WHEN WRK.VLRCMG_UNI = 0 THEN WRK.CUSREP ELSE WRK.VLRCMG_UNI END * WRK.SALDO
    FROM TW_SAL WRK
   WHERE SAL.CODMUL = 0
     AND WRK.CODFIL = SAL.CODFIL
     AND WRK.SEQUEN = SAL.SEQUEN
     AND WRK.USERID = WK_USERID;
  
  -- Esvazia tabela temporria
  DELETE FROM TW_SAL WRK
   WHERE WRK.USERID = WK_USERID;

  WK_RETORNO := 'OK';
  RETURN WK_RETORNO;

END;
$$ language 'plpgsql';




/*-- SEQ 1742 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION BI_LUCBRU (TT_VEN.CODFIL%TYPE,TT_VEN.VLRLIQ%TYPE,TT_VEN.VLRNOT%TYPE,TT_IVE.VLRMOV%TYPE,TT_IVE.QTDMOV%TYPE,TT_IVE.QTDMPB%TYPE,TT_IVE.VLR001%TYPE,TT_IVE.TOT_CM%TYPE,TT_IVE.LANEST%TYPE,TT_IVE.SAL_CM%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE,TT_IVE.VEN_DATHOR%TYPE,TT_IVE.PERPIS%TYPE,TT_IVE.PERCOF%TYPE) CASCADE;

/*-- SEQ 1743 --*/
CREATE OR REPLACE FUNCTION BI_LUCBRU (TT_VEN.CODFIL%TYPE,TT_VEN.VLRLIQ%TYPE,TT_VEN.VLRNOT%TYPE,TT_IVE.VLRMOV%TYPE,TT_IVE.QTDMOV%TYPE,TT_IVE.QTDMPB%TYPE,TT_IVE.VLR001%TYPE,TT_IVE.TOT_CM%TYPE,TT_IVE.LANEST%TYPE,TT_IVE.SAL_CM%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE,TT_IVE.VEN_DATHOR%TYPE,TT_IVE.PERPIS%TYPE,TT_IVE.PERCOF%TYPE)
RETURNS Numeric AS $$
DECLARE
pVEN_CODFIL ALIAS FOR $1 ;
pVEN_VLRLIQ ALIAS FOR $2 ;
pVEN_VLRNOT ALIAS FOR $3 ;
pIVE_VLRMOV ALIAS FOR $4 ;
pIVE_QTDMOV ALIAS FOR $5 ;
pIVE_QTDMPB ALIAS FOR $6 ;
pIVE_VLRICM ALIAS FOR $7 ;
pIVE_TOT_CM ALIAS FOR $8 ;
pIVE_LANEST ALIAS FOR $9 ;
pIVE_SAL_CM ALIAS FOR $10 ;
pIVE_FILMAT ALIAS FOR $11 ;
pIVE_CODMAT ALIAS FOR $12 ;
pIVE_CODCOR ALIAS FOR $13 ;
pIVE_CODTAM ALIAS FOR $14 ;
pIVE_VEN_DATHOR ALIAS FOR $15 ;
pIVE_PERPIS ALIAS FOR $16 ;
pIVE_PERCOF ALIAS FOR $17 ;
/* 
 * Objetivo: Calcular Lucro Bruto em expresso do BI
 * ("Valor Lquido " + "Valor MpBem")  - ( "ICMS" + "Pis/Confis" + "CM Fiscal") 
 */
  wk_ValorLiquido Numeric(12,2);
  wk_ValorMpBem   Numeric(12,2);
  wk_ICMS         Numeric(12,2);
  wk_PisCofins    Numeric(12,2);
  wk_CMFiscal     Numeric(12,2);
  wk_Resultado    Numeric(12,2);
BEGIN
   --RETURN ((COALESCE(pVEN_VLRLIQ,0) * (CASE pVEN_VLRNOT WHEN 0 THEN 0 ELSE pIVE_VLRMOV / pVEN_VLRNOT END))+(((COALESCE(pVEN_VLRLIQ,0) * (CASE pVEN_VLRNOT WHEN 0 THEN 0 ELSE pIVE_VLRMOV / pVEN_VLRNOT / pIVE_QTDMOV END)) * COALESCE(pIVE_QTDMPB,0)) * ((COALESCE(pIVE_PERPIS,0)+COALESCE(pIVE_PERCOF,0)) /100))) - 
   --  (COALESCE(pIVE_TAXICM,0)+((COALESCE(pVEN_VLRLIQ,0) * (CASE pVEN_VLRNOT WHEN 0 THEN 0 ELSE pIVE_VLRMOV / pVEN_VLRNOT END)) * ((COALESCE(pIVE_PERPIS,0)+COALESCE(pIVE_PERCOF,0)) /100))+(CASE WHEN ((pIVE_TOT_CM IS NULL) AND (pIVE_LANEST <> 'N')) OR COALESCE(pIVE_SAL_CM,0) = 0 THEN CUSTOMEDIO(pVEN_CODFIL,pIVE_FILMAT,pIVE_CODMAT,pIVE_CODCOR,pIVE_CODTAM,3,pIVE_VEN_DATHOR) ELSE pIVE_TOT_CM / pIVE_SAL_CM END * pIVE_QTDMOV));
  wk_ValorLiquido := COALESCE(pVEN_VLRLIQ,0) * (CASE pVEN_VLRNOT WHEN 0 THEN  0 ELSE pIVE_VLRMOV / pVEN_VLRNOT END); 
  wk_ValorMpBem   := BI_VLRMPB(pVEN_CODFIL,pVEN_VLRLIQ,pVEN_VLRNOT,pIVE_VLRMOV,pIVE_QTDMOV,pIVE_QTDMPB,pIVE_PERPIS,pIVE_PERCOF);
  wk_ICMS         := COALESCE(pIVE_VLRICM,0);  
  wk_PisCofins    := BI_VLRPISCOF(pVEN_CODFIL,pVEN_VLRLIQ,pVEN_VLRNOT,pIVE_VLRMOV,pIVE_PERPIS,pIVE_PERCOF);
  wk_CMFiscal     := (CASE WHEN ((pIVE_TOT_CM IS NULL) AND (pIVE_LANEST <> 'N')) OR COALESCE(pIVE_SAL_CM,0) = 0 THEN CUSTOMEDIO(pVEN_CODFIL,pIVE_FILMAT,pIVE_CODMAT,pIVE_CODCOR,pIVE_CODTAM,3,pIVE_VEN_DATHOR) ELSE pIVE_TOT_CM / pIVE_SAL_CM END * pIVE_QTDMOV);
  wk_Resultado    := (wk_ValorLiquido + wk_ValorMpBem) - (wk_ICMS + wk_PisCofins + wk_CMFiscal);
  RETURN wk_Resultado;
END;
$$ language 'plpgsql';




/*-- SEQ 1744 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalculaPontoDePedidoKIT (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,Numeric,TT_PXF.MEDENT%TYPE,Numeric,INTEGER,TD_MUL.CODTAB%TYPE,VARCHAR,TT_IVE.PROMOC%TYPE) CASCADE;

/*-- SEQ 1745 --*/
CREATE OR REPLACE FUNCTION CalculaPontoDePedidoKIT (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,Numeric,TT_PXF.MEDENT%TYPE,Numeric,INTEGER,TD_MUL.CODTAB%TYPE,VARCHAR,TT_IVE.PROMOC%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pDatIni ALIAS FOR $1 ;
pDatFim ALIAS FOR $2 ;
pFilMat ALIAS FOR $3 ;
pCodMat ALIAS FOR $4 ;
pCodCor ALIAS FOR $5 ;
pCodTam ALIAS FOR $6 ;
pCodFil ALIAS FOR $7 ;
pEstSeg ALIAS FOR $8 ;
pMedent ALIAS FOR $9 ;
pABCXYZ ALIAS FOR $10 ;
pTipoProjecao ALIAS FOR $11 ;
pCodmul ALIAS FOR $12 ;
pTipDia ALIAS FOR $13 ;
pPromoc ALIAS FOR $14 ;

   cResult                       VARCHAR(500);
   nQtdMinVen                    TT_IVE.QTDMOV%TYPE; -- var para quantidade minima diária vendida
   nQtdMaxVen                    TT_IVE.QTDMOV%TYPE; -- var para quantidade máxima diária vendida    
   nQtdTotVen                    TT_IVE.QTDMOV%TYPE; -- var para Total de vendas
   nMedVen                       Numeric;               -- var para Média de vendas
   nDesVen                       Numeric;               -- var para Desvio de Vendas
   nPonPed                       Numeric;               -- var para Ponto do pedido 
   nLotCom                       Numeric;               -- var para Lote de Compra
   nQtdMax                       Numeric;               -- var para Quantidade Máxima
   nTotDia                       INTEGER;            -- totalizador da quant. de dias 

   cRetorno                      VARCHAR(254);
   nQtdIte                       TT_KIT.QTDITE%TYPE;
   cFilmat                       TT_GRA.FILMAT%TYPE;
   cCodmat                       TT_GRA.CODMAT%TYPE;
   nCodcor                       TT_GRA.CODCOR%TYPE;
   nCodtam                       TT_GRA.CODTAM%TYPE;
-- Início da função
BEGIN
   cResult := '';

   -- MN - Essa função é destinada para headers de kit, como o POS não vende headers, somente os itens, deve-se procurar um item de "referência"
   -- para verificar quantas vendas o item de "referência" teve e inferir a quantidade de vendas do header do kit.
   SELECT TrazItemReferenciaKit(pFILMAT, pCODMAT, pCODCOR, pCODTAM)
     INTO cRetorno
     FROM DUAL;

   IF COALESCE(cRetorno, 'X') <> 'X' THEN
      cFilmat := Split_Part(cRetorno, ';', 1);
      cCodmat := Split_Part(cRetorno, ';', 2);
      nCodcor := Split_Part_Number(cRetorno, ';', 3);
      nCodtam := Split_Part_Number(cRetorno, ';', 4);
      nQtdIte := Split_Part_Number(cRetorno, ';', 5);

      -- MN - Busca o total de venda pelo item de referência, depois ainda deve dividir o total, pela quantidade necessária do item de referência
      -- para formar um kit ùnico.
      SELECT CalculaPontoDePedido(pDatIni, pDatFim, cFilmat, cCodmat, nCodcor, nCodtam, pCodFil,
                                  pEstSeg, pMedent, pABCXYZ, pTipoProjecao,
                                  pCodmul, pTipDia, pPromoc)
        INTO cResult
        FROM DUAL;

      nQtdMinVen := Split_Part_Number(cResult, ';', 1);
      nQtdMaxVen := Split_Part_Number(cResult, ';', 2);
      nQtdTotVen := Split_Part_Number(cResult, ';', 3);
      nMedVen    := Split_Part_Number(cResult, ';', 4);
      nDesVen    := Split_Part_Number(cResult, ';', 5);
      nPonPed    := Split_Part_Number(cResult, ';', 6);
      nLotCom    := Split_Part_Number(cResult, ';', 7);
      nQtdMax    := Split_Part_Number(cResult, ';', 8);
      nTotDia    := Split_Part_Number(cResult, ';', 9);

      nQtdMinVen := nQtdMinVen / nQtdIte;
      nQtdMaxVen := nQtdMaxVen / nQtdIte;
      nQtdTotVen := nQtdTotVen / nQtdIte;
      nMedVen    := nMedVen    / nQtdIte;
      nDesVen    := nDesVen    / nQtdIte;
      nPonPed    := nPonPed    / nQtdIte;
      nLotCom    := nLotCom    / nQtdIte;
      nQtdMax    := nQtdMax    / nQtdIte;
      nTotDia    := nTotDia    / nQtdIte;

      cResult := -- quantidade minima vendida
                 TO_CHAR(COALESCE(nQtdMinVen, 0), '000000000000000.0000') || ';' ||
                 -- quantidade máxima vendida
                 TO_CHAR(COALESCE(nQtdMaxVen, 0), '000000000000000.0000') || ';' ||
                 -- quantidade de Total de vendas
                 TO_CHAR(COALESCE(nQtdTotVen, 0), '000000000000000.0000') || ';' ||
                 -- média de vendas
                 TO_CHAR(COALESCE(nMedVen, 0), '000000000000000.0000') || ';' ||
                 -- desvio de Vendas
                 TO_CHAR(COALESCE(nDesVen, 0), '000000000000000.0000') || ';' ||
                 -- Ponto do pedido
                 TO_CHAR(COALESCE(nPonPed, 0), '000000000000000.0000') || ';' ||
                 -- Lote de Compra
                 TO_CHAR(COALESCE(nLotCom, 0), '000000000000000.0000') || ';' ||
                 -- Quantidade Máxima
                 TO_CHAR(COALESCE(nQtdMax, 0), '000000000000000.0000') || ';' ||
                 -- total de dias do periodo
                 TO_CHAR(COALESCE(nTotDia, 0), '000000') || ';'
                 ;

   END IF;
   
   RETURN cResult;

END;
$$ language 'plpgsql';


/*-- SEQ 1746 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalculaPontoDePedidoKIT (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,Numeric(14,4),TT_PXF.MEDENT%TYPE,Numeric(3),INTEGER) CASCADE;

/*-- SEQ 1747 --*/
CREATE OR REPLACE FUNCTION CalculaPontoDePedidoKIT (Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR,
                               Numeric(14,4),
                               TT_PXF.MEDENT%TYPE,
                               Numeric(3),
                               INTEGER) 
RETURNS VARCHAR AS $$
BEGIN
RETURN CalculaPontoDePedidoKIT($1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,null,'C','T');
END;
$$ language 'plpgsql';


/*-- SEQ 1748 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DesativaProdutosAntigos (Numeric,Numeric,Numeric) CASCADE;

/*-- SEQ 1749 --*/
CREATE OR REPLACE FUNCTION DesativaProdutosAntigos (Numeric,Numeric,Numeric)
RETURNS VARCHAR AS $$
DECLARE
pDiasSemVenda ALIAS FOR $1 ;
pDiasCadastrado ALIAS FOR $2 ;
pDiasSemCompra ALIAS FOR $3 ;

-- Objetivos:
-- 1. Desativar produtos antigos.

-- Parmetros:
-- pDiasSemVenda: Passar quantos dias sem venda devem ser considerados.
-- pDiasCadastrado: Passar h quantos dias o produto deve ter sido cadastrado.
-- pDiasSemCompra: Passar quantos dias sem compra devem ser considerados.

-- Declarao de variveis e cursores 
   cManut                        TT_IDF.MANUT%TYPE;
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('complemento');

-- Incio da funo
BEGIN
   SELECT MANUT INTO cManut
     FROM TT_IDF;

   IF cManut = 'T' THEN
      RAISE EXCEPTION 'PG-20010 Base em manuteno. %' , COMPLEMENTO;
   END IF;

   UPDATE TT_PRO
      SET SIGNAT = SIGNAT * -1
    WHERE (FILMAT,CODMAT) IN (SELECT TAB.FILMAT, TAB.CODMAT 
                                FROM (SELECT GRA.FILMAT,
                                             GRA.CODMAT,
                                             MAX(PRO.DATCAD) AS DATCAD,
                                             MAX(GRA.DATCOM) AS DATCOM,
                                             COALESCE(SUM(SAL.QTDEST),0) AS QTDEST,
                                             MAX(ULTIMADATAVENDA(SAL.CODFIL,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM)) AS ULTVEN,
                                             MAX(PEDIDOPENDENTE(SAL.CODFIL,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM)) as PEDPEN
                                        FROM TT_GRA GRA INNER JOIN TT_PRO PRO ON GRA.FILMAT = PRO.FILMAT
                                                                             AND GRA.CODMAT = PRO.CODMAT
                                                        INNER JOIN TT_SAL SAL ON GRA.FILMAT = SAL.FILMAT
                                                                             AND GRA.CODMAT = SAL.CODMAT
                                                                             AND GRA.CODCOR = SAL.CODCOR
                                                                             AND GRA.CODTAM = SAL.CODTAM
                                       WHERE PRO.SIGNAT > 0
                                       GROUP BY GRA.FILMAT, GRA.CODMAT) TAB
                               WHERE (TAB.ULTVEN IS NULL OR TRUNC(TAB.ULTVEN) < TRUNC(Add_day(Agora(),-pDiasSemVenda)))
                                 AND (TAB.DATCOM IS NULL OR TRUNC(TAB.DATCOM) < TRUNC(Add_day(Agora(),-pDiasSemCompra)))                               
                                 AND (TRUNC(TAB.DATCAD) < TRUNC(Add_day(Agora(),-pDiasCadastrado)))
                                 AND TAB.PEDPEN = 0
                                 AND TAB.QTDEST <= 0);
   RETURN 'OK';

END;
$$ language 'plpgsql';




/*-- SEQ 1750 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION EstoqueCustoMedio (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_SAL.CODFIL%TYPE,TT_SAL.CODMUL%TYPE) CASCADE;

/*-- SEQ 1751 --*/
CREATE OR REPLACE FUNCTION EstoqueCustoMedio (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TT_SAL.CODFIL%TYPE,TT_SAL.CODMUL%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pDatIni ALIAS FOR $1 ;
pDatFim ALIAS FOR $2 ;
pFilMat ALIAS FOR $3 ;
pCodMat ALIAS FOR $4 ;
pCodCor ALIAS FOR $5 ;
pCodTam ALIAS FOR $6 ;
pCodFil ALIAS FOR $7 ;
pCodMul ALIAS FOR $8 ;
--  --------------------------------------------------------
--  Objetivos:
--  Função que calcula a quantidade vendida, o valor vendido e cmv do período
--
--  Nota: utilize as funções spli_part() e split_part_null() para utilizar o
--        resultado desta função de maneira mais amigável.
--        http://intra.totall.com.br:8080/wiki/index.php/Split_part
--  --------------------------------------------------------
--  vars e cursores
    vResult         VARCHAR(4000);      --  resultado da função
    cTipo           CHAR(1);            --  tipo
    iDiaTot         INTEGER;            --  total dos dias
    iDiaInterv      INTEGER;            --  dias do intervalo
    bPrimeiro       BOOLEAN;            --  primeiro...
    dDatMov         TR_MOV.DATMOV%TYPE; --  Timestamp
    dDatMovAnt      TR_MOV.DATMOV%TYPE; --  Timestamp: anterior
    nSal_CM         TR_MOV.SAL_CM%TYPE; --  Numeric(16,4)
    nVlr_CM         TR_MOV.VLR_CM%TYPE; --  Numeric(16,4)
    nSal_CMAnt      TR_MOV.SAL_CM%TYPE; --  Numeric(16,4): anterior
    nVlr_CMAnt      TR_MOV.VLR_CM%TYPE; --  Numeric(16,4): anterior
    nSal_CMTot      TR_MOV.SAL_CM%TYPE; --  Numeric(16,4): total
    nVlr_CMTot      TR_MOV.VLR_CM%TYPE; --  Numeric(16,4): total
    nSal_CmMed      TR_MOV.SAL_CM%TYPE; --  Numeric(16,4): médio
    nVlr_CMMed      TR_MOV.VLR_CM%TYPE; --  Numeric(16,4): médio
    nVlr_CMMedUni   TR_MOV.VLR_CM%TYPE; --  Numeric(16,4): médio unitário
    nSal_CMIni      TR_MOV.SAL_CM%TYPE; --  Numeric(16,4): inicial
    nVlr_CMIni      TR_MOV.VLR_CM%TYPE; --  Numeric(16,4): inicial
    --  cursor dos movimentos
    crMov CURSOR FOR
      select Cast('1' as CHAR(1)) as TIPO, 
             pDatIni as DATMOV,
             Round(Coalesce(CustoMedio(pCodFil, pFilMat, pCodMat, pCodCor, pCodTam, 1, pDatIni), 0), 3) as SAL_CM,
             Round(Coalesce(CustoMedio(pCodFil, pFilMat, pCodMat, pCodCor, pCodTam, 2, pDatIni), 0), 3) as VLR_CM
        from DUAL
       where pDatIni < 
             (select Min(DATMOV)
                from TR_MOV
               where CODFIL = pCodFil
                 and FILMAT = pFilMat
                 and CODMAT = pCodMat
                 and CODCOR = pCodCor
                 and CODTAM = pCodTam
                 and CODMUL = pCodMul
                 and DATMOV between pDatIni and pDatFim
             )
      union  all
      select Cast('2' as CHAR(1)) as TIPO,
             RMOV.DATMOV,
             Coalesce(RMOV.SAL_CM, 0) as SAL_CM,
             Coalesce(RMOV.VLR_CM, 0) as VLR_CM       
        from TR_MOV RMOV 
       where RMOV.CODFIL = pCodFil
         and RMOV.FILMAT = pFilMat
         and RMOV.CODMAT = pCodMat
         and RMOV.CODCOR = pCodCor
         and RMOV.CODTAM = pCodTam
         and RMOV.CODMUL = pCodMul
         and RMOV.DATMOV between pDatIni and pDatFim 
      union  all                                                                                               
      select Cast('3' as CHAR(1)) as TIPO,
             pDatFim as DATMOV,
             0 as SAL_CM,
             0 as VLR_CM          
        from DUAL
       where not exists
             (select 1 as OK
                from TR_MOV RMOV 
               where RMOV.CODFIL = pCodFil
                 and RMOV.FILMAT = pFilMat
                 and RMOV.CODMAT = pCodMat
                 and RMOV.CODCOR = pCodCor
                 and RMOV.CODTAM = pCodTam
                 and RMOV.CODMUL = pCodMul
                 and RMOV.DATMOV = pDatFim
             )
    ;
--  --------------------------------------------------------
begin
    --  inicializando vars
    iDiaTot       := IntervaloDias(pDatFim, pDatIni) + 1;
    dDatMovAnt    := ADD_DAY(pDatIni, -1);
    nSal_CMAnt    := 0;
    nVlr_CMAnt    := 0;    
    nSal_CMTot    := 0;
    nVlr_CMTot    := 0; 
    nVlr_CMMedUni := 0;   
    bPrimeiro     := True;
    --  percorrendo todo o cursor
    open crMov;
    loop
        fetch crMov into cTipo, dDatMov, nSal_CM, nVlr_CM;
        exit when NOT FOUND;
		if  bPrimeiro then
            bPrimeiro  := false;
            nSal_CMIni := nSal_CM;
            nVlr_CMIni := nVlr_CM;	
		end if;
        iDiaInterv := IntervaloDias(dDatMov, dDatMovAnt);
        -- Antes de comecar o processamento do registro atual, verificamos se estao
        -- faltando dias entre data atual e a anterior.
        -- Se estiver, processamos os dias que estao faltando com os dados do dia anterior.
        if  iDiaInterv > 1 then
            nSal_CMTot := nSal_CMTot + (nSal_CMAnt * (iDiaInterv - 1));
            nVlr_CMTot := nVlr_CMTot + (nVlr_CMAnt * (iDiaInterv - 1));
            -- raise notice 'Dia % % % %', dDatMovAnt, nSal_CMAnt, nVlr_CMAnt, iDiaInterv-1;                     
        end if;
        -- O tipo 3 define que a TR_MOV atual nao existe. É apenas um registro para
        -- termos a data para comparar o intervalo.
        -- Utilizamos os valores anteriores para calcular esse registro.
        -- Por isso, tambem, nao atualizamos os dados anteriores.
        if  cTipo = '3' then 
            nSal_CMTot := nSal_CMTot + nSal_CMAnt;
            nVlr_CMTot := nVlr_CMTot + nVlr_CMAnt;
        else
            nSal_CMTot := nSal_CMTot + nSal_CM;
            nVlr_CMTot := nVlr_CMTot + nVlr_CM;
            dDatMovAnt := dDatMov;
            nSal_CMAnt := nSal_CM;
            nVlr_CMAnt := nVlr_CM;
        end if;
    end loop;
    close crMov;
    -- calculando as médias
    nSal_CmMed    := Nvlz(nSal_CMTot, 0.0001) / Nvlz(iDiaTot, 1);
    nVlr_CMMed    := Nvlz(nVlr_CMTot, 0.0001) / Nvlz(iDiaTot, 1);
    nVlr_CMMedUni := nVlr_CMTot / Nvlz(nSal_CMTot, 1);
    -- gerando o resultado em uma string
    vResult := Trim(to_char(nVlr_CMMedUni, '999999999.9999')) || ';' || -- Custo Medio Unitario do Periodo   
               Trim(to_char(nVlr_CMMed, '999999999.9999'))    || ';' || -- Custo Medio Total do Periodo 
               Trim(to_char(nVlr_CMAnt / Nvlz(nSal_CMAnt,1),'999999999.9999'))  || ';' || -- Custo Unitario do Ultimo Dia Periodo
               Trim(to_char(nSal_CmMed, '999999999.9999'))    || ';' || -- Quantidade Medio Periodo
               Trim(to_char(nSal_CMAnt, '999999999.9999'))    || ';' || -- Quantidade do Ultimo Dia Periodo    
               Trim(to_char(nSal_CMIni, '999999999.9999'))    || ';' || -- nSal_CMIni 
               Trim(to_char(nVlr_CMIni, '999999999.9999'));                        -- nVlr_CMIni  
    --  --------------------------------------------------------
    return vResult;  
END;
$$ language 'plpgsql';




/*-- SEQ 1752 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ATUALIZAMOV (TR_MOV.CODFIL%TYPE,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,TR_MOV.CODMUL%TYPE,CHAR) CASCADE;

/*-- SEQ 1753 --*/
CREATE OR REPLACE FUNCTION ATUALIZAMOV (TR_MOV.CODFIL%TYPE,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,TR_MOV.CODMUL%TYPE,CHAR)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pFILMAT ALIAS FOR $2 ;
pCODMAT ALIAS FOR $3 ;
pCODCOR ALIAS FOR $4 ;
pCODTAM ALIAS FOR $5 ;
pCODMUL ALIAS FOR $6 ;
pAtualizaSaldo ALIAS FOR $7 ;

vMOVEST CHAR(1);

BEGIN
  BEGIN
	SELECT MOVEST
      INTO vMOVEST
      FROM TT_SAL SAL  
     WHERE SAL.FILMAT = pFILMAT
       AND SAL.CODMAT = pCODMAT
       AND SAL.CODCOR = pCODCOR
       AND SAL.CODTAM = pCODTAM
       AND SAL.CODFIL = pCODFIL
       AND SAL.CODMUL = pCODMUL;
    END;
  
IF vMOVEST IS NULL THEN
   vMOVEST:= 'F';
END IF;

UPDATE TR_MOV 
   SET salant = -99999999
 WHERE CODFIL = pCODFIL
   AND FILMAT = pFILMAT
   AND CODMAT = pCODMAT
   AND CODCOR = pCODCOR
   AND CODTAM = pCODTAM
   AND CODMUL = pCODMUL;

DELETE
  FROM TR_MOV 
 WHERE CODFIL = pCODFIL
   AND FILMAT = pFILMAT
   AND CODMAT = pCODMAT
   AND CODCOR = pCODCOR
   AND CODTAM = pCODTAM
   AND CODMUL = pCODMUL;
        
IF vMOVEST = 'T' THEN
 INSERT INTO TR_MOV (CODFIL, 
                     SEQUEN,
                     FILMAT,
                     CODMAT,
                     CODCOR,
                     CODTAM,
                     DATMOV,
                     SALANT,
                     QTDVEN,
                     QTDCOM,
                     QTDOUT,
                     VLRVEN,
                     VLRCOM,
                     VLROUT,
                     VLR_CM,
                     VLRCMG,
                     SAL_CM,
                     VENFIS,
                     VENFIN,
                     CODMUL,
                     DESCOM,
                     NUMVEN)
(
SELECT CODFIL,
       PROXIMOCODIGO('TR_MOV',CODFIL) AS SEQUEN,
       FILMAT, CODMAT, CODCOR, CODTAM, DATMOV, 
       0           AS SALANT,
       SUM(COALESCE(QTDVEN,0)) AS QTDVEN,
       SUM(COALESCE(QTDCOM,0)) AS QTDCOM,
       SUM(COALESCE(QTDOUT,0)) AS QTDOUT,
       SUM(COALESCE(VLRVEN,0)) AS VLRVEN,
       SUM(COALESCE(VLRCOM,0)) AS VLRCOM,
       SUM(COALESCE(VLROUT,0)) AS VLROUT,
       SUM(COALESCE(VLR_CM,0)) AS VLR_CM,
       SUM(COALESCE(VLRCMG,0)) AS VLRCMG,
       SUM(COALESCE(SAL_CM,0)) AS SAL_CM,
       SUM(COALESCE(VENFIS,0)) AS VENFIS,
       SUM(COALESCE(VENFIN,0)) AS VENFIN,
       CODMUL,
       0 AS DESCOM,
       -- RFMP Ao modificar esse update, verificar tambm ContarNumeroVendas
       (SELECT COUNT( DISTINCT IVE.SEQUEN )
                             FROM TT_IVE IVE INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL
                                                                  AND VEN.SEQUEN = IVE.SEQUEN
                            WHERE IVE.VEN_DATHOR >= TAB.DATMOV
                              AND IVE.VEN_DATHOR <= ADD_DAY(TAB.DATMOV,1)
                              AND IVE.CODFIL = TAB.CODFIL
                              AND IVE.FILMAT = TAB.FILMAT
                              AND IVE.CODMAT = TAB.CODMAT
                              AND IVE.CODCOR = TAB.CODCOR
                              AND IVE.CODTAM = TAB.CODTAM
                              AND IVE.LANEST IN ('S','C')
                              AND IVE.SITKIT IN ('2','3')
                              AND IVE.SITMOV = 'N'
                              AND VEN.LANVEN = 'T'
                              AND VEN.NUMNOT NOT LIKE '%#%') AS NUMVEN
FROM (SELECT LAN.CODFIL, LAN.FILMAT, LAN.CODMAT, LAN.CODCOR, LAN.CODTAM, TRUNC( LAN.DATMOV ) AS DATMOV, 
             0 AS QTDVEN, 0 AS VLRVEN,
             0 AS QTDCOM, 0 AS VLRCOM,
             0 AS VLR_CM,
             0 AS VLRCMG,
             0 AS SAL_CM,
             LAN.QTDMOV AS QTDOUT, LAN.VLRMOV AS VLROUT,
             0 AS VENFIS, 0 AS VENFIN,  
             LAN.CODMUL
      FROM TT_LAN LAN
      WHERE LAN.SITMOV <> 'C' 
        AND LAN.CODFIL=pCODFIL
        AND LAN.FILMAT=pFILMAT
        AND LAN.CODMAT=pCODMAT
        AND LAN.CODCOR=pCODCOR
        AND LAN.CODTAM=pCODTAM
        AND LAN.CODMUL=pCODMUL
      UNION ALL (
      SELECT COM.CODFIL, ICO.FILMAT, ICO.CODMAT, ICO.CODCOR, ICO.CODTAM, TRUNC( ICO.COM_DATOPE ) AS DATMOV, 
             0 AS QTDVEN, 0 AS VLRVEN,
             ICO.QTDMOV AS QTDCOM, ICO.VLRMOV AS VLRCOM,
             0 AS VLR_CM,
             0 AS VLRCMG,
             0 AS SAL_CM,             
             0 AS QTDOUT, 0 AS VLROUT,
             0 AS VENFIS, 0 AS VENFIN,
             ICO.CODMUL
      FROM TT_COM COM, TT_ICO ICO
      WHERE COM.CODFIL = ICO.CODFIL
        AND COM.SEQUEN = ICO.SEQUEN
        AND ICO.LANEST = 'S'
        AND ICO.SITMOV <> 'C' 
        AND ICO.CODFIL=pCODFIL
        AND ICO.FILMAT=pFILMAT
        AND ICO.CODMAT=pCODMAT
        AND ICO.CODCOR=pCODCOR
        AND ICO.CODTAM=pCODTAM
        AND ICO.CODMUL=pCODMUL)
      UNION ALL (
      SELECT VEN.CODFIL, IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM, TRUNC( IVE.VEN_DATHOR ) AS DATMOV, 
             CASE VEN.LANVEN WHEN 'F' THEN 0 ELSE IVE.QTDMOV
             END AS QTDVEN,
             CASE VEN.LANVEN WHEN 'F' THEN 0 ELSE IVE.VLRMOV
             END AS VLRVEN,
             0 AS QTDCOM, 0 AS VLRCOM,
             0 AS VLR_CM,
             0 AS VLRCMG,
             0 AS SAL_CM,
             0 AS QTDOUT, 0 AS VLROUT,
             CASE VEN.LANVEN WHEN 'F' THEN IVE.QTDMOV ELSE 0
             END AS VENFIS,
             CASE VEN.LANVEN WHEN 'F' THEN IVE.VLRMOV ELSE 0
             END AS VENFIN,
             IVE.CODMUL
             FROM TT_IVE IVE, TT_VEN VEN
             WHERE VEN.CODFIL = IVE.CODFIL
               AND VEN.SEQUEN = IVE.SEQUEN
               AND IVE.LANEST IN ('S','C')
               AND IVE.SITMOV <> 'C' 
               AND IVE.SITKIT <> '1'
               AND IVE.CODFIL=pCODFIL
               AND IVE.FILMAT=pFILMAT
               AND IVE.CODMAT=pCODMAT
               AND IVE.CODCOR=pCODCOR
               AND IVE.CODTAM=pCODTAM
               AND IVE.CODMUL=pCODMUL)) TAB
GROUP BY CODFIL, FILMAT, CODMAT, CODCOR, CODTAM, DATMOV, CODMUL
);

update tr_mov set SALANT = (select sum( coalesce( QTDCOM, 0 ) + 
                                          coalesce( QTDOUT, 0 ) - 
                                          coalesce( QTDVEN, 0 ) - 
                                          coalesce( VENFIS, 0) )
                              from tr_mov i1
                              where i1.codfil = tr_mov.codfil
                                and i1.filmat = tr_mov.filmat
                                and i1.codmat = tr_mov.codmat
                                and i1.codcor = tr_mov.codcor
                                and i1.codtam = tr_mov.codtam
                                and i1.codmul = tr_mov.codmul
                                and i1.datmov < tr_mov.datmov),
                 DESCOM =
                        (SELECT GRA.DESICO
                           FROM TT_GRA GRA
                          WHERE TR_MOV.FILMAT=GRA.FILMAT
                            AND TR_MOV.CODMAT=GRA.CODMAT
                            AND TR_MOV.CODCOR=GRA.CODCOR
                            AND TR_MOV.CODTAM=GRA.CODTAM
                        ) 
  WHERE FILMAT=pFILMAT
    AND CODMAT=pCODMAT
    AND CODCOR=pCODCOR
    AND CODTAM=pCODTAM
    AND CODMUL=pCODMUL;
    
-- atualiza ultima compra que atualiza custo

drop table IF EXISTS TMP_TRMOV_ICO;

create temporary table TMP_TRMOV_ICO as
SELECT MAX(CASE WHEN IC.QTDMOV <> 0 THEN IC.COM_DATOPE END) AS ULTDAT,
	   MAX(CASE WHEN IC.CUSFRE > 0 THEN IC.COM_DATOPE END) AS ULTFRE,
	   TR_MOV.DATMOV
FROM TT_ICO IC INNER JOIN TR_MOV ON  TR_MOV.FILMAT = IC.FILMAT
							   AND TR_MOV.CODMAT = IC.CODMAT
							   AND TR_MOV.CODCOR = IC.CODCOR
							   AND TR_MOV.CODTAM = IC.CODTAM 
WHERE IC.COM_DATOPE <= TO_DATE(TO_CHAR(TR_MOV.DATMOV,'dd/mm/yyyy')||' 23:59:59','dd/mm/yyyy hh24:mi:ss')
 AND IC.CODFIL = pCODFIL
 AND IC.FILMAT = pFILMAT
 AND IC.CODMAT = pCODMAT
 AND IC.CODCOR = pCODCOR
 AND IC.CODTAM = pCODTAM
 AND IC.COM_ATUCUS = 'T'
 AND IC.QTDMOV <> 0
GROUP BY TR_MOV.DATMOV;

CREATE UNIQUE INDEX I_TMP_TRMOV_ICO ON TMP_TRMOV_ICO (DATMOV);


UPDATE TR_MOV SET FILICO = ICO.CODFIL,
                  SEQICO = ICO.SEQUEN,
                  NUMICO = ICO.NUMITE
  FROM TT_ICO ICO 
 WHERE TR_MOV.CODFIL = pCODFIL
   AND TR_MOV.FILMAT = pFILMAT
   AND TR_MOV.CODMAT = pCODMAT
   AND TR_MOV.CODCOR = pCODCOR
   AND TR_MOV.CODTAM = pCODTAM
   AND TR_MOV.FILMAT = ICO.FILMAT
   AND TR_MOV.CODMAT = ICO.CODMAT
   AND TR_MOV.CODCOR = ICO.CODCOR
   AND TR_MOV.CODTAM = ICO.CODTAM   
   AND ICO.COM_ATUCUS = 'T'
   AND ICO.QTDMOV <> 0
   AND ICO.COM_DATOPE IN (SELECT TMP.ULTDAT
                            FROM TMP_TRMOV_ICO TMP
                           WHERE TMP.DATMOV = TR_MOV.DATMOV);

-- atualiza ultima compra com custo de frete

UPDATE TR_MOV SET FILFRE = ICO.CODFIL,
                  SEQFRE = ICO.SEQUEN,
                  NUMFRE = ICO.NUMITE
  FROM TT_ICO ICO 
 WHERE TR_MOV.CODFIL = pCODFIL
   AND TR_MOV.FILMAT = pFILMAT
   AND TR_MOV.CODMAT = pCODMAT
   AND TR_MOV.CODCOR = pCODCOR
   AND TR_MOV.CODTAM = pCODTAM
   AND TR_MOV.FILMAT = ICO.FILMAT
   AND TR_MOV.CODMAT = ICO.CODMAT
   AND TR_MOV.CODCOR = ICO.CODCOR
   AND TR_MOV.CODTAM = ICO.CODTAM
   AND ICO.CUSFRE > 0
   AND ICO.COM_DATOPE IN (SELECT TMP.ULTFRE
                            FROM TMP_TRMOV_ICO TMP
                           WHERE TMP.DATMOV = TR_MOV.DATMOV);

  -- RFMP - 64861 - uniao de grade
  IF pAtualizaSaldo = 'T' THEN     
    UPDATE TT_SAL SET CAL_CM=NULL,
                      ATU_CM='F',
                      QTDEST=COALESCE(QTDEST,0)+1,
                      RESERV=COALESCE(RESERV,0)+1
      WHERE CODFIL=pCODFIL
        AND FILMAT=pFILMAT
        AND CODMAT=pCODMAT
        AND CODCOR=pCODCOR
        AND CODTAM=pCODTAM
        AND CODMUL=pCODMUL;                  
  END IF;

END IF;
        
  RETURN NULL;
END;
$$ language 'plpgsql';


/*-- SEQ 1754 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ATUALIZAMOV (TR_MOV.CODFIL%TYPE,TR_MOV.FILMAT%TYPE,TR_MOV.CODMAT%TYPE,TR_MOV.CODCOR%TYPE,TR_MOV.CODTAM%TYPE,TR_MOV.CODMUL%TYPE) CASCADE;

/*-- SEQ 1755 --*/
CREATE OR REPLACE FUNCTION ATUALIZAMOV (TR_MOV.CODFIL%TYPE,
                               TR_MOV.FILMAT%TYPE,
                               TR_MOV.CODMAT%TYPE,
                               TR_MOV.CODCOR%TYPE,
                               TR_MOV.CODTAM%TYPE,
                               TR_MOV.CODMUL%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN ATUALIZAMOV($1,$2,$3,$4,$5,$6,'T');
END;
$$ language 'plpgsql';


/*-- SEQ 1756 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ATUALIZAMOVGERAL (TT_SAL.CODFIL%TYPE) CASCADE;

/*-- SEQ 1757 --*/
CREATE OR REPLACE FUNCTION ATUALIZAMOVGERAL (TT_SAL.CODFIL%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
WK_ESTOQUE VARCHAR(3);
WK_CODFIL TT_SAL.CODFIL%TYPE;
WK_FILMAT TT_SAL.FILMAT%TYPE;
WK_CODMAT TT_SAL.CODMAT%TYPE;
WK_CODCOR TT_SAL.CODCOR%TYPE;
WK_CODTAM TT_SAL.CODTAM%TYPE;
WK_CODMUL TT_SAL.CODMUL%TYPE;

CR_ESTOQUE CURSOR(PCODFIL VARCHAR) IS
     SELECT CODFIL, FILMAT, CODMAT, CODCOR, CODTAM, CODMUL
       FROM TT_SAL
      WHERE CODFIL = COALESCE(PCODFIL,CODFIL)
        AND QTDEST <> SALDODAFILIAL(AGORA(), FILMAT, CODMAT, CODCOR, CODTAM, CODFIL, CODMUL);
BEGIN

   OPEN CR_ESTOQUE(PCODFIL);
   LOOP
      FETCH CR_ESTOQUE INTO WK_CODFIL, WK_FILMAT, WK_CODMAT, WK_CODCOR, WK_CODTAM, WK_CODMUL;

      EXIT WHEN NOT FOUND;

      WK_ESTOQUE := ATUALIZAMOV (WK_CODFIL,WK_FILMAT,WK_CODMAT,WK_CODCOR,WK_CODTAM,WK_CODMUL);

   END LOOP;
   CLOSE CR_ESTOQUE;
  RETURN 'OK';
END;
$$ language 'plpgsql';





/*-- SEQ 1758 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Aux_TrazLinhaDigitavel (TT_TIT.CODBCO%TYPE,TT_TIT.NUMAGE%TYPE,TT_TIT.CTACRR%TYPE,TT_TIT.NOSNUM%TYPE,TT_CCB.CARBCO%TYPE,TT_CRB.APECRB%TYPE,TT_MOE.MOEBCO%TYPE,TT_REC.VLRPAR%TYPE,TT_REC.DATVEN%TYPE,TT_CTB.AVISTA%TYPE,TT_CTB.APRAZO%TYPE,TT_CTB.DIGA_C%TYPE,TT_CTBXCCB.CODCNV%TYPE,VARCHAR,TT_CTBXCCB.CODCED%TYPE,TT_REC.NUMPAR%TYPE) CASCADE;

/*-- SEQ 1759 --*/
CREATE OR REPLACE FUNCTION Aux_TrazLinhaDigitavel (TT_TIT.CODBCO%TYPE,TT_TIT.NUMAGE%TYPE,TT_TIT.CTACRR%TYPE,TT_TIT.NOSNUM%TYPE,TT_CCB.CARBCO%TYPE,TT_CRB.APECRB%TYPE,TT_MOE.MOEBCO%TYPE,TT_REC.VLRPAR%TYPE,TT_REC.DATVEN%TYPE,TT_CTB.AVISTA%TYPE,TT_CTB.APRAZO%TYPE,TT_CTB.DIGA_C%TYPE,TT_CTBXCCB.CODCNV%TYPE,VARCHAR,TT_CTBXCCB.CODCED%TYPE,TT_REC.NUMPAR%TYPE)
RETURNS VARCHAR AS $$
DECLARE
CODBCO ALIAS FOR $1 ;
NUMAGE ALIAS FOR $2 ;
CTACRR ALIAS FOR $3 ;
NOSNUM ALIAS FOR $4 ;
CCBBCO ALIAS FOR $5 ;
APECRB ALIAS FOR $6 ;
MOEBCO ALIAS FOR $7 ;
VLRTIT ALIAS FOR $8 ;
DATVEN ALIAS FOR $9 ;
AVISTA ALIAS FOR $10 ;
APRAZO ALIAS FOR $11 ;
DIGA_C ALIAS FOR $12 ;
CODCNV ALIAS FOR $13 ;
CodBarras ALIAS FOR $14 ;
CODCED ALIAS FOR $15 ;
NUMPAR ALIAS FOR $16 ;
-- Objetivo
-- Confeciona a Linha Digitavel de um boleto bancario
  Wk_Campo1 char(11);
  Wk_Campo2 char(12);
  Wk_Campo3 char(13);
  Wk_Campo4 char(1);
  Wk_Campo5 char(14);

  wk_FatorVenc Numeric(4);
  wk_FatorSYSDATE Numeric(4);

begin

  -- BANCO ITAU
  if CODBCO = '341' then
      -- FAtor de vencimento a partir do dia 03/07/2002
      wk_FatorVenc := LPAD(TO_CHAR(mod(IntervaloDias(Trunc(DatVen), to_date('03/07/2000','DD/MM/YYYY')), 9000) + 1000),4,'0');
      wk_FatorSYSDATE := LPAD(TO_CHAR(mod(IntervaloDias(trunc(agora()) , to_date('03/07/2000','DD/MM/YYYY')),9000) + 1000),4,'0');
      if wk_FatorVenc = wk_FatorSYSDATE then
         wk_FatorVenc := wk_FatorVenc + AVISTA;
      elsif (APRAZO is not null) and (APRAZO > 0) then
         wk_FatorVenc := wk_FatorVenc + APRAZO;
      end if;

      -- Formata o campo e calcula o digito verificador


      wk_Campo1 :=    LPAD(COALESCE(CODBCO,'0'),03,'0')
                   || LPAD(TO_CHAR(COALESCE(MOEBCO,0)),01,'0')
                   || LPAD(TO_CHAR(COALESCE(CCBBCO,0)),03,'0')
                   || LPAD(COALESCE(SubStr(TRIM(NosNum),1,2),'0'), 02,'0');

      wk_Campo1 := Substr(wk_campo1,1,5) || '.' || Substr(wk_campo1,6,4) || Aux_calculadac(wk_Campo1);

      wk_Campo2 :=    LPAD(COALESCE(SubStr(TRIM(NosNum),3,6),'0'), 06,'0')
                  || LPAD(COALESCE(SubStr(TRIM(NosNum),9,1),'0'), 01,'0')
                  || LPAD(COALESCE(SubStr(TRIM(NUMAGE),2,3),'0'), 03,'0');

      wk_Campo2 := Substr(wk_campo2,1,5) || '.' || Substr(wk_campo2,6,5) || Aux_calculadac(wk_Campo2);

      wk_Campo3 :=    LPAD(COALESCE(SubStr(TRIM(NUMAGE),5,1),'0'), 01,'0')
                   || LPAD(COALESCE(TRIM(CTACRR),'0'),05,'0')
                   || LPAD(TO_CHAR(to_number(COALESCE(DIGA_C,'0'))),1,'0')
                   || LPAD('0',03,'0');

      wk_Campo3 := Substr(wk_campo3,1,5) || '.' || Substr(wk_campo3,6,5) || Aux_calculadac(wk_Campo3);

      wk_Campo4 := Substr(aux_TrazCodBarra(CODBCO,NUMAGE,CTACRR,NOSNUM,CCBBCO,APECRB,MOEBCO,VLRTIT,DATVEN,AVISTA,APRAZO,DIGA_C,CODCNV, CODCED, NUMPAR),5,1);

      wk_Campo5 := wk_FatorVenc || LPAD(TO_CHAR(COALESCE(TRUNC(VLRTIT*100),0)),10,'0');

      -- Retorna os cinco campos
      Return wk_campo1 || ' ' || wk_campo2 || ' ' || wk_campo3 || ' ' || wk_campo4 || ' ' || wk_campo5;

  -- HSBC
  elsif CODBCO = '399' then
      -- FAtor de vencimento a partir do dia 03/07/2002
      wk_FatorVenc := LPAD(TO_CHAR(mod(IntervaloDias(Trunc(DatVen) , to_date('03/07/2000','DD/MM/YYYY')), 9000) + 1000),4,'0');
      wk_FatorSYSDATE := LPAD(TO_CHAR(mod(IntervaloDias(Trunc(agora()) , to_date('03/07/2000','DD/MM/YYYY')), 9000) + 1000),4,'0');
      if wk_FatorVenc = wk_FatorSYSDATE then
         wk_FatorVenc := wk_FatorVenc + AVISTA;
      elsif (APRAZO is not null) and (APRAZO > 0) then
         wk_FatorVenc := wk_FatorVenc + APRAZO;
      end if;

      -- Formata o campo e calcula o digito verificador
      wk_Campo1 :=    LPAD(COALESCE(CODBCO,'0'),03,'0')
                   || LPAD(TO_CHAR(COALESCE(MOEBCO,0)),01,'0')
                   || LPAD(COALESCE(SubStr(TRIM(NosNum),1,5),'0'), 05,'0');
      wk_Campo1 := Substr(wk_campo1,1,5) || Substr(wk_campo1,6,4) || Aux_CalculaDAC(wk_Campo1);

      wk_Campo2 :=    LPAD(COALESCE(SubStr(TRIM(NosNum),6,6),'0'), 06,'0')
                  || LPAD(TO_CHAR(COALESCE(TO_NUMBER(NUMAGE),0)),04,'0');
      wk_Campo2 := Substr(wk_campo2,1,5) || Substr(wk_campo2,6,5) || Aux_CalculaDAC(wk_Campo2);

      wk_Campo3 :=    LPAD(TO_CHAR(to_number(COALESCE(CTACRR,'0'))),7,'0')
                   || LPAD(TO_CHAR(COALESCE(CCBBCO,0)),02,'0')
                   || '1';
      wk_Campo3 := Substr(wk_campo3,1,5) || Substr(wk_campo3,6,5) || Aux_CalculaDAC(wk_Campo3);

      wk_Campo4 := Substr(CodBarras,5,1);

      wk_Campo5 := wk_FatorVenc || LPAD(TO_CHAR(COALESCE(TRUNC(VLRTIT*100),0)),10,'0');

      -- Retorna os cinco campos
      Return wk_campo1 || ' ' || wk_campo2 || ' ' || wk_campo3 || ' ' || wk_campo4 || ' ' || wk_campo5;

  -- SICOOB
  elsif CODBCO = '756' then

    -- Campo 1: Cdigo do banco + moeda + 5 primeiros dgitos do campo livre + DV
    wk_campo1 := substr(CodBarras, 1, 4) || substr(CodBarras, 20, 5);
    wk_campo1 := wk_campo1 || CalculaDivLinhaDigitalSicoob(wk_campo1);

    -- Campo 2: 6 a 15 dgitos do campo livre + DV
    wk_campo2 := substr(CodBarras, 25, 10);
    wk_campo2 := wk_campo2 || CalculaDivLinhaDigitalSicoob(wk_campo2);

    -- Campo 3: 16 a 25 dgitos do campo livre + DV
    wk_campo3 := substr(CodBarras, 35, 10);
    wk_campo3 := wk_campo3 || CalculaDivLinhaDigitalSicoob(wk_campo3);

    -- Campo 4: Dgito verificador geral (posio 5 do cdigo de barras)
    wk_campo4 := substr(CodBarras, 5, 1);

    -- Campo 5: Fator de vencimento + Valor do boleto
    wk_campo5 := substr(CodBarras, 6, 14);

    -- Retorna a linha digitvel formatada
    Return wk_campo1 || ' ' || wk_campo2 || ' ' || wk_campo3 || ' ' || wk_campo4 || ' ' || wk_campo5;    

  -- Bradesco
  elsif CODBCO = '237' then
      -- Fator de vencimento a partir do dia 03/07/2002
      wk_FatorVenc := LPAD(TO_CHAR(mod(IntervaloDias(Trunc(DatVen) , to_date('03/07/2000','DD/MM/YYYY')), 9000) + 1000),4,'0');

      wk_FatorSYSDATE := LPAD(TO_CHAR(mod(IntervaloDias(Trunc(agora()) , to_date('03/07/2000','DD/MM/YYYY')), 9000) + 1000),4,'0');
      if wk_FatorVenc = wk_FatorSYSDATE then
         wk_FatorVenc := wk_FatorVenc + AVISTA;
        elsif (APRAZO is not null) and (APRAZO > 0) then
           wk_FatorVenc := wk_FatorVenc + APRAZO;
      end if;


      -- Formata o campo e calcula o digito verificador
      wk_Campo1 :=    LPAD(COALESCE(CODBCO,'0'),03,'0')
                   || LPAD(TO_CHAR(COALESCE(MOEBCO,0)),01,'0')
                   || substr(CodBarras,20,5);
      wk_Campo1 := Substr(wk_campo1,1,5) || '.' || Substr(wk_campo1,6,4) || Aux_CalculaDAC(wk_Campo1);

      wk_Campo2 := substr(CodBarras,25,10);
      wk_Campo2 := Substr(wk_campo2,1,5) || '.' || Substr(wk_campo2,6,5) || Aux_CalculaDAC(wk_Campo2);

      wk_Campo3 := substr(CodBarras,35,10);
      wk_Campo3 := Substr(wk_campo3,1,5) || '.' || Substr(wk_campo3,6,5) || Aux_CalculaDAC(wk_Campo3);

      wk_Campo4 := Substr(CodBarras,5,1);

      wk_Campo5 := Substr(CodBarras,6,14);

      -- Retorna os cinco campos
      Return TRIM(wk_campo1) || ' ' ||
             TRIM(wk_campo2) || ' ' ||
             TRIM(wk_campo3) || ' ' ||
             TRIM(wk_campo4) || ' ' ||
             TRIM(wk_campo5);

  -- Banco do Brasil
  elsif CODBCO = '001' then
      -- Fator de vencimento a partir do dia 03/07/2002
      wk_FatorVenc := LPAD(TO_CHAR(mod(IntervaloDias(Trunc(DatVen) , to_date('03/07/2000','DD/MM/YYYY')), 9000) + 1000),4,'0');

      wk_FatorSYSDATE := LPAD(TO_CHAR(mod(IntervaloDias(Trunc(agora()) , to_date('03/07/2000','DD/MM/YYYY')), 9000) + 1000),4,'0');
      if wk_FatorVenc = wk_FatorSYSDATE then
         wk_FatorVenc := wk_FatorVenc + AVISTA;
        elsif (APRAZO is not null) and (APRAZO > 0) then
           wk_FatorVenc := wk_FatorVenc + APRAZO;
      end if;

      -- Formata o campo e calcula o digito verificador
      wk_Campo1 :=    LPAD(COALESCE(CODBCO,'0'),03,'0')
                   || LPAD(TO_CHAR(COALESCE(MOEBCO,0)),01,'0')
                   || substr(CodBarras,20,5);
      wk_Campo1 := Substr(wk_campo1,1,5) || '.' || Substr(wk_campo1,6,4) || Aux_CalculaDAC(wk_Campo1);

      wk_Campo2 := substr(CodBarras,25,10);
      wk_Campo2 := Substr(wk_campo2,1,5) || '.' || Substr(wk_campo2,6,5) || Aux_CalculaDAC(wk_Campo2);

      wk_Campo3 := substr(CodBarras,35,10);
      wk_Campo3 := Substr(wk_campo3,1,5) || '.' || Substr(wk_campo3,6,5) || Aux_CalculaDAC(wk_Campo3);

      wk_Campo4 := Substr(CodBarras,5,1);

      wk_Campo5 := Substr(CodBarras,6,14);

      -- Retorna os cinco campos
      Return TRIM(wk_campo1) || ' ' ||
             TRIM(wk_campo2) || ' ' ||
             TRIM(wk_campo3) || ' ' ||
             TRIM(wk_campo4) || ' ' ||
             TRIM(wk_campo5);

  -- Servico Adicional Avulso 88170
  elsif CODBCO = '000' then
      -- Fator de vencimento a partir do dia 03/07/2002
      wk_FatorVenc := LPAD(TO_CHAR(mod(IntervaloDias(Trunc(DatVen) , to_date('03/07/2000','DD/MM/YYYY')), 9000) + 1000),4,'0');

      wk_FatorSYSDATE := LPAD(TO_CHAR(mod(IntervaloDias(Trunc(agora()) , to_date('03/07/2000','DD/MM/YYYY')), 9000) + 1000),4,'0');
      if wk_FatorVenc = wk_FatorSYSDATE then
         wk_FatorVenc := wk_FatorVenc + AVISTA;
        elsif (APRAZO is not null) and (APRAZO > 0) then
           wk_FatorVenc := wk_FatorVenc + APRAZO;
      end if;

      -- Formata o campo e calcula o digito verificador
      wk_Campo1 :=   LPAD(COALESCE(CODBCO,'0'),03,'0')
                     || LPAD(TO_CHAR(COALESCE(MOEBCO,0)),01,'0')
                     || substr(CodBarras,20,5); -- pega os 5 primeiros digitos do codigo avulso

      wk_Campo1 := Substr(wk_campo1,1,5) || '.' || Substr(wk_campo1,6,4) || Aux_CalculaDAC(wk_Campo1);

      wk_Campo2 := substr(CodBarras,25,10); -- Fim do codigo avulso 15 posicoes

      wk_Campo2 := Substr(wk_campo2, 1, 5) || '.' || Substr(wk_campo2,6,5) || Aux_CalculaDAC(wk_Campo2);

      wk_Campo3 := substr(CodBarras,35,10); -- Pega 5 mais 5 digitos que significam TDSAV CODRTT mais TDSAV CODTAB

      wk_Campo3 := Substr(wk_campo3,1,5) || '.' || Substr(wk_campo3,6,5) || Aux_CalculaDAC(wk_Campo3);

      wk_Campo4 := Substr(CodBarras,5,1); -- Digito verificador posicao 5 no codigo de barras

      wk_Campo5 := Substr(CodBarras,6,14); -- Pega o fator de data vencimento mais valor titulo

      -- Retorna os cinco campos
      Return TRIM(wk_campo1) || ' ' ||
             TRIM(wk_campo2) || ' ' ||
             TRIM(wk_campo3) || ' ' ||
             TRIM(wk_campo4) || ' ' ||
             TRIM(wk_campo5);

  -- Formato padro de linha digitvel a partir do cdigo de barras
  -- CAIXA
  -- SICREDI (RFMP 96710)
  -- BANRISUL (RFMP 97988)
  -- CECRED (RFMP 97014)
  ELSIF CODBCO IN ('104','748','041','085') THEN

     wk_Campo1 := SUBSTR(CodBarras,1,3)
                || SUBSTR(CodBarras,4,1)
                || SUBSTR(CodBarras,20,5);
     wk_Campo1 := SUBSTR(wk_campo1,1,5) || '.' || SUBSTR(wk_campo1,6,4) || Aux_CalculaDAC(wk_Campo1);

     wk_Campo2 := SUBSTR(CodBarras,25,10);
     wk_Campo2 := SUBSTR(wk_campo2,1,5) || '.' || SUBSTR(wk_campo2,6,5) || Aux_CalculaDAC(wk_Campo2);

     wk_Campo3 := SUBSTR(CodBarras,35,10);
     wk_Campo3 := SUBSTR(wk_campo3,1,5) || '.' || SUBSTR(wk_campo3,6,5) || Aux_CalculaDAC(wk_Campo3);

     wk_Campo4 := SUBSTR(CodBarras,5,1);

     wk_Campo5 := SUBSTR(CodBarras,6,4) || SUBSTR(CodBarras,10,10);

     -- Retorna os cinco campos
     Return wk_campo1 || ' ' ||
            wk_campo2 || ' ' ||
            wk_campo3 || ' ' ||
            wk_campo4 || ' ' ||
            wk_campo5;

  else
      Return '00000000000000000000000000000000000000000000000';
  end if;
END;
$$ language 'plpgsql';




/*-- SEQ 1760 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CancelaCheque (TT_OPE.CODFIL%TYPE,TT_OPE.TRN_ID%TYPE,TT_CHR.CODFIL%TYPE,TT_CHR.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1761 --*/
CREATE OR REPLACE FUNCTION CancelaCheque (TT_OPE.CODFIL%TYPE,TT_OPE.TRN_ID%TYPE,TT_CHR.CODFIL%TYPE,TT_CHR.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILOPE ALIAS FOR $1 ;
pTRN_ID ALIAS FOR $2 ;
pFILCHR ALIAS FOR $3 ;
pSEQCHR ALIAS FOR $4 ;
  vFILUSU            TT_USU.FILUSU%TYPE;               
  vCODUSU            TT_USU.CODUSU%TYPE;               
  vFILDIF            TT_USU.FILDIF%TYPE;               
  vSEQDIF            TT_USU.SEQDIF%TYPE;               
  vTIPDIF            TT_USU.TIPDIF%TYPE;               
  QuemLogou TRetQuemLogou;
  vComplemento CONSTANT VARCHAR(254) := Constante('complemento');  
  vFILTRN            TT_CFG.FILCTA_TRN%TYPE;
  vSEQTRN            TT_CFG.SEQCTA_TRN%TYPE;
  vTIPTRN            TT_CFG.TIPCTA_TRN%TYPE;
  vPORORI            TD_COB.CODTAB%TYPE;  
  vFILPOR            TD_COB.FILCTA%TYPE;
  vSEQPOR            TD_COB.SEQCTA%TYPE;
  vTIPPOR            TD_COB.TIPCTA%TYPE;
  vSEQFIN            TT_FIN.SEQUEN%TYPE;
  cRETLID            VARCHAR(2);
  NUMECF_000 CONSTANT VARCHAR(3) := '000';
  vFLGEST            TT_CHR.FLGEST%TYPE;
  vVLRCHE            TT_CHR.VLRCHE%TYPE;
  vDESDOM            TT_DOM.DESDOM%TYPE;
  vCHEQUE            VARCHAR(27);

-- Cancela cartao
  
BEGIN
  -- Verifica se usuario tem conta diferenca
  select * into QuemLogou from DadosLogon();
  IF  QuemLogou.Encontrou 
  AND QuemLogou.TemConta THEN
     vFILUSU := QuemLogou.FILUSU;
     vCODUSU := QuemLogou.CODUSU;
     vFILDIF := QuemLogou.FILDIF;
     vSEQDIF := QuemLogou.SEQDIF;  
     vTIPDIF := QuemLogou.TIPDIF; 
  ELSE
     RAISE EXCEPTION 'PG-20005 Usuario sem conta diferenca. %' , VComplemento;  
  END IF;  
  
  IF vTIPDIF = 'G' THEN
    RAISE EXCEPTION 'PG-20010 Conta diferenca do usuario deve ser nominal. %' , VComplemento;  
  END IF;
  
  -- Verifica cheque
  SELECT FLGEST, VLRCHE, PORORI,
         CODBCO||'-'||CODAGE||'-'||NUMCON||'-'||NUMCHE 
         INTO vFLGEST, vVLRCHE, vPORORI, vCHEQUE
    FROM TT_CHR
   WHERE CODFIL = pFILCHR
     AND SEQUEN = pSEQCHR;
  
  -- Se j est cancelado no precisa fazer mais nada
  IF vFLGEST = 'X' THEN
    RETURN 'OK';
  END IF;
  
  IF vFLGEST NOT IN ('A','S','V') THEN  
    SELECT DESDOM INTO vDESDOM
      FROM TT_DOM
     WHERE CODARQ = 'CHR'
       AND NOMCPO = 'FLGEST'
       AND CODCHR = vFLGEST;  
    RAISE EXCEPTION 'PG-20015 Nao se pode cancelar um cheque %. %' , vDESDOM,VComplemento;    
  END IF;
  
  -- Cancela cheque
  UPDATE TT_CHR
     SET FLGEST = 'X'
   WHERE CODFIL = pFILCHR
     AND SEQUEN = pSEQCHR;
     
  -- Conta Transferencia
  SELECT CFG.FILCTA_TRN, CFG.SEQCTA_TRN, CFG.TIPCTA_TRN INTO vFILTRN, vSEQTRN, vTIPTRN
 	 FROM TT_CFG CFG;  
 	 
  -- Pegar portador origem 
  SELECT FILCTA, SEQCTA, TIPCTA INTO vFILPOR, vSEQPOR, vTIPPOR
    FROM TD_COB
   WHERE CODTAB = vPORORI; 	 
   
  -- Gera lancamento financeiro
  SELECT ProximoCodigo('TT_FIN',pFILCHR) INTO vSEQFIN FROM DUAL;    
  
  -- Lancamento
  INSERT INTO TT_FIN (
    CODFIL, SEQUEN, FILUSU, CODUSU, DATOPE, 
    FILNUM, SEQNUM, TIPNUM, FILGER, SEQGER, TIPGER, 
    VLRMOV, OBSERV, NUMDOC, FLGFIN, ORILAN
  ) 
  VALUES (
    pFILCHR, vSEQFIN, vFILUSU, vCODUSU, TRUNC(Agora()), 
    vFILDIF, vSEQDIF, vTIPDIF, vFILTRN, vSEQTRN, vTIPTRN,
    vVLRCHE, 
    'Cancelamento do Cheque: '||vCHEQUE||' - Chave: ['||pFILCHR||'/'||pSEQCHR||']',
    NULL, 
    'S', 'I'       
  ); 
  
  -- Contralancamento
  INSERT INTO TT_FIN (
    CODFIL, SEQTRN, FILUSU, CODUSU, DATOPE,
    FILNUM, SEQNUM, TIPNUM, FILGER, SEQGER, TIPGER,
    VLRMOV, OBSERV, NUMDOC, FLGFIN, ORILAN
  )
  VALUES (
    pFILCHR, vSEQFIN, vFILUSU, vCODUSU, TRUNC(Agora()),
    vFILPOR, vSEQPOR, vTIPPOR, vFILTRN, vSEQTRN, vTIPTRN,
    vVLRCHE*-1,
    'Cancelamento do Cheque: '||vCHEQUE||' - Chave: ['||pFILCHR||'/'||pSEQCHR||']',
    NULL,
    'S', 'I'
  );
  
  cRETLID := CriaLid(pFILOPE, NUMECF_000, pTRN_ID);
  
  -- Operacao da ope
  INSERT INTO TT_OPE (
    CODFIL, NUMECF, TRN_ID, CUPFIS, NUMITE, VLROPE, DATOPE,
    FILUSU, CODUSU, FILCHR, SEQCHR
  )
  (
    SELECT pFILOPE, NUMECF_000, pTRN_ID, 0,  
           (
           SELECT COALESCE(MAX(NUMITE),0)+1
             FROM TT_OPE
            WHERE CODFIL = pFILOPE
              AND NUMECF = NUMECF_000
              AND TRN_ID = pTRN_ID
           ), 
           vVLRCHE*-1, TRUNC(Agora()),
           vFILUSU, vCODUSU, pFILCHR, pSEQCHR
      FROM DUAL
  );  
  
  -- Operacao da fin
  INSERT INTO TT_OPE (
    CODFIL, NUMECF, TRN_ID, CUPFIS, NUMITE, VLROPE, DATOPE,
    FILUSU, CODUSU, FILFIN, SEQFIN
  )
  (
    SELECT pFILOPE, NUMECF_000, pTRN_ID, 0,  
           (
           SELECT COALESCE(MAX(NUMITE),0)+1 
             FROM TT_OPE
            WHERE CODFIL = pFILOPE
              AND NUMECF = NUMECF_000
              AND TRN_ID = pTRN_ID
           ), 
           vVLRCHE, TRUNC(Agora()),
           vFILUSU, vCODUSU, pFILCHR, vSEQFIN
      FROM DUAL
  );    
     
  RETURN 'OK';
END;
$$ language 'plpgsql';


/*-- SEQ 1762 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CancelaCheque () CASCADE;

/*-- SEQ 1763 --*/
CREATE OR REPLACE FUNCTION CancelaCheque () 
RETURNS VARCHAR AS $$
BEGIN
RETURN CancelaCheque(1);
END;
$$ language 'plpgsql';


/*-- SEQ 1764 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CancelaTEF (TT_OPE.CODFIL%TYPE,TT_OPE.TRN_ID%TYPE,TT_TEF.CODFIL%TYPE,TT_TEF.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1765 --*/
CREATE OR REPLACE FUNCTION CancelaTEF (TT_OPE.CODFIL%TYPE,TT_OPE.TRN_ID%TYPE,TT_TEF.CODFIL%TYPE,TT_TEF.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILOPE ALIAS FOR $1 ;
pTRN_ID ALIAS FOR $2 ;
pFILTEF ALIAS FOR $3 ;
pSEQTEF ALIAS FOR $4 ;
  vFILUSU            TT_USU.FILUSU%TYPE;               
  vCODUSU            TT_USU.CODUSU%TYPE;               
  vFILDIF            TT_USU.FILDIF%TYPE;               
  vSEQDIF            TT_USU.SEQDIF%TYPE;               
  vTIPDIF            TT_USU.TIPDIF%TYPE;               
  QuemLogou TRetQuemLogou;
  vComplemento CONSTANT VARCHAR(254) := Constante('complemento');
  vVLROPE            TT_TEF.VLROPE%TYPE;
  vFILTRN            TT_CFG.FILCTA_TRN%TYPE;
  vSEQTRN            TT_CFG.SEQCTA_TRN%TYPE;
  vTIPTRN            TT_CFG.TIPCTA_TRN%TYPE;
  vPORORI            TD_COB.CODTAB%TYPE;  
  vFILPOR            TD_COB.FILCTA%TYPE;
  vSEQPOR            TD_COB.SEQCTA%TYPE;
  vTIPPOR            TD_COB.TIPCTA%TYPE;
  vSEQFIN            TT_FIN.SEQUEN%TYPE;
  vCARTAO            TT_TEF.CARTAO%TYPE;
  cRETLID            VARCHAR(2);
  NUMECF_000 CONSTANT VARCHAR(3) := '000';

-- Cancela cartao
  
BEGIN
  -- Verifica se usuario tem conta diferenca
  select * into QuemLogou from DadosLogon();
  IF  QuemLogou.Encontrou 
  AND QuemLogou.TemConta THEN
     vFILUSU := QuemLogou.FILUSU;
     vCODUSU := QuemLogou.CODUSU;
     vFILDIF := QuemLogou.FILDIF;
     vSEQDIF := QuemLogou.SEQDIF;  
     vTIPDIF := QuemLogou.TIPDIF; 
  ELSE
     RAISE EXCEPTION 'PG-20005 Usuario sem conta diferenca. %' , VComplemento;  
  END IF;  
  
  -- Verifica se cartao esta aberto
  IF vTIPDIF = 'G' THEN
    RAISE EXCEPTION 'PG-20010 Conta diferenca do usuario deve ser nominal. %' , VComplemento;  
  END IF;
  
  -- Calcula valor total das parcelas  
  SELECT COALESCE(SUM(VLRITE),0) INTO vVLROPE
    FROM TT_ITF
   WHERE CODFIL = pFILTEF
     AND SEQUEN = pSEQTEF
     AND FLGEST <> 'C';
     
  IF vVLROPE <= 0 THEN
    -- Manoel - 98789 - Ao estornar uma parcela, a funo cancelava todas as parcelas do carto, mas no cancela as 
    -- parcelas do sistema (TT_REC) e ao estornar a segunda/demais parcelas do sistema, gerava erro, e ficava inconsistente
    RETURN 'OK';
    --RAISE EXCEPTION 'PG-20015 Nao se pode cancelar um cartao sem parcelas em aberto. %' , VComplemento;
  END IF;
     
  -- Carrega dados da TEF
  SELECT PORORI, CARTAO INTO vPORORI, vCARTAO
    FROM TT_TEF
   WHERE CODFIL = pFILTEF
     AND SEQUEN = pSEQTEF;
  
  -- Cancela parcela do cartao
  UPDATE TT_ITF
     SET FLGEST = 'C'
   WHERE CODFIL = pFILTEF
     AND SEQUEN = pSEQTEF
     AND FLGEST <> 'C';
     
  -- Conta Transferencia
  SELECT CFG.FILCTA_TRN, CFG.SEQCTA_TRN, CFG.TIPCTA_TRN INTO vFILTRN, vSEQTRN, vTIPTRN
 	 FROM TT_CFG CFG;  
 	 
  -- Pegar portador origem 
  SELECT FILCTA, SEQCTA, TIPCTA INTO vFILPOR, vSEQPOR, vTIPPOR
    FROM TD_COB
   WHERE CODTAB = vPORORI; 	 
   
  -- Gera lancamento financeiro
  SELECT ProximoCodigo('TT_FIN',pFILTEF) INTO vSEQFIN FROM DUAL;    
  
  -- Lancamento
  INSERT INTO TT_FIN (
    CODFIL, SEQUEN, FILUSU, CODUSU, DATOPE, 
    FILNUM, SEQNUM, TIPNUM, FILGER, SEQGER, TIPGER, 
    VLRMOV, OBSERV, NUMDOC, FLGFIN, ORILAN
  ) 
  VALUES (
    pFILTEF, vSEQFIN, vFILUSU, vCODUSU, Agora(), 
    vFILDIF, vSEQDIF, vTIPDIF, vFILTRN, vSEQTRN, vTIPTRN,
    vVLROPE, 
    'Cancelamento de Cartao - Chave: ['||pFILTEF||'/'||pSEQTEF||']',
    NULL,
    'S', 'I'       
  ); 
  
  -- Contralancamento
  INSERT INTO TT_FIN (
    CODFIL, SEQTRN, FILUSU, CODUSU, DATOPE,
    FILNUM, SEQNUM, TIPNUM, FILGER, SEQGER, TIPGER,
    VLRMOV, OBSERV, NUMDOC, FLGFIN, ORILAN
  )
  VALUES (
    pFILTEF, vSEQFIN, vFILUSU, vCODUSU, Agora(),
    vFILPOR, vSEQPOR, vTIPPOR, vFILTRN, vSEQTRN, vTIPTRN,
    vVLROPE*-1,
    'Cancelamento de Cartao - Chave: ['||pFILTEF||'/'||pSEQTEF||']',
    NULL,
    'S', 'I'
  );
  
  cRETLID := CriaLid(pFILOPE, NUMECF_000, pTRN_ID);
  
  -- Operacao da ope
  INSERT INTO TT_OPE (
    CODFIL, NUMECF, TRN_ID, CUPFIS, NUMITE, VLROPE, DATOPE,
    FILUSU, CODUSU, FILTEF, SEQTEF, CARTAO
  )
  (
    SELECT pFILOPE, NUMECF_000, pTRN_ID, 0,  
           (
           SELECT COALESCE(MAX(NUMITE),0)+1
             FROM TT_OPE
            WHERE CODFIL = pFILOPE
              AND NUMECF = NUMECF_000
              AND TRN_ID = pTRN_ID
           ), 
           vVLROPE*-1, TRUNC(Agora()),
           vFILUSU, vCODUSU, pFILTEF, pSEQTEF, vCARTAO
      FROM DUAL
  );  
  
  -- Operacao da fin
  INSERT INTO TT_OPE (
    CODFIL, NUMECF, TRN_ID, CUPFIS, NUMITE, VLROPE, DATOPE,
    FILUSU, CODUSU, FILFIN, SEQFIN
  )
  (
    SELECT pFILOPE, NUMECF_000, pTRN_ID, 0,  
           (
           SELECT COALESCE(MAX(NUMITE),0)+1 
             FROM TT_OPE
            WHERE CODFIL = pFILOPE
              AND NUMECF = NUMECF_000
              AND TRN_ID = pTRN_ID
           ), 
           vVLROPE, TRUNC(Agora()),
           vFILUSU, vCODUSU, pFILTEF, vSEQFIN
      FROM DUAL
  );    
     
  RETURN 'OK';
END;
$$ language 'plpgsql';


/*-- SEQ 1766 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CancelaTEF () CASCADE;

/*-- SEQ 1767 --*/
CREATE OR REPLACE FUNCTION CancelaTEF () 
RETURNS VARCHAR AS $$
BEGIN
RETURN CancelaTEF(1);
END;
$$ language 'plpgsql';


/*-- SEQ 1768 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalculaCustoMedioFilial (TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 1769 --*/
CREATE OR REPLACE FUNCTION CalculaCustoMedioFilial (TD_FIL.CODFIL%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;

   vFILMAT                       TT_GRA.FILMAT%TYPE;
   vCODMAT                       TT_GRA.CODMAT%TYPE;
   vCODCOR                       TT_GRA.CODCOR%TYPE;
   vCODTAM                       TT_GRA.CODTAM%TYPE;
   cTemp                         VARCHAR(255);

   -- Cursor para percorrer os lancamentos
   Produtos CURSOR FOR
   SELECT FILMAT,CODMAT,CODCOR,CODTAM
     FROM TT_SAL
    WHERE COALESCE(ATU_CM,'F') <> 'T'
      AND CODFIL = pCODFIL
      AND CODMUL = 0
    ORDER BY CAL_CM;
BEGIN

   OPEN Produtos;
   LOOP
      FETCH Produtos INTO vFILMAT,vCODMAT,vCODCOR,vCODTAM;
      EXIT WHEN NOT FOUND;
      cTemp:=CalculaCustoMedio(pCODFIL,vFILMAT,vCODMAT,vCODCOR,vCODTAM);
         END LOOP;

   CLOSE Produtos;

   RETURN NULL;

END;
$$ language 'plpgsql';



/*-- SEQ 1770 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_CalculaCustoMedioFilial (TT_JOB.CODUID%TYPE) CASCADE;

/*-- SEQ 1771 --*/
CREATE OR REPLACE FUNCTION Job_CalculaCustoMedioFilial (TT_JOB.CODUID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODUID ALIAS FOR $1 ;
   vCODFIL                       TD_FIL.CODFIL%TYPE;
   vNOME                         TT_JOB.NOMJOB%TYPE;
   vDESC                         TT_JOB.DESJOB%TYPE;
   cDummy                        CHAR(2);
   I                             Numeric(2);

   -- Cursor para percorrer os lancamentos
   Filiais CURSOR FOR
   SELECT CODFIL
     FROM TD_FIL
    WHERE FILATI = 'T'
    ORDER BY CODFIL;

BEGIN
   vNOME := 'JOB_CALCULACUSTOMEDIOFILIAL';
   VDESC := 'Rotina para calculo de custo medio';
   BEGIN
      OPEN Filiais;
      LOOP
         FETCH Filiais INTO vCODFIL;
         EXIT WHEN NOT FOUND;
         cDummy := CalculaCustoMedioFilial(vCODFIL);
               END LOOP;

      CLOSE Filiais;

      -- Tenta calcular todos os produtos no atualizados. Isto ocorre porque o calculo pode alterar um produto de outra filial (transferencia)
      FOR I IN 1..10 LOOP
         OPEN Filiais;
         LOOP
            FETCH Filiais INTO vCODFIL;
            EXIT WHEN NOT FOUND;
            cDummy := CalculaCustoMedioFilial(vCODFIL);
                     END LOOP;

         CLOSE Filiais;
      END LOOP;
      cDummy := RegistraJob(vNOME, vDESC, NULL, pCODUID);
   EXCEPTION
      WHEN OTHERS THEN cDummy := RegistraJob(vNOME, vDESC, SQLERRM, pCODUID);
   END;
  RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 1772 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_CalculaCustoMedioFilial () CASCADE;

/*-- SEQ 1773 --*/
CREATE OR REPLACE FUNCTION Job_CalculaCustoMedioFilial () 
RETURNS VARCHAR AS $$
BEGIN
RETURN Job_CalculaCustoMedioFilial(NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1774 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION EstornaParcela (TT_OPE.CODFIL%TYPE,TT_OPE.TRN_ID%TYPE,TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1775 --*/
CREATE OR REPLACE FUNCTION EstornaParcela (TT_OPE.CODFIL%TYPE,TT_OPE.TRN_ID%TYPE,TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pFILOPE ALIAS FOR $1 ;
pTRN_ID ALIAS FOR $2 ;
pFILREC ALIAS FOR $3 ;
pSEQREC ALIAS FOR $4 ;
pNUMPAR ALIAS FOR $5 ;
pSUBPAR ALIAS FOR $6 ;
pGERPAR ALIAS FOR $7 ;
   vFILUSU                       TT_USU.FILUSU%TYPE;
   vCODUSU                       TT_USU.CODUSU%TYPE;
   vFILDIF                       TT_USU.FILDIF%TYPE;
   vSEQDIF                       TT_USU.SEQDIF%TYPE;
   vTIPDIF                       TT_USU.TIPDIF%TYPE;
   QuemLogou                     TRetQuemLogou;
   vComplemento                  CONSTANT VARCHAR(254) := Constante('complemento');
   vVLR_PARCIAIS                 TT_REC.VLRPAR%TYPE;
   vSEQFIN                       TT_FIN.SEQUEN%TYPE;
   vFILPOR                       TD_COB.FILCTA%TYPE;
   vSEQPOR                       TD_COB.SEQCTA%TYPE;
   vTIPPOR                       TD_COB.TIPCTA%TYPE;
   vDATVEN                       TT_REC.DATVEN%TYPE;
   vVLRPAR                       TT_REC.VLRPAR%TYPE;
   vVLREST                       TT_REC.VLRPAR%TYPE;
   nVLRPGT                       TT_REC.VLRPGT%TYPE;
   nVLRDES                       TT_REC.VLRDES%TYPE;
   nVLRTAX                       TT_REC.VLRTAX%TYPE;
   vCODMOE                       TT_REC.CODMOE%TYPE;
   vPORTAD                       TT_REC.PORTAD%TYPE;
   vSIGNAT                       TT_REC.SIGNAT%TYPE;
   vPROX_SUBPAR                  TT_REC.SUBPAR%TYPE;
   vFILTRN                       TT_CFG.FILCTA_TRN%TYPE;
   vSEQTRN                       TT_CFG.SEQCTA_TRN%TYPE;
   vTIPTRN                       TT_CFG.TIPCTA_TRN%TYPE;
   vDOCUME                       VARCHAR(100);
   vCUPFIS                       TT_REC.CUPFIS%TYPE;
   vNUMECF                       TT_REC.NUMECF%TYPE;
   vPAGAME                       TT_REC.PAGAME%TYPE;
   cRETLID                       VARCHAR(2);
   NUMECF_000                    CONSTANT VARCHAR(3) := '000';
   bEXISTE_CCC                   VARCHAR(1);
   vFILCCC                       TT_CCC.CODFIL%TYPE;
   vSEQCCC                       TT_CCC.SEQUEN%TYPE;
   vTIT_PAGA                     INTEGER;
   iTIPCCC                       TT_REC.TIPCCC%TYPE;

   CR_CCC CURSOR FOR
   SELECT CODFIL, SEQUEN
     FROM TT_CCC
    WHERE CODVEN = pFILREC
      AND SEQVEN = pSEQREC
      AND NUMPAR = pNUMPAR
      AND SUBPAR = pSUBPAR;

-- Estorna parcela
-- Gera subparcela se pGERPAR = T
-- Se a venda foi paga a dinheiro faz contra lancamento para a conta de diferenca do usuario
-- Se a venda foi paga por ccc faz contra lancamento na ccc
-- Gera transacao

BEGIN
  -- Verifica se usuario tem conta diferenca
  select * into QuemLogou from DadosLogon();
  IF  QuemLogou.Encontrou
  AND QuemLogou.TemConta THEN
     vFILUSU := QuemLogou.FILUSU;
     vCODUSU := QuemLogou.CODUSU;
     vFILDIF := QuemLogou.FILDIF;
     vSEQDIF := QuemLogou.SEQDIF;
     vTIPDIF := QuemLogou.TIPDIF;
  ELSE
     RAISE EXCEPTION 'PG-20005 Usuario sem conta diferenca. %' , VComplemento;
  END IF;

  IF vTIPDIF = 'G' THEN
    RAISE EXCEPTION 'PG-20010 Conta diferenca do usuario deve ser nominal. %' , VComplemento;
  END IF;

  /*
  -- RFMP 85510
  -- Se o ttulo est pago, este pagamento veio por CNAB.
  -- No deve ser possvel cancelar essa operao porque no a como fazer o banco devolver o dinheiro ao cliente.

  SELECT COUNT(*)
    INTO vTIT_PAGA
    FROM TT_TIT TIT --inner join tt_rtb rtb on RPAD(TIT.NOSNUM,20,' ') = RPAD(rtb.NOSNUM,20,' ')
                    --      AND TO_NUMBER(TIT.CODBCO)=COALESCE(rtb.CBANCO,TO_NUMBER(TIT.CODBCO))
                    --      AND TO_NUMBER(TIT.NUMAGE)=COALESCE(rtb.CODAGE,TO_NUMBER(TIT.NUMAGE))
                    --      AND TO_NUMBER(TIT.CTACRR)=COALESCE(rtb.COD_CC,TO_NUMBER(TIT.CTACRR))
   WHERE TIT.FILREC = pFILREC
     AND TIT.SEQREC = pSEQREC
     AND TIT.PARREC = pNUMPAR
     AND TIT.SUBREC = pSUBPAR
     AND TIT.FLGEST = 'P';

  IF vTIT_PAGA > 0 THEN
    RAISE EXCEPTION 'PG-20015 No  possvel estornar parcela com ttulo pago. %' , VComplemento;
  END IF;
  */

  -- Cancela ttulo
  UPDATE TT_TIT TIT
     SET FLGEST = 'C'
   WHERE TIT.FILREC = pFILREC
     AND TIT.SEQREC = pSEQREC
     AND TIT.PARREC = pNUMPAR
     AND TIT.SUBREC = pSUBPAR
     AND TIT.FLGEST = 'P';

  -- Estorna parcela
  UPDATE TT_REC
     SET FILUSU = vFILUSU,
         CODUSU = vCODUSU,
         FLGEST = 'X',
         ATU_EM = Agora(),
         ESTCAN = Agora()
   WHERE CODFIL = pFILREC
     AND SEQUEN = pSEQREC
     AND NUMPAR = pNUMPAR
     AND SUBPAR = pSUBPAR;

  -- Obtem soma das parcelas abertas
  SELECT SUM(VLRPAR) INTO vVLR_PARCIAIS
    FROM TT_REC
   WHERE CODFIL = pFILREC
     AND SEQUEN = pSEQREC
     AND NUMPAR = pNUMPAR
     AND FLGEST = 'A'
     AND SEQCHE IS NULL
     AND CARTAO IS NULL
     AND SUBPAR > COALESCE(pSUBPAR,' 0');

  -- Obtem dados da parcela
  SELECT REC.DATVEN,
         COALESCE(REC.VLRPGT,0) -
         COALESCE(REC.VLRDES,0) +
         COALESCE(REC.VLRTAX,0) +
         COALESCE(vVLR_PARCIAIS,0) AS VLRPAR,
         COALESCE(REC.VLRPGT,0) +
         COALESCE(REC.VLRTAX,0) AS VLREST,
         REC.VLRPGT,
         REC.VLRDES,
         REC.VLRTAX,
         REC.CODMOE,
         REC.PORTAD,
         REC.SIGNAT,
         REC.CUPFIS,
         REC.NUMECF,
         TRUNC(REC.PAGAME),
         REC.TIPCCC
    INTO vDATVEN, vVLRPAR, vVLREST, nVLRPGT, nVLRDES, nVLRTAX, vCODMOE, vPORTAD, vSIGNAT, vCUPFIS, vNUMECF, vPAGAME, iTIPCCC
    FROM TT_REC REC
   WHERE REC.CODFIL = pFILREC
     AND REC.SEQUEN = pSEQREC
     AND REC.NUMPAR = pNUMPAR
     AND REC.SUBPAR = pSUBPAR;

  -- Proxima subparcela
  SELECT MAX(TO_NUMBER(SUBPAR))+1 INTO vPROX_SUBPAR
    FROM TT_REC
   WHERE CODFIL = pFILREC
     AND SEQUEN = pSEQREC
     AND NUMPAR = pNUMPAR;

  -- Cria subparcela
  IF pGERPAR = 'T' THEN
    IF COALESCE(vVLR_PARCIAIS,0) > 0 THEN
      -- Cancela parcelas
      UPDATE TT_REC
         SET FLGEST = 'C',
             DUMMY  = CONSTANTE('VEM_DE_ESTORNO')
       WHERE CODFIL = pFILREC
         AND SEQUEN = pSEQREC
         AND NUMPAR = pNUMPAR
         AND FLGEST = 'A'
         AND SEQCHE IS NULL
         AND CARTAO IS NULL;
    END IF;

   -- Se nao tem valor a inserir entao sai da funcao
   IF vVLRPAR=0 THEN
      RETURN 'OK';
   END IF;

    -- RFMP 89451
    -- Incluso do TIPCCC no insert da nova parcela.

    -- Nova subparcela
    INSERT INTO TT_REC (
      CODFIL, SEQUEN, NUMPAR, SUBPAR, SUBORI,
      FLGEST, DATVEN, VLRPAR, CODMOE, PORTAD, SIGNAT,
      TIPCCC
    )
    VALUES (
      pFILREC, pSEQREC, pNUMPAR, vPROX_SUBPAR, pSUBPAR,
      'A', vDATVEN, vVLRPAR, vCODMOE, vPORTAD, vSIGNAT,
      iTIPCCC
    );
  END IF;

  -- Se no tem valor a estornar, insere apenas a TT_LID
  IF vVLREST = 0 THEN
    cRETLID := CriaLid(pFILOPE, NUMECF_000, pTRN_ID);
    RETURN 'OK';
  END IF;

  -- Verifica se existe na ccc
  OPEN CR_CCC;
  FETCH CR_CCC INTO vFILCCC, vSEQCCC;
  IF FOUND THEN
    bEXISTE_CCC := 'T';
  ELSE
    bEXISTE_CCC := 'F';
  END IF;
  CLOSE CR_CCC;

  IF bEXISTE_CCC = 'T' THEN
    -- Desconta diretamente do cliente estornado
    INSERT INTO TT_CCC (CODVEN, SEQVEN, NUMPAR, SUBPAR, CODFIL, FILCLI, CODCLI, DATOPE, NUMDOC,
                        FILUSU, CODUSU, VLRLAN, COMPLE, TIPCCC, PLACAS, STATUS, PORORI, DATFIS, TIPLAN)
                (SELECT CODVEN, SEQVEN, NUMPAR, SUBPAR, CODFIL, FILCLI, CODCLI, AGORA(), NUMDOC, FILUSU,
                        CODUSU, VLRLAN*-1,
                        TO_CHAR('ESTORNO REF. ESTORNO PARCELA'), TIPCCC, PLACAS,
                        CASE STATUS WHEN 'A'
                                    THEN 'P'
                                    ELSE 'A'
                         END AS STATUS,
                        PORORI, DATFIS, TO_CHAR('U')
                  FROM TT_CCC
                 WHERE CODVEN = pFILREC
                   AND SEQVEN = pSEQREC
                   AND NUMPAR = pNUMPAR
                   AND SUBPAR = pSUBPAR);

     -- Altera os lanamentos abertos para pagos
     UPDATE TT_CCC
        SET STATUS='P'
      WHERE CODVEN = pFILREC
        AND SEQVEN = pSEQREC
        AND NUMPAR = pNUMPAR
        AND SUBPAR = pSUBPAR
        AND STATUS = 'A'
        AND (COMPLE IS NULL OR COMPLE<>'ESTORNO REF. ESTORNO PARCELA');
  ELSE
    -- Obtem dados da venda
    SELECT COALESCE(VEN.CODSER,'')||'/'||lTrim(COALESCE(VEN.NUMECF,''))||'-'||lTrim(COALESCE(VEN.NUMNOT,''))||
               CASE WHEN COALESCE(VEN.CNT_RO,0)>0 THEN '['||VEN.CNT_RO||']' 
               ELSE '' 
               END||'/'||COALESCE(pNUMPAR,'')||
               CASE WHEN LTRIM(RTRIM(COALESCE(pSUBPAR,''))) IS NULL THEN '' 
               ELSE '-' 
               END||lTrim(COALESCE(pSUBPAR,''))
      INTO vDOCUME
      FROM TT_VEN VEN
     WHERE VEN.CODFIL = pFILREC
       AND VEN.SEQUEN = pSEQREC;

    -- Conta Transferencia
    SELECT CFG.FILCTA_TRN, CFG.SEQCTA_TRN, CFG.TIPCTA_TRN INTO vFILTRN, vSEQTRN, vTIPTRN
      FROM TT_CFG CFG;

    -- Pegar portador
    SELECT FILCTA, SEQCTA, TIPCTA INTO vFILPOR, vSEQPOR, vTIPPOR
      FROM TD_COB
     WHERE CODTAB = vPORTAD;

    -- Gera lancamento financeiro
    SELECT ProximoCodigo('TT_FIN',pFILREC) INTO vSEQFIN FROM DUAL;

    IF vNUMECF <> '000' THEN
      -- Lancamento
      INSERT INTO TT_FIN (
        CODFIL, SEQUEN, FILUSU, CODUSU, DATOPE, DATFIS,
        FILNUM, SEQNUM, TIPNUM, FILGER, SEQGER, TIPGER,
        VLRMOV, OBSERV, NUMDOC, FLGFIN, ORILAN
      )
      VALUES (
        pFILREC, vSEQFIN, vFILUSU, vCODUSU, Agora(), vPAGAME,
        vFILDIF, vSEQDIF, vTIPDIF, vFILTRN, vSEQTRN, vTIPTRN,
        vVLREST * -1,
        'Estorno de Parcela - Chave: ['||pFILREC||'-'||pSEQREC||'-'||pSUBPAR||'-'||pNUMPAR||']',
        vDOCUME,
        'S', 'I'
      );

      -- Contralancamento
      INSERT INTO TT_FIN (
        CODFIL, SEQTRN, FILUSU, CODUSU, DATOPE, DATFIS,
        FILNUM, SEQNUM, TIPNUM, FILGER, SEQGER, TIPGER,
        VLRMOV, OBSERV, NUMDOC, FLGFIN, ORILAN
      )
      VALUES (
        pFILREC, vSEQFIN, vFILUSU, vCODUSU, Agora(), vPAGAME,
        vFILPOR, vSEQPOR, vTIPPOR, vFILTRN, vSEQTRN, vTIPTRN,
        vVLREST,
        'Estorno da Parcela '||vDOCUME||' - Chave: ['||pFILREC||'-'||pSEQREC||'-'||pSUBPAR||'-'||pNUMPAR||']',
        vDOCUME,
        'S', 'I'
      );
    END IF;
  END IF;

  cRETLID := CriaLid(pFILOPE, NUMECF_000, pTRN_ID);

  -- Operacao da rec
  INSERT INTO TT_OPE (
    CODFIL, NUMECF, TRN_ID, CUPFIS, NUMITE, VLROPE, DATOPE,
    FILUSU, CODUSU, FILREC, SEQREC, NUMPAR, SUBPAR
  )
  (
    SELECT pFILOPE, NUMECF_000, pTRN_ID, 0,
           (
           SELECT COALESCE(MAX(NUMITE),0)+1
             FROM TT_OPE
            WHERE CODFIL = pFILOPE
              AND NUMECF = NUMECF_000
              AND TRN_ID = pTRN_ID
           ),
           vVLREST, TRUNC(Agora()),
           vFILUSU, vCODUSU, pFILREC, pSEQREC, pNUMPAR, pSUBPAR
      FROM DUAL
  );

  IF bEXISTE_CCC = 'T' THEN
    -- Operacao da ccc
    INSERT INTO TT_OPE (
      CODFIL, NUMECF, TRN_ID, CUPFIS, NUMITE, VLROPE, DATOPE,
      FILUSU, CODUSU, FILCCC, SEQCCC
    )
    (
      SELECT pFILOPE, NUMECF_000, pTRN_ID, 0,
             (
             SELECT COALESCE(MAX(NUMITE),0)+1
               FROM TT_OPE
              WHERE CODFIL = pFILOPE
                AND NUMECF = NUMECF_000
                AND TRN_ID = pTRN_ID
             ),
             CAST(vVLREST*-1 AS Numeric(16,2)), TRUNC(Agora()),
             vFILUSU, vCODUSU, vFILCCC, vSEQCCC
        FROM DUAL
    );
  ELSE
    IF vNUMECF <> '000' THEN
      -- Operacao da fin
      INSERT INTO TT_OPE (
        CODFIL, NUMECF, TRN_ID, CUPFIS, NUMITE, VLROPE, DATOPE,
        FILUSU, CODUSU, FILFIN, SEQFIN
      )
      (
        SELECT pFILOPE, NUMECF_000, pTRN_ID, 0,
               (
               SELECT COALESCE(MAX(NUMITE),0)+1
                 FROM TT_OPE
                WHERE CODFIL = pFILOPE
                  AND NUMECF = NUMECF_000
                  AND TRN_ID = pTRN_ID
               ),
               CAST(vVLREST*-1 AS Numeric(16,2)), TRUNC(Agora()),
               vFILUSU, vCODUSU, pFILREC, vSEQFIN
          FROM DUAL
      );
    END IF;
  END IF;

  RETURN 'OK';
END;
$$ language 'plpgsql';


/*-- SEQ 1776 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION EstornaParcela () CASCADE;

/*-- SEQ 1777 --*/
CREATE OR REPLACE FUNCTION EstornaParcela () 
RETURNS VARCHAR AS $$
BEGIN
RETURN EstornaParcela(1);
END;
$$ language 'plpgsql';


  /*-- SEQ 1778 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_PROCTIT_CONSTANTE (CHAR) CASCADE;

/*-- SEQ 1779 --*/
CREATE OR REPLACE FUNCTION AUX_PROCTIT_CONSTANTE (CHAR)
RETURNS CHAR AS $$
DECLARE
pNomeConstante ALIAS FOR $1 ;
    cRESULT CHAR;
  BEGIN
    IF    UPPER(pNomeConstante) = 'INCLUIR'                        THEN  cRESULT := 'A';
    ELSIF UPPER(pNomeConstante) = 'CANCELAR'                       THEN  cRESULT := 'C';
    ELSIF UPPER(pNomeConstante) = 'PAGAR_EM_CARTEIRA'              THEN  cRESULT := 'P';
    ELSIF UPPER(pNomeConstante) = 'CONSISTIR'                      THEN  cRESULT := 'I';
    ELSIF UPPER(pNomeConstante) = 'INSTRUCAO_ALTERAR_VALORES'      THEN  cRESULT := 'V';
    ELSIF UPPER(pNomeConstante) = 'INSTRUCAO_ALTERAR_DATA'         THEN  cRESULT := 'D';
    ELSIF UPPER(pNomeConstante) = 'INSTRUCAO_ALTERAR_VALOR'        THEN  cRESULT := 'V';
    ELSIF UPPER(pNomeConstante) = 'INSTRUCAO_CONCESSAO_ABATIMENTO' THEN  cRESULT := 'T';
    END IF;
    RETURN cRESULT;
  END;
$$ language 'plpgsql';



  /*-- SEQ 1780 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_PROCTIT_TrazBanco (TT_REC.PORTAD%TYPE,CHAR) CASCADE;

/*-- SEQ 1781 --*/
CREATE OR REPLACE FUNCTION AUX_PROCTIT_TrazBanco (TT_REC.PORTAD%TYPE,CHAR)
RETURNS TPC_TIT_Record AS $$
DECLARE
p_portador ALIAS FOR $1 ;
p_STATUS ALIAS FOR $2 ;
       wk_retorno TPC_TIT_Record;
       cFILCTA    TD_FIL.CODFIL%TYPE;
     BEGIN

               SELECT B.CODBCO,
                B.NUMAGE,
                B.CTACRR,
                A.CODCCB,
                B.FILCTA,
                B.DIGAGE,
                B.NUMAGE_NOSNUM,
                B.DIGAGE_NOSNUM
           INTO wk_retorno.CODBCO,
                wk_retorno.NUMAGE,
                wk_retorno.CTACRR,
                wk_retorno.CODCCB,
                cFILCTA,
                wk_retorno.DIGAGE,
                wk_retorno.NUMAGE_NOSNUM,
                wk_retorno.DIGAGE_NOSNUM
           FROM TT_CTB B, TD_COB A
          WHERE A.FILCTA = B.FILCTA
            AND A.SEQCTA = B.SEQCTA
            AND A.TIPCTA = B.TIPCTA
            AND A.TIPCTB = B.TIPCTB
            AND A.CODTAB = p_portador;
      
       IF cFILCTA IS NULL THEN -- Erro pois FILCTA nao pode ser NULL
          wk_retorno.STATUS := AUX_PROCTIT_CONSTANTE('consistir');
       ELSE
          wk_retorno.STATUS := p_STATUS;
       END IF;

       RETURN wk_retorno;
     END;
$$ language 'plpgsql';



     /*-- SEQ 1782 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_PROCTIT_TrazCFG (CHAR) CASCADE;

/*-- SEQ 1783 --*/
CREATE OR REPLACE FUNCTION AUX_PROCTIT_TrazCFG (CHAR)
RETURNS TPC_TIT_RecordCFG AS $$
DECLARE
p_STATUS ALIAS FOR $1 ;
       wk_cfg TPC_TIT_RecordCFG;
       cNOMEMP TT_CFG.NOMEMP%TYPE;
     BEGIN

              SELECT INT_CAN_TIT,
                INT_ALT_DAT,
                INT_ALT_VLR,
                INT_PAG_CAR,
                INT_INC_TIT,
                INT_CON_ABA,
                COD_ECB_TIT,
                NOMEMP
           INTO wk_cfg.INT_CAN_TIT,
                wk_cfg.INT_ALT_DAT,
                wk_cfg.INT_ALT_VLR,
                wk_cfg.INT_PAG_CAR,
                wk_cfg.INT_INC_TIT,
                wk_cfg.INT_CON_ABA,
                wk_cfg.COD_ECB_TIT,
                cNOMEMP
           FROM TT_CFG;
     
       -- Verificacao de inconsistencia
       IF wk_cfg.INT_CAN_TIT IS NULL
       OR wk_cfg.INT_ALT_DAT IS NULL
       OR wk_cfg.INT_ALT_VLR IS NULL
       OR wk_cfg.INT_PAG_CAR IS NULL
       OR wk_cfg.INT_INC_TIT IS NULL
       --OR wk_cfg.INT_CON_ABA IS NULL
       OR wk_cfg.COD_ECB_TIT IS NULL       
       OR cNOMEMP IS NULL THEN -- Erro pois NOMEMP e NOT NULL
          wk_cfg.STATUS := AUX_PROCTIT_CONSTANTE('consistir');
       ELSE
          wk_cfg.STATUS := p_STATUS;
       END IF;

       RETURN wk_cfg;

     END;
$$ language 'plpgsql';




     /*-- SEQ 1784 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_PROCTIT_TrazJur (TT_TIT.FILREC%TYPE,TT_TIT.SEQREC%TYPE,TT_TIT.PARREC%TYPE,TT_TIT.SUBREC%TYPE,TT_VEN.FILPGT%TYPE,TT_VEN.CODPGT%TYPE) CASCADE;

/*-- SEQ 1785 --*/
CREATE OR REPLACE FUNCTION AUX_PROCTIT_TrazJur (TT_TIT.FILREC%TYPE,TT_TIT.SEQREC%TYPE,TT_TIT.PARREC%TYPE,TT_TIT.SUBREC%TYPE,TT_VEN.FILPGT%TYPE,TT_VEN.CODPGT%TYPE)
RETURNS TPC_TIT_RecordJur AS $$
DECLARE
p_chave1 ALIAS FOR $1 ;
p_chave2 ALIAS FOR $2 ;
p_chave3 ALIAS FOR $3 ;
p_chave4 ALIAS FOR $4 ;
pFILPGT ALIAS FOR $5 ;
pCODPGT ALIAS FOR $6 ;
       c_default_CODMOR CONSTANT INTEGER := 1;
       c_default_CODDES CONSTANT INTEGER := 2;
       wk_retorno TPC_TIT_RecordJur;
       vFILPGT TT_VEN.FILPGT%TYPE;
       vCODPGT TT_VEN.CODPGT%TYPE;
       cCODFIL CHAR(3);
     BEGIN
      IF (pFILPGT IS NULL) AND (pCODPGT IS NULL) THEN
         
         SELECT VEN.FILPGT, VEN.CODPGT
             INTO vFILPGT, vCODPGT
             FROM TT_VEN VEN, TT_REC REC
            WHERE REC.CODFIL = VEN.CODFIL
              AND REC.SEQUEN = VEN.SEQUEN
              AND REC.CODFIL = p_chave1
              AND REC.SEQUEN = p_chave2
              AND REC.NUMPAR = p_chave3
              AND REC.SUBPAR = p_chave4;
         
      ELSE
         vCODPGT := pCODPGT;
         vFILPGT := pFILPGT;
      END IF;

                SELECT TRUNC(ADD_DAY(REC.DATVEN,PLA.CARMAX)) AS DATMOR,
                PLA.ACRDIA * REC.VLRPAR/100 AS JURMOR,
                ADD_DAY(REC.DATVEN,PLA.DIATIT * -1) AS DATDES,
                coalesce(PLA.BONPGT,0) AS JURDES,
                c_default_CODMOR AS CODMOR,
                c_default_CODDES AS CODDES,
                PLA.CODBAI,
                PLA.PRZBAI,
                PLA.CODPRT,
                PLA.PRZPRT,
                REC.CODFIL
           INTO wk_retorno.DATMOR,
                wk_retorno.JURMOR,
                wk_retorno.DATDES,
                wk_retorno.JURDES,
                wk_retorno.CODMOR,
                wk_retorno.CODDES,
                wk_retorno.CODBAI,
                wk_retorno.PRZBAI,
                wk_retorno.CODPRT,
                wk_retorno.PRZPRT,
                cCODFIL
           FROM TT_PLA PLA, TT_REC REC
          WHERE PLA.FILPGT = vFILPGT
            AND PLA.CODPGT = vCODPGT
            AND REC.CODFIL = p_chave1
            AND REC.SEQUEN = p_chave2
            AND REC.NUMPAR = p_chave3
            AND REC.SUBPAR = p_chave4;
       
       IF cCODFIL IS NULL THEN -- Erro pois REC.CODFIL nao pode ser nulo porque e chave primaria
          wk_retorno.CODMOR := 0;
          wk_retorno.CODDES := 0;
       END IF;

       RETURN wk_retorno;

     END;
$$ language 'plpgsql';




     /*-- SEQ 1786 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_PROCTIT_Atualiza_Titulo (TT_TIT.FILREC%TYPE,TT_TIT.SEQREC%TYPE,TT_TIT.PARREC%TYPE,TT_TIT.SUBREC%TYPE,TT_TIT.CODREM%TYPE,TT_TIT.FLGEST%TYPE,TT_TIT.DUMMY%TYPE,TT_TIT.VLRPAR%TYPE,TT_TIT.DATVEN%TYPE,TT_TIT.JURMOR%TYPE,TT_TIT.FLGEST%TYPE,TT_TIT.DATMOR%TYPE) CASCADE;

/*-- SEQ 1787 --*/
CREATE OR REPLACE FUNCTION AUX_PROCTIT_Atualiza_Titulo (TT_TIT.FILREC%TYPE,TT_TIT.SEQREC%TYPE,TT_TIT.PARREC%TYPE,TT_TIT.SUBREC%TYPE,TT_TIT.CODREM%TYPE,TT_TIT.FLGEST%TYPE,TT_TIT.DUMMY%TYPE,TT_TIT.VLRPAR%TYPE,TT_TIT.DATVEN%TYPE,TT_TIT.JURMOR%TYPE,TT_TIT.FLGEST%TYPE,TT_TIT.DATMOR%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_chave1 ALIAS FOR $1 ;
p_chave2 ALIAS FOR $2 ;
p_chave3 ALIAS FOR $3 ;
p_chave4 ALIAS FOR $4 ;
p_inst ALIAS FOR $5 ;
p_flag ALIAS FOR $6 ;
p_Dummy ALIAS FOR $7 ;
pVLRPAR ALIAS FOR $8 ;
pDatven ALIAS FOR $9 ;
pJURMOR ALIAS FOR $10 ;
pFLGEST ALIAS FOR $11 ;
pDATMOR ALIAS FOR $12 ;
      wk_conta Numeric(10);
     BEGIN
       SELECT COUNT(*) INTO wk_conta FROM tt_tit
        WHERE FILREC = p_chave1
          AND SEQREC = p_chave2
          AND PARREC = p_chave3
          AND SEQCAN IS NULL
          AND COALESCE(DUMMY,'#')  <> Constante('VEM_DE_TGRTB');

       IF wk_conta > 0 THEN
          UPDATE TT_TIT SET CODREM = p_inst,
                            DUMMY = p_Dummy,
                            FLGEST = COALESCE(p_flag,FLGEST),
                            VLRPAR = COALESCE(pVLRPAR,VLRPAR),
                            VLRABT = CASE WHEN pFLGEST = AUX_PROCTIT_CONSTANTE('instrucao_concessao_abatimento')
                                          THEN (VLRORI - pVLRPAR)
                                          ELSE VLRABT
                                     END,
                            DATVEN = COALESCE(pDATVEN,DATVEN),
                            DATMOR = COALESCE(pDATMOR,DATMOR),
                            SUBREC = COALESCE(p_chave4,SUBREC),
                            JURMOR = CASE WHEN (pFLGEST = AUX_PROCTIT_CONSTANTE('instrucao_alterar_valores')) OR
                                               (pFLGEST = AUX_PROCTIT_CONSTANTE('instrucao_concessao_abatimento'))
                                          THEN CASE COALESCE(pJURMOR,0) WHEN 0 THEN NULL
                                                                          ELSE pJURMOR
                                               END
                                          ELSE JURMOR
                                     END
           WHERE FILREC = p_chave1
             AND SEQREC = p_chave2
             AND PARREC = p_chave3
             AND SEQCAN IS NULL
             AND COALESCE(DUMMY,'#')  <> Constante('VEM_DE_TGRTB');

       END IF;
       RETURN NULL;

END;
$$ language 'plpgsql';





     /*-- SEQ 1788 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_PROCTIT_Traz_Carteira (TT_CCB.CODBCO%TYPE,TT_CCB.CODCCB%TYPE,CHAR) CASCADE;

/*-- SEQ 1789 --*/
CREATE OR REPLACE FUNCTION AUX_PROCTIT_Traz_Carteira (TT_CCB.CODBCO%TYPE,TT_CCB.CODCCB%TYPE,CHAR)
RETURNS TPC_TIT_Retorno AS $$
DECLARE
p_chave1 ALIAS FOR $1 ;
p_chave2 ALIAS FOR $2 ;
p_STATUS ALIAS FOR $3 ;
       wk_retorno TPC_TIT_Retorno;
       cCODBCO TT_CCB.CODBCO%TYPE;
     BEGIN

               SELECT LPAD(TO_CHAR(CCB.CARBCO),3,'0'), CCB.CODBCO, CCB.CARCCB, CRB.APECRB
           INTO wk_retorno.NOME, cCODBCO, wk_retorno.CODCNV, wk_retorno.APECRB
           FROM TT_CCB CCB
      LEFT JOIN TT_CRB CRB ON CCB.CODCRB = CRB.CODTAB
          WHERE CCB.CODBCO = p_chave1
            AND CCB.CODCCB = p_chave2;

      
       IF cCODBCO IS NULL THEN -- Erro poir CODBCO e chave primaria, nao pode ser NULL
          wk_Retorno.STATUS := AUX_PROCTIT_CONSTANTE('consistir');
       ELSE
          wk_Retorno.STATUS := p_STATUS;
       END IF;

       RETURN wk_retorno;

     END;
$$ language 'plpgsql';





     /*-- SEQ 1790 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_PROCTIT_Proximo_Numero (TT_TIT.CODBCO%TYPE,TT_TIT.NUMAGE%TYPE,TT_TIT.CTACRR%TYPE,TT_TIT.CODCCB%TYPE,CHAR) CASCADE;

/*-- SEQ 1791 --*/
CREATE OR REPLACE FUNCTION AUX_PROCTIT_Proximo_Numero (TT_TIT.CODBCO%TYPE,TT_TIT.NUMAGE%TYPE,TT_TIT.CTACRR%TYPE,TT_TIT.CODCCB%TYPE,CHAR)
RETURNS TPC_TIT_Retorno AS $$
DECLARE
p_CODBCO ALIAS FOR $1 ;
p_NUMAGE ALIAS FOR $2 ;
p_CTACRR ALIAS FOR $3 ;
p_CODCCB ALIAS FOR $4 ;
p_STATUS ALIAS FOR $5 ;
       crCTBXCCB CURSOR FOR
       SELECT TO_CHAR(TO_NUMBER(SUBSTR(BXC.CODCNV,1,9))) AS CODCNV,
              BXC.CODCED, BXC.CODMOD, BXC.CODTRA, BXC.CODGER
         FROM TT_CTBXCCB BXC
        WHERE BXC.CODBCO = p_CODBCO
          AND BXC.NUMAGE = p_NUMAGE
          AND BXC.CTACRR = p_CTACRR
          AND BXC.CODCCB = p_CODCCB;

        WK_RETORNO TPC_TIT_Retorno;
        cCODBCO    TT_CCB.CODBCO%TYPE;
     BEGIN

       -- rfmp - 63560
       -- pegar proximo numero entre numini e numfim
       -- quando prxtit for menor que numini assumir numini
       -- quando prxtot+1 > numfim ou 999999999999 voltar para numini ou 1
       UPDATE TT_CTB SET PRXTIT = CASE WHEN COALESCE(PRXTIT, 0) + 1 > 999999999999
                                    THEN COALESCE(NUMINI, 1)
                                    ELSE
                                      CASE WHEN COALESCE(PRXTIT, 0) + 1 < COALESCE(NUMINI, 0)
                                        THEN COALESCE(NUMINI, 1)
                                        ELSE COALESCE(PRXTIT, 0) + 1
                                      END
                                  END
        WHERE CODBCO = p_CODBCO
          AND NUMAGE = p_NUMAGE
          AND CTACRR = p_CTACRR;

               SELECT PRXTIT,CODBCO
           INTO wk_retorno.NUMERO,cCODBCO
           FROM TT_CTB
          WHERE CODBCO = p_CODBCO
            AND NUMAGE = p_NUMAGE
            AND CTACRR = p_CTACRR;
      
       IF cCODBCO IS NULL THEN -- Erro porque CODBCO nao pode ser NULL
          wk_Retorno.STATUS := AUX_PROCTIT_CONSTANTE('consistir');
          wk_Retorno.NUMERO := NULL;
       ELSE
          wk_Retorno.STATUS := p_STATUS;
       END IF;

       -- rfmp - 63964
       -- Flvio - 67235
       OPEN crCTBXCCB;
       FETCH crCTBXCCB INTO WK_RETORNO.CODCNV, WK_RETORNO.CODCED, WK_RETORNO.CODMOD, WK_RETORNO.CODTRA, WK_RETORNO.CODGER;
       IF NOT FOUND THEN
          WK_RETORNO.CODCNV := NULL;
          WK_RETORNO.CODCED := NULL;
          WK_RETORNO.CODMOD := NULL;
          WK_RETORNO.CODTRA := NULL;
          WK_RETORNO.CODGER := NULL;
       END IF;
       CLOSE crCTBXCCB;

       RETURN wk_retorno;

     END;
$$ language 'plpgsql';





     /*-- SEQ 1792 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_PROCTIT_Soma_Digito (INTEGER) CASCADE;

/*-- SEQ 1793 --*/
CREATE OR REPLACE FUNCTION AUX_PROCTIT_Soma_Digito (INTEGER)
RETURNS INTEGER AS $$
DECLARE
p_valor ALIAS FOR $1 ;
       wk_calculo INTEGER;
     BEGIN
       wk_calculo := p_valor;

       IF wk_calculo >= 10 THEN
         wk_calculo := to_number(SUBSTR(TO_CHAR(wk_calculo),1,1)) + to_number(SUBSTR(TO_CHAR(wk_calculo),2,1));
       END IF;

       RETURN wk_calculo;
     END;
$$ language 'plpgsql';



      /*-- SEQ 1794 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_PROCTIT_Formata_NosNum (TT_CTB.CODBCO%TYPE,TT_CTB.NUMAGE%TYPE,TT_CTB.DIGAGE%TYPE,TT_CTB.CTACRR%TYPE,TT_CTB.DIGCRR%TYPE,CHAR,CHAR,Numeric,VARCHAR,TT_CCB.CARCCB%TYPE,TT_CRB.APECRB%TYPE,TT_CTBXCCB.CODCNV%TYPE,TT_CTBXCCB.CODCED%TYPE,TT_CTBXCCB.CODMOD%TYPE,TT_CTBXCCB.CODTRA%TYPE,TT_CTBXCCB.CODGER%TYPE) CASCADE;

/*-- SEQ 1795 --*/
CREATE OR REPLACE FUNCTION AUX_PROCTIT_Formata_NosNum (TT_CTB.CODBCO%TYPE,TT_CTB.NUMAGE%TYPE,TT_CTB.DIGAGE%TYPE,TT_CTB.CTACRR%TYPE,TT_CTB.DIGCRR%TYPE,CHAR,CHAR,Numeric,VARCHAR,TT_CCB.CARCCB%TYPE,TT_CRB.APECRB%TYPE,TT_CTBXCCB.CODCNV%TYPE,TT_CTBXCCB.CODCED%TYPE,TT_CTBXCCB.CODMOD%TYPE,TT_CTBXCCB.CODTRA%TYPE,TT_CTBXCCB.CODGER%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_CODBCO ALIAS FOR $1 ;
p_NUMAGE ALIAS FOR $2 ;
p_DIGAGE ALIAS FOR $3 ;
p_CTACRR ALIAS FOR $4 ;
p_DIGCRR ALIAS FOR $5 ;
p_NUMAGE_NOSNUM ALIAS FOR $6 ;
p_DIGAGE_NOSNUM ALIAS FOR $7 ;
p_NOSSO_NUMERO ALIAS FOR $8 ;
p_CODIGO_CARTEIRA_BANCO ALIAS FOR $9 ;
p_CARCCB ALIAS FOR $10 ;
p_APECRB ALIAS FOR $11 ;
p_CODCNV ALIAS FOR $12 ;
p_CODCED ALIAS FOR $13 ;
p_CODMOD ALIAS FOR $14 ;
p_CODTRA ALIAS FOR $15 ;
p_CODGER ALIAS FOR $16 ;
                                                
         cNossoNumeroFormatado         VARCHAR(20);
         cNossoNumero                  VARCHAR(20);
         nTotal                        Numeric;
         nPeso                         Numeric;
         nResto                        Numeric;
         cDigito                       CHAR(2);
         cDigito1                      CHAR(2);
         cDigito2                      CHAR(2);
         nDac                          Numeric;
         nDigito                       Numeric;
         cDV_NossoNumero               CHAR(1);
         cDigcrr                       TT_CTB.DIGCRR%TYPE;
         cBaseNossoNumeroBanrisul      CHAR(8);
         cNossoNumeroSICOOB            VARCHAR(21);
      BEGIN

         /* Realiza formatao do Nosso Nmero de acordo com a regra de cada Banco */
         -- ITAU
         IF p_CodBco = '341' THEN
            cNossoNumeroFormatado    := SUBSTR(p_NUMAGE,2,4) ||
                                          SUBSTR(p_CTACRR,6,5) ||
                                          p_CODIGO_CARTEIRA_BANCO ||
                                          LPAD(TO_CHAR(p_NOSSO_NUMERO),8,'0');
            nTotal := 0;
            nDac := 0;
            FOR i IN 1..20 LOOP
               if MOD(i,2) = 0 then
                  nTotal := AUX_PROCTIT_Soma_Digito(TO_NUMBER(SUBSTR(cNossoNumeroFormatado,i,1)) * 2);
               else
                  nTotal := SUBSTR(cNossoNumeroFormatado,i,1);
               end if;
               nDac := nDac + nTotal;
            END LOOP;
            nDigito := 10 - MOD(nDac,10);
            if nDigito = 10 then
               nDigito := 0;
            end if;

            cNossoNumeroFormatado := LPAD(TO_CHAR(p_NOSSO_NUMERO)||TO_CHAR(nDigito),9,'0');

         -- Santander
         ELSIF p_CodBco = '033' THEN
            cNossoNumeroFormatado := LPAD(trim(to_CHAR(p_NOSSO_NUMERO)),12,'0');

            nTotal := 0;
            nPeso  := 2;
            FOR i IN 1..12 LOOP
            nTotal := nTotal + nPeso * TO_NUMBER(SUBSTR(cNossoNumeroFormatado, 13-i, 1));
               IF nPeso = 9 THEN
                  nPeso := 2;
               ELSE
                  nPeso := nPeso + 1;
               END IF;
            END LOOP;

            nResto := mod(nTotal, 11);

            IF nResto in (0, 1) THEN
               cDigito := '0';
            ELSIF nResto = 10 THEN
               cDigito := '1';
            ELSE
               cDigito := TO_CHAR(11 - nResto);
            END IF;

            -- Paulo K. - O nosso numero eh composto por 13 caracteres, Nosso numero + cDigito verificador.
            cNossoNumeroFormatado := LPAD(trim(to_CHAR(p_NOSSO_NUMERO)) || TRIM(cDigito), 13, '0');
         -- HSBC
         ELSIF p_CodBco = '399' THEN

            cNossoNumeroFormatado    := LPAD(to_CHAR(p_NOSSO_NUMERO),10,'0');

            nTotal := 0;
            nPeso := 2;

            FOR i IN 1..10 LOOP
               nTotal := nTotal + nPeso * TO_NUMBER(COALESCE(SUBSTR(RPAD(TRIM(cNossoNumeroFormatado),20,'0'),11-i,1),'0'));
               IF nPeso = 7 THEN
                  nPeso := 2;
               ELSE
                  nPeso := nPeso + 1;
               END IF;
            END LOOP;

            nTotal := 11 - mod(nTotal,11);

            IF nTotal in (10,11) THEN
            nTotal := 0;
            END IF;

            cNossoNumeroFormatado := LPAD(TRIM(cNossoNumeroFormatado) || TRIM(to_char(nTotal)),11,'0') || RPAD(' ',9,' ');
         -- Bradesco
         ELSIF p_CodBco = '237' THEN

            /* pNUMAGE_NOSNUM indica que possui uma agncia fictcia para clculo dgito
            e para formao do nosso nmero. Feito para Unicred.                    */
            IF LPAD(SUBSTR(TRIM(p_CODIGO_CARTEIRA_BANCO),2,2),2,'0') = '09' AND
            (TRIM(p_NUMAGE_NOSNUM) <> '') THEN
               /* Nosso nmero, respeitando a seguinte lei de formao.
               - Nmero de identificao da cobrana, variando de 1 a 4, conforme a legenda abaixo:
               (1 - Cobrana Registrada; 2 - Sem Registro, 3 - Cobrana Caucionada; 4 - Cobrana Descontada).
               - Nmero da agncia (4 posies).
               - Sequencial numrico de 6 posies, iniciando em 000001.
               - cDigito verificador do nosso nmero:                                        */
               cNossoNumeroFormatado := LPAD(SUBSTR(TRIM(p_CODIGO_CARTEIRA_BANCO),2,2),2,'0')||
                                        SUBSTR(TRIM(p_CARCCB),1,1)||
                                        SUBSTR(COALESCE(p_NUMAGE_NOSNUM,p_NUMAGE),2,4)||
                                        LPAD(trim(to_CHAR(p_NOSSO_NUMERO)),6,'0');
            ELSE
               cNossoNumeroFormatado := LPAD(SUBSTR(TRIM(p_CODIGO_CARTEIRA_BANCO),2,2),2,'0') ||
                                          LPAD(trim(to_CHAR(p_NOSSO_NUMERO)),11,'0');
            END IF;

            nTotal := 0;
            nPeso  := 2;
            FOR i IN 1..13 LOOP
               nTotal := nTotal + nPeso * TO_NUMBER(COALESCE(SUBSTR(RPAD(TRIM(cNossoNumeroFormatado),20,'0'),14-i,1),'0'));
               IF nPeso = 7 THEN
                  nPeso := 2;
               ELSE
                  nPeso := nPeso + 1;
               END IF;
            END LOOP;

            nResto := mod(nTotal,11);
            IF nResto = 1 THEN
               cDigito := 'P';
            ELSE
               cDigito := TO_CHAR(11 - nResto);
            END IF;

            IF cDigito = '11' THEN
               cDigito := '0';
            ELSIF cDigito = '10' THEN
               cDigito := '1';
            END IF;

            IF LPAD(SUBSTR(TRIM(p_CODIGO_CARTEIRA_BANCO),2,2),2,'0') = '09' AND
            (TRIM(p_NUMAGE_NOSNUM) <> '') THEN
               cNossoNumeroFormatado := SUBSTR(TRIM(p_CARCCB),1,1) ||
                                        SUBSTR(COALESCE(p_NUMAGE_NOSNUM,p_NUMAGE),2,4) ||
                                        LPAD(trim(to_CHAR(p_NOSSO_NUMERO)),6,'0') ||
                                        TRIM(cDigito);
            ELSE
               cNossoNumeroFormatado := LPAD(TRIM(TO_CHAR(p_NOSSO_NUMERO)) ||
                                          TRIM(cDigito) ,12,'0') ||
                                          LPAD(' ',8,' ');
            END IF;
         --Banco do Brasil
         ELSIF p_CodBco = '001' THEN

            -- CONVNIO DE 6 POSIES e CARTEIRA 17
            IF LENGTH(TRIM(p_CODCNV)) = 6
            AND p_CODIGO_CARTEIRA_BANCO = '017' THEN

               -- RFMP 81294 - PAVIN
               cNossoNumeroFormatado := TRIM(COALESCE(LPAD(p_CODCNV,6,'0'),''))||LPAD(to_CHAR(p_NOSSO_NUMERO),5,'0');

               -- Calculo do DV (mdulo 11)

               nTotal := 0;
               nPeso  := 9;
               FOR i IN 1..11 LOOP
                  nTotal := nTotal + nPeso * TO_NUMBER(COALESCE(SUBSTR(RPAD(TRIM(cNossoNumeroFormatado),20,'0'),12-i,1),'0'));
                  IF nPeso = 2 THEN
                     nPeso := 9;
                  ELSE
                     nPeso := nPeso - 1;
                  END IF;
               END LOOP;

               nResto := mod(nTotal,11);
               IF nResto < 10 THEN
                  cDigito := TO_CHAR(nResto);
               ELSIF nResto = 10 THEN
                  cDigito := 'X';
               ELSE
                  cDigito := '0';
               END IF;

               -- Nosso nmero + DV
               cNossoNumeroFormatado := cNossoNumeroFormatado || TRIM(cDigito);

            ELSE
               cNossoNumeroFormatado := TRIM(COALESCE(LPAD(p_CODCNV,7,'0'),''))||LPAD(to_CHAR(p_NOSSO_NUMERO),10,'0')|| LPAD(' ',3,' ');
            END IF;
         --Banco BESC
         ELSIF p_CodBco = '027' THEN

            cNossoNumeroFormatado := LPAD(trim(to_CHAR(p_NOSSO_NUMERO)),10,'0');

            nTotal := 0;
            FOR i IN 1..10 LOOP
               nTotal := nTotal + (i-1) * TO_NUMBER(COALESCE(SUBSTR(cNossoNumeroFormatado,i,1),'0'));
            END LOOP;


            --Primeiro cDigito
            cDigito1 := TO_CHAR(mod(nTotal,11));

            IF cDigito1 = '10' THEN
               cDigito1 := '0';
            END IF;

            --Segundo cDigito
            cNossoNumeroFormatado := trim(cNossoNumeroFormatado)||trim(cDigito1)||trim('3');

            nTotal := 0;
            nPeso  := 8;
            FOR i IN 1..12 LOOP
               nTotal := nTotal + nPeso * TO_NUMBER(COALESCE(SUBSTR(cNossoNumeroFormatado,i,1),'0'));
               IF nPeso = 8 THEN
                  nPeso := 9;
               ELSE
                  nPeso := i - 2;
               END IF;
            END LOOP;

            --Segundo cDigito
            cDigito2 := TO_CHAR(mod(nTotal,11));

            IF cDigito2 = '10' THEN
               cDigito2 := '0';
            END IF;

            cNossoNumeroFormatado := LPAD(trim(to_CHAR(cNossoNumeroFormatado)) || TRIM(cDigito2) ,16,'0');


         --Banco CEF - Cobrana Simples (11)
         ELSIF p_CodBco = '104' THEN
            --cNossoNumeroFormatado := LPAD('0',11,'0');
            -- Cobrana Sem Registro (14)
            -- RFMP 78977
            -- cNossoNumeroFormatado := LPAD(to_CHAR(p_NOSSO_NUMERO),11,'0');
            -- LEO 78977
            nTotal := 0;

            -- Sistema SIGCB  mais novo.
            -- Antigo era o SICOB.
            IF COALESCE(p_APECRB,'') = 'SIG14' THEN
               IF p_CODIGO_CARTEIRA_BANCO = '014' THEN

                  -- Formato: XYNNNNNNNNNNNNNNN-D, onde:
                  -- X Modalidade/Carteira de Cobrana (1-Registrada/2-Sem Registro)
                  -- Y Emisso do boleto (4-Beneficirio)
                  -- NNNNNNNNNNNNNNN Nosso Nmero (15 posies livres do Beneficirio)
                  -- D *Dgito Verificador

                  cNossoNumero    := '14'||LPAD(TO_CHAR(p_NOSSO_NUMERO),15,'0');
                  cDV_NossoNumero := Aux_CalculaDACMod11(cNossoNumero,'10;11;','0;0;','F');
                  cNossoNumeroFormatado := cNossoNumero||cDV_NossoNumero;
               ELSE
                  RAISE EXCEPTION 'PG-20001 Carteira nmero: "%" no implementada!' , p_CODIGO_CARTEIRA_BANCO;
               END IF;
            ELSE
            IF p_CODIGO_CARTEIRA_BANCO = '014' THEN
               FOR I IN REVERSE 1..LENGTH(TO_CHAR(p_NOSSO_NUMERO)) LOOP
                  nTotal := nTotal + to_number(SUBSTR(TO_CHAR(p_NOSSO_NUMERO),I,1)) * (LENGTH(TO_CHAR(p_NOSSO_NUMERO)) - I + 2);
               END LOOP;
               nDigito := MOD(nTotal * 12, 11); -- 84970
               if nDigito > 9 then
                  nDigito := 0;
               end if;
                  cNossoNumeroFormatado := to_CHAR('82')||LPAD(to_CHAR(p_NOSSO_NUMERO),12,'0')||nDigito; -- 84970
               ELSIF p_CODIGO_CARTEIRA_BANCO = '012' THEN

               -- RFMP 96958

               -- Para a Carteira 12 (Rpida/CR):
               -- Nosso Nmero informado pelo cliente  partir do que foi
               -- impresso nos bloquetos,  composto da seguinte forma:
               -- 9NNNNNNNNND, onde
               -- 9 = Fixo
               -- NNNNNNNNN = Nmero seqencial
               -- D = Dgito Verificador (mdulo 11)

               /*FOR I IN REVERSE 1..LENGTH(TO_CHAR(p_NOSSO_NUMERO)) LOOP
               nTotal := nTotal + to_number(SUBSTR(TO_CHAR(p_NOSSO_NUMERO),I,1)) * (LENGTH(TO_CHAR(p_NOSSO_NUMERO)) - I + 2);
               END LOOP;
               nDigito := MOD(nTotal * 12, 11); -- 84970
               if nDigito > 9 then
               nDigito := 0;
               end if;
               cNossoNumeroFormatado := to_CHAR('92')||LPAD(to_CHAR(p_NOSSO_NUMERO),12,'0')||nDigito; -- 84970*/

               -- Se o resultado da subtrao for > 9, o dgito verificador ser 0 (zero).
               cNossoNumero    := '9'||LPAD(TO_CHAR(p_NOSSO_NUMERO),9,'0');
               cDV_NossoNumero := Aux_CalculaDACMod11(cNossoNumero,'10;11;','0;0;','F');
               cNossoNumeroFormatado     := cNossoNumero||cDV_NossoNumero;

            ELSE
               RAISE EXCEPTION 'PG-20001 Carteira nmero: "%" no implementada!' , p_CODIGO_CARTEIRA_BANCO;
            END IF;
         END IF;

         --Banco UNICRED
         --       ELSIF p_CodBco = '087' THEN
         /* Nosso nmero, respeitando a seguinte lei de formao.
         - Nmero de identificao da cobrana Unicred, variando de 1 a 4, conforme a legenda abaixo:
         (1 - Cobrana Registrada; 2 - Sem Registro, 3 - Cobrana Caucionada; 4 - Cobrana Descontada).
         - Nmero da agncia Unicred, a qual o cooperado tem conta (4 posies).
         - Sequencial numrico de 6 posies, iniciando em 000001.
         - cDigito verificador do nosso nmero:                                        */
         --          cNossoNumeroFormatado := LPAD(SUBSTR(TRIM(p_CODIGO_CARTEIRA_BANCO),2,2),2,'0')||
         --                           SUBSTR(TRIM(p_CARCCB),1,1)||
         --                           SUBSTR(p_NUMAGE,2,4)||
         --                           LPAD(trim(to_CHAR(p_NOSSO_NUMERO)),6,'0');

         --          nTotal := 0;
         --          nPeso  := 2;
         --          FOR i IN 1..13 LOOP
         --             nTotal := nTotal + nPeso * TO_NUMBER(COALESCE(SUBSTR(TRIM(cNossoNumeroFormatado),i,1),'0'));
         --             IF nPeso = 2 THEN
         --                nPeso := 7;
         --             ELSE
         --                nPeso := nPeso - 1;
         --             END IF;
         --          END LOOP;

         --      nResto := mod(nTotal,11);
         --      IF nResto = 1 THEN
         --         cDigito := 'P';
         --      ELSIF (11 - nResto) > 10 THEN
         --            cDigito := '0';
         --         ELSE
         --            cDigito := TO_CHAR(11 - nResto);
         --      END IF;

         --        cNossoNumeroFormatado := SUBSTR(TRIM(p_CARCCB),1,1) || SUBSTR(p_NUMAGE,2,4)|| LPAD(trim(to_CHAR(p_NOSSO_NUMERO) || TRIM(cDigito)),7,'0');
         --UNIBANCO -
         ELSIF p_CodBco = '409' THEN
            cNossoNumeroFormatado := LPAD('0',20,'0');
         --SICREDI - 748
         ELSIF p_CodBco = '748' THEN
            -- Paulo K. - 89256 : Novo tratamento para SICREDI.
            -- Rhuan - 95941 - Alterao no tratamento
            -- RFMP 96285 - Simplificao do clculo

            -- Nosso nmero: yy/bnnnnn-d
            -- Base para clculo do Mdulo 11: aaaappcccccyybnnnnn

            cNossoNumero   := SUBSTR(p_NUMAGE,2,4)                   -- aaaa
                              ||LPAD(TRIM(p_DIGAGE), 2, '0')         -- pp
                              ||LPAD(TRIM(p_CODCNV),5,'0')           -- ccccc
                              ||TO_CHAR(AGORA(),'YY')                -- yy
                              ||COALESCE(TRIM(p_CODGER),'3')         -- b
                              ||LPAD(TO_CHAR(p_NOSSO_NUMERO),5,'0'); -- nnnnn

            -- Se o resultado da subtrao for 10 (dez) ou 11 (onze), o dgito verificador ser 0 (zero).
            cDV_NossoNumero := Aux_CalculaDACMod11(cNossoNumero,'10;11;','0;0;','F');
            cNossoNumeroFormatado := SUBSTR(cNossoNumero,12,2)                    -- yy
                                       ||SUBSTR(cNossoNumero,14,1)                -- b
                                       ||SUBSTR(cNossoNumero,15,5)                -- nnnnn
                                       ||cDV_NossoNumero;                         -- d

         --Numeric - registrado  7 cDigitos
         ELSIF p_CodBco = '085' THEN --94482

                           SELECT DIGCRR
                 INTO cDigcrr
                 FROM TT_CTB
                WHERE CODBCO = p_CODBCO
                  AND NUMAGE = p_NUMAGE
                  AND CTACRR = p_CTACRR;
            
            -- RFMP 96155
            -- Nosso Nmero: cccccccdnnnnnnnnn
            cNossoNumeroFormatado := LPAD(TO_CHAR(TO_NUMBER(TRIM(p_CTACRR))),7,'0')
                                       ||COALESCE(cDigcrr,' ')
                                       ||LPAD(TO_CHAR(p_NOSSO_NUMERO),9,'0');

         ELSIF p_CodBco = '356' THEN
            cNossoNumeroFormatado := LPAD(to_CHAR(p_NOSSO_NUMERO),7,'0');
         --SAFRA - 422
         ELSIF p_CodBco = '422' THEN
            cNossoNumeroFormatado := LPAD(trim(to_CHAR(p_NOSSO_NUMERO)),8,'0');

            nTotal := 0;
            nPeso  := 9;
            FOR i IN 1..8 LOOP
               nTotal := nTotal + nPeso * TO_NUMBER(SUBSTR(cNossoNumeroFormatado,i,1));
               nPeso := nPeso - 1;
            END LOOP;

            cDigito := TO_CHAR(11 - mod(nTotal,11));

            IF cDigito = '11' THEN
               cDigito := '1';
            ELSIF cDigito = '10' THEN
               cDigito := '0';
            END IF;

            cNossoNumeroFormatado := LPAD(trim(to_CHAR(p_NOSSO_NUMERO)) || TRIM(cDigito) ,9,'0') || LPAD(' ',11,' ');

         -- BANRISUL (RFMP 97988)
         ELSIF p_CodBco = '041' THEN

            cBaseNossoNumeroBanrisul := LPAD(TRIM(TO_CHAR(p_NOSSO_NUMERO)),8,'0');
            cNossoNumeroFormatado := cBaseNossoNumeroBanrisul||DigitoDuploBanrisul(cBaseNossoNumeroBanrisul, 7);
         ELSIF p_CodBco = '756' THEN
            cNossoNumeroSICOOB    := LPAD(SUBSTR(p_NUMAGE,2,4), 4,'0')||
                                     LPAD(TO_CHAR(p_CODCED),10,'0')||
                                     LPAD(TO_CHAR(p_NOSSO_NUMERO),7,'0');
                                     
            -- MN - Loop de 4 + 10 + 7 posies
            -- At aqui consegui debugar e chegar no certo
            -- 03990000019921000003 0399 agncia, 0000019921 Cedente,0000002 prximo nmero, ta certo e testado at aqui 
            
            -- MN - a hora que coloca nTotal := 0, que  o certo, fica estourando erro de valor mto longo para char(2)
            nPeso := 3;
            nTotal := 0;
            FOR i IN 1..21 LOOP
               nTotal := nTotal + nPeso * TO_NUMBER(SUBSTR(cNossoNumeroSICOOB, i, 1));
                           
               -- Deve-se aplicar a constante 3197, ou seja, comea em 3 vai pra 1, depois 9, 7 e volta pra 3            
               IF nPeso = 3 THEN
                  nPeso := 1;
               ELSIF nPeso = 1 THEN
                  nPeso := 9;
               ELSIF nPeso = 9 THEN
                 nPeso := 7;
               else
                 nPeso := 3;
               END IF;
            END LOOP;
            
            -- Calcular o resto atravs do mdulo 11, o resto deve ser subtrado de 11, achando o Dgito Verificador, se o resto for 1 ou 0, ento o DV  0.
            nResto := mod(nTotal, 11);

            IF nResto in (0, 1) THEN
               cDigito := '0';
            ELSE
               cDigito := TO_CHAR(11 - nResto);
            END IF;
            
            cNossoNumeroFormatado := LPAD(TO_CHAR(p_NOSSO_NUMERO), 7, '0') || LPAD(TO_CHAR(cDigito), 1, '0');
         ELSE
            cNossoNumeroFormatado := 'Banco nao tratado';
         END IF;

         RETURN cNossoNumeroFormatado;

      END;
$$ language 'plpgsql';



     /*-- SEQ 1796 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_PROCTIT_Nosso_Numero (CHAR,CHAR,CHAR,Numeric,CHAR,CHAR,CHAR,CHAR,CHAR,CHAR) CASCADE;

/*-- SEQ 1797 --*/
CREATE OR REPLACE FUNCTION AUX_PROCTIT_Nosso_Numero (CHAR,CHAR,CHAR,Numeric,CHAR,CHAR,CHAR,CHAR,CHAR,CHAR)
RETURNS TPC_TIT_Retorno AS $$
DECLARE
p_CODBCO ALIAS FOR $1 ;
p_NUMAGE ALIAS FOR $2 ;
p_CTACRR ALIAS FOR $3 ;
p_CODCCB ALIAS FOR $4 ;
p_STATUS2 ALIAS FOR $5 ;
p_DIGCRR ALIAS FOR $6 ;
p_STATUS ALIAS FOR $7 ;
p_DIGAGE ALIAS FOR $8 ;
p_NUMAGE_NOSNUM ALIAS FOR $9 ;
p_DIGAGE_NOSNUM ALIAS FOR $10 ;
       wk_nosso                      TPC_TIT_Retorno;
       oTIT_RETORNO_CARTEIRA         TPC_TIT_Retorno;
       wk_proximo                    TPC_TIT_Retorno;
       cNossoNumeroFormatado         VARCHAR(254);

     BEGIN
       /* Busca dados da carteira */
              
       SELECT * INTO oTIT_RETORNO_CARTEIRA FROM AUX_PROCTIT_Traz_Carteira(p_CODBCO,p_CODCCB, p_STATUS);
       
       /* Busca prxima sequncia do Nosso Nmero */
              
        SELECT * INTO wk_proximo FROM AUX_PROCTIT_Proximo_Numero(p_CODBCO,p_NUMAGE,p_CTACRR,p_CODCCB,p_STATUS);
       
       /* Realiza formatao do Nosso Nmero de acordo com a regra de cada Banco */
              
       SELECT * INTO cNossoNumeroFormatado FROM AUX_PROCTIT_Formata_NosNum(p_CODBCO, p_NUMAGE, p_DIGAGE, p_CTACRR, p_DIGCRR, p_NUMAGE_NOSNUM, p_DIGAGE_NOSNUM, 
                                                   wk_proximo.NUMERO, 
                                                   oTIT_RETORNO_CARTEIRA.NOME, oTIT_RETORNO_CARTEIRA.CODCNV, oTIT_RETORNO_CARTEIRA.APECRB,
                                                   wk_proximo.CODCNV, wk_proximo.CODCED, wk_proximo.CODMOD, wk_proximo.CODTRA, wk_proximo.CODGER);
       
       -- Monta retorno
       wk_nosso.STATUS := oTIT_RETORNO_CARTEIRA.STATUS;
       wk_nosso.APECRB := oTIT_RETORNO_CARTEIRA.APECRB;
       wk_nosso.NUMERO := wk_proximo.NUMERO;
       wk_nosso.STATUS := wk_proximo.STATUS;
       wk_nosso.NOME   := cNossoNumeroFormatado;

       RETURN wk_nosso;

     END;
$$ language 'plpgsql';




     /*-- SEQ 1798 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AUX_PROCTIT_UPDATE (TT_TIT.CODFIL%TYPE,TT_TIT.FILREC%TYPE,TT_TIT.SEQREC%TYPE,TT_TIT.PARREC%TYPE,TT_TIT.SUBREC%TYPE,TT_TIT.FLGEST%TYPE,TT_REC.PORTAD%TYPE,TT_REC.VLRPAR%TYPE,TT_TIT.DUMMY%TYPE,TT_TIT.DATVEN%TYPE,TT_VEN.FILPGT%TYPE,TT_VEN.CODPGT%TYPE,TT_REC.NOSNUM%TYPE) CASCADE;

/*-- SEQ 1799 --*/
CREATE OR REPLACE FUNCTION AUX_PROCTIT_UPDATE (TT_TIT.CODFIL%TYPE,TT_TIT.FILREC%TYPE,TT_TIT.SEQREC%TYPE,TT_TIT.PARREC%TYPE,TT_TIT.SUBREC%TYPE,TT_TIT.FLGEST%TYPE,TT_REC.PORTAD%TYPE,TT_REC.VLRPAR%TYPE,TT_TIT.DUMMY%TYPE,TT_TIT.DATVEN%TYPE,TT_VEN.FILPGT%TYPE,TT_VEN.CODPGT%TYPE,TT_REC.NOSNUM%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pFILREC ALIAS FOR $2 ;
pSEQREC ALIAS FOR $3 ;
pPARREC ALIAS FOR $4 ;
pSUBREC ALIAS FOR $5 ;
pFLGEST ALIAS FOR $6 ;
pPORTAD ALIAS FOR $7 ;
pVLRORI ALIAS FOR $8 ;
pDUMMY ALIAS FOR $9 ;
dDatven ALIAS FOR $10 ;
pFILPGT ALIAS FOR $11 ;
pCODPGT ALIAS FOR $12 ;
pNOSNUM ALIAS FOR $13 ;

     wk_traz_banco    TPC_TIT_Record;
     wk_traz_cfg      TPC_TIT_RecordCFG;
     wk_traz_juros    TPC_TIT_RecordJur;
     wk_inst          TT_TIT.CODREM%TYPE;
     wk_nosso_num     TPC_TIT_Retorno;
     wk_status        TT_TIT.FLGEST%TYPE;
     bContinuar       Boolean;
     cDUMMY           CHAR(1);
     bVeioDoPackage   boolean;
     wk_datmor        TT_TIT.DATMOR%TYPE;
     pg_dummy VARCHAR(5)
;
     BEGIN
      /* FACA AQUI O TRATAMENTO */
      wk_status   := pFLGEST;
      wk_datmor   :=  null;
            
       select * into wk_traz_cfg from AUX_PROCTIT_TrazCFG(wk_status);
     
      bContinuar  := False;

      IF pFLGEST = AUX_PROCTIT_CONSTANTE('incluir') THEN
                  
         select * into wk_traz_banco from AUX_PROCTIT_TrazBanco(pPORTAD, wk_status);
                  wk_status     := wk_traz_banco.STATUS;

         -- Rhuan - 101038 - Se nosso nmero vier preenchido no deve gerar um novo.
         IF ISNULL(pNOSNUM) = 'T' THEN
                        
            select * into wk_nosso_num from AUX_PROCTIT_Nosso_Numero(wk_traz_banco.CODBCO,wk_traz_banco.NUMAGE,
                                                                     wk_traz_banco.CTACRR,wk_traz_banco.CODCCB,
                                                                     wk_traz_banco.STATUS,wk_traz_banco.DIGCRR,
                                                                     wk_status, wk_traz_banco.DIGAGE,
                                                                     wk_traz_banco.NUMAGE_NOSNUM,
                                                                     wk_traz_banco.DIGAGE_NOSNUM);
                     END IF;

                  
         select * into wk_traz_juros from AUX_PROCTIT_TrazJur(pFILREC,
                                                              pSEQREC,
                                                              pPARREC,
                                                              pSUBREC,
                                                              pFILPGT,
                                                              pCODPGT);
         
         INSERT INTO TT_TIT (CODFIL
                            ,FILREC
                            ,SEQREC
                            ,PARREC
                            ,SUBREC
                            ,FLGEST
                            ,CODBCO
                            ,NUMAGE
                            ,CTACRR
                            ,CODCCB
                            ,CODREM
                            ,CODECB
                            ,CODMOR
                            ,CODDES
                            ,CODBAI
                            ,CODPRT
                            ,DATMOR
                            ,JURMOR
                            ,DATDES
                            ,JURDES
                            ,PRZBAI
                            ,PRZPRT
                            ,NOSNUM
                            ,VLRORI
                            ,DUMMY
                            ,DATVEN
                            ,PORTAD
                            ,VLRPAR)
                     VALUES (pCODFIL
                            ,pFILREC
                            ,pSEQREC
                            ,pPARREC
                            ,pSUBREC
                            ,wk_status
                            ,wk_traz_banco.CODBCO
                            ,wk_traz_banco.NUMAGE
                            ,wk_traz_banco.CTACRR
                            ,wk_traz_banco.CODCCB
                            ,wk_traz_cfg.INT_INC_TIT
                            ,wk_traz_cfg.COD_ECB_TIT
                            ,CASE COALESCE(wk_traz_juros.JURMOR,0) WHEN 0 THEN 0
                                                              ELSE wk_traz_juros.CODMOR
                             END
                            ,CASE COALESCE(wk_traz_juros.JURDES,0) WHEN 0 THEN 0
                                                              ELSE wk_traz_juros.CODDES
                             END
                            ,wk_traz_juros.CODBAI
                            ,wk_traz_juros.CODPRT
                            ,CASE COALESCE(wk_traz_juros.JURMOR,0) WHEN 0 THEN NULL
                                                              ELSE wk_traz_juros.DATMOR
                             END
                            ,CASE COALESCE(wk_traz_juros.JURMOR,0) WHEN 0 THEN NULL
                                                              ELSE wk_traz_juros.JURMOR
                             END
                            ,CASE COALESCE(wk_traz_juros.JURDES,0) WHEN 0 THEN NULL
                                                              ELSE wk_traz_juros.DATDES
                             END
                            ,CASE COALESCE(wk_traz_juros.JURDES,0) WHEN 0 THEN NULL
                                                              ELSE wk_traz_juros.JURDES
                             END
                            ,CASE wk_traz_juros.CODBAI        WHEN 0 THEN NULL
                                                              WHEN 2 THEN NULL
                                                              ELSE wk_traz_juros.PRZBAI
                             END
                            ,CASE wk_traz_juros.CODPRT        WHEN 0 THEN NULL
                                                              WHEN 3 THEN NULL
                                                              ELSE wk_traz_juros.PRZPRT
                             END
                            ,CASE WHEN ISNULL(pNOSNUM) = 'T' THEN wk_nosso_num.NOME ELSE pNOSNUM END
                            ,pVLRORI
                            ,pDUMMY
                            ,dDatven
                            ,pPORTAD
                            ,pVLRORI );

      ELSIF pFLGEST = AUX_PROCTIT_CONSTANTE('cancelar') THEN
         cDummy := AUX_PROCTIT_Atualiza_Titulo(pFILREC,pSEQREC,pPARREC,pSUBREC,null,wk_status,pDUMMY,pVLRORI,dDATVEN,null,pFLGEST,wk_datmor);

      ELSIF pFLGEST = AUX_PROCTIT_CONSTANTE('pagar_em_carteira') THEN
         cDummy := AUX_PROCTIT_Atualiza_Titulo(pFILREC,pSEQREC,pPARREC,pSUBREC,null,wk_status,pDUMMY,pVLRORI,dDATVEN,null,pFLGEST,wk_datmor);

      ELSIF (pFLGEST = AUX_PROCTIT_CONSTANTE('instrucao_alterar_valores')) OR
            (pFLGEST = AUX_PROCTIT_CONSTANTE('instrucao_concessao_abatimento')) THEN
                  
         select * into wk_traz_juros from AUX_PROCTIT_TrazJur(pFILREC,
                                                              pSEQREC,
                                                              pPARREC,
                                                              pSUBREC,
                                                              pFILPGT,
                                                              pCODPGT);
         
         IF pFLGEST = AUX_PROCTIT_CONSTANTE('instrucao_alterar_valores') THEN
            wk_inst := wk_traz_cfg.INT_ALT_VLR;
         ELSE
            wk_inst := wk_traz_cfg.INT_CON_ABA;
         END IF;
         
         IF COALESCE(wk_traz_juros.JURMOR,0) <> 0 THEN
            wk_datmor :=  wk_traz_juros.DATMOR;
         END IF;

         IF wk_inst is not null THEN
            cDummy := AUX_PROCTIT_Atualiza_Titulo(pFILREC,pSEQREC,pPARREC,pSUBREC,wk_inst,NULL,pDUMMY,pVLRORI,dDATVEN,wk_traz_juros.JURMOR,pFLGEST,wk_datmor);
         END IF;
      ELSIF pFLGEST = AUX_PROCTIT_CONSTANTE('instrucao_alterar_data') THEN
         wk_inst := wk_traz_cfg.INT_ALT_DAT;
		 
                  
         select * into wk_traz_juros from AUX_PROCTIT_TrazJur(pFILREC,
                                                              pSEQREC,
                                                              pPARREC,
                                                              pSUBREC,
                                                              pFILPGT,
                                                              pCODPGT);
         		 
         IF COALESCE(wk_traz_juros.JURMOR,0) <> 0 THEN
            wk_datmor :=  wk_traz_juros.DATMOR;
         END IF;
         IF wk_inst is not null THEN
            cDummy := AUX_PROCTIT_Atualiza_Titulo(pFILREC,pSEQREC,pPARREC,pSUBREC,wk_inst,NULL,pDUMMY,pVLRORI,dDATVEN,null,pFLGEST,wk_datmor);
         END IF;
      END IF;

      RETURN 'OK';

     END;
$$ language 'plpgsql';



/*-- SEQ 1800 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PROCESSATITULOS (TT_VEN.FILPGT%TYPE,TT_VEN.CODPGT%TYPE) CASCADE;

/*-- SEQ 1801 --*/
CREATE OR REPLACE FUNCTION PROCESSATITULOS (TT_VEN.FILPGT%TYPE,TT_VEN.CODPGT%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILPGT ALIAS FOR $1 ;
pCODPGT ALIAS FOR $2 ;

cr_lancamentos CURSOR FOR
     SELECT CODFIL,SEQUEN,NUMPAR,FLGEST,TITBAI
       FROM TM_TIT
      where flgest='P';

  cCodfil    TM_TIT.CODFIL%TYPE;
  cSequen    TM_TIT.SEQUEN%TYPE;
  cNumpar    TM_TIT.NUMPAR%TYPE;
  cFlgest    TM_TIT.FLGEST%TYPE;
  cTitbai    TM_TIT.TITBAI%TYPE;

  cRecSubpar TT_REC.SUBPAR%TYPE;
  dRecDatven TT_REC.DATVEN%TYPE;
  cRecPortad TT_REC.PORTAD%TYPE;
  cRecVlrpar TT_REC.VLRPAR%TYPE;
  cRecNosnum TT_REC.NOSNUM%TYPE;

  cTitSubpar TT_TIT.SUBREC%TYPE;
  dTitDatven TT_TIT.DATVEN%TYPE;
  cTitPortad TT_TIT.PORTAD%TYPE;
  cTitVlrpar TT_TIT.VLRPAR%TYPE;
  cTitFlgEst TT_TIT.FLGEST%TYPE;
  nTitVlrOri TT_TIT.VLRORI%TYPE;
  
  bNOVO_TIT_PAG_AJ_PARC          VARCHAR(1);
  cInstrucao                     TT_TIT.FLGEST%TYPE; 

  cDummy VARCHAR(10);

BEGIN

    UPDATE TM_TIT
       SET FLGEST='P'
     WHERE FLGEST='N';

    OPEN CR_Lancamentos;
    LOOP
      FETCH CR_Lancamentos INTO cCodfil, cSequen, cNumpar, cFlgest, cTitbai;
      EXIT WHEN NOT FOUND;

      -- Pega a parcela atualmente aberta
            select SUBPAR, DATVEN, PORTAD, VLRPAR, NOSNUM
        into cRecSubpar, dRecDatven, cRecPortad, cRecVlrpar, cRecNosnum
       from tt_rec
      where codfil=cCodfil
        and sequen=cSequen
        and numpar=cNumpar
        and flgest='A';
      
      -- Pega o ttulo atualmente aberto
            select SUBREC, DATVEN, PORTAD, VLRPAR, FLGEST, VLRORI
        into cTitSubpar, dTitDatven, cTitPortad, cTitVlrpar, cTitFlgEst, nTitVlrOri
       from tt_tit
      where FILREC=cCodfil
        and SEQREC=cSequen
        and PARREC=cNumpar
        and FLGEST in ('A','I','T','P');
      
      -- Se a parcela gera titulo e no tem ttulo aberto insere novo titulo
      IF cRecPortad IS NOT NULL AND TGR_GeraTitulo(cRecPortad) and cTitSubpar IS NULL THEN
          cDummy:=AUX_PROCTIT_UPDATE(cCodfil,cCodfil,cSequen,cNumpar,cRecSubpar,
                                     AUX_PROCTIT_CONSTANTE('incluir'),
                                     cRecPortad,cRecVlrpar,null,
                                     dRecDatven, pFILPGT, pCODPGT, cRecNosnum);
      END IF;

      -- RFMP 95874
      -- Desfazendo alterao da tarefa 85510.
      -- Revertendo para deixar a alterao da tarefa 85470 funcionando novamente.
      -- Quando ttulo estiver pago no pode fazer mais nada com ele.

      IF COALESCE(CTitFlgEst,' ') <> 'P' THEN

         -- Se no tem mais parcela ou a parcela atual no gera ttulo cancela o ttulo
         IF (cRecSubpar IS NULL OR (NOT TGR_GeraTitulo(cRecPortad))) AND cTitSubpar IS NOT NULL THEN
             cDummy:=AUX_PROCTIT_UPDATE( cCodfil,cCodfil,cSequen,cNumpar,null,
                                         AUX_PROCTIT_CONSTANTE('cancelar'),
                                         null,null,null, null, pFILPGT, pCODPGT, null);
         END IF;

         -- Alteracao de data de vencimento
         IF dTitDatven<>dRecDatven AND TGR_GeraTitulo(cRecPortad) THEN
             cDummy:=AUX_PROCTIT_UPDATE( cCodfil,cCodfil,cSequen,cNumpar,cRecSubpar,
                                         AUX_PROCTIT_CONSTANTE('instrucao_alterar_data'),
                                         cRecPortad,cRecVlrpar,null, dRecDatven, pFILPGT, pCODPGT, null);
         END IF;
                  
         -- Alteracao de valor
         IF cTitVlrpar<>cRecVlrpar AND TGR_GeraTitulo(cRecPortad) THEN
         
            IF cRecVlrpar > nTitVlrOri THEN
               --RAISE EXCEPTION 'PG-20001 ERRO 1 - cRecVlrpar: "%" / nTitVlrOri: "%"' , cRecVlrpar,nTitVlrOri;
               
               cDummy:=AUX_PROCTIT_UPDATE( cCodfil,cCodfil,cSequen,cNumpar,null,
                                           AUX_PROCTIT_CONSTANTE('cancelar'),
                                           null,null,null, null, pFILPGT, pCODPGT, null);
               cDummy:=AUX_PROCTIT_UPDATE(cCodfil,cCodfil,cSequen,cNumpar,cRecSubpar,
                                          AUX_PROCTIT_CONSTANTE('incluir'),
                                          cRecPortad,cRecVlrpar,null,
                                          dRecDatven, pFILPGT, pCODPGT, NULL);
                                           
            ELSE
               --RAISE EXCEPTION 'PG-20001 ERRO 2 - cTitVlrpar: "%" / nTitVlrOri: "%"' , cTitVlrpar,nTitVlrOri;
               
               -- Se estiver configurado para no criar nova parcela no ajuste de valor, manda a instruo de
               -- Concesso de Abatimento
               bNOVO_TIT_PAG_AJ_PARC := LeParametroBoo('NOVO_TIT_PAG_AJ_PARC', cCodfil, NULL, NULL, NULL);            
               IF bNOVO_TIT_PAG_AJ_PARC = 'T' THEN
                 cInstrucao := AUX_PROCTIT_CONSTANTE('instrucao_alterar_valores');
               ELSE
                 cInstrucao := AUX_PROCTIT_CONSTANTE('instrucao_concessao_abatimento');
               END IF;        
               
               cDummy:=AUX_PROCTIT_UPDATE( cCodfil,cCodfil,cSequen,cNumpar,cRecSubpar,
                                           cInstrucao,
                                           cRecPortad,cRecVlrpar,null, dRecDatven, pFILPGT, pCODPGT, null);            
            END IF;
         END IF;

         -- Alteracao de portador
         IF cTitPortad<>cRecPortad AND TGR_GeraTitulo(cTitPortad) AND TGR_GeraTitulo(cRecPortad)  THEN
             cDummy:=AUX_PROCTIT_UPDATE( cCodfil,cCodfil,cSequen,cNumpar,null,
                                         AUX_PROCTIT_CONSTANTE('cancelar'),
                                         null,null,null, null, pFILPGT, pCODPGT, null);
             cDummy:=AUX_PROCTIT_UPDATE( cCodfil,cCodfil,cSequen,cNumpar,cRecSubpar,
                                         AUX_PROCTIT_CONSTANTE('incluir'),
                                         cRecPortad,cRecVlrpar,null,
                                         dRecDatven, pFILPGT, pCODPGT, null);
         END IF;
      END IF;

    END LOOP;
    CLOSE CR_Lancamentos;

    -- Excluir ja Processados
    DELETE FROM TM_TIT
     WHERE FLGEST='P';


    RETURN 'OK';

END;
$$ language 'plpgsql';


/*-- SEQ 1802 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PROCESSATITULOS () CASCADE;

/*-- SEQ 1803 --*/
CREATE OR REPLACE FUNCTION PROCESSATITULOS () 
RETURNS VARCHAR AS $$
BEGIN
RETURN PROCESSATITULOS(NULL,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1804 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ResumodeParcela (TT_VEN.CODFIL%TYPE,TT_VEN.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE) CASCADE;

/*-- SEQ 1805 --*/
CREATE OR REPLACE FUNCTION ResumodeParcela (TT_VEN.CODFIL%TYPE,TT_VEN.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE)
RETURNS VARCHAR AS $$
DECLARE
PCodFil ALIAS FOR $1 ;
PSequen ALIAS FOR $2 ;
PNumPar ALIAS FOR $3 ;
PSubPar ALIAS FOR $4 ;
  nResultado VARCHAR(4000);
  i          Numeric(5);
  REC_TEXTO  VARCHAR(4000);

-- A string tem o formato abaixo:
--
-- 10/01/2003, R$ 300,00 - Carta Frete - Paga
-- 15/01/1003, R$ 200,00 - Cheque - Aberta
--
-- Onde
-- Data - Data de vencimento se aberta, ou de pagamento se no
-- Valor - Valor da parcela se aberta, ou de pagamento se no
-- Meio - Forma de pagamento
-- Situao - Situao da parcela (Aberta, Paga, Estornada)

  crResumoParcelas CURSOR FOR
   SELECT DATA || ', ' || VALOR || ': ' || MEIO AS TEXTO
   FROM (
     SELECT TO_CHAR(CASE WHEN REC.FLGEST='P' OR 
                              SEQCHE IS NOT NULL OR 
                              CARTAO IS NOT NULL THEN REC.PAGAME
                         WHEN REC.FLGEST='X' THEN REC.ESTCAN
                         WHEN REC.FLGEST='A' THEN REC.DATVEN  
                    END , 'DD/MM/YYYY') AS DATA,
            'R$ ' || TRIM(TO_CHAR(CASE WHEN REC.FLGEST='P' OR 
                                                       SEQCHE IS NOT NULL OR 
                                                       CARTAO IS NOT NULL THEN REC.VLRPGT 
                                                  WHEN REC.FLGEST='X' THEN REC.VLRPGT 
                                                  WHEN REC.FLGEST='A' THEN REC.VLRPAR                                                             
                                             END ,'9G999G999G990D00')) AS VALOR,
            COALESCE(MEIODEPAGAMENTO(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR),'Indefinido') AS MEIO
     FROM TT_REC REC
     WHERE REC.CODFIL = PCodFil
       AND REC.SEQUEN = PSequen
       AND REC.NUMPAR = COALESCE(PNumPar,REC.NUMPAR)
       AND REC.SUBPAR = COALESCE(PSubPar,REC.SUBPAR)
       AND REC.FLGEST <> 'C'
     ORDER BY NUMPAR, SUBPAR) int;

begin
   nResultado := '';
   i := 0;
   OPEN crResumoParcelas;
   LOOP
   FETCH crResumoParcelas into REC_TEXTO;
   EXIT WHEN NOT FOUND;
     if i = 0 then
       nResultado := REC_TEXTO;
     else
       nResultado := LTRIM(RTRIM(COALESCE(nResultado,''))) || chr(13) || chr(10) || COALESCE(REC_TEXTO,'');
     end if;
     i := i + 1;
   end loop;
   CLOSE crResumoParcelas;

   return nResultado;
END;
$$ language 'plpgsql';


/*-- SEQ 1806 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ResumodeParcela (TT_VEN.CODFIL%TYPE,TT_VEN.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1807 --*/
CREATE OR REPLACE FUNCTION ResumodeParcela (TT_VEN.CODFIL%TYPE,
                               TT_VEN.SEQUEN%TYPE) 
RETURNS VARCHAR AS $$
BEGIN
RETURN ResumodeParcela($1,$2,NULL,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 1808 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SUGESTAOCOMPRA (INTEGER,Timestamp,Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,VARCHAR,Numeric,Numeric,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1809 --*/
CREATE OR REPLACE FUNCTION SUGESTAOCOMPRA (INTEGER,Timestamp,Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,VARCHAR,Numeric,Numeric,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR)
RETURNS Numeric AS $$
DECLARE
TipoProjecao ALIAS FOR $1 ;
dhDataIni ALIAS FOR $2 ;
dhDataFim ALIAS FOR $3 ;
dhManterAte ALIAS FOR $4 ;
pFilMat ALIAS FOR $5 ;
pCodMat ALIAS FOR $6 ;
pCodCor ALIAS FOR $7 ;
pCodTam ALIAS FOR $8 ;
pCodFil ALIAS FOR $9 ;
NovPro ALIAS FOR $10 ;
PercVenda ALIAS FOR $11 ;
pQtdMaxPto ALIAS FOR $12 ;
pConsideraTransf ALIAS FOR $13 ;
pReposicaoParaQtdMin ALIAS FOR $14 ;
pSugestaoPara ALIAS FOR $15 ;
pConsideraPedReposPend ALIAS FOR $16 ;
pIgnoraFilialDeposito ALIAS FOR $17 ;
pIgnoraLoteEconomico ALIAS FOR $18 ;
pConsideraQtdReposicaoGrade ALIAS FOR $19 ;
--
-- pSugestaoPara - C - Sugesto para Pedido de Compra
--                 R - Sugesto para Pedido de Reposio
--                 D - Sugesto para Distribuio de Estoque
--                 P - Sugesto para Cotao de Preo para Fornecedor

-- Testes no PostGre use
-- 4,01/01/2002,04/04/2004,04/04/2004,"001"," 2779",0,0,"001"
   PedidosDeFilial               VARCHAR(4000);
   QtdSugerida                   Numeric (12,4) DEFAULT 0;
   DiasFuturos                   INTEGER;
   DiasAvaliados                 INTEGER;
   SazonalAnterior               INTEGER DEFAULT 1;
   SazonalFutura                 INTEGER DEFAULT 0;
   QtdVendida                    Numeric  DEFAULT 0;
   MediaVendas                   Numeric  DEFAULT 0;
   nPedidoPendente               Numeric  DEFAULT 0;
   nQtdEmTransito                Numeric  DEFAULT 0;
   nSaldoProduto                 Numeric  DEFAULT 0;
   nLoteEconomico                Numeric  DEFAULT 1;
   wk_QtdRep                     TT_SAL.QTDREP%TYPE;
   wk_MinQtd                     TT_SAL.QTDMIN%TYPE;
   wk_PtoPed                     TT_SAL.PTOPED%TYPE;
   wk_QtdMax                     TT_SAL.QTDMAX%TYPE;
   wk_DistribuicaoQtdMinZero     TT_SAL.DISMINZER%TYPE;
   PrimeiroLancto                Timestamp;
   PrimeiraData                  Timestamp  DEFAULT TRUNC( agora() );
   UltimaData                    Timestamp  DEFAULT TRUNC( agora() );
   DataIni                       Timestamp;
   DataFim                       Timestamp;
   ManterAte                     Timestamp;
   aSaz                          Numeric[];
   bAceitaDecimal                TT_PRO.DECIMA%TYPE;
   nPercVenda                    Numeric DEFAULT 1;
   nQtdest                       Numeric  DEFAULT 0;
   cFilialMatriz                 TT_IDF.CODDEP%TYPE;
   bEhDeposito                   VARCHAR(1);
   nPedidoPendenteEnt            Numeric (12,4) DEFAULT 0;
   nPedidoPendenteSai            Numeric (12,4) DEFAULT 0;
   bHeaderKit                    VARCHAR(1);
   
   cRetorno                      VARCHAR(254);
   cFilmatRetorno                TT_GRA.FILMAT%TYPE;
   cCodmatRetorno                TT_GRA.CODMAT%TYPE;
   nCodcorRetorno                TT_GRA.CODCOR%TYPE;
   nCodtamRetorno                TT_GRA.CODTAM%TYPE;
   
   Rec                           RecORd;
   Temp                          VARCHAR;

   FilialMatriz CURSOR FOR
   SELECT CODDEP FROM TT_IDF;

   SaldoProduto CURSOR(Filial TT_GRA.FILMAT%TYPE,
           Codigo TT_GRA.CODMAT%TYPE,
           Cor TT_GRA.CODCOR%TYPE,
           Tamanho TT_GRA.CODTAM%TYPE,
           pConsideraQtdReposicaoGrade VARCHAR) IS
   SELECT SUM( CASE WHEN GRA.GERSUG = 'T' THEN COALESCE(SALDOKIT(Agora(), GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, pCodFil, SAL.CODMUL), 0)-- MN - Headers de kit
                                          ELSE COALESCE(SAL.QTDEST, 0) -- MN - Itens que no so headers
               END - COALESCE(SAL.RESERV,0)
             ) AS SALDO,
          CASE WHEN pConsideraQtdReposicaoGrade = 'F'
            THEN CASE WHEN SUM(COALESCE(SAL.QTDREP,0)) > 0 THEN SUM(COALESCE(SAL.QTDREP,0)) ELSE MIN(COALESCE(GRA.QTDREP,0)) END 
            ELSE MIN(COALESCE(GRA.QTDREP,0))
          END AS QTDREP,
          SUM(COALESCE(SAL.QTDMIN,GRA.MINQTD,0)) AS QTDMIN,
          SUM(COALESCE(SAL.PTOPED,GRA.PTOQTD,0)) AS PTOPED,
          SUM(COALESCE(SAL.QTDMAX,0)) AS QTDMAX,
          SUM(CASE WHEN GRA.GERSUG = 'T' THEN COALESCE(SALDOKIT(Agora(), GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, pCodFil, SAL.CODMUL), 0)-- MN - Headers de kit
                                         ELSE COALESCE(SAL.QTDEST, 0) -- MN - Itens que no so headers
               END
              ) AS QTDEST,
          MIN(GRA.GERSUG) -- Indica se a gerao da sugesto  realizada no Headers de kit
     FROM TT_GRA GRA
    INNER JOIN TT_SAL SAL ON SAL.FILMAT = GRA.FILMAT AND SAL.CODMAT = GRA.CODMAT
                         AND SAL.CODCOR = GRA.CODCOR AND SAL.CODTAM = GRA.CODTAM
    INNER JOIN TD_MUL DMUL ON DMUL.CODTAB = SAL.CODMUL
    WHERE GRA.FILMAT = Filial
      AND GRA.CODMAT = Codigo
      AND GRA.CODCOR = Cor
      AND GRA.CODTAM = Tamanho
      AND DMUL.SUGEST = 'T';

   SaldoProdutoFilial CURSOR(Filial TT_GRA.FILMAT%TYPE,
           Codigo TT_GRA.CODMAT%TYPE,
           Cor TT_GRA.CODCOR%TYPE,
           Tamanho TT_GRA.CODTAM%TYPE,
           pCodFilSal VARCHAR,
           pConsideraQtdReposicaoGrade VARCHAR) IS
   SELECT SUM( CASE WHEN GRA.GERSUG = 'T' THEN COALESCE(SALDOKIT(Agora(), GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, SAL.CODFIL, SAL.CODMUL), 0)-- MN - Headers de kit
                                          ELSE COALESCE(SAL.QTDEST,0) -- MN - Itens que no so headers
               END -  COALESCE(SAL.RESERV,0)
             ) AS SALDO,
          CASE WHEN pConsideraQtdReposicaoGrade = 'F'
            THEN CASE WHEN SUM(COALESCE(SAL.QTDREP,0)) > 0 THEN SUM(COALESCE(SAL.QTDREP,0)) ELSE MIN(COALESCE(GRA.QTDREP,0)) END 
            ELSE MIN(COALESCE(GRA.QTDREP,0))
          END AS QTDREP,
          SUM(COALESCE(SAL.QTDMIN,GRA.MINQTD,0)) AS QTDMIN,
          SUM(COALESCE(SAL.PTOPED,GRA.PTOQTD,0)) AS PTOPED,
          SUM(COALESCE(SAL.QTDMAX,0)) AS QTDMAX,
          SUM(CASE WHEN GRA.GERSUG = 'T' THEN COALESCE(SALDOKIT(Agora(), GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, SAL.CODFIL, SAL.CODMUL), 0)-- MN - Headers de kit
                                         ELSE COALESCE(SAL.QTDEST, 0) -- MN - Itens que no so headers
               END
              ) AS QTDEST,
          -- MN - 2019065325 - Coluna utilizada somente em distribuio, o MIN foi colocado para no precisar de outro cursor, quando for Pedido de compra/reposio
          -- o valor dessa coluna no far diferena, e quando for distribuio ter filtro por filial, ento o valor ser nico
          MIN(COALESCE(SAL.DISMINZER, 'T')) AS DISMINZER,
          MIN(GRA.GERSUG) -- Indica se a gerao da sugesto  realizada no Headers de kit
     FROM TT_GRA GRA
    INNER JOIN TT_SAL SAL ON SAL.FILMAT = GRA.FILMAT AND SAL.CODMAT = GRA.CODMAT
                         AND SAL.CODCOR = GRA.CODCOR AND SAL.CODTAM = GRA.CODTAM
    INNER JOIN TD_MUL DMUL ON DMUL.CODTAB = SAL.CODMUL
    WHERE GRA.FILMAT = Filial
      AND GRA.CODMAT = Codigo
      AND GRA.CODCOR = Cor
      AND GRA.CODTAM = Tamanho
      AND INSTR(COALESCE(pCodFilSal, SAL.CODFIL)||';', SAL.CODFIL||';') > 0
      AND DMUL.SUGEST = 'T';

   Sazonalidade CURSOR(Filial TT_GRA.FILMAT%TYPE,
           Codigo TT_GRA.CODMAT%TYPE) IS
   SELECT  COALESCE(SAZ.SAZ001,0) as SAZ001, COALESCE(SAZ.SAZ002,0) as SAZ002,
           COALESCE(SAZ.SAZ003,0) as SAZ003, COALESCE(SAZ.SAZ004,0) as SAZ004,
           COALESCE(SAZ.SAZ005,0) as SAZ005, COALESCE(SAZ.SAZ006,0) as SAZ006,
           COALESCE(SAZ.SAZ007,0) as SAZ007, COALESCE(SAZ.SAZ008,0) as SAZ008,
           COALESCE(SAZ.SAZ009,0) as SAZ009, COALESCE(SAZ.SAZ010,0) as SAZ010,
           COALESCE(SAZ.SAZ011,0) as SAZ011, COALESCE(SAZ.SAZ012,0) as SAZ012,
           COALESCE(SAZ.SAZ001,0) as SAZ013, COALESCE(SAZ.SAZ002,0) as SAZ014,
           COALESCE(SAZ.SAZ003,0) as SAZ015, COALESCE(SAZ.SAZ004,0) as SAZ016,
           COALESCE(SAZ.SAZ005,0) as SAZ017, COALESCE(SAZ.SAZ006,0) as SAZ018,
           COALESCE(SAZ.SAZ007,0) as SAZ019, COALESCE(SAZ.SAZ008,0) as SAZ020,
           COALESCE(SAZ.SAZ009,0) as SAZ021, COALESCE(SAZ.SAZ010,0) as SAZ022,
           COALESCE(SAZ.SAZ011,0) as SAZ023, COALESCE(SAZ.SAZ012,0) as SAZ024
     FROM TD_SAZ SAZ, TT_PRO PRO
    WHERE PRO.FILMAT = Filial
      AND PRO.CODMAT = Codigo
      AND SAZ.CODTAB = PRO.CODSAZ;

   MovtoInicial CURSOR(Filial TT_GRA.FILMAT%TYPE,
           Codigo TT_GRA.CODMAT%TYPE,
           Cor TT_GRA.CODCOR%TYPE,
           Tamanho TT_GRA.CODTAM%TYPE) IS
   SELECT MIN( RMOV.DATMOV )
     FROM TR_MOV RMOV
    WHERE RMOV.FILMAT = Filial
      AND RMOV.CODMAT = Codigo
      AND RMOV.CODCOR = Cor
      AND RMOV.CODTAM = Tamanho;

   MovtoInicialFilial CURSOR(Filial TT_GRA.FILMAT%TYPE,
           Codigo TT_GRA.CODMAT%TYPE,
           Cor TT_GRA.CODCOR%TYPE,
           Tamanho TT_GRA.CODTAM%TYPE,
           pCodFilMov VARCHAR) IS
   SELECT MIN( RMOV.DATMOV )
     FROM TR_MOV RMOV
    WHERE RMOV.FILMAT = Filial
      AND RMOV.CODMAT = Codigo
      AND RMOV.CODCOR = Cor
      AND RMOV.CODTAM = Tamanho
      AND INSTR(COALESCE(pCodFilMov, RMOV.CODFIL)||';', RMOV.CODFIL||';') > 0;

-- Principal
begin

   -- Retira a hora das datas e ajusta datas se incorretas
   DataIni   := TRUNC( dhDataIni );
   DataFim   := TRUNC( dhDataFim );
   ManterAte := TRUNC( dhManterAte );

   IF DataIni >  TRUNC( agora() ) THEN
      DataIni := TRUNC( agora() );
   END IF;

   -- RFMP 67345
   IF DataFim is null THEN
      DataFim := TRUNC( agora() );
   END IF;

   IF ManterAte <  TRUNC( agora() ) THEN
      ManterAte := TRUNC( agora() );
   END IF;

   IF DataFim < DataIni THEN
      DataFim := DataIni;
   END IF;

   IF ManterAte < DataFim THEN
      ManterAte := DataFim;
   END IF;

   SELECT DECIMA
     INTO bAceitaDecimal
     FROM TT_PRO
    WHERE FILMAT = pFILMAT
      AND CODMAT = pCODMAT;

   IF (TipoProjecao = 2)
   OR (TipoProjecao = 3)
   OR (TipoProjecao = 4) THEN
      nPercVenda := PercVenda;
   END IF;
   
   -- Saldo atual do produto
   IF ISNULL(pCodFil)='T' THEN
      Open SaldoProduto( pFilMat, pCodMat, pCodCor, pCodTam, pConsideraQtdReposicaoGrade);
      Fetch SaldoProduto into nSaldoProduto, wk_QtdRep, wk_MinQtd, wk_PtoPed, wk_QtdMax, nQtdest, bHeaderKit;
      Close SaldoProduto;
   ELSE
      Open SaldoProdutoFilial( pFilMat, pCodMat, pCodCor, pCodTam, pCodFil, pConsideraQtdReposicaoGrade);
      Fetch SaldoProdutoFilial into nSaldoProduto, wk_QtdRep, wk_MinQtd, wk_PtoPed, wk_QtdMax, nQtdest, wk_DistribuicaoQtdMinZero, bHeaderKit;
      Close SaldoProdutoFilial;
   END IF;



   -- Quando Sugesto para Distribuio, Filial for o prprio Depsito, desconsidera Saldo atual.
   -- pIgnoraFilialDeposito = True quando marca opo para NO considerar a filial de depsito na tela sugesto de compra
   IF (pSugestaoPara='D') OR (pIgnoraFilialDeposito = 'T') THEN
      -- Busca Filial Matriz
      IF ISNULL(pCodFil)='T' THEN
         Open FilialMatriz;
         Fetch FilialMatriz into cFilialMatriz;
         Close FilialMatriz;
      END IF;

      -- Busca Filial de Depsito
      
      SELECT CAST('T' AS VARCHAR(1)) AS EhDeposito
        INTO bEhDeposito
        FROM TD_FIL DFIL
       WHERE DFIL.CODDEP = COALESCE(pCodFil, cFilialMatriz)
            
      LIMIT 1;
      
      
      -- Filial de Depsito  a mesma Filial do Filtro
      IF (COALESCE(bEhDeposito, 'F') = 'T')  THEN
         nSaldoProduto := 0;
      END IF;
   END IF;

   -- Procura a primeira movimentacao do produto
   -- (Caso um produto seja incluso apos a DataIni, ajusta-se a DataIni evitando distorcoes)
   -- Utilizado como parametro da funcao "Vendido"
   PrimeiraData := DataIni;
   UltimaData   := DataFim;
   IF (TipoProjecao = 2)
   OR (TipoProjecao = 3)
   OR (TipoProjecao = 4) THEN
      cFilmatRetorno := pFilMat;
      cCodmatRetorno := pCodmat;
      nCodcorRetorno := pCodCor;
      nCodtamRetorno := pCodTam;
      
      -- MN - Essa funo  destinada para headers de kit, como o POS no vende headers, somente os itens, deve-se procurar um item de "referncia"
      -- para verificar quantas vendas o item de "referncia" teve e inferir a quantidade de vendas do header do kit.
      IF (bHeaderKit = 'T') THEN
         SELECT TrazItemReferenciaKit(pFILMAT, pCODMAT, pCODCOR, pCODTAM)
           INTO cRetorno
           FROM DUAL;
         
         IF COALESCE(cRetorno, 'X') <> 'X' THEN
            -- MN - Trata Headers de kit
            cFilmatRetorno := COALESCE(Split_Part(cRetorno, ';', 1), pFilMat);
            cCodmatRetorno := COALESCE(Split_Part(cRetorno, ';', 2), pCodmat);
            nCodcorRetorno := COALESCE(Split_Part_Number(cRetorno, ';', 3), pCodCor);
            nCodtamRetorno := COALESCE(Split_Part_Number(cRetorno, ';', 4), pCodTam);
         END IF;
      END IF;
   
      IF ISNULL(pCodFil)='T' THEN
         Open MovtoInicial(cFilmatRetorno, cCodmatRetorno, nCodcorRetorno, nCodtamRetorno);
         Fetch MovtoInicial into PrimeiroLancto;

         IF NOT NOT FOUND THEN
            IF PrimeiroLancto > PrimeiraData THEN
               PrimeiraData := PrimeiroLancto;
            END IF;
         END IF;
         Close MovtoInicial;
      ELSE
         Open MovtoInicialFilial(cFilmatRetorno, cCodmatRetorno, nCodcorRetorno, nCodtamRetorno, pCodFil);
         Fetch MovtoInicialFilial into PrimeiroLancto;
         IF NOT NOT FOUND THEN
            IF PrimeiroLancto > PrimeiraData THEN
               PrimeiraData := PrimeiroLancto;
            END IF;
         END IF;
         Close MovtoInicialFilial;
      END IF;
   END IF;

   -- Calculo simples por wk_MINQTD
   IF (TipoProjecao = 0) THEN
      QtdSugerida := COALESCE(wk_minqtd,0);

   -- Calculo simples por wk_PTOPED.
   ELSIF (TipoProjecao = 1) THEN
      QtdSugerida := COALESCE(wk_ptoped,0);

   -- Calculo projetando a media de vendas do periodo anterior para o futuro
   -- ou Calculo projetando as vendas do mesmo periodo do ano anterior (ontem - 366 dias)
   ELSIF (TipoProjecao = 2)
      OR (TipoProjecao = 3) THEN

      -- Se for mesmo periodo no ano anterior, ajusta as datas de inicio e fim
      IF TipoProjecao = 3 THEN
         UltimaData   := TRUNC( agora() ) - 1;   -- Ontem
         PrimeiraData := TRUNC( agora() ) - 366; -- 1 ano anterior a Ontem
      END IF;

      -- Calcula as vendas do periodo anterior informado, e calcula numero de dias para a proporcao
      -- RFMP 99308
      -- Incluso de parmetro para considerar transferncias no total de vendas
      
      -- MN - Traz totalvenda/totaltransferencia do produto ou do header, conforme configurado na TT_GRA.GERSUG 
      QtdVendida  := CASE WHEN bHeaderKit = 'F' THEN COALESCE(TotalVenda(PrimeiraData, UltimaData, pFilMat, pCodMat, pCodCor, pCodTam, pCodFil),0)
                                                ELSE COALESCE(TotalVendaKIT(PrimeiraData, UltimaData, pFilMat, pCodMat, pCodCor, pCodTam, pCodFil),0)
                     END;

      IF pConsideraTransf = 'T' THEN
         QtdVendida := QtdVendida + CASE WHEN bHeaderKit = 'F' THEN COALESCE(TotalTransferencia(PrimeiraData, UltimaData, pFilMat, pCodMat, pCodCor, pCodTam, pCodFil),0)
                                                               ELSE COALESCE(TotalTransferenciaKIT(PrimeiraData, UltimaData, pFilMat, pCodMat, pCodCor, pCodTam, pCodFil),0)
                                     END;
      END IF;

      DiasFuturos := TRUNC(ManterAte) - TRUNC(agora()) + 1;
      DiasAvaliados := TRUNC(UltimaData) - TRUNC( PrimeiraData ) + 1;

      IF DiasAvaliados = 0 THEN
         DiasAvaliados := 1;
      END IF;

      QtdSugerida := QtdVendida / DiasAvaliados * DiasFuturos;
      MediaVendas := QtdSugerida;


   -- Calculo projetando as vendas do periodo anterior para o futuro proporcional a Sazonalidade
   ELSIF TipoProjecao = 4 THEN
      -- Transforma a Sazonalidade em Vetor
      OPEN Sazonalidade( pFilmat, pCodMat );

      FETCH Sazonalidade into Rec;

      SELECT ' { '|| REC.SAZ001||','||REC.SAZ002||','||REC.SAZ003||','||
            REC.SAZ004||','||REC.SAZ005||','||REC.SAZ006||','||
            REC.SAZ007||','||REC.SAZ008||','||REC.SAZ009||','||
            REC.SAZ010||','||REC.SAZ011||','||REC.SAZ012||','||
            REC.SAZ013||','||REC.SAZ014||','||REC.SAZ015||','||
            REC.SAZ016||','||REC.SAZ017||','||REC.SAZ018||','||
            REC.SAZ019||','||REC.SAZ020||','||REC.SAZ021||','||
            REC.SAZ022||','||REC.SAZ023||','||REC.SAZ020|| ' } ' INTO temp;
      aSaz := temp;

      IF NOT (NOT FOUND) THEN

         SazonalAnterior := AUX_CalcSazonalidade( PrimeiraData, UltimaData, aSaz );
         SazonalFutura   := AUX_CalcSazonalidade( UltimaData, ManterAte, aSaz );
         QtdVendida      := CASE WHEN bHeaderKit = 'F' THEN COALESCE(TotalVenda(PrimeiraData, UltimaData, pFilMat, pCodMat, pCodCor, pCodTam, pCodFil),0)
                                                       ELSE COALESCE(TotalVendaKIT(PrimeiraData, UltimaData, pFilMat, pCodMat, pCodCor, pCodTam, pCodFil),0)
                            END;         

         IF pConsideraTransf = 'T' THEN
            QtdVendida := QtdVendida + CASE WHEN bHeaderKit = 'F' THEN COALESCE(TotalTransferencia(PrimeiraData, UltimaData, pFilMat, pCodMat, pCodCor, pCodTam, pCodFil),0)
                                                                  ELSE COALESCE(TotalTransferenciaKIT(PrimeiraData, UltimaData, pFilMat, pCodMat, pCodCor, pCodTam, pCodFil),0)
                                        END;
         END IF;

         IF SazonalAnterior = 0 THEN
            SazonalAnterior := 1;
         END IF;
      END IF;

      CLOSE Sazonalidade;

      QtdSugerida := QtdVendida / SazonalAnterior * SazonalFutura;

   /* Quantidade Maxima em estoque */
   ELSIF (TipoProjecao = 5) THEN
      QtdSugerida := COALESCE(wk_qtdmax,0);

   /* Quantidade Estoque Mximo no Ponto de Pedido  */
   ELSIF (TipoProjecao = 6) THEN

      QtdSugerida := COALESCE(pQtdMaxPto,0);--Quantidade recebida por parametro

   END IF;

   -- Pedidos pendentes - Se filial null, busca a IDF, pois trata-se de pedidos da matriz
   -- ja que pedidos das lojas sao de reposicao interna
   PedidosDeFilial := pCodFil;
   IF ISNULL(pCodFil)='T' THEN
      Open FilialMatriz;
      Fetch FilialMatriz INTO PedidosDeFilial;
      Close FilialMatriz;
   END IF;

   -- Quando Sugesto para Distribuio, desconsidera pedidos pendentes.
   IF (pSugestaoPara = 'D') THEN
      IF (pConsideraPedReposPend = 'T') THEN
         nPedidoPendenteEnt := COALESCE(PedidoPendente( PedidosDeFilial, pFilMat, pCodMat, pCodCor, pCodTam, 'R', 'F', 'E'), 0);
         -- Filial de Depsito  a mesma Filial do Filtro
         IF (COALESCE(bEhDeposito, 'F') = 'F')  THEN
            nPedidoPendenteSai := COALESCE(PedidoPendente( PedidosDeFilial, pFilMat, pCodMat, pCodCor, pCodTam, 'R', 'F', 'S'), 0) * -1;
         END IF;

         nPedidoPendente := nPedidoPendenteEnt + nPedidoPendenteSai;
         nQtdEmTransito  := 0;
      ELSE
         nPedidoPendente := 0;
         nQtdEmTransito  := 0;
      END IF;
   ELSE
      IF (pSugestaoPara='C') OR (pSugestaoPara='P') THEN
         nPedidoPendente := COALESCE(PedidoPendente( PedidosDeFilial, pFilMat, pCodMat, pCodCor, pCodTam, 'C'), 0);

         -- MN - criar funo "QuantidadeEmTransito " com select abaixo, e outra "QuantidadeEmTransitoKIT" para headers de kit
         -- e chamar uma funo ou outra, dependendo se o item  header de kit ou no
         
         -- Obtem a quantidde de produtos em trnsito (Transferncias)
         nQtdEmTransito := CASE WHEN bHeaderKit = 'F' THEN COALESCE(QuantidadeEmTransito(pFilMat, pCodMat, pCodCor, pCodTam, pCodFil), 0)
                                                      ELSE COALESCE(QuantidadeEmTransitoKIT(pFilMat, pCodMat, pCodCor, pCodTam, pCodFil), 0)
                           END;

      ELSE
         nPedidoPendente := COALESCE(PedidoPendente( PedidosDeFilial, pFilMat, pCodMat, pCodCor, pCodTam, 'R'), 0);
         nQtdEmTransito  := 0;
      END IF;
   END IF;

   -- Necessidade de compra
   IF (TipoProjecao = 5) THEN
      -- RFMP 94329
      -- Estoque mximo (gndola)  um limite de espao na filial (subestoque).
      -- Por tanto, no podemos descontar a reserva do saldo, porque os produtos ainda
      -- esto ocupando o espao.
      QtdSugerida := QtdSugerida - nPedidoPendente - nQtdEmTransito - nQtdest;
      IF QtdSugerida < 0 THEN
         QtdSugerida := 0;
      END IF;
   ELSE
      QtdSugerida := QtdSugerida - nPedidoPendente - nQtdEmTransito - nSaldoProduto;

      IF QtdSugerida < 0 THEN
         QtdSugerida := 0;
      END IF;
      IF (TipoProjecao = 2)
      OR (TipoProjecao = 3) THEN
         IF ((MediaVendas > 0) AND ((QtdSugerida) = 0) AND (Novpro = 'T')) OR ((nSaldoProduto = 0) AND (QtdVendida = 0) AND (Novpro = 'T')) THEN
            IF wk_MinQtd > 0 THEN
               QtdSugerida := wk_MinQtd;
            ELSE
               QtdSugerida := 1;
            END IF;
         END IF;
      END IF;
   END IF;

   -- Tratamento para considerar sugesto de quantidade para suprir Estoque Mnimo
   IF (pReposicaoParaQtdMin = 'T') THEN
      IF ((wk_MinQtd - CASE WHEN (pConsideraPedReposPend = 'T') THEN nPedidoPendente ELSE 0 END) > 0) THEN
         IF (nSaldoProduto > 0) THEN
            IF (((wk_MinQtd - CASE WHEN (pConsideraPedReposPend = 'T') THEN nPedidoPendente ELSE 0 END) - nSaldoProduto) > QtdSugerida) THEN
               QtdSugerida := ((wk_MinQtd - CASE WHEN (pConsideraPedReposPend = 'T') THEN nPedidoPendente ELSE 0 END) - nSaldoProduto);
            END IF;
         ELSIF (((wk_MinQtd - CASE WHEN (pConsideraPedReposPend = 'T') THEN nPedidoPendente ELSE 0 END) + ABS(nSaldoProduto)) > QtdSugerida) THEN
            QtdSugerida := ((wk_MinQtd - CASE WHEN (pConsideraPedReposPend = 'T') THEN nPedidoPendente ELSE 0 END) + ABS(nSaldoProduto));
         END IF;
      END IF;
   END IF;

   IF (QtdSugerida > 0) THEN
      -- Obtem a quantidade definida para o lote economico
      nLoteEconomico := COALESCE(wk_qtdrep,1);

      IF (nLoteEconomico = 0) THEN
         nLoteEconomico := 1;
      END IF;

      -- A aplicao para lote economico pode ser ignorada atravs de parmetro
      IF (nLoteEconomico > 1)  AND (COALESCE(pIgnoraLoteEconomico, 'F') = 'F') THEN
         -- Arredonda pelo lote economico
         QtdSugerida := TRUNC(((QtdSugerida * nPercVenda) + nLoteEconomico - 1) / nLoteEconomico ) * nLoteEconomico;
      ELSE
         QtdSugerida := QtdSugerida * nPercVenda;
      END IF;

      IF (pSugestaoPara = 'D') AND (wk_MinQtd = 0) AND (COALESCE(wk_DistribuicaoQtdMinZero, 'T') = 'F') THEN
        QtdSugerida := 0;
      END IF;

      -- Manoel 93167 - Quando o produto nao aceitar decimal tem que dar TRUNC como era antes da tarefa 91860
      IF (bAceitaDecimal = 'F') THEN
         QtdSugerida := TRUNC(QtdSugerida);
      END IF;
   END IF;

   RETURN COALESCE(QtdSugerida,0);

END;
$$ language 'plpgsql';


/*-- SEQ 1810 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SUGESTAOCOMPRA (INTEGER,Timestamp,Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,VARCHAR,Numeric,Numeric,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1811 --*/
CREATE OR REPLACE FUNCTION SUGESTAOCOMPRA (INTEGER,
                               Timestamp,
                               Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR,
                               VARCHAR,
                               Numeric,
                               Numeric,
                               VARCHAR,
                               VARCHAR,
                               VARCHAR,
                               VARCHAR,
                               VARCHAR,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN SUGESTAOCOMPRA($1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,$12,$13,$14,$15,$16,$17,$18,'F');
END;
$$ language 'plpgsql';


/*-- SEQ 1812 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SUGESTAOCOMPRA (INTEGER,Timestamp,Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,VARCHAR,Numeric,Numeric,VARCHAR,VARCHAR,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1813 --*/
CREATE OR REPLACE FUNCTION SUGESTAOCOMPRA (INTEGER,
                               Timestamp,
                               Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR,
                               VARCHAR,
                               Numeric,
                               Numeric,
                               VARCHAR,
                               VARCHAR,
                               VARCHAR,
                               VARCHAR,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN SUGESTAOCOMPRA($1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,$12,$13,$14,$15,$16,$17,'F','F');
END;
$$ language 'plpgsql';


/*-- SEQ 1814 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SUGESTAOCOMPRA (INTEGER,Timestamp,Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,VARCHAR,Numeric,Numeric,VARCHAR,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1815 --*/
CREATE OR REPLACE FUNCTION SUGESTAOCOMPRA (INTEGER,
                               Timestamp,
                               Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR,
                               VARCHAR,
                               Numeric,
                               Numeric,
                               VARCHAR,
                               VARCHAR,
                               VARCHAR,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN SUGESTAOCOMPRA($1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,$12,$13,$14,$15,$16,'F','F','F');
END;
$$ language 'plpgsql';


/*-- SEQ 1816 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SUGESTAOCOMPRA (INTEGER,Timestamp,Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,VARCHAR,Numeric,Numeric,VARCHAR,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1817 --*/
CREATE OR REPLACE FUNCTION SUGESTAOCOMPRA (INTEGER,
                               Timestamp,
                               Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR,
                               VARCHAR,
                               Numeric,
                               Numeric,
                               VARCHAR,
                               VARCHAR,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN SUGESTAOCOMPRA($1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,$12,$13,$14,$15,'F','F','F','F');
END;
$$ language 'plpgsql';


/*-- SEQ 1818 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SUGESTAOCOMPRA (INTEGER,Timestamp,Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,VARCHAR,Numeric,Numeric,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1819 --*/
CREATE OR REPLACE FUNCTION SUGESTAOCOMPRA (INTEGER,
                               Timestamp,
                               Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR,
                               VARCHAR,
                               Numeric,
                               Numeric,
                               VARCHAR,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN SUGESTAOCOMPRA($1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,$12,$13,$14,'C','F','F','F','F');
END;
$$ language 'plpgsql';


/*-- SEQ 1820 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SUGESTAOCOMPRA (INTEGER,Timestamp,Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,VARCHAR,Numeric,Numeric,VARCHAR) CASCADE;

/*-- SEQ 1821 --*/
CREATE OR REPLACE FUNCTION SUGESTAOCOMPRA (INTEGER,
                               Timestamp,
                               Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR,
                               VARCHAR,
                               Numeric,
                               Numeric,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN SUGESTAOCOMPRA($1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,$12,$13,'F','C','F','F','F','F');
END;
$$ language 'plpgsql';


/*-- SEQ 1822 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SUGESTAOCOMPRA (INTEGER,Timestamp,Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,VARCHAR,Numeric,Numeric) CASCADE;

/*-- SEQ 1823 --*/
CREATE OR REPLACE FUNCTION SUGESTAOCOMPRA (INTEGER,
                               Timestamp,
                               Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR,
                               VARCHAR,
                               Numeric,
                               Numeric) 
RETURNS Numeric AS $$
BEGIN
RETURN SUGESTAOCOMPRA($1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,$12,'F','F','C','F','F','F','F');
END;
$$ language 'plpgsql';


/*-- SEQ 1824 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SUGESTAOCOMPRA (INTEGER,Timestamp,Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,VARCHAR,Numeric) CASCADE;

/*-- SEQ 1825 --*/
CREATE OR REPLACE FUNCTION SUGESTAOCOMPRA (INTEGER,
                               Timestamp,
                               Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR,
                               VARCHAR,
                               Numeric) 
RETURNS Numeric AS $$
BEGIN
RETURN SUGESTAOCOMPRA($1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,0,'F','F','C','F','F','F','F');
END;
$$ language 'plpgsql';


/*-- SEQ 1826 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SUGESTAOCOMPRA (INTEGER,Timestamp,Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1827 --*/
CREATE OR REPLACE FUNCTION SUGESTAOCOMPRA (INTEGER,
                               Timestamp,
                               Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN SUGESTAOCOMPRA($1,$2,$3,$4,$5,$6,$7,$8,$9,'F',1,0,'F','F','C','F','F','F','F');
END;
$$ language 'plpgsql';


/*-- SEQ 1828 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GiroEstoqueKIT (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TT_CFG.GIRO_ESTOQUE%TYPE,TR_MOV.PROMOC%TYPE) CASCADE;

/*-- SEQ 1829 --*/
CREATE OR REPLACE FUNCTION GiroEstoqueKIT (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR,TT_CFG.GIRO_ESTOQUE%TYPE,TR_MOV.PROMOC%TYPE)
RETURNS Numeric AS $$
DECLARE
pDatIni ALIAS FOR $1 ;
pDatFim ALIAS FOR $2 ;
pFilMat ALIAS FOR $3 ;
pCodMat ALIAS FOR $4 ;
pCodCor ALIAS FOR $5 ;
pCodTam ALIAS FOR $6 ;
pCodFil ALIAS FOR $7 ;
pTipo ALIAS FOR $8 ;
pPromocao ALIAS FOR $9 ;
-----------------------------------------------------------------------------------------------------------------------------------
   --Objetivos: 1 - Realizar a chamada da função de nível 4, "GiroEstoque" para headers de kit. 
-----------------------------------------------------------------------------------------------------------------------------------

   nQtdGiro                      Numeric;
   cRetorno                      VARCHAR(254);
   nQtdIte                       TT_KIT.QTDITE%TYPE;
   cFilmat                       TT_GRA.FILMAT%TYPE;
   cCodmat                       TT_GRA.CODMAT%TYPE;
   nCodcor                       TT_GRA.CODCOR%TYPE;
   nCodtam                       TT_GRA.CODTAM%TYPE;
-- Início da função
BEGIN
   nQtdGiro := 0;

   -- MN - Essa função é destinada para headers de kit, como o POS não vende headers, somente os itens, deve-se procurar um item de "referência"
   -- para verificar quantas vendas o item de "referência" teve e inferir a quantidade de vendas do header do kit.
   SELECT TrazItemReferenciaKit(pFILMAT, pCODMAT, pCODCOR, pCODTAM)
     INTO cRetorno
     FROM DUAL;

   IF COALESCE(cRetorno, 'X') <> 'X' THEN
      cFilmat := Split_Part(cRetorno, ';', 1);
      cCodmat := Split_Part(cRetorno, ';', 2);
      nCodcor := Split_Part_Number(cRetorno, ';', 3);
      nCodtam := Split_Part_Number(cRetorno, ';', 4);
      nQtdIte := Split_Part_Number(cRetorno, ';', 5);

      -- MN - Busca o total de venda pelo item de referência, depois ainda deve dividir o total, pela quantidade necessária do item de referência
      -- para formar um kit ùnico.
      SELECT GiroEstoque(pDatIni, pDatFim, cFilmat, cCodmat, nCodcor, nCodtam, pCodFil, pTipo, pPromocao)
        INTO nQtdGiro
        FROM DUAL;

      -- MN - A ideia dessa divisão, é que o item referência, é o item com maior quantidade dentro do kit, então primeiros
      -- pegamos quantos itens foram vendidos, por exemplo, 2000 unidades do item referência, agora para sabermos quantos KITS
      -- foram vendidos, devemos dividir a quantidade vendida, pela quantidade necessária para montar UM único kit.
      IF nQtdIte > 0 THEN
         nQtdGiro := nQtdGiro / nQtdIte;
      END IF;
   END IF;

   RETURN COALESCE(nQtdGiro, 0);

END;
$$ language 'plpgsql';


/*-- SEQ 1830 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION GiroEstoqueKIT (Timestamp,Timestamp,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1831 --*/
CREATE OR REPLACE FUNCTION GiroEstoqueKIT (Timestamp,
                               Timestamp,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               VARCHAR) 
RETURNS Numeric AS $$
BEGIN
RETURN GiroEstoqueKIT($1,$2,$3,$4,$5,$6,$7,'C','T');
END;
$$ language 'plpgsql';


/*-- SEQ 1832 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION MaterializaCustoVenda () CASCADE;

/*-- SEQ 1833 --*/
CREATE OR REPLACE FUNCTION MaterializaCustoVenda ()
RETURNS VARCHAR AS $$
DECLARE

/*
-- Objetivos:
-- 1. Atualizar Custo dos Itens de Venda

-- Declarao de variveis e cursores
   aItemVenda Numeric(10)[];
aItemVenda_cCODFIL CHAR(3)[];
aItemVenda_cSEQUEN CHAR(10)[];
aItemVenda_nNUMITE Numeric(5)[];
aItemVenda_nCUSREP_FREFIS Numeric(14,4)[];
aItemVenda_nCUSMED_FIS Numeric(14,4)[];
aItemVenda_nCUSSIM Numeric(14,4)[];

aItemVendaCount Numeric(10) := 0;

   aItemNFe Numeric(10)[];
aItemNFe_nNFE_ID_DOC Numeric(9)[];
aItemNFe_nINF_ID_ITEM Numeric(9)[];
aItemNFe_nCUSREP_FREFIS Numeric(14,4)[];
aItemNFe_nCUSMED_FIS Numeric(14,4)[];
aItemNFe_nCUSSIM Numeric(14,4)[];

aItemNFeCount Numeric(10) := 0;

   crItemVenda CURSOR(pDATINI TT_VEN.DATHOR%TYPE,
           pDATFIM TT_VEN.DATHOR%TYPE) IS
        SELECT VEN.FILPRE, VEN.CODPRE, VEN.DATHOR,
               IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE, IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM,
               CustoData('2',IVE.VEN_DATHOR,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,IVE.CODFIL,IVE.CODMUL) AS NEW_CUSREP_FREFIS,
               CASE WHEN ((IVE.TOT_CM IS NULL) AND(IVE.LANEST <> 'N')) OR
                         COALESCE(IVE.SAL_CM,0) = 0 THEN CUSTOMEDIO(IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,3,IVE.VEN_DATHOR)
                    ELSE IVE.TOT_CM / IVE.SAL_CM
               END AS NEW_CUSMED_FIS,
               CustoSimuladoDia(IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM,IVE.VEN_DATHOR,VEN.FILPRE,VEN.CODPRE) AS NEW_CUSSIM
          FROM TT_IVE IVE INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
         WHERE VEN.DATHOR BETWEEN ADD_DAY(pDATINI, -15) AND pDATFIM
           AND VEN.NUMNOT NOT LIKE '%#%'
        
        FOR UPDATE
                ; --Reprocessa os custos sempre dos ltimos 15 Dias do ltimo processamento

   crItemNFe CURSOR(pDATINI TT_VEN.DATHOR%TYPE,
           pDATFIM TT_VEN.DATHOR%TYPE) IS
        SELECT VEN.FILPRE, VEN.CODPRE, VEN.DATHOR, VEN.CODFIL, VEN.SEQUEN,
               NFE.NFE_ID_DOC,
               INF.INF_ID_ITEM, INF.INF_FILMAT, INF.INF_CODMAT, INF.INF_CODCOR, INF.INF_CODTAM,
               CustoData('2', VEN.DATHOR, INF.INF_FILMAT, INF.INF_CODMAT, INF.INF_CODCOR, INF.INF_CODTAM, VEN.CODFIL, 0) AS NEW_CUSREP_FREFIS,
               CUSTOMEDIO(VEN.CODFIL, INF.INF_FILMAT, INF.INF_CODMAT, INF.INF_CODCOR, INF.INF_CODTAM, 3, VEN.DATHOR) AS NEW_CUSMED_FIS,
               CustoSimuladoDia(INF.INF_FILMAT, INF.INF_CODMAT, INF.INF_CODCOR, INF.INF_CODTAM, VEN.DATHOR, VEN.FILPRE, VEN.CODPRE) AS NEW_CUSSIM
          FROM TT_VEN VEN INNER JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
                          INNER JOIN TT_NFE NFE ON NFE.NFE_CODFIL = VEN.CODFIL
                                               AND NFE.NFE_NU_SERIE = CAST(DSER.SEREXT AS Numeric)
                                               AND NFE.NFE_NU_NNF = CAST(VEN.NUMNOT  AS Numeric)
                          INNER JOIN TT_INF INF ON INF.NFE_ID_DOC = NFE.NFE_ID_DOC
         WHERE VEN.DATHOR BETWEEN ADD_DAY(pDATINI, -15) AND pDATFIM
           AND VEN.NUMNOT NOT LIKE '%#%'; --Reprocessa os custos sempre dos ltimos 15 Dias do ltimo processamento

   cMANUT                        TT_IDF.MANUT%TYPE;
   cComplemento                  CONSTANT VARCHAR(254) := Constante('Complemento');

   dDATCUS_VEN                   TT_IDF.DATCUS_VEN%TYPE;
   dNEW_DATCUS_VEN               TT_IDF.DATCUS_VEN%TYPE;

      
   rItemVenda                    RECORD;
   rItemNFe                      RECORD;
   */
-- Incio da funo
BEGIN
/*
   SELECT MANUT, DATCUS_VEN INTO cMANUT, dDATCUS_VEN
     FROM TT_IDF;

   IF cMANUT = 'T' THEN
      RAISE EXCEPTION 'PG-20000 Base em manuteno. %' , cComplemento;
   END IF;

   
   -- RFMP 100739
   -- Esse lock serve para previnir conflitos com o ImportaNFe (TotallNfeGX)
   LOCK TABLE TT_INF IN EXCLUSIVE MODE;
   
   dNEW_DATCUS_VEN := TRUNC(Agora());
   --Item da Venda(TT_IVE)
   OPEN crItemVenda(dDATCUS_VEN, dNEW_DATCUS_VEN);
   LOOP
      FETCH crItemVenda INTO rItemVenda;
      EXIT WHEN NOT FOUND;

      aItemVendaCount := aItemVendaCount + 1;
if aItemVendaCount = 1 then
   select ARRAY[aItemVendaCount] into aItemVenda; 
   select ARRAY[rItemVenda.CODFIL] into aItemVenda_cCODFIL;
   select ARRAY[rItemVenda.SEQUEN] into aItemVenda_cSEQUEN;
   select ARRAY[rItemVenda.NUMITE] into aItemVenda_nNUMITE;
   select ARRAY[rItemVenda.NEW_CUSREP_FREFIS] into aItemVenda_nCUSREP_FREFIS;
   select ARRAY[rItemVenda.NEW_CUSMED_FIS] into aItemVenda_nCUSMED_FIS;
   select ARRAY[rItemVenda.NEW_CUSSIM] into aItemVenda_nCUSSIM;
else
   select array_append(aItemVenda, aItemVendaCount) into aItemVenda;
   select array_append(aItemVenda_cCODFIL, rItemVenda.CODFIL) into aItemVenda_cCODFIL;
   select array_append(aItemVenda_cSEQUEN, rItemVenda.SEQUEN) into aItemVenda_cSEQUEN;
   select array_append(aItemVenda_nNUMITE, rItemVenda.NUMITE) into aItemVenda_nNUMITE;
   select array_append(aItemVenda_nCUSREP_FREFIS, rItemVenda.NEW_CUSREP_FREFIS) into aItemVenda_nCUSREP_FREFIS;
   select array_append(aItemVenda_nCUSMED_FIS, rItemVenda.NEW_CUSMED_FIS) into aItemVenda_nCUSMED_FIS;
   select array_append(aItemVenda_nCUSSIM, rItemVenda.NEW_CUSSIM) into aItemVenda_nCUSSIM;
end if;
   END LOOP;
   CLOSE crItemVenda;

   --Item da NFe(TT_INF)
   OPEN crItemNFe(dDATCUS_VEN, dNEW_DATCUS_VEN);
   LOOP
      FETCH crItemNFe INTO rItemNFe;
      EXIT WHEN NOT FOUND;

      aItemNFeCount := aItemNFeCount + 1;
if aItemNFeCount = 1 then
   select ARRAY[aItemNFeCount] into aItemNFe; 
   select ARRAY[rItemNFe.NFE_ID_DOC] into aItemNFe_nNFE_ID_DOC;
   select ARRAY[rItemNFe.INF_ID_ITEM] into aItemNFe_nINF_ID_ITEM;
   select ARRAY[rItemNFe.NEW_CUSREP_FREFIS] into aItemNFe_nCUSREP_FREFIS;
   select ARRAY[rItemNFe.NEW_CUSMED_FIS] into aItemNFe_nCUSMED_FIS;
   select ARRAY[rItemNFe.NEW_CUSSIM] into aItemNFe_nCUSSIM;
else
   select array_append(aItemNFe, aItemNFeCount) into aItemNFe;
   select array_append(aItemNFe_nNFE_ID_DOC, rItemNFe.NFE_ID_DOC) into aItemNFe_nNFE_ID_DOC;
   select array_append(aItemNFe_nINF_ID_ITEM, rItemNFe.INF_ID_ITEM) into aItemNFe_nINF_ID_ITEM;
   select array_append(aItemNFe_nCUSREP_FREFIS, rItemNFe.NEW_CUSREP_FREFIS) into aItemNFe_nCUSREP_FREFIS;
   select array_append(aItemNFe_nCUSMED_FIS, rItemNFe.NEW_CUSMED_FIS) into aItemNFe_nCUSMED_FIS;
   select array_append(aItemNFe_nCUSSIM, rItemNFe.NEW_CUSSIM) into aItemNFe_nCUSSIM;
end if;
   END LOOP;
   CLOSE crItemNFe;

   if aItemVendaCount > 0 then
for aItemVendaCount in array_lower(aItemVenda,1) .. array_upper(aItemVenda,1) loop
      rItemVenda.CODFIL             := aItemVenda_cCODFIL[aItemVendaCount];
      rItemVenda.SEQUEN             := aItemVenda_cSEQUEN[aItemVendaCount];
      rItemVenda.NUMITE             := aItemVenda_nNUMITE[aItemVendaCount];
      rItemVenda.NEW_CUSREP_FREFIS  := aItemVenda_nCUSREP_FREFIS[aItemVendaCount];
      rItemVenda.NEW_CUSMED_FIS     := aItemVenda_nCUSMED_FIS[aItemVendaCount];
      rItemVenda.NEW_CUSSIM         := aItemVenda_nCUSSIM[aItemVendaCount];

      UPDATE TT_IVE SET CUSREP_FREFIS = rItemVenda.NEW_CUSREP_FREFIS,
                        CUSMED_FIS = rItemVenda.NEW_CUSMED_FIS,
                        CUSSIM = rItemVenda.NEW_CUSSIM,
                        DUMMY = '%'
       WHERE CODFIL = rItemVenda.CODFIL
         AND SEQUEN = rItemVenda.SEQUEN
         AND NUMITE = rItemVenda.NUMITE;

      
   end loop;
end if;

   if aItemNFeCount > 0 then
for aItemNFeCount in array_lower(aItemNFe,1) .. array_upper(aItemNFe,1) loop
      rItemNFe.NFE_ID_DOC        := aItemNFe_nNFE_ID_DOC[aItemNFeCount];
      rItemNFe.INF_ID_ITEM       := aItemNFe_nINF_ID_ITEM[aItemNFeCount];
      rItemNFe.NEW_CUSREP_FREFIS := aItemNFe_nCUSREP_FREFIS[aItemNFeCount];
      rItemNFe.NEW_CUSMED_FIS    := aItemNFe_nCUSMED_FIS[aItemNFeCount];
      rItemNFe.NEW_CUSSIM        := aItemNFe_nCUSSIM[aItemNFeCount];

      UPDATE TT_INF SET INF_CUSREP_FREFIS = rItemNFe.NEW_CUSREP_FREFIS,
                        INF_CUSMED_FIS = rItemNFe.NEW_CUSMED_FIS,
                        INF_CUSSIM = rItemNFe.NEW_CUSSIM
       WHERE NFE_ID_DOC = rItemNFe.NFE_ID_DOC
         AND INF_ID_ITEM = rItemNFe.INF_ID_ITEM;

      
   end loop;
end if;

   IF dNEW_DATCUS_VEN > dDATCUS_VEN THEN
      UPDATE TT_IDF SET DATCUS_VEN = dNEW_DATCUS_VEN;
   END IF;
*/
   RETURN 'OK';

END;
$$ language 'plpgsql';



/*-- SEQ 1834 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_MaterializaCustoVenda (TT_JOB.CODUID%TYPE) CASCADE;

/*-- SEQ 1835 --*/
CREATE OR REPLACE FUNCTION Job_MaterializaCustoVenda (TT_JOB.CODUID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODUID ALIAS FOR $1 ;
/*
-- Objetivos:
-- 1. Executar funo CustoVenda.
-- 2. Registrar o resultado na TT_JOB.

-- Declarao de variveis e cursores
   cNOMJOB                       TT_JOB.NOMJOB%TYPE;
   cDESJOB                       TT_JOB.DESJOB%TYPE;
*/
   cDummy                        CHAR(2);

-- Incio da funo
BEGIN
/*
   cNOMJOB := 'JOB_MATERIALIZACUSTOVENDA';
   cDESJOB := 'Rotina para calcular o Custo dos produtos vendidos';
   BEGIN
      cDummy := MaterializaCustoVenda();
      cDummy := RegistraJob(cNOMJOB, cDESJOB, NULL, pCODUID);
   EXCEPTION
      WHEN OTHERS THEN cDummy := RegistraJob(cNOMJOB, cDESJOB, SQLERRM, pCODUID);
   END;
*/
   cDummy := 'OK';

  RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 1836 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_MaterializaCustoVenda () CASCADE;

/*-- SEQ 1837 --*/
CREATE OR REPLACE FUNCTION Job_MaterializaCustoVenda () 
RETURNS VARCHAR AS $$
BEGIN
RETURN Job_MaterializaCustoVenda(NULL);
END;
$$ language 'plpgsql';


   CREATE OR REPLACE FUNCTION PC_ACM_AUX_UPDATE (TT_ACM.DATAJU%TYPE,TT_ACM.CODFIL%TYPE,TT_ACM.FILMAT%TYPE,TT_ACM.CODMAT%TYPE,TT_ACM.CODCOR%TYPE,TT_ACM.CODTAM%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pDATAJU ALIAS FOR $1 ;
pCODFIL ALIAS FOR $2 ;
pFILMAT ALIAS FOR $3 ;
pCODMAT ALIAS FOR $4 ;
pCODCOR ALIAS FOR $5 ;
pCODTAM ALIAS FOR $6 ;
   BEGIN
      /* Atualiza a data do custo medio na TT_SAL */
      UPDATE TT_SAL
         SET CAL_CM = CASE WHEN CAL_CM IS NULL THEN NULL ELSE
                        CASE WHEN pDATAJU<CAL_CM THEN pDATAJU
                                                     ELSE CAL_CM
                        END
                      END,
             ATU_CM = 'F',
             DUMMY = Constante('vem_de_TGACM')
       WHERE CODFIL = pCODFIL
         AND FILMAT = pFILMAT
         AND CODMAT = pCODMAT
         AND CODCOR = pCODCOR
         AND CODTAM = pCODTAM
         AND CODMUL = 0;
         
     UPDATE TD_FIL SET DATFINEST=CASE WHEN DATFINEST IS NULL THEN NULL ELSE
                                    CASE WHEN pDATAJU<DATFINEST THEN TRUNC(pDATAJU)
                                                                 ELSE DATFINEST
                                    END
                                  END
      WHERE CODFIL = pCODFIL
        AND DATFINEST>TRUNC(pDATAJU);
      
    RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 1838 --*/
CREATE OR REPLACE FUNCTION PC_ATU_EM_Atualiza (VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pTabela ALIAS FOR $1 ;
pWhere ALIAS FOR $2 ;
  cExp VARCHAR(4000);
  cAux CHAR(2);
BEGIN 
     cExp := 'UPDATE ' || pTabela || ' SET ATU_EM = AGORA()';
     IF ISNOTNULL(pWhere) = 'T' THEN
       cExp := cExp || ' WHERE ' || pWhere;
     END IF;
       
     
     cExp := cExp || ';';   
     EXECUTE cExp; 
     
  RETURN NULL;

END;
$$ language 'plpgsql';



  
   CREATE OR REPLACE FUNCTION PC_CCC_UPDATE (TT_CCC.CODFIL%TYPE,TT_CCC.SEQUEN%TYPE,TT_CCC.FILCLI%TYPE,TT_CCC.CODCLI%TYPE,TT_CCC.TIPCCC%TYPE,TT_CCC.DUMMY%TYPE,TT_CCC.FILRAT%TYPE,TT_CCC.SEQRAT%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pFILCLI ALIAS FOR $3 ;
pCODCLI ALIAS FOR $4 ;
pTIPCCC ALIAS FOR $5 ;
pDUMMY ALIAS FOR $6 ;
pFILRAT ALIAS FOR $7 ;
pSEQRAT ALIAS FOR $8 ;
      vVLRSALDO             TT_LIM.VSALDO%TYPE;
      --vCCC_NAO_FATURADA     integer;
   BEGIN
     
     --IF pDUMMY = 'R'  THEN       
       -- verifica se tem fatura vinculada a rat em aberto
       --SELECT COUNT(*)
       --  INTO vCCC_NAO_FATURADA
       --  FROM TT_CCC
       -- WHERE FILFAT IS NULL
       --   AND SEQFAT IS NULL
       --   AND FILRAT = pFILRAT
       --   AND SEQRAT = pSEQRAT
       --   AND FILCLI = pFILCLI
       --   AND CODCLI = pCODCLI;
       -- se todas as faturas foram faturadas marcar rat como faturada
       --IF vCCC_NAO_FATURADA = 0 THEN   
       --  UPDATE TT_RAT
       --     SET SITFAT = '1'
       --   WHERE CODFIL = pFILRAT
       --     AND SEQUEN = pSEQRAT
       --     AND SITFAT <> '1'
       --END IF;       
     --ELSE
       SELECT VSALDO INTO vVLRSALDO
         FROM TT_LIM
        WHERE FILCLI = pFILCLI
          AND CODCLI = PCODCLI
          AND TIPCCC = PTIPCCC;
          
       IF vVLRSALDO >= 0 THEN
          UPDATE TT_CCC
             SET STATUS = 'P'
           WHERE FILCLI = pFILCLI
             AND CODCLI = PCODCLI
             AND TIPCCC = PTIPCCC
             AND VLRLAN < 0
             AND STATUS = 'A';
       END IF;
     --END IF;
     
       RETURN NULL;

END;
$$ language 'plpgsql';



  
   CREATE OR REPLACE FUNCTION PC_CCC2_UPDATE (TT_CCC.CODFIL%TYPE,TT_CCC.SEQUEN%TYPE,TT_CCC.CODVEN%TYPE,TT_CCC.SEQVEN%TYPE,TT_CCC.NUMPAR%TYPE,TT_CCC.SUBPAR%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pFILREC ALIAS FOR $3 ;
pSEQREC ALIAS FOR $4 ;
pNUMPAR ALIAS FOR $5 ;
pSUBPAR ALIAS FOR $6 ;
BEGIN
   IF (ISNOTNULL(pSEQREC)='T') THEN
      UPDATE TT_REC
         SET FILCCC = pCODFIL,
             SEQCCC = pSEQUEN
       WHERE CODFIL = pFILREC
         AND SEQUEN = pSEQREC
         AND NUMPAR = COALESCE(pNUMPAR, NUMPAR)
         AND SUBPAR = COALESCE(pSUBPAR, SUBPAR)
         AND SEQCCC IS NULL
         AND FLGEST IN ('A', 'P');
   END IF;
     
     RETURN NULL;

END;
$$ language 'plpgsql';



/*-- SEQ 1839 --*/
    CREATE OR REPLACE FUNCTION PC_CHR_UPDATE (TT_CHR.FLGEST%TYPE,TT_CHR.CODFIL%TYPE,TT_CHR.SEQUEN%TYPE,VARCHAR,TT_CHR.DATOPE%TYPE,TT_CHR.NUMCON%TYPE,TT_CHR.NUMDOC%TYPE,TT_CHR.CODBCO%TYPE,TT_CHR.CODAGE%TYPE,TT_CHR.NUMCHE%TYPE,TT_CHR.ATU_EM%TYPE,TT_CHR.DATVEN%TYPE,TT_CHR.VLRCHE%TYPE,TT_CHR.PORTAD%TYPE,TT_CHR.PAGAME%TYPE,TT_CHR.NUMDEP%TYPE,TT_CHR.ALINEA%TYPE,TT_CHR.VLRDIF%TYPE,TT_CHR.SEQCAN%TYPE,TT_CHR.AUTORI%TYPE,TT_CHR.TIPCOB%TYPE,TT_CHR.OBSLOG%TYPE,TT_CHR.NUMECF%TYPE,TT_CHR.CDCMC7%TYPE,VARCHAR,TT_CHR.VLRORI%TYPE,TT_CHR.PLACAS%TYPE,TT_CHR.SERCHE%TYPE,VARCHAR,TT_CHR.DATFIS%TYPE,TT_CHR.DATREA%TYPE,TT_CHR.PORORI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFLGEST ALIAS FOR $1 ;
pCODFIL ALIAS FOR $2 ;
pSEQUEN ALIAS FOR $3 ;
pCHVUSU ALIAS FOR $4 ;
pDATOPE ALIAS FOR $5 ;
pNUMCON ALIAS FOR $6 ;
pNUMDOC ALIAS FOR $7 ;
pCODBCO ALIAS FOR $8 ;
pCODAGE ALIAS FOR $9 ;
pNUMCHE ALIAS FOR $10 ;
pATU_EM ALIAS FOR $11 ;
pDATVEN ALIAS FOR $12 ;
pVLRCHE ALIAS FOR $13 ;
pPORTAD ALIAS FOR $14 ;
pPAGAME ALIAS FOR $15 ;
pNUMDEP ALIAS FOR $16 ;
pALINEA ALIAS FOR $17 ;
pVLRDIF ALIAS FOR $18 ;
pSEQCAN ALIAS FOR $19 ;
pAUTORI ALIAS FOR $20 ;
pTIPCOB ALIAS FOR $21 ;
pOBSLOG ALIAS FOR $22 ;
pNUMECF ALIAS FOR $23 ;
pCDCMC7 ALIAS FOR $24 ;
pCHVCLI ALIAS FOR $25 ;
pVLRORI ALIAS FOR $26 ;
pPLACAS ALIAS FOR $27 ;
pSERCHE ALIAS FOR $28 ;
pCHVDEP ALIAS FOR $29 ;
pDATFIS ALIAS FOR $30 ;
pDATREA ALIAS FOR $31 ;
pPORORI ALIAS FOR $32 ;

         SupCobrancas CURSOR(pCODFIL TT_REC.CODFIL%TYPE,
           pSEQUEN TT_REC.SEQUEN%TYPE) IS
         SELECT SUP.CODFIL,SUP.SEQUEN
           FROM TT_REC REC INNER JOIN TT_COB COB ON REC.CODFIL = COB.FILREC
                                                AND REC.SEQUEN = COB.SEQREC
                                                AND REC.NUMPAR = COB.NUMPAR
                                                AND REC.SUBPAR = COB.SUBPAR
                           INNER JOIN TT_SUP SUP ON COB.FILSUP=SUP.CODFIL
                                                AND COB.SEQSUP=SUP.SEQUEN
         WHERE SUP.SITUAC IN ('A','N')
           AND REC.CODFIL=pCODFIL
           AND REC.SEQUEN=pSEQUEN;

         cCODFIL TT_SUP.CODFIL%TYPE;
         cSEQUEN TT_SUP.SEQUEN%TYPE;
         
         cFILUSU TT_USU.FILUSU%TYPE;
         cCODUSU TT_USU.CODUSU%TYPE;
         cFILCLI TT_CLI.FILCLI%TYPE;
         cCODCLI TT_CLI.CODCLI%TYPE;
         cFILDEP TT_CHR.FILDEP%TYPE;
         cSEQDEP TT_CHR.SEQDEP%TYPE;

         vAux                      CHAR;
         vCHRDEV_CRIA_SUBPAR	   CHAR; 

    BEGIN
       cFILUSU := SUBSTR(pCHVUSU,1,3);
       cCODUSU := SUBSTR(pCHVUSU,4,10);
       cFILCLI := SUBSTR(pCHVCLI,1,3);  
       cCODCLI := SUBSTR(pCHVCLI,4,10); 
       cFILDEP := SUBSTR(pCHVDEP,1,3);  
       cSEQDEP := SUBSTR(pCHVDEP,4,10);     

       select CHRDEV_CRIA_SUBPAR INTO vCHRDEV_CRIA_SUBPAR FROM TT_CFG ;
    
      --estorna pagamento (utilizado R apenas para definir a primeira variavel como TRUE)
/*      IF pFLGEST = 'R' THEN 

         IF vCHRDEV_CRIA_SUBPAR = 'T' THEN             
            vAux := TGR_Atualiza_Recebimento(True,pCODFIL,pSEQUEN,cFILUSU,cCODUSU,pDATOPE);
         END IF;
      ELSE 
        IF pFLGEST = 'J' THEN 
          --davi - ptulio - 37085 - 03/08/05 
          INSERT INTO TT_CHR (CODFIL, SEQUEN, FLGEST, NUMCON, 
                              NUMDOC, CODBCO, FILUSU, CODUSU,
 	                      CODAGE, NUMCHE, ATU_EM, DATVEN,   			    
               	              VLRCHE, PORTAD, PAGAME, NUMDEP, 
 		              ALINEA, VLRDIF, 
			      --DUMMY,  
			      SEQCAN, 
   	                      AUTORI, TIPCOB, OBSLOG, DATOPE, 
 		              NUMECF, CDCMC7, FILCLI, CODCLI, 
			      VLRORI, PLACAS, SERCHE, FILDEP,
			      SEQDEP, DATFIS, DATREA, PORORI) 
                      VALUES (pCODFIL, pSEQUEN, 'X', pNUMCON,
 	     		      pNUMDOC, pCODBCO, cFILUSU, cCODUSU,
 	     		      pCODAGE, pNUMCHE, pATU_EM, pDATVEN,
	        	      pVLRCHE, pPORTAD, pPAGAME, pNUMDEP,   			    
	        	      pALINEA, pVLRDIF, 
			      --pDUMMY,  
			      pSEQCAN, 
	    		      pAUTORI, pTIPCOB, pOBSLOG, pDATOPE, 
	    		      pNUMECF, pCDCMC7, cFILCLI, cCODCLI, 
			      pVLRORI, pPLACAS, pSERCHE, cFILDEP, 
	    	              cSEQDEP, pDATFIS, pDATREA,pPORORI); 
        ELSE
        IF pFLGEST = 'X' THEN              
          --estorna pagamento (utilizado X apenas para definir a primeira variavel como FALSE)
          vAux := TGR_Atualiza_Recebimento(False,pCODFIL,pSEQUEN,cFILUSU,cCODUSU,pDATOPE);
        ELSE
*/
    IF pFLGEST is null or pFLGEST not in ('R','X','J') THEN
           OPEN SupCobrancas(pCODFIL,pSEQUEN);
             LOOP
             FETCH SupCobrancas INTO cCODFIL,cSEQUEN;
              EXIT WHEN NOT FOUND;

                 UPDATE TT_SUP
                    SET SITUAC = 'R'
                  WHERE CODFIL = cCODFIL
                    AND SEQUEN = cSEQUEN
                    AND (SELECT SUM( CASE WHEN COB.FILREC IS NOT NULL THEN
                                         CASE WHEN REC.FLGEST = 'A' THEN 1
                                                                    ELSE 0
                                         END
                                     ELSE CASE WHEN CHR.FLGEST = 'D' THEN 1
                                                                     ELSE 0
                                           END
                                      END)
                           FROM TT_COB COB LEFT OUTER JOIN TT_REC REC ON REC.CODFIL = COB.FILREC
                                                                     AND REC.SEQUEN = COB.SEQREC
                                                                     AND REC.NUMPAR = COB.NUMPAR
                                                                     AND REC.SUBPAR = COB.SUBPAR
                                           LEFT OUTER JOIN TT_CHR CHR ON COB.FILCHR = CHR.CODFIL
                                                                     AND COB.SEQCHR = CHR.SEQUEN
                          WHERE COB.FILSUP = TT_SUP.CODFIL
                            AND COB.SEQSUP = TT_SUP.SEQUEN
                          GROUP BY COB.FILSUP, COB.SEQSUP) = 0;
           END LOOP;
           CLOSE SupCobrancas;
--        END IF; 
--      END IF;
    END IF;
      RETURN NULL;

END;
$$ language 'plpgsql';



/*-- SEQ 1840 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AtualizaConjuge (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,TT_CLI.FILCON%TYPE,TT_CLI.CODCON%TYPE) CASCADE;

/*-- SEQ 1841 --*/
CREATE OR REPLACE FUNCTION AtualizaConjuge (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,TT_CLI.FILCON%TYPE,TT_CLI.CODCON%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILCLI ALIAS FOR $1 ;
pCODCLI ALIAS FOR $2 ;
pFILCON ALIAS FOR $3 ;
pCODCON ALIAS FOR $4 ;
BEGIN
  RETURN 'OK';
END;
$$ language 'plpgsql';




/*-- SEQ 1842 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AtualizaConjuge (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,TT_CLI.FILCON%TYPE,TT_CLI.CODCON%TYPE) CASCADE;

/*-- SEQ 1843 --*/
CREATE OR REPLACE FUNCTION AtualizaConjuge (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,TT_CLI.FILCON%TYPE,TT_CLI.CODCON%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILCLI ALIAS FOR $1 ;
pCODCLI ALIAS FOR $2 ;
pFILCON ALIAS FOR $3 ;
pCODCON ALIAS FOR $4 ;
  cPrimeiroNome   VARCHAR(1);
  cUsaSobrenome   VARCHAR(1);
  cVazio          VARCHAR(1);
  cDummy          VARCHAR(1);
  bVeioDoPackage  boolean;
  pg_dummy VARCHAR(5)
;
BEGIN
  cPrimeiroNome := 'F';
  cUsaSobrenome := 'T';
  cVazio        := ' ';

  -- Foi ativado pelo package?
  IF PC_TRIGGERS_ENABLED('PC_CONJUGE',FALSE) THEN
    bVeioDoPackage := false;
    pg_dummy := PC_INIT('PC_CONJUGE',FALSE)
;
  ELSE
    bVeioDoPackage := true;
  END IF;
   
  UPDATE TT_CLI
   SET NOMCLI = CASE WHEN ISNULL(SeparaNomes( CLI.CONJUG, cPrimeiroNome)) = cUsaSobrenome THEN  TT_CLI.NOMCLI ELSE SeparaNomes( CLI.CONJUG, cPrimeiroNome) END,
        ULTNOM = COALESCE( SeparaNomes( CLI.CONJUG, cUsaSobrenome), TT_CLI.ULTNOM),
        CONJUG = COALESCE( substr( TRIM(CLI.NOMCLI) || cVazio || TRIM(CLI.ULTNOM), 1, 44 ), TT_CLI.CONJUG ),
        NUMDOC = COALESCE( CLI.DOCCON, TT_CLI.NUMDOC ),
        CODSEX = COALESCE( CASE CLI.SEXCON WHEN 0 THEN NULL ELSE CLI.SEXCON END, TT_CLI.CODSEX ),
        DATNAS = COALESCE( CLI.NASCON, TT_CLI.DATNAS ),
        DOCCON = COALESCE( CLI.NUMDOC, TT_CLI.DOCCON ),
        ESTCIV = COALESCE( CLI.ESTCIV, TT_CLI.ESTCIV ),
        SEXCON = COALESCE( CLI.CODSEX, TT_CLI.SEXCON ),
        NASCON = COALESCE( CLI.DATNAS, TT_CLI.NASCON ),
        FILCON = CLI.FILCLI,
        CODCON = CLI.CODCLI,
        INSEST = COALESCE( SPC.RGCONJ, TT_CLI.INSEST ),
        DDCCON = COALESCE( SPC.DDDCEL, TT_CLI.DDCCON ),
        CELCON = COALESCE( SPC.NUMCEL, TT_CLI.CELCON ),
        E_MCON = COALESCE( SPC.E_MAIL, TT_CLI.E_MCON ),
        ATU_EM = AGORA()
  FROM TT_CLI CLI LEFT JOIN TT_SPC SPC ON SPC.FILCLI = CLI.FILCLI AND SPC.CODCLI = CLI.CODCLI
 WHERE CLI.FILCLI = pFILCLI AND CLI.CODCLI = pCODCLI AND TT_CLI.FILCLI = pFILCON AND TT_CLI.CODCLI = pCODCON;

  UPDATE TT_END
   SET CODDDD = COALESCE( CLI.DDTCON, TT_END.CODDDD),
        NUMFON = COALESCE( CLI.TELCON, TT_END.NUMFON)
  FROM TT_CLI CLI
 WHERE CLI.FILCLI = pFILCLI AND CLI.CODCLI = pCODCLI AND TT_END.FILCLI = pFILCON AND TT_END.CODCLI = pCODCON AND TT_END.CODFIL = pFILCON AND TT_END.NUMEND = 0;

  UPDATE TT_SPC
   SET DDDCEL = COALESCE( CLI.DDCCON, TT_SPC.DDDCEL ),
        NUMCEL = COALESCE( CLI.CELCON, TT_SPC.NUMCEL ),
        RGCONJ = COALESCE( CLI.INSEST, TT_SPC.RGCONJ ),
        E_MAIL = COALESCE( CLI.E_MCON, TT_SPC.E_MAIL ),
        SERCAR = COALESCE( SPC.SERCAC, TT_SPC.SERCAR ),
        SERCAC = COALESCE( SPC.SERCAR, TT_SPC.SERCAC ),
        ATUMES = COALESCE( SPC.ANTMES, TT_SPC.ATUMES ),
        CODOCU = COALESCE( SPC.CONOCU, TT_SPC.CODOCU ),
        CARPRO = COALESCE( SPC.CARPRC, TT_SPC.CARPRO ),
        FIRATU = COALESCE( SPC.FIRCON, TT_SPC.FIRATU ),
        SALBAS = COALESCE( SPC.SALBAC, TT_SPC.SALBAS ),
        ENDERE = COALESCE( SPC.ENDCO1, TT_SPC.ENDERE ),
        COMPLE = COALESCE( SPC.ENDCO2, TT_SPC.COMPLE ),
        NUMCOD = COALESCE( SPC.NUMCOC, TT_SPC.NUMCOD ),
        NUMTEL = COALESCE( SPC.TELCON, TT_SPC.NUMTEL ),
        CANMES = COALESCE( SPC.ATUMES, TT_SPC.CANMES ),
        CONOCU = COALESCE( SPC.CODOCU, TT_SPC.CONOCU ),
        CARPRC = COALESCE( SPC.CARPRO, TT_SPC.CARPRC ),
        FIRCON = COALESCE( SPC.FIRATU, TT_SPC.FIRCON ),
        SALBAC = COALESCE( SPC.SALBAS, TT_SPC.SALBAC ),
        ENDCO1 = COALESCE( SPC.ENDERE, TT_SPC.ENDCO1 ),
        ENDCO2 = COALESCE( SUBSTR(SPC.COMPLE,1,20), TT_SPC.ENDCO2 ),
        NUMCOC = COALESCE( SPC.NUMCOD, TT_SPC.NUMCOC ),
        TELCON = COALESCE( SPC.NUMTEL, TT_SPC.TELCON ),
        ANTMES = COALESCE( SPC.ATUMES, TT_SPC.ANTMES )
  FROM TT_CLI CLI LEFT JOIN TT_SPC SPC ON SPC.FILCLI = CLI.FILCLI AND SPC.CODCLI = CLI.CODCLI
 WHERE CLI.FILCLI = pFILCLI AND CLI.CODCLI = pCODCLI AND TT_SPC.FILCLI = pFILCON AND TT_SPC.CODCLI = pCODCON;
         
  -- Se nao veio do package...
  IF not bVeioDoPackage THEN
    pg_dummy := PC_INIT('PC_CONJUGE',TRUE)
;
  END IF;

  RETURN 'OK';
END;
$$ language 'plpgsql';




/*-- SEQ 1844 --*/
    -- Inclusao do parceiro do tipo filial
CREATE OR REPLACE FUNCTION PC_DFIL_Insert_Cascade_Cli (TD_FIL.CODFIL%TYPE,TD_FIL.RAZSOC%TYPE,TD_FIL.NOMFIL%TYPE,TD_FIL.CGCFIL%TYPE,VARCHAR,TD_FIL.IE_FIL%TYPE,TD_FIL.REGTRI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_Filial ALIAS FOR $1 ;
p_Razao ALIAS FOR $2 ;
p_Nome ALIAS FOR $3 ;
p_CGC ALIAS FOR $4 ;
p_Codigo_Filial ALIAS FOR $5 ;
p_IE ALIAS FOR $6 ;
p_REGTRI ALIAS FOR $7 ;
    BEGIN
      -- Incluindo
      INSERT INTO TT_CLI (FILCLI
                         ,CODCLI
                         ,NOMCLI
                         ,ULTNOM
                         ,SIGNAT
                         ,ATU_EM
                         ,NUMDOC
                         ,FLGTIP
                         ,PP_FLG
                         ,INSEST
                         ,TIPDOC  -- Rhuan - 96011 - Inclusão de TIPDOC na inclusão do parceiro
                         ,SIMPLE)
                  VALUES (p_Filial
                         ,p_Codigo_Filial
                         ,p_Razao
                         ,p_Nome
                         ,2
                         ,agora()
                         ,p_CGC
                         ,5
                         ,'F'
                         ,p_IE
                         ,'IE'
                         ,CASE WHEN p_REGTRI = 'S' THEN 'T' ELSE 'F' END);
  RETURN NULL;

END;
$$ language 'plpgsql';


    -- Inclusao do parceiro do tipo filial
CREATE OR REPLACE FUNCTION PC_DFIL_Insert_Cascade_Rel (TD_FIL.CODFIL%TYPE,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
p_Filial ALIAS FOR $1 ;
p_Codigo_Filial ALIAS FOR $2 ;
    BEGIN
      -- Incluindo
      INSERT INTO TT_REL (FILPAR
                         ,CODPAR
                         ,TIPPAR)
                  VALUES (p_Filial
                         ,p_Codigo_Filial
                         ,'F'
                         );
  RETURN NULL;

END;
$$ language 'plpgsql';

CREATE OR REPLACE FUNCTION PC_DFIL_Update_Cascade_End (TD_FIL.CODFIL%TYPE,TD_FIL.RAZSOC%TYPE,TD_FIL.NOMFIL%TYPE,TD_FIL.CGCFIL%TYPE,VARCHAR,TD_FIL.ENDERE%TYPE,TD_FIL.COMPLE%TYPE,TD_FIL.NUMERO%TYPE,TD_FIL.DDDFIL%TYPE,TD_FIL.NUMFON%TYPE,TD_FIL.CODCEP%TYPE,TD_FIL.BAIRRO%TYPE,TD_FIL.UFLOJA%TYPE,TD_FIL.FAXFIL%TYPE,TD_FIL.IE_FIL%TYPE,TD_FIL.CODCID%TYPE,VARCHAR,TD_FIL.TIPEND%TYPE,TD_FIL.CODIBG%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_Filial ALIAS FOR $1 ;
p_Razao ALIAS FOR $2 ;
p_Nome ALIAS FOR $3 ;
p_CGC ALIAS FOR $4 ;
p_Codigo_Filial ALIAS FOR $5 ;
p_ENDERE ALIAS FOR $6 ;
p_COMPLE ALIAS FOR $7 ;
p_NUMERO ALIAS FOR $8 ;
p_DDDFIL ALIAS FOR $9 ;
p_NUMFON ALIAS FOR $10 ;
p_CODCEP ALIAS FOR $11 ;
p_BAIRRO ALIAS FOR $12 ;
p_UFLOJA ALIAS FOR $13 ;
p_FAXFIL ALIAS FOR $14 ;
p_IE ALIAS FOR $15 ;
p_CODCID ALIAS FOR $16 ;
p_NOMCID ALIAS FOR $17 ;
p_TIPEND ALIAS FOR $18 ;
p_CODIBG ALIAS FOR $19 ;
    BEGIN
      UPDATE TT_END SET ENDERE = trim(p_ENDERE),
                        COMPLE = substr(trim(p_COMPLE),1,40),
                        NUMERO = trim(p_NUMERO),
                        CODDDD = substr(trim(p_DDDFIL),1,2),
                        NUMFON = substr(trim(p_NUMFON),1,10),
                        CODLOG = SUBSTR(trim(p_CODCEP),6,3),
                        CODCEP = SUBSTR(trim(p_CODCEP),1,5),
                        BAIRRO = trim(p_BAIRRO),
                        SIGEST = substr(trim(p_UFLOJA),1,2),
                        NUMFAX = substr(trim(p_FAXFIL),1,8),
                        INSEST = trim(p_IE),
                        CODCID = p_CODCID,
                        NOMCID = trim(p_NOMCID),
                        TIPEND = p_TIPEND,
                        NUMDOC = p_CGC,
                        CODIBG = p_CODIBG
       WHERE FILCLI = p_Filial
         AND CODCLI = p_Codigo_Filial
         AND SIGNAT >= 0;

  RETURN NULL;

END;
$$ language 'plpgsql';



CREATE OR REPLACE FUNCTION PC_DFIL_Insert_Cascade_End (TD_FIL.CODFIL%TYPE,TD_FIL.RAZSOC%TYPE,TD_FIL.NOMFIL%TYPE,TD_FIL.CGCFIL%TYPE,VARCHAR,TD_FIL.ENDERE%TYPE,TD_FIL.COMPLE%TYPE,TD_FIL.NUMERO%TYPE,TD_FIL.DDDFIL%TYPE,TD_FIL.NUMFON%TYPE,TD_FIL.CODCEP%TYPE,TD_FIL.BAIRRO%TYPE,TD_FIL.UFLOJA%TYPE,TD_FIL.FAXFIL%TYPE,TD_FIL.IE_FIL%TYPE,TD_FIL.CODCID%TYPE,VARCHAR,TD_FIL.TIPEND%TYPE,TD_FIL.CODIBG%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_Filial ALIAS FOR $1 ;
p_Razao ALIAS FOR $2 ;
p_Nome ALIAS FOR $3 ;
p_CGC ALIAS FOR $4 ;
p_Codigo_Filial ALIAS FOR $5 ;
p_ENDERE ALIAS FOR $6 ;
p_COMPLE ALIAS FOR $7 ;
p_NUMERO ALIAS FOR $8 ;
p_DDDFIL ALIAS FOR $9 ;
p_NUMFON ALIAS FOR $10 ;
p_CODCEP ALIAS FOR $11 ;
p_BAIRRO ALIAS FOR $12 ;
p_UFLOJA ALIAS FOR $13 ;
p_FAXFIL ALIAS FOR $14 ;
p_IE ALIAS FOR $15 ;
p_CODCID ALIAS FOR $16 ;
p_NOMCID ALIAS FOR $17 ;
p_TIPEND ALIAS FOR $18 ;
p_CODIBG ALIAS FOR $19 ;
BEGIN
      INSERT INTO TT_END (FILCLI,CODCLI,CODFIL,NUMEND,ENDCOB,ENDCOR,NUMDOC,ENDERE,
                          COMPLE,CODCEP,CODDDD,NUMFON,NUMFAX,CODLOG,BAIRRO,SIGEST,NUMERO,
                          FLGNAC,USA_NF,INSEST,CODCID,NOMCID,TIPEND,CODIBG)
                  VALUES (p_Filial,p_Codigo_Filial,p_Filial,1,'T','T',p_CGC,
                          trim(p_ENDERE),substr(trim(p_COMPLE),1,40),SUBSTR(trim(p_CODCEP),1,5),
                          substr(trim(p_DDDFIL),1,2),SUBSTR(trim(p_NUMFON),1,10),substr(trim(p_FAXFIL),1,8),
                          SUBSTR(trim(p_CODCEP),6,3),trim(p_BAIRRO),substr(trim(p_UFLOJA),1,2),
                          trim(p_NUMERO),'F','T',trim(p_IE),p_CODCID,trim(p_NOMCID),p_TIPEND, p_CODIBG);

  RETURN NULL;

END;
$$ language 'plpgsql';


    -- Alteracao do parceiro do tipo filial
CREATE OR REPLACE FUNCTION PC_DFIL_Update_Cascade_Cli (TD_FIL.CODFIL%TYPE,TD_FIL.RAZSOC%TYPE,TD_FIL.NOMFIL%TYPE,TD_FIL.CGCFIL%TYPE,VARCHAR,TD_FIL.IE_FIL%TYPE,TD_FIL.REGTRI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_Filial ALIAS FOR $1 ;
p_Razao ALIAS FOR $2 ;
p_Nome ALIAS FOR $3 ;
p_CGC ALIAS FOR $4 ;
p_Codigo_Filial ALIAS FOR $5 ;
p_IE ALIAS FOR $6 ;
p_REGTRI ALIAS FOR $7 ;
    BEGIN
      -- Alterando
      UPDATE TT_CLI SET NOMCLI = p_Razao,
                        ULTNOM = p_Nome,
                        NUMDOC = p_CGC,
                        ATU_EM = agora(),
                        DUMMY = Constante('vem_de_TGDFIL'),
                        INSEST = p_IE,
                        SIMPLE = CASE WHEN p_REGTRI = 'S' THEN 'T' ELSE 'F' END
       WHERE FILCLI = p_Filial
         AND CODCLI = p_Codigo_Filial;

  RETURN NULL;

END;
$$ language 'plpgsql';

    -- Inclusao do usuario do tipo Filial
CREATE OR REPLACE FUNCTION PC_DFIL_Insert_Cascade_Usu (TD_FIL.CODFIL%TYPE,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
p_Filial ALIAS FOR $1 ;
p_Codigo_Filial ALIAS FOR $2 ;
p_Codigo_Usuario ALIAS FOR $3 ;
      wk_Maximo Numeric;
    BEGIN

      -- Descobrindo o proximo codigo externo livre
              SELECT TO_NUMBER(MAX(LPAD(LTRIM(RTRIM(CODEXT)),10,'0') ) ) + 1 INTO wk_Maximo
          FROM TT_USU;
      
      wk_Maximo := COALESCE(wk_Maximo, 1); -- Em PG se NO_DATA_FOUND wk_Maximo vale NULL

      -- Incluindo usuario
      INSERT INTO TT_USU (FILUSU
                         ,CODUSU
                         ,NOMUSU
                         ,APEUSU
                         ,NIVUSU
                         ,ATU_EM
                         ,CODEXT
                         ,FILCLI
                         ,CODCLI
                         ,PERCOM
                         ,SENHA1
                         ,SENHA2
                         ,MAIDAT
                         ,MENDAT
                         ,FILSUP
                         ,CODSUP
                         ,PERMIS
                         ,SIGNAT)
                  VALUES (p_Filial
                         ,p_Codigo_Usuario
                         ,'ADMINISTRADOR FILIAL '||rtrim(ltrim(p_Filial))
                         ,'ADM_'||rtrim(ltrim(p_Filial))
                         ,0
                         ,agora()
                         ,LPad( wk_maximo ,10, '0' )
                         ,p_Filial
                         ,p_Codigo_Filial
                         ,0
                         ,'200'
                         ,'200'
                         ,0
                         ,0
                         ,p_Filial
                         ,p_Codigo_Usuario
                         ,LPAD('N',100,'N')
                         ,0);
  RETURN NULL;

END;
$$ language 'plpgsql';

    -- Inclusao de ECF padrao
CREATE OR REPLACE FUNCTION PC_DFIL_Insert_Cascade_ECF (TD_FIL.CODFIL%TYPE,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
p_Filial ALIAS FOR $1 ;
p_Codigo_ECF ALIAS FOR $2 ;
      wk_Maximo Numeric;
    BEGIN
      -- Obtem o proximo numero livre para o ECF

              SELECT MAX(CODTAB)+1 INTO wk_Maximo
          FROM TD_ECF;
      
      wk_Maximo := COALESCE(wk_Maximo, 1); -- Em PG se NO_DATA_FOUND wk_Maximo vale NULL

      -- Para garantir a integridade referencial
      INSERT INTO TD_IND (CODTAB)
           SELECT wk_Maximo FROM DUAL
            WHERE wk_Maximo NOT IN (SELECT CODTAB FROM TD_IND);

      -- Inclui um ECF padrao
      INSERT INTO TD_ECF (CODTAB
                         ,FILECF
                         ,NUMECF
                         ,ECFATI
                         ,COBECF
                         ,CODORI
                         ,MAXCAI)
                  VALUES (wk_Maximo
                         ,p_Filial
                         ,p_Codigo_ECF
                         ,'T'
                         ,'E'
                         ,'000'
                         ,99999.99);
  RETURN NULL;

END;
$$ language 'plpgsql';


CREATE OR REPLACE FUNCTION PC_DFIL_Principal (TD_FIL.RAZSOC%TYPE,TD_FIL.FILATI%TYPE,TD_FIL.CODFIL%TYPE,TD_FIL.NOMFIL%TYPE,TD_FIL.CGCFIL%TYPE,TD_FIL.ENDERE%TYPE,TD_FIL.COMPLE%TYPE,TD_FIL.NUMERO%TYPE,TD_FIL.DDDFIL%TYPE,TD_FIL.NUMFON%TYPE,TD_FIL.CODCEP%TYPE,TD_FIL.BAIRRO%TYPE,TD_FIL.UFLOJA%TYPE,TD_FIL.FAXFIL%TYPE,TD_FIL.IE_FIL%TYPE,TD_FIL.REGESP%TYPE,TD_FIL.CODCID%TYPE,TD_FIL.TIPEND%TYPE,TD_FIL.CODIBG%TYPE,TD_FIL.REGTRI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_RAZSOC ALIAS FOR $1 ;
p_FILATI ALIAS FOR $2 ;
p_CODFIL ALIAS FOR $3 ;
p_NOMFIL ALIAS FOR $4 ;
p_CGCFIL ALIAS FOR $5 ;
p_ENDERE ALIAS FOR $6 ;
p_COMPLE ALIAS FOR $7 ;
p_NUMERO ALIAS FOR $8 ;
p_DDDFIL ALIAS FOR $9 ;
p_NUMFON ALIAS FOR $10 ;
p_CODCEP ALIAS FOR $11 ;
p_BAIRRO ALIAS FOR $12 ;
p_SIGEST ALIAS FOR $13 ;
p_FAXFIL ALIAS FOR $14 ;
p_IE ALIAS FOR $15 ;
p_REGESP ALIAS FOR $16 ;
p_CODCID ALIAS FOR $17 ;
p_TIPEND ALIAS FOR $18 ;
p_CODIBG ALIAS FOR $19 ;
p_REGTRI ALIAS FOR $20 ;
      wk_existe INTEGER;
      c_Codigo_Filial  CONSTANT CHAR(6) := '     0';
      c_Codigo_Usuario CONSTANT CHAR(3) := '  1';
      c_Codigo_ECF     CONSTANT CHAR(3) := '000';
      cDUMMY           VARCHAR(1);
      vTemp VARCHAR(2);
      p_NOMCID VARCHAR(35);
    BEGIN

      IF p_REGESP = -1 THEN
         -- Atualiza a TT_IUF
         INSERT INTO TT_IUF
         (FILMAT,CODMAT,ESTADO,REGESP,RESICM,LUCSUB,SUBTRI,INSAGR,CALSUB)
         (SELECT FILMAT,
                 CODMAT,
                 UFLOJA,
                 REGESP,
                 0 AS RESICM,
                 0 AS LUCSUB,
                 '0' AS SUBTRI,
                 'F' AS INSAGR,
                 'D' AS CALSUB
           FROM (SELECT PRO.FILMAT,PRO.CODMAT,FIL.*
                   FROM TT_PRO PRO, (SELECT DISTINCT UFLOJA, REGESP
                                       FROM TD_FIL DFIL
                                    ) FIL
                  WHERE NOT EXISTS(SELECT 1 AS OK
                           FROM TT_IUF IUF
                           WHERE IUF.FILMAT = PRO.FILMAT 
                             AND IUF.CODMAT = PRO.CODMAT
                             AND IUF.ESTADO = FIL.UFLOJA
                             AND IUF.REGESP = FIL.REGESP
                         )
                 ) TAB
         );
      END IF;

      IF p_FILATI = 'I' THEN
         cDummy := PC_DFIL_Insert_Cascade_Cli(p_CODFIL,p_RAZSOC,p_NOMFIL,p_CGCFIL,c_Codigo_Filial,p_IE,p_REGTRI);
         cDummy := PC_DFIL_Insert_Cascade_Rel(p_CODFIL,c_Codigo_Filial);
         cDummy := PC_DFIL_Insert_Cascade_End(p_CODFIL,p_RAZSOC,p_NOMFIL,p_CGCFIL,c_Codigo_Filial,p_ENDERE,
                                                       p_COMPLE,p_NUMERO,p_DDDFIL,p_NUMFON,p_CODCEP,p_BAIRRO,p_SIGEST,
                                                       p_FAXFIL,p_IE,p_CODCID,p_NOMCID,p_TIPEND,p_CODIBG);
         --cDummy := PC_DFIL_Insert_Cascade_Usu(p_CODFIL,c_Codigo_Filial,c_Codigo_Usuario);
         cDummy := PC_DFIL_Insert_Cascade_ECF(p_CODFIL,c_Codigo_ECF);
         vTemp:=GeraSaldo(p_CODFIL);
         vTemp:=GeraSaldoLote(p_CODFIL); -- RFMP 96855
      ELSIF p_FILATI = 'U' THEN
         -- Se por algum motivo nao existir o cliente...
         SELECT COUNT(*) INTO wk_Existe
           FROM TT_CLI
          WHERE FILCLI = p_CODFIL
            AND CODCLI = c_Codigo_Filial;

         -- ... tenta incluir novamente.
         IF wk_Existe = 0 THEN
            cDummy := PC_DFIL_Insert_Cascade_Cli(p_CODFIL,p_RAZSOC,p_NOMFIL,p_CGCFIL,c_Codigo_Filial,p_IE,p_REGTRI);
            cDummy := PC_DFIL_Insert_Cascade_Rel(p_CODFIL,c_Codigo_Filial);
         ELSE
            cDummy := PC_DFIL_Update_Cascade_Cli(p_CODFIL,p_RAZSOC,p_NOMFIL,p_CGCFIL,c_Codigo_Filial,p_IE,p_REGTRI);
         END IF;

         -- ... verifica endereco.
         SELECT COUNT(*) INTO wk_Existe
           FROM TT_END
          WHERE FILCLI = p_CODFIL
            AND CODCLI = c_Codigo_Filial;

         --..busca NOMCID
         SELECT NOMCID INTO p_NOMCID
           FROM TT_MUN
          WHERE CODIGO = p_CODCID;


         IF wk_Existe = 0 THEN
           cDummy := PC_DFIL_Insert_Cascade_End(p_CODFIL,p_RAZSOC,p_NOMFIL,p_CGCFIL,c_Codigo_Filial,p_ENDERE,
                                                         p_COMPLE,p_NUMERO,p_DDDFIL,p_NUMFON,p_CODCEP,p_BAIRRO,p_SIGEST,
                                                         p_FAXFIL,p_IE,p_CODCID,p_NOMCID,p_TIPEND,p_CODIBG);
         ELSE
           cDummy := PC_DFIL_Update_Cascade_End(p_CODFIL,p_RAZSOC,p_NOMFIL,p_CGCFIL,c_Codigo_Filial,p_ENDERE,
                                                         p_COMPLE,p_NUMERO,p_DDDFIL,p_NUMFON,p_CODCEP,p_BAIRRO,p_SIGEST,
                                                         p_FAXFIL,p_IE,p_CODCID,p_NOMCID,p_TIPEND,p_CODIBG);
         END IF;


         -- Se por algum motivo nao existir o usuario...
         SELECT COUNT(*) INTO wk_Existe
           FROM TT_USU
          WHERE FILUSU = p_CODFIL
            AND CODUSU = c_Codigo_Usuario;

         -- ... tenta incluir novamente.
         --IF wk_Existe = 0 THEN
         --  cDummy := PC_DFIL_Insert_Cascade_Usu(p_CODFIL,c_Codigo_Filial,c_Codigo_Usuario);
         --END IF;

         -- Se por algum motivo nao existir o ECF...
         SELECT COUNT(*) INTO wk_Existe
           FROM TD_ECF
          WHERE FILECF = p_CODFIL
            AND NUMECF = c_Codigo_ECF;

         -- ... tenta incluir novamente.
         IF wk_Existe = 0 THEN
           cDummy := PC_DFIL_Insert_Cascade_ECF(p_CODFIL,c_Codigo_ECF);
         END IF;
      ELSE
         -- Tenta deletar tambem o parceiro do tipo filial
         DELETE FROM TT_CLI
          WHERE FILCLI = p_CODFIL
            AND CODCLI = c_Codigo_Filial;
      END IF;
  RETURN NULL;

END;
$$ language 'plpgsql';



/*-- SEQ 1845 --*/
CREATE OR REPLACE FUNCTION PC_DOP_AtualizePAG (TT_DOP.CODFIL%TYPE,TT_DOP.SEQUEN%TYPE,TT_DOP.FLGEST%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCodFil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
pFlgEst ALIAS FOR $3 ;
BEGIN
      IF (pFlgEst = 'C') THEN
          UPDATE TT_PAG
             SET FLGEST = 'X'
           WHERE FILDOP = pCodFil
             AND SEQDOP = pSequen;
		
		--rodrigo 55934
		INSERT INTO TT_CCC
        (CODFIL,FILCLI, CODCLI,
         FILUSU, CODUSU,NUMDOC,
         DATOPE, TIPCCC, VLRLAN,
         STATUS, EXPORT, PORORI,
         FILDOP, SEQDOP)
         (SELECT CODFIL, FILCLI, CODCLI,
                 FILUSU, CODUSU, 'ESTORNO C/C' AS NUMDOC,
                 DATOPE, TIPCCC, (VLRLAN * -1),
                 STATUS, EXPORT, PORORI,
                 FILDOP, SEQDOP
            FROM TT_CCC
           WHERE FILDOP = pCODFIL
             AND SEQDOP = pSEQUEN);
			 
      END IF;
  RETURN NULL;

END;
$$ language 'plpgsql';

CREATE OR REPLACE FUNCTION PC_DOP_AtualizeLDOP (TL_DOP.FILDOP%TYPE,TL_DOP.SEQDOP%TYPE,TL_DOP.MSGLOG%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFilDop ALIAS FOR $1 ;
pSeqDop ALIAS FOR $2 ;
pMsgLog ALIAS FOR $3 ;
BEGIN  
      INSERT INTO TL_DOP (FILDOP,SEQDOP,MSGLOG)
                  VALUES (pFilDop,
                          pSeqDop,
                          pMsgLog);
  RETURN NULL;

END;
$$ language 'plpgsql';





/*-- SEQ 1846 --*/


    CREATE OR REPLACE FUNCTION PC_FER_AUX_UPDATE (TT_FER.CODFIL%TYPE,TT_FER.SEQUEN%TYPE,TT_FER.DIAFER%TYPE,TT_FER.MESFER%TYPE,TT_FER.ANOFER%TYPE,TT_FER.FILFER%TYPE,TT_FER.LOJABR%TYPE,CHAR)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pDIAFER ALIAS FOR $3 ;
pMESFER ALIAS FOR $4 ;
pANOFER ALIAS FOR $5 ;
pFILFER ALIAS FOR $6 ;
pLOJABR ALIAS FOR $7 ;
pOperacao ALIAS FOR $8 ;
               
    cDUMMY CHAR(2);
    BEGIN
    
        cDUMMY := TGR_FER_AtualizaUTL(pDIAFER,pMESFER,pANOFER,pFILFER,pLOJABR,pOperacao);
        
      RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 1847 --*/



      CREATE OR REPLACE FUNCTION PC_FIN_UPDATE (TT_FIN.CODFIL%TYPE,TT_FIN.SEQUEN%TYPE,TT_FIN.SEQTRN%TYPE,TT_FIN.CHVTRN%TYPE,TT_FIN.FLGFIN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pSEQTRN ALIAS FOR $3 ;
pCHVTRN ALIAS FOR $4 ;
pFLGFIN ALIAS FOR $5 ;
      vChave       TT_FIN.CHVTRN%TYPE;
      vComplemento CONSTANT VARCHAR(100) := constante('complemento');
      vAplNumOri   CHAR(1);
      vAplNumDes   CHAR(1);
      cAPEUSU      TT_USU.APEUSU%TYPE;
      BEGIN


      IF pFLGFIN IN ('A','R') THEN
                  SELECT CHVTRN INTO vChave
            FROM TT_FIN
           WHERE CODFIL = pCODFIL
             AND SEQUEN = pSEQTRN;
        
        IF vChave IS NULL THEN
                      RAISE EXCEPTION 'PG-20003 Nao existe chave no lancamento de envio. %' , vComplemento;
        END IF;

        IF (pCHVTRN IS NOT NULL) AND (pCHVTRN <> '#####') AND (pCHVTRN <> vChave) THEN
                      RAISE EXCEPTION 'PG-20004 Chave nao confere com a do lancamento de envio. %' , vComplemento;
        ELSE
          UPDATE TT_FIN
             SET CHVTRN = vChave
           WHERE CODFIL = pCODFIL
             AND SEQUEN = pSEQUEN;
        END IF;
      END IF;
      -- PTulio - davi - 02/05/05 - 33744 - INICIO
                 SELECT APLNUM INTO vAplNumOri
           FROM TT_CTA
          WHERE (CODFIL,SEQUEN) IN (SELECT FILNUM,SEQNUM
                                      FROM TT_FIN
	                             WHERE SEQUEN = pSEQTRN);
        
                SELECT APLNUM INTO vAplNumDes
           FROM TT_CTA
          WHERE (CODFIL,SEQUEN) IN (SELECT FILNUM,SEQNUM
                                      FROM TT_FIN
	                             WHERE CODFIL = pCODFIL
		                       AND SEQUEN = pSEQUEN);
       
       IF (vAplNumOri IS NOT NULL) AND (vAplNumDes IS NOT NULL) THEN

          cAPEUSU := GetApeUsuAtual();

          IF (vAplNumOri = 'B') AND
             (vAplNumDes = 'C') AND
             (PERMISSAO(cAPEUSU,183) = 0) THEN
            RAISE EXCEPTION 'PG-20005 Voce nao tem permissao para realizar transferencias de Conta Bancaria para Conta Caixa. %' , vComplemento;
          END IF;

          IF (vAplNumOri = 'C') AND
             (vAplNumDes = 'B') AND
             (PERMISSAO(cAPEUSU,184) = 0) THEN
            RAISE EXCEPTION 'PG-20006 Voce nao tem permissao para realizar transferencias de Conta Caixa para Conta Bancaria. %' , vComplemento;
          END IF;

          IF (vAplNumOri = 'D') AND
             (vAplNumDes = 'D') AND
             (PERMISSAO(cAPEUSU,185) = 0) THEN
            RAISE EXCEPTION 'PG-20007 Voce nao tem permissao para realizar transferencias entre contas de diferenca. %' , vComplemento;
          END IF;

          IF (vAplNumOri = 'C') AND
             (vAplNumDes = 'D') AND
             (PERMISSAO(cAPEUSU,186) = 0) THEN
            RAISE EXCEPTION 'PG-20008 Voce nao tem permissao para realizar transferencias de Conta Caixa para Conta de diferenca. %' , vComplemento;
          END IF;

          IF (vAplNumOri = 'D') AND
             (vAplNumDes = 'C') AND
             (PERMISSAO(cAPEUSU,187) = 0) THEN
            RAISE EXCEPTION 'PG-20009 Voce nao tem permissao para realizar transferencias de Conta de diferenca para Conta Caixa. %' , vComplemento;
          END IF;

          IF (vAplNumOri = 'B') AND
             (vAplNumDes = 'B') AND
             (PERMISSAO(cAPEUSU,188) = 0) THEN
            RAISE EXCEPTION 'PG-20010 Voce nao tem permissao para realizar transferencias entre contas bancarias %' , vComplemento;
          END IF;

       END IF;
       -- PTulio - davi - 02/05/05 - 33744 - FIM

        RETURN NULL;

END;
$$ language 'plpgsql';



/*-- SEQ 1848 --*/
      CREATE OR REPLACE FUNCTION PC_GRA_UPDATE (TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILMAT ALIAS FOR $1 ;
pCODMAT ALIAS FOR $2 ;
pCODCOR ALIAS FOR $3 ;
pCODTAM ALIAS FOR $4 ;  
         vAux VARCHAR(2);
      BEGIN
      
      vAux:=GeraSaldo(pFILMAT,pCODMAT,pCODCOR,pCODTAM);      
      
        RETURN NULL;

END;
$$ language 'plpgsql';                                      


/*-- SEQ 1849 --*/
   CREATE OR REPLACE FUNCTION PC_IAG_UPDATE (TT_AGE.CODFIL%TYPE,TT_AGE.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCodfil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
   BEGIN
      UPDATE TT_AGE
         SET DATINI = (SELECT MIN(IAG.DATINI)
                         FROM TT_IAG IAG
                        WHERE IAG.CODFIL = TT_AGE.CODFIL
                          AND IAG.SEQUEN = TT_AGE.SEQUEN),
             DATFIM = (SELECT MAX(IAG.DATFIM)
                         FROM TT_IAG IAG
                        WHERE IAG.CODFIL = TT_AGE.CODFIL
                          AND IAG.SEQUEN = TT_AGE.SEQUEN) 
       WHERE CODFIL = pCodFil
         AND SEQUEN = pSequen;
    RETURN NULL;

END;
$$ language 'plpgsql';


   CREATE OR REPLACE FUNCTION PC_ICO_AUX_UPDATE (TT_ICO.COM_DATOPE%TYPE,TT_ICO.CODFIL%TYPE,TT_ICO.FILMAT%TYPE,TT_ICO.CODMAT%TYPE,TT_ICO.CODCOR%TYPE,TT_ICO.CODTAM%TYPE,TT_ICO.CODMUL%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCOM_DATOPE ALIAS FOR $1 ;
pCODFIL ALIAS FOR $2 ;
pFILMAT ALIAS FOR $3 ;
pCODMAT ALIAS FOR $4 ;
pCODCOR ALIAS FOR $5 ;
pCODTAM ALIAS FOR $6 ;
pCODMUL ALIAS FOR $7 ;
   BEGIN
      /* Atualiza a data do custo medio na TT_SAL */
      UPDATE TT_SAL
         SET CAL_CM = CASE WHEN CAL_CM IS NULL THEN NULL ELSE
                        CASE WHEN pCOM_DATOPE<CAL_CM THEN pCOM_DATOPE
                                                     ELSE CAL_CM
                        END
                      END,
             ATU_CM = 'F',
             DUMMY = Constante('vem_de_TGICO')
       WHERE CODFIL = pCODFIL
         AND FILMAT = pFILMAT
         AND CODMAT = pCODMAT
         AND CODCOR = pCODCOR
         AND CODTAM = pCODTAM
         AND CODMUL = 0;
         
     UPDATE TD_FIL SET DATFINEST=CASE WHEN DATFINEST IS NULL THEN NULL ELSE
                                    CASE WHEN pCOM_DATOPE<DATFINEST THEN TRUNC(pCOM_DATOPE)
                                                                 ELSE DATFINEST
                                    END
                                  END
      WHERE CODFIL = pCODFIL
        AND DATFINEST>TRUNC(pCOM_DATOPE);
      
    RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1850 --*/


    CREATE OR REPLACE FUNCTION PC_IOR_IVO_UPDATE (TT_IOR.CODFIL%TYPE,TT_IOR.TIPPED%TYPE,TT_IOR.NUMPED%TYPE,TT_IOR.NUMITE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pTIPPED ALIAS FOR $2 ;
pNUMPED ALIAS FOR $3 ;
pNUMITE ALIAS FOR $4 ;

CR_SEPARACAO_PC CURSOR FOR
  SELECT TAB.CODFIL,
         TAB.TIPPED,
         TAB.NUMPED,
         TAB.NUMITE
    FROM (SELECT IOR.CODFIL,
                 IOR.TIPPED,
                 IOR.NUMPED,
                 IOR.NUMITE,
                 QTD_A_SEPARAR(Null, Null, Null, IOR.CODFIL, IOR.TIPPED, IOR.NUMPED, IOR.NUMITE) AS QTDSEP
            FROM TT_IOR IOR INNER JOIN TT_ORC ORC ON IOR.CODFIL = ORC.CODFIL
                                                 AND IOR.TIPPED = ORC.TIPPED
                                                 AND IOR.NUMPED = ORC.NUMPED
                             LEFT JOIN TT_IVO IVO ON IVO.FILPED = IOR.CODFIL
                                                 AND IVO.TIPPED = IOR.TIPPED
                                                 AND IVO.NUMPED = IOR.NUMPED
                                                 AND IVO.NUMITE = IOR.NUMITE
                                                 AND IVO.FLGEST IN ('A','N')
           WHERE IOR.TIPENT IN ('1','2','3')
             AND ((LeParametroBoo('SEPARAR_TIP_1','','','','')='T' and IOR.TIPENT='1') or
                 (LeParametroBoo('SEPARAR_TIP_3','','','','')='T' and IOR.TIPENT='3') or
                 (IOR.TIPENT not in ('1','3')))
             AND IOR.FLGEST IN ('A','R')
             AND IOR.FLGIVO = 'A'
             AND ORC.TELEVE = 'T'
             AND ORC.APROVA = 'A'
             AND IOR.CODFIL = pCODFIL
             AND IOR.TIPPED = pTIPPED
             AND IOR.NUMPED = pNUMPED
             AND IOR.NUMITE = pNUMITE
             AND Tem_Encomenda(IOR.CODFIL, IOR.TIPPED, IOR.NUMPED) = 'F'
             AND IVO.FILVOL IS NULL
         ) TAB
   WHERE TAB.QTDSEP > 0
  UNION ALL
  SELECT TAB.CODFIL,
         TAB.TIPPED,
         TAB.NUMPED,
         TAB.NUMITE
    FROM (SELECT IOR.CODFIL,
                 IOR.TIPPED,
                 IOR.NUMPED,
                 IOR.NUMITE,
                 QTD_A_SEPARAR(Null, Null, Null, IOR.CODFIL, IOR.TIPPED, IOR.NUMPED, IOR.NUMITE) AS QTDSEP
            FROM TT_IOR IOR INNER JOIN TT_ORC ORC ON IOR.CODFIL = ORC.CODFIL
                                                 AND IOR.TIPPED = ORC.TIPPED
                                                 AND IOR.NUMPED = ORC.NUMPED
                            INNER JOIN TT_IVEXIPE ENC ON ENC.FILPED = IOR.CODFIL
                                                     AND ENC.TIPPED = IOR.TIPPED
                                                     AND ENC.NUMPED = IOR.NUMPED
                                                     AND ENC.NUMITE = IOR.NUMITE
                                                     AND ENC.FLGEST <> 'C'
                            INNER JOIN TT_IPE IPE ON IPE.CODFIL = ENC.FILIPE
                                                 AND IPE.NUMPED = ENC.NUMIPE
                                                 AND IPE.NUMITE = ENC.ITEIPE
                            INNER JOIN TT_ICO ICO ON ICO.CODFIL = IPE.FILICO
                                                 AND ICO.SEQUEN = IPE.SEQICO
                                                 AND ICO.NUMITE = IPE.NUMICO
                             LEFT JOIN TT_IVO IVO ON IVO.FILPED = IOR.CODFIL
                                                 AND IVO.TIPPED = IOR.TIPPED
                                                 AND IVO.NUMPED = IOR.NUMPED
                                                 AND IVO.NUMITE = IOR.NUMITE
                                                 AND IVO.FLGEST IN ('A','N')
           WHERE IOR.TIPENT IN ('7')
             AND IOR.FLGEST IN ('A','R')
             AND IOR.FLGIVO = 'A'
             AND ORC.TELEVE = 'T'
             AND ORC.APROVA = 'A'
			 AND IOR.CODFIL = pCODFIL
             AND IOR.TIPPED = pTIPPED
             AND IOR.NUMPED = pNUMPED
             AND IOR.NUMITE = pNUMITE
             AND IVO.FILVOL IS NULL
         ) TAB
   WHERE TAB.QTDSEP > 0;

  vFILVOL TT_IVO.FILVOL%type;
  vFLGEST TT_IVO.FLGEST%type;
  vFILPED TT_IVO.FILPED%type;
  vTIPPED TT_IVO.TIPPED%type;
  vNUMPED TT_IVO.NUMPED%type;
  vNUMITE TT_IVO.NUMITE%type;
  vFILIVE TT_IVO.FILIVE%type;
  vSEQIVE TT_IVO.SEQIVE%type;
  vNUMIVE TT_IVO.NUMIVE%type;
  vSEPARAR_ENTREGA TT_CFG.SEPARAR_ENTREGA%type;
  Begin
      OPEN CR_SEPARACAO_PC;
      LOOP
        FETCH CR_SEPARACAO_PC INTO vFILPED,
                              vTIPPED, vNUMPED, vNUMITE;
        EXIT WHEN NOT FOUND;

        SELECT SEPARAR_ENTREGA
          INTO vSEPARAR_ENTREGA
          FROM TT_CFG;

        -- Utiliza separao
        IF vSEPARAR_ENTREGA = 'T' THEN
          -- cria itens de volume
          INSERT INTO TT_IVO
          (FILVOL, FLGEST, FILPED, TIPPED, NUMPED, NUMITE)
          VALUES
          (vFILPED, 'A', vFILPED, vTIPPED, vNUMPED, vNUMITE);
        END IF;

      END LOOP;
      CLOSE CR_SEPARACAO_PC;
   RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 1851 --*/


    CREATE OR REPLACE FUNCTION PC_IOR_PLUS_UPDATE (TT_IOR.CODFIL%TYPE,TT_IOR.FILRES%TYPE,TT_VEN.SEQUEN%TYPE,TT_COM.SEQUEN%TYPE,TT_IOR.FILMAT%TYPE,TT_IOR.CODMAT%TYPE,TT_IOR.CODCOR%TYPE,TT_IOR.CODTAM%TYPE,TT_IOR.QTDITE%TYPE,TT_IOR.VLRITE%TYPE,TT_IOR.FLGEST%TYPE,TT_IOR.CODMUL%TYPE,TT_IOR.FILIVE%TYPE,TT_IOR.SEQIVE%TYPE,TT_IOR.NUMIVE%TYPE,TT_IOR.FILLOT%TYPE,TT_IOR.SEQLOT%TYPE,TT_IOR.TIPENT%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pFILRES ALIAS FOR $2 ;
pSEQVEN ALIAS FOR $3 ;
pSEQCOM ALIAS FOR $4 ;
pFILMAT ALIAS FOR $5 ;
pCODMAT ALIAS FOR $6 ;
pCODCOR ALIAS FOR $7 ;
pCODTAM ALIAS FOR $8 ;
pQTDITE ALIAS FOR $9 ;
pVLRITE ALIAS FOR $10 ;
pFLGEST ALIAS FOR $11 ;
pCODMUL ALIAS FOR $12 ;
pFILORI ALIAS FOR $13 ;
pNUMORI ALIAS FOR $14 ;
pITEORI ALIAS FOR $15 ;
pFILLOT ALIAS FOR $16 ;
pSEQLOT ALIAS FOR $17 ;
pTIPENT ALIAS FOR $18 ;
    vNUMIVE TT_IVE.NUMITE%TYPE;
    vNUMICO TT_ICO.NUMITE%TYPE;
    vTIPPRO TT_PRO.TIPPRO%TYPE;
    VVALCON TT_PRO.VALCON%TYPE;
    vUNICOM TT_GRA.UNIFOR%TYPE;
    vUNIVEM TT_GRA.UNIDAD%TYPE;
    vVLRMOV TT_IVE.VLRMOV%TYPE;
    vFILIVE TT_IVE.CODFIL%TYPE;
    vSEQIVE TT_IVE.SEQUEN%TYPE;
    vITEIVE TT_IVE.NUMITE%TYPE;
    iCODCFO TT_CFG.TRANSFER_CODCFO%TYPE;
    cDummy  VARCHAR(2);
  Begin
    IF (pFLGEST='E') THEN
      cDummy := IncluiItemTransfAutom(pCODFIL,pFILRES,pSEQVEN,pSEQCOM,
                                      pFILMAT,pCODMAT,pCODCOR,pCODTAM,
                                      pQTDITE,pVLRITE,pCODMUL,pFILORI,
                                      pNUMORI,pITEORI,pFILLOT,pSEQLOT, null); -- MN - 103975 - TT_ICO no possui coluina NUMEXT para enviar

    ELSE
      cDummy := RemoveItemTransfAutom(pCODFIL,pFILRES,pSEQVEN,pSEQCOM,
                                      pFILMAT,pCODMAT,pCODCOR,pCODTAM,
                                      pQTDITE,pVLRITE,pCODMUL,pFILORI,
                                      pNUMORI,pITEORI,pFILLOT,pSEQLOT);

    END IF;

   RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 1852 --*/

      CREATE OR REPLACE FUNCTION PC_IVE_UPDATE (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE,TT_IVE.FILORI%TYPE,TT_IVE.NUMORI%TYPE,TT_IVE.ITEORI%TYPE,TT_IVE.SITMOV%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pNUMITE ALIAS FOR $3 ;
pFILORI ALIAS FOR $4 ;
pNUMORI ALIAS FOR $5 ;
pITEORI ALIAS FOR $6 ;
pSITMOV ALIAS FOR $7 ;

      ORCAMENTOS CURSOR(pCODFIL TT_IOR.FILIVE%TYPE,
           pSEQUEN TT_IOR.SEQIVE%TYPE,
           pNUMITE TT_IOR.NUMIVE%TYPE) IS
            SELECT ORC.CODFIL,ORC.TIPPED,ORC.NUMPED
              FROM TT_ORC ORC INNER JOIN TT_IOR IOR ON ORC.CODFIL = IOR.CODFIL AND ORC.TIPPED = IOR.TIPPED AND ORC.NUMPED = IOR.NUMPED
             WHERE FILIVE = pCODFIL
               AND SEQIVE = pSEQUEN
               AND NUMIVE = pNUMITE
            GROUP BY ORC.CODFIL,ORC.TIPPED,ORC.NUMPED;

          cCODFIL TT_IOR.CODFIL%TYPE;
          cTIPPED TT_IOR.TIPPED%TYPE;
          cNUMPED TT_IOR.NUMPED%TYPE;

          vQTDORI Numeric(16,3);
          vQTDVIN Numeric(16,3);

          vCOUNT INTEGER;

          vFILCLI    TT_VEN.FILCLI%TYPE;
          vCODCLI    TT_VEN.CODCLI%TYPE;
          vDOCUME    VARCHAR(60);
          vCLIDEV    TD_DEV.CLIDEV%TYPE;
          vFILCLIORI TT_VEN.FILCLI%TYPE;
          vCODCLIORI TT_VEN.CODCLI%TYPE;
          vDOCUMEORI VARCHAR(60);
          vComplemento       VARCHAR(100) := constante('complemento');

          vVC_FILCLI TT_CFG.VC_FILCLI%TYPE;
          vVC_CODCLI TT_CFG.VC_CODCLI%TYPE;

          vQTD_TRANSF INTEGER; -- RFMP 73235

      BEGIN

      /* Verifica se os clientes da nota atual e vinculada sao iguais */
      IF pFILORI IS NOT NULL THEN
        SELECT VEN.FILCLI, VEN.CODCLI,
               COALESCE(VEN.CODSER,'')||'/'||lTrim(COALESCE(VEN.NUMECF,''))||'-'||lTrim(COALESCE(VEN.NUMNOT,''))||CASE WHEN COALESCE(VEN.CNT_RO,0)>0 THEN '['||VEN.CNT_RO||']' ELSE '' END AS DOCUME,
               DEV.CLIDEV,
               (SELECT COUNT(*)
                  FROM TT_TRA TRA
                 WHERE TRA.FILIVE = VEN.CODFIL
                   AND TRA.SEQIVE = VEN.SEQUEN) AS QTD_TRANSF
               INTO vFILCLI, vCODCLI, vDOCUME, vCLIDEV, vQTD_TRANSF
          FROM TT_VEN VEN INNER JOIN TD_DEV DEV ON VEN.CODDEV = DEV.CODTAB
         WHERE VEN.CODFIL = pCODFIL
           AND VEN.SEQUEN = pSEQUEN;

        IF  (vCLIDEV = 'T')
        AND (vQTD_TRANSF = 0) THEN -- Se nao for transferencia, validar cliente. RFMP 73235
            SELECT FILCLI, CODCLI,
                   COALESCE(VEN.CODSER,'')||'/'||lTrim(COALESCE(VEN.NUMECF,''))||'-'||lTrim(COALESCE(VEN.NUMNOT,''))||CASE WHEN COALESCE(VEN.CNT_RO,0)>0 THEN '['||VEN.CNT_RO||']' ELSE '' END AS DOCUME
                   INTO vFILCLIORI, vCODCLIORI, vDOCUMEORI
              FROM TT_VEN VEN
             WHERE CODFIL = pFILORI
               AND SEQUEN = pNUMORI;

            SELECT VC_FILCLI, VC_CODCLI INTO vVC_FILCLI, vVC_CODCLI FROM TT_CFG;

            IF  (vFILCLI||vCODCLI) <> (vFILCLIORI||vCODCLIORI)
            AND (vFILCLIORI||vCODCLIORI) <> (vVC_FILCLI||vVC_CODCLI) THEN -- RFMP 70263
              RAISE EXCEPTION 'PG-20001 Cliente da nota % difere do cliente da nota vinculada %. %' , vDOCUME,vDOCUMEORI,vComplemento;
            END IF;
        END IF;
      END IF;

      SELECT SUM(QTDMOV) INTO vQTDORI
        FROM TT_IVE
       WHERE CODFIL = pCODFIL
         AND SEQUEN = pNUMORI
         AND NUMITE = pITEORI;

      SELECT SUM(QTDMOV) INTO vQTDVIN
        FROM TT_IVE
       WHERE FILORI = pCODFIL
         AND NUMORI = pNUMORI
         AND ITEORI = pITEORI;

      /* Solicita a atualizacao da propria TT_IVE */
      UPDATE TT_IVE
         SET VINCUL = CASE WHEN vQTDORI+vQTDVIN <=0 THEN 'C'
                                                    ELSE 'A'
                      END
       WHERE CODFIL = pFILORI
         AND SEQUEN = pNUMORI
         AND NUMITE = pITEORI
         AND VINCUL <> 'N';


      -- No Postgre ele da erro quando tem nota de transferencia pois ele acaba entrando novamente
      -- e da cursor ja aberto
      -- Para evitar isto coloquei para somente abrir o cursor se realmente houver orcamentos
      SELECT COUNT(*) INTO vCOUNT
        FROM TT_IOR IOR
       WHERE FILIVE = PCODFIL
         AND SEQIVE = PSEQUEN
         AND NUMIVE = PNUMITE;

      IF pSITMOV = 'C'  AND vCOUNT>0 THEN

        -- Abre os orcamentos vinculados a venda antes de alterar os itens
        OPEN ORCAMENTOS (pCODFIL,pSEQUEN,pNUMITE);

        -- Cancela Orcamentos coms servicos adicionais
        UPDATE TT_IOR IOR
                      SET FLGEST = 'C',
                          ATU_EM = AGORA(),
                          DUMMY  = Constante('vem_de_TGIVE')
         WHERE FILIVE = pCODFIL
           AND SEQIVE = pSEQUEN
           AND NUMIVE = pNUMITE
           AND FLGEST = 'E'
           AND EXISTS (SELECT 1 AS OK
                 FROM TT_SAV SAV
                WHERE SAV.FILPED=IOR.CODFIL
                  AND SAV.TIPPED=IOR.TIPPED
                  AND SAV.NUMPED=IOR.NUMPED
                  AND SAV.NUMITE=IOR.NUMITE
              );

        -- Remove ligacao com DAV (faturado/entregue) se houver
        UPDATE TT_IOR IOR
                      SET FLGEST = CASE WHEN LeParametroBoo('CANC_DAV_NO_CANC_VEN','','','','') = 'T' THEN 'C' ELSE 'A' END, --GES-2021113635
                          FILIVE = NULL,
                          SEQIVE = NULL,
                          NUMIVE = NULL,
                          ECFVEN = NULL,
                          VLRPGT = VLRPGT * QTDENT / QTDITE,
                          VLRCUS = VLRCUS * QTDENT / QTDITE,
                          QTDITE = QTDENT,
                          FLGIVO = CASE WHEN COALESCE(FLGIVO,' ') = 'P' THEN 'A' ELSE FLGIVO END, -- RFMP 86017
                          DUMMY  = Constante('vem_de_TGIVE')
         WHERE FILIVE = pCODFIL
           AND SEQIVE = pSEQUEN
           AND NUMIVE = pNUMITE
           AND FLGEST = 'E'
           AND EXISTS (SELECT 1 AS OK
                 FROM TT_ORC ORC
                WHERE IOR.CODFIL=ORC.CODFIL
                  AND IOR.TIPPED=ORC.TIPPED
                  AND IOR.NUMPED=ORC.NUMPED
                  AND ORC.PREDAV='D'
              );

        -- Cancela Pre-Venda se houver
        UPDATE TT_IOR IOR
                      SET FLGEST = 'C',
                          DUMMY  = Constante('vem_de_TGIVE')
         WHERE FILIVE = pCODFIL
           AND SEQIVE = pSEQUEN
           AND NUMIVE = pNUMITE
           AND FLGEST = 'E'
           AND EXISTS (SELECT 1 AS OK
                 FROM TT_ORC ORC
                WHERE IOR.CODFIL=ORC.CODFIL
                  AND IOR.TIPPED=ORC.TIPPED
                  AND IOR.NUMPED=ORC.NUMPED
                  AND ORC.PREDAV='P'
              );


        -- enquanto houver orcamentos envolvidos
        LOOP

          FETCH ORCAMENTOS INTO cCODFIL,cTIPPED,cNUMPED ;
          EXIT WHEN NOT FOUND;

          -- Forca a atualizacao dos flgest dos orcamentos envolvidos
          UPDATE TT_ORC SET FLGEST='Z'
           WHERE CODFIL=cCODFIL
             AND TIPPED=cTIPPED
             AND NUMPED=cNUMPED;

        END LOOP;
        CLOSE ORCAMENTOS;

      END IF;

      -- Devolve pedido para autorizado
      UPDATE TT_PED
         SET FLGEST='2'
       WHERE (CODFIL,NUMPED) IN
             (SELECT CODFIL,NUMPED
                FROM TT_IPE
               WHERE FILIVE = pCODFIL
                 AND SEQIVE = pSEQUEN
                 AND NUMIVE = pNUMITE);

     -- desvincula os itens de pedido
     UPDATE TT_IPE
        SET FLGEST='A',
            FILIVE = NULL,
            SEQIVE = NULL,
            NUMIVE = NULL,
            QTDENT = 0
      WHERE FILIVE = pCODFIL
        AND SEQIVE = pSEQUEN
        AND NUMIVE = pNUMITE;

      -- Rhuan - 97445 - Cancela servios adicionais vinculados ao item da venda
      UPDATE TT_SAV
         SET FLGEST = 'C',
             DATCAN = Agora(),
             VLRCAN = VALSAD
       WHERE FILVEN = pCODFIL
         AND SEQVEN = pSEQUEN
         AND NUMIVE = pNUMITE;

        RETURN NULL;

END;
$$ language 'plpgsql';





      CREATE OR REPLACE FUNCTION PC_IVE_AUX_UPDATE (TT_IVE.VEN_DATHOR%TYPE,TT_IVE.CODFIL%TYPE,TT_IVE.FILMAT%TYPE,TT_IVE.CODMAT%TYPE,TT_IVE.CODCOR%TYPE,TT_IVE.CODTAM%TYPE,TT_IVE.DUMMY%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE,TT_IVE.QTDMOV%TYPE,TT_IVE.FILRES%TYPE,TT_IVE.FILLOT%TYPE,TT_IVE.SEQLOT%TYPE,TT_IVE.CODMUL%TYPE,TT_IVE.NUMEXT%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pVEN_DATHOR ALIAS FOR $1 ;
pCODFIL ALIAS FOR $2 ;
pFILMAT ALIAS FOR $3 ;
pCODMAT ALIAS FOR $4 ;
pCODCOR ALIAS FOR $5 ;
pCODTAM ALIAS FOR $6 ;
pDUMMY ALIAS FOR $7 ;
pSEQUEN ALIAS FOR $8 ;
pNUMITE ALIAS FOR $9 ;
pQTDMOV ALIAS FOR $10 ;
pFILRES ALIAS FOR $11 ;
pFILLOT ALIAS FOR $12 ;
pSEQLOT ALIAS FOR $13 ;
pCODMUL ALIAS FOR $14 ;
pNUMEXT ALIAS FOR $15 ;

        -- Declarao de variveis
        cDUMMY                         VARCHAR(100);
        bGRAVA_NFT                     BOOLEAN;
        bCANCELA_NFT                   BOOLEAN;
        nCusRep                        TT_GRA.CUSREP%TYPE;
        cSeqven                        TT_VEN.SEQUEN%TYPE;
        cSeqcom                        TT_COM.SEQUEN%TYPE;

      BEGIN
        IF LeParametroBoo('USA_TRANS_AUTOMATICA', '', '', '', '') = 'T' THEN
           -- Rhuan - 97440
           bGRAVA_NFT   := false;
           bCANCELA_NFT := false;

           IF pDUMMY = 'I' THEN    -- Insere
             bGRAVA_NFT   := true;
           ELSIF pDUMMY = 'C' THEN -- Exclui
             bCANCELA_NFT := true;
           END IF;

           IF (pDUMMY = 'R') OR (pDUMMY = 'X') THEN
             cDUMMY := Atu_ReservaPendente(pCODFIL, pSEQUEN, pNUMITE, pQTDMOV, pFILRES, pDUMMY);
           ELSIF bGRAVA_NFT OR bCANCELA_NFT  THEN
             nCusrep := ValoresProdutoTransfAutom(pFILMAT, pCODMAT, pCODCOR, pCODTAM, pCODFIL);
             IF bGRAVA_NFT THEN
               cDUMMY := GeraTransfAutom(pFILRES, pFILMAT, pCODMAT, pCODCOR, pCODTAM, pCODFIL, ABS(pQTDMOV), nCusrep);

               cSeqven := NotaAbertaTransfAutom('V', pFILRES, pCODFIL);
               cSeqcom := NotaAbertaTransfAutom('C', pFILRES, pCODFIL);

               cDUMMY := IncluiItemTransfAutom(pFILRES,pCODFIL,cSeqven,cSeqcom,
                                               pFILMAT,pCODMAT,pCODCOR,pCODTAM,
                                               ABS(pQTDMOV),nCusrep,pCODMUL,NULL,
                                               NULL,NULL,pFILLOT,pSEQLOT, pNUMEXT);
             END IF;

             IF bCANCELA_NFT THEN
               -- Cancela
               cSeqven := NotaAbertaTransfAutom('V', pFILRES, pCODFIL);
               cSeqcom := NotaAbertaTransfAutom('C', pFILRES, pCODFIL);

               -- Desfaz transferncia apenas se encontrar a nota
               IF cSeqven IS NOT NULL THEN
                 cDUMMY := RemoveItemTransfAutom(pFILRES,pCODFIL,cSeqven,cSeqcom,
                                                 pFILMAT,pCODMAT,pCODCOR,pCODTAM,
                                                 ABS(pQTDMOV),nCusrep,pCODMUL,NULL,
                                                 NULL,NULL,pFILLOT,pSEQLOT);
               ELSE
                 cDUMMY := EmailTransfAutom(pCODFIL,pCODFIL,pSEQUEN,
                                            pFILMAT,pCODMAT,pCODCOR,pCODTAM,
                                            null,null,null);

               END IF;
             END IF;
           ELSE
             /* Atualiza a data do custo medio na TT_SAL */
             UPDATE TT_SAL
                SET CAL_CM = CASE WHEN CAL_CM IS NULL
                                  THEN NULL
                                  ELSE CASE WHEN pVEN_DATHOR<CAL_CM
                                            THEN pVEN_DATHOR
                                            ELSE CAL_CM
                                       END
                             END,
                    ATU_CM = 'F',
                    DUMMY = Constante('vem_de_TGIVE')
              WHERE CODFIL = pCODFIL
                AND FILMAT = pFILMAT
                AND CODMAT = pCODMAT
                AND CODCOR = pCODCOR
                AND CODTAM = pCODTAM
                AND CODMUL = 0;

              UPDATE TD_FIL SET DATFINEST = CASE WHEN DATFINEST IS NULL
                                                 THEN NULL
                                                 ELSE CASE WHEN pVEN_DATHOR<DATFINEST
                                                           THEN TRUNC(pVEN_DATHOR)
                                                           ELSE DATFINEST
                                                      END
                                            END
               WHERE CODFIL = pCODFIL
                 AND DATFINEST > TRUNC(pVEN_DATHOR);

           END IF;
        END IF;

        RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1853 --*/

      CREATE OR REPLACE FUNCTION PC_IVE_IVO_UPDATE (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.NUMITE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pNUMITE ALIAS FOR $3 ;

CR_SEPARACAO CURSOR FOR
  SELECT TAB.CODFIL,
         TAB.SEQUEN,
         TAB.NUMITE,
         TAB.FILVOL
    FROM (SELECT CASE WHEN IOR.TIPENT = '3'
                      THEN IVE.QTDMOV
                      ELSE QtdPendente(IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE, IVE.QTDMOV)
                 END AS PENDEN,
                 QTD_A_SEPARAR(IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE, Null, Null, Null, Null) AS QTDSEP,
                 IVE.CODFIL,
                 IVE.SEQUEN,
                 IVE.NUMITE,
                 IOR.TIPENT,
                 COALESCE(IVE.FILRES,IVE.CODFIL) AS FILVOL
            FROM TT_IVE IVE INNER JOIN TT_IOR IOR ON IOR.FILIVE = IVE.CODFIL
                                                 AND IOR.SEQIVE = IVE.SEQUEN
                                                 AND IOR.NUMIVE = IVE.NUMITE
							INNER JOIN TT_ORC ORC ON ORC.CODFIL = IOR.CODFIL
                                                 AND ORC.TIPPED = IOR.TIPPED
                                                 AND ORC.NUMPED = IOR.NUMPED
                             LEFT JOIN TT_IVO IVO ON IVO.FILIVE = IVE.CODFIL
                                                 AND IVO.SEQIVE = IVE.SEQUEN
                                                 AND IVO.NUMIVE = IVE.NUMITE
                                                 AND IVO.FLGEST IN ('A','N','O') -- RFMP 90939
           WHERE IVE.SITMOV <> 'C'
             AND IVE.CODFIL = pCODFIL
             AND IVE.SEQUEN = pSEQUEN
             AND IVE.NUMITE = pNUMITE
             AND IOR.FLGEST = 'E'
             AND IOR.FLGIVO = 'A'
			 AND (IOR.TIPENT <>'3' or (LeParametroBoo('SEPARAR_TIP_3','','','','')='F') or (ORC.TELEVE = 'F'))
             AND IVO.FILIVE IS NULL
         ) TAB
   WHERE TAB.QTDSEP > 0
     AND TAB.PENDEN > 0;

  vFILIVE TT_IVO.FILIVE%type;
  vSEQIVE TT_IVO.SEQIVE%type;
  vNUMIVE TT_IVO.NUMIVE%type;
  vFILVOL TT_IVO.FILVOL%type;
  vSEPARAR_ENTREGA TT_CFG.SEPARAR_ENTREGA%type;
  cTEMP TT_FUN.NOMFUN%TYPE;
BEGIN

   SELECT SEPARAR_ENTREGA
     INTO vSEPARAR_ENTREGA
     FROM TT_CFG;
     
   -- Utiliza separao
   IF vSEPARAR_ENTREGA = 'T' THEN  
      -- Garantia de exclusividade no processo seguinte
      -- Usado tambm na CRIA_SEPARACAO
      SELECT NOMFUN 
        INTO cTEMP
        FROM TT_FUN
       WHERE NOMFUN = 'LOCK_SEP'
      FOR UPDATE;
      
      OPEN CR_SEPARACAO;
      LOOP
         FETCH CR_SEPARACAO INTO vFILIVE, vSEQIVE, vNUMIVE, vFILVOL;
         EXIT WHEN NOT FOUND;
           
         -- cria itens de volume
         INSERT INTO TT_IVO
         (FILVOL, FLGEST, FILIVE, SEQIVE, NUMIVE)
         VALUES
         (vFILVOL, 'A', vFILIVE, vSEQIVE, vNUMIVE);     
      END LOOP;
      CLOSE CR_SEPARACAO;    
   END IF;
  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1854 --*/

      CREATE OR REPLACE FUNCTION PC_IVExIPE_UPDATE (TT_IVExIPE.CODFIL%TYPE,TT_IVExIPE.FILIVE%TYPE,TT_IVExIPE.SEQIVE%TYPE,TT_IVExIPE.NUMIVE%TYPE,TT_IVExIPE.FLGEST%TYPE,TT_IVExIPE.QTDENC%TYPE,TT_IVExIPE.FILMAT%TYPE,TT_IVExIPE.CODMAT%TYPE,TT_IVExIPE.CODCOR%TYPE,TT_IVExIPE.CODTAM%TYPE,TT_IVExIPE.FILPED%TYPE,TT_IVExIPE.TIPPED%TYPE,TT_IVExIPE.NUMPED%TYPE,TT_IVExIPE.NUMITE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pFILIVE ALIAS FOR $2 ;
pSEQIVE ALIAS FOR $3 ;
pNUMIVE ALIAS FOR $4 ;
pFLGEST ALIAS FOR $5 ;
pQTDENC ALIAS FOR $6 ;
pFILMAT ALIAS FOR $7 ;
pCODMAT ALIAS FOR $8 ;
pCODCOR ALIAS FOR $9 ;
pCODTAM ALIAS FOR $10 ;
pFILPED ALIAS FOR $11 ;
pTIPPED ALIAS FOR $12 ;
pNUMPED ALIAS FOR $13 ;
pNUMITE ALIAS FOR $14 ;

      -- Cursores

      cENCOMENDA_ABERTO CURSOR(pCODFIL TT_IVExIPE.CODFIL%TYPE,
           pFILMAT TT_IVExIPE.FILMAT%TYPE,
           pCODMAT TT_IVExIPE.CODMAT%TYPE,
           pCODCOR TT_IVExIPE.CODCOR%TYPE,
           pCODTAM TT_IVExIPE.CODTAM%TYPE,
           pFILIVE TT_IVExIPE.FILIVE%TYPE,
           pSEQIVE TT_IVExIPE.SEQIVE%TYPE,
           pNUMIVE TT_IVExIPE.NUMIVE%TYPE,
           pFILPED TT_IVExIPE.FILPED%TYPE,
           pTIPPED TT_IVExIPE.TIPPED%TYPE,
           pNUMPED TT_IVExIPE.NUMPED%TYPE,
           pNUMITE TT_IVExIPE.NUMITE%TYPE) IS
           SELECT CODFIL, SEQUEN, FILIVE, SEQIVE, NUMIVE, QTDENC, FILPED, TIPPED, NUMPED, NUMITE
             FROM (SELECT CODFIL, SEQUEN, FILIVE, SEQIVE, NUMIVE, SUM(QTDENC) AS QTDENC, FILPED, TIPPED, NUMPED, NUMITE
                     FROM TT_IVEXIPE
                    WHERE CODFIL = pCODFIL
                      AND FILMAT = pFILMAT
                      AND CODMAT = pCODMAT
                      AND CODCOR = pCODCOR
                      AND CODTAM = pCODTAM
                      AND FILIVE = pFILIVE
                      AND SEQIVE = pSEQIVE
                      AND NUMIVE = pNUMIVE
                      AND FLGEST = 'A'
                    GROUP BY CODFIL, SEQUEN, FILIVE, SEQIVE, NUMIVE, FILPED, TIPPED, NUMPED, NUMITE
                   UNION ALL
                   SELECT CODFIL, SEQUEN, FILIVE, SEQIVE, NUMIVE, SUM(QTDENC) AS QTDENC, FILPED, TIPPED, NUMPED, NUMITE
                     FROM TT_IVEXIPE
                    WHERE CODFIL = pCODFIL
                      AND FILMAT = pFILMAT
                      AND CODMAT = pCODMAT
                      AND CODCOR = pCODCOR
                      AND CODTAM = pCODTAM
                      AND FILPED = pFILPED
                      AND TIPPED = pTIPPED
                      AND NUMPED = pNUMPED
                      AND NUMITE = pNUMITE
                      AND FLGEST = 'A'
                    GROUP BY CODFIL, SEQUEN, FILIVE, SEQIVE, NUMIVE, FILPED, TIPPED, NUMPED, NUMITE) A
             ORDER BY QTDENC;

      cENCOMENDA_PEDIDO CURSOR(pCODFIL TT_IVExIPE.CODFIL%TYPE,
           pFILMAT TT_IVExIPE.FILMAT%TYPE,
           pCODMAT TT_IVExIPE.CODMAT%TYPE,
           pCODCOR TT_IVExIPE.CODCOR%TYPE,
           pCODTAM TT_IVExIPE.CODTAM%TYPE,
           pFILIVE TT_IVExIPE.FILIVE%TYPE,
           pSEQIVE TT_IVExIPE.SEQIVE%TYPE,
           pNUMIVE TT_IVExIPE.NUMIVE%TYPE,
           pFILPED TT_IVExIPE.FILPED%TYPE,
           pTIPPED TT_IVExIPE.TIPPED%TYPE,
           pNUMPED TT_IVExIPE.NUMPED%TYPE,
           pNUMITE TT_IVExIPE.NUMITE%TYPE) IS
           SELECT CODFIL, SEQUEN, FILIVE, SEQIVE, NUMIVE, QTDENC, FILPED, TIPPED, NUMPED, NUMITE
             FROM (SELECT CODFIL, SEQUEN, FILIVE, SEQIVE, NUMIVE, SUM(QTDENC) AS QTDENC, FILPED, TIPPED, NUMPED, NUMITE
                     FROM TT_IVEXIPE
                    WHERE CODFIL = pCODFIL
                      AND FILMAT = pFILMAT
                      AND CODMAT = pCODMAT
                      AND CODCOR = pCODCOR
                      AND CODTAM = pCODTAM
                      AND FILIVE = pFILIVE
                      AND SEQIVE = pSEQIVE
                      AND NUMIVE = pNUMIVE
                      AND FLGEST = 'E'
                    GROUP BY CODFIL, SEQUEN, FILIVE, SEQIVE, NUMIVE, FILPED, TIPPED, NUMPED, NUMITE
                   UNION ALL
                   SELECT CODFIL, SEQUEN, FILIVE, SEQIVE, NUMIVE, SUM(QTDENC) AS QTDENC, FILPED, TIPPED, NUMPED, NUMITE
                     FROM TT_IVEXIPE
                    WHERE CODFIL = pCODFIL
                      AND FILMAT = pFILMAT
                      AND CODMAT = pCODMAT
                      AND CODCOR = pCODCOR
                      AND CODTAM = pCODTAM
                      AND FILPED = pFILPED
                      AND TIPPED = pTIPPED
                      AND NUMPED = pNUMPED
                      AND NUMITE = pNUMITE
                      AND FLGEST = 'E'
                    GROUP BY CODFIL, SEQUEN, FILIVE, SEQIVE, NUMIVE, FILPED, TIPPED, NUMPED, NUMITE) A
             ORDER BY QTDENC;

      cPEDIDO_PENDENTE CURSOR(pCODFIL TT_IVExIPE.CODFIL%TYPE,
           pFILMAT TT_IVExIPE.FILMAT%TYPE,
           pCODMAT TT_IVExIPE.CODMAT%TYPE,
           pCODCOR TT_IVExIPE.CODCOR%TYPE,
           pCODTAM TT_IVExIPE.CODTAM%TYPE) IS
           SELECT CODFIL, NUMPED, NUMITE, QTDPEN
             FROM (SELECT IPE.CODFIL, IPE.NUMPED, IPE.NUMITE,
                          SUM((COALESCE(IPE.QTDITE,0)
                              - COALESCE((SELECT SUM(QTDENC)
                                            FROM TT_IVEXIPE VXP
                                           WHERE VXP.FILIPE = IPE.CODFIL
                                             AND VXP.NUMIPE = IPE.NUMPED
                                             AND VXP.ITEIPE = IPE.NUMITE
                                             AND VXP.FLGEST <> 'C'),0)
                              - COALESCE(IPE.QTDCAN,0))) AS QTDPEN
                     FROM TT_PED PED INNER JOIN TT_IPE IPE ON PED.CODFIL = IPE.CODFIL AND PED.NUMPED = IPE.NUMPED
                                     CROSS JOIN TT_CFG CFG
                    WHERE IPE.FILMAT = pFILMAT
                      AND IPE.CODMAT = pCODMAT
                      AND IPE.CODCOR = pCODCOR
                      AND IPE.CODTAM = pCODTAM
                      AND ((IPE.FILENT = pCODFIL) OR (pCODFIL IS NULL))
                      AND IPE.FLGEST = 'A'
                      AND PED.FLGEST IN (CASE CFG.PENAUT WHEN 'T' THEN '2' ELSE 'A' END, '2' )
                      AND PED.CODFOR <> '     0' -- Desconsiderar pedidos de reposio
                    GROUP BY IPE.CODFIL, IPE.NUMPED, IPE.NUMITE) A
              WHERE QTDPEN > 0;

           -- Declarao de variveis
           vFILIPE                        TT_IPE.CODFIL%TYPE;
           vNUMIPE                        TT_IPE.NUMPED%TYPE;
           vITEIPE                        TT_IPE.NUMITE%TYPE;
           vQTDPEN                        TT_IPE.QTDITE%TYPE;
           WK_QTDPEN                      TT_IPE.QTDITE%TYPE;
           WK_QTD_ENCOMENDADA             TT_IPE.QTDITE%TYPE;
           WK_QTDENC_A                    TT_IVExIPE.QTDENC%TYPE;
           WK_QTDENC_E                    TT_IVExIPE.QTDENC%TYPE;
           cCODFIL                        TT_IVExIPE.CODFIL%TYPE;
           cSEQUEN                        TT_IVExIPE.SEQUEN%TYPE;
           cFILIVE                        TT_IVExIPE.FILIVE%TYPE;
           cSEQIVE                        TT_IVExIPE.SEQIVE%TYPE;
           cNUMIVE                        TT_IVExIPE.NUMIVE%TYPE;
           cFILPED                        TT_IVExIPE.FILPED%TYPE;
           cTIPPED                        TT_IVExIPE.TIPPED%TYPE;
           cNUMPED                        TT_IVExIPE.NUMPED%TYPE;
           cNUMITE                        TT_IVExIPE.NUMITE%TYPE;
           cQTDENC                        TT_IVExIPE.QTDENC%TYPE;
           pAUX_QTDENC                    TT_IVExIPE.QTDENC%TYPE;
           cSAIR_PACKAGE                  CHAR(1);
           bVAZIO                         CHAR(1);
           cFILRES                        TT_IVE.FILRES%TYPE;
           cCODFIL_AUX                    TT_IVExIPE.CODFIL%TYPE;
           iCountEncomendaRecebida        Numeric(5);

      BEGIN
        cSAIR_PACKAGE := 'F';

        -- Rhuan - 98953 - Se venda tiver filial de reserva preenchida (Regime Especial),
        -- deve usar o FILRES ao invs de CODFIL
        -- A consulta foi feita aqui, e no na trigger, para no dar mutante em Oracle
        cFILRES := NULL;
        IF pFILIVE IS NOT NULL THEN
          SELECT IVE.FILRES
            INTO cFILRES
            FROM TT_IVE IVE
           WHERE IVE.CODFIL = pFILIVE
             AND IVE.SEQUEN = pSEQIVE
             AND IVE.NUMITE = pNUMIVE;
        END IF;
        cCODFIL_AUX := COALESCE(cFILRES,pCODFIL);

        IF pFLGEST = 'I' THEN -- Incluso ou cancelamento de uma devoluo (re-incluso)

           -- RFMP 101411
           -- Ao devolver uma fatura que gerou uma encomenda j recebida, esse registro no 
           -- modificado. Ou seja, a encomenda continua recebida.
           -- Ao cancelar uma devoluo de fatura, o sistema - que deveria recriar a encomenda -
           -- no pode fazer nada.
           -- Por isso, foi feito esse tratamento. Para no incluir a encomenda nesse caso.
           -- Caso esse que s existe em encomendas vinculadas a fatura.
           iCountEncomendaRecebida := 0;
           IF pFILIVE IS NOT NULL THEN
              SELECT COUNT(*)
                INTO iCountEncomendaRecebida
                FROM TT_IVEXIPE
               WHERE FILIVE = pFILIVE
                 AND SEQIVE = pSEQIVE
                 AND NUMIVE = pNUMIVE
                 AND FLGEST = 'R';
           END IF;

           IF iCountEncomendaRecebida = 0 THEN
              bVAZIO             := 'F';
              WK_QTDPEN          := 0;
              WK_QTD_ENCOMENDADA := 0;
              OPEN cPEDIDO_PENDENTE (cCODFIL_AUX,pFILMAT,pCODMAT,pCODCOR,pCODTAM);
              LOOP
                  FETCH cPEDIDO_PENDENTE INTO vFILIPE,vNUMIPE,vITEIPE,vQTDPEN;
                  IF NOT FOUND THEN
                      IF (WK_QTDPEN = 0) AND (bVAZIO = 'F') THEN
                          INSERT INTO TT_IVExIPE (CODFIL, FILIVE, SEQIVE, NUMIVE, FLGEST, QTDENC, FILMAT, CODMAT, CODCOR, CODTAM, ATU_EM, DATINC, DATOPE, FILPED, TIPPED, NUMPED, NUMITE)
                                          VALUES (cCODFIL_AUX, pFILIVE, pSEQIVE, pNUMIVE, 'A', pQTDENC, pFILMAT, pCODMAT, pCODCOR, pCODTAM, AGORA(), AGORA(), TRUNC(AGORA()), pFILPED, pTIPPED, pNUMPED, pNUMITE);
                      END IF;
                      EXIT;
                  END IF;
                  IF COALESCE(vQTDPEN,0) = 0 THEN
                      INSERT INTO TT_IVExIPE (CODFIL, FILIVE, SEQIVE, NUMIVE, FLGEST, QTDENC, FILMAT, CODMAT, CODCOR, CODTAM, ATU_EM, DATINC, DATOPE, FILPED, TIPPED, NUMPED, NUMITE)
                                      VALUES (cCODFIL_AUX, pFILIVE, pSEQIVE, pNUMIVE, 'A', pQTDENC, pFILMAT, pCODMAT, pCODCOR, pCODTAM, AGORA(), AGORA(), TRUNC(AGORA()), pFILPED, pTIPPED, pNUMPED, pNUMITE);
                  END IF;
                  IF (vQTDPEN <> 0) THEN
                     IF (vQTDPEN <= (pQTDENC - WK_QTD_ENCOMENDADA)) THEN
                         INSERT INTO TT_IVExIPE (CODFIL, FILIVE, SEQIVE, NUMIVE, FLGEST, QTDENC, FILMAT, CODMAT, CODCOR, CODTAM, ATU_EM, DATINC, DATOPE, FILIPE, NUMIPE, ITEIPE, FILPED, TIPPED, NUMPED, NUMITE)
                                         VALUES (cCODFIL_AUX, pFILIVE, pSEQIVE, pNUMIVE, 'E', vQTDPEN, pFILMAT, pCODMAT, pCODCOR, pCODTAM, AGORA(), AGORA(), TRUNC(AGORA()), vFILIPE, vNUMIPE, vITEIPE, pFILPED, pTIPPED, pNUMPED, pNUMITE);
                         WK_QTDPEN          := pQTDENC - vQTDPEN;
                         WK_QTD_ENCOMENDADA := WK_QTD_ENCOMENDADA + vQTDPEN;
                         IF (pQTDENC - WK_QTD_ENCOMENDADA) = 0 THEN
                             EXIT;
                         END IF;
                     ELSIF (vQTDPEN > (pQTDENC - WK_QTD_ENCOMENDADA)) THEN
                         INSERT INTO TT_IVExIPE (CODFIL, FILIVE, SEQIVE, NUMIVE, FLGEST, QTDENC, FILMAT, CODMAT, CODCOR, CODTAM, ATU_EM, DATINC, DATOPE, FILIPE, NUMIPE, ITEIPE, FILPED, TIPPED, NUMPED, NUMITE)
                                         VALUES (cCODFIL_AUX, pFILIVE, pSEQIVE, pNUMIVE, 'E', (pQTDENC - WK_QTD_ENCOMENDADA), pFILMAT, pCODMAT, pCODCOR, pCODTAM, AGORA(), AGORA(), TRUNC(AGORA()), vFILIPE, vNUMIPE, vITEIPE, pFILPED, pTIPPED, pNUMPED, pNUMITE);
                         WK_QTDPEN          := 0;
                         WK_QTD_ENCOMENDADA := WK_QTD_ENCOMENDADA + (pQTDENC - WK_QTD_ENCOMENDADA);
                         IF (pQTDENC - WK_QTD_ENCOMENDADA) = 0 THEN
                             EXIT;
                         END IF;
                     END IF;
                  END IF;
                  IF (vQTDPEN <> 0) AND (vQTDPEN > pQTDENC) THEN
                      INSERT INTO TT_IVExIPE (CODFIL, FILIVE, SEQIVE, NUMIVE, FLGEST, QTDENC, FILMAT, CODMAT, CODCOR, CODTAM, ATU_EM, DATINC, DATOPE, FILIPE, NUMIPE, ITEIPE, FILPED, TIPPED, NUMPED, NUMITE)
                                      VALUES (cCODFIL_AUX, pFILIVE, pSEQIVE, pNUMIVE, 'E', pQTDENC, pFILMAT, pCODMAT, pCODCOR, pCODTAM, AGORA(), AGORA(), TRUNC(AGORA()), vFILIPE, vNUMIPE, vITEIPE, pFILPED, pTIPPED, pNUMPED, pNUMITE);
                      bVAZIO := 'T';
                      EXIT;
                  END IF;
              END LOOP;
              CLOSE cPEDIDO_PENDENTE;
              IF WK_QTD_ENCOMENDADA > 0 AND ((pQTDENC - WK_QTD_ENCOMENDADA) > 0) THEN
                  INSERT INTO TT_IVExIPE (CODFIL, FILIVE, SEQIVE, NUMIVE, FLGEST, QTDENC, FILMAT, CODMAT, CODCOR, CODTAM, ATU_EM, DATINC, DATOPE, FILPED, TIPPED, NUMPED, NUMITE)
                                  VALUES (cCODFIL_AUX, pFILIVE, pSEQIVE, pNUMIVE, 'A', (pQTDENC - WK_QTD_ENCOMENDADA), pFILMAT, pCODMAT, pCODCOR, pCODTAM, AGORA(), AGORA(), TRUNC(AGORA()), pFILPED, pTIPPED, pNUMPED, pNUMITE);
              END IF;
           END IF; -- IF count
        ELSIF (pFLGEST = 'D') THEN -- Devoluo

            SELECT COALESCE(SUM((SELECT SUM(A_ENCOMENDAR.QTDENC)
                                   FROM (SELECT QTDENC
                                           FROM TT_IVEXIPE
                                          WHERE CODFIL = cCODFIL_AUX
                                            AND FILMAT = pFILMAT
                                            AND CODMAT = pCODMAT
                                            AND CODCOR = pCODCOR
                                            AND CODTAM = pCODTAM
                                            AND FILIVE = pFILIVE
                                            AND SEQIVE = pSEQIVE
                                            AND NUMIVE = pNUMIVE
                                            AND FLGEST = 'A'
                                          UNION ALL
                                         SELECT QTDENC
                                           FROM TT_IVEXIPE
                                          WHERE CODFIL = pCODFIL
                                            AND FILMAT = pFILMAT
                                            AND CODMAT = pCODMAT
                                            AND CODCOR = pCODCOR
                                            AND CODTAM = pCODTAM
                                            AND FILPED = pFILPED
                                            AND TIPPED = pTIPPED
                                            AND NUMPED = pNUMPED
                                            AND NUMITE = pNUMITE
                                            AND FLGEST = 'A') A_ENCOMENDAR )),0) AS QTDENC,
                   COALESCE(SUM((SELECT SUM(ENCOMENDADO.QTDENC)
                                   FROM (SELECT QTDENC
                                           FROM TT_IVEXIPE
                                          WHERE CODFIL = cCODFIL_AUX
                                            AND FILMAT = pFILMAT
                                            AND CODMAT = pCODMAT
                                            AND CODCOR = pCODCOR
                                            AND CODTAM = pCODTAM
                                            AND FILIVE = pFILIVE
                                            AND SEQIVE = pSEQIVE
                                            AND NUMIVE = pNUMIVE
                                            AND FLGEST = 'E'
                                          UNION ALL
                                         SELECT QTDENC
                                           FROM TT_IVEXIPE
                                          WHERE CODFIL = pCODFIL
                                            AND FILMAT = pFILMAT
                                            AND CODMAT = pCODMAT
                                            AND CODCOR = pCODCOR
                                            AND CODTAM = pCODTAM
                                            AND FILPED = pFILPED
                                            AND TIPPED = pTIPPED
                                            AND NUMPED = pNUMPED
                                            AND NUMITE = pNUMITE
                                            AND FLGEST = 'E') ENCOMENDADO )),0) AS QTDENC
              INTO WK_QTDENC_A, WK_QTDENC_E
              FROM DUAL;

            -- RFMP 99726
            -- Tratamento para quando uma encomenda tiver sido dividida
            -- em vrios pedidos.
            -- Caso em que os pedidos podem estar Abertos ou Encomendados.
            IF ((WK_QTDENC_A + WK_QTDENC_E) < pQTDENC) THEN
                IF pFILIVE IS NOT NULL THEN
                    UPDATE TT_IVExIPE SET FLGEST = 'C'
                     WHERE CODFIL = cCODFIL_AUX
                       AND FILMAT = pFILMAT
                       AND CODMAT = pCODMAT
                       AND CODCOR = pCODCOR
                       AND CODTAM = pCODTAM
                       AND FILIVE = pFILIVE
                       AND SEQIVE = pSEQIVE
                       AND NUMIVE = pNUMIVE
                       AND FLGEST IN ('A','E');
                ELSE
                    UPDATE TT_IVExIPE SET FLGEST = 'C'
                     WHERE CODFIL = pCODFIL
                       AND FILMAT = pFILMAT
                       AND CODMAT = pCODMAT
                       AND CODCOR = pCODCOR
                       AND CODTAM = pCODTAM
                       AND FILPED = pFILPED
                       AND TIPPED = pTIPPED
                       AND NUMPED = pNUMPED
                       AND NUMITE = pNUMITE
                       AND FLGEST IN ('A','E');
                END IF;
                cSAIR_PACKAGE := 'T';
            END IF;
            IF (WK_QTDENC_A = pQTDENC) AND (cSAIR_PACKAGE = 'F') THEN
                IF pFILIVE IS NOT NULL THEN
                    UPDATE TT_IVExIPE SET FLGEST = 'C'
                     WHERE CODFIL = cCODFIL_AUX
                       AND FILMAT = pFILMAT
                       AND CODMAT = pCODMAT
                       AND CODCOR = pCODCOR
                       AND CODTAM = pCODTAM
                       AND FILIVE = pFILIVE
                       AND SEQIVE = pSEQIVE
                       AND NUMIVE = pNUMIVE
                       AND FLGEST = 'A';
                ELSE
                    UPDATE TT_IVExIPE SET FLGEST = 'C'
                     WHERE CODFIL = pCODFIL
                       AND FILMAT = pFILMAT
                       AND CODMAT = pCODMAT
                       AND CODCOR = pCODCOR
                       AND CODTAM = pCODTAM
                       AND FILPED = pFILPED
                       AND TIPPED = pTIPPED
                       AND NUMPED = pNUMPED
                       AND NUMITE = pNUMITE
                       AND FLGEST = 'A';
                END IF;
                cSAIR_PACKAGE := 'T';
            END IF;
            IF ((WK_QTDENC_A + WK_QTDENC_E) = pQTDENC) AND (cSAIR_PACKAGE = 'F') THEN
                IF pFILIVE IS NOT NULL THEN
                    UPDATE TT_IVExIPE SET FLGEST = 'C'
                     WHERE CODFIL = cCODFIL_AUX
                       AND FILMAT = pFILMAT
                       AND CODMAT = pCODMAT
                       AND CODCOR = pCODCOR
                       AND CODTAM = pCODTAM
                       AND FILIVE = pFILIVE
                       AND SEQIVE = pSEQIVE
                       AND NUMIVE = pNUMIVE
                       AND FLGEST IN ('A','E');
                ELSE
                    UPDATE TT_IVExIPE SET FLGEST = 'C'
                     WHERE CODFIL = pCODFIL
                       AND FILMAT = pFILMAT
                       AND CODMAT = pCODMAT
                       AND CODCOR = pCODCOR
                       AND CODTAM = pCODTAM
                       AND FILPED = pFILPED
                       AND TIPPED = pTIPPED
                       AND NUMPED = pNUMPED
                       AND NUMITE = pNUMITE
                       AND FLGEST IN ('A','E');
                END IF;
                cSAIR_PACKAGE := 'T';
            END IF;
            IF ((WK_QTDENC_A + WK_QTDENC_E) > pQTDENC) AND (cSAIR_PACKAGE = 'F') THEN

                pAUX_QTDENC := pQTDENC;

                OPEN cENCOMENDA_ABERTO (cCODFIL_AUX,pFILMAT,pCODMAT,pCODCOR,pCODTAM,pFILIVE,pSEQIVE,pNUMIVE,pFILPED,pTIPPED,pNUMPED,pNUMITE);
                LOOP
                    FETCH cENCOMENDA_ABERTO INTO cCODFIL,cSEQUEN,cFILIVE,cSEQIVE,cNUMIVE,cQTDENC,cFILPED,cTIPPED,cNUMPED,cNUMITE;
                    EXIT WHEN NOT FOUND;
                    IF cQTDENC > pAUX_QTDENC THEN
                        UPDATE TT_IVExIPE SET QTDENC = QTDENC - pAUX_QTDENC
                         WHERE CODFIL = cCODFIL
                           AND SEQUEN = cSEQUEN;
                        pAUX_QTDENC := 0;
                    ELSIF cQTDENC < pAUX_QTDENC THEN
                        pAUX_QTDENC := pAUX_QTDENC - cQTDENC;
                        UPDATE TT_IVExIPE SET FLGEST = 'C'
                         WHERE CODFIL = cCODFIL
                           AND SEQUEN = cSEQUEN;
                    ELSE
                        UPDATE TT_IVExIPE SET FLGEST = 'C'
                         WHERE CODFIL = cCODFIL
                           AND SEQUEN = cSEQUEN;
                        EXIT WHEN 1 = 1;
                    END IF;
                END LOOP;
                CLOSE cENCOMENDA_ABERTO;

                OPEN cENCOMENDA_PEDIDO (cCODFIL_AUX,pFILMAT,pCODMAT,pCODCOR,pCODTAM,pFILIVE,pSEQIVE,pNUMIVE,pFILPED,pTIPPED,pNUMPED,pNUMITE);
                LOOP
                    FETCH cENCOMENDA_PEDIDO INTO cCODFIL,cSEQUEN,cFILIVE,cSEQIVE,cNUMIVE,cQTDENC,cFILPED,cTIPPED,cNUMPED,cNUMITE;
                    EXIT WHEN NOT FOUND;
                    IF cQTDENC > pAUX_QTDENC THEN
                        UPDATE TT_IVExIPE SET QTDENC = QTDENC - pAUX_QTDENC
                         WHERE CODFIL = cCODFIL
                           AND SEQUEN = cSEQUEN;
                        pAUX_QTDENC := 0;
                    ELSIF cQTDENC < pAUX_QTDENC THEN
                        pAUX_QTDENC := pAUX_QTDENC - cQTDENC;
                        UPDATE TT_IVExIPE SET FLGEST = 'C'
                         WHERE CODFIL = cCODFIL
                           AND SEQUEN = cSEQUEN;
                    ELSE
                        UPDATE TT_IVExIPE SET FLGEST = 'C'
                         WHERE CODFIL = cCODFIL
                           AND SEQUEN = cSEQUEN;
                        EXIT WHEN 1 = 1;
                    END IF;
                END LOOP;
                CLOSE cENCOMENDA_PEDIDO;
            END IF;
        ELSIF pFLGEST = 'C' THEN -- Cancelamento
            IF pFILIVE IS NOT NULL THEN
                UPDATE TT_IVExIPE SET FLGEST = 'C'
                 WHERE CODFIL = pCODFIL
                   AND FILIVE = pFILIVE
                   AND SEQIVE = pSEQIVE
                   AND NUMIVE = pNUMIVE;
            ELSE
                UPDATE TT_IVExIPE SET FLGEST = 'C'
                 WHERE CODFIL = pCODFIL
                   AND FILPED = pFILPED
                   AND TIPPED = pTIPPED
                   AND NUMPED = pNUMPED
                   AND NUMITE = pNUMITE;
            END IF;
        END IF;
        RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1855 --*/

      CREATE OR REPLACE FUNCTION PC_IVExIPE_ESTOQUE_UPDATE (TT_IVExIPE.FLGEST%TYPE,TT_IVExIPE.FILPED%TYPE,TT_IVExIPE.TIPPED%TYPE,TT_IVExIPE.NUMPED%TYPE,TT_IVExIPE.NUMITE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFLGEST ALIAS FOR $1 ;
pFILPED ALIAS FOR $2 ;
pTIPPED ALIAS FOR $3 ;
pNUMPED ALIAS FOR $4 ;
pNUMITE ALIAS FOR $5 ;
      BEGIN
        IF pFLGEST = 'R' THEN
            UPDATE TT_IOR
               SET FLGEST = 'R',
                   DUMMY  = Constante('VEM_DE_TGIVEXIPE') -- Rhuan - GES-2019071302
             WHERE CODFIL = pFILPED
               AND TIPPED = pTIPPED
               AND NUMPED = pNUMPED
               AND NUMITE = pNUMITE
               AND FLGEST = 'A';
        ELSE
            UPDATE TT_IOR
               SET FLGEST = 'A',
                   DUMMY  = Constante('VEM_DE_TGIVEXIPE') -- Rhuan - GES-2019071302
             WHERE CODFIL = pFILPED
               AND TIPPED = pTIPPED
               AND NUMPED = pNUMPED
               AND NUMITE = pNUMITE
               AND FLGEST = 'R';
        END IF;
        RETURN NULL;

END;
$$ language 'plpgsql';





      CREATE OR REPLACE FUNCTION PC_IVO_UPDATE (TT_IVO.FILVOL%TYPE,TT_IVO.SEQUEN%TYPE,TT_IVO.FILPED%TYPE,TT_IVO.TIPPED%TYPE,TT_IVO.NUMPED%TYPE,TT_IVO.NUMITE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILVOL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pFILPED ALIAS FOR $3 ;
pTIPPED ALIAS FOR $4 ;
pNUMPED ALIAS FOR $5 ;
pNUMITE ALIAS FOR $6 ;
        cDUMMY          VARCHAR(100);     
        iEXISTE         integer;
        vNOVA_QTD       TT_IOR.QTDITE%TYPE;
        vNOVO_NUMITE    TT_IOR.NUMITE%TYPE;
        vSOBRA_QTD      TT_IOR.QTDITE%TYPE;
        vENC_CODFIL     TT_IVEXIPE.CODFIL%TYPE;
        vENC_FLGEST     TT_IVEXIPE.FLGEST%TYPE;
        vENC_QTDENC     TT_IVEXIPE.QTDENC%TYPE;
        vENC_FILMAT     TT_IVEXIPE.FILMAT%TYPE;
        vENC_CODMAT     TT_IVEXIPE.CODMAT%TYPE;
        vENC_CODCOR     TT_IVEXIPE.CODCOR%TYPE;
        vENC_CODTAM     TT_IVEXIPE.CODTAM%TYPE;
        vENC_FILIPE     TT_IVEXIPE.FILIPE%TYPE;
        vENC_NUMIPE     TT_IVEXIPE.NUMIPE%TYPE;
        vENC_ITEIPE     TT_IVEXIPE.ITEIPE%TYPE;
        vENC_DATOPE     TT_IVEXIPE.DATOPE%TYPE;
                                
        CR_ENCOMENDAS CURSOR(pFILPED TT_IVExIPE.FILPED%TYPE,
           pTIPPED TT_IVExIPE.TIPPED%TYPE,
           pNUMPED TT_IVExIPE.NUMPED%TYPE,
           pNUMITE TT_IVExIPE.NUMITE%TYPE) IS
        SELECT CODFIL, FLGEST, QTDENC, FILMAT, CODMAT, CODCOR, CODTAM, FILIPE, NUMIPE, ITEIPE, DATOPE
          FROM TT_IVEXIPE
         WHERE FILPED = pFILPED
           AND TIPPED = pTIPPED
           AND NUMPED = pNUMPED
           AND NUMITE = pNUMITE
           AND FLGEST <> 'C';

      BEGIN  
        
        -- descobre se a ior esta em outra ivo
        SELECT COUNT(*)
          INTO iEXISTE
          FROM TT_IVO IVO
         WHERE IVO.FILPED = pFILPED
           AND IVO.TIPPED = pTIPPED
           AND IVO.NUMPED = pNUMPED
           AND IVO.NUMITE = pNUMITE
           AND IVO.FLGEST NOT IN ('C','D')
           AND(IVO.FILVOL <> pFILVOL 
           OR  IVO.SEQUEN <> pSEQUEN);
                      
        IF  (COALESCE(iEXISTE,0) > 0) THEN                    
          -- descobre de quanto deve ser a nova ior para a nova ivo
          -- obtem vlrcus e vlrpgt da ior original   
          SELECT COALESCE(CASE WHEN IVO.FLGEST = 'P' THEN IVO.CONTEM
                               WHEN IVO.FLGEST = 'F' THEN IVO.QTDFAL
                          END, QTD_A_SEPARAR(Null,Null,Null,IVO.FILPED,IVO.TIPPED,IVO.NUMPED,IVO.NUMITE))
            INTO vNOVA_QTD
            FROM TT_IVO IVO
           WHERE IVO.FILVOL = pFILVOL 
             AND IVO.SEQUEN = pSEQUEN;                    
          
          IF (COALESCE(vNOVA_QTD,0) > 0) THEN          
            
            SELECT MAX(NUMITE)+1 
              INTO vNOVO_NUMITE
              FROM TT_IOR 
             WHERE CODFIL = pFILPED 
               AND TIPPED = pTIPPED  
               AND NUMPED = pNUMPED; 
               
            -- Verifica como vai ficar a original
            SELECT QTDITE - vNOVA_QTD
              INTO vSOBRA_QTD
              FROM TT_IOR
             WHERE CODFIL = pFILPED 
               AND TIPPED = pTIPPED 
               AND NUMPED = pNUMPED 
               AND NUMITE = pNUMITE;               
            
            IF COALESCE(vSOBRA_QTD,0) > 0 THEN

              -- cria uma nova ior para uma nova ivo
              INSERT INTO TT_IOR 
              (CODFIL, TIPPED, NUMPED, 
               NUMITE, FILMAT, CODMAT, 
               CODCOR, CODTAM, FLGEST, 
               ATU_EM, QTDITE, VLRITE, 
               FILFOR, CODFOR, PREUNI, 
               VLRENT, NUMFOR, TIPENT, 
               VLRCUS, VLRPGT, MONTAR, 
               PHOMAR, PHOTIP, PHOISO, 
               PHOOUT, FILRES, QTDENT, 
               ORDITE, PERIPI, FILORI,
               TIPORI, NUMORI, ITEORI, 
               FLGENC, DUMMY) 
              (SELECT CODFIL, TIPPED, NUMPED, 
                      vNOVO_NUMITE, FILMAT, CODMAT, 
                      CODCOR, CODTAM, 'A', 
                      Agora(), vNOVA_QTD, VLRITE, 
                      FILFOR, CODFOR, PREUNI, 
                      VLRENT, NUMFOR, 6 as TIPENT,                     
                      (VLRCUS/QTDITE)*vNOVA_QTD,
                      (VLRPGT/QTDITE)*vNOVA_QTD, 
                      MONTAR, PHOMAR, PHOTIP, 
                      PHOISO, PHOOUT, FILRES, 
                      0, vNOVO_NUMITE, PERIPI,
                      CODFIL, TIPPED, NUMPED,
                      NUMITE, 'F' ,
					  constante('VEM_DE_PC_IVO')
                 FROM TT_IOR 
                WHERE CODFIL = pFILPED 
                  AND TIPPED = pTIPPED 
                  AND NUMPED = pNUMPED 
                  AND NUMITE = pNUMITE);                      
                  
              -- atualiza a ior original, descontando o valor da nova ior
              UPDATE TT_IOR
                 SET QTDITE = (QTDITE - vNOVA_QTD),
                     VLRCUS = (VLRCUS/QTDITE)*(QTDITE-vNOVA_QTD),
                     VLRPGT = (VLRPGT/QTDITE)*(QTDITE-vNOVA_QTD),
                     DUMMY  = constante('VEM_DE_PC_IVO')
               WHERE CODFIL = pFILPED 
                 AND TIPPED = pTIPPED 
                 AND NUMPED = pNUMPED 
                 AND NUMITE = pNUMITE;
                 
              -- faz com que a nova ivo aponte para a nova ior
              UPDATE TT_IVO
                 SET FILPED = pFILPED,
                     TIPPED = pTIPPED,
                     NUMPED = pNUMPED,
                     NUMITE = vNOVO_NUMITE                     
               WHERE FILVOL = pFILVOL
                 AND SEQUEN = pSEQUEN;  

			  -- atualiza tipo de entrega para o correto, tem que fazer depois para no gerar 2 separacoes
              UPDATE TT_IOR
                 SET TIPENT = (select TIPENT
								 FROM TT_IOR 
								WHERE CODFIL = pFILPED 
								  AND TIPPED = pTIPPED 
								  AND NUMPED = pNUMPED 
								  AND NUMITE = pNUMITE),
                     DUMMY  = constante('VEM_DE_PC_IVO')
               WHERE CODFIL = pFILPED 
                 AND TIPPED = pTIPPED 
                 AND NUMPED = pNUMPED 
                 AND NUMITE = vNOVO_NUMITE;				 

              
              OPEN CR_ENCOMENDAS(pFILPED,pTIPPED,pNUMPED,pNUMITE);
              LOOP 
                  FETCH CR_ENCOMENDAS INTO vENC_CODFIL,vENC_FLGEST,vENC_QTDENC,
                                           vENC_FILMAT,vENC_CODMAT,vENC_CODCOR,
                                           vENC_CODTAM,vENC_FILIPE,vENC_NUMIPE,
                                           vENC_ITEIPE,vENC_DATOPE;
                  EXIT WHEN NOT FOUND;
                  
                  -- se vai quebrar a ior  necessrio quebrar a encomenda (tt_ivexipe)
                  /*
                  INSERT INTO TT_IVEXIPE
                        (CODFIL, FILIVE, SEQIVE, NUMIVE, FLGEST, QTDENC, FILMAT, CODMAT, CODCOR, CODTAM,
                         ATU_EM, DATINC, DATOPE, FILIPE, NUMIPE, ITEIPE, FILPED, TIPPED, NUMPED, NUMITE)
                  VALUES 
                        (vENC_CODFIL, null, null, null, vENC_FLGEST, vNOVA_QTD, vENC_FILMAT, vENC_CODMAT, vENC_CODCOR, vENC_CODTAM,
                         Agora(), Agora(), vENC_DATOPE, vENC_FILIPE, vENC_NUMIPE, vENC_ITEIPE, pFILPED, pTIPPED, pNUMPED, vNOVO_NUMITE);
				  */

                  -- atualiza a ior original, descontando o valor da nova ior
                  UPDATE TT_IOR
                     SET FLGENC = 'T'
                   WHERE CODFIL = pFILPED 
                     AND TIPPED = pTIPPED 
                     AND NUMPED = pNUMPED 
                     AND NUMITE = vNOVO_NUMITE;
                  -- 82152				
				  UPDATE TT_IVEXIPE
                     SET FLGEST = vENC_FLGEST,
					     QTDENC = vNOVA_QTD,
					     FILIPE = vENC_FILIPE, 
					     NUMIPE = vENC_NUMIPE, 
					     ITEIPE = vENC_ITEIPE
                   WHERE FILPED = pFILPED 
                     AND TIPPED = pTIPPED 
                     AND NUMPED = pNUMPED 
                     AND NUMITE = vNOVO_NUMITE
					 AND FLGEST = 'A';
				  -- atualiza a IVExIPE original, descontando o valor da nova IVExIPE
                  UPDATE TT_IVEXIPE
                     SET QTDENC = (QTDENC - vNOVA_QTD)
                   WHERE FILPED = pFILPED 
                     AND TIPPED = pTIPPED 
                     AND NUMPED = pNUMPED 
                     AND NUMITE = pNUMITE;					 
                  
              END LOOP;
              CLOSE CR_ENCOMENDAS;
              
            END IF;   

          END IF;
        END IF;
        
        RETURN NULL;

END;
$$ language 'plpgsql';






     /*-- SEQ 1856 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PC_IXT_TrazInstrucoes (TT_TIT.CODBCO%TYPE,TT_TIT.CODREM%TYPE) CASCADE;

/*-- SEQ 1857 --*/
CREATE OR REPLACE FUNCTION PC_IXT_TrazInstrucoes (TT_TIT.CODBCO%TYPE,TT_TIT.CODREM%TYPE)
RETURNS TPC_IXT_Retorno AS $$
DECLARE
p_banco ALIAS FOR $1 ;
p_remessa ALIAS FOR $2 ;
        wk_Retorno TPC_IXT_Retorno%ROWTYPE;
     BEGIN

       SELECT OCOBCO,
              INSTR1,
              INSTR2
         INTO wk_retorno.REMBCO,
              wk_retorno.INSTR1,
              wk_retorno.INSTR2
         FROM TT_REM
        WHERE CODBCO = p_banco
          AND CODREM = p_remessa;

        RETURN wk_retorno;
        END;
$$ language 'plpgsql';



    /*-- SEQ 1858 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PC_IXT_TrazCCB (TT_TIT.CODBCO%TYPE,TT_TIT.CODCCB%TYPE) CASCADE;

/*-- SEQ 1859 --*/
CREATE OR REPLACE FUNCTION PC_IXT_TrazCCB (TT_TIT.CODBCO%TYPE,TT_TIT.CODCCB%TYPE)
RETURNS TT_IXT.CCBBCO%TYPE AS $$
DECLARE
p_banco ALIAS FOR $1 ;
p_conta ALIAS FOR $2 ;
       wk_retorno TT_IXT.CCBBCO%TYPE;
     BEGIN

       SELECT CARBCO
         INTO wk_retorno
         FROM TT_CCB
        WHERE CODBCO = p_banco
          AND CODCCB = p_conta;

        RETURN wk_retorno;
        END;
$$ language 'plpgsql';



    /*-- SEQ 1860 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PC_IXT_TrazECB (TT_TIT.CODBCO%TYPE,TT_TIT.CODECB%TYPE) CASCADE;

/*-- SEQ 1861 --*/
CREATE OR REPLACE FUNCTION PC_IXT_TrazECB (TT_TIT.CODBCO%TYPE,TT_TIT.CODECB%TYPE)
RETURNS TT_IXT.ECBBCO%TYPE AS $$
DECLARE
p_banco ALIAS FOR $1 ;
p_conta ALIAS FOR $2 ;
       wk_retorno TT_IXT.ECBBCO%TYPE;
     BEGIN
       SELECT ECBBCO
         INTO wk_retorno
         FROM TT_ECB
        WHERE CODBCO = p_banco
          AND CODECB = p_conta;

        RETURN wk_retorno;
         END;
$$ language 'plpgsql';



    /*-- SEQ 1862 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PC_IXT_TrazMoeda (TT_TIT.CODBCO%TYPE,TT_REC.CODMOE%TYPE) CASCADE;

/*-- SEQ 1863 --*/
CREATE OR REPLACE FUNCTION PC_IXT_TrazMoeda (TT_TIT.CODBCO%TYPE,TT_REC.CODMOE%TYPE)
RETURNS TT_IXT.MOEBCO%TYPE AS $$
DECLARE
p_banco ALIAS FOR $1 ;
p_moeda ALIAS FOR $2 ;
       wk_retorno TT_IXT.MOEBCO%TYPE;
     BEGIN

       SELECT MOEBCO
         INTO wk_retorno
         FROM TT_MOE
        WHERE CODMOE = p_MOEDA
          AND CODBCO = p_banco;

        RETURN wk_retorno;
        END;
$$ language 'plpgsql';

    
    CREATE OR REPLACE FUNCTION PC_IXT_UPDATE (TT_IXT.CODFIL%TYPE,TT_IXT.SEQTIT%TYPE,TT_TIT.CODBCO%TYPE,TT_TIT.CODREM%TYPE,TT_TIT.CODCCB%TYPE,TT_TIT.CODECB%TYPE,TT_REC.CODMOE%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQTIT ALIAS FOR $2 ;
pCODBCO ALIAS FOR $3 ;
pCODREM ALIAS FOR $4 ;
pCODCCB ALIAS FOR $5 ;
pCODECB ALIAS FOR $6 ;
pCODMOE ALIAS FOR $7 ;       

       wk_instrucoes       TPC_IXT_Retorno%ROWTYPE;
       wk_c_conta_bancaria TT_IXT.CCBBCO%TYPE;
       wk_e_conta_bancaria TT_IXT.ECBBCO%TYPE;
       wk_moeda            TT_IXT.MOEBCO%TYPE;
     BEGIN
            
       select * into wk_instrucoes  from PC_IXT_TrazInstrucoes(pCODBCO, pCODREM);
      
       wk_c_conta_bancaria := PC_IXT_TrazCCB(pCODBCO, pCODCCB);

       wk_e_conta_bancaria := PC_IXT_TrazECB(pCODBCO, pCODECB);

       wk_moeda            := PC_IXT_TrazMoeda(pCODBCO, pCODMOE);

       INSERT INTO TT_IXT (CODFIL
                          ,SEQTIT
                          ,REMBCO
                          ,INSTR1
                          ,INSTR2
                          ,CCBBCO
                          ,ECBBCO
                          ,MOEBCO
                          ,CODREM
                          ,CODCCB
                          ,CODECB
                          ,CODMOE
                          )
                   VALUES (pCODFIL
                          ,pSEQTIT
                          ,wk_instrucoes.REMBCO
                          ,wk_instrucoes.INSTR1
                          ,wk_instrucoes.INSTR2
                          ,wk_c_conta_bancaria
                          ,wk_e_conta_bancaria
                          ,wk_moeda
                          ,pCODREM
                          ,pCODCCB
                          ,pCODECB
                          ,pCODMOE);
      RETURN NULL;

END;
$$ language 'plpgsql';




   CREATE OR REPLACE FUNCTION PC_LAN_AUX_UPDATE (TT_LAN.DATMOV%TYPE,TT_LAN.CODFIL%TYPE,TT_LAN.FILMAT%TYPE,TT_LAN.CODMAT%TYPE,TT_LAN.CODCOR%TYPE,TT_LAN.CODTAM%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pDATMOV ALIAS FOR $1 ;
pCODFIL ALIAS FOR $2 ;
pFILMAT ALIAS FOR $3 ;
pCODMAT ALIAS FOR $4 ;
pCODCOR ALIAS FOR $5 ;
pCODTAM ALIAS FOR $6 ;
   BEGIN
      /* Atualiza a data do custo medio na TT_SAL */
      UPDATE TT_SAL
         SET CAL_CM = CASE WHEN CAL_CM IS NULL THEN NULL ELSE
                        CASE WHEN pDATMOV<CAL_CM THEN pDATMOV
                                                     ELSE CAL_CM
                        END
                      END,
             ATU_CM = 'F',
             DUMMY = Constante('vem_de_TGLAN')
       WHERE CODFIL = pCODFIL
         AND FILMAT = pFILMAT
         AND CODMAT = pCODMAT
         AND CODCOR = pCODCOR
         AND CODTAM = pCODTAM
         AND CODMUL = 0;
         
     UPDATE TD_FIL SET DATFINEST=CASE WHEN DATFINEST IS NULL THEN NULL ELSE
                                    CASE WHEN pDATMOV<DATFINEST THEN TRUNC(pDATMOV)
                                                                 ELSE DATFINEST
                                    END
                                  END
      WHERE CODFIL = pCODFIL
        AND DATFINEST>TRUNC(pDATMOV);
      
    RETURN NULL;

END;
$$ language 'plpgsql';


   CREATE OR REPLACE FUNCTION PC_LEX_DEL_UPDATE (TT_LEX.CODFIL%TYPE,TT_LEX.SEQUEN%TYPE,TT_LEX.FILIEX%TYPE,TT_LEX.SEQIEX%TYPE,TT_LEX.NUMIEX%TYPE,TT_LEX.VLRLAN%TYPE,TT_LEX.FILREC%TYPE,TT_LEX.SEQREC%TYPE,TT_LEX.NUMPAR%TYPE,TT_LEX.SUBPAR%TYPE,TT_LEX.FILCCC%TYPE,TT_LEX.SEQCCC%TYPE,TT_LEX.FILCHR%TYPE,TT_LEX.SEQCHR%TYPE,TT_LEX.FILFIN%TYPE,TT_LEX.SEQFIN%TYPE,TT_LEX.FILDOP%TYPE,TT_LEX.SEQDOP%TYPE,TT_LEX.FILTIT%TYPE,TT_LEX.SEQTIT%TYPE,TT_LEX.FILDEP%TYPE,TT_LEX.SEQDEP%TYPE,TT_LEX.OLDFLG%TYPE,TT_LEX.OLDPOR%TYPE,TT_LEX.OLDSTD%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pFILIEX ALIAS FOR $3 ;
pSEQIEX ALIAS FOR $4 ;
pNUMIEX ALIAS FOR $5 ;
pVLRLAN ALIAS FOR $6 ;
pFILREC ALIAS FOR $7 ;
pSEQREC ALIAS FOR $8 ;
pNUMPAR ALIAS FOR $9 ;
pSUBPAR ALIAS FOR $10 ;
pFILCCC ALIAS FOR $11 ;
pSEQCCC ALIAS FOR $12 ;
pFILCHR ALIAS FOR $13 ;
pSEQCHR ALIAS FOR $14 ;
pFILFIN ALIAS FOR $15 ;
pSEQFIN ALIAS FOR $16 ;
pFILDOP ALIAS FOR $17 ;
pSEQDOP ALIAS FOR $18 ;
pFILTIT ALIAS FOR $19 ;
pSEQTIT ALIAS FOR $20 ;
pFILDEP ALIAS FOR $21 ;
pSEQDEP ALIAS FOR $22 ;
pOLDFLG ALIAS FOR $23 ;
pOLDPOR ALIAS FOR $24 ;
pOLDSTD ALIAS FOR $25 ;
     LINHA_EXT TT_EXT%ROWTYPE;
     LINHA_IEX TT_IEX%ROWTYPE;
     nQtdPortadores INTEGER;
     cFLGSTD TD_STD.FLGFLX%TYPE;
     cFLGDOP TT_DOP.FLGEST%TYPE;
     cPORTAD TD_COB.CODTAB%TYPE;
     cREC_FLGEST TT_REC.FLGEST%TYPE;
     cREC_PORTAD TT_REC.PORTAD%TYPE;
     cREC_SEQCHE TT_REC.SEQCHE%TYPE;
     cREC_CARTAO TT_REC.CARTAO%TYPE;
     cCHR_FLGEST TT_CHR.FLGEST%TYPE;
     cCHR_PORTAD TT_CHR.PORTAD%TYPE;
     cCHR_NEWFLGEST TT_CHR.FLGEST%TYPE;
     cTIT_FLGEST TT_TIT.FLGEST%TYPE;
     nCCC_VLRLAN TT_CCC.VLRLAN%TYPE;
     nMAXSUB TT_REC.SUBPAR%TYPE;
     cFILDEP TT_DEP.CODFIL%TYPE;
     cSEQDEP TT_DEP.SEQUEN%TYPE;
     cFILREC TT_REC.CODFIL%TYPE;
     cSEQREC TT_REC.SEQUEN%TYPE;   
     cNUMPAR TT_REC.NUMPAR%TYPE;   
     cSUBPAR TT_REC.SUBPAR%TYPE;   
     nAUX INTEGER;
     nSUBORI TT_REC.SUBPAR%TYPE;
        
      QuemLogou TRetQuemLogou%ROWTYPE;
              
     vComplemento CONSTANT VARCHAR(100) := constante('complemento');    
   BEGIN
    
    select * into QuemLogou from DadosLogon();
    -- Pega CODFIL e SEQUEN do usuario logado
    IF not QuemLogou.Encontrou THEN
       RAISE EXCEPTION 'PG-20050 Voce nao e um usuario cadastrado no sistema %' , vComplemento;
    END IF;         
   
     -- Pega dados das tabelas pais
     SELECT EXT.* INTO LINHA_EXT
       FROM TT_EXT EXT 
      WHERE EXT.CODFIL=pFILIEX
        AND EXT.SEQUEN=pSEQIEX;
        
     SELECT IEX.* INTO LINHA_IEX
       FROM TT_IEX IEX
      WHERE IEX.CODFIL=pFILIEX
        AND IEX.SEQUEN=pSEQIEX
        AND IEX.NUMITE=pNUMIEX;
     
     -- Se relacao eh com TT_DOP
     IF pFILDOP IS NOT NULL THEN
        SELECT STD.FLGFLX INTO cFLGSTD
        FROM TD_STD STD 
        WHERE STD.CODTAB = pOLDSTD;
            
        -- Se esta aberto desfaz conciliacao
        IF cFLGSTD <> 'R' THEN
           UPDATE TT_DOP SET STDDOP=pOLDSTD
            WHERE CODFIL=pFILDOP
              AND SEQUEN=pSEQDOP;
        END IF;
    END IF;
    
   -- Se relacao e com TT_REC ou TT_TIT
   IF PFILREC IS NOT NULL OR PFILTIT IS NOT NULL THEN
      IF PFILREC IS NOT NULL THEN 
         cFILREC:=pFILREC;
         cSEQREC:=pSEQREC;
         cNUMPAR:=pNUMPAR;
         cSUBPAR:=pSUBPAR;
      ELSE
         SELECT FILREC,SEQREC,PARREC,SUBREC INTO cFILREC,cSEQREC,cNUMPAR,cSUBPAR
           FROM TT_TIT
          WHERE CODFIL=pFILTIT
            AND SEQUEN=pSEQTIT;         
      END IF;
         
      -- Se estava aberto desfaz conciliacao
      IF pOLDFLG = 'A' THEN         
      
          SELECT MAX(TO_NUMBER(SUBPAR))+1, SUBPAR  INTO nMAXSUB, nSUBORI
          FROM TT_REC
           WHERE CODFIL = cFILREC                    
             AND SEQUEN = cSEQREC
             AND NUMPAR = cNUMPAR;
                               
          update TT_REC
          set
            FLGEST = 'X',
            --PAGAME = AGORA(), -- Data estorno
            ATU_EM = AGORA(),
            FILUSU = QuemLogou.FILUSU,
            CODUSU = QuemLogou.CODUSU
          where
            CODFIL = cFILREC and
            SEQUEN = cSEQREC and
            NUMPAR = cNUMPAR and
            SUBPAR = cSUBPAR;
            
          SELECT COUNT(*) INTO nAUX
            FROM TT_REC
           WHERE CODFIL=cFILREC
             AND SEQUEN=cSEQREC
             AND NUMPAR=cNUMPAR
             AND FLGEST='A'
             AND SEQCHE IS NULL
             AND CARTAO IS NULL; 
        
        IF nAUX=0 THEN  
            insert into TT_REC  
              (CODFIL, SEQUEN, NUMPAR, SUBPAR, SUBORI, ATU_EM, DATVEN, CODMOE, FLGEST, 
               VLRPAR, SIGNAT, PORTAD, CODUSU, FILUSU)
              (SELECT  CODFIL, SEQUEN, NUMPAR, 
              LPAD(nMAXSUB,2,' ') AS SUBPAR, nSUBORI, ATU_EM, DATVEN, CODMOE, 'A' AS FLGEST, 
               VLRPGT as VLRPAR, 0, 
               case when PFILREC is not null then pOLDPOR 
                                             else 0
               end as portad, 
               CODUSU, FILUSU 
               FROM TT_REC
               WHERE CODFIL = cFILREC and
                     SEQUEN = cSEQREC and
                     NUMPAR = cNUMPAR and
                     SUBPAR = cSUBPAR);          
         ELSE
            UPDATE TT_REC 
               SET VLRPAR=VLRPAR+(SELECT REC.VLRPGT 
                                    FROM TT_REC REC
                                   WHERE REC.CODFIL = cFILREC
                                     AND REC.SEQUEN = cSEQREC
                                     AND REC.NUMPAR = cNUMPAR
                                     AND REC.SUBPAR = cSUBPAR)
             WHERE CODFIL=cFILREC
               AND SEQUEN=cSEQREC
               AND NUMPAR=cNUMPAR
               AND FLGEST='A'
               AND SEQCHE IS NULL
               AND CARTAO IS NULL;
         END IF;
      END IF;
   END IF;
   
   -- Se relacao e com TT_CHR
   IF pFILCHR IS NOT NULL THEN

      IF LINHA_IEX.TIPEXT=119 THEN 
         cCHR_NEWFLGEST:='V';
         
/*         SELECT FILDEP,
                SEQDEP INTO cFILDEP, cSEQDEP
           FROM TT_CHR
          WHERE CODFIL = PFILCHR
            AND SEQUEN = PSEQCHR;
         
         UPDATE TT_DEP
            SET VLRDEV=VLRDEV-pVLRLAN,
                DUMMY=CONSTANTE('VEM_DE_PCLEX')
          WHERE CODFIL = cFILDEP
            AND SEQUEN = cSEQDEP; */
             
      ELSE 
         cCHR_NEWFLGEST:='D';
      END IF;
      
      -- Se estava aberto desfaz conciliacao
      IF (cCHR_NEWFLGEST =  'V' AND pOLDFLG NOT IN ('V','B'))
      OR (cCHR_NEWFLGEST = 'D' AND pOLDFLG IN ('A','U','G','V','P')) THEN
      
         IF pOLDFLG='C' THEN
            update TT_CHR
               set FLGEST = 'D', 
                   PORTAD = pOLDPOR,
                   TIPCOB = (SELECT TIPCOB FROM TD_COB WHERE CODTAB=pOLDPOR)
             where CODFIL = pFILCHR
               and SEQUEN = pSEQCHR;
         END IF;
      
         update TT_CHR
         set FLGEST = pOLDFLG, 
             PORTAD = pOLDPOR,
             TIPCOB = (SELECT TIPCOB FROM TD_COB WHERE CODTAB=pOLDPOR)
         where CODFIL = pFILCHR
           and SEQUEN = pSEQCHR;
           
      END IF;
   END IF;   
  
   -- Se relacao e com TT_CCC
   IF pFILCCC IS NOT NULL THEN
      IF pOLDFLG='I' THEN
         INSERT INTO TT_CCC 
            (CODFIL,DATOPE,VLRLAN,NUMDOC,FILUSU,CODUSU,STATUS,COMPLE,FILCLI,CODCLI,TIPCCC,PORORI,TIPLAN)
            (SELECT CODFIL,
                    AGORA() AS DATOPE,
                    VLRLAN*-1 AS VLRLAN,
                    NUMDOC,FILUSU,CODUSU,STATUS,
                    TO_CHAR('ESTORNO DE CONCILIACAO') AS COMPLE,
                    FILCLI,CODCLI,TIPCCC,PORORI, TO_CHAR('Z') AS TIPLAN
               FROM TT_CCC
              WHERE CODFIL = PFILCCC
                AND SEQUEN = PSEQCCC
            ); 
      END IF;
   END IF;   
   
   -- Se relacao e com TT_FIN
   IF pFILFIN IS NOT NULL THEN
      IF pOLDFLG='I' THEN
         INSERT INTO TT_FIN
            (CODFIL,NUMDOC,CODCTR,FILGER,SEQGER,TIPGER,CODCUS,OBSERV,DATOPE,FILNUM,SEQNUM,TIPNUM,FLGFIN,
             FILUSU,CODUSU,VLRMOV, ORILAN)
            (SELECT CODFIL,NUMDOC,CODCTR,FILGER,SEQGER,TIPGER,CODCUS,
                    TO_CHAR('ESTORNO DE CONCILIACAO') AS OBSERV,
                    AGORA() AS DATOPE,
                    FILNUM,SEQNUM,TIPNUM,FLGFIN,
                    FILUSU,CODUSU,
                    VLRMOV*-1 AS VLRMOV,
                    COALESCE(ORILAN,TO_CHAR('I')) AS ORILAN
               FROM TT_FIN
              WHERE CODFIL = PFILFIN
                AND SEQUEN = PSEQFIN
            ); 
      END IF;
   END IF;  
   
   -- Se relacao e com TT_DEP
   IF pFILDEP IS NOT NULL THEN
      UPDATE TT_DEP
         SET VLRCOM=VLRCOM-pVLRLAN,
             DUMMY=CONSTANTE('VEM_DE_PCLEX')
        WHERE CODFIL = PFILDEP
          AND SEQUEN = PSEQDEP;
      UPDATE TT_CHR
         SET FLGEST='A'
       WHERE FLGEST = 'C'
         AND FILDEP=pFILDEP
         AND SEQDEP=pSEQDEP;     
   END IF;
        
    RETURN NULL;

END;
$$ language 'plpgsql';


   CREATE OR REPLACE FUNCTION PC_LEX_INS_UPDATE (TT_LEX.CODFIL%TYPE,TT_LEX.SEQUEN%TYPE,TT_LEX.FILIEX%TYPE,TT_LEX.SEQIEX%TYPE,TT_LEX.NUMIEX%TYPE,TT_LEX.VLRLAN%TYPE,TT_LEX.FILREC%TYPE,TT_LEX.SEQREC%TYPE,TT_LEX.NUMPAR%TYPE,TT_LEX.SUBPAR%TYPE,TT_LEX.FILCCC%TYPE,TT_LEX.SEQCCC%TYPE,TT_LEX.FILCHR%TYPE,TT_LEX.SEQCHR%TYPE,TT_LEX.FILFIN%TYPE,TT_LEX.SEQFIN%TYPE,TT_LEX.FILDOP%TYPE,TT_LEX.SEQDOP%TYPE,TT_LEX.FILTIT%TYPE,TT_LEX.SEQTIT%TYPE,TT_LEX.FILDEP%TYPE,TT_LEX.SEQDEP%TYPE,TT_LEX.OLDFLG%TYPE,TT_LEX.OLDPOR%TYPE,TT_LEX.OLDSTD%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pFILIEX ALIAS FOR $3 ;
pSEQIEX ALIAS FOR $4 ;
pNUMIEX ALIAS FOR $5 ;
pVLRLAN ALIAS FOR $6 ;
pFILREC ALIAS FOR $7 ;
pSEQREC ALIAS FOR $8 ;
pNUMPAR ALIAS FOR $9 ;
pSUBPAR ALIAS FOR $10 ;
pFILCCC ALIAS FOR $11 ;
pSEQCCC ALIAS FOR $12 ;
pFILCHR ALIAS FOR $13 ;
pSEQCHR ALIAS FOR $14 ;
pFILFIN ALIAS FOR $15 ;
pSEQFIN ALIAS FOR $16 ;
pFILDOP ALIAS FOR $17 ;
pSEQDOP ALIAS FOR $18 ;
pFILTIT ALIAS FOR $19 ;
pSEQTIT ALIAS FOR $20 ;
pFILDEP ALIAS FOR $21 ;
pSEQDEP ALIAS FOR $22 ;
pOLDFLG ALIAS FOR $23 ;
pOLDPOR ALIAS FOR $24 ;
pOLDSTD ALIAS FOR $25 ;
     LINHA_EXT TT_EXT%ROWTYPE;
     LINHA_IEX TT_IEX%ROWTYPE;
     nQtdPortadores INTEGER;
     cFLGSTD TD_STD.FLGFLX%TYPE;
     cFLGDOP TT_DOP.FLGEST%TYPE;
     cPORTAD TD_COB.CODTAB%TYPE;
     cTIPCOB TD_COB.TIPCOB%TYPE;
     cREC_FLGEST TT_REC.FLGEST%TYPE;
     cREC_PORTAD TT_REC.PORTAD%TYPE;
     cREC_SEQCHE TT_REC.SEQCHE%TYPE;
     cREC_CARTAO TT_REC.CARTAO%TYPE;
     cCHR_FLGEST TT_CHR.FLGEST%TYPE;
     cCHR_PORTAD TT_CHR.PORTAD%TYPE;
     cCHR_NEWFLGEST TT_CHR.FLGEST%TYPE;
     cTIT_FLGEST TT_TIT.FLGEST%TYPE;
     nCCC_VLRLAN TT_CCC.VLRLAN%TYPE;
     vAUX VARCHAR(2);
     nVLRDEP TT_DEP.VLRTOT%TYPE;
     cFILDEP TT_DEP.CODFIL%TYPE;
     cSEQDEP TT_DEP.SEQUEN%TYPE;
     nAUX    INTEGER;  
     cFILREC TT_REC.CODFIL%TYPE;
     cSEQREC TT_REC.SEQUEN%TYPE;   
     cNUMPAR TT_REC.NUMPAR%TYPE;   
     cSUBPAR TT_REC.SUBPAR%TYPE;   
     cCODBCO TT_TIT.CODBCO%TYPE;
     CNUMAGE TT_TIT.NUMAGE%TYPE;
     cCTACRR TT_TIT.CTACRR%TYPE;
     cJURDES TT_TIT.JURDES%TYPE;
     cCODDES TT_TIT.CODDES%TYPE;
     cDATDES TT_TIT.DATDES%TYPE;
     cVLRORI TT_TIT.VLRORI%TYPE;
                         
        
      QuemLogou TRetQuemLogou%ROWTYPE;
         
     vComplemento CONSTANT VARCHAR(100) := constante('complemento');
   BEGIN
   
    select * into QuemLogou from DadosLogon();
    -- Pega CODFIL e SEQUEN do usuario logado
    IF not QuemLogou.Encontrou THEN
       RAISE EXCEPTION 'PG-20050 Voce nao e um usuario cadastrado no sistema %' , vComplemento;
    END IF;      
     -- Pega dados das tabelas pais
     SELECT EXT.* INTO LINHA_EXT
       FROM TT_LEX LEX INNER JOIN TT_EXT EXT ON LEX.FILIEX=EXT.CODFIL AND LEX.SEQIEX=EXT.SEQUEN
      WHERE LEX.CODFIL=pCODFIL
        AND LEX.SEQUEN=pSEQUEN;
        
     SELECT IEX.* INTO LINHA_IEX
       FROM TT_LEX LEX INNER JOIN TT_IEX IEX ON LEX.FILIEX=IEX.CODFIL AND LEX.SEQIEX=IEX.SEQUEN AND LEX.NUMIEX=IEX.NUMITE
      WHERE LEX.CODFIL=pCODFIL
        AND LEX.SEQUEN=pSEQUEN;

     -- valida se ha apenas um portador por conta bancaria
     SELECT MIN(COB.CODTAB),MIN(COB.TIPCOB),COUNT(*) INTO cPORTAD,cTIPCOB,nQtdPortadores
     FROM TT_CTB CTB INNER JOIN TD_COB COB ON COB.FILCTA = CTB.FILCTA
                                          AND COB.SEQCTA = CTB.SEQCTA
                                          AND COB.TIPCTA = CTB.TIPCTA                                          
     WHERE CTB.CODBCO = LINHA_EXT.CODBCO
       AND CTB.NUMAGE = LINHA_EXT.NUMAGE
       AND CTB.CTACRR = LINHA_EXT.CTACRR
       AND COB.TIPCOB='B'
       AND COB.GERTIT='T';
     IF nQtdPortadores > 1 THEN
        RAISE EXCEPTION 'PG-20001 Existe mais de um portador para a conta %-%-%. Favor corrigir.%' , LINHA_EXT.CODBCO,LINHA_EXT.NUMAGE,LINHA_EXT.CTACRR,vComplemento;
     END IF;
     
     -- Se relacao eh com TT_DOP
     IF pFILDOP IS NOT NULL THEN
        SELECT STD.FLGFLX,DOP.FLGEST INTO cFLGSTD,cFLGDOP
        FROM TT_DOP DOP LEFT JOIN TD_STD STD ON STD.CODTAB = DOP.STDDOP
        WHERE DOP.CODFIL = PFILDOP
          AND DOP.SEQUEN = PSEQDOP;
        -- No permite concilar com registro cancelado
        IF cFLGDOP = 'C' THEN
           RAISE EXCEPTION 'PG-20002 Nao e permitido conciliar um documento cancelado.%' , vComplemento;
        END IF;
        -- Se esta aberto faz conciliacao
        IF cFLGSTD <> 'R' THEN
           UPDATE TT_DOP
              SET STDDOP = (SELECT MAX(CODTAB) FROM TD_STD WHERE DOMDOP <> 0 AND FLGFLX = 'R'), -- Criar tarefa para poder identificar
                  DATPGT = LINHA_IEX.DATLAN
           WHERE CODFIL = PFILDOP
             AND SEQUEN = PSEQDOP;
        END IF;
    END IF;
    
   -- Se relacao e com TT_REC
   IF PFILREC IS NOT NULL THEN
      SELECT REC.FLGEST, 
             REC.PORTAD, 
             REC.SEQCHE, 
             REC.CARTAO INTO cREC_FLGEST,cREC_PORTAD,cREC_SEQCHE,cREC_CARTAO
      FROM TT_REC REC
      WHERE REC.CODFIL = PFILREC
        AND REC.SEQUEN = PSEQREC
        AND REC.NUMPAR = PNUMPAR
        AND REC.SUBPAR = PSUBPAR;
      -- No permite concilar com registro cancelado ou estornado
      IF cREC_FLGEST in ('C','X') THEN
         RAISE EXCEPTION 'PG-20003 Nao e permitido conciliar uma parcela cancelada.%' , vComplemento;
      END IF;
      -- No permite relacionar com parcela ja recebida com cheque
      IF cREC_SEQCHE is not null THEN
         RAISE EXCEPTION 'PG-20004 Nao e permitido conciliar uma parcela paga com cheque.%' , vComplemento;
      END IF;
      -- No permite relacionar com parcela ja recebida com cartao
      IF cREC_CARTAO is not null THEN
         RAISE EXCEPTION 'PG-20005 Nao e permitido conciliar uma parcela paga com cartao.%' , vComplemento;
      END IF;
      -- Se esta aberto faz conciliacao
      IF cREC_FLGEST = 'A' THEN
         update TT_REC
         set FLGEST = 'P',
             PAGAME = LINHA_IEX.DATLAN,
             ATU_EM = agora(),
             VLRPGT = pVLRLAN,
             VLRDES = CASE WHEN pVLRLAN<CALCRECATU(pFILREC,pSEQREC,pNUMPAR,pSUBPAR,0,LINHA_IEX.DATLAN) THEN 0
                           ELSE VLRPAR-pVLRLAN
                      END,
             FILUSU = QuemLogou.FILUSU,
             CODUSU = QuemLogou.CODUSU,
             FILREC = pCODFIL,
             PORTAD = cPORTAD
         where CODFIL = PFILREC
           and SEQUEN = PSEQREC     
           and NUMPAR = pNUMPAR
           and SUBPAR = pSUBPAR;
           
        IF pVLRLAN<CALCRECATU(pFILREC,pSEQREC,pNUMPAR,pSUBPAR,0,LINHA_IEX.DATLAN) then 
            
            SELECT COUNT(*) INTO nAUX
              FROM TT_REC
             WHERE CODFIL=PFILREC
               AND SEQUEN=PSEQREC
               AND NUMPAR=pNUMPAR
               AND FLGEST='A'
               AND SEQCHE IS NULL
               AND CARTAO IS NULL;              
               
            IF nAUX=0 THEN              
                INSERT INTO TT_REC 
                (CODFIL,SEQUEN,NUMPAR,SUBPAR,SUBORI,FLGEST,DATVEN,VLRPAR,CODMOE,PORTAD,SEQCHE,CODUSU,FILREC,FILUSU,
                 NUMECF,CUPFIS,CARTAO,DUMMY,TIPCCC,CODEXT,RENEGO,RENORI,DATINC,SIGNAT)
                (SELECT CODFIL,SEQUEN,NUMPAR,
                        (SELECT LPAD(MAX(SUBPAR)+1,2,' ') 
                           FROM TT_REC 
                          WHERE CODFIL=PFILREC
                            AND SEQUEN=PSEQREC
                            AND NUMPAR=pNUMPAR
                        ) AS SUBPAR,
                        (SELECT SUBPAR 
                           FROM TT_REC 
                          WHERE CODFIL=PFILREC
                            AND SEQUEN=PSEQREC
                            AND NUMPAR=pNUMPAR
                        ) AS SUBORI,
                        'A' AS FLGEST,
                        DATVEN,
                        VLRPAR-VLRPGT AS VLRPAR,
                        CODMOE,
                        PORTAD,SEQCHE,CODUSU,FILREC,FILUSU,
                        NUMECF,CUPFIS,CARTAO,DUMMY,TIPCCC,CODEXT,RENEGO,RENORI,DATINC,
                        0 AS SIGNAT
                   FROM TT_REC
                  WHERE CODFIL=PFILREC
                    AND SEQUEN=PSEQREC
                    AND NUMPAR=pNUMPAR
                    AND SUBPAR=pSUBPAR
                   );
           ELSE
               UPDATE TT_REC 
                  SET VLRPAR=VLRPAR+pVLRLAN
                WHERE CODFIL=PFILREC
                  AND SEQUEN=PSEQREC
                  AND NUMPAR=pNUMPAR
                  AND FLGEST='A'
                  AND SEQCHE IS NULL
                  AND CARTAO IS NULL;
           END IF;
        END IF;
           
      END IF; 
   END IF;
   
   -- Se relacao e com TT_CHR
   IF pFILCHR IS NOT NULL THEN
      SELECT FLGEST,
             PORTAD,
             FILDEP,
             SEQDEP INTO cCHR_FLGEST,cCHR_PORTAD, cFILDEP, cSEQDEP
      FROM TT_CHR
      WHERE CODFIL = PFILCHR
        AND SEQUEN = PSEQCHR;
      -- Nao permite concilar com registro cancelado ou substituido
      IF cCHR_FLGEST in ('X','S') THEN
         RAISE EXCEPTION 'PG-20007 Nao e permitido conciliar um cheque cancelado.%' , vComplemento;
      END IF;
      
      IF LINHA_IEX.TIPEXT=119 THEN 
         
         cCHR_NEWFLGEST:='V';
         
/*         UPDATE TT_DEP
            SET VLRDEV=VLRDEV+pVLRLAN,
                DUMMY=CONSTANTE('VEM_DE_PCLEX')
          WHERE CODFIL = cFILDEP
            AND SEQUEN = cSEQDEP;
                
          SELECT COUNT(*), MIN(VLRCOM-VLRCOM-VLRDEV) INTO nAUX,nVLRDEP
            FROM TT_DEP
            WHERE CODFIL = cFILDEP
              AND SEQUEN = cSEQDEP;          
              
          IF nVLRDEP=0 THEN      
             vAUX:=CompensaChequesConciliados(cFILDEP,cSEQDEP,cPORTAD,cTIPCOB);
          END IF;*/
            
      ELSE 
         cCHR_NEWFLGEST:='D';
      END IF;
      
      -- Se esta aberto faz conciliacao
      IF (cCHR_NEWFLGEST =  'V' AND cCHR_FLGEST NOT IN  ('V','B','I')) THEN
      --OR (cCHR_NEWFLGEST = 'D' AND cCHR_FLGEST IN ('A','U','G','V','P')) THEN

         update TT_CHR
         set FLGEST = 'A',
             ALINEA = LINHA_IEX.ALINEA,
             PORTAD = cPORTAD,
             TIPCOB = cTIPCOB,
             FILUSU = QuemLogou.FILUSU,   
             CODUSU = QuemLogou.CODUSU,   
             VLRCHE = pVLRLAN,
             PAGAME = LINHA_IEX.DATLAN,
             ATU_EM = AGORA()
         where CODFIL = pFILCHR
           and SEQUEN = pSEQCHR
           AND FLGEST = 'C';
           
         update TT_CHR
         set FLGEST = 'D',
             ALINEA = LINHA_IEX.ALINEA,
             PORTAD = cPORTAD,
             TIPCOB = cTIPCOB,
             FILUSU = QuemLogou.FILUSU,   
             CODUSU = QuemLogou.CODUSU,   
             VLRCHE = pVLRLAN,
             PAGAME = LINHA_IEX.DATLAN,
             ATU_EM = AGORA()
         where CODFIL = pFILCHR
           and SEQUEN = pSEQCHR
           AND FLGEST = 'A';

         update TT_CHR
         set FLGEST = 'V',
             ALINEA = LINHA_IEX.ALINEA,
             PORTAD = cPORTAD,
             TIPCOB = cTIPCOB,
             FILUSU = QuemLogou.FILUSU,   
             CODUSU = QuemLogou.CODUSU,   
             VLRCHE = pVLRLAN,
             PAGAME = LINHA_IEX.DATLAN,
             ATU_EM = AGORA()
         where CODFIL = pFILCHR
           and SEQUEN = pSEQCHR;
/*      ELSE
         -- Nao pode vilcular O cheque ja relacionado com outro portador
         IF cCHR_PORTAD <> cPORTAD THEN
            RAISE EXCEPTION 'PG-20008 Cheque ja esta pago com outro portador.%' , vComplemento;
         END IF;*/
      END IF;
   END IF;
   
   -- Se relacao e com TT_TIT
   IF pFILTIT IS NOT NULL THEN
      SELECT TIT.FILREC, TIT.SEQREC, TIT.PARREC, TIT.SUBREC, TIT.FLGEST,
             TIT.CODBCO,TIT.NUMAGE,TIT.CTACRR,TIT.JURDES,
             TIT.CODDES,TIT.DATDES,TIT.VLRORI
        INTO cFILREC, cSEQREC, cNUMPAR, cSUBPAR, cTIT_FLGEST, 
             cCODBCO,cNUMAGE,cCTACRR,cJURDES,
             cCODDES,cDATDES,cVLRORI
      FROM TT_TIT TIT
      WHERE TIT.CODFIL = PFILTIT
        AND TIT.SEQUEN = PSEQTIT; 
        
      SELECT REC.FLGEST, 
             REC.PORTAD, 
             REC.SEQCHE, 
             REC.CARTAO INTO cREC_FLGEST,cREC_PORTAD,cREC_SEQCHE,cREC_CARTAO
      FROM TT_REC REC
      WHERE REC.CODFIL = cFILREC
        AND REC.SEQUEN = cSEQREC
        AND REC.NUMPAR = cNUMPAR
        AND REC.SUBPAR = cSUBPAR;  
        
     IF cREC_FLGEST='A' THEN 
        
          update TT_REC
             set FLGEST = 'P',
                 PAGAME = LINHA_IEX.DATLAN,
                 ATU_EM = agora(),
                 VLRPGT = pVLRLAN,
                 VLRDES = VLRPAR-pVLRLAN,
                 FILUSU = QuemLogou.FILUSU,
                 CODUSU = QuemLogou.CODUSU,
                 FILREC = pCODFIL,
                 PORTAD = 0 --cPORTAD
             where CODFIL = cFILREC 
               and SEQUEN = cSEQREC
               and NUMPAR = cNUMPAR
               and SUBPAR = cSUBPAR;
               
          vAux:=CriaSubparTitulo (cFILREC,cSEQREC,cNUMPAR,cSUBPAR,
                                  cCODBCO,cNUMAGE,cCTACRR,cJURDES,
                                  cCODDES,cDATDES,cVLRORI);
      END IF;    
/*      IF cTIT_FLGEST<>'P' THEN 
         RAISE EXCEPTION 'PG-20009 Uma conciliacao somente deve ser vinculada a titulo pago.%' , vComplemento;
      END IF;        */
        
   END IF;
   
   -- Se relacao e com TT_CCC
   IF pFILCCC IS NOT NULL THEN
      SELECT CCC.VLRLAN INTO nCCC_VLRLAN
      FROM TT_CCC CCC
      WHERE CCC.CODFIL = PFILCCC
        AND CCC.SEQUEN = PSEQCCC; 
      
      IF nCCC_VLRLAN<=0 THEN 
         RAISE EXCEPTION 'PG-20010 Uma conciliacao deve ser vinculada a uma c/c com valor positivo.%' , vComplemento;
      END IF;
   END IF;   
   
   -- Se relacao e com TT_DEP
   IF pFILDEP IS NOT NULL THEN
      UPDATE TT_DEP
         SET VLRCOM=VLRCOM+pVLRLAN,
             DUMMY=CONSTANTE('VEM_DE_PCLEX')
        WHERE CODFIL = PFILDEP
          AND SEQUEN = PSEQDEP;
          
      SELECT VLRTOT-VLRCOM INTO nVLRDEP
        FROM TT_DEP
        WHERE CODFIL = PFILDEP
          AND SEQUEN = PSEQDEP;
          
      IF nVLRDEP=0 THEN      
         vAUX:=CompensaChequesConciliados(pFILDEP,pSEQDEP,cPORTAD,cTIPCOB);
      END IF;
   END IF;  
        
    RETURN NULL;

END;
$$ language 'plpgsql';








    /*-- SEQ 1864 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PC_PAG_TemLanctoParcial (TT_PAG.DATPRX%TYPE,TT_PAG.VLRDIF%TYPE) CASCADE;

/*-- SEQ 1865 --*/
CREATE OR REPLACE FUNCTION PC_PAG_TemLanctoParcial (TT_PAG.DATPRX%TYPE,TT_PAG.VLRDIF%TYPE)
RETURNS INTEGER AS $$
DECLARE
pDATPRX ALIAS FOR $1 ;
pVLRDIF ALIAS FOR $2 ;
    begin

      If (pDATPRX IS NOT NULL) AND (COALESCE(pVLRDIF,0)<>0) then
         RETURN 1;
      elsif (pDATPRX IS NULL)  AND (COALESCE(pVLRDIF,0) = 0) then
         RETURN 0;
      else
         RETURN -1;
      end if;

    END;
$$ language 'plpgsql';


    CREATE OR REPLACE FUNCTION PC_PAG_UPDATE (TT_PAG.CODFIL%TYPE,TT_PAG.SEQUEN%TYPE,TT_PAG.NUMPAR%TYPE,TT_PAG.DATPRX%TYPE,TT_PAG.VLRDIF%TYPE,TT_PAG.FILDOP%TYPE,TT_PAG.SEQDOP%TYPE,TT_PAG.FLGEST%TYPE,TT_PAG.DOCPGT%TYPE,TT_PAG.VLRPGT%TYPE,TT_PAG.DATPGT%TYPE,TT_PAG.DATVEN%TYPE,TT_PAG.VLRPAR%TYPE,TT_PAG.SUBORI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pNUMPAR ALIAS FOR $3 ;
pDATPRX ALIAS FOR $4 ;
pVLRDIF ALIAS FOR $5 ;
pFILDOP ALIAS FOR $6 ;
pSEQDOP ALIAS FOR $7 ;
pFLGEST ALIAS FOR $8 ;
pDOCPGT ALIAS FOR $9 ;
pVLRPGT ALIAS FOR $10 ;
pDATPGT ALIAS FOR $11 ;
pDATVEN ALIAS FOR $12 ;
pVLRPAR ALIAS FOR $13 ;
pSUBORI ALIAS FOR $14 ;

      Usuario_Filial TT_USU.FILUSU%TYPE;
      Usuario_Codigo TT_USU.CODUSU%TYPE;
      Subparcela     TT_PAG.SUBPAR%TYPE;
      bExiste        INTEGER;
      Lanca          INTEGER;
      vComplemento   CONSTANT VARCHAR(100) := constante('complemento');
      Logon          TRetQuemLogou%ROWTYPE;

      ProximaSubparcela CURSOR(pCurFilial TT_PAG.CODFIL%TYPE,
           pCurCodigo TT_PAG.SEQUEN%TYPE,
           pCurParcela TT_PAG.NUMPAR%TYPE) IS
             SELECT cast(MAX(COALESCE(SUBPAR,'0')) as integer)+1 AS SUBPAR
               FROM TT_PAG
              WHERE CODFIL = pCurFilial
                AND SEQUEN = pCurCodigo
                AND NUMPAR = pCurParcela;

      DocumentoCancelado CURSOR(pCurFilial TT_PAG.FILDOP%TYPE,
           pCurCodigo TT_PAG.SEQDOP%TYPE) IS
             SELECT COUNT(*) AS Existe
               FROM TT_DOP
              WHERE CODFIL = pCurFilial
                AND SEQUEN = pCurCodigo
                AND FLGEST = 'C';
    BEGIN

      /* Gera proxima subparcela ou quita a compra */
      IF (pFLGEST = 'P') THEN

         Lanca := PC_PAG_TemLanctoParcial(pDATPRX,pVLRDIF);

         /* Gera proxima subparcela */
         IF (Lanca = 1) THEN

            /* Cria subparcela */
            /* 1o. Verifica se o usuario e valido */
            select * into Logon from DadosLogon();
            IF NOT Logon.Encontrou THEN
               RAISE EXCEPTION 'PG-20001 Usuario nao cadastrado no sistema. %' , vComplemento;
            ELSE
               Usuario_Filial := Logon.FILUSU;
               Usuario_Codigo := Logon.CODUSU;
            END IF;

            /* 2o. Obtem a proxima subparcela */
            Open  ProximaSubparcela(pCODFIL,
                                    pSEQUEN,
                                    pNUMPAR);
            Fetch ProximaSubparcela into SubParcela;
            Close ProximaSubparcela;

            /* 3o. Insere a subparcela */
                       INSERT INTO TT_PAG (CODFIL,
                                SEQUEN,
                                NUMPAR,
                                SUBPAR,
                                FILUSU,
                                CODUSU,
                                FLGEST,
                                ATU_EM,
                                DATVEN,
                                VLRPAR,
                                SUBORI)
                        VALUES (pCODFIL,
                                pSEQUEN,
                                pNUMPAR,
                                SubParcela,
                                Usuario_Filial,
                                Usuario_Codigo,
                                'A',
                                agora(),
                                pDATPRX,
                                pVLRDIF,
                                pSUBORI);
           
         ELSIF (Lanca = 0) THEN             /* Quita a compra */
            UPDATE TT_COM
               SET FLGEST = 'Q'
             WHERE (CODFIL,SEQUEN) = ((SELECT CODFIL,SEQUEN
                                         FROM TT_PAG
                                        WHERE CODFIL = pCODFIL
                                          AND SEQUEN = pSEQUEN
                                          AND FLGEST = 'P'
                                                                            
                                          LIMIT 1)
                                       EXCEPT
                                                                             (SELECT CODFIL,SEQUEN
                                          FROM TT_PAG
                                         WHERE CODFIL = pCODFIL
                                           AND SEQUEN = pSEQUEN
                                           AND FLGEST IN ('A','1','2')
                                                                                    
                                           LIMIT 1))
                                                         AND FLGEST = 'A';

         ELSE                               /* Erro nos dados de lancamento */
            RAISE EXCEPTION 'PG-20003 Dados incompletos para lancamento parcial. %' , vComplemento;
         END IF;

      /* Tratamentos referentes ao estorno de uma parcela */
      ELSIF (pFLGEST = 'X') THEN

         /* Valida ou nao o estorno */
         Open DocumentoCancelado(pFILDOP,
                                 pSEQDOP);
         Fetch DocumentoCancelado into bExiste;
         Close DocumentoCancelado;

         IF bExiste = 0 THEN
            RAISE EXCEPTION 'PG-20002 Documento do portador nao foi cancelado. %' , vComplemento;
         END IF;

         /* Cria subparcela */
         /* Verifica se o usuario e valido */
         select * into Logon from DadosLogon();
         IF NOT Logon.Encontrou THEN
            RAISE EXCEPTION 'PG-20001 Usuario nao cadastrado no sistema. %' , vComplemento;
         ELSE
            Usuario_Filial := Logon.FILUSU;
            Usuario_Codigo := Logon.CODUSU;
         END IF;

         /* Verifica se eh possvel passar o valor estornado para uma sub-parcela jah aberta */
         SELECT MIN(TO_NUMBER(SUBPAR))
           INTO SubParcela
           FROM TT_PAG
          WHERE CODFIL = pCODFIL
            AND SEQUEN = pSEQUEN
            AND NUMPAR = pNUMPAR
            AND FLGEST = 'A'
            AND SUBPAR <> pSUBORI;

         IF SubParcela IS NULL THEN
           
           /* Obtem a proxima subparcela */
           Open  ProximaSubparcela(pCODFIL,
                                   pSEQUEN,
                                   pNUMPAR);
           Fetch ProximaSubparcela into SubParcela;
           Close ProximaSubparcela;
           
           /* Insere a subparcela */
           
                      INSERT INTO TT_PAG (CODFIL,
                               SEQUEN,
                               NUMPAR,
                               SUBPAR,
                               FLGEST,
                               DATVEN,
                               DATPGT,
                               ATU_EM,
                               VLRPGT,
                               VLRPAR,
                               FILUSU,
                               CODUSU,
                               VLRDIF,
                               DOCPGT,
                               SUBORI)
                       VALUES (pCODFIL,
                               pSEQUEN,
                               pNUMPAR,
                               Subparcela,
                               'A',
                               CASE WHEN pDATPRX IS NULL THEN pDATVEN
                                    ELSE pDATPGT
                               END,
                               Null,
                               agora(),
                               Null,
                               pVLRPAR - COALESCE(pVLRDIF, 0),
                               Usuario_Filial,
                               Usuario_Codigo,
                               Null,
                               pDOCPGT,
                               pSUBORI);
                    ELSE
                    
           UPDATE TT_PAG
              SET VLRPAR = COALESCE(VLRPAR,0) + COALESCE(pVLRPAR,0) - COALESCE(pVLRDIF,0),
                  ATU_EM = agora()
            WHERE CODFIL = pCODFIL
              AND SEQUEN = pSEQUEN
              AND NUMPAR = pNUMPAR
              AND SUBPAR = LPAD(TRIM(SubParcela),2);
                      
         END IF;

         /* Deixa a compra em aberto */
         UPDATE TT_COM
            SET FLGEST = 'A'
          WHERE CODFIL = pCODFIL
            AND SEQUEN = pSEQUEN
            AND FLGEST NOT IN ('A','D');

      END IF;
      RETURN NULL;

END;
$$ language 'plpgsql';



   CREATE OR REPLACE FUNCTION PC_PRJ_UPDATE (TT_PRJ.CODFIL%TYPE,TT_PRJ.SEQUEN%TYPE,TT_PRJ.FILATU%TYPE,TT_PRJ.CODATU%TYPE,TT_PRJ.FILPAI%TYPE,TT_PRJ.SEQPAI%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCodfil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
pFilusu ALIAS FOR $3 ;
pCodUsu ALIAS FOR $4 ;
pFilpai ALIAS FOR $5 ;
pSeqPai ALIAS FOR $6 ;
      vGERENTE CHAR(1);
      vComplemento CONSTANT VARCHAR(254):= constante('complemento');
   BEGIN
   
      IF (pFilpai is null or pSeqpai is null) THEN 
           SELECT CASE WHEN COALESCE(SUBSTR(PERMISSOESUSUARIO(FILUSU,CODUSU),113,1),'N')='S' OR
                            QUALDONO()=APEUSU THEN 'S' 
                       ELSE 'N' 
                  END INTO vGERENTE
             FROM TT_USU
            WHERE FILUSU=pFILUSU
              AND CODUSU=pCODUSU;
           
           IF vGERENTE='N' THEN 
              RAISE EXCEPTION 'PG-20001 Voce precisa ser administrador de projetos para poder incluir um projeto no nivel principal. %' , VComplemento;
           END IF;           
      ELSE
           IF ChecaPermissao(pFilpai,pSeqpai,pFILUSU,pCODUSU,CONSTANTE('wf_gerenciar')) = 0 THEN 
              RAISE EXCEPTION 'PG-20002 Voce nao tem permissao para incluir projetos. %' , VComplemento;
           END IF;
      END IF;
            
    RETURN NULL;

END;
$$ language 'plpgsql';


   CREATE OR REPLACE FUNCTION PC_PRJXPAP_UPDATE (TT_PRJXPAP.FILPRJ%TYPE,TT_PRJXPAP.SEQPRJ%TYPE,TT_PRJXPAP.FILPAP%TYPE,TT_PRJXPAP.SEQPAP%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFilprj ALIAS FOR $1 ;
pSeqprj ALIAS FOR $2 ;
pFilpap ALIAS FOR $3 ;
pSeqPap ALIAS FOR $4 ;
    vComplemento CONSTANT VARCHAR(254):= constante('complemento');
    Logon  TRetQuemLogou%ROWTYPE;
    pFILUSU TT_USU.FILUSU%TYPE;
    pCODUSU TT_USU.CODUSU%TYPE;
  begin
      select * into Logon from DadosLogon();
      IF Logon.Encontrou THEN
         pFILUSU := Logon.FILUSU;
         pCODUSU := Logon.CODUSU;
      ELSE
         RAISE EXCEPTION 'PG-20001 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
      END IF;
     
      IF ChecaPermissao(pFILPRJ,pSEQPRJ,pFILUSU,pCODUSU,CONSTANTE('wf_gerenciar')) = 0 THEN 
         RAISE EXCEPTION 'PG-20002 Voce nao tem permissao para alterar permissoes deste projeto. %' , VComplemento;
      END IF;
            
    RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 1866 --*/
CREATE OR REPLACE FUNCTION PC_PROxNOM_Atualiza (TT_PRO.TERASS%TYPE,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pWhere ALIAS FOR $1 ;
pFilMat ALIAS FOR $2 ;
pCodMat ALIAS FOR $3 ;
pCodCor ALIAS FOR $4 ;
pCodTam ALIAS FOR $5 ;
  cRet VARCHAR(2);
BEGIN 
      cRet := TRG_Produtos_Nomes(pWhere, pFilMat, pCodMat, pCodCor, pCodTam);

  RETURN NULL;

END;
$$ language 'plpgsql';





    /*-- SEQ 1867 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PC_PTR_TemLanctoParcial (TT_PTR.DATPRX%TYPE,TT_PTR.VLRDIF%TYPE) CASCADE;

/*-- SEQ 1868 --*/
CREATE OR REPLACE FUNCTION PC_PTR_TemLanctoParcial (TT_PTR.DATPRX%TYPE,TT_PTR.VLRDIF%TYPE)
RETURNS INTEGER AS $$
DECLARE
pDATPRX ALIAS FOR $1 ;
pVLRDIF ALIAS FOR $2 ;
    begin

      If (pDATPRX IS NOT NULL) AND COALESCE(pVLRDIF,0) > 0 then
         RETURN 1;
      elsif (pDATPRX IS NULL) AND COALESCE(pVLRDIF,0) = 0 then
         RETURN 0;
      else
         RETURN -1;
      end if;

    END;
$$ language 'plpgsql';


    CREATE OR REPLACE FUNCTION PC_PTR_UPDATE (TT_PTR.CODFIL%TYPE,TT_PTR.SEQUEN%TYPE,TT_PTR.NUMPAR%TYPE,TT_PTR.SUBPAR%TYPE,TT_PTR.FLGEST%TYPE,TT_PTR.DATVEN%TYPE,TT_PTR.DATPGT%TYPE,TT_PTR.DATPRX%TYPE,TT_PTR.VLRPAR%TYPE,TT_PTR.VLRPGT%TYPE,TT_PTR.VLRDIF%TYPE,TT_PTR.VLRDES%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pNUMPAR ALIAS FOR $3 ;
pSUBPAR ALIAS FOR $4 ;
pFLGEST ALIAS FOR $5 ;
pDATVEN ALIAS FOR $6 ;
pDATPGT ALIAS FOR $7 ;
pDATPRX ALIAS FOR $8 ;
pVLRPAR ALIAS FOR $9 ;
pVLRPGT ALIAS FOR $10 ;
pVLRDIF ALIAS FOR $11 ;
pVLRDES ALIAS FOR $12 ;

    Usuario_Filial TT_USU.FILUSU%TYPE;
    Usuario_Codigo TT_USU.CODUSU%TYPE;
    Subparcela     TT_PTR.SUBPAR%TYPE;
    ValorParcela   TT_PTR.VLRPAR%TYPE;
    Regra          INTEGER;
    QtdPaga        INTEGER;
    QtdEmAberto    INTEGER;
    Lanca          INTEGER;
    vComplemento   CONSTANT VARCHAR(100) := constante('complemento');
    Logon          TRetQuemLogou%ROWTYPE;

    ProximaSubparcela CURSOR(pCurFilial TT_PTR.CODFIL%TYPE,
           pCurCodigo TT_PTR.SEQUEN%TYPE,
           pCurParcela TT_PTR.NUMPAR%TYPE) IS
           SELECT cast(MAX(COALESCE(SUBPAR,'0')) as integer)+1 AS SUBPAR
             FROM TT_PTR
            WHERE CODFIL = pCurFilial
              AND SEQUEN = pCurCodigo
              AND NUMPAR = pCurParcela;

    QualRegra CURSOR(pCurFilial TT_PTR.CODFIL%TYPE,
           pCurCodigo TT_PTR.SEQUEN%TYPE,
           pCurParcela TT_PTR.NUMPAR%TYPE) IS
           SELECT QTDPAG,QTDABE
             FROM (SELECT COUNT(FLGEST) AS QTDPAG
                     FROM TT_PTR
                    WHERE CODFIL=pCurFilial
                      AND SEQUEN=pCurCodigo
                      AND NUMPAR=pCurParcela
                      AND FLGEST='P')A,
                  (SELECT COUNT(FLGEST) AS QTDABE
                     FROM TT_PTR
                    WHERE CODFIL=pCurFilial
                      AND SEQUEN=pCurCodigo
                      AND NUMPAR=pCurParcela
                      AND FLGEST='A')B
                  LEFT OUTER JOIN
                  (SELECT COUNT(FLGEST) AS TOTABE
                     FROM TT_PTR
                    WHERE CODFIL=pCurFilial
                      AND SEQUEN=pCurCodigo
                      AND NUMPAR=pCurParcela
                      AND FLGEST='A'
                    GROUP BY FLGEST
                   HAVING COUNT(FLGEST) = 1) C
                  ON (B.QTDABE = C.TOTABE);

   BEGIN

      /* Gera proxima subparcela ou quita o titulo */
      IF (pFLGEST = 'P') THEN

         Lanca := PC_PTR_TemLanctoParcial(pDATPRX,pVLRDIF);

         /* Gera proxima subparcela */
         IF (Lanca = 1) THEN

            /* Cria subparcela */
            /* 1o. Verifica se o usuario e valido */
            select * into Logon from DadosLogon();
            IF NOT Logon.Encontrou THEN
               RAISE EXCEPTION 'PG-20001 Usuario nao cadastrado no sistema. %' , vComplemento;
            ELSE
               Usuario_Filial := Logon.FILUSU;
               Usuario_Codigo := Logon.CODUSU;
            END IF;

            /* 2o. Obtem a proxima subparcela */
            Open  ProximaSubparcela(pCODFIL,
                                    pSEQUEN,
                                    pNUMPAR);
            Fetch ProximaSubparcela into SubParcela;
            Close ProximaSubparcela;

            /* 3o. Insere a subparcela */
                        IF pVLRDIF <> 0 THEN
                INSERT INTO TT_PTR (CODFIL,
                                    SEQUEN,
                                    NUMPAR,
                                    SUBPAR,
                                    FILUSU,
                                    CODUSU,
                                    FLGEST,
                                    ATU_EM,
                                    DATVEN,
                                    VLRPAR)
                            VALUES (pCODFIL,
                                    pSEQUEN,
                                    pNUMPAR,
                                    SubParcela,
                                    Usuario_Filial,
                                    Usuario_Codigo,
                                    'A',
                                    agora(),
                                    pDATPRX,
                                    pVLRDIF);
            END IF;
                     /* Quita o titulo */
         ELSIF (Lanca = 0) THEN
            UPDATE TT_TRC
               SET FLGEST = 'Q'
             WHERE (CODFIL,SEQUEN) = ((SELECT CODFIL,SEQUEN
                                         FROM TT_PTR
                                        WHERE CODFIL = pCODFIL
                                          AND SEQUEN = pSEQUEN
                                          AND FLGEST = 'P'
                                                                            
                                          LIMIT 1)
                                                                              EXCEPT
                                       (SELECT CODFIL,SEQUEN
                                         FROM TT_PTR
                                        WHERE CODFIL = pCODFIL
                                          AND SEQUEN = pSEQUEN
                                          AND FLGEST IN ('A','1','2')
                                                                            
                                          LIMIT 1))
                                                     AND FLGEST = 'A';

         /* Erro nos dados de lancamento */
         ELSE
            RAISE EXCEPTION 'PG-20003 Dados incompletos para lancamento parcial. %' , vComplemento;
         END IF;
         /*Tratamentos referentes ao estorno de uma parcela */
      ELSIF (pFLGEST = 'X') THEN

         /* Cria subparcela */
         /* 1o. Verifica se o usuario e valido */
         select * into Logon from DadosLogon();
         IF NOT Logon.Encontrou THEN
            RAISE EXCEPTION 'PG-20001 Usuario nao cadastrado no sistema. %' , vComplemento;
         ELSE
            Usuario_Filial := Logon.FILUSU;
            Usuario_Codigo := Logon.CODUSU;
         END IF;

         /* 2o. Obtem a proxima subparcela */
         Open  ProximaSubparcela(pCODFIL,
                                 pSEQUEN,
                                 pNUMPAR);
         Fetch ProximaSubparcela into SubParcela;
         Close ProximaSubparcela;


         /* 3o. Descobre a regra */
         Open  QualRegra(pCODFIL,
                         pSEQUEN,
                         pNUMPAR);
         Fetch QualRegra into QtdPaga,QtdEmAberto;
         Close QualRegra;

         IF    (QtdPaga = 1) AND (QtdEmAberto = 0) THEN
            Regra := 1;
         ELSIF (QtdPaga > 1) AND (QtdEmAberto = 0) THEN
            Regra := 2;
         ELSIF (QtdPaga = 1) AND (QtdEmAberto = 1) THEN
            Regra := 3;
         ELSIF (QtdPaga > 1) AND (QtdEmAberto > 1) THEN
            Regra := 4;
         ELSE
            Regra := 0;
         END IF;

         IF pFLGEST = 'X' THEN
            Regra := 3;
         END IF;

         ValorParcela := pVLRPGT - COALESCE(pVLRDES,0);

         /* 4o. Insere a subparcela */
                  IF (Regra IN (1,2) AND pVLRPAR <> 0) OR (REGRA NOT IN (1,2) AND ValorParcela<>0) THEN
             INSERT INTO TT_PTR (CODFIL,
                                 SEQUEN,
                                 NUMPAR,
                                 SUBPAR,
                                 FLGEST,
                                 DATVEN,
                                 DATPGT,
                                 ATU_EM,
                                 VLRPGT,
                                 VLRPAR,
                                 FILUSU,
                                 CODUSU,
                                 VLRDIF)
                         VALUES (pCODFIL,
                                 pSEQUEN,
                                 pNUMPAR,
                                 Subparcela,
                                 'A',
                                 CASE Regra WHEN 1 THEN pDATVEN
                                            WHEN 2 THEN pDATVEN
                                            WHEN 3 THEN pDATVEN
                                                   ELSE pDATPGT
                                 END,
                                 Null,
                                 agora(), 
                                 Null,
                                 CASE Regra WHEN 1 THEN pVLRPAR
                                            WHEN 2 THEN pVLRPAR
                                            ELSE        ValorParcela
                                 END,
                                 Usuario_Filial,
                                 Usuario_Codigo,
                                 Null);
         END IF;
         
         /* Deixa a compra em aberto */
         UPDATE TT_TRC
            SET FLGEST = 'A'
          WHERE CODFIL = pCODFIL
            AND SEQUEN = pSEQUEN
            AND FLGEST NOT IN ('A','C');
      END IF;
     RETURN NULL;

END;
$$ language 'plpgsql';



/*-- SEQ 1869 --*/

      CREATE OR REPLACE FUNCTION PC_REC_UPDATE (TT_VEN.CODFIL%TYPE,TT_VEN.SEQUEN%TYPE,TT_VEN.DUMMY%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pDUMMY ALIAS FOR $3 ;
      /* Solicita a quitao da venda, se possivel */
      BEGIN
      UPDATE TT_VEN
         SET FLGEST = 'Y',
             DUMMY = COALESCE(pDUMMY,CONSTANTE('VEM_DE_PCREC'))
       WHERE CODFIL = pCODFIL
         AND SEQUEN = pSEQUEN
         AND FLGEST <> 'I';
        RETURN NULL;

END;
$$ language 'plpgsql';



/*-- SEQ 1870 --*/
    
    CREATE OR REPLACE FUNCTION PC_REC_CASCADE_DATA (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE,TT_REC.ATU_EM%TYPE,TT_REC.DUMMY%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFilial ALIAS FOR $1 ;
pCodigo ALIAS FOR $2 ;
pParcela ALIAS FOR $3 ;
pSubpar ALIAS FOR $4 ;
pData ALIAS FOR $5 ;
pDUMMY ALIAS FOR $6 ;
         SupCobrancas CURSOR(pCODFIL TT_REC.CODFIL%TYPE,
           pSEQUEN TT_REC.SEQUEN%TYPE) IS
         SELECT SUP.CODFIL,SUP.SEQUEN
           FROM TT_REC REC INNER JOIN TT_COB COB ON REC.CODFIL = COB.FILREC
                                                AND REC.SEQUEN = COB.SEQREC
                                                AND REC.NUMPAR = COB.NUMPAR
                                                AND REC.SUBPAR = COB.SUBPAR
                           INNER JOIN TT_SUP SUP ON COB.FILSUP=SUP.CODFIL
                                                AND COB.SEQSUP=SUP.SEQUEN
         WHERE SUP.SITUAC='A'
           AND REC.CODFIL=pCODFIL
           AND REC.SEQUEN=pSEQUEN;    
           
         cCODFIL TT_SUP.CODFIL%TYPE;
         cSEQUEN TT_SUP.SEQUEN%TYPE;

    BEGIN
    
     IF pDUMMY='S' THEN -- Trata Subcobrancas
              OPEN SupCobrancas(pFilial,pCodigo);
              LOOP
                FETCH SupCobrancas INTO cCODFIL,cSEQUEN;
                EXIT WHEN NOT FOUND;
                   UPDATE TT_SUP
                      SET SITUAC = 'R'
                    WHERE CODFIL = cCODFIL
                      AND SEQUEN = cSEQUEN
                      AND (SELECT SUM( CASE WHEN COB.FILREC IS NOT NULL THEN 
                                           CASE WHEN REC.FLGEST = 'A' THEN 1 
                                                                      ELSE 0 
                                           END
                                       ELSE CASE WHEN CHR.FLGEST = 'D' THEN 1 
                                                                       ELSE 0 
                                            END
                                       END)
                             FROM TT_COB COB LEFT OUTER JOIN TT_REC REC ON REC.CODFIL = COB.FILREC
                                                                       AND REC.SEQUEN = COB.SEQREC
                                                                       AND REC.NUMPAR = COB.NUMPAR
                                                                       AND REC.SUBPAR = COB.SUBPAR
                                             LEFT OUTER JOIN TT_CHR CHR ON COB.FILCHR = CHR.CODFIL
                                                                       AND COB.SEQCHR = CHR.SEQUEN
                            WHERE COB.FILSUP = TT_SUP.CODFIL
                              AND COB.SEQSUP = TT_SUP.SEQUEN
                            GROUP BY COB.FILSUP, COB.SEQSUP) = 0; 
                
              END LOOP;
              CLOSE SupCobrancas;
     ELSE -- Trata update cascade de atu_em
          IF pParcela IS NOT NULL THEN 
    
              IF pDUMMY<>constante('vem_de_tgven') THEN 
                  UPDATE TT_VEN 
                     SET ATU_EM = pData,
                         DUMMY=constante('VEM_DE_PCRECCAS')
                   WHERE CODFIL = pFilial
                     AND SEQUEN = pCodigo;
              END IF;
             
/* desativado
              UPDATE TT_REC 
                 SET ATU_EM = pData,
                     DUMMY  = constante('VEM_DE_PCRECCAS')
               WHERE CODFIL = pFilial
                 AND SEQUEN = pCodigo
                 AND NUMPAR = pParcela
                 AND SUBPAR <> coalesce(pSubpar,'nulo')
                 AND FLGEST not in ('C','X')
                 AND ATU_EM <> pData;
          ELSE
              UPDATE TT_REC 
                 SET ATU_EM = pData,
                     DUMMY  = constante('VEM_DE_PCRECCAS')
               WHERE CODFIL = pFilial
                 AND SEQUEN = pCodigo
                 AND FLGEST not in ('C','X')
                 AND ATU_EM <> pData;

*/

         END IF;
     END IF;
      RETURN NULL;

END;
$$ language 'plpgsql';





    CREATE OR REPLACE FUNCTION PC_RECF_UPDATE (TT_ECF.CODFIL%TYPE,TT_ECF.NUMECF%TYPE,TT_ECF.DATOPE%TYPE,TT_ECF.CNT_RO%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pNUMECF ALIAS FOR $2 ;
pDATOPE ALIAS FOR $3 ;
pCNT_RO ALIAS FOR $4 ;
      wk_CONTATT   Numeric(5);
      wk_CONTATR   Numeric(5);

      cr_RECF CURSOR(pCurFilial TT_ECF.CODFIL%TYPE,
           pCurNumEcf TT_ECF.NUMECF%TYPE,
           pCurDatOpe TT_ECF.DATOPE%TYPE,
           pCnt_Ro TT_ECF.CNT_RO%TYPE) IS
        SELECT ECF.CODFIL, ECF.NUMECF, ECF.CNT_RZ, ECF.CNT_RO, MAX(ECF.DATOPE) AS DATOPE,
               -- MN - 101816
			   COALESCE(nvlz(MAX(ANT.CNTOPE),-1) + 1,0) AS CUPINI,   MAX(ECF.CNTOPE) AS CUPFIM,
               COALESCE(MAX(ANT.VLR_GT),0) AS GT_INI,   MAX(ECF.CODSER) AS CODSER,
               MAX(ECF.VLR_GT) AS GT_FIM, MIN(ECF.ATU_EM) AS DATFEC
          FROM (SELECT CODFIL,NUMECF,CNT_RZ, CNT_RO, MAX(TRUNC(DATOPE)) AS DATOPE,
                       MAX(CNTOPE) AS CNTOPE, MAX(VLR_GT) AS VLR_GT, MAX(CODSER) AS CODSER,
                       MIN(ATU_EM) AS ATU_EM
                  FROM TT_ECF
                 WHERE CODFIL = pCurFilial
                   AND NUMECF = pCurNumEcf
                   AND TRUNC(DATOPE) = trunc(pCurDatOpe)
                   AND CNT_RO = pCnt_Ro
                 GROUP BY CODFIL,NUMECF,CNT_RZ,CNT_RO) ECF
               LEFT JOIN
               (SELECT CODFIL,NUMECF,CNT_RZ + 1 AS CNT_RZ, CNT_RO, MAX(CNTOPE) AS CNTOPE,
                       MAX(VLR_GT) AS VLR_GT, MAX(CODSER) AS CODSER
                  FROM TT_ECF
                 WHERE CODFIL = pCurFilial
                   AND NUMECF = pCurNumEcf
                   AND CNT_RO = pCnt_Ro
                 GROUP BY CODFIL,NUMECF,CNT_RZ,CNT_RO) ANT
               ON (ECF.CODFIL = ANT.CODFIL AND ECF.NUMECF = ANT.NUMECF AND ECF.CNT_RZ = ANT.CNT_RZ AND ECF.CNT_RO = ANT.CNT_RO)
         GROUP BY ECF.CODFIL, ECF.NUMECF, ECF.CNT_RZ, ECF.CNT_RO;
            
        i  RECORD;
          BEGIN

      -- Conta registros em TT_ECF
      SELECT COUNT(*) INTO WK_CONTATT
        FROM TT_ECF
       WHERE CODFIL = pCODFIL
         AND NUMECF = pNUMECF
         AND TRUNC(DATOPE) = TRUNC(pDATOPE)
         AND CNT_RO = pCNT_RO;

      -- conta Registros em TR_ECF
      SELECT COUNT(*) INTO WK_CONTATR
        FROM TR_ECF
       WHERE CODFIL = pCODFIL
         AND NUMECF = pNUMECF
         AND TRUNC(DATOPE) = TRUNC(pDATOPE)
         AND CNT_RO = pCNT_RO;

      IF wk_CONTATT > 0 THEN
                    -- Existe TT_ECF.
           IF wk_CONTATR > 0 THEN
              -- EXISTE TR_ECF. Atualiza
              -- s retorna uma LINHA!!!!!
              OPEN cr_RECF(pCODFIL,pNUMECF,pDATOPE,pCNT_RO);
              LOOP
                FETCH cr_RECF into i;
                EXIT WHEN NOT FOUND;
                UPDATE TR_ECF
                   SET CODFIL = i.CODFIL,
                       NUMECF = i.NUMECF,
                       DATOPE = i.DATOPE,
                       CUPINI = i.CUPINI,
                       CUPFIM = i.CUPFIM,
                       CNT_RZ = i.CNT_RZ,
                       GT_INI = i.GT_INI,
                       GT_FIM = i.GT_FIM,
                       --DATFEC = i.DATFEC,
		               CODSER = rtrim(i.CODSER),
                       CNT_RO = i.CNT_RO
                 WHERE CODFIL = pCODFIL
                   AND NUMECF = pNUMECF
                   AND DATOPE = TRUNC(pDATOPE)
                   AND CNT_RO = pCNT_RO;
              END LOOP;
              CLOSE cr_RECF;
           ELSE
              -- No existe TR_ECF. Insere
              OPEN cr_RECF(pCODFIL,pNUMECF,pDATOPE,pCNT_RO);
              LOOP
                FETCH cr_RECF into i;
                EXIT WHEN NOT FOUND;
                INSERT INTO TR_ECF
                            (CODFIL, NUMECF, DATOPE,
                             CUPINI, CUPFIM, CNT_RZ,
                             GT_INI, GT_FIM, DATFEC, CODSER, CNT_RO)
                     SELECT  i.CODFIL, i.NUMECF, i.DATOPE,
                             i.CUPINI, i.CUPFIM, i.CNT_RZ,
                             i.GT_INI, i.GT_FIM, i.DATFEC, rtrim(i.CODSER), i.CNT_RO FROM DUAL;
              END LOOP;
              CLOSE cr_RECF;
           END IF;
              END IF;

      RETURN NULL;

END;
$$ language 'plpgsql';





    CREATE OR REPLACE FUNCTION PC_RECF_PLUS_UPDATE (TR_ECF.CODFIL%TYPE,TR_ECF.NUMECF%TYPE,TR_ECF.DATOPE%TYPE,TR_ECF.CUPINI%TYPE,TR_ECF.CUPFIM%TYPE,TR_ECF.CNT_RZ%TYPE,TR_ECF.GT_INI%TYPE,TR_ECF.GT_FIM%TYPE,TR_ECF.DATFEC%TYPE,TR_ECF.CODSER%TYPE,TR_ECF.CNT_RO%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pNUMECF ALIAS FOR $2 ;
pDATOPE ALIAS FOR $3 ;
pCUPINI ALIAS FOR $4 ;
pCUPFIM ALIAS FOR $5 ;
pCNT_RZ ALIAS FOR $6 ;
pGT_INI ALIAS FOR $7 ;
pGT_FIM ALIAS FOR $8 ;
pDATFEC ALIAS FOR $9 ;
pCODSER ALIAS FOR $10 ;
pCNT_RO ALIAS FOR $11 ;
        vMotivo       TR_ECF.OBSERV%TYPE := '';
    vMotivoFiscal TR_ECF.OBSERV%TYPE := '';
    cDummy        VARCHAR(2);

    BEGIN
      -- Tenta fechar um dia especifico
      vMotivo := DiaFechado(pCODFIL,pNUMECF,pDATOPE,pCNT_RO,'T');
      IF isnull(vMotivo) = 'T' THEN
        
       	 

      ELSE
        UPDATE TR_ECF
           SET DIAFEC = NULL,
               OBSERV = vMotivo
         WHERE CODFIL = pCODFIL
           AND NUMECF = pNUMECF
           AND DATOPE = pDATOPE
           AND CODSER = PCODSER
           AND CNT_RO = PCNT_RO;
      END IF;

      RETURN NULL;

END;
$$ language 'plpgsql';





/*-- SEQ 1871 --*/
CREATE OR REPLACE FUNCTION PC_TEF_Atualize (TT_TEF.CODFIL%TYPE,TT_TEF.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCodFil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
  cDUMMY             CHAR(10);
  nNUMITE TT_ITF.NUMITE%TYPE;
  
  cr_Items CURSOR FOR
     SELECT NUMITE
       FROM TT_ITF
      where CODFIL=pCODFIL
        AND SEQUEN=pSEQUEN;
  
BEGIN
    OPEN cr_Items;
    LOOP 
      FETCH cr_Items INTO nNUMITE;
      EXIT WHEN NOT FOUND;    
         cDUMMY:=INSERE_LFIN_LAN('TEF',pCodfil,pSequen,to_char(nNUMITE),'--');
    END LOOP;
    CLOSE cr_Items;
  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1872 --*/

CREATE OR REPLACE FUNCTION PC_TRA_Update (TT_TRA.FILIVE%TYPE,TT_TRA.SEQIVE%TYPE,TT_TRA.NUMIVE%TYPE,TT_TRA.FILICO%TYPE,TT_TRA.SEQICO%TYPE,TT_TRA.NUMICO%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILIVE ALIAS FOR $1 ;
pSEQIVE ALIAS FOR $2 ;
pNUMIVE ALIAS FOR $3 ;
pFILICO ALIAS FOR $4 ;
pSEQICO ALIAS FOR $5 ;
pNUMICO ALIAS FOR $6 ;
-- Objetivos:
-- 1. Esta package foi criada pois aqui  feita consulta na TT_TRA para obter a nota de devoluo 
--    e atualizar o custo da TT_ICO com o valor da origem (sada por transferncia)
   nVLR_CM_ORI                   TT_ICO.VLR_CM%TYPE;
   nVLR_CMG_ORI                  TT_ICO.VLRCMG%TYPE;   
   vVem_de_TRA                   CONSTANT VARCHAR(1) := constante('vem_de_tgtra');  
	nBASICM_CM_ORI						TT_ICO.BASICM_CM%TYPE; 
	nVLRICM_CM_ORI						TT_ICO.VLRICM_CM%TYPE; 
	nBAS_ST_CM_ORI						TT_ICO.BAS_ST_CM%TYPE;
	nVLR_ST_CM_ORI						TT_ICO.VLR_ST_CM%TYPE;
BEGIN
         SELECT TAB.VLR_CM AS VLR_CM_ORI, TAB.VLR_CMG AS VLR_CMG, TAB.BASICM_CM, TAB.VLRICM_CM, TAB.BAS_ST_CM, TAB.VLR_ST_CM
        INTO nVLR_CM_ORI, nVLR_CMG_ORI, nBASICM_CM_ORI, nVLRICM_CM_ORI, nBAS_ST_CM_ORI, nVLR_ST_CM_ORI
        FROM (
               SELECT ABS(IVE.VLR_CM / CASE WHEN IVE.QTD_CM IS NULL OR IVE.QTD_CM = 0 THEN 1 ELSE IVE.QTD_CM END ) AS VLR_CM,
                      ABS(IVE.VLRCMG / CASE WHEN IVE.QTD_CM IS NULL OR IVE.QTD_CM = 0 THEN 1 ELSE IVE.QTD_CM END ) AS VLR_CMG,
							 ABS(IVE.BASICM_CM / CASE WHEN IVE.QTD_CM IS NULL OR IVE.QTD_CM = 0 THEN 1 ELSE IVE.QTD_CM END ) AS BASICM_CM,
							 ABS(IVE.VLRICM_CM / CASE WHEN IVE.QTD_CM IS NULL OR IVE.QTD_CM = 0 THEN 1 ELSE IVE.QTD_CM END ) AS VLRICM_CM,
							 ABS(IVE.BAS_ST_CM / CASE WHEN IVE.QTD_CM IS NULL OR IVE.QTD_CM = 0 THEN 1 ELSE IVE.QTD_CM END ) AS BAS_ST_CM,
							 ABS(IVE.VLR_ST_CM / CASE WHEN IVE.QTD_CM IS NULL OR IVE.QTD_CM = 0 THEN 1 ELSE IVE.QTD_CM END ) AS VLR_ST_CM,
							 ABS(IVE_DEV.QTD_CM) AS QTD_CM
                 FROM TT_IVE IVE_DEV
                 JOIN TT_ICO ENT ON IVE_DEV.FILICOORI = ENT.CODFIL AND IVE_DEV.SEQICOORI = ENT.SEQUEN AND IVE_DEV.NUMICOORI = ENT.NUMITE -- NOTA ORIGEM DEVOLUO
                 JOIN TT_TRA TRA_ENT ON TRA_ENT.FILICO=ENT.CODFIL AND TRA_ENT.SEQICO = ENT.SEQUEN AND TRA_ENT.NUMICO = ENT.NUMITE 
                 JOIN TT_IVE IVE ON TRA_ENT.FILIVE = IVE.CODFIL AND TRA_ENT.SEQIVE = IVE.SEQUEN AND TRA_ENT.NUMIVE = IVE.NUMITE -- NOTA DEVOLUO DE ORIGEM  
                WHERE IVE_DEV.CODFIL = pFILIVE
                  AND IVE_DEV.SEQUEN = pSEQIVE
                  AND IVE_DEV.NUMITE = pNUMIVE) TAB;
   
   IF (COALESCE(nVLR_CM_ORI,0) <> 0) THEN
      UPDATE TT_ICO
         SET VLR_CM = (nVLR_CM_ORI * QTD_CM),
             VLRCMG = (nVLR_CMG_ORI * QTD_CM),
				 BASICM_CM = (nBASICM_CM_ORI * QTD_CM),
				 VLRICM_CM = (nVLRICM_CM_ORI * QTD_CM),
				 BAS_ST_CM = (nBAS_ST_CM_ORI * QTD_CM),
				 VLR_ST_CM = (nVLR_ST_CM_ORI * QTD_CM),
             DUMMY = vVem_de_TRA
       WHERE CODFIL = pFILICO
         AND SEQUEN = pSEQICO
         AND NUMITE = pNUMICO;
   END IF;

  RETURN NULL;

END;
$$ language 'plpgsql';



   CREATE OR REPLACE FUNCTION PC_USU_UPDATE (TT_USU.APEUSU%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pAPEUSU ALIAS FOR $1 ;
     vPermis char(1);
     vNIVUSU TT_USU.NIVUSU%TYPE;
   BEGIN

       SELECT CASE WHEN (SUBSTR(PERMISSOESUSUARIO(FILUSU,CODUSU),4,1)  = 'S'
                      OR SUBSTR(PERMISSOESUSUARIO(FILUSU,CODUSU),74,1) = 'S') THEN 'S'
                                                                                           ELSE 'N'
              END AS PERMIS,
              NIVUSU INTO vPermis,vNIVUSU
          FROM TT_USU
         WHERE APEUSU=pAPEUSU;
     IF vPERMIS='N' OR vNIVUSU<>0 THEN
        RAISE EXCEPTION 'PG-20030 Usuario sem permissao para realizar alteracao. ';
     END IF;
    RETURN NULL;

END;
$$ language 'plpgsql';






      CREATE OR REPLACE FUNCTION PC_VEN_UPDATE (TT_IVE.CODFIL%TYPE,TT_IVE.SEQUEN%TYPE,TT_IVE.DUMMY%TYPE,TT_CLI.TOTPAR%TYPE,TT_CLI.TOTATR%TYPE,TT_IVE.ESTORN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pDUMMY ALIAS FOR $3 ;
pTOTPAR ALIAS FOR $4 ;
pTOTATR ALIAS FOR $5 ;
pESTORN ALIAS FOR $6 ;
      BEGIN
        IF pDUMMY IS NULL THEN

           /* Cancela vinculo de faturamento */
           UPDATE TT_VEN
              SET SEQFAT = NULL,
                  NROIMP = 0
            WHERE (CODFIL,SEQFAT) IN (SELECT CODFIL,SEQUEN
                                        FROM TT_VEN
                                       WHERE CODFIL = pCODFIL
                                         AND SEQUEN = pSEQUEN);

           /* Cancela vnculo com NF de Transferncia de Saldo Credor de ICMS */
           UPDATE TT_VEN
              SET FILCRE = NULL,
                  SEQCRE = NULL
            WHERE (FILCRE, SEQCRE) IN (SELECT CODFIL,SEQUEN
                                         FROM TT_VEN
                                        WHERE CODFIL = pCODFIL
                                          AND SEQUEN = pSEQUEN);
        ELSE

          /* Atualiza total de parcelas */
          UPDATE TT_CLI SET TOTPAR = TOTPAR - COALESCE(pTOTPAR,0),
                            TOTATR = TOTATR - COALESCE(pTOTATR,0)
           WHERE (FILCLI,CODCLI) = (SELECT FILCLI,CODCLI
                                        FROM TT_VEN
                                       WHERE CODFIL = pCODFIL
                                         AND SEQUEN = pSEQUEN);
           /* Cancela item da nota */
           UPDATE TT_IVE
              SET SITMOV='C',
                  ESTORN= pESTORN,
                  DUMMY = pDUMMY
            WHERE SEQUEN = pSEQUEN
              AND CODFIL = pCODFIL
              AND SITMOV <> 'C';

        END IF;
        RETURN NULL;

END;
$$ language 'plpgsql';

      CREATE OR REPLACE FUNCTION PC_VEN_DEVOLUCAO (TT_DEVxREC.FILDEV%TYPE,TT_DEVxREC.SEQDEV%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILDEV ALIAS FOR $1 ;
pSEQDEV ALIAS FOR $2 ;
        -- Cursor das parcelas ligadas a devolucao de mercadorias
        DEVOLVE CURSOR(pFILDEV TT_DEVxREC.FILDEV%TYPE,
           pSEQDEV TT_DEVxREC.SEQDEV%TYPE) IS
        select B.*
          from TT_DEVxREC A inner join TT_REC B ON B.CODFIL = A.FILREC
                                               and B.SEQUEN = A.SEQREC
                                               and B.NUMPAR = A.PARREC
                                               and B.SUBPAR = A.SUBREC
                                               and B.FLGEST not in ('C','X')
        where A.FILDEV = pFILDEV
          and A.SEQDEV = pSEQDEV;

                
          ind RECORD;
              BEGIN
        -- Estornar parcelas ligadas a devolucao de mercadorias
        OPEN DEVOLVE(pFILDEV,pSEQDEV);
        LOOP
          FETCH DEVOLVE INTO ind;
          EXIT WHEN NOT FOUND;

          -- Estornando recebimentos
          UPDATE TT_REC SET FLGEST = 'X',
                             DUMMY = constante('vem_de_tgven')
           WHERE CODFIL = ind.CODFIL
             AND SEQUEN = ind.SEQUEN
             AND NUMPAR = ind.NUMPAR
             AND SUBPAR = ind.SUBPAR;

          -- Evita a insero de uma parcela zerada
          IF COALESCE(ind.VLRPGT,0)-COALESCE(ind.VLRDES,0) > 0 THEN
            -- Criando parcelas
            INSERT INTO TT_REC (CODFIL
                               ,SEQUEN
                               ,NUMPAR
                               ,SUBPAR
                               ,SUBORI
                               ,FLGEST
                               ,DATVEN
                               ,CUPFIS
                               ,VLRPAR
                               ,FILUSU
                               ,CODUSU
                               ,PORTAD
                               ,CODMOE
                               ,SIGNAT
                               ,DUMMY)
                        VALUES (ind.CODFIL
                               ,ind.SEQUEN
                               ,ind.NUMPAR
                               ,ProximaSubparcela(ind.CODFIL,ind.SEQUEN,ind.NUMPAR)
                               ,ind.SUBPAR
                               ,'A'
                               ,ind.DATVEN
                               ,ind.CUPFIS
                               ,COALESCE(ind.VLRPGT,0)-COALESCE(ind.VLRDES,0)
                               ,ind.FILUSU
                               ,ind.CODUSU
                               ,ind.PORTAD
                               ,ind.CODMOE
                               ,ind.SIGNAT
                               ,constante('vem_de_tgven'));
          END IF;
        END LOOP;
        CLOSE DEVOLVE;
        RETURN NULL;

END;
$$ language 'plpgsql';

	  CREATE OR REPLACE FUNCTION PC_VEN_DEVOLUCAO_CMS (TT_VEN.CODFIL%TYPE,TT_VEN.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;

        DEVOLVE_CMS CURSOR(pCODFIL TT_VEN.CODFIL%TYPE,
           pSEQUEN TT_VEN.SEQUEN%TYPE) IS

		SELECT DISTINCT VDD.*
          FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL
                                               AND IVE.SEQUEN = VEN.SEQUEN
                          INNER JOIN TT_VDD VDD ON VDD.FILVEN = IVE.FILORI
			                                   AND VDD.SEQVEN = IVE.NUMORI
         WHERE IVE.CODFIL = pCODFIL
           AND IVE.SEQUEN = pSEQUEN
           AND (VDD.FILVDD, VDD.CODVDD, VDD.TIPVDD) NOT IN
               (SELECT TT_VDD.FILVDD, TT_VDD.CODVDD, TT_VDD.TIPVDD
                  FROM TT_VDD
                 WHERE TT_VDD.FILVEN = pCODFIL
                   AND TT_VDD.SEQVEN = pSEQUEN);

                
          vdd RECORD;
              BEGIN
        OPEN DEVOLVE_CMS(pCODFIL,pSEQUEN);
        LOOP
          FETCH DEVOLVE_CMS INTO vdd;
          EXIT WHEN NOT FOUND;

          -- Criando parcelas
          INSERT INTO TT_VDD (CODFIL
                             ,FILPED
                             ,TIPPED
                             ,NUMPED
                             ,FILVEN
                             ,SEQVEN
                             ,FILVDD
                             ,CODVDD
                             ,TIPVDD)
                      VALUES (vdd.CODFIL
                             ,vdd.FILPED
                             ,vdd.TIPPED
                             ,vdd.NUMPED
                             ,pCODFIL
                             ,pSEQUEN
                             ,vdd.FILVDD
                             ,vdd.CODVDD
                             ,vdd.TIPVDD);
        END LOOP;
        CLOSE DEVOLVE_CMS;
        RETURN NULL;

END;
$$ language 'plpgsql';



      
      CREATE OR REPLACE FUNCTION PC_WOR_UPDATE (TT_WOR.CODFIL%TYPE,TT_WOR.SEQUEN%TYPE,TT_WOR.FLGSIT%TYPE,TT_WOR.FILPED%TYPE,TT_WOR.TIPPED%TYPE,TT_WOR.NUMPED%TYPE,TT_WOR.ITEPED%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pFLGSIT ALIAS FOR $3 ;
pFILPED ALIAS FOR $4 ;
pTIPPED ALIAS FOR $5 ;
pNUMPED ALIAS FOR $6 ;
pITEPED ALIAS FOR $7 ;

         nQTDWOR_EXE INTEGER;
         nQTDWOR_ABE INTEGER;
	 cEMAIL_FROM TT_USU.E_MAIL%TYPE;
         cEMAIL_TO TT_USU.E_MAIL%TYPE;
	 filial TT_USU.FILUSU%TYPE;
         usuario TT_USU.CODUSU%TYPE;
         QuemLogou TRetQuemLogou;
         cFILCLI TT_CLI.FILCLI%TYPE;
	 cCODCLI TT_CLI.CODCLI%TYPE;
	 CNOMCLI TT_CLI.NOMCLI%TYPE;
	 nJA_ENV  INTEGER;

      BEGIN
       IF pFLGSIT IS NULL THEN 
            /* Delete cascade */
            DELETE FROM TL_WOR
             WHERE CODFIL = pCODFIL
               AND SEQUEN = pSEQUEN;
	ELSE
            SELECT COUNT(*) INTO nQTDWOR_EXE
              FROM TT_WOR WOR INNER JOIN TD_SIT SIT ON WOR.FLGSIT=SIT.CODTAB
             WHERE WOR.FILPED=pFILPED
	       AND WOR.TIPPED=pTIPPED
               AND WOR.NUMPED=pNUMPED
	       AND SIT.TIPSIT IN ('X','1');
            
            SELECT COUNT(*) INTO nQTDWOR_ABE
              FROM TT_WOR WOR INNER JOIN TD_SIT SIT ON WOR.FLGSIT=SIT.CODTAB
             WHERE WOR.FILPED=pFILPED
	       AND WOR.TIPPED=pTIPPED
               AND WOR.NUMPED=pNUMPED
	       AND SIT.TIPSIT='A';

           -- Todas as tarefas esto executadas ( podem ter tarefas canceladas )
	   IF nQTDWOR_EXE >0 and nQTDWOR_ABE=0 THEN 
              SELECT USU.E_MAIL, CLI.FILCLI, CLI.CODCLI, CLI.NOMCLI into cEMAIL_TO, cFILCLI, cCODCLI, cNOMCLI
                FROM TT_ORC ORC INNER JOIN TT_USU USU ON ORC.FILVEN=USU.FILUSU AND ORC.CODVEN=USU.CODUSU 
                                INNER JOIN TT_CLI CLI ON ORC.FILCLI=CLI.FILCLI AND ORC.CODCLI=CLI.CODCLI
  	       WHERE CODFIL=pFILPED
	         AND TIPPED=pTIPPED
		 AND NUMPED=pNUMPED;

              SELECT COUNT(*) INTO nJA_ENV
   	        FROM TT_MAI
	       WHERE FILCLI=cFILCLI
	         AND CODCLI=cCODCLI
		 AND ASSUNT='[Concluso OS] Referente OS: '||pNUMPED
		 AND TRUNC(DATSOL)=TRUNC(AGORA);

	      -- Pegando o E_mail do usurio Logado!!
               select * into QuemLogou from DadosLogon();
               IF QuemLogou.Encontrou THEN
                  filial:=QuemLogou.filusu;
                  usuario:=QuemLogou.codusu;
                  cEMAIL_FROM := PegaE_Mail(Filial,Usuario);
               END IF;

	       IF cEMAIL_TO IS NOT NULL AND cEMAIL_FROM IS NOT NULL AND nJA_ENV=0 THEN
                  INSERT into TT_MAI 
                  (DATSOL, EXCLUI, ANEXOS, MAI_TO, MAI_CC, MAI_CB, MAI_FR, TEXTOS, ASSUNT, FILCLI, CODCLI)
                   VALUES 
                  (agora(), 'F', null, cEMAIL_TO, null, null, cEMAIL_FROM, 'Ordem de servio '||pNUMPED||' concluda. '||CHR(10)||'Favor comunicar ao cliente: '||cNOMCLI ,
                   '[Concluso OS] Referente OS: '||pNUMPED , cFILCLI, cCODCLI);
	        END IF;

	   END IF;

	END IF;
        RETURN NULL;

END;
$$ language 'plpgsql';



/*-- SEQ 1873 --*/


    CREATE OR REPLACE FUNCTION PC_IVEXIPE_PLUS_UPDATE (TT_IVEXIPE.CODFIL%TYPE,TT_IVEXIPE.SEQUEN%TYPE,TT_IVEXIPE.FILMAT%TYPE,TT_IVEXIPE.CODMAT%TYPE,TT_IVEXIPE.CODCOR%TYPE,TT_IVEXIPE.CODTAM%TYPE,TT_IVEXIPE.QTDENC%TYPE,TT_IVEXIPE.FLGEST%TYPE,TT_IOR.CODMUL%TYPE,TT_IVEXIPE.FILIVE%TYPE,TT_IVEXIPE.SEQIVE%TYPE,TT_IVEXIPE.NUMIVE%TYPE,TT_IVEXIPE.FILLOT%TYPE,TT_IVEXIPE.SEQLOT%TYPE,TT_IVEXIPE.FLGEST%TYPE,TT_IVEXIPE.FILICO%TYPE,TT_IVEXIPE.SEQICO%TYPE,TT_IVEXIPE.NUMICO%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pFILMAT ALIAS FOR $3 ;
pCODMAT ALIAS FOR $4 ;
pCODCOR ALIAS FOR $5 ;
pCODTAM ALIAS FOR $6 ;
pQTDENC ALIAS FOR $7 ;
pFLGEST ALIAS FOR $8 ;
pCODMUL ALIAS FOR $9 ;
pFILIVE ALIAS FOR $10 ;
pSEQIVE ALIAS FOR $11 ;
pNUMIVE ALIAS FOR $12 ;
pFILLOT ALIAS FOR $13 ;
pSEQLOT ALIAS FOR $14 ;
pOldFLGEST ALIAS FOR $15 ;
pFILICO ALIAS FOR $16 ;
pSEQICO ALIAS FOR $17 ;
pNUMICO ALIAS FOR $18 ;
    cDummy          VARCHAR(2);
    vComplemento    constant VARCHAR(100) := constante('complemento');
    bGRAVA_NFT      BOOLEAN;
    bCANCELA_NFT    BOOLEAN;
    cSeqven         TT_VEN.SEQUEN%TYPE;
    cSeqcom         TT_COM.SEQUEN%TYPE;
    nCusrep         TT_GRA.CUSREP%TYPE;
  Begin
      -- MN - Transferncia automtica somente executa se estiver parametrizado 
      IF LeParametroBoo('USA_TRANS_AUTOMATICA', '', '', '', '') = 'T' THEN
         -- RFMP 95450
         bGRAVA_NFT := false;
         bCANCELA_NFT := false;

         -- Tratamento para mudana de FLGEST
         IF  Equal(pFLGEST,pOldFLGEST) <> 1 THEN

             -- Se encomendou em filial e fez a compra em outra, ento gera transferncia.
             IF pCODFIL <> pFILICO THEN
                 -- Ao receber mercadoria encomendada gera transferencia automtica.
                 IF pFLGEST = 'R' THEN
                     bGRAVA_NFT := true;
                 ELSE
                     IF pOldFLGEST = 'R' THEN
                         bCANCELA_NFT := true;
                     END IF;
                 END IF;
             END IF;

         END IF;

         IF bGRAVA_NFT OR bCANCELA_NFT THEN
             
             nCusrep := ValoresProdutoTransfAutom(pFILMAT, pCODMAT, pCODCOR, pCODTAM, pFILICO);
         END IF;

         IF bGRAVA_NFT THEN
             cDummy := GeraTransfAutom(pCODFIL, pFILMAT, pCODMAT, pCODCOR, pCODTAM, pFILICO, pQTDENC, nCusrep);

             cSeqven := NotaAbertaTransfAutom('V', pCODFIL, pFILICO);
             cSeqcom := NotaAbertaTransfAutom('C', pCODFIL, pFILICO);

             cDummy := IncluiItemTransfAutom(pCODFIL,pFILICO,cSeqven,cSeqcom,
                                             pFILMAT,pCODMAT,pCODCOR,pCODTAM,
                                             pQTDENC,nCusrep,pCODMUL,pFILIVE,
                                             pSEQIVE,pNUMIVE,pFILLOT,pSEQLOT, null); -- MN - 103975 - TT_IVEXIPE no possui coluna NUMEXT para enviar
         END IF;

         IF bCANCELA_NFT THEN
             -- Cancela
             cSeqven := NotaAbertaTransfAutom('V', pCODFIL, pFILICO);
             cSeqcom := NotaAbertaTransfAutom('C', pCODFIL, pFILICO);

             -- Desfaz transferncia apenas se encontrar a nota
             IF cSeqven IS NOT NULL THEN
                 cDummy := RemoveItemTransfAutom(pCODFIL,pFILICO,cSeqven,cSeqcom,
                                                 pFILMAT,pCODMAT,pCODCOR,pCODTAM,
                                                 pQTDENC,nCusrep,pCODMUL,pFILIVE,
                                                 pSEQIVE,pNUMIVE,pFILLOT,pSEQLOT);
             ELSE
                 cDummy := EmailTransfAutom(pCODFIL, pFILIVE, pSEQIVE, 
                                            pFILMAT, pCODMAT, pCODCOR, pCODTAM, 
                                            pFILICO, pSEQICO, pNUMICO);
             END IF;
         END IF;
      END IF;

   RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 1874 --*/


    CREATE OR REPLACE FUNCTION PC_PED_IVO_UPDATE (TT_PED.CODFIL%TYPE,TT_PED.NUMPED%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pNUMPED ALIAS FOR $2 ;

  cDUMMY VARCHAR(20);
  Begin
            
         SELECT CriaSeparacaoReposicao(pCODFIL, null, pNUMPED) INTO cDUMMY;
         RETURN NULL;

END;
$$ language 'plpgsql';
 


/*-- SEQ 1875 --*/

CREATE OR REPLACE FUNCTION PC_PRO_AUX_Update (TT_PRO.FILMAT%TYPE,TT_PRO.CODMAT%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFILMAT ALIAS FOR $1 ;
pCODMAT ALIAS FOR $2 ;
-- Objetivos:
-- 1. Atualizar os preos do produto

-- Declarao de variveis e cursores

-- Incio da procedure
BEGIN

   -- Pedro E. Braga - 104287 - Comando de update na TT_PRE foi transferido para o controle atravs da funo "Insere_MATU".
   -- Atualiza preos do produto
   UPDATE TT_PRE
      SET ATU_EM = Agora()
    WHERE FILMAT = pFILMAT
      AND CODMAT = pCODMAT;

  RETURN NULL;

END;
$$ language 'plpgsql';




      CREATE OR REPLACE FUNCTION PC_USUxLOG_UPDATE (TL_CLI.FILCLI%TYPE,TL_CLI.CODCLI%TYPE,TL_CLI.MSGLOG%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pFilCli ALIAS FOR $1 ;
pCodCli ALIAS FOR $2 ;
pMsgLog ALIAS FOR $3 ;
      nCODUID                       TT_UID.CODUID%TYPE;
            
      QuemLogou                     TRetQuemLogou%ROWTYPE;
            cFILUSU                       TT_USU.FILUSU%TYPE;
      cCODUSU                       TT_USU.CODUSU%TYPE;
     begin
                     SELECT MAX(CODUID)
              INTO nCODUID
              FROM TT_UID
             WHERE SESSION_ID = USERENV('SESSIONID');
         
         select * into QuemLogou from DadosLogon();
         cFILUSU := QuemLogou.FILUSU;
         cCODUSU := QuemLogou.CODUSU;

         IF (ISNOTNULL(pFilCli)='T') AND (ISNOTNULL(pCodCli)='T') THEN
            INSERT INTO TL_CLI (FILUSU, CODUSU, FILCLI, CODCLI, DATOPE, MSGLOG, CODUID)
                       VALUES (cFILUSU, cCODUSU, pFilCli, pCodCli, Agora(), pMsgLog, nCODUID);
         END IF;
      RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 1876 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ESTORNA_TRANSACOES (TT_LID.CODFIL%TYPE,TT_LID.NUMECF%TYPE,TT_LID.TRN_ID%TYPE,TT_LID.CODFIL%TYPE,TT_LID.NUMECF%TYPE,TT_LID.TRN_ID%TYPE) CASCADE;

/*-- SEQ 1877 --*/
CREATE OR REPLACE FUNCTION ESTORNA_TRANSACOES (TT_LID.CODFIL%TYPE,TT_LID.NUMECF%TYPE,TT_LID.TRN_ID%TYPE,TT_LID.CODFIL%TYPE,TT_LID.NUMECF%TYPE,TT_LID.TRN_ID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pNUMECF ALIAS FOR $2 ;
pTRN_ID ALIAS FOR $3 ;
pFILORI ALIAS FOR $4 ;
pECFORI ALIAS FOR $5 ;
pID_ORI ALIAS FOR $6 ;
-- Objetivo:
-- 1) Estornas as transaes vindas do checkout. Verifica a integridade da transao, fazendo contra-lanamentos e
--    processos em cascata para que o processo de estorno fique integro
  WK_CODFIL                      TT_OPE.CODFIL%TYPE;
  WK_NUMECF                      TT_OPE.NUMECF%TYPE;
  WK_TRN_ID                      TT_OPE.TRN_ID%TYPE;
  WK_CUPFIS                      TT_OPE.CUPFIS%TYPE;
  WK_NUMITE                      TT_OPE.NUMITE%TYPE;
  WK_VLROPE                      TT_OPE.VLROPE%TYPE;
  WK_DATOPE                      TT_OPE.DATOPE%TYPE;
  WK_FILUSU                      TT_OPE.FILUSU%TYPE;
  WK_CODUSU                      TT_OPE.CODUSU%TYPE;
  WK_FILREC                      TT_OPE.FILREC%TYPE;
  WK_SEQREC                      TT_OPE.SEQREC%TYPE;
  WK_NUMPAR                      TT_OPE.NUMPAR%TYPE;
  WK_SUBPAR                      TT_OPE.SUBPAR%TYPE;
  WK_FILCCC                      TT_OPE.FILCCC%TYPE;
  WK_SEQCCC                      TT_OPE.SEQCCC%TYPE;
  WK_FILCHR                      TT_OPE.FILCHR%TYPE;
  WK_SEQCHR                      TT_OPE.SEQCHR%TYPE;
  WK_FILFIN                      TT_OPE.FILFIN%TYPE;
  WK_SEQFIN                      TT_OPE.SEQFIN%TYPE;
  WK_CARTAO                      TT_OPE.CARTAO%TYPE;
  WK_OUTROS                      TT_OPE.OUTROS%TYPE;
  WK_CAMBIO                      TT_OPE.CAMBIO%TYPE;
  WK_CODCAI                      TT_OPE.CODCAI%TYPE;
  WK_TIPCAR                      TT_OPE.TIPCAR%TYPE;
  WK_FILDOP                      TT_OPE.FILDOP%TYPE;
  WK_SEQDOP                      TT_OPE.SEQDOP%TYPE;
  WK_DOCTRO                      TT_OPE.DOCTRO%TYPE;
  WK_FILTEF                      TT_OPE.FILTEF%TYPE;
  WK_SEQTEF                      TT_OPE.SEQTEF%TYPE;
  WK_PARCELA                     Numeric(5);


CR_OPERACOES CURSOR FOR
   SELECT CODFIL,NUMECF,TRN_ID,CUPFIS,NUMITE,VLROPE,DATOPE,FILUSU,CODUSU,FILREC,
          SEQREC,NUMPAR,SUBPAR,FILCCC,SEQCCC,FILCHR,SEQCHR,FILFIN,SEQFIN,CARTAO,
          OUTROS,CAMBIO,CODCAI,TIPCAR,FILDOP,SEQDOP,DOCTRO,FILTEF,SEQTEF
     FROM TT_OPE
    WHERE CODFIL = pFILORI
      AND NUMECF = pECFORI
      AND TRN_ID = pID_ORI;
BEGIN

     OPEN CR_OPERACOES;

     LOOP

         FETCH CR_OPERACOES INTO WK_CODFIL,WK_NUMECF,WK_TRN_ID,WK_CUPFIS,WK_NUMITE,WK_VLROPE,WK_DATOPE,WK_FILUSU,WK_CODUSU,WK_FILREC,
                                 WK_SEQREC,WK_NUMPAR,WK_SUBPAR,WK_FILCCC,WK_SEQCCC,WK_FILCHR,WK_SEQCHR,WK_FILFIN,WK_SEQFIN,WK_CARTAO,
                                 WK_OUTROS,WK_CAMBIO,WK_CODCAI,WK_TIPCAR,WK_FILDOP,WK_SEQDOP,WK_DOCTRO,WK_FILTEF,WK_SEQTEF;
         EXIT WHEN NOT FOUND;

         IF (WK_FILREC IS NOT NULL) THEN

             SELECT COUNT(*)
               INTO WK_PARCELA
               FROM TT_REC
              WHERE CODFIL = WK_FILREC
                AND SEQUEN = WK_SEQREC
                AND NUMPAR = WK_NUMPAR
                AND FLGEST = 'A';

             IF WK_PARCELA > 0 THEN

                 UPDATE TT_REC
                    SET FLGEST='C',
                        DUMMY=CONSTANTE('VEM_DE_ESTORNO')
                  WHERE CODFIL = WK_FILREC
                    AND SEQUEN = WK_SEQREC
                    AND NUMPAR = WK_NUMPAR
                    AND FLGEST = 'A'
                    AND SEQCHE IS NULL
                    AND CARTAO IS NULL;

                  WK_PARCELA := 0;

             END IF;

             UPDATE TT_REC SET FLGEST = 'X',
                               ESTCAN = AGORA(),
                               ATU_EM = AGORA()
              WHERE CODFIL = WK_FILREC
                AND SEQUEN = WK_SEQREC
                AND NUMPAR = WK_NUMPAR
                AND SUBPAR = WK_SUBPAR;

              SELECT COUNT(*)
                INTO WK_PARCELA
                FROM TT_REC
               WHERE CODFIL = WK_FILREC
                 AND SEQUEN = WK_SEQREC
                 AND NUMPAR = WK_NUMPAR
                 AND FLGEST = 'A';

              IF WK_PARCELA > 0 THEN

                  UPDATE TT_REC SET VLRPAR = VLRPAR + ABS(WK_VLROPE)
                   WHERE CODFIL = WK_FILREC
                     AND SEQUEN = WK_SEQREC
                     AND NUMPAR = WK_NUMPAR
                     AND FLGEST = 'A';

              ELSE

                  SELECT ABS(SUM(VLROPE))
                    INTO WK_VLROPE
                    FROM TT_OPE
                   WHERE FILREC = WK_FILREC
                     AND SEQREC = WK_SEQREC
                     AND NUMPAR = WK_NUMPAR
                     AND SUBPAR <= WK_SUBPAR;

                  INSERT INTO TT_REC (CODFIL, SEQUEN, NUMPAR, SUBPAR, ATU_EM, DATVEN, CODMOE, FLGEST, VLRPAR,
                                      SIGNAT, PORTAD, SUBORI)
                                     (SELECT WK_FILREC,
                                             WK_SEQREC,
                                             WK_NUMPAR,
                                             (SELECT LPAD(TO_CHAR(MAX(TO_NUMBER(SUBPAR))+1),2,' ')
                                                FROM TT_REC
                                               WHERE CODFIL = WK_FILREC
                                                 AND SEQUEN = WK_SEQREC
                                                 AND NUMPAR = WK_NUMPAR) AS SUBPAR,
                                             AGORA(),
                                             (SELECT DATVEN
                                                FROM TT_REC
                                               WHERE CODFIL = WK_FILREC
                                                 AND SEQUEN = WK_SEQREC
                                                 AND NUMPAR = WK_NUMPAR
                                                 AND SUBPAR = WK_SUBPAR) AS DATVEN,
                                             REC.CODMOE,
                                             TO_CHAR('A') AS FLGEST,
                                             ABS(WK_VLROPE),
                                             0 AS SIGNAT,
                                             PORTAD,
                                             WK_SUBPAR
                                        FROM TT_REC REC
                                       WHERE REC.CODFIL = wk_filrec
                                         AND REC.SEQUEN = wk_seqrec
                                         AND REC.NUMPAR = WK_NUMPAR
                                         AND REC.SUBPAR = WK_SUBPAR);

              END IF;

              UPDATE TT_VEN SET FLGEST = '?'
               WHERE CODFIL = WK_FILREC
                 AND SEQUEN = WK_SEQREC;

         END IF;

         IF WK_FILCHR IS NOT NULL THEN

             UPDATE TT_CHR SET FLGEST = 'X'
              WHERE CODFIL = WK_FILCHR
                AND SEQUEN = WK_SEQCHR;

         END IF;

         IF WK_FILTEF IS NOT NULL THEN

             UPDATE TT_ITF SET FLGEST = 'C'
              WHERE CODFIL = WK_FILTEF
                AND SEQUEN = WK_SEQTEF;

         END IF;

         IF WK_FILCCC IS NOT NULL THEN

             INSERT INTO TT_CCC (CODVEN, SEQVEN, NUMPAR, SUBPAR, CODFIL, FILCLI, CODCLI, DATOPE, NUMDOC, FILUSU,
                                 CODUSU, VLRLAN, COMPLE, TIPCCC, PLACAS, STATUS, PORORI, DATFIS, TIPLAN)
                                (SELECT CODVEN, SEQVEN, NUMPAR, SUBPAR, CODFIL, FILCLI, CODCLI, AGORA(), NUMDOC, FILUSU,
                                        CODUSU, VLRLAN * -1,
                                        TO_CHAR('ESTORNO REF. ESTORNO PARCELA'), TIPCCC, PLACAS,
                                        CASE STATUS WHEN 'A' THEN 'P'
                                                    ELSE 'A'
                                         END AS STATUS,
                                        PORORI, DATFIS, TO_CHAR('U')
                                   FROM TT_CCC
                                  WHERE CODFIL = WK_FILCCC
                                    AND SEQUEN = WK_SEQCCC );

         END IF;

     END LOOP;

     UPDATE TT_LID SET FILORI = pFILORI,
                       ECFORI = pECFORI,
                       ID_ORI = pID_ORI
      WHERE CODFIL = pCODFIL
        AND NUMECF = pNUMECF
        AND TRN_ID = pTRN_ID;

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1878 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TRANSFERE_ESTOQUE (TD_FIL.CODFIL%TYPE,TD_FIL.CODFIL%TYPE,TD_MUL.CODTAB%TYPE,Numeric) CASCADE;

/*-- SEQ 1879 --*/
CREATE OR REPLACE FUNCTION TRANSFERE_ESTOQUE (TD_FIL.CODFIL%TYPE,TD_FIL.CODFIL%TYPE,TD_MUL.CODTAB%TYPE,Numeric)
RETURNS VARCHAR AS $$
DECLARE
pFILORI ALIAS FOR $1 ;
pFILDES ALIAS FOR $2 ;
pCODMUL ALIAS FOR $3 ;
pNUMITE ALIAS FOR $4 ;

--Objetivo : Trasnferir estoque de uma filial para outra usando oramento ou transferencia, dependendo do parmetro pTIPOPE

-- O parmetro NUMITE  a quantidade de itens que sero gerados na nota, no podendo ultrapassar 990 itens.

  WK_VC_FILPGT                   TT_CFG.VC_FILPGT%TYPE;
  WK_VC_CODPGT                   TT_CFG.VC_CODPGT%TYPE;
  WK_FILPRE                      TT_CFG.FILPRE%TYPE;
  WK_CODPRE                      TT_CFG.CODPRE%TYPE;
  WK_FILMAT                      TT_SAL.FILMAT%TYPE;
  WK_CODMAT                      TT_SAL.CODMAT%TYPE;
  WK_CODCOR                      TT_SAL.CODCOR%TYPE;
  WK_CODTAM                      TT_SAL.CODTAM%TYPE;
  WK_PRECOM                      TT_GRA.PRECOM%TYPE;
  WK_QTDEST                      TT_SAL.QTDEST%TYPE;
  WK_VLRTOT                      TT_ORC.VLRTOT%TYPE;
  ITEM                           Numeric;
  WK_NUMPED                      TT_ORC.NUMPED%TYPE;
  QuemLogou                      TRetQuemLogou;
  filial                         TT_USU.FILUSU%TYPE;
  usuario                        TT_USU.CODUSU%TYPE;
  vComplemento                   CONSTANT VARCHAR(254):= constante('complemento');


CR_PRODUTOS CURSOR(PFILIAL TT_SAL.CODFIL%TYPE,
           PCODEST TT_SAL.CODMUL%TYPE,
           PLIMIT Numeric) IS
SELECT SAL.FILMAT, SAL.CODMAT, SAL.CODCOR,SAL.CODTAM,GRA.PRECOM,SAL.QTDEST
  FROM TT_SAL SAL INNER JOIN TT_GRA GRA ON GRA.FILMAT = SAL.FILMAT AND GRA.CODMAT = SAL.CODMAT
                                       AND GRA.CODCOR = SAL.CODCOR AND GRA.CODTAM = SAL.CODTAM
 WHERE SAL.CODFIL = PFILIAL
   AND SAL.CODMUL = PCODMUL
   AND SAL.QTDEST > 0
   AND GRA.PRECOM > 0;

BEGIN
    select * into QuemLogou from DadosLogon();
    IF QuemLogou.Encontrou THEN
       filial:=QuemLogou.filusu;
       usuario:=QuemLogou.codusu;
    ELSE
      RAISE EXCEPTION 'PG-20037 Voce nao e um usuario cadastrado no sistema. %' , VComplemento;
    END IF;

  IF pNUMITE > 990 THEN
      RAISE EXCEPTION 'PG-20037 Notas nao devem ter mais do que 990 itens.';
  END IF;

  item := 0;
  wk_vlrtot := 0;

  SELECT VC_FILPGT, VC_CODPGT, FILPRE, CODPRE
    INTO WK_VC_FILPGT, WK_VC_CODPGT, WK_FILPRE, WK_CODPRE
    FROM TT_CFG;

     OPEN CR_PRODUTOS(pFILORI, pCODMUL, pNUMITE);
     LOOP

       FETCH CR_PRODUTOS INTO WK_FILMAT, WK_CODMAT, WK_CODCOR, WK_CODTAM, WK_PRECOM, WK_QTDEST;
        EXIT WHEN NOT FOUND;

       IF ITEM = 0 THEN
             SELECT LPAD(TO_CHAR(ULTCOD + 1),8,'0')
               INTO WK_NUMPED
               FROM TT_COD
              WHERE CODTAB = 'ORC'
                AND FILCOD = pFILORI;

             UPDATE TT_COD SET ULTCOD = ULTCOD + 1
              WHERE CODTAB = 'ORC'
                AND FILCOD = pFILORI;

             INSERT INTO TT_ORC(CODFIL,TIPPED,NUMPED,FLGEST,NATURE,TIPENT,CODPGT,CODUSU,CODVEN,FILCLI,
                                FILPGT,FILPRE,FILUSU,FILVEN,CODCLI,ATU_EM,DATPRI,DATVAL,PED_EM,VLRDES,
                                VLRPAR,VLRTOT,NUMCOB,NUMENT,NUMFAT,CODFIN,CODPRE,QTDPAR,DESCLI,EMIDES,
                                RESERV,FILCOB,FiLENT,FILFAT,FILALC,APROVA,APRCLI,SEPARA,COMAND)
                               (select pFILORI, 'O', WK_NUMPED, 'A', 0, 0, WK_VC_CODPGT, usuario, usuario, pFILDES,
                                       WK_VC_FILPGT, WK_FILPRE, filial, filial, '     0', agora(), agora(), add_day(agora(),1), agora(), 0,
                                       0, 0.01, 1, 1, 1, 0, WK_CODPRE, 0, 'F','F',
                                       'F', pFILDES,pFILDES,pFILDES,pFILORI,'E','1','F','F'
                                  from dual);
             wk_vlrtot := 0;
             item := 1;
        END IF;

        INSERT INTO TT_IOR (CODFIL,TIPPED, NUMPED,NUMITE,FLGEST,PROMOC, FILMAT,FILRES,CODMAT, ATU_EM,ORDITE,
                            CODTAM,VLRCUS,VLRENT,VLRITE,VLRPGT,QTDENT,QTDITE,MONTAR,CODMUL,CODCOR,DATINC,PERIPI)
                    (select pFILORI, 'O', WK_NUMPED, ITEM, 'A','N',WK_FILMAT, pFILORI, WK_CODMAT, AGORA(), ITEM, WK_CODTAM,
                            ROUND(WK_PRECOM * WK_QTDEST,2), WK_PRECOM, WK_PRECOM, ROUND(WK_PRECOM * WK_QTDEST,2), 0, WK_QTDEST, 'F', pCODMUL, WK_CODCOR, AGORA(),0
                        from dual);


       item := item + 1;
       wk_vlrtot := wk_vlrtot +  ROUND((WK_PRECOM * WK_QTDEST),2);
       IF ITEM = pNUMITE THEN
           UPDATE TT_ORC SET VLRTOT = WK_VLRTOT
            WHERE CODFIL = pFILORI
              AND TIPPED = 'O'
              AND NUMPED = WK_NUMPED;
          item := 0;
       END IF;

     END LOOP;
     CLOSE CR_PRODUTOS;

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1880 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RegistraAcessoPadrao (TT_UID.CODUID%TYPE,VARCHAR) CASCADE;

/*-- SEQ 1881 --*/
CREATE OR REPLACE FUNCTION RegistraAcessoPadrao (TT_UID.CODUID%TYPE,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pCODUID ALIAS FOR $1 ;
pHash ALIAS FOR $2 ;

-- Objetivos:
-- 1. Registra acesso pelo banco utilizando os dados padro da Totall.

-- Declarao de variveis e cursores
   nVERBAS                       TT_IDF.VERBAS%TYPE;
   
   cOK                           VARCHAR(2);
   
-- Incio da funo
BEGIN

   SELECT VERBAS INTO nVERBAS
     FROM TT_IDF;

   
   cOK :=
      RegistraAcesso(
           0,       -- TOTALL
           pHash,   -- Hash calculado
           pCODUID, -- Resultado do ConectaUID
           'totall',
           Agora(),
           'TOTALL',
           nVerbas,
           '--',
           'Totall',
           USERENV('SESSIONID'));

  RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1882 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ATUALIZAMOVDIFERENCA (TT_SAL.CODFIL%TYPE) CASCADE;

/*-- SEQ 1883 --*/
CREATE OR REPLACE FUNCTION ATUALIZAMOVDIFERENCA (TT_SAL.CODFIL%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
   WK_ESTOQUE                    VARCHAR(3);
   WK_CODFIL                     TT_SAL.CODFIL%TYPE;
   WK_FILMAT                     TT_SAL.FILMAT%TYPE;
   WK_CODMAT                     TT_SAL.CODMAT%TYPE;
   WK_CODCOR                     TT_SAL.CODCOR%TYPE;
   WK_CODTAM                     TT_SAL.CODTAM%TYPE;
   WK_CODMUL                     TT_SAL.CODMUL%TYPE;

CR_ESTOQUE CURSOR(PCODFIL VARCHAR) IS
    
        SELECT SAL.CODFIL, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, SAL.CODMUL
            FROM TT_SAL SAL
            WHERE SAL.MOVEST = 'T'
              AND SAL.CODFIL = COALESCE(PCODFIL,SAL.CODFIL)
        GROUP BY SAL.CODFIL, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, SAL.CODMUL
        HAVING SUM(SAL.QTDEST) <> SUM((SELECT COALESCE( RMOV.SALANT, 0) + COALESCE( RMOV.QTDCOM, 0) +
                                              COALESCE( RMOV.QTDOUT, 0) - COALESCE( RMOV.QTDVEN, 0) -
                                              COALESCE( RMOV.VENFIS, 0)
                                         FROM TR_MOV RMOV
                                        WHERE RMOV.FILMAT = SAL.FILMAT
                                          AND RMOV.CODMAT = SAL.CODMAT
                                          AND RMOV.CODCOR = SAL.CODCOR
                                          AND RMOV.CODTAM = SAL.CODTAM
                                          AND RMOV.CODMUL = SAL.CODMUL
                                          AND RMOV.CODFIL = SAL.CODFIL
                                        ORDER BY RMOV.DATMOV DESC
                                        LIMIT 1));
        BEGIN

   OPEN CR_ESTOQUE(PCODFIL);
   LOOP
      FETCH CR_ESTOQUE INTO WK_CODFIL, WK_FILMAT, WK_CODMAT, WK_CODCOR, WK_CODTAM, WK_CODMUL;

      EXIT WHEN NOT FOUND;

      WK_ESTOQUE := ATUALIZAMOV (WK_CODFIL,WK_FILMAT,WK_CODMAT,WK_CODCOR,WK_CODTAM,WK_CODMUL); 

   END LOOP;
   CLOSE CR_ESTOQUE;
  RETURN 'OK';
END;
$$ language 'plpgsql';





/*-- SEQ 1884 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION FormataNossoNumero (VARCHAR,Numeric,VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1885 --*/
CREATE OR REPLACE FUNCTION FormataNossoNumero (VARCHAR,Numeric,VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pNossoNumero ALIAS FOR $1 ;
pCarteira ALIAS FOR $2 ;
pApelidoCarteira ALIAS FOR $3 ;
pBanco ALIAS FOR $4 ;
-- Paulo - 83777 : Funo que formata "NossoNumero" no layout bradesco.
  nNum INTEGER [];

  nBaseCalc   VARCHAR(255);
  nFatorMult  VARCHAR(255);
  cRetorno    VARCHAR(255);
  i     INTEGER;
  nSoma INTEGER;
  nDiv  INTEGER;
  nCal  INTEGER;
  vNossoNumero VARCHAR(20);
  vCarteira    VARCHAR(03);

BEGIN
   IF (pNossoNumero IS NULL) OR (pCarteira IS NULL) THEN
      RETURN '';
   END IF;

   IF LENGTH(TO_CHAR(pCarteira)) = 1 THEN
      vCarteira := TO_CHAR('0'||pCarteira);
   ELSE
      vCarteira := TO_CHAR(pCarteira);
   END IF;

   vNossoNumero := TRIM(pNossoNumero);

   -- Se for banco Bradesco.
   IF pBanco = '237' THEN

      /*
      for iarray in 1..13 loop
  if iarray = 1 then
    select array [0] into nNum;
  else
    select array_append(nNum,0) into nNum;
  end if;
end loop;

      i := 0;

      nBaseCalc := vCarteira || SUBSTR(vNossoNumero, 2, Length(vNossoNumero));

      nFatorMult := '2765432765432';

      FOR i IN 1..Length(nBaseCalc) LOOP
      nCal := (SUBSTR(nBaseCalc, i, 1)) * (SUBSTR(nFatorMult, i, 1));
      nNum [i] := nCal;

      END LOOP;

      nSoma := 0;
      FOR i IN 1..LENGTH(nBaseCalc) LOOP
       nSoma := nSoma + nNum [i];
      END LOOP;

      nDiv := nSoma - ((TRUNC(nSoma / 11)) * 11);

      IF nDiv = 1 THEN
       cRetorno := vCarteira||'/'||SUBSTR(vNossoNumero, 2, Length(vNossoNumero))||'-'||'P';
      ELSE
      IF nDiv = 0 THEN
         cRetorno := vCarteira||'/'||SUBSTR(vNossoNumero, 2, Length(vNossoNumero))||'-'||'0';
      ELSE
         cRetorno := vCarteira||'/'||SUBSTR(vNossoNumero, 2, Length(vNossoNumero))||'-'||TO_CHAR(11 - nDiv);
      END IF;
      END IF;
      */

      cRetorno := vCarteira||'/'||SUBSTR(vNossoNumero, 1, Length(vNossoNumero)-1)||'-'||SUBSTR(vNossoNumero, Length(vNossoNumero), 1);

      RETURN cRetorno;
   ELSIF pBanco = '104' THEN
      -- Sistema SIGCB  mais novo.
      -- Antigo era o SICOB.

      IF COALESCE(pApelidoCarteira,'') = 'SIG14' THEN

         cRetorno := SUBSTR(vNossoNumero, 1, 2)
                     ||'/'
                     ||SUBSTR(vNossoNumero, 3, Length(vNossoNumero)-3)
                     ||'-'
                     ||SUBSTR(vNossoNumero, Length(vNossoNumero), 1);
         RETURN cRetorno;

      ELSE

         -- RFMP 96958
         -- SICOB 12-Cobrana Rpida
         IF pCarteira = 12 THEN

            cRetorno := SUBSTR(vNossoNumero, 1, 10)
                      ||'-'
                      ||SUBSTR(vNossoNumero, Length(vNossoNumero), 1);
            RETURN cRetorno;

         ELSE

            RETURN pNossoNumero;

         END IF;

      END IF;
   ELSIF pBanco = '748' THEN
      -- RFMP 96710
      -- AA/BXXXXX-D
      cRetorno := SUBSTR(vNossoNumero, 1, 2)
                 ||'/'
                 ||SUBSTR(vNossoNumero, 3, Length(vNossoNumero)-3)
                 ||'-'
                 ||SUBSTR(vNossoNumero, Length(vNossoNumero), 1);
      RETURN cRetorno;
   ELSIF pBanco = '085' THEN -- CECRED
      -- Nosso nmero:  composto por 17 dgitos sem o dgito verificador,
      -- 8 primeiros dgitos: Conta corrente do cooperado (Sempre ser fixo)
      -- 9 dgitos restantes: Nmero do boleto (Sequencial)
      RETURN pNossoNumero;
   ELSIF pBanco = '041' THEN -- RFMP 97988
      -- NNNNNNNN.NN
      cRetorno := SUBSTR(vNossoNumero, 1, 8)
                  ||'.'
                  ||SUBSTR(vNossoNumero, 9, 2);
      RETURN cRetorno;
   ELSE
      RETURN pNossoNumero;
   END IF;

END;
$$ language 'plpgsql';




/*-- SEQ 1886 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CalcCodBarrasBoleto (TT_TIT.CODFIL%Type,TT_TIT.SEQUEN%Type,Numeric) CASCADE;

/*-- SEQ 1887 --*/
CREATE OR REPLACE FUNCTION CalcCodBarrasBoleto (TT_TIT.CODFIL%Type,TT_TIT.SEQUEN%Type,Numeric)
RETURNS VARCHAR AS $$
DECLARE
p_FILTIT ALIAS FOR $1 ;
p_SEQTIT ALIAS FOR $2 ;
p_EhBarra ALIAS FOR $3 ;
-- Objetivo
-- 1) Calcula o Codigo de Barras para o Boleto Bancario.
  Titulo Record;
  WK_FLGTIT CHAR (1);
  wk_codbar CHAR(44);

-- Principal
BEGIN

  -- Testando consistencia
  SELECT COALESCE(MIN(TIT.FLGEST),'#') INTO WK_FLGTIT FROM TT_TIT TIT
  WHERE TIT.CODFIL = P_FILTIT
    AND TIT.SEQUEN = P_SEQTIT;

  IF (WK_FLGTIT = '#')
  OR (WK_FLGTIT = 'I') THEN
    -- Traz o que for pedido
    if p_ehBarra = 1 then
      Return '00000000000000000000000000000000000000000000';
    else
      Return '00000000000000000000000000000000000000000000000';
    end if;
  END IF;

  -- Traz o Titulo referente
  SELECT TIT.CODBCO, TIT.NUMAGE, TRIM(TO_CHAR(TO_NUMBER(TIT.CTACRR))) AS CTACRR, CTB.DIGA_C, CTB.AVISTA, BXC.CODCNV,
         TIT.NOSNUM, CCB.CARBCO, MOE.MOEBCO, REC.VLRPAR, REC.DATVEN, CTB.APRAZO, CRB.APECRB, BXC.CODCED, REC.NUMPAR
  INTO  Titulo
  FROM TT_TIT TIT LEFT JOIN TT_CTBXCCB BXC ON TIT.CODBCO = BXC.CODBCO
                                          AND TIT.NUMAGE = BXC.NUMAGE
                                          AND TIT.CTACRR = BXC.CTACRR
                                          AND TIT.CODCCB = BXC.CODCCB, 
       TT_REC REC, TT_CCB CCB LEFT JOIN TT_CRB CRB ON CCB.CODCRB = CRB.CODTAB, TT_MOE MOE, TT_CTB CTB                  
  WHERE TIT.CODFIL = P_FILTIT
    AND TIT.SEQUEN = P_SEQTIT
    AND TIT.FILREC = REC.CODFIL
    AND TIT.SEQREC = REC.SEQUEN
    AND TIT.PARREC = REC.NUMPAR
    AND TIT.SUBREC = REC.SUBPAR
    AND TIT.CODBCO = CCB.CODBCO
    AND TIT.CODCCB = CCB.CODCCB
    AND TIT.CODBCO = MOE.CODBCO
    AND REC.CODMOE = MOE.CODMOE
    AND CTB.CODBCO = TIT.CODBCO
    AND CTB.NUMAGE = TIT.NUMAGE
    AND CTB.CTACRR = TIT.CTACRR
    AND TIT.NUMAGE = CTB.NUMAGE
    AND TIT.CTACRR = CTB.CTACRR
    AND TIT.SEQCAN IS NULL;

  wk_codbar := Aux_TrazCodBarra(Titulo.CODBCO, Titulo.NUMAGE, Titulo.CTACRR, Titulo.NOSNUM,
                                Titulo.CARBCO, Titulo.APECRB, Titulo.MOEBCO, Titulo.VLRPAR, 
                                Titulo.DATVEN, Titulo.AVISTA, Titulo.APRAZO, Titulo.DIGA_C, 
                                Titulo.CODCNV, Titulo.CODCED, Titulo.NUMPAR);

  -- Traz o que for pedido
  if p_ehBarra = 1 then
    Return wk_codbar;
  else
    Return Aux_TrazLinhaDigitavel(Titulo.CODBCO, Titulo.NUMAGE, Titulo.CTACRR, Titulo.NOSNUM,
                                  Titulo.CARBCO, Titulo.APECRB, Titulo.MOEBCO, Titulo.VLRPAR, 
                                  Titulo.DATVEN, Titulo.AVISTA, Titulo.APRAZO, Titulo.DIGA_C,
                                  Titulo.CODCNV, wk_codbar, Titulo.CODCED, Titulo.NUMPAR);
  end if;
END;
$$ language 'plpgsql';




/*-- SEQ 1888 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DIA_SEMANA (VARCHAR) CASCADE;

/*-- SEQ 1889 --*/
CREATE OR REPLACE FUNCTION DIA_SEMANA (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pDATA ALIAS FOR $1 ;
-- Paulo K. - 88485
-- Funo que retorna o dia da semana de uma data especifica.
  WK_DIA_SEMANA VARCHAR(14);
BEGIN
  SELECT CAST(CASE TO_CHAR(TO_DATE(pData, 'DD/MM/YYYY'),'D')
              WHEN '1' THEN 'Domingo'
              WHEN '2' THEN 'Segunda-Feira'
              WHEN '3' THEN 'Tera-Feira'
  			  WHEN '4' THEN 'Quarta-Feira'
			  WHEN '5' THEN 'Quinta-Feira'
			  WHEN '6' THEN 'Sexta-Feira'
			  WHEN '7' THEN 'Sbado'
          END AS VARCHAR(14)) AS DIA 
    INTO WK_DIA_SEMANA
    FROM DUAL;
	
  -- Retorna o dia da semana.	
  RETURN WK_DIA_SEMANA;
END;
$$ language 'plpgsql';




/*-- SEQ 1890 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ENVIOU_REMESSA_HOJE (TT_TIT.NOSNUM%TYPE) CASCADE;

/*-- SEQ 1891 --*/
CREATE OR REPLACE FUNCTION ENVIOU_REMESSA_HOJE (TT_TIT.NOSNUM%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pNOSNUM ALIAS FOR $1 ;
  ENVIOU VARCHAR(1);
BEGIN 
SELECT CASE WHEN COUNT(TIT.NOSNUM) > 0 THEN 'T' ELSE 'F' END  INTO ENVIOU
  FROM TT_TIT TIT INNER JOIN TT_REC REC ON TIT.FILREC = REC.CODFIL AND TIT.SEQREC = REC.SEQUEN AND TIT.PARREC = REC.NUMPAR AND TIT.SUBREC = REC.SUBPAR
                  INNER JOIN TT_CTB CTB ON TIT.NUMAGE = CTB.NUMAGE AND TIT.CODBCO = CTB.CODBCO AND TIT.CTACRR = CTB.CTACRR
                  INNER JOIN TT_IXT IXT ON TIT.CODFIL = IXT.CODFIL AND TIT.SEQUEN = IXT.SEQTIT
                  INNER JOIN TT_CCB CCB ON IXT.CODCCB = CCB.CODCCB AND IXT.CCBBCO = CCB.CARBCO AND TIT.CODBCO = CCB.CODBCO
                  INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
  WHERE VEN.FILCOB IS NOT NULL
    AND VEN.ENDCOB IS NOT NULL
    AND IXT.DATENV IS not NULL
    AND TRUNC(IXT.DATENV) = TRUNC(AGORA())
    AND IXT.REMBCO = 1
    AND TIT.NOSNUM = pNOSNUM;

  RETURN ENVIOU;

END;
$$ language 'plpgsql';




/*-- SEQ 1892 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ErrosLCF (TT_MAI.CODFIL%TYPE,TT_MAI.SEQUEN%TYPE) CASCADE;

/*-- SEQ 1893 --*/
CREATE OR REPLACE FUNCTION ErrosLCF (TT_MAI.CODFIL%TYPE,TT_MAI.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCodFil ALIAS FOR $1 ;
pSequen ALIAS FOR $2 ;
 RESULTADO VARCHAR(4000);
 cTexto TT_MAI.TEXTOS%TYPE;
 nInicio Numeric;
 nfim Numeric;
BEGIN
  SELECT MSGERR INTO cTexto
   FROM TT_LCF 
  WHERE CODFIL = pCodFil
   AND SEQUEN = pSequen;
 
  nInicio := INSTR(  cTexto, CHR(13)||CHR(10)||'*'||CHR(13)||CHR(10)) ;
  cTexto  := substr( cTexto, nInicio, LEAST(4000, length( cTexto) - nInicio ) );
  nInicio := INSTR(  cTexto, '-- Instru') ;

  IF nInicio > 0 THEN
     cTexto    := substr( cTexto, nInicio + 10, LEAST(4000, length( cTexto) - (nInicio+10) ) );
     nInicio   := INSTR(  cTexto, CHR(13)||CHR(10)) ;
     cTexto    := substr( cTexto, nInicio + 05, LEAST(3000, length( cTexto) - (nInicio+03) ) );
     nFim      := LEAST(  INSTR(  cTexto, '-- Tentativa realizada' ),
                          INSTR(  cTexto, '-- Instru' ) );
     IF nFim > 0 THEN
        Resultado := substr( cTexto, 1, nFim - 3 );
     ELSE
        Resultado := cTexto;
     END IF;
     RETURN Resultado;
  ELSE
     RETURN null;
  END IF;
END;
$$ language 'plpgsql';





/*-- SEQ 1894 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION INITCAP (text) CASCADE;

/*-- SEQ 1895 --*/
CREATE OR REPLACE FUNCTION INITCAP (text)
RETURNS text AS $$
DECLARE
texto ALIAS FOR $1 ;
  i      integer;
  aux    VARCHAR(1);
  result VARCHAR(150);
  resul1 VARCHAR(150);
  primeira boolean;
BEGIN
   result   := '';
   primeira := true;
   for i in 1..length(texto) loop
      aux := substr(texto,i,1);
      if primeira then
         aux := upper(aux);
         primeira := false;
      else
         if aux in (' ','-','/') then
            primeira := true;
         else
            aux := lower(aux);
         end if;
      end if; 
      result := result || aux;        
   end loop;               
   return result;
END;
$$ language 'plpgsql';




/*-- SEQ 1896 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION MASKCNPJ (VARCHAR) CASCADE;

/*-- SEQ 1897 --*/
CREATE OR REPLACE FUNCTION MASKCNPJ (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
CNPJ ALIAS FOR $1 ;
-- Objetivo
-- 1) Retornar o CNPJ com mascara
  WK_CNPJ  VARCHAR(18);
  sCNPJ   VARCHAR(14);

-- Principal
BEGIN

  sCNPJ:= substr(CNPJ,1,14);


  Select
  trim(Translate(To_Char(cast(sCNPJ as Numeric(14))/100, '00,000,000/0000.00') 
                 ,',.' 
                 ,'.-'))
    INTO WK_CNPJ FROM dual;





   RETURN WK_CNPJ;


END;
$$ language 'plpgsql';




/*-- SEQ 1898 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION MASKCPF (VARCHAR) CASCADE;

/*-- SEQ 1899 --*/
CREATE OR REPLACE FUNCTION MASKCPF (VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
CPF ALIAS FOR $1 ;
-- Objetivo
-- 1) Retornar o CPF com mascara
  WK_CPF  VARCHAR(18);
  sCPF   VARCHAR(11);
BEGIN 

  sCPF:= substr(CPF,1,11);

  Select Translate(To_Char(cast(sCPF as Numeric(11))/100
                        ,'000,000,000.00') 
                 ,',.' 
                 ,'.-') 
  INTO WK_CPF FROM dual;

   RETURN WK_CPF;


END;
$$ language 'plpgsql';





/*-- SEQ 1900 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PC_REC_AUX_UPDATE_PLUS (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE,TT_REC.FLGEST%TYPE) CASCADE;

/*-- SEQ 1901 --*/
CREATE OR REPLACE FUNCTION PC_REC_AUX_UPDATE_PLUS (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE,TT_REC.FLGEST%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_CODFIL ALIAS FOR $1 ;
p_SEQUEN ALIAS FOR $2 ;
p_NUMPAR ALIAS FOR $3 ;
p_SUBPAR ALIAS FOR $4 ;
p_FLGEST ALIAS FOR $5 ;

BEGIN
     UPDATE TT_REC SET FLGEST = 'C', DUMMY2 = 'T'  
      WHERE CODFIL = p_CODFIL
        AND SEQUEN = p_SEQUEN
	AND NUMPAR = p_NUMPAR
	AND SUBPAR = p_SUBPAR
	AND FLGEST = p_FLGEST ;


     RETURN NULL;


END;
$$ language 'plpgsql';




/*-- SEQ 1902 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RETIRA_DUPLO (VARCHAR,VARCHAR) CASCADE;

/*-- SEQ 1903 --*/
CREATE OR REPLACE FUNCTION RETIRA_DUPLO (VARCHAR,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pString ALIAS FOR $1 ;
pDuplo ALIAS FOR $2 ;
-- Paulo K. - 86857
  WK_TROCADO VARCHAR(256);
BEGIN
  SELECT REPLACE(pString, pDuplo||pDuplo, pDuplo)
    INTO WK_TROCADO
    FROM DUAL;	
 
  IF INSTR(WK_TROCADO, pDuplo||pDuplo) > 0 THEN
    RETURN RETIRA_DUPLO(WK_TROCADO, pDuplo);
  ELSE
    RETURN pString;
  END IF;

END;
$$ language 'plpgsql';




/*-- SEQ 1904 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TRAZNOSNUM (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE) CASCADE;

/*-- SEQ 1905 --*/
CREATE OR REPLACE FUNCTION TRAZNOSNUM (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_CODFIL ALIAS FOR $1 ;
p_SEQUEN ALIAS FOR $2 ;
p_NUMPAR ALIAS FOR $3 ;
p_SUBPAR ALIAS FOR $4 ;
  p_NOSNUM VARCHAR(20);
BEGIN 
SELECT TIT.NOSNUM INTO p_NOSNUM
  FROM TT_TIT TIT INNER JOIN TT_REC REC ON TIT.FILREC = REC.CODFIL AND TIT.SEQREC = REC.SEQUEN 
                                       AND TIT.PARREC = REC.NUMPAR AND TIT.SUBREC = REC.SUBPAR
 WHERE REC.CODFIL = p_CODFIL
   AND REC.SEQUEN = p_SEQUEN
   AND REC.NUMPAR = p_NUMPAR
   AND REC.SUBPAR = p_SUBPAR
   AND TIT.SEQCAN IS NULL;

  RETURN p_NOSNUM;

END;
$$ language 'plpgsql';




    
    /*-- SEQ 1906 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PC_REC_AUX_GeraTitulo (TT_REC.PORTAD%TYPE) CASCADE;

/*-- SEQ 1907 --*/
CREATE OR REPLACE FUNCTION PC_REC_AUX_GeraTitulo (TT_REC.PORTAD%TYPE)
RETURNS boolean AS $$
DECLARE
Chave ALIAS FOR $1 ;
    /* CNAB */
      wk_DUMMY INTEGER;
    BEGIN

      SELECT COUNT(*)
        INTO wk_DUMMY
        FROM TD_COB
       WHERE CODTAB = Chave
         AND GERTIT = 'T';

      RETURN (wk_DUMMY > 0);

   
    END;
$$ language 'plpgsql';


    /*-- SEQ 1908 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION PC_REC_AUX_TrazMaximo (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE) CASCADE;

/*-- SEQ 1909 --*/
CREATE OR REPLACE FUNCTION PC_REC_AUX_TrazMaximo (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE)
RETURNS TT_REC.SUBPAR%TYPE AS $$
DECLARE
p_chave1 ALIAS FOR $1 ;
p_chave2 ALIAS FOR $2 ;
p_chave3 ALIAS FOR $3 ;
      wk_retorno TT_REC.SUBPAR%TYPE;
    BEGIN

      SELECT LPAD( COALESCE(TRIM(to_char(MAX(to_number(SUBPAR)+1))),'0'),2,' ')
        INTO wk_retorno
        FROM TT_REC
       WHERE CODFIL = p_chave1
         AND SEQUEN = p_chave2
         AND NUMPAR = p_chave3;

       RETURN wk_retorno;

   END;
$$ language 'plpgsql';


   CREATE OR REPLACE FUNCTION PC_REC_AUX_UPDATE (TT_REC.CODFIL%TYPE,TT_REC.SEQUEN%TYPE,TT_REC.NUMPAR%TYPE,TT_REC.SUBPAR%TYPE,TT_REC.FLGEST%TYPE,TT_REC.PAGAME%TYPE,TT_REC.DATVEN%TYPE,TT_REC.CUPFIS%TYPE,TT_REC.VLRPGT%TYPE,TT_REC.VLRPAR%TYPE,TT_REC.FILUSU%TYPE,TT_REC.CODUSU%TYPE,TT_REC.PORTAD%TYPE,TT_REC.CODMOE%TYPE,TT_REC.SIGNAT%TYPE,TT_REC.VLRDES%TYPE,TT_REC.NUMECF%TYPE,TT_REC.FILREC%TYPE,TT_REC.SEQCHE%TYPE,TT_REC.CARTAO%TYPE,TT_REC.TIPCCC%TYPE,TT_REC.DATFIS%TYPE,TT_REC.SUBPAR%TYPE,TT_REC.PORTAD%TYPE,TT_REC.FILCTA%TYPE,TT_REC.SEQCTA%TYPE,TT_REC.TIPCTA%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pNUMPAR ALIAS FOR $3 ;
pSUBPAR ALIAS FOR $4 ;
pFLGEST ALIAS FOR $5 ;
pPAGAME ALIAS FOR $6 ;
pDATVEN ALIAS FOR $7 ;
pCUPFIS ALIAS FOR $8 ;
pVLRPGT ALIAS FOR $9 ;
pVLRPAR ALIAS FOR $10 ;
pFILUSU ALIAS FOR $11 ;
pCODUSU ALIAS FOR $12 ;
pPORTAD ALIAS FOR $13 ;
pCODMOE ALIAS FOR $14 ;
pSIGNAT ALIAS FOR $15 ;
pVLRDES ALIAS FOR $16 ;
pNUMECF ALIAS FOR $17 ;
pFILREC ALIAS FOR $18 ;
pSEQCHE ALIAS FOR $19 ;
pCARTAO ALIAS FOR $20 ;
pTIPCCC ALIAS FOR $21 ;
pDATFIS ALIAS FOR $22 ;
pOLDSUBPAR ALIAS FOR $23 ;
pOLDPORTAD ALIAS FOR $24 ;
pFILCTA ALIAS FOR $25 ;
pSEQCTA ALIAS FOR $26 ;
pTIPCTA ALIAS FOR $27 ;
     wk_maximo TT_REC.SUBPAR%TYPE;
     cVEM_DE_TGVEN CHAR(1) := constante('VEM_DE_TGVEN');
     
       wk_reg_tit RECORD;
          cDUMMY VARCHAR(10);
    BEGIN

     wk_maximo := PC_REC_AUX_TrazMaximo(pCODFIL,
                                        pSEQUEN,
                                        pNUMPAR);

     INSERT INTO TT_REC (CODFIL
                        ,SEQUEN
                        ,NUMPAR
                        ,SUBPAR
                        ,SUBORI
                        ,FLGEST
                        ,PAGAME
                        ,DATVEN
                        ,CUPFIS
                        ,VLRPGT
                        ,VLRPAR
                        ,FILUSU
                        ,CODUSU
                        ,PORTAD
                        ,CODMOE
                        ,SIGNAT
                        ,VLRDES
                        ,NUMECF
                        ,FILREC
                        ,SEQCHE
                        ,CARTAO
                        ,TIPCCC
                        ,DATFIS
                        ,DUMMY
                        ,FILCTA
                        ,SEQCTA
                        ,TIPCTA)
                 VALUES (pCODFIL
                        ,pSEQUEN
                        ,pNUMPAR
                        ,wk_maximo
                        ,pSUBPAR
                        ,pFLGEST
                        ,pPAGAME
                        ,pDATVEN
                        ,pCUPFIS
                        ,pVLRPGT
                        ,pVLRPAR
                        ,pFILUSU
                        ,pCODUSU
                        ,pPORTAD
                        ,pCODMOE
                        ,pSIGNAT
                        ,pVLRDES
                        ,pNUMECF
                        ,pFILREC
                        ,pSEQCHE
                        ,pCARTAO
                        ,pTIPCCC
                        ,pDATFIS
                        ,cVEM_DE_TGVEN -- Nao gerar outro titulo
                        ,pFILCTA
                        ,pSEQCTA
                        ,pTIPCTA);
                     
     -- DN 54512 - Reestruturao de Titulos
     IF TGR_GeraTitulo(pPORTAD) or TGR_GeraTitulo(pOLDPORTAD) THEN 
        cDUMMY:=INSERE_MTIT(pCODFIL,pSEQUEN,pNUMPAR,pFLGEST);
     END IF;
     -- DN 54512 - Fim Reestruturao de Titulos

     RETURN NULL;

END;
$$ language 'plpgsql';



/*-- SEQ 1910 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_CadastrarIXT (TT_TIT.CODFIL%TYPE,TT_TIT.SEQUEN%TYPE,TT_TIT.FILREC%TYPE,TT_TIT.SEQREC%TYPE,TT_TIT.PARREC%TYPE,TT_TIT.SUBREC%TYPE,TT_TIT.CODBCO%TYPE,TT_TIT.CODECB%TYPE,TT_TIT.CODCCB%TYPE,TT_TIT.DUMMY%TYPE,Numeric) CASCADE;

/*-- SEQ 1911 --*/
CREATE OR REPLACE FUNCTION TGR_CadastrarIXT (TT_TIT.CODFIL%TYPE,TT_TIT.SEQUEN%TYPE,TT_TIT.FILREC%TYPE,TT_TIT.SEQREC%TYPE,TT_TIT.PARREC%TYPE,TT_TIT.SUBREC%TYPE,TT_TIT.CODBCO%TYPE,TT_TIT.CODECB%TYPE,TT_TIT.CODCCB%TYPE,TT_TIT.DUMMY%TYPE,Numeric)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
pFILREC ALIAS FOR $3 ;
pSEQREC ALIAS FOR $4 ;
pPARREC ALIAS FOR $5 ;
pSUBREC ALIAS FOR $6 ;
pCODBCO ALIAS FOR $7 ;
pCODECB ALIAS FOR $8 ;
pCODCCB ALIAS FOR $9 ;
pDUMMY ALIAS FOR $10 ;
pRemessa ALIAS FOR $11 ;
 wk_CODMOE       Numeric(5);
  cVEM_DE_TGRTB   constant VARCHAR(100) := constante('vem_de_tgrtb');
 cDUMMY          CHAR(1);
BEGIN

 -- Atualizando TT_IXT
 IF 
    (COALESCE(TRIM(pDUMMY),'/') <> cVEM_DE_TGRTB) THEN

    SELECT COALESCE(min(CODMOE),0)
      INTO wk_CODMOE
      FROM tt_rec
     WHERE CODFIL = pFILREC
       AND SEQUEN = pSEQREC
       AND NUMPAR = pPARREC
       AND SUBPAR = pSUBREC;

      
    cDUMMY := PC_IXT_UPDATE(pCODFIL, pSEQUEN,pCODBCO,
                            pRemessa,pCODCCB,pCODECB,
                            wk_CODMOE);
   
 END IF;

 RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 1912 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TGR_ICO_Atualiza_Pedido (TT_ICO.CODFIL%TYPE,TT_ICO.SEQUEN%TYPE,TT_ICO.NUMITE%TYPE,TT_ICO.QTDMOV%TYPE) CASCADE;

/*-- SEQ 1913 --*/
CREATE OR REPLACE FUNCTION TGR_ICO_Atualiza_Pedido (TT_ICO.CODFIL%TYPE,TT_ICO.SEQUEN%TYPE,TT_ICO.NUMITE%TYPE,TT_ICO.QTDMOV%TYPE)
RETURNS VARCHAR AS $$
DECLARE
p_CodFil ALIAS FOR $1 ;
p_Sequen ALIAS FOR $2 ;
p_NumIte ALIAS FOR $3 ;
p_QtdMov ALIAS FOR $4 ;
-- Atualiza TT_IPE
   wk_IteAbe                     TT_IPE.NUMITE%TYPE;
   wk_IteIpe                     TT_IPE.NUMITE%TYPE;
   wk_IteOri                     TT_IPE.ITEORI%TYPE;
   wk_QtdCan                     TT_IPE.QTDCAN%TYPE;
   wk_Filial                     TT_IPE.CODFIL%TYPE;
   wk_Pedido                     TT_IPE.NUMPED%TYPE;
   wk_Conta                      Numeric;
   inRec                         TT_ICO%ROWTYPE;
   MAXIMO                        TT_IPE.NUMITE%TYPE;
   vORDITE                       TT_IPE.ORDITE%TYPE;
   WK_ENCFIL                     TT_IVEXIPE.CODFIL%TYPE;
   WK_SEQFIL                     TT_IVEXIPE.SEQUEN%TYPE;
   cFILIVE                       TT_IVEXIPE.FILIVE%TYPE;
   cSEQIVE                       TT_IVEXIPE.SEQIVE%TYPE;
   cNUMIVE                       TT_IVEXIPE.NUMIVE%TYPE;
   cFILPED                       TT_IVEXIPE.FILPED%TYPE;
   cTIPPED                       TT_IVEXIPE.TIPPED%TYPE;
   cNUMPED                       TT_IVEXIPE.NUMPED%TYPE;
   nNUMITE                       TT_IVEXIPE.NUMITE%TYPE;
   cDUMMY                        VARCHAR(1);

  -- RFMP 98466
  -- Separando o cursor em dois selects. Um para vnculo com a venda (sem televendas)
  -- Outro para vnculo com a DAV (com televendas)
  cENCOMENDAS CURSOR(pCODFIL TT_IPE.CODFIL%TYPE,
           pNUMPED TT_IPE.NUMPED%TYPE,
           pNUMITE TT_IPE.NUMITE%TYPE) IS
      SELECT CODFIL, SEQUEN, FILIVE, SEQIVE, NUMIVE, FILPED, TIPPED, NUMPED, NUMITE
        FROM TT_IVEXIPE
       WHERE FILIPE = pCODFIL
         AND NUMIPE = pNUMPED
         AND ITEIPE = pNUMITE
         AND FLGEST = 'R'
         -- RFMP 98466
         -- S reabre a encomenda se ainda no tiver nenhum entrega.
         AND QtdEntregue(FILIVE, SEQIVE, NUMIVE) = 0
         AND FILIVE IS NOT NULL
      UNION ALL
      SELECT ENC.CODFIL, ENC.SEQUEN, ENC.FILIVE, ENC.SEQIVE, ENC.NUMIVE, ENC.FILPED, ENC.TIPPED, ENC.NUMPED, ENC.NUMITE
        FROM TT_IVEXIPE ENC INNER JOIN TT_IOR IOR ON IOR.CODFIL = ENC.FILPED
                                                 AND IOR.TIPPED = ENC.TIPPED
                                                 AND IOR.NUMPED = ENC.NUMPED
                                                 AND IOR.NUMITE = ENC.NUMITE
       WHERE ENC.FILIPE = pCODFIL
         AND ENC.NUMIPE = pNUMPED
         AND ENC.ITEIPE = pNUMITE
         AND ENC.FLGEST = 'R'
         -- RFMP 98466
         -- S reabre a encomenda se ainda no tiver nota impressa.
         AND IOR.FILIVE IS NULL
         AND ENC.FILPED IS NOT NULL;

  cPEDIDOS CURSOR(pCODFIL TT_IPE.FILICO%TYPE,
           pSEQUEN TT_IPE.SEQICO%TYPE,
           pNUMICO TT_IPE.NUMICO%TYPE) IS
      SELECT CODFIL, NUMPED, NUMITE, ITEORI, QTDCAN
        FROM TT_IPE
       WHERE FILICO = pCODFIL
         AND SEQICO = pSEQUEN
         AND NUMICO = pNUMICO;

BEGIN
   OPEN cPEDIDOS(p_CODFIL,p_SEQUEN,p_NUMITE);
   LOOP
      FETCH cPEDIDOS INTO wk_Filial, wk_pedido, wk_iteIpe, wk_IteOri, wk_QtdCan;
      EXIT WHEN NOT FOUND;

      -- Cancela o item
      UPDATE TT_IPE
         SET FLGEST = 'C'
       WHERE CODFIL = wk_Filial
         AND NUMPED = wk_Pedido
         AND NUMITE = wk_IteIpe;

      -- RFMP 75328
      UPDATE TT_PED
         SET FLGEST = 'Y'
       WHERE CODFIL = wk_Filial
         AND NUMPED = wk_Pedido;

      BEGIN
        SELECT MAX(NUMITE)+1
          INTO MAXIMO
          FROM TT_IPE
         WHERE CODFIL = wk_Filial
           AND NUMPED = wk_Pedido;

        SELECT MAX(ORDITE)+1
          INTO vORDITE
          FROM TT_IPE
         WHERE CODFIL = wk_Filial
           AND NUMPED = wk_Pedido;

        INSERT INTO TT_IPE (CODFIL, NUMPED, NUMITE, CODMAT, CODMOE, CODTAM, CODCOR, FLGEST,
                            VLRVEN, VLRITE, QTDITE, IPIITE, FILMAT, DATREB, QTDCAN, CODBUS,
                            ICMITE, BASICM, VLRICM, OUTICM, ISEICM, VLRDES, FILENT, UNICOM,
                            UNIVEN, VALCON, FILORI, PEDORI, ITEORI, ATU_EM, ORDITE, QTDPED,
                            VLRUNI, VLRIPI, VLREMB)
        (SELECT CODFIL, NUMPED, MAXIMO,
                CODMAT, CODMOE, CODTAM, CODCOR, 'A' AS FLGEST,
                VLRVEN, VLRITE, QTDITE, IPIITE, FILMAT, DATREB, wk_QTDCAN, CODBUS,
                ICMITE, BASICM, VLRICM, OUTICM, ISEICM, VLRDES, FILENT, UNICOM,
                UNIVEN, VALCON, CODFIL, NUMPED, wk_IteIpe, agora(), vORDITE, QTDPED,
                VLRUNI, VLRIPI, VLREMB
         FROM  TT_IPE
         WHERE CODFIL = wk_Filial
           AND NUMPED = wk_Pedido
           AND NUMITE = wk_IteIpe);

        UPDATE TT_PED
           SET FLGEST = '2'
         WHERE CODFIL = wk_Filial
           AND NUMPED = wk_Pedido;

        OPEN cENCOMENDAS(wk_Filial,wk_Pedido,wk_IteIpe);
        LOOP
            FETCH cENCOMENDAS INTO WK_ENCFIL, WK_SEQFIL, cFILIVE, cSEQIVE, cNUMIVE, cFILPED, cTIPPED, cNUMPED, nNUMITE;
             EXIT WHEN NOT FOUND;

            INSERT INTO TT_IVExIPE (CODFIL,FILIVE,SEQIVE,NUMIVE,FLGEST,QTDENC,FILMAT,CODMAT,CODCOR,CODTAM,ATU_EM,DATINC,DATOPE,
                                    FILIPE,NUMIPE,ITEIPE,
                                    FILPED,TIPPED,NUMPED,NUMITE)
                                   (SELECT CODFIL,FILIVE,SEQIVE,NUMIVE,'E',QTDENC,FILMAT,CODMAT,CODCOR,CODTAM,Agora(),Agora(),DATOPE,
                                           FILIPE,NUMIPE,MAXIMO,
                                           FILPED,TIPPED,NUMPED,NUMITE
                                      FROM TT_IVExIPE
                                     WHERE FILIPE = wk_Filial
                                       AND NUMIPE = wk_Pedido
                                       AND ITEIPE = wk_IteIpe
                                       AND FLGEST <> 'C');

            UPDATE TT_IVEXIPE SET FLGEST = 'C'
             WHERE FILIPE = wk_Filial
               AND NUMIPE = wk_Pedido
               AND ITEIPE = wk_IteIpe;

            -- RFMP 98466
            --  necessrio reprocessar as separaes.
            IF cFILPED IS NOT NULL THEN
               UPDATE TT_IOR
                  SET FLGIVO = 'A'
                WHERE CODFIL = cFILPED
                  AND TIPPED = cTIPPED
                  AND NUMPED = cNUMPED
                  AND NUMITE = nNUMITE;
            END IF;

        END LOOP;
        CLOSE cENCOMENDAS;
      END;
   END LOOP;
   CLOSE cPEDIDOS;
Return null;

END;
$$ language 'plpgsql';






/*-- SEQ 1914 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION SPAUX_PROCTIT_Nosso_Numero(Numeric,CHAR,CHAR,CHAR,Numeric,CHAR,CHAR,CHAR,CHAR,CHAR,CHAR);

/*-- SEQ 1915 --*/
CREATE FUNCTION SPAUX_PROCTIT_Nosso_Numero(p_Quantidade in Numeric,
                                           p_CODBCO in CHAR,
                                           p_NUMAGE in CHAR,
                                           p_CTACRR in CHAR,
                                           p_CODCCB in Numeric,
                                           p_STATUS2 in CHAR,
                                           p_DIGCRR in CHAR,
                                           p_STATUS in CHAR,
                                           p_DIGAGE in CHAR,
                                           p_NUMAGE_NOSNUM in CHAR,
                                           p_DIGAGE_NOSNUM in CHAR,
                                           Retorno out VARCHAR) AS $$
DECLARE
-- Declarao de variveis e cursores
   nContador                     Numeric;
   rNossoNum                     TPC_TIT_RETORNO;

-- Incio da funo
BEGIN
   Retorno := '';
   FOR n_Contador IN 1..p_Quantidade LOOP
      /* 102646 - Retirado gerao de numeraes j com a formatao devido ao componente ACBr espera apenas a numerao */
      --rNossoNum := AUX_PROCTIT_Nosso_Numero(p_CODBCO,p_NUMAGE,p_CTACRR,p_CODCCB,p_STATUS2,p_DIGCRR,p_STATUS,p_DIGAGE,p_NUMAGE_NOSNUM,p_DIGAGE_NOSNUM);
      --Retorno   := Retorno||','||rNossoNum.NOME;
      rNossoNum := AUX_PROCTIT_Proximo_Numero(p_CODBCO,p_NUMAGE,p_CTACRR,p_CODCCB,p_STATUS);
      Retorno   := Retorno||','||rNossoNum.NUMERO;
   END LOOP;

   Retorno := SUBSTR(Retorno,2);
END;
$$ LANGUAGE plpgsql;



/*-- SEQ 1916 --*/
/*-- IGNORE ERRO --*/
DROP VIEW ALL_TABLES CASCADE;

/*-- SEQ 1917 --*/
CREATE OR REPLACE VIEW ALL_TABLES AS
SELECT schemaname::varchar as owner, tablename::varchar as table_name, null::varchar as _name
  FROM pg_tables;

/*-- SEQ 1918 --*/
/*-- IGNORE ERRO --*/
DROP VIEW USER_TABLES CASCADE;

/*-- SEQ 1919 --*/
CREATE OR REPLACE VIEW USER_TABLES AS
SELECT tablename::varchar as table_name, null::varchar as _name
  FROM pg_tables
 WHERE tableowner = current_schema();

/*-- SEQ 1920 --*/
/*-- IGNORE ERRO --*/
DROP VIEW ALL_TAB_COLUMNS CASCADE;

/*-- SEQ 1921 --*/
CREATE OR REPLACE VIEW ALL_TAB_COLUMNS AS
 SELECT scm.nspname::varchar as owner,
        tab.relname::varchar as table_name,
        col.attname::varchar as column_name,
        tipo.typname::varchar as data_type,
        CASE col.atttypid WHEN 1700 THEN trunc((col.atttypmod-4)/65536)
                          ELSE CASE WHEN col.atttypmod < 0 then tipo.typlen
                                    ELSE col.atttypmod-4
                               END
        END as data_length,
        CASE col.atttypid WHEN 1700 THEN trunc((col.atttypmod-4)/65536)
                          ELSE CASE WHEN col.atttypmod < 0 then tipo.typlen
                                    ELSE col.atttypmod-4
                               END
        END as data_precision,
        CASE when col.atttypid=1700 THEN mod (col.atttypmod-4, 65536)
        END as data_scale,
        CASE WHEN col.attnotnull THEN 'N'
                                 ELSE 'Y'
        END AS NULLABLE,
        col.attnum as column_id,
        pg_get_expr(def.adbin, def.adrelid, true) as data_default
   FROM pg_class tab
        LEFT  JOIN pg_namespace scm  ON (scm.oid = tab.relnamespace)
        INNER JOIN pg_attribute col  ON (col.attrelid = tab.oid)
        INNER JOIN pg_type      tipo ON (tipo.oid     = col.atttypid)
        LEFT  JOIN pg_attrdef   def  ON (def.adrelid  = col.attrelid and def.adnum = col.attnum)
 WHERE ((tab.relkind = 'r') OR (tab.relkind = 's'))                       -- r(Table), s(Special)
   AND has_table_privilege(tab.oid, 'select')
   AND col.atttypid not between 26 and 29                                 -- Esconder colunas internas
 UNION ALL
 SELECT scm.nspname::varchar as owner,
        tab.relname::varchar as table_name,
        col.attname::varchar as column_name,
        tipo.typname::varchar as data_type,
        CASE col.atttypid WHEN 1700 THEN trunc((col.atttypmod-4)/65536)
                          ELSE CASE WHEN col.atttypmod < 0 then tipo.typlen
                                    ELSE col.atttypmod-4
                               END
        END as data_length,
        CASE col.atttypid WHEN 1700 THEN trunc((col.atttypmod-4)/65536)
                          ELSE CASE WHEN col.atttypmod < 0 then tipo.typlen
                                    ELSE col.atttypmod-4
                               END
        END as data_precision,
        CASE when col.atttypid=1700 THEN mod (col.atttypmod-4, 65536)
        END as data_scale,
        CASE WHEN col.attnotnull THEN 'N'
                                 ELSE 'Y'
        END AS NULLABLE,
        col.attnum as column_id,
        pg_get_expr(def.adbin, def.adrelid, true) as data_default
   FROM pg_class tab
        LEFT  JOIN pg_namespace scm  ON (scm.oid = tab.relnamespace)
        INNER JOIN pg_attribute col  ON (col.attrelid = tab.oid)
        INNER JOIN pg_type      tipo ON (tipo.oid     = col.atttypid)
        LEFT  JOIN pg_attrdef   def  ON (def.adrelid  = col.attrelid and def.adnum = col.attnum)
  WHERE (tab.relkind = 'v')                                                -- v(View)
    AND has_table_privilege(tab.oid, 'select')
    AND col.atttypid not between 26 and 29;                                -- Esconder colunas internas

/*-- SEQ 1922 --*/
/*-- IGNORE ERRO --*/
DROP VIEW USER_TAB_COLUMNS CASCADE;

/*-- SEQ 1923 --*/
CREATE OR REPLACE VIEW USER_TAB_COLUMNS AS
 SELECT tab.relname::varchar as table_name,
        col.attname::varchar as column_name,
        tipo.typname::varchar as data_type,
        CASE col.atttypid WHEN 1700 THEN trunc((col.atttypmod-4)/65536)
                          ELSE CASE WHEN col.atttypmod < 0 then tipo.typlen
                                    ELSE col.atttypmod-4
                               END
        END as data_length,
        CASE col.atttypid WHEN 1700 THEN trunc((col.atttypmod-4)/65536)
                          ELSE CASE WHEN col.atttypmod < 0 then tipo.typlen
                                    ELSE col.atttypmod-4
                               END
        END as data_precision,
        CASE when col.atttypid=1700 THEN mod (col.atttypmod-4, 65536)
        END as data_scale,
        col.attnum as column_id,
        pg_get_expr(def.adbin, def.adrelid, true) as data_default
   FROM pg_class tab
        LEFT  JOIN pg_namespace scm  ON (scm.oid = tab.relnamespace)
        INNER JOIN pg_attribute col  ON (col.attrelid  = tab.oid)
        INNER JOIN pg_type      tipo ON (tipo.oid      = col.atttypid)
        LEFT  JOIN pg_attrdef   def  ON (def.adrelid   = col.attrelid and def.adnum = col.attnum)
 WHERE ((tab.relkind = 'r') OR (tab.relkind = 's'))                       -- r(Table), s(Special)
   AND has_table_privilege(tab.oid, 'select')
   AND col.atttypid not between 26 and 29                                 -- Esconder colunas internas
   AND scm.nspname = current_schema()
UNION ALL
 SELECT tab.relname::varchar as table_name,
        col.attname::varchar as column_name,
        tipo.typname::varchar as data_type,
        CASE col.atttypid WHEN 1700 THEN trunc((col.atttypmod-4)/65536)
                          ELSE CASE WHEN col.atttypmod < 0 then tipo.typlen
                                    ELSE col.atttypmod-4
                               END
        END as data_length,
        CASE col.atttypid WHEN 1700 THEN trunc((col.atttypmod-4)/65536)
                          ELSE CASE WHEN col.atttypmod < 0 then tipo.typlen
                                    ELSE col.atttypmod-4
                               END
        END as data_precision,
        CASE when col.atttypid=1700 THEN mod (col.atttypmod-4, 65536)
        END as data_scale,
        col.attnum as column_id,
        pg_get_expr(def.adbin, def.adrelid, true) as data_default
   FROM pg_class tab
        LEFT  JOIN pg_namespace scm  ON (scm.oid = tab.relnamespace)
        INNER JOIN pg_attribute col  ON (col.attrelid = tab.oid)
        INNER JOIN pg_type      tipo ON (tipo.oid     = col.atttypid)
        LEFT  JOIN pg_attrdef   def  ON (def.adrelid  = col.attrelid and def.adnum = col.attnum)
  WHERE (tab.relkind = 'v')                                                -- v(View)
    AND has_table_privilege(tab.oid, 'select')
    AND col.atttypid not between 26 and 29                                 -- Esconder colunas internas
    AND scm.nspname = current_schema();

/*-- SEQ 1924 --*/
/*-- IGNORE ERRO --*/
DROP VIEW all_constraints CASCADE;

/*-- SEQ 1925 --*/
CREATE OR REPLACE VIEW all_constraints AS
 SELECT scm.nspname::varchar as owner,
        c.conname::varchar as constraint_name,
        CASE c.contype WHEN 'f' THEN 'r'
                                ELSE c.contype
        END::char(1) as constraint_type,
        tab.relname::varchar as table_name,
        pg_get_constraintdef(c.oid) as search_condition,
        rscm.nspname::varchar as r_owner,
        rc.conname::varchar as r_constraint_name,
        CASE c.confdeltype WHEN 'a' THEN 'no action'
                           WHEN 'c' THEN 'cascade'
        END as delete_rule,
        'enabled'::bpchar as STATUS
   FROM pg_constraint c
        inner join pg_class tab      ON (tab.oid  = c.conrelid)
        left  join pg_namespace scm  ON (scm.oid  = tab.relnamespace)
        left  join pg_class rtab     ON (rtab.oid = c.confrelid)
        left  join pg_namespace rscm ON (rscm.oid = rtab.relnamespace)
        left  join pg_constraint rc  ON (rc.conrelid = c.confrelid and rc.conkey = c.confkey and c.contype = 'f' and rc.contype in ('p','u'))
  WHERE has_table_privilege(tab.oid, 'select')
 UNION ALL
 SELECT scm.nspname::varchar as owner,
        'nn_'||substr(tab.relname,4)||'_'||col.attname::bpchar as constraint_name,
        'c'::char(1) as contraint_type,
        tab.relname::varchar as table_name,
        col.attname||' is not null'::text as search_condition,
        null::char(10), null::char(10) as r_constraint_name,
        null::char(10) as delete_rule, 'enabled'::bpchar as STATUS
   FROM pg_class tab
        LEFT  JOIN pg_namespace scm  ON (scm.oid = tab.relnamespace)
        INNER JOIN pg_attribute col  ON (col.attrelid = tab.oid)
  WHERE has_table_privilege(tab.oid, 'select')
    AND ((tab.relkind = 'r') OR (tab.relkind = 's'))
    AND col.atttypid not between 26 and 29                                 -- Esconder colunas internas
    AND col.attnotnull;                                                    --  not Null

/*-- SEQ 1926 --*/
/*-- IGNORE ERRO --*/
DROP VIEW user_constraints CASCADE;

/*-- SEQ 1927 --*/
CREATE OR REPLACE VIEW user_constraints AS
SELECT scm.nspname::varchar as owner,
       c.conname::varchar as constraint_name,
       CASE c.contype WHEN 'f' THEN 'r'
                               ELSE c.contype
       END::varchar as constraint_type,
       tab.relname::varchar as table_name,
       pg_get_constraintdef(c.oid) as search_condition,
       rscm.nspname::varchar as r_owner,
       rc.conname::varchar as r_constraint_name,
       CASE c.confdeltype WHEN 'a' THEN 'no action'
                          WHEN 'c' THEN 'cascade'
       END as delete_rule,
       'enabled'::bpchar as STATUS
  FROM pg_constraint c
       inner join pg_class tab      ON (tab.oid  = c.conrelid)
       left  join pg_namespace scm  ON (scm.oid  = tab.relnamespace)
       left  join pg_class rtab     ON (rtab.oid = c.confrelid)
       left  join pg_namespace rscm ON (rscm.oid = rtab.relnamespace)
       left  join pg_constraint rc  ON (rc.conrelid = c.confrelid and rc.conkey = c.confkey and c.contype = 'f' and rc.contype in ('p','u'))
 WHERE has_table_privilege(tab.oid, 'select')
   AND scm.nspname = current_schema()
 UNION ALL
 SELECT scm.nspname::varchar as owner,
        'nn_'||substr(tab.relname,4)||'_'||col.attname::varchar as constraint_name,
        'c'::char(1) as constraint_type,
        tab.relname::varchar as table_name,
        col.attname||' is not null'::text as search_condition,
        null::char(10), null::char(10) as r_constraint_name,
        null::char(10) as delete_rule, 'enabled'::bpchar as STATUS
   FROM pg_class tab
        LEFT  JOIN pg_namespace scm  ON (scm.oid = tab.relnamespace)
        INNER JOIN pg_attribute col  ON (col.attrelid = tab.oid)
  WHERE has_table_privilege(tab.oid, 'select')
    AND ((tab.relkind = 'r') OR (tab.relkind = 's'))
    AND scm.nspname = current_schema()
    AND col.atttypid not between 26 and 29                                 -- Esconder colunas internas
    AND col.attnotnull;                                                    --  not Null

/*-- SEQ 1928 --*/
/*-- IGNORE ERRO --*/
DROP VIEW ALL_CONS_COLUMNS CASCADE;

/*-- SEQ 1929 --*/
CREATE OR REPLACE VIEW ALL_CONS_COLUMNS AS
  SELECT scm.nspname::varchar as owner,
         c.conname::varchar as constraint_name,
         tab.relname::varchar as table_name,
         a.attname::varchar as column_name,
         array_find(c.conkey, a.attnum) as position
    FROM pg_constraint c
         inner join pg_class tab      ON (tab.oid    = c.conrelid)
         left  join pg_namespace scm  ON (scm.oid    = tab.relnamespace)
         left  join pg_attribute a    ON (a.attrelid = c.conrelid  and a.attnum = any(c.conkey))
   WHERE has_table_privilege(tab.oid, 'select')
UNION ALL
 SELECT scm.nspname::varchar as owner,
        'nn_'||substr(tab.relname,4)||'_'||col.attname::bpchar as constraint_name,
        tab.relname::varchar as table_name,
        col.attname::varchar as column_name,
        null::smallint as position
   FROM pg_class tab
        LEFT  JOIN pg_namespace scm  ON (scm.oid = tab.relnamespace)
        INNER JOIN pg_attribute col  ON (col.attrelid = tab.oid)
  WHERE has_table_privilege(tab.oid, 'select')
    AND ((tab.relkind = 'r') OR (tab.relkind = 's'))
    AND col.atttypid not between 26 and 29                                 -- Esconder colunas internas
    AND col.attnotnull;                                                    --  not Null

/*-- SEQ 1930 --*/
/*-- IGNORE ERRO --*/
DROP VIEW USER_CONS_COLUMNS CASCADE;

/*-- SEQ 1931 --*/
CREATE OR REPLACE VIEW USER_CONS_COLUMNS AS
  SELECT scm.nspname::varchar as owner,
         c.conname::varchar as constraint_name,
         tab.relname::varchar as table_name,
         a.attname::varchar as column_name,
         array_find(c.conkey, a.attnum) as position
    FROM pg_constraint c
         inner join pg_class tab      ON (tab.oid    = c.conrelid)
         left  join pg_namespace scm  ON (scm.oid    = tab.relnamespace)
         left  join pg_attribute a    ON (a.attrelid = c.conrelid  and a.attnum = any (c.conkey) )
   WHERE has_table_privilege(tab.oid, 'select')
     AND scm.nspname = current_schema()
UNION ALL
 SELECT scm.nspname::varchar as owner,
        'nn_'||substr(tab.relname,4)||'_'||col.attname::bpchar as constraint_name,
        tab.relname::varchar as table_name,
        col.attname::varchar as column_name,
        null::smallint as position
   FROM pg_class tab
        LEFT  JOIN pg_namespace scm  ON (scm.oid = tab.relnamespace)
        INNER JOIN pg_attribute col  ON (col.attrelid = tab.oid)
  WHERE has_table_privilege(tab.oid, 'select')
    AND ((tab.relkind = 'r') OR (tab.relkind = 's'))
    AND scm.nspname = current_schema()
    AND col.atttypid not between 26 and 29                                 -- Esconder colunas internas
    AND col.attnotnull;                                                    --  not Null

/*-- SEQ 1932 --*/
/*-- IGNORE ERRO --*/
DROP VIEW ALL_VIEWS CASCADE;

/*-- SEQ 1933 --*/
CREATE OR REPLACE VIEW ALL_VIEWS AS
  SELECT n.nspname::varchar as owner,
         c.relname::varchar as view_name,
         pg_get_viewdef(c.oid) as text
    FROM pg_class c LEFT JOIN pg_namespace n ON (n.oid = c.relnamespace)
   WHERE (c.relkind = 'v')
     AND has_table_privilege(c.oid, 'select');

/*-- SEQ 1934 --*/
/*-- IGNORE ERRO --*/
DROP VIEW USER_VIEWS CASCADE;

/*-- SEQ 1935 --*/
CREATE OR REPLACE VIEW USER_VIEWS AS
  SELECT n.nspname::varchar as owner,
         c.relname::varchar as view_name,
         pg_get_viewdef(c.oid) as text
    FROM pg_class c LEFT JOIN pg_namespace n ON (n.oid = c.relnamespace)
   WHERE (c.relkind = 'v')
     AND n.nspname = current_schema()
     AND has_table_privilege(c.oid, 'select');

/*-- SEQ 1936 --*/
/*-- IGNORE ERRO --*/
DROP VIEW ALL_INDEXES CASCADE;

/*-- SEQ 1937 --*/
CREATE OR REPLACE VIEW ALL_INDEXES AS
  SELECT scm.nspname::varchar as owner,
         class.relname::varchar as index_name,
         'normal'::bpchar as index_type,
         scm.nspname::varchar as table_owner,
         tab.relname::varchar as table_name,
         'table'::varchar as table_type,
         CASE WHEN indisunique THEN 'unique'::bpchar ELSE 'nounique' END as uniqueness,
         null::char as _name,
         /* "METRICA" */
         null::integer as INI_TRANS, null::integer as MAX_TRANS, null::integer as PCT_FREE,
         /* STORAGE */
         null::integer as INITIAL_EXTENT,
         null::integer as NEXT_EXTENT,
         null::integer as PCT_INCREASE,
         null::integer as MIN_EXTENTS,
         null::integer as MAX_EXTENTS,
         null::integer as FREELISTS,
         null::integer as FREELIST_GROUPS
    FROM pg_class class
         INNER JOIN pg_index idx ON (idx.indexrelid = class.oid)
         INNER JOIN pg_class tab ON (tab.oid = idx.indrelid)
         INNER JOIN pg_namespace scm  ON (scm.oid = tab.relnamespace)
   WHERE ((tab.relkind = 'r') OR (tab.relkind = 's'))                       -- r(Table), s(Special)
     AND (class.relkind = 'i')                                              -- i(Index)
     AND has_table_privilege(tab.oid, 'select');

/*-- SEQ 1938 --*/
/*-- IGNORE ERRO --*/
DROP VIEW ALL_IND_COLUMNS CASCADE;

/*-- SEQ 1939 --*/
CREATE OR REPLACE VIEW ALL_IND_COLUMNS AS
  SELECT scm.nspname::varchar as index_owner,
         class.relname::varchar as index_name,
         scm.nspname::varchar as table_owner,
         tab.relname::varchar as table_name,
         col.attname::varchar as column_name,
         col.attnum::varchar as column_position,
         'asc'::bpchar as descend
    FROM pg_class class
         INNER JOIN pg_attribute col ON (col.attrelid = class.oid)
         INNER JOIN pg_index idx     ON (idx.indexrelid = class.oid)
         INNER JOIN pg_class tab     ON (tab.oid = idx.indrelid)
         INNER JOIN pg_namespace scm ON (scm.oid = tab.relnamespace)
   WHERE ((tab.relkind = 'r') OR (tab.relkind = 's'))                       -- r(Table), s(Special)
     AND (class.relkind = 'i')                                              -- i(Index)
     AND has_table_privilege(tab.oid, 'select');

/*-- SEQ 1940 --*/
/*-- IGNORE ERRO --*/
DROP VIEW ALL_USERS CASCADE;

/*-- SEQ 1941 --*/
CREATE OR REPLACE VIEW ALL_USERS AS
  SELECT usename::varchar as username,
         usesysid as user_id
    FROM pg_shadow;

/*-- SEQ 1942 --*/
/*-- IGNORE ERRO --*/
DROP VIEW DBA_ROLE_PRIVS CASCADE;

/*-- SEQ 1943 --*/
CREATE OR REPLACE VIEW DBA_ROLE_PRIVS AS
  SELECT a.usename::varchar AS GRANTEE,
         b.groname::varchar AS GRANTED_ROLE,
         'no'::varchar AS ADMIN_OPTION ,'yes' AS DEFAULT_ROLE
    FROM pg_shadow a
         INNER JOIN pg_group b on  a.usesysid = any(b.grolist)
  UNION ALL
  SELECT usename::varchar AS GRANTEE, 'dba', 'no' , 'yes'
    FROM pg_shadow a
   WHERE usesuper = true;

/*-- SEQ 1944 --*/
/*-- IGNORE ERRO --*/
DROP VIEW ALL_TAB_PRIVS CASCADE;

/*-- SEQ 1945 --*/
CREATE OR REPLACE VIEW ALL_TAB_PRIVS AS
-- ALL_TAB_PRIVS
-- ALL_TAB_PRIVS lists the grants on objects where the user or PUBLIC is the grantee. This view does not display the OWNER column.
select c.usename::VARCHAR   as GRANTOR,
       d.grantee   as GRANTEE,
       c.usename::VARCHAR   as OWNER,
       b.nspname::VARCHAR   as TABLE_SCHEMA,
       a.relname::VARCHAR   as TABLE_NAME,
       d.privilege as PRIVILEGE,
       'no'::varchar        as GRANTABLE
from
     pg_class a
     inner join pg_namespace b on b.oid = a.relnamespace
     inner join pg_shadow c on c.usesysid = a.relowner
     inner join GetPrivileges() d on a.relowner = d.idowner and a.relname::VARCHAR = d.table_name
where relkind in ('r','v','t');

/*-- SEQ 1946 --*/
/*-- IGNORE ERRO --*/
DROP VIEW all_procs CASCADE;

/*-- SEQ 1947 --*/
CREATE OR REPLACE VIEW all_procs AS
  select a.proname::varchar as proc_name,
         scm.nspname::varchar as owner,
         'FUNCTION'::varchar as type,
         TrazFuncao(a.proname::varchar,lan.lanname::varchar, typret.typname::varchar , a.pronargs, a.proargtypes, a.prosrc::varchar) as text
    from pg_proc a
         inner join pg_namespace scm on a.pronamespace = scm.oid
         inner join pg_language lan on a.prolang = lan.oid
         inner join pg_type typret on a.prorettype = typret.oid;

/*-- SEQ 1948 --*/
/*-- IGNORE ERRO --*/
DROP VIEW user_procs CASCADE;

/*-- SEQ 1949 --*/
CREATE OR REPLACE VIEW user_procs AS
  select a.proname::varchar as proc_name,
         'FUNCTION'::varchar as type,
         TrazFuncao(a.proname::varchar,lan.lanname::varchar, typret.typname::varchar , a.pronargs, a.proargtypes, a.prosrc::varchar) as text
    from pg_proc a
         inner join pg_namespace scm on a.pronamespace = scm.oid
         inner join pg_language lan on a.prolang = lan.oid
         inner join pg_type typret on a.prorettype = typret.oid
   where scm.nspname = current_schema();

/*-- SEQ 1950 --*/
/*-- IGNORE ERRO --*/
DROP VIEW all_triggers CASCADE;

/*-- SEQ 1951 --*/
/*-- IGNORE ERRO --*/
-- PostgreSQL 8.2 ou anterior
CREATE VIEW all_triggers AS
 SELECT SPC.NSPNAME::varchar AS OWNER,
       TRG.TGNAME::varchar AS TRIGGER_NAME,
       CASE WHEN MOD(MOD(MOD(TRG.TGTYPE,16),8),4)>=2 THEN 'BEFORE'
                                             ELSE 'AFTER'
       END || ' ' || INF.ACTION AS TRIGGER_TYPE,
       TRG.EVINSERT||
       CASE WHEN (TRG.EVUPDATE='') OR (TRG.EVUPDATE IS NULL) THEN
            CASE WHEN (TRG.EVINSERT='') OR (TRG.EVINSERT IS NULL) THEN ' OR '||TRG.EVUPDATE
                                                  ELSE TRG.EVUPDATE
            END
       ELSE
            ''
       END||
       CASE WHEN (TRG.EVDELETE='') OR (TRG.EVDELETE IS NULL) THEN
            CASE WHEN  (COALESCE(TRG.EVINSERT,'')||COALESCE(TRG.EVUPDATE,'')='') OR ((TRG.EVINSERT IS NULL) AND (TRG.EVUPDATE IS NULL)) THEN ' OR '||TRG.EVDELETE
                                                                ELSE TRG.EVDELETE
            END
       ELSE
            ''
        END AS TRIGGERING_EVENT,
       TABOWN.NSPNAME::varchar AS TABLE_OWNER,
       TO_CHAR('TABLE') AS BASE_OBJECT_TYPE,
       TAB.RELNAME::varchar  AS TABLE_NAME,
       TO_CHAR('') AS COLUMNNAME,
       TO_CHAR('') AS REFERENCING_NAMES,
       TO_CHAR('') AS WHEN_CLAUSES,
       CASE TRG.TGENABLED WHEN TRUE THEN 'ENABLED'
                                    ELSE 'DISABLED'
       END AS STATUS,
       TO_CHAR('') AS DESCRIPTION,
       TO_CHAR('PL/SQL') AS ACTION_TYPE,
       PRO.PROSRC AS TRIGGER_BODY,
       PRO.PRONAME::varchar AS FUNCTION_NAME
  FROM (SELECT CASE WHEN MOD(MOD(TRG.TGTYPE,16),8)>=4 THEN 'INSERT'
                                                  ELSE ''
                END AS EVINSERT,
                CASE WHEN TRG.TGTYPE>=16 THEN 'UPDATE'
                                     ELSE ''
                END AS EVUPDATE,
                CASE WHEN MOD(TRG.TGTYPE,16)>=8 THEN 'DELETE'
                                            ELSE ''
                END AS EVDELETE,
                TRG.*
          FROM PG_TRIGGER TRG
          WHERE not tgisconstraint
        ) TRG INNER JOIN PG_PROC PRO ON TRG.TGFOID=PRO.OID
              INNER JOIN PG_NAMESPACE SPC ON SPC.OID=PRO.PRONAMESPACE
              INNER JOIN PG_CLASS TAB ON TRG.TGRELID=TAB.OID
              INNER JOIN PG_NAMESPACE TABOWN ON TABOWN.OID=TAB.RELNAMESPACE
              LEFT JOIN (SELECT TRIGGER_SCHEMA, TRIGGER_NAME, ACTION_ORIENTATION AS ACTION
                            FROM INFORMATION_SCHEMA.TRIGGERS
                           GROUP BY TRIGGER_SCHEMA, TRIGGER_NAME, ACTION_ORIENTATION
                         ) INF ON SPC.NSPNAME = INF.TRIGGER_SCHEMA AND TRG.TGNAME=INF.TRIGGER_NAME;

/*-- SEQ 1952 --*/
/*-- IGNORE ERRO --*/
-- PostgreSQL 8.4 ou posterior
CREATE VIEW all_triggers AS
 SELECT SPC.NSPNAME::varchar AS OWNER,
       TRG.TGNAME::varchar AS TRIGGER_NAME,
       CASE WHEN MOD(MOD(MOD(TRG.TGTYPE,16),8),4)>=2 THEN 'BEFORE'
                                             ELSE 'AFTER'
       END || ' ' || INF.ACTION AS TRIGGER_TYPE,
       TRG.EVINSERT||
       CASE WHEN (TRG.EVUPDATE='') OR (TRG.EVUPDATE IS NULL) THEN
            CASE WHEN (TRG.EVINSERT='') OR (TRG.EVINSERT IS NULL) THEN ' OR '||TRG.EVUPDATE
                                                  ELSE TRG.EVUPDATE
            END
       ELSE
            ''
       END||
       CASE WHEN (TRG.EVDELETE='') OR (TRG.EVDELETE IS NULL) THEN
            CASE WHEN  (COALESCE(TRG.EVINSERT,'')||COALESCE(TRG.EVUPDATE,'')='') OR ((TRG.EVINSERT IS NULL) AND (TRG.EVUPDATE IS NULL)) THEN ' OR '||TRG.EVDELETE
                                                                ELSE TRG.EVDELETE
            END
       ELSE
            ''
        END AS TRIGGERING_EVENT,
       TABOWN.NSPNAME::varchar AS TABLE_OWNER,
       TO_CHAR('TABLE') AS BASE_OBJECT_TYPE,
       TAB.RELNAME::varchar  AS TABLE_NAME,
       TO_CHAR('') AS COLUMNNAME,
       TO_CHAR('') AS REFERENCING_NAMES,
       TO_CHAR('') AS WHEN_CLAUSES,
       CASE WHEN TRG.TGENABLED<>'D' THEN 'ENABLED'
                                    ELSE 'DISABLED'
       END AS STATUS,
       TO_CHAR('') AS DESCRIPTION,
       TO_CHAR('PL/SQL') AS ACTION_TYPE,
       PRO.PROSRC AS TRIGGER_BODY,
       PRO.PRONAME::varchar AS FUNCTION_NAME
  FROM (SELECT CASE WHEN MOD(MOD(TRG.TGTYPE,16),8)>=4 THEN 'INSERT'
                                                  ELSE ''
                END AS EVINSERT,
                CASE WHEN TRG.TGTYPE>=16 THEN 'UPDATE'
                                     ELSE ''
                END AS EVUPDATE,
                CASE WHEN MOD(TRG.TGTYPE,16)>=8 THEN 'DELETE'
                                            ELSE ''
                END AS EVDELETE,
                TRG.*
          FROM PG_TRIGGER TRG
          WHERE not tgisconstraint
        ) TRG INNER JOIN PG_PROC PRO ON TRG.TGFOID=PRO.OID
              INNER JOIN PG_NAMESPACE SPC ON SPC.OID=PRO.PRONAMESPACE
              INNER JOIN PG_CLASS TAB ON TRG.TGRELID=TAB.OID
              INNER JOIN PG_NAMESPACE TABOWN ON TABOWN.OID=TAB.RELNAMESPACE
              LEFT JOIN (SELECT TRIGGER_SCHEMA, TRIGGER_NAME, ACTION_ORIENTATION AS ACTION
                            FROM INFORMATION_SCHEMA.TRIGGERS
                           GROUP BY TRIGGER_SCHEMA, TRIGGER_NAME, ACTION_ORIENTATION
                         ) INF ON SPC.NSPNAME = INF.TRIGGER_SCHEMA AND TRG.TGNAME=INF.TRIGGER_NAME;

/*-- SEQ 1953 --*/
/*-- IGNORE ERRO --*/
-- PostgreSQL 9.0 ou posterior
CREATE VIEW all_triggers AS
 SELECT SPC.NSPNAME::varchar AS OWNER,
       TRG.TGNAME::varchar AS TRIGGER_NAME,
       CASE WHEN MOD(MOD(MOD(TRG.TGTYPE,16),8),4)>=2 THEN 'BEFORE'
                                             ELSE 'AFTER'
       END || ' ' || INF.ACTION AS TRIGGER_TYPE,
       TRG.EVINSERT||
       CASE WHEN (TRG.EVUPDATE='') OR (TRG.EVUPDATE IS NULL) THEN
            CASE WHEN (TRG.EVINSERT='') OR (TRG.EVINSERT IS NULL) THEN ' OR '||TRG.EVUPDATE
                                                  ELSE TRG.EVUPDATE
            END
       ELSE
            ''
       END||
       CASE WHEN (TRG.EVDELETE='') OR (TRG.EVDELETE IS NULL) THEN
            CASE WHEN  (COALESCE(TRG.EVINSERT,'')||COALESCE(TRG.EVUPDATE,'')='') OR ((TRG.EVINSERT IS NULL) AND (TRG.EVUPDATE IS NULL)) THEN ' OR '||TRG.EVDELETE
                                                                ELSE TRG.EVDELETE
            END
       ELSE
            ''
        END AS TRIGGERING_EVENT,
       TABOWN.NSPNAME::varchar AS TABLE_OWNER,
       ('TABLE')::varchar AS BASE_OBJECT_TYPE,
       TAB.RELNAME::varchar  AS TABLE_NAME,
       ('')::varchar AS COLUMNNAME,
       ('')::varchar AS REFERENCING_NAMES,
       ('')::varchar AS WHEN_CLAUSES,
       CASE WHEN TRG.TGENABLED<>'D' THEN 'ENABLED'
                                    ELSE 'DISABLED'
       END AS STATUS,
       ('')::varchar AS DESCRIPTION,
       ('PL/SQL')::varchar AS ACTION_TYPE,
       PRO.PROSRC AS TRIGGER_BODY,
       PRO.PRONAME::varchar AS FUNCTION_NAME
  FROM (SELECT CASE WHEN MOD(MOD(TRG.TGTYPE,16),8)>=4 THEN 'INSERT'
                                                  ELSE ''
                END AS EVINSERT,
                CASE WHEN TRG.TGTYPE>=16 THEN 'UPDATE'
                                     ELSE ''
                END AS EVUPDATE,
                CASE WHEN MOD(TRG.TGTYPE,16)>=8 THEN 'DELETE'
                                            ELSE ''
                END AS EVDELETE,
                TRG.*
          FROM PG_TRIGGER TRG
          WHERE not tgisinternal
        ) TRG INNER JOIN PG_PROC PRO ON TRG.TGFOID=PRO.OID
              INNER JOIN PG_NAMESPACE SPC ON SPC.OID=PRO.PRONAMESPACE
              INNER JOIN PG_CLASS TAB ON TRG.TGRELID=TAB.OID
              INNER JOIN PG_NAMESPACE TABOWN ON TABOWN.OID=TAB.RELNAMESPACE
              LEFT JOIN (SELECT TRIGGER_SCHEMA, TRIGGER_NAME, ACTION_ORIENTATION AS ACTION
                            FROM INFORMATION_SCHEMA.TRIGGERS
                           GROUP BY TRIGGER_SCHEMA, TRIGGER_NAME, ACTION_ORIENTATION
                         ) INF ON SPC.NSPNAME = INF.TRIGGER_SCHEMA AND TRG.TGNAME=INF.TRIGGER_NAME;

/*-- SEQ 1954 --*/
/*-- IGNORE ERRO --*/
DROP VIEW all_sequences CASCADE;

/*-- SEQ 1955 --*/
CREATE OR REPLACE VIEW all_sequences AS
SELECT SCHEMANAME::varchar AS SEQUENCE_OWNER,
       RELNAME::varchar AS SEQUENCE_NAME,
       ValorSequencia('"'||SCHEMANAME||'"'||'.'||RELNAME,'min_value')::TEXT::FLOAT AS MIN_VALUE,
       ValorSequencia('"'||SCHEMANAME||'"'||'.'||RELNAME,'max_value')::TEXT::FLOAT AS MAX_VALUE,
       ValorSequencia('"'||SCHEMANAME||'"'||'.'||RELNAME,'increment_by')::TEXT::FLOAT AS INCREMENT_BY,
       ValorSequencia('"'||SCHEMANAME||'"'||'.'||RELNAME,'is_cycled') AS CYCLE_FLAG,
       TO_CHAR('N') as ORDER_FLAG,
       ValorSequencia('"'||SCHEMANAME||'"'||'.'||RELNAME,'cache_value')::TEXT::FLOAT AS CACHE_SIZE,
       ValorSequencia('"'||SCHEMANAME||'"'||'.'||RELNAME,'last_value')::TEXT::FLOAT AS LAST_NUMBER
  FROM pg_statio_all_sequences
 WHERE has_table_privilege('"'||SCHEMANAME||'"'||'.'||RELNAME,'select')  ;

 /*-- SEQ 1956 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_AUD_NUL CASCADE;

/*-- SEQ 1957 --*/
CREATE OR REPLACE VIEW TV_AUD_NUL AS
SELECT TABLE_NAME::varchar as TABLE_NAME,
       COLUMN_NAME::varchar as COLUMN_NAME
FROM USER_TAB_COLUMNS
WHERE data_type in ('bpchar','varchar','text','char')
  and CASE WHEN data_type in ('bpchar','varchar','text','char')
                and (table_name like 'tr_%' or
                     table_name like 'tt_%' or
                     table_name like 'tw_%' or
                     table_name like 'td_%') THEN CAMPOS_COM_VAZIOS (TABLE_NAME,COLUMN_NAME)
                                     ELSE 0
      END = 1
  and (table_name like 'tr_%' or
                     table_name like 'tt_%' or
                     table_name like 'tw_%' or
                     table_name like 'td_%')
  and (TABLE_NAME||'.'||COLUMN_NAME) <> 'tt_fis.subser'
  and (TABLE_NAME||'.'||COLUMN_NAME) <> 'tt_dom.codstr'
  and (TABLE_NAME||'.'||COLUMN_NAME) <> 'tt_dom.codchr'
  and (TABLE_NAME||'.'||COLUMN_NAME) <> 'tw_dom.codstr'
  and (TABLE_NAME||'.'||COLUMN_NAME) <> 'tw_dom.codchr'
ORDER BY TABLE_NAME,COLUMN_NAME;

/*-- SEQ 1958 --*/
/*-- IGNORE ERRO --*/
-- PostgreSQL 9.6
CREATE OR REPLACE VIEW TV_PG_STAT_ACTIVITY AS
SELECT  datid,
 datname,
 pid as procpid,
 usesysid,
 usename,
 application_name,
 client_addr,
 client_hostname,
 client_port,
 backend_start,
 xact_start,
 query_start,
 state_change,
 case when wait_event_type is not null
      then true
      else false
 end as waiting,
 state,
 query
 FROM PG_STAT_ACTIVITY;

/*-- SEQ 1959 --*/
/*-- IGNORE ERRO --*/
-- PostgreSQL 9
CREATE OR REPLACE VIEW TV_PG_STAT_ACTIVITY AS
SELECT  datid,
 datname,
 pid as procpid,
 usesysid,
 usename,
 application_name,
 client_addr,
 client_hostname,
 client_port,
 backend_start,
 xact_start,
 query_start,
 state_change,
 waiting,
 state,
 query
 FROM PG_STAT_ACTIVITY;

/*-- SEQ 1960 --*/
/*-- IGNORE ERRO --*/
-- PostgreSQL 8
CREATE OR REPLACE VIEW TV_PG_STAT_ACTIVITY AS
SELECT  datid,
 datname,
 procpid,
 usesysid,
 usename,
 cast('' as varchar(30)) as application_name,
 client_addr,
 cast('' as varchar(30)) as client_hostname,
 client_port,
 backend_start,
 to_date(null,'dd/mm/yyyy') as xact_start,
 query_start,
 to_date(null,'dd/mm/yyyy') as state_change,
 waiting,
 cast('' as varchar(30)) as state,
 current_query as query
 FROM PG_STAT_ACTIVITY;


/*-- SEQ 1961 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ARE CASCADE;

/*-- SEQ 1962 --*/
CREATE OR REPLACE VIEW TV_ARE AS
select filcli, codcli, tiprec, codfil, sequen, flgest, 
       vlrpar, vlrpre, flgflu, datven,
       case when trunc(datven) > trunc( agora() ) 
            then CAST('A' AS CHAR(1))
            else CAST('V' AS CHAR(1)) 
       end as status,
       datpre, docume, numpar, subpar, compet, 
       tabori, filcta, seqcta, tipcta,
       medatr
from (select ctt.filcli, ctt.codcli,
             cast(dccc.desccc || ' (Contrato)' as VARCHAR(254)) as tiprec,
             ctt.codfil, ctt.sequen, ctt.flgest,
             ctt.vlrmes * ctt.period as vlrpar,
             ADD_DAY(case when ctt.datfat is null 
                          then ADD_DAY(trunc(ctt.datini),coalesce(ctt.carenc,0) - (coalesce(CTT.PERIOD,1) * 28) ) 
                          else trunc(CTT.DATFAT)
                     end, ( coalesce(CTT.PERIOD,1) * 28 * par.parcela) + coalesce(lim.carenc,0) 
                    ) as datven,
             ctt.vlrmes * ctt.period as vlrpre,
             'T' as flgflu,
             ADD_DAY(case when ctt.datfat is null 
                          then ADD_DAY(trunc(ctt.datini),coalesce(ctt.carenc,0) - (coalesce(CTT.PERIOD,1) * 28) ) 
                          else trunc(CTT.DATFAT)
                     end, ( coalesce(CTT.PERIOD,1) * 28 * par.parcela) + coalesce(lim.carenc,0) 
                    ) as datpre,
             ctt.contra as docume,
             CAST(case when ctt.parfat + par.parcela > 99 then 0 else ctt.parfat + par.parcela end AS VARCHAR(2)) as NUMPAR,
             CAST('  ' AS VARCHAR(2)) as SUBPAR,
             ctt.datini as compet,
             CAST('CTT' AS VARCHAR(3)) as TABORI,
             DCCC.FILCCC AS FILCTA, DCCC.SEQCCC AS SEQCTA, DCCC.TIPCCC AS TIPCTA,
             0.00 as medatr
      from (select 1 as parcela from dual union all
            select 2 as parcela from dual union all
            select 3 as parcela from dual union all
            select 4 as parcela from dual union all
            select 5 as parcela from dual union all
            select 6 as parcela from dual union all
            select 7 as parcela from dual union all
            select 8 as parcela from dual union all
            select 9 as parcela from dual union all
            select 10 as parcela from dual union all
            select 11 as parcela from dual union all
            select 12 as parcela from dual) par,
           (select A.*, coalesce(A.tipccc, B.cc_workflow) as ContaCorrente
            from TT_CTT A, TT_CFG B) CTT INNER JOIN TT_CLI CLI  ON CTT.FILCLI  = CLI.FILCLI         
                                                               AND CTT.CODCLI  = CLI.CODCLI         
                                         inner join td_ccc dccc on dccc.codtab = ctt.ContaCorrente
                                         inner join tt_lim lim  on lim.filcli  = ctt.filcli
                                                               and lim.codcli  = ctt.codcli
                                                               and lim.tipccc  = ctt.ContaCorrente
      where CTT.FLGEST = 'R'                                                  
      union all
      select ccc.filcli, 
             ccc.codcli, 
             cast(dccc.desccc || ' (a faturar)' as VARCHAR(254)) as tiprec,
             ccc.codfil,
             ccc.sequen,             
             ccc.status as flgest,
             ccc.vlrlan*-1 as vlrpar,
             ADD_DAY(coalesce( ProximoFaturamento( ccc.filcli, ccc.codcli, ccc.tipccc,agora()), trunc(agora())),lim.carenc) as datven,
             to_number(null) as vlrpre,
             CAST('T' AS VARCHAR(1)) as flgflu,
             to_date(null,'dd/mm/yyyy') as datpre,
             CCC.NUMDOC AS DOCUME,
             CAST('  ' AS VARCHAR(2)) as NUMPAR,
             CAST('  ' AS VARCHAR(2)) as SUBPAR,
             ccc.datope as compet,
             CAST('CCC' AS VARCHAR(3)) as TABORI,
             DCCC.FILCCC AS FILCTA, DCCC.SEQCCC AS SEQCTA, DCCC.TIPCCC AS TIPCTA,
             0.00 as medatr
      from tt_ccc ccc inner join td_ccc dccc on dccc.codtab = ccc.tipccc
                      inner join tt_lim lim  on lim.filcli  = ccc.filcli
                                            and lim.codcli  = ccc.codcli
                                            and lim.tipccc  = ccc.tipccc
      where ccc.status in ('A', 'S')
        and lim.vsaldo < 0
      union all
      select ven.filcli, 
             ven.codcli, 
             dser.desser as tiprec, 
             ven.codfil,
             ven.sequen,
             rec.flgest, 
             rec.vlrpar, 
             rec.datven,             
             rec.vlrpre,
             rec.flgflu,             
             rec.datpre,
             cast(COALESCE(VEN.CODSER,'')||'/'||
                   COALESCE(VEN.NUMECF,'')||'-'||TRIM(COALESCE(VEN.NUMNOT,'')) as VARCHAR(254)) as docume,
             rec.numpar,
             rec.subpar,
             ven.dathor as compet,
             CAST('REC' AS VARCHAR(3)) as TABORI,
             DCOB.FILCTA, DCOB.SEQCTA, DCOB.TIPCTA,
             case when coalesce( abs(cli.totatr),0 ) = 0
                          or coalesce( abs(cli.totpar),0 ) = 0
                        then 0
                        else round(coalesce( abs(cli.totatr),0 ) / coalesce( abs(cli.totpar),0 ) )
             end as medatr
      from tt_ven ven inner join td_ser dser on dser.codser = ven.codser
                      inner join tt_rec rec  on rec.codfil = ven.codfil 
                                            and rec.sequen = ven.sequen
                      inner join tt_cli cli  on cli.filcli = ven.filcli
                                            and cli.codcli = ven.codcli
                      INNER JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD
     where ven.flgest = 'A'
       and rec.flgest = 'A'
       and rec.cartao is null 
       and rec.seqche is null
      union all
      select chr.filcli, chr.codcli,
             TO_CHAR('Cheque') as tiprec,
             chr.codfil,
             chr.sequen,             
             chr.flgest,
             chr.vlrche as vlrpar,
             chr.datven,
             chr.vlrpre,
             chr.flgflu,
             chr.datpre,
             TRIM(COALESCE(CHR.CODBCO,'')) || '(' || 
             TRIM(COALESCE(CHR.CODAGE,'')) || ')' || 
             TRIM(COALESCE(CHR.NUMCON,'')) || '-' || 
             TRIM(COALESCE(CHR.NUMCHE,'')) AS DOCUME,
             CAST('  ' AS VARCHAR(2)) as NUMPAR,
             CAST('  ' AS VARCHAR(2)) as SUBPAR,
             chr.datope as compet,
             CAST('CHR' AS VARCHAR(3)) as TABORI,
             DCOB.FILCTA, DCOB.SEQCTA, DCOB.TIPCTA,
             0.00 as medatr
      from tt_chr chr INNER JOIN TD_COB DCOB ON CHR.PORTAD = DCOB.CODTAB
      where chr.flgest not in ('B','I','C','S','X')
      union all
      select cfg.vc_filcli as filcli,
             cfg.vc_codcli as codcli,
             TO_CHAR('Cartes a Receber') as tiprec,
             tef.codfil,
             tef.sequen,
             itf.flgest,
             itf.vlrite-itf.vlrtax,
             itf.datven,
             itf.vlrite-itf.vlrtax,
             CAST('T' AS VARCHAR(1)) as flgflu,
             itf.datven as datpre,
             (SELECT 'Ref. NF '||MIN(VEN.CODFIL)||'-'||MIN(VEN.CODSER)||'/'||MIN(VEN.NUMECF)||'-'||MIN(VEN.NUMNOT)
                FROM TT_OPE OPE INNER JOIN TT_REC REC ON OPE.FILREC = REC.CODFIL AND OPE.SEQREC = REC.SEQUEN  
                                                     AND OPE.NUMPAR = REC.NUMPAR AND OPE.SUBPAR = REC.SUBPAR  
                                INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN  
               WHERE OPE.CODFIL = TEF.CODFIL
                 AND OPE.NUMECF = TEF.NUMECF
                 AND OPE.TRN_ID = TEF.TRN_ID
              HAVING MIN(VEN.NUMNOT)=MAX(VEN.NUMNOT)) AS docume,
             cast(itf.numite AS VARCHAR(2)) as numpar,
             CAST('  ' AS VARCHAR(2)) as SUBPAR,
             tef.dattrn as compet,
             CAST('TEF' AS VARCHAR(3)) as TABORI,
             DCAR.FILCAR                AS FILCTA,
             DCAR.SEQCAR                AS SEQCTA,
             DCAR.TIPCAR                AS TIPCTA,             
             0.00 as medatr
        from tt_cfg cfg,
             TT_TEF TEF INNER JOIN TT_ITF ITF ON TEF.CODFIL=ITF.CODFIL AND TEF.SEQUEN=ITF.SEQUEN
                      LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'CARTOES A RECEBER'
                      LEFT JOIN TD_CAR DCAR ON DCAR.CODTAB = TEF.CARTAO
       where itf.flgest = 'A' ) int
;


/*-- SEQ 1963 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_AVI CASCADE;

/*-- SEQ 1964 --*/
CREATE OR REPLACE VIEW TV_AVI AS
SELECT AVI.PLACAS,
       CLI.FILCLI,
       CLI.CODCLI,
       CLI.NUMDOC,
       AVI.DATINC,
       AVI.DATENT,
       FIL.NOMFIL,
       AVI.CODFIL,
       AVI.SEQUEN,
       cast(CASE WHEN VEN.CODSER IS NOT NULL THEN COALESCE(VEN.NUMECF,'')||'-'||COALESCE(VEN.CODSER,'')||'/'||RTRIM(LTRIM(COALESCE(VEN.NUMNOT,'')))
       END as VARCHAR(254)) AS DOCUME,
       AVI.DATEXP,
       AVI.MENSAG
 FROM TT_CLI CLI      INNER JOIN TT_VEI VEI ON VEI.FILCLI = CLI.FILCLI AND VEI.CODCLI = CLI.CODCLI
                      INNER JOIN TT_AVI AVI ON AVI.PLACAS = VEI.PLACAS
                 LEFT OUTER JOIN TT_VEN VEN ON VEN.CODFIL = AVI.FILVEN AND VEN.SEQUEN = AVI.SEQVEN
                 LEFT OUTER JOIN TD_FIL FIL ON FIL.CODFIL = VEN.CODFIL
 ;




/*-- SEQ 1965 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_C44 CASCADE;

/*-- SEQ 1966 --*/
CREATE OR REPLACE VIEW TV_C44 AS
SELECT DFIL.CODFIL,
       TO_CHAR('1')||'|'||
       DFIL.CGCFIL||'|'||
       DFIL.IE_FIL||'|'||
       DFIL.RAZSOC||'|'||
       TO_CHAR('1')||'|'||
       (SELECT COUNT(*) 
	      FROM TT_PRO PRO INNER JOIN TT_GRA GRA ON GRA.FILMAT = PRO.FILMAT AND PRO.CODMAT = GRA.CODMAT
		                  INNER JOIN TT_SAL SAL ON SAL.FILMAT = GRA.FILMAT AND SAL.CODMAT = GRA.CODMAT
                                               AND SAL.CODCOR = GRA.CODCOR AND SAL.CODTAM = GRA.CODTAM
                          INNER JOIN TD_FIL FIL ON FIL.CODFIL = SAL.CODFIL
                          INNER JOIN TD_MUL MUL ON MUL.CODTAB = SAL.CODMUL
                          INNER JOIN TT_IUF IUF ON IUF.FILMAT = GRA.FILMAT AND IUF.CODMAT = GRA.CODMAT
                                               AND IUF.ESTADO = FIL.UFLOJA AND IUF.REGESP = FIL.REGESP
                          INNER JOIN TD_ICM ICM ON ICM.CODTAB = IUF.RESICM
         				  INNER JOIN TD_MED MED ON MED.CODTAB = GRA.UNIDAD
		 		          INNER JOIN TD_FIS FIS ON FIS.CODTAB = IUF.CODFIS
         WHERE SALDODAFILIAL (TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL)  > 0
           AND FIL.CODFIL = '001'
           AND MUL.CODTAB = 0
           AND SUBSTR(FIS.CODFIS,1,4) IN ('8506','8507','8523','8524'))||'|'||TO_CHAR(TO_DATE('31/03/2008','DD/MM/YYYY'),'DD/MM/YYYY') AS LINHA
  FROM TD_FIL DFIL
-- WHERE DFIL.CODFIL = '001'  
UNION ALL
SELECT SAL.CODFIL,
       TO_CHAR('2')||'|'||
	   GRA.FILMAT||LPAD(TRIM(GRA.SEQUEN),10,'0')||'|'||
	   REPLACE(TO_CHAR(ROUND(SALDODAFILIAL (TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL),3)),'.',',')||'|'||
	   REPLACE(TO_CHAR(ROUND(CASE WHEN CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL) = 0 
	                              THEN COALESCE(GRA.CUSREP,0)
								  ELSE CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL)
							  END,2)),'.',',')||'|'||
	   REPLACE(TO_CHAR(ROUND(SALDODAFILIAL (TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL) * CASE WHEN CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL) = 0 
																																						 THEN COALESCE(GRA.CUSREP,0)
																																						 ELSE CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL)
																																					 END,2)),'.',',')||'|'||
	   TO_CHAR('18,00')||'|'||
	   CASE WHEN SUBSTR(FIS.CODFIS,1,4) IN ('8506','8507') 
	        THEN '40,00'
			ELSE '25,00'
		END	||'|'||
	   '0,00'||'|'||
	   REPLACE(TO_CHAR(CASE WHEN SUBSTR(FIS.CODFIS,1,4) IN ('8506','8507') 
	                        THEN ROUND(((CASE WHEN CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL) = 0 
	                                          THEN COALESCE(GRA.CUSREP,0)
								              ELSE CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL)
							              END + (CASE WHEN CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL) = 0 
	                                                  THEN COALESCE(GRA.CUSREP,0)
								                      ELSE CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL)
							                      END * 0.40)) * SALDODAFILIAL (TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL) ) * 0.18,2)
       				        ELSE ROUND(((CASE WHEN CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL) = 0 
	                                          THEN COALESCE(GRA.CUSREP,0)
								              ELSE CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL)
							              END + (CASE WHEN CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL) = 0 
	                                                  THEN COALESCE(GRA.CUSREP,0)
								                      ELSE CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL)
							                      END * 0.25)) * SALDODAFILIAL (TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL) ) * 0.18,2)
                        END),'.',',')||'|'||
	   '31'||'|'|| 
	   PRO.DESMAT||'|'||
	   MED.UNIMED AS LINHA
  FROM TT_PRO PRO INNER JOIN TT_GRA GRA ON GRA.FILMAT = PRO.FILMAT AND PRO.CODMAT = GRA.CODMAT
		          INNER JOIN TT_SAL SAL ON SAL.FILMAT = GRA.FILMAT AND SAL.CODMAT = GRA.CODMAT
                                       AND SAL.CODCOR = GRA.CODCOR AND SAL.CODTAM = GRA.CODTAM
                  INNER JOIN TD_FIL FIL ON FIL.CODFIL = SAL.CODFIL
                  INNER JOIN TD_MUL MUL ON MUL.CODTAB = SAL.CODMUL
                  INNER JOIN TT_IUF IUF ON IUF.FILMAT = GRA.FILMAT AND IUF.CODMAT = GRA.CODMAT
                                       AND IUF.ESTADO = FIL.UFLOJA AND IUF.REGESP = FIL.REGESP
				  INNER JOIN TT_PRE PRE ON PRE.FILMAT = GRA.FILMAT AND PRE.CODMAT = GRA.CODMAT
                                       AND PRE.CODCOR = GRA.CODCOR AND PRE.CODTAM = GRA.CODTAM
                                       AND PRE.FILPRE = '001' AND PRE.CODPRE = 1
                  INNER JOIN TD_ICM ICM ON ICM.CODTAB = IUF.RESICM
				  INNER JOIN TD_MED MED ON MED.CODTAB = GRA.UNIDAD
				  INNER JOIN TD_FIS FIS ON FIS.CODTAB = IUF.CODFIS
 WHERE SALDODAFILIAL (TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL)  > 0
--   AND FIL.CODFIL = '001'
   AND MUL.CODTAB = 0
   AND SUBSTR(FIS.CODFIS,1,4) IN ('8506','8507','8523','8524')
UNION ALL
SELECT SAL.CODFIL,
       TO_CHAR('3')||'|0,00|'||
       REPLACE(TO_CHAR(SUM(CASE WHEN SUBSTR(FIS.CODFIS,1,4) IN ('8506','8507') 
  	                            THEN ROUND(((CASE WHEN CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL) = 0 
	                                              THEN COALESCE(GRA.CUSREP,0)
								                  ELSE CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL)
							                  END + (CASE WHEN CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL) = 0 
	                                                      THEN COALESCE(GRA.CUSREP,0)
								                          ELSE CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL)
							                          END * 0.40)) * SALDODAFILIAL (TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL) ) * 0.18,2)
       				            ELSE ROUND(((CASE WHEN CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL) = 0 
	                                              THEN COALESCE(GRA.CUSREP,0)
								                  ELSE CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL)
							                  END + (CASE WHEN CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL) = 0 
	                                                      THEN COALESCE(GRA.CUSREP,0)
								                          ELSE CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL)
							                          END * 0.25)) * SALDODAFILIAL (TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL) ) * 0.18,2)
                            END)),'.',',')||'|'||
       REPLACE(TO_CHAR(SUM(CASE WHEN SUBSTR(FIS.CODFIS,1,4) IN ('8506','8507') 
  	                            THEN ROUND(((CASE WHEN CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL) = 0 
	                                              THEN COALESCE(GRA.CUSREP,0)
								                  ELSE CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL)
							                  END + (CASE WHEN CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL) = 0 
	                                                      THEN COALESCE(GRA.CUSREP,0)
								                          ELSE CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL)
							                          END * 0.40)) * SALDODAFILIAL (TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL) ) * 0.18,2)
       				            ELSE ROUND(((CASE WHEN CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL) = 0 
	                                              THEN COALESCE(GRA.CUSREP,0)
								                  ELSE CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL)
							                  END + (CASE WHEN CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL) = 0 
	                                                      THEN COALESCE(GRA.CUSREP,0)
								                          ELSE CUSTODATA('C',TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL)
							                          END * 0.25)) * SALDODAFILIAL (TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL) ) * 0.18,2)
                            END)),'.',',')||'|1' AS LINHA
  FROM TT_PRO PRO INNER JOIN TT_GRA GRA ON GRA.FILMAT = PRO.FILMAT AND PRO.CODMAT = GRA.CODMAT
		          INNER JOIN TT_SAL SAL ON SAL.FILMAT = GRA.FILMAT AND SAL.CODMAT = GRA.CODMAT
                                       AND SAL.CODCOR = GRA.CODCOR AND SAL.CODTAM = GRA.CODTAM
                  INNER JOIN TD_FIL FIL ON FIL.CODFIL = SAL.CODFIL
                  INNER JOIN TD_MUL MUL ON MUL.CODTAB = SAL.CODMUL
                  INNER JOIN TT_IUF IUF ON IUF.FILMAT = GRA.FILMAT AND IUF.CODMAT = GRA.CODMAT
                                       AND IUF.ESTADO = FIL.UFLOJA AND IUF.REGESP = FIL.REGESP
				  INNER JOIN TT_PRE PRE ON PRE.FILMAT = GRA.FILMAT AND PRE.CODMAT = GRA.CODMAT
                                       AND PRE.CODCOR = GRA.CODCOR AND PRE.CODTAM = GRA.CODTAM
                                       AND PRE.FILPRE = '001' AND PRE.CODPRE = 1
                  INNER JOIN TD_ICM ICM ON ICM.CODTAB = IUF.RESICM
				  INNER JOIN TD_MED MED ON MED.CODTAB = GRA.UNIDAD
				  INNER JOIN TD_FIS FIS ON FIS.CODTAB = IUF.CODFIS
WHERE SALDODAFILIAL (TO_DATE('31/03/2008','DD/MM/YYYY'),GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,FIL.CODFIL,SAL.CODMUL)  > 0
--  AND FIL.CODFIL = '001'
  AND MUL.CODTAB = 0
  AND SUBSTR(FIS.CODFIS,1,4) IN ('8506','8507','8523','8524')
GROUP BY SAL.CODFIL
;


/*-- SEQ 1967 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CAI CASCADE;

/*-- SEQ 1968 --*/
CREATE OR REPLACE VIEW TV_CAI AS
SELECT CAI.CODFIL,
    CAI.SEQUEN,
    CAI.SEQCAI,
    CAI.CODSER,
    CAI.ORIGEM,
    CAI.CODCAI,
    CAST(
    CASE WHEN CAI.CARTAO IS NULL THEN
      CASE WHEN CAI.OUTROS IS NULL THEN
         CASE WHEN CAI.CAMBIO IS NULL THEN
           CASE WHEN CAI.TIPCCC IS NULL THEN
              CASE COALESCE(CHEQUE,'?') WHEN 'V' THEN 'Cheque a Vista'
                           WHEN 'P' THEN 'Cheque Pr  '
                           WHEN 'T' THEN 'Cheque Troco '
                           ELSE 'Outros'
              END
              ELSE CCC.DESCCC
           END
           ELSE 'Dinheiro ' || COALESCE(MOE.DESMOE,'')
         END
         ELSE OUT.DESCAR
      END
      ELSE CAR.DESOUT || CASE COALESCE(CAI.TIPCAR,'X') WHEN 'D' THEN ' - C.Dbito'
                               WHEN 'C' THEN ' - C.Crdito'
                                   ELSE ''
                END
    END AS VARCHAR(30)) AS MEIO_P,
    CAST(
    CASE WHEN CAI.CARTAO IS NULL THEN
      CASE WHEN CAI.OUTROS IS NULL THEN
         CASE WHEN CAI.CAMBIO IS NULL THEN
           CASE WHEN CAI.TIPCCC IS NULL THEN
             'Cheque'
           ELSE 
             CCC.DESCCC
           END
         ELSE 
           COALESCE(MOE.DESMOE,'')
         END
      ELSE 
        OUT.DESCAR
      END
    ELSE 
      CAR.DESOUT
    END AS VARCHAR(16)) AS MEIO_P_REDUZ,
    CAI.VLRLAN
FROM TT_CAI CAI LEFT OUTER JOIN TD_CAR CAR ON CAI.CARTAO = CAR.CODTAB
        LEFT OUTER JOIN TD_OUT OUT ON CAI.OUTROS = OUT.CODTAB
        LEFT OUTER JOIN TD_MOE MOE ON CAI.CAMBIO = MOE.CODTAB
        LEFT OUTER JOIN TD_CCC CCC ON CAI.TIPCCC = CCC.CODTAB
;


/*-- SEQ 1969 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CFI CASCADE;

/*-- SEQ 1970 --*/
CREATE OR REPLACE VIEW TV_CFI AS
SELECT CON.FILCLI, CON.CODCLI, CON.NUMCON, COALESCE(CON.NOMTRA,CON.CONTAT) AS CONTAT, CON.DATNAS,
       CON.SEXCON, CON.CODREL, CON.DDDCON, CON.TELCON, CON.CELCON,
       CON.E_MAIL
  FROM TD_CON DCON INNER JOIN TT_CON CON ON DCON.CODTAB = CON.CODREL
                   INNER JOIN TT_CFG CFG ON DCON.CODTAB = CFG.CONTATO_FINANCEIRO
 WHERE CON.NUMCON IN (SELECT min(I.NUMCON)
                        FROM TT_CON I
                       WHERE I.FILCLI = CON.FILCLI
                         AND I.CODCLI = CON.CODCLI)
 ;




/*-- SEQ 1971 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CFO CASCADE;

/*-- SEQ 1972 --*/
CREATE OR REPLACE VIEW TV_CFO AS
SELECT CAST(SUBSTR(NATDEN,1,6) AS CHAR(6)) AS NATDEN, 
       CAST(SUBSTR(NATFOR,1,6) AS CHAR(6)) AS NATFOR,
       CAST(NATURE||' ('||CAST(SUBSTR(NATDEN,1,6) AS CHAR(6))||','||CAST(SUBSTR(NATFOR,1,6) AS CHAR(6))||')' AS VARCHAR(56)) AS DESNAT
  FROM TD_NAT 
 WHERE NATDEN IS NOT NULL AND NATFOR IS NOT NULL
UNION ALL
SELECT CAST(SUBSTR(CODCFO,1,6) AS CHAR(6)) AS NATDEN, 
       CAST(SUBSTR(CODCFO,1,6) AS CHAR(6)) AS NATFOR,
       CAST(DESCFO||' ('||CAST(SUBSTR(CODCFO,1,4) AS CHAR(4))||')' AS VARCHAR(56)) AS DESNAT
  FROM TD_CFO
;


/*-- SEQ 1973 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CHR_HAQ CASCADE;

/*-- SEQ 1974 --*/
CREATE OR REPLACE VIEW TV_CHR_HAQ AS
-- View para o Integrador de Cheques
-- Header de arquivo
  SELECT CTB.CODBCO AS CODBCO,
         CTB.NUMAGE AS NUMAGE,
         CTB.CTACRR AS CTACRR,
         TO_CHAR('0') AS TIPREG,
         0  AS VLRREG,
         TO_CHAR(NULL) AS CODFIL,
         TO_CHAR(NULL) AS SEQUEN,
         CASE ABS(trunc(chr.datven) - trunc(agora())) + (trunc(chr.datven) - trunc(agora())) WHEN 0 THEN '1' ELSE '2' END AS TIPDEP,
         TO_ASCII(LPAD(COALESCE(TRIM(MIN(CTB.CODBCO)),'0'), 3,'0')              -- Cdigo do Banco
         || LPAD('0',4,'0')                                                     -- Sequenciador do Lote
         || '0'                                                                 -- tipo de registro (0 = header de arq)
         || RPAD(' ',9,' ')                                                     -- Uso Exclusivo Febraban
         || '2'                                                                 -- Tipo de documento da empresa (2=CGC)
         || LPAD(COALESCE(TRIM(MIN(FIL.CGCFIL)),'0'),14,'0')                    -- Documento da empresa
         || RPAD(COALESCE(TRIM(MIN(BXC.CODCNV)),' '),20,' ')                    -- Convnio com o Banco
         || CASE CTB.CODBCO WHEN '341' THEN 
                LPAD(COALESCE(TRIM(to_char(MIN(TO_NUMBER(CTB.NUMAGE)))),'0'), 5,'0')     -- Nmero da agncia
                || LPAD(coalesce(TRIM(MIN(CTB.DIGAGE)),' '), 1,' ')             -- Dgito verificador da Agncia
                || LPAD(COALESCE(TRIM(to_char(MIN(TO_NUMBER(CTB.CTACRR)))),'0'),12,'0')  -- Nmero da conta corrente
                || LPAD(coalesce(TRIM(MIN(CTB.DIGCRR)),' '), 1,' ')             -- Digito verificador da conta corrente
                || LPAD(coalesce(TRIM(MIN(CTB.DIGA_C)),' '), 1,' ')             -- Dgito verificador da conta e agncia
            ELSE
                   LPAD(COALESCE(TRIM(MIN(CTB.NUMAGE)),'0'), 5,'0')             -- Nmero da agncia
                || LPAD(coalesce(TRIM(MIN(CTB.DIGAGE)),' '), 1,' ')             -- Dgito verificador da Agncia
                || LPAD(COALESCE(TRIM(MIN(CTB.CTACRR)),'0'),12,'0')             -- Nmero da conta corrente
                || LPAD(coalesce(TRIM(MIN(CTB.DIGCRR)),' '), 1,' ')             -- Digito verificador da conta corrente
                || LPAD(coalesce(TRIM(MIN(CTB.DIGA_C)),' '), 1,' ')             -- Dgito verificador da conta e agncia
            END
         || RPAD(COALESCE(TRIM(MIN(FIL.RAZSOC)),'0'),30,' ')                    -- Nome da empresa
         || RPAD(COALESCE(TRIM(MIN(BCO.NBANCO)),'0'),30,' ')                    -- Nome do Banco
         || RPAD(' ',10,' ')                                                    -- Uso Exclusivo Febraban
         || TO_CHAR('1')                                                        -- Cdigo 1=Remessa 2=Retorno
         || TO_CHAR(AGORA(),'DDMMYYYY')                                         -- data de gravao remessa/retorno
         || TO_CHAR(AGORA(),'HHMISS')                                           -- hora de gravao remessa/retorno
         || LPAD('0',6,'0')                                                     -- Sequencial do Arquivo (No  utilizado)
         || LPAD(CASE CTB.CODBCO WHEN '341' THEN '40'
                                 WHEN '399' THEN '30'
                                 ELSE '50'
                 END,3,'0')                                                     -- Layout do lote
         || LPAD('1600',5,'0')                                                  -- Densidade do Arquivo
         || LPAD(' ',20,' ')                                                    -- Uso do Banco
         || LPAD(' ',20,' ')                                                    -- Uso da Empresa
         || RPAD(' ',29,' ')                                                    -- Uso exclusivo CNAB
         ) -- FormASCII
         AS LINHA
    FROM TT_CTA CTA INNER JOIN TD_COB COB ON COB.FILCTA = CTA.CODFIL AND COB.SEQCTA = CTA.SEQUEN AND COB.TIPCTA = CTA.TIPCTA AND COB.TIPCOB = CTA.USOCTA
                    INNER JOIN TT_CHR CHR ON CHR.PORTAD = COB.CODTAB AND CHR.TIPCOB = COB.TIPCOB
                    INNER JOIN TT_CTB CTB ON CTA.CODFIL = CTB.FILCTA AND CTA.SEQUEN = CTB.SEQCTA AND CTA.TIPCTA = CTB.TIPCTA AND CTA.USOCTA = CTB.CTACTB
                    INNER JOIN TD_BCO BCO ON BCO.CBANCO = CTB.CODBCO 
                    INNER JOIN TD_FIL FIL ON FIL.CODFIL = '001'
                    LEFT  JOIN TT_CTBXCCB BXC ON CTB.CODBCO = BXC.CODBCO
                                             AND CTB.NUMAGE = BXC.NUMAGE
                                             AND CTB.CTACRR = BXC.CTACRR
                                             AND COB.CODCCB = BXC.CODCCB
   WHERE CHR.VLRCHE <= CTB.VLRCHE    
   GROUP BY CTB.CODBCO, CTB.NUMAGE, CTB.CTACRR, FIL.CODFIL, CASE ABS(trunc(chr.datven)  - trunc(agora())) + (trunc(chr.datven) - trunc(agora())) WHEN 0 THEN '1' ELSE '2' END
;


/*-- SEQ 1975 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CHR_HLT CASCADE;

/*-- SEQ 1976 --*/
CREATE OR REPLACE VIEW TV_CHR_HLT AS
-- View para o Integrador de Cheques.
-- Header de lote
  SELECT CTB.CODBCO AS CODBCO,
         CTB.NUMAGE AS NUMAGE,
         CTB.CTACRR AS CTACRR,
         TO_CHAR('1') AS TIPREG,
         0  AS VLRREG,
         TO_CHAR(NULL) AS CODFIL,
         TO_CHAR(NULL) AS SEQUEN,
         CASE ABS(trunc(chr.datven) - trunc(agora())) + (trunc(chr.datven) - trunc(agora())) WHEN 0 THEN '1' ELSE '2' END AS TIPDEP,
         TO_ASCII( LPAD(COALESCE(TRIM(CTB.CODBCO),'0'),3,'0')                   -- Cdigo do Banco
            || '0001'                                                           -- nico Lote
            || '1'                                                              -- tipo de registro (1 = header de lote)
            || 'C'                                                              -- tipo de operao (c = Cheque)
            || LPAD('6',2,'0')                                                  -- Tipo de servico (01 = Cobrana)
            || Lpad('1',2,'0')                                                  -- Forma de Lancamento
            || LPAD(CASE CTB.CODBCO WHEN '341' THEN '30'
                                    WHEN '399' THEN '10'
                                    ELSE '30'
                     END,3,'0')                                                 -- Layout do lote
            || RPAD(' ',1,' ')                                                  -- Uso exclusivo Febraban
            || '2'                                                              -- Tipo de documento da empresa (2=CGC)
            || LPAD(COALESCE(TRIM(MIN(FIL.CGCFIL)),'0'),14,'0')                 -- Documento da empresa
            || RPAD(COALESCE(TRIM(MIN(BXC.CODCNV)),' '),20,' ')                 -- Convnio com o Banco
            || CASE CTB.CODBCO WHEN '341' THEN 
                    LPAD(COALESCE(TRIM(to_char(MIN(TO_NUMBER(CTB.NUMAGE)))),'0'), 5,'0') -- Nmero da agncia
                    || LPAD(coalesce(TRIM(MIN(CTB.DIGAGE)),' '), 1,' ')         -- Dgito verificador da Agncia
                    || LPAD(COALESCE(TRIM(to_char(MIN(TO_NUMBER(CTB.CTACRR)))),'0'),12,'0')  -- Nmero da conta corrente
                    || LPAD(coalesce(TRIM(MIN(CTB.DIGCRR)),' '), 1,' ')             -- Digito verificador da conta corrente
                    || LPAD(coalesce(TRIM(MIN(CTB.DIGA_C)),' '), 1,' ')             -- Dgito verificador da conta e agncia
               ELSE
                    LPAD(COALESCE(TRIM(MIN(CTB.NUMAGE)),'0'), 5,'0')                -- Nmero da agncia
                    || LPAD(coalesce(TRIM(MIN(CTB.DIGAGE)),' '), 1,' ')             -- Dgito verificador da Agncia
                    || LPAD(COALESCE(TRIM(MIN(CTB.CTACRR)),'0'),12,'0')             -- Nmero da conta corrente
                    || LPAD(coalesce(TRIM(MIN(CTB.DIGCRR)),' '), 1,' ')             -- Digito verificador da conta corrente
                    || LPAD(coalesce(TRIM(MIN(CTB.DIGA_C)),' '), 1,' ')             -- Dgito verificador da conta e agncia
                END
            || RPAD(COALESCE(TRIM(MIN(FIL.RAZSOC)),' '),30,' ')                     -- Nome da empresa
            || LPAD(' ',7,' ')                                                      -- Envelope
            || LPAD(' ',5,' ')                                                      -- Agncia remetente para o Depsito
            || RPAD(' ',125,' ')                                                    -- Complemento
            || CASE ABS(trunc(chr.datven) - trunc(agora())) + (trunc(chr.datven) - trunc(agora())) WHEN 0 THEN '1' ELSE '2' END  -- Tipo de Depsito (1 - A vista, 2 - a Prazo)
         ) -- FormASCII
           AS LINHA
    FROM TT_CTA CTA INNER JOIN TD_COB COB ON COB.FILCTA = CTA.CODFIL AND COB.SEQCTA = CTA.SEQUEN AND COB.TIPCTA = CTA.TIPCTA AND COB.TIPCOB = CTA.USOCTA
                    INNER JOIN TT_CTB CTB ON CTA.CODFIL = CTB.FILCTA AND CTA.SEQUEN = CTB.SEQCTA AND CTA.TIPCTA = CTB.TIPCTA AND CTA.USOCTA = CTB.CTACTB
                    INNER JOIN TD_FIL FIL ON FIL.CODFIL = '001'
                    INNER JOIN TT_CHR CHR ON CHR.PORTAD = COB.CODTAB AND CHR.TIPCOB = COB.TIPCOB                    
                    LEFT  JOIN TT_CTBXCCB BXC ON CTB.CODBCO = BXC.CODBCO
                                             AND CTB.NUMAGE = BXC.NUMAGE
                                             AND CTB.CTACRR = BXC.CTACRR
                                             AND COB.CODCCB = BXC.CODCCB
   WHERE CHR.VLRCHE <= CTB.VLRCHE    
   GROUP BY CTB.CODBCO, CTB.NUMAGE, CTB.CTACRR, FIL.CODFIL, CASE ABS(trunc(chr.datven) - trunc(agora())) + (trunc(chr.datven) - trunc(agora())) WHEN 0 THEN '1' ELSE '2' END
;


/*-- SEQ 1977 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CHR_PEN CASCADE;

/*-- SEQ 1978 --*/
CREATE OR REPLACE VIEW TV_CHR_PEN AS
SELECT CODFIL,
       SEQUEN,
       NUMDOC,
       MAX(FILIAL) AS FILIAL,
       MAX(FLGEST) AS FLGEST,          
       MAX(CHEQUE) AS CHEQUE,
       MAX(DATVEN) AS DATVEN,
       MAX(VLRCHE) AS VLRCHE,
       MAX(PORTAD) AS PORTAD,
       MAX(PAGAME) AS PAGAME,
       MAX(NUMDEP) AS NUMDEP,
       MAX(ALINEA) AS ALINEA,
       MAX(DATOPE) AS DATOPE,
       MAX(NUMECF) AS NUMECF
FROM (
   SELECT CHR.CODFIL,CHR.SEQUEN,
          CLI.NUMDOC,
          FIL.NOMFIL AS FILIAL,
          CASE CHR.FLGEST WHEN 'B' THEN 'Cobrado'
                          WHEN 'X' THEN 'Cancelado'
                          WHEN 'A' THEN 'A Depositar'
                          WHEN 'C' THEN 'Compensado'
                          WHEN 'D' THEN 'Depositado'
                          WHEN 'P' THEN 'Pr-Descontado'
                          WHEN 'S' THEN 'Substitudo'
                          WHEN 'X' THEN 'Cancelado'
                          WHEN 'V' THEN 'Devolvido'
                          WHEN 'U' THEN 'Custodiado'  
                          WHEN 'G' THEN 'Depositar/Custodiar(Arquivo)'  
                          WHEN 'R' THEN 'Reservado'
                          WHEN 'I' THEN 'Incobrvel'                                                  
          END AS FLGEST,          
          COALESCE(CHR.CODBCO,'')||'.'||COALESCE(CHR.CODAGE,'')||'.'||COALESCE(CHR.NUMCON,'')||'.'||COALESCE(CHR.NUMCHE,'') AS CHEQUE,
          CHR.DATVEN,
          CHR.VLRCHE,
          COB.DESCOB AS PORTAD,
          CHR.PAGAME,
          CHR.NUMDEP,
          CHR.ALINEA,
          CHR.DATOPE,
          CHR.NUMECF
     FROM TT_CLI CLI INNER JOIN TT_VEN VEN ON VEN.FILCLI = CLI.FILCLI AND VEN.CODCLI = CLI.CODCLI
                     INNER JOIN TT_REC REC ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
                     INNER JOIN TT_CHR CHR ON CHR.CODFIL = REC.FILREC AND CHR.SEQUEN = REC.SEQCHE
                     INNER JOIN TD_COB COB ON CHR.PORTAD = COB.CODTAB
                     INNER JOIN TD_FIL FIL ON CHR.CODFIL = FIL.CODFIL         
    WHERE CHR.SEQCAN IS NULL 
      AND CHR.FLGEST NOT IN ('B','I','C')
   UNION ALL
   SELECT CHR.CODFIL,CHR.SEQUEN,
          CHR.NUMDOC,
          FIL.NOMFIL AS FILIAL,
          CASE CHR.FLGEST WHEN 'B' THEN 'Cobrado'
                          WHEN 'X' THEN 'Cancelado'
                          WHEN 'A' THEN 'A Depositar'
                          WHEN 'C' THEN 'Compensado'
                          WHEN 'D' THEN 'Depositado'
                          WHEN 'P' THEN 'Pr-Descontado'
                          WHEN 'S' THEN 'Substitudo'
                          WHEN 'X' THEN 'Cancelado'
                          WHEN 'V' THEN 'Devolvido'
                          WHEN 'U' THEN 'Custodiado'  
                          WHEN 'G' THEN 'Depositar/Custodiar(Arquivo)'  
                          WHEN 'R' THEN 'Reservado'
                          WHEN 'I' THEN 'Incobrvel'          
          END AS FLGEST,  
          COALESCE(CHR.CODBCO,'')||'.'||COALESCE(CHR.CODAGE,'')||'.'||COALESCE(CHR.NUMCON,'')||'.'||COALESCE(CHR.NUMCHE ,'')AS CHEQUE,
          CHR.DATVEN,
          CHR.VLRCHE,
          COB.DESCOB AS PORTAD,
          CHR.PAGAME,
          CHR.NUMDEP,
          CHR.ALINEA,
          CHR.DATOPE,
          CHR.NUMECF
    FROM TT_CHR CHR INNER JOIN TD_COB COB ON CHR.PORTAD = COB.CODTAB
                    INNER JOIN TD_FIL FIL ON CHR.CODFIL = FIL.CODFIL
   WHERE CHR.SEQCAN IS NULL 
     AND CHR.FLGEST NOT IN ('B','I','C')
   UNION ALL
   SELECT CHR.CODFIL,CHR.SEQUEN,
          CLI.NUMDOC,
          FIL.NOMFIL AS FILIAL,
          CASE CHR.FLGEST WHEN 'B' THEN 'Cobrado'
                          WHEN 'X' THEN 'Cancelado'
                          WHEN 'A' THEN 'A Depositar'
                          WHEN 'C' THEN 'Compensado'
                          WHEN 'D' THEN 'Depositado'
                          WHEN 'P' THEN 'Pr-Descontado'
                          WHEN 'S' THEN 'Substitudo'
                          WHEN 'X' THEN 'Cancelado'
                          WHEN 'V' THEN 'Devolvido'
                          WHEN 'U' THEN 'Custodiado'  
                          WHEN 'G' THEN 'Depositar/Custodiar(Arquivo)'  
                          WHEN 'R' THEN 'Reservado'
                          WHEN 'I' THEN 'Incobrvel'
          END AS FLGEST,  
          COALESCE(CHR.CODBCO,'')||'.'||COALESCE(CHR.CODAGE,'')||'.'||COALESCE(CHR.NUMCON,'')||'.'||COALESCE(CHR.NUMCHE ,'')AS CHEQUE,
          CHR.DATVEN,
          CHR.VLRCHE,
          COB.DESCOB AS PORTAD,
          CHR.PAGAME,
          CHR.NUMDEP,
          CHR.ALINEA,
          CHR.DATOPE,
          CHR.NUMECF
    FROM TT_CHR CHR INNER JOIN TD_COB COB ON CHR.PORTAD = COB.CODTAB
                    INNER JOIN TD_FIL FIL ON CHR.CODFIL = FIL.CODFIL
                    INNER JOIN TT_CLI CLI ON CLI.FILCLI = CHR.FILCLI AND CLI.CODCLI = CHR.CODCLI
   WHERE CHR.SEQCAN IS NULL 
     AND CHR.FLGEST NOT IN ('B','I','C')
) INT
GROUP BY CODFIL,SEQUEN,NUMDOC
 ;


/*-- SEQ 1979 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CHR_SGD CASCADE;

/*-- SEQ 1980 --*/
CREATE OR REPLACE VIEW TV_CHR_SGD AS
-- View para o Integrador de Cheques.
-- Segmento D
  SELECT CTB.CODBCO AS CODBCO,
         CTB.NUMAGE AS NUMAGE,
         CTB.CTACRR AS CTACRR,
         TO_CHAR('3') AS TIPREG,
         CHR.VLRCHE AS VLRREG,
         CHR.CODFIL AS CODFIL,
         CHR.SEQUEN AS SEQUEN,
         CASE ABS(trunc(chr.datven) - trunc(agora())) + (trunc(chr.datven) - trunc(agora())) WHEN 0 THEN '1' ELSE '2' END AS TIPDEP,
         TO_ASCII(LPAD(COALESCE(TRIM(CTB.CODBCO),'0'),3,'0')  -- Cdigo do Banco
         || '0001'                                       -- nico Lote
         || '3'                                          -- Tipo de Registro (3=Detalhe)
         || LPAD('|*#*|',5,'0')                          -- N. do registro
         || 'D'                                          -- Segmento D
         || '000'                                   -- Cdigo da Instruo para o Movimento = '000' Incluso
         || '2'                                     -- Tipo de documento da empresa (2=CGC)
         || LPAD(COALESCE(TRIM(FIL.CGCFIL),'0'),14,'0')  -- Documento da empresa
         || RPAD(COALESCE(TRIM(BXC.CODCNV),' '),20,' ')  -- Convnio com o Banco
         || CASE CTB.CODBCO WHEN  '341' THEN 
                 LPAD(COALESCE(TRIM(to_char(TO_NUMBER(CTB.NUMAGE))),'0'), 5,'0')  -- Nmero da agncia
                 || LPAD(coalesce(TRIM(CTB.DIGAGE),' '), 1,' ')  -- Dgito verificador da Agncia
                 || LPAD(COALESCE(TRIM(to_char(TO_NUMBER(CTB.CTACRR))),'0'),12,'0')  -- Nmero da conta corrente
                 || LPAD(coalesce(TRIM(CTB.DIGCRR),' '), 1,' ')  -- Digito verificador da conta corrente
                 || LPAD(coalesce(TRIM(CTB.DIGA_C),' '), 1,' ')  -- Dgito verificador da conta e agncia
            ELSE
                 LPAD(COALESCE(TRIM(CTB.NUMAGE),'0'), 5,'0')  -- Nmero da agncia
                 || LPAD(coalesce(TRIM(CTB.DIGAGE),' '), 1,' ')  -- Dgito verificador da Agncia
                 || LPAD(COALESCE(TRIM(CTB.CTACRR),'0'),12,'0')  -- Nmero da conta corrente
                 || LPAD(coalesce(TRIM(CTB.DIGCRR),' '), 1,' ')  -- Digito verificador da conta corrente
                 || LPAD(coalesce(TRIM(CTB.DIGA_C),' '), 1,' ')           -- Dgito verificador da conta e agncia
            END
        || LPAD(' ',30,' ')                       -- Nome do Emitente
        || CASE TRIM(CHR.NUMDOC) WHEN 'NAO INFORMADO' THEN '0' ELSE 
                CASE LENGTH(Translate(trim(CHR.numdoc),'./- ','0000')) WHEN 11 THEN '1'
                                                                       ELSE '2'
                END
           END -- Tipo de Inscrio do emitente do cheque
        || LPAD(CASE TRIM(CHR.NUMDOC) WHEN 'NAO INFORMADO' THEN '0' 
                                                           ELSE Translate(trim(CHR.numdoc),'./- ','0000')
                END ,14,'0') -- CGC ou CNPJ do Emitente.
        || TO_CHAR(CHR.DATOPE,'DDMMYYYY')         -- Data do Movimento
        || TO_CHAR(CHR.DATVEN,'DDMMYYYY')         -- Data de Vencimento
        || LPAD(COALESCE(TRIM(CHR.CDCMC7),'0'),30,'0')          -- CMC-7
        || LPAD(to_char(CHR.VLRCHE * 100),18,'0')          -- Valor do Ttulo
        || LPAD('0',7,'0')                        -- Envelope
        || RPAD(LPAD(CHR.CODFIL,3,' ') ||'/'|| LPAD(CHR.SEQUEN,10,' '),16,' ')                   -- Nmero do documento
        || RPAD(FIL.RAZSOC,24,' ')                -- Uso da Empresa
        || LPAD('40',6,'0')                       -- Ocorrncia
        || LPAD(' ',5,' ')                        -- Brancos
        || CASE ABS(trunc(chr.datven) - trunc(agora())) + (trunc(chr.datven) - trunc(agora())) WHEN 0 THEN '1' ELSE '2' END     -- Forma de entrada (1-Captura, 2-Digitao)
        ) AS LINHA
   FROM TT_CTA CTA INNER JOIN TD_COB COB ON COB.FILCTA = CTA.CODFIL AND COB.SEQCTA = CTA.SEQUEN AND COB.TIPCTA = CTA.TIPCTA AND COB.TIPCOB = CTA.USOCTA
                   INNER JOIN TT_CTB CTB ON CTA.CODFIL = CTB.FILCTA AND CTA.SEQUEN = CTB.SEQCTA AND CTA.TIPCTA = CTB.TIPCTA AND CTA.USOCTA = CTB.CTACTB
                   INNER JOIN TD_FIL FIL ON FIL.CODFIL = '001'
                   INNER JOIN TT_CHR CHR ON CHR.PORTAD = COB.CODTAB AND CHR.TIPCOB = COB.TIPCOB
                   LEFT  JOIN TT_CTBXCCB BXC ON CTB.CODBCO = BXC.CODBCO
                                            AND CTB.NUMAGE = BXC.NUMAGE
                                            AND CTB.CTACRR = BXC.CTACRR
                                            AND COB.CODCCB = BXC.CODCCB
  WHERE CHR.VLRCHE <= CTB.VLRCHE    
;


/*-- SEQ 1981 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CHR_TAQ CASCADE;

/*-- SEQ 1982 --*/
CREATE OR REPLACE VIEW TV_CHR_TAQ AS
-- View para o Integrador de Cheques
-- Trailer de lote
  SELECT CTB.CODBCO AS CODBCO,
         CTB.NUMAGE AS NUMAGE,
         CTB.CTACRR AS CTACRR,
         TO_CHAR('9') AS TIPREG,
         0  AS VLRREG,
         TO_CHAR(NULL) AS CODFIL,
         TO_CHAR(NULL) AS SEQUEN,
         CASE ABS(trunc(chr.datven) - trunc(agora())) + (trunc(chr.datven) - trunc(agora())) WHEN 0 THEN '1' ELSE '2' END AS TIPDEP,
         TO_ASCII(
            LPAD(COALESCE(TRIM(CTB.CODBCO),'0'),3,'0')    -- Cdigo do Banco
            || '9999'                                        -- nico Lote
            || '9'                                           -- tipo de registro (9 = trailer de arquivo)
            || Rpad(' ',9,' ')                               -- Uso exclusivo Febraban
            || LPAD('1',6,'0')                               -- Quantidade de Lotes
            || LPAD('|QR#G|',6,'0')                          -- Quantidade de Registros
            || LPAD('|000000000000VR#G|',18,'0')             -- Valor de Registros
            || LPAD(' ',193,' ')                             -- Complemento
         ) -- FormASCII
         AS LINHA
    FROM TT_CTA CTA INNER JOIN TD_COB COB ON COB.FILCTA = CTA.CODFIL AND COB.SEQCTA = CTA.SEQUEN AND COB.TIPCTA = CTA.TIPCTA AND COB.TIPCOB = CTA.USOCTA
                    INNER JOIN TT_CTB CTB ON CTA.CODFIL = CTB.FILCTA AND CTA.SEQUEN = CTB.SEQCTA AND CTA.TIPCTA = CTB.TIPCTA AND CTA.USOCTA = CTB.CTACTB
                    INNER JOIN TD_FIL FIL ON FIL.CODFIL = '001' 
                    INNER JOIN TT_CHR CHR ON CHR.PORTAD = COB.CODTAB AND CHR.TIPCOB = COB.TIPCOB
   WHERE CHR.VLRCHE <= CTB.VLRCHE     
   GROUP BY CTB.CODBCO, CTB.NUMAGE, CTB.CTACRR, FIL.CODFIL, CASE ABS(trunc(chr.datven) - trunc(agora())) + (trunc(chr.datven) - trunc(agora())) WHEN 0 THEN '1' ELSE '2' END                                              
; 


/*-- SEQ 1983 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CHR_TLT CASCADE;

/*-- SEQ 1984 --*/
CREATE OR REPLACE VIEW TV_CHR_TLT AS
-- View para o Integrador de Cheques
-- Trailer de lote
  SELECT CTB.CODBCO AS CODBCO,
         CTB.NUMAGE AS NUMAGE,
         CTB.CTACRR AS CTACRR,
         TO_CHAR('5') AS TIPREG,
         0  AS VLRREG,
         TO_CHAR(NULL) AS CODFIL,
         TO_CHAR(NULL) AS SEQUEN,
         CASE ABS(trunc(chr.datven) - trunc(agora())) + (trunc(chr.datven) - trunc(agora())) WHEN 0 THEN '1' ELSE '2' END AS TIPDEP,
         TO_ASCII(LPAD(COALESCE(TRIM(CTB.CODBCO),'0'),3,'0')                            -- Cdigo do Banco
                  || '0001'                                                             -- nico LOTE
                  || '5'                                                                -- tipo de registro (5 = trailer de lote)
                  || Rpad(' ',9,' ')                                                    -- Uso exclusivo Febraban
                  || '2'                                                                -- Tipo de documento da empresa (2=CGC)
                  || LPAD(COALESCE(TRIM(MIN(FIL.CGCFIL)),'0'),14,'0')                   -- Documento da empresa
                  || RPAD(COALESCE(TRIM(MIN(BXC.CODCNV)),' '),20,' ')                   -- Convnio com o Banco
                  || CASE CTB.CODBCO WHEN '341' THEN 
                          LPAD(COALESCE(TRIM(to_char(MIN(TO_NUMBER(CTB.NUMAGE)))),'0'), 5,'0')   -- Nmero da agncia
                          || LPAD(coalesce(TRIM(MIN(CTB.DIGAGE)),' '), 1,' ')           -- Dgito verificador da Agncia
                          || LPAD(COALESCE(TRIM(to_char(MIN(TO_NUMBER(CTB.CTACRR)))),'0'),12,'0')-- Nmero da conta corrente
                          || LPAD(coalesce(TRIM(MIN(CTB.DIGCRR)),' '), 1,' ')           -- Digito verificador da conta corrente
                          || LPAD(coalesce(TRIM(MIN(CTB.DIGA_C)),' '), 1,' ')           -- Digito verificador da conta corrente
                     ELSE
                          LPAD(COALESCE(TRIM(MIN(CTB.NUMAGE)),'0'), 5,'0')              -- Nmero da agncia
                          || LPAD(coalesce(TRIM(MIN(CTB.DIGAGE)),' '), 1,' ')           -- Dgito verificador da Agncia
                          || LPAD(COALESCE(TRIM(MIN(CTB.CTACRR)),'0'),12,'0')           -- Nmero da conta corrente
                          || LPAD(coalesce(TRIM(MIN(CTB.DIGCRR)),' '), 1,' ')           -- Digito verificador da conta corrente
                          || LPAD(coalesce(TRIM(MIN(CTB.DIGA_C)),' '), 1,' ')           -- Digito verificador da conta corrente
                     END
                  || LPAD(' ',98,' ')                                                   -- Brancos
                  || LPAD('|QR#G|',6,'0')                                               -- Quantidade de Registros
                  || LPAD('|000000000000VR#G|',18,'0')                                  -- Valor de Registros
                  || LPAD(' ',46,' ')                                                   -- Complemento
         ) -- FormASCII
         AS LINHA
    FROM TT_CTA CTA INNER JOIN TD_COB COB ON COB.FILCTA = CTA.CODFIL AND COB.SEQCTA = CTA.SEQUEN AND COB.TIPCTA = CTA.TIPCTA AND COB.TIPCOB = CTA.USOCTA
                    INNER JOIN TT_CTB CTB ON CTA.CODFIL = CTB.FILCTA AND CTA.SEQUEN = CTB.SEQCTA AND CTA.TIPCTA = CTB.TIPCTA AND CTA.USOCTA = CTB.CTACTB
                    INNER JOIN TD_FIL FIL ON FIL.CODFIL = '001'
                    INNER JOIN TT_CHR CHR ON CHR.PORTAD = COB.CODTAB AND CHR.TIPCOB = COB.TIPCOB
                    LEFT  JOIN TT_CTBXCCB BXC ON CTB.CODBCO = BXC.CODBCO
                                             AND CTB.NUMAGE = BXC.NUMAGE
                                             AND CTB.CTACRR = BXC.CTACRR
                                             AND COB.CODCCB = BXC.CODCCB
   WHERE CHR.VLRCHE <= CTB.VLRCHE     
   GROUP BY CTB.CODBCO, CTB.NUMAGE, CTB.CTACRR, FIL.CODFIL, CASE ABS(trunc(chr.datven) - trunc(agora())) + (trunc(chr.datven) - trunc(agora())) WHEN 0 THEN '1' ELSE '2' END
;


/*-- SEQ 1985 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CID CASCADE;

/*-- SEQ 1986 --*/
CREATE OR REPLACE VIEW TV_CID AS
SELECT CODCID,DESCID
  FROM TT_CID
 ;




/*-- SEQ 1987 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CLI_DES CASCADE;

/*-- SEQ 1988 --*/
CREATE OR REPLACE VIEW TV_CLI_DES AS
  SELECT FIN.CODFIL AS FILIAL,
         CLI.FILCLI AS FILIAL_CLI,
         CLI.CODCLI AS CODIGO_CLI,
         FIN.SEQUEN, FIN.NUMPAR, FIN.SUBPAR,
         CASE WHEN CLI.FLGTIP = 0 
              THEN CLI.NOMCLI || ' ' || COALESCE(CLI.ULTNOM,'')
              ELSE CLI.NOMCLI
         END AS NOMCLI,
         COALESCE( CLI.NUMDOC, VIN.NUMDOC ) AS CPF_CNPJ,
         REC.DATVEN AS VENCIMENTO,
         FIN.DATLAN AS PAGAMENTO,
         VEN.CODSER || '/' || VEN.NUMECF || '-' || VEN.NUMNOT AS DOCUME,
         FIN.NUMPAR || '-' || FIN.SUBPAR AS PARCELA,
         REC.VLRPAR AS VLR_PARCELA,
         REC.VLRPAR + FIN.VLRLAN AS VLR_RECEBIDO,
         FIN.VLRLAN AS VLR_DESCONTO,
         VEN.CODCTR, DCTR.DESCTR 
  FROM TD_CTA CTA INNER JOIN TR_FIN FIN ON FIN.FILCRT = CTA.FILCTA
                                       AND FIN.SEQCRT = CTA.SEQCTA
                                       AND FIN.TIPCRT = CTA.TIPCTA
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = FIN.FILCLI
                                       AND CLI.CODCLI = FIN.CODCLI
                  LEFT  JOIN TT_CLI VIN ON VIN.FILCLI = CLI.FILVIN
                                       AND VIN.CODCLI = CLI.CODVIN
                  INNER JOIN TT_VEN VEN ON VEN.CODFIL = FIN.CODFIL
                                       AND VEN.SEQUEN = FIN.SEQUEN
                  INNER JOIN TT_REC REC ON REC.CODFIL = FIN.CODFIL
                                       AND REC.SEQUEN = FIN.SEQUEN
                                       AND REC.NUMPAR = FIN.NUMPAR
                                       AND REC.SUBPAR = ' 0'
                  INNER JOIN TD_CTR DCTR ON DCTR.CODTAB = VEN.CODCTR
 WHERE FIN.ORIGEM = 'REC'
   AND FIN.FLGFLX = 'R'
   AND CTA.CFGCOL = 'TIPCTA_DES_CON'
 ORDER BY FIN.DATLAN,FIN.CODFIL;


/*-- SEQ 1989 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CLI_DIV_CCC CASCADE;

/*-- SEQ 1990 --*/
CREATE OR REPLACE VIEW TV_CLI_DIV_CCC AS
SELECT TAB.FLGTIP, TAB.FILCLI, TAB.CODCLI, TAB.NUMDOC,
       TAB.DIVIDA, TAB.OCORRE, TAB.LIMITE,
       CAST(0 AS Numeric) AS CHEDEV,
       CAST(3 AS Numeric) AS TIPDIV,
       TAB.DESDIV,
       TAB.CODFIL,
       CAST('' AS VARCHAR(30)) AS DOCUME,
       ADD_DAY(ProximoFaturamento(TAB.FILCLI,TAB.CODCLI,TAB.TIPCCC,AGORA(),NULL),
               CASE COALESCE(TAB.CARENC,0) WHEN 0
                    THEN COALESCE(TAB.CARFAT,0)
                    ELSE TAB.CARENC
               END) AS VENCIMENTO,
       TAB.EMISSAO as EMISSAO
  FROM (
    SELECT CCC.CODFIL, CCC.FILCLI, CCC.CODCLI, SUM(CCC.VLRLAN)*-1 AS DIVIDA,
           COUNT(*) AS OCORRE, LIM.CARENC, PLA.CARFAT, min(CCC.DATOPE) as EMISSAO,
           CLI.FLGTIP, CLI.NUMDOC,
           CASE WHEN CLI.VALLIM IS NOT NULL AND CLI.VALLIM < TRUNC(AGORA()) -- Se limite tem validade e j expirou
                THEN 0
                ELSE COALESCE(CLI.VALOR1,0)
           END AS LIMITE,
           DCC.DESCCC AS DESDIV,
           LIM.TIPCCC
      FROM TT_CCC CCC INNER JOIN TT_CLI CLI ON CCC.FILCLI = CLI.FILCLI
                                           AND CCC.CODCLI = CLI.CODCLI
                       LEFT JOIN TT_LIM LIM ON LIM.FILCLI = CCC.FILCLI
                                           AND LIM.CODCLI = CCC.CODCLI
                                           AND CCC.TIPCCC = LIM.TIPCCC
                       LEFT JOIN TT_PLA PLA ON LIM.FILPGT = PLA.FILPGT
                                           AND LIM.CODPGT = PLA.CODPGT
                       LEFT JOIN TD_CCC DCC ON DCC.CODTAB = LIM.TIPCCC
     WHERE CCC.STATUS IN ('A','P')
       AND CCC.FILFAT IS NULL
       AND ((TRUNC(CCC.DATOPE) <= COALESCE(AGORA(),ADD_DAY(TRUNC(AGORA()),- COALESCE(DCC.DIARET,0))))
        OR (CCC.VLRLAN>0))
     GROUP BY CCC.CODFIL, CCC.FILCLI, CCC.CODCLI,
              LIM.CARENC, PLA.CARFAT, CLI.FLGTIP,
              CLI.NUMDOC, CLI.VALLIM, CLI.VALOR1,
              DCC.DESCCC, LIM.TIPCCC
    HAVING SUM(CCC.VLRLAN) < 0
) TAB INNER JOIN TT_CFG CFG ON (TAB.FILCLI||TAB.CODCLI) <> (CFG.VC_FILCLI||CFG.VC_CODCLI)
;


/*-- SEQ 1991 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CLI_DIV_CHR CASCADE;

/*-- SEQ 1992 --*/
CREATE OR REPLACE VIEW TV_CLI_DIV_CHR AS
-- RFMP 76140
-- Views usadas pela TV_CLI_DIV devem mostrar as dvidas.
-- TV_RES e funo DIVIDA passaram a fazer o filtro pela NAODIV.
-- Mudana realizada para que a dvida do cliente aparecesse no histrico de parceiros.
SELECT /*+ INDEX(CLI,AK_CLI_NUMDOC) INDEX(CHR,I_FK_CHR_CLI)*/
       CLI.FLGTIP, CLI.FILCLI, CLI.CODCLI, CLI.NUMDOC,
       CASE WHEN CHR.FLGEST = 'V' THEN 0 ELSE CHR.VLRCHE END AS DIVIDA,
       CAST(1 AS Numeric) AS OCORRE,
       CASE WHEN CLI.VALLIM IS NOT NULL AND CLI.VALLIM < TRUNC(AGORA()) -- Se limite tem validade e j expirou
            THEN 0
            ELSE CASE WHEN CFG.LIMDIA = 0 THEN CLI.VALOR1
                      ELSE CASE WHEN AGORA() > ADD_DAY(GREATEST(CLI.DATCRE, COALESCE(CLI.ULTCOM, CLI.DATCRE)),  CFG.LIMDIA) THEN 0
                                ELSE COALESCE(CLI.VALOR1,0)
                            END
                 END
       END AS LIMITE,
       CASE WHEN CHR.FLGEST = 'V' THEN CHR.VLRCHE ELSE 0 END AS CHEDEV,
       -- Soma devolvidos separadamente, pois quando TV_RES_DEV  usada na TV_RES
       -- os mesmos j so somados na TV_RES_002
       CASE WHEN CHR.FLGEST = 'V' THEN 5 ELSE 2 END AS TIPDIV,
       cast('Cheque '||COALESCE(DOM.DESDOM,'') as VARCHAR(254)) AS DESDIV,
       CHR.CODFIL,
       cast(RTRIM(LTRIM(COALESCE(CHR.CODBCO,''))) || '(' || RTRIM(LTRIM(COALESCE(CHR.CODAGE,''))) || ')' || RTRIM(LTRIM(COALESCE(CHR.NUMCON,''))) || '-' || RTRIM(LTRIM(COALESCE(CHR.NUMCHE,''))) as VARCHAR(30)) AS DOCUME,
       CHR.DATVEN AS VENCIMENTO,
       CHR.DATOPE AS EMISSAO,
	   COB.DESCOB AS PORTAD,
	   CAST(NULL AS VARCHAR(35)) AS PLANO
FROM TT_CLI CLI INNER JOIN TT_CHR CHR ON CHR.FILCLI = CLI.FILCLI AND CHR.CODCLI = CLI.CODCLI
                LEFT  JOIN TD_COB COB ON COB.CODTAB = CHR.PORTAD
                INNER JOIN TT_CFG CFG ON (CLI.FILCLI||CLI.CODCLI) <> (CFG.VC_FILCLI||CFG.VC_CODCLI)
                LEFT  JOIN TT_DOM DOM ON DOM.CODARQ = 'CHR' AND
                                         DOM.NOMCPO = 'FLGEST' AND
                                         DOM.CODCHR = CHR.FLGEST
WHERE CHR.AUTORI IS NULL
  AND CHR.FLGEST IN ('A','D','P','U','V')
;


/*-- SEQ 1993 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CLI_DIV_CHT CASCADE;

/*-- SEQ 1994 --*/
CREATE OR REPLACE VIEW TV_CLI_DIV_CHT AS
-- RFMP 76140
-- Views usadas pela TV_CLI_DIV devem mostrar as dvidas.
-- TV_RES e funo DIVIDA passaram a fazer o filtro pela NAODIV.
-- Mudana realizada para que a dvida do cliente aparecesse no histrico de parceiros.
SELECT /*+ INDEX(CHR,I_LC_CHR_NUMDOC) */
       CASE LENGTH(TRIM(CHR.NUMDOC)) WHEN 11 THEN 0
                                             ELSE 1
       END AS FLGTIP,
       CLI.FILCLI, CLI.CODCLI, CHR.NUMDOC,
       CASE WHEN CHR.FLGEST = 'V' THEN 0 ELSE CHR.VLRCHE END AS DIVIDA,
       CAST(1 AS Numeric) AS OCORRE,
       TO_NUMBER(NULL) AS LIMITE,
       CASE WHEN CHR.FLGEST = 'V' THEN CHR.VLRCHE ELSE 0 END AS CHEDEV,
       -- Soma devolvidos separadamente, pois quando TV_RES_DEV  usada na TV_RES
       -- os mesmos j so somados na TV_RES_002
       CASE WHEN CHR.FLGEST = 'V' THEN 5 ELSE 4 END AS TIPDIV,
       cast('Cheque de Terceiro '||COALESCE(DOM.DESDOM,'') as VARCHAR(254)) AS DESDIV,
       CHR.CODFIL,
       CAST(RTRIM(LTRIM(COALESCE(CHR.CODBCO,''))) || '(' || RTRIM(LTRIM(COALESCE(CHR.CODAGE,''))) || ')' || RTRIM(LTRIM(COALESCE(CHR.NUMCON,''))) || '-' || RTRIM(LTRIM(COALESCE(CHR.NUMCHE,'')))AS VARCHAR(30)) AS DOCUME,
       CHR.DATVEN AS VENCIMENTO,
       CHR.DATOPE AS EMISSAO,
	   COB.DESCOB AS PORTAD,
	   CAST(NULL AS VARCHAR(35)) AS PLANO
  FROM TT_CHR CHR INNER JOIN TT_CLI CLI ON CHR.FILCLI=CLI.FILCLI AND CHR.CODCLI=CLI.CODCLI
                  LEFT  JOIN TD_COB COB ON COB.CODTAB = CHR.PORTAD
                  LEFT  JOIN TT_DOM DOM ON DOM.CODARQ = 'CHR' AND
                                           DOM.NOMCPO = 'FLGEST' AND
                                           DOM.CODCHR = CHR.FLGEST
WHERE CHR.FLGEST IN ('A','D','P','U','V')
  AND CHR.NUMDOC <> CLI.NUMDOC
;


/*-- SEQ 1995 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CLI_DIV_LIM CASCADE;

/*-- SEQ 1996 --*/
CREATE OR REPLACE VIEW TV_CLI_DIV_LIM AS
-- RFMP 76140
-- Views usadas pela TV_CLI_DIV devem mostrar as dvidas.
-- TV_RES e funo DIVIDA passaram a fazer o filtro pela NAODIV.
-- Mudana realizada para que a dvida do cliente aparecesse no histrico de parceiros.
SELECT /*+ INDEX(CLI,AK_CLI_NUMDOC) INDEX(LIM,PK_LIM) */
       CLI.FLGTIP, CLI.FILCLI, CLI.CODCLI, CLI.NUMDOC,
       (LIM.VSALDO*-1) AS DIVIDA,
       (SELECT COUNT(*) FROM TT_CCC CCC
        WHERE CCC.FILCLI = LIM.FILCLI
          AND CCC.CODCLI = LIM.CODCLI
          AND CCC.STATUS = 'A') AS OCORRE,
       CASE WHEN CLI.VALLIM IS NOT NULL AND CLI.VALLIM < TRUNC(AGORA()) -- Se limite tem validade e j expirou
            THEN 0
            ELSE CASE WHEN CFG.LIMDIA = 0 THEN CLI.VALOR1
                      ELSE CASE WHEN AGORA() > ADD_DAY(GREATEST(CLI.DATCRE, COALESCE(CLI.ULTCOM, CLI.DATCRE)),  CFG.LIMDIA) THEN 0
                                ELSE COALESCE(CLI.VALOR1,0)
                            END
                 END
       END AS LIMITE,
       0 AS CHEDEV,
       3 AS TIPDIV,
       DCC.DESCCC AS DESDIV,
       LIM.FILCLI AS CODFIL,
       cast('' as VARCHAR(30)) AS DOCUME,
       ADD_DAY(
           ProximoFaturamento(cli.filcli,cli.codcli,LIM.TIPCCC,AGORA(),NULL)
           ,CASE COALESCE(LIM.CARENC,0) WHEN 0 THEN COALESCE(PLA.CARFAT,0)
                                               ELSE LIM.CARENC
            END) AS VENCIMENTO,
       (SELECT MIN(DATOPE)
          FROM TT_CCC
          WHERE STATUS IN ('A')
            AND FILCLI = cli.filcli
            AND CODCLI = cli.codcli
            AND TIPCCC = LIM.TIPCCC) as EMISSAO,
	   CAST(NULL AS VARCHAR(30)) AS PORTAD,
       CAST(NULL AS VARCHAR(35)) AS PLANO
 FROM TT_CLI CLI LEFT OUTER JOIN TT_LIM LIM ON LIM.FILCLI = CLI.FILCLI AND
                                               LIM.CODCLI = CLI.CODCLI
                 LEFT OUTER JOIN tt_pla pla on LIM.filpgt=pla.filpgt and LIM.codpgt=pla.codpgt
                 LEFT OUTER JOIN TD_CCC DCC ON DCC.CODTAB = LIM.TIPCCC
                 INNER JOIN TT_CFG CFG ON (CLI.FILCLI||CLI.CODCLI) <> (CFG.VC_FILCLI||CFG.VC_CODCLI)
WHERE LIM.VSALDO < 0
;


/*-- SEQ 1997 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CLI_DIV_VEN CASCADE;

/*-- SEQ 1998 --*/
CREATE OR REPLACE VIEW TV_CLI_DIV_VEN AS
-- RFMP 76140
-- Views usadas pela TV_CLI_DIV devem mostrar as dvidas.
-- TV_RES e funo DIVIDA passaram a fazer o filtro pela NAODIV.
-- Mudana realizada para que a dvida do cliente aparecesse no histrico de parceiros.
SELECT /*+ INDEX(CLI,AK_CLI_NUMDOC) INDEX(VEN,I_LC_VEN_CLI_FLGEST) INDEX(REC,PK_REC) */
       CLI.FLGTIP, CLI.FILCLI, CLI.CODCLI, CLI.NUMDOC,
       REC.VLRPAR AS DIVIDA,
       CALCRECATU(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR,0,REC.PAGAME) as DIVIDACOR,
       CAST(1 AS Numeric) AS OCORRE,
       CASE WHEN CLI.VALLIM IS NOT NULL AND CLI.VALLIM < TRUNC(AGORA()) -- Se limite tem validade e j expirou
            THEN 0
            ELSE CASE WHEN CFG.LIMDIA = 0 THEN CLI.VALOR1
                      ELSE CASE WHEN AGORA() > ADD_DAY(GREATEST(CLI.DATCRE, COALESCE(CLI.ULTCOM, CLI.DATCRE)),  CFG.LIMDIA) THEN 0
                                ELSE COALESCE(CLI.VALOR1,0)
                            END
                 END
       END AS LIMITE,
       CAST(0 AS Numeric) AS CHEDEV,
       CAST(1 AS Numeric) AS TIPDIV,
       CAST('Parcelas em Aberto' AS VARCHAR(50)) AS DESDIV,
       VEN.CODFIL,
       CAST(LTRIM(COALESCE(VEN.CODSER,'')) || '/' || LTRIM(COALESCE(VEN.NUMECF,'')) || '-' || LTRIM(COALESCE(VEN.NUMNOT,'')) || '/' || REC.NUMPAR as VARCHAR(30)) AS DOCUME,
       REC.DATVEN AS VENCIMENTO,
	   REC.DATINC AS EMISSAO,
	   COB.DESCOB AS PORTAD,
	   PLA.DESPGT AS PLANO
FROM  TT_CLI CLI INNER JOIN TT_VEN VEN ON VEN.FILCLI = CLI.FILCLI AND VEN.CODCLI = CLI.CODCLI
                 INNER JOIN TT_REC REC ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
				 INNER JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT AND PLA.CODPGT = VEN.CODPGT
				 LEFT  JOIN TD_COB COB ON COB.CODTAB = REC.PORTAD
                 INNER JOIN TT_CFG CFG ON (CLI.FILCLI||CLI.CODCLI) <> (CFG.VC_FILCLI||CFG.VC_CODCLI)
WHERE REC.CARTAO IS NULL
  AND VEN.FLGEST = 'A'
  AND REC.SEQCHE IS NULL
  AND REC.FLGEST = 'A'
  AND ( VEN.FINANC='T' OR VEN.CODSER='CC')
;


/*-- SEQ 1999 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CLI_EXT CASCADE;

/*-- SEQ 2000 --*/
CREATE OR REPLACE VIEW TV_CLI_EXT AS
SELECT CLI.CODEXT,
       CLI.NOMCLI,
       CLI.ULTNOM,
       CLI.NUMDOC,
       CLI.DOCCON,
       CLI.DATNAS,
       CLI.ESTCIV,
       CLI.HOMPGE,
       CLI.FLGTIP,
       CLI.INSEST,
       CLI.CODSEX,
       CLI.CATEG1,
       CLI.CATEG2,
       CLI.CATEG3,
       CLI.DATA01,
       CLI.DATA02,
       CLI.DATA03,
       CLI.DATOPE,
       CLI.IMPRIM,
       CLI.VALOR1,
       CLI.TOTATR,
       CLI.TOTPAR,
       CLI.MAIATR,
       CLI.FILPLA,
       CLI.CODPLA,
       CLI.PORPAD,
       CLI.ULTCOM,
       CLI.SIGNAT,
       CLI.CONJUG,
       CLI.NASCON,
       CLI.SEXCON,
       CLI.FILVEN,
       CLI.CODVEN,
       CLI.FILVIN,
       CLI.CODVIN,
       CLI.TIPDOC,
       CLI.NOMIMG,
       CLI.ISENHA,
       CLI.SALBON,
       CLI.ICM_CF,
       CLI.ATU_EM,
       ENDE.TIPEND,
       DEND.DESEND,
       ENDE.ENDCOB,
       ENDE.ENDCOR,
       ENDE.NUMDOC AS DOCEND,
       ENDE.INSEST AS INSEND,
       ENDE.ENDERE,
       ENDE.COMPLE,
       ENDE.CODCEP,
       ENDE.CODDDD,
       ENDE.NUMFON,
       ENDE.NUMFAX,
       ENDE.LOCTRA,
       ENDE.REGIAO,
       ENDE.CODLOG,
       ENDE.FLGNAC,
       ENDE.ESTRAN,
       ENDE.CODCID,
       ENDE.CONTAT,
       ENDE.NUMERO,
       ENDE.BAIRRO,
       CLI.OBSERV
FROM TT_END ENDE INNER JOIN TT_CLI CLI ON CLI.FILCLI = ENDE.FILCLI AND CLI.CODCLI = ENDE.CODCLI
                 LEFT  JOIN TD_END DEND ON DEND.CODTAB = ENDE.TIPEND    
WHERE (ENDE.FILCLI,ENDE.CODCLI,ENDE.CODFIL,ENDE.NUMEND) IN (SELECT FILCLI,CODCLI,MIN(CODFIL),MIN(NUMEND) 
                                                              FROM TT_END 
                                                             WHERE FILCLI = CLI.FILCLI 
                                                               AND CODCLI = CLI.CODCLI 
                                                             GROUP BY FILCLI,CODCLI)
 ;




/*-- SEQ 2001 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CLI_JUR CASCADE;

/*-- SEQ 2002 --*/
CREATE OR REPLACE VIEW TV_CLI_JUR AS
SELECT FIN.CODFIL AS FILIAL,
       CLI.FILCLI AS FILIAL_CLI,
       CLI.CODCLI AS CODIGO_CLI,
       FIN.SEQUEN, FIN.NUMPAR, FIN.SUBPAR,
       CASE WHEN CLI.FLGTIP = 0 
            THEN CLI.NOMCLI || ' ' || COALESCE(CLI.ULTNOM,'')
            ELSE CLI.NOMCLI
       END AS NOMCLI,
       COALESCE( CLI.NUMDOC, VIN.NUMDOC ) AS CPF_CNPJ,
       REC.DATVEN AS VENCIMENTO,
       FIN.DATLAN AS PAGAMENTO,
       VEN.CODSER || '/' || VEN.NUMECF || '-' || VEN.NUMNOT AS DOCUME,
       FIN.NUMPAR || '-' || FIN.SUBPAR AS PARCELA,
       REC.VLRPAR AS VLR_PARCELA,
       REC.VLRPAR + FIN.VLRLAN AS VLR_RECEBIDO,
       FIN.VLRLAN AS VLR_JUROS,
       VEN.CODCTR, DCTR.DESCTR
FROM TD_CTA CTA INNER JOIN TR_FIN FIN ON FIN.FILCTA = CTA.FILCTA
                                     AND FIN.SEQCTA = CTA.SEQCTA
                                     AND FIN.TIPCTA = CTA.TIPCTA
                INNER JOIN TT_CLI CLI ON CLI.FILCLI = FIN.FILCLI
                                     AND CLI.CODCLI = FIN.CODCLI
                LEFT JOIN TT_CLI VIN ON VIN.FILCLI = CLI.FILVIN
                                     AND VIN.CODCLI = CLI.CODVIN
                INNER JOIN TT_VEN VEN ON VEN.CODFIL = FIN.CODFIL
                                     AND VEN.SEQUEN = FIN.SEQUEN
                INNER JOIN TT_REC REC ON REC.CODFIL = FIN.CODFIL
                                     AND REC.SEQUEN = FIN.SEQUEN
                                     AND REC.NUMPAR = FIN.NUMPAR
                                     AND REC.SUBPAR = ' 0'
                INNER JOIN TD_CTR DCTR ON DCTR.CODTAB = VEN.CODCTR
WHERE FIN.ORIGEM = 'REC'
  AND FIN.FLGFLX = 'R'
  AND CTA.CFGCOL = 'TIPCTA_JUR_REC'
ORDER BY FIN.DATLAN,FIN.CODFIL;




/*-- SEQ 2003 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CMG CASCADE;

/*-- SEQ 2004 --*/
CREATE OR REPLACE VIEW TV_CMG AS
SELECT RES.*,
       TRUNC(VALORVENDIDO * HORASVENDEDOR /TOTALHORAS,2) AS COMISSAO
  FROM (SELECT INT.*, USU.FILUSU, USU.CODUSU,
               HORAS_TRABALHADAS(CODFIL, DATINI, DATFIM, USU.FILUSU, USU.CODUSU) AS HORASVENDEDOR -- FUNCAO PARA DEFINIR TOTAL DE HORAS QUE DEVERIA TRABALHAR MENOS AUSENCIA
          FROM (SELECT INI.DATOPE AS DATINI,
                       FIM.DATOPE AS DATFIM,
                       FIL.CODFIL,
                       (SELECT SUM(VEN.VLRLIQ * FIL.COMGLO)
                          FROM TT_VEN VEN
                         WHERE VEN.CODFIL = FIL.CODFIL
                           AND VEN.FLGEST <> 'C'
                           AND VEN.LANVEN =  'T'
                           AND VEN.DATHOR >= INI.DATOPE
                           AND VEN.DATHOR <  ADD_DAY(FIM.DATOPE,1)) AS VALORVENDIDO,
                       HORAS_CONTRATADAS(FIL.CODFIL,INI.DATOPE,FIM.DATOPE) AS TOTALHORAS,
                       FIL.COMGLO
           FROM  TD_FIL FIL,
                 TT_DAT INI, TT_DAT FIM) INT, TT_USU USU) RES, TT_CFG CFG
WHERE RES.HORASVENDEDOR > 0
  --PADRO DE CLCULO DE COMISSES PARA A MARISOL
  AND CFG.PADRAO_COMISSAO = 1
UNION ALL
SELECT RES.*,
       TRUNC(VALORVENDIDO * HORASVENDEDOR /TOTALHORAS,2) AS COMISSAO
  FROM (SELECT INT.*, USU.FILUSU, USU.CODUSU,
               HORAS_TRABALHADAS(CODFIL, DATINI, DATFIM, USU.FILUSU, USU.CODUSU) AS HORASVENDEDOR -- FUNCAO PARA DEFINIR TOTAL DE HORAS QUE DEVERIA TRABALHAR MENOS AUSENCIA
          FROM (SELECT INI.DATOPE AS DATINI,
                       FIM.DATOPE AS DATFIM,
                       FIL.CODFIL,
                       (SELECT SUM(VEN.VLRLIQ * FIL.COMGLO)
                          FROM TT_VEN VEN
                         WHERE VEN.CODFIL = FIL.CODFIL
                           AND VEN.FLGEST <> 'C'
                           AND VEN.LANVEN =  'T'
                           AND VEN.DATHOR >= INI.DATOPE
                           AND VEN.DATHOR <  ADD_DAY(FIM.DATOPE,1)) AS VALORVENDIDO,
                       HORAS_CONTRATADAS(FIL.CODFIL,INI.DATOPE,FIM.DATOPE) AS TOTALHORAS,
                       FIL.COMGLO
           FROM  TD_FIL FIL,
                 TT_DAT INI, TT_DAT FIM) INT, TT_USU USU) RES, TT_CFG CFG
WHERE RES.HORASVENDEDOR > 0
  --PADRO DE CLCULO DE COMISSES PARA A MALHARIA CRISTINA
  AND CFG.PADRAO_COMISSAO = 2
 ;


/*-- SEQ 2005 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CMP CASCADE;

/*-- SEQ 2006 --*/
CREATE OR REPLACE VIEW TV_CMP AS
SELECT COM.VLRTOT-COM.VLRTOT+1 as VE_PAGTO_FUN, CFO.DESCFO AS NATURE,
       COM.SEQUEN, COM.CODFIL, COM.FILFOR, COM.CODFOR, COM.CODSER, COM.NUMNOT, COM.DATOPE,
       COM.FLGEST, COM.ATU_EM, COM.DATCMP, COM.QTDTOT, COM.NOTESP, COM.OUTTAX, COM.DESCON,
       COM.SEQAGC, COM.FILAGC, COM.FILUSU, COM.CODUSU, COM.CODMOE, COM.OBSERV, COM.VLTXJU,
       COM.INCOJU, COM.INTPJU, COM.VLTXMU, COM.INTPMU, COM.CONPGT, COM.ESPDOC, COM.SIGNAT,
       COM.MOEJUR, COM.SEQFAT, COM.FILFRE, COM.SEQFRE, COM.TIPNOT, COM.TIPPAR, COM.SEQCAN,
       COM.SUBSER, COM.CODSET, COM.SUBSTT, COM.FILCTA, COM.SEQCTA, COM.TIPCTA, COM.UFNOTA,
       COM.NUMVOL, COM.FILEND, COM.NUMEND, COM.OBSFAT, COM.TIPTRP, COM.RETCOF, COM.CODCFO,
       COM.ATUCUS, COM.EXPORT, COM.FLGINS, COM.MOTREJ, COM.FLGCSS, COM.FLGPIS, COM.FLGCOF,
       COM.TIPEMP, COM.POREMP, COM.FLGICM, COM.FLGISS, COM.CODDOP, COM.VLRTOT, COM.VLRLIQ,
       COM.VLRBON, COM.VLRRET, COM.ICMFRE, COM.VLRFRE, COM.BASFRE, COM.PERFRE, COM.PERIRR,
       COM.PERISS, COM.PERINS, COM.PERCSS, COM.PERICM, COM.VLRIRR, COM.VLRISS, COM.VLRINS,
       COM.VLRCSS, COM.VLRICM, COM.OUTICM, COM.ISEICM, COM.BASSUB, COM.VLRNOT, COM.VLRIPI,
       COM.CODAVU,
       COALESCE(COM.SUBSER,'   ') AS SUBSER_FIS,
       COM.RETIRR, COM.RETCSS, COM.VLRPIS, COM.VLRCOF, COM.OUTDES, COM.DESPAR,
       CASE WHEN COM.TIPNOT = 'F' THEN
                 CAST(0 AS FLOAT)
            WHEN COM.TIPNOT = 'A' THEN
                 COM.VLRLIQ - COALESCE(COM.DESPAR,0)
            ELSE (COM.VLRLIQ - COALESCE(COM.VLRPIS,0) - COALESCE(COM.VLRCOF,0) -
                 CASE WHEN (COM.RETCSS = 'T') THEN COALESCE(COM.VLRCSS,0) ELSE 0 END -
                 CASE WHEN (COM.FLGICM = 'T') THEN COALESCE(COM.VLRICM,0) ELSE 0 END -
                 CASE WHEN (COM.FLGISS = 'T') THEN COALESCE(COM.VLRISS,0) ELSE 0 END -
                 CASE WHEN (COM.FLGINS = 'T') THEN COALESCE(COM.VLRINS,0) ELSE 0 END -
                 CASE WHEN (COM.RETIRR = 'T') THEN COALESCE(COM.VLRIRR,0) ELSE 0 END)
       END AS TOTPAR,
       COM.BASRET, COM.RATEIO_FRETE, COM.CODFCE, COM.TIPFRE, COM.CHAVEA, COM.CODTRI,
       COM.BSTFRE, COM.ST_FRE, COM.BASICM, COM.SITPIS, COM.SITCOF, COM.CODFPS, COM.NATFRE,
       COM.VLRSRV, COM.NATBCC, COM.CODDAR, COM.FINNFE, COM.EXPFIS, COM.EXPORT_CAN, COM.XMLNFE,
       COM.CODSRV, COM.DATINC, COM.VLRBONFUT, COM.CODIBG, COM.TIPCCM, COM.TOTICMANT, COM.CODMUL
  FROM TT_COM COM INNER JOIN TT_USU USU ON USU.APEUSU = GetApeUsuAtual() -- Usurio Logado
                   LEFT JOIN TT_USU UCLI ON UCLI.FILCLI = COM.FILFOR
                                        AND UCLI.CODCLI = COM.CODFOR -- Usurio do compromisso
                   LEFT JOIN TD_CFO CFO ON CFO.CODTAB = COM.CODCFO
 WHERE UCLI.APEUSU IS NULL -- Compra/Compromisso no  de funcionrio
    OR COM.CODFOR = '     0' -- Transferncia
    OR SUBSTR(USU.PERMIS,147,1) = 'S' -- Usurio logado tem permisso para ver pagamentos de outro funcionrios
    OR EXISTS (SELECT 1 AS OK
                 FROM TT_PAP PAP INNER JOIN TT_PAPXUSU PXU ON PXU.FILPAP = PAP.CODFIL
                                                          AND PXU.SEQPAP = PAP.SEQUEN
                WHERE SUBSTR(PAP.PERMIS,147,1) = 'S'
                  AND PXU.FILUSU = USU.FILUSU
                  AND PXU.CODUSU = USU.CODUSU) -- Papel do usurio tem permisso para ver pagamentos de outro funcionrios
    -- Usurio  o OWNER
    OR (SELECT IDF.USUADM FROM TT_IDF IDF) = GetApeUsuAtual()
;


/*-- SEQ 2007 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CMS_IND CASCADE;

/*-- SEQ 2008 --*/
CREATE OR REPLACE VIEW TV_CMS_IND AS
SELECT VEN.CODFIL, 
       VEN.SEQUEN,
       VEN.DATHOR,
       VEN.FILGUI,
       VEN.CODGUI,
       VEN.VLRLIQ,
       cast(COALESCE(VEN.CODSER,'')||'/'||LTRIM(COALESCE(VEN.NUMECF,''))||'-'||LTRIM(COALESCE(VEN.NUMNOT,'')) as VARCHAR(254)) AS DOCUMENTO,
       -- Paulo - 81228 : Para nao ultrapassar o limite de tamanho de 100%, ou -100%.
       CASE WHEN (VEN.CMSIND/VEN.VLRLIQ) * 100 >= 100 THEN 99.99
            WHEN (VEN.CMSIND/VEN.VLRLIQ) * 100 <= -100 THEN -99.99  
            ELSE (VEN.CMSIND/VEN.VLRLIQ) * 100
        END AS PERCENTUAL,	   
       --CAST((VEN.CMSIND/VEN.VLRLIQ) * 100  AS Numeric(4,2)) AS PERCENTUAL,
       VEN.CMSIND AS COMISSAO, 
       VEN.COMSOB
  FROM TT_VEN VEN CROSS JOIN TT_CFG CFG
 WHERE VEN.FLGEST <> 'C' 
   AND VEN.FILGUI IS NOT NULL
   AND CFG.MULT_VENDEDORES = 'T'
   AND COALESCE(VEN.CMSIND, 0) <> 0;


/*-- SEQ 2009 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_COB_CREDIT CASCADE;

/*-- SEQ 2010 --*/
CREATE OR REPLACE VIEW TV_COB_CREDIT AS
SELECT COB.CODFIL,COB.SEQUEN,COB.DATOPE,COB.DATVEN,COB.NAOSPC,COB.QTDNAO,
       CASE WHEN COB.FILREC IS NOT NULL THEN
         '(Filial = '||REC.CODFIL||' CF/NF = '||LTRIM(RTRIM(VEN.CODSER))||'/'||LTRIM(RTRIM(VEN.NUMNOT))||
         ' ECF = '||VEN.NUMECF||' Parcela = '||LTRIM(RTRIM(REC.NUMPAR))||'/'||LTRIM(RTRIM(REC.SUBPAR))||')'
       ELSE
         '(Banco='||CHR.CODBCO||' Agncia='||CHR.CODAGE||' Conta='||CHR.NUMCON||' Cheque='||CHR.NUMCHE||')'
       END AS DOCUME,
       DOM.DESDOM AS SITUACAO,REC.VLRPAR,
       CalcRecAtu(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR,0,Agora()) AS VLRATU,
       CASE WHEN (REC.renego IS NOT NULL OR REC.RENORI IS NOT NULL) THEN 'SIM' ELSE 'NO' END AS RENEGO,
       CASE WHEN REC.FLGEST = 'P' THEN meiodepagamento(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)
                                  ELSE ' '
        END AS MEIO,
       COB.DATPRO,
       CASE WHEN REC.FLGEST = 'P' THEN REC.PAGAME
                                  ELSE NULL
        END AS PAGAME,
        COB.FILSUP,
        COB.SEQSUP,
        COB.FILREC,
        COB.SEQREC
  FROM TT_COB COB LEFT OUTER JOIN TT_REC REC ON REC.CODFIL = COB.FILREC
                                            AND REC.SEQUEN = COB.SEQREC
                                            AND REC.NUMPAR = COB.NUMPAR
                                            AND REC.SUBPAR = COB.SUBPAR
                  LEFT OUTER JOIN TT_VEN VEN ON VEN.CODFIL = COB.FILREC
                                            AND VEN.SEQUEN = COB.SEQREC
                  LEFT OUTER JOIN TT_CHR CHR ON REC.CODFIL = CHR.CODFIL
                                            AND REC.SEQUEN = CHR.SEQUEN
                  LEFT OUTER JOIN TT_DOM DOM ON DOM.CODARQ = CASE WHEN COB.FILREC IS NOT NULL THEN
                                                               'REC'
                                                             ELSE
                                                               'CHR' END
                                            AND DOM.NOMCPO = 'FLGEST'
                                            AND DOM.CODCHR = CASE WHEN COB.FILREC IS NOT NULL THEN
                                                               REC.FLGEST
                                                             ELSE CHR.FLGEST END
;


/*-- SEQ 2011 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_COM CASCADE;

/*-- SEQ 2012 --*/
CREATE OR REPLACE VIEW TV_COM AS
SELECT TRIM(COM.CODSER) ||'/'|| CASE WHEN COM.SUBSER IS NULL THEN ''
                                     ELSE TRIM(COM.SUBSER)||'-'
                                END || TRIM(COM.NUMNOT) AS DOCUME,
       COM.SEQUEN, COM.CODFIL, COM.FILFOR, COM.CODFOR, COM.CODSER,
       COM.NUMNOT, COM.DATOPE, COM.FLGEST, COM.ATU_EM, COM.DATCMP,
       COM.QTDTOT, COM.VLRTOT, COM.NOTESP, COM.OUTTAX, COM.DESCON,
       COM.VLRLIQ, COM.FILUSU, COM.CODUSU, COM.CODMOE, COM.OBSERV,
       COM.VLTXJU, COM.INCOJU, COM.INTPJU, COM.VLTXMU, COM.INTPMU,
       COM.CONPGT, CFO.CODCFO AS NATURE,   COM.ESPDOC, COM.SIGNAT,
       COM.MOEJUR, COM.SEQFAT, COM.FILFRE, COM.SEQFRE, COM.TIPNOT,
       COM.SEQCAN, COM.SUBSER, COM.FILEND, COM.NUMEND, COM.FILCTA,
       COM.SEQCTA, COM.TIPCTA, COM.CODCFO, COM.OBSFAT, COM.SUBSTT,
       COM.NUMVOL, COM.VLRRET, COM.VLRBON, COM.CODSET, COM.ATUCUS,
       COM.UFNOTA, COM.BASSUB, COM.VLRNOT, COM.VLRFRE, COM.VLRIPI,
       COM.DESPAR, COM.OUTDES, COM.ICMFRE, COM.PERFRE, COM.CODFCE,
       COM.CHAVEA, COM.BSTFRE, COM.ST_FRE, COM.TIPPAR,
       COM.SITPIS, COM.SITCOF, COM.CODFPS, COM.NATFRE, COM.VLRSRV,
       COM.NATBCC, COM.FINNFE, COM.XMLNFE, COM.CODSRV, COM.CODIBG,
       COM.TOTICMANT
  FROM TT_COM COM INNER JOIN TT_USU USU ON USU.APEUSU = GetApeUsuAtual() -- Usurio Logado
                   LEFT JOIN TT_USU UCLI ON COM.FILFOR = UCLI.FILCLI AND COM.CODFOR = UCLI.CODCLI -- Usurio do compromisso
                   LEFT JOIN TD_CFO CFO ON CFO.CODTAB = COM.CODCFO
                  CROSS JOIN TT_IDF IDF
 WHERE COM.TIPPAR = 'F'
   AND (-- Usurio logado tem permisso para ver pagamentos de outro funcionrios
        SUBSTR(PERMISSOESUSUARIO(USU.FILUSU,USU.CODUSU),147,1) = 'S'
        -- Usurio  o OWNER
        OR IDF.USUADM = GetApeUsuAtual()
        -- Compra/Compromisso no  de funcionrio
        OR UCLI.APEUSU IS NULL
        -- Transferncia
        OR COM.CODFOR = '     0')
;


/*-- SEQ 2013 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_COM_VEN_UNI CASCADE;

/*-- SEQ 2014 --*/
CREATE OR REPLACE VIEW TV_COM_VEN_UNI AS
select TAB.*,
       Coalesce(Round((TAB.MARGEMCONTRIB * TAB.GIROFINANC), 4), 0) as RETORNOCUSTOMEDIO
  from (select TAB3.*,
               Coalesce(case when (TAB3.VLRCUSTOMEDIO = 0) or (TAB3.VLRCMV = 0) then 0 else Round(TAB3.VLRCUSTOMEDIO / (TAB3.VLRCMV * Cast((365 / INTERVALO) as Numeric(14,4))) * 365, 4) end, 0)
                 as PRAZOMEDIO,
               Coalesce(case when (TAB3.VLRCONTRIBUCAO = 0) or (TAB3.VLRVENDA = 0) then 0 else Round((TAB3.VLRCONTRIBUCAO / TAB3.VLRVENDA) * 100, 4) end, 0)
                 as MARGEMCONTRIB,
               Coalesce(case when (TAB3.VLRVENDA = 0) or (TAB3.VLRCUSTOMEDIO = 0) then 0 else Round((TAB3.VLRVENDA * (Cast((365 / TAB3.INTERVALO) as Numeric(14, 4)))) / TAB3.VLRCUSTOMEDIO, 4) end,0)
                 as GIROFINANC,
               Coalesce(case when (TAB3.VLRCMV = 0) or (TAB3.VLRCOMPRA = 0) then 0 else Round(((TAB3.VLRCOMPRA / TAB3.VLRCMV)), 4) end, 0)
                 as COMPRASOBCMV
          from (select TAB2.*,                  
                       Round(Coalesce(TAB2.VSALCMINICIAL, 0), 4) as SALCMINICIAL,
                       Round(Coalesce(TAB2.VVLRCMINICIAL, 0), 4) as VLRCMINICIAL,             
                       Round(Coalesce((TAB2.QTDCUSTOFIM * TAB2.VLRCUSTOUNIFIM), 0), 4) as VLRCUSTOTOTFIM,                         
                       Round(Coalesce((TAB2.VLRVENDA - TAB2.VLRCSTVDA - (TAB2.VLRCUSTOUNI * TAB2.QTDVENDA)), 0), 2) as VLRCONTRIBUCAO
                  from (select TAB1.*,
                               Round(to_number(split_part(VENESTQMED,  ';', 2), '999999999.9999'), 4) as QTDVENDA,
                               Round(to_number(split_part(VENESTQMED,  ';', 1), '999999999.9999'), 4) as VLRVENDA,
                               Round(to_number(split_part(VENESTQMED,  ';', 3), '999999999.9999'), 4) as VLRCMV,
                               Round(to_number(split_part(VLRCUSTOMED, ';', 1), '999999999.9999'), 4) as VLRCUSTOUNI,
                               Round(to_number(split_part(VLRCUSTOMED, ';', 2), '999999999.9999'), 4) as VLRCUSTOMEDIO,
                               Round(to_number(split_part(VLRCUSTOMED, ';', 3), '999999999.9999'), 4) as VLRCUSTOUNIFIM,                   
                               Round(to_number(split_part(VLRCUSTOMED, ';', 4), '999999999.9999'), 4) as QTDCUSTOMED,                                      
                               Round(to_number(split_part(VLRCUSTOMED, ';', 5), '999999999.9999'), 4) as QTDCUSTOFIM,
                               Round(to_number(split_part(VLRCUSTOMED, ';', 6), '999999999.9999'), 4) as VSALCMINICIAL,
                               Round(to_number(split_part(VLRCUSTOMED, ';', 7), '999999999.9999'), 4) as VVLRCMINICIAL
                          from (select INI.DATOPE as DATAINI,
                                       FIM.DATOPE as DATAFIM, 
                                       (IntervaloDias(FIM.DATOPE, INI.DATOPE)) + 1 as INTERVALO,
                                       SAL.FILMAT, 
                                       SAL.CODMAT, 
                                       SAL.CODCOR, 
                                       SAL.CODTAM, 
                                       SAL.CODFIL, 
                                       SAL.CODMUL, 
                                       PRO.REFBAS, 
                                       GRA.REFPRO,
                                       PRO.DESMAT, 
                                       PRO.ESPMAT, 
                                       PRO.DEPART, 
                                       PRO.CLASS1, 
                                       PRO.CLASS2, 
                                       PRO.CLASS3, 
                                       PRO.CLASS4,
                                       Cast(EstoqueCustoMedio(INI.DATOPE, FIM.DATOPE, SAL.FILMAT, SAL.CODMAT,SAL.CODCOR, SAL.CODTAM, SAL.CODFIL, SAL.CODMUL) as VARCHAR(60))
                                         as VLRCUSTOMED,
                                       Cast(VendasEstoqueMedio(INI.DATOPE, FIM.DATOPE, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, SAL.CODFIL) as VARCHAR(50))
                                         as VENESTQMED,
                                       Round(Coalesce(ValorCompraProduto(INI.DATOPE, to_date(to_char(FIM.DATOPE, 'DD/MM/YYYY')||' 23:59:59', 'DD/MM/YYYY HH24:MI:SS'), SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, SAL.CODFIL), 0), 4)
                                         as VLRCOMPRA,
                                       Round(Coalesce(Vlr_Contri(INI.DATOPE, FIM.DATOPE, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, SAL.CODFIL), 0), 4)
                                         as VLRCSTVDA
                                  from TT_SAL SAL
                                 inner join TT_GRA GRA
                                         on GRA.FILMAT = SAL.FILMAT
                                        and GRA.CODMAT = SAL.CODMAT
                                        and GRA.CODCOR = SAL.CODCOR
                                        and GRA.CODTAM = SAL.CODTAM
                                 inner join TT_PRO PRO
                                         on PRO.FILMAT = GRA.FILMAT
                                        and PRO.CODMAT = GRA.CODMAT
                                 cross join TT_DAT INI
                                 cross join TT_DAT FIM
                               ) TAB1
                       ) TAB2
               ) TAB3
      ) TAB
where TAB.CODMUL = 0
;


/*-- SEQ 2015 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CONREC CASCADE;

/*-- SEQ 2016 --*/
CREATE OR REPLACE VIEW TV_CONREC AS
      select ven.filcli, 
             ven.codcli, 
             dser.desser as tiprec, 
             ven.codfil,
             ven.sequen,
             rec.numpar,
             rec.subpar,             
             rec.flgest, 
             DescontoParcela(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) as vlrdes, 
             rec.vlrtax,
             rec.vlrpgt, 
             rec.datven, 
             rec.pagame as datpgt,            
             cast(COALESCE(VEN.CODSER,'')||'/'||
                   COALESCE(VEN.NUMECF,'')||'-'||TRIM(COALESCE(VEN.NUMNOT,'')) as VARCHAR(254)) as docume,
             ven.dathor as compet,
             CAST('REC' AS VARCHAR(3)) as TABORI,
             DCOB.FILCTA AS FILNUM,
             DCOB.SEQCTA AS SEQNUM,
             DCOB.TIPCTA AS TIPNUM,
             DCTR.CTRFIL AS FILGER, 
             DCTR.CTRSEQ AS SEQGER,
             DCTR.CTRTIP AS TIPGER
      from tt_ven ven inner join td_ser dser on dser.codser = ven.codser
                      inner join tt_rec rec  on rec.codfil = ven.codfil 
                                            and rec.sequen = ven.sequen
                      INNER JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD
                      INNER JOIN TD_CTR DCTR ON DCTR.CODTAB = VEN.CODCTR
     where rec.flgest = 'P'
       and rec.cartao is null 
       and rec.seqche is null
      union all
      select chr.filcli, 
             chr.codcli,
             TO_CHAR('Cheque') as tiprec,
             chr.codfil,
             chr.sequen,             
             CAST('  ' AS VARCHAR(2)) as NUMPAR,
             CAST('  ' AS VARCHAR(2)) as SUBPAR,             
             chr.flgest,
             chr.vlrdif as vlrdes,             
             0.00 as vlrtax,
             chr.vlrche as vlrpgt,
             chr.datven,             
             chr.pagame as datpgt,
             TRIM(COALESCE(CHR.CODBCO,'')) || '(' || 
                  TRIM(COALESCE(CHR.CODAGE,'')) || ')' || 
                  TRIM(COALESCE(CHR.NUMCON,'')) || '-' || 
                  TRIM(COALESCE(CHR.NUMCHE,'')) AS DOCUME,
             chr.datope as compet,
             CAST('CHR' AS VARCHAR(3)) as TABORI,
             DCOB.FILCTA AS FILNUM, 
             DCOB.SEQCTA AS SEQNUM, 
             DCOB.TIPCTA AS TIPNUM,
             DCTR.CTRFIL AS FILGER, 
             DCTR.CTRSEQ AS SEQGER,
             DCTR.CTRTIP AS TIPGER
      FROM TT_CHR CHR INNER JOIN TD_COB DCOB ON CHR.PORTAD = DCOB.CODTAB
                      LEFT  JOIN TT_REC REC ON CHR.CODFIL=REC.FILREC AND CHR.SEQUEN=REC.SEQCHE
                      LEFT  JOIN TT_VEN VEN  ON REC.CODFIL = VEN.CODFIL 
                                            AND REC.SEQUEN = VEN.SEQUEN 
                      LEFT JOIN TD_CTR DCTR ON DCTR.CODTAB = VEN.CODCTR
      WHERE CHR.FLGEST IN ('B','I','C')
      union all
      select trc.filpar as filcli,
             trc.codpar as codcli,
             TO_CHAR('Ttulos Recebidos') as tiprec,
             ptr.codfil,
             ptr.sequen,
             ptr.numpar,
             ptr.subpar,            
             ptr.flgest,
             ptr.vlrdes,
             0.00 as vlrtax,
             ptr.vlrpgt,
             ptr.datven,
             ptr.datpgt,
             trim(TRC.CODSER) ||'/'|| CASE WHEN TRC.SUBSER IS NULL 
                                     THEN ''
                                     ELSE trim(TRC.SUBSER)||'-'
                                END || trim(TRC.NUMNOT) AS docume,
             trc.datope as compet,
             CAST('PTR' AS VARCHAR(3)) as TABORI,
             PTR.FILCTA AS FILNUM,  
             PTR.SEQCTA AS SEQNUM,  
             PTR.TIPCTA AS TIPNUM,  
             TRC.FILCTA AS FILGER,  
             TRC.SEQCTA AS SEQGER,  
             TRC.TIPCTA AS TIPGER   
      from tt_trc trc inner join tt_ptr ptr on ptr.codfil = trc.codfil 
                                           and ptr.sequen = trc.sequen
      where ptr.flgest = 'P'
      union all
      select cfg.vc_filcli as filcli,
             cfg.vc_codcli as codcli,
             TO_CHAR('Cartes Recebidos') as tiprec,
             tef.codfil,
             tef.sequen,
             cast(itf.numite AS VARCHAR(2)) as numpar,
             CAST('  ' AS VARCHAR(2)) as SUBPAR,             
             itf.flgest,
             0.00 as vlrdes,
             itf.vlrtax,
             itf.vlrite-itf.vlrtax AS VLRPGT,
             itf.datven,
             itf.datpgt,
             (SELECT 'Ref. NF '||MIN(VEN.CODFIL)||'-'||MIN(VEN.CODSER)||'/'||MIN(VEN.NUMECF)||'-'||MIN(VEN.NUMNOT)
                FROM TT_OPE OPE INNER JOIN TT_REC REC ON OPE.FILREC = REC.CODFIL AND OPE.SEQREC = REC.SEQUEN  
                                                     AND OPE.NUMPAR = REC.NUMPAR AND OPE.SUBPAR = REC.SUBPAR  
                                INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN  
               WHERE OPE.CODFIL = TEF.CODFIL
                 AND OPE.NUMECF = TEF.NUMECF
                 AND OPE.TRN_ID = TEF.TRN_ID
              HAVING MIN(VEN.NUMNOT)=MAX(VEN.NUMNOT)) AS docume,
             tef.dattrn as compet,
             CAST('TEF' AS VARCHAR(3)) as TABORI,
             DCOB.FILCTA                AS FILNUM,     
             DCOB.SEQCTA                AS SEQNUM,     
             DCOB.TIPCTA                AS TIPNUM,     
             (SELECT VCTR.CTRFIL
                FROM TT_OPE OPE INNER JOIN TT_REC REC ON OPE.FILREC = REC.CODFIL AND OPE.SEQREC = REC.SEQUEN
                                                     AND OPE.NUMPAR = REC.NUMPAR AND OPE.SUBPAR = REC.SUBPAR
                                INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
                                INNER JOIN TD_COB VCOB ON VCOB.CODTAB = REC.PORTAD
                                INNER JOIN TD_CTR VCTR ON VCTR.CODTAB = VEN.CODCTR
               WHERE OPE.CODFIL = TEF.CODFIL
                 AND OPE.NUMECF = TEF.NUMECF
                 AND OPE.TRN_ID = TEF.TRN_ID
               GROUP BY VCTR.CTRFIL, VCTR.CTRSEQ, VCTR.CTRTIP
              HAVING COUNT(*)=1)        AS FILGER,     
             (SELECT VCTR.CTRSEQ
                FROM TT_OPE OPE INNER JOIN TT_REC REC ON OPE.FILREC = REC.CODFIL AND OPE.SEQREC = REC.SEQUEN
                                                     AND OPE.NUMPAR = REC.NUMPAR AND OPE.SUBPAR = REC.SUBPAR
                                INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
                                INNER JOIN TD_COB VCOB ON VCOB.CODTAB = REC.PORTAD
                                INNER JOIN TD_CTR VCTR ON VCTR.CODTAB = VEN.CODCTR
               WHERE OPE.CODFIL = TEF.CODFIL
                 AND OPE.NUMECF = TEF.NUMECF
                 AND OPE.TRN_ID = TEF.TRN_ID
               GROUP BY VCTR.CTRFIL, VCTR.CTRSEQ, VCTR.CTRTIP
              HAVING COUNT(*)=1)         AS SEQGER,     
             (SELECT VCTR.CTRTIP
                FROM TT_OPE OPE INNER JOIN TT_REC REC ON OPE.FILREC = REC.CODFIL AND OPE.SEQREC = REC.SEQUEN
                                                     AND OPE.NUMPAR = REC.NUMPAR AND OPE.SUBPAR = REC.SUBPAR
                                INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
                                INNER JOIN TD_COB VCOB ON VCOB.CODTAB = REC.PORTAD
                                INNER JOIN TD_CTR VCTR ON VCTR.CODTAB = VEN.CODCTR
               WHERE OPE.CODFIL = TEF.CODFIL
                 AND OPE.NUMECF = TEF.NUMECF
                 AND OPE.TRN_ID = TEF.TRN_ID
               GROUP BY VCTR.CTRFIL, VCTR.CTRSEQ, VCTR.CTRTIP
              HAVING COUNT(*)=1)         AS TIPGER            
        from tt_cfg cfg,
             TT_TEF TEF INNER JOIN TT_ITF ITF ON TEF.CODFIL=ITF.CODFIL AND TEF.SEQUEN=ITF.SEQUEN
                        INNER JOIN TD_CAR DCAR ON DCAR.CODTAB = TEF.CARTAO
                        INNER JOIN TD_COB DCOB ON DCOB.CODTAB = DCAR.PORCAR                      
       where itf.flgest = 'P' 
;


/*-- SEQ 2017 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_COR_CREDIT CASCADE;

/*-- SEQ 2018 --*/
CREATE OR REPLACE VIEW TV_COR_CREDIT AS
SELECT DISTINCT
       COR.CODFIL, -- Filial
       COR.SEQUEN, -- Nro. Registro
       DCOR.TITCOR, -- Ttulo
       COR.DATOPE, -- Registro
       COR.DATIMP, -- Impresso
       COR.DATARC, -- A.R.
       COB.FILSUP, -- Filial Chamado
       COB.SEQSUP  -- Seq. Chamado
  FROM TT_COB COB INNER JOIN TT_CORxCOB CXC ON (CXC.FILREC = COB.FILREC
                                           AND  CXC.SEQREC = COB.SEQREC
                                           AND  CXC.NUMPAR = COB.NUMPAR)
                                            OR (CXC.FILCHR = COB.FILCHR
                                           AND  CXC.SEQCHR = COB.SEQCHR)
                  INNER JOIN TT_COR COR ON COR.CODFIL = CXC.FILCOR
                                       AND COR.SEQUEN = CXC.SEQCOR
                  INNER JOIN TD_COR DCOR ON DCOR.CODTAB = COR.CODCOR
;


/*-- SEQ 2019 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CRE_PON CASCADE;

/*-- SEQ 2020 --*/
CREATE OR REPLACE VIEW TV_CRE_PON AS
SELECT CLI.FILCLI,CLI.CODCLI,
       CASE WHEN COLPAI IS NULL THEN 0 
                                ELSE 1 
       END AS NIVEL, 
       DESCRI,
       CreditScore_Pontos(CLI.FILCLI,CLI.CODCLI,CRE.COLUNA) as pontos,  
       CRE.COLUNA
FROM TD_CRE CRE, TT_CLI CLI
order by COALESCE(COLPAI,COLUNA),CASE WHEN COLPAI IS NULL THEN 0 
                                                          ELSE 1 
                                 END
;


/*-- SEQ 2021 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CRTXCLI CASCADE;

/*-- SEQ 2022 --*/
CREATE OR REPLACE VIEW TV_CRTXCLI AS
SELECT CAST('C' AS CHAR(1)) AS USODET,
       FILCLI, CODCLI
  FROM TT_CLI
;


/*-- SEQ 2023 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CRTXEND CASCADE;

/*-- SEQ 2024 --*/
CREATE OR REPLACE VIEW TV_CRTXEND AS
SELECT CAST('E' AS CHAR(1)) AS USODET,
       FILCLI, CODCLI, CODFIL AS FILEND, NUMEND
  FROM TT_END
;


/*-- SEQ 2025 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CRTXGRA CASCADE;

/*-- SEQ 2026 --*/
CREATE OR REPLACE VIEW TV_CRTXGRA AS
SELECT CAST('G' AS CHAR(1)) AS USODET,
       FILMAT, CODMAT, CODCOR, CODTAM 
  FROM TT_GRA
;


/*-- SEQ 2027 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CRTXPRO CASCADE;

/*-- SEQ 2028 --*/
CREATE OR REPLACE VIEW TV_CRTXPRO AS
SELECT CAST('P' AS CHAR(1)) AS USODET,
       FILMAT, CODMAT 
  FROM TT_PRO
;


/*-- SEQ 2029 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CTA_USO CASCADE;

/*-- SEQ 2030 --*/
CREATE OR REPLACE VIEW TV_CTA_USO AS
select DCCC.FILCCC AS FILCTA, 
       DCCC.SEQCCC AS SEQCTA, 
       DCCC.TIPCCC AS TIPCTA,
       DCCC.DESCCC AS NOME,
       to_char('Tipos de C/C') as CONFIG,
       to_char('Lanamentos de C/C') as USO
from td_ccc dccc
union all
select DCOB.FILCTA, DCOB.SEQCTA, DCOB.TIPCTA,
       DCOB.DESCOB AS NOME,
       to_char('Cobrana (portadores)') as CONFIG,
       to_char('Cheques') as USO
from td_cob dcob
union all
select DCOB.FILCTA, DCOB.SEQCTA, DCOB.TIPCTA,
       DCOB.DESCOB AS NOME,
       to_char('Cobrana (portadores)') as CONFIG,
       to_char('Contas a Receber') as USO
from td_cob dcob
union all
select DCAR.FILCAR AS FILCTA, 
       DCAR.SEQCAR AS SEQCTA, 
       DCAR.TIPCAR AS TIPCTA,
       DCAR.DESOUT AS NOME,
       to_char('Cartes de crdito') as CONFIG,
       to_char('Taxa Cartao Cred.') as USO
from td_car dcar
union all
select DCTR.CTRFIL AS FILCTA, 
       DCTR.CTRSEQ AS SEQCTA, 
       DCTR.CTRTIP AS TIPCTA,
       DCTR.DESCTR AS NOME,
       to_char('Unidades de Negcio') as CONFIG,
       to_char('Vendas') as USO
from td_ctr dctr
union all
select dcta.FILCTA, 
       dcta.SEQCTA, 
       dcta.TIPCTA,
       descta AS NOME,
       to_char('Outros (contas Financeiras)') as CONFIG,
       case USOCTA WHEN '-' THEN 'Contas a Pagar'
                   WHEN '+' THEN 'Contas a Receber'
                   ELSE 'OUTROS'
       END as USO
from td_cta dcta
 ;


/*-- SEQ 2031 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CUS CASCADE;

/*-- SEQ 2032 --*/
CREATE OR REPLACE VIEW TV_CUS AS
select com.codfil, com.sequen, com.datcmp, com.filfor, 
       com.codfor, com.filcta, com.seqcta, 
       com.tipcta, com.observ, 0 as codcus, 
       com.vlrliq*-1 as vlrrat,
       CAST(COALESCE(com.codser,'')||'/'||CASE WHEN com.subser IS null THEN '' 
                                                                  ELSE COALESCE(com.subser,'')||'-'
                                     END ||ltrim(COALESCE(com.numnot,'')) AS VARCHAR(254)) as numdoc,
       CAST('C' AS CHAR(1)) AS TIPLAN, 
       COM.FILUSU, COM.CODUSU
from tt_com com LEFT OUTER JOIN tt_cus cus ON com.codfil = cus.codfil and com.sequen = cus.sequen and com.tipnot = cus.tipnot
where flgest <> 'D'
  and cus.codfil is null
union all
select com.codfil, com.sequen, com.datcmp, com.filfor, 
       com.codfor, com.filcta, com.seqcta, 
       com.tipcta, com.observ, cus.codcus, cus.vlrrat*-1,
       COALESCE(com.codser,'')||'/'||CASE WHEN com.subser IS null THEN '' 
                                                                  ELSE COALESCE(com.subser,'')||'-'
                                     END||ltrim(COALESCE(com.numnot,'')) as numdoc,
       CAST('C' AS CHAR(1)) AS TIPLAN, 
       COM.FILUSU, COM.CODUSU
from tt_com com INNER JOIN tt_cus cus ON com.codfil = cus.codfil and com.sequen = cus.sequen and com.tipnot = cus.tipnot
where flgest <> 'D'
union all
select fin.codfil, fin.sequen, fin.datope as datcmp,
       cfg.vc_filcli as filfor, 
       cfg.vc_codcli as codfor,
       fin.filger as filcta,
       fin.seqger as seqcta, 
       fin.tipger as tipcta, 
       fin.observ, fin.codcus, 
       fin.vlrmov as vlrrat,
       fin.numdoc,
       CAST('F' AS CHAR(1)) AS TIPLAN, 
       FIN.FILUSU, FIN.CODUSU
from tt_cfg cfg, tt_fin fin
where fin.tipger <> 'M'
union all
SELECT VEN.CODFIL, VEN.SEQUEN, 
       VEN.DATHOR AS DATCMP,
       VEN.FILCLI AS FILFOR,
       VEN.CODCLI AS CODFOR,
       DCTR.CTRFIL AS FILCTA, DCTR.CTRSEQ AS SEQCTA, DCTR.CTRTIP AS TIPCTA,
       VEN.OBSERV,
       CLI.CENCUS AS CODCUS, 
       VEN.VLRLIQ AS VLRRAT,
       CAST(COALESCE(VEN.CODSER,'')||'/'||COALESCE(VEN.NUMECF,'')||'-'||ltrim(COALESCE(VEN.NUMNOT,'')) AS VARCHAR(254)) AS NUMDOC,
       CAST('V' AS CHAR(1))  AS TIPLAN, 
       VEN.FILUSU, VEN.CODUSU
FROM TT_VEN VEN INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                INNER JOIN TD_CTR DCTR ON DCTR.CODTAB = VEN.CODCTR
WHERE VEN.FLGEST <> 'C'
  AND VEN.LANVEN = 'T'
;


/*-- SEQ 2033 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CUSMED CASCADE;

/*-- SEQ 2034 --*/
CREATE OR REPLACE VIEW TV_CUSMED AS
SELECT CAST(NATURE AS VARCHAR(40)) AS NATURE,
       CAST(DOCUME AS VARCHAR(22)) AS DOCUME,
       QTD_CM AS QTDMOV,
       VLRCMG AS GER_CUSTO,
       VLR_CM AS FIS_CUSTO,
       VLRCMG_UNI AS GER_CUSTO_UNI,
       VLR_CM_UNI AS FIS_CUSTO_UNI,       
       CAST(TIPMOV AS CHAR(1)) as TIPMOV,
       CODFIL,SEQUEN,NUMITE,FILMAT,CODMAT,CODCOR,CODTAM,DATMOV,ORD_CM,VLRMOV,
       SAL_CM,
       TOTCMG AS GER_FINANC,
       TOT_CM AS FIS_FINANC,
       CODSER,
       DATFIS
  FROM (
    -- INICIAL
    SELECT TO_CHAR('INICIAL') AS NATURE,
           CAST(NULL AS VARCHAR(22)) AS DOCUME,
           0 AS ORD_CM,
           SAL.INI_CM AS DATMOV,
           0.00 AS QTD_CM,
           0.00 AS VLR_CM,
           0.00 AS VLRCMG,
           0.00 AS VLR_CM_UNI,
           0.00 AS VLRCMG_UNI,           
           SAL.CODFIL,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,
           TO_CHAR('S') AS TIPMOV,
           TO_NUMBER(NULL) AS VLRMOV,
           SAL.QTD_CM AS SAL_CM,
           CASE SAL.QTD_CM WHEN 0 THEN 0
                                  ELSE SAL.VLR_CM
           END AS TOT_CM,
           CASE SAL.QTD_CM WHEN 0 THEN 0
                                  ELSE SAL.VLRCMG
           END AS TOTCMG, 
           SAL.SEQUEN,
           0 AS NUMITE,
           CAST(NULL AS CHAR(2)) AS CODSER,
           SAL.INI_CM AS DATFIS
      FROM TT_SAL SAL
     WHERE SAL.INI_CM IS NOT NULL
       AND CODMUL=0  
    UNION ALL
    -- COMPRAS
    SELECT CAST(COALESCE(CFO.DESCFO, 'ENTRADA') AS VARCHAR(40)) AS NATURE,
           CASE WHEN TRA.FILICO IS NULL
                THEN COALESCE(COM.FILFOR ,'')      ||'-'||
                     TRIM(COALESCE(COM.CODFOR ,''))||'/'||
                     COALESCE(COM.CODSER ,'')      ||'-'||
                     CASE WHEN COM.SUBSER IS NULL THEN '' ELSE LTRIM(COM.SUBSER,'') END ||'-'||
                     TRIM(COALESCE(COM.NUMNOT ,''))
                ELSE COALESCE(COM.CODSER ,'')      ||'-'||
                     TRIM(COALESCE(COM.NUMNOT ,'')) || '. Filial=' || COALESCE(COM.FILFOR ,'')
           END AS DOCUME,
           ICO.ORD_CM,
           ICO.COM_DATOPE AS DATMOV,
           ICO.QTD_CM,
           ICO.VLR_CM,
           ICO.VLRCMG,
           CASE COALESCE(ICO.QTD_CM,0) WHEN 0 THEN 0 ELSE ICO.VLR_CM/ICO.QTD_CM END AS VLR_CM_UNI,
           CASE COALESCE(ICO.QTD_CM,0) WHEN 0 THEN 0 ELSE ICO.VLRCMG/ICO.QTD_CM END AS VLRCMG_UNI,
           ICO.CODFIL,ICO.FILMAT,ICO.CODMAT,ICO.CODCOR,ICO.CODTAM,
           TO_CHAR('C') AS TIPMOV,
           ICO.VLRMOV,
           ICO.SAL_CM,
           ICO.TOT_CM,
           ICO.TOTCMG, 
           ICO.SEQUEN,
           ICO.NUMITE,
           CAST(NULL AS CHAR(2)) AS CODSER,
           TRUNC(ICO.COM_DATOPE) AS DATFIS
      FROM TT_ICO ICO INNER JOIN TT_SAL SAL ON ICO.CODFIL=SAL.CODFIL AND
                                           ICO.FILMAT=SAL.FILMAT AND
                                           ICO.CODMAT=SAL.CODMAT AND
                                           ICO.CODCOR=SAL.CODCOR AND
                                           ICO.CODTAM=SAL.CODTAM AND
                                           ICO.CODMUL=SAL.CODMUL
                      INNER JOIN TT_COM COM ON COM.CODFIL = ICO.CODFIL AND COM.SEQUEN = ICO.SEQUEN
                      LEFT JOIN  TT_TRA TRA ON TRA.FILICO = ICO.CODFIL AND TRA.SEQICO = ICO.SEQUEN AND TRA.NUMICO = ICO.NUMITE
                      LEFT JOIN  TD_CFO CFO ON COM.CODCFO = CFO.CODTAB
     WHERE ICO.SITMOV<>'C'
       AND ICO.LANEST NOT IN ('R','N')
       AND COALESCE(ICO.QTD_CM,0) <> 0
       AND COALESCE(COM.FINNFE,'1') <> '2'
       AND ICO.COM_DATOPE > TO_DATE(TO_CHAR(COALESCE(SAL.INI_CM,TO_DATE('01/01/1900','DD/MM/YYYY')),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
    UNION ALL
    -- Nota Complementar
    SELECT 'NOTA COMPLEMENTAR' AS NATURE,
           COALESCE(COM.FILFOR ,'')      ||'-'||
           TRIM(COALESCE(COM.CODFOR ,''))||'/'||
           COALESCE(COM.CODSER ,'')      ||'-'||
           CASE WHEN COM.SUBSER IS NULL THEN '' ELSE LTRIM(COM.SUBSER,'') END ||'-'||
           TRIM(COALESCE(COM.NUMNOT ,'')) AS DOCUME,
           ICO.ORD_CM,
           ICO.COM_DATOPE AS DATMOV,
           ICO.QTD_CM,
           ICO.VLR_CM,
           ICO.VLRCMG,
           (ICO.VLR_CM/NVLZ(ICO.QTD_CM,1)) AS VLR_CM_UNI,
           (ICO.VLRCMG/NVLZ(ICO.QTD_CM,1)) AS VLRCMG_UNI,
           ICO.CODFIL,ICO.FILMAT,ICO.CODMAT,ICO.CODCOR,ICO.CODTAM,
           TO_CHAR('N') AS TIPMOV,
           ICO.VLRMOV,
           ICO.SAL_CM,
           ICO.TOT_CM,
           ICO.TOTCMG, 
           ICO.SEQUEN,
           ICO.NUMITE,
           CAST(NULL AS CHAR(2)) AS CODSER,
           TRUNC(ICO.COM_DATOPE) AS DATFIS
      FROM TT_ICO ICO INNER JOIN TT_SAL SAL ON ICO.CODFIL=SAL.CODFIL AND
                                           ICO.FILMAT=SAL.FILMAT AND
                                           ICO.CODMAT=SAL.CODMAT AND
                                           ICO.CODCOR=SAL.CODCOR AND
                                           ICO.CODTAM=SAL.CODTAM AND
                                           ICO.CODMUL=SAL.CODMUL
                      INNER JOIN TT_COM COM ON COM.CODFIL = ICO.CODFIL AND COM.SEQUEN = ICO.SEQUEN
     WHERE ICO.SITMOV<>'C'
       --AND ICO.LANEST = 'N'--Independente da operao de estoque nota complementar sempre entra no Custo
       AND COALESCE(COM.FINNFE,'1') = '2'
       AND ICO.COM_DATOPE > TO_DATE(TO_CHAR(COALESCE(SAL.INI_CM,TO_DATE('01/01/1900','DD/MM/YYYY')),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
    UNION ALL
    -- Entradas de Importao, Devoluo de Transferncia e Sada de Transferncia
    SELECT DNAT.NATURE,
           COALESCE(VEN.FILCLI ,'') ||'-'|| TRIM(COALESCE(VEN.CODCLI ,'')) ||'/'|| COALESCE(VEN.CODSER ,'') ||'-'|| TRIM(COALESCE(VEN.NUMNOT ,'')) AS DOCUME,
           IVE.ORD_CM,
           IVE.VEN_DATHOR AS DATMOV,
           IVE.QTD_CM * -1 AS QTD_CM,
           IVE.VLR_CM * CASE WHEN DNAT.TIPNAT IN ('I','S') THEN 1 ELSE -1 END AS VLR_CM,
           IVE.VLRCMG * CASE WHEN DNAT.TIPNAT IN ('I','S') THEN 1 ELSE -1 END AS VLRCMG ,
           CASE COALESCE(IVE.QTD_CM,0) WHEN 0 THEN 0 ELSE ABS(ROUND(IVE.VLR_CM/IVE.QTD_CM, 4)) END AS VLR_CM_UNI,
           CASE COALESCE(IVE.QTD_CM,0) WHEN 0 THEN 0 ELSE ABS(ROUND(IVE.VLRCMG/IVE.QTD_CM, 4)) END AS VLRCMG_UNI,
           IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,
           TO_CHAR( CASE WHEN DNAT.TIPNAT = 'I' THEN 'I' WHEN DNAT.TIPNAT = 'S' THEN 'V' WHEN DNAT.TIPNAT = 'R' THEN 'R' ELSE 'V' END )  AS TIPMOV,
           IVE.VLRMOV * CASE WHEN DNAT.TIPNAT IN ('S') THEN 1 ELSE -1 END AS VLRMOV,
           IVE.SAL_CM,
           IVE.TOT_CM,
           IVE.TOTCMG, 
           IVE.SEQUEN,
           IVE.NUMITE,
           VEN.CODSER,
           TRUNC(IVE.VEN_DATHOR) AS DATFIS
      FROM TT_IVE IVE INNER JOIN TT_SAL SAL ON IVE.CODFIL=SAL.CODFIL AND 
                                           IVE.FILMAT=SAL.FILMAT AND
                                           IVE.CODMAT=SAL.CODMAT AND
                                           IVE.CODCOR=SAL.CODCOR AND
                                           IVE.CODTAM=SAL.CODTAM AND
                                           IVE.CODMUL=SAL.CODMUL
                      INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
                      INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
     WHERE IVE.SITMOV<>'C'
       AND IVE.LANEST = 'S'
       AND IVE.SITKIT<>'1'
       AND IVE.VEN_DATHOR>=TO_DATE(TO_CHAR(COALESCE(SAL.INI_CM,TO_DATE('01/01/1900','DD/MM/YYYY')),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
       AND DNAT.TIPNAT IN ('R','I','S') --Considera as notas de Sada de Transferncia\Devoluo de Transferncia\Importao como objetos de Compra
    UNION ALL
    -- VENDAS
    SELECT DNAT.NATURE,
           COALESCE(VEN.NUMECF ,'')||'-'||COALESCE(VEN.CODSER ,'')||'/'||
           TRIM(COALESCE(VEN.NUMNOT ,''))|| '     ' AS DOCUME,
           IVE.ORD_CM,
           IVE.VEN_DATHOR  AS DATMOV,
           IVE.QTD_CM * -1 AS QTD_CM,
           CASE WHEN IVE.TOT_CM IS NOT NULL 
                 AND COALESCE(TRUNC(IVE.SAL_CM,3),0)<>0 THEN ROUND(ROUND(IVE.TOT_CM,2)/TRUNC(IVE.SAL_CM,3),4)*IVE.QTD_CM
                                       ELSE CUSTOMEDIO(IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,3,TRUNC(IVE.VEN_DATHOR))*IVE.QTD_CM
           END*-1 AS VLR_CM,
           CASE WHEN IVE.TOTCMG IS NOT NULL
                 AND COALESCE(TRUNC(IVE.SAL_CM,3),0)<>0 THEN ROUND(ROUND(IVE.TOTCMG,2)/TRUNC(IVE.SAL_CM,3),4)*IVE.QTD_CM
                                       ELSE CUSTOMEDIO(IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,5,TRUNC(IVE.VEN_DATHOR))*IVE.QTD_CM
           END*-1 AS VLRCMG,
           CUSTOMEDIO(IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,3,TRUNC(IVE.VEN_DATHOR)) AS VLR_CM_UNI,
           CUSTOMEDIO(IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,5,TRUNC(IVE.VEN_DATHOR)) AS VLRCMG_UNI,
           IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,
           TO_CHAR('V') AS TIPMOV,
           IVE.VLRMOV,
           IVE.SAL_CM,
           IVE.TOT_CM,
           IVE.TOTCMG, 
           IVE.SEQUEN,
           IVE.NUMITE,
           VEN.CODSER,
           VEN.DATFIS
      FROM TT_IVE IVE INNER JOIN TT_SAL SAL ON IVE.CODFIL=SAL.CODFIL AND 
                                           IVE.FILMAT=SAL.FILMAT AND
                                           IVE.CODMAT=SAL.CODMAT AND
                                           IVE.CODCOR=SAL.CODCOR AND
                                           IVE.CODTAM=SAL.CODTAM AND
                                           IVE.CODMUL=SAL.CODMUL
                      INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
                      INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
     WHERE IVE.SITMOV<>'C'
       AND IVE.LANEST NOT IN ('R','N')
       AND COALESCE(IVE.QTD_CM,0) <> 0
       AND SITKIT<>'1'
       AND IVE.VEN_DATHOR > TO_DATE(TO_CHAR(COALESCE(SAL.INI_CM,TO_DATE('01/01/1900','DD/MM/YYYY')),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
       AND DNAT.TIPNAT NOT IN ('R','I','S') --Desconsidera as notas de Sada de Transferncia\Devoluo de Transferncia\Importao como objetos de Vendas
    UNION ALL
    -- LANAMENTO AVULSO
    SELECT COALESCE('Acerto Estoque',DNAT.NATURE) AS NATURE,
           LAN.DOCUME,
           LAN.ORD_CM,
           LAN.DATMOV,
           LAN.QTD_CM AS QTD_CM,
           CASE WHEN LAN.QTD_CM >0 THEN LAN.VLRMOV
                WHEN LAN.TOT_CM IS NOT NULL 
                 AND COALESCE(TRUNC(LAN.SAL_CM,3),0)<>0 THEN ROUND(ROUND(LAN.TOT_CM,2)/TRUNC(LAN.SAL_CM,3),4)*LAN.QTD_CM
                                       ELSE CUSTOMEDIO(LAN.CODFIL,LAN.FILMAT,LAN.CODMAT,LAN.CODCOR,LAN.CODTAM,3,TRUNC(LAN.DATMOV))*LAN.QTD_CM
           END AS VLR_CM,
           CASE WHEN LAN.QTD_CM >0 THEN LAN.VLRMOV
                WHEN LAN.TOTCMG IS NOT NULL
                 AND COALESCE(TRUNC(LAN.SAL_CM,3),0)<>0 THEN ROUND(ROUND(LAN.TOTCMG,2)/TRUNC(LAN.SAL_CM,3),4)*LAN.QTD_CM
                                       ELSE CUSTOMEDIO(LAN.CODFIL,LAN.FILMAT,LAN.CODMAT,LAN.CODCOR,LAN.CODTAM,5,TRUNC(LAN.DATMOV))*LAN.QTD_CM
           END AS VLRCMG,
           CASE WHEN TRUNC(LAN.QTD_CM,3) >0 THEN ROUND(ROUND(LAN.VLRMOV,2)/TRUNC(LAN.QTD_CM,3),4)
                WHEN LAN.TOT_CM IS NOT NULL 
                 AND COALESCE(TRUNC(LAN.SAL_CM,3),0)<>0 THEN ROUND(ROUND(LAN.TOT_CM,2)/TRUNC(LAN.SAL_CM,3),4)
                                       ELSE CUSTOMEDIO(LAN.CODFIL,LAN.FILMAT,LAN.CODMAT,LAN.CODCOR,LAN.CODTAM,3,TRUNC(LAN.DATMOV))
           END AS VLR_CM_UNI,
           CASE WHEN TRUNC(LAN.QTD_CM,3) >0 THEN ROUND(ROUND(LAN.VLRMOV,2)/TRUNC(LAN.QTD_CM,3),4)
                WHEN LAN.TOTCMG IS NOT NULL
                 AND COALESCE(TRUNC(LAN.SAL_CM,3),0)<>0 THEN ROUND(ROUND(LAN.TOTCMG,2)/TRUNC(LAN.SAL_CM,3),4)
                                       ELSE CUSTOMEDIO(LAN.CODFIL,LAN.FILMAT,LAN.CODMAT,LAN.CODCOR,LAN.CODTAM,5,TRUNC(LAN.DATMOV))
           END AS VLRCMG_UNI,
           LAN.CODFIL,LAN.FILMAT,LAN.CODMAT,LAN.CODCOR,LAN.CODTAM,
           TO_CHAR('L') AS TIPMOV,
           LAN.VLRMOV,
           LAN.SAL_CM,
           CASE LAN.SAL_CM WHEN 0 THEN 0
                           ELSE LAN.TOT_CM
           END AS TOT_CM,
           CASE LAN.SAL_CM WHEN 0 THEN 0
                           ELSE LAN.TOTCMG
           END AS TOTCMG, 
           LAN.SEQUEN,
           0 AS NUMITE,
           CAST(NULL AS CHAR(2)) AS CODSER,
           TRUNC(LAN.DATMOV) AS DATFIS
      FROM TT_LAN LAN INNER JOIN TT_SAL SAL ON LAN.CODFIL=SAL.CODFIL AND 
                                           LAN.FILMAT=SAL.FILMAT AND
                                           LAN.CODMAT=SAL.CODMAT AND
                                           LAN.CODCOR=SAL.CODCOR AND
                                           LAN.CODTAM=SAL.CODTAM AND
                                           LAN.CODMUL=SAL.CODMUL
                      INNER JOIN TD_LAN DLAN ON DLAN.CODTAB=LAN.TIPLAN
                      LEFT JOIN TD_NAT DNAT ON DNAT.CODTAB = DLAN.LANNAT
     WHERE LAN.SITMOV<>'C'
       AND DLAN.MOVLEG = 'T'
       AND COALESCE(LAN.QTD_CM,0) <> 0    
       AND LAN.DATMOV > TO_DATE(TO_CHAR(COALESCE(SAL.INI_CM,TO_DATE('01/01/1900','DD/MM/YYYY')),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS')    
    UNION ALL
    -- AJUSTES DE CUSTO MDIO
    SELECT COALESCE('Ajuste de Custo Mdio',NULL) AS NATURE,
           ACM.DOCUME,
           ACM.ORD_CM,
           ACM.DATAJU AS DATMOV,
           0 AS QTD_CM,
           ACM.VLRAJU AS VLR_CM,
           ACM.VLRAJU AS VLRCMG,
           CASE WHEN COALESCE(TRUNC(ACM.SAL_CM,3),0) = 0 THEN 0 ELSE ROUND(ROUND(ACM.TOT_CM,2)/TRUNC(ACM.SAL_CM,3),4) END AS VLR_CM_UNI,
           CASE WHEN COALESCE(TRUNC(ACM.SAL_CM,3),0) = 0 THEN 0 ELSE ROUND(ROUND(ACM.TOTCMG,2)/TRUNC(ACM.SAL_CM,3),4) END AS VLRCMG_UNI,
           ACM.CODFIL,ACM.FILMAT,ACM.CODMAT,ACM.CODCOR,ACM.CODTAM,
           TO_CHAR('A') AS TIPMOV,
           ACM.VLRAJU AS VLRMOV,
           ACM.SAL_CM,
           CASE ACM.SAL_CM WHEN 0 THEN 0
                           ELSE ACM.TOT_CM
           END AS TOT_CM,
           CASE ACM.SAL_CM WHEN 0 THEN 0
                           ELSE ACM.TOTCMG
           END AS TOTCMG, 
           ACM.SEQUEN,
           0 AS NUMITE,
           CAST(NULL AS CHAR(2)) AS CODSER,
           TRUNC(ACM.DATAJU) AS DATFIS
      FROM TT_ACM ACM INNER JOIN TT_SAL SAL ON ACM.CODFIL=SAL.CODFIL AND 
                                               ACM.FILMAT=SAL.FILMAT AND
                                               ACM.CODMAT=SAL.CODMAT AND
                                               ACM.CODCOR=SAL.CODCOR AND
                                               ACM.CODTAM=SAL.CODTAM AND
                                               SAL.CODMUL = 0
     WHERE ACM.SITMOV<>'C'
       AND ACM.DATAJU > TO_DATE(TO_CHAR(COALESCE(SAL.INI_CM,TO_DATE('01/01/1900','DD/MM/YYYY')),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS')    
   ) TAB 
 WHERE NOT EXISTS (SELECT SEQUEN 
                     FROM TT_KIT KIT
                    WHERE KIT.FILMAT=TAB.FILMAT
                      AND KIT.CODMAT=TAB.CODMAT
                      AND KIT.CODCOR=TAB.CODCOR
                      AND KIT.CODTAM=TAB.CODTAM)
;


/*-- SEQ 2035 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CUSPAR CASCADE;

/*-- SEQ 2036 --*/
CREATE OR REPLACE VIEW TV_CUSPAR AS
SELECT CUS.CODFIL, 
       CUS.SEQUEN, 
       PAG.NUMPAR, 
       PAG.SUBPAR, 
       CUS.TIPNOT, 
       CUS.CODCUS,
       COALESCE(PAG.VLRPGT,0)*(CUS.VLRRAT/COM.VLRLIQ) AS CUSPAR
  FROM TT_CUS CUS INNER JOIN TT_COM COM ON CUS.CODFIL = COM.CODFIL
                                       AND CUS.SEQUEN = COM.SEQUEN
                  INNER JOIN TT_PAG PAG ON CUS.CODFIL = PAG.CODFIL
                                       AND CUS.SEQUEN = PAG.SEQUEN
;


/*-- SEQ 2037 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CXG CASCADE;

/*-- SEQ 2038 --*/
CREATE OR REPLACE VIEW TV_CXG AS
select cxg.filmat, cxg.codmat, cxg.codcor, cxg.codtam,
       gra.filmat as filcxg,
       gra.codmat as codcxg,
       gra.codcor as corcxg,
       gra.codtam as tamcxg
  from tt_gra gra INNER JOIN tt_pro pro ON pro.filmat = gra.filmat AND pro.codmat = gra.codmat
                  INNER JOIN tt_cxg cxg ON coalesce(cxg.class1,pro.class1) = pro.class1
                                       and coalesce(cxg.class2,pro.class2) = pro.class2
                                       and coalesce(cxg.class3,pro.class3) = pro.class3
                                       and coalesce(cxg.class4,pro.class4) = pro.class4
                                       and coalesce(cxg.depart,pro.depart) = pro.depart
                                       and coalesce(cxg.filmar,pro.filmar) = pro.filmar
                                       and coalesce(cxg.codmar,pro.codmar) = pro.codmar
                                       and coalesce(cxg.tipmar,pro.tipmar) = pro.tipmar
 where cxg.filcxg is null
   and cxg.filmat is not null
   and cxg.codmat is not null
union all
select cxg.filmat, cxg.codmat, cxg.codcor, cxg.codtam,
       gra.filmat as filcxp,
       gra.codmat as codcxp,
       gra.codcor as codcxp,
       gra.codtam as tamcxp
  from tt_cxg cxg INNER JOIN tt_gra gra ON cxg.filcxg = gra.filmat and cxg.codcxg = gra.codmat
 where cxg.filcxg is not null
   and cxg.corcxg is null
   and cxg.filmat is not null
   and cxg.codmat is not null
union all
select filmat, codmat, codcor, codtam,
       filcxg,
       codcxg,
       corcxg,
       tamcxg
  from tt_cxg
 where corcxg is not null
   and filmat is not null
   and codmat is not null
union all
select gra.filmat, gra.codmat, gra.codcor, gra.codtam,      
       cxg.filcxg,
       cxg.codcxg,
       cxg.corcxg,
       cxg.tamcxg      
  from tt_pro pro INNER JOIN tt_gra gra ON gra.filmat = pro.filmat and gra.codmat = pro.codmat   
                  INNER JOIN tt_cxg cxg ON coalesce(cxg.class1,pro.class1) = pro.class1
                                       and coalesce(cxg.class2,pro.class2) = pro.class2
                                       and coalesce(cxg.class3,pro.class3) = pro.class3
                                       and coalesce(cxg.class4,pro.class4) = pro.class4
                                       and coalesce(cxg.depart,pro.depart) = pro.depart
                                       and coalesce(cxg.filmar,pro.filmar) = pro.filmar
                                       and coalesce(cxg.codmar,pro.codmar) = pro.codmar
                                       and coalesce(cxg.tipmar,pro.tipmar) = pro.tipmar
 where cxg.filcxg is not null
   and cxg.codcxg is not null
   and cxg.corcxg is not null
   and cxg.tamcxg is not null
   and cxg.filmat is null
   and cxg.codmat is null
 ;




/*-- SEQ 2039 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_DEB_CCC CASCADE;

/*-- SEQ 2040 --*/
CREATE OR REPLACE VIEW TV_DEB_CCC AS
SELECT CCC.FILCLI AS FILCLI,
       CCC.CODCLI AS CODCLI,
       CCC.PLACAS AS PLACAS,
       COALESCE(MOT.NOMCLI,'-X-') AS NOMMOT,
       COALESCE(VXP.QTD_KM,0) AS QTD_KM,
       Combustiveis(VEN.CODFIL,VEN.SEQUEN) AS QTDLIT,
       COALESCE(CCC.VLRLAN,0) AS VLRLAN,
       COALESCE(VXP.ORIGEM,'-X-') AS ORIGEM,
       COALESCE(VXP.DESTIN,'-X-') AS DESTIN,
       CCC.DATOPE AS DATOPE,
       COALESCE(FIL.NOMFIL,'-X-') AS NOMFIL,
       COALESCE(CCC.NUMDOC,'-X-') AS CUPFIS,
       COALESCE(DCCC.DESCCC,'-X-') AS TIPDEB,
       COALESCE(PROXIMOFATURAMENTO( CCC.FILCLI, CCC.CODCLI, CCC.TIPCCC, agora()),agora()) AS PRXFAT,
       CCC.FILFAT AS FILFAT,
       CCC.SEQFAT AS SEQFAT,
       TRA.NUMDOC AS NUMDOC,
       CCC.COMPLE, CCC.STATUS,
       CCC.CODFIL,
       FAT.NUMNOT,
       CCC.TIPCCC
FROM TT_CCC CCC INNER JOIN TD_FIL FIL  ON FIL.CODFIL = CCC.CODFIL
                INNER JOIN TT_CLI TRA  ON CCC.FILCLI = TRA.FILCLI AND CCC.CODCLI = TRA.CODCLI
                INNER JOIN TD_CCC DCCC ON DCCC.CODTAB = CCC.TIPCCC
                LEFT  JOIN TT_VEN VEN  ON VEN.CODFIL = CCC.CODFIL AND VEN.SEQUEN = CCC.SEQVEN 
                                      -- Fernando - 72128 (Comentado cdigo abaixo, para trazer QTDLIT, mesmo quando for CARTA FRETE)
                                      --AND VEN.FILCLI = CCC.FILCLI                             --  SOMENTE APRESENTA OS DADOS DA VENDA
                                      --AND VEN.CODCLI = CCC.CODCLI                             -- SE O CLIENTE FOR O MESMO (QUANDO CARTA FRETE NAO MOSTRA)
                LEFT  JOIN TT_VXP VXP  ON VXP.CODFIL = CCC.CODFIL AND VXP.SEQUEN = CCC.SEQVEN
                LEFT  JOIN TT_CLI MOT  ON MOT.FILCLI = VXP.FILMOT AND MOT.CODCLI = VXP.CODMOT
                LEFT  JOIN TT_VEN FAT  ON FAT.CODFIL = CCC.FILFAT
                                      AND FAT.SEQUEN = CCC.SEQFAT            
                LEFT  JOIN TT_CCC ORI ON CCC.CODFIL = ORI.FILCCC AND CCC.SEQUEN = ORI.SEQCCC
                LEFT  JOIN TT_CCC DES ON DES.CODFIL = CCC.FILCCC AND DES.SEQUEN = CCC.SEQCCC 
 WHERE (VEN.FLGEST <> 'C' OR VEN.FLGEST IS NULL)
   AND CCC.STATUS <> 'F'
   AND (CCC.SEQCCC IS NULL OR DES.SEQFAT IS NOT NULL)
   AND ORI.CODFIL IS NULL   
;


/*-- SEQ 2041 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_DEB_FAT CASCADE;

/*-- SEQ 2042 --*/
CREATE OR REPLACE VIEW TV_DEB_FAT AS
SELECT VEN.FILCLI,
       VEN.CODCLI,
       VEN.CODFIL,
       VEN.SEQUEN,
       REC.VLRPAR*-1 AS VLRLAN,
       VEN.DATHOR,
       REC.DATVEN,
       REC.PAGAME,
       CLI.NUMDOC,
       cast(COALESCE(VEN.CODSER,'')||'/'||TRIM(COALESCE(VEN.NUMNOT,''))||'-'|| COALESCE(REC.NUMPAR,'') ||'/'|| COALESCE(REC.SUBPAR,'') as VARCHAR(254)) AS DOCUME,
       CASE WHEN REC.FLGEST = 'A' AND REC.CARTAO IS NULL AND REC.SEQCHE IS NULL THEN 'ABERTO'
            ELSE 'PAGO'       
       END AS STATUS,
       VEN.FLGEST,
       DCCC.DESCCC AS TIPO,
       CASE WHEN REC.FLGEST = 'A' AND REC.CARTAO IS NULL AND REC.SEQCHE IS NULL THEN 'ABERTO'
            ELSE ResumodeParcela(VEN.CODFIL,VEN.SEQUEN,REC.NUMPAR,REC.SUBPAR)
       END AS MEIOPG,       
       VEN.VLRLIQ AS VLRFAT,
       USU.APEUSU, REC.VLRPGT,
	   CCC.COMPLE
  FROM TT_VEN VEN INNER JOIN TT_REC REC ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                  LEFT  JOIN TT_CCC CCC ON VEN.CODFIL = CCC.CODVEN AND VEN.SEQUEN = CCC.SEQVEN 				  
                  LEFT JOIN TD_CCC DCCC ON REC.TIPCCC = DCCC.CODTAB
		   LEFT JOIN TT_USU USU ON VEN.FILVEN = USU.FILUSU AND VEN.CODVEN = USU.CODUSU
 WHERE REC.FLGEST IN ('A','P')
   AND VEN.FLGEST <> 'C'
   AND VEN.CODSER = 'CC'
 ;



/*-- SEQ 2043 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_DEV_CREDIT CASCADE;

/*-- SEQ 2044 --*/
CREATE OR REPLACE VIEW TV_DEV_CREDIT AS
SELECT DEV.CODFIL, -- Filial
       DEV.SEQUEN, -- Nr. Registro
       DEV.REGINC, -- Registro~Incluso
       DEV.REGEXC, -- Registro~Ixcluso
       DEV.TRNINC, -- Transmisso~Incluso
       DEV.TRNEXC, -- Transmisso~Ixcluso
       CASE WHEN DEV.FILREC IS NOT NULL THEN
       '(Filial='
       ||REC.CODFIL||
       ' NF/CF= '
       ||LTRIM(RTRIM(VEN.CODSER))||
       '/'
       ||LTRIM(RTRIM(VEN.NUMNOT))||
       ' ECF='
       ||VEN.NUMECF||
       ' Parcela='
       ||LTRIM(RTRIM(REC.NUMPAR))||
       '/'
       ||LTRIM(RTRIM(REC.SUBPAR))||
       ')'
       ELSE
       '(Banco='
       ||CHR.CODBCO||
       ' Agncia='
       ||CHR.CODAGE||
       ' Conta='
       ||CHR.NUMCON||
       ' Cheque='
       ||CHR.NUMCHE||
       ')'
       END AS DOCUME,
       DEV.FILCLI, DEV.CODCLI
  FROM TT_DEV DEV LEFT OUTER JOIN TT_REC REC ON REC.CODFIL = DEV.FILREC
                                            AND REC.SEQUEN = DEV.SEQREC
                                            AND REC.NUMPAR = DEV.NUMPAR
                                            AND REC.SUBPAR = DEV.SUBPAR
                  LEFT OUTER JOIN TT_VEN VEN ON VEN.CODFIL = DEV.FILREC
                                            AND VEN.SEQUEN = DEV.SEQREC
                  LEFT OUTER JOIN TT_CHR CHR ON REC.CODFIL = CHR.CODFIL
                                            AND REC.SEQUEN = CHR.SEQUEN
;


/*-- SEQ 2045 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_DIA CASCADE;

/*-- SEQ 2046 --*/
CREATE OR REPLACE VIEW TV_DIA AS
SELECT CAST(TIPDIA AS VARCHAR(2)) AS TIPDIA, 
       CAST(TIPERR AS VARCHAR(40)) AS TIPERR,
       CAST(CODFIL AS VARCHAR(3)) AS CODFIL,
       DATOPE,
       CAST(FILUSU AS VARCHAR(3)) AS FILUSU,
       CAST(CODUSU AS VARCHAR(3)) AS CODUSU,
       CAST(APEUSU AS VARCHAR(10)) AS APEUSU,
       CAST(DOCUME AS VARCHAR(10)) AS DOCUME,
       CAST(NUMECF AS VARCHAR(3)) AS NUMECF,
       CAST( MSGERR  AS VARCHAR(255))  AS MSGERR
FROM(
   select cast('01' as VARCHAR(2)) as tipdia,
          CASE WHEN TIPOPE = 'PRECONOVO' THEN 'Preos Atualizados'
               ELSE cast(substr('Transao invlida: '||COALESCE(to_char(a.trn_id),'')||'-'||COALESCE(a.tipope,'')||
                          case when a.coderr is null then ''
                               else ','||COALESCE(to_char(a.coderr),'')
                                end,1,40) as VARCHAR(40)
                        )
               END 
          as tiperr,          
          a.codfil,
          a.dathor as datope,
          a.filusu,
          a.codusu,
          coalesce(b.apeusu,'* Nenhum *') as apeusu,
          cast(substr(case a.codser when '--' then ''
                                         else a.codser||'-'
                 end||trim(COALESCE(a.cupfis,'')),1,10) as VARCHAR(10)) as docume,
          a.numecf,
          a.msgerr
   from tt_lcf a left outer join tt_usu b on a.filusu = b.filusu and a.codusu = b.codusu
   where a.flgest = 'T'
   union all
   select /*+RULE*/ cast('02' as VARCHAR(2)) as tipdia,
          cast(substr('Dia Aberto: Cupons '||coalesce(TO_CHAR(cupini),'')||' a '||coalesce(TO_CHAR(cupfim),''),1,40) as VARCHAR(40)) as tiperr,
          ecf.codfil, datope,
          to_char(null) as filusu,
          to_char(null) as codusu,
          to_char('* Nenhum *') as apeusu,
          cast(substr(to_char(cnt_rz),1,10) as VARCHAR(10)) as docume,
          numecf,
          LCF.msgerr
   from  td_fil fil inner join tr_ecf ecf on ecf.codfil = fil.codfil
               left outer join (SELECT CODFIL, MSGERR FROM TT_LCF WHERE CODFIL IS NULL) LCF on lcf.codfil = ecf.codfil
   where diafec is null
   union all
   select /*+RULE*/ cast('03' as VARCHAR(2)) as tipdia,
          cast(SUBSTR(CASE WHEN QTDERR > 0 THEN 'Erro ao executar o job ' ELSE 'Job parado: ' END||NOMJOB,1,40) as VARCHAR(40)) AS tiperr,
          codloj as codfil,
          ultexe as datope,
          to_char(null) as filusu,
          to_char(null) as codusu,
          to_char('* Nenhum *') as apeusu,
          cast(null as VARCHAR(10)) as docume,
          to_char(null) as numecf,
          ulterr as msgerr
    from  (select min(codloj) as codloj from tt_idf) idf, tt_job
    where (qtderr > 0)
       OR (ultexe < add_day(agora(),-25))
   union all
   select cast('04' as VARCHAR(2)) as tipdia,
          cast(SUBSTR('Pedido no separado: ' || orc.codfil||'-'||orc.numped,1,40) as VARCHAR(40)) AS tiperr,
          orc.codfil as codfil,
          orc.ped_em as datope,
                  orc.filusu as filusu,
                  orc.codusu as codusu,
                  usu.apeusu as apeusu,
                  cast(orc.codfil||'-'||orc.numped as VARCHAR(15)) as docume,
                  to_char(null) as numecf,
                  lcf.msgerr
             from tt_orc orc left  join tt_usu usu on usu.filusu = orc.filusu and
                                                      usu.codusu = orc.codusu
                             left outer join (SELECT CODFIL, MSGERR FROM TT_LCF WHERE CODFIL IS NULL) LCF on lcf.codfil = orc.codfil
                             cross join tt_cfg cfg
            where orc.flgest = 'A'
              and orc.aprcli = '1'
              and orc.aprova = 'A'
              and orc.ped_em > add_day(agora(), - (1/24*cfg.hor_separa))
              and not exists (select 1 as ok
                                from tt_ior ior left join tt_ivo ivo on ivo.filped = ior.codfil and
                                                                        ivo.tipped = ior.tipped and
                                                                        ivo.numped = ior.numped and
                                                                        ivo.numite = ior.numite
                               where ior.codfil = orc.codfil
                                 and ior.tipped = orc.tipped
                                 and ior.numped = orc.numped)
   union all
   select cast('05' as VARCHAR(2)) as tipdia,
          cast(substr('Produtos com estoque negativo: '|| count(*) ,1,40) as VARCHAR(40)) as tiperr,
          to_char(null) as codfil,
          agora() as datope,
          to_char(null) as filusu,
          to_char(null) as codusu,
          to_char('* Nenhum *') as apeusu,
          cast(null as VARCHAR(10)) as docume,
          to_char(null) as numecf,
          null as msgerr
    from  tt_sal sal cross join tt_cfg cfg
   where sal.qtdest + sal.reserv < 0
     and cfg.AVISA_ESTOQUE_NEG = 'T'
   having count(*)>0
   union all
   select cast('06' as VARCHAR(2)) as tipdia,
          cast('Existem '|| COUNT(*) || ' e-mails para serem enviados'  as VARCHAR(40)) as tiperr,
          to_char(null) as codfil,
          agora() as datope,
          to_char(null) as filusu,
          to_char(null) as codusu,
          to_char('* Nenhum *') as apeusu,
          cast(null as VARCHAR(10)) as docume,
          to_char(null) as numecf,
          NULL as msgerr
     from TT_MAI
    WHERE TRUNC(DATSOL) < TRUNC(agora())
      AND DATENV IS NULL
   HAVING COUNT(*)>0
   union all
   /*select TO_CHAR('07') as tipdia,
          'Cartes financeiramente inconsistentes: '|| COUNT(*)
                          || '. Atualize o checkout e solicite ao suporte procedimento de ajuste. '  as tiperr,
          to_char(null) as codfil,
          agora() as datope,
          to_char(null) as filusu,
          to_char(null) as codusu,
          to_char('* Nenhum *') as apeusu,
          to_char(null) as docume,
          to_char(null) as numecf,
          NULL as msgerr
     FROM TT_CTM
    WHERE INVALI='T'
   HAVING COUNT(*)>0
   union all */
   SELECT CAST('08'  AS VARCHAR(2)) AS TIPDIA,
          CAST(SUBSTR('Falta fech. pista '||to_char(dat.datope,'DD/MM/YY')||' Tanq '||TAN.TANQUE,1,40)AS VARCHAR(40))  AS TIPERR,
          LMC.CODFIL AS CODFIL,
          DAT.DATOPE AS DATOPE,
          TO_CHAR(NULL) AS FILUSU,
          TO_CHAR(NULL) AS CODUSU,
          to_char('* Nenhum *') as apeusu,
          CAST(NULL AS VARCHAR(10)) AS DOCUME,
          TO_CHAR(NULL) AS NUMECF,
          NULL AS MSGERR
     FROM TT_LMC LMC INNER JOIN TT_DAT DAT ON DAT.DATOPE BETWEEN ADD_DAY(LMC.DATINI,1) AND ADD_DAY(LMC.DATINI,3)
                     INNER JOIN TD_TAN TAN ON TAN.GRAFIL = LMC.FILMAT AND TAN.GRACOD = LMC.CODMAT
                                          AND TAN.GRACOR = LMC.CODCOR AND TAN.GRATAM = LMC.CODTAM
                                          AND TAN.FILTAN = LMC.CODFIL
                      LEFT JOIN TT_FCP FCP ON FCP.CODFIL = TAN.FILTAN AND FCP.TANMED = TAN.TANQUE
                                          AND FCP.DATMED = DAT.DATOPE
    WHERE FCP.CODFIL IS NULL
      AND LMC.DATINI >= ADD_DAY(AGORA(),-365)
   UNION ALL
   SELECT CAST('09'  AS VARCHAR(2)) AS TIPDIA,
          cast(substr('Existem '||COUNT(*)||' lanamentos financeiramente inconsistentes'
                          || '. Motivo da inconsistncia: '||
          CASE MOTINC WHEN 'D' THEN 'Diferena entre numerria e gerencial.'
                      WHEN '+' THEN 'Diferenas entre contas de movimentao.'
                      WHEN 'V' THEN 'Lanamento fora de validade financeira.'
                      WHEN 'L' THEN 'Valor de lanamento e contra lanamento no conferem.'
                      WHEN 'F' THEN 'Faltam informaes obrigatrias em um lanamento financeiro.'
                      WHEN 'C' THEN 'Falta conta de contrapartida.'
          END,1,254) AS VARCHAR(254)) AS TIPERR,
          TO_CHAR(NULL) AS CODFIL,
          AGORA() AS DATOPE,
          TO_CHAR(NULL) AS FILUSU,
          TO_CHAR(NULL) AS CODUSU,
          TO_CHAR('* Nenhum *') as apeusu,
          CAST(NULL AS VARCHAR(10)) AS DOCUME,
          TO_CHAR(NULL) AS NUMECF,
          NULL AS MSGERR
     FROM TL_FIN
    WHERE FLGEST='I'
   GROUP BY MOTINC
   HAVING COUNT(*)>0
   UNION ALL
   -- VERIFICA SE EXISTE REDUO Z NO EXPORTADA NO PERODO QUE J FORAM EXPORTADOS OS MAPAS RESUMOS.
   -- CONSISTNCIA VALE A PARTIR DO PRIMEIRO MAPA RESUMO CRIADO NA FILIAL.
   SELECT CAST('10' AS VARCHAR(2)) AS TIPDIA,
          CAST(SUBSTR(CASE WHEN MPR.NUMERO IS NULL
                           then 'Reduo Z do dia '||to_char(recf.datope,'dd/mm/yyyy')||' na filial '||recf.codfil||' no possui mapa resumo.'
                           else 'Reduo Z do dia '||to_char(recf.datope,'dd/mm/yyyy')||' na filial '||recf.codfil||' no foi exportada.'
                      END,1,254) AS VARCHAR(254)) AS TIPERR,
          RECF.CODFIL,
          RECF.DATOPE,
          TO_CHAR(NULL) AS FILUSU,
          TO_CHAR(NULL) AS CODUSU,
          TO_CHAR('* Nenhum *') as apeusu,
          CAST(NULL AS VARCHAR(10)) AS DOCUME,
          TO_CHAR(NULL) AS NUMECF,
          NULL AS MSGERR
     FROM TR_ECF RECF INNER JOIN TD_FIL DFIL ON DFIL.CODFIL = RECF.CODFIL
                      INNER JOIN TD_ECF DECF ON DECF.FILECF = RECF.CODFIL
                                            AND DECF.NUMECF = RECF.NUMECF
                       LEFT JOIN TT_MPR MPR ON MPR.CODFIL = RECF.CODFIL
                                           AND MPR.DATOPE = RECF.DATOPE
    WHERE DFIL.FILATI = 'T'
      AND DECF.ECFATI = 'T'
      AND RECF.EXPORT = 'F'
      AND (SELECT COUNT(*)
             FROM TT_MPR MPR2
            WHERE MPR2.CODFIL = DFIL.CODFIL) > 0
      AND RECF.DATOPE <= (SELECT MAX(MPR.DATOPE)
                            FROM TT_MPR MPR
                           WHERE MPR.CODFIL = RECF.CODFIL
                             AND MPR.EXPORT = 'T')
      AND RECF.DATOPE >= (SELECT MIN(MPR.DATOPE)
                            FROM TT_MPR MPR
                           WHERE MPR.CODFIL = RECF.CODFIL
                             AND MPR.EXPORT = 'T')
   UNION ALL
   -- VERIFICA SE DEVERIA EXISTIR ALGUM MAPA RESUMO NO PERODO DO LTIMO MAPA RESUMO AT ONTEM.
   -- CONSISTNCIA VALE A PARTIR DO PRIMEIRO MAPA RESUMO CRIADO NA FILIAL.
   SELECT CAST('10' AS VARCHAR(2)) AS TIPDIA,
          CAST(SUBSTR('No foi gerado mapa resumo para o dia '||to_char(tab.datope,'dd/mm/yyyy')||' na filial '||tab.codfil||'.',1,254) as VARCHAR(254)) as tiperr,
          TAB.CODFIL,
          TAB.DATOPE,
          TO_CHAR(NULL) AS FILUSU,
          TO_CHAR(NULL) AS CODUSU,
          TO_CHAR('* Nenhum *') as apeusu,
          CAST(NULL AS VARCHAR(10)) AS DOCUME,
          TO_CHAR(NULL) AS NUMECF,
          NULL AS MSGERR
     FROM (
           SELECT DFIL.CODFIL, DAT.DATOPE
             FROM TD_FIL DFIL CROSS JOIN TT_DAT DAT
            WHERE DFIL.FILATI = 'T'
              AND DAT.DATOPE BETWEEN ADD_DAY((SELECT MAX(MPR.DATOPE)
                                                FROM TT_MPR MPR
                                               WHERE MPR.CODFIL = DFIL.CODFIL),1)
                                 AND ADD_DAY(AGORA(),-1)
          ) TAB INNER JOIN TD_ECF DECF ON DECF.FILECF = TAB.CODFIL
    WHERE DECF.ECFATI = 'T'
      AND EXISTS (SELECT 1 AS OK
                    FROM TT_MPR MPR2
                   WHERE MPR2.CODFIL = TAB.CODFIL)
      AND (EXISTS (SELECT 1 AS OK
                     FROM TR_ECF RECF
                    WHERE RECF.CODFIL = DECF.FILECF
                      AND RECF.NUMECF = DECF.NUMECF
                      AND RECF.DATOPE = TAB.DATOPE) OR
           EXISTS (SELECT 1 AS OK
                     FROM TT_CCX CCX
                    WHERE CCX.CODFIL = DECF.FILECF
                      AND CCX.NUMECF = DECF.NUMECF
                      AND CCX.DATABE = TAB.DATOPE) OR
           EXISTS (SELECT 1 AS OK
                     FROM TT_VEN VEN
                    WHERE VEN.CODFIL = DECF.FILECF
                      AND VEN.NUMECF = DECF.NUMECF
                      AND VEN.DATFIS = TAB.DATOPE) OR
           EXISTS (SELECT 1 AS OK
                     FROM TT_CHR CHR
                    WHERE CHR.CODFIL = DECF.FILECF
                      AND CHR.NUMECF = DECF.NUMECF
                      AND CHR.DATFIS = TAB.DATOPE) OR
           EXISTS (SELECT 1 AS OK
                     FROM TT_FIN FIN INNER JOIN TT_OPE OPE ON OPE.FILFIN = FIN.CODFIL
                                                          AND OPE.SEQFIN = FIN.SEQUEN
                    WHERE FIN.CODFIL = DECF.FILECF
                      AND OPE.NUMECF = DECF.NUMECF
                      AND FIN.DATFIS = TAB.DATOPE) OR
           EXISTS (SELECT 1 AS OK
                     FROM TR_ECF RECF
                    WHERE RECF.CODFIL = DECF.FILECF
                      AND RECF.NUMECF = DECF.NUMECF
                      AND RECF.DATOPE = TAB.DATOPE) OR
           EXISTS (SELECT 1 AS OK
                     FROM TT_TEF TEF
                    WHERE TEF.CODFIL = DECF.FILECF
                      AND TEF.NUMECF = DECF.NUMECF
                      AND TEF.DATFIS = TAB.DATOPE)
           )
   UNION ALL
   -- VERIFICA SE ALGUM MAPA RESUMO NO FOI EXPORTADO
   SELECT CAST('10' AS VARCHAR(2)) AS TIPDIA,
          CAST(SUBSTR('Mapa resumo do dia '||to_char(mpr.datope,'dd/mm/yyyy')||' na filial '||mpr.codfil||' no foi exportado.',1,254) as VARCHAR(254)) as tiperr,
          MPR.CODFIL,
          MPR.DATOPE,
          TO_CHAR(NULL) AS FILUSU,
          TO_CHAR(NULL) AS CODUSU,
          to_char('* Nenhum *') as apeusu,
          CAST(NULL AS VARCHAR(10)) AS DOCUME,
          TO_CHAR(NULL) AS NUMECF,
          NULL AS MSGERR
     FROM TT_MPR MPR
    WHERE MPR.EXPORT = 'F'
      AND MPR.DATOPE <= ADD_DAY(AGORA(),1)
   UNION ALL
   SELECT CAST('11' AS VARCHAR(2)) AS TIPDIA,
          CAST(SUBSTR(CASE WHEN TRUNC(ADD_DAY(DATHOR, 1))-TRUNC(AGORA()) > 0 THEN 'Restam '||IntervaloHoras(AGORA(), ADD_DAY(DATHOR, 1))||' horas para cancelar a nota fiscal '||TT_VEN.NUMNOT||' no SEFAZ. Comunique ao suporte.'
                                                               ELSE 'A nota fiscal '||TT_VEN.NUMNOT||' excedeu o limite de 24 horas para cancelamento eletrnico e deve ser cancelada no SEFAZ. Consulte o suporte.'
                      END,1,254) AS VARCHAR(254)) AS TIPERR,
          TO_CHAR(TT_VEN.CODFIL) AS CODFIL,
          TT_VEN.DATHOR AS DATOPE,
          TO_CHAR(TT_VEN.FILUSU) AS FILUSU,
          TO_CHAR(TT_VEN.CODUSU) AS CODUSU,
          TT_USU.APEUSU AS APEUSU,
          TT_VEN.NUMNOT AS DOCUME,
          TO_CHAR(NULL) AS NUMECF,
          NULL AS MSGERR
     FROM TT_VEN INNER JOIN TD_SER ON TT_VEN.CODSER = TD_SER.CODSER
                 INNER JOIN TT_USU ON TT_VEN.CODUSU = TT_USU.CODUSU AND TT_VEN.FILUSU = TT_USU.FILUSU
    WHERE TD_SER.MODNOT = '55'
      AND TT_VEN.FLGEST = 'C'
      AND COALESCE(TT_VEN.FLGNFE, 'X') NOT IN ('2','3','4','6')
      AND TT_VEN.FILEST IS NULL -- ESTORNO DE NOTA
      AND TRUNC(ADD_DAY(DATHOR, 60))-TRUNC(AGORA()) > 0
   UNION ALL
   SELECT CAST('11' AS VARCHAR(2)) AS TIPDIA,
          CAST(SUBSTR('A nota fiscal '||TT_VEN.NUMNOT||' deve ser inutilizada no SEFAZ at o dia '||to_date(ANO_MES(ADD_MONTHS(TT_VEN.DATHOR, 1))||'-10' , 'yyyy/mm/dd')||'. Consulte o suporte.',1,254) as VARCHAR(254))
          AS TIPERR,
          TO_CHAR(TT_VEN.CODFIL) AS CODFIL,
          TT_VEN.DATHOR AS DATOPE,
          TO_CHAR(TT_VEN.FILUSU) AS FILUSU,
          TO_CHAR(TT_VEN.CODUSU) AS CODUSU,
          TT_USU.APEUSU AS APEUSU,
          TT_VEN.NUMNOT AS DOCUME,
          TO_CHAR(NULL) AS NUMECF,
          NULL AS MSGERR
     FROM TT_VEN INNER JOIN TD_SER ON TT_VEN.CODSER = TD_SER.CODSER
                 INNER JOIN TT_USU ON TT_VEN.CODUSU = TT_USU.CODUSU AND TT_VEN.FILUSU = TT_USU.FILUSU
    WHERE TD_SER.MODNOT = '55'
      AND TT_VEN.FLGEST = 'C'
      AND  COALESCE(TT_VEN.FLGNFE, 'X') = '2'
      AND TRUNC(AGORA()) <= TO_DATE(ANO_MES(ADD_MONTHS(TT_VEN.DATHOR, 1))|| '-10', 'YYYY/MM/DD')
   UNION ALL
   -- VERIFICA SE H ALGUM MS ENTRE OS 12 ANTERIORES QUE NO EST APROVADO A RECEITA BRUTA.
   -- 81205 - LEO
   SELECT TO_CHAR('12') AS TIPDIA,
          'Receita Bruta do ms '||BRU.MESREF||'/'||BRU.ANOREF||' da empresa '||BRU.NUMDOC||' no foi aprovada.' AS TIPERR,
          TO_CHAR(NULL) AS CODFIL,
          BRU.DATINC,
          TO_CHAR(NULL) AS FILUSU,
          TO_CHAR(NULL) AS CODUSU,
          TO_CHAR('* Nenhum *') AS APEUSU,
          TO_CHAR(NULL) AS DOCUME,
          TO_CHAR(NULL) AS NUMECF,
          NULL AS MSGERR
     FROM TT_BRU BRU
    WHERE BRU.APROVA = 'F'
      AND ANOREF >= CASE WHEN ISLEAP(TO_NUMBER(TO_CHAR(AGORA(),'YYYY'))) = 'T'
                         THEN TO_NUMBER(TO_CHAR(TRUNC(ADD_DAY(AGORA(),-366)),'YYYY'))
                         ELSE TO_NUMBER(TO_CHAR(TRUNC(ADD_DAY(AGORA(),-365)),'YYYY'))
                    END
      AND ANOREF  <= TO_NUMBER(TO_CHAR(AGORA(),'YYYY'))
      AND (MESREF >= TO_NUMBER(TO_CHAR(AGORA(),'MM')) OR ANOREF = TO_NUMBER(TO_CHAR(AGORA(),'YYYY')))
      AND (MESREF <  TO_NUMBER(TO_CHAR(AGORA(),'MM')) OR ANOREF <> TO_NUMBER(TO_CHAR(AGORA(),'YYYY')))
   UNION ALL
   -- RFMP 82258
   SELECT TO_CHAR('13') AS TIPDIA,
          'Existem '||SOMA||' retornos de NF-e no processados. Isto pode impedir o cancelamento e inutilizao de NF-es. Verifique se o servio TotaliNfe est ativo.' AS TIPERR,
          TO_CHAR(NULL) AS CODFIL,
          TRUNC(ADD_DAY(AGORA(),-1)),
          TO_CHAR(NULL) AS FILUSU,
          TO_CHAR(NULL) AS CODUSU,
          TO_CHAR('* Nenhum *') AS APEUSU,
          TO_CHAR(NULL) AS DOCUME,
          TO_CHAR(NULL) AS NUMECF,
          NULL AS MSGERR
     FROM (
       SELECT SUM(QTD) AS SOMA
         FROM (
           SELECT COUNT(*) AS QTD
             FROM TT_VEN VEN INNER JOIN TD_SER DSER ON VEN.CODSER = DSER.CODSER
            WHERE /*VEN.FLGNFE IS NOT NULL
              AND*/ VEN.DATHOR BETWEEN ADD_DAY(AGORA(),-10)
                                 AND ADD_DAY(AGORA(),-1)
              AND VEN.FLGEST <> 'C'
              AND COALESCE(VEN.FLGNFE, 'X') = '0'
              AND DSER.MODNOT = '55'
            UNION ALL
           SELECT COUNT(*) AS QTD
             FROM TT_VEN VEN INNER JOIN TD_SER DSER ON VEN.CODSER = DSER.CODSER
            WHERE /*VEN.FLGNFE IS NOT NULL
              AND*/ VEN.DATHOR BETWEEN ADD_DAY(AGORA(),-10)
                                 AND ADD_DAY(AGORA(),-1)
              AND VEN.FLGEST = 'C'
              AND COALESCE(VEN.FLGNFE, 'X') IN ('0','1','2')
              AND DSER.MODNOT = '55'
              AND VEN.FILEST IS NULL -- ESTORNO DE NOTA
             ) TAB
         ) SUB
    WHERE SUB.SOMA > 0
    UNION ALL
    SELECT TO_CHAR('14') AS TIPDIA,
          'A nota nmero '||trim(NUMNOT)||' est com status '||DESDOM||'.  necessrio que seja feito a correo desta NF-e.' AS TIPERR,
          CODFIL,
          TRUNC(ADD_DAY(AGORA(),-1)),
          TO_CHAR(NULL) AS FILUSU,
          TO_CHAR(NULL) AS CODUSU,
          TO_CHAR('* Nenhum *') AS APEUSU,
          TO_CHAR(NULL) AS DOCUME,
          TO_CHAR(NULL) AS NUMECF,
          NULL AS MSGERR
     FROM (
       SELECT DESDOM, CODFIL, CODSER, NUMECF, NUMNOT
         FROM (
           SELECT DOM.DESDOM, VEN.CODFIL, VEN.CODSER, VEN.NUMECF, VEN.NUMNOT
             FROM TT_VEN VEN INNER JOIN TD_SER DSER ON VEN.CODSER = DSER.CODSER
             INNER JOIN TT_DOM DOM ON DOM.CODARQ = 'VEN '
                                  AND DOM.NOMCPO = 'FLGNFE'
                                  AND DOM.CODCHR = VEN.FLGNFE
            WHERE VEN.DATHOR BETWEEN ADD_DAY(AGORA(),-10)
                                 AND ADD_DAY(AGORA(),-1)
              AND VEN.FLGEST <> 'C'
              AND COALESCE(VEN.FLGNFE, 'X') <> '1'
              AND DSER.MODNOT = '55'
            ) TAB
           ) SUB
    UNION ALL
    --PEDRO E. BRAGA - 95992
   SELECT TO_CHAR('15') AS TIPDIA,
          CAST(CASE WHEN TAB.DIAVAL > 0
               THEN 'O arquivo CSV com alquotas para atendimento da lei de transparncia fiscal precisa ser atualizado para UF: '|| TAB.SIGEST ||' - '|| TAB.NOMEST ||'. '||
                    'Caso contrrio, o clculo deixar de aparecer no cupom fiscal. '||
                    'Faltam ['||TO_CHAR(DIAVAL)||'] dias.'
               ELSE 'O arquivo CSV com alquotas para atendimento da lei de transparncia fiscal est desatualizado para UF: '|| TAB.SIGEST ||' - '|| TAB.NOMEST ||'.'
               END AS VARCHAR(254)) AS TIPERR,
          CODFIL,
          TRUNC(ADD_DAY(AGORA(),-1)),
          TO_CHAR(NULL) AS FILUSU,
          TO_CHAR(NULL) AS CODUSU,
          TO_CHAR('* Nenhum *') AS APEUSU,
          TO_CHAR(NULL) AS DOCUME,
          TO_CHAR(NULL) AS NUMECF,
          NULL AS MSGERR
     FROM (SELECT SUB.CODFIL, SUB.SIGEST, MAX(DATINI) AS DATINI, MAX(SUB.DATFIM) AS DATFIM, MAX(SUB.DIAVAL) AS DIAVAL, CAST(MIN(DEST.NOMEST) AS VARCHAR(30)) AS NOMEST
             FROM ( SELECT CODFIL, SIGEST,
                           TO_NUMBER(TO_CHAR(DATFIM - AGORA(), 'DD'))                            AS DIAVAL,
                           MAX(DATINI) AS DATINI, MAX(DATFIM) AS DATFIM
                      FROM TT_IBP
                     WHERE DATINI > AGORA()
                  GROUP BY CODFIL, SIGEST,
                           TO_NUMBER(TO_CHAR(DATFIM - AGORA(), 'DD'))                            -- VIGENCIA FUTURA
                     UNION
                    SELECT CODFIL, SIGEST,
                           TO_NUMBER(TO_CHAR(DATFIM - AGORA(), 'DD'))                            AS DIAVAL,
                           MIN(DATINI) AS DATINI, MAX(DATFIM) AS DATFIM
                      FROM TT_IBP
                     WHERE DATINI <= AGORA()
                       AND DATFIM >= AGORA()
                  GROUP BY CODFIL, SIGEST,
                               TO_NUMBER(TO_CHAR(DATFIM - AGORA(), 'DD'))                                -- VIGENCIA ATUAL
                      UNION
                     SELECT CODFIL, SIGEST,
                            TO_NUMBER(TO_CHAR(DATFIM - AGORA(), 'DD'))                             AS DIAVAL,
                            MAX(DATINI) AS DATINI, MIN(DATFIM) AS DATFIM
                       FROM TT_IBP
                      WHERE DATFIM < AGORA()
                   GROUP BY CODFIL, SIGEST,
                            TO_NUMBER(TO_CHAR(DATFIM - AGORA(), 'DD'))                             -- VIGENCIA EXPIRADA
                   ) SUB
       INNER JOIN TD_EST DEST ON DEST.ESTADO = SUB.SIGEST
            WHERE SUB.SIGEST IN (SELECT DISTINCT TEND.SIGEST
                                   FROM TT_END TEND
                             INNER JOIN TD_FIL DFIL ON DFIL.CODFIL = TEND.CODFIL AND DFIL.FILATI='T'
                                  WHERE TEND.CODCLI = '     0')
         GROUP BY SUB.CODFIL, SUB.SIGEST
          ) TAB
    WHERE TAB.DIAVAL <= 10
   UNION ALL
   -- MANOEL - 100732
   SELECT CAST('16' AS VARCHAR(2)) AS TIPDIA,
          CAST(SUBSTR('O Cupom Eletrnico ' || VEN.CODSER || '/' || VEN.NUMNOT || ' da filial ' || VEN.CODFIL || ' est sem chave de acesso. Consulte o suporte.', 1, 254) AS VARCHAR(254))
          AS TIPERR,
          TO_CHAR(VEN.CODFIL) AS CODFIL,
          VEN.DATHOR AS DATOPE,
          TO_CHAR(VEN.FILUSU) AS FILUSU,
          TO_CHAR(VEN.CODUSU) AS CODUSU,
          USU.APEUSU AS APEUSU,
          VEN.NUMNOT AS DOCUME,
          TO_CHAR(NULL) AS NUMECF,
          NULL AS MSGERR
     FROM TT_VEN VEN INNER JOIN TD_SER DSER ON VEN.CODSER = DSER.CODSER
                     INNER JOIN TT_USU USU  ON VEN.CODUSU = USU.CODUSU
                                           AND VEN.FILUSU = USU.FILUSU
    WHERE DSER.MODNOT IN ('59', '65')
      AND VEN.FLGEST <> 'C'
      AND (VEN.CHAVEA IS NULL)
      AND VEN.DATHOR BETWEEN ADD_DAY(AGORA(),-60) AND ADD_DAY(AGORA(),-1)
   UNION ALL
   -- MANOEL - 100835
   SELECT CAST('17' AS VARCHAR(2)) AS TIPDIA,
          CAST(SUBSTR('A NFC-e ' || VEN.CODSER || '/' || VEN.NUMNOT || ' da filial ' || VEN.CODFIL || ' est aberta no sistema, porm sua autenticao no SEFAZ no foi confirmada. Campo FLGNFE deveria ser "1" ou "4". Consulte o suporte.', 1, 254) AS VARCHAR(254))
          AS TIPERR,
          TO_CHAR(VEN.CODFIL) AS CODFIL,
          VEN.DATHOR AS DATOPE,
          TO_CHAR(VEN.FILUSU) AS FILUSU,
          TO_CHAR(VEN.CODUSU) AS CODUSU,
          USU.APEUSU AS APEUSU,
          VEN.NUMNOT AS DOCUME,
          TO_CHAR(NULL) AS NUMECF,
          NULL AS MSGERR
     FROM TT_VEN VEN INNER JOIN TD_SER DSER ON VEN.CODSER = DSER.CODSER
                     INNER JOIN TT_USU USU  ON VEN.CODUSU = USU.CODUSU
                                           AND VEN.FILUSU = USU.FILUSU
    WHERE DSER.MODNOT = '65'
      AND VEN.FLGEST <> 'C'
      AND COALESCE(VEN.FLGNFE, 'X') NOT IN ('1', '4')
      AND VEN.DATHOR BETWEEN ADD_DAY(AGORA(),-60) AND ADD_DAY(AGORA(),-1)
   UNION ALL
   -- MANOEL - 100835
   SELECT CAST('18' AS VARCHAR(2)) AS TIPDIA,
          CAST(SUBSTR('A NFC-e ' || VEN.CODSER || '/' || VEN.NUMNOT || ' da filial ' || VEN.CODFIL || ' est cancelada no sistema, porm seu cancelamento ou inutilizao no SEFAZ no foi confirmado. Campo FLGNFE deveria ser "3" ou "4". Consulte o suporte.', 1, 254) AS VARCHAR(254))
          AS TIPERR,
          TO_CHAR(VEN.CODFIL) AS CODFIL,
          VEN.DATHOR AS DATOPE,
          TO_CHAR(VEN.FILUSU) AS FILUSU,
          TO_CHAR(VEN.CODUSU) AS CODUSU,
          USU.APEUSU AS APEUSU,
          VEN.NUMNOT AS DOCUME,
          TO_CHAR(NULL) AS NUMECF,
          NULL AS MSGERR
     FROM TT_VEN VEN INNER JOIN TD_SER DSER ON VEN.CODSER = DSER.CODSER
                     INNER JOIN TT_USU USU  ON VEN.CODUSU = USU.CODUSU
                                           AND VEN.FILUSU = USU.FILUSU
    WHERE DSER.MODNOT = '65'
      AND VEN.FLGEST = 'C'
      AND COALESCE(VEN.FLGNFE, 'X') NOT IN ('3', '4')
      AND VEN.DATHOR BETWEEN ADD_DAY(AGORA(),-60) AND ADD_DAY(AGORA(),-1)
      AND VEN.FILEST IS NULL -- ESTORNO DE NOTA
   UNION ALL
   -- MANOEL - 100835
   SELECT CAST('19' AS VARCHAR(2)) AS TIPDIA,
          CAST(SUBSTR('O CF-e-SAT ' || VEN.CODSER || '/' || VEN.NUMNOT || ' da filial ' || VEN.CODFIL || ' est cancelado no sistema, porm seu cancelamento no SAT no foi confirmado. Campo FLGNFE deveria ser "3". Consulte o suporte.', 1, 254) AS VARCHAR(254))
          AS TIPERR,
          TO_CHAR(VEN.CODFIL) AS CODFIL,
          VEN.DATHOR AS DATOPE,
          TO_CHAR(VEN.FILUSU) AS FILUSU,
          TO_CHAR(VEN.CODUSU) AS CODUSU,
          USU.APEUSU AS APEUSU,
          VEN.NUMNOT AS DOCUME,
          TO_CHAR(NULL) AS NUMECF,
          NULL AS MSGERR
     FROM TT_VEN VEN INNER JOIN TD_SER DSER ON VEN.CODSER = DSER.CODSER
                     INNER JOIN TT_USU USU ON VEN.CODUSU = USU.CODUSU
                                          AND VEN.FILUSU = USU.FILUSU
    WHERE DSER.MODNOT = '59'
      AND VEN.FLGEST = 'C'
      AND COALESCE(VEN.FLGNFE, 'X') = '1'
      AND VEN.DATHOR BETWEEN ADD_DAY(AGORA(),-60) AND ADD_DAY(AGORA(),-1)
      AND VEN.FILEST IS NULL -- ESTORNO DE NOTA
   UNION ALL
   -- Manoel - 100835
   SELECT CAST('20' AS VARCHAR(2)) AS TIPDIA,
          CAST(SUBSTR('O CF-e-SAT ' || VEN.CODSER || '/' || VEN.NUMNOT || ' da filial ' || VEN.CODFIL || ' no est cancelado no sistema, porm sua autenticao no SAT no foi confirmada. Campo FLGNFE deveria ser "1". Consulte o suporte.', 1, 254) AS VARCHAR(254))
          AS TIPERR,
          TO_CHAR(VEN.CODFIL) AS CODFIL,
          VEN.DATHOR AS DATOPE,
          TO_CHAR(VEN.FILUSU) AS FILUSU,
          TO_CHAR(VEN.CODUSU) AS CODUSU,
          USU.APEUSU AS APEUSU,
          VEN.NUMNOT AS DOCUME,
          TO_CHAR(NULL) AS NUMECF,
          NULL AS MSGERR
     FROM TT_VEN VEN INNER JOIN TD_SER DSER ON VEN.CODSER = DSER.CODSER
                     INNER JOIN TT_USU USU ON VEN.CODUSU = USU.CODUSU AND VEN.FILUSU = USU.FILUSU
    WHERE DSER.MODNOT = '59'
      AND VEN.FLGEST <> 'C'
      AND COALESCE(VEN.FLGNFE, 'X') <> '1'
      AND VEN.DATHOR BETWEEN ADD_DAY(AGORA(),-60) AND ADD_DAY(AGORA(),-1)
   UNION ALL
   -- RFMP 101803
   SELECT CAST('21' AS VARCHAR(2)) AS TIPDIA,
          CAST(SUBSTR('No foi possvel gerar NFS-e para o RPS ' || VEN.CODSER || '/' || VEN.NUMNOT || ' da filial ' || VEN.CODFIL || '. Consulte o suporte.', 1, 254) AS VARCHAR(254))
          AS TIPERR,
          TO_CHAR(VEN.CODFIL) AS CODFIL,
          VEN.DATHOR AS DATOPE,
          TO_CHAR(VEN.FILUSU) AS FILUSU,
          TO_CHAR(VEN.CODUSU) AS CODUSU,
          USU.APEUSU AS APEUSU,
          VEN.NUMNOT AS DOCUME,
          TO_CHAR(NULL) AS NUMECF,
          NULL AS MSGERR
     FROM TT_VEN VEN INNER JOIN TD_SER DSER ON VEN.CODSER = DSER.CODSER
                     INNER JOIN TT_USU USU ON VEN.CODUSU = USU.CODUSU
                                          AND VEN.FILUSU = USU.FILUSU
    WHERE DSER.ENVNFS = 'T'
      AND VEN.FLGEST <> 'C'
      AND COALESCE(VEN.FLGNFE, 'X') = '0'
      AND VEN.VLRLIQ > 0
      AND VEN.DATHOR BETWEEN ADD_DAY(AGORA(),-60) AND ADD_DAY(AGORA(),-1)
   UNION ALL
   -- RFMP 101803
   SELECT CAST('22' AS VARCHAR(2)) AS TIPDIA,
          CAST(SUBSTR('NFS-e enviada, aguardando retorno da prefeitura. Nota: ' || VEN.CODSER || '/' || VEN.NUMNOT || ' da filial ' || VEN.CODFIL || '.', 1, 254) AS VARCHAR(254))
          AS TIPERR,
          TO_CHAR(VEN.CODFIL) AS CODFIL,
          VEN.DATHOR AS DATOPE,
          TO_CHAR(VEN.FILUSU) AS FILUSU,
          TO_CHAR(VEN.CODUSU) AS CODUSU,
          USU.APEUSU AS APEUSU,
          VEN.NUMNOT AS DOCUME,
          TO_CHAR(NULL) AS NUMECF,
          NULL AS MSGERR
     FROM TT_VEN VEN INNER JOIN TD_SER DSER ON VEN.CODSER = DSER.CODSER
                     INNER JOIN TT_USU USU ON VEN.CODUSU = USU.CODUSU
                                          AND VEN.FILUSU = USU.FILUSU
    WHERE DSER.ENVNFS = 'T'
      AND VEN.FLGEST <> 'C'
      AND COALESCE(VEN.FLGNFE, 'X') = '5'
      AND VEN.VLRLIQ > 0
      AND VEN.DATHOR BETWEEN ADD_DAY(AGORA(),-60) AND ADD_DAY(AGORA(),-1)
   UNION ALL
   -- RFMP 101803
   SELECT CAST('23' AS VARCHAR(2)) AS TIPDIA,
          CAST(SUBSTR('No foi possvel transmitir o cancelamento da NFS-e referente ao RPS ' || VEN.CODSER || '/' || VEN.NUMNOT || ' da filial ' || VEN.CODFIL || '. Consulte o suporte.', 1, 254) AS VARCHAR(254))
          AS TIPERR,
          TO_CHAR(VEN.CODFIL) AS CODFIL,
          VEN.DATHOR AS DATOPE,
          TO_CHAR(VEN.FILUSU) AS FILUSU,
          TO_CHAR(VEN.CODUSU) AS CODUSU,
          USU.APEUSU AS APEUSU,
          VEN.NUMNOT AS DOCUME,
          TO_CHAR(NULL) AS NUMECF,
          NULL AS MSGERR
     FROM TT_VEN VEN INNER JOIN TD_SER DSER ON VEN.CODSER = DSER.CODSER
                     INNER JOIN TT_USU USU ON VEN.CODUSU = USU.CODUSU
                                          AND VEN.FILUSU = USU.FILUSU
    WHERE DSER.ENVNFS = 'T'
      AND VEN.FLGEST = 'C'
      AND COALESCE(VEN.FLGNFE, 'X') = '1'
   AND VEN.VLRLIQ > 0
   AND VEN.DATHOR BETWEEN ADD_DAY(AGORA(),-60) AND ADD_DAY(AGORA(),-1)
UNION ALL
-- Emisso de nota em mltiplas Filiais
SELECT CAST('24' AS VARCHAR(2)) AS TIPDIA,
       CAST(SUBSTR('Falha na emisso de nota para mltiplas filiais. Dados da Filial de Origem: ' || NMF.CODFIL || '-' || NMF.NUMECF || '. Consulte o suporte.', 1, 254) AS VARCHAR(254)) AS TIPERR,
       TO_CHAR(NMF.CODFIL) AS CODFIL,
       NMF.DATINC AS DATOPE,
       TO_CHAR(NMF.FILUSU) AS FILUSU,
       TO_CHAR(NMF.CODUSU) AS CODUSU,
       USU.APEUSU AS APEUSU,
       TO_CHAR(NMF.XMLDOC) AS DOCUME,
       TO_CHAR(NMF.NUMECF) AS NUMECF,
       NMF.MSGRET AS MSGERR
  FROM TT_NMF NMF INNER JOIN TT_USU USU ON NMF.CODUSU = USU.CODUSU
                                       AND NMF.FILUSU = USU.FILUSU
 WHERE 1=1
   AND NMF.FLGEST IN ('A', 'P')
) TAB
;


/*-- SEQ 2047 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_DIE CASCADE;

/*-- SEQ 2048 --*/
CREATE OR REPLACE VIEW TV_DIE AS
SELECT VEN.CODFIL, VEN.NUMECF, VEN.NUMNOT, VEN.CODSER, min(VEN.DATHOR) as DATHOR,
       SUM(IVE.QTDMOV) AS QTDMOV, VXP.PLACAS
  FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON VEN.CODFIL = IVE.CODFIL
                                       AND VEN.SEQUEN = IVE.SEQUEN
                  INNER JOIN TT_PRO PRO ON PRO.FILMAT = IVE.FILMAT
                                       AND PRO.CODMAT = IVE.CODMAT
				   LEFT JOIN TT_VXP VXP ON VXP.CODFIL = VEN.CODFIL
                                       AND VXP.SEQUEN = VEN.SEQUEN				  
 WHERE PRO.CLASS1 IN (SELECT CODTAB FROM TD_CL1 WHERE COMBUS='T')
   AND PRO.DESMAT LIKE '%DIESEL%'
--   AND VEN.CODSER = 'CF'
 GROUP BY  VEN.CODFIL, VEN.NUMECF, VEN.NUMNOT, VEN.CODSER, VXP.PLACAS;


/*-- SEQ 2049 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_DOP CASCADE;

/*-- SEQ 2050 --*/
CREATE OR REPLACE VIEW TV_DOP AS
SELECT DOP.*,
       CTB.CODBCO,
       CTB.NUMAGE,
       CTB.CTACRR
  FROM TT_DOP DOP LEFT OUTER JOIN TT_CTB CTB ON CTB.FILCTA=DOP.FILCTA AND CTB.SEQCTA=DOP.SEQCTA AND CTB.TIPCTA=DOP.TIPCTA
  ;




/*-- SEQ 2051 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_DOU CASCADE;

/*-- SEQ 2052 --*/
CREATE OR REPLACE VIEW TV_DOU AS
SELECT CODCRM,NOMDOU 
  FROM TT_DOU
 ;




/*-- SEQ 2053 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_DPG CASCADE;

/*-- SEQ 2054 --*/
CREATE OR REPLACE VIEW TV_DPG AS
SELECT DOP.*
  FROM TT_DOP DOP INNER JOIN TT_USU USU ON USU.APEUSU = GetApeUsuAtual() -- Usurio Logado
                   LEFT JOIN TT_USU UCLI ON UCLI.FILCLI = DOP.FILCLI 
                                        AND UCLI.CODCLI = DOP.CODCLI -- Usurio do compromisso
 WHERE UCLI.APEUSU IS NULL -- Compra/Compromisso no  de funcionrio
    OR SUBSTR(USU.PERMIS,147,1) = 'S' -- Usurio logado tem permisso para ver pagamentos de outro funcionrios
    OR EXISTS (SELECT 1 AS OK         
                  FROM TT_PAP PAP INNER JOIN TT_PAPXUSU PXU ON PXU.FILPAP = PAP.CODFIL
                                                           AND PXU.SEQPAP = PAP.SEQUEN
                 WHERE SUBSTR(PAP.PERMIS,147,1) = 'S'
                   AND PXU.FILUSU = USU.FILUSU
                   AND PXU.CODUSU = USU.CODUSU) -- Papel do usurio tem permisso para ver pagamentos de outro funcionrios
    -- Usurio  o OWNER
    OR (SELECT IDF.USUADM FROM TT_IDF IDF) = GetApeUsuAtual()
;


-- Autor: Luciano Chiqueti
-- Cliente(s): Carneiro
-- Finalidade(s): Viso do contas a receber retroativo, onde a situao da parcela como aberto, mesmo se quitado em data atual.
/*-- SEQ 2055 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_DREC CASCADE;

/*-- SEQ 2056 --*/
CREATE OR REPLACE VIEW TV_DREC AS
        SELECT VEN.CODFIL,
               VEN.SEQUEN, 
               VEN.DATHOR, 
               VEN.CODSER,
               VEN.NUMECF, 
               VEN.NUMNOT, 
               VEN.FILCLI, 
               VEN.CODCLI, 
               REC.NUMPAR, 
               REC.SUBPAR, 
               REC.DATVEN,
               REC.PAGAME, 
               REC.VLRPAR, 
               REC.VLRPGT, 
               CASE WHEN REC.FLGEST = 'P' AND trunc(REC.PAGAME) > FIM.DATOPE THEN 'A'
                    ELSE REC.FLGEST
               END AS FLGEST, 
               REC.FLGEST AS FLGORI, 
               FIM.DATOPE AS DATFIM
         FROM TT_REC REC
   CROSS JOIN TT_DAT FIM
   INNER JOIN TT_VEN VEN ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN;


/*-- SEQ 2057 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_DRO CASCADE;

/*-- SEQ 2058 --*/
CREATE OR REPLACE VIEW TV_DRO AS
SELECT CODDRO,DESDRO
  FROM TT_DRO
 ;




/*-- SEQ 2059 --*/
/*-- IGNORE ERRO --*/
DROP VIEW DW_Configuracoes CASCADE;

/*-- SEQ 2060 --*/
CREATE OR REPLACE VIEW DW_Configuracoes AS
SELECT CLASS1, CLASS2, CLASS3, CLASS4, CATEG1, CATEG2, CATEG3
   FROM tt_cfg
;


/*-- SEQ 2061 --*/
/*-- IGNORE ERRO --*/
DROP VIEW DW_UnidadeNegocio CASCADE;

/*-- SEQ 2062 --*/
CREATE OR REPLACE VIEW DW_UnidadeNegocio AS
SELECT CODTAB AS CODIGO, DESCTR AS DESCRICAO
 FROM TD_CTR
;


/*-- SEQ 2063 --*/
/*-- IGNORE ERRO --*/
DROP VIEW DW_Filiais CASCADE;

/*-- SEQ 2064 --*/
CREATE OR REPLACE VIEW DW_Filiais AS
SELECT CODFIL AS FILIAL,
       NOMFIL AS NOME_FILIAL,
       QTD_M2,
       QTDFUN,
       (SELECT COUNT(*) 
          FROM TD_ECF E  
         WHERE E.FILECF = FIL.CODFIL 
           AND E.ECFATI = 'T'
       ) AS QTDECF,
       CAST(NULL AS VARCHAR(40)) AS REGIONAL,
       GRU.DESGRU AS ATIVIDADE,
       NIVCRI,
       COMIS1,
       COMIS2,
       COMIS3,
       COMIS4,
       VALOR1,
       VALOR2,
       VALOR3,
       VALOR4       
  FROM TD_FIL FIL LEFT JOIN TD_GRU GRU ON FIL.CODGRU = GRU.CODTAB
;


/*-- SEQ 2065 --*/
/*-- IGNORE ERRO --*/
DROP VIEW DW_Metas_Filiais CASCADE;

/*-- SEQ 2066 --*/
CREATE OR REPLACE VIEW DW_Metas_Filiais AS
SELECT FILIAL, ANO, MES, COD_UNIDADE, QTD_M2, QTD_FUNCIONARIOS, QTD_ECF, META, MINIMO,
       CASE WHEN ANO IS NULL THEN 0
            WHEN COALESCE(DIASUTEIS,0) = 0
            THEN trunc(LAST_DAY( TO_DATE( REPLACE( '01/' || TO_CHAR(MES,'09') || '/' || TO_CHAR(ANO,'9999'), ' ', '' ), 'DD/MM/YYYY') )) -
                 trunc(TO_DATE( REPLACE( '01/' || TO_CHAR(MES,'09') || '/' || TO_CHAR(ANO,'9999'), ' ', '' ), 'DD/MM/YYYY')) + 1
            ELSE DIASUTEIS
       END AS DIASUTEIS
  FROM (SELECT MPF.CODFIL AS FILIAL,
               MPF.ANOREF AS ANO,
               MPF.MESREF AS MES,
               MPF.CODCTR AS COD_UNIDADE,
               MPF.QTD_M2 AS QTD_M2,
               MPF.QTDFUN AS QTD_FUNCIONARIOS,
               MPF.QTDECF AS QTD_ECF,
               MPF.VALOR1 AS META,
               MPF.NIVCRI AS MINIMO,
               DIASUTEIS( MPF.CODFIL, 
               TO_DATE(REPLACE('01/'||TO_CHAR(MESREF,'09')|| '/' ||TO_CHAR(ANOREF,'9999'), ' ', ''), 'DD/MM/YYYY'),
               LAST_DAY(trunc(TO_DATE(REPLACE('01/'||TO_CHAR(MESREF,'09')|| '/' ||TO_CHAR(ANOREF,'9999'), ' ', ''), 'DD/MM/YYYY')))) AS DIASUTEIS
          FROM TT_MPF MPF) INT
;


/*-- SEQ 2067 --*/
/*-- IGNORE ERRO --*/
DROP VIEW DW_Metas_Indicadores CASCADE;

/*-- SEQ 2068 --*/
CREATE OR REPLACE VIEW DW_Metas_Indicadores AS
SELECT ANOREF AS ANO,
       MESREF AS MES,
       CAST('M2' AS CHAR(15) ) AS INDICADOR, 
       M2_CRI AS MINIMO, M2_MET
       AS META
  FROM TT_MPI 
 UNION ALL
SELECT ANOREF AS ANO,
       MESREF AS MES,
       CAST('Funcionarios' AS CHAR(15) ) AS INDICADOR,
       FUNCRI AS MINIMO,
       FUNMET AS META 
  FROM TT_MPI 
 UNION ALL
SELECT ANOREF AS ANO, 
       MESREF AS MES, 
       CAST('ECFs' AS CHAR(15)) AS INDICADOR,
       ECFCRI AS MINIMO,
       ECFMET AS META 
  FROM TT_MPI 
 UNION ALL
SELECT ANOREF AS ANO, 
       MESREF AS MES, 
       CAST('Media Itens' AS CHAR(15)) AS INDICADOR,
       ITECRI AS MINIMO, 
       ITEMET AS META 
  FROM TT_MPI 
 UNION ALL
SELECT ANOREF AS ANO, 
       MESREF AS MES, 
       CAST('Venda Media'  AS CHAR(15) ) AS INDICADOR, 
       MEDCRI AS MINIMO,
       MEDMET AS META 
  FROM TT_MPI 
 UNION ALL
SELECT ANOREF AS ANO, 
       MESREF AS MES, 
       CAST('Venda Diaria' AS CHAR(15) ) AS INDICADOR, 
       0 AS MINIMO, 
       0 AS META 
  FROM TT_MPI
;


/*-- SEQ 2069 --*/
/*-- IGNORE ERRO --*/
DROP VIEW DW_View_Produto CASCADE;

/*-- SEQ 2070 --*/
CREATE OR REPLACE VIEW DW_View_Produto AS
SELECT CAST( TRIM(GRA.FILMAT)                  || '-' || 
             TRIM(GRA.CODMAT)                  || '-' || 
             TRIM(TO_CHAR(GRA.CODCOR,'99999')) || '-' || 
             TRIM(TO_CHAR(GRA.CODTAM,'99999')) AS CHAR(18)) AS COD_PRODUTO,
       cast(TRIM(CASE WHEN PRO.DESECF IS NULL THEN PRO.DESMAT
                                         ELSE PRO.DESECF
             END) ||
            CASE GRA.CODCOR WHEN 0 THEN ''
                                   ELSE ' ' || TRIM(COALESCE(DIV.NOMITE,''))
            END ||
            CASE GRA.CODTAM WHEN 0 THEN ''
                                   ELSE ' ' || TRIM(COALESCE(SUB.NOMITE,''))
            END || ' ' || COALESCE(PRO.ESPMAT ,'')  as VARCHAR(254)) AS PRODUTO,
       PRO.CLASS1 AS COD_CLASSE1,
       PRO.CLASS2 AS COD_CLASSE2,
       PRO.CLASS3 AS COD_CLASSE3,
       PRO.CLASS4 AS COD_CLASSE4,
       PRO.DEPART AS COD_DEPARTAMENTO,
       INITCAP(CL1.CLASS1) AS CLASSE1, 
       INITCAP(CL2.CLASS2) AS CLASSE2,
       INITCAP(CL3.CLASS3) AS CLASSE3,
       INITCAP(CL4.CLASS4) AS CLASSE4,
       INITCAP(DEP.DESDEP) AS DEPARTAMENTO,
       GRA.FILMAT,
       GRA.CODMAT,
       GRA.CODCOR,
       GRA.CODTAM
  FROM TT_PRO PRO INNER JOIN TT_GRA GRA  ON PRO.FILMAT = GRA.FILMAT 
                                        AND PRO.CODMAT = GRA.CODMAT
                  INNER JOIN TT_DIV DIV  ON GRA.CODCOR = DIV.CODITE
                  INNER JOIN TT_SUB SUB  ON GRA.CODTAM = SUB.CODITE
                  INNER JOIN TD_CL1 CL1 ON CL1.CODTAB = PRO.CLASS1
                  INNER JOIN TD_CL2 CL2 ON CL2.CODTAB = PRO.CLASS2
                  INNER JOIN TD_CL3 CL3 ON CL3.CODTAB = PRO.CLASS3
                  INNER JOIN TD_CL4 CL4 ON CL4.CODTAB = PRO.CLASS4
                  LEFT  JOIN TD_DEP DEP ON DEP.CODTAB = PRO.DEPART
                  CROSS JOIN TT_CFG CFG
 WHERE CFG.USA_VM_DECISOR = 'T'
;


/*-- SEQ 2071 --*/
/*-- IGNORE ERRO --*/
DROP VIEW DW_View_Produto CASCADE;

/*-- SEQ 2072 --*/
CREATE OR REPLACE VIEW DW_View_Produto AS
SELECT CAST( TRIM(GRA.FILMAT)                  || '-' || 
             TRIM(GRA.CODMAT)                  || '-' || 
             TRIM(TO_CHAR(GRA.CODCOR,'99999')) || '-' || 
             TRIM(TO_CHAR(GRA.CODTAM,'99999')) AS CHAR(18)) AS COD_PRODUTO,
       cast(TRIM(CASE WHEN PRO.DESECF IS NULL THEN PRO.DESMAT
                                         ELSE PRO.DESECF
             END) ||
            CASE GRA.CODCOR WHEN 0 THEN ''
                                   ELSE ' ' || TRIM(COALESCE(DIV.NOMITE,''))
            END ||
            CASE GRA.CODTAM WHEN 0 THEN ''
                                   ELSE ' ' || TRIM(COALESCE(SUB.NOMITE,''))
            END || ' ' || COALESCE(PRO.ESPMAT ,'') as VARCHAR(254))  AS PRODUTO,
       PRO.CLASS1 AS COD_CLASSE1,
       PRO.CLASS2 AS COD_CLASSE2,
       PRO.CLASS3 AS COD_CLASSE3,
       PRO.CLASS4 AS COD_CLASSE4,
       PRO.DEPART AS COD_DEPARTAMENTO,
       INITCAP(CL1.CLASS1) AS CLASSE1, 
       INITCAP(CL2.CLASS2) AS CLASSE2,
       INITCAP(CL3.CLASS3) AS CLASSE3,
       INITCAP(CL4.CLASS4) AS CLASSE4,
       INITCAP(DEP.DESDEP) AS DEPARTAMENTO,
       GRA.FILMAT,
       GRA.CODMAT,
       GRA.CODCOR,
       GRA.CODTAM
  FROM TT_PRO PRO, 
       TT_GRA GRA, 
       TT_DIV DIV,
       TT_SUB SUB,
       TD_CL1 CL1,
       TD_CL2 CL2,
       TD_CL3 CL3,
       TD_CL4 CL4,
       TD_DEP DEP
 WHERE PRO.FILMAT = GRA.FILMAT 
   AND PRO.CODMAT = GRA.CODMAT
   AND GRA.CODCOR = DIV.CODITE
   AND GRA.CODTAM = SUB.CODITE
   AND CL1.CODTAB = PRO.CLASS1
   AND CL2.CODTAB = PRO.CLASS2
   AND CL3.CODTAB = PRO.CLASS3
   AND CL4.CODTAB = PRO.CLASS4
   AND DEP.CODTAB = PRO.DEPART
;


/*-- SEQ 2073 --*/
/*-- IGNORE ERRO --*/
DROP VIEW DW_variacao_Vendas CASCADE;

/*-- SEQ 2074 --*/
CREATE OR REPLACE VIEW DW_variacao_Vendas AS
SELECT CASE WHEN COALESCE(VLRATU,0) = 0 OR COALESCE(VLRANT,0) = 0 THEN 1 ELSE VLRATU/VLRANT END AS VARIACAO
FROM (SELECT SUM(VALOR) AS VLRATU 
      FROM DW_VENDAS 
      WHERE DATA BETWEEN ADD_DAY(TRUNC(AGORA()),-90) 
                     AND ADD_DAY(TRUNC(AGORA()),-01)) tab1,
     (SELECT SUM(VALOR) AS VLRANT
      FROM DW_VENDAS 
      WHERE DATA BETWEEN ADD_MONTHS(ADD_DAY(TRUNC(AGORA()),-90),-12) 
                     AND ADD_MONTHS(ADD_DAY(TRUNC(AGORA()),-01),-12)) tab2
;


/*-- SEQ 2075 --*/
/*-- IGNORE ERRO --*/
DROP VIEW DW_View_Vendas CASCADE;

/*-- SEQ 2076 --*/
CREATE OR REPLACE VIEW DW_View_Vendas AS
SELECT VEN.CODFIL AS FILIAL, 
       VEN.CODCTR AS COD_UNIDADE,
       VEN.DATFIS AS DATA, 
       SUM(VEN.QTDITE) AS QTD_ITENS, 
       COUNT(*) AS QTD_VENDAS, 
       SUM(VEN.VLRLIQ) AS VALOR
  FROM TT_VEN VEN CROSS JOIN TT_CFG CFG
 WHERE VEN.LANVEN = 'T'
   AND VEN.FLGEST <> 'C'
   AND CFG.USA_VM_DECISOR = 'T'
 GROUP BY VEN.CODFIL, VEN.CODCTR, VEN.DATFIS
;


/*-- SEQ 2077 --*/
/*-- IGNORE ERRO --*/
DROP VIEW DW_View_Vendas_Cliente CASCADE;

/*-- SEQ 2078 --*/
CREATE OR REPLACE VIEW DW_View_Vendas_Cliente AS
SELECT VEN.CODFIL AS FILIAL,
       VEN.FILCLI AS FILIAL_CLIENTE,
       VEN.CODCLI AS CODIGO_CLIENTE,
       CAST(CLI.NOMCLI||' '||CLI.ULTNOM AS VARCHAR(100)) AS NOME_COMPLETO,
       ANO_MES(VEN.DATFIS) AS ANO_MES, 
       SUM(VEN.VLRLIQ) AS VALOR,
       SUM(VEN.QTDITE) AS QTD_ITENS,
       COUNT(*) AS QTD_VENDAS,
       CASE WHEN CFG.VC_FILCLI||CFG.VC_CODCLI = VEN.FILCLI||VEN.CODCLI THEN 'T' ELSE 'F' END AS CONSUMIDOR,
       INITCAP(COALESCE(CT1.NOMCT1, CAST('No Informado' AS VARCHAR(40)))) AS CATEGORIA1,
       INITCAP(COALESCE(CT2.NOMCT2, CAST('No Informado' AS VARCHAR(40)))) AS CATEGORIA2,
       INITCAP(COALESCE(CT3.NOMCT3, CAST('No Informado' AS VARCHAR(40)))) AS CATEGORIA3,
       CAST( CASE WHEN CLI.FLGTIP > 0 THEN 'Pessoa Jurdica'            
                  WHEN CLI.CODSEX = 1 THEN 'Masculino'
                  WHEN CLI.CODSEX = 2 THEN 'Feminino' 
                                ELSE 'No conhecido'
             END AS CHAR(15) ) AS SEXO,
       CAST( CASE WHEN CLI.FLGTIP > 0 then 'Pessoa Jurdica'
                  WHEN CLI.ESTCIV = 1 then 'Solteiro(a)'
                  WHEN CLI.ESTCIV = 2 then 'Casado(a)' 
                  WHEN CLI.ESTCIV = 3 then 'Viuvo(a)' 
                  WHEN CLI.ESTCIV = 4 then 'Divorciado(a)' 
                  WHEN CLI.ESTCIV = 5 then 'Unio Estvel' 
                  WHEN CLI.ESTCIV = 6 then 'Separado(a)' 
                                      else 'No conhecido'
             END AS CHAR(15) ) AS ESTADO_CIVIL,
       CAST( CASE WHEN CLI.FLGTIP > 0 THEN 'Pessoa Jurdica'
                                      ELSE INITCAP(COALESCE(OCU.DESOCU, 'No Informado' ))
             END AS CHAR(30) ) AS PROFISSAO,
       CAST( CASE WHEN CLI.FLGTIP = 0 THEN 'Fsica'
                  WHEN CLI.ESTCIV = 1 THEN 'Jurdica'
                  WHEN CLI.ESTCIV = 2 THEN 'Entidade' 
                  WHEN CLI.ESTCIV = 3 THEN 'Especial' 
                  WHEN CLI.ESTCIV = 4 THEN 'M.E.' 
                  WHEN CLI.ESTCIV = 5 THEN 'Filial' 
                                      ELSE 'No conhecido'
             END AS CHAR(15) ) AS TIPO_PESSOA,
       OCU.CODTAB AS OCU_CODTAB,
       CT1.CODTAB AS CT1_CODTAB,
       CT2.CODTAB AS CT2_CODTAB,
       CT3.CODTAB AS CT3_CODTAB     
  FROM TT_VEN VEN INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI
                                       AND CLI.CODCLI = VEN.CODCLI
                  LEFT  JOIN TT_SPC SPC ON SPC.FILCLI = CLI.FILCLI
                                       AND SPC.CODCLI = CLI.CODCLI
                  LEFT  JOIN TD_OCU OCU ON OCU.CODTAB = SPC.CODOCU
                  LEFT  JOIN TD_CT1 CT1 ON CT1.CODTAB = CLI.CATEG1
                  LEFT  JOIN TD_CT2 CT2 ON CT2.CODTAB = CLI.CATEG2
                  LEFT  JOIN TD_CT3 CT3 ON CT3.CODTAB = CLI.CATEG3
                  CROSS JOIN TT_CFG CFG
 WHERE VEN.LANVEN = 'T'
   AND VEN.FLGEST <> 'C'
   AND VEN.CODSER <> 'CC'
   AND CFG.USA_VM_DECISOR = 'T'
 GROUP BY VEN.CODFIL, VEN.FILCLI, VEN.CODCLI,
          CLI.NOMCLI, CLI.ULTNOM,
          CT1.NOMCT1, CT2.NOMCT2, CT3.NOMCT3,
          CLI.FLGTIP, CLI.ESTCIV, CLI.CODSEX, 
          OCU.DESOCU, CFG.VC_FILCLI, CFG.VC_CODCLI,
          ANO_MES(VEN.DATFIS),
          OCU.CODTAB, CT1.CODTAB, CT2.CODTAB, CT3.CODTAB
;


/*-- SEQ 2079 --*/
/*-- IGNORE ERRO --*/
DROP VIEW DW_Vendas_Cliente_Produto CASCADE;

/*-- SEQ 2080 --*/
CREATE OR REPLACE VIEW DW_Vendas_Cliente_Produto AS
SELECT VEN.FILCLI AS FILIAL_CLIENTE,
       VEN.CODCLI AS CODIGO_CLIENTE,
       CAST(CLI.NOMCLI||' '||CLI.ULTNOM AS VARCHAR(100)) AS CLIENTE,
       VEN.CODFIL AS FILIAL,
       VEN.DATFIS AS DATA, 
       PLA.APEPGT AS PLANO, 
       USU.APEUSU AS VENDEDOR,
       CTR.DESCTR AS UNIDADE,
       CL1.CLASS1 AS CLASSE1, 
       CL2.CLASS2 AS CLASSE2,
       CL3.CLASS3 AS CLASSE3,
       CL4.CLASS4 AS CLASSE4,
       DEP.DESDEP AS DEPARTAMENTO,
       (VEN.VLRLIQ * IVE.VLRMOV / VEN.VLRNOT) AS VALOR,
       IVE.QTDMOV AS QUANTIDADE
  FROM TT_VEN VEN INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI
                                       AND CLI.CODCLI = VEN.CODCLI
                  INNER JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT
                                       AND PLA.CODPGT = VEN.CODPGT
                  INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL
                                       AND IVE.SEQUEN = VEN.SEQUEN
                  INNER JOIN TT_PRO PRO ON PRO.FILMAT = IVE.FILMAT
                                       AND PRO.CODMAT = IVE.CODMAT
                  INNER JOIN TT_USU USU ON USU.FILUSU = VEN.FILVEN
                                       AND USU.CODUSU = VEN.CODVEN
                  INNER JOIN TD_CTR CTR ON CTR.CODTAB = VEN.CODCTR
                  INNER JOIN TD_CL1 CL1 ON CL1.CODTAB = PRO.CLASS1
                  INNER JOIN TD_CL2 CL2 ON CL2.CODTAB = PRO.CLASS2
                  INNER JOIN TD_CL3 CL3 ON CL3.CODTAB = PRO.CLASS3
                  INNER JOIN TD_CL4 CL4 ON CL4.CODTAB = PRO.CLASS4
                   LEFT JOIN TD_DEP DEP ON DEP.CODTAB = PRO.DEPART
 WHERE VEN.LANVEN = 'T'
   AND VEN.FLGEST <> 'C'
   AND VEN.VLRNOT <> 0
   AND IVE.SITMOV <> 'C'
;


/*-- SEQ 2081 --*/
/*-- IGNORE ERRO --*/
DROP VIEW DW_View_Vendas_Grupos CASCADE;

/*-- SEQ 2082 --*/
CREATE OR REPLACE VIEW DW_View_Vendas_Grupos AS
SELECT VEN.CODFIL AS FILIAL,
       ANO_MES(VEN.DATFIS) AS ANO_MES, 
       INITCAP(PLA.APEPGT) AS PLANO, 
       INITCAP(USU.APEUSU) AS VENDEDOR,
       INITCAP(CTR.DESCTR) AS UNIDADE,
       INITCAP(CL1.CLASS1) AS CLASSE1, 
       INITCAP(CL2.CLASS2) AS CLASSE2,
       INITCAP(CL3.CLASS3) AS CLASSE3,
       INITCAP(CL4.CLASS4) AS CLASSE4,
       INITCAP(DEP.DESDEP) AS DEPARTAMENTO,
       SUM(VEN.VLRLIQ * IVE.VLRMOV / VEN.VLRNOT) AS VALOR,
       SUM(IVE.QTDMOV) AS QUANTIDADE,
       COUNT(*) AS ITENS,
       PRO.CLASS1 AS COD_CLASSE1,
       PRO.CLASS2 AS COD_CLASSE2,
       PRO.CLASS3 AS COD_CLASSE3,
       PRO.CLASS4 AS COD_CLASSE4,
       PRO.DEPART AS COD_DEPARTAMENTO,
       PLA.FILPGT,
       PLA.CODPGT
  FROM TT_VEN VEN INNER JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT
                                       AND PLA.CODPGT = VEN.CODPGT
                  INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL
                                       AND IVE.SEQUEN = VEN.SEQUEN
                  INNER JOIN TT_PRO PRO ON PRO.FILMAT = IVE.FILMAT
                                       AND PRO.CODMAT = IVE.CODMAT
                  INNER JOIN TT_USU USU ON USU.FILUSU = VEN.FILVEN
                                       AND USU.CODUSU = VEN.CODVEN
                  INNER JOIN TD_CTR CTR ON CTR.CODTAB = VEN.CODCTR
                  INNER JOIN TD_CL1 CL1 ON CL1.CODTAB = PRO.CLASS1
                  INNER JOIN TD_CL2 CL2 ON CL2.CODTAB = PRO.CLASS2
                  INNER JOIN TD_CL3 CL3 ON CL3.CODTAB = PRO.CLASS3
                  INNER JOIN TD_CL4 CL4 ON CL4.CODTAB = PRO.CLASS4
                  LEFT  JOIN TD_DEP DEP ON DEP.CODTAB = PRO.DEPART
                  CROSS JOIN TT_CFG CFG
 WHERE VEN.LANVEN = 'T'
   AND VEN.FLGEST <> 'C'
   AND IVE.SITKIT <> '1'
   AND VEN.VLRNOT <> 0
   AND IVE.SITMOV <> 'C'
   AND CFG.USA_VM_DECISOR = 'T'
 GROUP BY VEN.CODFIL, PLA.FILPGT, PLA.CODPGT, PLA.APEPGT, USU.APEUSU, CTR.DESCTR, 
          PRO.CLASS1, PRO.CLASS2, PRO.CLASS3, PRO.CLASS4, PRO.DEPART,
          CL1.CLASS1, CL2.CLASS2, CL3.CLASS3, CL4.CLASS4, DEP.DESDEP,
          ANO_MES(VEN.DATFIS)
;


/*-- SEQ 2083 --*/
/*-- IGNORE ERRO --*/
DROP VIEW DW_View_Vendas_Hora CASCADE;

/*-- SEQ 2084 --*/
CREATE OR REPLACE VIEW DW_View_Vendas_Hora AS
SELECT VEN.CODFIL AS FILIAL,
       TRUNC_DATA(VEN.DATHOR) AS DATA, 
       HORA_DATA(VEN.DATHOR) AS HORA,
       SUM(VEN.VLRLIQ) AS VALOR,
       COUNT(*) AS QTDVEN
  FROM TT_VEN VEN CROSS JOIN TT_CFG CFG
 WHERE VEN.LANVEN = 'T'
   AND VEN.FLGEST <> 'C'
   AND CFG.USA_VM_DECISOR = 'T'
 GROUP BY VEN.CODFIL, TRUNC_DATA(VEN.DATHOR), HORA_DATA(VEN.DATHOR)
;


/*-- SEQ 2085 --*/
/*-- IGNORE ERRO --*/
DROP VIEW DW_View_Vendas_Meio CASCADE;

/*-- SEQ 2086 --*/
CREATE OR REPLACE VIEW DW_View_Vendas_Meio AS
SELECT VEN.CODFIL AS FILIAL,
       VEN.CODCTR AS COD_UNIDADE,
       ANO_MES(VEN.DATFIS) AS ANO_MES, 
       InitCap(CAST( CASE WHEN DCOB.CODTAB IS NOT NULL                THEN DCOB.DESCOB  ELSE
                     CASE WHEN TRUNC(VEN.DATHOR) <> TRUNC(REC.PAGAME) 
                           AND ABS(trunc(REC.PAGAME) - trunc(VEN.DATHOR)) >= 1    THEN 'Fatura'     ELSE
                     CASE WHEN REC.CARTAO IS NOT NULL                 THEN DCAR.DESOUT  ELSE 
                     CASE WHEN REC.SEQCHE IS NOT NULL 
                           AND TRUNC(VEN.DATHOR) = TRUNC(CHR.DATVEN)  THEN 'Cheque' ELSE 
                     CASE WHEN REC.SEQCHE IS NOT NULL                 THEN 'Cheque-Pr' ELSE 
                     CASE WHEN REC.TIPCCC IS NOT NULL                 THEN DCCC.DESCCC  ELSE
                     CASE WHEN BON.FILREC IS NOT NULL                 THEN 'Bnus'      ELSE 
                     CASE WHEN REC.CODOUT IS NOT NULL                 THEN DOUT.DESCAR  ELSE 
                          'Dinheiro' 
                     END END END END END END END END AS VARCHAR(30))) AS MEIO,
       SUM(REC.VLRPAR) AS VALOR,
       CASE WHEN REC.SEQCHE IS NOT NULL THEN TRUNC(CHR.DATVEN) - TRUNC(VEN.DATHOR)
                                        ELSE TRUNC(REC.DATVEN) - TRUNC(VEN.DATHOR)
       END AS PRAZO,
       REC.PORTAD AS DCOB_CODTAB,
       DCAR.CODTAB AS DCAR_CODTAB,
       DCCC.CODTAB AS DCCC_CODTAB,
       DOUT.CODTAB AS DOUT_CODTAB,
       CHR.CODFIL AS CHR_CODFIL,
       CHR.SEQUEN AS CHR_SEQUEN
  FROM TT_REC REC INNER JOIN TT_VEN VEN  ON  REC.CODFIL =  VEN.CODFIL 
                                        AND  REC.SEQUEN =  VEN.SEQUEN
                  LEFT  JOIN TD_COB DCOB ON DCOB.CODTAB =  REC.PORTAD
                                        AND DCOB.TIPCOB = 'B'
                  LEFT  JOIN TT_BON BON  ON  REC.CODFIL =  BON.FILREC 
                                        AND  REC.SEQUEN =  BON.SEQREC 
                                        AND  REC.NUMPAR =  BON.NUMPAR 
                                        AND  REC.SUBPAR =  BON.SUBPAR
                  LEFT  JOIN TD_CAR DCAR ON  REC.CARTAO = DCAR.CODTAB
                  LEFT  JOIN TD_CCC DCCC ON  REC.TIPCCC = DCCC.CODTAB
                  LEFT  JOIN TD_OUT DOUT ON DOUT.CODTAB =  REC.CODOUT 
                  LEFT  JOIN TT_CHR CHR  ON  CHR.CODFIL =  REC.CODFIL
                                        AND  CHR.SEQUEN =  REC.SEQCHE
                  CROSS JOIN TT_CFG CFG
 WHERE REC.FLGEST NOT IN ('C')
   AND VEN.LANVEN = 'T'
   AND REC.SUBPAR = ' 0'
   AND CFG.USA_VM_DECISOR = 'T'
 GROUP BY VEN.CODFIL, VEN.CODCTR, ANO_MES(VEN.DATFIS), 
          InitCap(CAST( CASE WHEN DCOB.CODTAB IS NOT NULL                THEN DCOB.DESCOB  ELSE
                        CASE WHEN TRUNC(VEN.DATHOR) <> TRUNC(REC.PAGAME) 
                              AND ABS(trunc(REC.PAGAME) - trunc(VEN.DATHOR)) >= 1    THEN 'Fatura'     ELSE
                        CASE WHEN REC.CARTAO IS NOT NULL                 THEN DCAR.DESOUT  ELSE 
                        CASE WHEN REC.SEQCHE IS NOT NULL 
                              AND TRUNC(VEN.DATHOR) = TRUNC(CHR.DATVEN)  THEN 'Cheque' ELSE 
                        CASE WHEN REC.SEQCHE IS NOT NULL                 THEN 'Cheque-Pr' ELSE 
                        CASE WHEN REC.TIPCCC IS NOT NULL                 THEN DCCC.DESCCC  ELSE
                        CASE WHEN BON.FILREC IS NOT NULL                 THEN 'Bnus'      ELSE 
                        CASE WHEN REC.CODOUT IS NOT NULL                 THEN DOUT.DESCAR  ELSE 
                             'Dinheiro' 
                        END END END END END END END END AS VARCHAR(30))),
          CASE WHEN REC.SEQCHE IS NOT NULL THEN TRUNC(CHR.DATVEN) - TRUNC(VEN.DATHOR)
                                           ELSE TRUNC(REC.DATVEN) - TRUNC(VEN.DATHOR)
          END,
          REC.PORTAD,
          DCAR.CODTAB,
          DCCC.CODTAB,
          DOUT.CODTAB,
          CHR.CODFIL,
          CHR.SEQUEN
;


/*-- SEQ 2087 --*/
/*-- IGNORE ERRO --*/
DROP VIEW DW_View_Vendas_Produto CASCADE;

/*-- SEQ 2088 --*/
CREATE OR REPLACE VIEW DW_View_Vendas_Produto AS
SELECT VEN.CODFIL AS FILIAL,
       ANO_MES(VEN.DATFIS) AS ANO_MES, 
       CAST( TRIM(IVE.FILMAT)                  || '-' || 
             TRIM(IVE.CODMAT)                  || '-' || 
             TRIM(TO_CHAR(IVE.CODCOR,'99999')) || '-' || 
             TRIM(TO_CHAR(IVE.CODTAM,'99999')) AS CHAR(18)) AS COD_PRODUTO,
       SUM(VEN.VLRLIQ * IVE.VLRMOV / VEN.VLRNOT) AS VALOR,
       SUM(IVE.QTDMOV) AS QUANTIDADE,
       COUNT(*) AS ITENS
  FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL
                                       AND IVE.SEQUEN = VEN.SEQUEN
                  CROSS JOIN TT_CFG CFG
 WHERE VEN.LANVEN = 'T'
   AND VEN.FLGEST <> 'C'
   AND IVE.SITKIT <> '1'
   AND VEN.VLRNOT <> 0
   AND IVE.SITMOV <> 'C'
   AND CFG.USA_VM_DECISOR = 'T'
 GROUP BY VEN.CODFIL, 
          ANO_MES(VEN.DATFIS), 
          IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM
;


/*-- SEQ 2089 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ECAM CASCADE;

/*-- SEQ 2090 --*/
CREATE OR REPLACE VIEW TV_ECAM AS
SELECT DMOE.DESMOE, CAM.DATREF, CAM.VLRREF, 
       0 AS STATUS, TO_CHAR(' ') AS DATIMP,TO_CHAR(' ') AS MOTREJ
  FROM TT_CAM CAM INNER JOIN TD_MOE DMOE ON DMOE.CODTAB = CAM.CODMOE;


/*-- SEQ 2091 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ECCC CASCADE;

/*-- SEQ 2092 --*/
CREATE OR REPLACE VIEW TV_ECCC AS
SELECT 'C/C '||COALESCE(DCCC.DESCCC ,'') AS DESCCC,
       CCC.CODFIL,
       CCC.SEQUEN,
       CCC.NUMDOC,
       CCC.DATOPE,
       CCC.PLACAS,
       CCC.FILUSU,
       CCC.CODUSU,
       USU.CODEXT AS USU_CODEXT,
       CCC.FILCLI,
       CCC.CODCLI,
       CLI.CODEXT AS CLI_CODEXT,
       CAST(CASE WHEN CCC.VLRLAN < 0 THEN '-' ELSE '+' END AS CHAR(1)) AS SINVLRLAN,
       ABS(CCC.VLRLAN) AS VLRLAN,
       CCC.STATUS,
       COALESCE(COMPLE,'') AS COMPLE,       
       FAT.CODFIL AS FAT_CODFIL,
       FAT.SEQUEN AS FAT_SEQUEN,
       FAT.CODSER AS FAT_CODSER,
       FAT.NUMECF AS FAT_NUMECF,
       FAT.NUMNOT AS FAT_NUMNOT,
       FAT.CNT_RO AS FAT_CNT_RO,
       CASE WHEN VEN.CODFIL IS NOT NULL THEN 'T' ELSE 'F' END AS PAGOU_REC,      
       VEN.CODFIL AS VEN_CODFIL,
       VEN.SEQUEN AS VEN_SEQUEN,
       VEN.CODSER AS VEN_CODSER,
       VEN.NUMECF AS VEN_NUMECF,
       VEN.NUMNOT AS VEN_NUMNOT,
       VEN.CNT_RO AS VEN_CNT_RO,
       REC.NUMPAR AS REC_NUMPAR,       
       REC.SUBPAR AS REC_SUBPAR,
       CCC.TIPLAN
  FROM TT_CCC CCC INNER JOIN TD_CCC DCCC ON DCCC.CODTAB = CCC.TIPCCC
                  INNER JOIN TT_USU USU  ON USU.FILUSU = CCC.FILUSU AND USU.CODUSU = CCC.CODUSU
                  INNER JOIN TT_CLI CLI  ON CLI.FILCLI = CCC.FILCLI AND CLI.CODCLI = CCC.CODCLI
                   LEFT JOIN TT_VEN FAT  ON CCC.FILFAT = FAT.CODFIL AND CCC.SEQFAT = FAT.SEQUEN
                   LEFT JOIN TT_REC REC ON REC.CODFIL = CCC.CODVEN
                                       AND REC.SEQUEN = CCC.SEQVEN
                                       AND REC.NUMPAR = CCC.NUMPAR
                                       AND REC.SUBPAR = CCC.SUBPAR
                   LEFT JOIN TT_VEN VEN ON VEN.CODFIL = CCC.CODVEN
                                       AND VEN.SEQUEN = CCC.SEQVEN
 WHERE (CCC.FILCLI||CCC.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
;


/*-- SEQ 2093 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ECFP CASCADE;

/*-- SEQ 2094 --*/
CREATE OR REPLACE VIEW TV_ECFP AS
SELECT CFPATI, DESCFP, VENCON, VENREV, DEVCON, DEVREV, SAICON, SAIREV,
       ENTCON, ENTREV, COMCON, COMREV, DVCCON, DVCREV, INTCON, INTREV, 0 AS STATUS,
       TO_CHAR(' ') AS DATIMP, TO_CHAR(' ') AS MOTREJ
  FROM TD_CFP;


/*-- SEQ 2095 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ECHR CASCADE;

/*-- SEQ 2096 --*/
CREATE OR REPLACE VIEW TV_ECHR AS
SELECT CHR.CODFIL, CHR.FLGEST, CHR.CODBCO, USU.CODEXT AS CODUSU, CHR.CODAGE, CHR.NUMCHE,
       CHR.NUMCON, CHR.NUMDOC, CHR.ATU_EM, CHR.DATVEN, CHR.VLRCHE, CHR.PORTAD,
       CHR.PAGAME, CHR.VLRDIF, CHR.NUMDEP, CHR.ALINEA, CHR.AUTORI, CHR.TIPCOB,
       CHR.OBSLOG, CHR.DATOPE, CHR.NUMECF, CHR.CDCMC7, CLI.CODEXT AS CODCLI, CHR.VLRORI,
       CHR.PLACAS, CHR.SERCHE
  FROM TT_CHR CHR INNER JOIN TT_USU USU  ON USU.FILUSU = CHR.FILUSU AND USU.CODUSU = CHR.CODUSU
                  INNER JOIN TT_CLI CLI  ON CLI.CODCLI = CHR.CODCLI AND CLI.FILCLI = CHR.FILCLI
                  INNER JOIN TD_EXP DEXP ON DEXP.CODTAB = 1
 WHERE CHR.ATU_EM BETWEEN TO_DATE(TO_CHAR(TRUNC(DEXP.DATINI),'DD/MM/YYYY')||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND TO_DATE(TO_CHAR(TRUNC(DEXP.DATFIM),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');


/*-- SEQ 2097 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ECNT CASCADE;

/*-- SEQ 2098 --*/
CREATE OR REPLACE VIEW TV_ECNT AS
SELECT CLI.CODEXT, CLI.FILCLI, CLI.CODCLI, CON.NOMTRA AS TRACON,
       CON.DATNAS AS NASCNT,CON.SEXCON AS SEXOCO,TO_CHAR(' ') AS TIPCON,
       TO_CHAR(' ') AS TIPPES,CON.DDDCON,TRIM(CON.TELCON) AS CONTEL,
       CON.DDDCEL,TRIM(CON.CELCON) AS CELUCO,CON.DDDFAX AS DDDFXC,
       TRIM(CON.NUMFAX) AS NUMFXC,CON.E_MAIL
  FROM TT_CLI CLI      JOIN TT_IED IED ON IED.TABELA = 'CLI'
                  LEFT JOIN TT_CON CON ON CON.FILCLI = CLI.FILCLI AND 
				                      CON.CODCLI = CLI.CODCLI
WHERE (CLI.FILCLI||CLI.CODCLI <> (SELECT VC_FILCLI||VC_CODCLI FROM TT_CFG))
;


/*-- SEQ 2099 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ECOM CASCADE;

/*-- SEQ 2100 --*/
CREATE OR REPLACE VIEW TV_ECOM AS
SELECT COM.CODFIL, COM.SEQUEN, COM.FLGEST, COM.INCOJU, COM.INTPJU, COM.INTPMU,
       COM.TIPCTA, COM.TIPNOT, COM.CODSER, USU.CODEXT AS CODUSU, CLI.CODEXT AS CODFOR,
       COM.NUMNOT, COM.ATU_EM,
       /*CASE WHEN VEN.SEQUEN IS NOT NULL THEN -- Transferencia
           VEN.DATHOR -- Apos todos os Checkouts estiverem corrigidos (tarefa 94121), pode-se voltar a usar DATCMP
       ELSE
           COM.DATCMP
       END*/ COM.DATCMP AS DATCMP,
       /*CASE WHEN VEN.SEQUEN IS NOT NULL THEN -- Transferencia
           CASE WHEN COM.DATOPE < COM.DATCMP
                THEN COM.DATCMP -- Entradas com a configuracao TRAORI="T" possuem DATOPE < DATCMP
                ELSE COM.DATOPE
           END
       ELSE
           COM.DATOPE
       END*/ COM.DATOPE AS DATOPE,
       CASE WHEN COM.DESCON > 0 THEN ABS(COM.DESCON) ELSE 0 END AS ACRESC,
       CASE WHEN COM.DESCON < 0 THEN ABS(COM.DESCON) ELSE 0 END AS DESCON,
       ABS(COM.OUTTAX) AS OUTTAX, ABS(COM.QTDTOT) AS QTDTOT, ABS(COM.VLRLIQ) AS VLRLIQ, ABS(COM.VLRTOT) AS VLRTOT, DMOE.DESMOE AS CODMOE,
       MOEJ.DESMOE AS MOEJUR, DSET.DESSET AS CODSET, COM.NOTESP, ABS(COM.VLRRET) AS VLRRET, ABS(COM.ICMFRE) AS ICMFRE,
       COM.TIPPAR, COM.TIPTRP, FRE.CODFIL AS FILFRE, FRE.CODSER AS SERFRE, FRE.SUBSER AS SUBFRE, TRA.CODEXT AS FORFRE,
       FRE.NUMNOT AS NUMFRE, FAT.CODFIL AS FILFAT, FAT.CODSER AS SERFAT, FAT.SUBSER AS SUBFAT, CRE.CODEXT AS FORFAT, FAT.NUMNOT AS NUMFAT,
       COM.SIGNAT, COM.UFNOTA, CTA.CODFIL AS FILCTA, COM.SUBSER, ABS(COM.VLTXJU) AS VLTXJU,
       ABS(COM.VLTXMU) AS VLRXMU, ABS(COM.NUMVOL) AS NUMVOL, ABS(COM.SUBSTT) AS SUBSTT, ABS(COM.BASSUB) AS BASSUB, ABS(COM.VLRBON) AS VLRBON, COM.ESPDOC,
       COM.CONPGT, REPLACE(COM.OBSERV,';','\;') AS OBSERV,
       COM.FILEND, COM.NUMEND, ABS(COM.BASICM) AS BASICM, ABS(COM.VLRNOT) AS VLRNOT, ABS(COM.VLRIPI) AS VLRIPI,
       REPLACE(COM.OBSFAT,';','\;') AS OBSFAT, ABS(COM.RETCOF) AS RETCOF, DCFO.CODCFO, COM.ATUCUS,
       COM.EXPORT, ABS(COM.VLRFRE) AS VLRFRE, ABS(COM.BASFRE) AS BASFRE, ABS(COM.PERFRE) AS PERFRE, ABS(COM.PERIRR) AS PERIRR,
       ABS(COM.PERISS) AS PERISS, ABS(COM.PERINS) AS PERINS, ABS(COM.PERCSS) AS PERCSS, ABS(COM.PERICM) AS PERICM, ABS(COM.VLRIRR) AS VLRIRR, COM.RETIRR, COM.RETCSS,
       ABS(COM.VLRISS) AS VLRISS, ABS(COM.VLRINS) AS VLRINS, ABS(COM.VLRCSS) AS VLRCSS, ABS(COM.VLRICM) AS VLRICM, COM.FLGINS,
       COM.FLGCSS, COM.FLGPIS, COM.FLGCOF, CTA.TITCTA, CTA.USOCTA,
       0 AS STATUS, TO_CHAR(' ') AS DATIMP,TO_CHAR(' ') AS MOTREJ,
       CLI.FILCLI||CLI.CODCLI as CLIENTE, USU.FILUSU||USU.CODUSU as USUARIO,
       COM.DESPAR, ABS(COM.OUTDES) AS OUTDES, COM.CODFCE, COM.TIPFRE, COM.CHAVEA, COM.CODTRI, COM.BSTFRE, COM.ST_FRE,
       FIS.MODNOT, CASE WHEN COM.TIPNOT = 'F' THEN 'A' ELSE COALESCE(COM.TIPPAR, 'F') END AS TIPDOC,
       CAST('E' AS VARCHAR(1))AS ENTSAI,
       CLI.CODCLI AS CODIGO,
       /* Pedro E. Braga - 92072 */
       CASE WHEN COM.SEQFRE IS NULL THEN COM.FLGPIS ELSE FRE.FLGPIS END AS FXC_FLGPIS,-- Retém PIS - Frete/Compromissos
       CASE WHEN COM.SEQFRE IS NULL THEN COM.SITPIS ELSE FRE.SITPIS END AS FXC_SITPIS,-- CST do PIS - Frete/Compromissos
       CASE WHEN COM.SEQFRE IS NULL THEN COM.VLRPIS ELSE FRE.VLRPIS END AS FXC_VLRPIS,-- Valor do PIS - Frete/Compromissos
       CASE WHEN COM.SEQFRE IS NULL THEN COM.FLGCOF ELSE FRE.FLGCOF END AS FXC_FLGCOF,-- Retém COFINS - Frete/Compromissos
       CASE WHEN COM.SEQFRE IS NULL THEN COM.SITCOF ELSE FRE.SITCOF END AS FXC_SITCOF,-- CST do COFINS - Frete/Compromissos
       CASE WHEN COM.SEQFRE IS NULL THEN COM.VLRCOF ELSE FRE.VLRCOF END AS FXC_VLRCOF,-- Valor do COFINS - Frete/Compromissos,
       CTACOM.CODEXT AS CTACOM,
       COM.EXPFIS, COM.EXPORT_CAN,
       ABS(COM.ISEICM) AS ISEICM, ABS(COM.OUTICM) AS OUTICM, COM.FLGICM, COM.FLGISS, COM.NATBCC, COM.CODSRV, --SRV.DESSRV, SRV.NIVSRV,
       ABS(COM.VLRPIS) AS VLRPIS, COM.SITPIS, (100 * ABS(COM.VLRPIS) / ABS(COM.VLRLIQ)) AS PERPIS,
       ABS(COM.VLRCOF) AS VLRCOF, COM.SITCOF, (100 * ABS(COM.VLRCOF) / ABS(COM.VLRLIQ)) AS PERCOF
  FROM TT_COM COM INNER JOIN TT_USU USU  ON USU.FILUSU = COM.FILUSU AND USU.CODUSU = COM.CODUSU
                  INNER JOIN TD_MOE DMOE ON DMOE.CODTAB = COM.CODMOE
                  INNER JOIN TD_MOE MOEJ ON MOEJ.CODTAB = COM.MOEJUR
                  INNER JOIN TT_CLI CLI  ON CLI.FILCLI = COM.FILFOR AND CLI.CODCLI = COM.CODFOR
                  INNER JOIN TD_SET DSET ON DSET.CODTAB = COM.CODSET
                  INNER JOIN (SELECT DISTINCT CODSER,
                                     CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER,
                                     SEREXP, SUBEXP, MODNOT, ORIGEM
                                FROM TT_FIS
                               WHERE ORIGEM IN ('C','F')
                                 AND EXPORT = 'T') FIS  ON FIS.CODSER = COM.CODSER
                                        AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$')
                                        AND FIS.ORIGEM = CASE WHEN COALESCE(COM.TIPPAR,'F') = 'T'
                                                              THEN 'F' ELSE 'C' END
                   LEFT JOIN TT_COM FRE  ON FRE.CODFIL = COM.FILFRE AND FRE.SEQUEN = COM.SEQFRE
                   LEFT JOIN TT_COM FAT  ON FAT.SEQUEN = COM.SEQFAT
                   LEFT JOIN TT_CLI TRA  ON TRA.FILCLI = FRE.FILFOR AND TRA.CODCLI = FRE.CODFOR
                   LEFT JOIN TT_CLI CRE  ON CRE.FILCLI = FAT.FILFOR AND CRE.CODCLI = FAT.CODFOR
                   LEFT JOIN TD_CFO DCFO ON DCFO.CODTAB = COM.CODCFO
                   LEFT JOIN TT_CTA CTA  ON CTA.CODFIL = COM.FILCTA AND CTA.SEQUEN = COM.SEQCTA
                                        AND CTA.TIPCTA = COM.TIPCTA
                   LEFT JOIN TT_VEN VEN  ON VEN.CODFIL = COM.FILFOR
                                        AND VEN.NUMECF = COM.SUBSER
                                        AND VEN.CODSER = COM.CODSER
                                        AND VEN.NUMNOT = SUBSTR(COM.NUMNOT,4)
                                        AND VEN.FILCLI = COM.CODFIL
                                        AND VEN.CODCLI = COM.CODFOR
                   LEFT JOIN TR_FIN RFIN ON RFIN.ORIGEM='COM' AND RFIN.CODFIL=COM.CODFIL AND RFIN.SEQUEN=COM.SEQUEN AND RFIN.TIPLAN IN ('FAT','FRE','COM','TIT')
                   LEFT JOIN TT_CTA CTACOM ON RFIN.FILCTA = CTACOM.CODFIL AND RFIN.SEQCTA=CTACOM.SEQUEN
                   LEFT JOIN TT_SRV SRV ON SRV.CODSRV = COM.CODSRV
 WHERE COM.NUMNOT NOT LIKE '%#%';


/*-- SEQ 2101 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ECP CASCADE;

/*-- SEQ 2102 --*/
CREATE OR REPLACE VIEW TV_ECP AS
SELECT DAT.DATOPE, COM.FILFOR, COM.CODFOR, COM.CODFIL, COM.SEQUEN, COM.VLRLIQ,
 (SELECT SUM(COALESCE(P.VLRPGT,0))
 FROM TT_PAG P
 WHERE P.CODFIL = COM.CODFIL
  AND P.SEQUEN = COM.SEQUEN
  AND P.FLGEST = 'P'
  AND TRUNC(P.DATPGT) <= DAT.DATOPE) AS VLRPGT,
 (SELECT SUM(COALESCE(P.VLRPGT-P.VLRPAR,0))
 FROM TT_PAG P
 WHERE P.CODFIL = COM.CODFIL
  AND P.SEQUEN = COM.SEQUEN
  AND P.FLGEST = 'P'
  AND TRUNC(P.DATPGT) <= DAT.DATOPE) AS JURDES,
 (SELECT SUM(CASE WHEN (TRUNC(P.DATINC) < DAT.DATOPE) AND 
    ((P.FLGEST IN ('A','1','2')) OR (TRUNC(P.DATPGT) > DAT.DATOPE )) 
   THEN P.VLRPAR
   ELSE 0
   END)
 FROM TT_PAG P
 WHERE P.CODFIL = COM.CODFIL
  AND P.SEQUEN = COM.SEQUEN) AS DIVIDA
FROM TT_DAT DAT, TT_COM COM
WHERE COM.DATOPE < DAT.DATOPE
 AND (SELECT MAX(CASE WHEN (TRUNC(P.DATINC) < DAT.DATOPE) AND 
    ((P.FLGEST IN ('A','1','2')) OR (TRUNC(P.DATPGT) > DAT.DATOPE )) 
   THEN 'T' 
   ELSE 'F' 
   END)
 FROM TT_PAG P
 WHERE P.CODFIL = COM.CODFIL
  AND P.SEQUEN = COM.SEQUEN) = 'T'
;


/*-- SEQ 2103 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ECR CASCADE;

/*-- SEQ 2104 --*/
CREATE OR REPLACE VIEW TV_ECR AS
SELECT DATINI, DATFIM, DATREF, VLRANT, VLRVEN, VLRPGT, VLRDEV, VLREST, VLRREN, NEWREN, 
       VLRANT + VLRVEN - VLRPGT + VLREST - VLRREN + NEWREN AS VLRARE,
       VLRDES, VLRACR, TIPLAN, CODFIL,
       -- Agrupador para subtotal
       CASE WHEN DATREF <= DATFIM THEN 'A'
            ELSE 'P'
       END AS SUBTOT,
       -- Anterior ao numero de meses minimo a apresentar
       CASE WHEN DATREF < TO_DATE( '01' ||
                            TO_CHAR( CASE WHEN CAST(TO_CHAR( DATINI, 'MM' ) AS Numeric) - CFG.MESES_CARTEIRA_MIN > 0 THEN CAST(TO_CHAR( DATINI, 'MM' ) AS Numeric) - CFG.MESES_CARTEIRA_MIN
                                          ELSE 12 + (CAST(TO_CHAR( DATINI, 'MM' ) AS Numeric) - CFG.MESES_CARTEIRA_MIN) 
                                     END, '09' ) ||
                            TO_CHAR( CASE WHEN CAST(TO_CHAR( DATINI, 'MM' ) AS Numeric) - CFG.MESES_CARTEIRA_MIN > 0 THEN TO_NUMBER(TO_CHAR( DATINI, 'YYYY' ))  
                                          ELSE TO_NUMBER(TO_CHAR( DATINI, 'YYYY' )) - 1 
                                     END, '0000' ), 'DD MM YYYY' ) THEN ' ANTES '
            -- Posterior ao numero maximo de meses a apresentar
            ELSE CASE WHEN DATREF > TO_DATE(TO_CHAR(LAST_DAY( ADD_MONTHS(DATINI, CFG.MESES_CARTEIRA_MAX)),'DD/MM/YYYY' )|| ' 23:59:59','DD/MM/YYYY HH24:MI:SS' ) THEN 'DEPOIS '
            
/*            LAST_DAY( TO_DATE( '01' || TO_CHAR( CASE WHEN CAST(TO_CHAR( DATINI, 'MM' ) AS Numeric) + CFG.MESES_CARTEIRA_MAX = 12 THEN 12 
                                                                             ELSE MOD( CAST(TO_CHAR( DATINI, 'MM' ) AS Numeric) + (CFG.MESES_CARTEIRA_MAX), 12 )
                                                                        END , '09' ) ||
                                                               TO_CHAR( CAST(TO_CHAR( DATINI, 'YYYY') AS Numeric) + TRUNC((CAST( TO_CHAR( DATINI, 'MM') AS Numeric) + (CFG.MESES_CARTEIRA_MAX-1) ) / 12), '0000' ) || ' 23:59:59', 'DD MM YYYY HH24:MI:SS' )) THEN 'DEPOIS '
*/                                                               
                      ELSE TO_CHAR( DATREF, 'YYYY-MM' ) || CASE WHEN TO_CHAR( DATREF, 'YYYYMM' ) = TO_CHAR( DATINI, 'YYYYMM' ) AND TRUNC(DATREF) < DATINI THEN TO_CHAR( DATINI, '"(< dia" DD)' )
                                                           END ||
                                                           CASE WHEN TO_CHAR( DATREF, 'YYYYMM' ) = TO_CHAR( DATFIM, 'YYYYMM' ) AND TRUNC(DATREF) > DATFIM THEN TO_CHAR( DATFIM, '"(> dia" DD)' )
                                                           END ||
                                                           CASE WHEN TRUNC(DATREF) BETWEEN TRUNC(DATINI) AND TRUNC(DATFIM) AND TIPLAN = ' ' THEN '(=Perodo)'
                                                           END
                 END
     END || 
CASE TIPLAN WHEN 'E' THEN '(=Entrada)' 
                          WHEN 'V' THEN '(=A vista)'
                          WHEN 'D' THEN '(=Devoluo)'
              END AS PERIODO,
     SEQUEN,
     NUMPAR,
     SUBPAR,
     FILCLI,
     CODCLI
FROM TT_CFG CFG,
     (-- A receber anterior a data de inicio
      SELECT INI.DATOPE AS DATINI,
             FIM.DATOPE AS DATFIM,
             REC.DATVEN AS DATREF,
             REC.VLRPAR AS VLRANT,
             0          AS VLRVEN,
             0          AS VLRPGT,
             0          AS VLRDEV,
             0          AS VLREST,
             0          AS VLRREN,
             0          AS NEWREN,
             0          AS VLRDES,
             0          AS VLRACR,
             ' '        AS TIPLAN,
             REC.CODFIL,
             REC.SEQUEN,
             REC.NUMPAR,
             REC.SUBPAR,
             VEN.FILCLI,
             VEN.CODCLI
      FROM TT_DAT INI, TT_DAT FIM, TT_REC REC INNER JOIN TT_VEN VEN ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
      WHERE CASE WHEN TRUNC(REC.DATINC) >= INI.DATOPE THEN 'F'
                 ELSE CASE WHEN (REC.FLGEST = 'A' AND REC.CARTAO IS NULL AND REC.SEQCHE IS NULL) THEN 'T'
                           ELSE CASE WHEN TRUNC(REC.PAGAME) >= INI.DATOPE THEN 'T' 
                                     ELSE 'F' 
                                END 
                      END
            END = 'T'
      UNION ALL
      -- Vendas no perodo
      SELECT INI.DATOPE AS DATINI,
             FIM.DATOPE AS DATFIM,
             REC.DATVEN AS DATREF,
             0          AS VLRANT,
             REC.VLRPAR AS VLRVEN,
             0          AS VLRPGT,
             0          AS VLRDEV,
             0          AS VLREST,
             0          AS VLRREN,
             0          AS NEWREN,
             0          AS VLRDES,
             0          AS VLRACR,
             CASE WHEN VEN.VLRLIQ < 0 THEN 'D'
                  ELSE CASE WHEN COALESCE(VEN.PRAMED,0) = 0 THEN 'V'
                            ELSE CASE WHEN TRUNC(VEN.DATHOR) = TRUNC(REC.PAGAME) AND TRUNC(VEN.DATHOR) = TRUNC(REC.DATVEN) AND (REC.FLGEST = 'P' OR REC.CARTAO IS NOT NULL OR REC.SEQCHE IS NOT NULL) THEN 'E' 
                                      ELSE ' ' 
                                 END
                       END
             END AS TIPLAN,
             REC.CODFIL,
             REC.SEQUEN,
             REC.NUMPAR,
             REC.SUBPAR,
             VEN.FILCLI,
             VEN.CODCLI
      FROM TT_DAT INI, TT_DAT FIM, 
           TT_VEN VEN INNER JOIN TT_REC REC ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
      WHERE VEN.DATHOR BETWEEN INI.DATOPE AND TO_DATE( TO_CHAR( FIM.DATOPE, 'DD/MM/YYYY' ) || ' 23:59:59', 'DD/MM/YYYY HH24:MI:SS' )
        AND VEN.FLGEST <> 'C'
        AND VEN.LANVEN = 'T'
        AND REC.SUBPAR = ' 0'
        AND REC.RENORI IS NULL
      UNION ALL
      -- Pagamentos, estornos, juros e descontos no perodo
      SELECT INI.DATOPE AS DATINI,
             FIM.DATOPE AS DATFIM,
             REC.DATVEN AS DATREF,
             0          AS VLRANT,
             0          AS VLRVEN,
             CASE WHEN SEQCHE IS NOT NULL OR CARTAO IS NOT NULL
                  THEN REC.VLRPAR
                  ELSE REC.VLRPGT 
             END AS VLRPGT,
             CASE WHEN REC.TIPCCC IS NOT NULL AND REC.TIPCCC = CFG.CC_DEVOLUCAO
                  THEN REC.VLRPGT 
                  ELSE 0
             END AS VLRDEV,
             CASE WHEN REC.FLGEST = 'X' 
                  THEN CASE WHEN SEQCHE IS NOT NULL OR CARTAO IS NOT NULL
                            THEN REC.VLRPAR
                            ELSE REC.VLRPGT
                       END
                  ELSE 0
             END AS VLREST,
             0          AS VLRREN,
             0          AS NEWREN,
             CASE WHEN REC.FLGEST <> 'X' AND REC.VLRDES < 0 AND REC.CARTAO IS NULL
                  THEN ABS(REC.VLRDES)
                  ELSE 0
             END AS VLRDES,
             CASE WHEN REC.FLGEST <> 'X' AND REC.VLRDES > 0 AND REC.CARTAO IS NULL
                  THEN REC.VLRDES
                  ELSE 0
             END AS VLRACR,
             CASE WHEN VEN.VLRLIQ < 0 THEN 'D'
                  ELSE CASE WHEN COALESCE(VEN.PRAMED,0) = 0 THEN 'V'
                            ELSE CASE WHEN TRUNC(VEN.DATHOR) = TRUNC(REC.PAGAME) AND TRUNC(VEN.DATHOR) = TRUNC(REC.DATVEN) AND (REC.FLGEST = 'P' OR REC.CARTAO IS NOT NULL OR REC.SEQCHE IS NOT NULL) THEN 'E'
                                      ELSE ' ' 
                                 END
                            END
             END AS TIPLAN,
             REC.CODFIL,
             REC.SEQUEN,
             REC.NUMPAR,
             REC.SUBPAR,
             VEN.FILCLI,
             VEN.CODCLI
      FROM TT_DAT INI, TT_DAT FIM, TT_CFG CFG,
           TT_VEN VEN INNER JOIN TT_REC REC ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
      WHERE REC.PAGAME BETWEEN INI.DATOPE AND TO_DATE( TO_CHAR( FIM.DATOPE, 'DD/MM/YYYY' ) || ' 23:59:59', 'DD/MM/YYYY HH24:MI:SS' )
        AND VEN.FLGEST <> 'C'
        AND ((REC.FLGEST IN ('P','X')) -- Pagas ou estornadas
          OR (REC.FLGEST = 'A' AND (REC.CARTAO IS NOT NULL OR REC.SEQCHE IS NOT NULL))) -- Pagas com cartao ou cheque
      UNION ALL
      -- Valor Renegociado
      SELECT INI.DATOPE AS DATINI,
             FIM.DATOPE AS DATFIM,
             REC.DATVEN AS DATREF,
             0          AS VLRANT,
             0          AS VLRVEN,
             0          AS VLRPGT,
             0          AS VLRDEV,
             0          AS VLREST,
             REC.VLRPAR as VLRREN,
             0          AS NEWREN,
             0          AS VLRDES,
             0          AS VLRACR,
             ' '        AS TIPLAN,
             REC.CODFIL,
             REC.SEQUEN,
             REC.NUMPAR,
             REC.SUBPAR,
             VEN.FILCLI,
             VEN.CODCLI
      FROM TT_DAT INI, TT_DAT FIM, TT_REC REC INNER JOIN TT_VEN VEN ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
      WHERE REC.PAGAME BETWEEN INI.DATOPE AND TO_DATE( TO_CHAR( FIM.DATOPE, 'DD/MM/YYYY' ) || ' 23:59:59', 'DD/MM/YYYY HH24:MI:SS' )
        AND REC.FLGEST = 'C'
        AND REC.RENEGO IS NOT NULL
      UNION ALL
      -- Valor aps renegociao
      SELECT INI.DATOPE AS DATINI,
             FIM.DATOPE AS DATFIM,
             REC.DATVEN AS DATREF,
             0          AS VLRANT,
             0          AS VLRVEN,
             0          AS VLRPGT,
             0          AS VLRDEV,
             0          AS VLREST,
             0          AS VLRREN,
             REC.VLRPAR AS NEWREN,
             0          AS VLRDES,
             0          AS VLRACR,
             ' '        AS TIPLAN,
             REC.CODFIL,
             REC.SEQUEN,
             REC.NUMPAR,
             REC.SUBPAR,
             VEN.FILCLI,
             VEN.CODCLI
      FROM TT_DAT INI, TT_DAT FIM, TT_REC REC INNER JOIN TT_VEN VEN ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
      WHERE REC.DATINC BETWEEN INI.DATOPE AND TO_DATE( TO_CHAR( FIM.DATOPE, 'DD/MM/YYYY' ) || ' 23:59:59', 'DD/MM/YYYY HH24:MI:SS' )
        AND REC.RENORI IS NOT NULL
      ) ECR
;


/*-- SEQ 2105 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ECT CASCADE;

/*-- SEQ 2106 --*/
CREATE OR REPLACE VIEW TV_ECT AS
SELECT USERENV( 'SESSIONID' ) AS USERID,
       cast(LPAD('T',14,'X') as VARCHAR(14)) AS CHV_ID,
       cast(NULL as VARCHAR(14)) AS CHVPAI,
       cast(NULL as VARCHAR(3))  AS FILCTA,
       cast(NULL as VARCHAR(10))  AS SEQCTA,
       cast(NULL as VARCHAR(1))  AS TIPCTA,
       cast('TODOS' as VARCHAR(254)) AS TITCTA
  FROM DUAL
UNION ALL
SELECT USERENV( 'SESSIONID' ) AS USERID,
       cast(COALESCE(CTA.CODFIL,'') || COALESCE(CTA.SEQUEN,'') || COALESCE(CTA.TIPCTA,'') as VARCHAR(14))  AS CHV_ID,
       cast(COALESCE(CTA.FILECT,'') || COALESCE(CTA.SEQECT,'') || 'T' as VARCHAR(14)) AS CHVPAI,
       CTA.CODFIL AS FILCTA, CTA.SEQUEN AS SEQCTA, CTA.TIPCTA,
       CTA.TITCTA
  FROM TT_CTA CTA
UNION ALL
SELECT USERENV( 'SESSIONID' ) AS USERID,
       cast(COALESCE(ECT.CODFIL,'') || COALESCE(ECT.SEQUEN,'') || 'T' as VARCHAR(14))  AS CHV_ID,
       cast(CASE WHEN ECT.FILECT IS NULL THEN LPAD('T',14,'X')
            ELSE COALESCE(ECT.FILECT,'') || COALESCE(ECT.SEQECT,'') || 'T'
       END as VARCHAR(14))  AS CHVPAI,
       ECT.CODFIL AS FILCTA, ECT.SEQUEN AS SEQCTA, 'T' AS TIPCTA,
       ECT.TITECT AS TITCTA
  FROM TT_ECT ECT
 ;




/*-- SEQ 2107 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EDOP CASCADE;

/*-- SEQ 2108 --*/
CREATE OR REPLACE VIEW TV_EDOP AS
SELECT DISTINCT DOP.CODFIL, DOP.SEQUEN, PAG.CODFIL AS FILCOM, PAG.SEQUEN AS SEQCOM, PAG.NUMPAR, PAG.SUBPAR,
       DOP.FLGEST, CTA.TIPCTA, USU.CODEXT AS CODUSU, CTA.CODFIL AS FILCTA,
       CTA.USOCTA, CTA.TITCTA, CTA.CODEXT AS CODEXT_CTA, DOP.ATU_EM, DOP.DATPGT, DOP.NUMIMP, DOP.DOMDOP, DOP.STDDOP, DOP.VLRDOC,
	   DOP.FILDES, DOP.FILRDP, DOP.SEQRDP, DOP.CHETRO, DOP.NUMDOC, DOP.OBSERV, CLI.CODEXT AS CODCLI,
	   DOP.OBSINT, 0 AS STATUS, TO_CHAR(' ') AS DATIMP,TO_CHAR(' ') AS MOTREJ,
	   PAG.ATU_EM AS PAG_ATU_EM, DDOP.DESDOP, DOP.CODEXT
  FROM TT_PAG PAG LEFT JOIN TT_DOP DOP ON DOP.CODFIL = PAG.FILDOP AND DOP.SEQUEN = PAG.SEQDOP
                  LEFT JOIN TD_DOP DDOP On DOP.DOMDOP = DDOP.CODTAB
                 INNER JOIN TT_CTA CTA ON CTA.CODFIL = DOP.FILCTA AND CTA.SEQUEN = DOP.SEQCTA
                                       AND CTA.TIPCTA = DOP.TIPCTA
                 INNER JOIN TT_USU USU ON USU.FILUSU = DOP.FILUSU AND USU.CODUSU = DOP.CODUSU
                  LEFT JOIN TT_CLI CLI ON CLI.FILCLI = DOP.FILCLI AND CLI.CODCLI = DOP.CODCLI;


/*-- SEQ 2109 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EECF CASCADE;

/*-- SEQ 2110 --*/
CREATE OR REPLACE VIEW TV_EECF AS
SELECT ECF.CODFIL, ECF.NUMECF, ECF.DATOPE, ECF.NUMSER, 
       ECF.TOTPAR, ECF.TOTALI, ECF.TIPTOT, ECF.VLRTOT, 
       ECF.VLRBAS, ECF.CNT_RO, ECF.ORDALI, 
       DECF.CODEXT_DECF, ECF.EXPFIS 
  FROM TT_ECF ECF INNER JOIN TD_ECF DECF ON DECF.FILECF = ECF.CODFIL
                                        AND DECF.NUMECF = ECF.NUMECF 
 ;


/*-- SEQ 2111 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EEND CASCADE;

/*-- SEQ 2112 --*/
CREATE OR REPLACE VIEW TV_EEND AS
SELECT CLI.CODEXT,CLI.FILCLI,CLI.CODCLI, ENDE.CODFIL AS FILEND,
       ENDE.NUMEND AS NUMEND, ENDE.ENDERE,ENDE.CONTAT,ENDE.NUMERO,
       ENDE.BAIRRO,ENDE.SIGEST,ENDE.NOMCID,ENDE.CODLOG,DREG.REGIAO,
       ENDE.FLGNAC,ENDE.ESTRAN,ENDE.USA_NF,ENDE.ENDCOB,ENDE.ENDCOR,
       ENDE.TIPEND,ENDE.COMPLE,ENDE.CODCEP,ENDE.LOCTRA,ENDE.CODDDD,
       TRIM(ENDE.NUMFON) AS NUMFON,ENDE.DDDFAX,TRIM(ENDE.NUMFAX) AS NUMFAX,
       ENDE.NUMDOC AS DOCEND,ENDE.INSEST AS IE_END, MUN.CODIBG,
	   ENDE.INSMUN, ENDE.CODPAI, ENDE.NOMREC
  FROM TT_CLI CLI      JOIN TT_IED IED ON IED.TABELA = 'CLI'
                  LEFT JOIN TT_END ENDE ON ENDE.FILCLI = CLI.FILCLI 
				                       AND ENDE.CODCLI = CLI.CODCLI
                  LEFT JOIN TT_MUN MUN  ON ENDE.CODCID = MUN.CODIGO
                  LEFT JOIN TD_REG DREG ON DREG.CODTAB = ENDE.REGIAO
 WHERE (CLI.FILCLI||CLI.CODCLI <> (SELECT VC_FILCLI||VC_CODCLI FROM TT_CFG))
;


/*-- SEQ 2113 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EIIN CASCADE;

/*-- SEQ 2114 --*/
CREATE OR REPLACE VIEW TV_EIIN AS
select INV.CODFIL,
       INV.SEQUEN,
       INV.CODEXT as INV_CODEXT,
       IIN.NUMITE,
       IIN.FILMAT,
       IIN.CODMAT,
       IIN.CODCOR,
       IIN.CODTAM,
       GRA.REFPRO as GRA_REFPRO,
       PRO.REFBAS as PRO_REFBAS,
       PRO.DESMAT as PRO_DESMAT,
       PRO.ESPMAT as PRO_ESPMAT,
       GRA.CUSREP as GRA_CUSREP,               
       DDIV.NOMDIV as DDIV_NOMDIV,
       DIV.NOMEXT as DIV_NOMEXT,
       DSUB.NOMSUB as DSUB_NOMSUB,
       SUB.NOMEXT as SUB_NOMEXT,
       MED.UNIMED as DMED_UNIMED,
       IIN.QTDEST,
       IIN.RESERV,
       IIN.CONPRI,
       IIN.CONSEG,
       IIN.CONTER,
       IIN.CONQUA,
       IIN.CONULT,
       Coalesce(IIN.CONULT, IIN.CONQUA, IIN.CONTER, IIN.CONSEG, IIN.CONPRI, 0) as ULTIMA,
       IIN.CODEXT as IIN_CODEXT
  from TT_INV INV
 inner join TT_IIN IIN
       on   INV.CODFIL = IIN.CODFIL
       and  INV.SEQUEN = IIN.SEQUEN
 inner join TT_GRA GRA
       on   IIN.FILMAT = GRA.FILMAT            
       and  IIN.CODMAT = GRA.CODMAT            
       and  IIN.CODCOR = GRA.CODCOR            
       and  IIN.CODTAM = GRA.CODTAM            
 inner join TT_PRO PRO
       on   GRA.FILMAT = PRO.FILMAT            
       and  GRA.CODMAT = PRO.CODMAT            
 inner join TT_DIV DIV 
       on   GRA.CODCOR = DIV.CODITE            
 inner join TD_DIV DDIV
       on   DIV.CODDIV = DDIV.CODTAB          
 inner join TT_SUB SUB
       on   GRA.CODTAM = SUB.CODITE            
 inner join TD_SUB DSUB
       on   SUB.CODSUB = DSUB.CODTAB          
 inner join TD_MED MED
       on   PRO.UNIDAD = MED.CODTAB            
;


/*-- SEQ 2115 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EINV CASCADE;

/*-- SEQ 2116 --*/
CREATE OR REPLACE VIEW TV_EINV AS
select INV.CODFIL,
       INV.SEQUEN,
       INV.CODEXT,
       INV.FLGEST,
       EST.DESDOM as FLGEST_DESDOM,
       INV.TITINV as DESINV,
       INV.CODCRI as USUCRI,
       CRI.APEUSU as CRI_APEUSU,
       INV.FILCRI,
       INV.DATCRI,
       INV.CODENC as USUENC,
       ENC.APEUSU as ENC_APEUSU,
       INV.FILENC,
       INV.DATENC,
       INV.CODMUL as CODEST,
       DMUL.DESMUL as DESEST,
       INV.ATU_EM
  from TT_INV INV
 inner join TT_USU CRI
       on   INV.FILCRI = CRI.FILUSU
       and  INV.CODCRI = CRI.CODUSU
  left join TT_USU ENC
       on   INV.FILENC = ENC.FILUSU
       and  INV.CODENC = ENC.CODUSU
  left join TD_MUL DMUL
       on   INV.CODMUL = DMUL.CODTAB
  left join TT_DOM EST
       on   EST.CODARQ = 'INV '
       and  EST.NOMCPO = 'FLGEST'
       and  INV.FLGEST = EST.CODCHR
;


/*-- SEQ 2117 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EIOR CASCADE;

/*-- SEQ 2118 --*/
CREATE OR REPLACE VIEW TV_EIOR AS
 SELECT IOR.CODFIL,
        IOR.TIPPED,
        IOR.NUMPED,
        IOR.NUMITE,
        IOR.ORDITE,
        IOR.FLGEST,
        IOR.PROMOC,
        IOR.FILMAT,
        IOR.CODMAT,
        IOR.CODCOR,
        IOR.CODTAM,
        IOR.FILRES,
        IOR.ATU_EM,
        IOR.QTDENT,
        IOR.QTDITE,
        IOR.VLRCUS,
        IOR.VLRENT,
        IOR.VLRITE,
        IOR.VLRPGT,
        IOR.MONTAR,
        IOR.FILUSU,
        IOR.CODUSU,
        IOR.FILIVE,
        IOR.SEQIVE,
        IOR.NUMIVE,
        IOR.FILPAR,
        IOR.CODPAR,
        IOR.TIPPAR,
        IOR.FILFOR,
        IOR.CODFOR,
        IOR.NUMFOR,
        IOR.ENTREG,
        IOR.PREUNI,
        IOR.PHOISO,
        IOR.PHOMAR,
        IOR.PHOOUT,
        IOR.PHOTIP,
        IOR.RESULT,
        IOR.APLICA,
        IOR.REPETE,
        IOR.PERIOD,
        IOR.DIADUR,
        IOR.CODMUL,
        IOR.CODAMB,
        IOR.SERITE,
        IOR.FILRCT,
        IOR.SEQRCT,
        IOR.QTDPRE,
        IOR.FILDOU,
        IOR.SEQDOU,
        IOR.CODTER,
        IOR.FILEQP,
        IOR.SEQEQP,
        IOR.OBSERV,
        IOR.FILORI,
        IOR.TIPORI,
        IOR.NUMORI,
        IOR.ITEORI,
        IOR.TIPPGT,
        IOR.DATINC,
        IOR.PERIPI,
        IOR.TIPENT,
        IOR.FLGIVO,
        IOR.FILEND,
        IOR.NUMEND,
        IOR.COOVEN,
        IOR.FLGENC,
        IOR.QTDORI,
        IOR.CONCLU,
        IOR.DESCON,
        IOR.ECFVEN,
        IOR.FILLOT,
        IOR.SEQLOT,
        IOR.PERENT
        FROM TT_IOR IOR
;


/*-- SEQ 2119 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EKIT CASCADE;

/*-- SEQ 2120 --*/
CREATE OR REPLACE VIEW TV_EKIT AS
SELECT GRA1.CODEXT AS CODKIT, GRA2.CODEXT, KIT.BRINDE, KIT.FLGIMP, KIT.QTDITE AS NUMITE,
       0 AS STATUS, TO_CHAR(' ') AS DATIMP,TO_CHAR(' ') AS MOTREJ,
	   PRO.ATU_EM
  FROM TT_KIT KIT  LEFT JOIN TT_GRA GRA1 ON GRA1.FILMAT = KIT.FILITE
                                        AND GRA1.CODMAT = KIT.CODITE
                                        AND GRA1.CODTAM = KIT.TAMITE
                                        AND GRA1.CODCOR = KIT.CORITE
                   LEFT JOIN TT_GRA GRA2 ON GRA2.FILMAT = KIT.FILMAT
                                        AND GRA2.CODMAT = KIT.CODMAT
                                        AND GRA2.CODTAM = KIT.CODCOR
                                        AND GRA2.CODCOR = KIT.CODTAM
                  INNER JOIN TT_PRO PRO ON KIT.FILMAT = PRO.FILMAT
                                       AND KIT.CODMAT = PRO.CODMAT;


/*-- SEQ 2121 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ELAN CASCADE;

/*-- SEQ 2122 --*/
CREATE OR REPLACE VIEW TV_ELAN AS
SELECT GRA.CODEXT, LAN.CODFIL, DMUL.DESMUL AS DESEST, LAN.DATMOV, LAN.DOCUME,
       LAN.NUMEXT, LAN.QTDMOV, LAN.TIPLAN,  LAN.TIPMOV, LAN.VLRMOV, LAN.ATU_EM,
	   REPLACE(LAN.OBSERV,';','\;') AS OBSERV, 0 AS STATUS, TO_CHAR(' ') AS DATIMP,TO_CHAR(' ') AS MOTREJ,
       PRO.REFBAS, GRA.REFPRO, GRA.CODFIS, GRA.FILMAT AS GRA_FILMAT, GRA.CODMAT AS GRA_CODMAT,
       GRA.CODCOR AS GRA_CODCOR, GRA.CODTAM AS GRA_CODTAM, LAN.EMBORI, LAN.EMBQTD, NCM.CODEXT AS NCM_CODEXT,
       LAN.FILLOT, LAN.SEQLOT, LAN.SEQUEN, LAN.EXPORT
  FROM TT_GRA GRA INNER JOIN TT_PRO PRO  ON PRO.FILMAT = GRA.FILMAT
                                        AND PRO.CODMAT = GRA.CODMAT
                  INNER JOIN TT_LAN LAN  ON GRA.FILMAT = LAN.FILMAT
                                        AND GRA.CODMAT = LAN.CODMAT
                                        AND GRA.CODCOR = LAN.CODCOR
                                        AND GRA.CODTAM = LAN.CODTAM
                  INNER JOIN TD_MUL DMUL ON LAN.CODMUL = DMUL.CODTAB
                  INNER JOIN TD_LAN DLAN ON LAN.TIPLAN = DLAN.CODTAB
                   LEFT JOIN TT_NCM NCM  ON PRO.CODNCM = NCM.CODNCM;


/*-- SEQ 2123 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ELIM CASCADE;

/*-- SEQ 2124 --*/
CREATE OR REPLACE VIEW TV_ELIM AS
SELECT CLI.CODEXT, LIM.LIMCCC, DCCC.DESCCC AS TIPCCC, REPLACE(LIM.OBSERV,';','\;') AS OBSERV,
       0 AS STATUS, TO_CHAR(' ') AS DATIMP,TO_CHAR(' ') AS MOTREJ,
	   CLI.ATU_EM
  FROM TT_LIM LIM INNER JOIN TT_CLI CLI ON CLI.FILCLI = LIM.FILCLI
                                        AND CLI.CODCLI = LIM.CODCLI
                   LEFT JOIN TD_CCC DCCC ON LIM.TIPCCC = DCCC.CODTAB;


/*-- SEQ 2125 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EMOV CASCADE;

/*-- SEQ 2126 --*/
CREATE OR REPLACE VIEW TV_EMOV AS
SELECT LAN.DOCUME, LAN.CODFIL, 0 AS NUMITE,
       LAN.FILMAT, LAN.CODMAT, LAN.CODCOR,
       LAN.CODTAM, LAN.CODMUL, LAN.DATMOV, LAN.ATU_EM,
       LAN.QTDMOV, LAN.VLRMOV, LAN.FILUSU,
       LAN.CODUSU, LAN.TIPMOV, LAN.NUMEXT,
       LAN.SITMOV, DLAN.DESLAN AS NATURE,
       LAN.EMBORI, LAN.EMBQTD, 
       CAST('S' AS VARCHAR(1)) AS LANEST,
       LAN.QTDMOV AS QTD_CM,
       CUSTOMEDIO(LAN.CODFIL,LAN.FILMAT,LAN.CODMAT,LAN.CODCOR,LAN.CODTAM,3,LAN.DATMOV)*LAN.QTDMOV AS FIS_CM,
       CUSTOMEDIO(LAN.CODFIL,LAN.FILMAT,LAN.CODMAT,LAN.CODCOR,LAN.CODTAM,5,LAN.DATMOV)*LAN.QTDMOV AS GER_CM,
       LAN.DATINC,
       CAST(NULL AS CHAR(3)) AS FILCLI,
       CAST(NULL AS CHAR(6)) AS CODCLI, 
       LAN.SEQUEN,
       DLAN.SINLAN AS SINMOV,
       GRA.CODEXT AS CODGRA,
       CAST(NULL AS VARCHAR(20)) AS CODDEP,
       CAST(NULL AS VARCHAR(20)) AS CODPAR,
       PRO.REFBAS, GRA.REFPRO, GRA.CODFIS,
       NCM.CODEXT AS NCM_CODEXT  
  FROM TD_LAN DLAN INNER JOIN TT_LAN LAN ON DLAN.CODTAB = LAN.TIPLAN
                   INNER JOIN TT_GRA GRA ON GRA.FILMAT = LAN.FILMAT AND GRA.CODMAT = LAN.CODMAT
                                        AND GRA.CODCOR = LAN.CODCOR AND GRA.CODTAM = LAN.CODTAM  
                   INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
                    LEFT JOIN TT_NCM NCM ON PRO.CODNCM = NCM.CODNCM
UNION ALL
SELECT COALESCE(COM.FILFOR ,'')||'-'||COALESCE(COM.CODFOR ,'')||'/'||
       COALESCE(COM.CODSER ,'')||'-'||COALESCE(COM.NUMNOT ,'') AS DOCUME,
       ICO.CODFIL, ICO.NUMITE,
       ICO.FILMAT, ICO.CODMAT, ICO.CODCOR,
       ICO.CODTAM, ICO.CODMUL, ICO.COM_DATOPE AS DATMOV,
       COM.ATU_EM, ICO.QTDMOV, ICO.VLRMOV,
       COM.FILUSU, COM.CODUSU, 
       CAST('C' AS VARCHAR(1)) AS TIPMOV,
       CAST(NULL AS VARCHAR(1)) AS NUMEXT, 
       ICO.SITMOV, 
       NaturezaItemCompra(ICO.CODFIL, ICO.SEQUEN, ICO.NUMITE) AS NATURE,
       ICO.EMBORI, ICO.EMBQTD, ICO.LANEST,
       CASE WHEN ICO.SITMOV <> 'C' AND ICO.LANEST NOT IN ('R','N') AND COALESCE(ICO.QTD_CM,0) <> 0 THEN ICO.QTD_CM ELSE 0 END AS QTD_CM,
       CASE WHEN ICO.SITMOV <> 'C' AND ICO.LANEST NOT IN ('R','N') AND COALESCE(ICO.QTD_CM,0) <> 0 THEN ICO.VLR_CM ELSE 0 END AS FIS_CM,
       CASE WHEN ICO.SITMOV <> 'C' AND ICO.LANEST NOT IN ('R','N') AND COALESCE(ICO.QTD_CM,0) <> 0 THEN ICO.VLRCMG ELSE 0 END AS GER_CM,
       ICO.DATINC,
       COM.FILFOR AS FILCLI,
       COM.CODFOR AS CODCLI, 
       COM.SEQUEN,
       CAST('+' AS CHAR(1)) AS SINMOV,
       GRA.CODEXT AS CODGRA,
       CAST(NULL AS VARCHAR(20)) AS CODDEP,
       CLI.CODEXT AS CODPAR,
       PRO.REFBAS, GRA.REFPRO, GRA.CODFIS,
       NCM.CODEXT AS NCM_CODEXT  
  FROM TT_COM COM INNER JOIN TT_ICO ICO ON COM.CODFIL = ICO.CODFIL AND COM.SEQUEN = ICO.SEQUEN
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = ICO.FILMAT AND GRA.CODMAT = ICO.CODMAT
                                       AND GRA.CODCOR = ICO.CODCOR AND GRA.CODTAM = ICO.CODTAM  
                  INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
                  INNER JOIN TT_CLI CLI ON COM.FILFOR = CLI.FILCLI AND COM.CODFOR = CLI.CODCLI
                   LEFT JOIN TT_NCM NCM ON PRO.CODNCM = NCM.CODNCM
 WHERE ICO.LANEST IN ('S', 'C')
   AND COALESCE(COM.FINNFE,'0') <> '2'--Desconsidera nota complementar
UNION ALL
SELECT COALESCE(VEN.NUMECF ,'')||'-'||COALESCE(VEN.CODSER ,'')||'/'||
       COALESCE(VEN.NUMNOT ,'')|| '     ' AS DOCUME,
       IVE.CODFIL, IVE.NUMITE,
       IVE.FILMAT, IVE.CODMAT, IVE.CODCOR,
       IVE.CODTAM, IVE.CODMUL, IVE.VEN_DATHOR AS DATMOV,
       VEN.ATU_EM, IVE.QTDMOV,
       IVE.VLRMOV,
       VEN.FILUSU, VEN.CODUSU, CAST('V' AS VARCHAR(1)) AS TIPMOV,
       IVE.NUMEXT, IVE.SITMOV, NAT.NATURE,
       IVE.EMBORI, IVE.EMBQTD, IVE.LANEST, 
       CASE WHEN IVE.SITMOV <> 'C' AND IVE.LANEST NOT IN ('R','N') AND COALESCE(IVE.QTD_CM,0) <> 0 THEN IVE.QTD_CM ELSE 0 END AS QTD_CM,
       CASE WHEN IVE.SITMOV <> 'C' AND IVE.LANEST NOT IN ('R','N') AND COALESCE(IVE.QTD_CM,0) <> 0 THEN 
           CASE WHEN COALESCE(IVE.TOT_CM,0) <> 0 AND COALESCE(IVE.SAL_CM,0) <> 0 THEN 
                ive.tot_cm/ive.sal_cm*ive.qtd_cm
           ELSE
                CUSTOMEDIO(IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,3,IVE.VEN_DATHOR)*IVE.QTD_CM
           END
       ELSE 
           0 
       END AS FIS_CM,
       CASE WHEN IVE.SITMOV <> 'C' AND IVE.LANEST NOT IN ('R','N') AND COALESCE(IVE.QTD_CM,0) <> 0 THEN 
           CASE WHEN COALESCE(IVE.TOTCMG,0) <> 0 AND COALESCE(IVE.SAL_CM,0) <> 0 THEN 
                ive.totcmg/ive.sal_cm*ive.qtd_cm
           ELSE
                CUSTOMEDIO(IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,5,IVE.VEN_DATHOR)*IVE.QTD_CM
           END
       ELSE 
           0 
       END AS GER_CM,
       IVE.DATINC,
       VEN.FILCLI,
       VEN.CODCLI,
       VEN.SEQUEN,       
       CAST(CASE WHEN VEN.VLRLIQ > 0 THEN '-' ELSE '+' END AS CHAR(1)) AS SINMOV,
       GRA.CODEXT AS CODGRA,
       IVE.NUMEXT_DEP AS CODDEP,
       CLI.CODEXT AS CODPAR,
       PRO.REFBAS, GRA.REFPRO, GRA.CODFIS,
       NCM.CODEXT AS NCM_CODEXT 
  FROM TT_IVE IVE INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL 
                                       AND VEN.SEQUEN = IVE.SEQUEN
                  INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = IVE.FILMAT AND GRA.CODMAT = IVE.CODMAT
                                       AND GRA.CODCOR = IVE.CODCOR AND GRA.CODTAM = IVE.CODTAM
                  INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT                     
                  INNER JOIN TT_CLI CLI ON VEN.FILCLI = CLI.FILCLI AND VEN.CODCLI = CLI.CODCLI
                   LEFT JOIN TT_NCM NCM ON PRO.CODNCM = NCM.CODNCM
 WHERE IVE.SITKIT <> '1'
   AND IVE.LANEST IN ('S', 'C');


/*-- SEQ 2127 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ENAT CASCADE;

/*-- SEQ 2128 --*/
CREATE OR REPLACE VIEW TV_ENAT AS
SELECT NAT.TIPNAT, NAT.FINANC, NAT.MOVEST, NAT.NATATI, NAT.NATOLN,
       NAT.TRIBUT, NAT.USACUS, NAT.NATRED, NAT.NATREF, NAT.LIMITE,
       NAT.USAICM, NAT.USAIPI, NAT.LANVEN, NAT.SERVIN, NAT.NATDEN,
       NAT.NATFOR, NAT.NATFUD, NAT.NATFUF, NAT.NATURE, NAT.COMENT,
       REPLACE(NAT.OBSERV,';','\;') AS OBSERV, NAT.EXTDEM, NAT.EXTFOR, 
       NAT.NATMUL, NAT.CONSFI, NAT.NATRED_ST, NAT.NATREF_ST,
       0 AS STATUS, TO_CHAR(' ') AS DATIMP, TO_CHAR(' ') AS MOTREJ
   FROM TD_NAT NAT;


/*-- SEQ 2129 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ENC_NSU CASCADE;

/*-- SEQ 2130 --*/
CREATE OR REPLACE VIEW TV_ENC_NSU AS
SELECT CODFIL,
       NUMTAN,
       DATMED,
       ENCABE,
       ENCFEC,
       CODTAN,
       FILTAN,
       FILMAT,
       CODMAT,
       CODCOR,
       CODTAM,
       CODBIC,
       BOMBA,
       BICO,
       IVE_CODFIL,
       IVE_SEQUEN,
       IVE_NUMITE
FROM (
select TAB.CODFIL,
       TAB.NUMTAN,
       TAB.DATMED,
       TAB.ENCABE,
       TAB.ENCFEC,
       TAB.CODTAN,
       TAB.FILTAN,
       TAB.FILMAT,
       TAB.CODMAT,
       TAB.CODCOR,
       TAB.CODTAM,
       TAB.CODBIC,
       TAB.BOMBA,
       TAB.BICO,
       TAB.IVE_CODFIL, 
       TAB.IVE_SEQUEN,
       TAB.IVE_NUMITE,
       CASE WHEN ENCABE<ENCFEC AND IVEENC BETWEEN ENCABE+0.01 AND ENCFEC THEN 1
                                    	              WHEN ENCABE>ENCFEC AND (IVEENC BETWEEN ENCABE+TAB.QTDMOV AND 9999999999999999 OR 
                                    		                        IVEENC BETWEEN 0 AND ENCFEC ) THEN 1
                                                          ELSE 0
       END AS EXIBIR
from (select MDT.CODFIL,
             MDT.NUMTAN,
             MDT.DATMED,
             Encerrante(MDT.CODFIL,MDT.NUMTAN,add_day(MDT.DATMED,-1),BIC.CODTAB) AS ENCABE,
             Encerrante(MDT.CODFIL,MDT.NUMTAN,MDT.DATMED,BIC.CODTAB) AS ENCFEC,
             TAN.CODTAB AS CODTAN,
             TAN.FILTAN,
             TAN.GRAFIL AS FILMAT,
             TAN.GRACOD AS CODMAT,
             TAN.GRACOR AS CODCOR,
             TAN.GRATAM AS CODTAM,
             BIC.CODTAB AS CODBIC,
             BOM.NUMBOM AS BOMBA,
             BIC.SEQFIL AS BICO,
             BIC.FILBIC,
             BIC.SEQFIL,
             IVE.CODFIL AS IVE_CODFIL,
             IVE.SEQUEN AS IVE_SEQUEN,
             IVE.NUMITE AS IVE_NUMITE,
             TO_NUMBER(COALESCE(IVE.NUMEXT,'0'))/1000 AS IVEENC,
             IVE.QTDMOV
        FROM TT_MDT MDT INNER JOIN TD_TAN TAN ON MDT.NUMTAN=TAN.TANQUE
                        INNER JOIN TD_BIC BIC ON BIC.CODTAN=TAN.CODTAB
                        INNER JOIN TD_BOM BOM ON BOM.CODTAB = BIC.CODBOM
                        INNER JOIN TT_IVE IVE ON IVE.VEN_DATHOR BETWEEN ADD_DAY(MDT.DATMED,-1) AND ADD_DAY(MDT.DATMED,+1) 
                                             AND IVE.FILBIC=BIC.FILBIC 
                                             AND IVE.SEQFIL=BIC.SEQFIL                                             
                                             AND IVE.SITMOV <> 'C'
                                             AND IVE.LANEST='S'
      ) tab 
) INT
WHERE EXIBIR=1
 ;


/*-- SEQ 2131 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ENT CASCADE;

/*-- SEQ 2132 --*/
CREATE OR REPLACE VIEW TV_ENT AS
SELECT VEN.CODFIL AS CODFIL, 
       VEN.SEQUEN AS SEQUEN,
       VEN.NUMECF AS NUMECF,
       VEN.CODSER AS CODSER,
       VEN.NUMNOT AS NUMNOT,
       IVEDEST.ITEORI AS NUMITE,
       SUM(COALESCE(IVEDEST.QTDMOV,0)) AS QTDENT
FROM TT_VEN VEN INNER JOIN  TT_IVE IVEINT ON VEN.CODFIL = IVEINT.CODFIL
                                         AND VEN.SEQUEN = IVEINT.SEQUEN
                INNER JOIN TT_IVE IVEDEST ON IVEINT.CODFIL = IVEDEST.FILORI
                                         AND IVEINT.SEQUEN = IVEDEST.NUMORI
                                         AND IVEINT.NUMITE = IVEDEST.ITEORI
GROUP BY VEN.CODFIL, VEN.SEQUEN, VEN.NUMECF, VEN.CODSER, VEN.NUMNOT,
         IVEDEST.FILORI, IVEDEST.NUMORI, IVEDEST.ITEORI
 ;







/*-- SEQ 2133 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EPAG CASCADE;

/*-- SEQ 2134 --*/
CREATE OR REPLACE VIEW TV_EPAG AS
SELECT COM.CODFIL, COM.SEQUEN, COM.NUMNOT, COM.CODSER, CLI.CODEXT AS CODFOR, PAG.NUMPAR,
       PAG.SUBPAR, PAG.FLGEST, PAG.DATVEN, AUT.CODEXT AS CODAUT, USU.CODEXT AS CODUSU,
       PRO.CODEXT AS CODPRO, PAG.ATU_EM, PAG.DATPGT, PAG.VLRPAR, COALESCE(PAG.VLRPGT,0) AS VLRPGT,
       PAG.DATINC, DOP.CODFIL AS FILDOP, DOP.SEQUEN AS SEQDOP, PAG.DATPRX, PAG.VLRDES, PAG.VLRDIF,
	   PAG.CODBCO, PAG.SIGNAT, PAG.CONPGT, PAG.DOCPGT, 0 AS STATUS, TO_CHAR(' ') AS DATIMP,TO_CHAR(' ') AS MOTREJ,
       PAG.RENEGO, PAG.RENORI, CLI.NOMCLI AS NOMFOR,
       CTACOM.CODEXT AS CTACOM,
       CTAPAG.CODEXT AS CTAPAG,
       ( SELECT CTA.CODEXT
           FROM TT_CTA CTA 
          WHERE CTA.CODFIL = DOP.FILCTA AND CTA.SEQUEN = DOP.SEQCTA AND CTA.TIPCTA = DOP.TIPCTA          
       ) AS CTADOP,
       DOP.OBSERV AS OBSERV,
       DOP.CODEXT AS DOP_CODEXT
  FROM TT_COM COM INNER JOIN TT_PAG PAG ON PAG.CODFIL = COM.CODFIL AND PAG.SEQUEN = COM.SEQUEN
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = COM.FILFOR AND CLI.CODCLI = COM.CODFOR
                   LEFT JOIN TR_FIN RFIN ON RFIN.ORIGEM='COM' AND RFIN.CODFIL=COM.CODFIL AND RFIN.SEQUEN=COM.SEQUEN AND RFIN.TIPLAN IN ('FAT','FRE','COM','TIT')
                   LEFT JOIN TT_CTA CTACOM ON RFIN.FILCTA = CTACOM.CODFIL AND RFIN.SEQCTA=CTACOM.SEQUEN
                   LEFT JOIN TT_CTA CTAPAG ON RFIN.FILCRT = CTAPAG.CODFIL AND RFIN.SEQCRT=CTAPAG.SEQUEN                   
                   LEFT JOIN TT_USU USU ON USU.FILUSU = PAG.FILUSU AND USU.CODUSU = PAG.CODUSU
                   LEFT JOIN TT_USU AUT ON AUT.FILUSU = PAG.FILAUT AND AUT.CODUSU = PAG.CODAUT
                   LEFT JOIN TT_USU PRO ON PRO.FILUSU = PAG.FILPRO AND PRO.CODUSU = PAG.CODPRO
                   LEFT JOIN TT_DOP DOP ON DOP.CODFIL = PAG.FILDOP AND DOP.SEQUEN = PAG.SEQDOP;


/*-- SEQ 2135 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EPAR CASCADE;

/*-- SEQ 2136 --*/
CREATE OR REPLACE VIEW TV_EPAR AS
SELECT CLI.CODEXT,CLI.FILCLI,CLI.CODCLI,CLI.DATOPE,CLI.NOMCLI,CLI.ULTNOM,CLI.TIPDOC AS CTIPDOC,
DDOC.DESDOC AS DTIPDOC,CLI.INSEST,CLI.NUMDOC,CLI.DATNAS,CLI.ESTCIV,CLI.FLGTIP,CLI.CODSEX,DCT1.NOMCT1 AS CATEG1,
DCT2.NOMCT2 AS CATEG2,DCT3.NOMCT3 AS CATEG3,CLI.OBSERV,CASE WHEN CLI.SIGNAT >= 0 THEN 'T' ELSE 'F' END AS ATIVO,
DINA.DESINA,CLI.ICM_CF,CLI.CALL_C,CLI.PORPAD,CLI.CONJUG,CLI.NASCON,CLI.SEXCON,CLI.DOCCON,CLI.DDTCON,TRIM(CLI.TELCON) AS TELCON,
CLI.DDCCON,TRIM(CLI.CELCON) AS CELCON,CLI.E_MCON,CLI.NOMTRA,CLI.ID_ORG,CLI.ID_EST,CLI.ID_DAT,CLI.VALOR1 AS LIMCRE,
PLA.CODEXT AS CODPLA,USU.APEUSU AS APEVEN,JUG.CODEXT AS CODCON,CLI.NAOSPC,CLI.CONBOL,VIN.CODEXT AS CODVIN,CLI.OBSOUT,
CLI.SIMPLE,CLI.HOMPGE,CLI.DATA01,CLI.DATA02,CLI.DATA03, CASE WHEN REL1.TIPPAR IS NULL THEN 'F' ELSE 'T' END AS TIPCLI1,
CASE WHEN REL2.TIPPAR IS NULL THEN 'F' ELSE 'T' END AS TIPCLI2,CASE WHEN REL3.TIPPAR IS NULL THEN 'F' ELSE 'T' END AS TIPCLI3,
CASE WHEN REL4.TIPPAR IS NULL THEN 'F' ELSE 'T' END AS TIPCLI4,CASE WHEN REL5.TIPPAR IS NULL THEN 'F' ELSE 'T' END AS TIPCLI5,
CASE WHEN REL6.TIPPAR IS NULL THEN 'F' ELSE 'T' END AS TIPCLI6,CASE WHEN REL7.TIPPAR IS NULL THEN 'F' ELSE 'T' END AS TIPCLI7,
CASE WHEN REL8.TIPPAR IS NULL THEN 'F' ELSE 'T' END AS TIPCLI8,CASE WHEN REL9.TIPPAR IS NULL THEN 'F' ELSE 'T' END AS TIPCLI9,
CASE WHEN REL0.TIPPAR IS NULL THEN 'F' ELSE 'T' END AS TIPCLI10,TO_CHAR(' ') AS FILECO,
TO_CHAR(' ') AS NUMECO, TO_CHAR(' ') AS TIPCON,
TO_CHAR(' ') AS TIPPES,SPC.NACION,SPC.CIDNAS,SPC.DDDCEL AS CELDDD,SPC.NUMCEL AS CELNUM,SPC.E_MAIL AS MAISPC,
SPC.ATUMES,SPC.CASMES,SPC.FIRATU,SPC.NUMCOD,SPC.NUMTEL,SPC.NOMSUP,SPC.ENDERE AS ENDSPC,SPC.COMPLE AS COMSPC,SPC.SALBAS,
DOCU.DESOCU,SPC.FIRANT,SPC.ANTMES,SPC.CARPRO,SPC.SERCAR,SPC.NOMLO1,SPC.ENDLO1,SPC.NOMLO2,SPC.ENDLO2,SPC.TIPRES,SPC.ALUFIN,
SPC.MORMES,SPC.CON_TC,SPC.CONSPC,SPC.CON_LT,SPC.CON_LR,SPC.CARLOJ,SPC.TEMAUT,SPC.TEM_CC,SPC.TEM_TC,SPC.NUMDEP,SPC.ORIRED,
SPC.VLRRED,SPC.RGCONJ,SPC.CONOCU,SPC.NUMCOC,SPC.TELCON AS TELSPC,SPC.FIRCON,SPC.ENDCO1,SPC.ENDCO2,SPC.CANMES,SPC.SALBAC,
SPC.CARPRC,SPC.SERCAC,0 AS STATUS, TO_CHAR(' ') AS DATIMP,TO_CHAR(' ') AS MOTREJ,CLI.ATU_EM,IED.ULTEXP,CLI.CODPAI,CLI.CODCRC, CLI.LIMCHE,
CLI.ISENTO, CLI.DATCRE, CLI.VALLIM, CLI.PERVDD, CLI.SUFRAM
FROM TT_CLI CLI JOIN TT_IED IED ON IED.TABELA = 'CLI'
LEFT JOIN TD_CT1 DCT1 ON DCT1.CODTAB = CLI.CATEG1
LEFT JOIN TD_CT2 DCT2 ON DCT2.CODTAB = CLI.CATEG2
LEFT JOIN TD_CT3 DCT3 ON DCT3.CODTAB = CLI.CATEG3
LEFT JOIN TD_INA DINA ON DINA.CODTAB = CLI.CODINA
LEFT JOIN TD_DOC DDOC ON DDOC.TIPDOC = CLI.TIPDOC
LEFT JOIN TT_USU USU ON USU.FILUSU = CLI.FILVEN AND USU.CODUSU = CLI.CODVEN
LEFT JOIN TT_SPC SPC ON SPC.FILCLI = CLI.FILCLI AND SPC.CODCLI = CLI.CODCLI
LEFT JOIN TD_OCU DOCU ON DOCU.CODTAB = SPC.CODOCU
LEFT JOIN TT_CLI VIN ON VIN.FILCLI = CLI.FILVIN AND VIN.CODCLI = CLI.CODVIN
LEFT JOIN TT_CLI JUG ON JUG.FILCLI = CLI.FILCON AND JUG.CODCLI = CLI.CODCON
LEFT JOIN TT_PLA PLA ON PLA.FILPGT = CLI.FILPLA AND PLA.CODPGT = CLI.CODPLA
LEFT JOIN TT_REL REL1 ON REL1.FILPAR = CLI.FILCLI AND REL1.CODPAR = CLI.CODCLI AND REL1.TIPPAR = 'M'
LEFT JOIN TT_REL REL2 ON REL2.FILPAR = CLI.FILCLI AND REL2.CODPAR = CLI.CODCLI AND REL2.TIPPAR = 'F'
LEFT JOIN TT_REL REL3 ON REL3.FILPAR = CLI.FILCLI AND REL3.CODPAR = CLI.CODCLI AND REL3.TIPPAR = 'T'
LEFT JOIN TT_REL REL4 ON REL4.FILPAR = CLI.FILCLI AND REL4.CODPAR = CLI.CODCLI AND REL4.TIPPAR = 'A'
LEFT JOIN TT_REL REL5 ON REL5.FILPAR = CLI.FILCLI AND REL5.CODPAR = CLI.CODCLI AND REL5.TIPPAR = 'R'
LEFT JOIN TT_REL REL6 ON REL6.FILPAR = CLI.FILCLI AND REL6.CODPAR = CLI.CODCLI AND REL6.TIPPAR = 'I'
LEFT JOIN TT_REL REL7 ON REL7.FILPAR = CLI.FILCLI AND REL7.CODPAR = CLI.CODCLI AND REL7.TIPPAR = 'O'
LEFT JOIN TT_REL REL8 ON REL8.FILPAR = CLI.FILCLI AND REL8.CODPAR = CLI.CODCLI AND REL8.TIPPAR = 'N'
LEFT JOIN TT_REL REL9 ON REL9.FILPAR = CLI.FILCLI AND REL9.CODPAR = CLI.CODCLI AND REL9.TIPPAR = 'X'
LEFT JOIN TT_REL REL0 ON REL0.FILPAR = CLI.FILCLI AND REL0.CODPAR = CLI.CODCLI AND REL0.TIPPAR = 'C'
WHERE (CLI.FILCLI||CLI.CODCLI <> (SELECT VC_FILCLI||VC_CODCLI FROM TT_CFG))
;


/*-- SEQ 2137 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EPED CASCADE;

/*-- SEQ 2138 --*/
CREATE OR REPLACE VIEW TV_EPED AS
SELECT PED.CODFIL, PED.NUMPED, 
       CASE WHEN PED.CODFOR = '0' THEN '0' ELSE '1' END AS FLGTIP,
       PED.FLGEST, PED.TIPFOR, PED.CODUSU, PED.FILFOR, PED.FILUSU, PED.CODFOR, PED.CODMOE, PED.CODAPR, PED.FILAPR, 
       PED.ATU_EM, PED.DATENT, PED.DATPED, COALESCE(PED.DESCON,0) AS DESCON, COALESCE(PED.OUTTAX,0) AS OUTTAX, 
       COALESCE(PED.QTDTOT,0) AS QTDTOT, PED.VLRLIQ, PED.VLRTOT, PED.SIGNAT, 
       COALESCE(PED.VLRBON,0) AS VLRBON, PED.CONPGT, 
              REPLACE(PED.OBSERV,';',E'\;') AS OBSERV,	   PED.PEDFOR, PED.VENENT, PED.PEDEXT, PED.CONVEN, PED.FILEND, PED.NUMEND, PED.PROMOC, PED.DATENV, 
       PED.NOMARQ, PED.CODCON, PED.ATUPED, PED.CODDOP, COALESCE(PED.DESESP,0) AS DESESP,  
       COALESCE(PED.VLRFRE,0) AS VLRFRE, 
       PED.FREORI, CLI.CODEXT AS CLI_CODEXT
  FROM TT_PED PED INNER JOIN TT_CLI CLI ON CLI.FILCLI = PED.FILFOR 
                                       AND CLI.CODCLI = PED.CODFOR
;                                       
                                       


/*-- SEQ 2139 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EPLA CASCADE;

/*-- SEQ 2140 --*/
CREATE OR REPLACE VIEW TV_EPLA AS
SELECT PLA.FILPGT, PLA.PREINF, PLA.ATU_EM, PLA.DATMAX, PLA.DATMIN, PLA.ABAMAX,
       PLA.ABAMIN, PLA.ACRDIA, PLA.DE1IDE, PLA.DE1MAX, PLA.DE1MIN, PLA.DESANT,
       PLA.PERCOM, PLA.PERENT, PLA.VLRMAX, PLA.VLRMIN, PLA.APLICA, DMOE1.DESMOE AS CODMOE,
       DMOE2.DESMOE AS MOECOR, PLA.ATRMAX, PLA.CARMAX, PLA.CODCOB, PLA.COMSOB, PLA.DIAANT,
       PLA.FLGJUR, PLA.FORMUL, PLA.MEDMAX, PLA.NIVUSU, PLA.NROMES, PLA.PARIDE,
       PLA.PARMAX, PLA.PARMIN, PLA.PARVEN, PLA.PERIOD, PLA.PORDEM, PLA.PORENT,
       PLA.PRAIDE, PLA.PRAMAX, PLA.PRAMIN, PLA.PRIIDE, PLA.PRIMAX, PLA.PRIMIN,
       PLA.PZOIDE, PLA.PZOMAX, PLA.PZOMIN, PLA.SIGNAT, PLA.TIPPLA, PLA.TOTLIM,
       PLA.CARONL, PLA.ENTVLR, PLA.FATURA, PLA.FLGESP, PLA.JURTOT, PLA.APEPGT,
       PLA.DESPGT, PLA.DATPRE, DCL1.CLASS1, DCL2.CLASS2, DCL3.CLASS3, DCL4.CLASS4,
       PLA.CODEXT, PLA.TIPCOB, PLA.USACAM, PLA.USACRE, PLA.USAOUT, PLA.USACHE,
       PLA.USADIN, PLA.USATEF, PLA.USAC_C, PLA.PROPOR, PLA.CODPRT, PLA.PRZPRT,
       PLA.CODBAI, PLA.PRZBAI, PLA.CHRREC, PLA.DESREC, PLA.RENEGO, PLA.JURREN,
       PLA.RENSOB, PLA.DESJUR, PLA.DIATIT, PLA.VLTXMU, PLA.INTPMU, PLA.USACPP,
       PLA.BONPGT, DNAT.NATDEN, DNAT.NATFOR, PLA.SOBNEG, PLA.MINPAR,
       PLA.INDDES,
       0 AS STATUS, TO_CHAR(' ') AS DATIMP,TO_CHAR(' ') AS MOTREJ
  FROM TT_PLA PLA INNER JOIN TD_MOE DMOE1 ON PLA.CODMOE = DMOE1.CODTAB
                  INNER JOIN TD_MOE DMOE2 ON PLA.MOECOR = DMOE2.CODTAB
                   LEFT JOIN TD_CL1 DCL1 ON DCL1.CODTAB = PLA.CLASS1
                   LEFT JOIN TD_CL2 DCL2 ON DCL2.CODTAB = PLA.CLASS2
                   LEFT JOIN TD_CL3 DCL3 ON DCL3.CODTAB = PLA.CLASS3
                   LEFT JOIN TD_CL4 DCL4 ON DCL4.CODTAB = PLA.CLASS4
                   LEFT JOIN TD_NAT DNAT ON DNAT.CODTAB = PLA.CODNAT;


/*-- SEQ 2141 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EPRE CASCADE;

/*-- SEQ 2142 --*/
CREATE OR REPLACE VIEW TV_EPRE AS
SELECT PRE.FILPRE AS CODFIL, PRE.PRECOV, TPR.DESPRE, GRA.CODEXT, DCT1.NOMCT1 AS CATEG1, DCT2.NOMCT2 AS CATEG2,
       DCT3.NOMCT3 AS CATEG3, 0 AS STATUS, TO_CHAR(' ') AS DATIMP,TO_CHAR(' ') AS MOTREJ,
       PRE.ULTREA, PRE.DESIDE, TPR.CODEXT AS PRE_CODEXT, TPR.FILDES, 
       PRE.FLGEST AS PRE_FLGEST, GRA.GRAATI AS GRA_GRAATI, CAST((CASE WHEN TPR.SIGNAT>=0 THEN 'T' ELSE 'F' END) AS CHAR(1)) AS TPR_ATIVO
  FROM TT_PRE PRE INNER JOIN TT_GRA GRA ON GRA.FILMAT = PRE.FILMAT
                                       AND GRA.CODMAT = PRE.CODMAT
                                       AND GRA.CODCOR = PRE.CODCOR
                                       AND GRA.CODTAM = PRE.CODTAM
                  INNER JOIN TT_TPR TPR ON TPR.CODFIL = PRE.FILPRE
                                       AND TPR.CODPRE = PRE.CODPRE
                   LEFT JOIN TD_CT1 DCT1 ON DCT1.CODTAB = TPR.CATEG1
                   LEFT JOIN TD_CT2 DCT2 ON DCT2.CODTAB = TPR.CATEG2
                   LEFT JOIN TD_CT3 DCT3 ON DCT3.CODTAB = TPR.CATEG3;


/*-- SEQ 2143 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EPRO CASCADE;

/*-- SEQ 2144 --*/
CREATE OR REPLACE VIEW TV_EPRO AS
SELECT GRA.CODEXT,PRO.FILMAT,PRO.CODMAT,PRO.REFBAS,PRO.DESMAT,PRO.ESPMAT, DCTR.CODTAB AS CODCTR,PRO.CONTRA,PRO.CONTRO,
       PRO.DESECF,FAB.CODEXT AS CODFAB, MAR.DESMAR, PRO.ENTREG,CASE WHEN PRO.SIGNAT >= 0 THEN 'T' ELSE 'F' END AS ATIVO,
       CASE WHEN PRO.SIGNAT >= 0 THEN NULL ELSE DINA.DESINA END AS DESINA,DCL1.CLASS1,DCL2.CLASS2,DCL3.CLASS3,DCL4.CLASS4,
       DDEP.DESDEP AS DEPART,DSAZ.DESSAZ AS SAZONA,PRO.TIPPRO, PRO.CLSXYZ,PRO.DATCAD,PRO.DECIMA,DETI.DESETI AS ETIQUE,PRO.SUBFED,
       PRO.NUMEXT,PRO.OBSERV,PRO.BRINDE,DGRA.NOMGRA AS DESGRA,PRO.MONTAR,PRO.NUMITE, PRO.RETCOF,DDIV.NOMDIV,DIV.NOMITE AS ITEDIV,
       DSUB.NOMSUB, SUB.NOMITE AS ITESUB,GRA.TIPVAL,GRA.VALIDA,GRA.VOLUNI,GRA.REFPRO,PRO.NOMIMG,GRA.MINQTD,GRA.PTOQTD, GRA.QTDREP,
       CASE WHEN PRO.BALSIM = 'T' THEN 0 ELSE GRA.PESLIQ END AS PESLIQ, GRA.PESBRU, GRA.PROMOC,GRA.PRECOM, GRA.DATCOM, GRA.CUSREP, GRA.TEMREP,GRA.DESMAX,GRA.DESIDE, GRA.PERLUC,
       GRA.PERCOM, GRA.LOCALI,MED1.UNIMED AS UNIDAD, MED2.UNIMED AS UNIFOR, GRA.VALCON, GRA.CUSFRE, GRA.CONAPL,GRA.QTDEMB, PRO.ICMFED,
       DAPL.UNIMED AS UNIAPL, DEMB.UNIMED AS UNIEMB, GRA.DESCOM, GRA.FORLIN, GRA.ICMCOM,GRA.ICMFRE, GRA.IPICOM, GRA.MARKUP,
       GRA.OBSERV AS OBSGRA,GRA.PREPSI, GRA.QTDCOM,GRA.SEGFRE,GRA.SUBCOM, GRA.TAXCOM,0.00 AS PRECOV,IUF.ESTADO,
       DICM.RESICM,DIES.ICMSES AS REDESP, DIME.ICMSME AS REDUME,DIRE.ICMSRE AS REDALI, DIRE.REDCON, DIRE.REDTRA,DIR1.ICMSR1 AS REDUC1, DIR2.ICMSR2 AS REDUC2,
       IUF.LUCSUB, IUF.SUBTRI,IUF.INSAGR,IUF.CALSUB,DTRI.CODTRI AS CODTRI, DCFP.DESCFP, IUF.REGESP,IUF.PERSRV, IUF.MVAVEN, IUF.MVAC07, IUF.MVAC12, DIPI.RESIPI,
       DIRR.RESIRR,TO_CHAR(' ') AS CAL_CM,0 AS STATUS, TO_CHAR(' ') AS DATIMP, TO_CHAR(' ') AS MOTREJ, PRO.ARRTRU, PRO.IIPTPR, PRO.CODSRV, PRO.CODFPS,
       PRO.ATU_EM, GRA.CODFIS, GRA.CODCOR, GRA.CODTAM, NCM.CODEXT AS NCM_CODEXT, RGC.FLGENC, PRO.CODNCM, PRO.CODENQ, PRO.CODCES, IUF.MVAC04,
       GRA.MAXPAR, GRA.DESGRA AS GRA_DESGRA,
       CAST(CASE WHEN DSUB.CODSAL IS NULL OR DSUB.CODSAL=GRA.CODTAM THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS EMBALAGEM, -- 102634 - Identificar os produtos com embalagem para integração Proton
       IUF.CODBEN_00, IUF.CODBEN_10, IUF.CODBEN_20, IUF.CODBEN_30, IUF.CODBEN_40, IUF.CODBEN_41, IUF.CODBEN_50, IUF.CODBEN_51, IUF.CODBEN_60, IUF.CODBEN_70, IUF.CODBEN_90,
       IUF.PERDIF, DICM.RESICM AS ALIDIF, IUF.REGDIF
  FROM TT_PRO PRO INNER JOIN TT_GRA GRA ON GRA.FILMAT = PRO.FILMAT AND GRA.CODMAT = PRO.CODMAT
                  INNER JOIN TT_DIV DIV ON DIV.CODITE = GRA.CODCOR
                  INNER JOIN TT_SUB SUB ON SUB.CODITE = GRA.CODTAM
                  INNER JOIN TD_DIV DDIV ON DDIV.CODTAB = DIV.CODDIV
                  INNER JOIN TD_SUB DSUB ON DSUB.CODTAB = SUB.CODSUB
                  INNER JOIN TD_CL1 DCL1 ON DCL1.CODTAB = PRO.CLASS1
                  INNER JOIN TD_CL2 DCL2 ON DCL2.CODTAB = PRO.CLASS2
                  INNER JOIN TD_CL3 DCL3 ON DCL3.CODTAB = PRO.CLASS3
                  INNER JOIN TD_CL4 DCL4 ON DCL4.CODTAB = PRO.CLASS4
                  INNER JOIN TD_DEP DDEP ON DDEP.CODTAB = PRO.DEPART
                  INNER JOIN TD_SAZ DSAZ ON DSAZ.CODTAB = PRO.CODSAZ
                  INNER JOIN TD_GRA DGRA ON DGRA.CODTAB = PRO.CODGRA
                  INNER JOIN TD_MED MED1 ON MED1.CODTAB = GRA.UNIDAD
                  INNER JOIN TD_MED MED2 ON MED2.CODTAB = GRA.UNIFOR
                  INNER JOIN TT_IUF IUF ON IUF.FILMAT = PRO.FILMAT AND IUF.CODMAT = PRO.CODMAT
                   LEFT JOIN TD_ICM DICM ON DICM.CODTAB = IUF.RESICM
                   LEFT JOIN TD_IES DIES ON DIES.CODTAB = IUF.REDESP
                   LEFT JOIN TD_IME DIME ON DIME.CODTAB = IUF.REDUME
                   LEFT JOIN TD_IRE DIRE ON DIRE.CODTAB = IUF.REDALI
                   LEFT JOIN TD_IR1 DIR1 ON DIR1.CODTAB = IUF.REDUC1
                   LEFT JOIN TD_IR2 DIR2 ON DIR2.CODTAB = IUF.REDUC2
                   LEFT JOIN TD_TRI DTRI ON DTRI.CODTAB = IUF.CODTRI
                   LEFT JOIN TD_IRR DIRR ON DIRR.CODTAB = PRO.RESIRR
                   LEFT JOIN TD_IPI DIPI ON DIPI.CODTAB = PRO.RESIPI
                   LEFT JOIN TD_MED DAPL ON DAPL.CODTAB = GRA.UNIAPL
                   LEFT JOIN TD_MED DEMB ON DEMB.CODTAB = GRA.UNIEMB
                   LEFT JOIN TD_INA DINA ON DINA.CODTAB = PRO.CODINA
                   LEFT JOIN TT_MAR MAR ON MAR.FILMAR = PRO.FILMAR AND MAR.CODMAR = PRO.CODMAR AND MAR.ITEMAR = PRO.ITEMAR
                   LEFT JOIN TT_REL REL ON REL.FILPAR = MAR.FILMAR AND REL.CODPAR = MAR.CODMAR AND REL.TIPPAR = MAR.TIPMAR
                   LEFT JOIN TT_CLI FAB ON FAB.FILCLI = REL.FILPAR AND FAB.CODCLI = REL.CODPAR
                   LEFT JOIN TD_CTR DCTR ON DCTR.CODTAB = PRO.CODCTR
                   LEFT JOIN TD_ETI DETI ON DETI.CODTAB = PRO.ETIQUE
                   LEFT JOIN TD_CFP DCFP ON DCFP.CODTAB = IUF.CODCFP
                   LEFT JOIN TT_NCM NCM ON PRO.CODNCM = NCM.CODNCM
                   LEFT JOIN TD_ICM DDIF ON DICM.CODTAB = IUF.ALIDIF
                  INNER JOIN TD_RGC RGC ON RGC.CODTAB = PRO.CODRGC;


/*-- SEQ 2145 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ERCAI CASCADE;

/*-- SEQ 2146 --*/
CREATE OR REPLACE VIEW TV_ERCAI AS
SELECT CAI.CODFIL, CAI.SEQUEN, CAI.NUMECF, CAI.CNT_RO, CAI.VLRFEC, 
       CAI.VLRDIF, CAI.CUPINI, CAI.CUPFIM, CAI.FILUSU, CAI.CODUSU, 
       CAI.DATOPE, CAI.DATABE, CAI.DATFEC,
       DECF.CODEXT_DECF, DECF.SERECF, 
       USU.APEUSU,
       RECF.CNT_RZ, RECF.GT_INI, RECF.GT_FIM, RECF.DATFEC AS RZ_DATFEC, RECF.DIAFEC AS RZ_DIAFEC, 
       RECF.CUPINI AS RZ_CUPINI, RECF.CUPFIM AS RZ_CUPFIM, RECF.INTERV 
FROM TR_CAI CAI INNER JOIN TT_USU USU  ON CAI.FILUSU = USU.FILUSU  
                                      AND CAI.CODUSU = USU.CODUSU
                INNER JOIN TD_ECF DECF ON CAI.NUMECF = DECF.NUMECF 
                                      AND CAI.CODFIL = DECF.FILECF
                INNER JOIN TR_ECF RECF ON CAI.CODFIL = RECF.CODFIL 
                                      AND CAI.NUMECF = RECF.NUMECF
                                      AND CAI.CNT_RO = RECF.CNT_RO
                                      AND CAI.DATOPE = RECF.DATOPE  
 ;


/*-- SEQ 2147 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EREC CASCADE;

/*-- SEQ 2148 --*/
CREATE OR REPLACE VIEW TV_EREC AS
SELECT VEN.CODFIL, VEN.NUMNOT, VEN.NUMECF, VEN.CODSER, REC.NUMPAR, REC.SUBPAR,
       REC.FLGEST, REC.ATU_EM, 
       coalesce(ITF.DATVEN,REC.DATVEN) AS DATVEN, 
       CHR.DATVEN AS CHR_DATVEN,
       REC.VLRPAR, DMOE.DESMOE AS CODMOE, 
       USU.CODEXT AS CODUSU, REC.FILREC, REC.NUMECF AS ECFREC, REC.CUPFIS, 
       COALESCE(ITF.DATPGT,REC.PAGAME) AS PAGAME, REC.VLRPGT, REC.PORTAD, REC.DATINC, REC.VLRDES, VEN.DATHOR AS DATFIS,
       REC.CODEXT, REC.CARTAO, CHR.CODBCO AS CHEBCO, CHR.CODAGE, CHR.NUMCHE, CHR.NUMCON, 
       REC.TIPCCC, REC.RENEGO, REC.RENORI, 0 AS STATUS, TO_CHAR(' ') AS DATIMP,TO_CHAR(' ') AS MOTREJ,
       VEN.CNT_RO, CLI.CODEXT AS CODCLI, CTB.CODBCO, CTB.NUMAGE, CTB.DIGAGE, CTB.CTACRR, CTB.DIGA_C,
       CTB.DIGCRR,
       CAST(CASE WHEN TIT.NOSNUM IS NOT NULL THEN
                 CASE WHEN CTB.CODBCO IN ('033','409','748','356') THEN TRIM(TIT.NOSNUM)
                      WHEN CTB.CODBCO = '027' THEN SUBSTR(TRIM(TIT.NOSNUM), 1, Length(TRIM(TIT.NOSNUM))-3)||'-'||SUBSTR(TRIM(TIT.NOSNUM), Length(TRIM(TIT.NOSNUM))-2, Length(TRIM(TIT.NOSNUM)))
                 ELSE CASE WHEN TIT.NOSNUM IS NOT NULL THEN
                           SUBSTR(TRIM(TIT.NOSNUM), 1, Length(TRIM(TIT.NOSNUM))-1)||'-'||SUBSTR(TRIM(TIT.NOSNUM), Length(TRIM(TIT.NOSNUM)), 1)
                      ELSE
                           NULL 
                      END
                 END
            ELSE
                 NULL
            END AS VARCHAR(25)) AS NOSNUM, REC.SEQUEN, REC.VLRTAX, TEF.MANUAL,
       CAST(COALESCE(TRIM(MeioDePagamento(REC.CODFIL, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR, 1)),'Indefinido') AS VARCHAR(50)) AS MEIPGT,
       CAST(CASE WHEN REC.CARTAO IS NOT NULL THEN
                 CASE WHEN TEF.SEQUEN IS NOT NULL THEN
                      CASE WHEN TEF.MANUAL = 'T' THEN TO_CHAR(TEF.NUMAUT) ELSE TEF.NSUTRN END
                 ELSE
                      (SELECT MIN(CASE WHEN TEF2.MANUAL = 'T' THEN TO_CHAR(TEF2.NUMAUT) ELSE TEF2.NSUTRN END)
                         FROM TT_OPE OPE INNER JOIN TT_OPE OPE2 ON OPE2.CODFIL = OPE.CODFIL 
                                                               AND OPE2.NUMECF = OPE.NUMECF
                                                               AND OPE2.TRN_ID = OPE.TRN_ID
                                                               AND ABS(OPE2.VLROPE) = ABS(OPE.VLROPE)
                                         INNER JOIN TT_TEF TEF2 ON TEF2.CODFIL = OPE2.CODFIL
                                                               AND TEF2.NUMECF = OPE2.NUMECF
                                                               AND TEF2.TRN_ID = OPE2.TRN_ID
                        WHERE OPE.FILREC = REC.CODFIL 
                          AND OPE.SEQREC = REC.SEQUEN
                          AND OPE.NUMPAR = REC.NUMPAR
                          AND OPE.SUBPAR = REC.SUBPAR
                          AND OPE2.CARTAO = REC.CARTAO)
                 END
            ELSE NULL
            END AS VARCHAR(20)) AS NUMAUT,
       -- Se parcela fica em aberto mais de 6 meses e no  paga, contabilmente  considerado como perda
       CAST(CASE WHEN (TO_DATE('01'||TO_CHAR(ADD_MONTHS(AGORA(),-6),'mm')||TO_CHAR(ADD_MONTHS(AGORA(),-6),'yyyy'),'ddmmyyyy') > REC.DATVEN) AND
                      ((REC.PAGAME IS NULL) OR 
                      (TO_DATE(TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'dd')||TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'mm')||TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'yyyy'),'ddmmyyyy') < REC.PAGAME))   
                 THEN 'T'
                 ELSE 'F'
            END AS VARCHAR(1)) AS PERDA,
       -- Se parcela  paga aps o perodo de 6 meses e  considerada perda,  necessrio fazer recuperao desta perda.
       CAST(CASE WHEN (CAST(CASE WHEN (TO_DATE('01'||TO_CHAR(ADD_MONTHS(AGORA(),-6),'mm')||TO_CHAR(ADD_MONTHS(AGORA(),-6),'yyyy'),'ddmmyyyy') > REC.DATVEN) AND
                      ((REC.PAGAME IS NULL) OR 
                      (TO_DATE(TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'dd')||TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'mm')||TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'yyyy'),'ddmmyyyy') < REC.PAGAME))   
                 THEN 'T'
                 ELSE 'F'
            END AS VARCHAR(1))) = 'T' AND REC.PAGAME IS NOT NULL
             THEN 'T'
             ELSE 'F' END AS VARCHAR(1)) AS RECUPERA,
       REC.ESTCAN, REC.AVISTA, VEN.ATU_EM AS VEN_ATU_EM, REC.ITEITF,			 
	   TEF.NUMAUT as TEF_NUMAUT, 
	   TEF.NSUTRN as TEF_NSUTRN,
	   TEF.TIPOPE as TEF_TIPOPE,
	   CASE TEF.TIPOPE WHEN 'D' THEN DCAR.EXTDEB ELSE DCAR.EXTCRE END AS TEF_CODEXT,
	   CASE REC.FLGEST WHEN 'A' THEN REC.VLRPAR WHEN 'P' THEN REC.VLRPGT-COALESCE(REC.VLRDES,0)+COALESCE(REC.VLRTAX,0) WHEN 'C' THEN COALESCE(REC.VLRDES,0)*-1 END AS VLRAJU,
	   CLICAR.NUMDOC AS DOCCAR,
	   CLICAR.CODEXT AS TEF_EXTADM
  FROM TT_VEN VEN INNER JOIN TT_CLI CLI  ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                  INNER JOIN TT_REC REC  ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
                  INNER JOIN TT_USU USU  ON USU.FILUSU = REC.FILUSU AND USU.CODUSU = REC.CODUSU
                  INNER JOIN TD_MOE DMOE ON DMOE.CODTAB = REC.CODMOE
                  INNER JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD
                  INNER JOIN TT_CTA CTA  ON DCOB.FILCTA = CTA.CODFIL
                                        AND DCOB.SEQCTA = CTA.SEQUEN
                                        AND DCOB.TIPCTA = CTA.TIPCTA 
                   LEFT JOIN TT_CHR CHR  ON CHR.CODFIL = REC.FILREC AND CHR.SEQUEN = REC.SEQCHE
                   LEFT JOIN TT_CTB CTB  ON CTA.CODFIL = CTB.FILCTA AND CTA.SEQUEN = CTB.SEQCTA
                                        AND CTA.TIPCTA = CTB.TIPCTA AND CTA.USOCTA = CTB.CTACTB
                   LEFT JOIN TD_CAR DCAR ON REC.CARTAO = DCAR.CODTAB
				   LEFT JOIN TT_CLI CLICAR ON DCAR.FILADM=CLICAR.FILCLI AND DCAR.CODADM=CLICAR.CODCLI
                   LEFT JOIN TT_ITF ITF ON ITF.CODFIL = REC.FILITF
                                       AND ITF.SEQUEN = REC.SEQITF
                                       AND ITF.NUMITE = REC.ITEITF
                   LEFT JOIN TT_TEF TEF ON TEF.CODFIL = ITF.CODFIL
                                       AND TEF.SEQUEN = ITF.SEQUEN
                   LEFT JOIN TT_TIT TIT ON TIT.FILREC = REC.CODFIL
                                       AND TIT.SEQREC = REC.SEQUEN
                                       AND TIT.PARREC = REC.NUMPAR
                                       AND TIT.SUBREC = REC.SUBPAR                                       
                                       AND TIT.FLGEST <> 'C';


/*-- SEQ 2149 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ERECF CASCADE;

/*-- SEQ 2150 --*/
CREATE OR REPLACE VIEW TV_ERECF AS
SELECT RECF.CODFIL, RECF.NUMECF, RECF.DATOPE, RECF.CUPINI, 
       RECF.CUPFIM, RECF.CNT_RZ, RECF.GT_INI, RECF.GT_FIM, 
       RECF.DATFEC, RECF.DIAFEC, RECF.INTERV, RECF.CNT_RO,
       RECF.EXPFIS,
       DECF.CODEXT_DECF, DECF.SERECF, RECF.EXPORT
  FROM TR_ECF RECF INNER JOIN TD_ECF DECF ON DECF.FILECF = RECF.CODFIL
                                         AND DECF.NUMECF = RECF.NUMECF 
 ;


/*-- SEQ 2151 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ESAL CASCADE;

/*-- SEQ 2152 --*/
CREATE OR REPLACE VIEW TV_ESAL AS
SELECT GRA.CODEXT, 
       SAL.CODFIL, 
       DMUL.DESMUL AS DESEST, 
       SAL.INI_CM, 
       SAL.PTOPED,
       SAL.QTD_CM, 
       SAL.QTDEST, 
       SAL.RESERV, 
       SAL.QTDMIN, 
       SAL.QTDREP, 
       SAL.VLR_CM,
	    0 AS STATUS, 
       TO_CHAR(' ') AS DATIMP,
       TO_CHAR(' ') AS MOTREJ, 
	    GRA.FILMAT, 
       GRA.CODMAT, 
       SAL.ATU_EM, 
       PRO.REFBAS, 
       GRA.REFPRO,
       GRA.CODFIS, 
       GRA.CODCOR, 
       GRA.CODTAM, 
       NCM.CODEXT AS NCM_CODEXT,
       TRUNC(AGORA()) AS DATCM_ATU,    
       CUSTOMEDIO(SAL.CODFIL,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,1,TRUNC(AGORA())) AS QTDCM_ATU,    
       CUSTOMEDIO(SAL.CODFIL,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,3,TRUNC(AGORA())) AS VLRCMUNI_ATU, 
       CUSTOMEDIO(SAL.CODFIL,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,2,TRUNC(AGORA())) AS VLRCMTOT_ATU 
  FROM TT_GRA GRA 
  INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT  AND PRO.CODMAT = GRA.CODMAT 
  INNER JOIN TT_SAL SAL ON GRA.FILMAT = SAL.FILMAT AND GRA.CODMAT = SAL.CODMAT AND GRA.CODCOR = SAL.CODCOR AND GRA.CODTAM = SAL.CODTAM                 
  INNER JOIN TD_MUL DMUL ON SAL.CODMUL = DMUL.CODTAB
  LEFT JOIN TT_NCM NCM ON PRO.CODNCM = NCM.CODNCM
WHERE DMUL.MULATI='T';


/*-- SEQ 2153 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ESER CASCADE;

/*-- SEQ 2154 --*/
CREATE OR REPLACE VIEW TV_ESER AS
SELECT SER.CODSER, SER.DIVTRO, SER.IMPNOT, SER.RESTRI, SER.SERATI, SER.SERMAN,
       SER.SERFIM, SER.SERINI, SER.MODNOT, SER.OBSCOL, SER.OBSLIN, SER.EXTNOT,
       SER.QTDITP, SER.QTDITS, SER.DESSER, SER.DISSAI, 
       REPLACE(REPLACE(SER.TXTENT,';','\;'),chr(39),chr(34)) AS TXTENT, 
       REPLACE(REPLACE(SER.TXTFIM,';','\;'),chr(39),chr(34)) AS TXTFIM, 
       REPLACE(REPLACE(SER.TXTINI,';','\;'),chr(39),chr(34)) AS TXTINI, 
       REPLACE(REPLACE(SER.TXTITE,';','\;'),chr(39),chr(34)) AS TXTITE,
       REPLACE(REPLACE(SER.TXTSER,';','\;'),chr(39),chr(34)) AS TXTSER,
       0 AS STATUS, TO_CHAR(' ') AS DATIMP,TO_CHAR(' ') AS MOTREJ
   FROM TD_SER SER;


/*-- SEQ 2155 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EUSU CASCADE;

/*-- SEQ 2156 --*/
CREATE OR REPLACE VIEW TV_EUSU AS
SELECT USU.FILUSU, SUP.CODEXT AS CODSUP, CLI.FILCLI,
       SUP.FILUSU AS FILSUP, CLI.CODEXT AS CODCLI,
       USU.CODEXT, USU.SENHA1, USU.SENHA2, RPAD(PERMISSOESUSUARIO(USU.FILUSU,USU.CODUSU),1000,'N') AS PERMIS,
       USU.ATU_EM, USU.PERCOM, USU.HORDOM, USU.HORQUA, USU.HORQUI, USU.HORSAB,
       USU.HORSEG, USU.HORSEX, USU.HORTER, DCTR.DESCTR AS CODCTR, USU.MAIDAT, USU.MENDAT,
       USU.NIVUSU, USU.SIGNAT, USU.AGENDB, USU.EDINDB, USU.USANDB, USU.USANDC,
       USU.APEUSU, USU.NOMUSU, USU.FILATV, USU.TABATU, USU.MAXDAT, USU.MINDAT,
       USU.VISSE1, USU.VISSE2, USU.LIMCOM, USU.E_MAIL, USU.VISPER, USU.PATNDB,
       USU.GRUPOS, USU.INDPRO, USU.CODSET, USU.FAZENQ, USU.FUNCAO, USU.FAZMON,
       USU.USUCOB, USU.NUMPAL, USU.COMIMP, USU.VALSEN, USU.FILINI, USU.CODINI,
       USU.CFGINI, USU.VISWOR, 0 AS STATUS, TO_CHAR(' ') AS DATIMP,TO_CHAR(' ') AS MOTREJ,
       USU.CSENHA, USU.HORRATCOR, USU.PERRATCOB, USU.MINRATCOB,
       USU.PRZPAG_MIN, USU.PRZPAG_MAX
  FROM TT_USU USU INNER JOIN TT_CLI CLI ON CLI.FILCLI = USU.FILCLI AND CLI.CODCLI = USU.CODCLI
                  INNER JOIN TD_CTR DCTR ON DCTR.CODTAB = USU.CODCTR
                  INNER JOIN TT_USU SUP ON SUP.FILUSU = USU.FILUSU AND SUP.CODUSU = USU.CODUSU;


/*-- SEQ 2157 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_BON CASCADE;

/*-- SEQ 2158 --*/
CREATE OR REPLACE VIEW TV_EVE_BON AS
   SELECT CAST('BON' AS VARCHAR(3)) AS TIPEVE, 
       CAST('Bnus' AS VARCHAR(5)) AS DESEVE,
       BON.FILCLI AS CODFIL, 
       CAST(COALESCE(BON.FILCLI ,'')|| '.' || LTRIM(COALESCE(BON.CODCLI,'')) AS VARCHAR(30)) AS EVE_ID, 
       BON.DATOPE, 
       CAST(' ' AS VARCHAR(1)) AS SITEVE, 
       BON.FILUSU AS FILUSU, BON.CODUSU AS CODUSU, BON.FILCLI, BON.CODCLI, 
       CAST(' ' AS VARCHAR(1)) AS CHVEVE, 
       BON.VLRLAN AS VLREVE, 
       CAST(' ' AS VARCHAR(1)) AS FLGEST, 
       CAST(' ' AS VARCHAR(1)) AS MSGEVE,
       CAST(0 AS Numeric) AS COREVE
   FROM TT_CFG CFG, TT_BON BON 
   WHERE (COALESCE(BON.FILCLI ,'')|| COALESCE(BON.CODCLI,'')) <>  (COALESCE(CFG.VC_FILCLI ,'')|| COALESCE(CFG.VC_CODCLI,''))
 ;




/*-- SEQ 2159 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_CCC CASCADE;

/*-- SEQ 2160 --*/
CREATE OR REPLACE VIEW TV_EVE_CCC AS
SELECT CAST('CCC' AS VARCHAR(3)) as tipeve,
             CAST(deseve AS VARCHAR(40)) as deseve,
             CODFIL,
             CAST(EVE_ID AS VARCHAR(30)) AS EVE_ID,
             DATOPE,
             CAST( siteve AS VARCHAR(15)) as siteve,
             FILUSU, CODUSU, FILCLI, CODCLI,
             CAST(' ' AS VARCHAR(1)) as chveve,
             vlreve,
             CAST(flgest AS VARCHAR(1)) as flgest,
             CAST(msgeve AS VARCHAR(100)) as msgeve,
             CAST(0 AS Numeric) AS COREVE
FROM (
SELECT CAST('CCC' AS VARCHAR(3)) as tipeve,
             CAST('C/C '||COALESCE(DCCC.DESCCC ,'') AS VARCHAR(40)) as deseve,
             CCC.FILCLI AS CODFIL,
             CCC.NUMDOC as EVE_ID,
             CCC.DATOPE,
             CAST( CASE WHEN FILFAT IS NOT NULL THEN 'Faturado'
                  WHEN STATUS = 'F' THEN 'Faturamento'
		  WHEN STATUS = 'S' THEN 'Suspenso'
                  WHEN CCC.VLRLAN<0 THEN 'Dbito'
                                    ELSE 'Crdito'
             END || CASE WHEN placas IS NOT NULL THEN ' (PLACA:'||placas||')' ELSE ''
                    END AS VARCHAR(15)) as siteve,
             CCC.FILUSU, CCC.CODUSU, CCC.FILCLI, CCC.CODCLI,
             CAST(' ' AS VARCHAR(1)) as chveve,
             CCC.VLRLAN as vlreve,
             CAST(CASE STATUS WHEN 'A' THEN 'A'
                                  ELSE 'P'
             END AS VARCHAR(1)) as flgest,
             CAST(COALESCE(COMPLE,'') AS VARCHAR(100)) as msgeve,
             CAST(0 AS Numeric) AS COREVE
  FROM TT_CFG CFG INNER JOIN TT_CCC CCC  ON (COALESCE(CCC.FILCLI,'') || COALESCE(CCC.CODCLI,'')) <>  (COALESCE(CFG.VC_FILCLI,'') || COALESCE(CFG.VC_CODCLI,''))
                  INNER JOIN TD_CCC DCCC ON DCCC.CODTAB = CCC.TIPCCC 
UNION ALL
SELECT CAST('CCC' AS VARCHAR(3)) AS TIPEVE, 
       'C/C '||CAST('Alterao' AS VARCHAR(40)) AS DESEVE, 
       LCC.FILCCC AS CODFIL, 
       CAST('Log' AS VARCHAR(3)) AS EVE_ID,
       LCC.DATOPE,
       CAST('CCC' AS VARCHAR(3)) AS SITEVE, 
       LCC.FILUSU,
       LCC.CODUSU,
       CCC.FILCLI,
       CCC.CODCLI,
       NULL AS CHVEVE,
       NULL AS VLREVE,
       NULL AS FLGEST,
       COALESCE(TO_CHAR(MSGLOG|| CASE WHEN IDL.CODUID IS NOT NULL 
                                      THEN ' [Usuarios SO: '||IDL.USEROS||
                                           '] [Estao: '||IDL.NOMMAQ||
                                           '] [Verso da Base de Dados: '||IDL.VERBAS||
                                           '] [Verso do Sistema: '||IDL.VERSIS||
                                           '] [Mdulo: '||IDL.NOMSIS||']'
                                      ELSE TO_CHAR('')
                                  END),'') AS MSGEVE,
       0 AS COREVE
  FROM TL_CCC LCC INNER JOIN TT_CCC CCC ON LCC.FILCCC = CCC.CODFIL  AND LCC.SEQCCC = CCC.SEQUEN
                   LEFT JOIN TT_UID IDL ON IDL.CODUID = LCC.CODUID
 WHERE MSGLOG IS NOT NULL
)TAB
 ;




/*-- SEQ 2161 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_CHR CASCADE;

/*-- SEQ 2162 --*/
CREATE OR REPLACE VIEW TV_EVE_CHR AS
   SELECT CAST('CHR' AS VARCHAR(3)) AS TIPEVE,
             CAST('Cheque Cliente' AS VARCHAR(15)) AS DESEVE,
             CHR.CODFIL,
             CAST(RTRIM(LTRIM(COALESCE(CHR.CODBCO,''))) || '(' || RTRIM(LTRIM(COALESCE(CHR.CODAGE,''))) || ')' || RTRIM(LTRIM(COALESCE(CHR.NUMCON,''))) || '-' || RTRIM(LTRIM(COALESCE(CHR.NUMCHE,''))) AS VARCHAR(30)) AS EVE_ID,
             CASE CHR.FLGEST WHEN 'A' THEN CHR.DATVEN
                                      ELSE CHR.PAGAME
             END AS DATOPE,
             DOM.DESDOM AS SITEVE,
             CHR.FILUSU,
             CHR.CODUSU,
             CHR.FILCLI,
             CHR.CODCLI,
             CHR.SEQUEN AS CHVEVE,
             (CHR.VLRCHE - COALESCE(CHR.VLRDIF, 0)) AS VLREVE,
             CHR.FLGEST,
             ParcelasCheque( CHR.CODFIL, CHR.SEQUEN) AS MSGEVE,
             CAST(0 AS Numeric) AS COREVE
     FROM TT_CHR CHR LEFT JOIN TT_DOM DOM ON DOM.CODCHR = CHR.FLGEST,
          TT_CFG CFG
    WHERE DOM.CODARQ =  'CHR'
         AND DOM.NOMCPO =  'FLGEST'
         AND (COALESCE(CHR.FILCLI,'') || COALESCE(CHR.CODCLI,'')) <>
             (COALESCE(CFG.VC_FILCLI,'') || COALESCE(CFG.VC_CODCLI,''))
;


/*-- SEQ 2163 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_COB CASCADE;

/*-- SEQ 2164 --*/
CREATE OR REPLACE VIEW TV_EVE_COB AS
SELECT CAST('COB' AS VARCHAR(3)) AS TIPEVE, 
       CAST('Cobranca' AS VARCHAR(8)) AS DESEVE,
       COB.CODFIL, 
       CAST(SUP.CODFIL||'.'||LTRIM(SUP.SEQUEN) AS VARCHAR(30))AS EVE_ID,
       COB.DATOPE, 
       COALESCE(DOM.DESDOM,'NAO IDENTIFICADA') AS SITEVE,
       SUP.FILCOB AS FILUSU,
       SUP.CODCOB AS CODUSU,
       COB.FILCLI,
       COB.CODCLI, 
       COB.SEQUEN AS CHVEVE, 
       CASE WHEN COB.FILCHR IS NOT NULL THEN (CHR.VLRCHE - COALESCE(CHR.VLRDIF, 0)) 
            ELSE CASE REC.FLGEST WHEN 'A' THEN REC.VLRPAR
                                 ELSE REC.VLRPGT
                 END
       END AS VLREVE,
       SUP.SITUAC AS FLGEST,
       CAST('' AS VARCHAR(1)) AS MSGEVE,
       CAST(0 AS Numeric) AS COREVE
  FROM TT_COB COB INNER JOIN TT_SUP SUP ON SUP.CODFIL = COB.FILSUP AND SUP.SEQUEN = COB.SEQSUP 
                   LEFT JOIN TT_DOM DOM ON DOM.CODCHR = SUP.SITUAC AND DOM.CODARQ = 'SPT' AND DOM.NOMCPO = 'SITUAC'
                   LEFT JOIN TT_CHR CHR ON CHR.CODFIL = COB.FILCHR AND CHR.SEQUEN = COB.SEQCHR  
                   LEFT JOIN TT_REC REC ON REC.CODFIL = COB.FILREC AND REC.SEQUEN = COB.SEQREC AND REC.NUMPAR = COB.NUMPAR AND REC.SUBPAR = COB.SUBPAR
 ;


/*-- SEQ 2165 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_COM CASCADE;

/*-- SEQ 2166 --*/
CREATE OR REPLACE VIEW TV_EVE_COM AS
SELECT CAST('COM' AS VARCHAR(3)) AS TIPEVE,
       CAST(CASE WHEN COM.TIPPAR = 'F' THEN 
          LTRIM(COALESCE(TIP.DESDOM,'')) || ' de compra'
       ELSE
         CASE WHEN COM.TIPNOT = 'A' THEN
            'Ttulo de Fatura'
         ELSE
            'Documento Simples'
         END
       END AS VARCHAR(30)) AS DESEVE,
       COM.CODFIL,
       CAST(LTRIM(COALESCE(COM.CODSER,'')) || '/' || LTRIM(COALESCE(COM.SUBSER,'')) || '-' || LTRIM(COALESCE(COM.NUMNOT,'')) AS VARCHAR(30)) AS EVE_ID,
       COM.DATOPE,
       DOM.DESDOM AS SITEVE,
       COM.FILUSU, COM.CODUSU,
       COM.FILFOR AS FILCLI,
       COM.CODFOR AS CODCLI,
       COM.SEQUEN AS CHVEVE,
       COM.VLRLIQ AS VLREVE,
       COM.FLGEST,
       CAST('' AS VARCHAR(1)) AS MSGEVE,
       0 AS COREVE
  FROM TT_COM COM INNER JOIN TT_DOM DOM ON DOM.CODCHR = COM.FLGEST
	              INNER JOIN TT_DOM TIP ON TIP.CODCHR = COM.TIPNOT
	              INNER JOIN TT_CFG CFG ON (COALESCE(COM.FILFOR ,'')|| COALESCE(COM.CODFOR,'')) <>  (COALESCE(CFG.VC_FILCLI ,'')|| COALESCE(CFG.VC_CODCLI,''))
	              INNER JOIN TT_USU USU ON USU.APEUSU = GetApeUsuAtual() -- Usurio Logado
                   LEFT JOIN TT_USU UCLI ON COM.FILFOR=UCLI.FILCLI AND COM.CODFOR=UCLI.CODCLI -- Usurio do compromisso                     
                  CROSS JOIN TT_IDF IDF
 WHERE DOM.CODARQ =  'COM'
   AND DOM.NOMCPO =  'FLGEST'
   AND (TIP.CODARQ =  'COM')
   AND (TIP.NOMCPO =  'TIPNOT')
   AND (-- Usurio logado tem permisso para ver pagamentos de outro funcionrios 
        SUBSTR(USU.PERMIS,147,1) = 'S' 
        -- Usurio logado tem papel com permisso para ver pagamentos de outro funcionrios
        OR EXISTS (SELECT 1 AS OK         
                     FROM TT_PAP PAP INNER JOIN TT_PAPXUSU PXU ON PXU.FILPAP = PAP.CODFIL
                                                              AND PXU.SEQPAP = PAP.SEQUEN
                    WHERE SUBSTR(PAP.PERMIS,147,1) = 'S'
                      AND PXU.FILUSU = USU.FILUSU
                      AND PXU.CODUSU = USU.CODUSU)
        -- Usurio  o OWNER                     
        OR IDF.USUADM = GetApeUsuAtual()
        -- Compra/Compromisso no  de funcionrio
        OR UCLI.APEUSU IS NULL)
;


/*-- SEQ 2167 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_COR CASCADE;

/*-- SEQ 2168 --*/
CREATE OR REPLACE VIEW TV_EVE_COR AS
SELECT CAST('COR' AS VARCHAR(3)) AS TIPEVE, 
       CAST('Correspondencia' AS VARCHAR(15)) AS DESEVE,
       COR.CODFIL, 
       CAST(COR.CODFIL||'.'||LTRIM(COR.SEQUEN) AS VARCHAR(30))AS EVE_ID,
       COR.DATOPE, 
       CAST(COALESCE(DOM.DESDOM,'NAO IDENTIFICADA') AS VARCHAR(30)) AS SITEVE,
       CAST('' AS CHAR(3)) AS FILUSU,
       CAST('' AS CHAR(3)) AS CODUSU,
       COR.FILCLI, COR.CODCLI, 
       COR.SEQUEN AS CHVEVE, 
       CAST(0 AS Numeric) AS VLREVE,
       COR.TIPCOR AS FLGEST, 
       ARC.DESARC AS MSGEVE,
       CAST(0 AS Numeric) AS COREVE
  FROM TT_COR COR LEFT JOIN TT_DOM DOM ON DOM.CODCHR = COR.TIPCOR AND DOM.CODARQ = 'COR' AND DOM.NOMCPO = 'TIPCOR'
                  LEFT JOIN TD_ARC ARC ON ARC.CODTAB = COR.CODARC
 ;


/*-- SEQ 2169 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_COS CASCADE;

/*-- SEQ 2170 --*/
CREATE OR REPLACE VIEW TV_EVE_COS AS
select CAST('COS' AS VARCHAR(3)) AS tipeve,
       CAST('Conclusao OS' AS VARCHAR(12)) AS deseve,
       filcos AS codfil,
       COALESCE(cos.codfil,'')||'/'||COALESCE(cos.numped,'')||'-'||COALESCE(TO_CHAR(cos.numite),'') AS eve_id,
       cos.datini AS datope,
       ros.result AS siteve, 
       ior.filusu, ior.codusu,
       cos.sequen AS chveve, 
       ior.vlrite AS vlreve, 
       ior.flgest,
       cos.observ AS msgeve,
       0 AS COREVE
  from tt_orc orc INNER JOIN tt_ior ior ON ior.codfil = orc.codfil
                                       and ior.tipped = orc.tipped
                                       and ior.numped = orc.numped
                  INNER JOIN tt_cos cos ON cos.codfil = ior.codfil
                                       and cos.tipped = ior.tipped
                                       and cos.numped = ior.numped
                                       and cos.numite = ior.numite
                  INNER JOIN td_ros ros ON ros.codtab = cos.codros
 ;




/*-- SEQ 2171 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_DEV CASCADE;

/*-- SEQ 2172 --*/
CREATE OR REPLACE VIEW TV_EVE_DEV AS
SELECT CAST(TIPEVE AS VARCHAR(3)) AS TIPEVE, 
       CAST(DESEVE AS VARCHAR(30)) AS DESEVE,
       CODFIL, 
       CAST( EVE_ID AS VARCHAR(40)) AS EVE_ID, 
       DATOPE, 
       CAST(SITEVE AS VARCHAR(20))AS SITEVE,
       FILUSU,
       CODUSU,
       FILCLI, 
       CODCLI, 
       CHVEVE, 
       VLREVE,
       CAST(FLGEST AS VARCHAR(1))AS FLGEST,
       CAST(MSGEVE AS VARCHAR(1)) AS MSGEVE,
       CAST(COREVE AS Numeric) AS COREVE
FROM (
SELECT CAST('SPC' AS VARCHAR(3)) AS TIPEVE, 
       CAST('Consta SPC' AS VARCHAR(30)) AS DESEVE,
       DEV.CODFIL, 
       CAST( CASE WHEN DEV.FILCHR IS NOT NULL THEN TRIM(COALESCE(CHR.CODBCO,'')) || '(' || TRIM(COALESCE(CHR.CODAGE,'')) || ')' || RTRIM(LTRIM(COALESCE(CHR.NUMCON,''))) || '-' ||TRIM(COALESCE(CHR.NUMCHE,''))
            ELSE LTRIM(COALESCE(VEN.CODSER,'')) || '/' || LTRIM(COALESCE(VEN.NUMECF,'')) || '-' || LTRIM(COALESCE(VEN.NUMNOT,'')) || '-' || LTRIM(COALESCE(REC.NUMPAR,'')) || '.' || LTRIM(COALESCE(REC.SUBPAR,''))
       END AS VARCHAR(40)) AS EVE_ID, 
       DEV.REGINC as DATOPE, 
       CAST('Incluso' || COALESCE(DEV.FILCHR,' (venda)',' (cheque)') AS VARCHAR(20))AS SITEVE,
       COALESCE(REC.FILUSU,CHR.FILUSU) AS FILUSU,
       COALESCE(REC.CODUSU,CHR.CODUSU) AS CODUSU,
       DEV.FILCLI, DEV.CODCLI, 
       DEV.SEQUEN AS CHVEVE, 
       CASE WHEN DEV.FILCHR IS NOT NULL THEN (CHR.VLRCHE - COALESCE(CHR.VLRDIF, 0)) 
            ELSE CASE REC.FLGEST WHEN 'A' THEN REC.VLRPAR
                                 ELSE REC.VLRPGT
                 END
       END AS VLREVE,
       CAST('I' AS VARCHAR(1))AS FLGEST,
       CAST('' AS VARCHAR(1)) AS MSGEVE,
       CAST(0 AS Numeric) AS COREVE
  FROM TT_DEV DEV LEFT JOIN TT_CHR CHR ON CHR.CODFIL = DEV.FILCHR AND CHR.SEQUEN = DEV.SEQCHR  
                  LEFT JOIN TT_REC REC ON REC.CODFIL = DEV.FILREC AND REC.SEQUEN = DEV.SEQREC AND REC.NUMPAR = DEV.NUMPAR AND REC.SUBPAR = DEV.SUBPAR
                  LEFT JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
WHERE DEV.REGEXC IS NULL
UNION ALL
SELECT CAST('SPC' AS VARCHAR(3)) AS TIPEVE, 
       CAST('Consta SPC' AS VARCHAR(15)) AS DESEVE,
       DEV.CODFIL, 
       CASE WHEN DEV.FILCHR IS NOT NULL THEN TRIM(COALESCE(CHR.CODBCO,'')) || '(' || TRIM(COALESCE(CHR.CODAGE,'')) || ')' || RTRIM(LTRIM(COALESCE(CHR.NUMCON,''))) || '-' ||TRIM(COALESCE(CHR.NUMCHE,''))
       ELSE LTRIM(COALESCE(VEN.CODSER,'')) || '/' || LTRIM(COALESCE(VEN.NUMECF,'')) || '-' || LTRIM(COALESCE(VEN.NUMNOT,'')) || '-' || LTRIM(COALESCE(REC.NUMPAR,'')) || '.' || LTRIM(COALESCE(REC.SUBPAR,''))
       END AS EVE_ID, 
       DEV.REGEXC as DATOPE, 
       'Excluso' || COALESCE(DEV.FILCHR,' (venda)',' (cheque)') AS SITEVE,
       COALESCE(REC.FILUSU,CHR.FILUSU) AS FILUSU,
       COALESCE(REC.CODUSU,CHR.CODUSU) AS CODUSU,
       DEV.FILCLI, DEV.CODCLI, 
       DEV.SEQUEN AS CHVEVE, 
       CASE WHEN DEV.FILCHR IS NOT NULL THEN (CHR.VLRCHE - COALESCE(CHR.VLRDIF, 0)) 
       ELSE CASE REC.FLGEST WHEN 'A' THEN REC.VLRPAR
            ELSE REC.VLRPGT
            END
       END AS VLREVE,
       'E' AS FLGEST,
       CAST('' AS VARCHAR(1)) AS MSGEVE,
       0 AS COREVE
  FROM TT_DEV DEV LEFT JOIN TT_CHR CHR ON CHR.CODFIL = DEV.FILCHR AND CHR.SEQUEN = DEV.SEQCHR 
       LEFT JOIN TT_REC REC ON REC.CODFIL = DEV.FILREC AND REC.SEQUEN = DEV.SEQREC AND REC.NUMPAR = DEV.NUMPAR AND REC.SUBPAR = DEV.SUBPAR
       LEFT JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
 WHERE DEV.REGEXC IS NOT NULL
) TAB
;


/*-- SEQ 2173 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_DOP CASCADE;

/*-- SEQ 2174 --*/
CREATE OR REPLACE VIEW TV_EVE_DOP AS
SELECT DISTINCT
       CAST('DOP' AS VARCHAR(3)) AS TIPEVE,
       CAST('Documentos Pagos' || ' - ' || DDOP.DESDOP AS VARCHAR(49)) AS DESEVE,
       DOP.CODFIL,
       DOP.DATPGT AS DATOPE,
       STD.DESSTD AS SITEVE,
       DOP.FILUSU,
       DOP.CODUSU,
       DOP.SEQUEN AS CHVEVE,
       DOP.VLRDOC AS VLREVE,
       DOP.FLGEST,
       DDOP.DESDOP,
       CAST(RTRIM(LTRIM(COALESCE(DOP.CODFIL,''))) || RTRIM(LTRIM(COALESCE(DOP.SEQUEN,''))) AS VARCHAR(30)) AS EVE_ID,
       DOP.OBSERV AS MSGEVE,
       CAST(1 AS Numeric) AS COREVE,
       CAST(CASE WHEN DOP.FILDES IS NULL
            THEN 'CHEQUE C/ CLIENTE'
            ELSE 'CHEQUE C/ LOJA'
       END AS VARCHAR(20)) AS CHEQUECOMQUEM,
       CTA.TITCTA AS QUALCHEQUE,
       COM.FILFOR AS FILCLI,
       COM.CODFOR AS CODCLI
  FROM TT_DOP DOP INNER JOIN TT_DOM  DOM ON DOM.CODCHR = DOP.FLGEST
                  INNER JOIN TD_STD  STD ON STD.DOMDOP = DOP.DOMDOP
                                        AND STD.CODTAB = DOP.STDDOP
                  INNER JOIN TD_DOP DDOP ON DDOP.CODTAB = DOP.DOMDOP
                  INNER JOIN TT_CTA  CTA ON DOP.FILCTA = CTA.CODFIL
                                        AND DOP.SEQCTA = CTA.SEQUEN
                                        AND CTA.TIPCTA = DOP.TIPCTA  
                  INNER JOIN TT_PAG PAG  ON PAG.FILDOP = DOP.CODFIL
                                        AND PAG.SEQDOP = DOP.SEQUEN
                  INNER JOIN TT_COM COM  ON COM.CODFIL = PAG.CODFIL
                                        AND COM.SEQUEN = PAG.SEQUEN 
                  INNER JOIN TT_USU USU ON USU.APEUSU = GetApeUsuAtual() -- Usurio Logado                                        
                   LEFT JOIN TT_USU UCLI ON COM.FILFOR = UCLI.FILCLI AND COM.CODFOR = UCLI.CODCLI -- Usurio do compromisso                                        
                  CROSS JOIN TT_IDF IDF                                        
 WHERE DOM.CODARQ =  'DOP'
   AND DOM.NOMCPO =  'FLGEST'
   AND (-- Usurio logado tem permisso para ver pagamentos de outro funcionrios 
        SUBSTR(PERMISSOESUSUARIO(USU.FILUSU,USU.CODUSU),147,1) = 'S'
        -- Usurio  o OWNER                     
        OR IDF.USUADM = GetApeUsuAtual()
        -- Compra/Compromisso no  de funcionrio
        OR UCLI.APEUSU IS NULL)      
;


/*-- SEQ 2175 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_FLG CASCADE;

/*-- SEQ 2176 --*/
CREATE OR REPLACE VIEW TV_EVE_FLG AS
SELECT DOM.CODARQ, 
       DOM.CODCHR, 
       COALESCE(ARQ.NOMTAB,'') || ' - ' || COALESCE(DOM.DESDOM,'') AS DESDOM
  FROM TT_ARQ ARQ INNER JOIN TT_DOM DOM ON ARQ.CODTAB = DOM.CODARQ
 WHERE DOM.CODARQ IN ('CHR', 'COM', 'ORC', 'PAG', 'PED', 'REC', 'VEN')
   AND DOM.NOMCPO = 'FLGEST'
 ;




/*-- SEQ 2177 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_IRO CASCADE;

/*-- SEQ 2178 --*/
CREATE OR REPLACE VIEW TV_EVE_IRO AS
SELECT CAST('IRO' AS VARCHAR(3)) AS TIPEVE, 
    CAST('Entrega' AS VARCHAR(5)) AS DESEVE,
    CODFIL, 
    CAST(EVE_ID AS VARCHAR(30)) AS EVE_ID,
    DATOPE, 
    CAST(SITEVE AS VARCHAR(15))AS SITEVE, 
    FILUSU, CODUSU,
    FILCLI, CODCLI, 
    CHVEVE, 
    VLREVE, 
    CAST(FLGEST AS VARCHAR(1)) AS FLGEST, 
    MSGEVE,
    CAST(0 AS Numeric) AS COREVE
FROM (
  SELECT IRO.FILVEN AS CODFIL, 
    CAST(LTRIM(COALESCE(VEN.CODSER,'')) || '/' || LTRIM(COALESCE(VEN.NUMECF,'')) || '-' || LTRIM(COALESCE(VEN.NUMNOT,'')) AS VARCHAR(30))AS EVE_ID,
    IRO.DATOPE, 
    CASE WHEN IRO.FLGEST = 'C' THEN 'Cancelado ' ELSE 'A entregar' END AS SITEVE, 
    IRO.FILUSU, IRO.CODUSU,
    IRO.FILCLI, IRO.CODCLI, 
    IRO.SEQUEN AS CHVEVE, 
    VEN.VLRLIQ AS VLREVE, 
    CASE WHEN IRO.FLGEST = 'C' THEN 'C' ELSE 'A' END AS FLGEST, 
    IRO.OBSERV AS MSGEVE
  FROM TT_CFG CFG, 
    TT_IRO IRO LEFT JOIN TT_VEN VEN ON VEN.CODFIL = IRO.FILVEN AND VEN.SEQUEN = IRO.SEQVEN
  WHERE (COALESCE(IRO.FILCLI,'')|| COALESCE(IRO.CODCLI,'')) <> (COALESCE(CFG.VC_FILCLI,'')|| COALESCE(CFG.VC_CODCLI,''))
   AND IRO.ENTREG = 'A'
  UNION ALL
  SELECT IRO.FILVEN AS CODFIL, 
    LTRIM(COALESCE(VEN.CODSER,'')) || '/' || LTRIM(COALESCE(VEN.NUMECF,'')) || '-' || LTRIM(COALESCE(VEN.NUMNOT,'')) AS EVE_ID,
    IRO.DATENT AS DATOPE, 
    CASE WHEN IRO.FLGEST = 'C' THEN 'Cancelado ' ELSE 'Entregue ' END AS SITEVE, 
    IRO.FILUSU, IRO.CODUSU,
    IRO.FILCLI, IRO.CODCLI, 
    IRO.SEQUEN AS CHVEVE, 
    VEN.VLRLIQ AS VLREVE, 
    CASE WHEN IRO.FLGEST = 'C' THEN 'C' ELSE 'E' END AS FLGEST, 
    IRO.OBSERV AS MSGEVE
  FROM TT_CFG CFG, 
    TT_IRO IRO LEFT JOIN TT_VEN VEN ON VEN.CODFIL = IRO.FILVEN AND VEN.SEQUEN = IRO.SEQVEN
  WHERE (COALESCE(IRO.FILCLI,'')|| COALESCE(IRO.CODCLI,'')) <> (COALESCE(CFG.VC_FILCLI,'')|| COALESCE(CFG.VC_CODCLI,''))
   AND IRO.ENTREG = 'E'
   AND IRO.DATENT IS NOT NULL
) TAB
 ;


/*-- SEQ 2179 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_LOG CASCADE;

/*-- SEQ 2180 --*/
CREATE OR REPLACE VIEW TV_EVE_LOG AS
	SELECT CAST('LOG' AS VARCHAR(3)) as tipeve, 
           CAST('Cadastro' AS VARCHAR(8)) as deseve,
           LOG.FILCLI AS CODFIL, 
           CAST(COALESCE(LOG.FILCLI,'') || '.' || LTRIM(COALESCE(LOG.CODCLI,'')) as VARCHAR(10)) as EVE_ID, 
           LOG.DATOPE, 
           CAST(' ' AS VARCHAR(1)) AS SITEVE, 
           LOG.FILUSU, LOG.CODUSU, LOG.FILCLI, LOG.CODCLI, 
           CAST(' ' AS VARCHAR(1)) as chveve, 
           CAST(0 AS FLOAT) as vlreve, 
           CAST(' ' AS VARCHAR(1)) as flgest, 
           SUBSTR(RTF2TXT(LOG.MSGLOG),1,3800)|| CASE WHEN IDL.CODUID IS NOT NULL 
                                      THEN SUBSTR(' [Usuarios SO: '||IDL.USEROS||
						  '] [Estao: '||IDL.NOMMAQ||
						  '] [Verso da Base de Dados: '||IDL.VERBAS||
						  '] [Verso do Sistema: '||IDL.VERSIS||
						  '] [Mdulo: '||IDL.NOMSIS||']',1,200)
                                      ELSE TO_CHAR('')
                          END as msgeve,
           CAST(0 AS INTEGER) AS COREVE
	  FROM TT_CFG CFG INNER JOIN TL_CLI LOG ON (COALESCE(LOG.FILCLI,'') || COALESCE(LOG.CODCLI,'')) <>  (COALESCE(CFG.VC_FILCLI,'') || COALESCE(CFG.VC_CODCLI,''))             
                           LEFT JOIN TT_UID IDL ON IDL.CODUID = LOG.CODUID
 ;


/*-- SEQ 2181 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_LRCP CASCADE;

/*-- SEQ 2182 --*/
CREATE OR REPLACE VIEW TV_EVE_LRCP AS
   SELECT CAST('RCP' AS VARCHAR(3)) AS TIPEVE, 
          CAST('Recepo de Produtos' AS VARCHAR(20)) AS DESEVE,
          LOG.FILFOR AS CODFIL, 
          LOG.NUMNOT AS EVE_ID, 
          LOG.DATHOR AS DATOPE, 
          CAST(' ' AS VARCHAR(1)) AS SITEVE, 
          LOG.FILUSU, LOG.CODUSU, LOG.FILFOR AS FILCLI, LOG.CODFOR AS CODCLI, 
          CAST(' ' AS VARCHAR(1)) AS CHVEVE, 
          CAST(0 AS  Numeric) AS VLREVE, 
          LOG.FLGEST AS FLGEST, 
          LOG.OBSERV|| CASE WHEN IDL.CODUID IS NOT NULL 
                            THEN ' [Usuarios SO: '||IDL.USEROS||
                                 '] [Estao: '||IDL.NOMMAQ||
                                 '] [Verso da Base de Dados: '||IDL.VERBAS||
                                 '] [Verso do Sistema: '||IDL.VERSIS||
                                 '] [Mdulo: '||IDL.NOMSIS||']'
                            ELSE TO_CHAR('')
                        END AS MSGEVE,
          CAST(0 AS  Numeric) AS COREVE
     FROM TT_CFG CFG INNER JOIN TL_RCP LOG ON (COALESCE(LOG.FILFOR,'') || COALESCE(LOG.CODFOR,'')) <> (COALESCE(CFG.VC_FILCLI,'') || COALESCE(CFG.VC_CODCLI,''))
                      LEFT JOIN TT_UID IDL ON IDL.CODUID = LOG.CODUID
 ;




/*-- SEQ 2183 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_MAI CASCADE;

/*-- SEQ 2184 --*/
CREATE OR REPLACE VIEW TV_EVE_MAI AS
SELECT CAST('MAI' AS VARCHAR(3)) AS TIPEVE, 
       CAST('e-Mail' AS VARCHAR(6)) AS DESEVE,
       MAI.CODFIL, 
       CAST(COALESCE(MAI.CODFIL,'') || '.' || LTRIM(COALESCE(MAI.SEQUEN,'')) AS VARCHAR(30)) AS EVE_ID, 
       MAI.DATSOL as DATOPE, 
       CAST(CASE WHEN DATENV IS NULL THEN 'A enviar'
            ELSE 'Enviado'
       END AS VARCHAR(10)) AS SITEVE, 
       MAI.FILUSU, MAI.CODUSU, MAI.FILCLI, MAI.CODCLI, 
       MAI.SEQUEN AS CHVEVE, 
       0  AS VLREVE, 
       CAST(CASE WHEN DATENV IS NULL THEN 'A'
            ELSE 'E' 
       END AS VARCHAR(30)) AS FLGEST, 
       ASSUNT AS MSGEVE,
       CAST(0 AS Numeric) AS COREVE
  FROM TT_MAI MAI
 ;




/*-- SEQ 2185 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_MON CASCADE;

/*-- SEQ 2186 --*/
CREATE OR REPLACE VIEW TV_EVE_MON AS
  SELECT CAST('MON' AS VARCHAR(3)) AS TIPEVE, 
    CAST('Montagem' AS VARCHAR(5)) AS DESEVE,
    MON.FILIVE AS CODFIL, 
    CAST(LTRIM(COALESCE(VEN.CODSER,'')) || '/' || LTRIM(COALESCE(VEN.NUMECF,'')) || '-' || LTRIM(COALESCE(VEN.NUMNOT,'')) || '.' || CAST(IVE.NUMITE AS VARCHAR(5)) AS VARCHAR(30))AS EVE_ID,
    MON.DATHOR AS DATOPE, 
    CAST(CASE MON.FLGEST WHEN 'C' THEN 'Cancelado '
                         WHEN 'A' THEN 'A montar  '
                         ELSE          'Montado   ' END AS VARCHAR(10)) AS SITEVE, 
    MON.FILUSU, MON.CODUSU,
    MON.FILCLI, MON.CODCLI, 
    MON.SEQUEN AS CHVEVE, 
    IVE.VLRMOV AS VLREVE, 
    MON.FLGEST AS FLGEST, 
    MON.OBSERV AS MSGEVE,
    CAST(0 AS Numeric) AS COREVE
  FROM TT_CFG CFG, 
       TT_MON MON  LEFT JOIN TT_IVE IVE ON IVE.CODFIL = MON.FILIVE AND IVE.SEQUEN = MON.SEQIVE AND IVE.NUMITE = MON.ITEIVE
                   LEFT JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
  WHERE (COALESCE(MON.FILCLI,'')|| COALESCE(MON.CODCLI,'')) <> (COALESCE(CFG.VC_FILCLI,'')|| COALESCE(CFG.VC_CODCLI,''))
;


/*-- SEQ 2187 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVEN CASCADE;

/*-- SEQ 2188 --*/
CREATE OR REPLACE VIEW TV_EVEN AS
SELECT VEN.CODFIL, VEN.SEQUEN, CLI.NUMDOC,
       CAST(CASE WHEN COALESCE(VEN.FILEST,'X') = 'X' THEN VEN.FLGEST ELSE 'Q' END AS CHAR(1)) AS FLGEST,
       VEN.FLGNFE, VEN.AVISTA, VEN.FLGTIP, VEN.TIPNOT, VEN.CODSER,
       USU.CODEXT AS CODUSU, VDD.CODEXT AS CODVEN, CLI.CODEXT AS CODCLI, VEN.INDFRE,
       VEN.NUMECF, VEN.NUMNOT, VEN.ATU_EM, VEN.DATHOR, ABS(VEN.VLRLIQ) AS VLRLIQ,
       VEN.VLRNOT, DCTR.DESCTR AS CODCTR, DNAT.NATDEN, DNAT.NATFOR, VEN.COMSOB, VEN.AUTENT,
       VEN.CONSFI, VEN.EMIDES, VEN.FINANC, VEN.TRIBUT, VEN.UFLOJA, VEN.DATSAI,
       --CASE WHEN VEN.DESCON < 0 THEN ROUND(ABS(VEN.VLRNOT * VEN.DESCON / 100),2) ELSE 0 END AS DESCON,
       CASE WHEN (COALESCE(VEN.DESRAT,0) < 0 AND COALESCE(VEN.VLRLIQ, 0) > 0) OR -- 94581
                 (COALESCE(VEN.DESRAT,0) > 0 AND COALESCE(VEN.VLRLIQ, 0) < 0) THEN ABS(VEN.DESRAT) ELSE 0 END  AS DESCON,
       --CASE WHEN VEN.DESCON > 0 THEN ROUND(ABS(VEN.VLRNOT * VEN.DESCON / 100),2) ELSE 0 END AS ACRESC,
       CASE WHEN (COALESCE(VEN.DESRAT,0) > 0 AND COALESCE(VEN.VLRLIQ, 0) > 0) OR -- 94581
                 (COALESCE(VEN.DESRAT,0) < 0 AND COALESCE(VEN.VLRLIQ, 0) < 0) THEN ABS(VEN.DESRAT) ELSE 0 END AS ACRESC,
       ABS(VEN.PESBRU) AS PESBRU, ABS(VEN.PESLIQ) AS PESLIQ, ABS(VEN.VLRFRE) AS VLRFRE, ABS(VEN.VLRSEG) AS VLRSEG, ABS(VEN.OUTTAX) AS OUTTAX, VEN.NROIMP,
       TPR.DESPRE AS CODPRE, DDEV.DESDEV AS CODDEV, REPLACE(VEN.OBSERV,';',to_path('/;')) AS OBSERV,
       VEN.LANVEN, TRUNC(VEN.DATHOR) AS DATFIS, ABS(VEN.NUMVOL) AS NUMVOL, ABS(VEN.VLRCOF) AS VLRCOF,
       PGT.CODEXT AS CODPGT, PGT.FILPGT,
       VEN.FILCOB, VEN.FILENT, FAT.CODFIL AS FILFAT, FAT.NUMECF AS ECFFAT, FAT.CODSER AS SERFAT,
       FAT.NUMNOT AS NUMFAT, VEN.FILGUI, VEN.CODGUI, TRA.CODEXT AS CODTRA, VEN.NUMCON, VEN.PROPGT,
       CAST(CASE WHEN DECF.INTERV IS NOT NULL
                 THEN DECF.INTERV
                 ELSE FAT.CNT_RO
            END AS CHAR(3)) AS CROFAT,
       ABS(VEN.PERCOM) AS PERCOM, ABS(VEN.PERENT) AS PERENT, VEN.SINAL, VEN.ENDCOB, VEN.ENDENT, VEN.ENDFAT,
       VEN.CODFIN, VEN.ESPECI,
       VEN.PRAMED, VEN.SIGNAT, ABS(VEN.BASUBS) AS BASUBS, VEN.RETIDO, ABS(VEN.SUBSTT) AS SUBSTT, VEN.CODEXT, VEN.VINCUL, VEN.MARCAS,
       VEN.EXPORT,  VEN.TIPTRO, ABS(VEN.QTDREN) AS QTDREN, VEN.PLAFRE, VEN.UF_FRE, TPR.CODFIL AS FILPRE, 0 AS STATUS,
       TO_CHAR(' ') AS DATIMP, TO_CHAR(' ') AS MOTREJ,
       CAST(CASE WHEN DECF.INTERV IS NOT NULL
                 THEN DECF.INTERV
                 ELSE VEN.CNT_RO
            END AS CHAR(3)) AS CNT_RO, VEN.SEREXT,
       -- Pedro E. Braga - Retirado controle devido a estar trazendo valor de item com ST na Base de ICMS
       -- Em Conversa com o Daniel ficou decidido que ira trazer a coluna BASICM da venda caso a mesma esteja errada sejá controlado pelo Checkout a gravação correta.
       /*CASE WHEN VEN.CODSER = 'CF' THEN -- RFMP 87922
                 ABS(VEN.VLRLIQ)
            ELSE
                 ABS(VEN.BASICM)
        END AS BASICM,*/
       ABS(VEN.BASICM) AS BASICM,
       ABS(VEN.VLRICM) AS VLRICM, ABS(VEN.VLRPIS) AS VLRPIS,
       ABS(VEN.BASISS) AS BASISS, ABS(VEN.VLRISS) AS VLRISS, ABS(VEN.VLRCSL) AS VLRCSL,
       ABS(VEN.BASIRR) AS BASIRR, ABS(VEN.VLRIRR) AS VLRIRR, VEN.OBSFIS, ABS(VEN.VLRCFI) AS VLRCFI,
       /* Pedro E. Braga - Ao alterar Coluna ("ENTSAI", "CLIENTE") deve replicar para TV_EIVE e TV_EIVE_FIS */
       CAST(CLI.FILCLI||TRIM(CLI.CODCLI) AS VARCHAR(20)) AS CLIENTE,
       CAST(CASE WHEN SUBSTR(DNAT.NATDEN, 1, 1) IN ('1', '2', '3') THEN 'E' ELSE 'S' END AS VARCHAR(1)) AS ENTSAI,
       ENDE.SIGEST, ENDF.SIGEST AS SIGEST_FAT,
       /* (SELECT VEN2.CODSER||VEN2.NUMNOT
                       FROM TT_IVE IVE INNER JOIN TT_IVE IVE2 ON IVE.FILORI = IVE2.CODFIL
                                                             AND IVE.NUMORI = IVE2.SEQUEN
                                                             AND IVE.ITEORI = IVE2.NUMITE
                                       INNER JOIN TT_VEN VEN2 ON IVE2.CODFIL = VEN2.CODFIL
                                                             AND IVE2.SEQUEN = VEN2.SEQUEN
                      WHERE IVE.CODFIL  = VEN.CODFIL
                        AND IVE.SEQUEN  = VEN.SEQUEN
                        AND IVE.LANEST  = 'C'
                        AND IVE2.LANEST = 'R') AS FATREM,*/
       COALESCE(CASE WHEN VEN.CHAVEA IS NULL OR LENGTH(VEN.CHAVEA) < 44 OR LENGTH(VEN.CHAVEA) IS NULL
              THEN NULL ELSE VEN.CHAVEA END,
              (SELECT MAX(VRT.CHAVEA)
                 FROM TT_VRT VRT
                WHERE VRT.FILVEN = VEN.CODFIL
                  AND VRT.ECFVEN = VEN.NUMECF
                  AND VRT.SERVEN = VEN.CODSER
                  AND VRT.NOTVEN = VEN.NUMNOT
                  AND VRT.CROVEN = VEN.CNT_RO)) AS CHAVEA,
       ABS((SELECT Coalesce(SUM(IVE3.QTDMOV), 0)
          FROM TT_IVE IVE3
         WHERE IVE3.CODFIL = VEN.CODFIL
           AND IVE3.SEQUEN = VEN.SEQUEN
           AND IVE3.SITKIT in ('2', '3')
           AND IVE3.SITMOV = 'N')) AS QTDITE,
       ABS((SELECT Coalesce(SUM(IVE3.BASIPI), 0)
          FROM TT_IVE IVE3
         WHERE IVE3.CODFIL = VEN.CODFIL
           AND IVE3.SEQUEN = VEN.SEQUEN
           AND IVE3.SITKIT in ('2', '3')
           AND IVE3.SITMOV = 'N')) AS BASIPI, CASE WHEN COALESCE(VEN.BASISS,0) = 0 THEN 0 ELSE ABS(ROUND(VEN.VLRISS * 100 / VEN.BASISS, 2)) END AS PERISS,
       CAST(CASE WHEN (DNAT.TIPNAT IN('D','M','R')) THEN 'T' ELSE 'F' END AS CHAR(1)) AS FLGDEV,
       DECF.SERECF, VEN.ORICAN, DECF.CODORI,
       VEN.SEQFAT,
       CAST(CASE WHEN VEN.CODSER='CF' THEN '2D'
	        WHEN VEN.MODNOT='0' THEN FIS.MODNOT
	        ELSE COALESCE(VEN.MODNOT,FIS.MODNOT)
       END AS VARCHAR(2)) AS FIS_MODNOT,
       (SELECT MIN(REC.CARTAO)
         FROM TT_REC REC
        WHERE VEN.CODFIL=REC.CODFIL
          AND VEN.SEQUEN=REC.SEQUEN
          AND CARTAO IS NOT NULL) AS CARTAO,
       VEN.EXPFIS, VEN.DOCNFP, VEN.SATSER, VEN.SATCFE,
       LID.CONGNF, LID.CONGRG, LID.CONCDC, LID.CONCOO, LID.CONCCF,
       VEN.NUMNFS,
       VEN.PROAUT, VEN.DATAUT, VEN.PROCAN, VEN.DATCAN,
       VEN.SEGRUR, VEN.SENAR,
       VEN.FILEST, VEN.SEQEST, VEN.IMPEST, VEN.ECFEST,
       CAST(CASE WHEN COALESCE(VEN.FILEST, '') = '' THEN 'F' ELSE 'T' END AS CHAR(1)) AS ESTORN,
       TPR.CODEXT AS PRE_CODEXT,
       VEN.SATCAN, VEN.CHVCAN, VEN.DESESP
  FROM TT_VEN VEN INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                  INNER JOIN TT_USU USU ON USU.FILUSU = VEN.FILUSU AND USU.CODUSU = VEN.CODUSU
                  INNER JOIN TT_USU VDD ON VDD.FILUSU = VEN.FILVEN AND VDD.CODUSU = VEN.CODVEN
                  INNER JOIN TT_TPR TPR ON TPR.CODFIL = VEN.FILPRE AND TPR.CODPRE = VEN.CODPRE
                  INNER JOIN TT_PLA PGT ON PGT.FILPGT = VEN.FILPGT AND PGT.CODPGT = VEN.CODPGT
                  INNER JOIN TD_DEV DDEV ON DDEV.CODTAB = VEN.CODDEV
                  INNER JOIN TD_CTR DCTR ON DCTR.CODTAB = VEN.CODCTR
                  INNER JOIN TD_ECF DECF ON DECF.FILECF = VEN.CODFIL
                                        AND DECF.NUMECF = VEN.NUMECF
                   LEFT JOIN TT_FIS FIS ON FIS.ORIGEM = 'V'
                                       AND FIS.CODSER = VEN.CODSER
                                       AND FIS.SUBSER = VEN.NUMECF
                   LEFT JOIN TT_LID LID ON LID.CODFIL = VEN.CODFIL
                                       AND LID.NUMECF = VEN.NUMECF
                                       AND LID.CODSER = VEN.CODSER
                                       AND LID.CUPFIS = VEN.NUMNOT
                                       AND (LID.CONCOO IS NOT NULL OR LID.CONCCF IS NOT NULL)
                                       AND LID.TIPOPE='VEN'
									   AND (VEN.TRN_ID IS NULL OR VEN.TRN_ID=LID.TRN_ID)
                   LEFT JOIN TT_CLI TRA ON TRA.FILCLI = VEN.FILTRA AND TRA.CODCLI = VEN.CODTRA
                   LEFT JOIN TT_VEN FAT ON FAT.CODFIL = VEN.FILFAT AND FAT.SEQUEN = VEN.SEQFAT
                   LEFT JOIN TT_END ENDE ON ENDE.FILCLI = VEN.FILCLI AND ENDE.CODCLI = VEN.CODCLI
                                        AND ENDE.CODFIL = VEN.FILENT AND ENDE.NUMEND = VEN.ENDENT
                   LEFT JOIN TT_END ENDF ON ENDF.FILCLI = VEN.FILCLI AND ENDF.CODCLI = VEN.CODCLI
                                        AND ENDF.CODFIL = VEN.FILFAT AND ENDF.NUMEND = VEN.ENDFAT
					LEFT JOIN TT_FUN FUN_INTAGRU ON FUN_INTAGRU.NOMFUN='INTEG_AGRU'
  WHERE VEN.NUMNOT NOT LIKE '%#%'
    AND (FUN_INTAGRU.NOMFUN IS NULL OR COALESCE(FIS.EXPORT,'F')='T')
	;


/*-- SEQ 2189 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_ORC CASCADE;

/*-- SEQ 2190 --*/
CREATE OR REPLACE VIEW TV_EVE_ORC AS
SELECT CAST('ORC' AS VARCHAR(3)) AS TIPEVE, 
       CAST('DAV' AS VARCHAR(9)) AS DESEVE, 
       ORC.CODFIL, 
       CAST(COALESCE(ORC.TIPPED,'') || '/' || COALESCE(ORC.NUMPED,'') AS VARCHAR(30)) AS EVE_ID, 
       ORC.PED_EM AS DATOPE, 
       DOM.DESDOM AS SITEVE, 
       ORC.FILUSU, ORC.CODUSU, ORC.FILCLI, ORC.CODCLI, 
       ORC.NUMPED AS CHVEVE, 
       ORC.VLRTOT AS VLREVE, 
       ORC.FLGEST, 
       CAST('' AS VARCHAR(1)) AS MSGEVE,
       CAST(0 AS Numeric) AS COREVE,
       PLA.DESPGT AS DESPGT
  FROM TT_DOM DOM INNER JOIN TT_ORC ORC ON DOM.CODCHR =  ORC.FLGEST 
                  INNER JOIN TT_CFG CFG ON (COALESCE(ORC.FILCLI,'') || COALESCE(ORC.CODCLI,'')) <>  (COALESCE(CFG.VC_FILCLI,'') || COALESCE(CFG.VC_CODCLI,''))
                  INNER JOIN TT_PLA PLA ON PLA.FILPGT = ORC.FILPGT AND PLA.CODPGT = ORC.CODPGT
 WHERE DOM.CODARQ =  'ORC' 
   AND DOM.NOMCPO =  'FLGEST'
   AND ORC.TIPPED =  'O'
 ;




/*-- SEQ 2191 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_OS CASCADE;

/*-- SEQ 2192 --*/
CREATE OR REPLACE VIEW TV_EVE_OS AS
	SELECT CAST('DOS' AS VARCHAR(3)) AS TIPEVE, 
           CAST('DAV-OS' AS VARCHAR(20)) AS DESEVE, 
           ORC.CODFIL, 
           CAST(COALESCE(ORC.TIPPED,'') || '/' || COALESCE(ORC.NUMPED,'') AS VARCHAR(30)) AS EVE_ID, 
           ORC.PED_EM AS DATOPE, 
           DOM.DESDOM AS SITEVE, 
           ORC.FILUSU, ORC.CODUSU, ORC.FILCLI, ORC.CODCLI, 
           ORC.NUMPED AS CHVEVE, 
           ORC.VLRTOT AS VLREVE, 
           ORC.FLGEST, 
           CAST('' AS VARCHAR(1)) AS MSGEVE,
           CAST(0 AS Numeric) AS COREVE
      FROM TT_ORC ORC INNER JOIN TT_DOM DOM ON DOM.CODCHR =  ORC.FLGEST
                      INNER JOIN TT_CFG CFG ON (COALESCE(ORC.FILCLI,'') || COALESCE(ORC.CODCLI,'')) <>  (COALESCE(CFG.VC_FILCLI,'') || COALESCE(CFG.VC_CODCLI,''))
	 WHERE DOM.CODARQ =  'ORC' 
	   AND DOM.NOMCPO =  'FLGEST' 
	   AND ORC.TIPPED =  'S' 
 ;




/*-- SEQ 2193 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_PAG CASCADE;

/*-- SEQ 2194 --*/
CREATE OR REPLACE VIEW TV_EVE_PAG AS
SELECT CAST('PAG' AS VARCHAR(3)) AS TIPEVE, 
       CAST(CASE PAG.FLGEST WHEN 'A' THEN 'A Pagar'
                       ELSE 'Pagamentos'
       END AS VARCHAR(20)) AS DESEVE, 
       PAG.CODFIL, 
       CAST(LTRIM(COALESCE(COM.CODSER,'')) || '/' || LTRIM(COALESCE(COM.SUBSER,'')) || '-' || LTRIM(COALESCE(COM.NUMNOT,'')) || '-' || LTRIM(COALESCE(PAG.NUMPAR,'')) || '.' || LTRIM(COALESCE(PAG.SUBPAR,'')) AS VARCHAR(30)) AS EVE_ID,
       COALESCE(PAG.DATVEN,PAG.DATPGT) AS DATOPE, 
       DOM.DESDOM AS SITEVE, 
       COALESCE( PAG.FILUSU, COM.FILUSU ) AS FILUSU, 
       COALESCE( PAG.CODUSU, COM.CODUSU ) AS CODUSU, 
       COM.FILFOR AS FILCLI, 
       COM.CODFOR AS CODCLI, 
       CAST(COALESCE(PAG.SEQUEN,'') || COALESCE(PAG.NUMPAR,'') || COALESCE(PAG.SUBPAR,'') AS VARCHAR(15)) AS CHVEVE, 
       CASE PAG.FLGEST WHEN 'A' THEN PAG.VLRPAR
                       ELSE PAG.VLRPGT
       END AS VLREVE, 
       PAG.FLGEST, 
       CAST('' AS VARCHAR(1)) AS MSGEVE,
       CAST(0 AS Numeric) AS COREVE
  FROM TT_COM COM INNER JOIN TT_PAG PAG ON PAG.CODFIL = COM.CODFIL AND PAG.SEQUEN = COM.SEQUEN
	              INNER JOIN TT_CFG CFG ON (COALESCE(COM.FILFOR,'') || COALESCE(COM.CODFOR,'')) <>  (COALESCE(CFG.VC_FILCLI,'') || COALESCE(CFG.VC_CODCLI,''))
	              INNER JOIN TT_DOM DOM ON DOM.CODCHR = PAG.FLGEST
                  INNER JOIN TT_USU USU ON USU.APEUSU = GetApeUsuAtual() -- Usurio Logado
                   LEFT JOIN TT_USU UCLI ON COM.FILFOR = UCLI.FILCLI AND COM.CODFOR = UCLI.CODCLI -- Usurio do compromisso
                  CROSS JOIN TT_IDF IDF
 WHERE DOM.CODARQ = 'PAG'
   AND DOM.NOMCPO = 'FLGEST' 
   AND (-- Usurio logado tem permisso para ver pagamentos de outro funcionrios 
        SUBSTR(PERMISSOESUSUARIO(USU.FILUSU,USU.CODUSU),147,1) = 'S'
        -- Usurio  o OWNER                     
        OR IDF.USUADM = GetApeUsuAtual()
        -- Compra/Compromisso no  de funcionrio
        OR UCLI.APEUSU IS NULL)      
;


/*-- SEQ 2195 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_PED CASCADE;

/*-- SEQ 2196 --*/
CREATE OR REPLACE VIEW TV_EVE_PED AS
	SELECT CAST('PED' AS VARCHAR(3)) AS TIPEVE, 
           CAST('Pedido de Compra' AS VARCHAR(20)) AS DESEVE, 
           PED.CODFIL, 
           CAST(LTRIM(PED.NUMPED) AS VARCHAR(30)) AS EVE_ID, 
           PED.DATPED AS DATOPE, 
           DOM.DESDOM AS SITEVE, 
           PED.FILUSU, 
           PED.CODUSU, 
           PED.FILFOR AS FILCLI, 
           PED.CODFOR AS CODCLI, 
           PED.NUMPED AS CHVEVE, 
           PED.VLRLIQ AS VLREVE, 
           PED.FLGEST, 
           CAST('' AS VARCHAR(1)) AS MSGEVE,
           CAST(0 AS Numeric) AS COREVE
	  FROM TT_DOM DOM INNER JOIN TT_PED PED ON DOM.CODCHR =  PED.FLGEST  
	                  INNER JOIN TT_CFG CFG ON (COALESCE(PED.FILFOR,'') || COALESCE(PED.CODFOR,'')) <>  (COALESCE(CFG.VC_FILCLI,'') || COALESCE(CFG.VC_CODCLI,''))
	 WHERE DOM.CODARQ =  'PED' 
	   AND DOM.NOMCPO =  'FLGEST' 	
	 ;


/*-- SEQ 2197 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_PRE CASCADE;

/*-- SEQ 2198 --*/
CREATE OR REPLACE VIEW TV_EVE_PRE AS
SELECT CAST('PRE' AS VARCHAR(3)) AS TIPEVE, 
         CAST('Pr-Venda' AS VARCHAR(9)) AS DESEVE, 
         ORC.CODFIL, 
         CAST(COALESCE(ORC.TIPPED,'') || '/' || COALESCE(ORC.NUMPED,'') AS VARCHAR(30)) AS EVE_ID, 
         ORC.PED_EM AS DATOPE, 
         DOM.DESDOM AS SITEVE, 
         ORC.FILUSU, ORC.CODUSU, ORC.FILCLI, ORC.CODCLI, 
         ORC.NUMPED AS CHVEVE, 
         ORC.VLRTOT AS VLREVE, 
         ORC.FLGEST, 
         CAST('' AS VARCHAR(1)) AS MSGEVE,
         CAST(0 AS  Numeric) AS COREVE
  FROM TT_DOM DOM INNER JOIN TT_ORC ORC ON DOM.CODCHR =  ORC.FLGEST 
                  INNER JOIN TT_CFG CFG ON (COALESCE(ORC.FILCLI,'') || COALESCE(ORC.CODCLI,'')) <>  (COALESCE(CFG.VC_FILCLI,'') || COALESCE(CFG.VC_CODCLI,''))
 WHERE DOM.CODARQ = 'ORC' 
   AND DOM.NOMCPO = 'FLGEST' 	   
   AND ORC.TIPPED = 'P'
;


/*-- SEQ 2199 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_PTR CASCADE;

/*-- SEQ 2200 --*/
CREATE OR REPLACE VIEW TV_EVE_PTR AS
	SELECT CAST('PTR' AS VARCHAR(3)) AS TIPEVE, 
            CASE PTR.FLGEST WHEN 'A' THEN 'A Receber'
                            ELSE 'Recebimento'
            END AS DESEVE, 
            PTR.CODFIL, 
            CAST(LTRIM(COALESCE(TRC.CODSER,'')) || '-' || LTRIM(COALESCE(TRC.NUMNOT,'')) || '-' || LTRIM(COALESCE(PTR.NUMPAR,'')) || '.' || LTRIM(COALESCE(PTR.SUBPAR,'')) AS VARCHAR(30)) AS EVE_ID, 
            COALESCE(PTR.DATVEN,PTR.DATPGT) AS DATOPE, 
            DOM.DESDOM AS SITEVE, 
            COALESCE( PTR.FILUSU, TRC.FILUSU ) AS FILUSU, 
            COALESCE( PTR.CODUSU, TRC.CODUSU ) AS CODUSU,
            TRC.FILPAR as FILCLI, TRC.CODPAR as CODCLI, 
            CAST(COALESCE(PTR.SEQUEN,'') || COALESCE(PTR.NUMPAR,'') || COALESCE(PTR.SUBPAR,'') AS VARCHAR(30))AS CHVEVE, 
            CASE PTR.FLGEST WHEN 'A' THEN PTR.VLRPAR
                            ELSE PTR.VLRPGT 
            END AS VLREVE, 
            PTR.FLGEST, 
            CAST('' AS VARCHAR(1)) AS MSGEVE,
            CAST(0 AS Numeric) AS COREVE
       FROM TT_TRC TRC INNER JOIN TT_PTR PTR ON PTR.CODFIL =  TRC.CODFIL AND PTR.SEQUEN =  TRC.SEQUEN 
                       INNER JOIN TT_DOM DOM ON DOM.CODCHR =  PTR.FLGEST 
                       INNER JOIN TT_CFG CFG ON (COALESCE(TRC.FILPAR,'') || COALESCE(TRC.CODPAR,'')) <>  (COALESCE(CFG.VC_FILCLI,'') || COALESCE(CFG.VC_CODCLI,''))
	  WHERE DOM.CODARQ =  'PTR' 
        AND DOM.NOMCPO =  'FLGEST'
 ;


/*-- SEQ 2201 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_REC CASCADE;

/*-- SEQ 2202 --*/
CREATE OR REPLACE VIEW TV_EVE_REC AS
	SELECT CAST('REC' AS VARCHAR(3)) AS TIPEVE, 
            CAST(CASE REC.FLGEST WHEN 'A' THEN 'A Receber'
                            ELSE 'Recebimento'
            END AS VARCHAR(40)) AS DESEVE, 
            REC.CODFIL, 
            CAST(LTRIM(COALESCE(VEN.CODSER,'')) || '/' || LTRIM(COALESCE(VEN.NUMECF,'')) || '-' || LTRIM(COALESCE(VEN.NUMNOT,'')) || '-' || LTRIM(COALESCE(REC.NUMPAR,'')) || '.' || LTRIM(COALESCE(REC.SUBPAR,'')) AS VARCHAR(30)) AS EVE_ID, 
            COALESCE(REC.PAGAME,REC.DATVEN) AS DATOPE, 
            CAST(CASE REC.FLGEST WHEN  'A' THEN 
                 CASE WHEN REC.CARTAO IS NULL THEN 
                      CASE WHEN REC.SEQCHE IS NULL THEN DOM.DESDOM
                      ELSE 'Pago com Cheque'
                      END
                  ELSE 'Pago com Carto'
                  END
            ELSE DOM.DESDOM
            END AS VARCHAR(15)) AS SITEVE, 
            COALESCE( REC.FILUSU, VEN.FILUSU ) AS FILUSU, 
            COALESCE( REC.CODUSU, VEN.CODUSU ) AS CODUSU,
            VEN.FILCLI, VEN.CODCLI, 
            CAST(COALESCE(REC.SEQUEN,'') || COALESCE(REC.NUMPAR,'') || COALESCE(REC.SUBPAR,'') AS VARCHAR(30)) AS CHVEVE, 
            CASE REC.FLGEST WHEN 'A' THEN REC.VLRPAR
                            ELSE REC.VLRPGT + REC.VLRTAX
            END AS VLREVE, 
            REC.FLGEST, 
            CAST(CASE WHEN REC.RENEGO IS null THEN '' 
                                         ELSE 'Renegociada ('||REC.RENEGO||' vez)'
            END AS VARCHAR(30)) AS MSGEVE,
            CAST(0 AS  Numeric) AS COREVE, REC.DATVEN, TRUNC(REC.PAGAME) AS PAGAME
       FROM TT_VEN VEN INNER JOIN TT_REC REC ON REC.CODFIL =  VEN.CODFIL AND REC.SEQUEN =  VEN.SEQUEN 
                       INNER JOIN TT_DOM DOM ON DOM.CODCHR =  REC.FLGEST 
                       INNER JOIN TT_CFG CFG ON (COALESCE(VEN.FILCLI,'') || COALESCE(VEN.CODCLI,'')) <>  (COALESCE(CFG.VC_FILCLI,'') || COALESCE(CFG.VC_CODCLI,''))
	  WHERE DOM.CODARQ =  'REC' 
        AND DOM.NOMCPO =  'FLGEST'
 ;


/*-- SEQ 2203 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_REG CASCADE;

/*-- SEQ 2204 --*/
CREATE OR REPLACE VIEW TV_EVE_REG AS
   SELECT CAST('REG' AS VARCHAR(3)) AS TIPEVE, 
          CAST('Registro de Cliente' AS VARCHAR(20)) AS DESEVE,
          REG.FILCLI AS CODFIL, 
          NUMREG AS EVE_ID, 
          REG.ATU_EM AS DATOPE, 
          CAST(' ' AS VARCHAR(1)) AS SITEVE, 
          CAST(' ' AS VARCHAR(1)) AS FILUSU, 
          CAST(' ' AS VARCHAR(1)) AS CODUSU, REG.FILCLI, REG.CODCLI, 
          CAST(' ' AS VARCHAR(1)) AS CHVEVE, 
          0 AS VLREVE, 
          CAST(' ' AS VARCHAR(1)) AS FLGEST, 
          CAST(' ' AS VARCHAR(1)) AS MSGEVE,
          0 AS COREVE
     FROM TT_REG REG INNER JOIN TT_CFG CFG ON (COALESCE(REG.FILCLI,'') || COALESCE(REG.CODCLI,'')) <>  (COALESCE(CFG.VC_FILCLI,'') || COALESCE(CFG.VC_CODCLI,''))
 ;




/*-- SEQ 2205 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_REN CASCADE;

/*-- SEQ 2206 --*/
CREATE OR REPLACE VIEW TV_EVE_REN AS
SELECT CAST('REN' AS VARCHAR(3)) AS TIPEVE, 
       CAST('Renegociacao' AS VARCHAR(12)) AS DESEVE,
       REN.CODFIL, 
       CAST(COALESCE(REN.FILCLI ,'')|| '.' || LTRIM(COALESCE(REN.CODCLI,'')) AS VARCHAR(30)) AS EVE_ID, 
       REN.DATOPE, 
       CAST(' ' AS VARCHAR(1)) AS SITEVE, 
       REN.FILUSU,
       REN.CODUSU,
       REN.FILCLI,
       REN.CODCLI, 
       REN.SEQUEN AS CHVEVE,
       REN.VLRPAR AS VLREVE, 
       CAST(' ' AS VARCHAR(1)) AS FLGEST, 
       CAST(' ' AS VARCHAR(1)) AS MSGEVE,
       CAST(0 AS Numeric) AS COREVE
   FROM TT_REN REN
 ;


/*-- SEQ 2207 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_RES CASCADE;

/*-- SEQ 2208 --*/
CREATE OR REPLACE VIEW TV_EVE_RES AS
 SELECT CAST('RES' AS VARCHAR(3)) as tipeve, 
             PER.TITPER as deseve,
             RES.FILCLI AS CODFIL, 
             COALESCE(RES.FILPER,'') || '/' || TRIM(COALESCE(RES.CODPER,'')) as EVE_ID,            
             RES.DATHOR AS DATOPE, 
             OPC.NOMOPC AS SITEVE, 
             CAST(' ' AS VARCHAR(1)) AS FILUSU, 
             CAST(' ' AS VARCHAR(1)) AS CODUSU, 
             RES.FILCLI AS FILCLI, 
             RES.CODCLI AS CODCLI, 
             COALESCE(RES.FILQUE,'')||COALESCE(RES.CODQUE,'') as chveve, 
             0 as vlreve, 
             CAST(' ' AS VARCHAR(1)) as flgest, 
             RES.COMENT as msgeve,
             0 AS COREVE
 FROM TT_RES RES    INNER JOIN TT_PER PER ON PER.FILPER = RES.FILPER AND PER.CODPER = RES.CODPER
                    INNER JOIN TT_OPC OPC ON OPC.FILPER = RES.FILPER AND OPC.CODPER = RES.CODPER AND OPC.CODOPC = RES.CODOPC
                    INNER JOIN TT_CFG CFG ON (COALESCE(RES.FILCLI,'') || COALESCE(RES.CODCLI,'')) <>  (COALESCE(CFG.VC_FILCLI,'') || COALESCE(CFG.VC_CODCLI,'')) 
 ;




/*-- SEQ 2209 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_SUP CASCADE;

/*-- SEQ 2210 --*/
CREATE OR REPLACE VIEW TV_EVE_SUP AS
	SELECT CAST('SUP' AS VARCHAR(3)) as tipeve, 
             sup.dessup as deseve,
             SUP.CODFIL AS CODFIL, 
             CAST(CAST(COALESCE(SUP.CODFIL,'') || '/' || LTRIM(COALESCE(SUP.SEQUEN,'')) AS VARCHAR(30)) AS VARCHAR(30)) as EVE_ID, 
             SUP.DATREG AS DATOPE, 
             DOM.DESDOM AS SITEVE, 
             SUP.FILRES AS FILUSU, SUP.CODRES AS CODUSU, SUP.FILCLI, SUP.CODCLI, 
             SUP.SEQUEN as chveve, 
             CAST(0 AS Numeric) as vlreve, 
             sup.situac as flgest,
             CAST(' ' AS VARCHAR(1)) AS MSGEVE,
             CAST(0 AS Numeric) AS COREVE
    FROM TT_DOM DOM   INNER JOIN TT_SUP SUP ON DOM.CODCHR =  SUP.SITUAC
                      INNER JOIN TT_CFG CFG ON (COALESCE(SUP.FILCLI,'') || COALESCE(SUP.CODCLI,'')) <>  (COALESCE(CFG.VC_FILCLI,'') || COALESCE(CFG.VC_CODCLI,''))
   WHERE DOM.CODARQ =  'SPT' 
     AND DOM.NOMCPO =  'SITUAC'
 ;




/*-- SEQ 2211 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_TIP CASCADE;

/*-- SEQ 2212 --*/
CREATE OR REPLACE VIEW TV_EVE_TIP AS
 SELECT 'VEN' AS TIPEVE,'Vendas' AS DESEVE FROM DUAL UNION ALL
 SELECT 'REC','Recebimentos' FROM DUAL UNION ALL
 SELECT 'CHR','Cheques Clientes' FROM DUAL UNION ALL
 SELECT 'COM','Compras' FROM DUAL UNION ALL
 SELECT 'LOG','Cadastros' FROM DUAL UNION ALL
 SELECT 'ORC','DAV' FROM DUAL UNION ALL
 SELECT 'DOS','DAV-OS' FROM DUAL UNION ALL
 SELECT 'PRE','Pr-Venda' FROM DUAL UNION ALL
 SELECT 'PAG','Pagamentos' FROM DUAL UNION ALL
 SELECT 'PED','Pedidos' FROM DUAL UNION ALL
 SELECT 'RES','Questionrios' FROM DUAL UNION ALL
 SELECT 'BON','Bnus' FROM DUAL UNION ALL
 SELECT 'SUP','SAC' FROM DUAL UNION ALL
 SELECT 'WOR','Workflow' FROM DUAL UNION ALL
 SELECT 'REG','Registro de Clientes' FROM DUAL UNION ALL
 SELECT 'TRC','Ttulos a Receber' FROM DUAL UNION ALL
 SELECT 'CCC','Conta Corrente' FROM DUAL UNION ALL
 SELECT 'RCP','Recebimento de Produtos' FROM DUAL UNION ALL
 SELECT 'PTR','Recebimento Ttulos' FROM DUAL UNION ALL
 SELECT 'REN','Renegociao' FROM DUAL
 ;




/*-- SEQ 2213 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_TRC CASCADE;

/*-- SEQ 2214 --*/
CREATE OR REPLACE VIEW TV_EVE_TRC AS
	SELECT CAST('TRC' AS VARCHAR(3)) AS TIPEVE, 
             CAST('Titulos a Receber' AS VARCHAR(17)) AS DESEVE, 
             TRC.CODFIL, 
             CAST(LTRIM(COALESCE(TRC.CODSER,'')) || '-' || LTRIM(COALESCE(TRC.NUMNOT,'')) AS VARCHAR(30)) AS EVE_ID,
             TRC.DATOPE AS DATOPE, 
             DOM.DESDOM AS SITEVE, 
             TRC.FILUSU, TRC.CODUSU, TRC.FILPAR as FILCLI, TRC.CODPAR as CODCLI, 
             TRC.SEQUEN AS CHVEVE, 
             TRC.VLRLIQ AS VLREVE, 
             TRC.FLGEST, 
             CAST('' AS VARCHAR(1)) AS MSGEVE,
             CAST(0 AS Numeric) AS COREVE            
    FROM TT_DOM DOM   INNER JOIN TT_TRC TRC ON DOM.CODCHR =  TRC.FLGEST
                      INNER JOIN TT_CFG CFG ON (COALESCE(TRC.FILPAR,'') || COALESCE(TRC.CODPAR,'')) <> (COALESCE(CFG.VC_FILCLI,'') || COALESCE(CFG.VC_CODCLI,'')) 
   WHERE DOM.CODARQ =  'TRC' 
     AND DOM.NOMCPO =  'FLGEST'   
 ;




/*-- SEQ 2215 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_VEN CASCADE;

/*-- SEQ 2216 --*/
CREATE OR REPLACE VIEW TV_EVE_VEN AS
	SELECT CAST('VEN' AS VARCHAR(3)) AS TIPEVE, 
             NAT.NATURE AS DESEVE, 
             VEN.CODFIL, 
             CAST(LTRIM(COALESCE(VEN.CODSER,'')) || '/' || LTRIM(COALESCE(VEN.NUMECF,'')) || '-' || LTRIM(COALESCE(VEN.NUMNOT,'')) AS VARCHAR(30)) AS EVE_ID,
             VEN.DATHOR AS DATOPE, 
             DOM.DESDOM AS SITEVE, 
             VEN.FILUSU, VEN.CODUSU, VEN.FILCLI, VEN.CODCLI, 
             VEN.SEQUEN AS CHVEVE, 
             VEN.VLRLIQ AS VLREVE, 
             VEN.FLGEST, 
             CAST('' AS VARCHAR(1)) AS MSGEVE,
             COALESCE( VEN.QTDREN, 0 ) AS COREVE,
             PLA.DESPGT AS DESPGT
    FROM TT_VEN VEN   INNER JOIN TT_CFG CFG ON (COALESCE(VEN.FILCLI,'') || COALESCE(VEN.CODCLI,'')) <> (COALESCE(CFG.VC_FILCLI,'') || COALESCE(CFG.VC_CODCLI,'')) 
                      INNER JOIN TT_DOM DOM ON DOM.CODCHR = VEN.FLGEST
                      INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
                      INNER JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT
                                           AND PLA.CODPGT = VEN.CODPGT
	WHERE DOM.CODARQ =  'VEN' 
	  AND DOM.NOMCPO =  'FLGEST' 
	 ;




/*-- SEQ 2217 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_WOR CASCADE;

/*-- SEQ 2218 --*/
CREATE OR REPLACE VIEW TV_EVE_WOR AS
	SELECT CAST('WOR' AS VARCHAR(3)) as tipeve, 
             WOR.DESTAR as deseve,
             WOR.FILCLI AS CODFIL, 
             CAST(COALESCE(WOR.FILCLI,'') || '.' || LTRIM(COALESCE(WOR.CODCLI,'')) AS VARCHAR(30)) as EVE_ID, 
             WOR.ATU_EM as datope, 
             SIT.DESSIT AS SITEVE, 
             WOR.FILRES AS FILUSU, WOR.CODRES AS CODUSU, WOR.FILCLI, WOR.CODCLI, 
             CAST(' ' AS VARCHAR(1)) as chveve, 
             CAST(0 AS Numeric) as vlreve, 
             SIT.TIPSIT as flgest, 
             WOR.TAREFA as msgeve,
             CAST(0 AS Numeric) AS COREVE
    FROM TT_WOR WOR INNER JOIN TT_CFG CFG ON (COALESCE(WOR.FILCLI,'') || COALESCE(WOR.CODCLI,'')) <> (COALESCE(CFG.VC_FILCLI,'') || COALESCE(CFG.VC_CODCLI,''))
		    INNER JOIN TD_SIT SIT ON SIT.CODTAB = WOR.FLGSIT
 ;




/*-- SEQ 2219 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVO_CON_REC CASCADE;

/*-- SEQ 2220 --*/
CREATE OR REPLACE VIEW TV_EVO_CON_REC AS
SELECT SALDOCONTA(DCTA.FILCTA,DCTA.SEQCTA,DCTA.TIPCTA,INI.DATOPE,'R',NULL) AS SALDO_INICIAL,
       (SELECT SUM(COALESCE(RCTA.TOTCRE,0) - COALESCE(RCTA.TOTDEB,0))
          FROM TR_CTA RCTA
         WHERE RCTA.FILCTA = DCTA.FILCTA
           AND RCTA.SEQCTA = DCTA.SEQCTA
           AND RCTA.DATLAN BETWEEN ADD_DAY(INI.DATOPE,1) AND FIM.DATOPE
           AND RCTA.FLGFLX = 'R'
       ) AS PAGO,
       (SELECT SUM(CCC.VLRLAN) * -1
          FROM TT_CCC CCC
         WHERE CCC.DATOPE BETWEEN INI.DATOPE AND FIM.DATOPE
           AND CCC.SEQVEN IS NOT NULL
           AND CCC.STATUS IN ('A','P')
       ) AS VALOR_CC,           
       SALDOCONTA(DCTA.FILCTA,DCTA.SEQCTA,DCTA.TIPCTA,FIM.DATOPE,'R',NULL) AS SALDO_FINAL,
       INI.DATOPE AS DATINI,
       FIM.DATOPE AS DATFIM
     FROM TD_CTA DCTA
          CROSS JOIN TT_DAT INI 
          CROSS JOIN TT_DAT FIM 
    WHERE 
   /* Devido a erro no componente TUniScript no podemos ter comentarios antes do ; final  e para no perder o comentarios foi necessario deixar nessa ordem */ 
   /*     INI.DATOPE = TO_DATE('27/08/2009', 'DD/MM/YYYY') --  obrigatrio usar esse filtro no BI */
   /* AND FIM.DATOPE = TO_DATE('27/09/2009', 'DD/MM/YYYY') --  obrigatrio usar esse filtro no BI */          
   /* AND */ DCTA.CFGCOL = 'CONTAS A RECEBER'
;


/*-- SEQ 2221 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EXPCLI CASCADE;

/*-- SEQ 2222 --*/
CREATE OR REPLACE VIEW TV_EXPCLI AS
SELECT CASE WHEN CLI.CODEXT IS NULL THEN CAST(CLI.FILCLI||TRIM(CLI.CODCLI) AS VARCHAR(20)) ELSE CLI.CODEXT END AS CODEXT,CLI.FILCLI,CLI.CODCLI,CLI.DATOPE,CLI.NOMCLI,CLI.ULTNOM,CLI.TIPDOC AS CTIPDOC,
DDOC.DESDOC AS DTIPDOC,CLI.INSEST,CLI.NUMDOC,CLI.DATNAS,CLI.ESTCIV,CLI.FLGTIP,CLI.CODSEX,DCT1.NOMCT1 AS CATEG1,
DCT2.NOMCT2 AS CATEG2,DCT3.NOMCT3 AS CATEG3,CLI.OBSERV,CASE WHEN CLI.SIGNAT >= 0 THEN 'T' ELSE 'F' END AS ATIVO,
DINA.DESINA,CLI.ICM_CF,CLI.CALL_C,CLI.PORPAD,CLI.CONJUG,CLI.NASCON,CLI.SEXCON,CLI.DOCCON,CLI.DDTCON,TRIM(CLI.TELCON) AS TELCON,
CLI.DDCCON,TRIM(CLI.CELCON) AS CELCON,CLI.E_MCON,CLI.NOMTRA,CLI.ID_ORG,CLI.ID_EST,CLI.ID_DAT,CLI.VALOR1 AS LIMCRE,
PLA.CODEXT AS CODPLA,USU.APEUSU AS APEVEN,JUG.CODEXT AS CODCON,CLI.NAOSPC,CLI.CONBOL,VIN.CODEXT AS CODVIN,CLI.OBSOUT,
CLI.SIMPLE,CLI.HOMPGE,CLI.DATA01,CLI.DATA02,CLI.DATA03, CASE WHEN REL1.TIPPAR IS NULL THEN 'F' ELSE 'T' END AS TIPCLI1,
CASE WHEN REL2.TIPPAR IS NULL THEN 'F' ELSE 'T' END AS TIPCLI2,CASE WHEN REL3.TIPPAR IS NULL THEN 'F' ELSE 'T' END AS TIPCLI3,
CASE WHEN REL4.TIPPAR IS NULL THEN 'F' ELSE 'T' END AS TIPCLI4,CASE WHEN REL5.TIPPAR IS NULL THEN 'F' ELSE 'T' END AS TIPCLI5,
CASE WHEN REL6.TIPPAR IS NULL THEN 'F' ELSE 'T' END AS TIPCLI6,CASE WHEN REL7.TIPPAR IS NULL THEN 'F' ELSE 'T' END AS TIPCLI7,
CASE WHEN REL8.TIPPAR IS NULL THEN 'F' ELSE 'T' END AS TIPCLI8,CASE WHEN REL9.TIPPAR IS NULL THEN 'F' ELSE 'T' END AS TIPCLI9,
CASE WHEN REL0.TIPPAR IS NULL THEN 'F' ELSE 'T' END AS TIPCLI10,CON.NUMCON,CON.CONTAT AS NCONTA, TO_CHAR(' ') AS FILECO,
TO_CHAR(' ') AS NUMECO, CON.NOMTRA AS TRACON,CON.DATNAS AS NASCNT,CON.SEXCON AS SEXOCO,TO_CHAR(' ') AS TIPCON,
TO_CHAR(' ') AS TIPPES,CON.DDDCON,TRIM(CON.TELCON) AS CONTEL,CON.DDDCEL,TRIM(CON.CELCON) AS CELUCO,CON.DDDFAX AS DDDFXC,
TRIM(CON.NUMFAX) AS NUMFXC,CON.E_MAIL,ENDE.CODFIL AS FILEND,ENDE.NUMEND AS NUMEND, ENDE.ENDERE,ENDE.CONTAT,ENDE.NUMERO,
ENDE.BAIRRO,ENDE.SIGEST,ENDE.CODCID,ENDE.NOMCID,ENDE.CODLOG,DREG.REGIAO,ENDE.FLGNAC,ENDE.ESTRAN,ENDE.USA_NF,ENDE.ENDCOB,ENDE.ENDCOR,
ENDE.TIPEND,ENDE.COMPLE,ENDE.CODCEP,ENDE.LOCTRA,ENDE.CODDDD,TRIM(ENDE.NUMFON) AS NUMFON,ENDE.DDDFAX,TRIM(ENDE.NUMFAX) AS NUMFAX,
ENDE.NUMDOC AS DOCEND,ENDE.INSEST AS IE_END,SPC.NACION,SPC.CIDNAS,SPC.DDDCEL AS CELDDD,SPC.NUMCEL AS CELNUM,SPC.E_MAIL AS MAISPC,
SPC.ATUMES,SPC.CASMES,SPC.FIRATU,SPC.NUMCOD,SPC.NUMTEL,SPC.NOMSUP,SPC.ENDERE AS ENDSPC,SPC.COMPLE AS COMSPC,SPC.SALBAS,
DOCU.DESOCU,SPC.FIRANT,SPC.ANTMES,SPC.CARPRO,SPC.SERCAR,SPC.NOMLO1,SPC.ENDLO1,SPC.NOMLO2,SPC.ENDLO2,SPC.TIPRES,SPC.ALUFIN,
SPC.MORMES,SPC.CON_TC,SPC.CONSPC,SPC.CON_LT,SPC.CON_LR,SPC.CARLOJ,SPC.TEMAUT,SPC.TEM_CC,SPC.TEM_TC,SPC.NUMDEP,SPC.ORIRED,
SPC.VLRRED,SPC.RGCONJ,SPC.CONOCU,SPC.NUMCOC,SPC.TELCON AS TELSPC,SPC.FIRCON,SPC.ENDCO1,SPC.ENDCO2,SPC.CANMES,SPC.SALBAC,
SPC.CARPRC,SPC.SERCAC,0 AS STATUS, TO_CHAR(' ') AS DATIMP,TO_CHAR(' ') AS MOTREJ,CLI.ATU_EM,IED.ULTEXP,CLI.CODPAI,CLI.CODCRC, CLI.LIMCHE,
CLI.ISENTO, CLI.DATCRE, CLI.VALLIM, CLI.PERVDD, ENDE.INSMUN, CLI.SUFRAM, CLI.DENEGA, CLI.CODNAE
FROM TT_CLI CLI JOIN TT_IED IED ON IED.TABELA = 'CLI'
LEFT JOIN TD_CT1 DCT1 ON DCT1.CODTAB = CLI.CATEG1
LEFT JOIN TD_CT2 DCT2 ON DCT2.CODTAB = CLI.CATEG2
LEFT JOIN TD_CT3 DCT3 ON DCT3.CODTAB = CLI.CATEG3
LEFT JOIN TD_INA DINA ON DINA.CODTAB = CLI.CODINA
LEFT JOIN TD_DOC DDOC ON DDOC.TIPDOC = CLI.TIPDOC
LEFT JOIN TT_USU USU ON USU.FILUSU = CLI.FILVEN AND USU.CODUSU = CLI.CODVEN
LEFT JOIN TT_CON CON ON CON.FILCLI = CLI.FILCLI AND CON.CODCLI = CLI.CODCLI
LEFT JOIN TT_END ENDE ON ENDE.FILCLI = CLI.FILCLI AND ENDE.CODCLI = CLI.CODCLI
LEFT JOIN TT_SPC SPC ON SPC.FILCLI = CLI.FILCLI AND SPC.CODCLI = CLI.CODCLI
LEFT JOIN TD_OCU DOCU ON DOCU.CODTAB = SPC.CODOCU
LEFT JOIN TD_REG DREG ON DREG.CODTAB = ENDE.REGIAO
LEFT JOIN TT_CLI VIN ON VIN.FILCLI = CLI.FILVIN AND VIN.CODCLI = CLI.CODVIN
LEFT JOIN TT_CLI JUG ON JUG.FILCLI = CLI.FILCON AND JUG.CODCLI = CLI.CODCON
LEFT JOIN TT_PLA PLA ON PLA.FILPGT = CLI.FILPLA AND PLA.CODPGT = CLI.CODPLA
LEFT JOIN TT_REL REL1 ON REL1.FILPAR = CLI.FILCLI AND REL1.CODPAR = CLI.CODCLI AND REL1.TIPPAR = 'M'
LEFT JOIN TT_REL REL2 ON REL2.FILPAR = CLI.FILCLI AND REL2.CODPAR = CLI.CODCLI AND REL2.TIPPAR = 'F'
LEFT JOIN TT_REL REL3 ON REL3.FILPAR = CLI.FILCLI AND REL3.CODPAR = CLI.CODCLI AND REL3.TIPPAR = 'T'
LEFT JOIN TT_REL REL4 ON REL4.FILPAR = CLI.FILCLI AND REL4.CODPAR = CLI.CODCLI AND REL4.TIPPAR = 'A'
LEFT JOIN TT_REL REL5 ON REL5.FILPAR = CLI.FILCLI AND REL5.CODPAR = CLI.CODCLI AND REL5.TIPPAR = 'R'
LEFT JOIN TT_REL REL6 ON REL6.FILPAR = CLI.FILCLI AND REL6.CODPAR = CLI.CODCLI AND REL6.TIPPAR = 'I'
LEFT JOIN TT_REL REL7 ON REL7.FILPAR = CLI.FILCLI AND REL7.CODPAR = CLI.CODCLI AND REL7.TIPPAR = 'O'
LEFT JOIN TT_REL REL8 ON REL8.FILPAR = CLI.FILCLI AND REL8.CODPAR = CLI.CODCLI AND REL8.TIPPAR = 'N'
LEFT JOIN TT_REL REL9 ON REL9.FILPAR = CLI.FILCLI AND REL9.CODPAR = CLI.CODCLI AND REL9.TIPPAR = 'X'
LEFT JOIN TT_REL REL0 ON REL0.FILPAR = CLI.FILCLI AND REL0.CODPAR = CLI.CODCLI AND REL0.TIPPAR = 'C'
INNER JOIN TD_EXP DEXP ON DEXP.CODTAB = 1
WHERE (CLI.FILCLI||CLI.CODCLI <> (SELECT VC_FILCLI||VC_CODCLI FROM TT_CFG))
;


/*-- SEQ 2223 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EXPCON CASCADE;

/*-- SEQ 2224 --*/
CREATE OR REPLACE VIEW TV_EXPCON AS
SELECT I1.*,
             CAST(TRIM(RTF2TXT( CASE WHEN AGRUPA = 'T'
                                 THEN ''
                                 ELSE SUBSTR(replace(replace(COMPLEMENTODADOSFINANCEIROS( ORIGEM, CODFIL, SEQUEN, NUMPAR, SUBPAR, 1),chr(13),' '),chr(10),' '),1,250)
                            END)) AS CHAR(250)) AS OBSERV,
             CAST( RTF2TXT( CASE WHEN AGRUPA = 'T'
                                 THEN ''
                                 ELSE SUBSTR(replace(replace(COMPLEMENTODADOSFINANCEIROS( ORIGEM, CODFIL, SEQUEN, NUMPAR, SUBPAR, 3),chr(13),' '),chr(10),' '),1,15)
                            END) AS CHAR(15)) AS DOCUME
      FROM (SELECT FIN.CODFIL, FIN.ORIGEM, FIN.DATLAN, FIN.VLRLAN, CTA.TIPCTA,
                   FIN.SEQUEN, FIN.NUMPAR, FIN.SUBPAR, FIN.FILORI, PAR.NOMCLI,
                   COALESCE(CTAXFIL.CODEXT, CTA.CODEXT) AS CODCTA,
                   CASE WHEN DCRT.cfgcol='CONTAS A RECEBER' AND FIN.TIPLAN='VEN' AND VEN.AVISTA='T' AND VEN.CODSER='CF' THEN CCOB.CODEXT ELSE COALESCE(CRTXFIL.CODEXT, CRT.CODEXT) END AS CODCRT,
                   CASE WHEN DCTA.cfgcol='CONTAS A RECEBER' AND FIN.TIPLAN='REC' AND VEN.AVISTA='T' AND VEN.CODSER='CF' THEN 'T' ELSE 'F' END AS EXC_MULREC,
                   CAST( CASE WHEN CFG.VC_FILCLI || CFG.VC_CODCLI = PAR.FILCLI || PAR.CODCLI THEN 'T' ELSE 'F' END AS CHAR(1)) AS CONSUMIDOR,
                   CASE WHEN (FIN.ORIGEM IN ('REC','CCC','TEF','CHR')
                              OR CTA.USOCTA = 'E'
                              OR CRT.USOCTA = 'E') and COALESCE(VEN.CODSER,'CF')='CF'
                             THEN 'T'
                        WHEN VEN.CODSER IS NOT NULL AND (CTA.USOCTA = 'E' OR CRT.USOCTA = 'E')
                             THEN 'N'
                        ELSE 'F'
                   END AS AGRUPA,
                   CASE WHEN (FIN.ORIGEM='REC' AND VEN.CODSER='CF' AND FIN.TIPLAN='VEN' AND DCRT.CFGCOL='CONTAS A RECEBER') THEN 'Receita de Vendas (CF)'
                        WHEN CTA.TIPCTA = 'G' THEN COALESCE(DCTA.DESCTA,CTA.TITCTA)
                        WHEN CRT.TIPCTA = 'G' THEN COALESCE(DCRT.DESCTA,CRT.TITCTA)
                        WHEN DCTA.CFGCOL='CONTAS A RECEBER' AND FIN.ORIGEM='REC' AND VEN.AVISTA='F' THEN 'Recebimento de parcelas'
                        WHEN DCTA.FILCTA IS NULL AND DCRT.FILCTA IS NULL THEN CTA.TITCTA
                        WHEN DCTA.FILCTA IS NULL  OR DCRT.FILCTA IS NULL THEN COALESCE(DCTA.DESCTA, DCRT.DESCTA)
                        WHEN FIN.VLRLAN<0 THEN DCTA.DESCTA
                        ELSE DCRT.DESCTA
                   END AS DESCTA,
                   CAST(CASE WHEN FIN.ORIGEM='FIN' AND CTA.USOCTA||CRT.APLNUM = 'ED'   THEN 'Diferena de Caixa'
                             WHEN FIN.ORIGEM='FIN' AND CRT.USOCTA||CTA.APLNUM = 'ED'   THEN 'Diferena de Caixa'
                             WHEN FIN.ORIGEM='FIN' AND CTA.USOCTA='E' AND FIN.VLRLAN<0 THEN 'Sangria/Abertura'
                             WHEN FIN.ORIGEM='FIN' AND CTA.USOCTA='E' AND FIN.VLRLAN>0 THEN 'Sangria/Abertura'
                             WHEN FIN.ORIGEM='FIN' AND CRT.USOCTA='E' AND FIN.VLRLAN>0 THEN 'Reforo/Fechamento'
                             WHEN FIN.ORIGEM='FIN' AND CRT.USOCTA='E' AND FIN.VLRLAN<0 THEN 'Reforo/Fechamento'
                             WHEN FIN.ORIGEM='CCC' AND (CTA.USOCTA='E' OR CRT.USOCTA='E') THEN DescricaoDominio('CCC','TIPLAN',CCC.TIPLAN)
                        END AS VARCHAR(30)) AS TIPDIF,
                   FIL.CODEXT,
                   CREC.CODEXT AS CTAREC,
                   CTA.TITCTA,
                   CRT.TITCTA AS TITCRT,
                   FIN.CODTAB AS RFIN_CODTAB,
                   FIN.TIPCRT,
                   FIN.FILDES
            FROM TT_CFG CFG,
                 TR_FIN FIN INNER JOIN TD_FIL FIL ON FIN.CODFIL=FIL.CODFIL
                            INNER JOIN TT_CTA CTA ON CTA.CODFIL=FIN.FILCTA  AND CTA.SEQUEN = FIN.SEQCTA AND CTA.TIPCTA = FIN.TIPCTA
                            INNER JOIN TT_CTA CRT ON CRT.CODFIL=FIN.FILCRT  AND CRT.SEQUEN = FIN.SEQCRT AND CRT.TIPCTA = FIN.TIPCRT
                            INNER JOIN TT_CLI PAR ON PAR.FILCLI=FIN.FILCLI  AND PAR.CODCLI = FIN.CODCLI
                            INNER JOIN TD_CTA DREC ON DREC.CFGCOL='CONTAS A RECEBER'
                            INNER JOIN TT_CTA CREC ON DREC.FILCTA=CREC.CODFIL AND DREC.SEQCTA=CREC.SEQUEN
                            LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL='CONTAS A RECEBER' AND CTA.CODFIL=DCTA.FILCTA AND CTA.SEQUEN=DCTA.SEQCTA
                            LEFT JOIN TD_CTA DCRT ON DCRT.CFGCOL='CONTAS A RECEBER' AND CRT.CODFIL=DCRT.FILCTA AND CRT.SEQUEN=DCRT.SEQCTA
                            LEFT JOIN TT_VEN VEN ON FIN.ORIGEM='REC' AND FIN.CODFIL=VEN.CODFIL AND FIN.SEQUEN=VEN.SEQUEN
                            LEFT JOIN TT_REC REC ON FIN.ORIGEM='REC' AND FIN.CODFIL=REC.CODFIL AND FIN.SEQUEN=REC.SEQUEN AND FIN.NUMPAR=REC.NUMPAR AND FIN.SUBPAR=REC.SUBPAR
                            LEFT JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD
                            LEFT JOIN TT_CTA CCOB ON CCOB.CODFIL=DCOB.FILCTA AND CCOB.SEQUEN=DCOB.SEQCTA
                            LEFT JOIN TT_CCC CCC ON FIN.ORIGEM='CCC' AND FIN.CODFIL=CCC.CODFIL AND FIN.SEQUEN=CCC.SEQUEN
                            LEFT JOIN TT_CTAXFIL CTAXFIL ON CTA.CODFIL=CTAXFIL.FILCTA AND CTA.SEQUEN = CTAXFIL.SEQCTA AND CTA.TIPCTA = CTAXFIL.TIPCTA AND CTAXFIL.CODFIL=FIN.FILORI
                            LEFT JOIN TT_CTAXFIL CRTXFIL ON CRT.CODFIL=CRTXFIL.FILCTA AND CRT.SEQUEN = CRTXFIL.SEQCTA AND CRT.TIPCTA = CRTXFIL.TIPCTA AND CRTXFIL.CODFIL=FIN.FILORI
          WHERE FIN.FLGFLX='R'
               ) I1
;


/*-- SEQ 2225 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FAT CASCADE;

/*-- SEQ 2226 --*/
CREATE OR REPLACE VIEW TV_FAT AS
    SELECT COALESCE(CODSER,'') ||'/'|| lTrim(COALESCE(NUMECF,''))||'-'||lTrim(COALESCE(NUMNOT,''))||CASE WHEN COALESCE(CNT_RO,0)>0 THEN '['||CNT_RO||']' ELSE '' END AS DOCUME,
	       CODFIL,NUMECF,CODSER,NUMNOT,FILCLI,CODCLI,
	       DATHOR,FLGEST,ATU_EM,FILUSU,CODUSU,FILVEN,
	       CODVEN,FILPGT,CODPGT,VLRNOT,VLRLIQ,PERCOM,
	       PERENT,COMSOB,CODNAT,PRAMED,ESPECI,OBSERV,
	       NROIMP,AUTENT,DESCON,FILGUI,CODGUI,SIGNAT,DATSAI,
	       NUMVOL,MARCAS,VLRSEG,VLRFRE,PESBRU,PESLIQ,
	       NUMCON,CODPRE,SINAL,FINANC,TRIBUT,SEQFAT,FILPRE,
	       PROPGT,EMIDES,SEQUEN,FILTRA,CODTRA,TIPNOT,TIPTRA,
	       FILFAT,ENDFAT,FILENT,ENDENT,FILCOB,ENDCOB,CNT_RO
	  FROM TT_VEN 
	 WHERE TIPNOT = 'F' 
	    OR TIPNOT = 'A'
 ;




-- Autor: Gabriel Rewell
-- Cliente(s): Casa Carneiro

-- Finalidade(s):
-- 1) Gerar relatrio para listar:
--    * Vendas de simples faturamento;
--    * Venda de simples remessa deste faturamento;
--    * Devoluo do simples faturamento;
--    * Devoluo da simples remessa
/*-- SEQ 2227 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FATURA_REMESSA_DEVOLUCOES CASCADE;

/*-- SEQ 2228 --*/
CREATE OR REPLACE VIEW TV_FATURA_REMESSA_DEVOLUCOES AS
SELECT VEN.CODFIL,
       VEN.FILCLI,
       VEN.CODCLI,
       CAST(VEN.CODFIL||'-'||VEN.NUMECF||'-'||VEN.CODSER||'/'||TRIM(VEN.NUMNOT)||'-'||IVE.NUMITE||' ['||IVE.NATFIS||']' AS VARCHAR(35)) AS FATURA,
       IVE.QTDMOV AS QTDFAT,
       IVE.QTDPEN AS QTDPEN,
       IVE.VEN_DATHOR AS DATFAT,
       COALESCE(COALESCE(IVE.QTDPEN,0)-
                       CASE WHEN CFG.RESERVA_ENT_FUT = 'T'
                             AND IVE.FLGFUT <> 'E'
                            THEN 0
                            ELSE COALESCE(IVE.QTDFUT,0)
                       END,0) AS QTDRES,
       IVE.VLRLIQRAT,
       CAST(DEV.CODFIL||'-'||DEV.NUMECF||'-'||DEV.CODSER||'/'||TRIM(DEV.NUMNOT)||'-'||IDE.NUMITE||' ['||IDE.NATFIS||']' AS VARCHAR(35)) AS DEVFAT,
      IDE.QTDMOV AS QTDDEVFAT,
      IDE.VEN_DATHOR AS DATDEVFAT,
      IDE.VLRLIQRAT AS VLRLIQRAT_IDE,
      CAST(REM.CODFIL||'-'||REM.NUMECF||'-'||REM.CODSER||'/'||TRIM(REM.NUMNOT)||'-'||IRE.NUMITE||' ['||IRE.NATFIS||']'AS VARCHAR(35)) AS REMESSA,
      IRE.QTDMOV AS QTDREM,
      IRE.VEN_DATHOR AS DATREM,
      IRE.VLRLIQRAT AS VLRLIQRAT_IRE,
      CAST(DRM.CODFIL||'-'||DRM.NUMECF||'-'||DRM.CODSER||'/'||TRIM(DRM.NUMNOT)||'-'||IDR.NUMITE||' ['||IDR.NATFIS||']'AS VARCHAR(35)) AS DEVREM,
      IDR.QTDMOV AS QTDDEVREM,
      IDR.VEN_DATHOR AS DATIDR,
      IDR.VLRLIQRAT AS VLRLIQRAT_IDR
  FROM TT_IVE IVE INNER JOIN TT_PRO PRO ON IVE.FILMAT = PRO.FILMAT
                                       AND IVE.CODMAT = PRO.CODMAT
                  INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL
                                       AND VEN.SEQUEN = IVE.SEQUEN
                   LEFT JOIN TT_IVE IDE ON IDE.FILORI = IVE.CODFIL
                                       AND IDE.NUMORI = IVE.SEQUEN
                                       AND IDE.ITEORI = IVE.NUMITE
                                       AND IDE.SITMOV = 'N'
                                       AND IDE.VLRMOV < 0
                   LEFT JOIN TT_VEN DEV ON DEV.CODFIL = IDE.CODFIL
                                       AND DEV.SEQUEN = IDE.SEQUEN
                   LEFT JOIN TT_IVE IRE ON IRE.FILORI = IVE.CODFIL
                                       AND IRE.NUMORI = IVE.SEQUEN
                                       AND IRE.ITEORI = IVE.NUMITE
                                       AND IRE.SITMOV = 'N'
                                       AND IRE.VLRMOV > 0
                   LEFT JOIN TT_VEN REM ON REM.CODFIL = IRE.CODFIL
                                       AND REM.SEQUEN = IRE.SEQUEN
                   LEFT JOIN TT_IVE IDR ON IDR.FILORI = IRE.CODFIL
                                       AND IDR.NUMORI = IRE.SEQUEN
                                       AND IDR.ITEORI = IRE.NUMITE
                                       AND IDR.SITMOV = 'N'
                                       AND IDR.VLRMOV < 0
                   LEFT JOIN TT_VEN DRM ON DRM.CODFIL = IDR.CODFIL
                                       AND DRM.SEQUEN = IDR.SEQUEN
                   CROSS JOIN TT_CFG CFG
 WHERE IVE.VEN_DATHOR > COALESCE(CFG.IGNORA_RESERVA, TO_DATE('01/01/1980','DD/MM/YYYY') )
   AND IVE.SITMOV <> 'C'
   AND IVE.LANEST = 'R'
   AND IVE.FILORI IS NULL
   AND PRO.TIPPRO NOT IN ('1','2')
 ORDER BY IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE, IDE.CODFIL, IDE.SEQUEN, IDE.NUMITE,
          IRE.CODFIL, IRE.SEQUEN, IRE.NUMITE, IDR.CODFIL, IDR.SEQUEN, IDR.NUMITE;


/*-- SEQ 2229 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FAV CASCADE;

/*-- SEQ 2230 --*/
CREATE OR REPLACE VIEW TV_FAV AS
SELECT CLI.CODCLI, 
       CLI.FILCLI,
       CASE WHEN (SELECT COUNT(*)
                    FROM TT_USU USU
                   WHERE CLI.CODCLI = USU.CODCLI
                     AND CLI.FILCLI = USU.FILCLI) = 0 THEN 'I'
       ELSE CASE WHEN (SELECT COUNT(*)
                         FROM TT_REL REL
                        WHERE CLI.CODCLI = REL.CODPAR
                          AND CLI.FILCLI = REL.FILPAR
					      AND REL.TIPPAR = 'I') = 0 THEN 'V' ELSE 'C'
			END
       END AS TIPFAV,
	   CLI.ATU_EM, CLI.NOMCLI, CLI.ULTNOM, CLI.NUMDOC, CLI.DOCCON, CLI.DATNAS, 
       CLI.ESTCIV, CLI.HOMPGE, CLI.FLGTIP, CLI.INSEST, CLI.CODSEX, CLI.CATEG1, CLI.CATEG2, CLI.CATEG3,
       CLI.DATA01, CLI.DATA02, CLI.DATA03, CLI.DATOPE, CLI.IMPRIM, CLI.VALOR1, CLI.TOTATR, CLI.TOTPAR,
       CLI.MAIATR, CLI.OBSERV, CLI.FILPLA, CLI.CODPLA, CLI.PORPAD, CLI.ULTCOM, CLI.SIGNAT, CLI.CONJUG, 
       CLI.NASCON, CLI.SEXCON, CLI.FILVEN, CLI.CODVEN, USU.FILUSU, USU.CODUSU, USU.CHVMAT
  FROM TT_CLI CLI LEFT JOIN TT_USU USU ON CLI.FILCLI = USU.FILCLI
                                      AND CLI.CODCLI = USU.CODCLI
 ;


/*-- SEQ 2231 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FCM CASCADE;

/*-- SEQ 2232 --*/
CREATE OR REPLACE VIEW TV_FCM AS
    SELECT COALESCE(CODSER,'')||'/'||lTrim(COALESCE(SUBSER,''))||'-'||lTrim(COALESCE(NUMNOT,'')) AS DOCUME,
           SEQUEN,CODFIL,FILFOR,CODFOR,CODSER,NUMNOT,
           DATOPE,FLGEST,ATU_EM,DATCMP,QTDTOT,VLRTOT,
           NOTESP,OUTTAX,DESCON,VLRLIQ,FILUSU,CODUSU,
           CODMOE,OBSERV,VLTXJU,INCOJU,INTPJU,VLTXMU,
           INTPMU,CONPGT,
           CFO.CODCFO AS NATURE,
           ESPDOC,SIGNAT,MOEJUR,
           SEQFAT,FILFRE,SEQFRE,TIPNOT,TIPPAR,SEQCAN,SUBSER
    FROM TT_COM COM LEFT OUTER JOIN TD_CFO CFO ON COM.CODCFO=CFO.CODTAB
    WHERE TIPNOT = 'F' 
       OR TIPNOT = 'A'
 ;




/*-- SEQ 2233 --*/
/*-- IGNORE ERRO --*/
DROP VIEW tv_fid CASCADE;

/*-- SEQ 2234 --*/
CREATE OR REPLACE VIEW tv_fid AS
    select d.codfil, d.numecf,
           d.trn_id + 1 as DE, 
           min(c.trn_id) - 1 as ATE,
           min(c.dathor) as ulttrn
    from (select * from tt_lid) c,
         (select b.*
          from tt_lid b 
          where B.LIDPOS = 'F') d
    where c.codfil=d.codfil 
      and c.numecf=d.numecf
      and c.trn_id > d.trn_id
    group by d.codfil, d.numecf, d.trn_id
 ;


/*-- SEQ 2235 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIN_CCC CASCADE;

/*-- SEQ 2236 --*/
CREATE OR REPLACE VIEW TV_FIN_CCC AS
  SELECT CCC.NUMDOC AS DOCUME,
         COALESCE(CCC.CODFIL,'')||COALESCE(CCC.SEQUEN ,'')AS CHVFIN,
         CCC.CODFIL AS FILREC,
         DCCC.FILCCC AS FILCTA, DCCC.SEQCCC AS SEQCTA, DCCC.TIPCCC AS TIPCTA,
         CCC.DATOPE AS DATPGT,
         CCC.VLRLAN AS VLRPGT,
         CCC.FILUSU, CCC.CODUSU,
         CCC.FILCLI, CCC.CODCLI,
         CCC.COMPLE AS OBSERV,
	 CAST(' ' AS VARCHAR(1)) AS COMPLE,
         CCC.CODVEN AS CODFIL,
         CCC.SEQVEN AS SEQUEN,CCC.NUMPAR,CCC.SUBPAR,
         CAST('Pago' AS VARCHAR(4)) AS FLGEST,
         CAST('R' AS VARCHAR(1)) AS FLGFLX,
         CAST('CCC' AS VARCHAR(3)) AS TABORI,
         CAST('Conta Corrente' AS VARCHAR(15)) AS NOMORI,
         DCCC.DESCCC AS MEIO_P
    FROM TT_CCC CCC   INNER JOIN TD_CCC DCCC ON CCC.TIPCCC = DCCC.CODTAB
   -- Ignora lancamentos de Faturamento, pois gera tambem TT_REC
   WHERE CCC.STATUS <> 'F'
 ;




/*-- SEQ 2237 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIN_CHR CASCADE;

/*-- SEQ 2238 --*/
CREATE OR REPLACE VIEW TV_FIN_CHR AS
  SELECT RTRIM(LTRIM(COALESCE(CHR.CODBCO,'')))||'-'||
         RTRIM(LTRIM(COALESCE(CHR.CODAGE,'')))||'-'||
         RTRIM(LTRIM(COALESCE(CHR.NUMCON,'')))||'-'||
         RTRIM(LTRIM(COALESCE(CHR.NUMCHE,''))) AS DOCUME,
         COALESCE(CHR.CODFIL,'')||COALESCE(CHR.SEQUEN,'') AS CHVFIN,
         CHR.CODFIL AS FILREC,
         DCOB.FILCTA, DCOB.SEQCTA, DCOB.TIPCTA,
         CHR.PAGAME AS DATPGT,
         CHR.VLRCHE-COALESCE(CHR.VLRDIF,0) AS VLRPGT,
         CHR.FILUSU, CHR.CODUSU,
         COALESCE( CLI.FILCLI, CFG.VC_FILCLI ) AS FILCLI,
         COALESCE( CLI.CODCLI, CFG.VC_CODCLI ) AS CODCLI,
         ' ' AS OBSERV,
	       CAST(' ' AS VARCHAR(1)) AS COMPLE,
         CHR.CODFIL, 
         CHR.SEQUEN, 
         ' 1' AS NUMPAR, 
         ' 0' AS SUBPAR,
         CASE CHR.FLGEST WHEN 'A' THEN 'A Depositar'
                         WHEN 'U' THEN 'Custodiado'
                         WHEN 'B' THEN 'Cobrado'
                         WHEN 'C' THEN 'Compensado'
                         WHEN 'D' THEN 'Depositado'
                         WHEN 'P' THEN 'Pr-Descontado'
                         WHEN 'S' THEN 'Substitudo'
                         WHEN 'V' THEN 'Devolvido'
                         WHEN 'X' THEN 'Estornado'
                         WHEN 'R' THEN 'Em circulacao'
                         WHEN 'I' THEN 'Incobrvel'
         END AS FLGEST,
         'R' AS FLGFLX,
         'CHR' AS TABORI,
         'Cheques' AS NOMORI,
         'Cheques' AS MEIO_P
    FROM TT_CHR CHR LEFT OUTER JOIN TT_CLI CLI  ON CHR.NUMDOC = CLI.NUMDOC
                         INNER JOIN TD_COB DCOB ON CHR.PORTAD = DCOB.CODTAB,
         TT_CFG CFG
   WHERE CHR.FLGEST IN ('P','C')
UNION ALL
  SELECT RTRIM(LTRIM(COALESCE(CHR.CODBCO,'')))||'-'||
         RTRIM(LTRIM(COALESCE(CHR.CODAGE,'')))||'-'||
         RTRIM(LTRIM(COALESCE(CHR.NUMCON,'')))||'-'||
         RTRIM(LTRIM(COALESCE(CHR.NUMCHE,''))) AS DOCUME,
         COALESCE(CHR.CODFIL,'')||COALESCE(CHR.SEQUEN,'') AS CHVFIN,
         CHR.CODFIL AS FILREC,
         DCOB.FILCTA, DCOB.SEQCTA, DCOB.TIPCTA,
         CHR.DATVEN AS DATPGT,
         CHR.VLRCHE AS VLRPGT,
         CHR.FILUSU, CHR.CODUSU,
         COALESCE( CLI.FILCLI, CFG.VC_FILCLI ) AS FILCLI,
         COALESCE( CLI.CODCLI, CFG.VC_CODCLI ) AS CODCLI,
         ' ' AS OBSERV,
	 CAST(' ' AS VARCHAR(1)) AS COMPLE,
         CHR.CODFIL, 
         CHR.SEQUEN, 
         ' 1' AS NUMPAR, 
         ' 0' AS SUBPAR,
         CASE CHR.FLGEST WHEN 'A' THEN 'A Depositar'
                         WHEN 'U' THEN 'Custodiado'
                         WHEN 'B' THEN 'Cobrado'
                         WHEN 'C' THEN 'Compensado'
                         WHEN 'D' THEN 'Depositado'
                         WHEN 'P' THEN 'Pr-Descontado'
                         WHEN 'S' THEN 'Substitudo'
                         WHEN 'V' THEN 'Devolvido'
                         WHEN 'X' THEN 'Estornado'
                         WHEN 'R' THEN 'Em circulacao'
                         WHEN 'I' THEN 'Incobrvel'
         END AS FLGEST,
         'A' AS FLGFLX,
         'CHR' AS TABORI,
         'Cheques' AS NOMORI,
         'Cheques' AS MEIO_P
    FROM TT_CHR CHR LEFT OUTER JOIN TT_CLI CLI ON CHR.NUMDOC = CLI.NUMDOC
                         INNER JOIN TD_COB DCOB ON CHR.PORTAD = DCOB.CODTAB,
         TT_CFG CFG
   WHERE CHR.FLGEST NOT IN ('X','P','C')
 ;





/*-- SEQ 2239 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIN_COM CASCADE;

/*-- SEQ 2240 --*/
CREATE OR REPLACE VIEW TV_FIN_COM AS
  SELECT COALESCE(COM.CODSER,'')||'/'||lTrim(COALESCE(COM.SUBSER,''))||'-'||lTrim(COALESCE(COM.NUMNOT,'')) AS DOCUME,
         COALESCE(PAG.CODFIL,'')||COALESCE(PAG.SEQUEN ,'')AS CHVFIN,
         COM.CODFIL AS FILREC,
         COM.FILCTA, COM.SEQCTA, COM.TIPCTA,
         DOP.DATPGT    AS DATPGT,
         CASE WHEN COM.SEQCTA IS NULL THEN ParcelasTVFINCOM(COM.CODFIL,COM.SEQUEN,PAG.VLRPAR,FAT.SEQUEN) * -1
                                      ELSE (PAG.VLRPGT*-1)-JurosDescontos('PAG',PAG.CODFIL,PAG.SEQUEN,PAG.NUMPAR,PAG.SUBPAR) 
         END AS VLRPGT,
         PAG.FILUSU, PAG.CODUSU,
         COM.FILFOR AS FILCLI, COM.CODFOR AS CODCLI,
         COM.OBSERV AS OBSERV,
	 COM.OBSFAT AS COMPLE,
         PAG.CODFIL,PAG.SEQUEN, PAG.NUMPAR, PAG.SUBPAR,
         CAST('Pago' AS VARCHAR(4)) AS FLGEST,
         COALESCE(DSTD.FLGFLX,'R') AS FLGFLX,
         CAST('COM' AS VARCHAR(3)) AS TABORI,
         CAST('Compras' AS VARCHAR(7)) AS NOMORI
    FROM TT_PAG PAG INNER JOIN TT_COM COM ON PAG.CODFIL = COM.CODFIL AND PAG.SEQUEN = COM.SEQUEN
                    INNER JOIN TT_DOP DOP ON PAG.FILDOP = DOP.CODFIL AND PAG.SEQDOP = DOP.SEQUEN
                    INNER JOIN TD_STD DSTD ON DOP.DOMDOP = DSTD.DOMDOP AND DOP.STDDOP = DSTD.CODTAB AND DOP.FLGEST = DSTD.USOSTD    
               LEFT OUTER JOIN TT_COM FAT ON COM.CODFIL = FAT.CODFIL AND COM.SEQUEN = FAT.SEQFAT
   WHERE PAG.FLGEST = 'P'
     AND COM.FLGEST <> 'D'   
     AND DOP.FLGEST <> 'C'
UNION ALL
  SELECT COALESCE(COM.CODSER,'')||'/'||lTrim(COALESCE(COM.SUBSER,''))||'-'||lTrim(COALESCE(COM.NUMNOT,'')) AS DOCUME,
         COALESCE(PAG.CODFIL,'')||COALESCE(PAG.SEQUEN ,'') AS CHVFIN,
         COM.CODFIL AS FILREC,
         COM.FILCTA, COM.SEQCTA, COM.TIPCTA,
         PAG.DATVEN    AS DATPGT,
         PAG.VLRPAR*-1 AS VLRPGT,
         PAG.FILUSU, PAG.CODUSU,
         COM.FILFOR AS FILCLI, 
         COM.CODFOR AS CODCLI,
         COM.OBSERV AS OBSERV,
	 COM.OBSFAT AS COMPLE,
         PAG.CODFIL,PAG.SEQUEN, PAG.NUMPAR, PAG.SUBPAR,
         CAST('Em Aberto' AS VARCHAR(10)) AS FLGEST,
         CAST('A' AS VARCHAR(1)) AS FLGFLX,
         CAST('COM' AS VARCHAR(3)) AS TABORI,
         CAST('Compras' AS VARCHAR(7)) AS NOMORI
    FROM TT_PAG PAG INNER JOIN  TT_COM COM ON PAG.CODFIL = COM.CODFIL AND PAG.SEQUEN = COM.SEQUEN
   WHERE PAG.FLGEST NOT IN ('C','X','P')
     AND COM.FLGEST <> 'D'
     AND COM.SEQCTA IS NOT NULL     
UNION ALL
  SELECT COALESCE(COM.CODSER,'')||'/'||lTrim(COALESCE(COM.SUBSER,''))||'-'||lTrim(COALESCE(COM.NUMNOT,'')) AS DOCUME,
         COALESCE(PAG.CODFIL,'')||COALESCE(PAG.SEQUEN ,'') AS CHVFIN,
         COM.CODFIL AS FILREC,
         COM.FILCTA, COM.SEQCTA, COM.TIPCTA,
         PAG.DATVEN    AS DATPGT,
         ParcelasTVFINCOM(COM.CODFIL,COM.SEQUEN,PAG.VLRPAR,FAT.SEQUEN) * -1 AS VLRPGT,
         PAG.FILUSU, PAG.CODUSU,
         COM.FILFOR AS FILCLI, 
         COM.CODFOR AS CODCLI,
         COM.OBSERV AS OBSERV,
	 COM.OBSFAT AS COMPLE,
         COM.CODFIL,COM.SEQUEN, 
         PAG.NUMPAR, PAG.SUBPAR,
         CAST('Em Aberto' AS VARCHAR(10)) AS FLGEST,
         CAST('A' AS VARCHAR(1)) AS FLGFLX,
         CAST('COM' AS VARCHAR(3)) AS TABORI,
         CAST('Compras' AS VARCHAR(7)) AS NOMORI
    FROM TT_COM FAT INNER JOIN TT_COM COM ON COM.CODFIL=FAT.CODFIL AND COM.SEQFAT=FAT.SEQUEN
                    INNER JOIN TT_PAG PAG ON FAT.CODFIL = PAG.CODFIL AND FAT.SEQUEN=PAG.SEQUEN 
   WHERE PAG.FLGEST NOT IN ('C','X','P')
     AND COM.FLGEST <> 'D'
     AND FAT.SEQCTA IS NULL               
 ;


/*-- SEQ 2241 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIN_DOP CASCADE;

/*-- SEQ 2242 --*/
CREATE OR REPLACE VIEW TV_FIN_DOP AS
SELECT /*+RULE*/
       DOP.NUMDOC AS DOCUME,
       COALESCE(DOP.CODFIL,'')||COALESCE(DOP.SEQUEN,'') AS CHVFIN,
       DOP.CODFIL AS FILREC,
       DOP.FILCTA, DOP.SEQCTA, DOP.TIPCTA,
       DOP.DATPGT,
       min(DOP.VLRDOC)*-1 AS VLRPGT,
       min(DOP.FILUSU) AS FILUSU, 
       min(DOP.CODUSU) AS CODUSU,
       CASE count(*) WHEN 1 THEN min(COM.FILFOR)
                     ELSE ' '
       END AS FILCLI,
       CASE count(*) WHEN 1 THEN min(COM.CODFOR) 
                     ELSE ' '
       END AS CODCLI,
       min(DOP.OBSERV) AS OBSERV,
       CAST(' ' AS VARCHAR(1)) AS COMPLE,
       DOP.CODFIL,DOP.SEQUEN,
       CAST(' ' AS VARCHAR(1)) AS NUMPAR,
       CAST(' ' AS VARCHAR(1)) AS SUBPAR,
       min(DSTD.DESSTD) AS FLGEST,
       MIN(COALESCE(DSTD.FLGFLX,'R')) AS FLGFLX,
       CAST('DOP' AS VARCHAR(3)) AS TABORI,
       CAST('Doc. de Pagamento' AS VARCHAR(17)) AS NOMORI
  FROM TT_DOP DOP INNER JOIN TT_PAG PAG  ON PAG.FILDOP = DOP.CODFIL  AND PAG.SEQDOP = DOP.SEQUEN
                  INNER JOIN TT_COM COM  ON PAG.CODFIL = COM.CODFIL  AND PAG.SEQUEN = COM.SEQUEN  
                  INNER JOIN TD_STD DSTD ON DOP.DOMDOP = DSTD.DOMDOP 
                                        AND DOP.STDDOP = DSTD.CODTAB
                                        AND DOP.FLGEST = DSTD.USOSTD
 WHERE DOP.FLGEST <> 'C'
 GROUP BY DOP.NUMDOC,
          DOP.CODFIL, DOP.SEQUEN,
          DOP.FILCTA, DOP.SEQCTA,
          DOP.TIPCTA, DOP.DATPGT
UNION ALL
SELECT /*+RULE*/
       DOP.NUMDOC AS DOCUME,
       COALESCE(DOP.CODFIL,'')||COALESCE(DOP.SEQUEN,'') AS CHVFIN,
       DOP.CODFIL AS FILREC,
       DOP.FILCTA, DOP.SEQCTA, DOP.TIPCTA,
       DOP.DATPGT,
       min(DOP.VLRDOC)*-1 AS VLRPGT,
       min(DOP.FILUSU) AS FILUSU, 
       min(DOP.CODUSU) AS CODUSU,
       min(DOP.FILCLI) AS FILCLI,
       min(DOP.CODCLI) AS CODCLI,
       min(DOP.OBSERV) AS OBSERV,
       CAST(' ' AS VARCHAR(1)) AS COMPLE,
       DOP.CODFIL,DOP.SEQUEN,
       CAST(' ' AS VARCHAR(1)) AS NUMPAR,
       CAST(' ' AS VARCHAR(1)) AS SUBPAR,
       min(DSTD.DESSTD) AS FLGEST,
       MIN(COALESCE(DSTD.FLGFLX,'R')) AS FLGFLX,
       CAST('DOP' AS VARCHAR(3)) AS TABORI,
       CAST('Doc. de Pagamento' AS VARCHAR(17)) AS NOMORI
  FROM TT_DOP DOP INNER JOIN TD_STD DSTD ON DOP.DOMDOP = DSTD.DOMDOP 
                                        AND DOP.STDDOP = DSTD.CODTAB
                                        AND DOP.FLGEST = DSTD.USOSTD
 WHERE DOP.FLGEST <> 'C' AND DOP.CHETRO = 'T'
 GROUP BY DOP.NUMDOC,
          DOP.CODFIL, DOP.SEQUEN,
          DOP.FILCTA, DOP.SEQCTA,
          DOP.TIPCTA, DOP.DATPGT
 ;


/*-- SEQ 2243 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIN_F_G CASCADE;

/*-- SEQ 2244 --*/
CREATE OR REPLACE VIEW TV_FIN_F_G AS
  SELECT FIN.NUMDOC AS DOCUME,
         COALESCE(FIN.CODFIL,'')||COALESCE(FIN.SEQUEN ,'') AS CHVFIN,
         FIN.CODFIL AS FILREC,
         FIN.FILGER AS FILCTA, 
         FIN.SEQGER AS SEQCTA, 
         FIN.TIPGER AS TIPCTA,
         FIN.DATOPE AS DATPGT,
         CASE WHEN FIN.NUMDOC = 'SANGRIA' 
	      THEN FIN.VLRMOV*-1 
	      ELSE FIN.VLRMOV
	 END AS VLRPGT,
         FIN.FILUSU, 
         FIN.CODUSU,
         CFG.VC_FILCLI AS FILCLI, 
         CFG.VC_CODCLI AS CODCLI,
         FIN.OBSERV,
         CAST(' ' AS VARCHAR(1)) AS COMPLE,
         FIN.CODFIL, 
         FIN.SEQUEN, 
         CAST(' 1' AS VARCHAR(2)) AS NUMPAR, 
         CAST(' 0' AS VARCHAR(2)) AS SUBPAR,
         CAST('Pago' AS VARCHAR(4)) AS FLGEST,
         CAST('R' AS VARCHAR(1)) AS FLGFLX,
         CAST('F_G' AS VARCHAR(3)) AS TABORI,
         CAST('Financeira Gerencial' AS VARCHAR(20)) AS NOMORI
    FROM TT_CFG CFG, TT_FIN FIN
    WHERE FIN.TIPGER <> 'M'
 ;


/*-- SEQ 2245 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIN_F_N CASCADE;

/*-- SEQ 2246 --*/
CREATE OR REPLACE VIEW TV_FIN_F_N AS
  SELECT FIN.NUMDOC AS DOCUME,
         COALESCE(FIN.CODFIL,'')||COALESCE(FIN.SEQUEN ,'') AS CHVFIN,
         FIN.CODFIL AS FILREC,
         FIN.FILNUM AS FILCTA, 
         FIN.SEQNUM AS SEQCTA, 
         FIN.TIPNUM AS TIPCTA,
         FIN.DATOPE AS DATPGT,
         FIN.VLRMOV AS VLRPGT,
         FIN.FILUSU, 
         FIN.CODUSU,
         CFG.VC_FILCLI AS FILCLI, 
         CFG.VC_CODCLI AS CODCLI,
         FIN.OBSERV,
	 CAST(' ' AS VARCHAR(1)) AS COMPLE,
         FIN.CODFIL, 
         FIN.SEQUEN, 
         TO_CHAR(' 1') AS NUMPAR, 
         TO_CHAR(' 0') AS SUBPAR,
         TO_CHAR('Pago') AS FLGEST,
         TO_CHAR('R') AS FLGFLX,
         TO_CHAR('F_N') AS TABORI,
         TO_CHAR('Financeira Numeraria') AS NOMORI
    FROM TT_CFG CFG, TT_FIN FIN
 ;


/*-- SEQ 2247 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIN_JDP CASCADE;

/*-- SEQ 2248 --*/
CREATE OR REPLACE VIEW TV_FIN_JDP AS
/* JUROS E DESCONTOS NA PAG (COMPRAS,FRETES,TITULOS) */
  SELECT COALESCE(COM.CODSER,'')||'/'||lTrim(COALESCE(COM.SUBSER,''))||'-'||lTrim(COALESCE(COM.NUMNOT,'')) AS DOCUME,
         COALESCE(PAG.CODFIL,'')||COALESCE(PAG.SEQUEN ,'')AS CHVFIN,
         COM.CODFIL AS FILREC,
         DCTA.FILCTA, 
         DCTA.SEQCTA, 
         DCTA.TIPCTA,
         PAG.DATPGT AS DATPGT,
         JurosDescontos('PAG',PAG.CODFIL,PAG.SEQUEN,PAG.NUMPAR,PAG.SUBPAR) AS VLRPGT,
         PAG.FILUSU, PAG.CODUSU,
         COM.FILFOR AS FILCLI, 
         COM.CODFOR AS CODCLI,
         COM.OBSERV,
	 COM.OBSFAT AS COMPLE,
         PAG.CODFIL,PAG.SEQUEN, PAG.NUMPAR, PAG.SUBPAR,
         CAST('Pago' AS VARCHAR(4)) AS FLGEST,
         COALESCE(DSTD.FLGFLX,'R') AS FLGFLX,
         CAST('JDP' AS VARCHAR(3)) AS TABORI,
         CAST('Desc. Obtidos' AS VARCHAR(13)) AS NOMORI
    FROM TT_PAG PAG INNER JOIN TT_COM COM ON PAG.CODFIL = COM.CODFIL AND PAG.SEQUEN = COM.SEQUEN
                    INNER JOIN TT_DOP DOP ON PAG.FILDOP = DOP.CODFIL AND PAG.SEQDOP = DOP.SEQUEN
                    INNER JOIN TD_STD DSTD ON DOP.DOMDOP = DSTD.DOMDOP AND DOP.STDDOP = DSTD.CODTAB AND DOP.FLGEST = DSTD.USOSTD
         ,TD_CTA DCTA
   WHERE DCTA.CFGCOL='TIPCTA_DES_OBT'
     AND PAG.FLGEST = 'P'
     AND COM.FLGEST <> 'D'   
     AND DOP.FLGEST <> 'C'
     AND JurosDescontos('PAG',PAG.CODFIL,PAG.SEQUEN,PAG.NUMPAR,PAG.SUBPAR) > 0
UNION ALL
  SELECT COALESCE(COM.CODSER,'')||'/'||lTrim(COALESCE(COM.SUBSER,''))||'-'||lTrim(COALESCE(COM.NUMNOT,'')) AS DOCUME,
         COALESCE(PAG.CODFIL,'')||COALESCE(PAG.SEQUEN ,'')AS CHVFIN,
         COM.CODFIL AS FILREC,
         DCTA.FILCTA, 
         DCTA.SEQCTA, 
         DCTA.TIPCTA,
         PAG.DATPGT    AS DATPGT,
         JurosDescontos('PAG',PAG.CODFIL,PAG.SEQUEN,PAG.NUMPAR,PAG.SUBPAR) AS VLRPGT,
         PAG.FILUSU, PAG.CODUSU,
         COM.FILFOR AS FILCLI, 
         COM.CODFOR AS CODCLI,
         COM.OBSERV,
	 COM.OBSFAT AS COMPLE,
         PAG.CODFIL,PAG.SEQUEN, PAG.NUMPAR, PAG.SUBPAR,
         CAST('Pago' AS VARCHAR(4)) AS FLGEST,
         COALESCE(DSTD.FLGFLX,'R') AS FLGFLX,
         CAST('JDP' AS VARCHAR(3)) AS TABORI,
         CAST('Juros Pagos' AS VARCHAR(12)) AS NOMORI
    FROM TT_PAG PAG INNER JOIN TT_COM COM ON PAG.CODFIL = COM.CODFIL AND PAG.SEQUEN = COM.SEQUEN
                    INNER JOIN TT_DOP DOP ON PAG.FILDOP = DOP.CODFIL AND PAG.SEQDOP = DOP.SEQUEN
                    INNER JOIN TD_STD DSTD ON DOP.DOMDOP = DSTD.DOMDOP AND DOP.STDDOP = DSTD.CODTAB AND DOP.FLGEST = DSTD.USOSTD
         ,TD_CTA DCTA
   WHERE DCTA.CFGCOL='TIPCTA_JUR_PAG'
     AND PAG.FLGEST = 'P'
     AND COM.FLGEST <> 'D'   
     AND DOP.FLGEST <> 'C'
     AND JurosDescontos('PAG',PAG.CODFIL,PAG.SEQUEN,PAG.NUMPAR,PAG.SUBPAR) < 0
UNION ALL
  SELECT COALESCE(COM.CODSER,'')||'/'||lTrim(COALESCE(COM.SUBSER,''))||'-'||lTrim(COALESCE(COM.NUMNOT,'')) AS DOCUME,
         COALESCE(PAG.CODFIL,'')||COALESCE(PAG.SEQUEN ,'') AS CHVFIN,
         COM.CODFIL AS FILREC,
         DCTA.FILCTA, 
         DCTA.SEQCTA, 
         DCTA.TIPCTA,
         PAG.DATVEN    AS DATPGT,
         JurosDescontos('PAG',PAG.CODFIL,PAG.SEQUEN,PAG.NUMPAR,PAG.SUBPAR) AS VLRPGT,
         PAG.FILUSU, PAG.CODUSU,
         COM.FILFOR AS FILCLI, 
         COM.CODFOR AS CODCLI,
         COM.OBSERV,
	 COM.OBSFAT AS COMPLE,
         PAG.CODFIL,PAG.SEQUEN, PAG.NUMPAR, PAG.SUBPAR,
         CAST('Em Aberto' AS VARCHAR(10)) AS FLGEST,
         CAST('A' AS VARCHAR(1)) AS FLGFLX,
         CAST('JDP' AS VARCHAR(3)) AS TABORI,
         CAST('Juros a Pagar' AS VARCHAR(15)) AS NOMORI
    FROM TT_PAG PAG INNER JOIN TT_COM COM ON PAG.CODFIL = COM.CODFIL AND PAG.SEQUEN = COM.SEQUEN
         ,TD_CTA DCTA
   WHERE DCTA.CFGCOL='TIPCTA_JUR_PAG'
     AND PAG.FLGEST NOT IN ('C','X','P')
     AND COM.FLGEST <> 'D'           
     AND JurosDescontos('PAG',PAG.CODFIL,PAG.SEQUEN,PAG.NUMPAR,PAG.SUBPAR) < 0
 ;





/*-- SEQ 2249 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIN_JDR CASCADE;

/*-- SEQ 2250 --*/
CREATE OR REPLACE VIEW TV_FIN_JDR AS
  SELECT COALESCE(VEN.CODSER,'')||'/'||lTrim(COALESCE(VEN.NUMECF,''))||'-'||lTrim(COALESCE(VEN.NUMNOT,'')) AS DOCUME,
         COALESCE(REC.CODFIL,'')||COALESCE(REC.SEQUEN ,'')AS CHVFIN,
         REC.FILREC,
         DCTA.FILCTA, 
         DCTA.SEQCTA, 
         DCTA.TIPCTA,
         REC.PAGAME AS DATPGT,
         CASE WHEN REC.CARTAO IS NULL THEN JurosDescontos('REC',REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)
              ELSE 0
         END AS VLRPGT,
         REC.FILUSU, REC.CODUSU,
         VEN.FILCLI, VEN.CODCLI,
         VEN.OBSERV,
         CAST(' ' AS VARCHAR(1)) AS COMPLE,
         REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR,
         COALESCE('Pago' ,'')AS FLGEST,
         CASE COALESCE(CHR.FLGEST,'.') WHEN '.' THEN 'R'
                                       ELSE CASE CHR.FLGEST WHEN 'P' THEN 'R'
                                                            WHEN 'C' THEN 'R'
                                                            ELSE 'A'
                                            END
         END AS FLGFLX,
         CAST('JDR' AS VARCHAR(3)) AS TABORI,
         CAST('Juros Cobrados' AS VARCHAR(15)) AS NOMORI
    FROM TT_REC REC INNER JOIN TT_VEN VEN  ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
                    INNER JOIN TD_CTR DCTR ON DCTR.CODTAB = VEN.CODCTR
               LEFT OUTER JOIN TT_CHR CHR  ON REC.FILREC = CHR.CODFIL AND REC.SEQCHE = CHR.SEQUEN
         ,TD_CTA DCTA
   WHERE DCTA.CFGCOL='TIPCTA_JUR_REC'
     AND REC.FLGEST = 'P'
     AND VEN.FINANC = 'T'
     AND VEN.FLGEST <> 'C'
     AND JurosDescontos('REC',REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) > 0
UNION ALL
  SELECT COALESCE(VEN.CODSER,'')||'/'||lTrim(COALESCE(VEN.NUMECF,''))||'-'||lTrim(COALESCE(VEN.NUMNOT,'')) AS DOCUME,
         COALESCE(REC.CODFIL,'')||COALESCE(REC.SEQUEN ,'') AS CHVFIN,
         REC.FILREC,
         DCTA.FILCTA, 
         DCTA.SEQCTA, 
         DCTA.TIPCTA,
         REC.PAGAME AS DATPGT,
         CASE WHEN REC.CARTAO IS NULL THEN JurosDescontos('REC',REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)
              ELSE 0
         END AS VLRPGT,
         REC.FILUSU, REC.CODUSU,
         VEN.FILCLI, VEN.CODCLI,
         VEN.OBSERV,
         CAST(' ' AS VARCHAR(1)) AS COMPLE,
         REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR,
         CAST('Pago' AS VARCHAR(4)) AS FLGEST,
         CASE COALESCE(CHR.FLGEST,'.') WHEN '.' THEN 'R' 
                                       ELSE CASE CHR.FLGEST WHEN 'P' THEN 'R'
                                                            WHEN 'C' THEN 'R'
                                                            ELSE 'A'
                                            END
         END AS FLGFLX,
         CAST('JDR' AS VARCHAR(3)) AS TABORI,
         CAST('Desc. Concedidos' AS VARCHAR(16)) AS NOMORI
    FROM TT_REC REC INNER JOIN TT_VEN VEN ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
                    INNER JOIN TD_CTR DCTR ON DCTR.CODTAB = VEN.CODCTR
               LEFT OUTER JOIN TT_CHR CHR ON REC.FILREC = CHR.CODFIL AND REC.SEQCHE = CHR.SEQUEN
         ,TD_CTA DCTA
   WHERE DCTA.CFGCOL='TIPCTA_DES_CON'
     AND REC.FLGEST = 'P'
     AND VEN.FINANC = 'T'
     AND VEN.FLGEST <> 'C'
     AND JurosDescontos('REC',REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) < 0
UNION ALL
  SELECT COALESCE(VEN.CODSER,'')||'/'||lTrim(COALESCE(VEN.NUMECF,''))||'-'||lTrim(COALESCE(VEN.NUMNOT,'')) AS DOCUME,
         COALESCE(REC.CODFIL,'')||COALESCE(REC.SEQUEN ,'') AS CHVFIN,
         REC.FILREC,
         DCTA.FILCTA, 
         DCTA.SEQCTA, 
         DCTA.TIPCTA,
         REC.DATVEN AS DATPGT,
         CASE WHEN REC.CARTAO IS NULL THEN JurosDescontos('REC',REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)
              ELSE 0
         END AS VLRPGT,
         REC.FILUSU, REC.CODUSU,
         VEN.FILCLI, VEN.CODCLI,
         VEN.OBSERV,
         CAST(' ' AS VARCHAR(1)) AS COMPLE,
         REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR,
         CAST('Em Aberto' AS VARCHAR(10)) AS FLGEST,
         CAST('A' AS VARCHAR(1)) AS FLGFLX,
         CAST('JDR' AS VARCHAR(3)) AS TABORI,
         CAST('Juros a Cobrar' AS VARCHAR(15)) AS NOMORI
    FROM TT_REC REC INNER JOIN TT_VEN VEN ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
                    INNER JOIN TD_CTR DCTR ON DCTR.CODTAB = VEN.CODCTR
         ,TD_CTA DCTA
   WHERE DCTA.CFGCOL='TIPCTA_JUR_REC'
     AND REC.FLGEST NOT IN ('C','X','P')
     AND VEN.FINANC = 'T'
     AND VEN.FLGEST <> 'C'
     AND JurosDescontos('REC',REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) > 0
 ;





/*-- SEQ 2251 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIN_JDT CASCADE;

/*-- SEQ 2252 --*/
CREATE OR REPLACE VIEW TV_FIN_JDT AS
  SELECT COALESCE(TRC.CODSER,'')||'-'||lTrim(COALESCE(TRC.NUMNOT,'')) AS DOCUME,
         COALESCE(TRC.CODFIL,'')||COALESCE(TRC.SEQUEN,'') AS CHVFIN,
         TRC.CODFIL AS FILREC,
         DCTA.FILCTA, 
         DCTA.SEQCTA, 
         DCTA.TIPCTA,
         PTR.DATPGT AS DATPGT,
         JurosDescontos('PTR',PTR.CODFIL,PTR.SEQUEN,PTR.NUMPAR,PTR.SUBPAR) AS VLRPGT,
         PTR.FILUSU, 
         PTR.CODUSU,
         TRC.FILPAR AS FILCLI,
         TRC.CODPAR AS CODCLI,
         TRC.OBSERV,
         CAST(' ' AS VARCHAR(1)) AS COMPLE,
         PTR.CODFIL,PTR.SEQUEN,PTR.NUMPAR,PTR.SUBPAR,
         CAST('Pago' AS VARCHAR(4)) AS FLGEST,
         CAST('R' AS VARCHAR(1)) AS FLGFLX,
         CAST('JDT' AS VARCHAR(3)) AS TABORI,
         CAST('Juros Cobrados' AS VARCHAR(14)) AS NOMORI
    FROM TT_PTR PTR INNER JOIN TT_TRC TRC ON PTR.CODFIL = TRC.CODFIL AND PTR.SEQUEN = TRC.SEQUEN
         ,TD_CTA DCTA
   WHERE DCTA.CFGCOL='TIPCTA_JUR_REC'
     AND PTR.FLGEST = 'P'
     AND TRC.FLGEST NOT IN ('X','C')
     AND JurosDescontos('PTR',PTR.CODFIL,PTR.SEQUEN,PTR.NUMPAR,PTR.SUBPAR) > 0
UNION ALL
  SELECT COALESCE(TRC.CODSER,'')||'-'||lTrim(COALESCE(TRC.NUMNOT,'')) AS DOCUME,
         COALESCE(TRC.CODFIL,'')||COALESCE(TRC.SEQUEN,'') AS CHVFIN,
         TRC.CODFIL AS FILREC,
         DCTA.FILCTA, 
         DCTA.SEQCTA, 
         DCTA.TIPCTA,
         PTR.DATPGT AS DATPGT,
         JurosDescontos('PTR',PTR.CODFIL,PTR.SEQUEN,PTR.NUMPAR,PTR.SUBPAR) AS VLRPGT,
         PTR.FILUSU, 
         PTR.CODUSU,
         TRC.FILPAR AS FILCLI, 
         TRC.CODPAR AS CODCLI,
         TRC.OBSERV,
         CAST(' ' AS VARCHAR(1)) AS COMPLE,
         PTR.CODFIL,
         PTR.SEQUEN,
         PTR.NUMPAR,
         PTR.SUBPAR,
         'Pago' AS FLGEST,
         'R' AS FLGFLX,
         'JDT' AS TABORI,
         'Desc. Concedidos' AS NOMORI
    FROM TT_PTR PTR INNER JOIN TT_TRC TRC ON PTR.CODFIL = TRC.CODFIL AND PTR.SEQUEN = TRC.SEQUEN
         ,TD_CTA DCTA
   WHERE DCTA.CFGCOL='TIPCTA_DES_CON'
     AND PTR.FLGEST = 'P'
     AND TRC.FLGEST NOT IN ('X','C')
     AND JurosDescontos('PTR',PTR.CODFIL,PTR.SEQUEN,PTR.NUMPAR,PTR.SUBPAR) < 0
UNION ALL
  SELECT COALESCE(TRC.CODSER,'')||'-'||lTrim(COALESCE(TRC.NUMNOT,'')) AS DOCUME,
         COALESCE(TRC.CODFIL,'')||COALESCE(TRC.SEQUEN,'') AS CHVFIN,
         TRC.CODFIL AS FILREC,
         DCTA.FILCTA, 
         DCTA.SEQCTA, 
         DCTA.TIPCTA,
         PTR.DATVEN AS DATPGT,
         JurosDescontos('PTR',PTR.CODFIL,PTR.SEQUEN,PTR.NUMPAR,PTR.SUBPAR) AS VLRPGT,
         PTR.FILUSU, 
         PTR.CODUSU,
         TRC.FILPAR AS FILCLI,
         TRC.CODPAR AS CODCLI,
         TRC.OBSERV,
         CAST(' ' AS VARCHAR(1)) AS COMPLE,
         PTR.CODFIL,
         PTR.SEQUEN,
         PTR.NUMPAR,
         PTR.SUBPAR,
         CAST('Em Aberto' AS VARCHAR(9)) AS FLGEST,
         CAST('A' AS VARCHAR(1)) AS FLGFLX,
         CAST('JDT' AS VARCHAR(3)) AS TABORI,
         CAST('Juros a Cobrar' AS VARCHAR(15)) AS NOMORI
    FROM TT_PTR PTR INNER JOIN TT_TRC TRC ON PTR.CODFIL = TRC.CODFIL AND PTR.SEQUEN = TRC.SEQUEN
         ,TD_CTA DCTA
   WHERE DCTA.CFGCOL='TIPCTA_JUR_REC'
     AND PTR.FLGEST NOT IN ('X','C','P')
     AND TRC.FLGEST NOT IN ('X','C')
     AND JurosDescontos('PTR',PTR.CODFIL,PTR.SEQUEN,PTR.NUMPAR,PTR.SUBPAR) > 0
 ;


/*-- SEQ 2253 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIN_LIM CASCADE;

/*-- SEQ 2254 --*/
CREATE OR REPLACE VIEW TV_FIN_LIM AS
  SELECT TO_CHAR(' ') AS DOCUME,
         COALESCE(LIM.FILCLI,'')||COALESCE(LIM.CODCLI,'')||COALESCE(TO_CHAR(LIM.TIPCCC),'') AS CHVFIN,
         IDF.CODLOJ AS FILREC,
         DCCC.FILCCC AS FILCTA, DCCC.SEQCCC AS SEQCTA, DCCC.TIPCCC AS TIPCTA,
         COALESCE(LIM.DATA,AGORA()) AS DATPGT,
         LIM.VSALDO*-1 AS VLRPGT,
         USU.FILUSU,
         USU.CODUSU,
         TO_CHAR(' ') AS OBSERV,
	 CAST(' ' AS VARCHAR(1)) AS COMPLE,
         LIM.FILCLI,
         LIM.CODCLI,
         LIM.FILCLI AS CODFIL,
         TO_CHAR(' ') AS SEQUEN,
         TO_CHAR(' ') as NUMPAR, 
         TO_CHAR(' ') as SUBPAR,
         TO_CHAR('Ativo') AS FLGEST,
         TO_CHAR('A') as FLGFLX,
         TO_CHAR('LIM') as  TABORI,
         TO_CHAR('Limite de C/C') as NOMORI,
         DCCC.DESCCC AS MEIO_P
    FROM (SELECT VSALDO, FILCLI, CODCLI, TIPCCC,
                 PROXIMOFATURAMENTO(FILCLI,CODCLI,TIPCCC,agora()) AS DATA
            FROM TT_LIM
           WHERE VSALDO <> 0) LIM INNER JOIN TD_CCC DCCC ON LIM.TIPCCC = DCCC.CODTAB
         ,TT_IDF IDF
         ,(select filusu, codusu 
            from tt_usu 
                      limit 1           ) USU
;


/*-- SEQ 2255 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIN_PAGFOR CASCADE;

/*-- SEQ 2256 --*/
CREATE OR REPLACE VIEW TV_FIN_PAGFOR AS
  SELECT COALESCE(COM.CODSER,'')||'/'||lTrim(COALESCE(COM.SUBSER,''))||'-'||lTrim(COALESCE(COM.NUMNOT,'')) AS DOCUME,
         COALESCE(PAG.CODFIL,'')||COALESCE(PAG.SEQUEN ,'') AS CHVFIN,
         COM.CODFIL AS FILREC,
         DCTA.FILCTA, 
         DCTA.SEQCTA,
         DCTA.TIPCTA,
         PAG.DATVEN    AS DATPGT,
         PAG.VLRPAR*-1 AS VLRPGT,
         PAG.FILUSU, 
         PAG.CODUSU,
         COM.FILFOR AS FILCLI,
         COM.CODFOR AS CODCLI,
         COM.OBSERV,
	 CAST(' ' AS VARCHAR(1)) AS COMPLE,
         PAG.CODFIL,PAG.SEQUEN, PAG.NUMPAR, PAG.SUBPAR,
         CAST('Em Aberto' AS VARCHAR(9)) AS FLGEST,
         CAST('A' AS VARCHAR(1)) AS FLGFLX,
         CAST('PAG' AS VARCHAR(3)) AS TABORI,
         CAST('Parc. Compras' AS VARCHAR(13)) AS NOMORI
    FROM TT_PAG PAG INNER JOIN TT_COM COM ON PAG.CODFIL = COM.CODFIL AND PAG.SEQUEN = COM.SEQUEN
         ,TD_CTA DCTA
   WHERE DCTA.CFGCOL='TIPCTA_FOR_PAG'
     AND PAG.FLGEST NOT IN ('C','X','P')
     AND COM.FLGEST <> 'D'           
     AND COM.TIPPAR = 'F'
 ;




/*-- SEQ 2257 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIN_PAGFRE CASCADE;

/*-- SEQ 2258 --*/
CREATE OR REPLACE VIEW TV_FIN_PAGFRE AS
  SELECT COALESCE(COM.CODSER,'')||'/'||lTrim(COALESCE(COM.SUBSER,''))||'-'||lTrim(COALESCE(COM.NUMNOT,'')) AS DOCUME,
         COALESCE(PAG.CODFIL,'')||COALESCE(PAG.SEQUEN ,'')AS CHVFIN,
         COM.CODFIL AS FILREC,
         DCTA.FILCTA, 
         DCTA.SEQCTA,
         DCTA.TIPCTA,
         PAG.DATVEN    AS DATPGT,
         PAG.VLRPAR*-1 AS VLRPGT,
         PAG.FILUSU, 
         PAG.CODUSU,
         COM.FILFOR AS FILCLI, 
         COM.CODFOR AS CODCLI,
         COM.OBSERV,
	 CAST(' ' AS VARCHAR(1)) AS COMPLE,
         PAG.CODFIL,PAG.SEQUEN, PAG.NUMPAR, PAG.SUBPAR,
         CAST('Em Aberto' AS VARCHAR(10)) AS FLGEST,
         CAST('A' AS VARCHAR(1)) AS FLGFLX,
         CAST('PAG' AS VARCHAR(3)) AS TABORI,
         CAST('Parc. Fretes' AS VARCHAR(12)) AS NOMORI
    FROM TT_COM COM INNER JOIN TT_PAG PAG ON PAG.CODFIL = COM.CODFIL AND PAG.SEQUEN = COM.SEQUEN
         ,TD_CTA DCTA
   WHERE DCTA.CFGCOL='TIPCTA_FRE_PAG'
     AND PAG.FLGEST NOT IN ('C','X','P')
     AND COM.FLGEST <> 'D'           
     AND COM.TIPPAR = 'T'
 ;




/*-- SEQ 2259 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIN_PAGTIT CASCADE;

/*-- SEQ 2260 --*/
CREATE OR REPLACE VIEW TV_FIN_PAGTIT AS
  SELECT COALESCE(COM.CODSER,'')||'/'||lTrim(COALESCE(COM.SUBSER,''))||'-'||lTrim(COALESCE(COM.NUMNOT,'')) AS DOCUME,
         COALESCE(PAG.CODFIL,'')||COALESCE(PAG.SEQUEN ,'') AS CHVFIN,
         COM.CODFIL AS FILREC,
         DCTA.FILCTA, 
         DCTA.SEQCTA,
         DCTA.TIPCTA,
         PAG.DATVEN    AS DATPGT,
         PAG.VLRPAR*-1 AS VLRPGT,
         PAG.FILUSU, 
         PAG.CODUSU,
         COM.FILFOR AS FILCLI, 
         COM.CODFOR AS CODCLI,
         COM.OBSERV,
	 CAST(' ' AS VARCHAR(1)) AS COMPLE,
         PAG.CODFIL,PAG.SEQUEN, PAG.NUMPAR, PAG.SUBPAR,
         CAST('Em Aberto' AS VARCHAR(9)) AS FLGEST,
         CAST('A' AS VARCHAR(1)) AS FLGFLX,
         CAST('PAG' AS VARCHAR(3)) AS TABORI,
         CAST('Parc. Titulos' AS VARCHAR(13)) AS NOMORI
    FROM TT_PAG PAG INNER JOIN TT_COM COM ON PAG.CODFIL = COM.CODFIL AND PAG.SEQUEN = COM.SEQUEN
         ,TD_CTA DCTA
   WHERE DCTA.CFGCOL='TIPCTA_TIT_PAG'
     AND PAG.FLGEST NOT IN ('C','X','P')
     AND COM.FLGEST <> 'D'           
     AND COM.TIPPAR IS NULL
 ;




/*-- SEQ 2261 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIN_PTR CASCADE;

/*-- SEQ 2262 --*/
CREATE OR REPLACE VIEW TV_FIN_PTR AS
  SELECT COALESCE(TRC.CODSER,'')||'-'||lTrim(COALESCE(TRC.NUMNOT,''))||' '||COALESCE(PTR.NUMPAR,'')||'/'||lTrim(COALESCE(PTR.SUBPAR,'')) AS DOCUME,
         COALESCE(PTR.CODFIL,'')||COALESCE(PTR.SEQUEN,'')||COALESCE(PTR.NUMPAR,'')||COALESCE(PTR.SUBPAR ,'') AS CHVFIN,
         PTR.CODFIL AS FILREC,
         PTR.FILCTA, 
         PTR.SEQCTA, 
         PTR.TIPCTA,
         PTR.DATPGT AS DATPGT,
         PTR.VLRPGT AS VLRPGT,
         PTR.FILUSU, 
         PTR.CODUSU,
         TRC.FILPAR AS FILCLI, 
         TRC.CODPAR AS CODCLI,
         TRC.OBSERV,
	 CAST(' ' AS VARCHAR(1)) AS COMPLE,
         PTR.CODFIL,
         PTR.SEQUEN,
         PTR.NUMPAR,
         PTR.SUBPAR, 
         'Pago' AS FLGEST,
         'R' AS FLGFLX,
         'PTR' AS TABORI,
         'Parc. Ttulos Receber' AS NOMORI,
         'Parc. Ttulos Receber' AS MEIO_P
    FROM TT_TRC TRC INNER JOIN TT_PTR PTR ON PTR.CODFIL = TRC.CODFIL AND PTR.SEQUEN = TRC.SEQUEN
   WHERE PTR.FLGEST = 'P'
     AND TRC.FLGEST NOT IN ('X','C')
UNION ALL
  SELECT COALESCE(TRC.CODSER,'')||'-'||lTrim(COALESCE(TRC.NUMNOT,''))||' '||COALESCE(PTR.NUMPAR,'')||'/'||lTrim(COALESCE(PTR.SUBPAR,'')) AS DOCUME,
         COALESCE(PTR.CODFIL,'')||COALESCE(PTR.SEQUEN,'')||COALESCE(PTR.NUMPAR,'')||COALESCE(PTR.SUBPAR ,'') AS CHVFIN,
         PTR.CODFIL AS FILREC,
         DCTA.FILCTA,
         DCTA.SEQCTA,
         DCTA.TIPCTA,
         PTR.DATVEN AS DATPGT,
         PTR.VLRPAR AS VLRPGT,
         PTR.FILUSU, 
         PTR.CODUSU,
         TRC.FILPAR AS FILCLI, 
         TRC.CODPAR AS CODCLI,
         TRC.OBSERV,
	 CAST(' ' AS VARCHAR(1)) AS COMPLE,
         PTR.CODFIL,
         PTR.SEQUEN,
         PTR.NUMPAR, 
         PTR.SUBPAR,
         'Em Aberto' AS FLGEST,
         'A' AS FLGFLX,
         'PTR' AS TABORI,
         'Parc. Ttulos Receber' AS NOMORI,
         'Parc. Ttulos Receber' AS MEIO_P
    FROM TT_TRC TRC INNER JOIN TT_PTR PTR ON PTR.CODFIL = TRC.CODFIL AND PTR.SEQUEN = TRC.SEQUEN
         ,TD_CTA DCTA
   WHERE DCTA.CFGCOL='TIPCTA_TIT_REC'
     AND PTR.FLGEST NOT IN ('X','C','P')
     AND TRC.FLGEST NOT IN ('X','C')
 ;




/*-- SEQ 2263 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIN_REC CASCADE;

/*-- SEQ 2264 --*/
CREATE OR REPLACE VIEW TV_FIN_REC AS
-- Utiliza-se Union em funcao de que cada conjunto pega por uma data diferente
-- e isto facilita o indice
 SELECT COALESCE(VEN.CODSER,'')||'/'||COALESCE(VEN.NUMECF,'')||'-'||LTRIM(COALESCE(VEN.NUMNOT,''))||'/'||COALESCE(REC.NUMPAR,'')||CASE WHEN LTRIM(RTRIM(COALESCE(REC.SUBPAR,''))) IS NULL THEN '' ELSE '-' END||lTrim(COALESCE(REC.SUBPAR,'')) AS DOCUME,
        COALESCE(REC.CODFIL,'')||COALESCE(REC.SEQUEN,'')||COALESCE(REC.NUMPAR,'')||COALESCE(REC.SUBPAR ,'') AS CHVFIN,
        COALESCE( REC.FILREC, REC.CODFIL ) AS FILREC,
        DCOB.FILCTA, DCOB.SEQCTA, DCOB.TIPCTA,
        REC.PAGAME AS DATPGT,
        REC.VLRPGT AS VLRPGT,
        REC.FILUSU, 
        REC.CODUSU,
        CASE WHEN DCAR.FILADM IS NULL THEN VEN.FILCLI ELSE DCAR.FILADM END AS FILCLI,
        CASE WHEN DCAR.CODADM IS NULL THEN VEN.CODCLI ELSE DCAR.CODADM END AS CODCLI,
        VEN.OBSERV,
        CAST(' ' AS VARCHAR(1)) AS COMPLE,
        REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR,
        CAST('Pago' AS VARCHAR(4)) AS FLGEST,
        CAST('R' AS VARCHAR(1)) AS FLGFLX,
        CAST('REC' AS VARCHAR(3)) AS TABORI,
        CAST('Recebimentos' AS VARCHAR(12)) AS NOMORI,
        CASE WHEN REC.CARTAO IS NULL THEN
              CASE WHEN REC.TIPCCC IS NULL THEN 
                   CASE WHEN BON.FILREC IS NULL THEN 'Carteira'
                        ELSE 'Bnus'
                   END
                   ELSE
                   DCCC.DESCCC
              END
              ELSE DCAR.DESOUT
        END AS MEIO_P
    FROM TT_REC REC INNER JOIN TT_VEN VEN ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
               LEFT OUTER JOIN TT_BON BON ON REC.CODFIL = BON.FILREC AND REC.SEQUEN = BON.SEQREC AND REC.NUMPAR = BON.NUMPAR AND REC.SUBPAR = BON.SUBPAR
               LEFT OUTER JOIN TD_CAR DCAR ON REC.CARTAO = DCAR.CODTAB
               LEFT OUTER JOIN TD_CCC DCCC ON REC.TIPCCC = DCCC.CODTAB 
                    INNER JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD
   WHERE REC.FLGEST = 'P'
     AND REC.SEQCHE IS NULL
     AND REC.FLGEST NOT IN ('X','C')
     AND VEN.FLGEST NOT IN ('C')
UNION ALL
 SELECT COALESCE(VEN.CODSER,'')||'/'||COALESCE(VEN.NUMECF,'')||'-'||LTRIM(COALESCE(VEN.NUMNOT,''))||'/'||COALESCE(REC.NUMPAR,'')||CASE WHEN LTRIM(RTRIM(COALESCE(REC.SUBPAR,''))) IS NULL THEN '' ELSE '-' END||lTrim(COALESCE(REC.SUBPAR,'')) AS DOCUME,
        COALESCE(REC.CODFIL,'')||COALESCE(REC.SEQUEN,'')||COALESCE(REC.NUMPAR,'')||COALESCE(REC.SUBPAR ,'')AS CHVFIN,
        COALESCE( REC.FILREC, REC.CODFIL ) AS FILREC,
        DCOB.FILCTA, DCOB.SEQCTA, DCOB.TIPCTA,
        REC.DATVEN AS DATPGT,
        REC.VLRPAR AS VLRPGT,
        REC.FILUSU, REC.CODUSU,
        CASE WHEN DCAR.FILADM IS NULL THEN VEN.FILCLI ELSE DCAR.FILADM END AS FILCLI,
        CASE WHEN DCAR.CODADM IS NULL THEN VEN.CODCLI ELSE DCAR.CODADM END AS CODCLI,
        VEN.OBSERV,
	CAST(' ' AS VARCHAR(1)) AS COMPLE,
        REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR,
        CAST('Em Aberto' AS VARCHAR(10)) AS FLGEST,
        CAST('A' AS VARCHAR(1)) AS FLGFLX,
        CAST('REC' AS VARCHAR(3)) AS TABORI,
        CAST('Recebimentos' AS VARCHAR(12)) AS NOMORI,
        CASE WHEN REC.CARTAO IS NULL THEN
             CASE WHEN REC.TIPCCC IS NULL THEN
                  CASE WHEN BON.FILREC IS NULL THEN 'Carteira'
                       ELSE 'Bnus'
                  END
                  ELSE DCCC.DESCCC
             END
             ELSE DCAR.DESOUT
        END AS MEIO_P
    FROM TT_REC REC INNER JOIN TT_VEN VEN ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
               LEFT OUTER JOIN TT_BON BON ON REC.CODFIL = BON.FILREC AND REC.SEQUEN = BON.SEQREC AND REC.NUMPAR = BON.NUMPAR AND REC.SUBPAR = BON.SUBPAR
               LEFT OUTER JOIN TD_CAR DCAR ON REC.CARTAO = DCAR.CODTAB
               LEFT OUTER JOIN TD_CCC DCCC ON REC.TIPCCC = DCCC.CODTAB 
                    INNER JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD
   WHERE REC.SEQCHE IS NULL
     AND REC.FLGEST NOT IN ('X','C','P')
     AND VEN.FLGEST NOT IN ('C')
 ;


/*-- SEQ 2265 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIN_TRC CASCADE;

/*-- SEQ 2266 --*/
CREATE OR REPLACE VIEW TV_FIN_TRC AS
  SELECT COALESCE(TRC.CODSER,'')||'-'||lTrim(COALESCE(TRC.NUMNOT,'')) AS DOCUME,
         COALESCE(TRC.CODFIL,'')||COALESCE(TRC.SEQUEN ,'') AS CHVFIN,
         TRC.CODFIL AS FILREC,
         TRC.FILCTA, TRC.SEQCTA, TRC.TIPCTA,
         PTR.DATPGT AS DATPGT,
         (PTR.VLRPGT-JurosDescontos('PTR',PTR.CODFIL,PTR.SEQUEN,PTR.NUMPAR,PTR.SUBPAR)) AS VLRPGT,
         PTR.FILUSU, PTR.CODUSU,
         TRC.FILPAR AS FILCLI, 
         TRC.CODPAR AS CODCLI,
         TRC.OBSERV,
         CAST(' ' AS VARCHAR(1)) AS COMPLE,
         PTR.CODFIL,PTR.SEQUEN,PTR.NUMPAR,PTR.SUBPAR,
         CAST('Pago' AS VARCHAR(4)) AS FLGEST,
         CAST('R' AS VARCHAR(1)) AS FLGFLX,
         CAST('TRC' AS VARCHAR(3)) AS TABORI,
         CAST('Ttulos a Receber' AS VARCHAR(18)) AS NOMORI
    FROM TT_PTR PTR INNER JOIN TT_TRC TRC ON PTR.CODFIL = TRC.CODFIL AND PTR.SEQUEN = TRC.SEQUEN
         ,TT_CFG CFG
   WHERE PTR.FLGEST = 'P'
     AND TRC.FLGEST NOT IN ('X','C')
UNION ALL
  SELECT COALESCE(TRC.CODSER,'')||'-'||lTrim(COALESCE(TRC.NUMNOT,'')) AS DOCUME,
         COALESCE(TRC.CODFIL,'')||COALESCE(TRC.SEQUEN ,'')AS CHVFIN,
         TRC.CODFIL AS FILREC,
         TRC.FILCTA, TRC.SEQCTA, TRC.TIPCTA,
         PTR.DATVEN AS DATPGT,
         PTR.VLRPAR AS VLRPGT,
         PTR.FILUSU, PTR.CODUSU,
         TRC.FILPAR AS FILCLI, TRC.CODPAR AS CODCLI,
         TRC.OBSERV,
         CAST(' ' AS VARCHAR(1)) AS COMPLE,
         PTR.CODFIL,PTR.SEQUEN,PTR.NUMPAR,PTR.SUBPAR,
         CAST('Em Aberto' AS VARCHAR(10)) AS FLGEST,
         CAST('A' AS VARCHAR(1)) AS  FLGFLX,
         CAST('TRC' AS VARCHAR(3)) AS TABORI,
         CAST('Ttulos a Receber' AS VARCHAR(18)) AS NOMORI
    FROM TT_PTR PTR INNER JOIN TT_TRC TRC ON PTR.CODFIL = TRC.CODFIL AND PTR.SEQUEN = TRC.SEQUEN
   WHERE PTR.FLGEST NOT IN ('X','C','P')
     AND TRC.FLGEST NOT IN ('X','C')
 ;




/*-- SEQ 2267 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIN_TXC CASCADE;

/*-- SEQ 2268 --*/
CREATE OR REPLACE VIEW TV_FIN_TXC AS
-- Utiliza-se Union em funcao de que cada conjunto pega por uma data diferente
-- e isto facilita o indice
 SELECT COALESCE(REC.NUMPAR,'')||CASE WHEN LTRIM(RTRIM(REC.SUBPAR)) IS NULL THEN '' ELSE '-' END||lTrim(COALESCE(REC.SUBPAR,'')) AS DOCUME,
        COALESCE(REC.CODFIL,'')||COALESCE(REC.SEQUEN,'')||COALESCE(REC.NUMPAR,'')||COALESCE(REC.SUBPAR ,'') AS CHVFIN,
        COALESCE( REC.FILREC, REC.CODFIL ) AS FILREC,
        DCAR.FILCAR AS FILCTA, 
        DCAR.SEQCAR AS SEQCTA, 
        DCAR.TIPCAR AS TIPCTA,
        REC.PAGAME AS DATPGT,
        JurosDescontos('CAR',REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) AS VLRPGT,
        REC.FILUSU, REC.CODUSU,
        CASE WHEN DCAR.FILADM IS NULL THEN VEN.FILCLI ELSE DCAR.FILADM END AS FILCLI,
        CASE WHEN DCAR.CODADM IS NULL THEN VEN.CODCLI ELSE DCAR.CODADM END AS CODCLI,
        VEN.OBSERV,
        CAST(' ' AS VARCHAR(1)) AS COMPLE,
        REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR,
        CAST('Pago' AS VARCHAR(4)) AS FLGEST,
        CAST('R' AS VARCHAR(4)) AS FLGFLX,
        CAST('TXC' AS VARCHAR(3)) AS TABORI,
        CAST('Taxa Cartao Cred.' AS VARCHAR(17)) AS NOMORI
    FROM TT_REC REC INNER JOIN TT_VEN VEN ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
                    INNER JOIN TD_CAR DCAR ON REC.CARTAO = DCAR.CODTAB    
   WHERE REC.FLGEST = 'P'
     AND REC.CARTAO IS NOT NULL
     AND REC.FLGEST NOT IN ('X','C')
     AND VEN.FLGEST NOT IN ('C')
UNION ALL
 SELECT COALESCE(REC.NUMPAR,'')||CASE WHEN LTRIM(RTRIM(REC.SUBPAR)) IS NULL THEN '' ELSE '-' END ||lTrim(COALESCE(REC.SUBPAR,'')) AS DOCUME,
        COALESCE(REC.CODFIL,'')||COALESCE(REC.SEQUEN,'')||COALESCE(REC.NUMPAR,'')||COALESCE(REC.SUBPAR ,'') AS CHVFIN,
        COALESCE( REC.FILREC, REC.CODFIL ) AS FILREC,
        DCAR.FILCAR AS FILCTA, 
        DCAR.SEQCAR AS SEQCTA, 
        DCAR.TIPCAR AS TIPCTA,
        REC.DATVEN AS DATPGT,
        JurosDescontos('CAR',REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) AS VLRPGT,
        REC.FILUSU, REC.CODUSU,
        CASE WHEN DCAR.FILADM IS NULL THEN VEN.FILCLI ELSE DCAR.FILADM END AS FILCLI,
        CASE WHEN DCAR.CODADM IS NULL THEN VEN.CODCLI ELSE DCAR.CODADM END AS CODCLI,
        VEN.OBSERV,
        CAST(' ' AS VARCHAR(1)) AS COMPLE,
        REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR,
        CAST('Em Aberto' AS VARCHAR(10)) AS FLGEST,
        CAST('A' AS VARCHAR(1)) AS FLGFLX,
        CAST('TXC' AS VARCHAR(3)) AS TABORI,
        CAST('Taxa Cartao Cred.' AS VARCHAR(17)) AS NOMORI
    FROM TT_REC REC INNER JOIN TT_VEN VEN ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
                    INNER JOIN TD_CAR DCAR ON REC.CARTAO = DCAR.CODTAB 
   WHERE REC.CARTAO IS NOT NULL
     AND REC.FLGEST NOT IN ('X','C','P')
     AND VEN.FLGEST NOT IN ('C') 
;





/*-- SEQ 2269 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIN_TXP CASCADE;

/*-- SEQ 2270 --*/
CREATE OR REPLACE VIEW TV_FIN_TXP AS
  SELECT CHR.NUMDOC AS DOCUME,
         COALESCE(CHR.CODFIL,'')||COALESCE(CHR.SEQUEN ,'') AS CHVFIN,
         CHR.CODFIL AS FILREC,
         DCTA.FILCTA, 
         DCTA.SEQCTA, 
         DCTA.TIPCTA,
         CHR.PAGAME AS DATPGT,
         CHR.VLRDIF*-1 AS VLRPGT,
         CHR.FILUSU, CHR.CODUSU,
         CLI.FILCLI, CLI.CODCLI,
         CAST(' ' AS VARCHAR(1)) AS OBSERV,
         CAST(' ' AS VARCHAR(1)) AS COMPLE,
         CHR.CODFIL, 
         CHR.SEQUEN, 
         CAST(' 1' AS VARCHAR(2)) AS NUMPAR, 
         CAST(' 0' AS VARCHAR(2)) AS SUBPAR,
         CASE CHR.FLGEST WHEN 'A' THEN 'A Depositar'
                         WHEN 'B' THEN 'Cobrado'
                         WHEN 'C' THEN 'Compensado'
                         WHEN 'D' THEN 'Depositado'
                         WHEN 'P' THEN 'Pr-Descontado'
                         WHEN 'S' THEN 'Substitudo'
                         WHEN 'V' THEN 'Devolvido'
                         WHEN 'X' THEN 'Estornado'
                         WHEN 'R' THEN 'Em circulacao'
                         WHEN 'I' THEN 'Incobrvel'
         END AS FLGEST,
         CAST('R' AS VARCHAR(1)) AS FLGFLX,
         CAST('TXP' AS VARCHAR(3)) AS TABORI,
         CAST('Taxa Che. Pre-desc.' AS VARCHAR(20)) AS NOMORI
    FROM TT_CHR CHR LEFT OUTER JOIN TT_CLI CLI  ON CHR.NUMDOC = CLI.NUMDOC
                         INNER JOIN TD_COB DCOB ON CHR.PORTAD = DCOB.CODTAB
         ,TD_CTA DCTA
   WHERE DCTA.CFGCOL='TIPCTA_TAX_PRE'
     AND CHR.FLGEST IN ('P','C')
     AND CHR.VLRDIF IS NOT NULL
 ;




/*-- SEQ 2271 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIN_VEN CASCADE;

/*-- SEQ 2272 --*/
CREATE OR REPLACE VIEW TV_FIN_VEN AS
  SELECT COALESCE(VEN.CODSER,'')||'/'||lTrim(COALESCE(VEN.NUMECF,''))||'-'||lTrim(COALESCE(VEN.NUMNOT,'')) AS DOCUME,
         COALESCE(REC.CODFIL,'')||COALESCE(REC.SEQUEN ,'')AS CHVFIN,
         REC.FILREC,
         DCTR.CTRFIL AS FILCTA, DCTR.CTRSEQ AS SEQCTA, DCTR.CTRTIP AS TIPCTA,
         case WHEN REC.SEQCHE IS NOT NULL 
	      THEN CHR.PAGAME
	      ELSE REC.PAGAME 
         END  AS DATPGT,
--	 REC.PAGAME AS DATPGT,
         REC.VLRPGT-JurosDescontos('REC',REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) AS VLRPGT,
         REC.FILUSU, REC.CODUSU,
         VEN.FILCLI, VEN.CODCLI,
         VEN.OBSERV,
         CAST(' ' AS VARCHAR(1)) AS COMPLE,
         REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR,
         CAST('Pago' AS VARCHAR(4)) AS FLGEST,
         CASE COALESCE(CHR.FLGEST,'.') WHEN '.' THEN 'R'
                                       ELSE CASE CHR.FLGEST WHEN 'P' THEN 'R'
                                                            WHEN 'C' THEN 'R'
                                                            ELSE 'A'
                                            END
         END AS FLGFLX,
         CAST('VEN' AS VARCHAR(3)) AS TABORI,
         CAST('Vendas' AS VARCHAR(6)) AS NOMORI
    FROM TT_REC REC INNER JOIN TT_VEN VEN  ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
                    INNER JOIN TD_CTR DCTR ON DCTR.CODTAB = VEN.CODCTR
               LEFT OUTER JOIN TT_CHR CHR  ON REC.FILREC = CHR.CODFIL AND REC.SEQCHE = CHR.SEQUEN
         ,TT_CFG CFG
   WHERE REC.FLGEST = 'P'
     AND VEN.FINANC = 'T'
     AND VEN.FLGEST <> 'C'
UNION ALL
  SELECT COALESCE(VEN.CODSER,'')||'/'||lTrim(COALESCE(VEN.NUMECF,''))||'-'||lTrim(COALESCE(VEN.NUMNOT,'')) AS DOCUME,
         COALESCE(REC.CODFIL,'')||COALESCE(REC.SEQUEN ,'') AS CHVFIN,
         REC.FILREC,
         DCTR.CTRFIL AS FILCTA, DCTR.CTRSEQ AS SEQCTA, DCTR.CTRTIP AS TIPCTA,
         REC.DATVEN AS DATPGT,
         case when REC.SEQCHE IS NOT NULL OR REC.CARTAO IS NOT NULL
              then REC.VLRPGT
              else REC.VLRPAR
         end - JurosDescontos('REC',REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) AS VLRPGT,
         REC.FILUSU, REC.CODUSU,
         VEN.FILCLI, VEN.CODCLI,
         VEN.OBSERV,
         CAST(' ' AS VARCHAR(1)) AS COMPLE,
         REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR,
         CAST('Em Aberto' AS VARCHAR(9)) AS FLGEST,
         CAST('A' AS VARCHAR(1)) AS FLGFLX,
         CAST('VEN' AS VARCHAR(3)) AS TABORI,
         CAST('Vendas' AS VARCHAR(6)) AS NOMORI
    FROM TT_REC REC INNER JOIN TT_VEN VEN ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
                    INNER JOIN TD_CTR DCTR ON DCTR.CODTAB = VEN.CODCTR
         ,TT_CFG CFG
   WHERE REC.FLGEST NOT IN ('C','X','P')
     AND VEN.FINANC = 'T'
     AND VEN.FLGEST <> 'C'
 ;





/*-- SEQ 2273 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_50CINTERNO CASCADE;

/*-- SEQ 2274 --*/
CREATE OR REPLACE VIEW TV_FIS_50CINTERNO AS
SELECT CODFIL, SEQUEN, NUMDOC, INSEST, TIPPAR, NUMNOT, POREMP, TIPEMP, SUM(ICMSRE) AS ICMSRE, NUMEND,
       FLGEST, FILFOR, CODFOR, CODSER, SUBSER, TIPNOT, DATAOK, MODNOT, NATURE, ICMITE, UFNOTA,
       SUM(VLRLIQ) AS VLRLIQ, SUM(VLRSUB) AS VLRSUB, SUM(VLRIPI) AS VLRIPI,
       SUM(DESCON) AS DESCON, SUM(VLRTOT) AS VLRTOT, SUM(BASICM) AS BASICM,
       SUM(VLRICM) AS VLRICM, SUM(BASINT) AS BASINT, SUM(OUTRAS) AS OUTRAS
  FROM (SELECT COALESCE(ICO.CODFIL,COM.CODFIL) AS CODFIL, COALESCE(ICO.SEQUEN,COM.SEQUEN) AS SEQUEN,
               COM.NUMDOC, COALESCE(COM.INSEST,'ISENTO') AS INSEST,
               COM.TIPPAR, COM.NUMNOT, COM.POREMP, COM.TIPEMP,
               CASE WHEN TRA.SEQIVE IS NOT NULL
                    THEN MAX(COALESCE(IVE.REDITE,0))
                    ELSE 0
                END AS ICMSRE,
               COALESCE(COM.NUMEND,1) AS NUMEND,
               ROUND(ABS(SUM(COALESCE((ICO.VLRMOV + ICO.VLRIPI),COM.VLRLIQ)) +
                         COALESCE(SUM(CASE WHEN (ICO.ICMTIP = '3')
                                           THEN COALESCE(COM.SUBSTT,0) * ICO.VLRMOV /
                                                  NVLZ((SELECT SUM(VLRMOV)
                                                           FROM TW_ICO_FIS
                                                          WHERE CODFIL = ICO.CODFIL
                                                            AND SEQUEN = ICO.SEQUEN
                                                            AND ICMTIP = '3'), 1)
                                           ELSE 0
                                      END +
                                      COALESCE(COM.DESCON,0) * ICO.VLRMOV /
                                                  NVLZ((SELECT SUM(VLRMOV)
                                                          FROM TW_ICO_FIS
                                                         WHERE CODFIL = ICO.CODFIL
                                                           AND SEQUEN = ICO.SEQUEN), 1) +
                                      -- 102149 - Estava duplicando outras taxas, o valor j est embutido no vlrmov atualmente
                                      -- antigamente era necessrio fazer rateio
                                      /*COALESCE(COM.OUTTAX,0) * ICO.VLRMOV /
                                                  NVLZ((SELECT SUM(VLRMOV)
                                                          FROM TW_ICO_FIS
                                                         WHERE CODFIL = ICO.CODFIL
                                                           AND SEQUEN = ICO.SEQUEN), 1) + */
                                      ICO.ICO_VLRFRE+ COALESCE(ICO.IPIFRE,0)
                                      ),0)),2) AS VLRLIQ,
               MAX(CASE COALESCE(ICO.ICMITE,0) WHEN 0 THEN COM.SUBSTT
                                                      ELSE 0
                   END) AS VLRSUB,
               ROUND(ABS(SUM(CASE ICO.TIPPRO WHEN '0' THEN (ICO.VLRMOV+(COM.DESCON*(ICO.VLRMOV*100/NVLZ(COM.VLRTOT, 1))/100))*COALESCE(ICO.IPIITE,0)/100
                                                      ELSE 0
                             END)),2) AS VLRIPI,
               COM.DESCON,
               ABS(SUM(COALESCE(ICO.VLRMOV,COM.VLRTOT))) AS VLRTOT,
               COM.FLGEST, COM.FILFOR, COM.CODFOR, COM.CODSER,
               COM.SUBSER, COM.TIPNOT, COM.DATOPE AS DATAOK,
               COALESCE(ICO.MODNOT, COM.MODNOT) AS MODNOT,
               CASE WHEN TRA.SEQIVE IS NOT NULL AND TRA.SEQICO IS NOT NULL
                    THEN CASE WHEN SUBSTR(COALESCE(IVE.NATFIS,NATUREZAVENDA(VEN.UFLOJA, CASE WHEN IVE.ICMTIP IN ('1','2', '3') OR (VEN.TRIBUT = 'F') THEN '2' ELSE IVE.ICMTIP END, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),1,1) = '5'
                              THEN '1'||SUBSTR(NATUREZAVENDA( VEN.UFLOJA, IVE.ICMTIP, COALESCE(IVE.NATFIS,NAT.NATDEN), COALESCE(IVE.NATFIS,NAT.NATFOR), VEN.SUBSTT),2,3)
                              ELSE CASE WHEN SUBSTR(COALESCE(IVE.NATFIS,NATUREZAVENDA( VEN.UFLOJA, CASE WHEN VEN.TRIBUT = 'T' THEN IVE.ICMTIP ELSE '2' END, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),1,1) = '6'
                                        THEN '2'||SUBSTR(NATUREZAVENDA( VEN.UFLOJA, IVE.ICMTIP, COALESCE(IVE.NATFIS,NAT.NATDEN), COALESCE(IVE.NATFIS,NAT.NATFOR), VEN.SUBSTT),2,3)
                                        ELSE ''
                                    END
                          END
                    ELSE CASE WHEN SUBSTR(MAX(COALESCE(ICO.NATURE,COM.NATURE)),1,1) = '5'
                              THEN '1'||SUBSTR(MAX(COALESCE(ICO.NATURE,COM.NATURE)),2,3)
                              ELSE CASE WHEN SUBSTR(MAX(COALESCE(ICO.NATURE,COM.NATURE)),1,1) = '6'
                                        THEN '2'||SUBSTR(MAX(COALESCE(ICO.NATURE,COM.NATURE)),2,3)
                                        ELSE MAX(COALESCE(ICO.NATURE,COM.NATURE))
                                    END
                          END
                END AS NATURE,
               CASE WHEN ((FIL.REGTRI = 'S') AND (COALESCE(FIL.TRISIM,'X') <> 'O')) -- Simples
                    THEN 0
                    WHEN COALESCE(ICO.ICMITE,0) = 0
                    THEN CASE WHEN COALESCE(IVE.TAX001,0) = 0
                              THEN SUM(COALESCE(COM.PERICM,0))
                              ELSE IVE.TAX001
                          END
                    ELSE CASE WHEN ICO.ICMTIP = '3' THEN 0 ELSE ICO.ICMITE END
                END AS ICMITE,
               RPAD(COALESCE(COM.UFNOTA,''),2,'  ')  AS UFNOTA,
               /* VER SE CALCULA ICMS SOBRE IPI */
               /* PEGA SOMENTE VALORES PARA ICMS, QUANDO EXISTE */
               COALESCE(ROUND(CASE WHEN ((FIL.REGTRI = 'S') AND (COALESCE(FIL.TRISIM,'X') <> 'O')) -- Simples
                                   THEN 0
                                   WHEN TRA.SEQIVE IS NOT NULL
                                   THEN SUM(COALESCE(ICO.BASICM,CASE WHEN (COALESCE(IVE.TAX001,0) = 0) OR (VEN.TRIBUT = 'F')
                                                 THEN 0
                                                 ELSE CASE WHEN IUF.REDALI IS NOT NULL
                                                           THEN IVE.VLRMOV * (100+((COALESCE(COM.DESCON,0)/NVLZ(COM.VLRTOT, 1))*100)) -
                                                                              (IVE.VLRMOV * (IRE.ICMSRE/100)) *(100+((COALESCE(COM.DESCON,0)/NVLZ(COM.VLRTOT, 1))*100))
                                                           ELSE IVE.VLRMOV - ROUND((IVE.VLRMOV * IVE.REDITE / 100),2)
                                                      END
                                             END))
                                   ELSE CASE WHEN ICO.CODFIL IS NULL
                                             THEN COALESCE(COM.BASICM,0)
                                             ELSE CASE WHEN ICO.ICMTIP = '3' THEN 0 ELSE SUM(COALESCE(ICO.BASICM,0)) END
                                        END
                              END,2),0) AS BASICM,
               CASE WHEN ((FIL.REGTRI = 'S') AND (COALESCE(FIL.TRISIM,'X') <> 'O')) -- Simples
                    THEN 0
                    WHEN TRA.SEQIVE IS NOT NULL
                    THEN SUM(COALESCE(ICO.VLRICM,CASE WHEN (COALESCE(IVE.TAX001,0) = 0) OR (VEN.TRIBUT = 'F')
                                  THEN 0
                                  ELSE IVE.VLR001
                              END))
                    ELSE CASE WHEN ICO.CODFIL IS NULL
                              THEN COALESCE(COM.VLRICM,0)
                              ELSE CASE WHEN ICO.ICMTIP = '3' THEN 0 ELSE SUM(COALESCE(ICO.VLRICM,0)) END
                         END
                END AS VLRICM,
               /* MONTANTE ISENTO/NAO TRIBUTADO */ /* TODOS MENOS MATERIAIS E TERCEIRIZADOS */
               CASE WHEN TRA.SEQIVE IS NULL
                    THEN CASE WHEN ICO.CODFIL IS NULL
                              THEN ABS(COALESCE(COM.ISEICM,0))
                              ELSE CASE WHEN ICO.ICMTIP IN ('1','2','4')
                                        THEN ABS(SUM(COALESCE(ICO.ISEICM,0)))
                                        ELSE 0
                                    END
                         END
                    ELSE CASE WHEN (IVE.ICMTIP IN ('1','2','4') AND VEN.TRIBUT = 'F')
                              THEN (ABS(SUM(COALESCE(ICO.ISEICM,ABS(ROUND((IVE.VLRMOV + (IVE.VLRMOV * COALESCE(VEN.DESCON,0) / 100)) * COALESCE(IVE.REDITE,0) / 100,3))))))
                              ELSE ABS(SUM(COALESCE(ICO.ISEICM,0)))
                          END
                 END AS BASINT,
               /* VALOR QUE NAO CONFIRA DEBITO/CREDITO DE ICMS */ /* TERCEIRIZADO */
               CASE WHEN ((FIL.REGTRI = 'S') AND (COALESCE(FIL.TRISIM,'X') <> 'O')) -- Simples
                    THEN CASE WHEN ICO.CODFIL IS NULL
                              THEN COALESCE(COM.OUTICM,0)
                              ELSE CASE WHEN ICO.VLRICM > 0
                                        THEN SUM(COALESCE(ICO.BASICM,0)+COALESCE(ICO.OUTICM,0))
                                        ELSE SUM(COALESCE(ICO.OUTICM,0))
                                   END
                         END
                    WHEN TRA.SEQIVE IS NULL
                    THEN CASE WHEN ICO.CODFIL IS NULL
                              THEN COALESCE(COM.OUTICM,0)
                              ELSE CASE WHEN ICO.ICMTIP = '3' AND ICO.VLRICM > 0 -- RFMP 79429
                                        THEN SUM(COALESCE(ICO.BASICM,0)+COALESCE(ICO.OUTICM,0))
                                        ELSE SUM(COALESCE(ICO.OUTICM,0))
                                   END
                         END
                    ELSE CASE WHEN ((VEN.TRIBUT = 'F') AND (IVE.ICMTIP IN ('0','3')))
                                OR ((VEN.TRIBUT = 'T') AND (IVE.ICMTIP = '3'))
                              THEN ABS(SUM(COALESCE(ICO.OUTICM,IVE.VLRMOV,0)))
                              ELSE 0
                          END
                END AS OUTRAS
          FROM TW_COM_FIS COM LEFT OUTER JOIN TW_ICO_FIS ICO ON ICO.CODFIL = COM.CODFIL AND ICO.SEQUEN = COM.SEQUEN
                              LEFT OUTER JOIN TT_TRA TRA ON TRA.FILICO = ICO.CODFIL AND TRA.SEQICO = ICO.SEQUEN AND TRA.NUMICO = ICO.NUMITE
                              LEFT OUTER JOIN TT_IVE IVE ON IVE.CODFIL = TRA.FILIVE AND IVE.SEQUEN = TRA.SEQIVE AND IVE.NUMITE = TRA.NUMIVE
                              LEFT OUTER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
                              LEFT OUTER JOIN TT_GRA GRA ON GRA.FILMAT = ICO.FILMAT AND GRA.CODMAT = ICO.CODMAT
                                                        AND GRA.CODCOR = ICO.CODCOR AND GRA.CODTAM = ICO.CODTAM
                                   INNER JOIN TD_FIL FIL ON FIL.CODFIL = COM.CODFIL
                              LEFT OUTER JOIN TT_IUF IUF ON IUF.FILMAT = ICO.FILMAT AND IUF.CODMAT = ICO.CODMAT AND IUF.REGESP = FIL.REGESP AND IUF.ESTADO = FIL.UFLOJA
                              LEFT OUTER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
                              LEFT OUTER JOIN TD_IRE IRE ON IRE.CODTAB = IUF.REDALI
         WHERE (COM.TIPPAR = 'F' OR COM.TIPPAR IS NULL)
           AND COM.FLGEST    <> 'D'
           AND COM.NUMNOT NOT LIKE '%#%'
           AND COM.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
           AND (ICO.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL) OR ICO.SESSION_ID IS NULL)
           AND (CASE WHEN (IsDigit(TRIM(COM.CODSER)) = 0) AND (COALESCE(ICO.NATURE,COM.NATURE,'') IN ('1933','2933')) -- nao exportar servico com serie que tenha letra
                     THEN 'F'
                     ELSE 'T'
                END = 'T')
         GROUP BY ICO.CODFIL, COM.CODFIL, COM.SEQUEN, ICO.SEQUEN, COM.POREMP, COM.TIPEMP, COM.DATOPE, IVE.NATFIS, ICO.NATURE, COALESCE(ICO.ICMITE,0), COM.OUTTAX,
                  COM.UFNOTA, COM.TIPPAR, COM.NUMEND, COM.NUMNOT, COM.DESCON, COM.SUBSTT, COM.VLRTOT, ICO.ICMTIP, COM.ISEICM, COM.BASICM, COM.VLRICM,
                  COM.FLGEST, COM.FILFOR, COM.CODFOR, COM.CODSER, COM.SUBSER, COM.TIPNOT, ICO.MODNOT, COM.MODNOT, COM.NUMDOC, COM.INSEST, ICO.VLRICM,
                  TRA.SEQIVE, VEN.UFLOJA, IVE.ICMTIP, VEN.TRIBUT, NAT.NATDEN, NAT.NATFOR, TRA.SEQICO, ICO.ICMITE, IVE.TAX001, COM.OUTICM, VEN.SUBSTT,
                  FIL.REGTRI, FIL.TRISIM,
                  NATUREZAVENDA( VEN.UFLOJA, CASE WHEN VEN.TRIBUT = 'T' THEN IVE.ICMTIP ELSE '2' END, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)) A
GROUP BY CODFIL, SEQUEN, NUMDOC, INSEST, TIPPAR, NUMNOT, POREMP, TIPEMP, NUMEND,
         FLGEST, FILFOR, CODFOR, CODSER, SUBSER, TIPNOT, DATAOK, MODNOT, NATURE, ICMITE, UFNOTA
;


/*-- SEQ 2275 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_50VINTERNO CASCADE;

/*-- SEQ 2276 --*/
CREATE OR REPLACE VIEW TV_FIS_50VINTERNO AS
SELECT /*+RULE*/
    IVE.CODFIL, IVE.SEQUEN,
    VEN.MODNOT, VEN.CODSER,
    VEN.DATHOR AS DATAOK,
    VEN.NUMNOT,
    VEN.UFLOJA, VEN.NUMDOC, COALESCE(VEN.INSEST,'ISENTO') AS INSEST,
    VEN.SUBSTT, VEN.UFNOTA,
    VEN.REDTOT, VEN.ICMFRE,
    COALESCE(VEN.VLRFRE,0) AS VLRFRE,
    VEN.VLRNOT, VEN.FLGEST,
    VEN.FILCLI, VEN.CODCLI, VEN.FILFAT, VEN.ENDFAT, VEN.NUMECF,
    IVE.NATFIS as NATURE,
    /* ZERAR CAMPOS 11 A 16 - RFMP 73474 */
    /* MN 101763 - Os campos so zerados quando o CFOP for 5929 ou 6929, pois se trata de reimpresso de nota, nesse caso, devemos zerar,
       conforme consta no link de perguntas do site da fazenda, no item 6.4: http://www.pfe.fazenda.sp.gov.br/guia_procedimentos_ecf_06.shtm#4*/
    CASE WHEN (SUBSTR(TRIM(IVE.NATFIS),1,4) IN ('5929','6929')) OR ((DFIL.REGTRI = 'S') AND (COALESCE(DFIL.TRISIM,'X') <> 'O')) -- Simples 
         THEN 0
         ELSE CASE WHEN IVE.ICMTIP = '3' THEN 0 ELSE IVE.TAX001 END
    END AS PERICM,
    CASE WHEN SUBSTR(TRIM(IVE.NATFIS),1,4) IN ('5929','6929')
         THEN 0
         ELSE SUM(IVE.ITELIQ + ABS(COALESCE(IVE.VLRFRE,0)) + ABS(COALESCE(IVE.VLRSEG,0)) + ABS(COALESCE(IVE.OUTTAX,0)))
    END AS VLRLIQ,
    CASE WHEN (SUBSTR(TRIM(IVE.NATFIS),1,4) IN ('5929','6929')) OR ((DFIL.REGTRI = 'S') AND (COALESCE(DFIL.TRISIM,'X') <> 'O')) -- Simples 
         THEN 0
         ELSE SUM(IVE.VLR001) -- RFMP 70199
    END AS VLRICM,
    CASE WHEN (SUBSTR(TRIM(IVE.NATFIS),1,4) IN ('5929','6929')) OR ((DFIL.REGTRI = 'S') AND (COALESCE(DFIL.TRISIM,'X') <> 'O')) -- Simples 
         THEN 0
         ELSE SUM(IVE.BASINT)
    END AS BASINT,
    CASE WHEN (DFIL.REGTRI = 'S') AND (COALESCE(DFIL.TRISIM,'X') <> 'O') -- Simples 
         THEN SUM(IVE.ITELIQ + ABS(COALESCE(IVE.VLRFRE,0)) + ABS(COALESCE(IVE.VLRSEG,0)) + ABS(COALESCE(IVE.OUTTAX,0)))
         WHEN SUBSTR(TRIM(IVE.NATFIS),1,4) IN ('5929','6929')
         THEN 0
         ELSE SUM(IVE.OUTRAS)
    END AS OUTRAS,
    CASE WHEN (SUBSTR(TRIM(IVE.NATFIS),1,4) IN ('5929','6929')) OR ((DFIL.REGTRI = 'S') AND (COALESCE(DFIL.TRISIM,'X') <> 'O')) -- Simples 
         THEN 0
         ELSE SUM(IVE.BASICM) -- RFMP 70161
    END AS BASICM
 FROM TW_VEN_FIS VEN INNER JOIN TD_NAT NAT ON VEN.CODNAT = NAT.CODTAB
                     INNER JOIN TD_FIL DFIL ON DFIL.CODFIL = VEN.CODFIL
                     INNER JOIN TW_IVE_FIS IVE ON VEN.CODFIL = IVE.CODFIL
                                              AND VEN.SEQUEN = IVE.SEQUEN
                                              AND VEN.CODSER = IVE.CODSER
                                              AND VEN.NUMNOT = IVE.NUMNOT
 WHERE VEN.CODSER <> 'CF'
   AND VEN.MODNOT <> '65' -- MN - Cupom Eletrnico deve ser gerado no registro 61, conforme legislao https://www.confaz.fazenda.gov.br/legislacao/convenios/2013/cv073_13
   AND VEN.MODNOT <> '59' -- MN - No h nada na legislao indicando como deve ser enviado o SAT, modelo 59, conforme legislao https://www.confaz.fazenda.gov.br/legislacao/convenios/2013/cv073_13
   AND VEN.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
   AND IVE.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
--   AND VEN.NUMNOT NOT LIKE '%#%'
   AND VEN.MODNOT <> '02' -- registro 61 - RFMP 73538
 GROUP BY IVE.CODFIL, IVE.SEQUEN, VEN.MODNOT, VEN.CODSER, VEN.DATHOR , VEN.NUMNOT, VEN.UFLOJA, VEN.NUMDOC, VEN.INSEST,
       VEN.SUBSTT, VEN.REDTOT, COALESCE(VEN.VLRFRE,0), VEN.VLRNOT, VEN.FLGEST, VEN.VLRSEG,
       VEN.FILCLI, VEN.CODCLI, VEN.FILFAT, VEN.ENDFAT, VEN.CODSER, VEN.NUMECF, VEN.UFNOTA,
       IVE.NATFIS, VEN.ICMFRE, VEN.DESCON, 
       CASE WHEN (SUBSTR(TRIM(IVE.NATFIS),1,4) IN ('5929','6929')) OR ((DFIL.REGTRI = 'S') AND (COALESCE(DFIL.TRISIM,'X') <> 'O')) -- Simples 
            THEN 0
            ELSE CASE WHEN IVE.ICMTIP = '3' THEN 0 ELSE IVE.TAX001 END
       END,
       DFIL.REGTRI, DFIL.TRISIM
 ;


/*-- SEQ 2277 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_51CINTERNO CASCADE;

/*-- SEQ 2278 --*/
CREATE OR REPLACE VIEW TV_FIS_51CINTERNO AS
SELECT * 
  FROM (SELECT ICO.CODFIL,
               ICO.SEQUEN,
               COM.DATOPE AS DATAOK,               
               COALESCE(CFO1.CODCFO,COALESCE(CFO2.CODCFO,'   ')) AS NATURE,
               /* MONTANTE DE IPI */
               SUM(CASE ICO.TIPPRO WHEN '0' THEN ICO.VLRMOV * COALESCE(ICO.IPIITE,0) / 100
                                            ELSE 0
                   END) AS VLRIPI,
               /* MONTANTE ISENTO/NAO TRIBUTADO */
               SUM(CASE ICO.TIPPRO WHEN '0' THEN
                      CASE COALESCE(ICO.IPIITE,0) WHEN 0 THEN ICO.VLRMOV
                                                         ELSE 0
                      END
                   ELSE 0
                   END) AS BASINT,
               /* VALOR QUE NAO CONFIRA DEBITO OU CREDITO DE IPI */
               SUM(CASE ICO.TIPPRO WHEN '0' THEN 0
                                            ELSE ICO.VLRMOV
                   END) AS OUTRAS
          FROM (SELECT DISTINCT FIS.CODSER, CASE WHEN LPAD(FIS.SUBSER,3,' ') = '   ' THEN '$$$' ELSE FIS.SUBSER END AS SUBSER, FIS.SEREXP, FIS.SUBEXP, FIS.MODNOT, FIS.ORIGEM
                  FROM TT_FIS FIS
                 WHERE FIS.ORIGEM = 'C'
                   AND FIS.EXPORT = 'T') FIS INNER JOIN TV_CMP COM ON FIS.CODSER = COM.CODSER
                                                                  AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$')
                                                                  AND FIS.ORIGEM = CASE WHEN COALESCE(COM.TIPPAR,'F') = 'T' THEN 'F' ELSE 'C' END
                  INNER JOIN TT_ICO ICO ON ICO.CODFIL = COM.CODFIL AND ICO.SEQUEN = COM.SEQUEN
                  LEFT OUTER JOIN TD_CFO CFO1 ON COM.CODCFO=CFO1.CODTAB
                  LEFT OUTER JOIN TD_CFO CFO2 ON ICO.CODCFO=CFO2.CODTAB                  
         WHERE COM.FLGEST <> 'D'               
         GROUP BY ICO.CODFIL, ICO.SEQUEN, COM.DATOPE, COALESCE(CFO1.CODCFO,COALESCE(CFO2.CODCFO,'   '))) TAB
 ;


/*-- SEQ 2279 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_51VINTERNO CASCADE;

/*-- SEQ 2280 --*/
CREATE OR REPLACE VIEW TV_FIS_51VINTERNO AS
SELECT * FROM (SELECT IVE.CODFIL,
               IVE.SEQUEN,
               VEN.DATHOR AS DATAOK,
               /* PEGA SOMENTE TIP001=MERCADORIA E ICMTIP = TRIBUTADO */
               SUM(IVE.VLR002) AS VLRIPI,
               /* PEGA SOMENTE TIP001=MERCADORIA E ICMTIP = ISENTO OU NAO TRIBUTADO OU ISENTO NO ESTADO */
               SUM(CASE COALESCE(IVE.TIP001,'M') WHEN 'M' THEN
                    CASE IVE.ICMTIP WHEN '1' THEN IVE.VLRMOV
                                    WHEN '2' THEN IVE.VLRMOV
                                    WHEN '4' THEN IVE.VLRMOV
                                             ELSE  0
                    END
                   ELSE 0
                   END) AS BASINT,
               /* QUALQUER OUTRA FORMA NAO TOTALIZADA ACIMA */
               SUM(CASE COALESCE(IVE.TIP001,'M') WHEN 'M' THEN
                    CASE IVE.ICMTIP WHEN '1' THEN 0
                                    WHEN '2' THEN 0
                                    WHEN '4' THEN 0
                                             ELSE CASE COALESCE(IVE.TAX002, 0) WHEN 0 THEN VLRMOV
                                                                                 ELSE 0
                                                  END
                    END
                   ELSE VLRMOV
                   END) AS OUTRAS
          FROM (SELECT EXP.CODSER, RTRIM(LTRIM(EXP.SUBSER)) AS SUBSER,
                       EXP.SEREXP, EXP.SUBEXP, EXP.MODNOT, FIL.CODFIL
                  FROM TT_FIS EXP, TD_FIL FIL
                 WHERE EXP.ORIGEM = 'V'
                   AND EXP.EXPORT = 'T') FIS
               INNER JOIN TW_VEN_FIS VEN ON VEN.CODFIL = FIS.CODFIL
                                        AND VEN.CODSER = FIS.CODSER
                                        AND VEN.NUMECF = FIS.SUBSER
               INNER JOIN TW_IVE_FIS IVE ON VEN.CODFIL = IVE.CODFIL
                                        AND VEN.SEQUEN = IVE.SEQUEN
                                        AND VEN.CODSER = IVE.CODSER
                                        AND VEN.NUMNOT = IVE.NUMNOT
         WHERE VEN.CODSER <> 'CF'
           AND VEN.MODNOT <> '65'
           AND VEN.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
         GROUP BY IVE.CODFIL, IVE.SEQUEN, VEN.DATHOR) TAB
 ;


/*-- SEQ 2281 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_53CINTERNO CASCADE;

/*-- SEQ 2282 --*/
CREATE OR REPLACE VIEW TV_FIS_53CINTERNO AS
SELECT COM.DATOPE,
       COM.CODFIL,
       CASE WHEN SUBSTR(CASE WHEN TRA.SEQIVE IS NOT NULL AND TRA.SEQICO IS NOT NULL
                             THEN CASE WHEN SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),1,1) = '5'
                                       THEN '1'||SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),2,3)
                                       ELSE CASE WHEN SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),1,1) = '6'
                                                 THEN '2'||SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),2,3)
                                                 ELSE ''
                                             END
                                   END
                              ELSE CASE WHEN SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),1,1) = '5'
                                        THEN '1'||SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),2,3)
                                        ELSE CASE WHEN SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),1,1) = '6'
                                                  THEN '2'||SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),2,3)
                                                  ELSE COALESCE(ICO.NATURE,COM.NATURE)
                                              END
                                    END
                         END,1,1) = '3'
             THEN '0'
             ELSE REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(COALESCE(LTRIM(RTRIM(COALESCE(ENDE.NUMDOC,COALESCE(CFO.NUMDOC,VIN.NUMDOC)))),'0'),',',''),'.',''),'/',''),'-',''),' ','')
        END AS NUMDOC,
       COALESCE(COM.INSEST,'ISENTO') AS INSEST,
       COM.UFNOTA,
       COALESCE(ICO.MODNOT,COM.MODNOT,'01') AS MODELO,
       COM.CODSER,
       COM.NUMNOT,
       RPAD(SUBSTR(CASE WHEN TRA.SEQIVE IS NOT NULL AND TRA.SEQICO IS NOT NULL
                        THEN CASE WHEN SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),1,1) = '5'
                                  THEN '1'||SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),2,3)
                                  ELSE CASE WHEN SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),1,1) = '6'
                                            THEN '2'||SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),2,3)
                                            ELSE ''
                                        END
                              END
                         ELSE CASE WHEN SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),1,1) = '5'
                                   THEN '1'||SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),2,3)
                                   ELSE CASE WHEN SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),1,1) = '6'
                                             THEN '2'||SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),2,3)
                                             ELSE COALESCE(ICO.NATURE,COM.NATURE)
                                         END
                               END
                     END,1,4),4,' ') AS CODCFO,
       CAST('P' AS CHAR(1)) AS EMITEN,
       ROUND(CASE WHEN ICO.RETSUB = 'T' 
                  THEN COALESCE(ICO.ICO_BASRET,0)
                  ELSE COALESCE(ICO_ORI.BASSUBDIF,0)
             END,2) AS BASSUB,
       ROUND(CASE WHEN ICO.RETSUB = 'T' 
                  THEN COALESCE(ICO.ICO_VLRRET,0)
                  ELSE COALESCE(ICO_ORI.VLR_STDIF,0)
             END,2) AS VLRRET,
       ROUND(ABS(COALESCE(ICO.ICO_OUTTAX,0)+COALESCE(ICO.ICO_VLRFRE,0)),2) AS DESPES,
       CAST(CASE COM.FLGEST WHEN 'C' THEN 'S' ELSE 'N' END AS CHAR(1)) AS FLGEST
  FROM TW_COM_FIS COM INNER JOIN TW_ICO_FIS ICO ON ICO.CODFIL = COM.CODFIL
                                               AND ICO.SEQUEN = COM.SEQUEN
                      INNER JOIN TT_ICO ICO_ORI ON ICO_ORI.CODFIL = ICO.CODFIL
                                               AND ICO_ORI.SEQUEN = ICO.SEQUEN
                                               AND ICO_ORI.NUMITE = ICO.NUMITE
                      INNER JOIN TT_GRA GRA ON GRA.FILMAT = ICO.FILMAT
                                           AND GRA.CODMAT = ICO.CODMAT
                                           AND GRA.CODCOR = ICO.CODCOR
                                           AND GRA.CODTAM = ICO.CODTAM
                      INNER JOIN TD_FIL DFIL ON DFIL.CODFIL = ICO.CODFIL
                      INNER JOIN TD_EST DEST ON DEST.ESTADO = DFIL.UFLOJA
                      INNER JOIN TT_CLI CFO ON CFO.FILCLI = COM.FILFOR
                                           AND CFO.CODCLI = COM.CODFOR
                      LEFT  JOIN TT_IUF IUF ON IUF.FILMAT = ICO.FILMAT
                                           AND IUF.CODMAT = ICO.CODMAT
                                           AND IUF.REGESP = DFIL.REGESP
                      LEFT  JOIN TD_IRE IRE ON IRE.CODTAB = IUF.REDALI
                      LEFT  JOIN TT_CLI VIN ON VIN.FILCLI = CFO.FILVIN
                                           AND VIN.CODCLI = CFO.CODVIN
                      LEFT  JOIN TT_TRA TRA ON TRA.FILICO = ICO.CODFIL
                                           AND TRA.SEQICO = ICO.SEQUEN
                                           AND TRA.NUMICO = ICO.NUMITE
                      LEFT  JOIN TT_IVE IVE ON IVE.CODFIL = TRA.FILIVE
                                           AND IVE.SEQUEN = TRA.SEQIVE
                                           AND IVE.NUMITE = TRA.NUMIVE
                      LEFT  JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL
                                           AND VEN.SEQUEN = IVE.SEQUEN
                      LEFT  JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
                      LEFT  JOIN TT_END ENDE ON ENDE.FILCLI = COM.FILFOR
                                            AND ENDE.CODCLI = COM.CODFOR
                                            AND ENDE.CODFIL = COALESCE(COM.FILEND,ENDE.CODFIL)
                                            AND ENDE.NUMEND = COALESCE(COM.NUMEND,1)
                      LEFT  JOIN TT_COM FRE ON COM.FILFRE = FRE.CODFIL
                                           AND COM.SEQFRE = FRE.SEQUEN
 WHERE COM.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
   AND ICO.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
   AND COM.FLGEST <> 'D'
   AND COM.NUMNOT NOT LIKE '%#%'
   AND COALESCE(IUF.ESTADO,DFIL.UFLOJA) = DFIL.UFLOJA
   AND ((COM.VLRRET > 0 AND ICO.RETSUB = 'T') OR
        (ICO_ORI.CODCSTDIF IN ('10','30','60','70','201','202','203','500','010','110','210','310','410','510','610','710','030','130','230','330','430','530','630','730','060','160','260','360','460','560','660','760','070','170','270','370','470','570','670','770') AND COALESCE(COM.BASSUB,0) > 0))
;


/*-- SEQ 2283 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_54V CASCADE;

/*-- SEQ 2284 --*/
CREATE OR REPLACE VIEW TV_FIS_54V AS
SELECT DISTINCT DATAOK, CODFIL,
       COALESCE(CHAVE ,'')|| COALESCE(CGC ,'')|| COALESCE(MODELO ,'')|| COALESCE(SERIE ,'')|| COALESCE(NUMNOT ,'')||
       COALESCE(CFOP ,'')|| LPAD(COALESCE(CST ,''),3,' ')|| COALESCE(to_char(NUMITE) ,'')|| COALESCE(CODMAT ,'')|| COALESCE(to_char(QTDMOV) ,'')||
       COALESCE(to_char(VLRMOV) ,'')|| COALESCE(DESPES ,'')|| COALESCE(BASICM ,'')|| COALESCE(VLRSUB ,'')|| COALESCE(to_char(VLRIPI) ,'')||
       COALESCE(to_char(PERICM) ,'') AS LINHA
FROM (
       SELECT to_char('54') AS CHAVE,
       VEN.DATHOR AS DATAOK,
       VEN.CODFIL,
       LPAD(TRIM(VEN.NUMDOC),14,'0') AS CGC,
       COALESCE(LPAD(RTRIM(LTRIM(COALESCE(VEN.MODNOT,'01'))),2,'0'),'  ') AS MODELO,
       COALESCE(RPAD(RTRIM(LTRIM(COALESCE(VEN.CODSER,' '))),3,' '),'   ') AS SERIE,
       SUBSTR(LPAD(TRIM(to_char(VEN.NUMNOT)),8,'0'),-6,6) AS NUMNOT,
       SUBSTR(TRIM(IVE.NATFIS),1,4) AS CFOP,
       IVE.CODCST AS CST,
       LPAD(to_char(IVE.NUMITE), 3, '0') AS NUMITE,
       GRA.FILMAT||REPLACE(GRA.SEQUEN,' ','0')||' ' AS CODMAT,
       LPAD(TO_CHAR(ABS(ROUND(IVE.QTDMOV * 1000))), 11, '0') AS QTDMOV,
       LPAD(TO_CHAR(ABS(ROUND(IVE.VLRMOV * 100, 0))), 12, '0') AS VLRMOV,
       LPAD(TO_CHAR(CASE WHEN VEN.VLRLIQ > 0
                         THEN CASE WHEN COALESCE(IVE2.DESRAT,0) < 0 THEN ABS(ROUND(IVE2.DESRAT * 100,0)) ELSE 0 END
                         ELSE CASE WHEN COALESCE(IVE2.DESRAT,0) > 0 THEN ABS(ROUND(IVE2.DESRAT * 100,0)) ELSE 0 END
                    END),12, '0') AS DESPES,
       /* VER SE CALCULA ICMS SOBRE IPI */
       /* BASE DE CALCULO DE ICMS */
       CASE WHEN (DFIL.REGTRI = 'S') AND (COALESCE(DFIL.TRISIM,'X') <> 'O') -- Simples 
            THEN LPAD('0',12,'0')
            ELSE LPAD(TO_CHAR(CASE COALESCE(IVE.TIP001,'M') || IVE.ICMTIP WHEN 'M0' 
                                                                          THEN ABS(ROUND((IVE.ITELIQ - IVE.VLR002 - IVE.REDVLR) * 100, 0))
                                                                          ELSE 0
                              END + ABS(ROUND((COALESCE(IVE.VLRFRE,0) + COALESCE(IVE.VLRSEG,0) + COALESCE(IVE.OUTTAX,0)) * 100, 0))), 12, '0') 
       END AS BASICM,
       /* BASE DE CALCULO DE ICMS SUBSTITUIDO */
       CASE WHEN (DFIL.REGTRI = 'S') AND (COALESCE(DFIL.TRISIM,'X') <> 'O') -- Simples
            THEN LPAD('0',12,'0')
            ELSE LPAD(TO_CHAR(CASE WHEN COALESCE(IVE.TIP001,'M') || IVE.ICMTIP = 'M3' AND VEN.SUBSTT > 0
                                   THEN ABS(ROUND( CASE WHEN VEN.VLRLIQ > VEN.VLRNOT
                                                        THEN IVE.VLRMOV * 100 * ((VEN.VLRNOT - COALESCE(VEN.SUBSTT,0) - COALESCE(VEN.REDTOT,0)) / VEN.VLRNOT)
                                                        ELSE IVE.VLRMOV * 100 * ((VEN.VLRLIQ - COALESCE(VEN.SUBSTT,0) - COALESCE(VEN.REDTOT,0)) / VEN.VLRNOT)
                                                    END
                                        , 0))
                                   ELSE 0
                              END), 12, '0') 
       END AS VLRSUB,
       /* VALOR DE IPI, SOMENTE PARA PRODUTOS TRIBUTADOS */
       LPAD(TO_CHAR(CASE IVE.ICMTIP WHEN '0' THEN ABS(ROUND(100 * (IVE.VLRMOV - (IVE.VLRMOV / ((100 + COALESCE(IVE.TAX002, 0)) / 100))) * ((VEN.VLRLIQ - COALESCE(VEN.SUBSTT,0) - COALESCE(VEN.REDTOT,0)) / VEN.VLRNOT), 0))
                                     ELSE 0
            END), 12, '0') AS VLRIPI,
       /* ALIQUOTA DE ICMS */
       CASE WHEN (DFIL.REGTRI = 'S') AND (COALESCE(DFIL.TRISIM,'X') <> 'O') -- Simples
            THEN LPAD('0',4,'0')
            ELSE  LPAD(TO_CHAR(CASE COALESCE(IVE.TIP001,'M') || IVE.ICMTIP WHEN 'M0' 
                                                                           THEN ROUND(COALESCE(IVE.TAX001,0)*100)
                                                                           ELSE 0
                               END), 4, '0') 
       END AS PERICM
       FROM TW_VEN_FIS VEN INNER JOIN TW_IVE_FIS IVE ON VEN.CODFIL = IVE.CODFIL
                                                    AND VEN.SEQUEN = IVE.SEQUEN
                                                    AND VEN.NUMNOT = IVE.NUMNOT                                                    
                           INNER JOIN TT_GRA GRA ON GRA.FILMAT = IVE.FILMAT
                                                AND GRA.CODMAT = IVE.CODMAT
                                                AND GRA.CODCOR = IVE.CODCOR
                                                AND GRA.CODTAM = IVE.CODTAM
                           INNER JOIN TT_IVE IVE2 ON IVE2.CODFIL = IVE.CODFIL
                                                 AND IVE2.SEQUEN = IVE.SEQUEN
                                                 AND IVE2.NUMITE = IVE.NUMITE
                           INNER JOIN TD_FIL DFIL ON DFIL.CODFIL = VEN.CODFIL
       WHERE VEN.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
         AND IVE.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
         AND VEN.CODSER   <> 'CF'
         AND VEN.FLGEST   <> 'C'
         AND SUBSTR(TRIM(IVE.NATFIS),1,4) NOT IN ('5929','6929')
         AND VEN.MODNOT <> '02' -- registro 61 - RFMP 73538
         AND VEN.MODNOT <> '65' -- Rhuan - 102977 - NFC-e  exportada nos Registros 61 e 61R
       UNION ALL
      SELECT TO_CHAR('54') AS CHAVE,   /* REGISTRO DE FRETE */
             VEN.DATHOR AS DATAOK, VEN.CODFIL,
             LPAD(TRIM(VEN.NUMDOC),14,'0') AS CGC,
             COALESCE(RPAD(RTRIM(LTRIM(COALESCE(VEN.MODNOT,' '))),2,' '),'  ') AS MODELO,
             COALESCE(RPAD(RTRIM(LTRIM(COALESCE(VEN.CODSER,' '))),3,' '),'   ') AS SERIE,
             SUBSTR(LPAD(TRIM(to_Char(VEN.NUMNOT)),8,'0'),-6,6) AS NUMNOT,
             SUBSTR(MIN((SELECT MIN(TRIM(IVE.NATFIS))
                    FROM TW_IVE_FIS IVE
                   WHERE IVE.CODFIL = VEN.CODFIL
                     AND IVE.SEQUEN = VEN.SEQUEN)
              ),1,4) AS CFOP,
             TO_CHAR('   ') AS CST,
             TO_CHAR('991') AS NUMITE,
             LPAD(' ',14,' ') AS CODMAT,
             LPAD('0',11,'0') AS QTDMOV,
             LPAD('0',12,'0') AS VLRMOV,
             LPAD(TO_CHAR(ABS(ROUND(COALESCE(VEN.VLRFRE,0)*100))),12,'0') AS DESPES,
             LPAD('0',12,'0') AS BASICM,
             LPAD('0',12,'0') AS VLRSUB,
             LPAD('0',12,'0') AS VLRIPI,
             LPAD('0', 4,'0') AS PERICM
        FROM TW_VEN_FIS VEN INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
       WHERE VEN.CODSER   <> 'CF'
         AND VEN.FLGEST   <> 'C'
         AND VEN.VLRFRE    > 0
         AND VEN.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
         AND (SUBSTR(TRIM(NAT.NATDEN),1,4) <> '5929' AND SUBSTR(TRIM(NAT.NATFOR),1,4) <> '6929')
         AND VEN.MODNOT <> '02' -- registro 61 - RFMP 73538
         AND VEN.MODNOT <> '65' -- Rhuan - 102977 - NFC-e  exportada nos Registros 61 e 61R
       GROUP BY VEN.DATHOR, VEN.CODFIL, VEN.NUMDOC, VEN.MODNOT, VEN.CODSER, VEN.NUMNOT, VEN.VLRFRE
  UNION ALL
       SELECT TO_CHAR('54') AS CHAVE,   /* REGISTRO DE SEGURO */
              VEN.DATHOR AS DATAOK, VEN.CODFIL,
              LPAD(TRIM(VEN.NUMDOC),14,'0') AS CGC,
              COALESCE(RPAD(RTRIM(LTRIM(COALESCE(VEN.MODNOT,' '))),2,' '),'  ') AS MODELO,
              COALESCE(RPAD(RTRIM(LTRIM(COALESCE(VEN.CODSER,' '))),3,' '),'   ') AS SERIE,
              SUBSTR(LPAD(TRIM(to_Char(VEN.NUMNOT)),8,'0'),-6,6) AS NUMNOT,
              SUBSTR(MIN((SELECT MIN(TRIM(IVE.NATFIS))
                    FROM TW_IVE_FIS IVE
                   WHERE IVE.CODFIL = VEN.CODFIL
                     AND IVE.SEQUEN = VEN.SEQUEN)
              ),1,4) AS CFOP,
--              CASE WHEN VEN.UFLOJA = 'T' THEN COALESCE(SUBSTR(TRIM(NAT.NATDEN),1,4),TO_CHAR('0000'))
--                                         ELSE COALESCE(SUBSTR(TRIM(NAT.NATFOR),1,4),TO_CHAR('0000'))
--               END AS CFOP,
              TO_CHAR('   ') AS CST,
              TO_CHAR('992') AS NUMITE,
              LPAD(' ',14,' ') AS CODMAT,
              LPAD('0',11,'0') AS QTDMOV,
              LPAD('0',12,'0') AS VLRMOV,
              LPAD(TO_CHAR(ABS(ROUND(COALESCE(VEN.VLRSEG,0)*100))),12,'0') AS DESPES,
              LPAD('0',12,'0') AS BASICM,
              LPAD('0',12,'0') AS VLRSUB,
              LPAD('0',12,'0') AS VLRIPI,
              LPAD('0', 4,'0') AS PERICM
       FROM TW_VEN_FIS VEN INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
       WHERE VEN.CODSER   <> 'CF'
         AND VEN.FLGEST   <> 'C'
         AND VEN.VLRSEG    > 0
         AND VEN.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
         AND (SUBSTR(TRIM(NAT.NATDEN),1,4) <> '5929' AND SUBSTR(TRIM(NAT.NATFOR),1,4) <> '6929')
         AND VEN.MODNOT <> '02' -- registro 61 - RFMP 73538
         AND VEN.MODNOT <> '65' -- Rhuan - 102977 - NFC-e  exportada nos Registros 61 e 61R
       GROUP BY VEN.DATHOR, VEN.CODFIL, VEN.NUMDOC, VEN.MODNOT, VEN.CODSER, VEN.NUMNOT, VEN.VLRSEG
  UNION ALL
       SELECT TAB.CHAVE, TAB.DATAOK, TAB.CODFIL, TAB.CGC, TAB.MODELO, TAB.SERIE,
              TAB.NUMNOT, TAB.CFOP, TAB.CST, TAB.NUMITE, TAB.CODMAT, TAB.QTDMOV,
              TAB.VLRMOV, LPAD(TO_CHAR(ROUND(TAB.DESPES_CALC*100,0)),12,'0') AS DESPES,
              TAB.BASICM, TAB.VLRSUB, TAB.VLRIPI, TAB.PERICM
         FROM (
               SELECT TO_CHAR('54') AS CHAVE,   /* OUTRAS DESPESAS ACESSORIAS */
                      VEN.DATHOR AS DATAOK, VEN.CODFIL,
                      LPAD(TRIM(VEN.NUMDOC),14,'0') AS CGC,
                      COALESCE(RPAD(RTRIM(LTRIM(COALESCE(VEN.MODNOT,' '))),2,' '),'  ') AS MODELO,
                      COALESCE(RPAD(RTRIM(LTRIM(COALESCE(VEN.CODSER,' '))),3,' '),'   ') AS SERIE,
                      SUBSTR(LPAD(TRIM(to_Char(VEN.NUMNOT)),8,'0'),-6,6) AS NUMNOT,
                      SUBSTR(MIN((SELECT MIN(NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, COALESCE(IVE.NATFIS,NAT.NATDEN), COALESCE(IVE.NATFIS,NAT.NATFOR), VEN.SUBSTT))
                            FROM TW_IVE_FIS IVE
                           WHERE IVE.CODFIL = VEN.CODFIL
                             AND IVE.SEQUEN = VEN.SEQUEN)
                      ),1,4) AS CFOP,
                      TO_CHAR('   ') AS CST,
                      TO_CHAR('999') AS NUMITE,
                      LPAD(' ',14,' ') AS CODMAT,
                      LPAD('0',11,'0') AS QTDMOV,
                      LPAD('0',12,'0') AS VLRMOV,
                      SUM(CASE WHEN VEN.VLRLIQ > 0
                               THEN COALESCE(IVE2.OUTTAX,0) + CASE WHEN COALESCE(IVE2.DESRAT,0) > 0 THEN COALESCE(IVE2.DESRAT,0) ELSE 0 END
                               ELSE ABS(COALESCE(IVE2.OUTTAX,0)) + CASE WHEN COALESCE(IVE2.DESRAT,0) < 0 THEN ABS(COALESCE(IVE2.DESRAT,0)) ELSE 0 END
                          END) AS DESPES_CALC,
                      LPAD('0',12,'0') AS BASICM,
                      LPAD('0',12,'0') AS VLRSUB,
                      LPAD('0',12,'0') AS VLRIPI,
                      LPAD('0', 4,'0') AS PERICM
               FROM TW_VEN_FIS VEN INNER JOIN TW_IVE_FIS IVE ON VEN.CODFIL = IVE.CODFIL
                                                            AND VEN.SEQUEN = IVE.SEQUEN
                                                            AND VEN.NUMNOT = IVE.NUMNOT
                                   INNER JOIN TT_IVE IVE2 ON IVE2.CODFIL = IVE.CODFIL
                                                         AND IVE2.SEQUEN = IVE.SEQUEN
                                                         AND IVE2.NUMITE = IVE.NUMITE
                                   INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
               WHERE VEN.CODSER <> 'CF'
                 AND VEN.FLGEST <> 'C'         
                 AND VEN.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
                 AND (SUBSTR(TRIM(NAT.NATDEN),1,4) <> '5929' AND SUBSTR(TRIM(NAT.NATFOR),1,4) <> '6929')
                 AND VEN.MODNOT <> '02' -- registro 61 - RFMP 73538
                 AND VEN.MODNOT <> '65' -- Rhuan - 102977 - NFC-e  exportada nos Registros 61 e 61R
               GROUP BY VEN.DATHOR, VEN.CODFIL, VEN.NUMDOC, VEN.MODNOT, VEN.CODSER, VEN.NUMNOT, VEN.VLRLIQ, VEN.VLRNOT
              ) TAB
             WHERE TAB.DESPES_CALC > 0
) TAB
  ;


/*-- SEQ 2285 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_61VINTERNO CASCADE;

/*-- SEQ 2286 --*/
CREATE OR REPLACE VIEW TV_FIS_61VINTERNO AS
SELECT /*+RULE*/
       VEN.CODFIL,
       VEN.MODNOT,
       VEN.CODSER,
       TRUNC(VEN.DATHOR) AS DATAOK,
       VEN.NUMNOT,
       CASE WHEN SUBSTR(TRIM(IVE.NATFIS),1,4) IN ('5929','6929')
            THEN 0
            ELSE COALESCE(IVE.ITELIQ,0) + COALESCE(IVE.VLRFRE,0) + COALESCE(IVE.VLRSEG,0) + COALESCE(IVE.OUTTAX,0)
       END AS VLRLIQ,
       CASE WHEN SUBSTR(TRIM(IVE.NATFIS),1,4) IN ('5929','6929')
            THEN 0
            ELSE COALESCE(IVE.BASICM,0)
       END AS BASICM,
       CASE WHEN SUBSTR(TRIM(IVE.NATFIS),1,4) IN ('5929','6929')
            THEN 0
            ELSE COALESCE(IVE.VLR001,0)
       END AS VLRICM,
       CASE WHEN SUBSTR(TRIM(IVE.NATFIS),1,4) IN ('5929','6929')
            THEN 0
            ELSE COALESCE(IVE.BASINT,0)
       END AS BASINT,
       CASE WHEN SUBSTR(TRIM(IVE.NATFIS),1,4) IN ('5929','6929')
            THEN 0
            ELSE COALESCE(IVE.OUTRAS,0)
       END AS OUTRAS,
       CASE WHEN SUBSTR(TRIM(IVE.NATFIS),1,4) IN ('5929','6929')
            THEN 0
            ELSE CASE WHEN IVE.ICMTIP = '3' THEN 0 ELSE COALESCE(IVE.TAX001,0) END
       END AS PERICM
  FROM TW_VEN_FIS VEN INNER JOIN TW_IVE_FIS IVE ON VEN.CODFIL = IVE.CODFIL
                                               AND VEN.SEQUEN = IVE.SEQUEN
                                               AND VEN.CODSER = IVE.CODSER
                                               AND VEN.NUMNOT = IVE.NUMNOT
 WHERE (VEN.MODNOT = '02' OR ((VEN.MODNOT = '65') AND (VEN.FLGEST <> 'C'))) -- MN - 101952 - Deve gerar CE no registro 61 conforme legislao: https://www.confaz.fazenda.gov.br/legislacao/convenios/2013/cv073_13
   AND VEN.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
   AND IVE.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
 ;


/*-- SEQ 2287 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_70CINTERNO CASCADE;

/*-- SEQ 2288 --*/
CREATE OR REPLACE VIEW TV_FIS_70CINTERNO AS
  SELECT COM.CODFIL, COM.SEQUEN, COM.UFNOTA, COM.TIPPAR, COM.NUMNOT, COM.MODNOT, COM.VLRLIQ,
         COM.DESCON, COM.VLRTOT, COM.FLGEST, COM.FILFOR, COM.CODFOR, COM.CODSER,
         COM.SUBSER, COM.TIPNOT, COM.DATOPE AS DATAOK,
         COM.NATURE AS NATURE, COM.INSEST, COM.NUMDOC, COM.PERFRE,
         /* BASE DE CALCULO */
         NVLZ(COALESCE(COM.BASFRE,0), COALESCE(COM.BASICM,0)) AS BASICM,
         /* ALIQUOTA ICMS */
         COALESCE(COM.PERFRE,0) AS ICMITE,
         /* VALOR DO ICMS */
         NVLZ(COM.ICMFRE,COALESCE(COM.VLRICM,0)) AS VLRICM,
         /* ISENTO ICMS */
         COALESCE(COM.ISEICM,0) AS BASINT,
         /* OUTROS ICMS */
         COALESCE(COM.OUTICM,0) AS OUTRAS,
         COM.POREMP
    FROM TW_COM_FIS COM 
    WHERE COM.TIPPAR = 'T'
          --NOTAS CANCELADAS-DEVOLVIDAS
      AND COM.FLGEST <> 'D'
;


/*-- SEQ 2289 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_74 CASCADE;

/*-- SEQ 2290 --*/
CREATE OR REPLACE VIEW TV_FIS_74 AS
  SELECT /*+RULE*/
         CODFIL, 
         COALESCE(to_char(CHAVE) ,'')|| COALESCE(DATA ,'')|| COALESCE(CODMAT ,'')|| COALESCE(to_char(QTDSAL) ,'')|| COALESCE(to_char(VLRTOT) ,'')|| COALESCE(CODPOSSE ,'')||
         COALESCE(CGCPOSSE ,'')|| COALESCE(IEPOSSE ,'')|| COALESCE(UFPOSSE ,'')|| COALESCE(BRANCOS ,'') AS LINHA
  FROM (
     SELECT
        INV.CODFIL,
        74 AS CHAVE,
        TO_CHAR(INV.DATINV,'YYYYMMDD') AS DATA,
        GRA.FILMAT||REPLACE(GRA.SEQUEN,' ','0')||' ' AS CODMAT,
        LPAD(TO_CHAR(trunc(CustoMedio(INV.CODFIL,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,1,INV.DATFIN)*1000)),13,'0') AS QTDSAL,
        LPAD(TO_CHAR(trunc(CustoMedio(INV.CODFIL,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,2,INV.DATFIN)*100)),13,'0') AS VLRTOT,
        TO_CHAR('1') AS CODPOSSE,
        LPAD('0',14,'0') AS CGCPOSSE,
        LPAD(' ',14,' ') AS IEPOSSE,
        LPAD(' ',02,' ') AS UFPOSSE,
        LPAD(' ',45,' ') AS BRANCOS
     FROM TT_GRA GRA, TW_INV_FIS INV
     WHERE INV.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
       AND CustoMedio(INV.CODFIL,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,1,INV.DATFIN) > 0
       AND CustoMedio(INV.CODFIL,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,2,INV.DATFIN) > 0
) TAB
;


/*-- SEQ 2291 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_GER_74 CASCADE;

/*-- SEQ 2292 --*/
CREATE OR REPLACE VIEW TV_FIS_GER_74 AS
  SELECT /*+RULE*/
         CODFIL, 
         COALESCE(to_char(CHAVE) ,'')|| COALESCE(DATA ,'')|| COALESCE(CODMAT ,'')|| COALESCE(to_char(QTDSAL) ,'')|| COALESCE(to_char(VLRTOT) ,'')|| COALESCE(CODPOSSE ,'')||
         COALESCE(CGCPOSSE ,'')|| COALESCE(IEPOSSE ,'')|| COALESCE(UFPOSSE ,'')|| COALESCE(BRANCOS ,'') AS LINHA
  FROM (
     SELECT
        INV.CODFIL,
        74 AS CHAVE,
        TO_CHAR(INV.DATINV,'YYYYMMDD') AS DATA,
        GRA.FILMAT||REPLACE(GRA.SEQUEN,' ','0')||' ' AS CODMAT,
        LPAD(to_char(trunc(CustoMedio(INV.CODFIL,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,1,INV.DATFIN)*1000)),13,'0') AS QTDSAL,
        LPAD(to_char(trunc(CustoMedio(INV.CODFIL,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,4,INV.DATFIN)*100)),13,'0') AS VLRTOT,
        TO_CHAR('1') AS CODPOSSE,
        LPAD('0',14,'0') AS CGCPOSSE,
        LPAD(' ',14,' ') AS IEPOSSE,
        LPAD(' ',02,' ') AS UFPOSSE,
        LPAD(' ',45,' ') AS BRANCOS
     FROM TT_GRA GRA, TW_INV_FIS INV
     WHERE INV.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
       AND CustoMedio(INV.CODFIL,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,1,INV.DATFIN) > 0
       AND CustoMedio(INV.CODFIL,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,4,INV.DATFIN) > 0
) TAB
;


/*-- SEQ 2293 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_CODSER CASCADE;

/*-- SEQ 2294 --*/
CREATE OR REPLACE VIEW TV_FIS_CODSER AS
  SELECT FIS.*,
         COALESCE(FIS.SUBSER,'   ') AS SUBSER_FIS
    FROM TT_FIS FIS
   WHERE ORIGEM='C' 
;


/*-- SEQ 2295 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FOR CASCADE;

/*-- SEQ 2296 --*/
CREATE OR REPLACE VIEW TV_FOR AS
    SELECT REL.FILPAR, REL.CODPAR, REL.TIPPAR,
           CLI.FILCLI, CLI.CODCLI, CLI.ATU_EM,
           CLI.NOMCLI, CLI.ULTNOM, CLI.NUMDOC,
           CLI.DOCCON, CLI.DATNAS, CLI.ESTCIV,
           CLI.HOMPGE, CLI.FLGTIP, CLI.INSEST,
           CLI.CODSEX, CLI.CATEG1, CLI.CATEG2,
           CLI.CATEG3, CLI.DATA01, CLI.DATA02,
           CLI.DATA03, CLI.DATOPE, CLI.IMPRIM,
           CLI.VALOR1, CLI.TOTATR, CLI.TOTPAR,
           CLI.MAIATR, CLI.OBSERV, CLI.FILPLA,
           CLI.CODPLA, CLI.PORPAD, CLI.ULTCOM,
           CLI.SIGNAT, CLI.CONJUG, CLI.NASCON,
           CLI.SEXCON, CLI.FILVEN, CLI.CODVEN,
           CLI.PP_FLG, CLI.ATUCUS, CLI.PEDELE,
           CLI.REPASE, CLI.SIMPLE, CLI.PARPED,
           CLI.PREENT, CLI.PRIPAR, CLI.PERIOD,
           CLI.DESCON, CLI.TIPDES, CLI.OBSFOR,
           CLI.VLRMIN_PEDCOM
      FROM TT_CLI CLI 
           INNER JOIN TT_REL REL ON CLI.FILCLI =  REL.FILPAR AND CLI.CODCLI =  REL.CODPAR
     WHERE REL.TIPPAR =  'F'
 ;






/*-- SEQ 2297 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FPV_GRA_INT CASCADE;

/*-- SEQ 2298 --*/
CREATE OR REPLACE VIEW TV_FPV_GRA_INT AS
SELECT CODTAB,CODFIL,SEQUEN,FILFRE,SEQFRE,FILFOR,TIPPAR,CODFOR,UF_FOR,DATOPE,DATCMP,
       DOCUME,ATU_EM,VLRFRE,VLRSEG,ICMFRE,VLRTOT,DESCON,OUTTAX,
       VLRLIQ,OBSERV,NUMITE,FILMAT,CODMAT,CODCOR,CODTAM,QTDMOV,PAUTAF,SUBTRI,
       VLRMOV,COALESCE(VLRBRU,0) AS VLRBRU,VLRPRE,IPIITE,ICMITE,COMPIS,COMCOF,VENPIS,VENCOF,PERSOC,PERSOC_R,PERIVE,
       PERCOM,PEROPE,PERIRE,PERIRE_R,PERLUC,PERTOT,REFPRO,VLR_COMPIS,VLR_COMCOF,
       ORDDIV,ORDSUB,DESMAT,ESPMAT,ITEDIV,ITESUB,VLRUNI,
       CODSER,SUBSER,NUMNOT,VMVIPI,PRECOV,TOTCOMFRE, ATUCUS,
       ICMCOM,IPICOM,VLRICM,ICMTIP,ICMTIPDIF,MARGEM,COALESCE(VLRUNI*IPIITE/100,0)+COALESCE(IPIFRE,0) AS VLRIPI,
       CASE WHEN COALESCE(VLRFRE,0) = 0
             AND COALESCE(IPIITE,0) > 0
            THEN 100*COALESCE(IPIFRE,0)/IPIITE
            ELSE COALESCE(VLRFRE,0)
       END AS FREITE,
       COALESCE((VLRSEG*(VLRTOT/NVLZ(TOTCOMFRE,null))*(VMVIPI/NVLZ(VLRTOT,NULL))),0) AS SEGITE,
       (DESCON*(VMVIPI/NVLZ(VLRTOT,NULL))) AS DESITE,
       (OUTTAX*(VMVIPI/NVLZ(VLRTOT,NULL))) AS TAXITE,
       (OUTDES / QTDMOV) AS OUTDESITE,
       ((DESPAR*(VMVIPI/NVLZ(VLRTOT,NULL)))/COM_QTDTOT) AS DESPARITE,
       SUBFED,VLRSUB,SUBITE,CUSREP,VLRCMG,BASE_MARKUP,
       PRECOM_CIPI+SUBITE as PRECOM_CIPI,REGTRI,TIPLUC,TRISIM,MARKUP,PREPSI,REPGRA,
       DEPART, CLASS1, CLASS2, CLASS3, CLASS4, ALIFRE, AFICUS, RESICM, ICMSRE, FATCON, IPIFRE, OUTDES, DESPAR, REDITE, MVACOM,
       VLRRET_ITE,
       VLRRET_UNI,
       ST_FRE,
       CAST('F' AS CHAR(1)) AS RETSUB,
       GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM, GRA_DATFPV,
       0.00 as pisfre,
       FILPRE,
       CODPRE,
       VAREJO,
       DESPRE,
       CODNCM,
       TIPMPB,
       ORIPRO,
       SUBSTITUTA,
       0.00 as DESESP,
       0.00 as VLRDESESP,
       PEROPEFIX, /* Paulo K. 90072 */
       0.00 as ALIICMAGR,
       0.00 as VLRICMAGR,
       MULTIP,
       ULTELA,
       DIAELA,
       CODMOE,
       TPR_SIGNAT,
       CAST(0 AS Numeric(12,2)) AS VALOR_ST_UNI,
       PIS_S_ICMS_VEN, PISCOF_SEMIPISAIDA, FOR060, APRBON, CLAABC, CLAXYZ, NOMCLI, ULTNOM, VLRUNI_ANT, QTDMOV_ANT, NOMCLI_ANT, ULTNOM_ANT,
       UFLOJA,
       CAST(((((COALESCE(VLRUNI_ANT, 0) - COALESCE(VLRUNI, 0)) / NVLZ(VLRUNI_ANT, NULL)) * 100) * (-1)) AS Numeric(18,4)) AS PERDIF_ULTCOM,
       IUF_PERFCP,
       DICM_RESICM,
       DICM_PERESPINTCOM,
       DICM_PERESPESTCOM,
       DICM_PERESPINTVEN,
       DICM_PERESPESTVEN,
       DICM_COM_RESICM,
       DICM_COM_PERESPINTCOM,
       DICM_COM_PERESPESTCOM,
       DICM_COM_PERESPINTVEN,
       DICM_COM_PERESPESTVEN,
       VLRICMANT, PERICMANT,
       UTILIZA_ICMS_ESPECIFICO,
       COALESCE(DICM_PERESPINTVEN,0) AS PERICMESPVEN,
       CASE WHEN UF_FOR = UFLOJA THEN COALESCE(DICM_COM_PERESPINTCOM,0) ELSE COALESCE(DICM_COM_PERESPESTCOM,0) END AS PERICMESPCOM,
       COALESCE(VLRUNI*CASE WHEN UF_FOR = UFLOJA THEN COALESCE(DICM_COM_PERESPINTCOM,0) ELSE COALESCE(DICM_COM_PERESPESTCOM,0) END/NVLZ(PERTOT,NULL), 0) AS VLRICMESPCOM
FROM (
SELECT (SELECT IND.CODTAB FROM TD_IND IND WHERE IND.CODTAB = 2) AS CODTAB,
       DFIL.CODFIL,
       TO_CHAR(' ') AS SEQUEN,
       TO_CHAR(' ') AS FILFRE,
       TO_CHAR(' ') AS SEQFRE,
       TO_CHAR(' ') AS FILFOR,
       TO_CHAR(' ') AS CODFOR,
       TO_CHAR(' ') AS TIPPAR,
       TO_CHAR(' ') AS UF_FOR,
       TO_CHAR(' ') AS CODSER,
       TO_CHAR(' ') AS SUBSER,
       TO_CHAR(' ') AS NUMNOT,
       IPR.ATU_EM AS DATOPE,
       IPR.ATU_EM AS DATCMP,
       CAST(DFIL.CODFIL AS VARCHAR(25)) AS DOCUME,
       IPR.ATU_EM AS ATU_EM,
       COALESCE(IPR.ALIFRE,0) AS ALIFRE,
       CASE WHEN ROUND(((IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100))) * COALESCE(IPR.PERFRE,0) / 100),4) = 0
            THEN COALESCE(IPR.CUSFRE,0)
            ELSE ROUND(((IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100))) * COALESCE(IPR.PERFRE,0) / 100),4)
       END AS VLRFRE,
       IPR.SEGFRE AS VLRSEG,
       CASE WHEN ROUND(((IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100))) * COALESCE(IPR.PERFRE,0) / 100) * COALESCE(IPR.ALIFRE,0) / 100 ,4) = 0
            THEN COALESCE(IPR.ICMFRE,0)
            ELSE ROUND(((IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100))) * COALESCE(IPR.PERFRE,0) / 100) * COALESCE(IPR.ALIFRE,0) / 100 ,4)
       END AS ICMFRE,
       ROUND(((IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100))) * COALESCE(IPR.ICMCUS,0) / 100),4) AS ICMCOM,
       ROUND(((IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100))) * COALESCE(IPR.IPICUS,0) / 100),4) AS IPICOM,
       (ROUND(((IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100))) * COALESCE(IPR.ICMCUS,0) / 100),4) + ROUND(((IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100))) * COALESCE(IPR.IPICUS,0) / 100),4)) AS ICMIPICOM,
       (IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100))) + ROUND(((IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100))) * COALESCE(IPR.IPICUS,0) / 100),4) AS VLRTOT,
       COALESCE(COALESCE(IPR.DACCUS,0),0) AS DESCON,
       COALESCE(IPR.OUTCUS,0) AS OUTTAX,
       (IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100))) + ROUND(((IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100))) * COALESCE(IPR.IPICUS,0) / 100),4) AS VLRLIQ,
       IPR.OBSERV AS OBSERV,
       cast(0 as Numeric(12,2)) AS SUBSTT,
       IUF.SUBTRI AS SUBTRI,
       cast(0 as Numeric(12,2)) AS VLRSUB,
       cast(0 as Numeric(12,2)) AS SUBITE,
       cast(0 as Numeric(5)) AS NUMITE,
       IPR.FILMAT AS FILMAT,
       IPR.CODMAT AS CODMAT,
       IPR.CODCOR AS CODCOR,
       IPR.CODTAM AS CODTAM,
       IPR.ICMTIP AS ICMTIP,
       IPR.ICMTIP AS ICMTIPDIF,
       IUF.MVAVEN AS MARGEM, -- RFMP 71137
       CAST(1 AS Numeric(12,2)) AS QTDMOV,
       CAST(0 AS Numeric(14,2)) AS PAUTAF, --82777
       IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100)) AS VLRMOV,
       IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100)) AS VLRBRU,
       COALESCE((IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100))) + ROUND(((IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100))) * COALESCE(IPR.IPICUS,0) / 100),4),0) AS VMVIPI,
       IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100)) AS VLRPRE,
       IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100)) AS VLRUNI,
       COALESCE(IPR.IPICUS,0) AS IPIITE,
       COALESCE(IPR.ICMCUS,0) AS ICMITE,
       CASE WHEN (DFIL.REGTRI = 'N') OR (DFIL.REGTRI = 'S' AND (COALESCE(DFIL.TRISIM,'X') = 'O')) THEN ROUND(((IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100))) * COALESCE(IPR.ICMCUS,0) / 100),4) ELSE 0 END AS VLRICM,
       COALESCE((IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100))),0) * CASE WHEN IPR.SUBFED = 'T' OR DFIL.REGTRI <> 'N' OR IPR.ISEPIS = 'T' THEN 0 ELSE (DFIL.COMPIS/100) END AS VLR_COMPIS,
       COALESCE((IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100))),0) * CASE WHEN IPR.SUBFED = 'T' OR DFIL.REGTRI <> 'N' OR IPR.ISEPIS = 'T' THEN 0 ELSE (DFIL.COMCOF/100) END AS VLR_COMCOF,
       CASE WHEN IPR.SUBFED = 'T' OR DFIL.REGTRI <> 'N' OR IPR.ISEPIS = 'T' THEN 0 ELSE COALESCE(DFIL.COMPIS,0) END AS COMPIS,                                              /* PERCENTUAL DE PIS                 */
       CASE WHEN IPR.SUBFED = 'T' OR DFIL.REGTRI <> 'N' OR IPR.ISEPIS = 'T' THEN 0 ELSE COALESCE(DFIL.COMCOF,0) END AS COMCOF,                                              /* PERCENTUAL DE COFINS              */
       CASE WHEN IPR.SUBFED = 'T' OR DFIL.REGTRI <> 'N' OR IPR.ISEPIS = 'T' THEN 0 ELSE COALESCE(DFIL.COMPIS,0) END AS VENPIS,                                              /* PERCENTUAL DE PIS                 */
       CASE WHEN IPR.SUBFED = 'T' OR DFIL.REGTRI <> 'N' OR IPR.ISEPIS = 'T' THEN 0 ELSE COALESCE(DFIL.COMCOF,0) END AS VENCOF,                                              /* PERCENTUAL DE COFINS              */
       /* PERCENTUAL DE CONTR. SOCIAL */
       -- percentual configurado para mostrar na tela para o usuario nao se confundir
       CASE WHEN DFIL.REGTRI = 'N' THEN COALESCE(DFIL.PERSOC,0) ELSE 0 END AS PERSOC,
       /* RFMP 85326 PERCENTUAL DE CONTR. SOCIAL NO LUCRO Numeric: CSLL * LUCRO / 100 */
       -- percentual utilizado para fins de calculos
       CASE WHEN DFIL.REGTRI = 'N' AND DFIL.TIPLUC = 'R' THEN COALESCE(DFIL.PERSOC,0) * COALESCE(IPR.PERLUC,0) / 100 ELSE CASE WHEN DFIL.REGTRI = 'N' THEN COALESCE(DFIL.PERSOC,0) ELSE 0 END END AS PERSOC_R,
       CASE WHEN CFG.PERCOM_FPV = 'T' THEN
                 CASE WHEN COALESCE(IPR.PERCOM,0) = 0 THEN COALESCE(CFG.PERCOM,0) ELSE COALESCE(IPR.PERCOM,0) END
            ELSE 0
        END AS PERCOM,                                       /* PERCENTUAL DE COMISSAO            */
       COALESCE(DespesaOperacional('V',PRE.FILPRE,PRE.CODPRE,IPR.CLASS1,IPR.CLASS2,IPR.CLASS3,IPR.CLASS4,IPR.DEPART,DFIL.CODFIL),0) AS PEROPE,    /* PERCENTUAL DE DESPESA OPERACIONAL */
       COALESCE(DespesaOperacional('F',PRE.FILPRE,PRE.CODPRE,IPR.CLASS1,IPR.CLASS2,IPR.CLASS3,IPR.CLASS4,IPR.DEPART,DFIL.CODFIL),0) AS PEROPEFIX, /* PERCENTUAL DE DESPESA OPERACIONAL */
       /* IMPOSTO DE RENDA */
       -- percentual configurado para mostrar na tela para o usuario nao se confundir
       CASE WHEN (DFIL.REGTRI = 'N' OR LeParametroBoo('CALC_IR_FILSIMPLES', DFIL.CODFIL, '', '', '') = 'T') THEN COALESCE(NVLZ(CFG.PERIR, NULL), NVLZ(IRR_PRO.RESIRR, NULL), IRR_FIL.RESIRR, 0) ELSE 0 END AS PERIRE,
       /* RFMP 85326 IMPOSTO DE RENDA NO LUCRO Numeric: IR vezes LUCRO dividido por 100 */
       -- percentual utilizado para fins de calculos
       CASE WHEN (DFIL.REGTRI = 'N' OR LeParametroBoo('CALC_IR_FILSIMPLES', DFIL.CODFIL, '', '', '') = 'T') AND DFIL.TIPLUC = 'R' THEN COALESCE(NVLZ(CFG.PERIR, NULL), NVLZ(IRR_PRO.RESIRR, NULL), IRR_FIL.RESIRR, 0) * COALESCE(IPR.PERLUC,0) / 100 
       ELSE CASE WHEN (DFIL.REGTRI = 'N' OR LeParametroBoo('CALC_IR_FILSIMPLES', DFIL.CODFIL, '', '', '') = 'T') THEN COALESCE(NVLZ(CFG.PERIR, NULL), NVLZ(IRR_PRO.RESIRR, NULL), IRR_FIL.RESIRR, 0) ELSE 0 END END AS PERIRE_R,
       CASE WHEN ((DFIL.REGTRI = 'N') OR (DFIL.REGTRI = 'S' AND (COALESCE(DFIL.TRISIM,'X') = 'O'))) AND (COALESCE(IUF.ICMISE, 'F') = 'F')
            THEN CASE WHEN DFIL.RE8020='T' AND IPR.MONTAR<>'F'
                      THEN (COALESCE(CASE WHEN COALESCE(IUF.ICMISE, 'F') = 'T' THEN 0 ELSE DICM.RESICM END,0)*(100-COALESCE(IUF.PERSRV,0))+COALESCE(ISS.RESISS,0)*COALESCE(IUF.PERSRV,0))/100
                      ELSE CASE WHEN COALESCE(IUF.ICMISE, 'F') = 'T' THEN 0 ELSE DICM.RESICM END
                  END*(1-(COALESCE(IRE.ICMSRE,0)/100))
             ELSE 0
       END AS PERIVE,                                               /* PERCENTUAL DE ICMS NA VENDA       */
       COALESCE(IPR.PERLUC,0) AS PERLUC,
       COALESCE(IPR.AFICUS,0) AS AFICUS,
       DIV.ORDDIV AS ORDDIV,
       SUB.ORDSUB AS ORDSUB,
       IPR.DESMAT AS DESMAT,
       IPR.ESPMAT AS ESPMAT,
       CASE WHEN IUF.ICMISE = 'T' THEN 0 ELSE COALESCE(DICM.RESICM,0) END AS RESICM,
       COALESCE(IRE.ICMSRE,0) AS ICMSRE,
       IPR.MARKUP,
       IPR.PREPSI,
       DIV.NOMITE AS ITEDIV,
       SUB.NOMITE AS ITESUB,
       DFIL.REGTRI,
       DFIL.TIPLUC,
       DFIL.TRISIM,
       100-(CASE WHEN IPR.SUBFED = 'T' OR DFIL.REGTRI <> 'N' OR IPR.ISEPIS = 'T' THEN 0 ELSE COALESCE(DFIL.COMPIS,0) END +
            CASE WHEN IPR.SUBFED = 'T' OR DFIL.REGTRI <> 'N' OR IPR.ISEPIS = 'T' THEN 0 ELSE COALESCE(DFIL.COMCOF,0) END +
            CASE WHEN DFIL.REGTRI = 'N' AND DFIL.TIPLUC = 'R' THEN COALESCE(DFIL.PERSOC,0) * COALESCE(IPR.PERLUC,0) / 100 ELSE CASE WHEN DFIL.REGTRI = 'N' THEN COALESCE(DFIL.PERSOC,0) ELSE 0 END END +
            CASE WHEN CFG.PERCOM_FPV = 'T' THEN
                   CASE WHEN COALESCE(IPR.PERCOM,0) = 0 THEN COALESCE(CFG.PERCOM,0) ELSE COALESCE(IPR.PERCOM,0) END
                 ELSE 0
            END +
            COALESCE(DespesaOperacional('V',PRE.FILPRE,PRE.CODPRE,IPR.CLASS1,IPR.CLASS2,IPR.CLASS3,IPR.CLASS4,IPR.DEPART,DFIL.CODFIL),0)+
            COALESCE(DespesaOperacional('F',PRE.FILPRE,PRE.CODPRE,IPR.CLASS1,IPR.CLASS2,IPR.CLASS3,IPR.CLASS4,IPR.DEPART,DFIL.CODFIL),0)+
            CASE WHEN (DFIL.REGTRI = 'N' OR LeParametroBoo('CALC_IR_FILSIMPLES', DFIL.CODFIL, '', '', '') = 'T') AND DFIL.TIPLUC = 'R' THEN COALESCE(NVLZ(CFG.PERIR, NULL), NVLZ(IRR_PRO.RESIRR, NULL), IRR_FIL.RESIRR, 0) * COALESCE(IPR.PERLUC,0) / 100 
            ELSE CASE WHEN (DFIL.REGTRI = 'N' OR LeParametroBoo('CALC_IR_FILSIMPLES', DFIL.CODFIL, '', '', '') = 'T') THEN COALESCE(NVLZ(CFG.PERIR, NULL), NVLZ(IRR_PRO.RESIRR, NULL), IRR_FIL.RESIRR, 0) ELSE 0 END END +
            COALESCE(
            CASE WHEN DFIL.RE8020='T' AND IPR.MONTAR<>'F'                     -- ICMS com tratamento 80 20
                            THEN (COALESCE(CASE WHEN COALESCE(IUF.ICMISE, 'F') = 'T' THEN 0 ELSE DICM.RESICM END,0)*(100-COALESCE(IUF.PERSRV,0))+COALESCE(ISS.RESISS,0)*COALESCE(IUF.PERSRV,0))/100
                            ELSE CASE WHEN (IUF.SUBTRI = '3') OR (COALESCE(IUF.ICMISE, 'F') = 'T')
                                      THEN 0
                                      ELSE CASE WHEN (DFIL.REGTRI = 'N') OR (DFIL.REGTRI = 'S' AND (COALESCE(DFIL.TRISIM,'X') = 'O')) THEN DICM.RESICM ELSE 0 END
                                  END
            END * (1-(COALESCE(IRE.ICMSRE,0)/100)),0)+COALESCE(IPR.PERLUC,0) ) AS PERTOT,
       IPR.REFPRO AS REFPRO,
       PRE.PRECOV,
       ROUND((IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100))) + ((IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100))) * IPR.PERFRE /100),4) AS TOTCOMFRE,
       COALESCE(IPR.CUSREP,0) AS CUSREP,
       IPR.SUBFED,
       SUB.FATCON,
       IPR.CUSREP AS REPGRA,
       COALESCE(CUSTOMEDIO(DFIL.CODFIL,IPR.FILMAT, IPR.CODMAT, IPR.CODCOR, IPR.CODTAM, 5),0) AS VLRCMG,
       CFG.BASE_MARKUP,
       (IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100))) + ROUND(((IPR.PRECOM * (1 + (COALESCE(IPR.DACCUS,0) / 100))) * COALESCE(IPR.IPICUS,0) / 100),4) AS PRECOM_CIPI,
       IPR.DEPART, IPR.CLASS1, IPR.CLASS2, IPR.CLASS3, IPR.CLASS4,
       IPR.IPIFRE,
       COALESCE(ICO.OUTDES,0)/(ICO.QTDMOV/CASE WHEN COALESCE(DSUB.CODSAL, 0) = 0 THEN 1 ELSE SUB.FATCON END) AS OUTDES, 
       COALESCE(COM.DESPAR,0) AS DESPAR, COALESCE(COM.QTDTOT,1) AS COM_QTDTOT,
       COALESCE(IPR.ULTBAS,0) AS REDITE,
       COALESCE(IPR.MVACOM,0) AS MVACOM,
       CAST(0 AS Numeric(12,2)) AS VLRRET_ITE,
       CAST(0 AS Numeric(12,2)) AS VLRRET_UNI,
       CAST(0 AS Numeric(12,2)) AS ST_FRE,
       GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM, GRA_DATFPV, COM.ATUCUS,
       PRE.FILPRE,
       PRE.CODPRE,
       TPR.VAREJO,
       TPR.DESPRE,
       IPR.PRO_CODNCM AS CODNCM,
       IPR.TIPMPB,
       IPR.ORIPRO,
       DFIL.SUBSTITUTA,
       COALESCE(NVLZ(PRE.MULTIP, TPR.MULTIP), 1) AS MULTIP, -- RFMP 97282 Incluso das colunas
       PRE.ULTELA,                                          -- de elasticidade e multiplicador
       PRE.DIAELA,
       PRE.CODMOE,
       TPR.SIGNAT AS TPR_SIGNAT,
       LeParametroBoo('PIS_S_ICMS_VEN', DFIL.CODFIL, '', '', '') AS PIS_S_ICMS_VEN,
       LeParametroBoo('PISCOF_SEMIPISAIDA', DFIL.CODFIL, '', '', '') AS PISCOF_SEMIPISAIDA,
       IPR.FOR060, 
       CAST(0 AS Numeric(16,2)) AS APRBON, IPR.CLAABC, IPR.CLAXYZ, CLI.NOMCLI, CLI.ULTNOM, 
       CAST(ICO_ANT.VLRMOV/(ICO_ANT.QTDMOV/CASE WHEN COALESCE(DSUB.CODSAL, 0) = 0 THEN 1 ELSE SUB.FATCON END) AS Numeric(18,4)) AS VLRUNI_ANT, 
       CAST(ICO_ANT.QTDMOV AS Numeric(18,4)) AS QTDMOV_ANT, 
       CAST(CLI_ANT.NOMCLI AS VARCHAR(100)) AS NOMCLI_ANT, CAST(CLI_ANT.ULTNOM AS VARCHAR(100)) AS ULTNOM_ANT,
       IPR.UFLOJA,
       IUF.PERFCP AS IUF_PERFCP,
       DICM.RESICM AS DICM_RESICM,
       DICM.PERESPINTCOM AS DICM_PERESPINTCOM,
       DICM.PERESPESTCOM AS DICM_PERESPESTCOM,
       DICM.PERESPINTVEN AS DICM_PERESPINTVEN,
       DICM.PERESPESTVEN AS DICM_PERESPESTVEN,
       DICM_COM.RESICM AS DICM_COM_RESICM,
       DICM_COM.PERESPINTCOM AS DICM_COM_PERESPINTCOM,
       DICM_COM.PERESPESTCOM AS DICM_COM_PERESPESTCOM,
       DICM_COM.PERESPINTVEN AS DICM_COM_PERESPINTVEN,
       DICM_COM.PERESPESTVEN AS DICM_COM_PERESPESTVEN,
       CAST(0 AS Numeric(12, 2)) AS VLRICMANT, CAST(0 AS Numeric(7, 4)) AS PERICMANT,
       -- MN - Realiza clculo do ICMS especfico. O ICMS especfico  um benefcio fiscal concedido ao cliente JRA, nele o cliente perde o crdito de ICMS na entrada, alm disso, ainda inclui
       -- um % "Extra" de ICMS, ou seja, aumenta o custo da mercadoria, mas por outro lado na sada/venda, ao invs de pagar 17% de ICMS eles pagam s 2.5% (alquotas variveis, apenas um exemplo)
       -- Somente produtos TRIBUTADOS e que no forcem o CST 060.
       -- Regras para Aplicar ICMS Especfico:
       -- 01 - Nas entradas da filial SUBSTITUTA, interestaduais
       -- 02 - Nas entradas da filial SUBSTITUDA quando for transferncia oriunda da filial SUBSTITUDA
       -- MN - Nos clculos posteriores o sistema estar setado para calcular as entradas estaduais, porm como o benefcio  somente para interestadual, o bloqueio  realizado aqui
       -- Setando UTILIZA_ICMS_ESPECIFICO para F nas entradas estaduais, produtos que no sejam tributados ou produtos que forcem 060
       CASE WHEN (LeParametroBoo('USA_ICMS_ESPECIFICO',DFIL.CODFIL,'','','') = 'F') OR IUF.SUBTRI <> '0' OR IPR.FOR060 = 'T'
             THEN 'F' -- MN - Parmetro indicando se filial utiliza ICMS Especfico
             ELSE CASE WHEN (COALESCE(DFIL.SUBSTITUTA, 'F') = 'T') AND (DFIL.UFLOJA <> TEND.SIGEST) THEN 'T' -- MN - Regra 1
                       WHEN (COALESCE(DFIL.SUBSTITUTA, 'T') = 'F') AND (COM.CODFOR = '     0') AND (COALESCE(DFIL_FOR.SUBSTITUTA, 'F') = 'T') THEN 'T' -- MN - Regra 2
                       ELSE 'F'
                       END
             END AS UTILIZA_ICMS_ESPECIFICO
  FROM (SELECT FL1.UFLOJA, FL1.REGESP, FL1.CODCID, GRA.*, PRO.MONTAR, PRO.DESMAT, PRO.ESPMAT, PRO.SUBFED,
                                     PRO.DEPART, PRO.CLASS1, PRO.CLASS2, PRO.CLASS3, PRO.CLASS4, PRO.ISEPIS,
                                     GRA.FILCOM AS GRA_FILCOM, GRA.SEQCOM AS GRA_SEQCOM, GRA.ITECOM AS GRA_ITECOM, GRA.DATFPV AS GRA_DATFPV, 
                                     COALESCE(GRA.GRAABC, CAST(DescricaoDominio('PRO','CLSABC',TO_CHAR(PRO.CLSABC)) AS VARCHAR(1))) AS CLAABC, 
                                     COALESCE(GRA.GRAXYZ, CAST(DescricaoDominio('PRO','CLSXYZ',TO_CHAR(PRO.CLSXYZ)) AS VARCHAR(1))) AS CLAXYZ,
                                     PRO.TIPMPB, PRO.ORIPRO, PRO.SIGNAT, PRO.CODNCM AS PRO_CODNCM, PRO.FOR060,
                                     GRA.FILCOM_ANT AS GRA_FILCOM_ANT, GRA.SEQCOM_ANT AS GRA_SEQCOM_ANT, GRA.ITECOM_ANT AS GRA_ITECOM_ANT
                                FROM TT_GRA GRA INNER JOIN TT_PRO PRO ON GRA.FILMAT = PRO.FILMAT AND GRA.CODMAT = PRO.CODMAT
                                                CROSS JOIN TD_FIL FL1
                                                CROSS JOIN TT_IDF ID1
                                                CROSS JOIN TT_CFG CFG
                               WHERE FL1.CODFIL = COALESCE(CFG.FILCMP,ID1.CODLOJ)
                     ) IPR INNER JOIN TT_SUB SUB ON SUB.CODITE = IPR.CODTAM
                            LEFT JOIN TD_SUB DSUB ON DSUB.CODTAB = SUB.CODSUB
                           INNER JOIN TT_DIV DIV ON DIV.CODITE = IPR.CODCOR
                           INNER JOIN TT_IUF IUF ON IUF.FILMAT = IPR.FILMAT AND IUF.CODMAT = IPR.CODMAT AND IUF.ESTADO = IPR.UFLOJA AND IUF.REGESP = IPR.REGESP
                           INNER JOIN TD_ICM DICM ON DICM.CODTAB = IUF.RESICM
                            LEFT JOIN TD_ICM DICM_COM ON DICM_COM.RESICM = IPR.ICMCUS
                           INNER JOIN TT_PRE PRE ON PRE.FILMAT = IPR.FILMAT AND PRE.CODMAT = IPR.CODMAT AND PRE.CODCOR = IPR.CODCOR AND PRE.CODTAM = IPR.CODTAM
                           INNER JOIN TT_TPR TPR ON TPR.CODFIL = PRE.FILPRE AND TPR.CODPRE = PRE.CODPRE
                            LEFT JOIN TT_IMU IMU ON IMU.FILMAT = IPR.FILMAT AND IMU.CODMAT = IPR.CODMAT AND IMU.CODCID = IPR.CODCID
                            LEFT JOIN TD_ISS ISS ON ISS.CODTAB = IMU.RESISS
                            LEFT JOIN TD_IRE IRE ON IRE.CODTAB = IUF.REDALI
                            LEFT JOIN TT_ICO ICO ON IPR.GRA_FILCOM = ICO.CODFIL
                                                AND IPR.GRA_SEQCOM = ICO.SEQUEN
                                                AND IPR.GRA_ITECOM = ICO.NUMITE
                            LEFT JOIN TT_COM COM ON ICO.CODFIL = COM.CODFIL
                                                AND ICO.SEQUEN = COM.SEQUEN
                            LEFT JOIN TT_CLI CLI ON CLI.FILCLI = COM.FILFOR
                                                AND CLI.CODCLI = COM.CODFOR
                            LEFT  JOIN TT_END TEND ON TEND.FILCLI = CLI.FILCLI
                                                  AND TEND.CODCLI = CLI.CODCLI
                                                  AND TEND.CODFIL = COALESCE(COM.FILEND, CLI.FILEND)
                                                  AND TEND.NUMEND = COALESCE(COM.NUMEND, CLI.NUMEND)
                            LEFT JOIN TD_FIL DFIL_FOR ON COM.FILFOR = DFIL_FOR.CODFIL
                            -- Dados da penltima Compra
                            LEFT JOIN TT_ICO ICO_ANT ON IPR.GRA_FILCOM_ANT = ICO_ANT.CODFIL AND IPR.GRA_SEQCOM_ANT = ICO_ANT.SEQUEN AND IPR.GRA_ITECOM_ANT = ICO_ANT.NUMITE
                            LEFT JOIN TT_COM COM_ANT ON ICO_ANT.CODFIL = COM_ANT.CODFIL AND ICO_ANT.SEQUEN = COM_ANT.SEQUEN
                            LEFT JOIN TT_CLI CLI_ANT ON CLI_ANT.FILCLI = COM_ANT.FILFOR AND CLI_ANT.CODCLI = COM_ANT.CODFOR
                            LEFT JOIN TT_PRO PRO     ON     PRO.FILMAT =     ICO.FILMAT AND     PRO.CODMAT =     ICO.CODMAT
                            CROSS JOIN TD_FIL DFIL
                            CROSS JOIN TT_CFG CFG
                            LEFT JOIN TD_IRR IRR_PRO ON IRR_PRO.CODTAB = PRO.RESIRR
                            LEFT JOIN TD_IRR IRR_FIL ON IRR_FIL.CODTAB = DFIL.RESIRR
         WHERE IPR.GRAATI = 'T'
           AND IPR.SIGNAT>=0
           --AND IPR.ORICUS = 'M' Tarefa 64419
           AND IPR.PRECOM <> 0
           -- RFMP 97282
           -- Filtro pela tabela varejo foi removido.
           --AND PRE.FILPRE = CFG.FILPRE
           --AND PRE.CODPRE = CFG.CODPRE
       ) TAB
;


/*-- SEQ 2299 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FPV_INT CASCADE;

/*-- SEQ 2300 --*/
CREATE OR REPLACE VIEW TV_FPV_INT AS
SELECT CODTAB,CODFIL,SEQUEN,FILFRE,SEQFRE,FILFOR,TIPPAR,CODFOR,UF_FOR,DATOPE,DATCMP,
       /* MN - As regras mais complicadas da formao de preo so referentes a PCIA. Os pontos mais importantes para entender as regras abaixo so:
        1 - DFIL.SUBSTITUTA = 'T' -> Significa que a filial  substituta, ou seja, ela tem a obrigao de recolher o ICMS ST. Isso significa que ao vender para consumidor final
            a filial deve calcular o imposto que vai ser pago depois que a revenda vender para o consumidor final, antecipando o imposto.
        2 - AND SUBTRI = '3' -> Significa que o produto  substitudo no cadastro
        3 - TPR.VAREJO IN (0, 2, 4) -> Na FPV tem vrias validaes em relao a tabela de preos, se ela  varejo ou no. No ticket 2020113170 tivemos uma nova tabela "hibrida"
            a tabela "4". Essa tabela tem as mesmas regras de vendas do varejo, mas a compra  igual ao atacado. Exemplo, na compra ela tem reduo de imposto (atacado) mas na venda
            ela apenas declara o ST (igual varejo). Isso porque ela no vende o suficiente para ser considerada atacado (70% das vendas serem atacados, por exemplo)
        4 - Algumas regras relativas a compra passaram a obter (ticket 2020113170) o icms do fornecedor, conforme solicitado pela PCIA, que seria o ICMS sem a reduo "especial" deles
       */
       DOCUME,ATU_EM,VLRFRE,VLRSEG,VLRTOT,DESCON,OUTTAX,
       VLRLIQ,OBSERV,NUMITE,FILMAT,CODMAT,CODCOR,CODTAM,QTDMOV,PAUTAF,SUBTRI,
       VLRMOV,COALESCE(VLRBRU,0) AS VLRBRU,VLRPRE,IPIITE,COMPIS,COMCOF,PERSOC,PERSOC_R, CASE WHEN UTILIZA_ICMS_ESPECIFICO = 'T' THEN 0 ELSE PERIVE END AS PERIVE,
       PERCOM,PEROPE,PERIRE,PERIRE_R,PERLUC,REFPRO,VLR_COMPIS,VLR_COMCOF,
       ORDDIV,ORDSUB,DESMAT,ESPMAT,ITEDIV,ITESUB,VLRUNI,
       CODSER,SUBSER,NUMNOT,VMVIPI,PRECOV,TOTCOMFRE,
       ICMCOM, ATUCUS,
       IPICOM,
       ICMTIP,ICMTIPDIF,MARGEM,
       VLRIPI,
       CASE WHEN COALESCE(VLRFRE,0) = 0
             AND COALESCE(IPIITE,0) > 0
            THEN 100*COALESCE(IPIFRE,0)/IPIITE
            ELSE COALESCE(VLRFRE,0)
       END/QTDMOV AS FREITE,
       COALESCE((VLRSEG*(VLRTOT/NVLZ(TOTCOMFRE,null))*(VMVIPI/NVLZ(VLRTOT,NULL)))/QTDMOV,0) AS SEGITE,
       CASE WHEN COALESCE(ALIFRE,0) <> 0
         THEN (CASE WHEN COALESCE(VLRFRE,0) = 0 AND COALESCE(IPIITE,0) > 0 THEN 100*COALESCE(IPIFRE,0)/IPIITE
                    ELSE COALESCE(VLRFRE,0)
               END/QTDMOV) * ALIFRE / 100
         ELSE 0
       END AS ICMFRE,
       CASE WHEN FILFRE IS NULL THEN 0
            WHEN COALESCE(VLRFRE,0) = 0 AND               COALESCE(IPIITE,0) > 0              THEN 100*COALESCE(IPIFRE,0)/IPIITE
            ELSE (COALESCE(VLRFRE,0) - 
                  CASE WHEN LeParametroBoo('PIS_S_ICMS_COM',CODFIL,'','','') ='T' 
                       THEN RateioCustoFrete('ICMFRE',CODFIL, SEQUEN, NUMITE, RATEIO_FRETE)
                       ELSE 0 
                  END)
       END/QTDMOV * (COALESCE(COMPIS,0)+COALESCE(COMCOF,0))/100 AS PISFRE,
       (DESCON*(VLRMOV/NVLZ(VLRNOT,NULL)))/QTDMOV AS DESITE,
       (OUTTAX*(VLRMOV/NVLZ(VLRNOT,NULL)))/QTDMOV AS TAXITE,
       (OUTDES / QTDMOV) AS OUTDESITE,
       (DESPAR*(VLRMOV/NVLZ(VLRNOT,NULL)))/QTDMOV AS DESPARITE,
       SUBFED,
       VLRSUB,SUBITE,CUSREP,VLRCMG,BASE_MARKUP,
       PRECOM_CIPI+SUBITE as PRECOM_CIPI,
       REGTRI,TIPLUC,TRISIM,MARKUP,PREPSI,REPGRA,
       DEPART, CLASS1, CLASS2, CLASS3, CLASS4, ALIFRE, AFICUS, ICMSRE, RESICM, FATCON, IPIFRE, OUTDES, DESPAR, REDITE, MVACOM,
       VLRRET_ITE,
       VLRRET_UNI,
       ST_FRE,
       RETSUB, GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM, GRA_DATFPV,
       FILPRE,
       CODPRE,
       VAREJO,
       DESPRE,
       CODNCM,
       TIPMPB,
       ORIPRO,
       DFIL_SUBSTITUTA AS SUBSTITUTA,
       MVAVEN,
       REDCON,
       DESESP,
       ((VLRUNI * ((100 - DESESP)/100)) - VLRUNI) AS VLRDESESP, -- Manoel - 89486
       PEROPEFIX, /* Paulo K. 90072 */
       ALIICMAGR,
       VLRICMAGR,
       MULTIP,
       ULTELA,
       DIAELA,
       CODMOE,
       TPR_SIGNAT,
       CASE WHEN ICMTIP = '0' AND SUBTRI = '3' AND RETSUB = 'T'
            THEN VLRRET_UNI -- Retido na Fonte
            ELSE SUBITE     -- Retido pela Viso da Empresa ou Compra Tributada por Filial Substituta que vai Vender no Varejo (ou seja, vai recolher ST)
       END AS VALOR_ST_UNI,
       PIS_S_ICMS_VEN,
       PISCOF_SEMIPISAIDA,
       FOR060, APRBON, CLAABC, CLAXYZ, NOMCLI, ULTNOM, VLRUNI_ANT, QTDMOV_ANT, NOMCLI_ANT, ULTNOM_ANT, UFLOJA,
       CAST(((((COALESCE(VLRUNI_ANT, 0) - COALESCE(VLRUNI, 0)) / NVLZ(VLRUNI_ANT, NULL)) * 100) * (-1)) AS Numeric(18,4)) AS PERDIF_ULTCOM,
       -- Desconta Custos de Venda e Valores Finais para descobrir
       -- um percentual que corresponda ao Custo de Aquisio
       100-(/*-- pis da venda --*/            
            CASE WHEN SUBFED = 'T' OR REGTRI <> 'N' OR ISEPIS = 'T' THEN 0 
                 ELSE CASE WHEN PIS_S_ICMS_VEN = 'T' THEN  COALESCE(DFIL_VENPIS * (1 - (CASE WHEN UTILIZA_ICMS_ESPECIFICO = 'T' THEN 0 ELSE COALESCE(PERIVE, 0) END + 
                                                                                    CASE WHEN PISCOF_SEMIPISAIDA = 'T' THEN COALESCE(IPIITE, 0) ELSE 0 END) 
                                                                               / 100), 0)
                           WHEN PISCOF_SEMIPISAIDA = 'T' THEN COALESCE(DFIL_VENPIS * (1 - (COALESCE(IPIITE, 0) / 100)), 0)
                           ELSE COALESCE(DFIL_VENPIS, 0)
                      END
            END +
            /*-- cofins da venda --*/
            CASE WHEN SUBFED = 'T' OR REGTRI <> 'N' OR ISEPIS = 'T' THEN 0 
                 ELSE CASE WHEN PIS_S_ICMS_VEN = 'T' THEN  COALESCE(DFIL_VENCOF * (1 - (CASE WHEN UTILIZA_ICMS_ESPECIFICO = 'T' THEN 0 ELSE COALESCE(PERIVE, 0) END + 
                                                                                    CASE WHEN PISCOF_SEMIPISAIDA = 'T' THEN COALESCE(IPIITE, 0) ELSE 0 END) 
                                                                               / 100),0)  
                           WHEN PISCOF_SEMIPISAIDA = 'T' THEN COALESCE(DFIL_VENCOF * (1 - (COALESCE(IPIITE, 0) / 100)), 0)
                           ELSE COALESCE(DFIL_VENCOF, 0)
                      END
            END +
            /*-- contribuio social --*/
            CASE WHEN REGTRI = 'N' AND TIPLUC = 'R'
                 THEN COALESCE(DFIL_PERSOC,0) * NVLZ(NVLZ(PRE_PERLUC, TPR_PERLUC), COALESCE(IPR_PERLUC, 0)) / 100
                 ELSE CASE WHEN REGTRI = 'N' THEN COALESCE(DFIL_PERSOC,0) ELSE 0 END
             END +
            /*-- comisses --*/
            CASE WHEN PERCOM_FPV = 'T' THEN
                   CASE WHEN COALESCE(IPR_PERCOM,0) = 0 THEN COALESCE(CFG_PERCOM,0) ELSE COALESCE(IPR_PERCOM,0) END
                 ELSE 0
             END +
            /*-- despesas operacionais variveis --*/
            COALESCE(DespesaOperacional('V',FILPRE,CODPRE,CLASS1,CLASS2,CLASS3,CLASS4,DEPART,CODFIL),0)+
            /*-- despesas operacionais fixas --*/
            COALESCE(DespesaOperacional('F',FILPRE,CODPRE,CLASS1,CLASS2,CLASS3,CLASS4,DEPART,CODFIL),0)+
            /*-- imposto de renda --*/
            CASE WHEN REGTRI = 'N' AND TIPLUC = 'R'
                 THEN COALESCE(PERIR, 0) * NVLZ(NVLZ(PRE_PERLUC, TPR_PERLUC), COALESCE(IPR_PERLUC, 0)) / 100
                 ELSE CASE WHEN REGTRI = 'N' THEN COALESCE(PERIR, 0) ELSE 0 END
             END +
            /*-- icms para venda --*/
            COALESCE(
                     /*-- alquota de icms para venda --*/
                     CASE WHEN DFIL_RE8020='T' AND IPR_MONTAR<>'F'                     -- ICMS com tratamento 80 20
                                     THEN (COALESCE(CASE WHEN COALESCE(IUF_ICMISE, 'F') = 'T' THEN 0 ELSE DICM_RESICM END,0)*(100-COALESCE(IUF_PERSRV,0))+COALESCE(ISS_RESISS,0)*COALESCE(IUF_PERSRV,0))/100
                                     ELSE CASE WHEN (SUBTRI = '3' AND ((COALESCE(DFIL_SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4))) OR (COALESCE(IUF_ICMISE, 'F') = 'T')
                                               THEN 0
                                               ELSE CASE WHEN (REGTRI = 'N') OR (REGTRI = 'S' AND (COALESCE(TRISIM,'X') = 'O')) THEN DICM_RESICM ELSE 0 END
                                     END
                     END * /*-- reduo de base de icms para venda --*/
                           -- RFMP 87318
                           -- MN - Tabela ATACADO LOJA se comporta igual varejo na hora da venda de produto SUBSTITUDO, por isso no est no if abaixo, porque esse  o IF de produto TRIBUTADO
                           -- ATACADO LOJA  um conceito da PCIA porque a filial no vende o suficiente pra ser SUBSTITUTA, ter a obrigao de recolher o ST, e portanto pagar imposto s na hora da venda
                           -- Mas esse tipo de filial ainda conta com Regime especial na compra
                           CASE WHEN VAREJO IN (0, 2) OR (VAREJO = 3 AND IUF_FLGRED = 'E')
                                THEN (1-(COALESCE(REDCON,0)/100)) -- VAREJO
                                ELSE (1-(COALESCE(IRE_ICMSRE,0)/100)) -- ATACADO
                           END,0) +
            /*-- percentual de lucro --*/
            NVLZ(NVLZ(PRE_PERLUC, TPR_PERLUC), COALESCE(IPR_PERLUC, 0))) AS PERTOT,
       CASE WHEN SUBFED = 'T' OR REGTRI <> 'N' OR ISEPIS = 'T' THEN 0 
                 ELSE CASE WHEN PIS_S_ICMS_VEN = 'T' THEN  COALESCE(DFIL_VENPIS * (1 - (CASE WHEN UTILIZA_ICMS_ESPECIFICO = 'T' THEN 0 ELSE COALESCE(PERIVE, 0) END + 
                                                                                    CASE WHEN PISCOF_SEMIPISAIDA = 'T' THEN COALESCE(IPIITE, 0) ELSE 0 END) 
                                                                               / 100), 0)
                           WHEN PISCOF_SEMIPISAIDA = 'T' THEN COALESCE(DFIL_VENPIS * (1 - (COALESCE(IPIITE, 0) / 100)), 0)
                           ELSE COALESCE(DFIL_VENPIS, 0)
                      END
       END AS VENPIS, /* PERCENTUAL DE PIS */
       CASE WHEN SUBFED = 'T' OR REGTRI <> 'N' OR ISEPIS = 'T' THEN 0 
                 ELSE CASE WHEN PIS_S_ICMS_VEN = 'T' THEN  COALESCE(DFIL_VENCOF * (1 - (CASE WHEN UTILIZA_ICMS_ESPECIFICO = 'T' THEN 0 ELSE COALESCE(PERIVE, 0) END + 
                                                                                    CASE WHEN PISCOF_SEMIPISAIDA = 'T' THEN COALESCE(IPIITE, 0) ELSE 0 END) 
                                                                               / 100),0)  
                           WHEN PISCOF_SEMIPISAIDA = 'T' THEN COALESCE(DFIL_VENCOF * (1 - (COALESCE(IPIITE, 0) / 100)), 0)
                           ELSE COALESCE(DFIL_VENCOF, 0)
                      END
       END AS VENCOF, /* PERCENTUAL DE COFINS */
       IUF_PERFCP,
       DICM_RESICM,
       DICM_PERESPINTCOM,
       DICM_PERESPESTCOM,
       DICM_PERESPINTVEN,
       DICM_PERESPESTVEN,
       DICM_COM_RESICM,
       DICM_COM_PERESPINTCOM,
       DICM_COM_PERESPESTCOM,
       DICM_COM_PERESPINTVEN,
       DICM_COM_PERESPESTVEN,
       UTILIZA_ICMS_ESPECIFICO, VLRICMANT, PERICMANT,
       -- MN - Quando houver ICMS Especfico deve zerar ICMS, pois a empresa no possui crdito de ICMS
       CASE WHEN UTILIZA_ICMS_ESPECIFICO = 'T' THEN 0 ELSE ICMITE END AS ICMITE,
       CASE WHEN UTILIZA_ICMS_ESPECIFICO = 'T' THEN 0 ELSE VLRICM END AS VLRICM,
       CASE WHEN UTILIZA_ICMS_ESPECIFICO = 'T' THEN COALESCE(DICM_PERESPINTVEN, 0) ELSE 0 END AS PERICMESPVEN,
       -- MN - Define % do ICMS Especfico
       CASE WHEN UTILIZA_ICMS_ESPECIFICO = 'T' THEN CASE WHEN UF_FOR = UFLOJA THEN COALESCE(DICM_COM_PERESPINTCOM, 0)
                                                                              ELSE COALESCE(DICM_COM_PERESPESTCOM, 0)
                                                                              END
                                               ELSE 0
                                               END AS PERICMESPCOM,
       -- MN - Calcula valor do ICMS Especfico
       CASE WHEN UTILIZA_ICMS_ESPECIFICO = 'T' THEN COALESCE(VLRUNI * CASE WHEN UF_FOR = UFLOJA THEN COALESCE(DICM_COM_PERESPINTCOM / 100,0) ELSE COALESCE(DICM_COM_PERESPESTCOM / 100,0) END, 0)
                                               ELSE 0
                                               END AS VLRICMESPCOM
            -- SE eu estou no varejo,  uma transferencia ('     0', a entrada vem do atacado, aplica icms especifico
            -- se eu estou no atacado, interestadual, no pode deduzir o icms (criar parametro por filial se usa icms especfico), e tem que somar o icms especfico.
FROM (
SELECT (SELECT CODTAB FROM TD_IND IND WHERE IND.CODTAB = 1) AS CODTAB,
       COM.CODFIL AS CODFIL,
       COM.SEQUEN AS SEQUEN,
       COM.FILFRE AS FILFRE,
       COM.SEQFRE AS SEQFRE,
       COM.FILFOR AS FILFOR,
       COM.TIPPAR AS TIPPAR,
       COM.CODFOR AS CODFOR,
       TEND.SIGEST AS UF_FOR,
       COM.CODSER AS CODSER,
       COM.SUBSER AS SUBSER,
       COM.NUMNOT AS NUMNOT,
       COM.DATOPE AS DATOPE,
       COM.DATCMP AS DATCMP,
       COM.ATUCUS AS ATUCUS,
       COM.RATEIO_FRETE AS RATEIO_FRETE,
       cast(0 as Numeric(12,2)) AS AFICUS,
       CAST(COALESCE(COM.CODFIL,'')||'-'||LTRIM(COALESCE(COM.CODSER,''))||'/'||
            LTRIM(COALESCE(COM.SUBSER,''))||'-'||LTRIM(COALESCE(COM.NUMNOT,'')) AS VARCHAR(25)) AS DOCUME,
       COM.ATU_EM AS ATU_EM,
       CASE WHEN COALESCE(COM.VLRFRE,0) > 0 THEN
              -- Pedro E. Braga - Sempre realiza baseado no calculo proporcional pois  assim que  realizado no calculo do Custo Mdio
              --CASE WHEN COALESCE(ICO.ICO_VLRFRE,0) > 0 THEN ICO.ICO_VLRFRE+COALESCE(ICO.IPIFRE,0)
              --     ELSE ROUND(COM.VLRFRE * ICO.VLRMOV / (COM.VLRTOT-COALESCE(COM.VLRIPI,0)-COALESCE(COM.VLRSRV,0)),2)/ICO.QTDMOV
              --END
              ROUND(COM.VLRFRE * ICO.VLRMOV / (COM.VLRTOT-COALESCE(COM.VLRIPI,0)-COALESCE(COM.VLRSRV,0)),2)
            ELSE COALESCE(RateioCustoFrete('FRETE',ICO.CODFIL, ICO.SEQUEN, ICO.NUMITE, COM.RATEIO_FRETE),0)
       END AS VLRFRE,
       COALESCE(RateioCustoFrete('OUTTAX',ICO.CODFIL, ICO.SEQUEN, ICO.NUMITE, COM.RATEIO_FRETE),0) AS VLRSEG,
       CASE WHEN COM.FILFRE IS NOT NULL
            THEN CASE WHEN COALESCE(FRE.ICMFRE,0) = 0 OR COALESCE(FRE.VLRTOT, 0) = 0 THEN 0 --Se o conhecimento de frete no possui valor ento j retorna zero para impedir erro de diviso por zero abaixo.
                 ELSE CASE WHEN (COALESCE(DFIL.SUBSTITUTA,'F') = 'T' AND IUF.FLGRED = 'E') THEN 
                        CASE WHEN TPR.VAREJO IN (2,4) THEN COALESCE(FRE.PERFRE,0)
                        ELSE COALESCE(ROUND(FRE.ICMFRE/FRE.VLRTOT * 100),0)--S reduz o ICMS se a filial for Substituta e for regime especial e no estiver na tabela de preo de Varejo/Atacado Loja
                        END
                      ELSE COALESCE(FRE.PERFRE,0)
                      END
                 END --GES-2022108778 - Recalcula pois a alquota pode se manter mas a base pode ser reduzida -SOMENTE SE FOR SUBSTITUTA E ESPECIAL
            -- Pedro E. Braga - Quando Frete tiver sido aplicado sobre a propria compra no deve-se aplicar Aliquota de ICMS para Frete pois o mesmo deve ser embutido no proprio valor da base de ICMS do Item
            -- Mesma regra vale para PIS/COFINS
            ELSE 0 --COALESCE(COM.PERFRE,0)
       END AS ALIFRE,
       TO_NUMBER(SUBSTR(TOTICMIPICOM(COM.CODFIL,COM.SEQUEN),01,11),'9999999.99') AS ICMCOM,
       TO_NUMBER(SUBSTR(TOTICMIPICOM(COM.CODFIL,COM.SEQUEN),12,11),'9999999.99') AS IPICOM,
       NVLZ(COM.VLRTOT,null) AS VLRTOT,
       COALESCE(COM.DESCON,0) AS DESCON,
       COALESCE(COM.OUTTAX,0) AS OUTTAX,
       COALESCE(COM.VLRLIQ,0) AS VLRLIQ,
       COM.OBSERV AS OBSERV,
       COALESCE(COM.SUBSTT,0) AS SUBSTT,
       IUF.SUBTRI,
       -- RFMP 87318
       COALESCE(
         -- MN - 2020113170 - Ao vender produto substitudo (SUBTRI='3') que foi comprado tributado (ICO.CODCST 00/20...) e a filial  substituta (filial que tem o dever de recolher ST)
         -- CALCULA o ICMS ST, pois ele vai ser declarado na nota, pois est vendendo para consumidor final
         CASE WHEN (COALESCE(DFIL.SUBSTITUTA,'F') = 'T') AND (ICO.CODCSTDIF IN ('00','20','101','102','000','100','200','300','400','500','600','700','020','120','220','320','420','520','620','720')) 
               AND (IUF.SUBTRI = '3') AND (LeParametroBoo('DESC_ST_PROD_FIL_SUB',DFIL.CODFIL,'','','') = 'F') THEN
                  CASE WHEN TPR.VAREJO IN (0, 2, 4)
                       THEN -- VAREJO
                           -- Calcular ST a partir de um item tributado
                           -- Valor do Item = Valor do Movimento + IPI rateado + Frete rateado + Desc/Acresc rateado + Outras Taxas rateado
                           -- Base de ST = Valor do Item * (1 + percentual MVA) * (1 - percentual  Reducao da Base de Calculo)
                           -- Valor de ST = (Base de ST * percentual ICMS para Venda) - ICMS Proprio
                           ((ICO.VLRMOV + ICO.VLRIPI) *
                           --(1+(COALESCE(ICO.MVACOMDIF,0)/100)) *
                           (1+(
                               CASE WHEN ICO.ICMITEDIF = 4 THEN COALESCE(IUF.MVAC04,0)
                                    WHEN ICO.ICMITEDIF = 7 THEN COALESCE(IUF.MVAC07,0)
                                    WHEN ICO.ICMITEDIF = 12 THEN COALESCE(IUF.MVAC12,0)
                                    ELSE IUF.MVAVEN
                               END --DN Deve pegar MVA interno pois a transferencia sera no estado
                               /100)) *
                           (1-(COALESCE(IRE.REDCON,0)/100)) * --DN  Esta reducao no deve ser a da compra e sim a da venda
                           (CASE WHEN COALESCE(IUF.ICMISE,'F') = 'T' THEN 0 ELSE DICM.RESICM END/100)
                           )-CASE WHEN COALESCE(IUF.ICMISE,'F') = 'T' THEN 0 ELSE ICO.VLRICM END -- MN - 2020113170 - PCIA utiliza preo vindo do fornecedor na compra de produto substitudo para varejo/atacado loja
                       ELSE -- ATACADO
                           NULL
                  END
              ELSE
                  -- MN - 2020113170 - No deve entrar na regra abaixo para abaixo, talvez transformar em funcionalidade essa validao com = 'F' para ficar explcito que  situao da PCIA
                  CASE WHEN (COALESCE(DFIL.SUBSTITUTA,'F') = 'F') AND (ICO.CODCSTDIF IN ('10','30','60','70','201','202','203','500','010','110','210','310','410','510','610','710','030','130','230','330','430','530','630','730','060','160','260','360','460','560','660','760','070','170','270','370','470','570','670','770'))
                        AND (COALESCE(COM.BASSUB,0) > 0) AND (LeParametroBoo('DESC_ST_PROD_FIL_SUB',DFIL.CODFIL,'','','') = 'F') THEN
                       COALESCE(ICO.VLR_STDIF,0) -- RFMP 79796 Utilizacao do campo materializado ao inves do calculo
                  ELSE NULL
                  END
         END,0) AS VLRSUB,
       -- RFMP 87318
       COALESCE(
         -- MN - 2020113170 - Ao vender produto substitudo (SUBTRI='3') que foi comprado tributado (ICO.CODCST 00/20...) e a filial  substituta (filial que tem o dever de recolher ST)
         -- CALCULA o ICMS ST, pois ele vai ser declarado na nota, pois est vendendo para consumidor final
         CASE WHEN (COALESCE(DFIL.SUBSTITUTA,'F') = 'T') AND (ICO.CODCSTDIF IN ('00','20','101','102','000','100','200','300','400','500','600','700','020','120','220','320','420','520','620','720')) 
               AND (IUF.SUBTRI = '3') AND (LeParametroBoo('DESC_ST_PROD_FIL_SUB',DFIL.CODFIL,'','','') = 'F') THEN
                  -- Compra Tributada por Filial Substituta que vai Vender no Varejo (ou seja, vai recolher ST)
                  CASE WHEN TPR.VAREJO IN (0, 2, 4)
                       THEN -- VAREJO
                           -- Calcular ST a partir de um item tributado
                           -- Valor do Item = Valor do Movimento + IPI (rat.) + Frete (rat.) + Desc/Acresc (rat.) + Outras Taxas (rat.)
                           -- Base de ST = Valor do Item * (1 + percentual MVA) * (1 - percentual Reducao da Base de Calculo)
                           -- Valor de ST = (Base de ST * percentual ICMS para Venda) - ICMS Proprio
                           COALESCE(
                           ((ICO.VLRMOV + ICO.VLRIPI) *
                           (1+(
                               CASE WHEN ICO.ICMITEDIF = 4 THEN COALESCE(IUF.MVAC04,0)
                                    WHEN ICO.ICMITEDIF = 7 THEN COALESCE(IUF.MVAC07,0)
                                    WHEN ICO.ICMITEDIF = 12 THEN COALESCE(IUF.MVAC12,0)
                                    ELSE IUF.MVAVEN
                               END --DN Deve pegar MVA interno pois a transferencia sera no estado
                               /100)) *
                           (1-(COALESCE(IRE.REDCON,0)/100)) * --DN  Esta reducao nao deve ser a da compra e sim a da venda
                           (CASE WHEN COALESCE(IUF.ICMISE,'F') = 'T' THEN 0 ELSE DICM.RESICM END/100)
                           -- MN - 2020113170 - PCIA utiliza preo vindo do fornecedor na compra de produto substitudo para varejo/atacado loja
                           )-CASE WHEN COALESCE(IUF.ICMISE,'F') = 'T' THEN 0 ELSE ICO.VLRICM END, 0) / (ICO.QTDMOV / CASE WHEN COALESCE(DSUB.CODSAL, 0) = 0 THEN 1 ELSE SUB.FATCON END)
                       ELSE -- ATACADO
                           NULL
                  END
              ELSE
                  -- MN - 2020113170 - No deve entrar na regra abaixo para abaixo, talvez transformar em funcionalidade essa validao com = 'F' para ficar explcito que  situao da PCIA
                  CASE WHEN (COALESCE(DFIL.SUBSTITUTA,'F') = 'F') AND (COALESCE(ICO.VLR_STDIF,0) > 0)
                        AND (ICO.CODCSTDIF IN ('10','30','60','70',
                                               '201','202','203','500',
                                               '010','110','210','310','410','510','610','710',
                                               '030','130','230','330','430','530','630','730',
                                               '060','160','260','360','460','560','660','760',
                                               '070','170','270','370','470','570','670','770'))
                         AND (LeParametroBoo('DESC_ST_PROD_FIL_SUB',DFIL.CODFIL,'','','') = 'F') THEN
                       COALESCE(ICO.VLR_STDIF,0) / (ICO.QTDMOV / CASE WHEN COALESCE(DSUB.CODSAL, 0) = 0 THEN 1 ELSE SUB.FATCON END)
                  ELSE NULL
                  END
         END,0) AS SUBITE,
       -- RFMP 71114
       -- Valor de ICMS retido na fonte por substituicao tributaria
       COALESCE(CASE WHEN ICO.RETSUB = 'T' AND COM.VLRRET > 0 THEN
                          ICO.ICO_VLRRET
                          ELSE NULL
                END,0) AS VLRRET_ITE,
       -- RFMP 71114
       -- Valor unitario de ICMS retido na fonte por substituicao tributaria
       COALESCE(CASE WHEN ICO.RETSUB = 'T' AND COM.VLRRET > 0 THEN
                          ICO.ICO_VLRRET / (ICO.QTDMOV / CASE WHEN COALESCE(DSUB.CODSAL, 0) = 0 THEN 1 ELSE SUB.FATCON END)
                          ELSE NULL
                END,0) AS VLRRET_UNI,
       -- LEO 77185
       -- Valor unitario de ICMS retido na fonte por substituicao tributaria
       COALESCE(ICO.ST_FRE / (ICO.QTDMOV / CASE WHEN COALESCE(DSUB.CODSAL, 0) = 0 THEN 1 ELSE SUB.FATCON END),0) AS ST_FRE,
       ICO.NUMITE AS NUMITE,
       ICO.FILMAT AS FILMAT,
       ICO.CODMAT AS CODMAT,
       ICO.CODCOR AS CODCOR,
       -- RFMP 97041
       -- Utilizar CST original da nota (viso do fornecedor)
       CASE WHEN ICO.CODCST IS NOT NULL AND ICO.CODCST IN ('10','30','60','70','201','202','203','500') THEN '3' -- Substituido
            WHEN ICO.CODCST IS NOT NULL AND ICO.CODCST IN ('00','20','101','102') THEN '0' -- Tributado
            WHEN ICO.CODCST IS NOT NULL AND ICO.CODCST IN ('40','300','103') AND SUBSTR(COALESCE(CFO.CODCFO,'      '),1,1) = '2' THEN '2' -- Isento
            WHEN ICO.CODCST IS NOT NULL AND ICO.CODCST IN ('40','300','103') AND SUBSTR(COALESCE(CFO.CODCFO,'      '),1,1) = '1' THEN '4' -- Isento no Estado
            WHEN ICO.CODCST IS NOT NULL AND ICO.CODCST IN ('41','400') THEN '1' -- Nao Tributado
            ELSE ICO.ICMTIP
       END AS ICMTIP,
       -- RFMP 101347 regra do form de compras
       CASE WHEN ICO.CODCSTDIF IS NOT NULL AND ICO.CODCSTDIF IN ('0','00','101','102') THEN '0'
            WHEN ICO.CODCSTDIF IS NOT NULL AND ICO.CODCSTDIF IN ('10','201','202') THEN '3'
            WHEN ICO.CODCSTDIF IS NOT NULL AND ICO.CODCSTDIF IN ('20') THEN '0'
            WHEN ICO.CODCSTDIF IS NOT NULL AND ICO.CODCSTDIF IN ('30','203') THEN '3'
            WHEN ICO.CODCSTDIF IS NOT NULL AND ICO.CODCSTDIF IN ('40','300','103') THEN '2'
            WHEN ICO.CODCSTDIF IS NOT NULL AND ICO.CODCSTDIF IN ('41','400') THEN '1'
            WHEN ICO.CODCSTDIF IS NOT NULL AND ICO.CODCSTDIF IN ('50') THEN '1'
            WHEN ICO.CODCSTDIF IS NOT NULL AND ICO.CODCSTDIF IN ('51') THEN '0'
            WHEN ICO.CODCSTDIF IS NOT NULL AND ICO.CODCSTDIF IN ('60','500') THEN '3'
            WHEN ICO.CODCSTDIF IS NOT NULL AND ICO.CODCSTDIF IN ('70') THEN '3'
            WHEN ICO.CODCSTDIF IS NOT NULL AND ICO.CODCSTDIF IN ('90','900') THEN '1'
            ELSE ICO.ICMTIP
       END AS ICMTIPDIF,
       ICO.MVACOMDIF AS MARGEM, -- RFMP 71137
       GRA.CODTAM AS CODTAM,
       ICO.QTDMOV/CASE WHEN COALESCE(DSUB.CODSAL, 0) = 0 THEN 1 ELSE SUB.FATCON END AS QTDMOV,
       ICO.PAUTAF AS PAUTAF, --82777
       COALESCE(ICO.VLRMOV,0) AS VLRMOV,
       (ICO.VLRMOV-COALESCE(ICO.VLRDES,0))/ICO.QTDCOM AS VLRBRU,
       (ICO.VLRMOV + CASE WHEN COALESCE(COM.VLRFRE,0) > 0 THEN
                          -- Pedro E. Braga - Sempre realiza baseado no calculo proporcional pois  assim que  realizado no calculo do Custo Mdio
                          --CASE WHEN COALESCE(ICO.ICO_VLRFRE,0) > 0 THEN ICO.ICO_VLRFRE+COALESCE(ICO.IPIFRE,0)
                          --     ELSE ROUND(COM.VLRFRE * ICO.VLRMOV / (COM.VLRTOT-COALESCE(COM.VLRIPI,0)-COALESCE(COM.VLRSRV,0)),2)/ICO.QTDMOV
                          --END
                          ROUND(COM.VLRFRE * ICO.VLRMOV / (COM.VLRTOT-COALESCE(COM.VLRIPI,0)-COALESCE(COM.VLRSRV,0)),2)
                          ELSE COALESCE(RateioCustoFrete('FRETE',ICO.CODFIL, ICO.SEQUEN, ICO.NUMITE, COM.RATEIO_FRETE),0)
                     END)*(1+(COALESCE(ICO.IPIITE,0)/100)) AS VMVIPI,   -- VALOR DO MOVIMENTO + VLRFRE COM IPI
       ICO.VLRMOV/(ICO.QTDMOV/CASE WHEN COALESCE(DSUB.CODSAL, 0) = 0 THEN 1 ELSE SUB.FATCON END) AS VLRPRE, /* sera valor presente no futuro */
       ICO.VLRMOV/(ICO.QTDMOV/CASE WHEN COALESCE(DSUB.CODSAL, 0) = 0 THEN 1 ELSE SUB.FATCON END) AS VLRUNI,
       COALESCE(ICO.IPIITE,0) AS IPIITE,
       -- MN - As tabelas de produto tributado no varejo, e substitudo no varejo e atacado loja devem obter o % de ICMS da viso do fornecedor
       CASE WHEN (COALESCE(DFIL.SUBSTITUTA,'F') = 'T') AND ICO.CODCSTDIF IN ('00','20') AND IUF.SUBTRI = '3' THEN
                CASE WHEN TPR.VAREJO IN (0, 2, 4) OR COALESCE(IUF.ICMISE, 'F') = 'T'
                     THEN ICO.ICMITE
                     ELSE ICO.ICMITEDIF
                END
       ELSE 
           CASE WHEN COALESCE(IUF.ICMISE, 'F') = 'T' 
              THEN 0 
              ELSE 
                 CASE WHEN (COALESCE(DFIL.SUBSTITUTA,'F') = 'T') AND TPR.VAREJO IN (0, 2)
                    THEN
                       ICO.ICMITE
                    ELSE 
                       ICO.ICMITEDIF
                 END
              END
       END AS ICMITE,
       -- MN - 2020113170 - Ao vender produto substitudo (SUBTRE='3') que foi comprado tributado (ICO.CODCST 00/20) e a filial  substituta (filial que tem o dever de recolher ST)
       -- Zera o ICMS no varejo, pois no varejo haver o ICMS ST declarado
       -- MN - Trata para zerar ICMS quando tiver ICMS Especfico, pois no caso de haver ICMS especfico a empresa no tem direito a crdito, ento no pode deduzir o valor como custo
       CASE WHEN (COALESCE(DFIL.SUBSTITUTA,'F') = 'T') AND (ICO.CODCSTDIF IN ('00','20')) 
             AND (IUF.SUBTRI = '3') AND (LeParametroBoo('DESC_ST_PROD_FIL_SUB',DFIL.CODFIL,'','','') = 'F') THEN
                CASE WHEN TPR.VAREJO IN (0, 2, 4) OR COALESCE(IUF.ICMISE, 'F') = 'T'
                     THEN 0 -- VAREJO | ATACADO LOJA (Filial No Substituta) - 2020113170
                     ELSE   -- ATACADO CORPORATIVO (Filial Substituta)
                         CASE WHEN (DFIL.REGTRI = 'N') OR (DFIL.REGTRI = 'S' AND (COALESCE(DFIL.TRISIM,'X') = 'O')) 
                                -- MN - No caso de atacado corporativo OU revenda, vai pegar o% de ICMS que est na viso do fornecedor no momento da compra
                                THEN (COALESCE(ICO.VLRICMDIF,0)/(ICO.QTDMOV/CASE WHEN COALESCE(DSUB.CODSAL, 0) = 0 THEN 1 
                                                                                                                     ELSE SUB.FATCON 
                                                                                                                     END))
                                ELSE 0
                                END
                END
       ELSE 
           CASE WHEN COALESCE(IUF.ICMISE, 'F') = 'T'
              THEN 0
              ELSE 
                 CASE WHEN (COALESCE(DFIL.SUBSTITUTA,'F') = 'T') AND TPR.VAREJO IN (0, 2)
                    THEN
                       -- MN - Pega ICMS da viso do fornecedor, pois na PCIA venda de produto no VAREJO a PCIA no tem reduo
                       -- mas no ATACADO Loja, eles POSSUEM a reduo, por isso no  VAREJO IN (0, 2, 4)
                       (COALESCE(CASE WHEN COALESCE(IUF.ICMISE,'F') = 'T' THEN 0 ELSE ICO.VLRICM END, 0) / (ICO.QTDMOV/ CASE WHEN COALESCE(DSUB.CODSAL, 0) = 0 THEN 1 ELSE SUB.FATCON END))
                    ELSE 
                       CASE WHEN (DFIL.REGTRI = 'N') OR (DFIL.REGTRI = 'S' AND (COALESCE(DFIL.TRISIM,'X') = 'O'))
                            THEN (COALESCE(ICO.VLRICMDIF, 0) / (ICO.QTDMOV/ CASE WHEN COALESCE(DSUB.CODSAL, 0) = 0 THEN 1 ELSE SUB.FATCON END))
                            ELSE 0
                            END
                 END
              END
       END AS VLRICM,
--       COALESCE(ICO.VLRMOV/ICO.QTDMOV,0)*(DFIL.COMPIS/100) AS VLR_COMPIS,
--       COALESCE(ICO.VLRMOV/ICO.QTDMOV,0)*(DFIL.COMCOF/100) AS VLR_COMCOF,
       ICO.VLRPIS/(ICO.QTDMOV/CASE WHEN COALESCE(DSUB.CODSAL, 0) = 0 THEN 1 ELSE SUB.FATCON END) AS VLR_COMPIS,
       ICO.VLRCOF/(ICO.QTDMOV/CASE WHEN COALESCE(DSUB.CODSAL, 0) = 0 THEN 1 ELSE SUB.FATCON END) AS VLR_COMCOF,
       ICO.PERPIS AS COMPIS,                               /* PERCENTUAL DE PIS                 */
       ICO.PERCOF AS COMCOF,                               /* PERCENTUAL DE COFINS              */
       /* PERCENTUAL DE CONTR. SOCIAL - para apresentacao na tela */
       CASE WHEN DFIL.REGTRI = 'N' THEN COALESCE(DFIL.PERSOC,0) ELSE 0 END AS PERSOC,
       /* PERCENTUAL DE CONTR. SOCIAL - para fins de calculo */
       -- RFMP 85326 NO LUCRO Numeric a formula e CSLL * LUCRO / 100 */
       CASE WHEN DFIL.REGTRI = 'N' AND DFIL.TIPLUC = 'R'
            THEN COALESCE(DFIL.PERSOC,0) * NVLZ(NVLZ(PRE.PERLUC, TPR.PERLUC), COALESCE(GRA.PERLUC, 0)) / 100
            ELSE CASE WHEN DFIL.REGTRI = 'N' THEN COALESCE(DFIL.PERSOC,0) ELSE 0 END
        END AS PERSOC_R,
       CASE WHEN CFG.PERCOM_FPV = 'T' THEN
              CASE WHEN COALESCE(GRA.PERCOM,0) = 0 THEN COALESCE(CFG.PERCOM,0) ELSE COALESCE(GRA.PERCOM,0) END
            ELSE 0
        END AS PERCOM,                              /* PERCENTUAL DE COMISSAO            */
       COALESCE(DespesaOperacional('V',PRE.FILPRE,PRE.CODPRE,PRO.CLASS1,PRO.CLASS2,PRO.CLASS3,PRO.CLASS4,PRO.DEPART,DFIL.CODFIL),0) AS PEROPE,    /* PERCENTUAL DE DESPESA OPERACIONAL */
       COALESCE(DespesaOperacional('F',PRE.FILPRE,PRE.CODPRE,PRO.CLASS1,PRO.CLASS2,PRO.CLASS3,PRO.CLASS4,PRO.DEPART,DFIL.CODFIL),0) AS PEROPEFIX, /* PERCENTUAL DE DESPESA OPERACIONAL */
       /* IMPOSTO DE RENDA - para apresentacao na tela */
       CASE WHEN (DFIL.REGTRI = 'N' OR LeParametroBoo('CALC_IR_FILSIMPLES', DFIL.CODFIL, '', '', '') = 'T') THEN COALESCE(NVLZ(CFG.PERIR, NULL), NVLZ(IRR_PRO.RESIRR, NULL), IRR_FIL.RESIRR, 0) ELSE 0 END AS PERIRE,
       /* IMPOSTO DE RENDA - para fins de calculo */
       -- RFMP 85326 NO LUCRO Numeric a formula e IR * LUCRO / 100 */
       CASE WHEN (DFIL.REGTRI = 'N' OR LeParametroBoo('CALC_IR_FILSIMPLES', DFIL.CODFIL, '', '', '') = 'T') AND DFIL.TIPLUC = 'R'
            THEN COALESCE(NVLZ(CFG.PERIR, NULL), NVLZ(IRR_PRO.RESIRR, NULL), IRR_FIL.RESIRR, 0) * NVLZ(NVLZ(PRE.PERLUC, TPR.PERLUC), COALESCE(GRA.PERLUC, 0)) / 100
            ELSE CASE WHEN DFIL.REGTRI = 'N' THEN COALESCE(NVLZ(CFG.PERIR, NULL), NVLZ(IRR_PRO.RESIRR, NULL), IRR_FIL.RESIRR, 0) ELSE 0 END
        END AS PERIRE_R,
       /* PERCENTUAL DE ICMS NA VENDA */
       COALESCE(
           CASE WHEN DFIL.RE8020='T' AND PRO.MONTAR<>'F' -- ICMS com tratamento 80 20
                           THEN (COALESCE(CASE WHEN COALESCE(IUF.ICMISE, 'F') = 'T' THEN 0 ELSE DICM.RESICM END,0)*(100-COALESCE(IUF.PERSRV,0))+COALESCE(ISS.RESISS,0)*COALESCE(IUF.PERSRV,0))/100
                           -- MN - Tabela ATACADO LOJA se comporta igual varejo na hora da venda, nesse IF  validado IUF.SUBTRI = '3' ou seja, venda de produto substitudo
                           -- como est sendo calculado o % de ICMS, o imposto  zerado, pois varejo/atacado loja, declara o ST
                           ELSE CASE WHEN (IUF.SUBTRI = '3' AND ((COALESCE(DFIL.SUBSTITUTA,'F') = 'F') OR TPR.VAREJO in (0, 2, 4))) OR (COALESCE(IUF.ICMISE, 'F') = 'T') OR (((COALESCE(DFIL.SUBSTITUTA,'F') = 'T') AND FOR060 = 'T'))
                                     THEN 0
                                     ELSE CASE WHEN (DFIL.REGTRI = 'N') OR (DFIL.REGTRI = 'S' AND (COALESCE(DFIL.TRISIM,'X') = 'O')) THEN DICM.RESICM ELSE 0 END
                           END
           END * -- RFMP 87318
                 -- MN - Tabela ATACADO LOJA se comporta igual varejo na hora da venda
                 -- ATACADO LOJA  um conceito da PCIA porque a filial no vende o suficiente pra ser SUBSTITUTA, ter a obrigao de recolher o ST, e portanto pagar imposto s na hora da venda
                 -- Mas esse tipo de filial ainda conta com Regime especial na compra
                 CASE WHEN TPR.VAREJO IN (0,2) OR (TPR.VAREJO = 3 AND IUF.FLGRED = 'E')  OR (((COALESCE(DFIL.SUBSTITUTA,'F') = 'T') AND FOR060 = 'T'))
                      THEN (1-(COALESCE(IRE.REDCON,0)/100)) -- VAREJO
                      ELSE (1-(COALESCE(IRE.ICMSRE,0)/100)) -- ATACADO
                 END,0) 
                 -- MN - 2020113170 - Case apenas para zerar ICMS se o produto for isento de ICMS na venda
                 * CASE WHEN COALESCE(IUF.ICMISE, 'F') = 'T' THEN 0 ELSE 1 
                   END AS PERIVE,
       /* PERCENTUAL DE LUCRO */
       NVLZ(NVLZ(PRE.PERLUC, TPR.PERLUC), COALESCE(GRA.PERLUC, 0)) AS PERLUC,
       -- RFMP 87318
       -- MN - Tabela ATACADO LOJA se comporta igual varejo na hora da venda
                 -- ATACADO LOJA  um conceito da PCIA porque a filial no vende o suficiente pra ser SUBSTITUTA, ter a obrigao de recolher o ST, e portanto pagar imposto s na hora da venda
                 -- Mas esse tipo de filial ainda conta com Regime especial na compra
       CASE WHEN TPR.VAREJO IN (0, 2) OR (TPR.VAREJO = 3 AND IUF.FLGRED = 'E')
            THEN COALESCE(IRE.REDCON,0) -- VAREJO
            ELSE COALESCE(IRE.ICMSRE,0) -- ATACADO
       END AS ICMSRE,
       -- MN - 100280 - Zerar RESICM se filial substituta, produto substitudo e fora 060
       CASE WHEN (COALESCE(IUF.ICMISE, 'F') = 'T') OR (IUF.SUBTRI = '3' AND (COALESCE(DFIL.SUBSTITUTA,'F') = 'T') AND FOR060 = 'T') THEN 0 ELSE COALESCE(DICM.RESICM,0) END AS RESICM,
       DIV.ORDDIV AS ORDDIV,
       SUB.ORDSUB AS ORDSUB,
       CASE WHEN COALESCE(DSUB.CODSAL, 0) = 0 THEN 1 ELSE SUB.FATCON END AS FATCON,
       PRO.DESMAT AS DESMAT,
       PRO.ESPMAT AS ESPMAT,
       COALESCE(PRE.MARKUP, GRA.MARKUP) AS MARKUP,
       GRA.PREPSI,
       DIV.NOMITE AS ITEDIV,
       SUB.NOMITE AS ITESUB,
       DFIL.REGTRI,
       DFIL.TIPLUC,
       DFIL.TRISIM,
       DFIL.VENPIS AS DFIL_VENPIS,
       DFIL.VENCOF AS DFIL_VENCOF,
       DFIL.PERSOC AS DFIL_PERSOC,
       PRE.PERLUC AS PRE_PERLUC,
       TPR.PERLUC AS TPR_PERLUC,
       GRA.PERLUC AS IPR_PERLUC,
       CFG.PERCOM_FPV,
       GRA.PERCOM AS IPR_PERCOM,
       CFG.PERCOM AS CFG_PERCOM,
       COALESCE(NVLZ(CFG.PERIR, NULL), NVLZ(IRR_PRO.RESIRR, NULL), IRR_FIL.RESIRR, 0) AS PERIR, 
       DFIL.RE8020 AS DFIL_RE8020, 
       PRO.MONTAR AS IPR_MONTAR,
       IUF.ICMISE AS IUF_ICMISE,
       IUF.PERFCP AS IUF_PERFCP,
       DICM.RESICM AS DICM_RESICM,
       DICM.PERESPINTCOM AS DICM_PERESPINTCOM,
       DICM.PERESPESTCOM AS DICM_PERESPESTCOM,
       DICM.PERESPINTVEN AS DICM_PERESPINTVEN,
       DICM.PERESPESTVEN AS DICM_PERESPESTVEN,
       DICM_COM.RESICM AS DICM_COM_RESICM,
       DICM_COM.PERESPINTCOM AS DICM_COM_PERESPINTCOM,
       DICM_COM.PERESPESTCOM AS DICM_COM_PERESPESTCOM,
       DICM_COM.PERESPINTVEN AS DICM_COM_PERESPINTVEN,
       DICM_COM.PERESPESTVEN AS DICM_COM_PERESPESTVEN,
       IUF.PERSRV AS IUF_PERSRV,
       ISS.RESISS AS ISS_RESISS,
       IUF.FLGRED AS IUF_FLGRED,
       IRE.ICMSRE AS IRE_ICMSRE,
       GRA.REFPRO AS REFPRO,
       COALESCE(PRE.PRECOV,0) AS PRECOV,
       CASE WHEN COALESCE(COM.VLRFRE,0) > 0 THEN 
               -- Pedro E. Braga - Sempre realiza baseado no calculo proporcional pois  assim que  realizado no calculo do Custo Mdio
               --CASE WHEN COALESCE(ICO.ICO_VLRFRE,0) > 0 THEN ICO.ICO_VLRFRE+COALESCE(ICO.IPIFRE,0)
               --     ELSE ROUND(COM.VLRFRE * ICO.VLRMOV / (COM.VLRTOT-COALESCE(COM.VLRIPI,0)-COALESCE(COM.VLRSRV,0)),2)/ICO.QTDMOV
               --END
               ROUND(COM.VLRFRE * ICO.VLRMOV / (COM.VLRTOT-COALESCE(COM.VLRIPI,0)-COALESCE(COM.VLRSRV,0)),2)
            ELSE TotComFre(FRE.CODFIL,FRE.SEQUEN)
        END AS TOTCOMFRE,
       ICO.CUSREP,PRO.SUBFED,GRA.CUSREP AS REPGRA,
       CUSTOMEDIO(ICO.CODFIL,ICO.FILMAT,ICO.CODMAT,ICO.CODCOR,ICO.CODTAM,5,ICO.COM_DATOPE) AS VLRCMG,
       CFG.BASE_MARKUP, (ICO.VLRMOV+((ICO.VLRMOV*COALESCE(ICO.IPIITE,0))/100))/ICO.QTDMOV as PRECOM_CIPI,
       PRO.DEPART, PRO.CLASS1, PRO.CLASS2, PRO.CLASS3, PRO.CLASS4, ICO.IPIFRE,
       COALESCE(ICO.OUTDES,0) AS OUTDES,
       COALESCE(COM.DESPAR,0) AS DESPAR,
       ICO.REDITEDIF AS REDITE,
       COM.VLRNOT,
       COALESCE(ICO.MVACOMDIF,IUF.MVAVEN,0) AS MVACOM,
       ICO.RETSUB,
       GRA.FILCOM AS GRA_FILCOM, GRA.SEQCOM AS GRA_SEQCOM, GRA.ITECOM AS GRA_ITECOM, 
       GRA.DATFPV AS GRA_DATFPV,
       PRO.ISEPIS,
       ICO.VLRIPI/(ICO.QTDMOV/CASE WHEN COALESCE(DSUB.CODSAL, 0) = 0 THEN 1 ELSE SUB.FATCON END) AS VLRIPI,
       PRE.FILPRE,
       PRE.CODPRE,
       TPR.VAREJO,
       TPR.DESPRE,
       PRO.CODNCM,
       PRO.TIPMPB,
       PRO.ORIPRO,
       DFIL.SUBSTITUTA AS DFIL_SUBSTITUTA,
       CASE WHEN ICO.ICMITEDIF = 4 THEN COALESCE(IUF.MVAC04,0)
            WHEN ICO.ICMITEDIF = 7 THEN COALESCE(IUF.MVAC07,0)
            WHEN ICO.ICMITEDIF = 12 THEN COALESCE(IUF.MVAC12,0)
            ELSE IUF.MVAVEN
       END AS MVAVEN,
       IRE.REDCON,
       COALESCE((SELECT MIN(PED.DESESP)
                   FROM TT_IPE IPE INNER JOIN TT_PED PED ON PED.CODFIL = IPE.CODFIL
                                                        AND PED.NUMPED = IPE.NUMPED
                  WHERE IPE.FILICO = ICO.CODFIL
                    AND IPE.SEQICO = ICO.SEQUEN
                    AND IPE.NUMICO = ICO.NUMITE),0) AS DESESP,
       COALESCE(ICO.ALIICMAGR,0) AS ALIICMAGR,
       CASE WHEN COALESCE(ICO.VLRICMAGR,0) > 0 -- RFMP 96341
            THEN ICO.VLRICMAGR/(ICO.QTDMOV/CASE WHEN COALESCE(DSUB.CODSAL, 0) = 0 THEN 1 ELSE SUB.FATCON END)
            ELSE 0
       END AS VLRICMAGR,
       COALESCE(NVLZ(PRE.MULTIP, TPR.MULTIP), 1) AS MULTIP, -- RFMP 97282 Incluso das colunas
       PRE.ULTELA,                                          -- de elasticidade e multiplicador
       PRE.DIAELA,
       PRE.CODMOE,
       TPR.SIGNAT AS TPR_SIGNAT,
       LeParametroBoo('PIS_S_ICMS_VEN',DFIL.CODFIL,'','','') AS PIS_S_ICMS_VEN,
       LeParametroBoo('PISCOF_SEMIPISAIDA', DFIL.CODFIL, '', '', '') AS PISCOF_SEMIPISAIDA,
       PRO.FOR060,
       CASE WHEN COALESCE(ICO.APRBON,0) > 0
            THEN ICO.APRBON/(ICO.QTDMOV/CASE WHEN COALESCE(DSUB.CODSAL, 0) = 0 THEN 1 ELSE SUB.FATCON END)
            ELSE 0
       END AS APRBON,
       COALESCE(GRA.GRAABC, CAST(DescricaoDominio('PRO','CLSABC',TO_CHAR(PRO.CLSABC)) AS VARCHAR(1))) AS CLAABC,
       COALESCE(GRA.GRAXYZ, CAST(DescricaoDominio('PRO','CLSXYZ',TO_CHAR(PRO.CLSXYZ)) AS VARCHAR(1))) AS CLAXYZ,
       CLI.NOMCLI, CLI.ULTNOM, 
       CAST(ICO_ANT.VLRMOV/(ICO_ANT.QTDMOV/CASE WHEN COALESCE(DSUB.CODSAL, 0) = 0 THEN 1 ELSE SUB.FATCON END) AS Numeric(18,4)) AS VLRUNI_ANT, 
       CAST(ICO_ANT.QTDMOV AS Numeric(18,4)) AS QTDMOV_ANT, 
       CAST(CLI_ANT.NOMCLI AS VARCHAR(100)) AS NOMCLI_ANT, CAST(CLI_ANT.ULTNOM AS VARCHAR(100)) AS ULTNOM_ANT,
       DFIL.UFLOJA, 
       (COALESCE(ICO.VLRICMANT, 0) / (ICO.QTDMOV/ CASE WHEN COALESCE(DSUB.CODSAL, 0) = 0 THEN 1 ELSE SUB.FATCON END)) AS VLRICMANT,
       ICO.PERICMANT,
       -- MN - Realiza clculo do ICMS especfico. O ICMS especfico  um benefcio fiscal concedido ao cliente JRA, nele o cliente perde o crdito de ICMS na entrada, alm disso, ainda inclui
       -- um % "Extra" de ICMS, ou seja, aumenta o custo da mercadoria, mas por outro lado na sada/venda, ao invs de pagar 17% de ICMS eles pagam s 2.5% (alquotas variveis, apenas um exemplo)
       -- Somente produtos TRIBUTADOS e substitudos, que no forcem o CST 060. Somente calcula o ICMS especfico se a tabela de preo estiver marcada para calcular o ICMS especfico.
       -- Regras para Aplicar ICMS Especfico:
       -- 01 - Nas entradas da filial SUBSTITUTA, interestaduais
       -- 02 - Nas entradas da filial SUBSTITUDA quando for transferncia oriunda da filial SUBSTITUDA
       -- MN - Nos clculos posteriores o sistema estar setado para calcular as entradas estaduais, porm como o benefcio  somente para interestadual, o bloqueio  realizado aqui
       -- Setando UTILIZA_ICMS_ESPECIFICO para F nas entradas estaduais, produtos que no sejam tributados ou produtos que forcem 060
       --CASE WHEN ((LeParametroBoo('USA_ICMS_ESPECIFICO',COM.CODFIL,'','','') = 'F') OR PRO.FOR060 = 'T') AND (IUF.SUBTRI <> '0' AND IUF.SUBTRI <> '3') OR (COALESCE(TPR.USAICMESP, 'F') <> 'T')
       --      THEN 'F' -- MN - Parmetro indicando se filial utiliza ICMS Especfico
       --      ELSE CASE WHEN (COALESCE(DFIL.SUBSTITUTA, 'F') = 'T') AND (DFIL.UFLOJA <> TEND.SIGEST) THEN 'T' -- MN - Regra 1
       --                WHEN (COALESCE(DFIL.SUBSTITUTA, 'T') = 'F') AND (COM.CODFOR = '     0') AND (COALESCE(DFIL_FOR.SUBSTITUTA, 'F') = 'T') THEN 'T' -- MN - Regra 2
       --                ELSE 'F'
       --           END
       --END AS UTILIZA_ICMS_ESPECIFICO
      CAST(CASE WHEN ICO.CODCSTDIF IN ('60','500') THEN 'F'
                ELSE COALESCE(TPR.USAICMESP, 'F')
           END AS VARCHAR(1)) AS UTILIZA_ICMS_ESPECIFICO
  FROM TT_COM COM INNER JOIN TT_ICO ICO ON ICO.CODFIL = COM.CODFIL 
                                       AND ICO.SEQUEN = COM.SEQUEN
                  INNER JOIN TD_FIL DFIL ON COM.CODFIL = DFIL.CODFIL
                  INNER JOIN TD_FIL DFIL_FOR ON COM.FILFOR = DFIL_FOR.CODFIL
                  LEFT JOIN TD_CFO CFO ON CFO.CODTAB = ICO.CODCFO
                  LEFT JOIN TT_COM FRE ON COM.FILFRE = FRE.CODFIL 
                                      AND COM.SEQFRE = FRE.SEQUEN
                  CROSS JOIN (SELECT FL1.CODCID, FL1.UFLOJA, FL1.REGESP
                                FROM TD_FIL FL1
                              CROSS JOIN TT_IDF ID1
                              CROSS JOIN TT_CFG CFG
                              WHERE FL1.CODFIL = COALESCE(CFG.FILCMP,ID1.CODLOJ)) FL1
                  INNER JOIN TT_PRO PRO ON PRO.FILMAT = ICO.FILMAT
                                       and PRO.CODMAT = ICO.CODMAT
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = ICO.FILMAT
                                       AND GRA.CODMAT = ICO.CODMAT
                                       AND GRA.CODCOR = ICO.CODCOR
                                       AND GRA.CODTAM IN (SELECT CODITE FROM TT_SUB
                                                           WHERE CODITE = ICO.CODTAM
                                                           UNION ALL
                                                          SELECT TT.CODITE
                                                            FROM TD_SUB TD, TT_SUB TT, TT_SUB SUB
                                                           WHERE TD.CODTAB = TT.CODSUB
                                                             AND SUB.CODSUB = TT.CODSUB
                                                             AND SUB.CODITE = ICO.CODTAM
                                                             AND TT.CODITE <> ICO.CODTAM
                                                             AND TD.CODSAL IS NOT NULL)
                  INNER JOIN TT_SUB SUB ON SUB.CODITE = GRA.CODTAM
                  LEFT OUTER JOIN TD_SUB DSUB ON DSUB.CODTAB = SUB.CODSUB
                  INNER JOIN TT_DIV DIV ON GRA.CODCOR = DIV.CODITE
                  INNER JOIN TT_IUF IUF ON IUF.FILMAT = GRA.FILMAT
                                       AND IUF.CODMAT = GRA.CODMAT
                                       AND IUF.ESTADO = FL1.UFLOJA
                                       AND IUF.REGESP = FL1.REGESP
                   LEFT JOIN TD_ICM DICM_COM ON DICM_COM.RESICM = ICO.ICMITE
                  INNER JOIN TD_ICM DICM ON DICM.CODTAB = IUF.RESICM
                  INNER JOIN TT_PRE PRE ON PRE.FILMAT = GRA.FILMAT
                                       AND PRE.CODMAT = GRA.CODMAT
                                       AND PRE.CODCOR = GRA.CODCOR
                                       AND PRE.CODTAM = GRA.CODTAM
                  INNER JOIN TT_TPR TPR ON TPR.CODFIL = PRE.FILPRE
                                       AND TPR.CODPRE = PRE.CODPRE
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = COM.FILFOR
                                       AND CLI.CODCLI = COM.CODFOR
                  INNER JOIN TT_END TEND ON TEND.FILCLI = CLI.FILCLI
                                        AND TEND.CODCLI = CLI.CODCLI
                                        AND TEND.CODFIL = COALESCE(COM.FILEND, CLI.FILEND)
                                        AND TEND.NUMEND = COALESCE(COM.NUMEND, CLI.NUMEND)
                   LEFT JOIN TT_IMU IMU ON IMU.FILMAT = GRA.FILMAT
                                       AND IMU.CODMAT = GRA.CODMAT
                                       AND IMU.CODCID = FL1.CODCID
                   LEFT JOIN TD_ISS ISS ON ISS.CODTAB = IMU.RESISS
                   LEFT JOIN TD_IRE IRE ON IRE.CODTAB = IUF.REDALI
                   -- Dados da penltima Compra
                   LEFT JOIN TT_ICO ICO_ANT ON GRA.FILCOM_ANT = ICO_ANT.CODFIL
                                           AND GRA.SEQCOM_ANT = ICO_ANT.SEQUEN
                                           AND GRA.ITECOM_ANT = ICO_ANT.NUMITE
                   LEFT JOIN TT_COM COM_ANT ON ICO_ANT.CODFIL = COM_ANT.CODFIL
                                           AND ICO_ANT.SEQUEN = COM_ANT.SEQUEN
                   LEFT JOIN TT_CLI CLI_ANT ON CLI_ANT.FILCLI = COM_ANT.FILFOR
                                           AND CLI_ANT.CODCLI = COM_ANT.CODFOR
                   LEFT JOIN TD_IRR IRR_PRO ON IRR_PRO.CODTAB = PRO.RESIRR
                   LEFT JOIN TD_IRR IRR_FIL ON IRR_FIL.CODTAB = DFIL.RESIRR
                  CROSS JOIN TT_CFG CFG
 WHERE 1 = 1
   AND PRO.SIGNAT >= 0
   AND GRA.GRAATI = 'T'
   -- RFMP 97282
   -- Filtro de tabelas-finalidade foi removido.
   -- Agora a view trs todas as tabelas de preo.
   -- AND (PRE.FILPRE,PRE.CODPRE) in ((CFG.FILPRE,CFG.CODPRE),(CFG.FILPRE_ATC,CFG.CODPRE_ATC),(CFG.FILPRE_REV,CFG.CODPRE_REV))
   AND COM.FLGEST   <> 'D'
   AND COM.TIPPAR   <> 'T'
   AND COALESCE(COM.FINNFE,'0') <> '2'--Desconsidera nota complementar
   AND COALESCE(COM.FINNFE,'0') <> '4'--Desconsidera nota de devoluo
   AND COALESCE(COM.VLRTOT,0) <> 0
   AND COALESCE(ICO.QTDMOV,0) <> 0
   AND ICO.TIPPRO <> '1'
) TAB
;


/*-- SEQ 2301 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FPV_PXF_INT CASCADE;

/*-- SEQ 2302 --*/
CREATE OR REPLACE VIEW TV_FPV_PXF_INT AS
SELECT CODTAB,CODFIL,SEQUEN,FILFRE,SEQFRE,FILFOR,TIPPAR,CODFOR,UF_FOR,DATOPE,DATCMP,
       DOCUME,ATU_EM,VLRFRE,VLRSEG,ICMFRE,VLRTOT,DESCON,OUTTAX,
       VLRLIQ,OBSERV,NUMITE,FILMAT,CODMAT,CODCOR,CODTAM,QTDMOV,PAUTAF,SUBTRI,
       VLRMOV,COALESCE(VLRBRU,0) AS VLRBRU,VLRPRE,IPIITE,ICMITE,COMPIS,COMCOF,VENPIS,VENCOF,PERSOC,PERSOC_R,PERIVE,
       PERCOM,PEROPE,PERIRE,PERIRE_R,PERLUC,PERTOT,REFPRO,VLR_COMPIS,VLR_COMCOF,
       ORDDIV,ORDSUB,DESMAT,ESPMAT,ITEDIV,ITESUB,VLRUNI,
       CODSER,SUBSER,NUMNOT,VMVIPI,PRECOV,TOTCOMFRE, ATUCUS,
       ICMCOM,IPICOM,VLRICM,ICMTIP,ICMTIPDIF,MARGEM,COALESCE(VLRUNI*IPIITE/100,0) AS VLRIPI,
       COALESCE(VLRFRE,0) AS FREITE,
       COALESCE((VLRSEG*(VLRTOT/NVLZ(TOTCOMFRE,null))*(VMVIPI/NVLZ(VLRTOT,NULL))),0) AS SEGITE,
       (DESCON*(VMVIPI/NVLZ(VLRTOT,NULL))) AS DESITE,
       (OUTTAX*(VMVIPI/NVLZ(VLRTOT,NULL))) AS TAXITE,
       (OUTDES / QTDMOV) AS OUTDESITE,
       ((DESPAR*(VMVIPI/NVLZ(VLRTOT,NULL)))/COM_QTDTOT) AS DESPARITE,
       SUBFED,VLRSUB,SUBITE,CUSREP,VLRCMG,BASE_MARKUP,
       PRECOM_CIPI+SUBITE as PRECOM_CIPI,REGTRI,TIPLUC,TRISIM,MARKUP,PREPSI,REPGRA,
       DEPART, CLASS1, CLASS2, CLASS3, CLASS4, ALIFRE, AFICUS, ICMSRE, RESICM, FATCON, REDITE,
       OUTDES, DESPAR, IPIFRE, MVACOM,
       VLRRET_ITE,
       VLRRET_UNI, ST_FRE, GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM,
       CAST('F' AS CHAR(1)) AS RETSUB, GRA_DATFPV,
       0.00 as PISFRE,
       FILPRE,
       CODPRE,
       VAREJO,
       DESPRE,
       CODNCM,
       TIPMPB,
       ORIPRO,
       SUBSTITUTA,
       0.00 as DESESP,
       0.00 as VLRDESESP,
       PEROPEFIX, /* Paulo K. 90072 */
       0.00 as ALIICMAGR,
       0.00 as VLRICMAGR,
       MULTIP,
       ULTELA,
       DIAELA,
       CODMOE,
       TPR_SIGNAT,
       CAST(0 AS Numeric(12,2)) AS VALOR_ST_UNI,
       PIS_S_ICMS_VEN, PISCOF_SEMIPISAIDA,FOR060, APRBON, CLAABC, CLAXYZ, NOMCLI, ULTNOM, VLRUNI_ANT, QTDMOV_ANT, NOMCLI_ANT, ULTNOM_ANT, 
       UFLOJA,
       CAST(((((COALESCE(VLRUNI_ANT, 0) - COALESCE(VLRUNI, 0)) / NVLZ(VLRUNI_ANT, NULL)) * 100) * (-1)) AS Numeric(18,4)) AS PERDIF_ULTCOM,
       IUF_PERFCP,
       DICM_RESICM,
       DICM_PERESPINTCOM,
       DICM_PERESPESTCOM,
       DICM_PERESPINTVEN,
       DICM_PERESPESTVEN,
       DICM_COM_RESICM,
       DICM_COM_PERESPINTCOM,
       DICM_COM_PERESPESTCOM,
       DICM_COM_PERESPINTVEN,
       DICM_COM_PERESPESTVEN,
       UTILIZA_ICMS_ESPECIFICO, VLRICMANT, PERICMANT,
       COALESCE(DICM_PERESPINTVEN,0) AS PERICMESPVEN,
       CASE WHEN UF_FOR = UFLOJA THEN COALESCE(DICM_COM_PERESPINTCOM,0) ELSE COALESCE(DICM_COM_PERESPESTCOM,0) END AS PERICMESPCOM,
       COALESCE(VLRUNI*CASE WHEN UF_FOR = UFLOJA THEN COALESCE(DICM_COM_PERESPINTCOM,0) ELSE COALESCE(DICM_COM_PERESPESTCOM,0) END/NVLZ(PERTOT,NULL), 0) AS VLRICMESPCOM
FROM (
SELECT (SELECT IND.CODTAB FROM TD_IND IND WHERE IND.CODTAB = 3) AS CODTAB,
       DFIL.CODFIL,
       TO_CHAR(' ') AS SEQUEN,
       TO_CHAR(' ') AS FILFRE,
       TO_CHAR(' ') AS SEQFRE,
       PXF.FILFOR AS FILFOR,
       PXF.CODFOR AS CODFOR,
       PXF.TIPFOR AS TIPPAR,
       PXF.UF_FOR AS UF_FOR,
       TO_CHAR(' ') AS CODSER,
       TO_CHAR(' ') AS SUBSER,
       TO_CHAR(' ') AS NUMNOT,
       PXF.ATU_EM AS DATOPE,
       PXF.ATU_EM AS DATCMP,
       CAST(DFIL.CODFIL AS VARCHAR(25)) AS DOCUME,
       PXF.ATU_EM AS ATU_EM,
       ROUND(((PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))) * PXF.PERFRE / 100),4) AS VLRFRE,
       CAST(0 AS Numeric(12,2)) AS VLRSEG,
       COALESCE(PXF.ALIFRE,0) AS ALIFRE,
       ROUND(((PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))) * PXF.PERFRE / 100) * PXF.ALIFRE / 100,4) AS ICMFRE,
       ROUND(((PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))) * COALESCE(PXF.ICMCUS,0) / 100),4) AS ICMCOM,
       ROUND(((PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))) * COALESCE(PXF.IPICUS,0) / 100),4) AS IPICOM,
       (COALESCE(ROUND(((PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))) * COALESCE(PXF.ICMCUS,0) / 100),4),0) + COALESCE(ROUND(((PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))) * COALESCE(PXF.IPICUS,0) / 100),4),0)) AS ICMIPICOM,
       (PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))) + ROUND(((PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))) * COALESCE(PXF.IPICUS,0) / 100),4) AS VLRTOT,
       PXF.DACCUS AS DESCON,
       PXF.AFICUS AS AFICUS,
       PXF.OUTCUS AS OUTTAX,
       (PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))) + ROUND(((PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))) * COALESCE(PXF.IPICUS,0) / 100),4) AS VLRLIQ,
       TO_CHAR(' ') AS OBSERV,
       CAST(0 AS Numeric(12,2)) AS SUBSTT,
       IUF.SUBTRI AS SUBTRI,
       CAST(0 AS Numeric(12,2)) AS VLRSUB,
       CAST(0 AS Numeric(12,2)) AS SUBITE,
       CAST(0 AS Numeric(5)) AS NUMITE,
       PXF.FILMAT AS FILMAT,
       PXF.CODMAT AS CODMAT,
       PXF.CODCOR AS CODCOR,
       PXF.CODTAM AS CODTAM,
       PXF.ICMTIP AS ICMTIP,
       PXF.ICMTIP AS ICMTIPDIF,
       IUF.MVAVEN AS MARGEM, -- RFMP 71137
       CAST(1 AS Numeric(12,2))  AS QTDMOV,
       CAST(0 AS Numeric(14,2)) AS PAUTAF, --82777
       (PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))) AS VLRMOV,
       (PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))) AS VLRBRU,
       COALESCE((PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))) + ROUND(((PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))) * COALESCE(PXF.IPICUS,0) / 100),4),0) AS VMVIPI,
       (PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))) AS VLRPRE,
       (PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))) AS VLRUNI,
       COALESCE(PXF.IPICUS,0) AS IPIITE,
       COALESCE(PXF.ICMCUS,0) AS ICMITE,
       CASE WHEN (DFIL.REGTRI = 'N') OR (DFIL.REGTRI = 'S' AND (COALESCE(DFIL.TRISIM,'X') = 'O')) THEN ROUND(((PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))) * COALESCE(PXF.ICMCUS,0) / 100),4) ELSE 0 END AS VLRICM,
       COALESCE((PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))),0) * CASE WHEN PXF.SUBFED = 'T' OR DFIL.REGTRI <> 'N' OR PXF.ISEPIS = 'T' THEN 0 ELSE (DFIL.COMPIS/100) END AS VLR_COMPIS,
       COALESCE((PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))),0) * CASE WHEN PXF.SUBFED = 'T' OR DFIL.REGTRI <> 'N' OR PXF.ISEPIS = 'T' THEN 0 ELSE (DFIL.COMCOF/100) END AS VLR_COMCOF,
       CASE WHEN PXF.SUBFED = 'T' OR DFIL.REGTRI <> 'N' OR PXF.ISEPIS = 'T' THEN 0 ELSE COALESCE(DFIL.COMPIS,0) END AS COMPIS,                                              /* PERCENTUAL DE PIS                 */
       CASE WHEN PXF.SUBFED = 'T' OR DFIL.REGTRI <> 'N' OR PXF.ISEPIS = 'T' THEN 0 ELSE COALESCE(DFIL.COMCOF,0) END AS COMCOF,                                              /* PERCENTUAL DE COFINS              */
       CASE WHEN PXF.SUBFED = 'T' OR DFIL.REGTRI <> 'N' OR PXF.ISEPIS = 'T' THEN 0 ELSE COALESCE(DFIL.COMPIS,0) END AS VENPIS,                                              /* PERCENTUAL DE PIS                 */
       CASE WHEN PXF.SUBFED = 'T' OR DFIL.REGTRI <> 'N' OR PXF.ISEPIS = 'T' THEN 0 ELSE COALESCE(DFIL.COMCOF,0) END AS VENCOF,                                              /* PERCENTUAL DE COFINS              */
       /* PERCENTUAL DE CONTR. SOCIAL  para apresentacao na tela */
       CASE WHEN DFIL.REGTRI = 'N' THEN COALESCE(DFIL.PERSOC,0) ELSE 0 END AS PERSOC,
       /* PERCENTUAL DE CONTR. SOCIAL  para fins de calculo */
       -- RFMP 85326 NO LUCRO Numeric a formula e CSLL * LUCRO / 100 */
       CASE WHEN DFIL.REGTRI = 'N' AND DFIL.TIPLUC = 'R' THEN COALESCE(DFIL.PERSOC,0) * PXF.PERLUC / 100 ELSE CASE WHEN DFIL.REGTRI = 'N' THEN COALESCE(DFIL.PERSOC,0) ELSE 0 END END AS PERSOC_R,
       CASE WHEN CFG.PERCOM_FPV = 'T' THEN
              CASE WHEN COALESCE(PXF.PERCOM,0) = 0 THEN COALESCE(CFG.PERCOM,0) ELSE COALESCE(PXF.PERCOM,0) END
            ELSE 0
        END AS PERCOM,                                                /* PERCENTUAL DE COMISSAO            */
       COALESCE(DespesaOperacional('V',PRE.FILPRE,PRE.CODPRE,PXF.CLASS1,PXF.CLASS2,PXF.CLASS3,PXF.CLASS4,PXF.DEPART,DFIL.CODFIL),0) AS PEROPE,    /* PERCENTUAL DE DESPESA OPERACIONAL */
       COALESCE(DespesaOperacional('F',PRE.FILPRE,PRE.CODPRE,PXF.CLASS1,PXF.CLASS2,PXF.CLASS3,PXF.CLASS4,PXF.DEPART,DFIL.CODFIL),0) AS PEROPEFIX, /* PERCENTUAL DE DESPESA OPERACIONAL */
       /* IMPOSTO DE RENDA  para apresentacao na tela */
       CASE WHEN (DFIL.REGTRI = 'N' OR LeParametroBoo('CALC_IR_FILSIMPLES', DFIL.CODFIL, '', '', '') = 'T') THEN COALESCE(NVLZ(CFG.PERIR, NULL), NVLZ(IRR_PRO.RESIRR, NULL), IRR_FIL.RESIRR, 0) ELSE 0 END AS PERIRE,
       /* IMPOSTO DE RENDA  para fins de calculo */
       -- RFMP 85326 NO LUCRO Numeric e IR * LUCRO / 100
       CASE WHEN (DFIL.REGTRI = 'N' OR LeParametroBoo('CALC_IR_FILSIMPLES', DFIL.CODFIL, '', '', '') = 'T') AND DFIL.TIPLUC = 'R' THEN COALESCE(NVLZ(CFG.PERIR, NULL), NVLZ(IRR_PRO.RESIRR, NULL), IRR_FIL.RESIRR, 0) * PXF.PERLUC / 100 
       ELSE CASE WHEN (DFIL.REGTRI = 'N' OR LeParametroBoo('CALC_IR_FILSIMPLES', DFIL.CODFIL, '', '', '') = 'T') THEN COALESCE(NVLZ(CFG.PERIR, NULL), NVLZ(IRR_PRO.RESIRR, NULL), IRR_FIL.RESIRR, 0) ELSE 0 END END AS PERIRE_R,
       CASE WHEN ((DFIL.REGTRI = 'N') OR (DFIL.REGTRI = 'S' AND (COALESCE(DFIL.TRISIM,'X') = 'O'))) AND (COALESCE(IUF.ICMISE, 'F') = 'F')
            THEN CASE WHEN DFIL.RE8020='T' AND PXF.MONTAR<>'F'
                      THEN (COALESCE(DICM.RESICM,0)*(100-COALESCE(IUF.PERSRV,0))+COALESCE(ISS.RESISS,0)*COALESCE(IUF.PERSRV,0))/100
                      ELSE DICM.RESICM
                  END*(1-(COALESCE(IRE.ICMSRE,0)/100))
             ELSE 0
       END AS PERIVE,                                               /* PERCENTUAL DE ICMS NA VENDA       */
       PXF.PERLUC,
       DIV.ORDDIV AS ORDDIV,
       SUB.ORDSUB AS ORDSUB,
       PXF.DESMAT AS DESMAT,
       PXF.ESPMAT AS ESPMAT,
       PXF.MARKUP,
       PXF.PREPSI,
       DIV.NOMITE AS ITEDIV,
       SUB.NOMITE AS ITESUB,
       SUB.FATCON,
       CASE WHEN COALESCE(IUF.ICMISE, 'F') = 'T' THEN 0 ELSE COALESCE(DICM.RESICM,0) END AS RESICM,
       COALESCE(IRE.ICMSRE,0) AS ICMSRE,
       DFIL.REGTRI,
       DFIL.TIPLUC,
       DFIL.TRISIM,
       100-(CASE WHEN PXF.SUBFED = 'T' OR DFIL.REGTRI <> 'N' OR PXF.ISEPIS = 'T' THEN 0 ELSE COALESCE(DFIL.COMPIS,0) END +
            CASE WHEN PXF.SUBFED = 'T' OR DFIL.REGTRI <> 'N' OR PXF.ISEPIS = 'T' THEN 0 ELSE COALESCE(DFIL.COMCOF,0) END +
            CASE WHEN DFIL.REGTRI = 'N' AND DFIL.TIPLUC = 'R' THEN COALESCE(DFIL.PERSOC,0) * PXF.PERLUC / 100 ELSE CASE WHEN DFIL.REGTRI = 'N' THEN COALESCE(DFIL.PERSOC,0) ELSE 0 END END +
            CASE WHEN CFG.PERCOM_FPV = 'T' THEN
                   CASE WHEN COALESCE(PXF.PERCOM,0) = 0 THEN COALESCE(CFG.PERCOM,0) ELSE COALESCE(PXF.PERCOM,0) END
                 ELSE 0
             END+
            COALESCE(DespesaOperacional('V',PRE.FILPRE,PRE.CODPRE,PXF.CLASS1,PXF.CLASS2,PXF.CLASS3,PXF.CLASS4,PXF.DEPART,DFIL.CODFIL),0)+
            COALESCE(DespesaOperacional('F',PRE.FILPRE,PRE.CODPRE,PXF.CLASS1,PXF.CLASS2,PXF.CLASS3,PXF.CLASS4,PXF.DEPART,DFIL.CODFIL),0)+
            CASE WHEN (DFIL.REGTRI = 'N' OR LeParametroBoo('CALC_IR_FILSIMPLES', DFIL.CODFIL, '', '', '') = 'T') AND DFIL.TIPLUC = 'R' THEN COALESCE(NVLZ(CFG.PERIR, NULL), NVLZ(IRR_PRO.RESIRR, NULL), IRR_FIL.RESIRR, 0) * PXF.PERLUC / 100 
            ELSE CASE WHEN (DFIL.REGTRI = 'N' OR LeParametroBoo('CALC_IR_FILSIMPLES', DFIL.CODFIL, '', '', '') = 'T') THEN COALESCE(NVLZ(CFG.PERIR, NULL), NVLZ(IRR_PRO.RESIRR, NULL), IRR_FIL.RESIRR, 0) ELSE 0 END END +
            COALESCE(
            CASE WHEN DFIL.RE8020='T' AND PXF.MONTAR<>'F'                     -- ICMS com tratamento 80 20
                            THEN (COALESCE(CASE WHEN COALESCE(IUF.ICMISE, 'F') = 'T' THEN 0 ELSE DICM.RESICM END,0)*(100-COALESCE(IUF.PERSRV,0))+COALESCE(ISS.RESISS,0)*COALESCE(IUF.PERSRV,0))/100
                            ELSE CASE WHEN (IUF.SUBTRI = '3') OR (COALESCE(IUF.ICMISE, 'F') = 'T')
                                      THEN 0
                                      ELSE CASE WHEN (DFIL.REGTRI = 'N') OR (DFIL.REGTRI = 'S' AND (COALESCE(DFIL.TRISIM,'X') = 'O')) THEN DICM.RESICM ELSE 0 END
                                  END
            END * (1-(COALESCE(IRE.ICMSRE,0)/100)),0)+PXF.PERLUC ) AS PERTOT,
       PXF.REFPRO AS REFPRO,
       PRE.PRECOV,
       ROUND((PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))) + ((PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))) * PXF.PERFRE / 100),4) AS TOTCOMFRE,
       PXF.CUSREP,
       PXF.SUBFED,
       PXF.CUSREP AS REPGRA,
       COALESCE(CUSTOMEDIO(DFIL.CODFIL, PXF.FILMAT, PXF.CODMAT, PXF.CODCOR, PXF.CODTAM, 5),0) AS VLRCMG,
       CFG.BASE_MARKUP,
       (PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))) + ROUND(((PXF.PRECOM * (1 + (COALESCE(PXF.DACCUS,0) / 100))) * COALESCE(PXF.IPICUS,0) / 100),4) AS PRECOM_CIPI,
       PXF.DEPART, PXF.CLASS1, PXF.CLASS2, PXF.CLASS3, PXF.CLASS4,
       COALESCE(PXF.ULTBAS,0) AS REDITE,
       CAST(0 AS Numeric(12,2)) AS OUTDES, CAST(0 AS Numeric(12,2)) AS DESPAR, CAST(1 AS Numeric(12,2)) AS COM_QTDTOT,
       PXF.IPIFRE,
       COALESCE(PXF.MVACOM,0) AS MVACOM,
       CAST(0 AS Numeric(12,2)) AS VLRRET_ITE,
       CAST(0 AS Numeric(12,2)) AS VLRRET_UNI,
       CAST(0 AS Numeric(12,2)) AS ST_FRE,
       GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM, GRA_DATFPV, ATUCUS,
       PRE.FILPRE,
       PRE.CODPRE,
       TPR.VAREJO,
       TPR.DESPRE,
       PXF.CODNCM,
       PXF.TIPMPB,
       PXF.ORIPRO,
       DFIL.SUBSTITUTA,
       COALESCE(NVLZ(PRE.MULTIP, TPR.MULTIP), 1) AS MULTIP, -- RFMP 97282 Incluso das colunas
       PRE.ULTELA,                                          -- de elasticidade e multiplicador
       PRE.DIAELA,
       PRE.CODMOE,
       TPR.SIGNAT AS TPR_SIGNAT,
       LeParametroBoo('PIS_S_ICMS_VEN', DFIL.CODFIL, '', '', '') AS PIS_S_ICMS_VEN,
       LeParametroBoo('PISCOF_SEMIPISAIDA', DFIL.CODFIL, '', '', '') AS PISCOF_SEMIPISAIDA,
       PXF.FOR060,
       CAST(0 AS Numeric(16,2)) AS APRBON,
       PXF.CLAABC, PXF.CLAXYZ, PXF.NOMCLI, PXF.ULTNOM, 
       CAST(NULL AS Numeric(18,4)) AS VLRUNI_ANT, CAST(NULL AS Numeric(18,4)) AS QTDMOV_ANT, 
       CAST(NULL AS VARCHAR(100)) AS NOMCLI_ANT, CAST(NULL AS VARCHAR(100)) AS ULTNOM_ANT,
       PXF.UFLOJA,
       IUF.PERFCP AS IUF_PERFCP,
       DICM.RESICM AS DICM_RESICM,
       DICM.PERESPINTCOM AS DICM_PERESPINTCOM,
       DICM.PERESPESTCOM AS DICM_PERESPESTCOM,
       DICM.PERESPINTVEN AS DICM_PERESPINTVEN,
       DICM.PERESPESTVEN AS DICM_PERESPESTVEN,
       DICM_COM.RESICM AS DICM_COM_RESICM,
       DICM_COM.PERESPINTCOM AS DICM_COM_PERESPINTCOM,
       DICM_COM.PERESPESTCOM AS DICM_COM_PERESPESTCOM,
       DICM_COM.PERESPINTVEN AS DICM_COM_PERESPINTVEN,
       DICM_COM.PERESPESTVEN AS DICM_COM_PERESPESTVEN,
       CAST(0 AS Numeric(12, 2)) AS VLRICMANT, CAST(0 AS Numeric(7, 4)) AS PERICMANT,
       -- MN - Realiza clculo do ICMS especfico. O ICMS especfico  um benefcio fiscal concedido ao cliente JRA, nele o cliente perde o crdito de ICMS na entrada, alm disso, ainda inclui
       -- um % "Extra" de ICMS, ou seja, aumenta o custo da mercadoria, mas por outro lado na sada/venda, ao invs de pagar 17% de ICMS eles pagam s 2.5% (alquotas variveis, apenas um exemplo)
       -- Somente produtos TRIBUTADOS e que no forcem o CST 060.
       -- Regras para Aplicar ICMS Especfico:
       -- 01 - Nas entradas da filial SUBSTITUTA, interestaduais
       -- 02 - Nas entradas da filial SUBSTITUDA quando for transferncia oriunda da filial SUBSTITUDA
       -- MN - Nos clculos posteriores o sistema estar setado para calcular as entradas estaduais, porm como o benefcio  somente para interestadual, o bloqueio  realizado aqui
       -- Setando UTILIZA_ICMS_ESPECIFICO para F nas entradas estaduais, produtos que no sejam tributados ou produtos que forcem 060
       CASE WHEN (LeParametroBoo('USA_ICMS_ESPECIFICO', DFIL.CODFIL,'','','') = 'F') OR IUF.SUBTRI <> '0' OR PRO.FOR060 = 'T'
             THEN 'F' -- MN - Parmetro indicando se filial utiliza ICMS Especfico
             ELSE CASE WHEN (COALESCE(DFIL.SUBSTITUTA, 'F') = 'T') AND (DFIL.UFLOJA <> UF_FOR) THEN 'T' -- MN - Regra 1
                       WHEN (COALESCE(DFIL.SUBSTITUTA, 'T') = 'F') AND (PXF.CODFOR = '     0') AND (COALESCE(DFIL_FOR_SUBSTITUTA, 'F') = 'T') THEN 'T' -- MN - Regra 2
                       ELSE 'F'
                       END
             END AS UTILIZA_ICMS_ESPECIFICO
  FROM (SELECT FL1.UFLOJA, FL1.REGESP, FL1.CODCID, PXF.*, GRA.PERCOM, GRA.CUSREP, GRA.REFPRO, GRA.PREPSI, GRA.MARKUP, COALESCE(GRA.PERLUC,0) AS PERLUC, PRO.MONTAR, PRO.DESMAT, PRO.ESPMAT, PRO.SUBFED,
                                     PRO.DEPART, PRO.CLASS1, PRO.CLASS2, PRO.CLASS3, PRO.CLASS4, PRO.ISEPIS,
                                     GRA.FILCOM AS GRA_FILCOM, GRA.SEQCOM AS GRA_SEQCOM, GRA.ITECOM AS GRA_ITECOM, GRA.DATFPV AS GRA_DATFPV, 
                                     COALESCE(GRA.GRAABC, CAST(DescricaoDominio('PRO','CLSABC',TO_CHAR(PRO.CLSABC)) AS VARCHAR(1))) AS CLAABC, 
                                     COALESCE(GRA.GRAXYZ, CAST(DescricaoDominio('PRO','CLSXYZ',TO_CHAR(PRO.CLSXYZ)) AS VARCHAR(1))) AS CLAXYZ,
                                     COM.ATUCUS AS ATUCUS,
                                     PRO.CODNCM, PRO.TIPMPB, PRO.ORIPRO, PRO.FOR060,
                                     TEND.SIGEST AS UF_FOR, CLI.NOMCLI, CLI.ULTNOM, DFIL_FOR.SUBSTITUTA AS DFIL_FOR_SUBSTITUTA
                                FROM TT_PXF PXF INNER JOIN TT_PRO PRO ON PXF.FILMAT = PRO.FILMAT AND PXF.CODMAT = PRO.CODMAT
                                                INNER JOIN TT_GRA GRA ON GRA.FILMAT = PXF.FILMAT AND GRA.CODMAT = PXF.CODMAT
                                                                     AND GRA.CODCOR = PXF.CODCOR AND GRA.CODTAM = PXF.CODTAM
                                                INNER JOIN TT_CLI CLI ON CLI.FILCLI = PXF.FILFOR
                                                                     AND CLI.CODCLI = PXF.CODFOR
                                                INNER JOIN TD_FIL DFIL_FOR ON PXF.FILFOR = DFIL_FOR.CODFIL
                                                INNER JOIN TT_END TEND ON TEND.CODFIL = CLI.FILEND
                                                                      AND TEND.NUMEND = CLI.NUMEND
                                                                      AND TEND.FILCLI = CLI.FILCLI
                                                                      AND TEND.CODCLI = CLI.CODCLI
                                                LEFT JOIN  TT_COM COM ON GRA.FILCOM = COM.CODFIL
                                                                     AND GRA.SEQCOM = COM.SEQUEN
                                                CROSS JOIN TD_FIL FL1
                                                CROSS JOIN TT_IDF ID1
                                                CROSS JOIN TT_CFG CFG
                               WHERE FL1.CODFIL = COALESCE(CFG.FILCMP,ID1.CODLOJ)
                                 AND PRO.SIGNAT>=0
                                 AND GRA.GRAATI='T'
                       ) PXF INNER JOIN TT_SUB SUB ON SUB.CODITE = PXF.CODTAM
                           INNER JOIN TT_DIV DIV ON DIV.CODITE = PXF.CODCOR
                           INNER JOIN TT_IUF IUF ON IUF.FILMAT = PXF.FILMAT AND IUF.CODMAT = PXF.CODMAT AND IUF.ESTADO = PXF.UFLOJA AND IUF.REGESP = PXF.REGESP
                           INNER JOIN TD_ICM DICM ON DICM.CODTAB = IUF.RESICM
                            LEFT JOIN TD_ICM DICM_COM ON DICM_COM.RESICM = PXF.ICMCUS
                           INNER JOIN TT_PRE PRE ON PRE.FILMAT = PXF.FILMAT AND PRE.CODMAT = PXF.CODMAT AND PRE.CODCOR = PXF.CODCOR AND PRE.CODTAM = PXF.CODTAM
                           INNER JOIN TT_TPR TPR ON TPR.CODFIL = PRE.FILPRE AND TPR.CODPRE = PRE.CODPRE
                            LEFT JOIN TT_IMU IMU ON IMU.FILMAT = PXF.FILMAT and IMU.CODMAT = PXF.CODMAT and IMU.CODCID = PXF.CODCID
                            LEFT JOIN TT_PRO PRO ON PRO.CODMAT = PRE.CODMAT AND PRO.FILMAT = PRE.FILMAT
                            LEFT JOIN TD_ISS ISS ON ISS.CODTAB = IMU.RESISS
                            LEFT JOIN TD_IRE IRE ON IRE.CODTAB = IUF.REDALI
                            CROSS JOIN TT_CFG CFG
                            CROSS JOIN TD_FIL DFIL
                            LEFT JOIN TD_IRR IRR_PRO ON IRR_PRO.CODTAB = PRO.RESIRR
                            LEFT JOIN TD_IRR IRR_FIL ON IRR_FIL.CODTAB = DFIL.RESIRR
         WHERE PXF.PRECOM <> 0
           -- RFMP 97282
           -- Filtro pela tabela varejo foi removido.
           --AND PRE.FILPRE = CFG.FILPRE
           --AND PRE.CODPRE = CFG.CODPRE
       ) TAB
;


/*-- SEQ 2303 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FPV_SIM_INT CASCADE;

/*-- SEQ 2304 --*/
CREATE OR REPLACE VIEW TV_FPV_SIM_INT AS
SELECT CODTAB,CODFIL,SEQUEN,FILFRE,SEQFRE,FILFOR,TIPPAR,CODFOR,UF_FOR,DATOPE,DATCMP,
       DOCUME,ATU_EM,VLRFRE,VLRSEG,ICMFRE,VLRTOT,DESCON,OUTTAX,
       VLRLIQ,OBSERV,NUMITE,FILMAT,CODMAT,CODCOR,CODTAM,QTDMOV,PAUTAF,SUBTRI,
       VLRMOV,COALESCE(VLRBRU,0) AS VLRBRU,VLRPRE,IPIITE,COMPIS,COMCOF,PERSOC,PERSOC_R,CASE WHEN UTILIZA_ICMS_ESPECIFICO = 'T' THEN 0 ELSE PERIVE END AS PERIVE,
       PERCOM,PEROPE,PERIRE,PERIRE_R,PERLUC,REFPRO,VLR_COMPIS,VLR_COMCOF,
       ORDDIV,ORDSUB,DESMAT,ESPMAT,ITEDIV,ITESUB,VLRUNI,
       CODSER,SUBSER,NUMNOT,VMVIPI,PRECOV,TOTCOMFRE, ATUCUS,
       ICMCOM,IPICOM,ICMTIP,ICMTIPDIF,MARGEM,VLRIPI,
       COALESCE(VLRFRE,0) AS FREITE,
       COALESCE((VLRSEG*(VLRTOT/NVLZ(TOTCOMFRE,null))*(VMVIPI/NVLZ(VLRTOT,NULL))),0) AS SEGITE,
       DESITE,
       (OUTTAX*(VMVIPI/NVLZ(VLRTOT,NULL))) AS TAXITE,
       (OUTDES / QTDMOV) AS OUTDESITE,
       ((DESPAR*(VMVIPI/NVLZ(VLRTOT,NULL)))/COM_QTDTOT) AS DESPARITE,
       SUBFED,VLRSUB,SUBITE,CUSREP,VLRCMG,BASE_MARKUP,
       PRECOM_CIPI+SUBITE as PRECOM_CIPI,REGTRI,TIPLUC,TRISIM,MARKUP,PREPSI,REPGRA,
       DEPART, CLASS1, CLASS2, CLASS3, CLASS4, ALIFRE, AFICUS, ICMSRE, RESICM, FATCON, REDITE,
       OUTDES, DESPAR, IPIFRE, MVACOM,
       VLRRET_ITE,
       VLRRET_UNI, ST_FRE, GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM,
       CAST('F' AS CHAR(1)) AS RETSUB, GRA_DATFPV,
       0.00 as PISFRE,
       100-(CASE WHEN SUBFED = 'T' OR REGTRI <> 'N' OR ISEPIS = 'T' THEN 0 ELSE COALESCE(COMPIS,0) END +
            CASE WHEN SUBFED = 'T' OR REGTRI <> 'N' OR ISEPIS = 'T' THEN 0 ELSE COALESCE(COMCOF,0) END +
            /*-- pis da venda --*/            
            CASE WHEN SUBFED = 'T' OR REGTRI <> 'N' OR ISEPIS = 'T' THEN 0 
                 ELSE CASE WHEN PIS_S_ICMS_VEN = 'T' THEN  COALESCE(TAB.VENPIS * (1 - (CASE WHEN UTILIZA_ICMS_ESPECIFICO = 'T' THEN 0 ELSE COALESCE(PERIVE, 0) END + 
                                                                                    CASE WHEN PISCOF_SEMIPISAIDA = 'T' THEN COALESCE(IPIITE, 0) ELSE 0 END) 
                                                                               / 100), 0)
                           WHEN PISCOF_SEMIPISAIDA = 'T' THEN COALESCE(TAB.VENPIS * (1 - (COALESCE(IPIITE, 0) / 100)), 0)
                           ELSE COALESCE(TAB.VENPIS, 0)
                      END
            END +
            /*-- cofins da venda --*/
            CASE WHEN SUBFED = 'T' OR REGTRI <> 'N' OR ISEPIS = 'T' THEN 0 
                 ELSE CASE WHEN PIS_S_ICMS_VEN = 'T' THEN  COALESCE(TAB.VENCOF * (1 - (CASE WHEN UTILIZA_ICMS_ESPECIFICO = 'T' THEN 0 ELSE COALESCE(PERIVE, 0) END + 
                                                                                    CASE WHEN PISCOF_SEMIPISAIDA = 'T' THEN COALESCE(IPIITE, 0) ELSE 0 END) 
                                                                               / 100),0)  
                           WHEN PISCOF_SEMIPISAIDA = 'T' THEN COALESCE(TAB.VENCOF * (1 - (COALESCE(IPIITE, 0) / 100)), 0)
                           ELSE COALESCE(TAB.VENCOF, 0)
                      END
            END +
            CASE WHEN REGTRI = 'N' AND TIPLUC = 'R' THEN COALESCE(PERSOC,0) * PERLUC / 100 ELSE CASE WHEN REGTRI = 'N' THEN COALESCE(PERSOC,0) ELSE 0 END END +
            PERCOM+
            COALESCE(DespesaOperacional('V',FILPRE,CODPRE,CLASS1,CLASS2,CLASS3,CLASS4,DEPART,CODFIL),0)+
            COALESCE(DespesaOperacional('F',FILPRE,CODPRE,CLASS1,CLASS2,CLASS3,CLASS4,DEPART,CODFIL),0)+
            CASE WHEN REGTRI = 'N' AND TIPLUC = 'R' THEN COALESCE(PERIR,0) * PERLUC / 100 
            ELSE CASE WHEN REGTRI = 'N' THEN COALESCE(PERIR,0) ELSE 0 END END +
            COALESCE(
            CASE WHEN RE8020='T' AND MONTAR<>'F'                     -- ICMS com tratamento 80 20
                            THEN (COALESCE(CASE WHEN COALESCE(ICMISE, 'F') = 'T' THEN 0 ELSE RESICM END,0)*(100-COALESCE(PERSRV,0))+COALESCE(RESISS,0)*COALESCE(PERSRV,0))/100
                            ELSE CASE WHEN (SUBTRI = '3') OR (COALESCE(ICMISE, 'F') = 'T')
                                      THEN 0
                                      ELSE CASE WHEN (REGTRI = 'N') OR (REGTRI = 'S' AND (COALESCE(TRISIM,'X') = 'O')) THEN RESICM ELSE 0 END
                                  END
            END * (1-(COALESCE(ICMSRE,0)/100)),0)+PERLUC ) AS PERTOT,
       CASE WHEN SUBFED = 'T' OR REGTRI <> 'N' OR ISEPIS = 'T' THEN 0 
                 ELSE CASE WHEN PIS_S_ICMS_VEN = 'T' THEN  COALESCE(TAB.VENPIS * (1 - (CASE WHEN UTILIZA_ICMS_ESPECIFICO = 'T' THEN 0 ELSE COALESCE(PERIVE, 0) END + 
                                                                                    CASE WHEN PISCOF_SEMIPISAIDA = 'T' THEN COALESCE(IPIITE, 0) ELSE 0 END) 
                                                                               / 100), 0)
                           WHEN PISCOF_SEMIPISAIDA = 'T' THEN COALESCE(TAB.VENPIS * (1 - (COALESCE(IPIITE, 0) / 100)), 0)
                           ELSE COALESCE(TAB.VENPIS, 0)
                      END
       END AS VENPIS,
       CASE WHEN SUBFED = 'T' OR REGTRI <> 'N' OR ISEPIS = 'T' THEN 0 
                 ELSE CASE WHEN PIS_S_ICMS_VEN = 'T' THEN  COALESCE(TAB.VENCOF * (1 - (CASE WHEN UTILIZA_ICMS_ESPECIFICO = 'T' THEN 0 ELSE COALESCE(PERIVE, 0) END + 
                                                                                    CASE WHEN PISCOF_SEMIPISAIDA = 'T' THEN COALESCE(IPIITE, 0) ELSE 0 END) 
                                                                               / 100),0)  
                           WHEN PISCOF_SEMIPISAIDA = 'T' THEN COALESCE(TAB.VENCOF * (1 - (COALESCE(IPIITE, 0) / 100)), 0)
                           ELSE COALESCE(TAB.VENCOF, 0)
                      END
       END AS VENCOF,
       FILPRE,
       CODPRE,
       VAREJO,
       DESPRE,
       CODNCM,
       TIPMPB,
       ORIPRO,
       SUBSTITUTA,
       0.00 as DESESP,
       0.00 as VLRDESESP,
       PEROPEFIX, /* Paulo K. 90072 */
       0.00 as ALIICMAGR,
       0.00 as VLRICMAGR,
       MULTIP,
       ULTELA,
       DIAELA,
       CODMOE,
       TPR_SIGNAT,
       SUBITE AS VALOR_ST_UNI,
       PIS_S_ICMS_VEN, PISCOF_SEMIPISAIDA, FOR060, APRBON, CLAABC, CLAXYZ, NOMCLI, ULTNOM, VLRUNI_ANT, QTDMOV_ANT, NOMCLI_ANT, ULTNOM_ANT, 
       UFLOJA,
       CAST(((((COALESCE(VLRUNI_ANT, 0) - COALESCE(VLRUNI, 0)) / NVLZ(VLRUNI_ANT, NULL)) * 100) * (-1)) AS Numeric(18,4)) AS PERDIF_ULTCOM,
       IUF_PERFCP,
       DICM_RESICM,
       DICM_PERESPINTCOM,
       DICM_PERESPESTCOM,
       DICM_PERESPINTVEN,
       DICM_PERESPESTVEN,
       DICM_COM_RESICM,
       DICM_COM_PERESPINTCOM,
       DICM_COM_PERESPESTCOM,
       DICM_COM_PERESPINTVEN,
       DICM_COM_PERESPESTVEN,
       VLRICMANT, PERICMANT,
       -- MN - Quando houver ICMS Específico deve zerar ICMS, pois a empresa não possui crédito de ICMS
       UTILIZA_ICMS_ESPECIFICO,
       CASE WHEN UTILIZA_ICMS_ESPECIFICO = 'T' THEN 0 ELSE ICMITE END AS ICMITE,
       CASE WHEN UTILIZA_ICMS_ESPECIFICO = 'T' THEN 0 ELSE VLRICM END AS VLRICM,
       CASE WHEN UTILIZA_ICMS_ESPECIFICO = 'T' THEN COALESCE(DICM_PERESPINTVEN, 0) ELSE 0 END AS PERICMESPVEN,
       -- MN - Define % do ICMS Específico
       CASE WHEN UTILIZA_ICMS_ESPECIFICO = 'T' THEN CASE WHEN UF_FOR = UFLOJA THEN COALESCE(DICM_COM_PERESPINTCOM, 0)
                                                                              ELSE COALESCE(DICM_COM_PERESPESTCOM, 0)
                                                                              END
                                               ELSE 0
                                               END AS PERICMESPCOM,
       -- MN - Calcula valor do ICMS Específico
       CASE WHEN UTILIZA_ICMS_ESPECIFICO = 'T' THEN COALESCE(VLRUNI * CASE WHEN UF_FOR = UFLOJA THEN COALESCE(DICM_COM_PERESPINTCOM / 100,0) ELSE COALESCE(DICM_COM_PERESPESTCOM / 100,0) END, 0)
                                               ELSE 0
                                               END AS VLRICMESPCOM
            -- SE eu estou no varejo, é uma transferencia ('     0', a entrada vem do atacado, aplica icms especifico
            -- se eu estou no atacado, interestadual, não pode deduzir o icms (criar parametro por filial se usa icms específico), e tem que somar o icms específico.
FROM (
SELECT (SELECT IND.CODTAB FROM TD_IND IND WHERE IND.CODTAB = 4) AS CODTAB,
       DFIL.CODFIL,
       DFIL.VENPIS, 
       DFIL.VENCOF,
       TO_CHAR(' ') AS SEQUEN,
       TO_CHAR(' ') AS FILFRE,
       TO_CHAR(' ') AS SEQFRE,
       TAB.FILFOR AS FILFOR,
       TAB.CODFOR AS CODFOR,
       TAB.TIPFOR AS TIPPAR,
       TAB.UF_ORI AS UF_FOR,
       TO_CHAR(' ') AS CODSER,
       TO_CHAR(' ') AS SUBSER,
       TO_CHAR(' ') AS NUMNOT,
       TAB.ATU_EM AS DATOPE,
       TAB.ATU_EM AS DATCMP,
       CAST(TAB.FILFOR||'-'||TRIM(TAB.CODFOR)||'-'||TAB.UF_ORI AS VARCHAR(25)) AS DOCUME,
       TAB.ATU_EM AS ATU_EM,
       -- Valor de Frete [COM.VLRFRE]
       COALESCE(TAB.VLRFRE,0) AS VLRFRE,
       -- Valor de Seguro
       -- Não tem valor no preço simulado
       TAB.VLRSEG,
       -- % ICMS para Frete
       -- Por simulação não tem conceito do ICMS de frete separado
       CAST(0 AS Numeric(12,2)) AS ALIFRE,
       -- Valor de ICMS para Frete
       -- Por simulação não tem conceito do ICMS de frete separado
       CAST(0 AS Numeric(12,2)) AS ICMFRE,
       -- Valor Total de ICMS
       COALESCE(TAB.VLRICM,0) AS ICMCOM,
       -- Valor Total de IPI
       COALESCE(TAB.VLRIPI,0) AS IPICOM,
       -- ICMS + IPI (não é usado na FPV)
       -- (COALESCE(TAB.VLRICM,0) + COALESCE(TAB.VLRIPI,0)) AS ICMIPICOM,
       -- Valor dos Produtos com IPI [COM.VLRTOT]
       -- -- MN - Campo "Valor da Compra" na tela de formação de preço de custo (Aba compra) - Não é utilizado no preço simulado
       TAB.PRESIM AS VLRTOT,
       -- Valor Desconto/Acréscimo [COM.DESCON]
       COALESCE(TAB.DESRAT,0) AS DESCON,
       -- MN - Campo desconto na tela de formação de preço de custo (custo de aquisição)
       -- Desconto/Acréscimo já é incorporado ao preço simulado pois ele é aplicado no calculo do IPI e para evitar confusão sobre a base de IPI o mesmo foi ocultado "TT_IFC.DESRAT" mantém o valor calculado
       COALESCE(TAB.DESRAT,0) AS DESITE,
       -- Acréscimo Financeiro [Não tem]
       TAB.AFICUS AS AFICUS,
       -- Outras Taxas [COM.OUTTAX]
       -- Não tem valor no preço simulado
       TAB.OUTTAX,
       TAB.PRESIM AS VLRLIQ,
       TO_CHAR(' ') AS OBSERV,
       -- Valor Total de ST (não é usado na FPV)
       -- Era assim: CAST(0 AS Numeric(12,2)) AS SUBSTT,
       IUF.SUBTRI AS SUBTRI,
       -- Valor de ST
       -- Era assim: CAST(0 AS Numeric(12,2)) AS VLRSUB,
       COALESCE(TAB.VLR_ST,0) AS VLRSUB,
       -- Valor de ST
       COALESCE(TAB.VLR_ST,0) AS SUBITE,
       CAST(0 AS Numeric(5)) AS NUMITE,
       TAB.FILMAT AS FILMAT,
       TAB.CODMAT AS CODMAT,
       TAB.CODCOR AS CODCOR,
       TAB.CODTAM AS CODTAM,
       TAB.ICMTIP AS ICMTIP,
       TAB.ICMTIP AS ICMTIPDIF,
       -- MVA
       COALESCE(TAB.LUCMVA,0) AS MARGEM,
       CAST(1 AS Numeric(12,2)) AS QTDMOV,
       CAST(0 AS Numeric(14,2)) AS PAUTAF, --82777
       TAB.PRESIM AS VLRMOV,
       TAB.PRESIM AS VLRBRU,
       COALESCE(TAB.PRESIM,0) AS VMVIPI,
       TAB.PRESIM_SEM_IPI AS VLRPRE,
       TAB.PRESIM_SEM_IPI AS VLRUNI,
       -- % IPI [ICO.IPIITE]
       COALESCE(TAB.PERIPI,0) AS IPIITE,
       -- Valor do IPI [ICO.VLRIPI]
       COALESCE(TAB.VLRIPI,0) AS VLRIPI,
       -- % ICMS [ICO.ICMITEDIF]
       COALESCE(TAB.PERICM,0) AS ICMITE,
       -- Valor de ICMS [ICO.VLRICMDIF]
       COALESCE(TAB.VLRICM,0) AS VLRICM,
       TAB.ISEPIS,
       DFIL.RE8020,
       TAB.MONTAR,
       IUF.ICMISE,
       IUF.PERSRV,
       COALESCE(NVLZ(CFG.PERIR, NULL), NVLZ(IRR_PRO.RESIRR, NULL), IRR_FIL.RESIRR, 0) as PERIR,
       ISS.RESISS,
       COALESCE(TAB.PRESIM,0) * CASE WHEN TAB.SUBFED = 'T' OR DFIL.REGTRI <> 'N' OR TAB.ISEPIS = 'T' THEN 0 ELSE (DFIL.COMPIS/100) END AS VLR_COMPIS,
       COALESCE(TAB.PRESIM,0) * CASE WHEN TAB.SUBFED = 'T' OR DFIL.REGTRI <> 'N' OR TAB.ISEPIS = 'T' THEN 0 ELSE (DFIL.COMCOF/100) END AS VLR_COMCOF,
       CASE WHEN TAB.SUBFED = 'T' OR DFIL.REGTRI <> 'N' OR TAB.ISEPIS = 'T' THEN 0 ELSE COALESCE(DFIL.COMPIS,0) END AS COMPIS,                                              /* PERCENTUAL DE PIS                 */
       CASE WHEN TAB.SUBFED = 'T' OR DFIL.REGTRI <> 'N' OR TAB.ISEPIS = 'T' THEN 0 ELSE COALESCE(DFIL.COMCOF,0) END AS COMCOF,                                              /* PERCENTUAL DE COFINS              *//* PERCENTUAL DE CONTR. SOCIAL  para apresentacao na tela */
       /* PERCENTUAL DE CONTR. SOCIAL  para apresentacao na tela */
       CASE WHEN DFIL.REGTRI = 'N' THEN COALESCE(DFIL.PERSOC,0) ELSE 0 END AS PERSOC,
       /* PERCENTUAL DE CONTR. SOCIAL  para fins de calculo */
       -- RFMP 85326 NO LUCRO Numeric a formula e CSLL * LUCRO / 100 */
       CASE WHEN DFIL.REGTRI = 'N' AND DFIL.TIPLUC = 'R' THEN COALESCE(DFIL.PERSOC,0) * TAB.PERLUC / 100 ELSE CASE WHEN DFIL.REGTRI = 'N' THEN COALESCE(DFIL.PERSOC,0) ELSE 0 END END AS PERSOC_R,
       CASE WHEN CFG.PERCOM_FPV = 'T' THEN
              CASE WHEN COALESCE(TAB.PERCOM,0) = 0 THEN COALESCE(CFG.PERCOM,0) ELSE COALESCE(TAB.PERCOM,0) END
            ELSE 0
        END AS PERCOM,                                                /* PERCENTUAL DE COMISSAO            */
       COALESCE(DespesaOperacional('V',PRE.FILPRE,PRE.CODPRE,TAB.CLASS1,TAB.CLASS2,TAB.CLASS3,TAB.CLASS4,TAB.DEPART,DFIL.CODFIL),0) AS PEROPE,    /* PERCENTUAL DE DESPESA OPERACIONAL */
       COALESCE(DespesaOperacional('F',PRE.FILPRE,PRE.CODPRE,TAB.CLASS1,TAB.CLASS2,TAB.CLASS3,TAB.CLASS4,TAB.DEPART,DFIL.CODFIL),0) AS PEROPEFIX, /* PERCENTUAL DE DESPESA OPERACIONAL */
       /* IMPOSTO DE RENDA  para apresentacao na tela */
       CASE WHEN (DFIL.REGTRI = 'N' OR LeParametroBoo('CALC_IR_FILSIMPLES', DFIL.CODFIL, '', '', '') = 'T') THEN COALESCE(NVLZ(CFG.PERIR, NULL), NVLZ(IRR_PRO.RESIRR, NULL), IRR_FIL.RESIRR, 0) ELSE 0 END AS PERIRE,
       /* IMPOSTO DE RENDA  para fins de calculo */
       -- RFMP 85326 NO LUCRO Numeric e IR * LUCRO / 100
       CASE WHEN (DFIL.REGTRI = 'N' OR LeParametroBoo('CALC_IR_FILSIMPLES', DFIL.CODFIL, '', '', '') = 'T') AND DFIL.TIPLUC = 'R' THEN COALESCE(NVLZ(CFG.PERIR, NULL), NVLZ(IRR_PRO.RESIRR, NULL), IRR_FIL.RESIRR, 0) * TAB.PERLUC / 100 
       ELSE CASE WHEN (DFIL.REGTRI = 'N' OR LeParametroBoo('CALC_IR_FILSIMPLES', DFIL.CODFIL, '', '', '') = 'T') THEN COALESCE(NVLZ(CFG.PERIR, NULL), NVLZ(IRR_PRO.RESIRR, NULL), IRR_FIL.RESIRR, 0) ELSE 0 END END AS PERIRE_R,
       /* PERCENTUAL DE ICMS NA VENDA */
       COALESCE(
           CASE WHEN DFIL.RE8020='T' AND PRO.MONTAR<>'F' -- ICMS com tratamento 80 20
                           THEN (COALESCE(CASE WHEN COALESCE(IUF.ICMISE, 'F') = 'T' THEN 0 ELSE DICM.RESICM END,0)*(100-COALESCE(IUF.PERSRV,0))+COALESCE(ISS.RESISS,0)*COALESCE(IUF.PERSRV,0))/100
                           -- MN - Tabela ATACADO LOJA se comporta igual varejo na hora da venda, nesse IF é validado IUF.SUBTRI = '3' ou seja, venda de produto substituído
                           -- como está sendo calculado o % de ICMS, o imposto é zerado, pois varejo/atacado loja, declara o ST
                           ELSE CASE WHEN (IUF.SUBTRI = '3' AND ((COALESCE(DFIL.SUBSTITUTA,'F') = 'F') OR TPR.VAREJO in (0, 2, 4))) OR (COALESCE(IUF.ICMISE, 'F') = 'T') OR (((COALESCE(DFIL.SUBSTITUTA,'F') = 'T') AND PRO.FOR060 = 'T'))
                                     THEN 0
                                     ELSE CASE WHEN (DFIL.REGTRI = 'N') OR (DFIL.REGTRI = 'S' AND (COALESCE(DFIL.TRISIM,'X') = 'O')) THEN DICM.RESICM ELSE 0 END
                           END
           END * -- RFMP 87318
                 -- MN - Tabela ATACADO LOJA se comporta igual varejo na hora da venda
                 -- ATACADO LOJA é um conceito da PCIA porque a filial não vende o suficiente pra ser SUBSTITUTA, ter a obrigação de recolher o ST, e portanto pagar imposto só na hora da venda
                 -- Mas esse tipo de filial ainda conta com Regime especial na compra
                 CASE WHEN TPR.VAREJO IN (0,2) OR (TPR.VAREJO = 3 AND IUF.FLGRED = 'E')  OR (((COALESCE(DFIL.SUBSTITUTA,'F') = 'T') AND PRO.FOR060 = 'T'))
                      THEN (1-(COALESCE(IRE.REDCON,0)/100)) -- VAREJO
                      ELSE (1-(COALESCE(IRE.ICMSRE,0)/100)) -- ATACADO
                 END,0) 
                 -- MN - 2020113170 - Case apenas para zerar ICMS se o produto for isento de ICMS na venda
                 * CASE WHEN COALESCE(IUF.ICMISE, 'F') = 'T' THEN 0 ELSE 1 
       END AS PERIVE,
       TAB.PERLUC,
       DIV.ORDDIV AS ORDDIV,
       SUB.ORDSUB AS ORDSUB,
       TAB.DESMAT AS DESMAT,
       TAB.ESPMAT AS ESPMAT,
       TAB.MARKUP,
       TAB.PREPSI,
       DIV.NOMITE AS ITEDIV,
       SUB.NOMITE AS ITESUB,
       SUB.FATCON,
       CASE WHEN COALESCE(IUF.ICMISE, 'F') = 'T' THEN 0 ELSE COALESCE(DICM.RESICM,0) END AS RESICM,
       COALESCE(IRE.ICMSRE,0) AS ICMSRE,
       DFIL.REGTRI,
       DFIL.TIPLUC,
       DFIL.TRISIM,
       TAB.REFPRO AS REFPRO,
       PRE.PRECOV,
       ROUND(TAB.PRESIM + (TAB.PRESIM * TAB.PERFRE / 100),4) AS TOTCOMFRE,
       TAB.CUSREP,
       TAB.SUBFED,
       TAB.CUSREP AS REPGRA,
       COALESCE(CUSTOMEDIO(DFIL.CODFIL, TAB.FILMAT, TAB.CODMAT, TAB.CODCOR, TAB.CODTAM, 5),0) AS VLRCMG,
       CFG.BASE_MARKUP,
       TAB.PRESIM AS PRECOM_CIPI,
       TAB.DEPART, TAB.CLASS1, TAB.CLASS2, TAB.CLASS3, TAB.CLASS4,
       COALESCE(TAB.REDICM,0) AS REDITE,
       CAST(0 AS Numeric(12,2)) AS OUTDES, CAST(0 AS Numeric(12,2)) AS DESPAR, CAST(1 AS Numeric(12,2)) AS COM_QTDTOT,
       TAB.IPIFRE,
       COALESCE(TAB.PERMVA,0) AS MVACOM,
       CAST(0 AS Numeric(12,2)) AS VLRRET_ITE,
       CAST(0 AS Numeric(12,2)) AS VLRRET_UNI,
       CAST(0 AS Numeric(12,2)) AS ST_FRE,
       GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM, GRA_DATFPV, ATUCUS,
       PRE.FILPRE,
       PRE.CODPRE,
       TPR.VAREJO,
       TPR.DESPRE,
       TAB.CODNCM,
       TAB.TIPMPB,
       TAB.ORIPRO,
       DFIL.SUBSTITUTA,
       TAB.DESRAT,
       COALESCE(NVLZ(PRE.MULTIP, TPR.MULTIP), 1) AS MULTIP, -- RFMP 97282 Inclusão das colunas
       PRE.ULTELA,                                          -- de elasticidade e multiplicador
       PRE.DIAELA,
       PRE.CODMOE,
       TPR.SIGNAT AS TPR_SIGNAT,
       TAB.FOR060, CAST(0 AS Numeric(16,2)) AS APRBON, TAB.CLAABC, TAB.CLAXYZ, TAB.NOMCLI, TAB.ULTNOM,
       CAST(NULL AS Numeric(18,4)) AS VLRUNI_ANT, CAST(NULL AS Numeric(18,4)) AS QTDMOV_ANT, 
       CAST(NULL AS VARCHAR(100)) AS NOMCLI_ANT, CAST(NULL AS VARCHAR(100)) AS ULTNOM_ANT,
       TAB.UFLOJA,
       IUF.PERFCP AS IUF_PERFCP,
       DICM.RESICM AS DICM_RESICM,
       DICM.PERESPINTCOM AS DICM_PERESPINTCOM,
       DICM.PERESPESTCOM AS DICM_PERESPESTCOM,
       DICM.PERESPINTVEN AS DICM_PERESPINTVEN,
       DICM.PERESPESTVEN AS DICM_PERESPESTVEN,
       DICM_COM.RESICM AS DICM_COM_RESICM,
       DICM_COM.PERESPINTCOM AS DICM_COM_PERESPINTCOM,
       DICM_COM.PERESPESTCOM AS DICM_COM_PERESPESTCOM,
       DICM_COM.PERESPINTVEN AS DICM_COM_PERESPINTVEN,
       DICM_COM.PERESPESTVEN AS DICM_COM_PERESPESTVEN,
       CAST(0 AS Numeric(12, 2)) AS VLRICMANT, CAST(0 AS Numeric(7, 4)) AS PERICMANT,
       -- MN - Realiza cálculo do ICMS específico. O ICMS específico é um benefício fiscal concedido ao cliente JRA, nele o cliente perde o crédito de ICMS na entrada, além disso, ainda inclui
       -- um % "Extra" de ICMS, ou seja, aumenta o custo da mercadoria, mas por outro lado na saída/venda, ao invés de pagar 17% de ICMS eles pagam só 2.5% (alíquotas variáveis, apenas um exemplo)
       -- Somente produtos TRIBUTADOS e substituídos, que não forcem o CST 060. Somente calcula o ICMS específico se a tabela de preço estiver marcada para calcular o ICMS específico.
       -- Regras para Aplicar ICMS Específico:
       -- 01 - Nas entradas da filial SUBSTITUTA, interestaduais
       -- 02 - Nas entradas da filial SUBSTITUÍDA quando for transferência oriunda da filial SUBSTITUÍDA
       -- MN - Nos cálculos posteriores o sistema estará setado para calcular as entradas estaduais, porém como o benefício é somente para interestadual, o bloqueio é realizado aqui
       -- Setando UTILIZA_ICMS_ESPECIFICO para F nas entradas estaduais, produtos que não sejam tributados ou produtos que forcem 060
       --CASE WHEN ((LeParametroBoo('USA_ICMS_ESPECIFICO',DFIL.CODFIL,'','','') = 'F') OR TAB.FOR060 = 'T') AND (IUF.SUBTRI <> '0' AND IUF.SUBTRI <> '3') OR (COALESCE(TPR.USAICMESP, 'F') <> 'T')
       --     THEN 'F' -- MN - Parâmetro indicando se filial utiliza ICMS Específico
       --     ELSE CASE WHEN (COALESCE(DFIL.SUBSTITUTA, 'F') = 'T') AND (DFIL.UFLOJA <> TEND.SIGEST) THEN 'T' -- MN - Regra 1
       --               --WHEN (COALESCE(DFIL.SUBSTITUTA, 'T') = 'F') AND (COM.CODFOR = '     0') AND (COALESCE(DFIL_FOR.SUBSTITUTA, 'F') = 'T') THEN 'T' -- MN - Regra 2
       --               ELSE 'F'
       --          END
       --END AS UTILIZA_ICMS_ESPECIFICO
       CAST(COALESCE(TPR.USAICMESP, 'F') AS VARCHAR(1)) AS UTILIZA_ICMS_ESPECIFICO,
       LeParametroBoo('PISCOF_SEMIPISAIDA', DFIL.CODFIL, '', '', '') AS PISCOF_SEMIPISAIDA,
       LeParametroBoo('PIS_S_ICMS_VEN', DFIL.CODFIL, '', '', '') AS PIS_S_ICMS_VEN
  FROM ( SELECT FL1.UFLOJA, FL1.REGESP, FL1.CODCID, GRA.PERCOM, GRA.CUSREP, GRA.REFPRO, GRA.PREPSI, GRA.MARKUP, COALESCE(GRA.PERLUC,0) AS PERLUC, PRO.MONTAR, PRO.DESMAT, PRO.ESPMAT, PRO.SUBFED,
                PRO.DEPART, PRO.CLASS1, PRO.CLASS2, PRO.CLASS3, PRO.CLASS4, PRO.ISEPIS,
                GRA.FILCOM AS GRA_FILCOM, GRA.SEQCOM AS GRA_SEQCOM, GRA.ITECOM AS GRA_ITECOM, GRA.DATFPV AS GRA_DATFPV, 
                COALESCE(GRA.GRAABC, CAST(DescricaoDominio('PRO','CLSABC',TO_CHAR(PRO.CLSABC)) AS VARCHAR(1))) AS CLAABC, 
                COALESCE(GRA.GRAXYZ, CAST(DescricaoDominio('PRO','CLSXYZ',TO_CHAR(PRO.CLSXYZ)) AS VARCHAR(1))) AS CLAXYZ,
                CAST('T' AS VARCHAR(1)) AS ATUCUS,
                PRO.CODNCM, PRO.TIPMPB, PRO.ORIPRO,
                -- Dados a ignorar devido ao não uso do mesmo
                --IFO.CODFIL, IFO.SEQUEN, IFO.FILMAT, IFO.CODMAT, IFO.FILFOR, IFO.CODFOR, IFO.FLGSUB,
                --IFO.PERDICM_INT_ORIG, IFO.PERDICM_INT_DEST, IFO.PERDICM_FOR_DEST, IFO.FLGRED_DICM_P_ST,
                --IFO.ORIPRO
                IFO.PERIPI, IFO.PERMVA, IFO.REDICM, IFO.ICMTIP, IFO.UF_ORI,
                -- Dados a ignorar devido ao não uso do mesmo
                --IFC.FILMAT, IFC.CODMAT, IFC.CODCOR, IFC.CODTAM, IFC.FILFOR, IFC.CODFOR, IFC.UF_ORI,
                --IFC.VLRIPIFRE, IFC.FILCMP, IFC.REDICM
                IFC.LUCMVA,
                IFC.BASIPI, IFC.VLRIPI, IFC.BASICM, IFC.PERICM, IFC.VLRICM, IFC.VLRSEG,IFC.BAS_ST, IFC.VLR_ST, IFC.OUTTAX,
                IFC.DESRAT,
                -- Valor do Frete RFMP 101254
                NVLZ(IFC.VLRFRE,
                     CASE WHEN DRGC.FLGENC = 'T'
                          THEN
                              CASE COALESCE(DFRE_ENC.DFRE_TIPCOB,' ')
                                   WHEN 'V' -- Percentual sobre valor
                                   THEN ((COALESCE(PXF.PRESIM,0) * (1 + (COALESCE(PXF.DACSIM,0) / 100))) + COALESCE(IFC.VLRIPI,0)) * COALESCE(DFRE_ENC.DFRE_PERVEN,0) / 100
                                   WHEN 'E' -- Valor por entrega
                                   THEN COALESCE(DFRE_ENC.DFRE_VALENT,0)
                                   WHEN 'P' -- Valor por peso
                                   THEN COALESCE(GRA.PESBRU,0) * COALESCE(DFRE_ENC.DFRE_VALPES,0)
                                   WHEN 'Q' -- Valor por quantidade
                                   THEN COALESCE(DFRE_ENC.DFRE_VALQTD,0)
                              END
                          ELSE
                              CASE COALESCE(DFRE_PAD.DFRE_TIPCOB,' ')
                                   WHEN 'V' -- Percentual sobre valor
                                   THEN ((COALESCE(PXF.PRESIM,0) * (1 + (COALESCE(PXF.DACSIM,0) / 100))) + COALESCE(IFC.VLRIPI,0)) * COALESCE(DFRE_PAD.DFRE_PERVEN,0) / 100
                                   WHEN 'E' -- Valor por entrega
                                   THEN COALESCE(DFRE_PAD.DFRE_VALENT,0)
                                   WHEN 'P' -- Valor por peso
                                   THEN COALESCE(GRA.PESBRU,0) * COALESCE(DFRE_PAD.DFRE_VALPES,0)
                                   WHEN 'Q' -- Valor por quantidade
                                   THEN COALESCE(DFRE_PAD.DFRE_VALQTD,0)
                              END
                     END) AS VLRFRE,
                -- Dados a ignorar devido ao uso do mesmo de origem em outra tabela
                --PXF.PRECOM, PXF.DACCUS, PXF.PERICM, PXF.PERIPI, PXF.IPICUS, PXF.OUTCUS
                --PXF.BASICM, PXF.ORDPED, PXF.ULTBAS, PXF.REPASE, PXF.ORICUS, PXF.ICMTIP,
                --PXF.ICMFRE, PXF.ICMCUS, PXF.MVACOM, PXF.CUSFRE
                PXF.FILMAT, PXF.CODMAT, PXF.CODCOR, PXF.CODTAM, PXF.FILFOR, PXF.CODFOR, PXF.TIPFOR, PXF.DACSIM,
                PXF.AFICUS, PXF.PERFRE, PXF.ATU_EM, PXF.ALIFRE, PXF.IPIFRE, PRO.FOR060,
                -- O preço simulado informado pelo cliente no cadastro deve ser sem o IPI, retiramos o valor do desconto para achar o preço liquido simulado que é utilizado nos calculos de impostos.
                -- Para o calculo do CUSAQS deve-se retirar o IPI, pois o mesmo será somado na tela,e já está somado no campo CUSAQS que é o total do custo de aquisição. O campo CUSAQS é totalizado na view que usa essa TV_FPV_SIM_TOT
                ((COALESCE(PXF.PRESIM,0) * (1 + (COALESCE(PXF.DACSIM,0) / 100))) + COALESCE(IFC.VLRIPI,0)) AS PRESIM,
                (COALESCE(PXF.PRESIM,0) * (1 + (COALESCE(PXF.DACSIM,0) / 100))) AS PRESIM_SEM_IPI, 
                CLI.NOMCLI, CLI.ULTNOM, COALESCE(DFIL_FOR.SUBSTITUTA, 'F') AS DFIL_FOR_SUBSTITUTA
           FROM TT_IFO IFO INNER JOIN TT_IFC IFC ON IFO.FILMAT = IFC.FILMAT
                                                AND IFO.CODMAT = IFC.CODMAT
                                                AND IFO.FILFOR = IFC.FILFOR
                                                AND IFO.CODFOR = IFC.CODFOR
                                                AND IFO.UF_ORI = IFC.UF_ORI
                           INNER JOIN TT_PXF PXF ON IFC.FILMAT = PXF.FILMAT
                                                AND IFC.CODMAT = PXF.CODMAT
                                                AND IFC.CODCOR = PXF.CODCOR
                                                AND IFC.CODTAM = PXF.CODTAM
                                                AND IFC.FILFOR = PXF.FILFOR
                                                AND IFC.CODFOR = PXF.CODFOR
                           INNER JOIN TT_PRO PRO ON IFC.FILMAT = PRO.FILMAT AND IFC.CODMAT = PRO.CODMAT
                           INNER JOIN TD_RGC DRGC ON DRGC.CODTAB = PRO.CODRGC
                           INNER JOIN TT_GRA GRA ON GRA.FILMAT = IFC.FILMAT AND GRA.CODMAT = IFC.CODMAT
                                                AND GRA.CODCOR = IFC.CODCOR AND GRA.CODTAM = IFC.CODTAM
                           LEFT JOIN  TT_COM COM ON GRA.FILCOM = COM.CODFIL
                                                AND GRA.SEQCOM = COM.SEQUEN
                           CROSS JOIN TT_CFG CFG
                           CROSS JOIN TT_IDF IDF
                           INNER JOIN TD_FIL FL1 ON FL1.CODFIL = COALESCE(CFG.FILCMP, IDF.CODLOJ)
                                                AND FL1.CODFIL = COALESCE(CFG.FILCMP, IDF.CODLOJ)              
                           INNER JOIN TT_CLI CLI ON CLI.FILCLI = PXF.FILFOR
                                                AND CLI.CODCLI = PXF.CODFOR
                           INNER JOIN TD_FIL DFIL_FOR ON PXF.FILFOR = DFIL_FOR.CODFIL
                            LEFT JOIN TD_FRE DFRE_PAD ON DFRE_PAD.CODTAB = CLI.CODFRE
                            LEFT JOIN TD_FRE DFRE_ENC ON DFRE_ENC.CODTAB = CLI.CODFRE_ENC
          WHERE PRO.SIGNAT>=0
            AND GRA.GRAATI='T'
          ) TAB  INNER JOIN TT_SUB SUB ON SUB.CODITE = TAB.CODTAM
               INNER JOIN TT_DIV DIV ON DIV.CODITE = TAB.CODCOR
               INNER JOIN TT_IUF IUF ON IUF.FILMAT = TAB.FILMAT AND IUF.CODMAT = TAB.CODMAT AND IUF.ESTADO = TAB.UFLOJA AND IUF.REGESP = TAB.REGESP
               INNER JOIN TD_ICM DICM ON DICM.CODTAB = IUF.RESICM
                LEFT JOIN TD_ICM DICM_COM ON DICM_COM.RESICM = TAB.PERICM
               INNER JOIN TT_PRE PRE ON PRE.FILMAT = TAB.FILMAT AND PRE.CODMAT = TAB.CODMAT AND PRE.CODCOR = TAB.CODCOR AND PRE.CODTAM = TAB.CODTAM
               INNER JOIN TT_TPR TPR ON TPR.CODFIL = PRE.FILPRE AND TPR.CODPRE = PRE.CODPRE
                LEFT JOIN TT_IMU IMU ON IMU.FILMAT = TAB.FILMAT and IMU.CODMAT = TAB.CODMAT and IMU.CODCID = TAB.CODCID
                LEFT JOIN TT_PRO PRO ON PRO.CODMAT = PRE.CODMAT AND PRO.FILMAT = PRE.FILMAT
                LEFT JOIN TD_ISS ISS ON ISS.CODTAB = IMU.RESISS
                LEFT JOIN TD_IRE IRE ON IRE.CODTAB = IUF.REDALI
               CROSS JOIN TT_CFG CFG
               CROSS JOIN TT_IDF IDF
               INNER JOIN TD_FIL DFIL ON DFIL.CODFIL = COALESCE(CFG.FILCMP, IDF.CODLOJ)
               LEFT JOIN TD_IRR IRR_PRO ON IRR_PRO.CODTAB = PRO.RESIRR
               LEFT JOIN TD_IRR IRR_FIL ON IRR_FIL.CODTAB = DFIL.RESIRR
         WHERE TAB.PRESIM <> 0
           -- RFMP 97282
           -- Filtro pela tabela varejo foi removido.
           --AND PRE.FILPRE = CFG.FILPRE
           --AND PRE.CODPRE = CFG.CODPRE
       ) TAB;


/*-- SEQ 2305 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FRE CASCADE;

/*-- SEQ 2306 --*/
CREATE OR REPLACE VIEW TV_FRE AS
select trim(COM.CODSER) ||'/'|| CASE WHEN COM.SUBSER IS NULL THEN ''
                                     ELSE trim(COM.SUBSER)||'-'
                                END || trim(COM.NUMNOT) AS DOCUME,
       COM.SEQUEN, COM.CODFIL, COM.FILFOR, COM.CODFOR, COM.CODSER, COM.NUMNOT, COM.DATOPE,
       COM.FLGEST, COM.ATU_EM, COM.DATCMP, COM.QTDTOT, COM.VLRTOT, COM.NOTESP, COM.OUTTAX,
       COM.DESCON, COM.VLRLIQ, COM.FILUSU, COM.CODUSU, COM.CODMOE, COM.OBSERV, COM.VLTXJU,
       COM.INCOJU, COM.INTPJU, COM.VLTXMU, COM.INTPMU, COM.CONPGT, CFO.CODCFO AS NATURE,
       COM.ESPDOC, COM.SIGNAT, COM.MOEJUR, COM.SEQFAT, COM.FILFRE, COM.SEQFRE, COM.TIPNOT,
       COM.TIPPAR, COM.SEQCAN, COM.SUBSER
  from TT_COM COM LEFT OUTER JOIN TD_CFO CFO ON COM.CODCFO=CFO.CODTAB
 where COM.TIPPAR = 'T'
;


-- Autor: Luciano Chiqueti
-- Cliente(s): Casa Carneiro

-- Finalidade(s):
-- 1) Gerar relatrio de Fretes a Pagar
/*-- SEQ 2307 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FRETE_ORIGEM CASCADE;

/*-- SEQ 2308 --*/
CREATE OR REPLACE VIEW TV_FRETE_ORIGEM AS
SELECT T2.*,
       VEN.FILCLI,
       VEN.CODCLI,
       CAST((VEN.CODSER||'/'||VEN.NUMECF||'-'||TRIM(VEN.NUMNOT)) AS VARCHAR(15)) AS DOCUME,
       VEN.VLRLIQ,
       CAST(CASE CLI.FLGTIP WHEN 0 THEN CLI.NOMCLI || ' ' || CLI.ULTNOM ELSE CLI.NOMCLI || '/' || CLI.ULTNOM END AS VARCHAR(50)) AS NOMCLI,
       CAST(CASE MOT.FLGTIP WHEN 0 THEN MOT.NOMCLI || ' ' || MOT.ULTNOM ELSE MOT.NOMCLI || '/' || MOT.ULTNOM END AS VARCHAR(50)) AS NOMMOT,
       ED1.ENDERE,
       ED1.NUMERO,
       ED1.BAIRRO,
       ED1.NOMCID,
       REG.REGIAO
 FROM (
       SELECT T1.CODFIL,
              T1.SEQUEN,
              T1.FILMOT,
              T1.CODMOT,
              SUM(T1.VLRFRE) AS VLRFRE,
              SUM(T1.VLRFREORI) AS VLRFREORI,
              T1.DATHOR,
              T1.NATFIS,
              T1.FLGEST,
              SUM(T1.PESBRU) AS PESBRU,
              SUM(T1.PESLIQ) AS PESLIQ
            FROM (
                  SELECT IVE.CODFIL,
                         IVE.SEQUEN,
                         IOR.VLRFREORI,
                         IOR.VLRFRE,
                         IVE.VEN_DATHOR AS DATHOR,
                         ROM.FILMOT,
                         ROM.CODMOT,
                         IVE.NATFIS,
                         ROM.FLGEST,
                         (IVE.QTDMOV*GRA.PESBRU) AS PESBRU,
                         (IVE.QTDMOV*GRA.PESLIQ) AS PESLIQ
                    FROM TT_IVE IVE INNER JOIN TT_IOR IOR ON IOR.FILIVE = IVE.CODFIL
                                                         AND IOR.SEQIVE = IVE.SEQUEN
                                                         AND IOR.NUMIVE = IVE.NUMITE
                                    INNER JOIN TT_IRO IRO ON IRO.FILVEN=IVE.CODFIL
                                                         AND IRO.SEQVEN=IVE.SEQUEN
                                    INNER JOIN TT_ROM ROM ON ROM.CODFIL=IRO.CODFIL
                                                         AND ROM.SEQUEN=IRO.SEQUEN
                                    INNER JOIN TT_GRA GRA ON GRA.FILMAT = IVE.FILMAT
                                                         AND GRA.CODMAT = IVE.CODMAT
                                                         AND GRA.CODCOR = IVE.CODCOR
                                                         AND GRA.CODTAM = IVE.CODTAM
                  UNION ALL
                  SELECT REM.CODFIL,
                         REM.SEQUEN,
                         ROUND(IOR.VLRFREORI/IOR.QTDITE*REM.QTDMOV,2) AS VLRFREORI,
                         IOR.VLRFRE,
                         REM.VEN_DATHOR AS DATHOR,
                         ROM.FILMOT,
                         ROM.CODMOT,
                         REM.NATFIS,
                         ROM.FLGEST,
                         (REM.QTDMOV*GRA.PESBRU) AS PESBRU,
                         (REM.QTDMOV*GRA.PESLIQ) AS PESLIQ
                    FROM TT_IVE IVE INNER JOIN TT_IVE REM ON IVE.CODFIL=REM.FILORI
                                                         AND IVE.SEQUEN=REM.NUMORI
                                                         AND IVE.NUMITE=REM.ITEORI
                                    INNER JOIN TT_IOR IOR ON IOR.FILIVE = IVE.CODFIL
                                                         AND IOR.SEQIVE = IVE.SEQUEN
                                                         AND IOR.NUMIVE = IVE.NUMITE
                                    INNER JOIN TT_IRO IRO ON IRO.FILVEN=REM.CODFIL
                                                         AND IRO.SEQVEN=REM.SEQUEN
                                    INNER JOIN TT_ROM ROM ON ROM.CODFIL=IRO.CODFIL
                                                         AND ROM.SEQUEN=IRO.SEQUEN
                                    INNER JOIN TT_GRA GRA ON GRA.FILMAT = IVE.FILMAT
                                                         AND GRA.CODMAT = IVE.CODMAT
                                                         AND GRA.CODCOR = IVE.CODCOR
                                                         AND GRA.CODTAM = IVE.CODTAM
               ) T1
        GROUP BY T1.CODFIL, T1.SEQUEN, T1.DATHOR, T1.FILMOT, T1.CODMOT, T1.NATFIS, T1.FLGEST
     ) T2 INNER JOIN TT_VEN VEN ON VEN.CODFIL = T2.CODFIL
                                  AND VEN.SEQUEN = T2.SEQUEN
          INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI
                               AND CLI.CODCLI = VEN.CODCLI
          INNER JOIN TT_CLI MOT ON MOT.FILCLI = T2.FILMOT
                               AND MOT.CODCLI = T2.CODMOT
          INNER JOIN TT_END ED1 ON ED1.FILCLI = CLI.FILCLI
                               AND ED1.CODCLI = CLI.CODCLI
                               AND ED1.CODFIL = VEN.FILENT
                               AND ED1.NUMEND = VEN.ENDENT
          INNER JOIN TD_REG REG ON REG.CODTAB = ED1.REGIAO
;


/*-- SEQ 2309 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IDA CASCADE;

/*-- SEQ 2310 --*/
CREATE OR REPLACE VIEW TV_IDA AS
SELECT VEI.PLACAS, VEI.FILCLI, VEI.CODCLI, CCC.NUMDOC,
       CCC.CODFIL, CCC.SEQUEN, CCC.DATOPE, VEN.FILMOT,
       VEN.CODMOT
FROM TT_VEI VEI INNER JOIN TT_CCC CCC ON CCC.CODFIL = VEI.FILCCC AND CCC.SEQUEN = VEI.SEQCCC
                INNER JOIN TT_VXP VEN ON VEN.CODFIL = CCC.CODVEN AND VEN.SEQUEN = CCC.SEQVEN
                INNER JOIN TD_CCC DCC ON DCC.CODTAB = CCC.TIPCCC
WHERE VEI.VLRCCC < 0
  AND TRUNC(AGORA()) - TRUNC(CCC.DATOPE) > COALESCE(DCC.DIARET,0)
 ;






/*-- SEQ 2311 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IIN CASCADE;

/*-- SEQ 2312 --*/
CREATE OR REPLACE VIEW TV_IIN AS
SELECT IIN.*,
       CUSTOMEDIO( IIN.CODFIL, IIN.FILMAT, IIN.CODMAT, IIN.CODCOR, IIN.CODTAM, 3, INV.DATENC) AS CUSTO_UNI,
       COALESCE( CONULT, CONQUA, CONTER, CONSEG, CONPRI, 0 ) AS ULTIMA,
       (SELECT SUM(IVE.QTDMOV)
          FROM TT_IVE IVE
         WHERE IVE.CODFIL = IIN.CODFIL
           AND IVE.FILMAT = IIN.FILMAT
           AND IVE.CODMAT = IIN.CODMAT
           AND IVE.CODCOR = IIN.CODCOR
           AND IVE.CODTAM = IIN.CODTAM
           AND IVE.VEN_DATHOR BETWEEN INV.INVANT AND INV.DATCRI
           AND IVE.LANEST = 'S'
           AND IVE.SITMOV = 'N'
           AND IVE.SITKIT IN ('2','3') ) AS QTD_EM_NF
  FROM (SELECT ATU.*,
              (SELECT MAX(ANT.DATCRI)
                 FROM TT_INV ANT
                WHERE ANT.CODFIL = ATU.CODFIL
                  AND ANT.SEQUEN < ATU.SEQUEN) AS INVANT
          FROM TT_INV ATU) INV INNER JOIN TT_IIN IIN ON IIN.CODFIL = INV.CODFIL AND IIN.SEQUEN = INV.SEQUEN;


 /*-- SEQ 2313 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IND CASCADE;

/*-- SEQ 2314 --*/
CREATE OR REPLACE VIEW TV_IND AS
SELECT REL.FILPAR, REL.CODPAR, REL.TIPPAR, CLI.FILCLI, CLI.CODCLI,
       CLI.ATU_EM, CLI.NOMCLI, CLI.ULTNOM, CLI.NUMDOC, CLI.DOCCON,
       CLI.DATNAS, CLI.ESTCIV, CLI.HOMPGE, CLI.FLGTIP, CLI.INSEST,
       CLI.CODSEX, CLI.CATEG1, CLI.CATEG2, CLI.CATEG3, CLI.DATA01,
       CLI.DATA02, CLI.DATA03, CLI.DATOPE, CLI.IMPRIM, CLI.VALOR1,
       CLI.TOTATR, CLI.TOTPAR, CLI.MAIATR, CLI.OBSERV, CLI.FILPLA,
       CLI.CODPLA, CLI.PORPAD, CLI.ULTCOM, CLI.SIGNAT, CLI.CONJUG,
       CLI.NASCON, CLI.SEXCON, CLI.FILVEN, CLI.CODVEN, CLI.DEPART,
       CLI.CLASS1, CLI.CLASS2, CLI.CLASS3, CLI.CLASS4, CLI.CMSIND
  FROM TT_REL REL INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI =  REL.CODPAR
 WHERE REL.TIPPAR =  'I'
  ;
 
 


/*-- SEQ 2315 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IND_CLI CASCADE;

/*-- SEQ 2316 --*/
CREATE OR REPLACE VIEW TV_IND_CLI AS
select filcli, codcli, sum(renego) as renego,
       -- Quitada Pontual
          to_char( sum( case when Quitada_Pontual = 1 then 1          else 0       end ), '99999') || 
          case when sum(case when Quitada_Pontual = 1 then 1 else 0 end) > 0 then
            to_char( min( case when Quitada_Pontual = 1 then ven_dathor else null    end ), ' (mm/yy"a"') || 
            to_char( max( case when Quitada_Pontual = 1 then rec_pagame else null    end ), 'mm/yy)')
          else 
            ''
          end as quit_p, 
       -- Quitada com atrasos
          to_char( sum( case when Quitada_Pontual = 0 and ven_flgest = 'Q' then 1  else 0       end ), '99999') ||
          case when sum(case when Quitada_Pontual = 0 and ven_flgest = 'Q' then 1  else 0 end) > 0 then
            to_char( min( case when Quitada_Pontual = 0 then ven_dathor else null    end ), ' (mm/yy"a"') || 
            to_char( max( case when Quitada_Pontual = 0 then rec_pagame else null    end ), 'mm/yy)')
          else
            ''
          end as quit_a,
       -- Abertas atrasadas sem pagamento
          to_char( sum( case when Sem_Pagto       = 1 then 1          else 0       end ), '99999') || 
          case when sum( case when Sem_Pagto = 1 then 1 else 0 end ) > 0 then
            to_char( min( case when Sem_Pagto       = 1 then rec_datven else null    end ), ' (dd/mm/yy)')
          else
            '' 
          end as aber_s,
       -- Abertas em atraso
          to_char( sum( case when Em_atraso       = 1 then 1          else 0       end ), '99999') || 
          case when sum(case when Em_atraso = 1 then 1 else 0 end) > 0 then
            to_char( max( case when Em_atraso       = 1 then rec_pagame else null    end ), ' (dd/mm/yy)') 
          else
            '' 
          end as aber_a,
       -- Abertas Pontual
          to_char( sum( case when Aberto_Pontual  = 1 then 1          else 0       end ), '99999') as aber_p,
       -- Abertas Futuro
          to_char( sum( case when Aberto_Futuro   = 1 then 1          else 0       end ), '99999') as aber_f,
       -- A Vista
          to_char( sum( case when a_vista       = 'T' then 1          else 0       end ), '99999') as avista,
       -- Maior atraso
          max( maiatr ) as maiatr,
       -- Ultimo atraso
          max( ultatr ) as ultatr,
       -- Media de atrasos
          case when sum( qtdpar ) = 0 then 0 else trunc( sum( totatr ) / sum( qtdpar )) end as medatr
from (select int.*,
             case when a_vista = 'F' and ven_flgest = 'Q' and pag_atraso = 0 then 1 else 0 end as Quitada_Pontual,
             case when a_vista = 'F' and ven_flgest = 'A' and qtd_pagas  = 0 and abe_atraso > 0 then 1 else 0 end as Sem_Pagto,
             case when a_vista = 'F' and ven_flgest = 'A' and qtd_pagas  > 0 and abe_atraso > 0 then 1 else 0 end as Em_atraso,
             case when a_vista = 'F' and ven_flgest = 'A' and qtd_pagas  > 0 and abe_atraso = 0 then 1 else 0 end as Aberto_Pontual,
             case when a_vista = 'F' and ven_flgest = 'A' and qtd_pagas  = 0 and abe_atraso = 0 then 1 else 0 end as Aberto_Futuro,
             case when a_vista = 'F' then qtd_parcelas  else 0 end as qtdpar,
             case when a_vista = 'F' then total_atrasos else 0 end as totatr
      from (select ven.filcli, ven.codcli, 
                   max( coalesce(rec.renego,0) ) as renego,
                   min(ven.flgest) as ven_flgest,
                   min(ven.dathor) as ven_dathor,
                   max(rec.pagame) as rec_pagame,
                   max(rec.datven) as rec_datven,
                   max( case when trunc(rec.pagame) > trunc(rec.datven)
                             then trunc(rec.pagame) - trunc(rec.datven) else 0 end ) as maiatr,
                   sum( case when trunc(rec.pagame) > trunc(rec.datven) 
                             then trunc(rec.pagame) - trunc(rec.datven) else 0 end ) as total_atrasos,
                   max( case when trunc(rec.pagame) > trunc(rec.datven) then rec.pagame else null end ) as ultatr,
                   min( case when rec.datven <= trunc(ven.dathor)
                               or rec.cartao is not null                      then 'T' else 'F' end ) as a_vista,
                   sum( case when  rec.flgest = 'P' or rec.cartao is not null then  1  else  0  end ) as qtd_pagas,
                   sum( case when (rec.flgest = 'P' or rec.cartao is not null)
                              and (trunc(rec.pagame) > trunc(rec.datven))     then  1  else  0  end ) as pag_atraso,
                   sum( case when rec.flgest = 'A' 
                              and rec.cartao is null
                              and trunc(rec.datven) < trunc(agora())          then  1  else  0  end ) as abe_atraso,
                   sum( case when rec.flgest not in ('C','X')                 then  1  else  0  end ) as qtd_parcelas
            from tt_ven ven inner join tt_rec rec on rec.codfil = ven.codfil
              and rec.sequen = ven.sequen
                            left  join tt_cfg cfg on cfg.vc_filcli = ven.filcli and cfg.vc_codcli = ven.codcli
            where ven.flgest <> 'C'
              and cfg.vc_filcli is null
            group by ven.codfil, ven.sequen, ven.filcli, ven.codcli ) int ) ext
group by filcli, codcli
;


/*-- SEQ 2317 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_INT CASCADE;

/*-- SEQ 2318 --*/
CREATE OR REPLACE VIEW TV_INT AS
select cli.numdoc, int.csenha, con.numcon, coalesce(con.nomtra,con.contat) as contat, cli.filcli, cli.codcli, cli.nomcli
from tt_cli cli LEFT JOIN tt_con con ON con.filcli = cli.filcli and con.codcli = cli.codcli
                LEFT JOIN tt_int int ON int.filcli = con.filcli
                                    and int.codcli = con.codcli
                                    and int.numcon = con.numcon
 ;





/*-- SEQ 2319 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IPR CASCADE;

/*-- SEQ 2320 --*/
CREATE OR REPLACE VIEW TV_IPR AS
SELECT GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM,
       GRA.REFPRO, GRA.MINQTD, GRA.PTOQTD, GRA.QTDREP,
       GRA.PESLIQ, GRA.PESBRU, GRA.PROMOC, GRA.PRECOM,
       GRA.DATCOM, GRA.CUSREP, GRA.DESMAX, GRA.DESIDE,
       GRA.PERLUC, GRA.PERCOM, GRA.TEMREP, GRA.LOCALI,
       GRA.UNIEMB, GRA.UNIAPL, GRA.QTDEMB, GRA.CONAPL,
       GRA.UNIDAD, GRA.UNIFOR, GRA.VALCON, GRA.SEQUEN,
       GRA.CUSFRE, GRA.QTDCOM, GRA.FORLIN, DIV.CODDIV, DIV.ORDDIV,
       GRA.SEQCOM, GRA.FILCOM, GRA.ITECOM, GRA.ICMCOM, GRA.IPICOM,
       GRA.ORICUS, GRA.IPICUS, GRA.ICMCUS, GRA.OUTCUS, GRA.CODFIS,
       GRA.ATU_EM AS ATUGRA, GRA.DACCUS, GRA.AFICUS, GRA.ICMTIP,
       SUB.CODSUB, SUB.FATCON, SUB.ORDSUB,DDIV.NOMDIV,
       DSUB.NOMSUB,PRO.TIPPRO, PRO.ETIQUE, PRO.CODTRI, PRO.TIPDOC,
       DSUB.CODSAL, GRA.CODEXT, GRA.QTDMUL,PRO.TIPMPB,
       CAST(CASE WHEN PRO.SIGNAT < 0 THEN 'F' ELSE GRA.GRAATI END AS CHAR(1)) AS GRAATI,
       DIV.NOMEXT AS ITEDIV,
       SUB.NOMEXT AS ITESUB,
       PRO.CODNCM,
       NCM.NOMNCM,
       COALESCE(PRO.OBSERV ,'')||CASE WHEN GRA.OBSERV IS NOT NULL THEN CHR(13)||CHR(10)||COALESCE(GRA.OBSERV,'')
                                      ELSE ''
                                 END AS OBSERV,
       PRO.ATU_EM, PRO.DESMAT, PRO.ESPMAT, PRO.FILMAR,
       PRO.CODMAR, PRO.DECIMA, PRO.BALSIM, PRO.RESIPI, PRO.RESIRR,
       PRO.NUMITE, PRO.CODSAZ, PRO.CLSXYZ, PRO.CLASS1,
       PRO.CLASS2, PRO.CLASS3, PRO.CLASS4, PRO.CODGRA,
       PRO.DATCAD, PRO.DEPART, PRO.NUMEXT, CASE WHEN PRO.SIGNAT < 0
                                                THEN PRO.SIGNAT
                                                ELSE CASE WHEN GRA.GRAATI = 'T'
                                                          THEN PRO.SIGNAT
                                                          ELSE PRO.SIGNAT * -1
                                                      END
                                             END AS SIGNAT,
       PRO.DESECF, PRO.REFBAS, PRO.MONTAR, PRO.BRINDE,
       PRO.NOMIMG, PRO.TIPMAR, PRO.CONTRA, PRO.CONTRO,
       PRO.ITEMAR, PRO.RETCOF, PRO.PERSER, PRO.SUGSER,
       PRO.CODLPC, PRO.FILCLA, PRO.SEQCLA, PRO.TERASS,PRO.FLGSER, PRO.ISEPIS,
       CAST((SELECT MED1.UNIMED
               FROM TD_MED MED1
              WHERE GRA.UNIDAD = MED1.CODTAB
            ) AS VARCHAR(2)) AS MEDUNI,
       CAST((SELECT MED2.UNIMED
               FROM TD_MED MED2
              WHERE GRA.UNIFOR = MED2.CODTAB
            ) AS VARCHAR(2)) AS MEDFOR,
       CAST((SELECT MED3.UNIMED
               FROM TD_MED MED3
              WHERE GRA.UNIEMB = MED3.CODTAB
            ) AS VARCHAR(2)) AS MEDEMB,
       CAST((SELECT MED4.UNIMED
               FROM TD_MED MED4
              WHERE GRA.UNIAPL = MED4.CODTAB
            ) AS VARCHAR(2)) AS MEDAPL,
       CAST((SELECT COALESCE(MED5.DESMED, MED5.UNIMED)
               FROM TD_MED MED5
              WHERE GRA.UNIDAD = MED5.CODTAB
            ) AS VARCHAR(20)) AS DESMEDUNI,
       CAST((SELECT COALESCE(MED6.DESMED, MED6.UNIMED)
               FROM TD_MED MED6
              WHERE GRA.UNIFOR = MED6.CODTAB
            ) AS VARCHAR(20)) AS DESMEDFOR,
       CAST((SELECT COALESCE(MED7.DESMED, MED7.UNIMED)
               FROM TD_MED MED7
              WHERE GRA.UNIEMB = MED7.CODTAB
            ) AS VARCHAR(20)) AS DESMEDEMB,
       CAST((SELECT COALESCE(MED8.DESMED, MED8.UNIMED)
               FROM TD_MED MED8
              WHERE GRA.UNIAPL = MED8.CODTAB
            ) AS VARCHAR(20)) AS DESMEDAPL,
       CAST(NomeProduto(PRO.DESECF, PRO.DESMAT, GRA.CODCOR, DIV.NOMITE, GRA.CODTAM, SUB.NOMITE, PRO.ESPMAT, GRA.DESGRA, DIV.NOMEXT, SUB.NOMEXT) AS VARCHAR(254)) AS NOMPRO,
       (SELECT PRE.PRECOV
          FROM TT_PRE PRE
          WHERE PRE.FILMAT = GRA.FILMAT
            AND PRE.CODMAT = GRA.CODMAT
            AND PRE.CODCOR = GRA.CODCOR
            AND PRE.CODTAM = GRA.CODTAM
            AND (PRE.FILPRE,PRE.CODPRE) = (SELECT FILPRE,CODPRE FROM TT_CFG)) AS PRECOV,
       GRA.PREPSI, PRO.CODCTR, GRA.VOLUME, PRO.VALEST, PRO.ARRTRU, PRO.IIPTPR, PRO.COD_EX, PRO.CODANP,
       PRO.SITCOF, PRO.SITPIS, PRO.SITIPI, PRO.IMPKIT, PRO.CODSRV, PRO.CODFPS, PRO.ORIPRO, MAR.DESMAR as MARCA, GRA.PREFIS,
       PRO.CODUID AS PRO_CODUID,
       PRO.ASSINA AS PRO_ASSINA,
       GRA.CODUID AS GRA_CODUID,
       GRA.ASSINA AS GRA_ASSINA,
       PRO.VLRPIS,
       PRO.VLRCOF,
       PRO.ICMFED,
       PRO.NATBCC,
       PRO.VENPIS,
       PRO.VENCOF,
       GRA.VALIDA,
       GRA.TIPVAL,
       PRO.OBSMPB,
       PRO.CODRGC,
       PRO.DESFRE,
       PRO.SUBFRE,
       GRA.OBSERV AS OBSGRA,
       PRO.USALOT,
       GRA.PERIND,
       GRA.USABON,
       GRA.QTDBON,
       GRA.FILRES,
       PRO.SITPISCOM,
       PRO.SITCOFCOM,
       PRO.CLSABC,
       GRA.GRAABC,
       GRA.GRAXYZ,
       PRO.CODNIV,
       GRA.ENVECO,
       GRA.SKYHUB,
       PRO.LOTONL,
       GRA.MVACOM,
       GRA.BALTAR,
       PRO.CODIMG,
       GRA.IMGGRU,
       PRO.OBIMEI,
       PRO.CONFER,
       PRO.SUBFED,
       PRO.ESTCHE,
       PRO.CODCES, PRO.CODENQ, PRO.VENPISIMP, PRO.VENCOFIMP, PRO.PER_II,
       PRO.FOR060,
       DIPI.RESIPI AS PERIPI, DIRR.RESIRR AS PERIRR,
       GRA.MAXPAR,
       GRA.DESGRA,
       GRA.CODPOS_GRA,
       PRO.PROCON,
       PRO.DESWEB, GRA.SUGHED, GRA.GERSUG, GRA.FLGREP,
       PRO.DESDET
  FROM TT_PRO PRO
 INNER JOIN TT_GRA GRA  ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
 INNER JOIN TT_DIV DIV  ON GRA.CODCOR = DIV.CODITE
 INNER JOIN TD_DIV DDIV ON DIV.CODDIV = DDIV.CODTAB
 INNER JOIN TT_SUB SUB  ON GRA.CODTAM = SUB.CODITE
 INNER JOIN TD_SUB DSUB ON SUB.CODSUB = DSUB.CODTAB
  LEFT JOIN TT_NCM NCM  ON NCM.CODNCM = PRO.CODNCM
  LEFT JOIN TT_MAR MAR  ON PRO.ITEMAR = MAR.ITEMAR
                       AND PRO.FILMAR = MAR.FILMAR
                       AND PRO.CODMAR = MAR.CODMAR
  LEFT JOIN TD_IPI DIPI ON DIPI.CODTAB = PRO.RESIPI
  LEFT JOIN TD_IRR DIRR ON DIRR.CODTAB = PRO.RESIRR
 ;


/*-- SEQ 2321 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IPR_FAST CASCADE;

/*-- SEQ 2322 --*/
CREATE OR REPLACE VIEW TV_IPR_FAST AS
SELECT GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM,
       GRA.REFPRO, GRA.MINQTD, GRA.PTOQTD, GRA.QTDREP,
       GRA.PESLIQ, GRA.PESBRU, GRA.PROMOC, GRA.PRECOM,
       GRA.DATCOM, GRA.CUSREP, GRA.DESMAX, GRA.DESIDE,
       GRA.PERLUC, GRA.PERCOM, GRA.TEMREP, GRA.LOCALI,
       GRA.UNIEMB, GRA.UNIAPL, GRA.QTDEMB, GRA.CONAPL,
       GRA.UNIDAD, GRA.UNIFOR, GRA.VALCON, GRA.SEQUEN,
       GRA.CUSFRE, GRA.QTDCOM, GRA.FORLIN, DIV.CODDIV, DIV.ORDDIV,
       GRA.SEQCOM, GRA.FILCOM, GRA.ITECOM, GRA.ICMCOM, GRA.IPICOM,
       GRA.ORICUS, GRA.IPICUS, GRA.ICMCUS, GRA.OUTCUS, GRA.CODFIS,
       GRA.ATU_EM AS ATUGRA, GRA.DACCUS, GRA.AFICUS, GRA.ICMTIP,
       SUB.CODSUB, SUB.FATCON, SUB.ORDSUB, PRO.TIPMPB,
       DSUB.NOMSUB,PRO.TIPPRO, PRO.ETIQUE, PRO.CODTRI, PRO.TIPDOC,
       DSUB.CODSAL, GRA.CODEXT, GRA.QTDMUL,
       DIV.NOMEXT AS ITEDIV,
       SUB.NOMEXT AS ITESUB,
       PRO.CODNCM,      
       cast(substr(COALESCE(PRO.OBSERV ,'')||CASE WHEN GRA.OBSERV IS NOT NULL THEN CHR(13)||CHR(10)||COALESCE(GRA.OBSERV,'')
                                      ELSE ''
                                 END,1,4000) as VARCHAR(4000)) AS OBSERV,
       PRO.ATU_EM, PRO.DESMAT, PRO.ESPMAT, PRO.FILMAR,
       PRO.CODMAR, PRO.DECIMA, PRO.BALSIM, PRO.RESIPI, PRO.RESIRR,
       PRO.NUMITE, PRO.CODSAZ, PRO.CLSXYZ, PRO.CLASS1,
       PRO.CLASS2, PRO.CLASS3, PRO.CLASS4, PRO.CODGRA,
       PRO.DATCAD, PRO.DEPART, PRO.NUMEXT, CASE WHEN PRO.SIGNAT < 0
                                                THEN PRO.SIGNAT
                                                ELSE CASE WHEN GRA.GRAATI = 'T'
                                                          THEN PRO.SIGNAT
                                                          ELSE PRO.SIGNAT * -1
                                                      END
                                             END AS SIGNAT,
       PRO.DESECF, PRO.REFBAS, PRO.MONTAR, PRO.BRINDE,
       PRO.NOMIMG, PRO.TIPMAR, PRO.CONTRA, PRO.CONTRO,
       PRO.ITEMAR, PRO.RETCOF, PRO.PERSER, PRO.SUGSER,
       PRO.CODLPC, PRO.FILCLA, PRO.SEQCLA, PRO.TERASS,PRO.FLGSER, PRO.ISEPIS,
       CAST(MED1.UNIMED AS VARCHAR(2)) AS MEDUNI,
       CAST(NomeProduto(PRO.DESECF, PRO.DESMAT, GRA.CODCOR, DIV.NOMITE, GRA.CODTAM, SUB.NOMITE, PRO.ESPMAT, GRA.DESGRA, DIV.NOMEXT, SUB.NOMEXT) AS VARCHAR(254)) AS NOMPRO,
       GRA.PREPSI, PRO.CODCTR, GRA.VOLUME, PRO.VALEST, PRO.ARRTRU, PRO.IIPTPR, PRO.COD_EX, PRO.CODANP,
       PRO.SITCOF, PRO.SITPIS, PRO.SITIPI, PRO.IMPKIT, PRO.CODSRV, PRO.CODFPS, PRO.ORIPRO, GRA.PREFIS,
       PRO.CODUID AS PRO_CODUID,
       PRO.ASSINA AS PRO_ASSINA,
       GRA.CODUID AS GRA_CODUID,
       GRA.ASSINA AS GRA_ASSINA,
       PRO.VLRPIS,
       PRO.VLRCOF,
       PRO.ICMFED,
       PRO.NATBCC, DDIV.NOMDIV,
       PRO.VENPIS,
       PRO.VENCOF,
       PRO.OBSMPB,
       PRO.CODRGC,
       PRO.DESFRE,
       PRO.SUBFRE,
       PRO.USALOT,
       GRA.PERIND,
       GRA.USABON,
       GRA.QTDBON,
       GRA.FILRES,
       PRO.SITPISCOM,
       PRO.SITCOFCOM,
       PRO.CLSABC,
       GRA.GRAABC,
       GRA.GRAXYZ,
       PRO.CODNIV,
       GRA.ENVECO,
       GRA.SKYHUB,
       PRO.LOTONL,
       GRA.BALTAR,
       PRO.CODIMG,
       GRA.IMGGRU,
       PRO.OBIMEI,
       PRO.CONFER,
       PRO.SUBFED,
       PRO.ESTCHE,
       PRO.CODCES, PRO.CODENQ, PRO.VENPISIMP, PRO.VENCOFIMP, PRO.PER_II,
       PRO.FOR060,
       GRA.MAXPAR,
       GRA.DESGRA,
       GRA.CODPOS_GRA,
       PRO.PROCON, GRA.SUGHED, GRA.GERSUG, GRA.FLGREP,
       PRO.DESDET,
       PRO.FILFAT
  FROM TT_GRA GRA INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT
                                       AND PRO.CODMAT = GRA.CODMAT
                  INNER JOIN TT_DIV DIV ON GRA.CODCOR = DIV.CODITE
                  INNER JOIN TD_DIV DDIV ON DIV.CODDIV = DDIV.CODTAB
                  INNER JOIN TT_SUB SUB ON GRA.CODTAM = SUB.CODITE
                  INNER JOIN TD_SUB DSUB ON SUB.CODSUB = DSUB.CODTAB
                  INNER JOIN TD_MED MED1 ON MED1.CODTAB = GRA.UNIDAD
;


/*-- SEQ 2323 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IVE_FIS CASCADE;

/*-- SEQ 2324 --*/
CREATE OR REPLACE VIEW TV_IVE_FIS AS
   SELECT /*+RULE*/ * FROM (
      SELECT VEN.CODFIL, IVE.SEQUEN, VEN.NUMNOT, VEN.CODSER,VEN.FILCLI, VEN.CODCLI, COALESCE(VEN.FILENT,IVE.CODFIL) AS FILENT, COALESCE(VEN.ENDENT,1) AS ENDENT,
             (SELECT COUNT(*) AS NUM        /* SELECT PARA RENUMERAR OS ITENS */
                FROM TT_IVE I
               WHERE (I.CODFIL  = IVE.CODFIL)
                 AND (I.SEQUEN  = IVE.SEQUEN)
                 AND (I.NUMITE <= IVE.NUMITE)
                 AND (I.SITKIT IN ('2',IIF_Char_Char(I.IMPKIT,'T','3','1')))
                 AND (I.QTDMOV <> 0) -- RFMP 70845 alteracao de tipo de entrega pode zerar a quantidade de uma ive
             ) AS NUMITE,
             IVE.CODCOR, IVE.CODMAT, IVE.CODTAM, ABS(IVE.VLRMOV) AS VLRMOV,
             CASE WHEN (IVE.REDITE IS NULL) OR ((VEN.VLRLIQ = 0) OR (VEN.VLRNOT = 0)) THEN 0
                                                                                      ELSE ABS(ROUND((((IVE.VLRMOV * (VEN.VLRLIQ - COALESCE(VEN.VLRFRE,0))) /  VEN.VLRNOT) * (IVE.REDITE / 100)),2))
              END AS REDVLR,
             CASE WHEN (IVE.REDITE IS NULL) OR ((VEN.VLRLIQ = 0) OR (VEN.VLRNOT = 0)) /*OR (SUBSTR(TRIM(IVE.NATFIS),1,4) IN ('5415','6415','5904','6904'))*/ -- RFMP 73474
                  THEN 0
                  WHEN VEN.CODSER = 'CF' THEN ABS(Rateio_ValorLiquido(IVE.CODFIL,IVE.SEQUEN,IVE.NUMITE))
                                         ELSE IVE.VLRMOV + COALESCE(IVE.DESRAT, 0)
              END AS ITELIQ,
             IVE.TIPPRO, ABS(IVE.QTDMOV) AS QTDMOV, IVE.LANEST, IVE.FILMAT, IVE.SITKIT, IVE.SITMOV, IVE.FILORI, IVE.NUMORI, IVE.ITEORI, IVE.VEN_DATHOR, VEN.DATHOR,
             IVE.REDITE, IVE.DUMMY ,
             CASE WHEN VEN.TRIBUT = 'F'
                  THEN '1'
                  ELSE CASE WHEN IVE.ICMTIP IN ('1','2','4')
                            THEN '1'
                            ELSE IVE.ICMTIP
                        END
              END AS ICMTIP, IVE.NUMEXT, IVE.EMBORI, IVE.EMBQTD, CASE WHEN VEN.TRIBUT = 'T'
                                                                      THEN CASE WHEN IVE.ICMTIP <> '0' THEN 0 ELSE ABS(IVE.TAX001) END
                                                                      ELSE 0
                                                                  END AS TAX001,
             ABS(IVE.TAX002) AS TAX002,
             IVE.TIP001,
             ABS(CASE WHEN VEN.TRIBUT = 'T' THEN COALESCE(IVE.VLR001,0) ELSE 0 END) AS VLR001,
             ABS(IVE.VLR002) AS VLR002, ABS(IVE.COMISS) AS COMISS, IVE.VINCUL, IVE.EXPORT,
             SUBSTR(NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, COALESCE(IVE.NATFIS,NAT.NATDEN), COALESCE(IVE.NATFIS,NAT.NATFOR)),1,4) AS NATFIS, IVE.CALSUB,
             /*CASE WHEN (IVE.ICMTIP = '0' AND VEN.TRIBUT <> 'F')  AND ((VEN.VLRLIQ <> 0) AND (VEN.VLRNOT <> 0))
                  THEN COALESCE(IVE.BASICM,ABS( Rateio_ValorLiquido(IVE.CODFIL,IVE.SEQUEN,IVE.NUMITE) - COALESCE(IVE.VLR002,0) - (Rateio_ValorLiquido(IVE.CODFIL,IVE.SEQUEN,IVE.NUMITE) * COALESCE(IVE.REDITE,0) / 100)))
                  ELSE 0
              END*/
              ABS(IVE.BASICM) AS BASICM,
             -- RFMP 70199 Alterao temporria enquanto os campos outras e isento no so materializadas na TT_IVE
             -- Valor lquido = Base + Isento + Outras
             -- Valor lquido = clculo de ITELIQ + clculo de VLRFRE + clculo de VLRSEG + clculo de OUTTAX
             -- IVE.ITELIQ + COALESCE(IVE.VLRFRE,0) + COALESCE(IVE.VLRSEG,0) + COALESCE(IVE.OUTTAX,0) 
             (CASE WHEN (IVE.REDITE IS NULL) OR ((VEN.VLRLIQ = 0) OR (VEN.VLRNOT = 0)) /*OR (SUBSTR(TRIM(IVE.NATFIS),1,4) IN ('5415','6415','5904','6904'))*/ -- RFMP 73474
                  THEN 0
                  WHEN VEN.CODSER = 'CF' THEN ABS(Rateio_ValorLiquido(IVE.CODFIL,IVE.SEQUEN,IVE.NUMITE))
                                         ELSE CASE WHEN VEN.VLRLIQ > 0 THEN IVE.VLRMOV + COALESCE(IVE.DESRAT, 0) ELSE IVE.VLRMOV + COALESCE(IVE.DESRAT, 0) 
                                         END
              END + -- ITELIQ 
              CASE VEN.VLRNOT WHEN 0 THEN 0
					       ELSE COALESCE((VEN.VLRFRE / VEN.VLRNOT) * IVE.VLRMOV,0)
                      END + -- VLRFRE
                      CASE VEN.VLRNOT WHEN 0 THEN 0
					       ELSE COALESCE((VEN.VLRSEG / VEN.VLRNOT) * IVE.VLRMOV,0)
                      END  + -- VLRSEG
                      CASE VEN.VLRNOT WHEN 0 THEN 0
					       ELSE COALESCE(ABS((VEN.OUTTAX / VEN.VLRNOT) * IVE.VLRMOV),0)
                      END) -- OUTTAX
              /* - (CASE WHEN (IVE.ICMTIP = '0' AND VEN.TRIBUT <> 'F')  AND ((VEN.VLRLIQ <> 0) AND (VEN.VLRNOT <> 0))
                     THEN COALESCE(IVE.BASICM,ABS( Rateio_ValorLiquido(IVE.CODFIL,IVE.SEQUEN,IVE.NUMITE) - COALESCE(IVE.VLR002,0) - (Rateio_ValorLiquido(IVE.CODFIL,IVE.SEQUEN,IVE.NUMITE) * COALESCE(IVE.REDITE,0) / 100)))
                     ELSE 0
                END) */ -- no utilizado
              - ABS(IVE.BASICM) -- BASICM
              - CASE WHEN ((IVE.ICMTIP IN ('1','2','4')) AND 
                           /*(SUBSTR(NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, COALESCE(IVE.NATFIS,NAT.NATDEN), COALESCE(IVE.NATFIS,NAT.NATFOR)),1,4) NOT IN ('5929','6929')) AND */ -- RFMP 73474
                           (TRA.SEQIVE IS NULL OR IVE.TAX001 <> 0) -- RFMP 70203 transferencia com aliquota 0 vai no campo outras
                          ) 
                       OR (COALESCE(IVE.REDITE,0) <> 0)
                     THEN ABS(ROUND(NVLZ(ABS(Rateio_ValorLiquido(IVE.CODFIL,IVE.SEQUEN,IVE.NUMITE)) - ABS(IVE.BASICM), ABS(Rateio_ValorLiquido(IVE.CODFIL,IVE.SEQUEN,IVE.NUMITE)) * CASE WHEN IVE.REDITE <> 0 THEN COALESCE(IVE.REDITE,0) ELSE 100 END/ 100)  ,3))
                     ELSE 0
                END -- ISEICM ou BASINT
             AS OUTRAS,  
             CASE WHEN ((IVE.ICMTIP IN ('1','2','4')) AND 
                        /*(SUBSTR(NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, COALESCE(IVE.NATFIS,NAT.NATDEN), COALESCE(IVE.NATFIS,NAT.NATFOR)),1,4) NOT IN ('5929','6929')) AND */ -- RFMP 73474
                        (TRA.SEQIVE IS NULL OR IVE.TAX001 <> 0) -- RFMP 70203 transferencia com aliquota 0 vai no campo outras
                       ) 
                    OR (COALESCE(IVE.REDITE,0) <> 0)
                  THEN ABS(ROUND(NVLZ(ABS(Rateio_ValorLiquido(IVE.CODFIL,IVE.SEQUEN,IVE.NUMITE)) - ABS(IVE.BASICM), ABS(Rateio_ValorLiquido(IVE.CODFIL,IVE.SEQUEN,IVE.NUMITE)) * CASE WHEN IVE.REDITE <> 0 THEN COALESCE(IVE.REDITE,0) ELSE 100 END/ 100)  ,3))
                  ELSE 0
             END AS BASINT,
             CASE WHEN IVE.CODCST IS NOT NULL THEN IVE.CODCST ELSE
             '0' ||
             CASE IVE.TIPPRO WHEN '1' 
                       THEN '90' 
                       ELSE                   /* SERVICO */
                       CASE IVE.TIPPRO WHEN '2' 
                                       THEN '90' 
                                       ELSE                  /* TERCEIRIZADO */
                                       CASE IVE.ICMTIP WHEN '3'
                                                       THEN                         /* PRODUTO COM SUBSTITUICAO, REDUZIDO OU NAO */
                                                       CASE IVE.REDITE WHEN 0
                                                                       THEN
                                                                       CASE COALESCE(IVE.CALSUB,'D') WHEN 'D' 
                                                                                                     THEN '60'
                                                                                                     WHEN 'R' 
                                                                                                     THEN '10'
                                                                                                     ELSE '60'
                                                                        END
                                                                       ELSE '70'
                                                        END
                                                       ELSE CASE IVE.ICMTIP WHEN  '1'
                                                                            THEN '41' 
                                                                            ELSE            /* PRODUTO NAO TRIBUTADO */
                                                                            CASE IVE.ICMTIP WHEN '2' 
                                                                                            THEN '40' 
                                                                                            ELSE           /* PRODUTO ISENTO */
                                                                                            CASE IVE.ICMTIP WHEN '4' 
                                                                                                            THEN '40'
                                                                                                            ELSE       /* PRODUTO ISENTO NO ESTADO */
                                                                                                            CASE IVE.REDITE WHEN 0 
                                                                                                                            THEN '00'           /* PRODUTO REDUZIDO OU TRIBUTADO INTEGRALMENTE */
                                                                                                                            ELSE '20'
                                                                                                             END
                                                                                             END
                                                                             END
                                                             END
                                           END
                        END
             END
             END AS CODCST, VEN.UFNOTA,
            CASE VEN.VLRNOT WHEN 0 THEN 0
					       ELSE (VEN.VLRFRE / VEN.VLRNOT) * IVE.VLRMOV 
			END AS VLRFRE,
            CASE VEN.VLRNOT WHEN 0 THEN 0
					       ELSE (VEN.VLRSEG / VEN.VLRNOT) * IVE.VLRMOV 
		    END AS VLRSEG,
            CASE VEN.VLRNOT WHEN 0 THEN 0
					       ELSE ABS((VEN.OUTTAX / VEN.VLRNOT) * IVE.VLRMOV) 
			END AS OUTTAX,
            CASE VEN.VLRNOT WHEN 0 THEN 0
			     ELSE round((VEN.VLRFRE * CASE WHEN VEN.UFLOJA = 'T'
                                     THEN COALESCE(FIL.FRDENT,0)
                                     ELSE CASE WHEN CLI.FLGTIP = '0'
                                               THEN COALESCE(FIL.FRNAOC,0)
                                               ELSE COALESCE(FIL.FRCONT,0)
                                          END
                                END / 100 / VEN.VLRNOT) * IVE.VLRMOV,4) 
			END AS ICMFRE,
            CASE VEN.VLRNOT WHEN 0 THEN 0
				 ELSE round((VEN.VLRSEG * CASE WHEN VEN.UFLOJA = 'T'
                                     THEN COALESCE(FIL.FRDENT,0)
                                     ELSE CASE WHEN CLI.FLGTIP = '0'
                                               THEN COALESCE(FIL.FRNAOC,0)
                                               ELSE COALESCE(FIL.FRCONT,0)
                                           END
                                END / 100 / VEN.VLRNOT) * IVE.VLRMOV,4) 
			END AS ICMSEG,
            CASE VEN.VLRNOT WHEN 0 THEN 0
			     ELSE ABS(round((VEN.OUTTAX * COALESCE(IVE.TAX001,0) / 100 / VEN.VLRNOT) * IVE.VLRMOV,4)) 
			END AS ICMTAX,
            IVE.CODMOT, 
            IVE.CODCNC, VEN.SATSER, VEN.SATCFE
      FROM TW_VEN_FIS VEN INNER JOIN TT_IVE IVE ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
                          INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                          INNER JOIN TD_FIL FIL ON FIL.CODFIL = VEN.CODFIL
                          INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
                          LEFT  JOIN TT_TRA TRA ON TRA.FILIVE = IVE.CODFIL AND TRA.SEQIVE = IVE.SEQUEN AND TRA.NUMIVE = IVE.NUMITE
      WHERE IVE.SITKIT IN ('2','3')
        AND IVE.QTDMOV <> 0 -- RFMP 70845 alteracao de tipo de entrega pode zerar a quantidade de uma ive
        AND VEN.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
) TAB
;


/*-- SEQ 2325 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IVO CASCADE;

/*-- SEQ 2326 --*/
CREATE OR REPLACE VIEW TV_IVO AS
SELECT SEP.ORIGEM,
       ROM.PLACAS, MOT.NOMCLI AS MOTORA,
       MOT.FILCLI AS FILMOT, MOT.CODCLI AS CODMOT,
       ROUND(GRA.VOLUME * SEP.CONTEM,5) AS VOLCAR,
       ROUND(GRA.PESBRU * SEP.CONTEM,4) AS PESCAR, SEP.VLRMOV AS VLRITE,
       SEP.CODFIL, SEP.FLGEST, SEP.FILCLI,
       SEP.CODCLI, SEP.FILVEN, SEP.CODVEN, SEP.CODSER, SEP.NUMNOT,
       SEP.NUMECF, SEP.CODNAT, SEP.VLRBRU, SEP.VLRNOT,
       SEP.DATHOR, SEP.DOCUME, SEP.CONTEM, SEP.QTDFAL,
       SEP.FILIVE, SEP.SEQIVE, SEP.NUMIVE, SEP.FILPED,
       SEP.TIPPED, SEP.NUMPED, SEP.NUMPED_RE, SEP.NUMITE, SEP.FILVOL, SEP.SEQUEN,
       SEP.FILIPE, SEP.NUMIPE, SEP.ITEIPE, GRA.REFPRO, 
       CAST(ReferenciaPrimeiraEmbalagem(GRA.REFPRO) AS VARCHAR(20)) AS REFPRO_Embalagem, 
       PRO.DESMAT,
       SEP.ITEDOC, SEP.QTDITE, SEP.EDE_FILCLI, SEP.EDE_CODCLI,
       SEP.EDE_CODFIL, SEP.EDE_NUMEND, 
       SEP.EDE_FILCOB, SEP.EDE_ENDCOB,
       SEP.EDE_FILFAT, SEP.EDE_ENDFAT,
       SEP.GRA_FILMAT, SEP.GRA_CODMAT,
       SEP.GRA_CODCOR, SEP.GRA_CODTAM, SEP.PRO_FILMAT, SEP.PRO_CODMAT,
       SEP.ROM_CODFIL, SEP.ROM_SEQUEN,
       CASE SEP.FLGEST WHEN 'F' THEN COALESCE(SEP.QTDFAL,0)  -- RFMP 100440 Tratar QTDSEP para Em Falta e Separado,
                       WHEN 'P' THEN COALESCE(SEP.CONTEM,0)  -- conforme tela de Montagem de Carga
                       ELSE SEP.QTDSEP
       END AS QTDSEP,
       SEP.FILLOT, SEP.SEQLOT,
       CAST(ROM.CODFIL||'/'||TRIM(ROM.SEQUEN) AS CHAR(14)) AS NUMCAR,
       ROM.CODFIL AS CODFIL2, ROM.SEQUEN AS SEQROM, ROM.FLGEST AS FLGROM,
       ROM.FILTRA, ROM.CODTRA, ROM.DATOPE, SEP.REGIAO, SEP.NOMCID, SEP.BAIRRO,
       SEP.TIPENT, PRO.DEPART,
       PRO.DESMAT||CASE WHEN GRA.CODCOR = 0 OR DDIV.NOMDIV = '--' THEN ''
                        ELSE ' ' || TRIM(COALESCE(DIV.NOMEXT,''))
                   END||
                   CASE WHEN SEP.GRA_EMBORI IS NULL THEN
                      CASE WHEN GRA.CODTAM = 0 OR DSUB.NOMSUB = '--' THEN ''
                           ELSE ' ' || TRIM(COALESCE(SUB.NOMEXT,''))
                      END
                   ELSE
                      CASE WHEN SEP.GRA_EMBORI = 0 OR DSUBORI.NOMSUB = '--' THEN ''
                           ELSE ' ' || TRIM(COALESCE(SUBORI.NOMEXT,''))
                      END
                   END||
                   ' '||COALESCE(PRO.ESPMAT,'')||
                   ' '||COALESCE(MED1.UNIMED,'')||
                   CASE WHEN MAR.DESMAR IS NULL THEN ''
                        ELSE ' ' || TRIM(MAR.DESMAR)
                   END AS DESSEP,
       SAL.LOCAL1, SAL.LOCAL2, SAL.LOCAL3, SEP.OBSERV, SEP.FILEQP, SEP.SEQEQP,
       PRO.REFBAS, ROM.CODEXT AS ROM_CODEXT, SEP.IMPSEP, SEP.VLRCUS, SEP.ORC_FLGEST, SEP.PED_FLGEST,
       SEP.ATU_EM, SEP.ORCECO, SEP.FLGECO, SEP.FILRET, SEP.FILRET_NOME, SEP.CODMUL, SEP.ORC_APROVA,
       SEP.ORC_APRCLI, SEP.IPE_FLGEST, SEP.SISORI, SEP.TELEVE, SEP.TIPPAG
  FROM (
         SELECT IVO.ORIGEM,
               IVO.CONTEM,
               IVO.FLGEST,
               IVO.QTDFAL,
               VEN.CODFIL AS CODFIL,
               ROUND(IVE.VLRMOV/IVE.QTDMOV * IVO.CONTEM,2) AS VLRMOV,
               VEN.FILCLI,
               VEN.CODCLI,
               VEN.FILVEN,
               VEN.CODVEN,
               VEN.CODSER,
               VEN.NUMNOT,
               VEN.NUMECF,
               VEN.CODNAT,
               IVE.VLRMOV - COALESCE(IVE.VLRDES,0) AS VLRBRU,
               VEN.VLRNOT,
               VEN.DATHOR,
               TO_CHAR('NF '||COALESCE(VEN.CODSER,'') ||'/'|| lTrim(COALESCE(VEN.NUMECF,''))||'-'||lTrim(COALESCE(VEN.NUMNOT,''))||CASE WHEN COALESCE(VEN.CNT_RO,0)>0 THEN '['||VEN.CNT_RO||']' ELSE '' END) AS DOCUME,
               IVO.FILIVE,
               IVO.SEQIVE,
               IVO.NUMIVE,
               IVO.FILPED,
               IVO.TIPPED,
               IVO.NUMPED, ORC.NUMPED_RE, ORC.FILRET,
               DFIL.NOMFIL AS FILRET_NOME, -- MN - Filial de Retirada
               IVO.NUMITE,
               IVO.FILVOL,
               IVO.SEQUEN,
               IVO.FILIPE,
               IVO.NUMIPE,
               IVO.ITEIPE,
               IVE.NUMITE AS ITEDOC,
               CASE WHEN IVE.EMBORI IS NULL THEN IVE.QTDMOV ELSE IVE.EMBQTD
               END AS QTDITE,
               VEN.FILCLI AS EDE_FILCLI,
               VEN.CODCLI AS EDE_CODCLI,
               VEN.FILENT AS EDE_CODFIL,
               VEN.ENDENT AS EDE_NUMEND,
               VEN.FILCOB AS EDE_FILCOB,
               VEN.ENDCOB AS EDE_ENDCOB,
               VEN.FILFAT AS EDE_FILFAT,
               VEN.ENDFAT AS EDE_ENDFAT,
               IVE.FILMAT AS GRA_FILMAT,
               IVE.CODMAT AS GRA_CODMAT,
               IVE.CODCOR AS GRA_CODCOR,
               IVE.CODTAM AS GRA_CODTAM,
               IVE.EMBORI AS GRA_EMBORI,
               IVE.FILMAT AS PRO_FILMAT,
               IVE.CODMAT AS PRO_CODMAT,
               IVO.FILROM AS ROM_CODFIL,
               IVO.SEQROM AS ROM_SEQUEN,
               QTD_A_SEPARAR(IVE.CODFIL,IVE.SEQUEN,IVE.NUMITE,null,null,null,null) AS QTDSEP,
               IVE.FILLOT,
               IVE.SEQLOT,
               IOR.TIPENT,
               ORC.OBSERV,
               IVO.ATU_EM,
               EDE.REGIAO, 
               EDE.NOMCID, 
               EDE.BAIRRO,
               VEN.CODFIL AS SAL_CODFIL,
               ORC.FLGECO, ORC.IMPSEP,
               CAST(CASE WHEN ORC.FLGECO IS NOT NULL THEN 'T' ELSE 'F' END AS CHAR(1)) AS ORCECO,
               IOR.CODMUL, IOR.VLRCUS, IOR.FILEQP, IOR.SEQEQP,
               ORC.FLGEST AS ORC_FLGEST, CAST(NULL AS CHAR(1)) AS PED_FLGEST,
               ORC.APROVA AS ORC_APROVA, ORC.APRCLI AS ORC_APRCLI,
               NULL AS IPE_FLGEST,
               ORC.SISORI,
               ORC.TELEVE,
               ORC.TIPPAG
          FROM TT_IVO IVO INNER JOIN TT_IVE IVE ON IVE.CODFIL = IVO.FILIVE
                                               AND IVE.SEQUEN = IVO.SEQIVE
                                               AND IVE.NUMITE = IVO.NUMIVE
                          INNER JOIN TT_VEN VEN ON IVE.CODFIL = VEN.CODFIL
                                               AND IVE.SEQUEN = VEN.SEQUEN
                          LEFT  JOIN TT_IOR IOR ON IOR.FILIVE = IVE.CODFIL
                                               AND IOR.SEQIVE = IVE.SEQUEN
                                               AND IOR.NUMIVE = IVE.NUMITE
                          LEFT  JOIN TT_ORC ORC ON ORC.CODFIL = IOR.CODFIL
                                               AND ORC.TIPPED = IOR.TIPPED
                                               AND ORC.NUMPED = IOR.NUMPED
                          INNER JOIN TT_END EDE ON EDE.FILCLI = VEN.FILCLI
                                               AND EDE.CODCLI = VEN.CODCLI
                                               AND EDE.CODFIL = VEN.FILENT
                                               AND EDE.NUMEND = VEN.ENDENT
                          LEFT JOIN TD_FIL DFIL ON DFIL.CODFIL = ORC.FILRET
       UNION ALL
        SELECT IVO.ORIGEM,
               IVO.CONTEM,
               IVO.FLGEST,
               IVO.QTDFAL,
               ORC.CODFIL AS CODFIL,
               ROUND(IOR.VLRITE * IVO.CONTEM,2) AS VLRMOV,
               ORC.FILCLI,
               ORC.CODCLI,
               ORC.FILVEN,
               ORC.CODVEN,
               ORC.CODSER,
               ORC.NUMNOT,
               ORC.NUMECF,
               NULL AS CODNAT,
               IOR.VLRPGT AS VLRBRU,
               ORC.VLRTOT AS VLRNOT,
               ORC.PED_EM AS DATHOR,
               TO_CHAR('PED '||IOR.CODFIL||'-'||IOR.TIPPED||'/'||TO_NUMBER(IOR.NUMPED)) AS DOCUME,
               IVO.FILIVE,
               IVO.SEQIVE,
               IVO.NUMIVE,
               IVO.FILPED,
               IVO.TIPPED,
               IVO.NUMPED, ORC.NUMPED_RE, ORC.FILRET,
               DFIL.NOMFIL AS FILRET_NOME,
               IVO.NUMITE,
               IVO.FILVOL,
               IVO.SEQUEN,
               IVO.FILIPE,
               IVO.NUMIPE,
               IVO.ITEIPE,
               IOR.NUMITE AS ITEDOC,
               IOR.QTDITE,
               ORC.FILCLI AS EDE_FILCLI,
               ORC.CODCLI AS EDE_CODCLI,
               COALESCE(IOR.FILEND,ORC.FILENT) AS EDE_CODFIL,
               COALESCE(IOR.NUMEND,ORC.NUMENT) AS EDE_NUMEND,
               ORC.FILCOB AS EDE_FILCOB,
               ORC.NUMCOB AS EDE_ENDCOB,
               ORC.FILFAT AS EDE_FILFAT,
               ORC.NUMFAT AS EDE_ENDFAT,
               IOR.FILMAT AS GRA_FILMAT,
               IOR.CODMAT AS GRA_CODMAT,
               IOR.CODCOR AS GRA_CODCOR,
               IOR.CODTAM AS GRA_CODTAM,
               CAST(NULL AS Numeric(5)) AS GRA_EMBORI,
               IOR.FILMAT AS PRO_FILMAT,
               IOR.CODMAT AS PRO_CODMAT,
               IVO.FILROM AS ROM_CODFIL,
               IVO.SEQROM AS ROM_SEQUEN,
               QTD_A_SEPARAR(null,null,null,IOR.CODFIL,IOR.TIPPED,IOR.NUMPED,IOR.NUMITE) AS QTDSEP,
               IOR.FILLOT,
               IOR.SEQLOT,
               IOR.TIPENT,
               ORC.OBSERV,
               IVO.ATU_EM,
               EDE.REGIAO, 
               EDE.NOMCID, 
               EDE.BAIRRO,
               ORC.CODFIL AS SAL_CODFIL,
               ORC.FLGECO, ORC.IMPSEP,
               CAST(CASE WHEN ORC.FLGECO IS NOT NULL THEN 'T' ELSE 'F' END AS CHAR(1)) AS ORCECO,
               IOR.CODMUL, IOR.VLRCUS, IOR.FILEQP, IOR.SEQEQP,
               ORC.FLGEST AS ORC_FLGEST, CAST(NULL AS CHAR(1)) AS PED_FLGEST,
               ORC.APROVA AS ORC_APROVA, ORC.APRCLI AS ORC_APRCLI,
               NULL AS IPE_FLGEST,
               ORC.SISORI,
               ORC.TELEVE,
               ORC.TIPPAG
         FROM TT_IVO IVO INNER JOIN TT_IOR IOR ON IVO.FILPED = IOR.CODFIL
                                              AND IVO.NUMPED = IOR.NUMPED
                                              AND IVO.TIPPED = IOR.TIPPED
                                              AND IVO.NUMITE = IOR.NUMITE
                         INNER JOIN TT_ORC ORC ON ORC.CODFIL = IOR.CODFIL
                                              AND ORC.TIPPED = IOR.TIPPED
                                              AND ORC.NUMPED = IOR.NUMPED
                         INNER JOIN TT_END EDE ON EDE.FILCLI = ORC.FILCLI
                                              AND EDE.CODCLI = ORC.CODCLI
                                              AND EDE.CODFIL = COALESCE(IOR.FILEND,ORC.FILENT)
                                              AND EDE.NUMEND = COALESCE(IOR.NUMEND,ORC.NUMENT)
                         LEFT JOIN TD_FIL DFIL ON DFIL.CODFIL = ORC.FILRET
       UNION ALL
         SELECT IVO.ORIGEM,
               IVO.CONTEM,
               IVO.FLGEST,
               IVO.QTDFAL,
               PED.CODFIL AS CODFIL,
               ROUND(IPE.VLRITE * IVO.CONTEM,2) AS VLRMOV,
               PED.FILFOR AS FILCLI,
               PED.CODFOR AS CODCLI,
               PED.FILUSU AS FILVEN,
               PED.CODUSU AS CODVEN,
               NULL AS CODSER,
               NULL AS NUMNOT,
               NULL AS NUMECF,
               NULL AS CODNAT,
               (IPE.VLRITE - COALESCE(IPE.VLRDES,0)) AS VLRBRU,
               PED.VLRTOT AS VLRNOT,
               PED.DATPED AS DATHOR,
               TO_CHAR('REP '||(TO_CHAR(PED.CODFIL) || TO_CHAR(PED.NUMPED))) AS DOCUME,
               IVO.FILIVE,
               IVO.SEQIVE,
               IVO.NUMIVE,
               IVO.FILPED,
               IVO.TIPPED,
               IVO.NUMPED, NULL AS NUMPED_RE, NULL AS FILRET,
               NULL AS FILRET_NOME,
               IVO.NUMITE,
               IVO.FILVOL,
               IVO.SEQUEN,
               IVO.FILIPE,
               IVO.NUMIPE,
               IVO.ITEIPE,
               IPE.NUMITE AS ITEDOC,
               IPE.QTDITE,
               PED.FILFOR AS EDE_FILCLI,
               PED.CODFOR AS EDE_CODCLI,
               PED.FILEND AS EDE_CODFIL,
               PED.NUMEND AS EDE_NUMEND,
               PED.FILEND AS EDE_FILCOB,
               PED.NUMEND AS EDE_ENDCOB,
               PED.FILEND AS EDE_FILFAT,
               PED.NUMEND AS EDE_ENDFAT,
               IPE.FILMAT AS GRA_FILMAT,
               IPE.CODMAT AS GRA_CODMAT,
               IPE.CODCOR AS GRA_CODCOR,
               IPE.CODTAM AS GRA_CODTAM,
               CAST(NULL AS Numeric(5)) AS GRA_EMBORI,
               IPE.FILMAT AS PRO_FILMAT,
               IPE.CODMAT AS PRO_CODMAT,
               IVO.FILROM AS ROM_CODFIL,
               IVO.SEQROM AS ROM_SEQUEN,
               (IPE.QTDITE - COALESCE(IVO.CONTEM,0) -  COALESCE(IVO.QTDFAL,0)) AS QTDSEP,
               IPE.FILLOT,
               IPE.SEQLOT,
               null as TIPENT,
               PED.OBSERV,
               IVO.ATU_EM,
               EDE.REGIAO, 
               EDE.NOMCID, 
               EDE.BAIRRO,
               PED.FILFOR AS SAL_CODFIL,
               NULL AS FLGECO, PED.IMPSEP,
               CAST('F' AS CHAR(1)) ORCECO,
               IPE.CODMUL, IPE.VLRITE AS VLRCUS, NULL AS FILEQP, NULL AS SEQEQP,
               CAST(NULL AS CHAR(1)) AS ORC_FLGEST, PED.FLGEST AS PED_FLGEST,
               CAST(NULL AS CHAR(1)) AS ORC_APROVA, CAST(NULL AS CHAR(1)) AS ORC_APRCLI,
               IPE.FLGEST AS IPE_FLGEST,
               CAST(NULL AS CHAR(1)) AS SISORI,
               CAST('F' AS CHAR(1)) AS TELEVE,
               CAST(NULL AS VARCHAR(1)) AS TIPPAG
          FROM TT_IVO IVO INNER JOIN TT_IPE IPE ON IVO.FILIPE = IPE.CODFIL
                                               AND IVO.NUMIPE = IPE.NUMPED
                                               AND IVO.ITEIPE = IPE.NUMITE
                          INNER JOIN TT_PED PED ON PED.CODFIL = IPE.CODFIL
                                               AND PED.NUMPED = IPE.NUMPED
                           LEFT JOIN TT_END EDE ON EDE.FILCLI = PED.FILFOR
                                               AND EDE.CODCLI = PED.CODFOR
                                               AND EDE.CODFIL = PED.FILEND
                                               AND EDE.NUMEND = PED.NUMEND
       ) SEP INNER JOIN TT_GRA GRA ON GRA.FILMAT = SEP.GRA_FILMAT
                                  AND GRA.CODMAT = SEP.GRA_CODMAT
                                  AND GRA.CODCOR = SEP.GRA_CODCOR
                                  AND GRA.CODTAM = SEP.GRA_CODTAM
             INNER JOIN TT_SAL SAL ON SAL.CODFIL = SEP.SAL_CODFIL
                                  AND SAL.FILMAT = SEP.GRA_FILMAT
                                  AND SAL.CODMAT = SEP.GRA_CODMAT
                                  AND SAL.CODCOR = SEP.GRA_CODCOR
                                  AND SAL.CODTAM = SEP.GRA_CODTAM
                                  AND SAL.CODMUL = 0
             INNER JOIN TT_PRO PRO ON PRO.FILMAT = SEP.PRO_FILMAT
                                  AND PRO.CODMAT = SEP.PRO_CODMAT
             INNER JOIN TT_DIV DIV ON GRA.CODCOR = DIV.CODITE
             INNER JOIN TD_DIV DDIV ON DIV.CODDIV = DDIV.CODTAB
             INNER JOIN TT_SUB SUB ON GRA.CODTAM = SUB.CODITE
             INNER JOIN TD_SUB DSUB ON SUB.CODSUB = DSUB.CODTAB
             INNER JOIN TD_MED MED1 ON MED1.CODTAB = GRA.UNIDAD
              LEFT JOIN TT_ROM ROM ON SEP.ROM_CODFIL = ROM.CODFIL
                                  AND SEP.ROM_SEQUEN = ROM.SEQUEN
              LEFT JOIN TT_CLI MOT ON MOT.FILCLI = ROM.FILMOT
                                  AND MOT.CODCLI = ROM.CODMOT
              LEFT JOIN TT_MAR MAR  ON PRO.ITEMAR = MAR.ITEMAR
                                         AND PRO.FILMAR = MAR.FILMAR
                                         AND PRO.CODMAR = MAR.CODMAR
              LEFT JOIN TT_SUB SUBORI ON SUBORI.CODITE = SEP.GRA_EMBORI
              LEFT JOIN TD_SUB DSUBORI ON SUBORI.CODSUB = DSUBORI.CODTAB;


/*-- SEQ 2327 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IXT_HAQ CASCADE;

/*-- SEQ 2328 --*/
CREATE OR REPLACE VIEW TV_IXT_HAQ AS
-- View para o Integrador de CNAB
-- Header de arquivo
-- 1 Arquivo por Banco e Filial
  SELECT TIT.CODBCO AS CODBCO,
       TIT.NUMAGE AS NUMAGE,
       TIT.CTACRR AS CTACRR,
       TIT.CODFIL AS CODFIL,
       -1    AS REMBCO,
       TO_NUMBER(NULL) AS INSTR1,
       TO_NUMBER(NULL) AS INSTR2,
       CAST('0' AS VARCHAR(1))        AS TIPREG,
       CAST('0' AS VARCHAR(1))        AS REGIST,
       CAST('0' AS VARCHAR(1))        AS NUMREG,
       CAST(' ' AS VARCHAR(1))        AS SEGREG,
       TO_ASCII(LPAD(COALESCE(TRIM(MIN(TIT.CODBCO)),'0'), 3,'0')                                -- Cdigo do Banco - Numero do Banco na camara de compensacao
                || LPAD('0',4,'0')                                                    -- Sequenciador do Lote - lote de servico
                || '0'                                                              -- tipo de registro (0 = header de arq) - registro header de arquivo
                || RPAD(' ',9,' ')                                                    -- Uso Exclusivo Febraban - Complemento de Registro
                || '2'                                                              -- Tipo de documento da empresa (2=CGC)  - Tipo de Inscricao da Empresa
                || LPAD(COALESCE(TRIM(MIN(FIL.CGCFIL)),'0'),14,'0')                                -- Documento da empresa  - Numero de inscricao da empresa
                || RPAD(COALESCE(TRIM(MIN(BXC.CODCNV)),' '),20,' ')                                -- Convnio com o Banco  - complemento de registro
                || CASE TIT.CODBCO WHEN '341' THEN '0' ELSE '' END                           -- Somente p/ Itau - complemento de registro
                || CASE TIT.CODBCO WHEN '399' THEN LPAD(COALESCE(TRIM(MIN(TIT.NUMAGE)),'0'), 5,'0')            -- HSBC
                                   WHEN '341' THEN LPAD(COALESCE(TRIM(MIN(SUBSTR(TIT.NUMAGE,2,4))),'0'), 4,'0')   -- ITAU
                                   WHEN '001' THEN LPAD(COALESCE(TRIM(MIN(TIT.NUMAGE)),'0'), 5,'0')          -- BRASIL
                                   ELSE '' END                                                  -- Nmero da agncia - agencia mantenedora da conta
                || CASE TIT.CODBCO WHEN '341' THEN ' ' ELSE '' END                           -- Somente p/ Itau   - complemento de registro
                || CASE TIT.CODBCO WHEN '341' THEN LPAD('0',7,'0') ELSE '' END                      -- Somente p/ Itau - complemento de registro
                || CASE TIT.CODBCO WHEN '341' THEN LPAD(COALESCE(TRIM(MIN(SUBSTR(TIT.CTACRR,6,5))),'0'),5,'0')
                                   ELSE '' END                                                  -- Nmero da conta corrente
                || CASE TIT.CODBCO WHEN '341' THEN ' ' ELSE '' END                          -- Somente p/ Itau - complemento de registro
                || CASE TIT.CODBCO WHEN '341' THEN LPAD(COALESCE(TRIM(MIN(CTB.DIGA_C)),' '), 1,' ') ELSE '' END          -- digito de auto-conferncia ag./conta
                || CASE TIT.CODBCO WHEN '399' THEN LPAD(COALESCE(TRIM(MIN(CTB.DIGAGE)),' '), 1,' ')          -- Dgito verificador da Agncia  - HSBC
                                   WHEN '001' THEN LPAD(COALESCE(TRIM(MIN(CTB.DIGAGE)),' '), 1,' ')  ELSE ''  END      -- Dgito verificador da Agncia  - BRASIL
                || CASE TIT.CODBCO WHEN '399' THEN LPAD(COALESCE(TRIM(MIN(TIT.CTACRR)),'0'),12,'0')           -- Nmero da conta corrente - HSBC
                                   WHEN '001' THEN LPAD(COALESCE(TRIM(MIN(TIT.CTACRR)),'0'),12,'0') ELSE ''  END          -- Nmero da conta corrente - BRASIL
                || CASE TIT.CODBCO WHEN '399' THEN LPAD(COALESCE(TRIM(MIN(CTB.DIGCRR)),' '), 1,' ')           -- Digito verificador da conta corrente - HSBC
                                   WHEN '001' THEN LPAD(COALESCE(TRIM(MIN(CTB.DIGCRR)),' '), 1,' ')  ELSE '' END          -- Digito verificador da conta corrente - BRASIL
                || CASE TIT.CODBCO WHEN '399' THEN LPAD(COALESCE(TRIM(MIN(CTB.DIGA_C)),' '), 1,' ')           -- Dgito verificador da conta e agncia - HSBC
                                   WHEN '001' THEN LPAD(COALESCE(TRIM(MIN(CTB.DIGA_C)),' '), 1,' ')  ELSE '' END          -- Dgito verificador da conta e agncia - BRASIL
                || RPAD(COALESCE(TRIM(MIN(FIL.RAZSOC)),' '),30,' ')                          -- Nome da empresa
                || RPAD(COALESCE(TRIM(MIN(BCO.NBANCO)),' '),30,' ')                          -- Nome do Banco  - Alterar Nome Banco para BANCO ITAU SA
                || RPAD(' ',10,' ')                                          -- Uso Exclusivo Febraban  - Complemento de Registro
                || '1'                                                  -- Cdigo 1=Remessa 2=Retorno
                || TO_CHAR(AGORA(),'DDMMYYYY')                                      -- data de gravao (geracao) remessa/retorno
                || TO_CHAR(AGORA(),'HHMISS')                                      -- hora de gravao remessa/retorno
                || LPAD(COALESCE(TRIM(to_char(MIN(BCO.PRXREM))),'0'),6,'0')                          -- Sequencial do Arquivo
                || LPAD(CASE TIT.CODBCO WHEN '341' THEN '40'
                                        WHEN '399' THEN '30'
                                        WHEN '001' THEN '30'
                                        ELSE            '50'
                        END,3,'0')                                          -- Nro da versao Layout do lote
                || LPAD('0',5,'0')                                          -- Densidade do Arquivo  - Complemento de Registro
                || CASE TIT.CODBCO WHEN '399' THEN LPAD(' ',20,' ')
                                   WHEN '341' THEN LPAD(' ',54,' ')
                                   WHEN '001' THEN LPAD(' ',20,' ')
                   ELSE '' END                                                  -- Uso do Banco  - Complemento de Registro
                || CASE TIT.CODBCO WHEN '399' THEN LPAD(' ',20,' ')
                                   WHEN '341' THEN LPAD('0',3,'0')
                                   WHEN '001' THEN LPAD(' ',20,' ')
                   ELSE ''  END                                                  -- Uso da Empresa  - Complemento de Registro
                || CASE TIT.CODBCO WHEN '399' THEN RPAD(' ',29,' ')
                                   WHEN '341' THEN LPAD(' ',12,' ')
                                   WHEN '001' THEN RPAD(' ',11,' ')
                   ELSE ''  END                                                  -- Uso exclusivo CNAB  - Complemento de Registro
                || CASE TIT.CODBCO WHEN '001' THEN 'CSP'  ELSE ''    END                              -- Identificao cobranca s/ papel 'CSP' - BRASIL
                || CASE TIT.CODBCO WHEN '001' THEN LPAD('0',3,'0')  ELSE ''    END                      -- Uso exclusivo das VANS - BRASIL
                || CASE TIT.CODBCO WHEN '001' THEN RPAD(' ',2,' ')  ELSE ''    END                      -- Tipo de servio - BRASIL
                || CASE TIT.CODBCO WHEN '001' THEN RPAD(' ',10,' ')  ELSE ''   END                      -- Codigos das Ocorrencias - BRASIL
                ) AS LINHA
  FROM TT_VEN VEN INNER JOIN TT_TIT TIT ON VEN.CODFIL = TIT.FILREC AND VEN.SEQUEN = TIT.SEQREC
                  INNER JOIN TT_IXT IXT ON IXT.CODFIL = TIT.CODFIL AND IXT.SEQTIT = TIT.SEQUEN
                  INNER JOIN TD_FIL FIL ON TIT.CODFIL = FIL.CODFIL
                  INNER JOIN TT_CTB CTB ON TIT.NUMAGE = CTB.NUMAGE
                                       AND TIT.CODBCO = CTB.CODBCO
                                       AND TIT.CTACRR = CTB.CTACRR
                  INNER JOIN TD_BCO BCO ON TIT.CODBCO = BCO.CBANCO
                  LEFT  JOIN TT_CTBXCCB BXC ON TIT.CODBCO = BXC.CODBCO
                                           AND TIT.NUMAGE = BXC.NUMAGE
                                           AND TIT.CTACRR = BXC.CTACRR
                                           AND TIT.CODCCB = BXC.CODCCB
  WHERE VEN.FILCOB is not null
    AND VEN.ENDCOB is not null
    AND IXT.DATENV IS NULL
    AND TIT.FLGEST <> 'I'
 GROUP BY TIT.CODBCO, TIT.NUMAGE, TIT.CTACRR, TIT.CODFIL
;


/*-- SEQ 2329 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IXT_HAQ_BESC CASCADE;

/*-- SEQ 2330 --*/
CREATE OR REPLACE VIEW TV_IXT_HAQ_BESC AS
-- View para a Cobrana BESC
-- Header de arquivo
-- 1 Arquivo por Banco e Filial
SELECT TIT.CODBCO AS CODBCO,
       TIT.NUMAGE AS NUMAGE,
       TIT.CTACRR AS CTACRR,
       TIT.CODFIL AS CODFIL,
       -1    AS REMBCO,
       TO_NUMBER(NULL) AS INSTR1,
       TO_NUMBER(NULL) AS INSTR2,
       CAST('0' AS VARCHAR(1))        AS TIPREG,
       CAST('0' AS VARCHAR(1))        AS REGIST,
       CAST('0' AS VARCHAR(1))        AS NUMREG,
       CAST(' ' AS VARCHAR(1))        AS SEGREG,
       TO_ASCII(LPAD(COALESCE(TRIM(MIN(TIT.CODBCO)),'0'), 3,'0')						  -- Cdigo do Banco - Numero do Banco na camara de compensacao
                || LPAD('0',4,'0')										  -- Sequenciador do Lote - lote de servico
                || '0'												  -- tipo de registro (0 = header de arq) - registro header de arquivo
                || RPAD(' ',9,' ')										  -- Uso Exclusivo Febraban - Complemento de Registro
--empresa
		|| '2'												  -- Tipo de documento da empresa (2=CGC)  - Tipo de Inscricao da Empresa
                || LPAD(COALESCE(TRIM(MIN(FIL.CGCFIL)),'0'),14,'0')						  -- Documento da empresa  - Numero de inscricao da empresa
                || LPAD(COALESCE(TRIM(MIN(BXC.CODCNV)),'0'),20,'0')						  -- Convnio com o Banco  - complemento de registro
                || LPAD(COALESCE(TRIM(MIN(TIT.NUMAGE)),'0'), 5,'0')						  -- Nmero da agncia - agencia mantenedora da conta
                || LPAD(COALESCE(TRIM(MIN(CTB.DIGAGE)),'0'), 1,'0')						  -- Dgito verificador da Agncia  
		|| LPAD(COALESCE(TRIM(MIN(TIT.CTACRR)),'0'),12,'0')						  -- Nmero da conta corrente 
		|| LPAD(COALESCE(TRIM(MIN(CTB.DIGCRR)),'0'), 1,'0')						  -- Digito verificador da conta corrente 
		|| LPAD(COALESCE(TRIM(MIN(CTB.DIGA_C)),'0'), 1,'0')						  -- Dgito verificador da conta e agncia
		|| RPAD(COALESCE(TRIM(MIN(FIL.RAZSOC)),' '),30,' ')						  -- Nome da empresa
--banco
		|| RPAD(COALESCE(TRIM(MIN(BCO.NBANCO)),' '),30,' ')						  -- Nome do Banco  
                || RPAD(' ',10,' ')										  -- Uso Exclusivo Febraban  - Complemento de Registro
--arquivo
                || '1'												  -- Cdigo de transmissao do arquivo 1=remessa
		|| TO_CHAR(AGORA(),'DDMMYYYY')									  -- data de gravao (geracao) remessa/retorno
                || TO_CHAR(AGORA(),'HHMISS')									  -- hora de gravao remessa/retorno
		|| LPAD(COALESCE(TRIM(to_char(MIN(BCO.PRXREM))),'0'),6,'0')						  -- Sequencial do Arquivo
		|| '020' 											  -- Nro da versao Layout do lote
                || '00000'											  -- Densidade do Arquivo  - Complemento de Registro
		|| 'AGL'											  -- Uso do Banco  - Complemento de Registro
                || '0'												  -- '0' para incluso de lanamento e '5' para alterao
                || RPAD(' ',16,' ')										  -- Uso exclusivo BESC
                || RPAD(' ',20,' ')										  -- Uso exclusivo Empresa
                || RPAD(' ',29,' ')										  -- Uso exclusivo CNAB
                ) AS LINHA
  from tt_ven ven inner join tt_tit tit ON VEN.CODFIL = TIT.FILREC AND VEN.SEQUEN = TIT.SEQREC
                  INNER JOIN TT_CTB CTB ON TIT.NUMAGE = CTB.NUMAGE AND TIT.CODBCO = CTB.CODBCO AND TIT.CTACRR = CTB.CTACRR
                  INNER JOIN TT_IXT IXT ON TIT.CODFIL = IXT.CODFIL AND TIT.SEQUEN = IXT.SEQTIT
                  inner join td_fil fil on fil.codfil = TIT.codfil
                  INNER JOIN TD_BCO BCO ON TIT.CODBCO = BCO.CBANCO
                  LEFT  JOIN TT_CTBXCCB BXC ON TIT.CODBCO = BXC.CODBCO
                                           AND TIT.NUMAGE = BXC.NUMAGE
                                           AND TIT.CTACRR = BXC.CTACRR
                                           AND TIT.CODCCB = BXC.CODCCB
  WHERE VEN.FILCOB IS NOT NULL
    AND VEN.ENDCOB IS NOT NULL
    and ven.flgest = 'A'
    and ven.codser= 'CC' 
    and ven.tipnot= 'F'
    AND IXT.DATENV IS NULL
    AND TIT.FLGEST <> 'I'
 GROUP BY TIT.CODBCO, TIT.NUMAGE, TIT.CTACRR, TIT.CODFIL
;


/*-- SEQ 2331 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IXT_HLT CASCADE;

/*-- SEQ 2332 --*/
CREATE OR REPLACE VIEW TV_IXT_HLT AS
-- View para o Integrador de CNAB
-- Header de lote
  SELECT TIT.CODBCO AS CODBCO,
       TIT.NUMAGE AS NUMAGE,
       TIT.CTACRR AS CTACRR,
       TIT.CODFIL AS CODFIL,
       IXT.REMBCO AS REMBCO,
       IXT.INSTR1 AS INSTR1,
       IXT.INSTR2 AS INSTR2,
       CAST('1' AS VARCHAR(1))        AS TIPREG,
       CAST('0' AS VARCHAR(1))        AS REGIST,
       CAST('0' AS VARCHAR(1))        AS NUMREG,
       CAST(' ' AS VARCHAR(1))        AS SEGREG,
       TO_ASCII(LPAD(COALESCE(TRIM(MIN(TIT.CODBCO)),'0'),3,'0')                          -- Cdigo do Banco
                || LPAD(COALESCE(TRIM(MIN('|L#|')),'0'),4,'0')                          -- Sequenciador do Lote
                || '1'                                              -- tipo de registro (1 = header de lote)
                || 'R'                                              -- tipo de operao (r = remessa t = retorno)
                || LPAD('1',2,'0')                                      -- Tipo de servico (01 = Cobrana)
                || Rpad('0',2,'0')                                      -- Uso exclusivo Febraban || BRASIL - FORMA DA LANCAMENTO
                || LPAD(CASE TIT.CODBCO WHEN '341' THEN '30'
                                        WHEN '399' THEN '10'
                                        WHEN '001' THEN '20'                          -- BRASIL
                                        ELSE '30'
                        END,3,'0')                                             -- Nro da versao do Layout do lote
                || RPAD(' ',1,' ')                                             -- Uso exclusivo Febraban
                || '2'                                                         -- Tipo de documento da empresa (2=CGC)
                || LPAD(COALESCE(TRIM(MIN(DFIL.CGCFIL)),'0'),15,'0')           -- Documento da empresa
                || RPAD(CASE TIT.CODBCO WHEN '399' THEN COALESCE(TRIM(MIN(BXC.CODCNV)),'0')
                                        WHEN '341' THEN ' '
                                        WHEN '001' THEN COALESCE(TRIM(MIN(BXC.CODCNV)),' ')                 -- BRASIL
                        ELSE ''    END,20,' ')                                             -- Convnio com o Banco
                || CASE TIT.CODBCO WHEN '341' THEN '0' ELSE '' END                             -- Somente p/ Itau - complemento de registro
                || CASE TIT.CODBCO WHEN '399' THEN LPAD(COALESCE(TRIM(MIN(TIT.NUMAGE)),'0'), 5,'0')
                                   WHEN '341' THEN LPAD(COALESCE(TRIM(MIN(SUBSTR(TIT.NUMAGE,2,4))),'0'), 4,'0')
                                   WHEN '001' THEN LPAD(COALESCE(TRIM(MIN(TIT.NUMAGE)),'0'), 5,'0')             -- BRASIL agencia mantenedora da conta || digito verificador
                                   ELSE '' END                                                     -- Nmero da agncia - agencia mantenedora da conta
                || CASE TIT.CODBCO WHEN '001' THEN LPAD(COALESCE(TRIM(MIN(CTB.DIGAGE)),' '), 1,' ') ELSE ''  END             -- Dgito verificador da Agncia  -
                || CASE TIT.CODBCO WHEN '001' THEN LPAD(COALESCE(TRIM(MIN(TIT.CTACRR)),'0'),12,'0') ELSE '' END             -- Nmero da conta corrente
                || CASE TIT.CODBCO WHEN '001' THEN LPAD(COALESCE(TRIM(MIN(CTB.DIGCRR)),' '), 1,' ') ELSE '' END             -- Digito verificador da conta corrente
                || CASE TIT.CODBCO WHEN '001' THEN LPAD(COALESCE(TRIM(MIN(CTB.DIGA_C)),' '), 1,' ') ELSE '' END             -- Dgito verificador da conta e agncia
                || CASE TIT.CODBCO WHEN '001' THEN RPAD(COALESCE(TRIM(MIN(DFIL.RAZSOC)),' '),30,' ')ELSE '' END             -- Nome da empresa
                || CASE TIT.CODBCO WHEN '341' THEN LPAD(' ',1,' ') ELSE '' END                             -- Somente p/ Itau - complemento de registro
                || CASE TIT.CODBCO WHEN '341' THEN LPAD('0',7,'0') ELSE '' END                             -- Somente p/ Itau - complemento de registro
                || CASE TIT.CODBCO WHEN '341' THEN LPAD(COALESCE(TRIM(MIN(SUBSTR(TIT.CTACRR,6,5))),'0'),5,'0') ELSE ''  END     -- Nmero da conta corrente
                || CASE TIT.CODBCO WHEN '341' THEN LPAD(' ',1,' ')ELSE ''  END                             -- Somente p/ Itau - complemento de registro
                || CASE TIT.CODBCO WHEN '341' THEN LPAD(COALESCE(TRIM(MIN(CTB.DIGA_C)),' '), 1,' ') ELSE '' END             -- digito de auto-conferncia ag./conta
                || CASE TIT.CODBCO WHEN '399' THEN LPAD(COALESCE(TRIM(MIN(CTB.DIGAGE)),' '), 1,' ') ELSE '' END             -- Dgito verificador da Agncia  -
                || CASE TIT.CODBCO WHEN '399' THEN LPAD(COALESCE(TRIM(MIN(TIT.CTACRR)),'0'),12,'0') ELSE '' END             -- Nmero da conta corrente
                || CASE TIT.CODBCO WHEN '399' THEN LPAD(COALESCE(TRIM(MIN(CTB.DIGCRR)),' '), 1,' ') ELSE '' END             -- Digito verificador da conta corrente
                || CASE TIT.CODBCO WHEN '399' THEN LPAD(COALESCE(TRIM(MIN(CTB.DIGA_C)),' '), 1,' ') ELSE '' END             -- Dgito verificador da conta e agncia
                || CASE TIT.CODBCO WHEN '399' THEN RPAD(COALESCE(TRIM(MIN(DFIL.RAZSOC)),' '),30,' ')             -- Nome da empresa
                                   WHEN '341' THEN RPAD(COALESCE(TRIM(MIN(DFIL.RAZSOC)),' '),30,' ')
                                   ELSE ''   END
                || CASE TIT.CODBCO WHEN '399' THEN RPAD(COALESCE(TRIM(MIN(REM.DESINS1)),' '),40,' ')
                                   ELSE RPAD(' ',40,' ')
                   END                                                     -- 1 Mensagem
                || CASE TIT.CODBCO WHEN '399' THEN RPAD(COALESCE(TRIM(MIN(REM.DESINS2)),' '),40,' ')
                                   ELSE RPAD(' ',40,' ')
                   END                                                     -- 2 Mensagem
                || CASE TIT.CODBCO WHEN '001' THEN LPAD(COALESCE(TRIM(to_char(MIN(DBCO.PRXREM))),'0'),8,'0')
                                   WHEN '341' THEN RPAD('0',8,'0')                                               
                                   ELSE LPAD(COALESCE(TRIM(to_char(MIN(DBCO.PRXREM))),' '),8,' ')                 -- nmero de remessa/retorno
                   END
                || TO_CHAR(AGORA(),'DDMMYYYY')                                         -- data gravaao remessa/retorno
                || CASE TIT.CODBCO WHEN '341' THEN TO_CHAR(AGORA(),'DDMMYYYY')
                                              ELSE RPAD('0',8,'0')
                   END                                                          -- Data de crdito (somente Retorno)
                || RPAD(' ',33,' ')                                             -- Uso exclusivo Febraban
               ) AS LINHA
 FROM TT_TIT TIT
      INNER JOIN TT_REC REC ON TIT.FILREC = REC.CODFIL AND TIT.SEQREC = REC.SEQUEN AND TIT.PARREC = REC.NUMPAR AND TIT.SUBREC = REC.SUBPAR
      INNER JOIN TT_IXT IXT  ON TIT.CODFIL = IXT.CODFIL AND TIT.SEQUEN = IXT.SEQTIT
      INNER JOIN TT_VEN VEN  ON VEN.CODFIL = TIT.FILREC AND VEN.SEQUEN = TIT.SEQREC
      INNER JOIN TT_CTB CTB  ON TIT.NUMAGE = CTB.NUMAGE AND TIT.CODBCO = CTB.CODBCO AND TIT.CTACRR = CTB.CTACRR
      INNER JOIN TD_FIL DFIL ON TIT.CODFIL = DFIL.CODFIL
      INNER JOIN TD_BCO DBCO ON TIT.CODBCO = DBCO.CBANCO
      INNER JOIN (SELECT REM.*, INS1.DESINS AS DESINS1, INS2.DESINS AS DESINS2
                  FROM TT_REM REM INNER JOIN TT_CFG CFG  ON REM.CODREM = CFG.INT_INC_TIT
                             LEFT OUTER JOIN TD_INS INS1 ON REM.INSTR1 = INS1.CODTAB
                             LEFT OUTER JOIN TD_INS INS2 ON REM.INSTR2 = INS2.CODTAB
                 ) REM ON REM.CODBCO = TIT.CODBCO
      LEFT  JOIN TT_CTBXCCB BXC ON TIT.CODBCO = BXC.CODBCO
                               AND TIT.NUMAGE = BXC.NUMAGE
                               AND TIT.CTACRR = BXC.CTACRR
                               AND TIT.CODCCB = BXC.CODCCB
 WHERE VEN.FILCOB is not null
   AND VEN.ENDCOB is not null
   AND IXT.DATENV IS NULL
   AND TIT.FLGEST <> 'I'
 GROUP BY TIT.CODBCO, TIT.NUMAGE, TIT.CTACRR, TIT.CODFIL, IXT.REMBCO, IXT.INSTR1, IXT.INSTR2
 ;


/*-- SEQ 2333 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IXT_HLT_BESC CASCADE;

/*-- SEQ 2334 --*/
CREATE OR REPLACE VIEW TV_IXT_HLT_BESC AS
-- View para a Cobrana BESC
-- Header de lote
SELECT TIT.CODBCO AS CODBCO,
       TIT.NUMAGE AS NUMAGE,
       TIT.CTACRR AS CTACRR,
       TIT.CODFIL AS CODFIL,
       IXT.REMBCO AS REMBCO,
       IXT.INSTR1 AS INSTR1,
       IXT.INSTR2 AS INSTR2,
       CAST('1' AS VARCHAR(1))        AS TIPREG,
       CAST('0' AS VARCHAR(1))        AS REGIST,
       CAST('0' AS VARCHAR(1))        AS NUMREG,
       CAST(' ' AS VARCHAR(1))        AS SEGREG,
       TO_ASCII(LPAD(COALESCE(TRIM(MIN(TIT.CODBCO)),'0'),3,'0')						  -- Cdigo do Banco
                || LPAD(COALESCE(TRIM(MIN('|L#|')),'0'),4,'0')						  -- Sequenciador do Lote
                || '1'											  -- tipo de registro (1 = header de lote)
		|| 'D'											  -- tipo de lanamento (d = debito c = credito)
		|| LPAD('0',2,'0')									  -- Tipo de servico "opcional" (05 = dbitos 20 = pag. fornecedores 30 = pag. salario 90 = pag. beneficios)
		|| '50'											  -- forma de lanamento verificar manual (... 50=debito C/C )
                || '020'  										  -- Nro da versao do Layout do lote
                || RPAD(' ',1,' ')											 -- Uso exclusivo Febraban
--empresa
		|| '2'												  -- Tipo de documento da empresa (2=CGC)  - Tipo de Inscricao da Empresa
                || LPAD(COALESCE(TRIM(MIN(DFIL.CGCFIL)),'0'),14,'0')						  -- Documento da empresa  - Numero de inscricao da empresa
                || LPAD(COALESCE(TRIM(MIN(BXC.CODCNV)),'0'),20,'0')						  -- Convnio com o Banco  - complemento de registro
                || LPAD(COALESCE(TRIM(MIN(TIT.NUMAGE)),'0'), 5,'0')						  -- Nmero da agncia - agencia mantenedora da conta
                || LPAD(COALESCE(TRIM(MIN(CTB.DIGAGE)),'0'), 1,'0')						  -- Dgito verificador da Agncia  
		|| LPAD(COALESCE(TRIM(MIN(TIT.CTACRR)),'0'),12,'0')						  -- Nmero da conta corrente 
		|| LPAD(COALESCE(TRIM(MIN(CTB.DIGCRR)),'0'), 1,'0')						  -- Digito verificador da conta corrente 
		|| LPAD(COALESCE(TRIM(MIN(CTB.DIGA_C)),'0'), 1,'0')						  -- Dgito verificador da conta e agncia
		|| RPAD(COALESCE(TRIM(MIN(DFIL.RAZSOC)),' '),30,' ')						  -- Nome da empresa
--mensagem
		|| RPAD(' ',40,' ')										  -- opcional mensagem da empresa
--endereco
  	        || RPAD(COALESCE(TRIM(MIN(DFIL.ENDERE)), ' '), 30, ' ')        -- Logradouro
                || LPAD(COALESCE(TRIM(MIN(DFIL.NUMERO)), '0'),  5, '0')        -- Numero              
  	        || RPAD(COALESCE(TRIM(MIN(DFIL.COMPLE)), ' '), 15, ' ')        -- Complementos
                || RPAD(COALESCE(TRIM(MIN(MUN.NOMCID)) , ' '), 20, ' ')        -- Nome da Cidade
                || LPAD(COALESCE(TRIM(MIN(substr(DFIL.codcep,1,5))), '0'),  5, '0')        -- Cdigo do CEP
                || LPAD(COALESCE(TRIM(MIN(substr(DFIL.codcep,6,3))), '0'),  3, '0')        -- Sufixo do CEP
                || RPAD(COALESCE(TRIM(MIN(DFIL.UFLOJA)), ' '),  2, ' ')        -- Sigla do Estado
                || RPAD(' ',8,' ')											 -- 
                || RPAD(' ',10,' ')											 -- Uso exclusivo ocorrencia de retorno 
               ) AS LINHA
  from tt_ven ven inner join tt_tit tit  ON VEN.CODFIL  = TIT.FILREC AND VEN.SEQUEN = TIT.SEQREC
                  INNER JOIN TT_CTB CTB  ON TIT.NUMAGE  = CTB.NUMAGE AND TIT.CODBCO = CTB.CODBCO AND TIT.CTACRR = CTB.CTACRR
                  INNER JOIN TT_IXT IXT  ON TIT.CODFIL  = IXT.CODFIL AND TIT.SEQUEN = IXT.SEQTIT
                  inner join td_fil Dfil on Dfil.codfil = TIT.codfil
                  INNER JOIN TD_BCO DBCO ON TIT.CODBCO  = DBCO.CBANCO
                  INNER JOIN TT_MUN MUN  ON MUN.CODIGO  = DFIL.CODCID
                  LEFT  JOIN TT_CTBXCCB BXC ON TIT.CODBCO = BXC.CODBCO
                                           AND TIT.NUMAGE = BXC.NUMAGE
                                           AND TIT.CTACRR = BXC.CTACRR
                                           AND TIT.CODCCB = BXC.CODCCB
  WHERE VEN.FILCOB IS NOT NULL
    AND VEN.ENDCOB IS NOT NULL
    and ven.flgest = 'A'
    and ven.codser= 'CC' 
    and ven.tipnot= 'F'
    AND IXT.DATENV IS NULL
    AND TIT.FLGEST <> 'I'
 GROUP BY TIT.CODBCO, TIT.NUMAGE, TIT.CTACRR, TIT.CODFIL, IXT.REMBCO, IXT.INSTR1, IXT.INSTR2
 ;


/*-- SEQ 2335 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IXT_SGD_BESC CASCADE;

/*-- SEQ 2336 --*/
CREATE OR REPLACE VIEW TV_IXT_SGD_BESC AS
-- View para a Cobrana BESC
-- Cria linhas segmento Detalhe iniciando na coluna 0 da linha desejada
SELECT TIT.CODBCO AS CODBCO,
       TIT.NUMAGE AS NUMAGE,
       TIT.CTACRR AS CTACRR,
       TIT.CODFIL AS CODFIL,
       IXT.REMBCO AS REMBCO,
       IXT.INSTR1 AS INSTR1,
       IXT.INSTR2 AS INSTR2,
       CAST('3' AS VARCHAR(1)) AS TIPREG,
--       IXT.SEQUEN AS REGIST,
       CAST('0' AS VARCHAR(1))        AS REGIST,
       CAST('|*#*|'AS VARCHAR(5)) AS NUMREG,
       CAST('P' AS VARCHAR(1)) AS SEGREG,
       TO_ASCII (LPAD(COALESCE(TRIM(TIT.CODBCO),'0'),3,'0')       -- Cdigo do Banco
                 || LPAD(COALESCE(TRIM('|L#|'),'0'),4,'0')           -- Cdigo do Lote
                 || '3'                                         -- Tipo de Registro (3=Detalhe)
--servio
		 || LPAD('|*#*|',5,'0')                         -- N. do registro
                 || 'A'                                         -- Segmento A
                 || '0'                                         -- Tipo de movimento (0= inclusao lancamento  5= alteracao de lancamento ja enviado
		 || '00'				        -- Cdigo do movimento (00= inclusao lancamento)
--favorecido CLIENTE FARMACIA
                 || '000'							-- Cdigo da camara compensao do destinatario ('000' qdo banco for BESC)
                 || LPAD(COALESCE(MIN(TRIM(CBP.CODBCO)),'0'), 3,'0')		-- Cdigo banco do favorecido
		 || LPAD(COALESCE(MIN(TRIM(CBP.NUMAGE)),'0'), 5,'0')		-- Nmero da agncia - agencia mantenedora da conta
		 || RPAD(COALESCE(MIN(TRIM(CBP.DIGAGE)),' '), 1,' ')		-- Dgito verificador da Agncia
		 || LPAD(COALESCE(MIN(TRIM(CBP.CTACRR)),'0'),12,'0')                -- Nmero da conta corrente
                 || RPAD(COALESCE(MIN(TRIM(CBP.DIGCRR)),' '), 1,' ')		-- Digito verificador da conta corrente
                 || RPAD(COALESCE(MIN(TRIM(CBP.DIGCRR)),' '), 1,' ')		-- Dgito verificador da conta e agncia ( O MESMO DA CONTA CORRENTE)
                 || RPAD(COALESCE(MIN(TRIM(CLI.NOMCLI)||' '||TRIM(coalesce(CLI.ULTNOM,''))),' '),30,' ')-- Nome do favorecido
--Debito
                 || RPAD(COALESCE(MIN(TRIM(TIT.NOSNUM)),' '),20,' ')			-- Nosso Nmero gerado pela empresa
--ou             || RPAD(COALESCE(MIN(TRIM(VEN.CODSER)),' '),02,' ')||LPAD(MIN(VEN.NUMNOT),6,' ') -- Nmero do documento
		 || TO_CHAR(MIN(REC.DATVEN),'DDMMYYYY')				-- Data prevista para o lanamento  (VENCIMENTO)
		 || 'BRL'                                                       -- Tipo moeda corrente atual no Brasil
		 || LPAD('0',15,'0')						-- opcional (quantidade de moeda)
		 || REPLACE(REPLACE(COALESCE(LPAD(TO_CHAR(MIN(REC.VLRPAR),'FM9999999999999D00'),16,'0'),'000000000000000'),',',''),'.','')
		 || TO_CHAR(ADD_DAY(MIN(REC.DATVEN),MIN(CTB.AVISTA)),'DDMMYYYY')		-- Data validade do lanamento (VENCIMENTO + X DIAS)
		 || '1'                                                         -- Indicador de provisionamento (0= sem  1= com proviso)
		 || '00'                                                        -- cdigo finalidade para DOC ou TED (01= crdito em C/C ....)
		 || RPAD(' ',9,' ')						-- uso exclusivo BESC
		 || LPAD('0',8,'0')						-- Data  efetivacao do lanamento - uso BESC
		 || LPAD('0',15,'0')						-- Valor efetivacao do lanamento - uso BESC
		 || RPAD(' ',40,' ')						-- Mensagem
		 || RPAD(' ',12,' ')						-- FEBRABAN
		 || '0'								-- Flag aviso ao Favorecido
		 || RPAD(' ',10,' ')						-- Banco
               ) AS LINHA

  from tt_ven ven inner join tt_rec rec on ven.codfil = rec.codfil and ven.sequen = rec.sequen
                  inner join tt_tit tit on rec.codfil = tit.filrec and rec.sequen = tit.seqrec
                                       and rec.numpar = tit.parrec and rec.subpar = tit.subrec
                  INNER JOIN TT_CTB CTB ON TIT.NUMAGE = CTB.NUMAGE AND TIT.CODBCO = CTB.CODBCO AND TIT.CTACRR = CTB.CTACRR
                  INNER JOIN TT_IXT IXT ON TIT.CODFIL = IXT.CODFIL AND TIT.SEQUEN = IXT.SEQTIT
                  INNER JOIN TT_CCB CCB ON IXT.CODCCB = CCB.CODCCB AND IXT.CCBBCO = CCB.CARBCO AND TIT.CODBCO = CCB.CODBCO
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                  INNER JOIN TT_CBP CBP ON CBP.FILCLI = CLI.FILCLI AND CBP.CODCLI = CLI.CODCLI,
                             TT_CFG CFG
  WHERE VEN.FILCOB IS NOT NULL
    AND VEN.ENDCOB IS NOT NULL
    and ven.flgest = 'A'
    and ven.codser= 'CC'
    and ven.tipnot= 'F'
    AND IXT.DATENV IS NULL
    AND TIT.FLGEST <> 'I'
    AND REC.TIPCCC = CFG.TIPCCC_PMI
GROUP BY VEN.FILCLI, VEN.CODCLI, TIT.CODBCO, TIT.NUMAGE, TIT.CTACRR, TIT.CODFIL, IXT.REMBCO, IXT.INSTR1, IXT.INSTR2 
;


/*-- SEQ 2337 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IXT_SGP CASCADE;

/*-- SEQ 2338 --*/
CREATE OR REPLACE VIEW TV_IXT_SGP AS
-- View para o Integrador de CNAB
-- Cria linhas segmento "P" iniciando na coluna 0 da linha desejada
  SELECT TIT.CODBCO AS CODBCO,
       TIT.NUMAGE AS NUMAGE,
       TIT.CTACRR AS CTACRR,
       TIT.CODFIL AS CODFIL,
       IXT.REMBCO AS REMBCO,
       IXT.INSTR1 AS INSTR1,
       IXT.INSTR2 AS INSTR2,
       CAST('3' AS VARCHAR(1)) AS TIPREG,
       IXT.SEQUEN AS REGIST,
       CAST('|*#*|'AS VARCHAR(5)) AS NUMREG,
       CAST('P' AS VARCHAR(1)) AS SEGREG,
       TO_ASCII (LPAD(COALESCE(TRIM(TIT.CODBCO),'0'),3,'0')     -- Cdigo do Banco
                 || LPAD(COALESCE(TRIM('|L#|'),'0'),4,'0')      -- Cdigo do Lote
                 || '3'                                         -- Tipo de Registro (3=Detalhe)
                 || LPAD('|*#*|',5,'0')                         -- N. do registro
                 || 'P'                                         -- Segmento P
                 || RPAD(' ',1,' ')                             -- Uso exclusivo Febraban
                 || LPAD(COALESCE(TRIM(TO_CHAR(IXT.REMBCO)),'0'), 2,'0')      -- Cdigo do movimento de remessa
                 || CASE TIT.CODBCO WHEN '341' THEN '0' ELSE '' END                             -- Somente p/ Itau - complemento de registro
                 || CASE TIT.CODBCO WHEN '399' THEN LPAD(COALESCE(TRIM(TIT.NUMAGE),'0'), 5,'0')
                                    WHEN '341' THEN LPAD(COALESCE(TRIM(SUBSTR(TIT.NUMAGE,2,4)),'0'), 4,'0')
                                    WHEN '001' THEN LPAD(COALESCE(TRIM(TIT.NUMAGE),'0'), 5,'0') ELSE ''    END        -- Nmero da agncia - agencia mantenedora da conta
                    --WHEN '001' THEN LPAD('0', 5,'0') ELSE ''    END                    -- Nmero da agncia - agencia mantenedora da conta (BRASIL ,seleciona a cobradora a partir do CEP do sacado)
                 || CASE TIT.CODBCO WHEN '399' THEN LPAD(COALESCE(TRIM(CTB.DIGAGE),'0'), 1,' ')
                                    WHEN '001' THEN LPAD(COALESCE(TRIM(CTB.DIGAGE),'0'), 1,'0') ELSE '' END            -- Dgito verificador da Agncia
                    --WHEN '001' THEN LPAD('0', 1,'0') ELSE '' END            -- Dgito verificador da Agncia
                 || CASE TIT.CODBCO WHEN '001' THEN LPAD(COALESCE(TRIM(TIT.CTACRR),'0'),12,'0') ELSE ''END   -- Nmero da conta corrente
                 || CASE TIT.CODBCO WHEN '001' THEN LPAD(COALESCE(TRIM(CTB.DIGCRR),' '), 1,' ') ELSE '' END   -- Digito verificador da conta corrente
                 || CASE TIT.CODBCO WHEN '001' THEN LPAD(COALESCE(TRIM(CTB.DIGA_C),' '), 1,' ') ELSE '' END   -- Dgito verificador da conta e agncia
--                 || CASE TIT.CODBCO WHEN '001' THEN RPAD(COALESCE(TRIM(TIT.NOSNUM),' '),20,' ') ELSE '' END   -- Nosso Nmero (carteira 11-simples (brancos) , banco numera)
                 || CASE TIT.CODBCO WHEN '001' THEN
                         CASE CCB.ENVNOS WHEN 'T' -- envia nosso numero
                              THEN RPAD(COALESCE(TRIM(TIT.NOSNUM),' '),20,' ')
                              ELSE RPAD('0',20,'0')
                         END
                    ELSE '' END                                -- Nosso Nmero BRASIL - (carteira 11-simples (brancos) , banco numera, emite e expede)
                 || CASE TIT.CODBCO WHEN '001' THEN LPAD(COALESCE(TRIM(CCB.CARCCB),'0'), 1,'0') ELSE '' END   -- Cdigo da Carteira
                 || CASE TIT.CODBCO WHEN '001' THEN LPAD(COALESCE(TRIM(CCB.FRMCAD),'0') ,1,'0') ELSE '' END   -- Forma de Cadastramento do Ttulo no Banco
                 || CASE TIT.CODBCO WHEN '001' THEN LPAD(COALESCE(TRIM(CCB.TIPDOC),'0') ,1,'0') ELSE '' END   -- Tipo de documento
                 || CASE TIT.CODBCO WHEN '001' THEN LPAD(COALESCE(TRIM(CCB.EMIBLQ),'0') ,1,'0') ELSE '' END   -- Identificao da emisso do bloqueto
                 || CASE TIT.CODBCO WHEN '001' THEN LPAD(COALESCE(TRIM(CCB.DTRBLQ),'0') ,1,'0') ELSE '' END   -- Identificao da distribuicao
                 || CASE TIT.CODBCO WHEN '341' THEN LPAD(' ',1,' ') ELSE '' END                              -- Somente p/ Itau - complemento de registro
                 || CASE TIT.CODBCO WHEN '341' THEN LPAD('0',7,'0') ELSE '' END                              --Somente p/ Itau - complemento de registro
                 || CASE TIT.CODBCO WHEN '341' THEN LPAD(COALESCE(TRIM(SUBSTR(TIT.CTACRR,6,5)),'0'),5,'0') ELSE '' END  -- Nmero da conta corrente
                 || CASE TIT.CODBCO WHEN '341' THEN LPAD(' ',1,' ') ELSE '' END         -- Somente p/ Itau - complemento de registro
                 || CASE TIT.CODBCO WHEN '341' THEN LPAD(COALESCE(TRIM(CTB.DIGA_C),' '), 1,' ') ELSE '' END   -- digito de auto-conferncia ag./conta
                 || CASE TIT.CODBCO WHEN '341' THEN LPAD(COALESCE(TRIM(TO_cHAR(CCB.CARBCO)),'0'), 3,'0') ELSE '' END   -- CDIGO DA CARTEIRA NO BANCO
                 || CASE TIT.CODBCO WHEN '341' THEN LPAD(COALESCE(TRIM(TIT.NOSNUM),'0'), 9,'0') ELSE '' END   -- NOSSO NMERO
                 || CASE TIT.CODBCO WHEN '341' THEN LPAD(' ',8,' ') ELSE '' END                              -- Somente p/ Itau - complemento de registro
                 || CASE TIT.CODBCO WHEN '341' THEN LPAD('0',5,'0') ELSE '' END                              -- Somente p/ Itau - complemento de registro
                 || CASE TIT.CODBCO WHEN '399' THEN LPAD(COALESCE(TRIM(TIT.CTACRR),'0'),12,'0') ELSE '' END   -- Nmero da conta corrente
                 || CASE TIT.CODBCO WHEN '399' THEN LPAD(COALESCE(TRIM(CTB.DIGCRR),' '), 1,' ') ELSE '' END   -- Digito verificador da conta corrente
                 || CASE TIT.CODBCO WHEN '399' THEN LPAD(COALESCE(TRIM(CTB.DIGA_C),' '), 1,' ') ELSE '' END   -- Dgito verificador da conta e agncia
                 || CASE TIT.CODBCO WHEN '399' THEN RPAD(COALESCE(TRIM(TIT.NOSNUM),' '),20,' ') ELSE '' END   -- Nosso Nmero
                 || CASE TIT.CODBCO WHEN '399' THEN LPAD(COALESCE(TRIM(CCB.CARCCB),'0'), 1,'0') ELSE '' END   -- Cdigo da Carteira
                 || CASE TIT.CODBCO WHEN '399' THEN LPAD(COALESCE(TRIM(CCB.FRMCAD),'0') ,1,'0') ELSE '' END   -- Forma de Cadastramento do Ttulo no Banco
                 || CASE TIT.CODBCO WHEN '399' THEN LPAD(COALESCE(TRIM(CCB.TIPDOC),'0') ,1,'0') ELSE '' END   -- Tipo de documento
                 || CASE TIT.CODBCO WHEN '399' THEN LPAD(COALESCE(TRIM(CCB.EMIBLQ),'0') ,1,'0') ELSE '' END   -- Identificao da emisso do bloqueto
                 || CASE TIT.CODBCO WHEN '399' THEN LPAD(COALESCE(TRIM(CCB.DTRBLQ),'0') ,1,'0') ELSE '' END   -- Identificao da distribuicao
                 -- Depende do Banco
                 || RPAD(CASE TIT.CODBCO WHEN '341' THEN LPAD(VEN.CODSER,2,' ')||LPAD(VEN.NUMNOT,6,' ') -- 341 = ITA
                                         WHEN '399' THEN LPAD(VEN.CODSER,2,' ')||LPAD(VEN.NUMNOT,6,' ') -- 399 = HSBC
                                         WHEN '001' THEN LPAD(VEN.CODSER,2,' ')||LPAD(VEN.NUMNOT,6,' ') -- 001 = BRASIL
                                         ELSE LPAD(VEN.CODFIL,3,' ')||LPAD(VEN.NUMECF,3,' ')||LPAD(VEN.CODSER,2,' ')||LPAD(VEN.NUMNOT,6,' ')
                         END,15,' ')                                    -- Nmero do documento
                 --
                 || TO_CHAR(REC.DATVEN,'DDMMYYYY')                            -- Data do Vencimento
                 || REPLACE(REPLACE(COALESCE(LPAD(TO_CHAR(REC.VLRPAR,'FM9999999999999D00'),16,'0'),'000000000000000'),',',''),'.','')
--                 || REPLACE(LPAD(REC.VLRPAR * 100,15,'0'),'.','')                    -- Valor do Ttulo
                 || CASE TIT.CODBCO WHEN '399' THEN LPAD(' ', 5,' ')
                                    WHEN '341' THEN LPAD('0', 5,'0')
                                    WHEN '001' THEN LPAD('0', 5,'0')                        --informar zeros, pois o Banco seleciona a cobradora a partir do CEP do sacado BRASIL
                                    ELSE ''   END                                            -- Nmero da agncia COBRADORA
                 || CASE TIT.CODBCO WHEN '399' THEN LPAD(' ', 1,' ')
                                    WHEN '341' THEN LPAD(COALESCE(TRIM(CTB.DIGAGE),'0'),1,'0')
                                    WHEN '001' THEN RPAD('0',1,'0')                        --informar zeros, pois o Banco seleciona a cobradora a partir do CEP do sacado  BRASIL
                                    ELSE ''   END                                            -- Dgito verificador da Agncia COBRADORA
                 || LPAD(COALESCE(TRIM(TO_CHAR(IXT.ECBBCO)),'0'),2,'0')                        -- Espcie
                 || CASE TIT.CODBCO WHEN '341' THEN CASE TRIM(TIT.ACEITE) WHEN 'F' THEN 'N' ELSE 'A' END
                                    WHEN '001' THEN CASE TRIM(TIT.ACEITE) WHEN 'F' THEN 'N' ELSE 'A' END
                                    ELSE LPAD(COALESCE(TRIM(TIT.ACEITE),'N'),1,' ')
                    END                                            -- Aceito/No Aceito ITA
                 || TO_CHAR(VEN.DATHOR,'DDMMYYYY')                            -- Data de emisso
                 -- por banco
                 || CASE to_char(TIT.CODBCO) WHEN '399' THEN LPAD(to_char(NVLZ(TIT.CODMOR,'3')),1,'0')
                                             WHEN '001' THEN LPAD(to_char(NVLZ(TIT.CODMOR,'3')),1,'0')
                                             ELSE '' END                                            -- cdigo do juros de mora
                 || CASE TIT.CODBCO WHEN '341' THEN LPAD('0',1,'0') ELSE '' END                    -- Somente p/ Itau - complemento de registro
                 || LPAD(COALESCE(TO_CHAR(DATMOR,'DDMMYYYY'),'0'),8,'0')                -- Data de incio do juros de mora
                 || REPLACE(REPLACE(LPAD(TO_CHAR(CASE WHEN COALESCE(TIT.JURMOR,0) < 0 THEN 0 ELSE COALESCE(TIT.JURMOR,0) END,'FM9999999999999D00'),16,'0'),',',''),'.','')
--               || REPLACE(LPAD(COALESCE(TIT.JURMOR,0) * 100,15,'0'),'.','')                        -- Juros de Mora / Dia/mes
                 -- por banco
                 || LPAD(CASE TIT.CODBCO WHEN '399' THEN CASE COALESCE(trim(to_char(TIT.CODDES)),'0') WHEN '1' THEN '1'
                                                                                                      WHEN '2' THEN '2'
                                                                                                      WHEN '3' THEN '3'
                                                                                                      ELSE COALESCE(TRIM(to_char(TIT.CODDES)),'0')
                                                         END
                                         WHEN '001' THEN CASE COALESCE(trim(to_char(TIT.CODDES)),'0') WHEN '1' THEN '1'
                                                                                                      WHEN '2' THEN '2'
                                                                                                      WHEN '3' THEN '3'
                                                                                                      WHEN '4' THEN '4'
                                                                                                      WHEN '5' THEN '5'
                                                                                                      WHEN '6' THEN '6'
                                                                                                      ELSE COALESCE(TRIM(to_char(TIT.CODDES)),'0')
                                                         END
                        ELSE ''   END,1,'0')                                    -- Tipo de Desconto
                 --|| CASE TIT.CODBCO WHEN '341' THEN ' ' ELSE '' END                    -- Somente p/ Itau - complemento de registro
                 || LPAD(COALESCE(TO_CHAR(TIT.DATDES,'DDMMYYYY'),'0'),8,'0')                -- Data de fim do desconto
                 || REPLACE(REPLACE(LPAD(TO_CHAR(CASE WHEN COALESCE(TIT.JURDES,0) < 0 THEN 0 ELSE COALESCE(TIT.JURDES,0) END,'FM9999999999999D00'),16,'0'),',',''),'.','')
--                 || LPAD(COALESCE(CAST (TRIM(TIT.JURDES) AS Numeric),0) * 100,15,'0')            -- Descontos
                 || LPAD('0',15,'0')                                    -- IOF a ser recolhido
                 || REPLACE(REPLACE(LPAD(TO_CHAR(CASE WHEN COALESCE(TIT.VLRABT,0) < 0 THEN 0 ELSE COALESCE(TIT.VLRABT,0) END,'FM9999999999999D00'),16,'0'),',',''),'.','')
--                 || LPAD(COALESCE(CAST (TRIM(TIT.VLRABT) AS Numeric),0) * 100,15,'0')            -- valor abatimento
                 || RPAD(TIT.CODFIL||'/'||TRIM(TIT.SEQUEN),25,' ')                    -- uso da empresa
                 -- por banco
                 || LPAD(CASE TIT.CODBCO WHEN '399' THEN CASE COALESCE(TRIM(to_char(TIT.CODPRT)),'0') WHEN '0' THEN '3'
                                                                                                      WHEN '1' THEN '4'
                                                                                                      WHEN '2' THEN '5'
                                                                                                      WHEN '3' THEN '3'
                                                                                                      ELSE COALESCE(TRIM(to_char(TIT.CODPRT)),'0')
                                                         END
                                         WHEN '001' THEN CASE COALESCE(TRIM(to_char(TIT.CODPRT)),'0')  WHEN '0' THEN '3'
                                                                                                       WHEN '1' THEN '1'
                                                                                                       WHEN '2' THEN '2'
                                                                                                       WHEN '3' THEN '3'
                                                                                                       ELSE COALESCE(TRIM(to_char(TIT.CODPRT)),'3')
                                                         END
                                        ELSE COALESCE(TRIM(to_char(TIT.CODPRT)),'0')
                         END,1,'0')                                     -- cod protesto
                 --
                 || LPAD(COALESCE(TRIM(to_char(TIT.PRZPRT)),'0'),2,'0')                         -- prazo protesto
                 -- por banco
                 || LPAD(CASE TIT.CODBCO WHEN '399' THEN CASE CAST (NVLZ(CAST (TRIM(to_char(TIT.CODBAI)) AS Numeric),2) AS CHAR)
                                                              WHEN '1' THEN '1'
                                                              WHEN '2' THEN '2'
                                                              ELSE '2'
                                                         END
                                         WHEN '001' THEN CASE CAST (NVLZ(CAST (TRIM(to_char(TIT.CODBAI)) AS Numeric),2) AS CHAR)
                                                              WHEN '1' THEN '1'
                                                              WHEN '2' THEN '2'
                                                              ELSE '0'
                                                         END
                                         ELSE COALESCE(TRIM(to_char(TIT.CODBAI)),'0')
                         END,1,'0')                                     -- Cdigo para baixa/devoluo
                 || CASE TIT.CODBCO WHEN '399' THEN LPAD(COALESCE(TRIM(to_char(TIT.PRZBAI)),'0'),3,'0')
                                    WHEN '001' THEN LPAD(COALESCE(TRIM(to_char(TIT.PRZBAI)),'0'),3,'0')
                                   ELSE '' END                                             -- Prazo para baixa/devoluo
                 || CASE TIT.CODBCO WHEN '341' THEN LPAD(COALESCE(TRIM(to_char(TIT.PRZBAI)),'0'),2,'0') ELSE '' END     -- Prazo para baixa/devoluo - Ita
                 || CASE TIT.CODBCO WHEN '341' THEN LPAD('0',13,'0') ELSE '' END                 -- Somente p/ Itau - complemento de registro
                 || CASE TIT.CODBCO WHEN '341' THEN LPAD(' ',1,' ') ELSE '' END                 -- Somente p/ Itau - complemento de registro
                 || CASE TIT.CODBCO WHEN '399' THEN LPAD(COALESCE(TRIM(to_char(IXT.MOEBCO)),'0'),2,'0')
                                    WHEN '001' THEN LPAD(COALESCE(TRIM(to_char(IXT.MOEBCO)),'0'),2,'0')
                                    ELSE '' END                                             -- Moeda
                 || CASE TIT.CODBCO WHEN '399' THEN LPAD('0',10,'0')
                                    WHEN '001' THEN LPAD('0',10,'0')
                                    ELSE '' END                                             -- Contrato. pode variar, pelo banco, agencia, empresa
                 || CASE TIT.CODBCO WHEN '399' THEN RPAD(' ',1,'0')
                                    WHEN '001' THEN RPAD(' ',1,'0')
                                    ELSE '' END                                             -- Uso Exclusivo Febraban
                ) AS LINHA
  FROM TT_TIT TIT INNER JOIN TT_REC REC ON TIT.FILREC = REC.CODFIL AND TIT.SEQREC = REC.SEQUEN AND TIT.PARREC = REC.NUMPAR AND TIT.SUBREC = REC.SUBPAR
                  INNER JOIN TT_CTB CTB ON TIT.NUMAGE = CTB.NUMAGE AND TIT.CODBCO = CTB.CODBCO AND TIT.CTACRR = CTB.CTACRR
                  INNER JOIN TT_IXT IXT ON TIT.CODFIL = IXT.CODFIL AND TIT.SEQUEN = IXT.SEQTIT
                  INNER JOIN TT_CCB CCB ON IXT.CODCCB = CCB.CODCCB AND IXT.CCBBCO = CCB.CARBCO AND TIT.CODBCO = CCB.CODBCO
                  INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
  WHERE VEN.FILCOB IS NOT NULL
    AND VEN.ENDCOB IS NOT NULL
    AND IXT.DATENV IS NULL
    AND TIT.FLGEST <> 'I'
  ;



/*-- SEQ 2339 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IXT_SGQ CASCADE;

/*-- SEQ 2340 --*/
CREATE OR REPLACE VIEW TV_IXT_SGQ AS
-- View para o Integrador de CNAB
-- Cria linhas segmento "Q" iniciando na coluna 0 da linha desejada
  SELECT TIT.CODBCO AS CODBCO,
       TIT.NUMAGE AS NUMAGE,
       TIT.CTACRR AS CTACRR,
       TIT.CODFIL AS CODFIL,
       IXT.REMBCO AS REMBCO,
       IXT.INSTR1 AS INSTR1,
       IXT.INSTR2 AS INSTR2,
       CAST('3' AS VARCHAR(1)) AS TIPREG,
       IXT.SEQUEN AS REGIST,
       CAST('|*#*|' AS VARCHAR(4)) AS NUMREG,
       CAST('Q' AS VARCHAR(1))     AS SEGREG,
       TO_ASCII(LPAD(COALESCE(TRIM(TIT.CODBCO),'0'),3,'0')               -- Cdigo do Banco
                || LPAD(COALESCE(TRIM('|L#|'),'0'),4,'0')                -- Cdigo do Lote
                || '3'                                              -- Tipo de Registro (3=Detalhe)
                || LPAD('|*#*|',5,'0')                              -- N. do registro
                || 'Q'                                              -- Segmento Q
                || RPAD(' ',1,' ')                                  -- Uso exclusivo Febraban
                || LPAD(COALESCE(TRIM(to_char(IXT.REMBCO)),'0'),2,'0')            -- Cdigo do movimento de remessa
                || CASE TIT.CODBCO WHEN '001' THEN CASE CLI.NUMDOC WHEN NULL THEN '0'
                                                                   ELSE CASE CLI.FLGTIP WHEN NULL THEN '0'
                                                                                        WHEN 0    THEN '1'
                                                                                        WHEN 1    THEN '2'
                                                                                        ELSE '9'
                                                                        END
                                                   END                            -- Tipo de documento
                                   ELSE CASE CLI.NUMDOC WHEN NULL THEN '0'
                                                        ELSE CASE CLI.FLGTIP WHEN 0 THEN '1'
                                                                             WHEN 1 THEN '2'
                                                                             ELSE '2'
                                                             END
                                        END
                   END
                || LPAD(COALESCE(TRIM(CLI.NUMDOC),''),15,'0')                                    -- CGC ou CPF do cliente
                || CASE TIT.CODBCO WHEN '341' THEN RPAD( CASE CLI.FLGTIP WHEN 0 THEN COALESCE(CLI.NOMCLI,'') || ' ' || COALESCE(CLI.ULTNOM,'')
                                                                         ELSE COALESCE(CLI.NOMCLI,'')
                                                         END,30,' ')
                   ELSE '' END                                                    -- Nome do cliente ITA
                || CASE TIT.CODBCO WHEN '341' THEN LPAD(' ',10,' ') ELSE '' END                            -- Somente p/ Itau - complemento de registro
                || CASE TIT.CODBCO WHEN '399' THEN RPAD( CASE CLI.FLGTIP WHEN 0 THEN COALESCE(CLI.NOMCLI,'') || ' ' || COALESCE(CLI.ULTNOM,'')
                                                                         ELSE COALESCE(CLI.NOMCLI,'')
                                                         END,40,' ')
                                   WHEN '001' THEN RPAD( CASE CLI.FLGTIP WHEN 0 THEN COALESCE(CLI.NOMCLI,'') || ' ' || COALESCE(CLI.ULTNOM,'')
                                                                         ELSE COALESCE(CLI.NOMCLI,'')
                                                         END,40,' ')
                   ELSE ''  END                                                    -- Nome do cliente
                || CASE TIT.CODBCO WHEN '001' THEN RPAD(COALESCE(TRIM(SUBSTR(ENDE.ENDERE,1,40-LENGTH(COALESCE(ENDE.NUMERO,'0'))+1)) ||','||COALESCE(ENDE.NUMERO,'')||COALESCE(TRIM(ENDE.COMPLE),'')||COALESCE(TRIM(ENDE.BAIRRO),''),' '),40,' ')  -- Endereo + numero + complemento + BAIRRO (o banco somente pega 37 posies)
                                   ELSE RPAD(COALESCE(TRIM(SUBSTR(ENDE.ENDERE,1,40-LENGTH(COALESCE(ENDE.NUMERO,'0'))+1)) ||','||COALESCE(ENDE.NUMERO,'')||COALESCE(ENDE.COMPLE,''),' '),40,' ')  -- Endereo + numero + complemento
                   END
                || CASE TIT.CODBCO WHEN '001' THEN RPAD(' ', 15, ' ')        -- Bairro
                                   ELSE RPAD(COALESCE(TRIM(ENDE.BAIRRO), ' '), 15, ' ')        -- Bairro
                   END
                || LPAD(COALESCE(TRIM(ENDE.CODCEP), '0'),  5, '0')        -- Cdigo do CEP
                || LPAD(COALESCE(TRIM(ENDE.CODLOG), '0'),  3, '0')        -- Sufixo do CEP
                || RPAD(COALESCE(TRIM(ENDE.NOMCID), ' '), 15, ' ')        -- Nome da Cidade
                || RPAD(COALESCE(TRIM(ENDE.SIGEST), ' '),  2, ' ')        -- Sigla do Estado
                || CASE TIT.CODBCO WHEN '341' THEN CASE CLI.NUMDOC WHEN NULL THEN '0'
                                                                   ELSE CASE CLI.FLGTIP WHEN 0 THEN '1'
                                                                                        WHEN 1 THEN '2'
                                                                                        ELSE '2'
                                                                        END
                                                   END
                                   WHEN '001' THEN LPAD('0', 1,'0')
                                   ELSE LPAD('0', 1,'0')
                   END                                            -- Tipo de documento do Sacador/avalista
                || LPAD('0',15,'0')                               -- nmero do documento do Sacador/avalista
                || RPAD(' ',40,' ')                                                -- nome do Sacador/Avalista
                || RPAD('0', 3,'0')                                 -- Banco correspondente
                || RPAD(' ',20,' ')                                 -- Nosso nmero do banco correspondente
                || RPAD(' ', 8,' ')                                 -- Uso exclusivo Febraban
               ) AS LINHA
  FROM TT_TIT TIT
        INNER JOIN TT_REC REC ON TIT.FILREC = REC.CODFIL AND TIT.SEQREC = REC.SEQUEN AND TIT.PARREC = REC.NUMPAR AND TIT.SUBREC = REC.SUBPAR
        INNER JOIN TT_IXT IXT ON TIT.CODFIL = IXT.CODFIL AND TIT.SEQUEN = IXT.SEQTIT
        INNER JOIN TT_VEN VEN ON TIT.FILREC = VEN.CODFIL AND TIT.SEQREC = VEN.SEQUEN
        INNER JOIN TT_CLI CLI ON VEN.FILCLI = CLI.FILCLI AND VEN.CODCLI = CLI.CODCLI
        INNER JOIN TT_END ENDE ON VEN.FILCLI = ENDE.FILCLI AND VEN.CODCLI = ENDE.CODCLI AND VEN.FILCOB = ENDE.CODFIL AND VEN.ENDCOB = ENDE.NUMEND
  WHERE VEN.FILCOB IS NOT NULL
    AND VEN.ENDCOB IS NOT NULL
    AND IXT.DATENV IS NULL
    AND TIT.FLGEST <> 'I'
 ;


/*-- SEQ 2341 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IXT_TAQ CASCADE;

/*-- SEQ 2342 --*/
CREATE OR REPLACE VIEW TV_IXT_TAQ AS
-- View para o Integrador de CNAB
-- Trailer de arquivo
  SELECT
    TIT.CODBCO      AS CODBCO,
    TIT.NUMAGE AS NUMAGE,
    TIT.CTACRR AS CTACRR,
    TIT.CODFIL      AS CODFIL,
    99999           AS REMBCO,
    TO_NUMBER(NULL)   AS INSTR1,
    TO_NUMBER(NULL)   AS INSTR2,
    TO_CHAR('9') AS TIPREG,
    TO_CHAR('0') AS REGIST,
    TO_CHAR('0') AS NUMREG,
    TO_CHAR(' ') AS SEGREG,
    TO_ASCII(LPAD(COALESCE(TRIM(TIT.CODBCO),'0'),3,'0')     -- Cdigo do Banco
    || LPAD('9',4,'9')                                 -- Sequenciador do Lote
    || '9'                                             -- tipo de registro (5 = trailer de lote)
    || Rpad(' ',9,' ')                                 -- Uso exclusivo Febraban
    || LPAD('|QL#T|',6,'0')                            -- Quantidade de Lotes
    || LPAD('|QT#D|',6,'0')                            -- Quantidade de Registros
    || LPAD('0',6,'0')                                 -- Quantidade de contas conciliadas (somente para conciliao bancria)
    || Rpad(' ',205,' ')                               -- Exclusivos CnAB
    ) -- FormASCII
    AS LINHA
   FROM TT_VEN VEN INNER JOIN TT_TIT TIT ON VEN.CODFIL = TIT.FILREC AND VEN.SEQUEN = TIT.SEQREC
                   INNER JOIN TT_IXT IXT ON TIT.CODFIL = IXT.CODFIL AND TIT.SEQUEN = IXT.SEQTIT
                   INNER JOIN TT_REC REC ON TIT.FILREC = REC.CODFIL AND TIT.SEQREC = REC.SEQUEN AND TIT.PARREC = REC.NUMPAR AND TIT.SUBREC = REC.SUBPAR
  WHERE VEN.FILCOB is not null
    AND VEN.ENDCOB is not null
    AND IXT.DATENV IS NULL
    AND TIT.FLGEST <> 'I'
  GROUP BY TIT.CODBCO, TIT.NUMAGE, TIT.CTACRR, TIT.CODFIL
;


/*-- SEQ 2343 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IXT_TAQ_BESC CASCADE;

/*-- SEQ 2344 --*/
CREATE OR REPLACE VIEW TV_IXT_TAQ_BESC AS
-- View para a Cobrana BESC
-- Trailer de arquivo
    SELECT
    TIT.CODBCO      AS CODBCO,
    TIT.NUMAGE AS NUMAGE,
    TIT.CTACRR AS CTACRR,
    TIT.CODFIL      AS CODFIL,
    99999           AS REMBCO,
    TO_NUMBER(NULL)   AS INSTR1,
    TO_NUMBER(NULL)   AS INSTR2,
    CAST('9' AS VARCHAR(1)) AS TIPREG,
    CAST('0' AS VARCHAR(1)) AS REGIST,
    CAST('0' AS VARCHAR(1)) AS NUMREG,
    CAST(' ' AS VARCHAR(1)) AS SEGREG,
    TO_ASCII(LPAD(COALESCE(TRIM(TIT.CODBCO),'0'),3,'0')     -- Cdigo do Banco
	  || LPAD('9',4,'9')                                 -- Sequenciador do Lote
	  || '9'                                             -- tipo de registro (9 = trailer de lote)
	  || Rpad(' ',9,' ')                                 -- Uso exclusivo Febraban
	  || LPAD('|QL#T|',6,'0')                            -- Quantidade de Lotes
	  || LPAD('|QT#D|',6,'0')                            -- Quantidade de Registros
	  || Lpad('0', 6,'0')                                -- Exclusivos CnAB
	  || Rpad(' ', 205,' ')                              -- Exclusivos CnAB
    ) 
    AS LINHA
  from tt_ven ven inner join tt_tit tit  ON VEN.CODFIL  = TIT.FILREC AND VEN.SEQUEN = TIT.SEQREC
                  INNER JOIN TT_IXT IXT  ON TIT.CODFIL  = IXT.CODFIL AND TIT.SEQUEN = IXT.SEQTIT
  WHERE VEN.FILCOB IS NOT NULL
    AND VEN.ENDCOB IS NOT NULL
    and ven.flgest = 'A'
    and ven.codser= 'CC' 
    and ven.tipnot= 'F'
    AND IXT.DATENV IS NULL
    AND TIT.FLGEST <> 'I'
  GROUP BY TIT.CODBCO, TIT.NUMAGE, TIT.CTACRR, TIT.CODFIL
;


/*-- SEQ 2345 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IXT_TLT CASCADE;

/*-- SEQ 2346 --*/
CREATE OR REPLACE VIEW TV_IXT_TLT AS
-- View para o Integrador de CNAB
-- Trailer de lote
  SELECT
    TIT.CODBCO AS CODBCO,
    TIT.NUMAGE AS NUMAGE,
    TIT.CTACRR AS CTACRR,
    TIT.CODFIL AS CODFIL,
    IXT.REMBCO AS REMBCO,
    IXT.INSTR1 AS INSTR1,
    IXT.INSTR2 AS INSTR2,
    CAST('5' AS VARCHAR(1)) AS TIPREG,
    CAST('0' AS VARCHAR(1)) AS REGIST,
    CAST('0' AS VARCHAR(1)) AS NUMREG,
    CAST(' ' AS VARCHAR(1)) AS SEGREG,
    TO_ASCII(LPAD(COALESCE(TRIM(TIT.CODBCO ),'0'),3,'0')    -- Cdigo do Banco
            || LPAD(COALESCE(TRIM(MIN('|L#|')),'0'),4,'0')   -- Sequenciador do Lote
            || '5'                                            -- tipo de registro (5 = trailer de lote)
            || Rpad(' ',9,' ')                                -- Uso exclusivo Febraban
            || LPAD('|QR#G|',6,'0')                           -- Quantidade de Registros
            || CASE TIT.CODBCO WHEN '001' THEN LPAD('0',6,'0')
                               WHEN '341' THEN LPAD('0',6,'0')
                               ELSE RPAD(' ',6,' ')
               END                                           -- Qtde. de ttulos em cobrana simples
            || CASE TIT.CODBCO WHEN '001' THEN LPAD('0', 86,'0')                              -- Campos somente de Retorno.
                               WHEN '341' THEN LPAD('0', 86,'0')
                               ELSE RPAD(' ', 86,' ')
                END
            || CASE TIT.CODBCO WHEN '341' THEN LPAD('0',8,'0')
                               ELSE RPAD(' ',8,' ')
                END                                           -- Numero do Aviso do Lancamento
            || Rpad(' ',117,' ')                              -- Uso exclusivo Febraban
            ) -- FormASCII
    AS LINHA
  FROM TT_TIT TIT INNER JOIN TT_REC REC ON TIT.FILREC = REC.CODFIL AND TIT.SEQREC = REC.SEQUEN AND TIT.PARREC = REC.NUMPAR AND TIT.SUBREC = REC.SUBPAR
                  INNER JOIN TT_VEN VEN ON VEN.CODFIL = TIT.FILREC AND VEN.SEQUEN = TIT.SEQREC
                  INNER JOIN TT_IXT IXT ON TIT.CODFIL = IXT.CODFIL AND TIT.SEQUEN = IXT.SEQTIT
  WHERE VEN.FILCOB is not null
    AND VEN.ENDCOB is not null
    AND IXT.DATENV IS NULL
    AND TIT.FLGEST <> 'I'
  GROUP BY TIT.CODBCO, TIT.NUMAGE, TIT.CTACRR, TIT.CODFIL, IXT.REMBCO, IXT.INSTR1, IXT.INSTR2
;


/*-- SEQ 2347 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IXT_TLT_BESC CASCADE;

/*-- SEQ 2348 --*/
CREATE OR REPLACE VIEW TV_IXT_TLT_BESC AS
-- View para a Cobrana BESC
-- Trailer de lote
    SELECT
    TIT.CODBCO AS CODBCO,
    TIT.NUMAGE AS NUMAGE,
    TIT.CTACRR AS CTACRR,
    TIT.CODFIL AS CODFIL,
    IXT.REMBCO AS REMBCO,
    IXT.INSTR1 AS INSTR1,
    IXT.INSTR2 AS INSTR2,
    CAST('5' AS VARCHAR(1)) AS TIPREG,
    CAST('0' AS VARCHAR(1)) AS REGIST,
    CAST('0' AS VARCHAR(1)) AS NUMREG,
    CAST(' ' AS VARCHAR(1)) AS SEGREG,
    TO_ASCII(LPAD(COALESCE(TRIM(TIT.CODBCO ),'0'),3,'0')    -- Cdigo do Banco
	  || LPAD(COALESCE(TRIM(MIN('|L#|')),'0'),4,'0')   -- Sequenciador do Lote
	  || '5'                                            -- tipo de registro (5 = trailer de lote)
	  || Rpad(' ',9,' ')                                -- Uso exclusivo Febraban
	  || LPAD('|QR#G|',6,'0')                           -- Quantidade de Registros
	  || LPAD('||ST#V||',18,'0')                           -- Somatorio de valores de todos os lanamentos
	  || LPAD('0',18,'0')                           -- Somatorio de quantidade de moedas
	  || Rpad(' ',171,' ')                               -- Exclusivos CnAB
	  || Rpad(' ', 10,' ')                               -- Exclusivos CnAB
    ) -- FormASCII
    AS LINHA
  from tt_ven ven inner join tt_tit tit  ON VEN.CODFIL  = TIT.FILREC AND VEN.SEQUEN = TIT.SEQREC
                  INNER JOIN TT_IXT IXT  ON TIT.CODFIL  = IXT.CODFIL AND TIT.SEQUEN = IXT.SEQTIT
  WHERE VEN.FILCOB IS NOT NULL
    AND VEN.ENDCOB IS NOT NULL
    and ven.flgest = 'A'
    and ven.codser= 'CC' 
    and ven.tipnot= 'F'
    AND IXT.DATENV IS NULL
    AND TIT.FLGEST <> 'I'
  GROUP BY TIT.CODBCO, TIT.NUMAGE, TIT.CTACRR, TIT.CODFIL, IXT.REMBCO, IXT.INSTR1, IXT.INSTR2
;


/*-- SEQ 2349 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_LID_OPE CASCADE;

/*-- SEQ 2350 --*/
CREATE OR REPLACE VIEW TV_LID_OPE AS
SELECT LID.CODFIL,
       LID.NUMECF,
       LID.DATHOR,
       LID.DATFIS,
       OPE.TRN_ID,
       OPE.FILUSU,
       OPE.CODUSU,
       LID.TIPDOC,
       LID.CUPFIS,
       LID.CONCOO,
       LID.CONCCF,
       /* Pedro E. Braga - Pega GNF do CDC quando Venda TEF */
       --CAST(CASE WHEN (((OPE.FILREC IS NOT NULL) AND (REC.CARTAO IS NOT NULL)) OR
       --                (OPE.FILTEF IS NOT NULL) OR (OPE.CARTAO IS NOT NULL)) AND
       --               ((LID.CONGNF IS NULL) OR (LID.CONGNF = 0))
       --    THEN (SELECT PLID.CONGNF
       --            FROM TT_LID PLID
       --           WHERE PLID.CODFIL = LID.CODFIL
       --             AND PLID.NUMECF = LID.NUMECF
       --             AND PLID.TRN_ID = LID.TRN_ID+1 )
       --            ELSE LID.CONGNF
       --            END AS Numeric) AS CONGNF,
       LID.CONGNF,
       REC.CARTAO AS REC_CARTAO,
       CAST(SUBSTR(CASE WHEN OPE.FILREC IS NOT NULL THEN CASE WHEN DEV.FILREC IS NOT NULL THEN 'Devolvido' --'DEVOLUCAO'
                                                              WHEN LEX.FILREC IS NOT NULL THEN 'Outros' --'DEPOSITO'
                                                         ELSE CASE WHEN REC.SEQCHE IS NULL THEN
                                                                   CASE WHEN REC.CARTAO IS NULL THEN
                                                                        CASE WHEN CCC.SEQUEN IS NULL THEN
                                                                             CASE WHEN BON.FILREC IS NULL THEN
                                                                                  CASE WHEN DOUT.DESCAR IS NULL THEN
                                                                                       'Dinheiro'
                                                                                  ELSE UPPER(DOUT.DESCAR)
                                                                                  END
                                                                             ELSE 'Outros' --'BONUS'
                                                                             END
                                                                        ELSE 'C/C'
                                                                        END
                                                                   ELSE CASE WHEN COALESCE(TEF.MANUAL,'X') = 'F'
                                                           THEN 'TEF'
                                                           ELSE 'Cartao'
                                                         END
                                                                   END
                                                              ELSE 'Cheque'
                                                              END
                                                         END
                        WHEN OPE.FILCCC IS NOT NULL THEN 'C/C'
                        WHEN OPE.FILCHR IS NOT NULL THEN 'Cheque'
                        WHEN OPE.FILFIN IS NOT NULL THEN 'Dinheiro'
                        WHEN OPE.FILTEF IS NOT NULL THEN CASE WHEN COALESCE(TEF.MANUAL,'X') = 'F'
                                                              THEN 'TEF'
                                                              ELSE 'Cartao'
                                                         END
                        WHEN OPE.CARTAO IS NOT NULL THEN 'Cartao'
                        WHEN OPE.OUTROS IS NOT NULL THEN 'Outros' --(SELECT UPPER(OUT.DESCAR)
                                                                  --   FROM TD_OUT OUT
                                                                  --  WHERE OUT.CODTAB = OPE.OUTROS)
                        WHEN OPE.CAMBIO IS NOT NULL THEN CASE WHEN MOE.CODTAB = 0 THEN 'Dinheiro'
                                                                                  ELSE 'Cambio'
                                                         END
                        WHEN OPE.FILDOP IS NOT NULL THEN 'Cheque' --'CHEQUE TROCO'
                        WHEN OPE.DOCTRO IS NOT NULL THEN 'Cheque' --'CHEQUE TROCO NAO CADASTRADO'
                   ELSE 'Outros'
                   END,1,15) AS VARCHAR(15)) AS MEIO_PAGAMENTO,
       COALESCE(OPE.VLROPE,0) AS VLROPE,
       LID.TIPOPE,
       LID.CODSER,
       CAST(COALESCE(VEN.FLGEST,'A') AS VARCHAR(1)) AS FLGEST,
       LID.CODFIL AS LID_CODFIL,
       LID.NUMECF AS LID_NUMECF,
       LID.TRN_ID AS LID_TRN_ID,
       LID.CONCCF AS LID_CONCCF,
       LID.CONCOO AS LID_CONCOO,
       LID.CONGNF AS LID_CONGNF,
       LID.CONCDC AS LID_CONCDC,
       LID.CONGRG AS LID_CONGRG,
       LID.TIPDOC AS LID_TIPDOC,
       LID.DATHOR AS LID_DATHOR,
       LID.CODUID AS LID_CODUID,
       LID.ASSINA AS LID_ASSINA,
       LID.DATFIS AS LID_DATFIS,
       OPE.CODFIL AS OPE_CODFIL,
       OPE.NUMECF AS OPE_NUMECF,
       OPE.TRN_ID AS OPE_TRN_ID,
       OPE.VLROPE AS OPE_VLROPE,
       OPE.FILREC AS OPE_FILREC,
       OPE.SEQREC AS OPE_SEQREC,
       OPE.FILCCC AS OPE_FILCCC,
       OPE.SEQCCC AS OPE_SEQCCC,
       OPE.FILCHR AS OPE_FILCHR,
       OPE.SEQCHR AS OPE_SEQCHR,
       OPE.FILFIN AS OPE_FILFIN,
       OPE.SEQFIN AS OPE_SEQFIN,
       OPE.FILTEF AS OPE_FILTEF,
       OPE.SEQTEF AS OPE_SEQTEF,
       OPE.CARTAO AS OPE_CARTAO,
       OPE.OUTROS AS OPE_OUTROS,
       OPE.CAMBIO AS OPE_CAMBIO,
       OPE.FILDOP AS OPE_FILDOP,
       OPE.SEQDOP AS OPE_SEQDOP,
       OPE.DOCTRO AS OPE_DOCTRO,
       OPE.FILUSU AS OPE_FILUSU,
       OPE.CODUSU AS OPE_CODUSU,
       OPE.CODUID AS OPE_CODUID,
       OPE.ASSINA AS OPE_ASSINA,
       VEN.CODFIL AS VEN_CODFIL,
       VEN.SEQUEN AS VEN_SEQUEN,
       VEN.NUMECF AS VEN_NUMECF,
       VEN.CODSER AS VEN_CODSER,
       VEN.NUMNOT AS VEN_NUMNOT,
       VEN.CNT_RO AS VEN_CNT_RO,
       VEN.VLRLIQ AS VEN_VLRLIQ,
       VEN.FLGEST AS VEN_FLGEST,
       VEN.SEREXT AS VEN_SEREXT,
       VEN.MODNOT AS VEN_MODNOT,
       VEN.CHAVEA AS VEN_CHAVEA,
       VEN.FILUSU AS VEN_FILUSU,
       VEN.CODUSU AS VEN_CODUSU,
       VEN.VLRNOT AS VEN_VLRNOT,
       VEN.DOCNFP AS VEN_DOCNFP,
       VEN.DATHOR AS VEN_DATHOR,
       VEN.NOTMAN AS VEN_NOTMAN,
       VEN.CODUID AS VEN_CODUID,
       VEN.ASSINA AS VEN_ASSINA,
       REC.CODFIL AS REC_CODFIL,
       REC.SEQUEN AS REC_SEQUEN,
       REC.NUMPAR AS REC_NUMPAR,
       REC.SUBPAR AS REC_SUBPAR
  FROM TT_LID LID LEFT JOIN TT_OPE OPE ON OPE.CODFIL = LID.CODFIL
                                      AND OPE.NUMECF = LID.NUMECF
                                      AND OPE.TRN_ID = LID.TRN_ID
                  LEFT JOIN TT_REC REC ON REC.CODFIL = OPE.FILREC
                                      AND REC.SEQUEN = OPE.SEQREC
                                      AND REC.NUMPAR = OPE.NUMPAR
                                      AND REC.SUBPAR = OPE.SUBPAR
                  LEFT JOIN TT_BON BON ON BON.FILREC = REC.CODFIL
                                      AND BON.SEQREC = REC.SEQUEN
                                      AND BON.NUMPAR = REC.NUMPAR
                                      AND BON.SUBPAR = REC.SUBPAR
                  LEFT JOIN TT_CCC CCC ON CCC.CODFIL = REC.FILCCC
                                      AND CCC.SEQUEN = REC.SEQCCC
                  LEFT JOIN TT_DEVxREC DEV ON DEV.FILREC = REC.CODFIL
                                          AND DEV.SEQREC = REC.SEQUEN
                                          AND DEV.PARREC = REC.NUMPAR
                                          AND DEV.SUBREC = REC.SUBPAR
                  LEFT JOIN TT_LEX LEX  ON LEX.FILREC = REC.CODFIL
                                       AND LEX.SEQREC = REC.SEQUEN
                                       AND LEX.NUMPAR = REC.NUMPAR
                                       AND LEX.SUBPAR = REC.SUBPAR
                  LEFT JOIN TD_OUT DOUT ON DOUT.CODTAB = REC.CODOUT
                  LEFT JOIN TT_TEF TEF ON TEF.CODFIL = OPE.FILTEF
                                      AND TEF.SEQUEN = OPE.SEQTEF
                  LEFT JOIN TD_MOE MOE ON MOE.CODTAB = OPE.CAMBIO
                  LEFT JOIN TT_VEN VEN ON VEN.CODFIL = LID.CODFIL
                                      AND VEN.NUMECF = LID.NUMECF
                                      AND VEN.CODSER = LID.CODSER
                                      AND VEN.NUMNOT = LID.CUPFIS
                                      --AND VEN.CNT_RO = 0 --Coluna faz parte da AK da venda mas  enviada sempre como 0 pelo checkout
                                      AND LID.TIPOPE = 'VEN' 
 WHERE ((OPE.FILREC IS NULL AND OPE.FILFIN IS NULL) OR OPE.CODFIL IS NULL)
   AND ((LID.TIPOPE = 'GRAVASLDCC' AND OPE.FILCCC IS NULL) OR LID.TIPOPE <> 'GRAVASLDCC' OR OPE.MEIPGT IS NOT NULL) -- RFMP 79317
   AND LID.TIPDOC IS NOT NULL
   AND (OPE.MEIPGT IS NULL OR OPE.MEIPGT = 'T')
;


/*-- SEQ 2351 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_LIM_CLI CASCADE;

/*-- SEQ 2352 --*/
CREATE OR REPLACE VIEW TV_LIM_CLI AS
SELECT LIM.FILCLI,
       LIM.CODCLI,
       CLI.NUMDOC,
       CLI.NOMCLI,
       DCCC.DESCCC,
       LIM.LIMCCC,
       LIM.VSALDO,
       PLA.APEPGT AS PLANO,
       LIM.CARENC,
       LIM.DESCON,
       COB.DESCOB AS PORTAD,
       LIM.OBSERV,
       ProximoFaturamento( LIM.FILCLI, LIM.CODCLI, LIM.TIPCCC, AGORA()) AS PROFAT
FROM TT_LIM LIM INNER JOIN TT_CLI CLI ON LIM.FILCLI = CLI.FILCLI AND LIM.CODCLI = CLI.CODCLI
                INNER JOIN TT_PLA PLA ON LIM.FILPGT = PLA.FILPGT AND LIM.CODPGT = PLA.CODPGT
                INNER JOIN TD_COB COB ON LIM.CODCOB = COB.CODTAB
                INNER JOIN TD_CCC DCCC ON DCCC.CODTAB = LIM.TIPCCC
 ;






/*-- SEQ 2353 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_LIS_SAL CASCADE;

/*-- SEQ 2354 --*/
CREATE OR REPLACE VIEW TV_LIS_SAL AS
SELECT ILI.CODFIL,
       ILI.SEQUEN,
       ILI.NUMITE,
       ILI.CODEXT,
       ILI.FILMAT,
       ILI.CODMAT,
       ILI.CODCOR,
       ILI.CODTAM,
       ILI.QTDITE,
       ILI.QTDRES,
       ILI.SITMOV,
       COALESCE(SUM(IOR.QTDITE),0) AS QTDITE_IOR,
       COALESCE(SUM(IVE.QTDMOV),0) AS QTDMOV_VENDIDA,
       COALESCE(SUM(IVEDEV.QTDMOV),0) AS QTDMOV_DEVOLVIDA,
       (ILI.QTDITE-(ILI.QTDRES + COALESCE(SUM(IOR.QTDITE),0) + COALESCE(SUM(IVE.QTDMOV),0) + COALESCE(SUM(IVEDEV.QTDMOV),0))) AS SALDO
  FROM TT_ILI ILI LEFT JOIN (SELECT T1.*
                               FROM TT_IOR T1 INNER JOIN TT_ORC ORC ON ORC.CODFIL = T1.CODFIL
                                                                   AND ORC.TIPPED = T1.TIPPED
                                                                   AND ORC.NUMPED = T1.NUMPED
                              WHERE ORC.FLGECO IS NOT NULL
                                AND T1.FLGEST = 'A'
                              ) IOR ON ILI.CODFIL = IOR.FILILI
                                   AND ILI.SEQUEN = IOR.SEQILI
                                   AND ILI.NUMITE = IOR.NUMILI
                  LEFT JOIN TT_IOR IORVEN ON ILI.CODFIL = IORVEN.FILILI
                                         AND ILI.SEQUEN = IORVEN.SEQILI
                                         AND ILI.NUMITE = IORVEN.NUMILI
                                         AND IORVEN.FLGEST = 'E'
                  LEFT JOIN TT_IVE IVE ON IORVEN.CODFIL = IVE.CODFIL
                                      AND IORVEN.SEQIVE = IVE.SEQUEN
                                      AND IORVEN.NUMITE = IVE.NUMITE
                                      AND IVE.LANEST IN ('S','R')
                                      AND IVE.SITMOV <> 'C'
                  LEFT JOIN TT_IVE IVEDEV ON IVEDEV.FILORI = IVE.CODFIL
                                         AND IVEDEV.NUMORI = IVE.SEQUEN
                                         AND IVEDEV.ITEORI = IVE.NUMITE
                                         AND IVEDEV.LANEST IN ('S','R')
                                         AND IVEDEV.SITMOV <> 'C'
                                         AND IVEDEV.QTDMOV < 0
GROUP BY ILI.CODFIL, ILI.SEQUEN, ILI.NUMITE, ILI.CODEXT, ILI.FILMAT, ILI.CODMAT, ILI.CODCOR, ILI.CODTAM, ILI.QTDITE, ILI.QTDRES, ILI.SITMOV
;


/*-- SEQ 2355 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_LIT CASCADE;

/*-- SEQ 2356 --*/
CREATE OR REPLACE VIEW TV_LIT AS
SELECT cli.FILCLI,
       cli.CODCLI,
       CLI.NUMDOC,
       IVE.QTDMOV AS QTDLIT,
       VEN.DATHOR
  FROM TT_CLI CLI INNER JOIN TT_VEN VEN ON VEN.FILCLI = CLI.FILCLI AND VEN.CODCLI = CLI.CODCLI
                  INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN
                  INNER JOIN TT_PRO PRO ON PRO.FILMAT = IVE.FILMAT AND PRO.CODMAT = IVE.CODMAT
                  INNER JOIN TD_CL1 CL1 ON PRO.CLASS1 = CL1.CODTAB
WHERE CL1.COMBUS = 'T'
  AND VEN.FLGEST <> 'C'
  AND VEN.CODSER in ('CF', 'TK')
  AND IVE.SITMOV <> 'C'
 ;




/*-- SEQ 2357 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_LMC_COM CASCADE;

/*-- SEQ 2358 --*/
CREATE OR REPLACE VIEW TV_LMC_COM AS
select COM.CODFIL||'-'||COALESCE(COM.CODSER,'')||'-'||COALESCE(COM.SUBSER,'')||'/'||TRIM(COM.NUMNOT) AS DOCUME,
       ICO.CODFIL,
       ICO.SEQUEN,
       ICO.NUMITE,
       COM.FILFOR,COM.CODFOR,COM.NUMNOT,
       ICO.COM_DATOPE AS DATOPE,
       TAN.TANQUE,DES.QTDLTS - COALESCE(IVE.QTDMOV, 0) AS QTDLTS,
       ICO.FILMAT,ICO.CODMAT,ICO.CODCOR,ICO.CODTAM
  from tt_des DES INNER JOIN TT_ICO ICO ON DES.FILICO=ICO.CODFIL AND DES.SEQICO=ICO.SEQUEN AND DES.NUMICO=ICO.NUMITE              
                  INNER JOIN TT_COM COM ON COM.CODFIL=ICO.CODFIL AND COM.SEQUEN=ICO.SEQUEN
                  INNER JOIN TD_TAN TAN ON DES.CODTAN=TAN.CODTAB
				   LEFT JOIN TT_IVE IVE ON IVE.FILICOORI = ICO.CODFIL
                                       AND IVE.SEQICOORI = ICO.SEQUEN
                                       AND IVE.NUMICOORI = ICO.NUMITE
 where ico.sitmov <> 'C'
 ;


/*-- SEQ 2359 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_LMC_MDT CASCADE;

/*-- SEQ 2360 --*/
CREATE OR REPLACE VIEW TV_LMC_MDT AS
select MDT.CODFIL,
       MDT.DATMED,
       MDT.DATLEI,
       MDT.DATREG,       
       MDT.QTDLTS,
       TAN.TANQUE,
       TAN.FILTAN,
       TAN.GRAFIL AS FILMAT,
       TAN.GRACOD AS CODMAT,
       TAN.GRACOR AS CODCOR,
       TAN.GRATAM AS CODTAM,
       LEI.APEUSU AS APELEI,
       LEI.NOMUSU AS NOMLEI,
       REG.APEUSU AS APEREG,
       REG.NOMUSU AS NOMREG            
from TT_MDT MDT INNER JOIN TD_TAN TAN ON MDT.CODFIL = TAN.FILTAN AND MDT.NUMTAN = TAN.TANQUE
                INNER JOIN TT_USU LEI ON MDT.FILLEI = LEI.FILUSU AND MDT.CODLEI = LEI.CODUSU
                INNER JOIN TT_USU REG ON MDT.FILREG = REG.FILUSU AND MDT.CODREG = REG.CODUSU
 ;


/*-- SEQ 2361 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_LMC_VEN CASCADE;

/*-- SEQ 2362 --*/
CREATE OR REPLACE VIEW TV_LMC_VEN AS
SELECT TAB2.*,
       CASE TAB2.QTDMOV WHEN 0 THEN 0
            ELSE ValorLMCVenda(cast(TAB2.PREBOM*TAB2.QTDMOV as Numeric),TAB2.DATMED,TAB2.FILBIC,TAB2.SEQFIL,TAB2.FILMAT,TAB2.CODMAT,TAB2.CODCOR,TAB2.CODTAM,TAB2.CODBIC,TAB2.ENCABE,TAB2.ENCFEC) 
       END AS VLRMOV,
       QuantidadeLMCVenda(TAB2.DATMED, TAB2.FILBIC, TAB2.SEQFIL, 
                          TAB2.FILMAT, TAB2.CODMAT, TAB2.CODCOR, 
                          TAB2.CODTAM, TAB2.ENCABE, TAB2.ENCFEC) AS QTDMOVVEN
FROM (select TAB.*,
             CASE WHEN ENCABE<=ENCFEC THEN ENCFEC
                  WHEN ENCABE>ENCFEC  THEN ENCFEC + power(10, length(trim(to_char(trunc(encabe),'9999999999999999'))))
             END-ENCABE-
             COALESCE((SELECT ABS(SUM(AFE.ENCFIM-AFE.ENCINI))
                         FROM TT_AFE AFE
                        WHERE AFE.CODBIC = TAB.CODBIC      
                          AND AFE.DATAFE = TAB.DATMED),0) AS QTDMOV
        from (select MDT.CODFIL,
                     MDT.NUMTAN,
                     MDT.DATMED,
                     COALESCE(Encerrante(MDT.CODFIL,MDT.NUMTAN,MDT.DATMED,BIC.CODTAB,'T'),
                              Encerrante(MDT.CODFIL,MDT.NUMTAN,add_day(MDT.DATMED,-1),BIC.CODTAB)) AS ENCABE,
                     Encerrante(MDT.CODFIL,MDT.NUMTAN,MDT.DATMED,BIC.CODTAB) AS ENCFEC,
                     EncerranteManual(MDT.CODFIL,MDT.NUMTAN,add_day(MDT.DATMED,-1),BIC.CODTAB) AS ENCABEMAN,
                     EncerranteManual(MDT.CODFIL,MDT.NUMTAN,MDT.DATMED,BIC.CODTAB) AS ENCFECMAN,
                     TAN.TANQUE,
                     TAN.FILTAN,
                     TAN.GRAFIL AS FILMAT,
                     TAN.GRACOD AS CODMAT,
                     TAN.GRACOR AS CODCOR,
                     TAN.GRATAM AS CODTAM,
                     BIC.CODTAB AS CODBIC,
                     BOM.NUMBOM AS BOMBA,
                     BIC.SEQBOM AS BICO,
                     BIC.FILBIC,
                     BIC.SEQFIL,
                     MDT.PREBOM                   
                FROM TT_MDT MDT INNER JOIN TD_TAN TAN ON MDT.CODFIL = TAN.FILTAN AND MDT.NUMTAN = TAN.TANQUE
                                INNER JOIN TD_BIC BIC ON BIC.FILBIC = TAN.FILTAN AND BIC.CODTAN = TAN.CODTAB
                                INNER JOIN TD_BOM BOM ON BOM.CODTAB = BIC.CODBOM
             ) tab 
     ) tab2
 ;


/*-- SEQ 2363 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_LUC CASCADE;

/*-- SEQ 2364 --*/
CREATE OR REPLACE VIEW TV_LUC AS
SELECT I_4.*,
       PRECO_TOT_VENDA / CASE WHEN QTDMOV=0 THEN 1 ELSE QTDMOV END AS PRECO_VENDA,
       LUCRO / CASE WHEN QTDMOV=0 THEN 1 ELSE QTDMOV END AS LUCRO_UNI,
       LUCRO / PRECO_TOT_VENDA*100 AS PERLUC,
       LUCRO_CUSTO_ATU / CASE WHEN QTDMOV=0 THEN 1 ELSE QTDMOV END AS LUCRO_UNI_CUSTO_ATU,
       LUCRO_CUSTO_ATU /PRECO_TOT_VENDA*100 AS PERLUC_CUSTO_ATU,
       (CUSTO_AQUISICAO*QTDMOV) AS CUSTO_AQUISICAO_TOT
FROM (SELECT I_3.*,
             PRECO_TOT_VENDA - (CUSTO_AQUISICAO*QTDMOV) - COMISSOES - IMPOSTOS -
             IMPSOBREVENDA - DESP_OPERACIONAIS - CUSTO_FINANCEIRO - ICM_RETIDO AS LUCRO,
             PRECO_TOT_VENDA - (CUSTO_AQUISICAO_ATU*QTDMOV) - COMISSOES - IMPOSTOS -
             IMPSOBREVENDA - DESP_OPERACIONAIS - CUSTO_FINANCEIRO - ICM_RETIDO AS LUCRO_CUSTO_ATU
      FROM (SELECT I_2.*,
                   PRECO_TOT_VENDA * ((VENPIS+VENCOF+PERSOC+PERIR)/100) AS IMPSOBREVENDA,
                   PRECO_TOT_VENDA * PEROPE / 100 AS DESP_OPERACIONAIS
            FROM (SELECT I_1.*,
                         CASE WHEN COALESCE(VLRNOT,0) = 0
                              THEN 0.000001
                              ELSE NVLZ(COALESCE( (VLRMOV-IPIITE) * (VLRLIQ/NVLZ(VLRNOT,NULL)), 0),NULL)
                         END AS PRECO_TOT_VENDA,
                         (CASE WHEN LUCRO_POR_CM = 'T' AND CUSTOMEDIO_UNI > 0 THEN CUSTOMEDIO_UNI                         
                               WHEN CUSREP = 0 THEN GRA_CUSREP 
                               ELSE CUSREP 
                          END) + (CASE WHEN LUCRO_POR_CM = 'T' AND CUSTOMEDIO_UNI > 0 THEN 0                        
                                       WHEN CUSFRE = 0 THEN GRA_CUSFRE 
                                       ELSE CUSFRE 
                                  END) AS CUSTO_AQUISICAO,
                         CUSREP_ATU + COALESCE(CUSFRE_ATU,0) AS CUSTO_AQUISICAO_ATU,
                         CASE WHEN PRAFIN = 0
                              THEN 0
                              ELSE COALESCE( VLRLIQ * (((TAXFIN/100)/NVLZ(PRAFIN,NULL))*PRAMED) * (VLRMOV/NVLZ(VLRNOT,NULL)), 0)
                         END AS CUSTO_FINANCEIRO,
                         COALESCE(ICMITE,0) + COALESCE(ISSITE,0) + IPIITE AS IMPOSTOS,
                         CASE WHEN ICMTIP <> '3' OR VLRNOT <> 0
                              THEN 0
                              ELSE (SELECT CASE WHEN COALESCE(SUM(RET.VLRMOV),0) = 0 
                                                THEN 0 
                                                ELSE COALESCE((COALESCE(I_1.VLRMOV,0)/NVLZ(SUM(RET.VLRMOV),NULL))*COALESCE(RETIDO,0),0)
                                           END
                                    FROM TT_IVE RET
                                    WHERE RET.CODFIL = I_1.CODFIL
                                      AND RET.SEQUEN = I_1.SEQUEN
                                      AND RET.ICMTIP = '3')
                         END AS ICM_RETIDO
                  FROM (SELECT COALESCE(CustoData( 'R', VEN.DATHOR, IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM, NULL, 0 ), 0) AS CUSREP,
				               -- Dn - O Custo de Frete deve ser o custo na compra que gerou o custo de reposio.
							   --      O parmetro '1' pega o custo total da compra (REPOSICAO+FRETE), retirando o de reposio fica o de frete.
                               COALESCE(CustoData( '1', VEN.DATHOR, IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM, NULL, 0 )-CustoData( 'R', VEN.DATHOR, IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM, NULL, 0 ), 0) AS CUSFRE,
                               COALESCE(GRA.CUSREP,0) AS GRA_CUSREP,
                               COALESCE(GRA.CUSFRE,0) AS GRA_CUSFRE,
                               COALESCE(CustoCompraData   ( VEN.DATHOR, IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM, NULL, 0 ), 0) AS PRECOM,
                               COALESCE(CustoData( 'R', AGORA(), IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM, NULL, 0 ), 0)     AS CUSREP_ATU,
                               COALESCE(CustoData( '1', AGORA(), IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM, NULL, 0 )-CustoData( 'R', AGORA(), IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM, NULL, 0 ), 0) AS CUSFRE_ATU,
                               COALESCE(CustoCompraData   ( AGORA(),    IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM, NULL, 0 ), 0) AS PRECOM_ATU,
                               COALESCE(VEN.RETIDO ,0) AS RETIDO,
                               COALESCE(CFG.TAXFIN ,0) AS TAXFIN,    /* TAXA FINANCEIRA */
                               COALESCE(CFG.PRAFIN ,1) AS PRAFIN,    /* PRAZO DIVISOR DA TAXA FINANCEIRA */
                               COALESCE(DFIL.VENPIS,0) AS VENPIS,    /* PERCENTUAL DE CONTRIBUICAO DO PIS */
                               COALESCE(DFIL.VENCOF,0) AS VENCOF,    /* PERCENTUAL DE CONTRIBUICAO DO COFINS */
                               COALESCE(DFIL.PERSOC,0) AS PERSOC,    /* PERCENTUAL DE CONTRIBUICAO DO CONTRIB. SOCIAL */
                               COALESCE(DFIL.PEROPE,0) AS PEROPE,    /* PERCENTUAL MDIO EXTRA PARA COBRIR O OPERACIONAL */
                               COALESCE(CFG.PERIR  ,0) AS PERIR,     /* PERCENTUAL DE CONTRIBUICAO DO I.R. */
                               COALESCE(IVE.COMISS ,0) AS COMISSOES, /* COMISSAO DO ITEM */
                               COALESCE(IVE.VLR002 ,0) AS IPIITE,
                               VEN.CODFIL, VEN.SEQUEN, VEN.NUMECF, VEN.CODSER, VEN.NUMNOT, VEN.CNT_RO,
                               COALESCE(VEN.CODSER,'')||'/'||LTRIM(COALESCE(VEN.NUMECF,''))||'-'||LTRIM(COALESCE(VEN.NUMNOT,''))||CASE WHEN COALESCE(VEN.CNT_RO,0)>0 THEN '['||VEN.CNT_RO||']' ELSE '' END AS DOCUME,
                               VEN.VLRLIQ, VEN.VLRNOT, VEN.COMSOB, VEN.PRAMED, VEN.DESCON,
                               VEN.VLRSEG, VEN.VLRFRE, VEN.BASUBS, VEN.SUBSTT, VEN.DATHOR, IVE.NUMITE, 
                               IVE.SITMOV, IVE.LANEST, IVE.TIPPRO, IVE.REDITE, IVE.ICMTIP, IVE.TAX001, 
                               IVE.TIP001, IVE.TAX002, IVE.VLRMOV, NVLZ(IVE.QTDMOV,NULL) AS QTDMOV, VEN.FILCLI, VEN.CODCLI,
                               VEN.FLGEST, VEN.ATU_EM, VEN.FILUSU, VEN.CODUSU, VEN.FILVEN, VEN.CODVEN, 
                               VEN.FILPGT, VEN.CODPGT, VEN.PERCOM, VEN.PERENT, VEN.CODNAT, VEN.ESPECI, 
                               VEN.OBSERV, VEN.NROIMP, VEN.AUTENT, VEN.FILGUI, VEN.CODGUI, VEN.SIGNAT,
                               VEN.DATSAI, VEN.NUMVOL, VEN.MARCAS, VEN.PESBRU, VEN.PESLIQ, VEN.NUMCON, 
                               VEN.CODPRE, VEN.SINAL,  VEN.FINANC, VEN.TRIBUT, VEN.SEQFAT, VEN.FILPRE, 
                               VEN.PROPGT, VEN.EMIDES, VEN.FILTRA, VEN.CODTRA, VEN.TIPNOT, VEN.TIPTRA, 
                               VEN.FILFAT, VEN.ENDFAT, VEN.FILENT, VEN.ENDENT, VEN.FILCOB, VEN.ENDCOB, 
                               VEN.CODFIN, VEN.CONSFI, VEN.VINCUL, VEN.UFLOJA, VEN.FLGTIP, VEN.LANVEN,
                               VEN.CODEXT, VEN.CODCTR, IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM, 
                               IVE.CODMUL, IVE.SITKIT, IVE.FILORI, IVE.NUMORI, IVE.ITEORI, IVE.NUMEXT,
                               IVE.EMBORI, IVE.EMBQTD, IVE.VLR001, IVE.VLR002, IVE.COMISS, IVE.VEN_DATHOR,
                               CASE COALESCE(IVE.TIP001,'M') WHEN 'M' 
                                    THEN CASE IVE.ICMTIP WHEN '3' 
                                              THEN 0
                                              ELSE COALESCE(IVE.VLR001,0)
                                         END
                                    ELSE 0
                               END AS ICMITE,
                               CASE COALESCE(IVE.TIP001,'M') WHEN 'S' 
                                    THEN COALESCE(IVE.VLR001,0)
                                    ELSE COALESCE(IVE.VLRISS,0)
                               END AS ISSITE,
                               (CASE WHEN (IVE.TOT_CM IS NULL) OR (IVE.LANEST = 'N') THEN CUSTOMEDIO(IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,2,IVE.VEN_DATHOR) ELSE CASE WHEN COALESCE(IVE.SAL_CM,0) = 0 THEN 0 ELSE IVE.TOT_CM / IVE.SAL_CM * IVE.QTDMOV END END) AS CUSTOMEDIO_TOT,
                               (CASE WHEN (IVE.TOT_CM IS NULL) OR (IVE.LANEST = 'N') THEN CUSTOMEDIO(IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,3,IVE.VEN_DATHOR) ELSE CASE WHEN COALESCE(IVE.SAL_CM,0) = 0 THEN IVE.TOT_CM ELSE IVE.TOT_CM / IVE.SAL_CM END END) AS CUSTOMEDIO_UNI,
                               (CASE WHEN (IVE.TOTCMG IS NULL) OR (IVE.LANEST = 'N') THEN CUSTOMEDIO(IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,4,IVE.VEN_DATHOR) ELSE CASE WHEN COALESCE(IVE.SAL_CM,0) = 0 THEN 0 ELSE IVE.TOTCMG / IVE.SAL_CM * IVE.QTDMOV END END) AS CUSTO_FGT,
                               (CASE WHEN (IVE.TOTCMG IS NULL) OR (IVE.LANEST = 'N') THEN CUSTOMEDIO(IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,5,IVE.VEN_DATHOR) ELSE CASE WHEN COALESCE(IVE.SAL_CM,0) = 0 THEN IVE.TOTCMG ELSE IVE.TOTCMG / IVE.SAL_CM END END) AS CUSTO_FGT_UNI,
                               GRA.PRECOM AS GRA_PRECOM,
                               CASE WHEN (select count(*) 
                                            from TT_FUN FUN 
                                           WHERE FUN.NOMFUN = 'LUC_POR_CM') >0 THEN 'T' ELSE 'F'
                               END AS LUCRO_POR_CM
                          FROM TT_VEN VEN CROSS JOIN TT_CFG CFG
                                          INNER JOIN TT_IVE IVE ON VEN.CODFIL = IVE.CODFIL 
                                                               AND VEN.SEQUEN = IVE.SEQUEN
                                                               AND VEN.DATHOR = IVE.VEN_DATHOR
                                          INNER JOIN TD_FIL DFIL ON DFIL.CODFIL = VEN.CODFIL
                                          INNER JOIN TT_GRA GRA ON GRA.FILMAT = IVE.FILMAT
                                                               AND GRA.CODMAT = IVE.CODMAT
                                                               AND GRA.CODCOR = IVE.CODCOR
                                                               AND GRA.CODTAM = IVE.CODTAM
                         WHERE VEN.VLRNOT <> 0
                       ) I_1
                 ) I_2
           ) I_3
     ) I_4
 ;


/*-- SEQ 2365 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_MAR CASCADE;

/*-- SEQ 2366 --*/
CREATE OR REPLACE VIEW TV_MAR AS
SELECT REL.FILPAR, REL.CODPAR, REL.TIPPAR, CLI.FILCLI, CLI.CODCLI,
       CLI.ATU_EM, CLI.NOMCLI, CLI.ULTNOM, CLI.NUMDOC, CLI.DOCCON,
       CLI.DATNAS, CLI.ESTCIV, CLI.HOMPGE, CLI.FLGTIP, CLI.INSEST,
       CLI.CODSEX, CLI.CATEG1, CLI.CATEG2, CLI.CATEG3, CLI.DATA01,
       CLI.DATA02, CLI.DATA03, CLI.DATOPE, CLI.IMPRIM, CLI.VALOR1,
       CLI.TOTATR, CLI.TOTPAR, CLI.MAIATR, CLI.OBSERV, CLI.FILPLA,
       CLI.CODPLA, CLI.PORPAD, CLI.ULTCOM, CLI.SIGNAT, CLI.CONJUG,
       CLI.NASCON, CLI.SEXCON, CLI.FILVEN, CLI.CODVEN, CLI.PP_FLG
  FROM TT_REL REL INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI =  REL.CODPAR 
 WHERE REL.TIPPAR =  'M'
 ;




/*-- SEQ 2367 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_MAX_IVE CASCADE;

/*-- SEQ 2368 --*/
CREATE OR REPLACE VIEW TV_MAX_IVE AS
    SELECT IVE.FILMAT, 
           IVE.CODMAT, 
           IVE.CODCOR, 
           IVE.CODTAM, 
           MAX(IVE.VEN_DATHOR) AS ULTVEN
      FROM TT_IVE IVE
     WHERE IVE.SITMOV = 'N'
  GROUP BY IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM
 ;


/*-- SEQ 2369 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_MET CASCADE;

/*-- SEQ 2370 --*/
CREATE OR REPLACE VIEW TV_MET AS
-- View para apresentar as Vendas por Vendedor e sua respectiva meta atingida
-- Ver exemplo matemtico para entender os DECODEs abaixo..
--
-- Exemplo matemtico...
-- Baseado na seguinte relao :
--    
--     ABS(-5) - (-5) = +5 - -5 = +5 +5 = 10
--     ABS(+5) - (+5) = +5 - +5 = +5 -5 = 0    
--
--  "REALIZADO" = soma do TT_VEN.TOTLIQ das vendas por vendedor
--  "METAS" = TT_MET.VALOR1, TT_MET.VALOR2 , TT_MET.VALOR3 , TT_MET.VALOR4 
--
--  P/ REALIZADO maior ou igual a META...
--     REALIZADO = 3500 E META = 3000
--     ABS(REALIZADO-META)-(REALIZADO-META) =  
--     ABS(3500-3000)     -(3500-3000) =
--             +(500)     -(+500) = 0    ---- > resultado igual a 0  ento atingiu a meta em questo
--
--  P/ REALIZADO menor que a META...
--     REALIZADO = 2500 E META = 3000
--     ABS(REALIZADO-META)-(REALIZADO-META) = 
--     ABS(2500-3000)     -(2500-3000) =
--          ABS(-500)     -(-500) =
--             +(500)     +(500)  = 1000 ---- > resultado diferente de 0  ento no atingiu a meta em questao
--
-- O DECODE equipara 0 com cada clculo exemplificado acima e retorna o prximo
--          campo aps o calculo... nesta view iguais a VALOR e COMIS
--
-- Exs. :
--          0  "            clculo                   " "retornos"
--   DECODE(0, ABS(REALIZADO-VALOR4)-(REALIZADO-VALOR4)  ,VALOR4,
--             ABS(REALIZADO-VALOR3)-(REALIZADO-VALOR3)  ,VALOR3,
--             ABS(REALIZADO-VALOR2)-(REALIZADO-VALOR2)  ,VALOR2,
--             ABS(REALIZADO-VALOR1)-(REALIZADO-VALOR1)  ,VALOR1,0) AS VALALC
-- 
--    Case 0 of
--         ABS(REALIZADO-VALOR4)-(REALIZADO-VALOR4)  VALOR4,
--         ABS(REALIZADO-VALOR3)-(REALIZADO-VALOR3)  VALOR3,
--         ABS(REALIZADO-VALOR2)-(REALIZADO-VALOR2)  VALOR2,
--         ABS(REALIZADO-VALOR1)-(REALIZADO-VALOR1)  VALOR1
--         otherwize 0
--
SELECT FILUSU, CODUSU, ANOREF, MESREF, VALOR1, VALOR2, VALOR3, VALOR4,
       COMIS1, COMIS2, COMIS3, COMIS4, VLRREA, CNTVEN, 
       CASE 0 WHEN ABS(VLRREA-VALOR4)-(VLRREA-VALOR4) THEN VALOR4
              WHEN ABS(VLRREA-VALOR3)-(VLRREA-VALOR3) THEN VALOR3
              WHEN ABS(VLRREA-VALOR2)-(VLRREA-VALOR2) THEN VALOR2
              WHEN ABS(VLRREA-VALOR1)-(VLRREA-VALOR1) THEN VALOR1
              ELSE 0
       END AS VALALC,
       CASE 0 WHEN ABS(VLRREA-VALOR4)-(VLRREA-VALOR4) THEN COMIS4
              WHEN ABS(VLRREA-VALOR3)-(VLRREA-VALOR3) THEN COMIS3
              WHEN ABS(VLRREA-VALOR2)-(VLRREA-VALOR2) THEN COMIS2
              WHEN ABS(VLRREA-VALOR1)-(VLRREA-VALOR1) THEN COMIS1
              ELSE 0
       END AS PREMI
FROM (
      SELECT MET.FILUSU, MET.CODUSU, MET.ANOREF, MET.MESREF,
             MIN(MET.VALOR1) AS VALOR1, MIN(MET.VALOR2) AS VALOR2,
             MIN(MET.VALOR3) AS VALOR3, MIN(MET.VALOR4) AS VALOR4,
             MIN(MET.COMIS1) AS COMIS1, MIN(MET.COMIS2) AS COMIS2,
             MIN(MET.COMIS3) AS COMIS3, MIN(MET.COMIS4) AS COMIS4, 
             SUM(COALESCE(VEN.VLRLIQ,0)) AS VLRREA,
             CAST(COUNT(DISTINCT VEN.SEQUEN) AS INTEGER) AS CNTVEN
        FROM TT_MET MET  
  LEFT JOIN TT_VEN VEN ON VEN.FILVEN = MET.FILUSU 
                       AND VEN.CODVEN = MET.CODUSU
                       AND VEN.DATHOR BETWEEN TO_DATE('01' || TO_CHAR(MET.MESREF,'FM09') || TO_CHAR(MET.ANOREF,'FM0999'),'DDMMYYYY')
                       AND TO_DATE(TO_CHAR(LAST_DAY( TO_DATE('01' || TO_CHAR(MET.MESREF,'FM09') || 
                           TO_CHAR(MET.ANOREF,'FM0999'),'DDMMYYYY') ),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
                       AND VEN.FLGEST <> 'C'                                                                   -- ignora canceladas
                       AND VEN.LANVEN = 'T'                                                                    -- lancado como venda
                       AND VEN.FINANC = 'T'                                                                    -- gerou dado financeiro a receber
      GROUP BY MET.FILUSU, MET.CODUSU, MET.ANOREF, MET.MESREF
     ) TABELA
 ;




/*-- SEQ 2371 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_MET_IVE CASCADE;

/*-- SEQ 2372 --*/
CREATE OR REPLACE VIEW TV_MET_IVE AS
-- View para apresentar as Vendas por Vendedor e sua respectiva meta atingida
-- Ver exemplo matemtico para entender os DECODEs abaixo..
--
-- Exemplo matemtico...
-- Baseado na seguinte relao :
--    
--     ABS(-5) - (-5) = +5 - -5 = +5 +5 = 10
--     ABS(+5) - (+5) = +5 - +5 = +5 -5 = 0    
--
--  "REALIZADO" = soma do TT_VEN.TOTLIQ das vendas por vendedor
--  "METAS" = TT_MET.VALOR1, TT_MET.VALOR2 , TT_MET.VALOR3 , TT_MET.VALOR4 
--
--  P/ REALIZADO maior ou igual a META...
--     REALIZADO = 3500 E META = 3000
--     ABS(REALIZADO-META)-(REALIZADO-META) =  
--     ABS(3500-3000)     -(3500-3000) =
--             +(500)     -(+500) = 0    ---- > resultado igual a 0  ento atingiu a meta em questo
--
--  P/ REALIZADO menor que a META...
--     REALIZADO = 2500 E META = 3000
--     ABS(REALIZADO-META)-(REALIZADO-META) = 
--     ABS(2500-3000)     -(2500-3000) =
--          ABS(-500)     -(-500) =
--             +(500)     +(500)  = 1000 ---- > resultado diferente de 0  ento no atingiu a meta em questao
--
-- O DECODE equipara 0 com cada clculo exemplificado acima e retorna o prximo
--          campo aps o calculo... nesta view iguais a VALOR e COMIS
--
-- Exs. :
--          0  "            clculo                   " "retornos"
--   DECODE(0, ABS(REALIZADO-VALOR4)-(REALIZADO-VALOR4)  ,VALOR4,
--             ABS(REALIZADO-VALOR3)-(REALIZADO-VALOR3)  ,VALOR3,
--             ABS(REALIZADO-VALOR2)-(REALIZADO-VALOR2)  ,VALOR2,
--             ABS(REALIZADO-VALOR1)-(REALIZADO-VALOR1)  ,VALOR1,0) AS VALALC
-- 
--    Case 0 of
--         ABS(REALIZADO-VALOR4)-(REALIZADO-VALOR4)  VALOR4,
--         ABS(REALIZADO-VALOR3)-(REALIZADO-VALOR3)  VALOR3,
--         ABS(REALIZADO-VALOR2)-(REALIZADO-VALOR2)  VALOR2,
--         ABS(REALIZADO-VALOR1)-(REALIZADO-VALOR1)  VALOR1
--         otherwize 0
--
SELECT FILUSU, CODUSU, ANOREF, MESREF, VALOR1, VALOR2, VALOR3, VALOR4,
       COMIS1, COMIS2, COMIS3, COMIS4, VLRREA, CNTVEN, SUBSTT, VLRIPI, 
       VLRPROPOR, 
       CASE 0 WHEN ABS(VLRREA-VALOR4)-(VLRREA-VALOR4) THEN VALOR4
              WHEN ABS(VLRREA-VALOR3)-(VLRREA-VALOR3) THEN VALOR3
              WHEN ABS(VLRREA-VALOR2)-(VLRREA-VALOR2) THEN VALOR2
              WHEN ABS(VLRREA-VALOR1)-(VLRREA-VALOR1) THEN VALOR1
              ELSE 0
       END AS VALALC,
       CASE 0 WHEN ABS(VLRREA-VALOR4)-(VLRREA-VALOR4) THEN COMIS4
              WHEN ABS(VLRREA-VALOR3)-(VLRREA-VALOR3) THEN COMIS3
              WHEN ABS(VLRREA-VALOR2)-(VLRREA-VALOR2) THEN COMIS2
              WHEN ABS(VLRREA-VALOR1)-(VLRREA-VALOR1) THEN COMIS1
              ELSE 0
       END AS PREMI
FROM (
      SELECT MET.FILUSU, MET.CODUSU, MET.ANOREF, MET.MESREF,
             MIN(MET.VALOR1) AS VALOR1, MIN(MET.VALOR2) AS VALOR2,
             MIN(MET.VALOR3) AS VALOR3, MIN(MET.VALOR4) AS VALOR4,
             MIN(MET.COMIS1) AS COMIS1, MIN(MET.COMIS2) AS COMIS2,
             MIN(MET.COMIS3) AS COMIS3, MIN(MET.COMIS4) AS COMIS4, 
             SUM(COALESCE(VEN.VLRLIQ,0)) AS VLRREA,
             SUM(COALESCE(IVE.SUBSTT,0)) AS SUBSTT,
             SUM(COALESCE(IVE.VLRIPI,0)) AS VLRIPI,
             SUM(COALESCE(VEN.VLRLIQ,0) * (CASE WHEN VEN.VLRNOT = 0 THEN 0 ELSE IVE.VLRMOV / VEN.VLRNOT END)) AS VLRPROPOR,
             CAST(COUNT(DISTINCT VEN.SEQUEN) AS INTEGER) AS CNTVEN
        FROM TT_MET MET  
  LEFT JOIN TT_VEN VEN ON VEN.FILVEN = MET.FILUSU 
                       AND VEN.CODVEN = MET.CODUSU
                       AND VEN.DATHOR BETWEEN TO_DATE('01' || TO_CHAR(MET.MESREF,'FM09') || TO_CHAR(MET.ANOREF,'FM0999'),'DDMMYYYY')
                       AND TO_DATE(TO_CHAR(LAST_DAY( TO_DATE('01' || TO_CHAR(MET.MESREF,'FM09') || 
                           TO_CHAR(MET.ANOREF,'FM0999'),'DDMMYYYY') ),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
                       AND VEN.FLGEST <> 'C'                                                                   -- ignora canceladas
                       AND VEN.LANVEN = 'T'                                                                    -- lancado como venda
                       AND VEN.FINANC = 'T'                                                                    -- gerou dado financeiro a receber
  LEFT JOIN TT_IVE IVE ON IVE.SEQUEN = VEN.SEQUEN 
                       AND IVE.CODFIL = VEN.CODFIL
                       AND IVE.SITMOV <> 'C'                                                     -- ignora item cancelados pois quando ECF pode haver apenas itens na nota                       
      GROUP BY MET.FILUSU, MET.CODUSU, MET.ANOREF, MET.MESREF
     ) TABELA
 ;




/*-- SEQ 2373 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_MOT CASCADE;

/*-- SEQ 2374 --*/
CREATE OR REPLACE VIEW TV_MOT AS
SELECT CLI.FILCLI, CLI.CODCLI, 
       CLI.FILVIN AS FILTRA, CLI.CODVIN AS CODTRA, 
       CLI.ATU_EM,
       CLI.NOMCLI, CLI.ULTNOM, CLI.NUMDOC,       
       CLI.DOCCON, CLI.DATNAS, CLI.ESTCIV,
       CLI.HOMPGE, CLI.FLGTIP, CLI.INSEST,
       CLI.CODSEX, CLI.CATEG1, CLI.CATEG2,
       CLI.CATEG3, CLI.DATA01, CLI.DATA02,
       CLI.DATA03, CLI.DATOPE, CLI.IMPRIM,
       CLI.VALOR1, CLI.TOTATR, CLI.TOTPAR,
       CLI.MAIATR, CLI.OBSERV, CLI.FILPLA,
       CLI.CODPLA, CLI.PORPAD, CLI.ULTCOM,
       CLI.SIGNAT, CLI.CONJUG, CLI.NASCON,
       CLI.SEXCON, CLI.FILVEN, CLI.CODVEN,
       CLI.PP_FLG
  FROM TT_CLI CLI INNER JOIN TT_REL REL ON CLI.FILCLI =  REL.FILPAR AND CLI.CODCLI =  REL.CODPAR
 WHERE REL.TIPPAR =  'O'
 ;




/*-- SEQ 2375 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_MOV CASCADE;

/*-- SEQ 2376 --*/
CREATE OR REPLACE VIEW TV_MOV AS
SELECT LAN.DOCUME, LAN.CODFIL, 0 AS NUMITE,
       LAN.FILMAT, LAN.CODMAT, LAN.CODCOR,
       LAN.CODTAM, LAN.CODMUL, LAN.DATMOV, LAN.ATU_EM,
       LAN.QTDMOV, LAN.VLRMOV, LAN.FILUSU,
       LAN.CODUSU, LAN.TIPMOV, LAN.NUMEXT,
       LAN.SITMOV, DLAN.DESLAN AS NATURE,
       LAN.EMBORI, LAN.EMBQTD,
       CAST('S' AS VARCHAR(1)) AS LANEST,
       LAN.QTDMOV AS QTD_CM,
       CUSTOMEDIO(LAN.CODFIL,LAN.FILMAT,LAN.CODMAT,LAN.CODCOR,LAN.CODTAM,3,LAN.DATMOV)*LAN.QTDMOV AS FIS_CM,
       CUSTOMEDIO(LAN.CODFIL,LAN.FILMAT,LAN.CODMAT,LAN.CODCOR,LAN.CODTAM,5,LAN.DATMOV)*LAN.QTDMOV AS GER_CM,
       LAN.DATINC,
       CAST(NULL AS CHAR(3)) AS FILCLI,
       CAST(NULL AS CHAR(6)) AS CODCLI,
       LAN.SEQUEN,
       DLAN.SINLAN AS SINMOV,
       GRA.CODEXT AS CODGRA,
       CAST(NULL AS VARCHAR(20)) AS CODDEP,
       CAST(NULL AS VARCHAR(20)) AS CODPAR
  FROM TD_LAN DLAN INNER JOIN TT_LAN LAN ON DLAN.CODTAB = LAN.TIPLAN
                   INNER JOIN TT_GRA GRA ON GRA.FILMAT = LAN.FILMAT AND GRA.CODMAT = LAN.CODMAT
                                        AND GRA.CODCOR = LAN.CODCOR AND GRA.CODTAM = LAN.CODTAM
UNION ALL
SELECT COALESCE(COM.FILFOR ,'')||'-'||COALESCE(COM.CODFOR ,'')||'/'||
       COALESCE(COM.CODSER ,'')||'-'||COALESCE(COM.NUMNOT ,'') AS DOCUME,
       ICO.CODFIL, ICO.NUMITE,
       ICO.FILMAT, ICO.CODMAT, ICO.CODCOR,
       ICO.CODTAM, ICO.CODMUL, ICO.COM_DATOPE AS DATMOV,
       COM.ATU_EM, ICO.QTDMOV, ICO.VLRMOV,
       COM.FILUSU, COM.CODUSU,
       CAST('C' AS VARCHAR(1)) AS TIPMOV,
       CAST(NULL AS VARCHAR(1)) AS NUMEXT,
       ICO.SITMOV,
       NaturezaItemCompra(ICO.CODFIL, ICO.SEQUEN, ICO.NUMITE) AS NATURE,
       ICO.EMBORI, ICO.EMBQTD, ICO.LANEST,
       CASE WHEN ICO.SITMOV <> 'C' AND ICO.LANEST NOT IN ('R','N') AND COALESCE(ICO.QTD_CM,0) <> 0 THEN ICO.QTD_CM ELSE 0 END AS QTD_CM,
       CASE WHEN ICO.SITMOV <> 'C' AND ICO.LANEST NOT IN ('R','N') AND COALESCE(ICO.QTD_CM,0) <> 0 THEN ICO.VLR_CM ELSE 0 END AS FIS_CM,
       CASE WHEN ICO.SITMOV <> 'C' AND ICO.LANEST NOT IN ('R','N') AND COALESCE(ICO.QTD_CM,0) <> 0 THEN ICO.VLRCMG ELSE 0 END AS GER_CM,
       ICO.DATINC,
       COM.FILFOR AS FILCLI,
       COM.CODFOR AS CODCLI,
       COM.SEQUEN,
       CAST('+' AS CHAR(1)) AS SINMOV,
       GRA.CODEXT AS CODGRA,
       CAST(NULL AS VARCHAR(20)) AS CODDEP,
       CLI.CODEXT AS CODPAR
  FROM TT_COM COM INNER JOIN TT_ICO ICO ON COM.CODFIL = ICO.CODFIL AND COM.SEQUEN = ICO.SEQUEN
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = ICO.FILMAT AND GRA.CODMAT = ICO.CODMAT
                                       AND GRA.CODCOR = ICO.CODCOR AND GRA.CODTAM = ICO.CODTAM
                  INNER JOIN TT_CLI CLI ON COM.FILFOR = CLI.FILCLI AND COM.CODFOR = CLI.CODCLI
 WHERE COALESCE(COM.FINNFE,'0') <> '2'--Desconsidera nota complementar
UNION ALL
SELECT COALESCE(VEN.NUMECF ,'')||'-'||COALESCE(VEN.CODSER ,'')||'/'||
       COALESCE(VEN.NUMNOT ,'')|| '     ' AS DOCUME,
       IVE.CODFIL, IVE.NUMITE,
       IVE.FILMAT, IVE.CODMAT, IVE.CODCOR,
       IVE.CODTAM, IVE.CODMUL, IVE.VEN_DATHOR AS DATMOV,
       VEN.ATU_EM, IVE.QTDMOV * -1 AS QTDMOV,
       IVE.VLRMOV * -1 AS VLRMOV,
       VEN.FILUSU, VEN.CODUSU, CAST('V' AS VARCHAR(1)) AS TIPMOV,
       IVE.NUMEXT, IVE.SITMOV, NAT.NATURE,
       IVE.EMBORI, IVE.EMBQTD, IVE.LANEST,
       CASE WHEN IVE.SITMOV <> 'C' AND IVE.LANEST NOT IN ('R','N') AND COALESCE(IVE.QTD_CM,0) <> 0 THEN IVE.QTD_CM ELSE 0 END AS QTD_CM,
       CASE WHEN IVE.SITMOV <> 'C' AND IVE.LANEST NOT IN ('R','N') AND COALESCE(IVE.QTD_CM,0) <> 0 THEN
           CASE WHEN COALESCE(IVE.TOT_CM,0) <> 0 AND COALESCE(IVE.SAL_CM,0) <> 0 THEN
                ive.tot_cm/ive.sal_cm*ive.qtd_cm
           ELSE
                CUSTOMEDIO(IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,3,IVE.VEN_DATHOR)*IVE.QTD_CM
           END
       ELSE
           0
       END AS FIS_CM,
       CASE WHEN IVE.SITMOV <> 'C' AND IVE.LANEST NOT IN ('R','N') AND COALESCE(IVE.QTD_CM,0) <> 0 THEN
           CASE WHEN COALESCE(IVE.TOTCMG,0) <> 0 AND COALESCE(IVE.SAL_CM,0) <> 0 THEN
                ive.totcmg/ive.sal_cm*ive.qtd_cm
           ELSE
                CUSTOMEDIO(IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,5,IVE.VEN_DATHOR)*IVE.QTD_CM
           END
       ELSE
           0
       END AS GER_CM,
       IVE.DATINC,
       VEN.FILCLI,
       VEN.CODCLI,
       VEN.SEQUEN,
       CAST(CASE WHEN VEN.VLRLIQ > 0 THEN '-' ELSE '+' END AS CHAR(1)) AS SINMOV,
       GRA.CODEXT AS CODGRA,
       IVE.NUMEXT_DEP AS CODDEP,
       CLI.CODEXT AS CODPAR
  FROM TT_IVE IVE INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL
                                       AND VEN.SEQUEN = IVE.SEQUEN
                  INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = IVE.FILMAT AND GRA.CODMAT = IVE.CODMAT
                                       AND GRA.CODCOR = IVE.CODCOR AND GRA.CODTAM = IVE.CODTAM
                  INNER JOIN TT_CLI CLI ON VEN.FILCLI = CLI.FILCLI AND VEN.CODCLI = CLI.CODCLI
 WHERE IVE.SITKIT <> '1'
UNION ALL
SELECT (INV.CODFIL || '/') || TRIM(INV.SEQUEN) AS DOCUME,
    INV.CODFIL,
    0 AS NUMITE,
    IIN.FILMAT,
    IIN.CODMAT,
    IIN.CODCOR,
    IIN.CODTAM,
    INV.CODMUL,
    INV.DATENC AS DATMOV,
    INV.ATU_EM,
    0 AS QTDMOV,
    0 AS VLRMOV,
    INV.FILENC AS FILUSU,
    INV.CODENC AS CODUSU,
    CAST('A' AS VARCHAR(1)) AS TIPMOV,
    CAST(NULL AS VARCHAR(1)) AS NUMEXT,
    CAST('N' AS CHAR(1)) AS SITMOV,
    CAST('INVENTARIO' AS VARCHAR(30)) AS NATURE,
    CAST(0 AS Numeric(5,0)) AS EMBORI,
    CAST(0 AS Numeric(12,4)) AS EMBQTD,
    CAST('S' AS VARCHAR(1)) AS LANEST,
    0 AS QTD_CM,
    0 AS FIS_CM,
    0 AS GER_CM,
    INV.DATENC AS DATINC,
    CAST(NULL AS CHAR(3)) AS FILCLI,
    CAST(NULL AS CHAR(6)) AS CODCLI,
    CAST(NULL AS CHAR(10)) AS SEQUEN,
    CAST('-' AS CHAR(1)) AS SINMOV,
    GRA.CODEXT AS CODGRA,
    CAST(NULL AS VARCHAR(20)) AS CODDEP,
    CAST(NULL AS VARCHAR(20)) AS CODPAR
   FROM TT_IIN IIN INNER JOIN TT_INV INV ON INV.CODFIL = IIN.CODFIL
                                        AND INV.SEQUEN = IIN.SEQUEN
                   INNER JOIN TT_GRA GRA ON GRA.FILMAT = IIN.FILMAT
                                        AND GRA.CODMAT = IIN.CODMAT
                                        AND GRA.CODCOR = IIN.CODCOR
                                        AND GRA.CODTAM = IIN.CODTAM
                    LEFT JOIN TT_LAN LAN ON LAN.FILMAT = IIN.FILMAT
                                        AND LAN.CODMAT = IIN.CODMAT
                                        AND LAN.CODCOR = IIN.CODCOR
                                        AND LAN.CODTAM = IIN.CODTAM
                                        AND LAN.DOCUME = (INV.CODFIL||'/')||TRIM(INV.SEQUEN)
  WHERE TEMFUN('INV_GIMBA') = 'T'
    AND INV.FLGEST = 'E'
    AND LAN.FILMAT IS NULL;


/*-- SEQ 2377 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_MPB CASCADE;

/*-- SEQ 2378 --*/
CREATE OR REPLACE VIEW TV_MPB AS
SELECT TAB.CODFIL, TAB.SEQUEN, TAB.NUMITE, TAB.VLRNOT, TAB.VLRLIQ,
       TAB.NUMNOT, TAB.DATFIS, TAB.DATHOR, TAB.NUMECF, TAB.CODSER, TAB.SEREXP, TAB.CNT_RO,
       TAB.QTDMPB, TAB.CODPRO, TAB.REFPRO, TAB.NOMPRO,
       TAB.CODNCM, TAB.GENNCM,
       TAB.QTDMOV, TAB.VLRMOV, TAB.VLRLIQRAT,
       TAB.SITPIS, TAB.BASPIS, TAB.PERPIS, TAB.VLRPIS, TAB.VLRPIS_ISENTO, TAB.TOTPIS,
       TAB.SITCOF, TAB.BASCOF, TAB.PERCOF, TAB.VLRCOF, TAB.VLRCOF_ISENTO, TAB.TOTCOF,
       TAB.CODCTR, TAB.DOCUME, TAB.CODNAT,
       ROUND((TAB.VLRMOV + ABS(CASE WHEN TAB.DESTOT <> 0 THEN TAB.VLRMOV * TAB.VLRNOT / TAB.DESTOT ELSE 0 END) + ABS(TAB.DESITE)) / TAB.QTDMOV * TAB.QTDMPB,2) AS VALOR_MERC
  FROM (
    SELECT VEN.CODFIL,
           VEN.SEQUEN,
           VEN.NUMNOT,
           VEN.DATFIS,
           VEN.DATHOR,
           VEN.VLRLIQ,
           VEN.VLRNOT,
           VEN.NUMECF,
           VEN.CODSER,
           CAST(TRIM(FIS.SEREXP) AS VARCHAR(3)) AS SEREXP,
           VEN.CNT_RO,
           IVE.NUMITE,
           IVE.QTDMOV,
           IVE.VLRMOV,
           IVE.SITPIS,
           ABS(IVE.BASPIS) AS BASPIS,
           IVE.PERPIS,
           ABS(IVE.VLRPIS) AS VLRPIS,
           ROUND((ABS(IVE.BASPIS)*IVE.PERPIS/100)-ABS(IVE.VLRPIS),2) AS VLRPIS_ISENTO,
           ROUND((ABS(IVE.BASPIS)*IVE.PERPIS/100),2) AS TOTPIS,
           IVE.SITCOF,
           ABS(IVE.BASCOF) AS BASCOF,
           IVE.PERCOF,
           ABS(IVE.VLRCOF) AS VLRCOF,
           ROUND((ABS(IVE.BASCOF)*IVE.PERCOF/100)-ABS(IVE.VLRCOF),2) AS VLRCOF_ISENTO,
           ROUND((ABS(IVE.BASCOF)*IVE.PERCOF/100),2) AS TOTCOF,
           CASE WHEN VEN.VLRLIQ = VEN.VLRNOT
                THEN IVE.VLRMOV
                ELSE CASE WHEN VEN.CODSER = 'CF'
                          THEN Rateio_ValorLiquido_ECF(IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE)
                          ELSE ROUND(COALESCE(COALESCE(VEN.VLRLIQ,0) * (CASE VEN.VLRNOT WHEN 0 THEN 0 ELSE IVE.VLRMOV/VEN.VLRNOT END),0),2)
                     END
           END AS VLRLIQRAT,
           IVE.QTDMPB,
           CASE WHEN EXISTS (SELECT 'OK' FROM TT_FUN WHERE NOMFUN = 'EXPCODVEND') THEN
                IPR.FILMAT||LPAD(TRIM(IPR.SEQUEN),10,'0')
               ELSE
                  Cast(COALESCE(IPR.FILMAT, '')|| COALESCE(IPR.CODMAT, '')|| '-' || TRIM(COALESCE(TO_CHAR(IPR.CODCOR), ''))
                  || '-' || TRIM(COALESCE(TO_CHAR(IPR.CODTAM),'')) as VARCHAR(21))
           END AS CODPRO,
           IPR.REFPRO,
           NomeProduto(IPR.DESECF, IPR.DESMAT, IPR.CODCOR, IPR.ITEDIV,
                       IPR.CODTAM, IPR.ITESUB, IPR.ESPMAT, IPR.DESGRA) AS NOMPRO,
           IPR.CODNCM,
           SUBSTR(IPR.CODNCM,1,2) AS GENNCM,
           VEN.CODCTR,
           COALESCE(VEN.CODSER,'')||'/'||lTrim(COALESCE(VEN.NUMECF,''))||'-'||lTrim(COALESCE(VEN.NUMNOT,''))||CASE WHEN COALESCE(VEN.CNT_RO,0)>0 THEN '['||VEN.CNT_RO||']' ELSE '' END AS DOCUME,
           VEN.VLRLIQ - VEN.VLRSEG - VEN.VLRFRE - VEN.OUTTAX - VEN.VLRNOT - VEN.SUBSTT AS DESTOT,
           CASE WHEN VEN.CODSER = 'CF' THEN IVE.VLRDES ELSE 0 END AS DESITE,
           VEN.CODNAT
      FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL
                                           AND IVE.SEQUEN = VEN.SEQUEN
                                           AND IVE.SITMOV = 'N'
                                           AND IVE.SITKIT IN ('2','3')
                                           AND IVE.QTDMOV <> 0
                      INNER JOIN TD_ECF ECF ON VEN.CODFIL=ECF.FILECF AND VEN.NUMECF=ECF.NUMECF
                      INNER JOIN (SELECT GRA.FILMAT, GRA.SEQUEN, GRA.CODMAT,
                                         GRA.CODCOR, GRA.CODTAM, PRO.CODNCM,
                                         GRA.UNIDAD,
                                         PRO.DESECF, PRO.DESMAT, PRO.ESPMAT,
                                         PRO.CODFPS, PRO.COD_EX, PRO.CODSRV,
                                         PRO.CODANP, PRO.SITIPI,
                                         NULL AS NATBCC,
                                         DIV.CODITE AS DIV_CODITE,
                                         DIV.NOMITE AS ITEDIV,
                                         SUB.CODITE AS SUB_CODITE,
                                         SUB.NOMITE AS ITESUB,
                                         GRA.CODEXT,
                                         GRA.REFPRO,
                                         GRA.DESGRA
                                    FROM TT_GRA GRA INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT
                                                                         AND PRO.CODMAT = GRA.CODMAT
                                                    INNER JOIN TT_DIV DIV ON GRA.CODCOR = DIV.CODITE
                                                    INNER JOIN TT_SUB SUB ON GRA.CODTAM = SUB.CODITE) IPR
                                    ON IPR.FILMAT = IVE.FILMAT
                                   AND IPR.CODMAT = IVE.CODMAT
                                   AND IPR.CODCOR = IVE.CODCOR
                                   AND IPR.CODTAM = IVE.CODTAM
                      INNER JOIN TT_FIS FIS ON FIS.CODSER = VEN.CODSER
                                           AND FIS.SUBSER = VEN.NUMECF
                      INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
		       LEFT JOIN TT_IVE ORI ON IVE.FILORI = ORI.CODFIL
                                           AND IVE.NUMORI = ORI.SEQUEN
                                           AND IVE.ITEORI = ORI.NUMITE
     WHERE VEN.TIPTRO IN ('+','-','2')
       AND VEN.NUMNOT NOT LIKE '###%'
       AND FIS.ORIGEM = 'V'
       AND FIS.EXPORT = 'T'
       AND COALESCE(VEN.FUNRUR,0) = 0
       AND (IVE.QTDMPB > 0 OR (VLRLIQ < 0 AND COALESCE(ORI.QTDMPB,0) > 0))
     ORDER BY VEN.CODFIL, VEN.SEQUEN, IVE.NUMITE
) TAB
;


/*-- SEQ 2379 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_MPF CASCADE;

/*-- SEQ 2380 --*/
CREATE OR REPLACE VIEW TV_MPF AS
SELECT INT.*,
       CASE 0 WHEN ABS(VLRREA-VALOR4)-(VLRREA-VALOR4) THEN VALOR4
              WHEN ABS(VLRREA-VALOR3)-(VLRREA-VALOR3) THEN VALOR3
              WHEN ABS(VLRREA-VALOR2)-(VLRREA-VALOR2) THEN VALOR2
              WHEN ABS(VLRREA-VALOR1)-(VLRREA-VALOR1) THEN VALOR1
              ELSE 0
       END AS VALALC,
       CASE 0 WHEN ABS(VLRREA-VALOR4)-(VLRREA-VALOR4) THEN COMIS4
              WHEN ABS(VLRREA-VALOR3)-(VLRREA-VALOR3) THEN COMIS3
              WHEN ABS(VLRREA-VALOR2)-(VLRREA-VALOR2) THEN COMIS2
              WHEN ABS(VLRREA-VALOR1)-(VLRREA-VALOR1) THEN COMIS1
              ELSE 0
       END AS PREMIO
FROM (SELECT CODFIL, ANOREF, MESREF, 
             VALOR1, VALOR2, VALOR3, VALOR4,
             COMIS1, COMIS2, COMIS3, COMIS4, 
             CAST( SUBSTR( VENDAS, 01, 15) AS Numeric(13,2)) AS VLRREA,
             CAST( SUBSTR( VENDAS, 16, 15) AS Numeric(13,2)) AS VLRDEV,
             CAST( SUBSTR( VENDAS, 31, 15) AS Numeric(13,2)) AS CNTVEN,
             CAST( SUBSTR( PARCEL, 01, 15) AS Numeric(13,2)) AS AVISTA,
             CAST( SUBSTR( PARCEL, 16, 15) AS Numeric(13,2)) AS VLRENT,
             CAST( SUBSTR( PARCEL, 31, 15) AS Numeric(13,2)) AS VLRPRE,
             CAST( SUBSTR( PARCEL, 46, 15) AS Numeric(13,2)) AS VLRCAR,
             CAST( SUBSTR( PARCEL, 61, 15) AS Numeric(13,2)) AS VLRDES,
             CAST( SUBSTR( PARCEL, 76, 15) AS Numeric(13,2)) AS VLRJUR,
             CAST( SUBSTR( PARCEL,  91, 15) AS Numeric(13,2)) AS DEVAVI,
             CAST( SUBSTR( PARCEL, 106, 15) AS Numeric(13,2)) AS DEVENT,
             CAST( SUBSTR( PARCEL, 121, 15) AS Numeric(13,2)) AS DEVPRE,
             CODCTR
      FROM (SELECT MPF.*,
                  (SELECT TO_CHAR( SUM( case when VEN.LANVEN = 'T' 
                                        then COALESCE(VEN.VLRLIQ,0) 
                                             else 0
                                        end), '99999999990D99') ||
                          TO_CHAR( SUM( case when VEN.VLRLIQ < 0 
                                        then COALESCE(VEN.VLRLIQ*-1,0)
                                             else 0
                                        end), '99999999990D99') ||
                          TO_CHAR( COUNT(*), '99999999990D99')
                   FROM TT_VEN VEN 
                   WHERE VEN.CODFIL = MPF.CODFIL
                     AND VEN.CODCTR = MPF.CODCTR
                     AND VEN.DATHOR BETWEEN MPF.INIMES AND TO_DATE(TO_CHAR(LAST_DAY( MPF.INIMES ),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
                     AND VEN.FLGEST <> 'C'  -- ignora canceladas
                     AND VEN.FINANC = 'T'   -- gerou dado financeiro a receber
                  )  AS VENDAS,
                  (SELECT TO_CHAR( SUM( case when VEN.PRAMED = 0 AND TRUNC(VEN.DATHOR) = TRUNC(REC.PAGAME)
                                             then CASE WHEN REC.SEQCHE IS NOT NULL OR REC.CARTAO IS NOT NULL
                                                       THEN REC.VLRPAR
                                                       ELSE REC.VLRPGT
                                                  END
                                             else 0
                                        end), '99999999990D99') || -- AVISTA (A Vista)
                          TO_CHAR( SUM( case when VEN.PRAMED > 0 AND
                                                 TRUNC(VEN.DATHOR) = TRUNC(REC.PAGAME)
                                             then CASE WHEN REC.SEQCHE IS NOT NULL OR REC.CARTAO IS NOT NULL
                                                       THEN REC.VLRPAR
                                                       ELSE REC.VLRPGT
                                                  END
                                             else 0
                                        end), '99999999990D99') || -- VLRENT (Entradas)
                          TO_CHAR( SUM( case when TRUNC(VEN.DATHOR) <> TRUNC(REC.PAGAME) AND REC.CARTAO IS NULL
                                             then CASE WHEN REC.SEQCHE IS NOT NULL
                                                       THEN REC.VLRPAR
                                                       ELSE REC.VLRPGT
                                                  END
                                             else 0
                                        end), '99999999990D99') || -- VLRPRE (Prestaes)
                          TO_CHAR( SUM( case when TRUNC(VEN.DATHOR) <> TRUNC(REC.PAGAME) AND REC.CARTAO IS NOT NULL
                                             THEN REC.VLRPAR
                                             else 0
                                        end), '99999999990D99') || -- VLRCAR (Cartes)
                          TO_CHAR( SUM( case when COALESCE(REC.VLRDES,0) < 0 AND REC.CARTAO IS NULL
                                             then REC.VLRDES * -1
                                             else 0
                                        end), '99999999990D99') || -- VLRDES (Descontos)
                          TO_CHAR( SUM( case when COALESCE(REC.VLRDES,0) > 0 AND REC.CARTAO IS NULL
                                             then REC.VLRDES
                                             else 0
                                        end), '99999999990D99') ||   -- VLRJUR (Juros)
                          TO_CHAR( SUM( case when VEN.PRAMED = 0 AND TRUNC(VEN.DATHOR) = TRUNC(REC.PAGAME) AND
                                                  REC.TIPCCC IS NOT NULL AND REC.TIPCCC = CFG.CC_DEVOLUCAO
                                             then REC.VLRPGT
                                             else 0
                                        end), '99999999990D99') || -- DEVAVI (A Vista paga com devolucao)
                          TO_CHAR( SUM( case when VEN.PRAMED > 0 AND TRUNC(VEN.DATHOR) = TRUNC(REC.PAGAME) AND
                                                  REC.TIPCCC IS NOT NULL AND REC.TIPCCC = CFG.CC_DEVOLUCAO
                                             then REC.VLRPGT
                                             else 0
                                        end), '99999999990D99') || -- DEVENT (Entradas pagas com devolucao)
                          TO_CHAR( SUM( case when TRUNC(VEN.DATHOR) <> TRUNC(REC.PAGAME) AND REC.CARTAO IS NULL AND
                                                  REC.TIPCCC IS NOT NULL AND REC.TIPCCC = CFG.CC_DEVOLUCAO
                                             then REC.VLRPGT
                                             else 0
                                        end), '99999999990D99') -- DEVPRE (Prestaes pagas com devolucao)
                   FROM TT_VEN VEN, TT_REC REC, TT_CFG CFG
                   WHERE VEN.CODFIL = REC.CODFIL
                     AND VEN.CODCTR = MPF.CODCTR
                     AND VEN.SEQUEN = REC.SEQUEN
                     AND REC.CODFIL = MPF.CODFIL
                     AND REC.PAGAME BETWEEN MPF.INIMES AND TO_DATE(TO_CHAR(LAST_DAY( MPF.INIMES ),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
                     AND ((REC.FLGEST = 'P') OR
                          (REC.FLGEST = 'A' AND REC.CARTAO IS NOT NULL OR REC.SEQCHE IS NOT NULL))
                  )  AS PARCEL
            FROM (SELECT MET.*, 
                         TO_DATE('01' || 
                                 TO_CHAR(MET.MESREF,'FM09') || 
                                 TO_CHAR(MET.ANOREF,'FM0999'),'DDMMYYYY') AS INIMES 
                    FROM TT_MPF MET) MPF
           ) INT
     ) INT
;


/*-- SEQ 2381 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_NAO_CCC CASCADE;

/*-- SEQ 2382 --*/
CREATE OR REPLACE VIEW TV_NAO_CCC AS
    SELECT VEN.FILCLI, VEN.CODCLI,
           CASE WHEN REC.FLGEST = 'P' THEN 'Q'
                WHEN REC.FLGEST IN ('C','X') THEN 'C'
                WHEN REC.FLGEST = 'A' THEN 'A'
           END AS FLGEST,
           CASE WHEN REC.FLGEST = 'P' THEN 'Quitada'
                WHEN REC.FLGEST IN ('C','X') THEN 'Cancelada'
                WHEN REC.FLGEST = 'A' THEN 'Aberta'
           END AS STATUS,
           SUM(CASE WHEN REC.FLGEST IN ('P','X') THEN REC.VLRPGT
                    ELSE REC.VLRPAR
               END) AS VLRLAN,
           VEN.DATHOR,
           COALESCE(VEN.NUMECF,'')||'-'||COALESCE(VEN.CODSER,'')||'/'||COALESCE(VEN.NUMNOT ,'')AS CUPFIS,
           COALESCE(FIL.NOMFIL,'-X-') AS NOMFIL,
           ResumodeParcela(VEN.CODFIL,VEN.SEQUEN) AS MEIOPG,
           VXP.PLACAS,
           COALESCE(MOT.NOMCLI,'-X-') AS NOMMOT,
           COALESCE(VXP.QTD_KM,0) AS QTD_KM,
           Combustiveis(VEN.CODFIL,VEN.SEQUEN) AS QTDLIT,
           COALESCE(VXP.ORIGEM,'-X-') AS ORIGEM,
           COALESCE(VXP.DESTIN,'-X-') AS DESTIN
      FROM TT_VEN VEN LEFT OUTER JOIN TT_CCC CCC ON CCC.CODVEN = VEN.CODFIL AND CCC.SEQVEN = VEN.SEQUEN
                      LEFT OUTER JOIN TT_VXP VXP ON VXP.CODFIL = VEN.CODFIL AND VXP.SEQUEN = VEN.SEQUEN
                      LEFT OUTER JOIN TT_CLI MOT ON MOT.FILCLI = VXP.FILMOT AND MOT.CODCLI = VXP.CODMOT
                           INNER JOIN TD_FIL FIL ON FIL.CODFIL = VEN.CODFIL
                           INNER JOIN TT_REC REC ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
     WHERE (CCC.CODFIL IS NULL OR ((COALESCE(CCC.FILCLI,'')||COALESCE(CCC.CODCLI,''))<>(COALESCE(VEN.FILCLI,'')||COALESCE(VEN.CODCLI,''))))
       AND VEN.CODSER <> 'CC'
  GROUP BY VEN.CODFIL, VEN.SEQUEN, VEN.NUMECF, VEN.CODSER, VEN.NUMNOT,
           VEN.FILCLI, VEN.CODCLI, VEN.DATHOR,
           REC.FLGEST,
           VXP.PLACAS, VXP.QTD_KM, VXP.ORIGEM, VXP.DESTIN,
           FIL.NOMFIL,
           MOT.NOMCLI 
 ;






/*-- SEQ 2383 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_NFE_2 CASCADE;

/*-- SEQ 2384 --*/
CREATE OR REPLACE VIEW TV_NFE_2 AS
SELECT CODFIL, DATAOK,
       COALESCE(TIPREG,'')||
       COALESCE(TIPRPS,'')||
       COALESCE(CODSER,'')||
       COALESCE(NUMNOT,'')||
       COALESCE(DATHOR,'')||
       COALESCE(SITRPS,'')||
       COALESCE(TO_CHAR(VLRMOV),'')||
       COALESCE(TO_CHAR(VLRDED),'')||
       COALESCE(CODCDS,'')||
       COALESCE(PERISS,'')||
       COALESCE(IDEISS,'')||
       COALESCE(TIPDOC,'')||
       COALESCE(NUMDOC,'')||
       COALESCE(INSMUN,'')||
       COALESCE(INSEST,'')||
       COALESCE(NOMCLI,'')||
       COALESCE(TIPLOG,'')||
       COALESCE(ENDERE,'')||
       COALESCE(NUMERO,'')||
       COALESCE(COMPLE,'')||
       COALESCE(BAIRRO,'')||
       COALESCE(NOMCID,'')||
       COALESCE(SIGEST,'')||
       COALESCE(CODCEP,'')||
       COALESCE(E_MAIL,'')||
       COALESCE(ESPMAT,'') AS LINHA
  FROM (SELECT VEN.CODFIL,
               ven.sequen,
               VEN.DATHOR AS DATAOK,
               TO_CHAR('2') AS TIPREG,
               CASE WHEN (SELECT count(*)
                            FROM TT_IVE
                           WHERE CODFIL = IVE.CODFIL
                             AND SEQUEN = IVE.SEQUEN
                             AND NUMITE = IVE.NUMITE
                             AND TIPPRO <> '1') > 0
                    THEN TO_CHAR('RPS-M')
                    ELSE TO_CHAR('RPS  ')
                END AS TIPRPS,
               RPAD(TRIM(FIS.SEREXP),5,' ') AS CODSER,
               LPAD(TRIM(VEN.NUMNOT),12,'0') AS NUMNOT,
               TO_CHAR(VEN.DATHOR,'YYYYMMDD') AS DATHOR,
               CASE WHEN IVE.SITMOV = 'C' 
                    THEN TO_CHAR('C')
                    ELSE CASE WHEN IVE.TAX001 > 0 
                              THEN TO_CHAR('T')
                              ELSE CASE WHEN (IVE.TAX001 = 0) AND (MUN.NOMCID = 'SAO PAULO')
                                        THEN TO_CHAR('I')
                                        ELSE TO_CHAR('F')
                                    END
                          END
                END AS SITRPS,
               LPAD(TO_CHAR(ROUND(IVE.VLRMOV * 100,0)),15,'0') AS VLRMOV,
               LPAD(TO_CHAR(ROUND(0 * 100,0)),15,'0') AS VLRDED,
               LPAD(COALESCE(CDS.CODCDS,'0'),5,'0') AS CODCDS,
               LPAD(TO_CHAR(ROUND(COALESCE(IVE.TAX001,0) * 100,0)),4,'0') AS PERISS,
               TO_CHAR('2') AS IDEISS,
               LPAD(TO_CHAR(ROUND(COALESCE(IVE.VLR001,0) * 100,0)),15,'0') AS ISSRET,
               CASE WHEN CLI.FLGTIP = '0'
                    THEN TO_CHAR('1')
                    ELSE CASE WHEN (COALESCE(ENDE.NUMDOC,CLI.NUMDOC) IS NOT NULL) AND (CLI.FLGTIP = '1')
                              THEN TO_CHAR('2')
                              ELSE TO_CHAR('3')
                          END
                END AS TIPDOC,
               LPAD(COALESCE(COALESCE(ENDE.NUMDOC,CLI.NUMDOC),'00000000000000'),14,'0') AS NUMDOC,
               CASE WHEN (ENDE.SIGEST = 'SP') AND (MUN.NOMCID = 'SAO PAULO')
                    THEN LPAD(COALESCE(ENDE.INSMUN,'0'),12,'0')
                    ELSE TO_CHAR('00000000')
                END AS INSMUN,
               CASE WHEN (ENDE.SIGEST = 'SP') AND (MUN.NOMCID = 'SAO PAULO')
                    THEN TO_CHAR('000000000000')
                    ELSE LPAD(COALESCE(ENDE.INSEST,'0'),12,'0')
                END AS INSEST,
               RPAD(COALESCE(CLI.NOMCLI,' ')||'/'||COALESCE(CLI.ULTNOM,' '),75,' ') AS NOMCLI,
               RPAD(SUBSTR(COALESCE(LOG.TIPLOG,'RUA'),1,3),3,' ') AS TIPLOG,
               RPAD(SUBSTR(COALESCE(ENDE.ENDERE,' '),1,50),50,' ') AS ENDERE,
               RPAD(COALESCE(TO_CHAR(ENDE.NUMERO),' '),10,' ') AS NUMERO,
               RPAD(COALESCE(ENDE.COMPLE,' '),30,' ') AS COMPLE,
               RPAD(COALESCE(ENDE.BAIRRO,' '),30,' ') AS BAIRRO,
               RPAD(COALESCE(ENDE.NOMCID,' '),50,' ') AS NOMCID,
               RPAD(COALESCE(ENDE.SIGEST,' '),2,' ') AS SIGEST,
               COALESCE(ENDE.CODCEP,'00000')||COALESCE(ENDE.CODLOG,'000') AS CODCEP,
               RPAD(COALESCE(SPC.E_MAIL,' '),75,' ') AS E_MAIL,
               TRIM(PRO.DESMAT) AS ESPMAT
          FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN
                          INNER JOIN TT_FIS FIS ON FIS.CODSER = VEN.CODSER AND FIS.SUBSER = VEN.NUMECF
                          INNER JOIN TT_GRA GRA ON GRA.FILMAT = IVE.FILMAT AND GRA.CODMAT = IVE.CODMAT
                                               AND GRA.CODCOR = IVE.CODCOR AND GRA.CODTAM = IVE.CODTAM
                          INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
                           LEFT JOIN TD_CDS CDS ON CDS.CODTAB = PRO.CODCDS
                          INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                          INNER JOIN TT_END ENDE ON ENDE.FILCLI = CLI.FILCLI AND ENDE.CODCLI = CLI.CODCLI AND ENDE.NUMEND = COALESCE(VEN.ENDENT,1)
                           LEFT JOIN TD_DOC DOC ON DOC.TIPDOC = CLI.TIPDOC
                           LEFT JOIN TT_SPC SPC ON SPC.FILCLI = CLI.FILCLI AND SPC.CODCLI = CLI.CODCLI
                           LEFT JOIN TT_MUN MUN ON MUN.CODIGO = ENDE.CODCID
                           LEFT JOIN TT_LOG LOG ON LOG.CODCEP = ENDE.CODCEP
         WHERE IVE.TIPPRO = '1'
           AND VEN.CODSER <> 'CF'
           AND FIS.ORIGEM = 'V'
           AND FIS.EXPORT = 'T') REG1
;


/*-- SEQ 2385 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_NFE_3 CASCADE;

/*-- SEQ 2386 --*/
CREATE OR REPLACE VIEW TV_NFE_3 AS
SELECT CODFIL, DATAOK,
       COALESCE(TIPREG,'')||
       COALESCE(TIPRPS,'')||
       COALESCE(CODSER,'')||
       COALESCE(NUMNOT,'')||
       COALESCE(DATHOR,'')||
       COALESCE(SITRPS,'')||
       COALESCE(TO_CHAR(VLRMOV),'')||
       COALESCE(TO_CHAR(VLRDED),'')||
       COALESCE(CODCDS,'')||
       COALESCE(TO_CHAR(PERISS),'')||
       COALESCE(ISSRET,'')||
       COALESCE(TIPDOC,'')||
       COALESCE(NUMDOC,'')||
       COALESCE(ESPMAT,'') AS LINHA
  FROM (SELECT VEN.CODFIL,
               ven.sequen,
               VEN.DATHOR AS DATAOK,
               TO_CHAR('3') AS TIPREG,
               TO_CHAR('RPS-C') AS TIPRPS,
               RPAD(TRIM(FIS.SEREXP),5,' ') AS CODSER,
               LPAD(TRIM(VEN.NUMNOT),12,'0') AS NUMNOT,
               TO_CHAR(VEN.DATHOR,'YYYYMMDD') AS DATHOR,
               CASE WHEN IVE.SITMOV = 'C'
                    THEN 'C'
                    ELSE 'T'
                END AS SITRPS,
               LPAD(TO_CHAR(ROUND(IVE.VLRMOV * 100,0)),15,'0') AS VLRMOV,
               LPAD(TO_CHAR(ROUND(0 * 100,0)),15,'0') AS VLRDED,
               LPAD(COALESCE(CDS.CODCDS,'0'),5,'0') AS CODCDS,
               LPAD(TO_CHAR(ROUND(COALESCE(IVE.TAX001,0) * 100,0)),4,'0') AS PERISS,
               LPAD(TO_CHAR(ROUND(IVE.VLR001 * 100,0)),15,'0') AS ISSRET,
             CASE WHEN CLI.FLGTIP = '0'
                    THEN '1'
                    ELSE CASE WHEN (COALESCE(ENDE.NUMDOC,CLI.NUMDOC) IS NOT NULL) AND (CLI.FLGTIP = '1')
                              THEN '2'
                              ELSE '3'
                          END
                END AS TIPDOC,
               LPAD(COALESCE(COALESCE(ENDE.NUMDOC,CLI.NUMDOC),'00000000000000'),14,'0') AS NUMDOC,
               TRIM(PRO.DESMAT) AS ESPMAT
          FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN
                          INNER JOIN TT_FIS FIS ON FIS.CODSER = VEN.CODSER AND FIS.SUBSER = VEN.NUMECF
                          INNER JOIN TT_GRA GRA ON GRA.FILMAT = IVE.FILMAT AND GRA.CODMAT = IVE.CODMAT
                                               AND GRA.CODCOR = IVE.CODCOR AND GRA.CODTAM = IVE.CODTAM
                          INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
                           LEFT JOIN TD_CDS CDS ON CDS.CODTAB = PRO.CODCDS
                          INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                          INNER JOIN TT_END ENDE ON ENDE.FILCLI = CLI.FILCLI AND ENDE.CODCLI = CLI.CODCLI AND ENDE.NUMEND = COALESCE(VEN.ENDENT,1)
                           LEFT JOIN TD_DOC DOC ON DOC.TIPDOC = CLI.TIPDOC
                           LEFT JOIN TT_SPC SPC ON SPC.FILCLI = CLI.FILCLI AND SPC.CODCLI = CLI.CODCLI
                           LEFT JOIN TT_MUN MUN ON MUN.CODIGO = ENDE.CODCID
                           LEFT JOIN TT_LOG LOG ON LOG.CODCEP = ENDE.CODCEP
         WHERE IVE.TIPPRO = '1'
           AND VEN.CODSER = 'CF'
           AND FIS.ORIGEM = 'V'
           AND FIS.EXPORT = 'T') REG1
;


/*-- SEQ 2387 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_NFP CASCADE;

/*-- SEQ 2388 --*/
CREATE OR REPLACE VIEW TV_NFP AS
SELECT ECF.FILECF,
       ECF.NUMECF,
       RECF.DATOPE,
       ECF.CODFAB,
       ECF.CODMOD,
       ECF.SERECF,
       TO_CHAR('E00')||
       RPAD(TRIM(ECF.SERECF),20,' ')||TO_CHAR('A')||TO_CHAR('01')||'ECF-IF '||RPAD(TRIM(ECF.MARECF),20,' ')||RPAD(TRIM(ECF.MODECF),20,' ')||'000000'||'00'||
       CASE WHEN CFG.FILIAL_CONTRATO = 0
            THEN LPAD(TRIM('83137562000109'),14,'0')||LPAD(TRIM('252418859'),14,'0')||LPAD(TRIM('4370'),14,'0')||RPAD(TO_CHAR('OFICINA SOFTWARE LTDA.'),40,' ')
            ELSE LPAD(TRIM('04303719000152'),14,'0')||LPAD(TRIM('254350518'),14,'0')||LPAD(TRIM('69006'),14,'0')||RPAD(TO_CHAR('TOTALL SISTEMAS LTDA.'),40,' ')
       END||
       RPAD(TO_CHAR('TOTALL CHECKOUT'),40,' ')||
       RPAD(CASE WHEN FIL.CHEHOM IS NOT NULL THEN FIL.CHEHOM ELSE '' END,10,' ')||
       LPAD(' ',84,' ') AS LINHA
  FROM TT_CFG CFG,
       TD_ECF ECF INNER JOIN TD_FIL FIL ON FIL.CODFIL = ECF.FILECF
                  INNER JOIN TR_ECF RECF ON RECF.CODFIL = ECF.FILECF AND RECF.NUMECF = ECF.NUMECF
                  INNER JOIN TT_FIS FIS ON FIS.CODSER = 'CF' AND FIS.SUBSER = ECF.NUMECF
 WHERE FIS.ORIGEM = 'V'
   AND FIS.EXPORT = 'T'
--   AND ECF.NUMECF = '999'
--   AND RECF.DATOPE = TO_DATE('24/04/2006','DD/MM/YYYY')
UNION ALL
SELECT ECF.FILECF,
       ECF.NUMECF,
       RECF.DATOPE,
       ECF.CODFAB,
       ECF.CODMOD,
       ECF.SERECF,
       TO_CHAR('E01')||
       RPAD(TRIM(SUBSTR(ECF.SERECF,1,20)),20,' ')||TO_CHAR('A')||'ECF-IF '||RPAD(TRIM(ECF.MARECF),20,' ')||RPAD(TRIM(ECF.MODECF),20,' ')||
       RPAD(ECF.VSWECF,10,' ')||
       COALESCE(TO_CHAR(ECF.DSWECF,'YYYYMMDD'),TO_CHAR('        '))||
       COALESCE(TO_CHAR(ECF.DSWECF,'HHMMSS'),TO_CHAR('      '))||
       ECF.NUMECF||LPAD(TRIM(FIL.CGCFIL),14,'0')||'APL'||
       LPAD(TO_CHAR(RECF.CNT_RZ),6,'0')||LPAD(TO_CHAR(RECF.CNT_RZ),6,'0')||
       COALESCE(TO_CHAR(RECF.DATOPE,'YYYYMMDD'),TO_CHAR('        '))||
       COALESCE(TO_CHAR(RECF.DATOPE,'YYYYMMDD'),TO_CHAR('        '))||
       TO_CHAR('01.01.01')||
       TO_CHAR('AC1704 01.00.00')
       AS LINHA
  FROM TD_ECF ECF INNER JOIN TD_FIL FIL ON FIL.CODFIL = ECF.FILECF
                  INNER JOIN TR_ECF RECF ON RECF.CODFIL = ECF.FILECF AND RECF.NUMECF = ECF.NUMECF
                  INNER JOIN TT_FIS FIS ON FIS.CODSER = 'CF' AND FIS.SUBSER = ECF.NUMECF
 WHERE FIS.ORIGEM = 'V'
   AND FIS.EXPORT = 'T'
-- WHERE ECF.FILECF = '001'
--   AND ECF.NUMECF = '999'
--   AND RECF.DATOPE = TO_DATE('24/04/2006','DD/MM/YYYY')
UNION ALL
SELECT ECF.FILECF,
       ECF.NUMECF,
       RECF.DATOPE,
       ECF.CODFAB,
       ECF.CODMOD,
       ECF.SERECF,
       TO_CHAR('E02')||
       RPAD(TRIM(SUBSTR(ECF.SERECF,1,20)),20,' ')||TO_CHAR('A')||RPAD(TRIM(ECF.MODECF),20,' ')||
       LPAD(TRIM(FIL.CGCFIL),14,'0')||
       RPAD(TRIM(FIL.IE_FIL),14,' ')||
       RPAD(TRIM(FIL.RAZSOC),40,' ')||
       RPAD(TRIM(FIL.ENDERE),120,' ')||
       COALESCE(TO_CHAR(FIL.INIFIL,'YYYYMMDD'),TO_CHAR('        '))||
       COALESCE(TO_CHAR(FIL.INIFIL,'HHMMSS'),TO_CHAR('      '))||
       LPAD(TRIM(TO_CHAR(RECF.CNT_RO)),6,'0')||
       LPAD(TRIM(TO_CHAR(ROUND(RECF.GT_FIM * 100,0))),18,'0')||TO_CHAR('01')
  FROM TD_ECF ECF INNER JOIN TD_FIL FIL ON FIL.CODFIL = ECF.FILECF
                  INNER JOIN TR_ECF RECF ON RECF.CODFIL = ECF.FILECF AND RECF.NUMECF = ECF.NUMECF
                  INNER JOIN TT_FIS FIS ON FIS.CODSER = 'CF' AND FIS.SUBSER = ECF.NUMECF
 WHERE FIS.ORIGEM = 'V'
   AND FIS.EXPORT = 'T'
-- WHERE ECF.FILECF = '001'
--   AND ECF.NUMECF = '999'
--   AND RECF.DATOPE = TO_DATE('24/04/2006','DD/MM/YYYY')
UNION ALL
SELECT ECF.FILECF,
       ECF.NUMECF,
       RECF.DATOPE,
       ECF.CODFAB,
       ECF.CODMOD,
       ECF.SERECF,
       TO_CHAR('E12')||
       RPAD(TRIM(SUBSTR(ECF.SERECF,1,20)),20,' ')||TO_CHAR('A')||RPAD(TRIM(ECF.MODECF),20,' ')||
       '01'||
       LPAD(TO_CHAR(RECF.CNT_RZ),6,'0')||
       LPAD(TO_CHAR(RECF.CUPFIM),6,'0')||
       LPAD(TO_CHAR(RECF.CNT_RO),6,'0')||
       COALESCE(TO_CHAR(RECF.DATOPE,'YYYYMMDD'),TO_CHAR('        '))||
       COALESCE(TO_CHAR(RECF.DATFEC,'YYYYMMDD'),TO_CHAR('        '))||
       COALESCE(TO_CHAR(RECF.DATFEC,'HHMMSS'),TO_CHAR('      '))||
       LPAD(TO_CHAR(ROUND((RECF.GT_FIM - RECF.GT_INI) * 100,0)),14,'0')||'N'
  FROM TD_ECF ECF INNER JOIN TD_FIL FIL ON FIL.CODFIL = ECF.FILECF
                  INNER JOIN TR_ECF RECF ON RECF.CODFIL = ECF.FILECF AND RECF.NUMECF = ECF.NUMECF
                  INNER JOIN TT_FIS FIS ON FIS.CODSER = 'CF' AND FIS.SUBSER = ECF.NUMECF
 WHERE FIS.ORIGEM = 'V'
   AND FIS.EXPORT = 'T'
-- WHERE ECF.FILECF = '001'
--   AND ECF.NUMECF = '999'
--   AND RECF.DATOPE = TO_DATE('24/04/2006','DD/MM/YYYY')
UNION ALL
SELECT ECF.FILECF,
       ECF.NUMECF,
       RECF.DATOPE,
       ECF.CODFAB,
       ECF.CODMOD,
       ECF.SERECF,
       TO_CHAR('E13')||
       RPAD(TRIM(SUBSTR(ECF.SERECF,1,20)),20,' ')||TO_CHAR('A')||RPAD(TRIM(ECF.MODECF),20,' ')||
       '01'||
       LPAD(TO_CHAR(RECF.CNT_RZ),6,'0')||
       RPAD(COALESCE(TECF.TOTPAR, TECF.TOTALI),7,' ')||LPAD(TO_CHAR(ROUND(COALESCE(TECF.VLRTOT,0) * 100,0)),13,'0') AS LINHA 
  FROM TD_ECF ECF INNER JOIN TD_FIL FIL ON FIL.CODFIL = ECF.FILECF
                  INNER JOIN TR_ECF RECF ON RECF.CODFIL = ECF.FILECF AND RECF.NUMECF = ECF.NUMECF
                  INNER JOIN TT_ECF TECF ON TECF.CODFIL = RECF.CODFIL AND TECF.NUMECF = RECF.NUMECF 
                                        AND TECF.DATOPE = RECF.DATOPE AND TECF.CNT_RO = RECF.CNT_RO 
                                        AND TECF.CNT_RZ = RECF.CNT_RZ
                  INNER JOIN TT_FIS FIS ON FIS.CODSER = 'CF' AND FIS.SUBSER = ECF.NUMECF
-- WHERE ECF.FILECF = '001'
--   AND ECF.NUMECF = '999'
--   AND RECF.DATOPE = TO_DATE('24/04/2006','DD/MM/YYYY')
 WHERE TECF.VLRTOT > 0
   AND FIS.ORIGEM = 'V'
   AND FIS.EXPORT = 'T'
UNION ALL
SELECT ECF.FILECF,
       ECF.NUMECF,
       RECF.DATOPE,
       ECF.CODFAB,
       ECF.CODMOD,
       ECF.SERECF,
       TO_CHAR('E14')||
       RPAD(TRIM(SUBSTR(ECF.SERECF,1,20)),20,' ')||TO_CHAR('A')||RPAD(TRIM(ECF.MODECF),20,' ')||
       '01'||
       LPAD(TRIM(VEN.NUMNOT),6,'0')||
       LPAD(TRIM(VEN.NUMNOT),6,'0')||
       TO_CHAR(VEN.DATHOR,'YYYYMMDD')||
       LPAD(TO_CHAR(ROUND(SUM(IVE.VLRMOV) * 100,0)),14,'0')|| -- E14-09 (soma de E15-16)
       LPAD(TO_CHAR(CASE WHEN (SUM(IVE.VLRMOV) - VEN.VLRLIQ) > 0
                 THEN ROUND(ABS(SUM(IVE.VLRMOV) - VEN.VLRLIQ) * 100,0)
                 ELSE 0
             END),13,'0')|| -- E14-10
       CASE WHEN (SUM(IVE.VLRMOV) - VEN.VLRLIQ) > 0
            THEN TO_CHAR('V')
            ELSE TO_CHAR(' ')
        END|| 
       LPAD(TO_CHAR(CASE WHEN (SUM(IVE.VLRMOV) - VEN.VLRLIQ) < 0
                 THEN ROUND(ABS(VEN.VLRLIQ - SUM(IVE.VLRMOV)) * 100,0)
                 ELSE 0
             END),13,'0')|| -- E14-12
       CASE WHEN (SUM(IVE.VLRMOV) - VEN.VLRLIQ) < 0
            THEN TO_CHAR('V')
            ELSE TO_CHAR(' ')
        END||
       LPAD(TO_CHAR(ROUND(SUM(IVE.VLRMOV) * 100,0) - 
             CASE WHEN (SUM(IVE.VLRMOV) - VEN.VLRLIQ) > 0
                  THEN ROUND(ABS(SUM(IVE.VLRMOV) - VEN.VLRLIQ) * 100,0)
                  ELSE 0
             END + 
             CASE WHEN (SUM(IVE.VLRMOV) - VEN.VLRLIQ) < 0
                 THEN ROUND(ABS(VEN.VLRLIQ - SUM(IVE.VLRMOV)) * 100,0)
                 ELSE 0
             END),14,'0')|| -- E14-14 = E14-09  E14-10 + E14-12
       CASE WHEN VEN.FLGEST = 'C'
            THEN 'S'
            ELSE 'N'
         END||
       LPAD('0',13,'0')||
       TO_CHAR(' ')||
       RPAD((COALESCE(CLI.NOMCLI,' ')||' '||COALESCE(CLI.ULTNOM,' ')),40,' ')||
       LPAD(COALESCE(TRIM(COALESCE(VEN.DOCNFP,CLI.NUMDOC)),'0'),14,'0')
  FROM TD_ECF ECF INNER JOIN TD_FIL FIL ON FIL.CODFIL = ECF.FILECF
                  INNER JOIN TR_ECF RECF ON RECF.CODFIL = ECF.FILECF AND RECF.NUMECF = ECF.NUMECF
                  INNER JOIN TT_VEN VEN ON (RECF.CODFIL = VEN.CODFIL AND RECF.NUMECF = VEN.NUMECF AND RECF.CNT_RO = VEN.CNT_RO)
                                       and VEN.NUMNOT NOT LIKE '%#%'
                                               and TO_NUMBER(REPLACE(VEN.NUMNOT,'#','')) BETWEEN RECF.CUPINI AND RECF.CUPFIM
                                               and VEN.VLRLIQ > 0
                                               and VEN.CODSER IN ('CF','TK')
                                               and VEN.FLGEST <> 'C'
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                  INNER JOIN TT_FIS FIS ON FIS.CODSER = 'CF' AND FIS.SUBSER = ECF.NUMECF
                  INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL 
                                       AND IVE.SEQUEN = VEN.SEQUEN
 WHERE FIS.ORIGEM = 'V'
   AND FIS.EXPORT = 'T'
   AND IVE.SITKIT IN ('1','2')
   AND COALESCE(VEN.DOCNFP,CLI.NUMDOC) IS NOT NULL   
   AND (IVE.SITMOV='N' OR VEN.FLGEST='C')
-- WHERE ECF.FILECF = '001'
--   AND ECF.NUMECF = '999'
--   AND RECF.DATOPE = TO_DATE('24/04/2006','DD/MM/YYYY')
 GROUP BY ECF.FILECF, ECF.NUMECF, RECF.DATOPE, ECF.CODFAB, ECF.CODMOD, ECF.SERECF,
          ECF.SERECF, ECF.MODECF, VEN.NUMNOT, VEN.DATHOR, VEN.VLRLIQ, VEN.FLGEST, 
          CLI.NOMCLI, CLI.ULTNOM, VEN.DOCNFP, CLI.NUMDOC
UNION ALL
SELECT ECF.FILECF,
       ECF.NUMECF,
       RECF.DATOPE,
       ECF.CODFAB,
       ECF.CODMOD,
       ECF.SERECF,
       TO_CHAR('E15')||
       RPAD(TRIM(SUBSTR(ECF.SERECF,1,20)),20,' ')||TO_CHAR('A')||RPAD(TRIM(ECF.MODECF),20,' ')||
       '01'||
       LPAD(TRIM(VEN.NUMNOT),6,'0')||
       LPAD(TRIM(VEN.NUMNOT),6,'0')||
       LPAD(TO_CHAR(IVE.NUMITE),3,'0')||
       RPAD(GRA.FILMAT||LPAD(TRIM(GRA.SEQUEN),10,'0'),14,' ')||
       REPLACE(RPAD(COALESCE(GRA.DESMAT ,'')|| ' ' || COALESCE(GRA.ESPMAT ,'')|| ' ' || RTRIM(COALESCE(GRA.ITEDIV,'')) ||'/'||COALESCE(GRA.ITESUB,''), 100),'"',' ')||
       LPAD(TO_CHAR(ROUND(IVE.QTDMOV * 100,0)),7,'0')||
       RPAD(GRA.MEDUNI,3,' ')||
       LPAD(TO_CHAR(ROUND(ROUND(IVE.VLRMOV / IVE.QTDMOV,2) * 100,0)), 8, '0')||
       LPAD('0', 8, '0')||
       LPAD('0', 8, '0')||
       LPAD(TO_CHAR(ROUND(IVE.VLRMOV * 100,0)), 14,'0')|| -- E15-16
       RPAD((SELECT DISTINCT COALESCE(TECF.TOTPAR, TECF.TOTALI)
               FROM TT_ECF TECF 
              WHERE TECF.CODFIL = RECF.CODFIL
                AND TECF.NUMECF = RECF.NUMECF
                AND TECF.DATOPE = RECF.DATOPE
                AND TECF.CNT_RZ = RECF.CNT_RZ
                AND TECF.CNT_RO = RECF.CNT_RO
                AND TECF.TOTALI = CASE IVE.ICMTIP WHEN '0' THEN LPAD(TO_CHAR(ROUND((IVE.TAX001 * 100),0)),4,'0')
                                                  WHEN '1' THEN 'NAOT'
                                                  WHEN '2' THEN 'ISEN'
                                                  WHEN '3' THEN 'SUBS'
                                                  WHEN '4' THEN 'ISEN'
                                                  ELSE TO_CHAR(' ')
                                   END
                 LIMIT 1                                 ), 7, ' ') ||
       CASE WHEN IVE.SITMOV <> 'C'
            THEN 'N'
            ELSE 'S'
       END||'0000000'||'0000000000000'||'0000000000000'||'A'||'2'||'2'
  FROM TD_ECF ECF INNER JOIN TD_FIL FIL ON FIL.CODFIL = ECF.FILECF
                  INNER JOIN TR_ECF RECF ON RECF.CODFIL = ECF.FILECF AND RECF.NUMECF = ECF.NUMECF
                  INNER JOIN TT_VEN VEN ON (RECF.CODFIL = VEN.CODFIL AND RECF.NUMECF = VEN.NUMECF AND RECF.CNT_RO = VEN.CNT_RO)
                                       and VEN.NUMNOT NOT LIKE '%#%'
                                               and TO_NUMBER(REPLACE(VEN.NUMNOT,'#','')) BETWEEN RECF.CUPINI AND RECF.CUPFIM
                                               and VEN.VLRLIQ > 0
                                               and VEN.CODSER IN ('CF','TK')
                                               and VEN.FLGEST <> 'C'
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                  INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN
                  INNER JOIN TV_IPR GRA ON GRA.FILMAT = IVE.FILMAT AND GRA.CODMAT = IVE.CODMAT
                                       AND GRA.CODCOR = IVE.CODCOR AND GRA.CODTAM = IVE.CODTAM
                  INNER JOIN TT_FIS FIS ON FIS.CODSER = 'CF' AND FIS.SUBSER = ECF.NUMECF
 WHERE FIS.ORIGEM = 'V'
   AND FIS.EXPORT = 'T'
   AND IVE.SITKIT IN ('1','2')
-- WHERE ECF.FILECF = '001'
--   AND ECF.NUMECF = '999'
--   AND RECF.DATOPE = TO_DATE('24/04/2006','DD/MM/YYYY')
UNION ALL
SELECT ECF.FILECF,
       ECF.NUMECF,
       RECF.DATOPE,
       ECF.CODFAB,
       ECF.CODMOD,
       ECF.SERECF,
       TO_CHAR('E21')||
       RPAD(TRIM(SUBSTR(ECF.SERECF,1,20)),20,' ')||TO_CHAR('A')||RPAD(TRIM(ECF.MODECF),20,' ')||
       '01'||
       LPAD(TRIM(VEN.NUMNOT),6,'0')||
       LPAD(TRIM(VEN.NUMNOT),6,'0')||
       CASE WHEN REC.CARTAO IS NOT NULL
            THEN LPAD(TO_CHAR(TO_NUMBER(TRIM(VEN.NUMNOT))+1),6,'0')
            ELSE LPAD('0',6,'0')
         END||
       RPAD(CASE WHEN REC.SEQCHE IS NOT NULL
                 THEN 'CHEQUE'
                 ELSE CASE WHEN REC.CODMOE <> 0
                           THEN 'CAMBIO'
                           ELSE CASE WHEN (REC.TIPCCC IS NOT NULL) OR (CCC.CODFIL IS NOT NULL)
                                     THEN 'C/C'
                                     ELSE CASE WHEN REC.CARTAO IS NOT NULL
                                               THEN 'CARTAO'
                                               ELSE 'OUTROS'
                                           END
                                 END
                      END
             END,15,' ')||
       LPAD(TO_CHAR(ROUND(REC.VLRPGT * 100,0)),13,'0')||
       CASE WHEN REC.FLGEST = 'X'
            THEN 'S'
            ELSE 'N'
        END||
       LPAD(TO_CHAR(ROUND(REC.VLRPGT * 100,0)),13,'0')
  FROM TD_ECF ECF INNER JOIN TD_FIL FIL ON FIL.CODFIL = ECF.FILECF
                  INNER JOIN TR_ECF RECF ON RECF.CODFIL = ECF.FILECF AND RECF.NUMECF = ECF.NUMECF
                  INNER JOIN TT_VEN VEN ON (RECF.CODFIL = VEN.CODFIL AND RECF.NUMECF = VEN.NUMECF AND RECF.CNT_RO = VEN.CNT_RO)
                                       and VEN.NUMNOT NOT LIKE '%#%'
                                               and TO_NUMBER(REPLACE(VEN.NUMNOT,'#','')) BETWEEN RECF.CUPINI AND RECF.CUPFIM
                                               and VEN.VLRLIQ > 0
                                               and VEN.CODSER IN ('CF','TK')
                                               and VEN.FLGEST <> 'C'
                  INNER JOIN TT_REC REC ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
                  INNER JOIN TT_FIS FIS ON FIS.CODSER = 'CF' AND FIS.SUBSER = ECF.NUMECF
                   LEFT JOIN TT_CCC CCC ON CCC.CODFIL = REC.FILCCC AND CCC.SEQUEN = REC.SEQCCC
 WHERE FIS.ORIGEM = 'V'
   AND FIS.EXPORT = 'T'
;


/*-- SEQ 2389 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_NFP_MD1 CASCADE;

/*-- SEQ 2390 --*/
CREATE OR REPLACE VIEW TV_NFP_MD1 AS
SELECT DISTINCT FIL.CODFIL,
       TO_CHAR('  ') AS CODSER,
       TO_CHAR('000') AS NUMECF,
       0 AS NUMNOT,
       0 AS VLRLIQ,
       0 AS NUMITE,
       TRUNC(MIN(TRUNC(VEN.DATHOR))) AS DATHOR,
       TO_CHAR('10|1,00')||'|'||
       LPAD(TRIM(FIL.CGCFIL),14,'0')||'|'||
       'DATINI'||'|'||
       'DATFIN' AS LINHA
 FROM TD_FIL FIL INNER JOIN TW_VEN_FIS VEN ON VEN.CODFIL = FIL.CODFIL
 GROUP BY FIL.CODFIL, FIL.CGCFIL
UNION ALL
SELECT VEN.CODFIL,
       VEN.CODSER,
       VEN.NUMECF,
       VEN.NUMNOT,
       VEN.VLRLIQ,
       0 AS NUMITE,
       VEN.DATHOR,
       TO_CHAR('20')||'|'||
       TO_CHAR('I')||'||'||
       NAT.NATURE||'|'||
       TRIM(VEN.CODSER)||'|'||
       TRIM(to_char(VEN.NUMNOT))||'|'||
       TO_CHAR(VEN.DATHOR,'DD/MM/YYYY HH24:MI:SS')||'|'||
       TO_CHAR(COALESCE(VEN.DATSAI,VEN.DATHOR),'DD/MM/YYYY HH24:MI:SS')||'|'||
       CASE WHEN NAT.TIPNAT IN ('D','E','P')
            THEN '0'
            ELSE '1'
        END||'|'||
       CASE WHEN VEN.UFLOJA = 'T'
            THEN SUBSTR(TRIM(NAT.NATDEN),1,4)
            ELSE SUBSTR(TRIM(NAT.NATFOR),1,4)
        END||'|'||
       TRIM(COALESCE(ENDE.INSEST,CLI.INSEST,''))||'| |'||
       CASE WHEN CLI.ESTRAN = 'T' THEN '00000000000000' ELSE TRIM(COALESCE(VEN.DOCNFP,COALESCE(ENDE.NUMDOC,CLI.NUMDOC))) END||'|'||
       SUBSTR(CLI.NOMCLI||COALESCE(CLI.ULTNOM,TO_CHAR(' ')),1,60)||'|'||
       TRIM(SUBSTR(COALESCE(ENDE.ENDERE,' '),1,60))||'|'||
       TRIM(SUBSTR(COALESCE(ENDE.NUMERO,' '),1,60))||'|'||
       TRIM(SUBSTR(COALESCE(ENDE.COMPLE,' '),1,60))||'|'||
       TRIM(SUBSTR(COALESCE(ENDE.BAIRRO,' '),1,60))||'|'||
       CASE WHEN CLI.ESTRAN = 'T' THEN 'EX' ELSE TRIM(SUBSTR(COALESCE(ENDE.NOMCID,' '),1,60)) END||'|'||
       CASE WHEN CLI.ESTRAN = 'T' THEN 'EX' ELSE TRIM(COALESCE(ENDE.SIGEST,' ')) END||'|'||
       TRIM(COALESCE(ENDE.CODCEP,' ')||COALESCE(ENDE.CODLOG,' '))||'| |'||
       TRIM(COALESCE(ENDE.NUMFON,' '))||'|'||
       TRIM(COALESCE(ENDE.INSEST,' ')) AS LINHA
 FROM TW_VEN_FIS VEN INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
                     INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND VEN.CODCLI = CLI.CODCLI
                      LEFT JOIN TT_END ENDE ON ENDE.FILCLI = CLI.FILCLI AND ENDE.CODCLI = CLI.CODCLI
                                           AND ENDE.CODFIL = COALESCE(VEN.FILENT,ENDE.CODFIL) AND ENDE.NUMEND = COALESCE(VEN.ENDENT,1)
WHERE VEN.FLGEST <> 'C'
UNION ALL
SELECT VEN.CODFIL,
       VEN.CODSER,
       VEN.NUMECF,
       VEN.NUMNOT,
       0 AS VLRLIQ,
       IVE.NUMITE,
       VEN.DATHOR,
       CASE WHEN VEN.FLGEST <> 'C'
            THEN
       TO_CHAR('30')||'|'||
       GRA.FILMAT||REPLACE(GRA.SEQUEN,' ','0')||'|'||
       REPLACE(COALESCE(PRO.DESMAT ,'')|| ' ' || COALESCE(PRO.ESPMAT ,'')|| ' ' || RTRIM(COALESCE(DIV.NOMITE,'')) ||'/'||COALESCE(SUB.NOMITE,''),'"',' ')||TO_CHAR('|        |')||
       UPPER(COALESCE(MED.UNIMED,'  '))||'|'||
       REPLACE(TO_CHAR(ABS(ROUND(IVE.QTDMOV,4))),'.',',')||'|'||
       REPLACE(TO_CHAR(ABS(ROUND((IVE.VLRMOV - COALESCE(IVE.VLR002,0)) / IVE.QTDMOV,4))),'.',',')||'|'||
       REPLACE(TO_CHAR(ABS(ROUND(IVE.VLRMOV,2) - COALESCE(IVE.VLR002,0))),'.',',')||'|'||
       IVE.CODCST||'|'||
       REPLACE(TO_CHAR(ABS(ROUND(IVE.TAX001,2))),'.',',')||'|'||
       REPLACE(TO_CHAR(ABS(ROUND(IVE.TAX002,2))),'.',',')||'|'||
       REPLACE(TO_CHAR(ABS(ROUND(IVE.VLR002,2))),'.',',')
       ELSE TO_CHAR('')
       END AS LINHA
 FROM TW_VEN_FIS VEN INNER JOIN TW_IVE_FIS IVE ON IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN
                     INNER JOIN TT_GRA GRA ON GRA.FILMAT = IVE.FILMAT AND GRA.CODMAT = IVE.CODMAT
                                          AND GRA.CODCOR = IVE.CODCOR AND GRA.CODTAM = IVE.CODTAM
                     INNER JOIN TT_DIV DIV ON GRA.CODCOR = DIV.CODITE
                     INNER JOIN TT_SUB SUB ON GRA.CODTAM = SUB.CODITE
                     INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
                     INNER JOIN TD_MED MED ON MED.CODTAB = GRA.UNIDAD
WHERE VEN.FLGEST <> 'C'
UNION ALL
SELECT VEN.CODFIL,
       VEN.CODSER,
       VEN.NUMECF,
       VEN.NUMNOT,
       0 AS VLRLIQ,
       0 AS NUMITE,
       VEN.DATHOR,
       CASE WHEN VEN.FLGEST <> 'C'
            THEN
       TO_CHAR('40')||'|'||
       REPLACE(to_char(ROUND(ABS(SUM(IVE.BASICM + COALESCE(IVE.VLRFRE,0) - COALESCE(IVE.OUTTAX,0) + COALESCE(IVE.VLRSEG,0) )),2)),'.',',')||'|'||
       REPLACE(to_char(ROUND(SUM(IVE.VLR001 + COALESCE(IVE.ICMTAX,0)),2)),'.',',')||'|'||
       REPLACE(to_char(ROUND(MIN((SELECT V.BASUBS FROM TW_VEN_FIS V WHERE V.CODFIL = VEN.CODFIL AND V.SEQUEN = VEN.SEQUEN)) ,2)),'.',',')||'|'||
       REPLACE(to_char(ROUND(MIN((SELECT V.SUBSTT FROM TW_VEN_FIS V WHERE V.CODFIL = VEN.CODFIL AND V.SEQUEN = VEN.SEQUEN)) ,2)),'.',',')||'|'||
       REPLACE(to_char(ROUND(SUM(IVE.VLRMOV - COALESCE(IVE.VLR002,0)),2)),'.',',')||'|'||
       REPLACE(to_char(ROUND(SUM(IVE.VLRFRE),2)),'.',',')||'|'||
       REPLACE(to_char(ROUND(SUM(IVE.VLRSEG),2)),'.',',')||'|'||
       REPLACE(to_char(ABS(ROUND(SUM(ABS(CASE WHEN VEN.DESCON <> 0 THEN ABS(IVE.VLRMOV - IVE.ITELIQ) ELSE 0 END)),2))),'.',',')||'|'||
       REPLACE(to_char(ROUND(SUM(IVE.VLR002),2)),'.',',')||'|'||
       REPLACE(to_char(ROUND(MIN(ABS(COALESCE(VEN.OUTTAX,0))),2)),'.',',')||'|'||
       REPLACE(to_char(ROUND(SUM(IVE.ITELIQ + COALESCE(IVE.OUTTAX,0) + COALESCE(IVE.VLRFRE,0) + COALESCE(IVE.VLRSEG,0)),2)),'.',',') ||'|'||
       REPLACE(to_char(ROUND(SUM(IVE.BASINT),2)),'.',',')||'|0,00|0,00'
       ELSE TO_CHAR('')
       END AS LINHA
  FROM TW_VEN_FIS VEN INNER JOIN TW_IVE_FIS IVE ON IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN
WHERE VEN.FLGEST <> 'C'
  AND IVE.SITKIT IN ('1','2')
GROUP BY VEN.CODFIL,VEN.CODSER,VEN.NUMECF,VEN.NUMNOT,VEN.DATHOR, VEN.FLGEST
UNION ALL
SELECT VEN.CODFIL,
       VEN.CODSER,
       VEN.NUMECF,
       VEN.NUMNOT,
       0 AS VLRLIQ,
       0 AS NUMITE,
       VEN.DATHOR,
       CASE WHEN VEN.FLGEST <> 'C'
            THEN
       TO_CHAR('50')||'|'||
	   CASE WHEN VEN.EMIDES = 'T' THEN '0' ELSE '1' END||'|'||
       CASE WHEN TRIM(COALESCE(LPAD(TRIM(COALESCE(ENDE.NUMDOC,CLI.NUMDOC)),14,'0'),'|')) = '|' 
	        THEN TO_CHAR('|')
			ELSE TRIM(COALESCE(LPAD(TRIM(COALESCE(ENDE.NUMDOC,CLI.NUMDOC)),14,'0'),'|'))||'|'
		END||
       CASE WHEN TRIM(COALESCE(SUBSTR(CLI.NOMCLI||COALESCE(CLI.ULTNOM,TO_CHAR(' ')),1,60),'|')) = '|' 
	        THEN TO_CHAR('|')
			ELSE TRIM(COALESCE(SUBSTR(CLI.NOMCLI||COALESCE(CLI.ULTNOM,TO_CHAR(' ')),1,60),'|'))||'|'
		END||
       CASE WHEN TRIM(COALESCE(COALESCE(ENDE.INSEST,CLI.INSEST),'|')) = '|' 
	        THEN TO_CHAR('|')
			ELSE TRIM(COALESCE(COALESCE(ENDE.INSEST,CLI.INSEST),'|'))||'|'
		END||
		CASE WHEN TRIM(COALESCE(SUBSTR(COALESCE(ENDE.ENDERE,' ')||' '||COALESCE(ENDE.NUMERO,' ')||' '||COALESCE(ENDE.COMPLE,' ')||' '||COALESCE(ENDE.BAIRRO,' '),1,60),'|')) = '|' 
	         THEN TO_CHAR('|')
			 ELSE TRIM(COALESCE(SUBSTR(COALESCE(ENDE.ENDERE,' ')||' '||COALESCE(ENDE.NUMERO,' ')||' '||COALESCE(ENDE.COMPLE,' ')||' '||COALESCE(ENDE.BAIRRO,' '),1,60),'|'))||'|'
		END||
		CASE WHEN TRIM(SUBSTR(COALESCE(ENDE.NOMCID,'|'),1,60)) = '|' 
	        THEN TO_CHAR('|')
			ELSE TRIM(SUBSTR(COALESCE(ENDE.NOMCID,'|'),1,60))||'|'
		END||
		CASE WHEN TRIM(COALESCE(ENDE.SIGEST,'|')) = '|' 
	        THEN TO_CHAR('|||')
			ELSE TRIM(COALESCE(ENDE.SIGEST,'|'))||'|||'
		END||
		CASE WHEN TRIM(TO_CHAR(COALESCE(TO_CHAR(TRUNC(VEN.NUMVOL)),'|'))) = '|' 
	        THEN TO_CHAR('||||')
			ELSE TRIM(TO_CHAR(COALESCE(TO_CHAR(TRUNC(VEN.NUMVOL)),'|')))||'||||'
		END||
		CASE WHEN TRIM(COALESCE(TO_CHAR(REPLACE(TO_CHAR(ROUND(VEN.PESLIQ,3)),'.',',')),'|')) = '|' 
	        THEN TO_CHAR('|')
			ELSE TRIM(COALESCE(TO_CHAR(REPLACE(TO_CHAR(ROUND(VEN.PESLIQ,3)),'.',',')),'|'))||'|'
		END||
		CASE WHEN TRIM(COALESCE(TO_CHAR(REPLACE(TO_CHAR(ROUND(VEN.PESBRU,3)),'.',',')),'|')) = '|' 
	        THEN TRIM(TO_CHAR(' '))
			ELSE TRIM(COALESCE(TO_CHAR(REPLACE(TO_CHAR(ROUND(VEN.PESBRU,3)),'.',',')),'|'))||''
		END
       ELSE TO_CHAR('')
       END AS LINHA
  FROM TW_VEN_FIS VEN LEFT JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILTRA AND CLI.CODCLI = VEN.CODTRA
                      LEFT JOIN TT_END ENDE ON ENDE.FILCLI = CLI.FILCLI AND ENDE.CODCLI = CLI.CODCLI
                                            AND ENDE.CODFIL = COALESCE(VEN.FILENT,ENDE.CODFIL) AND ENDE.NUMEND = COALESCE(VEN.ENDENT,1)
WHERE VEN.FLGEST <> 'C'
;




/*-- SEQ 2391 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_NFP_MD2 CASCADE;

/*-- SEQ 2392 --*/
CREATE OR REPLACE VIEW TV_NFP_MD2 AS
SELECT DISTINCT FIL.CODFIL,
       TO_CHAR('  ') AS CODSER,
       TO_CHAR('000') AS NUMECF,
       0 AS NUMNOT,
       0 AS VLRLIQ,
       0 AS NUMITE,
       TRUNC(MIN(TRUNC(VEN.DATHOR))) AS DATHOR,
       TO_CHAR('10|1.00')||'|'||
       LPAD(TRIM(FIL.CGCFIL),14,'0')||'|'||
       'DATINI'||'|'||
       'DATFIN' AS LINHA
 FROM TD_FIL FIL INNER JOIN TW_VEN_FIS VEN ON VEN.CODFIL = FIL.CODFIL
 GROUP BY FIL.CODFIL, FIL.CGCFIL
UNION ALL
SELECT VEN.CODFIL,
       VEN.CODSER,
       VEN.NUMECF,
       VEN.NUMNOT,
       VEN.VLRLIQ,
       0 AS NUMITE,
       VEN.DATHOR,
       TO_CHAR('20')||'|1||'||
       TRIM(to_char(VEN.NUMNOT))||'|'||
       TO_CHAR(VEN.DATHOR,'DD/MM/YYYY')||'|'||
       TO_CHAR(COALESCE(VEN.DATSAI,VEN.DATHOR),'DD/MM/YYYY')||'|'||
       CASE WHEN CLI.ESTRAN = 'T' THEN '00000000000000' ELSE TRIM(COALESCE(VEN.DOCNFP,COALESCE(ENDE.NUMDOC,CLI.NUMDOC))) END||'|'||
       SUBSTR(CLI.NOMCLI||COALESCE(CLI.ULTNOM,TO_CHAR(' ')),1,60)||'|'||
       TRIM(SUBSTR(COALESCE(ENDE.ENDERE,' '),1,60))||'|'||
       TRIM(SUBSTR(COALESCE(ENDE.NUMERO,' '),1,60))||'|'||
       TRIM(SUBSTR(COALESCE(ENDE.COMPLE,' '),1,60))||'|'||
       TRIM(SUBSTR(COALESCE(ENDE.BAIRRO,' '),1,60))||'|'||
       CASE WHEN CLI.ESTRAN = 'T' THEN 'EX' ELSE TRIM(SUBSTR(COALESCE(ENDE.NOMCID,' '),1,60)) END||'|'||
       CASE WHEN CLI.ESTRAN = 'T' THEN 'EX' ELSE TRIM(COALESCE(ENDE.SIGEST,' ')) END||'|'||
       TRIM(COALESCE(ENDE.CODCEP,' ')||COALESCE(ENDE.CODLOG,' '))||'|'||
       TRIM(COALESCE(ENDE.NUMFON,' '))||'|'||
       REPLACE(to_char(ROUND(SUM(IVE.VLRMOV),2)),'.',',')||'|'||
       REPLACE(to_char(ROUND(VEN.DESCON,2)),'.',',')||'|'||
       REPLACE(to_char(ROUND(VEN.VLRFRE,2)),'.',',')||'|'||
       REPLACE(to_char(ROUND(VEN.VLRSEG,2)),'.',',')||'|'||
       REPLACE(to_char(ROUND(COALESCE(VEN.OUTTAX,0),2)),'.',',')||'|'||
       SUBSTR(TRIM(COALESCE(VEN.OBSERV,' ')),1,60)||'|'||
       REPLACE(to_char(ROUND(SUM(IVE.ITELIQ + COALESCE(IVE.VLRFRE,0) + COALESCE(IVE.VLRSEG,0)),2)),'.',',')||'|||2|||||||'||
       CASE WHEN VEN.AVISTA = 'T' THEN '2' ELSE '1' END||'|'||
       REPLACE(to_char(ROUND(SUM(IVE.ITELIQ),2)),'.',',')||'|'||
       CASE WHEN VEN.AVISTA = 'T'
            THEN TO_CHAR('')
            ELSE TO_CHAR(REPLACE(to_char(ABS(ROUND((SELECT SUM(REC.VLRPAR)
                                      FROM TT_REC REC
                                     WHERE REC.CODFIL = VEN.CODFIL
                                       AND REC.SEQUEN = VEN.SEQUEN
                                       AND REC.SUBPAR = ' 0'),2))),'.',','))
        END||'|'||
       CASE WHEN VEN.AVISTA = 'T'
            THEN TO_CHAR('')
            ELSE TO_CHAR(ROUND((SELECT MAX(TO_NUMBER(TRIM(REC.NUMPAR)))
                          FROM TT_REC REC
                         WHERE REC.CODFIL = VEN.CODFIL
                           AND REC.SEQUEN = VEN.SEQUEN
                           AND REC.SUBPAR = ' 0'),0))
        END AS LINHA
  FROM TW_VEN_FIS VEN INNER JOIN TW_IVE_FIS IVE ON IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN
                      INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
                      INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND VEN.CODCLI = CLI.CODCLI
                       LEFT JOIN TT_END ENDE ON ENDE.FILCLI = CLI.FILCLI AND ENDE.CODCLI = CLI.CODCLI
                                            AND ENDE.NUMEND = VEN.ENDENT
GROUP BY VEN.CODFIL, VEN.CODSER, VEN.NUMECF, VEN.NUMNOT, VEN.VLRLIQ, VEN.DATHOR, VEN.DATSAI, ENDE.NUMDOC, CLI.NOMCLI, CLI.ULTNOM,
         ENDE.ENDERE, ENDE.NUMERO, ENDE.COMPLE, ENDE.BAIRRO, ENDE.NOMCID, ENDE.SIGEST, ENDE.CODCEP, ENDE.CODLOG, ENDE.NUMFON, VEN.DESCON,
         VEN.VLRFRE, VEN.VLRSEG, VEN.AVISTA, VEN.SEQUEN, VEN.OBSERV, VEN.OUTTAX, CLI.NUMDOC, CLI.ESTRAN, VEN.DOCNFP
UNION ALL
SELECT VEN.CODFIL,
       VEN.CODSER,
       VEN.NUMECF,
       VEN.NUMNOT,
       0 AS VLRLIQ,
       IVE.NUMITE,
       VEN.DATHOR,
       TO_CHAR('21')||'|'||
       IVE.NUMITE||'|'||
       GRA.FILMAT||REPLACE(GRA.SEQUEN,' ','0')||'|1|'||
       REPLACE(COALESCE(PRO.DESMAT ,'')|| ' ' || COALESCE(PRO.ESPMAT ,'')|| ' ' || RTRIM(COALESCE(DIV.NOMITE,'')) ||'/'||COALESCE(SUB.NOMITE,''),'"',' ')||'|'||
       UPPER(COALESCE(MED.UNIMED,'  '))||'|'||
       REPLACE(TO_CHAR(ABS(ROUND(IVE.QTDMOV,3))),'.',',')||'|'||
       REPLACE(TO_CHAR(ABS(ROUND(IVE.VLRMOV / IVE.QTDMOV,2))),'.',',')||'|'||
       REPLACE(TO_CHAR(ABS(ROUND(IVE.VLRMOV,2))),'.',',') AS LINHA
 FROM TW_VEN_FIS VEN INNER JOIN TW_IVE_FIS IVE ON IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN
                     INNER JOIN TT_GRA GRA ON GRA.FILMAT = IVE.FILMAT AND GRA.CODMAT = IVE.CODMAT
                                          AND GRA.CODCOR = IVE.CODCOR AND GRA.CODTAM = IVE.CODTAM
                     INNER JOIN TT_DIV DIV ON GRA.CODCOR = DIV.CODITE
                     INNER JOIN TT_SUB SUB ON GRA.CODTAM = SUB.CODITE
                     INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
                     INNER JOIN TD_MED MED ON MED.CODTAB = GRA.UNIDAD
UNION ALL
SELECT VEN.CODFIL,
       VEN.CODSER,
       VEN.NUMECF,
       VEN.NUMNOT,
       0 AS VLRLIQ,
       TO_NUMBER(TRIM(REC.NUMPAR)) AS NUMITE,
       VEN.DATHOR,
       TO_CHAR('22')||'|'||
       REPLACE(TO_CHAR(ABS(ROUND(REC.VLRPAR,2))),'.',',')||'|'||
       TO_CHAR(REC.DATVEN,'DD/MM/YYYY')
 FROM TW_VEN_FIS VEN INNER JOIN TT_REC REC ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
WHERE VEN.AVISTA <> 'T'
  AND REC.FLGEST IN ('A','P')
;


/*-- SEQ 2393 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_OPE CASCADE;

/*-- SEQ 2394 --*/
CREATE OR REPLACE VIEW TV_OPE AS
SELECT OPE.CODFIL, OPE.NUMECF, OPE.TRN_ID, OPE.CUPFIS, OPE.NUMITE,
       OPE.VLROPE, OPE.DATOPE, OPE.FILUSU, OPE.CODUSU, OPE.FILREC,
       OPE.SEQREC, OPE.NUMPAR, OPE.SUBPAR, OPE.FILCCC, OPE.SEQCCC,
       OPE.FILCHR, OPE.SEQCHR, OPE.FILFIN, OPE.SEQFIN, OPE.FILDOP,
       OPE.SEQDOP, OPE.DOCTRO, OPE.CARTAO, OPE.OUTROS, OPE.CAMBIO,
       OPE.CODCAI, OPE.TIPCAR, OPE.FILTEF, OPE.SEQTEF,
       case when ope.filrec is not null then (select filcli from tt_ven where codfil = ope.filrec and sequen = ope.seqrec)
            when ope.filchr is not null then coalesce( (select cli.filcli from tt_cli cli where numdoc = (select chr.numdoc from tt_chr chr where chr.codfil = ope.filchr and sequen = ope.seqchr)),
                                                       (select chr.filcli from tt_chr chr where chr.codfil = ope.filchr and sequen = ope.seqchr)) 
            when ope.fildop is not null then (select filcli from tt_dop where codfil = ope.fildop and sequen = ope.seqdop)
            when ope.filccc is not null then (select filcli from tt_ccc where codfil = ope.filccc and sequen = ope.seqccc)
            when ope.filtef is not null then (select filcli from tt_tef where codfil = ope.filtef and sequen = ope.seqtef)
            else (select vc_filcli from tt_cfg)
       end as filcli,
       case when ope.filrec is not null then (select codcli from tt_ven where codfil = ope.filrec and sequen = ope.seqrec)
            when ope.filchr is not null then coalesce( (select cli.codcli from tt_cli cli where numdoc = (select chr.numdoc from tt_chr chr where chr.codfil = ope.filchr and sequen = ope.seqchr)),
                                                       (select chr.codcli from tt_chr chr where chr.codfil = ope.filchr and sequen = ope.seqchr)) 
            when ope.fildop is not null then (select codcli from tt_dop where codfil = ope.fildop and sequen = ope.seqdop)
            when ope.filccc is not null then (select codcli from tt_ccc where codfil = ope.filccc and sequen = ope.seqccc)
            when ope.filtef is not null then (select codcli from tt_tef where codfil = ope.filtef and sequen = ope.seqtef)
            else (select vc_codcli from tt_cfg)
       end as codcli,
       CAST(CASE WHEN OPE.FILREC IS NOT NULL THEN 'Recebimento em: '||MeioDePagamento(OPE.FILREC,OPE.SEQREC,OPE.NUMPAR,OPE.SUBPAR)
            WHEN OPE.FILCCC IS NOT NULL THEN (SELECT CAST(DCCC.DESCCC AS VARCHAR(254))
                                              FROM TT_CCC CCC INNER JOIN TD_CCC DCCC ON DCCC.CODTAB=CCC.TIPCCC
                                              WHERE CCC.CODFIL=OPE.FILCCC
                                                AND CCC.SEQUEN=OPE.SEQCCC)
            WHEN OPE.FILCHR IS NOT NULL THEN CAST('Cheque' AS VARCHAR(254))
            WHEN OPE.FILFIN IS NOT NULL THEN (SELECT CAST(SUBSTR(CTA.TITCTA||
                                                          CASE WHEN OPE.CODCAI IS NOT NULL 
                                                               THEN '-'||CAI.CX_DES
                                                               ELSE ''
                                                          END,1,254) AS VARCHAR(254))
                                              FROM TD_CAI CAI,
                                                   TT_FIN FIN INNER JOIN TT_CTA CTA ON CTA.CODFIL=FIN.FILNUM
                                                                                   AND CTA.SEQUEN=FIN.SEQNUM
                                                                                   AND CTA.TIPCTA=FIN.TIPNUM
                                              WHERE FIN.CODFIL=OPE.FILFIN
                                                AND FIN.SEQUEN=OPE.SEQFIN
                                                and CAI.CODTAB=OPE.CODCAI)
            WHEN OPE.CARTAO IS NOT NULL THEN (SELECT CAST(CAR.DESOUT || CASE COALESCE(OPE.TIPCAR,'X') WHEN 'D' THEN ' - C.Dbito'
                                                                                                      WHEN 'C' THEN ' - C.Crdito'
                                                                                                      ELSE ''
                                                                        END AS VARCHAR(254))
                                              FROM TD_CAR CAR 
                                              WHERE CAR.CODTAB=OPE.CARTAO)
            WHEN OPE.OUTROS IS NOT NULL THEN (SELECT CAST(OUT.DESCAR AS VARCHAR(254))
                                              FROM TD_OUT OUT
                                              WHERE OUT.CODTAB=OPE.OUTROS)
            WHEN OPE.CAMBIO IS NOT NULL THEN (SELECT CAST('Dinheiro ' || COALESCE(MOE.DESMOE,'') AS VARCHAR(254))
                                              FROM TD_MOE MOE 
                                              WHERE MOE.CODTAB=OPE.CAMBIO)
            WHEN OPE.FILDOP IS NOT NULL THEN CAST('Cheque Troco' AS VARCHAR(254))
            WHEN OPE.DOCTRO IS NOT NULL THEN CAST('Cheque Troco No Cadastrado' AS VARCHAR(254))
        END AS VARCHAR(254)) AS TIPOPE,
        CASE WHEN OPE.VLROPE < 0 THEN ABS(VLROPE) 
                                 ELSE 0 
        END AS VLRDEB, 
        CASE WHEN OPE.VLROPE > 0 THEN VLROPE 
                                 ELSE 0 
        END AS VLRCRE,
        CAST(CASE WHEN OPE.FILREC IS NOT NULL THEN (SELECT COALESCE(VEN.CODSER,'')||'/'||COALESCE(VEN.NUMECF,'')||'-'||LTRIM(COALESCE(VEN.NUMNOT,''))||'/'||COALESCE(REC.NUMPAR,'')||CASE WHEN LTRIM(RTRIM(COALESCE(REC.SUBPAR,''))) IS NULL THEN '' ELSE '-' END||lTrim(COALESCE(REC.SUBPAR,''))
                                               FROM TT_REC REC INNER JOIN TT_VEN VEN ON VEN.CODFIL=REC.CODFIL 
                                                                                    AND VEN.SEQUEN=REC.SEQUEN
                                               WHERE REC.CODFIL=OPE.FILREC
                                                 AND REC.SEQUEN=OPE.SEQREC
                                                 AND REC.NUMPAR=OPE.NUMPAR
                                                 AND REC.SUBPAR=OPE.SUBPAR)                                               
             WHEN OPE.FILCCC IS NOT NULL THEN (SELECT CCC.NUMDOC
                                               FROM TT_CCC CCC 
                                               WHERE CCC.CODFIL=OPE.FILCCC
                                                 AND CCC.SEQUEN=OPE.SEQCCC)
             WHEN OPE.FILCHR IS NOT NULL THEN (SELECT COALESCE(CHR.CODBCO,'')||'.'||COALESCE(CHR.CODAGE,'')||'.'||COALESCE(CHR.NUMCON,'')||'.'||COALESCE(CHR.NUMCHE,'')
                                               FROM TT_CHR CHR
                                               WHERE CHR.CODFIL=OPE.FILCHR
                                                 AND CHR.SEQUEN=OPE.SEQCHR)
             WHEN OPE.FILFIN IS NOT NULL THEN (SELECT FIN.NUMDOC
                                               FROM TT_FIN FIN
                                               WHERE FIN.CODFIL=OPE.FILFIN
                                                 AND FIN.SEQUEN=OPE.SEQFIN)
             WHEN OPE.FILDOP IS NOT NULL THEN (SELECT COALESCE(CTB.CODBCO,'')||'.'||COALESCE(CTB.NUMAGE,'')||'.'||COALESCE(CTB.CTACRR,'')||'.'||COALESCE(DOP.NUMDOC,'')
                                               FROM TT_DOP DOP INNER JOIN TT_CTB CTB ON DOP.FILCTA=CTB.FILCTA 
                                                                                    AND DOP.SEQCTA=CTB.SEQCTA 
                                                                                    AND DOP.TIPCTA=CTB.TIPCTA 
                                                                                    AND DOP.CHETRO=CTB.CHETRO                  
                                               WHERE DOP.CODFIL=OPE.FILDOP
                                                 AND DOP.SEQUEN=OPE.SEQDOP)                                                 
             WHEN OPE.DOCTRO IS NOT NULL THEN TRIM(DOCTRO)
             WHEN OPE.FILTEF IS NOT NULL THEN (SELECT DCAR.DESOUT||' - '||
                                                 CASE TEF.TIPOPE WHEN 'C' THEN 'Crdito'
                                                      WHEN 'D' THEN 'Dbito'
                                                  END
                                                 FROM TT_TEF TEF LEFT JOIN TD_CAR DCAR ON TEF.CARTAO = DCAR.CODTAB
                                                WHERE TEF.CODFIL = OPE.FILTEF
                                                  AND TEF.SEQUEN = OPE.SEQTEF)
        END AS VARCHAR(254)) as DOCUME
  FROM TT_OPE OPE 
;


/*-- SEQ 2395 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PAR CASCADE;

/*-- SEQ 2396 --*/
CREATE OR REPLACE VIEW TV_PAR AS
SELECT CLI.FILCLI, CLI.CODCLI, CLI.ATU_EM, CLI.NOMCLI,
       CLI.ULTNOM, CLI.NUMDOC, CLI.DOCCON, CLI.DATNAS,
       CLI.ESTCIV, CLI.HOMPGE, CLI.FLGTIP, CLI.INSEST,
       CLI.CODSEX, CLI.CATEG1, CLI.CATEG2, CLI.CATEG3,
       CLI.DATA01, CLI.DATA02, CLI.DATA03, CLI.DATOPE,
       CLI.IMPRIM, CLI.VALOR1, CLI.TOTATR, CLI.TOTPAR,
       CLI.MAIATR, CLI.OBSERV, CLI.FILPLA, CLI.CODPLA,
       CLI.PORPAD, CLI.ULTCOM, CLI.SIGNAT, CLI.CONJUG,
       CLI.NASCON, CLI.SEXCON, CLI.FILVEN, CLI.CODVEN,
       VIN.NUMDOC  AS  DOCVIN, CLI.TIPDOC, CLI.DETTIP,
       CLI.NOMTRA, CLI.PP_FLG, CLI.SIMPLE, CLI.ISENTO,
       CLI.FILGUI, CLI.CODGUI, GUI.NOMCLI AS NOMGUI, GUI.NUMDOC AS DOCGUI, CLI.ENTISE,
       CLI.SUFRAM, CLI.CONTRIBUINTE
FROM TT_CLI CLI LEFT JOIN TT_CLI VIN ON CLI.FILVIN = VIN.FILCLI AND CLI.CODVIN = VIN.CODCLI
                LEFT JOIN TT_CLI GUI ON CLI.FILGUI = GUI.FILCLI AND CLI.CODGUI = GUI.CODCLI
;


/*-- SEQ 2397 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PCIA_INV_HP CASCADE;

/*-- SEQ 2398 --*/
CREATE OR REPLACE VIEW TV_PCIA_INV_HP AS
SELECT DISTINCT 
       CAST('3-9M2SI' AS VARCHAR(9)) AS CODIGO_REVENDA,
       FILORI.CODEXT AS CODIGO_ORIGEM,
       --CAST('PAPEL E CIA PREMIUM RESELLER' AS VARCHAR(28)) AS STORE_NAME, 
       CAST('BRAZIL' AS VARCHAR(10)) AS PAIS, 
       DAT.DATOPE AS DATA_IVENTARIO,
       EAN.CODEAN AS PART_NUMBER,
       TMAR.DESMAR AS MARCA,
       PRO.CLASS2 AS CLASS2,
       PRO.CLASS3 AS CLASS3,
       --GRA.REFPRO AS UCP, 
       --CAST(NULL AS VARCHAR(1)) AS HP_PRODUCT, 
       SUM(CASE WHEN TT_CRTXPRO.DESCRT = 'T' 
                THEN (SALDODAFILIAL(DAT.DATOPE,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,'012',SAL.CODMUL)+
                      SALDODAFILIAL(DAT.DATOPE,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,'006',SAL.CODMUL)) 
                ELSE SALDODAFILIAL(DAT.DATOPE,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,'012',SAL.CODMUL) END) AS SALDO_FISICO,
       SUM(CASE WHEN TT_CRTXPRO.DESCRT = 'T' 
                THEN PEDIDOPENDENTE(CAST('006' AS VARCHAR(3)),SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM) 
                ELSE 0 
           END) AS SALDO_TRANSITO,
       SUM(CASE WHEN TT_CRTXPRO.DESCRT = 'T' 
                THEN (SALDODAFILIAL(DAT.DATOPE,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,'012',SAL.CODMUL)+
                      SALDODAFILIAL(DAT.DATOPE,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,'006',SAL.CODMUL)) 
                ELSE SALDODAFILIAL(DAT.DATOPE,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,'012',SAL.CODMUL) 
           END)+SUM(CASE WHEN TT_CRTXPRO.DESCRT = 'T' 
                         THEN PEDIDOPENDENTE(CAST('006' AS VARCHAR(3)),SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM) 
                         ELSE 0 
                    END) AS SALDO_REAL
  FROM TT_GRA GRA INNER JOIN TT_PRO PRO ON GRA.FILMAT = PRO.FILMAT AND GRA.CODMAT = PRO.CODMAT
                  INNER JOIN TT_SAL SAL ON GRA.FILMAT = SAL.FILMAT AND GRA.CODMAT = SAL.CODMAT AND GRA.CODCOR = SAL.CODCOR AND GRA.CODTAM = SAL.CODTAM
                  INNER JOIN TT_EAN EAN ON GRA.FILMAT = EAN.FILMAT AND GRA.CODMAT = EAN.CODMAT AND GRA.CODCOR = EAN.CODCOR AND GRA.CODTAM = EAN.CODTAM
                  LEFT  JOIN TT_CRTXPRO ON TT_CRTXPRO.FILMAT = GRA.FILMAT AND TT_CRTXPRO.CODMAT = GRA.CODMAT
                  INNER JOIN TD_FIL FILORI ON FILORI.CODFIL=SAL.CODFIL
                  INNER JOIN TD_CL2 CL2 ON CL2.CODTAB = PRO.CLASS2
                  INNER JOIN TD_CL3 CL3 ON CL3.CODTAB = PRO.CLASS3
                  INNER JOIN TT_MAR TMAR ON TMAR.FILMAR = PRO.FILMAR 
                                        AND TMAR.CODMAR = PRO.CODMAR 
                                        AND TMAR.ITEMAR = PRO.ITEMAR
                  CROSS JOIN TT_DAT DAT
 WHERE EAN.USOEAN = -3 -- PATHP
   AND SAL.CODMUL = 0 -- PADRAO
   AND SAL.CODFIL = '012' -- 012  FILIAL "HP" DO CLIENTE. A 006  O ESTOQUE.
   AND (PRO.FILMAR,PRO.CODMAR) IN (SELECT FILMAR,CODMAR FROM TT_MAR WHERE DESMAR LIKE 'HP%')
   /* AND DAT.DATOPE = TO_DATE('08/09/2009', 'MM/DD/YYYY') --  OBRIGATRIO USAR ESSE FILTRO NO BI */
 GROUP BY FILORI.CODEXT, DAT.DATOPE, EAN.CODEAN, GRA.REFPRO, TMAR.DESMAR, PRO.CLASS2, PRO.CLASS3
;


/*-- SEQ 2399 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PCIA_INV_HP_013_015 CASCADE;

/*-- SEQ 2400 --*/
CREATE OR REPLACE VIEW TV_PCIA_INV_HP_013_015 AS
SELECT SAL.CODFIL,
       CASE SAL.CODFIL WHEN '013' THEN '3-FDK3BP'
                       WHEN '015' THEN '3-FDK3KZ' 
                       ELSE '' END AS CODIGO_REVENDA,
       FILORI.CODEXT AS CODIGO_ORIGEM,
       'BRAZIL' AS PAIS,
       DAT.DATOPE AS DATA_IVENTARIO,
       EAN.CODEAN AS PART_NUMBER,
       TMAR.DESMAR AS MARCA,
       PRO.CLASS2 AS CLASS2,
       PRO.CLASS3 AS CLASS3,
       (COALESCE(SALDODAFILIAL(DAT.DATOPE,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,SAL.CODFIL,SAL.CODMUL),0)) AS SALDO_FILIAL,
       (COALESCE(PEDIDOPENDENTE(SAL.CODFIL,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM),0)) AS PEDIDO_PENDENTE,
       (COALESCE(SALDODAFILIAL(DAT.DATOPE,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,SAL.CODFIL,SAL.CODMUL),0))+
       (COALESCE(PEDIDOPENDENTE(SAL.CODFIL,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM),0)) AS TOTAL_INVENTARIO
  FROM TT_EAN EAN
   INNER JOIN TT_SAL SAL ON SAL.FILMAT = EAN.FILMAT AND SAL.CODMAT=EAN.CODMAT AND SAL.CODCOR=EAN.CODCOR AND SAL.CODTAM=EAN.CODTAM AND EAN.USOEAN=-3
   INNER JOIN TD_FIL FILORI ON FILORI.CODFIL=SAL.CODFIL
   INNER JOIN TT_PRO PRO ON PRO.FILMAT = SAL.FILMAT AND PRO.CODMAT = SAL.CODMAT
   INNER JOIN TD_CL2 CL2 ON CL2.CODTAB = PRO.CLASS2
   INNER JOIN TD_CL3 CL3 ON CL3.CODTAB = PRO.CLASS3
   INNER JOIN TT_MAR TMAR ON TMAR.FILMAR = PRO.FILMAR AND TMAR.CODMAR = PRO.CODMAR AND TMAR.ITEMAR = PRO.ITEMAR
      CROSS JOIN TT_DAT DAT
WHERE SAL.CODMUL=0
  AND SAL.CODFIL NOT IN ('001','002','003','004','005','009')
;


/*-- SEQ 2401 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PCIA_TRANS_HP CASCADE;

/*-- SEQ 2402 --*/
CREATE OR REPLACE VIEW TV_PCIA_TRANS_HP AS
SELECT 
VEN.FILCLI AS CODFIL,
   CASE VEN.CODFIL WHEN '013' THEN '3-FDK3BP'
                WHEN '015' THEN '3-9M2SI' 
                WHEN '012' THEN '3-9M2SI'
			ELSE FIL.NOMFIL END AS CODIGO_REVENDA_ORIGEM ,
   FILORI.CODEXT AS CODIGO_ORIGEM,   
   CASE VEN.FILCLI WHEN '013' THEN '3-FDK3BP'
                WHEN '015' THEN '3-9M2SI' 
                WHEN '012' THEN '3-9M2SI'
			ELSE FIL.NOMFIL END AS CODIGO_REVENDA_DESTINO,
   FILDES.CODEXT AS CODIGO_DESTINO,
   TMAR.DESMAR AS MARCA,
   PRO.CLASS2 AS CLASS2,
   PRO.CLASS3 AS CLASS3,      
TRUNC(DATHOR) AS DATA_TRANSFERENCIA,
EAN.CODEAN AS PART_NUMBER,
IVE.QTDMOV AS QUANTIDADE,
VEN.NUMNOT AS NUMERO_NOTA
  FROM TT_IVE IVE 
  INNER JOIN TT_VEN VEN ON VEN.CODFIL=IVE.CODFIL AND VEN.SEQUEN=IVE.SEQUEN
  INNER JOIN TT_EAN EAN ON EAN.FILMAT=IVE.FILMAT AND EAN.CODMAT=IVE.CODMAT AND EAN.CODCOR=IVE.CODCOR AND EAN.CODTAM=IVE.CODTAM
  INNER JOIN TD_FIL FIL ON FIL.CODFIL=IVE.CODFIL
  INNER JOIN TT_PRO PRO ON PRO.FILMAT = IVE.FILMAT AND PRO.CODMAT = IVE.CODMAT
  INNER JOIN TD_CL2 CL2 ON CL2.CODTAB = PRO.CLASS2
  INNER JOIN TD_CL3 CL3 ON CL3.CODTAB = PRO.CLASS3
  INNER JOIN TT_MAR TMAR ON TMAR.FILMAR = PRO.FILMAR AND TMAR.CODMAR = PRO.CODMAR AND TMAR.ITEMAR = PRO.ITEMAR
  INNER JOIN TD_FIL FILORI ON FILORI.CODFIL=IVE.CODFIL
  INNER JOIN TD_FIL FILDES ON FILDES.CODFIL=VEN.FILCLI  
  WHERE EAN.USOEAN=-3
AND VEN.FLGEST <> 'C'
AND ((VEN.CODNAT=7) OR (VEN.CODNAT=-1))
;


/*-- SEQ 2403 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PCR CASCADE;

/*-- SEQ 2404 --*/
CREATE OR REPLACE VIEW TV_PCR AS
-- View que apresenta uma conferncia entre Pedidos, Compras faturadas e Recepo de Compras
-- O objetivo  fornecer informaes para que se possa verificar se a entrada das mercadorias
-- esta conferindo com o lanamento da nota no contas a pagar e ver a relao entre os pedidos
-- e as compras efetuadas...
-- A seleo reune inicialmente itens de compras(tt_ico) e compras(tt_com) com as notas digitadas
-- na recepo das mercadorias(tt_rcp) que coincidam com as compras(tt_com)
-- Uma vez selecionadas as notas de compras e de recepo, so adicionados os itens das notas
-- recepcionadas(tt_irc)
-- Ao conjunto anterior, sero adicionados(union all) todas as notas digitadas na recepo que
-- no possuem notas de compras relacionadas...Obs: tanto para compras quanto para recepo,
-- a identificao das notas  igual... (filfor/codfor/codser/subser/numnot)
-- Unidos os dois conjuntos, adicionam-se os itens de pedidos(tt_ipe) que coincidam com
-- os itens de compras(tt_ico) via (tt_ipe->filico/seqico/numico)...
-- Por ltimo so adicionados os headers de pedido(tt_ped) correspondentes aos itens de
-- de pedidos(tt_ipe) adicionados...
-- Todos os registros que esto cancelados ou reprovados ou devolvidos em qualquer tabela
-- so ignorados...
--
--
--   +--------+      +--------+      +--------+
--   | TT_PED |      | TT_COM |------| TT_RCP |
--   +--------+      +--------+      +--------+
--       |               |               |
--       |               |               |
--   +--------+      +--------+      +--------+
--   | TT_IPE |------| TT_ICO |      | TT_IRC |
--   +--------+      +--------+      +--------+
--
    SELECT Ref.*, 
           Ped.FILFOR AS FILFORPED, 
           Ped.FILUSU AS FILUSUPED, 
           Ped.CODUSU AS CODUSUPED,
           CASE Ref.QTDPED WHEN Ref.QTDFAT THEN CASE Ref.QTDPED WHEN Ref.QTDREC THEN 'F'
                                                                ELSE 'T'
                                                END
                       ELSE 'T'
       END AS QTDDIV,
       CASE Ref.VLRPED WHEN Ref.VLRFAT THEN 'F'
                       ELSE 'T'
       END AS VLRDIV,
       CASE CASE Ref.QTDPED WHEN Ref.QTDFAT THEN CASE Ref.QTDPED WHEN Ref.QTDREC THEN 'F'
                                                                 ELSE 'T'
                                                 END
                            ELSE 'T'
             END 
       WHEN 'F' THEN CASE CASE Ref.VLRPED WHEN Ref.VLRFAT THEN 'F'
                                          ELSE 'T'
                          END
                     WHEN 'F' THEN 'F'
                     ELSE 'T'
                     END
       ELSE 'T'
       END AS QQ_DIV
FROM ( SELECT Ico.FILMAT, Ico.CODMAT, Ico.CODCOR, Ico.CODTAM,
              Com.DATOPE AS DATENT,
              Rcp.DATRCP AS DATRCP,
              Com.DATOPE AS DATOPE,
              Ico.VLRMOV AS VLRFAT,
              Ico.QTDMOV AS QTDFAT,
              Ico.QTDCOM,
              Rcp.CODFIL AS RCPCODFIL, 
              Rcp.SEQUEN AS RCPSEQUEN,
              COALESCE(Com.FILFOR,'')||'/'||ltrim(COALESCE(Com.CODFOR,''))||'/'||
              COALESCE(Com.CODSER,'')||'/'||ltrim(COALESCE(Com.SUBSER,''))||'/'||ltrim(COALESCE(Com.NUMNOT,'')) AS DOCUME,
              Com.TIPPAR,
              Com.FILUSU AS FILUSUCOM, 
              Com.CODUSU AS CODUSUCOM,
              Rcp.FILUSU AS FILUSURCP, 
              Rcp.CODUSU AS CODUSURCP,
              Ico.ICOCODFIL, 
              Ico.ICOSEQUEN, 
              Ico.ICONUMITE,
              Com.FILFOR, 
              Com.CODFOR, 
              Com.CODSER, 
              Com.SUBSER, 
              Com.NUMNOT,
              Com.NUMVOL AS VOLCOM,
              Rcp.NUMVOL AS VOLRCP,
              Irc.QTDITE AS QTDREC,
              ICO.CODFIL,
              ICO.NUMPED,
              ICO.NUMITE,
              ICO.QTDPED,
              ICO.VLRPED
         FROM TT_COM COM INNER JOIN ( SELECT IIco.FILMAT, IIco.CODMAT, IIco.CODCOR, IIco.CODTAM,
                                             SUM(IIco.VLRMOV) AS VLRMOV, 
                                             SUM(IIco.QTDMOV) AS QTDMOV,
                                             SUM(IIco.QTDCOM) AS QTDCOM,
                                             IIco.CODFIL AS ICOCODFIL,                
                                             IIco.SEQUEN AS ICOSEQUEN,                
                                             TO_NUMBER(NULL) AS ICONUMITE,  
                                             IIpe.CODFIL, 
                                             IIpe.NUMPED, 
                                             TO_NUMBER(NULL) AS NUMITE, 
                                             SUM(IIpe.QTDITE) AS QTDPED, 
                                             SUM(IIpe.VLRITE) AS VLRPED
                                        FROM TT_ICO IICO  LEFT OUTER JOIN TT_IPE IIpe  ON IIpe.FILICO = IICO.CODFIL    -- Obs todos null, no precisa tratar flgest
                                                                                      AND IIpe.SEQICO = IICO.SEQUEN
                                                                                      AND IIpe.NUMICO = IICO.NUMITE
                                                                                      AND IIpe.FLGEST <> 'C' 
                                       WHERE IIco.SITMOV <> 'C'
                                       GROUP BY IIco.CODFIL, IIco.SEQUEN,IIco.FILMAT, IIco.CODMAT, IIco.CODCOR, IIco.CODTAM,
                                                IIpe.CODFIL, 
                                                IIpe.NUMPED  
                                     ) ICO ON Ico.ICOCODFIL = Com.CODFIL AND Ico.ICOSEQUEN = Com.SEQUEN
                         LEFT  JOIN TT_RCP Rcp ON Rcp.FILFOR = Com.FILFOR
                                              AND Rcp.CODFOR = Com.CODFOR
                                              AND Rcp.CODSER = Com.CODSER
                                              AND (Rcp.SUBSER = Com.SUBSER OR (Rcp.SUBSER IS NULL AND Com.SUBSER IS NULL))
                                              AND Rcp.NUMNOT = Com.NUMNOT
                                              AND Rcp.FLGEST<> 'C'
                         LEFT  JOIN (SELECT IIrc.CODFIL,
                                            IIrc.SEQUEN,
                                            IIrc.FILMAT,
                                            IIrc.CODMAT,
                                            IIrc.CODCOR,
                                            IIrc.CODTAM,
                                            SUM(IIrc.QTDITE) AS QTDITE
                                       FROM TT_IRC IIRC
                                      GROUP BY IIrc.CODFIL,
                                               IIrc.SEQUEN,
                                               IIrc.FILMAT,
                                               IIrc.CODMAT,
                                               IIrc.CODCOR,
                                               IIrc.CODTAM 
                                      ) Irc ON Irc.CODFIL = RCP.CODFIL                            
                                           AND Irc.SEQUEN = RCP.SEQUEN
                                           AND Irc.FILMAT = ICO.FILMAT
                                           AND Irc.CODMAT = ICO.CODMAT
                                           AND Irc.CODCOR = ICO.CODCOR
                                           AND Irc.CODTAM = ICO.CODTAM                                              
                 WHERE Com.FLGEST <> 'D' 
                   AND COALESCE(COM.FINNFE,'0') <> '2'--Desconsidera nota complementar
                UNION ALL
                SELECT Irc.FILMAT, Irc.CODMAT, Irc.CODCOR, Irc.CODTAM,
                       Com.DATOPE AS DATENT,
                       Rcp.DATRCP AS DATRCP,
                       Rcp.DATRCP AS DATOPE,
                       TO_NUMBER(NULL) AS VLRFAT,
                       TO_NUMBER(NULL) AS QTDFAT,
                       TO_NUMBER(NULL) AS QTDCOM,
                       Rcp.CODFIL AS RCPCODFIL, 
                       Rcp.SEQUEN AS RCPSEQUEN,
                       COALESCE(Rcp.FILFOR,'')||'/'||ltrim(COALESCE(Rcp.CODFOR,''))||'/'||
                       COALESCE(Rcp.CODSER,'')||'/'||ltrim(COALESCE(Rcp.SUBSER,''))||'/'||ltrim(COALESCE(Rcp.NUMNOT,'')) AS DOCUME,
                       Rcp.TIPFOR,
                       Com.FILUSU AS FILUSUCOM, 
                       Com.CODUSU AS CODUSUCOM,
                       Rcp.FILUSU AS FILUSURCP, 
                       Rcp.CODUSU AS CODUSURCP,
                       TO_CHAR(NULL) AS ICOCODFIL, 
                       TO_CHAR(NULL) AS ICOSEQUEN, 
                       TO_NUMBER(NULL) AS ICONUMITE,
                       TO_CHAR(NULL) AS FILFOR, 
                       TO_CHAR(NULL) AS CODFOR,
                       TO_CHAR(NULL) AS CODSER, 
                       TO_CHAR(NULL) AS SUBSER, 
                       TO_CHAR(NULL) AS NUMNOT,
                       Com.NUMVOL AS VOLCOM,
                       Rcp.NUMVOL AS VOLRCP,
                       Irc.QTDITE AS QTDREC,
                       TO_CHAR(NULL) AS CODFIL,
                       TO_CHAR(NULL) AS NUMPED,
                       TO_NUMBER(NULL) AS NUMITE,
                       TO_NUMBER(NULL) AS QTDPED,
                       TO_NUMBER(NULL) AS VLRPED
                  FROM TT_IRC Irc      INNER JOIN TT_RCP Rcp ON Irc.CODFIL = Rcp.CODFIL AND Irc.SEQUEN = Rcp.SEQUEN
                                  LEFT OUTER JOIN TT_COM Com ON  Rcp.FILFOR = Com.FILFOR
                                                             AND Rcp.CODFOR = Com.CODFOR
                                                             AND Rcp.CODSER = Com.CODSER
                                                             AND (Rcp.SUBSER = Com.SUBSER  OR (Rcp.SUBSER IS NULL AND Com.SUBSER IS NULL))
                                                             AND Rcp.NUMNOT = Com.NUMNOT
                 WHERE Rcp.FLGEST <> 'C'
                   AND Com.FILFOR is null
        ) Ref LEFT OUTER JOIN TT_PED Ped ON Ped.CODFIL = Ref.CODFIL
                                        AND Ped.NUMPED = Ref.NUMPED
                                        AND (NOT Ped.FLGEST IN ('C','0')) 
 ;


/*-- SEQ 2405 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_BASF_AE1 CASCADE;

/*-- SEQ 2406 --*/
CREATE OR REPLACE VIEW TV_PED_BASF_AE1 AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       0 AS NUMITE,
       TO_CHAR('*') AS REFFOR,
       /*Valor Fixo */
       'AE1'
       /*Pedido*/
       ||LPAD(TRIM(FIL.CODFIL),3,' ')||LPAD(TRIM(PED.NUMPED),17,'0')||TO_CHAR(PED.DATPED,'YYYYMMDD')
       /*Filial de Entrega*/
       ||( SELECT RPAD(/*TRIM(EFIL.CODFIL)*/' ',15,' ')/*Conforme conversa com Rhuan e analise do arquivo exemplo optou-se por deixar em branco */
                  ||RPAD(TRIM(coalesce(EFIL.CGCFIL,'')),15,' ')
           FROM TT_CFG CFG LEFT JOIN TD_FIL EFIL ON EFIL.CODFIL = CFG.FILENT )
       /*Filial de Cobrança*/
       ||( SELECT RPAD(/*TRIM(EFIL.CODFIL)*/' ',15,' ')/*Conforme conversa com Rhuan e analise do arquivo exemplo optou-se por deixar em branco */
                  ||RPAD(TRIM(coalesce(EFIL.CGCFIL,'')),15,' ')
           FROM TT_CFG CFG LEFT JOIN TD_FIL EFIL ON EFIL.CODFIL = CFG.FILCOB )
       /*Filial de Compra*/
       ||RPAD(/*TRIM(FIL.CODFIL)*/' ',15,' ')/*Conforme conversa com Rhuan e analise do arquivo exemplo optou-se por deixar em branco */
       ||RPAD(TRIM(FIL.CGCFIL),15,' ')
       /*Condição de Pagamento*/
       ||CASE (SELECT COUNT(CPE.NUMPAR)
                  FROM TT_CPE CPE 
                 WHERE CPE.CODFIL = PED.CODFIL
                   AND CPE.NUMPED = PED.NUMPED) 
         WHEN 0 THEN RPAD(' ',30,' ')
         WHEN 1 THEN CASE (SELECT MIN(CPE.DATVEN)
                            FROM TT_CPE CPE 
                           WHERE CPE.CODFIL = PED.CODFIL
                             AND CPE.NUMPED = PED.NUMPED) 
                     WHEN COALESCE(PED.DATENT,PED.DATPED) THEN RPAD('A VISTA',30,' ')
                     ELSE RPAD('1/1',30,' ')
                     END
         ELSE TRIM((SELECT LPAD(to_char(COUNT(CPE.NUMPAR)),2,'0')||'/'
                  FROM TT_CPE CPE 
                 WHERE CPE.CODFIL = PED.CODFIL
                   AND CPE.NUMPED = PED.NUMPED))       
               ||RPAD(TRIM(COALESCE((SELECT CAST(REPLACE(AGREGATXT(TRIM(LPAD(to_char(COALESCE((TRUNC(CPE.DATVEN) - TRUNC(COALESCE(PED.DATENT,PED.DATPED))),0)),3,'0'))),cHR(13)||cHR(10), '/') AS VARCHAR(254))
                                  FROM TT_CPE CPE 
                                 WHERE CPE.CODFIL = PED.CODFIL
                                   AND CPE.NUMPED = PED.NUMPED),'000')),27,' ')
       END                   
       /*Observação*/
       ||RPAD(SUBSTR(CAST(REPLACE(REPLACE(TRIM(Rtf2txt(coalesce(PED.OBSERV,''))) ,cHR(13), ' '),cHR(10), ' ') AS VARCHAR(200)),1,200),200,' ') AS LINHA
  FROM TT_PED PED INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR AND REL.CODPAR = PED.CODFOR 
                                       AND REL.TIPPAR = PED.TIPFOR 
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR 
                                       AND CLI.CODCLI = REL.CODPAR 
                  INNER JOIN TD_FIL FIL ON FIL.CODFIL = PED.CODFIL 
 WHERE PED.FLGEST = '2' 
   AND REL.TIPPAR = 'F' 
   AND CLI.PEDELE = 'T' 
 ;


/*-- SEQ 2407 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_BASF_AE2 CASCADE;

/*-- SEQ 2408 --*/
CREATE OR REPLACE VIEW TV_PED_BASF_AE2 AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       IPE.NUMITE,
       CASE CLI.USAREF WHEN 'T' THEN coalesce((CASE WHEN (TRIM(REF.REFFOR) = '') or (REF.REFFOR IS NULL) THEN IPE.CODMAT
                                                                             ELSE coalesce(TRIM(REF.REFFOR),' ')
                                                                              END),'')
                                ELSE GRA.REFPRO
       END AS REFFOR,
       /*Valor Fixo */
       'AE2'
       /*Itens Pedido*/
       ||LPAD(TRIM(PED.CODFIL),3,'0')||LPAD(TRIM(PED.NUMPED),17,'0')||LPAD(TRIM(to_char(IPE.NUMITE)),8,'0')
       /*Código Grupo*/
       ||RPAD(/*TRIM(PRO.CLASS1)*/' ',15,' ')/*Conforme conversa com Rhuan e analise do arquivo exemplo optou-se por deixar em branco */
       /*Código Família*/
       ||RPAD(/*TRIM(PRO.CLASS3)*/' ',15,' ')/*Conforme conversa com Rhuan e analise do arquivo exemplo optou-se por deixar em branco */
       /*Código do Produto*/
       ||RPAD(TRIM(CASE WHEN (TRIM(REF.REFFOR) = '') or (REF.REFFOR IS NULL) THEN IPE.CODMAT
                                                                             ELSE coalesce(TRIM(REF.REFFOR),' ')
                                                                              END),15,' ')
       /*Código GTIN(EAN)*/
       ||LPAD(coalesce(TRIM(EAN.CODEAN),' '),15,' ')
       /*Quantidade Layout aceita apenas Inteiro*/
       ||TO_CHAR(LPAD(to_char(CAST(COALESCE(IPE.QTDPED,0) AS INTEGER)),12,'0'))
       /*Valor Unitário*/
       ||TO_CHAR(LPAD(to_char(CAST(((COALESCE(IPE.VLRITE,0)+(COALESCE(IPE.VLRDES*-1,0)))/COALESCE(IPE.QTDPED,0))*100 AS INTEGER)),8,'0'))
       /*Número do Contato*/
       ||RPAD(' ',20,' ')
       /*Percentual de Desconto*/
       ||TO_CHAR(LPAD(to_char(CAST((((CASE WHEN IPE.VLRDES < 0 THEN ((((COALESCE(IPE.VLRITE,0)/(COALESCE(IPE.VLRITE,0)+(COALESCE(IPE.VLRDES*-1,0))))-1)*100))
                                                ELSE 0
                                                 END)*-1)*100) AS INTEGER)),5,'0'))
       /*Observação*/
       ||RPAD(' ',200,' ') AS LINHA
  FROM TT_PED PED INNER JOIN TT_IPE IPE ON IPE.CODFIL = PED.CODFIL AND IPE.NUMPED = PED.NUMPED
                  INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR AND REL.CODPAR = PED.CODFOR
                                       AND REL.TIPPAR = PED.TIPFOR
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR
                                       AND CLI.CODCLI = REL.CODPAR
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = IPE.FILMAT AND GRA.CODMAT = IPE.CODMAT
                                       AND GRA.CODCOR = IPE.CODCOR AND GRA.CODTAM = IPE.CODTAM
                  INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
                  INNER JOIN TT_PXF PXF ON PXF.FILMAT = PRO.FILMAT AND PXF.CODMAT = PRO.CODMAT
                                       AND PXF.FILFOR = REL.FILPAR AND PXF.CODFOR = REL.CODPAR
                                       AND PXF.TIPFOR = REL.TIPPAR
                                       AND PXF.CODCOR = IPE.CODCOR AND PXF.CODTAM = IPE.CODTAM
                  LEFT  JOIN TT_REF REF ON REF.FILMAT = PXF.FILMAT AND REF.CODMAT = PXF.CODMAT
                                       AND REF.CODCOR = PXF.CODCOR AND REF.CODTAM = PXF.CODTAM
                                       AND REF.FILFOR = PXF.FILFOR AND REF.CODFOR = PXF.CODFOR
                  LEFT  JOIN TT_CLIXFIL CFIL ON CFIL.FILCLI = CLI.FILCLI
                                            AND CFIL.CODCLI = CLI.CODCLI
                                            AND CFIL.CODFIL = PED.CODFIL
                  LEFT JOIN TT_EAN EAN ON GRA.FILMAT = EAN.FILMAT
                                      AND GRA.CODMAT = EAN.CODMAT
                                      AND GRA.CODCOR = EAN.CODCOR
                                      AND GRA.CODTAM = EAN.CODTAM
 WHERE PED.FLGEST = '2'
   AND REL.TIPPAR = 'F'
   AND CLI.PEDELE = 'T'
 ;


/*-- SEQ 2409 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_BASF_AE3 CASCADE;

/*-- SEQ 2410 --*/
CREATE OR REPLACE VIEW TV_PED_BASF_AE3 AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       IPE.NUMITE,
       CASE CLI.USAREF WHEN 'T' THEN coalesce((CASE WHEN (TRIM(REF.REFFOR) = '') or (REF.REFFOR IS NULL) THEN IPE.CODMAT 
                                                                             ELSE coalesce(TRIM(REF.REFFOR),' ') 
                                                                              END),'')
                                ELSE GRA.REFPRO
       END AS REFFOR,
       /*Valor Fixo */
       'AE3'
       /*Previsão Entrega dos Itens Pedido*/
       ||TO_CHAR(COALESCE(PED.DATENT,PED.DATPED),'YYYYMMDD')||TO_CHAR(LPAD(to_char(CAST(COALESCE(IPE.QTDPED,0) AS INTEGER)),12,'0'))
       ||LPAD(' ',8,' ')||LPAD(' ',12,' ')
       ||LPAD(' ',8,' ')||LPAD(' ',12,' ')
       ||LPAD(' ',8,' ')||LPAD(' ',12,' ')
       ||LPAD(' ',8,' ')||LPAD(' ',12,' ')
       /*Observação*/
       ||LPAD(' ',200,' ') AS LINHA
  FROM TT_PED PED INNER JOIN TT_IPE IPE ON IPE.CODFIL = PED.CODFIL AND IPE.NUMPED = PED.NUMPED 
                  INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR AND REL.CODPAR = PED.CODFOR 
                                       AND REL.TIPPAR = PED.TIPFOR 
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR 
                                       AND CLI.CODCLI = REL.CODPAR 
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = IPE.FILMAT AND GRA.CODMAT = IPE.CODMAT 
                                       AND GRA.CODCOR = IPE.CODCOR AND GRA.CODTAM = IPE.CODTAM 
                  INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT 
                  INNER JOIN TT_PXF PXF ON PXF.FILMAT = PRO.FILMAT AND PXF.CODMAT = PRO.CODMAT 
                                       AND PXF.FILFOR = REL.FILPAR AND PXF.CODFOR = REL.CODPAR 
                                       AND PXF.TIPFOR = REL.TIPPAR 
                                       AND PXF.CODCOR = IPE.CODCOR AND PXF.CODTAM = IPE.CODTAM 
                  LEFT  JOIN TT_REF REF ON REF.FILMAT = PXF.FILMAT AND REF.CODMAT = PXF.CODMAT 
                                       AND REF.CODCOR = PXF.CODCOR AND REF.CODTAM = PXF.CODTAM 
                                       AND REF.FILFOR = PXF.FILFOR AND REF.CODFOR = PXF.CODFOR                            
 WHERE PED.FLGEST = '2' 
   AND REL.TIPPAR = 'F' 
   AND CLI.PEDELE = 'T' 
 ;


/*-- SEQ 2411 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_BASF_ITP CASCADE;

/*-- SEQ 2412 --*/
CREATE OR REPLACE VIEW TV_PED_BASF_ITP AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       -1 AS NUMITE,
       TO_CHAR('*') AS REFFOR,
       /*Valor Fixo */
       'ITP'||'001'
       /*Transmissor*/
       ||RPAD(TRIM(FIL.CODFIL),8,' ')||RPAD(TRIM(FIL.RAZSOC),25,' ')||RPAD(TRIM(FIL.CGCFIL),15,' ')||RPAD(TRIM(FIL.IE_FIL),15,' ')||RPAD(TRIM(FIL.ENDERE),50,' ')
       ||RPAD(TRIM(FIL.BAIRRO),30,' ')||RPAD(TRIM(FMUN.NOMCID),25,' ')||RPAD(TRIM(FMUN.SIGEST),2,' ')||RPAD(TRIM(FIL.CODCEP),8,' ')
       /*Receptor*/
       ||( SELECT RPAD(TRIM(BCLI.CODCLI),8,' ')||RPAD(TRIM(BCLI.NOMCLI)||' '||TRIM(BCLI.ULTNOM),25,' ')||RPAD(TRIM(BCLI.NUMDOC),15,' ')||RPAD(TRIM(BCLI.INSEST),15,' ')
            FROM TT_CFG CFG INNER JOIN TT_CLI BCLI ON BCLI.FILCLI = CFG.FIL_BASF
                                                  AND BCLI.CODCLI = CFG.COD_BASF ) AS LINHA
  FROM TT_PED PED INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR AND REL.CODPAR = PED.CODFOR 
                                       AND REL.TIPPAR = PED.TIPFOR 
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR 
                                       AND CLI.CODCLI = REL.CODPAR 
                  INNER JOIN TD_FIL FIL ON FIL.CODFIL = PED.CODFIL 
                  INNER JOIN TT_MUN FMUN ON FMUN.CODIGO = FIL.CODCID 
 WHERE PED.FLGEST = '2' 
   AND REL.TIPPAR = 'F' 
   AND CLI.PEDELE = 'T' 
 ;


/*-- SEQ 2413 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_DIMED_0 CASCADE;

/*-- SEQ 2414 --*/
CREATE OR REPLACE VIEW TV_PED_DIMED_0 AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       -1 AS NUMITE,
       TO_CHAR('*') AS REFFOR,
       '0'||LPAD(TRIM(CFIL.MEUCOD),7,'0')||TO_CHAR(AGORA(),'DDMMYYYY')||TO_CHAR(AGORA(),'HH24MISS')||'0005'||LPAD(FIL.CGCFIL,14,'0') AS LINHA
  FROM TT_PED PED INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR AND REL.CODPAR = PED.CODFOR
                                       AND REL.TIPPAR = PED.TIPFOR                  
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR 
                                       AND CLI.CODCLI = REL.CODPAR
                  INNER JOIN TD_FIL FIL ON FIL.CODFIL = PED.CODFIL
                  LEFT  JOIN TT_CLIXFIL CFIL ON CFIL.FILCLI = CLI.FILCLI
                                            AND CFIL.CODCLI = CLI.CODCLI
                                            AND CFIL.CODFIL = PED.CODFIL 
 WHERE PED.FLGEST = '2'
   AND REL.TIPPAR = 'F'
   AND CLI.PEDELE = 'T'
 ;


/*-- SEQ 2415 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_DIMED_1 CASCADE;

/*-- SEQ 2416 --*/
CREATE OR REPLACE VIEW TV_PED_DIMED_1 AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       0 AS NUMITE,
       TO_CHAR('*') AS REFFOR,
       '1'||LPAD(TRIM(CFIL.MEUCOD),7,'0')||TO_CHAR('0001006')||TO_CHAR(LPAD(TRIM(COALESCE(PED.PEDEXT,'0')),11,'0'))||TO_CHAR('00000')||FIL.CGCFIL||TO_CHAR('000000000000') AS LINHA
  FROM TT_PED PED INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR AND REL.CODPAR = PED.CODFOR
                                       AND REL.TIPPAR = PED.TIPFOR
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR 
                                       AND CLI.CODCLI = REL.CODPAR
                  INNER JOIN TD_FIL FIL ON FIL.CODFIL = PED.CODFIL
                  LEFT  JOIN TT_CLIXFIL CFIL ON CFIL.FILCLI = CLI.FILCLI
                                            AND CFIL.CODCLI = CLI.CODCLI
                                            AND CFIL.CODFIL = PED.CODFIL 
 WHERE PED.FLGEST = '2'
   AND REL.TIPPAR = 'F'
   AND CLI.PEDELE = 'T'
 ;


/*-- SEQ 2417 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_DIMED_2 CASCADE;

/*-- SEQ 2418 --*/
CREATE OR REPLACE VIEW TV_PED_DIMED_2 AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       IPE.NUMITE,
       REF.REFFOR,
       '2'||LPAD(TRIM(CFIL.MEUCOD),7,'0')||TO_CHAR('0001006')||TO_CHAR(LPAD(TRIM(COALESCE(PED.PEDEXT,'0')),11,'0'))||LPAD(TRIM(REF.REFFOR),14,'0')||LPAD(TRIM(TO_CHAR(ROUND(IPE.QTDPED,0))),5,'0') AS LINHA
  FROM TT_PED PED INNER JOIN TT_IPE IPE ON IPE.CODFIL = PED.CODFIL AND IPE.NUMPED = PED.NUMPED
                  INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR AND REL.CODPAR = PED.CODFOR
                                       AND REL.TIPPAR = PED.TIPFOR
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI = REL.CODPAR
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = IPE.FILMAT AND GRA.CODMAT = IPE.CODMAT
                                       AND GRA.CODCOR = IPE.CODCOR AND GRA.CODTAM = IPE.CODTAM
                  INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
                  INNER JOIN TT_PXF PXF ON PXF.FILMAT = PRO.FILMAT AND PXF.CODMAT = PRO.CODMAT
                                       AND PXF.FILFOR = REL.FILPAR AND PXF.CODFOR = REL.CODPAR
                                       AND PXF.TIPFOR = REL.TIPPAR
                                       AND PXF.CODCOR = IPE.CODCOR AND PXF.CODTAM = IPE.CODTAM
                  INNER JOIN TT_REF REF ON REF.FILMAT = PXF.FILMAT AND REF.CODMAT = PXF.CODMAT
                                       AND REF.CODCOR = PXF.CODCOR AND REF.CODTAM = PXF.CODTAM 
                                       AND REF.FILFOR = PXF.FILFOR AND REF.CODFOR = PXF.CODFOR
                  LEFT  JOIN TT_CLIXFIL CFIL ON CFIL.FILCLI = CLI.FILCLI
                                            AND CFIL.CODCLI = CLI.CODCLI
                                            AND CFIL.CODFIL = PED.CODFIL 
 WHERE PED.FLGEST = '2'
   AND REL.TIPPAR = 'F'
   AND CLI.PEDELE = 'T'
 ;


/*-- SEQ 2419 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_DIMPER_1 CASCADE;

/*-- SEQ 2420 --*/
CREATE OR REPLACE VIEW TV_PED_DIMPER_1 AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       0 AS NUMITE,
       to_CHAR('*') AS REFFOR,
       '*'||LPAD(TRIM(CFIL.MEUCOD),5,'0')||TO_CHAR(PED.DATPED,'DDMMYYYY')||LPAD(TRIM(PED.CONVEN),4,'0')||LPAD(TRIM(COALESCE(PED.PEDEXT,'1')),6,'0')||'P'||COALESCE(ENDE.SIGEST,'PR') AS LINHA
  FROM TT_PED PED INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR AND REL.CODPAR = PED.CODFOR
                                       AND REL.TIPPAR = PED.TIPFOR
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI = REL.CODPAR
                  INNER JOIN TD_FIL FIL ON FIL.CODFIL = PED.CODFIL
                  LEFT  JOIN TT_END ENDE ON ENDE.FILCLI = PED.FILFOR AND ENDE.CODCLI = PED.CODFOR AND ENDE.NUMEND = PED.NUMEND
                  LEFT  JOIN TT_CLIXFIL CFIL ON CFIL.FILCLI = CLI.FILCLI
                                            AND CFIL.CODCLI = CLI.CODCLI
                                            AND CFIL.CODFIL = PED.CODFIL
 WHERE PED.FLGEST = '2'
   AND REL.TIPPAR = 'F'
   AND CLI.PEDELE = 'T'
 ;


/*-- SEQ 2421 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_DIMPER_2 CASCADE;

/*-- SEQ 2422 --*/
CREATE OR REPLACE VIEW TV_PED_DIMPER_2 AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       0 AS NUMITE,
       REF.REFFOR,
       LPAD(TRIM(REF.REFFOR),5,'0')||LPAD(TRIM(to_char(ROUND(IPE.QTDPED,0))),4,'0')||'000' AS LINHA
  FROM TT_PED PED INNER JOIN TT_IPE IPE ON IPE.CODFIL = PED.CODFIL AND IPE.NUMPED = PED.NUMPED
                  INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR AND REL.CODPAR = PED.CODFOR
                                       AND REL.TIPPAR = PED.TIPFOR
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI = REL.CODPAR
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = IPE.FILMAT AND GRA.CODMAT = IPE.CODMAT
                                       AND GRA.CODCOR = IPE.CODCOR AND GRA.CODTAM = IPE.CODTAM
                  INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
                  INNER JOIN TT_PXF PXF ON PXF.FILMAT = PRO.FILMAT AND PXF.CODMAT = PRO.CODMAT
                                       AND PXF.FILFOR = REL.FILPAR AND PXF.CODFOR = REL.CODPAR
                                       AND PXF.TIPFOR = REL.TIPPAR
                                       AND PXF.CODCOR = IPE.CODCOR AND PXF.CODTAM = IPE.CODTAM
                  INNER JOIN TT_REF REF ON REF.FILMAT = PXF.FILMAT AND REF.CODMAT = PXF.CODMAT
                                       AND REF.CODCOR = PXF.CODCOR AND REF.CODTAM = PXF.CODTAM 
                                       AND REF.FILFOR = PXF.FILFOR AND REF.CODFOR = PXF.CODFOR
 WHERE PED.FLGEST = '2'
   AND REL.TIPPAR = 'F'
   AND CLI.PEDELE = 'T'
 ;


/*-- SEQ 2423 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_GENESIO CASCADE;

/*-- SEQ 2424 --*/
CREATE OR REPLACE VIEW TV_PED_GENESIO AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       IPE.NUMITE,
       REF.REFFOR,
       LPAD(TRIM(CFIL.MEUCOD),5,'0')||LPAD(TRIM(REF.REFFOR),6,'0')||LPAD(TRIM(TO_CHAR(ROUND(IPE.QTDPED,0))),3,'0')||LPAD(TRIM(TO_CHAR(ROUND(IPE.NUMITE,0))),3,'0') AS LINHA
  FROM TT_PED PED INNER JOIN TT_IPE IPE ON IPE.CODFIL = PED.CODFIL AND IPE.NUMPED = PED.NUMPED
                  INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR AND REL.CODPAR = PED.CODFOR
                                       AND REL.TIPPAR = PED.TIPFOR
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI = REL.CODPAR
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = IPE.FILMAT AND GRA.CODMAT = IPE.CODMAT
                                       AND GRA.CODCOR = IPE.CODCOR AND GRA.CODTAM = IPE.CODTAM
                  INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
                  INNER JOIN TT_PXF PXF ON PXF.FILMAT = PRO.FILMAT AND PXF.CODMAT = PRO.CODMAT
                                       AND PXF.FILFOR = REL.FILPAR AND PXF.CODFOR = REL.CODPAR
                                       AND PXF.TIPFOR = REL.TIPPAR
                                       AND PXF.CODCOR = IPE.CODCOR AND PXF.CODTAM = IPE.CODTAM
                  INNER JOIN TT_REF REF ON REF.FILMAT = PXF.FILMAT AND REF.CODMAT = PXF.CODMAT
                                       AND REF.CODCOR = PXF.CODCOR AND REF.CODTAM = PXF.CODTAM
                                       AND REF.FILFOR = PXF.FILFOR AND REF.CODFOR = PXF.CODFOR
                  LEFT  JOIN TT_CLIXFIL CFIL ON CFIL.FILCLI = CLI.FILCLI
                                            AND CFIL.CODCLI = CLI.CODCLI
                                            AND CFIL.CODFIL = PED.CODFIL 
 WHERE PED.FLGEST = '2'
   AND REL.TIPPAR = 'F'
   AND CLI.PEDELE = 'T'
;


/*-- SEQ 2425 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_PANARELLO_1 CASCADE;

/*-- SEQ 2426 --*/
CREATE OR REPLACE VIEW TV_PED_PANARELLO_1 AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       -1 AS NUMITE,
       to_CHAR('*') AS REFFOR,
       '01'||LPAD(TRIM(CFIL.MEUCOD),8,'0')||TO_CHAR(AGORA(),'YYYYMMDD')||TO_CHAR(AGORA(),'HH24MI')||FIL.CGCFIL||'3'||TO_CHAR('      ') AS LINHA
  FROM TT_PED PED INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR AND REL.CODPAR = PED.CODFOR
                                       AND REL.TIPPAR = PED.TIPFOR
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI = REL.CODPAR
                  INNER JOIN TD_FIL FIL ON FIL.CODFIL = PED.CODFIL
                  LEFT  JOIN TT_CLIXFIL CFIL ON CFIL.FILCLI = CLI.FILCLI
                                            AND CFIL.CODCLI = CLI.CODCLI
                                            AND CFIL.CODFIL = PED.CODFIL 
 WHERE PED.FLGEST = '2'
   AND REL.TIPPAR = 'F'
   AND CLI.PEDELE = 'T'
 ;


/*-- SEQ 2427 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_PANARELLO_3 CASCADE;

/*-- SEQ 2428 --*/
CREATE OR REPLACE VIEW TV_PED_PANARELLO_3 AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       0 AS NUMITE,
       to_CHAR('*') AS REFFOR,
       '03'||LPAD(TRIM(PED.PEDEXT),6,'0')||'130000000000 000                     ' AS LINHA
  FROM TT_PED PED INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR AND REL.CODPAR = PED.CODFOR
                                       AND REL.TIPPAR = PED.TIPFOR
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI = REL.CODPAR
 WHERE PED.FLGEST = '2'
   AND REL.TIPPAR = 'F'
   AND CLI.PEDELE = 'T'
 ;


/*-- SEQ 2429 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_PANARELLO_4 CASCADE;

/*-- SEQ 2430 --*/
CREATE OR REPLACE VIEW TV_PED_PANARELLO_4 AS
SELECT DISTINCT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       IPE.NUMITE,
       IPE.QTDPED,
       to_CHAR('*') AS REFFOR,
       '04'||LPAD(TRIM(GRA.REFPRO),13,'0')||LPAD(TRIM('0'),13,'0')||'3'||LPAD(TRIM(TO_CHAR(ROUND(IPE.QTDPED * 100,0))),9,'0')||COALESCE(LPAD(MED.UNIMED,3,' '),' UN')||LPAD(TRIM(TO_CHAR(ROUND(COALESCE(GRA.QTDEMB,0),0))),4,'0') AS LINHA
  FROM TT_PED PED INNER JOIN TT_IPE IPE ON IPE.CODFIL = PED.CODFIL AND IPE.NUMPED = PED.NUMPED
                  INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR AND REL.CODPAR = PED.CODFOR
                                       AND REL.TIPPAR = PED.TIPFOR
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI = REL.CODPAR
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = IPE.FILMAT AND GRA.CODMAT = IPE.CODMAT
                                       AND GRA.CODCOR = IPE.CODCOR AND GRA.CODTAM = IPE.CODTAM
                  INNER JOIN TD_FIL FIL ON FIL.CODFIL = PED.CODFIL
		  INNER JOIN TD_MED MED ON GRA.UNIFOR = MED.CODTAB
 WHERE PED.FLGEST = '2'
   AND REL.TIPPAR = 'F'
   AND CLI.PEDELE = 'T'
 ;


/*-- SEQ 2431 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_PROFARMA_1 CASCADE;

/*-- SEQ 2432 --*/
CREATE OR REPLACE VIEW TV_PED_PROFARMA_1 AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       -3 AS NUMITE,
       to_CHAR('*') AS REFFOR,
       '1'||LPAD(TRIM(CFIL.MEUCOD),8,'0')||LPAD(TRIM(PED.CONVEN),2,'0') AS LINHA
  FROM TT_PED PED INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR AND REL.CODPAR = PED.CODFOR
                                       AND REL.TIPPAR = PED.TIPFOR
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI = REL.CODPAR
                  LEFT  JOIN TT_CLIXFIL CFIL ON CFIL.FILCLI = CLI.FILCLI
                                            AND CFIL.CODCLI = CLI.CODCLI
                                            AND CFIL.CODFIL = PED.CODFIL
 WHERE PED.FLGEST = '2'
   AND REL.TIPPAR = 'F'
   AND CLI.PEDELE = 'T'
 ;


/*-- SEQ 2433 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_PROFARMA_2 CASCADE;

/*-- SEQ 2434 --*/
CREATE OR REPLACE VIEW TV_PED_PROFARMA_2 AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       -2 AS NUMITE,
       to_CHAR('*') AS REFFOR,
       '2'||LPAD(TRIM(PED.PEDEXT),10,'0')||'0000' AS LINHA
  FROM TT_PED PED INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR AND REL.CODPAR = PED.CODFOR
                                       AND REL.TIPPAR = PED.TIPFOR
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI = REL.CODPAR
 WHERE PED.FLGEST = '2'
   AND REL.TIPPAR = 'F'
   AND CLI.PEDELE = 'T'
 ;


/*-- SEQ 2435 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_PROFARMA_5 CASCADE;

/*-- SEQ 2436 --*/
CREATE OR REPLACE VIEW TV_PED_PROFARMA_5 AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       -1 AS NUMITE,
       to_CHAR('*') AS REFFOR,
       '5'||TO_CHAR(PED.DATPED,'DDMMYYYY') AS LINHA
  FROM TT_PED PED INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR AND REL.CODPAR = PED.CODFOR
                                       AND REL.TIPPAR = PED.TIPFOR
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI = REL.CODPAR
 WHERE PED.FLGEST = '2'
   AND REL.TIPPAR = 'F'
   AND CLI.PEDELE = 'T'
 ;


/*-- SEQ 2437 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_PROFARMA_6 CASCADE;

/*-- SEQ 2438 --*/
CREATE OR REPLACE VIEW TV_PED_PROFARMA_6 AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       0 AS NUMITE,
       to_CHAR('*') AS REFFOR,
       '6'||TO_CHAR(PED.DATPED,'HH24MI') AS LINHA
  FROM TT_PED PED INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR AND REL.CODPAR = PED.CODFOR
                                       AND REL.TIPPAR = PED.TIPFOR
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI = REL.CODPAR
 WHERE PED.FLGEST = '2'
   AND REL.TIPPAR = 'F'
   AND CLI.PEDELE = 'T'
 ;



/*-- SEQ 2439 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_PROFARMA_7 CASCADE;

/*-- SEQ 2440 --*/
CREATE OR REPLACE VIEW TV_PED_PROFARMA_7 AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       IPE.NUMITE,
       IPE.QTDPED,
       to_CHAR('*') AS REFFOR,
       '7'||LPAD(TRIM(GRA.REFPRO),13,'0')||LPAD(TO_CHAR(ROUND(IPE.QTDPED,0)),5,'0') AS LINHA
  FROM TT_PED PED INNER JOIN TT_IPE IPE ON IPE.CODFIL = PED.CODFIL AND IPE.NUMPED = PED.NUMPED
                  INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR AND REL.CODPAR = PED.CODFOR
                                       AND REL.TIPPAR = PED.TIPFOR
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI = REL.CODPAR
                  INNER JOIN TT_END ENDE ON ENDE.FILCLI = CLI.FILCLI AND ENDE.CODCLI = CLI.CODCLI
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = IPE.FILMAT AND GRA.CODMAT = IPE.CODMAT
                                       AND GRA.CODCOR = IPE.CODCOR AND GRA.CODTAM = IPE.CODTAM
                  INNER JOIN TD_FIL FIL ON FIL.CODFIL = PED.CODFIL
 WHERE PED.FLGEST = '2'
   AND REL.TIPPAR = 'F'
   AND CLI.PEDELE = 'T'
 ;


/*-- SEQ 2441 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_SANTACRUZ_1 CASCADE;

/*-- SEQ 2442 --*/
CREATE OR REPLACE VIEW TV_PED_SANTACRUZ_1 AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       0 AS NUMITE,
       TO_CHAR('*') AS REFFOR,
       '1'||LPAD(TRIM(CFIL.MEUCOD),6,'0')||LPAD(TRIM(PED.PEDEXT),12,'0')||TO_CHAR(PED.DATPED,'DDMMYYYY')||
       CASE WHEN COALESCE(PED.CODCON,'1') = 'N' THEN 'Z' ELSE '1' END||'EC N        TTCOM'||LPAD(TRIM(COALESCE(PED.CONVEN,'0')),5,'0')||'000'||LPAD(' ',27,' ') AS LINHA
  FROM TT_PED PED INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR AND REL.CODPAR = PED.CODFOR
                                       AND REL.TIPPAR = PED.TIPFOR
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI = REL.CODPAR
                  LEFT  JOIN TT_CLIXFIL CFIL ON CFIL.FILCLI = CLI.FILCLI
                                            AND CFIL.CODCLI = CLI.CODCLI
                                            AND CFIL.CODFIL = PED.CODFIL
 WHERE PED.FLGEST = '2'
   AND REL.TIPPAR = 'F'
   AND CLI.PEDELE = 'T'
 ;


/*-- SEQ 2443 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_SANTACRUZ_2 CASCADE;

/*-- SEQ 2444 --*/
CREATE OR REPLACE VIEW TV_PED_SANTACRUZ_2 AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       IPE.NUMITE,
       to_CHAR('*') AS REFFOR,
       '2'||LPAD(TRIM(GRA.REFPRO),14,'0')||LPAD(TO_CHAR(ROUND((IPE.QTDPED),0)),5,'0')||LPAD(' ',60,' ') AS LINHA
  FROM TT_PED PED INNER JOIN TT_IPE IPE ON IPE.CODFIL = PED.CODFIL AND IPE.NUMPED = PED.NUMPED
                  INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR AND REL.CODPAR = PED.CODFOR
                                       AND REL.TIPPAR = PED.TIPFOR
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI = REL.CODPAR
                  INNER JOIN TT_END ENDE ON ENDE.FILCLI = CLI.FILCLI AND ENDE.CODCLI = CLI.CODCLI
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = IPE.FILMAT AND GRA.CODMAT = IPE.CODMAT
                                       AND GRA.CODCOR = IPE.CODCOR AND GRA.CODTAM = IPE.CODTAM
                  INNER JOIN TD_FIL FIL ON FIL.CODFIL = PED.CODFIL
 WHERE PED.FLGEST = '2'
   AND REL.TIPPAR = 'F'
   AND CLI.PEDELE = 'T'
 ;


/*-- SEQ 2445 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_SANTACRUZ_3 CASCADE;

/*-- SEQ 2446 --*/
CREATE OR REPLACE VIEW TV_PED_SANTACRUZ_3 AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       9999 AS NUMITE,
       to_CHAR('*') AS REFFOR,
       '3'||LPAD(TRIM(PED.PEDEXT),12,'0')||
       (SELECT LPAD(TO_CHAR(MAX(NUMITE) * 100),5,'0')
          FROM TT_IPE
         WHERE CODFIL = PED.CODFIL
           AND NUMPED = PED.NUMPED)||LPAD(TO_CHAR(ROUND(PED.QTDTOT * 100,0)),10,'0')||LPAD(' ',49,' ') AS LINHA
  FROM TT_PED PED INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR AND REL.CODPAR = PED.CODFOR
                                       AND REL.TIPPAR = PED.TIPFOR
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI = REL.CODPAR
 WHERE PED.FLGEST = '2'
   AND REL.TIPPAR = 'F'
   AND CLI.PEDELE = 'T'
;


/*-- SEQ 2447 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_TOTALL_0 CASCADE;

/*-- SEQ 2448 --*/
CREATE OR REPLACE VIEW TV_PED_TOTALL_0 AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       -1 AS NUMITE,
       TO_CHAR('*') AS REFFOR,       
       '0'||';'||
       COALESCE(LPAD(TRIM(CFIL.MEUCOD),7,'0'),' ')||';'||
       PED.CODFIL||TRIM(PED.NUMPED)||';'||
       COALESCE(TO_CHAR(PED.DATENT,'DDMMYYYY'),' ')||';'||
       COALESCE(REPLACE(to_char(PED.VLRTOT),',','.'),' ')||';'||
       COALESCE(REPLACE(to_char(PED.VLRLIQ),',','.'),' ')||';' 
       AS LINHA
  FROM TT_PED PED INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR 
                                       AND REL.CODPAR = PED.CODFOR
                                       AND REL.TIPPAR = PED.TIPFOR                  
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR 
                                       AND CLI.CODCLI = REL.CODPAR
                  INNER JOIN TD_FIL FIL ON FIL.CODFIL = PED.CODFIL
                  INNER JOIN TT_CLIXFIL CFIL ON CFIL.FILCLI = CLI.FILCLI
                                            AND CFIL.CODCLI = CLI.CODCLI
                                            AND CFIL.CODFIL = PED.CODFIL 
 WHERE PED.FLGEST = '2'
   AND REL.TIPPAR = 'F'
   AND CLI.PEDELE = 'T'
 ;


/*-- SEQ 2449 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_TOTALL_1 CASCADE;

/*-- SEQ 2450 --*/
CREATE OR REPLACE VIEW TV_PED_TOTALL_1 AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       0 AS NUMITE,
       TO_CHAR('*') AS REFFOR,
       '1'||';'||
       PED.CODFIL||TRIM(PED.NUMPED)||';'||
       CPE.NUMPAR||';'||
       TO_CHAR(CPE.DATVEN,'DDMMYYYY')||';'||
       CPE.VLRPAR||';' 
       AS LINHA
  FROM TT_PED PED INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR 
                                       AND REL.CODPAR = PED.CODFOR
                                       AND REL.TIPPAR = PED.TIPFOR
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR 
                                       AND CLI.CODCLI = REL.CODPAR
                  INNER JOIN TD_FIL FIL ON FIL.CODFIL = PED.CODFIL
                  INNER JOIN TT_CPE CPE ON CPE.CODFIL = PED.CODFIL
                                       AND CPE.NUMPED = PED.NUMPED
 WHERE PED.FLGEST = '2'
   AND REL.TIPPAR = 'F'
   AND CLI.PEDELE = 'T'
 ;


/*-- SEQ 2451 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_TOTALL_2 CASCADE;

/*-- SEQ 2452 --*/
CREATE OR REPLACE VIEW TV_PED_TOTALL_2 AS
SELECT PED.CODFIL,
       PED.NUMPED,
       PED.FILFOR,
       PED.CODFOR,
       PED.TIPFOR,
       PED.DATENV,
       IPE.NUMITE,
       CASE CLI.USAREF WHEN 'T' THEN coalesce(MAX(REF.REFFOR),'')
                                ELSE GRA.REFPRO
       END AS REFFOR,
       '2'||';'||
       PED.CODFIL||TRIM(PED.NUMPED)||';'||
       IPE.NUMITE||';'||
       CASE CLI.USAREF WHEN 'T' THEN TRIM(GRA.REFPRO)||';'
                                ELSE coalesce(TRIM(MAX(EAN.CODEAN)),'')||';'
       END||
       CASE CLI.USAREF WHEN 'T' THEN coalesce(TRIM(MAX(REF.REFFOR)),'')||';'
                                ELSE TRIM(GRA.REFPRO)||';'
       END||  
       COALESCE(IPE.VLRICM,0)||';'||
       IPE.VLRITE||';'||
       COALESCE(IPE.ICMITE,0)||';'||
       COALESCE(IPE.IPIITE,0)||';'||
       COALESCE(IPE.ISEICM,0)||';'||
       COALESCE(IPE.OUTICM,0)||';'||
       IPE.QTDPED||';'
       AS LINHA
  FROM TT_PED PED INNER JOIN TT_IPE IPE ON IPE.CODFIL = PED.CODFIL 
                                       AND IPE.NUMPED = PED.NUMPED
                  INNER JOIN TT_REL REL ON REL.FILPAR = PED.FILFOR 
                                       AND REL.CODPAR = PED.CODFOR
                                       AND REL.TIPPAR = PED.TIPFOR
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR 
                                       AND CLI.CODCLI = REL.CODPAR
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = IPE.FILMAT 
                                       AND GRA.CODMAT = IPE.CODMAT
                                       AND GRA.CODCOR = IPE.CODCOR 
                                       AND GRA.CODTAM = IPE.CODTAM
                  INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT 
                                       AND PRO.CODMAT = GRA.CODMAT
                  INNER JOIN TT_PXF PXF ON PXF.FILMAT = PRO.FILMAT 
                                       AND PXF.CODMAT = PRO.CODMAT
                                       AND PXF.FILFOR = REL.FILPAR 
                                       AND PXF.CODFOR = REL.CODPAR
                                       AND PXF.TIPFOR = REL.TIPPAR
                                       AND PXF.CODCOR = IPE.CODCOR 
                                       AND PXF.CODTAM = IPE.CODTAM
                   LEFT JOIN TT_EAN EAN ON GRA.FILMAT = EAN.FILMAT 
                                       AND GRA.CODMAT = EAN.CODMAT
                                       AND GRA.CODCOR = EAN.CODCOR 
                                       AND GRA.CODTAM = EAN.CODTAM  
                   LEFT JOIN TT_REF REF ON REF.FILMAT = PXF.FILMAT 
                                       AND REF.CODMAT = PXF.CODMAT
                                       AND REF.CODCOR = PXF.CODCOR 
                                       AND REF.CODTAM = PXF.CODTAM 
                                       AND REF.FILFOR = PXF.FILFOR 
                                       AND REF.CODFOR = PXF.CODFOR                                          
 WHERE PED.FLGEST = '2'
   AND REL.TIPPAR = 'F'
   AND CLI.PEDELE = 'T'
 GROUP BY PED.CODFIL, PED.NUMPED, PED.FILFOR, PED.CODFOR, PED.TIPFOR, PED.DATENV, 
          IPE.NUMITE, IPE.VLRITE, 
          COALESCE(IPE.VLRICM,0), 
          COALESCE(IPE.ICMITE,0),
          COALESCE(IPE.IPIITE,0),
          COALESCE(IPE.ISEICM,0),
          COALESCE(IPE.OUTICM,0),
          IPE.QTDPED,
          CLI.USAREF, 
          GRA.REFPRO          
 ;


/*-- SEQ 2453 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PES CASCADE;

/*-- SEQ 2454 --*/
CREATE OR REPLACE VIEW TV_PES AS
-- Traz o titular
SELECT DISTINCT FILCLI, CODCLI, NOMCLI, ULTNOM, NOMTRA,SIGNAT,
       NUMDOC,
       DATNAS,  
       NOMCLI AS BUSCA1, 
       ULTNOM AS BUSCA2,
       NOMTRA AS BUSCA3
  FROM TV_PAR 
 WHERE NUMDOC IS NOT NULL
UNION 
SELECT DISTINCT FILCLI, CODCLI, NOMCLI, ULTNOM, NOMTRA,SIGNAT,
       DOCVIN AS NUMDOC,
       DATNAS,  
       NOMCLI AS BUSCA1, 
       ULTNOM AS BUSCA2,
       NOMTRA AS BUSCA3
  FROM TV_PAR 
 WHERE NUMDOC IS NULL
UNION 
-- Traz o conjuge com ligacao
SELECT DISTINCT CLI.FILCLI, CLI.CODCLI, 
       cast(COALESCE(CLI.CONJUG,'')||CASE CLI.FLGTIP WHEN 0 
                                        THEN ' (Conjuge'
                                        ELSE ' (Contato'
                             END ||' de: '||COALESCE(CLI.NOMCLI,'')||')' as VARCHAR(254)) AS NOMCLI, 
       TO_CHAR(NULL) AS ULTNOM, 
       TO_CHAR(NULL) AS NOMTRA,
       CLI.SIGNAT, 
       CLI.DOCCON AS NUMDOC, 
       CLI.NASCON,
       CNJ.NOMCLI AS BUSCA1, 
       CNJ.ULTNOM AS BUSCA2,
       TO_CHAR(NULL) AS BUSCA3
  FROM TT_CLI CLI INNER JOIN TT_CLI CNJ ON CLI.FILCON=CNJ.FILCLI AND CLI.CODCON=CNJ.CODCLI 
UNION 
-- Traz o conjuge ou contato sem ligacao por tabela
SELECT DISTINCT CLI.FILCLI, CLI.CODCLI, 
       cast(COALESCE(CLI.CONJUG,'')||CASE CLI.FLGTIP WHEN 0 
                                        THEN ' (Conjuge'
                                        ELSE ' (Contato'
                             END ||' de: '||COALESCE(CLI.NOMCLI,'')||')' as VARCHAR(254)) AS NOMCLI, 
       TO_CHAR(NULL) AS ULTNOM, 
       TO_CHAR(NULL) AS NOMTRA,
       CLI.SIGNAT, 
       CLI.DOCCON AS NUMDOC, 
       CLI.NASCON,
       CLI.CONJUG AS BUSCA1, 
       SeparaNomes(CLI.CONJUG,'T','T','') AS BUSCA2,
       TO_CHAR(NULL) AS BUSCA3
  FROM TT_CLI CLI LEFT JOIN TT_CLI CNJ ON CLI.FILCON=CNJ.FILCLI AND CLI.CODCON=CNJ.CODCLI 
 WHERE CNJ.FILCLI IS NULL
UNION 
-- Traz o contato
SELECT DISTINCT CON.FILCLI, CON.CODCLI,
       cast(COALESCE(CON.CONTAT,'')||' (Contato de: '||COALESCE(CLI.NOMCLI,'')||')' as VARCHAR(254)) AS NOMCLI,
       TO_CHAR(NULL) AS ULTNOM, 
       CON.NOMTRA, CLI.SIGNAT, 
       CLI.NUMDOC AS NUMDOC, 
       CON.DATNAS,
       CON.CONTAT AS BUSCA1, 
       TO_CHAR(NULL) AS BUSCA2,
       CON.NOMTRA AS BUSCA3
  FROM TT_CLI CLI INNER JOIN TT_CON CON ON CLI.FILCLI = CON.FILCLI AND CLI.CODCLI = CON.CODCLI
UNION 
-- Traz o endereo
SELECT DISTINCT ENDE.FILCLI, ENDE.CODCLI,
       cast(COALESCE(DEND.DESEND,'')||' (Endereo de: '||COALESCE(CLI.NOMCLI,'')||')' as VARCHAR(254)) AS NOMCLI,
       TO_CHAR(NULL) AS ULTNOM, 
       DEND.DESEND AS NOMTRA,
       CLI.SIGNAT, 
       ENDE.NUMDOC AS NUMDOC, 
       CLI.DATNAS,
       TO_CHAR(NULL) AS BUSCA1, 
       TO_CHAR(NULL) AS BUSCA2,
       TO_CHAR(NULL) AS BUSCA3
  FROM TT_CLI CLI INNER JOIN TT_END ENDE ON CLI.FILCLI = ENDE.FILCLI AND CLI.CODCLI = ENDE.CODCLI
                  INNER JOIN TD_END DEND ON ENDE.TIPEND=DEND.CODTAB
 WHERE ENDE.NUMDOC<>CLI.NUMDOC
;


/*-- SEQ 2455 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PESFAT CASCADE;

/*-- SEQ 2456 --*/
CREATE OR REPLACE VIEW TV_PESFAT AS
SELECT COM.NUMNOT, COM.FLGEST, COM.CODFIL, COM.SEQUEN, COM.CODSER, COM.DATCMP,                
       COM.DATOPE, COM.FILFOR, COM.CODFOR, COM.SUBSER, COM.SEQCAN, COM.TIPNOT,                
       CLI.NOMCLI, CLI.ULTNOM, COM.VLRLIQ, COM.OBSFAT, COM.SEQFAT, PAG.DATVEN,
       COM.TIPPAR, PAG.SEQUEN AS SEQPAG, COM.CODAVU, COM.FINNFE, PAG.DATPGT
  FROM TT_CLI CLI INNER JOIN TT_COM COM ON CLI.FILCLI = COM.FILFOR AND CLI.CODCLI = COM.CODFOR
                   LEFT JOIN TT_PAG PAG ON PAG.CODFIL = COM.CODFIL AND PAG.SEQUEN = COM.SEQUEN
 WHERE COM.VLRLIQ <> 0
;


/*-- SEQ 2457 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PAR_EVE_VEN CASCADE;

/*-- SEQ 2458 --*/
CREATE OR REPLACE VIEW TV_PAR_EVE_VEN AS
SELECT REC.SEQUEN, 
       REC.DATPRE, 
       REC.FLGFLU, 
       REC.ORIREC, 
       REC.SUBORI, 
       REC.VLRPRE, 
       REC1.NOMFIL AS FILIAL_RECEBIMENTO, 
       REC.FILREC, 
       REC.CODFIL, 
       REC2.NOMFIL AS FILIAL, 
       (CASE WHEN REC.SIGNAT>=0 THEN 'T' ELSE 'F' END) AS ATIVO, 
       (REC.NUMPAR || (CASE WHEN REC.SUBPAR = ' 0' THEN ' ' ELSE '-' || LTRIM(REC.SUBPAR) END)) AS PARCELA, 
       REC.SUBPAR, 
       TO_NUMBER(REC.SUBPAR) AS SUBPAR_NUM, 
       REC.NUMECF, 
       substr(FLGEST.DESDOM,1,30) AS FLGEST_DOM, 
       REC.CUPFIS, 
       REC3.APEUSU, 
       REC.CODEXT, 
       REC.DATINC, 
       RTRIM(SUBSTR(MEIODEPAGAMENTO(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR,0),1,250)) AS MEIPGT, 
       SUBSTR( CASE WHEN REC.SEQCHE IS NULL AND REC.CARTAO IS NULL AND REC.FLGEST IN ('A','X','C') THEN NULL ELSE MEIODEPAGAMENTO( REC.CODFIL,REC.SEQUEN, REC.NUMPAR, REC.SUBPAR,0) END ,1,50) AS PAGAMENTO, 
       REC.NUMPAR, 
       DATAFATURAMENTOCARTAO(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) AS DATFATCAR, 
       TRAZ_DATPRO(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) AS DATPRO, 
       (SELECT CASE WHEN TRUNC(REC.PAGAME)=TRUNC(VEN.DATHOR) THEN 'T' ELSE 'F' END FROM TT_VEN VEN WHERE REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN) AS DATPAGVEN, 
       CALCDIFPAG(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) AS DIFPAG, 
       CAST(TRAZNOSNUM(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) AS VARCHAR(20)) AS NOSNUM, 
       REC4.DESOUT, 
       REC5.DESCCC, 
       REC.PAGAME, 
       REC.VLRTAX, 
       REC.ESTCAN, 
       REC.DATVEN, 
       REC.VLRPGT, 
       REC.VLRPAR, 
       REC6.DESCOB, 
       REC7.DESMOE, 
       REC.ATU_EM, 
       REC.RENEGO, 
       REC.RENORI, 
       TRUNC(DATVEN)-TRUNC(AGORA()) AS DIAS_VENC, 
       REC.DATFIS, 
       (SELECT CASE WHEN COUNT(*)>0 AND REC.FLGEST='P' THEN 'T' ELSE 'F' END FROM TT_REC SUB WHERE SUB.CODFIL=REC.CODFIL AND SUB.SEQUEN=REC.SEQUEN AND SUB.NUMPAR=REC.NUMPAR AND SUB.SUBORI=REC.SUBPAR) AS PARCIAL, 
       TRUNC(AGORA())-TRUNC(REC.DATVEN) AS DIASATR, 
       TRUNC(COALESCE(REC.PAGAME, AGORA())) - TRUNC(REC.DATVEN) AS VENC_DIAS, 
       COALESCE(REC.PAGAME,AGORA()) AS DATPAGPER, 
       REC8.DESCAR, 
       REC.FILCTA, 
       REC.SEQCTA, 
       SUBSTR(TIPCTA.DESDOM,1,30) AS TIPCTA_DOM, 
       CASE REC.FLGEST WHEN 'A' THEN REC.VLRPAR WHEN 'P' THEN REC.VLRPGT-COALESCE(REC.VLRDES,0)+COALESCE(REC.VLRTAX,0) WHEN 'C' THEN COALESCE(REC.VLRDES,0)*-1 END AS VLRAJU, 
       REC.FILITF, 
       REC.SEQITF, 
       REC.ITEITF, 
       REC.SEQCHE, 
       (CASE WHEN COALESCE(REC.VLRDES,0) < 0 AND REC.CARTAO IS NULL THEN ABS(REC.VLRDES) ELSE 0 END) AS VLRDES, 
       DESCONTOPARCELA(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) AS JURDES, 
       CALCRECATU(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR,0,REC.PAGAME) AS VLRCOR, 
       (CASE WHEN COALESCE(REC.VLRDES,0) > 0 AND REC.CARTAO IS NULL THEN ABS(REC.VLRDES) ELSE 0 END) AS VLRJUR, 
       REC9.NOMFIL AS FIL_VENDA_RENEG, 
       REC.SEQREN, 
       REC.PROCES, 
       RTRIM(SUBSTR(OPERACAOCAIXA('REC',REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR),1,50)) AS OPER_CAIX, 
       PLA.DESPGT
  FROM TT_REC REC 
       INNER JOIN TT_VEN VEN ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
       INNER JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT AND PLA.CODPGT = VEN.CODPGT  
  LEFT OUTER JOIN TD_FIL REC1 ON REC1.CODFIL = REC.FILREC
  LEFT OUTER JOIN TD_FIL REC2 ON REC.CODFIL = REC2.CODFIL
        LEFT JOIN TT_DOM FLGEST ON FLGEST.CODARQ = 'REC' AND FLGEST.NOMCPO = 'FLGEST' AND FLGEST.CODCHR = REC.FLGEST
  LEFT OUTER JOIN TT_USU REC3 ON REC.FILUSU = REC3.FILUSU AND REC.CODUSU = REC3.CODUSU
  LEFT OUTER JOIN TD_CAR REC4 ON REC4.CODTAB = REC.CARTAO
  LEFT OUTER JOIN TD_CCC REC5 ON REC5.CODTAB = REC.TIPCCC
  LEFT OUTER JOIN TD_COB REC6 ON REC.PORTAD = REC6.CODTAB
  LEFT OUTER JOIN TD_MOE REC7 ON REC.CODMOE = REC7.CODTAB
  LEFT OUTER JOIN TD_OUT REC8 ON REC8.CODTAB = REC.CODOUT
        LEFT JOIN TT_DOM TIPCTA ON TIPCTA.CODARQ = 'REC' AND TIPCTA.NOMCPO = 'TIPCTA' AND TIPCTA.CODCHR = REC.TIPCTA
  LEFT OUTER JOIN TD_FIL REC9 ON REC9.CODFIL = REC.FILREN
;


/*-- SEQ 2459 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PGT CASCADE;

/*-- SEQ 2460 --*/
CREATE OR REPLACE VIEW TV_PGT AS
SELECT PAG.VLRPAR-PAG.VLRPAR+1 as VE_PAGTO_FUN,
       PAG.SEQUEN, PAG.CODFIL, PAG.NUMPAR, PAG.SUBPAR, PAG.FLGEST, PAG.DATVEN, PAG.DATPGT,
       PAG.ATU_EM, PAG.FILUSU, PAG.CODUSU, PAG.CONPGT, PAG.DOCPGT, PAG.SIGNAT, PAG.FILAUT,
       PAG.CODAUT, PAG.FILPRO, PAG.CODPRO, PAG.DATPRX, PAG.DUMMY , PAG.FILDOP, PAG.SEQDOP,
       PAG.CODBCO, PAG.DATINC, PAG.SUBORI,
       PAG.VLRPGT,
       PAG.VLRPAR,
       PAG.VLRDES,
       PAG.VLRDIF,
       PAG.RENEGO,
       PAG.RENORI,
       PAG.FLGFLU,
       PAG.VLRPRE,
	   PAG.AUTBAN,
	   PAG.VLRJUR
  FROM TT_COM COM INNER JOIN TT_PAG PAG ON COM.CODFIL = PAG.CODFIL 
                                       AND COM.SEQUEN = PAG.SEQUEN                  
                  INNER JOIN TT_USU USU ON USU.APEUSU = GetApeUsuAtual() -- Usurio Logado
                   LEFT JOIN TT_USU UCLI ON UCLI.FILCLI = COM.FILFOR 
                                        AND UCLI.CODCLI = COM.CODFOR -- Usurio do compromisso                 
 WHERE UCLI.APEUSU IS NULL -- Compra/Compromisso no  de funcionrio
    OR SUBSTR(USU.PERMIS,147,1) = 'S' -- Usurio logado tem permisso para ver pagamentos de outro funcionrios
    OR EXISTS (SELECT 1 AS OK         
                  FROM TT_PAP PAP INNER JOIN TT_PAPXUSU PXU ON PXU.FILPAP = PAP.CODFIL
                                                           AND PXU.SEQPAP = PAP.SEQUEN
                 WHERE SUBSTR(PAP.PERMIS,147,1) = 'S'
                   AND PXU.FILUSU = USU.FILUSU
                   AND PXU.CODUSU = USU.CODUSU) -- Papel do usurio tem permisso para ver pagamentos de outro funcionrios
    -- Usurio  o OWNER
    OR (SELECT IDF.USUADM FROM TT_IDF IDF) = GetApeUsuAtual()
;




/*-- SEQ 2461 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PRJ_BAS CASCADE;

/*-- SEQ 2462 --*/
CREATE OR REPLACE VIEW TV_PRJ_BAS AS
SELECT CODFIL,SEQUEN,FILCLI,CODCLI,CHVPRJ,CHVPAI
FROM TT_PRJ
;








/*-- SEQ 2463 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PRO_CONTROLADO CASCADE;

/*-- SEQ 2464 --*/
CREATE OR REPLACE VIEW TV_PRO_CONTROLADO AS
SELECT IVE.QTDMOV, -- QTD
       PRO.REFBAS, -- COD REF
       GRA.REFPRO, -- COD ISBN
       PRO.DESMAT, -- TITULO
       (IVE.VLRMOV/IVE.QTDMOV) AS PREUNI, -- PRECO UNITARIO
       IVE.VLRMOV, -- VALOR LIQUIDO
       VEN.NUMNOT, -- CF
       CAST((SELECT NUMNOT
               FROM TT_VEN 
              WHERE CODFIL = VEN.CODFIL
                AND SEQUEN = VEN.SEQFAT
                AND VEN.NROIMP = '2') AS CHAR(6)) AS NOTIMP, -- NF
       VEN.DATFIS, -- DATA DA VENDA
       CLI.NUMDOC -- CPF CNPJ DO COMPRADOR
  FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON VEN.CODFIL = IVE.CODFIL
                                       AND VEN.SEQUEN = IVE.SEQUEN
                  INNER JOIN TT_GRA GRA ON IVE.FILMAT = GRA.FILMAT 
                                       AND IVE.CODMAT = GRA.CODMAT
                                       AND IVE.CODCOR = GRA.CODCOR 
                                       AND IVE.CODTAM = GRA.CODTAM
                  INNER JOIN TT_PRO PRO ON GRA.FILMAT = PRO.FILMAT
                                       AND GRA.CODMAT = PRO.CODMAT 
                  INNER JOIN TT_CLI CLI ON VEN.FILCLI = CLI.FILCLI
                                       AND VEN.CODCLI = CLI.CODCLI
 WHERE VEN.CODSER = 'CF' 
   AND PRO.CONTRO = 'T'  -- Produto controlado.
   AND VEN.FLGEST <> 'C'
   AND IVE.SITMOV = 'N'
;


/*-- SEQ 2465 --*/
/*-- IGNORE ERRO --*/
SELECT * FROM NADA;

-- RFMP 
-- View era utilizada pela carga do Checkout. 
-- Agora no est mais sendo utilizada.
/*
CREATE OR REPLACE VIEW TV_PRO_OUT AS
SELECT rpad(GRA.FILMAT||GRA.CODMAT||'-'||TO_CHAR(GRA.CODCOR)||'-'||TO_CHAR(GRA.CODTAM),21,' ') as CHAVEPRO,
GRA.PTOQTD,GRA.PERCOM,PRO.DESMAT,PRO.REFBAS,PRO.ESPMAT,GRA.MINQTD,PRO.DECIMA,
GRA.VALCON,GRA.PERLUC,PRO.NUMEXT,PRO.BRINDE,GRA.REFPRO,PRO.DESECF,TRI.CODTRI,
PRE.CODMOE,PRO.CLASS1,PRO.CLASS2,PRO.CLASS3,PRO.CLASS4,PRE.FLGEST,PRO.RETCOF,
MAR.DESMAR,PRO.CODGRA,DIV.ORDDIV,SUB.ORDSUB,PRO.BALSIM,GRA.PRECOM,IUF.ESTADO,
FIS.CODFIS,IUF.CALSUB,IUF.INSAGR,IUF.REGESP,IUF.PERSRV,PRO.ICMFED,IUF.MVAVEN,IUF.MVAC07,IUF.MVAC12,PRO.ARRTRU,PRO.IIPTPR, 
CASE WHEN PRO.SIGNAT < 0 THEN PRO.SIGNAT ELSE CASE WHEN GRA.GRAATI = 'T' THEN PRO.SIGNAT ELSE PRO.SIGNAT * -1 END END AS SIGNAT,
ICM.RESICM AS PERICM,IES.ICMSES AS REDESP,IME.ICMSME AS REDUME,
IRE.ICMSRE AS REDBAS,IRE.REDCON,
IR1.ICMSR1 AS REDGR1,IR2.ICMSR2 AS REDGR2,
IUF.LUCSUB AS MARGST,IUF.SUBTRI AS TIPICM,ISS.RESISS AS PERISS,
DIV.NOMITE AS ITEDIV,SUB.NOMITE AS ITESUB,MED.UNIMED AS UNIDAD,
GRA.UNIDAD AS UNIVEN,GRA.UNIFOR AS UNICOM,IPI.RESIPI AS PERIPI,
IRR.RESIRR AS PERIRR,PRO.TIPPRO AS SERMAT,GRA.SEQUEN AS SEQUEN,
RPAD(coalesce(TO_CHAR(IUF.CODCFP),' '),5,' ') AS CODCFP,
CASE WHEN CFG.ValorTransferencia = 'R' THEN GRA.CUSREP ELSE TRUNC(ValoresProduto(CFG.ValorTransferencia, GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, NULL, GRA.CUSREP),4) END AS CUSREP,
CASE COALESCE(PRE.DESMAX,0) WHEN 0 THEN GRA.DESMAX ELSE PRE.DESMAX END as DESMAX,
Rtf2txt(CAST(SUBSTR(COALESCE(PRO.OBSERV,'')||COALESCE((SELECT AGREGATXT(ITE.DESMAT) FROM TT_KIT KIT INNER JOIN TT_PRO ITE ON KIT.FILITE = ITE.FILMAT AND KIT.CODITE = ITE.CODMAT WHERE KIT.FILMAT = PRO.FILMAT AND KIT.CODMAT = PRO.CODMAT AND KIT.FLGIMP = 'T'),'') || CASE WHEN GRA.OBSERV IS NOT NULL THEN chr(13)||chr(10)||COALESCE(gra.observ,'') ELSE '' END,1,4000) AS VARCHAR(4000))) as OBSERV,
COALESCE(PRO.NOMIMG,DEP.IMGDEP) AS IMAGEM,
PRO.FILMAR||PRO.CODMAR AS CHAVEMAR, TO_CHAR(PRO.ATU_EM,'DD/MM/YYYY HH24:MI:SS') AS ATU_EM,
PRO.IMPKIT, GRA.QTDMUL, PRO.TIPMPB,
PRO.CODANP,GRA.CODNCM,PRO.SITCOF,PRO.SITPIS,PRO.COD_EX,PRO.SITIPI, PRO.CODSRV, PRO.CODFPS, PRO.ORIPRO, GRA.PREFIS,
round(ICO.BASSUBDIF/ICO.QTDMOV,4) AS BASSUB, round(ICO.VLR_STDIF/ICO.QTDMOV,4) AS VLR_ST,
FIL.CODFIL,
COALESCE(round(ICO.BASIPI/ICO.QTDMOV,4), 0) AS BASIPI,
COALESCE(round(ICO.VLRIPI/ICO.QTDMOV,4), 0) AS VLRIPI,
COALESCE(round((ICO.ICO_VLRFRE + ICO.IPIFRE)/ICO.QTDMOV,4), 0) AS VLRFRE, PRO.VENPIS, PRO.VENCOF
from TT_PRO PRO INNER JOIN TT_GRA GRA ON GRA.FILMAT = PRO.FILMAT AND GRA.CODMAT = PRO.CODMAT
INNER JOIN TT_DIV DIV ON GRA.CODCOR = DIV.CODITE
INNER JOIN TT_SUB SUB ON GRA.CODTAM = SUB.CODITE
INNER JOIN TD_MED MED ON GRA.UNIDAD = MED.CODTAB
CROSS JOIN TD_FIL FIL 
CROSS JOIN TT_CFG CFG
LEFT OUTER JOIN TD_DEP DEP ON DEP.CODTAB = PRO.DEPART
LEFT OUTER JOIN TD_IPI IPI ON IPI.CODTAB = PRO.RESIPI
LEFT OUTER JOIN TD_IRR IRR ON IRR.CODTAB = PRO.RESIRR
LEFT OUTER JOIN TT_MAR MAR ON MAR.FILMAR = PRO.FILMAR AND MAR.CODMAR = PRO.CODMAR AND MAR.ITEMAR = PRO.ITEMAR
LEFT OUTER JOIN TT_PRE PRE ON PRE.FILMAT = GRA.FILMAT AND PRE.CODMAT = GRA.CODMAT AND PRE.CODCOR = GRA.CODCOR AND PRE.CODTAM = GRA.CODTAM AND PRE.FILPRE = CFG.FILPRE AND PRE.CODPRE = CFG.CODPRE
LEFT OUTER JOIN TT_IMU IMU ON IMU.FILMAT = PRO.FILMAT AND IMU.CODMAT = PRO.CODMAT AND IMU.CODCID = FIL.CODCID
LEFT OUTER JOIN TD_ISS ISS ON ISS.CODTAB = IMU.RESISS
LEFT OUTER JOIN TT_IUF IUF ON IUF.FILMAT = PRO.FILMAT AND IUF.CODMAT = PRO.CODMAT AND IUF.ESTADO = FIL.UFLOJA AND IUF.REGESP = FIL.REGESP
LEFT OUTER JOIN TD_IME IME ON IME.CODTAB = IUF.REDUME
LEFT OUTER JOIN TD_FIS FIS ON FIS.CODTAB = IUF.CODFIS
LEFT OUTER JOIN TD_IR2 IR2 ON IR2.CODTAB = IUF.REDUC2
LEFT OUTER JOIN TD_IR1 IR1 ON IR1.CODTAB = IUF.REDUC1
LEFT OUTER JOIN TD_IRE IRE ON IRE.CODTAB = IUF.REDALI
LEFT OUTER JOIN TD_IES IES ON IES.CODTAB = IUF.REDESP
LEFT OUTER JOIN TD_ICM ICM ON ICM.CODTAB = IUF.RESICM
LEFT OUTER JOIN TD_TRI TRI ON TRI.CODTAB = COALESCE(IUF.CODTRI,PRO.CODTRI)
LEFT OUTER JOIN TT_ICO ICO ON GRA.FILCOM = ICO.CODFIL AND GRA.SEQCOM = ICO.SEQUEN AND GRA.ITECOM = ICO.NUMITE
WHERE ((CFG.PAPHOTO='F')
   OR ((PRO.FILMAT||PRO.CODMAT<>COALESCE(CFG.PAPHOFILREVELA||CFG.PAPHOCODREVELA,' ')) AND 
       (PRO.FILMAT||PRO.CODMAT<>COALESCE(CFG.PAPHOFILREVAMP||CFG.PAPHOCODREVAMP,' ')) AND
       (PRO.FILMAT||PRO.CODMAT<>COALESCE(CFG.PAPHOFILAMPLIA||CFG.PAPHOCODAMPLIA,' '))))
;
*/


/*-- SEQ 2466 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PVD CASCADE;

/*-- SEQ 2467 --*/
CREATE OR REPLACE VIEW TV_PVD AS
  SELECT REL.FILPAR, REL.CODPAR, REL.TIPPAR, CLI.FILCLI, CLI.CODCLI,
         CLI.ATU_EM, CLI.NOMCLI, CLI.ULTNOM, CLI.NUMDOC, CLI.DOCCON,
         CLI.DATNAS, CLI.ESTCIV, CLI.HOMPGE, CLI.FLGTIP, CLI.INSEST,
         CLI.CODSEX, CLI.CATEG1, CLI.CATEG2, CLI.CATEG3, CLI.DATA01,
         CLI.DATA02, CLI.DATA03, CLI.DATOPE, CLI.IMPRIM, CLI.VALOR1,
         CLI.TOTATR, CLI.TOTPAR, CLI.MAIATR, CLI.OBSERV, CLI.FILPLA,
         CLI.CODPLA, CLI.PORPAD, CLI.ULTCOM, CLI.SIGNAT, CLI.CONJUG,
         CLI.NASCON, CLI.SEXCON, CLI.FILVEN, CLI.CODVEN, CLI.FILVIN,
         CLI.CODVIN, CLI.PP_FLG, CLI.VLRMIN_PEDCOM
    FROM TT_REL REL INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR
                                         AND CLI.CODCLI = REL.CODPAR
   WHERE REL.TIPPAR IN ('F','T','M')
   ;




/*-- SEQ 2468 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RAD_CLI CASCADE;

/*-- SEQ 2469 --*/
CREATE OR REPLACE VIEW TV_RAD_CLI AS
SELECT CODFIL,
       DATAOK,
       ULTNOM ||';'|| NOMCLI ||';'|| ENDERE ||';'|| BAIRRO ||';'|| SIGEST ||';'|| CEP ||';'|| CODDDD ||';'||
       NUMFON ||';'|| NUMFAX ||';'|| NUMDOC AS LINHA
  FROM ( SELECT CLI.ULTNOM AS ULTNOM,
                CLI.NOMCLI AS NOMCLI,
                ENDE.ENDERE AS ENDERE,
                ENDE.BAIRRO AS BAIRRO,
                ENDE.SIGEST AS SIGEST,
                COALESCE(ENDE.CODCEP,'00000')||'-'||COALESCE(ENDE.CODLOG,'000') AS CEP,
                COALESCE(ENDE.CODDDD,'0') AS CODDDD,
                COALESCE(ENDE.NUMFON,'0') AS NUMFON,
                COALESCE(ENDE.NUMFAX,'0') AS NUMFAX,
                TRIM(COALESCE(ENDE.NUMDOC,CLI.NUMDOC)) AS NUMDOC,
                COALESCE(CLI.INSEST,' ')AS INSEST,
                VEN.CODFIL,
                VEN.DATHOR AS DATAOK
           FROM TT_CLI CLI LEFT OUTER JOIN TT_END ENDE ON CLI.FILCLI = ENDE.FILCLI AND CLI.CODCLI = ENDE.CODCLI
                                INNER JOIN TT_VEN VEN ON VEN.FILCLI = CLI.FILCLI AND VEN.CODCLI = CLI.CODCLI
      WHERE (CLI.NUMDOC IS NOT NULL
       OR ENDE.NUMDOC IS NOT NULL)
    UNION ALL 
   SELECT TO_CHAR('VENDA AO CONSUMIDOR') AS ULTNOM,
          TO_CHAR('VENDA AO CONSUMIDOR') AS NOMCLI,
          TO_CHAR('INDEFINIDO') AS ENDERE, 
          TO_CHAR('INDEFINIDO') AS BAIRRO,
          TO_CHAR(' ') AS SIGEST,
          TO_CHAR(' ') AS CEP,
          TO_CHAR(' ') AS CODDDD,
          TO_CHAR(' ') AS NUMFON,
          TO_CHAR(' ') AS NUMFAX,
          TO_CHAR('11111111111') AS NUMDOC,
          TO_CHAR('ISENTO') AS INSEST,
          NULL AS CODFIL,
          NULL AS DATAOK
     FROM DUAL) TAB
;


/*-- SEQ 2470 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RAD_COM CASCADE;

/*-- SEQ 2471 --*/
CREATE OR REPLACE VIEW TV_RAD_COM AS
 SELECT COM.CODFIL, COM.SEQUEN,
         COM.TIPPAR, COM.NUMNOT, FIS.ESPDOC,
         CASE WHEN SUBSTR(ICO.NATURE,1,4) NOT IN ('1202','2202') 
              THEN CASE WHEN SUBSTR(ICO.NATURE,1,4) IN ('1949','2949','1411','2411') 
                        THEN ROUND(ABS(SUM(ICO.VLRMOV + ROUND((ICO.VLRMOV * COM.DESCON / 100),4))),2) 
                        ELSE ROUND(SUM(ICO.VLRMOV + ICO.VLRIPI) + SUM(((( COM.DESCON * ( (ICO.VLRMOV) / COM.VLRTOT)) / ICO.QTDMOV))),2)
                    END 
              ELSE ROUND(ABS(SUM(ICO.VLRMOV + ICO.VLRIPI)+COM.DESCON),2)
           END AS VLRLIQ,
         MAX(CASE COALESCE(ICO.ICMITE,0) WHEN 0 THEN COM.SUBSTT
                                                ELSE 0
             END) AS VLRSUB,
         ROUND(ABS(SUM(ICO.VLRIPI)),2) AS VLRIPI,
--         ROUND(ABS(SUM(CASE ICO.TIPPRO WHEN '0' THEN (ICO.VLRMOV+(COM.DESCON*(ICO.VLRMOV*100/COM.VLRTOT)/100))
--                                                ELSE 0
--                       END)),2) AS BASIPI,
         CASE COALESCE(ICO.IPIITE,0) WHEN 0 THEN 0
                                            ELSE CASE WHEN SUBSTR(ICO.NATURE,1,4) IN ('1403','2403')
                                                      THEN 0
                                                      ELSE ROUND(SUM(ICO.VLRMOV + ICO.VLRIPI) + SUM(((( COM.DESCON * ( (ICO.VLRMOV) / COM.VLRTOT)) / ICO.QTDMOV))),2)
                                                  END
          END AS BASIPI,
         0 AS ISEIPI,
         SUM(CASE ICO.TIPPRO WHEN '0' THEN 0
                                      ELSE CASE COALESCE(ICO.IPIITE,0) WHEN 0 THEN ICO.VLRMOV
                                                                              ELSE 0
                                           END
             END) AS OUTIPI,
         CASE WHEN SUBSTR(ICO.NATURE,1,4) IN ('1949','2949','1411','2411') THEN 0 ELSE COM.DESCON END AS DESCON,
         ABS(SUM(ICO.VLRMOV + ICO.VLRIPI)) AS VLRTOT,
         COM.FLGEST, COM.FILFOR, COM.CODFOR, COM.CODSER,
         COM.SUBSER, COM.TIPNOT, COM.DATOPE AS DATAOK, FIS.SEREXP, FIS.SUBEXP, 
         MAX(COALESCE(ICO.MODNOT,COM.MODNOT)) AS MODNOT,
         MAX(COALESCE(ICO.NATURE,COM.NATURE)) AS NATURE,
         COALESCE(ICO.ICMITE,0) AS ICMITE,
         COALESCE(ICO.IPIITE,0) AS IPIITE,
         RPAD(COALESCE(COM.UFNOTA,ENDE.SIGEST),2,' ') AS UFNOTA,
         /* VER SE CALCULA ICMS SOBRE IPI */
         /* PEGA SOMENTE VALORES PARA ICMS, QUANDO EXISTE */
         SUM(ICO.BASICM) AS BASICM,
         SUM(ICO.VLRICM) AS VLRICM,
         /* MONTANTE ISENTO/NAO TRIBUTADO */ /* TODOS MENOS MATERIAIS E TERCEIRIZADOS */
         SUM(CASE ICO.TIPPRO WHEN '1' THEN ICO.VLRMOV
                             WHEN '2' THEN ICO.VLRMOV
                             WHEN '4' THEN ICO.VLRMOV
                                      ELSE 0
             END) AS BASINT,
         /* VALOR QUE NAO CONFIRA DEBITO/CREDITO DE ICMS */ /* TERCEIRIZADO */
         SUM(ICO.OUTICM) AS OUTRAS
    FROM (SELECT CODSER, COALESCE(TRIM(SUBSER),'$$$') AS SUBSER, SEREXP, SUBEXP, MODNOT, ESPDOC FROM TT_FIS WHERE ORIGEM = 'C' AND EXPORT = 'T') FIS
          INNER JOIN TW_COM_FIS COM ON FIS.CODSER = COM.CODSER AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$')
     LEFT OUTER JOIN TW_ICO_FIS ICO ON ICO.CODFIL = COM.CODFIL AND ICO.SEQUEN = COM.SEQUEN
          INNER JOIN (SELECT FILCLI,CODCLI,MIN(CODFIL),MIN(NUMEND),MIN(SIGEST) AS SIGEST
                        FROM TT_END 
                       GROUP BY FILCLI,CODCLI) ENDE
                     ON ENDE.FILCLI = COM.FILFOR AND ENDE.CODCLI = COM.CODFOR
    WHERE COM.TIPPAR IN ('F','T')
      AND COM.FLGEST <> 'D' 
      AND COM.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
      AND ICO.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL) 
    GROUP BY COM.CODFIL, COM.SEQUEN, COM.DATOPE, COM.NATURE, ICO.ICMITE,COALESCE(ICO.IPIITE,0), FIS.ESPDOC,
             COALESCE(COM.UFNOTA,ENDE.SIGEST), COM.TIPPAR, COM.NUMNOT, COM.DESCON, COM.SUBSTT, COM.VLRTOT,
             COM.FLGEST, COM.FILFOR, COM.CODFOR, COM.CODSER, COM.SUBSER, COM.TIPNOT, FIS.SEREXP, FIS.SUBEXP, COM.MODNOT, ICO.MODNOT, ICO.NATURE
 ;             


/*-- SEQ 2472 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RAD_FOR CASCADE;

/*-- SEQ 2473 --*/
CREATE OR REPLACE VIEW TV_RAD_FOR AS
SELECT CODFIL, DATAOK,
       ULTNOM ||';'|| NOMCLI ||';'|| ENDERE ||';'|| BAIRRO ||';'|| SIGEST ||';'|| CEP ||';'|| CODDDD ||';'|| 
       NUMFON ||';'|| NUMFAX ||';'|| NUMDOC ||';'|| INSEST AS LINHA
  FROM ( SELECT CLI.ULTNOM AS ULTNOM,
                CLI.NOMCLI AS NOMCLI,
                ENDE.ENDERE AS ENDERE,
                ENDE.BAIRRO AS BAIRRO,
                ENDE.SIGEST AS SIGEST,
                COALESCE(ENDE.CODCEP,'00000')||'-'||COALESCE(ENDE.CODLOG,'000') AS CEP,
                ENDE.CODDDD AS CODDDD,
                ENDE.NUMFON AS NUMFON,
                ENDE.NUMFAX AS NUMFAX,
                TRIM(COALESCE(ENDE.NUMDOC,CLI.NUMDOC)) AS NUMDOC,
                LPAD(COALESCE(CLI.INSEST,' '),19,' ') AS INSEST,
                COM.CODFIL,
                COM.DATOPE AS DATAOK
           FROM TT_CLI CLI LEFT OUTER JOIN TT_END ENDE ON CLI.FILCLI = ENDE.FILCLI
                                                     AND CLI.CODCLI = ENDE.CODCLI
                           LEFT OUTER JOIN TT_REL REL ON CLI.FILCLI = REL.FILPAR
                                                     AND CLI.CODCLI = REL.CODPAR
                                INNER JOIN TT_COM COM ON COM.FILFOR = CLI.FILCLI AND COM.CODFOR = CLI.CODCLI
          WHERE (CLI.NUMDOC IS NOT NULL
             OR ENDE.NUMDOC IS NOT NULL)
            AND REL.TIPPAR = 'F') TAB
;


/*-- SEQ 2474 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RAD_VEN CASCADE;

/*-- SEQ 2475 --*/
CREATE OR REPLACE VIEW TV_RAD_VEN AS
SELECT /*+INDEX(RECF,PK_RECF)*/
       VEN.CODFIL, IVE.SEQUEN, FIS.SUBEXP,
       VEN.MODNOT, FIS.SEREXP, FIS.ESPDOC,
       VEN.DATHOR AS DATAOK,IVE.ICMTIP,
       VEN.NUMNOT, VEN.UFLOJA,
       VEN.REDTOT, VEN.OBSERV, VEN.VLRLIQ,
       VEN.VLRNOT, VEN.FLGEST, IVE.TIPPRO,
       VEN.FILCLI, VEN.CODCLI, VEN.CODSER, DECF.CODORI AS NUMECF,
       CASE COALESCE(IVE.TIP001,'M')||IVE.ICMTIP WHEN 'M0'
                                                 THEN COALESCE(IVE.TAX001,0)
                                                 ELSE 0
       END AS PERICM,
       CASE WHEN (COALESCE(CLI.NUMDOC,VIN.NUMDOC) IS NULL) OR LENGTH(TRIM(COALESCE(CLI.NUMDOC,VIN.NUMDOC))) < 11
            THEN '11111111111' ELSE COALESCE(CLI.NUMDOC,VIN.NUMDOC)
        END AS NUMDOC,
       ENDE.SIGEST,
       NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, COALESCE(IVE.NATFIS,NAT.NATDEN), COALESCE(IVE.NATFIS,NAT.NATFOR),VEN.SUBSTT) AS NATFIS, 
       NAT.NATDEN, NAT.NATFOR, (SELECT UFLOJA FROM TD_FIL WHERE CODFIL = VEN.CODFIL) AS UFFILIAL, RECF.CNT_RZ, VEN.PROPGT, RECF.GT_INI, RECF.GT_FIM,
       RECF.CODFIL AS CODECF, RECF.NUMECF AS RECECF, RECF.DATOPE AS DATECF, RECF.CUPINI, RECF.CUPFIM,
       ROUND(SUM(IVE.VLRMOV + round((IVE.VLRMOV * VEN.DESCON / 100),2)),2) AS VLRMOV,
       /* VER SE CALCULA ICMS SOBRE IPI */
       /* PEGA SOMENTE TIP001=MERCADORIA E ICMTIP = TRIBUTADO */
       SUM(CASE COALESCE(IVE.TIP001,'M') || IVE.ICMTIP WHEN 'M0'
                                                       THEN ABS(IVE.ITELIQ) - ABS(IVE.ITELIQ * IVE.REDITE) / 100
                                                       ELSE 0
            END) AS BASICM,
       SUM(CASE COALESCE(IVE.TIP001,'M') || IVE.ICMTIP WHEN 'M0' THEN ABS(IVE.VLR001)
                                                                ELSE 0
            END) AS VLRICM,

       /* PEGA SOMENTE TIP001=MERCADORIA E ICMTIP = ISENTO OU NAO TRIBUTADO OU ISENTO NO ESTADO */
       SUM(CASE WHEN VEN.TRIBUT = 'F'
                THEN 0
                ELSE CASE COALESCE(IVE.TIP001,'M') WHEN 'M'
                                                   THEN CASE IVE.ICMTIP WHEN '1'
                                                                        THEN IVE.VLRMOV
                                                                        WHEN '2'
                                                                        THEN IVE.VLRMOV
                                                                        WHEN '4'
                                                                        THEN IVE.VLRMOV
                                                                        ELSE 0
                                                         END
                                                   ELSE 0
                      END
            END) AS BASINT,
       /* QUALQUER OUTRA FORMA NAO TOTALIZADA ACIMA */
       SUM(CASE COALESCE(IVE.TIP001,'M') WHEN 'M'
                                         THEN CASE WHEN IVE.ICMTIP = '3' OR VEN.TRIBUT = 'F'
                                                   THEN ROUND(IVE.VLRMOV + (IVE.VLRMOV * VEN.DESCON /100),2)
                                                   ELSE 0
                                               END
                                         ELSE IVE.VLRMOV  + (IVE.VLRMOV * VEN.DESCON /100)
            END) AS OUTRAS,
       (SELECT VLRTOT
          FROM TT_ECF
         WHERE CODFIL = RECF.CODFIL
           AND NUMECF = RECF.NUMECF
           AND DATOPE = RECF.DATOPE
           AND TOTALI = 'CANC') AS VLRCAN,
       (SELECT VLRTOT
          FROM TT_ECF
         WHERE CODFIL = RECF.CODFIL
           AND NUMECF = RECF.NUMECF
           AND DATOPE = RECF.DATOPE
           AND TOTALI = 'DESC') AS VLRDES,
       (SELECT VLRTOT
          FROM TT_ECF
         WHERE CODFIL = RECF.CODFIL
           AND NUMECF = RECF.NUMECF
           AND DATOPE = RECF.DATOPE
           AND TOTALI = 'I_NT') AS VLRISS
  FROM TW_VEN_FIS VEN INNER JOIN TW_IVE_FIS IVE ON IVE.SESSION_ID = VEN.SESSION_ID AND IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN
                      INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI 
                 LEFT OUTER JOIN TT_CLI VIN ON VIN.FILCLI = CLI.FILVIN AND VIN.CODCLI = CLI.CODVIN
                 LEFT OUTER JOIN TT_END ENDE ON ENDE.FILCLI = CLI.FILCLI AND ENDE.CODCLI = CLI.CODCLI
                                            AND ENDE.NUMEND = VEN.ENDENT
                      INNER JOIN TT_FIS FIS ON FIS.ORIGEM = 'V' AND TRIM(FIS.CODSER) = VEN.CODSER AND FIS.SUBSER = VEN.NUMECF
                       LEFT JOIN TR_ECF RECF ON RECF.CODFIL = VEN.CODFIL AND RECF.NUMECF = VEN.NUMECF 
                                            AND RECF.DATOPE = TRUNC(VEN.DATHOR) AND VEN.CNT_RO = RECF.CNT_RO
                      INNER JOIN TD_ECF DECF ON DECF.FILECF = VEN.CODFIL AND DECF.NUMECF = VEN.NUMECF 
                      INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT 
 WHERE FIS.ORIGEM = 'V'
   AND FIS.EXPORT = 'T'   
   AND ((SUBSTR(NAT.NATDEN,1,1) = ('5')) OR (SUBSTR(NAT.NATFOR,1,1) = ('6')))
   AND VEN.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
   AND IVE.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
 GROUP BY VEN.CODFIL, IVE.SEQUEN, VEN.DATHOR, FIS.SEREXP,FIS.ESPDOC,
          VEN.NUMNOT, VEN.UFLOJA, VEN.REDTOT, VEN.OBSERV, VEN.VLRNOT,VEN.VLRLIQ,FIS.SUBEXP,
          VEN.FLGEST, IVE.TIPPRO, VEN.FILCLI, VEN.CODCLI, NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, COALESCE(IVE.NATFIS,NAT.NATDEN), COALESCE(IVE.NATFIS,NAT.NATFOR),VEN.SUBSTT),
          VEN.CODSER, VEN.CODNAT, DECF.CODORI, ENDE.NUMDOC, CLI.NUMDOC, VIN.NUMDOC, ENDE.SIGEST, NAT.NATDEN,
          NAT.NATFOR, RECF.CNT_RZ, VEN.PROPGT, RECF.GT_INI, RECF.GT_FIM,
          RECF.CODFIL, RECF.NUMECF, RECF.DATOPE, RECF.CUPINI, RECF.CUPFIM,IVE.ICMTIP,
          CASE COALESCE(IVE.TIP001,'M') || IVE.ICMTIP WHEN 'M0'
                                                      THEN COALESCE(IVE.TAX001,0)
                                                      ELSE 0
          END,
          VEN.MODNOT
;


/*-- SEQ 2476 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_REP CASCADE;

/*-- SEQ 2477 --*/
CREATE OR REPLACE VIEW TV_REP AS
 SELECT REL.FILPAR, REL.CODPAR, REL.TIPPAR, CLI.FILCLI, CLI.CODCLI,
        CLI.ATU_EM, CLI.NOMCLI, CLI.ULTNOM, CLI.NUMDOC, CLI.DOCCON,
        CLI.DATNAS, CLI.ESTCIV, CLI.HOMPGE, CLI.FLGTIP, CLI.INSEST,
        CLI.CODSEX, CLI.CATEG1, CLI.CATEG2, CLI.CATEG3, CLI.DATA01,
        CLI.DATA02, CLI.DATA03, CLI.DATOPE, CLI.IMPRIM, CLI.VALOR1,
        CLI.TOTATR, CLI.TOTPAR, CLI.MAIATR, CLI.OBSERV, CLI.FILPLA,
        CLI.CODPLA, CLI.PORPAD, CLI.ULTCOM, CLI.SIGNAT, CLI.CONJUG,
        CLI.NASCON, CLI.SEXCON, CLI.FILVEN, CLI.CODVEN
   FROM TT_REL REL INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI = REL.CODPAR
  WHERE REL.TIPPAR = 'R'
    ;




/*-- SEQ 2478 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RES_CAI CASCADE;

/*-- SEQ 2479 --*/
CREATE OR REPLACE VIEW TV_RES_CAI AS
  SELECT CAST(' ' AS VARCHAR(1)) AS EXPAND,
         CAI.CODFIL,CAI.SEQUEN,
         DECF.CODORI AS NUMECF,
         TO_CHAR(TRUNC(COALESCE(CAI.DATOPE,CAI.DATFEC)),'DD/MM/YYYY') AS DATREL,
         CAI.DATOPE,CAI.DATABE,CAI.DATFEC,CAI.FILUSU,
         CAI.CODUSU,CAI.VLRFEC,CAI.VLRDIF,CAI.ARQCAI,
         CAI.ARQXLS,CAI.CUPINI,CAI.CUPFIM,USU.APEUSU, CAI.CNT_RO
    FROM TR_CAI CAI INNER JOIN TT_USU USU  ON CAI.FILUSU = USU.FILUSU AND CAI.CODUSU = USU.CODUSU
                    INNER JOIN TD_ECF DECF ON CAI.NUMECF = DECF.NUMECF AND CAI.CODFIL = DECF.FILECF  
 ;







/*-- SEQ 2480 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RES_EXT CASCADE;

/*-- SEQ 2481 --*/
CREATE OR REPLACE VIEW TV_RES_EXT AS
SELECT LPAD(' ',20,' ') AS CODEXT, 
       CAST('F' AS VARCHAR(1)) AS STATUS,
       LPAD(' ',30,' ') AS MOTIVO
  FROM DUAL WHERE 1=0
 ;




/*-- SEQ 2482 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RFC CASCADE;

/*-- SEQ 2483 --*/
CREATE OR REPLACE VIEW TV_RFC AS
-- Resumo financeito de clientes
   select sum(RFP_Atraso(  Rec.DatVen, VALORPARCELAABERTA(REC.FLGEST,REC.CARTAO,COALESCE(REC.SEQCHE,'          '),REC.VLRPAR-coalesce(sub.vlrpar,0),'OUTROS',REC.FILREC) )) as VLRVEN,
          sum(RFP_AVencer( Rec.DatVen, VALORPARCELAABERTA(REC.FLGEST,REC.CARTAO,COALESCE(REC.SEQCHE,'          '),REC.VLRPAR-coalesce(sub.vlrpar,0),'OUTROS',REC.FILREC) )) AS VLRAVE,
          sum(                         VALORPARCELAABERTA(REC.FLGEST,REC.CARTAO,COALESCE(REC.SEQCHE,'          '),REC.VLRPAR-coalesce(sub.vlrpar,0),'CARTAO',REC.FILREC) )  AS VLRCAR,
          sum(                         VALORPARCELAABERTA(REC.FLGEST,REC.CARTAO,COALESCE(REC.SEQCHE,'          '),REC.VLRPAR-coalesce(sub.vlrpar,0),'CHEQUE',REC.FILREC) )  AS VLRCHE,
          sum(                         VALORPARCELAABERTA(REC.FLGEST,REC.CARTAO,COALESCE(REC.SEQCHE,'          '),REC.VLRPAR-coalesce(sub.vlrpar,0),'CARTAO_E_CHEQUE',REC.FILREC) ) AS VLRCCH,
          sum(CASE rec.flgest WHEN 'P' THEN COALESCE(rec.vlrpgt,0)
                                       ELSE 0
              END) AS VLRPGT,
          cli.filcli, cli.codcli, max(COALESCE(lim.vsaldo,0)) AS VLRCCC
     from tt_cli cli left JOIN tt_ven ven ON cli.filcli = ven.filcli and cli.codcli = ven.codcli
                     left JOIN tt_rec rec ON rec.codfil = ven.codfil and rec.sequen = ven.sequen
                     left join tt_rec sub on sub.codfil = rec.codfil and sub.sequen = rec.sequen
                                                                     and sub.numpar = rec.numpar 
                                                                     and sub.subpar = substr(to_char(to_number(rec.subpar)+1,'99'),2)
                LEFT OUTER JOIN
                     (select filcli, codcli, sum(COALESCE(vsaldo,0)) as vsaldo
                        from tt_lim
                       where vsaldo <> 0
                       group by filcli,codcli) lim ON lim.filcli = cli.filcli and lim.codcli = cli.codcli     
    group by cli.filcli, cli.codcli
;


/*-- SEQ 2484 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RFF CASCADE;

/*-- SEQ 2485 --*/
CREATE OR REPLACE VIEW TV_RFF AS
select sum(RFP_Atraso(  pag.datven, CASE pag.flgest WHEN 'A' THEN pag.vlrpar
                                                    ELSE 0
                                    END )) as VLRVEN,
       sum(RFP_AVencer( pag.datven, CASE pag.flgest WHEN 'A' THEN pag.vlrpar
                                                    ELSE 0
                                    END )) AS VLRAVE,
       sum(CASE pag.flgest WHEN 'P' THEN pag.vlrpgt
                           ELSE  0
           END) AS VLRPGT,
       com.filfor as filcli, com.codfor as codcli
  from tt_pag pag INNER JOIN tt_com com ON pag.codfil = com.codfil and pag.sequen = com.sequen
 group by com.filfor, com.codfor
 ;




/*-- SEQ 2486 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RMOV_DIA CASCADE;

/*-- SEQ 2487 --*/
CREATE OR REPLACE VIEW TV_RMOV_DIA AS
SELECT MOV.CODFIL, MOV.FILMAT, MOV.CODMAT, 
       MOV.CODCOR, MOV.CODTAM, MOV.CODMUL,
       COALESCE(SUM(MOV.QTDVEN),0) AS QTDVEN, 
       COALESCE(SUM(MOV.VENFIN),0) AS QTDFIS, 
       COALESCE(SUM(MOV.QTDCOM),0) AS QTDCOM, 
       COALESCE(SUM(MOV.QTDOUT),0) AS QTDOUT, 
       SALDODAFILIAL(MAX(MOV.DATMOV), MOV.FILMAT, MOV.CODMAT, MOV.CODCOR, MOV.CODTAM, MOV.CODFIL, MOV.CODMUL) AS SALDO,
       MOV.DATMOV
  FROM TR_MOV MOV 
 GROUP BY MOV.CODFIL,
          MOV.FILMAT,
          MOV.CODMAT,
          MOV.CODCOR,
          MOV.CODTAM,
          MOV.CODMUL,
          MOV.DATMOV
 ;


/*-- SEQ 2488 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RMOV_MES CASCADE;

/*-- SEQ 2489 --*/
CREATE OR REPLACE VIEW TV_RMOV_MES AS
SELECT MOV.CODFIL, MOV.FILMAT, MOV.CODMAT, 
       MOV.CODCOR, MOV.CODTAM, MOV.CODMUL,
       COALESCE(SUM(MOV.QTDVEN),0) AS QTDVEN, 
       COALESCE(SUM(MOV.VENFIN),0) AS QTDFIS, 
       COALESCE(SUM(MOV.QTDCOM),0) AS QTDCOM, 
       COALESCE(SUM(MOV.QTDOUT),0) AS QTDOUT, 
       SALDODAFILIAL(MAX(MOV.DATMOV), MOV.FILMAT, MOV.CODMAT, MOV.CODCOR, MOV.CODTAM, MOV.CODFIL, MOV.CODMUL) AS SALDO,
       TO_DATE('01'||TO_CHAR(MOV.DATMOV,'YYYYMM'), 'DDYYYYMM') AS DATMOV
  FROM TR_MOV MOV 
 GROUP BY MOV.CODFIL,
          MOV.FILMAT,
          MOV.CODMAT,
          MOV.CODCOR,
          MOV.CODTAM,
          MOV.CODMUL,
          TO_CHAR(MOV.DATMOV, 'YYYYMM')
 ;


/*-- SEQ 2490 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RTT_AGENC CASCADE;

/*-- SEQ 2491 --*/
CREATE OR REPLACE VIEW TV_RTT_AGENC AS
SELECT CODFIL,
       SEQUEN,
       FLGEST,
       CUPFIS,
       VLRPGT,
       DATPGT,
       CODAVU
  FROM TT_RTT  
 WHERE TIPRTT = (SELECT CFG.TIPRTT_AGENC FROM TT_CFG CFG)          
;




/*-- SEQ 2492 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_SAL_CUSTOS CASCADE;

/*-- SEQ 2493 --*/
CREATE OR REPLACE VIEW TV_SAL_CUSTOS AS
SELECT SAL.CODFIL, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, SAL.CODMUL, DAT.DATOPE, 
       PrecoDia(SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, DAT.DATOPE, CFG.FILPRE, CFG.CODPRE) AS PRECOV,
       CustoMedio(SAL.CODFIL, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, 3, DAT.DATOPE, 'T', 'T') AS VLR_CM,
       CustoReposicaoData(DAT.DATOPE, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, SAL.CODFIL, SAL.CODMUL) AS CUSREP,
       SALDODAFILIAL(DAT.DATOPE, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, SAL.CODFIL, SAL.CODMUL) AS QTDEST
  FROM TT_SAL SAL INNER JOIN TD_FIL FIL ON FIL.CODFIL = SAL.CODFIL
                  CROSS JOIN TT_DAT DAT
                  CROSS JOIN TT_CFG CFG
;


/*-- SEQ 2494 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_SBT CASCADE;

/*-- SEQ 2495 --*/
CREATE OR REPLACE VIEW TV_SBT AS
SELECT ESTADO, 0 AS CODMAR, MARG00 AS MARGEM FROM TD_EST UNION ALL
SELECT ESTADO, 1 AS CODMAR, MARG01 AS MARGEM FROM TD_EST UNION ALL
SELECT ESTADO, 2 AS CODMAR, MARG02 AS MARGEM FROM TD_EST UNION ALL
SELECT ESTADO, 3 AS CODMAR, MARG03 AS MARGEM FROM TD_EST UNION ALL
SELECT ESTADO, 4 AS CODMAR, MARG04 AS MARGEM FROM TD_EST UNION ALL
SELECT ESTADO, 5 AS CODMAR, MARG05 AS MARGEM FROM TD_EST UNION ALL
SELECT ESTADO, 6 AS CODMAR, MARG06 AS MARGEM FROM TD_EST UNION ALL
SELECT ESTADO, 7 AS CODMAR, MARG07 AS MARGEM FROM TD_EST UNION ALL
SELECT ESTADO, 8 AS CODMAR, MARG08 AS MARGEM FROM TD_EST UNION ALL
SELECT ESTADO, 9 AS CODMAR, MARG09 AS MARGEM FROM TD_EST
 ;




/*-- SEQ 2496 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_SLE CASCADE;

/*-- SEQ 2497 --*/
CREATE OR REPLACE VIEW TV_SLE AS
SELECT /*+RULE*/ GRA.REFPRO,
        FIL.CODFIL,
        SAL.SEQUEN,
        GRA.FILMAT,
        GRA.CODMAT,
        GRA.CODCOR,
        GRA.CODTAM,
        MUL.CODTAB AS CODMUL,
        GRA.CODTAM AS TAMORI,
        COALESCE(SAL.QTDEST,0) AS QTDEST,
        COALESCE(SAL.QTDMIN,0) AS QTDMIN,
        COALESCE(SAL.RESERV,0) AS RESERV,
        SAL.PTOPED, PRO.DEPART, PRO.FILMAR, PRO.CODMAR, PRO.CLASS1, PRO.CLASS2, PRO.CLASS3, PRO.CLASS4, PRO.SIGNAT,
        SUBSTR(USACODSAL(GRA.CODTAM),1,1) AS INVENT,
        CASE WHEN DSUB.CODSAL IS NULL THEN 'F'
                                      ELSE 'T'
        END AS EMBTEM,
        DSUB.CODSAL AS EMBORI,
        TRUNC(COALESCE(SAL.QTDEST,0) / SUB.FATCON,4) AS EMBQTD,
        TRUNC(COALESCE(SAL.RESERV,0) / SUB.FATCON,4) AS EMBRES,
        COALESCE(CASE CASE WHEN DSUB.CODSAL IS NULL THEN 'F'
                                                         ELSE 'T'
                           END /* EMBTEM */
                      WHEN 'F' THEN COALESCE(QTDEST,0)
                      ELSE TRUNC(COALESCE(SAL.QTDEST,0) / SUB.FATCON,4) /* EMBQTD */
                 END ,0) -
        COALESCE(CASE CASE WHEN DSUB.CODSAL IS NULL THEN 'F'
                                                    ELSE 'T'
                      END /* EMBTEM */
                      WHEN 'F' THEN RESERV
                      ELSE TRUNC(COALESCE(SAL.RESERV,0) / SUB.FATCON,4) /* EMBRES */
                 END,0) AS SALREA
FROM TT_GRA GRA INNER JOIN TT_PRO PRO ON GRA.FILMAT = PRO.FILMAT AND GRA.CODMAT = PRO.CODMAT
                CROSS JOIN TD_MUL MUL
                CROSS JOIN TD_FIL FIL
                INNER JOIN TD_GRA DGRA ON PRO.CODGRA  = DGRA.CODTAB
                INNER JOIN TD_SUB DSUB ON DGRA.CODSUB = DSUB.CODTAB
                LEFT JOIN TT_SAL SAL ON GRA.FILMAT  = SAL.FILMAT AND GRA.CODMAT = SAL.CODMAT
                                     AND GRA.CODCOR  = SAL.CODCOR --AND GRA.CODTAM = SAL.CODTAM --DAVI - 37228 - 10/08/05
                                     AND CASE WHEN DSUB.CODSAL IS NULL THEN GRA.CODTAM ELSE DSUB.CODSAL END = SAL.CODTAM
                                    AND SAL.CODFIL = FIL.CODFIL AND SAL.CODMUL = MUL.CODTAB
                INNER JOIN TT_SUB SUB ON GRA.CODTAM  = SUB.CODITE
;


/*-- SEQ 2498 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_SLT CASCADE;

/*-- SEQ 2499 --*/
CREATE OR REPLACE VIEW TV_SLT AS
SELECT SLT.CODFIL,
       SLT.SEQUEN,
       SLT.CODMUL,
       SLT.FILLOT,
       SLT.SEQLOT,
       CASE WHEN SLT.CODMUL = 0 AND SLT.CODFIL = LOT.CODFIL
            THEN SLT.QTDEST + COALESCE(LOT.QTDINI,0)
            ELSE SLT.QTDEST
       END AS QTDEST,
       SLT.RESERV,
       SLT.ATU_EM,
       CASE WHEN SLT.CODMUL = 0 AND SLT.CODFIL = LOT.CODFIL
            THEN COALESCE(LOT.QTDINI,0)
            ELSE 0
       END AS QTDINI,
       LOT.LOTATI,
       SLT.MOVSLT
  FROM TT_SLT SLT INNER JOIN TT_LOT LOT ON LOT.CODFIL = SLT.FILLOT
                                       AND LOT.SEQUEN = SLT.SEQLOT
;


/*-- SEQ 2500 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TAB_001 CASCADE;

/*-- SEQ 2501 --*/
CREATE OR REPLACE VIEW TV_TAB_001 AS
SELECT /*+RULE*/
       IND.CODTAB,
       COB.COBATI,
       COB.DESCOB,
       COB.LARUNI,
       COB.TXTCOB,
       COB.SAICAR,
       COB.TIPCOB,
       COB.FILCTA,
       COB.SEQCTA,
       COB.TIPCTA,
       COB.GERTIT,
       COB.TIPCTB,
       COB.CODCCB,
       COB.TITCTA,
       COB.COBPAD,
       CAR.CARATI,
       CAR.DESOUT,
       CAR.DIACAR,
       CAR.TAXCAR,
       CAR.PROCAR,
       CAR.PORCAR,
       CAR.COBCAR,
       CAR.FILADM,
       CAR.CODADM,
       CAR.TIPADM,
       CAR.FILCAR,
       CAR.SEQCAR,
       CAR.TIPCAR,
       CAR.CTACAR,
       CAR.TAXDEB,
       CAR.DIADEB,
       CAR.TITCAR,
       CAR.CLIADM,
       CAR.CODCRE,
       CAI.CX_ATI,
       CAI.CX_COD,
       CAI.CX_DES,
       CAI.CX_USU,
       CAI.CX_HIS,
       CAI.FILCAI,
       CAI.SEQCAI,
       CAI.TIPCAI,
       CAI.CTACAI,
       CAI.TRANSF,
       CAI.TITCAI,
       CAI.CX_MAX,
       CAI.CAIMEN,
       MOD.MODULO,
       MOD.MODATI,
       MOD.FILSAC,
       MOD.CODSAC,
       MOD.FILTST,
       MOD.CODTST,
       MOD.FILWOR,
       MOD.CODWOR,
       MOD.FILINT,
       MOD.CODINT,
       MOD.VERATU,
       MOD.SACUSU,
       MOD.WORUSU,
       MOD.INTUSU,
       MOD.TSTUSU,
       MOD.GRUMOD,
       MOD.FILCOM,
       MOD.CODCOM,
       MOD.COMUSU,
       STD.DOMDOP,
       STD.DESSTD,
       STD.STDATI,
       STD.USOSTD,
       STD.FLGFLX,
       STD.DESDOP_STD,
       ECF.FILECF,
       ECF.NUMECF,
       CASE WHEN ECF.FILECF IS NULL THEN NULL ELSE COALESCE(ECF.SERECF, 'NOVO '||ECF.FILECF||'-'||ECF.NUMECF) END AS SERECF,
       ECF.ECFATI,
       ECF.PORECF,
       ECF.COBECF,
       ECF.CODORI,
       ECF.CODMUL,
       CCBxCOB.DESCCB AS CCBTIT,
       ECF.SAIENV,
       ECF.MAQECF,
       ECF.CODCTR,
       ECF.MARECF,
       ECF.MODECF,
       ECF.VSWECF,
       ECF.CODFAB,
       ECF.CODMOD,
       ECF.DSWECF,
       ECF.FITDET,
       ECF.ECFUTL,
       ECF.ECFMFA,
       ECF.ECFTIP,
       ECF.ECFCOL,
       ECF.TNCIEE,
       ECF.CODEXT_DECF,
       LIB.FILMAT,
       LIB.CODMAT,
       LIB.CODCOR,
       LIB.CODTAM,
       LIB.DESLIB,
       LIB.CODLIB,
       LIB.LIBATI,
       LIB.DESMAT,
       ECF.MAXCAI,
       COB.VLRMBL,
       COB.VLRABL,
       ECF.CK4G_MANMOV,
       ECF.CK4G_MANLOG_DET,
       ECF.CK4G_MANLOG_GER,
       ECF.CK4G_HOMOL,
       ECF.STATUS_DADOS,
       CAR.CARLET,
       CAR.CARIMG,
       CAR.CARLIM,
       CAR.CARNIV,
       CAR.REGCAR,
       CAR.MINAUT,
       ECF.NIVLOG,
       COB.COBLET,
       COB.COBIMG,
       COB.COBNIV,
       ECF.CK4G_BARRASALTURA,
       ECF.CK4G_BARRASLARGURA,
       ECF.CK4G_BARRASPADRAO,
       ECF.CK4G_INTERVALOCARGADESALDOS,
       ECF.CK4G_ACAOPADRAO,
       ECF.CK4G_USAFRETE,
       ECF.CK4G_ZSOMENTEAPOS24H,
       ECF.CK4G_VALIDADE,
       ECF.CK4G_MD5,
       ECF.CK4G_MODFIS_VC,
       ECF.CK4G_MODFIS_VC_CONT,
       ECF.CK4G_USA_CONT_OFFLINE,
       ECF.FLGCFE,
       ECF.DECF_NUMEXT,
       CAR.EXTDEB,
       CAR.EXTCRE,
       COB.CODEXT_DCOB,
       CAR.BANDEB,
       CAR.BANCRE,
       MTD.DESMTD,
       MTD.MTDATI,
       MOT.DESCMO,
       MOT.TIPCOM,
       MOT.CILIND,
       MOT.POTENC,
       MOT.MTOATI,
       MDV.CODVEI,
       MDV.DESMDV,
       MDV.DISEXI,
       MDV.CODMAR,
       MDV.MDVATI,
       CRV.DESCORVEI,
       CRV.CORVEIATI,
       CRV.CODCORDEN
  FROM TD_IND IND LEFT JOIN (SELECT iCTA.TITCTA, iCOB.*
                                   FROM TD_COB iCOB
                                   LEFT JOIN TT_CTA iCTA ON iCTA.CODFIL = iCOB.FILCTA
                                                              AND iCTA.SEQUEN = iCOB.SEQCTA
                                                              AND iCTA.TIPCTA = iCOB.TIPCTA)COB ON COB.CODTAB = IND.CODTAB
                  LEFT JOIN (SELECT iCAR.*, iADM.NOMCLI as CLIADM,cast(COD_TITCTA(CODFIL, SEQUEN) as VARCHAR(255)) as TITCAR
                                   FROM TD_CAR iCAR
                                   LEFT JOIN TT_CTA iCTA ON iCTA.CODFIL = iCAR.FILCAR
                                                              AND iCTA.SEQUEN = iCAR.SEQCAR
                                                              AND iCTA.TIPCTA = iCAR.TIPCAR
                                   LEFT JOIN TT_CLI iADM ON iADM.FILCLI = iCAR.FILADM
                                                              AND iADM.CODCLI = iCAR.CODADM) CAR ON CAR.CODTAB = IND.CODTAB
                  LEFT JOIN (SELECT iCAI.*, CAST(COD_TITCTA(iCTA.CODFIL,iCTA.SEQUEN) AS VARCHAR(255)) AS TITCAI
                                   FROM TD_CAI iCAI
                                   LEFT JOIN TT_CTA iCTA ON iCTA.CODFIL = iCAI.FILCAI
                                                              AND iCTA.SEQUEN = iCAI.SEQCAI
                                                              AND iCTA.TIPCTA = iCAI.TIPCAI) CAI ON CAI.CODTAB = IND.CODTAB
                  LEFT JOIN (SELECT iMOD.*,
                                          iSAC.APEUSU AS SACUSU,
                                          iWOR.APEUSU AS WORUSU,
                                          iINT.APEUSU AS INTUSU,
                                          iTST.APEUSU AS TSTUSU,
                                          iCOM.APEUSU AS COMUSU
                                   FROM TD_MOD iMOD
                                   LEFT JOIN TT_USU iSAC ON iSAC.FILUSU = iMOD.FILSAC
                                                              AND iSAC.CODUSU = iMOD.CODSAC
                                   LEFT JOIN TT_USU iWOR ON iWOR.FILUSU = iMOD.FILWOR
                                                              AND iWOR.CODUSU = iMOD.CODWOR
                                   LEFT JOIN TT_USU iINT ON iINT.FILUSU = iMOD.FILINT
                                                              AND iINT.CODUSU = iMOD.CODINT
                                   LEFT JOIN TT_USU iTST ON iTST.FILUSU = iMOD.FILTST
                                                              AND iTST.CODUSU = iMOD.CODTST
                                   LEFT JOIN TT_USU iCOM ON iCOM.FILUSU = iMOD.FILCOM
                                                              AND iCOM.CODUSU = iMOD.CODCOM) MOD ON MOD.CODTAB = IND.CODTAB
                  LEFT JOIN (SELECT iSTD.*, iD_S.DESDOP AS DESDOP_STD
                                   FROM TD_STD iSTD
                                   LEFT JOIN TD_DOP iD_S ON iD_S.CODTAB = iSTD.DOMDOP) STD ON STD.CODTAB = IND.CODTAB
                  LEFT JOIN TD_ECF ECF ON ECF.CODTAB = IND.CODTAB
                  LEFT JOIN TD_MTD MTD ON MTD.CODTAB = IND.CODTAB
                  LEFT JOIN TD_MOT MOT ON MOT.CODTAB = IND.CODTAB
                  LEFT JOIN TD_MDV MDV ON MDV.CODTAB = IND.CODTAB 
                  LEFT JOIN TD_CORVEI CRV ON CRV.CODTAB = IND.CODTAB
                  LEFT JOIN (SELECT iLIB.*, iPRO.DESMAT
                                   FROM TD_LIB iLIB
                                   LEFT JOIN TT_GRA iGRA ON iGRA.FILMAT = iLIB.FILMAT
                                                              AND iGRA.CODMAT = iLIB.CODMAT
                                                              AND iGRA.CODCOR = iLIB.CODCOR
                                                              AND iGRA.CODTAM = iLIB.CODTAM
                                   LEFT JOIN TT_PRO iPRO ON iPRO.FILMAT = iGRA.FILMAT
                                                              AND iPRO.CODMAT = iGRA.CODMAT) LIB ON LIB.CODTAB = IND.CODTAB
                  LEFT JOIN TD_CCB CCBxCOB ON CCBxCOB.CODTAB = COB.CODCCB
;

/*-- SEQ 2502 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TAB_002 CASCADE;

/*-- SEQ 2503 --*/
CREATE OR REPLACE VIEW TV_TAB_002 AS
SELECT /*+RULE*/
       IND.CODTAB,
       LAN.SINLAN,
       LAN.DESLAN,
       LAN.LANATI,
       LAN.LANVLR,
       LAN.LANEDI,
       LAN.LANNAT,
       LAN.MOVLEG,
       LAN.FILLAN,
       ESP.ESPATI,
       ESP.ESPECI,
       NAT.NATATI,
       NAT.NATURE,
       NAT.TIPNAT,
       NAT.USAICM,
       NAT.USAIPI,
       NAT.MOVEST,
       NAT.USACUS,
       NAT.LIMITE,
       NAT.COMENT,
       NAT.NATDEN,
       NAT.NATFOR,
       NAT.NATFUD,
       NAT.NATFUF,
       NAT.SERVIN,
       NAT.FINANC,
       NAT.OBSERV,
       NAT.NATOLN,
       NAT.TRIBUT,
       NAT.LANVEN,
       NAT.NATRED,
       NAT.NATREF,
       NAT.EXTDEM,
       NAT.EXTFOR,
       NAT.NATMUL,
       NAT.DESMULNAT,
       NAT.CONSFI,
       NAT.SEQEXC,
       NAT.DEVVIN,
       NAT.NATMOD,
       NAT.NATUTL,
       NAT.NATDEN_FIL,
       NAT.NATDEN_SEQ,
       NAT.NATDEN_TIP,
       NAT.NATFOR_FIL,
       NAT.NATFOR_SEQ,
       NAT.NATFOR_TIP,
       NAT.NATEST_FIL,
       NAT.NATEST_SEQ,
       NAT.NATEST_TIP,
       NAT.SITPIS,
       NAT.SITCOF,
       SER.MODNOT,
       SER.SERATI,
       SER.CODSER,
       SER.DESSER,
       SER.EXTNOT,
       SER.DISSAI,
       SER.IMPNOT,
       SER.QTDITP,
       SER.QTDITS,
       SER.SERMAN,
       SER.TXTINI,
       SER.TXTITE,
       SER.TXTENT,
       SER.TXTSER,
       SER.TXTFIM,
       SER.RESTRI,
       SER.DIVTRO,
       SER.SERINI,
       SER.SERFIM,
       SER.OBSLIN,
       SER.OBSCOL,
       SER.SERUTL,
       SER.SERDOC,
       SER.SEREXT,
       ICM.ICMATI,
       ICM.RESICM,
       IPI.IPIATI,
       IPI.RESIPI,
       ISS.ISSATI,
       ISS.RESISS,
       IRR.IRRATI,
       IRR.RESIRR,
       IES.ES_ATI,
       IES.ICMSES,
       IME.ME_ATI,
       IME.ICMSME,
       IRE.RE_ATI,
       IRE.ICMSRE,
       IRE.APLCON,
       IRE.REDTRA,
       IRE.REDCON,
       IR1.R1_ATI,
       IR1.ICMSR1,
       IR2.R2_ATI,
       IR2.ICMSR2,
       FIS.FISATI,
       FIS.CODFIS,
       MOE.MOEATI,
       MOE.DESMOE,
       PRI.PRIATI,
       PRI.DESPRI,
       PRI.OBSPRI,
       PRI.HORTRN,
       PRI.HORPAD,
       PRI.TIPHOR,
       PRI.PESPRI,
       PRI.APEPRI,
       FUN.FUNATI,
       FUN.DESFUN,
       FUN.CODFUN,
       FUN.TIPFUN,
       CL1.CL1ATI,
       CL1.CLASS1,
       CL1.CODEX1,
       CL1.NATCL1,
       CL1.CL1WEB,
       CL2.CL2ATI,
       CL2.CLASS2,
       CL2.CODEX2,
       CL2.CL2WEB,
       CL3.CL3ATI,
       CL3.CLASS3,
       CL3.CODEX3,
       CL3.CL3WEB,
       CL4.CL4ATI,
       CL4.CLASS4,
       CL4.CODEX4,
       CL4.CL4WEB,
       ETI.ETIATI,
       ETI.DESETI,
       ETI.RBFILE,
       CT1.CT1ATI,
       CT1.NOMCT1,
       CT1.CODEXT_DCT1,
       CT2.CT2ATI,
       CT2.NOMCT2,
       CT2.CODEXT_DCT2,
       CT3.CT3ATI,
       CT3.NOMCT3,
       CT3.CODEXT_DCT3,
       MED.MEDATI,
       MED.UNIMED,
       MED.DESMED,
       SAZ.SAZATI,
       SAZ.DESSAZ,
       SAZ.SAZ001,
       SAZ.SAZ002,
       SAZ.SAZ003,
       SAZ.SAZ004,
       SAZ.SAZ005,
       SAZ.SAZ006,
       SAZ.SAZ007,
       SAZ.SAZ008,
       SAZ.SAZ009,
       SAZ.SAZ010,
       SAZ.SAZ011,
       SAZ.SAZ012,
       OUT.OUTATI,
       OUT.DESCAR,
       OUT.DADREC,
       COM.COMATI,
       COM.DESCOM,
       COM.NUMCOM,
       COM.CABCOM,
       COM.ITECOM,
       COM.RODCOM,
       DEP.DEPATI,
       DEP.DESDEP,
       DEP.IMGDEP,
       DEP.CONTAB,
       DEP.DEPWEB,
       REG.REGATI,
       REG.REGIAO,
       REG.CEPINI,
       REG.CEPFIM,
       PRE.PREATI,
       PRE.DESPRE,
       PRE.NUMPRE,
       PRE.USOPRE,
       PRE.CABPRE,
       PRE.ITEPRE,
       PRE.RODPRE,
       CON.CONATI,
       CON.DESCON,
       CON.TIPCON,
       CON.CLACON,
       FIN.DESFIN,
       FIN.FINATI,
       FIN.CARTAO,
       TRI.TRIATI,
       TRI.CODTRI,
       MAR.MARATI,
       MAR.PHOMAR,
       TIP.TIPATI,
       TIP.PHOTIP,
       ISO.ISOATI,
       ISO.PHOISO,
       PHO.PHOATI,
       PHO.PHOOUT,
       AMP.AMPATI,
       AMP.PHOLAR,
       AMP.PHOALT,
       AMP.PHOCOM,
       TCC.TCCATI,
       TCC.TEFPRC,
       TCC.TEFJRC,
       TCD.TCDATI,
       TCD.TEFPRO,
       TCD.TEFJRD,
       TCD.TEFENT,
       ROS.ROSATI,
       ROS.RESULT,
       OBS.OBSATI,
       OBS.USUOBS,
       OBS.DESOBS,
       OBS.TXTOBS,
       GRA.GRAATI,
       GRA.NOMGRA,
       GRA.CODDIV,
       GRA.CODSUB,
       DIV.DIVATI,
       DIV.NOMDIV,
       DIV.ORDDIV,
       SUB.SUBATI,
       SUB.NOMSUB,
       SUB.ORDSUB,
       SUB.CODSAL,
       DFC.CODDFC,
       DFC.DESDFC,
       DFC.DFCATI,
       DCFO.DESCFO,
       DCFO.CFOATI,
       DCFO.CODCFO,
       DCFO.EXTCFO,
       DCFO.CFOMOD,
       DCFO.CFOCTA_FIL,
       DCFO.CFOCTA_SEQ,
       DCFO.CFOCTA_TIP,
       DCFO.CFOFOR,
       ENDE.DESEND,
       ENDE.ENDATV,
       ENDE.DUPEND,
       ENDE.USOEND,
       APR.DESAPR,
       APR.APROVA,
       APR.APRATI,
       TAN.FILTAN,
       TAN.TANQUE,
       TAN.GRAFIL,
       TAN.GRACOD,
       TAN.GRACOR,
       TAN.GRATAM,
       TAN.TANATV,
       TAN.QTDLTS,
       BIC.FILBIC,
       BIC.CODTAN,
       BIC.SEQFIL,
       BIC.SEQBOM,
       BIC.QTDENC,
       BIC.NIVPRE,
       BIC.MAXCHE,
       BIC.BICATV,
       BIC.CODBOM,
       BIC.FILLAC,
       BIC.SEQLAC,
       AMB.DESAMB,
       AMB.AMBATI,
       DEV.DESDEV,
       DEV.DEVATI,
       DEV.DEVCOM,
       DEV.DEVMON,
       DEV.DEVICM,
       DEV.MULDEV,
       DEV.DESMULDEV,
       DEV.DEVATE,
       DEV.USODEV,
       DEV.VLRDEV,
       DEV.CLIDEV,
       OCU.DESOCU,
       OCU.BASOCU,
       OCU.OCUATI,
       MON.DESMON,
       MON.MONURB,
       MON.MONINT,
       MON.MONDEN,
       MON.MONCOR,
       MON.MONATI,
       INA.DESINA,
       INA.INAATI,
       INA.USOINA,
       ARC.DESARC,
       ARC.ARCATV,
       ARC.TIPARC,
       COR.TITCOR,
       COR.RB_COR,
       COR.CORATV,
       HOM.DESHOM,
       HOM.ATIHOM,
       HOM.CODHOM,
       MUL.DESMUL,
       MUL.MULATI,
       MUL.CODEXT_DMUL,
       MUL.SUGEST,
       MUL.MULWEB, /* Paulo - 68421 */
       INS.INSATI,
       INS.DESINS,
       INS.QTDDIA,
       REM.REMATI,
       REM.DESREM,
       RET.RETATI,
       RET.DESRET,
       RET.FLGNEW,
       CCB.CCBATI,
       CCB.DESCCB,
       CCB.APECCB,
       CCB.TIPCCB,
       CCB.ENVREM,
       CAST('                              ' AS VARCHAR(30)) AS LIVRE,
       DES.DESATV,
       DES.TIPDES,
       VTP.DESVTP,
       VTP.VTPATI,
       ECB.ECBATI,
       ECB.DESECB,
       TAN.PRECAL,
       SER.TITAVU,
       SER.SERORD,
       NAT.NATBCC,
       SER.SERREM,
       DCFO.MOVEST_DCFO,
       NAT.NATESD,
       NAT.NATESF,
       MOE.MOELET,
       MOE.MOEIMG,
       MOE.MOELIM,
       MOE.MOENIV,
       OUT.OUTLET,
       OUT.OUTIMG,
       OUT.OUTLIM,
       OUT.OUTNIV,
       OUT.REGOUT,
       NAT.NATMEN,
       NAT.NATRED_ST,
       NAT.NATREF_ST,
       NAT.CSTNOR,
       NAT.CST_ST,
       SER.RECIBO,
       NAT.CONLOC,
       SER.ENVNFS,
       NAT.NATPRE,
       SER.SERCON,
       MED.CODPOS_DMED,
       DEP.CODPOS_DDEP,
       DEP.PESPREVEN,
       DEP.PESPREFOR,
       DEP.PESPRZENT,
       DEP.TAXJURMES,
       DCFO.TIPCCM,
       ICM.PERESPINTCOM,
       ICM.PERESPESTCOM,
       ICM.PERESPINTVEN,
       ICM.PERESPESTVEN
  FROM TD_IND IND LEFT JOIN TD_ESP ESP ON ESP.CODTAB = IND.CODTAB
                  LEFT JOIN TD_LAN LAN ON LAN.CODTAB = IND.CODTAB
                  LEFT JOIN (SELECT iNAT.*, iMUL.DESMUL AS DESMULNAT
                                     FROM TD_NAT iNAT LEFT JOIN TD_MUL iMUL ON iMUL.CODTAB=iNAT.NATMUL
                                  ) NAT ON NAT.CODTAB = IND.CODTAB
                  LEFT JOIN TD_SER SER ON SER.CODTAB = IND.CODTAB and SER.codser NOT in ('TT','XX','CK')
                  LEFT JOIN TD_ICM ICM ON ICM.CODTAB = IND.CODTAB
                  LEFT JOIN TD_IPI IPI ON IPI.CODTAB = IND.CODTAB
                  LEFT JOIN TD_ISS ISS ON ISS.CODTAB = IND.CODTAB
                  LEFT JOIN TD_IRR IRR ON IRR.CODTAB = IND.CODTAB
                  LEFT JOIN TD_IES IES ON IES.CODTAB = IND.CODTAB
                  LEFT JOIN TD_IME IME ON IME.CODTAB = IND.CODTAB
                  LEFT JOIN TD_IRE IRE ON IRE.CODTAB = IND.CODTAB
                  LEFT JOIN TD_IR1 IR1 ON IR1.CODTAB = IND.CODTAB
                  LEFT JOIN TD_IR2 IR2 ON IR2.CODTAB = IND.CODTAB
                  LEFT JOIN TD_FIS FIS ON FIS.CODTAB = IND.CODTAB
                  LEFT JOIN TD_MOE MOE ON MOE.CODTAB = IND.CODTAB
                  LEFT JOIN TD_CL1 CL1 ON CL1.CODTAB = IND.CODTAB
                  LEFT JOIN TD_CL2 CL2 ON CL2.CODTAB = IND.CODTAB
                  LEFT JOIN TD_CL3 CL3 ON CL3.CODTAB = IND.CODTAB
                  LEFT JOIN TD_CL4 CL4 ON CL4.CODTAB = IND.CODTAB
                  LEFT JOIN TD_ETI ETI ON ETI.CODTAB = IND.CODTAB
                  LEFT JOIN TD_CT1 CT1 ON CT1.CODTAB = IND.CODTAB
                  LEFT JOIN TD_CT2 CT2 ON CT2.CODTAB = IND.CODTAB
                  LEFT JOIN TD_CT3 CT3 ON CT3.CODTAB = IND.CODTAB
                  LEFT JOIN TD_MED MED ON MED.CODTAB = IND.CODTAB
                  LEFT JOIN TD_SAZ SAZ ON SAZ.CODTAB = IND.CODTAB
                  LEFT JOIN TD_OUT OUT ON OUT.CODTAB = IND.CODTAB
                  LEFT JOIN TD_COM COM ON COM.CODTAB = IND.CODTAB
                  LEFT JOIN TD_DEP DEP ON DEP.CODTAB = IND.CODTAB
                  LEFT JOIN TD_REG REG ON REG.CODTAB = IND.CODTAB
                  LEFT JOIN TD_PRE PRE ON PRE.CODTAB = IND.CODTAB
                  LEFT JOIN TD_CON CON ON CON.CODTAB = IND.CODTAB
                  LEFT JOIN TD_FIN FIN ON FIN.CODTAB = IND.CODTAB
                  LEFT JOIN TD_TRI TRI ON TRI.CODTAB = IND.CODTAB
                  LEFT JOIN TD_MAR MAR ON MAR.CODTAB = IND.CODTAB
                  LEFT JOIN TD_TIP TIP ON TIP.CODTAB = IND.CODTAB
                  LEFT JOIN TD_ISO ISO ON ISO.CODTAB = IND.CODTAB
                  LEFT JOIN TD_PHO PHO ON PHO.CODTAB = IND.CODTAB
                  LEFT JOIN TD_AMP AMP ON AMP.CODTAB = IND.CODTAB
                  LEFT JOIN TD_TCC TCC ON TCC.CODTAB = IND.CODTAB
                  LEFT JOIN TD_TCD TCD ON TCD.CODTAB = IND.CODTAB
                  LEFT JOIN TD_ROS ROS ON ROS.CODTAB = IND.CODTAB
                  LEFT JOIN TD_OBS OBS ON OBS.CODTAB = IND.CODTAB
                  LEFT JOIN TD_GRA GRA ON GRA.CODTAB = IND.CODTAB
                  LEFT JOIN TD_DIV DIV ON DIV.CODTAB = IND.CODTAB
                  LEFT JOIN TD_SUB SUB ON SUB.CODTAB = IND.CODTAB
                  LEFT JOIN TD_PRI PRI ON PRI.CODTAB = IND.CODTAB
                  LEFT JOIN TD_FUN FUN ON FUN.CODTAB = IND.CODTAB
                  LEFT JOIN TD_DFC DFC ON DFC.CODTAB = IND.CODTAB
                  LEFT JOIN TD_CFO DCFO ON DCFO.CODTAB = IND.CODTAB
                  LEFT JOIN TD_END ENDE ON ENDE.CODTAB = IND.CODTAB
                  LEFT JOIN TD_APR APR ON APR.CODTAB = IND.CODTAB
                  LEFT JOIN TD_TAN TAN ON TAN.CODTAB = IND.CODTAB
                  LEFT JOIN TD_BIC BIC ON BIC.CODTAB = IND.CODTAB
                  LEFT JOIN TD_AMB AMB ON AMB.CODTAB = IND.CODTAB
                  LEFT JOIN (SELECT iDEV.*, iMUL.DESMUL AS DESMULDEV
                                     FROM TD_MUL iMUL LEFT JOIN TD_DEV iDEV ON iDEV.MULDEV=iMUL.CODTAB
                                  ) DEV ON DEV.CODTAB = IND.CODTAB
                  LEFT JOIN TD_OCU OCU ON OCU.CODTAB = IND.CODTAB
                  LEFT JOIN TD_MON MON ON MON.CODTAB = IND.CODTAB
                  LEFT JOIN TD_INA INA ON INA.CODTAB = IND.CODTAB
                  LEFT JOIN TD_ARC ARC ON ARC.CODTAB = IND.CODTAB
                  LEFT JOIN TD_COR COR ON COR.CODTAB = IND.CODTAB
                  LEFT JOIN TD_HOM HOM ON HOM.CODTAB = IND.CODTAB
                  LEFT JOIN TD_MUL MUL ON MUL.CODTAB = IND.CODTAB
                  LEFT JOIN TD_INS INS ON INS.CODTAB = IND.CODTAB
                  LEFT JOIN TD_REM REM ON REM.CODTAB = IND.CODTAB
                  LEFT JOIN TD_RET RET ON RET.CODTAB = IND.CODTAB
                  LEFT JOIN TD_CCB CCB ON CCB.CODTAB = IND.CODTAB
                  LEFT JOIN TD_DES DES ON DES.CODTAB = IND.CODTAB
                  LEFT JOIN TD_VTP VTP ON VTP.CODTAB = IND.CODTAB
                  LEFT JOIN TD_ECB ECB ON ECB.CODTAB = IND.CODTAB
;


/*-- SEQ 2504 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TAB_003 CASCADE;

/*-- SEQ 2505 --*/
CREATE OR REPLACE VIEW TV_TAB_003 AS
SELECT /*+RULE*/
       IND.CODTAB,
       EST.ESTATI,
       EST.ESTADO,
       EST.PERICM,
       EST.NOMEST,
       EST.ICMCID,
       EST.INSCST,
       EST.NORINT,
       EST.ALIINT,
       EST.MARG00,
       EST.MARG01,
       EST.MARG02,
       EST.MARG03,
       EST.MARG04,
       EST.MARG05,
       EST.MARG06,
       EST.MARG07,
       EST.MARG08,
       EST.MARG09,
       EST.ONDCAL,
       EST.SOMBAS,
       EST.PERREP,
       EST.ICMINT,
       EST.MAX_CF,
       EST.PERFCP,
       EST.BASMAR,
       BCO.NBANCO,
       BCO.CBANCO,
       BCO.BCOATI,
       BCO.FBANCO,
       BCO.ABANCO,
       BCO.VLRCHE,
       BCO.FILBCO,
       BCO.CODBCO,
       CUS.CUSATI,
       CUS.CENCUS,
       CUS.EXTCUS,
       TOR.SETATI,
       TOR.DESSET,
       TOR.FILSET,
       TOR.PRJSET,
       DOC.DOCATV,
       DOC.TIPDOC,
       DOC.DESDOC,
       CNC.NOMCNC,
       CNC.CNCATI,
       GRU.GRUATI,
       GRU.DESGRU,
       VEI.VEIATI,
       VEI.PESMAX,
       VEI.VOLMAX,
       VEI.PLACAS,
       VEI.DESVEI,
       VEI.CODFRE,
       COL.NOMCOL,
       COL.COLATI,
       COL.INIREF,
       COL.FIMREF,
       COL.INIQTD,
       COL.FIMQTD,
       COL.COLREF,
       COL.COLQTD,
       COL.DELIMI,
       COL.HEADER,
       COL.FOOTER,
       COL.SEPDEC,
       COL.QTDDEC,
       COL.ZERESQ,
       EAN.DESEAN,
       EAN.EANFIL,
       EAN.EANCOD,
       EAN.USAVEN,
       EAN.EANATI,
       DOP.DESDOP,
       DOP.DOPATI,
       DOP.MODPGT,
       DOP.TIPTIT,
       CCC.FILCCC,
       CCC.DESCCC,
       CCC.CCCATI,
       CCC.COMCCC,
       CCC.CLILIV,
       CCC.DIARET,
       CCC.ASSCCC,
       CCC.TXTCCC,
       CCC.REGCCC,
       CCC.CTACCC,
       CCC.VLRBON,
       CWS.DESCWS,
       CWS.CWSATI,
       CWS.PEDAUT,
       CWS.TIPCWS,
       CWS.HORCWS,
       CWS.TIPWOR,
       CWS.ORICWS,
       VPE.MOTVPE,
       VPE.VPEATI,
       JUS.DESJUS,
       JUS.JUSATI,
       JUS.COMJUS,
       JUS.TIPJUS,
       JUS.AVIJUS,
       VCR.CORATI,
       VCR.DESCOR,
       CLT.DESCLT,
       CLT.CLTATV,
       PRI.WORPRI,
       LPC.LPCATI,  /*JADER*/
       LPC.DESLPC,
       LPC.NUMEXT,
       LPC.TIPRCE,
       TER.TERATI,
       TER.TER_IP,
       TER.TERVEN,
       TER.FILTER,
       TER.TERCTR,
       PRI.CARENC,
       CFP.CFPATI,
       CFP.DESCFP,
       CFP.VENCON,
       CFP.VENREV,
       CFP.DEVCON,
       CFP.DEVREV,
       CFP.SAICON,
       CFP.SAIREV,
       CFP.ENTCON,
       CFP.ENTREV,
       CFP.COMCON,
       CFP.COMREV,
       CFP.DVCCON,
       CFP.DVCREV,
       CFP.INTCON,
       CFP.INTREV,
       CFP.VENCON_FOR,
       CFP.VENREV_FOR,
       CFP.DEVCON_FOR,
       CFP.DEVREV_FOR,
       CFP.SAICON_FOR,
       CFP.SAIREV_FOR,
       CFP.ENTCON_FOR,
       CFP.ENTREV_FOR,
       CFP.COMCON_FOR,
       CFP.COMREV_FOR,
       CFP.DVCCON_FOR,
       CFP.DVCREV_FOR,
       CFP.INTCON_FOR,
       CFP.INTREV_FOR,
       REL.RELATI,
       REL.DESREL,
       REL.PRIMIN,
       REL.PRIMAX,
       SIT.SITATI,
       SIT.DESSIT,
       SIT.FLGRES,
       SIT.FLGREV,
       SIT.FLGREG,
       SIT.FLGMOD,
       SIT.TIPSIT,
       SIT.TIPADO,
       SIT.GER_CC,  /*Paulo : 66920*/
       SIT.SITMAI,
       FCC.VLRTAX,
       FCC.PERATE,
       FCC.FCCATI,
       STR.DESSTR,
       STR.FLGSTR,
       STR.STRATI,
       CTR.CTRATI,
       CTR.DESCTR,
       CTR.CTRTIP,
       CTR.CTRSEQ,
       CTR.CTRFIL,
       CTR.CTRUSO,
       CTR.TITCTR,
       CTR.FILPRA,
       CTR.SEQPRA,
       CTR.TIPPRA,
       CTR.PATPED,
       CTR.CTREST_FIL,
       CTR.CTREST_SEQ,
       CTR.CTREST_TIP,
       CTR.CODEXT,
       REQ.DESREQ,
       REQ.REQATI,
       REQ.ABRREQ,
       REQ.CLAREQ,
       CTRP.TITCTRPRA,
       NATD.TITCTADEN,
       NATF.TITCTAFOR,
       CFOC.CFOCTA_TIT,
       BOM.CODTAB AS CODTAB_BOM,
       BOM.CODFIL AS CODFIL_BOM,
       BOM.NUMBOM,
       BOM.NSERIE,
       BOM.NOMFAB,
       BOM.MODELO,
       BOM.TIPMED,
       BOM.BOMATI,
       RTT.DESRTT,
       RTT.RTTATI,
       RTT.RTTEST,
       RTT.FILCTA_DRTT,
       RTT.SEQCTA_DRTT,
       RTT.TIPCTA_DRTT,
       RTT.FILCTA_EST_DRTT,
       RTT.SEQCTA_EST_DRTT,
       RTT.TIPCTA_EST_DRTT,
       FCC.FCCFIL,
       FCC.FCC_FILMAT,
       FCC.FCC_CODMAT,
       FCC.FCC_CODCOR,
       FCC.FCC_CODTAM,
       MPB.DESMPB,
       MPB.VLRMAX,
       MPB.MPBATI,
       RGC.DESRGC,
       RGC.RGCATI,
       RGC.FLGENC,
       RGC.FLGDEV,
       RGC.RGC_TIPENT,
       STF.DESSTF,
       STF.STFATI,
       STF.STF_FILFOR,
       STF.STF_CODFOR,
       STF.STF_CODSER,
       STF.STF_SUBSER,
       STF.STF_DIAVEN,
       STF.STF_CODDAR,
       STF.STF_CODSET,
       STF.STF_FILCTA,
       STF.STF_SEQCTA,
       STF.STF_TIPCTA,
       STF.STF_CODFPS,
       STF.STF_CODCTR,
       STF.STF_CODCUS,
       STF.STF_CODCFO,
       FRE.DESFRE,
       FRE.FREATI,
       FRE.DFRE_TIPCOB,
       FRE.DFRE_PERVEN,
       FRE.DFRE_VALENT,
       FRE.DFRE_VALPES,
       FRE.DFRE_VALQTD,
       FRE.DFRE_FREMIN,
       FRE.DFRE_MINDES,
       FRE.DFRE_PERDES,
       PES.DESPES,
       PES.PESATI,
       PES.PESINI,
       PES.PESFIM,
       NIV.DESNIV,
       NIV.NIVATI,
       NIV.PERNIV,
       NIV.FATNIV,
       CCC.SQLCCC,
       CCC.CCCLET,
       CCC.CCCIMG,
       CCC.CCCLIM,
       CCC.CCCNIV,
       RTT.RTTDIG,
       RTT.RTTTEF,
       RTT.RTTBAR,
       RTT.RTTTIP,
       CCC.CCCCAI,
       IMG.DESIMG,
       IMG.LETIMG,
       IMG.NOMIMG,
       IMG.IMGATI,
       MVP.DESMOT,
       MVP.USOMOT,
       MVP.CONMOT,
       MVP.PERMOT,
       MVP.DESMAXMOT,
       MVP.ACRMAXMOT,
       MVP.TIPMOT,
       MVP.MOTATI,
       EST.ICMIMP,
       SAT.DESSAT,
       SAT.SATATI,
       SAT.SAT_NUMSER,
       SAT.SAT_CODFIL,
       SAT.SAT_CODSER,
       SAT.SAT_CNT_RO,
       OMI.DESOMI,
       OMI.OMIATI,
       OMI.OMILIS,
       OMI.OMIRES,
       OMI.OMICON,
       OMI.OMIFIL,
       PER.DESPER,
       PER.PERCOD,
       PER.PERORD,
       PER.PERATI,
       CCC.CODEXT_DCCC,
       TXI.DESTIPxINT,
       VEI.CODMTD,
       VEI.TIPVEI,
       VEI.ESPVEI,
       VEI.CONVEI,
       VEI.CAPMAX,
       VEI.MAXTRA
  FROM TD_IND IND LEFT JOIN TD_EST EST ON EST.CODTAB = IND.CODTAB
                  LEFT JOIN TD_BCO BCO ON BCO.CODTAB = IND.CODTAB
                  LEFT JOIN TD_CUS CUS ON CUS.CODTAB = IND.CODTAB
                  LEFT JOIN TD_SET TOR ON TOR.CODTAB = IND.CODTAB
                  LEFT JOIN TD_DOC DOC ON DOC.CODTAB = IND.CODTAB
                  LEFT JOIN TD_CNC CNC ON CNC.CODTAB = IND.CODTAB
                  LEFT JOIN TD_GRU GRU ON GRU.CODTAB = IND.CODTAB
                  LEFT JOIN TD_VEI VEI ON VEI.CODTAB = IND.CODTAB
                  LEFT JOIN TD_COL COL ON COL.CODTAB = IND.CODTAB
                  LEFT JOIN TD_EAN EAN ON EAN.CODTAB = IND.CODTAB
                  LEFT JOIN TD_DOP DOP ON DOP.CODTAB = IND.CODTAB
                  LEFT JOIN TD_CCC CCC ON CCC.CODTAB = IND.CODTAB
                  LEFT JOIN TD_CWS CWS ON CWS.CODTAB = IND.CODTAB
                  LEFT JOIN TD_VPE VPE ON VPE.CODTAB = IND.CODTAB
                  LEFT JOIN TD_JUS JUS ON JUS.CODTAB = IND.CODTAB
                  LEFT JOIN TD_VCR VCR ON VCR.CODTAB = IND.CODTAB
                  LEFT JOIN TD_CLT CLT ON CLT.CODTAB = IND.CODTAB
                  LEFT JOIN TD_PRI PRI ON PRI.CODTAB = IND.CODTAB
                  LEFT JOIN TD_LPC LPC ON LPC.CODTAB = IND.CODTAB
                  LEFT JOIN TD_CFP CFP ON CFP.CODTAB = IND.CODTAB
                  LEFT JOIN TD_TER TER ON TER.CODTAB = IND.CODTAB
                  LEFT JOIN TD_REL REL ON REL.CODTAB = IND.CODTAB
                  LEFT JOIN TD_SIT SIT ON SIT.CODTAB = IND.CODTAB
                  LEFT JOIN TD_FCC FCC ON FCC.CODTAB = IND.CODTAB
                  LEFT JOIN TD_STR STR ON STR.CODTAB = IND.CODTAB
                  LEFT JOIN TD_REQ REQ ON REQ.CODTAB = IND.CODTAB
                  LEFT JOIN TD_BOM BOM ON BOM.CODTAB = IND.CODTAB
                  LEFT JOIN TD_RTT RTT ON RTT.CODTAB = IND.CODTAB
                  LEFT JOIN TD_MPB MPB ON MPB.CODTAB = IND.CODTAB
                  LEFT JOIN TD_RGC RGC ON RGC.CODTAB = IND.CODTAB
                  LEFT JOIN TD_STF STF ON STF.CODTAB = IND.CODTAB
                  LEFT JOIN TD_FRE FRE ON FRE.CODTAB = IND.CODTAB
                  LEFT JOIN TD_PES PES ON PES.CODTAB = IND.CODTAB
                  LEFT JOIN TD_NIV NIV ON NIV.CODTAB = IND.CODTAB
                  LEFT JOIN TD_OMI OMI ON OMI.CODTAB = IND.CODTAB
                  LEFT JOIN (SELECT iCTR.*, iCTA.TITCTA AS TITCTR
                                   FROM TD_CTR iCTR
                                   LEFT JOIN TT_CTA iCTA ON iCTA.CODFIL = iCTR.CTRFIL
                                                              AND iCTA.SEQUEN = iCTR.CTRSEQ
                                                              AND iCTA.TIPCTA = iCTR.CTRTIP) CTR ON CTR.CODTAB = IND.CODTAB
                  LEFT JOIN (SELECT iCTR.*, iCTA.TITCTA AS TITCTRPRA
                                   FROM TD_CTR iCTR
                                   LEFT JOIN TT_CTA iCTA ON iCTA.CODFIL = iCTR.FILPRA
                                                              AND iCTA.SEQUEN = iCTR.SEQPRA
                                                              AND iCTA.TIPCTA = iCTR.TIPPRA) CTRP ON CTRP.CODTAB = IND.CODTAB
                  LEFT JOIN (SELECT iNAT.*, iCTA.TITCTA AS TITCTADEN
                                   FROM TD_NAT iNAT
                                   LEFT JOIN TT_CTA iCTA ON iCTA.CODFIL = iNAT.NATDEN_FIL
                                                              AND iCTA.SEQUEN = iNAT.NATDEN_SEQ
                                                              AND iCTA.TIPCTA = iNAT.NATDEN_TIP) NATD ON NATD.CODTAB = IND.CODTAB
                  LEFT JOIN (SELECT iNAT.*, iCTA.TITCTA AS TITCTAFOR
                                   FROM TD_NAT iNAT
                                   LEFT JOIN TT_CTA iCTA ON iCTA.CODFIL = iNAT.NATFOR_FIL
                                                              AND iCTA.SEQUEN = iNAT.NATFOR_SEQ
                                                              AND iCTA.TIPCTA = iNAT.NATFOR_TIP) NATF ON NATF.CODTAB = IND.CODTAB
                  LEFT JOIN (SELECT iCFO.*, iCTA.TITCTA AS CFOCTA_TIT
                                   FROM TD_CFO iCFO
                                   LEFT JOIN TT_CTA iCTA ON iCTA.CODFIL = iCFO.CFOCTA_FIL
                                                              AND iCTA.SEQUEN = iCFO.CFOCTA_SEQ
                                                              AND iCTA.TIPCTA = iCFO.CFOCTA_TIP) CFOC ON CFOC.CODTAB = IND.CODTAB
                  LEFT JOIN TD_NAT NAT ON NAT.CODTAB = IND.CODTAB
                  LEFT JOIN TD_IMG IMG ON IMG.CODTAB = IND.CODTAB
                  LEFT JOIN TD_MVP MVP ON MVP.CODTAB = IND.CODTAB
                  LEFT JOIN TD_SAT SAT ON SAT.CODTAB = IND.CODTAB
                  LEFT JOIN TD_PER PER ON PER.CODTAB = IND.CODTAB
                  LEFT JOIN TD_TIPxINT TXI ON TXI.CODTAB = IND.CODTAB
;


/*-- SEQ 2506 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TAB_OUT CASCADE;

/*-- SEQ 2507 --*/
CREATE OR REPLACE VIEW TV_TAB_OUT AS
select IND.CODTAB, 
       SER.CODSER, SER.DESSER, SER.EXTNOT, SER.IMPNOT,SER.DISSAI, SER.TXTINI, SER.TXTITE, SER.TXTFIM, SER.TXTENT,
       SER.TXTSER, SER.SERMAN, SER.DIVTRO, SER.SERINI, SER.SERFIM, SER.OBSLIN, SER.OBSCOL, SER.MODNOT, SER.SERDOC, SER.SERUTL, 
       SER.TITAVU, SER.SEREXT,
       NAT.NATDEN, NAT.NATFOR, NAT.NATFUD, NAT.NATFUF, NAT.TRIBUT,NAT.FINANC, NAT.SERVIN, NAT.DEVVIN, NAT.NATUTL,
       EST.NORINT, EST.ALIINT, EST.NOMEST, EST.PERICM, EST.ICMCID, EST.ONDCAL,EST.SOMBAS, 
       MOE.DESMOE,
       COB.DESCOB, COB.TXTCOB, COB.LARUNI,COB.SAICAR, COB.TIPCOB,
       CAR.DIACAR, CAR.TAXCAR, CAR.DIADEB, CAR.TAXDEB,
       CAST(CAR.FILADM || CAR.CODADM AS VARCHAR(9)) as CHAVECAR,
       CAI.CX_HIS, CAI.CX_COD, CAI.CX_DES, CAI.TRANSF,
       CL1.CLASS1, CL2.CLASS2, CL3.CLASS3, CL4.CLASS4, 
       CL1.NATCL1, CL1.COMBUS,
       NAT.NATRED, NAT.NATREF,
       SER.QTDITS AS QTDSER,
       SER.QTDITP AS QTDITE,
       NAT.NATOLN AS NATONL, 
       NAT.MOVEST AS BAIEST,
       NAT.TIPNAT AS USOSER,
       NAT.NATURE AS NATDES,
       NAT.LANVEN,
       NAT.NATMUL,
       NAT.USAMUL,
       NAT.CONSFI, 
       EST.MARG00 AS MARG01,
       EST.MARG01 AS MARG02,
       EST.MARG02 AS MARG03,
       EST.MARG03 AS MARG04,
       EST.MARG04 AS MARG05,
       EST.MARG05 AS MARG06,
       EST.MARG06 AS MARG07,
       EST.MARG07 AS MARG08,
       EST.MARG08 AS MARG09,
       EST.MARG09 AS MARG10,
       EST.ESTADO AS SIGEST,
       EST.INSCST AS INSEST,
       OUT.DESCAR AS DESOUT,
       OUT.DADREC,
       CAR.DESOUT AS DESCAR,
       CAI.CX_USU AS CX_USO,
       CT1.NOMCT1 AS TIPCLI,
       CT2.NOMCT2 AS CATEG1,
       CAR.PROCAR,
       CAR.PORCAR,
       CAR.COBCAR AS COBCAR,
       CCC.DESCCC, CCC.COMCCC, CCC.CLILIV, CCC.REGCCC,
       COALESCE(CAI.FILCAI,'')||COALESCE(CAI.SEQCAI,'')||COALESCE(CAI.TIPCAI,'') AS CTADEB,
       COALESCE(CAI.FILCAI,'')||COALESCE(CAI.SEQCAI,'')||COALESCE(CAI.TIPCAI,'') AS CTACRE,
       CASE SER.CODSER WHEN CFG.SERIE_FAT_CC THEN 'T' 
                                             ELSE SER.RESTRI 
       END AS RESTRI,
       COB.GERTIT,
       AMP.PHOALT,AMP.PHOLAR,AMP.PHOCOM,AMP.CORAMP,
       MAR.PHOMAR,
       TIP.PHOTIP,ISO.PHOISO,PHO.PHOOUT,ROS.RESULT,OBS.USUOBS,OBS.DESOBS,OBS.TXTOBS,
       ECF.SAIENV,
       DEV.DESDEV,DEV.USODEV,DEV.DEVATE,DEV.VLRDEV,DEV.DEVCOM,DEV.DEVICM,DEV.MULDEV,DEV.CLIDEV,
       MUL.DESMUL,
       LPC.DESLPC, LPC.TIPRCE
       --usar tv_tab_out2, essa estourou!
from TD_IND IND LEFT OUTER JOIN (SELECT * 
                                   FROM TD_SER 
                                  WHERE CODSER IS NOT NULL 
                                    AND SERATI = 'T') SER ON SER.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select NAT.*,CASE WHEN NAT.NATMUL IS NULL THEN 'F' ELSE 'T' END AS USAMUL
                   from TD_NAT NAT   
                  where NAT.NATURE is not NULL and NATATI = 'T') NAT ON NAT.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_EST where ESTATI = 'T') EST ON EST.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_MOE where DESMOE is not NULL and MOEATI = 'T') MOE ON MOE.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_MUL where DESMUL is not NULL and MULATI = 'T') MUL ON MUL.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_COB where DESCOB is not NULL and COBATI = 'T') COB ON COB.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_OUT where DESCAR is not NULL and OUTATI = 'T' and CODTAB <> 0) OUT ON OUT.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_CAR where DESOUT is not NULL and CARATI = 'T' and CODTAB <> 0) CAR ON CAR.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_CAI where CX_DES is not NULL and CX_ATI = 'T' and CX_USU <> 2) CAI ON CAI.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_CL1 where CLASS1 is not NULL and CL1ATI = 'T') CL1 ON CL1.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_CL2 where CLASS2 is not NULL and CL2ATI = 'T') CL2 ON CL2.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_CL3 where CLASS3 is not NULL and CL3ATI = 'T') CL3 ON CL3.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_CL4 where CLASS4 is not NULL and CL4ATI = 'T') CL4 ON CL4.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_CT1 where NOMCT1 is not NULL and CT1ATI = 'T') CT1 ON CT1.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_CT2 where NOMCT2 is not NULL and CT2ATI = 'T') CT2 ON CT2.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_CCC where CCCATI = 'T') CCC ON CCC.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_AMP where AMPATI = 'T') AMP ON AMP.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_MAR where MARATI = 'T') MAR ON MAR.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_TIP where TIPATI = 'T') TIP ON TIP.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_ISO where ISOATI = 'T') ISO ON ISO.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_PHO where PHOATI = 'T') PHO ON PHO.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_ROS where ROSATI = 'T') ROS ON ROS.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_OBS where DESOBS is not NULL AND OBSATI = 'T') OBS ON OBS.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_DEV where DEVATI = 'T') DEV ON DEV.CODTAB = IND.CODTAB
LEFT OUTER JOIN (select * from TD_LPC where LPCATI = 'T') LPC ON LPC.CODTAB = IND.CODTAB
LEFT OUTER JOIN TD_ECF ECF ON ECF.CODTAB = IND.CODTAB
,TT_CFG CFG
;


/*-- SEQ 2508 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TAB_OUT2 CASCADE;

/*-- SEQ 2509 --*/
CREATE OR REPLACE VIEW TV_TAB_OUT2 AS
SELECT IND.CODTAB,
       CFP.DESCFP,
       CFP.VENCON,
       CFP.VENREV,
       CFP.DEVCON,
       CFP.DEVREV,
       CFP.SAICON,
       CFP.SAIREV,
       CFP.ENTCON,
       CFP.ENTREV,
       CFP.COMCON,
       CFP.COMREV,
       CFP.DVCCON,
       CFP.DVCREV,
       CFP.INTCON,
       CFP.INTREV,
       CFP.VENCON_FOR,
       CFP.VENREV_FOR,
       CFP.DEVCON_FOR,
       CFP.DEVREV_FOR,
       CFP.SAICON_FOR,
       CFP.SAIREV_FOR,
       CFP.ENTCON_FOR,
       CFP.ENTREV_FOR,
       CFP.COMCON_FOR,
       CFP.COMREV_FOR,
       CFP.DVCCON_FOR,
       CFP.DVCREV_FOR,
       CFP.INTCON_FOR,
       CFP.INTREV_FOR,
       EST.ICMINT,
       EST.MAX_CF,
       EST.ICMIMP,
       EST.PERFCP,
       EST.BASMAR,
       COALESCE(EST.SUBLIM,0) AS SUBLIM,
       SER.TXTOBS AS OBSSER,
       SER.SERREM,
       SER.RECIBO,
       SER.ENVNFS,
       NAT.SITPIS,
       NAT.SITCOF,
       NAT.NATBCC,
       NAT.NATESD,
       NAT.NATESF,
       NAT.NATRED_ST,
       NAT.NATREF_ST,
       NAT.CSTNOR,
       NAT.CST_ST,
       NAT.CONLOC,
       COB.VLRMBL,
       COB.VLRABL,
       CAR.CODCRE,
       SER.SERCON,
       CAR.BANDEB,
       CAR.BANCRE
  FROM TD_IND IND LEFT OUTER JOIN (SELECT * FROM TD_CFP WHERE CFPATI = 'T') CFP ON CFP.CODTAB = IND.CODTAB
                  LEFT OUTER JOIN (SELECT * FROM TD_EST WHERE ESTATI = 'T') EST ON EST.CODTAB = IND.CODTAB
                  LEFT OUTER JOIN (SELECT * FROM TD_SER WHERE CODSER IS NOT NULL AND SERATI = 'T') SER ON SER.CODTAB = IND.CODTAB
                  LEFT OUTER JOIN (SELECT * FROM TD_COB WHERE DESCOB IS NOT NULL AND COBATI = 'T') COB ON COB.CODTAB = IND.CODTAB
                  LEFT OUTER JOIN (SELECT * FROM TD_CAR WHERE DESOUT IS NOT NULL AND CARATI = 'T' AND CODTAB <> 0) CAR ON CAR.CODTAB = IND.CODTAB
                  LEFT OUTER JOIN TD_NAT NAT ON NAT.CODTAB = IND.CODTAB
       ,TT_CFG CFG
;


/*-- SEQ 2510 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TCM CASCADE;

/*-- SEQ 2511 --*/
CREATE OR REPLACE VIEW TV_TCM AS
SELECT trim(COM.CODSER) ||'/'|| CASE WHEN COM.SUBSER IS NULL THEN ''
                                     ELSE trim(COM.SUBSER)||'-'
                                END || trim(COM.NUMNOT) AS DOCUME,
       COM.SEQUEN, COM.CODFIL, COM.FILFOR, COM.CODFOR, COM.CODSER, COM.NUMNOT, COM.DATOPE,
       COM.FLGEST, COM.ATU_EM, COM.DATCMP, COM.QTDTOT, COM.VLRTOT, COM.NOTESP, COM.OUTTAX,
       COM.DESCON, COM.VLRLIQ, COM.FILUSU, COM.CODUSU, COM.CODMOE, COM.OBSERV, COM.VLTXJU,
       COM.INCOJU, COM.INTPJU, COM.VLTXMU, COM.INTPMU, COM.CONPGT, CFO.CODCFO AS NATURE, 
       COM.ESPDOC, COM.SIGNAT, COM.MOEJUR, COM.SEQFAT, COM.FILFRE, COM.SEQFRE, COM.TIPNOT, COM.TIPPAR,
       COM.SEQCAN, COM.SUBSER, COM.CODSET, COM.SUBSTT, COM.FILCTA, COM.SEQCTA, COM.TIPCTA,
       COM.NUMVOL
  FROM TT_COM COM LEFT OUTER JOIN TD_CFO CFO ON COM.CODCFO=CFO.CODTAB
;


/*-- SEQ 2512 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TEC CASCADE;

/*-- SEQ 2513 --*/
CREATE OR REPLACE VIEW TV_TEC AS
SELECT CLI.FILCLI,CLI.CODCLI,CLI.NOMCLI,CLI.ULTNOM,CLI.NUMDOC,
       CLI.DATNAS,CLI.CONJUG,CLI.FLGTIP,CLI.DOCCON,REL.TIPPAR,
       CLI.PP_FLG
FROM TT_CLI CLI
 INNER JOIN TT_REL REL ON 
            CLI.FILCLI = REL.FILPAR 
        AND CLI.CODCLI = REL.CODPAR
        AND REL.TIPPAR IN ('X','N')
 ;




/*-- SEQ 2514 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TEL CASCADE;

/*-- SEQ 2515 --*/
CREATE OR REPLACE VIEW TV_TEL AS
select ENDE.FILCLI, ENDE.CODCLI, 
    0 AS ORDEM, 
    ENDE.CODDDD AS DDD,
    ENDE.NUMFON AS FONE,
    DEND.DESEND AS TIPO,
    'O Prprio' AS NOME,
    'UPDATE TT_END SET CODDDD = :DDD, NUMFON = :FON '||
    'WHERE FILCLI = ''' || ENDE.FILCLI || 
   ''' AND CODCLI = ''' || ENDE.CODCLI ||
   ''' AND CODFIL = ''' || ENDE.CODFIL ||
   ''' AND NUMEND = '   || ENDE.NUMEND AS EXPRESSAO
from tt_end ende left join td_end dend on dend.codtab = ende.tipend 
union all 
select SPC.FILCLI, SPC.CODCLI, 
    1 AS ORDEM, 
    SPC.NUMCOD AS DDD,
    SPC.NUMTEL AS FONE,
    'Comercial' AS TIPO,
    SPC.FIRATU AS NOME,
    'UPDATE TT_SPC SET NUMCOD = :DDD, NUMTEL = :FON '||
    'WHERE FILCLI = ''' || SPC.FILCLI || 
   ''' AND CODCLI = ''' || SPC.CODCLI || ''''  AS EXPRESSAO
from tt_spc spc 
union all
select SPC.FILCLI, SPC.CODCLI, 
    2 AS ORDEM, 
    SPC.DDDCEL AS DDD,
    SPC.NUMCEL AS FONE,
    'Celular' AS TIPO,
    'O Prprio' AS NOME,
    'UPDATE TT_SPC SET DDDCEL = :DDD, NUMCEL = :FON '||
    'WHERE FILCLI = ''' || SPC.FILCLI || 
   ''' AND CODCLI = ''' || SPC.CODCLI || ''''  AS EXPRESSAO
from tt_spc spc 
union all
select FILCLI, CODCLI, 
    3 AS ORDEM, 
    DDTCON AS DDD,
    TELCON AS FONE,
    CASE FLGTIP WHEN 0 THEN 'Conjuge' ELSE 'Contato' END AS TIPO,
    CONJUG AS NOME,
    'UPDATE TT_CLI SET DDTCON = :DDD, TELCON = :FON '||
    'WHERE FILCLI = ''' || CLI.FILCLI || 
    ''' AND CODCLI = ''' || CLI.CODCLI || ''''  AS EXPRESSAO
from tt_cli cli
union all
select FILCLI, CODCLI, 
    4 AS ORDEM, 
    DDCCON AS DDD,
    CELCON AS FONE,
    'Celular do ' || CASE FLGTIP WHEN 0 THEN 'Conjuge' ELSE 'Contato' END AS TIPO,
    CONJUG AS NOME,
    'UPDATE TT_CLI SET DDCCON = :DDD, CELCON = :FON '||
    'WHERE FILCLI = ''' || CLI.FILCLI || 
   ''' AND CODCLI = ''' || CLI.CODCLI || ''''  AS EXPRESSAO
from tt_cli cli
union all
select SPC.FILCLI, SPC.CODCLI, 
    5 AS ORDEM, 
    SPC.NUMCOC AS DDD,
    SPC.TELCON AS FONE,
    'Comercial do ' || CASE CLI.FLGTIP WHEN 0 THEN 'Conjuge' ELSE 'Contato' END AS TIPO,
    CLI.CONJUG || ' (' || SPC.FIRCON || ')' AS NOME,
    'UPDATE TT_SPC SET NUMCOC = :DDD, TELCON = :FON '||
    'WHERE FILCLI = ''' || SPC.FILCLI || 
   ''' AND CODCLI = ''' || SPC.CODCLI || ''''  AS EXPRESSAO
from tt_cli cli inner join tt_spc spc on spc.filcli = cli.filcli and spc.codcli = cli.codcli
union all
select ENDE.FILCLI, ENDE.CODCLI, 
    6 AS ORDEM, 
    ENDE.DDDFAX AS DDD,
    ENDE.NUMFAX AS FONE,
    DEND.DESEND || ' (Fax)' AS TIPO,
    'O Prprio' AS NOME,
    'UPDATE TT_END SET DDDFAX = :DDD, NUMFAX = :FON '||
    'WHERE FILCLI = ''' || ENDE.FILCLI || 
   ''' AND CODCLI = ''' || ENDE.CODCLI ||
   ''' AND CODFIL = ''' || ENDE.CODFIL ||
   ''' AND NUMEND = '   || ENDE.NUMEND AS EXPRESSAO
from tt_end ende left join td_end dend on dend.codtab = ende.tipend 
union all
select CON.FILCLI, CON.CODCLI, 
    7 AS ORDEM, 
    CON.DDDCON AS DDD,
    CON.TELCON AS FONE,
    DCON.DESCON AS TIPO,
    CON.CONTAT || CASE CON.NOMTRA WHEN NULL THEN '' ELSE ' (' || CON.NOMTRA || ')' END AS NOME,
    'UPDATE TT_CON SET DDDCON = :DDD, TELCON = :FON '||
    'WHERE FILCLI = ''' || CON.FILCLI || 
   ''' AND CODCLI = ''' || CON.CODCLI ||
   ''' AND NUMCON = '   || CON.NUMCON AS EXPRESSAO
from tt_con con left join td_con dcon on dcon.codtab = con.codrel
union all
select CON.FILCLI, CON.CODCLI, 
    8 AS ORDEM, 
    CON.DDDCEL AS DDD,
    CON.CELCON AS FONE,
    DCON.DESCON || ' (Celular)' AS TIPO,
    CON.CONTAT || CASE CON.NOMTRA WHEN NULL THEN '' ELSE ' (' || CON.NOMTRA || ')' END AS NOME,
    'UPDATE TT_CON SET DDDCEL = :DDD, CELCON = :FON '||
    'WHERE FILCLI = ''' || CON.FILCLI || 
   ''' AND CODCLI = ''' || CON.CODCLI ||
   ''' AND NUMCON = '   || CON.NUMCON AS EXPRESSAO
from tt_con con left join td_con dcon on dcon.codtab = con.codrel
union all
select CON.FILCLI, CON.CODCLI, 
    9 AS ORDEM, 
    CON.DDDFAX AS DDD,
    CON.numfax AS FONE,
    DCON.DESCON || ' (Fax)' AS TIPO,
    CON.CONTAT || CASE CON.NOMTRA WHEN NULL THEN '' ELSE ' (' || CON.NOMTRA || ')' END AS NOME,
    'UPDATE TT_CON SET DDDFAX = :DDD, NUMFAX = :FON '||
    'WHERE FILCLI = ''' || CON.FILCLI || 
   ''' AND CODCLI = ''' || CON.CODCLI ||
   ''' AND NUMCON = '   || CON.NUMCON AS EXPRESSAO
from tt_con con left join td_con dcon on dcon.codtab = con.codrel
;


/*-- SEQ 2516 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TOTVENLIQ CASCADE;

/*-- SEQ 2517 --*/
CREATE OR REPLACE VIEW TV_TOTVENLIQ AS
SELECT CODFIL, 
       TRUNC(VEN_DATHOR) AS VEN_DATHOR, 
       FILVDD, 
       CODVDD, 
       DEPART, 
       CLASS1, 
       CODNAT, 
       NATFIS,	   
       CAST((CODSER||' '||NUMECF||' '||NUMNOT) AS VARCHAR(15)) AS DOCUME, 
       CAST(COUNT(DISTINCT SEQVEN) AS Numeric) AS QTDVEN,
       AVG(QTDITE) AS QTDITEMED,
       AVG(QTDPAR) AS QTDPARMED, 
       ROUND(SUM(VLRMOVORI),2) AS VLRMOVORI,
       ABS(SUM(DESCON)) AS DESCON,
       SUM(ACRESC) AS ACRESC,
       SUM(VLRFRE) AS VLRFRE,
       ROUND(SUM(VLRMOV),2) AS VLRMOV, 
       SUM(QTDMOV) AS QTDMOV,
       ROUND((SUM(VLRMOV) / SUM(QTDMOV)), 3) AS VLRUNI,        
       ROUND(SUM(ICMITE),3) AS ICMITE,
       ROUND(SUM(VLRMOV * VENPIS / 100), 3) AS VENPIS,
       ROUND(SUM(VLRMOV * VENCOF / 100), 3) AS VENCOF,
       ROUND(SUM(VLRMOV * PERSOC / 100), 3) AS PERSOC,
       ROUND(SUM(VLRMOV * PEROPE / 100), 3) AS PEROPE,
       ROUND(SUM(VLRMOV * PERIR  / 100), 3) AS PERIR,
       ROUND(SUM(CUSMED), 3) AS CUSMED,
       ROUND(COALESCE(SUM(VLRMOV) - (SUM(ICMITE) +
           SUM(VLRMOV * VENPIS / 100) + SUM(VLRMOV * VENCOF / 100) +
           SUM(VLRMOV * PERSOC / 100) + SUM(VLRMOV * PEROPE / 100) +
           SUM(VLRMOV * PERIR  / 100) + (SUM(CUSMED))), 0), 3) AS VLRCONT        
  FROM (SELECT TAB.*,   
          (SELECT COUNT(*) 
             FROM TT_IVE SUB 
            WHERE SUB.CODFIL = TAB.CODFIL
              AND SUB.SEQUEN = TAB.SEQVEN
              AND SUB.SITMOV <> 'C'
              AND SUB.SITKIT IN ('2','3')
          ) AS QTDITE,
          (SELECT COUNT(*) 
             FROM TT_REC REC 
            WHERE REC.CODFIL = TAB.CODFIL
              AND REC.SEQUEN = TAB.SEQVEN
          ) AS QTDPAR
          FROM (SELECT IVE.CODFIL,
                       VEN.CODNAT, 
                       VEN.NUMNOT, 
                       VEN.NUMECF, 
                       VEN.CODSER, 
                       IVE.FILMAT, 
                       IVE.CODMAT, 
                       IVE.CODCOR, 
                       IVE.CODTAM, 
                       IVE.NUMITE, 
                       IVE.QTDMOV, 
                       IVE.VLRFRE, 
                       IVE.TIP001, 
                       IVE.SITKIT,
                       CAST(COALESCE(IVE.NATFIS, 
                                CAST((SELECT NATUREZAVENDA(VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR,VEN.SUBSTT)||'00' 
                                        FROM TT_VEN VEN 
                                             INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT 
                                       WHERE VEN.CODFIL = IVE.CODFIL
                                         AND VEN.SEQUEN = IVE.SEQUEN
                                ) AS CHAR(6)))
                           AS VARCHAR(6)) AS NATFIS,
                       IVE.ICMTIP,
                       IVE.SEQUEN,
                       IVE.BASICM,
                       IVE.SITPIS,
                       IVE.SITCOF,
                       IVE.TAXICM,
                       IVE.CODCST,
                       VEN.SEQUEN AS SEQVEN, 
                       VEN.VLRLIQ,
                       VEN.VLRNOT,
                       VEN.FLGEST,
                       VEN.LANVEN,
                       IVE.SITMOV,
                       TRUNC(IVE.VEN_DATHOR) AS VEN_DATHOR,
                       PRO.DEPART,
                       PRO.CLASS1,
                       PRO.CLASS2,
                       PRO.CLASS3,
                       PRO.CLASS4,
                       IVE.VLRMOV AS VLRMOVORI,
                       IVE.FILVDD,
                       IVE.CODVDD,
                       -- CUSMED
                       (IVE.QTDMOV * ROUND(COALESCE(CUSTOMEDIO(IVE.CODFIL, IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM, 3, IVE.VEN_DATHOR), 0), 3)
                       ) AS CUSMED,
                       -- VLRMOV
                       ((IVE.VLRMOV + 
                       (IVE.VLRFRE + 
                       (CASE WHEN (COALESCE(IVE.DESRAT, 0) > 0) THEN IVE.DESRAT ELSE 0 END) + 
                       (CASE WHEN (COALESCE(IVE.DESRAT, 0) < 0) THEN IVE.DESRAT ELSE 0 END))
                       ) - IVE.VLRFRE - 
                       (CASE WHEN (COALESCE(IVE.DESRAT, 0) > 0) THEN IVE.DESRAT ELSE 0 END)
                       ) AS VLRMOV,
                       -- DESCONTO RATIANO ITEM 
                       CASE WHEN (COALESCE(IVE.DESRAT,0) > 0)  THEN 0 ELSE IVE.DESRAT END AS DESCON, 
                       -- ACRESCIMO RATIANO ITEM
                       CASE WHEN (COALESCE(IVE.DESRAT,0) <= 0) THEN 0 ELSE IVE.DESRAT END AS ACRESC, 
                       -- TAXA FINANCEIRA
                       COALESCE(CFG.TAXFIN ,0) AS TAXFIN,
                       -- PRAZO DIVISOR DA TAXA FINANCEIRA
                       COALESCE(CFG.PRAFIN ,1) AS PRAFIN, 
                       -- PERCENTUAL DE CONTRIBUICAO DO PIS
                       COALESCE(DFIL.VENPIS,0) AS VENPIS,
                       -- PERCENTUAL DE CONTRIBUICAO DO COFINS
                       COALESCE(DFIL.VENCOF,0) AS VENCOF,
                       -- PERCENTUAL DE CONTRIBUICAO DO CONTRIB. SOCIAL
                       COALESCE(DFIL.PERSOC,0) AS PERSOC,
                       -- PERCENTUAL MDIO EXTRA PARA COBRIR O OPERACIONAL
                       COALESCE(DFIL.PEROPE,0) AS PEROPE,
                       -- PERCENTUAL DE CONTRIBUICAO DO I.R.
                       COALESCE(CFG.PERIR  ,0) AS PERIR,
                       -- COMISSAO DO ITEM
                       COALESCE(IVE.COMISS ,0) AS COMISS,
                       -- ICMITE
                       CASE COALESCE(IVE.TIP001, 'M') 
                           WHEN 'M' THEN 
                               CASE IVE.ICMTIP 
                                    WHEN '3' THEN 0 
                                    ELSE CASE IVE.ICMTIP 
                                         WHEN '0' THEN (COALESCE(IVE.BASICM,0) / 100) * IVE.TAXICM 
                                         ELSE (COALESCE(IVE.BASICM,0) / 100) * IVE.TAXICM
                                         END 
                               END 
                           ELSE 0 
                       END AS ICMITE
                  FROM TT_VEN VEN 
                       CROSS JOIN TT_CFG CFG           
                       INNER JOIN TT_IVE IVE 
                             ON  VEN.CODFIL = IVE.CODFIL 
                             AND VEN.SEQUEN = IVE.SEQUEN
                       INNER JOIN TD_FIL DFIL
                             ON DFIL.CODFIL = IVE.CODFIL
                       INNER JOIN TT_GRA GRA 
                             ON  GRA.FILMAT = IVE.FILMAT
                             AND GRA.CODMAT = IVE.CODMAT
                             AND GRA.CODCOR = IVE.CODCOR
                             AND GRA.CODTAM = IVE.CODTAM
                       INNER JOIN TT_PRO PRO 
                             ON  PRO.FILMAT = GRA.FILMAT
                             AND PRO.CODMAT = GRA.CODMAT                                                      
               ) TAB 
       ) TAB2
  WHERE TAB2.FLGEST <> 'C'
    AND TAB2.SITMOV <> 'C'  
    AND TAB2.NATFIS NOT IN ('511700', '611700', '515200', '615200', '540900', '640900', '194901', '294901')
    AND TAB2.SITKIT <> '1'
  GROUP BY CODFIL, 
        DEPART, 
        CLASS1, 
        CODNAT, 
        VEN_DATHOR, 
        FILVDD, 
        CODVDD, 
        NATFIS,
        (CODSER||' '||NUMECF||' '||NUMNOT)
;


/*-- SEQ 2518 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TRA CASCADE;

/*-- SEQ 2519 --*/
CREATE OR REPLACE VIEW TV_TRA AS
  SELECT REL.FILPAR, REL.CODPAR, REL.TIPPAR, CLI.FILCLI, CLI.CODCLI,
         CLI.ATU_EM, CLI.NOMCLI, CLI.ULTNOM, CLI.NUMDOC, CLI.DOCCON,
         CLI.DATNAS, CLI.ESTCIV, CLI.HOMPGE, CLI.FLGTIP, CLI.INSEST,
         CLI.CODSEX, CLI.CATEG1, CLI.CATEG2, CLI.CATEG3, CLI.DATA01,
         CLI.DATA02, CLI.DATA03, CLI.DATOPE, CLI.IMPRIM, CLI.VALOR1,
         CLI.TOTATR, CLI.TOTPAR, CLI.MAIATR, CLI.OBSERV, CLI.FILPLA,
         CLI.CODPLA, CLI.PORPAD, CLI.ULTCOM, CLI.SIGNAT, CLI.CONJUG,
         CLI.NASCON, CLI.SEXCON, CLI.FILVEN, CLI.CODVEN, CLI.PP_FLG
    FROM TT_REL REL INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI = REL.CODPAR 
   WHERE REL.TIPPAR =  'T'
 ;




/*-- SEQ 2520 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_VAR CASCADE;

/*-- SEQ 2521 --*/
CREATE OR REPLACE VIEW TV_VAR AS
  select SEQUEN,FILPRE,CODPRE,FILMAT,CODMAT,
         CODCOR,CODTAM,PRECOV,CODMOE,FLGEST,
         ULTREA,DESMAX, PERLUC, DESIDE
    from TT_PRE
   where FILPRE = (select FILPRE from TT_CFG)
     and CODPRE = (select CODPRE from TT_CFG) 
 ;


/*-- SEQ 2522 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_VAV CASCADE;

/*-- SEQ 2523 --*/
CREATE OR REPLACE VIEW TV_VAV AS
-- View que retorna todas as parcelas vencidas e a vencer agrupadas
-- por portador e conta, somadas dentro da faixa de prazo vencido ou a vencer
-- Vencidas : a mais de 120 dias
--            de 91 a 120 dias
--            de 61 a 90 dias
--            de 31 a 60 dias
--            de 01 a 30 dias
-- Vincendas : de hoje at daqui a 30 dias
--             em 31 a 60 dias
--             em 61 a 90 dias
--             em 91 a 120 dias
--             em mais de 120
SELECT CODFIL, PORTAD, FILCTA, SEQCTA, TIPCTA,
       SUM(CASE 0 WHEN ABS(TTDIAS+121)-(TTDIAS+121)       THEN 0
                  WHEN ABS(TTDIAS+100000)-(TTDIAS+100000) THEN VLRPAR
                  ELSE 0
            END) AS VENMAI120,
       SUM(CASE 0 WHEN ABS(TTDIAS+091)-(TTDIAS+091) THEN 0
                  WHEN ABS(TTDIAS+120)-(TTDIAS+120) THEN VLRPAR
                  ELSE 0
            END) AS VENATE120,
       SUM(CASE 0 WHEN ABS(TTDIAS+061)-(TTDIAS+061) THEN 0
                  WHEN ABS(TTDIAS+090)-(TTDIAS+090) THEN VLRPAR
                  ELSE 0
           END) AS VENATE090,
       SUM(CASE 0 WHEN ABS(TTDIAS+031)-(TTDIAS+031) THEN 0
                  WHEN ABS(TTDIAS+060)-(TTDIAS+060) THEN VLRPAR
                  ELSE 0
           END) AS VENATE060,
       SUM(CASE 0 WHEN ABS(TTDIAS+001)-(TTDIAS+001) THEN 0
                  WHEN ABS(TTDIAS+030)-(TTDIAS+030) THEN VLRPAR
                  ELSE 0
            END) AS VENATE030,
       SUM(CASE 0 WHEN ABS(TTDIAS-000)+(TTDIAS-000) THEN 0
                  WHEN ABS(TTDIAS-030)+(TTDIAS-030) THEN VLRPAR
                  ELSE 0
           END) AS AVEATE030,
       SUM(CASE 0 WHEN ABS(TTDIAS-031)+(TTDIAS-031) THEN 0
                  WHEN ABS(TTDIAS-060)+(TTDIAS-060) THEN VLRPAR
                  ELSE 0
            END) AS AVEATE060,
       SUM(CASE 0 WHEN ABS(TTDIAS-061)+(TTDIAS-061) THEN 0
                  WHEN ABS(TTDIAS-090)+(TTDIAS-090) THEN VLRPAR
                  ELSE 0
            END) AS AVEATE090,
       SUM(CASE 0 WHEN ABS(TTDIAS-091)+(TTDIAS-091) THEN 0
                  WHEN ABS(TTDIAS-120)+(TTDIAS-120) THEN VLRPAR
                  ELSE 0
            END) AS AVEATE120,
       SUM(CASE 0 WHEN ABS(TTDIAS-121)+(TTDIAS-121)       THEN 0
                  WHEN ABS(TTDIAS-100000)+(TTDIAS-100000) THEN VLRPAR
                  ELSE 0
            END) AS AVEMAI120
 FROM (SELECT REC.CODFIL, REC.PORTAD, REC.VLRPAR,
              trunc(REC.DATVEN)-TRUNC(AGORA()) AS TTDIAS,
              DCOB.FILCTA, DCOB.SEQCTA, DCOB.TIPCTA
       FROM   TT_REC REC INNER JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD
       WHERE  REC.FLGEST = 'A'
         AND  REC.PAGAME IS NULL
       UNION ALL
       SELECT PTR.CODFIL, 0 AS PORTAD, PTR.VLRPAR,
              trunc(PTR.DATVEN)-TRUNC(AGORA()) AS TTDIAS,
              PTR.FILCTA, PTR.SEQCTA, PTR.TIPCTA
       FROM   TT_PTR PTR
       WHERE  PTR.FLGEST = 'A'
         AND  PTR.DATPGT IS NULL) TABELA
GROUP BY CODFIL,PORTAD, FILCTA, SEQCTA, TIPCTA
 ;




/*-- SEQ 2524 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_VDD CASCADE;

/*-- SEQ 2525 --*/
CREATE OR REPLACE VIEW TV_VDD AS
SELECT VDD.FILVEN AS CODFIL, VDD.SEQVEN AS SEQUEN, VDD.FILVDD AS FILVEN, VDD.CODVDD AS CODVEN, VDD.TIPVDD
  FROM TT_VDD VDD
 WHERE VDD.FILVEN IS NOT NULL
   AND (VDD.TIPVDD = 'V'
        OR (((SELECT MULT_VENDEDORES FROM TT_CFG) = 'T')
            AND NOT EXISTS (SELECT 1
                              FROM TT_VDD AUX
                             WHERE AUX.FILVEN = VDD.FILVEN
                               AND AUX.SEQVEN = VDD.SEQVEN
                               AND AUX.FILVDD = VDD.FILVDD
                               AND AUX.CODVDD = VDD.CODVDD
                               AND AUX.TIPVDD = 'V')));


/*-- SEQ 2526 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_VEI CASCADE;

/*-- SEQ 2527 --*/
CREATE OR REPLACE VIEW TV_VEI AS
SELECT VEI.PLACAS,
       CLI.FILCLI,
       CLI.CODCLI,
       CLI.NUMDOC
  FROM TT_VEI VEI INNER JOIN TT_CLI CLI ON VEI.FILCLI = CLI.FILCLI AND VEI.CODCLI = CLI.CODCLI
 ;




/*-- SEQ 2528 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_VEN CASCADE;

/*-- SEQ 2529 --*/
CREATE OR REPLACE VIEW TV_VEN AS
SELECT CAST(COALESCE(VEN.CODSER,'')||'/'||lTrim(COALESCE(VEN.NUMECF,''))||'-'||lTrim(COALESCE(VEN.NUMNOT,''))||CASE WHEN COALESCE(VEN.CNT_RO,0)>0 THEN '['||VEN.CNT_RO||']' ELSE '' END AS VARCHAR(21)) AS DOCUME,
       VEN.CODFIL, VEN.NUMECF, VEN.CODSER, VEN.NUMNOT, VEN.FILCLI, VEN.CODCLI,
       VEN.DATHOR, VEN.FLGEST, VEN.ATU_EM, VEN.FILUSU, VEN.CODUSU, VEN.FILVEN,
       VEN.CODVEN, VEN.FILPGT, VEN.CODPGT, VEN.VLRNOT, VEN.VLRLIQ, VEN.PERCOM,
       VEN.PERENT, VEN.COMSOB, VEN.CODNAT, VEN.PRAMED, VEN.ESPECI, VEN.OBSERV,
       VEN.NROIMP, VEN.AUTENT, VEN.DESCON, VEN.FILGUI, VEN.CODGUI, VEN.SIGNAT,
       VEN.DATSAI, VEN.NUMVOL, VEN.MARCAS, VEN.VLRSEG, VEN.VLRFRE, VEN.PESBRU, VEN.CODNSU,
       VEN.PESLIQ, VEN.NUMCON, VEN.CODPRE, VEN.SINAL, VEN.FINANC, VEN.TRIBUT, VEN.SEQFAT,
       VEN.FILPRE, VEN.PROPGT, VEN.EMIDES, VEN.SEQUEN, VEN.FILTRA, VEN.CODTRA, VEN.TIPNOT,
       VEN.TIPTRA, VEN.FILFAT, VEN.ENDFAT, VEN.FILENT, VEN.ENDENT, VEN.FILCOB, VEN.ENDCOB,
       VEN.CODFIN, VEN.BASUBS, VEN.SUBSTT, VEN.RETIDO, VEN.CONSFI, VEN.VINCUL,VEN.OUTTAX,
       VEN.CODEXT, VEN.FLGTIP, VEN.LANVEN, VEN.UFLOJA, VEN.CODCTR, VEN.TIPTRO, VEN.FUNRUR,
       CAST(' ' AS CHAR(1)) AS MOTREI,
       (SELECT CASE WHEN (CFG.VC_FILCLI||CFG.VC_CODCLI)=(VEN.FILCLI||VEN.CODCLI) THEN 'T'
                                                                                 ELSE 'F'
       END
       FROM TT_CFG CFG) AS VENCON,
       (SELECT CASE VEN.UFLOJA WHEN 'T' THEN NAT.EXTDEM
                                        ELSE NAT.EXTFOR
               END
          FROM TD_NAT NAT
         WHERE VEN.CODNAT = NAT.CODTAB
       ) AS EXTNAT,
       (SELECT CASE VEN.UFLOJA WHEN 'T' THEN NAT.NATDEN
                                        ELSE NAT.NATFOR
               END
          FROM TD_NAT NAT
         WHERE VEN.CODNAT = NAT.CODTAB
       ) AS CODCFO,
       (SELECT PLA.CODEXT
         FROM TT_PLA PLA
         WHERE VEN.FILPGT = PLA.FILPGT AND VEN.CODPGT = PLA.CODPGT
       ) AS EXTPLA,
       VEN.EXPORT, VEN.DATFIS,
       VEN.AVISTA, VEN.DOCNFP,
       (select max(ccc.tipccc)
          from tt_ccc ccc
         where ccc.filfat = ven.codfil
           and ccc.seqfat = ven.sequen
           and ccc.status = 'F') as tipccc,
       VEN.FILCTA,
       VEN.SEQCTA,
       VEN.TIPCTA,
       VEN.TITAVU,
       VEN.CODAVU,
       VEN.FILVDP,
       VEN.CODVDP,
       VEN.CMSIND,
       VEN.FLGNFE,
       VEN.SEREXT,
       VEN.BASICM,
       VEN.VLRICM,
       VEN.VLRPIS,
       VEN.BASISS,
       VEN.VLRISS,
       VEN.VLRCSL,
       VEN.BASIRR,
       VEN.VLRIRR,
       VEN.OBSFIS,
       VEN.VLRCFI,
       VEN.VLR_ST_COM,
       VEN.BAS_ST_COM,
       VEN.CODCRT,
       VEN.VLRSAD,
       VEN.VLRIBP,
       VEN.CODFRE,
       VEN.FLGEXT,
       VEN.VLRFLX,
       VEN.NOTMAN,
       VEN.FILEST,
       VEN.SEQEST,
       VEN.IMPEST,
       VEN.ECFEST,
       VEN.TIPESP,
       VEN.MOTCAN,
       VEN.FILORI,
       VEN.SEQORI,
       VEN.VLRIBPFED,
       VEN.VLRIBPEST,
       VEN.VLRIBPMUN,
       VEN.CHVIBP,
       VEN.FONIBP,
       VEN.VLRSADCAN,
       VEN.MODNOT,
       VEN.EXPFIS,
       VEN.SATSER,
       VEN.SATCFE,
       VEN.EMAILC,
       VEN.TRN_ID,
       VEN.VLRADU,
       VEN.DOCIMP,
       VEN.TIPIMP,
       VEN.CHAVEA,
       VEN.RECIBO,
       VEN.NFRECI,
       VEN.PROAUT,
       VEN.DATAUT,
       VEN.PROCAN,
       VEN.DATCAN,
       VEN.NUMNFS,
       VEN.CHVCAN,
       VEN.SATCAN,
       VEN.SENAR,
       VEN.SEGRUR,
       VEN.FILCRE,
       VEN.SEQCRE,
       VEN.DESRAT,
       VEN.DESESP,
       VEN.DATINC,
       VEN.EXPEM4,
       VEN.EXT_EC,
       VEN.FILINT,
       VEN.CODINT,
       VEN.TIPINT,
       VEN.ID_INT,
       VEN.DESFID,
       VEN.FATFID,
       VEN.PONFID
  FROM TT_VEN VEN
 ;




/*-- SEQ 2530 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_VEN_FIS CASCADE;

/*-- SEQ 2531 --*/
CREATE OR REPLACE VIEW TV_VEN_FIS AS
   SELECT /*+RULE*/ *
     FROM (
      SELECT VEN.TIPTRO, VEN.CODFIL, VEN.SEQUEN, VEN.ATU_EM, VEN.COMSOB, VEN.CODVEN, ABS(VEN.VLRNOT) AS VLRNOT,
             ABS(VEN.VLRLIQ) AS VLRLIQ,VEN.DOCNFP,
             VEN.TIPNOT, VEN.FILVEN, VEN.FILUSU, VEN.FILPGT, VEN.FILCLI,
             CASE WHEN VEN.MODNOT = '59' THEN VEN.SATCFE ELSE (TO_NUMBER(VEN.NUMNOT)+0) END AS NUMNOT,
             VEN.NUMECF, VEN.FLGTIP, VEN.FLGEST, VEN.DATHOR, VEN.CODNAT, TRIM(FIS.SEREXP) AS CODSER,
             VEN.CODUSU, VEN.CODPGT, VEN.CODCLI, VEN.AUTENT, VEN.UFLOJA, VEN.TRIBUT, VEN.FINANC, VEN.EMIDES,
             VEN.CONSFI, VEN.FILPRE, VEN.CODPRE, VEN.ENDFAT, VEN.ENDENT, VEN.ENDCOB,
             ValoresComplementares(VEN.CODFIL, VEN.SEQUEN, 0,1) AS REDTOT, VEN.CNT_RO,
             ValoresComplementares(VEN.CODFIL, VEN.SEQUEN, VEN.VLRNOT,2) AS BASUBS,
             ValoresComplementares(VEN.CODFIL, VEN.SEQUEN, VEN.VLRNOT,3) AS SUBSTT,
             VEN.CODFIN, VEN.ESPECI, VEN.FILENT, VEN.FILGUI, VEN.DATFIS,
             ABS(COALESCE(VEN.VLRSEG,0)) AS VLRSEG, ABS(COALESCE(VEN.VLRFRE,0)) AS VLRFRE, ROUND(VEN.VLRFRE * CASE WHEN VEN.UFLOJA = 'T'
                                                             THEN COALESCE(FIL.FRDENT,0)
                                                             ELSE CASE WHEN CLI.FLGTIP = '0'
                                                                       THEN COALESCE(FIL.FRNAOC,0)
                                                                       ELSE COALESCE(FIL.FRCONT,0)
                                                                   END
                                                         END / 100,2) +
                                      TRUNC(VEN.VLRSEG * CASE WHEN VEN.UFLOJA = 'T'
                                                             THEN COALESCE(FIL.FRDENT,0)
                                                             ELSE CASE WHEN CLI.FLGTIP = '0'
                                                                       THEN COALESCE(FIL.FRNAOC,0)
                                                                       ELSE COALESCE(FIL.FRCONT,0)
                                                                   END
                                                         END / 100,2) AS ICMFRE,
             VEN.TIPTRA, VEN.SINAL, VEN.SIGNAT, VEN.SEQFAT, ABS(VEN.RETIDO) AS RETIDO,
             VEN.PROPGT, VEN.PRAMED, VEN.PESLIQ, VEN.PESBRU, VEN.PERENT, VEN.PERCOM, VEN.NUMVOL, VEN.NUMCON,
             CASE WHEN VEN.UFLOJA = 'T'
                  THEN COALESCE(FIL.FRDENT,0)
                  ELSE CASE WHEN CLI.FLGTIP = '0'
                            THEN COALESCE(FIL.FRNAOC,0)
                            ELSE COALESCE(FIL.FRCONT,0)
                        END
              END AS ALQFRE,
             VEN.NROIMP, VEN.FILTRA, VEN.FILFAT, VEN.FILCOB,
             CASE WHEN COALESCE(VEN.VLRNOT,0) <> 0 THEN ((VEN.VLRLIQ-COALESCE(VEN.VLRSEG,0)-COALESCE(VEN.OUTTAX,0)-COALESCE(VEN.VLRFRE,0)-VEN.VLRNOT)/VEN.VLRNOT*100) ELSE 0 END AS DESCON, -- 65150
             VEN.DATSAI, VEN.CODTRA, VEN.CODGUI,
             VEN.LANVEN, VEN.MARCAS, VEN.VINCUL, VEN.CODEXT, VEN.CODCTR, VEN.EXPORT, VEN.OBSERV,
             LPAD(COALESCE(FIS.MODNOT,'01'),2,'0') AS MODNOT, -- RFMP 75908
             CASE WHEN (SUBSTR(NAT.NATDEN,1,1) = '7') OR (SUBSTR(NAT.NATFOR,1,1) = '7') OR (COALESCE(CLI.ESTRAN,'F') = 'T')
                  THEN '00000000000000'
                  ELSE CASE WHEN (CFG.VC_FILCLI = CLI.FILCLI) AND (CFG.VC_CODCLI = CLI.CODCLI)
                            THEN '00000000000000' -- RFMP 73518
                            ELSE LPAD(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(COALESCE(LTRIM(RTRIM(COALESCE(COALESCE(ENDE.NUMDOC,CLI.NUMDOC),VIN.NUMDOC))),'0'),',',''),'.',''),'/',''),'-',''),' ',''),14,'0')
                        END
              END AS NUMDOC,
             RPAD(COALESCE(TRIM(REPLACE(REPLACE(REPLACE(REPLACE(COALESCE(CASE WHEN (CLI.FLGTIP = 0) AND (CFG.VC_FILCLI <> CLI.FILCLI) AND (CFG.VC_CODCLI <> CLI.CODCLI)
                                                                         THEN 'ISENTO'
                                                                         ELSE CASE WHEN (CFG.VC_FILCLI = CLI.FILCLI) AND (CFG.VC_CODCLI = CLI.CODCLI)
                                                                                   THEN 'ISENTO' -- RFMP 73518
                                                                                   ELSE CASE WHEN (CLI.FLGTIP = 0)
                                                                                             THEN 'ISENTO'
                                                                                             ELSE LTRIM(RTRIM(COALESCE(COALESCE(ENDE.INSEST,CLI.INSEST),VIN.INSEST)))
                                                                                         END
                                                                               END
                                                      END, ' '), ',', ''), '.', ''), '/', ''), '-', '')),'ISENTO'), 14, ' ') AS INSEST,
            CASE WHEN VEN.UFLOJA = 'T' THEN NAT.NATDEN ELSE NAT.NATFOR END AS NATURE,
            CASE WHEN (SUBSTR(NAT.NATDEN,1,1) = '7') OR (SUBSTR(NAT.NATFOR,1,1) = '7') OR (COALESCE(CLI.ESTRAN,'F') = 'T')
                 THEN 'EX'
                 ELSE COALESCE(ENDE.SIGEST,FIL.UFLOJA)
             END AS UFNOTA, VEN.AVISTA, ABS(COALESCE(VEN.OUTTAX,0)) AS OUTTAX,
            VEN.FUNRUR, VEN.SATSER, VEN.SATCFE, VEN.SENAR, VEN.SEGRUR, VEN.CHAVEA
       FROM TT_CFG CFG,
            TT_VEN VEN INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
                       INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                       INNER JOIN TT_FIS FIS ON FIS.CODSER = VEN.CODSER AND FIS.SUBSER = VEN.NUMECF
                  LEFT OUTER JOIN TT_CLI VIN ON VIN.FILCLI = CLI.FILVIN AND VIN.CODCLI = CLI.CODVIN
                  LEFT OUTER JOIN TT_END ENDE ON VEN.FILCLI  = ENDE.FILCLI AND VEN.CODCLI  = ENDE.CODCLI
                                             AND VEN.FILFAT  = ENDE.CODFIL AND VEN.ENDFAT  = ENDE.NUMEND
                       INNER JOIN TD_FIL FIL ON VEN.CODFIL  = FIL.CODFIL
      WHERE VEN.TIPTRO IN ('+','-','2')
        AND VEN.NUMNOT NOT LIKE '###%'
        AND FIS.ORIGEM    = 'V'
        AND FIS.EXPORT    = 'T'
        AND COALESCE(VEN.FUNRUR,0) = 0
) TAB
;


/*-- SEQ 2532 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_VEN_ROM CASCADE;

/*-- SEQ 2533 --*/
CREATE OR REPLACE VIEW TV_VEN_ROM AS
SELECT VEN.CODFIL,
       VEN.SEQUEN,
       REC.NUMPAR,
       REC.SUBPAR,
       REC.DATVEN,
       REC.VLRPAR,
       ROM.CODFIL AS FILROM,
       ROM.SEQUEN AS SEQROM,
       IRO.CODFIL AS FILIRO,
       IRO.SEQUEN AS SEQIRO,
       IRO.FILVEN AS FILVEN,
       IRO.SEQVEN AS SEQVEN,
       IRO.SEQCAN AS SEQCAN
  FROM TT_VEN VEN LEFT JOIN TT_REC REC ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
                  LEFT JOIN TT_IRO IRO ON IRO.FILVEN = VEN.CODFIL AND IRO.SEQVEN = VEN.SEQUEN
                  LEFT JOIN TT_ROM ROM ON ROM.CODFIL = IRO.CODFIL AND ROM.SEQUEN = IRO.SEQUEN
 WHERE (REC.FLGEST IN ('A','P') OR REC.FLGEST IS NULL)
   AND ((SELECT COUNT(*)
          FROM TT_VEN X1 INNER JOIN TT_IVE X2 ON X1.CODFIL = X2.CODFIL AND X1.SEQUEN = X2.SEQUEN
                          LEFT JOIN TT_IOR X3 ON X3.FILIVE = X2.CODFIL AND X3.SEQIVE = X2.SEQUEN AND X3.NUMIVE = X2.NUMITE
         WHERE (X3.TIPENT IN ('2','3') OR X3.TIPENT IS NULL)
           AND X1.CODFIL = VEN.CODFIL
           AND X1.SEQUEN = VEN.SEQUEN) > 0 OR ROM.CODFIL IS NOT NULL)
;


/*-- SEQ 2534 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_VPE_CP CASCADE;

/*-- SEQ 2535 --*/
CREATE OR REPLACE VIEW TV_VPE_CP AS
SELECT tt_vpe.codfil, tt_vpe.filcli, tt_vpe.codcli, 
       tt_vpe.status, tt_vpe.datvpe, tt_vpe.codctr, 
       tt_vpe.filvdd, tt_vpe.codvdd 
  FROM tt_vpe 
 GROUP BY tt_vpe.codfil, tt_vpe.filcli, tt_vpe.codcli, 
          tt_vpe.status, tt_vpe.datvpe, tt_vpe.codctr, 
          tt_vpe.filvdd, tt_vpe.codvdd
;


/*-- SEQ 2536 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_VSI CASCADE;

/*-- SEQ 2537 --*/
CREATE OR REPLACE VIEW TV_VSI AS
/* TT_FIS SEM SRIE DE EXPORTAO CONFIGURADA */
SELECT ORIGEM AS TIPREG,
       NULL AS CODFIL, CODSER, SUBSER AS NUMECF, TO_CHAR('') AS NUMNOT, TO_DATE(NULL,'DD/MM/YYYY HH24:MI:SS') AS DATOPE,
       'Coluna "Srie Como" da tela de Sries Fiscais no foi informada' AS VALIDA 
  FROM TT_FIS
 WHERE EXPORT = 'T'
   AND (SEREXP IS NULL OR TRIM(SEREXP) = '')
UNION ALL
/* FILIAL SEM RESPONSVEL INFORMADO */
SELECT TO_CHAR('T') AS TIPREG, 
       FIL.CODFIL, TO_CHAR('') AS CODSER, TO_CHAR('') AS NUMECF, TO_CHAR('') AS NUMNOT, NULL AS DATOPE,
       'Responsvel pelas informaes no informado: Informe o responsvel pelas informaes no cadastro de filiais' AS VALIDA
  FROM TD_FIL FIL
 WHERE FIL.RESPON IS NULL
UNION ALL
/* CLIENTE SEM CNPJ/CPF OU INSCRIO ESTADUAL INFORMADOS */
SELECT TO_CHAR('V') AS TIPREG, 
       VEN.CODFIL, VEN.CODSER, VEN.NUMECF, VEN.NUMNOT, VEN.DATHOR,
       'O cliente '||CASE CLI.FLGTIP WHEN 0 THEN CLI.NOMCLI || ' ' || COALESCE(CLI.ULTNOM,'')
                                           ELSE CLI.NOMCLI || '/' || COALESCE(CLI.ULTNOM,'')
                     END||' ('||VEN.FILCLI||'/'||TRIM(VEN.CODCLI)||')'||' no possui CNPJ/CPF ou Inscrio Estadual informada'
  FROM TT_CFG CFG,
       TT_VEN VEN INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                   LEFT JOIN TT_END ENDE ON ENDE.FILCLI = CLI.FILCLI AND ENDE.CODCLI = CLI.CODCLI
                                        AND ENDE.CODFIL = VEN.FILENT AND ENDE.NUMEND = VEN.ENDENT,
       (SELECT SUBSER AS NUMECF FROM TT_FIS WHERE CODSER =  'CF'  AND ORIGEM =  'V'  AND EXPORT =  'T' ) FIS
WHERE (COALESCE(COALESCE(ENDE.NUMDOC,CLI.NUMDOC),'##############') = '##############'
   OR  COALESCE(CASE WHEN CLI.FLGTIP = 0 THEN 'ISENTO' ELSE COALESCE(ENDE.INSEST,CLI.INSEST) END,'##############') = '##############')
  AND VEN.FLGEST <> 'C'
  AND VEN.NUMECF = FIS.NUMECF
  AND VEN.FILCLI <> CFG.VC_FILCLI
  AND VEN.CODCLI <> CFG.VC_CODCLI
UNION ALL
/* CLIENTE COM CNPJ/CPF INVLIDO */
SELECT TO_CHAR('V') AS TIPREG, 
       VEN.CODFIL, VEN.CODSER, VEN.NUMECF, VEN.NUMNOT, VEN.DATHOR,
       'O cliente '||CASE CLI.FLGTIP WHEN 0 THEN CLI.NOMCLI || ' ' || COALESCE(CLI.ULTNOM,'')
                                            ELSE CLI.NOMCLI || '/' || COALESCE(CLI.ULTNOM,'')
                     END||' ('||VEN.FILCLI||'/'||TRIM(VEN.CODCLI)||')'||' possui CNPJ/CPF invlido: '||COALESCE(ENDE.NUMDOC,CLI.NUMDOC)
  FROM TT_CFG CFG,
       TT_VEN VEN INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                   LEFT JOIN TT_END ENDE ON ENDE.FILCLI = CLI.FILCLI AND ENDE.CODCLI = CLI.CODCLI
                                        AND ENDE.CODFIL = VEN.FILENT AND ENDE.NUMEND = VEN.ENDENT,
       (SELECT SUBSER AS NUMECF FROM TT_FIS WHERE CODSER =  'CF'  AND ORIGEM =  'V'  AND EXPORT =  'T' ) FIS
WHERE CASE WHEN CLI.FLGTIP = 0 THEN CheckCPF(COALESCE(ENDE.NUMDOC,CLI.NUMDOC)) 
                               ELSE CheckCGC(COALESCE(ENDE.NUMDOC,CLI.NUMDOC))
      END <> 1
  AND COALESCE(COALESCE(ENDE.NUMDOC,CLI.NUMDOC),'##############') <> '##############'
  AND VEN.FLGEST <> 'C'
  AND VEN.NUMECF = FIS.NUMECF
  AND VEN.FILCLI <> CFG.VC_FILCLI
  AND VEN.CODCLI <> CFG.VC_CODCLI
UNION ALL
/* FORNECEDOR SEM CNPJ/CPF OU INSCRIO ESTADUAL INFORMADOS */
SELECT CASE WHEN COM.TIPPAR = 'T' 
            THEN TO_CHAR('F') 
            ELSE TO_CHAR('C') 
       END AS TIPREG,
       COM.CODFIL, COM.CODSER, COM.SUBSER, COM.NUMNOT, COM.DATOPE,
       'O fornecedor/transportadora '||CASE CLI.FLGTIP WHEN 0 THEN CLI.NOMCLI || ' ' || CLI.ULTNOM
                                               ELSE CLI.NOMCLI || '/' || CLI.ULTNOM
                         END||' ('||COM.FILFOR||'/'||TRIM(COM.CODFOR)||')'||' no possui CNPJ/CPF ou Inscrio Estadual informada'
  FROM (SELECT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT
          FROM TT_FIS
         WHERE ORIGEM = 'C'
           AND EXPORT = 'T') FIS INNER JOIN TV_CMP COM ON FIS.CODSER = COM.CODSER AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$')
                                 INNER JOIN TT_CLI CLI ON CLI.FILCLI = COM.FILFOR AND CLI.CODCLI = COM.CODFOR
                                  LEFT JOIN TT_END ENDE ON ENDE.FILCLI = CLI.FILCLI AND ENDE.CODCLI = CLI.CODCLI
                                                       AND ENDE.CODFIL = COM.FILEND AND ENDE.NUMEND = COM.NUMEND
WHERE (COALESCE(COALESCE(ENDE.NUMDOC,CLI.NUMDOC),'##############') = '##############'
   OR  COALESCE(COALESCE(ENDE.INSEST,CLI.INSEST),'##############') = '##############')
  AND COM.FLGEST <> 'D'
  AND COM.CODFOR <> '     0'
UNION ALL
/* FORNECEDOR COM CNPJ/CPF INVLIDO */
SELECT CASE WHEN COM.TIPPAR = 'T' 
            THEN TO_CHAR('F') 
            ELSE TO_CHAR('C') 
       END AS TIPREG,
       COM.CODFIL, COM.CODSER, COM.SUBSER, COM.NUMNOT, COM.DATOPE,
       'O fornecedor/transportadora '||CASE CLI.FLGTIP WHEN 0 THEN CLI.NOMCLI || ' ' || CLI.ULTNOM
                                               ELSE CLI.NOMCLI || '/' || CLI.ULTNOM
                         END||' ('||COM.FILFOR||'/'||TRIM(COM.CODFOR)||')'||' possui CNPJ/CPF invlido: '||COALESCE(ENDE.NUMDOC,CLI.NUMDOC)
  FROM (SELECT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT
          FROM TT_FIS
         WHERE ORIGEM = 'C'
           AND EXPORT = 'T') FIS INNER JOIN TV_CMP COM ON FIS.CODSER = COM.CODSER AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$')
                                 INNER JOIN TT_CLI CLI ON CLI.FILCLI = COM.FILFOR AND CLI.CODCLI = COM.CODFOR
                                  LEFT JOIN TT_END ENDE ON ENDE.FILCLI = CLI.FILCLI AND ENDE.CODCLI = CLI.CODCLI
                                                       AND ENDE.CODFIL = COM.FILEND AND ENDE.NUMEND = COM.NUMEND
WHERE CASE WHEN CLI.FLGTIP = 0 THEN CheckCPF(COALESCE(ENDE.NUMDOC,CLI.NUMDOC)) 
                               ELSE CheckCGC(COALESCE(ENDE.NUMDOC,CLI.NUMDOC))
      END <> 1
  AND COALESCE(COALESCE(ENDE.NUMDOC,CLI.NUMDOC),'##############') <> '##############'
  AND COM.FLGEST <> 'D'
  AND COM.CODFOR <> '     0'
UNION ALL
/* VENDA SEM QUE O DIA ESTEJA FECHADO */
SELECT TO_CHAR('V') AS TIPREG, 
       ECF.CODFIL, ECF.CODSER, ECF.NUMECF, 'Cupons entre: '||COALESCE(TO_CHAR(ECF.CUPINI),'No informado')||' e '||COALESCE(TO_CHAR(ECF.CUPFIM),'No informado'), ECF.DATOPE,
       TO_CHAR('O dia no foi fechado para este ECF') AS VALIDA
  FROM TR_ECF ECF
 WHERE ECF.DIAFEC IS NULL
UNION ALL
/* COMPROMISSO SEM CFOP INFORMADO */
SELECT TO_CHAR('C') AS TIPREG, 
       COM.CODFIL, COM.CODSER, COM.SUBSER, COM.NUMNOT, COM.DATOPE,
       'O compromisso '||COALESCE(TRIM(COM.CODSER),'')||'-'||
                         CASE WHEN COM.SUBSER IS NOT NULL 
                              THEN COALESCE(COM.SUBSER,'')||'-'
                              ELSE ''
                         END|| 
                         COALESCE(TRIM(COM.NUMNOT),'')||' da filial '||COM.CODFIL||' no possui CFOP informado'
  FROM (SELECT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT
          FROM TT_FIS
         WHERE ORIGEM = 'C'
           AND EXPORT = 'T') FIS INNER JOIN TV_CMP COM ON FIS.CODSER = COM.CODSER AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$')
                                 INNER JOIN TT_CLI CLI ON CLI.FILCLI = COM.FILFOR AND CLI.CODCLI = COM.CODFOR
                                  LEFT JOIN TT_END ENDE ON ENDE.FILCLI = CLI.FILCLI AND ENDE.CODCLI = CLI.CODCLI
                                                       AND ENDE.CODFIL = COM.FILEND AND ENDE.NUMEND = COM.NUMEND
WHERE (COALESCE(COALESCE(ENDE.NUMDOC,CLI.NUMDOC),'##############') = '##############'
   OR  COALESCE(COALESCE(ENDE.INSEST,CLI.INSEST),'##############') = '##############')
  AND COM.FLGEST <> 'D'
  AND COM.CODFOR <> '     0'
  AND COM.CODCFO IS NULL
  AND (SELECT COUNT(*)
         FROM TT_ICO ICO
        WHERE ICO.CODFIL = COM.CODFIL
          AND ICO.SEQUEN = COM.SEQUEN) = 0
UNION ALL
/* SRIE NUMRICA COM MODELO DE NOTA DIFERENTE DE 01 */
SELECT FIS.ORIGEM AS TIPREG, 
       NULL AS CODFIL, FIS.CODSER AS CODSER, TO_CHAR('') AS NUMECF, TO_CHAR('') AS NUMNOT, NULL AS DATOPE,
       'Srie '||FIS.CODSER||' sub-srie '||LPad(COALESCE(FIS.SUBSER,''),2,' ')||'  numrica por isso deve ter modelo 01' AS VALIDA
  FROM TT_FIS FIS
 WHERE FIS.EXPORT = 'T'  
   AND IsDigit(TRIM(FIS.CODSER)) > 0
   AND LPad(TRIM(COALESCE(FIS.MODNOT,'')),2,'0') <> '01'
UNION ALL
/* FRETES QUE POSSUEM SRIE NUMRICA */
SELECT TO_CHAR('F') AS TIPREG, 
       COM.CODFIL, COM.CODSER, COM.SUBSER, COM.NUMNOT, COM.DATOPE,
       'Nota de conhecimento de frete '||' ('||COM.FILFOR||'/'||TRIM(COM.CODFOR)||') '||
               COALESCE(TRIM(COM.CODSER),'')||'-'||CASE WHEN COM.SUBSER IS NOT NULL 
                                                        THEN COALESCE(COM.SUBSER,'')||'-'
                                                        ELSE ''
                                                   END||COALESCE(TRIM(COM.NUMNOT),'')||' no pode ser exportada como uma srie numrica (entre 1 e 99). Srie exportada como: '||TRIM(FIS.SEREXP)
  FROM (SELECT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT
          FROM TT_FIS
         WHERE ORIGEM = 'F'
           AND EXPORT = 'T') FIS INNER JOIN TV_CMP COM ON FIS.CODSER = COM.CODSER AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$')
WHERE COM.FLGEST <> 'D'
  AND COM.CODFOR <> '     0'
  AND COM.TIPPAR = 'T' 
  AND NOT EXISTS (SELECT 1
                    FROM TT_ICO ICO
                   WHERE ICO.CODFIL = COM.CODFIL
                     AND ICO.SEQUEN = COM.SEQUEN)
  AND IsDigit(TRIM(FIS.SEREXP)) >= 1
UNION ALL
/* COMPROMISSOS E FRETES QUE NO BATEM NO CLCULO DA BASE ICMS COM O VALOR LQUIDO */
SELECT CASE WHEN COM.TIPPAR = 'T' 
            THEN TO_CHAR('F') 
            ELSE TO_CHAR('C') 
       END AS TIPREG, 
       COM.CODFIL, COM.CODSER, COM.SUBSER, COM.NUMNOT, COM.DATOPE,
       'Documento possui diferena entre ICMS (Base + Isento + Outros) e o Valor Lquido'
  FROM (SELECT DISTINCT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT, ORIGEM
          FROM TT_FIS
         WHERE ORIGEM IN ('C','F')
           AND EXPORT = 'T') FIS INNER JOIN TV_CMP COM ON FIS.CODSER = COM.CODSER 
                                                      AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$')
                                                      AND FIS.ORIGEM = CASE WHEN COALESCE(COM.TIPPAR,'F') = 'T' THEN 'F' ELSE 'C' END
WHERE COM.FLGEST <> 'D'
  AND COM.CODFOR <> '     0'
  AND ROUND(CASE WHEN COM.PERICM > 0 THEN ROUND(((COM.VLRICM * 100) / COM.PERICM),2) ELSE 0 END 
            + COALESCE(COM.ISEICM,0) 
            + COALESCE(COM.OUTICM,0),2) <> ROUND(COM.VLRLIQ,2)
  AND NOT EXISTS (SELECT 1
                    FROM TT_ICO ICO
                   WHERE ICO.CODFIL = COM.CODFIL
                     AND ICO.SEQUEN = COM.SEQUEN)
UNION ALL
/* ITENS DE COMPRA QUE NO BATEM NO CLCULO DA BASE ICMS COM O VALOR DO ITEM + IMPOSTOS */
SELECT TO_CHAR('C') AS TIPREG, 
       COM.CODFIL, COM.CODSER, COM.SUBSER, COM.NUMNOT, COM.DATOPE,
       'O item '||ICO.NUMITE||' possui diferena entre ICMS (Base + Isento + Outros) e o Valor (com incidncia de Substituio Tributria, Outras Taxas, Frete, Desc/Acrscimo e Bonificao)'
  FROM (SELECT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT
          FROM TT_FIS
         WHERE ORIGEM = 'C'
           AND EXPORT = 'T') FIS INNER JOIN TV_CMP COM ON FIS.CODSER = COM.CODSER AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$')
                                 INNER JOIN TT_ICO ICO ON COM.CODFIL = ICO.CODFIL AND COM.SEQUEN = ICO.SEQUEN
WHERE COM.FLGEST <> 'D'
  AND COM.CODFOR <> '     0'
  AND ICO.VLRMOV > 0
  AND ROUND(ICO.BASICMDIF+ICO.ISEICM+ICO.OUTICM,1) <> -- RFMP 65377 mesma validacao do registro de compras, com tolerancia para arredondamento
      ROUND((((COM.VLRLIQ
               - COM.VLRIPI
               - COM.VLRNOT)
                 / NVLZ(COM.VLRNOT, (SELECT SUM(ICO.VLRMOV) FROM TT_ICO ICO WHERE COM.CODFIL = ICO.CODFIL AND COM.SEQUEN = ICO.SEQUEN)))
                   * ICO.VLRMOV) + ICO.VLRMOV,1)
UNION ALL
/* COMPROMISSOS, FRETES (E POSSIVELMENTE ITENS DE COMPRA) COM NATUREZA 1933/2933 DE SERVIOS COM SRIE NUMRICA */ 
SELECT CASE WHEN COM.TIPPAR = 'T' 
            THEN TO_CHAR('F') 
            ELSE TO_CHAR('C') 
       END AS TIPREG, 
       COM.CODFIL, COM.CODSER, COM.SUBSER, COM.NUMNOT, COM.DATOPE,       
       CASE WHEN ICO.NUMITE IS NULL 
            THEN 'Documento possui natureza '||CF1.CODCFO||' e srie numrica (entre 1 e 99)'
            ELSE 'O item '||ICO.NUMITE||' possui natureza '||CF2.CODCFO||' e srie numrica (entre 1 e 99)'  
       END
  FROM (SELECT DISTINCT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT, ORIGEM
          FROM TT_FIS
         WHERE ORIGEM IN ('C','F')
           AND EXPORT = 'T') FIS INNER JOIN TV_CMP COM ON FIS.CODSER = COM.CODSER 
                                                      AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$')
                                                      AND FIS.ORIGEM = CASE WHEN COALESCE(COM.TIPPAR,'F') = 'T' THEN 'F' ELSE 'C' END
                                 INNER JOIN TD_CFO CF1 ON CF1.CODTAB = COM.CODCFO
                                  LEFT JOIN TT_ICO ICO ON COM.CODFIL = ICO.CODFIL AND COM.SEQUEN = ICO.SEQUEN
                                  LEFT JOIN TD_CFO CF2 ON CF2.CODTAB = ICO.CODCFO
WHERE COM.FLGEST <> 'D'
  AND COM.CODFOR <> '     0'
  AND COALESCE(CF2.CODCFO,CF1.CODCFO) IN ('1933','2933')
  AND IsDigit(TRIM(COM.CODSER)) >= 1
UNION ALL
/* ITENS DE COMPRA SUBSTITUDOS SEM VALOR EM OUTROS ICMS */
SELECT TO_CHAR('C') AS TIPREG, 
       COM.CODFIL, COM.CODSER, COM.SUBSER, COM.NUMNOT, COM.DATOPE,
      'O item '||ICO.NUMITE||'  substitudo porm no tem valor em Outros ICMS'
  FROM (SELECT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT
          FROM TT_FIS
         WHERE ORIGEM = 'C'
           AND EXPORT = 'T') FIS INNER JOIN TV_CMP COM ON FIS.CODSER = COM.CODSER AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$')
                                 INNER JOIN TT_ICO ICO ON COM.CODFIL = ICO.CODFIL AND COM.SEQUEN = ICO.SEQUEN
WHERE COM.FLGEST <> 'D'
  AND COM.CODFOR <> '     0'
  AND ICO.ICMTIP = '3'
  AND COALESCE(ICO.OUTICM,0) = 0
UNION ALL
/* ITENS DE COMPRA ISENTO/NO TRIBUTADOS SEM VALOR EM ISENTO ICMS */
SELECT TO_CHAR('C') AS TIPREG, 
       COM.CODFIL, COM.CODSER, COM.SUBSER, COM.NUMNOT, COM.DATOPE,
      'O item '||ICO.NUMITE||'  Isento/No Tributado porm no tem valor em Isento ICMS'
  FROM (SELECT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT
          FROM TT_FIS
         WHERE ORIGEM = 'C'
           AND EXPORT = 'T') FIS INNER JOIN TV_CMP COM ON FIS.CODSER = COM.CODSER AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$')
                                 INNER JOIN TT_ICO ICO ON COM.CODFIL = ICO.CODFIL AND COM.SEQUEN = ICO.SEQUEN
WHERE COM.FLGEST <> 'D'
  AND COM.CODFOR <> '     0'
  AND ICO.ICMTIP IN ('1','2','4')
  AND COALESCE(ICO.ISEICM,0) = 0
UNION ALL
/* ITENS DE COMPRA TRIBUTADOS SEM VALOR EM BASE ICMS */
SELECT TO_CHAR('C') AS TIPREG, 
       COM.CODFIL, COM.CODSER, COM.SUBSER, COM.NUMNOT, COM.DATOPE,
      'O item '||ICO.NUMITE||'  Tributado porm no tem valor em Base ICMS'
  FROM (SELECT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT
          FROM TT_FIS
         WHERE ORIGEM = 'C'
           AND EXPORT = 'T') FIS INNER JOIN TV_CMP COM ON FIS.CODSER = COM.CODSER AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$')
                                 INNER JOIN TT_ICO ICO ON COM.CODFIL = ICO.CODFIL AND COM.SEQUEN = ICO.SEQUEN
WHERE COM.FLGEST <> 'D'
  AND COM.CODFOR <> '     0'
  AND ICO.ICMTIP = '0'
  AND COALESCE(ICO.BASICMDIF,0) = 0
;


/*-- SEQ 2538 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_VXP CASCADE;

/*-- SEQ 2539 --*/
CREATE OR REPLACE VIEW TV_VXP AS
SELECT VEN.CODFIL,
       FIL.NOMFIL AS FILIAL,
       VEN.CODSER,
       COALESCE(VXP.PLACAS,'-X-') AS PLACAS,
       VEN.DATHOR,
       VEN.FILCLI,
       VEN.CODCLI,
       COALESCE(MOT.NOMCLI,'-X-') AS NOMMOT,
       CLI.NUMDOC,
       VEN.VLRLIQ,
       Combustiveis(VEN.CODFIL,VEN.SEQUEN) AS QTDLIT,
       COALESCE(VXP.ORIGEM,'-X-') AS ORIGEM,
       COALESCE(VXP.DESTIN,'-X-') AS DESTIN,
       COALESCE(VXP.QTD_KM,0) AS QTD_KM,
       COALESCE(VEN.NUMECF,'')||'-'||COALESCE(RTRIM(LTRIM(VEN.CODSER)),'')||'/'||COALESCE(RTRIM(LTRIM(VEN.NUMNOT)),'') AS DOCUME,
       COALESCE(VXP.OBSERV,'   ') AS OBSERV,
       VXP.FILMOT,
       VXP.CODMOT, FAT.NUMNOT
FROM TT_CLI CLI INNER JOIN TT_VEN VEN ON VEN.FILCLI = CLI.FILCLI AND VEN.CODCLI = CLI.CODCLI
                INNER JOIN TD_FIL FIL ON VEN.CODFIL = FIL.CODFIL                
           LEFT OUTER JOIN TT_VXP VXP ON VXP.CODFIL = VEN.CODFIL AND VXP.SEQUEN = VEN.SEQUEN
           LEFT OUTER JOIN TT_CLI MOT ON MOT.FILCLI = VXP.FILMOT AND MOT.CODCLI = VXP.CODMOT
           LEFT OUTER JOIN TT_VEN FAT ON FAT.CODFIL = VEN.CODFIL AND FAT.SEQUEN = VEN.SEQFAT
WHERE VEN.CODSER in ('CF', 'TK')
  AND VEN.FLGEST <> 'C'  
 ;





/*-- SEQ 2540 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_WEB_CPM CASCADE;

/*-- SEQ 2541 --*/
CREATE OR REPLACE VIEW TV_WEB_CPM AS
SELECT TAB.REFPRO, /* CODIGO DO PRODUTO */
       TAB.REFBAS, /* REFERENCIA BASICA DO PRODUTO */
       TAB.CHAVEPRO, /* CHAVE DO PRODUTO */
       TAB.CHAVEPRE, /* CHAVE DA TABELA DE PREÇO */
       TAB.SEQUEN,
       TAB.PREPMC_AVISTA, /* PRECO PROMOCIONAL A VISTA */
       TAB.PREPMC_APRAZO  /* PRECO PROMOCIONAL A PRAZO */
  FROM (
        SELECT GRA.REFPRO,
               PRO.REFBAS,
               CAST(GRA.FILMAT||GRA.SEQUEN AS CHAR(13)) AS CHAVEPRO,
               CAST(PRE.FILPRE||LPAD(TO_CHAR(PRE.CODPRE),10,'0') AS CHAR(13)) AS CHAVEPRE,
               CAST(GRA.FILMAT||GRA.CODMAT AS CHAR(13)) AS SEQUEN,
               SUM(SUB.PREPMC_AVISTA) AS PREPMC_AVISTA,
               SUM(SUB.PREPMC_APRAZO) AS PREPMC_APRAZO
          FROM (
                SELECT CPM.FILPRE,
                       CPM.SEQPRE,
                       MIN(CPM.PRECOP) AS PREPMC_AVISTA,
                       0 AS PREPMC_APRAZO
                  FROM TT_CPM CPM INNER JOIN TT_PLA PLA ON PLA.FILPGT = CPM.FILPGT
                                                       AND PLA.CODPGT = CPM.CODPGT
                 WHERE CPM.DATVAL >= TRUNC(AGORA())
                   AND COALESCE(CPM.DATINI,TO_DATE('01/01/2000','DD/MM/YYYY')) <= TRUNC(AGORA())
                   AND PLA.PARIDE = 1
                   AND PLA.SIGNAT >= 0
                   AND PLA.APLICA = 5
                 GROUP BY CPM.FILPRE, CPM.SEQPRE
                UNION ALL
                SELECT CPM.FILPRE,
                       CPM.SEQPRE,
                       0 AS PREPMC_AVISTA,
                       MIN(CPM.PRECOP) AS PREPMC_APRAZO
                  FROM TT_CPM CPM LEFT JOIN TT_PLA PLA ON PLA.FILPGT = CPM.FILPGT
                                                      AND PLA.CODPGT = CPM.CODPGT
                 WHERE CPM.DATVAL >= TRUNC(AGORA())
                   AND COALESCE(CPM.DATINI,TO_DATE('01/01/2000','DD/MM/YYYY')) <= TRUNC(AGORA())
                   AND ((PLA.FILPGT IS NULL) OR (PLA.PARIDE > 1 AND PLA.DE1IDE = 0 AND PLA.SIGNAT >= 0))
                   AND ((PLA.APLICA IS NULL) OR (PLA.APLICA = 5))
                 GROUP BY CPM.FILPRE, CPM.SEQPRE
        ) SUB INNER JOIN TT_PRE PRE ON PRE.FILPRE = SUB.FILPRE
                                   AND PRE.SEQUEN = SUB.SEQPRE
              INNER JOIN TT_GRA GRA ON GRA.FILMAT = PRE.FILMAT
                                   AND GRA.CODMAT = PRE.CODMAT
                                   AND GRA.CODCOR = PRE.CODCOR
                                   AND GRA.CODTAM = PRE.CODTAM
              INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT
                                   AND PRO.CODMAT = GRA.CODMAT
              INNER JOIN TD_DEP DEP  ON DEP.CODTAB  = PRO.DEPART
              INNER JOIN TD_CL1 CL1  ON CL1.CODTAB  = PRO.CLASS1
              INNER JOIN TD_CL2 CL2  ON CL2.CODTAB  = PRO.CLASS2
              INNER JOIN TD_CL3 CL3  ON CL3.CODTAB  = PRO.CLASS3
              INNER JOIN TD_CL4 CL4  ON CL4.CODTAB  = PRO.CLASS4
              INNER JOIN TD_MOE MOE ON MOE.CODTAB   = PRE.CODMOE
        WHERE 1=1
          --AND (CL1.CL1WEB='T' OR CL2.CL2WEB='T' OR CL3.CL3WEB='T' OR CL4.CL4WEB='T' OR DEP.DEPWEB='T')
          --AND PRO.SIGNAT >= 0
          AND CASE WHEN GRA.ENVECO = 'T' THEN 'T'
                   ELSE
                        CASE WHEN ((CL1.CL1WEB='T' OR CL2.CL2WEB='T' OR CL3.CL3WEB='T' OR CL4.CL4WEB='T' OR DEP.DEPWEB='T')
                              AND PRO.SIGNAT >= 0
                              AND GRA.GRAATI='T') THEN 'T'
                        ELSE 'F'
                        END
              END  = 'T'
        GROUP BY GRA.REFPRO, PRO.REFBAS, GRA.FILMAT||GRA.SEQUEN,PRE.FILPRE||LPAD(TO_CHAR(PRE.CODPRE),10,'0'), CAST(GRA.FILMAT||GRA.CODMAT AS CHAR(13))
) TAB
;




-- Autor: Pedro E. Braga
-- Cliente(s): ATACADAO DO PAPEL EIRELI
 
-- Finalidade(s):
-- 1) Gerar relatrio de crdito e estorno de ICMS - Projeto: DES-107 - DES-134
/*-- SEQ 2542 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CRE_EST_ICMS CASCADE;

/*-- SEQ 2543 --*/
CREATE OR REPLACE VIEW TV_CRE_EST_ICMS AS
SELECT 
       -- Nota de Vendas
       TAB.*,
       -- Nota de Transferncia
       TRA.CODFIL AS TRA_CODFIL, TRA.SEQUEN AS TRA_SEQUEN, TRA.NUMECF AS TRA_NUMECF, TRA.CODSER AS TRA_CODSER, TRA.NUMNOT AS TRA_NUMNOT, TRA.MODNOT AS TRA_MODNOT, 
       TRA.FILCLI AS TRA_FILCLI, TRA.CODCLI AS TRA_CODCLI, TRA.CHAVEA AS TRA_CHAVEA, TRA.DATHOR AS TRA_DATHOR, TRA.DATFIS AS TRA_DATFIS, TRA.VLRNOT AS TRA_VLRNOT, TRA.VLRLIQ AS TRA_VLRLIQ,
       TRAIVE.VLRICM_CRE, -- Valor do crdito de ICMS na nota de transferncia
       TRAIVE.VLRICM_EST, -- Estorno do crdito de ICMS na nota de transferncia
       TRAIVE.VLRICM_COM AS TRAIVE_VLRICM_COM, TRAIVE.BAS_ST_COM AS TRAIVE_BAS_ST_COM, TRAIVE.VLR_ST_COM AS TRAIVE_VLR_ST_COM, 
       TRAIVE.QTDMOV AS TRAIVE_QTDMOV, TRAIVE.VLRMOV AS TRAIVE_VLRMOV
  FROM (SELECT TABVEN.*,
               -- Chave da ltima transferncia antes da venda
               CAST(LPAD(split_part_null(TABVEN.ULTTRANF, ';', 1), 3, '0') AS CHAR(3)) AS ULTTRA_CODFIL,
               CAST(LPAD(split_part_null(TABVEN.ULTTRANF, ';', 2), 10, ' ') AS VARCHAR(10)) AS ULTTRA_SEQUEN,
               CAST(Split_Part_Number(TABVEN.ULTTRANF, ';', 3) AS Numeric(5)) AS ULTTRA_NUMITE,
               -- % ICMS da ltima compra na filial de origem da transferncia
               CAST(ROUND(TO_NUMBER(split_part_null(TABVEN.ULTTRANF, ';', 4), '999.9999'), 4) AS Numeric(7,4)) AS PERICM_ULT_COM_ANT_TRA 
          FROM ( SELECT IVE.CODFIL AS IVE_CODFIL, IVE.SEQUEN AS IVE_SEQUEN, IVE.FILMAT AS IVE_FILMAT, IVE.CODMAT AS IVE_CODMAT, IVE.CODCOR AS IVE_CODCOR, IVE.CODTAM AS IVE_CODTAM, IVE.QTDMOV AS IVE_QTDMOV, 
                        IVE.VLRMOV AS IVE_VLRMOV, IVE.ICMTIP AS IVE_ICMTIP, IVE.TAXICM AS IVE_TAXICM, IVE.TAX001 AS IVE_TAX001, IVE.TAX002 AS IVE_TAX002, IVE.REDITE AS IVE_REDITE, IVE.VEN_DATHOR AS IVE_DATHOR,
                        IVE.CODCST AS IVE_CODCST, CAST(ROUND(IVE.TAXICM - (IVE.TAXICM * (IVE.REDITE / 100)), 2) AS Numeric(5,2)) AS IVE_ICMRED,
                        -- Nota de Venda
                        VEN.CODFIL AS VEN_CODFIL, VEN.SEQUEN AS VEN_SEQUEN, VEN.NUMECF AS VEN_NUMECF, VEN.CODSER AS VEN_CODSER, VEN.NUMNOT AS VEN_NUMNOT, VEN.MODNOT AS VEN_MODNOT, 
                        VEN.FILCLI AS VEN_FILCLI, VEN.CODCLI AS VEN_CODCLI, VEN.CHAVEA AS VEN_CHAVEA, VEN.DATHOR AS VEN_DATHOR, VEN.DATFIS AS VEN_DATFIS, VEN.VLRNOT AS VEN_VLRNOT, VEN.VLRLIQ AS VEN_VLRLIQ,
                        -- Traz a "chave da ltima transferncia antes da venda" e "% ICMS da ltima compra na filial de origem da transferncia"
                        ULTIMAENTRADADETRANSFERENCIA(IVE.CODFIL, IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM, IVE.VEN_DATHOR) AS ULTTRANF
                   FROM TT_IVE IVE 
                   JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN -- Nota de Venda
                   --JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
                  WHERE VEN.FLGEST <> 'C'         AND VEN.LANVEN = 'T'
                    AND VEN.NUMNOT NOT LIKE '%#%' AND IVE.LANEST IN ('S','R')
                    AND IVE.SITMOV <> 'C'         AND IVE.SITKIT <> '1'
                    --AND DNAT.TIPNAT NOT IN ('E', 'R', 'S') --E - Entrada via Transferncia; S - Sada via Transferncia; R - Devolucao de Transferencia
                ) TABVEN
       ) TAB
  -- Nota de Transferncia
  JOIN TT_VEN TRA ON TRA.CODFIL =  TAB.ULTTRA_CODFIL  AND TRA.SEQUEN = TAB.ULTTRA_SEQUEN
  JOIN TT_IVE TRAIVE ON TRAIVE.CODFIL = TAB.ULTTRA_CODFIL AND TRAIVE.SEQUEN = TAB.ULTTRA_SEQUEN AND TRAIVE.NUMITE = TAB.ULTTRA_NUMITE
;


-- Autor: Gabriel Felipe Schaefer
-- Cliente(s): CARNEIRO CASA & CONSTRUCAO LTDA
-- Finalidade(s):
-- 1) 97571 - Saber o que foi pago como conta corrente.
/*-- SEQ 2544 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_DOP_CCC CASCADE;

/*-- SEQ 2545 --*/
CREATE OR REPLACE VIEW TV_DOP_CCC AS
 SELECT DOP.NUMDOC, SUM(DOP.VLRDOC) AS VLRCCC
   FROM TT_DOP DOP
  WHERE DOP.DOMDOP = 1
  GROUP BY DOP.NUMDOC
;


-- Autor: Gabriel Felipe Schaefer
-- Cliente(s): CARNEIRO CASA & CONSTRUCAO LTDA
-- Finalidade(s):
-- 1) Possibilitar gerar um extrato do "A Pagar" de forma retroativa, ou seja com ela  possivel pesquisar quando estava devendo em 31/12/2014 por exemplo.
/*-- SEQ 2546 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_DPAG CASCADE;

/*-- SEQ 2547 --*/
CREATE OR REPLACE VIEW TV_DPAG AS
        SELECT COM.SEQUEN, 
               COM.DATOPE, 
               COM.DATCMP, 
               COM.CODFIL, 
               COM.CODSER, 
               COM.SUBSER, 
               COM.NUMNOT, 
               COM.FILFOR, 
               COM.CODFOR, 
               PAG.NUMPAR, 
               PAG.SUBPAR, 
               PAG.DATVEN, 
               PAG.VLRPAR, 
               PAG.VLRPGT, 
               CASE WHEN PAG.FLGEST = 'P' AND DOP.DATPGT > FIM.DATOPE THEN 'A'
                    ELSE PAG.FLGEST
               END AS FLGEST, PAG.FLGEST AS FLGORI, FIM.DATOPE AS DATFIM
         FROM TT_PAG PAG
   CROSS JOIN TT_DAT FIM
   INNER JOIN TT_COM COM ON PAG.CODFIL = COM.CODFIL AND PAG.SEQUEN = COM.SEQUEN
   LEFT  JOIN TT_DOP DOP ON PAG.FILDOP = DOP.CODFIL AND PAG.SEQDOP = DOP.SEQUEN
;


/*-- SEQ 2548 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EEAN CASCADE;

/*-- SEQ 2549 --*/
CREATE OR REPLACE VIEW TV_EEAN AS
SELECT EAN.CODFIL,
       EAN.SEQUEN,
       EAN.CODEAN,
       EAN.USOEAN,
       DEAN.DESEAN,
       EAN.ATU_EM,
       EAN.DATINC,
       GRA.FILMAT AS GRA_FILMAT,
       GRA.CODMAT AS GRA_CODMAT,
       GRA.CODCOR AS GRA_CODCOR,
       GRA.CODTAM AS GRA_CODTAM,
       GRA.CODEXT AS GRA_CODEXT
  FROM TT_EAN EAN INNER JOIN TT_GRA GRA ON GRA.FILMAT = EAN.FILMAT
                                       AND GRA.CODMAT = EAN.CODMAT
                                       AND GRA.CODCOR = EAN.CODCOR
                                       AND GRA.CODTAM = EAN.CODTAM
                  INNER JOIN TD_EAN DEAN ON DEAN.CODTAB = EAN.USOEAN
;


/*-- SEQ 2550 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EIMU CASCADE;

/*-- SEQ 2551 --*/
CREATE OR REPLACE VIEW TV_EIMU AS
SELECT GRA.CODEXT, 
       GRA.FILMAT, 
       GRA.CODMAT,
       MUN.CODIBG,
       IMU.RESISS, 
       IMU.SITTRI, 
       IMU.EXIISS, 
       IMU.DESRPS, 
       IMU.NATNFS,
       IMU.TRINFS, 
       IMU.CODSRV,
       IMU.DESSRV       
  FROM TT_IMU IMU
 INNER JOIN TT_GRA GRA ON (IMU.FILMAT = GRA.FILMAT AND IMU.CODMAT = GRA.CODMAT)
 INNER JOIN TT_MUN MUN ON (IMU.CODCID = MUN.CODIGO)
;


-- Autor: Luciano
-- Cliente(s): MINERVA FOODS
-- Finalidade(s):
-- 1) Auxiliar no processo de integrao da Minerva.
/*-- SEQ 2552 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ERECXEVEN CASCADE;

/*-- SEQ 2553 --*/
CREATE OR REPLACE VIEW TV_ERECXEVEN AS
     SELECT VEN.EXPORT, VEN.CODFIL, VEN.SEQUEN, VEN.ATU_EM, VEN.FLGEST, VEN.CODSER, VEN.NUMECF, VEN.NUMNOT, VEN.DATHOR,
            VEN.VLRLIQ, VEN.FLGNFE, VEN.DATFIS,
            CAST((CASE WHEN CLI.GLOBAL = 'G' THEN (SELECT VIN.CODEXT 
                                                     FROM TT_CLI VIN 
                                                    WHERE VIN.FILCLI = CLI.FILVIN AND VIN.CODCLI = CLI.CODVIN) 
                                             ELSE CLI.CODEXT END) AS VARCHAR(20) ) AS CODCLI, CLI.NUMDOC,
            CAST(COALESCE(MEIODEPAGAMENTO(REC.CODFIL, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR, 1),'INDEFINIDO') AS VARCHAR(30)) AS MEIPGT,
            REC.NUMPAR, REC.SUBPAR, REC.DATVEN, REC.VLRPAR, REC.VLRPGT, REC.FLGEST AS REC_FLGEST,
            CAST(CASE WHEN TIT.NOSNUM IS NOT NULL THEN
                    CASE WHEN CTB.CODBCO IN ('033','409','748','356') THEN TRIM(TIT.NOSNUM)
                         WHEN CTB.CODBCO = '027' THEN SUBSTR(TRIM(TIT.NOSNUM), 1, LENGTH(TRIM(TIT.NOSNUM))-3)||'-'||SUBSTR(TRIM(TIT.NOSNUM), LENGTH(TRIM(TIT.NOSNUM))-2, LENGTH(TRIM(TIT.NOSNUM)))
                         ELSE CASE WHEN TIT.NOSNUM IS NOT NULL THEN 
                         SUBSTR(TRIM(TIT.NOSNUM), 1, LENGTH(TRIM(TIT.NOSNUM))-1)||'-'||SUBSTR(TRIM(TIT.NOSNUM), LENGTH(TRIM(TIT.NOSNUM)), 1)
                    ELSE NULL END END ELSE NULL
                 END AS VARCHAR(25)) AS NOSNUM,   
            CHR.NUMCHE, CHR.DATVEN AS CHR_DATVEN, DNAT.NATDEN, DNAT.NATFOR
       FROM TT_VEN VEN
 INNER JOIN TT_REC REC  ON REC.CODFIL  = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
 INNER JOIN TT_CLI CLI  ON CLI.FILCLI  = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
 INNER JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD 
 INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT                       
 INNER JOIN TT_CTA CTA  ON DCOB.FILCTA = CTA.CODFIL AND DCOB.SEQCTA = CTA.SEQUEN 
                       AND DCOB.TIPCTA = CTA.TIPCTA
  LEFT JOIN TT_CHR CHR  ON CHR.CODFIL  = REC.FILREC AND CHR.SEQUEN = REC.SEQCHE                                               
  LEFT JOIN TT_CTB CTB  ON CTA.CODFIL  = CTB.FILCTA AND CTA.SEQUEN = CTB.SEQCTA 
                       AND CTA.TIPCTA  = CTB.TIPCTA AND CTA.USOCTA = CTB.CTACTB                       
  LEFT JOIN TT_TIT TIT  ON TIT.FILREC  = REC.CODFIL AND TIT.SEQREC = REC.SEQUEN 
                       AND TIT.PARREC  = REC.NUMPAR AND TIT.SUBREC = REC.SUBPAR AND TIT.FLGEST <> 'C'
;


-- Autor: Luciano
-- Cliente(s): MINERVA FOODS
-- Finalidade(s):
-- 1) Auxiliar no processo de integrao da Minerva.
/*-- SEQ 2554 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EREC_DESOUT CASCADE;

/*-- SEQ 2555 --*/
CREATE OR REPLACE VIEW TV_EREC_DESOUT AS
   SELECT TAB.DATFIS AS DATOPE, TAB.DESOUT, TAB.NUMEXT, SUM(TAB.VLRPGT1) AS VLRPAR 
     FROM (SELECT VEN.CODFIL, VEN.NUMNOT, VEN.NUMECF, VEN.CODSER, REC.NUMPAR, REC.SUBPAR,
                  REC.FLGEST, REC.ATU_EM, (CASE WHEN REC.VLRPGT = 0 THEN REC.VLRPAR ELSE VLRPGT END) AS VLRPGT1,
                  CAST((CASE WHEN (REC.PORTAD = 0) AND (REC.FLGEST = 'A') THEN 'NAO USA' 
                      WHEN DCAR.DESOUT IS NULL THEN SUBSTR(CAST(COALESCE(MeioDePagamento(REC.CODFIL, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR, 1),'Indefinido') AS VARCHAR(50)),1,8) 
                      ELSE DCAR.DESOUT END) AS VARCHAR(50)) as DESOUT, 
                  COALESCE(ITF.DATVEN,REC.DATVEN) AS DATVEN, 
                  CHR.DATVEN AS CHR_DATVEN,
                  REC.VLRPAR, DMOE.DESMOE AS CODMOE, 
                  USU.CODEXT AS CODUSU, REC.FILREC, REC.NUMECF AS ECFREC, REC.CUPFIS, 
                  COALESCE(ITF.DATPGT,REC.PAGAME) AS PAGAME, REC.VLRPGT, REC.PORTAD, REC.DATINC, REC.VLRDES, TRUNC(VEN.DATHOR) AS DATFIS,
                  REC.CODEXT, REC.CARTAO, CHR.CODBCO AS CHEBCO, CHR.CODAGE, CHR.NUMCHE, CHR.NUMCON, 
                  REC.TIPCCC, REC.RENEGO, REC.RENORI, 0 AS STATUS, TO_CHAR(' ') AS DATIMP,TO_CHAR(' ') AS MOTREJ,
                  VEN.CNT_RO, CLI.CODEXT AS CODCLI, CTB.CODBCO, CTB.NUMAGE, CTB.DIGAGE, CTB.CTACRR, CTB.DIGA_C,
                  CTB.DIGCRR,       
                  DCAR.DESOUT AS DESCAR,
                  CAST((CASE WHEN REC.CARTAO IS NOT NULL THEN CASE WHEN TEF.TIPOPE = 'C' THEN 'Credito' ELSE 'Debito' END END) AS VARCHAR(15)) as tipope,      
                  (CASE WHEN TEF.TIPOPE = 'C' THEN DCAR.EXTCRE ELSE DCAR.EXTDEB END) as NUMEXT,
                  (CASE WHEN TEF.TIPOPE = 'C' THEN DCAR.DIACAR ELSE DCAR.DIADEB END) as PRZEXT,
                  CAST(CASE WHEN TIT.NOSNUM IS NOT NULL THEN
                          CASE WHEN CTB.CODBCO IN ('033','409','748','356') THEN TRIM(TIT.NOSNUM)
                               WHEN CTB.CODBCO = '027' THEN SUBSTR(TRIM(TIT.NOSNUM), 1, LENGTH(TRIM(TIT.NOSNUM))-3)||'-'||SUBSTR(TRIM(TIT.NOSNUM), LENGTH(TRIM(TIT.NOSNUM))-2, LENGTH(TRIM(TIT.NOSNUM)))
                          ELSE CASE WHEN TIT.NOSNUM IS NOT NULL THEN
                                    SUBSTR(TRIM(TIT.NOSNUM), 1, LENGTH(TRIM(TIT.NOSNUM))-1)||'-'||SUBSTR(TRIM(TIT.NOSNUM), LENGTH(TRIM(TIT.NOSNUM)), 1)
                               ELSE
                                    NULL 
                               END
                          END
                     ELSE
                          NULL
                     END AS VARCHAR(25)) AS NOSNUM, REC.SEQUEN, REC.VLRTAX, TEF.MANUAL,
                  SUBSTR(CAST(COALESCE(MeioDePagamento(REC.CODFIL, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR, 1),'Indefinido') AS VARCHAR(50)),1,8) AS MEIPGT,
                  CAST(CASE WHEN REC.CARTAO IS NOT NULL THEN
                          CASE WHEN TEF.SEQUEN IS NOT NULL THEN
                               CASE WHEN TEF.MANUAL = 'T' THEN TO_CHAR(TEF.NUMAUT) ELSE TEF.NSUTRN END
                          ELSE
                               (SELECT MIN(CASE WHEN TEF2.MANUAL = 'T' THEN TO_CHAR(TEF2.NUMAUT) ELSE TEF2.NSUTRN END)
                                  FROM TT_OPE OPE INNER JOIN TT_OPE OPE2 ON OPE2.CODFIL = OPE.CODFIL 
                                                                        AND OPE2.NUMECF = OPE.NUMECF
                                                                        AND OPE2.TRN_ID = OPE.TRN_ID
                                                                        AND ABS(OPE2.VLROPE) = ABS(OPE.VLROPE)
                                                  INNER JOIN TT_TEF TEF2 ON TEF2.CODFIL = OPE2.CODFIL
                                                                        AND TEF2.NUMECF = OPE2.NUMECF
                                                                        AND TEF2.TRN_ID = OPE2.TRN_ID
                                 WHERE OPE.FILREC = REC.CODFIL 
                                   AND OPE.SEQREC = REC.SEQUEN
                                   AND OPE.NUMPAR = REC.NUMPAR
                                   AND OPE.SUBPAR = REC.SUBPAR
                                   AND OPE2.CARTAO = REC.CARTAO)
                          END
                     ELSE NULL
                  END AS VARCHAR(20)) AS NUMAUT,
                  -- Se parcela fica em aberto mais de 6 meses e no  paga, contabilmente  considerado como perda
                  CAST(CASE WHEN (TO_DATE('01'||TO_CHAR(ADD_MONTHS(AGORA(),-6),'mm')||TO_CHAR(ADD_MONTHS(AGORA(),-6),'yyyy'),'ddmmyyyy') > REC.DATVEN) AND
                              ((REC.PAGAME IS NULL) OR 
                              (TO_DATE(TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'dd')||TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'mm')||TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'yyyy'),'ddmmyyyy') < REC.PAGAME))   
                         THEN 'T'
                         ELSE 'F'
                  END AS VARCHAR(1)) AS PERDA,
                  -- Se parcela  paga aps o perodo de 6 meses e  considerada perda,  necessrio fazer recuperao desta perda.
                  CAST(CASE WHEN (CAST(CASE WHEN (TO_DATE('01'||TO_CHAR(ADD_MONTHS(AGORA(),-6),'mm')||TO_CHAR(ADD_MONTHS(AGORA(),-6),'yyyy'),'ddmmyyyy') > REC.DATVEN) AND
                               ((REC.PAGAME IS NULL) OR 
                               (TO_DATE(TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'dd')||TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'mm')||TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'yyyy'),'ddmmyyyy') < REC.PAGAME))   
                          THEN 'T'
                          ELSE 'F'
                          END AS VARCHAR(1))) = 'T' AND REC.PAGAME IS NOT NULL
                          THEN 'T'
                  ELSE 'F' END AS VARCHAR(1)) AS RECUPERA,
                  REC.ESTCAN
            FROM TT_VEN VEN   INNER JOIN TT_CLI CLI  ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                              INNER JOIN TT_REC REC  ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
                              INNER JOIN TT_USU USU  ON USU.FILUSU = REC.FILUSU AND USU.CODUSU = REC.CODUSU
                              INNER JOIN TD_MOE DMOE ON DMOE.CODTAB = REC.CODMOE
                              INNER JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD
                              INNER JOIN TT_CTA CTA  ON DCOB.FILCTA = CTA.CODFIL
                                                    AND DCOB.SEQCTA = CTA.SEQUEN
                                                    AND DCOB.TIPCTA = CTA.TIPCTA
                               LEFT JOIN TD_CAR DCAR ON DCAR.CODTAB = REC.CARTAO                                         
                               LEFT JOIN TT_CHR CHR  ON CHR.CODFIL = REC.FILREC AND CHR.SEQUEN = REC.SEQCHE
                               LEFT JOIN TT_CTB CTB  ON CTA.CODFIL = CTB.FILCTA AND CTA.SEQUEN = CTB.SEQCTA
                                                    AND CTA.TIPCTA = CTB.TIPCTA AND CTA.USOCTA = CTB.CTACTB
                               LEFT JOIN TT_ITF ITF  ON ITF.CODFIL = REC.FILITF
                                                    AND ITF.SEQUEN = REC.SEQITF
                                                    AND ITF.NUMITE = REC.ITEITF
                               LEFT JOIN TT_TEF TEF  ON TEF.CODFIL = ITF.CODFIL
                                                    AND TEF.SEQUEN = ITF.SEQUEN
                               LEFT JOIN TT_TIT TIT  ON TIT.FILREC = REC.CODFIL
                                                    AND TIT.SEQREC = REC.SEQUEN
                                                    AND TIT.PARREC = REC.NUMPAR
                                                    AND TIT.SUBREC = REC.SUBPAR
                                                    AND TIT.FLGEST <> 'C' ) TAB
    WHERE TAB.FLGEST NOT IN ('C','X')
 GROUP BY TAB.DATFIS, TAB.DESOUT, TAB.NUMEXT, TAB.MEIPGT
 ORDER BY TAB.DATFIS, TAB.DESOUT
;


-- Autor: Luciano
-- Cliente(s): MINERVA FOODS
-- Finalidade(s):
-- 1) Auxiliar no processo de integrao da Minerva.
/*-- SEQ 2556 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EREC_MEIPGT CASCADE;

/*-- SEQ 2557 --*/
CREATE OR REPLACE VIEW TV_EREC_MEIPGT AS
   SELECT TAB.DATFIS AS DATOPE, MIN(TAB.DATVEN) AS DATVEN, TAB.DESOUT, TAB.TIPOPE, TAB.NUMEXT, TAB.PRZEXT, TAB.MEIPGT, SUM(TAB.VLRPGT1) AS VLRPAR 
     FROM (SELECT VEN.CODFIL, VEN.NUMNOT, VEN.NUMECF, VEN.CODSER, REC.NUMPAR, REC.SUBPAR,
                  REC.FLGEST, REC.ATU_EM, (CASE WHEN REC.VLRPGT = 0 THEN REC.VLRPAR ELSE VLRPGT END) AS VLRPGT1, 
                  coalesce(ITF.DATVEN,REC.DATVEN) AS DATVEN, 
                  CHR.DATVEN AS CHR_DATVEN,
                  REC.VLRPAR, DMOE.DESMOE AS CODMOE, 
                  USU.CODEXT AS CODUSU, REC.FILREC, REC.NUMECF AS ECFREC, REC.CUPFIS, 
                  COALESCE(ITF.DATPGT,REC.PAGAME) AS PAGAME, REC.VLRPGT, REC.PORTAD, REC.DATINC, REC.VLRDES, TRUNC(VEN.DATHOR) AS DATFIS,
                  REC.CODEXT, REC.CARTAO, CHR.CODBCO AS CHEBCO, CHR.CODAGE, CHR.NUMCHE, CHR.NUMCON, 
                  REC.TIPCCC, REC.RENEGO, REC.RENORI, 0 AS STATUS, TO_CHAR(' ') AS DATIMP,TO_CHAR(' ') AS MOTREJ,
                  VEN.CNT_RO, CLI.CODEXT AS CODCLI, CTB.CODBCO, CTB.NUMAGE, CTB.DIGAGE, CTB.CTACRR, CTB.DIGA_C,
                  CTB.DIGCRR,       
                  DCAR.DESOUT,
                  CAST((CASE WHEN REC.CARTAO IS NOT NULL THEN CASE WHEN TEF.TIPOPE = 'C' THEN 'Credito' ELSE 'Debito' END END) AS VARCHAR(15)) as tipope,      
                  (CASE WHEN TEF.TIPOPE = 'C' THEN DCAR.EXTCRE ELSE DCAR.EXTDEB END) as NUMEXT,
                  (CASE WHEN TEF.TIPOPE = 'C' THEN DCAR.DIACAR ELSE DCAR.DIADEB END) as PRZEXT,
                  CAST(CASE WHEN TIT.NOSNUM IS NOT NULL THEN
                          CASE WHEN CTB.CODBCO IN ('033','409','748','356') THEN TRIM(TIT.NOSNUM)
                               WHEN CTB.CODBCO = '027' THEN SUBSTR(TRIM(TIT.NOSNUM), 1, Length(TRIM(TIT.NOSNUM))-3)||'-'||SUBSTR(TRIM(TIT.NOSNUM), Length(TRIM(TIT.NOSNUM))-2, Length(TRIM(TIT.NOSNUM)))
                          ELSE CASE WHEN TIT.NOSNUM IS NOT NULL THEN
                                    SUBSTR(TRIM(TIT.NOSNUM), 1, Length(TRIM(TIT.NOSNUM))-1)||'-'||SUBSTR(TRIM(TIT.NOSNUM), Length(TRIM(TIT.NOSNUM)), 1)
                               ELSE
                                    NULL 
                               END
                          END
                     ELSE
                          NULL
                  END AS VARCHAR(25)) AS NOSNUM, REC.SEQUEN, REC.VLRTAX, TEF.MANUAL,
                  CAST(COALESCE(MeioDePagamento(REC.CODFIL, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR, 1),'Indefinido') AS VARCHAR(50)) AS MEIPGT,
                  CAST(CASE WHEN REC.CARTAO IS NOT NULL THEN
                       CASE WHEN TEF.SEQUEN IS NOT NULL THEN
                            CASE WHEN TEF.MANUAL = 'T' THEN TO_CHAR(TEF.NUMAUT) ELSE TEF.NSUTRN END
                       ELSE
                            (SELECT MIN(CASE WHEN TEF2.MANUAL = 'T' THEN TO_CHAR(TEF2.NUMAUT) ELSE TEF2.NSUTRN END)
                               FROM TT_OPE OPE INNER JOIN TT_OPE OPE2 ON OPE2.CODFIL = OPE.CODFIL 
                                                                     AND OPE2.NUMECF = OPE.NUMECF
                                                                     AND OPE2.TRN_ID = OPE.TRN_ID
                                                                     AND ABS(OPE2.VLROPE) = ABS(OPE.VLROPE)
                                               INNER JOIN TT_TEF TEF2 ON TEF2.CODFIL = OPE2.CODFIL
                                                                     AND TEF2.NUMECF = OPE2.NUMECF
                                                                     AND TEF2.TRN_ID = OPE2.TRN_ID
                              WHERE OPE.FILREC = REC.CODFIL 
                                AND OPE.SEQREC = REC.SEQUEN
                                AND OPE.NUMPAR = REC.NUMPAR
                                AND OPE.SUBPAR = REC.SUBPAR
                                AND OPE2.CARTAO = REC.CARTAO)
                       END
                  ELSE NULL
                  END AS VARCHAR(20)) AS NUMAUT,
                  -- Se parcela fica em aberto mais de 6 meses e no  paga, contabilmente  considerado como perda
                  CAST(CASE WHEN (TO_DATE('01'||TO_CHAR(ADD_MONTHS(AGORA(),-6),'mm')||TO_CHAR(ADD_MONTHS(AGORA(),-6),'yyyy'),'ddmmyyyy') > REC.DATVEN) AND
                            ((REC.PAGAME IS NULL) OR 
                            (TO_DATE(TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'dd')||TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'mm')||TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'yyyy'),'ddmmyyyy') < REC.PAGAME))   
                       THEN 'T'
                       ELSE 'F'
                  END AS VARCHAR(1)) AS PERDA,
                  -- Se parcela  paga aps o perodo de 6 meses e  considerada perda,  necessrio fazer recuperao desta perda.
                  CAST(CASE WHEN (CAST(CASE WHEN (TO_DATE('01'||TO_CHAR(ADD_MONTHS(AGORA(),-6),'mm')||TO_CHAR(ADD_MONTHS(AGORA(),-6),'yyyy'),'ddmmyyyy') > REC.DATVEN) AND
                                                 ((REC.PAGAME IS NULL) OR 
                                                 (TO_DATE(TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'dd')||TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'mm')||TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'yyyy'),'ddmmyyyy') < REC.PAGAME))
                                       THEN 'T'
                                       ELSE 'F'
                                       END AS VARCHAR(1))) = 'T' AND REC.PAGAME IS NOT NULL
                       THEN 'T'
                       ELSE 'F' 
                  END AS VARCHAR(1)) AS RECUPERA,
                  REC.ESTCAN
     FROM TT_VEN VEN INNER JOIN TT_CLI CLI  ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                     INNER JOIN TT_REC REC  ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
                     INNER JOIN TT_USU USU  ON USU.FILUSU = REC.FILUSU AND USU.CODUSU = REC.CODUSU
                     INNER JOIN TD_MOE DMOE ON DMOE.CODTAB = REC.CODMOE		   
                     INNER JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD
                     INNER JOIN TT_CTA CTA  ON DCOB.FILCTA = CTA.CODFIL
                                           AND DCOB.SEQCTA = CTA.SEQUEN
                                           AND DCOB.TIPCTA = CTA.TIPCTA
                      LEFT JOIN TD_CAR DCAR ON DCAR.CODTAB = REC.CARTAO                                         
                      LEFT JOIN TT_CHR CHR  ON CHR.CODFIL = REC.FILREC AND CHR.SEQUEN = REC.SEQCHE
                      LEFT JOIN TT_CTB CTB  ON CTA.CODFIL = CTB.FILCTA AND CTA.SEQUEN = CTB.SEQCTA
                                           AND CTA.TIPCTA = CTB.TIPCTA AND CTA.USOCTA = CTB.CTACTB
                      LEFT JOIN TT_ITF ITF ON ITF.CODFIL = REC.FILITF
                                          AND ITF.SEQUEN = REC.SEQITF
                                          AND ITF.NUMITE = REC.ITEITF
                      LEFT JOIN TT_TEF TEF ON TEF.CODFIL = ITF.CODFIL
                                          AND TEF.SEQUEN = ITF.SEQUEN
                      LEFT JOIN TT_TIT TIT ON TIT.FILREC = REC.CODFIL
                                          AND TIT.SEQREC = REC.SEQUEN
                                          AND TIT.PARREC = REC.NUMPAR
                                          AND TIT.SUBREC = REC.SUBPAR
                                          AND TIT.FLGEST <> 'C' ) TAB
 GROUP BY TAB.DATFIS, TAB.DESOUT, TAB.NUMEXT, TAB.PRZEXT, TAB.TIPOPE, TAB.MEIPGT
 ORDER BY TAB.DATFIS, TAB.MEIPGT
;


-- Autor: Luciano
-- Cliente(s): MINERVA FOODS
-- Finalidade(s):
-- 1) Auxiliar no processo de integrao da Minerva.
/*-- SEQ 2558 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EREC_NUMECF CASCADE;

/*-- SEQ 2559 --*/
CREATE OR REPLACE VIEW TV_EREC_NUMECF AS
   SELECT TAB.DATFIS AS DATOPE, TAB.DESOUT, TAB.CODFIL, TAB.NUMECF, TAB.CODSER, TAB.NUMEXT, SUM(TAB.VLRPGT1) AS VLRPAR, TAB.VEN_EXPORT , TAB.REC_EXPORT 
     FROM (SELECT VEN.CODFIL, VEN.NUMNOT, VEN.NUMECF, VEN.CODSER, REC.NUMPAR, REC.SUBPAR,
                  REC.FLGEST, REC.ATU_EM, (CASE WHEN REC.VLRPGT = 0 THEN REC.VLRPAR ELSE REC.VLRPGT END) AS VLRPGT1,
                  VEN.EXPORT AS VEN_EXPORT, REC.EXPORT AS REC_EXPORT,
                  CAST((CASE WHEN (REC.PORTAD = 0) AND (REC.FLGEST = 'A') THEN 'NAO USA' 
                            WHEN DCAR.DESOUT IS NULL THEN SUBSTR(CAST(COALESCE(MeioDePagamento(REC.CODFIL, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR, 1),'Indefinido') AS VARCHAR(50)),1,8) 
                        ELSE DCAR.DESOUT END) AS VARCHAR(50)) as DESOUT,
                  COALESCE(ITF.DATVEN,REC.DATVEN) AS DATVEN, 
                  CHR.DATVEN AS CHR_DATVEN,
                  REC.VLRPAR, DMOE.DESMOE AS CODMOE, 
                  USU.CODEXT AS CODUSU, REC.FILREC, REC.NUMECF AS ECFREC, REC.CUPFIS, 
                  COALESCE(ITF.DATPGT,REC.PAGAME) AS PAGAME, REC.VLRPGT, REC.PORTAD, REC.DATINC, REC.VLRDES, TRUNC(VEN.DATHOR) AS DATFIS,
                  REC.CODEXT, REC.CARTAO, CHR.CODBCO AS CHEBCO, CHR.CODAGE, CHR.NUMCHE, CHR.NUMCON, 
                  REC.TIPCCC, REC.RENEGO, REC.RENORI, 0 AS STATUS, TO_CHAR(' ') AS DATIMP,TO_CHAR(' ') AS MOTREJ,
                  VEN.CNT_RO, CLI.CODEXT AS CODCLI, CTB.CODBCO, CTB.NUMAGE, CTB.DIGAGE, CTB.CTACRR, CTB.DIGA_C,
                  CTB.DIGCRR,       
                  DCAR.DESOUT AS DESCAR,
                  CAST((CASE WHEN REC.CARTAO IS NOT NULL THEN CASE WHEN TEF.TIPOPE = 'C' THEN 'Credito' ELSE 'Debito' END END) AS VARCHAR(15)) as tipope,      
                  (CASE WHEN TEF.TIPOPE = 'C' THEN DCAR.EXTCRE ELSE DCAR.EXTDEB END) as NUMEXT,
                  (CASE WHEN TEF.TIPOPE = 'C' THEN DCAR.DIACAR ELSE DCAR.DIADEB END) as PRZEXT,
                  CAST(CASE WHEN TIT.NOSNUM IS NOT NULL THEN
                          CASE WHEN CTB.CODBCO IN ('033','409','748','356') THEN TRIM(TIT.NOSNUM)
                               WHEN CTB.CODBCO = '027' THEN SUBSTR(TRIM(TIT.NOSNUM), 1, Length(TRIM(TIT.NOSNUM))-3)||'-'||SUBSTR(TRIM(TIT.NOSNUM), Length(TRIM(TIT.NOSNUM))-2, Length(TRIM(TIT.NOSNUM)))
                          ELSE CASE WHEN TIT.NOSNUM IS NOT NULL THEN
                                    SUBSTR(TRIM(TIT.NOSNUM), 1, Length(TRIM(TIT.NOSNUM))-1)||'-'||SUBSTR(TRIM(TIT.NOSNUM), Length(TRIM(TIT.NOSNUM)), 1)
                               ELSE
                                    NULL 
                               END
                          END
                     ELSE
                          NULL
                  END AS VARCHAR(25)) AS NOSNUM, REC.SEQUEN, REC.VLRTAX, TEF.MANUAL,
                  SUBSTR(CAST(COALESCE(MeioDePagamento(REC.CODFIL, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR, 1),'Indefinido') AS VARCHAR(50)),1,8) AS MEIPGT,
                  CAST(CASE WHEN REC.CARTAO IS NOT NULL THEN
                       CASE WHEN TEF.SEQUEN IS NOT NULL THEN
                            CASE WHEN TEF.MANUAL = 'T' THEN TO_CHAR(TEF.NUMAUT) ELSE TEF.NSUTRN END
                       ELSE
                            (SELECT MIN(CASE WHEN TEF2.MANUAL = 'T' THEN TO_CHAR(TEF2.NUMAUT) ELSE TEF2.NSUTRN END)
                               FROM TT_OPE OPE INNER JOIN TT_OPE OPE2 ON OPE2.CODFIL = OPE.CODFIL 
                                                                     AND OPE2.NUMECF = OPE.NUMECF
                                                                     AND OPE2.TRN_ID = OPE.TRN_ID
                                                                     AND ABS(OPE2.VLROPE) = ABS(OPE.VLROPE)
                                               INNER JOIN TT_TEF TEF2 ON TEF2.CODFIL = OPE2.CODFIL
                                                                     AND TEF2.NUMECF = OPE2.NUMECF
                                                                     AND TEF2.TRN_ID = OPE2.TRN_ID
                              WHERE OPE.FILREC = REC.CODFIL 
                                AND OPE.SEQREC = REC.SEQUEN
                                AND OPE.NUMPAR = REC.NUMPAR
                                AND OPE.SUBPAR = REC.SUBPAR
                                AND OPE2.CARTAO = REC.CARTAO)
                       END
                  ELSE NULL
                  END AS VARCHAR(20)) AS NUMAUT,
                  -- Se parcela fica em aberto mais de 6 meses e no  paga, contabilmente  considerado como perda
                  CAST(CASE WHEN (TO_DATE('01'||TO_CHAR(ADD_MONTHS(AGORA(),-6),'mm')||TO_CHAR(ADD_MONTHS(AGORA(),-6),'yyyy'),'ddmmyyyy') > REC.DATVEN) AND
                            ((REC.PAGAME IS NULL) OR 
                            (TO_DATE(TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'dd')||TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'mm')||TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'yyyy'),'ddmmyyyy') < REC.PAGAME))   
                       THEN 'T'
                       ELSE 'F'
                  END AS VARCHAR(1)) AS PERDA,
                  -- Se parcela  paga aps o perodo de 6 meses e  considerada perda,  necessrio fazer recuperao desta perda.
                  CAST(CASE WHEN (CAST(CASE WHEN (TO_DATE('01'||TO_CHAR(ADD_MONTHS(AGORA(),-6),'mm')||TO_CHAR(ADD_MONTHS(AGORA(),-6),'yyyy'),'ddmmyyyy') > REC.DATVEN) AND
                                                 ((REC.PAGAME IS NULL) OR 
                                                 (TO_DATE(TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'dd')||TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'mm')||TO_CHAR(ADD_MONTHS(REC.DATVEN,6),'yyyy'),'ddmmyyyy') < REC.PAGAME))   
                                         THEN 'T'
                                         ELSE 'F'
                                        END AS VARCHAR(1))) = 'T' AND REC.PAGAME IS NOT NULL
                     THEN 'T'
                     ELSE 'F' 
                  END AS VARCHAR(1)) AS RECUPERA,
                  REC.ESTCAN
     FROM TT_VEN VEN INNER JOIN TT_CLI CLI  ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                     INNER JOIN TT_REC REC  ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
                     INNER JOIN TT_USU USU  ON USU.FILUSU = REC.FILUSU AND USU.CODUSU = REC.CODUSU
                     INNER JOIN TD_MOE DMOE ON DMOE.CODTAB = REC.CODMOE
                     INNER JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD
                     INNER JOIN TT_CTA CTA  ON DCOB.FILCTA = CTA.CODFIL
                                           AND DCOB.SEQCTA = CTA.SEQUEN
                                           AND DCOB.TIPCTA = CTA.TIPCTA
                      LEFT JOIN TD_CAR DCAR ON DCAR.CODTAB = REC.CARTAO
                      LEFT JOIN TT_CHR CHR  ON CHR.CODFIL = REC.FILREC AND CHR.SEQUEN = REC.SEQCHE
                      LEFT JOIN TT_CTB CTB  ON CTA.CODFIL = CTB.FILCTA AND CTA.SEQUEN = CTB.SEQCTA
                                           AND CTA.TIPCTA = CTB.TIPCTA AND CTA.USOCTA = CTB.CTACTB
                      LEFT JOIN TT_ITF ITF ON ITF.CODFIL = REC.FILITF
                                          AND ITF.SEQUEN = REC.SEQITF
                                          AND ITF.NUMITE = REC.ITEITF
                      LEFT JOIN TT_TEF TEF ON TEF.CODFIL = ITF.CODFIL
                                          AND TEF.SEQUEN = ITF.SEQUEN
                      LEFT JOIN TT_TIT TIT ON TIT.FILREC = REC.CODFIL
                                          AND TIT.SEQREC = REC.SEQUEN
                                          AND TIT.PARREC = REC.NUMPAR
                                          AND TIT.SUBREC = REC.SUBPAR
                                          AND TIT.FLGEST <> 'C' ) TAB
    WHERE TAB.FLGEST NOT IN ('C','X')
 GROUP BY TAB.DATFIS, TAB.DESOUT, TAB.CODFIL, TAB.NUMECF, TAB.CODSER, TAB.NUMEXT, TAB.VEN_EXPORT, TAB.REC_EXPORT
;


/*-- SEQ 2560 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EROM CASCADE;

/*-- SEQ 2561 --*/
CREATE OR REPLACE VIEW TV_EROM AS
SELECT ROM.CODFIL AS ROM_CODFIL,
       ROM.SEQUEN AS ROM_SEQUEN,
       ROM.CODEXT AS ROM_CODEXT,
       ROM.FILMOT AS ROM_FILMOT,
       ROM.CODMOT AS ROM_CODMOT,
       ROM.PLACAS AS ROM_PLACA,
       ROM.FLGEST AS ROM_FLGEST,
       ROM.DATOPE AS ROM_DATINC,
       ROM.ATU_EM AS ROM_ATU_EM
  FROM TT_ROM ROM
;


-- Autor: Luciano Chiqueti
-- Cliente(s): Gimba

-- Finalidade(s):
-- 1) View criada para a integrao com sistema da Gimba em SQL Server
/*-- SEQ 2562 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVEN_IVE_GBA CASCADE;

/*-- SEQ 2563 --*/
CREATE OR REPLACE VIEW TV_EVEN_IVE_GBA AS
SELECT VEN.CODFIL,
       VEN.FILCLI,
       VEN.CODCLI,
       CLI.NUMDOC,
       CAST(CLI.FILCLI||TRIM(CLI.CODCLI) AS VARCHAR(20)) AS CLIENTE,
       VEN.CODSER,
       VEN.NUMNOT,
       VEN.SATCFE,
       VEN.DATHOR,
       VEN.DATSAI,
       VEN.VLRLIQ,
       VEN.CODTRA,
       VEN.DESCON,
       VEN.CHAVEA,
       CAST(CASE WHEN SUBSTR(DNAT.NATDEN, 1, 1) IN ('1', '2', '3') THEN 'E' ELSE 'S' END AS VARCHAR(1)) AS ENTSAI,
       VEN.FLGNFE,
       VEN.ENDENT,
       VEN.BASICM,
       VEN.BASIRR,
       VEN.BASISS,
       ABS((SELECT COALESCE(SUM(IVE1.BASIPI), 0)
              FROM TT_IVE IVE1
             WHERE IVE1.CODFIL = VEN.CODFIL
               AND IVE1.SEQUEN = VEN.SEQUEN
               AND IVE1.SITKIT IN ('2', '3')
               AND IVE1.SITMOV = 'N')) AS BASIPI,
       VEN.BASUBS,
       VEN.NUMVOL,
       VEN.SUBSTT,
       VEN.VLRSEG,
       VEN.VLRPIS,
       VEN.VLRISS,
       VEN.VLRIRR,
       VEN.VLRICM,
       VEN.VLRFRE,
       VEN.VLRCFI,
       VEN.DOCNFP AS VEN_DOCNFP,
       CASE WHEN COALESCE(IVE.DESRAT,0) > 0 THEN IVE.DESRAT      ELSE 0 END IVE_ACRESC,  
       CASE WHEN COALESCE(IVE.DESRAT,0) < 0 THEN ABS(IVE.DESRAT) ELSE 0 END IVE_DESCON,
       CASE WHEN COALESCE(VEN.DESRAT,0) > 0 THEN VEN.DESRAT      ELSE 0 END VEN_ACRESC,    
       CASE WHEN COALESCE(VEN.DESRAT,0) < 0 THEN ABS(VEN.DESRAT) ELSE 0 END VEN_DESCON,
       VEN.DESRAT AS VEN_DESRAT,
       IVE.DESRAT AS IVE_DESRAT,
       CASE WHEN (COALESCE(VEN.DESRAT,0) > 0 AND COALESCE(VEN.VLRLIQ, 0) > 0) OR
                 (COALESCE(VEN.DESRAT,0) < 0 AND COALESCE(VEN.VLRLIQ, 0) < 0)
            THEN ABS(VEN.DESRAT) ELSE 0 END AS ACRESC,
       VEN.PESBRU,
       VEN.PESLIQ,
       CAST(VEN.OBSERV AS VARCHAR(4000)) AS OBSERV,
       DNAT.NATDEN,
       VDD.CODEXT AS CODVEN,
       IVE.CODMAT,
       MED.UNIMED,
       IVE.NUMITE,
       IVE.QTDMOV,
       ABS(COALESCE(IVE.TAX002,0)) AS PERIPI,
       IVE.PEREFE,
       GRA.CODFIS,
       IVE.VLRICM AS VLRICM_ITENS,
       IVE.VLRMOV,
       IVE.BASICM AS BASICM_ITENS,
       IVE.VLRDES,
       IVE.VLRIPI,
       IVE.BASUBS AS BASUBS_ITENS,
       IVE.SUBSTT AS SUBSTT_ITENS,
       IVE.REDEFE,
       IVE.PERPIS,
       IVE.PERCOF,
       IVE.BASPIS,
       IVE.BASCOF,
       IVE.VLRPIS AS VLRPIS_ITENS,
       IVE.VLRCOF,
       IVE.VLRICMORI,
       IVE.VLRICMDES,
       IVE.PERFCP,
       IVE.CODCES,
       VEN.FLGEST,
       IVE.SITMOV,
       IVE.NATFIS,
       IVE.VLRFRE AS FRETE_ITEM,
       VEN.TIPTRO,
       IVE.CODCST,
       VEN.SEQUEN,
       VEN.ATU_EM,
       VEN.NUMECF,
       VEN.NUMNOT AS DOCUMENTO,
       CAST(COALESCE(VEN.CODSER,'')||'/'||lTrim(COALESCE(VEN.NUMECF,''))||'-'||lTrim(COALESCE(VEN.NUMNOT,''))||CASE WHEN COALESCE(VEN.CNT_RO,0)>0 THEN '['||VEN.CNT_RO||']' ELSE '' END AS VARCHAR(40)) AS DOCUMENTO_CHAVE,
       VEN.CODPGT,
       IVE.TOT_CM,
       IVE.SAL_CM,
       COALESCE(TRUNC(CUSTOMEDIO(IVE.CODFIL, GRA.FILMAT, GRA.CODMAT,
                                 GRA.CODCOR, GRA.CODTAM, 3, TRUNC(IVE.VEN_DATHOR)), 4),0) AS VLR_CM,
       GRA.CUSREP ,
       IVE.FILORI AS CODFIL_ORIGEM,
       IVE.NUMORI AS SEQUEN_ORIGEM,
       IVE.ITEORI AS NUMITE_ORIGEM,
       ORI.CHAVEA AS CHAVEA_ORIGEM,
       IOR.CODFIL AS FILPED,
       IOR.NUMPED,
       IOR.NUMITE AS ITEPED,
       VEN.EXPORT,
       ENDFAT.ENDERE AS ENDFAT_ENDERE,
       ENDFAT.NUMERO AS ENDFAT_NUMERO,
       ENDFAT.BAIRRO AS ENDFAT_BAIRRO,
       ENDFAT.NOMCID AS ENDFAT_NOMCID,
       ENDFAT.CODCEP AS ENDFAT_CODCEP,
       ENDFAT.CODLOG AS ENDFAT_CODLOG,
       ENDFAT.SIGEST AS ENDFAT_SIGEST,
       ENDENT.ENDERE AS ENDENT_ENDERE,
       ENDENT.NUMERO AS ENDENT_NUMERO,
       ENDENT.BAIRRO AS ENDENT_BAIRRO,
       ENDENT.NOMCID AS ENDENT_NOMCID,
       ENDENT.CODCEP AS ENDENT_CODCEP,
       ENDENT.CODLOG AS ENDENT_CODLOG,
       ENDENT.SIGEST AS ENDENT_SIGEST,
       ENDCOB.ENDERE AS ENDCOB_ENDERE,
       ENDCOB.NUMERO AS ENDCOB_NUMERO,
       ENDCOB.BAIRRO AS ENDCOB_BAIRRO,
       ENDCOB.NOMCID AS ENDCOB_NOMCID,
       ENDCOB.CODCEP AS ENDCOB_CODCEP,
       ENDCOB.CODLOG AS ENDCOB_CODLOG,
       ENDCOB.SIGEST AS ENDCOB_SIGEST
  FROM TT_VEN VEN INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
                  INNER JOIN TT_IVE  IVE ON IVE.CODFIL = VEN.CODFIL
                                        AND IVE.SEQUEN = VEN.SEQUEN
                  INNER JOIN TT_CLI  CLI ON CLI.FILCLI = VEN.FILCLI
                                        AND CLI.CODCLI = VEN.CODCLI
                  -- Endereo de Faturamento
                   LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = VEN.FILCLI 
                                          AND ENDFAT.CODCLI = VEN.CODCLI 
                                          AND ENDFAT.CODFIL = VEN.FILFAT 
                                          AND ENDFAT.NUMEND = VEN.ENDFAT
                  -- Endereo de Entrega
                   LEFT JOIN TT_END ENDENT ON ENDENT.FILCLI = VEN.FILCLI 
                                          AND ENDENT.CODCLI = VEN.CODCLI 
                                          AND ENDENT.CODFIL = VEN.FILENT 
                                          AND ENDENT.NUMEND = VEN.ENDENT
                  -- Endereo de Cobrana
                   LEFT JOIN TT_END ENDCOB ON ENDCOB.FILCLI = VEN.FILCLI 
                                          AND ENDCOB.CODCLI = VEN.CODCLI 
                                          AND ENDCOB.CODFIL = VEN.FILCOB 
                                          AND ENDCOB.NUMEND = VEN.ENDCOB
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = IVE.FILMAT
                                       AND GRA.CODMAT = IVE.CODMAT
                                       AND GRA.CODCOR = IVE.CODCOR
                                       AND GRA.CODTAM = IVE.CODTAM
                  INNER JOIN TD_MED MED ON MED.CODTAB = GRA.UNIDAD
                   LEFT JOIN TT_VEN ORI ON ORI.CODFIL = IVE.FILORI
                                       AND ORI.SEQUEN = IVE.NUMORI
                   LEFT JOIN TT_IOR IOR ON IOR.FILIVE = IVE.CODFIL
                                       AND IOR.SEQIVE = IVE.SEQUEN
                                       AND IOR.NUMIVE = IVE.NUMITE
                  INNER JOIN TT_USU VDD ON VDD.FILUSU = VEN.FILVEN 
                                       AND VDD.CODUSU = VEN.CODVEN
 WHERE IVE.SITKIT <> '1'
 ORDER BY VEN.ATU_EM
;


-- Autor: Gabriel Rewell
-- Cliente(s): CARNEIRO CASA & CONSTRUCAO LTDA
-- Finalidade(s):
-- 1) Relacionar uma nota de Simples Faturamento com Simples Remessa com Dev. do Faturamento e a Dev. da Simples Remessa.
/*-- SEQ 2564 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FAT_REM_DEVFAT_DAVREM CASCADE;

/*-- SEQ 2565 --*/
CREATE OR REPLACE VIEW TV_FAT_REM_DEVFAT_DAVREM AS
     SELECT FAT.CODFIL AS FILFAT,
            FAT.SEQUEN AS SEQFAT, 
            FAT.NUMITE AS ITEFAT,
            FAT.NATFIS AS NATFAT,
            REM.CODFIL AS FILREM,
            REM.SEQUEN AS SEQREM,
            REM.NUMITE AS ITEREM,
            REM.NATFIS AS NATREM,
            DEVFAT.CODFIL AS DEVFILFAT,
            DEVFAT.SEQUEN AS DEVSEQFAT,
            DEVFAT.NUMITE AS DEVITEFAT,
            DEVFAT.NATFIS AS DEVNATFAT,
            DEVREM.CODFIL AS DEVFILREM,
            DEVREM.SEQUEN AS DEVSEQREM,
            DEVREM.NUMITE AS DEVITEREM,
            DEVREM.NATFIS AS DEVNATREM
       FROM TT_IVE FAT
  LEFT JOIN TT_IVE REM ON FAT.CODFIL = REM.FILORI
                      AND FAT.SEQUEN = REM.NUMORI
                      AND FAT.NUMITE = REM.ITEORI
                      AND REM.NATFIS IN ('511700','611700')
  LEFT JOIN TT_IVE DEVFAT ON FAT.CODFIL = DEVFAT.FILORI
                         AND FAT.SEQUEN = DEVFAT.NUMORI
                         AND FAT.NUMITE = DEVFAT.ITEORI
                         AND DEVFAT.NATFIS IN('194901','141100','141101','120200','120201',
                                              '294901','241100','241101','220200','120201')
  LEFT JOIN TT_IVE DEVREM ON REM.CODFIL = DEVREM.FILORI
                         AND REM.SEQUEN = DEVREM.NUMORI
                         AND REM.NUMITE = DEVREM.ITEORI
      WHERE FAT.NATFIS IN ('592200','540500','510200','510201',
                           '692200','640400','610200','610800')
;


/*-- SEQ 2566 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_61RV_INTERNO CASCADE;

/*-- SEQ 2567 --*/
CREATE OR REPLACE VIEW TV_FIS_61RV_INTERNO AS
SELECT CAST(TO_CHAR('61R') AS CHAR(3)) AS CHAVE,
       VEN.CODFIL,
       TRUNC(VEN.DATHOR) AS DATAOK,
       CAST(TO_CHAR(VEN.DATHOR, 'MMYYYY') AS VARCHAR(6)) AS MESANO,
       CAST(GRA.FILMAT||REPLACE(GRA.SEQUEN,' ','0')||' ' AS VARCHAR(14)) AS CODMAT,
       IVE.QTDMOV AS QTDMOV,
       IVE.VLRMOV AS VLRMOV,
       /* BASE DE CALCULO DE ICMS */
       CASE COALESCE(IVE.TIP001,'M') || IVE.ICMTIP WHEN 'M0'
                                                   THEN IVE.ITELIQ - IVE.VLR002 - IVE.REDVLR
                                                   ELSE 0
       END + COALESCE(IVE.VLRFRE,0) + COALESCE(IVE.VLRSEG,0) + COALESCE(IVE.OUTTAX,0) AS BASICM,
       /* ALIQUOTA DE ICMS */
       CASE COALESCE(IVE.TIP001,'M') || IVE.ICMTIP WHEN 'M0'
                                                   THEN COALESCE(IVE.TAX001,0)
                                                   ELSE 0
       END AS PERICM
  FROM TW_VEN_FIS VEN INNER JOIN TW_IVE_FIS IVE ON VEN.CODFIL = IVE.CODFIL
                                               AND VEN.SEQUEN = IVE.SEQUEN
                                               AND VEN.CODSER = IVE.CODSER
                                               AND VEN.NUMNOT = IVE.NUMNOT
                      INNER JOIN TT_GRA GRA ON GRA.FILMAT = IVE.FILMAT
                                           AND GRA.CODMAT = IVE.CODMAT
                                           AND GRA.CODCOR = IVE.CODCOR
                                           AND GRA.CODTAM = IVE.CODTAM
 WHERE (VEN.MODNOT = '02' OR ((VEN.MODNOT = '65') AND (VEN.FLGEST <> 'C')))
   AND VEN.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
   AND IVE.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
;


-- Autor: Luciano Chiqueti
-- Cliente(s): Gimba

-- Finalidade(s):
-- 1) View GB_PRECOS exibindo preo promocional fora da validade
--    View personalizada que foi incorporada ao sistema a pedido da Gimba GES-2023090831
/*-- SEQ 2568 --*/
/*-- IGNORE ERRO --*/
DROP VIEW GB_PRECOS CASCADE;

/*-- SEQ 2569 --*/
CREATE OR REPLACE VIEW GB_PRECOS AS
SELECT 
    DISTINCT 
    tpr.fildes,
    tpr.codpre,
    tpr.despre,
    cast(CASE WHEN tpr.signat > 0 THEN 'T' ELSE 'F' END as VARCHAR(1)) AS atipre,
    pro.refbas,
    pro.desmat,
    pro.codncm,
    COALESCE(pre.precov, 0) AS precov,
    COALESCE(
       CASE WHEN to_date(to_char(cpm.datval,     'DD/MM/YYYY' || ' 23:59:59'), 'DD/MM/YYYY HH24:MI:SS') >= 
                 to_date(to_char(trunc(agora()), 'DD/MM/YYYY' || ' 23:59:59'), 'DD/MM/YYYY HH24:MI:SS') 
            THEN cpm.precop
       ELSE 0.00 END, 0) AS precop
    from tt_pro pro
   inner join tt_gra gra on gra.filmat = pro.filmat
                        and gra.codmat = pro.codmat
    left join tt_ean ean on ean.filmat = gra.filmat
                        and ean.codmat = gra.codmat
                        and ean.codcor = gra.codcor
                        and ean.codtam = gra.codtam
         join tt_pre pre on pre.filmat = gra.filmat 
                        and pre.codmat = gra.codmat
                        and pre.codcor = gra.codcor
                        and pre.codtam = gra.codtam
         join tt_tpr tpr ON tpr.codfil = pre.filpre
                        and tpr.codpre = pre.codpre  
    left join tt_cpm cpm ON cpm.filpre = pre.filpre 
                        and cpm.seqpre = pre.sequen 
                        and to_date((to_char(cpm.datval,     'DD/MM/YYYY') || ' 23:59:59'), 'DD/MM/YYYY HH24:MI:SS') > 
                            to_date((to_char(trunc(agora()), 'DD/MM/YYYY') || ' 23:59:59'), 'DD/MM/YYYY HH24:MI:SS')
                        and cpm.datini <= to_date((to_char(trunc(agora()), 'DD/MM/YYYY') || ' 23:59:59'), 'DD/MM/YYYY HH24:MI:SS')
  GROUP BY tpr.fildes, 
           tpr.codpre, 
           tpr.despre,
           CASE WHEN tpr.signat > 0 THEN 'T' ELSE 'F' END, 
           pro.refbas, 
           (to_date(to_char(cpm.datval,'DD/MM/YYYY'||' 23:59:59'),'DD/MM/YYYY HH24:MI:SS')), 
           cpm.precop, 
           pre.precov, 
           pro.desmat, 
           pro.codncm;


-- Autor: Manoel - 2020095738
-- Cliente(s): Gimba/PAVIN

-- Finalidade(s):
-- 1) View criada para a PAVIN h muito tempo atrs e reutilizada na GIMBA recentemente
/*-- SEQ 2570 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_GERTEC CASCADE;

/*-- SEQ 2571 --*/
CREATE OR REPLACE VIEW TV_GERTEC AS
SELECT GRA.REFPRO,
       CAST((SELECT PRE.PRECOV
               FROM TT_PRE PRE
              WHERE PRE.FILMAT = GRA.FILMAT
                AND PRE.CODMAT = GRA.CODMAT
                AND PRE.CODCOR = GRA.CODCOR
                AND PRE.CODTAM = GRA.CODTAM
                AND (PRE.FILPRE,PRE.CODPRE) = (SELECT FILPRE,CODPRE FROM TT_CFG)) AS Numeric(12,4)) AS PRECOV,
       CAST(TRIM(CASE WHEN PRO.DESECF IS NULL OR COALESCE(PRO.DESMAT,'') = COALESCE(PRO.ESPMAT,'') THEN PRO.DESMAT ELSE PRO.DESECF END) ||
             CASE WHEN GRA.CODCOR = 0 OR DIV.NOMITE = '--' THEN '' ELSE ' ' || trim(COALESCE(DIV.NOMITE,'')) END ||
             CASE WHEN GRA.CODTAM = 0 OR SUB.NOMITE = '--' THEN '' ELSE ' ' || trim(COALESCE(SUB.NOMITE,'')) END || 
             CASE WHEN PRO.ESPMAT IS NULL OR COALESCE(PRO.DESMAT,'') = COALESCE(PRO.ESPMAT,'') THEN '' ELSE ' ' || COALESCE(PRO.ESPMAT ,'') END AS VARCHAR(254)) AS NOMPRO
  FROM TT_PRO PRO 
 INNER JOIN TT_GRA GRA ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
 INNER JOIN TT_DIV DIV ON GRA.CODCOR = DIV.CODITE
 INNER JOIN TT_SUB SUB ON GRA.CODTAM = SUB.CODITE;



-- Autor: Manoel - 2020095738
-- Cliente(s): Gimba

-- Finalidade(s):
-- 1) View criada para a integrao com sistema da Gimba, com o intuito de exportar referncia de venda e preo promocional
/*-- SEQ 2572 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_GERTEC_EAN CASCADE;

/*-- SEQ 2573 --*/
CREATE OR REPLACE VIEW TV_GERTEC_EAN AS
SELECT GRA.REFPRO,
       CAST(TRIM(CASE WHEN PRO.DESECF IS NULL OR COALESCE(PRO.DESMAT,'') = COALESCE(PRO.ESPMAT,'') THEN PRO.DESMAT ELSE PRO.DESECF END) ||
                CASE WHEN GRA.CODCOR = 0 OR DIV.NOMITE = '--' THEN '' ELSE ' ' || trim(COALESCE(DIV.NOMITE,'')) END ||
                CASE WHEN GRA.CODTAM = 0 OR SUB.NOMITE = '--' THEN '' ELSE ' ' || trim(COALESCE(SUB.NOMITE,'')) END || 
                CASE WHEN PRO.ESPMAT IS NULL OR COALESCE(PRO.DESMAT,'') = COALESCE(PRO.ESPMAT,'') THEN '' ELSE ' ' || COALESCE(PRO.ESPMAT ,'') END AS VARCHAR(254)) AS NOMPRO,
       EAN.CODEAN,
       DFIL.CODFIL,
       PrecoPorFilial(GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, DFIL.CODFIL, 'F') AS PRECO_VENDA,
       PrecoPorFilial(GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, DFIL.CODFIL, 'T') AS PRECO_PROMOCIONAL
  FROM TT_PRO PRO 
 INNER JOIN TT_GRA GRA ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
 INNER JOIN TT_DIV DIV ON GRA.CODCOR = DIV.CODITE 
 INNER JOIN TT_SUB SUB ON GRA.CODTAM = SUB.CODITE
  LEFT JOIN TT_EAN EAN ON EAN.FILMAT = GRA.FILMAT 
                      AND EAN.CODMAT = GRA.CODMAT
                      AND EAN.CODCOR = GRA.CODCOR
                      AND EAN.CODTAM = GRA.CODTAM
 CROSS JOIN TD_FIL DFIL;


-- Finalidade(s):
-- 1) Calcula as grandezas da carga (Peso,volume,valor)
/*-- SEQ 2574 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_GRACAR CASCADE;

/*-- SEQ 2575 --*/
CREATE OR REPLACE VIEW TV_GRACAR AS
SELECT IVO.FILROM,
       IVO.SEQROM,
       SUM(COALESCE(GRA.PESBRU,0)*COALESCE(IVO.CONTEM,0)) AS PESBRU,
       SUM(COALESCE(GRA.VOLUME,0)*COALESCE(IVO.CONTEM,0)) AS VOLUME,
       SUM(COALESCE(IVO.VLRITE,0)*COALESCE(IVO.CONTEM,0)) AS VLRITE
  FROM (
        SELECT IVO.FILROM,
               IVO.SEQROM,
               IVO.CONTEM,
               IOR.FILMAT,
               IOR.CODMAT,
               IOR.CODCOR,
               IOR.CODTAM,
               IOR.VLRITE AS VLRITE
          FROM TT_IVO IVO INNER JOIN TT_IOR IOR ON IOR.CODFIL = IVO.FILPED
                                               AND IOR.TIPPED = IVO.TIPPED
                                               AND IOR.NUMPED = IVO.NUMPED
                                               AND IOR.NUMITE = IVO.NUMITE
         WHERE IVO.FLGEST = 'P'
           AND IOR.QTDITE > 0
        UNION ALL
        SELECT IVO.FILROM,
               IVO.SEQROM,
               IVO.CONTEM,
               IVE.FILMAT,
               IVE.CODMAT,
               IVE.CODCOR,
               IVE.CODTAM,
               IVE.VLRMOV/IVE.QTDMOV AS VLRITE
          FROM TT_IVO IVO INNER JOIN TT_IVE IVE ON IVE.CODFIL = IVO.FILIVE
                                               AND IVE.SEQUEN = IVO.SEQIVE
                                               AND IVE.NUMITE = IVO.NUMIVE
         WHERE IVO.FLGEST = 'P'
           AND IVE.QTDMOV > 0
       ) IVO INNER JOIN TT_GRA GRA ON GRA.FILMAT = IVO.FILMAT
                                  AND GRA.CODMAT = IVO.CODMAT
                                  AND GRA.CODCOR = IVO.CODCOR
                                  AND GRA.CODTAM = IVO.CODTAM
GROUP BY IVO.FILROM, IVO.SEQROM;


-- Autor: Luciano Chiqueti
-- Cliente(s): Casa Carneiro
 
-- Finalidade(s):
-- 1) Gerar relatrio de Valor de Compra de produtos pelo Custo em determinada data
/*-- SEQ 2576 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ICO_CUS CASCADE;

/*-- SEQ 2577 --*/
CREATE OR REPLACE VIEW TV_ICO_CUS AS
SELECT ICO.CODFIL,
       ICO.COM_DATOPE,
       ICO.FILMAT,
       ICO.CODMAT,
       ICO.CODCOR,
       ICO.CODTAM,
       ICO.VLRMOV,
       COM.FILFOR,
       COM.CODFOR,
       COM.CODSER,
       COM.NUMNOT,
       ICO.CODCFO AS CODNAT,
       ICO.UNICOM,
       ICO.QTDMOV,
       CUSTODATA('1', ICO.COM_DATOPE, ICO.FILMAT, ICO.CODMAT, ICO.CODCOR, ICO.CODTAM, ICO.CODFIL, ICO.CODMUL) AS CUSCOM,
       CUSTODATA('1', ADD_SECOND(ICO.COM_DATOPE, '-1'), ICO.FILMAT, ICO.CODMAT, ICO.CODCOR, ICO.CODTAM, ICO.CODFIL, ICO.CODMUL) AS ULTCOM
  FROM TT_ICO ICO INNER JOIN TT_COM COM ON COM.CODFIL = ICO.CODFIL AND COM.SEQUEN = ICO.SEQUEN
;


-- Autor: Rodrigo F. M. Petters
-- Cliente(s): Casa Carneiro (tarefa 94319)
-- Finalidade(s):
-- 1) Facilitar relacionamento das TT_INFs com TT_GRAs no TotallNfeGX.
/*-- SEQ 2578 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_INF CASCADE;

/*-- SEQ 2579 --*/
CREATE OR REPLACE VIEW TV_INF AS
SELECT INF.inf_id_item,
       INF.nfe_id_doc,
       GRA.FILMAT,
       GRA.CODMAT,
       GRA.CODCOR,
       CAST(COALESCE(DSUB.CODSAL,SUB.CODITE) AS Numeric(5)) AS CODTAM,
       CAST(COALESCE(INF.inf_nu_qtrib,0) AS Numeric(12,4)) AS QTDMOV,
       CAST((INF.INF_vl_prod + COALESCE(INF.inf_vl_IPI,0)) AS Numeric(14,2)) AS VLRMOV,
       CAST(CASE WHEN DSUB.CODSAL IS NULL THEN NULL
            ELSE COALESCE(INF.inf_nu_qcom,0)
       END AS Numeric(12,4)) AS EMBQTD,
       CAST(CASE WHEN DSUB.CODSAL IS NULL THEN NULL
                 ELSE SUB.CODITE
            END AS Numeric(5)) AS EMBORI
  FROM TT_INF INF INNER JOIN TT_GRA GRA ON GRA.FILMAT = INF.inf_filmat
                                       AND GRA.CODMAT = INF.inf_codmat
                                       AND GRA.CODCOR = INF.inf_codcor
                                       AND GRA.CODTAM = INF.inf_codtam
                  INNER JOIN TT_SUB SUB ON SUB.CODITE = GRA.CODTAM
                  INNER JOIN TD_SUB DSUB ON DSUB.CODTAB = SUB.CODSUB
;


-- Autor: Pedro E. Braga
-- Cliente(s): CARNEIRO CASA & CONSTRUCAO LTDA (Tarefa 97887)
-- Finalidade(s):
-- 1) Criao de um TT_IOR Virtual para soma da lucratividade da TT_IORXDET que so os detalhes de produtos Tintas e Kit,
--    quando produto possuir detalhe toda a lucratividade  feita com base no calculo dos detalhes dos itens assim para exibio deve-se considerar a soma da TT_IORXDET e no os dados gravados na TT_IOR.
/*-- SEQ 2580 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IOR_LUC CASCADE;

/*-- SEQ 2581 --*/
CREATE OR REPLACE VIEW TV_IOR_LUC AS
    SELECT IOR.CODFIL, IOR.NUMPED, IOR.TIPPED, IOR.NUMITE,
           IOR.FILMAT, IOR.CODMAT, IOR.CODCOR, IOR.CODTAM,
           IOR.VLRITE, IOR.FLGEST, IOR.QTDITE, IOR.ORDITE,
           COALESCE(IOR.DESRAT,0) AS DESRAT, COALESCE(IOR.VLRFRE,0) AS VLRFRE,
           COALESCE(IOR.VLRSEG,0) AS VLRSEG,
           SUM(COALESCE(IXD.CUSPRO,IOR.CUSPRO)) AS CUSPRO,
           SUM(COALESCE(IXD.VLRTOT,IOR.VLRCUS)) AS VLRCUS,
           SUM(COALESCE(IXD.CUSMAR,IOR.CUSMAR)) AS CUSMAR,
           SUM(COALESCE(IXD.VLRPIS,IOR.VLRPIS)) AS VLRPIS,
           SUM(COALESCE(IXD.VLRCOF,IOR.VLRCOF)) AS VLRCOF,
           SUM(COALESCE(IXD.VLRSOC,IOR.VLRSOC)) AS VLRSOC,
           SUM(COALESCE(IXD.VLRIRR,IOR.VLRIRR)) AS VLRIRR,
           SUM(COALESCE(IXD.VLRIPI,IOR.VLRIPI)) AS VLRIPI,
           SUM(COALESCE(IXD.VLROPE,IOR.VLROPE)) AS VLROPE,
           SUM(COALESCE(IXD.PEROPEFIX,IOR.PEROPEFIX)) AS PEROPEFIX,
           SUM(COALESCE(IXD.VLROPEFIX,IOR.VLROPEFIX)) AS VLROPEFIX,
           SUM(COALESCE(IXD.VLRICM,IOR.VLRICM)) AS VLRICM,
           SUM(COALESCE(IXD.VLRCOM,IOR.VLRCOM)) AS VLRCOM,
           SUM(COALESCE(IXD.PERMCP,IOR.PERMCP)) AS PERMCP,
           SUM(COALESCE(IXD.VLRMCP,IOR.VLRMCP)) AS VLRMCP,
           SUM(COALESCE(IXD.PERMCO,IOR.PERMCO)) AS PERMCO,
           SUM(COALESCE(IXD.VLRMCO,IOR.VLRMCO)) AS VLRMCO,
           SUM(COALESCE(IXD.PERLUC,IOR.PERLUC)) AS PERLUC,
           SUM(COALESCE(IXD.VLRLUC,IOR.VLRLUC)) AS VLRLUC
      FROM TT_IOR IOR
 LEFT JOIN TT_IORXDET IXD ON IOR.CODFIL=IXD.FILPED
                         AND IOR.NUMPED=IXD.NUMPED
                         AND IOR.TIPPED=IXD.TIPPED
                         AND IOR.NUMITE=IXD.ITEPED
  GROUP BY IOR.CODFIL, IOR.NUMPED, IOR.TIPPED, IOR.NUMITE,
           IOR.FILMAT, IOR.CODMAT, IOR.CODCOR, IOR.CODTAM,
           IOR.VLRITE, IOR.FLGEST, IOR.QTDITE, IOR.ORDITE,
           COALESCE(IOR.DESRAT,0), COALESCE(IOR.VLRFRE,0),
           COALESCE(IOR.VLRSEG,0)
 ;


-- Autor: Gabriel Felipe Schaefer
-- Cliente(s): CARNEIRO CASA & CONSTRUCAO LTDA
-- Finalidade(s):
-- 1) Criao de relatrio de Venda Sob Encomenda
/*-- SEQ 2582 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IVEXIPE CASCADE;

/*-- SEQ 2583 --*/
CREATE OR REPLACE VIEW TV_IVEXIPE AS
SELECT VEN.CODFIL AS CODFIL_VEN, VEN.FILVEN, VEN.CODVEN, VEN.CODSER, VEN.NUMECF, VEN.NUMNOT, VEN.FILCLI, VEN.CODCLI,
       IOR.CODFIL AS FILIOR, IOR.NUMPED, IOR.TIPENT, IOR.CODMUL,
       COM.DATOPE,
       IXI.FLGEST, IXI.FILMAT, IXI.CODMAT, IXI.CODCOR, IXI.CODTAM, IXI.QTDENC
  FROM TT_IVEXIPE IXI INNER JOIN TT_IVE IVE ON IVE.CODFIL = IXI.FILIVE
                                           AND IVE.SEQUEN = IXI.SEQIVE
                                           AND IVE.NUMITE = IXI.NUMIVE
                      INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL
                                           AND VEN.SEQUEN = IVE.SEQUEN
                      INNER JOIN TT_IOR IOR ON IOR.FILIVE = IXI.FILIVE
                                           AND IOR.SEQIVE = IXI.SEQIVE
                                           AND IOR.NUMIVE = IXI.NUMIVE                                                                                      
                      INNER JOIN TT_IPE IPE ON IPE.CODFIL = IXI.FILIPE
                                           AND IPE.NUMPED = IXI.NUMIPE
                                           AND IPE.NUMITE = IXI.ITEIPE
                      INNER JOIN TT_ICO ICO ON ICO.CODFIL = IPE.FILICO
                                           AND ICO.SEQUEN = IPE.SEQICO
                                           AND ICO.NUMITE = IPE.NUMICO                                                                                                                                   
                      INNER JOIN TT_COM COM ON COM.CODFIL = ICO.CODFIL
                                           AND COM.SEQUEN = ICO.SEQUEN
 ORDER BY COM.DATOPE DESC
 ;


-- Autor: Rodrigo F. M. Petters
-- Cliente(s): Casa Carneiro (tarefa 94319)
-- Finalidade(s):
-- 1) Visualizar no TotallNfeGX os itens de venda agrupados pelas mesmas colunas usadas pelo Checkout.
/*-- SEQ 2584 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IVE_AGR CASCADE;

/*-- SEQ 2585 --*/
CREATE OR REPLACE VIEW TV_IVE_AGR AS
SELECT IVE.CODFIL,
       IVE.SEQUEN,
       CAST(MIN(IVE.NUMITE) AS Numeric(5)) AS NUMITE,
       IVE.FILMAT,
       IVE.CODMAT,
       CAST(MIN(IVE.CODCOR) AS Numeric(5)) AS CODCOR,
       CAST(MIN(IVE.CODTAM) AS Numeric(5)) AS CODTAM,
       SUM(IVE.QTDMOV) AS QTDMOV,
       SUM(IVE.VLRMOV) AS VLRMOV,
       CAST(MIN(IVE.EMBQTD) AS Numeric(12,4)) AS EMBQTD,
       CAST(MIN(IVE.EMBORI) AS Numeric(5)) AS EMBORI,
       IVE.SITMOV,
       IVE.SITKIT,
       IVE.CODMOT,
       IVE.CODCNC
  FROM TT_IVE IVE
 GROUP BY IVE.CODFIL, IVE.SEQUEN, IVE.FILMAT, IVE.CODMAT, IVE.VLRUNI,
          IVE.SITPIS, IVE.SITCOF, IVE.SITMOV, IVE.SITKIT, IVE.CODMOT, IVE.CODCNC
;


-- Autor:Luciano Chiqueti
-- Cliente(s): GIMBA

-- Finalidade(s):
-- 1) View criada para atender ao relatrio de Vendas com Campanhas promocionais
/*-- SEQ 2586 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IVXC_CPR CASCADE;

/*-- SEQ 2587 --*/
CREATE OR REPLACE VIEW TV_IVXC_CPR AS
SELECT 
    IVXC.FILIVE,
    IVXC.SEQIVE,
    IVXC.NUMIVE,
    IVXC.VLRMOV,
    IVXC.QTDMOV,
    CPR.CPRATI,
    CPR.DESCRI
  FROM TT_IVEXCPR IVXC
  JOIN TT_CPR CPR ON IVXC.FILCPR = CPR.CODFIL AND IVXC.SEQCPR = CPR.SEQUEN;


-- Autor: Luciano Chiqueti
-- Cliente(s): Gimba

-- Finalidade(s):
-- 1) Exibir as informaes de Remessa e Retorno de boletos
/*-- SEQ 2588 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IXT_RTB CASCADE;

/*-- SEQ 2589 --*/
CREATE OR REPLACE VIEW TV_IXT_RTB AS
SELECT ATB.FILREC,
       ATB.SEQREC,
       ATB.PARREC,
       ATB.SUBREC,
       ATB.FILTIT,
       ATB.SEQTIT,
       ATB.TIPCNB,
       ATB.DATMOV,
       ATB.CODREM,
       ATB.DATCRE,
       ATB.VLRCRE,
       ATB.CODMOV,
       ATB.DESMSG
  FROM ( SELECT TIT.CODFIL AS FILTIT,
                TIT.SEQUEN AS SEQTIT,
                TIT.FILREC,
                TIT.SEQREC,
                TIT.PARREC,
                TIT.SUBREC,
                CAST('M' AS CHAR(1)) AS TIPCNB,
                IXT.DATENV AS DATMOV,
                IXT.CODREM,
                TO_DATE(NULL,'DD/MM/YYYY') AS DATCRE,
                CAST(NULL AS Numeric(15,2)) AS VLRCRE,
                CAST(NULL AS Numeric(2,0)) AS CODMOV,
                CAST(DREM.DESREM AS VARCHAR(100)) AS DESMSG
           FROM TT_TIT TIT JOIN TT_IXT IXT ON IXT.CODFIL = TIT.CODFIL
                                          AND IXT.SEQTIT = TIT.SEQUEN
                           JOIN TD_REM DREM ON DREM.CODTAB = IXT.CODREM
        UNION ALL
        SELECT TIT.CODFIL AS FILTIT,
               TIT.SEQUEN AS SEQTIT,
               TIT.FILREC,
               TIT.SEQREC,
               TIT.PARREC,
               TIT.SUBREC,
               CAST('R' AS CHAR(1)) AS TIPCNB,
               RTB.DATOCO AS DATMOV,
               CAST(NULL AS Numeric(5,0)) AS CODREM,
               RTB.DATCRE,
               RTB.VLRCRE,
               RTB.CODMOV,
               CAST(RTB.DESRET AS VARCHAR(100)) AS DESMSG
          FROM TT_TIT TIT JOIN TT_RTB RTB ON RTB.NOSNUM = SUBSTR(TIT.NOSNUM, 1, 11)
      ) ATB
 ORDER BY ATB.FILTIT, ATB.SEQTIT, ATB.DATMOV
;


/*-- SEQ 2590 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_LGPD CASCADE;

/*-- SEQ 2591 --*/
CREATE OR REPLACE VIEW TV_LGPD AS
SELECT -- CAMPOS TT_ARQ
       ARQ.NOMTAB AS TV_LGPD_NOMTAB,
       -- CAMPOS TT_LAY
       LAY.CODTAB AS TV_LGPD_CODTAB, LAY.NOMCPO AS TV_LGPD_NOMCPO, LAY.TIP_LGPD AS TV_LGPD_TIP_LGPD_PADRAO,
       LAY.DESCPO AS TV_LGPD_DESCPO,
       -- CAMPOS TT_LAYXLGPD
       LAYXLGPD.ID_LAYXLGPD AS TV_LGPD_ID_LAYXLGPD, LAYXLGPD.TIP_LGPD AS TV_LGPD_TIP_LGPD
  FROM TT_LAY LAY INNER JOIN TT_ARQ ARQ ON LAY.CODTAB = ARQ.CODTAB
                  LEFT JOIN TT_LAYXLGPD LAYXLGPD ON LAY.CODTAB = LAYXLGPD.CODTAB
                                                AND LAY.NOMCPO = LAYXLGPD.NOMCPO
 -- MN - Tabelas "controladas" pela LGPD, por terem relao com o Cliente. Somente Pessoa Fsica  controlada na LGPD
 WHERE (LAY.CODTAB IN ('CBP ', 'CFIL', 'CLI ', 'CON ', 'DSC ', 'EDE ', 'LIM ', 'LXF ', 'SPC ', 'TRFC', 'VEI '))
   -- MN - Condio abaixo para no trazer campos calculados ou com frmulas
   AND LAY.EXPRES NOT LIKE '%:%'
 ORDER BY LAY.CODTAB, LAY.NOMCPO
;


/*-- SEQ 2592 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_LOG_INTEGRACAOEME4 CASCADE;

/*-- SEQ 2593 --*/
CREATE OR REPLACE VIEW TV_LOG_INTEGRACAOEME4 AS
SELECT  LSVM.CODTAB,
        LSVM.DATOPE,
        LSVM.ORILOG,
        CAST(DescricaoDominio('LSVM','ORILOG',TO_CHAR(LSVM.ORILOG)) AS VARCHAR(40)) AS DESORILOG,
        LSVM.TIPLOG,
        CAST(DescricaoDominio('LSVM','TIPLOG',TO_CHAR(LSVM.TIPLOG)) AS VARCHAR(40)) AS DESTIPLOG,
        LSVM.NIVLOG,
        LSVM.MSGLOG
  FROM TL_SRV_MID LSVM 
 WHERE LSVM.ORILOG = 1
;


/*-- SEQ 2594 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_MAX_VEN_CLI CASCADE;

/*-- SEQ 2595 --*/
CREATE OR REPLACE VIEW TV_MAX_VEN_CLI AS
SELECT TAB.*, VEN.VLRLIQ, VEN.DATHOR
  FROM (             
SELECT VEN.FILCLI, 
       VEN.CODCLI,
       VEN.FLGEST, 
       VEN.LANVEN, 
       VEN.FINANC, 
       VEN.CODFIL, 
       CAST(MAX(VEN.SEQUEN) AS CHAR(10)) AS SEQUEN
  FROM TT_VEN VEN
 GROUP BY VEN.FILCLI, VEN.CODCLI, VEN.FLGEST, VEN.LANVEN, VEN.FINANC, VEN.CODFIL) TAB
INNER JOIN TT_VEN VEN ON VEN.CODFIL = TAB.CODFIL
                     AND VEN.SEQUEN = TAB.SEQUEN
ORDER BY TAB.FILCLI, TAB.CODCLI, TAB.FLGEST, TAB.LANVEN, TAB.FINANC;


-- Autor: Jardel - 2024034126

-- Finalidade(s):
-- 1) View criada para retornar os meios de pagamento disponveis para cada plano.
--    O retorno  similiar ao campo Mei_Tipo gerado na tabela "Meio" do POS, alteraes podem ser necessrias.
--    Passar filtro utilizando FILPGT e CODPGT para pegar meios de determinado plano.
/*-- SEQ 2596 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_MEIOS_PAGAMENTO_DISPONIVEIS CASCADE;

/*-- SEQ 2597 --*/
CREATE OR REPLACE VIEW TV_MEIOS_PAGAMENTO_DISPONIVEIS AS
SELECT CAST('R' AS VARCHAR(1)) AS LetraMeio, 
       CAST('Dinheiro' AS VARCHAR(100)) AS DescricaoMeio, 
       pla.filpgt AS filpgt,
       pla.codpgt AS codpgt
  FROM tt_pla pla                                                                                    
-- WHERE pla.usadin = 'T'                                                                            
UNION ALL       
SELECT CAST('B' AS VARCHAR(1)) AS LetraMeio, 
       CAST('Boleto' AS VARCHAR(100)) AS DescricaoMeio, 
       pla.filpgt AS filpgt,
       pla.codpgt AS codpgt
  FROM tt_pla pla                                                                                                                                                             
UNION ALL                                                                              
SELECT CAST('N' AS VARCHAR(1)) AS LetraMeio, 
       CAST('Carn' AS VARCHAR(100)) AS DescricaoMeio,
       pla.filpgt AS filpgt,
       pla.codpgt AS codpgt       
  FROM tt_pla pla                                                                                                                                                              
UNION ALL                                                                                              
SELECT CAST('E' AS VARCHAR(1)) AS LetraMeio, 
       CAST('U$' AS VARCHAR(100)) AS DescricaoMeio,
       pla.filpgt AS filpgt,
       pla.codpgt AS codpgt
  FROM tt_pla pla                                                                                    
 WHERE pla.usacam = 'T'                                                                            
UNION ALL                                                                                            
SELECT CAST('H' AS VARCHAR(1)) AS LetraMeio, 
       CAST('Cheque' AS VARCHAR(100)) AS DescricaoMeio,
       pla.filpgt AS filpgt,
       pla.codpgt AS codpgt      
  FROM tt_pla pla                                                                                    
 WHERE pla.usache = 'T'                                                                            
UNION ALL                                                                                           
SELECT CAST('1' AS VARCHAR(1)) AS LetraMeio, 
       CAST('Carto de Dbito' AS VARCHAR(100)) AS DescricaoMeio,
       pla.filpgt AS filpgt,
       pla.codpgt AS codpgt      
  FROM tt_pla pla                                                                                    
 WHERE pla.usacre = 'T'                                                                            
UNION ALL
SELECT CAST('2' AS VARCHAR(1)) AS LetraMeio, 
       CAST('Carto de Crdito' AS VARCHAR(100)) AS DescricaoMeio,
       pla.filpgt AS filpgt,
       pla.codpgt AS codpgt      
  FROM tt_pla pla                                                                                    
 WHERE pla.usacre = 'T'                                                                            
UNION ALL   
SELECT CAST('3' AS VARCHAR(1)) AS LetraMeio, 
       CAST('Dbito em Conta-Corrente' AS VARCHAR(100)) AS DescricaoMeio,
       pla.filpgt AS filpgt,
       pla.codpgt AS codpgt
  FROM tt_pla pla 
 WHERE pla.usadeb = 'T'  
UNION ALL    
SELECT CAST('C' AS VARCHAR(1)) AS LetraMeio, 
       CAST('Crdito Via TEF' AS VARCHAR(100)) AS DescricaoMeio,
       pla.filpgt AS filpgt,
       pla.codpgt AS codpgt
  FROM tt_pla pla 
 WHERE pla.usatef = 'T'  
UNION ALL   
SELECT CAST('D' AS VARCHAR(1)) AS LetraMeio, 
       CAST('Dbito Via TEF' AS VARCHAR(100)) AS DescricaoMeio,
       pla.filpgt AS filpgt,
       pla.codpgt AS codpgt
  FROM tt_pla pla 
 WHERE pla.usatef = 'T'  
UNION ALL   
SELECT CAST('?' AS VARCHAR(1)) AS LetraMeio, 
       CAST('Carto Prprio - TODO' AS VARCHAR(100)) AS DescricaoMeio,
       pla.filpgt AS filpgt,
       pla.codpgt AS codpgt
  FROM tt_pla pla 
 WHERE pla.usacpp = 'T'  
UNION ALL   
SELECT CAST('O' AS VARCHAR(1)) AS LetraMeio, 
       CAST('Outros' || ' - ' || out.descar AS VARCHAR(100)) AS DescricaoMeio,
       pla.filpgt AS filpgt,
       pla.codpgt AS codpgt
  FROM tt_pla pla 
  LEFT JOIN td_out out ON pla.plaout = out.codtab 
 WHERE pla.usaout = 'T'  
   AND out.descar IS NOT NULL 
UNION ALL   
SELECT CAST('F' AS VARCHAR(1)) AS LetraMeio, 
       CAST('Conta-Corrente' || ' - ' || ccc.desccc AS VARCHAR(100)) AS DescricaoMeio,
       pla.filpgt AS filpgt,
       pla.codpgt AS codpgt
  FROM tt_pla pla 
  LEFT JOIN TD_CCC CCC ON pla.tipccc = ccc.codtab 
 WHERE pla.usac_c = 'T'  
   AND ccc.cccati = 'T'  
   AND ccc.desccc IS NOT NULL 
UNION ALL    
SELECT CAST('1' AS VARCHAR(1)) AS LetraMeio, 
       CAST('Dbito' || ' - ' || car.desout AS VARCHAR(100)) AS DescricaoMeio,
       pla.filpgt AS filpgt,
       pla.codpgt AS codpgt
  FROM tt_pla pla                                                                              
  LEFT JOIN TT_PLAXCAR PXC ON pla.filpgt = pxc.filpgt                                          
                          AND pla.codpgt = pxc.codpgt                                                                 
  LEFT JOIN TD_CAR CAR     ON CAR.CODTAB = pxc.cartao                                          
 WHERE CAR.CARATI = 'T'                                                                     
   AND PXC.FLGDEB = 'T'                                                                       
UNION ALL                                                                                    
SELECT CAST('2' AS VARCHAR(1)) AS LetraMeio, 
       CAST('Crdito' || ' - ' || car.desout AS VARCHAR(100)) AS DescricaoMeio,
       pla.filpgt AS filpgt,
       pla.codpgt AS codpgt
  FROM tt_pla pla 
  LEFT JOIN TT_PLAXCAR PXC ON pla.filpgt = pxc.filpgt 
                          AND pla.codpgt = pxc.codpgt 
  LEFT JOIN TD_CAR CAR     ON CAR.CODTAB = pxc.cartao 
 WHERE CAR.CARATI = 'T'  
   AND PXC.FLGCRE = 'T';


-- Autor: Anderson Alexandre Favero
-- Cliente(s): JW COSMETICOS EIRELI - EPP
-- Finalidade(s):
-- 1) Mostrar Metas Alcanadas Por Categoria
/*-- SEQ 2598 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_MET_IVE2 CASCADE;

/*-- SEQ 2599 --*/
CREATE OR REPLACE VIEW TV_MET_IVE2 AS
SELECT FILUSU, CODUSU, ANOREF, MESREF, VALOR1, VALOR2, VALOR3, VALOR4, cATEG1,
       COMIS1, COMIS2, COMIS3, COMIS4, VLRREA, CNTVEN, SUBSTT, VLRIPI, 
       VLRPROPOR, 
       CASE 0 WHEN ABS(VLRREA-VALOR4)-(VLRREA-VALOR4) THEN VALOR4
              WHEN ABS(VLRREA-VALOR3)-(VLRREA-VALOR3) THEN VALOR3
              WHEN ABS(VLRREA-VALOR2)-(VLRREA-VALOR2) THEN VALOR2
              WHEN ABS(VLRREA-VALOR1)-(VLRREA-VALOR1) THEN VALOR1
              ELSE 0
       END AS VALALC,
       CASE 0 WHEN ABS(VLRREA-VALOR4)-(VLRREA-VALOR4) THEN COMIS4
              WHEN ABS(VLRREA-VALOR3)-(VLRREA-VALOR3) THEN COMIS3
              WHEN ABS(VLRREA-VALOR2)-(VLRREA-VALOR2) THEN COMIS2
              WHEN ABS(VLRREA-VALOR1)-(VLRREA-VALOR1) THEN COMIS1
              ELSE 0
       END AS PREMI
FROM (
      SELECT MET.FILUSU, MET.CODUSU, MET.ANOREF, MET.MESREF, CLI.CATEG1,
             MIN(MET.VALOR1) AS VALOR1, MIN(MET.VALOR2) AS VALOR2,
             MIN(MET.VALOR3) AS VALOR3, MIN(MET.VALOR4) AS VALOR4,
             MIN(MET.COMIS1) AS COMIS1, MIN(MET.COMIS2) AS COMIS2,
             MIN(MET.COMIS3) AS COMIS3, MIN(MET.COMIS4) AS COMIS4, 
             SUM(COALESCE(VEN.VLRLIQ,0)) AS VLRREA,
             SUM(COALESCE(IVE.SUBSTT,0)) AS SUBSTT,
             SUM(COALESCE(IVE.VLRIPI,0)) AS VLRIPI,
             SUM(COALESCE(VEN.VLRLIQ,0) * (CASE WHEN VEN.VLRNOT = 0 THEN 0 ELSE IVE.VLRMOV / VEN.VLRNOT END)) AS VLRPROPOR,
             CAST(COUNT(DISTINCT VEN.SEQUEN) AS INTEGER) AS CNTVEN
        FROM TT_MET MET  
  LEFT JOIN TT_VEN VEN ON VEN.FILVEN = MET.FILUSU 
                       AND VEN.CODVEN = MET.CODUSU
                       AND VEN.DATHOR BETWEEN TO_DATE('01' || TO_CHAR(MET.MESREF,'FM09') || TO_CHAR(MET.ANOREF,'FM0999'),'DDMMYYYY')
                       AND TO_DATE(TO_CHAR(LAST_DAY( TO_DATE('01' || TO_CHAR(MET.MESREF,'FM09') || 
                           TO_CHAR(MET.ANOREF,'FM0999'),'DDMMYYYY') ),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
                       AND VEN.FLGEST <> 'C'                                                                   -- ignora canceladas
                       AND VEN.LANVEN = 'T'                                                                    -- lancado como venda
                       AND VEN.FINANC = 'T'                                                                    -- gerou dado financeiro a receber
  LEFT JOIN TT_IVE IVE ON IVE.SEQUEN = VEN.SEQUEN 
                       AND IVE.CODFIL = VEN.CODFIL
                       AND IVE.SITMOV <> 'C'
  LEFT JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI
                      AND CLI.CODCLI = VEN.CODCLI  
      GROUP BY MET.FILUSU, MET.CODUSU, MET.ANOREF, MET.MESREF, CLI.CATEG1 
     ) TABELA
     ;


-- Autor: Luciano
-- Cliente(s): ANGELI E DIAS COMERCIO LTDA
-- Finalidade(s): 
-- 1) Obter o movimento por marca
/*-- SEQ 2600 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_MOV_MARCA CASCADE;

/*-- SEQ 2601 --*/
CREATE OR REPLACE VIEW TV_MOV_MARCA AS
 SELECT SAL.CODFIL,
        PRO.FILMAT,
        PRO.CODMAT,
        INI.DATOPE AS DATINI,
        FIM.DATOPE AS DATFIM,
        SAL.CODMUL,
        PRO.CLASS1,
        PRO.CLASS2,
        PRO.CLASS3,
        PRO.CLASS4,
        PRO.FILMAR,
        PRO.CODMAR,
        PRO.ITEMAR,
        PRO.TIPMAR,
        SUM(COALESCE(SALDODAFILIAL(ADD_DAY(TRUNC(INI.DATOPE), '-1'), SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, SAL.CODFIL, SAL.CODMUL), 0)) AS SALINI,
            CASE
                WHEN SAL.CODMUL <> 0 THEN 0
                ELSE SUM(COALESCE(QTDCOMPRAPRODUTO(INI.DATOPE, FIM.DATOPE, GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, SAL.CODFIL), 0))
            END AS QTDCOM,
        SUM(COALESCE(TOTALVENDA(INI.DATOPE, FIM.DATOPE, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, SAL.CODFIL, SAL.CODMUL), 0)) AS QTDVEN,
        SUM(COALESCE(VALORCOMPRAPRODUTO(INI.DATOPE, FIM.DATOPE, GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, SAL.CODFIL), 0)) AS VLRCOM,
        SUM(COALESCE(VALORVENDAPRODUTO(INI.DATOPE, FIM.DATOPE, GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, SAL.CODFIL), 0)) AS VLRVEN,
        SUM(COALESCE(SALDODAFILIAL(FIM.DATOPE, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, SAL.CODFIL, SAL.CODMUL), 0)) AS SALFIL
   FROM TT_PRO PRO INNER JOIN TT_GRA GRA ON PRO.FILMAT = GRA.FILMAT 
	                                     AND PRO.CODMAT = GRA.CODMAT
                   INNER JOIN TT_SAL SAL ON SAL.FILMAT = GRA.FILMAT 
	                                     AND SAL.CODMAT = GRA.CODMAT 
	                                     AND SAL.CODCOR = GRA.CODCOR 
					                         AND SAL.CODTAM = GRA.CODTAM
     CROSS JOIN TT_DAT INI
     CROSS JOIN TT_DAT FIM
  GROUP BY SAL.CODFIL, PRO.FILMAT, PRO.CODMAT, INI.DATOPE, FIM.DATOPE, 
           SAL.CODMUL, PRO.CLASS1, PRO.CLASS2, PRO.CLASS3, PRO.CLASS4, 
		   PRO.FILMAR, PRO.CODMAR, PRO.ITEMAR, PRO.TIPMAR
;


-- Autor: Luciano
-- Cliente(s): PAVIN
-- Finalidade(s):
-- 1) Auxiliar na obteno das Origens de Vendas Renegociadas
/*-- SEQ 2602 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_VEN_ORI_RENEGOCIACAO CASCADE;

/*-- SEQ 2603 --*/
CREATE OR REPLACE VIEW TV_VEN_ORI_RENEGOCIACAO AS
SELECT VE1.CODFIL AS CODFIL_REN, VE1.SEQUEN AS SEQUEN_REN, VE1.DATHOR AS DATHOR_REN,
       VE1.CODSER AS CODSER_REN, VE1.NUMECF AS NUMECF_REN, VE1.NUMNOT AS NUMNOT_REN,
       VE1.FILVEN AS FILVEN_REN, VE1.CODVEN AS CODVEN_REN, VE1.VLRLIQ AS VLRLIQ_REN,
       VEN.CODFIL AS CODFIL_ORI, VEN.SEQUEN AS SEQUEN_ORI, VEN.DATHOR AS DATHOR_ORI,
       VEN.CODSER AS CODSER_ORI, VEN.NUMECF AS NUMECF_ORI, VEN.NUMNOT AS NUMNOT_ORI,
       VEN.FILVEN AS FILVEN_ORI, VEN.CODVEN AS CODVEN_ORI, VEN.VLRLIQ AS VLRLIQ_ORI,
       VEN.FILCLI AS FILCLI_REN, VEN.CODCLI AS CODCLI_REN, REC.NUMPAR AS NUMPAR_ORI,
       REC.FLGEST AS FLGEST_ORI, REC.VLRPAR AS VLRPAR_ORI, REC.VLRPGT AS VLRPGT_ORI,
       (CASE WHEN CLI.FLGTIP = 0 THEN (CLI.NOMCLI || ' ' || COALESCE(CLI.ULTNOM,'')) ELSE CLI.NOMCLI END) as NOMCLI
  FROM TT_VEN VEN
 INNER JOIN TT_REC REC ON REC.CODFIL = VEN.CODFIL
                      AND REC.SEQUEN = VEN.SEQUEN
 INNER JOIN TT_VEN VE1 ON VE1.CODFIL = REC.FILREN
                      AND VE1.SEQUEN = REC.SEQREN
 INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI 
                      AND CLI.CODCLI = VEN.CODCLI                      
;


-- Autor: Jean Ricardo Otto
-- Cliente(s): Papel & Cia
-- Finalidade(s):
-- 1) Gerar relatrio para apresentar crdito de icms na Devoluo de Compra
/*-- SEQ 2604 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PCIA_EST_ICMS_COMPRA CASCADE;

/*-- SEQ 2605 --*/
CREATE OR REPLACE VIEW TV_PCIA_EST_ICMS_COMPRA AS
SELECT COM.NUMNOT AS COMNUMNOT,
       ICO.BASICM AS ICOBASICM,
       ICO.ICMITE AS ICOICMITE,
       ICO.VLRICM AS ICOVLRICM,
       ICO.QTDMOV AS ICOATQMOV,
       ICO.BASICMDIF AS ICOBASICMDIF,
       ICO.ICMITEDIF AS ICOICMITEDIF,
       ICO.VLRICMDIF AS ICOVLRICMDIF,
       VEN.NUMNOT AS VENNUMNOT,
       VEN_DATHOR AS VENDATHOR,
       IVE.QTDMOV AS IVEQTDMOV,
       IVE.BASICM AS IVEBASICM,
       IVE.VLRICM AS IVEVLRICM,
       (IVE.VLR001 - ROUND((ICO.VLRICMDIF/ICO.QTDMOV)*IVE.QTDMOV,2)) AS ICMEST
  FROM TT_COM COM INNER JOIN TT_ICO ICO ON COM.CODFIL = ICO.CODFIL
                                       AND COM.SEQUEN = ICO.SEQUEN
                  INNER JOIN TT_IVE IVE ON IVE.FILICOORI = ICO.CODFIL
                                       AND IVE.SEQICOORI = ICO.SEQUEN
                                       AND IVE.NUMICOORI = ICO.NUMITE
                  INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL
                                       AND VEN.SEQUEN = IVE.SEQUEN
 WHERE COM.CODFOR <> '     0'
   AND ICO.VLRICM <> ICO.VLRICMDIF
   AND VEN.FLGEST <> 'C'
   AND IVE.SITMOV <> 'C'
;



-- Autor: Luciano Chiqueti
-- Cliente(s): Paris Cosmticos

-- Finalidade(s):
-- 1) Gerar relatrio para exibir o total de vendas de trs meses a partir de uma data
-- Obs: Essa view funciona apenas em PostgreSQL. Caso seja necessrio utiliz-la em Oracle realizar as devidas adaptaes.
/*-- SEQ 2606 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_QDADEMINIMA CASCADE;

/*-- SEQ 2607 --*/
CREATE OR REPLACE VIEW TV_QDADEMINIMA AS
SELECT CODFIL,
       FILMAT,
       CODMAT,
       CODCOR,
       CODTAM,
       CODMUL,
       DATINI,
       MES1,
       MES2,
       MES3,
       QTDMIN,
       (MES1+MES2+MES3) AS TOTAL,
       ROUND((MES1+MES2+MES3)/3,2) AS MEDIA,
       CASE WHEN QTDMIN = 0
            THEN 0
            ELSE ROUND(( ( QTDMIN / ((MES1+MES2+MES3)/3) * 100 ) -100),2) END AS PERCENTUAL
  FROM (
         SELECT CODFIL,
                FILMAT,
                CODMAT,
                CODCOR,
                CODTAM,
                CODMUL,
                DAT.DATOPE AS DATINI,
                CASE WHEN QTDMIN IS NULL THEN 0 ELSE QTDMIN END AS QTDMIN,
                TOTALVENDA(DAT.DATOPE,(DAT.DATOPE + INTERVAL'1 MONTH' - INTERVAL'1 DAY'),SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,SAL.CODFIL,SAL.CODMUL) AS MES1,
                TOTALVENDA(DAT.DATOPE + INTERVAL '1 MONTH',((DAT.DATOPE + INTERVAL '1 MONTH') + INTERVAL'1 MONTH' - INTERVAL'1 DAY'),SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,SAL.CODFIL,SAL.CODMUL) AS MES2,
                TOTALVENDA(DAT.DATOPE + INTERVAL '2 MONTH',((DAT.DATOPE + INTERVAL '2 MONTH') + INTERVAL'1 MONTH' - INTERVAL'1 DAY'),SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,SAL.CODFIL,SAL.CODMUL) AS MES3
           FROM TT_SAL SAL CROSS JOIN TT_DAT DAT
       ) AS TAB
 WHERE (MES1+MES2+MES3) > 0
;


-- Autor: Pedro E. Braga
-- Cliente(s): SALLO CONFECCAO E COMERCIO DE ROUPAS LTDA
-- Tarefa: 104146
 
-- Finalidade(s):
-- 1) Gerar relatrio de "Vendas Nota a Nota x Meio Pagamento x Parcela"
/*-- SEQ 2608 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_REC_MEIODEPAGAMENTO CASCADE;

/*-- SEQ 2609 --*/
CREATE OR REPLACE VIEW TV_REC_MEIODEPAGAMENTO AS
SELECT TAB.*,
       CASE WHEN (Upper(SUBSTR(TAB.MEIPOR, 1, 3)) = 'BOL') THEN 'Boleto' 
            WHEN (Upper(SUBSTR(TAB.MEIPOR, 1, 3)) = 'CAR') THEN 'Carto'
            WHEN (Upper(SUBSTR(TAB.MEIPOR, 1, 3)) = 'C/C') THEN 'Credito Devoluo'
            ELSE TAB.MEIPOR
       END AS MEIPGT
  FROM (SELECT SUB.*, CASE WHEN (SUBSTR(SUB.DESCOB, 1, 3) = 'ECF') THEN SUB.MEIODEPAGAMENTO ELSE SUB.DESCOB END AS MEIPOR
          FROM (SELECT REC.CODFIL, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR, REC.RENEGO, REC.FILITF, REC.SEQITF, REC.ITEITF, REC.FILPGT, REC.CODPGT, REC.PORTAD,
                       REC.FLGEST, REC.VLRPAR, REC.VLRTAX, REC.VLRPGT AS REC_VLRPGT, 
                       (CASE WHEN COALESCE(REC.VLRDES,0) < 0 AND REC.CARTAO IS NULL THEN ABS(REC.VLRDES) ELSE 0 END) AS VLRDES,
                       COALESCE( (SELECT ITF.VLRITE - ABS(ITF.VLRTAX) FROM TT_ITF ITF WHERE ITF.CODFIL = REC.FILITF AND ITF.SEQUEN = REC.SEQITF AND ITF.NUMITE = REC.ITEITF ),COALESCE(REC.VLRPGT,0)) AS VLRPGT,
                       CAST(RTRIM(SUBSTR(MEIODEPAGAMENTO(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR,'0'), 1, 250)) AS VARCHAR(250)) AS MEIODEPAGAMENTO,
                       DCOB.DESCOB
                  FROM TT_REC REC
                  LEFT JOIN TD_COB DCOB ON REC.PORTAD = DCOB.CODTAB
              ) SUB
      ) TAB
;


-- Autor: Gabriel R.
-- Cliente(s): Casas Carneiro
-- Finalidade(s):
-- 1) Ao filtrar um meio de pagamento, mostrar todas as vendas/parcelas onde o meio de pagamento esta presente.
/*-- SEQ 2610 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_REC_MEIPGT CASCADE;

/*-- SEQ 2611 --*/
CREATE OR REPLACE VIEW TV_REC_MEIPGT AS 
  SELECT DISTINCT REC.CODFIL, REC.SEQUEN,
                  MEIODEPAGAMENTO(REC.CODFIL,REC.SEQUEN, REC.NUMPAR, REC.SUBPAR, 1) AS MEIPGT 
  FROM TT_REC REC;


-- Autor: Rhuan R. Cattoni
-- Cliente(s): Gimba

-- Finalidade(s):
-- 1) Gerar relatrio para trazer os Recebimentos "Normais" e Recebimentos de Pendncias
/*-- SEQ 2612 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_REC_RECPEND CASCADE;

/*-- SEQ 2613 --*/
CREATE OR REPLACE VIEW TV_REC_RECPEND AS
SELECT REC.CODFIL,
       REC.SEQUEN,
       REC.NUMPAR,
       REC.SUBPAR,
       REC.FLGEST,
       REC.ATU_EM,
       REC.DATVEN,
       REC.CODMOE,
       REC.SIGNAT,
       REC.VLRPAR,
       REC.FILUSU,
       REC.CODUSU,
       REC.FILREC,
       REC.NUMECF,
       REC.CUPFIS,
       REC.SEQCHE,
       REC.PAGAME,
       REC.CARTAO,
       REC.PORTAD,
       REC.TIPCCC,
       REC.VLRDES,
       REC.VLRPGT,
       REC.CODEXT,
       REC.RENEGO,
       REC.RENORI,
       REC.DATINC,
       REC.DATFIS,
       REC.PROCES,
       REC.VLRTAX,
       REC.ESTCAN,
       REC.FLGFLU,
       REC.DATPRE,
       REC.VLRPRE,
       REC.SUBORI,
       REC.ORIREC,
       REC.CODOUT,
       REC.FILCTA,
       REC.SEQCTA,
       REC.TIPCTA,
       REC.FILREN,
       REC.SEQREN,
       REC.FILITF,
       REC.SEQITF,
       REC.ITEITF,
       REC.OBSERV,
       REC.AVISTA,
       REC.EXPORT,
       REC.FILPGT,
       REC.CODPGT,
       REC.NOSNUM,
       REC.CODFIL AS ORI_CODFIL,
       REC.SEQUEN AS ORI_SEQUEN,
       REC.NUMPAR AS ORI_NUMPAR,
       REC.SUBPAR AS ORI_SUBPAR
  FROM TT_REC REC
 WHERE NOT EXISTS (SELECT 1 AS OK
                     FROM TT_CCC CCC
                    WHERE CCC.CODFIL = REC.FILCCC
                      AND CCC.SEQUEN = REC.SEQCCC
                      AND CCC.TIPCCC = (SELECT CC_PENDENCIA FROM TT_CFG))
UNION ALL
SELECT RECP.CODFIL,
       RECP.SEQUEN,
       RECP.NUMPAR,
       RECP.SUBPAR,
       RECP.FLGEST,
       RECP.ATU_EM,
       RECP.DATVEN,
       RECP.CODMOE,
       RECP.SIGNAT,
       ROUND((RECP.VLRPAR * VEN.VLRLIQ / FAT.VLRLIQ),2) AS VLRPAR,
       RECP.FILUSU,
       RECP.CODUSU,
       RECP.FILREC,
       RECP.NUMECF,
       RECP.CUPFIS,
       RECP.SEQCHE,
       RECP.PAGAME,
       RECP.CARTAO,
       RECP.PORTAD,
       RECP.TIPCCC,
       ROUND((COALESCE(RECP.VLRDES,0) * VEN.VLRLIQ / FAT.VLRLIQ),2) AS VLRDES,
       ROUND((COALESCE(RECP.VLRPGT,0) * VEN.VLRLIQ / FAT.VLRLIQ),2) AS VLRDES,
       RECP.CODEXT,
       RECP.RENEGO,
       RECP.RENORI,
       RECP.DATINC,
       RECP.DATFIS,
       RECP.PROCES,
       ROUND((COALESCE(RECP.VLRTAX,0) * VEN.VLRLIQ / FAT.VLRLIQ),2) AS VLRDES,
       RECP.ESTCAN,
       RECP.FLGFLU,
       RECP.DATPRE,
       ROUND((COALESCE(RECP.VLRPRE,0) * VEN.VLRLIQ / FAT.VLRLIQ),2) AS VLRDES,
       RECP.SUBORI,
       RECP.ORIREC,
       RECP.CODOUT,
       RECP.FILCTA,
       RECP.SEQCTA,
       RECP.TIPCTA,
       RECP.FILREN,
       RECP.SEQREN,
       RECP.FILITF,
       RECP.SEQITF,
       RECP.ITEITF,
       RECP.OBSERV,
       RECP.AVISTA,
       RECP.EXPORT,
       RECP.FILPGT,
       RECP.CODPGT,
       RECP.NOSNUM,
       REC.CODFIL AS ORI_CODFIL,
       REC.SEQUEN AS ORI_SEQUEN,
       REC.NUMPAR AS ORI_NUMPAR,
       REC.SUBPAR AS ORI_SUBPAR
  FROM TT_REC REC INNER JOIN TT_CCC CCC ON CCC.CODFIL = REC.FILCCC
                                       AND CCC.SEQUEN = REC.SEQCCC
                  INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL
                                       AND VEN.SEQUEN = REC.SEQUEN
                  INNER JOIN TT_VEN FAT ON FAT.CODFIL = CCC.FILFAT
                                       AND FAT.SEQUEN = CCC.SEQFAT
                  INNER JOIN TT_REC RECP ON RECP.CODFIL = FAT.CODFIL
                                        AND RECP.SEQUEN = FAT.SEQUEN
                  CROSS JOIN TT_CFG CFG
 WHERE CCC.TIPCCC = CFG.CC_PENDENCIA
;


-- Autor: Luciano
-- Cliente(s): CARNEIRO CASA & CONSTRUCAO LTDA
-- Finalidade(s):
-- 1) Listar os itens com reserva e a origem destas reservas.
/*-- SEQ 2614 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RESERVA CASCADE;

/*-- SEQ 2615 --*/
CREATE OR REPLACE VIEW TV_RESERVA AS
   SELECT INT.CODFIL,
          INT.DATOPE,
          CAST(INT.NUMDOC AS VARCHAR(13)) AS NUMDOC,
          CAST(INT.DESTIP AS VARCHAR(40)) AS DESTIP,
          INT.QTDITE,
          CAST(INT.NOMCLI AS VARCHAR(94)) AS NOMCLI,
          INT.FILMAT,
          INT.CODMAT,
          INT.CODCOR,
          INT.CODTAM
     FROM (SELECT IOR.CODFIL, IOR.QTDITE, 'ORAMENTO' AS DESTIP,
                  ORC.NUMPED AS NUMDOC,
                  ORC.PED_EM AS DATOPE,
                  CLI.NOMCLI || CASE WHEN CLI.FLGTIP = 1 THEN ' ' || CLI.ULTNOM ELSE '' END AS NOMCLI,
                  IOR.FILMAT,
                  IOR.CODMAT,
                  IOR.CODCOR,
                  IOR.CODTAM
             FROM TT_ORC ORC INNER JOIN TT_USU VDD ON VDD.FILUSU = ORC.FILVEN
                                                  AND VDD.CODUSU = ORC.CODVEN
                             INNER JOIN TT_IOR IOR ON IOR.CODFIL = ORC.CODFIL
                                                  AND IOR.TIPPED = ORC.TIPPED
                                                  AND IOR.NUMPED = ORC.NUMPED
                             INNER JOIN TT_CLI CLI ON ORC.FILCLI = CLI.FILCLI
                                                  AND ORC.CODCLI = CLI.CODCLI
            WHERE ORC.RESERV = 'T'
              AND ORC.FLGEST = 'A'
              AND IOR.FLGEST = 'R'
           UNION ALL
           SELECT VEN.CODFIL,
                  COALESCE(RES.QTDPEN,0)-COALESCE(RES.QTDFUT,0) AS QTDITE,
                  NAT.NATURE AS DESTIP,
                  VEN.CODSER||'/'||TRIM(VEN.NUMECF)||'-'||TRIM(VEN.NUMNOT) AS NUMDOC,
                  VEN.DATHOR AS DATOPE,
                  CLI.NOMCLI || CASE WHEN CLI.FLGTIP = 1 THEN ' ' || CLI.ULTNOM ELSE '' END AS NOMCLI,
                  RES.FILMAT,
                  RES.CODMAT,
                  RES.CODCOR,
                  RES.CODTAM
             FROM TT_IVE RES INNER JOIN TT_VEN VEN ON RES.CODFIL = VEN.CODFIL
                                                 AND RES.SEQUEN = VEN.SEQUEN
                            INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
                            INNER JOIN TT_CLI CLI ON VEN.FILCLI = CLI.FILCLI
                                                 AND VEN.CODCLI = CLI.CODCLI
            WHERE RES.LANEST = 'R'
              AND RES.SITMOV = 'N'
              AND COALESCE(RES.QTDPEN,0)-COALESCE(RES.QTDFUT,0)>0
          ) INT
 ORDER BY INT.CODFIL, INT.DATOPE, INT.NUMDOC
;



-- Autor: Manoel Ribeiro
-- Cliente(s): GIMBA
-- Finalidade(s):
-- 1) Identificar os saltos de numerao das notas fiscais
/*-- SEQ 2616 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_SALTONUMERACAO CASCADE;

/*-- SEQ 2617 --*/
CREATE OR REPLACE VIEW TV_SALTONUMERACAO AS
SELECT RELACAO.CODFIL, RELACAO.CODSER, RELACAO.MODNOT, RELACAO.SERECF, RELACAO.SERIE,
       RELACAO.MINNOT, RELACAO.MAXNOT, 
       RELACAO.NUMERO AS NUMERO 
  FROM (SELECT MODSER.*, NUMERO.*
          FROM (SELECT VEN.CODFIL, VEN.CODSER, VEN.MODNOT, CAST(CASE WHEN VEN.CODSER = 'CE' THEN VEN.NUMECF ELSE '000' END AS VARCHAR(3)) AS SERECF,
                        CAST(CAST(CASE WHEN VEN.NUMECF >= '400' THEN VEN.NUMECF ELSE COALESCE(DSER.SEREXT, '0') END AS VARCHAR(3)) AS INTEGER) AS SERIE,
                        MIN(SomenteNumeros(VEN.NUMNOT)) AS MINNOT, 
                        MAX(SomenteNumeros(VEN.NUMNOT)) AS MAXNOT 
                   FROM TT_VEN VEN
                   JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
                   WHERE VEN.MODNOT = '65'
                     AND VEN.DATHOR >= ADD_DAY(AGORA(), -365)
                  GROUP BY VEN.CODFIL, VEN.CODSER, VEN.MODNOT, VEN.NUMECF, CAST(CASE WHEN VEN.CODSER = 'CE' THEN VEN.NUMECF ELSE '000' END AS VARCHAR(3)), DSER.SEREXT 
                UNION ALL
                SELECT VEN.CODFIL, VEN.CODSER, VEN.MODNOT, CAST(CASE WHEN VEN.CODSER = 'CE' THEN VEN.NUMECF ELSE '000' END AS VARCHAR(3)) AS SERECF,
                        CAST(COALESCE(DSER.SEREXT, '0') AS INTEGER) AS SERIE, 
                        MIN(SomenteNumeros(VEN.NUMNOT)) AS MINNOT, 
                        MAX(SomenteNumeros(VEN.NUMNOT)) AS MAXNOT 
                   FROM TT_VEN VEN
                   JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
                  WHERE VEN.MODNOT='55'
                  GROUP BY VEN.CODFIL, VEN.CODSER, VEN.MODNOT, CAST(CASE WHEN VEN.CODSER = 'CE' THEN VEN.NUMECF ELSE '000' END AS VARCHAR(3)), DSER.SEREXT 
                 ) MODSER
          CROSS JOIN GENERATE_SERIES ( MODSER.MINNOT, MODSER.MAXNOT ) NUMERO 
      ) RELACAO
 WHERE 1=1
   AND NOT EXISTS ( SELECT VEN_B.NUMNOT FROM TT_VEN VEN_B JOIN TD_SER DSER_B ON DSER_B.CODSER = VEN_B.CODSER
                     WHERE VEN_B.CODFIL = RELACAO.CODFIL AND VEN_B.CODSER = RELACAO.CODSER
                       AND CAST(CASE WHEN VEN_B.CODSER='CE' THEN VEN_B.NUMECF ELSE '000' END AS VARCHAR(3)) = RELACAO.SERECF 
                       AND CAST(COALESCE(DSER_B.SEREXT,VEN_B.NUMECF) AS INTEGER) = RELACAO.SERIE 
                       AND SomenteNumeros(VEN_B.NUMNOT) = RELACAO.NUMERO )
   AND NOT EXISTS ( SELECT INU.NUMINI FROM TT_INU INU 
                                      JOIN TD_FIL DFIL ON DFIL.CGCFIL = INU.NUMDOC
                     WHERE (RELACAO.NUMERO  BETWEEN INU.NUMINI AND INU.NUMFIM)
                       AND INU.CODSER = RELACAO.SERIE 
                       AND DFIL.CODFIL = RELACAO.CODFIL
                       ) -- VERIFICA SE NOTA J FOI INUTILIZADA
   AND RELACAO.MODNOT IN ('55', '65')
   -- IGNORA SAT, NOTA MANUAL, RECEBIMENTO DE PENDENCIA, TITULO AVULSO E NFSE
   AND RELACAO.CODSER NOT IN ('CF','ST','NM','CC','TR','SE')
ORDER BY RELACAO.CODFIL, RELACAO.MODNOT, RELACAO.NUMERO;


/*-- SEQ 2618 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_SANREF_BARRAS CASCADE;

/*-- SEQ 2619 --*/
CREATE OR REPLACE VIEW TV_SANREF_BARRAS AS
SELECT FIN.CODFIL,
       FIN.SEQUEN,
       FIN.FLGFIN,
       FIN.DOC_ID,
       FIN.VLRMOV,
       CAST(CalcCodBarrasCK4G(CAST(1||FIN.DOC_ID||TO_CHAR(ABS(FIN.VLRMOV*100),'fm00000000') AS VARCHAR(22)),FIN.CODFIL) AS VARCHAR(30)) AS CODBAR
  FROM TT_FIN FIN
 WHERE FIN.DOC_ID IS NOT NULL
   AND FIN.FLGFIN IN ('A','R')
;


-- AUTOR: DANIEL NASCHENWENG
-- FINALIDADE(S): SPED
-- 1) TRAZER A CONTA DE DESPESA PARA SPED CONTRIBUIÇÃO
/*-- SEQ 2620 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_SPED_CTACOM CASCADE;

/*-- SEQ 2621 --*/
CREATE OR REPLACE VIEW TV_SPED_CTACOM AS
SELECT DOC.CODFIL AS FILCOM,
       DOC.SEQUEN AS SEQCOM, 
	   CASE WHEN (DOC.FILCTA IS NULL) OR DOC.TIPNOT = 'F' THEN CASE WHEN CTACFO.SEQUEN IS NOT NULL THEN CFO.CFOCTA_FIL         ELSE DCTA.FILCTA            END ELSE DOC.FILCTA END AS FILCTA,
       CASE WHEN (DOC.FILCTA IS NULL) OR DOC.TIPNOT = 'F' THEN CASE WHEN CTACFO.SEQUEN IS NOT NULL THEN CFO.CFOCTA_SEQ         ELSE DCTA.SEQCTA            END ELSE DOC.SEQCTA END AS SEQCTA              
FROM TT_COM DOC LEFT JOIN TT_CTA CTAD ON DOC.FILCTA = CTAD.CODFIL
                                     AND DOC.SEQCTA = CTAD.SEQUEN
                LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL = CASE WHEN DOC.TIPNOT='F' THEN
                                                                 CASE WHEN DOC.TIPPAR='T'
                                                                      THEN 'FRETES A FATURAR'  -- Conhecimento de Fretes a faturar
                                                                      ELSE 'COMPRAS A FATURAR' -- Faturas
                                                                 END
                                                            WHEN DOC.TIPPAR='T' THEN 'TIPCTA_FRE_MER'    -- Fretes
                                                            WHEN DOC.TIPPAR='F' THEN 'TIPCTA_MER_REV'    -- Compras
                                                                                ELSE 'DESPESAS DIVERSAS' -- Títulos
                                                       END
				LEFT JOIN TD_CFO CFO ON DOC.CODCFO = CFO.CODTAB
                LEFT JOIN TT_CTA CTACFO ON CFO.CFOCTA_FIL = CTACFO.CODFIL
                                       AND CFO.CFOCTA_SEQ = CTACFO.SEQUEN
                                       AND DOC.TIPPAR IN ('F','T') -- fornecedor ou transportadora
;


-- AUTOR: DANIEL NASCHENWENG
-- FINALIDADE(S): SPED
-- 1) TRAZER A CONTA DE RECEITA PARA SPED CONTRIBUIÇÃO
/*-- SEQ 2622 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_SPED_CTAVEN CASCADE;

/*-- SEQ 2623 --*/
CREATE OR REPLACE VIEW TV_SPED_CTAVEN AS
SELECT VEN.CODFIL AS FILVEN,
       VEN.SEQUEN AS SEQVEN, 
              CASE WHEN VEN.FILCTA IS NULL
                  THEN CASE WHEN SUBSTR(COALESCE(DNAT.NATDEN,'    '),1,4) IN ('1102','2102') THEN
                                          DCOM.FILCTA
                                     WHEN SUBSTR(COALESCE(DNAT.NATDEN,'    '),1,4) IN ('5202','6202') THEN
                                          DDEC.FILCTA
                                     ELSE
                                          CASE WHEN VEN.VLRLIQ > 0 THEN
                                                    CASE WHEN CTANAT.SEQUEN IS NOT NULL THEN
                                                              CTANAT.CODFIL
                                                         WHEN VEN.AVISTA = 'T' THEN
                                                              DCTR.CTRFIL
                                                         ELSE
                                                              DCTR.FILPRA
                                                     END
                                               ELSE DDEV.FILCTA
                                          END
                                END
                  ELSE
                      VEN.FILCTA
             END AS FILCTA, 
              CASE WHEN VEN.FILCTA IS NULL
                  THEN CASE WHEN SUBSTR(COALESCE(DNAT.NATDEN,'    '),1,4) IN ('1102','2102') THEN
                                          DCOM.SEQCTA
                                     WHEN SUBSTR(COALESCE(DNAT.NATDEN,'    '),1,4) IN ('5202','6202') THEN
                                          DDEC.SEQCTA
                                     ELSE
                                          CASE WHEN VEN.VLRLIQ > 0 THEN
                                                    CASE WHEN CTANAT.SEQUEN IS NOT NULL THEN
                                                              CTANAT.SEQUEN
                                                         WHEN VEN.AVISTA = 'T' THEN
                                                              DCTR.CTRSEQ
                                                         ELSE
                                                              DCTR.SEQPRA
                                                     END
                                               ELSE DDEV.SEQCTA
                                          END
                                END
                  ELSE
                      VEN.SEQCTA
             END AS SEQCTA
FROM TT_VEN VEN  INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
                      INNER JOIN TD_CTR DCTR ON DCTR.CODTAB = VEN.CODCTR
                      LEFT  JOIN TD_CTA DDEC ON DDEC.CFGCOL = 'DEVOLUCAO COMPRAS'
                      LEFT  JOIN TD_CTA DCOM ON DCOM.CFGCOL = 'TIPCTA_MER_REV'
                      LEFT  JOIN TD_CTA DDEV ON DDEV.CFGCOL = 'DEVOLUCAO VENDAS'
                      LEFT JOIN TT_CTA DDEVCTA ON DDEV.FILCTA=DDEVCTA.CODFIL AND DDEV.SEQCTA=DDEVCTA.SEQUEN                                            
                      LEFT  JOIN TT_CTA CTANAT ON (DNAT.NATDEN_FIL = CTANAT.CODFIL -- DENTRO
                                              AND  DNAT.NATDEN_SEQ = CTANAT.SEQUEN
                                              AND  VEN.UFLOJA      = 'T')
                                               OR (DNAT.NATFOR_FIL = CTANAT.CODFIL -- FORA
                                              AND  DNAT.NATFOR_SEQ = CTANAT.SEQUEN
                                              AND  VEN.UFLOJA      = 'F')
;


-- Autor: Luciano Chiqueti 
-- Cliente(s): JRA
 
-- Finalidade(s):
-- 1) Viu para ser utilizada em relatrios para ver as mesmas sadas do SPED
/*-- SEQ 2624 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_SPED_SAIDA CASCADE;

/*-- SEQ 2625 --*/
CREATE OR REPLACE VIEW TV_SPED_SAIDA AS
SELECT 'E'||VEN.CODFIL||LPAD(TRIM(VEN.SEQUEN),10,'0') AS DOC_CODIGO,                                  
       VEN.CODFIL AS DOC_CODFIL,                                                                          
       VEN.SEQUEN AS DOC_SEQUEN,                                                                          
       VEN.NUMNOT AS DOC_NUMNOT,                                                                          
       VEN.DATFIS AS DOC_DATDOC,                                                                          
       VEN.DATFIS AS DOC_DATOPE,
       (IVE.VLRMOV+
       (CASE WHEN ( (VEN.MODNOT = '55' OR VEN.MODNOT = '65') AND IVE.DESRAT > 0 AND VEN.VLRLIQ > 0 ) OR  
                 ( (VEN.MODNOT = '55' OR VEN.MODNOT = '65') AND IVE.DESRAT < 0 AND VEN.VLRLIQ < 0 )     
           THEN 0 ELSE IVE.DESRAT END)+ 
       IVE.SUBSTT+
       (CASE WHEN (VEN.VLRLIQ > 0 AND IVE.DESRAT > 0) OR (VEN.VLRLIQ < 0 AND IVE.DESRAT < 0) 
            THEN IVE.DESRAT ELSE 0 END))  AS VLROPE, 	   
       TRIM(COALESCE(VEN.DOCNFP, CASE WHEN ((VEN.FILCLI||VEN.CODCLI) <> (CFG.VC_FILCLI||CFG.VC_CODCLI))   
                                      THEN CLI.NUMDOC                                                     
                                      ELSE NULL END))                                                     
       AS DOC_DOCNFP,                                                                                     
       VEN.VLRLIQ AS DOC_VLRLIQ,                                                                          
       0 AS DOC_DESCON,                                                                                   
       0 AS DOC_VLRPIS,                                                                                   
       0 AS DOC_VLRCOF,                                                                                   
       VEN.VLRNOT AS DOC_VLRTOT,                                                                          
     CAST(CASE WHEN VEN.FLGNFE = '4' AND VEN.CODSER <> 'CF' THEN '05' ELSE                        
       CASE WHEN VEN.FLGNFE = '6' AND VEN.CODSER <> 'CF' THEN '04' ELSE                           
         CASE WHEN (VEN.FLGEST = 'C') AND (VEN.IMPEST IS NULL) THEN '02' ELSE                       
           CASE WHEN (VEN.FLGNFE IS NULL OR VEN.CODSER = 'CF') AND (VEN.FLGEST = 'C') AND (VEN.IMPEST IS NULL) THEN '02' ELSE 
             '00'  END END END END AS VARCHAR(2)) AS DOC_FLGEST,                                      
       0 AS DOC_BASICM,                                                                                   
       0 AS DOC_VLRICM,                                                                                   
       0 AS DOC_TIPFRE,                                                                                   
       0 AS DOC_ISEICM,                                                                                   
       0 AS DOC_VLRIPI,                                                                                   
       0 AS DOC_VLRIPI_TRA,                                                                               
       COALESCE(CASE WHEN VEN.CHAVEA IS NULL                                                              
                       OR LENGTH(VEN.CHAVEA) < 44                                                         
                       OR LENGTH(VEN.CHAVEA) IS NULL                                                      
                     THEN NULL                                                                            
                     ELSE VEN.CHAVEA                                                                      
                END, (SELECT MAX(VRT.CHAVEA)                                                              
                        FROM TT_VRT VRT                                                                   
                       WHERE VRT.FILVEN = VEN.CODFIL                                                      
                         AND VRT.ECFVEN = VEN.NUMECF                                                      
                         AND VRT.SERVEN = VEN.CODSER                                                      
                         AND VRT.NOTVEN = VEN.NUMNOT                                                      
                         AND VRT.CROVEN = VEN.CNT_RO)) AS DOC_CHAVEA,                                     
       VEN.VLRFRE AS DOC_VLRFRE,                                                                          
       VEN.VLRSEG AS DOC_VLRSEG,                                                                          
       VEN.OUTTAX AS DOC_OUTTAX,                                                                          
       (SELECT SUM(IVE2.BASUBS)                                                                           
          FROM TT_IVE IVE2                                                                                
         WHERE IVE2.CODFIL = VEN.CODFIL                                                                   
           AND IVE2.SEQUEN = VEN.SEQUEN                                                                   
           AND IVE2.SITMOV = 'N'                                                                        
           AND IVE2.SITKIT IN ('2','3')) AS DOC_BASSUB,                                               
       (SELECT SUM(IVE3.SUBSTT)                                                                           
          FROM TT_IVE IVE3                                                                                
         WHERE IVE3.CODFIL = VEN.CODFIL                                                                   
           AND IVE3.SEQUEN = VEN.SEQUEN                                                                   
           AND IVE3.SITMOV = 'N'                                                                        
           AND IVE3.SITKIT IN ('2','3')) AS DOC_SUBSTT,                                               
       VEN.TIPNOT AS DOC_TIPNOT,                                                                          
       TRANSLATE(Rtf2txt(replace(replace(VEN.OBSFIS,chr(13),''),chr(10),'')),'',' ') AS DOC_OBSFIS,
       0 AS DOC_PERICM,                                                                                   
       VEN.BASISS AS DOC_BASISS,                                                                          
       VEN.VLRISS AS DOC_VLRISS,                                                                          
       0 AS DOC_PERISS,                                                                                   
       VEN.BASIRR AS DOC_BASIRR,                                                                          
       VEN.VLRIRR AS DOC_VLRIRR,                                                                          
       0 AS DOC_PERIRR,                                                                                   
       VEN.VLRPIS AS DOC_VLRPIS_RET,                                                                      
       VEN.VLRCFI AS DOC_VLRCOF_RET,                                                                      
       VEN.FLGNFE AS DOC_FLGNFE,                                                                          
       0          AS DOC_BSTFRE,                                                                          
       0          AS DOC_ST_FRE,                                                                          
       ECF.CODORI /*VEN.NUMECF*/ AS VEN_NUMECF,                                                           
       VEN.CNT_RO AS VEN_CNT_RO,                                                                          
       VEN.DATFIS AS VEN_DATFIS,                                                                          
       VEN.EMIDES AS VEN_EMIDES,                                                                          
       VEN.AVISTA AS VEN_AVISTA,                                                                          
       VEN.FINANC AS VEN_FINANC,                                                                          
       VEN.TITAVU AS VEN_TITAVU,                                                                          
       VEN.FLGEST AS VEN_FLGEST,                                                                          
     VEN.INDFRE AS VEN_INDFRE,                                                                          
       VEN.SATSER AS VEN_SATSER,                                                                       
       VEN.SATCFE AS VEN_SATCFE,                                                                       
       COALESCE(VEN.CHVCAN, VEN.CHAVEA) AS VEN_CHVCAN,                                                 
       COALESCE(VEN.SATCAN, COALESCE(VEN.SATCFE,0)+1) AS VEN_SATCAN,                                                 
       CTAVEN.CODEXT AS CTADOC_CODEXT,                                                                    
       FIS.MODNOT AS FIS_MODNOT,                                                                          
       TRIM(FIS.SEREXP) AS FIS_CODSER,                                                                    
       TRIM(FIS.SUBEXP) AS FIS_SUBSER,                                                                          
       'E'||IVE.CODFIL||LPAD(TRIM(IVE.SEQUEN),10,'0')||LPAD(TO_CHAR(IVE.NUMITE),5,'0') AS ITE_CODIGO,     
       IVE.CODFIL AS ITE_CODFIL,                                                                          
       IVE.NUMITE AS ITE_NUMITE,                                                                          
       IVE.QTDMOV AS ITE_QTDMOV,                                                                          
       COALESCE(IVE.EMBQTD, IVE.QTDMOV) AS ITE_EMBQTD,                                                    
       IVE.VLRMOV AS ITE_VLRMOV,                                                                          
       CASE WHEN VEN.CODSER = 'CF' THEN IVE.VLRDES ELSE 0 END AS ITE_VLRDES,                            
       IVE.TIPPRO AS ITE_TIPPRO,                                                                          
       IVE.ICMTIP AS ITE_ICMTIP,                                                                          
       IVE.REDITE AS ITE_REDITE,                                                                          
       IVE.CALSUB AS ITE_CALSUB,                                                                          
       Rateio_ValorLiquido_Notas(IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE) AS ITE_RATEIO_PROMOCAO,              
       CASE WHEN (SELECT COUNT(*)                                                                         
                    FROM TT_IVE IVE2                                                                      
                   WHERE IVE2.CODFIL = IVE.CODFIL                                                         
                     AND IVE2.SEQUEN = IVE.SEQUEN                                                         
                     AND IVE2.SITMOV <> 'C'                                                             
                     AND IVE2.SITKIT IN ('1', '2')                                                    
                     AND IVE2.PROMOC = 'T') > 0 THEN 'T' ELSE 'F' END AS DOC_ITENS_PROMOCAO,        
       IVE.SUBSTT AS ITE_VLR_ST,                                                                          
       IVE.BASUBS AS ITE_BASSUB,                                                                          
       CASE WHEN SUBSTR(IVE.CODCST,2,2) = '60'                                                          
            THEN 0                                                                                        
            ELSE CASE WHEN COALESCE(IVE.TAXICM,0) <> 0                                                    
                      THEN IVE.TAXICM                                                                     
                      ELSE CASE WHEN IVE.TIP001 = 'M' THEN IVE.TAX001 ELSE 0 END                        
                 END                                                                                      
       END AS ITE_TAXICM,                                                                                 
       IVE.BASICM AS ITE_BASICM,                                                                          
       IVE.VLRICM AS ITE_VLRICM,                                                                                 
       CASE WHEN COALESCE(IVE.VLRIPI,0) <> 0                                                              
            THEN IVE.VLRIPI                                                                               
            ELSE IVE.VLR002                                                                               
       END AS ITE_VLRIPI,                                                                                 
       IVE.ISEICM AS ITE_ISEICM,                                                                          
       IVE.LANEST AS ITE_LANEST,                                                                          
       IVE.VLRPIS AS ITE_VLRPIS,                                                                          
       IVE.VLRCOF AS ITE_VLRCOF,                                                                          
       CASE WHEN (COALESCE(IVE.TAXIPI, 0) = 0) AND (COALESCE(IVE.TAX002, 0) = 0) THEN                     
            0 ELSE IVE.BASIPI END AS ITE_BASIPI,                                                          
       CASE WHEN COALESCE(IVE.TAXIPI,0) <> 0                                                              
            THEN IVE.TAXIPI                                                                               
            ELSE IVE.TAX002                                                                               
       END AS ITE_TAXIPI,                                                                                 
       IVE.SITPIS AS ITE_SITPIS,                                                                          
       IVE.BASPIS AS ITE_BASPIS,                                                                          
       IVE.PERPIS AS ITE_PERPIS,                                                                          
       IVE.SITCOF AS ITE_SITCOF,                                                                          
       IVE.BASCOF AS ITE_BASCOF,                                                                          
       IVE.PERCOF AS ITE_PERCOF,                                                                          
       0 AS ITE_IPIFRE,                                                                                   
       IVE.VLRFRE AS ITE_VLRFRE,                                                                                   
       0 AS ITE_RED_ST,                                                                                   
       CASE WHEN SUBSTR(IVE.CODCST,2,2) = '60'                                                          
            THEN 0                                                                                        
            ELSE CASE WHEN COALESCE(IVE.TAXICM,0) <> 0                                                    
                      THEN IVE.TAXICM                                                                     
                      ELSE CASE WHEN IVE.TIP001 = 'M' THEN IVE.TAX001 ELSE 0 END                        
                 END                                                                                      
       END AS ITE_ICMVEN,                                                                                 
       IVE.VLRUNI AS ITE_VLRUNI,                                                                          
     CASE WHEN IVE.ESTORN = 'T' THEN 'N' ELSE IVE.SITMOV END AS ITE_SITMOV,                         
       COALESCE(CASE WHEN SUBSTR(IVE.CODCST,1,1) = '0' THEN TO_CHAR(COALESCE(IVE.CODORI,0))||SUBSTR(IVE.CODCST,2,2)
                     ELSE IVE.CODCST                                                                      
                 END,'   ') AS ITE_CODCST,                                                              
       IVE.CODORI AS ITE_CODORI,                                                                          
       IVE.BASISS AS IVE_BASISS,                                                                          
       IVE.TAXISS AS IVE_TAXISS,                                                                          
       IVE.VLRISS AS IVE_VLRISS,                                                                          
       CASE WHEN VEN.CODSER='CF' THEN                                                                   
         CASE WHEN VEN.VLRLIQ = VEN.VLRNOT THEN                                                           
                 IVE.VLRMOV ELSE                                                                          
                 Rateio_ValorLiquido_ECF(IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE)                              
         END                                                                                              
       ELSE 0 END AS IVE_VLRLIQ,                                                                          
      IPR.CODFIS AS PRO_CODIGO,                                                                         
       IPR.REFPRO AS PRO_REFPRO,                                                                          
       IPR.REFBAS AS PRO_REFBAS,                                                                          
       NomeProduto(IPR.DESECF, IPR.DESMAT, IPR.CODCOR, IPR.ITEDIV,                                        
                   IPR.CODTAM, IPR.ITESUB, IPR.ESPMAT, IPR.DESGRA) AS PRO_NOMPRO,                         
       CASE WHEN IsDigit(IPR.REFPRO) = 1 THEN                                                             
                 CASE WHEN (LENGTH(IPR.REFPRO) = 8)  AND (EAN8(IPR.REFPRO) = IPR.REFPRO) THEN IPR.REFPRO  
                      WHEN (LENGTH(IPR.REFPRO) = 13) AND (EAN(IPR.REFPRO) = IPR.REFPRO)  THEN IPR.REFPRO  
                      ELSE NULL                                                                           
                 END                                                                                      
            ELSE NULL                                                                                     
       END AS PRO_CODEAN,                                                                                 
       IPR.CODFPS AS PRO_CODFPS,                                                                          
       IPR.CODNCM AS PRO_CODNCM,                                                                          
       IPR.COD_EX AS PRO_COD_EX,                                                                          
       SUBSTR(IPR.CODNCM,1,2) AS PRO_GENNCM,                                                              
       CAST(TRIM(REPLACE(TO_CHAR(IPR.CODSRV,'00G00'),',','.')) AS VARCHAR(5)) AS PRO_CODSRV,              
       ICM.RESICM AS PRO_PERICM,                                                                          
       IPR.CODANP AS PRO_CODANP,                                                                          
       CASE WHEN CLI.FLGTIP = 0 THEN NULL                                                                 
            ELSE COALESCE(IVE.NATBCC, NAT.NATBCC)                                                         
       END AS PRO_NATBCC,                                                                                 
       CASE WHEN IVE.SITIPI IS NULL THEN                                                                  
          CASE WHEN VEN.FINANC = 'T' THEN IPR.SITIPI ELSE '9' END                                     
       ELSE IVE.SITIPI END AS ITE_SITIPI,                                                                 
       IPR.CODEXT AS PRO_CODEXT,                                                                          
       IPR.IIPTPR AS PRO_IIPTPR,                                                                          
       MED.CODTAB AS MED_CODTAB,                                                                          
       MED.MEDATI AS MED_MEDATI,                                                                          
       MED.UNIMED AS MED_UNIMED,                                                                        
       MED.DESMED AS MED_DESMED,                                                                          
       CLI.FILCLI||LPAD(TRIM(CLI.CODCLI),6,'0') AS PAR_CODIGO,                                          
       CLI.FILCLI AS PAR_FILCLI,                                                                          
       CLI.CODCLI AS PAR_CODCLI,                                                                          
       CLI.NOMCLI AS PAR_NOMCLI,                                                                          
       CLI.CODPAI AS PAR_CODPAI,                                                                          
       COALESCE(CLI.NUMDOC, VIN.NUMDOC) AS PAR_NUMDOC,                                                    
       CASE WHEN CLI.TIPDOC='IE' THEN CLI.INSEST END AS PAR_INSEST,                                     
       CLI.SUFRAM AS PAR_SUFRAM,                                                                          
       CLI.FLGTIP AS PAR_FLGTIP,                                                                          
       COALESCE(ENF.CODIBG, MUN.CODIBG) AS MUN_CODIBG,                                                    
       MUN.SIGEST AS MUN_SIGEST,                                                                          
       ENF.FILCLI||LPAD(TRIM(ENF.CODCLI),6,'0')||ENF.CODFIL||LPAD(TO_CHAR(ENF.NUMEND),4,'0') AS ENC_CODIGO, 
       ENF.FILCLI AS ENC_FILCLI,                                                                          
       ENF.CODCLI AS ENC_CODCLI,                                                                          
       REPLACE(ENF.ENDERE,'|','-') AS ENC_ENDERE,                                                     
       (REPLACE(ENF.ENDERE,'|','-')||', '||ENF.NOMCID||', '||DPAI.DESPAI) AS ENC_ENDERE_ESTRAN,   
       ENF.NUMERO AS ENC_NUMERO,                                                                          
       REPLACE(ENF.COMPLE,'|','-') AS ENC_COMPLE,                                                     
       ENF.BAIRRO AS ENC_BAIRRO,                                                                          
       ENF.CODPAI AS ENC_CODPAI,                                                                          
       ENF.SIGEST AS ENC_SIGEST,                                                                          
       ENF.NUMDOC AS ENC_NUMDOC,                                                                          
       ENF.INSMUN AS ENC_INSMUN,                                                                          
       CASE WHEN CLI.TIPDOC='IE' THEN ENF.INSEST END AS ENC_INSEST,                                     
       COALESCE(ENE.CODIBG, MUE.CODIBG) AS MUE_CODIBG,                                                    
       ENE.FILCLI||LPAD(TRIM(ENE.CODCLI),6,'0')||ENE.CODFIL||LPAD(TO_CHAR(ENE.NUMEND),4,'0') AS ENE_CODIGO, 
       ENE.FILCLI AS ENE_FILCLI,                                                                          
       ENE.CODCLI AS ENE_CODCLI,                                                                          
       ENE.CODFIL AS ENE_CODFIL,                                                                          
       ENE.NUMEND AS ENE_NUMEND,                                                                          
       ENE.NUMDOC AS ENE_NUMDOC,                                                                          
       CASE WHEN CLI.TIPDOC='IE' THEN ENE.INSEST END AS ENE_INSEST,                                     
       ENE.CODPAI AS ENE_CODPAI,                                                                          
       ENE.SIGEST AS ENE_SIGEST,                                                                          
       COALESCE(FIL.CODIBG, MUF.CODIBG) AS MUF_CODIBG,                                                    
       COALESCE(SUBORI.FATCON,1) AS SUBORI_FATCON,                                                        
       MEDEMB.CODTAB AS MEDEMB_CODTAB,                                                                    
       MEDEMB.MEDATI AS MEDEMB_MEDATI,                                                                    
       CASE WHEN COALESCE(SUBORI.FATCON,1) = 1 THEN                                                     
         MEDEMB.UNIMED                                                                                  
       ELSE                                                                                             
         MEDEMB.UNIMED||SUBSTR(REPLACE(TO_CHAR(SUBORI.FATCON, 'FM9999999990D9999'),'.',''),1,4)   
       END AS MEDEMB_UNIMED,                                                                            
       MEDEMB.DESMED AS MEDEMB_DESMED,                                                                    
       CASE VEN.UFLOJA WHEN 'T' THEN NAT.NATDEN                                                         
                                  ELSE NAT.NATFOR                                                         
       END AS DOC_CODNAT,                                                                                 
       NAT.NATURE AS DOC_DESNAT,                                                                          
       NAT.TIPNAT AS NAT_TIPNAT,                                                                          
       CAST(                                                                                              
            CASE WHEN VEN.CODSER = 'CF'                                                                 
                 THEN                                                                                     
                      CASE WHEN IUF.CODCFP IS NOT NULL AND CFP.VENCON IS NOT NULL                         
                           THEN '5'||CFP.VENCON                                                         
                           ELSE                                                                           
                                CASE WHEN CL1.NATCL1 IS NOT NULL AND NATCL1.NATDEN IS NOT NULL            
                                     THEN NATCL1.NATDEN                                                   
                                     ELSE                                                                 
                                          CASE WHEN PLA.CODNAT IS NOT NULL AND NATPLA.NATDEN IS NOT NULL  
                                               THEN NATPLA.NATDEN                                         
                                               ELSE NATUREZAVENDA('T', IVE.ICMTIP, IVE.NATFIS, NAT.NATFOR, VEN.SUBSTT)||SUBSTR(IVE.NATFIS,5,2) 
                                          END                                                             
                                END                                                                       
                      END                                                                                 
                 ELSE                                                                                     
                      -- CFOP de NF                                                                       
                      SUBSTR(IVE.NATFIS,1,4)||SUBSTR(NAT.NATDEN,5,2)                                      
             END AS CHAR(6)) AS ITE_CODNAT,                                                               
       (SELECT INAT.NATURE                                                                                 
          FROM TD_NAT INAT                                                                                 
         WHERE (  INAT.NATDEN=SUBSTR(IVE.NATFIS,1,4)||SUBSTR(NAT.NATDEN,5,2) OR                            
                  INAT.NATFOR=SUBSTR(IVE.NATFIS,1,4)||SUBSTR(NAT.NATDEN,5,2)                               
               )                                                                                           
             AND INAT.TIPNAT = NAT.TIPNAT                                                                  
       ) AS ITE_DESNAT, 
       COALESCE( (SELECT MAX(ORI.CODFIL)                                                                  
                    FROM TT_VEN ORI WHERE ORI.CODFIL = VEN.CODFIL AND ORI.SEQFAT = VEN.SEQUEN             
                   GROUP BY ORI.CODFIL, ORI.SEQFAT                                                        
                   ), IVE.FILORI) AS DOC_FILORI,                                                          
       IVE.NUMORI AS DOC_SEQORI,                                                                          
       CFG.VC_FILCLI AS CFG_VC_FILCLI,                                                                    
       CFG.VC_CODCLI AS CFG_VC_CODCLI,                                                                    
       TRA.FILIVE AS TRA_FILITE,                                                                          
       (SELECT MAX(LID.CONCCF)                                                                            
          FROM TT_LID LID                                                                                 
         WHERE LID.CODFIL = VEN.CODFIL                                                                    
           AND LID.NUMECF = VEN.NUMECF                                                                    
           AND LID.CODSER = VEN.CODSER                                                                    
           AND LID.CUPFIS = VEN.NUMNOT                                                                    
           AND LID.TIPOPE = 'VEN') AS LID_CONCCF,                                                       
       CASE WHEN ( (VEN.MODNOT = '55' OR VEN.MODNOT = '65') AND IVE.DESRAT > 0 AND VEN.VLRLIQ > 0 ) OR  
                 ( (VEN.MODNOT = '55' OR VEN.MODNOT = '65') AND IVE.DESRAT < 0 AND VEN.VLRLIQ < 0 )     
            THEN 0 ELSE IVE.DESRAT END AS ITE_DESRAT,                                                       
       CASE WHEN (VEN.VLRLIQ > 0 AND IVE.DESRAT > 0) OR                                                     
                 (VEN.VLRLIQ < 0 AND IVE.DESRAT < 0) THEN IVE.DESRAT ELSE 0 END AS ITE_ACR_ORIGINAL,        
       CASE WHEN NAT.TIPNAT <> 'M' THEN 0                                                                 
                                     ELSE (SELECT SUM(COALESCE(IVE4.VLRIPI, 0))                             
                                             FROM TT_IVE IVE4                                               
                                            WHERE IVE4.CODFIL = VEN.CODFIL                                  
                                              AND IVE4.SEQUEN = VEN.SEQUEN                                  
                                              AND IVE4.SITMOV = 'N'                                       
                                              AND IVE4.SITKIT IN ('2','3'))                             
                                     END AS DOC_VLRIPI_DEVOLVIDO,                                           
       ECF.MARECF AS ECF_MARECF,                                                                           
       'F' AS PAR_REGESP,                                                                                
       CASE WHEN CLI.CODCLI = '     0' THEN                                                             
           CASE WHEN FCLI.REGTRI = 'N' THEN 'F'                                                       
                WHEN COALESCE(FCLI.TRISIM,'X') = 'O' THEN 'F'                                       
                ELSE 'T'                                                                                
           END                                                                                            
       ELSE CLI.SIMPLE END AS PAR_SIMPLE, NULL AS DOC_NATBCC,                                             
       NULL AS DOC_FINNFE,                                                                                
       0 AS FIL_PERPIS, 0 AS FIL_PERCOF,                                                                  
       FIL.TIPLUC AS FIL_TIPLUC,                                                                          
       COALESCE(VEN.CODCRT,                                                                               
                CASE WHEN FIL.REGTRI = 'N' THEN 3                                                       
                     ELSE CASE WHEN COALESCE(FIL.TRISIM,'X') = 'O' THEN 2                             
                                                                       ELSE 1                             
                          END                                                                             
                END                                                                                       
               ) AS FIL_REGTRI,                                                                            
       IVE.VLRICMFCP AS ITE_VALOR_FCP, IVE.VLRICMDES AS ITE_VALOR_PARTILHA_DESTINO,                       
       IVE.VLRICMORI AS ITE_VALOR_PARTILHA_REMETENTE,                                                     
       0 AS ITE_OUTTAX,                                                                                   
     VEN.IMPEST AS VEN_IMPEST, IVE.ESTORN AS IVE_ESTORN,                                                
     EST.CODFIL AS EST_CODFIL, EST.SEQUEN AS EST_SEQUEN,                                                
     NATEST.TIPNAT AS EST_TIPNAT,                                                                       
     OIP.DOCIMP AS OIP_DOCIMP, OIP.TIPDOC AS OIP_TIPDOC, ADI.NUMDRA AS ADI_NUMDRA,                      
     IVE.VLRADU AS IVE_VLRADU, IVE.BAS_II AS IVE_BAS_II, IVE.VLR_II AS IVE_VLR_II,                      
     IVE.VLRANT AS IVE_VLRANT, IVE.PERPISCRE AS IVE_PERPISCRE, IVE.VLRPISCRE AS IVE_VLRPISCRE,          
     IVE.PERCOFCRE AS IVE_PERCOFCRE, IVE.VLRCOFCRE AS IVE_VLRCOFCRE,                                    
       IPR.CODCES AS PRO_CODCES,                                                                          
       NULL AS DOC_MUN_DESTINO                                                                            
  FROM TT_VEN VEN LEFT JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL                                         
                                       AND IVE.SEQUEN = VEN.SEQUEN                                        
                                     AND (VEN.CODSER = 'CF' OR (VEN.CODSER <> 'CF' AND (IVE.SITMOV = 'N' OR (IVE.SITMOV = 'C' AND IVE.ESTORN = 'T'))))
                                       AND (IVE.SITKIT IN ('2','3'))                                  
                  INNER JOIN TD_ECF ECF on VEN.CODFIL=ECF.FILECF and VEN.NUMECF=ECF.NUMECF                
                  LEFT JOIN (SELECT GRA.FILMAT, GRA.SEQUEN, GRA.CODMAT,                                  
                                     GRA.CODCOR, GRA.CODTAM, PRO.CODNCM,                                  
                                     GRA.UNIDAD,                                                          
                                   GRA.CODFIS,                                                          
                                     PRO.DESECF, PRO.DESMAT, PRO.ESPMAT,                                  
                                     PRO.CODFPS, PRO.COD_EX, PRO.CODSRV,                                  
                                     PRO.CODANP, PRO.SITIPI, PRO.REFBAS,                                  
                                  PRO.NATBCC,                                                          
                                     DIV.CODITE AS DIV_CODITE,                                            
                                     DIV.NOMITE AS ITEDIV,                                                
                                     SUB.CODITE AS SUB_CODITE,                                            
                                     SUB.NOMITE AS ITESUB,                                                
                                     GRA.CODEXT,                                                          
                                     GRA.REFPRO,                                                          
                                     PRO.CLASS1,                                                          
                                     PRO.IIPTPR,                                                          
                                     GRA.DESGRA,                                                          
                                  PRO.CODCES                                                           
                                FROM TT_GRA GRA INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT          
                                                                     AND PRO.CODMAT = GRA.CODMAT          
                                                INNER JOIN TT_DIV DIV ON GRA.CODCOR = DIV.CODITE          
                                                INNER JOIN TT_SUB SUB ON GRA.CODTAM = SUB.CODITE) IPR     
                                ON IPR.FILMAT = IVE.FILMAT                                                
                               AND IPR.CODMAT = IVE.CODMAT                                                
                               AND IPR.CODCOR = IVE.CODCOR                                                
                               AND IPR.CODTAM = IVE.CODTAM                                                
                  LEFT JOIN TD_MED MED ON IPR.UNIDAD = MED.CODTAB                                         
                  LEFT JOIN TD_FIL FIL ON FIL.CODFIL = VEN.CODFIL                                         
                  LEFT JOIN TT_IUF IUF ON FIL.UFLOJA = IUF.ESTADO AND FIL.REGESP = IUF.REGESP             
                                       AND IPR.FILMAT = IUF.FILMAT AND IPR.CODMAT = IUF.CODMAT            
                  LEFT JOIN TD_CFP CFP ON IUF.CODCFP = CFP.CODTAB                                         
                  LEFT JOIN TD_ICM ICM ON IUF.RESICM = ICM.CODTAB                                         
                  INNER JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT                                        
                                       AND PLA.CODPGT = VEN.CODPGT                                        
                  LEFT JOIN TD_NAT NATPLA ON NATPLA.CODTAB = PLA.CODNAT                                   
                  LEFT JOIN TD_CL1 CL1 ON CL1.CODTAB = IPR.CLASS1                                         
                  LEFT JOIN TD_NAT NATCL1 ON NATCL1.CODTAB = CL1.NATCL1                                   
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI                                        
                                       AND CLI.CODCLI = VEN.CODCLI                                        
                  LEFT JOIN TD_FIL FCLI ON FCLI.CODFIL = CLI.FILCLI                                       
                  INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT                                        
                  INNER JOIN TT_FIS FIS ON FIS.CODSER = VEN.CODSER                                        
                                       AND FIS.SUBSER = VEN.NUMECF                                        
                  LEFT JOIN TT_MUN MUF ON MUF.CODIGO = FIL.CODCID                                        
                  LEFT  JOIN TT_CLI VIN ON VIN.FILCLI = CLI.FILVIN                                        
                                       AND VIN.CODCLI = CLI.CODVIN                                        
                                       AND CLI.FLGTIP <> 0                                                
                  LEFT  JOIN TT_END ENF ON ENF.FILCLI = VEN.FILCLI                                        
                                       AND ENF.CODCLI = VEN.CODCLI                                        
                                    AND ENF.CODFIL = COALESCE(VEN.FILFAT, VEN.FILCOB, VEN.FILENT, CLI.FILEND) 
                                    AND ENF.NUMEND = COALESCE(VEN.ENDFAT, VEN.ENDCOB, VEN.ENDENT, CLI.NUMEND) 
                  LEFT  JOIN TT_MUN MUN ON MUN.CODIGO = ENF.CODCID                                        
                  LEFT  JOIN TT_END ENE ON VEN.FILCLI = ENE.FILCLI                                        
                                       AND VEN.CODCLI = ENE.CODCLI                                        
                                       AND VEN.FILENT = ENE.CODFIL                                        
                                       AND VEN.ENDENT = ENE.NUMEND                                        
                  LEFT  JOIN TT_MUN MUE ON MUE.CODIGO = ENE.CODCID                                        
                  LEFT  JOIN TT_TRA TRA ON TRA.FILIVE = IVE.CODFIL                                        
                                       AND TRA.SEQIVE = IVE.SEQUEN                                        
                                       AND TRA.NUMIVE = IVE.NUMITE                                        
                  LEFT  JOIN TT_CTA CTAVEN ON CTAVEN.CODFIL = VEN.FILCTA                                  
                                          AND CTAVEN.SEQUEN = VEN.SEQCTA                                  
                                          AND CTAVEN.TIPCTA = VEN.TIPCTA                                  
                  LEFT  JOIN TT_SUB SUBORI ON IVE.EMBORI = SUBORI.CODITE                                  
                  LEFT  JOIN TT_GRA GRAORI ON GRAORI.FILMAT=IVE.FILMAT                                    
                                          AND GRAORI.CODMAT=IVE.CODMAT                                    
                                          AND GRAORI.CODCOR=IVE.CODCOR                                    
                                          AND GRAORI.CODTAM=IVE.EMBORI                                    
                  LEFT  JOIN TD_MED MEDEMB ON GRAORI.UNIDAD = MEDEMB.CODTAB                               
                  LEFT  JOIN TD_PAI DPAI   ON ENF.CODPAI = DPAI.CODPAI                                    
                LEFT  JOIN TT_VEN EST ON EST.FILEST = VEN.CODFIL AND EST.SEQEST = VEN.SEQUEN            
                LEFT  JOIN TD_NAT NATEST ON NATEST.CODTAB = EST.CODNAT                                  
                LEFT  JOIN TT_ADI ADI ON ADI.CODFIL = IVE.FILOIP                                        
                                     AND ADI.SEQUEN = IVE.SEQOIP                                        
                                     AND ADI.NUMITE = IVE.NUMADI                                        
                LEFT  JOIN TT_OIP OIP ON OIP.CODFIL = ADI.CODFIL                                        
                                     AND OIP.SEQUEN = ADI.SEQUEN                                        
                  CROSS JOIN TT_CFG CFG                                                                   
 WHERE 1 = 1                                                                                              
   AND VEN.TIPTRO IN ('+','-','2')                                                                  
   AND VEN.NUMNOT NOT LIKE '###%'                                                                       
   AND FIS.ORIGEM = 'V'                                                                                 
   AND FIS.EXPORT = 'T'                                                                                 
   AND COALESCE(VEN.FUNRUR,0) = 0                                                                      
   AND COALESCE(VEN.FLGNFE,' ') NOT IN ('0','2')                                                    
 ORDER BY VEN.CODFIL, VEN.SEQUEN, IVE.NUMITE;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Agncia" (Tabela Integrao Mult)
/*-- SEQ 2626 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_AGENCIABANCARIA CASCADE;

/*-- SEQ 2627 --*/
CREATE OR REPLACE VIEW TV_TIMU_AGENCIABANCARIA AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST('X' AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODBCO, TAB.NUMAGE, TAB.DIGAGE, TAB.ATU_EM, TAB.DATINC,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.CodigoBanco, -- Cdigo do Banco
      TAB.Codigo, -- Cdigo da Agncia
      TAB.Digito, -- Dgito da Agncia
      TAB.Posto, -- Posto da Agncia
      -- Dados no existe no sistema da Totall
      TAB.CNPJ, -- CNPJ da Agncia
      TAB.NomeFantasia, -- Nome Fantasia da Agncia
      TAB.Nome, -- Razo Social da Agncia
      TAB.Logradouro, -- Logradouro do Endereo
      TAB.CEP, -- CEP do Endereo
      TAB.Cidade, -- Cidade do Endereo
      TAB.Bairro, -- Bairro do Endereo
      TAB.Estado, -- Estado do Endereo
      TAB.ComplementoEnd, -- Complemento do Endereo
      TAB.NumeroEnd, -- Nmero do Endereo
      TAB.InscricaoEstadual -- Inscrio Estadual
  FROM (   
   SELECT DISTINCT 
          CTB.CODBCO, CTB.NUMAGE, CTB.DIGAGE, CTB.ATU_EM, CTB.ATU_EM AS DATINC,
          CTB.ATU_EM AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
          CAST(TO_NUMBER(CTB.CODBCO) AS Numeric(10)) AS CodigoBanco, -- Cdigo do Banco
          CAST(CTB.NUMAGE AS VARCHAR(10)) AS Codigo, -- Cdigo da Agncia
          CAST(CTB.DIGAGE AS VARCHAR(2)) AS Digito, -- Dgito da Agncia
          CAST(NULL AS Numeric(9)) AS Posto, -- Posto da Agncia
          -- Dados no existe no sistema da Totall passa valores prefixados pois campos so obrigatrios na EME4
          CAST('11111111111111' AS VARCHAR(18)) AS CNPJ, -- CNPJ da Agncia
          CAST(CTB.CODBCO||'-'||CTB.NUMAGE AS VARCHAR(50)) AS NomeFantasia, -- Nome Fantasia da Agncia
          CAST(CTB.CODBCO||'-'||CTB.NUMAGE AS VARCHAR(120)) AS Nome, -- Razo Social da Agncia
          CAST(NULL AS VARCHAR(120)) AS Logradouro, -- Logradouro do Endereo
          CAST(NULL AS VARCHAR(10)) AS CEP, -- CEP do Endereo
          CAST(NULL AS VARCHAR(25)) AS Cidade, -- Cidade do Endereo
          CAST(NULL AS VARCHAR(80)) AS Bairro, -- Bairro do Endereo
          CAST(NULL AS VARCHAR(2)) AS Estado, -- Estado do Endereo
          CAST(NULL AS VARCHAR(30)) AS ComplementoEnd, -- Complemento do Endereo
          CAST(NULL AS Numeric(9)) AS NumeroEnd, -- Nmero do Endereo
          CAST(NULL AS VARCHAR(20)) AS InscricaoEstadual -- Inscrio Estadual
     FROM TT_CTB CTB) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Documentos Referenciados" (Tabela Integrao Mult)
/*-- SEQ 2628 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_ARRECADACAOREFERENC CASCADE;

/*-- SEQ 2629 --*/
CREATE OR REPLACE VIEW TV_TIMU_ARRECADACAOREFERENC AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.FILREF, TAB.SEQREF, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.CodigoModelo, -- 0 - Documento Estadual de Arrecadao / 1 - GNRE
      TAB.NroDocReferenciado, -- Nmero do Documento Referenciado
      TAB.CodigoAutenticacao, -- Cdigo de Autenticao
      TAB.ValorDoctoRef, -- Valor do Documento Referenciado
      TAB.DataVencimento, -- Data do Vencimento do Documento Referenciado
      TAB.DataPagamento, -- Data do Pagamento do Documento Referenciado
      TAB.NumeroConvenio, -- Nmero do Convnio
      TAB.UFDocto, -- Sigla da UF do Documento Referenciado
      TAB.PaisDocto, -- Nome do Pais do Documento Referenciado
      TAB.UFSubstituto, -- Sigla da UF do Substituto Documento Referenciado
      TAB.PaisSubstituto, -- Nome do Pais do Substituto Documento Referenciado
      TAB.CodigoBanco, -- Cdigo do Banco da Parcela
      TAB.CodigoAgencia, -- Cdigo da Agncia Bancria da Parcela
      TAB.DigitoAgencia -- Dgito da Agncia Bancria da Parcela
  FROM (-- Notas de Recebidas
         SELECT
               COM.CODFIL, COM.SEQUEN, CREF.CODFIL AS FILREF, CREF.SEQUEN AS SEQREF, CAST('COM' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_ARRECADACAOREFERENCIADO' AS VARCHAR(50)) AS DESTINO, COALESCE(COM.DATINC, COM.DATOPE) AS DATINC, COM.ATU_EM, COM.EXPORT, COM.EXPEM4,
               CAST('COM' || COM.CODFIL || COM.SEQUEN AS VARCHAR(50)) AS CHAVE,
               COALESCE(COM.DATINC, COM.DATOPE) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               CAST(                    TO_NUMBER(NULLIF(regexp_replace(DCFO.EXTCFO, '[^0-9]', '', 'gi'), '')) AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST(TO_NUMBER(COM.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = COM.FILFOR AND REL.CODPAR = COM.CODFOR AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F' ELSE 'C' END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('2' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST(CASE WHEN ISNOTNULL(FIS.SEREXP)='T' THEN LPAD(TRIM(FIS.SEREXP), 3, '0')||CASE WHEN COM.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(FIS.SUBEXP),'0'), 2, '0') END
                         ELSE LPAD(TRIM(COM.CODSER), 2, '0')||CASE WHEN COM.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(COM.SUBSER),'0'), 3, '0') END
                    END AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(TO_CHAR(TO_NUMBER(TRIM(COM.NUMNOT))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST(COM.CODDAR AS VARCHAR(1)) AS CodigoModelo, -- 0 - Documento Estadual de Arrecadao / 1 - GNRE
               CAST(TO_CHAR(TO_NUMBER(TRIM(CREF.NUMNOT))) AS VARCHAR(20)) AS NroDocReferenciado, -- Nmero do Documento Referenciado
               CAST(PAG.AUTBAN AS VARCHAR(20)) AS CodigoAutenticacao, -- Cdigo de Autenticao
               CAST(ABS(CREF.VLRLIQ) AS Numeric(15,2)) AS ValorDoctoRef, -- Valor do Documento Referenciado
               CAST(TRUNC(PAG.DATVEN) AS Timestamp) AS DataVencimento, -- Data do Vencimento do Documento Referenciado
               CAST(TRUNC(PAG.DATPGT) AS Timestamp) AS DataPagamento, -- Data do Pagamento do Documento Referenciado
               CAST(NULL AS VARCHAR(30)) AS NumeroConvenio, -- Nmero do Convnio
               CAST(TRIM(CREF.UFNOTA) AS VARCHAR(2)) AS UFDocto, -- Sigla da UF do Documento Referenciado
               CAST('Brasil' AS VARCHAR(80)) AS PaisDocto, -- Nome do Pais do Documento Referenciado
               CAST(NULL AS VARCHAR(2)) AS UFSubstituto, -- Sigla da UF do Substituto Documento Referenciado
               CAST(NULL AS VARCHAR(80)) AS PaisSubstituto, -- Nome do Pais do Substituto Documento Referenciado
               CAST( PAG.CODBCO  AS Numeric(9)) AS CodigoBanco, -- Cdigo do Banco da Parcela
               CAST(NULL AS VARCHAR(9)) AS CodigoAgencia, -- Cdigo da Agncia Bancria da Parcela
               CAST(NULL AS VARCHAR(2)) AS DigitoAgencia -- Dgito da Agncia Bancria da Parcela
          FROM TT_COM COM
          -- Srie de Emisso
          LEFT JOIN (SELECT DISTINCT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT, ORIGEM
                       FROM TT_FIS
                      WHERE ORIGEM IN ('C','F')) FIS ON FIS.CODSER = COM.CODSER AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$') AND FIS.ORIGEM = CASE WHEN COALESCE(COM.TIPPAR,'F') = 'T' THEN 'F' ELSE 'C' END
          -- Natureza
          LEFT JOIN TD_CFO DCFO ON DCFO.CODTAB = COM.CODCFO
          -- Fornecedor
          JOIN TT_CLI PAR ON PAR.FILCLI = COM.FILFOR AND PAR.CODCLI = COM.CODFOR
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.FILEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = COM.FILFOR AND ENDFAT.CODCLI = COM.CODFOR AND ENDFAT.CODFIL = COM.FILEND AND ENDFAT.NUMEND = COM.NUMEND
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          -- Busca Informaes do pagamento
          JOIN (SELECT LPAG.CODFIL, LPAG.SEQUEN, MIN(LPAG.CODBCO) AS CODBCO, MIN(LPAG.DOCPGT) AS DOCPGT, MIN(LPAG.AUTBAN) AS AUTBAN, MIN(LPAG.DATVEN) AS DATVEN, COALESCE(MIN(LPAG.DATPGT),MIN(LPAG.DATVEN)) AS DATPGT
                  FROM TT_PAG LPAG
                 GROUP BY LPAG.CODFIL, LPAG.SEQUEN
                ) PAG ON PAG.CODFIL = COM.CODFIL AND PAG.SEQUEN = COM.SEQUEN
          -- Busca documentos refernciados
          JOIN ( SELECT DISTINCT CXC.FILCOM AS FILREF, CXC.SEQCOM AS SEQREF, CXC.FILDOC AS FILORI, CXC.SEQDOC AS SEQORI
                   FROM TT_COMXCOM CXC
                ) NREF ON NREF.FILORI = COM.CODFIL AND NREF.SEQORI = COM.SEQUEN
          JOIN TT_COM CREF ON CREF.CODFIL = NREF.FILREF AND CREF.SEQUEN = NREF.SEQREF
          -- Srie de Emisso
          LEFT JOIN (SELECT DISTINCT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT, ORIGEM
                       FROM TT_FIS
                      WHERE ORIGEM IN ('C','F')) CREF_FIS ON CREF_FIS.CODSER = CREF.CODSER AND CREF_FIS.SUBSER = COALESCE(CREF.SUBSER,'$$$') AND CREF_FIS.ORIGEM = CASE WHEN COALESCE(CREF.TIPPAR,'F') = 'T' THEN 'F' ELSE 'C' END
          -- Natureza
          LEFT JOIN TD_CFO CREF_DCFO ON CREF_DCFO.CODTAB = CREF.CODCFO
          -- Fornecedor
          JOIN TT_CLI CREF_PAR ON CREF_PAR.FILCLI = CREF.FILFOR AND CREF_PAR.CODCLI = CREF.CODFOR
          --JOIN TT_END CREF_ENDE ON CREF_ENDE.FILCLI = CREF_PAR.FILCLI AND CREF_ENDE.CODCLI = CREF_PAR.CODCLI AND CREF_ENDE.CODFIL = CREF_PAR.FILEND AND CREF_ENDE.NUMEND = CREF_PAR.FILEND
         WHERE COM.FLGEST <> 'D'
           AND COM.NUMNOT NOT LIKE '%#%'
           AND CREF.NUMNOT NOT LIKE '%#%'
           AND COALESCE(COM.CODDAR,'-1') IN ('0','1')
           AND COM.TIPPAR IS NULL
           AND COM.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',COM.CODFIL,'','','')
           AND (LeParametroTXT('TIPO_EXP_EME4', COM.CODFIL, '', '', '') = 'C')
           AND COM.EXPEM4 = 'F'
       ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Banco" (Tabela Integrao Mult)
/*-- SEQ 2630 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_BANCO CASCADE;

/*-- SEQ 2631 --*/
CREATE OR REPLACE VIEW TV_TIMU_BANCO AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST('X' AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CBANCO, TAB.ATU_EM, TAB.DATINC,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger
      TAB.Codigo, -- Cdigo do Banco
      TAB.NomeFantasia -- Nome do Banco
  FROM (
         SELECT DBCO.CBANCO, 
               (SELECT ATU_EM 
                  FROM TT_ATU 
                 WHERE DESATU='CONFIGURACAO') AS ATU_EM, 
               (SELECT ATU_EM 
                  FROM TT_ATU 
                 WHERE DESATU='CONFIGURACAO') AS DATINC,
               (SELECT ATU_EM 
                  FROM TT_ATU 
                 WHERE DESATU='CONFIGURACAO') AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger
               CAST(TO_NUMBER(DBCO.CBANCO) AS Numeric(10)) AS Codigo, -- Cdigo do Banco
               CAST(DBCO.NBANCO AS VARCHAR(40)) AS NomeFantasia -- Nome do Banco
          FROM TD_BCO DBCO ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Centros de Custos do Documento" (Tabela Integrao Mult)
/*-- SEQ 2632 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_CENTROCUSTOFINANCEIRO CASCADE;

/*-- SEQ 2633 --*/
CREATE OR REPLACE VIEW TV_TIMU_CENTROCUSTOFINANCEIRO AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.FILCTA, TAB.SEQCTA, TAB.TIPCTA, TAB.CODCUS, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.CodigoConta, -- Cdigo da Conta Financeira
      TAB.CodigoCentroCusto, -- Cdigo do Centro de Custo
      TAB.Valor -- Valor para este centro de custo
  FROM ( -- Notas de Recebidas
         SELECT
               COM.CODFIL, COM.SEQUEN, CXC.FILCTA, CXC.SEQCTA, CXC.TIPCTA, CUS.CODCUS, CAST('CUS' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_CENTROCUSTOFINANCEIRO' AS VARCHAR(50)) AS DESTINO, COALESCE(COM.DATINC, COM.DATOPE) AS DATINC, COM.ATU_EM, COM.EXPORT, COM.EXPEM4,
               CAST('COM' || COM.CODFIL || COM.SEQUEN AS VARCHAR(50)) AS CHAVE,
               COALESCE(COM.DATINC, COM.DATOPE) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               CAST(                    TO_NUMBER(NULLIF(regexp_replace(DCFO.EXTCFO, '[^0-9]', '', 'gi'), '')) AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST(TO_NUMBER(COM.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = COM.FILFOR AND REL.CODPAR = COM.CODFOR AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                         ELSE 'C' 
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('2' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST(CASE WHEN ISNOTNULL(FIS.SEREXP)='T' THEN LPAD(TRIM(FIS.SEREXP), 3, '0')||CASE WHEN COM.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(FIS.SUBEXP),'0'), 2, '0') END
                         ELSE LPAD(TRIM(COM.CODSER), 2, '0')||CASE WHEN COM.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(COM.SUBSER),'0'), 3, '0') END
                    END AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(TO_CHAR(TO_NUMBER(TRIM(COM.NUMNOT))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               -- Definido juntamente com a EME4 quando o cdigo da conta financeira no possuir um "-" devemos exportar para uma Conta fixa para posterior reviso
               --CAST(TRIM(COALESCE(CXF.CODEXT, CTA.CODEXT, CODIGO_CONTA(CTA.CODFIL, CTA.SEQUEN, 'X'))) AS VARCHAR(15)) AS CodigoConta, -- Cdigo da Conta Financeira
               CAST(TRIM(CASE WHEN INSTR(COALESCE(CXF.CODEXT, CTA.CODEXT, CODIGO_CONTA(CTA.CODFIL, CTA.SEQUEN, 'X')), '-') > 0 THEN TRIM(SUBSTR(COALESCE(CXF.CODEXT, CTA.CODEXT, CODIGO_CONTA(CTA.CODFIL, CTA.SEQUEN, 'X')),1,15)) ELSE '99999-1' END) AS VARCHAR(15)) AS CodigoConta, -- Cdigo da Conta Financeira
               CAST(TRIM(SUBSTR(COALESCE(DCUS.EXTCUS, DCUS.CENCUS),1,15)) AS VARCHAR(15)) AS CodigoCentroCusto, -- Cdigo do Centro de Custo
               /* Calcula valor proporcional do centro de custo para com o Valor da conta financeira */
               CAST(CUS.VLRRAT * (CXC.VLRRAT / COM.VLRLIQ) AS Numeric(15,2)) AS Valor -- Valor para este centro de custo
          FROM TT_CUS CUS 
          JOIN TT_COM COM ON COM.CODFIL = CUS.CODFIL AND COM.SEQUEN = CUS.SEQUEN
          -- Contas Financeira
          JOIN (SELECT COALESCE(LCXC.CODFIL, LCOM.CODFIL) AS CODFIL, COALESCE(LCXC.SEQUEN, LCOM.SEQUEN) AS SEQUEN, 
                       COALESCE(LCXC.FILCTA, LCOM.FILCTA) AS FILCTA, COALESCE(LCXC.SEQCTA, LCOM.SEQCTA) AS SEQCTA, COALESCE(LCXC.TIPCTA, LCOM.TIPCTA) AS TIPCTA, COALESCE(LCXC.VLRRAT, LCOM.VLRLIQ) AS VLRRAT
                  FROM TT_COM LCOM
                  LEFT JOIN TT_COMXCTA LCXC ON LCXC.CODFIL=LCOM.CODFIL AND LCXC.SEQUEN=LCOM.SEQUEN
                ) CXC ON CXC.CODFIL = CUS.CODFIL AND CXC.SEQUEN = CUS.SEQUEN
          -- Centro de Custo
          JOIN TD_CUS DCUS ON DCUS.CODTAB = CUS.CODCUS
          -- Srie de Emisso
          LEFT JOIN (SELECT DISTINCT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT, ORIGEM
                       FROM TT_FIS
                      WHERE ORIGEM IN ('C','F')) FIS ON FIS.CODSER = COM.CODSER AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$') AND FIS.ORIGEM = CASE WHEN COALESCE(COM.TIPPAR,'F') = 'T' THEN 'F' ELSE 'C' END
          -- Natureza
          LEFT JOIN TD_CFO DCFO ON DCFO.CODTAB = COM.CODCFO
          -- Fornecedor
          JOIN TT_CLI PAR ON PAR.FILCLI = COM.FILFOR AND PAR.CODCLI = COM.CODFOR
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.FILEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = COM.FILFOR AND ENDFAT.CODCLI = COM.CODFOR AND ENDFAT.CODFIL = COM.FILEND AND ENDFAT.NUMEND = COM.NUMEND
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          JOIN TT_CTA CTA ON CTA.CODFIL = CXC.FILCTA AND CTA.SEQUEN = CXC.SEQCTA AND CTA.TIPCTA = CXC.TIPCTA  
          LEFT JOIN TT_CTAXFIL CXF ON CXF.FILCTA = CTA.CODFIL AND CXF.SEQCTA = CTA.SEQUEN AND CXF.CODFIL = CXC.CODFIL
        WHERE COM.FLGEST <> 'D'
          AND COM.NUMNOT NOT LIKE '%#%'
          AND COM.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',COM.CODFIL,'','','')
          AND (LeParametroTXT('TIPO_EXP_EME4', COM.CODFIL, '', '', '') = 'C')
          AND COM.EXPEM4 = 'F'
          -- Definido juntamente com a EME4 que documentos de Transferncia no devem gerar a Parte
          AND NOT EXISTS(SELECT 1 AS OK FROM TT_TRA TRA WHERE TRA.FILICO = COM.CODFIL AND TRA.SEQICO = COM.SEQUEN)
       ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integração de "Clientes" (Tabela Integração Mult)
/*-- SEQ 2634 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_CLIENTE CASCADE;

/*-- SEQ 2635 --*/
CREATE OR REPLACE VIEW TV_TIMU_CLIENTE AS
   SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST('X' AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Inclusão/Alteração Automática para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importação / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrição da inconsistência
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importação / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrição da inconsistência
      TAB.FILCLI, TAB.CODCLI, TAB.ATU_EM, TAB.DATINC, TAB.CODEXT,
      TAB.DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
      TAB.CpfCnpj, -- CPF ou CNPJ do Cliente
      TAB.InscEstadual, -- Inscrição Estadual do Cliente
      TAB.InscMunicipal, -- Inscrição Municipal do Cliente
      TAB.CodigoCliente, -- Código do Cliente
      TAB.CodAltCli, -- Código Alternativo do Cliente
      TAB.Fantasia, -- Nome Fantasia do Cliente
      TAB.TipoPessoa, -- 1=Física; 2=Jurídica
      TAB.Nome, -- Razão Social do Cliente
      TAB.Logradouro, -- Logradouro do Endereço
      TAB.NumeroEnd, -- Número do Endereço do Cliente
      TAB.ComplementoEnd, -- Complemento do Endereço do Cliente
      TAB.CEPEnd, -- CEP do Endereço do Cliente
      TAB.CodMunicipioIBGE, -- GeoCodigo do M3 - caso esteja informado deverá importar o vínculo do município por este código (Endereço)
      TAB.CidadeEnd, -- Cidade do Endereço do Cliente
      TAB.BairroEnd, -- Bairro do Endereço do Cliente
      TAB.EstadoEnd, -- Estado do Endereço do Cliente
      TAB.CodigoPaisEnd, -- Codigo do Banco Central para o Pais
      TAB.PaisEnd, -- Nome do Pais do Endereço do Cliente
      TAB.CpfCnpjRepresentante, -- CPF ou CNPJ do Representante do Cliente
      TAB.CodRepresentante, -- Código do Representante do Cliente
      TAB.CpfCnpjVendedor, -- CPF ou CNPJ do Representante do Cliente
      TAB.CodVendedor, -- Código do Vendedor Interno do Cliente      
      TAB.CpfCnpjTransportadora, -- CPF ou CNPJ da Transportadora do Cliente
      TAB.CodTransportadora, -- Código da Transportadora do Cliente
      TAB.CpfCnpjTranspRedespacho, -- CPF ou CNPJ da Transportadora de Redespacho do Cliente
      TAB.CodTranspRedespacho, -- Código da Transportadora de Redespacho do Cliente
      TAB.LogradouroCob, -- Logradouro do Endereço de Cobrança
      TAB.CepCob, -- CEP do Endereço de Cobrança
      TAB.CodMunicipioIBGECob, -- GeoCodigo do M3 - caso esteja informado deverá importar o vínculo do município por este código (Endereço)
      TAB.CidadeCob, -- Cidade do Endereço de Cobrança
      TAB.BairroCob, -- Bairro do Endereço de Cobrança
      TAB.EstadoCob, -- Estado do Endereço de Cobrança
      TAB.CodigoPaisCob, -- Codigo do Banco Central para o Pais
      TAB.PaisCob, -- Nome do Pais do Endereço de Cobrança
      TAB.Telefone, -- Telefone Principal do Cliente
      TAB.DataFundacao, -- Data da Fundação da Empresa do Cliente
      TAB.ValorLimiteCredito, -- Valor Limite de crédito 
      TAB.DataLimiteCredito, -- Data do Limite de Crédito
      TAB.ContatoComprador, -- Nome Contato Cobrança
      TAB.DataCadastro, -- Data de Cadastro do Cliente 
      TAB.DataAtualizacao, -- Data de última atualização do cadastro do Cliente
      TAB.SituacaoCliente, --Situação de crédito {0=Normal;1=Crédito Bloqueado;3=Limite Atingido;4=Inadimplente;5=Limite Atingido/InadimplenteInativo;6=Encerrou Atividades;7=Data Limite Atingida;8=Cadastro;9=Cadastro Bloqueado}
      TAB.CodCondParcelamento, -- Código da Condição de Parcelamento
      TAB.CodTipoCob, -- Código do Tipo de Cobrança
      TAB.CodFormaCob, -- Código da Forma de Cobrança
      TAB.Classificacao, -- Nome da Classificação do cliente
      TAB.CodigoCategoria, -- Código da Categoria do Cliente
      TAB.CodigoBanco, -- Código do Banco do Cliente
      TAB.CodigoAgencia, -- Código da Agência Bancária do Cliente
      TAB.CodigoContaBancaria, -- Código da Conta Bancária do Cliente
      TAB.DiasAtrasoMedio, -- Dias de atraso médio do cliente (Análise de crédito)
      TAB.Inativo, -- Situação do Cliente T/F
      TAB.TemRegimeEspecial, -- T/F - Tem regime especial? (Tributação)
      TAB.Funcionario, -- É funcionário?
      TAB.CodFilialFuncionario, -- Código da Filial do Funcionário
      TAB.FuncaoFuncionario, -- Descrição da Função do Funcionário
      TAB.SetorFuncionario, -- Descrição do Setor do Funcionário
      TAB.NaoEnviarInstProt, -- Não Enviar Instrução de Protesto
      TAB.DesconsJurosMulta, -- Desconsiderar Juros e Multas na baixa
      TAB.EGrupoEmpresarial, -- É Grupo empresarial?
      TAB.CPFCNPJGrupoEmp, -- CPF ou CNPJ do Grupo Empresarial
      TAB.CodFilial, -- Código da Filial Opcional Param. Cliente
      TAB.DataNascimento -- Data de Nascimento - Pessoa Física
  FROM (SELECT PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS ATU_EM, PAR.DATOPE AS DATINC, PAR.CODEXT,
          GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
          CAST(TRIM(PAR.NUMDOC) AS VARCHAR(18)) AS CpfCnpj, -- CPF ou CNPJ do Cliente
          CAST(TRIM(COALESCE(ENDE.INSEST, PAR.INSEST)) AS VARCHAR(20)) AS InscEstadual, -- Inscrição Estadual do Cliente
          CAST(ENDE.INSMUN AS VARCHAR(10)) AS InscMunicipal, -- Inscrição Municipal do Cliente
          CAST(TO_NUMBER(CASE WHEN (ISNULL(PAR.NUMDOC)='T') AND (ISNULL(PAR.CODEXT)='T') THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                              ELSE SUBSTR(TO_CHAR(CAST(                                                       NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                          END) AS Numeric(9)) AS CodigoCliente, -- Código do Cliente
          CAST(PAR.FILCLI||PAR.CODCLI AS VARCHAR(20)) AS CodAltCli, -- Código Alternativo do Cliente
          CAST(CASE WHEN (ISNULL(PAR.CODEXT)='F') THEN NULL ELSE TRIM(CASE WHEN PAR.FLGTIP = '0' THEN PAR.NOMTRA ELSE COALESCE(PAR.ULTNOM, PAR.NOMTRA) END) END AS VARCHAR(50)) AS Fantasia, -- Nome Fantasia do Cliente
          CAST(CASE WHEN PAR.FLGTIP = '0' THEN '1'
                    ELSE '2'
               END AS VARCHAR(1)) AS TipoPessoa, -- 1=Física; 2=Jurídica
          CAST(TRIM(PAR.NOMCLI || ' ' || CASE WHEN (PAR.FLGTIP = '0') AND ((SELECT CFG.UNE_NOME_SOBRENOME FROM TT_CFG CFG)='F') THEN COALESCE(PAR.ULTNOM,'') ELSE '' END) AS VARCHAR(120)) AS Nome, -- Razão Social do Cliente
          CAST(TRIM(ENDE.ENDERE) AS VARCHAR(120)) AS Logradouro, -- Logradouro do Endereço
          CAST(SUBSTR(TO_CHAR(CAST(                                   NULLIF(regexp_replace(ENDE.NUMERO, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 10) AS Numeric(10)) AS NumeroEnd, -- Número do Endereço do Cliente
          CAST(TRIM(ENDE.COMPLE) AS VARCHAR(30)) AS ComplementoEnd, -- Complemento do Endereço do Cliente
          CAST(CASE WHEN DPAI.CODPAI = 1058 THEN LPAD(COALESCE(TRIM(ENDE.CODCEP), '0'), 5, '0')||LPAD(COALESCE(TRIM(ENDE.CODLOG), '0'), 3, '0') ELSE NULL END AS VARCHAR(10)) AS CEPEnd, -- CEP do Endereço do Cliente
          CAST(TRIM(ENDE.BAIRRO) AS VARCHAR(80)) AS BairroEnd, -- Bairro do Endereço do Cliente
          CAST(CASE WHEN DPAI.CODPAI = 1058 THEN IBG.CODIBG ELSE NULL END AS Numeric(10)) AS CodMunicipioIBGE, -- GeoCodigo do M3 - caso esteja informado deverá importar o vínculo do município por este código (Endereço)
          -- A Pedido da EME4 não será exportado os dados da Cidade/Estado/Pais
          CAST(TRIM(CASE WHEN DPAI.CODPAI = 1058 THEN NULL /*IBG.NOMMUN*/ ELSE ENDE.NOMCID END) AS VARCHAR(100)) AS CidadeEnd, -- Cidade do Endereço do Cliente
          CAST(TRIM(CASE WHEN DPAI.CODPAI = 1058 THEN NULL /*IBG.SIGEST*/ ELSE NULL END) AS VARCHAR(2)) AS EstadoEnd, -- Estado do Endereço do Cliente
          CAST(DPAI.CODPAI AS Numeric(9)) AS CodigoPaisEnd, -- Codigo do Banco Central para o Pais
          CAST(TRIM(CASE WHEN DPAI.CODPAI = 1058 THEN NULL /*DPAI.DESPAI*/ ELSE DPAI.DESPAI END) AS VARCHAR(80)) AS PaisEnd, -- Nome do Pais do Endereço do Cliente
          --CAST(TRIM(COALESCE(VENENDE.NUMDOC, VENPAR.NUMDOC)) AS VARCHAR(18)) AS CpfCnpjRepresentante, -- CPF ou CNPJ do Representante do Cliente
          CAST(TRIM(VENPAR.NUMDOC) AS VARCHAR(18)) AS CpfCnpjRepresentante, -- CPF ou CNPJ do Representante do Cliente
          CAST(NULL AS Numeric(9)) AS CodRepresentante, -- Código do Representante do Cliente
          --CAST(TRIM(COALESCE(VENENDE.NUMDOC, VENPAR.NUMDOC)) AS VARCHAR(18)) AS CpfCnpjVendedor, -- CPF ou CNPJ do Vendedor Interno do Cliente
          CAST(TRIM(VENPAR.NUMDOC) AS VARCHAR(18)) AS CpfCnpjVendedor, -- CPF ou CNPJ do Representante do Cliente
          CAST(NULL AS Numeric(9)) AS CodVendedor, -- Código do Vendedor Interno do Cliente      
          CAST(NULL AS VARCHAR(18)) AS CpfCnpjTransportadora, -- CPF ou CNPJ da Transportadora do Cliente
          CAST(NULL AS Numeric(9)) AS CodTransportadora, -- Código da Transportadora do Cliente
          CAST(NULL AS VARCHAR(18)) AS CpfCnpjTranspRedespacho, -- CPF ou CNPJ da Transportadora de Redespacho do Cliente
          CAST(NULL AS Numeric(9)) AS CodTranspRedespacho, -- Código da Transportadora de Redespacho do Cliente
          CAST(TRIM(ENDCOB.ENDERE) AS VARCHAR(120)) AS LogradouroCob, -- Logradouro do Endereço de Cobrança
          --CAST(SUBSTR(TO_CHAR(CAST(          --                         NULLIF(regexp_replace(ENDCOB.NUMERO, '[^0-9]', '', 'gi'), '')) AS Numeric(20)), 1, 10) AS Numeric(10)) AS NumeroCob, -- Número do Endereço de Cobrança
          --CAST(TRIM(ENDCOB.COMPLE) AS VARCHAR(30)) AS ComplementoCob, -- Complemento do Endereço de Cobrança
          CAST(TRIM(CASE WHEN DPAICOB.CODPAI = 1058 THEN LPAD(COALESCE(TRIM(ENDCOB.CODCEP), '0'), 5, '0')||LPAD(COALESCE(TRIM(ENDCOB.CODLOG), '0'), 3, '0') ELSE NULL END) AS VARCHAR(10)) AS CepCob, -- CEP do Endereço de Cobrança
          CAST(TRIM(ENDCOB.BAIRRO) AS VARCHAR(80)) AS BairroCob, -- Bairro do Endereço de Cobrança
          CAST(CASE WHEN DPAICOB.CODPAI = 1058 THEN IBGCOB.CODIBG ELSE NULL END AS Numeric(10)) AS CodMunicipioIBGECob, -- GeoCodigo do M3 - caso esteja informado deverá importar o vínculo do município por este código (Endereço)
          -- A Pedido da EME4 não será exportado os dados da Cidade/Estado/Pais
          CAST(TRIM(CASE WHEN DPAICOB.CODPAI = 1058 THEN NULL /*IBGCOB.NOMMUN*/ ELSE ENDCOB.NOMCID END) AS VARCHAR(80)) AS CidadeCob, -- Cidade do Endereço de Cobrança
          CAST(TRIM(CASE WHEN DPAICOB.CODPAI = 1058 THEN NULL /*IBGCOB.SIGEST*/ ELSE NULL END) AS VARCHAR(2)) AS EstadoCob, -- Estado do Endereço de Cobrança
          CAST(DPAICOB.CODPAI AS Numeric(9)) AS CodigoPaisCob, -- Codigo do Banco Central para o Pais
          CAST(TRIM(CASE WHEN DPAICOB.CODPAI = 1058 THEN NULL /*DPAICOB.DESPAI*/ ELSE DPAICOB.DESPAI END) AS VARCHAR(80)) AS PaisCob, -- Nome do Pais do Endereço de Cobrança
          CAST(CASE WHEN ISNULL(ENDE.CODDDD)='T' THEN '' ELSE '(' || COALESCE(ENDE.CODDDD,'') || ') ' END || TRIM(ENDE.NUMFON) AS VARCHAR(20)) AS Telefone, -- Telefone Principal do Cliente
          TRUNC(PAR.DATNAS) AS DataFundacao, -- Data da Fundação da Empresa do Cliente
          CAST(PAR.VALOR1 AS Numeric(15,2)) AS ValorLimiteCredito, -- Valor Limite de crédito 
          TRUNC(PAR.VALLIM) AS DataLimiteCredito, -- Data do Limite de Crédito
          CAST(NULL AS VARCHAR(50)) AS ContatoComprador, -- Nome Contato Cobrança
          TRUNC(PAR.DATOPE) AS DataCadastro, -- Data de Cadastro do Cliente 
          TRUNC(GREATEST(PAR.ATU_EM, PAR.ULTCOM)) AS DataAtualizacao, -- Data de última atualização do cadastro do Cliente
          CAST(CASE WHEN PAR.TOTATR > 0 THEN '4'
                    WHEN TRUNC(PAR.VALLIM) > TRUNC(Agora()) THEN '7'
                    WHEN PAR.SIGNAT < 0 THEN '9'
                    ELSE '0'
               END AS VARCHAR(1)) AS SituacaoCliente, --Situação de crédito {0=Normal;1=Crédito Bloqueado;3=Limite Atingido;4=Inadimplente;5=Limite Atingido/InadimplenteInativo;6=Encerrou Atividades;7=Data Limite Atingida;8=Cadastro;9=Cadastro Bloqueado}
          CAST(TRIM(PAR.FILPLA||PAR.CODPLA) AS VARCHAR(10)) AS CodCondParcelamento, -- Código da Condição de Parcelamento
          CAST(NULL AS VARCHAR(10)) AS CodTipoCob, -- Código do Tipo de Cobrança
          CAST(NULL AS VARCHAR(5)) AS CodFormaCob, -- Código da Forma de Cobrança
          CAST(NULL AS VARCHAR(1)) AS Classificacao, -- Nome da Classificação do cliente
          CAST(COALESCE(DCT1.CODEXT_DCT1, COALESCE(DCT2.CODEXT_DCT2, DCT3.CODEXT_DCT3)) AS VARCHAR(20)) AS CodigoCategoria, -- Código da Categoria do Cliente
          CAST(CBP.CODBCO AS Numeric(9)) AS CodigoBanco, -- Código do Banco do Cliente
          CAST(CBP.NUMAGE AS VARCHAR(10)) AS CodigoAgencia, -- Código da Agência Bancária do Cliente
             --CAST(CBP.DIGAGE AS VARCHAR(2)) AS DigitoAgencia, -- Dígito da Agência Bancária do Cliente
          CAST(CBP.CTACRR AS VARCHAR(20)) AS CodigoContaBancaria, -- Código da Conta Bancária do Cliente
             --CAST(CBP.DIGCRR AS Numeric(1)) AS DigitoContaBancaria, -- Dígito da Conta Bancária do Cliente
             --CAST(CASE WHEN COALESCE(CBP.TIPCON, 'X') NOT IN ('C','P') THEN NULL
             --          ELSE CBP.TIPCON
             --     END AS VARCHAR(1)) AS TipoConta, -- C = Conta Corrente / P = Poupança
          CAST(CASE WHEN COALESCE(PAR.TOTPAR,0) = 0 THEN 0
                    ELSE COALESCE(PAR.TOTATR,0)/PAR.TOTPAR
               END AS Numeric(9)) AS DiasAtrasoMedio, -- Dias de atraso médio do cliente (Análise de crédito)
          CAST(CASE WHEN PAR.SIGNAT>=0 THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situação do Cliente T/F
          CAST(PAR.REGESP AS VARCHAR(1)) AS TemRegimeEspecial, -- T/F - Tem regime especial? (Tributação)
          CAST(CASE WHEN ISNOTNULL(FUN.FILUSU) = 'T' THEN 'T' ELSE 'F' END AS VARCHAR(1)) AS Funcionario, -- É funcionário?
          --CAST(CASE WHEN ISNOTNULL(FUN.FILUSU) = 'T' THEN TO_NUMBER(COALESCE(FUN.FILATV, '${PA_FILIAL_FUNCIONARIO}'/*FUN.FILUSU*/)) ELSE NULL END AS Numeric(3)) AS CodFilialFuncionario, -- Código da Filial do Funcionário
          CAST(CASE WHEN ISNOTNULL(FUN.FILUSU) = 'T' THEN TO_NUMBER(COALESCE(FUN.FILATV, LeParametroTxt('FIL_FUNC_EXP_EME4', PAR.FILCLI, '', '', ''))) ELSE NULL END AS Numeric(3)) AS CodFilialFuncionario, -- Código da Filial do Funcionário          
          CAST(CASE WHEN ISNOTNULL(FUN.FILUSU) = 'T' THEN CASE WHEN ISNOTNULL(DOCU.DESOCU) = 'T' THEN TRIM(DOCU.DESOCU) ELSE DescricaoDominio('USU','NIVUSU',TO_CHAR(FUN.NIVUSU)) END ELSE NULL END AS VARCHAR(50)) AS FuncaoFuncionario, -- Descrição da Função do Funcionário
          CAST(CASE WHEN ISNOTNULL(FUN.FILUSU) = 'T' THEN CASE WHEN ISNOTNULL(DSET.DESSET) = 'T' THEN DSET.DESSET ELSE 'NAO INFORMADO' END ELSE NULL END AS VARCHAR(50)) AS SetorFuncionario, -- Descrição do Setor do Funcionário
          CAST('F' AS VARCHAR(1)) AS NaoEnviarInstProt, -- Não Enviar Instrução de Protesto
          CAST('F' AS VARCHAR(1)) AS DesconsJurosMulta, -- Desconsiderar Juros e Multas na baixa
          CAST('F' AS VARCHAR(1)) AS EGrupoEmpresarial, -- É Grupo empresarial?
          CAST(NULL AS VARCHAR(1)) AS CPFCNPJGrupoEmp, -- CPF ou CNPJ do Grupo Empresarial
          CAST(TO_NUMBER(PAR.FILCLI) AS Numeric(3)) AS CodFilial, -- Código da Filial Opcional Param. Cliente
          CASE WHEN PAR.FLGTIP = '0' THEN TRUNC(PAR.DATNAS) ELSE NULL END AS DataNascimento -- Data de Nascimento - Pessoa Física
     FROM TT_CLI PAR
     LEFT JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
     LEFT JOIN TT_MUN MUN ON MUN.CODIGO = ENDE.CODCID
     LEFT JOIN TT_IBG IBG ON IBG.CODIBG = COALESCE(ENDE.CODIBG, MUN.CODIBG)
     LEFT JOIN TD_PAI DPAI ON DPAI.CODPAI = ENDE.CODPAI
     LEFT JOIN TT_SPC SPC ON SPC.FILCLI = PAR.FILCLI AND SPC.CODCLI = PAR.CODCLI
     LEFT JOIN TD_OCU DOCU ON DOCU.CODTAB = SPC.CODOCU -- Cargo Ocupado na Guia SPC
     LEFT JOIN TT_USU VEN ON VEN.FILUSU = PAR.FILVEN AND VEN.CODUSU = PAR.CODVEN
     LEFT JOIN TT_CLI VENPAR ON VENPAR.FILCLI = VEN.FILCLI AND VENPAR.CODCLI = VEN.CODCLI
     --LEFT JOIN TT_END VENENDE ON VENENDE.FILCLI = VENPAR.FILCLI AND VENENDE.CODCLI = VENPAR.CODCLI AND VENENDE.CODFIL = VENPAR.FILEND AND VENENDE.NUMEND = VENPAR.NUMEND
     -- Parceiro Vinculado - Só buscar o vínculo se a pessoa não for física
     --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
     -- Dados de Funcionário
     LEFT JOIN TT_USU FUN ON FUN.FILCLI = PAR.FILCLI AND FUN.CODCLI = PAR.CODCLI AND FUN.SIGNAT >= 0
     LEFT JOIN TD_SET DSET ON DSET.CODTAB = FUN.CODSET
     -- Endereço de Cobrança
     LEFT JOIN TT_END ENDCOB ON ENDCOB.FILCLI = PAR.FILCLI AND ENDCOB.CODCLI = PAR.CODCLI
                           AND ENDCOB.ENDCOB = 'T'
                           AND (ENDCOB.CODFIL, ENDCOB.NUMEND) IN 
                               (SELECT COB.CODFIL, COB.NUMEND
                                  FROM TT_END COB 
                                 WHERE COB.FILCLI = ENDCOB.FILCLI AND COB.CODCLI = ENDCOB.CODCLI
                                   AND COB.ENDCOB = 'T'
                                                                 LIMIT 1  )
     LEFT JOIN TT_MUN MUNCOB ON MUNCOB.CODIGO = ENDCOB.CODCID
     LEFT JOIN TT_IBG IBGCOB ON IBGCOB.CODIBG = COALESCE(ENDCOB.CODIBG, MUNCOB.CODIBG)
     LEFT JOIN TD_PAI DPAICOB ON DPAICOB.CODPAI = ENDCOB.CODPAI
     -- Conta Bancária
     LEFT JOIN TT_CBP CBP ON CBP.FILCLI = PAR.FILCLI AND CBP.CODCLI = PAR.CODCLI
                         AND (CBP.CODFIL, CBP.SEQUEN) IN 
                           (SELECT CTB.CODFIL, CTB.SEQUEN
                              FROM TT_CBP CTB
                             WHERE CTB.FILCLI = CBP.FILCLI AND CTB.CODCLI = CBP.CODCLI
                                                             LIMIT 1  )
      -- Categorias
      LEFT JOIN TD_CT1 DCT1 ON DCT1.CODTAB = PAR.CATEG1
      LEFT JOIN TD_CT2 DCT2 ON DCT2.CODTAB = PAR.CATEG2
      LEFT JOIN TD_CT3 DCT3 ON DCT3.CODTAB = PAR.CATEG3
    WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
      AND (PAR.CODCLI <> LPAD('0', 6, ' '))
      AND COALESCE(PAR.INDEXP, 'E') <> 'N'
    UNION ALL
    -- Parceiro Filial cadastrado como um Endereço
    SELECT PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS ATU_EM, PAR.DATOPE AS DATINC, CAST(NULL AS VARCHAR(20)) AS CODEXT,
          GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
          CAST(TRIM(ENDE.NUMDOC) AS VARCHAR(18)) AS CpfCnpj, -- CPF ou CNPJ do Cliente
          CAST(TRIM(COALESCE(ENDE.INSEST, PAR.INSEST)) AS VARCHAR(20)) AS InscEstadual, -- Inscrição Estadual do Cliente
          CAST(ENDE.INSMUN AS VARCHAR(10)) AS InscMunicipal, -- Inscrição Municipal do Cliente
          CAST(NULL AS Numeric(9)) AS CodigoCliente, -- Código do Cliente
          CAST(PAR.FILCLI||PAR.CODCLI AS VARCHAR(20)) AS CodAltCli, -- Código Alternativo do Cliente
          CAST(CASE WHEN (ISNULL(PAR.CODEXT)='F') THEN NULL ELSE TRIM(CASE WHEN PAR.FLGTIP = '0' THEN PAR.NOMTRA ELSE COALESCE(PAR.ULTNOM, PAR.NOMTRA) END) END AS VARCHAR(50)) AS Fantasia, -- Nome Fantasia do Cliente
          CAST(CASE WHEN PAR.FLGTIP = '0' THEN '1'
                    ELSE '2'
               END AS VARCHAR(1)) AS TipoPessoa, -- 1=Física; 2=Jurídica
          CAST(TRIM(PAR.NOMCLI || ' ' || CASE WHEN (PAR.FLGTIP = '0') AND ((SELECT CFG.UNE_NOME_SOBRENOME FROM TT_CFG CFG)='F') THEN COALESCE(PAR.ULTNOM,'') ELSE '' END) AS VARCHAR(120)) AS Nome, -- Razão Social do Cliente
          CAST(TRIM(ENDE.ENDERE) AS VARCHAR(120)) AS Logradouro, -- Logradouro do Endereço
          CAST(SUBSTR(TO_CHAR(CAST(                                   NULLIF(regexp_replace(ENDE.NUMERO, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 10) AS Numeric(10)) AS NumeroEnd, -- Número do Endereço do Cliente
          CAST(TRIM(ENDE.COMPLE) AS VARCHAR(30)) AS ComplementoEnd, -- Complemento do Endereço do Cliente
          CAST(CASE WHEN DPAI.CODPAI = 1058 THEN LPAD(COALESCE(TRIM(ENDE.CODCEP), '0'), 5, '0')||LPAD(COALESCE(TRIM(ENDE.CODLOG), '0'), 3, '0') ELSE NULL END AS VARCHAR(10)) AS CEPEnd, -- CEP do Endereço do Cliente
          CAST(TRIM(ENDE.BAIRRO) AS VARCHAR(80)) AS BairroEnd, -- Bairro do Endereço do Cliente
          CAST(CASE WHEN DPAI.CODPAI = 1058 THEN IBG.CODIBG ELSE NULL END AS Numeric(10)) AS CodMunicipioIBGE, -- GeoCodigo do M3 - caso esteja informado deverá importar o vínculo do município por este código (Endereço)
          -- A Pedido da EME4 não será exportado os dados da Cidade/Estado/Pais
          CAST(TRIM(CASE WHEN DPAI.CODPAI = 1058 THEN NULL /*IBG.NOMMUN*/ ELSE ENDE.NOMCID END) AS VARCHAR(100)) AS CidadeEnd, -- Cidade do Endereço do Cliente
          CAST(TRIM(CASE WHEN DPAI.CODPAI = 1058 THEN NULL /*IBG.SIGEST*/ ELSE NULL END) AS VARCHAR(2)) AS EstadoEnd, -- Estado do Endereço do Cliente
          CAST(DPAI.CODPAI AS Numeric(9)) AS CodigoPaisEnd, -- Codigo do Banco Central para o Pais
          CAST(TRIM(CASE WHEN DPAI.CODPAI = 1058 THEN NULL /*DPAI.DESPAI*/ ELSE DPAI.DESPAI END) AS VARCHAR(80)) AS PaisEnd, -- Nome do Pais do Endereço do Cliente
          --CAST(TRIM(COALESCE(VENENDE.NUMDOC, VENPAR.NUMDOC)) AS VARCHAR(18)) AS CpfCnpjRepresentante, -- CPF ou CNPJ do Representante do Cliente
          CAST(TRIM(VENPAR.NUMDOC) AS VARCHAR(18)) AS CpfCnpjRepresentante, -- CPF ou CNPJ do Representante do Cliente
          CAST(NULL AS Numeric(9)) AS CodRepresentante, -- Código do Representante do Cliente
          --CAST(TRIM(COALESCE(VENENDE.NUMDOC, VENPAR.NUMDOC)) AS VARCHAR(18)) AS CpfCnpjVendedor, -- CPF ou CNPJ do Vendedor Interno do Cliente
          CAST(TRIM(VENPAR.NUMDOC) AS VARCHAR(18)) AS CpfCnpjVendedor, -- CPF ou CNPJ do Representante do Cliente
          CAST(NULL AS Numeric(9)) AS CodVendedor, -- Código do Vendedor Interno do Cliente      
          CAST(NULL AS VARCHAR(18)) AS CpfCnpjTransportadora, -- CPF ou CNPJ da Transportadora do Cliente
          CAST(NULL AS Numeric(9)) AS CodTransportadora, -- Código da Transportadora do Cliente
          CAST(NULL AS VARCHAR(18)) AS CpfCnpjTranspRedespacho, -- CPF ou CNPJ da Transportadora de Redespacho do Cliente
          CAST(NULL AS Numeric(9)) AS CodTranspRedespacho, -- Código da Transportadora de Redespacho do Cliente
          CAST(TRIM(ENDCOB.ENDERE) AS VARCHAR(120)) AS LogradouroCob, -- Logradouro do Endereço de Cobrança
          --CAST(SUBSTR(TO_CHAR(CAST(          --                         NULLIF(regexp_replace(ENDCOB.NUMERO, '[^0-9]', '', 'gi'), '')  AS Numeric(20))), 1, 10) AS Numeric(10)) AS NumeroCob, -- Número do Endereço de Cobrança
          --CAST(TRIM(ENDCOB.COMPLE) AS VARCHAR(30)) AS ComplementoCob, -- Complemento do Endereço de Cobrança
          CAST(TRIM(CASE WHEN DPAICOB.CODPAI = 1058 THEN LPAD(COALESCE(TRIM(ENDCOB.CODCEP), '0'), 5, '0')||LPAD(COALESCE(TRIM(ENDCOB.CODLOG), '0'), 3, '0') ELSE NULL END) AS VARCHAR(10)) AS CepCob, -- CEP do Endereço de Cobrança
          CAST(TRIM(ENDCOB.BAIRRO) AS VARCHAR(80)) AS BairroCob, -- Bairro do Endereço de Cobrança
          CAST(CASE WHEN DPAICOB.CODPAI = 1058 THEN IBGCOB.CODIBG ELSE NULL END AS Numeric(10)) AS CodMunicipioIBGECob, -- GeoCodigo do M3 - caso esteja informado deverá importar o vínculo do município por este código (Endereço)
          -- A Pedido da EME4 não será exportado os dados da Cidade/Estado/Pais
          CAST(TRIM(CASE WHEN DPAICOB.CODPAI = 1058 THEN NULL /*IBGCOB.NOMMUN*/ ELSE ENDCOB.NOMCID END) AS VARCHAR(80)) AS CidadeCob, -- Cidade do Endereço de Cobrança
          CAST(TRIM(CASE WHEN DPAICOB.CODPAI = 1058 THEN NULL /*IBGCOB.SIGEST*/ ELSE NULL END) AS VARCHAR(2)) AS EstadoCob, -- Estado do Endereço de Cobrança
          CAST(DPAICOB.CODPAI AS Numeric(9)) AS CodigoPaisCob, -- Codigo do Banco Central para o Pais
          CAST(TRIM(CASE WHEN DPAICOB.CODPAI = 1058 THEN NULL /*DPAICOB.DESPAI*/ ELSE DPAICOB.DESPAI END) AS VARCHAR(80)) AS PaisCob, -- Nome do Pais do Endereço de Cobrança
          CAST(CASE WHEN ISNULL(ENDE.CODDDD)='T' THEN '' ELSE '(' || COALESCE(ENDE.CODDDD,'') || ') ' END || TRIM(ENDE.NUMFON) AS VARCHAR(20)) AS Telefone, -- Telefone Principal do Cliente
          TRUNC(PAR.DATNAS) AS DataFundacao, -- Data da Fundação da Empresa do Cliente
          CAST(PAR.VALOR1 AS Numeric(15,2)) AS ValorLimiteCredito, -- Valor Limite de crédito 
          TRUNC(PAR.VALLIM) AS DataLimiteCredito, -- Data do Limite de Crédito
          CAST(NULL AS VARCHAR(50)) AS ContatoComprador, -- Nome Contato Cobrança
          TRUNC(PAR.DATOPE) AS DataCadastro, -- Data de Cadastro do Cliente 
          TRUNC(GREATEST(PAR.ATU_EM, PAR.ULTCOM)) AS DataAtualizacao, -- Data de última atualização do cadastro do Cliente
          CAST(CASE WHEN (LeParametroTXT('TIPO_EXP_EME4', '', '', '', '') = 'C') THEN '0'
                    WHEN PAR.TOTATR > 0 THEN '4'
                    WHEN TRUNC(PAR.VALLIM) > TRUNC(Agora()) THEN '7'
                    WHEN PAR.SIGNAT < 0 THEN '9'
                    ELSE '0'
               END AS VARCHAR(1)) AS SituacaoCliente, --Situação de crédito {0=Normal;1=Crédito Bloqueado;3=Limite Atingido;4=Inadimplente;5=Limite Atingido/InadimplenteInativo;6=Encerrou Atividades;7=Data Limite Atingida;8=Cadastro;9=Cadastro Bloqueado}
          CAST(TRIM(PAR.FILPLA||PAR.CODPLA) AS VARCHAR(10)) AS CodCondParcelamento, -- Código da Condição de Parcelamento
          CAST(NULL AS VARCHAR(10)) AS CodTipoCob, -- Código do Tipo de Cobrança
          CAST(NULL AS VARCHAR(5)) AS CodFormaCob, -- Código da Forma de Cobrança
          CAST(NULL AS VARCHAR(1)) AS Classificacao, -- Nome da Classificação do cliente
          CAST(COALESCE(DCT1.CODEXT_DCT1, COALESCE(DCT2.CODEXT_DCT2, DCT3.CODEXT_DCT3)) AS VARCHAR(20)) AS CodigoCategoria, -- Código da Categoria do Cliente
          CAST(CBP.CODBCO AS Numeric(9)) AS CodigoBanco, -- Código do Banco do Cliente
          CAST(CBP.NUMAGE AS VARCHAR(10)) AS CodigoAgencia, -- Código da Agência Bancária do Cliente
             --CAST(CBP.DIGAGE AS VARCHAR(2)) AS DigitoAgencia, -- Dígito da Agência Bancária do Cliente
          CAST(CBP.CTACRR AS VARCHAR(20)) AS CodigoContaBancaria, -- Código da Conta Bancária do Cliente
             --CAST(CBP.DIGCRR AS Numeric(1)) AS DigitoContaBancaria, -- Dígito da Conta Bancária do Cliente
             --CAST(CASE WHEN COALESCE(CBP.TIPCON, 'X') NOT IN ('C','P') THEN NULL
             --          ELSE CBP.TIPCON
             --     END AS VARCHAR(1)) AS TipoConta, -- C = Conta Corrente / P = Poupança
          CAST(CASE WHEN COALESCE(PAR.TOTPAR,0) = 0 THEN 0
                    ELSE COALESCE(PAR.TOTATR,0)/PAR.TOTPAR
               END AS Numeric(9)) AS DiasAtrasoMedio, -- Dias de atraso médio do cliente (Análise de crédito)
          CAST(CASE WHEN PAR.SIGNAT>=0 THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situação do Cliente T/F
          CAST(PAR.REGESP AS VARCHAR(1)) AS TemRegimeEspecial, -- T/F - Tem regime especial? (Tributação)
          CAST(CASE WHEN ISNOTNULL(FUN.FILUSU) = 'T' THEN 'T' ELSE 'F' END AS VARCHAR(1)) AS Funcionario, -- É funcionário?
          --CAST(CASE WHEN ISNOTNULL(FUN.FILUSU) = 'T' THEN TO_NUMBER(COALESCE(FUN.FILATV, '${PA_FILIAL_FUNCIONARIO}'/*FUN.FILUSU*/)) ELSE NULL END AS Numeric(3)) AS CodFilialFuncionario, -- Código da Filial do Funcionário
          CAST(CASE WHEN ISNOTNULL(FUN.FILUSU) = 'T' THEN TO_NUMBER(COALESCE(FUN.FILATV, LeParametroTxt('FIL_FUNC_EXP_EME4', PAR.FILCLI, '', '', ''))) ELSE NULL END AS Numeric(3)) AS CodFilialFuncionario, -- Código da Filial do Funcionário          
          CAST(CASE WHEN ISNOTNULL(FUN.FILUSU) = 'T' THEN CASE WHEN ISNOTNULL(DOCU.DESOCU) = 'T' THEN TRIM(DOCU.DESOCU) ELSE DescricaoDominio('USU','NIVUSU',TO_CHAR(FUN.NIVUSU)) END ELSE NULL END AS VARCHAR(50)) AS FuncaoFuncionario, -- Descrição da Função do Funcionário
          CAST(CASE WHEN ISNOTNULL(FUN.FILUSU) = 'T' THEN CASE WHEN ISNOTNULL(DSET.DESSET) = 'T' THEN DSET.DESSET ELSE 'NAO INFORMADO' END ELSE NULL END AS VARCHAR(50)) AS SetorFuncionario, -- Descrição do Setor do Funcionário
          CAST('F' AS VARCHAR(1)) AS NaoEnviarInstProt, -- Não Enviar Instrução de Protesto
          CAST('F' AS VARCHAR(1)) AS DesconsJurosMulta, -- Desconsiderar Juros e Multas na baixa
          CAST('F' AS VARCHAR(1)) AS EGrupoEmpresarial, -- É Grupo empresarial?
          CAST(NULL AS VARCHAR(1)) AS CPFCNPJGrupoEmp, -- CPF ou CNPJ do Grupo Empresarial
          CAST(TO_NUMBER(PAR.FILCLI) AS Numeric(3)) AS CodFilial, -- Código da Filial Opcional Param. Cliente
          CASE WHEN PAR.FLGTIP = '0' THEN TRUNC(PAR.DATNAS) ELSE NULL END AS DataNascimento -- Data de Nascimento - Pessoa Física
     FROM TT_CLI PAR
     JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ISNOTNULL(ENDE.NUMDOC) = 'T' AND TRIM(COALESCE(ENDE.NUMDOC, '')) <> TRIM(COALESCE(PAR.NUMDOC, ''))
     LEFT JOIN TT_MUN MUN ON MUN.CODIGO = ENDE.CODCID
     LEFT JOIN TT_IBG IBG ON IBG.CODIBG = COALESCE(ENDE.CODIBG, MUN.CODIBG)
     LEFT JOIN TD_PAI DPAI ON DPAI.CODPAI = ENDE.CODPAI
     LEFT JOIN TT_SPC SPC ON SPC.FILCLI = PAR.FILCLI AND SPC.CODCLI = PAR.CODCLI
     LEFT JOIN TD_OCU DOCU ON DOCU.CODTAB = SPC.CODOCU -- Cargo Ocupado na Guia SPC
     LEFT JOIN TT_USU VEN ON VEN.FILUSU = PAR.FILVEN AND VEN.CODUSU = PAR.CODVEN
     LEFT JOIN TT_CLI VENPAR ON VENPAR.FILCLI = VEN.FILCLI AND VENPAR.CODCLI = VEN.CODCLI
     --LEFT JOIN TT_END VENENDE ON VENENDE.FILCLI = VENPAR.FILCLI AND VENENDE.CODCLI = VENPAR.CODCLI AND VENENDE.CODFIL = VENPAR.FILEND AND VENENDE.NUMEND = VENPAR.NUMEND
     -- Parceiro Vinculado - Só buscar o vínculo se a pessoa não for física
     --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
     -- Dados de Funcionário
     LEFT JOIN TT_USU FUN ON FUN.FILCLI = PAR.FILCLI AND FUN.CODCLI = PAR.CODCLI AND FUN.SIGNAT >= 0
     LEFT JOIN TD_SET DSET ON DSET.CODTAB = FUN.CODSET
     -- Endereço de Cobrança
     LEFT JOIN TT_END ENDCOB ON ENDCOB.FILCLI = PAR.FILCLI AND ENDCOB.CODCLI = PAR.CODCLI
                           AND ENDCOB.ENDCOB = 'T'
                           AND (ENDCOB.CODFIL, ENDCOB.NUMEND) IN 
                               (SELECT COB.CODFIL, COB.NUMEND
                                  FROM TT_END COB 
                                 WHERE COB.FILCLI = ENDCOB.FILCLI AND COB.CODCLI = ENDCOB.CODCLI
                                   AND COB.ENDCOB = 'T'
                                                                 LIMIT 1  )
     LEFT JOIN TT_MUN MUNCOB ON MUNCOB.CODIGO = ENDCOB.CODCID
     LEFT JOIN TT_IBG IBGCOB ON IBGCOB.CODIBG = COALESCE(ENDCOB.CODIBG, MUNCOB.CODIBG)
     LEFT JOIN TD_PAI DPAICOB ON DPAICOB.CODPAI = ENDCOB.CODPAI
     -- Conta Bancária
     LEFT JOIN TT_CBP CBP ON CBP.FILCLI = PAR.FILCLI AND CBP.CODCLI = PAR.CODCLI
                         AND (CBP.CODFIL, CBP.SEQUEN) IN 
                           (SELECT CTB.CODFIL, CTB.SEQUEN
                              FROM TT_CBP CTB
                             WHERE CTB.FILCLI = CBP.FILCLI AND CTB.CODCLI = CBP.CODCLI
                                                             LIMIT 1  )
      -- Categorias
      LEFT JOIN TD_CT1 DCT1 ON DCT1.CODTAB = PAR.CATEG1
      LEFT JOIN TD_CT2 DCT2 ON DCT2.CODTAB = PAR.CATEG2
      LEFT JOIN TD_CT3 DCT3 ON DCT3.CODTAB = PAR.CATEG3
    WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
      AND (PAR.CODCLI <> LPAD('0', 6, ' '))
      AND COALESCE(PAR.INDEXP, 'E') <> 'N'
          ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Composies Produto Produo" (Tabela Integrao Mult)
/*-- SEQ 2636 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_COMPOSICAOPRODPRODU CASCADE;

/*-- SEQ 2637 --*/
CREATE OR REPLACE VIEW TV_TIMU_COMPOSICAOPRODPRODU AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST('X' AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.ATU_EM, TAB.DATINC,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.CodigoItem, -- Cdigo do Produto
      TAB.CodigoFilial, -- Cdigo da Filial
      TAB.TipoAssunto, -- Tipo Assunto Produto Produzido - Default {5}
      TAB.CodigoProdutoComposicao, -- Cdigo do Produto papel composio produzido
      TAB.CodigoUnidade, -- Cdigo da unidade do produto
      TAB.SequenciaComposicao, -- Sequencial do item na composio
      TAB.QuantidadeComposicao, -- Quantidade do item na composio - Float 6 casas
      TAB.TipoCusto, -- 0=ltima Compra,1=Custo Reposio,2=Custo Reposio Moeda 1,0=Fixa,1=Proporcional,2=Por M,3=Por Permetro,4=Frmula,
      TAB.CustoUnitarioInformado, -- Custo unitrio informado do item na composio - Float 6 casas
      TAB.Fixa_Proporcional, -- 0=Fixa,1=Proporcional,2=Por M,3=Por Permetro,4=Frmula, 
      TAB.GeraComposicao, -- T/F
      TAB.Insumo, -- T/F 
      TAB.Ativo, -- T/F
      TAB.DescricaoProducao, -- Descrio do Produto
      TAB.CodigoMaquinaOperacao, -- Cdigo da Mquina no M3 - caso vincule mquina a composio
      TAB.GerarOrdemProducao, -- T/F
      TAB.PercPesoLiquido, -- Percentual de Peso Lquido do item no Produto - Float 6 casas
      TAB.PercProporcional, -- Percentual do item no produto - Flaot 6 casas
      TAB.FormulaQuantidade,
      TAB.ExpandirComposicao, -- T/F
      TAB.BaixaSomenteseNivelAntBaixado, -- T/F
      TAB.BuscarCustodeSuasComposicoes, -- T/F
      TAB.EtapaProcessoProducao, -- Etapa de Produo do M3 - caso utilize mapa de produo
      TAB.NaoConsisteSaldoEstoque -- T/F
  FROM(SELECT ITP.CODFIL, ITP.SEQUEN, ITP.ATU_EM, ITP.DATINC,
          ITP.ATU_EM AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
          CAST(TRIM(SUBSTR(GRA.CODFIS,1,30)) AS VARCHAR(30)) AS CodigoItem, -- Cdigo do Produto
          CAST(TO_NUMBER(ITP.CODFIL) AS Numeric(3)) AS CodigoFilial, -- Cdigo da Filial
          CAST(5 AS Numeric(3)) AS TipoAssunto, -- Tipo Assunto Produto Produzido - Default {5}
          CAST(SUBSTR(INSGRA.CODFIS,1,30) AS VARCHAR(30)) AS CodigoProdutoComposicao, -- Cdigo do Produto papel composio produzido
          CAST(INSDMED.UNIMED AS VARCHAR(6)) AS CodigoUnidade, -- Cdigo da unidade do produto
          CAST(TO_NUMBER(ITP.SEQUEN) AS Numeric(10)) AS SequenciaComposicao, -- Sequencial do item na composio
          CAST(ITP.QTDINS AS Numeric(15,6)) AS QuantidadeComposicao, -- Quantidade do item na composio - Float 6 casas
          CAST('1' AS VARCHAR(1)) AS TipoCusto, -- 0=ltima Compra,1=Custo Reposio,2=Custo Reposio Moeda 1,0=Fixa,1=Proporcional,2=Por M,3=Por Permetro,4=Frmula,
          CAST(INSGRA.CUSREP AS Numeric(15,6)) AS CustoUnitarioInformado, -- Custo unitrio informado do item na composio - Float 6 casas
          CAST('0' AS VARCHAR(1)) AS Fixa_Proporcional, -- 0=Fixa,1=Proporcional,2=Por M,3=Por Permetro,4=Frmula, 
          CAST('F' AS VARCHAR(1)) AS GeraComposicao, -- T/F
          CAST('F' AS VARCHAR(1)) AS Insumo, -- T/F 
          CAST('T' AS VARCHAR(1)) AS Ativo, -- T/F
          CAST(NomeProduto(INSPRO.DESECF, INSPRO.DESMAT, INSGRA.CODCOR, INSDIV.NOMITE, INSGRA.CODTAM, INSSUB.NOMITE, INSPRO.ESPMAT,  INSGRA.DESGRA, INSDIV.NOMEXT, INSSUB.NOMEXT) AS VARCHAR(250)) AS DescricaoProducao, -- Descrio do Produto
          CAST(NULL AS VARCHAR(30)) AS CodigoMaquinaOperacao, -- Cdigo da Mquina no M3 - caso vincule mquina a composio
          CAST('T' AS VARCHAR(1)) AS GerarOrdemProducao, -- T/F
          CAST(NULL AS Numeric(15,6)) AS PercPesoLiquido, -- Percentual de Peso Lquido do item no Produto - Float 6 casas
          CAST(NULL AS Numeric(15,6)) AS PercProporcional, -- Percentual do item no produto - Flaot 6 casas
          CAST(NULL AS VARCHAR(250)) AS FormulaQuantidade,
          CAST('F' AS VARCHAR(1)) AS ExpandirComposicao, -- T/F
          CAST('F' AS VARCHAR(1)) AS BaixaSomenteseNivelAntBaixado, -- T/F
          CAST('F' AS VARCHAR(1)) AS BuscarCustodeSuasComposicoes, -- T/F
          CAST(NULL AS VARCHAR(150)) AS EtapaProcessoProducao, -- Etapa de Produo do M3 - caso utilize mapa de produo
          CAST('F' AS VARCHAR(1)) AS NaoConsisteSaldoEstoque -- T/F
     FROM TT_ITP ITP 
     -- Produto Produzido
     INNER JOIN TT_GRA GRA ON GRA.FILMAT = ITP.FILMAT 
                          AND GRA.CODMAT = ITP.CODMAT 
                          AND GRA.CODCOR = ITP.CODCOR 
                          AND GRA.CODTAM = ITP.CODTAM 
     INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT 
                          AND PRO.CODMAT = GRA.CODMAT
     INNER JOIN TT_DIV DIV ON GRA.CODCOR = DIV.CODITE
     INNER JOIN TD_DIV DDIV ON DIV.CODDIV = DDIV.CODTAB
     INNER JOIN TT_SUB SUB ON GRA.CODTAM = SUB.CODITE
     INNER JOIN TD_SUB DSUB ON SUB.CODSUB = DSUB.CODTAB 
     -- Insumo
     INNER JOIN TT_GRA INSGRA ON INSGRA.FILMAT = ITP.FILINS 
                             AND INSGRA.CODMAT = ITP.CODINS 
                             AND INSGRA.CODCOR = ITP.CORINS 
                             AND INSGRA.CODTAM = ITP.TAMINS
     LEFT JOIN TD_MED INSDMED ON INSDMED.CODTAB = GRA.UNIDAD
     INNER JOIN TT_PRO INSPRO ON INSPRO.FILMAT = INSGRA.FILMAT 
                             AND INSPRO.CODMAT = INSGRA.CODMAT
     INNER JOIN TT_DIV INSDIV ON INSGRA.CODCOR = INSDIV.CODITE
     INNER JOIN TD_DIV INSDDIV ON INSDIV.CODDIV = INSDDIV.CODTAB
     INNER JOIN TT_SUB INSSUB ON INSGRA.CODTAM = INSSUB.CODITE
     INNER JOIN TD_SUB INSDSUB ON INSSUB.CODSUB = INSDSUB.CODTAB 
     ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Conta Bancria" (Tabela Integrao Mult)
/*-- SEQ 2638 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_CONTABANCARIA CASCADE;

/*-- SEQ 2639 --*/
CREATE OR REPLACE VIEW TV_TIMU_CONTABANCARIA AS
   SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST('X' AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODBCO, TAB.NUMAGE, TAB.DIGAGE, TAB.CTACRR, TAB.DIGCRR, TAB.ATU_EM, TAB.DATINC,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.CodigoBanco, -- Cdigo do Banco da Conta
      TAB.CodigoAgencia, -- Cdigo da Agncia da Conta
      TAB.DigitoAgencia, -- Dgito da Agncia Bancria da Conta
      TAB.ContaCorrente, -- Nmero da Conta Corrente
      TAB.DigitoCC, -- Descrio da CC
      TAB.CodigoFilial, -- Cdigo da Filial
      TAB.Descricao, -- Descrio da CC
      TAB.TipoConta, -- Tipo da Conta (Conta Corrente, Conta de Aplicao, Caixa, Compensao, Cheque, Carto  Pagar, Carto  Receber, Conta Cauo ou Conta Poupana)
      TAB.CodigoEmpresa, -- Cdigo da Empresa no Banco
      TAB.CodigodaFilial, -- Cdigo da Filial no Banco
      TAB.LimiteSaldo, -- Valor do Limite da Conta - Float 4 casas
      TAB.Inativo, -- Situao da Conta Corrente - T/F
      TAB.IdentificacaoCobBancaria, -- Identificao Cobrana Bancria
      TAB.IDentificacaoPagtoAuto -- Identificao Pagamento Automatizado
   FROM (
    SELECT CTB.CODBCO, 
           CTB.NUMAGE, 
           CTB.DIGAGE, 
           CTB.CTACRR, 
           CTB.DIGCRR, 
           CTB.ATU_EM, 
           CTB.ATU_EM AS DATINC,
           CTB.ATU_EM AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
           CAST(TO_NUMBER(CTB.CODBCO) AS Numeric(10)) AS CodigoBanco, -- Cdigo do Banco da Conta
           CAST(CTB.NUMAGE AS VARCHAR(40)) AS CodigoAgencia, -- Cdigo da Agncia da Conta
           CAST(CTB.DIGAGE AS VARCHAR(2)) AS DigitoAgencia, -- Dgito da Agncia Bancria da Conta
           CAST(CTB.CTACRR AS VARCHAR(40)) AS ContaCorrente, -- Nmero da Conta Corrente
           CAST(CTB.DIGCRR AS VARCHAR(2)) AS DigitoCC, -- Descrio da CC
           CAST(TO_NUMBER(CTB.FILCTA) AS Numeric(3)) AS CodigoFilial, -- Cdigo da Filial
           CAST(CTB.NOMAGE AS VARCHAR(40)) AS Descricao, -- Descrio da CC
           -- Ser Exportado sempre como Conta Corrente no existe identificao no sistema da Totall
           CAST('Conta Corrente' AS VARCHAR(50)) AS TipoConta, -- Tipo da Conta (Conta Corrente, Conta de Aplicao, Caixa, Compensao, Cheque, Carto  Pagar, Carto  Receber, Conta Cauo ou Conta Poupana)
           CAST(NULL AS Numeric(9)) AS CodigoEmpresa, -- Cdigo da Empresa no Banco
           CAST(BXC.CODCED AS VARCHAR(20)) AS CodigodaFilial, -- Cdigo da Filial no Banco
           CAST(NULL AS Numeric(10,4)) AS LimiteSaldo, -- Valor do Limite da Conta - Float 4 casas
           CAST('F' AS VARCHAR(1)) AS Inativo, -- Situao da Conta Corrente - T/F
           CAST(BXC.CODCNV AS VARCHAR(20)) AS IdentificacaoCobBancaria, -- Identificao Cobrana Bancria
           CAST(NULL AS VARCHAR(20)) AS IDentificacaoPagtoAuto -- Identificao Pagamento Automatizado
      FROM TT_CTB CTB
      LEFT JOIN TT_CTA CTA ON CTA.CODFIL = CTB.FILCTA
                          AND CTA.SEQUEN = CTB.SEQCTA
                          AND CTA.TIPCTA = CTB.TIPCTA
                          AND CTA.USOCTA = CTB.CTACTB
      LEFT JOIN TD_COB DCOB ON CTB.TIPCTA = DCOB.TIPCTA
                           AND CTB.FILCTA = DCOB.FILCTA
                           AND CTB.SEQCTA = DCOB.SEQCTA
                           AND CTB.TIPCTB = DCOB.TIPCTB
      LEFT JOIN TT_CTBXCCB BXC ON BXC.CODBCO = CTB.CODBCO
                           AND BXC.NUMAGE = CTB.NUMAGE
                           AND BXC.CTACRR = CTB.CTACRR
                           AND BXC.CODCCB = DCOB.CODCCB ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
 
-- Finalidade(s):
-- 1) Gerar Tabela de Integração de "Contatos das Identificações" (Tabela Integração Mult)
/*-- SEQ 2640 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_CONTATOIDENT CASCADE;

/*-- SEQ 2641 --*/
CREATE OR REPLACE VIEW TV_TIMU_CONTATOIDENT AS
   SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST('X' AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Inclusão/Alteração Automática para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importação / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrição da inconsistência
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importação / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrição da inconsistência
      TAB.FILCLI, TAB.CODCLI, TAB.ATU_EM, TAB.DATINC,
      TAB.DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
      TAB.CodigoCliente, -- Código do Cliente
      TAB.CodigoFornecedor, -- Código do Fornecedor
      TAB.CodigoRepresentante, -- Código do Representante
      TAB.CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
      TAB.Contato, -- Descrição ou Nome do Contato
      TAB.CpfCnpjContato, -- CPF ou CNPJ Contato - Enviar o número completo, seja com ou sem caracteres especiais
      TAB.TipoTelefone, -- 0=Comercial;1=Residencial;2=Fax;3=Celular;4=Pager;5=Cobrança;6=Vendas Interno;7=Nextel
      TAB.Telefone, -- Telefone do Contato
      TAB.Email, -- Email do Contato
      TAB.DataCadastro, -- Data do Cadastro do Contato no Sistema
      TAB.UsuarioCadastro, -- Usuário do Cadastro
      TAB.Classificacao -- Nome da Classificação da identificação
     FROM (
   SELECT PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS ATU_EM, PAR.DATOPE AS DATINC,
          GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
          CAST(NULL AS Numeric(9)) AS CodigoCliente, -- Código do Cliente
          CAST(NULL AS Numeric(9)) AS CodigoFornecedor, -- Código do Fornecedor
          CAST(NULL AS Numeric(9)) AS CodigoRepresentante, -- Código do Representante
          --CAST(TRIM(COALESCE(PAR.NUMDOC, VIN.NUMDOC)) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(TRIM(PAR.NUMDOC) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(PAR.CONJUG AS VARCHAR(50)) AS Contato, -- Descrição ou Nome do Contato
          CAST(PAR.DOCCON AS VARCHAR(18)) AS CpfCnpjContato, -- CPF ou CNPJ Contato - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(CASE WHEN COALESCE(SUBSTR(TRIM(PAR.TELCON), 1, 1), '0') IN ('1', '2', '3', '4', '5') THEN '1'
                    WHEN COALESCE(SUBSTR(TRIM(PAR.TELCON), 1, 1), '0') IN ('6', '7', '8', '9') THEN '3'
                    ELSE NULL
               END AS VARCHAR(1)) AS TipoTelefone, -- 0=Comercial,1=Residencial,2=Fax,3=Celular,4=Pager,5=Cobrança,6=Vendas Interno,7=Nextel
          CAST(CASE WHEN ISNULL(PAR.DDTCON)='T' THEN '' ELSE '(' || COALESCE(PAR.DDTCON,'') || ') ' END || TRIM(PAR.TELCON) AS VARCHAR(20)) AS Telefone, -- Telefone do Contato
          CAST(PAR.E_MCON AS VARCHAR(80)) AS Email, -- Email do Contato
          CAST(NULL AS Timestamp) AS DataCadastro, -- Data do Cadastro do Contato no Sistema
          CAST(NULL AS VARCHAR(25)) AS UsuarioCadastro, -- Usuário do Cadastro
          CAST(CASE WHEN PAR.SIGNAT>=0 THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situação do Cliente T/F
          CAST(NULL AS VARCHAR(20)) AS Classificacao -- Nome da Classificação da identificação
     FROM TT_CLI PAR
     -- Parceiro Vinculado - Só buscar o vínculo se a pessoa não for física
     --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
      AND ISNOTNULL(PAR.CONJUG) = 'T'
      AND COALESCE(PAR.INDEXP, 'E') <> 'N'
     UNION ALL
   SELECT PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM), PAR.DATOPE AS DATINC,
          GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
          CAST(NULL AS Numeric(9)) AS CodigoCliente, -- Código do Cliente
          CAST(NULL AS Numeric(9)) AS CodigoFornecedor, -- Código do Fornecedor
          CAST(NULL AS Numeric(9)) AS CodigoRepresentante, -- Código do Representante
          --CAST(TRIM(COALESCE(PAR.NUMDOC, VIN.NUMDOC)) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(TRIM(PAR.NUMDOC) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(CON.CONTAT AS VARCHAR(50)) AS Contato, -- Descrição ou Nome do Contato
          CAST(CON.DOCCON AS VARCHAR(18)) AS CpfCnpjContato, -- CPF ou CNPJ Contato - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(CASE WHEN COALESCE(SUBSTR(TRIM(CON.TELCON), 1, 1), '0') IN ('1', '2', '3', '4', '5') THEN '1'
                    WHEN COALESCE(SUBSTR(TRIM(CON.TELCON), 1, 1), '0') IN ('6', '7', '8', '9') THEN '3'
                    ELSE NULL
               END AS VARCHAR(1)) AS TipoTelefone, -- 0=Comercial,1=Residencial,2=Fax,3=Celular,4=Pager,5=Cobrança,6=Vendas Interno,7=Nextel
          CAST(CASE WHEN ISNULL(CON.DDDCON)='T' THEN '' ELSE '(' || COALESCE(CON.DDDCON,'') || ') ' END || TRIM(CON.TELCON) AS VARCHAR(20)) AS Telefone, -- Telefone do Contato
          CAST(CON.E_MAIL AS VARCHAR(80)) AS Email, -- Email do Contato
          CAST(NULL AS Timestamp) AS DataCadastro, -- Data do Cadastro do Contato no Sistema
          CAST(NULL AS VARCHAR(25)) AS UsuarioCadastro, -- Usuário do Cadastro
          CAST(CASE WHEN PAR.SIGNAT>=0 THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situação do Cliente T/F
          CAST(NULL AS VARCHAR(20)) AS Classificacao -- Nome da Classificação da identificação
     FROM TT_CLI PAR
     JOIN TT_CON CON ON CON.FILCLI = PAR.FILCLI AND CON.CODCLI = PAR.CODCLI
     -- Parceiro Vinculado - Só buscar o vínculo se a pessoa não for física
     --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
      AND COALESCE(PAR.INDEXP, 'E') <> 'N'
    ) TAB    
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1)Retornar os DAV/Pr-Vendas.
/*-- SEQ 2642 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_DAV_PREVENDA CASCADE;

/*-- SEQ 2643 --*/
CREATE OR REPLACE VIEW TV_TIMU_DAV_PREVENDA AS
   SELECT
         --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
         CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
         CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
         CAST('T' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
         --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
         CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
         --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
         TAB.CODFIL, TAB.SEQUEN, TAB.NUMPAR, TAB.SUBPAR, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.NUMDOC, TAB.DATAFILTRO, 
         TAB.CODSER, TAB.SUBSER, TAB.NUMECF, TAB.NUMNOT, TAB.NUMPED, TAB.TIPPED,
         TAB.TEM_ITEM, TAB.TEM_PARCELA, TAB.TEM_LIQUIDACAO, TAB.TEM_MOVCONTABIL, TAB.TEM_CCUSTOCONTABIL, TAB.TEM_FRETE, TAB.TEM_OPERACAOFINANCEIRA, TAB.TEM_CONTAFINANCEIRA, TAB.TEM_CCUSTOFINANCEIRO, TAB.CHAVE, TAB.VLRNOT_VALIDACAO, TAB.VLRLIQ_VALIDACAO,
         TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
         TAB.TipoOperacao, -- Cdigo do Tipo de Operao
         TAB.Filial, -- Cdigo da Filial
         TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
         TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
         TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
         TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
         TAB.Serie, -- Srie do Documento
         TAB.NumeroDocumento, -- Nmero do documento
         TAB.DataEntrada, -- Data de Entrada
         TAB.DataSaida, -- Data de Sada
         TAB.DataEntSai, -- Data de Entrada ou Sada
         TAB.DataEmissao, -- Data de Emisso
         TAB.ValorContabil, -- Valor Contbil Original do Documento (Tesouraria)
         TAB.ValorDescontos, -- Valor Desconto dos Produtos
         TAB.ValorOutrasDespesas, -- Valor Outras Despesas dos Produtos
         TAB.ValorDescontosServ, -- Valor Desconto dos Servios
         TAB.ValorOutrasDespesasServ, -- Valor Outras Despesas dos Servios
         TAB.SituacaoNFE, -- {3=Autorizada;5=Cancelada;7=Inutilizada;8=Substituida;9=Denegada;A=Contingncia}
         TAB.SituacaoDOC, -- {0=Normal;1=Cancelada;2=Devoluo Parcial;3=Devoluo Total;4=Crdito Bloqueado;5=Inadimplncia;6=Cred. Bloq/Inad.;7=Bloqueio nos Itens;8=Faturado;A=Bloq. Val. Parcela;B=Bloq. Val. Min. Venda}
         TAB.ObsFiscal, -- Observao Fiscal do Documento
         TAB.Observacoes, -- Observaes da Nota
         TAB.InfoComplementares, -- Informaes Complementares da Nota
         TAB.TextoFiscal, -- Texto Fiscal do Documento
         TAB.NumPedCliente, -- Nmero do Pedido no Cliente
         TAB.NumPedRepresentante, -- Nmero do Pedido no Representante
         TAB.IndNaturezaFrete, -- {0=Operaes de vendas, com nus suportado pelo estabelecimento vendedor;1=Operaes de vendas, com nus suportado pelo adquirente;2=Operaes de compras (bens para revenda, matrias prima e outros produtos, geradores de crdito);3=Operaes de compras (bens para revenda, matrias prima e outros produtos, no geradores de crdito);4=Transferncia de produtos acabados entre estabelecimentos da pessoa jurdica;5=Transferncia de produtos entre estabelecimentos da pessoa jurdica;9=Outras}
         TAB.ChaveNFE, -- Chave NFE
         TAB.ChaveNFERefer, -- Chave NFE Referenciada
         TAB.CodContaTes, -- Cdigo da Conta Tesouraria
         TAB.Justificativa, -- Justificativa do documento Contbil
         TAB.TipoFrete, -- {F=Por conta do emitente;T=Por conta do destinatrio;A=Por conta de terceiros;B=Sem frete}
         TAB.CodTransportadora, -- Cdigo da Transportadora do Documento
         TAB.CpfCnpjTransportadora, -- CPF ou CNPJ da Transportadora do Documento
         TAB.PlacaVeiculo, -- Placa do Veculo de Entrega
         TAB.CodTranspRedespacho, -- Cdigo da Transportadora de Redespacho do Documento
         TAB.CpfCnpjTranspRedespacho, -- CPF ou CNPJ da Transportadora de Redespacho do Documento
         TAB.CodigoModelo, -- Cdigo do Modelo de Documento (01 ou 65)
         TAB.LogradouroEnt, -- Logradouro do Endereo de Entrega
         TAB.NumeroEnt, -- Nmero do Endereo de Entrega
         TAB.ComplementoEnt, -- Complemento do Endereo de Entrega
         TAB.CEPEnt, -- CEP do Endereo de Entrega
         TAB.CodMunicipioIBGEEnt, -- GeoCodigo do M3 - caso esteja informado dever importar o vnculo do municpio por este cdigo (Endereo)
         TAB.CidadeEndEnt, -- Cidade do Endereo de Entrega
         TAB.BairroEnt, -- Bairro do Endereo de Entrega
         TAB.EstadoEnt, -- Estado do Endereo de Entrega
         TAB.CodigoPaisEnt, -- Codigo do Banco Central para o Pais da Cidade de Entrega
         TAB.PaisEnt, -- Nome do Pais do Endereo de Entrega
         TAB.ValorFrete, -- Valor do Frete
         TAB.ValorFreteTerceiros, -- Valor do Frete Terceiros
         TAB.ICMSFreteTerceiros, -- Valor ICMS do Frete Terceiros
         TAB.DifaFreteTerceiros, -- Valor DIFA do Frete Terceiros
         TAB.ValorSeguro, -- Valor do Seguro
         TAB.ValorAcrescimos, -- Valor Acrescimos
         TAB.ValorTHC, -- Valor THC
         TAB.ValorAFRMM, -- Valor AFRMM
         TAB.ValorDemurrage, -- Valor Demurrage
         TAB.ValorDesestiva, -- Valro Desestiva
         TAB.ValorDesembaraco, -- Valor Desembarao
         TAB.ValorSiscomex, -- Valor Siscomex
         TAB.ValorPISImport, -- Valro PIS Importao
         TAB.ValorCofinsImport, -- Valro Cofins Importao
         TAB.ValorDespAduaneira, -- Valor Despesa Aduaneira
         TAB.SimboloMoeda, -- Smbolo da Moeda
         TAB.ValorCotacaoMoeda, -- Valor Cotao Moeda
         TAB.DataCotacaoMoeda, -- Data Cotao Moeda
         TAB.CPFCNPJRepresentante, -- CPF ou CNPJ do Representante
         TAB.COO, -- COO Cupom
         TAB.NroECF, -- Nmero do ECF
         TAB.NroSerieECF, -- Nmero de rie do ECF
         TAB.ModeloECF, -- Modelo do ECF
         TAB.MarcaECF, -- Marca do ECF
         TAB.CPFCNPJCupom -- CPF ou CNPJ do cliente no identificado no cupom
     FROM(
   SELECT 
         ORC.CODFIL,
         CAST(ORC.TIPPED||ORC.NUMPED AS CHAR(10)) AS SEQUEN,
         ORC.NUMPED,
         ORC.TIPPED,
         CAST(NULL AS CHAR(2)) AS NUMPAR,
         CAST(NULL AS CHAR(2)) AS SUBPAR,
         CAST(NULL AS VARCHAR(3)) AS CODSER, CAST(NULL AS VARCHAR(3)) AS SUBSER, CAST(NULL AS CHAR(3)) AS NUMECF, CAST(NULL AS VARCHAR(10)) AS NUMNOT,
         CAST('ORC' AS VARCHAR(3)) AS ORIGEM,
         CAST('TIMU_DOCUMENTO' AS VARCHAR(50)) AS DESTINO,
         CAST('T' AS CHAR(1)) AS TEM_ITEM,
         CAST(CASE WHEN (ORC.FLGEST = 'C') OR (ORC.APROVA = 'R') OR (ORC.APRCLI = '2') THEN 'F' ELSE 'T' END AS CHAR(1)) AS TEM_PARCELA,
         CAST('F' AS CHAR(1)) AS TEM_LIQUIDACAO,
         CAST('F' AS CHAR(1)) AS TEM_MOVCONTABIL,
         CAST('F' AS CHAR(1)) AS TEM_CCUSTOCONTABIL,
         CAST('F' AS CHAR(1)) AS TEM_FRETE,
         CAST('F' AS CHAR(1)) AS TEM_OPERACAOFINANCEIRA,
         CAST('F' AS CHAR(1)) AS TEM_CONTAFINANCEIRA,
         CAST('F' AS CHAR(1)) AS TEM_CCUSTOFINANCEIRO,
         CAST('ORC' || ORC.CODFIL || ORC.TIPPED || ORC.NUMPED AS VARCHAR(50)) AS CHAVE,
         (SELECT SUM(IOR.VLRPGT) FROM TT_IOR IOR WHERE IOR.CODFIL = ORC.CODFIL AND IOR.TIPPED = ORC.TIPPED AND IOR.NUMPED = ORC.NUMPED AND IOR.FLGEST<>'C') AS VLRNOT_VALIDACAO,
         ABS(ORC.VLRTOT) AS VLRLIQ_VALIDACAO,
         ORC.DATINC, 
         ORC.ATU_EM, 
         ORC.EXPORT,
         ORC.EXPEM4,
         COALESCE(PAR.NUMDOC, VIN.NUMDOC) AS NUMDOC, 
         ORC.DATINC AS DATAFILTRO,
         ORC.DATINC AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
         -- Definido juntamente com a EME4 quando for cupom fiscal enviar tipo de operao fixo
         CAST(CASE WHEN (ORC.TIPPED = 'O') THEN 995 -- DAV
                   WHEN (ORC.TIPPED = 'P') THEN 994 -- Pr-Venda
                   WHEN (ORC.TIPPED = 'S') THEN 993 -- DAV-OS
                   ELSE NULL
              END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
         CAST(TO_NUMBER(ORC.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
         CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                   ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
              END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
         CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
         CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = ORC.FILCLI AND REL.CODPAR = ORC.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                   ELSE 'C' 
              END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
         CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
         CAST(ORC.TIPPED AS VARCHAR(5)) AS Serie, -- Srie do Documento
         CAST(TO_CHAR(TO_NUMBER(TRIM(COALESCE(ORC.NUMPED_RE,ORC.NUMPED)))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
         CAST(NULL AS Timestamp) AS DataEntrada, -- Data de Entrada
         CAST(ORC.PED_EM AS Timestamp) AS DataSaida, -- Data de Sada
         CAST(TRUNC(ORC.PED_EM) AS Timestamp) AS DataEntSai, -- Data de Entrada ou Sada
         CAST(TRUNC(ORC.PED_EM) AS Timestamp) AS DataEmissao, -- Data de Emisso
         CAST(ABS(ORC.VLRTOT) AS Numeric(15,2)) AS ValorContabil, -- Valor Contbil Original do Documento (Tesouraria)
         CAST(ABS(CASE WHEN ORC.VLRDES < 0 THEN ORC.VLRDES ELSE 0 END) AS Numeric(15,2)) AS ValorDescontos, -- Valor Desconto dos Produtos
         CAST(ABS(CASE WHEN ORC.VLRDES > 0 THEN ORC.VLRDES ELSE 0 END) AS Numeric(15,2)) AS ValorOutrasDespesas, -- Valor Outras Despesas dos Produtos
         CAST(NULL AS Numeric(15,2)) AS ValorDescontosServ, -- Valor Desconto dos Servios
         CAST(NULL AS Numeric(15,2)) AS ValorOutrasDespesasServ, -- Valor Outras Despesas dos Servios
         CAST(NULL AS VARCHAR(1)) AS SituacaoNFE, -- {3=Autorizada;5=Cancelada;7=Inutilizada;8=Substituida;9=Denegada;A=Contingncia}
         CAST(CASE WHEN (ORC.FLGEST = 'C') THEN '1' -- C - Cancelado
                   WHEN (ORC.FLGEST = 'E') THEN '8' -- E - Vendido
                   WHEN (ORC.FLGEST = 'O') THEN '0' -- O - Concludo
                   ELSE '0' -- A - Em aberto
              END AS VARCHAR(1)) AS SituacaoDOC, -- {0=Normal;1=Cancelada;2=Devoluo Parcial;3=Devoluo Total;4=Crdito Bloqueado;5=Inadimplncia;6=Cred. Bloq/Inad.;7=Bloqueio nos Itens;8=Faturado;A=Bloq. Val. Parcela;B=Bloq. Val. Min. Venda}
         CAST(RTF2TXT(ORC.OBSERV) AS VARCHAR(50)) AS ObsFiscal, -- Observao Fiscal do Documento
         CAST(RTF2TXT(ORC.OBSERV) AS VARCHAR(150)) AS Observacoes, -- Observaes da Nota
         CAST(RTF2TXT(ORC.OBSERV) AS VARCHAR(4000)) AS InfoComplementares, -- Informaes Complementares da Nota
         CAST(RTF2TXT(ORC.OBSERV) AS VARCHAR(4000)) AS TextoFiscal, -- Texto Fiscal do Documento
         CAST(NULL AS VARCHAR(200)) AS NumPedCliente, -- Nmero do Pedido no Cliente
         CAST(NULL AS VARCHAR(100)) AS NumPedRepresentante, -- Nmero do Pedido no Representante
         CAST(NULL AS VARCHAR(1)) AS IndNaturezaFrete, -- {0=Operaes de vendas, com nus suportado pelo estabelecimento vendedor;1=Operaes de vendas, com nus suportado pelo adquirente;2=Operaes de compras (bens para revenda, matrias prima e outros produtos, geradores de crdito);3=Operaes de compras (bens para revenda, matrias prima e outros produtos, no geradores de crdito);4=Transferncia de produtos acabados entre estabelecimentos da pessoa jurdica;5=Transferncia de produtos entre estabelecimentos da pessoa jurdica;9=Outras}
         CAST(NULL AS VARCHAR(60)) AS ChaveNFE, -- Chave NFE
         CAST(NULL AS VARCHAR(60)) AS ChaveNFERefer, -- Chave NFE Referenciada
         -- Pedro E. Braga - Conforme reunio no ser exportado a informao nesse momento
         CAST(NULL AS VARCHAR(20)) AS CodContaTes, -- Cdigo da Conta Tesouraria
         -- Justificativa utilizada em Testes de Integrao pela EME4
         CAST('DAV/Pr-Venda - Chave: '||ORC.CODFIL||'/'||ORC.TIPPED||'/'||ORC.NUMPED AS VARCHAR(200)) AS Justificativa, -- Justificativa do documento Contbil
         --CAST(NULL AS VARCHAR(200)) AS Justificativa, -- Justificativa do documento Contbil
         CAST(CASE WHEN ORC.EMIDES = 'T' THEN 'T'
                   --WHEN ORC.INDFRE = 'F' THEN 'F'
                   --WHEN ORC.INDFRE = 'A' THEN 'A'
                   ELSE 'B'
              END AS VARCHAR(1)) AS TipoFrete, -- {F=Por conta do emitente;T=Por conta do destinatrio;A=Por conta de terceiros;B=Sem frete}
         CAST(TO_NUMBER(TRA.FILCLI||LPAD(TRIM(TRA.CODCLI), 6, '0')) AS Numeric(9)) AS CodTransportadora, -- Cdigo da Transportadora do Documento
         --CAST(TRIM(COALESCE(ENDTRA.NUMDOC, TRA.NUMDOC)) AS VARCHAR(18)) AS CpfCnpjTransportadora, -- CPF ou CNPJ da Transportadora do Documento
         CAST(TRIM(TRA.NUMDOC) AS VARCHAR(18)) AS CpfCnpjTransportadora, -- CPF ou CNPJ da Transportadora do Documento
         CAST(ORC.PLACAT AS VARCHAR(10)) AS PlacaVeiculo, -- Placa do Veculo de Entrega
         CAST(NULL AS Numeric(9)) AS CodTranspRedespacho, -- Cdigo da Transportadora de Redespacho do Documento
         CAST(NULL AS VARCHAR(18)) AS CpfCnpjTranspRedespacho, -- CPF ou CNPJ da Transportadora de Redespacho do Documento
         CAST(NULL AS VARCHAR(2)) AS CodigoModelo, -- Cdigo do Modelo de Documento (01 ou 65)
         -- Dados da Entrega
         CAST(TRIM(ENDENT.ENDERE) AS VARCHAR(120)) AS LogradouroEnt, -- Logradouro do Endereo de Entrega
         CAST(SUBSTR(TO_CHAR(CAST(                                   NULLIF(regexp_replace(ENDENT.NUMERO, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 10) AS Numeric(10)) AS NumeroEnt, -- Nmero do Endereo de Entrega
         CAST(TRIM(ENDENT.COMPLE) AS VARCHAR(30)) AS ComplementoEnt, -- Complemento do Endereo de Entrega
         CAST(CASE WHEN DPAIENT.CODPAI = 1058 THEN LPAD(COALESCE(TRIM(ENDENT.CODCEP), '0'), 5, '0')||LPAD(COALESCE(TRIM(ENDENT.CODLOG), '0'), 3, '0') ELSE NULL END AS VARCHAR(10)) AS CEPEnt, -- CEP do Endereo de Entrega
         CAST(TRIM(ENDENT.BAIRRO) AS VARCHAR(80)) AS BairroEnt, -- Bairro do Endereo de Entrega
         CAST(CASE WHEN DPAIENT.CODPAI = 1058 THEN IBGENT.CODIBG ELSE NULL END AS Numeric(10)) AS CodMunicipioIBGEEnt, -- GeoCodigo do M3 - caso esteja informado dever importar o vnculo do municpio por este cdigo (Endereo)
         -- A Pedido da EME4 no ser exportado os dados da Cidade/Estado/Pais
         CAST(TRIM(CASE WHEN DPAIENT.CODPAI = 1058 THEN NULL /*IBGENT.NOMMUN*/ ELSE ENDENT.NOMCID END) AS VARCHAR(100)) AS CidadeEndEnt, -- Cidade do Endereo de Entrega
         CAST(TRIM(CASE WHEN DPAIENT.CODPAI = 1058 THEN NULL /*IBGENT.SIGEST*/ ELSE NULL END) AS VARCHAR(2)) AS EstadoEnt, -- Estado do Endereo de Entrega
         CAST(DPAIENT.CODPAI AS Numeric(9)) AS CodigoPaisEnt, -- Codigo do Banco Central para o Pais da Cidade de Entrega
         CAST(TRIM(CASE WHEN DPAIENT.CODPAI = 1058 THEN NULL /*DPAIENT.DESPAI*/ ELSE DPAIENT.DESPAI END) AS VARCHAR(80)) AS PaisEnt, -- Nome do Pais do Endereo de Entrega
         CAST(ABS(ORC.VLRFRE) AS Numeric(15,2)) AS ValorFrete, -- Valor do Frete
         CAST(NULL AS Numeric(15,2)) AS ValorFreteTerceiros, -- Valor do Frete Terceiros
         CAST(NULL AS Numeric(15,2)) AS ICMSFreteTerceiros, -- Valor ICMS do Frete Terceiros
         CAST(NULL AS Numeric(15,2)) AS DifaFreteTerceiros, -- Valor DIFA do Frete Terceiros
         CAST(ABS(ORC.VLRSEG) AS Numeric(15,2)) AS ValorSeguro, -- Valor do Seguro
         CAST(CASE WHEN COALESCE(ORC.VLRDES, 0) > 0 THEN ABS(ORC.VLRDES) ELSE 0 END AS Numeric(15,2)) AS ValorAcrescimos, -- Valor Acrescimos
         -- Valores relativo a Nota de Importao
         CAST(NULL AS Numeric(15,2)) AS ValorTHC, -- Valor THC
         CAST(NULL AS Numeric(15,2)) AS ValorAFRMM, -- Valor AFRMM
         CAST(NULL AS Numeric(15,2)) AS ValorDemurrage, -- Valor Demurrage
         CAST(NULL AS Numeric(15,2)) AS ValorDesestiva, -- Valro Desestiva
         CAST(NULL AS Numeric(15,2)) AS ValorDesembaraco, -- Valor Desembarao
         CAST(NULL AS Numeric(15,2)) AS ValorSiscomex, -- Valor Siscomex
         CAST(NULL AS Numeric(15,2)) AS ValorPISImport, -- Valro PIS Importao
         CAST(NULL AS Numeric(15,2)) AS ValorCofinsImport, -- Valro Cofins Importao
         CAST(NULL AS Numeric(15,2)) AS ValorDespAduaneira, -- Valor Despesa Aduaneira
         CAST(DMOE.DESMOE AS VARCHAR(10)) AS SimboloMoeda, -- Smbolo da Moeda
         CAST(CAM.VLRREF AS Numeric(15,4)) AS ValorCotacaoMoeda, -- Valor Cotao Moeda
         CAST(TRUNC(CAM.DATREF) AS Timestamp) AS DataCotacaoMoeda, -- Data Cotao Moeda
         --CAST(TRIM(COALESCE(ENDFUN.NUMDOC, FUNPAR.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJRepresentante, -- CPF ou CNPJ do Representante
         CAST(TRIM(FUNPAR.NUMDOC) AS VARCHAR(18)) AS CPFCNPJRepresentante, -- CPF ou CNPJ do Representante
         CAST(NULL AS Numeric(8)) AS COO, -- COO Cupom
         CAST(NULL AS Numeric(8)) AS NroECF, -- Nmero do ECF
         CAST(NULL AS VARCHAR(50)) AS NroSerieECF, -- Nmero de Srie do ECF
         CAST(NULL AS VARCHAR(20)) AS ModeloECF, -- Modelo do ECF
         CAST(NULL AS VARCHAR(20)) AS MarcaECF, -- Marca do ECF
         CAST(NULL AS VARCHAR(18)) as CPFCNPJCupom -- CPF ou CNPJ do cliente no identificado no cupom
    FROM TT_ORC ORC
    -- Cliente
    JOIN TT_CLI PAR ON PAR.FILCLI = ORC.FILCLI AND PAR.CODCLI = ORC.CODCLI
    --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
    -- Endereo de Faturamento
    LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = ORC.FILCLI AND ENDFAT.CODCLI = ORC.CODCLI AND ENDFAT.CODFIL = ORC.FILFAT AND ENDFAT.NUMEND = ORC.NUMFAT
    -- Endereo de Entrega
    LEFT JOIN TT_END ENDENT ON ENDENT.FILCLI = ORC.FILCLI AND ENDENT.CODCLI = ORC.CODCLI AND ENDENT.CODFIL = ORC.FILENT AND ENDENT.NUMEND = ORC.NUMENT
    LEFT JOIN TT_MUN MUNENT ON MUNENT.CODIGO = ENDENT.CODCID
    LEFT JOIN TT_IBG IBGENT ON IBGENT.CODIBG = COALESCE(ENDENT.CODIBG, MUNENT.CODIBG)
    LEFT JOIN TD_PAI DPAIENT ON DPAIENT.CODPAI = ENDENT.CODPAI
    -- Transportadora
    LEFT JOIN TT_CLI TRA ON TRA.FILCLI = ORC.FILTRA AND TRA.CODCLI = ORC.CODTRA
    --LEFT JOIN TT_END ENDTRA ON ENDTRA.FILCLI = TRA.FILCLI AND ENDTRA.CODCLI = TRA.CODCLI AND ENDTRA.CODFIL = TRA.FILEND AND ENDTRA.NUMEND = TRA.NUMEND
    -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
    LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    -- Vendedor/Representante
    LEFT JOIN TT_USU FUN ON FUN.FILUSU = ORC.FILVEN AND FUN.CODUSU = ORC.CODVEN
    LEFT JOIN TT_CLI FUNPAR ON FUNPAR.FILCLI = FUN.FILCLI AND FUNPAR.CODCLI = FUN.CODCLI
    -- Plano de Pagamento
    LEFT JOIN TT_PLA PLA ON PLA.FILPGT = ORC.FILPGT AND PLA.CODPGT = ORC.CODPGT
    -- Moeda
    LEFT JOIN TD_MOE DMOE ON DMOE.CODTAB = PLA.CODMOE
    LEFT JOIN ( SELECT LCAM.CODMOE, MAX(LCAM.DATREF) AS DATREF, MAX(LCAM.VLRREF) AS VLRREF 
                  FROM TT_CAM LCAM
                 GROUP BY LCAM.CODMOE ) CAM ON CAM.CODMOE = DMOE.CODTAB AND CAM.DATREF = ORC.PED_EM
   WHERE 1 = 1
     AND ORC.PED_EM >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',ORC.CODFIL,'','','')
     AND ((ORC.EXPEM4 = 'F') OR (ORC.EXPORT = 'F'))
     AND LeParametroBoo('EXP_DAV_EME4',ORC.CODFIL,'','','') = 'T'
   ) TAB
;


-- Autor: Jardel Angelo dos Santos
-- Cliente(s): EME4
-- Finalidade(s):
-- 1)Retornar os documentos inutilizados.
/*-- SEQ 2644 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_DOCSINUTILIZADOS CASCADE;

/*-- SEQ 2645 --*/
CREATE OR REPLACE VIEW TV_TIMU_DOCSINUTILIZADOS AS
   SELECT
         CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
         CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
         CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Inclusão/Alteração Automática para Cadastros
         CAST('T' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importação / I - Importando / E - Erro / R - Registro Importado
         --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrição da inconsistência
         CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importação / I - Importando / E - Erro / R - Registro Importado
         --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrição da inconsistência
         TAB.ORIGEM, 
         TAB.DESTINO,
         TAB.SEQUEN,
         TAB.EXPEM4,
         TAB.CODFIL,
         TAB.NUMPED,
         TAB.TIPPED,
         TAB.NUMPAR,
         TAB.SUBPAR,
         TAB.CODSER,
         TAB.SUBSER,
         TAB.NUMECF,
         TAB.NUMNOT,
         TAB.TEM_ITEM, 
         TAB.TEM_PARCELA, 
         TAB.TEM_LIQUIDACAO, 
         TAB.TEM_MOVCONTABIL, 
         TAB.TEM_CCUSTOCONTABIL, 
         TAB.TEM_FRETE, 
         TAB.TEM_OPERACAOFINANCEIRA, 
         TAB.TEM_CONTAFINANCEIRA, 
         TAB.TEM_CCUSTOFINANCEIRO, 
         TAB.VLRNOT_VALIDACAO, 
         TAB.VLRLIQ_VALIDACAO,
         TAB.DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
         TAB.TipoOperacao, -- Código do Tipo de Operação
         TAB.Filial, -- Código da Filial
         TAB.CodigoCliFor, -- Código do Cliente ou Fornecedor
         TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
         TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
         TAB.TipoSerie, -- Tipo da Série do Documento 1 - Própria / 2 - Terceiros
         TAB.Serie, -- Série do Documento
         TAB.NumeroDocumento, -- Número do documento
         TAB.DataEntrada, -- Data de Entrada
         TAB.DataSaida, -- Data de Saída
         TAB.DataEntSai, -- Data de Entrada ou Saída
         TAB.DataEmissao, -- Data de Emissão
         TAB.ValorContabil, -- Valor Contábil Original do Documento (Tesouraria)
         TAB.ValorDescontos, -- Valor Desconto dos Produtos
         TAB.ValorOutrasDespesas, -- Valor Outras Despesas dos Produtos
         TAB.ValorDescontosServ, -- Valor Desconto dos Serviços
         TAB.ValorOutrasDespesasServ, -- Valor Outras Despesas dos Serviços
         TAB.SituacaoNFE, -- {3=Autorizada;5=Cancelada;7=Inutilizada;8=Substituida;9=Denegada;A=Contingência}
         TAB.SituacaoDOC, -- {0=Normal;1=Cancelada;2=Devolução Parcial;3=Devolução Total;4=Crédito Bloqueado;5=Inadimplência;6=Cred. Bloq/Inad.;7=Bloqueio nos Itens;8=Faturado;A=Bloq. Val. Parcela;B=Bloq. Val. Min. Venda}
         TAB.ObsFiscal, -- Observação Fiscal do Documento
         TAB.Observacoes, -- Observações da Nota
         TAB.InfoComplementares, -- Informações Complementares da Nota
         TAB.TextoFiscal, -- Texto Fiscal do Documento
         TAB.NumPedCliente, -- Número do Pedido no Cliente
         TAB.NumPedRepresentante, -- Número do Pedido no Representante
         TAB.IndNaturezaFrete, -- {0=Operações de vendas, com ônus suportado pelo estabelecimento vendedor;1=Operações de vendas, com ônus suportado pelo adquirente;2=Operações de compras (bens para revenda, matérias prima e outros produtos, geradores de crédito);3=Operações de compras (bens para revenda, matérias prima e outros produtos, não geradores de crédito);4=Transferência de produtos acabados entre estabelecimentos da pessoa jurídica;5=Transferência de produtos entre estabelecimentos da pessoa jurídica;9=Outras}
         TAB.ChaveNFE, -- Chave NFE
         TAB.ChaveNFERefer, -- Chave NFE Referenciada
         TAB.CodContaTes, -- Código da Conta Tesouraria
         TAB.Justificativa, -- Justificativa do documento Contábil
         TAB.TipoFrete, -- {F=Por conta do emitente;T=Por conta do destinatário;A=Por conta de terceiros;B=Sem frete}
         TAB.CodTransportadora, -- Código da Transportadora do Documento
         TAB.CpfCnpjTransportadora, -- CPF ou CNPJ da Transportadora do Documento
         TAB.PlacaVeiculo, -- Placa do Veículo de Entrega
         TAB.CodTranspRedespacho, -- Código da Transportadora de Redespacho do Documento
         TAB.CpfCnpjTranspRedespacho, -- CPF ou CNPJ da Transportadora de Redespacho do Documento
         TAB.CodigoModelo, -- Código do Modelo de Documento (01 ou 65)
         TAB.LogradouroEnt, -- Logradouro do Endereço de Entrega
         TAB.NumeroEnt, -- Número do Endereço de Entrega
         TAB.ComplementoEnt, -- Complemento do Endereço de Entrega
         TAB.CEPEnt, -- CEP do Endereço de Entrega
         TAB.CodMunicipioIBGEEnt, -- GeoCodigo do M3 - caso esteja informado deverá importar o vínculo do município por este código (Endereço)
         TAB.CidadeEndEnt, -- Cidade do Endereço de Entrega
         TAB.BairroEnt, -- Bairro do Endereço de Entrega
         TAB.EstadoEnt, -- Estado do Endereço de Entrega
         TAB.CodigoPaisEnt, -- Codigo do Banco Central para o Pais da Cidade de Entrega
         TAB.PaisEnt, -- Nome do Pais do Endereço de Entrega
         TAB.ValorFrete, -- Valor do Frete
         TAB.ValorFreteTerceiros, -- Valor do Frete Terceiros
         TAB.ICMSFreteTerceiros, -- Valor ICMS do Frete Terceiros
         TAB.DifaFreteTerceiros, -- Valor DIFA do Frete Terceiros
         TAB.ValorSeguro, -- Valor do Seguro
         TAB.ValorAcrescimos, -- Valor Acrescimos
         TAB.ValorTHC, -- Valor THC
         TAB.ValorAFRMM, -- Valor AFRMM
         TAB.ValorDemurrage, -- Valor Demurrage
         TAB.ValorDesestiva, -- Valro Desestiva
         TAB.ValorDesembaraco, -- Valor Desembaraço
         TAB.ValorSiscomex, -- Valor Siscomex
         TAB.ValorPISImport, -- Valro PIS Importação
         TAB.ValorCofinsImport, -- Valro Cofins Importação
         TAB.ValorDespAduaneira, -- Valor Despesa Aduaneira
         TAB.SimboloMoeda, -- Símbolo da Moeda
         TAB.ValorCotacaoMoeda, -- Valor Cotação Moeda
         TAB.DataCotacaoMoeda, -- Data Cotação Moeda
         TAB.CPFCNPJRepresentante, -- CPF ou CNPJ do Representante
         TAB.COO, -- COO Cupom
         TAB.NroECF, -- Número do ECF
         TAB.NroSerieECF, -- Número de érie do ECF
         TAB.ModeloECF, -- Modelo do ECF
         TAB.MarcaECF, -- Marca do ECF
         TAB.CPFCNPJCupom -- CPF ou CNPJ do cliente não identificado no cupom
     FROM(
   SELECT 
         CAST('INU' AS VARCHAR(3)) AS ORIGEM,
         CAST('TIMU_DOCUMENTO' AS VARCHAR(50)) AS DESTINO,
         INU.SEQUEN,
         INU.EXPEM4,
         INU.CODFIL,
         CAST(NULL AS CHAR(8)) AS NUMPED,
         CAST(NULL AS CHAR(1)) AS TIPPED,
         CAST(NULL AS CHAR(2)) AS NUMPAR,
         CAST(NULL AS CHAR(2)) AS SUBPAR,
         INU.CODSER, 
         CAST(NULL AS VARCHAR(3)) AS SUBSER, 
         CAST(NULL AS CHAR(3)) AS NUMECF, 
         CAST(NULL AS VARCHAR(10)) AS NUMNOT,
         CAST('F' AS CHAR(1)) AS TEM_ITEM,
         CAST('F' AS CHAR(1)) AS TEM_PARCELA,
         CAST('F' AS CHAR(1)) AS TEM_LIQUIDACAO,
         CAST('F' AS CHAR(1)) AS TEM_MOVCONTABIL,
         CAST('F' AS CHAR(1)) AS TEM_CCUSTOCONTABIL,
         CAST('F' AS CHAR(1)) AS TEM_FRETE,
         CAST('F' AS CHAR(1)) AS TEM_OPERACAOFINANCEIRA,
         CAST('F' AS CHAR(1)) AS TEM_CONTAFINANCEIRA,
         CAST('F' AS CHAR(1)) AS TEM_CCUSTOFINANCEIRO,
         CAST(NULL AS Numeric(5)) AS VLRNOT_VALIDACAO,
         CAST(NULL AS Numeric(5)) AS VLRLIQ_VALIDACAO,
         INU.DATINC AS DataHoraAtuReg, -- Data e Hora da última atualização do registro
         -- Definido juntamente com a EME4 quando for cupom fiscal enviar tipo de operação fixo
         CAST(CASE  WHEN (INU.MODNOT = '55') THEN 990
                    WHEN (INU.MODNOT = '65') THEN 997
                    ELSE NULL
               END AS Numeric(3)) AS TipoOperacao, -- Código do Tipo de Operação, -- Código do Tipo de Operação
         CAST(TO_NUMBER(INU.CODFIL) AS Numeric(3)) AS Filial, -- Código da Filial
         CAST(NULL AS Numeric(9)) AS CodigoCliFor,
         CAST(NULL AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
         CAST('C' AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
         CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Série do Documento 1 - Própria / 2 - Terceiros
         CAST(INU.CODSER AS VARCHAR(5)) AS Serie, -- Série do Documento
         CAST(NumeroDocInu AS VARCHAR(10)) AS NumeroDocumento,
         CAST(INU.DATINC AS Timestamp) AS DataEntrada, -- Data de Entrada
         CAST(INU.DATINC AS Timestamp) AS DataSaida, -- Data de Saída
         CAST(TRUNC(INU.DATINC) AS Timestamp) AS DataEntSai, -- Data de Entrada ou Saída
         CAST(TRUNC(INU.DATINC) AS Timestamp) AS DataEmissao, -- Data de Emissão
         CAST(NULL AS Numeric(15,2)) AS ValorContabil, -- Valor Contábil Original do Documento (Tesouraria)
         CAST(NULL AS Numeric(15,2)) AS ValorDescontos, -- Valor Desconto dos Produtos
         CAST(NULL AS Numeric(15,2)) AS ValorOutrasDespesas, -- Valor Outras Despesas dos Produtos
         CAST(NULL AS Numeric(15,2)) AS ValorDescontosServ, -- Valor Desconto dos Serviços
         CAST(NULL AS Numeric(15,2)) AS ValorOutrasDespesasServ, -- Valor Outras Despesas dos Serviços
         CAST('7' AS VARCHAR(1)) AS SituacaoNFE, -- {3=Autorizada;5=Cancelada;7=Inutilizada;8=Substituida;9=Denegada;A=Contingência}
         CAST('0' AS VARCHAR(1)) AS SituacaoDOC, -- {0=Normal;1=Cancelada;2=Devolução Parcial;3=Devolução Total;4=Crédito Bloqueado;5=Inadimplência;6=Cred. Bloq/Inad.;7=Bloqueio nos Itens;8=Faturado;A=Bloq. Val. Parcela;B=Bloq. Val. Min. Venda}
         CAST(RTF2TXT(INU.JUSTIF) AS VARCHAR(50)) AS ObsFiscal, -- Observação Fiscal do Documento
         CAST(RTF2TXT(INU.JUSTIF) AS VARCHAR(150)) AS Observacoes, -- Observações da Nota
         CAST(RTF2TXT(INU.JUSTIF) AS VARCHAR(4000)) AS InfoComplementares, -- Informações Complementares da Nota
         CAST(RTF2TXT(INU.JUSTIF) AS VARCHAR(4000)) AS TextoFiscal, -- Texto Fiscal do Documento
         CAST(NULL AS VARCHAR(200)) AS NumPedCliente, -- Número do Pedido no Cliente
         CAST(NULL AS VARCHAR(100)) AS NumPedRepresentante, -- Número do Pedido no Representante
         CAST(NULL AS VARCHAR(1)) AS IndNaturezaFrete, -- {0=Operações de vendas, com ônus suportado pelo estabelecimento vendedor;1=Operações de vendas, com ônus suportado pelo adquirente;2=Operações de compras (bens para revenda, matérias prima e outros produtos, geradores de crédito);3=Operações de compras (bens para revenda, matérias prima e outros produtos, não geradores de crédito);4=Transferência de produtos acabados entre estabelecimentos da pessoa jurídica;5=Transferência de produtos entre estabelecimentos da pessoa jurídica;9=Outras}
         CAST(NULL AS VARCHAR(60)) AS ChaveNFE, -- Chave NFE
         CAST(NULL AS VARCHAR(60)) AS ChaveNFERefer, -- Chave NFE Referenciada
         -- Pedro E. Braga - Conforme reunião não será exportado a informação nesse momento
         CAST(NULL AS VARCHAR(20)) AS CodContaTes, -- Código da Conta Tesouraria
         -- Justificativa utilizada em Testes de Integração pela EME4
         CAST('Documento Inutilizado - ' || INU.JUSTIF   AS VARCHAR(200)) AS Justificativa, -- Justificativa do documento Contábil
         --CAST(NULL AS VARCHAR(200)) AS Justificativa, -- Justificativa do documento Contábil
         CAST(NULL AS VARCHAR(1)) AS TipoFrete, -- {F=Por conta do emitente;T=Por conta do destinatário;A=Por conta de terceiros;B=Sem frete}
         CAST(NULL AS Numeric(9)) AS CodTransportadora, -- Código da Transportadora do Documento
         --CAST(TRIM(COALESCE(ENDTRA.NUMDOC, TRA.NUMDOC)) AS VARCHAR(18)) AS CpfCnpjTransportadora, -- CPF ou CNPJ da Transportadora do Documento
         CAST(NULL AS VARCHAR(18)) AS CpfCnpjTransportadora, -- CPF ou CNPJ da Transportadora do Documento
         CAST(NULL AS VARCHAR(10)) AS PlacaVeiculo, -- Placa do Veículo de Entrega
         CAST(NULL AS Numeric(9)) AS CodTranspRedespacho, -- Código da Transportadora de Redespacho do Documento
         CAST(NULL AS VARCHAR(18)) AS CpfCnpjTranspRedespacho, -- CPF ou CNPJ da Transportadora de Redespacho do Documento
         CAST(INU.MODNOT AS VARCHAR(2)) AS CodigoModelo, -- Código do Modelo de Documento (01 ou 65)
         -- Dados da Entrega
         CAST(NULL AS VARCHAR(120)) AS LogradouroEnt, -- Logradouro do Endereço de Entrega
         CAST(NULL AS Numeric(10)) AS NumeroEnt, -- Número do Endereço de Entrega
         CAST(NULL AS VARCHAR(30)) AS ComplementoEnt, -- Complemento do Endereço de Entrega
         CAST(NULL AS VARCHAR(10)) AS CEPEnt, -- CEP do Endereço de Entrega
         CAST(NULL AS VARCHAR(80)) AS BairroEnt, -- Bairro do Endereço de Entrega
         CAST(NULL AS Numeric(10)) AS CodMunicipioIBGEEnt, -- GeoCodigo do M3 - caso esteja informado deverá importar o vínculo do município por este código (Endereço)
         -- A Pedido da EME4 não será exportado os dados da Cidade/Estado/Pais
         CAST(NULL AS VARCHAR(100)) AS CidadeEndEnt, -- Cidade do Endereço de Entrega
         CAST(NULL AS VARCHAR(2)) AS EstadoEnt, -- Estado do Endereço de Entrega
         CAST(NULL AS Numeric(9)) AS CodigoPaisEnt, -- Codigo do Banco Central para o Pais da Cidade de Entrega
         CAST(NULL AS VARCHAR(80)) AS PaisEnt, -- Nome do Pais do Endereço de Entrega
         CAST(NULL AS Numeric(15,2)) AS ValorFrete, -- Valor do Frete
         CAST(NULL AS Numeric(15,2)) AS ValorFreteTerceiros, -- Valor do Frete Terceiros
         CAST(NULL AS Numeric(15,2)) AS ICMSFreteTerceiros, -- Valor ICMS do Frete Terceiros
         CAST(NULL AS Numeric(15,2)) AS DifaFreteTerceiros, -- Valor DIFA do Frete Terceiros
         CAST(NULL AS Numeric(15,2)) AS ValorSeguro, -- Valor do Seguro
         CAST(NULL AS Numeric(15,2)) AS ValorAcrescimos, -- Valor Acrescimos
         -- Valores relativo a Nota de Importação
         CAST(NULL AS Numeric(15,2)) AS ValorTHC, -- Valor THC
         CAST(NULL AS Numeric(15,2)) AS ValorAFRMM, -- Valor AFRMM
         CAST(NULL AS Numeric(15,2)) AS ValorDemurrage, -- Valor Demurrage
         CAST(NULL AS Numeric(15,2)) AS ValorDesestiva, -- Valro Desestiva
         CAST(NULL AS Numeric(15,2)) AS ValorDesembaraco, -- Valor Desembaraço
         CAST(NULL AS Numeric(15,2)) AS ValorSiscomex, -- Valor Siscomex
         CAST(NULL AS Numeric(15,2)) AS ValorPISImport, -- Valro PIS Importação
         CAST(NULL AS Numeric(15,2)) AS ValorCofinsImport, -- Valro Cofins Importação
         CAST(NULL AS Numeric(15,2)) AS ValorDespAduaneira, -- Valor Despesa Aduaneira
         CAST(NULL AS VARCHAR(10)) AS SimboloMoeda, -- Símbolo da Moeda
         CAST(NULL AS Numeric(15,4)) AS ValorCotacaoMoeda, -- Valor Cotação Moeda
         CAST(NULL AS Timestamp) AS DataCotacaoMoeda, -- Data Cotação Moeda
         --CAST(TRIM(COALESCE(ENDFUN.NUMDOC, FUNPAR.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJRepresentante, -- CPF ou CNPJ do Representante
         CAST(NULL AS VARCHAR(18)) AS CPFCNPJRepresentante, -- CPF ou CNPJ do Representante
         CAST(NULL AS Numeric(8)) AS COO, -- COO Cupom
         CAST(NULL AS Numeric(8)) AS NroECF, -- Número do ECF
         CAST(NULL AS VARCHAR(50)) AS NroSerieECF, -- Número de Série do ECF
         CAST(NULL AS VARCHAR(20)) AS ModeloECF, -- Modelo do ECF
         CAST(NULL AS VARCHAR(20)) AS MarcaECF, -- Marca do ECF
         CAST(NULL AS VARCHAR(18)) as CPFCNPJCupom -- CPF ou CNPJ do cliente não identificado no cupom
    FROM TT_INU INU
   INNER JOIN ( SELECT LINU.sequen, generate_series(LINU.NUMINI, LINU.NUMFIM) AS NumeroDocInu
                  FROM TT_INU LINU
              ) INUTILIZADOS ON INUTILIZADOS.SEQUEN = INU.SEQUEN
   WHERE 1 = 1
     AND INU.DATINC >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',INU.CODFIL,'','','')
     AND INU.EXPEM4 = 'F'
   ) TAB
   ORDER BY TAB.SEQUEN, TAB.NUMERODOCUMENTO
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Documentos Referenciados" (Tabela Integrao Mult)
/*-- SEQ 2646 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_DOCTOREFDEVCOMEMIT CASCADE;

/*-- SEQ 2647 --*/
CREATE OR REPLACE VIEW TV_TIMU_DOCTOREFDEVCOMEMIT AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.FILREF, TAB.SEQREF, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.IndicadorOperacao, -- 0 - Entrada ou Aquisio / 1 - Sada ou Prestao
      TAB.IndicadorEmitente, -- 0 - Prpria / 1 - Terceiros
      TAB.NumeroDoctoRefer, -- Nmero do Documento Referenciado
      TAB.DataEmiDoctoRefer, -- Data de Emisso do Documento Referenciado
      TAB.CPFCNPJParticip, -- CPF ou CNPJ do Participante
      TAB.CodModeloDoctoRefer, -- Cdigo do Modelo do Documento Referenciado (01 a 65)
      TAB.TipoSerieRefer, -- Tipo da Srie do Documento Referenciado 1 - Prpria / 2 - Terceiros
      TAB.SerieDoctoRefer, -- Srie do Documento Referenciado
      TAB.SubSerie, -- Sub Srie do Documento Referenciado
      TAB.ChaveNFECTE, -- Chave NFE ou CTE do Documento Referenciado
      TAB.TipoDoctoRefer, -- 1 - Nota Fiscal / 2 - Nota Fiscal Eletrnica / 3 - Nota Fiscal Produtor / 4 - Cupom Fiscal / 5 - Conhecimento de Transporte Eletrnico / 6 - Despesa Pblica / 7 - Nota Fiscal de Consumidor Eletrnica / 8 - Declarao / 9 - Outros / 0 - NFe / CTe de Anulao de valores
      TAB.ValorDocumento, -- Valor do Documento Referenciado
      TAB.DataPrevEntrega, -- Data de previso de entrega do Documento Referenciado
      TAB.DescricaoDocumento, -- Descrio do Documento Referenciado
      TAB.PINSuframa -- PIN do Suframa
  FROM (-- Notas Emitidas (Devoluo de Compra)
        SELECT
               VEN.CODFIL, VEN.SEQUEN, CREF.CODFIL AS FILREF, CREF.SEQUEN AS SEQREF, CAST('VEN' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_DOCTOREFERENCIADO' AS VARCHAR(50)) AS DESTINO, COALESCE(VEN.DATINC, VEN.DATHOR) AS DATINC, VEN.ATU_EM, VEN.EXPORT, VEN.EXPEM4,
               CAST('VEN' || VEN.CODFIL || VEN.SEQUEN AS VARCHAR(50)) AS CHAVE,
               COALESCE(VEN.DATINC, VEN.DATHOR) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               -- Definido juntamente com a EME4 quando for cupom fiscal enviar tipo de operao fixo
               CAST(CASE WHEN (VEN.CODSER = 'CF') THEN 998
                         WHEN (VEN.MODNOT = '65') THEN 997
                         WHEN (VEN.MODNOT = '59') THEN 996
                         WHEN (VEN.UFLOJA = 'T') THEN                                                       TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTDEM, '[^0-9]', '', 'gi'), ''))                         ELSE                               TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTFOR, '[^0-9]', '', 'gi'), ''))                    END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST(TO_NUMBER(VEN.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = VEN.FILCLI AND REL.CODPAR = VEN.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                         ELSE 'C' 
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST(TRIM(CASE WHEN VEN.CODSER='CF' THEN VEN.CODSER
                              WHEN ( (VEN.MODNOT = '65' OR VEN.MODNOT = '59') AND VEN.NUMECF >= '400' ) THEN VEN.NUMECF
                              WHEN VEN.CODSER<>'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN DSER.SEREXT
                              ELSE NULL
                         END) AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(TO_CHAR(TO_NUMBER(TRIM(CASE WHEN VEN.CODSER = 'CF' THEN VEN.SEQUEN 
                                                WHEN VEN.CODSER = 'ST' THEN COALESCE(TO_CHAR(VEN.SATCFE), VEN.NUMNOT)
                                                ELSE VEN.NUMNOT END))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST('1' AS VARCHAR(1)) AS IndicadorOperacao, -- 0 - Entrada ou Aquisio / 1 - Sada ou Prestao
               CAST('0' AS VARCHAR(1)) AS IndicadorEmitente, -- 0 - Prpria / 1 - Terceiros
               CAST(TO_CHAR(TO_NUMBER(TRIM(CREF.NUMNOT))) AS VARCHAR(20)) AS NumeroDoctoRefer, -- Nmero do Documento Referenciado
               CAST(TRUNC(CREF.DATOPE) AS Timestamp) AS DataEmiDoctoRefer, -- Data de Emisso do Documento Referenciado
               CAST(TRIM(COALESCE(CREF_PAR.NUMDOC, CREF_VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJParticip, -- CPF ou CNPJ do Participante
               CAST(CASE WHEN ISNOTNULL(CREF_FIS.MODNOT)='T' THEN CREF_FIS.MODNOT ELSE '55' END AS VARCHAR(2)) AS CodModeloDoctoRefer, -- Cdigo do Modelo do Documento Referenciado (01 a 65)
               CAST('2' AS VARCHAR(1)) AS TipoSerieRefer, -- Tipo da Srie do Documento Referenciado 1 - Prpria / 2 - Terceiros
               CAST(CASE WHEN ISNOTNULL(CREF_FIS.SEREXP)='T' THEN LPAD(TRIM(CREF_FIS.SEREXP), 3, '0')||CASE WHEN CREF.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(CREF_FIS.SUBEXP),'0'), 2, '0') END
                         ELSE LPAD(TRIM(CREF.CODSER), 2, '0')||CASE WHEN CREF.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(CREF.SUBSER),'0'), 3, '0') END
                    END AS VARCHAR(5)) AS SerieDoctoRefer, -- Srie do Documento Referenciado
               CAST(TRIM(CASE WHEN ISNOTNULL(CREF_FIS.SUBEXP)='T' THEN CREF_FIS.SUBEXP ELSE CREF.SUBSER END) AS VARCHAR(3)) AS SubSerie, -- Sub Srie do Documento Referenciado
               CAST(CREF.CHAVEA AS VARCHAR(60)) AS ChaveNFECTE, -- Chave NFE ou CTE do Documento Referenciado
               CAST(CASE WHEN CREF_FIS.MODNOT='01' THEN '1'
                         WHEN CREF_FIS.MODNOT='55' THEN '2'
                         WHEN CREF_FIS.MODNOT='04' THEN '3'
                         WHEN CREF_FIS.MODNOT='2D' THEN '4'
                         WHEN CREF_FIS.MODNOT='57' THEN '5'
                         --WHEN CREF_FIS.MODNOT='' THEN '6'
                         WHEN CREF_FIS.MODNOT='65' THEN '7'
                         --WHEN CREF_FIS.MODNOT='' THEN '8'
                         WHEN CREF_FIS.MODNOT='59' THEN '9'
                         --WHEN CREF_FIS.MODNOT='' THEN '0'
                         ELSE '9' 
                    END AS VARCHAR(1)) AS TipoDoctoRefer, -- 1 - Nota Fiscal / 2 - Nota Fiscal Eletrnica / 3 - Nota Fiscal Produtor / 4 - Cupom Fiscal / 5 - Conhecimento de Transporte Eletrnico / 6 - Despesa Pblica / 7 - Nota Fiscal de Consumidor Eletrnica / 8 - Declarao / 9 - Outros / 0 - NFe / CTe de Anulao de valores
               CAST(ABS(CREF.VLRLIQ) AS Numeric(15,2)) AS ValorDocumento, -- Valor do Documento Referenciado
               CAST(NULL AS Timestamp) AS DataPrevEntrega, -- Data de previso de entrega do Documento Referenciado
               --CAST('Compra - CFOP: '||CREF_DCFO.CODCFO||' '||CREF_DCFO.DESCFO||' - Chave: '||CREF.CODFIL||'/'||CREF.SEQUEN AS VARCHAR(100)) AS DescricaoDocumento, -- Descrio do Documento Referenciado
               CAST(NULL AS VARCHAR(100)) AS DescricaoDocumento, -- Descrio do Documento Referenciado
               CAST(NULL AS VARCHAR(9)) AS PINSuframa -- PIN do Suframa
          FROM TT_VEN VEN
          -- Srie de Emisso
          JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
          -- Natureza
          JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
          -- Cliente
          JOIN TT_CLI PAR ON PAR.FILCLI = VEN.FILCLI AND PAR.CODCLI = VEN.CODCLI
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = VEN.FILCLI AND ENDFAT.CODCLI = VEN.CODCLI AND ENDFAT.CODFIL = VEN.FILFAT AND ENDFAT.NUMEND = VEN.ENDFAT
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          -- Busca nota de entrada devolvida
          JOIN (
                SELECT DISTINCT IVE.FILICOORI AS FILREF, IVE.SEQICOORI AS SEQREF, IVE.CODFIL AS FILORI, IVE.SEQUEN AS SEQORI
                  FROM TT_IVE IVE
                  WHERE IVE.SITMOV <> 'C'
                    AND IVE.FILICOORI IS NOT NULL
                    AND IVE.SEQICOORI IS NOT NULL
                    AND IVE.NUMICOORI IS NOT NULL
                ) NREF ON NREF.FILORI = VEN.CODFIL AND NREF.SEQORI = VEN.SEQUEN
          JOIN TT_COM CREF ON CREF.CODFIL = NREF.FILREF AND CREF.SEQUEN = NREF.SEQREF
          -- Srie de Emisso
          LEFT JOIN (SELECT DISTINCT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT, ORIGEM
                       FROM TT_FIS
                      WHERE ORIGEM IN ('C','F')) CREF_FIS ON CREF_FIS.CODSER = CREF.CODSER AND CREF_FIS.SUBSER = COALESCE(CREF.SUBSER,'$$$') AND CREF_FIS.ORIGEM = CASE WHEN COALESCE(CREF.TIPPAR,'F') = 'T' THEN 'F' ELSE 'C' END
          -- Natureza
          LEFT JOIN TD_CFO CREF_DCFO ON CREF_DCFO.CODTAB = CREF.CODCFO
          -- Fornecedor
          JOIN TT_CLI CREF_PAR ON CREF_PAR.FILCLI = CREF.FILFOR AND CREF_PAR.CODCLI = CREF.CODFOR
          --JOIN TT_END CREF_ENDE ON CREF_ENDE.FILCLI = CREF_PAR.FILCLI AND CREF_ENDE.CODCLI = CREF_PAR.CODCLI AND CREF_ENDE.CODFIL = CREF_PAR.FILEND AND CREF_ENDE.NUMEND = CREF_PAR.FILEND
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI CREF_VIN ON CREF_VIN.FILCLI = CREF_PAR.FILVIN AND CREF_VIN.CODCLI = CREF_PAR.CODVIN  AND CREF_PAR.FLGTIP <> 0
         WHERE VEN.CODSER <> 'CF'
           AND VEN.NUMNOT NOT LIKE '%#%'
           AND VEN.DATHOR >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',VEN.CODFIL,'','','')
           AND CREF.NUMNOT NOT LIKE '%#%'
           AND (
                  -- Quando no for Documento Eletrnico
                  (VEN.MODNOT NOT IN ('55','65','59','SE')) OR
                  -- Quando Documento Eletrnico
                  (
                     (VEN.MODNOT IN ('55','65','59','SE')) AND 
                     (
                        -- Quando Cancelado exporta quando situao for Cancelada, Inutilizada ou Denegada
                        ((VEN.FLGEST = 'C') AND (VEN.FLGNFE IN ('3','4','6'))) OR
                        -- Quando Aberto/Quitado exporta quando situao for Autorizado
                        ((VEN.FLGEST <> 'C') AND (VEN.FLGNFE IN ('1'))) OR
                        -- Nota Estornada fica cancelada no banco mas autorizada na Sefaz
                        ((VEN.FLGEST = 'C') AND (VEN.FLGNFE = '1'))
                     )
                  )
               )
           AND VEN.EXPEM4 = 'F'
       ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Documentos Referenciados" (Tabela Integrao Mult)
/*-- SEQ 2648 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_DOCTOREFERENCIADOEMIT CASCADE;

/*-- SEQ 2649 --*/
CREATE OR REPLACE VIEW TV_TIMU_DOCTOREFERENCIADOEMIT AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.FILREF, TAB.SEQREF, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.IndicadorOperacao, -- 0 - Entrada ou Aquisio / 1 - Sada ou Prestao
      TAB.IndicadorEmitente, -- 0 - Prpria / 1 - Terceiros
      TAB.NumeroDoctoRefer, -- Nmero do Documento Referenciado
      TAB.DataEmiDoctoRefer, -- Data de Emisso do Documento Referenciado
      TAB.CPFCNPJParticip, -- CPF ou CNPJ do Participante
      TAB.CodModeloDoctoRefer, -- Cdigo do Modelo do Documento Referenciado (01 a 65)
      TAB.TipoSerieRefer, -- Tipo da Srie do Documento Referenciado 1 - Prpria / 2 - Terceiros
      TAB.SerieDoctoRefer, -- Srie do Documento Referenciado
      TAB.SubSerie, -- Sub Srie do Documento Referenciado
      TAB.ChaveNFECTE, -- Chave NFE ou CTE do Documento Referenciado
      TAB.TipoDoctoRefer, -- 1 - Nota Fiscal / 2 - Nota Fiscal Eletrnica / 3 - Nota Fiscal Produtor / 4 - Cupom Fiscal / 5 - Conhecimento de Transporte Eletrnico / 6 - Despesa Pblica / 7 - Nota Fiscal de Consumidor Eletrnica / 8 - Declarao / 9 - Outros / 0 - NFe / CTe de Anulao de valores
      TAB.ValorDocumento, -- Valor do Documento Referenciado
      TAB.DataPrevEntrega, -- Data de previso de entrega do Documento Referenciado
      TAB.DescricaoDocumento, -- Descrio do Documento Referenciado
      TAB.PINSuframa -- PIN do Suframa
  FROM (-- Notas Emitidas (Reimpresso, Estorno, Devoluo de Venda)
        SELECT
               VEN.CODFIL, VEN.SEQUEN, VREF.CODFIL AS FILREF, VREF.SEQUEN AS SEQREF, CAST('VEN' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_DOCTOREFERENCIADO' AS VARCHAR(50)) AS DESTINO, COALESCE(VEN.DATINC, VEN.DATHOR) AS DATINC, VEN.ATU_EM, VEN.EXPORT, VEN.EXPEM4,
               CAST('VEN' || VEN.CODFIL || VEN.SEQUEN AS VARCHAR(50)) AS CHAVE,
               COALESCE(VEN.DATINC, VEN.DATHOR) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               -- Definido juntamente com a EME4 quando for cupom fiscal enviar tipo de operao fixo
               CAST(CASE WHEN (VEN.CODSER = 'CF') THEN 998
                         WHEN (VEN.MODNOT = '65') THEN 997
                         WHEN (VEN.MODNOT = '59') THEN 996
                         WHEN (VEN.UFLOJA = 'T') THEN                                                       TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTDEM, '[^0-9]', '', 'gi'), ''))                         ELSE                               TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTFOR, '[^0-9]', '', 'gi'), ''))                    END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST(TO_NUMBER(VEN.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = VEN.FILCLI AND REL.CODPAR = VEN.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                         ELSE 'C' 
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST(TRIM(CASE WHEN VEN.CODSER='CF' THEN VEN.CODSER
                              WHEN ( (VEN.MODNOT = '65' OR VEN.MODNOT = '59') AND VEN.NUMECF >= '400' ) THEN VEN.NUMECF
                              WHEN VEN.CODSER<>'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN DSER.SEREXT
                              ELSE NULL
                         END) AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(TO_CHAR(TO_NUMBER(TRIM(CASE WHEN VEN.CODSER = 'CF' THEN VEN.SEQUEN 
                                                WHEN VEN.CODSER = 'ST' THEN COALESCE(TO_CHAR(VEN.SATCFE), VEN.NUMNOT)
                                                ELSE VEN.NUMNOT END))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST(CASE WHEN VREF_DNAT.TIPNAT IN ('B', 'D', 'E', 'I', 'M', 'P') THEN '0' ELSE '1' END AS VARCHAR(1)) AS IndicadorOperacao, -- 0 - Entrada ou Aquisio / 1 - Sada ou Prestao
               CAST('0' AS VARCHAR(1)) AS IndicadorEmitente, -- 0 - Prpria / 1 - Terceiros
               CAST(TO_CHAR(TO_NUMBER(TRIM(VREF.NUMNOT))) AS VARCHAR(20)) AS NumeroDoctoRefer, -- Nmero do Documento Referenciado
               CAST(TRUNC(VREF.DATHOR) AS Timestamp) AS DataEmiDoctoRefer, -- Data de Emisso do Documento Referenciado
               CAST(TRIM(COALESCE(VREF_PAR.NUMDOC, VREF_VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJParticip, -- CPF ou CNPJ do Participante
               CAST(CASE WHEN VREF.CODSER='CF' THEN '2D' ELSE VREF.MODNOT END AS VARCHAR(2)) AS CodModeloDoctoRefer, -- Cdigo do Modelo do Documento Referenciado (01 a 65)
               CAST('1' AS VARCHAR(1)) AS TipoSerieRefer, -- Tipo da Srie do Documento Referenciado 1 - Prpria / 2 - Terceiros
               CAST(TRIM(CASE --WHEN VREF.CODSER='CF' THEN VREF.CODSER
                              WHEN VREF.CODSER<>'CF' AND ISNOTNULL(VREF_DSER.SEREXT)='T' THEN VREF_DSER.SEREXT 
                              WHEN ( (VREF.MODNOT = '65' OR VREF.MODNOT = '59') AND VREF.NUMECF >= '400' ) THEN VREF.NUMECF
                              ELSE NULL 
                         END) AS VARCHAR(5)) AS SerieDoctoRefer, -- Srie do Documento Referenciado
               CAST(NULL AS VARCHAR(3)) AS SubSerie, -- Sub Srie do Documento Referenciado
               CAST(VREF.CHAVEA AS VARCHAR(60)) AS ChaveNFECTE, -- Chave NFE ou CTE do Documento Referenciado
               CAST(CASE WHEN VREF.CODSER='CF' THEN '4'
                         WHEN VREF.MODNOT='01' THEN '1'
                         WHEN VREF.MODNOT='55' THEN '2'
                         WHEN VREF.MODNOT='04' THEN '3'
                         WHEN VREF.MODNOT='2D' THEN '4'
                         WHEN VREF.MODNOT='57' THEN '5'
                         --WHEN VREF.MODNOT='' THEN '6'
                         WHEN VREF.MODNOT='65' THEN '7'
                         --WHEN VREF.MODNOT='' THEN '8'
                         WHEN VREF.MODNOT='59' THEN '9'
                         --WHEN VREF.MODNOT='' THEN '0'
                         ELSE '9' 
                    END AS VARCHAR(1)) AS TipoDoctoRefer, -- 1 - Nota Fiscal / 2 - Nota Fiscal Eletrnica / 3 - Nota Fiscal Produtor / 4 - Cupom Fiscal / 5 - Conhecimento de Transporte Eletrnico / 6 - Despesa Pblica / 7 - Nota Fiscal de Consumidor Eletrnica / 8 - Declarao / 9 - Outros / 0 - NFe / CTe de Anulao de valores
               CAST(ABS(VREF.VLRLIQ) AS Numeric(15,2)) AS ValorDocumento, -- Valor do Documento Referenciado
               CAST(NULL AS Timestamp) AS DataPrevEntrega, -- Data de previso de entrega do Documento Referenciado
               --CAST('Venda - CFOP: '||CASE WHEN (VREF.UFLOJA = 'T') THEN VREF_DNAT.NATDEN ELSE VREF_DNAT.NATFOR END||' '||VREF_DNAT.NATURE||' - Chave: '||VREF.CODFIL||'/'||VREF.SEQUEN AS VARCHAR(100)) AS DescricaoDocumento, -- Descrio do Documento Referenciado
               CAST(NULL AS VARCHAR(100)) AS DescricaoDocumento, -- Descrio do Documento Referenciado
               CAST(NULL AS VARCHAR(9)) AS PINSuframa -- PIN do Suframa
          FROM TT_VEN VEN
          -- Srie de Emisso
          JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
          -- Natureza
          JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
          -- Cliente
          JOIN TT_CLI PAR ON PAR.FILCLI = VEN.FILCLI AND PAR.CODCLI = VEN.CODCLI
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = VEN.FILCLI AND ENDFAT.CODCLI = VEN.CODCLI AND ENDFAT.CODFIL = VEN.FILFAT AND ENDFAT.NUMEND = VEN.ENDFAT
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          -- Busca "notas da reimpresso", "nota de origem do Estorno", "nota de origem da devoluo/fatura"
          JOIN (
                SELECT DISTINCT ORI.CODFIL AS FILREF,
                                ORI.SEQUEN AS SEQREF,
                                IVE.CODFIL AS FILORI, IVE.SEQUEN AS SEQORI
                  FROM TT_IVE IVE
                  JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
                  JOIN TT_VEN ORI ON ORI.FILEST = VEN.CODFIL AND ORI.SEQEST = VEN.SEQUEN
                 WHERE 1=1
                   AND VEN.FLGEST <> 'C'
                   AND VEN.NUMNOT NOT LIKE '%#%'
                   AND IVE.SITMOV <> 'C'
                   AND ORI.SEQEST IS NOT NULL -- Nota de Estorno
                 UNION
                SELECT DISTINCT ORI.CODFIL AS FILREF,
                                ORI.SEQUEN AS SEQREF,
                                IVE.CODFIL AS FILORI, IVE.SEQUEN AS SEQORI
                  FROM TT_IVE IVE
                  JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
                  JOIN TT_VEN ORI ON ORI.CODFIL = VEN.CODFIL AND ORI.SEQFAT = VEN.SEQUEN
                 WHERE 1=1
                   AND VEN.FLGEST <> 'C'
                   AND VEN.NUMNOT NOT LIKE '%#%'
                   AND IVE.SITMOV <> 'C'
                   AND ORI.SEQFAT IS NOT NULL -- Nota de Reimpresso
                 UNION
                SELECT DISTINCT IVE.CODFIL AS FILREF, IVE.SEQUEN AS SEQREF, IRE.CODFIL AS FILORI, IRE.SEQUEN AS SEQORI
                  FROM TT_IVE IVE
                  -- Traz a Nota de Fatura/Devoluo
                  JOIN TT_IVE IRE ON IRE.FILORI = IVE.CODFIL AND IRE.NUMORI = IVE.SEQUEN
                                 AND IRE.ITEORI = IVE.NUMITE AND IRE.SITMOV = 'N'
                ) NREF ON NREF.FILORI = VEN.CODFIL AND NREF.SEQORI = VEN.SEQUEN
          JOIN TT_VEN VREF ON VREF.CODFIL = NREF.FILREF AND VREF.SEQUEN = NREF.SEQREF
          -- Srie de Emisso
          JOIN TD_SER VREF_DSER ON VREF_DSER.CODSER = VREF.CODSER
          -- Natureza
          JOIN TD_NAT VREF_DNAT ON VREF_DNAT.CODTAB = VREF.CODNAT
          -- Cliente
          JOIN TT_CLI VREF_PAR ON VREF_PAR.FILCLI = VREF.FILCLI AND VREF_PAR.CODCLI = VREF.CODCLI
          --JOIN TT_END VREF_ENDE ON ENDE.FILCLI = VREF_PAR.FILCLI AND VREF_ENDE.CODCLI = VREF_PAR.CODCLI AND VREF_ENDE.CODFIL = VREF_PAR.FILEND AND VREF_ENDE.NUMEND = VREF_PAR.NUMEND
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VREF_VIN ON VREF_VIN.FILCLI = VREF_PAR.FILVIN AND VREF_VIN.CODCLI = VREF_PAR.CODVIN  AND VREF_PAR.FLGTIP <> 0
         WHERE VEN.CODSER <> 'CF'
           AND VEN.NUMNOT NOT LIKE '%#%'
           AND VEN.DATHOR >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',VEN.CODFIL,'','','')
           AND VREF.NUMNOT NOT LIKE '%#%'
           AND (
                  -- Quando no for Documento Eletrnico
                  (VEN.MODNOT NOT IN ('55','65','59','SE')) OR
                  -- Quando Documento Eletrnico
                  (
                     (VEN.MODNOT IN ('55','65','59','SE')) AND 
                     (
                        -- Quando Cancelado exporta quando situao for Cancelada, Inutilizada ou Denegada
                        ((VEN.FLGEST = 'C') AND (VEN.FLGNFE IN ('3','4','6'))) OR
                        -- Quando Aberto/Quitado exporta quando situao for Autorizado
                        ((VEN.FLGEST <> 'C') AND (VEN.FLGNFE IN ('1'))) OR
                        -- Nota Estornada fica cancelada no banco mas autorizada na Sefaz
                        ((VEN.FLGEST = 'C') AND (VEN.FLGNFE = '1'))
                     )
                  )
               )
           AND VEN.EXPEM4 = 'F'
       ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Documentos Referenciados" (Tabela Integrao Mult)
/*-- SEQ 2650 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_DOCTOREFERENCIADORECEB CASCADE;

/*-- SEQ 2651 --*/
CREATE OR REPLACE VIEW TV_TIMU_DOCTOREFERENCIADORECEB AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.FILREF, TAB.SEQREF, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.IndicadorOperacao, -- 0 - Entrada ou Aquisio / 1 - Sada ou Prestao
      TAB.IndicadorEmitente, -- 0 - Prpria / 1 - Terceiros
      TAB.NumeroDoctoRefer, -- Nmero do Documento Referenciado
      TAB.DataEmiDoctoRefer, -- Data de Emisso do Documento Referenciado
      TAB.CPFCNPJParticip, -- CPF ou CNPJ do Participante
      TAB.CodModeloDoctoRefer, -- Cdigo do Modelo do Documento Referenciado (01 a 65)
      TAB.TipoSerieRefer, -- Tipo da Srie do Documento Referenciado 1 - Prpria / 2 - Terceiros
      TAB.SerieDoctoRefer, -- Srie do Documento Referenciado
      TAB.SubSerie, -- Sub Srie do Documento Referenciado
      TAB.ChaveNFECTE, -- Chave NFE ou CTE do Documento Referenciado
      TAB.TipoDoctoRefer, -- 1 - Nota Fiscal / 2 - Nota Fiscal Eletrnica / 3 - Nota Fiscal Produtor / 4 - Cupom Fiscal / 5 - Conhecimento de Transporte Eletrnico / 6 - Despesa Pblica / 7 - Nota Fiscal de Consumidor Eletrnica / 8 - Declarao / 9 - Outros / 0 - NFe / CTe de Anulao de valores
      TAB.ValorDocumento, -- Valor do Documento Referenciado
      TAB.DataPrevEntrega, -- Data de previso de entrega do Documento Referenciado
      TAB.DescricaoDocumento, -- Descrio do Documento Referenciado
      TAB.PINSuframa -- PIN do Suframa
  FROM (-- Notas de Recebidas
         SELECT
               COM.CODFIL, COM.SEQUEN, CREF.CODFIL AS FILREF, CREF.SEQUEN AS SEQREF, CAST('COM' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_DOCTOREFERENCIADO' AS VARCHAR(50)) AS DESTINO, COALESCE(COM.DATINC, COM.DATOPE) AS DATINC, COM.ATU_EM, COM.EXPORT, COM.EXPEM4,
               CAST('COM' || COM.CODFIL || COM.SEQUEN AS VARCHAR(50)) AS CHAVE,
               COALESCE(COM.DATINC, COM.DATOPE) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               CAST(                    TO_NUMBER(NULLIF(regexp_replace(DCFO.EXTCFO, '[^0-9]', '', 'gi'), '')) AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST(TO_NUMBER(COM.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = COM.FILFOR AND REL.CODPAR = COM.CODFOR AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                         ELSE 'C' 
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('2' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST(CASE WHEN ISNOTNULL(FIS.SEREXP)='T' THEN LPAD(TRIM(FIS.SEREXP), 3, '0')||CASE WHEN COM.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(FIS.SUBEXP),'0'), 2, '0') END
                         ELSE LPAD(TRIM(COM.CODSER), 2, '0')||CASE WHEN COM.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(COM.SUBSER),'0'), 3, '0') END
                    END AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(TO_CHAR(TO_NUMBER(TRIM(COM.NUMNOT))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST('0' AS VARCHAR(1)) AS IndicadorOperacao, -- 0 - Entrada ou Aquisio / 1 - Sada ou Prestao
               CAST('0' AS VARCHAR(1)) AS IndicadorEmitente, -- 0 - Prpria / 1 - Terceiros
               CAST(TO_CHAR(TO_NUMBER(TRIM(CREF.NUMNOT))) AS VARCHAR(20)) AS NumeroDoctoRefer, -- Nmero do Documento Referenciado
               CAST(TRUNC(CREF.DATOPE) AS Timestamp) AS DataEmiDoctoRefer, -- Data de Emisso do Documento Referenciado
               CAST(TRIM(COALESCE(CREF_PAR.NUMDOC, CREF_VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJParticip, -- CPF ou CNPJ do Participante
               CAST(CASE WHEN ISNOTNULL(CREF_FIS.MODNOT)='T' THEN CREF_FIS.MODNOT ELSE '55' END AS VARCHAR(2)) AS CodModeloDoctoRefer, -- Cdigo do Modelo do Documento Referenciado (01 a 65)
               CAST('2' AS VARCHAR(1)) AS TipoSerieRefer, -- Tipo da Srie do Documento Referenciado 1 - Prpria / 2 - Terceiros
               CAST(CASE WHEN ISNOTNULL(CREF_FIS.SEREXP)='T' THEN LPAD(TRIM(CREF_FIS.SEREXP), 3, '0')||CASE WHEN CREF.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(CREF_FIS.SUBEXP),'0'), 2, '0') END
                         ELSE LPAD(TRIM(CREF.CODSER), 2, '0')||CASE WHEN CREF.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(CREF.SUBSER),'0'), 3, '0') END
                    END AS VARCHAR(5)) AS SerieDoctoRefer, -- Srie do Documento Referenciado
               CAST(TRIM(CASE WHEN ISNOTNULL(CREF_FIS.SUBEXP)='T' THEN CREF_FIS.SUBEXP ELSE CREF.SUBSER END) AS VARCHAR(3)) AS SubSerie, -- Sub Srie do Documento Referenciado
               CAST(CREF.CHAVEA AS VARCHAR(60)) AS ChaveNFECTE, -- Chave NFE ou CTE do Documento Referenciado
               CAST(CASE WHEN CREF_FIS.MODNOT='01' THEN '1'
                         WHEN CREF_FIS.MODNOT='55' THEN '2'
                         WHEN CREF_FIS.MODNOT='04' THEN '3'
                         WHEN CREF_FIS.MODNOT='2D' THEN '4'
                         WHEN CREF_FIS.MODNOT='57' THEN '5'
                         --WHEN CREF_FIS.MODNOT='' THEN '6'
                         WHEN CREF_FIS.MODNOT='65' THEN '7'
                         --WHEN CREF_FIS.MODNOT='' THEN '8'
                         WHEN CREF_FIS.MODNOT='59' THEN '9'
                         --WHEN CREF_FIS.MODNOT='' THEN '0'
                         ELSE '9' 
                    END AS VARCHAR(1)) AS TipoDoctoRefer, -- 1 - Nota Fiscal / 2 - Nota Fiscal Eletrnica / 3 - Nota Fiscal Produtor / 4 - Cupom Fiscal / 5 - Conhecimento de Transporte Eletrnico / 6 - Despesa Pblica / 7 - Nota Fiscal de Consumidor Eletrnica / 8 - Declarao / 9 - Outros / 0 - NFe / CTe de Anulao de valores
               CAST(ABS(CREF.VLRLIQ) AS Numeric(15,2)) AS ValorDocumento, -- Valor do Documento Referenciado
               CAST(NULL AS Timestamp) AS DataPrevEntrega, -- Data de previso de entrega do Documento Referenciado
               --CAST('Compra - CFOP: '||CREF_DCFO.CODCFO||' '||CREF_DCFO.DESCFO||' - Chave: '||CREF.CODFIL||'/'||CREF.SEQUEN AS VARCHAR(100)) AS DescricaoDocumento, -- Descrio do Documento Referenciado
               CAST(NULL AS VARCHAR(100)) AS DescricaoDocumento, -- Descrio do Documento Referenciado
               CAST(NULL AS VARCHAR(9)) AS PINSuframa -- PIN do Suframa
          FROM TT_COM COM
          -- Srie de Emisso
          LEFT JOIN (SELECT DISTINCT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT, ORIGEM
                       FROM TT_FIS
                      WHERE ORIGEM IN ('C','F')) FIS ON FIS.CODSER = COM.CODSER AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$') AND FIS.ORIGEM = CASE WHEN COALESCE(COM.TIPPAR,'F') = 'T' THEN 'F' ELSE 'C' END
          -- Natureza
          LEFT JOIN TD_CFO DCFO ON DCFO.CODTAB = COM.CODCFO
          -- Fornecedor
          JOIN TT_CLI PAR ON PAR.FILCLI = COM.FILFOR AND PAR.CODCLI = COM.CODFOR
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.FILEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = COM.FILFOR AND ENDFAT.CODCLI = COM.CODFOR AND ENDFAT.CODFIL = COM.FILEND AND ENDFAT.NUMEND = COM.NUMEND
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          -- Busca "notas de referencia da Fatura" "notas de referencia da compra e compromissos". Obs: Notas de Referncias de Frete so tratados pela "TIMU_ParteDoctoConheceFrete" 
          JOIN ( SELECT DISTINCT LCOM.CODFIL AS FILREF, LCOM.SEQUEN AS SEQREF, LCOM.CODFIL AS FILORI, LCOM.SEQFAT AS SEQORI
                  FROM TT_COM LCOM
                  WHERE LCOM.SEQFAT IS NOT NULL
                    AND LCOM.SEQUEN <> LCOM.SEQFAT
                    AND LCOM.FLGEST <> 'D'
                    AND LCOM.TIPPAR <> 'T'
                 UNION
                 SELECT DISTINCT CXC.FILCOM AS FILREF, CXC.SEQCOM AS SEQREF, CXC.FILDOC AS FILORI, CXC.SEQDOC AS SEQORI
                   FROM TT_COMXCOM CXC
                ) NREF ON NREF.FILORI = COM.CODFIL AND NREF.SEQORI = COM.SEQUEN
          JOIN TT_COM CREF ON CREF.CODFIL = NREF.FILREF AND CREF.SEQUEN = NREF.SEQREF AND CREF.TIPPAR <> 'T' AND COALESCE(CREF.CODDAR,'-1') NOT IN ('0','1')
          -- Srie de Emisso
          LEFT JOIN (SELECT DISTINCT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT, ORIGEM
                       FROM TT_FIS
                      WHERE ORIGEM IN ('C','F')) CREF_FIS ON CREF_FIS.CODSER = CREF.CODSER AND CREF_FIS.SUBSER = COALESCE(CREF.SUBSER,'$$$') AND CREF_FIS.ORIGEM = CASE WHEN COALESCE(CREF.TIPPAR,'F') = 'T' THEN 'F' ELSE 'C' END
          -- Natureza
          LEFT JOIN TD_CFO CREF_DCFO ON CREF_DCFO.CODTAB = CREF.CODCFO
          -- Fornecedor
          JOIN TT_CLI CREF_PAR ON CREF_PAR.FILCLI = CREF.FILFOR AND CREF_PAR.CODCLI = CREF.CODFOR
          --JOIN TT_END CREF_ENDE ON CREF_ENDE.FILCLI = CREF_PAR.FILCLI AND CREF_ENDE.CODCLI = CREF_PAR.CODCLI AND CREF_ENDE.CODFIL = CREF_PAR.FILEND AND CREF_ENDE.NUMEND = CREF_PAR.FILEND
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI CREF_VIN ON CREF_VIN.FILCLI = CREF_PAR.FILVIN AND CREF_VIN.CODCLI = CREF_PAR.CODVIN  AND CREF_PAR.FLGTIP <> 0
         WHERE COM.FLGEST <> 'D'
           AND COM.NUMNOT NOT LIKE '%#%'
           AND COM.TIPPAR <> 'T'
           AND CREF.NUMNOT NOT LIKE '%#%'
           AND COM.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',COM.CODFIL,'','','')
           AND COM.EXPEM4 = 'F'
       ) TAB
;


-- Autor: Carla Alves
-- Cliente(s): EME4
-- Finalidade(s):
-- 1)Retornar as notas pagas.
-- Arquivo Pai: TIMU_DOCUMENTO
/*-- SEQ 2652 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_DOC_CONTACORRENTE CASCADE;

/*-- SEQ 2653 --*/
CREATE OR REPLACE VIEW TV_TIMU_DOC_CONTACORRENTE AS
   SELECT
         CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
         CAST('I' AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
         CAST('T' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
         CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
         TAB.CODFIL, TAB.SEQUEN, TAB.NUMPAR, TAB.SUBPAR, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.NUMDOC, TAB.DATAFILTRO, 
         TAB.CODSER, TAB.SUBSER, TAB.NUMECF, TAB.NUMNOT, TAB.NUMPED, TAB.TIPPED,
         TAB.TEM_ITEM, TAB.TEM_PARCELA, TAB.TEM_LIQUIDACAO, TAB.TEM_MOVCONTABIL, TAB.TEM_CCUSTOCONTABIL, TAB.TEM_FRETE, TAB.TEM_OPERACAOFINANCEIRA, TAB.TEM_CONTAFINANCEIRA, TAB.TEM_CCUSTOFINANCEIRO, TAB.CHAVE, TAB.VLRNOT_VALIDACAO, TAB.VLRLIQ_VALIDACAO,
         TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
         TAB.TipoOperacao, -- Cdigo do Tipo de Operao
         TAB.Filial, -- Cdigo da Filial
         TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
         TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
         TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
         TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
         TAB.Serie, -- Srie do Documento
         TAB.NumeroDocumento, -- Nmero do documento
         TAB.DataEntrada, -- Data de Entrada
         TAB.DataSaida, -- Data de Sada
         TAB.DataEntSai, -- Data de Entrada ou Sada
         TAB.DataEmissao, -- Data de Emisso
         TAB.ValorContabil, -- Valor Contbil Original do Documento (Tesouraria)
         TAB.ValorDescontos, -- Valor Desconto dos Produtos
         TAB.ValorOutrasDespesas, -- Valor Outras Despesas dos Produtos
         TAB.ValorDescontosServ, -- Valor Desconto dos Servios
         TAB.ValorOutrasDespesasServ, -- Valor Outras Despesas dos Servios
         TAB.SituacaoNFE, -- {3=Autorizada;5=Cancelada;7=Inutilizada;8=Substituida;9=Denegada;A=Contingncia}
         TAB.SituacaoDOC, -- {0=Normal;1=Cancelada;2=Devoluo Parcial;3=Devoluo Total;4=Crdito Bloqueado;5=Inadimplncia;6=Cred. Bloq/Inad.;7=Bloqueio nos Itens;8=Faturado;A=Bloq. Val. Parcela;B=Bloq. Val. Min. Venda}
         TAB.ObsFiscal, -- Observao Fiscal do Documento
         TAB.Observacoes, -- Observaes da Nota
         TAB.InfoComplementares, -- Informaes Complementares da Nota
         TAB.TextoFiscal, -- Texto Fiscal do Documento
         TAB.NumPedCliente, -- Nmero do Pedido no Cliente
         TAB.NumPedRepresentante, -- Nmero do Pedido no Representante
         TAB.IndNaturezaFrete, -- {0=Operaes de vendas, com nus suportado pelo estabelecimento vendedor;1=Operaes de vendas, com nus suportado pelo adquirente;2=Operaes de compras (bens para revenda, matrias prima e outros produtos, geradores de crdito);3=Operaes de compras (bens para revenda, matrias prima e outros produtos, no geradores de crdito);4=Transferncia de produtos acabados entre estabelecimentos da pessoa jurdica;5=Transferncia de produtos entre estabelecimentos da pessoa jurdica;9=Outras}
         TAB.ChaveNFE, -- Chave NFE
         TAB.ChaveNFERefer, -- Chave NFE Referenciada
         TAB.CodContaTes, -- Cdigo da Conta Tesouraria
         TAB.Justificativa, -- Justificativa do documento Contbil
         TAB.TipoFrete, -- {F=Por conta do emitente;T=Por conta do destinatrio;A=Por conta de terceiros;B=Sem frete}
         TAB.CodTransportadora, -- Cdigo da Transportadora do Documento
         TAB.CpfCnpjTransportadora, -- CPF ou CNPJ da Transportadora do Documento
         TAB.PlacaVeiculo, -- Placa do Veculo de Entrega
         TAB.CodTranspRedespacho, -- Cdigo da Transportadora de Redespacho do Documento
         TAB.CpfCnpjTranspRedespacho, -- CPF ou CNPJ da Transportadora de Redespacho do Documento
         TAB.CodigoModelo, -- Cdigo do Modelo de Documento (01 ou 65)
         TAB.LogradouroEnt, -- Logradouro do Endereo de Entrega
         TAB.NumeroEnt, -- Nmero do Endereo de Entrega
         TAB.ComplementoEnt, -- Complemento do Endereo de Entrega
         TAB.CEPEnt, -- CEP do Endereo de Entrega
         TAB.CodMunicipioIBGEEnt, -- GeoCodigo do M3 - caso esteja informado dever importar o vnculo do municpio por este cdigo (Endereo)
         TAB.CidadeEndEnt, -- Cidade do Endereo de Entrega
         TAB.BairroEnt, -- Bairro do Endereo de Entrega
         TAB.EstadoEnt, -- Estado do Endereo de Entrega
         TAB.CodigoPaisEnt, -- Codigo do Banco Central para o Pais da Cidade de Entrega
         TAB.PaisEnt, -- Nome do Pais do Endereo de Entrega
         TAB.ValorFrete, -- Valor do Frete
         TAB.ValorFreteTerceiros, -- Valor do Frete Terceiros
         TAB.ICMSFreteTerceiros, -- Valor ICMS do Frete Terceiros
         TAB.DifaFreteTerceiros, -- Valor DIFA do Frete Terceiros
         TAB.ValorSeguro, -- Valor do Seguro
         TAB.ValorAcrescimos, -- Valor Acrescimos
         TAB.ValorTHC, -- Valor THC
         TAB.ValorAFRMM, -- Valor AFRMM
         TAB.ValorDemurrage, -- Valor Demurrage
         TAB.ValorDesestiva, -- Valro Desestiva
         TAB.ValorDesembaraco, -- Valor Desembarao
         TAB.ValorSiscomex, -- Valor Siscomex
         TAB.ValorPISImport, -- Valro PIS Importao
         TAB.ValorCofinsImport, -- Valro Cofins Importao
         TAB.ValorDespAduaneira, -- Valor Despesa Aduaneira
         TAB.SimboloMoeda, -- Smbolo da Moeda
         TAB.ValorCotacaoMoeda, -- Valor Cotao Moeda
         TAB.DataCotacaoMoeda, -- Data Cotao Moeda
         TAB.CPFCNPJRepresentante, -- CPF ou CNPJ do Representante
         TAB.COO, -- COO Cupom
         TAB.NroECF, -- Nmero do ECF
         TAB.NroSerieECF, -- Nmero de rie do ECF
         TAB.ModeloECF, -- Modelo do ECF
         TAB.MarcaECF, -- Marca do ECF
         TAB.CPFCNPJCupom -- CPF ou CNPJ do cliente no identificado no cupom
     FROM (
   SELECT CCC.CODFIL,
          CCC.SEQUEN,
          CCC.NUMPAR,
          CCC.SUBPAR,
          CAST(NULL AS CHAR(8)) AS NUMPED,
          CAST(NULL AS CHAR(1)) AS TIPPED,
          CAST(NULL AS VARCHAR(3)) AS CODSER, 
          CAST(NULL AS VARCHAR(3)) AS SUBSER, 
          CAST(CCC.NUMECF AS CHAR(3)) AS NUMECF,
          CAST(CCC.SEQUEN AS VARCHAR(10)) AS NUMNOT,
          CAST('CCC' AS VARCHAR(3)) AS ORIGEM,
          CAST('TIMU_DOCUMENTO' AS VARCHAR(50)) AS DESTINO,
          CAST('F' AS CHAR(1)) AS TEM_ITEM,
          CAST('F' AS CHAR(1)) AS TEM_PARCELA,
          CAST('T' AS CHAR(1)) AS TEM_LIQUIDACAO,
          CAST('F' AS CHAR(1)) AS TEM_MOVCONTABIL,
          CAST('F' AS CHAR(1)) AS TEM_CCUSTOCONTABIL,
          CAST('F' AS CHAR(1)) AS TEM_FRETE,
          CAST('T' AS CHAR(1)) AS TEM_OPERACAOFINANCEIRA,
          CAST('F' AS CHAR(1)) AS TEM_CONTAFINANCEIRA,
          CAST('F' AS CHAR(1)) AS TEM_CCUSTOFINANCEIRO,
          CAST('CCC' || CCC.CODFIL || CCC.SEQUEN AS VARCHAR(50)) AS CHAVE,
          (ABS(CCC.VLRLAN)) AS VLRNOT_VALIDACAO, 
          ABS(CCC.VLRLAN) AS VLRLIQ_VALIDACAO,
          CCC.DATINC, 
          CCC.DATINC AS ATU_EM,
          CCC.EXPORT,
          CCC.EXPEM4,
          CCC.DATINC AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
          COALESCE(PAR.NUMDOC, VIN.NUMDOC) AS NUMDOC,
          CCC.DATOPE AS DATAFILTRO,
          -- Tipo de Operao exportado de forma fixa conforme conversado com a EME4
          CAST(CASE WHEN CCC.TIPLAN = 'D' THEN 992 ELSE 993 END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao (992-Deposito / 993-Retirada)
          CAST(TO_NUMBER(CCC.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
          CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                   ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
              END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
          CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
          CAST(CASE WHEN EXISTS(SELECT 1 AS OK 
                                  FROM TT_REL REL 
                                 WHERE REL.FILPAR = CCC.FILCLI 
                                   AND REL.CODPAR = CCC.CODCLI 
                                   AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                    ELSE 'C' 
               END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
          CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
          CAST('CC'||CCC.NUMECF AS VARCHAR(5)) AS Serie, -- Srie do Documento
          CAST(TRIM(CCC.SEQUEN) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
          CAST(TRUNC(CCC.DATOPE) AS Timestamp) AS DataEntrada, -- Data de Entrada
          CAST(TRUNC(CCC.DATOPE) AS Timestamp) AS DataSaida, -- Data de Sada
          CAST(TRUNC(CCC.DATOPE) AS Timestamp) AS DataEntSai, -- Data de Entrada ou Sada
          CAST(TRUNC(CCC.DATOPE) AS Timestamp) AS DataEmissao, -- Data de Emisso
          CAST(ABS(CCC.VLRLAN) AS Numeric(15,2)) AS ValorContabil, -- Valor Contbil Original do Documento (Tesouraria)
          CAST(NULL AS Numeric(15,2)) AS ValorDescontos, -- Valor Desconto dos Produtos
          CAST(NULL AS Numeric(15,2)) AS ValorOutrasDespesas, -- Valor Outras Despesas dos Produtos
          CAST(NULL AS Numeric(15,2)) AS ValorDescontosServ, -- Valor Desconto dos Servios
          CAST(NULL AS Numeric(15,2)) AS ValorOutrasDespesasServ, -- Valor Outras Despesas dos Servios
          CAST(NULL AS VARCHAR(1)) AS SituacaoNFE, -- {3=Autorizada;5=Cancelada;7=Inutilizada;8=Substituida;9=Denegada;A=Contingncia}
          CAST(NULL AS VARCHAR(1)) AS SituacaoDOC, -- {0=Normal;1=Cancelada;2=Devoluo Parcial;3=Devoluo Total;4=Crdito Bloqueado;5=Inadimplncia;6=Cred. Bloq/Inad.;7=Bloqueio nos Itens;8=Faturado;A=Bloq. Val. Parcela;B=Bloq. Val. Min. Venda}
          CAST(NULL AS VARCHAR(50)) AS ObsFiscal, -- Observao Fiscal do Documento
          CAST(NULL AS VARCHAR(150)) AS Observacoes, -- Observaes da Nota
          CAST(NULL AS VARCHAR(4000)) AS InfoComplementares, -- Informaes Complementares da Nota
          CAST(NULL AS VARCHAR(4000)) AS TextoFiscal, -- Texto Fiscal do Documento
          CAST(NULL AS VARCHAR(200)) AS NumPedCliente, -- Nmero do Pedido no Cliente
          CAST(NULL AS VARCHAR(100)) AS NumPedRepresentante, -- Nmero do Pedido no Representante
          CAST(NULL AS VARCHAR(1)) AS IndNaturezaFrete, -- {0=Operaes de vendas, com nus suportado pelo estabelecimento vendedor;1=Operaes de vendas, com nus suportado pelo adquirente;2=Operaes de compras (bens para revenda, matrias prima e outros produtos, geradores de crdito);3=Operaes de compras (bens para revenda, matrias prima e outros produtos, no geradores de crdito);4=Transferncia de produtos acabados entre estabelecimentos da pessoa jurdica;5=Transferncia de produtos entre estabelecimentos da pessoa jurdica;9=Outras}
          CAST(NULL AS VARCHAR(60)) AS ChaveNFE, -- Chave NFE
          CAST(NULL AS VARCHAR(60)) AS ChaveNFERefer, -- Chave NFE Referenciada
          CAST(NULL AS VARCHAR(20)) AS CodContaTes, -- Cdigo da Conta Tesouraria
          -- Justificativa utilizada em Testes de Integrao pela EME4
          CAST('ContaCorrente - Chave: '||CCC.CODFIL||'/'||CCC.SEQUEN AS VARCHAR(200)) AS Justificativa, -- Justificativa do documento Contbil
          --CAST(NULL AS VARCHAR(200)) AS Justificativa, -- Justificativa do documento Contbil
          CAST(NULL AS VARCHAR(1)) AS TipoFrete, -- {F=Por conta do emitente;T=Por conta do destinatrio;A=Por conta de terceiros;B=Sem frete}
          CAST(NULL AS Numeric(9)) AS CodTransportadora, -- Cdigo da Transportadora do Documento
          CAST(NULL AS VARCHAR(18)) AS CpfCnpjTransportadora, -- CPF ou CNPJ da Transportadora do Documento
          CAST(NULL AS VARCHAR(10)) AS PlacaVeiculo, -- Placa do Veculo de Entrega
          CAST(NULL AS Numeric(9)) AS CodTranspRedespacho, -- Cdigo da Transportadora de Redespacho do Documento
          CAST(NULL AS VARCHAR(18)) AS CpfCnpjTranspRedespacho, -- CPF ou CNPJ da Transportadora de Redespacho do Documento
          CAST(NULL AS VARCHAR(2)) AS CodigoModelo, -- Cdigo do Modelo de Documento (01 ou 65)
          CAST(NULL AS VARCHAR(120)) AS LogradouroEnt, -- Logradouro do Endereo de Entrega
          CAST(NULL AS Numeric(10)) AS NumeroEnt, -- Nmero do Endereo de Entrega
          CAST(NULL AS VARCHAR(30)) AS ComplementoEnt, -- Complemento do Endereo de Entrega
          CAST(NULL AS VARCHAR(10)) AS CEPEnt, -- CEP do Endereo de Entrega
          CAST(NULL AS VARCHAR(80)) AS BairroEnt, -- Bairro do Endereo de Entrega
          CAST(NULL AS Numeric(10)) AS CodMunicipioIBGEEnt, -- GeoCodigo do M3 - caso esteja informado dever importar o vnculo do municpio por este cdigo (Endereo)
          CAST(NULL AS VARCHAR(100)) AS CidadeEndEnt, -- Cidade do Endereo de Entrega
          CAST(NULL AS VARCHAR(2)) AS EstadoEnt, -- Estado do Endereo de Entrega
          CAST(NULL AS Numeric(9)) AS CodigoPaisEnt, -- Codigo do Banco Central para o Pais da Cidade de Entrega
          CAST(NULL AS VARCHAR(80)) AS PaisEnt, -- Nome do Pais do Endereo de Entrega
          CAST(NULL AS Numeric(15,2)) AS ValorFrete, -- Valor do Frete
          CAST(NULL AS Numeric(15,2)) AS ValorFreteTerceiros, -- Valor do Frete Terceiros
          CAST(NULL AS Numeric(15,2)) AS ICMSFreteTerceiros, -- Valor ICMS do Frete Terceiros
          CAST(NULL AS Numeric(15,2)) AS DifaFreteTerceiros, -- Valor DIFA do Frete Terceiros
          CAST(NULL AS Numeric(15,2)) AS ValorSeguro, -- Valor do Seguro
          CAST(NULL AS Numeric(15,2)) AS ValorAcrescimos, -- Valor Acrescimos
          -- Valores relativo a Nota de Importao
          CAST(NULL AS Numeric(15,2)) AS ValorTHC, -- Valor THC
          CAST(NULL AS Numeric(15,2)) AS ValorAFRMM, -- Valor AFRMM
          CAST(NULL AS Numeric(15,2)) AS ValorDemurrage, -- Valor Demurrage
          CAST(NULL AS Numeric(15,2)) AS ValorDesestiva, -- Valro Desestiva
          CAST(NULL AS Numeric(15,2)) AS ValorDesembaraco, -- Valor Desembarao
          CAST(NULL AS Numeric(15,2)) AS ValorSiscomex, -- Valor Siscomex
          CAST(NULL AS Numeric(15,2)) AS ValorPISImport, -- Valro PIS Importao
          CAST(NULL AS Numeric(15,2)) AS ValorCofinsImport, -- Valro Cofins Importao
          CAST(NULL AS Numeric(15,2)) AS ValorDespAduaneira, -- Valor Despesa Aduaneira
          CAST(NULL AS VARCHAR(10)) AS SimboloMoeda, -- Smbolo da Moeda
          CAST(NULL AS Numeric(15,4)) AS ValorCotacaoMoeda, -- Valor Cotao Moeda
          CAST(NULL AS Timestamp) AS DataCotacaoMoeda, -- Data Cotao Moeda
          CAST(NULL AS VARCHAR(18)) AS CPFCNPJRepresentante, -- CPF ou CNPJ do Representante
          CAST(NULL AS Numeric(8)) AS COO, -- COO Cupom
          CAST(NULL AS Numeric(8)) AS NroECF, -- Nmero do ECF
          CAST(NULL AS VARCHAR(50)) AS NroSerieECF, -- Nmero de rie do ECF
          CAST(NULL AS VARCHAR(20)) AS ModeloECF, -- Modelo do ECF
          CAST(NULL AS VARCHAR(20)) AS MarcaECF, -- Marca do ECF
          CAST(NULL AS VARCHAR(18)) as CPFCNPJCupom -- CPF ou CNPJ do cliente no identificado no cupom
     FROM TT_CCC CCC
     -- Cliente
     JOIN TT_CLI PAR ON PAR.FILCLI = CCC.FILCLI AND PAR.CODCLI = CCC.CODCLI
     -- Endereo de Faturamento
     LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = CCC.FILCLI AND ENDFAT.CODCLI = CCC.CODCLI
     -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
     LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    WHERE 1=1 
      AND COALESCE(CCC.INDEXP, 'E') <> 'N'
      AND CCC.TIPLAN IN('D','I')
      AND CCC.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',CCC.CODFIL,'','','')
      AND (LeParametroTXT('TIPO_EXP_EME4', CCC.CODFIL, '', '', '') = 'V')
      AND CCC.EXPEM4 = 'F'
      ) TAB 
ORDER BY TAB.CODFIL, TAB.SEQUEN, TAB.DataHoraAtuReg
   ;


-- Autor: Bruno B.
-- Cliente(s): EME4
-- Finalidade(s):
-- 1)Retornar as notas pagas.
-- Arquivo Pai: TIMU_DOCUMENTO
/*-- SEQ 2654 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_DOC_PAGAMENTOS CASCADE;

/*-- SEQ 2655 --*/
CREATE OR REPLACE VIEW TV_TIMU_DOC_PAGAMENTOS AS
   SELECT
         --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
         CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
         CAST(CASE WHEN TAB.ORIGEM = 'LID' THEN CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END
                   WHEN EXISTS(SELECT 1 AS OK FROM TW_EXTXDOC EXD 
                                WHERE EXD.ORIGEM = TAB.ORIGEM AND EXD.DESTINO = TAB.DESTINO
                                  AND EXD.FILORI = TAB.CODFIL AND EXD.SEQORI = TAB.SEQUEN
                                  AND EXD.PARORI = TAB.NUMPAR AND EXD.SUBORI = TAB.SUBPAR) THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
         CAST('T' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
         --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
         CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
         --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
         TAB.CODFIL, TAB.SEQUEN, TAB.NUMPAR, TAB.SUBPAR, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.NUMDOC, TAB.DATAFILTRO, 
         TAB.CODSER, TAB.SUBSER, TAB.NUMECF, TAB.TRN_ID, TAB.NUMNOT, TAB.NUMPED, TAB.TIPPED,
         TAB.TEM_ITEM, TAB.TEM_PARCELA, TAB.TEM_LIQUIDACAO, TAB.TEM_MOVCONTABIL, TAB.TEM_CCUSTOCONTABIL, TAB.TEM_FRETE, TAB.TEM_OPERACAOFINANCEIRA, TAB.TEM_CONTAFINANCEIRA, TAB.TEM_CCUSTOFINANCEIRO, TAB.CHAVE, TAB.VLRNOT_VALIDACAO, TAB.VLRLIQ_VALIDACAO,
         TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
         TAB.TipoOperacao, -- Cdigo do Tipo de Operao
         TAB.Filial, -- Cdigo da Filial
         TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
         TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
         TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
         TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
         TAB.Serie, -- Srie do Documento
         TAB.NumeroDocumento, -- Nmero do documento
         TAB.DataEntrada, -- Data de Entrada
         TAB.DataSaida, -- Data de Sada
         TAB.DataEntSai, -- Data de Entrada ou Sada
         TAB.DataEmissao, -- Data de Emisso
         TAB.ValorContabil, -- Valor Contbil Original do Documento (Tesouraria)
         TAB.ValorDescontos, -- Valor Desconto dos Produtos
         TAB.ValorOutrasDespesas, -- Valor Outras Despesas dos Produtos
         TAB.ValorDescontosServ, -- Valor Desconto dos Servios
         TAB.ValorOutrasDespesasServ, -- Valor Outras Despesas dos Servios
         TAB.SituacaoNFE, -- {3=Autorizada;5=Cancelada;7=Inutilizada;8=Substituida;9=Denegada;A=Contingncia}
         TAB.SituacaoDOC, -- {0=Normal;1=Cancelada;2=Devoluo Parcial;3=Devoluo Total;4=Crdito Bloqueado;5=Inadimplncia;6=Cred. Bloq/Inad.;7=Bloqueio nos Itens;8=Faturado;A=Bloq. Val. Parcela;B=Bloq. Val. Min. Venda}
         TAB.ObsFiscal, -- Observao Fiscal do Documento
         TAB.Observacoes, -- Observaes da Nota
         TAB.InfoComplementares, -- Informaes Complementares da Nota
         TAB.TextoFiscal, -- Texto Fiscal do Documento
         TAB.NumPedCliente, -- Nmero do Pedido no Cliente
         TAB.NumPedRepresentante, -- Nmero do Pedido no Representante
         TAB.IndNaturezaFrete, -- {0=Operaes de vendas, com nus suportado pelo estabelecimento vendedor;1=Operaes de vendas, com nus suportado pelo adquirente;2=Operaes de compras (bens para revenda, matrias prima e outros produtos, geradores de crdito);3=Operaes de compras (bens para revenda, matrias prima e outros produtos, no geradores de crdito);4=Transferncia de produtos acabados entre estabelecimentos da pessoa jurdica;5=Transferncia de produtos entre estabelecimentos da pessoa jurdica;9=Outras}
         TAB.ChaveNFE, -- Chave NFE
         TAB.ChaveNFERefer, -- Chave NFE Referenciada
         TAB.CodContaTes, -- Cdigo da Conta Tesouraria
         TAB.Justificativa, -- Justificativa do documento Contbil
         TAB.TipoFrete, -- {F=Por conta do emitente;T=Por conta do destinatrio;A=Por conta de terceiros;B=Sem frete}
         TAB.CodTransportadora, -- Cdigo da Transportadora do Documento
         TAB.CpfCnpjTransportadora, -- CPF ou CNPJ da Transportadora do Documento
         TAB.PlacaVeiculo, -- Placa do Veculo de Entrega
         TAB.CodTranspRedespacho, -- Cdigo da Transportadora de Redespacho do Documento
         TAB.CpfCnpjTranspRedespacho, -- CPF ou CNPJ da Transportadora de Redespacho do Documento
         TAB.CodigoModelo, -- Cdigo do Modelo de Documento (01 ou 65)
         TAB.LogradouroEnt, -- Logradouro do Endereo de Entrega
         TAB.NumeroEnt, -- Nmero do Endereo de Entrega
         TAB.ComplementoEnt, -- Complemento do Endereo de Entrega
         TAB.CEPEnt, -- CEP do Endereo de Entrega
         TAB.CodMunicipioIBGEEnt, -- GeoCodigo do M3 - caso esteja informado dever importar o vnculo do municpio por este cdigo (Endereo)
         TAB.CidadeEndEnt, -- Cidade do Endereo de Entrega
         TAB.BairroEnt, -- Bairro do Endereo de Entrega
         TAB.EstadoEnt, -- Estado do Endereo de Entrega
         TAB.CodigoPaisEnt, -- Codigo do Banco Central para o Pais da Cidade de Entrega
         TAB.PaisEnt, -- Nome do Pais do Endereo de Entrega
         TAB.ValorFrete, -- Valor do Frete
         TAB.ValorFreteTerceiros, -- Valor do Frete Terceiros
         TAB.ICMSFreteTerceiros, -- Valor ICMS do Frete Terceiros
         TAB.DifaFreteTerceiros, -- Valor DIFA do Frete Terceiros
         TAB.ValorSeguro, -- Valor do Seguro
         TAB.ValorAcrescimos, -- Valor Acrescimos
         TAB.ValorTHC, -- Valor THC
         TAB.ValorAFRMM, -- Valor AFRMM
         TAB.ValorDemurrage, -- Valor Demurrage
         TAB.ValorDesestiva, -- Valro Desestiva
         TAB.ValorDesembaraco, -- Valor Desembarao
         TAB.ValorSiscomex, -- Valor Siscomex
         TAB.ValorPISImport, -- Valro PIS Importao
         TAB.ValorCofinsImport, -- Valro Cofins Importao
         TAB.ValorDespAduaneira, -- Valor Despesa Aduaneira
         TAB.SimboloMoeda, -- Smbolo da Moeda
         TAB.ValorCotacaoMoeda, -- Valor Cotao Moeda
         TAB.DataCotacaoMoeda, -- Data Cotao Moeda
         TAB.CPFCNPJRepresentante, -- CPF ou CNPJ do Representante
         TAB.COO, -- COO Cupom
         TAB.NroECF, -- Nmero do ECF
         TAB.NroSerieECF, -- Nmero de rie do ECF
         TAB.ModeloECF, -- Modelo do ECF
         TAB.MarcaECF, -- Marca do ECF
         TAB.CPFCNPJCupom -- CPF ou CNPJ do cliente no identificado no cupom
     FROM (
   SELECT LID.CODFIL,
          LID.TRN_ID,
          CAST(LPAD(TO_CHAR(LID.TRN_ID), 10, ' ') AS CHAR(10)) AS SEQUEN, -- REC.SEQUEN
          CAST(' 0' AS CHAR(2)) AS NUMPAR,
          CAST(' 0' AS CHAR(2)) AS SUBPAR,
          CAST(NULL AS CHAR(8)) AS NUMPED,
          CAST(NULL AS CHAR(1)) AS TIPPED,
          CAST('999' AS VARCHAR(3)) AS CODSER, CAST(NULL AS VARCHAR(3)) AS SUBSER, CAST(LID.NUMECF AS CHAR(3)) AS NUMECF, CAST(LID.CUPFIS AS VARCHAR(10)) AS NUMNOT,
          CAST('LID' AS VARCHAR(3)) AS ORIGEM,
          CAST('TIMU_DOCUMENTO' AS VARCHAR(50)) AS DESTINO,
          CAST('F' AS CHAR(1)) AS TEM_ITEM,
          CAST('F' AS CHAR(1)) AS TEM_PARCELA,
          CAST('T' AS CHAR(1)) AS TEM_LIQUIDACAO,
          CAST('F' AS CHAR(1)) AS TEM_MOVCONTABIL,
          CAST('F' AS CHAR(1)) AS TEM_CCUSTOCONTABIL,
          CAST('F' AS CHAR(1)) AS TEM_FRETE,
          CAST('T' AS CHAR(1)) AS TEM_OPERACAOFINANCEIRA,
          CAST('F' AS CHAR(1)) AS TEM_CONTAFINANCEIRA,
          CAST('F' AS CHAR(1)) AS TEM_CCUSTOFINANCEIRO,
          CAST('PGT' || LID.CODFIL|| TO_CHAR(LID.TRN_ID) || LID.NUMECF || LID.CUPFIS AS VARCHAR(50)) AS CHAVE,
          ABS(LID.VLROPE) AS VLRNOT_VALIDACAO, 
          ABS(LID.VLROPE) AS VLRLIQ_VALIDACAO,
          LID.DATHOR AS DATINC, 
          CASE WHEN LID.EXPEM4='F' THEN Agora() ELSE LID.DATEXE END AS ATU_EM,
          LID.EXPEM4 AS EXPORT,
          LID.EXPEM4,
          --REC.EXPEM4,
          LID.DATEXE AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
          COALESCE(PAR.NUMDOC, VIN.NUMDOC) AS NUMDOC,
          LID.DATHOR AS DATAFILTRO,
          -- Tipo de Operao exportado de forma fixa conforme conversado com a EME4
          CAST(999 AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
          CAST(TO_NUMBER(LID.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
          CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                   ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
              END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
          CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
          CAST(CASE WHEN EXISTS(SELECT 1 AS OK 
                                  FROM TT_REL REL 
                                 WHERE REL.FILPAR = VEN.FILCLI 
                                   AND REL.CODPAR = VEN.CODCLI 
                                   AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                    ELSE 'C' 
               END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
          CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
          CAST('PG'|| LID.NUMECF AS VARCHAR(5)) AS Serie, -- Srie do Documento
          CAST(LID.TRN_ID AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
         --CAST(LPAD(TRIM(VEN.NUMNOT), 6, '0')||LPAD(TRIM(REC.NUMPAR), 2, '0')||LPAD(TRIM(REC.SUBPAR), 2, '0') AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
          CAST(TRUNC(LID.DATHOR) AS Timestamp) AS DataEntrada, -- Data de Entrada
          CAST(TRUNC(LID.DATHOR) AS Timestamp) AS DataSaida, -- Data de Sada
          CAST(TRUNC(LID.DATHOR) AS Timestamp) AS DataEntSai, -- Data de Entrada ou Sada
          CAST(TRUNC(LID.DATHOR) AS Timestamp) AS DataEmissao, -- Data de Emisso
          CAST(ABS(LID.VLROPE) AS Numeric(15,2)) AS ValorContabil, -- Valor Contbil Original do Documento (Tesouraria)
          CAST(NULL AS Numeric(15,2)) AS ValorDescontos, -- Valor Desconto dos Produtos
          CAST(NULL AS Numeric(15,2)) AS ValorOutrasDespesas, -- Valor Outras Despesas dos Produtos
          CAST(NULL AS Numeric(15,2)) AS ValorDescontosServ, -- Valor Desconto dos Servios
          CAST(NULL AS Numeric(15,2)) AS ValorOutrasDespesasServ, -- Valor Outras Despesas dos Servios
          CAST(NULL AS VARCHAR(1)) AS SituacaoNFE, -- {3=Autorizada;5=Cancelada;7=Inutilizada;8=Substituida;9=Denegada;A=Contingncia}
          CAST(NULL AS VARCHAR(1)) AS SituacaoDOC, -- {0=Normal;1=Cancelada;2=Devoluo Parcial;3=Devoluo Total;4=Crdito Bloqueado;5=Inadimplncia;6=Cred. Bloq/Inad.;7=Bloqueio nos Itens;8=Faturado;A=Bloq. Val. Parcela;B=Bloq. Val. Min. Venda}
          CAST(NULL AS VARCHAR(50)) AS ObsFiscal, -- Observao Fiscal do Documento
          CAST(NULL AS VARCHAR(150)) AS Observacoes, -- Observaes da Nota
          CAST(NULL AS VARCHAR(4000)) AS InfoComplementares, -- Informaes Complementares da Nota
          CAST(NULL AS VARCHAR(4000)) AS TextoFiscal, -- Texto Fiscal do Documento
          CAST(NULL AS VARCHAR(200)) AS NumPedCliente, -- Nmero do Pedido no Cliente
          CAST(NULL AS VARCHAR(100)) AS NumPedRepresentante, -- Nmero do Pedido no Representante
          CAST(NULL AS VARCHAR(1)) AS IndNaturezaFrete, -- {0=Operaes de vendas, com nus suportado pelo estabelecimento vendedor;1=Operaes de vendas, com nus suportado pelo adquirente;2=Operaes de compras (bens para revenda, matrias prima e outros produtos, geradores de crdito);3=Operaes de compras (bens para revenda, matrias prima e outros produtos, no geradores de crdito);4=Transferncia de produtos acabados entre estabelecimentos da pessoa jurdica;5=Transferncia de produtos entre estabelecimentos da pessoa jurdica;9=Outras}
          CAST(NULL AS VARCHAR(60)) AS ChaveNFE, -- Chave NFE
          CAST(NULL AS VARCHAR(60)) AS ChaveNFERefer, -- Chave NFE Referenciada
          CAST(NULL AS VARCHAR(20)) AS CodContaTes, -- Cdigo da Conta Tesouraria
          -- Justificativa utilizada em Testes de Integrao pela EME4
          CAST('Pagamentos - Chave: '||LID.CODFIL||'/'||TO_CHAR(LID.TRN_ID)||'-'||LID.NUMECF||'-'||LID.CUPFIS AS VARCHAR(200)) AS Justificativa, -- Justificativa do documento Contbil
          --CAST(NULL AS VARCHAR(200)) AS Justificativa, -- Justificativa do documento Contbil
          CAST(NULL AS VARCHAR(1)) AS TipoFrete, -- {F=Por conta do emitente;T=Por conta do destinatrio;A=Por conta de terceiros;B=Sem frete}
          CAST(NULL AS Numeric(9)) AS CodTransportadora, -- Cdigo da Transportadora do Documento
          CAST(NULL AS VARCHAR(18)) AS CpfCnpjTransportadora, -- CPF ou CNPJ da Transportadora do Documento
          CAST(NULL AS VARCHAR(10)) AS PlacaVeiculo, -- Placa do Veculo de Entrega
          CAST(NULL AS Numeric(9)) AS CodTranspRedespacho, -- Cdigo da Transportadora de Redespacho do Documento
          CAST(NULL AS VARCHAR(18)) AS CpfCnpjTranspRedespacho, -- CPF ou CNPJ da Transportadora de Redespacho do Documento
          CAST(NULL AS VARCHAR(2)) AS CodigoModelo, -- Cdigo do Modelo de Documento (01 ou 65)
          CAST(NULL AS VARCHAR(120)) AS LogradouroEnt, -- Logradouro do Endereo de Entrega
          CAST(NULL AS Numeric(10)) AS NumeroEnt, -- Nmero do Endereo de Entrega
          CAST(NULL AS VARCHAR(30)) AS ComplementoEnt, -- Complemento do Endereo de Entrega
          CAST(NULL AS VARCHAR(10)) AS CEPEnt, -- CEP do Endereo de Entrega
          CAST(NULL AS VARCHAR(80)) AS BairroEnt, -- Bairro do Endereo de Entrega
          CAST(NULL AS Numeric(10)) AS CodMunicipioIBGEEnt, -- GeoCodigo do M3 - caso esteja informado dever importar o vnculo do municpio por este cdigo (Endereo)
          CAST(NULL AS VARCHAR(100)) AS CidadeEndEnt, -- Cidade do Endereo de Entrega
          CAST(NULL AS VARCHAR(2)) AS EstadoEnt, -- Estado do Endereo de Entrega
          CAST(NULL AS Numeric(9)) AS CodigoPaisEnt, -- Codigo do Banco Central para o Pais da Cidade de Entrega
          CAST(NULL AS VARCHAR(80)) AS PaisEnt, -- Nome do Pais do Endereo de Entrega
          CAST(NULL AS Numeric(15,2)) AS ValorFrete, -- Valor do Frete
          CAST(NULL AS Numeric(15,2)) AS ValorFreteTerceiros, -- Valor do Frete Terceiros
          CAST(NULL AS Numeric(15,2)) AS ICMSFreteTerceiros, -- Valor ICMS do Frete Terceiros
          CAST(NULL AS Numeric(15,2)) AS DifaFreteTerceiros, -- Valor DIFA do Frete Terceiros
          CAST(NULL AS Numeric(15,2)) AS ValorSeguro, -- Valor do Seguro
          CAST(NULL AS Numeric(15,2)) AS ValorAcrescimos, -- Valor Acrescimos
          -- Valores relativo a Nota de Importao
          CAST(NULL AS Numeric(15,2)) AS ValorTHC, -- Valor THC
          CAST(NULL AS Numeric(15,2)) AS ValorAFRMM, -- Valor AFRMM
          CAST(NULL AS Numeric(15,2)) AS ValorDemurrage, -- Valor Demurrage
          CAST(NULL AS Numeric(15,2)) AS ValorDesestiva, -- Valro Desestiva
          CAST(NULL AS Numeric(15,2)) AS ValorDesembaraco, -- Valor Desembarao
          CAST(NULL AS Numeric(15,2)) AS ValorSiscomex, -- Valor Siscomex
          CAST(NULL AS Numeric(15,2)) AS ValorPISImport, -- Valro PIS Importao
          CAST(NULL AS Numeric(15,2)) AS ValorCofinsImport, -- Valro Cofins Importao
          CAST(NULL AS Numeric(15,2)) AS ValorDespAduaneira, -- Valor Despesa Aduaneira
          CAST(NULL AS VARCHAR(10)) AS SimboloMoeda, -- Smbolo da Moeda
          CAST(NULL AS Numeric(15,4)) AS ValorCotacaoMoeda, -- Valor Cotao Moeda
          CAST(NULL AS Timestamp) AS DataCotacaoMoeda, -- Data Cotao Moeda
          CAST(NULL AS VARCHAR(18)) AS CPFCNPJRepresentante, -- CPF ou CNPJ do Representante
          CAST(NULL AS Numeric(8)) AS COO, -- COO Cupom
          CAST(NULL AS Numeric(8)) AS NroECF, -- Nmero do ECF
          CAST(NULL AS VARCHAR(50)) AS NroSerieECF, -- Nmero de rie do ECF
          CAST(NULL AS VARCHAR(20)) AS ModeloECF, -- Modelo do ECF
          CAST(NULL AS VARCHAR(20)) AS MarcaECF, -- Marca do ECF
          CAST(NULL AS VARCHAR(18)) as CPFCNPJCupom -- CPF ou CNPJ do cliente no identificado no cupom
     FROM (
            SELECT LD.CODFIL, LD.NUMECF, LD.TRN_ID, LD.CUPFIS, LD.DATHOR, LD.DATEXE, LD.VLROPE, LD.EXPEM4,
                   MIN(OPE.FILREC||OPE.SEQREC) as PARCELA
              FROM TT_LID LD
              JOIN (SELECT OP.CODFIL, OP.NUMECF, OP.TRN_ID, OP.CUPFIS, OP.FILREC, OP.SEQREC 
                      FROM TT_OPE OP
                     WHERE OP.MEIPGT = 'F'
                       AND OP.FILREC IS NOT NULL
                    ) OPE ON OPE.CODFIL = LD.CODFIL AND OPE.NUMECF = LD.NUMECF
                         AND OPE.TRN_ID = LD.TRN_ID AND OPE.CUPFIS = LD.CUPFIS
             WHERE LD.TIPOPE = 'RECDEBITO'
               AND LD.EXPEM4 = 'F'
               AND LD.VLROPE > 0
             GROUP BY LD.CODFIL, LD.NUMECF, LD.TRN_ID, LD.CUPFIS, LD.DATHOR, LD.DATEXE, LD.VLROPE, LD.EXPEM4
          ) LID
     JOIN TT_VEN VEN ON VEN.CODFIL = SUBSTR(LID.PARCELA,1,3) AND VEN.SEQUEN = SUBSTR(LID.PARCELA,4,10)
     -- Cliente
     JOIN TT_CLI PAR ON PAR.FILCLI = VEN.FILCLI AND PAR.CODCLI = VEN.CODCLI
     --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
     -- Endereo de Faturamento
     LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = VEN.FILCLI AND ENDFAT.CODCLI = VEN.CODCLI AND ENDFAT.CODFIL = VEN.FILFAT AND ENDFAT.NUMEND = VEN.ENDFAT
     -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
     LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    WHERE 1=1
      AND LID.DATHOR >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',LID.CODFIL,'','','')
      AND (LeParametroTXT('TIPO_EXP_EME4', LID.CODFIL, '', '', '') = 'V')
      --AND LID.EXPEM4 = 'F'
   UNION ALL
   SELECT REC.CODFIL,
          CAST(NULL AS Numeric(10)) AS TRN_ID,
          REC.SEQUEN,
          REC.NUMPAR,
          REC.SUBPAR,
          CAST(NULL AS CHAR(8)) AS NUMPED,
          CAST(NULL AS CHAR(1)) AS TIPPED,
          CAST(VEN.CODSER AS VARCHAR(3)) AS CODSER, CAST(NULL AS VARCHAR(3)) AS SUBSER, CAST(VEN.NUMECF AS CHAR(3)) AS NUMECF, CAST(VEN.NUMNOT AS VARCHAR(10)) AS NUMNOT,
          CAST('PGT' AS VARCHAR(3)) AS ORIGEM,
          CAST('TIMU_DOCUMENTO' AS VARCHAR(50)) AS DESTINO,
          CAST('F' AS CHAR(1)) AS TEM_ITEM,
          CAST('F' AS CHAR(1)) AS TEM_PARCELA,
          CAST('T' AS CHAR(1)) AS TEM_LIQUIDACAO,
          CAST('F' AS CHAR(1)) AS TEM_MOVCONTABIL,
          CAST('F' AS CHAR(1)) AS TEM_CCUSTOCONTABIL,
          CAST('F' AS CHAR(1)) AS TEM_FRETE,
          CAST('T' AS CHAR(1)) AS TEM_OPERACAOFINANCEIRA,
          CAST('F' AS CHAR(1)) AS TEM_CONTAFINANCEIRA,
          CAST('F' AS CHAR(1)) AS TEM_CCUSTOFINANCEIRO,
          CAST('PGT' || REC.CODFIL || REC.SEQUEN || REC.NUMPAR || REC.SUBPAR AS VARCHAR(50)) AS CHAVE,
          (ABS(REC.VLRPGT) + COALESCE(ABS(REC.VLRTAX),0)) AS VLRNOT_VALIDACAO, ABS(REC.VLRPGT) AS VLRLIQ_VALIDACAO,
          REC.PAGAME AS DATINC,
          REC.ATU_EM,
          REC.EXPORT,
          REC.EXPORT AS EXPEM4,
          --REC.EXPEM4,
          REC.ATU_EM AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
          COALESCE(PAR.NUMDOC, VIN.NUMDOC) AS NUMDOC,
          REC.PAGAME AS DATAFILTRO,
          -- Tipo de Operao exportado de forma fixa conforme conversado com a EME4
          CAST(999 AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
          CAST(TO_NUMBER(REC.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
          CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                   ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
              END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
          CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
          CAST(CASE WHEN EXISTS(SELECT 1 AS OK 
                                  FROM TT_REL REL 
                                 WHERE REL.FILPAR = VEN.FILCLI 
                                   AND REL.CODPAR = VEN.CODCLI 
                                   AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                    ELSE 'C' 
               END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
          CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
          CAST('PG'||CASE WHEN VEN.CODSER <> 'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN LPAD(TRIM(DSER.SEREXT), 3, '0')
                          ELSE VEN.NUMECF
                     END AS VARCHAR(5)) AS Serie, -- Srie do Documento
          CAST(LPAD(TRIM(VEN.NUMNOT), 6, '0') AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
         --CAST(LPAD(TRIM(VEN.NUMNOT), 6, '0')||LPAD(TRIM(REC.NUMPAR), 2, '0')||LPAD(TRIM(REC.SUBPAR), 2, '0') AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
          CAST(TRUNC(REC.PAGAME) AS Timestamp) AS DataEntrada, -- Data de Entrada
          CAST(TRUNC(REC.PAGAME) AS Timestamp) AS DataSaida, -- Data de Sada
          CAST(TRUNC(REC.PAGAME) AS Timestamp) AS DataEntSai, -- Data de Entrada ou Sada
          CAST(TRUNC(REC.PAGAME) AS Timestamp) AS DataEmissao, -- Data de Emisso
          CAST(ABS(REC.VLRPGT) + COALESCE(ABS(REC.VLRTAX),0) AS Numeric(15,2)) AS ValorContabil, -- Valor Contbil Original do Documento (Tesouraria)
          CAST(NULL AS Numeric(15,2)) AS ValorDescontos, -- Valor Desconto dos Produtos
          CAST(NULL AS Numeric(15,2)) AS ValorOutrasDespesas, -- Valor Outras Despesas dos Produtos
          CAST(NULL AS Numeric(15,2)) AS ValorDescontosServ, -- Valor Desconto dos Servios
          CAST(NULL AS Numeric(15,2)) AS ValorOutrasDespesasServ, -- Valor Outras Despesas dos Servios
          CAST(NULL AS VARCHAR(1)) AS SituacaoNFE, -- {3=Autorizada;5=Cancelada;7=Inutilizada;8=Substituida;9=Denegada;A=Contingncia}
          CAST(NULL AS VARCHAR(1)) AS SituacaoDOC, -- {0=Normal;1=Cancelada;2=Devoluo Parcial;3=Devoluo Total;4=Crdito Bloqueado;5=Inadimplncia;6=Cred. Bloq/Inad.;7=Bloqueio nos Itens;8=Faturado;A=Bloq. Val. Parcela;B=Bloq. Val. Min. Venda}
          CAST(NULL AS VARCHAR(50)) AS ObsFiscal, -- Observao Fiscal do Documento
          CAST(NULL AS VARCHAR(150)) AS Observacoes, -- Observaes da Nota
          CAST(NULL AS VARCHAR(4000)) AS InfoComplementares, -- Informaes Complementares da Nota
          CAST(NULL AS VARCHAR(4000)) AS TextoFiscal, -- Texto Fiscal do Documento
          CAST(NULL AS VARCHAR(200)) AS NumPedCliente, -- Nmero do Pedido no Cliente
          CAST(NULL AS VARCHAR(100)) AS NumPedRepresentante, -- Nmero do Pedido no Representante
          CAST(NULL AS VARCHAR(1)) AS IndNaturezaFrete, -- {0=Operaes de vendas, com nus suportado pelo estabelecimento vendedor;1=Operaes de vendas, com nus suportado pelo adquirente;2=Operaes de compras (bens para revenda, matrias prima e outros produtos, geradores de crdito);3=Operaes de compras (bens para revenda, matrias prima e outros produtos, no geradores de crdito);4=Transferncia de produtos acabados entre estabelecimentos da pessoa jurdica;5=Transferncia de produtos entre estabelecimentos da pessoa jurdica;9=Outras}
          CAST(NULL AS VARCHAR(60)) AS ChaveNFE, -- Chave NFE
          CAST(NULL AS VARCHAR(60)) AS ChaveNFERefer, -- Chave NFE Referenciada
          CAST(NULL AS VARCHAR(20)) AS CodContaTes, -- Cdigo da Conta Tesouraria
          -- Justificativa utilizada em Testes de Integrao pela EME4
          CAST('Pagamentos - Chave: '||REC.CODFIL||'/'||REC.SEQUEN||'-'||REC.NUMPAR||'-'||REC.SUBPAR AS VARCHAR(200)) AS Justificativa, -- Justificativa do documento Contbil
          --CAST(NULL AS VARCHAR(200)) AS Justificativa, -- Justificativa do documento Contbil
          CAST(NULL AS VARCHAR(1)) AS TipoFrete, -- {F=Por conta do emitente;T=Por conta do destinatrio;A=Por conta de terceiros;B=Sem frete}
          CAST(NULL AS Numeric(9)) AS CodTransportadora, -- Cdigo da Transportadora do Documento
          CAST(NULL AS VARCHAR(18)) AS CpfCnpjTransportadora, -- CPF ou CNPJ da Transportadora do Documento
          CAST(NULL AS VARCHAR(10)) AS PlacaVeiculo, -- Placa do Veculo de Entrega
          CAST(NULL AS Numeric(9)) AS CodTranspRedespacho, -- Cdigo da Transportadora de Redespacho do Documento
          CAST(NULL AS VARCHAR(18)) AS CpfCnpjTranspRedespacho, -- CPF ou CNPJ da Transportadora de Redespacho do Documento
          CAST(NULL AS VARCHAR(2)) AS CodigoModelo, -- Cdigo do Modelo de Documento (01 ou 65)
          CAST(NULL AS VARCHAR(120)) AS LogradouroEnt, -- Logradouro do Endereo de Entrega
          CAST(NULL AS Numeric(10)) AS NumeroEnt, -- Nmero do Endereo de Entrega
          CAST(NULL AS VARCHAR(30)) AS ComplementoEnt, -- Complemento do Endereo de Entrega
          CAST(NULL AS VARCHAR(10)) AS CEPEnt, -- CEP do Endereo de Entrega
          CAST(NULL AS VARCHAR(80)) AS BairroEnt, -- Bairro do Endereo de Entrega
          CAST(NULL AS Numeric(10)) AS CodMunicipioIBGEEnt, -- GeoCodigo do M3 - caso esteja informado dever importar o vnculo do municpio por este cdigo (Endereo)
          CAST(NULL AS VARCHAR(100)) AS CidadeEndEnt, -- Cidade do Endereo de Entrega
          CAST(NULL AS VARCHAR(2)) AS EstadoEnt, -- Estado do Endereo de Entrega
          CAST(NULL AS Numeric(9)) AS CodigoPaisEnt, -- Codigo do Banco Central para o Pais da Cidade de Entrega
          CAST(NULL AS VARCHAR(80)) AS PaisEnt, -- Nome do Pais do Endereo de Entrega
          CAST(NULL AS Numeric(15,2)) AS ValorFrete, -- Valor do Frete
          CAST(NULL AS Numeric(15,2)) AS ValorFreteTerceiros, -- Valor do Frete Terceiros
          CAST(NULL AS Numeric(15,2)) AS ICMSFreteTerceiros, -- Valor ICMS do Frete Terceiros
          CAST(NULL AS Numeric(15,2)) AS DifaFreteTerceiros, -- Valor DIFA do Frete Terceiros
          CAST(NULL AS Numeric(15,2)) AS ValorSeguro, -- Valor do Seguro
          CAST(NULL AS Numeric(15,2)) AS ValorAcrescimos, -- Valor Acrescimos
          -- Valores relativo a Nota de Importao
          CAST(NULL AS Numeric(15,2)) AS ValorTHC, -- Valor THC
          CAST(NULL AS Numeric(15,2)) AS ValorAFRMM, -- Valor AFRMM
          CAST(NULL AS Numeric(15,2)) AS ValorDemurrage, -- Valor Demurrage
          CAST(NULL AS Numeric(15,2)) AS ValorDesestiva, -- Valro Desestiva
          CAST(NULL AS Numeric(15,2)) AS ValorDesembaraco, -- Valor Desembarao
          CAST(NULL AS Numeric(15,2)) AS ValorSiscomex, -- Valor Siscomex
          CAST(NULL AS Numeric(15,2)) AS ValorPISImport, -- Valro PIS Importao
          CAST(NULL AS Numeric(15,2)) AS ValorCofinsImport, -- Valro Cofins Importao
          CAST(NULL AS Numeric(15,2)) AS ValorDespAduaneira, -- Valor Despesa Aduaneira
          CAST(NULL AS VARCHAR(10)) AS SimboloMoeda, -- Smbolo da Moeda
          CAST(NULL AS Numeric(15,4)) AS ValorCotacaoMoeda, -- Valor Cotao Moeda
          CAST(NULL AS Timestamp) AS DataCotacaoMoeda, -- Data Cotao Moeda
          CAST(NULL AS VARCHAR(18)) AS CPFCNPJRepresentante, -- CPF ou CNPJ do Representante
          CAST(NULL AS Numeric(8)) AS COO, -- COO Cupom
          CAST(NULL AS Numeric(8)) AS NroECF, -- Nmero do ECF
          CAST(NULL AS VARCHAR(50)) AS NroSerieECF, -- Nmero de rie do ECF
          CAST(NULL AS VARCHAR(20)) AS ModeloECF, -- Modelo do ECF
          CAST(NULL AS VARCHAR(20)) AS MarcaECF, -- Marca do ECF
          CAST(NULL AS VARCHAR(18)) as CPFCNPJCupom -- CPF ou CNPJ do cliente no identificado no cupom
     FROM TT_REC REC
     JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
     -- Srie de Emisso
     JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
     -- Plano 
     JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT AND PLA.CODPGT = VEN.CODPGT
     -- Cliente
     JOIN TT_CLI PAR ON PAR.FILCLI = VEN.FILCLI AND PAR.CODCLI = VEN.CODCLI
     --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
     -- Endereo de Faturamento
     LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = VEN.FILCLI AND ENDFAT.CODCLI = VEN.CODCLI AND ENDFAT.CODFIL = VEN.FILFAT AND ENDFAT.NUMEND = VEN.ENDFAT
     -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
     LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    WHERE 1=1 --REC.SUBPAR = ' 0' -- No trata Sub-Parcela 0 pois operao de recebimento pode ocorrer com todas as operaes
      AND VEN.NUMNOT NOT LIKE '%#%'
      AND REC.FLGEST = 'P'
      AND REC.AVISTA = 'F'
      AND COALESCE(REC.INDEXP, 'E') <> 'N'
      AND REC.PAGAME >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',REC.CODFIL,'','','')
      AND (LeParametroTXT('TIPO_EXP_EME4', REC.CODFIL, '', '', '') = 'V')
      --AND LID.EXPEM4 = 'F'
      AND NOT EXISTS (SELECT 1 AS OK 
                        FROM TT_OPE OPE
                        JOIN TT_LID LID ON LID.CODFIL = OPE.CODFIL AND LID.NUMECF = OPE.NUMECF 
                                       AND LID.TRN_ID = OPE.TRN_ID AND LID.CUPFIS = OPE.CUPFIS
                       WHERE LID.TIPOPE = 'RECDEBITO'
                         AND OPE.FILREC = REC.CODFIL AND OPE.SEQREC = REC.SEQUEN
                         AND OPE.NUMPAR = REC.NUMPAR AND OPE.SUBPAR = REC.SUBPAR)
      AND NOT EXISTS ( SELECT 1 AS OK 
                         FROM TW_EXTXDOC EXD 
                        WHERE EXD.ORIGEM = ORIGEM AND EXD.DESTINO = DESTINO
                          AND EXD.FILORI = REC.CODFIL AND EXD.SEQORI = REC.SEQUEN
                          AND EXD.PARORI = REC.NUMPAR AND EXD.SUBORI = REC.SUBPAR )
            --OR (TAB.EXPORT = 'F') -- No considera o TT_REC.EXPORT pois o registro  marcardo em varias operaes
   UNION ALL
   SELECT REC.CODFIL,
          CAST(NULL AS Numeric(10)) AS TRN_ID,
          REC.SEQUEN,
          REC.NUMPAR,
          REC.SUBPAR,
          CAST(NULL AS CHAR(8)) AS NUMPED,
          CAST(NULL AS CHAR(1)) AS TIPPED,
          CAST(VEN.CODSER AS VARCHAR(3)) AS CODSER, CAST(NULL AS VARCHAR(3)) AS SUBSER, CAST(VEN.NUMECF AS CHAR(3)) AS NUMECF, CAST(VEN.NUMNOT AS VARCHAR(10)) AS NUMNOT,
          CAST('PGT' AS VARCHAR(3)) AS ORIGEM,
          CAST('TIMU_DOCUMENTO' AS VARCHAR(50)) AS DESTINO,
          CAST('F' AS CHAR(1)) AS TEM_ITEM,
          CAST('F' AS CHAR(1)) AS TEM_PARCELA,
          CAST('T' AS CHAR(1)) AS TEM_LIQUIDACAO,
          CAST('F' AS CHAR(1)) AS TEM_MOVCONTABIL,
          CAST('F' AS CHAR(1)) AS TEM_CCUSTOCONTABIL,
          CAST('F' AS CHAR(1)) AS TEM_FRETE,
          CAST('T' AS CHAR(1)) AS TEM_OPERACAOFINANCEIRA,
          CAST('F' AS CHAR(1)) AS TEM_CONTAFINANCEIRA,
          CAST('F' AS CHAR(1)) AS TEM_CCUSTOFINANCEIRO,
          CAST('PGT' || REC.CODFIL || REC.SEQUEN || REC.NUMPAR || REC.SUBPAR AS VARCHAR(50)) AS CHAVE,
          (ABS(REC.VLRPGT) + COALESCE(ABS(REC.VLRTAX),0)) AS VLRNOT_VALIDACAO, ABS(REC.VLRPGT) AS VLRLIQ_VALIDACAO,
          REC.PAGAME AS DATINC, 
          REC.ATU_EM,
          REC.EXPORT,
          REC.EXPORT AS EXPEM4,
          --REC.EXPEM4,
          REC.ATU_EM AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
          COALESCE(PAR.NUMDOC, VIN.NUMDOC) AS NUMDOC,
          REC.PAGAME AS DATAFILTRO,
          -- Tipo de Operao exportado de forma fixa conforme conversado com a EME4
          CAST(999 AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
          CAST(TO_NUMBER(VEN.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
          CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                   ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
              END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
          CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
          CAST(CASE WHEN EXISTS(SELECT 1 AS OK 
                                  FROM TT_REL REL 
                                 WHERE REL.FILPAR = VEN.FILCLI 
                                   AND REL.CODPAR = VEN.CODCLI 
                                   AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                    ELSE 'C' 
               END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
          CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
          CAST('PG'||CASE WHEN VEN.CODSER <> 'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN LPAD(TRIM(DSER.SEREXT), 3, '0')
                          ELSE VEN.NUMECF
                     END AS VARCHAR(5)) AS Serie, -- Srie do Documento
         CAST(LPAD(TRIM(VEN.NUMNOT), 6, '0') AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
          --CAST(LPAD(TRIM(VEN.NUMNOT), 6, '0')||LPAD(TRIM(REC.NUMPAR), 2, '0')||LPAD(TRIM(REC.SUBPAR), 2, '0') AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
          CAST(TRUNC(REC.PAGAME) AS Timestamp) AS DataEntrada, -- Data de Entrada
          CAST(TRUNC(REC.PAGAME) AS Timestamp) AS DataSaida, -- Data de Sada
          CAST(TRUNC(REC.PAGAME) AS Timestamp) AS DataEntSai, -- Data de Entrada ou Sada
          CAST(TRUNC(REC.PAGAME) AS Timestamp) AS DataEmissao, -- Data de Emisso
          CAST(ABS(REC.VLRPGT) + COALESCE(ABS(REC.VLRTAX),0) AS Numeric(15,2)) AS ValorContabil, -- Valor Contbil Original do Documento (Tesouraria)
          CAST(NULL AS Numeric(15,2)) AS ValorDescontos, -- Valor Desconto dos Produtos
          CAST(NULL AS Numeric(15,2)) AS ValorOutrasDespesas, -- Valor Outras Despesas dos Produtos
          CAST(NULL AS Numeric(15,2)) AS ValorDescontosServ, -- Valor Desconto dos Servios
          CAST(NULL AS Numeric(15,2)) AS ValorOutrasDespesasServ, -- Valor Outras Despesas dos Servios
          CAST(NULL AS VARCHAR(1)) AS SituacaoNFE, -- {3=Autorizada;5=Cancelada;7=Inutilizada;8=Substituida;9=Denegada;A=Contingncia}
          CAST(NULL AS VARCHAR(1)) AS SituacaoDOC, -- {0=Normal;1=Cancelada;2=Devoluo Parcial;3=Devoluo Total;4=Crdito Bloqueado;5=Inadimplncia;6=Cred. Bloq/Inad.;7=Bloqueio nos Itens;8=Faturado;A=Bloq. Val. Parcela;B=Bloq. Val. Min. Venda}
          CAST(NULL AS VARCHAR(50)) AS ObsFiscal, -- Observao Fiscal do Documento
          CAST(NULL AS VARCHAR(150)) AS Observacoes, -- Observaes da Nota
          CAST(NULL AS VARCHAR(4000)) AS InfoComplementares, -- Informaes Complementares da Nota
          CAST(NULL AS VARCHAR(4000)) AS TextoFiscal, -- Texto Fiscal do Documento
          CAST(NULL AS VARCHAR(200)) AS NumPedCliente, -- Nmero do Pedido no Cliente
          CAST(NULL AS VARCHAR(100)) AS NumPedRepresentante, -- Nmero do Pedido no Representante
          CAST(NULL AS VARCHAR(1)) AS IndNaturezaFrete, -- {0=Operaes de vendas, com nus suportado pelo estabelecimento vendedor;1=Operaes de vendas, com nus suportado pelo adquirente;2=Operaes de compras (bens para revenda, matrias prima e outros produtos, geradores de crdito);3=Operaes de compras (bens para revenda, matrias prima e outros produtos, no geradores de crdito);4=Transferncia de produtos acabados entre estabelecimentos da pessoa jurdica;5=Transferncia de produtos entre estabelecimentos da pessoa jurdica;9=Outras}
          CAST(NULL AS VARCHAR(60)) AS ChaveNFE, -- Chave NFE
          CAST(NULL AS VARCHAR(60)) AS ChaveNFERefer, -- Chave NFE Referenciada
          CAST(NULL AS VARCHAR(20)) AS CodContaTes, -- Cdigo da Conta Tesouraria
          -- Justificativa utilizada em Testes de Integrao pela EME4
          CAST('Pagamentos - Chave: '||REC.CODFIL||'/'||REC.SEQUEN||'-'||REC.NUMPAR||'-'||REC.SUBPAR AS VARCHAR(200)) AS Justificativa, -- Justificativa do documento Contbil
          --CAST(NULL AS VARCHAR(200)) AS Justificativa, -- Justificativa do documento Contbil
          CAST(NULL AS VARCHAR(1)) AS TipoFrete, -- {F=Por conta do emitente;T=Por conta do destinatrio;A=Por conta de terceiros;B=Sem frete}
          CAST(NULL AS Numeric(9)) AS CodTransportadora, -- Cdigo da Transportadora do Documento
          CAST(NULL AS VARCHAR(18)) AS CpfCnpjTransportadora, -- CPF ou CNPJ da Transportadora do Documento
          CAST(NULL AS VARCHAR(10)) AS PlacaVeiculo, -- Placa do Veculo de Entrega
          CAST(NULL AS Numeric(9)) AS CodTranspRedespacho, -- Cdigo da Transportadora de Redespacho do Documento
          CAST(NULL AS VARCHAR(18)) AS CpfCnpjTranspRedespacho, -- CPF ou CNPJ da Transportadora de Redespacho do Documento
          CAST(NULL AS VARCHAR(2)) AS CodigoModelo, -- Cdigo do Modelo de Documento (01 ou 65)
          CAST(NULL AS VARCHAR(120)) AS LogradouroEnt, -- Logradouro do Endereo de Entrega
          CAST(NULL AS Numeric(10)) AS NumeroEnt, -- Nmero do Endereo de Entrega
          CAST(NULL AS VARCHAR(30)) AS ComplementoEnt, -- Complemento do Endereo de Entrega
          CAST(NULL AS VARCHAR(10)) AS CEPEnt, -- CEP do Endereo de Entrega
          CAST(NULL AS VARCHAR(80)) AS BairroEnt, -- Bairro do Endereo de Entrega
          CAST(NULL AS Numeric(10)) AS CodMunicipioIBGEEnt, -- GeoCodigo do M3 - caso esteja informado dever importar o vnculo do municpio por este cdigo (Endereo)
          CAST(NULL AS VARCHAR(100)) AS CidadeEndEnt, -- Cidade do Endereo de Entrega
          CAST(NULL AS VARCHAR(2)) AS EstadoEnt, -- Estado do Endereo de Entrega
          CAST(NULL AS Numeric(9)) AS CodigoPaisEnt, -- Codigo do Banco Central para o Pais da Cidade de Entrega
          CAST(NULL AS VARCHAR(80)) AS PaisEnt, -- Nome do Pais do Endereo de Entrega
          CAST(NULL AS Numeric(15,2)) AS ValorFrete, -- Valor do Frete
          CAST(NULL AS Numeric(15,2)) AS ValorFreteTerceiros, -- Valor do Frete Terceiros
          CAST(NULL AS Numeric(15,2)) AS ICMSFreteTerceiros, -- Valor ICMS do Frete Terceiros
          CAST(NULL AS Numeric(15,2)) AS DifaFreteTerceiros, -- Valor DIFA do Frete Terceiros
          CAST(NULL AS Numeric(15,2)) AS ValorSeguro, -- Valor do Seguro
          CAST(NULL AS Numeric(15,2)) AS ValorAcrescimos, -- Valor Acrescimos
          -- Valores relativo a Nota de Importao
          CAST(NULL AS Numeric(15,2)) AS ValorTHC, -- Valor THC
          CAST(NULL AS Numeric(15,2)) AS ValorAFRMM, -- Valor AFRMM
          CAST(NULL AS Numeric(15,2)) AS ValorDemurrage, -- Valor Demurrage
          CAST(NULL AS Numeric(15,2)) AS ValorDesestiva, -- Valro Desestiva
          CAST(NULL AS Numeric(15,2)) AS ValorDesembaraco, -- Valor Desembarao
          CAST(NULL AS Numeric(15,2)) AS ValorSiscomex, -- Valor Siscomex
          CAST(NULL AS Numeric(15,2)) AS ValorPISImport, -- Valro PIS Importao
          CAST(NULL AS Numeric(15,2)) AS ValorCofinsImport, -- Valro Cofins Importao
          CAST(NULL AS Numeric(15,2)) AS ValorDespAduaneira, -- Valor Despesa Aduaneira
          CAST(NULL AS VARCHAR(10)) AS SimboloMoeda, -- Smbolo da Moeda
          CAST(NULL AS Numeric(15,4)) AS ValorCotacaoMoeda, -- Valor Cotao Moeda
          CAST(NULL AS Timestamp) AS DataCotacaoMoeda, -- Data Cotao Moeda
          CAST(NULL AS VARCHAR(18)) AS CPFCNPJRepresentante, -- CPF ou CNPJ do Representante
          CAST(NULL AS Numeric(8)) AS COO, -- COO Cupom
          CAST(NULL AS Numeric(8)) AS NroECF, -- Nmero do ECF
          CAST(NULL AS VARCHAR(50)) AS NroSerieECF, -- Nmero de rie do ECF
          CAST(NULL AS VARCHAR(20)) AS ModeloECF, -- Modelo do ECF
          CAST(NULL AS VARCHAR(20)) AS MarcaECF, -- Marca do ECF
          CAST(NULL AS VARCHAR(18)) as CPFCNPJCupom -- CPF ou CNPJ do cliente no identificado no cupom
     FROM TT_REC REC
     JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
     -- Srie de Emisso
     JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
     -- Plano 
     JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT AND PLA.CODPGT = VEN.CODPGT
     -- Cliente
     JOIN TT_CLI PAR ON PAR.FILCLI = VEN.FILCLI AND PAR.CODCLI = VEN.CODCLI
     --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
     -- Endereo de Faturamento
     LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = VEN.FILCLI AND ENDFAT.CODCLI = VEN.CODCLI AND ENDFAT.CODFIL = VEN.FILFAT AND ENDFAT.NUMEND = VEN.ENDFAT
     -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
     LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    WHERE 1=1 --REC.SUBPAR = ' 0' -- No trata Sub-Parcela 0 pois operao de recebimento pode ocorrer com todas as operaes
      AND VEN.NUMNOT NOT LIKE '%#%'
      AND VEN.FILEST IS NOT NULL -- Devoluo automtica ou Nota de Estorno
      AND REC.FLGEST = 'X'       -- Devoluo automtica ou Nota de Estorno
      AND REC.AVISTA = 'F'
      AND COALESCE(REC.INDEXP, 'E') <> 'N'
      AND REC.PAGAME >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',REC.CODFIL,'','','')
      AND (LeParametroTXT('TIPO_EXP_EME4', REC.CODFIL, '', '', '') = 'V')
      AND NOT EXISTS ( SELECT 1 AS OK 
                         FROM TW_EXTXDOC EXD 
                        WHERE EXD.ORIGEM = ORIGEM AND EXD.DESTINO = DESTINO
                          AND EXD.FILORI = REC.CODFIL AND EXD.SEQORI = REC.SEQUEN
                          AND EXD.PARORI = REC.NUMPAR AND EXD.SUBORI = REC.SUBPAR )
      --AND LID.EXPEM4 = 'F'   
            --OR (TAB.EXPORT = 'F') -- No considera o TT_REC.EXPORT pois o registro  marcardo em varias operaes
      ) TAB 
   ORDER BY TAB.CODFIL, TAB.SEQUEN, TAB.NUMPAR, TAB.SUBPAR, TAB.DataHoraAtuReg
   ;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integração de "Endereços Virtuais das Identificações" (Tabela Integração Mult)
/*-- SEQ 2656 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_ENDVIRTUAL CASCADE;

/*-- SEQ 2657 --*/
CREATE OR REPLACE VIEW TV_TIMU_ENDVIRTUAL AS
   SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST('X' AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Inclusão/Alteração Automática para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importação / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrição da inconsistência
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importação / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrição da inconsistência
      TAB.FILCLI, TAB.CODCLI, TAB.ATU_EM, TAB.DATINC,
      TAB.DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
      TAB.CodigoCliente, -- Código do Cliente
      TAB.CodigoFornecedor, -- Código do Fornecedor
      TAB.CodigoRepresentante, -- Código do Representante
      TAB.CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
      TAB.TipoEnderecoVirtual, -- 0=Email;1=Site;2=Email NFe;3=Email DANFe;4=Rede Social
      TAB.Endereco, -- Endereço Virtual da Identificação
      TAB.Observacoes -- Observações do Endereço Virtual
     FROM (      
   SELECT PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS ATU_EM, PAR.DATOPE AS DATINC,
          GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
          CAST(NULL AS Numeric(9)) AS CodigoCliente, -- Código do Cliente
          CAST(NULL AS Numeric(9)) AS CodigoFornecedor, -- Código do Fornecedor
          CAST(NULL AS Numeric(9)) AS CodigoRepresentante, -- Código do Representante
          --CAST(TRIM(COALESCE(PAR.NUMDOC, VIN.NUMDOC)) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(TRIM(PAR.NUMDOC) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(1 AS Numeric(1)) AS TipoEnderecoVirtual, -- 0=Email;1=Site;2=Email NFe;3=Email DANFe;4=Rede Social
          CAST(PAR.HOMPGE AS VARCHAR(120)) AS Endereco, -- Endereço Virtual da Identificação
          CAST(CASE WHEN PAR.SIGNAT>=0 THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situação do Cliente T/F
          CAST(NULL AS VARCHAR(250)) AS Observacoes -- Observações do Endereço Virtual
     FROM TT_CLI PAR
     -- Parceiro Vinculado - Só buscar o vínculo se a pessoa não for física
     --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
      AND ISNOTNULL(PAR.HOMPGE) = 'T'
      AND COALESCE(PAR.INDEXP, 'E') <> 'N'
    UNION ALL
   SELECT PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS ATU_EM, PAR.DATOPE AS DATINC,
          GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
          CAST(NULL AS Numeric(9)) AS CodigoCliente, -- Código do Cliente
          CAST(NULL AS Numeric(9)) AS CodigoFornecedor, -- Código do Fornecedor
          CAST(NULL AS Numeric(9)) AS CodigoRepresentante, -- Código do Representante
          --CAST(TRIM(COALESCE(PAR.NUMDOC, VIN.NUMDOC)) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(TRIM(PAR.NUMDOC) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(0 AS Numeric(1)) AS TipoEnderecoVirtual, -- 0=Email;1=Site;2=Email NFe;3=Email DANFe;4=Rede Social
          CAST(SPC.E_MAIL AS VARCHAR(120)) AS Endereco, -- Endereço Virtual da Identificação
          CAST(CASE WHEN PAR.SIGNAT>=0 THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situação do Cliente T/F
          CAST(NULL AS VARCHAR(250)) AS Observacoes -- Observações do Endereço Virtual
     FROM TT_CLI PAR
     JOIN TT_SPC SPC ON SPC.FILCLI = PAR.FILCLI AND SPC.CODCLI = PAR.CODCLI
     -- Parceiro Vinculado - Só buscar o vínculo se a pessoa não for física
     --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
      AND ISNOTNULL(SPC.E_MAIL) = 'T'
      AND COALESCE(PAR.INDEXP, 'E') <> 'N'
    UNION ALL
   SELECT PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS ATU_EM, PAR.DATOPE AS DATINC,
          GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
          CAST(NULL AS Numeric(9)) AS CodigoCliente, -- Código do Cliente
          CAST(NULL AS Numeric(9)) AS CodigoFornecedor, -- Código do Fornecedor
          CAST(NULL AS Numeric(9)) AS CodigoRepresentante, -- Código do Representante
          --CAST(TRIM(COALESCE(PAR.NUMDOC, VIN.NUMDOC)) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(TRIM(PAR.NUMDOC) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(0 AS Numeric(1)) AS TipoEnderecoVirtual, -- 0=Email;1=Site;2=Email NFe;3=Email DANFe;4=Rede Social
          CAST(PAR.E_MCON AS VARCHAR(120)) AS Endereco, -- Endereço Virtual da Identificação
          CAST(CASE WHEN PAR.SIGNAT>=0 THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situação do Cliente T/F
          CAST(NULL AS VARCHAR(250)) AS Observacoes -- Observações do Endereço Virtual
     FROM TT_CLI PAR
     -- Parceiro Vinculado - Só buscar o vínculo se a pessoa não for física
     --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
      AND ISNOTNULL(PAR.E_MCON) = 'T'
      AND COALESCE(PAR.INDEXP, 'E') <> 'N'
    UNION ALL
   SELECT PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS ATU_EM, PAR.DATOPE AS DATINC,
          GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
          CAST(NULL AS Numeric(9)) AS CodigoCliente, -- Código do Cliente
          CAST(NULL AS Numeric(9)) AS CodigoFornecedor, -- Código do Fornecedor
          CAST(NULL AS Numeric(9)) AS CodigoRepresentante, -- Código do Representante
          --CAST(TRIM(COALESCE(PAR.NUMDOC, VIN.NUMDOC)) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(TRIM(PAR.NUMDOC) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(0 AS Numeric(1)) AS TipoEnderecoVirtual, -- 0=Email;1=Site;2=Email NFe;3=Email DANFe;4=Rede Social
          CAST(PAR.E_MFIN AS VARCHAR(120)) AS Endereco, -- Endereço Virtual da Identificação
          CAST(CASE WHEN PAR.SIGNAT>=0 THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situação do Cliente T/F
          CAST(NULL AS VARCHAR(250)) AS Observacoes -- Observações do Endereço Virtual
     FROM TT_CLI PAR
     -- Parceiro Vinculado - Só buscar o vínculo se a pessoa não for física
     --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
      AND ISNOTNULL(PAR.E_MFIN) = 'T'
      AND COALESCE(PAR.INDEXP, 'E') <> 'N'
      ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Estoque Produtos" (Tabela Integrao Mult)
/*-- SEQ 2658 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_ESTOQUEPRODUTO CASCADE;

/*-- SEQ 2659 --*/
CREATE OR REPLACE VIEW TV_TIMU_ESTOQUEPRODUTO AS
   SELECT --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
          CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
          CAST('X' AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
          CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
          --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
          CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
          --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
          TAB.CODFIL, TAB.ATU_EM,
          TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
          TAB.CNPJFilial, -- CNPJ da Filial
          TAB.CodigoItem, -- Cdigo do Produto
          TAB.DataEstoque, -- Data final do estoque
          TAB.Quantidade, -- Float 3 casas decimais - Quantidade em estoque
          TAB.TipoEstoque, -- Indicador do tipo de estoque: 
                                                           -- 0 = Estoque de propriedade do informante e em seu poder,
                                                           -- 1 = Estoque de propriedade do informante e em posse de terceiros,
                                                           -- 2 = Estoque de propriedade de terceiros e em posse do informante
          TAB.CodParticipante -- Cdigo do Participante 
     FROM (
   SELECT SAL.CODFIL, SAL.ATU_EM,
          SAL.ATU_EM AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
          CAST(TRIM(DFIL.CGCFIL) AS VARCHAR(18)) AS CNPJFilial, -- CNPJ da Filial
          CAST(TRIM(GRA.CODFIS) AS VARCHAR(60)) AS CodigoItem, -- Cdigo do Produto
          TRUNC(Agora()) AS DataEstoque, -- Data final do estoque
          CAST(TRUNC(CUSTOMEDIO(SAL.CODFIL, GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, 1, Agora()), 3) AS Numeric(15,3)) AS Quantidade, -- Float 3 casas decimais - Quantidade em estoque
          CAST('0' AS VARCHAR(1)) AS TipoEstoque, -- Indicador do tipo de estoque: 
                                                  -- 0 = Estoque de propriedade do informante e em seu poder
                                                  -- 1 = Estoque de propriedade do informante e em posse de terceiros
                                                  -- 2 = Estoque de propriedade de terceiros e em posse do informante
          CAST(NULL AS VARCHAR(60)) AS CodParticipante -- Cdigo do Participante 
     FROM TT_GRA GRA 
     JOIN TT_SAL SAL ON SAL.FILMAT = GRA.FILMAT
                    AND SAL.CODMAT = GRA.CODMAT
                    AND SAL.CODCOR = GRA.CODCOR
                    AND SAL.CODTAM = GRA.CODTAM
                    AND SAL.CODMUL = 0
     JOIN TD_FIL DFIL ON DFIL.CODFIL = SAL.CODFIL
     ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integração de "Tabela de Integração de Fornecedores" (Tabela Integração Mult)
/*-- SEQ 2660 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_FORNECEDOR CASCADE;

/*-- SEQ 2661 --*/
CREATE OR REPLACE VIEW TV_TIMU_FORNECEDOR AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST('X' AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Inclusão/Alteração Automática para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importação / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrição da inconsistência
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importação / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrição da inconsistência
      TAB.FILCLI, TAB.CODCLI, TAB.ATU_EM, TAB.DATINC, TAB.CODEXT,
      TAB.DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
      TAB.CpfCnpj, -- CPF ou CNPJ do Fornecedor
      TAB.InscricaoEstadual, -- Inscrição Estadual do Fornecedor
      TAB.InscMunicipal, -- Inscrição Municipal do Fornecedor
      TAB.CodigoFornecedor, -- Código do Fornecedor
         --TAB.CodAltFor, -- Código Alternativo do Fornecedor
      TAB.NomeFantasia, -- Nome Fantasia do Fornecedor
      TAB.Pessoa, -- 1=Física, 2=Jurídica
      TAB.Nome, -- Razão Social do Fornecedor
      TAB.Endereco, -- Logradouro do Endereço
      TAB.NumeroEnd, -- Número do Endereço do Fornecedor
      TAB.ComplementoEnd, -- Complemento do Endereço do Fornecedor
      TAB.CEP, -- CEP do Endereço do Fornecedor
      TAB.CodMunicipioIBGE, -- GeoCodigo do M3 - caso esteja informado deverá importar o vínculo do município por este código (Endereço)
      TAB.Cidade, -- Cidade do Endereço do Fornecedor
      TAB.Bairro, -- Bairro do Endereço do Fornecedor
      TAB.Estado, -- Estado do Endereço do Fornecedor
      TAB.CodigoPais, -- Codigo do Banco Central para o Pais
      TAB.Pais, -- Nome do Pais do Endereço do Fornecedor
      TAB.Telefone, -- Telefone Principal do Fornecedor
      TAB.Categoria, -- Código da Categoria do Fornecedor
      TAB.CodigoBanco, -- Código do Banco do Fornecedor
      TAB.CodigoAgencia, -- Código da Agência Bancária do Fornecedor
      TAB.DigitoAgencia, -- Dígito da Agência Bancária do Fornecedor
      TAB.CodigoContaBancaria, -- Código da Conta Bancária do Fornecedor
      TAB.DigitoContaBancaria, -- Dígito da Conta Bancária do Fornecedor
      TAB.TipoConta, -- C = Conta Corrente / P = Poupança
      TAB.Transportadora, -- É transportadora?
      TAB.FormaPagamento, -- Código da Forma de Cobrança
      TAB.DataCadastro, -- Data de Cadastro do Fornecedor 
      TAB.DataAlteracao, -- Data de última atualização do cadastro do Fornecedor
      TAB.Inativo, -- Situação do Fornecedor T/F
      TAB.DistanciaKM -- Distância entre o fornecedor e a empresa
  FROM (SELECT 
               PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS ATU_EM, PAR.DATOPE AS DATINC, PAR.CODEXT,
               GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
               CAST(TRIM(PAR.NUMDOC) AS VARCHAR(18)) AS CpfCnpj, -- CPF ou CNPJ do Fornecedor
               CAST(TRIM(COALESCE(ENDE.INSEST, PAR.INSEST)) AS VARCHAR(20)) AS InscricaoEstadual, -- Inscrição Estadual do Fornecedor
               CAST(ENDE.INSMUN AS VARCHAR(20)) AS InscMunicipal, -- Inscrição Municipal do Fornecedor
               CAST(TO_NUMBER(CASE WHEN (ISNULL(PAR.NUMDOC)='T') AND (ISNULL(PAR.CODEXT)='T') THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                   ELSE SUBSTR(TO_CHAR(CAST(                                                            NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                              END) AS Numeric(9)) AS CodigoFornecedor, -- Código do Fornecedor
                  --CAST(PAR.FILCLI||PAR.CODCLI AS VARCHAR(20)) AS CodAltFor, -- Código Alternativo do Fornecedor
               CAST(CASE WHEN (ISNULL(PAR.CODEXT)='F') THEN NULL ELSE TRIM(CASE WHEN PAR.FLGTIP = '0' THEN PAR.NOMTRA ELSE COALESCE(PAR.ULTNOM, PAR.NOMTRA) END) END AS VARCHAR(50)) AS NomeFantasia, -- Nome Fantasia do Fornecedor
               CAST(CASE WHEN PAR.FLGTIP = '0' THEN '1'
                         ELSE '2'
                    END AS VARCHAR(1)) AS Pessoa, -- 1=Física, 2=Jurídica
               CAST(TRIM(PAR.NOMCLI || ' ' || CASE WHEN (PAR.FLGTIP = '0') AND ((SELECT CFG.UNE_NOME_SOBRENOME FROM TT_CFG CFG)='F') THEN COALESCE(PAR.ULTNOM,'') ELSE '' END) AS VARCHAR(120)) AS Nome, -- Razão Social do Fornecedor
               CAST(TRIM(ENDE.ENDERE) AS VARCHAR(120)) AS Endereco, -- Logradouro do Endereço
               CAST(SUBSTR(TO_CHAR(CAST(                                        NULLIF(regexp_replace(ENDE.NUMERO, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 10) AS Numeric(10)) AS NumeroEnd, -- Número do Endereço do Fornecedor
               CAST(TRIM(ENDE.COMPLE) AS VARCHAR(30)) AS ComplementoEnd, -- Complemento do Endereço do Fornecedor
               CAST(CASE WHEN DPAI.CODPAI = 1058 THEN LPAD(COALESCE(TRIM(ENDE.CODCEP), '0'), 5, '0')||LPAD(COALESCE(TRIM(ENDE.CODLOG), '0'), 3, '0') ELSE NULL END AS VARCHAR(10)) AS CEP, -- CEP do Endereço do Fornecedor
               CAST(TRIM(ENDE.BAIRRO) AS VARCHAR(80)) AS Bairro, -- Bairro do Endereço do Fornecedor
               CAST(CASE WHEN DPAI.CODPAI = 1058 THEN IBG.CODIBG ELSE NULL END AS Numeric(10)) AS CodMunicipioIBGE, -- GeoCodigo do M3 - caso esteja informado deverá importar o vínculo do município por este código (Endereço)
               -- A Pedido da EME4 não será exportado os dados da Cidade/Estado/Pais
               CAST(TRIM(CASE WHEN DPAI.CODPAI = 1058 THEN NULL /*IBG.NOMMUN*/ ELSE ENDE.NOMCID END) AS VARCHAR(25)) AS Cidade, -- Cidade do Endereço do Fornecedor
               CAST(TRIM(CASE WHEN DPAI.CODPAI = 1058 THEN NULL /*IBG.SIGEST*/ ELSE NULL END) AS VARCHAR(2)) AS Estado, -- Estado do Endereço do Fornecedor
               CAST(DPAI.CODPAI AS Numeric(9)) AS CodigoPais, -- Codigo do Banco Central para o Pais
               CAST(TRIM(CASE WHEN DPAI.CODPAI = 1058 THEN NULL /*DPAI.DESPAI*/ ELSE DPAI.DESPAI END) AS VARCHAR(80)) AS Pais, -- Nome do Pais do Endereço do Fornecedor
               CAST(CASE WHEN ISNULL(ENDE.CODDDD)='T' THEN '' ELSE '(' || COALESCE(ENDE.CODDDD,'') || ') ' END || TRIM(ENDE.NUMFON) AS VARCHAR(20)) AS Telefone, -- Telefone Principal do Fornecedor
               CAST(COALESCE(DCT1.CODEXT_DCT1, COALESCE(DCT2.CODEXT_DCT2, DCT3.CODEXT_DCT3)) AS VARCHAR(20)) AS Categoria, -- Código da Categoria do Fornecedor
               CAST(CBP.CODBCO AS Numeric(9)) AS CodigoBanco, -- Código do Banco do Fornecedor
               CAST(CBP.NUMAGE AS VARCHAR(9)) AS CodigoAgencia, -- Código da Agência Bancária do Fornecedor
               CAST(CBP.DIGAGE AS VARCHAR(2)) AS DigitoAgencia, -- Dígito da Agência Bancária do Fornecedor
               CAST(CBP.CTACRR AS VARCHAR(13)) AS CodigoContaBancaria, -- Código da Conta Bancária do Fornecedor
               CAST(CBP.DIGCRR AS Numeric(1)) AS DigitoContaBancaria, -- Dígito da Conta Bancária do Fornecedor
               CAST(CASE WHEN COALESCE(CBP.TIPCON, 'X') NOT IN ('C','P') THEN NULL
                         ELSE CBP.TIPCON
                    END AS VARCHAR(1)) AS TipoConta, -- C = Conta Corrente / P = Poupança
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = PAR.FILCLI AND REL.CODPAR = PAR.CODCLI AND REL.TIPPAR IN ('A','T')) THEN 'T'
                         ELSE 'F'
                    END AS VARCHAR(1)) AS Transportadora, -- É transportadora?
               CAST(NULL AS VARCHAR(20)) AS FormaPagamento, -- Código da Forma de Cobrança
               TRUNC(PAR.DATOPE) AS DataCadastro, -- Data de Cadastro do Fornecedor 
               TRUNC(GREATEST(PAR.ATU_EM, PAR.ULTCOM)) AS DataAlteracao, -- Data de última atualização do cadastro do Fornecedor
               CAST(CASE WHEN (LeParametroTXT('TIPO_EXP_EME4', '', '', '', '') = 'C') OR (PAR.SIGNAT >= 0) THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situação do Fornecedor T/F
               CAST(NULL AS Numeric(15,3)) AS DistanciaKM -- Distância entre o fornecedor e a empresa
           FROM TT_CLI PAR
           LEFT JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
           LEFT JOIN TT_MUN MUN ON MUN.CODIGO = ENDE.CODCID
           LEFT JOIN TT_IBG IBG ON IBG.CODIBG = COALESCE(ENDE.CODIBG, MUN.CODIBG)
           LEFT JOIN TD_PAI DPAI ON DPAI.CODPAI = ENDE.CODPAI
           LEFT JOIN TT_SPC SPC ON SPC.FILCLI = PAR.FILCLI AND SPC.CODCLI = PAR.CODCLI
           -- Parceiro Vinculado - Só buscar o vínculo se a pessoa não for física
           --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
           -- Conta Bancária
           LEFT JOIN TT_CBP CBP ON CBP.FILCLI = PAR.FILCLI AND CBP.CODCLI = PAR.CODCLI
                               AND (CBP.CODFIL, CBP.SEQUEN) IN 
                                   (SELECT CTB.CODFIL, CTB.SEQUEN
                                      FROM TT_CBP CTB
                                     WHERE CTB.FILCLI = CBP.FILCLI AND CTB.CODCLI = CBP.CODCLI
                                                                           LIMIT 1  )
           -- Categorias
           LEFT JOIN TD_CT1 DCT1 ON DCT1.CODTAB = PAR.CATEG1
           LEFT JOIN TD_CT2 DCT2 ON DCT2.CODTAB = PAR.CATEG2
           LEFT JOIN TD_CT3 DCT3 ON DCT3.CODTAB = PAR.CATEG3
          WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
            AND (PAR.CODCLI <> LPAD('0', 6, ' '))
            AND ( -- A - Cliente Transportadora,F - Fornecedor,M - Marca/Produto,T - Transportador
                  EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = PAR.FILCLI AND REL.CODPAR = PAR.CODCLI AND REL.TIPPAR IN ('A','F','M','T'))
                  OR
                  EXISTS(SELECT 1 AS OK FROM TT_COM COM 
                          WHERE COM.FLGEST <> 'D'
                            AND COM.NUMNOT NOT LIKE '%#%'
                            AND COM.FILFOR = PAR.FILCLI AND COM.CODFOR = PAR.CODCLI
                            AND COM.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',COM.CODFIL,'','','')
                            AND ((COM.EXPEM4 = 'F') OR (COM.EXPORT = 'F')) )
                )
            AND COALESCE(PAR.INDEXP, 'E') <> 'N'
      UNION ALL
      SELECT 
               PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS ATU_EM, PAR.DATOPE AS DATINC, CAST(NULL AS VARCHAR(20)) AS CODEXT,
               GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
               CAST(TRIM(ENDE.NUMDOC) AS VARCHAR(18)) AS CpfCnpj, -- CPF ou CNPJ do Fornecedor
               CAST(TRIM(COALESCE(ENDE.INSEST, PAR.INSEST)) AS VARCHAR(20)) AS InscricaoEstadual, -- Inscrição Estadual do Fornecedor
               CAST(ENDE.INSMUN AS VARCHAR(20)) AS InscMunicipal, -- Inscrição Municipal do Fornecedor
               CAST(NULL AS Numeric(9)) AS CodigoFornecedor, -- Código do Fornecedor
                  --CAST(PAR.FILCLI||PAR.CODCLI AS VARCHAR(20)) AS CodAltFor, -- Código Alternativo do Fornecedor
               CAST(CASE WHEN (ISNULL(PAR.CODEXT)='F') THEN NULL ELSE TRIM(CASE WHEN PAR.FLGTIP = '0' THEN PAR.NOMTRA ELSE COALESCE(PAR.ULTNOM, PAR.NOMTRA) END) END AS VARCHAR(50)) AS NomeFantasia, -- Nome Fantasia do Fornecedor
               CAST(CASE WHEN PAR.FLGTIP = '0' THEN '1'
                         ELSE '2'
                    END AS VARCHAR(1)) AS Pessoa, -- 1=Física, 2=Jurídica
               CAST(TRIM(PAR.NOMCLI || ' ' || CASE WHEN (PAR.FLGTIP = '0') AND ((SELECT CFG.UNE_NOME_SOBRENOME FROM TT_CFG CFG)='F') THEN COALESCE(PAR.ULTNOM,'') ELSE '' END) AS VARCHAR(120)) AS Nome, -- Razão Social do Fornecedor
               CAST(TRIM(ENDE.ENDERE) AS VARCHAR(120)) AS Endereco, -- Logradouro do Endereço
               CAST(SUBSTR(TO_CHAR(CAST(                                        NULLIF(regexp_replace(ENDE.NUMERO, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 10) AS Numeric(10)) AS NumeroEnd, -- Número do Endereço do Fornecedor
               CAST(TRIM(ENDE.COMPLE) AS VARCHAR(30)) AS ComplementoEnd, -- Complemento do Endereço do Fornecedor
               CAST(CASE WHEN DPAI.CODPAI = 1058 THEN LPAD(COALESCE(TRIM(ENDE.CODCEP), '0'), 5, '0')||LPAD(COALESCE(TRIM(ENDE.CODLOG), '0'), 3, '0') ELSE NULL END AS VARCHAR(10)) AS CEP, -- CEP do Endereço do Fornecedor
               CAST(TRIM(ENDE.BAIRRO) AS VARCHAR(80)) AS Bairro, -- Bairro do Endereço do Fornecedor
               CAST(CASE WHEN DPAI.CODPAI = 1058 THEN IBG.CODIBG ELSE NULL END AS Numeric(10)) AS CodMunicipioIBGE, -- GeoCodigo do M3 - caso esteja informado deverá importar o vínculo do município por este código (Endereço)
               -- A Pedido da EME4 não será exportado os dados da Cidade/Estado/Pais
               CAST(TRIM(CASE WHEN DPAI.CODPAI = 1058 THEN NULL /*IBG.NOMMUN*/ ELSE ENDE.NOMCID END) AS VARCHAR(25)) AS Cidade, -- Cidade do Endereço do Fornecedor
               CAST(TRIM(CASE WHEN DPAI.CODPAI = 1058 THEN NULL /*IBG.SIGEST*/ ELSE NULL END) AS VARCHAR(2)) AS Estado, -- Estado do Endereço do Fornecedor
               CAST(DPAI.CODPAI AS Numeric(9)) AS CodigoPais, -- Codigo do Banco Central para o Pais
               CAST(TRIM(CASE WHEN DPAI.CODPAI = 1058 THEN NULL /*DPAI.DESPAI*/ ELSE DPAI.DESPAI END) AS VARCHAR(80)) AS Pais, -- Nome do Pais do Endereço do Fornecedor
               CAST(CASE WHEN ISNULL(ENDE.CODDDD)='T' THEN '' ELSE '(' || COALESCE(ENDE.CODDDD,'') || ') ' END || TRIM(ENDE.NUMFON) AS VARCHAR(20)) AS Telefone, -- Telefone Principal do Fornecedor
               CAST(COALESCE(DCT1.CODEXT_DCT1, COALESCE(DCT2.CODEXT_DCT2, DCT3.CODEXT_DCT3)) AS VARCHAR(20)) AS Categoria, -- Código da Categoria do Fornecedor
               CAST(CBP.CODBCO AS Numeric(9)) AS CodigoBanco, -- Código do Banco do Fornecedor
               CAST(CBP.NUMAGE AS VARCHAR(9)) AS CodigoAgencia, -- Código da Agência Bancária do Fornecedor
               CAST(CBP.DIGAGE AS VARCHAR(2)) AS DigitoAgencia, -- Dígito da Agência Bancária do Fornecedor
               CAST(CBP.CTACRR AS VARCHAR(13)) AS CodigoContaBancaria, -- Código da Conta Bancária do Fornecedor
               CAST(CBP.DIGCRR AS Numeric(1)) AS DigitoContaBancaria, -- Dígito da Conta Bancária do Fornecedor
               CAST(CASE WHEN COALESCE(CBP.TIPCON, 'X') NOT IN ('C','P') THEN NULL
                         ELSE CBP.TIPCON
                    END AS VARCHAR(1)) AS TipoConta, -- C = Conta Corrente / P = Poupança
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = PAR.FILCLI AND REL.CODPAR = PAR.CODCLI AND REL.TIPPAR IN ('A','T')) THEN 'T'
                         ELSE 'F'
                    END AS VARCHAR(1)) AS Transportadora, -- É transportadora?
               CAST(NULL AS VARCHAR(20)) AS FormaPagamento, -- Código da Forma de Cobrança
               TRUNC(PAR.DATOPE) AS DataCadastro, -- Data de Cadastro do Fornecedor 
               TRUNC(GREATEST(PAR.ATU_EM, PAR.ULTCOM)) AS DataAlteracao, -- Data de última atualização do cadastro do Fornecedor
               CAST(CASE WHEN PAR.SIGNAT>=0 THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situação do Fornecedor T/F
               CAST(NULL AS Numeric(15,3)) AS DistanciaKM -- Distância entre o fornecedor e a empresa
           FROM TT_CLI PAR
           JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ISNOTNULL(ENDE.NUMDOC) = 'T' AND TRIM(COALESCE(ENDE.NUMDOC, '')) <> TRIM(COALESCE(PAR.NUMDOC, ''))
           LEFT JOIN TT_MUN MUN ON MUN.CODIGO = ENDE.CODCID
           LEFT JOIN TT_IBG IBG ON IBG.CODIBG = COALESCE(ENDE.CODIBG, MUN.CODIBG)
           LEFT JOIN TD_PAI DPAI ON DPAI.CODPAI = ENDE.CODPAI
           LEFT JOIN TT_SPC SPC ON SPC.FILCLI = PAR.FILCLI AND SPC.CODCLI = PAR.CODCLI
           -- Parceiro Vinculado - Só buscar o vínculo se a pessoa não for física
           --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
           -- Conta Bancária
           LEFT JOIN TT_CBP CBP ON CBP.FILCLI = PAR.FILCLI AND CBP.CODCLI = PAR.CODCLI
                               AND (CBP.CODFIL, CBP.SEQUEN) IN 
                                   (SELECT CTB.CODFIL, CTB.SEQUEN
                                      FROM TT_CBP CTB
                                     WHERE CTB.FILCLI = CBP.FILCLI AND CTB.CODCLI = CBP.CODCLI
                                                                           LIMIT 1  )
           -- Categorias
           LEFT JOIN TD_CT1 DCT1 ON DCT1.CODTAB = PAR.CATEG1
           LEFT JOIN TD_CT2 DCT2 ON DCT2.CODTAB = PAR.CATEG2
           LEFT JOIN TD_CT3 DCT3 ON DCT3.CODTAB = PAR.CATEG3
          WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
            AND (PAR.CODCLI <> LPAD('0', 6, ' '))
            AND ( -- A - Cliente Transportadora,F - Fornecedor,M - Marca/Produto,T - Transportador
                  EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = PAR.FILCLI AND REL.CODPAR = PAR.CODCLI AND REL.TIPPAR IN ('A','F','M','T'))
                  OR
                  EXISTS(SELECT 1 AS OK FROM TT_COM COM 
                          WHERE COM.FLGEST <> 'D'
                            AND COM.NUMNOT NOT LIKE '%#%'
                            AND COM.FILFOR = PAR.FILCLI AND COM.CODFOR = PAR.CODCLI
                            AND COM.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',COM.CODFIL,'','','')
                            AND ((COM.EXPEM4 = 'F') OR (COM.EXPORT = 'F')) )
                )
            AND COALESCE(PAR.INDEXP, 'E') <> 'N'
      ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integração de "Informações Auxiliares das Identificações" (Tabela Integração Mult)
/*-- SEQ 2662 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_INFORMACOES CASCADE;

/*-- SEQ 2663 --*/
CREATE OR REPLACE VIEW TV_TIMU_INFORMACOES AS
   SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST('X' AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Inclusão/Alteração Automática para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importação / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrição da inconsistência
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importação / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrição da inconsistência
      TAB.FILCLI, TAB.CODCLI, TAB.ATU_EM, TAB.DATINC,
      TAB.DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
      TAB.CodigoCliente, -- Código do Cliente
      TAB.CodigoFornecedor, -- Código do Fornecedor
      TAB.CodigoRepresentante, -- Código do Representante
      TAB.CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
      TAB.TipoInformacao, -- 0=Comercial,1=Bancaria,2=Outros,3=Informações Auxiliares,4=Referências,5=Restrições,6=Cobrança,
      TAB.Descricao, -- Descrição da observação
      TAB.DataCadastro, -- Data do Cadastro da informação no Sistema
      TAB.UsuarioCadastro -- Chave do usuário de cadastro
     FROM (
   SELECT PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS ATU_EM, PAR.DATOPE AS DATINC,
          GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
          CAST(NULL AS Numeric(9)) AS CodigoCliente, -- Código do Cliente
          CAST(NULL AS Numeric(9)) AS CodigoFornecedor, -- Código do Fornecedor
          CAST(NULL AS Numeric(9)) AS CodigoRepresentante, -- Código do Representante
          --CAST(TRIM(COALESCE(PAR.NUMDOC, VIN.NUMDOC)) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(TRIM(PAR.NUMDOC) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(4 AS Numeric(1)) AS TipoInformacao, -- 0=Comercial,1=Bancaria,2=Outros,3=Informações Auxiliares,4=Referências,5=Restrições,6=Cobrança,
          CAST(TRIM(RFC.NOMRFC || 
                   CASE WHEN COALESCE(RFC.NUMFON,'')='' THEN '' 
                        ELSE ' - ' || CASE WHEN ISNOTNULL(RFC.DDDFON) = 'T' THEN '' ELSE '(' || COALESCE(RFC.DDDFON,'') || ') ' END || COALESCE(RFC.NUMFON,'') 
                   END ||
                   CASE WHEN COALESCE(RFC.ENDERE,'')='' THEN '' 
                        ELSE ' - ' || COALESCE(RFC.ENDERE,'')
                   END) AS VARCHAR(250)) AS Descricao, -- Descrição da observação
          TRUNC(RFC.DATINC) AS DataCadastro, -- Data do Cadastro da informação no Sistema
          CAST(CASE WHEN PAR.SIGNAT>=0 THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situação do Cliente T/F
          CAST(NULL AS VARCHAR(25)) AS UsuarioCadastro -- Chave do usuário de cadastro
     FROM TT_CLI PAR
     JOIN TT_RFC RFC ON RFC.FILCLI = PAR.FILCLI AND RFC.CODCLI = PAR.CODCLI
     -- Parceiro Vinculado - Só buscar o vínculo se a pessoa não for física
     --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
      AND COALESCE(PAR.INDEXP, 'E') <> 'N'
      AND ISNOTNULL(RFC.NOMRFC) = 'T'
    UNION ALL
   SELECT 
          PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS ATU_EM, PAR.DATOPE AS DATINC,
          GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
          CAST(NULL AS Numeric(9)) AS CodigoCliente, -- Código do Cliente
          CAST(NULL AS Numeric(9)) AS CodigoFornecedor, -- Código do Fornecedor
          CAST(NULL AS Numeric(9)) AS CodigoRepresentante, -- Código do Representante
          --CAST(TRIM(COALESCE(PAR.NUMDOC, VIN.NUMDOC)) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(TRIM(PAR.NUMDOC) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(2 AS Numeric(1)) AS TipoInformacao, -- 0=Comercial,1=Bancaria,2=Outros,3=Informações Auxiliares,4=Referências,5=Restrições,6=Cobrança,
          CAST(TRIM(SUBSTR(PAR.OBSOUT, 1, 250)) AS VARCHAR(250)) AS Descricao, -- Descrição da observação
          CAST(NULL AS Timestamp) AS DataCadastro, -- Data do Cadastro da informação no Sistema
          CAST(CASE WHEN PAR.SIGNAT>=0 THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situação do Cliente T/F
          CAST(NULL AS VARCHAR(25)) AS UsuarioCadastro -- Chave do usuário de cadastro
     FROM TT_CLI PAR
     -- Parceiro Vinculado - Só buscar o vínculo se a pessoa não for física
     --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
      AND ISNOTNULL(PAR.OBSOUT) = 'T'
      AND COALESCE(PAR.INDEXP, 'E') <> 'N'
    UNION ALL
   SELECT 
          PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS ATU_EM, PAR.DATOPE AS DATINC,
          GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
          CAST(NULL AS Numeric(9)) AS CodigoCliente, -- Código do Cliente
          CAST(NULL AS Numeric(9)) AS CodigoFornecedor, -- Código do Fornecedor
          CAST(NULL AS Numeric(9)) AS CodigoRepresentante, -- Código do Representante
          --CAST(TRIM(COALESCE(PAR.NUMDOC, VIN.NUMDOC)) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(TRIM(PAR.NUMDOC) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(4 AS Numeric(1)) AS TipoInformacao, -- 0=Comercial,1=Bancaria,2=Outros,3=Informações Auxiliares,4=Referências,5=Restrições,6=Cobrança,
          CAST(TRIM(SUBSTR(RTF2TXT(PAR.OBSERV), 1, 250)) AS VARCHAR(250)) AS Descricao, -- Descrição da observação
          CAST(NULL AS Timestamp) AS DataCadastro, -- Data do Cadastro da informação no Sistema
          CAST(CASE WHEN PAR.SIGNAT>=0 THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situação do Cliente T/F
          CAST(NULL AS VARCHAR(25)) AS UsuarioCadastro -- Chave do usuário de cadastro
     FROM TT_CLI PAR
     -- Parceiro Vinculado - Só buscar o vínculo se a pessoa não for física
     --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
      AND ISNOTNULL(TRIM(RTF2TXT(PAR.OBSERV))) = 'T'
      AND COALESCE(PAR.INDEXP, 'E') <> 'N'
   ) TAB   
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Insumos da Produo" (Tabela Integrao Mult)
/*-- SEQ 2664 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_INSUMOSPRODUCAO CASCADE;

/*-- SEQ 2665 --*/
CREATE OR REPLACE VIEW TV_TIMU_INSUMOSPRODUCAO AS
   SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.DATINC, TAB.ATU_EM, TAB.CHAVE, TAB.EXPEM4, TAB.EXPORT,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.CNPJFilial, -- CNPJ da Filial
      -- Ordem de Produo  
      TAB.DataSaida, -- Data de sada do estoque para alocao ao produto
      TAB.DataInicio, -- Data de incio da ordem de produo 
      TAB.CodigoOrdemProducao, -- Cdigo de identificao da ordem de produo
      -- Insumo Utilizado
      TAB.CodigoItemConsumido, -- Cdigo do item componente/insumo 
      TAB.QuantidadeAcabada, -- Float 6 casas decimais - Quantidade consumida do item
      TAB.CodigoInsumoSubstituido -- Cdigo do insumo que foi substitudo, caso ocorra a substituio
     FROM (
   SELECT PPR.CODFIL, PPR.SEQUEN, PPR.DATINC, PPR.ATU_EM, CAST('INS' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_INSUMOSPRODUCAO' AS VARCHAR(50)) AS DESTINO,
          CAST('PPR' || PPR.CODFIL || PPR.SEQUEN AS VARCHAR(50)) AS CHAVE, PPR.EXPEM4, PPR.EXPORT,
          PPR.ATU_EM AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
          CAST(TRIM(DFIL.CGCFIL) AS VARCHAR(18)) AS CNPJFilial, -- CNPJ da Filial
          -- Ordem de Produo  
          TRUNC(PPR.DATINI) AS DataSaida, -- Data de sada do estoque para alocao ao produto
          TRUNC(PPR.DATINI) AS DataInicio, -- Data de incio da ordem de produo 
          CAST(PPR.CODFIL||LPAD(TRIM(PPR.SEQUEN),10,'0') AS VARCHAR(30)) AS CodigoOrdemProducao, -- Cdigo de identificao da ordem de produo
          -- Insumo Utilizado
          CAST(TRIM(GRA.CODFIS) AS VARCHAR(60)) AS CodigoItemConsumido, -- Cdigo do item componente/insumo 
          CAST(ABS(INS.QTDMOV) AS Numeric(17,6)) AS QuantidadeAcabada, -- Float 6 casas decimais - Quantidade consumida do item
          CAST('' AS VARCHAR(60)) AS CodigoInsumoSubstituido -- Cdigo do insumo que foi substitudo, caso ocorra a substituio
     FROM TT_LAN INS 
     JOIN TT_PPR PPR ON PPR.CODFIL = INS.FILPPR 
                    AND PPR.SEQUEN = INS.SEQPPR 
     JOIN TD_FIL DFIL ON DFIL.CODFIL = PPR.CODFIL 
     JOIN TT_GRA GRA ON GRA.FILMAT = INS.FILMAT 
                    AND GRA.CODMAT = INS.CODMAT 
                    AND GRA.CODCOR = INS.CODCOR 
                    AND GRA.CODTAM = INS.CODTAM 
    CROSS JOIN TT_CFG CFG 
    WHERE INS.TIPLAN = CFG.TIPLAN_INS
      AND PPR.DATINC >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',PPR.CODFIL,'','','')
      AND ((PPR.EXPEM4 = 'F') OR (PPR.EXPORT = 'F'))
    ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Inventrio de Estoque" (Tabela Integrao Mult)
/*-- SEQ 2666 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_INVENTARIO CASCADE;

/*-- SEQ 2667 --*/
CREATE OR REPLACE VIEW TV_TIMU_INVENTARIO AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TW_EXTXDOC EXD 
                             WHERE EXD.ORIGEM = TAB.ORIGEM AND EXD.DESTINO = TAB.DESTINO
                               AND EXD.FILORI = TAB.CODFIL AND EXD.SEQORI = TAB.SEQUEN
                               ) THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('T' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.ORIGEM, TAB.DESTINO, TAB.CHAVE,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.Filial, -- Cdigo da Filial
      TAB.Data, -- Data do Inventrio
      TAB.TipoInventario, -- 0=Inventrio Geral,1=Inventrio Cclico,2=Inventrio FCI
      TAB.Descricao, -- DescricaoInventario
      TAB.OrigemValorUni, -- 0=Preo Custo,1=Custo Mdio,
      TAB.CodigoAlmox, -- Cdigo do Almoxarifado
      TAB.CodigoCentroCusto -- Cdigo do Centro de Custo
  FROM (SELECT 
              DFIL.CODFIL, CAST(TO_CHAR(LeParametroDat('DAT_INV_EST_EXP_EME4',DFIL.CODFIL,'','','') ,'DDMMYYYY') AS VARCHAR(10)) AS SEQUEN, CAST('INV' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_INVENTARIO' AS VARCHAR(50)) AS DESTINO,
              CAST('INV' || DFIL.CODFIL || TO_CHAR(LeParametroDat('DAT_INV_EST_EXP_EME4',DFIL.CODFIL,'','','') ,'DDMMYYYY') AS VARCHAR(50)) AS CHAVE,
              CAST(Agora() AS Timestamp) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
              CAST(TO_NUMBER(DFIL.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
              LeParametroDat('DAT_INV_EST_EXP_EME4',DFIL.CODFIL,'','','') AS Data, -- Data do Inventrio
              CAST(LeParametroNum('TIPO_INV_EXP_EME4', DFIL.CODFIL, '', '', '') AS VARCHAR(1)) AS TipoInventario, -- 0=Inventrio Geral,1=Inventrio Cclico,2=Inventrio FCI
              CAST(TO_CHAR(LeParametroDat('DAT_INV_EST_EXP_EME4',DFIL.CODFIL,'','',''),'DDMMYYYY') AS VARCHAR(50)) AS Descricao, -- DescricaoInventario
              CAST('1' AS VARCHAR(1)) AS OrigemValorUni, -- 0=Preo Custo,1=Custo Mdio,
              CAST(0 AS Numeric(3)) AS CodigoAlmox, -- Cdigo do Almoxarifado
              CAST(NULL AS VARCHAR(10)) AS CodigoCentroCusto -- Cdigo do Centro de Custo
         FROM TD_FIL DFIL
        WHERE DFIL.CODFIL IN (LeParametroTxt('FILIAIS_INV_EXP_EME4', '', '', '', ''))
          AND DFIL.FILATI = 'T'
      ) TAB
 ORDER BY TAB.CODFIL
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Itens Cupom" (Tabela Integrao Mult)
/*-- SEQ 2668 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_ITEMCUPOMFISCAL CASCADE;

/*-- SEQ 2669 --*/
CREATE OR REPLACE VIEW TV_TIMU_ITEMCUPOMFISCAL AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.NUMITE, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE, TAB.VLRNOT_VALIDACAO,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.SeqNroItem, -- Sequncia do Item no documento
      TAB.CodigoProduto, -- Cdigo do Produto
      TAB.Quantidade, -- Quantidade de itens
      TAB.ValorUnitario, -- Valor Unitrio do Item
      TAB.ValLiquido, -- Valor Lquido do Item
      TAB.ValBruto, -- Valor Bruto do Item
      TAB.ValorDesconto, -- Valor total do desconto do item
      TAB.ValorAcrescimo, -- Valor total do Acrscimo do item
      TAB.Unidade, -- Cdigo da Unidade do Item no Documento com 6 posies
      TAB.UnidSPED, -- Cdigo da Unidade do Item no Documento com 2 posies - Unidade SPED
      TAB.CodigoContaFinanceira, -- Cdigo da Conta Financeira
      TAB.CodigoCentroCusto, -- Cdigo do Centro de Custo
      TAB.CodigoLote, -- Cdigo do Lote
      TAB.DataFabricacaoLote, -- Data de Fabricao do Lote
      TAB.DataValidadeLote, -- Data de Validade do Lote
      TAB.ValorPMC, -- Valor do Preo Mximo Medicamentos Venda Consumidor
      TAB.TributacaoICMS, -- Tipo Tributao: {0=Tributado,1=Isento,2=Subst. Tributria,3=No Incidente}
      TAB.AliqICMS, -- Alquota de ICMS
      TAB.CodListaPreco, -- Cdigo Lista de Preos do Item
      TAB.ItemTabela, -- Nome Item Tabela
      TAB.LPrecoPermForma, -- Lista de Preos do Item permite formao? {F=False,T=True}  Enviar como F sempre (Filtro interno)
      TAB.PercComis, -- Percentual de Comisso
      TAB.PercComissaoFixa, -- Perc. Comisso Fixa? {F=False,T=True}  Enviar como F por padro
      TAB.PercComisVendedor, -- Percentual de Comisso Vendedor
      TAB.PercComisFixaVendedor, -- Perc. Comisso Fixa para Vendedor? {F=False,T=True}  Enviar como F por padro
      TAB.PercComisSegRep, -- Percentual de Comisso Segundo Representante
      TAB.PercComisFixaSegRep, -- Perc. Comisso Fixa para Segundo Representante? {F=False,T=True} Enviar como F por padro
      TAB.SituacaoItem, -- Situao do Item: 0=Normal,1=Cancelado
      TAB.NumPedido, -- Nmero do Pedido (DAV/Pr-Venda)
      TAB.AliquotaPIS, -- Alquota do PIS para Produto
      TAB.PercRedPIS, -- Percentual de Reduo do PIS
      TAB.ValorPIS, -- Valor do PIS
      TAB.AliquotaCOFINS, -- Alquota COFINS
      TAB.PercRedCOFINS, -- Percentual de Reduo do COFINS
      TAB.ValorCOFINS, -- Valor COFINS
      TAB.AliquotaIPI, -- Alquota IPI
      TAB.ValorIPI, -- Valor IPI
      TAB.ValorICMS, -- Valor do ICMS
      TAB.ValorISS, -- Valor ISS
      TAB.CSTIPI, -- A=00 - Entrada com recuperao de crdito,B=01 - Entrada tributada com alquota zero,C=02 - Entrada isenta,D=03 - Entrada no-tributada,E=04 - Entrada imune,F=05 - Entrada com suspenso,
                  -- G=49 - Outras entradas,H=50 - Sada tributada,I=51 - Sada tributada com alquota zero,J=52 - Sada isenta,L=53 - Sada no-tributada,M=54 - Sada imune,N=55 - Sada com suspenso,O=99 - Outras sadas
      TAB.CSTPIS, -- A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,
                  -- I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,
                  -- J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,
                  -- M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,
                  -- P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,
                  -- S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,
                  -- V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,
                  -- 1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,
                  -- 6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
      TAB.CSTCOFINS, -- A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,
                     -- I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,
                     -- J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,
                     -- M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,
                     -- P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,
                     -- S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,
                     -- V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,
                     -- 1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,
                     -- 6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
      TAB.BaseICMSRetObs, -- Base do icms retido observao
      TAB.ValorICMSRetObs, -- Valor do icms retido observao
      TAB.ContPrevAliq, -- Alquota da contribuio previdenciaria
      TAB.ContPrevBas, -- Base da contribuio previdenciaria
      TAB.ContPrevValor, -- Valor da contribuio previdenciaria
      TAB.ContPrevRecBruta, -- Valor da Receita Bruta da contribuio previdenciaria
      TAB.ContPrevVlrExc, -- Valor das excluses da contribuio previdenciaria
      TAB.NumAlmox -- Nmero do Almoxarifado
  FROM (-- Item de Cupom Fiscal Emitidas
        SELECT
               VEN.CODFIL, VEN.SEQUEN, IVE.NUMITE, CAST('ICF' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_ITEMCUPOMFISCAL' AS VARCHAR(50)) AS DESTINO, COALESCE(VEN.DATINC, VEN.DATHOR) AS DATINC, VEN.ATU_EM, IVE.EXPORT, VEN.EXPEM4,
               CAST('VEN' || VEN.CODFIL || VEN.SEQUEN AS VARCHAR(50)) AS CHAVE,
               IVE.VLRMOV AS VLRNOT_VALIDACAO,
               COALESCE(VEN.DATINC, VEN.DATHOR) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               -- Definido juntamente com a EME4 quando for cupom fiscal enviar tipo de operao fixo
               CAST(CASE WHEN (VEN.CODSER = 'CF') THEN 998
                         WHEN (VEN.MODNOT = '65') THEN 997
                         WHEN (VEN.MODNOT = '59') THEN 996
                         WHEN (VEN.UFLOJA = 'T') THEN                                                       TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTDEM, '[^0-9]', '', 'gi'), ''))                         ELSE                               TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTFOR, '[^0-9]', '', 'gi'), ''))                    END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST(TO_NUMBER(VEN.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = VEN.FILCLI AND REL.CODPAR = VEN.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                         ELSE 'C' 
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST(TRIM(CASE WHEN VEN.CODSER='CF' THEN VEN.CODSER
                              WHEN ( (VEN.MODNOT = '65' OR VEN.MODNOT = '59') AND VEN.NUMECF >= '400' ) THEN VEN.NUMECF
                              WHEN VEN.CODSER<>'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN DSER.SEREXT
                              ELSE NULL
                         END) AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(TO_CHAR(TO_NUMBER(TRIM(CASE WHEN VEN.CODSER = 'CF' THEN VEN.SEQUEN 
                                                WHEN VEN.CODSER = 'ST' THEN COALESCE(TO_CHAR(VEN.SATCFE), VEN.NUMNOT)
                                                ELSE VEN.NUMNOT END))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST(IVE.NUMITE AS Numeric(9)) AS SeqNroItem, -- Sequncia do Item no documento
               CAST(TRIM(SUBSTR(GRA.CODFIS,1,30)) AS VARCHAR(30)) AS CodigoProduto, -- Cdigo do Produto
               --CAST(ABS(COALESCE(IVE.EMBQTD, IVE.QTDMOV)) AS Numeric(18,6)) AS Quantidade, -- Quantidade de itens
               CAST(ABS(IVE.QTDMOV) AS Numeric(18,6)) AS Quantidade, -- Quantidade de itens
               CAST(ABS((IVE.VLRMOV + CASE WHEN IVE.VLRDES < 0 THEN ABS(IVE.VLRDES) ELSE 0 END - ABS(COALESCE(IVE.VLRIPI,0))) / NVLZ(IVE.QTDMOV,1)) AS Numeric(16,6)) AS ValorUnitario, -- Valor Unitrio do Item
               CAST(ABS(IVE.VLRLIQRAT) AS Numeric(18,6)) AS ValLiquido, -- Valor Lquido do Item
               CAST((ABS(IVE.VLRMOV) + CASE WHEN (VEN.CODSER = 'CF') AND (IVE.VLRDES < 0) THEN ABS(IVE.VLRDES) ELSE 0 END - ABS(COALESCE(IVE.VLRIPI,0))) AS Numeric(18,6)) AS ValBruto, -- Valor Bruto do Item
               CAST(CASE WHEN (VEN.CODSER = 'CF') AND (IVE.VLRDES < 0) THEN ABS(IVE.VLRDES) ELSE 0 END +
                    CASE WHEN IVE.DESRAT < 0 THEN ABS(IVE.DESRAT) ELSE 0 END
                    AS Numeric(15,2)) AS ValorDesconto, -- Valor total do desconto do item
               CAST(CASE WHEN (VEN.CODSER = 'CF') AND (IVE.VLRDES > 0) THEN ABS(IVE.VLRDES) ELSE 0 END +
                    CASE WHEN (IVE.DESRAT > 0) THEN ABS(IVE.DESRAT) ELSE 0 END
                    AS Numeric(15,2)) AS ValorAcrescimo, -- Valor total do Acrscimo do item
               CAST(NULL AS VARCHAR(6)) AS Unidade, -- Cdigo da Unidade do Item no Documento com 6 posies
               CAST(DMED_VEN.UNIMED AS VARCHAR(2)) AS UnidSPED, -- Cdigo da Unidade do Item no Documento com 2 posies - Unidade SPED
                  CAST(NULL AS VARCHAR(10)) AS CodigoContaFinanceira, -- Cdigo da Conta Financeira
                  CAST(NULL AS VARCHAR(10)) AS CodigoCentroCusto, -- Cdigo do Centro de Custo
               CAST(TRIM(LOT.CODEXT) AS VARCHAR(30)) AS CodigoLote, -- Cdigo do Lote
               CAST(NULL AS Timestamp) AS DataFabricacaoLote, -- Data de Fabricao do Lote
               CAST(TRUNC(LOT.DATVAL) AS Timestamp) AS DataValidadeLote, -- Data de Validade do Lote
               CAST(NULL AS Numeric(15,2)) AS ValorPMC, -- Valor do Preo Mximo Medicamentos Venda Consumidor
               CAST(CASE WHEN IVE.ICMTIP='2' THEN '1'
                         WHEN IVE.ICMTIP='3' THEN '2'
                         WHEN IVE.ICMTIP IN ('1', '4') THEN '3'
                         ELSE '0'
                    END AS VARCHAR(1)) AS TributacaoICMS, -- Tipo Tributao: {0=Tributado,1=Isento,2=Subst. Tributria,3=No Incidente}
               CAST(CASE WHEN SUBSTR(IVE.CODCST,2,2) IN ('60', '40', '41') OR IVE.CODCST = '500' THEN 0
                         ELSE ABS(COALESCE(IVE.TAX001,0))
                    END AS Numeric(15,2)) AS AliqICMS, -- Alquota de ICMS
               CAST(SUBSTR(TPR.CODEXT, 1, INSTR(TPR.CODEXT, '-')-1) AS VARCHAR(20)) AS CodListaPreco, -- Cdigo Lista de Preos do Item
               CAST(SUBSTR(TPR.CODEXT, INSTR(TPR.CODEXT, '-')+1, LENGTH(TPR.CODEXT))AS VARCHAR(30))  AS ItemTabela, -- Nome Item Tabela
               CAST('F' AS VARCHAR(1)) AS LPrecoPermForma, -- Lista de Preos do Item permite formao? {F=False,T=True}  Enviar como F sempre (Filtro interno)
               CAST(NULL AS Numeric(15,2)) AS PercComis, -- Percentual de Comisso
               CAST('F' AS VARCHAR(1)) AS PercComissaoFixa, -- Perc. Comisso Fixa? {F=False,T=True}  Enviar como F por padro
               CAST(NULL AS Numeric(15,2)) AS PercComisVendedor, -- Percentual de Comisso Vendedor
               CAST('F' AS VARCHAR(1)) AS PercComisFixaVendedor, -- Perc. Comisso Fixa para Vendedor? {F=False,T=True}  Enviar como F por padro
               CAST(NULL AS Numeric(15,2)) AS PercComisSegRep, -- Percentual de Comisso Segundo Representante
               CAST('F' AS VARCHAR(1)) AS PercComisFixaSegRep, -- Perc. Comisso Fixa para Segundo Representante? {F=False,T=True} Enviar como F por padro
               CAST(CASE WHEN IVE.SITMOV = 'C' THEN '1'
                         ELSE '0'
                    END AS VARCHAR(1)) AS SituacaoItem, -- Situao do Item: 0=Normal,1=Cancelado
               CAST((SELECT COALESCE(ORC.NUMPED_RE, ORC.NUMPED )
                       FROM TT_IOR IOR INNER JOIN TT_ORC ORC ON ORC.CODFIL = IOR.CODFIL
                                                            AND ORC.TIPPED = IOR.TIPPED
                                                            AND ORC.NUMPED = IOR.NUMPED
                      WHERE IOR.FILIVE = IVE.CODFIL 
                        AND IOR.SEQIVE = IVE.SEQUEN 
                        AND IOR.NUMIVE = IVE.NUMITE 
                        AND (
                             (LeParametroBoo('EXP_DAV_EME4',IVE.CODFIL,'','','') = 'T') OR
                             (LeParametroBoo('EXP_NUMDAV_EME4',IVE.CODFIL,'','','') = 'T')
                            )
                     ) AS Numeric(10)) AS NumPedido, -- Nmero do Pedido (DAV/Pr-Venda)
               CAST(CASE WHEN PRO.CODFPS <> '09' THEN ABS(IVE.PERPIS) ELSE 0 END AS Numeric(18,6)) AS AliquotaPIS, -- Alquota do PIS para Produto
               CAST(NULL AS Numeric(18,6)) AS PercRedPIS, -- Percentual de Reduo do PIS
               CAST(ABS(IVE.VLRPIS) AS Numeric(18,6)) AS ValorPIS, -- Valor do PIS
               CAST(ABS(IVE.PERCOF) AS Numeric(18,6)) AS AliquotaCOFINS, -- Alquota COFINS
               CAST(NULL AS Numeric(18,6)) AS PercRedCOFINS, -- Percentual de Reduo do COFINS
               CAST(ABS(IVE.VLRCOF) AS Numeric(18,6)) AS ValorCOFINS, -- Valor COFINS
               CAST(ABS(IVE.TAXIPI) AS Numeric(18,6)) AS AliquotaIPI, -- Alquota IPI
               CAST(ABS(IVE.VLRIPI) AS Numeric(18,6)) AS ValorIPI, -- Valor IPI
               CAST(ABS(COALESCE(IVE.VLRICM, IVE.VLR001)) AS Numeric(15,2)) AS ValorICMS, -- Valor do ICMS
               CAST(CASE WHEN IVE.SITISS IN ('N','S') THEN ABS(IVE.VLRISS)
                         ELSE 0
                    END AS Numeric(15,2)) AS ValorISS, -- Valor ISS
               CAST(CASE IVE.SITIPI WHEN '00' THEN 'A'
                                    WHEN '01' THEN 'B'
                                    WHEN '02' THEN 'C'
                                    WHEN '03' THEN 'D'
                                    WHEN '04' THEN 'E'
                                    WHEN '06' THEN 'F'
                                    WHEN '49' THEN 'G'
                                    WHEN '50' THEN 'H'
                                    WHEN '51' THEN 'I'
                                    WHEN '52' THEN 'J'
                                    WHEN '53' THEN 'L'
                                    WHEN '54' THEN 'M'
                                    WHEN '55' THEN 'N'
                                    WHEN '99' THEN 'O'
                                    ELSE 'O'
                     END AS VARCHAR(1)) AS CSTIPI, -- A=00 - Entrada com recuperao de crdito,B=01 - Entrada tributada com alquota zero,C=02 - Entrada isenta,D=03 - Entrada no-tributada,E=04 - Entrada imune,F=05 - Entrada com suspenso,
                                                   -- G=49 - Outras entradas,H=50 - Sada tributada,I=51 - Sada tributada com alquota zero,J=52 - Sada isenta,L=53 - Sada no-tributada,M=54 - Sada imune,N=55 - Sada com suspenso,O=99 - Outras sadas
               CAST(CASE IVE.SITPIS WHEN '01' THEN 'A'
                                    WHEN '02' THEN 'B'
                                    WHEN '03' THEN 'C'
                                    WHEN '04' THEN 'D'
                                    WHEN '06' THEN 'E'
                                    WHEN '07' THEN 'F'
                                    WHEN '08' THEN 'G'
                                    WHEN '09' THEN 'H'
                                    WHEN '05' THEN 'I'
                                    WHEN '49' THEN 'J'
                                    WHEN '50' THEN 'K'
                                    WHEN '51' THEN 'L'
                                    WHEN '52' THEN 'M'
                                    WHEN '53' THEN 'N'
                                    WHEN '54' THEN 'O'
                                    WHEN '55' THEN 'P'
                                    WHEN '56' THEN 'Q'
                                    WHEN '60' THEN 'R'
                                    WHEN '61' THEN 'S'
                                    WHEN '62' THEN 'T'
                                    WHEN '63' THEN 'U'
                                    WHEN '64' THEN 'V'
                                    WHEN '65' THEN 'W'
                                    WHEN '66' THEN 'X'
                                    WHEN '67' THEN '1'
                                    WHEN '70' THEN '2'
                                    WHEN '71' THEN '3'
                                    WHEN '72' THEN '4'
                                    WHEN '73' THEN '5'
                                    WHEN '74' THEN '6'
                                    WHEN '75' THEN '7'
                                    WHEN '98' THEN 'Y'
                                    WHEN '99' THEN 'Z'
                                    ELSE 'Z'
                     END AS VARCHAR(2)) AS CSTPIS, -- A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,
                                                   -- I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,
                                                   -- J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,
                                                   -- M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,
                                                   -- P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,
                                                   -- S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,
                                                   -- V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,
                                                   -- 1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,
                                                   -- 6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
               CAST(CASE IVE.SITCOF WHEN '01' THEN 'A'
                                    WHEN '02' THEN 'B'
                                    WHEN '03' THEN 'C'
                                    WHEN '04' THEN 'D'
                                    WHEN '06' THEN 'E'
                                    WHEN '07' THEN 'F'
                                    WHEN '08' THEN 'G'
                                    WHEN '09' THEN 'H'
                                    WHEN '05' THEN 'I'
                                    WHEN '49' THEN 'J'
                                    WHEN '50' THEN 'K'
                                    WHEN '51' THEN 'L'
                                    WHEN '52' THEN 'M'
                                    WHEN '53' THEN 'N'
                                    WHEN '54' THEN 'O'
                                    WHEN '55' THEN 'P'
                                    WHEN '56' THEN 'Q'
                                    WHEN '60' THEN 'R'
                                    WHEN '61' THEN 'S'
                                    WHEN '62' THEN 'T'
                                    WHEN '63' THEN 'U'
                                    WHEN '64' THEN 'V'
                                    WHEN '65' THEN 'W'
                                    WHEN '66' THEN 'X'
                                    WHEN '67' THEN '1'
                                    WHEN '70' THEN '2'
                                    WHEN '71' THEN '3'
                                    WHEN '72' THEN '4'
                                    WHEN '73' THEN '5'
                                    WHEN '74' THEN '6'
                                    WHEN '75' THEN '7'
                                    WHEN '98' THEN 'Y'
                                    WHEN '99' THEN 'Z'
                                    ELSE 'Z'
                     END AS VARCHAR(2)) AS CSTCOFINS, -- A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,
                                                      -- I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,
                                                      -- J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,
                                                      -- M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,
                                                      -- P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,
                                                      -- S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,
                                                      -- V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,
                                                      -- 1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,
                                                      -- 6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
                     CAST(ABS(IVE.BASUBS) AS Numeric(15,2)) AS BaseICMSRetObs, -- Base do icms retido observao
                     CAST(ABS(IVE.SUBSTT) AS Numeric(15,2)) AS ValorICMSRetObs, -- Valor do icms retido observao
                     CAST(NULL AS Numeric(15,2)) AS ContPrevAliq, -- Alquota da contribuio previdenciaria
                     CAST(NULL AS Numeric(15,2)) AS ContPrevBas, -- Base da contribuio previdenciaria
                     CAST(NULL AS Numeric(15,2)) AS ContPrevValor, -- Valor da contribuio previdenciaria
                     CAST(NULL AS Numeric(15,2)) AS ContPrevRecBruta, -- Valor da Receita Bruta da contribuio previdenciaria
                     CAST(NULL AS Numeric(15,2)) AS ContPrevVlrExc, -- Valor das excluses da contribuio previdenciaria
                     CAST(TO_NUMBER(DMUL.CODEXT_DMUL) AS Numeric(10)) AS NumAlmox -- Nmero do Almoxarifado
          FROM TT_IVE IVE
          JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
          -- Srie de Emisso
          JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
          -- Natureza
          JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
          -- Cliente
          JOIN TT_CLI PAR ON PAR.FILCLI = VEN.FILCLI AND PAR.CODCLI = VEN.CODCLI
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = VEN.FILCLI AND ENDFAT.CODCLI = VEN.CODCLI AND ENDFAT.CODFIL = VEN.FILFAT AND ENDFAT.NUMEND = VEN.ENDFAT
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          -- Produto
          JOIN TT_GRA GRA ON GRA.FILMAT = IVE.FILMAT AND GRA.CODMAT = IVE.CODMAT AND GRA.CODCOR = IVE.CODCOR AND GRA.CODTAM = IVE.CODTAM /*COALESCE(IVE.EMBORI, IVE.CODTAM)*/
          JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
          LEFT JOIN TD_MED DMED_VEN ON DMED_VEN.CODTAB = GRA.UNIDAD
          -- Lote
          LEFT JOIN TT_LOT LOT ON LOT.CODFIL = IVE.FILLOT AND LOT.SEQUEN = IVE.SEQLOT
          -- Tabela de Preo
          JOIN TT_TPR TPR ON TPR.CODFIL = VEN.FILPRE AND TPR.CODPRE= VEN.CODPRE
          JOIN TD_MUL DMUL ON IVE.CODMUL = DMUL.CODTAB
         WHERE VEN.CODSER = 'CF'
           AND VEN.NUMNOT NOT LIKE '%#%'
           AND IVE.SITKIT IN ('2','3')
           AND VEN.DATHOR >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',VEN.CODFIL,'','','') 
           AND VEN.EXPEM4 = 'F'
       ) TAB
;


-- Autor: Carla Alves
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Liquidaes do Documento" (Tabela Integrao Mult)
-- Arquivo Pai: TIMU_LIQUIDACAODOCTO
/*-- SEQ 2670 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_LIQUIDACAOCC CASCADE;

/*-- SEQ 2671 --*/
CREATE OR REPLACE VIEW TV_TIMU_LIQUIDACAOCC AS
   SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      TAB.CODFIL, TAB.SEQUEN, TAB.NUMPAR, TAB.SUBPAR, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.FilialAdtoADC, -- Cdigo da Filial do Adiantamento de Cliente
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.FormaLiquidacao, -- Informar uma das opes: 'Liquidao Carto CRE', 'Liquidao Cheque CRE', 'Liquidao Duplicata', 'Liquidao Operao Caixa', 'Liquidao Convnio CRE', 'Liquidao Adiant. Cliente', 'Troco Dinheiro'
      TAB.TPPADCONTA, -- Tipo padro de conta tesouraria. Informar uma das opes. 0 - Conta Caixa, 1 - Conta Bancria, 2 - Conta Convnio  Receber, 3 - Conta Convnio  Pagar, 4 - Conta Carto  Pagar, 5 - Conta Carto  Receber, 6 - Conta Aplicao Financeira
      TAB.CodContaTes, -- Cdigo da Conta Tesouraria para onde vai a liquidao
      TAB.ValorFormaLiqOri, -- Valor da Forma de Liquidao Original
      TAB.ValorFormaLiq, -- Valor da Forma de Liquidao
      TAB.Historico, -- Histrico da Liquidao
      TAB.DataVctoCartao, -- Primeira Data de Vencimento do Carto (Operao Carto)
      COALESCE(TAB.TaxaCartaoParcelas, TAB.TaxaCartao) AS TaxaCartao, -- Taxa do carto (Operao Carto)
      TAB.TipoCartao, -- {1 - Crdito / 2 - Dbito} (Operao Carto)
      TAB.GerenciadorTEF, -- {0 - Nenhum / 1 - TEF Disc / 2 - TEF Dial / 3 - Hiper TEF} (Operao Carto)
      TAB.TipoParcelamento, -- {0 -  Vista / 1 - Parc. Administradora / 2 - Parc. Lojista} (Operao Carto)
      TAB.NumeroParcelas, -- Nmero de Parcelas - Esse nmero deve ser igual ao nmero de parcelas do documento (Operao Carto)
      TAB.NSU, -- Nmero Transao (Operao Carto)
      TAB.CodAutTransacao, -- Cdigo de Autorizao da Transao (Operao Carto)
      TAB.NumeroRVRO, -- Nmero do Resumo de Vendas ou de Operao (Operao Carto)
      TAB.DataEntradaCaixa, -- Data Entrada (Operao Caixa)
      TAB.CodigoBanco, -- Cdigo do Banco (Operao Cheque)
      TAB.CODAGENCIA, -- Cdigo da Agncia (Operao Cheque)
      TAB.CODCONTABAN, -- Cdigo da Conta Bancria (Operao Cheque)
      TAB.NumeroCheque, -- Nmero Cheque (Operao Cheque)
      TAB.Tipificacao, -- Tipificao (Operao Cheque)
      TAB.DataVctoCheque, -- Data de Vencimento (Operao Cheque)
      TAB.ChequeTerceiro, --  Cheque Terceiro? (Operao Cheque) {F=False, T=True} Enviar como F por padro
      TAB.CPFCNPJCheque, -- CPF ou CNPJ da Identificao Cliente (Operao Cheque)
      TAB.DataVctoDuplicata, -- Data de Vencimento (Operao Duplicata)
      TAB.Parcela, -- N Parcela (Operao Duplicata)
      TAB.MoraAtrasoDuplic, -- Taxa Mora Atraso (Operao Duplicata)
      TAB.MoraAntecipDuplic, -- Taxa Mora Antecipao (Operao Duplicata)
      TAB.DiasJurosAtrasoDuplic, -- Dias Cobrar Juros Atraso (Operao Duplicata)
      TAB.DiasJurosAntecDuplic, -- Dias Cobrar Juros Antecipao (Operao Duplicata)
      TAB.CodigoCliConv, -- Cdigo do Cliente Conveniado
      TAB.CPFCNPJCliConv, -- CPF ou CNPJ do Cliente Conveniado
      TAB.CPFCNPJConvenio, -- CPF ou CNPJ do Convnio
      TAB.NumeroParcelasConv, -- Nmero de Parcelas (Operao Convnio)
      TAB.NroDoctoAdtoADC -- Nmero do Documento de Origem do Adiantamento
     FROM (
        -- Liquidao para Documentos de Conta Corrente
        SELECT
               CCC.CODFIL, 
               CCC.SEQUEN, 
               CCC.NUMPAR, 
               CCC.SUBPAR, 
               CAST('CCC' AS VARCHAR(3)) AS ORIGEM, 
               CAST('TIMU_LIQUIDACAODOCTO' AS VARCHAR(50)) AS DESTINO, 
               CCC.DATINC, 
               CCC.DATINC AS ATU_EM, 
               CCC.EXPORT, 
               CCC.EXPEM4,
               CAST('CCC' || CCC.CODFIL || CCC.SEQUEN  AS VARCHAR(50)) AS CHAVE,
               CCC.DATINC AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               -- Tipo de Operao exportado de forma fixa conforme conversado com a EME4
               CAST(CASE WHEN CCC.TIPLAN = 'D' THEN 992 ELSE 993 END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao (992-Deposito / 993-Retirada)
               CAST(TO_NUMBER(CCC.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN ((ISNULL(CCC.SEQCHR) = 'T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') AND (COALESCE(CCC.VLRLAN, 0) < 0)) THEN TO_NUMBER(CCC.CODFIL)
                         ELSE NULL -- Envia NULL quando "FormaLiquidacao = Liquidao Adiant. Cliente"
                    END AS Numeric(3)) AS FilialAdtoADC, -- Cdigo da Filial do Adiantamento de Cliente
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         WHEN ((ISNULL(CCC.SEQCHR) = 'T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') AND (COALESCE(CCC.VLRLAN, 0) < 0)) THEN 
                              TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                         ELSE NULL -- Envia NULL quando "FormaLiquidacao = Liquidao Adiant. Cliente"
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(CASE WHEN ((ISNULL(CCC.SEQCHR) = 'T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') AND (COALESCE(CCC.VLRLAN, 0) < 0)) THEN TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))
                         ELSE NULL -- Envia NULL quando "FormaLiquidacao = Liquidao Adiant. Cliente"
                    END AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN ((ISNULL(CCC.SEQCHR) = 'T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') AND (COALESCE(CCC.VLRLAN, 0) < 0)) THEN
                                CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = CCC.FILCLI AND REL.CODPAR = CCC.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                                     ELSE 'C' 
                                END 
                         ELSE NULL -- Envia NULL quando "FormaLiquidacao = Liquidao Adiant. Cliente"
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST('CC'|| CCC.NUMECF AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(TRIM(CCC.SEQUEN) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST(CASE WHEN (ISNOTNULL(CCC.SEQCHR) = 'T') THEN 'Liquidao Cheque CRE'
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN 'Liquidao Convnio CRE'
                         --WHEN (COALESCE(CCC.VLRLAN, 0) < 0) THEN 'Liquidao Adiant. Cliente'
                         WHEN (COALESCE(CCC.VLRLAN, 0) < 0) THEN 'Liquidao Operao Caixa'
                         WHEN (DCOB.TIPCOB IN ('B','L','O','P')) OR (CCC.CODVEN IS NOT NULL) THEN 'Liquidao Duplicata'
                         ELSE 'Liquidao Operao Caixa'
                    END AS VARCHAR(50)) AS FormaLiquidacao, -- Informar uma das opes: 'Liquidao Carto CRE', 'Liquidao Cheque CRE', 'Liquidao Duplicata', 'Liquidao Operao Caixa', 'Liquidao Convnio CRE', 'Liquidao Adiant. Cliente', 'Troco Dinheiro'
               CAST(CASE WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN '2'
                         ELSE '0'
                    END AS VARCHAR(1)) AS TPPADCONTA, -- Tipo padro de conta tesouraria. Informar uma das opes. 0 - Conta Caixa, 1 - Conta Bancria, 2 - Conta Convnio  Receber, 3 - Conta Convnio  Pagar, 4 - Conta Carto  Pagar, 5 - Conta Carto  Receber, 6 - Conta Aplicao Financeira
               CAST(CASE WHEN (ISNOTNULL(CCC.SEQCHR) = 'T') THEN TRIM(COALESCE(CXF.CODEXT, CTA.CODEXT, CODIGO_CONTA(CTA.CODFIL, CTA.SEQUEN, 'X')))
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN NULL
                         ELSE TRIM(COALESCE(CXF.CODEXT, CTA.CODEXT, CODIGO_CONTA(CTA.CODFIL, CTA.SEQUEN, 'X')))
                    END AS VARCHAR(20)) AS CodContaTes, -- Cdigo da Conta Tesouraria para onde vai a liquidao
               CAST(ABS(CCC.VLRLAN) AS Numeric(15,2)) AS ValorFormaLiqOri, -- Valor da Forma de Liquidao Original
               CAST(ABS(CCC.VLRLAN) AS Numeric(15,2)) AS ValorFormaLiq, -- Valor da Forma de Liquidao
               CAST(CASE WHEN (ISNOTNULL(CCC.SEQCHR) = 'T') THEN 'Liquidao Cheque CRE'
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN 'Liquidao Convnio CRE'
                         --WHEN (COALESCE(CCC.VLRLAN, 0) < 0) THEN 'Liquidao Adiant. Cliente'
                         WHEN (COALESCE(CCC.VLRLAN, 0) < 0) THEN 'Liquidao Operao Caixa'
                         WHEN (DCOB.TIPCOB IN ('B','L','O','P')) OR (CCC.CODVEN IS NOT NULL) THEN 'Liquidao Duplicata'
                         ELSE 'Liquidao Operao Caixa'
                    END AS VARCHAR(150)) AS Historico, -- Histrico da Liquidao
               -- Carto
               CAST(NULL AS Timestamp) AS DataVctoCartao, -- Primeira Data de Vencimento do Carto (Operao Carto)
               CAST(NULL AS Numeric(15,2)) AS TaxaCartao, -- Taxa do carto (Operao Carto)
               CAST(NULL AS Numeric(15,2)) AS TaxaCartaoParcelas, -- Taxa do carto (Operao Carto)
               CAST(NULL AS VARCHAR(1)) AS TipoCartao, -- {1 - Crdito / 2 - Dbito} (Operao Carto)
               CAST('0' AS VARCHAR(1)) AS GerenciadorTEF, -- {0 - Nenhum / 1 - TEF Disc / 2 - TEF Dial / 3 - Hiper TEF} (Operao Carto)
               CAST('0' AS VARCHAR(1)) AS TipoParcelamento, -- {0 -  Vista / 1 - Parc. Administradora / 2 - Parc. Lojista} (Operao Carto)
               CAST(NULL AS Numeric(8)) AS NumeroParcelas, -- Nmero de Parcelas - Esse nmero deve ser igual ao nmero de parcelas do documento (Operao Carto)
               CAST(NULL AS VARCHAR(20)) AS NSU, -- Nmero Transao (Operao Carto)
               CAST(NULL AS VARCHAR(20)) AS CodAutTransacao, -- Cdigo de Autorizao da Transao (Operao Carto)
               CAST(NULL AS VARCHAR(20)) AS NumeroRVRO, -- Nmero do Resumo de Vendas ou de Operao (Operao Carto)
               -- Operao
               CAST(TRUNC(CCC.DATOPE) AS Timestamp) AS DataEntradaCaixa, -- Data Entrada (Operao Caixa)
               -- Cheque
               CAST(TO_NUMBER(CHR.CODBCO) AS Numeric(9)) AS CodigoBanco, -- Cdigo do Banco (Operao Cheque)
               CAST(CHR.CODAGE AS VARCHAR(10)) AS CODAGENCIA, -- Cdigo da Agncia (Operao Cheque)
               CAST(CHR.NUMCON AS VARCHAR(10)) AS CODCONTABAN, -- Cdigo da Conta Bancria (Operao Cheque)
               CAST(TO_NUMBER(CHR.NUMCHE) AS Numeric(9)) AS NumeroCheque, -- Nmero Cheque (Operao Cheque)
               CAST(NULL AS Numeric(9)) AS Tipificacao, -- Tipificao (Operao Cheque)
               CAST(CASE WHEN (ISNOTNULL(CCC.SEQCHR)='T') THEN CCC.DATOPE 
                         ELSE NULL
                    END AS Timestamp) AS DataVctoCheque, -- Data de Vencimento (Operao Cheque)
               CAST(CASE WHEN (ISNULL(CCC.SEQCHR)='T') THEN 'F'
                         WHEN (CHR.FILCLI||CHR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) AND (CCC.FILCLI||CCC.CODCLI = CHR.FILCLI||CHR.CODCLI) AND (ISNOTNULL(CHR.FILCLI) = 'T') THEN 'F'
                         ELSE 'T'
                    END AS VARCHAR(1)) AS ChequeTerceiro, --  Cheque Terceiro? (Operao Cheque) {F=False, T=True} Enviar como F por padro
               CAST(TRIM(COALESCE(CHR.NUMDOC, CHR_PAR.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCheque, -- CPF ou CNPJ da Identificao Cliente (Operao Cheque)
               -- Crdiario/Boleto
               CAST(CASE WHEN (ISNULL(CCC.SEQCHR)='T') AND ((CASE WHEN (ISNOTNULL(DCCC.DESCCC) = 'T') THEN UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) ELSE 'CREDIARIO' END) <> 'CONVENIO CRE') THEN CCC.DATOPE 
                         ELSE NULL
                    END AS Timestamp) AS DataVctoDuplicata, -- Data de Vencimento (Operao Duplicata)
               CAST(NULL AS Numeric(9)) AS Parcela, -- N Parcela (Operao Duplicata)
               CAST(NULL AS Numeric(15,5)) AS MoraAtrasoDuplic, -- Taxa Mora Atraso (Operao Duplicata)
               CAST(NULL AS Numeric(15,5)) AS MoraAntecipDuplic, -- Taxa Mora Antecipao (Operao Duplicata)
               CAST(NULL AS Numeric(9)) AS DiasJurosAtrasoDuplic, -- Dias Cobrar Juros Atraso (Operao Duplicata)
               CAST(NULL AS Numeric(9)) AS DiasJurosAntecDuplic, -- Dias Cobrar Juros Antecipao (Operao Duplicata)
               -- Convnio
               CAST(CASE WHEN (ISNULL(CCC.SEQCHR)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') AND (LeParametroTXT('TIPO_EXP_EME4', CCC.CODFIL, '', '', '')='C') THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0') ELSE NULL END AS Numeric(9)) AS CodigoCliConv, -- Cdigo do Cliente Conveniado
               CAST(CASE WHEN (ISNULL(CCC.SEQCHR)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN PAR.NUMDOC ELSE NULL END AS VARCHAR(18)) AS CPFCNPJCliConv, -- CPF ou CNPJ do Cliente Conveniado
               CAST(CASE WHEN (ISNULL(CCC.SEQCHR)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN VIN_CNV.NUMDOC ELSE NULL END AS VARCHAR(18)) AS CPFCNPJConvenio, -- CPF ou CNPJ do Convnio
               CAST(CASE WHEN (ISNULL(CCC.SEQCHR)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN 1 ELSE NULL END AS Numeric(8)) AS NumeroParcelasConv, -- Nmero de Parcelas (Operao Convnio)
               CAST(NULL AS VARCHAR(25)) AS NroDoctoAdtoADC -- Nmero do Documento de Origem do Adiantamento
          FROM TT_CCC CCC
          LEFT OUTER JOIN TD_CCC DCCC ON DCCC.CODTAB = CCC.TIPCCC
          -- Cliente
          JOIN TT_CLI PAR ON PAR.FILCLI = CCC.FILCLI AND PAR.CODCLI = CCC.CODCLI
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = CCC.FILCLI AND ENDFAT.CODCLI = CCC.CODCLI
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          -- Portador
          JOIN TD_COB DCOB ON DCOB.CODTAB = CCC.PORORI
          -- Conta Financeira
          JOIN TT_CTA CTA ON CTA.CODFIL = DCOB.FILCTA AND CTA.SEQUEN = DCOB.SEQCTA AND CTA.TIPCTA  = DCOB.TIPCTA
          --Cdigo externo da conta financeira
          LEFT JOIN TT_CTAXFIL CXF ON CXF.FILCTA = CTA.CODFIL AND CXF.SEQCTA = CTA.SEQUEN AND CXF.CODFIL = CCC.CODFIL
          -- Cheque
          LEFT JOIN TT_CHR CHR ON CHR.CODFIL = CCC.CODFIL AND CHR.SEQUEN = CCC.SEQCHR
          -- Parceiro do Cheque
          LEFT JOIN TT_CLI CHR_PAR ON CHR_PAR.FILCLI = CHR.FILCLI AND CHR_PAR.CODCLI = CHR.CODCLI
          -- Parceiro Vinculado - Convnio
          LEFT JOIN TT_CLI VIN_CNV ON VIN_CNV.FILCLI = PAR.FILVIN AND VIN_CNV.CODCLI = PAR.CODVIN
         WHERE 1=1
           AND COALESCE(CCC.INDEXP, 'E') <> 'N'
           AND CCC.TIPLAN IN('D','I')
           AND CCC.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',CCC.CODFIL,'','','')
           AND (LeParametroTXT('TIPO_EXP_EME4', CCC.CODFIL, '', '', '') = 'V')
           AND CCC.EXPEM4 = 'F'
     ) TAB
   WHERE 1=1
     AND TAB.TipoOperacao IS NOT NULL
ORDER BY TAB.CODFIL, TAB.SEQUEN, TAB.DataHoraAtuReg
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Liquidaes do Documento" (Tabela Integrao Mult)
-- Arquivo Pai: TIMU_LIQUIDACAODOCTO
/*-- SEQ 2672 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_LIQUIDACAODOCTOLIQ CASCADE;

/*-- SEQ 2673 --*/
CREATE OR REPLACE VIEW TV_TIMU_LIQUIDACAODOCTOLIQ AS
   SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.NUMPAR, TAB.SUBPAR, TAB.CODSER, TAB.SUBSER, TAB.NUMECF, TAB.NUMNOT, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.FilialAdtoADC, -- Cdigo da Filial do Adiantamento de Cliente
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.FormaLiquidacao, -- Informar uma das opes: 'Liquidao Carto CRE', 'Liquidao Cheque CRE', 'Liquidao Duplicata', 'Liquidao Operao Caixa', 'Liquidao Convnio CRE', 'Liquidao Adiant. Cliente', 'Troco Dinheiro', 'Liquidao Operao Bancaria'
      TAB.TPPADCONTA, -- Tipo padro de conta tesouraria. Informar uma das opes. 0 - Conta Caixa, 1 - Conta Bancria, 2 - Conta Convnio  Receber, 3 - Conta Convnio  Pagar, 4 - Conta Carto  Pagar, 5 - Conta Carto  Receber, 6 - Conta Aplicao Financeira
      TAB.CodContaTes, -- Cdigo da Conta Tesouraria para onde vai a liquidao
      TAB.ValorFormaLiqOri, -- Valor da Forma de Liquidao Original
      TAB.ValorFormaLiq, -- Valor da Forma de Liquidao
      TAB.Historico, -- Histrico da Liquidao
      TAB.DataVctoCartao, -- Primeira Data de Vencimento do Carto (Operao Carto)
      COALESCE(TAB.TaxaCartaoParcelas, TAB.TaxaCartao) AS TaxaCartao, -- Taxa do carto (Operao Carto)
      TAB.TipoCartao, -- {1 - Crdito / 2 - Dbito} (Operao Carto)
      TAB.GerenciadorTEF, -- {0 - Nenhum / 1 - TEF Disc / 2 - TEF Dial / 3 - Hiper TEF} (Operao Carto)
      TAB.TipoParcelamento, -- {0 -  Vista / 1 - Parc. Administradora / 2 - Parc. Lojista} (Operao Carto)
      TAB.NumeroParcelas, -- Nmero de Parcelas - Esse nmero deve ser igual ao nmero de parcelas do documento (Operao Carto)
      TAB.NSU, -- Nmero Transao (Operao Carto)
      TAB.CodAutTransacao, -- Cdigo de Autorizao da Transao (Operao Carto)
      TAB.NumeroRVRO, -- Nmero do Resumo de Vendas ou de Operao (Operao Carto)
      TAB.DataEntradaCaixa, -- Data Entrada (Operao Caixa)
      TAB.CodigoBanco, -- Cdigo do Banco (Operao Cheque)
      TAB.CODAGENCIA, -- Cdigo da Agncia (Operao Cheque)
      TAB.CODCONTABAN, -- Cdigo da Conta Bancria (Operao Cheque)
      TAB.NumeroCheque, -- Nmero Cheque (Operao Cheque)
      TAB.Tipificacao, -- Tipificao (Operao Cheque)
      TAB.DataVctoCheque, -- Data de Vencimento (Operao Cheque)
      TAB.ChequeTerceiro, --  Cheque Terceiro? (Operao Cheque) {F=False, T=True} Enviar como F por padro
      TAB.CPFCNPJCheque, -- CPF ou CNPJ da Identificao Cliente (Operao Cheque)
      TAB.DataVctoDuplicata, -- Data de Vencimento (Operao Duplicata)
      TAB.Parcela, -- N Parcela (Operao Duplicata)
      TAB.MoraAtrasoDuplic, -- Taxa Mora Atraso (Operao Duplicata)
      TAB.MoraAntecipDuplic, -- Taxa Mora Antecipao (Operao Duplicata)
      TAB.DiasJurosAtrasoDuplic, -- Dias Cobrar Juros Atraso (Operao Duplicata)
      TAB.DiasJurosAntecDuplic, -- Dias Cobrar Juros Antecipao (Operao Duplicata)
      TAB.CodigoCliConv, -- Cdigo do Cliente Conveniado
      TAB.CPFCNPJCliConv, -- CPF ou CNPJ do Cliente Conveniado
      TAB.CPFCNPJConvenio, -- CPF ou CNPJ do Convnio
      TAB.NumeroParcelasConv, -- Nmero de Parcelas (Operao Convnio)
      TAB.NroDoctoAdtoADC -- Nmero do Documento de Origem do Adiantamento
     FROM (
        -- Liquidao para Documentos de Pagamentos
        SELECT
               LID.CODFIL,
               CAST(LPAD(TO_CHAR(LID.TRN_ID), 10, ' ') AS CHAR(10)) AS SEQUEN, -- REC.SEQUEN
               CAST(' 0' AS CHAR(2)) AS NUMPAR,
               CAST(' 0' AS CHAR(2)) AS SUBPAR,
               CAST('LID' AS VARCHAR(3)) AS ORIGEM, 
               CAST('TIMU_LIQUIDACAODOCTO' AS VARCHAR(50)) AS DESTINO, 
               LID.DATHOR AS DATINC, 
               LID.DATEXE AS ATU_EM, 
               LID.EXPEM4 AS EXPORT, 
               LID.EXPEM4,
               CAST('999' AS VARCHAR(3)) AS CODSER, CAST(NULL AS VARCHAR(3)) AS SUBSER, CAST(LID.NUMECF AS CHAR(3)) AS NUMECF, CAST(LID.CUPFIS AS VARCHAR(10)) AS NUMNOT,
               CAST('PGT' || LID.CODFIL|| TO_CHAR(LID.TRN_ID) || LID.NUMECF || LID.CUPFIS AS VARCHAR(50)) AS CHAVE,
               LID.DATEXE AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               -- Tipo de Operao exportado de forma fixa conforme conversado com a EME4
               CAST(999 AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST( CASE WHEN (UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'PIX' OR UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'CARDSE') THEN NULL --Solicitao da EME4 para integ. PIX
                     ELSE TO_NUMBER(LID.CODFIL)
                     END AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'PIX' OR UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'CARDSE') THEN NULL --Solicitao EME4.
                         WHEN (OPE.CARTAO IS NULL AND (ISNULL(OPE.SEQCHR) = 'T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') AND (COALESCE(CCC.VLRLAN, 0) < 0)) THEN TO_NUMBER(VEN.CODFIL)
                         ELSE NULL -- Envia NULL quando "FormaLiquidacao = Liquidao Adiant. Cliente"
                    END AS Numeric(3)) AS FilialAdtoADC, -- Cdigo da Filial do Adiantamento de Cliente
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         WHEN (OPE.CARTAO IS NULL AND (ISNULL(OPE.SEQCHR) = 'T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') AND (COALESCE(CCC.VLRLAN, 0) < 0)) THEN 
                              TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                         ELSE NULL -- Envia NULL quando "FormaLiquidacao = Liquidao Adiant. Cliente"
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(CASE WHEN (OPE.CARTAO IS NULL AND (ISNULL(OPE.SEQCHR) = 'T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') AND (COALESCE(CCC.VLRLAN, 0) < 0)) THEN TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))
                         ELSE NULL -- Envia NULL quando "FormaLiquidacao = Liquidao Adiant. Cliente"
                    END AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN (OPE.CARTAO IS NULL AND (ISNULL(OPE.SEQCHR) = 'T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') AND (COALESCE(CCC.VLRLAN, 0) < 0)) THEN
                                CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = VEN.FILCLI AND REL.CODPAR = VEN.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                                     ELSE 'C' 
                                END 
                         ELSE NULL -- Envia NULL quando "FormaLiquidacao = Liquidao Adiant. Cliente"
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST('PG'|| LID.NUMECF AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(LID.TRN_ID AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               --CAST(LPAD(TRIM(OPE.NUMNOT), 6, '0')||LPAD(TRIM(OPE.NUMPAR), 2, '0')||LPAD(TRIM(OPE.SUBPAR), 2, '0') AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST(CASE WHEN OPE.VLROPE < 0 THEN 'Troco Dinheiro'
                         WHEN OPE.CARTAO IS NOT NULL THEN CASE WHEN (UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'PIX' OR UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'CARDSE') THEN 'Liquidao Operao Bancaria'
                              ELSE 'Liquidao Carto CRE'
                           END
                         WHEN (ISNOTNULL(OPE.SEQCHR) = 'T') THEN 'Liquidao Cheque CRE'
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN 'Liquidao Convnio CRE'
                         WHEN (COALESCE(CCC.VLRLAN, 0) < 0) THEN 'Liquidao Adiant. Cliente'
                         --WHEN (DCOB.TIPCOB IN ('B','L','O','P')) OR (CCC.CODVEN IS NOT NULL) THEN 'Liquidao Duplicata'
                         ELSE 'Liquidao Operao Caixa'
                    END AS VARCHAR(50)) AS FormaLiquidacao, -- Informar uma das opes: 'Liquidao Carto CRE', 'Liquidao Cheque CRE', 'Liquidao Duplicata', 'Liquidao Operao Caixa', 'Liquidao Convnio CRE', 'Liquidao Adiant. Cliente', 'Troco Dinheiro', 'Liquidao Operao Bancaria'
               CAST(CASE WHEN OPE.CARTAO IS NOT NULL THEN 
                           CASE WHEN (UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'PIX' OR UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'CARDSE') THEN '1'
                           ELSE '5'
                           END
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN '2'
                         ELSE '0'
                    END AS VARCHAR(1)) AS TPPADCONTA, -- Tipo padro de conta tesouraria. Informar uma das opes. 0 - Conta Caixa, 1 - Conta Bancria, 2 - Conta Convnio  Receber, 3 - Conta Convnio  Pagar, 4 - Conta Carto  Pagar, 5 - Conta Carto  Receber, 6 - Conta Aplicao Financeira
               CAST(CASE WHEN OPE.CARTAO IS NOT NULL THEN TRIM(COALESCE(CXF_DCAR.CODEXT, CTA_DCAR.CODEXT, CODIGO_CONTA(CTA_DCAR.CODFIL, CTA_DCAR.SEQUEN, 'X')))
                         --WHEN (ISNOTNULL(OPE.SEQCHR) = 'T') THEN TRIM(CTA_CHR.CODEXT)
                         WHEN (ISNOTNULL(OPE.SEQCHR) = 'T') THEN TRIM(COALESCE(CXF.CODEXT, CTA.CODEXT, CODIGO_CONTA(CTA.CODFIL, CTA.SEQUEN, 'X')))
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN NULL
                         ELSE TRIM(COALESCE(CXF.CODEXT, CTA.CODEXT, CODIGO_CONTA(CTA.CODFIL, CTA.SEQUEN, 'X')))
                    END AS VARCHAR(20)) AS CodContaTes, -- Cdigo da Conta Tesouraria para onde vai a liquidao
               CAST(ABS(OPE.VLROPE) AS Numeric(15,2)) AS ValorFormaLiqOri, -- Valor da Forma de Liquidao Original
               CAST(ABS(OPE.VLROPE) AS Numeric(15,2)) AS ValorFormaLiq, -- Valor da Forma de Liquidao
               CAST(CASE WHEN OPE.VLROPE < 0 THEN 'Troco Dinheiro'
                         WHEN OPE.CARTAO IS NOT NULL THEN CASE WHEN (UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'PIX' OR UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'CARDSE') THEN 'Liquidao Operao Bancaria'
                              ELSE 'Liquidao Carto CRE'
                           END
                         WHEN (ISNOTNULL(OPE.SEQCHR) = 'T') THEN 'Liquidao Cheque CRE'
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN 'Liquidao Convnio CRE'
                         WHEN (COALESCE(CCC.VLRLAN, 0) < 0) THEN 'Liquidao Adiant. Cliente'
                         --WHEN (DCOB.TIPCOB IN ('B','L','O','P')) OR (CCC.CODVEN IS NOT NULL) THEN 'Liquidao Duplicata'
                         ELSE 'Liquidao Operao Caixa'
                    END AS VARCHAR(150)) AS Historico, -- Histrico da Liquidao
               -- Carto
               CAST(CASE WHEN OPE.CARTAO IS NOT NULL THEN (SELECT MIN(ITF.DATVEN) FROM TT_ITF ITF WHERE ITF.CODFIL = TEF.CODFIL AND ITF.SEQUEN = TEF.SEQUEN)
                         ELSE NULL
                    END AS Timestamp) AS DataVctoCartao, -- Primeira Data de Vencimento do Carto (Operao Carto)
               CAST(CASE WHEN TEF.TIPOPE = 'D' THEN DCAR.TAXDEB 
                         WHEN TEF.TIPOPE = 'C' THEN DCAR.TAXCAR 
                         WHEN OPE.CARTAO IS NOT NULL THEN DCAR.TAXCAR 
                         ELSE NULL
                    END AS Numeric(15,2)) AS TaxaCartao, -- Taxa do carto (Operao Carto)
               CAST(CASE WHEN TEF.TIPOPE = 'D' OR OPE.CARTAO IS NULL THEN NULL
                         -- Em Oracle est apresentando erro Interno "ORA-00600: cdigo de erro interno, argumentos: [kkqcscorcbk: correlated string not found.]" ao realizar a sub-consulta com isso optei por calcular a taxa conforme o valor da taxa na REC
                           ELSE (SELECT TAX.TAXCAR FROM (SELECT TCP.NUMPAR, TCP.TAXCAR
                                         FROM TT_TCP TCP 
                                        WHERE TCP.CARTAO = OPE.CARTAO
                                          AND TCP.NUMPAR <= (SELECT COUNT(*) FROM TT_ITF ITF WHERE ITF.CODFIL = TEF.CODFIL AND ITF.SEQUEN = TEF.SEQUEN)
                                        ORDER BY TCP.NUMPAR DESC ) TAX LIMIT 1 )                     END AS Numeric(15,2)) AS TaxaCartaoParcelas, -- Taxa do carto (Operao Carto)
               CAST(CASE WHEN TEF.TIPOPE = 'D' THEN '2'
                         WHEN TEF.TIPOPE = 'C' THEN '1'
                         WHEN OPE.CARTAO IS NOT NULL THEN '1'
                         ELSE NULL
                    END AS VARCHAR(1)) AS TipoCartao, -- {1 - Crdito / 2 - Dbito} (Operao Carto)
               CAST(CASE WHEN TEF.MANUAL = 'T' THEN '0'
                         ELSE '0' -- SiTEF
                    END AS VARCHAR(1)) AS GerenciadorTEF, -- {0 - Nenhum / 1 - TEF Disc / 2 - TEF Dial / 3 - Hiper TEF} (Operao Carto)
               CAST(CASE WHEN OPE.CARTAO IS NOT NULL AND (SELECT COUNT(*) FROM TT_ITF ITF WHERE ITF.CODFIL = TEF.CODFIL AND ITF.SEQUEN = TEF.SEQUEN) = 1 THEN '0'
                         WHEN OPE.CARTAO IS NOT NULL THEN '2'
                         ELSE NULL
                    END AS VARCHAR(1)) AS TipoParcelamento, -- {0 -  Vista / 1 - Parc. Administradora / 2 - Parc. Lojista} (Operao Carto)
               --CAST((SELECT MAX(ITF.NUMITE) FROM TT_ITF ITF WHERE ITF.CODFIL = TEF.CODFIL AND ITF.SEQUEN = TEF.SEQUEN) AS Numeric(8)) AS NumeroParcelas, -- Nmero de Parcelas - Esse nmero deve ser igual ao nmero de parcelas do documento (Operao Carto)
               CASE WHEN OPE.CARTAO IS NOT NULL THEN CAST(COALESCE((SELECT MAX(ITF.NUMITE) FROM TT_ITF ITF WHERE ITF.CODFIL = TEF.CODFIL AND ITF.SEQUEN = TEF.SEQUEN),1) AS Numeric(8)) ELSE NULL END AS NumeroParcelas, -- Nmero de Parcelas - Esse nmero deve ser igual ao nmero de parcelas do documento (Operao Carto)
               CAST(TEF.NSUTRN AS VARCHAR(20)) AS NSU, -- Nmero Transao (Operao Carto)
               CAST(TEF.NUMAUT AS VARCHAR(20)) AS CodAutTransacao, -- Cdigo de Autorizao da Transao (Operao Carto)
               CAST(NULL AS VARCHAR(20)) AS NumeroRVRO, -- Nmero do Resumo de Vendas ou de Operao (Operao Carto)
               -- Operao
               CAST(TRUNC(LID.DATHOR) AS Timestamp) AS DataEntradaCaixa, -- Data Entrada (Operao Caixa)
               -- Cheque
               CAST(TO_NUMBER(CHR.CODBCO) AS Numeric(9)) AS CodigoBanco, -- Cdigo do Banco (Operao Cheque)
               CAST(CHR.CODAGE AS VARCHAR(10)) AS CODAGENCIA, -- Cdigo da Agncia (Operao Cheque)
               CAST(CHR.NUMCON AS VARCHAR(10)) AS CODCONTABAN, -- Cdigo da Conta Bancria (Operao Cheque)
               CAST(TO_NUMBER(CHR.NUMCHE) AS Numeric(9)) AS NumeroCheque, -- Nmero Cheque (Operao Cheque)
               CAST(NULL AS Numeric(9)) AS Tipificacao, -- Tipificao (Operao Cheque)
               CAST(CASE WHEN (ISNOTNULL(OPE.SEQCHR)='T') THEN CHR.DATVEN 
                         ELSE NULL
                    END AS Timestamp) AS DataVctoCheque, -- Data de Vencimento (Operao Cheque)
               CAST(CASE WHEN (ISNULL(OPE.SEQCHR)='T') THEN 'F'
                         WHEN (CHR.FILCLI||CHR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) AND (VEN.FILCLI||VEN.CODCLI = CHR.FILCLI||CHR.CODCLI) AND 
                              (ISNOTNULL(CHR.FILCLI) = 'T') AND (TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) = TRIM(COALESCE(CHR.NUMDOC, CHR_PAR.NUMDOC))) THEN 'F'
                         ELSE 'T'
                    END AS VARCHAR(1)) AS ChequeTerceiro, --  Cheque Terceiro? (Operao Cheque) {F=False, T=True} Enviar como F por padro
               CAST(TRIM(COALESCE(CHR.NUMDOC, CHR_PAR.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCheque, -- CPF ou CNPJ da Identificao Cliente (Operao Cheque)
               -- Crdiario/Boleto
               CAST(CASE WHEN OPE.CARTAO IS NULL AND (ISNULL(OPE.SEQCHR)='T') AND ((CASE WHEN (ISNOTNULL(DCCC.DESCCC) = 'T') THEN UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) ELSE 'CREDIARIO' END) <> 'CONVENIO CRE') THEN OPE.DATOPE 
                         ELSE NULL
                    END AS Timestamp) AS DataVctoDuplicata, -- Data de Vencimento (Operao Duplicata)
               -- Definido juntamente com a EME4 que deve ser enviado apenas numero sem zero a esquerda, ser enviado apenas o n da parcela pois no enviaremos as sub-parcelas nesse ponto ser enviado como Operao de Liquidao 
               --CAST(CASE WHEN OPE.CARTAO IS NULL AND (ISNULL(OPE.SEQCHR)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') THEN TO_NUMBER(LPAD(TRIM(REC.NUMPAR), 2, '0')||LPAD(TRIM(REC.SUBPAR), 2, '0'))
               CAST(CASE WHEN OPE.CARTAO IS NULL AND (ISNULL(OPE.SEQCHR)='T') AND ((CASE WHEN (ISNOTNULL(DCCC.DESCCC) = 'T') THEN UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) ELSE 'CREDIARIO' END) <> 'CONVENIO CRE') THEN TO_NUMBER(TRIM(OPE.NUMPAR))
                         ELSE NULL
                    END AS Numeric(9)) AS Parcela, -- N Parcela (Operao Duplicata)
               CAST(CASE WHEN OPE.CARTAO IS NULL AND (ISNULL(OPE.SEQCHR)='T') AND ((CASE WHEN (ISNOTNULL(DCCC.DESCCC) = 'T') THEN UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) ELSE 'CREDIARIO' END) <> 'CONVENIO CRE') THEN PLA.VLTXMU
                         ELSE NULL
                    END AS Numeric(15,5)) AS MoraAtrasoDuplic, -- Taxa Mora Atraso (Operao Duplicata)
               CAST(NULL AS Numeric(15,5)) AS MoraAntecipDuplic, -- Taxa Mora Antecipao (Operao Duplicata)
               CAST(CASE WHEN OPE.CARTAO IS NULL AND (ISNULL(OPE.SEQCHR)='T') AND ((CASE WHEN (ISNOTNULL(DCCC.DESCCC) = 'T') THEN UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) ELSE 'CREDIARIO' END) <> 'CONVENIO CRE') THEN PLA.PRAIDE
                         ELSE NULL
                    END AS Numeric(9)) AS DiasJurosAtrasoDuplic, -- Dias Cobrar Juros Atraso (Operao Duplicata)
               CAST(NULL AS Numeric(9)) AS DiasJurosAntecDuplic, -- Dias Cobrar Juros Antecipao (Operao Duplicata)
               -- Convnio
               CAST(CASE WHEN OPE.CARTAO IS NULL AND (ISNULL(OPE.SEQCHR)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') AND (LeParametroTXT('TIPO_EXP_EME4', LID.CODFIL, '', '', '')='C') THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0') ELSE NULL END AS Numeric(9)) AS CodigoCliConv, -- Cdigo do Cliente Conveniado
               CAST(CASE WHEN OPE.CARTAO IS NULL AND (ISNULL(OPE.SEQCHR)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN PAR.NUMDOC ELSE NULL END AS VARCHAR(18)) AS CPFCNPJCliConv, -- CPF ou CNPJ do Cliente Conveniado
               CAST(CASE WHEN OPE.CARTAO IS NULL AND (ISNULL(OPE.SEQCHR)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN VIN_CNV.NUMDOC ELSE NULL END AS VARCHAR(18)) AS CPFCNPJConvenio, -- CPF ou CNPJ do Convnio
               CAST(CASE WHEN OPE.CARTAO IS NULL AND (ISNULL(OPE.SEQCHR)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN 1 ELSE NULL END AS Numeric(8)) AS NumeroParcelasConv, -- Nmero de Parcelas (Operao Convnio)
               -- Definido juntamente com a EME4 que devemos enviar NULL para o campo
               /*
               CAST(CASE WHEN OPE.CARTAO IS NOT NULL THEN NULL
                         WHEN (ISNOTNULL(OPE.SEQCHR) = 'T') THEN NULL
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN NULL
                         WHEN (COALESCE(CCC.VLRLAN, 0) < 0) AND VEN.NUMECF >= '500' THEN (
                                    SELECT TRIM(CASE WHEN VENVLE.CODSER='CF' THEN VENVLE.CODSER
                                                     WHEN VENVLE.CODSER<>'CF' AND ISNOTNULL(DSERVLE.SEREXT)='T' THEN DSERVLE.SEREXT
                                                     WHEN ( (VENVLE.MODNOT = '65' OR VENVLE.MODNOT = '59') AND VENVLE.NUMECF >= '400' ) THEN VENVLE.NUMECF
                                                     ELSE NULL
                                                END) || '-' ||
                                           TO_CHAR(TO_NUMBER(TRIM(CASE WHEN VENVLE.CODSER = 'CF' THEN VENVLE.SEQUEN 
                                                                       WHEN VENVLE.CODSER = 'ST' THEN COALESCE(TO_CHAR(VENVLE.SATCFE), VENVLE.NUMNOT)
                                                                       ELSE VENVLE.NUMNOT END)))
                                      FROM TT_CCC VALE
                                      JOIN TT_VEN VENVLE ON VENVLE.CODFIL = VALE.CODVEN AND VENVLE.SEQUEN = VALE.SEQVEN
                                      JOIN TD_SER DSERVLE ON DSERVLE.CODSER = VENVLE.CODSER
                                     WHERE VALE.TIPLAN = 'K'
                                       AND VALE.TIPCCC = CCC.TIPCCC
                                       AND VALE.VLRLAN = (CCC.VLRLAN * -1)
                                       AND VALE.NUMDOC = CCC.NUMDOC
                                   )
                         ELSE NULL
                    END AS VARCHAR(25)) AS NroDoctoAdtoADC -- Nmero do Documento de Origem do Adiantamento
               */
               CAST(NULL AS VARCHAR(25)) AS NroDoctoAdtoADC -- Nmero do Documento de Origem do Adiantamento
          FROM (
            SELECT LD.CODFIL, LD.NUMECF, LD.TRN_ID, LD.CUPFIS, LD.DATHOR, LD.DATEXE, LD.EXPEM4,
                   MIN(OPE.FILREC||OPE.SEQREC) as PARCELA
              FROM TT_LID LD
              JOIN (SELECT OP.CODFIL, OP.NUMECF, OP.TRN_ID, OP.CUPFIS, OP.FILREC, OP.SEQREC 
                      FROM TT_OPE OP
                     WHERE OP.MEIPGT = 'F'
                       AND OP.FILREC IS NOT NULL
                    ) OPE ON OPE.CODFIL = LD.CODFIL AND OPE.NUMECF = LD.NUMECF
                         AND OPE.TRN_ID = LD.TRN_ID AND OPE.CUPFIS = LD.CUPFIS
             WHERE LD.TIPOPE = 'RECDEBITO'
               AND LD.EXPEM4 = 'F'
               AND LD.VLROPE > 0
             GROUP BY LD.CODFIL, LD.NUMECF, LD.TRN_ID, LD.CUPFIS, LD.DATHOR, LD.DATEXE, LD.VLROPE, LD.EXPEM4
          ) LID
          JOIN TT_OPE OPE ON OPE.CODFIL = LID.CODFIL AND OPE.NUMECF = LID.NUMECF
                         AND OPE.TRN_ID = LID.TRN_ID AND OPE.CUPFIS = LID.CUPFIS
                         AND OPE.MEIPGT = 'T'
          -- ECF
          JOIN TD_ECF DECF ON DECF.FILECF = LID.CODFIL AND DECF.NUMECF = LID.NUMECF
          JOIN TT_VEN VEN ON VEN.CODFIL = SUBSTR(LID.PARCELA,1,3) AND VEN.SEQUEN = SUBSTR(LID.PARCELA,4,10)
          -- Srie de Emisso
          JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
          -- Cliente
          JOIN TT_CLI PAR ON PAR.FILCLI = VEN.FILCLI AND PAR.CODCLI = VEN.CODCLI
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = VEN.FILCLI AND ENDFAT.CODCLI = VEN.CODCLI AND ENDFAT.CODFIL = VEN.FILFAT AND ENDFAT.NUMEND = VEN.ENDFAT
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          -- Portador
          JOIN TD_COB DCOB ON DCOB.CODTAB = DECF.PORECF
          -- Conta Financeira
          JOIN TT_CTA CTA ON CTA.CODFIL = DCOB.FILCTA AND CTA.SEQUEN = DCOB.SEQCTA AND CTA.TIPCTA  = DCOB.TIPCTA
          -- Carto
          LEFT JOIN TT_TEF TEF ON TEF.CODFIL = OPE.FILTEF AND TEF.SEQUEN = OPE.SEQTEF
          LEFT JOIN TD_CAR DCAR ON DCAR.CODTAB = OPE.CARTAO
          -- Portador do Carto
          LEFT JOIN TD_COB DCOB_DCAR ON DCOB_DCAR.CODTAB = DCAR.PORCAR AND DCOB_DCAR.TIPCOB = DCAR.COBCAR
          -- Conta Financeira do Carto
          LEFT JOIN TT_CTA CTA_DCAR ON CTA_DCAR.CODFIL = DCOB_DCAR.FILCTA AND CTA_DCAR.SEQUEN = DCOB_DCAR.SEQCTA AND CTA_DCAR.TIPCTA  = DCOB_DCAR.TIPCTA
          -- Cheque
          LEFT JOIN TT_CHR CHR ON CHR.CODFIL = OPE.FILCHR AND CHR.SEQUEN = OPE.SEQCHR
          -- Portador do Cheque
          --LEFT JOIN TD_COB DCOB_CHR ON DCOB_CHR.CODTAB = CHR.PORTAD AND DCOB_CHR.TIPCOB = CHR.TIPCOB
          -- Conta Financeira do Cheque
          --LEFT JOIN TT_CTA CTA_CHR ON CTA_CHR.CODFIL = DCOB_CHR.FILCTA AND CTA_CHR.SEQUEN = DCOB_CHR.SEQCTA AND CTA_CHR.TIPCTA  = DCOB_CHR.TIPCTA
          -- Parceiro do Cheque
          LEFT JOIN TT_CLI CHR_PAR ON CHR_PAR.FILCLI = CHR.FILCLI AND CHR_PAR.CODCLI = CHR.CODCLI
          -- Plano 
          JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT AND PLA.CODPGT = VEN.CODPGT
          -- Conta Corrente
          LEFT OUTER JOIN TT_CCC CCC ON CCC.CODFIL = OPE.FILCCC AND CCC.SEQUEN = OPE.SEQCCC
                                    AND ((CCC.TIPLAN <> 'K') OR ((CCC.TIPLAN = 'K') AND (CCC.VLRLAN  < 0))) -- Desconsidera lanamento do novo Vale Compra quando utilizao parcial
          LEFT OUTER JOIN TD_CCC DCCC ON DCCC.CODTAB = CCC.TIPCCC
          -- Parceiro Vinculado - Convnio
          LEFT JOIN TT_CLI VIN_CNV ON VIN_CNV.FILCLI = PAR.FILVIN AND VIN_CNV.CODCLI = PAR.CODVIN
          --Cdigo externo da conta financeira
          LEFT JOIN TT_CTAXFIL CXF ON CXF.FILCTA = CTA.CODFIL AND CXF.SEQCTA = CTA.SEQUEN AND CXF.CODFIL = LID.CODFIL 
          --Cdigo externo da conta financeira
          LEFT JOIN TT_CTAXFIL CXF_DCAR ON CXF_DCAR.FILCTA = CTA_DCAR.CODFIL AND CXF_DCAR.SEQCTA = CTA_DCAR.SEQUEN AND CXF_DCAR.CODFIL = LID.CODFIL 
         WHERE 1=1
           AND LID.DATHOR >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',LID.CODFIL,'','','')
           AND (LeParametroTXT('TIPO_EXP_EME4', LID.CODFIL, '', '', '') = 'V')
           --AND LID.EXPEM4 = 'F'
        UNION ALL
        -- Liquidao para Documentos de Pagamentos gerados na Retaguarda
        SELECT
               REC.CODFIL, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR, CAST('PGT' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_LIQUIDACAODOCTO' AS VARCHAR(50)) AS DESTINO, REC.PAGAME AS DATINC, REC.ATU_EM, REC.EXPORT, REC.EXPORT AS EXPEM4,
               CAST(VEN.CODSER AS VARCHAR(3)) AS CODSER, CAST(NULL AS VARCHAR(3)) AS SUBSER, CAST(VEN.NUMECF AS CHAR(3)) AS NUMECF, CAST(VEN.NUMNOT AS VARCHAR(10)) AS NUMNOT,
               CAST('PGT' || REC.CODFIL || REC.SEQUEN || REC.NUMPAR || REC.SUBPAR AS VARCHAR(50)) AS CHAVE,
               REC.ATU_EM AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               -- Tipo de Operao exportado de forma fixa conforme conversado com a EME4
               CAST(999 AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST( CASE WHEN (UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'PIX' OR UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'CARDSE') THEN NULL --Solicitao da EME4 para integ. PIX
                     ELSE TO_NUMBER(REC.CODFIL)
                     END AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE) = 'T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') AND (COALESCE(CCC.VLRLAN, 0) < 0)) THEN TO_NUMBER(VEN.CODFIL)
                         ELSE NULL -- Envia NULL quando "FormaLiquidacao = Liquidao Adiant. Cliente"
                    END AS Numeric(3)) AS FilialAdtoADC, -- Cdigo da Filial do Adiantamento de Cliente
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         WHEN (REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE) = 'T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') AND (COALESCE(CCC.VLRLAN, 0) < 0)) THEN 
                              TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                         ELSE NULL -- Envia NULL quando "FormaLiquidacao = Liquidao Adiant. Cliente"
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(CASE WHEN (REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE) = 'T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') AND (COALESCE(CCC.VLRLAN, 0) < 0)) THEN TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))
                         ELSE NULL -- Envia NULL quando "FormaLiquidacao = Liquidao Adiant. Cliente"
                    END AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN (REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE) = 'T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') AND (COALESCE(CCC.VLRLAN, 0) < 0)) THEN
                                CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = VEN.FILCLI AND REL.CODPAR = VEN.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                                     ELSE 'C' 
                                END 
                         ELSE NULL -- Envia NULL quando "FormaLiquidacao = Liquidao Adiant. Cliente"
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST('PG'||CASE WHEN VEN.CODSER<>'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN LPAD(TRIM(DSER.SEREXT), 3, '0')
                               ELSE VEN.NUMECF
                          END AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(LPAD(TRIM(VEN.NUMNOT), 6, '0') AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               --CAST(LPAD(TRIM(VEN.NUMNOT), 6, '0')||LPAD(TRIM(REC.NUMPAR), 2, '0')||LPAD(TRIM(REC.SUBPAR), 2, '0') AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST(CASE WHEN REC.CARTAO IS NOT NULL THEN 
                           CASE WHEN (UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'PIX' OR UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'CARDSE') THEN 'Liquidao Operao Bancaria'
                              ELSE 'Liquidao Carto CRE'
                           END
                         WHEN (ISNOTNULL(REC.SEQCHE) = 'T') THEN 'Liquidao Cheque CRE'
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN 'Liquidao Convnio CRE'
                         WHEN (COALESCE(CCC.VLRLAN, 0) < 0) THEN 'Liquidao Adiant. Cliente'
                         WHEN (DCOB.TIPCOB IN ('B','L','O','P')) OR (CCC.CODVEN IS NOT NULL) THEN 'Liquidao Duplicata'
                         ELSE 'Liquidao Operao Caixa'
                    END AS VARCHAR(50)) AS FormaLiquidacao, -- Informar uma das opes: 'Liquidao Carto CRE', 'Liquidao Cheque CRE', 'Liquidao Duplicata', 'Liquidao Operao Caixa', 'Liquidao Convnio CRE', 'Liquidao Adiant. Cliente', 'Troco Dinheiro', 'Liquidao Operao Bancaria'
               CAST(CASE WHEN REC.CARTAO IS NOT NULL THEN 
                           CASE WHEN (UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'PIX' OR UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'CARDSE') THEN '1'
                              ELSE '5'
                           END
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN '2'
                         ELSE '0'
                    END AS VARCHAR(1)) AS TPPADCONTA, -- Tipo padro de conta tesouraria. Informar uma das opes. 0 - Conta Caixa, 1 - Conta Bancria, 2 - Conta Convnio  Receber, 3 - Conta Convnio  Pagar, 4 - Conta Carto  Pagar, 5 - Conta Carto  Receber, 6 - Conta Aplicao Financeira
               CAST(CASE WHEN REC.CARTAO IS NOT NULL THEN TRIM(COALESCE(CXF_DCAR.CODEXT, CTA_DCAR.CODEXT, CODIGO_CONTA(CTA_DCAR.CODFIL, CTA_DCAR.SEQUEN, 'X')))
                         --WHEN (ISNOTNULL(REC.SEQCHE) = 'T') THEN TRIM(CTA_CHR.CODEXT)
                         WHEN (ISNOTNULL(REC.SEQCHE) = 'T') THEN TRIM(COALESCE(CXF.CODEXT, CTA.CODEXT, CODIGO_CONTA(CTA.CODFIL, CTA.SEQUEN, 'X')))
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN NULL
                         ELSE TRIM(COALESCE(CXF.CODEXT, CTA.CODEXT, CODIGO_CONTA(CTA.CODFIL, CTA.SEQUEN, 'X')))
                    END AS VARCHAR(20)) AS CodContaTes, -- Cdigo da Conta Tesouraria para onde vai a liquidao
               CAST(ABS(REC.VLRPGT) + COALESCE(ABS(REC.VLRTAX),0) AS Numeric(15,2)) AS ValorFormaLiqOri, -- Valor da Forma de Liquidao Original
               CAST(ABS(REC.VLRPGT) + COALESCE(ABS(REC.VLRTAX),0) AS Numeric(15,2)) AS ValorFormaLiq, -- Valor da Forma de Liquidao
               CAST(CASE WHEN REC.CARTAO IS NOT NULL THEN 
                           CASE WHEN (UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'PIX' OR UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'CARDSE') THEN 'Liquidao Operao Bancaria'
                              ELSE 'Liquidao Carto CRE'
                           END
                         WHEN (ISNOTNULL(REC.SEQCHE) = 'T') THEN 'Liquidao Cheque CRE'
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN 'Liquidao Convnio CRE'
                         WHEN (COALESCE(CCC.VLRLAN, 0) < 0) THEN 'Liquidao Adiant. Cliente'
                         WHEN (DCOB.TIPCOB IN ('B','L','O','P')) OR (CCC.CODVEN IS NOT NULL) THEN 'Liquidao Duplicata'
                         ELSE 'Liquidao Operao Caixa'
                    END AS VARCHAR(150)) AS Historico, -- Histrico da Liquidao
               -- Carto
               CAST(CASE WHEN REC.CARTAO IS NOT NULL THEN REC.DATVEN
                         ELSE NULL
                    END AS Timestamp) AS DataVctoCartao, -- Primeira Data de Vencimento do Carto (Operao Carto)
               CAST(CASE WHEN TEF.TIPOPE = 'D' THEN DCAR.TAXDEB 
                         WHEN TEF.TIPOPE = 'C' THEN DCAR.TAXCAR 
                         WHEN REC.CARTAO IS NOT NULL THEN DCAR.TAXCAR
                         ELSE NULL
                    END AS Numeric(15,2)) AS TaxaCartao, -- Taxa do carto (Operao Carto)
               CAST(CASE WHEN TEF.TIPOPE = 'D' OR REC.CARTAO IS NULL THEN NULL
                         -- Em Oracle est apresentando erro Interno "ORA-00600: cdigo de erro interno, argumentos: [kkqcscorcbk: correlated string not found.]" ao realizar a sub-consulta com isso optei por calcular a taxa conforme o valor da taxa na REC
                           ELSE (SELECT TAX.TAXCAR FROM (SELECT TCP.NUMPAR, TCP.TAXCAR
                                         FROM TT_TCP TCP 
                                        WHERE TCP.CARTAO = REC.CARTAO
                                          AND TCP.NUMPAR <= (SELECT COUNT(*) FROM TT_ITF ITF WHERE ITF.CODFIL = TEF.CODFIL AND ITF.SEQUEN = TEF.SEQUEN)
                                        ORDER BY TCP.NUMPAR DESC ) TAX LIMIT 1 )                     END AS Numeric(15,2)) AS TaxaCartaoParcelas, -- Taxa do carto (Operao Carto)
               CAST(CASE WHEN TEF.TIPOPE = 'D' THEN '2'
                         WHEN TEF.TIPOPE = 'C' THEN '1'
                         WHEN REC.CARTAO IS NOT NULL THEN '1'
                         ELSE NULL
                    END AS VARCHAR(1)) AS TipoCartao, -- {1 - Crdito / 2 - Dbito} (Operao Carto)
               CAST(CASE WHEN TEF.MANUAL = 'T' THEN '0'
                         ELSE '0' -- SiTEF
                    END AS VARCHAR(1)) AS GerenciadorTEF, -- {0 - Nenhum / 1 - TEF Disc / 2 - TEF Dial / 3 - Hiper TEF} (Operao Carto)
               CAST(CASE WHEN REC.CARTAO IS NOT NULL AND REC.AVISTA = 'T' THEN '0'
                         WHEN REC.CARTAO IS NOT NULL AND REC.AVISTA = 'F' THEN '2'
                         ELSE NULL
                    END AS VARCHAR(1)) AS TipoParcelamento, -- {0 -  Vista / 1 - Parc. Administradora / 2 - Parc. Lojista} (Operao Carto)
               --CAST((SELECT MAX(ITF.NUMITE) FROM TT_ITF ITF WHERE ITF.CODFIL = TEF.CODFIL AND ITF.SEQUEN = TEF.SEQUEN) AS Numeric(8)) AS NumeroParcelas, -- Nmero de Parcelas - Esse nmero deve ser igual ao nmero de parcelas do documento (Operao Carto)
               CASE WHEN REC.CARTAO IS NOT NULL THEN CAST(COALESCE((SELECT MAX(ITF.NUMITE) FROM TT_ITF ITF WHERE ITF.CODFIL = TEF.CODFIL AND ITF.SEQUEN = TEF.SEQUEN),1) AS Numeric(8)) ELSE NULL END AS NumeroParcelas, -- Nmero de Parcelas - Esse nmero deve ser igual ao nmero de parcelas do documento (Operao Carto)
               CAST(TEF.NSUTRN AS VARCHAR(20)) AS NSU, -- Nmero Transao (Operao Carto)
               CAST(TEF.NUMAUT AS VARCHAR(20)) AS CodAutTransacao, -- Cdigo de Autorizao da Transao (Operao Carto)
               CAST(NULL AS VARCHAR(20)) AS NumeroRVRO, -- Nmero do Resumo de Vendas ou de Operao (Operao Carto)
               -- Operao
               CAST(TRUNC(REC.PAGAME) AS Timestamp) AS DataEntradaCaixa, -- Data Entrada (Operao Caixa)
               -- Cheque
               CAST(TO_NUMBER(CHR.CODBCO) AS Numeric(9)) AS CodigoBanco, -- Cdigo do Banco (Operao Cheque)
               CAST(CHR.CODAGE AS VARCHAR(10)) AS CODAGENCIA, -- Cdigo da Agncia (Operao Cheque)
               CAST(CHR.NUMCON AS VARCHAR(10)) AS CODCONTABAN, -- Cdigo da Conta Bancria (Operao Cheque)
               CAST(TO_NUMBER(CHR.NUMCHE) AS Numeric(9)) AS NumeroCheque, -- Nmero Cheque (Operao Cheque)
               CAST(NULL AS Numeric(9)) AS Tipificacao, -- Tipificao (Operao Cheque)
               CAST(CASE WHEN (ISNOTNULL(REC.SEQCHE)='T') THEN REC.DATVEN 
                         ELSE NULL
                    END AS Timestamp) AS DataVctoCheque, -- Data de Vencimento (Operao Cheque)
               CAST(CASE WHEN (ISNULL(REC.SEQCHE)='T') THEN 'F'
                         WHEN (CHR.FILCLI||CHR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) AND (VEN.FILCLI||VEN.CODCLI = CHR.FILCLI||CHR.CODCLI) AND (ISNOTNULL(CHR.FILCLI) = 'T') THEN 'F'
                         ELSE 'T'
                    END AS VARCHAR(1)) AS ChequeTerceiro, --  Cheque Terceiro? (Operao Cheque) {F=False, T=True} Enviar como F por padro
               CAST(TRIM(COALESCE(CHR.NUMDOC, CHR_PAR.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCheque, -- CPF ou CNPJ da Identificao Cliente (Operao Cheque)
               -- Crdiario/Boleto
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND ((CASE WHEN (ISNOTNULL(DCCC.DESCCC) = 'T') THEN UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) ELSE 'CREDIARIO' END) <> 'CONVENIO CRE') THEN REC.DATVEN 
                         ELSE NULL
                    END AS Timestamp) AS DataVctoDuplicata, -- Data de Vencimento (Operao Duplicata)
               -- Definido juntamente com a EME4 que deve ser enviado apenas numero sem zero a esquerda, ser enviado apenas o n da parcela pois no enviaremos as sub-parcelas nesse ponto ser enviado como Operao de Liquidao 
               --CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') THEN TO_NUMBER(LPAD(TRIM(REC.NUMPAR), 2, '0')||LPAD(TRIM(REC.SUBPAR), 2, '0'))
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND ((CASE WHEN (ISNOTNULL(DCCC.DESCCC) = 'T') THEN UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) ELSE 'CREDIARIO' END) <> 'CONVENIO CRE') THEN TO_NUMBER(TRIM(REC.NUMPAR))
                         ELSE NULL
                    END AS Numeric(9)) AS Parcela, -- N Parcela (Operao Duplicata)
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND ((CASE WHEN (ISNOTNULL(DCCC.DESCCC) = 'T') THEN UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) ELSE 'CREDIARIO' END) <> 'CONVENIO CRE') THEN PLA.VLTXMU
                         ELSE NULL
                    END AS Numeric(15,5)) AS MoraAtrasoDuplic, -- Taxa Mora Atraso (Operao Duplicata)
               CAST(NULL AS Numeric(15,5)) AS MoraAntecipDuplic, -- Taxa Mora Antecipao (Operao Duplicata)
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND ((CASE WHEN (ISNOTNULL(DCCC.DESCCC) = 'T') THEN UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) ELSE 'CREDIARIO' END) <> 'CONVENIO CRE') THEN PLA.PRAIDE
                         ELSE NULL
                    END AS Numeric(9)) AS DiasJurosAtrasoDuplic, -- Dias Cobrar Juros Atraso (Operao Duplicata)
               CAST(NULL AS Numeric(9)) AS DiasJurosAntecDuplic, -- Dias Cobrar Juros Antecipao (Operao Duplicata)
               -- Convnio
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') AND (LeParametroTXT('TIPO_EXP_EME4', REC.CODFIL, '', '', '')='C') THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0') ELSE NULL END AS Numeric(9)) AS CodigoCliConv, -- Cdigo do Cliente Conveniado
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN PAR.NUMDOC ELSE NULL END AS VARCHAR(18)) AS CPFCNPJCliConv, -- CPF ou CNPJ do Cliente Conveniado
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN VIN_CNV.NUMDOC ELSE NULL END AS VARCHAR(18)) AS CPFCNPJConvenio, -- CPF ou CNPJ do Convnio
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN 1 ELSE NULL END AS Numeric(8)) AS NumeroParcelasConv, -- Nmero de Parcelas (Operao Convnio)
               -- Definido juntamente com a EME4 que devemos enviar NULL para o campo
               /*
               CAST(CASE WHEN REC.CARTAO IS NOT NULL THEN NULL
                         WHEN (ISNOTNULL(REC.SEQCHE) = 'T') THEN NULL
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN NULL
                         WHEN (COALESCE(CCC.VLRLAN, 0) < 0) AND VEN.NUMECF >= '500' THEN (
                                    SELECT TRIM(CASE WHEN VENVLE.CODSER='CF' THEN VENVLE.CODSER
                                                     WHEN VENVLE.CODSER<>'CF' AND ISNOTNULL(DSERVLE.SEREXT)='T' THEN DSERVLE.SEREXT
                                                     WHEN ( (VENVLE.MODNOT = '65' OR VENVLE.MODNOT = '59') AND VENVLE.NUMECF >= '400' ) THEN VENVLE.NUMECF
                                                     ELSE NULL
                                                END) || '-' ||
                                           TO_CHAR(TO_NUMBER(TRIM(CASE WHEN VENVLE.CODSER = 'CF' THEN VENVLE.SEQUEN 
                                                                       WHEN VENVLE.CODSER = 'ST' THEN COALESCE(TO_CHAR(VENVLE.SATCFE), VENVLE.NUMNOT)
                                                                       ELSE VENVLE.NUMNOT END)))
                                      FROM TT_CCC VALE
                                      JOIN TT_VEN VENVLE ON VENVLE.CODFIL = VALE.CODVEN AND VENVLE.SEQUEN = VALE.SEQVEN
                                      JOIN TD_SER DSERVLE ON DSERVLE.CODSER = VENVLE.CODSER
                                     WHERE VALE.TIPLAN = 'K'
                                       AND VALE.TIPCCC = CCC.TIPCCC
                                       AND VALE.VLRLAN = (CCC.VLRLAN * -1)
                                       AND VALE.NUMDOC = CCC.NUMDOC
                                   )
                         ELSE NULL
                    END AS VARCHAR(25)) AS NroDoctoAdtoADC -- Nmero do Documento de Origem do Adiantamento
               */
               CAST(NULL AS VARCHAR(25)) AS NroDoctoAdtoADC -- Nmero do Documento de Origem do Adiantamento
          FROM TT_REC REC
          JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
          -- Srie de Emisso
          JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
          -- Cliente
          JOIN TT_CLI PAR ON PAR.FILCLI = VEN.FILCLI AND PAR.CODCLI = VEN.CODCLI
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = VEN.FILCLI AND ENDFAT.CODCLI = VEN.CODCLI AND ENDFAT.CODFIL = VEN.FILFAT AND ENDFAT.NUMEND = VEN.ENDFAT
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          -- Portador
          JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD
          -- Conta Financeira
          JOIN TT_CTA CTA ON CTA.CODFIL = DCOB.FILCTA AND CTA.SEQUEN = DCOB.SEQCTA AND CTA.TIPCTA  = DCOB.TIPCTA
          -- Carto
          LEFT JOIN TT_TEF TEF ON TEF.CODFIL = REC.FILITF AND TEF.SEQUEN = REC.SEQITF
          LEFT JOIN TD_CAR DCAR ON DCAR.CODTAB = REC.CARTAO
          -- Portador do Carto
          LEFT JOIN TD_COB DCOB_DCAR ON DCOB_DCAR.CODTAB = DCAR.PORCAR AND DCOB_DCAR.TIPCOB = DCAR.COBCAR
          -- Conta Financeira do Carto
          LEFT JOIN TT_CTA CTA_DCAR ON CTA_DCAR.CODFIL = DCOB_DCAR.FILCTA AND CTA_DCAR.SEQUEN = DCOB_DCAR.SEQCTA AND CTA_DCAR.TIPCTA  = DCOB_DCAR.TIPCTA
          -- Cheque
          LEFT JOIN TT_CHR CHR ON CHR.CODFIL = REC.FILREC AND CHR.SEQUEN = REC.SEQCHE
          -- Portador do Cheque
          --LEFT JOIN TD_COB DCOB_CHR ON DCOB_CHR.CODTAB = CHR.PORTAD AND DCOB_CHR.TIPCOB = CHR.TIPCOB
          -- Conta Financeira do Cheque
          --LEFT JOIN TT_CTA CTA_CHR ON CTA_CHR.CODFIL = DCOB_CHR.FILCTA AND CTA_CHR.SEQUEN = DCOB_CHR.SEQCTA AND CTA_CHR.TIPCTA  = DCOB_CHR.TIPCTA
          -- Parceiro do Cheque
          LEFT JOIN TT_CLI CHR_PAR ON CHR_PAR.FILCLI = CHR.FILCLI AND CHR_PAR.CODCLI = CHR.CODCLI
          -- Plano 
          JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT AND PLA.CODPGT = VEN.CODPGT
          -- Conta Corrente
          LEFT OUTER JOIN TT_CCC CCC ON CCC.CODFIL = REC.FILCCC AND CCC.SEQUEN = REC.SEQCCC
                                    AND ((CCC.TIPLAN <> 'K') OR ((CCC.TIPLAN = 'K') AND (CCC.VLRLAN  < 0))) -- Desconsidera lanamento do novo Vale Compra quando utilizao parcial
          LEFT OUTER JOIN TD_CCC DCCC ON DCCC.CODTAB = CCC.TIPCCC
          -- Parceiro Vinculado - Convnio
          LEFT JOIN TT_CLI VIN_CNV ON VIN_CNV.FILCLI = PAR.FILVIN AND VIN_CNV.CODCLI = PAR.CODVIN
          --Cdigo externo da conta financeira
          LEFT JOIN TT_CTAXFIL CXF ON CXF.FILCTA = CTA.CODFIL AND CXF.SEQCTA = CTA.SEQUEN AND CXF.CODFIL = REC.CODFIL 
          --Cdigo externo da conta financeira
          LEFT JOIN TT_CTAXFIL CXF_DCAR ON CXF_DCAR.FILCTA = CTA_DCAR.CODFIL AND CXF_DCAR.SEQCTA = CTA_DCAR.SEQUEN AND CXF_DCAR.CODFIL = REC.CODFIL           
         WHERE 1=1 --REC.SUBPAR = ' 0' -- No trata Sub-Parcela 0 pois operao de recebimento pode ocorrer com todas as operaes
           AND VEN.NUMNOT NOT LIKE '%#%'
           AND REC.FLGEST = 'P'
           AND REC.AVISTA = 'F'
           AND COALESCE(REC.INDEXP, 'E') <> 'N'
           AND REC.PAGAME >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',REC.CODFIL,'','','')
           AND (LeParametroTXT('TIPO_EXP_EME4', REC.CODFIL, '', '', '') = 'V')
           --AND LID.EXPEM4 = 'F'
           AND NOT EXISTS (SELECT 1 AS OK 
                             FROM TT_OPE OPE
                             JOIN TT_LID LID ON LID.CODFIL = OPE.CODFIL AND LID.NUMECF = OPE.NUMECF 
                                            AND LID.TRN_ID = OPE.TRN_ID AND LID.CUPFIS = OPE.CUPFIS
                             WHERE LID.TIPOPE = 'RECDEBITO'
                               AND OPE.FILREC = REC.CODFIL AND OPE.SEQREC = REC.SEQUEN
                               AND OPE.NUMPAR = REC.NUMPAR AND OPE.SUBPAR = REC.SUBPAR)
            AND NOT EXISTS(SELECT 1 AS OK 
                             FROM TW_EXTXDOC EXD 
                            WHERE EXD.ORIGEM = ORIGEM AND EXD.DESTINO = DESTINO
                              AND EXD.FILORI = REC.CODFIL AND EXD.SEQORI = REC.SEQUEN 
                              AND EXD.PARORI = REC.NUMPAR AND EXD.SUBORI = REC.SUBPAR)
        UNION ALL
        -- Liquidao para Documentos Estorno de Pagamentos
        SELECT
               REC.CODFIL, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR, CAST('PGT' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_LIQUIDACAODOCTO' AS VARCHAR(50)) AS DESTINO, REC.PAGAME AS DATINC, REC.ATU_EM, REC.EXPORT, REC.EXPORT AS EXPEM4,
               CAST(VEN.CODSER AS VARCHAR(3)) AS CODSER, CAST(NULL AS VARCHAR(3)) AS SUBSER, CAST(VEN.NUMECF AS CHAR(3)) AS NUMECF, CAST(VEN.NUMNOT AS VARCHAR(10)) AS NUMNOT,
               CAST('PGT' || REC.CODFIL || REC.SEQUEN || REC.NUMPAR || REC.SUBPAR AS VARCHAR(50)) AS CHAVE,
               REC.ATU_EM AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               -- Tipo de Operao exportado de forma fixa conforme conversado com a EME4
               CAST(999 AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST( CASE WHEN (UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'PIX' OR UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'CARDSE') THEN NULL --Solicitao da EME4 para integ. PIX
                     ELSE TO_NUMBER(VEN.CODFIL)
                     END AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE) = 'T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') AND (COALESCE(CCC.VLRLAN, 0) < 0)) THEN TO_NUMBER(VEN.CODFIL)
                         ELSE NULL -- Envia NULL quando "FormaLiquidacao = Liquidao Adiant. Cliente"
                    END AS Numeric(3)) AS FilialAdtoADC, -- Cdigo da Filial do Adiantamento de Cliente
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         WHEN (REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE) = 'T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') AND (COALESCE(CCC.VLRLAN, 0) < 0)) THEN 
                              TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                         ELSE NULL -- Envia NULL quando "FormaLiquidacao = Liquidao Adiant. Cliente"
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(CASE WHEN (REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE) = 'T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') AND (COALESCE(CCC.VLRLAN, 0) < 0)) THEN TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))
                         ELSE NULL -- Envia NULL quando "FormaLiquidacao = Liquidao Adiant. Cliente"
                    END AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN (REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE) = 'T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') AND (COALESCE(CCC.VLRLAN, 0) < 0)) THEN
                                CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = VEN.FILCLI AND REL.CODPAR = VEN.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                                     ELSE 'C' 
                                END 
                         ELSE NULL -- Envia NULL quando "FormaLiquidacao = Liquidao Adiant. Cliente"
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST('PG'||CASE WHEN VEN.CODSER<>'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN LPAD(TRIM(DSER.SEREXT), 3, '0')
                               ELSE VEN.NUMECF
                          END AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(LPAD(TRIM(VEN.NUMNOT), 6, '0') AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               --CAST(LPAD(TRIM(VEN.NUMNOT), 6, '0')||LPAD(TRIM(REC.NUMPAR), 2, '0')||LPAD(TRIM(REC.SUBPAR), 2, '0') AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST(CASE WHEN REC.CARTAO IS NOT NULL THEN 
                           CASE WHEN (UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'PIX' OR UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'CARDSE') THEN 'Liquidao Operao Bancaria'
                              ELSE 'Liquidao Carto CRE'
                           END
                         WHEN (ISNOTNULL(REC.SEQCHE) = 'T') THEN 'Liquidao Cheque CRE'
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN 'Liquidao Convnio CRE'
                         WHEN (COALESCE(CCC.VLRLAN, 0) < 0) THEN 'Liquidao Adiant. Cliente'
                         WHEN (DCOB.TIPCOB IN ('B','L','O','P')) OR (CCC.CODVEN IS NOT NULL) THEN 'Liquidao Duplicata'
                         ELSE 'Liquidao Operao Caixa'
                    END AS VARCHAR(50)) AS FormaLiquidacao, -- Informar uma das opes: 'Liquidao Carto CRE', 'Liquidao Cheque CRE', 'Liquidao Duplicata', 'Liquidao Operao Caixa', 'Liquidao Convnio CRE', 'Liquidao Adiant. Cliente', 'Troco Dinheiro', 'Liquidao Operao Bancaria'
               CAST(CASE WHEN REC.CARTAO IS NOT NULL THEN
                           CASE WHEN (UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'PIX' OR UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'CARDSE') THEN '1'
                              ELSE '5'
                           END 
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN '2'
                         ELSE '0'
                    END AS VARCHAR(1)) AS TPPADCONTA, -- Tipo padro de conta tesouraria. Informar uma das opes. 0 - Conta Caixa, 1 - Conta Bancria, 2 - Conta Convnio  Receber, 3 - Conta Convnio  Pagar, 4 - Conta Carto  Pagar, 5 - Conta Carto  Receber, 6 - Conta Aplicao Financeira
               CAST(CASE WHEN REC.CARTAO IS NOT NULL THEN TRIM(COALESCE(CXF_DCAR.CODEXT, CTA_DCAR.CODEXT, CODIGO_CONTA(CTA_DCAR.CODFIL, CTA_DCAR.SEQUEN, 'X')))
                         --WHEN (ISNOTNULL(REC.SEQCHE) = 'T') THEN TRIM(CTA_CHR.CODEXT)
                         WHEN (ISNOTNULL(REC.SEQCHE) = 'T') THEN TRIM(COALESCE(CXF.CODEXT, CTA.CODEXT, CODIGO_CONTA(CTA.CODFIL, CTA.SEQUEN, 'X')))
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN NULL
                         ELSE TRIM(COALESCE(CXF.CODEXT, CTA.CODEXT, CODIGO_CONTA(CTA.CODFIL, CTA.SEQUEN, 'X')))
                    END AS VARCHAR(20)) AS CodContaTes, -- Cdigo da Conta Tesouraria para onde vai a liquidao
               CAST(ABS(REC.VLRPGT) + COALESCE(ABS(REC.VLRTAX),0) AS Numeric(15,2)) AS ValorFormaLiqOri, -- Valor da Forma de Liquidao Original
               CAST(ABS(REC.VLRPGT) + COALESCE(ABS(REC.VLRTAX),0) AS Numeric(15,2)) AS ValorFormaLiq, -- Valor da Forma de Liquidao
               CAST(CASE WHEN REC.CARTAO IS NOT NULL THEN 
                           CASE WHEN (UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'PIX' OR UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'CARDSE') THEN 'Liquidao Operao Bancaria'
                              ELSE 'Liquidao Carto CRE'
                           END
                         WHEN (ISNOTNULL(REC.SEQCHE) = 'T') THEN 'Liquidao Cheque CRE'
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN 'Liquidao Convnio CRE'
                         WHEN (COALESCE(CCC.VLRLAN, 0) < 0) THEN 'Liquidao Adiant. Cliente'
                         WHEN (DCOB.TIPCOB IN ('B','L','O','P')) OR (CCC.CODVEN IS NOT NULL) THEN 'Liquidao Duplicata'
                         ELSE 'Liquidao Operao Caixa'
                    END AS VARCHAR(150)) AS Historico, -- Histrico da Liquidao
               -- Carto
               CAST(CASE WHEN REC.CARTAO IS NOT NULL THEN REC.DATVEN
                         ELSE NULL
                    END AS Timestamp) AS DataVctoCartao, -- Primeira Data de Vencimento do Carto (Operao Carto)
               CAST(CASE WHEN TEF.TIPOPE = 'D' THEN DCAR.TAXDEB 
                         WHEN TEF.TIPOPE = 'C' THEN DCAR.TAXCAR 
                         WHEN REC.CARTAO IS NOT NULL THEN DCAR.TAXCAR 
                         ELSE NULL
                    END AS Numeric(15,2)) AS TaxaCartao, -- Taxa do carto (Operao Carto)
               CAST(CASE WHEN TEF.TIPOPE = 'D' OR REC.CARTAO IS NULL THEN NULL
                         -- Em Oracle est apresentando erro Interno "ORA-00600: cdigo de erro interno, argumentos: [kkqcscorcbk: correlated string not found.]" ao realizar a sub-consulta com isso optei por calcular a taxa conforme o valor da taxa na REC
                           ELSE (SELECT TAX.TAXCAR FROM (SELECT TCP.NUMPAR, TCP.TAXCAR
                                         FROM TT_TCP TCP 
                                        WHERE TCP.CARTAO = REC.CARTAO
                                          AND TCP.NUMPAR <= (SELECT COUNT(*) FROM TT_ITF ITF WHERE ITF.CODFIL = TEF.CODFIL AND ITF.SEQUEN = TEF.SEQUEN)
                                        ORDER BY TCP.NUMPAR DESC ) TAX LIMIT 1 )                     END AS Numeric(15,2)) AS TaxaCartaoParcelas, -- Taxa do carto (Operao Carto)
               CAST(CASE WHEN TEF.TIPOPE = 'D' THEN '2'
                         WHEN TEF.TIPOPE = 'C' THEN '1'
                         WHEN REC.CARTAO IS NOT NULL THEN '1'
                         ELSE NULL
                    END AS VARCHAR(1)) AS TipoCartao, -- {1 - Crdito / 2 - Dbito} (Operao Carto)
               CAST(CASE WHEN TEF.MANUAL = 'T' THEN '0'
                         ELSE '0' -- SiTEF
                    END AS VARCHAR(1)) AS GerenciadorTEF, -- {0 - Nenhum / 1 - TEF Disc / 2 - TEF Dial / 3 - Hiper TEF} (Operao Carto)
               CAST(CASE WHEN REC.CARTAO IS NOT NULL AND REC.AVISTA = 'T' THEN '0'
                         WHEN REC.CARTAO IS NOT NULL AND REC.AVISTA = 'F' THEN '2'
                         ELSE NULL
                    END AS VARCHAR(1)) AS TipoParcelamento, -- {0 -  Vista / 1 - Parc. Administradora / 2 - Parc. Lojista} (Operao Carto)
               --CAST((SELECT MAX(ITF.NUMITE) FROM TT_ITF ITF WHERE ITF.CODFIL = TEF.CODFIL AND ITF.SEQUEN = TEF.SEQUEN) AS Numeric(8)) AS NumeroParcelas, -- Nmero de Parcelas - Esse nmero deve ser igual ao nmero de parcelas do documento (Operao Carto)
               CASE WHEN REC.CARTAO IS NOT NULL THEN CAST(COALESCE((SELECT MAX(ITF.NUMITE) FROM TT_ITF ITF WHERE ITF.CODFIL = TEF.CODFIL AND ITF.SEQUEN = TEF.SEQUEN),1) AS Numeric(8)) ELSE NULL END AS NumeroParcelas, -- Nmero de Parcelas - Esse nmero deve ser igual ao nmero de parcelas do documento (Operao Carto)
               CAST(TEF.NSUTRN AS VARCHAR(20)) AS NSU, -- Nmero Transao (Operao Carto)
               CAST(TEF.NUMAUT AS VARCHAR(20)) AS CodAutTransacao, -- Cdigo de Autorizao da Transao (Operao Carto)
               CAST(NULL AS VARCHAR(20)) AS NumeroRVRO, -- Nmero do Resumo de Vendas ou de Operao (Operao Carto)
               -- Operao
               CAST(TRUNC(REC.PAGAME) AS Timestamp) AS DataEntradaCaixa, -- Data Entrada (Operao Caixa)
               -- Cheque
               CAST(TO_NUMBER(CHR.CODBCO) AS Numeric(9)) AS CodigoBanco, -- Cdigo do Banco (Operao Cheque)
               CAST(CHR.CODAGE AS VARCHAR(10)) AS CODAGENCIA, -- Cdigo da Agncia (Operao Cheque)
               CAST(CHR.NUMCON AS VARCHAR(10)) AS CODCONTABAN, -- Cdigo da Conta Bancria (Operao Cheque)
               CAST(TO_NUMBER(CHR.NUMCHE) AS Numeric(9)) AS NumeroCheque, -- Nmero Cheque (Operao Cheque)
               CAST(NULL AS Numeric(9)) AS Tipificacao, -- Tipificao (Operao Cheque)
               CAST(CASE WHEN (ISNOTNULL(REC.SEQCHE)='T') THEN REC.DATVEN 
                         ELSE NULL
                    END AS Timestamp) AS DataVctoCheque, -- Data de Vencimento (Operao Cheque)
               CAST(CASE WHEN (ISNULL(REC.SEQCHE)='T') THEN 'F'
                         WHEN (CHR.FILCLI||CHR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) AND (VEN.FILCLI||VEN.CODCLI = CHR.FILCLI||CHR.CODCLI) AND 
                              (ISNOTNULL(CHR.FILCLI) = 'T') AND (TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) = TRIM(COALESCE(CHR.NUMDOC, CHR_PAR.NUMDOC))) THEN 'F'
                         ELSE 'T'
                    END AS VARCHAR(1)) AS ChequeTerceiro, --  Cheque Terceiro? (Operao Cheque) {F=False, T=True} Enviar como F por padro
               CAST(TRIM(COALESCE(CHR.NUMDOC, CHR_PAR.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCheque, -- CPF ou CNPJ da Identificao Cliente (Operao Cheque)
               -- Crdiario/Boleto
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND ((CASE WHEN (ISNOTNULL(DCCC.DESCCC) = 'T') THEN UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) ELSE 'CREDIARIO' END) <> 'CONVENIO CRE') THEN REC.DATVEN 
                         ELSE NULL
                    END AS Timestamp) AS DataVctoDuplicata, -- Data de Vencimento (Operao Duplicata)
               -- Definido juntamente com a EME4 que deve ser enviado apenas numero sem zero a esquerda, ser enviado apenas o n da parcela pois no enviaremos as sub-parcelas nesse ponto ser enviado como Operao de Liquidao 
               --CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') THEN TO_NUMBER(LPAD(TRIM(REC.NUMPAR), 2, '0')||LPAD(TRIM(REC.SUBPAR), 2, '0'))
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND ((CASE WHEN (ISNOTNULL(DCCC.DESCCC) = 'T') THEN UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) ELSE 'CREDIARIO' END) <> 'CONVENIO CRE') THEN TO_NUMBER(TRIM(REC.NUMPAR))
                         ELSE NULL
                    END AS Numeric(9)) AS Parcela, -- N Parcela (Operao Duplicata)
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND ((CASE WHEN (ISNOTNULL(DCCC.DESCCC) = 'T') THEN UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) ELSE 'CREDIARIO' END) <> 'CONVENIO CRE') THEN PLA.VLTXMU
                         ELSE NULL
                    END AS Numeric(15,5)) AS MoraAtrasoDuplic, -- Taxa Mora Atraso (Operao Duplicata)
               CAST(NULL AS Numeric(15,5)) AS MoraAntecipDuplic, -- Taxa Mora Antecipao (Operao Duplicata)
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND ((CASE WHEN (ISNOTNULL(DCCC.DESCCC) = 'T') THEN UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) ELSE 'CREDIARIO' END) <> 'CONVENIO CRE') THEN PLA.PRAIDE
                         ELSE NULL
                    END AS Numeric(9)) AS DiasJurosAtrasoDuplic, -- Dias Cobrar Juros Atraso (Operao Duplicata)
               CAST(NULL AS Numeric(9)) AS DiasJurosAntecDuplic, -- Dias Cobrar Juros Antecipao (Operao Duplicata)
               -- Convnio
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') AND (LeParametroTXT('TIPO_EXP_EME4', REC.CODFIL, '', '', '')='C') THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0') ELSE NULL END AS Numeric(9)) AS CodigoCliConv, -- Cdigo do Cliente Conveniado
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN PAR.NUMDOC ELSE NULL END AS VARCHAR(18)) AS CPFCNPJCliConv, -- CPF ou CNPJ do Cliente Conveniado
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN VIN_CNV.NUMDOC ELSE NULL END AS VARCHAR(18)) AS CPFCNPJConvenio, -- CPF ou CNPJ do Convnio
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN 1 ELSE NULL END AS Numeric(8)) AS NumeroParcelasConv, -- Nmero de Parcelas (Operao Convnio)
               -- Definido juntamente com a EME4 que devemos enviar NULL para o campo
               /*
               CAST(CASE WHEN REC.CARTAO IS NOT NULL THEN NULL
                         WHEN (ISNOTNULL(REC.SEQCHE) = 'T') THEN NULL
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN NULL
                         WHEN (COALESCE(CCC.VLRLAN, 0) < 0) AND VEN.NUMECF >= '500' THEN (
                                    SELECT TRIM(CASE WHEN VENVLE.CODSER='CF' THEN VENVLE.CODSER
                                                     WHEN VENVLE.CODSER<>'CF' AND ISNOTNULL(DSERVLE.SEREXT)='T' THEN DSERVLE.SEREXT
                                                     WHEN ( (VENVLE.MODNOT = '65' OR VENVLE.MODNOT = '59') AND VENVLE.NUMECF >= '400' ) THEN VENVLE.NUMECF
                                                     ELSE NULL
                                                END) || '-' ||
                                           TO_CHAR(TO_NUMBER(TRIM(CASE WHEN VENVLE.CODSER = 'CF' THEN VENVLE.SEQUEN 
                                                                       WHEN VENVLE.CODSER = 'ST' THEN COALESCE(TO_CHAR(VENVLE.SATCFE), VENVLE.NUMNOT)
                                                                       ELSE VENVLE.NUMNOT END)))
                                      FROM TT_CCC VALE
                                      JOIN TT_VEN VENVLE ON VENVLE.CODFIL = VALE.CODVEN AND VENVLE.SEQUEN = VALE.SEQVEN
                                      JOIN TD_SER DSERVLE ON DSERVLE.CODSER = VENVLE.CODSER
                                     WHERE VALE.TIPLAN = 'K'
                                       AND VALE.TIPCCC = CCC.TIPCCC
                                       AND VALE.VLRLAN = (CCC.VLRLAN * -1)
                                       AND VALE.NUMDOC = CCC.NUMDOC
                                   )
                         ELSE NULL
                    END AS VARCHAR(25)) AS NroDoctoAdtoADC -- Nmero do Documento de Origem do Adiantamento
               */
               CAST(NULL AS VARCHAR(25)) AS NroDoctoAdtoADC -- Nmero do Documento de Origem do Adiantamento
          FROM TT_REC REC
          JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
          -- Srie de Emisso
          JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
          -- Cliente
          JOIN TT_CLI PAR ON PAR.FILCLI = VEN.FILCLI AND PAR.CODCLI = VEN.CODCLI
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = VEN.FILCLI AND ENDFAT.CODCLI = VEN.CODCLI AND ENDFAT.CODFIL = VEN.FILFAT AND ENDFAT.NUMEND = VEN.ENDFAT
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          -- Portador
          JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD
          -- Conta Financeira
          JOIN TT_CTA CTA ON CTA.CODFIL = DCOB.FILCTA AND CTA.SEQUEN = DCOB.SEQCTA AND CTA.TIPCTA  = DCOB.TIPCTA
          -- Carto
          LEFT JOIN TT_TEF TEF ON TEF.CODFIL = REC.FILITF AND TEF.SEQUEN = REC.SEQITF
          LEFT JOIN TD_CAR DCAR ON DCAR.CODTAB = REC.CARTAO
          -- Portador do Carto
          LEFT JOIN TD_COB DCOB_DCAR ON DCOB_DCAR.CODTAB = DCAR.PORCAR AND DCOB_DCAR.TIPCOB = DCAR.COBCAR
          -- Conta Financeira do Carto
          LEFT JOIN TT_CTA CTA_DCAR ON CTA_DCAR.CODFIL = DCOB_DCAR.FILCTA AND CTA_DCAR.SEQUEN = DCOB_DCAR.SEQCTA AND CTA_DCAR.TIPCTA  = DCOB_DCAR.TIPCTA
          -- Cheque
          LEFT JOIN TT_CHR CHR ON CHR.CODFIL = REC.FILREC AND CHR.SEQUEN = REC.SEQCHE
          -- Portador do Cheque
          --LEFT JOIN TD_COB DCOB_CHR ON DCOB_CHR.CODTAB = CHR.PORTAD AND DCOB_CHR.TIPCOB = CHR.TIPCOB
          -- Conta Financeira do Cheque
          --LEFT JOIN TT_CTA CTA_CHR ON CTA_CHR.CODFIL = DCOB_CHR.FILCTA AND CTA_CHR.SEQUEN = DCOB_CHR.SEQCTA AND CTA_CHR.TIPCTA  = DCOB_CHR.TIPCTA
          -- Parceiro do Cheque
          LEFT JOIN TT_CLI CHR_PAR ON CHR_PAR.FILCLI = CHR.FILCLI AND CHR_PAR.CODCLI = CHR.CODCLI
          -- Plano 
          JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT AND PLA.CODPGT = VEN.CODPGT
          -- Conta Corrente
          LEFT OUTER JOIN TT_CCC CCC ON CCC.CODFIL = REC.FILCCC AND CCC.SEQUEN = REC.SEQCCC 
                                    AND ((CCC.TIPLAN <> 'K') OR ((CCC.TIPLAN = 'K') AND (CCC.VLRLAN  < 0))) -- Desconsidera lanamento do novo Vale Compra quando utilizao parcial
          LEFT OUTER JOIN TD_CCC DCCC ON DCCC.CODTAB = CCC.TIPCCC
          -- Parceiro Vinculado - Convnio
          LEFT JOIN TT_CLI VIN_CNV ON VIN_CNV.FILCLI = PAR.FILVIN AND VIN_CNV.CODCLI = PAR.CODVIN
          --Cdigo externo da conta financeira
          LEFT JOIN TT_CTAXFIL CXF ON CXF.FILCTA = CTA.CODFIL AND CXF.SEQCTA = CTA.SEQUEN AND CXF.CODFIL = REC.CODFIL 
          --Cdigo externo da conta financeira
          LEFT JOIN TT_CTAXFIL CXF_DCAR ON CXF_DCAR.FILCTA = CTA_DCAR.CODFIL AND CXF_DCAR.SEQCTA = CTA_DCAR.SEQUEN AND CXF_DCAR.CODFIL = REC.CODFIL 
         WHERE 1=1 --REC.SUBPAR = ' 0' -- No trata Sub-Parcela 0 pois operao de recebimento pode ocorrer com todas as operaes
           AND VEN.NUMNOT NOT LIKE '%#%'
           AND VEN.FILEST IS NOT NULL -- Devoluo automtica ou Nota de Estorno
           AND REC.FLGEST = 'X'       -- Devoluo automtica ou Nota de Estorno
           AND REC.AVISTA = 'F'
           AND COALESCE(REC.INDEXP, 'E') <> 'N'
           AND REC.PAGAME >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',REC.CODFIL,'','','')
           AND (LeParametroTXT('TIPO_EXP_EME4', REC.CODFIL, '', '', '') = 'V')
           --AND LID.EXPEM4 = 'F'        
         AND NOT EXISTS(SELECT 1 AS OK 
                          FROM TW_EXTXDOC EXD 
                         WHERE EXD.ORIGEM = DESTINO AND EXD.DESTINO = ORIGEM
                           AND EXD.FILORI = REC.CODFIL AND EXD.SEQORI = REC.SEQUEN 
                           AND EXD.PARORI = REC.NUMPAR AND EXD.SUBORI = REC.SUBPAR)
     ) TAB
 WHERE 1=1
   AND TAB.TipoOperacao IS NOT NULL
ORDER BY TAB.CODFIL, TAB.SEQUEN, TAB.NUMPAR, TAB.SUBPAR, TAB.DataHoraAtuReg
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Liquidaes do Documento" (Tabela Integrao Mult)
-- Arquivo Pai: TIMU_LIQUIDACAODOCTO
/*-- SEQ 2674 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_LIQUIDACAODOCTOPAGEMI CASCADE;

/*-- SEQ 2675 --*/
CREATE OR REPLACE VIEW TV_TIMU_LIQUIDACAODOCTOPAGEMI AS
   SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.NUMPAR, TAB.SUBPAR, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.FilialAdtoADC, -- Cdigo da Filial do Adiantamento de Cliente
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.FormaLiquidacao, -- Informar uma das opes: 'Liquidao Carto CRE', 'Liquidao Cheque CRE', 'Liquidao Duplicata', 'Liquidao Operao Caixa', 'Liquidao Convnio CRE', 'Liquidao Adiant. Cliente', 'Troco Dinheiro', 'Liquidao Operao Bancaria'
      TAB.TPPADCONTA, -- Tipo padro de conta tesouraria. Informar uma das opes. 0 - Conta Caixa, 1 - Conta Bancria, 2 - Conta Convnio  Receber, 3 - Conta Convnio  Pagar, 4 - Conta Carto  Pagar, 5 - Conta Carto  Receber, 6 - Conta Aplicao Financeira
      TAB.CodContaTes, -- Cdigo da Conta Tesouraria para onde vai a liquidao
      TAB.ValorFormaLiqOri, -- Valor da Forma de Liquidao Original
      TAB.ValorFormaLiq, -- Valor da Forma de Liquidao
      TAB.Historico, -- Histrico da Liquidao
      TAB.DataVctoCartao, -- Primeira Data de Vencimento do Carto (Operao Carto)
      COALESCE(TAB.TaxaCartaoParcelas, TAB.TaxaCartao) AS TaxaCartao, -- Taxa do carto (Operao Carto)
      TAB.TipoCartao, -- {1 - Crdito / 2 - Dbito} (Operao Carto)
      TAB.GerenciadorTEF, -- {0 - Nenhum / 1 - TEF Disc / 2 - TEF Dial / 3 - Hiper TEF} (Operao Carto)
      TAB.TipoParcelamento, -- {0 -  Vista / 1 - Parc. Administradora / 2 - Parc. Lojista} (Operao Carto)
      TAB.NumeroParcelas, -- Nmero de Parcelas - Esse nmero deve ser igual ao nmero de parcelas do documento (Operao Carto)
      TAB.NSU, -- Nmero Transao (Operao Carto)
      TAB.CodAutTransacao, -- Cdigo de Autorizao da Transao (Operao Carto)
      TAB.NumeroRVRO, -- Nmero do Resumo de Vendas ou de Operao (Operao Carto)
      TAB.DataEntradaCaixa, -- Data Entrada (Operao Caixa)
      TAB.CodigoBanco, -- Cdigo do Banco (Operao Cheque)
      TAB.CODAGENCIA, -- Cdigo da Agncia (Operao Cheque)
      TAB.CODCONTABAN, -- Cdigo da Conta Bancria (Operao Cheque)
      TAB.NumeroCheque, -- Nmero Cheque (Operao Cheque)
      TAB.Tipificacao, -- Tipificao (Operao Cheque)
      TAB.DataVctoCheque, -- Data de Vencimento (Operao Cheque)
      TAB.ChequeTerceiro, --  Cheque Terceiro? (Operao Cheque) {F=False, T=True} Enviar como F por padro
      TAB.CPFCNPJCheque, -- CPF ou CNPJ da Identificao Cliente (Operao Cheque)
      TAB.DataVctoDuplicata, -- Data de Vencimento (Operao Duplicata)
      TAB.Parcela, -- N Parcela (Operao Duplicata)
      TAB.MoraAtrasoDuplic, -- Taxa Mora Atraso (Operao Duplicata)
      TAB.MoraAntecipDuplic, -- Taxa Mora Antecipao (Operao Duplicata)
      TAB.DiasJurosAtrasoDuplic, -- Dias Cobrar Juros Atraso (Operao Duplicata)
      TAB.DiasJurosAntecDuplic, -- Dias Cobrar Juros Antecipao (Operao Duplicata)
      TAB.CodigoCliConv, -- Cdigo do Cliente Conveniado
      TAB.CPFCNPJCliConv, -- CPF ou CNPJ do Cliente Conveniado
      TAB.CPFCNPJConvenio, -- CPF ou CNPJ do Convnio
      TAB.NumeroParcelasConv, -- Nmero de Parcelas (Operao Convnio)
      TAB.NroDoctoAdtoADC, -- Nmero do Documento de Origem do Adiantamento
      TAB.CPFCNPJCliCC -- CPF ou CNPJ do Cliente do Vale Compra
     FROM (
        -- Pagamentos de Notas Emitidas
        SELECT
               VEN.CODFIL, VEN.SEQUEN, REC.NUMPAR, REC.SUBPAR, CAST('REC' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_LIQUIDACAODOCTO' AS VARCHAR(50)) AS DESTINO, COALESCE(VEN.DATINC, VEN.DATHOR) AS DATINC, VEN.ATU_EM, REC.EXPORT, VEN.EXPEM4,
               CAST('VEN' || VEN.CODFIL || VEN.SEQUEN AS VARCHAR(50)) AS CHAVE,
               COALESCE(VEN.DATINC, VEN.DATHOR) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               -- Definido juntamente com a EME4 quando for cupom fiscal enviar tipo de operao fixo
               CAST(CASE WHEN (VEN.CODSER = 'CF') THEN 998
                         WHEN (VEN.MODNOT = '65') THEN 997
                         WHEN (VEN.MODNOT = '59') THEN 996
                         WHEN (VEN.UFLOJA = 'T') THEN                                                       TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTDEM, '[^0-9]', '', 'gi'), ''))                         ELSE                               TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTFOR, '[^0-9]', '', 'gi'), ''))                    END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST( CASE WHEN (UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'PIX' OR UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'CARDSE') THEN NULL --Solicitao da EME4 para integ. PIX
                     ELSE TO_NUMBER(VEN.CODFIL)
                     END AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE) = 'T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') AND (COALESCE(CCC.VLRLAN, 0) < 0)) THEN TO_NUMBER(VEN.CODFIL)
                         ELSE NULL -- Envia NULL quando "FormaLiquidacao = Liquidao Adiant. Cliente"
                    END AS Numeric(3)) AS FilialAdtoADC, -- Cdigo da Filial do Adiantamento de Cliente
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         WHEN (REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE) = 'T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') AND (COALESCE(CCC.VLRLAN, 0) < 0)) THEN 
                              TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                         ELSE NULL -- Envia NULL quando "FormaLiquidacao = Liquidao Adiant. Cliente"
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(CASE WHEN (REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE) = 'T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') AND (COALESCE(CCC.VLRLAN, 0) < 0)) THEN TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))
                         ELSE NULL -- Envia NULL quando "FormaLiquidacao = Liquidao Adiant. Cliente"
                    END AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN (REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE) = 'T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') AND (COALESCE(CCC.VLRLAN, 0) < 0)) THEN
                                CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = VEN.FILCLI AND REL.CODPAR = VEN.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                                     ELSE 'C' 
                                END 
                         ELSE NULL -- Envia NULL quando "FormaLiquidacao = Liquidao Adiant. Cliente"
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST(TRIM(CASE WHEN VEN.CODSER='CF' THEN VEN.CODSER
                              WHEN VEN.CODSER='NM' THEN CAST(CONCAT('N',VEN.NUMECF) AS VARCHAR(5))
                              WHEN ( (VEN.MODNOT = '65' OR VEN.MODNOT = '59') AND VEN.NUMECF >= '400' ) THEN VEN.NUMECF
                              WHEN VEN.CODSER<>'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN DSER.SEREXT
                              ELSE NULL
                         END) AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(TO_CHAR(TO_NUMBER(TRIM(CASE WHEN VEN.CODSER = 'CF' THEN VEN.SEQUEN 
                                                WHEN VEN.CODSER = 'ST' THEN COALESCE(TO_CHAR(VEN.SATCFE), VEN.NUMNOT)
                                                ELSE VEN.NUMNOT END))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST(CASE WHEN REC.CARTAO IS NOT NULL THEN 
                           CASE WHEN (UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'PIX' OR UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'CARDSE') THEN 'Liquidao Operao Bancaria'
                           ELSE 'Liquidao Carto CRE'
                           END
                         WHEN (ISNOTNULL(REC.SEQCHE) = 'T') THEN 'Liquidao Cheque CRE'
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN 'Liquidao Convnio CRE'
                         WHEN (COALESCE(CCC.VLRLAN, 0) < 0) THEN 'Liquidao Adiant. Cliente'
                         WHEN (DCOB.TIPCOB IN ('B','L','O','P')) OR (CCC.SEQUEN IS NOT NULL) THEN 'Liquidao Duplicata'
                         ELSE 'Liquidao Operao Caixa'
                    END AS VARCHAR(50)) AS FormaLiquidacao, -- Informar uma das opes: 'Liquidao Carto CRE', 'Liquidao Cheque CRE', 'Liquidao Duplicata', 'Liquidao Operao Caixa', 'Liquidao Convnio CRE', 'Liquidao Adiant. Cliente', 'Troco Dinheiro', 'Liquidao Operao Bancaria'
               CAST(CASE WHEN REC.CARTAO IS NOT NULL THEN 
                           CASE WHEN (UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'PIX' OR UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'CARDSE') THEN '1'
                           ELSE '5'
                           END
                         WHEN (ISNOTNULL(REC.SEQCHE) = 'T') THEN '0'
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN '2'
                         WHEN (DCOB.TIPCOB IN ('B','L','O','P')) OR (CCC.SEQUEN IS NOT NULL) THEN ''
                         ELSE '0'
                    END AS VARCHAR(1)) AS TPPADCONTA, -- Tipo padro de conta tesouraria. Informar uma das opes. 0 - Conta Caixa, 1 - Conta Bancria, 2 - Conta Convnio  Receber, 3 - Conta Convnio  Pagar, 4 - Conta Carto  Pagar, 5 - Conta Carto  Receber, 6 - Conta Aplicao Financeira
               CAST(CASE WHEN REC.CARTAO IS NOT NULL THEN TRIM(COALESCE(CXF_DCAR.CODEXT, CTA_DCAR.CODEXT, CODIGO_CONTA(CTA_DCAR.CODFIL, CTA_DCAR.SEQUEN, 'X')))
                         --WHEN (ISNOTNULL(REC.SEQCHE) = 'T') THEN TRIM(CTA_CHR.CODEXT)
                         WHEN (ISNOTNULL(REC.SEQCHE) = 'T') THEN TRIM(COALESCE(CXF.CODEXT, CTA.CODEXT, CODIGO_CONTA(CTA.CODFIL, CTA.SEQUEN, 'X')))
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN NULL
                         ELSE TRIM(COALESCE(CXF.CODEXT, CTA.CODEXT, CODIGO_CONTA(CTA.CODFIL, CTA.SEQUEN, 'X')))
                    END AS VARCHAR(20)) AS CodContaTes, -- Cdigo da Conta Tesouraria para onde vai a liquidao
               CAST(ABS(REC.VLRPAR) AS Numeric(15,2)) AS ValorFormaLiqOri, -- Valor da Forma de Liquidao Original
               CAST(ABS(REC.VLRPAR) +
                    CASE WHEN (REC.CARTAO IS NOT NULL) OR (ISNOTNULL(REC.SEQCHE) = 'T') OR (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') OR (COALESCE(CCC.VLRLAN, 0) < 0) OR ((DCOB.TIPCOB IN ('B','L','O','P')) OR (CCC.SEQUEN IS NOT NULL)) THEN 0
                         ELSE ABS(COALESCE(TRC.VLROPE,0))
                    END AS Numeric(15,2)) AS ValorFormaLiq, -- Valor da Forma de Liquidao
               CAST(CASE WHEN REC.CARTAO IS NOT NULL THEN 
                           CASE WHEN (UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'PIX' OR UPPER(LIMPA_ESPECIAIS(DCAR.DESOUT)) = 'CARDSE') THEN 'Liquidao Operao Bancaria'
                           ELSE 'Liquidao Carto CRE'
                           END
                         WHEN (ISNOTNULL(REC.SEQCHE) = 'T') THEN 'Liquidao Cheque CRE'
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN 'Liquidao Convnio CRE'
                         WHEN (COALESCE(CCC.VLRLAN, 0) < 0) THEN 'Liquidao Adiant. Cliente'
                         WHEN (DCOB.TIPCOB IN ('B','L','O','P')) OR (CCC.SEQUEN IS NOT NULL) THEN 'Liquidao Duplicata'
                         ELSE 'Liquidao Operao Caixa'
                    END AS VARCHAR(150)) AS Historico, -- Histrico da Liquidao
               -- Carto
               CAST(CASE WHEN REC.CARTAO IS NOT NULL THEN REC.DATVEN
                         ELSE NULL
                    END AS Timestamp) AS DataVctoCartao, -- Primeira Data de Vencimento do Carto (Operao Carto)
               CAST(CASE WHEN TEF.TIPOPE = 'D' THEN DCAR.TAXDEB 
                         WHEN TEF.TIPOPE = 'C' THEN DCAR.TAXCAR
                         WHEN REC.CARTAO IS NULL THEN DCAR.TAXCAR
                         ELSE NULL
                    END AS Numeric(15,2)) AS TaxaCartao, -- Taxa do carto (Operao Carto)
               CAST(CASE WHEN TEF.TIPOPE = 'D' OR REC.CARTAO IS NULL THEN NULL
                         -- Em Oracle est apresentando erro Interno "ORA-00600: cdigo de erro interno, argumentos: [kkqcscorcbk: correlated string not found.]" ao realizar a sub-consulta com isso optei por calcular a taxa conforme o valor da taxa na REC
                           ELSE (SELECT TAX.TAXCAR FROM (SELECT TCP.NUMPAR, TCP.TAXCAR
                                         FROM TT_TCP TCP 
                                        WHERE TCP.CARTAO = REC.CARTAO
                                          AND TCP.NUMPAR <= (SELECT COUNT(*) FROM TT_ITF ITF WHERE ITF.CODFIL = TEF.CODFIL AND ITF.SEQUEN = TEF.SEQUEN)
                                        ORDER BY TCP.NUMPAR DESC ) TAX LIMIT 1 )                     END AS Numeric(15,2)) AS TaxaCartaoParcelas, -- Taxa do carto (Operao Carto)
               CAST(CASE WHEN TEF.TIPOPE = 'D' THEN '2'
                         WHEN TEF.TIPOPE = 'C' THEN '1'
                         WHEN REC.CARTAO IS NOT NULL THEN '1'
                         ELSE NULL
                    END AS VARCHAR(1)) AS TipoCartao, -- {1 - Crdito / 2 - Dbito} (Operao Carto)
               CAST(CASE WHEN TEF.MANUAL = 'T' THEN '0'
                         ELSE '0' -- SiTEF
                    END AS VARCHAR(1)) AS GerenciadorTEF, -- {0 - Nenhum / 1 - TEF Disc / 2 - TEF Dial / 3 - Hiper TEF} (Operao Carto)
               CAST(CASE WHEN REC.CARTAO IS NOT NULL AND REC.AVISTA = 'T' THEN '0'
                         WHEN REC.CARTAO IS NOT NULL AND REC.AVISTA = 'F' THEN '2'
                         ELSE NULL
                    END AS VARCHAR(1)) AS TipoParcelamento, -- {0 -  Vista / 1 - Parc. Administradora / 2 - Parc. Lojista} (Operao Carto)
               --CAST((SELECT MAX(ITF.NUMITE) FROM TT_ITF ITF WHERE ITF.CODFIL = TEF.CODFIL AND ITF.SEQUEN = TEF.SEQUEN) AS Numeric(8)) AS NumeroParcelas, -- Nmero de Parcelas - Esse nmero deve ser igual ao nmero de parcelas do documento (Operao Carto)
               CASE WHEN REC.CARTAO IS NOT NULL THEN CAST(COALESCE((SELECT MAX(ITF.NUMITE) FROM TT_ITF ITF WHERE ITF.CODFIL = TEF.CODFIL AND ITF.SEQUEN = TEF.SEQUEN),1) AS Numeric(8)) ELSE NULL END AS NumeroParcelas, -- Nmero de Parcelas - Esse nmero deve ser igual ao nmero de parcelas do documento (Operao Carto)
               CAST(TEF.NSUTRN AS VARCHAR(20)) AS NSU, -- Nmero Transao (Operao Carto)
               CAST(TEF.NUMAUT AS VARCHAR(20)) AS CodAutTransacao, -- Cdigo de Autorizao da Transao (Operao Carto)
               CAST(NULL AS VARCHAR(20)) AS NumeroRVRO, -- Nmero do Resumo de Vendas ou de Operao (Operao Carto)
               -- Operao
               CAST(TRUNC(REC.PAGAME) AS Timestamp) AS DataEntradaCaixa, -- Data Entrada (Operao Caixa)
               -- Cheque
               CAST(TO_NUMBER(CHR.CODBCO) AS Numeric(9)) AS CodigoBanco, -- Cdigo do Banco (Operao Cheque)
               CAST(CHR.CODAGE AS VARCHAR(10)) AS CODAGENCIA, -- Cdigo da Agncia (Operao Cheque)
               CAST(CHR.NUMCON AS VARCHAR(10)) AS CODCONTABAN, -- Cdigo da Conta Bancria (Operao Cheque)
               CAST(TO_NUMBER(CHR.NUMCHE) AS Numeric(9)) AS NumeroCheque, -- Nmero Cheque (Operao Cheque)
               CAST(NULL AS Numeric(9)) AS Tipificacao, -- Tipificao (Operao Cheque)
               CAST(CASE WHEN ISNOTNULL(REC.SEQCHE)='T' THEN REC.DATVEN 
                         ELSE NULL
                    END AS Timestamp) AS DataVctoCheque, -- Data de Vencimento (Operao Cheque)
               CAST(CASE WHEN ISNULL(REC.SEQCHE)='T' THEN 'F'
                         WHEN (CHR.FILCLI||CHR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) AND (VEN.FILCLI||VEN.CODCLI = CHR.FILCLI||CHR.CODCLI) AND 
                              (ISNOTNULL(CHR.FILCLI) = 'T') AND (TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) = TRIM(COALESCE(CHR.NUMDOC, CHR_PAR.NUMDOC))) THEN 'F'
                         ELSE 'T'
                    END AS VARCHAR(1)) AS ChequeTerceiro, --  Cheque Terceiro? (Operao Cheque) {F=False, T=True} Enviar como F por padro
               CAST(TRIM(COALESCE(CHR.NUMDOC, CHR_PAR.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCheque, -- CPF ou CNPJ da Identificao Cliente (Operao Cheque)
               -- Crdiario/Boleto
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND ((CASE WHEN (ISNOTNULL(DCCC.DESCCC) = 'T') THEN UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) ELSE 'CREDIARIO' END) <> 'CONVENIO CRE') THEN REC.DATVEN 
                         ELSE NULL
                    END AS Timestamp) AS DataVctoDuplicata, -- Data de Vencimento (Operao Duplicata)
               -- Definido juntamente com a EME4 que deve ser enviado apenas numero sem zero a esquerda, ser enviado apenas o n da parcela pois no enviaremos as sub-parcelas nesse ponto ser enviado como Operao de Liquidao 
               --CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) <> 'CONVENIO CRE') THEN TO_NUMBER(LPAD(TRIM(REC.NUMPAR), 2, '0')||LPAD(TRIM(REC.SUBPAR), 2, '0'))
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND ((CASE WHEN (ISNOTNULL(DCCC.DESCCC) = 'T') THEN UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) ELSE 'CREDIARIO' END) <> 'CONVENIO CRE') THEN TO_NUMBER(TRIM(REC.NUMPAR))
                         ELSE NULL
                    END AS Numeric(9)) AS Parcela, -- N Parcela (Operao Duplicata)
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND ((CASE WHEN (ISNOTNULL(DCCC.DESCCC) = 'T') THEN UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) ELSE 'CREDIARIO' END) <> 'CONVENIO CRE') THEN PLA.VLTXMU
                         ELSE NULL
                    END AS Numeric(15,5)) AS MoraAtrasoDuplic, -- Taxa Mora Atraso (Operao Duplicata)
               CAST(NULL AS Numeric(15,5)) AS MoraAntecipDuplic, -- Taxa Mora Antecipao (Operao Duplicata)
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND ((CASE WHEN (ISNOTNULL(DCCC.DESCCC) = 'T') THEN UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) ELSE 'CREDIARIO' END) <> 'CONVENIO CRE') THEN PLA.PRAIDE
                         ELSE NULL
                    END AS Numeric(9)) AS DiasJurosAtrasoDuplic, -- Dias Cobrar Juros Atraso (Operao Duplicata)
               CAST(NULL AS Numeric(9)) AS DiasJurosAntecDuplic, -- Dias Cobrar Juros Antecipao (Operao Duplicata)
               -- Convnio
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') AND (LeParametroTXT('TIPO_EXP_EME4', VEN.CODFIL, '', '', '')='C') THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0') ELSE NULL END AS Numeric(9)) AS CodigoCliConv, -- Cdigo do Cliente Conveniado
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN PAR.NUMDOC ELSE NULL END AS VARCHAR(18)) AS CPFCNPJCliConv, -- CPF ou CNPJ do Cliente Conveniado
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN VIN_CNV.NUMDOC ELSE NULL END AS VARCHAR(18)) AS CPFCNPJConvenio, -- CPF ou CNPJ do Convnio
               CAST(CASE WHEN REC.CARTAO IS NULL AND (ISNULL(REC.SEQCHE)='T') AND (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN 1 ELSE NULL END AS Numeric(8)) AS NumeroParcelasConv, -- Nmero de Parcelas (Operao Convnio)
               -- Definido juntamente com a EME4 que devemos enviar NULL para o campo
               /*
               CAST(CASE WHEN REC.CARTAO IS NOT NULL THEN NULL
                         WHEN (ISNOTNULL(REC.SEQCHE) = 'T') THEN NULL
                         WHEN (UPPER(LIMPA_ESPECIAIS(DCCC.DESCCC)) = 'CONVENIO CRE') THEN NULL
                         WHEN (COALESCE(CCC.VLRLAN, 0) < 0) AND VEN.NUMECF >= '500' THEN (
                                    SELECT TRIM(CASE WHEN VENVLE.CODSER='CF' THEN VENVLE.CODSER
                                                     WHEN VENVLE.CODSER<>'CF' AND ISNOTNULL(DSERVLE.SEREXT)='T' THEN DSERVLE.SEREXT
                                                     WHEN ( (VENVLE.MODNOT = '65' OR VENVLE.MODNOT = '59') AND VENVLE.NUMECF >= '400' ) THEN VENVLE.NUMECF
                                                     ELSE NULL
                                                END) || '-' ||
                                           TO_CHAR(TO_NUMBER(TRIM(CASE WHEN VENVLE.CODSER = 'CF' THEN VENVLE.SEQUEN 
                                                                       WHEN VENVLE.CODSER = 'ST' THEN COALESCE(TO_CHAR(VENVLE.SATCFE), VENVLE.NUMNOT)
                                                                       ELSE VENVLE.NUMNOT END)))
                                      FROM TT_CCC VALE
                                      JOIN TT_VEN VENVLE ON VENVLE.CODFIL = VALE.CODVEN AND VENVLE.SEQUEN = VALE.SEQVEN
                                      JOIN TD_SER DSERVLE ON DSERVLE.CODSER = VENVLE.CODSER
                                     WHERE VALE.TIPLAN = 'K'
                                       AND VALE.TIPCCC = CCC.TIPCCC
                                       AND VALE.VLRLAN = (CCC.VLRLAN * -1)
                                       AND VALE.NUMDOC = CCC.NUMDOC
                                   )
                         ELSE NULL
                    END AS VARCHAR(25)) AS NroDoctoAdtoADC -- Nmero do Documento de Origem do Adiantamento
               */
               CAST(NULL AS VARCHAR(25)) AS NroDoctoAdtoADC, -- Nmero do Documento de Origem do Adiantamento
--               CAST(TRIM(CLI_CC.NUMDOC) AS VARCHAR(14)) AS CPFCNPJCliCC -- CPF ou CNPJ do Cliente do Vale Compra
   			   CAST(CASE WHEN (CLI_CC.FILCLI||CLI_CC.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
			                THEN TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))  -- CPF ou CNPJ do Cliente ou Fornecedor
                         ELSE CLI_CC.NUMDOC END AS VARCHAR(14)) AS CPFCNPJCliCC -- CPF ou CNPJ do Cliente do Vale Compra
          FROM TT_REC REC
          JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
          -- Srie de Emisso
          JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
          -- Natureza
          JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
          -- Cliente
          JOIN TT_CLI PAR ON PAR.FILCLI = VEN.FILCLI AND PAR.CODCLI = VEN.CODCLI
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = VEN.FILCLI AND ENDFAT.CODCLI = VEN.CODCLI AND ENDFAT.CODFIL = VEN.FILFAT AND ENDFAT.NUMEND = VEN.ENDFAT
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          -- Portador
          JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD
          -- Conta Financeira
          JOIN TT_CTA CTA ON CTA.CODFIL = DCOB.FILCTA AND CTA.SEQUEN = DCOB.SEQCTA AND CTA.TIPCTA  = DCOB.TIPCTA
          -- Carto
          LEFT JOIN TT_TEF TEF ON TEF.CODFIL = REC.FILITF AND TEF.SEQUEN = REC.SEQITF
          LEFT JOIN TD_CAR DCAR ON DCAR.CODTAB = REC.CARTAO
          -- Portador do Carto
          LEFT JOIN TD_COB DCOB_DCAR ON DCOB_DCAR.CODTAB = DCAR.PORCAR AND DCOB_DCAR.TIPCOB = DCAR.COBCAR
          -- Conta Financeira do Carto
          LEFT JOIN TT_CTA CTA_DCAR ON CTA_DCAR.CODFIL = DCOB_DCAR.FILCTA AND CTA_DCAR.SEQUEN = DCOB_DCAR.SEQCTA AND CTA_DCAR.TIPCTA  = DCOB_DCAR.TIPCTA
          -- Cheque
          LEFT JOIN TT_CHR CHR ON CHR.CODFIL = REC.FILREC AND CHR.SEQUEN = REC.SEQCHE
          -- Portador do Cheque
          --LEFT JOIN TD_COB DCOB_CHR ON DCOB_CHR.CODTAB = CHR.PORTAD AND DCOB_CHR.TIPCOB = CHR.TIPCOB
          -- Conta Financeira do Cheque
          --LEFT JOIN TT_CTA CTA_CHR ON CTA_CHR.CODFIL = DCOB_CHR.FILCTA AND CTA_CHR.SEQUEN = DCOB_CHR.SEQCTA AND CTA_CHR.TIPCTA  = DCOB_CHR.TIPCTA
          -- Parceiro do Cheque
          LEFT JOIN TT_CLI CHR_PAR ON CHR_PAR.FILCLI = CHR.FILCLI AND CHR_PAR.CODCLI = CHR.CODCLI
          -- Plano 
          JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT AND PLA.CODPGT = VEN.CODPGT
          -- Conta Corrente
          LEFT OUTER JOIN TT_CCC CCC ON CCC.CODFIL = REC.FILCCC AND CCC.SEQUEN = REC.SEQCCC
                                    AND ((CCC.TIPLAN <> 'K') OR ((CCC.TIPLAN = 'K') AND (CCC.VLRLAN  < 0))) -- Desconsidera lanamento do novo Vale Compra quando utilizao parcial
          LEFT OUTER JOIN TD_CCC DCCC ON DCCC.CODTAB = CCC.TIPCCC
          LEFT JOIN TT_CLI CLI_CC ON CLI_CC.FILCLI = CCC.FILCLI
                                 AND CLI_CC.CODCLI = CCC.CODCLI
          -- Parceiro Vinculado - Convnio
          LEFT JOIN TT_CLI VIN_CNV ON VIN_CNV.FILCLI = PAR.FILVIN AND VIN_CNV.CODCLI = PAR.CODVIN
          -- Seleciona Operao da Indicao do Troco
          LEFT JOIN ( SELECT VLID_OPE.MEIO_PAGAMENTO, VLID_OPE.DATHOR, VLID_OPE.VLROPE, VLID_OPE.TIPOPE, VLID_OPE.VEN_CODFIL, VLID_OPE.VEN_SEQUEN, VLID_OPE.VEN_NUMECF, VLID_OPE.VEN_CODSER, VLID_OPE.VEN_NUMNOT, VLID_OPE.VEN_CNT_RO
                        FROM TV_LID_OPE VLID_OPE 
                       WHERE VLID_OPE.MEIO_PAGAMENTO = 'Dinheiro' AND VLID_OPE.TIPOPE = 'VEN' AND VLID_OPE.VLROPE < 0
                      ) TRC ON TRC.VEN_CODFIL = VEN.CODFIL AND TRC.VEN_SEQUEN = VEN.SEQUEN
                           AND REC.NUMPAR = (SELECT MIN(LREC.NUMPAR) 
                                               FROM TT_REC LREC 
                                               JOIN TD_COB LDCOB ON LDCOB.CODTAB = LREC.PORTAD
                                               LEFT OUTER JOIN TT_CCC LCCC ON LCCC.CODVEN = LREC.CODFIL AND LCCC.SEQVEN = LREC.SEQUEN AND LCCC.NUMPAR = LREC.NUMPAR AND LCCC.SUBPAR = LREC.SUBPAR
                                                                          AND ((LCCC.TIPLAN <> 'K') OR ((LCCC.TIPLAN = 'K') AND (LCCC.VLRLAN  < 0))) -- Desconsidera lanamento do novo Vale Compra quando utilizao parcial
                                               LEFT OUTER JOIN TD_CCC LDCCC ON LDCCC.CODTAB = LCCC.TIPCCC
                                              WHERE LREC.CODFIL = REC.CODFIL AND LREC.SEQUEN = REC.SEQUEN
                                                AND LREC.CARTAO IS NULL
                                                AND ISNULL(LREC.SEQCHE) = 'T'
                                                AND COALESCE(UPPER(LIMPA_ESPECIAIS(LDCCC.DESCCC)),'X') <> 'CONVENIO CRE'
                                                AND COALESCE(LCCC.VLRLAN, 0) >= 0
                                                AND ((LDCOB.TIPCOB NOT IN ('B','L','O','P')) OR (LCCC.CODVEN IS NULL))
                                              )
          --Cdigo externo da conta financeira
          LEFT JOIN TT_CTAXFIL CXF ON CXF.FILCTA = CTA.CODFIL AND CXF.SEQCTA = CTA.SEQUEN AND CXF.CODFIL = REC.CODFIL 
          --Cdigo externo da conta financeira
          LEFT JOIN TT_CTAXFIL CXF_DCAR ON CXF_DCAR.FILCTA = CTA_DCAR.CODFIL AND CXF_DCAR.SEQCTA = CTA_DCAR.SEQUEN AND CXF_DCAR.CODFIL = REC.CODFIL   
         WHERE REC.SUBPAR = ' 0' -- Trata apenas Sub-Parcela 0 pois todo controle de gerao de Recebimento Parcial deve ser controlado pela TIMU_ParteDoctoOpera
           AND VEN.NUMNOT NOT LIKE '%#%'
           AND VEN.DATHOR >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',VEN.CODFIL,'','','')
           -- Operao de Devoluo no precisa ser enviado a Parte da Liquidao para o EME4
           AND VEN.VLRNOT > 0
           AND (
                  -- Quando Cupom Fiscal
                  (VEN.CODSER = 'CF') OR
                  -- Quando a nota manual no for null (status  NM)
                  (VEN.NOTMAN IS NOT NULL) OR
                  -- Quando no for Documento Eletrnico
                  (VEN.MODNOT NOT IN ('55','65','59','SE')) OR
                  -- Quando Documento Eletrnico
                  (
                     (VEN.MODNOT IN ('55','65','59','SE')) AND 
                     (
                        -- Quando Cancelado exporta quando situao for Cancelada, Inutilizada ou Denegada
                        ((VEN.FLGEST = 'C') AND (VEN.FLGNFE IN ('3'))) OR
                        -- Quando Aberto/Quitado exporta quando situao for Autorizado
                        ((VEN.FLGEST <> 'C') AND (VEN.FLGNFE IN ('1'))) OR
                        -- Nota Estornada fica cancelada no banco mas autorizada na Sefaz
                        ((VEN.FLGEST = 'C') AND (VEN.FLGNFE = '1'))
                     )
                  )
               )
           AND VEN.EXPEM4 = 'F'
        UNION ALL
        -- Seleciona Operao da Indicao do Troco
        SELECT
               VEN.CODFIL, VEN.SEQUEN, CAST('99' AS CHAR(2)) AS NUMPAR,CAST('99' AS CHAR(2)) AS SUBPAR, CAST('REC' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_LIQUIDACAODOCTO' AS VARCHAR(50)) AS DESTINO, COALESCE(VEN.DATINC, VEN.DATHOR) AS DATINC, VEN.ATU_EM, CAST('F' AS VARCHAR(1)) AS EXPORT, VEN.EXPEM4,
               CAST('VEN' || VEN.CODFIL || VEN.SEQUEN AS VARCHAR(50)) AS CHAVE,
               COALESCE(VEN.DATINC, VEN.DATHOR) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               -- Definido juntamente com a EME4 quando for cupom fiscal enviar tipo de operao fixo
               CAST(CASE WHEN (VEN.CODSER = 'CF') THEN 998
                         WHEN (VEN.MODNOT = '65') THEN 997
                         WHEN (VEN.MODNOT = '59') THEN 996
                         WHEN (VEN.UFLOJA = 'T') THEN                                                       TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTDEM, '[^0-9]', '', 'gi'), ''))                         ELSE                               TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTFOR, '[^0-9]', '', 'gi'), ''))                    END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST(TO_NUMBER(VEN.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(NULL AS Numeric(3)) AS FilialAdtoADC, -- Cdigo da Filial do Adiantamento de Cliente
               CAST(NULL AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(NULL AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(NULL AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST(TRIM(CASE WHEN VEN.CODSER='CF' THEN VEN.CODSER
                              WHEN VEN.CODSER='NM' THEN CAST(CONCAT('N',VEN.NUMECF) AS VARCHAR(5))
                              WHEN ( (VEN.MODNOT = '65' OR VEN.MODNOT = '59') AND VEN.NUMECF >= '400' ) THEN VEN.NUMECF
                              WHEN VEN.CODSER<>'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN DSER.SEREXT
                              ELSE NULL
                         END) AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(TO_CHAR(TO_NUMBER(TRIM(CASE WHEN VEN.CODSER = 'CF' THEN VEN.SEQUEN 
                                                WHEN VEN.CODSER = 'ST' THEN COALESCE(TO_CHAR(VEN.SATCFE), VEN.NUMNOT)
                                                ELSE VEN.NUMNOT END))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST('Troco Dinheiro' AS VARCHAR(50)) AS FormaLiquidacao, -- Informar uma das opes: 'Liquidao Carto CRE', 'Liquidao Cheque CRE', 'Liquidao Duplicata', 'Liquidao Operao Caixa', 'Liquidao Convnio CRE', 'Liquidao Adiant. Cliente', 'Troco Dinheiro', 'Liquidao Operao Bancaria'
               CAST('0' AS VARCHAR(1)) AS TPPADCONTA, -- Tipo padro de conta tesouraria. Informar uma das opes. 0 - Conta Caixa, 1 - Conta Bancria, 2 - Conta Convnio  Receber, 3 - Conta Convnio  Pagar, 4 - Conta Carto  Pagar, 5 - Conta Carto  Receber, 6 - Conta Aplicao Financeira
               CAST(TRIM(CTA.CODEXT) AS VARCHAR(20)) AS CodContaTes, -- Cdigo da Conta Tesouraria para onde vai a liquidao
               CAST(0 AS Numeric(15,2)) AS ValorFormaLiqOri, -- Valor da Forma de Liquidao Original
               CAST(ABS(COALESCE(TRC.VLROPE,0)) AS Numeric(15,2)) AS ValorFormaLiq, -- Valor da Forma de Liquidao
               CAST('Troco Dinheiro' AS VARCHAR(150)) AS Historico, -- Histrico da Liquidao
               -- Carto
               CAST(NULL AS Timestamp) AS DataVctoCartao, -- Primeira Data de Vencimento do Carto (Operao Carto)
               CAST(NULL AS Numeric(15,2)) AS TaxaCartao, -- Taxa do carto (Operao Carto)
               CAST(NULL AS Numeric(15,2)) AS TaxaCartaoParcelas, -- Taxa do carto (Operao Carto)
               CAST(NULL AS VARCHAR(1)) AS TipoCartao, -- {1 - Crdito / 2 - Dbito} (Operao Carto)
               CAST(NULL AS VARCHAR(1)) AS GerenciadorTEF, -- {0 - Nenhum / 1 - TEF Disc / 2 - TEF Dial / 3 - Hiper TEF} (Operao Carto)
               CAST(NULL AS VARCHAR(1)) AS TipoParcelamento, -- {0 -  Vista / 1 - Parc. Administradora / 2 - Parc. Lojista} (Operao Carto)
               CAST(NULL AS Numeric(8)) AS NumeroParcelas, -- Nmero de Parcelas - Esse nmero deve ser igual ao nmero de parcelas do documento (Operao Carto)
               CAST(NULL AS VARCHAR(20)) AS NSU, -- Nmero Transao (Operao Carto)
               CAST(NULL AS VARCHAR(20)) AS CodAutTransacao, -- Cdigo de Autorizao da Transao (Operao Carto)
               CAST(NULL AS VARCHAR(20)) AS NumeroRVRO, -- Nmero do Resumo de Vendas ou de Operao (Operao Carto)
               -- Operao
               CAST(TRUNC(TRC.DATHOR) AS Timestamp) AS DataEntradaCaixa, -- Data Entrada (Operao Caixa)
               -- Cheque
               CAST(NULL AS Numeric(9)) AS CodigoBanco, -- Cdigo do Banco (Operao Cheque)
               CAST(NULL AS VARCHAR(10)) AS CODAGENCIA, -- Cdigo da Agncia (Operao Cheque)
               CAST(NULL AS VARCHAR(10)) AS CODCONTABAN, -- Cdigo da Conta Bancria (Operao Cheque)
               CAST(NULL AS Numeric(9)) AS NumeroCheque, -- Nmero Cheque (Operao Cheque)
               CAST(NULL AS Numeric(9)) AS Tipificacao, -- Tipificao (Operao Cheque)
               CAST(NULL AS Timestamp) AS DataVctoCheque, -- Data de Vencimento (Operao Cheque)
               CAST(NULL AS VARCHAR(1)) AS ChequeTerceiro, --  Cheque Terceiro? (Operao Cheque) {F=False, T=True} Enviar como F por padro
               CAST(NULL AS VARCHAR(18)) AS CPFCNPJCheque, -- CPF ou CNPJ da Identificao Cliente (Operao Cheque)
               -- Crdiario/Boleto
               CAST(NULL AS Timestamp) AS DataVctoDuplicata, -- Data de Vencimento (Operao Duplicata)
               -- Definido juntamente com a EME4 que deve ser enviado apenas numero sem zero a esquerda, ser enviado apenas o n da parcela pois no enviaremos as sub-parcelas nesse ponto ser enviado como Operao de Liquidao 
               CAST(NULL AS Numeric(9)) AS Parcela, -- N Parcela (Operao Duplicata)
               CAST(NULL AS Numeric(15,5)) AS MoraAtrasoDuplic, -- Taxa Mora Atraso (Operao Duplicata)
               CAST(NULL AS Numeric(15,5)) AS MoraAntecipDuplic, -- Taxa Mora Antecipao (Operao Duplicata)
               CAST(NULL AS Numeric(9)) AS DiasJurosAtrasoDuplic, -- Dias Cobrar Juros Atraso (Operao Duplicata)
               CAST(NULL AS Numeric(9)) AS DiasJurosAntecDuplic, -- Dias Cobrar Juros Antecipao (Operao Duplicata)
               -- Convnio
               CAST(NULL AS Numeric(9)) AS CodigoCliConv, -- Cdigo do Cliente Conveniado
               CAST(NULL AS VARCHAR(18)) AS CPFCNPJCliConv, -- CPF ou CNPJ do Cliente Conveniado
               CAST(NULL AS VARCHAR(18)) AS CPFCNPJConvenio, -- CPF ou CNPJ do Convnio
               CAST(NULL AS Numeric(8)) AS NumeroParcelasConv, -- Nmero de Parcelas (Operao Convnio)
               -- Definido juntamente com a EME4 que devemos enviar NULL para o campo
               CAST(NULL AS VARCHAR(25)) AS NroDoctoAdtoADC, -- Nmero do Documento de Origem do Adiantamento
               CAST(NULL AS VARCHAR(14)) AS CPFCNPJCliCC -- CPF ou CNPJ do Cliente do Vale Compra
          FROM TT_VEN VEN 
          JOIN ( SELECT VLID_OPE.MEIO_PAGAMENTO, VLID_OPE.DATHOR, VLID_OPE.VLROPE, VLID_OPE.TIPOPE, VLID_OPE.VEN_CODFIL, VLID_OPE.VEN_SEQUEN, VLID_OPE.VEN_NUMECF, VLID_OPE.VEN_CODSER, VLID_OPE.VEN_NUMNOT, VLID_OPE.VEN_CNT_RO
                        FROM TV_LID_OPE VLID_OPE 
                       WHERE VLID_OPE.MEIO_PAGAMENTO = 'Dinheiro' AND VLID_OPE.TIPOPE = 'VEN' AND VLID_OPE.VLROPE < 0
                      ) TRC ON TRC.VEN_CODFIL = VEN.CODFIL AND TRC.VEN_SEQUEN = VEN.SEQUEN
          -- Srie de Emisso
          JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
          -- Natureza
          JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
          -- Terminal ECF
          JOIN TD_ECF DECF ON DECF.FILECF = VEN.CODFIL AND DECF.NUMECF = VEN.NUMECF
          -- Portador
          JOIN TD_COB DCOB ON DCOB.CODTAB = DECF.PORECF
          -- Conta Financeira
          JOIN TT_CTA CTA ON CTA.CODFIL = DCOB.FILCTA AND CTA.SEQUEN = DCOB.SEQCTA AND CTA.TIPCTA  = DCOB.TIPCTA
         WHERE VEN.NUMNOT NOT LIKE '%#%'
           AND VEN.DATHOR >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',VEN.CODFIL,'','','')
           -- Operao de Devoluo no precisa ser enviado a Parte da Liquidao para o EME4
           AND VEN.VLRNOT > 0
           AND (
                  -- Quando Cupom Fiscal
                  (VEN.CODSER = 'CF') OR
                  -- Quando a nota manual no for null (status  NM)
                  (VEN.NOTMAN IS NOT NULL) OR
                  -- Quando no for Documento Eletrnico
                  (VEN.MODNOT NOT IN ('55','65','59','SE')) OR
                  -- Quando Documento Eletrnico
                  (
                     (VEN.MODNOT IN ('55','65','59','SE')) AND 
                     (
                        -- Quando Cancelado exporta quando situao for Cancelada
                        ((VEN.FLGEST = 'C') AND (VEN.FLGNFE IN ('3'))) OR
                        -- Quando Aberto/Quitado exporta quando situao for Autorizado
                        ((VEN.FLGEST <> 'C') AND (VEN.FLGNFE IN ('1'))) OR
                        -- Nota Estornada fica cancelada no banco mas autorizada na Sefaz
                        ((VEN.FLGEST = 'C') AND (VEN.FLGNFE = '1'))
                     )
                  )
               )
           AND VEN.EXPEM4 = 'F'
        UNION ALL
        -- Caso esteja Cancelado e FLGNFE IN (6) Denegado deve criar um recebimento vazio para impedir erros de integrao.
        SELECT
               VEN.CODFIL, VEN.SEQUEN, CAST(' 1' AS CHAR(2)) AS NUMPAR,CAST(' 0' AS CHAR(2)) AS SUBPAR, CAST('REC' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_LIQUIDACAODOCTO' AS VARCHAR(50)) AS DESTINO, COALESCE(VEN.DATINC, VEN.DATHOR) AS DATINC, VEN.ATU_EM, CAST('F' AS VARCHAR(1)) AS EXPORT, VEN.EXPEM4,
               CAST('VEN' || VEN.CODFIL || VEN.SEQUEN AS VARCHAR(50)) AS CHAVE,
               COALESCE(VEN.DATINC, VEN.DATHOR) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               -- Definido juntamente com a EME4 quando for cupom fiscal enviar tipo de operao fixo
               CAST(CASE WHEN (VEN.CODSER = 'CF') THEN 998
                         WHEN (VEN.MODNOT = '65') THEN 997
                         WHEN (VEN.MODNOT = '59') THEN 996
                         WHEN (VEN.UFLOJA = 'T') THEN                                                       TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTDEM, '[^0-9]', '', 'gi'), ''))                         ELSE                               TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTFOR, '[^0-9]', '', 'gi'), ''))                    END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST(TO_NUMBER(VEN.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(NULL AS Numeric(3)) AS FilialAdtoADC, -- Cdigo da Filial do Adiantamento de Cliente
               CAST(NULL AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(NULL AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(NULL AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST(TRIM(CASE WHEN VEN.CODSER='CF' THEN VEN.CODSER
                              WHEN VEN.CODSER='NM' THEN CAST(CONCAT('N',VEN.NUMECF) AS VARCHAR(5))
                              WHEN ( (VEN.MODNOT = '65' OR VEN.MODNOT = '59') AND VEN.NUMECF >= '400' ) THEN VEN.NUMECF
                              WHEN VEN.CODSER<>'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN DSER.SEREXT
                              ELSE NULL
                         END) AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(TO_CHAR(TO_NUMBER(TRIM(CASE WHEN VEN.CODSER = 'CF' THEN VEN.SEQUEN 
                                                WHEN VEN.CODSER = 'ST' THEN COALESCE(TO_CHAR(VEN.SATCFE), VEN.NUMNOT)
                                                ELSE VEN.NUMNOT END))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST('Liquidao Operao Caixa' AS VARCHAR(50)) AS FormaLiquidacao, -- Informar uma das opes: 'Liquidao Carto CRE', 'Liquidao Cheque CRE', 'Liquidao Duplicata', 'Liquidao Operao Caixa', 'Liquidao Convnio CRE', 'Liquidao Adiant. Cliente', 'Troco Dinheiro', 'Liquidao Operao Bancaria'
               CAST('0' AS VARCHAR(1)) AS TPPADCONTA, -- Tipo padro de conta tesouraria. Informar uma das opes. 0 - Conta Caixa, 1 - Conta Bancria, 2 - Conta Convnio  Receber, 3 - Conta Convnio  Pagar, 4 - Conta Carto  Pagar, 5 - Conta Carto  Receber, 6 - Conta Aplicao Financeira
               CAST(TRIM(CTA.CODEXT) AS VARCHAR(20)) AS CodContaTes, -- Cdigo da Conta Tesouraria para onde vai a liquidao
               CAST(0 AS Numeric(15,2)) AS ValorFormaLiqOri, -- Valor da Forma de Liquidao Original
               --Nota denegada no tem valor, porm o EME4 exige esse informao, por esse motivo o select abaixo					
               CAST((SELECT COALESCE(SUM(ABS(IVE.VLRMOV + COALESCE(IVE.DESRAT,0))),0)
                       FROM TT_IVE IVE 
                      WHERE IVE.CODFIL = VEN.CODFIL
                        AND IVE.SEQUEN = VEN.SEQUEN ) AS Numeric(15,2)) AS ValorFormaLiq, -- Valor da Forma de Liquidao
               CAST('Liquidao Operao Caixa' AS VARCHAR(150)) AS Historico, -- Histrico da Liquidao
               -- Carto
               CAST(NULL AS Timestamp) AS DataVctoCartao, -- Primeira Data de Vencimento do Carto (Operao Carto)
               CAST(NULL AS Numeric(15,2)) AS TaxaCartao, -- Taxa do carto (Operao Carto)
               CAST(NULL AS Numeric(15,2)) AS TaxaCartaoParcelas, -- Taxa do carto (Operao Carto)
               CAST(NULL AS VARCHAR(1)) AS TipoCartao, -- {1 - Crdito / 2 - Dbito} (Operao Carto)
               CAST(NULL AS VARCHAR(1)) AS GerenciadorTEF, -- {0 - Nenhum / 1 - TEF Disc / 2 - TEF Dial / 3 - Hiper TEF} (Operao Carto)
               CAST(NULL AS VARCHAR(1)) AS TipoParcelamento, -- {0 -  Vista / 1 - Parc. Administradora / 2 - Parc. Lojista} (Operao Carto)
               CAST(NULL AS Numeric(8)) AS NumeroParcelas, -- Nmero de Parcelas - Esse nmero deve ser igual ao nmero de parcelas do documento (Operao Carto)
               CAST(NULL AS VARCHAR(20)) AS NSU, -- Nmero Transao (Operao Carto)
               CAST(NULL AS VARCHAR(20)) AS CodAutTransacao, -- Cdigo de Autorizao da Transao (Operao Carto)
               CAST(NULL AS VARCHAR(20)) AS NumeroRVRO, -- Nmero do Resumo de Vendas ou de Operao (Operao Carto)
               -- Operao
               CAST(NULL AS Timestamp) AS DataEntradaCaixa, -- Data Entrada (Operao Caixa)
               -- Cheque
               CAST(NULL AS Numeric(9)) AS CodigoBanco, -- Cdigo do Banco (Operao Cheque)
               CAST(NULL AS VARCHAR(10)) AS CODAGENCIA, -- Cdigo da Agncia (Operao Cheque)
               CAST(NULL AS VARCHAR(10)) AS CODCONTABAN, -- Cdigo da Conta Bancria (Operao Cheque)
               CAST(NULL AS Numeric(9)) AS NumeroCheque, -- Nmero Cheque (Operao Cheque)
               CAST(NULL AS Numeric(9)) AS Tipificacao, -- Tipificao (Operao Cheque)
               CAST(NULL AS Timestamp) AS DataVctoCheque, -- Data de Vencimento (Operao Cheque)
               CAST(NULL AS VARCHAR(1)) AS ChequeTerceiro, --  Cheque Terceiro? (Operao Cheque) {F=False, T=True} Enviar como F por padro
               CAST(NULL AS VARCHAR(18)) AS CPFCNPJCheque, -- CPF ou CNPJ da Identificao Cliente (Operao Cheque)
               -- Crdiario/Boleto
               CAST(NULL AS Timestamp) AS DataVctoDuplicata, -- Data de Vencimento (Operao Duplicata)
               -- Definido juntamente com a EME4 que deve ser enviado apenas numero sem zero a esquerda, ser enviado apenas o n da parcela pois no enviaremos as sub-parcelas nesse ponto ser enviado como Operao de Liquidao 
               CAST(NULL AS Numeric(9)) AS Parcela, -- N Parcela (Operao Duplicata)
               CAST(NULL AS Numeric(15,5)) AS MoraAtrasoDuplic, -- Taxa Mora Atraso (Operao Duplicata)
               CAST(NULL AS Numeric(15,5)) AS MoraAntecipDuplic, -- Taxa Mora Antecipao (Operao Duplicata)
               CAST(NULL AS Numeric(9)) AS DiasJurosAtrasoDuplic, -- Dias Cobrar Juros Atraso (Operao Duplicata)
               CAST(NULL AS Numeric(9)) AS DiasJurosAntecDuplic, -- Dias Cobrar Juros Antecipao (Operao Duplicata)
               -- Convnio
               CAST(NULL AS Numeric(9)) AS CodigoCliConv, -- Cdigo do Cliente Conveniado
               CAST(NULL AS VARCHAR(18)) AS CPFCNPJCliConv, -- CPF ou CNPJ do Cliente Conveniado
               CAST(NULL AS VARCHAR(18)) AS CPFCNPJConvenio, -- CPF ou CNPJ do Convnio
               CAST(NULL AS Numeric(8)) AS NumeroParcelasConv, -- Nmero de Parcelas (Operao Convnio)
               -- Definido juntamente com a EME4 que devemos enviar NULL para o campo
               CAST(NULL AS VARCHAR(25)) AS NroDoctoAdtoADC, -- Nmero do Documento de Origem do Adiantamento
               CAST(NULL AS VARCHAR(14)) AS CPFCNPJCliCC -- CPF ou CNPJ do Cliente do Vale Compra
          FROM TT_VEN VEN 
          -- Srie de Emisso
          JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
          -- Natureza
          JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
          -- Terminal ECF
          JOIN TD_ECF DECF ON DECF.FILECF = VEN.CODFIL AND DECF.NUMECF = VEN.NUMECF
          -- Portador
          JOIN TD_COB DCOB ON DCOB.CODTAB = DECF.PORECF
          -- Conta Financeira
          JOIN TT_CTA CTA ON CTA.CODFIL = DCOB.FILCTA AND CTA.SEQUEN = DCOB.SEQCTA AND CTA.TIPCTA  = DCOB.TIPCTA			 
          WHERE VEN.NUMNOT NOT LIKE '%#%'
           AND VEN.DATHOR >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',VEN.CODFIL,'','','')
           AND VEN.FINANC = 'T'
           AND (
                  -- Quando Documento Eletrnico
                  (
                     (VEN.MODNOT IN ('55','65')) AND 
                     (
                        -- Quando Cancelado exporta quando situao for Inutilizada ou Denegada
                        (VEN.FLGEST = 'C') AND (VEN.FLGNFE IN ('4', '6')) 
                     )
                  )
               )
           AND VEN.EXPEM4 = 'F'
      ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Liquidaes do Documento" (Tabela Integrao Mult)
-- Arquivo Pai: TIMU_LIQUIDACAODOCTO
/*-- SEQ 2676 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_LIQUIDACAODOCTOPAGREC CASCADE;

/*-- SEQ 2677 --*/
CREATE OR REPLACE VIEW TV_TIMU_LIQUIDACAODOCTOPAGREC AS
   SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.NUMPAR, TAB.SUBPAR, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.FilialAdtoADC, -- Cdigo da Filial do Adiantamento de Cliente
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.FormaLiquidacao, -- Informar uma das opes: 'Liquidao Carto CRE', 'Liquidao Cheque CRE', 'Liquidao Duplicata', 'Liquidao Operao Caixa', 'Liquidao Convnio CRE', 'Liquidao Adiant. Cliente', 'Troco Dinheiro', 'Liquidao Operao Bancaria'
      TAB.TPPADCONTA, -- Tipo padro de conta tesouraria. Informar uma das opes. 0 - Conta Caixa, 1 - Conta Bancria, 2 - Conta Convnio  Receber, 3 - Conta Convnio  Pagar, 4 - Conta Carto  Pagar, 5 - Conta Carto  Receber, 6 - Conta Aplicao Financeira
      TAB.CodContaTes, -- Cdigo da Conta Tesouraria para onde vai a liquidao
      TAB.ValorFormaLiqOri, -- Valor da Forma de Liquidao Original
      TAB.ValorFormaLiq, -- Valor da Forma de Liquidao
      TAB.Historico, -- Histrico da Liquidao
      TAB.DataVctoCartao, -- Primeira Data de Vencimento do Carto (Operao Carto)
      TAB.TaxaCartao, -- Taxa do carto (Operao Carto)
      TAB.TipoCartao, -- {1 - Crdito / 2 - Dbito} (Operao Carto)
      TAB.GerenciadorTEF, -- {0 - Nenhum / 1 - TEF Disc / 2 - TEF Dial / 3 - Hiper TEF} (Operao Carto)
      TAB.TipoParcelamento, -- {0 -  Vista / 1 - Parc. Administradora / 2 - Parc. Lojista} (Operao Carto)
      TAB.NumeroParcelas, -- Nmero de Parcelas - Esse nmero deve ser igual ao nmero de parcelas do documento (Operao Carto)
      TAB.NSU, -- Nmero Transao (Operao Carto)
      TAB.CodAutTransacao, -- Cdigo de Autorizao da Transao (Operao Carto)
      TAB.NumeroRVRO, -- Nmero do Resumo de Vendas ou de Operao (Operao Carto)
      TAB.DataEntradaCaixa, -- Data Entrada (Operao Caixa)
      TAB.CodigoBanco, -- Cdigo do Banco (Operao Cheque)
      TAB.CODAGENCIA, -- Cdigo da Agncia (Operao Cheque)
      TAB.CODCONTABAN, -- Cdigo da Conta Bancria (Operao Cheque)
      TAB.NumeroCheque, -- Nmero Cheque (Operao Cheque)
      TAB.Tipificacao, -- Tipificao (Operao Cheque)
      TAB.DataVctoCheque, -- Data de Vencimento (Operao Cheque)
      TAB.ChequeTerceiro, --  Cheque Terceiro? (Operao Cheque) {F=False, T=True} Enviar como F por padro
      TAB.CPFCNPJCheque, -- CPF ou CNPJ da Identificao Cliente (Operao Cheque)
      TAB.DataVctoDuplicata, -- Data de Vencimento (Operao Duplicata)
      TAB.Parcela, -- N Parcela (Operao Duplicata)
      TAB.MoraAtrasoDuplic, -- Taxa Mora Atraso (Operao Duplicata)
      TAB.MoraAntecipDuplic, -- Taxa Mora Antecipao (Operao Duplicata)
      TAB.DiasJurosAtrasoDuplic, -- Dias Cobrar Juros Atraso (Operao Duplicata)
      TAB.DiasJurosAntecDuplic, -- Dias Cobrar Juros Antecipao (Operao Duplicata)
      TAB.CodigoCliConv, -- Cdigo do Cliente Conveniado
      TAB.CPFCNPJCliConv, -- CPF ou CNPJ do Cliente Conveniado
      TAB.CPFCNPJConvenio, -- CPF ou CNPJ do Convnio
      TAB.NumeroParcelasConv, -- Nmero de Parcelas (Operao Convnio)
      TAB.NroDoctoAdtoADC -- Nmero do Documento de Origem do Adiantamento
     FROM (
         -- Pagamentos de Notas de Recebidas
         SELECT
               COM.CODFIL, COM.SEQUEN, PAG.NUMPAR, PAG.SUBPAR, CAST('PAG' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_LIQUIDACAODOCTO' AS VARCHAR(50)) AS DESTINO, COALESCE(COM.DATINC, COM.DATOPE) AS DATINC, COM.ATU_EM, CAST('F' AS VARCHAR(1)) AS EXPORT, COM.EXPEM4,
               CAST('COM' || COM.CODFIL || COM.SEQUEN AS VARCHAR(50)) AS CHAVE,
               COALESCE(COM.DATINC, COM.DATOPE) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               CAST(TO_NUMBER(                              NULLIF(regexp_replace(DCFO.EXTCFO, '[^0-9]', '', 'gi'), '')) AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST(TO_NUMBER(COM.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(NULL AS Numeric(3)) AS FilialAdtoADC, -- Cdigo da Filial do Adiantamento de Cliente
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = COM.FILFOR AND REL.CODPAR = COM.CODFOR AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                         ELSE 'C' 
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('2' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST(CASE WHEN ISNOTNULL(FIS.SEREXP)='T' THEN LPAD(TRIM(FIS.SEREXP), 3, '0')||CASE WHEN COM.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(FIS.SUBEXP),'0'), 2, '0') END
                         ELSE LPAD(TRIM(COM.CODSER), 2, '0')||CASE WHEN COM.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(COM.SUBSER),'0'), 3, '0') END
                    END AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(TO_CHAR(TO_NUMBER(TRIM(COM.NUMNOT))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST('Liquidao Operao Caixa' AS VARCHAR(50)) AS FormaLiquidacao, -- Informar uma das opes: 'Liquidao Carto CRE', 'Liquidao Cheque CRE', 'Liquidao Duplicata', 'Liquidao Operao Caixa', 'Liquidao Convnio CRE', 'Liquidao Adiant. Cliente', 'Troco Dinheiro', 'Liquidao Operao Bancaria'
               CAST('0' AS VARCHAR(1)) AS TpPadConta, -- Tipo padro de conta tesouraria. Informar uma das opes. 0 - Conta Caixa, 1 - Conta Bancria, 2 - Conta Convnio  Receber, 3 - Conta Convnio  Pagar, 4 - Conta Carto  Pagar, 5 - Conta Carto  Receber, 6 - Conta Aplicao Financeira
               CAST(TRIM(CTAPAG.CODEXT) AS VARCHAR(20)) AS CodContaTes, -- Cdigo da Conta Tesouraria para onde vai a liquidao
               CAST(ABS(PAG.VLRPAR) AS Numeric(15,2)) AS ValorFormaLiqOri, -- Valor da Forma de Liquidao Original
               CAST(ABS(PAG.VLRPAR) AS Numeric(15,2)) AS ValorFormaLiq, -- Valor da Forma de Liquidao
               CAST('Liquidao Operao Caixa' AS VARCHAR(150)) AS Historico, -- Histrico da Liquidao
               -- Carto
               CAST(NULL AS Timestamp) AS DataVctoCartao, -- Primeira Data de Vencimento do Carto (Operao Carto)
               CAST(NULL AS Numeric(15,2)) AS TaxaCartao, -- Taxa do carto (Operao Carto)
               CAST(NULL AS VARCHAR(1)) AS TipoCartao, -- {1 - Crdito / 2 - Dbito} (Operao Carto)
               CAST(NULL AS VARCHAR(1)) AS GerenciadorTEF, -- {0 - Nenhum / 1 - TEF Disc / 2 - TEF Dial / 3 - Hiper TEF} (Operao Carto)
               CAST(NULL AS VARCHAR(1)) AS TipoParcelamento, -- {0 -  Vista / 1 - Parc. Administradora / 2 - Parc. Lojista} (Operao Carto)
               CAST(NULL AS Numeric(8)) AS NumeroParcelas, -- Nmero de Parcelas - Esse nmero deve ser igual ao nmero de parcelas do documento (Operao Carto)
               CAST(NULL AS VARCHAR(20)) AS NSU, -- Nmero Transao (Operao Carto)
               CAST(NULL AS VARCHAR(20)) AS CodAutTransacao, -- Cdigo de Autorizao da Transao (Operao Carto)
               CAST(NULL AS VARCHAR(20)) AS NumeroRVRO, -- Nmero do Resumo de Vendas ou de Operao (Operao Carto)
               -- Operao
               CAST(TRUNC(PAG.DATPGT) AS Timestamp) AS DataEntradaCaixa, -- Data Entrada (Operao Caixa)
               -- Cheque
               CAST(NULL AS Numeric(9)) AS CodigoBanco, -- Cdigo do Banco (Operao Cheque)
               CAST(NULL AS VARCHAR(10)) AS CODAGENCIA, -- Cdigo da Agncia (Operao Cheque)
               CAST(NULL AS VARCHAR(10)) AS CODCONTABAN, -- Cdigo da Conta Bancria (Operao Cheque)
               CAST(NULL AS Numeric(9)) AS NumeroCheque, -- Nmero Cheque (Operao Cheque)
               CAST(NULL AS Numeric(9)) AS Tipificacao, -- Tipificao (Operao Cheque)
               CAST(NULL AS Timestamp) AS DataVctoCheque, -- Data de Vencimento (Operao Cheque)
               CAST(NULL AS VARCHAR(1)) AS ChequeTerceiro, --  Cheque Terceiro? (Operao Cheque) {F=False, T=True} Enviar como F por padro
               CAST(NULL AS VARCHAR(18)) AS CPFCNPJCheque, -- CPF ou CNPJ da Identificao Cliente (Operao Cheque)
               -- Crdiario/Boleto
               CAST(NULL AS Timestamp) AS DataVctoDuplicata, -- Data de Vencimento (Operao Duplicata)
               CAST(NULL AS Numeric(9)) AS Parcela, -- N Parcela (Operao Duplicata)
               CAST(NULL AS Numeric(15,5)) AS MoraAtrasoDuplic, -- Taxa Mora Atraso (Operao Duplicata)
               CAST(NULL AS Numeric(15,5)) AS MoraAntecipDuplic, -- Taxa Mora Antecipao (Operao Duplicata)
               CAST(NULL AS Numeric(9)) AS DiasJurosAtrasoDuplic, -- Dias Cobrar Juros Atraso (Operao Duplicata)
               CAST(NULL AS Numeric(9)) AS DiasJurosAntecDuplic, -- Dias Cobrar Juros Antecipao (Operao Duplicata)
               -- Convnio
               CAST(NULL AS Numeric(9)) AS CodigoCliConv, -- Cdigo do Cliente Conveniado
               CAST(NULL AS VARCHAR(18)) AS CPFCNPJCliConv, -- CPF ou CNPJ do Cliente Conveniado
               CAST(NULL AS VARCHAR(18)) AS CPFCNPJConvenio, -- CPF ou CNPJ do Convnio
               CAST(NULL AS Numeric(8)) AS NumeroParcelasConv, -- Nmero de Parcelas (Operao Convnio)
               CAST(NULL AS VARCHAR(25)) AS NroDoctoAdtoADC -- Nmero do Documento de Origem do Adiantamento
          FROM TT_PAG PAG
          JOIN TT_COM COM ON COM.CODFIL = PAG.CODFIL AND COM.SEQUEN = PAG.SEQUEN
          -- Srie de Emisso
          LEFT JOIN (SELECT DISTINCT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT, ORIGEM
                       FROM TT_FIS
                      WHERE ORIGEM IN ('C','F')) FIS ON FIS.CODSER = COM.CODSER AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$') AND FIS.ORIGEM = CASE WHEN COALESCE(COM.TIPPAR,'F') = 'T' THEN 'F' ELSE 'C' END
          -- Natureza
          LEFT JOIN TD_CFO DCFO ON DCFO.CODTAB = COM.CODCFO
          -- Fornecedor
          JOIN TT_CLI PAR ON PAR.FILCLI = COM.FILFOR AND PAR.CODCLI = COM.CODFOR
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.FILEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = COM.FILFOR AND ENDFAT.CODCLI = COM.CODFOR AND ENDFAT.CODFIL = COM.FILEND AND ENDFAT.NUMEND = COM.NUMEND
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          -- Pagamento
          LEFT JOIN TT_DOP DOP ON DOP.CODFIL = PAG.FILDOP AND DOP.SEQUEN = PAG.SEQDOP
          LEFT JOIN TT_CTA CTAPAG ON CTAPAG.CODFIL = DOP.FILCTA AND CTAPAG.SEQUEN = DOP.SEQCTA AND CTAPAG.TIPCTA = DOP.TIPCTA
         WHERE PAG.SUBPAR = ' 0' -- Trata apenas Sub-Parcela 0 pois todo controle de gerao de Pagamento Parcial deve ser controlado pela TIMU_ParteDoctoOpera
           AND COM.FLGEST <> 'D'
           AND COM.NUMNOT NOT LIKE '%#%'
           AND COM.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',COM.CODFIL,'','','')
           AND COM.EXPEM4 = 'F'
      ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Movimento Contabilidade Reduo Z" (Tabela Integrao Mult)
/*-- SEQ 2678 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_MOVIMENTOCTBRDZ CASCADE;

/*-- SEQ 2679 --*/
CREATE OR REPLACE VIEW TV_TIMU_MOVIMENTOCTBRDZ AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.NUMECF, TAB.CNT_RZ, TAB.CNT_RO, TAB.DATOPE, TAB.DATFEC, TAB.ATU_EM, TAB.DATINC, TAB.ORIGEM, TAB.DESTINO, TAB.CHAVE,
      TAB.EXPEM4, TAB.EXPORT,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.Filial, -- Cdigo da Filial
      TAB.NumeroECF, -- Nmero do ECF
      TAB.NumeroSerieECF, -- Nmero de Srie ECF
      TAB.ModeloECF, -- Modelo do ECF
      TAB.DataMovimentacao, -- Data da Movimentao
      TAB.COOReducao, -- COO da Reduo Z
      TAB.ContaContabil, -- Cdigo da Conta Contbil
      TAB.ValorLanctoContabil, -- Valor do Lanamento Contbil
      TAB.Natureza, -- Natureza {0=Crdito;1=Dbito}
      TAB.Historico -- Histrico do Movimento Contbil
  FROM (SELECT RECF.CODFIL, RECF.NUMECF, RECF.CNT_RZ, RECF.CNT_RO, RECF.DATOPE, RECF.DATFEC, RECF.ATU_EM, RECF.DATINC, CAST('RCT' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_MOVIMENTOCTBRDZ' AS VARCHAR(50)) AS DESTINO, 
               CAST('RED' || RECF.CODFIL || RECF.NUMECF || TO_CHAR(RECF.CNT_RZ) || TO_CHAR(RECF.CNT_RO) AS VARCHAR(50)) AS CHAVE,
               RECF.EXPEM4, RECF.EXPORT,
               CAST(RECF.DATINC AS Timestamp) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
               CAST(TO_NUMBER(RECF.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(TO_NUMBER(DECF.CODORI) AS Numeric(9)) AS NumeroECF, -- Nmero do ECF
               CAST(TRIM(DECF.SERECF) AS VARCHAR(20)) AS NumeroSerieECF, -- Nmero de Srie ECF
               CAST(TRIM(DECF.MODECF) AS VARCHAR(20)) AS ModeloECF, -- Modelo do ECF
               CAST(TRUNC(RECF.DATFEC) AS Timestamp) AS DataReducao, -- Data da Reduo
               CAST(TRUNC(RECF.DATOPE) AS Timestamp) AS DataMovimentacao, -- Data da Movimentao
               CAST(RECF.CUPFIM AS Numeric(9)) AS COOReducao, -- COO da Reduo Z
               /* No possuimos dados gravados para possibilitar a exportao */ 
               CAST(NULL AS VARCHAR(20)) AS ContaContabil, -- Cdigo da Conta Contbil
               CAST(NULL AS Numeric(15,2)) AS ValorLanctoContabil, -- Valor do Lanamento Contbil
               CAST(NULL AS VARCHAR(1)) AS Natureza, -- Natureza {0=Crdito;1=Dbito}
               CAST(NULL AS VARCHAR(300)) AS Historico -- Histrico do Movimento Contbil
          FROM TR_ECF RECF
          JOIN TD_ECF DECF ON DECF.FILECF = RECF.CODFIL AND DECF.NUMECF = RECF.NUMECF
          WHERE RECF.DATFEC IS NOT NULL 
            AND RECF.DIAFEC IN ('F', 'S')
            AND ((RECF.EXPEM4 = 'F') OR (RECF.EXPORT = 'F'))
            AND RECF.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',RECF.CODFIL,'','','')
    ) TAB
;


-- Autor: Bruno B.
-- Cliente(s): EME4
-- Finalidade(s):
-- 1)Retornar as notas de sada.
-- Arquivo Pai: TIMU_DOCUMENTO
/*-- SEQ 2680 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_NOTAS_EMITIDAS CASCADE;

/*-- SEQ 2681 --*/
CREATE OR REPLACE VIEW TV_TIMU_NOTAS_EMITIDAS AS
   SELECT
         --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
         CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
         CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
         CAST('T' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
         --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
         CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
         --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
         TAB.CODFIL, TAB.SEQUEN, TAB.CNPJFilial, TAB.NUMPAR, TAB.SUBPAR, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.NUMDOC, TAB.DATAFILTRO,
         TAB.CODSER, TAB.SUBSER, TAB.NUMECF, TAB.NUMNOT, TAB.NUMPED, TAB.TIPPED,
         TAB.TEM_ITEM, TAB.TEM_PARCELA, TAB.TEM_LIQUIDACAO, TAB.TEM_MOVCONTABIL, TAB.TEM_CCUSTOCONTABIL, TAB.TEM_FRETE, TAB.TEM_OPERACAOFINANCEIRA, TAB.TEM_CONTAFINANCEIRA, TAB.TEM_CCUSTOFINANCEIRO, TAB.CHAVE, TAB.VLRNOT_VALIDACAO, TAB.VLRLIQ_VALIDACAO, TAB.CodigoExternoCliFor,
         TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
         TAB.TipoOperacao, -- Cdigo do Tipo de Operao
         TAB.Filial, -- Cdigo da Filial
         TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
         TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
         TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
         TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
         TAB.Serie, -- Srie do Documento
         TAB.NumeroDocumento, -- Nmero do documento
         TAB.DataEntrada, -- Data de Entrada
         TAB.DataSaida, -- Data de Sada
         TAB.DataEntSai, -- Data de Entrada ou Sada
         TAB.DataEmissao, -- Data de Emisso
         TAB.ValorContabil, -- Valor Contbil Original do Documento (Tesouraria)
         TAB.ValorDescontos, -- Valor Desconto dos Produtos
         TAB.ValorOutrasDespesas, -- Valor Outras Despesas dos Produtos
         TAB.ValorDescontosServ, -- Valor Desconto dos Servios
         TAB.ValorOutrasDespesasServ, -- Valor Outras Despesas dos Servios
         TAB.SituacaoNFE, -- {3=Autorizada;5=Cancelada;7=Inutilizada;8=Substituida;9=Denegada;A=Contingncia}
         TAB.SituacaoDOC, -- {0=Normal;1=Cancelada;2=Devoluo Parcial;3=Devoluo Total;4=Crdito Bloqueado;5=Inadimplncia;6=Cred. Bloq/Inad.;7=Bloqueio nos Itens;8=Faturado;A=Bloq. Val. Parcela;B=Bloq. Val. Min. Venda}
         TAB.ObsFiscal, -- Observao Fiscal do Documento
         TAB.Observacoes, -- Observaes da Nota
         TAB.InfoComplementares, -- Informaes Complementares da Nota
         TAB.TextoFiscal, -- Texto Fiscal do Documento
         TAB.NumPedCliente, -- Nmero do Pedido no Cliente
         TAB.NumPedRepresentante, -- Nmero do Pedido no Representante
         TAB.IndNaturezaFrete, -- {0=Operaes de vendas, com nus suportado pelo estabelecimento vendedor;1=Operaes de vendas, com nus suportado pelo adquirente;2=Operaes de compras (bens para revenda, matrias prima e outros produtos, geradores de crdito);3=Operaes de compras (bens para revenda, matrias prima e outros produtos, no geradores de crdito);4=Transferncia de produtos acabados entre estabelecimentos da pessoa jurdica;5=Transferncia de produtos entre estabelecimentos da pessoa jurdica;9=Outras}
         TAB.ChaveNFE, -- Chave NFE
         TAB.ChaveNFERefer, -- Chave NFE Referenciada
         TAB.CodContaTes, -- Cdigo da Conta Tesouraria
         TAB.Justificativa, -- Justificativa do documento Contbil
         TAB.TipoFrete, -- {F=Por conta do emitente;T=Por conta do destinatrio;A=Por conta de terceiros;B=Sem frete}
         TAB.CodTransportadora, -- Cdigo da Transportadora do Documento
         TAB.CpfCnpjTransportadora, -- CPF ou CNPJ da Transportadora do Documento
         TAB.PlacaVeiculo, -- Placa do Veculo de Entrega
         TAB.CodTranspRedespacho, -- Cdigo da Transportadora de Redespacho do Documento
         TAB.CpfCnpjTranspRedespacho, -- CPF ou CNPJ da Transportadora de Redespacho do Documento
         TAB.CodigoModelo, -- Cdigo do Modelo de Documento (01 ou 65)
         TAB.LogradouroEnt, -- Logradouro do Endereo de Entrega
         TAB.NumeroEnt, -- Nmero do Endereo de Entrega
         TAB.ComplementoEnt, -- Complemento do Endereo de Entrega
         TAB.CEPEnt, -- CEP do Endereo de Entrega
         TAB.CodMunicipioIBGEEnt, -- GeoCodigo do M3 - caso esteja informado dever importar o vnculo do municpio por este cdigo (Endereo)
         TAB.CidadeEndEnt, -- Cidade do Endereo de Entrega
         TAB.BairroEnt, -- Bairro do Endereo de Entrega
         TAB.EstadoEnt, -- Estado do Endereo de Entrega
         TAB.CodigoPaisEnt, -- Codigo do Banco Central para o Pais da Cidade de Entrega
         TAB.PaisEnt, -- Nome do Pais do Endereo de Entrega
         TAB.ValorFrete, -- Valor do Frete
         TAB.ValorFreteTerceiros, -- Valor do Frete Terceiros
         TAB.ICMSFreteTerceiros, -- Valor ICMS do Frete Terceiros
         TAB.DifaFreteTerceiros, -- Valor DIFA do Frete Terceiros
         TAB.ValorSeguro, -- Valor do Seguro
         TAB.ValorAcrescimos, -- Valor Acrescimos
         TAB.ValorTHC, -- Valor THC
         TAB.ValorAFRMM, -- Valor AFRMM
         TAB.ValorDemurrage, -- Valor Demurrage
         TAB.ValorDesestiva, -- Valro Desestiva
         TAB.ValorDesembaraco, -- Valor Desembarao
         TAB.ValorSiscomex, -- Valor Siscomex
         TAB.ValorPISImport, -- Valro PIS Importao
         TAB.ValorCofinsImport, -- Valro Cofins Importao
         TAB.ValorDespAduaneira, -- Valor Despesa Aduaneira
         TAB.SimboloMoeda, -- Smbolo da Moeda
         TAB.ValorCotacaoMoeda, -- Valor Cotao Moeda
         TAB.DataCotacaoMoeda, -- Data Cotao Moeda
         TAB.CPFCNPJRepresentante, -- CPF ou CNPJ do Representante
         TAB.COO, -- COO Cupom
         TAB.NroECF, -- Nmero do ECF
         TAB.NroSerieECF, -- Nmero de rie do ECF
         TAB.ModeloECF, -- Modelo do ECF
         TAB.MarcaECF, -- Marca do ECF
         TAB.CPFCNPJCupom, -- CPF ou CNPJ do cliente no identificado no cupom
         TAB.TPDEVVENDA -- Cdigo de Devoluo 
     FROM(
   SELECT VEN.CODFIL,
          VEN.SEQUEN,
          DFIL.CGCFIL AS CNPJFilial,
          CAST(NULL AS CHAR(8)) AS NUMPED,
          CAST(NULL AS CHAR(1)) AS TIPPED,
          CAST(NULL AS CHAR(2)) AS NUMPAR,
          CAST(NULL AS CHAR(2)) AS SUBPAR,
          CAST(VEN.CODSER AS VARCHAR(3)) AS CODSER, CAST(NULL AS VARCHAR(3)) AS SUBSER, CAST(VEN.NUMECF AS CHAR(3)) AS NUMECF, CAST(VEN.NUMNOT AS VARCHAR(10)) AS NUMNOT,
          CAST('VEN' AS VARCHAR(3)) AS ORIGEM,
          CAST('TIMU_DOCUMENTO' AS VARCHAR(50)) AS DESTINO,
          CAST(VEN.LANVEN AS CHAR(1)) AS TEM_ITEM,
          CAST(CASE WHEN (PAR.CODCLI = LPAD('0', 6, ' ')) THEN 'F' ELSE VEN.FINANC END AS CHAR(1)) AS TEM_PARCELA,
          CAST(CASE WHEN (VEN.FINANC = 'T') AND (LeParametroTXT('TIPO_EXP_EME4', VEN.CODFIL, '', '', '') = 'V') AND (VEN.VLRNOT > 0) THEN 'T' ELSE 'F' END AS CHAR(1)) AS TEM_LIQUIDACAO,
          CAST(CASE WHEN (LeParametroTXT('TIPO_EXP_EME4', VEN.CODFIL, '', '', '') = 'C') AND (PAR.CODCLI <> LPAD('0', 6, ' ')) AND (VEN.FINANC = 'T') THEN 'T' ELSE 'F' END AS CHAR(1)) AS TEM_MOVCONTABIL,
          CAST('F' AS CHAR(1)) AS TEM_CCUSTOCONTABIL,
          CAST('F' AS CHAR(1)) AS TEM_FRETE,
          CAST('F' AS CHAR(1)) AS TEM_OPERACAOFINANCEIRA,
          CAST('F' AS CHAR(1)) AS TEM_CONTAFINANCEIRA,
          CAST('F' AS CHAR(1)) AS TEM_CCUSTOFINANCEIRO,
          CAST('VEN' || VEN.CODFIL || VEN.SEQUEN AS VARCHAR(50)) AS CHAVE,
          VEN.VLRNOT AS VLRNOT_VALIDACAO, (VEN.VLRLIQ + COALESCE(VEN.VLRSAD, 0)) AS VLRLIQ_VALIDACAO,
          COALESCE(VEN.DATINC, VEN.DATHOR) AS DATINC,
          VEN.ATU_EM,
          VEN.EXPORT,
          VEN.EXPEM4,
          COALESCE(VEN.DATINC, VEN.DATHOR) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
          COALESCE(PAR.NUMDOC, VIN.NUMDOC) AS NUMDOC,
          COALESCE(VEN.DATINC, VEN.DATHOR) AS DATAFILTRO,
          VEN.MODNOT,
          VEN.UFLOJA,
          DNAT.EXTFOR,
          DNAT.EXTDEM,
          CAST(TO_NUMBER(VEN.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
          -- Definido juntamente com a EME4 quando for cupom fiscal enviar tipo de operao fixo
          CAST(CASE WHEN (VEN.CODSER = 'CF') THEN 998
                    WHEN (VEN.MODNOT = '65') THEN 997
                    WHEN (VEN.MODNOT = '59') THEN 996
                    WHEN (VEN.UFLOJA = 'T') THEN TO_NUMBER(                                                           NULLIF(regexp_replace(DNAT.EXTDEM, '[^0-9]', '', 'gi'), ''))
                    ELSE TO_NUMBER(                                   NULLIF(regexp_replace(DNAT.EXTFOR, '[^0-9]', '', 'gi'), ''))
               END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
         CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                   ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                       THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                 ELSE SUBSTR(TO_CHAR(CAST(                                                                          NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                            END
                                       ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                 ELSE SUBSTR(TO_CHAR(CAST(                                                                                    NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                            END
                                  END)
              END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
          PAR.CODEXT AS CodigoExternoCliFor,
          CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
          CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = VEN.FILCLI AND REL.CODPAR = VEN.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                    ELSE 'C'
                END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
          CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
          CAST(TRIM(CASE WHEN VEN.CODSER='CF' THEN VEN.CODSER
                         WHEN VEN.CODSER='NM' THEN CAST(CONCAT('N',VEN.NUMECF) AS VARCHAR(5))
                         WHEN ( (VEN.MODNOT = '65' OR VEN.MODNOT = '59') AND VEN.NUMECF >= '400' ) THEN VEN.NUMECF
                         WHEN VEN.CODSER <> 'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN DSER.SEREXT
                         ELSE NULL
                    END) AS VARCHAR(5)) AS Serie, -- Srie do Documento
          CAST(TO_CHAR(TO_NUMBER(TRIM(CASE WHEN VEN.CODSER = 'CF' THEN VEN.SEQUEN
                                           WHEN VEN.CODSER = 'ST' THEN COALESCE(TO_CHAR(VEN.SATCFE), VEN.NUMNOT)
                                           ELSE VEN.NUMNOT END))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
          CAST(CASE WHEN VEN.VLRNOT < 0 THEN TRUNC(VEN.DATHOR)
               ELSE NULL
          END AS Timestamp) AS DataEntrada, -- Data de Entrada
          CAST(CASE WHEN VEN.VLRNOT > 0 THEN TRUNC(VEN.DATHOR)
               ELSE NULL
          END AS Timestamp) AS DataSaida, -- Data de Sada
          CAST(TRUNC(VEN.DATHOR) AS Timestamp) AS DataEntSai, -- Data de Entrada ou Sada
          CAST(TRUNC(VEN.DATHOR) AS Timestamp) AS DataEmissao, -- Data de Emisso
          CAST(ABS(VEN.VLRLIQ) AS Numeric(15,2)) AS ValorContabil, -- Valor Contbil Original do Documento (Tesouraria)
          CAST(0 AS Numeric(15,2)) AS ValorDescontos, -- Valor Desconto dos Produtos
          CAST(ABS(VEN.OUTTAX) AS Numeric(15,2)) AS ValorOutrasDespesas, -- Valor Outras Despesas dos Produtos
          CAST(NULL AS Numeric(15,2)) AS ValorDescontosServ, -- Valor Desconto dos Servios
          CAST(NULL AS Numeric(15,2)) AS ValorOutrasDespesasServ, -- Valor Outras Despesas dos Servios
          CAST(CASE WHEN VEN.CODSER IN ('CF', 'NM') THEN NULL -- Cupom Fiscal no tem Situao no Sefaz
                    ELSE CASE WHEN VEN.FLGNFE = '1' THEN '3'                         -- 1 - Autorizada
                              WHEN VEN.FLGNFE = '2' THEN NULL                        -- 2 - Rejeitada
                              WHEN VEN.FLGNFE = '3' THEN '5'                         -- 3 - Cancelado
                              WHEN VEN.FLGNFE = '4' THEN '7'                         -- 4 - Inutilizado
                              WHEN VEN.FLGNFE = '5' THEN NULL                        -- 5 - Enviada ao Sefaz
                              WHEN VEN.FLGNFE = '6' THEN '9'                         -- 6 - Denegado
                              WHEN VEN.FLGNFE = '8' THEN NULL                        -- 8 - Erro de Importao
                              WHEN VEN.FLGNFE = '0' AND VEN.FLGEST <> 'C' THEN 'A'   -- 0 - No enviado
                              ELSE NULL -- Situao do Sefaz inexistente
                         END
               END AS VARCHAR(1)) AS SituacaoNFE, -- {3=Autorizada;5=Cancelada;7=Inutilizada;8=Substituida;9=Denegada;A=Contingncia}
          CAST(CASE WHEN (VEN.FLGEST = 'C') AND (VEN.FILEST IS NULL) THEN '1'
                    --WHEN (SELECT COALESCE(SUM(ABS(I.QTDMOV)),0) FROM TT_IVE I INNER JOIN TT_VEN D ON D.CODFIL = I.CODFIL AND D.SEQUEN = I.SEQUEN INNER JOIN TD_NAT N ON D.CODNAT = N.CODTAB WHERE I.FILORI = VEN.CODFIL AND I.NUMORI = VEN.SEQUEN AND N.TIPNAT = 'D' AND I.QTDMOV < 0) >=
                    --     (SELECT SUM(IIVE.QTDMOV) FROM TT_IVE IIVE WHERE IIVE.CODFIL = VEN.CODFIL AND IIVE.SEQUEN = VEN.SEQUEN) THEN '3'
                    --WHEN (SELECT COALESCE(SUM(ABS(I.QTDMOV)),0) FROM TT_IVE I INNER JOIN TT_VEN D ON D.CODFIL = I.CODFIL AND D.SEQUEN = I.SEQUEN INNER JOIN TD_NAT N ON D.CODNAT = N.CODTAB WHERE I.FILORI = VEN.CODFIL AND I.NUMORI = VEN.SEQUEN AND N.TIPNAT = 'D' AND I.QTDMOV < 0) > 0 THEN '2'
                    ELSE '0'
               END AS VARCHAR(1)) AS SituacaoDOC, -- {0=Normal;1=Cancelada;2=Devoluo Parcial;3=Devoluo Total;4=Crdito Bloqueado;5=Inadimplncia;6=Cred. Bloq/Inad.;7=Bloqueio nos Itens;8=Faturado;A=Bloq. Val. Parcela;B=Bloq. Val. Min. Venda}
          CAST(RTF2TXT(VEN.OBSFIS) AS VARCHAR(50)) AS ObsFiscal, -- Observao Fiscal do Documento
          CAST(RTF2TXT(VEN.OBSERV) AS VARCHAR(150)) AS Observacoes, -- Observaes da Nota
          CAST(RTF2TXT(VEN.OBSERV) AS VARCHAR(4000)) AS InfoComplementares, -- Informaes Complementares da Nota
          CAST(RTF2TXT(VEN.OBSFIS) AS VARCHAR(4000)) AS TextoFiscal, -- Texto Fiscal do Documento
          CAST(NULL AS VARCHAR(200)) AS NumPedCliente, -- Nmero do Pedido no Cliente
          CAST(NULL AS VARCHAR(100)) AS NumPedRepresentante, -- Nmero do Pedido no Representante
          CAST(NULL AS VARCHAR(1)) AS IndNaturezaFrete, -- {0=Operaes de vendas, com nus suportado pelo estabelecimento vendedor;1=Operaes de vendas, com nus suportado pelo adquirente;2=Operaes de compras (bens para revenda, matrias prima e outros produtos, geradores de crdito);3=Operaes de compras (bens para revenda, matrias prima e outros produtos, no geradores de crdito);4=Transferncia de produtos acabados entre estabelecimentos da pessoa jurdica;5=Transferncia de produtos entre estabelecimentos da pessoa jurdica;9=Outras}
          CAST(VEN.CHAVEA AS VARCHAR(60)) AS ChaveNFE, -- Chave NFE
          CAST(NULL AS VARCHAR(60)) AS ChaveNFERefer, -- Chave NFE Referenciada
          -- Pedro E. Braga - Conforme reunio no ser exportado a informao nesse momento
          --CAST(CTA.CODEXT AS VARCHAR(20)) AS CodContaTes, -- Cdigo da Conta Tesouraria
          CAST(NULL AS VARCHAR(20)) AS CodContaTes, -- Cdigo da Conta Tesouraria
          -- Justificativa utilizada em Testes de Integrao pela EME4
          CAST('Venda - CFOP: '||CASE WHEN (VEN.UFLOJA = 'T') THEN DNAT.NATDEN ELSE DNAT.NATFOR END||' '||DNAT.NATURE||' - Chave: '||VEN.CODFIL||'/'||VEN.SEQUEN AS VARCHAR(200)) AS Justificativa, -- Justificativa do documento Contbil
          --CAST(NULL AS VARCHAR(200)) AS Justificativa, -- Justificativa do documento Contbil
          CAST(CASE WHEN VEN.INDFRE IN ('0', '3') THEN 'F'
                    WHEN VEN.INDFRE IN ('1', '4') THEN 'T'
                    WHEN VEN.INDFRE = '2' THEN 'A'
                    ELSE 'B'
               END AS VARCHAR(1)) AS TipoFrete, -- {F=Por conta do emitente;T=Por conta do destinatrio;A=Por conta de terceiros;B=Sem frete}
          CAST(NULL AS Numeric(9)) AS CodTransportadora, -- Cdigo da Transportadora do Documento
          CAST(TRIM(TRA.NUMDOC) AS VARCHAR(18)) AS CpfCnpjTransportadora, -- CPF ou CNPJ da Transportadora do Documento
          CAST(VEN.PLAFRE AS VARCHAR(10)) AS PlacaVeiculo, -- Placa do Veculo de Entrega
          CAST(NULL AS Numeric(9)) AS CodTranspRedespacho, -- Cdigo da Transportadora de Redespacho do Documento
          CAST(NULL AS VARCHAR(18)) AS CpfCnpjTranspRedespacho, -- CPF ou CNPJ da Transportadora de Redespacho do Documento
          CAST(CASE WHEN VEN.CODSER='CF' THEN '2D'
                    WHEN VEN.CODSER <> 'CF' AND VEN.MODNOT IN ('01', '55', '59', '65') THEN VEN.MODNOT
                    ELSE NULL
               END AS VARCHAR(2)) AS CodigoModelo, -- Cdigo do Modelo de Documento (01 ou 65)
          -- Dados da Entrega
          CAST(TRIM(ENDENT.ENDERE) AS VARCHAR(120)) AS LogradouroEnt, -- Logradouro do Endereo de Entrega
          CAST(SUBSTR(TO_CHAR(CAST(                                   NULLIF(regexp_replace(ENDENT.NUMERO, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 10) AS Numeric(10)) AS NumeroEnt, -- Nmero do Endereo de Entrega
          CAST(TRIM(ENDENT.COMPLE) AS VARCHAR(30)) AS ComplementoEnt, -- Complemento do Endereo de Entrega
          CAST(CASE WHEN DPAIENT.CODPAI = 1058 THEN LPAD(COALESCE(TRIM(ENDENT.CODCEP), '0'), 5, '0')||LPAD(COALESCE(TRIM(ENDENT.CODLOG), '0'), 3, '0') ELSE NULL END AS VARCHAR(10)) AS CEPEnt, -- CEP do Endereo de Entrega
          CAST(TRIM(ENDENT.BAIRRO) AS VARCHAR(80)) AS BairroEnt, -- Bairro do Endereo de Entrega
          CAST(CASE WHEN DPAIENT.CODPAI = 1058 THEN IBGENT.CODIBG ELSE NULL END AS Numeric(10)) AS CodMunicipioIBGEEnt, -- GeoCodigo do M3 - caso esteja informado dever importar o vnculo do municpio por este cdigo (Endereo)
          -- A Pedido da EME4 no ser exportado os dados da Cidade/Estado/Pais
          CAST(TRIM(CASE WHEN DPAIENT.CODPAI = 1058 THEN NULL /*IBGENT.NOMMUN*/ ELSE ENDENT.NOMCID END) AS VARCHAR(100)) AS CidadeEndEnt, -- Cidade do Endereo de Entrega
          CAST(TRIM(CASE WHEN DPAIENT.CODPAI = 1058 THEN NULL /*IBGENT.SIGEST*/ ELSE NULL END) AS VARCHAR(2)) AS EstadoEnt, -- Estado do Endereo de Entrega
          CAST(DPAIENT.CODPAI AS Numeric(9)) AS CodigoPaisEnt, -- Codigo do Banco Central para o Pais da Cidade de Entrega
          CAST(TRIM(CASE WHEN DPAIENT.CODPAI = 1058 THEN NULL /*DPAIENT.DESPAI*/ ELSE DPAIENT.DESPAI END) AS VARCHAR(80)) AS PaisEnt, -- Nome do Pais do Endereo de Entrega
          CAST(ABS(VEN.VLRFRE) AS Numeric(15,2)) AS ValorFrete, -- Valor do Frete
          CAST(NULL AS Numeric(15,2)) AS ValorFreteTerceiros, -- Valor do Frete Terceiros
          CAST(NULL AS Numeric(15,2)) AS ICMSFreteTerceiros, -- Valor ICMS do Frete Terceiros
          CAST(NULL AS Numeric(15,2)) AS DifaFreteTerceiros, -- Valor DIFA do Frete Terceiros
          CAST(ABS(VEN.VLRSEG) AS Numeric(15,2)) AS ValorSeguro, -- Valor do Seguro
          -- GES-2020084063 - Em Conversa com o Gustavo Demmer verificamos que no se faz necessrio o envio do acrscimo nessa TIMU apenas nos Itens.
          --CAST(CASE WHEN (COALESCE(VEN.DESRAT,0) > 0 AND COALESCE(VEN.VLRLIQ, 0) > 0) OR (COALESCE(VEN.DESRAT,0) < 0 AND COALESCE(VEN.VLRLIQ, 0) < 0) THEN ABS(VEN.DESRAT)
          --          ELSE 0
          --     END AS Numeric(15,2)) AS ValorAcrescimos, -- Valor Acrescimos
          CAST(0 AS Numeric(15,2)) AS ValorAcrescimos, -- Valor Acrescimos
          -- Valores relativo a Nota de Importao
          CAST(NULL AS Numeric(15,2)) AS ValorTHC, -- Valor THC
          CAST(NULL AS Numeric(15,2)) AS ValorAFRMM, -- Valor AFRMM
          CAST(NULL AS Numeric(15,2)) AS ValorDemurrage, -- Valor Demurrage
          CAST(NULL AS Numeric(15,2)) AS ValorDesestiva, -- Valro Desestiva
          CAST(NULL AS Numeric(15,2)) AS ValorDesembaraco, -- Valor Desembarao
          CAST(NULL AS Numeric(15,2)) AS ValorSiscomex, -- Valor Siscomex
          CAST(NULL AS Numeric(15,2)) AS ValorPISImport, -- Valro PIS Importao
          CAST(NULL AS Numeric(15,2)) AS ValorCofinsImport, -- Valro Cofins Importao
          CAST(NULL AS Numeric(15,2)) AS ValorDespAduaneira, -- Valor Despesa Aduaneira
          CAST(DMOE.DESMOE AS VARCHAR(10)) AS SimboloMoeda, -- Smbolo da Moeda
          CAST(CAM.VLRREF AS Numeric(15,4)) AS ValorCotacaoMoeda, -- Valor Cotao Moeda
          CAST(TRUNC(CAM.DATREF) AS Timestamp) AS DataCotacaoMoeda, -- Data Cotao Moeda
          --CAST(TRIM(COALESCE(ENDFUN.NUMDOC, FUNPAR.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJRepresentante, -- CPF ou CNPJ do Representante
          CAST(TRIM(FUNPAR.NUMDOC) AS VARCHAR(18)) AS CPFCNPJRepresentante, -- CPF ou CNPJ do Representante
          CAST(CASE WHEN VEN.CODSER = 'CF' THEN TO_NUMBER(VEN.NUMNOT)
                    ELSE NULL
               END AS Numeric(8)) AS COO, -- COO Cupom
          CAST(CASE WHEN VEN.CODSER = 'CF' THEN TO_NUMBER(VEN.NUMECF)
                    ELSE NULL
                END AS Numeric(8)) AS NroECF, -- Nmero do ECF
          CAST(CASE WHEN VEN.CODSER = 'CF' THEN DECF.SERECF
                    ELSE NULL
               END AS VARCHAR(50)) AS NroSerieECF, -- Nmero de Srie do ECF
          CAST(CASE WHEN VEN.CODSER = 'CF' THEN DECF.MODECF
                    ELSE NULL
               END AS VARCHAR(20)) AS ModeloECF, -- Modelo do ECF
          CAST(CASE WHEN VEN.CODSER = 'CF' THEN DECF.MARECF
                    ELSE NULL
               END AS VARCHAR(20)) AS MarcaECF, -- Marca do ECF
          CAST(VEN.DOCNFP AS VARCHAR(18)) as CPFCNPJCupom, -- CPF ou CNPJ do cliente no identificado no cupom
          CAST(TO_NUMBER(                         NULLIF(regexp_replace(DDEV.CODEXT, '[^0-9]', '', 'gi'), '')) AS Numeric(5)) AS TPDEVVENDA -- Cdigo de Devoluo
     FROM TT_VEN VEN
     -- Filial de Emisso
     JOIN TD_FIL DFIL ON DFIL.CODFIL = VEN.CODFIL
     -- Srie de Emisso
     JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
     -- Natureza
     JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
     -- Conta
     LEFT JOIN TT_CTA CTA ON CTA.CODFIL = VEN.FILCTA AND CTA.SEQUEN = VEN.SEQCTA AND CTA.TIPCTA = VEN.TIPCTA
     -- ECF
     JOIN TD_ECF DECF ON DECF.FILECF = VEN.CODFIL AND DECF.NUMECF = VEN.NUMECF
     -- Cliente
     JOIN TT_CLI PAR ON PAR.FILCLI = VEN.FILCLI AND PAR.CODCLI = VEN.CODCLI
     --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
     -- Endereo de Faturamento
     LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = VEN.FILCLI AND ENDFAT.CODCLI = VEN.CODCLI AND ENDFAT.CODFIL = VEN.FILFAT AND ENDFAT.NUMEND = VEN.ENDFAT
     -- Endereo de Entrega
     LEFT JOIN TT_END ENDENT ON ENDENT.FILCLI = VEN.FILCLI AND ENDENT.CODCLI = VEN.CODCLI AND ENDENT.CODFIL = VEN.FILENT AND ENDENT.NUMEND = VEN.ENDENT
     LEFT JOIN TT_MUN MUNENT ON MUNENT.CODIGO = ENDENT.CODCID
     LEFT JOIN TT_IBG IBGENT ON IBGENT.CODIBG = COALESCE(ENDENT.CODIBG, MUNENT.CODIBG)
     LEFT JOIN TD_PAI DPAIENT ON DPAIENT.CODPAI = ENDENT.CODPAI
     -- Transportadora
     LEFT JOIN TT_CLI TRA ON TRA.FILCLI = VEN.FILTRA AND TRA.CODCLI = VEN.CODTRA
     --LEFT JOIN TT_END ENDTRA ON ENDTRA.FILCLI = TRA.FILCLI AND ENDTRA.CODCLI = TRA.CODCLI AND ENDTRA.CODFIL = TRA.FILEND AND ENDTRA.NUMEND = TRA.NUMEND
     -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
     LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
     -- Vendedor/Representante
     LEFT JOIN TT_USU FUN ON FUN.FILUSU = VEN.FILVEN AND FUN.CODUSU = VEN.CODVEN
     LEFT JOIN TT_CLI FUNPAR ON FUNPAR.FILCLI = FUN.FILCLI AND FUNPAR.CODCLI = FUN.CODCLI
     -- Plano de Pagamento
     LEFT JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT AND PLA.CODPGT = VEN.CODPGT
     -- Codigo de Devoluo 
     LEFT JOIN TD_DEV DDEV ON DDEV.CODTAB = VEN.CODDEV 
     -- Moeda
     LEFT JOIN TD_MOE DMOE ON DMOE.CODTAB = PLA.CODMOE
     LEFT JOIN ( SELECT LCAM.CODMOE, MAX(LCAM.DATREF) AS DATREF, MAX(LCAM.VLRREF) AS VLRREF
                   FROM TT_CAM LCAM
                  GROUP BY LCAM.CODMOE ) CAM ON CAM.CODMOE = DMOE.CODTAB AND CAM.DATREF = VEN.DATHOR
    WHERE 1 = 1
      AND VEN.DATHOR >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',VEN.CODFIL,'','','')
      AND VEN.NUMNOT NOT LIKE '%#%'
      AND (
             -- Quando Cupom Fiscal
             (VEN.CODSER = 'CF') OR
             -- Quando a nota manual no for null (status  NM)
             (VEN.NOTMAN IS NOT NULL) OR
             -- Quando no for Documento Eletrnico
             (VEN.MODNOT NOT IN ('55','65','59','SE')) OR 
             -- Quando Documento Eletrnico
             (
                (VEN.MODNOT IN ('55','65','59','SE')) AND
                (
                   -- Quando Cancelado exporta quando situao for Cancelada
                   ((VEN.FLGEST = 'C') AND (VEN.FLGNFE IN ('3'))) OR
                   -- Quando Aberto/Quitado exporta quando situao for Autorizado
                   ((VEN.FLGEST <> 'C') AND (VEN.FLGNFE IN ('1'))) OR
                   -- Nota Estornada fica cancelada no banco mas autorizada na Sefaz
                   ((VEN.FLGEST = 'C') AND (VEN.FLGNFE = '1'))
                )
             )
          )
      AND ((VEN.EXPEM4 = 'F') OR (VEN.EXPORT = 'F'))
UNION ALL
   SELECT VEN.CODFIL,
          VEN.SEQUEN,
          DFIL.CGCFIL AS CNPJFilial,
          CAST(NULL AS CHAR(8)) AS NUMPED,
          CAST(NULL AS CHAR(1)) AS TIPPED,
          CAST(NULL AS CHAR(2)) AS NUMPAR,
          CAST(NULL AS CHAR(2)) AS SUBPAR,
          CAST(VEN.CODSER AS VARCHAR(3)) AS CODSER, CAST(NULL AS VARCHAR(3)) AS SUBSER, CAST(VEN.NUMECF AS CHAR(3)) AS NUMECF, CAST(VEN.NUMNOT AS VARCHAR(10)) AS NUMNOT,
          CAST('VEN' AS VARCHAR(3)) AS ORIGEM,
          CAST('TIMU_DOCUMENTO' AS VARCHAR(50)) AS DESTINO,
          CAST(VEN.LANVEN AS CHAR(1)) AS TEM_ITEM,
          CAST(CASE WHEN (PAR.CODCLI = LPAD('0', 6, ' ')) THEN 'F' ELSE VEN.FINANC END AS CHAR(1)) AS TEM_PARCELA,
          CAST(CASE WHEN (VEN.FINANC = 'T') AND (LeParametroTXT('TIPO_EXP_EME4', VEN.CODFIL, '', '', '') = 'V') AND (VEN.VLRNOT > 0) THEN 'T' ELSE 'F' END AS CHAR(1)) AS TEM_LIQUIDACAO,
          CAST(CASE WHEN (LeParametroTXT('TIPO_EXP_EME4', VEN.CODFIL, '', '', '') = 'C') AND (PAR.CODCLI <> LPAD('0', 6, ' ')) AND (VEN.FINANC = 'T') THEN 'T' ELSE 'F' END AS CHAR(1)) AS TEM_MOVCONTABIL,
          CAST('F' AS CHAR(1)) AS TEM_CCUSTOCONTABIL,
          CAST('F' AS CHAR(1)) AS TEM_FRETE,
          CAST('F' AS CHAR(1)) AS TEM_OPERACAOFINANCEIRA,
          CAST('F' AS CHAR(1)) AS TEM_CONTAFINANCEIRA,
          CAST('F' AS CHAR(1)) AS TEM_CCUSTOFINANCEIRO,
          CAST('VEN' || VEN.CODFIL || VEN.SEQUEN AS VARCHAR(50)) AS CHAVE,
          VEN.VLRNOT AS VLRNOT_VALIDACAO, (VEN.VLRLIQ + COALESCE(VEN.VLRSAD, 0)) AS VLRLIQ_VALIDACAO,
          COALESCE(VEN.DATINC, VEN.DATHOR) AS DATINC,
          VEN.ATU_EM,
          VEN.EXPORT,
          VEN.EXPEM4,
          COALESCE(VEN.DATINC, VEN.DATHOR) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
          COALESCE(PAR.NUMDOC, VIN.NUMDOC) AS NUMDOC,
          COALESCE(VEN.DATINC, VEN.DATHOR) AS DATAFILTRO,
          VEN.MODNOT,
          VEN.UFLOJA,
          DNAT.EXTFOR,
          DNAT.EXTDEM,
          CAST(TO_NUMBER(VEN.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
          -- Definido juntamente com a EME4 quando for cupom fiscal enviar tipo de operao fixo
          CAST(CASE WHEN (VEN.CODSER = 'CF') THEN 998
                    WHEN (VEN.MODNOT = '65') THEN 997
                    WHEN (VEN.MODNOT = '59') THEN 996
                    WHEN (VEN.UFLOJA = 'T') THEN TO_NUMBER(                                                           NULLIF(regexp_replace(DNAT.EXTDEM, '[^0-9]', '', 'gi'), ''))
                    ELSE TO_NUMBER(                                   NULLIF(regexp_replace(DNAT.EXTFOR, '[^0-9]', '', 'gi'), ''))
               END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
         CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                   ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                       THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                 ELSE SUBSTR(TO_CHAR(CAST(                                                                          NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                            END
                                       ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                 ELSE SUBSTR(TO_CHAR(CAST(                                                                                    NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                            END
                                  END)
              END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
          PAR.CODEXT AS CodigoExternoCliFor,
          CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
          CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = VEN.FILCLI AND REL.CODPAR = VEN.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                    ELSE 'C'
                END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
          CAST('1' AS VARCHAR(1)) AS TipoM, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
          CAST(TRIM(CASE WHEN VEN.CODSER='CF' THEN VEN.CODSER
                         WHEN VEN.CODSER='NM' THEN CAST(CONCAT('N',VEN.NUMECF) AS VARCHAR(5))
                         WHEN ( (VEN.MODNOT = '65' OR VEN.MODNOT = '59') AND VEN.NUMECF >= '400' ) THEN VEN.NUMECF
                         WHEN VEN.CODSER <> 'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN DSER.SEREXT
                         ELSE NULL
                    END) AS VARCHAR(5)) AS Serie, -- Srie do Documento
          CAST(TO_CHAR(TO_NUMBER(TRIM(CASE WHEN VEN.CODSER = 'CF' THEN VEN.SEQUEN
                                           WHEN VEN.CODSER = 'ST' THEN COALESCE(TO_CHAR(VEN.SATCFE), VEN.NUMNOT)
                                           ELSE VEN.NUMNOT END))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
          CAST(CASE WHEN VEN.VLRNOT < 0 THEN TRUNC(VEN.DATHOR)
               ELSE NULL
          END AS Timestamp) AS DataEntrada, -- Data de Entrada
          CAST(CASE WHEN VEN.VLRNOT > 0 THEN TRUNC(VEN.DATHOR)
               ELSE NULL
          END AS Timestamp) AS DataSaida, -- Data de Sada
          CAST(TRUNC(VEN.DATHOR) AS Timestamp) AS DataEntSai, -- Data de Entrada ou Sada
          CAST(TRUNC(VEN.DATHOR) AS Timestamp) AS DataEmissao, -- Data de Emisso
          CAST((SELECT COALESCE(SUM(ABS(IVE.VLRMOV + COALESCE(IVE.DESRAT,0) - COALESCE(IVE.VLRIPI,0))),0)
                     FROM TT_IVE IVE 
                    WHERE IVE.CODFIL = VEN.CODFIL
                      AND IVE.SEQUEN = VEN.SEQUEN ) AS Numeric(15,2) ) AS ValorContabil, -- Valor Contbil Original do Documento (Tesouraria)
          CAST(0 AS Numeric(15,2)) AS ValorDescontos, -- Valor Desconto dos Produtos
          CAST(ABS(VEN.OUTTAX) AS Numeric(15,2)) AS ValorOutrasDespesas, -- Valor Outras Despesas dos Produtos
          CAST(NULL AS Numeric(15,2)) AS ValorDescontosServ, -- Valor Desconto dos Servios
          CAST(NULL AS Numeric(15,2)) AS ValorOutrasDespesasServ, -- Valor Outras Despesas dos Servios
          CAST(CASE WHEN VEN.CODSER IN ('CF', 'NM') THEN NULL -- Cupom Fiscal no tem Situao no Sefaz
                    ELSE CASE WHEN VEN.FLGNFE = '1' THEN '3'                         -- 1 - Autorizada
                              WHEN VEN.FLGNFE = '2' THEN NULL                        -- 2 - Rejeitada
                              WHEN VEN.FLGNFE = '3' THEN '5'                         -- 3 - Cancelado
                              WHEN VEN.FLGNFE = '4' THEN '7'                         -- 4 - Inutilizado
                              WHEN VEN.FLGNFE = '5' THEN NULL                        -- 5 - Enviada ao Sefaz
                              WHEN VEN.FLGNFE = '6' THEN '9'                         -- 6 - Denegado
                              WHEN VEN.FLGNFE = '8' THEN NULL                        -- 8 - Erro de Importao
                              WHEN VEN.FLGNFE = '0' AND VEN.FLGEST <> 'C' THEN 'A'   -- 0 - No enviado
                              ELSE NULL -- Situao do Sefaz inexistente
                         END
               END AS VARCHAR(1)) AS SituacaoNFE, -- {3=Autorizada;5=Cancelada;7=Inutilizada;8=Substituida;9=Denegada;A=Contingncia}
          CAST(CASE WHEN (VEN.FLGEST = 'C') AND (VEN.FILEST IS NULL) THEN '1'
                    WHEN (SELECT COALESCE(SUM(ABS(I.QTDMOV)),0) FROM TT_IVE I INNER JOIN TT_VEN D ON D.CODFIL = I.CODFIL AND D.SEQUEN = I.SEQUEN INNER JOIN TD_NAT N ON D.CODNAT = N.CODTAB WHERE I.FILORI = VEN.CODFIL AND I.NUMORI = VEN.SEQUEN AND N.TIPNAT = 'D' AND I.QTDMOV < 0) >=
                         (SELECT SUM(IIVE.QTDMOV) FROM TT_IVE IIVE WHERE IIVE.CODFIL = VEN.CODFIL AND IIVE.SEQUEN = VEN.SEQUEN) THEN '3'
                    WHEN (SELECT COALESCE(SUM(ABS(I.QTDMOV)),0) FROM TT_IVE I INNER JOIN TT_VEN D ON D.CODFIL = I.CODFIL AND D.SEQUEN = I.SEQUEN INNER JOIN TD_NAT N ON D.CODNAT = N.CODTAB WHERE I.FILORI = VEN.CODFIL AND I.NUMORI = VEN.SEQUEN AND N.TIPNAT = 'D' AND I.QTDMOV < 0) > 0 THEN '2'
                    ELSE '0'
               END AS VARCHAR(1)) AS SituacaoDOC, -- {0=Normal;1=Cancelada;2=Devoluo Parcial;3=Devoluo Total;4=Crdito Bloqueado;5=Inadimplncia;6=Cred. Bloq/Inad.;7=Bloqueio nos Itens;8=Faturado;A=Bloq. Val. Parcela;B=Bloq. Val. Min. Venda}
          CAST(RTF2TXT(VEN.OBSFIS) AS VARCHAR(50)) AS ObsFiscal, -- Observao Fiscal do Documento
          CAST(RTF2TXT(VEN.OBSERV) AS VARCHAR(150)) AS Observacoes, -- Observaes da Nota
          CAST(RTF2TXT(VEN.OBSERV) AS VARCHAR(4000)) AS InfoComplementares, -- Informaes Complementares da Nota
          CAST(RTF2TXT(VEN.OBSFIS) AS VARCHAR(4000)) AS TextoFiscal, -- Texto Fiscal do Documento
          CAST(NULL AS VARCHAR(200)) AS NumPedCliente, -- Nmero do Pedido no Cliente
          CAST(NULL AS VARCHAR(100)) AS NumPedRepresentante, -- Nmero do Pedido no Representante
          CAST(NULL AS VARCHAR(1)) AS IndNaturezaFrete, -- {0=Operaes de vendas, com nus suportado pelo estabelecimento vendedor;1=Operaes de vendas, com nus suportado pelo adquirente;2=Operaes de compras (bens para revenda, matrias prima e outros produtos, geradores de crdito);3=Operaes de compras (bens para revenda, matrias prima e outros produtos, no geradores de crdito);4=Transferncia de produtos acabados entre estabelecimentos da pessoa jurdica;5=Transferncia de produtos entre estabelecimentos da pessoa jurdica;9=Outras}
          CAST(VEN.CHAVEA AS VARCHAR(60)) AS ChaveNFE, -- Chave NFE
          CAST(NULL AS VARCHAR(60)) AS ChaveNFERefer, -- Chave NFE Referenciada
          -- Pedro E. Braga - Conforme reunio no ser exportado a informao nesse momento
          --CAST(CTA.CODEXT AS VARCHAR(20)) AS CodContaTes, -- Cdigo da Conta Tesouraria
          CAST(NULL AS VARCHAR(20)) AS CodContaTes, -- Cdigo da Conta Tesouraria
          -- Justificativa utilizada em Testes de Integrao pela EME4
          CAST('Venda - CFOP: '||CASE WHEN (VEN.UFLOJA = 'T') THEN DNAT.NATDEN ELSE DNAT.NATFOR END||' '||DNAT.NATURE||' - Chave: '||VEN.CODFIL||'/'||VEN.SEQUEN AS VARCHAR(200)) AS Justificativa, -- Justificativa do documento Contbil
          --CAST(NULL AS VARCHAR(200)) AS Justificativa, -- Justificativa do documento Contbil
          CAST(CASE WHEN VEN.INDFRE IN ('0', '3') THEN 'F'
                    WHEN VEN.INDFRE IN ('1', '4') THEN 'T'
                    WHEN VEN.INDFRE = '2' THEN 'A'
                    ELSE 'B'
               END AS VARCHAR(1)) AS TipoFrete, -- {F=Por conta do emitente;T=Por conta do destinatrio;A=Por conta de terceiros;B=Sem frete}
          CAST(NULL AS Numeric(9)) AS CodTransportadora, -- Cdigo da Transportadora do Documento
          CAST(TRIM(TRA.NUMDOC) AS VARCHAR(18)) AS CpfCnpjTransportadora, -- CPF ou CNPJ da Transportadora do Documento
          CAST(VEN.PLAFRE AS VARCHAR(10)) AS PlacaVeiculo, -- Placa do Veculo de Entrega
          CAST(NULL AS Numeric(9)) AS CodTranspRedespacho, -- Cdigo da Transportadora de Redespacho do Documento
          CAST(NULL AS VARCHAR(18)) AS CpfCnpjTranspRedespacho, -- CPF ou CNPJ da Transportadora de Redespacho do Documento
          CAST(CASE WHEN VEN.CODSER='CF' THEN '2D'
                    WHEN VEN.CODSER <> 'CF' AND VEN.MODNOT IN ('01', '55', '59', '65') THEN VEN.MODNOT
                    ELSE NULL
               END AS VARCHAR(2)) AS CodigoModelo, -- Cdigo do Modelo de Documento (01 ou 65)
          -- Dados da Entrega
          CAST(TRIM(ENDENT.ENDERE) AS VARCHAR(120)) AS LogradouroEnt, -- Logradouro do Endereo de Entrega
          CAST(SUBSTR(TO_CHAR(CAST(                                   NULLIF(regexp_replace(ENDENT.NUMERO, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 10) AS Numeric(10)) AS NumeroEnt, -- Nmero do Endereo de Entrega
          CAST(TRIM(ENDENT.COMPLE) AS VARCHAR(30)) AS ComplementoEnt, -- Complemento do Endereo de Entrega
          CAST(CASE WHEN DPAIENT.CODPAI = 1058 THEN LPAD(COALESCE(TRIM(ENDENT.CODCEP), '0'), 5, '0')||LPAD(COALESCE(TRIM(ENDENT.CODLOG), '0'), 3, '0') ELSE NULL END AS VARCHAR(10)) AS CEPEnt, -- CEP do Endereo de Entrega
          CAST(TRIM(ENDENT.BAIRRO) AS VARCHAR(80)) AS BairroEnt, -- Bairro do Endereo de Entrega
          CAST(CASE WHEN DPAIENT.CODPAI = 1058 THEN IBGENT.CODIBG ELSE NULL END AS Numeric(10)) AS CodMunicipioIBGEEnt, -- GeoCodigo do M3 - caso esteja informado dever importar o vnculo do municpio por este cdigo (Endereo)
          -- A Pedido da EME4 no ser exportado os dados da Cidade/Estado/Pais
          CAST(TRIM(CASE WHEN DPAIENT.CODPAI = 1058 THEN NULL /*IBGENT.NOMMUN*/ ELSE ENDENT.NOMCID END) AS VARCHAR(100)) AS CidadeEndEnt, -- Cidade do Endereo de Entrega
          CAST(TRIM(CASE WHEN DPAIENT.CODPAI = 1058 THEN NULL /*IBGENT.SIGEST*/ ELSE NULL END) AS VARCHAR(2)) AS EstadoEnt, -- Estado do Endereo de Entrega
          CAST(DPAIENT.CODPAI AS Numeric(9)) AS CodigoPaisEnt, -- Codigo do Banco Central para o Pais da Cidade de Entrega
          CAST(TRIM(CASE WHEN DPAIENT.CODPAI = 1058 THEN NULL /*DPAIENT.DESPAI*/ ELSE DPAIENT.DESPAI END) AS VARCHAR(80)) AS PaisEnt, -- Nome do Pais do Endereo de Entrega
          CAST(ABS(VEN.VLRFRE) AS Numeric(15,2)) AS ValorFrete, -- Valor do Frete
          CAST(NULL AS Numeric(15,2)) AS ValorFreteTerceiros, -- Valor do Frete Terceiros
          CAST(NULL AS Numeric(15,2)) AS ICMSFreteTerceiros, -- Valor ICMS do Frete Terceiros
          CAST(NULL AS Numeric(15,2)) AS DifaFreteTerceiros, -- Valor DIFA do Frete Terceiros
          CAST(ABS(VEN.VLRSEG) AS Numeric(15,2)) AS ValorSeguro, -- Valor do Seguro
          -- GES-2020084063 - Em Conversa com o Gustavo Demmer verificamos que no se faz necessrio o envio do acrscimo nessa TIMU apenas nos Itens.
          --CAST(CASE WHEN (COALESCE(VEN.DESRAT,0) > 0 AND COALESCE(VEN.VLRLIQ, 0) > 0) OR (COALESCE(VEN.DESRAT,0) < 0 AND COALESCE(VEN.VLRLIQ, 0) < 0) THEN ABS(VEN.DESRAT)
          --          ELSE 0
          --     END AS Numeric(15,2)) AS ValorAcrescimos, -- Valor Acrescimos
          CAST(0 AS Numeric(15,2)) AS ValorAcrescimos, -- Valor Acrescimos
          -- Valores relativo a Nota de Importao
          CAST(NULL AS Numeric(15,2)) AS ValorTHC, -- Valor THC
          CAST(NULL AS Numeric(15,2)) AS ValorAFRMM, -- Valor AFRMM
          CAST(NULL AS Numeric(15,2)) AS ValorDemurrage, -- Valor Demurrage
          CAST(NULL AS Numeric(15,2)) AS ValorDesestiva, -- Valro Desestiva
          CAST(NULL AS Numeric(15,2)) AS ValorDesembaraco, -- Valor Desembarao
          CAST(NULL AS Numeric(15,2)) AS ValorSiscomex, -- Valor Siscomex
          CAST(NULL AS Numeric(15,2)) AS ValorPISImport, -- Valro PIS Importao
          CAST(NULL AS Numeric(15,2)) AS ValorCofinsImport, -- Valro Cofins Importao
          CAST(NULL AS Numeric(15,2)) AS ValorDespAduaneira, -- Valor Despesa Aduaneira
          CAST(DMOE.DESMOE AS VARCHAR(10)) AS SimboloMoeda, -- Smbolo da Moeda
          CAST(CAM.VLRREF AS Numeric(15,4)) AS ValorCotacaoMoeda, -- Valor Cotao Moeda
          CAST(TRUNC(CAM.DATREF) AS Timestamp) AS DataCotacaoMoeda, -- Data Cotao Moeda
          --CAST(TRIM(COALESCE(ENDFUN.NUMDOC, FUNPAR.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJRepresentante, -- CPF ou CNPJ do Representante
          CAST(TRIM(FUNPAR.NUMDOC) AS VARCHAR(18)) AS CPFCNPJRepresentante, -- CPF ou CNPJ do Representante
          CAST(CASE WHEN VEN.CODSER = 'CF' THEN TO_NUMBER(VEN.NUMNOT)
                    ELSE NULL
               END AS Numeric(8)) AS COO, -- COO Cupom
          CAST(CASE WHEN VEN.CODSER = 'CF' THEN TO_NUMBER(VEN.NUMECF)
                    ELSE NULL
                END AS Numeric(8)) AS NroECF, -- Nmero do ECF
          CAST(CASE WHEN VEN.CODSER = 'CF' THEN DECF.SERECF
                    ELSE NULL
               END AS VARCHAR(50)) AS NroSerieECF, -- Nmero de Srie do ECF
          CAST(CASE WHEN VEN.CODSER = 'CF' THEN DECF.MODECF
                    ELSE NULL
               END AS VARCHAR(20)) AS ModeloECF, -- Modelo do ECF
          CAST(CASE WHEN VEN.CODSER = 'CF' THEN DECF.MARECF
                    ELSE NULL
               END AS VARCHAR(20)) AS MarcaECF, -- Marca do ECF
          CAST(VEN.DOCNFP AS VARCHAR(18)) as CPFCNPJCupom, -- CPF ou CNPJ do cliente no identificado no cupom
          CAST(TO_NUMBER(                         NULLIF(regexp_replace(DDEV.CODEXT, '[^0-9]', '', 'gi'), '')) AS Numeric(5)) AS TPDEVVENDA -- Cdigo de Devoluo
     FROM TT_VEN VEN
     -- Filial de Emisso
     JOIN TD_FIL DFIL ON DFIL.CODFIL = VEN.CODFIL
     -- Srie de Emisso
     JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
     -- Natureza
     JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
     -- Conta
     LEFT JOIN TT_CTA CTA ON CTA.CODFIL = VEN.FILCTA AND CTA.SEQUEN = VEN.SEQCTA AND CTA.TIPCTA = VEN.TIPCTA
     -- ECF
     JOIN TD_ECF DECF ON DECF.FILECF = VEN.CODFIL AND DECF.NUMECF = VEN.NUMECF
     -- Cliente
     JOIN TT_CLI PAR ON PAR.FILCLI = VEN.FILCLI AND PAR.CODCLI = VEN.CODCLI
     --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
     -- Endereo de Faturamento
     LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = VEN.FILCLI AND ENDFAT.CODCLI = VEN.CODCLI AND ENDFAT.CODFIL = VEN.FILFAT AND ENDFAT.NUMEND = VEN.ENDFAT
     -- Endereo de Entrega
     LEFT JOIN TT_END ENDENT ON ENDENT.FILCLI = VEN.FILCLI AND ENDENT.CODCLI = VEN.CODCLI AND ENDENT.CODFIL = VEN.FILENT AND ENDENT.NUMEND = VEN.ENDENT
     LEFT JOIN TT_MUN MUNENT ON MUNENT.CODIGO = ENDENT.CODCID
     LEFT JOIN TT_IBG IBGENT ON IBGENT.CODIBG = COALESCE(ENDENT.CODIBG, MUNENT.CODIBG)
     LEFT JOIN TD_PAI DPAIENT ON DPAIENT.CODPAI = ENDENT.CODPAI
     -- Transportadora
     LEFT JOIN TT_CLI TRA ON TRA.FILCLI = VEN.FILTRA AND TRA.CODCLI = VEN.CODTRA
     --LEFT JOIN TT_END ENDTRA ON ENDTRA.FILCLI = TRA.FILCLI AND ENDTRA.CODCLI = TRA.CODCLI AND ENDTRA.CODFIL = TRA.FILEND AND ENDTRA.NUMEND = TRA.NUMEND
     -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
     LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
     -- Vendedor/Representante
     LEFT JOIN TT_USU FUN ON FUN.FILUSU = VEN.FILVEN AND FUN.CODUSU = VEN.CODVEN
     LEFT JOIN TT_CLI FUNPAR ON FUNPAR.FILCLI = FUN.FILCLI AND FUNPAR.CODCLI = FUN.CODCLI
     -- Plano de Pagamento
     LEFT JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT AND PLA.CODPGT = VEN.CODPGT
     -- Codigo de Devoluo 
     LEFT JOIN TD_DEV DDEV ON DDEV.CODTAB = VEN.CODDEV 
     -- Moeda
     LEFT JOIN TD_MOE DMOE ON DMOE.CODTAB = PLA.CODMOE
     LEFT JOIN ( SELECT LCAM.CODMOE, MAX(LCAM.DATREF) AS DATREF, MAX(LCAM.VLRREF) AS VLRREF
                   FROM TT_CAM LCAM
                  GROUP BY LCAM.CODMOE ) CAM ON CAM.CODMOE = DMOE.CODTAB AND CAM.DATREF = VEN.DATHOR
    WHERE 1 = 1
      AND VEN.DATHOR >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',VEN.CODFIL,'','','')
      AND VEN.NUMNOT NOT LIKE '%#%'
      AND (
             -- Quando Documento Eletrnico
             (
                (VEN.MODNOT IN ('55','65')) AND 
                (
                   -- S notas inutilizadas e denegadas
                   (VEN.FLGEST = 'C') AND VEN.FLGNFE IN ('4', '6')
                )
             )
          )
      AND ((VEN.EXPEM4 = 'F') OR (VEN.EXPORT = 'F'))
   ) TAB
   ;


-- Autor: Bruno B.
-- Cliente(s): EME4
-- Finalidade(s):
-- 1)Retornar as notas de entrada.
-- Arquivo Pai: TIMU_DOCUMENTO
/*-- SEQ 2682 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_NOTAS_RECEBIDAS CASCADE;

/*-- SEQ 2683 --*/
CREATE OR REPLACE VIEW TV_TIMU_NOTAS_RECEBIDAS AS
   SELECT
         --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
         CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
         CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN CASE WHEN TAB.FLGEST = 'D' THEN 'E' ELSE 'A' END ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
         CAST('T' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
         --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
         CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
         --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
         TAB.CODFIL, TAB.SEQUEN, TAB.NUMPAR, TAB.SUBPAR, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.NUMDOC, TAB.DATAFILTRO, 
         TAB.CODSER, TAB.SUBSER, TAB.NUMECF, TAB.NUMNOT, TAB.NUMPED, TAB.TIPPED,
         TAB.TEM_ITEM, TAB.TEM_PARCELA, TAB.TEM_LIQUIDACAO, TAB.TEM_MOVCONTABIL, TAB.TEM_CCUSTOCONTABIL, TAB.TEM_FRETE, TAB.TEM_OPERACAOFINANCEIRA, TAB.TEM_CONTAFINANCEIRA, TAB.TEM_CCUSTOFINANCEIRO, TAB.CHAVE, TAB.VLRNOT_VALIDACAO, TAB.VLRLIQ_VALIDACAO,
         TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
         TAB.TipoOperacao, -- Cdigo do Tipo de Operao
         TAB.Filial, -- Cdigo da Filial
         TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
         TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
         TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
         TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
         TAB.Serie, -- Srie do Documento
         TAB.NumeroDocumento, -- Nmero do documento
         TAB.DataEntrada, -- Data de Entrada
         TAB.DataSaida, -- Data de Sada
         TAB.DataEntSai, -- Data de Entrada ou Sada
         TAB.DataEmissao, -- Data de Emisso
         TAB.ValorContabil, -- Valor Contbil Original do Documento (Tesouraria)
         TAB.ValorDescontos, -- Valor Desconto dos Produtos
         TAB.ValorOutrasDespesas, -- Valor Outras Despesas dos Produtos
         TAB.ValorDescontosServ, -- Valor Desconto dos Servios
         TAB.ValorOutrasDespesasServ, -- Valor Outras Despesas dos Servios
         TAB.SituacaoNFE, -- {3=Autorizada;5=Cancelada;7=Inutilizada;8=Substituida;9=Denegada;A=Contingncia}
         TAB.SituacaoDOC, -- {0=Normal;1=Cancelada;2=Devoluo Parcial;3=Devoluo Total;4=Crdito Bloqueado;5=Inadimplncia;6=Cred. Bloq/Inad.;7=Bloqueio nos Itens;8=Faturado;A=Bloq. Val. Parcela;B=Bloq. Val. Min. Venda}
         TAB.ObsFiscal, -- Observao Fiscal do Documento
         TAB.Observacoes, -- Observaes da Nota
         TAB.InfoComplementares, -- Informaes Complementares da Nota
         TAB.TextoFiscal, -- Texto Fiscal do Documento
         TAB.NumPedCliente, -- Nmero do Pedido no Cliente
         TAB.NumPedRepresentante, -- Nmero do Pedido no Representante
         TAB.IndNaturezaFrete, -- {0=Operaes de vendas, com nus suportado pelo estabelecimento vendedor;1=Operaes de vendas, com nus suportado pelo adquirente;2=Operaes de compras (bens para revenda, matrias prima e outros produtos, geradores de crdito);3=Operaes de compras (bens para revenda, matrias prima e outros produtos, no geradores de crdito);4=Transferncia de produtos acabados entre estabelecimentos da pessoa jurdica;5=Transferncia de produtos entre estabelecimentos da pessoa jurdica;9=Outras}
         TAB.ChaveNFE, -- Chave NFE
         TAB.ChaveNFERefer, -- Chave NFE Referenciada
         TAB.CodContaTes, -- Cdigo da Conta Tesouraria
         TAB.Justificativa, -- Justificativa do documento Contbil
         TAB.TipoFrete, -- {F=Por conta do emitente;T=Por conta do destinatrio;A=Por conta de terceiros;B=Sem frete}
         TAB.CodTransportadora, -- Cdigo da Transportadora do Documento
         TAB.CpfCnpjTransportadora, -- CPF ou CNPJ da Transportadora do Documento
         TAB.PlacaVeiculo, -- Placa do Veculo de Entrega
         TAB.CodTranspRedespacho, -- Cdigo da Transportadora de Redespacho do Documento
         TAB.CpfCnpjTranspRedespacho, -- CPF ou CNPJ da Transportadora de Redespacho do Documento
         TAB.CodigoModelo, -- Cdigo do Modelo de Documento (01 ou 65)
         TAB.LogradouroEnt, -- Logradouro do Endereo de Entrega
         TAB.NumeroEnt, -- Nmero do Endereo de Entrega
         TAB.ComplementoEnt, -- Complemento do Endereo de Entrega
         TAB.CEPEnt, -- CEP do Endereo de Entrega
         TAB.CodMunicipioIBGEEnt, -- GeoCodigo do M3 - caso esteja informado dever importar o vnculo do municpio por este cdigo (Endereo)
         TAB.CidadeEndEnt, -- Cidade do Endereo de Entrega
         TAB.BairroEnt, -- Bairro do Endereo de Entrega
         TAB.EstadoEnt, -- Estado do Endereo de Entrega
         TAB.CodigoPaisEnt, -- Codigo do Banco Central para o Pais da Cidade de Entrega
         TAB.PaisEnt, -- Nome do Pais do Endereo de Entrega
         TAB.ValorFrete, -- Valor do Frete
         TAB.ValorFreteTerceiros, -- Valor do Frete Terceiros
         TAB.ICMSFreteTerceiros, -- Valor ICMS do Frete Terceiros
         TAB.DifaFreteTerceiros, -- Valor DIFA do Frete Terceiros
         TAB.ValorSeguro, -- Valor do Seguro
         TAB.ValorAcrescimos, -- Valor Acrescimos
         TAB.ValorTHC, -- Valor THC
         TAB.ValorAFRMM, -- Valor AFRMM
         TAB.ValorDemurrage, -- Valor Demurrage
         TAB.ValorDesestiva, -- Valro Desestiva
         TAB.ValorDesembaraco, -- Valor Desembarao
         TAB.ValorSiscomex, -- Valor Siscomex
         TAB.ValorPISImport, -- Valro PIS Importao
         TAB.ValorCofinsImport, -- Valro Cofins Importao
         TAB.ValorDespAduaneira, -- Valor Despesa Aduaneira
         TAB.SimboloMoeda, -- Smbolo da Moeda
         TAB.ValorCotacaoMoeda, -- Valor Cotao Moeda
         TAB.DataCotacaoMoeda, -- Data Cotao Moeda
         TAB.CPFCNPJRepresentante, -- CPF ou CNPJ do Representante
         TAB.COO, -- COO Cupom
         TAB.NroECF, -- Nmero do ECF
         TAB.NroSerieECF, -- Nmero de rie do ECF
         TAB.ModeloECF, -- Modelo do ECF
         TAB.MarcaECF, -- Marca do ECF
         TAB.CPFCNPJCupom -- CPF ou CNPJ do cliente no identificado no cupom
     FROM (
   SELECT COM.CODFIL, 
          COM.SEQUEN, 
          CAST(NULL AS CHAR(8)) AS NUMPED,
          CAST(NULL AS CHAR(1)) AS TIPPED,
          CAST(NULL AS CHAR(2)) AS NUMPAR,
          CAST(NULL AS CHAR(2)) AS SUBPAR,
          CAST(COM.CODSER AS VARCHAR(3)) AS CODSER, CAST(COM.SUBSER AS VARCHAR(3)) AS SUBSER, CAST(NULL AS CHAR(3)) AS NUMECF, CAST(COM.NUMNOT AS VARCHAR(10)) AS NUMNOT,
          CAST('COM' AS VARCHAR(3)) AS ORIGEM, 
          CAST('TIMU_DOCUMENTO' AS VARCHAR(50)) AS DESTINO, 
          CAST(CASE WHEN COM.TIPNOT = 'F' THEN 'F' -- Fatura
                    --WHEN TRA.FILICO IS NOT NULL THEN 'T' -- Transferncia
                    WHEN COM.TIPPAR = 'F' THEN 'T' -- Compra
                    WHEN COM.TIPPAR = 'T' THEN 'F' -- Frete
                    WHEN COM.TIPPAR IS NULL THEN 'F' -- Ttulo
                    ELSE 'T' -- Desconhecido
               END AS CHAR(1)) AS TEM_ITEM,
          CAST(CASE WHEN (PAR.CODCLI = LPAD('0', 6, ' ')) THEN 'F' -- Documento entre filiais pode no gerar financeiro. Ex. Nota de Transferncia
                    WHEN COM.NOTESP = 'T' AND COM.TIPNOT = 'N' THEN 'F' -- NF  (nota fiscal), no vai gerar compromisso financeiro
                    WHEN COM.NOTESP = 'T' AND COM.TIPNOT = 'F' THEN 'T' -- F   (fatura), gerar compromisso financeiro
                    WHEN COM.NOTESP = 'T' AND COM.TIPNOT = 'A' THEN 'T' -- NFF (nota fiscal fatura), gerar compromisso financeiro
                    ELSE 'T'
               END AS CHAR(1)) AS TEM_PARCELA,
          CAST('F' AS CHAR(1)) AS TEM_LIQUIDACAO,
          CAST(CASE WHEN (PAR.CODCLI = LPAD('0', 6, ' ')) THEN 'F' -- Documento entre filiais pode no gerar movimentao contbil. Ex. Nota de Transferncia
                    WHEN (COM.TIPNOT <> 'F') AND (LeParametroTXT('TIPO_EXP_EME4', COM.CODFIL, '', '', '') = 'C') THEN 'T' 
                    ELSE 'F' 
               END AS CHAR(1)) AS TEM_MOVCONTABIL,
          CAST(CASE WHEN (PAR.CODCLI = LPAD('0', 6, ' ')) THEN 'F' -- Documento entre filiais pode no gerar centro de custo. Ex. Nota de Transferncia
                    WHEN (COM.TIPNOT <> 'F') AND (LeParametroTXT('TIPO_EXP_EME4', COM.CODFIL, '', '', '') = 'C') THEN 'T' 
                    ELSE 'F' 
               END AS CHAR(1)) AS TEM_CCUSTOCONTABIL,
          CAST(CASE WHEN (COM.TIPNOT <> 'F') AND (COM.TIPPAR = 'T') THEN 'T' -- Frete
                    ELSE 'F'
               END AS CHAR(1)) AS TEM_FRETE,
          CAST('F' AS CHAR(1)) AS TEM_OPERACAOFINANCEIRA,
          CAST(CASE WHEN (COM.TIPNOT = 'F') OR (PAR.CODCLI = LPAD('0', 6, ' ')) THEN 'F' -- Documento entre filiais pode no gerar centro de custo. Ex. Nota de Transferncia
                    ELSE 'T' 
               END AS CHAR(1)) AS TEM_CONTAFINANCEIRA,
          CAST(CASE WHEN (COM.TIPNOT = 'F') OR (PAR.CODCLI = LPAD('0', 6, ' ')) THEN 'F' -- Documento entre filiais pode no gerar centro de custo. Ex. Nota de Transferncia
                    ELSE 'T' 
               END AS CHAR(1)) AS TEM_CCUSTOFINANCEIRO,
          CAST('COM' || COM.CODFIL || COM.SEQUEN AS VARCHAR(50)) AS CHAVE,
          COM.VLRNOT AS VLRNOT_VALIDACAO, 
          (COM.VLRLIQ + COALESCE(COM.DESPAR,0) - 
             ( CASE WHEN COM.FLGPIS = 'T' THEN COALESCE(COM.VLRPIS,0) ELSE 0 END +
               CASE WHEN COM.FLGCOF = 'T' THEN COALESCE(COM.VLRCOF,0) ELSE 0 END +
               CASE WHEN COM.RETCSS = 'T' THEN COALESCE(COM.VLRCSS,0) ELSE 0 END +
               CASE WHEN COM.RETIRR = 'T' THEN COALESCE(COM.VLRIRR,0) ELSE 0 END +
               CASE WHEN COM.FLGICM = 'T' THEN COALESCE(COM.VLRICM,0) ELSE 0 END +
               CASE WHEN COM.FLGISS = 'T' THEN COALESCE(COM.VLRISS,0) ELSE 0 END +
               CASE WHEN COM.FLGINS = 'T' THEN COALESCE(COM.VLRINS,0) ELSE 0 END )) AS VLRLIQ_VALIDACAO,
          COALESCE(COM.DATINC, COM.DATOPE) AS DATINC, 
          COM.ATU_EM, 
          COM.EXPORT,
          COM.EXPEM4,
          COM.FLGEST,
          COALESCE(COM.DATINC, COM.DATOPE) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
          COALESCE(PAR.NUMDOC, VIN.NUMDOC) AS NUMDOC,
          COALESCE(COM.DATINC, COM.DATOPE) AS DATAFILTRO,
          DCFO.EXTCFO,
          CAST(TO_NUMBER(COM.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
          CAST(TO_NUMBER(                         NULLIF(regexp_replace(DCFO.EXTCFO, '[^0-9]', '', 'gi'), '')) AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
          CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                   ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                       THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                 ELSE SUBSTR(TO_CHAR(CAST(                                                                          NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                            END
                                       ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                 ELSE SUBSTR(TO_CHAR(CAST(                                                                          NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                            END
                                  END)
              END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
          CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
          CAST(CASE WHEN EXISTS(SELECT 1 AS OK 
                                  FROM TT_REL REL 
                                 WHERE REL.FILPAR = COM.FILFOR 
                                   AND REL.CODPAR = COM.CODFOR 
                                   AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                    ELSE 'C' 
               END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
          CAST('2' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
          CAST(CASE WHEN ISNOTNULL(FIS.SEREXP)='T' THEN LPAD(TRIM(FIS.SEREXP), 3, '0')||CASE WHEN COM.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(FIS.SUBEXP),'0'), 2, '0') END
                    ELSE LPAD(TRIM(COM.CODSER), 2, '0')||CASE WHEN COM.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(COM.SUBSER),'0'), 3, '0') END
               END AS VARCHAR(5)) AS Serie, -- Srie do Documento
          CAST(TO_CHAR(TO_NUMBER(TRIM(COM.NUMNOT))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
          CAST(TRUNC(COM.DATOPE) AS Timestamp) AS DataEntrada, -- Data de Entrada
          CAST(TRUNC(COM.DATCMP) AS Timestamp) AS DataSaida, -- Data de Sada
          CAST(TRUNC(COM.DATOPE) AS Timestamp) AS DataEntSai, -- Data de Entrada ou Sada
          CAST(TRUNC(COM.DATCMP) AS Timestamp) AS DataEmissao, -- Data de Emisso
          CAST(ABS(COM.VLRLIQ) - ABS(COALESCE(COM.OUTTAX,0)) + CASE WHEN COALESCE(COM.DESCON,0) < 0 THEN ABS(COM.DESCON) ELSE 0 END AS Numeric(15,2)) AS ValorContabil, -- Valor Contbil Original do Documento (Tesouraria)
          CAST(CASE WHEN COALESCE(COM.DESCON,0) < 0 THEN ABS(COM.DESCON) ELSE 0 END AS Numeric(15,2)) AS ValorDescontos, -- Valor Desconto dos Produtos
          CAST(ABS(COM.OUTTAX) AS Numeric(15,2)) AS ValorOutrasDespesas, -- Valor Outras Despesas dos Produtos
          CAST(NULL AS Numeric(15,2)) AS ValorDescontosServ, -- Valor Desconto dos Servios
          CAST(NULL AS Numeric(15,2)) AS ValorOutrasDespesasServ, -- Valor Outras Despesas dos Servios
          CAST(NULL AS VARCHAR(1)) AS SituacaoNFE, -- {3=Autorizada;5=Cancelada;7=Inutilizada;8=Substituida;9=Denegada;A=Contingncia}
          CAST(CASE WHEN (COM.FLGEST = 'D') THEN '1'
                    ELSE '0'
               END AS VARCHAR(1)) AS SituacaoDOC, -- {0=Normal;1=Cancelada;2=Devoluo Parcial;3=Devoluo Total;4=Crdito Bloqueado;5=Inadimplncia;6=Cred. Bloq/Inad.;7=Bloqueio nos Itens;8=Faturado;A=Bloq. Val. Parcela;B=Bloq. Val. Min. Venda}
          CAST(NULL AS VARCHAR(50)) AS ObsFiscal, -- Observao Fiscal do Documento
          CAST(RTF2TXT(COM.OBSERV) AS VARCHAR(150)) AS Observacoes, -- Observaes da Nota
          CAST(RTF2TXT(COM.OBSERV) AS VARCHAR(4000)) AS InfoComplementares, -- Informaes Complementares da Nota
          CAST(NULL AS VARCHAR(4000)) AS TextoFiscal, -- Texto Fiscal do Documento
          CAST(NULL AS VARCHAR(200)) AS NumPedCliente, -- Nmero do Pedido no Cliente
          CAST(NULL AS VARCHAR(100)) AS NumPedRepresentante, -- Nmero do Pedido no Representante
          CAST(NULL AS VARCHAR(1)) AS IndNaturezaFrete, -- {0=Operaes de vendas, com nus suportado pelo estabelecimento vendedor;1=Operaes de vendas, com nus suportado pelo adquirente;2=Operaes de compras (bens para revenda, matrias prima e outros produtos, geradores de crdito);3=Operaes de compras (bens para revenda, matrias prima e outros produtos, no geradores de crdito);4=Transferncia de produtos acabados entre estabelecimentos da pessoa jurdica;5=Transferncia de produtos entre estabelecimentos da pessoa jurdica;9=Outras}
          CAST(COM.CHAVEA AS VARCHAR(60)) AS ChaveNFE, -- Chave NFE
          CAST(NULL AS VARCHAR(60)) AS ChaveNFERefer, -- Chave NFE Referenciada
          -- Pedro E. Braga - Conforme reunio no ser exportado a informao nesse momento
          --CAST(CTA.CODEXT VARCHAR(20)) AS CodContaTes, -- Cdigo da Conta Tesouraria
          CAST(NULL AS VARCHAR(20)) AS CodContaTes, -- Cdigo da Conta Tesouraria
          -- Justificativa utilizada em Testes de Integrao pela EME4
          CAST('Compra - CFOP: '||DCFO.CODCFO||' '||DCFO.DESCFO||' - Chave: '||COM.CODFIL||'/'||COM.SEQUEN AS VARCHAR(200)) AS Justificativa, -- Justificativa do documento Contbil
          --CAST(NULL AS VARCHAR(200)) AS Justificativa, -- Justificativa do documento Contbil
          CAST(CASE WHEN COM.TIPFRE = '1' THEN 'F'
                    WHEN COM.TIPFRE = '2' THEN 'T'
                    WHEN COM.TIPFRE = '0' THEN 'A'
                    ELSE 'B'
               END AS VARCHAR(1)) AS TipoFrete, -- {F=Por conta do emitente;T=Por conta do destinatrio;A=Por conta de terceiros;B=Sem frete}
          CAST(NULL AS Numeric(9)) AS CodTransportadora, -- Cdigo da Transportadora do Documento
          CAST(NULL AS VARCHAR(18)) AS CpfCnpjTransportadora, -- CPF ou CNPJ da Transportadora do Documento
          CAST(NULL AS VARCHAR(10)) AS PlacaVeiculo, -- Placa do Veculo de Entrega
          CAST(NULL AS Numeric(9)) AS CodTranspRedespacho, -- Cdigo da Transportadora de Redespacho do Documento
          CAST(NULL AS VARCHAR(18)) AS CpfCnpjTranspRedespacho, -- CPF ou CNPJ da Transportadora de Redespacho do Documento
          CAST(FIS.MODNOT AS VARCHAR(2)) AS CodigoModelo, -- Cdigo do Modelo de Documento (01 ou 65)
          CAST(TRIM(ENDENT.ENDERE) AS VARCHAR(120)) AS LogradouroEnt, -- Logradouro do Endereo de Entrega
          CAST(SUBSTR(TO_CHAR(CAST(                                   NULLIF(regexp_replace(ENDENT.NUMERO, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 10) AS Numeric(10)) AS NumeroEnt, -- Nmero do Endereo de Entrega
          CAST(TRIM(ENDENT.COMPLE) AS VARCHAR(30)) AS ComplementoEnt, -- Complemento do Endereo de Entrega
          CAST(CASE WHEN DPAIENT.CODPAI = 1058 THEN LPAD(COALESCE(TRIM(ENDENT.CODCEP), '0'), 5, '0')||LPAD(COALESCE(TRIM(ENDENT.CODLOG), '0'), 3, '0') ELSE NULL END AS VARCHAR(10)) AS CEPEnt, -- CEP do Endereo de Entrega
          CAST(TRIM(ENDENT.BAIRRO) AS VARCHAR(80)) AS BairroEnt, -- Bairro do Endereo de Entrega
          CAST(CASE WHEN DPAIENT.CODPAI = 1058 THEN IBGENT.CODIBG ELSE NULL END AS Numeric(10)) AS CodMunicipioIBGEEnt, -- GeoCodigo do M3 - caso esteja informado dever importar o vnculo do municpio por este cdigo (Endereo)
          -- A Pedido da EME4 no ser exportado os dados da Cidade/Estado/Pais
          CAST(TRIM(CASE WHEN DPAIENT.CODPAI = 1058 THEN NULL /*IBGENT.NOMMUN*/ ELSE ENDENT.NOMCID END) AS VARCHAR(100)) AS CidadeEndEnt, -- Cidade do Endereo de Entrega
          CAST(TRIM(CASE WHEN DPAIENT.CODPAI = 1058 THEN NULL /*IBGENT.SIGEST*/ ELSE NULL END) AS VARCHAR(2)) AS EstadoEnt, -- Estado do Endereo de Entrega
          CAST(DPAIENT.CODPAI AS Numeric(9)) AS CodigoPaisEnt, -- Codigo do Banco Central para o Pais da Cidade de Entrega
          CAST(TRIM(CASE WHEN DPAIENT.CODPAI = 1058 THEN NULL /*DPAIENT.DESPAI*/ ELSE DPAIENT.DESPAI END) AS VARCHAR(80)) AS PaisEnt, -- Nome do Pais do Endereo de Entrega
          CAST(ABS(COM.VLRFRE) AS Numeric(15,2)) AS ValorFrete, -- Valor do Frete
          CAST(NULL AS Numeric(15,2)) AS ValorFreteTerceiros, -- Valor do Frete Terceiros
          CAST(NULL AS Numeric(15,2)) AS ICMSFreteTerceiros, -- Valor ICMS do Frete Terceiros
          CAST(NULL AS Numeric(15,2)) AS DifaFreteTerceiros, -- Valor DIFA do Frete Terceiros
          CAST(NULL AS Numeric(15,2)) AS ValorSeguro, -- Valor do Seguro
          CAST(CASE WHEN COALESCE(COM.DESCON,0) > 0 THEN ABS(COM.DESCON) 
                    ELSE 0 
               END AS Numeric(15,2)) AS ValorAcrescimos, -- Valor Acrescimos
          -- Valores relativo a Nota de Importao
          CAST(NULL AS Numeric(15,2)) AS ValorTHC, -- Valor THC
          CAST(NULL AS Numeric(15,2)) AS ValorAFRMM, -- Valor AFRMM
          CAST(NULL AS Numeric(15,2)) AS ValorDemurrage, -- Valor Demurrage
          CAST(NULL AS Numeric(15,2)) AS ValorDesestiva, -- Valro Desestiva
          CAST(NULL AS Numeric(15,2)) AS ValorDesembaraco, -- Valor Desembarao
          CAST(NULL AS Numeric(15,2)) AS ValorSiscomex, -- Valor Siscomex
          CAST(NULL AS Numeric(15,2)) AS ValorPISImport, -- Valro PIS Importao
          CAST(NULL AS Numeric(15,2)) AS ValorCofinsImport, -- Valro Cofins Importao
          CAST(NULL AS Numeric(15,2)) AS ValorDespAduaneira, -- Valor Despesa Aduaneira
          CAST(DMOE.DESMOE AS VARCHAR(10)) AS SimboloMoeda, -- Smbolo da Moeda
          CAST(CAM.VLRREF AS Numeric(15,4)) AS ValorCotacaoMoeda, -- Valor Cotao Moeda
          CAST(TRUNC(CAM.DATREF) AS Timestamp) AS DataCotacaoMoeda, -- Data Cotao Moeda
          CAST(NULL AS VARCHAR(18)) AS CPFCNPJRepresentante, -- CPF ou CNPJ do Representante
          CAST(NULL AS Numeric(8)) AS COO, -- COO Cupom
          CAST(NULL AS Numeric(8)) AS NroECF, -- Nmero do ECF
          CAST(NULL AS VARCHAR(50)) AS NroSerieECF, -- Nmero de rie do ECF
          CAST(NULL AS VARCHAR(20)) AS ModeloECF, -- Modelo do ECF
          CAST(NULL AS VARCHAR(20)) AS MarcaECF, -- Marca do ECF
          CAST(NULL AS VARCHAR(18)) as CPFCNPJCupom -- CPF ou CNPJ do cliente no identificado no cupom
     FROM TT_COM COM
     -- Srie de Emisso
     LEFT JOIN (SELECT DISTINCT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT, ORIGEM
                  FROM TT_FIS
                 WHERE ORIGEM IN ('C','F')) FIS ON FIS.CODSER = COM.CODSER AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$') AND FIS.ORIGEM = CASE WHEN COALESCE(COM.TIPPAR,'F') = 'T' THEN 'F' ELSE 'C' END
     -- Natureza
     LEFT JOIN TD_CFO DCFO ON DCFO.CODTAB = COM.CODCFO
     -- Conta
     LEFT JOIN TT_CTA CTA ON CTA.CODFIL = COM.FILCTA AND CTA.SEQUEN = COM.SEQCTA AND CTA.TIPCTA = COM.TIPCTA
     -- Fornecedor
     JOIN TT_CLI PAR ON PAR.FILCLI = COM.FILFOR AND PAR.CODCLI = COM.CODFOR
     --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.FILEND
     -- Endereo de Faturamento
     LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = COM.FILFOR AND ENDFAT.CODCLI = COM.CODFOR AND ENDFAT.CODFIL = COM.FILEND AND ENDFAT.NUMEND = COM.NUMEND
     -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
     LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
     -- Endereo de Entrega
     JOIN TT_CLI FIL ON FIL.FILCLI = COM.CODFIL AND FIL.CODCLI = LPAD('0', 6, ' ')
     LEFT JOIN TT_END ENDENT ON ENDENT.FILCLI = FIL.FILCLI AND ENDENT.CODCLI = FIL.CODCLI AND ENDENT.CODFIL = FIL.FILEND AND ENDENT.NUMEND = FIL.NUMEND
     LEFT JOIN TT_MUN MUNENT ON MUNENT.CODIGO = ENDENT.CODCID
     LEFT JOIN TT_IBG IBGENT ON IBGENT.CODIBG = COALESCE(ENDENT.CODIBG, MUNENT.CODIBG)
     LEFT JOIN TD_PAI DPAIENT ON DPAIENT.CODPAI = ENDENT.CODPAI
     -- Moeda
     LEFT JOIN TD_MOE DMOE ON DMOE.CODTAB = COM.CODMOE
     LEFT JOIN ( SELECT LCAM.CODMOE, MAX(LCAM.DATREF) AS DATREF, MAX(LCAM.VLRREF) AS VLRREF 
                   FROM TT_CAM LCAM
                  GROUP BY LCAM.CODMOE ) CAM ON CAM.CODMOE = DMOE.CODTAB AND CAM.DATREF = COM.DATOPE
     -- Transferncia
     --LEFT JOIN TT_TRA TRA ON CMP.CODFIL = TRA.FILICO AND CMP.SEQUEN = TRA.SEQICO
    WHERE COM.NUMNOT NOT LIKE '%#%'
      AND COM.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',COM.CODFIL,'','','')
      AND ((COM.FLGEST <> 'D') OR ((COM.FLGEST = 'D') AND (COM.EXPEM4 = 'T')))
      AND ((COM.EXPEM4 = 'F') OR (COM.EXPORT = 'F'))
   ) TAB
   ;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Tributao do Cliente" (Tabela Integrao Mult)
/*-- SEQ 2684 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_PARAMTRIBCLI CASCADE;

/*-- SEQ 2685 --*/
CREATE OR REPLACE VIEW TV_TIMU_PARAMTRIBCLI AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST('X' AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.FILCLI, TAB.CODCLI, TAB.ATU_EM, TAB.DATINC,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.CodigoCliente, -- Cdigo do Cliente
      TAB.CpfCnpjCliente, -- CPF ou CNPJ do Cliente
      TAB.DataInicioVigencia, -- Data de incio de vigncia da tributao
      TAB.PercRedICMS, -- Percentual de Reduo ICMS
      TAB.PercRedICMSZerado, -- ICMS no tem Percentual de Reduo
      TAB.OptanteSimplesFederal, -- Cliente  optante do Simples Federal
      TAB.ContribuinteICMS, -- Cliente  Contribuinte
      TAB.ConsumidorFinal, -- Cliente  Consumidor Final
      TAB.AntecipaAliquotaICMS, -- Cliente Antecipa Alquota ICMS
      TAB.CalcularRepasse, -- Calcular Repasse?
      TAB.PercRedMargem, -- Percentual de Reduo de Margem ST
      TAB.MargemLucro, -- Percentual de Margem de Lucro ST
      TAB.AbateDescontoBase, -- Abate Desconto da Base de Clculo?
      TAB.AliquotaInternaRegimeEspecial, -- Alquota Interna Regime Especial
      TAB.TemSubstituicaoTributaria, -- Cliente tem substituio tributria?
      TAB.RecolhimentoISS, -- 0=Normal,1=Substituto,2=Isento
      TAB.MotivoIsencaoISS, -- Motivo de Iseno do ISS
      TAB.AliquotaISS, -- Alquota do ISS
      TAB.PercentualReducaoISS, -- Percentual de Reduo do ISS
      TAB.RetemPISServico, -- T/F
      TAB.RetemCOFINSServico, -- T/F
      TAB.RetemCSLLServico, -- T/F
      TAB.RetemIRRFServico, -- T/F
      TAB.RetemINSSServico, -- T/F
      TAB.DescontoObrigatorioRedICMS, -- Desconto Obrigatrio da Reduo de ICMS
      TAB.InscricaoSuframa, -- Nmero de Inscrio no Suframa
      TAB.TemInscricaoSuframa, -- T/F
      TAB.TipoDescontoSuframa, -- 0=ICMS, PIS e COFINS,1=ICMS,2=NO TEM DESCONTO,3=PIS e COFINS,
      TAB.CodClassifTribVenda, -- Classificao Tributria na Venda (00, 10, 20, 30, 40, 41, 50, 51, 60, 70, 90)
      TAB.IPIIsento, -- Cliente Isento de IPI
      TAB.CodCFOPVenda, -- CFOP - Cdigo Fiscal de Operao na Venda
      TAB.TemTIPIEspecial, -- T/F
      TAB.RetemPISProduto, -- T/F
      TAB.RetemCOFINSProduto, -- T/F
      TAB.RetemCSLLProduto, -- T/F
      TAB.RetemIRRFProduto, -- T/F
      TAB.PercRedINSS, -- Percentual de Reduo do INSS
      TAB.PisIsento, -- T/F
      TAB.CofinsIsento, -- T/F
      TAB.IndicadorNaturezaRetencao, -- 1=Reteno por rgos, Autarquias e Fund. Federais,2=Reteno por outras Ent. Adm.Pb.Fed.,3=Reteno por Pessoas Jurdicas de Direito Privado,4=Recolhimento por Sociedade Coperativa,5=Reteno por Fabricante de Mquinas e Veculos,9=Outras Retenes,
      TAB.RetemSESTSENAT, -- T/F
      TAB.ClassificacaoTribIPIIsento, -- I=51 - Sada tributada com alquota zero, J=52 - Sada isenta,L=53 - Sada no-tributada,M=54 - Sada imune,N=55 - Sada com suspenso,O=99 - Outras sadas,
      TAB.PercReducaoIPI, -- Percentual de Reduo do IPI
      TAB.PercReducaoPIS, -- Percentual de Reduo do PIS
      TAB.PercRedCOFINS, -- Percentual de Reduo do COFINS
      TAB.ClassifTribPISIsento, -- D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,J=49 - Outras Operaes de Sada,Z=99 - Outras Operaes
      TAB.ClassifTribCOFINSIsento, -- D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,J=49 - Outras Operaes de Sada,Z=99 - Outras Operaes
      TAB.CodigoTabelaOpSpedPis, -- Cdigo da Tabela de Operao do SPED para o PIS
      TAB.CodigoTabelaOpSpedCofins, -- Cdigo da Tabela de Operao do SPED para o COFINS
      TAB.NaoRetemISS, -- T/F
      TAB.ClienteProEmprego, -- T/F
      TAB.CNAE, -- CNAE
      TAB.TipoMovimentacaoProduto -- Descrio do Tipo de Movimentao Produto
     FROM ( 
   SELECT PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS ATU_EM, PAR.DATOPE AS DATINC,
          GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
          CAST(TO_NUMBER(CASE WHEN (ISNULL(PAR.NUMDOC)='T') AND (ISNULL(PAR.CODEXT)='T') THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                              ELSE SUBSTR(TO_CHAR(CAST(                                                       NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                          END) AS Numeric(9)) AS CodigoCliente, -- Cdigo do Cliente
          CAST(TRIM(PAR.NUMDOC) AS VARCHAR(18)) AS CpfCnpjCliente, -- CPF ou CNPJ do Cliente
          TRUNC(COALESCE(PAR.DATA01, PAR.DATOPE)) AS DataInicioVigencia, -- Data de incio de vigncia da tributao
          CAST(NULL AS Numeric(8,4)) AS PercRedICMS, -- Percentual de Reduo ICMS
          CAST('F' AS VARCHAR(1)) AS PercRedICMSZerado, -- ICMS no tem Percentual de Reduo
          CAST(PAR.SIMPLE AS VARCHAR(1)) AS OptanteSimplesFederal, -- Cliente  optante do Simples Federal
          CAST(CASE WHEN PAR.ISENTO = 'F' THEN 'T' ELSE 'F' END AS VARCHAR(1)) AS ContribuinteICMS, -- Cliente  Contribuinte
          CAST(CASE WHEN PAR.ISENTO = 'T' THEN 'T' ELSE 'F' END AS VARCHAR(1)) AS ConsumidorFinal, -- Cliente  Consumidor Final
          CAST('F' AS VARCHAR(1)) AS AntecipaAliquotaICMS, -- Cliente Antecipa Alquota ICMS
          CAST('F' AS VARCHAR(1)) AS CalcularRepasse, -- Calcular Repasse?
          CAST(NULL AS Numeric(8,4)) AS PercRedMargem, -- Percentual de Reduo de Margem ST
          CAST(NULL AS Numeric(8,4)) AS MargemLucro, -- Percentual de Margem de Lucro ST
          CAST('F' AS VARCHAR(1)) AS AbateDescontoBase, -- Abate Desconto da Base de Clculo?
          CAST(NULL AS Numeric(8,4)) AS AliquotaInternaRegimeEspecial, -- Alquota Interna Regime Especial
          CAST('F' AS VARCHAR(1)) AS TemSubstituicaoTributaria, -- Cliente tem substituio tributria?
          CAST(NULL AS VARCHAR(1)) AS RecolhimentoISS, -- 0=Normal,1=Substituto,2=Isento
          CAST(NULL AS VARCHAR(80)) AS MotivoIsencaoISS, -- Motivo de Iseno do ISS
          CAST(NULL AS Numeric(8,4)) AS AliquotaISS, -- Alquota do ISS
          CAST(NULL AS Numeric(8,4)) AS PercentualReducaoISS, -- Percentual de Reduo do ISS
          CAST('F' AS VARCHAR(1)) AS RetemPISServico, -- T/F
          CAST('F' AS VARCHAR(1)) AS RetemCOFINSServico, -- T/F
          CAST('F' AS VARCHAR(1)) AS RetemCSLLServico, -- T/F
          CAST('F' AS VARCHAR(1)) AS RetemIRRFServico, -- T/F
          CAST('F' AS VARCHAR(1)) AS RetemINSSServico, -- T/F
          CAST(NULL AS Numeric(8,4)) AS DescontoObrigatorioRedICMS, -- Desconto Obrigatrio da Reduo de ICMS
          CAST(PAR.SUFRAM AS VARCHAR(30)) AS InscricaoSuframa, -- Nmero de Inscrio no Suframa
          CAST(CASE WHEN ISNOTNULL(PAR.SUFRAM)='T' THEN 'T' ELSE 'F' END AS VARCHAR(1)) AS TemInscricaoSuframa, -- T/F
          CAST(NULL AS Numeric(1)) AS TipoDescontoSuframa, -- 0=ICMS, PIS e COFINS,1=ICMS,2=NO TEM DESCONTO,3=PIS e COFINS,
          CAST(NULL AS VARCHAR(2)) AS CodClassifTribVenda, -- Classificao Tributria na Venda (00, 10, 20, 30, 40, 41, 50, 51, 60, 70, 90)
          CAST('F' AS VARCHAR(1)) AS IPIIsento, -- Cliente Isento de IPI
          CAST(NULL AS VARCHAR(20)) AS CodCFOPVenda, -- CFOP - Cdigo Fiscal de Operao na Venda
          CAST('F' AS VARCHAR(1)) AS TemTIPIEspecial, -- T/F
          CAST('F' AS VARCHAR(1)) AS RetemPISProduto, -- T/F
          CAST('F' AS VARCHAR(1)) AS RetemCOFINSProduto, -- T/F
          CAST('F' AS VARCHAR(1)) AS RetemCSLLProduto, -- T/F
          CAST('F' AS VARCHAR(1)) AS RetemIRRFProduto, -- T/F
          CAST(NULL AS Numeric(8,4)) AS PercRedINSS, -- Percentual de Reduo do INSS
          CAST('F' AS VARCHAR(1)) AS PisIsento, -- T/F
          CAST('F' AS VARCHAR(1)) AS CofinsIsento, -- T/F
          CAST(NULL AS VARCHAR(1)) AS IndicadorNaturezaRetencao, -- 1=Reteno por rgos, Autarquias e Fund. Federais,2=Reteno por outras Ent. Adm.Pb.Fed.,3=Reteno por Pessoas Jurdicas de Direito Privado,4=Recolhimento por Sociedade Coperativa,5=Reteno por Fabricante de Mquinas e Veculos,9=Outras Retenes,
          CAST('F' AS VARCHAR(1)) AS RetemSESTSENAT, -- T/F
          CAST(NULL AS VARCHAR(1)) AS ClassificacaoTribIPIIsento, -- I=51 - Sada tributada com alquota zero, J=52 - Sada isenta,L=53 - Sada no-tributada,M=54 - Sada imune,N=55 - Sada com suspenso,O=99 - Outras sadas,
          CAST(NULL AS Numeric(8,4)) AS PercReducaoIPI, -- Percentual de Reduo do IPI
          CAST(NULL AS Numeric(8,4)) AS PercReducaoPIS, -- Percentual de Reduo do PIS
          CAST(NULL AS Numeric(8,4)) AS PercRedCOFINS, -- Percentual de Reduo do COFINS
          CAST(NULL AS VARCHAR(1)) AS ClassifTribPISIsento, -- D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,J=49 - Outras Operaes de Sada,Z=99 - Outras Operaes
          CAST(NULL AS VARCHAR(1)) AS ClassifTribCOFINSIsento, -- D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,J=49 - Outras Operaes de Sada,Z=99 - Outras Operaes
          CAST(NULL AS Numeric(9)) AS CodigoTabelaOpSpedPis, -- Cdigo da Tabela de Operao do SPED para o PIS
          CAST(NULL AS Numeric(9)) AS CodigoTabelaOpSpedCofins, -- Cdigo da Tabela de Operao do SPED para o COFINS
          CAST('F' AS VARCHAR(1)) AS NaoRetemISS, -- T/F
          CAST('F' AS VARCHAR(1)) AS ClienteProEmprego, -- T/F
          CAST(PAR.CODNAE AS VARCHAR(20)) AS CNAE, -- CNAE
          CAST(CASE WHEN PAR.SIGNAT>=0 THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situao do Cliente T/F
          CAST(NULL AS VARCHAR(50)) AS TipoMovimentacaoProduto -- Descrio do Tipo de Movimentao Produto
     FROM TT_CLI PAR
     --LEFT JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
     -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
     --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
      AND COALESCE(PAR.INDEXP, 'E') <> 'N'
    UNION ALL 
    SELECT PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS ATU_EM, PAR.DATOPE AS DATINC,
          GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
          CAST(NULL AS Numeric(9)) AS CodigoCliente, -- Cdigo do Cliente
          CAST(TRIM(ENDE.NUMDOC) AS VARCHAR(18)) AS CpfCnpjCliente, -- CPF ou CNPJ do Cliente
          TRUNC(COALESCE(PAR.DATA01, PAR.DATOPE)) AS DataInicioVigencia, -- Data de incio de vigncia da tributao
          CAST(NULL AS Numeric(8,4)) AS PercRedICMS, -- Percentual de Reduo ICMS
          CAST('F' AS VARCHAR(1)) AS PercRedICMSZerado, -- ICMS no tem Percentual de Reduo
          CAST(PAR.SIMPLE AS VARCHAR(1)) AS OptanteSimplesFederal, -- Cliente  optante do Simples Federal
          CAST(CASE WHEN PAR.ISENTO = 'F' THEN 'T' ELSE 'F' END AS VARCHAR(1)) AS ContribuinteICMS, -- Cliente  Contribuinte
          CAST(CASE WHEN PAR.ISENTO = 'T' THEN 'T' ELSE 'F' END AS VARCHAR(1)) AS ConsumidorFinal, -- Cliente  Consumidor Final
          CAST('F' AS VARCHAR(1)) AS AntecipaAliquotaICMS, -- Cliente Antecipa Alquota ICMS
          CAST('F' AS VARCHAR(1)) AS CalcularRepasse, -- Calcular Repasse?
          CAST(NULL AS Numeric(8,4)) AS PercRedMargem, -- Percentual de Reduo de Margem ST
          CAST(NULL AS Numeric(8,4)) AS MargemLucro, -- Percentual de Margem de Lucro ST
          CAST('F' AS VARCHAR(1)) AS AbateDescontoBase, -- Abate Desconto da Base de Clculo?
          CAST(NULL AS Numeric(8,4)) AS AliquotaInternaRegimeEspecial, -- Alquota Interna Regime Especial
          CAST('F' AS VARCHAR(1)) AS TemSubstituicaoTributaria, -- Cliente tem substituio tributria?
          CAST(NULL AS VARCHAR(1)) AS RecolhimentoISS, -- 0=Normal,1=Substituto,2=Isento
          CAST(NULL AS VARCHAR(80)) AS MotivoIsencaoISS, -- Motivo de Iseno do ISS
          CAST(NULL AS Numeric(8,4)) AS AliquotaISS, -- Alquota do ISS
          CAST(NULL AS Numeric(8,4)) AS PercentualReducaoISS, -- Percentual de Reduo do ISS
          CAST('F' AS VARCHAR(1)) AS RetemPISServico, -- T/F
          CAST('F' AS VARCHAR(1)) AS RetemCOFINSServico, -- T/F
          CAST('F' AS VARCHAR(1)) AS RetemCSLLServico, -- T/F
          CAST('F' AS VARCHAR(1)) AS RetemIRRFServico, -- T/F
          CAST('F' AS VARCHAR(1)) AS RetemINSSServico, -- T/F
          CAST(NULL AS Numeric(8,4)) AS DescontoObrigatorioRedICMS, -- Desconto Obrigatrio da Reduo de ICMS
          CAST(PAR.SUFRAM AS VARCHAR(30)) AS InscricaoSuframa, -- Nmero de Inscrio no Suframa
          CAST(CASE WHEN ISNOTNULL(PAR.SUFRAM)='T' THEN 'T' ELSE 'F' END AS VARCHAR(1)) AS TemInscricaoSuframa, -- T/F
          CAST(NULL AS Numeric(1)) AS TipoDescontoSuframa, -- 0=ICMS, PIS e COFINS,1=ICMS,2=NO TEM DESCONTO,3=PIS e COFINS,
          CAST(NULL AS VARCHAR(2)) AS CodClassifTribVenda, -- Classificao Tributria na Venda (00, 10, 20, 30, 40, 41, 50, 51, 60, 70, 90)
          CAST('F' AS VARCHAR(1)) AS IPIIsento, -- Cliente Isento de IPI
          CAST(NULL AS VARCHAR(20)) AS CodCFOPVenda, -- CFOP - Cdigo Fiscal de Operao na Venda
          CAST('F' AS VARCHAR(1)) AS TemTIPIEspecial, -- T/F
          CAST('F' AS VARCHAR(1)) AS RetemPISProduto, -- T/F
          CAST('F' AS VARCHAR(1)) AS RetemCOFINSProduto, -- T/F
          CAST('F' AS VARCHAR(1)) AS RetemCSLLProduto, -- T/F
          CAST('F' AS VARCHAR(1)) AS RetemIRRFProduto, -- T/F
          CAST(NULL AS Numeric(8,4)) AS PercRedINSS, -- Percentual de Reduo do INSS
          CAST('F' AS VARCHAR(1)) AS PisIsento, -- T/F
          CAST('F' AS VARCHAR(1)) AS CofinsIsento, -- T/F
          CAST(NULL AS VARCHAR(1)) AS IndicadorNaturezaRetencao, -- 1=Reteno por rgos, Autarquias e Fund. Federais,2=Reteno por outras Ent. Adm.Pb.Fed.,3=Reteno por Pessoas Jurdicas de Direito Privado,4=Recolhimento por Sociedade Coperativa,5=Reteno por Fabricante de Mquinas e Veculos,9=Outras Retenes,
          CAST('F' AS VARCHAR(1)) AS RetemSESTSENAT, -- T/F
          CAST(NULL AS VARCHAR(1)) AS ClassificacaoTribIPIIsento, -- I=51 - Sada tributada com alquota zero, J=52 - Sada isenta,L=53 - Sada no-tributada,M=54 - Sada imune,N=55 - Sada com suspenso,O=99 - Outras sadas,
          CAST(NULL AS Numeric(8,4)) AS PercReducaoIPI, -- Percentual de Reduo do IPI
          CAST(NULL AS Numeric(8,4)) AS PercReducaoPIS, -- Percentual de Reduo do PIS
          CAST(NULL AS Numeric(8,4)) AS PercRedCOFINS, -- Percentual de Reduo do COFINS
          CAST(NULL AS VARCHAR(1)) AS ClassifTribPISIsento, -- D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,J=49 - Outras Operaes de Sada,Z=99 - Outras Operaes
          CAST(NULL AS VARCHAR(1)) AS ClassifTribCOFINSIsento, -- D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,J=49 - Outras Operaes de Sada,Z=99 - Outras Operaes
          CAST(NULL AS Numeric(9)) AS CodigoTabelaOpSpedPis, -- Cdigo da Tabela de Operao do SPED para o PIS
          CAST(NULL AS Numeric(9)) AS CodigoTabelaOpSpedCofins, -- Cdigo da Tabela de Operao do SPED para o COFINS
          CAST('F' AS VARCHAR(1)) AS NaoRetemISS, -- T/F
          CAST('F' AS VARCHAR(1)) AS ClienteProEmprego, -- T/F
          CAST(PAR.CODNAE AS VARCHAR(20)) AS CNAE, -- CNAE
          CAST(CASE WHEN PAR.SIGNAT>=0 THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situao do Cliente T/F
          CAST(NULL AS VARCHAR(50)) AS TipoMovimentacaoProduto -- Descrio do Tipo de Movimentao Produto
     FROM TT_CLI PAR
     JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ISNOTNULL(ENDE.NUMDOC) = 'T' AND TRIM(COALESCE(ENDE.NUMDOC, '')) <> TRIM(COALESCE(PAR.NUMDOC, ''))
     -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
     --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
      AND COALESCE(PAR.INDEXP, 'E') <> 'N'
    ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Tributao do Fornecedor" (Tabela Integrao Mult)
/*-- SEQ 2686 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_PARAMTRIBFOR CASCADE;

/*-- SEQ 2687 --*/
CREATE OR REPLACE VIEW TV_TIMU_PARAMTRIBFOR AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST('X' AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.FILCLI, TAB.CODCLI, TAB.ATU_EM, TAB.DATINC,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.CodigoFornecedor, -- Cdigo do Fornecedor
      TAB.CpfCnpjFornec, -- CPF ou CNPJ do Fornecedor
      TAB.DataInicioVigencia, -- Data de incio de vigncia da tributao
      TAB.PercRedICMS, -- Percentual de Reduo ICMS
      TAB.AliquotaPIS, -- Alquota PIS
      TAB.PercRedPIS, -- Percentual de Reduo PIS
      TAB.AliquotaCOFINS, -- Alquota COFINS
      TAB.PercRedCOFINS, -- Percentual de Reduo COFINS
      TAB.RetemPIS, -- T/F
      TAB.RetemCOFINS, -- T/F
      TAB.RetemCSLL, -- T/F
      TAB.TemFatorImportacao, -- T/F
      TAB.FatorImportacao, -- Fator de Importao ICMS
      TAB.AliquotaISS, -- Alquota ISS
      TAB.PercRedISS, -- Percentual de Reduo do ISS
      TAB.RecolhimentoISS, -- 0=Normal,1=Substituto,2=Isento
      TAB.MotivoISSIsencao, -- Motivo da iseno de ISS
      TAB.RetemINSS, -- T/F
      TAB.NaoRecuperaIPI, -- T/F
      TAB.PercRedIRRF, -- Percentual de Reduo do IRRF
      TAB.OptanteSuperSimples, -- T/F
      TAB.CodigoServicoPrestado, -- 
      TAB.NaoContribuinteIPI, -- T/F
      TAB.TipoTributacaoDestacada, -- T=Calcula e no soma total nota,F=Calcula e soma total nota,N=No tem Subst.Trib.
      TAB.PercRedINSS, -- Percentual de Reduo do INSS
      TAB.IndicadorNaturezaRetencao, -- 1=Reteno por rgos, Autarquias e Fund. Federais,2=Reteno por outras Ent. Adm.Pb.Fed.,3=Reteno por Pessoas Jurdicas de Direito Privado,4=Recolhimento por Sociedade Coperativa,5=Reteno por Fabricante de Mquinas e Veculos,9=Outras Retenes,
      TAB.RetemSESTSENAT, -- T/F
      TAB.AliquotaICMSEspecial, -- Alquota ICMS Especial
      TAB.PercCreditoICMSSimplesNacional, -- Percentual de Crdito ICMS Simples Nacional
      TAB.ClassifTributariaIPI, -- A=00 - Entrada com recuperao de crdito,B=01 - Entrada tributada com alquota zero,C=02 - Entrada isenta,D=03 - Entrada no-tributada,E=04 - Entrada imune,F=05 - Entrada com suspenso,G=49 - Outras entradas,H=50 - Sada tributada,I=51 - Sada tributada com alquota zero,J=52 - Sada isenta,L=53 - Sada no-tributada,M=54 - Sada imune,N=55 - Sada com suspenso,O=99 - Outras sadas,
      TAB.ClassifTributariaPIS, -- 	A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
      TAB.ClassifTributariaCOFINS, -- A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
      TAB.CodigoClassifTributariaICMS, -- CST ICMS
      TAB.ApuracaoFiscal, -- 1=Simples Nacional,2=Lucro Presumido,3=Lucro Numeric,
      TAB.DespachanteAduaneiro, -- T/F
      TAB.TipoIPI -- 0=Normal,1=Crdito 50%,2=Isento,3=Outras,4=Observao
      FROM ( 
   SELECT PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS ATU_EM, PAR.DATOPE AS DATINC,
          GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
          CAST(TO_NUMBER(CASE WHEN (ISNULL(PAR.NUMDOC)='T') AND (ISNULL(PAR.CODEXT)='T') THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                              ELSE SUBSTR(TO_CHAR(CAST(                                                       NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                          END) AS Numeric(9)) AS CodigoFornecedor, -- Cdigo do Fornecedor
          CAST(TRIM(PAR.NUMDOC) AS VARCHAR(18)) AS CpfCnpjFornec, -- CPF ou CNPJ do Fornecedor
          TRUNC(COALESCE(PAR.DATA01, PAR.DATOPE)) AS DataInicioVigencia, -- Data de incio de vigncia da tributao
          CAST(NULL AS Numeric(8,4)) AS PercRedICMS, -- Percentual de Reduo ICMS
          CAST(NULL AS Numeric(8,4)) AS AliquotaPIS, -- Alquota PIS
          CAST(NULL AS Numeric(8,4)) AS PercRedPIS, -- Percentual de Reduo PIS
          CAST(NULL AS Numeric(8,4)) AS AliquotaCOFINS, -- Alquota COFINS
          CAST(NULL AS Numeric(8,4)) AS PercRedCOFINS, -- Percentual de Reduo COFINS
          CAST('F' AS VARCHAR(1)) AS RetemPIS, -- T/F
          CAST('F' AS VARCHAR(1)) AS RetemCOFINS, -- T/F
          CAST('F' AS VARCHAR(1)) AS RetemCSLL, -- T/F
          CAST('F' AS VARCHAR(1)) AS TemFatorImportacao, -- T/F
          CAST(NULL AS Numeric(8,4)) AS FatorImportacao, -- Fator de Importao ICMS
          CAST(NULL AS Numeric(8,4)) AS AliquotaISS, -- Alquota ISS
          CAST(NULL AS Numeric(8,4)) AS PercRedISS, -- Percentual de Reduo do ISS
          CAST(NULL AS VARCHAR(1)) AS RecolhimentoISS, -- 0=Normal,1=Substituto,2=Isento
          CAST(NULL AS VARCHAR(80)) AS MotivoISSIsencao, -- Motivo da iseno de ISS
          CAST('F' AS VARCHAR(1)) AS RetemINSS, -- T/F
          CAST('F' AS VARCHAR(1)) AS NaoRecuperaIPI, -- T/F
          CAST(NULL AS Numeric(8,4)) AS PercRedIRRF, -- Percentual de Reduo do IRRF
          CAST(PAR.SIMPLE AS VARCHAR(1)) AS OptanteSuperSimples, -- T/F
          CAST(NULL AS VARCHAR(10)) AS CodigoServicoPrestado, -- 
          CAST('F' AS VARCHAR(1)) AS NaoContribuinteIPI, -- T/F
          CAST(NULL AS VARCHAR(1)) AS TipoTributacaoDestacada, -- T=Calcula e no soma total nota,F=Calcula e soma total nota,N=No tem Subst.Trib.
          CAST(NULL AS Numeric(8,4)) AS PercRedINSS, -- Percentual de Reduo do INSS
          CAST(NULL AS VARCHAR(1)) AS IndicadorNaturezaRetencao, -- 1=Reteno por rgos, Autarquias e Fund. Federais,2=Reteno por outras Ent. Adm.Pb.Fed.,3=Reteno por Pessoas Jurdicas de Direito Privado,4=Recolhimento por Sociedade Coperativa,5=Reteno por Fabricante de Mquinas e Veculos,9=Outras Retenes,
          CAST('F' AS VARCHAR(1)) AS RetemSESTSENAT, -- T/F
          CAST(NULL AS Numeric(8,4)) AS AliquotaICMSEspecial, -- Alquota ICMS Especial
          CAST(NULL AS Numeric(8,4)) AS PercCreditoICMSSimplesNacional, -- Percentual de Crdito ICMS Simples Nacional
          CAST(NULL AS VARCHAR(1)) AS ClassifTributariaIPI, -- A=00 - Entrada com recuperao de crdito,B=01 - Entrada tributada com alquota zero,C=02 - Entrada isenta,D=03 - Entrada no-tributada,E=04 - Entrada imune,F=05 - Entrada com suspenso,G=49 - Outras entradas,H=50 - Sada tributada,I=51 - Sada tributada com alquota zero,J=52 - Sada isenta,L=53 - Sada no-tributada,M=54 - Sada imune,N=55 - Sada com suspenso,O=99 - Outras sadas,
          CAST(NULL AS VARCHAR(1)) AS ClassifTributariaPIS, -- 	A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
          CAST(NULL AS VARCHAR(1)) AS ClassifTributariaCOFINS, -- A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
          CAST(NULL AS VARCHAR(2)) AS CodigoClassifTributariaICMS, -- CST ICMS
          CAST(CASE WHEN PAR.SIMPLE = 'T' THEN '1'
                    WHEN PAR.ISENTO = 'F' THEN '2'
                    ELSE '3'
               END AS VARCHAR(1)) AS ApuracaoFiscal, -- 1=Simples Nacional,2=Lucro Presumido,3=Lucro Numeric,
          CAST('F' AS VARCHAR(1)) AS DespachanteAduaneiro, -- T/F
          CAST(CASE WHEN PAR.SIGNAT>=0 THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situao do Cliente T/F
          CAST(NULL AS VARCHAR(1)) AS TipoIPI -- 0=Normal,1=Crdito 50%,2=Isento,3=Outras,4=Observao
     FROM TT_CLI PAR
     --LEFT JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
     -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
     --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
      AND (PAR.CODCLI <> LPAD('0', 6, ' '))
      AND ( -- A - Cliente Transportadora,F - Fornecedor,M - Marca/Produto,T - Transportador
            EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = PAR.FILCLI AND REL.CODPAR = PAR.CODCLI AND REL.TIPPAR IN ('A','F','M','T'))
            OR
            EXISTS(SELECT 1 AS OK FROM TT_COM COM 
                    WHERE COM.FLGEST <> 'D'
                      AND COM.NUMNOT NOT LIKE '%#%'
                      AND COM.FILFOR = PAR.FILCLI AND COM.CODFOR = PAR.CODCLI
                      AND COM.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',COM.CODFIL,'','','')
                      AND ((COM.EXPEM4 = 'F') OR (COM.EXPORT = 'F')) )
         )
      AND COALESCE(PAR.INDEXP, 'E') <> 'N'
    UNION ALL
    SELECT PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS ATU_EM, PAR.DATOPE AS DATINC,
          GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
          CAST(NULL AS Numeric(9)) AS CodigoFornecedor, -- Cdigo do Fornecedor
          CAST(TRIM(ENDE.NUMDOC) AS VARCHAR(18)) AS CpfCnpjFornec, -- CPF ou CNPJ do Fornecedor
          TRUNC(COALESCE(PAR.DATA01, PAR.DATOPE)) AS DataInicioVigencia, -- Data de incio de vigncia da tributao
          CAST(NULL AS Numeric(8,4)) AS PercRedICMS, -- Percentual de Reduo ICMS
          CAST(NULL AS Numeric(8,4)) AS AliquotaPIS, -- Alquota PIS
          CAST(NULL AS Numeric(8,4)) AS PercRedPIS, -- Percentual de Reduo PIS
          CAST(NULL AS Numeric(8,4)) AS AliquotaCOFINS, -- Alquota COFINS
          CAST(NULL AS Numeric(8,4)) AS PercRedCOFINS, -- Percentual de Reduo COFINS
          CAST('F' AS VARCHAR(1)) AS RetemPIS, -- T/F
          CAST('F' AS VARCHAR(1)) AS RetemCOFINS, -- T/F
          CAST('F' AS VARCHAR(1)) AS RetemCSLL, -- T/F
          CAST('F' AS VARCHAR(1)) AS TemFatorImportacao, -- T/F
          CAST(NULL AS Numeric(8,4)) AS FatorImportacao, -- Fator de Importao ICMS
          CAST(NULL AS Numeric(8,4)) AS AliquotaISS, -- Alquota ISS
          CAST(NULL AS Numeric(8,4)) AS PercRedISS, -- Percentual de Reduo do ISS
          CAST(NULL AS VARCHAR(1)) AS RecolhimentoISS, -- 0=Normal,1=Substituto,2=Isento
          CAST(NULL AS VARCHAR(80)) AS MotivoISSIsencao, -- Motivo da iseno de ISS
          CAST('F' AS VARCHAR(1)) AS RetemINSS, -- T/F
          CAST('F' AS VARCHAR(1)) AS NaoRecuperaIPI, -- T/F
          CAST(NULL AS Numeric(8,4)) AS PercRedIRRF, -- Percentual de Reduo do IRRF
          CAST(PAR.SIMPLE AS VARCHAR(1)) AS OptanteSuperSimples, -- T/F
          CAST(NULL AS VARCHAR(10)) AS CodigoServicoPrestado, -- 
          CAST('F' AS VARCHAR(1)) AS NaoContribuinteIPI, -- T/F
          CAST(NULL AS VARCHAR(1)) AS TipoTributacaoDestacada, -- T=Calcula e no soma total nota,F=Calcula e soma total nota,N=No tem Subst.Trib.
          CAST(NULL AS Numeric(8,4)) AS PercRedINSS, -- Percentual de Reduo do INSS
          CAST(NULL AS VARCHAR(1)) AS IndicadorNaturezaRetencao, -- 1=Reteno por rgos, Autarquias e Fund. Federais,2=Reteno por outras Ent. Adm.Pb.Fed.,3=Reteno por Pessoas Jurdicas de Direito Privado,4=Recolhimento por Sociedade Coperativa,5=Reteno por Fabricante de Mquinas e Veculos,9=Outras Retenes,
          CAST('F' AS VARCHAR(1)) AS RetemSESTSENAT, -- T/F
          CAST(NULL AS Numeric(8,4)) AS AliquotaICMSEspecial, -- Alquota ICMS Especial
          CAST(NULL AS Numeric(8,4)) AS PercCreditoICMSSimplesNacional, -- Percentual de Crdito ICMS Simples Nacional
          CAST(NULL AS VARCHAR(1)) AS ClassifTributariaIPI, -- A=00 - Entrada com recuperao de crdito,B=01 - Entrada tributada com alquota zero,C=02 - Entrada isenta,D=03 - Entrada no-tributada,E=04 - Entrada imune,F=05 - Entrada com suspenso,G=49 - Outras entradas,H=50 - Sada tributada,I=51 - Sada tributada com alquota zero,J=52 - Sada isenta,L=53 - Sada no-tributada,M=54 - Sada imune,N=55 - Sada com suspenso,O=99 - Outras sadas,
          CAST(NULL AS VARCHAR(1)) AS ClassifTributariaPIS, -- 	A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
          CAST(NULL AS VARCHAR(1)) AS ClassifTributariaCOFINS, -- A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
          CAST(NULL AS VARCHAR(2)) AS CodigoClassifTributariaICMS, -- CST ICMS
          CAST(CASE WHEN PAR.SIMPLE = 'T' THEN '1'
                    WHEN PAR.ISENTO = 'F' THEN '2'
                    ELSE '3'
               END AS VARCHAR(1)) AS ApuracaoFiscal, -- 1=Simples Nacional,2=Lucro Presumido,3=Lucro Numeric,
          CAST('F' AS VARCHAR(1)) AS DespachanteAduaneiro, -- T/F
          CAST(CASE WHEN PAR.SIGNAT>=0 THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situao do Cliente T/F
          CAST(NULL AS VARCHAR(1)) AS TipoIPI -- 0=Normal,1=Crdito 50%,2=Isento,3=Outras,4=Observao
     FROM TT_CLI PAR
     JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ISNOTNULL(ENDE.NUMDOC) = 'T' AND TRIM(COALESCE(ENDE.NUMDOC, '')) <> TRIM(COALESCE(PAR.NUMDOC, ''))
     -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
     --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
      AND (PAR.CODCLI <> LPAD('0', 6, ' '))
      AND ( -- A - Cliente Transportadora,F - Fornecedor,M - Marca/Produto,T - Transportador
            EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = PAR.FILCLI AND REL.CODPAR = PAR.CODCLI AND REL.TIPPAR IN ('A','F','M','T'))
            OR
            EXISTS(SELECT 1 AS OK FROM TT_COM COM 
                    WHERE COM.FLGEST <> 'D'
                      AND COM.NUMNOT NOT LIKE '%#%'
                      AND COM.FILFOR = PAR.FILCLI AND COM.CODFOR = PAR.CODCLI
                      AND COM.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',COM.CODFIL,'','','')
                      AND ((COM.EXPEM4 = 'F') OR (COM.EXPORT = 'F')) )
         )
      AND COALESCE(PAR.INDEXP, 'E') <> 'N'
         ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Parcelas do Documento" (Tabela Integrao Mult)
/*-- SEQ 2688 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_PARCDAVPREVENDA CASCADE;

/*-- SEQ 2689 --*/
CREATE OR REPLACE VIEW TV_TIMU_PARCDAVPREVENDA AS
   -- Parcelas de DAV/Pr-Venda
   SELECT
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (ISNOTNULL(TAB.Acao)='T') THEN TAB.Acao
                WHEN EXISTS(SELECT 1 AS OK FROM TW_EXTXDOC EXD -- Busca para controle da ao pois o DAV pode ser alterado varias vezes antes de ser sincronizado com o EME4
                             WHERE EXD.ORIGEM = TAB.ORIGEM AND EXD.DESTINO = TAB.DESTINO
                               AND EXD.FILORI = TAB.CODFIL AND EXD.SEQORI = TAB.SEQUEN
                               AND EXD.PARORI = TAB.NUMPAR AND EXD.SUBORI = TAB.SUBPAR) THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.NUMPAR, TAB.SUBPAR, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE, TAB.NUMPED, TAB.TIPPED,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.NumeroParcela, -- Nmero da Parcela ou Identificador da Parcela
      TAB.DataVencimento, -- Data de Vencimento da Parcela
      TAB.CodigoBanco, -- Cdigo do Banco da Parcela
      TAB.CodigoAgencia, -- Cdigo da Agncia Bancria da Parcela
      TAB.DigitoAgencia, -- Dgito da Agncia Bancria da Parcela
      TAB.TipoCobrancaPagamento, -- Cdigo do Tipo de Cobrana da Parcela
      TAB.ValorParcela, -- Valor da Parcela
      TAB.TaxaJuros, -- Taxa de Juros
      TAB.Historico, -- Histrico da Parcela
      TAB.Suspensa -- Parcela Suspensa / Bloqueada
     FROM (
      SELECT ORC.CODFIL, CAST(ORC.TIPPED||ORC.NUMPED AS CHAR(10)) AS SEQUEN, CAST(COALESCE(POR.NUMPAR, ' 0') AS CHAR(2)) AS NUMPAR, CAST(' 0' AS CHAR(2)) AS SUBPAR, CAST('POR' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_PARTEDOCTOPARC' AS VARCHAR(50)) AS DESTINO, ORC.DATINC, ORC.ATU_EM, CAST('F' AS VARCHAR(1)) AS EXPORT,
             CAST('ORC' || ORC.CODFIL || ORC.TIPPED || ORC.NUMPED AS VARCHAR(50)) AS CHAVE,
             ORC.NUMPED,
             ORC.TIPPED,
             ORC.EXPEM4,
             CAST(CASE WHEN (COALESCE(ORC.EXPEM4, 'F') = 'T') THEN NULL ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
             ORC.DATINC AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
             -- Definido juntamente com a EME4 quando for cupom fiscal enviar tipo de operao fixo
             CAST(CASE WHEN (ORC.TIPPED = 'O') THEN 995 -- DAV
                       WHEN (ORC.TIPPED = 'P') THEN 994 -- Pr-Venda
                       WHEN (ORC.TIPPED = 'S') THEN 993 -- DAV-OS
                       ELSE NULL
                  END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
             CAST(TO_NUMBER(ORC.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
             CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                       ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                          THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                    ELSE SUBSTR(TO_CHAR(CAST(                                                                             NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                               END
                                          ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                    ELSE SUBSTR(TO_CHAR(CAST(                                                                             NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                               END
                                     END)
                  END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
             CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
             CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = ORC.FILCLI AND REL.CODPAR = ORC.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                       ELSE 'C'
                  END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
             CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
             CAST(ORC.TIPPED AS VARCHAR(5)) AS Serie, -- Srie do Documento
             CAST(TO_CHAR(TO_NUMBER(TRIM(COALESCE(ORC.NUMPED_RE,ORC.NUMPED)))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
             -- Definido juntamente com a EME4 que deve ser enviado apenas numero sem zero a esquerda, ser enviado apenas o n da parcela pois no enviaremos as sub-parcelas nesse ponto ser enviado como Operao de Liquidao
             --CAST(LPAD(TRIM(POR.NUMPAR), 2, '0')||LPAD(TRIM(POR.SUBPAR), 2, '0') AS VARCHAR(30)) AS NumeroParcela, -- Nmero da Parcela ou Identificador da Parcela
             CAST(TRIM(COALESCE(POR.NUMPAR, ' 1')) AS VARCHAR(30)) AS NumeroParcela, -- Nmero da Parcela ou Identificador da Parcela
             CAST(COALESCE(POR.DATVEN, TRUNC(ORC.PED_EM)) AS Timestamp) AS DataVencimento, -- Data de Vencimento da Parcela
             CAST(NULL AS Numeric(9)) AS CodigoBanco, -- Cdigo do Banco da Parcela
             CAST(NULL AS VARCHAR(9)) AS CodigoAgencia, -- Cdigo da Agncia Bancria da Parcela
             CAST(NULL AS VARCHAR(2)) AS DigitoAgencia, -- Dgito da Agncia Bancria da Parcela
             CAST(CASE WHEN PLA_DCOB.CODTAB IN (-1, 0) THEN TO_CHAR(PLA_DCOB.CODTAB)
                       ELSE TRIM(SUBSTR(PLA_DCOB.DESCOB, 1, 10))
                  END AS VARCHAR(10)) AS TipoCobrancaPagamento, -- Cdigo do Tipo de Cobrana da Parcela
             CAST(ABS(COALESCE(POR.VLRPAR, ORC.VLRTOT)) AS Numeric(15,2)) AS ValorParcela, -- Valor da Parcela
             CAST(PLA.ACRDIA AS Numeric(15,2)) AS TaxaJuros, -- Taxa de Juros
             CAST(NULL AS VARCHAR(4000)) AS Historico, -- Histrico da Parcela
             CAST('F' AS VARCHAR(1)) AS Suspensa -- Parcela Suspensa / Bloqueada
       FROM TT_ORC ORC
       -- Tratado Parcelas como Opcional pois quando origem  o TotallOrderWeb no so gerado as parcelas assim gero sempre um registro com base no prprio DAV/Pr-Venda
       LEFT JOIN TT_POR POR ON POR.CODFIL = ORC.CODFIL AND POR.TIPPED = ORC.TIPPED AND POR.NUMPED = ORC.NUMPED 
       -- Plano
       JOIN TT_PLA PLA ON PLA.FILPGT = ORC.FILPGT AND PLA.CODPGT = ORC.CODPGT
       JOIN TD_COB PLA_DCOB ON PLA_DCOB.CODTAB = PLA.CODCOB AND PLA_DCOB.TIPCOB = PLA.TIPCOB
       -- Cliente
       JOIN TT_CLI PAR ON PAR.FILCLI = ORC.FILCLI AND PAR.CODCLI = ORC.CODCLI
       --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
       -- Endereo de Faturamento
       LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = ORC.FILCLI AND ENDFAT.CODCLI = ORC.CODCLI AND ENDFAT.CODFIL = ORC.FILFAT AND ENDFAT.NUMEND = ORC.NUMFAT
       -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
       LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
      WHERE 1 = 1
        AND ORC.PED_EM >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',ORC.CODFIL,'','','')
        AND ((ORC.EXPEM4 = 'F') OR (ORC.EXPORT = 'F'))
        AND LeParametroBoo('EXP_DAV_EME4',ORC.CODFIL,'','','') = 'T'
     ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Parcelas do Documento" (Tabela Integrao Mult)
/*-- SEQ 2690 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_PARCNOTASEMIT CASCADE;

/*-- SEQ 2691 --*/
CREATE OR REPLACE VIEW TV_TIMU_PARCNOTASEMIT AS
   -- Parcelas de Notas Emitidas
   SELECT
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.NUMPAR, TAB.SUBPAR, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE, TAB.NUMPED, TAB.TIPPED,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.NumeroParcela, -- Nmero da Parcela ou Identificador da Parcela
      TAB.DataVencimento, -- Data de Vencimento da Parcela
      TAB.CodigoBanco, -- Cdigo do Banco da Parcela
      TAB.CodigoAgencia, -- Cdigo da Agncia Bancria da Parcela
      TAB.DigitoAgencia, -- Dgito da Agncia Bancria da Parcela
      TAB.TipoCobrancaPagamento, -- Cdigo do Tipo de Cobrana da Parcela
      TAB.ValorParcela, -- Valor da Parcela
      TAB.TaxaJuros, -- Taxa de Juros
      TAB.Historico, -- Histrico da Parcela
      TAB.Suspensa -- Parcela Suspensa / Bloqueada
     FROM (
      SELECT VEN.CODFIL, VEN.SEQUEN, REC.NUMPAR, REC.SUBPAR, CAST('REC' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_PARTEDOCTOPARC' AS VARCHAR(50)) AS DESTINO, COALESCE(VEN.DATINC, VEN.DATHOR) AS DATINC, VEN.ATU_EM, REC.EXPORT, VEN.EXPEM4,
             CAST('VEN' || VEN.CODFIL || VEN.SEQUEN AS VARCHAR(50)) AS CHAVE,
             CAST(NULL AS CHAR(8)) AS NUMPED,
             CAST(NULL AS CHAR(1)) AS TIPPED,
             COALESCE(VEN.DATINC, VEN.DATHOR) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
             -- Definido juntamente com a EME4 quando for cupom fiscal enviar tipo de operao fixo
             CAST(CASE WHEN (VEN.CODSER = 'CF') THEN 998
                       WHEN (VEN.MODNOT = '65') THEN 997
                       WHEN (VEN.MODNOT = '59') THEN 996
                       WHEN (VEN.UFLOJA = 'T') THEN                                                     TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTDEM, '[^0-9]', '', 'gi'), ''))                       ELSE                             TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTFOR, '[^0-9]', '', 'gi'), ''))                  END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
             CAST(TO_NUMBER(VEN.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
             CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                       ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                          THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                    ELSE SUBSTR(TO_CHAR(CAST(                                                                             NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                               END
                                          ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                    ELSE SUBSTR(TO_CHAR(CAST(                                                                             NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                               END
                                     END)
                  END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
             CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
             CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = VEN.FILCLI AND REL.CODPAR = VEN.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                       ELSE 'C'
                  END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
             CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
             CAST(TRIM(CASE WHEN VEN.CODSER='CF' THEN VEN.CODSER
									 WHEN VEN.CODSER='NM' THEN CAST(CONCAT('N',VEN.NUMECF) AS VARCHAR(5))
                            WHEN ( (VEN.MODNOT = '65' OR VEN.MODNOT = '59') AND VEN.NUMECF >= '400' ) THEN VEN.NUMECF
                            WHEN VEN.CODSER<>'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN DSER.SEREXT
                            ELSE NULL
                       END) AS VARCHAR(5)) AS Serie, -- Srie do Documento
             CAST(TO_CHAR(TO_NUMBER(TRIM(CASE WHEN VEN.CODSER = 'CF' THEN VEN.SEQUEN 
                                              WHEN VEN.CODSER = 'ST' THEN COALESCE(TO_CHAR(VEN.SATCFE), VEN.NUMNOT)
                                              ELSE VEN.NUMNOT END))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
             -- Definido juntamente com a EME4 que deve ser enviado apenas numero sem zero a esquerda, ser enviado apenas o n da parcela pois no enviaremos as sub-parcelas nesse ponto ser enviado como Operao de Liquidao
             --CAST(LPAD(TRIM(REC.NUMPAR), 2, '0')||LPAD(TRIM(REC.SUBPAR), 2, '0') AS VARCHAR(30)) AS NumeroParcela, -- Nmero da Parcela ou Identificador da Parcela
             CAST(TRIM(REC.NUMPAR) AS VARCHAR(30)) AS NumeroParcela, -- Nmero da Parcela ou Identificador da Parcela
             CAST(REC.DATVEN AS Timestamp) AS DataVencimento, -- Data de Vencimento da Parcela
             CAST(TO_NUMBER(CTB.CODBCO) AS Numeric(9)) AS CodigoBanco, -- Cdigo do Banco da Parcela
             CAST(CTB.NUMAGE AS VARCHAR(9)) AS CodigoAgencia, -- Cdigo da Agncia Bancria da Parcela
             CAST(CTB.DIGAGE AS VARCHAR(2)) AS DigitoAgencia, -- Dgito da Agncia Bancria da Parcela
             CAST(CASE WHEN PLA_DCOB.CODTAB IN (-1, 0) THEN TO_CHAR(PLA_DCOB.CODTAB)
                       ELSE TRIM(SUBSTR(PLA_DCOB.DESCOB, 1, 10))
                  END AS VARCHAR(10)) AS TipoCobrancaPagamento, -- Cdigo do Tipo de Cobrana da Parcela
             CAST(ABS(REC.VLRPAR) AS Numeric(15,2)) AS ValorParcela, -- Valor da Parcela
             CAST(PLA.ACRDIA AS Numeric(15,2)) AS TaxaJuros, -- Taxa de Juros
             CAST(NULL AS VARCHAR(4000)) AS Historico, -- Histrico da Parcela
             CAST(CASE WHEN REC.FLGEST IN ('C', 'X') AND VEN.FILEST IS NULL THEN 'T'
                       ELSE 'F'
                  END AS VARCHAR(1)) AS Suspensa -- Parcela Suspensa / Bloqueada
       FROM TT_REC REC
       JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
       -- Srie de Emisso
       JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
       -- Natureza
       JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
       -- Plano
       JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT AND PLA.CODPGT = VEN.CODPGT
       JOIN TD_COB PLA_DCOB ON PLA_DCOB.CODTAB = PLA.CODCOB AND PLA_DCOB.TIPCOB = PLA.TIPCOB
       -- Cliente
       JOIN TT_CLI PAR ON PAR.FILCLI = VEN.FILCLI AND PAR.CODCLI = VEN.CODCLI
       --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
       -- Endereo de Faturamento
       LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = VEN.FILCLI AND ENDFAT.CODCLI = VEN.CODCLI AND ENDFAT.CODFIL = VEN.FILFAT AND ENDFAT.NUMEND = VEN.ENDFAT
       -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
       LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
       -- Portador
       JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD
       JOIN TT_CTA CTA ON CTA.CODFIL = DCOB.FILCTA AND CTA.SEQUEN = DCOB.SEQCTA AND CTA.TIPCTA = DCOB.TIPCTA
       LEFT JOIN TT_CTB CTB ON CTB.FILCTA = CTA.CODFIL AND CTB.SEQCTA = CTA.SEQUEN
                           AND CTB.TIPCTA = CTA.TIPCTA AND CTB.CTACTB = CTA.USOCTA
      WHERE REC.SUBPAR = ' 0' -- Trata apenas Sub-Parcela 0 pois todo controle de gerao de Recebimento Parcial  controlado pela TIMU_ParteDoctoOpera
        AND VEN.DATHOR >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',VEN.CODFIL,'','','')
        AND VEN.NUMNOT NOT LIKE '%#%'
        AND (
               -- Quando Cupom Fiscal
               (VEN.CODSER = 'CF') OR
					-- Quando a nota manual no for null (status  NM)
					(VEN.NOTMAN IS NOT NULL) OR
               -- Quando no for Documento Eletrnico
               (VEN.MODNOT NOT IN ('55','65','59','SE')) OR
               -- Quando Documento Eletrnico
               (
                  (VEN.MODNOT IN ('55','65','59','SE')) AND
                  (
                     -- Quando Cancelado exporta quando situao for Cancelada, Inutilizada ou Denegada
                     ((VEN.FLGEST = 'C') AND (VEN.FLGNFE IN ('3'))) OR
                     -- Quando Aberto/Quitado exporta quando situao for Autorizado
                     ((VEN.FLGEST <> 'C') AND (VEN.FLGNFE IN ('1'))) OR
                     -- Nota Estornada fica cancelada no banco mas autorizada na Sefaz
                     ((VEN.FLGEST = 'C') AND (VEN.FLGNFE = '1'))
                  )
               )
            )
        AND VEN.EXPEM4 = 'F'
UNION ALL
      SELECT VEN.CODFIL, VEN.SEQUEN, CAST(' 1' AS CHAR(2)) AS NUMPAR, CAST(' 0' AS CHAR(2)) AS SUBPAR, CAST('REC' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_PARTEDOCTOPARC' AS VARCHAR(50)) AS DESTINO, COALESCE(VEN.DATINC, VEN.DATHOR) AS DATINC, VEN.ATU_EM, VEN.EXPORT, VEN.EXPEM4,
             CAST('VEN' || VEN.CODFIL || VEN.SEQUEN AS VARCHAR(50)) AS CHAVE,
             CAST(NULL AS CHAR(8)) AS NUMPED,
             CAST(NULL AS CHAR(1)) AS TIPPED,
             COALESCE(VEN.DATINC, VEN.DATHOR) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
             -- Definido juntamente com a EME4 quando for cupom fiscal enviar tipo de operao fixo
             CAST(CASE WHEN (VEN.CODSER = 'CF') THEN 998
                       WHEN (VEN.MODNOT = '65') THEN 997
                       WHEN (VEN.MODNOT = '59') THEN 996
                       WHEN (VEN.UFLOJA = 'T') THEN                                                     TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTDEM, '[^0-9]', '', 'gi'), ''))                       ELSE                             TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTFOR, '[^0-9]', '', 'gi'), ''))                  END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
             CAST(TO_NUMBER(VEN.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
             CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                       ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                          THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                    ELSE SUBSTR(TO_CHAR(CAST(                                                                             NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                               END
                                          ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                    ELSE SUBSTR(TO_CHAR(CAST(                                                                             NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                               END
                                     END)
                  END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
             CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
             CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = VEN.FILCLI AND REL.CODPAR = VEN.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                       ELSE 'C'
                  END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
             CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
             CAST(TRIM(CASE WHEN VEN.CODSER='CF' THEN VEN.CODSER
									 WHEN VEN.CODSER='NM' THEN CAST(CONCAT('N',VEN.NUMECF) AS VARCHAR(5))
                            WHEN ( (VEN.MODNOT = '65' OR VEN.MODNOT = '59') AND VEN.NUMECF >= '400' ) THEN VEN.NUMECF
                            WHEN VEN.CODSER<>'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN DSER.SEREXT
                            ELSE NULL
                       END) AS VARCHAR(5)) AS Serie, -- Srie do Documento
             CAST(TO_CHAR(TO_NUMBER(TRIM(CASE WHEN VEN.CODSER = 'CF' THEN VEN.SEQUEN 
                                              WHEN VEN.CODSER = 'ST' THEN COALESCE(TO_CHAR(VEN.SATCFE), VEN.NUMNOT)
                                              ELSE VEN.NUMNOT END))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
             -- Definido juntamente com a EME4 que deve ser enviado apenas numero sem zero a esquerda, ser enviado apenas o n da parcela pois no enviaremos as sub-parcelas nesse ponto ser enviado como Operao de Liquidao
             --CAST(LPAD(TRIM(REC.NUMPAR), 2, '0')||LPAD(TRIM(REC.SUBPAR), 2, '0') AS VARCHAR(30)) AS NumeroParcela, -- Nmero da Parcela ou Identificador da Parcela
             CAST(1 AS VARCHAR(30)) AS NumeroParcela, -- Nmero da Parcela ou Identificador da Parcela
             CAST(TRUNC(VEN.DATHOR) AS Timestamp) AS DataVencimento, -- Data de Vencimento da Parcela
             CAST(NULL AS Numeric(9)) AS CodigoBanco, -- Cdigo do Banco da Parcela
             CAST(NULL AS VARCHAR(9)) AS CodigoAgencia, -- Cdigo da Agncia Bancria da Parcela
             CAST(NULL AS VARCHAR(2)) AS DigitoAgencia, -- Dgito da Agncia Bancria da Parcela
             CAST(NULL AS VARCHAR(10)) AS TipoCobrancaPagamento, -- Cdigo do Tipo de Cobrana da Parcela
             --Nota denegada no tem valor, porm o EME4 exige esse informao, por esse motivo o select abaixo
             CAST((SELECT COALESCE(SUM(ABS(IVE.VLRMOV + COALESCE(IVE.DESRAT,0) - COALESCE(IVE.VLRIPI,0))),0)
                     FROM TT_IVE IVE 
                    WHERE IVE.CODFIL = VEN.CODFIL
                      AND IVE.SEQUEN = VEN.SEQUEN ) AS Numeric(15,2)) AS ValorParcela, -- Valor da Parcela
             CAST(NULL AS Numeric(15,2)) AS TaxaJuros, -- Taxa de Juros
             CAST(NULL AS VARCHAR(4000)) AS Historico, -- Histrico da Parcela
             CAST(NULL AS VARCHAR(1)) AS Suspensa -- Parcela Suspensa / Bloqueada
          FROM TT_VEN VEN 
          -- Srie de Emisso
          JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
          -- Natureza
          JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
			 -- Plano
			 JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT AND PLA.CODPGT = VEN.CODPGT
			 JOIN TD_COB PLA_DCOB ON PLA_DCOB.CODTAB = PLA.CODCOB AND PLA_DCOB.TIPCOB = PLA.TIPCOB
			 -- Cliente
			 JOIN TT_CLI PAR ON PAR.FILCLI = VEN.FILCLI AND PAR.CODCLI = VEN.CODCLI
			 --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
			 -- Endereo de Faturamento
			 LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = VEN.FILCLI AND ENDFAT.CODCLI = VEN.CODCLI AND ENDFAT.CODFIL = VEN.FILFAT AND ENDFAT.NUMEND = VEN.ENDFAT	 
			 -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0			 
          WHERE VEN.NUMNOT NOT LIKE '%#%'
           AND VEN.DATHOR >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',VEN.CODFIL,'','','')
           AND VEN.FINANC = 'T'
           AND (
                  -- Quando Documento Eletrnico
                  (
                     (VEN.MODNOT IN ('55','65')) AND 
                     (
                        -- Quando Cancelado exporta quando situao for Inutilizada ou Denegada
                        (VEN.FLGEST = 'C') AND VEN.FLGNFE IN ('4','6')
                     )
                  )
               )
           AND VEN.EXPEM4 = 'F'	  
     ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Parcelas do Documento" (Tabela Integrao Mult)
/*-- SEQ 2692 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_PARCNOTASEST CASCADE;

/*-- SEQ 2693 --*/
CREATE OR REPLACE VIEW TV_TIMU_PARCNOTASEST AS
   SELECT
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.NUMPAR, TAB.SUBPAR, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE, TAB.NUMPED, TAB.TIPPED,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.NumeroParcela, -- Nmero da Parcela ou Identificador da Parcela
      TAB.DataVencimento, -- Data de Vencimento da Parcela
      TAB.CodigoBanco, -- Cdigo do Banco da Parcela
      TAB.CodigoAgencia, -- Cdigo da Agncia Bancria da Parcela
      TAB.DigitoAgencia, -- Dgito da Agncia Bancria da Parcela
      TAB.TipoCobrancaPagamento, -- Cdigo do Tipo de Cobrana da Parcela
      TAB.ValorParcela, -- Valor da Parcela
      TAB.TaxaJuros, -- Taxa de Juros
      TAB.Historico, -- Histrico da Parcela
      TAB.Suspensa -- Parcela Suspensa / Bloqueada
     FROM (
        -- Parcela de Nota de Estorno / Devoluo Automtica
        SELECT
               VEN.CODFIL, VEN.SEQUEN, CAST(' 1' AS CHAR(2)) AS NUMPAR, CAST(' 0' AS CHAR(2)) as SUBPAR, CAST('REC' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_PARTEDOCTOPARC' AS VARCHAR(50)) AS DESTINO, COALESCE(VEN.DATINC, VEN.DATHOR) AS DATINC, VEN.ATU_EM, VEN.EXPORT, VEN.EXPEM4,
               CAST('VEN' || VEN.CODFIL || VEN.SEQUEN AS VARCHAR(50)) AS CHAVE,
               CAST(NULL AS CHAR(8)) AS NUMPED,
               CAST(NULL AS CHAR(1)) AS TIPPED,
               COALESCE(VEN.DATINC, VEN.DATHOR) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               -- Definido juntamente com a EME4 quando for cupom fiscal enviar tipo de operao fixo
               CAST(CASE WHEN (VEN.CODSER = 'CF') THEN 998
                         WHEN (VEN.MODNOT = '65') THEN 997
                         WHEN (VEN.MODNOT = '59') THEN 996
                         WHEN (VEN.UFLOJA = 'T') THEN                                                       TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTDEM, '[^0-9]', '', 'gi'), ''))                         ELSE                               TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTFOR, '[^0-9]', '', 'gi'), ''))                    END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST(TO_NUMBER(VEN.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = VEN.FILCLI AND REL.CODPAR = VEN.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                         ELSE 'C'
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST(TRIM(CASE WHEN VEN.CODSER='CF' THEN VEN.CODSER
										WHEN VEN.CODSER='NM' THEN CAST(CONCAT('N',VEN.NUMECF) AS VARCHAR(5))
                              WHEN ( (VEN.MODNOT = '65' OR VEN.MODNOT = '59') AND VEN.NUMECF >= '400' ) THEN VEN.NUMECF
                              WHEN VEN.CODSER<>'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN DSER.SEREXT
                              ELSE NULL
                         END) AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(TO_CHAR(TO_NUMBER(TRIM(CASE WHEN VEN.CODSER = 'CF' THEN VEN.SEQUEN 
                                                WHEN VEN.CODSER = 'ST' THEN COALESCE(TO_CHAR(VEN.SATCFE), VEN.NUMNOT)
                                                ELSE VEN.NUMNOT END))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST('1' AS VARCHAR(30)) AS NumeroParcela, -- Nmero da Parcela ou Identificador da Parcela
               CAST(TRUNC(VEN.DATHOR) AS Timestamp) AS DataVencimento, -- Data de Vencimento da Parcela
               CAST(NULL AS Numeric(9)) AS CodigoBanco, -- Cdigo do Banco da Parcela
               CAST(NULL AS VARCHAR(9)) AS CodigoAgencia, -- Cdigo da Agncia Bancria da Parcela
               CAST(NULL AS VARCHAR(2)) AS DigitoAgencia, -- Dgito da Agncia Bancria da Parcela
               CAST(CASE WHEN PLA_DCOB.CODTAB IN (-1, 0) THEN TO_CHAR(PLA_DCOB.CODTAB)
                         ELSE TRIM(SUBSTR(PLA_DCOB.DESCOB, 1, 10))
                    END AS VARCHAR(10)) AS TipoCobrancaPagamento, -- Cdigo do Tipo de Cobrana da Parcela
               CAST(ABS(VEN.VLRLIQ) AS Numeric(15,2)) AS ValorParcela, -- Valor da Parcela
               CAST(PLA.ACRDIA AS Numeric(15,2)) AS TaxaJuros, -- Taxa de Juros
               CAST(NULL AS VARCHAR(4000)) AS Historico, -- Histrico da Parcela
               CAST('F' AS VARCHAR(1)) AS Suspensa -- Parcela Suspensa / Bloqueada
          FROM TT_VEN VEN
          -- Srie de Emisso
          JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
          -- Natureza
          JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
          -- Plano
          JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT AND PLA.CODPGT = VEN.CODPGT
          JOIN TD_COB PLA_DCOB ON PLA_DCOB.CODTAB = PLA.CODCOB AND PLA_DCOB.TIPCOB = PLA.TIPCOB
          -- Cliente
          JOIN TT_CLI PAR ON PAR.FILCLI = VEN.FILCLI AND PAR.CODCLI = VEN.CODCLI
          -- Nota de Origem do Estorno / Devoluo Automtica
          LEFT JOIN TT_VEN EST ON EST.FILEST = VEN.CODFIL AND EST.SEQEST = VEN.SEQUEN
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = VEN.FILCLI AND ENDFAT.CODCLI = VEN.CODCLI AND ENDFAT.CODFIL = VEN.FILFAT AND ENDFAT.NUMEND = VEN.ENDFAT
         WHERE VEN.NUMNOT NOT LIKE '%#%'
           AND VEN.DATHOR >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',VEN.CODFIL,'','','')
           AND VEN.FINANC = 'F' -- Nota de Estorno / Devoluo Automtica no gera financeiro
           AND EST.CODFIL IS NOT NULL
           AND (
                  -- Quando Cupom Fiscal
                  (VEN.CODSER = 'CF') OR
						-- Quando a nota manual no for null (status  NM)
						(VEN.NOTMAN IS NOT NULL) OR
                  -- Quando no for Documento Eletrnico
                  (VEN.MODNOT NOT IN ('55','65','59','SE')) OR
                  -- Quando Documento Eletrnico
                  (
                     (VEN.MODNOT IN ('55','65','59','SE')) AND
                     (
                        -- Quando Cancelado exporta quando situao for Cancelada, Inutilizada ou Denegada
                        ((VEN.FLGEST = 'C') AND (VEN.FLGNFE IN ('3','4','6'))) OR
                        -- Quando Aberto/Quitado exporta quando situao for Autorizado
                        ((VEN.FLGEST <> 'C') AND (VEN.FLGNFE IN ('1'))) OR
                        -- Nota Estornada fica cancelada no banco mas autorizada na Sefaz
                        ((VEN.FLGEST = 'C') AND (VEN.FLGNFE = '1'))
                     )
                  )
               )
           AND VEN.EXPEM4 = 'F'
       ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Parcelas do Documento" (Tabela Integrao Mult)
/*-- SEQ 2694 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_PARCNOTASRECEB CASCADE;

/*-- SEQ 2695 --*/
CREATE OR REPLACE VIEW TV_TIMU_PARCNOTASRECEB AS
   SELECT
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.NUMPAR, TAB.SUBPAR, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE, TAB.NUMPED, TAB.TIPPED,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.NumeroParcela, -- Nmero da Parcela ou Identificador da Parcela
      TAB.DataVencimento, -- Data de Vencimento da Parcela
      TAB.CodigoBanco, -- Cdigo do Banco da Parcela
      TAB.CodigoAgencia, -- Cdigo da Agncia Bancria da Parcela
      TAB.DigitoAgencia, -- Dgito da Agncia Bancria da Parcela
      TAB.TipoCobrancaPagamento, -- Cdigo do Tipo de Cobrana da Parcela
      TAB.ValorParcela, -- Valor da Parcela
      TAB.TaxaJuros, -- Taxa de Juros
      TAB.Historico, -- Histrico da Parcela
      TAB.Suspensa -- Parcela Suspensa / Bloqueada
     FROM (
      -- Parcelas de Notas de Recebidas
      SELECT COM.CODFIL, COM.SEQUEN, PAG.NUMPAR, PAG.SUBPAR, CAST('PAG' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_PARTEDOCTOPARC' AS VARCHAR(50)) AS DESTINO, COALESCE(COM.DATINC, COM.DATOPE) AS DATINC, COM.ATU_EM, CAST('F' AS VARCHAR(1)) AS EXPORT, COM.EXPEM4,
             CAST('COM' || COM.CODFIL || COM.SEQUEN AS VARCHAR(50)) AS CHAVE,
             CAST(NULL AS CHAR(8)) AS NUMPED,
             CAST(NULL AS CHAR(1)) AS TIPPED,
             COALESCE(COM.DATINC, COM.DATOPE) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
             CAST(                  TO_NUMBER(NULLIF(regexp_replace(DCFO.EXTCFO, '[^0-9]', '', 'gi'), '')) AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
             CAST(TO_NUMBER(COM.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
             CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                       ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                          THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                    ELSE SUBSTR(TO_CHAR(CAST(                                                                             NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                               END
                                          ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                    ELSE SUBSTR(TO_CHAR(CAST(                                                                             NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                               END
                                     END)
                  END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
             CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
             CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = COM.FILFOR AND REL.CODPAR = COM.CODFOR AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                       ELSE 'C'
                  END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
             CAST('2' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
             CAST(CASE WHEN ISNOTNULL(FIS.SEREXP)='T' THEN LPAD(TRIM(FIS.SEREXP), 3, '0')||CASE WHEN COM.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(FIS.SUBEXP),'0'), 2, '0') END
                       ELSE LPAD(TRIM(COM.CODSER), 2, '0')||CASE WHEN COM.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(COM.SUBSER),'0'), 3, '0') END
                  END AS VARCHAR(5)) AS Serie, -- Srie do Documento
             CAST(TO_CHAR(TO_NUMBER(TRIM(COM.NUMNOT))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
             -- Definido juntamente com a EME4 que deve ser enviado apenas numero sem zero a esquerda, ser enviado apenas o n da parcela pois no enviaremos as sub-parcelas nesse ponto ser enviado como Operao de Liquidao
             --CAST(LPAD(TRIM(PAG.NUMPAR), 2, '0')||LPAD(TRIM(PAG.SUBPAR), 2, '0') AS VARCHAR(30)) AS NumeroParcela, -- Nmero da Parcela ou Identificador da Parcela
             CAST(TRIM(PAG.NUMPAR) AS VARCHAR(30)) AS NumeroParcela, -- Nmero da Parcela ou Identificador da Parcela
             CAST(PAG.DATVEN AS Timestamp) AS DataVencimento, -- Data de Vencimento da Parcela
             CAST(PAG.CODBCO AS Numeric(9)) AS CodigoBanco, -- Cdigo do Banco da Parcela
             CAST(NULL AS VARCHAR(9)) AS CodigoAgencia, -- Cdigo da Agncia Bancria da Parcela
             CAST(NULL AS VARCHAR(2)) AS DigitoAgencia, -- Dgito da Agncia Bancria da Parcela
             CAST(NULL AS VARCHAR(10)) AS TipoCobrancaPagamento, -- Cdigo do Tipo de Cobrana da Parcela
             CAST(ABS(PAG.VLRPAR) AS Numeric(15,2)) AS ValorParcela, -- Valor da Parcela
             CAST(NULL AS Numeric(15,2)) AS TaxaJuros, -- Taxa de Juros
             CAST(NULL AS VARCHAR(4000)) AS Historico, -- Histrico da Parcela
             CAST(CASE WHEN PAG.FLGEST IN ('C', 'X') THEN 'T'
                       ELSE 'F'
                  END AS VARCHAR(1)) AS Suspensa -- Parcela Suspensa / Bloqueada
       FROM TT_PAG PAG
       JOIN TT_COM COM ON COM.CODFIL = PAG.CODFIL AND COM.SEQUEN = PAG.SEQUEN
       -- Srie de Emisso
       LEFT JOIN (SELECT DISTINCT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT, ORIGEM
                    FROM TT_FIS
                   WHERE ORIGEM IN ('C','F')) FIS ON FIS.CODSER = COM.CODSER AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$') AND FIS.ORIGEM = CASE WHEN COALESCE(COM.TIPPAR,'F') = 'T' THEN 'F' ELSE 'C' END
       -- Natureza
       LEFT JOIN TD_CFO DCFO ON DCFO.CODTAB = COM.CODCFO
       -- Fornecedor
       JOIN TT_CLI PAR ON PAR.FILCLI = COM.FILFOR AND PAR.CODCLI = COM.CODFOR
       --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.FILEND
       -- Endereo de Faturamento
       LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = COM.FILFOR AND ENDFAT.CODCLI = COM.CODFOR AND ENDFAT.CODFIL = COM.FILEND AND ENDFAT.NUMEND = COM.NUMEND
       -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
       LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
     WHERE PAG.SUBPAR = ' 0' -- Trata apenas Sub-Parcela 0 pois todo controle de gerao de Pagamento Parcial deve ser controlado pela TIMU_ParteDoctoOpera
       AND COM.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',COM.CODFIL,'','','')
       AND COM.FLGEST <> 'D'
       AND COM.NUMNOT NOT LIKE '%#%'
       AND COM.EXPEM4 = 'F'
       ) TAB
;


-- Autor: Carla Alves
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Operao Financeira Documento" (Tabela Integrao Mult)
-- Arquivo Pai: TIMU_PARTEDOCTOOPERA
/*-- SEQ 2696 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_PARTEDOCCONTACORRENTE CASCADE;

/*-- SEQ 2697 --*/
CREATE OR REPLACE VIEW TV_TIMU_PARTEDOCCONTACORRENTE AS
SELECT
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.NUMPAR, TAB.SUBPAR, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.NomeOperacao, -- {Recebimentos, Pagamentos Duplicatas, Adiantamentos Clientes}
      TAB.DataOperacao, -- Data da Operao (Enviar igual a DataBaixa)
      TAB.DataBaixa, -- Data da Baixa (Enviar igual a DataOperacao)
      TAB.Valor, -- Valor da Operao (Enviar igual ao ValorBaixa)
      TAB.ValorBaixa, -- Valor da Baixa (Enviar igual ao Valor)
      TAB.NroDiasValidade, -- Nmero de Dias de Validade do Adiantamento
      TAB.FilialParcela, -- Cdigo da Filial da Parcela a ser Recebida/Paga
      TAB.CPFCNPJCliForParcela, -- CPF ou CNPJ do Cliente ou Fornecedor da Parcela a ser Recebida/Paga
      TAB.CodigoCliForParcela, -- Cdigo do Cliente ou Fornecedor da Parcela a ser Recebida/Paga
      TAB.SerieParcela, -- Srie do Documento da Parcela a ser Recebida/Paga
      TAB.NumeroDocumentoParcela, -- Nmero do documento da Parcela a ser Recebida/Paga
      TAB.NumeroParcela, -- Nmero da Parcela a ser Recebida/Paga
      TAB.ValorJuros, -- Valor do Juros
      TAB.ValorMulta, -- Valor da Multa
      TAB.ValorDesconto, -- Valor do Desconto
      TAB.ValorAbatimento, -- Valor Abatimento
      TAB.Historico -- Histrico da Baixa
      --TAB.ChaveMueller -- Campo Chave Sistema Mueller
  FROM (-- Operao de Documentos de Conta Corrente
        SELECT
               CCC.CODFIL, 
               CCC.SEQUEN, 
               CCC.NUMPAR, 
               CCC.SUBPAR, 
               CAST('CCC' AS VARCHAR(3)) AS ORIGEM, 
               CAST('TIMU_PARTEDOCTOOPERA' AS VARCHAR(50)) AS DESTINO, 
               CCC.DATINC, 
               CCC.DATINC AS ATU_EM, 
               CCC.EXPORT, 
               CCC.EXPORT AS EXPEM4,
               CAST('CCC' || CCC.CODFIL || CCC.SEQUEN AS VARCHAR(50)) AS CHAVE,
               CCC.DATINC AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               -- Tipo de Operao exportado de forma fixa conforme conversado com a EME4
               CAST(CASE WHEN CCC.TIPLAN = 'D' THEN 992 ELSE 993 END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao (992-Deposito / 993-Retirada)
               CAST(TO_NUMBER(CCC.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = CCC.FILCLI AND REL.CODPAR = CCC.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                         ELSE 'C'
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST('CC'||CCC.NUMECF AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(TRIM(CCC.SEQUEN) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento              
               CAST('ContaCorrente' AS VARCHAR(50)) AS NomeOperacao, -- {Recebimentos, Pagamentos Duplicatas, Adiantamentos Clientes}
               CAST(TRUNC(CCC.DATOPE) AS Timestamp) AS DataOperacao, -- Data da Operao (Enviar igual a DataBaixa)
               CAST(TRUNC(CCC.DATOPE) AS Timestamp) AS DataBaixa, -- Data da Baixa (Enviar igual a DataOperacao)
               CAST(ABS(CCC.VLRLAN) AS Numeric(15,2)) AS Valor, -- Valor da Operao (Enviar igual ao ValorBaixa)
               CAST(ABS(CCC.VLRLAN) AS Numeric(15,2)) AS ValorBaixa, -- Valor da Baixa (Enviar igual ao Valor)
               CAST(NULL AS Numeric(4)) AS NroDiasValidade, -- Nmero de Dias de Validade do Adiantamento
               -- Dados da Parcela Paga
               CAST(TO_NUMBER(CCC.CODFIL) AS Numeric(3)) AS FilialParcela, -- Cdigo da Filial da Parcela a ser Recebida/Paga
               CAST(CASE WHEN (LeParametroTXT('TIPO_EXP_EME4', CCC.CODFIL, '', '', '')='V') AND (ISNOTNULL(COALESCE(PAR.NUMDOC, VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliForParcela, -- Cdigo do Cliente ou Fornecedor da Parcela a ser Recebida/Paga
               CAST(TRIM(COALESCE(PAR.NUMDOC, VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliForParcela, -- CPF ou CNPJ do Cliente ou Fornecedor da Parcela a ser Recebida/Paga
               CAST('CC'||CCC.NUMECF AS VARCHAR(5)) AS SerieParcela, -- Srie do Documento da Parcela a ser Recebida/Paga
               CAST(CCC.SEQUEN AS VARCHAR(10)) AS NumeroDocumentoParcela, -- Nmero do documento da Parcela a ser Recebida/Paga
               CAST(TRIM(CCC.NUMPAR) AS VARCHAR(30)) AS NumeroParcela, -- Nmero da Parcela a ser Recebida/Paga
               CAST(0 AS Numeric(15,2)) AS ValorJuros, -- Valor do Juros
               CAST(NULL AS Numeric(15,2)) AS ValorMulta, -- Valor da Multa
               CAST(0 AS Numeric(15,2)) AS ValorDesconto, -- Valor do Desconto
               CAST(NULL AS Numeric(15,2)) AS ValorAbatimento, -- Valor Abatimento
               CAST('Conta Corrente Varejo: Cliente ' ||
                    CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = CFG.VC_FILCLI||CFG.VC_CODCLI) THEN
                           CASE WHEN PAR.FLGTIP = 0
                                     THEN CASE WHEN CFG.UNE_NOME_SOBRENOME = 'T'
                                               THEN PAR.NOMCLI
                                               ELSE PAR.NOMCLI||' '||COALESCE(PAR.ULTNOM,'')
                                          END
                                     ELSE PAR.NOMCLI
                           END ||
                           CASE WHEN PAR.FLGTIP = 0
                                THEN ''
                                ELSE ' ' || COALESCE(PAR.ULTNOM,'')
                           END
                         ELSE
                           CASE WHEN VIN.FLGTIP = 0
                                     THEN CASE WHEN CFG.UNE_NOME_SOBRENOME = 'T'
                                               THEN VIN.NOMCLI
                                               ELSE VIN.NOMCLI||' '||COALESCE(VIN.ULTNOM,'')
                                          END
                                     ELSE VIN.NOMCLI
                           END ||
                           CASE WHEN VIN.FLGTIP = 0
                                THEN ''
                                ELSE ' ' || COALESCE(VIN.ULTNOM,'')
                           END
                    END AS VARCHAR(80)) AS Historico -- Histrico da Baixa
          FROM TT_CCC CCC
          -- Cliente
          JOIN TT_CLI PAR ON PAR.FILCLI = CCC.FILCLI AND PAR.CODCLI = CCC.CODCLI
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = CCC.FILCLI AND ENDFAT.CODCLI = CCC.CODCLI
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          CROSS JOIN TT_CFG CFG
         WHERE 1=1
           AND COALESCE(CCC.INDEXP, 'E') <> 'N'
           AND CCC.TIPLAN IN('D','I')
           AND CCC.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',CCC.CODFIL,'','','')
           AND (LeParametroTXT('TIPO_EXP_EME4', CCC.CODFIL, '', '', '') = 'V')
           AND CCC.EXPEM4 = 'F'
       ) TAB
 WHERE 1=1
   AND TAB.TipoOperacao IS NOT NULL
 ORDER BY TAB.CODFIL, TAB.SEQUEN, TAB.DataHoraAtuReg
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Conhecimento de Frete Documento" (Tabela Integrao Mult)
/*-- SEQ 2698 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_PARTEDOCTOCONHECEFRETE CASCADE;

/*-- SEQ 2699 --*/
CREATE OR REPLACE VIEW TV_TIMU_PARTEDOCTOCONHECEFRETE AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.FILREF, TAB.SEQREF, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4,
      TAB.FRE_VLRNOT, TAB.FRE_VLRLIQ, TAB.FRE_RATEIO_FRETE, TAB.FRE_BASFRE, TAB.FRE_ICMFRE, TAB.FRE_OUTTAX, TAB.FRE_ISEICM, TAB.FRE_OUTICM,
      TAB.COM_VLRNOT, TAB.COM_VLRLIQ, TAB.CHAVE,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.ValorFrete, -- Valor do Frete
      TAB.FilialDocto, -- Cdigo da Filial do Documento Referenciado
      TAB.CPFCNPJCliForDocto, -- CPF ou CNPJ do Documento Referenciado
      TAB.CodigoCliForDocto, -- Cdigo do Cliente ou Fornecedor do Documento Referenciado
      TAB.SerieDocto, -- Srie do Documento do Documento Referenciado
      TAB.NumeroDocumentoDocto, -- Nmero do documento do Documento Referenciado
      TAB.CFOP, -- Cdigo Fiscal Operao (0.000)
      TAB.ClassificacaoFiscal, -- Classificao Fiscal {00, 10, 20, 30, 40, 41, 50, 51, 60, 70, 90}
      TAB.CodigoContaFinanceira, -- Cdigo da Conta Financeira
      TAB.ICMSInfManualmente, -- ICMS Informado Manualmente
      TAB.BaseCalcICMSFrete, -- Base de Clculo ICMS Frete
      TAB.ValorICMS, -- Valor de ICMS
      TAB.AliquotaICMS, -- Alquota de ICMS
      TAB.ValorIsentasICMS, -- Valor Isento de ICMS
      TAB.ValorOutrasICMS, -- Valor de Outros ICMS
      TAB.AliqDifAliquota, -- Alquota Difercial de Alquota
      TAB.ValorDifAliquota, -- Valor Diferncial de Alquota
      TAB.BaseCalcIPI, -- Base de Clculo do IPI
      TAB.ValorIPI, -- Valor do IPI
      TAB.ValorIsentoIPI, -- Valor Isento IPI
      TAB.ValorOutrasIPI, -- Valor de Outros IPI
      TAB.ClassificacaoPIS, -- {A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes}
      TAB.BasePIS, -- Base de Clculo PIS
      TAB.ValorPIS, -- Valor de PIS
      TAB.AliquotaPIS, -- Alquota de PIS
      TAB.ValorIsentasPIS, -- Valor Isento de PIS
      TAB.ValorOutrasPIS, -- Valor de Outros PIS
      TAB.ClassificacaoCOFINS, -- {A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes}
      TAB.BaseCOFINS, -- Base de Clculo COFINS
      TAB.ValorCOFINS, -- Valor de COFINS
      TAB.AliquotaCOFINS, -- Alquota de COFINS
      TAB.ValorIsentasCOFINS, -- Valor Isento de COFINS
      TAB.ValorOutrasCOFINS, -- Valor de Outros COFINS
      TAB.CodBaseCalcCredito, -- {0=Nenhum,1=Aquisio de bens para revenda,2=Aquisio de bens utilizados como insumo,3=Aquisio de servios utilizados como insumo,4=Energia eltrica e trmica, inclusive sob a forma de vapor,5=Aluguis de prdios,6=Aluguis de mquinas e equipamentos,7=Armazenagem de mercadoria e frete na operao de venda,8=Contraprestaes de arrendamento mercantil,9=Mquinas, equipamentos e outros bens incorporados ao ativo imobilizado,B=Amortizao e Depreciao de edificaes e benfeitorias em imveis,C=Devoluo de Vendas Sujeitas  Incidncia No-Cumulativa,D=Outras Operaes com Direito a Crdito,E=Atividade de Transporte de Cargas  Subcontratao,F=Atividade Imobiliria  Custo Incorrido de Unidade Imobiliria,G=Atividade Imobiliria  Custo Orado de unidade no concluda,H=Atividade de Prestao de Servios de Limpeza, Conservao e Manuteno,I=Estoque de abertura de bens,}
      TAB.RegimeIncidencia, -- {0=Cumulativa,1=No-Cumulativa,}
      TAB.TipoFrete, -- A - Por Conta de Terceiros / T  - Por Conta do Emitente  / F - Por Conta do Destinatrio / B - Sem Frete
      TAB.IndNaturezaFrete, -- {0=Operaes de vendas, com nus suportado pelo estabelecimento vendedor,1=Operaes de vendas, com nus suportado pelo adquirente,2=Operaes de compras (bens para revenda, matrias prima e outros produtos, geradores de crdito),3=Operaes de compras (bens para revenda, matrias prima e outros produtos, no geradores de crdito),4=Transferncia de produtos acabados entre estabelecimentos da pessoa jurdica,5=Transferncia de produtos entre estabelecimentos da pessoa jurdica,9=Outras}
      TAB.NumeroConhecimento, -- Nmero do Conhecimento
      TAB.TipoCTE, -- {0=0-CT-e Normal,1=1-CT-e de Complemento de Valores,2=2-CT-e emitido em hiptese de anulao de dbito,3=3-CTE substituto do CT-e anulado,}
      TAB.ChaveCTE, -- Chave do CTE
      TAB.DataEmissao, -- Data de Emisso
      TAB.DataEntrada, -- Data de Entrada
      TAB.ObservacaoFiscal, -- Observao Fiscal
      TAB.TextoFiscal, -- Texto Fiscal
      TAB.ValorDifaCIAP, -- Valor Diferncial de Alquota CIAP
      TAB.ValorICMSCIAP, -- Valor de ICMS CIAP
      TAB.ValorPISCIAP, -- Valor de PIS CIAP
      TAB.ValorCOFINSCIAP -- Valor de COFINS CIAP
  FROM (
         -- Conhecimento de Frete
         SELECT
               FRE.CODFIL, FRE.SEQUEN, COM.CODFIL AS FILREF, COM.SEQUEN AS SEQREF, CAST('FRE' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_PARTEDOCTOCONHECEFRETE' AS VARCHAR(50)) AS DESTINO, COALESCE(FRE.DATINC, FRE.DATOPE) AS DATINC, FRE.ATU_EM, FRE.EXPORT, FRE.EXPEM4,
               CAST('COM' || FRE.CODFIL || FRE.SEQUEN AS VARCHAR(50)) AS CHAVE,
               COALESCE(FRE.DATINC, FRE.DATOPE) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               CAST(                    TO_NUMBER(NULLIF(regexp_replace(DCFO.EXTCFO, '[^0-9]', '', 'gi'), '')) AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST(TO_NUMBER(FRE.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = FRE.FILFOR AND REL.CODPAR = FRE.CODFOR AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                         ELSE 'C' 
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('2' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST(CASE WHEN ISNOTNULL(FIS.SEREXP)='T' THEN LPAD(TRIM(FIS.SEREXP), 3, '0')||CASE WHEN FRE.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(FIS.SUBEXP),'0'), 2, '0') END
                         ELSE LPAD(TRIM(FRE.CODSER), 2, '0')||CASE WHEN FRE.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(FRE.SUBSER),'0'), 3, '0') END
                    END AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(TO_CHAR(TO_NUMBER(TRIM(FRE.NUMNOT))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               FRE.VLRNOT AS FRE_VLRNOT, FRE.VLRLIQ AS FRE_VLRLIQ, FRE.RATEIO_FRETE AS FRE_RATEIO_FRETE, FRE.BASFRE AS FRE_BASFRE, FRE.ICMFRE AS FRE_ICMFRE, FRE.OUTTAX AS FRE_OUTTAX, FRE.ISEICM AS FRE_ISEICM, FRE.OUTICM AS FRE_OUTICM,
               COM.VLRNOT AS COM_VLRNOT, COM.VLRLIQ AS COM_VLRLIQ,
               CAST(ABS(COM.VLRFRE) AS Numeric(15,2)) AS ValorFrete, -- Valor do Frete
               CAST(TO_NUMBER(COM.CODFIL) AS Numeric(3)) AS FilialDocto, -- Cdigo da Filial do Documento Referenciado
               CAST(TRIM(COALESCE(PAR_FOR.NUMDOC, VIN_FOR.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliForDocto, -- CPF ou CNPJ do Documento Referenciado
               CAST(CASE WHEN (LeParametroTXT('TIPO_EXP_EME4', FRE.CODFIL, '', '', '')='V') AND (ISNOTNULL(COALESCE(PAR_FOR.NUMDOC, VIN_FOR.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR_FOR.NUMDOC)='T') OR (PAR_FOR.CODCLI = LPAD('0', 6, ' ')) OR (PAR_FOR.FILCLI||PAR_FOR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR_FOR.FILCLI||LPAD(TRIM(PAR_FOR.CODCLI), 6, '0') 
                                             ELSE VIN_FOR.FILCLI||LPAD(TRIM(VIN_FOR.CODCLI), 6, '0') 
                                        END)
                    END AS Numeric(9)) AS CodigoCliForDocto, -- Cdigo do Cliente ou Fornecedor
               CAST(CASE WHEN ISNOTNULL(FIS_COM.SEREXP)='T' THEN LPAD(TRIM(FIS_COM.SEREXP), 3, '0')||LPAD(COALESCE(TRIM(FIS_COM.SUBEXP),'0'), 2, '0')
                         ELSE LPAD(TRIM(COM.CODSER), 2, '0')||LPAD(COALESCE(TRIM(COM.SUBSER),'0'), 3, '0')
                    END AS VARCHAR(5)) AS SerieDocto, -- Srie do Documento do Documento Referenciado
               CAST(TO_CHAR(TO_NUMBER(TRIM(COM.NUMNOT))) AS VARCHAR(10)) AS NumeroDocumentoDocto, -- Nmero do documento do Documento Referenciado
               CAST(CASE WHEN ISNOTNULL(DCFO.CODCFO)='T' THEN SUBSTR(DCFO.CODCFO, 1, 1) || '.' || SUBSTR(DCFO.CODCFO, 2, 3)
                         ELSE NULL
                    END AS VARCHAR(20)) AS CFOP, -- Cdigo Fiscal Operao (0.000)
               CAST(SUBSTR(DTRI.CODTRI, 2, 2) AS VARCHAR(3)) AS ClassificacaoFiscal, -- Classificao Fiscal {00, 10, 20, 30, 40, 41, 50, 51, 60, 70, 90}
               -- Definido juntamente com a EME4 quando o cdigo da conta financeira no possuir um "-" devemos exportar para uma Conta fixa para posterior reviso
               --CAST(TRIM(COALESCE(CXF.CODEXT, CTA.CODEXT, CODIGO_CONTA(CTA.CODFIL, CTA.SEQUEN, 'X'))) AS VARCHAR(10)) AS CodigoContaFinanceira, -- Cdigo da Conta Financeira
               CAST(TRIM(CASE WHEN INSTR(COALESCE(CXF.CODEXT, CTA.CODEXT, CODIGO_CONTA(CTA.CODFIL, CTA.SEQUEN, 'X')), '-') > 0 THEN TRIM(SUBSTR(COALESCE(CXF.CODEXT, CTA.CODEXT, CODIGO_CONTA(CTA.CODFIL, CTA.SEQUEN, 'X')),1,10)) ELSE '99999-1' END) AS VARCHAR(10)) AS CodigoContaFinanceira, -- Cdigo da Conta Financeira
               CAST('T' AS VARCHAR(1)) AS ICMSInfManualmente, -- ICMS Informado Manualmente
               CAST(ABS(COM.BASFRE) AS Numeric(15,2)) AS BaseCalcICMSFrete, -- Base de Clculo ICMS Frete
               CAST(ABS(COM.ICMFRE) AS Numeric(15,2)) AS ValorICMS, -- Valor de ICMS
               CAST(ABS(FRE.PERFRE) AS Numeric(15,2)) AS AliquotaICMS, -- Alquota de ICMS
               CAST(ABS(COM.ISEICM) AS Numeric(15,2)) AS ValorIsentasICMS, -- Valor Isento de ICMS
               CAST(ABS(COM.OUTICM) AS Numeric(15,2)) AS ValorOutrasICMS, -- Valor de Outros ICMS
               CAST(NULL AS Numeric(15,2)) AS AliqDifAliquota, -- Alquota Difercial de Alquota
               CAST(NULL AS Numeric(15,2)) AS ValorDifAliquota, -- Valor Diferncial de Alquota
               CAST(NULL AS Numeric(15,2)) AS BaseCalcIPI, -- Base de Clculo do IPI
               CAST(NULL AS Numeric(15,2)) AS ValorIPI, -- Valor do IPI
               CAST(NULL AS Numeric(15,2)) AS ValorIsentoIPI, -- Valor Isento IPI
               CAST(NULL AS Numeric(15,2)) AS ValorOutrasIPI, -- Valor de Outros IPI
               CAST(CASE FRE.SITPIS WHEN '01' THEN 'A'
                                    WHEN '02' THEN 'B'
                                    WHEN '03' THEN 'C'
                                    WHEN '04' THEN 'D'
                                    WHEN '06' THEN 'E'
                                    WHEN '07' THEN 'F'
                                    WHEN '08' THEN 'G'
                                    WHEN '09' THEN 'H'
                                    WHEN '05' THEN 'I'
                                    WHEN '49' THEN 'J'
                                    WHEN '50' THEN 'K'
                                    WHEN '51' THEN 'L'
                                    WHEN '52' THEN 'M'
                                    WHEN '53' THEN 'N'
                                    WHEN '54' THEN 'O'
                                    WHEN '55' THEN 'P'
                                    WHEN '56' THEN 'Q'
                                    WHEN '60' THEN 'R'
                                    WHEN '61' THEN 'S'
                                    WHEN '62' THEN 'T'
                                    WHEN '63' THEN 'U'
                                    WHEN '64' THEN 'V'
                                    WHEN '65' THEN 'W'
                                    WHEN '66' THEN 'X'
                                    WHEN '67' THEN '1'
                                    WHEN '70' THEN '2'
                                    WHEN '71' THEN '3'
                                    WHEN '72' THEN '4'
                                    WHEN '73' THEN '5'
                                    WHEN '74' THEN '6'
                                    WHEN '75' THEN '7'
                                    WHEN '98' THEN 'Y'
                                    WHEN '99' THEN 'Z'
                                    ELSE 'Z'
                     END AS VARCHAR(3)) AS ClassificacaoPIS, -- {A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes}
               CAST(NULL AS Numeric(15,2)) AS BasePIS, -- Base de Clculo PIS
               CAST(NULL AS Numeric(15,2)) AS ValorPIS, -- Valor de PIS
               CAST(NULL AS Numeric(15,2)) AS AliquotaPIS, -- Alquota de PIS
               CAST(NULL AS Numeric(15,2)) AS ValorIsentasPIS, -- Valor Isento de PIS
               CAST(NULL AS Numeric(15,2)) AS ValorOutrasPIS, -- Valor de Outros PIS
               CAST(CASE FRE.SITCOF WHEN '01' THEN 'A'
                                    WHEN '02' THEN 'B'
                                    WHEN '03' THEN 'C'
                                    WHEN '04' THEN 'D'
                                    WHEN '06' THEN 'E'
                                    WHEN '07' THEN 'F'
                                    WHEN '08' THEN 'G'
                                    WHEN '09' THEN 'H'
                                    WHEN '05' THEN 'I'
                                    WHEN '49' THEN 'J'
                                    WHEN '50' THEN 'K'
                                    WHEN '51' THEN 'L'
                                    WHEN '52' THEN 'M'
                                    WHEN '53' THEN 'N'
                                    WHEN '54' THEN 'O'
                                    WHEN '55' THEN 'P'
                                    WHEN '56' THEN 'Q'
                                    WHEN '60' THEN 'R'
                                    WHEN '61' THEN 'S'
                                    WHEN '62' THEN 'T'
                                    WHEN '63' THEN 'U'
                                    WHEN '64' THEN 'V'
                                    WHEN '65' THEN 'W'
                                    WHEN '66' THEN 'X'
                                    WHEN '67' THEN '1'
                                    WHEN '70' THEN '2'
                                    WHEN '71' THEN '3'
                                    WHEN '72' THEN '4'
                                    WHEN '73' THEN '5'
                                    WHEN '74' THEN '6'
                                    WHEN '75' THEN '7'
                                    WHEN '98' THEN 'Y'
                                    WHEN '99' THEN 'Z'
                                    ELSE 'Z'
                     END AS VARCHAR(3)) AS ClassificacaoCOFINS, -- {A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes}
               CAST(NULL AS Numeric(15,2)) AS BaseCOFINS, -- Base de Clculo COFINS
               CAST(NULL AS Numeric(15,2)) AS ValorCOFINS, -- Valor de COFINS
               CAST(NULL AS Numeric(15,2)) AS AliquotaCOFINS, -- Alquota de COFINS
               CAST(NULL AS Numeric(15,2)) AS ValorIsentasCOFINS, -- Valor Isento de COFINS
               CAST(NULL AS Numeric(15,2)) AS ValorOutrasCOFINS, -- Valor de Outros COFINS
               CAST(CASE FRE.NATBCC WHEN '01' THEN '1'
                                    WHEN '02' THEN '2'
                                    WHEN '03' THEN '3'
                                    WHEN '04' THEN '4'
                                    WHEN '05' THEN '5'
                                    WHEN '06' THEN '6'
                                    WHEN '07' THEN '7'
                                    WHEN '08' THEN '8'
                                    WHEN '09' THEN '9'
                                    --WHEN '10' THEN 'A'
                                    WHEN '11' THEN 'B'
                                    WHEN '12' THEN 'C'
                                    WHEN '13' THEN 'D'
                                    WHEN '14' THEN 'E'
                                    WHEN '15' THEN 'F'
                                    WHEN '16' THEN 'G'
                                    WHEN '17' THEN 'H'
                                    WHEN '18' THEN 'I'
                                    ELSE '0'
                    END AS VARCHAR(1)) AS CodBaseCalcCredito, -- {0=Nenhum,1=Aquisio de bens para revenda,2=Aquisio de bens utilizados como insumo,3=Aquisio de servios utilizados como insumo,4=Energia eltrica e trmica, inclusive sob a forma de vapor,5=Aluguis de prdios,6=Aluguis de mquinas e equipamentos,7=Armazenagem de mercadoria e frete na operao de venda,8=Contraprestaes de arrendamento mercantil,9=Mquinas, equipamentos e outros bens incorporados ao ativo imobilizado,B=Amortizao e Depreciao de edificaes e benfeitorias em imveis,C=Devoluo de Vendas Sujeitas  Incidncia No-Cumulativa,D=Outras Operaes com Direito a Crdito,E=Atividade de Transporte de Cargas  Subcontratao,F=Atividade Imobiliria  Custo Incorrido de Unidade Imobiliria,G=Atividade Imobiliria  Custo Orado de unidade no concluda,H=Atividade de Prestao de Servios de Limpeza, Conservao e Manuteno,I=Estoque de abertura de bens,}
               CAST(NULL AS VARCHAR(1)) AS RegimeIncidencia, -- {0=Cumulativa,1=No-Cumulativa,}
               CAST(CASE FRE.TIPFRE WHEN '0' THEN 'A'
                                    WHEN '1' THEN 'T'
                                    WHEN '2' THEN 'F'
                                    ELSE 'B'
                    END AS VARCHAR(1)) AS TipoFrete, -- A - Por Conta de Terceiros / T  - Por Conta do Emitente  / F - Por Conta do Destinatrio / B - Sem Frete
               CAST(CASE FRE.NATFRE --WHEN '0' THEN '0'
                                    --WHEN '1' THEN '1'
                                    WHEN '2' THEN '2'
                                    WHEN '3' THEN '3'
                                    --WHEN '4' THEN '4'
                                    --WHEN '5' THEN '5'
                                    ELSE '9'
                    END AS VARCHAR(1)) AS IndNaturezaFrete, -- {0=Operaes de vendas, com nus suportado pelo estabelecimento vendedor,1=Operaes de vendas, com nus suportado pelo adquirente,2=Operaes de compras (bens para revenda, matrias prima e outros produtos, geradores de crdito),3=Operaes de compras (bens para revenda, matrias prima e outros produtos, no geradores de crdito),4=Transferncia de produtos acabados entre estabelecimentos da pessoa jurdica,5=Transferncia de produtos entre estabelecimentos da pessoa jurdica,9=Outras}
               CAST(TRIM(FRE.NUMNOT) AS VARCHAR(100)) AS NumeroConhecimento, -- Nmero do Conhecimento
               CAST('0' AS VARCHAR(1)) AS TipoCTE, -- {0=0-CT-e Normal,1=1-CT-e de Complemento de Valores,2=2-CT-e emitido em hiptese de anulao de dbito,3=3-CTE substituto do CT-e anulado,}
               CAST(TRIM(FRE.CHAVEA) AS VARCHAR(60)) AS ChaveCTE, -- Chave do CTE
               CAST(FRE.DATCMP AS Timestamp) AS DataEmissao, -- Data de Emisso
               CAST(FRE.DATOPE AS Timestamp) AS DataEntrada, -- Data de Entrada
               CAST(RTF2TXT(FRE.OBSFAT) AS VARCHAR(60)) AS ObservacaoFiscal, -- Observao Fiscal
               CAST(RTF2TXT(FRE.OBSERV) AS VARCHAR(600)) AS TextoFiscal, -- Texto Fiscal
               CAST(NULL AS Numeric(15,2)) AS ValorDifaCIAP, -- Valor Diferncial de Alquota CIAP
               CAST(NULL AS Numeric(15,2)) AS ValorICMSCIAP, -- Valor de ICMS CIAP
               CAST(NULL AS Numeric(15,2)) AS ValorPISCIAP, -- Valor de PIS CIAP
               CAST(NULL AS Numeric(15,2)) AS ValorCOFINSCIAP -- Valor de COFINS CIAP
          FROM TT_COM FRE
          -- Srie de Emisso do Frete
          LEFT JOIN (SELECT DISTINCT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT, ORIGEM
                       FROM TT_FIS
                      WHERE ORIGEM IN ('C','F')) FIS ON FIS.CODSER = FRE.CODSER AND FIS.SUBSER = COALESCE(FRE.SUBSER,'$$$') AND FIS.ORIGEM = CASE WHEN COALESCE(FRE.TIPPAR,'F') = 'T' THEN 'F' ELSE 'C' END
          -- Natureza
          LEFT JOIN TD_CFO DCFO ON DCFO.CODTAB = FRE.CODCFO
          -- Classificao Fiscal
          LEFT JOIN TD_TRI DTRI ON DTRI.CODTAB = FRE.CODTRI
          -- Transportador
          JOIN TT_CLI PAR ON PAR.FILCLI = FRE.FILFOR AND PAR.CODCLI = FRE.CODFOR
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.FILEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = FRE.FILFOR AND ENDFAT.CODCLI = FRE.CODFOR AND ENDFAT.CODFIL = FRE.FILEND AND ENDFAT.NUMEND = FRE.NUMEND
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          -- Conta Financeira
          JOIN TT_CTA CTA ON CTA.CODFIL = FRE.FILCTA AND CTA.SEQUEN = FRE.SEQCTA AND CTA.TIPCTA = FRE.TIPCTA
          LEFT JOIN TT_CTAXFIL CXF ON CXF.FILCTA = CTA.CODFIL AND CXF.SEQCTA = CTA.SEQUEN AND CXF.CODFIL = FRE.CODFIL
          -- Traz Chave das compras e valores correspondentes a cada nota
          JOIN (SELECT LCOM.CODFIL, LCOM.SEQUEN, FREXCOM.FILFRE, FREXCOM.SEQFRE, LCOM.CODSER, LCOM.SUBSER, LCOM.NUMNOT, LCOM.FILFOR, LCOM.CODFOR, LCOM.TIPPAR,
                       MAX(LCOM.VLRNOT) AS VLRNOT, MAX(LCOM.VLRLIQ) AS VLRLIQ,
                       -- Valores Rateador sero calculados em processo secundrio para que possa tratar rateio de forma correta alm de um melhor desempenho
                       CAST(NULL AS Numeric(15,2)) /*SUM(RateioCustoFrete('FRETE',LICO.CODFIL,LICO.SEQUEN,LICO.NUMITE, FRE.RATEIO_FRETE))*/ AS VLRFRE,  -- Valor do Frete
                       CAST(NULL AS Numeric(15,2)) /*SUM(RateioCustoFrete('BASFRE',LICO.CODFIL,LICO.SEQUEN,LICO.NUMITE, FRE.RATEIO_FRETE))*/ AS BASFRE, -- Base do ICMS do Frete
                       CAST(NULL AS Numeric(15,2)) /*SUM(RateioCustoFrete('ICMFRE',LICO.CODFIL,LICO.SEQUEN,LICO.NUMITE, FRE.RATEIO_FRETE))*/ AS ICMFRE, -- ICMS do Frete
                       CAST(NULL AS Numeric(15,2)) /*SUM(RateioCustoFrete('OUTTAX',LICO.CODFIL,LICO.SEQUEN,LICO.NUMITE, FRE.RATEIO_FRETE))*/ AS OUTTAX, -- Seguro do Frete
                       CAST(NULL AS Numeric(15,2)) /*SUM(RateioCustoFrete('ISEICM',LICO.CODFIL,LICO.SEQUEN,LICO.NUMITE, FRE.RATEIO_FRETE))*/ AS ISEICM, -- Isento do ICMS do Frete
                       CAST(NULL AS Numeric(15,2)) /*SUM(RateioCustoFrete('OUTICM',LICO.CODFIL,LICO.SEQUEN,LICO.NUMITE, FRE.RATEIO_FRETE))*/ AS OUTICM  -- Outros do ICMS do Frete
                  FROM TT_COM LCOM
                  JOIN TT_FREXCOM FREXCOM ON FREXCOM.FILCOM=LCOM.CODFIL AND FREXCOM.SEQCOM=LCOM.SEQUEN
                  --JOIN TT_ICO LICO ON LICO.CODFIL = LCOM.CODFIL AND LICO.SEQUEN = LCOM.SEQUEN
                 WHERE LCOM.FILFRE IS NOT NULL
                   AND LCOM.NUMNOT NOT LIKE '%#%'
                 GROUP BY LCOM.CODFIL, LCOM.SEQUEN, FREXCOM.FILFRE, FREXCOM.SEQFRE, LCOM.CODSER, LCOM.SUBSER, LCOM.NUMNOT, LCOM.FILFOR, LCOM.CODFOR, LCOM.TIPPAR ) COM ON COM.FILFRE = FRE.CODFIL AND COM.SEQFRE = FRE.SEQUEN
          -- Srie de Emisso da Compra
          LEFT JOIN (SELECT DISTINCT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT, ORIGEM
                       FROM TT_FIS
                      WHERE ORIGEM IN ('C','F')) FIS_COM ON FIS_COM.CODSER = COM.CODSER AND FIS_COM.SUBSER = COALESCE(COM.SUBSER,'$$$') AND FIS_COM.ORIGEM = CASE WHEN COALESCE(COM.TIPPAR,'F') = 'T' THEN 'F' ELSE 'C' END
          -- Fornecedor
          JOIN TT_CLI PAR_FOR ON PAR_FOR.FILCLI = COM.FILFOR AND PAR_FOR.CODCLI = COM.CODFOR
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR_FOR.FILCLI AND ENDE.CODCLI = PAR_FOR.CODCLI AND ENDE.CODFIL = PAR_FOR.FILEND AND ENDE.NUMEND = PAR_FOR.FILEND
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN_FOR ON VIN_FOR.FILCLI = PAR_FOR.FILVIN AND VIN_FOR.CODCLI = PAR_FOR.CODVIN AND PAR_FOR.FLGTIP <> 0
         WHERE FRE.TIPPAR = 'T'
           AND FRE.NUMNOT NOT LIKE '%#%'
           AND FRE.EXPEM4 = 'F'
           AND FRE.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',FRE.CODFIL,'','','')
           AND (LeParametroTXT('TIPO_EXP_EME4', FRE.CODFIL, '', '', '') = 'C')
       ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Contas Financeiras do Documento" (Tabela Integrao Mult)
/*-- SEQ 2700 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_PARTEDOCTOCONTAFIN CASCADE;

/*-- SEQ 2701 --*/
CREATE OR REPLACE VIEW TV_TIMU_PARTEDOCTOCONTAFIN AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.FILCTA, TAB.SEQCTA, TAB.TIPCTA, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.CodigoConta, -- Cdigo da Conta Financeira
      TAB.Natureza, -- {0=Crdito;1=Dbito}
      TAB.Valor -- Valor para esta conta financeira
  FROM ( -- Notas de Recebidas
         SELECT
               COM.CODFIL, COM.SEQUEN, CXC.FILCTA, CXC.SEQCTA, CXC.TIPCTA, CAST('CXC' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_PARTEDOCTOCONTAFIN' AS VARCHAR(50)) AS DESTINO, COALESCE(COM.DATINC, COM.DATOPE) AS DATINC, COM.ATU_EM, COM.EXPORT, COM.EXPEM4,
               CAST('COM' || COM.CODFIL || COM.SEQUEN AS VARCHAR(50)) AS CHAVE,
               COALESCE(COM.DATINC, COM.DATOPE) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               CAST(                    TO_NUMBER(NULLIF(regexp_replace(DCFO.EXTCFO, '[^0-9]', '', 'gi'), '')) AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST(TO_NUMBER(COM.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = COM.FILFOR AND REL.CODPAR = COM.CODFOR AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                         ELSE 'C' 
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('2' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST(CASE WHEN ISNOTNULL(FIS.SEREXP)='T' THEN LPAD(TRIM(FIS.SEREXP), 3, '0')||CASE WHEN COM.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(FIS.SUBEXP),'0'), 2, '0') END
                         ELSE LPAD(TRIM(COM.CODSER), 2, '0')||CASE WHEN COM.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(COM.SUBSER),'0'), 3, '0') END
                    END AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(TO_CHAR(TO_NUMBER(TRIM(COM.NUMNOT))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               -- Definido juntamente com a EME4 quando o cdigo da conta financeira no possuir um "-" devemos exportar para uma Conta fixa para posterior reviso
               --CAST(TRIM(COALESCE(CXF.CODEXT, CTA.CODEXT, CODIGO_CONTA(CTA.CODFIL, CTA.SEQUEN, 'X'))) AS VARCHAR(15)) AS CodigoConta, -- Cdigo da Conta Financeira
               CAST(TRIM(CASE WHEN INSTR(COALESCE(CXF.CODEXT, CTA.CODEXT, CODIGO_CONTA(CTA.CODFIL, CTA.SEQUEN, 'X')), '-') > 0 THEN TRIM(SUBSTR(COALESCE(CXF.CODEXT, CTA.CODEXT, CODIGO_CONTA(CTA.CODFIL, CTA.SEQUEN, 'X')),1,15)) ELSE '99999-1' END) AS VARCHAR(15)) AS CodigoConta, -- Cdigo da Conta Financeira
               CAST('1' AS VARCHAR(1)) AS Natureza, -- {0=Crdito;1=Dbito}
               CAST(CXC.VLRRAT AS Numeric(15,2)) AS Valor -- Valor para esta conta financeira
          FROM (SELECT COALESCE(LCXC.CODFIL, LCOM.CODFIL) AS CODFIL, COALESCE(LCXC.SEQUEN, LCOM.SEQUEN) AS SEQUEN, 
                       COALESCE(LCXC.FILCTA, LCOM.FILCTA) AS FILCTA, COALESCE(LCXC.SEQCTA, LCOM.SEQCTA) AS SEQCTA, COALESCE(LCXC.TIPCTA, LCOM.TIPCTA) AS TIPCTA, COALESCE(LCXC.VLRRAT, LCOM.VLRLIQ) AS VLRRAT
                  FROM TT_COM LCOM
                  LEFT JOIN TT_COMXCTA LCXC ON LCXC.CODFIL=LCOM.CODFIL AND LCXC.SEQUEN=LCOM.SEQUEN
                ) CXC
          JOIN TT_COM COM ON COM.CODFIL = CXC.CODFIL AND COM.SEQUEN = CXC.SEQUEN
          -- Srie de Emisso
          LEFT JOIN (SELECT DISTINCT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT, ORIGEM
                       FROM TT_FIS
                      WHERE ORIGEM IN ('C','F')) FIS ON FIS.CODSER = COM.CODSER AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$') AND FIS.ORIGEM = CASE WHEN COALESCE(COM.TIPPAR,'F') = 'T' THEN 'F' ELSE 'C' END
          -- Natureza
          LEFT JOIN TD_CFO DCFO ON DCFO.CODTAB = COM.CODCFO
          -- Fornecedor
          JOIN TT_CLI PAR ON PAR.FILCLI = COM.FILFOR AND PAR.CODCLI = COM.CODFOR
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.FILEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = COM.FILFOR AND ENDFAT.CODCLI = COM.CODFOR AND ENDFAT.CODFIL = COM.FILEND AND ENDFAT.NUMEND = COM.NUMEND
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          JOIN TT_CTA CTA ON CTA.CODFIL = CXC.FILCTA AND CTA.SEQUEN = CXC.SEQCTA AND CTA.TIPCTA = CXC.TIPCTA
          LEFT JOIN TT_CTAXFIL CXF ON CXF.FILCTA = CTA.CODFIL AND CXF.SEQCTA = CTA.SEQUEN AND CXF.CODFIL = CXC.CODFIL
         WHERE COM.FLGEST <> 'D'
           AND COM.NUMNOT NOT LIKE '%#%'
           AND COM.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',COM.CODFIL,'','','')
           AND (LeParametroTXT('TIPO_EXP_EME4', COM.CODFIL, '', '', '') = 'C')
           AND COM.EXPEM4 = 'F'
           -- Definido juntamente com a EME4 que documentos de Transferncia no devem gerar a Parte
          AND NOT EXISTS(SELECT 1 AS OK FROM TT_TRA TRA WHERE TRA.FILICO = COM.CODFIL AND TRA.SEQICO = COM.SEQUEN)
       ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Itens Documento" (Tabela Integrao Mult)
-- Arquivo Pai: TIMU_PARTEDOCTOITEM
/*-- SEQ 2702 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_PARTEDOCTOITEMDAV CASCADE;

/*-- SEQ 2703 --*/
CREATE OR REPLACE VIEW TV_TIMU_PARTEDOCTOITEMDAV AS
   SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (ISNOTNULL(TAB.Acao)='T') THEN TAB.Acao
                WHEN EXISTS(SELECT 1 AS OK FROM TW_EXTXDOC EXD -- Busca para controle da ao pois o DAV pode ser alterado varias vezes antes de ser sincronizado com o EME4
                             WHERE EXD.ORIGEM = TAB.ORIGEM AND EXD.DESTINO = TAB.DESTINO
                               AND EXD.FILORI = TAB.CODFIL AND EXD.SEQORI = TAB.SEQUEN AND EXD.ITEORI = TAB.NUMITE) THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.NUMPED, TAB.TIPPED, TAB.NUMITE, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE, TAB.VLRNOT_VALIDACAO,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.CodigoProduto, -- Cdigo do Produto
      TAB.CodigoServico, -- Cdigo do Servio
      TAB.SeqItemDoc, -- Sequncia do Item no Documento
      TAB.Quantidade, -- Quantidade de itens
      TAB.ValorUnitario, -- Valor Unitrio do Item (No vai ser utilizado, ser calculado)
      TAB.ValorLiquido, -- Valor Lquido do Item (No utilizado, ser utilizado pelo valor bruto)
      TAB.ValorBruto, -- Valor Bruto do Item
      TAB.ValorDesconto, -- Valor total do desconto do item
      TAB.Unidade, -- Cdigo da Unidade do Item no Documento com 6 posies
      TAB.UnidSPED, -- Cdigo da Unidade do Item no Documento com 2 posies - Unidade SPED
      TAB.CodigoContaFinanceira, -- Cdigo da Conta Financeira
      TAB.CodigoCentroCusto, -- Cdigo do Centro de Custo
      TAB.CodigoLote, -- Cdigo do Lote
      TAB.DataFabricacaoLote, -- Data de Fabricao do Lote
      TAB.DataValidadeLote, -- Data de Validade do Lote
      TAB.ValorPMC, -- Valor do Preo Mximo Medicamentos Venda Consumidor
      TAB.NaoCalcularTributacao, -- T/F - Enviar T para que o sistema no recalcule os impostos informados
      TAB.ClassificacaoOrigem, -- Cdigo Classificao Origem
      TAB.CFOP, -- Cdigo Fiscal Operao (0.000)
      TAB.ClassificacaoFiscal, -- Classificao Fiscal {00, 10, 20, 30, 40, 41, 50, 51, 60, 70, 90}
      TAB.RegimeIncidencia, -- {0=Cumulativa,1=No-Cumulativa,}
      TAB.BaseICMS, -- Valor Base de ICMS
      TAB.ValorIsentoICMS, -- Valor Isento de ICMS
      TAB.ValorOutrasICMS, -- Valor Outras ICMS
      TAB.PercRedBaseCalcICMS, -- Percentual Reduo Base Clculo ICMS
      TAB.PercRedValICMS, -- Percentual de Reduo do Valor do ICMS
      TAB.AliquotaICMS, -- Alquota do ICMS
      TAB.ValorICMS, -- Valor do ICMS
      TAB.BaseICMSST, -- Valor Base de ICMS ST
      TAB.AliquotaICMSST, -- Alquota do ICMS ST
      TAB.ValorICMSST, -- Valor de ICMS ST
      TAB.ModalidadeBaseICMSST, -- (A=0 - Preo tabelado ou mximo sugerido,B=1 - Lista Negativa (valor),C=2 - Lista Positiva (valor), D=3 - Lista Neutra (valor),E=4 - Margem Valo Agregado (percentual),F=5 - Pauta (valor))
      TAB.MargemLucroICMSST, -- Margem de Lucro do ICMS ST
      TAB.PercRedICMSST, -- Percentual de Reduo de ICMS ST
      TAB.ClassificacaoPIS, -- A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,
                            -- I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,
                            -- J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,
                            -- M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,
                            -- P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,
                            -- S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,
                            -- V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,
                            -- 1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,
                            -- 6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
      TAB.BasePIS, -- Valor Base PIS
      TAB.ValorIsentoPIS, -- Valor Isento de PIS
      TAB.PercRedPIS, -- Percentual de Reduo do PIS
      TAB.AliquotaPIS, -- Alquota do PIS para Produto
      TAB.AliquotaPISServ, -- Alquota do PIS para Servio
      TAB.ValorPIS, -- Valor do PIS
      TAB.PercRecupCredCOFINSImp, -- Percentual Recuperao Crdito COFINS Importao
      TAB.AliquotaCOFINSImport, -- Alquota do COFINS Importao
      TAB.ValorCOFINSImport, -- Valor do COFINS Importao
      TAB.ClassificacaoCOFINS, -- A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,
                               -- I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,
                               -- J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,
                               -- M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,
                               -- P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,
                               -- S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,
                               -- V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,
                               -- 1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,
                               -- 6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
      TAB.BaseCOFINS, -- Valor Base COFINS
      TAB.AliquotaCOFINS, -- Alquota COFINS
      TAB.ValorCOFINS, -- Valor COFINS
      TAB.PercRecupCredPisImp, -- Percentual Recuperao Crdito PIS Importao
      TAB.ValorPISImport, -- Valor do PIS Importao
      TAB.AliquotaPISImport, -- Alquota do PIS Importao
      TAB.ValorIsentoCOFINS, -- Valor Isento de COFINS
      TAB.PercRedCOFINS, -- Percentual de Reduo do COFINS
      TAB.CodBaseCalcCreditoEnt, -- 0=Nenhum,1=Aquisio de bens para revenda,2=Aquisio de bens utilizados como insumo,3=Aquisio de servios utilizados como insumo,4=Energia eltrica e trmica, inclusive sob a forma de vapor,5=Aluguis de prdios,6=Aluguis de mquinas e equipamentos,7=Armazenagem de mercadoria e frete na operao de venda,
                                 -- 8=Contraprestaes de arrendamento mercantil,9=Mquinas, equipamentos e outros bens incorporados ao ativo imobilizado,B=Amortizao e Depreciao de edificaes e benfeitorias em imveis,C=Devoluo de Vendas Sujeitas  Incidncia No-Cumulativa,D=Outras Operaes com Direito a Crdito,
                                 -- E=Atividade de Transporte de Cargas - Subcontratao,F=Atividade Imobiliria - Custo Incorrido de Unidade Imobiliria,G=Atividade Imobiliria - Custo Orado de unidade no concluda,H=Atividade de Prestao de Servios de Limpeza, Conservao e Manuteno,I=Estoque de abertura de bens,
      TAB.ClassificacaoIPI, -- A=00 - Entrada com recuperao de crdito,B=01 - Entrada tributada com alquota zero,C=02 - Entrada isenta,D=03 - Entrada no-tributada,E=04 - Entrada imune,F=05 - Entrada com suspenso,G=49 - Outras entradas,H=50 - Sada tributada,I=51 - Sada tributada com alquota zero,J=52 - Sada isenta,L=53 - Sada no-tributada,M=54 - Sada imune,N=55 - Sada com suspenso,O=99 - Outras sadas,
      TAB.BaseIPI, -- Valor Base IPI
      TAB.ValorIsentoIPI, -- Valor Isento de IPI
      TAB.ValorOutrasIPI, -- Valor Outras IPI
      TAB.PercRedIPI, -- Percentual de Reduo do IPI
      TAB.AliquotaIPI, -- Alquota IPI
      TAB.ValorIPI, -- Valor IPI
      TAB.ValorICMSOBS, -- Valor ICMS Observao
      TAB.BaseIPIOBS, -- Valor Base IPI Observao
      TAB.AliquotaIPIOBS, -- Aliquota IPI Observao
      TAB.ValorIPIOBS, -- Valor IPI Observao
      TAB.BaseICMSSTOBS, -- Valor Base ICMS ST Observao
      TAB.ValorICMSSTOBS, -- Valor ICMS ST Observao
      TAB.ValorSTRecolhido, -- Valor ST Recolhido
      TAB.BaseINSS, -- Valor Base INSS
      TAB.PercRedINSS, -- Percentual de Reduo do INSS
      TAB.AliquotaINSS, -- Alquota INSS
      TAB.ValorINSS, -- Valor INSS
      TAB.BaseIRRF, -- Valor Base IRRF
      TAB.ValorIsentoIRRF, -- Valor Isento de IRRF
      TAB.PercRedIRRF, -- Percentual de Reduo do IRRF
      TAB.AliquotaIRRF, -- Alquota IRRF
      TAB.ValorIRRF, -- Valor IRRF
      TAB.BaseISS, -- Valor Base ISS
      TAB.PercRedISS, -- Percentual de Reduo do ISS
      TAB.AliquotaISS, -- Alquota ISS
      TAB.ValorISS, -- Valor ISS
      TAB.ValorIsentoISS, -- Valor Isento ISS
      TAB.TemRetencaoISS, -- Tem reteno ISS
      TAB.BaseImpostoImp, -- Base do Imposto de Importao
      TAB.AliqImpostoImp, -- Valor do Imposto de Importao
      TAB.ValorImpostoImp, -- Alquota do Imposto de Importao
      TAB.BaseAFRMM, -- Base do AFRMM
      TAB.AliqAFRMM, -- Valor do AFRMM
      TAB.ValorAFRMM, -- Alquota do AFRMM
      TAB.BasePISRetido, -- Valor Base PIS Retido
      TAB.AliquotaPISRetido, -- Alquota do PIS Retido
      TAB.ValorPISRetido, -- Valor do PIS Retido
      TAB.BaseCOFINSRetido, -- Valor Base COFINS Retido
      TAB.AliquotaCOFINSRetido, -- Alquota COFINS Retido
      TAB.ValorCOFINSRetido, -- Valor COFINS Retido 
      TAB.BaseCSLLRetido, -- Valor Base CSLL Retido
      TAB.AliquotaCSLLRetido, -- Alquota CSLL Retido
      TAB.ValorCSLLRetido, -- Valor CSLL Retido
      TAB.BaseSimplesNac, -- Base Simples Nacional
      TAB.AliquotaSimplesNac, -- Alquota Simples Nacional
      TAB.ValorSimplesNac, -- Valor Simples Nacional
      TAB.FornecDespAduaneiro, -- Fornecedor  Comercial Importadora / Desp. Aduaneiro
      TAB.BaseDifa, -- Base do Diferencial de Alquota
      TAB.AliquotaDifa, -- Valor do Diferencial de Alquota
      TAB.ValorDifa, -- Alquota do Diferencial de Alquota
      TAB.ValorICMSFCPDest, -- Valor do ICMS relativo ao Fundo de Combate  Pobreza (FCP) da UF de destino
      TAB.ValorICMSIntUFDest, -- Valor do ICMS Interestadual para a UF do remetente
      TAB.ValorICMSIntUFRemet, -- Valor do ICMS Interestadual para a UF do remetente
      TAB.ValorICMSFCPSTDest, -- Valor do ICMS ST relativo ao Fundo de Combate  Pobreza (FCP) da UF de destino
      TAB.ValorICMSProprioCIAP, -- Valor ICMS CIAP Nota
      TAB.ValorICMSSTCIAP, -- Valor ICMS ST CIAP Nota
      TAB.ValorDIFACIAP, -- Valor DIFA CIAP Nota
      TAB.VenctoIniCIAP, -- Vencimento Inicial Parcelamento CIAP
      TAB.NroParcICMSCIAP, -- Quantidade de Parcelamento ICMS CIAP (Default 48)
      TAB.BasePisCIAP, -- Base Pis CIAP - Enviar apenas para casos de Importao
      TAB.AliqPisCIAP, -- Alquota Pis CIAP
      TAB.BaseCofinsCIAP, -- Base Cofins CIAP - Enviar apenas para casos de Importao
      TAB.AliqCofinsCIAP, -- Alquota Cofins CIAP
      TAB.NroParcPISCOFCIAP, -- Quantidade Parcelamento PIS/COFINS CIAP
      TAB.ConferidoCIAP, -- Valores j conferidos pelo usurio
      TAB.CFOPSimples, -- Cdigo Fiscal Operao Simples Nacional (0.000)
      TAB.CodigoTabelaOpSpedPis, -- Cdigo da Tabela de Operao do SPED para o PIS
      TAB.CodigoTabelaOpSpedCofins, -- Cdigo da Tabela de Operao do SPED para o COFINS
      TAB.CodigoProjeto, -- Cdigo do Projeto Financeiro
      TAB.CodImpIRRFServico, -- Cdigo do Imposto para IRRF do Servio
      TAB.ValorFrete, -- Valor do Frete para o Item (s funciona se estiver configurado Frete Informado no Item no Tipo Documento)
      TAB.ValorOutrasDespesas, -- Valor de Outras Despesas para o Item  (s funciona se estiver configurado Outras Despesas Informado no Item no Tipo Documento)
      TAB.ValorDescSuframa, -- Valor Desconto Suframa
      TAB.NumAlmox, -- Nmero do Almoxarifado
      TAB.NumPedido, -- Nmero do Pedido (DAV/Pr-Venda)
      TAB.SituacaoItem -- Situao do Item: 0=Normal,1=Cancelado
     FROM (
        -- Item de DAV/Pr-Venda
        SELECT
               IOR.CODFIL, CAST(IOR.TIPPED||IOR.NUMPED AS CHAR(10)) AS SEQUEN, IOR.NUMITE, CAST('IOR' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_PARTEDOCTOITEM' AS VARCHAR(50)) AS DESTINO, ORC.DATINC, ORC.ATU_EM, CAST('F' AS VARCHAR(1)) AS EXPORT, ORC.EXPEM4,
               CAST('ORC' || ORC.CODFIL || ORC.TIPPED || ORC.NUMPED AS VARCHAR(50)) AS CHAVE,
               IOR.NUMPED,
               IOR.TIPPED,
               IOR.VLRPGT AS VLRNOT_VALIDACAO,
               ORC.DATINC AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               CAST(CASE WHEN (COALESCE(ORC.EXPEM4, 'T') = 'T') THEN NULL ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
               -- Definido juntamente com a EME4 quando for cupom fiscal enviar tipo de operao fixo
               CAST(CASE WHEN (ORC.TIPPED = 'O') THEN 995 -- DAV
                         WHEN (ORC.TIPPED = 'P') THEN 994 -- Pr-Venda
                         WHEN (ORC.TIPPED = 'S') THEN 993 -- DAV-OS
                         ELSE NULL
                    END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST(TO_NUMBER(IOR.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = ORC.FILCLI AND REL.CODPAR = ORC.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                         ELSE 'C' 
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST(ORC.TIPPED AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(TO_CHAR(TO_NUMBER(TRIM(COALESCE(ORC.NUMPED_RE,ORC.NUMPED)))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST(TRIM(CASE WHEN PRO.CODFPS <> '09' THEN SUBSTR(GRA.CODFIS,1,30)
                              ELSE NULL
                         END) AS VARCHAR(30)) AS CodigoProduto, -- Cdigo do Produto
               CAST(TRIM(CASE WHEN PRO.CODFPS = '09' THEN SUBSTR(GRA.CODFIS,1,30)
                              ELSE NULL
                         END) AS VARCHAR(30)) AS CodigoServico, -- Cdigo do Servio
               CAST(IOR.NUMITE AS Numeric(9)) AS SeqItemDoc, -- Sequncia do Item no Documento
               CAST(ABS(COALESCE(IOR.QTDITE,0)) AS Numeric(18,6)) AS Quantidade, -- Quantidade de itens
               CAST(ABS((IOR.VLRPGT + CASE WHEN (IOR.DESCON < 0) THEN ABS(IOR.DESCON) ELSE 0 END) / NVLZ(IOR.QTDITE,1)) AS Numeric(16,6)) AS ValorUnitario, -- Valor Unitrio do Item (No vai ser utilizado, ser calculado)
               CAST(0 AS Numeric(15,2)) AS ValorLiquido, -- Valor Lquido do Item (No utilizado, ser utilizado pelo valor bruto)
               CAST(0 AS Numeric(15,2)) AS ValorBruto, -- Valor Bruto do Item
               CAST((CASE WHEN (IOR.DESCON > 0) THEN ABS(IOR.DESCON) ELSE 0 END +
                     CASE WHEN (IOR.DESRAT < 0) THEN ABS(IOR.DESRAT) ELSE 0 END) / NVLZ(IOR.QTDITE,1)
                    AS Numeric(15,2)) AS ValorDesconto, -- Valor total do desconto do item
               CAST(NULL AS VARCHAR(6)) AS Unidade, -- Cdigo da Unidade do Item no Documento com 6 posies
               CAST(DMED_VEN.UNIMED AS VARCHAR(2)) AS UnidSPED, -- Cdigo da Unidade do Item no Documento com 2 posies - Unidade SPED
               -- Definido juntamente com a EME4 quando o cdigo da conta financeira no possuir um "-" devemos exportar para uma Conta fixa para posterior reviso
               CAST(NULL AS VARCHAR(10)) AS CodigoContaFinanceira, -- Cdigo da Conta Financeira
               CAST(NULL AS VARCHAR(10)) AS CodigoCentroCusto, -- Cdigo do Centro de Custo
               CAST(TRIM(LOT.CODEXT) AS VARCHAR(30)) AS CodigoLote, -- Cdigo do Lote
               CAST(NULL AS Timestamp) AS DataFabricacaoLote, -- Data de Fabricao do Lote
               CAST(TRUNC(LOT.DATVAL) AS Timestamp) AS DataValidadeLote, -- Data de Validade do Lote
               CAST(NULL AS Numeric(15,2)) AS ValorPMC, -- Valor do Preo Mximo Medicamentos Venda Consumidor
               CAST('T' AS VARCHAR(1)) AS NaoCalcularTributacao, -- T/F - Enviar T para que o sistema no recalcule os impostos informados
               CAST(PRO.ORIPRO AS VARCHAR(2)) AS ClassificacaoOrigem, -- Cdigo Classificao Origem
               CAST(CASE WHEN (DFIL.UFLOJA <> IBGFAT.SIGEST) AND (ISNOTNULL(DNAT.NATFOR)='T') THEN SUBSTR(DNAT.NATFOR, 1, 1) || '.' || SUBSTR(DNAT.NATFOR, 2, 3)
                         WHEN (ISNOTNULL(DNAT.NATDEN)='T') THEN SUBSTR(DNAT.NATDEN, 1, 1) || '.' || SUBSTR(DNAT.NATDEN, 2, 3)
                         ELSE NULL
                    END AS VARCHAR(20)) AS CFOP, -- Cdigo Fiscal Operao (0.000)
               CAST(CASE WHEN DFIL.REGTRI = 'S' THEN
                           CASE WHEN IOR.ICMTIP = '0' THEN COALESCE(DNAT.CSTNOR, '00')
                                WHEN IOR.ICMTIP = '1' THEN '41'
                                WHEN IOR.ICMTIP = '2' THEN '40'
                                WHEN IOR.ICMTIP = '3' THEN COALESCE(DNAT.CST_ST, '60')
                                WHEN IOR.ICMTIP = '4' THEN '40'
                                ELSE NULL
                           END
                    ELSE
                           CASE WHEN IOR.ICMTIP = '0' THEN COALESCE(DNAT.CSTNOR, '00')
                                WHEN IOR.ICMTIP = '1' THEN '41'
                                WHEN IOR.ICMTIP = '2' THEN '40'
                                WHEN IOR.ICMTIP = '3' THEN COALESCE(DNAT.CST_ST, '60')
                                WHEN IOR.ICMTIP = '4' THEN '40'
                                ELSE NULL
                           END
                    END AS VARCHAR(2)) AS ClassificacaoFiscal, -- Classificao Fiscal {00, 10, 20, 30, 40, 41, 50, 51, 60, 70, 90}
               CAST(NULL AS VARCHAR(1)) AS RegimeIncidencia, -- {0=Cumulativa,1=No-Cumulativa,}
               CAST(ABS(IOR.BASICM) AS Numeric(15,2)) AS BaseICMS, -- Valor Base de ICMS
               CAST(ABS(COALESCE(IOR.ISEICM, 0)) AS Numeric(15,2)) AS ValorIsentoICMS, -- Valor Isento de ICMS
               CAST(NULL AS Numeric(15,2)) AS ValorOutrasICMS, -- Valor Outras ICMS
               CAST(ABS(IOR.REDICM) AS Numeric(18,4)) AS PercRedBaseCalcICMS, -- Percentual Reduo Base Clculo ICMS
               CAST(NULL AS Numeric(18,4)) AS PercRedValICMS, -- Percentual de Reduo do Valor do ICMS
               CAST(CASE WHEN IOR.ICMTIP = '3' THEN 0
                         ELSE ABS(COALESCE(IOR.TAXICM,0))
                    END AS Numeric(15,2)) AS AliquotaICMS, -- Alquota do ICMS
               CAST(ABS(COALESCE(IOR.VLRICM, 0)) AS Numeric(15,2)) AS ValorICMS, -- Valor do ICMS
               CAST(ABS(IOR.BASSUB) AS Numeric(15,2)) AS BaseICMSST, -- Valor Base de ICMS ST
               CAST(ABS(IOR.TAXSUB) AS Numeric(15,2)) AS AliquotaICMSST, -- Alquota do ICMS ST
               CAST(ABS(IOR.VLRSUB) AS Numeric(15,2)) AS ValorICMSST, -- Valor de ICMS ST
               CAST('4' AS VARCHAR(1)) AS ModalidadeBaseICMSST, -- (A=0 - Preo tabelado ou mximo sugerido,B=1 - Lista Negativa (valor),C=2 - Lista Positiva (valor), D=3 - Lista Neutra (valor),E=4 - Margem Valo Agregado (percentual),F=5 - Pauta (valor))
               CAST(ABS(IOR.MVAVEN) AS Numeric(15,2)) AS MargemLucroICMSST, -- Margem de Lucro do ICMS ST
               CAST(ABS(IOR.REDSUB) AS Numeric(18,4)) AS PercRedICMSST, -- Percentual de Reduo de ICMS ST
               CAST(CASE PRO.SITPIS WHEN '01' THEN 'A'
                                    WHEN '02' THEN 'B'
                                    WHEN '03' THEN 'C'
                                    WHEN '04' THEN 'D'
                                    WHEN '06' THEN 'E'
                                    WHEN '07' THEN 'F'
                                    WHEN '08' THEN 'G'
                                    WHEN '09' THEN 'H'
                                    WHEN '05' THEN 'I'
                                    WHEN '49' THEN 'J'
                                    WHEN '50' THEN 'K'
                                    WHEN '51' THEN 'L'
                                    WHEN '52' THEN 'M'
                                    WHEN '53' THEN 'N'
                                    WHEN '54' THEN 'O'
                                    WHEN '55' THEN 'P'
                                    WHEN '56' THEN 'Q'
                                    WHEN '60' THEN 'R'
                                    WHEN '61' THEN 'S'
                                    WHEN '62' THEN 'T'
                                    WHEN '63' THEN 'U'
                                    WHEN '64' THEN 'V'
                                    WHEN '65' THEN 'W'
                                    WHEN '66' THEN 'X'
                                    WHEN '67' THEN '1'
                                    WHEN '70' THEN '2'
                                    WHEN '71' THEN '3'
                                    WHEN '72' THEN '4'
                                    WHEN '73' THEN '5'
                                    WHEN '74' THEN '6'
                                    WHEN '75' THEN '7'
                                    WHEN '98' THEN 'Y'
                                    WHEN '99' THEN 'Z'
                                    ELSE 'Z'
                     END AS VARCHAR(3)) AS ClassificacaoPIS, -- A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,
                                                             -- I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,
                                                             -- J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,
                                                             -- M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,
                                                             -- P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,
                                                             -- S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,
                                                             -- V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,
                                                             -- 1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,
                                                             -- 6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
               CAST(ABS(IOR.BASPIS) AS Numeric(15,2)) AS BasePIS, -- Valor Base PIS
               CAST(NULL AS Numeric(15,2)) AS ValorIsentoPIS, -- Valor Isento de PIS
               CAST(NULL AS Numeric(15,2)) AS PercRedPIS, -- Percentual de Reduo do PIS
               CAST(CASE WHEN PRO.CODFPS <> '09' THEN ABS(PRO.VENPIS) ELSE 0 END AS Numeric(15,2)) AS AliquotaPIS, -- Alquota do PIS para Produto
               CAST(CASE WHEN PRO.CODFPS = '09' THEN ABS(PRO.VENPIS) ELSE 0 END AS Numeric(15,2)) AS AliquotaPISServ, -- Alquota do PIS para Servio
               CAST(ABS(IOR.VLRPIS) AS Numeric(15,2)) AS ValorPIS, -- Valor do PIS
               CAST(NULL AS Numeric(15,2)) AS PercRecupCredCOFINSImp, -- Percentual Recuperao Crdito COFINS Importao
               CAST(NULL AS Numeric(15,2)) AS AliquotaCOFINSImport, -- Alquota do COFINS Importao
               CAST(NULL AS Numeric(15,2)) AS ValorCOFINSImport, -- Valor do COFINS Importao
               CAST(CASE PRO.SITCOF WHEN '01' THEN 'A'
                                    WHEN '02' THEN 'B'
                                    WHEN '03' THEN 'C'
                                    WHEN '04' THEN 'D'
                                    WHEN '06' THEN 'E'
                                    WHEN '07' THEN 'F'
                                    WHEN '08' THEN 'G'
                                    WHEN '09' THEN 'H'
                                    WHEN '05' THEN 'I'
                                    WHEN '49' THEN 'J'
                                    WHEN '50' THEN 'K'
                                    WHEN '51' THEN 'L'
                                    WHEN '52' THEN 'M'
                                    WHEN '53' THEN 'N'
                                    WHEN '54' THEN 'O'
                                    WHEN '55' THEN 'P'
                                    WHEN '56' THEN 'Q'
                                    WHEN '60' THEN 'R'
                                    WHEN '61' THEN 'S'
                                    WHEN '62' THEN 'T'
                                    WHEN '63' THEN 'U'
                                    WHEN '64' THEN 'V'
                                    WHEN '65' THEN 'W'
                                    WHEN '66' THEN 'X'
                                    WHEN '67' THEN '1'
                                    WHEN '70' THEN '2'
                                    WHEN '71' THEN '3'
                                    WHEN '72' THEN '4'
                                    WHEN '73' THEN '5'
                                    WHEN '74' THEN '6'
                                    WHEN '75' THEN '7'
                                    WHEN '98' THEN 'Y'
                                    WHEN '99' THEN 'Z'
                                    ELSE 'Z'
                     END AS VARCHAR(3)) AS ClassificacaoCOFINS, -- A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,
                                                                -- I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,
                                                                -- J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,
                                                                -- M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,
                                                                -- P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,
                                                                -- S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,
                                                                -- V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,
                                                                -- 1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,
                                                                -- 6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
               CAST(ABS(IOR.BASCOF) AS Numeric(15,2)) AS BaseCOFINS, -- Valor Base COFINS
               CAST(ABS(PRO.VENCOF) AS Numeric(15,2)) AS AliquotaCOFINS, -- Alquota COFINS
               CAST(ABS(IOR.VLRCOF) AS Numeric(15,2)) AS ValorCOFINS, -- Valor COFINS
               --IOR.ALICOFVLR, -- Alquota de COFINS por Valor
               --IOR.ALIPISVLR, -- Alquota de PIS por Valor
               CAST(NULL AS Numeric(15,2)) AS PercRecupCredPisImp, -- Percentual Recuperao Crdito PIS Importao
               CAST(NULL AS Numeric(15,2)) AS ValorPISImport, -- Valor do PIS Importao
               CAST(NULL AS Numeric(15,2)) AS AliquotaPISImport, -- Alquota do PIS Importao
               CAST(NULL AS Numeric(15,2)) AS ValorIsentoCOFINS, -- Valor Isento de COFINS
               CAST(NULL AS Numeric(15,2)) AS PercRedCOFINS, -- Percentual de Reduo do COFINS
               CAST(CASE (CASE WHEN PAR.FLGTIP = 0 THEN NULL
                               ELSE DNAT.NATBCC
                          END)
                         WHEN '01' THEN '1'
                         WHEN '02' THEN '2'
                         WHEN '03' THEN '3'
                         WHEN '04' THEN '4'
                         WHEN '05' THEN '5'
                         WHEN '06' THEN '6'
                         WHEN '07' THEN '7'
                         WHEN '08' THEN '8'
                         WHEN '09' THEN '9'
                         --WHEN '10' THEN 'A'
                         WHEN '11' THEN 'B'
                         WHEN '12' THEN 'C'
                         WHEN '13' THEN 'D'
                         WHEN '14' THEN 'E'
                         WHEN '15' THEN 'F'
                         WHEN '16' THEN 'G'
                         WHEN '17' THEN 'H'
                         WHEN '18' THEN 'I'
                         ELSE '0'
                    END AS VARCHAR(1)) AS CodBaseCalcCreditoEnt, -- 0=Nenhum,1=Aquisio de bens para revenda,2=Aquisio de bens utilizados como insumo,3=Aquisio de servios utilizados como insumo,4=Energia eltrica e trmica, inclusive sob a forma de vapor,5=Aluguis de prdios,6=Aluguis de mquinas e equipamentos,7=Armazenagem de mercadoria e frete na operao de venda,
                                                                 -- 8=Contraprestaes de arrendamento mercantil,9=Mquinas, equipamentos e outros bens incorporados ao ativo imobilizado,B=Amortizao e Depreciao de edificaes e benfeitorias em imveis,C=Devoluo de Vendas Sujeitas  Incidncia No-Cumulativa,D=Outras Operaes com Direito a Crdito,
                                                                 -- E=Atividade de Transporte de Cargas - Subcontratao,F=Atividade Imobiliria - Custo Incorrido de Unidade Imobiliria,G=Atividade Imobiliria - Custo Orado de unidade no concluda,H=Atividade de Prestao de Servios de Limpeza, Conservao e Manuteno,I=Estoque de abertura de bens,
               CAST(CASE PRO.SITIPI WHEN '00' THEN 'A'
                                    WHEN '01' THEN 'B'
                                    WHEN '02' THEN 'C'
                                    WHEN '03' THEN 'D'
                                    WHEN '04' THEN 'E'
                                    WHEN '06' THEN 'F'
                                    WHEN '49' THEN 'G'
                                    WHEN '50' THEN 'H'
                                    WHEN '51' THEN 'I'
                                    WHEN '52' THEN 'J'
                                    WHEN '53' THEN 'L'
                                    WHEN '54' THEN 'M'
                                    WHEN '55' THEN 'N'
                                    WHEN '99' THEN 'O'
                                    ELSE 'O'
                     END AS VARCHAR(3)) AS ClassificacaoIPI, -- {A=00 - Entrada com recuperao de crdito,B=01 - Entrada tributada com alquota zero,C=02 - Entrada isenta,D=03 - Entrada no-tributada,E=04 - Entrada imune,F=05 - Entrada com suspenso,G=49 - Outras entradas,H=50 - Sada tributada,I=51 - Sada tributada com alquota zero,J=52 - Sada isenta,L=53 - Sada no-tributada,M=54 - Sada imune,N=55 - Sada com suspenso,O=99 - Outras sadas,}
               CAST(ABS(IOR.BASIPI) AS Numeric(15,2)) AS BaseIPI, -- Valor Base IPI
               CAST(NULL AS Numeric(15,2)) AS ValorIsentoIPI, -- Valor Isento de IPI
               CAST(NULL AS Numeric(15,2)) AS ValorOutrasIPI, -- Valor Outras IPI
               CAST(NULL AS Numeric(15,2)) AS PercRedIPI, -- Percentual de Reduo do IPI
               CAST(ABS(IOR.PERIPI) AS Numeric(15,2)) AS AliquotaIPI, -- Alquota IPI
               CAST(ABS(IOR.VLRIPI) AS Numeric(15,2)) AS ValorIPI, -- Valor IPI
               CAST(NULL AS Numeric(15,2)) AS ValorICMSOBS, -- Valor ICMS Observao
               CAST(NULL AS Numeric(15,2)) AS BaseIPIOBS, -- Valor Base IPI Observao
               CAST(NULL AS Numeric(15,2)) AS AliquotaIPIOBS, -- Aliquota IPI Observao
               CAST(NULL AS Numeric(15,2)) AS ValorIPIOBS, -- Valor IPI Observao
               CAST(NULL AS Numeric(15,2)) AS BaseICMSSTOBS, -- Valor Base ICMS ST Observao
               CAST(NULL AS Numeric(15,2)) AS ValorICMSSTOBS, -- Valor ICMS ST Observao
               CAST(NULL AS Numeric(18,6)) AS ValorSTRecolhido, -- Valor ST Recolhido
               CAST(NULL AS Numeric(15,2)) AS BaseINSS, -- Valor Base INSS
               CAST(NULL AS Numeric(15,2)) AS PercRedINSS, -- Percentual de Reduo do INSS
               CAST(NULL AS Numeric(15,2)) AS AliquotaINSS, -- Alquota INSS
               CAST(NULL AS Numeric(15,2)) AS ValorINSS, -- Valor INSS
               CAST(ABS(IOR.VLRITE) + ABS(IOR.VLRFRE) + ABS(IOR.VLRSEG) AS Numeric(15,2)) AS BaseIRRF, -- Valor Base IRRF
               CAST(NULL AS Numeric(15,2)) AS ValorIsentoIRRF, -- Valor Isento de IRRF
               CAST(ABS(PRO.RESIRR - ((PRO.RESIRR * IOR.PERLUC) / 100)) AS Numeric(15,2)) AS PercRedIRRF, -- Percentual de Reduo do IRRF
               CAST(ABS((PRO.RESIRR * IOR.PERLUC) / 100) AS Numeric(15,2)) AS AliquotaIRRF, -- Alquota IRRF
               CAST(ABS(IOR.VLRIRR) AS Numeric(15,2)) AS ValorIRRF, -- Valor IRRF
               CAST(NULL AS Numeric(15,2)) AS BaseISS, -- Valor Base ISS
               CAST(NULL AS Numeric(15,2)) AS PercRedISS, -- Percentual de Reduo do ISS
               CAST(NULL AS Numeric(15,2)) AS AliquotaISS, -- Alquota ISS
               CAST(NULL AS Numeric(15,2)) AS ValorISS, -- Valor ISS
               CAST(NULL AS Numeric(15,2)) AS ValorIsentoISS, -- Valor Isento ISS
               CAST(NULL AS VARCHAR(1)) AS TemRetencaoISS, -- Tem reteno ISS
               CAST(NULL AS Numeric(15,2)) AS BaseImpostoImp, -- Base do Imposto de Importao
               CAST(NULL AS Numeric(15,2)) AS AliqImpostoImp, -- Valor do Imposto de Importao
               CAST(NULL AS Numeric(15,2)) AS ValorImpostoImp, -- Alquota do Imposto de Importao
               CAST(NULL AS Numeric(15,2)) AS BaseAFRMM, -- Base do AFRMM
               CAST(NULL AS Numeric(15,2)) AS AliqAFRMM, -- Valor do AFRMM
               CAST(NULL AS Numeric(15,2)) AS ValorAFRMM, -- Alquota do AFRMM
               CAST(NULL AS Numeric(15,2)) AS BasePISRetido, -- Valor Base PIS Retido
               CAST(NULL AS Numeric(15,2)) AS AliquotaPISRetido, -- Alquota do PIS Retido
               CAST(NULL AS Numeric(15,2)) AS ValorPISRetido, -- Valor do PIS Retido
               CAST(NULL AS Numeric(15,2)) AS BaseCOFINSRetido, -- Valor Base COFINS Retido
               CAST(NULL AS Numeric(15,2)) AS AliquotaCOFINSRetido, -- Alquota COFINS Retido
               CAST(NULL AS Numeric(15,2)) AS ValorCOFINSRetido, -- Valor COFINS Retido 
               CAST(NULL AS Numeric(15,2)) AS BaseCSLLRetido, -- Valor Base CSLL Retido
               CAST(NULL AS Numeric(15,2)) AS AliquotaCSLLRetido, -- Alquota CSLL Retido
               CAST(NULL AS Numeric(15,2)) AS ValorCSLLRetido, -- Valor CSLL Retido
               CAST(NULL AS Numeric(15,2)) AS BaseSimplesNac, -- Base Simples Nacional
               CAST(NULL AS Numeric(15,2)) AS AliquotaSimplesNac, -- Alquota Simples Nacional
               CAST(NULL AS Numeric(15,2)) AS ValorSimplesNac, -- Valor Simples Nacional
               CAST(NULL AS VARCHAR(1)) AS FornecDespAduaneiro, -- Fornecedor  Comercial Importadora / Desp. Aduaneiro
               CAST(NULL AS Numeric(15,2)) AS BaseDifa, -- Base do Diferencial de Alquota
               CAST(NULL AS Numeric(15,2)) AS AliquotaDifa, -- Valor do Diferencial de Alquota
               CAST(NULL AS Numeric(15,2)) AS ValorDifa, -- Alquota do Diferencial de Alquota
               CAST(NULL AS Numeric(15,2)) AS ValorICMSFCPDest, -- Valor do ICMS relativo ao Fundo de Combate  Pobreza (FCP) da UF de destino
               CAST(NULL AS Numeric(15,2)) AS ValorICMSIntUFDest, -- Valor do ICMS Interestadual para a UF do remetente
               CAST(NULL AS Numeric(15,2)) AS ValorICMSIntUFRemet, -- Valor do ICMS Interestadual para a UF do remetente
               CAST(NULL AS Numeric(15,2)) AS ValorICMSFCPSTDest, -- Valor do ICMS ST relativo ao Fundo de Combate  Pobreza (FCP) da UF de destino
               CAST(NULL AS Numeric(15,2)) AS ValorICMSProprioCIAP, -- Valor ICMS CIAP Nota
               CAST(NULL AS Numeric(15,2)) AS ValorICMSSTCIAP, -- Valor ICMS ST CIAP Nota
               CAST(NULL AS Numeric(15,2)) AS ValorDIFACIAP, -- Valor DIFA CIAP Nota
               CAST(NULL AS Timestamp) AS VenctoIniCIAP, -- Vencimento Inicial Parcelamento CIAP
               CAST(NULL AS Numeric(8)) AS NroParcICMSCIAP, -- Quantidade de Parcelamento ICMS CIAP (Default 48)
               CAST(NULL AS Numeric(15,2)) AS BasePisCIAP, -- Base Pis CIAP - Enviar apenas para casos de Importao
               CAST(NULL AS Numeric(15,2)) AS AliqPisCIAP, -- Alquota Pis CIAP
               CAST(NULL AS Numeric(15,2)) AS BaseCofinsCIAP, -- Base Cofins CIAP - Enviar apenas para casos de Importao
               CAST(NULL AS Numeric(15,2)) AS AliqCofinsCIAP, -- Alquota Cofins CIAP
               CAST(NULL AS Numeric(8)) AS NroParcPISCOFCIAP, -- Quantidade Parcelamento PIS/COFINS CIAP
               CAST('F' AS VARCHAR(1)) AS ConferidoCIAP, -- Valores j conferidos pelo usurio
               CAST(NULL AS VARCHAR(20)) AS CFOPSimples, -- Cdigo Fiscal Operao Simples Nacional (0.000)
               CAST(NULL AS Numeric(4)) AS CodigoTabelaOpSpedPis, -- Cdigo da Tabela de Operao do SPED para o PIS
               CAST(NULL AS Numeric(9)) AS CodigoTabelaOpSpedCofins, -- Cdigo da Tabela de Operao do SPED para o COFINS
               CAST(NULL AS VARCHAR(20)) AS CodigoProjeto, -- Cdigo do Projeto Financeiro
               CAST(NULL AS VARCHAR(20)) AS CodImpIRRFServico, -- Cdigo do Imposto para IRRF do Servio
               --CAST(ABS(IOR.VLRFRE) AS Numeric(15,2)) AS ValorFrete, -- Valor do Frete para o Item (s funciona se estiver configurado Frete Informado no Item no Tipo Documento)
               CAST(NULL AS Numeric(15,2)) AS ValorFrete, -- Valor do Frete para o Item (s funciona se estiver configurado Frete Informado no Item no Tipo Documento)
               --CAST(ABS(IOR.OUTTAX) AS Numeric(15,2)) AS ValorOutrasDespesas, -- Valor de Outras Despesas para o Item  (s funciona se estiver configurado Outras Despesas Informado no Item no Tipo Documento)
               CAST(NULL AS Numeric(15,2)) AS ValorOutrasDespesas, -- Valor de Outras Despesas para o Item  (s funciona se estiver configurado Outras Despesas Informado no Item no Tipo Documento)
               CAST(NULL AS Numeric(15,2)) AS ValorDescSuframa, -- Valor Desconto Suframa
               CAST(TO_NUMBER(DMUL.CODEXT_DMUL) AS Numeric(10)) AS NumAlmox, -- Nmero do Almoxarifado
               CAST(NULL AS Numeric(10)) AS NumPedido, -- Nmero do Pedido (DAV/Pr-Venda)
               CAST(CASE WHEN IOR.FLGEST='C' THEN '1'
                         ELSE '0'
                    END AS VARCHAR(1)) AS SituacaoItem -- Situao do Item: 0=Normal,1=Cancelado
          FROM TT_IOR IOR
          JOIN TT_ORC ORC ON ORC.CODFIL = IOR.CODFIL AND ORC.TIPPED = IOR.TIPPED AND ORC.NUMPED = IOR.NUMPED
          JOIN TD_FIL DFIL ON DFIL.CODFIL = IOR.CODFIL
          CROSS JOIN TT_CFG CFG
          -- Natureza
          JOIN TD_NAT DNAT ON DNAT.CODTAB = CFG.NATVEN
          -- Cliente
          JOIN TT_CLI PAR ON PAR.FILCLI = ORC.FILCLI AND PAR.CODCLI = ORC.CODCLI
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = ORC.FILCLI AND ENDFAT.CODCLI = ORC.CODCLI AND ENDFAT.CODFIL = ORC.FILFAT AND ENDFAT.NUMEND = ORC.NUMFAT
          LEFT JOIN TT_MUN MUNFAT ON MUNFAT.CODIGO = ENDFAT.CODCID
          LEFT JOIN TT_IBG IBGFAT ON IBGFAT.CODIBG = COALESCE(ENDFAT.CODIBG, MUNFAT.CODIBG)
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          -- Produto
          JOIN TT_GRA GRA ON GRA.FILMAT = IOR.FILMAT AND GRA.CODMAT = IOR.CODMAT AND GRA.CODCOR = IOR.CODCOR AND GRA.CODTAM = IOR.CODTAM --COALESCE(IOR.EMBORI, IOR.CODTAM)
          JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
          JOIN TT_DIV DIV ON DIV.CODITE = GRA.CODCOR
          JOIN TD_DIV DDIV ON DDIV.CODTAB = DIV.CODDIV
          JOIN TT_SUB SUB ON SUB.CODITE = GRA.CODTAM
          JOIN TD_SUB DSUB ON DSUB.CODTAB = SUB.CODSUB
          JOIN TD_MUL DMUL ON DMUL.CODTAB = IOR.CODMUL
          LEFT JOIN TD_MED DMED_VEN ON DMED_VEN.CODTAB = GRA.UNIDAD
          -- Lote
          LEFT JOIN TT_LOT LOT ON LOT.CODFIL = IOR.FILLOT AND LOT.SEQUEN = IOR.SEQLOT
         WHERE ORC.PED_EM >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',ORC.CODFIL,'','','')
           AND ((ORC.EXPEM4 = 'F') OR (ORC.EXPORT = 'F'))
           AND LeParametroBoo('EXP_DAV_EME4',ORC.CODFIL,'','','') = 'T'
         UNION ALL
        -- Itens Excludos
        SELECT
               LIORPAF.CODFIL, CAST(LIORPAF.TIPPED||LIORPAF.NUMPED AS CHAR(10)) AS SEQUEN, LIORPAF.NUMITE, CAST('LIO' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_PARTEDOCTOITEM' AS VARCHAR(50)) AS DESTINO, ORC.PED_EM AS DATINC, ORC.ATU_EM, CAST('F' AS VARCHAR(1)) AS EXPORT, ORC.EXPEM4,
               CAST('ORC' || ORC.CODFIL || ORC.TIPPED || ORC.NUMPED AS VARCHAR(50)) AS CHAVE,
               LIORPAF.NUMPED,
               LIORPAF.TIPPED,
               LIORPAF.VLRPGT AS VLRNOT_VALIDACAO,
               ORC.PED_EM AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               CAST('E' AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
               -- Definido juntamente com a EME4 quando for cupom fiscal enviar tipo de operao fixo
               CAST(CASE WHEN (ORC.TIPPED = 'O') THEN 995 -- DAV
                         WHEN (ORC.TIPPED = 'P') THEN 994 -- Pr-Venda
                         WHEN (ORC.TIPPED = 'S') THEN 993 -- DAV-OS
                         ELSE NULL
                    END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST(TO_NUMBER(LIORPAF.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = ORC.FILCLI AND REL.CODPAR = ORC.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                         ELSE 'C' 
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST(ORC.TIPPED AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(TO_CHAR(TO_NUMBER(TRIM(COALESCE(ORC.NUMPED_RE,ORC.NUMPED)))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST(TRIM(CASE WHEN PRO.CODFPS <> '09' THEN SUBSTR(GRA.CODFIS,1,30)
                              ELSE NULL
                         END) AS VARCHAR(30)) AS CodigoProduto, -- Cdigo do Produto
               CAST(TRIM(CASE WHEN PRO.CODFPS = '09' THEN SUBSTR(GRA.CODFIS,1,30)
                              ELSE NULL
                         END) AS VARCHAR(30)) AS CodigoServico, -- Cdigo do Servio
               CAST(LIORPAF.NUMITE AS Numeric(9)) AS SeqItemDoc, -- Sequncia do Item no Documento
               CAST(ABS(LIORPAF.QTDITE) AS Numeric(18,6)) AS Quantidade, -- Quantidade de itens
               CAST(ABS((LIORPAF.VLRPGT + CASE WHEN (LIORPAF.DESCON < 0) THEN ABS(LIORPAF.DESCON) ELSE 0 END) / NVLZ(LIORPAF.QTDITE,1)) AS Numeric(16,6)) AS ValorUnitario, -- Valor Unitrio do Item (No vai ser utilizado, ser calculado)
               CAST(0 AS Numeric(15,2)) AS ValorLiquido, -- Valor Lquido do Item (No utilizado, ser utilizado pelo valor bruto)
               CAST(0 AS Numeric(15,2)) AS ValorBruto, -- Valor Bruto do Item
               CAST(CASE WHEN (LIORPAF.DESCON > 0) THEN (ABS(LIORPAF.DESCON) / NVLZ(LIORPAF.QTDITE,1)) ELSE 0 END AS Numeric(15,2)) AS ValorDesconto, -- Valor total do desconto do item
               CAST(NULL AS VARCHAR(6)) AS Unidade, -- Cdigo da Unidade do Item no Documento com 6 posies
               CAST(DMED_VEN.UNIMED AS VARCHAR(2)) AS UnidSPED, -- Cdigo da Unidade do Item no Documento com 2 posies - Unidade SPED
               -- Definido juntamente com a EME4 quando o cdigo da conta financeira no possuir um "-" devemos exportar para uma Conta fixa para posterior reviso
               CAST(NULL AS VARCHAR(10)) AS CodigoContaFinanceira, -- Cdigo da Conta Financeira
               CAST(NULL AS VARCHAR(10)) AS CodigoCentroCusto, -- Cdigo do Centro de Custo
               CAST(NULL AS VARCHAR(30)) AS CodigoLote, -- Cdigo do Lote
               CAST(NULL AS Timestamp) AS DataFabricacaoLote, -- Data de Fabricao do Lote
               CAST(NULL AS Timestamp) AS DataValidadeLote, -- Data de Validade do Lote
               CAST(NULL AS Numeric(15,2)) AS ValorPMC, -- Valor do Preo Mximo Medicamentos Venda Consumidor
               CAST('T' AS VARCHAR(1)) AS NaoCalcularTributacao, -- T/F - Enviar T para que o sistema no recalcule os impostos informados
               CAST(PRO.ORIPRO AS VARCHAR(2)) AS ClassificacaoOrigem, -- Cdigo Classificao Origem
               CAST(NULL AS VARCHAR(20)) AS CFOP, -- Cdigo Fiscal Operao (0.000)
               CAST(NULL AS VARCHAR(2)) AS ClassificacaoFiscal, -- Classificao Fiscal {00, 10, 20, 30, 40, 41, 50, 51, 60, 70, 90}
               CAST(NULL AS VARCHAR(1)) AS RegimeIncidencia, -- {0=Cumulativa,1=No-Cumulativa,}
               CAST(NULL AS Numeric(15,2)) AS BaseICMS, -- Valor Base de ICMS
               CAST(NULL AS Numeric(15,2)) AS ValorIsentoICMS, -- Valor Isento de ICMS
               CAST(NULL AS Numeric(15,2)) AS ValorOutrasICMS, -- Valor Outras ICMS
               CAST(NULL AS Numeric(18,4)) AS PercRedBaseCalcICMS, -- Percentual Reduo Base Clculo ICMS
               CAST(NULL AS Numeric(18,4)) AS PercRedValICMS, -- Percentual de Reduo do Valor do ICMS
               CAST(NULL AS Numeric(15,2)) AS AliquotaICMS, -- Alquota do ICMS
               CAST(NULL AS Numeric(15,2)) AS ValorICMS, -- Valor do ICMS
               CAST(NULL AS Numeric(15,2)) AS BaseICMSST, -- Valor Base de ICMS ST
               CAST(NULL AS Numeric(15,2)) AS AliquotaICMSST, -- Alquota do ICMS ST
               CAST(NULL AS Numeric(15,2)) AS ValorICMSST, -- Valor de ICMS ST
               CAST(NULL AS VARCHAR(1)) AS ModalidadeBaseICMSST, -- (A=0 - Preo tabelado ou mximo sugerido,B=1 - Lista Negativa (valor),C=2 - Lista Positiva (valor), D=3 - Lista Neutra (valor),E=4 - Margem Valo Agregado (percentual),F=5 - Pauta (valor))
               CAST(NULL AS Numeric(15,2)) AS MargemLucroICMSST, -- Margem de Lucro do ICMS ST
               CAST(NULL AS Numeric(18,4)) AS PercRedICMSST, -- Percentual de Reduo de ICMS ST
               CAST(NULL AS VARCHAR(3)) AS ClassificacaoPIS, -- A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,
                                                             -- I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,
                                                             -- J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,
                                                             -- M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,
                                                             -- P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,
                                                             -- S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,
                                                             -- V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,
                                                             -- 1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,
                                                             -- 6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
               CAST(NULL AS Numeric(15,2)) AS BasePIS, -- Valor Base PIS
               CAST(NULL AS Numeric(15,2)) AS ValorIsentoPIS, -- Valor Isento de PIS
               CAST(NULL AS Numeric(15,2)) AS PercRedPIS, -- Percentual de Reduo do PIS
               CAST(NULL AS Numeric(15,2)) AS AliquotaPIS, -- Alquota do PIS para Produto
               CAST(NULL AS Numeric(15,2)) AS AliquotaPISServ, -- Alquota do PIS para Servio
               CAST(NULL AS Numeric(15,2)) AS ValorPIS, -- Valor do PIS
               CAST(NULL AS Numeric(15,2)) AS PercRecupCredCOFINSImp, -- Percentual Recuperao Crdito COFINS Importao
               CAST(NULL AS Numeric(15,2)) AS AliquotaCOFINSImport, -- Alquota do COFINS Importao
               CAST(NULL AS Numeric(15,2)) AS ValorCOFINSImport, -- Valor do COFINS Importao
               CAST(NULL AS VARCHAR(3)) AS ClassificacaoCOFINS, -- A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,
                                                                -- I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,
                                                                -- J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,
                                                                -- M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,
                                                                -- P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,
                                                                -- S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,
                                                                -- V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,
                                                                -- 1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,
                                                                -- 6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
               CAST(NULL AS Numeric(15,2)) AS BaseCOFINS, -- Valor Base COFINS
               CAST(NULL AS Numeric(15,2)) AS AliquotaCOFINS, -- Alquota COFINS
               CAST(NULL AS Numeric(15,2)) AS ValorCOFINS, -- Valor COFINS
               CAST(NULL AS Numeric(15,2)) AS PercRecupCredPisImp, -- Percentual Recuperao Crdito PIS Importao
               CAST(NULL AS Numeric(15,2)) AS ValorPISImport, -- Valor do PIS Importao
               CAST(NULL AS Numeric(15,2)) AS AliquotaPISImport, -- Alquota do PIS Importao
               CAST(NULL AS Numeric(15,2)) AS ValorIsentoCOFINS, -- Valor Isento de COFINS
               CAST(NULL AS Numeric(15,2)) AS PercRedCOFINS, -- Percentual de Reduo do COFINS
               CAST(NULL AS VARCHAR(1)) AS CodBaseCalcCreditoEnt, -- 0=Nenhum,1=Aquisio de bens para revenda,2=Aquisio de bens utilizados como insumo,3=Aquisio de servios utilizados como insumo,4=Energia eltrica e trmica, inclusive sob a forma de vapor,5=Aluguis de prdios,6=Aluguis de mquinas e equipamentos,7=Armazenagem de mercadoria e frete na operao de venda,
                                                                 -- 8=Contraprestaes de arrendamento mercantil,9=Mquinas, equipamentos e outros bens incorporados ao ativo imobilizado,B=Amortizao e Depreciao de edificaes e benfeitorias em imveis,C=Devoluo de Vendas Sujeitas  Incidncia No-Cumulativa,D=Outras Operaes com Direito a Crdito,
                                                                 -- E=Atividade de Transporte de Cargas - Subcontratao,F=Atividade Imobiliria - Custo Incorrido de Unidade Imobiliria,G=Atividade Imobiliria - Custo Orado de unidade no concluda,H=Atividade de Prestao de Servios de Limpeza, Conservao e Manuteno,I=Estoque de abertura de bens,
               CAST(NULL AS VARCHAR(3)) AS ClassificacaoIPI, -- {A=00 - Entrada com recuperao de crdito,B=01 - Entrada tributada com alquota zero,C=02 - Entrada isenta,D=03 - Entrada no-tributada,E=04 - Entrada imune,F=05 - Entrada com suspenso,G=49 - Outras entradas,H=50 - Sada tributada,I=51 - Sada tributada com alquota zero,J=52 - Sada isenta,L=53 - Sada no-tributada,M=54 - Sada imune,N=55 - Sada com suspenso,O=99 - Outras sadas,}
               CAST(NULL AS Numeric(15,2)) AS BaseIPI, -- Valor Base IPI
               CAST(NULL AS Numeric(15,2)) AS ValorIsentoIPI, -- Valor Isento de IPI
               CAST(NULL AS Numeric(15,2)) AS ValorOutrasIPI, -- Valor Outras IPI
               CAST(NULL AS Numeric(15,2)) AS PercRedIPI, -- Percentual de Reduo do IPI
               CAST(NULL AS Numeric(15,2)) AS AliquotaIPI, -- Alquota IPI
               CAST(NULL AS Numeric(15,2)) AS ValorIPI, -- Valor IPI
               CAST(NULL AS Numeric(15,2)) AS ValorICMSOBS, -- Valor ICMS Observao
               CAST(NULL AS Numeric(15,2)) AS BaseIPIOBS, -- Valor Base IPI Observao
               CAST(NULL AS Numeric(15,2)) AS AliquotaIPIOBS, -- Aliquota IPI Observao
               CAST(NULL AS Numeric(15,2)) AS ValorIPIOBS, -- Valor IPI Observao
               CAST(NULL AS Numeric(15,2)) AS BaseICMSSTOBS, -- Valor Base ICMS ST Observao
               CAST(NULL AS Numeric(15,2)) AS ValorICMSSTOBS, -- Valor ICMS ST Observao
               CAST(NULL AS Numeric(18,6)) AS ValorSTRecolhido, -- Valor ST Recolhido
               CAST(NULL AS Numeric(15,2)) AS BaseINSS, -- Valor Base INSS
               CAST(NULL AS Numeric(15,2)) AS PercRedINSS, -- Percentual de Reduo do INSS
               CAST(NULL AS Numeric(15,2)) AS AliquotaINSS, -- Alquota INSS
               CAST(NULL AS Numeric(15,2)) AS ValorINSS, -- Valor INSS
               CAST(NULL AS Numeric(15,2)) AS BaseIRRF, -- Valor Base IRRF
               CAST(NULL AS Numeric(15,2)) AS ValorIsentoIRRF, -- Valor Isento de IRRF
               CAST(NULL AS Numeric(15,2)) AS PercRedIRRF, -- Percentual de Reduo do IRRF
               CAST(NULL AS Numeric(15,2)) AS AliquotaIRRF, -- Alquota IRRF
               CAST(NULL AS Numeric(15,2)) AS ValorIRRF, -- Valor IRRF
               CAST(NULL AS Numeric(15,2)) AS BaseISS, -- Valor Base ISS
               CAST(NULL AS Numeric(15,2)) AS PercRedISS, -- Percentual de Reduo do ISS
               CAST(NULL AS Numeric(15,2)) AS AliquotaISS, -- Alquota ISS
               CAST(NULL AS Numeric(15,2)) AS ValorISS, -- Valor ISS
               CAST(NULL AS Numeric(15,2)) AS ValorIsentoISS, -- Valor Isento ISS
               CAST(NULL AS VARCHAR(1)) AS TemRetencaoISS, -- Tem reteno ISS
               CAST(NULL AS Numeric(15,2)) AS BaseImpostoImp, -- Base do Imposto de Importao
               CAST(NULL AS Numeric(15,2)) AS AliqImpostoImp, -- Valor do Imposto de Importao
               CAST(NULL AS Numeric(15,2)) AS ValorImpostoImp, -- Alquota do Imposto de Importao
               CAST(NULL AS Numeric(15,2)) AS BaseAFRMM, -- Base do AFRMM
               CAST(NULL AS Numeric(15,2)) AS AliqAFRMM, -- Valor do AFRMM
               CAST(NULL AS Numeric(15,2)) AS ValorAFRMM, -- Alquota do AFRMM
               CAST(NULL AS Numeric(15,2)) AS BasePISRetido, -- Valor Base PIS Retido
               CAST(NULL AS Numeric(15,2)) AS AliquotaPISRetido, -- Alquota do PIS Retido
               CAST(NULL AS Numeric(15,2)) AS ValorPISRetido, -- Valor do PIS Retido
               CAST(NULL AS Numeric(15,2)) AS BaseCOFINSRetido, -- Valor Base COFINS Retido
               CAST(NULL AS Numeric(15,2)) AS AliquotaCOFINSRetido, -- Alquota COFINS Retido
               CAST(NULL AS Numeric(15,2)) AS ValorCOFINSRetido, -- Valor COFINS Retido 
               CAST(NULL AS Numeric(15,2)) AS BaseCSLLRetido, -- Valor Base CSLL Retido
               CAST(NULL AS Numeric(15,2)) AS AliquotaCSLLRetido, -- Alquota CSLL Retido
               CAST(NULL AS Numeric(15,2)) AS ValorCSLLRetido, -- Valor CSLL Retido
               CAST(NULL AS Numeric(15,2)) AS BaseSimplesNac, -- Base Simples Nacional
               CAST(NULL AS Numeric(15,2)) AS AliquotaSimplesNac, -- Alquota Simples Nacional
               CAST(NULL AS Numeric(15,2)) AS ValorSimplesNac, -- Valor Simples Nacional
               CAST(NULL AS VARCHAR(1)) AS FornecDespAduaneiro, -- Fornecedor  Comercial Importadora / Desp. Aduaneiro
               CAST(NULL AS Numeric(15,2)) AS BaseDifa, -- Base do Diferencial de Alquota
               CAST(NULL AS Numeric(15,2)) AS AliquotaDifa, -- Valor do Diferencial de Alquota
               CAST(NULL AS Numeric(15,2)) AS ValorDifa, -- Alquota do Diferencial de Alquota
               CAST(NULL AS Numeric(15,2)) AS ValorICMSFCPDest, -- Valor do ICMS relativo ao Fundo de Combate  Pobreza (FCP) da UF de destino
               CAST(NULL AS Numeric(15,2)) AS ValorICMSIntUFDest, -- Valor do ICMS Interestadual para a UF do remetente
               CAST(NULL AS Numeric(15,2)) AS ValorICMSIntUFRemet, -- Valor do ICMS Interestadual para a UF do remetente
               CAST(NULL AS Numeric(15,2)) AS ValorICMSFCPSTDest, -- Valor do ICMS ST relativo ao Fundo de Combate  Pobreza (FCP) da UF de destino
               CAST(NULL AS Numeric(15,2)) AS ValorICMSProprioCIAP, -- Valor ICMS CIAP Nota
               CAST(NULL AS Numeric(15,2)) AS ValorICMSSTCIAP, -- Valor ICMS ST CIAP Nota
               CAST(NULL AS Numeric(15,2)) AS ValorDIFACIAP, -- Valor DIFA CIAP Nota
               CAST(NULL AS Timestamp) AS VenctoIniCIAP, -- Vencimento Inicial Parcelamento CIAP
               CAST(NULL AS Numeric(8)) AS NroParcICMSCIAP, -- Quantidade de Parcelamento ICMS CIAP (Default 48)
               CAST(NULL AS Numeric(15,2)) AS BasePisCIAP, -- Base Pis CIAP - Enviar apenas para casos de Importao
               CAST(NULL AS Numeric(15,2)) AS AliqPisCIAP, -- Alquota Pis CIAP
               CAST(NULL AS Numeric(15,2)) AS BaseCofinsCIAP, -- Base Cofins CIAP - Enviar apenas para casos de Importao
               CAST(NULL AS Numeric(15,2)) AS AliqCofinsCIAP, -- Alquota Cofins CIAP
               CAST(NULL AS Numeric(8)) AS NroParcPISCOFCIAP, -- Quantidade Parcelamento PIS/COFINS CIAP
               CAST('F' AS VARCHAR(1)) AS ConferidoCIAP, -- Valores j conferidos pelo usurio
               CAST(NULL AS VARCHAR(20)) AS CFOPSimples, -- Cdigo Fiscal Operao Simples Nacional (0.000)
               CAST(NULL AS Numeric(4)) AS CodigoTabelaOpSpedPis, -- Cdigo da Tabela de Operao do SPED para o PIS
               CAST(NULL AS Numeric(9)) AS CodigoTabelaOpSpedCofins, -- Cdigo da Tabela de Operao do SPED para o COFINS
               CAST(NULL AS VARCHAR(20)) AS CodigoProjeto, -- Cdigo do Projeto Financeiro
               CAST(NULL AS VARCHAR(20)) AS CodImpIRRFServico, -- Cdigo do Imposto para IRRF do Servio
               CAST(NULL AS Numeric(15,2)) AS ValorFrete, -- Valor do Frete para o Item (s funciona se estiver configurado Frete Informado no Item no Tipo Documento)
               CAST(NULL AS Numeric(15,2)) AS ValorOutrasDespesas, -- Valor de Outras Despesas para o Item  (s funciona se estiver configurado Outras Despesas Informado no Item no Tipo Documento)
               CAST(NULL AS Numeric(15,2)) AS ValorDescSuframa, -- Valor Desconto Suframa
               --CAST(TO_NUMBER(DMUL.CODEXT_DMUL) AS Numeric(10)) AS NumAlmox -- Nmero do Almoxarifado
               CAST(NULL AS Numeric(10)) AS NumAlmox, -- Nmero do Almoxarifado
               CAST(NULL AS Numeric(10)) AS NumPedido, -- Nmero do Pedido (DAV/Pr-Venda)
               CAST('1' AS VARCHAR(1)) AS SituacaoItem -- Situao do Item: 0=Normal,1=Cancelado
          FROM TL_IOR_PAF LIORPAF
          JOIN TT_ORC ORC ON ORC.CODFIL = LIORPAF.CODFIL AND ORC.TIPPED = LIORPAF.TIPPED AND ORC.NUMPED = LIORPAF.NUMPED
          JOIN TD_FIL DFIL ON DFIL.CODFIL = LIORPAF.CODFIL
          CROSS JOIN TT_CFG CFG
          -- Natureza
          JOIN TD_NAT DNAT ON DNAT.CODTAB = CFG.NATVEN
          -- Cliente
          JOIN TT_CLI PAR ON PAR.FILCLI = ORC.FILCLI AND PAR.CODCLI = ORC.CODCLI
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = ORC.FILCLI AND ENDFAT.CODCLI = ORC.CODCLI AND ENDFAT.CODFIL = ORC.FILFAT AND ENDFAT.NUMEND = ORC.NUMFAT
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          -- Produto
          JOIN TT_GRA GRA ON GRA.FILMAT = LIORPAF.FILMAT AND GRA.CODMAT = LIORPAF.CODMAT AND GRA.CODCOR = LIORPAF.CODCOR AND GRA.CODTAM = LIORPAF.CODTAM --COALESCE(LIORPAF.EMBORI, LIORPAF.CODTAM)
          JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
          JOIN TT_DIV DIV ON DIV.CODITE = GRA.CODCOR
          JOIN TD_DIV DDIV ON DDIV.CODTAB = DIV.CODDIV
          JOIN TT_SUB SUB ON SUB.CODITE = GRA.CODTAM
          JOIN TD_SUB DSUB ON DSUB.CODTAB = SUB.CODSUB
          --JOIN TD_MUL DMUL ON DMUL.CODTAB = LIORPAF.CODMUL
          LEFT JOIN TD_MED DMED_VEN ON DMED_VEN.CODTAB = GRA.UNIDAD
         WHERE LIORPAF.TIPLOG = 'E'
           AND ORC.PED_EM >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',ORC.CODFIL,'','','')
           AND ((ORC.EXPEM4 = 'F') OR (ORC.EXPORT = 'F'))
           AND LeParametroBoo('EXP_DAV_EME4',ORC.CODFIL,'','','') = 'T'
           AND EXISTS(SELECT 1 AS OK 
                        FROM TW_EXTXDOC EXD 
                       WHERE EXD.ORIGEM = 'IOR' AND EXD.DESTINO = 'TIMU_PARTEDOCTOITEM'
                         AND EXD.FILORI = LIORPAF.CODFIL AND EXD.SEQORI = (LIORPAF.TIPPED||LIORPAF.NUMPED) AND EXD.ITEORI = LIORPAF.NUMITE)
       ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Itens Documento" (Tabela Integrao Mult)
-- Arquivo Pai: TIMU_PARTEDOCTOITEM
/*-- SEQ 2704 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_PARTEDOCTOITEMEMIT CASCADE;

/*-- SEQ 2705 --*/
CREATE OR REPLACE VIEW TV_TIMU_PARTEDOCTOITEMEMIT AS
   SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.NUMPED, TAB.TIPPED, TAB.NUMITE, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE, TAB.VLRNOT_VALIDACAO,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.CodigoProduto, -- Cdigo do Produto
      TAB.CodigoServico, -- Cdigo do Servio
      TAB.SeqItemDoc, -- Sequncia do Item no Documento
      TAB.Quantidade, -- Quantidade de itens
      TAB.ValorUnitario, -- Valor Unitrio do Item (No vai ser utilizado, ser calculado)
      TAB.ValorLiquido, -- Valor Lquido do Item (No utilizado, ser utilizado pelo valor bruto)
      TAB.ValorBruto, -- Valor Bruto do Item
      TAB.ValorDesconto, -- Valor total do desconto do item
      TAB.Unidade, -- Cdigo da Unidade do Item no Documento com 6 posies
      TAB.UnidSPED, -- Cdigo da Unidade do Item no Documento com 2 posies - Unidade SPED
      TAB.CodigoContaFinanceira, -- Cdigo da Conta Financeira
      TAB.CodigoCentroCusto, -- Cdigo do Centro de Custo
      TAB.CodigoLote, -- Cdigo do Lote
      TAB.DataFabricacaoLote, -- Data de Fabricao do Lote
      TAB.DataValidadeLote, -- Data de Validade do Lote
      TAB.ValorPMC, -- Valor do Preo Mximo Medicamentos Venda Consumidor
      TAB.NaoCalcularTributacao, -- T/F - Enviar T para que o sistema no recalcule os impostos informados
      TAB.ClassificacaoOrigem, -- Cdigo Classificao Origem
      TAB.CFOP, -- Cdigo Fiscal Operao (0.000)
      TAB.ClassificacaoFiscal, -- Classificao Fiscal {00, 10, 20, 30, 40, 41, 50, 51, 60, 70, 90}
      TAB.RegimeIncidencia, -- {0=Cumulativa,1=No-Cumulativa,}
      TAB.BaseICMS, -- Valor Base de ICMS
      TAB.ValorIsentoICMS, -- Valor Isento de ICMS
      TAB.ValorOutrasICMS, -- Valor Outras ICMS
      TAB.PercRedBaseCalcICMS, -- Percentual Reduo Base Clculo ICMS
      TAB.PercRedValICMS, -- Percentual de Reduo do Valor do ICMS
      TAB.AliquotaICMS, -- Alquota do ICMS
      TAB.ValorICMS, -- Valor do ICMS
      TAB.BaseICMSST, -- Valor Base de ICMS ST
      TAB.AliquotaICMSST, -- Alquota do ICMS ST
      TAB.ValorICMSST, -- Valor de ICMS ST
      TAB.ModalidadeBaseICMSST, -- (A=0 - Preo tabelado ou mximo sugerido,B=1 - Lista Negativa (valor),C=2 - Lista Positiva (valor), D=3 - Lista Neutra (valor),E=4 - Margem Valo Agregado (percentual),F=5 - Pauta (valor))
      TAB.MargemLucroICMSST, -- Margem de Lucro do ICMS ST
      TAB.PercRedICMSST, -- Percentual de Reduo de ICMS ST
      TAB.ClassificacaoPIS, -- A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,
                            -- I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,
                            -- J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,
                            -- M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,
                            -- P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,
                            -- S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,
                            -- V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,
                            -- 1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,
                            -- 6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
      TAB.BasePIS, -- Valor Base PIS
      TAB.ValorIsentoPIS, -- Valor Isento de PIS
      TAB.PercRedPIS, -- Percentual de Reduo do PIS
      TAB.AliquotaPIS, -- Alquota do PIS para Produto
      TAB.AliquotaPISServ, -- Alquota do PIS para Servio
      TAB.ValorPIS, -- Valor do PIS
      TAB.PercRecupCredCOFINSImp, -- Percentual Recuperao Crdito COFINS Importao
      TAB.AliquotaCOFINSImport, -- Alquota do COFINS Importao
      TAB.ValorCOFINSImport, -- Valor do COFINS Importao
      TAB.ClassificacaoCOFINS, -- A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,
                               -- I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,
                               -- J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,
                               -- M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,
                               -- P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,
                               -- S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,
                               -- V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,
                               -- 1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,
                               -- 6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
      TAB.BaseCOFINS, -- Valor Base COFINS
      TAB.AliquotaCOFINS, -- Alquota COFINS
      TAB.ValorCOFINS, -- Valor COFINS
      TAB.PercRecupCredPisImp, -- Percentual Recuperao Crdito PIS Importao
      TAB.ValorPISImport, -- Valor do PIS Importao
      TAB.AliquotaPISImport, -- Alquota do PIS Importao
      TAB.ValorIsentoCOFINS, -- Valor Isento de COFINS
      TAB.PercRedCOFINS, -- Percentual de Reduo do COFINS
      TAB.CodBaseCalcCreditoEnt, -- 0=Nenhum,1=Aquisio de bens para revenda,2=Aquisio de bens utilizados como insumo,3=Aquisio de servios utilizados como insumo,4=Energia eltrica e trmica, inclusive sob a forma de vapor,5=Aluguis de prdios,6=Aluguis de mquinas e equipamentos,7=Armazenagem de mercadoria e frete na operao de venda,
                                 -- 8=Contraprestaes de arrendamento mercantil,9=Mquinas, equipamentos e outros bens incorporados ao ativo imobilizado,B=Amortizao e Depreciao de edificaes e benfeitorias em imveis,C=Devoluo de Vendas Sujeitas  Incidncia No-Cumulativa,D=Outras Operaes com Direito a Crdito,
                                 -- E=Atividade de Transporte de Cargas - Subcontratao,F=Atividade Imobiliria - Custo Incorrido de Unidade Imobiliria,G=Atividade Imobiliria - Custo Orado de unidade no concluda,H=Atividade de Prestao de Servios de Limpeza, Conservao e Manuteno,I=Estoque de abertura de bens,
      TAB.ClassificacaoIPI, -- A=00 - Entrada com recuperao de crdito,B=01 - Entrada tributada com alquota zero,C=02 - Entrada isenta,D=03 - Entrada no-tributada,E=04 - Entrada imune,F=05 - Entrada com suspenso,G=49 - Outras entradas,H=50 - Sada tributada,I=51 - Sada tributada com alquota zero,J=52 - Sada isenta,L=53 - Sada no-tributada,M=54 - Sada imune,N=55 - Sada com suspenso,O=99 - Outras sadas,
      TAB.BaseIPI, -- Valor Base IPI
      TAB.ValorIsentoIPI, -- Valor Isento de IPI
      TAB.ValorOutrasIPI, -- Valor Outras IPI
      TAB.PercRedIPI, -- Percentual de Reduo do IPI
      TAB.AliquotaIPI, -- Alquota IPI
      TAB.ValorIPI, -- Valor IPI
      TAB.ValorICMSOBS, -- Valor ICMS Observao
      TAB.BaseIPIOBS, -- Valor Base IPI Observao
      TAB.AliquotaIPIOBS, -- Aliquota IPI Observao
      TAB.ValorIPIOBS, -- Valor IPI Observao
      TAB.BaseICMSSTOBS, -- Valor Base ICMS ST Observao
      TAB.ValorICMSSTOBS, -- Valor ICMS ST Observao
      TAB.ValorSTRecolhido, -- Valor ST Recolhido
      TAB.BaseINSS, -- Valor Base INSS
      TAB.PercRedINSS, -- Percentual de Reduo do INSS
      TAB.AliquotaINSS, -- Alquota INSS
      TAB.ValorINSS, -- Valor INSS
      TAB.BaseIRRF, -- Valor Base IRRF
      TAB.ValorIsentoIRRF, -- Valor Isento de IRRF
      TAB.PercRedIRRF, -- Percentual de Reduo do IRRF
      TAB.AliquotaIRRF, -- Alquota IRRF
      TAB.ValorIRRF, -- Valor IRRF
      TAB.BaseISS, -- Valor Base ISS
      TAB.PercRedISS, -- Percentual de Reduo do ISS
      TAB.AliquotaISS, -- Alquota ISS
      TAB.ValorISS, -- Valor ISS
      TAB.ValorIsentoISS, -- Valor Isento ISS
      TAB.TemRetencaoISS, -- Tem reteno ISS
      TAB.BaseImpostoImp, -- Base do Imposto de Importao
      TAB.AliqImpostoImp, -- Valor do Imposto de Importao
      TAB.ValorImpostoImp, -- Alquota do Imposto de Importao
      TAB.BaseAFRMM, -- Base do AFRMM
      TAB.AliqAFRMM, -- Valor do AFRMM
      TAB.ValorAFRMM, -- Alquota do AFRMM
      TAB.BasePISRetido, -- Valor Base PIS Retido
      TAB.AliquotaPISRetido, -- Alquota do PIS Retido
      TAB.ValorPISRetido, -- Valor do PIS Retido
      TAB.BaseCOFINSRetido, -- Valor Base COFINS Retido
      TAB.AliquotaCOFINSRetido, -- Alquota COFINS Retido
      TAB.ValorCOFINSRetido, -- Valor COFINS Retido 
      TAB.BaseCSLLRetido, -- Valor Base CSLL Retido
      TAB.AliquotaCSLLRetido, -- Alquota CSLL Retido
      TAB.ValorCSLLRetido, -- Valor CSLL Retido
      TAB.BaseSimplesNac, -- Base Simples Nacional
      TAB.AliquotaSimplesNac, -- Alquota Simples Nacional
      TAB.ValorSimplesNac, -- Valor Simples Nacional
      TAB.FornecDespAduaneiro, -- Fornecedor  Comercial Importadora / Desp. Aduaneiro
      TAB.BaseDifa, -- Base do Diferencial de Alquota
      TAB.AliquotaDifa, -- Valor do Diferencial de Alquota
      TAB.ValorDifa, -- Alquota do Diferencial de Alquota
      TAB.ValorICMSFCPDest, -- Valor do ICMS relativo ao Fundo de Combate  Pobreza (FCP) da UF de destino
      TAB.ValorICMSIntUFDest, -- Valor do ICMS Interestadual para a UF do remetente
      TAB.ValorICMSIntUFRemet, -- Valor do ICMS Interestadual para a UF do remetente
      TAB.ValorICMSFCPSTDest, -- Valor do ICMS ST relativo ao Fundo de Combate  Pobreza (FCP) da UF de destino
      TAB.ValorICMSProprioCIAP, -- Valor ICMS CIAP Nota
      TAB.ValorICMSSTCIAP, -- Valor ICMS ST CIAP Nota
      TAB.ValorDIFACIAP, -- Valor DIFA CIAP Nota
      TAB.VenctoIniCIAP, -- Vencimento Inicial Parcelamento CIAP
      TAB.NroParcICMSCIAP, -- Quantidade de Parcelamento ICMS CIAP (Default 48)
      TAB.BasePisCIAP, -- Base Pis CIAP - Enviar apenas para casos de Importao
      TAB.AliqPisCIAP, -- Alquota Pis CIAP
      TAB.BaseCofinsCIAP, -- Base Cofins CIAP - Enviar apenas para casos de Importao
      TAB.AliqCofinsCIAP, -- Alquota Cofins CIAP
      TAB.NroParcPISCOFCIAP, -- Quantidade Parcelamento PIS/COFINS CIAP
      TAB.ConferidoCIAP, -- Valores j conferidos pelo usurio
      TAB.CFOPSimples, -- Cdigo Fiscal Operao Simples Nacional (0.000)
      TAB.CodigoTabelaOpSpedPis, -- Cdigo da Tabela de Operao do SPED para o PIS
      TAB.CodigoTabelaOpSpedCofins, -- Cdigo da Tabela de Operao do SPED para o COFINS
      TAB.CodigoProjeto, -- Cdigo do Projeto Financeiro
      TAB.CodImpIRRFServico, -- Cdigo do Imposto para IRRF do Servio
      TAB.ValorFrete, -- Valor do Frete para o Item (s funciona se estiver configurado Frete Informado no Item no Tipo Documento)
      TAB.ValorOutrasDespesas, -- Valor de Outras Despesas para o Item  (s funciona se estiver configurado Outras Despesas Informado no Item no Tipo Documento)
      TAB.ValorDescSuframa, -- Valor Desconto Suframa
      TAB.NumAlmox, -- Nmero do Almoxarifado
      TAB.NumPedido, -- Nmero do Pedido (DAV/Pr-Venda)
      TAB.SituacaoItem -- Situao do Item: 0=Normal,1=Cancelado
     FROM (
   -- Item de Notas Emitidas
        SELECT
               VEN.CODFIL, VEN.SEQUEN, IVE.NUMITE, CAST('IVE' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_PARTEDOCTOITEM' AS VARCHAR(50)) AS DESTINO, COALESCE(VEN.DATINC, VEN.DATHOR) AS DATINC, VEN.ATU_EM, IVE.EXPORT, VEN.EXPEM4,
               CAST('VEN' || VEN.CODFIL || VEN.SEQUEN AS VARCHAR(50)) AS CHAVE,
               CAST(NULL AS CHAR(8)) AS NUMPED,
               CAST(NULL AS CHAR(1)) AS TIPPED,
               CASE WHEN IVE.SITKIT in ('2','3') THEN IVE.VLRMOV ELSE 0 END AS VLRNOT_VALIDACAO,
               COALESCE(VEN.DATINC, VEN.DATHOR) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               -- Definido juntamente com a EME4 quando for cupom fiscal enviar tipo de operao fixo
               CAST(CASE WHEN (VEN.CODSER = 'CF') THEN 998
                         WHEN (VEN.MODNOT = '65') THEN 997
                         WHEN (VEN.MODNOT = '59') THEN 996
                         WHEN (VEN.UFLOJA = 'T') THEN                                                       TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTDEM, '[^0-9]', '', 'gi'), ''))                         ELSE                               TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTFOR, '[^0-9]', '', 'gi'), ''))                    END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST(TO_NUMBER(VEN.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = VEN.FILCLI AND REL.CODPAR = VEN.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                         ELSE 'C' 
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST(TRIM(CASE WHEN VEN.CODSER='CF' THEN VEN.CODSER
										WHEN VEN.CODSER='NM' THEN CAST(CONCAT('N',VEN.NUMECF) AS VARCHAR(5))
                              WHEN ( (VEN.MODNOT = '65' OR VEN.MODNOT = '59') AND VEN.NUMECF >= '400' ) THEN VEN.NUMECF
                              WHEN VEN.CODSER<>'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN DSER.SEREXT
                              ELSE NULL
                         END) AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(TO_CHAR(TO_NUMBER(TRIM(CASE WHEN VEN.CODSER = 'CF' THEN VEN.SEQUEN 
                                                WHEN VEN.CODSER = 'ST' THEN COALESCE(TO_CHAR(VEN.SATCFE), VEN.NUMNOT)
                                                ELSE VEN.NUMNOT END))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST(TRIM(CASE WHEN PRO.CODFPS <> '09' THEN SUBSTR(GRA.CODFIS,1,30)
                              ELSE NULL
                         END) AS VARCHAR(30)) AS CodigoProduto, -- Cdigo do Produto
               CAST(TRIM(CASE WHEN PRO.CODFPS = '09' THEN SUBSTR(GRA.CODFIS,1,30)
                              ELSE NULL
                         END) AS VARCHAR(30)) AS CodigoServico, -- Cdigo do Servio
               CAST(IVE.NUMITE AS Numeric(9)) AS SeqItemDoc, -- Sequncia do Item no Documento
               --CAST(ABS(COALESCE(IVE.EMBQTD, IVE.QTDMOV)) AS Numeric(18,6)) AS Quantidade, -- Quantidade de itens
               CAST(ABS(COALESCE(IVE.QTDMOV,0)) AS Numeric(18,6)) AS Quantidade, -- Quantidade de itens
               CAST(ABS((IVE.VLRMOV + CASE WHEN (VEN.CODSER = 'CF') AND (IVE.VLRDES < 0) THEN ABS(IVE.VLRDES) ELSE 0 END - ABS(COALESCE(IVE.VLRIPI,0))) / NVLZ(IVE.QTDMOV,1)) AS Numeric(16,6)) AS ValorUnitario, -- Valor Unitrio do Item (No vai ser utilizado, ser calculado)
               --CAST(ABS(IVE.VLRLIQRAT) AS Numeric(15,2)) AS ValorLiquido, -- Valor Lquido do Item (No utilizado, ser utilizado pelo valor bruto)
               --CAST(0 AS Numeric(15,2)) AS ValorLiquido, -- Valor Lquido do Item (No utilizado, ser utilizado pelo valor bruto)
               --CAST(0 AS Numeric(15,2)) AS ValorBruto, -- Valor Bruto do Item
               CAST(ABS(IVE.VLRMOV + COALESCE(IVE.DESRAT,0) - COALESCE(IVE.VLRIPI,0)) AS Numeric(15,2)) AS ValorLiquido, -- Valor Lquido do Item
               CAST((ABS(IVE.VLRMOV) - ABS(COALESCE(IVE.VLRIPI,0))) AS Numeric(15,2)) AS ValorBruto, -- Valor Bruto do Item               
               -- GES-2020084063 - Em Conversa com o Gustavo Demmer verificamos que se faz necessrio o envio do acrscimo com valor negativo no item para que o valor da venda feche
               CAST(CASE WHEN (VEN.CODSER = 'CF') AND (IVE.VLRDES < 0) THEN ABS(IVE.VLRDES) ELSE 0 END +
                    CASE WHEN (COALESCE(IVE.VLRMOV,0) > 0)
                         THEN CASE WHEN (COALESCE(IVE.DESRAT,0) < 0) THEN COALESCE(ABS(IVE.DESRAT),0) ELSE (COALESCE(IVE.DESRAT,0) * -1) END
                         ELSE CASE WHEN (COALESCE(IVE.DESRAT,0) > 0) THEN COALESCE(ABS(IVE.DESRAT),0) ELSE (COALESCE(IVE.DESRAT,0) * -1) END                    
                    END AS Numeric(15,2)) AS ValorDesconto, -- Valor total do desconto do item
               CAST(CASE WHEN (LeParametroTXT('TIPO_EXP_EME4', IVE.CODFIL, '', '', '') = 'V') THEN NULL ELSE DMED_VEN.UNIMED END AS VARCHAR(6)) AS Unidade, -- Cdigo da Unidade do Item no Documento com 6 posies
               CAST(DMED_VEN.UNIMED AS VARCHAR(2)) AS UnidSPED, -- Cdigo da Unidade do Item no Documento com 2 posies - Unidade SPED
               -- Definido juntamente com a EME4 quando o cdigo da conta financeira no possuir um "-" devemos exportar para uma Conta fixa para posterior reviso
               CAST(CASE WHEN (LeParametroTXT('TIPO_EXP_EME4', VEN.CODFIL, '', '', '')='V') THEN NULL
                         ELSE (SELECT TRIM(CASE WHEN INSTR(COALESCE(CXF.CODEXT, CTA.CODEXT, CODIGO_CONTA(CTA.CODFIL, CTA.SEQUEN, 'X')), '-') > 0 THEN TRIM(SUBSTR(COALESCE(CXF.CODEXT, CTA.CODEXT, CODIGO_CONTA(CTA.CODFIL, CTA.SEQUEN, 'X')),1,10)) ELSE '99999-2' END)
                                 FROM TV_SPED_CTAVEN CTAVEN 
                                 JOIN TT_CTA CTA ON CTAVEN.FILCTA = CTA.CODFIL AND CTAVEN.SEQCTA = CTA.SEQUEN
                                 LEFT JOIN TT_CTAXFIL CXF ON CXF.FILCTA = CTA.CODFIL AND CXF.SEQCTA = CTA.SEQUEN AND CXF.CODFIL = CTAVEN.FILVEN
                                WHERE CTAVEN.FILVEN = VEN.CODFIL AND CTAVEN.SEQVEN = VEN.SEQUEN)
                    END AS VARCHAR(10)) AS CodigoContaFinanceira, -- Cdigo da Conta Financeira
               CAST(CASE WHEN (LeParametroTXT('TIPO_EXP_EME4', VEN.CODFIL, '', '', '')='V') THEN NULL
                         ELSE TRIM(SUBSTR(COALESCE(DCTR.CODEXT, DCTR.DESCTR),1,10))
                    END AS VARCHAR(10)) AS CodigoCentroCusto, -- Cdigo do Centro de Custo
               CAST(TRIM(LOT.CODEXT) AS VARCHAR(30)) AS CodigoLote, -- Cdigo do Lote
               CAST(NULL AS Timestamp) AS DataFabricacaoLote, -- Data de Fabricao do Lote
               CAST(TRUNC(LOT.DATVAL) AS Timestamp) AS DataValidadeLote, -- Data de Validade do Lote
               CAST(NULL AS Numeric(15,2)) AS ValorPMC, -- Valor do Preo Mximo Medicamentos Venda Consumidor
               CAST('T' AS VARCHAR(1)) AS NaoCalcularTributacao, -- T/F - Enviar T para que o sistema no recalcule os impostos informados
               CAST(PRO.ORIPRO AS VARCHAR(2)) AS ClassificacaoOrigem, -- Cdigo Classificao Origem
               CAST(CASE WHEN ISNOTNULL(IVE.NATFIS)='T' THEN SUBSTR(IVE.NATFIS, 1, 1) || '.' || SUBSTR(IVE.NATFIS, 2, 3)
                         ELSE NULL
                    END AS VARCHAR(20)) AS CFOP, -- Cdigo Fiscal Operao (0.000)
               CAST(CASE WHEN ISNOTNULL(IVE.CODCST)='T' THEN CASE WHEN DFIL.REGTRI = 'S' THEN IVE.CODCST
                                                                  WHEN LENGTH(IVE.CODCST) > 2 THEN SUBSTR(IVE.CODCST, 2, 2)
                                                                  ELSE IVE.CODCST
                                                             END
                         ELSE NULL
                    END AS VARCHAR(2)) AS ClassificacaoFiscal, -- Classificao Fiscal {00, 10, 20, 30, 40, 41, 50, 51, 60, 70, 90}
                  CAST(NULL AS VARCHAR(1)) AS RegimeIncidencia, -- {0=Cumulativa,1=No-Cumulativa,}
               CAST(ABS(IVE.BASICM) AS Numeric(15,2)) AS BaseICMS, -- Valor Base de ICMS
               CAST(ABS(COALESCE(IVE.ISEICM, 
                                 CASE WHEN SUBSTR(IVE.NATFIS,2,3) <> '922' AND IVE.ICMTIP IN ('0', '2', '4') THEN IVE.VLRLIQRAT-IVE.BASICM
                                      ELSE 0
                                 END)) AS Numeric(15,2)) AS ValorIsentoICMS, -- Valor Isento de ICMS
               CAST(ABS(COALESCE(IVE.OUTICM, 
                                 CASE WHEN (SUBSTR(IVE.NATFIS,2,3) = '922' OR IVE.ICMTIP IN ('1','3')) AND SUBSTR(IVE.CODCST,2,2)<>'10' THEN IVE.VLRLIQRAT
                                      WHEN SUBSTR(IVE.NATFIS,2,3) <> '922' AND SUBSTR(IVE.CODCST,2,2)='10' THEN IVE.SUBSTT
                                      ELSE 0
                                 END)) AS Numeric(15,2)) AS ValorOutrasICMS, -- Valor Outras ICMS
               CAST(ABS(IVE.REDITE) AS Numeric(18,4)) AS PercRedBaseCalcICMS, -- Percentual Reduo Base Clculo ICMS
               CAST(NULL AS Numeric(18,4)) AS PercRedValICMS, -- Percentual de Reduo do Valor do ICMS
               CAST(CASE WHEN SUBSTR(IVE.CODCST,2,2) IN ('60', '40', '41') OR IVE.CODCST = '500' THEN 0
                         ELSE ABS(COALESCE(IVE.TAX001,0))
                    END AS Numeric(15,2)) AS AliquotaICMS, -- Alquota do ICMS
               CAST(ABS(COALESCE(IVE.VLRICM, IVE.VLR001)) AS Numeric(15,2)) AS ValorICMS, -- Valor do ICMS
               CAST(ABS(IVE.BASUBS) AS Numeric(15,2)) AS BaseICMSST, -- Valor Base de ICMS ST
               CAST(ABS(IVE.ICMINT) AS Numeric(15,2)) AS AliquotaICMSST, -- Alquota do ICMS ST
               CAST(ABS(IVE.SUBSTT) AS Numeric(15,2)) AS ValorICMSST, -- Valor de ICMS ST
               CAST('4' AS VARCHAR(1)) AS ModalidadeBaseICMSST, -- (A=0 - Preo tabelado ou mximo sugerido,B=1 - Lista Negativa (valor),C=2 - Lista Positiva (valor), D=3 - Lista Neutra (valor),E=4 - Margem Valo Agregado (percentual),F=5 - Pauta (valor))
               CAST(ABS(IVE.MVAVEN) AS Numeric(15,2)) AS MargemLucroICMSST, -- Margem de Lucro do ICMS ST
               CAST(ABS(IVE.REDSUB) AS Numeric(18,4)) AS PercRedICMSST, -- Percentual de Reduo de ICMS ST
               CAST(CASE IVE.SITPIS WHEN '01' THEN 'A'
                                    WHEN '02' THEN 'B'
                                    WHEN '03' THEN 'C'
                                    WHEN '04' THEN 'D'
                                    WHEN '06' THEN 'E'
                                    WHEN '07' THEN 'F'
                                    WHEN '08' THEN 'G'
                                    WHEN '09' THEN 'H'
                                    WHEN '05' THEN 'I'
                                    WHEN '49' THEN 'J'
                                    WHEN '50' THEN 'K'
                                    WHEN '51' THEN 'L'
                                    WHEN '52' THEN 'M'
                                    WHEN '53' THEN 'N'
                                    WHEN '54' THEN 'O'
                                    WHEN '55' THEN 'P'
                                    WHEN '56' THEN 'Q'
                                    WHEN '60' THEN 'R'
                                    WHEN '61' THEN 'S'
                                    WHEN '62' THEN 'T'
                                    WHEN '63' THEN 'U'
                                    WHEN '64' THEN 'V'
                                    WHEN '65' THEN 'W'
                                    WHEN '66' THEN 'X'
                                    WHEN '67' THEN '1'
                                    WHEN '70' THEN '2'
                                    WHEN '71' THEN '3'
                                    WHEN '72' THEN '4'
                                    WHEN '73' THEN '5'
                                    WHEN '74' THEN '6'
                                    WHEN '75' THEN '7'
                                    WHEN '98' THEN 'Y'
                                    WHEN '99' THEN 'Z'
                                    ELSE 'Z'
                     END AS VARCHAR(3)) AS ClassificacaoPIS, -- A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,
                                                             -- I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,
                                                             -- J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,
                                                             -- M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,
                                                             -- P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,
                                                             -- S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,
                                                             -- V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,
                                                             -- 1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,
                                                             -- 6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
               CAST(ABS(IVE.BASPIS) AS Numeric(15,2)) AS BasePIS, -- Valor Base PIS
               CAST(NULL AS Numeric(15,2)) AS ValorIsentoPIS, -- Valor Isento de PIS
               CAST(NULL AS Numeric(15,2)) AS PercRedPIS, -- Percentual de Reduo do PIS
               CAST(CASE WHEN PRO.CODFPS <> '09' THEN ABS(IVE.PERPIS) ELSE 0 END AS Numeric(15,2)) AS AliquotaPIS, -- Alquota do PIS para Produto
               CAST(CASE WHEN PRO.CODFPS = '09' THEN ABS(IVE.PERPIS) ELSE 0 END AS Numeric(15,2)) AS AliquotaPISServ, -- Alquota do PIS para Servio
               CAST(ABS(IVE.VLRPIS) AS Numeric(15,2)) AS ValorPIS, -- Valor do PIS
               CAST(NULL AS Numeric(15,2)) AS PercRecupCredCOFINSImp, -- Percentual Recuperao Crdito COFINS Importao
               CAST(ABS(IVE.PERCOFCRE) AS Numeric(15,2)) AS AliquotaCOFINSImport, -- Alquota do COFINS Importao
               CAST(ABS(IVE.VLRCOFCRE) AS Numeric(15,2)) AS ValorCOFINSImport, -- Valor do COFINS Importao
               CAST(CASE IVE.SITCOF WHEN '01' THEN 'A'
                                    WHEN '02' THEN 'B'
                                    WHEN '03' THEN 'C'
                                    WHEN '04' THEN 'D'
                                    WHEN '06' THEN 'E'
                                    WHEN '07' THEN 'F'
                                    WHEN '08' THEN 'G'
                                    WHEN '09' THEN 'H'
                                    WHEN '05' THEN 'I'
                                    WHEN '49' THEN 'J'
                                    WHEN '50' THEN 'K'
                                    WHEN '51' THEN 'L'
                                    WHEN '52' THEN 'M'
                                    WHEN '53' THEN 'N'
                                    WHEN '54' THEN 'O'
                                    WHEN '55' THEN 'P'
                                    WHEN '56' THEN 'Q'
                                    WHEN '60' THEN 'R'
                                    WHEN '61' THEN 'S'
                                    WHEN '62' THEN 'T'
                                    WHEN '63' THEN 'U'
                                    WHEN '64' THEN 'V'
                                    WHEN '65' THEN 'W'
                                    WHEN '66' THEN 'X'
                                    WHEN '67' THEN '1'
                                    WHEN '70' THEN '2'
                                    WHEN '71' THEN '3'
                                    WHEN '72' THEN '4'
                                    WHEN '73' THEN '5'
                                    WHEN '74' THEN '6'
                                    WHEN '75' THEN '7'
                                    WHEN '98' THEN 'Y'
                                    WHEN '99' THEN 'Z'
                                    ELSE 'Z'
                     END AS VARCHAR(3)) AS ClassificacaoCOFINS, -- A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,
                                                                -- I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,
                                                                -- J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,
                                                                -- M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,
                                                                -- P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,
                                                                -- S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,
                                                                -- V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,
                                                                -- 1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,
                                                                -- 6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
               CAST(ABS(IVE.BASCOF) AS Numeric(15,2)) AS BaseCOFINS, -- Valor Base COFINS
               CAST(ABS(IVE.PERCOF) AS Numeric(15,2)) AS AliquotaCOFINS, -- Alquota COFINS
               CAST(ABS(IVE.VLRCOF) AS Numeric(15,2)) AS ValorCOFINS, -- Valor COFINS
               --IVE.ALICOFVLR, -- Alquota de COFINS por Valor
               --IVE.ALIPISVLR, -- Alquota de PIS por Valor
               CAST(NULL AS Numeric(15,2)) AS PercRecupCredPisImp, -- Percentual Recuperao Crdito PIS Importao
               CAST(ABS(IVE.PERPISCRE) AS Numeric(15,2)) AS ValorPISImport, -- Valor do PIS Importao
               CAST(ABS(IVE.VLRPISCRE) AS Numeric(15,2)) AS AliquotaPISImport, -- Alquota do PIS Importao
               CAST(NULL AS Numeric(15,2)) AS ValorIsentoCOFINS, -- Valor Isento de COFINS
               CAST(NULL AS Numeric(15,2)) AS PercRedCOFINS, -- Percentual de Reduo do COFINS
               CAST(CASE (CASE WHEN PAR.FLGTIP = 0 THEN NULL
                               ELSE COALESCE(IVE.NATBCC, DNAT.NATBCC)
                          END)
                         WHEN '01' THEN '1'
                         WHEN '02' THEN '2'
                         WHEN '03' THEN '3'
                         WHEN '04' THEN '4'
                         WHEN '05' THEN '5'
                         WHEN '06' THEN '6'
                         WHEN '07' THEN '7'
                         WHEN '08' THEN '8'
                         WHEN '09' THEN '9'
                         --WHEN '10' THEN 'A'
                         WHEN '11' THEN 'B'
                         WHEN '12' THEN 'C'
                         WHEN '13' THEN 'D'
                         WHEN '14' THEN 'E'
                         WHEN '15' THEN 'F'
                         WHEN '16' THEN 'G'
                         WHEN '17' THEN 'H'
                         WHEN '18' THEN 'I'
                         ELSE '0'
                    END AS VARCHAR(1)) AS CodBaseCalcCreditoEnt, -- 0=Nenhum,1=Aquisio de bens para revenda,2=Aquisio de bens utilizados como insumo,3=Aquisio de servios utilizados como insumo,4=Energia eltrica e trmica, inclusive sob a forma de vapor,5=Aluguis de prdios,6=Aluguis de mquinas e equipamentos,7=Armazenagem de mercadoria e frete na operao de venda,
                                                                 -- 8=Contraprestaes de arrendamento mercantil,9=Mquinas, equipamentos e outros bens incorporados ao ativo imobilizado,B=Amortizao e Depreciao de edificaes e benfeitorias em imveis,C=Devoluo de Vendas Sujeitas  Incidncia No-Cumulativa,D=Outras Operaes com Direito a Crdito,
                                                                 -- E=Atividade de Transporte de Cargas - Subcontratao,F=Atividade Imobiliria - Custo Incorrido de Unidade Imobiliria,G=Atividade Imobiliria - Custo Orado de unidade no concluda,H=Atividade de Prestao de Servios de Limpeza, Conservao e Manuteno,I=Estoque de abertura de bens,
               CAST(CASE IVE.SITIPI WHEN '00' THEN 'A'
                                    WHEN '01' THEN 'B'
                                    WHEN '02' THEN 'C'
                                    WHEN '03' THEN 'D'
                                    WHEN '04' THEN 'E'
                                    WHEN '06' THEN 'F'
                                    WHEN '49' THEN 'G'
                                    WHEN '50' THEN 'H'
                                    WHEN '51' THEN 'I'
                                    WHEN '52' THEN 'J'
                                    WHEN '53' THEN 'L'
                                    WHEN '54' THEN 'M'
                                    WHEN '55' THEN 'N'
                                    WHEN '99' THEN 'O'
                                    ELSE 'O'
                     END AS VARCHAR(3)) AS ClassificacaoIPI, -- {A=00 - Entrada com recuperao de crdito,B=01 - Entrada tributada com alquota zero,C=02 - Entrada isenta,D=03 - Entrada no-tributada,E=04 - Entrada imune,F=05 - Entrada com suspenso,G=49 - Outras entradas,H=50 - Sada tributada,I=51 - Sada tributada com alquota zero,J=52 - Sada isenta,L=53 - Sada no-tributada,M=54 - Sada imune,N=55 - Sada com suspenso,O=99 - Outras sadas,}
               CAST(ABS(IVE.BASIPI) AS Numeric(15,2)) AS BaseIPI, -- Valor Base IPI
               CAST(NULL AS Numeric(15,2)) AS ValorIsentoIPI, -- Valor Isento de IPI
               CAST(NULL AS Numeric(15,2)) AS ValorOutrasIPI, -- Valor Outras IPI
               CAST(NULL AS Numeric(15,2)) AS PercRedIPI, -- Percentual de Reduo do IPI
               CAST(ABS(IVE.TAXIPI) AS Numeric(15,2)) AS AliquotaIPI, -- Alquota IPI
               CAST(ABS(IVE.VLRIPI) AS Numeric(15,2)) AS ValorIPI, -- Valor IPI
               CAST(NULL AS Numeric(15,2)) AS ValorICMSOBS, -- Valor ICMS Observao
               CAST(NULL AS Numeric(15,2)) AS BaseIPIOBS, -- Valor Base IPI Observao
               CAST(NULL AS Numeric(15,2)) AS AliquotaIPIOBS, -- Aliquota IPI Observao
               CAST(NULL AS Numeric(15,2)) AS ValorIPIOBS, -- Valor IPI Observao
               CAST(NULL AS Numeric(15,2)) AS BaseICMSSTOBS, -- Valor Base ICMS ST Observao
               CAST(NULL AS Numeric(15,2)) AS ValorICMSSTOBS, -- Valor ICMS ST Observao
               CAST(NULL AS Numeric(18,6)) AS ValorSTRecolhido, -- Valor ST Recolhido
               CAST(NULL AS Numeric(15,2)) AS BaseINSS, -- Valor Base INSS
               CAST(NULL AS Numeric(15,2)) AS PercRedINSS, -- Percentual de Reduo do INSS
               CAST(NULL AS Numeric(15,2)) AS AliquotaINSS, -- Alquota INSS
               CAST(NULL AS Numeric(15,2)) AS ValorINSS, -- Valor INSS
               CAST(ABS(IVE.VLRMOV) + ABS(IVE.VLRFRE) + ABS(IVE.VLRSEG) + ABS(IVE.OUTTAX) AS Numeric(15,2)) AS BaseIRRF, -- Valor Base IRRF
               CAST(NULL AS Numeric(15,2)) AS ValorIsentoIRRF, -- Valor Isento de IRRF
               CAST(ABS(PRO.RESIRR - ((PRO.RESIRR * IVE.PERLUC) / 100)) AS Numeric(15,2)) AS PercRedIRRF, -- Percentual de Reduo do IRRF
               CAST(ABS((PRO.RESIRR * IVE.PERLUC) / 100) AS Numeric(15,2)) AS AliquotaIRRF, -- Alquota IRRF
               CAST(ABS(IVE.VLRIRR) AS Numeric(15,2)) AS ValorIRRF, -- Valor IRRF
               CAST(CASE WHEN IVE.SITISS IN ('N','S') THEN ABS(IVE.BASISS)
                         ELSE 0
                    END AS Numeric(15,2)) AS BaseISS, -- Valor Base ISS
                  CAST(NULL AS Numeric(15,2)) AS PercRedISS, -- Percentual de Reduo do ISS
               CAST(CASE WHEN IVE.SITISS IN ('N','S') THEN ABS(IVE.TAXISS)
                         ELSE 0
                    END AS Numeric(15,2)) AS AliquotaISS, -- Alquota ISS
               CAST(CASE WHEN IVE.SITISS IN ('N','S') THEN ABS(IVE.VLRISS)
                         ELSE 0
                    END AS Numeric(15,2)) AS ValorISS, -- Valor ISS
               CAST(CASE WHEN IVE.SITISS = 'I' THEN ABS(IVE.VLRMOV)
                         ELSE 0
                    END AS Numeric(15,2)) AS ValorIsentoISS, -- Valor Isento ISS
               CAST(CASE WHEN IVE.SITISS = 'R' THEN 'T'
                         ELSE 'F'
                    END AS VARCHAR(1)) AS TemRetencaoISS, -- Tem reteno ISS
               CAST(ABS(IVE.BAS_II) AS Numeric(15,2)) AS BaseImpostoImp, -- Base do Imposto de Importao
               CAST(CASE WHEN ABS(IVE.BAS_II) > 0 THEN ROUND((ABS(IVE.VLR_II)/ABS(IVE.BAS_II))*100,2) 
                         ELSE NULL
                    END AS Numeric(15,2)) AS AliqImpostoImp, -- Valor do Imposto de Importao
               CAST(ABS(IVE.VLR_II) AS Numeric(15,2)) AS ValorImpostoImp, -- Alquota do Imposto de Importao
                  CAST(NULL AS Numeric(15,2)) AS BaseAFRMM, -- Base do AFRMM
                  CAST(NULL AS Numeric(15,2)) AS AliqAFRMM, -- Valor do AFRMM
               CAST(ABS(IVE.VLRAFR) AS Numeric(15,2)) AS ValorAFRMM, -- Alquota do AFRMM
               CAST(ABS(IVE.BASCOFRET) AS Numeric(15,2)) AS BasePISRetido, -- Valor Base PIS Retido
               CAST(ABS(IVE.TAXPISRET) AS Numeric(15,2)) AS AliquotaPISRetido, -- Alquota do PIS Retido
               CAST(ABS(IVE.VLRPISRET) AS Numeric(15,2)) AS ValorPISRetido, -- Valor do PIS Retido
               CAST(ABS(IVE.BASCOFRET) AS Numeric(15,2)) AS BaseCOFINSRetido, -- Valor Base COFINS Retido
               CAST(ABS(IVE.TAXCOFRET) AS Numeric(15,2)) AS AliquotaCOFINSRetido, -- Alquota COFINS Retido
               CAST(ABS(IVE.VLRCOFRET) AS Numeric(15,2)) AS ValorCOFINSRetido, -- Valor COFINS Retido 
               CAST(ABS(IVE.BASCOFRET) AS Numeric(15,2)) AS BaseCSLLRetido, -- Valor Base CSLL Retido
               CAST(ABS(IVE.TAXSOCRET) AS Numeric(15,2)) AS AliquotaCSLLRetido, -- Alquota CSLL Retido
               CAST(ABS(IVE.VLRSOCRET) AS Numeric(15,2)) AS ValorCSLLRetido, -- Valor CSLL Retido
               CAST(ABS(IVE.VLRMOV - CASE WHEN (VEN.CODSER = 'CF') AND (COALESCE(IVE.VLRDES,0) < 0) THEN COALESCE(ABS(IVE.VLRDES),0) ELSE 0 END + COALESCE(IVE.DESRAT,0) - COALESCE(IVE.VLRIPI,0)) AS Numeric(15,2)) AS BaseSimplesNac, -- Base Simples Nacional
               CAST(ABS(IVE.ALISIM) AS Numeric(15,2)) AS AliquotaSimplesNac, -- Alquota Simples Nacional
               CAST(ABS(IVE.VLRSIM) AS Numeric(15,2)) AS ValorSimplesNac, -- Valor Simples Nacional
               CAST(CASE WHEN COALESCE(IVE.VLRADU,0)>0 THEN 'T'
                         ELSE 'F'
                    END AS VARCHAR(1)) AS FornecDespAduaneiro, -- Fornecedor  Comercial Importadora / Desp. Aduaneiro
               CAST(NULL AS Numeric(15,2)) AS BaseDifa, -- Base do Diferencial de Alquota
               CAST(ABS(IVE.PERDIF) AS Numeric(17,4)) AS AliquotaDifa, -- Valor do Diferencial de Alquota
               CAST(ABS(IVE.VLRDIF) AS Numeric(15,2)) AS ValorDifa, -- Alquota do Diferencial de Alquota
               CAST(ABS(IVE.VLRICMFCP) AS Numeric(15,2)) AS ValorICMSFCPDest, -- Valor do ICMS relativo ao Fundo de Combate  Pobreza (FCP) da UF de destino
               CAST(ABS(IVE.VLRICMDES) AS Numeric(15,2)) AS ValorICMSIntUFDest, -- Valor do ICMS Interestadual para a UF do remetente
               CAST(ABS(IVE.VLRICMORI) AS Numeric(15,2)) AS ValorICMSIntUFRemet, -- Valor do ICMS Interestadual para a UF do remetente
               CAST(ABS(IVE.VLRFCP_ST) AS Numeric(15,2)) AS ValorICMSFCPSTDest, -- Valor do ICMS ST relativo ao Fundo de Combate  Pobreza (FCP) da UF de destino
               CAST(NULL AS Numeric(15,2)) AS ValorICMSProprioCIAP, -- Valor ICMS CIAP Nota
               CAST(NULL AS Numeric(15,2)) AS ValorICMSSTCIAP, -- Valor ICMS ST CIAP Nota
               CAST(NULL AS Numeric(15,2)) AS ValorDIFACIAP, -- Valor DIFA CIAP Nota
               CAST(NULL AS Timestamp) AS VenctoIniCIAP, -- Vencimento Inicial Parcelamento CIAP
               CAST(NULL AS Numeric(8)) AS NroParcICMSCIAP, -- Quantidade de Parcelamento ICMS CIAP (Default 48)
               CAST(NULL AS Numeric(15,2)) AS BasePisCIAP, -- Base Pis CIAP - Enviar apenas para casos de Importao
               CAST(NULL AS Numeric(15,2)) AS AliqPisCIAP, -- Alquota Pis CIAP
               CAST(NULL AS Numeric(15,2)) AS BaseCofinsCIAP, -- Base Cofins CIAP - Enviar apenas para casos de Importao
               CAST(NULL AS Numeric(15,2)) AS AliqCofinsCIAP, -- Alquota Cofins CIAP
               CAST(NULL AS Numeric(8)) AS NroParcPISCOFCIAP, -- Quantidade Parcelamento PIS/COFINS CIAP
               CAST('F' AS VARCHAR(1)) AS ConferidoCIAP, -- Valores j conferidos pelo usurio
               CAST(NULL AS VARCHAR(20)) AS CFOPSimples, -- Cdigo Fiscal Operao Simples Nacional (0.000)
               CAST(NULL AS Numeric(4)) AS CodigoTabelaOpSpedPis, -- Cdigo da Tabela de Operao do SPED para o PIS
               CAST(NULL AS Numeric(9)) AS CodigoTabelaOpSpedCofins, -- Cdigo da Tabela de Operao do SPED para o COFINS
               CAST(NULL AS VARCHAR(20)) AS CodigoProjeto, -- Cdigo do Projeto Financeiro
               CAST(NULL AS VARCHAR(20)) AS CodImpIRRFServico, -- Cdigo do Imposto para IRRF do Servio
               --CAST(ABS(IVE.VLRFRE) AS Numeric(15,2)) AS ValorFrete, -- Valor do Frete para o Item (s funciona se estiver configurado Frete Informado no Item no Tipo Documento)
               CAST(NULL AS Numeric(15,2)) AS ValorFrete, -- Valor do Frete para o Item (s funciona se estiver configurado Frete Informado no Item no Tipo Documento)
               --CAST(ABS(IVE.OUTTAX) AS Numeric(15,2)) AS ValorOutrasDespesas, -- Valor de Outras Despesas para o Item  (s funciona se estiver configurado Outras Despesas Informado no Item no Tipo Documento)
               CAST(NULL AS Numeric(15,2)) AS ValorOutrasDespesas, -- Valor de Outras Despesas para o Item  (s funciona se estiver configurado Outras Despesas Informado no Item no Tipo Documento)
               CAST(NULL AS Numeric(15,2)) AS ValorDescSuframa, -- Valor Desconto Suframa
               CAST(TO_NUMBER(DMUL.CODEXT_DMUL) AS Numeric(10)) AS NumAlmox, -- Nmero do Almoxarifado
               CAST((SELECT COALESCE(ORC.NUMPED_RE,ORC.NUMPED)
                       FROM TT_IOR IOR INNER JOIN TT_ORC ORC ON ORC.CODFIL = IOR.CODFIL
                                                            AND ORC.TIPPED = IOR.TIPPED
                                                            AND ORC.NUMPED = IOR.NUMPED
                      WHERE IOR.FILIVE = IVE.CODFIL 
                        AND IOR.SEQIVE = IVE.SEQUEN 
                        AND IOR.NUMIVE = IVE.NUMITE 
                        AND (
                             (LeParametroBoo('EXP_DAV_EME4',IVE.CODFIL,'','','') = 'T') OR
                             (LeParametroBoo('EXP_NUMDAV_EME4',IVE.CODFIL,'','','') = 'T')
                            ) 
                     ) AS Numeric(10)) AS NumPedido, -- Nmero do Pedido (DAV/Pr-Venda)
               CAST(CASE WHEN (IVE.SITMOV='C') AND (VEN.FILEST IS NULL) THEN '1'
                         ELSE '0'
                    END AS VARCHAR(1)) AS SituacaoItem -- Situao do Item: 0=Normal,1=Cancelado
          FROM TT_IVE IVE
          JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
          JOIN TD_FIL DFIL ON DFIL.CODFIL = VEN.CODFIL
          -- Srie de Emisso
          JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
          -- Natureza
          JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
          -- Unidade de Negcios / Centro de Custo
          JOIN TD_CTR DCTR ON DCTR.CODTAB = VEN.CODCTR
          -- Cliente
          JOIN TT_CLI PAR ON PAR.FILCLI = VEN.FILCLI AND PAR.CODCLI = VEN.CODCLI
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = VEN.FILCLI AND ENDFAT.CODCLI = VEN.CODCLI AND ENDFAT.CODFIL = VEN.FILFAT AND ENDFAT.NUMEND = VEN.ENDFAT
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          -- Produto
          JOIN TT_GRA GRA ON GRA.FILMAT = IVE.FILMAT AND GRA.CODMAT = IVE.CODMAT AND GRA.CODCOR = IVE.CODCOR AND GRA.CODTAM = IVE.CODTAM --COALESCE(IVE.EMBORI, IVE.CODTAM)
          JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
          JOIN TT_DIV DIV ON DIV.CODITE = GRA.CODCOR
          JOIN TD_DIV DDIV ON DDIV.CODTAB = DIV.CODDIV
          JOIN TT_SUB SUB ON SUB.CODITE = GRA.CODTAM
          JOIN TD_SUB DSUB ON DSUB.CODTAB = SUB.CODSUB
          JOIN TD_MUL DMUL ON IVE.CODMUL = DMUL.CODTAB
          LEFT JOIN TD_MED DMED_VEN ON DMED_VEN.CODTAB = GRA.UNIDAD
          -- Lote
          LEFT JOIN TT_LOT LOT ON LOT.CODFIL = IVE.FILLOT AND LOT.SEQUEN = IVE.SEQLOT
         WHERE 1 = 1
           AND VEN.CODSER <> 'CF'
           AND VEN.NUMNOT NOT LIKE '%#%'
           AND IVE.SITKIT IN ('2','3')
           AND VEN.DATHOR >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',IVE.CODFIL,'','','')
           AND VEN.EXPEM4 = 'F'
           AND (
                  -- Quando Cupom Fiscal
                  (VEN.CODSER = 'CF') OR
						-- Quando a nota manual no for null (status  NM)
						(VEN.NOTMAN IS NOT NULL) OR
                  -- Quando no for Documento Eletrnico
                  (VEN.MODNOT NOT IN ('55','65','59','SE')) OR
                  -- Quando Documento Eletrnico
                  (
                     (VEN.MODNOT IN ('55','65','59','SE')) AND 
                     (
                        -- Quando Cancelado exporta quando situao for Cancelada, Inutilizada ou Denegada
                        ((VEN.FLGEST = 'C') AND (VEN.FLGNFE IN ('3','4','6'))) OR
                        -- Quando Aberto/Quitado exporta quando situao for Autorizado
                        ((VEN.FLGEST <> 'C') AND (VEN.FLGNFE IN ('1'))) OR
                        -- Nota Estornada fica cancelada no banco mas autorizada na Sefaz
                        ((VEN.FLGEST = 'C') AND (VEN.FLGNFE = '1'))
                     )
                  )
               )
       ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Itens Documento" (Tabela Integrao Mult)
-- Arquivo Pai: TIMU_PARTEDOCTOITEM
/*-- SEQ 2706 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_PARTEDOCTOITEMRECEB CASCADE;

/*-- SEQ 2707 --*/
CREATE OR REPLACE VIEW TV_TIMU_PARTEDOCTOITEMRECEB AS
   SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.NUMPED, TAB.TIPPED, TAB.NUMITE, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE, TAB.VLRNOT_VALIDACAO,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.CodigoProduto, -- Cdigo do Produto
      TAB.CodigoServico, -- Cdigo do Servio
      TAB.SeqItemDoc, -- Sequncia do Item no Documento
      TAB.Quantidade, -- Quantidade de itens
      TAB.ValorUnitario, -- Valor Unitrio do Item (No vai ser utilizado, ser calculado)
      TAB.ValorLiquido, -- Valor Lquido do Item (No utilizado, ser utilizado pelo valor bruto)
      TAB.ValorBruto, -- Valor Bruto do Item
      TAB.ValorDesconto, -- Valor total do desconto do item
      TAB.Unidade, -- Cdigo da Unidade do Item no Documento com 6 posies
      TAB.UnidSPED, -- Cdigo da Unidade do Item no Documento com 2 posies - Unidade SPED
      TAB.CodigoContaFinanceira, -- Cdigo da Conta Financeira
      TAB.CodigoCentroCusto, -- Cdigo do Centro de Custo
      TAB.CodigoLote, -- Cdigo do Lote
      TAB.DataFabricacaoLote, -- Data de Fabricao do Lote
      TAB.DataValidadeLote, -- Data de Validade do Lote
      TAB.ValorPMC, -- Valor do Preo Mximo Medicamentos Venda Consumidor
      TAB.NaoCalcularTributacao, -- T/F - Enviar T para que o sistema no recalcule os impostos informados
      TAB.ClassificacaoOrigem, -- Cdigo Classificao Origem
      TAB.CFOP, -- Cdigo Fiscal Operao (0.000)
      TAB.ClassificacaoFiscal, -- Classificao Fiscal {00, 10, 20, 30, 40, 41, 50, 51, 60, 70, 90}
      TAB.RegimeIncidencia, -- {0=Cumulativa,1=No-Cumulativa,}
      TAB.BaseICMS, -- Valor Base de ICMS
      TAB.ValorIsentoICMS, -- Valor Isento de ICMS
      TAB.ValorOutrasICMS, -- Valor Outras ICMS
      TAB.PercRedBaseCalcICMS, -- Percentual Reduo Base Clculo ICMS
      TAB.PercRedValICMS, -- Percentual de Reduo do Valor do ICMS
      TAB.AliquotaICMS, -- Alquota do ICMS
      TAB.ValorICMS, -- Valor do ICMS
      TAB.BaseICMSST, -- Valor Base de ICMS ST
      TAB.AliquotaICMSST, -- Alquota do ICMS ST
      TAB.ValorICMSST, -- Valor de ICMS ST
      TAB.ModalidadeBaseICMSST, -- (A=0 - Preo tabelado ou mximo sugerido,B=1 - Lista Negativa (valor),C=2 - Lista Positiva (valor), D=3 - Lista Neutra (valor),E=4 - Margem Valo Agregado (percentual),F=5 - Pauta (valor))
      TAB.MargemLucroICMSST, -- Margem de Lucro do ICMS ST
      TAB.PercRedICMSST, -- Percentual de Reduo de ICMS ST
      TAB.ClassificacaoPIS, -- A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,
                            -- I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,
                            -- J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,
                            -- M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,
                            -- P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,
                            -- S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,
                            -- V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,
                            -- 1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,
                            -- 6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
      TAB.BasePIS, -- Valor Base PIS
      TAB.ValorIsentoPIS, -- Valor Isento de PIS
      TAB.PercRedPIS, -- Percentual de Reduo do PIS
      TAB.AliquotaPIS, -- Alquota do PIS para Produto
      TAB.AliquotaPISServ, -- Alquota do PIS para Servio
      TAB.ValorPIS, -- Valor do PIS
      TAB.PercRecupCredCOFINSImp, -- Percentual Recuperao Crdito COFINS Importao
      TAB.AliquotaCOFINSImport, -- Alquota do COFINS Importao
      TAB.ValorCOFINSImport, -- Valor do COFINS Importao
      TAB.ClassificacaoCOFINS, -- A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,
                               -- I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,
                               -- J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,
                               -- M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,
                               -- P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,
                               -- S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,
                               -- V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,
                               -- 1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,
                               -- 6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
      TAB.BaseCOFINS, -- Valor Base COFINS
      TAB.AliquotaCOFINS, -- Alquota COFINS
      TAB.ValorCOFINS, -- Valor COFINS
      TAB.PercRecupCredPisImp, -- Percentual Recuperao Crdito PIS Importao
      TAB.ValorPISImport, -- Valor do PIS Importao
      TAB.AliquotaPISImport, -- Alquota do PIS Importao
      TAB.ValorIsentoCOFINS, -- Valor Isento de COFINS
      TAB.PercRedCOFINS, -- Percentual de Reduo do COFINS
      TAB.CodBaseCalcCreditoEnt, -- 0=Nenhum,1=Aquisio de bens para revenda,2=Aquisio de bens utilizados como insumo,3=Aquisio de servios utilizados como insumo,4=Energia eltrica e trmica, inclusive sob a forma de vapor,5=Aluguis de prdios,6=Aluguis de mquinas e equipamentos,7=Armazenagem de mercadoria e frete na operao de venda,
                                 -- 8=Contraprestaes de arrendamento mercantil,9=Mquinas, equipamentos e outros bens incorporados ao ativo imobilizado,B=Amortizao e Depreciao de edificaes e benfeitorias em imveis,C=Devoluo de Vendas Sujeitas  Incidncia No-Cumulativa,D=Outras Operaes com Direito a Crdito,
                                 -- E=Atividade de Transporte de Cargas - Subcontratao,F=Atividade Imobiliria - Custo Incorrido de Unidade Imobiliria,G=Atividade Imobiliria - Custo Orado de unidade no concluda,H=Atividade de Prestao de Servios de Limpeza, Conservao e Manuteno,I=Estoque de abertura de bens,
      TAB.ClassificacaoIPI, -- A=00 - Entrada com recuperao de crdito,B=01 - Entrada tributada com alquota zero,C=02 - Entrada isenta,D=03 - Entrada no-tributada,E=04 - Entrada imune,F=05 - Entrada com suspenso,G=49 - Outras entradas,H=50 - Sada tributada,I=51 - Sada tributada com alquota zero,J=52 - Sada isenta,L=53 - Sada no-tributada,M=54 - Sada imune,N=55 - Sada com suspenso,O=99 - Outras sadas,
      TAB.BaseIPI, -- Valor Base IPI
      TAB.ValorIsentoIPI, -- Valor Isento de IPI
      TAB.ValorOutrasIPI, -- Valor Outras IPI
      TAB.PercRedIPI, -- Percentual de Reduo do IPI
      TAB.AliquotaIPI, -- Alquota IPI
      TAB.ValorIPI, -- Valor IPI
      TAB.ValorICMSOBS, -- Valor ICMS Observao
      TAB.BaseIPIOBS, -- Valor Base IPI Observao
      TAB.AliquotaIPIOBS, -- Aliquota IPI Observao
      TAB.ValorIPIOBS, -- Valor IPI Observao
      TAB.BaseICMSSTOBS, -- Valor Base ICMS ST Observao
      TAB.ValorICMSSTOBS, -- Valor ICMS ST Observao
      TAB.ValorSTRecolhido, -- Valor ST Recolhido
      TAB.BaseINSS, -- Valor Base INSS
      TAB.PercRedINSS, -- Percentual de Reduo do INSS
      TAB.AliquotaINSS, -- Alquota INSS
      TAB.ValorINSS, -- Valor INSS
      TAB.BaseIRRF, -- Valor Base IRRF
      TAB.ValorIsentoIRRF, -- Valor Isento de IRRF
      TAB.PercRedIRRF, -- Percentual de Reduo do IRRF
      TAB.AliquotaIRRF, -- Alquota IRRF
      TAB.ValorIRRF, -- Valor IRRF
      TAB.BaseISS, -- Valor Base ISS
      TAB.PercRedISS, -- Percentual de Reduo do ISS
      TAB.AliquotaISS, -- Alquota ISS
      TAB.ValorISS, -- Valor ISS
      TAB.ValorIsentoISS, -- Valor Isento ISS
      TAB.TemRetencaoISS, -- Tem reteno ISS
      TAB.BaseImpostoImp, -- Base do Imposto de Importao
      TAB.AliqImpostoImp, -- Valor do Imposto de Importao
      TAB.ValorImpostoImp, -- Alquota do Imposto de Importao
      TAB.BaseAFRMM, -- Base do AFRMM
      TAB.AliqAFRMM, -- Valor do AFRMM
      TAB.ValorAFRMM, -- Alquota do AFRMM
      TAB.BasePISRetido, -- Valor Base PIS Retido
      TAB.AliquotaPISRetido, -- Alquota do PIS Retido
      TAB.ValorPISRetido, -- Valor do PIS Retido
      TAB.BaseCOFINSRetido, -- Valor Base COFINS Retido
      TAB.AliquotaCOFINSRetido, -- Alquota COFINS Retido
      TAB.ValorCOFINSRetido, -- Valor COFINS Retido 
      TAB.BaseCSLLRetido, -- Valor Base CSLL Retido
      TAB.AliquotaCSLLRetido, -- Alquota CSLL Retido
      TAB.ValorCSLLRetido, -- Valor CSLL Retido
      TAB.BaseSimplesNac, -- Base Simples Nacional
      TAB.AliquotaSimplesNac, -- Alquota Simples Nacional
      TAB.ValorSimplesNac, -- Valor Simples Nacional
      TAB.FornecDespAduaneiro, -- Fornecedor  Comercial Importadora / Desp. Aduaneiro
      TAB.BaseDifa, -- Base do Diferencial de Alquota
      TAB.AliquotaDifa, -- Valor do Diferencial de Alquota
      TAB.ValorDifa, -- Alquota do Diferencial de Alquota
      TAB.ValorICMSFCPDest, -- Valor do ICMS relativo ao Fundo de Combate  Pobreza (FCP) da UF de destino
      TAB.ValorICMSIntUFDest, -- Valor do ICMS Interestadual para a UF do remetente
      TAB.ValorICMSIntUFRemet, -- Valor do ICMS Interestadual para a UF do remetente
      TAB.ValorICMSFCPSTDest, -- Valor do ICMS ST relativo ao Fundo de Combate  Pobreza (FCP) da UF de destino
      TAB.ValorICMSProprioCIAP, -- Valor ICMS CIAP Nota
      TAB.ValorICMSSTCIAP, -- Valor ICMS ST CIAP Nota
      TAB.ValorDIFACIAP, -- Valor DIFA CIAP Nota
      TAB.VenctoIniCIAP, -- Vencimento Inicial Parcelamento CIAP
      TAB.NroParcICMSCIAP, -- Quantidade de Parcelamento ICMS CIAP (Default 48)
      TAB.BasePisCIAP, -- Base Pis CIAP - Enviar apenas para casos de Importao
      TAB.AliqPisCIAP, -- Alquota Pis CIAP
      TAB.BaseCofinsCIAP, -- Base Cofins CIAP - Enviar apenas para casos de Importao
      TAB.AliqCofinsCIAP, -- Alquota Cofins CIAP
      TAB.NroParcPISCOFCIAP, -- Quantidade Parcelamento PIS/COFINS CIAP
      TAB.ConferidoCIAP, -- Valores j conferidos pelo usurio
      TAB.CFOPSimples, -- Cdigo Fiscal Operao Simples Nacional (0.000)
      TAB.CodigoTabelaOpSpedPis, -- Cdigo da Tabela de Operao do SPED para o PIS
      TAB.CodigoTabelaOpSpedCofins, -- Cdigo da Tabela de Operao do SPED para o COFINS
      TAB.CodigoProjeto, -- Cdigo do Projeto Financeiro
      TAB.CodImpIRRFServico, -- Cdigo do Imposto para IRRF do Servio
      TAB.ValorFrete, -- Valor do Frete para o Item (s funciona se estiver configurado Frete Informado no Item no Tipo Documento)
      TAB.ValorOutrasDespesas, -- Valor de Outras Despesas para o Item  (s funciona se estiver configurado Outras Despesas Informado no Item no Tipo Documento)
      TAB.ValorDescSuframa, -- Valor Desconto Suframa
      TAB.NumAlmox, -- Nmero do Almoxarifado
      TAB.NumPedido, -- Nmero do Pedido (DAV/Pr-Venda)
      TAB.SituacaoItem -- Situao do Item: 0=Normal,1=Cancelado
     FROM (
   -- Itens de Notas de Recebidas
         SELECT
               COM.CODFIL, COM.SEQUEN, ICO.NUMITE, CAST('ICO' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_PARTEDOCTOITEM' AS VARCHAR(50)) AS DESTINO, COALESCE(COM.DATINC, COM.DATOPE) AS DATINC, COM.ATU_EM, ICO.EXPORT, COM.EXPEM4,
               CAST('COM' || COM.CODFIL || COM.SEQUEN AS VARCHAR(50)) AS CHAVE,
               CAST(NULL AS CHAR(8)) AS NUMPED,
               CAST(NULL AS CHAR(1)) AS TIPPED,
               ICO.VLRITE AS VLRNOT_VALIDACAO,
               COALESCE(COM.DATINC, COM.DATOPE) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               CAST(                    TO_NUMBER(NULLIF(regexp_replace(DCFO.EXTCFO, '[^0-9]', '', 'gi'), '')) AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST(TO_NUMBER(COM.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = COM.FILFOR AND REL.CODPAR = COM.CODFOR AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                         ELSE 'C' 
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('2' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST(CASE WHEN ISNOTNULL(FIS.SEREXP)='T' THEN LPAD(TRIM(FIS.SEREXP), 3, '0')||LPAD(COALESCE(TRIM(FIS.SUBEXP),'0'), 2, '0')
                         ELSE LPAD(TRIM(COM.CODSER), 2, '0')||LPAD(COALESCE(TRIM(COM.SUBSER),'0'), 3, '0')
                    END AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(TO_CHAR(TO_NUMBER(TRIM(COM.NUMNOT))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST(TRIM(CASE WHEN PRO.CODFPS <> '09' THEN SUBSTR(GRA.CODFIS,1,30)
                              ELSE NULL
                         END) AS VARCHAR(30)) AS CodigoProduto, -- Cdigo do Produto
               CAST(TRIM(CASE WHEN PRO.CODFPS = '09' THEN SUBSTR(GRA.CODFIS,1,30)
                              ELSE NULL
                         END) AS VARCHAR(30)) AS CodigoServico, -- Cdigo do Servio
               CAST(ICO.NUMITE AS Numeric(9)) AS SeqItemDoc, -- Sequncia do Item no Documento
               --CAST(ABS(COALESCE(ICO.EMBQTD, ICO.QTDMOV)) AS Numeric(18,6)) AS Quantidade, -- Quantidade de itens
               CAST(ABS(COALESCE(ICO.QTDMOV,0)) AS Numeric(18,6)) AS Quantidade, -- Quantidade de itens
               --CAST(ABS((ICO.VLRMOV - COALESCE(ICO.ICO_OUTTAX,0)) / NVLZ(COALESCE(ICO.EMBQTD, ICO.QTDMOV),1)) AS Numeric(16,6)) AS ValorUnitario, -- Valor Unitrio do Item (No vai ser utilizado, ser calculado)
               CAST(ABS((ICO.VLRMOV - COALESCE(ICO.ICO_OUTTAX,0)) / NVLZ(ICO.QTDMOV,1)) AS Numeric(16,6)) AS ValorUnitario, -- Valor Unitrio do Item (No vai ser utilizado, ser calculado)
               --CAST(ABS((ICO.VLRMOV - COALESCE(ICO.ICO_OUTTAX,0))) AS Numeric(15,2)) AS ValorLiquido, -- Valor Lquido do Item (No utilizado, ser utilizado pelo valor bruto)
               CAST(0 AS Numeric(15,2)) AS ValorLiquido, -- Valor Lquido do Item (No utilizado, ser utilizado pelo valor bruto)
               CAST(0 AS Numeric(15,2)) AS ValorBruto, -- Valor Bruto do Item
               CAST(CASE WHEN ICO.VLRDES < 0 THEN ABS(ICO.VLRDES) ELSE 0 END AS Numeric(15,2)) AS ValorDesconto, -- Valor total do desconto do item
               CAST(CASE WHEN (LeParametroTXT('TIPO_EXP_EME4', ICO.CODFIL, '', '', '') = 'V') THEN NULL ELSE DMED_COM.UNIMED END AS VARCHAR(6)) AS Unidade, -- Cdigo da Unidade do Item no Documento com 6 posies
               CAST(DMED_COM.UNIMED AS VARCHAR(2)) AS UnidSPED, -- Cdigo da Unidade do Item no Documento com 2 posies - Unidade SPED
               --CAST(CASE WHEN ('${PA_TIPO_EXPORTACAO}'='V') THEN NULL
               --          ELSE (SELECT TRIM(COALESCE(CXF.CODEXT, CTA.CODEXT, CODIGO_CONTA(CTA.CODFIL,CTA.SEQUEN,'X')))
               --                  FROM TV_SPED_CTACOM CTACOM 
               --                  JOIN TT_CTA CTA ON CTACOM.FILCTA = CTA.CODFIL AND CTACOM.SEQCTA = CTA.SEQUEN
               --                  LEFT JOIN TT_CTAXFIL CXF ON CXF.FILCTA = CTA.CODFIL AND CXF.SEQCTA = CTA.SEQUEN AND CXF.CODFIL = CTACOM.FILCOM 
               --                 WHERE CTACOM.FILCOM = COM.CODFIL AND CTACOM.SEQCOM = COM.SEQUEN)
               --     END AS VARCHAR(10)) AS CodigoContaFinanceira, -- Cdigo da Conta Financeira
               -- Solicitado pela EME4 a passagem do valor fixo para os campos
               CAST(CASE WHEN (LeParametroTXT('TIPO_EXP_EME4', COM.CODFIL, '', '', '')='V') THEN NULL
                         ELSE '019'
                    END AS VARCHAR(10)) AS CodigoContaFinanceira, -- Cdigo da Conta Financeira
               CAST('3000' AS VARCHAR(10)) AS CodigoCentroCusto, -- Cdigo do Centro de Custo
               CAST(TRIM(LOT.CODEXT) AS VARCHAR(30)) AS CodigoLote, -- Cdigo do Lote
               CAST(NULL AS Timestamp) AS DataFabricacaoLote, -- Data de Fabricao do Lote
               CAST(TRUNC(LOT.DATVAL) AS Timestamp) AS DataValidadeLote, -- Data de Validade do Lote
               CAST(NULL AS Numeric(15,2)) AS ValorPMC, -- Valor do Preo Mximo Medicamentos Venda Consumidor
               CAST('T' AS VARCHAR(1)) AS NaoCalcularTributacao, -- T/F - Enviar T para que o sistema no recalcule os impostos informados
               CAST(PRO.ORIPRO AS VARCHAR(2)) AS ClassificacaoOrigem, -- Cdigo Classificao Origem
               CAST(CASE WHEN ISNOTNULL(IDCFO.CODCFO)='T' THEN SUBSTR(IDCFO.CODCFO, 1, 1) || '.' || SUBSTR(IDCFO.CODCFO, 2, 3)
                         ELSE NULL
                    END AS VARCHAR(20)) AS CFOP, -- Cdigo Fiscal Operao (0.000)
               CAST(CASE WHEN ISNOTNULL(ICO.CODCSTDIF)='T' THEN CASE WHEN PAR.SIMPLE='T' THEN ICO.CODCSTDIF
                                                                     WHEN LENGTH(ICO.CODCSTDIF) > 2 THEN SUBSTR(ICO.CODCSTDIF, 2, 2)
                                                                     ELSE ICO.CODCSTDIF
                                                                END
                         ELSE NULL
                    END AS VARCHAR(2)) AS ClassificacaoFiscal, -- Classificao Fiscal {00, 10, 20, 30, 40, 41, 50, 51, 60, 70, 90}
               CAST(NULL AS VARCHAR(1)) AS RegimeIncidencia, -- {0=Cumulativa,1=No-Cumulativa,}
               CAST(ABS(ICO.BASICMDIF) AS Numeric(15,2)) AS BaseICMS, -- Valor Base de ICMS
               CAST(ABS(ICO.ISEICMDIF) AS Numeric(15,2)) AS ValorIsentoICMS, -- Valor Isento de ICMS
               -- Em conversa com o Gustavo Demmer devemos enviar o valor da ST da Viso do fornecedor no campo ValorICMSSTOBS quando viso do cliente no tem CST 10
               --CAST(ABS(ICO.OUTICMDIF) AS Numeric(15,2)) AS ValorOutrasICMS, -- Valor Outras ICMS
               CAST(CASE WHEN ((SUBSTR(ICO.CODCSTDIF, 1, 2) <> '10') AND (SUBSTR(ICO.CODCST, 1, 2) = '10')) THEN 
                              CASE WHEN ((COALESCE(ICO.OUTICMDIF,0) - COALESCE(ICO.VLR_ST,0)) > 0) THEN ABS(COALESCE(ICO.OUTICMDIF,0) - COALESCE(ICO.VLR_ST,0))
                                   ELSE 0
                              END
                         ELSE ABS(ICO.OUTICMDIF)
                    END AS Numeric(15,2)) AS ValorOutrasICMS, -- Valor Outras ICMS
               CAST(ABS(ICO.REDITEDIF) AS Numeric(18,4)) AS PercRedBaseCalcICMS, -- Percentual Reduo Base Clculo ICMS
               CAST(NULL AS Numeric(18,4)) AS PercRedValICMS, -- Percentual de Reduo do Valor do ICMS
               CAST(ABS(ICO.ICMITEDIF) AS Numeric(15,2)) AS AliquotaICMS, -- Alquota do ICMS
               CAST(ABS(ICO.VLRICMDIF) AS Numeric(15,2)) AS ValorICMS, -- Valor do ICMS
               CAST(CASE WHEN ((SUBSTR(ICO.CODCSTDIF, 1, 2) <> '10') AND (SUBSTR(ICO.CODCST, 1, 2) = '10')) THEN NULL
                         ELSE ABS(ICO.BASSUBDIF)
                    END AS Numeric(15,2)) AS BaseICMSST, -- Valor Base de ICMS ST
               CAST(CASE WHEN ((SUBSTR(ICO.CODCSTDIF, 1, 2) <> '10') AND (SUBSTR(ICO.CODCST, 1, 2) = '10')) THEN NULL
                         ELSE ABS(ICO.ICMVENDIF)
                    END AS Numeric(15,2)) AS AliquotaICMSST, -- Alquota do ICMS ST
               CAST(CASE WHEN ((SUBSTR(ICO.CODCSTDIF, 1, 2) <> '10') AND (SUBSTR(ICO.CODCST, 1, 2) = '10')) THEN NULL
                         ELSE ABS(ICO.VLR_STDIF)
                    END AS Numeric(15,2)) AS ValorICMSST, -- Valor de ICMS ST
               CAST('4' AS VARCHAR(1)) AS ModalidadeBaseICMSST, -- (A=0 - Preo tabelado ou mximo sugerido,B=1 - Lista Negativa (valor),C=2 - Lista Positiva (valor), D=3 - Lista Neutra (valor),E=4 - Margem Valo Agregado (percentual),F=5 - Pauta (valor))
               CAST(CASE WHEN ((SUBSTR(ICO.CODCSTDIF, 1, 2) <> '10') AND (SUBSTR(ICO.CODCST, 1, 2) = '10')) THEN NULL
                         ELSE ABS(ICO.MVACOMDIF)
                    END AS Numeric(15,2)) AS MargemLucroICMSST, -- Margem de Lucro do ICMS ST
               CAST(CASE WHEN ((SUBSTR(ICO.CODCSTDIF, 1, 2) <> '10') AND (SUBSTR(ICO.CODCST, 1, 2) = '10')) THEN NULL
                         ELSE ABS(ICO.RED_STDIF)
                    END AS Numeric(18,4)) AS PercRedICMSST, -- Percentual de Reduo de ICMS ST
               CAST(CASE ICO.SITPIS WHEN '01' THEN 'A'
                                    WHEN '02' THEN 'B'
                                    WHEN '03' THEN 'C'
                                    WHEN '04' THEN 'D'
                                    WHEN '06' THEN 'E'
                                    WHEN '07' THEN 'F'
                                    WHEN '08' THEN 'G'
                                    WHEN '09' THEN 'H'
                                    WHEN '05' THEN 'I'
                                    WHEN '49' THEN 'J'
                                    WHEN '50' THEN 'K'
                                    WHEN '51' THEN 'L'
                                    WHEN '52' THEN 'M'
                                    WHEN '53' THEN 'N'
                                    WHEN '54' THEN 'O'
                                    WHEN '55' THEN 'P'
                                    WHEN '56' THEN 'Q'
                                    WHEN '60' THEN 'R'
                                    WHEN '61' THEN 'S'
                                    WHEN '62' THEN 'T'
                                    WHEN '63' THEN 'U'
                                    WHEN '64' THEN 'V'
                                    WHEN '65' THEN 'W'
                                    WHEN '66' THEN 'X'
                                    WHEN '67' THEN '1'
                                    WHEN '70' THEN '2'
                                    WHEN '71' THEN '3'
                                    WHEN '72' THEN '4'
                                    WHEN '73' THEN '5'
                                    WHEN '74' THEN '6'
                                    WHEN '75' THEN '7'
                                    WHEN '98' THEN 'Y'
                                    WHEN '99' THEN 'Z'
                                    ELSE 'Z'
                     END AS VARCHAR(3)) AS ClassificacaoPIS, -- A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,
                                                             -- I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,
                                                             -- J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,
                                                             -- M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,
                                                             -- P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,
                                                             -- S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,
                                                             -- V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,
                                                             -- 1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,
                                                             -- 6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
               CAST(ABS(ICO.BASPIS) AS Numeric(15,2)) AS BasePIS, -- Valor Base PIS
               CAST(NULL AS Numeric(15,2)) AS ValorIsentoPIS, -- Valor Isento de PIS
               CAST(NULL AS Numeric(15,2)) AS PercRedPIS, -- Percentual de Reduo do PIS
               CAST(CASE WHEN PRO.CODFPS <> '09' THEN ABS(ICO.PERPIS) ELSE 0 END AS Numeric(15,2)) AS AliquotaPIS, -- Alquota do PIS para Produto
               CAST(CASE WHEN PRO.CODFPS = '09' THEN ABS(ICO.PERPIS) ELSE 0 END AS Numeric(15,2)) AS AliquotaPISServ, -- Alquota do PIS para Servio
               CAST(ABS(ICO.VLRPIS) AS Numeric(15,2)) AS ValorPIS, -- Valor do PIS
               CAST(NULL AS Numeric(15,2)) AS PercRecupCredCOFINSImp, -- Percentual Recuperao Crdito COFINS Importao
               CAST(NULL AS Numeric(15,2)) AS AliquotaCOFINSImport, -- Alquota do COFINS Importao
               CAST(NULL AS Numeric(15,2)) AS ValorCOFINSImport, -- Valor do COFINS Importao
               CAST(CASE ICO.SITCOF WHEN '01' THEN 'A'
                                    WHEN '02' THEN 'B'
                                    WHEN '03' THEN 'C'
                                    WHEN '04' THEN 'D'
                                    WHEN '06' THEN 'E'
                                    WHEN '07' THEN 'F'
                                    WHEN '08' THEN 'G'
                                    WHEN '09' THEN 'H'
                                    WHEN '05' THEN 'I'
                                    WHEN '49' THEN 'J'
                                    WHEN '50' THEN 'K'
                                    WHEN '51' THEN 'L'
                                    WHEN '52' THEN 'M'
                                    WHEN '53' THEN 'N'
                                    WHEN '54' THEN 'O'
                                    WHEN '55' THEN 'P'
                                    WHEN '56' THEN 'Q'
                                    WHEN '60' THEN 'R'
                                    WHEN '61' THEN 'S'
                                    WHEN '62' THEN 'T'
                                    WHEN '63' THEN 'U'
                                    WHEN '64' THEN 'V'
                                    WHEN '65' THEN 'W'
                                    WHEN '66' THEN 'X'
                                    WHEN '67' THEN '1'
                                    WHEN '70' THEN '2'
                                    WHEN '71' THEN '3'
                                    WHEN '72' THEN '4'
                                    WHEN '73' THEN '5'
                                    WHEN '74' THEN '6'
                                    WHEN '75' THEN '7'
                                    WHEN '98' THEN 'Y'
                                    WHEN '99' THEN 'Z'
                                    ELSE 'Z'
                     END AS VARCHAR(3)) AS ClassificacaoCOFINS, -- A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,
                                                                -- I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,
                                                                -- J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,
                                                                -- M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,
                                                                -- P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,
                                                                -- S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,
                                                                -- V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,
                                                                -- 1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,
                                                                -- 6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes
               CAST(ABS(ICO.BASCOF) AS Numeric(15,2)) AS BaseCOFINS, -- Valor Base COFINS
               CAST(ABS(ICO.PERCOF) AS Numeric(15,2)) AS AliquotaCOFINS, -- Alquota COFINS
               CAST(ABS(ICO.VLRCOF) AS Numeric(15,2)) AS ValorCOFINS, -- Valor COFINS
               CAST(NULL AS Numeric(15,2)) AS PercRecupCredPisImp, -- Percentual Recuperao Crdito PIS Importao
               CAST(NULL AS Numeric(15,2)) AS ValorPISImport, -- Valor do PIS Importao
               CAST(NULL AS Numeric(15,2)) AS AliquotaPISImport, -- Alquota do PIS Importao
               CAST(NULL AS Numeric(15,2)) AS ValorIsentoCOFINS, -- Valor Isento de COFINS
               CAST(NULL AS Numeric(15,2)) AS PercRedCOFINS, -- Percentual de Reduo do COFINS
               CAST(CASE (CASE WHEN PAR.FLGTIP = 0 THEN NULL
                               ELSE COALESCE(ICO.NATBCC, COM.NATBCC)
                          END)
                         WHEN '01' THEN '1'
                         WHEN '02' THEN '2'
                         WHEN '03' THEN '3'
                         WHEN '04' THEN '4'
                         WHEN '05' THEN '5'
                         WHEN '06' THEN '6'
                         WHEN '07' THEN '7'
                         WHEN '08' THEN '8'
                         WHEN '09' THEN '9'
                         --WHEN '10' THEN 'A'
                         WHEN '11' THEN 'B'
                         WHEN '12' THEN 'C'
                         WHEN '13' THEN 'D'
                         WHEN '14' THEN 'E'
                         WHEN '15' THEN 'F'
                         WHEN '16' THEN 'G'
                         WHEN '17' THEN 'H'
                         WHEN '18' THEN 'I'
                         ELSE '0'
                    END AS VARCHAR(1)) AS CodBaseCalcCreditoEnt, -- 0=Nenhum,1=Aquisio de bens para revenda,2=Aquisio de bens utilizados como insumo,3=Aquisio de servios utilizados como insumo,4=Energia eltrica e trmica, inclusive sob a forma de vapor,5=Aluguis de prdios,6=Aluguis de mquinas e equipamentos,7=Armazenagem de mercadoria e frete na operao de venda,
                                                                 -- 8=Contraprestaes de arrendamento mercantil,9=Mquinas, equipamentos e outros bens incorporados ao ativo imobilizado,B=Amortizao e Depreciao de edificaes e benfeitorias em imveis,C=Devoluo de Vendas Sujeitas  Incidncia No-Cumulativa,D=Outras Operaes com Direito a Crdito,
                                                                 -- E=Atividade de Transporte de Cargas - Subcontratao,F=Atividade Imobiliria - Custo Incorrido de Unidade Imobiliria,G=Atividade Imobiliria - Custo Orado de unidade no concluda,H=Atividade de Prestao de Servios de Limpeza, Conservao e Manuteno,I=Estoque de abertura de bens,
               CAST(CASE ICO.SITIPI WHEN '00' THEN 'A'
                                    WHEN '01' THEN 'B'
                                    WHEN '02' THEN 'C'
                                    WHEN '03' THEN 'D'
                                    WHEN '04' THEN 'E'
                                    WHEN '06' THEN 'F'
                                    WHEN '49' THEN 'G'
                                    WHEN '50' THEN 'H'
                                    WHEN '51' THEN 'I'
                                    WHEN '52' THEN 'J'
                                    WHEN '53' THEN 'L'
                                    WHEN '54' THEN 'M'
                                    WHEN '55' THEN 'N'
                                    WHEN '99' THEN 'O'
                                    ELSE 'O'
                     END AS VARCHAR(3)) AS ClassificacaoIPI, -- {A=00 - Entrada com recuperao de crdito,B=01 - Entrada tributada com alquota zero,C=02 - Entrada isenta,D=03 - Entrada no-tributada,E=04 - Entrada imune,F=05 - Entrada com suspenso,G=49 - Outras entradas,H=50 - Sada tributada,I=51 - Sada tributada com alquota zero,J=52 - Sada isenta,L=53 - Sada no-tributada,M=54 - Sada imune,N=55 - Sada com suspenso,O=99 - Outras sadas,}
               CAST(ABS(ICO.BASIPI) AS Numeric(15,2)) AS BaseIPI, -- Valor Base IPI
               CAST(NULL AS Numeric(15,2)) AS ValorIsentoIPI, -- Valor Isento de IPI
               CAST(NULL AS Numeric(15,2)) AS ValorOutrasIPI, -- Valor Outras IPI
               CAST(NULL AS Numeric(15,2)) AS PercRedIPI, -- Percentual de Reduo do IPI
               CAST(ABS(ICO.IPIITE) AS Numeric(15,2)) AS AliquotaIPI, -- Alquota IPI
               CAST(ABS(ICO.VLRIPI) AS Numeric(15,2)) AS ValorIPI, -- Valor IPI
               CAST(ABS(ICO.VLRICM) AS Numeric(15,2)) AS ValorICMSOBS, -- Valor ICMS Observao
               CAST(NULL AS Numeric(15,2)) AS BaseIPIOBS, -- Valor Base IPI Observao
               CAST(NULL AS Numeric(15,2)) AS AliquotaIPIOBS, -- Aliquota IPI Observao
               CAST(NULL AS Numeric(15,2)) AS ValorIPIOBS, -- Valor IPI Observao
               -- Em conversa com o Gustavo Demmer devemos enviar o valor da ST da Viso do fornecedor no campo ValorICMSSTOBS quando viso do cliente no tem CST 10
               CAST(CASE WHEN ((SUBSTR(ICO.CODCSTDIF, 1, 2) <> '10') AND (SUBSTR(ICO.CODCST, 1, 2) = '10')) THEN ABS(ICO.BASSUB)
                         ELSE NULL
                    END AS Numeric(15,2)) AS BaseICMSSTOBS, -- Valor Base ICMS ST Observao
               CAST(CASE WHEN ((SUBSTR(ICO.CODCSTDIF, 1, 2) <> '10') AND (SUBSTR(ICO.CODCST, 1, 2) = '10')) THEN ABS(ICO.VLR_ST)
                         ELSE NULL
                    END AS Numeric(15,2)) AS ValorICMSSTOBS, -- Valor ICMS ST Observao
               CAST(ABS(ICO.ICO_VLRRET) AS Numeric(18,6)) AS ValorSTRecolhido, -- Valor ST Recolhido
               CAST(NULL AS Numeric(15,2)) AS BaseINSS, -- Valor Base INSS
               CAST(NULL AS Numeric(15,2)) AS PercRedINSS, -- Percentual de Reduo do INSS
               CAST(NULL AS Numeric(15,2)) AS AliquotaINSS, -- Alquota INSS
               CAST(NULL AS Numeric(15,2)) AS ValorINSS, -- Valor INSS
               CAST(NULL AS Numeric(15,2)) AS BaseIRRF, -- Valor Base IRRF
               CAST(NULL AS Numeric(15,2)) AS ValorIsentoIRRF, -- Valor Isento de IRRF
               CAST(NULL AS Numeric(15,2)) AS PercRedIRRF, -- Percentual de Reduo do IRRF
               CAST(NULL AS Numeric(15,2)) AS AliquotaIRRF, -- Alquota IRRF
               CAST(NULL AS Numeric(15,2)) AS ValorIRRF, -- Valor IRRF
               CAST(ABS(ICO.BASISS) AS Numeric(15,2)) AS BaseISS, -- Valor Base ISS
               CAST(NULL AS Numeric(15,2)) AS PercRedISS, -- Percentual de Reduo do ISS
               CAST(ABS(ICO.PERISS) AS Numeric(15,2)) AS AliquotaISS, -- Alquota ISS
               CAST(ABS(ICO.VLRISS) AS Numeric(15,2)) AS ValorISS, -- Valor ISS
               CAST(NULL AS Numeric(15,2)) AS ValorIsentoISS, -- Valor Isento ISS
               CAST('F' AS VARCHAR(1)) AS TemRetencaoISS, -- Tem reteno ISS
               CAST(NULL AS Numeric(15,2)) AS BaseImpostoImp, -- Base do Imposto de Importao
               CAST(NULL AS Numeric(15,2)) AS AliqImpostoImp, -- Valor do Imposto de Importao
               CAST(NULL AS Numeric(15,2)) AS ValorImpostoImp, -- Alquota do Imposto de Importao
               CAST(NULL AS Numeric(15,2)) AS BaseAFRMM, -- Base do AFRMM
               CAST(NULL AS Numeric(15,2)) AS AliqAFRMM, -- Valor do AFRMM
               CAST(NULL AS Numeric(15,2)) AS ValorAFRMM, -- Alquota do AFRMM
               CAST(NULL AS Numeric(15,2)) AS BasePISRetido, -- Valor Base PIS Retido
               CAST(NULL AS Numeric(15,2)) AS AliquotaPISRetido, -- Alquota do PIS Retido
               CAST(NULL AS Numeric(15,2)) AS ValorPISRetido, -- Valor do PIS Retido
               CAST(NULL AS Numeric(15,2)) AS BaseCOFINSRetido, -- Valor Base COFINS Retido
               CAST(NULL AS Numeric(15,2)) AS AliquotaCOFINSRetido, -- Alquota COFINS Retido
               CAST(NULL AS Numeric(15,2)) AS ValorCOFINSRetido, -- Valor COFINS Retido 
               CAST(NULL AS Numeric(15,2)) AS BaseCSLLRetido, -- Valor Base CSLL Retido
               CAST(NULL AS Numeric(15,2)) AS AliquotaCSLLRetido, -- Alquota CSLL Retido
               CAST(NULL AS Numeric(15,2)) AS ValorCSLLRetido, -- Valor CSLL Retido
               CAST(NULL AS Numeric(15,2)) AS BaseSimplesNac, -- Base Simples Nacional
               CAST(ABS(ICO.PERCRESN) AS Numeric(15,2)) AS AliquotaSimplesNac, -- Alquota Simples Nacional
               CAST(ABS(ICO.VLRCRESN) AS Numeric(15,2)) AS ValorSimplesNac, -- Valor Simples Nacional
               CAST('F' AS VARCHAR(1)) AS FornecDespAduaneiro, -- Fornecedor  Comercial Importadora / Desp. Aduaneiro
               CAST(NULL AS Numeric(15,2)) AS BaseDifa, -- Base do Diferencial de Alquota
               CAST(ABS(ICO.PERDIF) AS Numeric(17,4)) AS AliquotaDifa, -- Valor do Diferencial de Alquota
               CAST(ABS(ICO.VLRDIF) AS Numeric(15,2)) AS ValorDifa, -- Alquota do Diferencial de Alquota
               CAST(ABS(ICO.VLRFCP) AS Numeric(15,2)) AS ValorICMSFCPDest, -- Valor do ICMS relativo ao Fundo de Combate  Pobreza (FCP) da UF de destino
               CAST(ABS(ICO.VLRFCP_RET) AS Numeric(15,2)) AS ValorICMSIntUFDest, -- Valor do ICMS Interestadual para a UF do remetente
               CAST(NULL AS Numeric(15,2)) AS ValorICMSIntUFRemet, -- Valor do ICMS Interestadual para a UF do remetente
               CAST(ABS(ICO.VLRFCP_ST) AS Numeric(15,2)) AS ValorICMSFCPSTDest, -- Valor do ICMS ST relativo ao Fundo de Combate  Pobreza (FCP) da UF de destino
               CAST(NULL AS Numeric(15,2)) AS ValorICMSProprioCIAP, -- Valor ICMS CIAP Nota
               CAST(NULL AS Numeric(15,2)) AS ValorICMSSTCIAP, -- Valor ICMS ST CIAP Nota
               CAST(NULL AS Numeric(15,2)) AS ValorDIFACIAP, -- Valor DIFA CIAP Nota
               CAST(NULL AS Timestamp) AS VenctoIniCIAP, -- Vencimento Inicial Parcelamento CIAP
               CAST(NULL AS Numeric(8)) AS NroParcICMSCIAP, -- Quantidade de Parcelamento ICMS CIAP (Default 48)
               CAST(NULL AS Numeric(15,2)) AS BasePisCIAP, -- Base Pis CIAP - Enviar apenas para casos de Importao
               CAST(NULL AS Numeric(15,2)) AS AliqPisCIAP, -- Alquota Pis CIAP
               CAST(NULL AS Numeric(15,2)) AS BaseCofinsCIAP, -- Base Cofins CIAP - Enviar apenas para casos de Importao
               CAST(NULL AS Numeric(15,2)) AS AliqCofinsCIAP, -- Alquota Cofins CIAP
               CAST(NULL AS Numeric(8)) AS NroParcPISCOFCIAP, -- Quantidade Parcelamento PIS/COFINS CIAP
               CAST('F' AS VARCHAR(1)) AS ConferidoCIAP, -- Valores j conferidos pelo usurio
               CAST(NULL AS VARCHAR(20)) AS CFOPSimples, -- Cdigo Fiscal Operao Simples Nacional (0.000)
               CAST(NULL AS Numeric(4)) AS CodigoTabelaOpSpedPis, -- Cdigo da Tabela de Operao do SPED para o PIS
               CAST(NULL AS Numeric(9)) AS CodigoTabelaOpSpedCofins, -- Cdigo da Tabela de Operao do SPED para o COFINS
               CAST(NULL AS VARCHAR(20)) AS CodigoProjeto, -- Cdigo do Projeto Financeiro
               CAST(NULL AS VARCHAR(20)) AS CodImpIRRFServico, -- Cdigo do Imposto para IRRF do Servio
               --CAST(ABS(ICO.ICO_VLRFRE) AS Numeric(15,2)) AS ValorFrete, -- Valor do Frete para o Item (s funciona se estiver configurado Frete Informado no Item no Tipo Documento)
               CAST(NULL AS Numeric(15,2)) AS ValorFrete, -- Valor do Frete para o Item (s funciona se estiver configurado Frete Informado no Item no Tipo Documento)
               --CAST(ABS(COALESCE(ICO.ICO_OUTTAX,0)) AS Numeric(15,2)) AS ValorOutrasDespesas, -- Valor de Outras Despesas para o Item  (s funciona se estiver configurado Outras Despesas Informado no Item no Tipo Documento)
               CAST(NULL AS Numeric(15,2)) AS ValorOutrasDespesas, -- Valor de Outras Despesas para o Item  (s funciona se estiver configurado Outras Despesas Informado no Item no Tipo Documento)
               CAST(NULL AS Numeric(15,2)) AS ValorDescSuframa, -- Valor Desconto Suframa
               CAST(NULL AS Numeric(10)) AS NumAlmox, -- Nmero do Almoxarifado
               CAST(NULL AS Numeric(10)) AS NumPedido, -- Nmero do Pedido (DAV/Pr-Venda)
               CAST(CASE WHEN ICO.SITMOV='C' THEN '1'
                         ELSE '0'
                    END AS VARCHAR(1)) AS SituacaoItem -- Situao do Item: 0=Normal,1=Cancelado
          FROM TT_ICO ICO
          JOIN TT_COM COM ON COM.CODFIL = ICO.CODFIL AND COM.SEQUEN = ICO.SEQUEN
          -- Srie de Emisso
          LEFT JOIN (SELECT DISTINCT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT, ORIGEM
                       FROM TT_FIS
                      WHERE ORIGEM IN ('C','F')) FIS ON FIS.CODSER = COM.CODSER AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$') AND FIS.ORIGEM = CASE WHEN COALESCE(COM.TIPPAR,'F') = 'T' THEN 'F' ELSE 'C' END
          -- Natureza
          LEFT JOIN TD_CFO DCFO ON DCFO.CODTAB = COM.CODCFO
          -- Natureza Item
          LEFT JOIN TD_CFO IDCFO ON IDCFO.CODTAB = ICO.CODCFO
          -- Fornecedor
          JOIN TT_CLI PAR ON PAR.FILCLI = COM.FILFOR AND PAR.CODCLI = COM.CODFOR
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.FILEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = COM.FILFOR AND ENDFAT.CODCLI = COM.CODFOR AND ENDFAT.CODFIL = COM.FILEND AND ENDFAT.NUMEND = COM.NUMEND
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          -- Produto
          JOIN TT_GRA GRA ON GRA.FILMAT = ICO.FILMAT AND GRA.CODMAT = ICO.CODMAT AND GRA.CODCOR = ICO.CODCOR AND GRA.CODTAM = ICO.CODTAM --COALESCE(ICO.EMBORI, ICO.CODTAM)
          JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
          LEFT JOIN TD_MED DMED_COM ON DMED_COM.CODTAB = GRA.UNIDAD --ICO.UNICOM
          -- Lote
          LEFT JOIN TT_LOT LOT ON LOT.CODFIL = ICO.FILLOT AND LOT.SEQUEN = ICO.SEQLOT
         WHERE COM.FLGEST <> 'D'
           AND COM.NUMNOT NOT LIKE '%#%'
           AND COM.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',COM.CODFIL,'','','')
           AND COM.EXPEM4 = 'F'
       ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Operao Financeira Documento" (Tabela Integrao Mult)
-- Arquivo Pai: TIMU_PARTEDOCTOOPERA
/*-- SEQ 2708 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_PARTEDOCTOOPERA CASCADE;

/*-- SEQ 2709 --*/
CREATE OR REPLACE VIEW TV_TIMU_PARTEDOCTOOPERA AS
SELECT
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.NUMPAR, TAB.SUBPAR, TAB.CODSER, TAB.SUBSER, TAB.NUMECF, TAB.NUMNOT, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.NomeOperacao, -- {Recebimentos, Pagamentos Duplicatas, Adiantamentos Clientes}
      TAB.DataOperacao, -- Data da Operao (Enviar igual a DataBaixa)
      TAB.DataBaixa, -- Data da Baixa (Enviar igual a DataOperacao)
      TAB.ValorOriginal, -- Valor da Original da Parcela
      TAB.Valor, -- Valor da Operao (Enviar igual ao ValorBaixa)
      TAB.ValorBaixa, -- Valor da Baixa (Enviar igual ao Valor)
      TAB.NroDiasValidade, -- Nmero de Dias de Validade do Adiantamento
      TAB.FilialParcela, -- Cdigo da Filial da Parcela a ser Recebida/Paga
      TAB.CPFCNPJCliForParcela, -- CPF ou CNPJ do Cliente ou Fornecedor da Parcela a ser Recebida/Paga
      TAB.CodigoCliForParcela, -- Cdigo do Cliente ou Fornecedor da Parcela a ser Recebida/Paga
      TAB.SerieParcela, -- Srie do Documento da Parcela a ser Recebida/Paga
      TAB.NumeroDocumentoParcela, -- Nmero do documento da Parcela a ser Recebida/Paga
      TAB.NumeroParcela, -- Nmero da Parcela a ser Recebida/Paga
      TAB.ValorJuros, -- Valor do Juros
      TAB.ValorMulta, -- Valor da Multa
      TAB.ValorDesconto, -- Valor do Desconto
      TAB.ValorAcrescimo, -- Valor Acrscimo
      TAB.ValorAbatimento, -- Valor Abatimento
      TAB.Historico -- Histrico da Baixa
      --TAB.ChaveMueller -- Campo Chave Sistema Mueller
  FROM (-- Operao de Documentos de Pagamentos
        SELECT
               LID.CODFIL,
               CAST(LPAD(TO_CHAR(LID.TRN_ID), 10, ' ') AS CHAR(10)) AS SEQUEN, -- REC.SEQUEN
               CAST(' 0' AS CHAR(2)) AS NUMPAR,
               CAST(' 0' AS CHAR(2)) AS SUBPAR,
               CAST('999' AS VARCHAR(3)) AS CODSER, CAST(NULL AS VARCHAR(3)) AS SUBSER, CAST(LID.NUMECF AS CHAR(3)) AS NUMECF, CAST(LID.CUPFIS AS VARCHAR(10)) AS NUMNOT,
               CAST('LID' AS VARCHAR(3)) AS ORIGEM, 
               CAST('TIMU_PARTEDOCTOOPERA' AS VARCHAR(50)) AS DESTINO, 
               LID.DATHOR AS DATINC, 
               LID.DATEXE AS ATU_EM,
               LID.EXPEM4 AS EXPORT,
               LID.EXPEM4,
               CAST('PGT' || LID.CODFIL|| TO_CHAR(LID.TRN_ID) || LID.NUMECF || LID.CUPFIS AS VARCHAR(50)) AS CHAVE,
               LID.DATEXE AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               -- Tipo de Operao exportado de forma fixa conforme conversado com a EME4
               CAST(999 AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST(TO_NUMBER(LID.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = VEN.FILCLI AND REL.CODPAR = VEN.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                         ELSE 'C'
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST('PG'|| LID.NUMECF AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(LID.TRN_ID AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               --CAST(LPAD(TRIM(VEN.NUMNOT), 6, '0')||LPAD(TRIM(REC.NUMPAR), 2, '0')||LPAD(TRIM(REC.SUBPAR), 2, '0') AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST('Recebimentos' AS VARCHAR(50)) AS NomeOperacao, -- {Recebimentos, Pagamentos Duplicatas, Adiantamentos Clientes}
               CAST(TRUNC(LID.DATHOR) AS Timestamp) AS DataOperacao, -- Data da Operao (Enviar igual a DataBaixa)
               CAST(TRUNC(LID.DATHOR) AS Timestamp) AS DataBaixa, -- Data da Baixa (Enviar igual a DataOperacao)
               CAST(ABS(RECORI.VLRPAR) AS Numeric(15,2)) AS ValorOriginal, -- Valor da Original da Parcela
               CAST(ABS(LID.VLROPE) AS Numeric(15,2)) AS Valor, -- Valor da Operao (Enviar igual ao ValorBaixa)
               CAST(ABS(LID.VLROPE) - CASE WHEN COALESCE(LID.VLRDES,0) > 0 THEN ABS(LID.VLRDES) ELSE 0 END + CASE WHEN COALESCE(LID.VLRDES,0) < 0 THEN ABS(LID.VLRDES) ELSE 0 END AS Numeric(15,2)) AS ValorBaixa, -- Valor da Baixa (Enviar igual ao Valor)
               CAST(NULL AS Numeric(4)) AS NroDiasValidade, -- Nmero de Dias de Validade do Adiantamento
               -- Dados da Parcela Paga
               CAST(TO_NUMBER(LID.FILREC) AS Numeric(3)) AS FilialParcela, -- Cdigo da Filial da Parcela a ser Recebida/Paga
               CAST(CASE WHEN (LeParametroTXT('TIPO_EXP_EME4', LID.CODFIL, '', '', '')='V') AND (ISNOTNULL(COALESCE(PAR.NUMDOC, VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliForParcela, -- Cdigo do Cliente ou Fornecedor da Parcela a ser Recebida/Paga
               CAST(TRIM(COALESCE(PAR.NUMDOC, VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliForParcela, -- CPF ou CNPJ do Cliente ou Fornecedor da Parcela a ser Recebida/Paga
               CAST(TRIM(CASE WHEN VEN.CODSER='CF' THEN VEN.CODSER
                              WHEN VEN.CODSER='NM' THEN CAST(CONCAT('N',VEN.NUMECF) AS VARCHAR(5))
                              WHEN ( (VEN.MODNOT = '65' OR VEN.MODNOT = '59') AND VEN.NUMECF >= '400' ) THEN VEN.NUMECF
                              WHEN VEN.CODSER<>'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN DSER.SEREXT
                              ELSE NULL
                         END) AS VARCHAR(5)) AS SerieParcela, -- Srie do Documento da Parcela a ser Recebida/Paga
               CAST(TO_CHAR(TO_NUMBER(TRIM(CASE WHEN VEN.CODSER = 'CF' THEN VEN.SEQUEN
                                                WHEN VEN.CODSER='NM' THEN CAST(CONCAT('N',VEN.NUMECF) AS VARCHAR(5))
                                                WHEN VEN.CODSER = 'ST' THEN COALESCE(TO_CHAR(VEN.SATCFE), VEN.NUMNOT)
                                                ELSE VEN.NUMNOT END))) AS VARCHAR(10)) AS NumeroDocumentoParcela, -- Nmero do documento da Parcela a ser Recebida/Paga
               -- Definido juntamente com a EME4 que deve ser enviado apenas numero sem zero a esquerda, ser enviado apenas o n da parcela pois no enviaremos as sub-parcelas nesse ponto ser enviado como Operao de Liquidao
               --CAST(LPAD(TRIM(REC.NUMPAR), 2, '0')||LPAD('0'/*TRIM(REC.SUBPAR)*/, 2, '0') AS VARCHAR(30)) AS NumeroParcela, -- Nmero da Parcela a ser Recebida/Paga
               CAST(TRIM(LID.NUMPAR) AS VARCHAR(30)) AS NumeroParcela, -- Nmero da Parcela a ser Recebida/Paga
               CAST(ABS(LID.VLRJUROS) + ABS(LID.VLRACRES) AS Numeric(12,2)) AS ValorJuros, -- Valor do Juros
               CAST(ABS(LID.VLRMULTA) AS Numeric(12,2)) AS ValorMulta, -- Valor da Multa
               CAST(ABS(LID.VLRDESPAG) AS Numeric(12,2)) AS ValorDesconto, -- Valor do Desconto
               CAST(0 AS Numeric(12,2)) AS ValorAcrescimo, -- Valor Acrscimo
               CAST(ABS(LID.VLRABATIMENTO) AS Numeric(12,2)) AS ValorAbatimento, -- Valor Abatimento
               CAST('Receb. Varejo: Cliente ' ||
                    CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = CFG.VC_FILCLI||CFG.VC_CODCLI) THEN
                           CASE WHEN PAR.FLGTIP = 0
                                     THEN CASE WHEN CFG.UNE_NOME_SOBRENOME = 'T'
                                               THEN PAR.NOMCLI
                                               ELSE PAR.NOMCLI||' '||COALESCE(PAR.ULTNOM,'')
                                          END
                                     ELSE PAR.NOMCLI
                           END ||
                           CASE WHEN PAR.FLGTIP = 0
                                THEN ''
                                ELSE ' ' || COALESCE(PAR.ULTNOM,'')
                           END
                         ELSE
                           CASE WHEN VIN.FLGTIP = 0
                                     THEN CASE WHEN CFG.UNE_NOME_SOBRENOME = 'T'
                                               THEN VIN.NOMCLI
                                               ELSE VIN.NOMCLI||' '||COALESCE(VIN.ULTNOM,'')
                                          END
                                     ELSE VIN.NOMCLI
                           END ||
                           CASE WHEN VIN.FLGTIP = 0
                                THEN ''
                                ELSE ' ' || COALESCE(VIN.ULTNOM,'')
                           END
                    END AS VARCHAR(80)) AS Historico -- Histrico da Baixa
      FROM (
            SELECT LD.CODFIL, LD.NUMECF, LD.TRN_ID, LD.CUPFIS, LD.DATHOR, LD.DATEXE, LD.EXPEM4,
                   OPE.FILREC, OPE.SEQREC, OPE.NUMPAR, SUM(OPE.VLROPE) AS VLROPE, SUM(OPE.VLRDES) AS VLRDES, SUM(OPE.VLRTAX) AS VLRTAX,
                   SUM(OPE.VLRJUROS) AS VLRJUROS, SUM(OPE.VLRMULTA) AS VLRMULTA, SUM(OPE.VLRDESPAG) AS VLRDESPAG, SUM(OPE.VLRACRES) AS VLRACRES,
                   SUM(OPE.VLRABATIMENTO) AS VLRABATIMENTO
              FROM TT_LID LD
              JOIN (SELECT OP.CODFIL, OP.NUMECF, OP.TRN_ID, OP.CUPFIS, OP.FILREC, OP.SEQREC, OP.NUMPAR, OP.VLROPE, REC.VLRDES, REC.VLRTAX,
                           REC.VLRJUROS, REC.VLRMULTA, REC.VLRDESPAG, REC.VLRACRES, REC.VLRABATIMENTO
                      FROM TT_OPE OP
                      JOIN TT_REC REC ON REC.CODFIL = OP.FILREC AND REC.SEQUEN = OP.SEQREC
                                     AND REC.NUMPAR = OP.NUMPAR AND REC.SUBPAR = OP.SUBPAR
                     WHERE OP.MEIPGT = 'F'
                       AND OP.FILREC IS NOT NULL
                    ) OPE ON OPE.CODFIL = LD.CODFIL AND OPE.NUMECF = LD.NUMECF
                         AND OPE.TRN_ID = LD.TRN_ID AND OPE.CUPFIS = LD.CUPFIS
             WHERE LD.TIPOPE = 'RECDEBITO'
               AND LD.EXPEM4 = 'F'
               AND LD.VLROPE > 0
             GROUP BY LD.CODFIL, LD.NUMECF, LD.TRN_ID, LD.CUPFIS, LD.DATHOR, LD.DATEXE, LD.EXPEM4, OPE.FILREC, OPE.SEQREC, OPE.NUMPAR
          ) LID
          -- Venda de Emisso para possibilitar extrao do cliente
          JOIN TT_VEN VEN ON VEN.CODFIL = LID.FILREC AND VEN.SEQUEN = LID.SEQREC
          -- Srie de Emisso
          JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
          -- Cliente
          JOIN TT_CLI PAR ON PAR.FILCLI = VEN.FILCLI AND PAR.CODCLI = VEN.CODCLI
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = VEN.FILCLI AND ENDFAT.CODCLI = VEN.CODCLI AND ENDFAT.CODFIL = VEN.FILFAT AND ENDFAT.NUMEND = VEN.ENDFAT
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          -- Valor Original da Parcela
          LEFT JOIN TT_REC RECORI ON RECORI.CODFIL = LID.FILREC AND RECORI.SEQUEN = LID.SEQREC
                                 AND RECORI.NUMPAR = LID.NUMPAR AND RECORI.SUBPAR = ' 0'
          CROSS JOIN TT_CFG CFG
         WHERE 1=1
           AND LID.DATHOR >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',LID.CODFIL,'','','')
           AND (LeParametroTXT('TIPO_EXP_EME4', LID.CODFIL, '', '', '') = 'V')
           --AND LID.EXPEM4 = 'F'
        UNION ALL
        SELECT
               REC.CODFIL, 
               REC.SEQUEN, 
               REC.NUMPAR, 
               REC.SUBPAR, 
               CAST(VEN.CODSER AS VARCHAR(3)) AS CODSER, 
               CAST(NULL AS VARCHAR(3)) AS SUBSER, 
               CAST(VEN.NUMECF AS CHAR(3)) AS NUMECF,
               CAST(VEN.NUMNOT AS VARCHAR(10)) AS NUMNOT,
               CAST('PGT' AS VARCHAR(3)) AS ORIGEM, 
               CAST('TIMU_PARTEDOCTOOPERA' AS VARCHAR(50)) AS DESTINO, 
               REC.PAGAME AS DATINC, 
               REC.ATU_EM, REC.EXPORT, 
               REC.EXPORT AS EXPEM4,
               CAST('PGT' || REC.CODFIL || REC.SEQUEN || REC.NUMPAR || REC.SUBPAR AS VARCHAR(50)) AS CHAVE,
               REC.ATU_EM AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               -- Tipo de Operao exportado de forma fixa conforme conversado com a EME4
               CAST(999 AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST(TO_NUMBER(REC.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = VEN.FILCLI AND REL.CODPAR = VEN.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                         ELSE 'C'
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST('PG'||CASE WHEN VEN.CODSER<>'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN LPAD(TRIM(DSER.SEREXT), 3, '0')
                               ELSE VEN.NUMECF
                          END AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(LPAD(TRIM(VEN.NUMNOT), 6, '0') AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               --CAST(LPAD(TRIM(VEN.NUMNOT), 6, '0')||LPAD(TRIM(REC.NUMPAR), 2, '0')||LPAD(TRIM(REC.SUBPAR), 2, '0') AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST('Recebimentos' AS VARCHAR(50)) AS NomeOperacao, -- {Recebimentos, Pagamentos Duplicatas, Adiantamentos Clientes}
               CAST(TRUNC(REC.PAGAME) AS Timestamp) AS DataOperacao, -- Data da Operao (Enviar igual a DataBaixa)
               CAST(TRUNC(REC.PAGAME) AS Timestamp) AS DataBaixa, -- Data da Baixa (Enviar igual a DataOperacao)
               CAST(ABS(RECORI.VLRPAR) AS Numeric(15,2)) AS ValorOriginal, -- Valor da Original da Parcela
               CAST(ABS(REC.VLRPGT) + COALESCE(ABS(REC.VLRTAX),0) AS Numeric(15,2)) AS Valor, -- Valor da Operao (Enviar igual ao ValorBaixa)
               CAST(ABS(REC.VLRPGT) + COALESCE(ABS(REC.VLRTAX),0) - CASE WHEN COALESCE(REC.VLRDES,0) > 0 THEN ABS(REC.VLRDES) ELSE 0 END AS Numeric(15,2)) AS ValorBaixa, -- Valor da Baixa (Enviar igual ao Valor)
               CAST(NULL AS Numeric(4)) AS NroDiasValidade, -- Nmero de Dias de Validade do Adiantamento
               -- Dados da Parcela Paga
               CAST(TO_NUMBER(VEN.CODFIL) AS Numeric(3)) AS FilialParcela, -- Cdigo da Filial da Parcela a ser Recebida/Paga
               CAST(CASE WHEN (LeParametroTXT('TIPO_EXP_EME4', REC.CODFIL, '', '', '')='V') AND (ISNOTNULL(COALESCE(PAR.NUMDOC, VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliForParcela, -- Cdigo do Cliente ou Fornecedor da Parcela a ser Recebida/Paga
               CAST(TRIM(COALESCE(PAR.NUMDOC, VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliForParcela, -- CPF ou CNPJ do Cliente ou Fornecedor da Parcela a ser Recebida/Paga
               CAST(TRIM(CASE WHEN VEN.CODSER='CF' THEN VEN.CODSER
                              WHEN ( (VEN.MODNOT = '65' OR VEN.MODNOT = '59') AND VEN.NUMECF >= '400' ) THEN VEN.NUMECF
                              WHEN VEN.CODSER<>'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN DSER.SEREXT
                              ELSE NULL
                         END) AS VARCHAR(5)) AS SerieParcela, -- Srie do Documento da Parcela a ser Recebida/Paga
               CAST(TO_CHAR(TO_NUMBER(TRIM(CASE WHEN VEN.CODSER = 'CF' THEN VEN.SEQUEN ELSE VEN.NUMNOT END))) AS VARCHAR(10)) AS NumeroDocumentoParcela, -- Nmero do documento da Parcela a ser Recebida/Paga
               -- Definido juntamente com a EME4 que deve ser enviado apenas numero sem zero a esquerda, ser enviado apenas o n da parcela pois no enviaremos as sub-parcelas nesse ponto ser enviado como Operao de Liquidao
               --CAST(LPAD(TRIM(REC.NUMPAR), 2, '0')||LPAD('0'/*TRIM(REC.SUBPAR)*/, 2, '0') AS VARCHAR(30)) AS NumeroParcela, -- Nmero da Parcela a ser Recebida/Paga
               CAST(TRIM(REC.NUMPAR) AS VARCHAR(30)) AS NumeroParcela, -- Nmero da Parcela a ser Recebida/Paga
               CAST(ABS(REC.VLRJUROS) AS Numeric(12,2)) AS ValorJuros, -- Valor do Juros
               CAST(ABS(REC.VLRMULTA) AS Numeric(12,2)) AS ValorMulta, -- Valor da Multa
               CAST(ABS(REC.VLRDESPAG) AS Numeric(12,2)) AS ValorDesconto, -- Valor do Desconto
               CAST(ABS(REC.VLRACRES) AS Numeric(12,2)) AS ValorAcrescimo, -- Valor Acrscimo
               CAST(ABS(REC.VLRABATIMENTO) AS Numeric(12,2)) AS ValorAbatimento, -- Valor Abatimento
               CAST('Receb. Varejo: Cliente ' ||
                    CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = CFG.VC_FILCLI||CFG.VC_CODCLI) THEN
                           CASE WHEN PAR.FLGTIP = 0
                                     THEN CASE WHEN CFG.UNE_NOME_SOBRENOME = 'T'
                                               THEN PAR.NOMCLI
                                               ELSE PAR.NOMCLI||' '||COALESCE(PAR.ULTNOM,'')
                                          END
                                     ELSE PAR.NOMCLI
                           END ||
                           CASE WHEN PAR.FLGTIP = 0
                                THEN ''
                                ELSE ' ' || COALESCE(PAR.ULTNOM,'')
                           END
                         ELSE
                           CASE WHEN VIN.FLGTIP = 0
                                     THEN CASE WHEN CFG.UNE_NOME_SOBRENOME = 'T'
                                               THEN VIN.NOMCLI
                                               ELSE VIN.NOMCLI||' '||COALESCE(VIN.ULTNOM,'')
                                          END
                                     ELSE VIN.NOMCLI
                           END ||
                           CASE WHEN VIN.FLGTIP = 0
                                THEN ''
                                ELSE ' ' || COALESCE(VIN.ULTNOM,'')
                           END
                    END AS VARCHAR(80)) AS Historico -- Histrico da Baixa
          FROM TT_REC REC
          JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
          -- Srie de Emisso
          JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
          -- Plano
          JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT AND PLA.CODPGT = VEN.CODPGT
          -- Cliente
          JOIN TT_CLI PAR ON PAR.FILCLI = VEN.FILCLI AND PAR.CODCLI = VEN.CODCLI
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = VEN.FILCLI AND ENDFAT.CODCLI = VEN.CODCLI AND ENDFAT.CODFIL = VEN.FILFAT AND ENDFAT.NUMEND = VEN.ENDFAT
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          -- Valor Original da Parcela
          LEFT JOIN TT_REC RECORI ON RECORI.CODFIL = REC.FILREC AND RECORI.SEQUEN = REC.SEQUEN
                                 AND RECORI.NUMPAR = REC.NUMPAR AND RECORI.SUBPAR = ' 0'
          CROSS JOIN TT_CFG CFG
         WHERE 1=1 --REC.SUBPAR = ' 0' -- No trata Sub-Parcela 0 pois operao de recebimento pode ocorrer com todas as operaes
           AND VEN.NUMNOT NOT LIKE '%#%'
           AND REC.FLGEST = 'P'
           AND REC.AVISTA = 'F'
         AND COALESCE(REC.INDEXP, 'E') <> 'N'
           AND REC.PAGAME >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',REC.CODFIL,'','','')
           AND (LeParametroTXT('TIPO_EXP_EME4', REC.CODFIL, '', '', '') = 'V')
           --AND LID.EXPEM4 = 'F'
           AND NOT EXISTS (SELECT 1 AS OK 
                             FROM TT_OPE OPE
                             JOIN TT_LID LID ON LID.CODFIL = OPE.CODFIL AND LID.NUMECF = OPE.NUMECF 
                                            AND LID.TRN_ID = OPE.TRN_ID AND LID.CUPFIS = OPE.CUPFIS
                            WHERE 1=1
                              AND LID.TIPOPE = 'RECDEBITO'
                              AND OPE.FILREC = REC.CODFIL AND OPE.SEQREC = REC.SEQUEN
                              AND OPE.NUMPAR = REC.NUMPAR AND OPE.SUBPAR = REC.SUBPAR)
           AND NOT EXISTS(SELECT 1 AS OK
                    FROM TW_EXTXDOC EXD
                   WHERE EXD.ORIGEM = ORIGEM AND EXD.DESTINO = DESTINO
                     AND EXD.FILORI = REC.CODFIL AND EXD.SEQORI = REC.SEQUEN
                     AND EXD.PARORI = REC.NUMPAR AND EXD.SUBORI = REC.SUBPAR)
        UNION ALL
       SELECT
               REC.CODFIL, 
               REC.SEQUEN, 
               REC.NUMPAR, 
               REC.SUBPAR, 
               CAST(VEN.CODSER AS VARCHAR(3)) AS CODSER, 
               CAST(NULL AS VARCHAR(3)) AS SUBSER, 
               CAST(VEN.NUMECF AS CHAR(3)) AS NUMECF, 
               CAST(VEN.NUMNOT AS VARCHAR(10)) AS NUMNOT,
               CAST('PGT' AS VARCHAR(3)) AS ORIGEM, 
               CAST('TIMU_PARTEDOCTOOPERA' AS VARCHAR(50)) AS DESTINO, 
               REC.PAGAME AS DATINC, 
               REC.ATU_EM, 
               REC.EXPORT, 
               REC.EXPORT AS EXPEM4,
               CAST('PGT' || REC.CODFIL || REC.SEQUEN || REC.NUMPAR || REC.SUBPAR AS VARCHAR(50)) AS CHAVE,
               REC.ATU_EM AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               -- Tipo de Operao exportado de forma fixa conforme conversado com a EME4
               CAST(999 AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST(TO_NUMBER(VEN.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = VEN.FILCLI AND REL.CODPAR = VEN.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                         ELSE 'C'
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST('PG'||CASE WHEN VEN.CODSER<>'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN LPAD(TRIM(DSER.SEREXT), 3, '0')
                               ELSE VEN.NUMECF
                          END AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(LPAD(TRIM(VEN.NUMNOT), 6, '0') AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               --CAST(LPAD(TRIM(VEN.NUMNOT), 6, '0')||LPAD(TRIM(REC.NUMPAR), 2, '0')||LPAD(TRIM(REC.SUBPAR), 2, '0') AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST('Recebimentos' AS VARCHAR(50)) AS NomeOperacao, -- {Recebimentos, Pagamentos Duplicatas, Adiantamentos Clientes}
               CAST(TRUNC(REC.PAGAME) AS Timestamp) AS DataOperacao, -- Data da Operao (Enviar igual a DataBaixa)
               CAST(TRUNC(REC.PAGAME) AS Timestamp) AS DataBaixa, -- Data da Baixa (Enviar igual a DataOperacao)
               CAST(ABS(RECORI.VLRPAR) AS Numeric(15,2)) AS ValorOriginal, -- Valor da Original da Parcela
               CAST(ABS(REC.VLRPGT) + COALESCE(ABS(REC.VLRTAX),0) AS Numeric(15,2)) AS Valor, -- Valor da Operao (Enviar igual ao ValorBaixa)
               CAST(ABS(REC.VLRPGT) + COALESCE(ABS(REC.VLRTAX),0) - CASE WHEN COALESCE(REC.VLRDES,0) > 0 THEN ABS(REC.VLRDES) ELSE 0 END AS Numeric(15,2)) AS ValorBaixa, -- Valor da Baixa (Enviar igual ao Valor)
               CAST(NULL AS Numeric(4)) AS NroDiasValidade, -- Nmero de Dias de Validade do Adiantamento
               -- Dados da Parcela Paga
               CAST(TO_NUMBER(VEN.CODFIL) AS Numeric(3)) AS FilialParcela, -- Cdigo da Filial da Parcela a ser Recebida/Paga
               CAST(CASE WHEN (LeParametroTXT('TIPO_EXP_EME4', REC.CODFIL, '', '', '')='V') AND (ISNOTNULL(COALESCE(PAR.NUMDOC, VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliForParcela, -- Cdigo do Cliente ou Fornecedor da Parcela a ser Recebida/Paga
               CAST(TRIM(COALESCE(PAR.NUMDOC, VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliForParcela, -- CPF ou CNPJ do Cliente ou Fornecedor da Parcela a ser Recebida/Paga
               CAST(TRIM(CASE WHEN VEN.CODSER='CF' THEN VEN.CODSER
                              WHEN ( (VEN.MODNOT = '65' OR VEN.MODNOT = '59') AND VEN.NUMECF >= '400' ) THEN VEN.NUMECF
                              WHEN VEN.CODSER<>'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN DSER.SEREXT
                              ELSE NULL
                         END) AS VARCHAR(5)) AS SerieParcela, -- Srie do Documento da Parcela a ser Recebida/Paga
               CAST(TO_CHAR(TO_NUMBER(TRIM(CASE WHEN VEN.CODSER = 'CF' THEN VEN.SEQUEN ELSE VEN.NUMNOT END))) AS VARCHAR(10)) AS NumeroDocumentoParcela, -- Nmero do documento da Parcela a ser Recebida/Paga
               -- Definido juntamente com a EME4 que deve ser enviado apenas numero sem zero a esquerda, ser enviado apenas o n da parcela pois no enviaremos as sub-parcelas nesse ponto ser enviado como Operao de Liquidao
               --CAST(LPAD(TRIM(REC.NUMPAR), 2, '0')||LPAD('0'/*TRIM(REC.SUBPAR)*/, 2, '0') AS VARCHAR(30)) AS NumeroParcela, -- Nmero da Parcela a ser Recebida/Paga
               CAST(TRIM(REC.NUMPAR) AS VARCHAR(30)) AS NumeroParcela, -- Nmero da Parcela a ser Recebida/Paga
               CAST(ABS(REC.VLRJUROS) AS Numeric(12,2)) AS ValorJuros, -- Valor do Juros
               CAST(ABS(REC.VLRMULTA) AS Numeric(12,2)) AS ValorMulta, -- Valor da Multa
               CAST(ABS(REC.VLRDESPAG) AS Numeric(12,2)) AS ValorDesconto, -- Valor do Desconto
               CAST(ABS(REC.VLRACRES) AS Numeric(12,2)) AS ValorAcrescimo, -- Valor Acrscimo
               CAST(ABS(REC.VLRABATIMENTO) AS Numeric(12,2)) AS ValorAbatimento, -- Valor Abatimento
               CAST('Receb. Varejo: Cliente ' ||
                    CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = CFG.VC_FILCLI||CFG.VC_CODCLI) THEN
                           CASE WHEN PAR.FLGTIP = 0
                                     THEN CASE WHEN CFG.UNE_NOME_SOBRENOME = 'T'
                                               THEN PAR.NOMCLI
                                               ELSE PAR.NOMCLI||' '||COALESCE(PAR.ULTNOM,'')
                                          END
                                     ELSE PAR.NOMCLI
                           END ||
                           CASE WHEN PAR.FLGTIP = 0
                                THEN ''
                                ELSE ' ' || COALESCE(PAR.ULTNOM,'')
                           END
                         ELSE
                           CASE WHEN VIN.FLGTIP = 0
                                     THEN CASE WHEN CFG.UNE_NOME_SOBRENOME = 'T'
                                               THEN VIN.NOMCLI
                                               ELSE VIN.NOMCLI||' '||COALESCE(VIN.ULTNOM,'')
                                          END
                                     ELSE VIN.NOMCLI
                           END ||
                           CASE WHEN VIN.FLGTIP = 0
                                THEN ''
                                ELSE ' ' || COALESCE(VIN.ULTNOM,'')
                           END
                    END AS VARCHAR(80)) AS Historico -- Histrico da Baixa
          FROM TT_REC REC
          JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
          -- Srie de Emisso
          JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
          -- Plano
          JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT AND PLA.CODPGT = VEN.CODPGT
          -- Cliente
          JOIN TT_CLI PAR ON PAR.FILCLI = VEN.FILCLI AND PAR.CODCLI = VEN.CODCLI
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = VEN.FILCLI AND ENDFAT.CODCLI = VEN.CODCLI AND ENDFAT.CODFIL = VEN.FILFAT AND ENDFAT.NUMEND = VEN.ENDFAT
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          -- Valor Original da Parcela
          LEFT JOIN TT_REC RECORI ON RECORI.CODFIL = REC.FILREC AND RECORI.SEQUEN = REC.SEQUEN
                                 AND RECORI.NUMPAR = REC.NUMPAR AND RECORI.SUBPAR = ' 0'
          CROSS JOIN TT_CFG CFG
         WHERE 1=1 --REC.SUBPAR = ' 0' -- No trata Sub-Parcela 0 pois operao de recebimento pode ocorrer com todas as operaes
           AND VEN.NUMNOT NOT LIKE '%#%'
           AND VEN.FILEST IS NOT NULL -- Devoluo automtica ou Nota de Estorno
           AND REC.FLGEST = 'X'       -- Devoluo automtica ou Nota de Estorno
           AND REC.AVISTA = 'F'
           AND COALESCE(REC.INDEXP, 'E') <> 'N'
           AND REC.PAGAME >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',REC.CODFIL,'','','')
           AND (LeParametroTXT('TIPO_EXP_EME4', REC.CODFIL, '', '', '') = 'V')
           --AND LID.EXPEM4 = 'F'        
           AND NOT EXISTS(SELECT 1 AS OK
                    FROM TW_EXTXDOC EXD
                   WHERE EXD.ORIGEM = ORIGEM AND EXD.DESTINO = DESTINO
                     AND EXD.FILORI = REC.CODFIL AND EXD.SEQORI = REC.SEQUEN
                     AND EXD.PARORI = REC.NUMPAR AND EXD.SUBORI = REC.SUBPAR)
       ) TAB
 WHERE 1=1
   AND TAB.TipoOperacao IS NOT NULL
 ORDER BY TAB.CODFIL, TAB.SEQUEN, TAB.NUMPAR, TAB.SUBPAR, TAB.DataHoraAtuReg
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Operao Financeira Documento" (Tabela Integrao Mult)
-- Arquivo Pai: TIMU_PARTEDOCTOOPERA
/*-- SEQ 2710 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_PARTEDOCTOOPERAEMIT CASCADE;

/*-- SEQ 2711 --*/
CREATE OR REPLACE VIEW TV_TIMU_PARTEDOCTOOPERAEMIT AS
SELECT
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.NomeOperacao, -- {Recebimentos, Pagamentos Duplicatas, Adiantamentos Clientes}
      TAB.DataOperacao, -- Data da Operao (Enviar igual a DataBaixa)
      TAB.DataBaixa, -- Data da Baixa (Enviar igual a DataOperacao)
      TAB.Valor, -- Valor da Operao (Enviar igual ao ValorBaixa)
      TAB.ValorBaixa, -- Valor da Baixa (Enviar igual ao Valor)
      TAB.NroDiasValidade, -- Nmero de Dias de Validade do Adiantamento
      TAB.FilialParcela, -- Cdigo da Filial da Parcela a ser Recebida/Paga
      TAB.CPFCNPJCliForParcela, -- CPF ou CNPJ do Cliente ou Fornecedor da Parcela a ser Recebida/Paga
      TAB.CodigoCliForParcela, -- Cdigo do Cliente ou Fornecedor da Parcela a ser Recebida/Paga
      TAB.SerieParcela, -- Srie do Documento da Parcela a ser Recebida/Paga
      TAB.NumeroDocumentoParcela, -- Nmero do documento da Parcela a ser Recebida/Paga
      TAB.NumeroParcela, -- Nmero da Parcela a ser Recebida/Paga
      TAB.ValorJuros, -- Valor do Juros
      TAB.ValorMulta, -- Valor da Multa
      TAB.ValorDesconto, -- Valor do Desconto
      TAB.ValorAbatimento, -- Valor Abatimento
      TAB.Historico -- Histrico da Baixa
      --TAB.ChaveMueller -- Campo Chave Sistema Mueller
  FROM (-- Operao de Documentos Emitidos
        SELECT
               VEN.CODFIL, VEN.SEQUEN, CAST('VEN' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_PARTEDOCTOOPERA' AS VARCHAR(50)) AS DESTINO, COALESCE(VEN.DATINC, VEN.DATHOR) AS DATINC, VEN.ATU_EM, VEN.EXPORT, VEN.EXPEM4,
               CAST('VEN' || VEN.CODFIL || VEN.SEQUEN AS VARCHAR(50)) AS CHAVE,
               COALESCE(VEN.DATINC, VEN.DATHOR) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               -- Definido juntamente com a EME4 quando for cupom fiscal enviar tipo de operao fixo
               CAST(CASE WHEN (VEN.CODSER = 'CF') THEN 998
                         WHEN (VEN.MODNOT = '65') THEN 997
                         WHEN (VEN.MODNOT = '59') THEN 996
                         WHEN (VEN.UFLOJA = 'T') THEN                                                       TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTDEM, '[^0-9]', '', 'gi'), ''))                         ELSE                               TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTFOR, '[^0-9]', '', 'gi'), ''))                    END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST(TO_NUMBER(VEN.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = VEN.FILCLI AND REL.CODPAR = VEN.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                         ELSE 'C' 
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST(TRIM(CASE WHEN VEN.CODSER='CF' THEN VEN.CODSER
										WHEN VEN.CODSER='NM' THEN CAST(CONCAT('N',VEN.NUMECF) AS VARCHAR(5))
                              WHEN ( (VEN.MODNOT = '65' OR VEN.MODNOT = '59') AND VEN.NUMECF >= '400' ) THEN VEN.NUMECF
                              WHEN VEN.CODSER<>'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN DSER.SEREXT
                              ELSE NULL
                         END) AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(TO_CHAR(TO_NUMBER(TRIM(CASE WHEN VEN.CODSER = 'CF' THEN VEN.SEQUEN 
                                                WHEN VEN.CODSER = 'ST' THEN COALESCE(TO_CHAR(VEN.SATCFE), VEN.NUMNOT)
                                                ELSE VEN.NUMNOT END))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST('Recebimentos' AS VARCHAR(50)) AS NomeOperacao, -- {Recebimentos, Pagamentos Duplicatas, Adiantamentos Clientes}
               CAST(TRUNC(REC.PAGAME) AS Timestamp) AS DataOperacao, -- Data da Operao (Enviar igual a DataBaixa)
               CAST(TRUNC(REC.PAGAME) AS Timestamp) AS DataBaixa, -- Data da Baixa (Enviar igual a DataOperacao)
               CAST(ABS(REC.VLRPGT) + COALESCE(ABS(REC.VLRTAX),0) AS Numeric(15,2)) AS Valor, -- Valor da Operao (Enviar igual ao ValorBaixa)
               CAST(ABS(REC.VLRPGT) + COALESCE(ABS(REC.VLRTAX),0) - CASE WHEN COALESCE(REC.VLRDES,0) > 0 AND REC.CARTAO IS NULL THEN ABS(REC.VLRDES) ELSE 0 END AS Numeric(15,2)) AS ValorBaixa, -- Valor da Baixa (Enviar igual ao Valor)
               CAST(NULL AS Numeric(4)) AS NroDiasValidade, -- Nmero de Dias de Validade do Adiantamento
               -- Dados da Parcela Paga
               CAST(TO_NUMBER(VEN.CODFIL) AS Numeric(3)) AS FilialParcela, -- Cdigo da Filial da Parcela a ser Recebida/Paga
               CAST(CASE WHEN (LeParametroTXT('TIPO_EXP_EME4', REC.CODFIL, '', '', '')='V') AND (ISNOTNULL(COALESCE(PAR.NUMDOC, VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliForParcela, -- Cdigo do Cliente ou Fornecedor da Parcela a ser Recebida/Paga
               CAST(TRIM(COALESCE(PAR.NUMDOC, VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliForParcela, -- CPF ou CNPJ do Cliente ou Fornecedor da Parcela a ser Recebida/Paga
               CAST(TRIM(CASE WHEN VEN.CODSER='CF' THEN VEN.CODSER
                              WHEN ( (VEN.MODNOT = '65' OR VEN.MODNOT = '59') AND VEN.NUMECF >= '400' ) THEN VEN.NUMECF
                              WHEN VEN.CODSER<>'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN DSER.SEREXT
                              ELSE NULL
                         END) AS VARCHAR(5)) AS SerieParcela, -- Srie do Documento da Parcela a ser Recebida/Paga
               CAST(TO_CHAR(TO_NUMBER(TRIM(CASE WHEN VEN.CODSER = 'CF' THEN VEN.SEQUEN ELSE VEN.NUMNOT END))) AS VARCHAR(10)) AS NumeroDocumentoParcela, -- Nmero do documento da Parcela a ser Recebida/Paga
               -- Definido juntamente com a EME4 que deve ser enviado apenas numero sem zero a esquerda, ser enviado apenas o n da parcela pois no enviaremos as sub-parcelas nesse ponto ser enviado como Operao de Liquidao
               --CAST(LPAD(TRIM(REC.NUMPAR), 2, '0')||LPAD('0'/*TRIM(REC.SUBPAR)*/, 2, '0') AS VARCHAR(30)) AS NumeroParcela, -- Nmero da Parcela a ser Recebida/Paga
               CAST(TRIM(REC.NUMPAR) AS VARCHAR(30)) AS NumeroParcela, -- Nmero da Parcela a ser Recebida/Paga
               CAST(CASE WHEN COALESCE(REC.VLRDES,0) > 0 AND REC.CARTAO IS NULL THEN ABS(REC.VLRDES) ELSE 0 END AS Numeric(15,2)) AS ValorJuros, -- Valor do Juros
               CAST(NULL AS Numeric(15,2)) AS ValorMulta, -- Valor da Multa
               CAST(CASE WHEN COALESCE(REC.VLRDES,0) < 0 THEN ABS(REC.VLRDES) ELSE 0 END AS Numeric(15,2)) AS ValorDesconto, -- Valor do Desconto
               CAST(NULL AS Numeric(15,2)) AS ValorAbatimento, -- Valor Abatimento
               CAST('Cliente ' ||
                    CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = CFG.VC_FILCLI||CFG.VC_CODCLI) THEN
                           CASE WHEN PAR.FLGTIP = 0
                                     THEN CASE WHEN CFG.UNE_NOME_SOBRENOME = 'T'
                                               THEN PAR.NOMCLI
                                               ELSE PAR.NOMCLI||' '||COALESCE(PAR.ULTNOM,'')
                                          END
                                     ELSE PAR.NOMCLI
                           END ||
                           CASE WHEN PAR.FLGTIP = 0
                                THEN ''
                                ELSE ' ' || COALESCE(PAR.ULTNOM,'')
                           END
                         ELSE
                           CASE WHEN VIN.FLGTIP = 0
                                     THEN CASE WHEN CFG.UNE_NOME_SOBRENOME = 'T'
                                               THEN VIN.NOMCLI
                                               ELSE VIN.NOMCLI||' '||COALESCE(VIN.ULTNOM,'')
                                          END
                                     ELSE VIN.NOMCLI
                           END ||
                           CASE WHEN VIN.FLGTIP = 0
                                THEN ''
                                ELSE ' ' || COALESCE(VIN.ULTNOM,'')
                           END
                    END AS VARCHAR(80)) AS Historico -- Histrico da Baixa
          FROM TT_VEN VEN
          JOIN TT_REC REC ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
          -- Srie de Emisso
          JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
          -- Natureza
          JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
          -- Plano
          JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT AND PLA.CODPGT = VEN.CODPGT
          -- Cliente
          JOIN TT_CLI PAR ON PAR.FILCLI = VEN.FILCLI AND PAR.CODCLI = VEN.CODCLI
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = VEN.FILCLI AND ENDFAT.CODCLI = VEN.CODCLI AND ENDFAT.CODFIL = VEN.FILFAT AND ENDFAT.NUMEND = VEN.ENDFAT
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          CROSS JOIN TT_CFG CFG
         WHERE 1=1 --REC.SUBPAR = ' 0' -- No trata Sub-Parcela 0 pois operao de recebimento pode ocorrer com todas as operaes
           AND VEN.NUMNOT NOT LIKE '%#%'
           AND VEN.DATHOR >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',VEN.CODFIL,'','','')
           AND VEN.NUMNOT NOT LIKE '%#%'
           AND (
                  -- Quando Cupom Fiscal
                  (VEN.CODSER = 'CF') OR
						-- Quando a nota manual no for null (status  NM)
						(VEN.NOTMAN IS NOT NULL) OR
                  -- Quando no for Documento Eletrnico
                  (VEN.MODNOT NOT IN ('55','65','59','SE')) OR
                  -- Quando Documento Eletrnico
                  (
                     (VEN.MODNOT IN ('55','65','59','SE')) AND
                     (
                        -- Quando Cancelado exporta quando situao for Cancelada, Inutilizada ou Denegada
                        ((VEN.FLGEST = 'C') AND (VEN.FLGNFE IN ('3','4','6'))) OR
                        -- Quando Aberto/Quitado exporta quando situao for Autorizado
                        ((VEN.FLGEST <> 'C') AND (VEN.FLGNFE IN ('1'))) OR
                        -- Nota Estornada fica cancelada no banco mas autorizada na Sefaz
                        ((VEN.FLGEST = 'C') AND (VEN.FLGNFE = '1'))
                     )
                  )
               )
           AND (LeParametroTXT('TIPO_EXP_EME4', REC.CODFIL, '', '', '') = 'V')
           AND REC.NUMPAR = '00'
           AND VEN.EXPEM4 = 'F'
       ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Processo de Importao (DI)" (Tabela Integrao Mult)
/*-- SEQ 2712 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_PROCESSOIMPORT CASCADE;

/*-- SEQ 2713 --*/
CREATE OR REPLACE VIEW TV_TIMU_PROCESSOIMPORT AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.FILREF, TAB.SEQREF, TAB.ITEREF, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.IndicarImportacao, -- 0=Declarao de Importao,1=Declarao Simplificada de Importao,
      TAB.NumeroProcesso, -- Nmero do Processo
      TAB.NumeroDI, -- Nmero da Declarao de Importao
      TAB.DataDI, -- Data da DI
      TAB.DataEmissao, -- Data de Emisso do processo de importao
      TAB.LocalDesembaraco, -- Local do Desembarao
      TAB.UFDesembaraco, -- Sigla da UF do Desembarao
      TAB.PaisDesembaraco, -- Nome do Pais do Desembarao
      TAB.DataDesembaraco, -- Data do Desembarao
      TAB.Exportador, -- Nome do Exportador
      TAB.FormaImportacao, -- 1=Importao por conta prpria,2=Importao por conta e ordem,3=Importao por encomenda
      TAB.Adquirente, -- Nome do Adquirente
      TAB.AFRMM, -- VALOR AFRMM
      TAB.IndiceFinanceiro, -- Nome Moeda
      TAB.NroDrawback, -- Nmero Ato do Regime Drawback
      TAB.NroProforma -- Nmero Proforma
   FROM (
   SELECT VEN.CODFIL, VEN.SEQUEN, IVE.FILOIP AS FILREF, IVE.SEQOIP AS SEQREF, IVE.NUMADI AS ITEREF, CAST('IVE' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_PROCESSOIMPORT' AS VARCHAR(50)) AS DESTINO, COALESCE(VEN.DATINC, VEN.DATHOR) AS DATINC, VEN.ATU_EM, VEN.EXPORT, VEN.EXPEM4,
          CAST('VEN' || VEN.CODFIL || VEN.SEQUEN AS VARCHAR(50)) AS CHAVE,
          COALESCE(VEN.DATINC, VEN.DATHOR) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
          -- Definido juntamente com a EME4 quando for cupom fiscal enviar tipo de operao fixo
          CAST(CASE WHEN (VEN.CODSER = 'CF') THEN 998
                    WHEN (VEN.MODNOT = '65') THEN 997
                    WHEN (VEN.MODNOT = '59') THEN 996
                    WHEN (VEN.UFLOJA = 'T') THEN                                                  TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTDEM, '[^0-9]', '', 'gi'), ''))                    ELSE                          TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTFOR, '[^0-9]', '', 'gi'), ''))               END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
          CAST(TO_NUMBER(VEN.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
          CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                    ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                       THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                 ELSE SUBSTR(TO_CHAR(CAST(                                                                          NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                            END
                                       ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                 ELSE SUBSTR(TO_CHAR(CAST(                                                                          NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                            END
                                  END)
               END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
          CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
          CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = VEN.FILCLI AND REL.CODPAR = VEN.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F' ELSE 'C' END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
          CAST('1' AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
          CAST(TRIM(CASE WHEN VEN.CODSER='CF' THEN VEN.CODSER
								 WHEN VEN.CODSER='NM' THEN CAST(CONCAT('N',VEN.NUMECF) AS VARCHAR(5))
                         WHEN ( (VEN.MODNOT = '65' OR VEN.MODNOT = '59') AND VEN.NUMECF >= '400' ) THEN VEN.NUMECF
                         WHEN VEN.CODSER<>'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN DSER.SEREXT
                         ELSE NULL
                    END) AS VARCHAR(5)) AS Serie, -- Srie do Documento
          CAST(TO_CHAR(TO_NUMBER(TRIM(CASE WHEN VEN.CODSER = 'CF' THEN VEN.SEQUEN 
                                           WHEN VEN.CODSER = 'ST' THEN COALESCE(TO_CHAR(VEN.SATCFE), VEN.NUMNOT)
                                           ELSE VEN.NUMNOT END))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
          CAST(CASE WHEN OIP.TIPDOC = '1' THEN '1'
                    ELSE '0'
               END AS VARCHAR(1)) AS IndicarImportacao, -- 0=Declarao de Importao,1=Declarao Simplificada de Importao,
          -- Deve passar uma chave nica para que possa ser localizado internamente no sistema da EME4
          CAST(TO_NUMBER(TRIM(OIP.SEQUEN)) AS Numeric(9)) AS NumeroProcesso, -- Nmero do Processo
          CAST(OIP.DOCIMP AS VARCHAR(20)) AS NumeroDI, -- Nmero da Declarao de Importao
          CAST(TRUNC(OIP.DATOPE) AS Timestamp) AS DataDI, -- Data da DI
          CAST(TRUNC(OIP.DATOPE) AS Timestamp) AS DataEmissao, -- Data de Emisso do processo de importao
          CAST(OIP.LOCDES AS VARCHAR(50)) AS LocalDesembaraco, -- Local do Desembarao
          CAST(OIP.UF_DES AS VARCHAR(2)) AS UFDesembaraco, -- Sigla da UF do Desembarao
          CAST('Brasil' AS VARCHAR(80)) AS PaisDesembaraco, -- Nome do Pais do Desembarao
          CAST(TRUNC(OIP.DATDES) AS Timestamp) AS DataDesembaraco, -- Data do Desembarao
          CAST(ADI.DESFOR AS VARCHAR(120)) AS Exportador, -- Nome do Exportador
          CAST(CASE WHEN OIP.INTERM = '1' THEN '1'
                    WHEN OIP.INTERM = '2' THEN '2'
                    WHEN OIP.INTERM = '3' THEN '3'
                    ELSE NULL
               END AS VARCHAR(1)) AS FormaImportacao, -- 1=Importao por conta prpria,2=Importao por conta e ordem,3=Importao por encomenda
          CAST(DFIL.NOMFIL AS VARCHAR(120)) AS Adquirente, -- Nome do Adquirente
          CAST(OIP.VLRAFR AS Numeric(15,2)) AS AFRMM, -- VALOR AFRMM
          CAST('Dolar' AS VARCHAR(80)) AS IndiceFinanceiro, -- Nome Moeda
          CAST(ADI.NUMDRA AS VARCHAR(11)) AS NroDrawback, -- Nmero Ato do Regime Drawback
          CAST(NULL AS VARCHAR(20)) AS NroProforma -- Nmero Proforma
    FROM (SELECT DISTINCT LIVE.CODFIL, LIVE.SEQUEN, LIVE.FILOIP, LIVE.SEQOIP, LIVE.NUMADI
            FROM TT_IVE LIVE
            -- Filtra apenas notas com itens vinculados a Importao
           WHERE LIVE.FILOIP IS NOT NULL 
             AND LIVE.SEQOIP IS NOT NULL
             AND LIVE.NUMADI IS NOT NULL
             AND LIVE.SEQMER IS NOT NULL) IVE
    JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
    -- Srie de Emisso
    JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
    -- Natureza
    JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
    -- Cliente
    JOIN TT_CLI PAR ON PAR.FILCLI = VEN.FILCLI AND PAR.CODCLI = VEN.CODCLI
    --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
    -- Endereo de Faturamento
    LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = VEN.FILCLI AND ENDFAT.CODCLI = VEN.CODCLI AND ENDFAT.CODFIL = VEN.FILFAT AND ENDFAT.NUMEND = VEN.ENDFAT
    -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
    LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    JOIN TD_FIL DFIL ON DFIL.CODFIL = VEN.CODFIL
    JOIN TT_OIP OIP ON OIP.CODFIL = IVE.FILOIP AND OIP.SEQUEN = IVE.SEQOIP
    JOIN TT_ADI ADI ON ADI.CODFIL = IVE.FILOIP AND ADI.SEQUEN = IVE.SEQOIP AND ADI.NUMITE = IVE.NUMADI
   WHERE 1 = 1
     AND VEN.DATHOR >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',VEN.CODFIL,'','','')
     AND (LeParametroTXT('TIPO_EXP_EME4', VEN.CODFIL, '', '', '') = 'C')
     AND VEN.NUMNOT NOT LIKE '%#%'
     AND (
            -- Quando Cupom Fiscal
            (VEN.CODSER = 'CF') OR
				-- Quando a nota manual no for null (status  NM)
				(VEN.NOTMAN IS NOT NULL) OR
            -- Quando no for Documento Eletrnico
            (VEN.MODNOT NOT IN ('55','65','59','SE')) OR
            -- Quando Documento Eletrnico
            (
               (VEN.MODNOT IN ('55','65','59','SE')) AND 
               (
                  -- Quando Cancelado exporta quando situao for Cancelada, Inutilizada ou Denegada
                  ((VEN.FLGEST = 'C') AND (VEN.FLGNFE IN ('3','4','6'))) OR
                  -- Quando Aberto/Quitado exporta quando situao for Autorizado
                  ((VEN.FLGEST <> 'C') AND (VEN.FLGNFE IN ('1'))) OR
                  -- Nota Estornada fica cancelada no banco mas autorizada na Sefaz
                  ((VEN.FLGEST = 'C') AND (VEN.FLGNFE = '1'))
               )
            )
         )
     AND VEN.EXPEM4 = 'F'
   ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
 
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Produto do Inventrio" (Tabela Integrao Mult)
/*-- SEQ 2714 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_PRODINVENT CASCADE;

/*-- SEQ 2715 --*/
CREATE OR REPLACE VIEW TV_TIMU_PRODINVENT AS
   SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TW_EXTXDOC EXD 
                             WHERE EXD.ORIGEM = TAB.ORIGEM AND EXD.DESTINO = TAB.DESTINO
                               AND EXD.FILORI = TAB.CODFIL AND EXD.SEQORI = TAB.SEQUEN
                               ) THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.ORIGEM, TAB.DESTINO, TAB.CHAVE,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.Filial, -- Cdigo da Filial
      TAB.Data, -- Data do Inventrio
      TAB.Descricao, -- DescricaoInventario
      TAB.PapelEstoque, -- Fixo Estoque
      TAB.CodigoProduto, -- Cdigo do Produto
      TAB.Quantidade, -- Quantidade em Estoque
      TAB.ValorUnitario, -- Valor unitrio do item em estoque
      TAB.CodigoAlmox, -- Cdigo do Almoxarifado
      TAB.Unidade, -- Cdigo da Unidade do Item no Documento
      TAB.CodigoCentroCusto -- Cdigo do Centro de Custo
     FROM (SELECT INT.*
             FROM (SELECT DFIL.CODFIL, 
                          CAST(TO_CHAR(LeParametroDat('DAT_INV_EST_EXP_EME4',DFIL.CODFIL,'','',''), 'DDMMYYYY') AS VARCHAR(10)) AS SEQUEN, -- Data do Inventrio
                          --CAST(TO_CHAR(TO_DATE('${PA_INV_DATEST}', 'DD/MM/YYYY'),'DDMMYYYY') AS VARCHAR(10)) AS SEQUEN, 
                          CAST('INV' AS VARCHAR(3)) AS ORIGEM, 
                          CAST('TIMU_PRODINVENT' AS VARCHAR(50)) AS DESTINO,
                          CAST('INV' || DFIL.CODFIL || TO_CHAR(LeParametroDat('DAT_INV_EST_EXP_EME4',DFIL.CODFIL,'','','') ,'DDMMYYYY') AS VARCHAR(50)) AS CHAVE,
                          CAST(Agora() AS Timestamp) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
                          CAST(TO_NUMBER(DFIL.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
                          LeParametroDat('DAT_INV_EST_EXP_EME4',DFIL.CODFIL,'','','') AS Data, -- Data do Inventrio
                          CAST(TO_CHAR(LeParametroDat('DAT_INV_EST_EXP_EME4',DFIL.CODFIL,'','',''), 'DD/MM/YYYY') AS VARCHAR(50)) AS Descricao, -- DescricaoInventario
                          --CAST(TO_DATE('${PA_INV_DATEST}', 'DD/MM/YYYY') AS Timestamp) AS Data, -- Data do Inventrio
                          --CAST(TO_CHAR(TO_DATE('${PA_INV_DATEST}', 'DD/MM/YYYY'),'DD/MM/YYYY') AS VARCHAR(50)) AS Descricao, -- DescricaoInventario
                          CAST('Estoque' AS VARCHAR(30)) AS PapelEstoque, -- Fixo Estoque
                          CAST(TRIM(SUBSTR(GRA.CODFIS,1,30)) AS VARCHAR(30)) AS CodigoProduto, -- Cdigo do Produto
                          CAST(TRUNC(COALESCE(CUSTOMEDIO(DFIL.CODFIL, GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, 1, LeParametroDat('DAT_INV_EST_EXP_EME4',DFIL.CODFIL,'','','')), 0), 3) AS Numeric(18,6)) AS Quantidade, -- Quantidade em Estoque
                          CAST(TRUNC(COALESCE(CUSTOMEDIO(DFIL.CODFIL, GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, 3, LeParametroDat('DAT_INV_EST_EXP_EME4',DFIL.CODFIL,'','','')), 0), 4) AS Numeric(18,6)) AS ValorUnitario, -- Valor unitrio do item em estoque
                          --CAST(TRUNC(COALESCE(CUSTOMEDIO(DFIL.CODFIL, GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, 1, TO_DATE('${PA_INV_DATEST}', 'DD/MM/YYYY')), 0), 3) AS Numeric(18,6)) AS Quantidade, -- Quantidade em Estoque
                          --CAST(TRUNC(COALESCE(CUSTOMEDIO(DFIL.CODFIL, GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, 3, TO_DATE('${PA_INV_DATEST}', 'DD/MM/YYYY')), 0), 4) AS Numeric(18,6)) AS ValorUnitario, -- Valor unitrio do item em estoque
                          CAST(0 AS Numeric(3)) AS CodigoAlmox, -- Cdigo do Almoxarifado
                          CAST(DMED.UNIMED AS VARCHAR(3)) AS Unidade, -- Cdigo da Unidade do Item no Documento
                          CAST(NULL AS VARCHAR(10)) AS CodigoCentroCusto -- Cdigo do Centro de Custo
             FROM TT_GRA GRA 
             -- Unidade de Medida
             JOIN TD_MED DMED ON DMED.CODTAB = COALESCE(GRA.UNIEMB, GRA.UNIDAD)
             -- Sub-Diviso
             JOIN TT_SUB SUB ON GRA.CODTAM = SUB.CODITE
             JOIN TD_SUB DSUB ON SUB.CODSUB = DSUB.CODTAB
             -- Filial
             --JOIN TD_FIL DFIL ON DFIL.CODFIL IN (${PA_INV_FILIAIS}) AND DFIL.FILATI = 'T'
             JOIN TD_FIL DFIL ON DFIL.CODFIL IN (LeParametroTxt('FILIAIS_INV_EXP_EME4', '', '', '', '')) AND DFIL.FILATI = 'T'
            WHERE GRA.CODTAM = COALESCE(DSUB.CODSAL, GRA.CODTAM) -- Traz apenas os produtos de Saldo
           ) INT
     WHERE INT.ValorUnitario > 0
     AND INT.Quantidade > 0
         ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Produtos" (Tabela Integrao Mult)
/*-- SEQ 2716 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_PRODUTO CASCADE;

/*-- SEQ 2717 --*/
CREATE OR REPLACE VIEW TV_TIMU_PRODUTO AS
   SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST('X' AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.FILMAT, TAB.CODMAT, TAB.CODCOR, TAB.CODTAM, TAB.ATU_EM, TAB.DATINC, TAB.CODEXT,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.CodigoGrupo, -- Grupo j dever estar cadastrado no M3
      TAB.CodigoItem, -- Cdigo do Produto
      TAB.Descricao, -- Descrio do Produto
      TAB.CodigoBarras, -- Cdigo de Barras do Produto
      TAB.UnidadePadrao, -- Unidade Padro do Produto
      TAB.TipoItem, -- A=Mercadoria para Revenda,B=Matria-Prima,C= Embalagem,D= Produto em Processo,E=Produto Acabado,F=Subproduto,G=Produto Intermedirio,H=Material de Uso e Consumo,I=Ativo Imobilizado,J=Servios,K=Outros insumos,L=Outras
      TAB.CodigoNCM, -- Cdigo NCM do Produto
      TAB.CodigoAlmoxarifadoPadrao, -- Cdigo do Almoxarifado Padro do Produto
      TAB.MarcaProduto, -- Nome da Marca do Produto 
      TAB.PesoBruto, -- Peso Bruto do Produto - Float 6 casas decimais
      TAB.PesoLiquido, -- Peso Lquido do Produto - Float 6 casas decimais 
      TAB.Volume, -- Volume do Produto - Float 6 casas decimais
      TAB.PrecoCusto, -- Preo de Custo - Float 6 casas de decimais
      TAB.CustoMedio, -- Custo Mdio - Float 6 casas decimais
      TAB.LocalizacaoPadrao, -- Localizao Padro do Produto
      TAB.UnidadeVenda, -- Unidade Padro de Venda do Produto
      TAB.FatorConversaoUnidVenda, -- Fator de converso para a unidade de vendas - Float 6 casas decimais
      TAB.UnidadeCompra, -- Unidade Padro de Compra do Produto
      TAB.FatorConversaoUnidCompra, --Fator de converso para a unidade de compras - Float 6 casas decimais
      TAB.FatorMultiploCompra, -- Fator Mltiplo na Compra - Float 6 casas decimais
      TAB.Origem, -- 0 - Nacional, 1 - Importado (Apenas para definir a Mscara do Produto)     
      TAB.Situacao, -- 1=Ativo,2=Inativo,3=Fora de Linha,4=Fora de Linha/Inativo,5=Bloqueado,
      TAB.Modelo, -- Modelo do Produto
      TAB.DataCadastro, -- Data de Cadastro do Produto
      TAB.DataAtualizacao, -- Data de ltima atualizao do cadastro do cliente
      TAB.UsuarioCadastro, -- Usurio do Cadastro
      TAB.Comprador, -- Nome do comprador do produto 
      TAB.CentroCusto,-- Centro de custos do produto
      TAB.TemContribuicaoPrev -- Tem Contribuio Previdenciria
      FROM (
   SELECT GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, GRA.ATU_EM, PRO.DATCAD AS DATINC, GRA.CODEXT,
          GRA.ATU_EM AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
          CAST(TRIM(TO_CHAR(PRO.DEPART)) AS VARCHAR(30)) AS CodigoGrupo, -- Grupo j dever estar cadastrado no M3
          CAST(TRIM(SUBSTR(GRA.CODFIS,1,30)) AS VARCHAR(30)) AS CodigoItem, -- Cdigo do Produto
          CAST(NomeProduto(PRO.DESECF, PRO.DESMAT, GRA.CODCOR, DIV.NOMITE, GRA.CODTAM, SUB.NOMITE, PRO.ESPMAT, GRA.DESGRA, DIV.NOMEXT, SUB.NOMEXT) AS VARCHAR(100)) AS Descricao, -- Descrio do Produto
          -- EME4 Solicitou a no exportar de dados na coluna
          --CAST(GRA.REFPRO AS VARCHAR(40)) AS CodigoBarras, -- Cdigo de Barras do Produto
          CAST(NULL AS VARCHAR(40)) AS CodigoBarras, -- Cdigo de Barras do Produto
          CAST(DMED_EST.UNIMED AS VARCHAR(6)) AS UnidadePadrao, -- Unidade Padro do Produto
          CAST(CASE WHEN PRO.CODFPS = '00' THEN 'A'
                    WHEN PRO.CODFPS = '01' THEN 'B'
                    WHEN PRO.CODFPS = '02' THEN 'C'
                    WHEN PRO.CODFPS = '03' THEN 'D'
                    WHEN PRO.CODFPS = '04' THEN 'E'
                    WHEN PRO.CODFPS = '05' THEN 'F'
                    WHEN PRO.CODFPS = '06' THEN 'G'
                    WHEN PRO.CODFPS = '07' THEN 'H'
                    WHEN PRO.CODFPS = '08' THEN 'I'
                    WHEN PRO.CODFPS = '09' THEN 'J'
                    WHEN PRO.CODFPS = '10' THEN 'K'
                    WHEN PRO.CODFPS = '99' THEN 'L'
                    ELSE 'L' 
               END AS VARCHAR(1)) AS TipoItem, -- A=Mercadoria para Revenda,B=Matria-Prima,C= Embalagem,D= Produto em Processo,E=Produto Acabado,F=Subproduto,G=Produto Intermedirio,H=Material de Uso e Consumo,I=Ativo Imobilizado,J=Servios,K=Outros insumos,L=Outras
          CAST(PRO.CODNCM AS VARCHAR(20)) AS CodigoNCM, -- Cdigo NCM do Produto
          CAST(NULL AS VARCHAR(10)) AS CodigoAlmoxarifadoPadrao, -- Cdigo do Almoxarifado Padro do Produto
          CAST(TRIM(MAR.DESMAR) AS VARCHAR(60)) AS MarcaProduto, -- Nome da Marca do Produto 
          CAST(GRA.PESBRU AS Numeric(15,6)) AS PesoBruto, -- Peso Bruto do Produto - Float 6 casas decimais
          CAST(GRA.PESLIQ AS Numeric(15,6)) AS PesoLiquido, -- Peso Lquido do Produto - Float 6 casas decimais 
          CAST(GRA.VOLUME AS Numeric(15,6)) AS Volume, -- Volume do Produto - Float 6 casas decimais
          CAST(GRA.CUSREP AS Numeric(15,6)) AS PrecoCusto, -- Preo de Custo - Float 6 casas de decimais
          /* Pedro E. Braga - Funo de Calculo do Custo Mdio traz muita lentido ao processo utilizado o ltimo custo mdio calculado na tabela de saldo */
          --CAST(COALESCE(CustoMedio(IDF.CODLOJ, GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, '3', ADD_DAY(Agora(), -1)), 0) AS Numeric(15,6)) AS CustoMedio, -- Custo Mdio - Float 6 casas decimais
          CAST((SELECT SAL.VLR_CM / NVLZ(SAL.QTD_CM, 1) 
                  FROM TT_SAL SAL 
                 WHERE SAL.CODFIL = IDF.CODLOJ
                   AND SAL.FILMAT = GRA.FILMAT
                   AND SAL.CODMAT = GRA.CODMAT
                   AND SAL.CODCOR = GRA.CODCOR
                   AND SAL.CODTAM = GRA.CODTAM
                   AND SAL.CODMUL = 0) AS Numeric(15,6)) AS CustoMedio, -- Custo Mdio - Float 6 casas decimais
          --CAST(NULL AS Numeric(15,6)) AS CustoMedio, -- Custo Mdio - Float 6 casas decimais
          CAST(GRA.LOCALI AS VARCHAR(20)) AS LocalizacaoPadrao, -- Localizao Padro do Produto
          CAST(DMED_VEN.UNIMED AS VARCHAR(6)) AS UnidadeVenda, -- Unidade Padro de Venda do Produto
          CAST(SUB.FATCON AS Numeric(15,6)) AS FatorConversaoUnidVenda, -- Fator de converso para a unidade de vendas - Float 6 casas decimais
          CAST(DMED_COM.UNIMED AS VARCHAR(15)) AS UnidadeCompra, -- Unidade Padro de Compra do Produto
          CAST(SUB.FATCON AS Numeric(15,6)) AS FatorConversaoUnidCompra, --Fator de converso para a unidade de compras - Float 6 casas decimais
          CAST(NULL AS Numeric(15,6)) AS FatorMultiploCompra, -- Fator Mltiplo na Compra - Float 6 casas decimais
          CAST(CASE WHEN PRO.ORIPRO IN ('1', '2', '6', '7') THEN '1'
                    ELSE '0'
               END AS VARCHAR(1)) AS Origem, -- 0 - Nacional, 1 - Importado (Apenas para definir a Mscara do Produto)
          CAST(CASE WHEN (LeParametroTXT('TIPO_EXP_EME4', '', '', '', '') = 'C') THEN '1'
                    WHEN ((PRO.SIGNAT < 0) OR (GRA.GRAATI = 'F')) AND (GRA.FORLIN = 'T') THEN '4'
                    WHEN ((PRO.SIGNAT < 0) OR (GRA.GRAATI = 'F')) THEN '2'
                    WHEN (PRO.SIGNAT >= 0) AND (GRA.GRAATI = 'T') AND (GRA.FORLIN = 'T') THEN '3'
                    WHEN (PRO.SIGNAT >= 0) AND (GRA.GRAATI = 'T') AND (GRA.FORLIN <> 'T') THEN '1'
                    ELSE '1' 
               END AS VARCHAR(1)) AS Situacao, -- 1=Ativo,2=Inativo,3=Fora de Linha,4=Fora de Linha/Inativo,5=Bloqueado,
          CAST(NULL AS VARCHAR(20)) As Modelo, -- Modelo do Produto
          TRUNC(PRO.DATCAD) As DataCadastro, -- Data de Cadastro do Produto
          TRUNC(GRA.ATU_EM) AS DataAtualizacao, -- Data de ltima atualizao do cadastro do cliente
          CAST(NULL AS VARCHAR(10)) AS UsuarioCadastro, -- Usurio do Cadastro
          CAST(NULL AS VARCHAR(40)) AS Comprador, -- Nome do comprador do produto 
          CAST(NULL AS VARCHAR(30)) AS CentroCusto,-- Centro de custos do produto
          CAST('F' AS VARCHAR(1)) AS TemContribuicaoPrev -- Tem Contribuio Previdenciria
      FROM TT_GRA GRA
    INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT
                         AND PRO.CODMAT = GRA.CODMAT
    INNER JOIN TT_DIV DIV ON GRA.CODCOR = DIV.CODITE
    INNER JOIN TD_DIV DDIV ON DIV.CODDIV = DDIV.CODTAB
    INNER JOIN TT_SUB SUB ON GRA.CODTAM = SUB.CODITE
    INNER JOIN TD_SUB DSUB ON SUB.CODSUB = DSUB.CODTAB
     --LEFT JOIN TT_GRA GRA_EST ON GRA_EST.FILMAT = GRA.FILMAT
     --                        AND GRA_EST.CODMAT = GRA.CODMAT
     --                        AND GRA_EST.CODCOR = GRA.CODCOR
     --                        AND GRA_EST.CODTAM = COALESCE(DSUB.CODSAL, GRA.CODTAM)
     LEFT JOIN TD_MED DMED_EST ON DMED_EST.CODTAB = COALESCE(GRA.UNIEMB, GRA.UNIDAD)--COALESCE(GRA_EST.UNIEMB, GRA_EST.UNIDAD)
     LEFT JOIN TD_MED DMED_VEN ON DMED_VEN.CODTAB = GRA.UNIDAD
     LEFT JOIN TD_MED DMED_COM ON DMED_COM.CODTAB = GRA.UNIFOR
     LEFT JOIN TT_MAR MAR ON PRO.ITEMAR = MAR.ITEMAR
                         AND PRO.FILMAR = MAR.FILMAR
                         AND PRO.CODMAR = MAR.CODMAR
    CROSS JOIN TT_IDF IDF
    WHERE GRA.CODTAM = COALESCE(DSUB.CODSAL, GRA.CODTAM) -- Traz apenas os produtos de Saldo
    ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Reduo Z" (Tabela Integrao Mult)
/*-- SEQ 2718 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_REDUCAOZ CASCADE;

/*-- SEQ 2719 --*/
CREATE OR REPLACE VIEW TV_TIMU_REDUCAOZ AS
   SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('T' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.NUMECF, TAB.CNT_RZ, TAB.CNT_RO, TAB.DATOPE, TAB.DATFEC, TAB.ATU_EM, TAB.DATINC, TAB.ORIGEM, TAB.DESTINO, TAB.CHAVE,
      TAB.EXPEM4, TAB.EXPORT,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.Filial, -- Cdigo da Filial
      TAB.NumeroECF, -- Nmero do ECF
      TAB.NumeroSerieECF, -- Nmero de Srie ECF
      TAB.ModeloECF, -- Modelo do ECF
      TAB.DataReducao, -- Data da Reduo
      TAB.DataMovimentacao, -- Data da Movimentao
      TAB.COOReducao, -- COO da Reduo Z
      TAB.TotalGeral, -- Total Geral
      TAB.TotalVendaBruta, -- Total Venda Bruta
      TAB.TotalVendaLiquida, -- Total Venda Lquida
      TAB.ContadorReinicioOperacao, -- Contador Reincio de Operao
      TAB.ContadorRedZ, -- Contador Redues Z
      TAB.ContadorCF, -- Contador Cupom Fiscal
      TAB.ContadorFitaDetalhe, -- Contador Fita Detalhe
      TAB.ContadorCompCredDeb, -- Contador Compr. Crdito/Dbito
      TAB.ContadorOpNFiscal, -- Contador Operao No Fiscal
      TAB.ContadorRelGerencial, -- Contador Relatrio Gerencial
      TAB.ContadorCancCF, -- Contador Cancelamento Cupom Fiscal
      TAB.ContadorCancOpNFiscal, -- Contador Cancelamento Operao No Fiscal
      TAB.TotalCancICMS, -- Total Cancelamento ICMS
      TAB.TotalDescICMS, -- Total Desconto ICMS
      TAB.TotalAcrescICMS, -- Total Acrscimo ICMS
      TAB.TotalSTICMS, -- Total Substituio Tributria ICMS
      TAB.TotalIsenteICMS, -- Total Isento ICMS
      TAB.TotalNaoIncideICMS, -- Total No Incidncia ICMS
      TAB.TotalTributadoICMS, -- Total Tributado ICMS
      TAB.TotalCancISS, -- Total Cancelamento ISS
      TAB.TotalDescISS, -- Total Desconto ISS
      TAB.TotalAcrescISS, -- Total Acrscimo ISS
      TAB.TotalSTISS, -- Total Substituio Tributria ISS
      TAB.TotalIsenteISS, -- Total Isento ISS
      TAB.TotalNaoIncideISS, -- Total No Incidncia ISS
      TAB.TotalTributadoISS, -- Total Tributado ISS
      TAB.TotalCancNFiscal, -- Total Cancelamento No Fiscal
      TAB.TotalDescNFiscal, -- Total Desconto No Fiscal
      TAB.TotalAcrescNFiscal, -- Total Acrscimo No Fiscal
      TAB.TotalNFiscal -- Total No Fiscal
      FROM (
   SELECT RECF.CODFIL, RECF.NUMECF, RECF.CNT_RZ, RECF.CNT_RO, RECF.DATOPE, RECF.DATFEC, RECF.ATU_EM, RECF.DATINC, CAST('RED' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_REDUCAOZ' AS VARCHAR(50)) AS DESTINO, 
          CAST('RED' || RECF.CODFIL || RECF.NUMECF || TO_CHAR(RECF.CNT_RZ) || TO_CHAR(RECF.CNT_RO) AS VARCHAR(50)) AS CHAVE,
          RECF.EXPEM4, RECF.EXPORT,
          CAST(RECF.DATINC AS Timestamp) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
          CAST(TO_NUMBER(RECF.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
          CAST(TO_NUMBER(DECF.CODORI) AS Numeric(9)) AS NumeroECF, -- Nmero do ECF
          CAST(TRIM(DECF.SERECF) AS VARCHAR(20)) AS NumeroSerieECF, -- Nmero de Srie ECF
          CAST(TRIM(DECF.MODECF) AS VARCHAR(20)) AS ModeloECF, -- Modelo do ECF
          CAST(TRUNC(RECF.DATFEC) AS Timestamp) AS DataReducao, -- Data da Reduo
          CAST(TRUNC(RECF.DATOPE) AS Timestamp) AS DataMovimentacao, -- Data da Movimentao
          CAST(RECF.CUPFIM AS Numeric(9)) AS COOReducao, -- COO da Reduo Z
          CAST(RECF.GT_FIM AS Numeric(15,2)) AS TotalGeral, -- Total Geral
          CAST((RECF.GT_FIM - RECF.GT_INI) AS Numeric(15,2)) AS TotalVendaBruta, -- Total Venda Bruta
          CAST((SELECT SUM(VEN.VLRLIQ)
                  FROM TT_VEN VEN
                 WHERE VEN.CODFIL = RECF.CODFIL AND VEN.NUMECF = RECF.NUMECF 
                   AND TO_NUMBER(REPLACE(VEN.NUMNOT,'#',' ')) BETWEEN RECF.CUPINI AND RECF.CUPFIM 
                   AND VEN.VLRLIQ > 0 AND VEN.CODSER = 'CF' 
                   AND VEN.FLGEST <> 'C' 
                 GROUP BY VEN.CODFIL, VEN.NUMECF) AS Numeric(15,2)) AS TotalVendaLiquida, -- Total Venda Lquida
          CAST(NVLZ(RECF.INTERV, DECF.INTERV) AS Numeric(9)) AS ContadorReinicioOperacao, -- Contador Reincio de Operao
          CAST(RECF.CNT_RZ AS Numeric(9)) AS ContadorRedZ, -- Contador Redues Z
          CAST(NULL AS Numeric(9)) AS ContadorCF, -- Contador Cupom Fiscal
          CAST(NULL AS Numeric(9)) AS ContadorFitaDetalhe, -- Contador Fita Detalhe
          CAST(NULL AS Numeric(9)) AS ContadorCompCredDeb, -- Contador Compr. Crdito/Dbito
          CAST(NULL AS Numeric(9)) AS ContadorOpNFiscal, -- Contador Operao No Fiscal
          CAST(NULL AS Numeric(9)) AS ContadorRelGerencial, -- Contador Relatrio Gerencial
          CAST(NULL AS Numeric(9)) AS ContadorCancCF, -- Contador Cancelamento Cupom Fiscal
          CAST(NULL AS Numeric(9)) AS ContadorCancOpNFiscal, -- Contador Cancelamento Operao No Fiscal
          CAST((SELECT SUM(ECF.VLRTOT) 
                  FROM TT_ECF ECF 
                 WHERE ECF.CODFIL = RECF.CODFIL AND ECF.NUMECF = RECF.NUMECF 
                   AND ECF.DATOPE = RECF.DATOPE AND ECF.CNT_RO = RECF.CNT_RO 
                   AND ECF.TIPTOT = 'O' AND ECF.TOTALI = 'CANC') AS Numeric(15,2)) AS TotalCancICMS, -- Total Cancelamento ICMS
          CAST((SELECT SUM(ECF.VLRTOT) 
                  FROM TT_ECF ECF 
                 WHERE ECF.CODFIL = RECF.CODFIL AND ECF.NUMECF = RECF.NUMECF 
                   AND ECF.DATOPE = RECF.DATOPE AND ECF.CNT_RO = RECF.CNT_RO 
                   AND ECF.TIPTOT = 'O' AND ECF.TOTALI = 'DESC') AS Numeric(15,2)) AS TotalDescICMS, -- Total Desconto ICMS
          CAST((SELECT SUM(ECF.VLRTOT) 
                  FROM TT_ECF ECF 
                 WHERE ECF.CODFIL = RECF.CODFIL AND ECF.NUMECF = RECF.NUMECF 
                   AND ECF.DATOPE = RECF.DATOPE AND ECF.CNT_RO = RECF.CNT_RO 
                   AND ECF.TIPTOT = 'O' AND ECF.TOTALI = 'ACRE') AS Numeric(15,2)) AS TotalAcrescICMS, -- Total Acrscimo ICMS
          CAST((SELECT SUM(ECF.VLRTOT) 
                  FROM TT_ECF ECF 
                 WHERE ECF.CODFIL = RECF.CODFIL AND ECF.NUMECF = RECF.NUMECF 
                   AND ECF.DATOPE = RECF.DATOPE AND ECF.CNT_RO = RECF.CNT_RO 
                   AND ECF.TIPTOT = 'O' AND ECF.TOTALI = 'SUBS') AS Numeric(15,2)) AS TotalSTICMS, -- Total Substituio Tributria ICMS
          CAST((SELECT SUM(ECF.VLRTOT) 
                  FROM TT_ECF ECF 
                 WHERE ECF.CODFIL = RECF.CODFIL AND ECF.NUMECF = RECF.NUMECF 
                   AND ECF.DATOPE = RECF.DATOPE AND ECF.CNT_RO = RECF.CNT_RO 
                   AND ECF.TIPTOT = 'O' AND ECF.TOTALI = 'ISEN') AS Numeric(15,2)) AS TotalIsenteICMS, -- Total Isento ICMS
          CAST((SELECT SUM(ECF.VLRTOT) 
                  FROM TT_ECF ECF 
                 WHERE ECF.CODFIL = RECF.CODFIL AND ECF.NUMECF = RECF.NUMECF 
                   AND ECF.DATOPE = RECF.DATOPE AND ECF.CNT_RO = RECF.CNT_RO 
                   AND ECF.TIPTOT = 'O' AND ECF.TOTALI = 'NAOT') AS Numeric(15,2)) AS TotalNaoIncideICMS, -- Total No Incidncia ICMS
          CAST((SELECT SUM(ECF.VLRTOT)
                  FROM TT_ECF ECF
                 WHERE ECF.CODFIL = RECF.CODFIL AND ECF.NUMECF = RECF.NUMECF 
                   AND ECF.DATOPE = RECF.DATOPE AND ECF.CNT_RO = RECF.CNT_RO 
                   AND ECF.TIPTOT = 'M' AND ECF.TOTALI NOT IN ('CANC', 'DESC', 'ACRE', 'SUBS', 'ISEN', 'NAOT')) AS Numeric(15,2)) AS TotalTributadoICMS, -- Total Tributado ICMS
          CAST(NULL AS Numeric(15,2)) AS TotalCancISS, -- Total Cancelamento ISS
          CAST(NULL AS Numeric(15,2)) AS TotalDescISS, -- Total Desconto ISS
          CAST(NULL AS Numeric(15,2)) AS TotalAcrescISS, -- Total Acrscimo ISS
          CAST(NULL AS Numeric(15,2)) AS TotalSTISS, -- Total Substituio Tributria ISS
          CAST(NULL AS Numeric(15,2)) AS TotalIsenteISS, -- Total Isento ISS
          CAST(NULL AS Numeric(15,2)) AS TotalNaoIncideISS, -- Total No Incidncia ISS
          CAST((SELECT SUM(ECF.VLRBAS)
                  FROM TT_ECF ECF 
                 WHERE ECF.CODFIL = RECF.CODFIL AND ECF.NUMECF = RECF.NUMECF 
                   AND ECF.DATOPE = RECF.DATOPE AND ECF.CNT_RO = RECF.CNT_RO 
                   AND ECF.TIPTOT = 'S' AND ECF.TOTALI NOT IN ('CANC', 'DESC', 'ACRE', 'SUBS', 'ISEN', 'NAOT')) AS Numeric(15,2)) AS TotalTributadoISS, -- Total Tributado ISS
          CAST(NULL AS Numeric(15,2)) AS TotalCancNFiscal, -- Total Cancelamento No Fiscal
          CAST(NULL AS Numeric(15,2)) AS TotalDescNFiscal, -- Total Desconto No Fiscal
          CAST(NULL AS Numeric(15,2)) AS TotalAcrescNFiscal, -- Total Acrscimo No Fiscal
          CAST(NULL AS Numeric(15,2)) AS TotalNFiscal -- Total No Fiscal
    FROM TR_ECF RECF
    JOIN TD_ECF DECF ON DECF.FILECF = RECF.CODFIL AND DECF.NUMECF = RECF.NUMECF
    WHERE RECF.DATFEC IS NOT NULL 
      AND RECF.DIAFEC IN ('F', 'S')
      AND ((RECF.EXPEM4 = 'F') OR (RECF.EXPORT = 'F'))
      AND RECF.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',RECF.CODFIL,'','','')
      ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Registro Produo" (Tabela Integrao Mult)
/*-- SEQ 2720 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_REGISTROPRODUCAO CASCADE;

/*-- SEQ 2721 --*/
CREATE OR REPLACE VIEW TV_TIMU_REGISTROPRODUCAO AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('T' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.DATINC, TAB.ATU_EM, TAB.CHAVE, TAB.EXPEM4, TAB.EXPORT,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.CNPJFilial, -- CNPJ da Filial
      -- Ordem de Produo 
      TAB.DataInicio, -- Data de incio da ordem de produo 
      TAB.DataConclusao, -- Data de concluso da ordem de produo
      TAB.CodigoOrdemProducao, -- Cdigo de identificao da ordem de produo 
      -- Produto Produzido 
      TAB.CodigoItemProduzido, -- Cdigo do item produzido 
      TAB.QuantidadeAcabada -- Float 6 casas decimais - Quantidade de produo acabada
      FROM (
   SELECT PPR.CODFIL, PPR.SEQUEN, PPR.DATINC, PPR.ATU_EM, CAST('PPR' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_REGISTROPRODUCAO' AS VARCHAR(50)) AS DESTINO,
          CAST('PPR' || PPR.CODFIL || PPR.SEQUEN AS VARCHAR(50)) AS CHAVE, PPR.EXPEM4, PPR.EXPORT,
          PPR.ATU_EM AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
          CAST(TRIM(DFIL.CGCFIL) AS VARCHAR(18)) AS CNPJFilial, -- CNPJ da Filial
          -- Ordem de Produo 
          TRUNC(PPR.DATINI) AS DataInicio, -- Data de incio da ordem de produo 
          TRUNC(PPR.DATFIM) AS DataConclusao, -- Data de concluso da ordem de produo
          CAST(PPR.CODFIL||LPAD(TRIM(PPR.SEQUEN),10,'0') AS VARCHAR(30)) AS CodigoOrdemProducao, -- Cdigo de identificao da ordem de produo 
          -- Produto Produzido 
          CAST(TRIM(GRA.CODFIS) AS VARCHAR(60)) AS CodigoItemProduzido, -- Cdigo do item produzido 
          CAST(PPR.QTDPRD AS Numeric(17,6)) AS QuantidadeAcabada -- Float 6 casas decimais - Quantidade de produo acabada
    FROM TT_PPR PPR
    JOIN TD_FIL DFIL ON DFIL.CODFIL = PPR.CODFIL 
    JOIN TT_GRA GRA ON GRA.FILMAT = PPR.FILMAT 
                   AND GRA.CODMAT = PPR.CODMAT 
                   AND GRA.CODCOR = PPR.CODCOR 
                   AND GRA.CODTAM = PPR.CODTAM 
   WHERE 1 = 1
     AND PPR.DATINC >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',PPR.CODFIL,'','','')
     AND ((PPR.EXPEM4 = 'F') OR (PPR.EXPORT = 'F'))
   ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Representantes" (Tabela Integrao Mult)
/*-- SEQ 2722 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_REPRESENTANTE CASCADE;

/*-- SEQ 2723 --*/
CREATE OR REPLACE VIEW TV_TIMU_REPRESENTANTE AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST('X' AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.FILCLI, TAB.CODCLI, TAB.ATU_EM, TAB.DATINC, TAB.CODEXT,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.CpfCnpj, -- CPF ou CNPJ do Representante
      TAB.Nome, -- Razo Social do Representante
      TAB.Codigo, -- Cdigo do Representante
      TAB.NomeFantasia, -- Nome Fantasia do Representante
      TAB.Pessoa, -- 1=Fsica, 2=Jurdica
      TAB.Endereco, -- Logradouro do Endereo
      TAB.CEP, -- CEP do Endereo do Representante
      TAB.CodMunicipioIBGE, -- GeoCodigo do M3 - caso esteja informado dever importar o vnculo do municpio por este cdigo (Endereo)
      TAB.Cidade, -- Cidade do Endereo do Representante 
      TAB.Bairro, -- Bairro do Endereo do Representante
      TAB.Estado, -- Estado do Endereo do Representante
      TAB.Pais, -- Nome do Pais do Endereo do Representante
      TAB.NumeroEnd, -- Nmero do Endereo do Representante
      TAB.CodigoPais, -- Codigo do Banco Central para o Pais
      TAB.ComplementoEnd, -- Complemento do Endereo do Representante
      TAB.Tipovendedor, -- I=INTERNO,E=EXTERNO,R=NORMAL
      TAB.CategoriaRepresentante, -- Cdigo da Categoria do Representante
      TAB.InscEstadual, -- Inscrio Estadual do Representante 
      TAB.InscMunicipal, -- Inscrio Municipal do Representante
      TAB.CodigoBanco, -- Cdigo do Banco do Representante
      TAB.CodigoAgencia, -- Cdigo da Agncia Bancria do Representante
      TAB.DigitoAgencia, -- Dgito da Agncia Bancria do Representante
      TAB.CodigoContaBancaria, -- Cdigo da Conta Bancria do Representante
      TAB.DigitoContaBancaria, -- Dgito da Conta Bancria do Representante
      TAB.DataCadastro, -- Data de Cadastro do Representante 
      TAB.DataAlteracao, -- Data de ltima atualizao do cadastro do Representnate
      TAB.Inativo, -- Situao do Representante - T/F
      TAB.RetemIRRF, -- T/F - Retm IRRF
      TAB.RetemISS, -- T/F - Retm ISS
      TAB.RetemINSS -- T/F - Retm INSS
     FROM (
   SELECT PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS ATU_EM, PAR.DATOPE AS DATINC, PAR.CODEXT,
          GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
          --CAST(TRIM(COALESCE(ENDE.NUMDOC, PAR.NUMDOC)) AS VARCHAR(18)) AS CpfCnpj, -- CPF ou CNPJ do Representante
          --CAST(TRIM(COALESCE(PAR.NUMDOC, VIN.NUMDOC)) AS VARCHAR(18)) AS CpfCnpj, -- CPF ou CNPJ do Representante
          CAST(TRIM(PAR.NUMDOC) AS VARCHAR(18)) AS CpfCnpj, -- CPF ou CNPJ do Representante
          CAST(TRIM(PAR.NOMCLI || ' ' || CASE WHEN (PAR.FLGTIP = '0') AND ((SELECT CFG.UNE_NOME_SOBRENOME FROM TT_CFG CFG)='F') THEN COALESCE(PAR.ULTNOM,'') ELSE '' END) AS VARCHAR(120)) AS Nome, -- Razo Social do Representante
          CAST(TO_NUMBER(CASE WHEN (ISNULL(PAR.NUMDOC)='T') AND (ISNULL(PAR.CODEXT)='T') THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                              ELSE SUBSTR(TO_CHAR(CAST(                                                       NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                          END) AS Numeric(9)) AS Codigo, -- Cdigo do Representante
          CAST(CASE WHEN (ISNULL(PAR.CODEXT)='F') THEN NULL ELSE TRIM(CASE WHEN PAR.FLGTIP = '0' THEN PAR.NOMTRA ELSE COALESCE(PAR.ULTNOM, PAR.NOMTRA) END) END AS VARCHAR(50)) AS NomeFantasia, -- Nome Fantasia do Representante
          CAST(CASE WHEN PAR.FLGTIP = '0' THEN '1'
                    ELSE '2'
               END AS VARCHAR(1)) AS Pessoa, -- 1=Fsica, 2=Jurdica
          CAST(TRIM(ENDE.ENDERE) AS VARCHAR(120)) AS Endereco, -- Logradouro do Endereo
          CAST(CASE WHEN DPAI.CODPAI = 1058 THEN LPAD(COALESCE(TRIM(ENDE.CODCEP), '0'), 5, '0')||LPAD(COALESCE(TRIM(ENDE.CODLOG), '0'), 3, '0') ELSE NULL END AS VARCHAR(10)) AS CEP, -- CEP do Endereo do Representante
          CAST(TRIM(ENDE.BAIRRO) AS VARCHAR(80)) AS Bairro, -- Bairro do Endereo do Representante
          CAST(CASE WHEN DPAI.CODPAI = 1058 THEN IBG.CODIBG ELSE NULL END AS Numeric(10)) AS CodMunicipioIBGE, -- GeoCodigo do M3 - caso esteja informado dever importar o vnculo do municpio por este cdigo (Endereo)
          -- A Pedido da EME4 no ser exportado os dados da Cidade/Estado/Pais
          CAST(TRIM(CASE WHEN DPAI.CODPAI = 1058 THEN NULL /*IBG.NOMMUN*/ ELSE ENDE.NOMCID END) AS VARCHAR(25)) AS Cidade, -- Cidade do Endereo do Representante
          CAST(TRIM(CASE WHEN DPAI.CODPAI = 1058 THEN NULL /*IBG.SIGEST*/ ELSE NULL END) AS VARCHAR(2)) AS Estado, -- Estado do Endereo do Representante
          CAST(DPAI.CODPAI AS Numeric(9)) AS CodigoPais, -- Codigo do Banco Central para o Pais
          CAST(TRIM(CASE WHEN DPAI.CODPAI = 1058 THEN NULL /*DPAI.DESPAI*/ ELSE DPAI.DESPAI END) AS VARCHAR(80)) AS Pais, -- Nome do Pais do Endereo do Representante
          CAST(SUBSTR(TO_CHAR(CAST(                                   NULLIF(regexp_replace(ENDE.NUMERO, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 10) AS Numeric(10)) AS NumeroEnd, -- Nmero do Endereo do Representante
          CAST(TRIM(ENDE.COMPLE) AS VARCHAR(30)) AS ComplementoEnd, -- Complemento do Endereo do Representante
          CAST('R' AS VARCHAR(1)) AS Tipovendedor, -- I=INTERNO,E=EXTERNO,R=NORMAL
          CAST(NULL AS VARCHAR(20)) AS CategoriaRepresentante, -- Cdigo da Categoria do Representante
          CAST(TRIM(COALESCE(ENDE.INSEST, PAR.INSEST)) AS VARCHAR(20)) AS InscEstadual, -- Inscrio Estadual do Representante 
          CAST(ENDE.INSMUN AS VARCHAR(10)) AS InscMunicipal, -- Inscrio Municipal do Representante
          CAST(CBP.CODBCO AS Numeric(8)) AS CodigoBanco, -- Cdigo do Banco do Representante
          CAST(CBP.NUMAGE AS Numeric(2)) AS CodigoAgencia, -- Cdigo da Agncia Bancria do Representante
          CAST(CBP.DIGAGE AS Numeric(1)) AS DigitoAgencia, -- Dgito da Agncia Bancria do Representante
          CAST(CBP.CTACRR AS Numeric(8)) AS CodigoContaBancaria, -- Cdigo da Conta Bancria do Representante
          CAST(CBP.DIGCRR AS Numeric(1)) AS DigitoContaBancaria, -- Dgito da Conta Bancria do Representante
          CAST(CASE WHEN COALESCE(CBP.TIPCON, 'X') NOT IN ('C','P') THEN NULL
                    ELSE CBP.TIPCON
               END AS VARCHAR(1)) AS TipoConta, -- C = Conta Corrente / P = Poupana
          PAR.DATOPE AS DataCadastro, -- Data de Cadastro do Representante 
          GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataAlteracao, -- Data de ltima atualizao do cadastro do Representnate
          CAST(CASE WHEN (LeParametroTXT('TIPO_EXP_EME4', '', '', '', '') = 'C') OR (PAR.SIGNAT >= 0) THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situao do Representante - T/F
          CAST('F' AS VARCHAR(1)) AS RetemIRRF, -- T/F - Retm IRRF
          CAST('F' AS VARCHAR(1)) AS RetemISS, -- T/F - Retm ISS
          CAST('F' AS VARCHAR(1)) AS RetemINSS -- T/F - Retm INSS
     FROM TT_CLI PAR
     LEFT JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
     LEFT JOIN TT_MUN MUN ON MUN.CODIGO = ENDE.CODCID
     LEFT JOIN TT_IBG IBG ON IBG.CODIBG = COALESCE(ENDE.CODIBG, MUN.CODIBG)
     LEFT JOIN TD_PAI DPAI ON DPAI.CODPAI = ENDE.CODPAI
     LEFT JOIN TT_SPC SPC ON SPC.FILCLI = PAR.FILCLI AND SPC.CODCLI = PAR.CODCLI
     -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
     --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
     -- Conta Bancria
     LEFT JOIN TT_CBP CBP ON CBP.FILCLI = PAR.FILCLI AND CBP.CODCLI = PAR.CODCLI
                         AND (CBP.CODFIL, CBP.SEQUEN) IN 
                             (SELECT CTB.CODFIL, CTB.SEQUEN
                                FROM TT_CBP CTB
                               WHERE CTB.FILCLI = CBP.FILCLI AND CTB.CODCLI = CBP.CODCLI
                                                               LIMIT 1  )
    WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
      AND (PAR.CODCLI <> LPAD('0', 6, ' '))
      AND ( -- Vendedor
            EXISTS(SELECT 1 AS OK FROM TT_USU USU WHERE USU.FILCLI = PAR.FILCLI AND USU.CODCLI = PAR.CODCLI)
           OR
            -- Representante
            EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = PAR.FILCLI AND REL.CODPAR = PAR.CODCLI AND REL.TIPPAR = 'R')
          )
      AND COALESCE(PAR.INDEXP, 'E') <> 'N'
    UNION ALL
   SELECT 
         PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS ATU_EM, PAR.DATOPE AS DATINC, CAST(NULL AS VARCHAR(20)) AS CODEXT,
         GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
         CAST(TRIM(ENDE.NUMDOC) AS VARCHAR(18)) AS CpfCnpj, -- CPF ou CNPJ do Representante
         CAST(TRIM(PAR.NOMCLI || ' ' || CASE WHEN (PAR.FLGTIP = '0') AND ((SELECT CFG.UNE_NOME_SOBRENOME FROM TT_CFG CFG)='F') THEN COALESCE(PAR.ULTNOM,'') ELSE '' END) AS VARCHAR(120)) AS Nome, -- Razo Social do Representante
         CAST(NULL AS Numeric(9)) AS Codigo, -- Cdigo do Representante
         CAST(CASE WHEN (ISNULL(PAR.CODEXT)='F') THEN NULL ELSE TRIM(CASE WHEN PAR.FLGTIP = '0' THEN PAR.NOMTRA ELSE COALESCE(PAR.ULTNOM, PAR.NOMTRA) END) END AS VARCHAR(50)) AS NomeFantasia, -- Nome Fantasia do Representante
         CAST(CASE WHEN PAR.FLGTIP = '0' THEN '1'
                   ELSE '2'
              END AS VARCHAR(1)) AS Pessoa, -- 1=Fsica; 2=Jurdica
         CAST(TRIM(ENDE.ENDERE) AS VARCHAR(120)) AS Endereco, -- Logradouro do Endereo
         CAST(CASE WHEN DPAI.CODPAI = 1058 THEN LPAD(COALESCE(TRIM(ENDE.CODCEP), '0'), 5, '0')||LPAD(COALESCE(TRIM(ENDE.CODLOG), '0'), 3, '0') ELSE NULL END AS VARCHAR(10)) AS CEP, -- CEP do Endereo do Representante
         CAST(TRIM(ENDE.BAIRRO) AS VARCHAR(80)) AS Bairro, -- Bairro do Endereo do Representante
         CAST(CASE WHEN DPAI.CODPAI = 1058 THEN IBG.CODIBG ELSE NULL END AS Numeric(10)) AS CodMunicipioIBGE, -- GeoCodigo do M3 - caso esteja informado dever importar o vnculo do municpio por este cdigo (Endereo)
         -- A Pedido da EME4 no ser exportado os dados da Cidade/Estado/Pais
         CAST(TRIM(CASE WHEN DPAI.CODPAI = 1058 THEN NULL /*IBG.NOMMUN*/ ELSE ENDE.NOMCID END) AS VARCHAR(25)) AS Cidade, -- Cidade do Endereo do Representante
         CAST(TRIM(CASE WHEN DPAI.CODPAI = 1058 THEN NULL /*IBG.SIGEST*/ ELSE NULL END) AS VARCHAR(2)) AS Estado, -- Estado do Endereo do Representante
         CAST(DPAI.CODPAI AS Numeric(9)) AS CodigoPais, -- Codigo do Banco Central para o Pais
         CAST(TRIM(CASE WHEN DPAI.CODPAI = 1058 THEN NULL /*DPAI.DESPAI*/ ELSE DPAI.DESPAI END) AS VARCHAR(80)) AS Pais, -- Nome do Pais do Endereo do Representante
         CAST(SUBSTR(TO_CHAR(CAST(                                  NULLIF(regexp_replace(ENDE.NUMERO, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 10) AS Numeric(10)) AS NumeroEnd, -- Nmero do Endereo do Representante
         CAST(TRIM(ENDE.COMPLE) AS VARCHAR(30)) AS ComplementoEnd, -- Complemento do Endereo do Representante
         CAST('R' AS VARCHAR(1)) AS Tipovendedor, -- I=INTERNO;E=EXTERNO;R=NORMAL
         CAST(NULL AS VARCHAR(20)) AS CategoriaRepresentante, -- Cdigo da Categoria do Representante
         CAST(TRIM(COALESCE(ENDE.INSEST, PAR.INSEST)) AS VARCHAR(20)) AS InscEstadual, -- Inscrio Estadual do Representante 
         CAST(ENDE.INSMUN AS VARCHAR(10)) AS InscMunicipal, -- Inscrio Municipal do Representante
         CAST(CBP.CODBCO AS Numeric(8)) AS CodigoBanco, -- Cdigo do Banco do Representante
         CAST(CBP.NUMAGE AS Numeric(2)) AS CodigoAgencia, -- Cdigo da Agncia Bancria do Representante
         CAST(CBP.DIGAGE AS Numeric(1)) AS DigitoAgencia, -- Dgito da Agncia Bancria do Representante
         CAST(CBP.CTACRR AS Numeric(8)) AS CodigoContaBancaria, -- Cdigo da Conta Bancria do Representante
         CAST(CBP.DIGCRR AS Numeric(1)) AS DigitoContaBancaria, -- Dgito da Conta Bancria do Representante
         CAST(CASE WHEN COALESCE(CBP.TIPCON, 'X') NOT IN ('C','P') THEN NULL
                   ELSE CBP.TIPCON
              END AS VARCHAR(1)) AS TipoConta, -- C = Conta Corrente / P = Poupana
         PAR.DATOPE AS DataCadastro, -- Data de Cadastro do Representante 
         GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataAlteracao, -- Data de ltima atualizao do cadastro do Representnate
         CAST(CASE WHEN PAR.SIGNAT>=0 THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situao do Representante - T/F
         CAST('F' AS VARCHAR(1)) AS RetemIRRF, -- T/F - Retm IRRF
         CAST('F' AS VARCHAR(1)) AS RetemISS, -- T/F - Retm ISS
         CAST('F' AS VARCHAR(1)) AS RetemINSS -- T/F - Retm INSS
     FROM TT_CLI PAR
     JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ISNOTNULL(ENDE.NUMDOC) = 'T' AND TRIM(COALESCE(ENDE.NUMDOC, '')) <> TRIM(COALESCE(PAR.NUMDOC, ''))
     LEFT JOIN TT_MUN MUN ON MUN.CODIGO = ENDE.CODCID
     LEFT JOIN TT_IBG IBG ON IBG.CODIBG = COALESCE(ENDE.CODIBG, MUN.CODIBG)
     LEFT JOIN TD_PAI DPAI ON DPAI.CODPAI = ENDE.CODPAI
     LEFT JOIN TT_SPC SPC ON SPC.FILCLI = PAR.FILCLI AND SPC.CODCLI = PAR.CODCLI
     -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
     --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
     -- Conta Bancria
     LEFT JOIN TT_CBP CBP ON CBP.FILCLI = PAR.FILCLI AND CBP.CODCLI = PAR.CODCLI
                         AND (CBP.CODFIL, CBP.SEQUEN) IN 
                             (SELECT CTB.CODFIL, CTB.SEQUEN
                                FROM TT_CBP CTB
                               WHERE CTB.FILCLI = CBP.FILCLI AND CTB.CODCLI = CBP.CODCLI
                                                               LIMIT 1  )
    WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
      AND (PAR.CODCLI <> LPAD('0', 6, ' '))
      AND ( -- Vendedor
            EXISTS(SELECT 1 AS OK FROM TT_USU USU WHERE USU.FILCLI = PAR.FILCLI AND USU.CODCLI = PAR.CODCLI)
           OR
            -- Representante
            EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = PAR.FILCLI AND REL.CODPAR = PAR.CODCLI AND REL.TIPPAR = 'R')
          )
      AND COALESCE(PAR.INDEXP, 'E') <> 'N'
          ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4 
-- Finalidade(s):
-- 1) Gerar Tabela de Integração de "Telefones Adicionais" (Tabela Integração Mult)
/*-- SEQ 2724 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_TELEFONE CASCADE;

/*-- SEQ 2725 --*/
CREATE OR REPLACE VIEW TV_TIMU_TELEFONE AS
SELECT --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST('X' AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Inclusão/Alteração Automática para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importação / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrição da inconsistência
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importação / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrição da inconsistência
      TAB.FILCLI, TAB.CODCLI, TAB.ATU_EM, TAB.DATINC,
      TAB.DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)      
      TAB.CodigoCliente, -- Código do Cliente
      TAB.CodigoFornecedor, -- Código do Fornecedor
      TAB.CodigoRepresentante, -- Código do Representante
      TAB.CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
      TAB.TipoTelefone, -- 0=Comercial,1=Residencial,2=Fax,3=Celular,4=Pager,5=Cobrança,6=Vendas Interno,7=Nextel
      TAB.Telefone -- Número do Telefone da Identificação
      FROM (
   SELECT PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS ATU_EM, PAR.DATOPE AS DATINC,
          GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
          CAST(NULL AS Numeric(9)) AS CodigoCliente, -- Código do Cliente
          CAST(NULL AS Numeric(9)) AS CodigoFornecedor, -- Código do Fornecedor
          CAST(NULL AS Numeric(9)) AS CodigoRepresentante, -- Código do Representante
          --CAST(TRIM(COALESCE(PAR.NUMDOC, VIN.NUMDOC)) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(TRIM(PAR.NUMDOC) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(CASE WHEN COALESCE(SUBSTR(TRIM(ENDE.NUMFON), 1, 1), '0') IN ('1', '2', '3', '4', '5') THEN 1
                    WHEN COALESCE(SUBSTR(TRIM(ENDE.NUMFON), 1, 1), '0') IN ('6', '7', '8', '9') THEN 3
                    ELSE CASE WHEN PAR.FLGTIP = 0 THEN 1 ELSE 0 END
               END AS Numeric(1)) AS TipoTelefone, -- 0=Comercial,1=Residencial,2=Fax,3=Celular,4=Pager,5=Cobrança,6=Vendas Interno,7=Nextel
          CAST(CASE WHEN PAR.SIGNAT>=0 THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situação do Cliente T/F
          CAST(CASE WHEN ISNULL(ENDE.CODDDD)='T' THEN '' ELSE '(' || COALESCE(ENDE.CODDDD,'') || ') ' END ||TRIM(ENDE.NUMFON) AS VARCHAR(20)) AS Telefone -- Número do Telefone da Identificação
     FROM TT_CLI PAR
     JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
     -- Parceiro Vinculado - Só buscar o vínculo se a pessoa não for física
     --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
      AND ISNOTNULL(ENDE.NUMFON) = 'T'
      AND COALESCE(PAR.INDEXP, 'E') <> 'N'
    UNION ALL
   SELECT 
          PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS ATU_EM, PAR.DATOPE AS DATINC,
          GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
          CAST(NULL AS Numeric(9)) AS CodigoCliente, -- Código do Cliente
          CAST(NULL AS Numeric(9)) AS CodigoFornecedor, -- Código do Fornecedor
          CAST(NULL AS Numeric(9)) AS CodigoRepresentante, -- Código do Representante
          --CAST(TRIM(COALESCE(PAR.NUMDOC, VIN.NUMDOC)) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(TRIM(PAR.NUMDOC) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(2 AS Numeric(1)) AS TipoTelefone, -- 0=Comercial,1=Residencial,2=Fax,3=Celular,4=Pager,5=Cobrança,6=Vendas Interno,7=Nextel
          CAST(CASE WHEN PAR.SIGNAT>=0 THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situação do Cliente T/F
          CAST(CASE WHEN ISNULL(ENDE.DDDFAX)='T' THEN '' ELSE '(' || COALESCE(ENDE.DDDFAX,'') || ') ' END ||TRIM(ENDE.NUMFAX) AS VARCHAR(20)) AS Telefone -- Número do Telefone da Identificação
     FROM TT_CLI PAR
     JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
     -- Parceiro Vinculado - Só buscar o vínculo se a pessoa não for física
     --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
      AND ISNOTNULL(ENDE.NUMFAX) = 'T'
      AND COALESCE(PAR.INDEXP, 'E') <> 'N'
    UNION ALL
   SELECT 
          PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS ATU_EM, PAR.DATOPE AS DATINC,
          GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
          CAST(NULL AS Numeric(9)) AS CodigoCliente, -- Código do Cliente
          CAST(NULL AS Numeric(9)) AS CodigoFornecedor, -- Código do Fornecedor
          CAST(NULL AS Numeric(9)) AS CodigoRepresentante, -- Código do Representante
          --CAST(TRIM(COALESCE(PAR.NUMDOC, VIN.NUMDOC)) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(TRIM(PAR.NUMDOC) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(3 AS Numeric(1)) AS TipoTelefone, -- 0=Comercial,1=Residencial,2=Fax,3=Celular,4=Pager,5=Cobrança,6=Vendas Interno,7=Nextel
          CAST(CASE WHEN PAR.SIGNAT>=0 THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situação do Cliente T/F
          CAST(CASE WHEN ISNULL(SPC.DDDCEL)='T' THEN '' ELSE '(' || COALESCE(SPC.DDDCEL,'') || ') ' END ||TRIM(SPC.NUMCEL) AS VARCHAR(20)) AS Telefone -- Número do Telefone da Identificação
     FROM TT_CLI PAR
     JOIN TT_SPC SPC ON SPC.FILCLI = PAR.FILCLI AND SPC.CODCLI = PAR.CODCLI
     -- Parceiro Vinculado - Só buscar o vínculo se a pessoa não for física
     --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
      AND ISNOTNULL(SPC.NUMCEL) = 'T'
      AND COALESCE(PAR.INDEXP, 'E') <> 'N'
    UNION ALL
   SELECT 
          PAR.FILCLI, PAR.CODCLI, GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS ATU_EM, PAR.DATOPE AS DATINC,
          GREATEST(PAR.ATU_EM, PAR.ULTCOM) AS DataHoraAtuReg, -- Data e Hora da última atualização do registro (pode ser atualizado por trigger)
          CAST(NULL AS Numeric(9)) AS CodigoCliente, -- Código do Cliente
          CAST(NULL AS Numeric(9)) AS CodigoFornecedor, -- Código do Fornecedor
          CAST(NULL AS Numeric(9)) AS CodigoRepresentante, -- Código do Representante
          --CAST(TRIM(COALESCE(PAR.NUMDOC, VIN.NUMDOC)) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(TRIM(PAR.NUMDOC) AS VARCHAR(18)) AS CpfCnpjIdentificacao, -- CPF ou CNPJ - Enviar o número completo, seja com ou sem caracteres especiais
          CAST(3 AS Numeric(1)) AS TipoTelefone, -- 0=Comercial,1=Residencial,2=Fax,3=Celular,4=Pager,5=Cobrança,6=Vendas Interno,7=Nextel
          CAST(CASE WHEN PAR.SIGNAT>=0 THEN 'F' ELSE 'T' END AS VARCHAR(1)) AS Inativo, -- Situação do Cliente T/F
          CAST(CASE WHEN ISNULL(PAR.DDCCON)='T' THEN '' ELSE '(' || COALESCE(PAR.DDCCON,'') || ') ' END ||TRIM(PAR.CELCON) AS VARCHAR(20)) AS Telefone -- Número do Telefone da Identificação
     FROM TT_CLI PAR
     -- Parceiro Vinculado - Só buscar o vínculo se a pessoa não for física
     --LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
    WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
      AND ISNOTNULL(PAR.CELCON) = 'T'
      AND COALESCE(PAR.INDEXP, 'E') <> 'N'
      ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Totalizadores ICMS Reduo Z" (Tabela Integrao Mult)
/*-- SEQ 2726 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_TOTICMSRDZ CASCADE;

/*-- SEQ 2727 --*/
CREATE OR REPLACE VIEW TV_TIMU_TOTICMSRDZ AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.NUMECF, TAB.CNT_RZ, TAB.CNT_RO, TAB.DATOPE, TAB.DATFEC, TAB.TOTALI, TAB.DATINC, TAB.ATU_EM, TAB.ORIGEM, TAB.DESTINO, TAB.CHAVE,
      TAB.EXPEM4, TAB.EXPORT,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.Filial, -- Cdigo da Filial
      TAB.NumeroECF, -- Nmero do ECF
      TAB.NumeroSerieECF, -- Nmero de Srie ECF
      TAB.COOReducao, -- COO da Reduo Z
      TAB.DataMovimentacao, -- Data da Movimentao
      TAB.Aliquota, -- Alquota ICMS
      TAB.PercReducao, -- Perc. Reduo ICMS
      TAB.BaseCalculo, -- Base Clculo ICMS
      TAB.TotalImposto, -- Total Imposto ICMS
      TAB.Indice -- ndice ICMS
      FROM (
   SELECT ECF.CODFIL, ECF.NUMECF, ECF.DATOPE, RECF.DATFEC, ECF.TOTALI, ECF.CNT_RZ, ECF.CNT_RO, RECF.DATINC, RECF.ATU_EM, CAST('RIC' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_TOTICMSRDZ' AS VARCHAR(50)) AS DESTINO, 
          CAST('RED' || RECF.CODFIL || RECF.NUMECF || TO_CHAR(RECF.CNT_RZ) || TO_CHAR(RECF.CNT_RO) AS VARCHAR(50)) AS CHAVE,
          RECF.EXPEM4, RECF.EXPORT,
          CAST(RECF.DATINC AS Timestamp) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
          CAST(TO_NUMBER(RECF.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
          CAST(TO_NUMBER(DECF.CODORI) AS Numeric(9)) AS NumeroECF, -- Nmero do ECF
          CAST(TRIM(DECF.SERECF) AS VARCHAR(20)) AS NumeroSerieECF, -- Nmero de Srie ECF
          CAST(RECF.CUPFIM AS Numeric(9)) AS COOReducao, -- COO da Reduo Z
          CAST(TRUNC(RECF.DATOPE) AS Timestamp) AS DataMovimentacao, -- Data da Movimentao
          CAST((TO_NUMBER(ECF.TOTALI)/100) AS Numeric(15,2)) AS Aliquota, -- Alquota ICMS
          CAST(NULL AS Numeric(15,2)) AS PercReducao, -- Perc. Reduo ICMS
          CAST(ECF.VLRBAS AS Numeric(15,2)) AS BaseCalculo, -- Base Clculo ICMS
          CAST(ECF.VLRTOT AS Numeric(15,2)) AS TotalImposto, -- Total Imposto ICMS
          CAST(ECF.ORDALI AS Numeric(9)) AS Indice -- ndice ICMS
    FROM TT_ECF ECF
    JOIN TR_ECF RECF ON RECF.CODFIL = ECF.CODFIL AND RECF.NUMECF = ECF.NUMECF
                    AND RECF.DATOPE = ECF.DATOPE AND RECF.CNT_RO = ECF.CNT_RO
    JOIN TD_ECF DECF ON DECF.FILECF = ECF.CODFIL AND DECF.NUMECF = ECF.NUMECF
    WHERE RECF.DATFEC IS NOT NULL 
      AND RECF.DIAFEC IN ('F', 'S')
      AND ((RECF.EXPEM4 = 'F') OR (RECF.EXPORT = 'F'))
      AND ECF.TIPTOT = 'M' AND ECF.TOTALI NOT IN ('CANC', 'DESC', 'ACRE', 'SUBS', 'ISEN', 'NAOT')
      AND RECF.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',RECF.CODFIL,'','','')
      ) TAB 
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Totalizadores ISS Reduo Z" (Tabela Integrao Mult)
/*-- SEQ 2728 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_TOTISSRDZ CASCADE;

/*-- SEQ 2729 --*/
CREATE OR REPLACE VIEW TV_TIMU_TOTISSRDZ AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.NUMECF, TAB.CNT_RZ, TAB.CNT_RO, TAB.DATOPE, TAB.DATFEC, TAB.TOTALI, TAB.DATINC, TAB.ATU_EM, TAB.ORIGEM, TAB.DESTINO, TAB.CHAVE,
      TAB.EXPEM4, TAB.EXPORT,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.Filial, -- Cdigo da Filial
      TAB.NumeroECF, -- Nmero do ECF
      TAB.NumeroSerieECF, -- Nmero de Srie ECF
      TAB.COOReducao, -- COO da Reduo Z
      TAB.DataMovimentacao, -- Data da Movimentao
      TAB.Aliquota, -- Alquota ISS
      TAB.PercReducao, -- Perc. Reduo ISS
      TAB.BaseCalculo, -- Base Clculo ISS
      TAB.TotalImposto, -- Total Imposto ISS
      TAB.Indice -- ndice ISS
      FROM (
SELECT ECF.CODFIL, ECF.NUMECF, ECF.DATOPE, RECF.DATFEC, ECF.TOTALI, ECF.CNT_RZ, ECF.CNT_RO, RECF.DATINC, RECF.ATU_EM, CAST('RIS' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_TOTISSRDZ' AS VARCHAR(50)) AS DESTINO, 
       CAST('RED' || RECF.CODFIL || RECF.NUMECF || TO_CHAR(RECF.CNT_RZ) || TO_CHAR(RECF.CNT_RO) AS VARCHAR(50)) AS CHAVE,
       RECF.EXPEM4, RECF.EXPORT,
       CAST(RECF.DATINC AS Timestamp) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
       CAST(TO_NUMBER(RECF.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
       CAST(TO_NUMBER(DECF.CODORI) AS Numeric(9)) AS NumeroECF, -- Nmero do ECF
       CAST(TRIM(DECF.SERECF) AS VARCHAR(20)) AS NumeroSerieECF, -- Nmero de Srie ECF
       CAST(RECF.CUPFIM AS Numeric(9)) AS COOReducao, -- COO da Reduo Z
       CAST(TRUNC(RECF.DATOPE) AS Timestamp) AS DataMovimentacao, -- Data da Movimentao
       CAST((TO_NUMBER(ECF.TOTALI)/100) AS Numeric(15,2)) AS Aliquota, -- Alquota ISS
       CAST(NULL AS Numeric(15,2)) AS PercReducao, -- Perc. Reduo ISS
       CAST(ECF.VLRBAS AS Numeric(15,2)) AS BaseCalculo, -- Base Clculo ISS
       CAST(ECF.VLRTOT AS Numeric(15,2)) AS TotalImposto, -- Total Imposto ISS
       CAST(ECF.ORDALI AS Numeric(9)) AS Indice -- ndice ISS
    FROM TT_ECF ECF
    JOIN TR_ECF RECF ON RECF.CODFIL = ECF.CODFIL AND RECF.NUMECF = ECF.NUMECF
                    AND RECF.DATOPE = ECF.DATOPE AND RECF.CNT_RO = ECF.CNT_RO
    JOIN TD_ECF DECF ON DECF.FILECF = ECF.CODFIL AND DECF.NUMECF = ECF.NUMECF
    WHERE RECF.DATFEC IS NOT NULL 
      AND RECF.DIAFEC IN ('F', 'S')
      AND ((RECF.EXPEM4 = 'F') OR (RECF.EXPORT = 'F'))
      AND ECF.TIPTOT = 'S' AND ECF.TOTALI NOT IN ('CANC', 'DESC', 'ACRE', 'SUBS', 'ISEN', 'NAOT')
      AND RECF.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',RECF.CODFIL,'','','')
      ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Totalizadores Itens Movimento Dirio Reduo Z" (Tabela Integrao Mult)
/*-- SEQ 2730 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_TOTITENSRDZ CASCADE;

/*-- SEQ 2731 --*/
CREATE OR REPLACE VIEW TV_TIMU_TOTITENSRDZ AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.NUMECF, TAB.CNT_RZ, TAB.CNT_RO, TAB.DATOPE, TAB.DATFEC, TAB.DATINC, TAB.ATU_EM, TAB.ORIGEM, TAB.DESTINO, TAB.CHAVE,
      TAB.EXPEM4, TAB.EXPORT,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.Filial, -- Cdigo da Filial
      TAB.NumeroECF, -- Nmero do ECF
      TAB.NumeroSerieECF, -- Nmero de Srie ECF
      TAB.COOReducao, -- COO da Reduo Z
      TAB.DataMovimentacao, -- Data da Movimentao
      TAB.CodigoItem, -- Cdigo do Item
      TAB.DescricaoItem, -- Descrio do Item
      TAB.TipoItem, -- Tipo do Item {P=Produto,S=Servio,}
      TAB.Unidade, -- Unidade
      TAB.QdadeAcumulada, -- Quantidade Acumulada
      TAB.ValorAcumulado, -- Valor Acumulado
      TAB.CodTotalizador, -- Cdigo Totalizador
      TAB.ClassTributCOFINS, -- Classificao Tributria COFINS {A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes}
      TAB.ValBaseCalcCOFINS, -- Base Clculo COFINS
      TAB.AliqCOFINS, -- Alquota COFINS
      TAB.ValorCOFINS, -- Valor COFINS
      TAB.ClassTributPIS, -- Classificao Tributria PIS {A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes}
      TAB.ValBaseCalcPIS, -- Base Clculo PIS
      TAB.AliqPIS, -- Alquota PIS
      TAB.ValorPIS, -- Valor PIS
      TAB.ValBaseCalcICMS, -- Base Clculo ICMS
      TAB.AliqICMS, -- Alquota ICMS
      TAB.ValorICMS, -- Valor ICMS
      TAB.CFOP, -- Cdigo Fiscal Operao (0.000)
      TAB.TipoTributacao, -- Tipo de Tributao {0=Tributado,1=Isento,2=Subst. Tributria,3=No Incidente}
      TAB.SituacaoItem -- Situao do Item {0=Normal,1=Cancelado}
      FROM (
   SELECT T_1.CODFIL, T_1.NUMECF, T_1.CNT_RZ, T_1.CNT_RO, T_1.DATOPE, T_1.DATFEC, T_1.ATU_EM, T_1.DATINC, CAST('RIT' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_TOTITENSRDZ' AS VARCHAR(50)) AS DESTINO, 
          CAST('RED' || T_1.CODFIL || T_1.NUMECF || TO_CHAR(T_1.CNT_RZ) || TO_CHAR(T_1.CNT_RO) AS VARCHAR(50)) AS CHAVE,
          T_1.EXPEM4, T_1.EXPORT,
          CAST(T_1.DATINC AS Timestamp) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
          CAST(TO_NUMBER(T_1.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
          CAST(TO_NUMBER(T_1.CODORI) AS Numeric(9)) AS NumeroECF, -- Nmero do ECF
          CAST(TRIM(T_1.SERECF) AS VARCHAR(20)) AS NumeroSerieECF, -- Nmero de Srie ECF
          CAST(T_1.CUPFIM AS Numeric(9)) AS COOReducao, -- COO da Reduo Z
          CAST(TRUNC(T_1.DATOPE) AS Timestamp) AS DataMovimentacao, -- Data da Movimentao
          CAST(TRIM(SUBSTR(GRA.CODFIS,1,30)) AS VARCHAR(60)) AS CodigoItem, -- Cdigo do Item
          CAST(NomeProduto(PRO.DESECF, PRO.DESMAT, GRA.CODCOR, DIV.NOMITE, GRA.CODTAM, SUB.NOMITE, PRO.ESPMAT, GRA.DESGRA, DIV.NOMEXT, SUB.NOMEXT) AS VARCHAR(100)) AS DescricaoItem, -- Descrio do Item
          CAST(CASE WHEN PRO.CODFPS = '09' THEN 'S'
                    ELSE 'P' 
               END AS VARCHAR(1)) AS TipoItem, -- Tipo do Item {P=Produto,S=Servio,}
          CAST(DMED_VEN.UNIMED AS VARCHAR(10)) AS Unidade, -- Unidade
          CAST(ABS(T_1.QTDMOV) AS Numeric(15,2)) AS QdadeAcumulada, -- Quantidade Acumulada
          CAST(ABS(T_1.VLRMOV) AS Numeric(15,2)) AS ValorAcumulado, -- Valor Acumulado
          CAST(CASE WHEN T_1.SITMOV='C' AND PRO.CODFPS <> '09' THEN 'Can-T'
                    WHEN T_1.SITMOV='C' AND PRO.CODFPS = '09' THEN 'Can-S'
                    ELSE CASE WHEN T_1.ICMTIP='2' AND PRO.CODFPS <> '09' THEN 'N1'
                              WHEN T_1.ICMTIP='3' AND PRO.CODFPS <> '09' THEN 'F1'
                              WHEN T_1.ICMTIP IN ('1', '4') AND PRO.CODFPS <> '09' THEN 'I1'
                              WHEN T_1.ICMTIP='2' AND PRO.CODFPS = '09' THEN 'NS1'
                              WHEN T_1.ICMTIP='3' AND PRO.CODFPS = '09' THEN 'FS1'
                              WHEN T_1.ICMTIP IN ('1', '4') AND PRO.CODFPS = '09' THEN 'IS1'
                              WHEN PRO.CODFPS = '09' THEN ( SELECT MAX(ECF.TOTPAR)
                                                              FROM TT_ECF ECF
                                                             WHERE ECF.CODFIL = T_1.CODFIL AND ECF.NUMECF = T_1.NUMECF 
                                                               AND ECF.DATOPE = T_1.DATOPE AND ECF.CNT_RO = T_1.CNT_RO 
                                                               AND ECF.TIPTOT = 'S' AND ECF.TOTALI = LPAD(TO_CHAR((NVLZ(T_1.TAXISS, T_1.TAX002)*100)), 4, '0') )
                              ELSE (SELECT MAX(ECF.TOTPAR)
                                      FROM TT_ECF ECF
                                     WHERE ECF.CODFIL = T_1.CODFIL AND ECF.NUMECF = T_1.NUMECF 
                                       AND ECF.DATOPE = T_1.DATOPE AND ECF.CNT_RO = T_1.CNT_RO 
                                       AND ECF.TIPTOT = 'M' AND ECF.TOTALI = LPAD(TO_CHAR((NVLZ(T_1.TAXICM, T_1.TAX001)*100)), 4, '0') )
                        END
               END AS VARCHAR(10)) AS CodTotalizador, -- Cdigo Totalizador
          CAST(CASE T_1.SITCOF WHEN '01' THEN 'A'
                               WHEN '02' THEN 'B'
                               WHEN '03' THEN 'C'
                               WHEN '04' THEN 'D'
                               WHEN '06' THEN 'E'
                               WHEN '07' THEN 'F'
                               WHEN '08' THEN 'G'
                               WHEN '09' THEN 'H'
                               WHEN '05' THEN 'I'
                               WHEN '49' THEN 'J'
                               WHEN '50' THEN 'K'
                               WHEN '51' THEN 'L'
                               WHEN '52' THEN 'M'
                               WHEN '53' THEN 'N'
                               WHEN '54' THEN 'O'
                               WHEN '55' THEN 'P'
                               WHEN '56' THEN 'Q'
                               WHEN '60' THEN 'R'
                               WHEN '61' THEN 'S'
                               WHEN '62' THEN 'T'
                               WHEN '63' THEN 'U'
                               WHEN '64' THEN 'V'
                               WHEN '65' THEN 'W'
                               WHEN '66' THEN 'X'
                               WHEN '67' THEN '1'
                               WHEN '70' THEN '2'
                               WHEN '71' THEN '3'
                               WHEN '72' THEN '4'
                               WHEN '73' THEN '5'
                               WHEN '74' THEN '6'
                               WHEN '75' THEN '7'
                               WHEN '98' THEN 'Y'
                               WHEN '99' THEN 'Z'
                               ELSE 'Z'
                END AS VARCHAR(1)) AS ClassTributCOFINS, -- Classificao Tributria COFINS {A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes}
          CAST(T_1.BASCOF AS Numeric(15,4)) AS ValBaseCalcCOFINS, -- Base Clculo COFINS
          CAST(T_1.PERCOF AS Numeric(15,4)) AS AliqCOFINS, -- Alquota COFINS
          CAST(T_1.VLRCOF AS Numeric(15,2)) AS ValorCOFINS, -- Valor COFINS
          CAST(CASE T_1.SITPIS WHEN '01' THEN 'A'
                               WHEN '02' THEN 'B'
                               WHEN '03' THEN 'C'
                               WHEN '04' THEN 'D'
                               WHEN '06' THEN 'E'
                               WHEN '07' THEN 'F'
                               WHEN '08' THEN 'G'
                               WHEN '09' THEN 'H'
                               WHEN '05' THEN 'I'
                               WHEN '49' THEN 'J'
                               WHEN '50' THEN 'K'
                               WHEN '51' THEN 'L'
                               WHEN '52' THEN 'M'
                               WHEN '53' THEN 'N'
                               WHEN '54' THEN 'O'
                               WHEN '55' THEN 'P'
                               WHEN '56' THEN 'Q'
                               WHEN '60' THEN 'R'
                               WHEN '61' THEN 'S'
                               WHEN '62' THEN 'T'
                               WHEN '63' THEN 'U'
                               WHEN '64' THEN 'V'
                               WHEN '65' THEN 'W'
                               WHEN '66' THEN 'X'
                               WHEN '67' THEN '1'
                               WHEN '70' THEN '2'
                               WHEN '71' THEN '3'
                               WHEN '72' THEN '4'
                               WHEN '73' THEN '5'
                               WHEN '74' THEN '6'
                               WHEN '75' THEN '7'
                               WHEN '98' THEN 'Y'
                               WHEN '99' THEN 'Z'
                               ELSE 'Z'
                END AS VARCHAR(1)) AS ClassTributPIS, -- Classificao Tributria PIS {A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes}
          CAST(T_1.BASPIS AS Numeric(15,4)) AS ValBaseCalcPIS, -- Base Clculo PIS
          CAST(T_1.PERPIS AS Numeric(15,4)) AS AliqPIS, -- Alquota PIS
          CAST(T_1.VLRPIS AS Numeric(15,2)) AS ValorPIS, -- Valor PIS
          CAST(T_1.BASICM AS Numeric(15,4)) AS ValBaseCalcICMS, -- Base Clculo ICMS
          CAST(NVLZ(T_1.TAXICM, T_1.TAX001) AS Numeric(15,4)) AS AliqICMS, -- Alquota ICMS
          CAST(T_1.VLRICM AS Numeric(15,4)) AS ValorICMS, -- Valor ICMS
          CAST(CASE WHEN ISNOTNULL(T_1.NATFIS)='T' THEN SUBSTR(T_1.NATFIS, 1, 1) || '.' || SUBSTR(T_1.NATFIS, 2, 3)
                    ELSE NULL
               END AS VARCHAR(20)) AS CFOP, -- Cdigo Fiscal Operao (0.000)
          CAST(CASE WHEN T_1.ICMTIP='2' THEN '1'
                    WHEN T_1.ICMTIP='3' THEN '2'
                    WHEN T_1.ICMTIP IN ('1', '4') THEN '3'
                    ELSE '0'
               END AS VARCHAR(1)) AS TipoTributacao, -- Tipo de Tributao {0=Tributado,1=Isento,2=Subst. Tributria,3=No Incidente}
          CAST(CASE WHEN T_1.SITMOV='C' THEN '1'
                    ELSE '0'
               END AS VARCHAR(1)) AS SituacaoItem -- Situao do Item {0=Normal,1=Cancelado}
    FROM ( SELECT RECF.CODFIL, RECF.NUMECF, RECF.CNT_RZ, RECF.CNT_RO, RECF.DATOPE, RECF.DATFEC, RECF.DATINC, RECF.ATU_EM, RECF.CUPINI, RECF.CUPFIM, DECF.SERECF, DECF.CODORI, RECF.EXPEM4, RECF.EXPORT,
                  IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM, /*IVE.EMBORI,*/ IVE.SITMOV,
                  IVE.SITPIS, IVE.SITCOF, IVE.NATFIS, IVE.ICMTIP, IVE.PERPIS, IVE.PERCOF, IVE.TAXICM, IVE.TAX001, IVE.TAXISS, IVE.TAX002,
                  SUM(IVE.QTDMOV/*COALESCE(IVE.EMBQTD, IVE.QTDMOV)*/) AS QTDMOV, SUM(IVE.VLRMOV) AS VLRMOV, SUM(ABS(COALESCE(IVE.BASICM, 0))) AS BASICM, SUM(ABS(COALESCE(IVE.VLRICM, 0))) AS VLRICM,
                  SUM(ABS(COALESCE(IVE.BASPIS, 0))) AS BASPIS, SUM(ABS(COALESCE(IVE.VLRPIS, 0))) AS VLRPIS,
                  SUM(ABS(COALESCE(IVE.BASCOF, 0))) AS BASCOF, SUM(ABS(COALESCE(IVE.VLRCOF, 0))) AS VLRCOF
             FROM TR_ECF RECF
             JOIN TD_ECF DECF ON DECF.FILECF = RECF.CODFIL AND DECF.NUMECF = RECF.NUMECF
             JOIN TT_VEN VEN ON VEN.CODFIL = RECF.CODFIL AND VEN.CODSER = 'CF' 
                            AND VEN.NUMNOT BETWEEN LPAD(TO_CHAR(RECF.CUPINI), 6, ' ') AND LPAD(TO_CHAR(RECF.CUPFIM), 6, ' ')
                            AND VEN.NUMECF = RECF.NUMECF AND VEN.CNT_RO = RECF.CNT_RO
             JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN
            WHERE RECF.DATFEC IS NOT NULL 
              AND RECF.DIAFEC IN ('F', 'S')
              AND ((RECF.EXPEM4 = 'F') OR (RECF.EXPORT = 'F'))
              AND VEN.NUMNOT NOT LIKE '%#%'
              --AND VEN.FLGEST <> 'C' AND IVE.SITMOV <> 'C'
            GROUP BY RECF.CODFIL, RECF.NUMECF, RECF.CNT_RZ, RECF.CNT_RO, RECF.DATOPE, RECF.DATFEC, RECF.DATINC, RECF.ATU_EM, RECF.CUPINI, RECF.CUPFIM, DECF.SERECF, DECF.CODORI, RECF.EXPEM4, RECF.EXPORT,
                  IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM, /*IVE.EMBORI,*/ IVE.SITMOV,
                  IVE.SITPIS, IVE.SITCOF, IVE.NATFIS, IVE.ICMTIP, IVE.PERPIS, IVE.PERCOF, IVE.TAXICM, IVE.TAX001, IVE.TAXISS, IVE.TAX002
    ) T_1
    -- Produto
    JOIN TT_GRA GRA ON GRA.FILMAT = T_1.FILMAT AND GRA.CODMAT = T_1.CODMAT AND GRA.CODCOR = T_1.CODCOR AND GRA.CODTAM = T_1.CODTAM /*COALESCE(T_1.EMBORI, T_1.CODTAM)*/
    JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
    JOIN TT_DIV DIV ON DIV.CODITE = GRA.CODCOR
    JOIN TD_DIV DDIV ON DDIV.CODTAB = DIV.CODDIV
    JOIN TT_SUB SUB ON SUB.CODITE = GRA.CODTAM
    JOIN TD_SUB DSUB ON DSUB.CODTAB = SUB.CODSUB
    LEFT JOIN TD_MED DMED_VEN ON DMED_VEN.CODTAB = GRA.UNIDAD
    WHERE T_1.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',T_1.CODFIL,'','','')
    ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Totalizadores No Fiscais Reduo Z" (Tabela Integrao Mult)
/*-- SEQ 2732 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_TOTNAOFISCALRDZ CASCADE;

/*-- SEQ 2733 --*/
CREATE OR REPLACE VIEW TV_TIMU_TOTNAOFISCALRDZ AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.NUMECF, TAB.CNT_RZ, TAB.CNT_RO, TAB.DATOPE, TAB.DATFEC, TAB.DATINC, TAB.ATU_EM, TAB.ORIGEM, TAB.DESTINO, TAB.CHAVE,
      TAB.EXPEM4, TAB.EXPORT,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.Filial, -- Cdigo da Filial
      TAB.NumeroECF, -- Nmero do ECF
      TAB.NumeroSerieECF, -- Nmero de Srie ECF
      TAB.COOReducao, -- COO da Reduo Z
      TAB.DataMovimentacao, -- Data da Movimentao
      TAB.Descricao, -- Descrio No Fiscal
      TAB.Valor, -- Valor No Fiscal
      TAB.Indice -- ndice No Fiscal
      FROM (
   SELECT T_1.CODFIL, T_1.NUMECF, T_1.CNT_RZ, T_1.CNT_RO, T_1.DATOPE, T_1.DATFEC, T_1.ATU_EM, T_1.DATINC, CAST('RNF' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_TOTNAOFISCALRDZ' AS VARCHAR(50)) AS DESTINO, 
          CAST('RED' || T_1.CODFIL || T_1.NUMECF || TO_CHAR(T_1.CNT_RZ) || TO_CHAR(T_1.CNT_RO) AS VARCHAR(50)) AS CHAVE,
          T_1.EXPEM4, T_1.EXPORT,
          CAST(T_1.DATINC AS Timestamp) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
          CAST(TO_NUMBER(T_1.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
          CAST(TO_NUMBER(DECF.CODORI) AS Numeric(9)) AS NumeroECF, -- Nmero do ECF
          CAST(TRIM(DECF.SERECF) AS VARCHAR(20)) AS NumeroSerieECF, -- Nmero de Srie ECF
          CAST(T_1.CUPFIM AS Numeric(9)) AS COOReducao, -- COO da Reduo Z
          CAST(TRUNC(T_1.DATOPE) AS Timestamp) AS DataMovimentacao, -- Data da Movimentao
          --CAST(DescricaoDominio('LID', 'TIPOPE', T_1.TIPOPE) AS VARCHAR(20)) AS Descricao, -- Descrio No Fiscal
          CAST(T_1.TIPOPE AS VARCHAR(20)) AS Descricao, -- Descrio No Fiscal
          CAST(T_1.VLROPE AS Numeric(15,2)) AS Valor, -- Valor No Fiscal
          /* No  gravado o Indice do Totalizador No Fiscal */
          CAST(NULL AS Numeric(9)) AS Indice -- ndice No Fiscal
    FROM (SELECT RECF.CODFIL, RECF.NUMECF, RECF.CNT_RZ, RECF.CNT_RO, RECF.DATOPE, RECF.DATFEC, RECF.DATINC, RECF.ATU_EM, RECF.CUPINI, RECF.CUPFIM, RECF.EXPEM4, RECF.EXPORT,
                 LID.TIPDOC, LID.TIPOPE,
                 ABS(SUM(LID.VLROPE)) AS VLROPE
            FROM TR_ECF RECF
            JOIN TT_LID LID ON LID.CODFIL = RECF.CODFIL AND LID.NUMECF = RECF.NUMECF 
                           AND LID.TIPDOC = 'CN' AND LID.CONCOO BETWEEN RECF.CUPINI AND RECF.CUPFIM
                           AND COALESCE(LID.CONGNF,0) > 0 AND LID.VLROPE <> 0
           WHERE RECF.DATFEC IS NOT NULL 
             AND RECF.DIAFEC IN ('F', 'S')
             AND ((RECF.EXPEM4 = 'F') OR (RECF.EXPORT = 'F'))
           GROUP BY RECF.CODFIL, RECF.NUMECF, RECF.CNT_RZ, RECF.CNT_RO, RECF.DATOPE, RECF.DATFEC, RECF.DATINC, RECF.ATU_EM, RECF.CUPINI, RECF.CUPFIM, RECF.EXPEM4, RECF.EXPORT,
                    LID.TIPDOC, LID.TIPOPE
         ) T_1
    JOIN TD_ECF DECF ON DECF.FILECF = T_1.CODFIL AND DECF.NUMECF = T_1.NUMECF
   WHERE T_1.VLROPE <> 0
     AND T_1.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',T_1.CODFIL,'','','')
   ) TAB
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Totalizadores PIS/COFINS  Reduo Z" (Tabela Integrao Mult)
/*-- SEQ 2734 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_TOTPISCOFINSRDZ CASCADE;

/*-- SEQ 2735 --*/
CREATE OR REPLACE VIEW TV_TIMU_TOTPISCOFINSRDZ AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.NUMECF, TAB.CNT_RZ, TAB.CNT_RO, TAB.DATOPE, TAB.DATFEC, TAB.DATINC, TAB.ATU_EM, TAB.ORIGEM, TAB.DESTINO, TAB.CHAVE,
      TAB.EXPEM4, TAB.EXPORT,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.Filial, -- Cdigo da Filial
      TAB.NumeroECF, -- Nmero do ECF
      TAB.NumeroSerieECF, -- Nmero de Srie ECF
      TAB.COOReducao, -- COO da Reduo Z
      TAB.DataMovimentacao, -- Data da Movimentao
      TAB.Aliquota, -- Alquota ICMS
      TAB.BaseCalculo, -- Base Clculo ICMS
      TAB.TotalImposto, -- Total Imposto ICMS
      TAB.TipoImposto, -- Tipo Imposto PIS/COFINS {1=PIS,2=COFINS,}
      TAB.ClassifTrib, -- Classificao Tributria PIS/COFINS {A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes}
      TAB.CFOP, -- Cdigo Fiscal Operao (0.000)
      TAB.TipoTributacao -- Tipo de Tributao {1=Tributado,2=Isento,3=Outros,4=Subs. Trib.,}
      FROM (
   SELECT T_1.CODFIL, T_1.NUMECF, T_1.CNT_RZ, T_1.CNT_RO, T_1.DATOPE, T_1.DATFEC, T_1.ATU_EM, T_1.DATINC, CAST('RPC' AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_TOTPISCOFINSRDZ' AS VARCHAR(50)) AS DESTINO, 
          CAST('RED' || T_1.CODFIL || T_1.NUMECF || TO_CHAR(T_1.CNT_RZ) || TO_CHAR(T_1.CNT_RO) AS VARCHAR(50)) AS CHAVE,
          T_1.EXPEM4, T_1.EXPORT,
          CAST(T_1.DATINC AS Timestamp) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
          CAST(TO_NUMBER(T_1.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
          CAST(TO_NUMBER(T_1.CODORI) AS Numeric(9)) AS NumeroECF, -- Nmero do ECF
          CAST(TRIM(T_1.SERECF) AS VARCHAR(20)) AS NumeroSerieECF, -- Nmero de Srie ECF
          CAST(T_1.CUPFIM AS Numeric(9)) AS COOReducao, -- COO da Reduo Z
          CAST(TRUNC(T_1.DATOPE) AS Timestamp) AS DataMovimentacao, -- Data da Movimentao
          CAST(T_1.PERIMP AS Numeric(15,2)) AS Aliquota, -- Alquota PIS/COFINS
          CAST(T_1.VLRBAS AS Numeric(15,2)) AS BaseCalculo, -- Base Clculo PIS/COFINS
          CAST(T_1.VLRTOT AS Numeric(15,2)) AS TotalImposto, -- Total Imposto PIS/COFINS
          CAST(T_1.TIPO AS VARCHAR(1)) AS TipoImposto, -- Tipo Imposto PIS/COFINS {1=PIS,2=COFINS,}
          CAST(CASE T_1.SITIMP WHEN '01' THEN 'A'
                               WHEN '02' THEN 'B'
                               WHEN '03' THEN 'C'
                               WHEN '04' THEN 'D'
                               WHEN '06' THEN 'E'
                               WHEN '07' THEN 'F'
                               WHEN '08' THEN 'G'
                               WHEN '09' THEN 'H'
                               WHEN '05' THEN 'I'
                               WHEN '49' THEN 'J'
                               WHEN '50' THEN 'K'
                               WHEN '51' THEN 'L'
                               WHEN '52' THEN 'M'
                               WHEN '53' THEN 'N'
                               WHEN '54' THEN 'O'
                               WHEN '55' THEN 'P'
                               WHEN '56' THEN 'Q'
                               WHEN '60' THEN 'R'
                               WHEN '61' THEN 'S'
                               WHEN '62' THEN 'T'
                               WHEN '63' THEN 'U'
                               WHEN '64' THEN 'V'
                               WHEN '65' THEN 'W'
                               WHEN '66' THEN 'X'
                               WHEN '67' THEN '1'
                               WHEN '70' THEN '2'
                               WHEN '71' THEN '3'
                               WHEN '72' THEN '4'
                               WHEN '73' THEN '5'
                               WHEN '74' THEN '6'
                               WHEN '75' THEN '7'
                               WHEN '98' THEN 'Y'
                               WHEN '99' THEN 'Z'
                               ELSE 'Z'
                END AS VARCHAR(1)) AS ClassifTrib, -- Classificao Tributria PIS/COFINS {A=01 - Operao Tributvel c/Alquota Bsica,B=02 - Operao Tributvel c/Alquota Diferenciada,C=03 - Operao Tributvel c/Alquota por Unidade de Medida de Produto,D=04 - Operao Tributvel Monofsica - Revenda a Alquota Zero,I=05 - Operao Tributvel por Substituio Tributria,E=06 - Operao Tributvel a Alquota Zero,F=07 - Operao Isenta da Contribuio,G=08 - Operao s/Incidncia da Contribuio,H=09 - Operao c/Suspenso da Contribuio,J=49 - Outras Operaes de Sada,K=50 - Operao c/Direito a Crdito-Vinc. Excl. a Receita Trib. no Merc. Int.,L=51 - Operao c/Direito a Crdito-Vinc. Excl. a Receita No-Trib. no Merc. Int.,M=52 - Operao c/Direito a Crdito-Vinc. Excl. a Receita de Export.,N=53 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,O=54 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. no Merc. Int. e de Export.,P=55 - Operao c/Direito a Crdito-Vinc. a Receitas No Trib. no Merc. Int. e de Export.,Q=56 - Operao c/Direito a Crdito-Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,R=60 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita Trib. no Merc. Int.,S=61 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita No-Trib. no Merc. Int.,T=62 - Crdito Presumido-Operao de Aquis. Vinc. Excl. a Receita de Export.,U=63 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int.,V=64 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. no Merc. Int. e de Export.,W=65 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas No-Trib. no Merc. Int. e de Export.,X=66 - Crdito Presumido-Operao de Aquis. Vinc. a Receitas Trib. e No-Trib. no Merc. Int. e de Export.,1=67 - Crdito Presumido-Outras Operaes,2=70 - Operao de Aquisio s/Direito a Crdito,3=71 - Operao de Aquisio c/Iseno,4=72 - Operao de Aquisio c/Suspenso,5=73 - Operao de Aquisio a Alquota Zero,6=74 - Operao de Aquisio s/Incidncia da Contribuio,7=75 - Operao de Aquisio por Substituio Tributria,Y=98 - Outras Operaes de Entrada,Z=99 - Outras Operaes}
          CAST(CASE WHEN ISNOTNULL(T_1.NATFIS)='T' THEN SUBSTR(T_1.NATFIS, 1, 1) || '.' || SUBSTR(T_1.NATFIS, 2, 3)
                    ELSE NULL
               END AS VARCHAR(20)) AS CFOP, -- Cdigo Fiscal Operao (0.000)
          CAST(CASE WHEN T_1.ICMTIP='1' THEN '3'
                    WHEN T_1.ICMTIP IN ('2', '4') THEN '2'
                    WHEN T_1.ICMTIP='3' THEN '4'
                    ELSE '1'
               END AS VARCHAR(1)) AS TipoTributacao -- Tipo de Tributao {1=Tributado,2=Isento,3=Outros,4=Subs. Trib.,}
    FROM ( SELECT RECF.CODFIL, RECF.NUMECF, RECF.CNT_RZ, RECF.CNT_RO, RECF.DATOPE, RECF.DATFEC, RECF.DATINC, RECF.ATU_EM, RECF.CUPINI, RECF.CUPFIM, DECF.SERECF, DECF.CODORI, RECF.EXPEM4, RECF.EXPORT,
                  IVE.SITPIS AS SITIMP, IVE.NATFIS, IVE.ICMTIP, IVE.PERPIS AS PERIMP, CAST('1' AS VARCHAR(1)) AS TIPO,
                  SUM(ABS(COALESCE(IVE.BASPIS, 0))) AS VLRBAS, SUM(ABS(COALESCE(IVE.VLRPIS, 0))) AS VLRTOT
             FROM TR_ECF RECF
             JOIN TD_ECF DECF ON DECF.FILECF = RECF.CODFIL AND DECF.NUMECF = RECF.NUMECF
             JOIN TT_VEN VEN ON VEN.CODFIL = RECF.CODFIL AND VEN.CODSER = 'CF' 
                            AND VEN.NUMNOT BETWEEN LPAD(TO_CHAR(RECF.CUPINI), 6, ' ') AND LPAD(TO_CHAR(RECF.CUPFIM), 6, ' ')
                            AND VEN.NUMECF = RECF.NUMECF AND VEN.CNT_RO = RECF.CNT_RO
             JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN
            WHERE RECF.DATFEC IS NOT NULL 
              AND RECF.DIAFEC IN ('F', 'S')
              AND ((RECF.EXPEM4 = 'F') OR (RECF.EXPORT = 'F'))
              AND VEN.NUMNOT NOT LIKE '%#%'
              AND VEN.FLGEST <> 'C' AND IVE.SITMOV <> 'C' AND COALESCE(IVE.VLRPIS, 0) <> 0
            GROUP BY RECF.CODFIL, RECF.NUMECF, RECF.CNT_RZ, RECF.CNT_RO, RECF.DATOPE, RECF.DATFEC, RECF.DATINC, RECF.ATU_EM, RECF.CUPINI, RECF.CUPFIM, DECF.SERECF, DECF.CODORI, RECF.EXPEM4, RECF.EXPORT,
                     IVE.SITPIS, IVE.NATFIS, IVE.ICMTIP, IVE.PERPIS, CAST('1' AS VARCHAR(1))
            UNION ALL
           SELECT RECF.CODFIL, RECF.NUMECF, RECF.CNT_RZ, RECF.CNT_RO, RECF.DATOPE, RECF.DATFEC, RECF.DATINC, RECF.ATU_EM, RECF.CUPINI, RECF.CUPFIM, DECF.SERECF, DECF.CODORI, RECF.EXPEM4, RECF.EXPORT,
                  IVE.SITCOF AS SITIMP, IVE.NATFIS, IVE.ICMTIP, IVE.PERCOF AS PERIMP, CAST('2' AS VARCHAR(1)) AS TIPO,
                  SUM(ABS(COALESCE(IVE.BASCOF, 0))) AS VLRBAS, SUM(ABS(COALESCE(IVE.VLRCOF, 0))) AS VLRTOT
             FROM TR_ECF RECF
             JOIN TD_ECF DECF ON DECF.FILECF = RECF.CODFIL AND DECF.NUMECF = RECF.NUMECF
             JOIN TT_VEN VEN ON VEN.CODFIL = RECF.CODFIL AND VEN.CODSER = 'CF' 
                            AND VEN.NUMNOT BETWEEN LPAD(TO_CHAR(RECF.CUPINI), 6, ' ') AND LPAD(TO_CHAR(RECF.CUPFIM), 6, ' ')
                            AND VEN.NUMECF = RECF.NUMECF AND VEN.CNT_RO = RECF.CNT_RO
             JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN
            WHERE RECF.DATFEC IS NOT NULL 
              AND RECF.DIAFEC IN ('F', 'S')
              AND ((RECF.EXPEM4 = 'F') OR (RECF.EXPORT = 'F'))
              AND VEN.NUMNOT NOT LIKE '%#%'
              AND VEN.FLGEST <> 'C' AND IVE.SITMOV <> 'C' AND COALESCE(IVE.VLRCOF, 0) <> 0
            GROUP BY RECF.CODFIL, RECF.NUMECF, RECF.CNT_RZ, RECF.CNT_RO, RECF.DATOPE, RECF.DATFEC, RECF.DATINC, RECF.ATU_EM, RECF.CUPINI, RECF.CUPFIM, DECF.SERECF, DECF.CODORI, RECF.EXPEM4, RECF.EXPORT,
                     IVE.SITCOF, IVE.NATFIS, IVE.ICMTIP, IVE.PERCOF, CAST('2' AS VARCHAR(1)) ) T_1
                     ) TAB
   WHERE TAB.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',TAB.CODFIL,'','','')
;


/*-- SEQ 2736 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Aux_TV_ECT_USO (TT_ECT.CODFIL%TYPE,TT_ECT.SEQUEN%TYPE) CASCADE;

/*-- SEQ 2737 --*/
CREATE OR REPLACE FUNCTION Aux_TV_ECT_USO (TT_ECT.CODFIL%TYPE,TT_ECT.SEQUEN%TYPE)
RETURNS INTEGER AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pSEQUEN ALIAS FOR $2 ;
  nQTD INTEGER;
BEGIN
select count(*) INTO nQTD
  from tt_cta cta inner join tv_cta_uso uso on uso.filcta = cta.codfil and uso.seqcta = cta.sequen
 where (filect, seqect) in
       (-- Ver detalhes sobre a macro em
-- \\tt2000\Docs\desenv\depto\Manuais\Ansi\connectby.mac
SELECT codfil,sequen
FROM connectby('(select to_char(''NULL'') as filho,
                        to_char(null) as pai,
                        0 as ordem
                   from dual
                 union all
                 select TO_CHAR(chvprj) as filho,
                        coalesce(TO_CHAR(chvpai),''NULL'') as pai,
                        0 as ordem
                   from tt_ect int) tab', 'filho', 'pai','ordem', pCodfil||pSequen, 0, '~')
AS c (conn_codigo VARCHAR, conn_codpai VARCHAR, level int, arvore text, ordem int)
INNER JOIN tt_ect t ON c.conn_codigo  = (chvprj)
where conn_codigo<>'NULL'
order by ordem
       );
return nQTD;
END;
$$ language 'plpgsql';




/*-- SEQ 2738 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ESTADOCOMPRA (TV_CMP.CODFIL%TYPE,TV_CMP.SEQUEN%TYPE) CASCADE;

/*-- SEQ 2739 --*/
CREATE OR REPLACE FUNCTION ESTADOCOMPRA (TV_CMP.CODFIL%TYPE,TV_CMP.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
P_CODFIL ALIAS FOR $1 ;
P_SEQUEN ALIAS FOR $2 ;
VDENFORUF VARCHAR(10);  
-- Funcao para verificar se a compra e para Dentro ou Fora do Estado
begin
  select (CASE WHEN ((COM.UFNOTA IS NULL) OR (COM.UFNOTA = DFIL.UFLOJA)) THEN  'Dentro UF' else 'Fora UF' end) INTO VDENFORUF
  from TV_CMP COM, TD_FIL DFIL 
  where COM.CODFIL = DFIL.CODFIL
    AND COM.CODFIL = P_CODFIL
    AND COM.SEQUEN = P_SEQUEN;    
  Return VDENFORUF;
END;
$$ language 'plpgsql';




/*-- SEQ 2740 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CLI_DIV CASCADE;

/*-- SEQ 2741 --*/
CREATE OR REPLACE VIEW TV_CLI_DIV AS
SELECT FLGTIP, FILCLI, CODCLI,
       NUMDOC, DIVIDA, OCORRE,
       LIMITE, CHEDEV, TIPDIV,
       CAST(DESDIV as VARCHAR(60)) AS DESDIV, 
       CODFIL, 
       CAST(DOCUME as VARCHAR(30)) AS DOCUME,
       VENCIMENTO, EMISSAO, PORTAD, PLANO, DIVIDACOR 
FROM (
SELECT FLGTIP, FILCLI, CODCLI,
       NUMDOC, DIVIDA, OCORRE,
       LIMITE, CHEDEV, TIPDIV,
       DESDIV, CODFIL, DOCUME,
       VENCIMENTO, EMISSAO, PORTAD, PLANO, DIVIDACOR
  FROM TV_CLI_DIV_VEN
UNION ALL
SELECT FLGTIP, FILCLI, CODCLI,
       NUMDOC, DIVIDA, OCORRE,
       LIMITE, CHEDEV, TIPDIV,
       DESDIV, CODFIL, DOCUME,
       VENCIMENTO, EMISSAO, PORTAD, PLANO, DIVIDA as DIVIDACOR
  FROM TV_CLI_DIV_CHR
UNION ALL
SELECT FLGTIP, FILCLI, CODCLI,
       NUMDOC, DIVIDA, OCORRE,
       LIMITE, CHEDEV, TIPDIV,
       DESDIV, CODFIL, DOCUME,
       VENCIMENTO, EMISSAO, PORTAD, PLANO, DIVIDA as DIVIDACOR
  FROM TV_CLI_DIV_LIM
UNION ALL
SELECT FLGTIP, FILCLI, CODCLI,
       NUMDOC, DIVIDA, OCORRE,
       LIMITE, CHEDEV, TIPDIV,
       DESDIV, CODFIL, DOCUME,
       VENCIMENTO, EMISSAO, PORTAD, PLANO, DIVIDA as DIVIDACOR
  FROM TV_CLI_DIV_CHT
) TAB
;


/*-- SEQ 2742 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CLI_DIV_FIL CASCADE;

/*-- SEQ 2743 --*/
CREATE OR REPLACE VIEW TV_CLI_DIV_FIL AS
SELECT FLGTIP, FILCLI, CODCLI,
       NUMDOC, DIVIDA, OCORRE,
       LIMITE, CHEDEV, TIPDIV,
       DESDIV, CODFIL, DOCUME,
       VENCIMENTO
  FROM TV_CLI_DIV_VEN
UNION ALL
SELECT FLGTIP, FILCLI, CODCLI,
       NUMDOC, DIVIDA, OCORRE,
       LIMITE, CHEDEV, TIPDIV,
       DESDIV, CODFIL, DOCUME,
       VENCIMENTO
  FROM TV_CLI_DIV_CHR
UNION ALL
SELECT FLGTIP, FILCLI, CODCLI,
       NUMDOC, DIVIDA, OCORRE,
       LIMITE, CHEDEV, TIPDIV,
       DESDIV, CODFIL, DOCUME,
       VENCIMENTO
  FROM TV_CLI_DIV_CCC
UNION ALL
SELECT FLGTIP, FILCLI, CODCLI,
       NUMDOC, DIVIDA, OCORRE,
       LIMITE, CHEDEV, TIPDIV,
       DESDIV, CODFIL, DOCUME,
       VENCIMENTO
  FROM TV_CLI_DIV_CHT
;


/*-- SEQ 2744 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CLI_PER CASCADE;

/*-- SEQ 2745 --*/
CREATE OR REPLACE VIEW TV_CLI_PER AS
SELECT FILIAL, NOME_CLIENTE, CPF_CNPJ, FILIAL_CLI, CODIGO_CLI, DOCUMENTO, PR,  VENCIMENTO, PLANO, NATUREZA,  VENDA, PAGO, JUROS, DESCONTOS, CODCTR,
       TRIM_PERDA AS PERDA, VENDA-(PAGO-JUROS-DESCONTOS) AS "VLR PERDA", DATA_FILTRO,
       FORNEC, PAGAME, ABERTA, SEQUEN
FROM (
SELECT CODFIL AS FILIAL,
       MAX(ABERTA) AS ABERTA,
       CODNAT AS NATUREZA,
       CAST( DOCUME AS CHAR(13) ) AS DOCUMENTO,
       NUMPAR AS PR, APEPGT AS PLANO,
       MIN( DATVEN) AS VENCIMENTO,
       MIN( VLRPAR ) AS VENDA,
       SUM( CASE WHEN TIPLAN IN ('REC','COB') AND ABERTA = 'F'       THEN VLRLAN*-1 ELSE 0 END ) AS PAGO,
       SUM( CASE WHEN TIPLAN = 'JDR' AND ABERTA = 'F' AND VLRLAN > 0 THEN VLRLAN    ELSE 0 END ) AS JUROS,
       SUM( CASE WHEN TIPLAN = 'JDR' AND ABERTA = 'F' AND VLRLAN < 0 THEN VLRLAN    ELSE 0 END ) AS DESCONTOS,
       CAST( TRUNC( ( TO_NUMBER( TO_CHAR( MIN(DATVEN), 'MM' ) )+2) / 3 )  || '-' || TO_CHAR( MIN(DATVEN), 'YYYY' ) AS CHAR(6) ) AS TRIM_PERDA,
       NUMDOC AS CPF_CNPJ,
       CODCLI AS CODIGO_CLI,
       FILCLI AS FILIAL_CLI,
       CODCTR AS CODCTR,
       NOMCLI || CASE WHEN FLGTIP = 0 THEN ' ' || ULTNOM ELSE '' END AS NOME_CLIENTE,
       DATOPE AS DATA_FILTRO,
       FORNEC,
       max(PAGAME) as pagame,
       SEQUEN
FROM (SELECT REC.CODFIL, NAT.NATDEN, VEN.DOCUME, REC.NUMPAR, VEN.CODNAT, VEN.CODCTR,
             REC.DATVEN, FIN.TIPLAN, FIN.VLRLAN, REC.PAGAME,
             CLI.NUMDOC, CLI.CODCLI, CLI.FILCLI, CLI.NOMCLI, CLI.FLGTIP, CLI.ULTNOM,
             REC.SEQUEN, PLA.APEPGT,
             CASE WHEN COALESCE(REC.PAGAME,AGORA()) >=
                       --ADD_MONTHS(TO_DATE('01/'||TO_CHAR(DAT.DATVEN,'MM/YYYY'), 'DD/MM/YYYY'),7) THEN 'T' ELSE 'F' END AS ABERTA,
                       ADD_MONTHS(TO_DATE('01/'||LPAD(to_char(cast(TRUNC( ( TO_NUMBER( TO_CHAR( DAT.DATVEN, 'MM' ) )+2) / 3 ) * 3 as integer)), 2, '0')||'/'||TO_CHAR( DAT.DATVEN, 'YYYY' ),'DD/MM/YYYY'),7) THEN 'T' ELSE 'F' END AS ABERTA,
             DAT.DATVEN AS DATOPE,
             DAT.VLRPAR,
             CASE WHEN COALESCE(REL.TIPPAR,' ') = 'F' THEN 'T' ELSE 'F' END AS FORNEC
      FROM TT_REC REC INNER JOIN TT_REC DAT ON DAT.CODFIL = REC.CODFIL
                                           AND DAT.SEQUEN = REC.SEQUEN
                                           AND DAT.NUMPAR = REC.NUMPAR
                                           AND DAT.SUBPAR = ' 0'
                      INNER JOIN TV_VEN VEN ON VEN.CODFIL = REC.CODFIL
                                           AND VEN.SEQUEN = REC.SEQUEN
                      INNER JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT
                                           AND PLA.CODPGT = VEN.CODPGT
                      INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI
                                           AND CLI.CODCLI = VEN.CODCLI
                      INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
                      INNER JOIN TR_FIN FIN ON FIN.CODFIL = REC.CODFIL
                                           AND FIN.SEQUEN = REC.SEQUEN
                                           AND FIN.NUMPAR = REC.NUMPAR
                                           AND ((FIN.SUBPAR = REC.SUBPAR AND FIN.TIPLAN<>'VEN')
                                            OR  (FIN.TIPLAN='VEN' and FIN.SUBPAR=' 0'))
                                           AND FIN.ORIGEM = 'REC'
                                           AND FIN.FLGFLX = 'R'
                       LEFT JOIN TT_REL REL ON CLI.FILCLI = REL.FILPAR
                                           AND CLI.CODCLI = REL.CODPAR
                                           AND REL.TIPPAR = 'F'
      WHERE REC.FLGEST IN ('P','A')
        AND VEN.FLGEST <> 'C'
        AND VEN.AVISTA = 'F'
        AND REC.CARTAO IS NULL
        AND REC.SEQCHE IS NULL
        AND DAT.CARTAO IS NULL
        AND DAT.SEQCHE IS NULL
        AND VEN.LANVEN = 'T'
        AND VEN.VLRLIQ > 0
        AND (VEN.FILCLI,VEN.CODCLI) <> (SELECT vc_filcli,vc_codcli FROM Tt_cfg)
        AND NOT (DAT.FLGEST = 'P' AND DAT.DATVEN >= TRUNC(DAT.PAGAME) AND DAT.VLRPGT >= DAT.VLRPAR)
    )  LIS
GROUP BY DATOPE, CODFIL, DOCUME, SEQUEN, NUMPAR, NOMCLI, ULTNOM, FLGTIP, NUMDOC, FILCLI, CODCLI, NATDEN, CODNAT, CODCTR, APEPGT, FORNEC
HAVING SUM( CASE WHEN TIPLAN = 'VEN' THEN VLRLAN ELSE 0 END ) <> 0
) INT
WHERE VENDA-(PAGO-JUROS-DESCONTOS) <> 0;


/*-- SEQ 2746 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CLI_REC CASCADE;

/*-- SEQ 2747 --*/
CREATE OR REPLACE VIEW TV_CLI_REC AS
SELECT REC.CODFIL AS FILIAL,
       CLI.NOMCLI || CASE WHEN CLI.FLGTIP = 0 THEN ' ' || CLI.ULTNOM ELSE '' END AS NOME_CLIENTE,
       CLI.NUMDOC AS CGC_CNPJ,
       CLI.CODCLI AS CODIGO_CLI,
       CAST( VEN.DOCUME AS CHAR(13) ) AS DOCUMENTO,
       REC.NUMPAR AS PR,
       REC.SUBPAR AS SP,
       VEN.CODCTR,
       CTR.DESCTR,
       MIN(REC.DATVEN) AS VENCIMENTO,
       MAX(FIN.DATLAN) AS PAGAMENTO,
       SUM( CASE WHEN FIN.TIPLAN = 'REC'                    THEN FIN.VLRLAN*-1 ELSE 0 END ) AS PAGO,
       SUM( CASE WHEN FIN.TIPLAN = 'JDR' AND FIN.VLRLAN > 0 THEN FIN.VLRLAN    ELSE 0 END ) AS JUROS,
       SUM( CASE WHEN FIN.TIPLAN = 'JDR' AND FIN.VLRLAN < 0 THEN FIN.VLRLAN    ELSE 0 END ) AS DESCONTOS,
       SUM( FIN.VLRLAN*-1 ) AS RECUPERAVEL,
       CAST( TRUNC( ( TO_NUMBER( TO_CHAR( MIN(REC.DATVEN), 'MM' ) )+2) / 3 ) || '-' || TO_CHAR( MIN(REC.DATVEN), 'YYYY' ) AS CHAR(6) ) AS TRIM_PERDA,
       CAST( TRUNC( ( TO_NUMBER( TO_CHAR( MAX(FIN.DATLAN), 'MM' ) )+2) / 3 ) || '-' || TO_CHAR( MAX(FIN.DATLAN), 'YYYY' ) AS CHAR(6) ) AS TRIM_RECUP,
       DAT.DATOPE,
       VEN.LANVEN
FROM TR_FIN FIN INNER JOIN TT_DAT DAT ON FIN.DATLAN between DAT.DATOPE and TO_DATE(TO_CHAR(DAT.DATOPE,'DD/MM/YYYY')||' 23:59:59', 'DD/MM/YYYY HH24:MI:SS')
                INNER JOIN TT_REC REC ON REC.CODFIL = FIN.CODFIL
                                     AND REC.SEQUEN = FIN.SEQUEN
                                     AND REC.NUMPAR = FIN.NUMPAR
                                     AND REC.SUBPAR = FIN.SUBPAR
                INNER JOIN TV_VEN VEN ON VEN.CODFIL = REC.CODFIL
                                     AND VEN.SEQUEN = REC.SEQUEN
                INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI
                                     AND CLI.CODCLI = VEN.CODCLI
                INNER JOIN TD_CTR CTR ON VEN.CODCTR = CTR.CODTAB
WHERE FIN.ORIGEM = 'REC'
  AND FIN.TIPLAN IN ('REC','JDR')
  AND FIN.FLGFLX = 'R'
  AND REC.DATVEN <= LAST_DAY( ADD_MONTHS( TO_DATE('01' || TO_CHAR( TRUNC( (TO_NUMBER( TO_CHAR( FIN.DATLAN, 'MM' ) )+2) / 3 ) * 3, '09' ) || ' ' || TO_CHAR( FIN.DATLAN, 'YYYY' ), 'DD MM YYYY' ), -9 ) )
GROUP BY VEN.CODCTR,CTR.DESCTR,DAT.DATOPE, VEN.LANVEN, REC.CODFIL, VEN.DOCUME, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR, CLI.NOMCLI, CLI.ULTNOM, CLI.FLGTIP, CLI.NUMDOC, CLI.CODCLI;


/*-- SEQ 2748 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CMS CASCADE;

/*-- SEQ 2749 --*/
CREATE OR REPLACE VIEW TV_CMS AS
SELECT CMS.CODFIL,
       CMS.SEQUEN,
       CMS.NUMPAR,
       CMS.SUBPAR,
       CMS.FILIAL,
       CMS.DATA,
       CASE WHEN CMS.MULT_VENDEDORES = 'T' THEN COALESCE(VVDD.FILVEN,CMS.FILVEN) ELSE CMS.FILVEN END AS FILVEN,
       CASE WHEN CMS.MULT_VENDEDORES = 'T' THEN COALESCE(VVDD.CODVEN,CMS.CODVEN) ELSE CMS.CODVEN END AS CODVEN,
       CMS.VALORDOC,
       CMS.DOCUMENTO,
       CMS.PARCELA,
       CMS.PERCENTUAL,
       CMS.CODSER,
       CMS.FILPGT,
       CMS.CODPGT,
       CMS.COMSOB,
       CASE WHEN (CMS.MULT_VENDEDORES = 'T') AND (CMS.QTD_VDD > 0)
            -- quando se usa mltiplos vendedores
            THEN CASE WHEN (CMS.PERVDD > 0) AND (CMS.FILVDP IS NOT NULL)
                      THEN CASE WHEN (VVDD.FILVEN||VVDD.CODVEN) = (CMS.FILVDP||CMS.CODVDP)
                                -- vendedor principal recebe % de comisso do vendedor principal
                                THEN CMS.COMISSAO * CMS.PERVDD / 100
                                -- os demais vendedores recebem o rateio da comisso menos o % de comisso do vendedor principal
                                ELSE (CMS.COMISSAO - (CMS.COMISSAO * CMS.PERVDD / 100)) / CMS.QTD_VDD
                           END
                      -- no havendo % de comisso para o vendedor principal, o rateio da comisso  feito entre todos os vendedores
                      ELSE CMS.COMISSAO / CMS.QTD_VDD
                 END
            -- comisso completa para o vendedor
            ELSE CMS.COMISSAO
       END AS COMISSAO,
       CMS.FLGPAR,
       CMS.VLRPAR,
       CASE WHEN (CMS.MULT_VENDEDORES = 'T') AND (VVDD.FILVEN||VVDD.CODVEN) = (CMS.FILVDP||CMS.CODVDP) THEN 'T' ELSE 'F' END AS MV_FLG_VDP,
       CASE WHEN (CMS.MULT_VENDEDORES = 'T') AND (CMS.PERCENTUAL > 0)
            THEN
              (CASE WHEN (CMS.MULT_VENDEDORES = 'T') AND (CMS.QTD_VDD > 0)
                    -- quando se usa mltiplos vendedores
                    THEN CASE WHEN (CMS.PERVDD > 0) AND (CMS.FILVDP IS NOT NULL)
                              THEN CASE WHEN (VVDD.FILVEN||VVDD.CODVEN) = (CMS.FILVDP||CMS.CODVDP)
                                        -- vendedor principal recebe % de comisso do vendedor principal
                                        THEN CMS.COMISSAO * CMS.PERVDD / 100
                                        -- os demais vendedores recebem o rateio da comisso menos o % de comisso do vendedor principal
                                        ELSE (CMS.COMISSAO - (CMS.COMISSAO * CMS.PERVDD / 100)) / CMS.QTD_VDD
                                   END
                              -- no havendo % de comisso para o vendedor principal, o rateio da comisso  feito entre todos os vendedores
                              ELSE CMS.COMISSAO / CMS.QTD_VDD
                         END
                    -- comisso completa para o vendedor
                    ELSE CMS.COMISSAO
               END) * 100 / CMS.PERCENTUAL
            ELSE 0
       END AS MV_BAS_CMS,
       CMS.MV_PER_CMS_IND,
       CMS.MV_VLR_CMS_IND,
       CMS.MV_BAS_CMS_VDP,
       CASE WHEN (CMS.MULT_VENDEDORES = 'T') AND (CMS.PERVDD > 0) AND (CMS.FILVDP IS NOT NULL)
            THEN CMS.PERVDD
            ELSE 0
       END AS MV_PER_CMS_VDP,
       CASE WHEN (CMS.MULT_VENDEDORES = 'T') AND (CMS.PERVDD > 0) AND (CMS.FILVDP IS NOT NULL)
            THEN CMS.COMISSAO * CMS.PERVDD / 100
            ELSE 0
       END AS MV_VLR_CMS_VDP,
       CASE WHEN (CMS.MULT_VENDEDORES = 'T') THEN CMS.PERCENTUAL ELSE 0 END AS MV_PER_CMS_VDD,
       CASE WHEN (CMS.MULT_VENDEDORES = 'T')
            THEN CASE WHEN CMS.PERVDD > 0
                      THEN (CMS.COMISSAO - (CMS.COMISSAO * CMS.PERVDD / 100))
                      ELSE CMS.COMISSAO
                 END
            ELSE 0
       END AS MV_VLR_CMS_VDD,
       CMS.QTD_VDD AS MV_QTD_VDD,
       CMS.VLRPGT,
       CMS.FILCLI,
       CMS.CODCLI
  FROM (
      SELECT TAB.CODFIL,
             TAB.SEQUEN,
             TAB.NUMPAR,
             TAB.SUBPAR,
             TAB.FILIAL,
             TAB.DATA,
             TAB.FILVEN,
             TAB.CODVEN,
             TAB.VALORDOC,
             TAB.DOCUMENTO,
             TAB.PARCELA,
             TAB.PERCENTUAL,
             TAB.CODSER,
             TAB.FILPGT,
             TAB.CODPGT,
             TAB.COMSOB,
             (COALESCE((TAB.VALORDOC) * TAB.PERCENTUAL,0)/100) AS COMISSAO,
             CASE WHEN TAB.VLRLIQ < 0 THEN
               'D' ELSE CASE WHEN TAB.VLRLIQ = TAB.VLRPAR AND TRUNC(TAB.DATHOR) = TRUNC(TAB.DATVEN) THEN
               'V' ELSE CASE WHEN TRUNC(TAB.DATHOR) = TRUNC(TAB.DATVEN) THEN
               'E' ELSE
               'P' END END
             END AS FLGPAR,
             TAB.VLRPAR,
             CFG.MULT_VENDEDORES,
             COALESCE(CLI.PERVDD,0) AS PERVDD,
             CASE WHEN CFG.MULT_VENDEDORES = 'T' THEN
                    (SELECT COUNT(*)
                       FROM TV_VDD V
                      WHERE V.CODFIL = TAB.CODFIL
                        AND V.SEQUEN = TAB.SEQUEN
                        -- RFMP 85901 Tratamento para caso do VDP ter sido includo na lista de vendedores
                        AND RegraVenPrincViewComiss(V.TIPVDD, TAB.FILVDP, TAB.CODVDP, CLI.PERVDD, V.FILVEN, V.CODVEN) = 'T')
                  ELSE 0
             END AS QTD_VDD,
             TAB.FILVDP,
             TAB.CODVDP,
             CASE WHEN (CFG.MULT_VENDEDORES = 'T') AND (COALESCE(TAB.CMSIND,0) > 0)
                  THEN (TAB.VALORDOC)
                  ELSE 0
             END AS MV_BAS_CMS_VDP,
             CASE WHEN (CFG.MULT_VENDEDORES = 'T') AND (COALESCE(TAB.CMSIND, 0) > 0)
                  THEN TAB.CMSIND
                  ELSE 0
             END AS MV_VLR_CMS_IND,
             CASE WHEN (CFG.MULT_VENDEDORES = 'T') AND (COALESCE(TAB.CMSIND, 0) > 0)
                  THEN (TAB.CMSIND/TAB.VLRLIQ) * 100
                  ELSE 0
             END AS MV_PER_CMS_IND,
             TAB.VLRPGT,
             TAB.FILCLI,
             TAB.CODCLI
      FROM
         (-- Paga-se sobre a subpar = 0, mesmo se estornada ou cancelada
          -- Para comisses sobre o valor liquido ou sobre o valor bruto da venda na data da venda
          -- Se comisso da entrada for igual a comisso das demais parcelas trs somente o valor total na forma de uma parcela
          SELECT VEN.CODFIL AS FILIAL,
                 VEN.DATHOR AS DATA,
                 VEN.FILVEN,
                 VEN.CODVEN,
                 COALESCE(CASE WHEN VEN.COMSOB = 0 THEN (VEN.VLRLIQ-COALESCE(VEN.VLRFRE,0)) ELSE VEN.VLRNOT END,0) AS VALORDOC,
                 COALESCE(VEN.CODSER,'')||'/'||LTRIM(COALESCE(VEN.NUMECF,''))||'-'||LTRIM(COALESCE(VEN.NUMNOT,'')) AS DOCUMENTO,
                 LTRIM(COALESCE(REC.NUMPAR,''))||'-'||LTRIM(COALESCE(REC.SUBPAR,'')) AS PARCELA,
                 COALESCE(VEN.PERENT,0) AS PERCENTUAL,
                 VEN.CODSER,
                 VEN.FILPGT,
                 VEN.CODPGT,
                 VEN.COMSOB,
                 VEN.VLRLIQ,
                 COALESCE(CASE WHEN VEN.COMSOB = 0 THEN (VEN.VLRLIQ-COALESCE(VEN.VLRFRE,0)) ELSE VEN.VLRNOT END,0) AS VLRPAR,
                 VEN.DATHOR,
                 REC.DATVEN,
                 REC.CODFIL,
                 REC.SEQUEN,
                 REC.NUMPAR,
                 REC.SUBPAR,
                 VEN.FILCLI,
                 VEN.CODCLI,
                 VEN.CMSIND,
                 VEN.FILVDP,
                 VEN.CODVDP,
                 REC.VLRPGT
          FROM TT_VEN VEN
               INNER JOIN TT_REC REC ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
          WHERE VEN.COMSOB in (0,1)
            AND VEN.FLGEST <> 'C'
            -- AND ((REC.FLGEST <> 'C') OR (REC.RENEGO is not null))
            -- AND COALESCE( REC.RENORI, 0 ) = 0
            AND REC.RENORI is null
            AND VEN.FINANC = 'T'
            AND REC.NUMPAR = ' 1'
            AND REC.SUBPAR = ' 0'
            AND VEN.PERENT = VEN.PERCOM
          UNION ALL
          -- Paga-se sobre a subpar = 0, mesmo se estornada ou cancelada
          -- Para comisses sobre o valor liquido ou sobre o valor bruto da venda na data da venda
          -- Se comisso da entrada for diferente da comisso das demais parcelas trs somente o valor total na forma de uma parcela
          SELECT VEN.CODFIL AS FILIAL,
                 VEN.DATHOR AS DATA,
                 VEN.FILVEN,
                 VEN.CODVEN,
                 COALESCE(CASE WHEN VEN.COMSOB = 0 THEN REC.VLRPAR-(REC.VLRPAR * COALESCE(VEN.VLRFRE,0) / VEN.VLRLIQ) ELSE (VEN.VLRNOT * REC.VLRPAR / VEN.VLRLIQ) END,0) AS VALORDOC,
                 COALESCE(VEN.CODSER,'')||'/'||LTRIM(COALESCE(VEN.NUMECF,''))||'-'||LTRIM(COALESCE(VEN.NUMNOT,'')) AS DOCUMENTO,
                 LTRIM(COALESCE(REC.NUMPAR,''))||'-'||LTRIM(COALESCE(REC.SUBPAR,'')) AS PARCELA,
                 COALESCE(CASE WHEN TRUNC(VEN.DATHOR) = TRUNC(REC.DATVEN) THEN VEN.PERENT ELSE VEN.PERCOM END,0) AS PERCENTUAL,
                 VEN.CODSER,
                 VEN.FILPGT,
                 VEN.CODPGT,
                 VEN.COMSOB,
                 VEN.VLRLIQ,
                 REC.VLRPAR-(REC.VLRPAR * COALESCE(VEN.VLRFRE,0) / VEN.VLRLIQ) AS VLRPAR,
                 VEN.DATHOR,
                 REC.DATVEN,
                 REC.CODFIL,
                 REC.SEQUEN,
                 REC.NUMPAR,
                 REC.SUBPAR,
                 VEN.FILCLI,
                 VEN.CODCLI,
                 VEN.CMSIND*CASE REC.FLGEST WHEN 'A' THEN REC.VLRPAR
                                                    WHEN 'P' THEN REC.VLRPGT-COALESCE(REC.VLRDES,0)+COALESCE(REC.VLRTAX,0)
                                                    WHEN 'C' THEN COALESCE(REC.VLRDES,0)*-1
                                    END/NVLZ(VEN.VLRLIQ,1)
                         AS CMSIND,
                 VEN.FILVDP,
                 VEN.CODVDP,
                 REC.VLRPGT
          FROM TT_VEN VEN
               INNER JOIN TT_REC REC ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
          WHERE VEN.COMSOB in (0,1)
            AND VEN.FLGEST <> 'C'
            -- AND ((REC.FLGEST <> 'C') OR (REC.RENEGO is not null))
            -- AND COALESCE( REC.RENORI, 0 ) = 0
            AND REC.RENORI is null
            AND VEN.FINANC = 'T'
            AND REC.SUBPAR = ' 0'
            AND VEN.PERENT <> VEN.PERCOM
          UNION ALL
            -- Sobre o valor a receber na data do vencimento
          SELECT VEN.CODFIL AS FILIAL,
                 REC.DATVEN AS DATA,
                 VEN.FILVEN,
                 VEN.CODVEN,
                 COALESCE(REC.VLRPAR,0) AS VALORDOC,
                 COALESCE(VEN.CODSER,'')||'/'||LTRIM(COALESCE(VEN.NUMECF,''))||'-'||LTRIM(COALESCE(VEN.NUMNOT,'')) AS DOCUMENTO,
                 LTRIM(COALESCE(REC.NUMPAR,''))||'-'||LTRIM(COALESCE(REC.SUBPAR,'')) AS PARCELA,
                 COALESCE(CASE WHEN TRUNC(VEN.DATHOR) = TRUNC(REC.DATVEN) THEN VEN.PERENT ELSE VEN.PERCOM END,0) AS PERCENTUAL,
                 VEN.CODSER,
                 VEN.FILPGT,
                 VEN.CODPGT,
                 VEN.COMSOB,
                 VEN.VLRLIQ,
                 REC.VLRPAR,
                 VEN.DATHOR,
                 REC.DATVEN,
                 REC.CODFIL,
                 REC.SEQUEN,
                 REC.NUMPAR,
                 REC.SUBPAR,
                 VEN.FILCLI,
                 VEN.CODCLI,
                 VEN.CMSIND*CASE REC.FLGEST WHEN 'A' THEN REC.VLRPAR
                                                    WHEN 'P' THEN REC.VLRPGT-COALESCE(REC.VLRDES,0)+COALESCE(REC.VLRTAX,0)
                                                    WHEN 'C' THEN COALESCE(REC.VLRDES,0)*-1
                                    END/NVLZ(VEN.VLRLIQ,1)
                         AS CMSIND,
                 VEN.FILVDP,
                 VEN.CODVDP,
                 REC.VLRPGT
          FROM TT_VEN VEN
               INNER JOIN TT_REC REC ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
          WHERE VEN.COMSOB = 2
            AND VEN.FLGEST <> 'C'
--        AND ((REC.FLGEST <> 'C') OR (REC.RENEGO is not null))
--        AND COALESCE( REC.RENORI, 0 ) = 0
            AND REC.RENORI is null
            AND VEN.FINANC = 'T'
            AND REC.SUBPAR = ' 0'
          UNION ALL
          -- Sobre o valor a recebido na data do recebimento
          -- ou Sobre o valor a receber na data do recebimento
          SELECT VEN.CODFIL AS FILIAL,
                 REC.PAGAME AS DATA,
                 VEN.FILVEN,
                 VEN.CODVEN,
                 COALESCE( CASE WHEN VEN.COMSOB IN (3,5) THEN REC.VLRPGT ELSE COALESCE(REC.VLRPGT,0)-COALESCE(REC.VLRDES,0) END,0) AS VALORDOC,
                 COALESCE(VEN.CODSER,'')||'/'||LTRIM(COALESCE(VEN.NUMECF,''))||'-'||LTRIM(COALESCE(VEN.NUMNOT,'')) AS DOCUMENTO,
                 LTRIM(COALESCE(REC.NUMPAR,''))||'-'||LTRIM(COALESCE(REC.SUBPAR,'')) AS PARCELA,
                 COALESCE(CASE WHEN TRUNC(VEN.DATHOR) = TRUNC(REC.DATVEN) THEN VEN.PERENT ELSE VEN.PERCOM END,0) AS PERCENTUAL,
                 VEN.CODSER,
                 VEN.FILPGT,
                 VEN.CODPGT,
                 VEN.COMSOB,
                 VEN.VLRLIQ,
                 REC.VLRPAR,
                 VEN.DATHOR,
                 REC.DATVEN,
                 REC.CODFIL,
                 REC.SEQUEN,
                 REC.NUMPAR,
                 REC.SUBPAR,
                 VEN.FILCLI,
                 VEN.CODCLI,
                 VEN.CMSIND*CASE REC.FLGEST WHEN 'A' THEN REC.VLRPAR
                                                    WHEN 'P' THEN REC.VLRPGT-COALESCE(REC.VLRDES,0)+COALESCE(REC.VLRTAX,0)
                                                    WHEN 'C' THEN COALESCE(REC.VLRDES,0)*-1
                                    END/NVLZ(VEN.VLRLIQ,1)
                         AS CMSIND,
                 VEN.FILVDP,
                 VEN.CODVDP,
                 REC.VLRPGT
          FROM TT_VEN VEN
               INNER JOIN TT_REC REC ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
          WHERE (VEN.COMSOB in (3,4) OR (VEN.COMSOB in (5,6) AND REC.SEQCHE IS NULL))
          AND VEN.FLGEST<>'C'
          AND REC.FLGEST NOT IN ('X','C')
          UNION ALL
          -- Sobre o valor a recebido na data de compensao do cheque
          -- ou Sobre o valor a receber na data de compensao do cheque
          SELECT VEN.CODFIL AS FILIAL,
                 CHR.PAGAME AS DATA,
                 VEN.FILVEN,
                 VEN.CODVEN,
                 COALESCE( CASE WHEN VEN.COMSOB = 5 THEN REC.VLRPGT ELSE COALESCE(REC.VLRPGT,0)-COALESCE(REC.VLRDES,0) END,0) AS VALORDOC,
                 COALESCE(VEN.CODSER,'')||'/'||LTRIM(COALESCE(VEN.NUMECF,''))||'-'||LTRIM(COALESCE(VEN.NUMNOT,'')) AS DOCUMENTO,
                 LTRIM(COALESCE(REC.NUMPAR,''))||'-'||LTRIM(COALESCE(REC.SUBPAR,'')) AS PARCELA,
                 COALESCE(CASE WHEN TRUNC(VEN.DATHOR) = TRUNC(REC.DATVEN) THEN VEN.PERENT ELSE VEN.PERCOM END,0) AS PERCENTUAL,
                 VEN.CODSER,
                 VEN.FILPGT,
                 VEN.CODPGT,
                 VEN.COMSOB,
                 VEN.VLRLIQ,
                 REC.VLRPAR,
                 VEN.DATHOR,
                 REC.DATVEN,
                 REC.CODFIL,
                 REC.SEQUEN,
                 REC.NUMPAR,
                 REC.SUBPAR,
                 VEN.FILCLI,
                 VEN.CODCLI,
                 VEN.CMSIND*CASE REC.FLGEST WHEN 'A' THEN REC.VLRPAR
                                                    WHEN 'P' THEN REC.VLRPGT-COALESCE(REC.VLRDES,0)+COALESCE(REC.VLRTAX,0)
                                                    WHEN 'C' THEN COALESCE(REC.VLRDES,0)*-1
                                    END/NVLZ(VEN.VLRLIQ,1)
                         AS CMSIND,
                 VEN.FILVDP,
                 VEN.CODVDP,
                 REC.VLRPGT
          FROM TT_CHR CHR INNER JOIN TT_REC REC ON REC.FILREC = CHR.CODFIL AND REC.SEQCHE = CHR.SEQUEN
                          INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
          WHERE VEN.COMSOB in (5,6)
            AND CHR.FLGEST IN ('B','C')
          UNION ALL
          --Comisso sobre Markup
          SELECT SUB.FILIAL, SUB.DATA, SUB.FILVEN, SUB.CODVEN,
                 -- RFMP 88968 - Otimizao da view
                 CASE WHEN SUB.GETVLRPAGCMS=0 THEN 0.00
                      WHEN ABS(SUB.GETVLRPAGCMS) < SUB.GETCUSTOCMS/SUB.VLRLIQ*ABS(SUB.GETVLRPAGCMS) THEN 0.00
                 ELSE SUB.GETVLRPAGCMS - ((SUB.GETVLRPAGCMS / SUB.VLRLIQ) * SUB.GETCUSTOCMS)
                 END AS VALORDOC,
                 SUB.DOCUMENTO, SUB.PARCELA, SUB.PERCENTUAL, SUB.CODSER, SUB.FILPGT,
                 SUB.CODPGT, SUB.COMSOB, SUB.VLRLIQ, SUB.VLRPAR, SUB.DATHOR,
                 SUB.DATVEN, SUB.CODFIL, SUB.SEQUEN, SUB.NUMPAR, SUB.SUBPAR,
                 SUB.FILCLI, SUB.CODCLI, SUB.CMSIND, SUB.FILVDP, SUB.CODVDP,
                 SUB.VLRPGT
            FROM (-- Data da Parcela
                  SELECT VEN.CODFIL AS FILIAL,
                         REC.PAGAME AS DATA,
                         VEN.FILVEN,
                         VEN.CODVEN,
                         -- RFMP 88968 - Otimizao da view
                         --CASE WHEN GETVLRPAGCMS(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)=0 THEN 0.00
                         --     WHEN ABS(GETVLRPAGCMS(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)) < GETCUSTOCMS(VEN.CODFIL, VEN.SEQUEN)/VEN.VLRLIQ*ABS(GETVLRPAGCMS(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)) THEN
                         --          0.00
                         --ELSE
                         --          GETVLRPAGCMS(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)  - (GETVLRPAGCMS(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) / VEN.VLRLIQ) * GETCUSTOCMS(VEN.CODFIL, VEN.SEQUEN)
                         --END AS VALORDOC,
                         GETVLRPAGCMS(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) AS GETVLRPAGCMS,
                         GETCUSTOCMS(VEN.CODFIL,VEN.SEQUEN) AS GETCUSTOCMS,
                         COALESCE(VEN.CODSER,'')||'/'||LTRIM(COALESCE(VEN.NUMECF,''))||'-'||LTRIM(COALESCE(VEN.NUMNOT,'')) AS DOCUMENTO,
                         LTRIM(COALESCE(REC.NUMPAR,''))||'-'||LTRIM(COALESCE(REC.SUBPAR,'')) AS PARCELA,
                         COALESCE(VEN.PERENT,0) AS PERCENTUAL,
                         VEN.CODSER,
                         VEN.FILPGT,
                         VEN.CODPGT,
                         VEN.COMSOB,
                         VEN.VLRLIQ,
                         REC.VLRPAR AS VLRPAR,
                         VEN.DATHOR,
                         VEN.DATHOR AS DATVEN,
                         REC.CODFIL,
                         REC.SEQUEN,
                         REC.NUMPAR,
                         REC.SUBPAR,
                         VEN.FILCLI,
                         VEN.CODCLI,
                         VEN.CMSIND*CASE REC.FLGEST WHEN 'A' THEN REC.VLRPAR
                                                    WHEN 'P' THEN REC.VLRPGT-COALESCE(REC.VLRDES,0)+COALESCE(REC.VLRTAX,0)
                                                    WHEN 'C' THEN COALESCE(REC.VLRDES,0)*-1
                                    END/NVLZ(VEN.VLRLIQ,1)
                         AS CMSIND,
                         VEN.FILVDP,
                         VEN.CODVDP,
                         REC.VLRPGT
                    FROM TT_REC REC INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL
                                                         AND VEN.SEQUEN = REC.SEQUEN
                                    INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
                                     LEFT JOIN TT_CHR CHR ON CHR.CODFIL = REC.FILREC
                                                         AND CHR.SEQUEN = REC.SEQCHE
                                                         --AND CHR.FLGEST IN ('C','B')   Paulo : 74371 - Estava causando a perca de conexo com o Oracle.
                                                         AND CHR.PAGAME>REC.PAGAME
                   WHERE VEN.FLGEST <> 'C'
                     AND VEN.FINANC  = 'T'
                     AND REC.FLGEST NOT IN ('X','C')
                     AND VEN.VLRLIQ <> 0.01
                     AND VEN.COMSOB  = 7
                     AND CHR.PAGAME IS NULL
                     AND (CHR.FLGEST IS NULL OR CHR.FLGEST IN ('C','B'))
                   UNION ALL
                  -- Data do cheque
                  SELECT VEN.CODFIL AS FILIAL,
                         CHR.PAGAME AS DATA,
                         VEN.FILVEN,
                         VEN.CODVEN,
                         -- RFMP 88968 - Otimizao da view
                         --CASE WHEN GETVLRPAGCMS(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)=0 THEN 0.00
                         --     WHEN ABS(GETVLRPAGCMS(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)) < GETCUSTOCMS(VEN.CODFIL, VEN.SEQUEN)/VEN.VLRLIQ*ABS(GETVLRPAGCMS(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)) THEN
                         --          0.00
                         --ELSE
                         --          GETVLRPAGCMS(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)  - (GETVLRPAGCMS(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) / VEN.VLRLIQ) * GETCUSTOCMS(VEN.CODFIL, VEN.SEQUEN)
                         --END AS VALORDOC,
                         GETVLRPAGCMS(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) AS GETVLRPAGCMS,
                         GETCUSTOCMS(VEN.CODFIL,VEN.SEQUEN) AS GETCUSTOCMS,
                         COALESCE(VEN.CODSER,'')||'/'||LTRIM(COALESCE(VEN.NUMECF,''))||'-'||LTRIM(COALESCE(VEN.NUMNOT,'')) AS DOCUMENTO,
                         LTRIM(COALESCE(REC.NUMPAR,''))||'-'||LTRIM(COALESCE(REC.SUBPAR,'')) AS PARCELA,
                         COALESCE(VEN.PERENT,0) AS PERCENTUAL,
                         VEN.CODSER,
                         VEN.FILPGT,
                         VEN.CODPGT,
                         VEN.COMSOB,
                         VEN.VLRLIQ,
                         REC.VLRPAR AS VLRPAR,
                         VEN.DATHOR,
                         VEN.DATHOR AS DATVEN,
                         REC.CODFIL,
                         REC.SEQUEN,
                         REC.NUMPAR,
                         REC.SUBPAR,
                         VEN.FILCLI,
                         VEN.CODCLI,
                         VEN.CMSIND*CASE REC.FLGEST WHEN 'A' THEN REC.VLRPAR
                                                    WHEN 'P' THEN REC.VLRPGT-COALESCE(REC.VLRDES,0)+COALESCE(REC.VLRTAX,0)
                                                    WHEN 'C' THEN COALESCE(REC.VLRDES,0)*-1
                                    END/NVLZ(VEN.VLRLIQ,1)
                         AS CMSIND,
                         VEN.FILVDP,
                         VEN.CODVDP,
                         REC.VLRPGT
                    FROM TT_REC REC INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL
                                                         AND VEN.SEQUEN = REC.SEQUEN
                                    INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
                                    INNER JOIN TT_CHR CHR ON CHR.CODFIL = REC.FILREC
                                                         AND CHR.SEQUEN = REC.SEQCHE
                                                         AND CHR.FLGEST IN ('C','B')
                                                         AND CHR.PAGAME>REC.PAGAME
                   WHERE VEN.FLGEST <> 'C'
                     AND VEN.FINANC  = 'T'
                     AND REC.FLGEST NOT IN ('X','C')
                     AND VEN.VLRLIQ <> 0.01
                     AND VEN.COMSOB  = 7) SUB
               WHERE -- RFMP 88968 - Otimizao da view
                     --VALORDOC <> 0
                     CASE WHEN SUB.GETVLRPAGCMS=0 THEN 0.00
                          WHEN ABS(SUB.GETVLRPAGCMS) < SUB.GETCUSTOCMS/SUB.VLRLIQ*ABS(SUB.GETVLRPAGCMS) THEN 0.00
                     ELSE SUB.GETVLRPAGCMS - (SUB.GETVLRPAGCMS / SUB.VLRLIQ) * SUB.GETCUSTOCMS
                     END <> 0
          UNION ALL
          --Comisso Sobre: Markup no momento da Venda
          SELECT SUB.FILIAL, SUB.DATA, SUB.FILVEN, SUB.CODVEN,
                 CASE WHEN SUB.VALORPARDOC=0 THEN 0.00
                      WHEN ABS(SUB.VALORPARDOC) < ((SUB.GETCUSTOCMS/SUB.VLRLIQ)*ABS(SUB.VALORPARDOC)) THEN 0.00
                      ELSE SUB.VALORPARDOC - ((SUB.VALORPARDOC / SUB.VLRLIQ) * SUB.GETCUSTOCMS)
                 END AS VALORDOC,
                 SUB.DOCUMENTO, SUB.PARCELA, SUB.PERCENTUAL, SUB.CODSER, SUB.FILPGT,
                 SUB.CODPGT, SUB.COMSOB, SUB.VLRLIQ, SUB.VLRPAR, SUB.DATHOR,
                 SUB.DATVEN, SUB.CODFIL, SUB.SEQUEN, SUB.NUMPAR, SUB.SUBPAR,
                 SUB.FILCLI, SUB.CODCLI, SUB.CMSIND, SUB.FILVDP, SUB.CODVDP,
                 SUB.VLRPGT
            FROM ( SELECT VEN.CODFIL AS FILIAL,
                          VEN.DATHOR AS DATA,
                          VEN.FILVEN,
                          VEN.CODVEN,
                          COALESCE(VEN.VLRNOT * REC.VLRPAR / VEN.VLRLIQ,0) AS VALORPARDOC,
                          GETCUSTOCMS(VEN.CODFIL,VEN.SEQUEN) AS GETCUSTOCMS,
                          COALESCE(VEN.CODSER,'')||'/'||LTRIM(COALESCE(VEN.NUMECF,''))||'-'||LTRIM(COALESCE(VEN.NUMNOT,'')) AS DOCUMENTO,
                          LTRIM(COALESCE(REC.NUMPAR,''))||'-'||LTRIM(COALESCE(REC.SUBPAR,'')) AS PARCELA,
                          COALESCE(CASE WHEN TRUNC(VEN.DATHOR) = TRUNC(REC.DATVEN) THEN VEN.PERENT ELSE VEN.PERCOM END,0) AS PERCENTUAL,
                          VEN.CODSER,
                          VEN.FILPGT,
                          VEN.CODPGT,
                          VEN.COMSOB,
                          VEN.VLRLIQ,
                          REC.VLRPAR-(REC.VLRPAR * COALESCE(VEN.VLRFRE,0) / VEN.VLRLIQ) AS VLRPAR,
                          VEN.DATHOR,
                          REC.DATVEN,
                          REC.CODFIL,
                          REC.SEQUEN,
                          REC.NUMPAR,
                          REC.SUBPAR,
                          VEN.FILCLI,
                          VEN.CODCLI,
                          VEN.CMSIND*CASE REC.FLGEST WHEN 'A' THEN REC.VLRPAR
                                                             WHEN 'P' THEN REC.VLRPGT-COALESCE(REC.VLRDES,0)+COALESCE(REC.VLRTAX,0)
                                                             WHEN 'C' THEN COALESCE(REC.VLRDES,0)*-1
                                             END/NVLZ(VEN.VLRLIQ,1)
                                  AS CMSIND,
                          VEN.FILVDP,
                          VEN.CODVDP,
                          REC.VLRPGT
                    FROM TT_VEN VEN
                   INNER JOIN TT_REC REC ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
                   WHERE VEN.COMSOB = 8
                     AND VEN.FLGEST <> 'C'
                     AND REC.RENORI IS NULL
                     AND VEN.FINANC = 'T'
                     AND REC.SUBPAR = ' 0'
                   ) SUB
               WHERE CASE WHEN SUB.VALORPARDOC=0 THEN 0.00
                          WHEN ABS(SUB.VALORPARDOC) < ((SUB.GETCUSTOCMS/SUB.VLRLIQ)*ABS(SUB.VALORPARDOC)) THEN 0.00
                          ELSE SUB.VALORPARDOC - ((SUB.VALORPARDOC / SUB.VLRLIQ) * SUB.GETCUSTOCMS)
                     END <> 0

      ) TAB INNER JOIN TT_CLI CLI ON TAB.FILCLI = CLI.FILCLI
                                 AND TAB.CODCLI = CLI.CODCLI
            CROSS JOIN TT_CFG CFG
  ) CMS INNER JOIN TV_VDD VVDD ON VVDD.CODFIL = CMS.CODFIL
                              AND VVDD.SEQUEN = CMS.SEQUEN
                               -- RFMP 85901 Tratamento para caso do VDP ter sido includo na lista de vendedores
                              AND RegraVenPrincViewComiss(VVDD.TIPVDD, CMS.FILVDP, CMS.CODVDP, CMS.PERVDD, VVDD.FILVEN, VVDD.CODVEN) = 'T'
 WHERE CMS.VALORDOC <> 0
   AND CMS.PERCENTUAL > 0;


/*-- SEQ 2750 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_COBIVE_CREDIT CASCADE;

/*-- SEQ 2751 --*/
CREATE OR REPLACE VIEW TV_COBIVE_CREDIT AS
SELECT INT.* FROM
(SELECT IVE.NUMITE, IVE.QTDMOV, IPR.NOMPRO, IVE.VLRMOV, IVE.NUMORI,
       VEN.VLRLIQ * IVE.VLRMOV / VEN.VLRNOT AS VLRLIQ, IVE.CODFIL AS FILIVE, IVE.SEQUEN AS SEQIVE
  FROM TT_IVE IVE LEFT JOIN TV_IPR_FAST IPR ON IPR.FILMAT = IVE.FILMAT
                                           AND IPR.CODMAT = IVE.CODMAT
                                           AND IPR.CODCOR = IVE.CODCOR
                                           AND IPR.CODTAM = IVE.CODTAM
                  LEFT JOIN TT_VEN VEN ON IVE.CODFIL = VEN.CODFIL
                                      AND IVE.SEQUEN = VEN.SEQUEN
 WHERE IVE.SITKIT <> '3'
) INT
;


/*-- SEQ 2752 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CONTRIBUICOES CASCADE;

/*-- SEQ 2753 --*/
CREATE OR REPLACE VIEW TV_CONTRIBUICOES AS
 SELECT INT.DOC_CODFIL,
        INT.DOC_SEQUEN,
        INT.ITE_NUMITE,
        INT.DOC_TIPDOC,
        INT.DOC_NUMNOT,
        INT.DOC_DATDOC,
        INT.DOC_DATOPE,
        INT.DOC_VLRLIQ,
        INT.FILMAT,
        INT.CODMAT,
        INT.CODCOR,
        INT.CODTAM,
        INT.DOC_VLRPIS_RET,
        INT.DOC_VLRCOF_RET,
        INT.ITE_SITPIS,
        INT.ITE_BASPIS,
        INT.ITE_PERPIS,
        INT.ITE_SITCOF,
        INT.ITE_BASCOF,
        INT.ITE_PERCOF,
        INT.ITE_VLRMOV,
        INT.ITE_QTDMOV,
        INT.DOC_CODNAT,
        INT.ITE_SITMOV,
        INT.CLASS1,
        INT.CLASS2,
        INT.DESMAT,
        INT.REFBAS
   FROM (SELECT 'E'||VEN.CODFIL||LPAD(TRIM(VEN.SEQUEN),10,'0') AS DOC_CODIGO,
                VEN.CODFIL AS DOC_CODFIL,
                VEN.SEQUEN AS DOC_SEQUEN,
                VEN.NUMNOT AS DOC_NUMNOT,
                TO_CHAR('E') AS DOC_TIPDOC,
                VEN.DATFIS AS DOC_DATDOC,
                VEN.DATFIS AS DOC_DATOPE,
                VEN.DOCNFP AS DOC_DOCNFP,
                VEN.VLRLIQ AS DOC_VLRLIQ,
                0 AS DOC_DESCON,
                0 AS DOC_VLRPIS,
                0 AS DOC_VLRCOF,
                VEN.VLRNOT AS DOC_VLRTOT,
                CAST(CASE WHEN VEN.FLGNFE = '4' THEN '05' ELSE
                  CASE WHEN VEN.FLGNFE = '6' THEN '04' ELSE
                    CASE WHEN (VEN.FLGNFE <>'4' OR VEN.FLGNFE <>'6') AND (VEN.FLGEST = 'C') THEN '02' ELSE
                      CASE WHEN (VEN.FLGNFE IS NULL)  AND (VEN.FLGEST = 'C') THEN '02' ELSE
                        '00'  END END END END AS VARCHAR(2)) AS DOC_FLGEST,
                0 AS DOC_BASICM,
                0 AS DOC_VLRICM,
                0 AS DOC_ISEICM,
                0 AS DOC_VLRIPI,
                COALESCE(CASE WHEN VEN.CHAVEA IS NULL
                                OR LENGTH(VEN.CHAVEA) < 44
                                OR LENGTH(VEN.CHAVEA) IS NULL
                              THEN NULL
                              ELSE VEN.CHAVEA
                         END, (SELECT MAX(VRT.CHAVEA)
                                 FROM TT_VRT VRT
                                WHERE VRT.FILVEN = VEN.CODFIL
                                  AND VRT.ECFVEN = VEN.NUMECF
                                  AND VRT.SERVEN = VEN.CODSER
                                  AND VRT.NOTVEN = VEN.NUMNOT
                                  AND VRT.CROVEN = VEN.CNT_RO)) AS DOC_CHAVEA,
                VEN.VLRFRE AS DOC_VLRFRE,
                VEN.VLRSEG AS DOC_VLRSEG,
                VEN.OUTTAX AS DOC_OUTTAX,
                (SELECT SUM(IVE2.BASUBS)
                   FROM TT_IVE IVE2
                  WHERE IVE2.CODFIL = VEN.CODFIL
                    AND IVE2.SEQUEN = VEN.SEQUEN
                    AND IVE2.SITMOV = 'N'
                    AND IVE2.SITKIT IN ('2','3')) AS DOC_BASSUB,
                (SELECT SUM(IVE3.SUBSTT)
                   FROM TT_IVE IVE3
                  WHERE IVE3.CODFIL = VEN.CODFIL
                    AND IVE3.SEQUEN = VEN.SEQUEN
                    AND IVE3.SITMOV = 'N'
                    AND IVE3.SITKIT IN ('2','3')) AS DOC_SUBSTT,
                VEN.TIPNOT AS DOC_TIPNOT,
                TRANSLATE(Rtf2txt(replace(replace(VEN.OBSFIS,chr(13),''),chr(10),'')),'',' ') AS DOC_OBSFIS,
                0 AS DOC_PERICM,
                VEN.BASISS AS DOC_BASISS,
                VEN.VLRISS AS DOC_VLRISS,
                0 AS DOC_PERISS,
                VEN.BASIRR AS DOC_BASIRR,
                VEN.VLRIRR AS DOC_VLRIRR,
                0 AS DOC_PERIRR,
                VEN.VLRPIS AS DOC_VLRPIS_RET,
                VEN.VLRCOF AS DOC_VLRCOF_RET,
                VEN.FLGNFE AS DOC_FLGNFE,
                --VEN.NUMECF AS VEN_NUMECF,
                --VEN.CNT_RO AS VEN_CNT_RO,
                --VEN.DATFIS AS VEN_DATFIS,
                --VEN.EMIDES AS VEN_EMIDES,
                --VEN.AVISTA AS VEN_AVISTA,
                --VEN.FINANC AS VEN_FINANC,
                --VEN.TITAVU AS VEN_TITAVU,
                --VEN.FLGEST AS VEN_FLGEST,
                --NULL AS VEN_INDFRE,
                --CTAVEN.CODEXT AS CTADOC_CODEXT,
                COALESCE(VEN.MODNOT, FIS.MODNOT) AS FIS_MODNOT,
                TRIM(FIS.SEREXP) AS FIS_CODSER,
                TRIM(FIS.SUBEXP) AS FIS_SUBSER,
                'E'||IVE.CODFIL||LPAD(TRIM(IVE.SEQUEN),10,'0')||LPAD(to_char(IVE.NUMITE),5,'0') AS ITE_CODIGO,
                IVE.CODFIL AS ITE_CODFIL,
                IVE.NUMITE AS ITE_NUMITE,
                IVE.QTDMOV AS ITE_QTDMOV,
                IVE.VLRMOV AS ITE_VLRMOV,
                CASE WHEN VEN.CODSER = 'CF' THEN IVE.VLRDES ELSE 0 END AS ITE_VLRDES,
                IVE.TIPPRO AS ITE_TIPPRO,
                IVE.ICMTIP AS ITE_ICMTIP,
                IVE.REDITE AS ITE_REDITE,
                NULL AS ITE_CALSUB,
                IVE.SUBSTT AS ITE_VLR_ST,
                IVE.BASUBS AS ITE_BASSUB,
                CASE WHEN SUBSTR(IVE.CODCST,2,2) = '60'
                       OR IVE.CODCST = '500'
                     THEN 0
                     ELSE CASE WHEN COALESCE(IVE.TAXICM,0) <> 0
                               THEN IVE.TAXICM
                               ELSE CASE WHEN IVE.TIP001 = 'M' THEN IVE.TAX001 ELSE 0 END
                          END
                END AS ITE_TAXICM,
                IVE.BASICM AS ITE_BASICM,
                CASE WHEN COALESCE(IVE.VLRICM,0) <> 0
                     THEN IVE.VLRICM
                     ELSE CASE WHEN IVE.TIP001 = 'M' THEN IVE.VLR001 ELSE 0 END
                END AS ITE_VLRICM,
                CASE WHEN COALESCE(IVE.VLRIPI,0) <> 0
                     THEN IVE.VLRIPI
                     ELSE IVE.VLR002
                END AS ITE_VLRIPI,
                IVE.ISEICM AS ITE_ISEICM,
                IVE.LANEST AS ITE_LANEST,
                IVE.VLRPIS AS ITE_VLRPIS,
                IVE.VLRCOF AS ITE_VLRCOF,
                CASE WHEN (COALESCE(IVE.TAXIPI, 0) = 0) AND (COALESCE(IVE.TAX002, 0) = 0) THEN
                     0 ELSE IVE.BASIPI END AS ITE_BASIPI,
                CASE WHEN COALESCE(IVE.TAXIPI,0) <> 0
                     THEN IVE.TAXIPI
                     ELSE IVE.TAX002
                END AS ITE_TAXIPI,
                IVE.SITPIS AS ITE_SITPIS,
                IVE.BASPIS AS ITE_BASPIS,
                IVE.PERPIS AS ITE_PERPIS,
                IVE.SITCOF AS ITE_SITCOF,
                IVE.BASCOF AS ITE_BASCOF,
                IVE.PERCOF AS ITE_PERCOF,
                0 AS ITE_IPIFRE,
                0 AS ITE_VLRFRE,
                0 AS ITE_RED_ST,
                CASE WHEN SUBSTR(IVE.CODCST,2,2) = '60'
                       OR IVE.CODCST = '500'
                     THEN 0
                     ELSE CASE WHEN COALESCE(IVE.TAXICM,0) <> 0
                               THEN IVE.TAXICM
                               ELSE CASE WHEN IVE.TIP001 = 'M' THEN IVE.TAX001 ELSE 0 END
                          END
                END AS ITE_ICMVEN,
                IVE.VLRUNI AS ITE_VLRUNI,
                IVE.SITMOV AS ITE_SITMOV,
                COALESCE(IVE.CODCST, '   ') AS ITE_CODCST,
                --IVE.BASISS AS IVE_BASISS,
                --IVE.TAXISS AS IVE_TAXISS,
                --IVE.VLRISS AS IVE_VLRISS,
                --CASE WHEN VEN.CODSER='CF' THEN
                --  CASE WHEN VEN.VLRLIQ = VEN.VLRNOT THEN
                --          IVE.VLRMOV ELSE
                --          Rateio_ValorLiquido_ECF(IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE)
                --  END
                --ELSE 0 END AS IVE_VLRLIQ,
               --CASE WHEN EXISTS (SELECT 'OK' FROM TT_FUN WHERE NOMFUN = 'EXPCODVEND') THEN
               --      IPR.FILMAT||LPAD(TRIM(IPR.SEQUEN),10,'0')
               --     ELSE
               --        Cast(COALESCE(IPR.FILMAT, '')|| COALESCE(IPR.CODMAT, '')|| '-' || TRIM(COALESCE(TO_CHAR(IPR.CODCOR), ''))
               --        || '-' || TRIM(COALESCE(TO_CHAR(IPR.CODTAM),'')) as VARCHAR(21))
               --END AS PRO_CODIGO,
               -- IPR.REFPRO AS PRO_REFPRO,
               -- NomeProduto(IPR.DESECF, IPR.DESMAT, IPR.CODCOR, IPR.ITEDIV,
               --             IPR.CODTAM, IPR.ITESUB, IPR.ESPMAT, IPR.DESGRA) AS PRO_NOMPRO,
               -- (SELECT MIN(EAN.CODEAN)
               --    FROM TT_EAN EAN
               --   WHERE EAN.FILMAT = IPR.FILMAT
               --     AND EAN.CODMAT = IPR.CODMAT
               --     AND EAN.CODCOR = IPR.CODCOR
               --     AND EAN.CODTAM = IPR.CODTAM) AS PRO_CODEAN,
               -- IPR.CODFPS AS PRO_CODFPS,
               -- IPR.CODNCM AS PRO_CODNCM,
               -- IPR.COD_EX AS PRO_COD_EX,
               -- SUBSTR(IPR.CODNCM,1,2) AS PRO_GENNCM,
               -- IPR.CODSRV AS PRO_CODSRV,
               -- ICM.RESICM AS PRO_PERICM,
               -- IPR.CODANP AS PRO_CODANP,
               -- IPR.NATBCC AS PRO_NATBCC,
               -- CASE WHEN IVE.SITIPI IS NULL THEN
               --    CASE WHEN VEN.FINANC = 'T' THEN IPR.SITIPI ELSE '9' END
               -- ELSE IVE.SITIPI END AS ITE_SITIPI,
               -- IPR.CODEXT AS PRO_CODEXT,
                --MED.CODTAB AS MED_CODTAB,
                --MED.MEDATI AS MED_MEDATI,
                --MED.UNIMED AS MED_UNIMED,
                --MED.DESMED AS MED_DESMED,
                CLI.FILCLI||LPAD(TRIM(CLI.CODCLI),6,'0') AS PAR_CODIGO,
                CLI.FILCLI AS PAR_FILCLI,
                CLI.CODCLI AS PAR_CODCLI,
                CLI.NOMCLI AS PAR_NOMCLI,
                CLI.CODPAI AS PAR_CODPAI,
                COALESCE(CLI.NUMDOC, VIN.NUMDOC) AS PAR_NUMDOC,
                CASE WHEN CLI.TIPDOC='IE' THEN CLI.INSEST END AS PAR_INSEST,
                CLI.SUFRAM AS PAR_SUFRAM,
                CLI.FLGTIP AS PAR_FLGTIP,
                MUN.CODIBG AS MUN_CODIBG,
                ENF.FILCLI||LPAD(TRIM(ENF.CODCLI),6,'0')||ENF.CODFIL||LPAD(to_char(ENF.NUMEND),4,'0') AS ENC_CODIGO,
                ENF.FILCLI AS ENC_FILCLI,
                ENF.CODCLI AS ENC_CODCLI,
                ENF.ENDERE AS ENC_ENDERE,
                (ENF.ENDERE||' - '||ENF.NOMCID||', '||DPAI.DESPAI) AS ENC_ENDERE_ESTRAN,
                ENF.NUMERO AS ENC_NUMERO,
                ENF.COMPLE AS ENC_COMPLE,
                ENF.BAIRRO AS ENC_BAIRRO,
                ENF.CODPAI AS ENC_CODPAI,
                ENF.SIGEST AS ENC_SIGEST,
                ENF.NUMDOC AS ENC_NUMDOC,
                CASE WHEN CLI.TIPDOC='IE' THEN ENF.INSEST END AS ENC_INSEST,
                --MUE.CODIBG AS MUE_CODIBG,
                --ENE.FILCLI||LPAD(TRIM(ENE.CODCLI),6,'0')||ENE.CODFIL||LPAD(ENE.NUMEND,4,'0') AS ENE_CODIGO,
                --ENE.FILCLI AS ENE_FILCLI,
                --ENE.CODCLI AS ENE_CODCLI,
                --ENE.CODFIL AS ENE_CODFIL,
                --ENE.NUMEND AS ENE_NUMEND,
                --ENE.NUMDOC AS ENE_NUMDOC,
                --CASE WHEN CLI.TIPDOC='IE' THEN ENE.INSEST END AS ENE_INSEST,
                --ENE.CODPAI AS ENE_CODPAI,
                --ENE.SIGEST AS ENE_SIGEST,
                --MUF.CODIBG AS MUF_CODIBG,
                SUBORI.FATCON AS SUBORI_FATCON,
                MEDEMB.CODTAB AS MEDEMB_CODTAB,
                MEDEMB.MEDATI AS MEDEMB_MEDATI,
                MEDEMB.UNIMED AS MEDEMB_UNIMED,
                MEDEMB.DESMED AS MEDEMB_DESMED,
                CASE VEN.UFLOJA WHEN 'T' THEN NAT.NATDEN
                                           ELSE NAT.NATFOR
                END AS DOC_CODNAT,
                NAT.NATURE AS DOC_DESNAT,
                --NAT.TIPNAT AS NAT_TIPNAT,
                --CAST(
                --     CASE WHEN VEN.CODSER = 'CF'
                --          THEN
                --               CASE WHEN IUF.CODCFP IS NOT NULL AND CFP.VENCON IS NOT NULL
                --                    THEN '5'||CFP.VENCON
                --                    ELSE
                --                         CASE WHEN CL1.NATCL1 IS NOT NULL AND NATCL1.NATDEN IS NOT NULL
                --                              THEN NATCL1.NATDEN
                --                              ELSE
                --                                   CASE WHEN PLA.CODNAT IS NOT NULL AND NATPLA.NATDEN IS NOT NULL
                --                                        THEN NATPLA.NATDEN
                --                                        ELSE NATUREZAVENDA('T', IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)||SUBSTR(NAT.NATDEN,5,2)
                --                                   END
                --                         END
                --               END
                --          ELSE
                --               -- CFOP de NF
                --               SUBSTR(IVE.NATFIS,1,4)||SUBSTR(NAT.NATDEN,5,2)
                --      END
                -- AS CHAR(6)) AS ITE_CODNAT,
                (SELECT INAT.NATURE
                FROM TD_NAT INAT
                WHERE INAT.NATDEN=SUBSTR(IVE.NATFIS,1,4)||SUBSTR(NAT.NATDEN,5,2)
                   OR INAT.NATFOR=SUBSTR(IVE.NATFIS,1,4)||SUBSTR(NAT.NATDEN,5,2)) AS ITE_DESNAT,
                --(SELECT CASE WHEN MAX(ORI.CODFIL) IS NOT NULL THEN MAX(ORI.CODFIL) ELSE IVE.FILORI END
                --   FROM TT_VEN ORI WHERE ORI.CODFIL = VEN.CODFIL AND ORI.SEQFAT = VEN.SEQUEN
                --  GROUP BY ORI.CODFIL, ORI.SEQFAT) AS DOC_FILORI,
                --(SELECT CASE WHEN MAX(ORI.CODFIL) IS NOT NULL THEN MAX(ORI.SEQUEN) ELSE IVE.NUMORI END
                --   FROM TT_VEN ORI WHERE ORI.CODFIL = VEN.CODFIL AND ORI.SEQFAT = VEN.SEQUEN
                --  GROUP BY ORI.CODFIL, ORI.SEQFAT) AS DOC_SEQORI,
                CFG.VC_FILCLI AS CFG_VC_FILCLI,
                CFG.VC_CODCLI AS CFG_VC_CODCLI,
                TRA.FILIVE AS TRA_FILITE,
                --(SELECT MAX(LID.CONCCF)
                --   FROM TT_LID LID
                --  WHERE LID.CODFIL = VEN.CODFIL
                --    AND LID.NUMECF = VEN.NUMECF
                --    AND LID.CODSER = VEN.CODSER
                --    AND LID.CUPFIS = VEN.NUMNOT
                --    AND LID.TIPOPE = 'VEN') AS LID_CONCCF,
                --ECF.MARECF AS ECF_MARECF,
                IVE.FILMAT,
                IVE.CODMAT,
                IVE.CODCOR,
                IVE.CODTAM,
                PRO.CLASS1,
                PRO.CLASS2,
                PRO.DESMAT,
                PRO.REFBAS
           FROM TT_VEN VEN LEFT JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL
                                                AND IVE.SEQUEN = VEN.SEQUEN
                                                AND (VEN.CODSER = 'CF' OR (VEN.CODSER <> 'CF' AND IVE.SITMOV = 'N'))
                                                AND (IVE.SITKIT IN ('2','3'))
                                                AND IVE.QTDMOV <> 0
                           INNER JOIN TD_ECF ECF on VEN.CODFIL=ECF.FILECF and VEN.NUMECF=ECF.NUMECF
                           --LEFT JOIN (SELECT GRA.FILMAT, GRA.SEQUEN, GRA.CODMAT,
                           --                   GRA.CODCOR, GRA.CODTAM, GRA.CODNCM,
                           --                   GRA.UNIDAD,
                           --                   PRO.DESECF, PRO.DESMAT, PRO.ESPMAT,
                           --                   PRO.CODFPS, PRO.COD_EX, PRO.CODSRV,
                           --                   PRO.CODANP, PRO.SITIPI,
                           --                PRO.NATBCC,
                           --                   DIV.CODITE AS DIV_CODITE,
                           --                   DIV.NOMITE AS ITEDIV,
                           --                   SUB.CODITE AS SUB_CODITE,
                           --                   SUB.NOMITE AS ITESUB,
                           --                   GRA.CODEXT,
                           --                   GRA.REFPRO,
                           --                   PRO.CLASS1,
                           --                   GRA.DESGRA
                           --              FROM TT_GRA GRA INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT
                           --                                                   AND PRO.CODMAT = GRA.CODMAT
                           --                              INNER JOIN TT_DIV DIV ON GRA.CODCOR = DIV.CODITE
                           --                              INNER JOIN TT_SUB SUB ON GRA.CODTAM = SUB.CODITE) IPR
                           --              ON IPR.FILMAT = IVE.FILMAT
                           --             AND IPR.CODMAT = IVE.CODMAT
                           --             AND IPR.CODCOR = IVE.CODCOR
                           --             AND IPR.CODTAM = IVE.CODTAM
                           --LEFT JOIN TD_MED MED ON IPR.UNIDAD = MED.CODTAB
                           LEFT JOIN TD_FIL FIL ON FIL.CODFIL = VEN.CODFIL
                           --LEFT JOIN TT_IUF IUF ON FIL.UFLOJA = IUF.ESTADO AND FIL.REGESP = IUF.REGESP
                           --                     AND IPR.FILMAT = IUF.FILMAT AND IPR.CODMAT = IUF.CODMAT
                           --LEFT JOIN TD_CFP CFP ON IUF.CODCFP = CFP.CODTAB
                           --LEFT JOIN TD_ICM ICM ON IUF.RESICM = ICM.CODTAB
                           INNER JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT
                                                AND PLA.CODPGT = VEN.CODPGT
                           LEFT JOIN TD_NAT NATPLA ON NATPLA.CODTAB = PLA.CODNAT
                           --LEFT JOIN TD_CL1 CL1 ON CL1.CODTAB = IPR.CLASS1
                           --LEFT JOIN TD_NAT NATCL1 ON NATCL1.CODTAB = CL1.NATCL1
                           INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI
                                                AND CLI.CODCLI = VEN.CODCLI
                           INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
                           INNER JOIN TT_FIS FIS ON FIS.CODSER = VEN.CODSER
                                                AND FIS.SUBSER = VEN.NUMECF
                           INNER JOIN TT_PRO PRO ON PRO.FILMAT = IVE.FILMAT
                                                AND PRO.CODMAT = IVE.CODMAT
                           LEFT JOIN TT_MUN MUF ON MUF.CODIGO = FIL.CODCID
                           LEFT  JOIN TT_CLI VIN ON VIN.FILCLI = CLI.FILVIN
                                                AND VIN.CODCLI = CLI.CODVIN
                                                AND CLI.FLGTIP <> 0
                           LEFT  JOIN TT_END ENF ON ENF.FILCLI = VEN.FILCLI
                                                AND ENF.CODCLI = VEN.CODCLI
                                             AND ENF.CODFIL = COALESCE(VEN.FILFAT, VEN.FILCOB, VEN.FILENT, CLI.FILEND)
                                             AND ENF.NUMEND = COALESCE(VEN.ENDFAT, VEN.ENDCOB, VEN.ENDENT, CLI.NUMEND)
                           LEFT  JOIN TT_MUN MUN ON MUN.CODIGO = ENF.CODCID
                           LEFT  JOIN TT_END ENE ON VEN.FILCLI = ENE.FILCLI
                                                AND VEN.CODCLI = ENE.CODCLI
                                                AND VEN.FILENT = ENE.CODFIL
                                                AND VEN.ENDENT = ENE.NUMEND
                           LEFT  JOIN TT_MUN MUE ON MUE.CODIGO = ENE.CODCID
                           LEFT  JOIN TT_TRA TRA ON TRA.FILIVE = IVE.CODFIL
                                                AND TRA.SEQIVE = IVE.SEQUEN
                                                AND TRA.NUMIVE = IVE.NUMITE
                           LEFT  JOIN TT_CTA CTAVEN ON CTAVEN.CODFIL = VEN.FILCTA
                                                   AND CTAVEN.SEQUEN = VEN.SEQCTA
                                                   AND CTAVEN.TIPCTA = VEN.TIPCTA
                           LEFT  JOIN TT_SUB SUBORI ON IVE.EMBORI = SUBORI.CODITE
                           LEFT  JOIN TT_GRA GRAORI ON GRAORI.FILMAT=IVE.FILMAT
                                                   AND GRAORI.CODMAT=IVE.CODMAT
                                                   AND GRAORI.CODCOR=IVE.CODCOR
                                                   AND GRAORI.CODTAM=IVE.EMBORI
                           LEFT  JOIN TD_MED MEDEMB ON GRAORI.UNIDAD = MEDEMB.CODTAB
                           LEFT  JOIN TD_PAI DPAI   ON ENF.CODPAI = DPAI.CODPAI
                           CROSS JOIN TT_CFG CFG
          WHERE VEN.TIPTRO IN ('+','-','2')
            AND VEN.NUMNOT NOT LIKE '###%'
            AND FIS.ORIGEM = 'V'
            AND FIS.EXPORT = 'T'
            AND COALESCE(VEN.FUNRUR,0) = 0
         UNION ALL
         SELECT 'R'||COM.CODFIL||LPAD(TRIM(COM.SEQUEN),10,'0') AS DOC_CODIGO,
                COM.CODFIL AS DOC_CODFIL,
                COM.SEQUEN AS DOC_SEQUEN,
                COM.NUMNOT AS DOC_NUMNOT,
                TO_CHAR('R') AS DOC_TIPDOC,
                CASE WHEN COM.DATCMP > COM.DATOPE THEN COM.DATOPE ELSE COM.DATCMP END AS DOC_DATDOC,
                COM.DATOPE AS DOC_DATOPE,
                NULL AS DOC_DOCNFP,
                COM.VLRLIQ + COALESCE(COM.VLRBON,0) AS DOC_VLRLIQ,
                COM.DESCON AS DOC_DESCON,
                COM.VLRPIS AS DOC_VLRPIS,
                COM.VLRCOF AS DOC_VLRCOF,
                COM.VLRTOT AS DOC_VLRTOT,
                '00' AS DOC_FLGEST,
                CASE WHEN ICO.RETSUB = 'T' THEN 0 ELSE COM.BASICM END AS DOC_BASICM,
                CASE WHEN ICO.RETSUB = 'T' THEN 0 ELSE COM.VLRICM END AS DOC_VLRICM,
                COM.ISEICM AS DOC_ISEICM,
                COM.VLRIPI AS DOC_VLRIPI,
                CASE WHEN COM.CHAVEA IS NOT NULL
                      AND LENGTH(COM.CHAVEA) = 44
                     THEN COM.CHAVEA
                     ELSE NULL
                 END AS DOC_CHAVEA,
                COM.VLRFRE AS DOC_VLRFRE,
                0          AS DOC_VLRSEG,
                COM.OUTTAX AS DOC_OUTTAX,
                (SELECT SUM(ICO2.BASSUBDIF)
                   FROM TT_ICO ICO2
                  WHERE ICO2.CODFIL = COM.CODFIL
                    AND ICO2.SEQUEN = COM.SEQUEN) AS DOC_BASSUB,
                (SELECT SUM(ICO3.VLR_STDIF)
                   FROM TT_ICO ICO3
                  WHERE ICO3.CODFIL = COM.CODFIL
                    AND ICO3.SEQUEN = COM.SEQUEN) AS DOC_SUBSTT,
                COM.TIPNOT AS DOC_TIPNOT,
                TRANSLATE(Rtf2txt(replace(replace(COALESCE(COM.OBSFAT,COM.OBSERV),chr(13),''),chr(10),'')),'',' ') AS DOC_OBSFIS,
                COM.PERICM AS DOC_PERICM,
                --COM.PERFRE AS COM_PERFRE,
                --COM.CODFCE AS COM_CODFCE,
                --COM.TIPFRE AS DOC_TIPFRE,
                --COM.TIPPAR AS COM_TIPPAR,
                --COM.BASFRE AS COM_BASFRE,
                --COM.ICMFRE AS COM_ICMFRE,
                0          AS DOC_BASISS,
                COM.VLRISS AS DOC_VLRISS,
                COM.PERISS AS DOC_PERISS,
                0          AS DOC_BASIRR,
                COM.VLRIRR AS DOC_VLRIRR,
                COM.PERIRR AS DOC_PERIRR,
                0          AS DOC_VLRPIS_RET,
                0          AS DOC_VLRCOF_RET,
                --COM.CODFIL AS DOC_FILORI,
                --COM.SEQFAT AS DOC_SEQORI,
                --COM.CODFPS AS DOC_CODFPS,
                --COM.SITPIS AS DOC_SITPIS,
                --COM.SITCOF AS DOC_SITCOF,
                --COM.NATFRE AS COM_NATFRE,
                NULL       AS DOC_FLGNFE,
                CASE WHEN FIS.MODNOT <> '55' AND COM.CHAVEA IS NOT NULL THEN '55' ELSE FIS.MODNOT END AS FIS_MODNOT,
                TRIM(FIS.SEREXP) AS FIS_CODSER,
                TRIM(FIS.SUBEXP) AS FIS_SUBSER,
                'R'||ICO.CODFIL||LPAD(TRIM(ICO.SEQUEN),10,'0')||LPAD(to_char(ICO.NUMITE),5,'0') AS ITE_CODIGO,
                ICO.CODFIL AS ITE_CODFIL,
                ICO.NUMITE AS ITE_NUMITE,
                ICO.QTDMOV AS ITE_QTDMOV,
                ICO.VLRMOV AS ITE_VLRMOV,
                ICO.VLRDES AS ITE_VLRDES,
                ICO.TIPPRO AS ITE_TIPPRO,
                ICO.ICMTIP AS ITE_ICMTIP,
                CASE WHEN ICO.RETSUB = 'T' THEN 0 ELSE ICO.REDITEDIF END AS ITE_REDITE,
                0             AS ITE_CALSUB,
                ICO.VLR_STDIF AS ITE_VLR_ST,
                ICO.BASSUBDIF AS ITE_BASSUB,
                CASE WHEN ICO.RETSUB = 'T' THEN 0 ELSE ICO.ICMITEDIF END AS ITE_TAXICM,
                CASE WHEN ICO.RETSUB = 'T' THEN 0 ELSE ICO.BASICMDIF END AS ITE_BASICM,
                CASE WHEN ICO.RETSUB = 'T' THEN 0 ELSE ICO.VLRICMDIF END AS ITE_VLRICM,
                ICO.VLRIPI    AS ITE_VLRIPI,
                ICO.ISEICM AS ITE_ISEICM,
                ICO.LANEST AS ITE_LANEST,
                ICO.VLRPIS AS ITE_VLRPIS,
                ICO.VLRCOF AS ITE_VLRCOF,
                CASE COALESCE(ICO.IPIITE,0) WHEN 0 THEN
                     0 ELSE ICO.BASIPI END AS ITE_BASIPI,
                ICO.IPIITE AS ITE_TAXIPI,
                ICO.SITPIS AS ITE_SITPIS,
                ICO.BASPIS AS ITE_BASPIS,
                ICO.PERPIS AS ITE_PERPIS,
                ICO.SITCOF AS ITE_SITCOF,
                ICO.BASCOF AS ITE_BASCOF,
                ICO.PERCOF AS ITE_PERCOF,
                ICO.IPIFRE AS ITE_IPIFRE,
                ICO.ICO_VLRFRE AS ITE_VLRFRE,
                ICO.RED_STDIF AS ITE_RED_ST,
                ICO.ICMVENDIF AS ITE_ICMVEN,
                ICO.VLRMOV/NVLZ(ICO.QTDMOV,1) AS ITE_VLRUNI,
                ICO.SITMOV AS ITE_SITMOV,
                CASE WHEN ICO.RETSUB = 'T' THEN
                     CASE WHEN (FIL.REGTRI = 'S') AND (COALESCE(FIL.TRISIM,'X') <> 'O') THEN
                          COALESCE(ICO.CODORI, 0)||'500'
                     ELSE
                          COALESCE(ICO.CODORI, 0)||'60'
                     END
                ELSE
                     CASE WHEN LENGTH(TRIM(ICO.CODCSTDIF)) = 2 THEN
                          COALESCE(ICO.CODORI, 0)||ICO.CODCSTDIF
                     ELSE
                          ICO.CODCSTDIF
                     END
                END AS ITE_CODCST,
                --ICO.VLRMOV AS ICO_VLRMOV,
                --NVLZ(ICO.VLRITE, ICO.VLRMOV) AS ICO_VLRITE,
                --CASE WHEN EXISTS (SELECT 'OK' FROM TT_FUN WHERE NOMFUN = 'EXPCODVEND') THEN
                --      IPR.FILMAT||LPAD(TRIM(IPR.SEQUEN),10,'0')
                --     ELSE
                --        Cast(COALESCE(IPR.FILMAT, '')|| COALESCE(IPR.CODMAT, '')|| '-' || TRIM(COALESCE(TO_CHAR(IPR.CODCOR), ''))
                --        || '-' || TRIM(COALESCE(TO_CHAR(IPR.CODTAM),'')) as VARCHAR(21))
                --END AS PRO_CODIGO,
                --IPR.REFPRO AS PRO_REFPRO,
                --NomeProduto(IPR.DESECF, IPR.DESMAT, IPR.CODCOR, IPR.ITEDIV,
                --            IPR.CODTAM, IPR.ITESUB, IPR.ESPMAT, IPR.DESGRA) AS PRO_NOMPRO,
                --(SELECT MIN(EAN.CODEAN)
                --   FROM TT_EAN EAN
                --  WHERE EAN.FILMAT = IPR.FILMAT
                --    AND EAN.CODMAT = IPR.CODMAT
                --    AND EAN.CODCOR = IPR.CODCOR
                --    AND EAN.CODTAM = IPR.CODTAM) AS PRO_CODEAN,
                --IPR.CODFPS AS PRO_CODFPS,
                --IPR.CODNCM AS PRO_CODNCM,
                --IPR.COD_EX AS PRO_COD_EX,
                --SUBSTR(IPR.CODNCM,1,2) AS PRO_GENNCM,
                --IPR.CODSRV AS PRO_CODSRV,
                --ICM.RESICM AS PRO_PERICM,
                --IPR.CODANP AS PRO_CODANP,
                --IPR.NATBCC AS PRO_NATBCC,
                --COALESCE(ICO.SITIPI, '03') AS ITE_SITIPI,
                --IPR.CODEXT AS PRO_CODEXT,
                --MED.CODTAB AS MED_CODTAB,
                --MED.MEDATI AS MED_MEDATI,
                --MED.UNIMED AS MED_UNIMED,
                --MED.DESMED AS MED_DESMED,
                --ICO.UNICOM AS ICO_UNICOM,
                --ICO.UNIVEN AS ICO_UNIVEN,
                --ICO.QTDCOM AS ICO_QTDCOM,
                --MEDFAT.MEDATI AS MEDFAT_MEDATI,
                --MEDFAT.DESMED AS MEDFAT_DESMED,
                --MEDFAT.UNIMED AS MEDFAT_UNIMED,
                CLI.FILCLI||LPAD(TRIM(CLI.CODCLI),6,'0') AS PAR_CODIGO,
                CLI.FILCLI AS PAR_FILCLI,
                CLI.CODCLI AS PAR_CODCLI,
                CLI.NOMCLI AS PAR_NOMCLI,
                CLI.CODPAI AS PAR_CODPAI,
                COALESCE(CLI.NUMDOC, VIN.NUMDOC) AS PAR_NUMDOC,
                CASE WHEN CLI.TIPDOC='IE' THEN CLI.INSEST END AS PAR_INSEST,
                CLI.SUFRAM AS PAR_SUFRAM,
                CLI.FLGTIP AS PAR_FLGTIP,
                MUN.CODIBG AS MUN_CODIBG,
                CLI.FILCLI||LPAD(TRIM(CLI.CODCLI),6,'0')||ENDE.CODFIL||LPAD(to_char(ENDE.NUMEND),4,'0') AS ENC_CODIGO,
                ENDE.FILCLI AS ENC_FILCLI,
                ENDE.CODCLI AS ENC_CODCLI,
                ENDE.ENDERE AS ENC_ENDERE,
                (ENDE.ENDERE||' - '||ENDE.NOMCID||', '||DPAI.DESPAI) AS ENC_ENDERE_ESTRAN,
                ENDE.NUMERO AS ENC_NUMERO,
                ENDE.COMPLE AS ENC_COMPLE,
                ENDE.BAIRRO AS ENC_BAIRRO,
                ENDE.CODPAI AS ENC_CODPAI,
                ENDE.SIGEST AS ENC_SIGEST,
                ENDE.NUMDOC AS ENC_NUMDOC,
                CASE WHEN CLI.TIPDOC='IE' THEN ENDE.INSEST END AS ENC_INSEST,
                SUBORI.FATCON AS SUBORI_FATCON,
                MEDEMB.CODTAB AS MEDEMB_CODTAB,
                MEDEMB.MEDATI AS MEDEMB_MEDATI,
                MEDEMB.UNIMED AS MEDEMB_UNIMED,
                MEDEMB.DESMED AS MEDEMB_DESMED,
                --TRI.CODTRI AS TRI_CODTRI,
                CFO.CODCFO AS DOC_CODNAT,
                CFO.DESCFO AS DOC_DESNAT,
                --CASE WHEN ICO.RETSUB = 'T' THEN CFOST.CODCFO ELSE ICFO.CODCFO END AS ITE_CODNAT,
                CASE WHEN ICO.RETSUB = 'T' THEN CFOST.DESCFO ELSE ICFO.DESCFO END AS ITE_DESNAT,
                CFG.VC_FILCLI AS CFG_VC_FILCLI,
                CFG.VC_CODCLI AS CFG_VC_CODCLI,
                TRA.FILICO AS TRA_FILITE,
                ICO.FILMAT,
                ICO.CODMAT,
                ICO.CODCOR,
                ICO.CODTAM,
                PRO.CLASS1,
                PRO.CLASS2,
                PRO.DESMAT,
                PRO.REFBAS
           FROM (SELECT DISTINCT CODSER,
                        CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER,
                        SEREXP, SUBEXP, MODNOT, ORIGEM
                   FROM TT_FIS
                  WHERE ORIGEM IN ('C','F')
                    AND EXPORT = 'T') FIS
                INNER JOIN TV_CMP COM ON FIS.CODSER = COM.CODSER
                                   AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$')
                                   AND FIS.ORIGEM = CASE WHEN COALESCE(COM.TIPPAR,'F') = 'T'
                                                         THEN 'F' ELSE 'C' END
                INNER JOIN TT_CLI CLI ON CLI.FILCLI = COM.FILFOR
                                     AND CLI.CODCLI = COM.CODFOR
                INNER JOIN TD_FIL FIL ON FIL.CODFIL = COM.CODFIL
                LEFT  JOIN TD_CFO CFO ON COM.CODCFO = CFO.CODTAB
                LEFT  JOIN TT_CLI VIN ON VIN.FILCLI = CLI.FILVIN
                                     AND VIN.CODCLI = CLI.CODVIN
                                     AND CLI.FLGTIP <> 0
                LEFT  JOIN TT_END ENDE ON ENDE.FILCLI = COM.FILFOR
                                      AND ENDE.CODCLI = COM.CODFOR
                                   AND ENDE.CODFIL = COALESCE(COM.FILEND, CLI.FILEND)
                                   AND ENDE.NUMEND = COALESCE(COM.NUMEND, CLI.NUMEND)
                LEFT  JOIN TT_ICO ICO ON ICO.CODFIL = COM.CODFIL
                                     AND ICO.SEQUEN = COM.SEQUEN
                                     AND ICO.SITMOV = 'N'
                LEFT JOIN TT_TRA TRA ON ICO.CODFIL = TRA.FILICO
                                    AND ICO.SEQUEN = TRA.SEQICO
                                    AND ICO.NUMITE = TRA.NUMICO
                LEFT  JOIN TD_CFO ICFO ON ICO.CODCFO = ICFO.CODTAB
                LEFT  JOIN TT_PRO PRO ON PRO.FILMAT = ICO.FILMAT
                                     AND PRO.CODMAT = ICO.CODMAT
                --LEFT  JOIN (SELECT GRA.FILMAT, GRA.SEQUEN, GRA.CODMAT,
                --                   GRA.CODCOR, GRA.CODTAM, GRA.CODNCM,
                --                   GRA.UNIDAD,
                --                   PRO.DESECF, PRO.DESMAT, PRO.ESPMAT,
                --                   PRO.CODFPS, PRO.COD_EX, PRO.CODSRV,
                --                   PRO.CODANP, PRO.SITIPI,
                --                PRO.NATBCC,
                --                   DIV.CODITE AS DIV_CODITE,
                --                   DIV.NOMITE AS ITEDIV,
                --                   SUB.CODITE AS SUB_CODITE,
                --                   SUB.NOMITE AS ITESUB,
                --                   GRA.CODEXT,
                --                   GRA.REFPRO,
                --                   GRA.DESGRA
                --              FROM TT_GRA GRA LEFT JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT
                --                                                   AND PRO.CODMAT = GRA.CODMAT
                --                              LEFT JOIN TT_DIV DIV ON GRA.CODCOR = DIV.CODITE
                --                              LEFT JOIN TT_SUB SUB ON GRA.CODTAM = SUB.CODITE) IPR
                --                      ON IPR.FILMAT = ICO.FILMAT
                --                     AND IPR.CODMAT = ICO.CODMAT
                --                     AND IPR.CODCOR = ICO.CODCOR
                --                     AND IPR.CODTAM = ICO.CODTAM
                --LEFT  JOIN TD_MED MED ON IPR.UNIDAD = MED.CODTAB
                LEFT  JOIN TD_MED MEDFAT ON ICO.UNICOM = MEDFAT.CODTAB
                --LEFT  JOIN TT_IUF IUF ON IPR.FILMAT = IUF.FILMAT AND IPR.CODMAT = IUF.CODMAT
                --                     AND FIL.UFLOJA = IUF.ESTADO AND FIL.REGESP = IUF.REGESP
                --LEFT  JOIN TD_ICM ICM ON IUF.RESICM = ICM.CODTAB
                LEFT  JOIN TT_MUN MUN ON MUN.CODIGO = ENDE.CODCID
                LEFT  JOIN TT_SUB SUBORI ON ICO.EMBORI = SUBORI.CODITE
                LEFT  JOIN TT_GRA GRAORI ON GRAORI.FILMAT = ICO.FILMAT
                                        AND GRAORI.CODMAT = ICO.CODMAT
                                        AND GRAORI.CODCOR = ICO.CODCOR
                                        AND GRAORI.CODTAM = ICO.EMBORI
                LEFT  JOIN TD_MED MEDEMB ON GRAORI.UNIDAD = MEDEMB.CODTAB
                --LEFT  JOIN TD_TRI TRI ON COM.CODTRI = TRI.CODTAB
                LEFT  JOIN TD_PAI DPAI ON ENDE.CODPAI = DPAI.CODPAI
                LEFT  JOIN TD_CFO CFOST ON CFOST.CODCFO = CASE WHEN FIL.UFLOJA = COALESCE(COM.UFNOTA, FIL.UFLOJA) THEN '1403' ELSE '2403' END
                CROSS JOIN TT_CFG CFG
          WHERE 1=1
            AND COM.NUMNOT NOT LIKE '###%'
            AND COM.FLGEST <> 'D'
            AND NOT (COM.TIPPAR = 'T' AND COM.TIPNOT = 'F')
            AND ICO.SITMOV = 'N'
            AND FIL.REGTRI = 'N'
            AND FIL.TIPLUC = 'R'
            AND CFOPGeradorCredito(COALESCE(ICFO.CODCFO,CFO.CODCFO)) = 'T') INT
;


/*-- SEQ 2754 --*/
/*-- IGNORE ERRO --*/
DROP VIEW tv_cta_des CASCADE;

/*-- SEQ 2755 --*/
CREATE OR REPLACE VIEW tv_cta_des AS
-- Ver detalhes sobre a macro em
-- \\tt2000\Docs\desenv\depto\Manuais\Ansi\connectby.mac
SELECT codfil,sequen
FROM connectby('(select to_char(''NULL'') as filho,
                        to_char(null) as pai,
                        0 as ordem
                   from dual
                 union all
                 select TO_CHAR(chvprj) as filho,
                        coalesce(TO_CHAR(chvpai),''NULL'') as pai,
                        0 as ordem
                   from tt_ect int) tab', 'filho', 'pai','ordem', (select chvprj from tt_ect where usocta='D'), 0, '~')
AS c (conn_codigo VARCHAR, conn_codpai VARCHAR, level int, arvore text, ordem int)
INNER JOIN tt_ect t ON c.conn_codigo  = (chvprj)
where conn_codigo<>'NULL'
order by ordem
;


/*-- SEQ 2756 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CUSMEDGRU CASCADE;

/*-- SEQ 2757 --*/
CREATE OR REPLACE VIEW TV_CUSMEDGRU AS
SELECT GRU.DOCUME, GRU.NATURE, 
       GRU.DATMOV,
       GRU.TIPMOV,GRU.CODFIL, GRU.FILMAT, GRU.CODMAT, GRU.CODCOR, GRU.CODTAM,
       GRU.DATINI, GRU.DATFIM,
       TO_NUMBER(SUBSTR(GRU.CODIGO,1,10)) AS ORD_CM,
       SUBSTR(GRU.CODIGO,15,10) AS SEQUEN,
       TO_NUMBER(SUBSTR(GRU.CODIGO,25,5)) AS NUMITE,
       GRU.QTDMOV,
       CASE WHEN GRU.TIPMOV = 'V'
               THEN CASE WHEN COALESCE(IVE.SAL_CM,0)=0 OR COALESCE(IVE.SAL_CM,0) = COALESCE(IVE.TOTCMG,0)*GRU.QTDMOV THEN 0 ELSE  ROUND(IVE.TOTCMG/ROUND(IVE.SAL_CM,3),4)*GRU.QTDMOV END
            WHEN GRU.TIPMOV = 'L'
               THEN CASE WHEN COALESCE(LAN.SAL_CM,0)=0 OR COALESCE(LAN.SAL_CM,0) = COALESCE(LAN.TOTCMG,0)*GRU.QTDMOV THEN 0 ELSE  ROUND(LAN.TOTCMG/ROUND(LAN.SAL_CM,3),4)*GRU.QTDMOV END
            WHEN GRU.TIPMOV = 'A'
               THEN ACM.VLRAJU
            ELSE GRU.GER_CUSTO
       END AS GER_CUSTO,
       CASE WHEN GRU.TIPMOV = 'V' 
               THEN CASE WHEN COALESCE(IVE.SAL_CM,0)=0 OR COALESCE(IVE.SAL_CM,0) = COALESCE(IVE.TOT_CM,0)*GRU.QTDMOV THEN 0 ELSE ROUND(IVE.TOT_CM/ROUND(IVE.SAL_CM,3),4)*GRU.QTDMOV END
            WHEN GRU.TIPMOV = 'L' 
               THEN CASE WHEN COALESCE(LAN.SAL_CM,0)=0 OR COALESCE(LAN.SAL_CM,0) = COALESCE(LAN.TOT_CM,0)*GRU.QTDMOV THEN 0 ELSE ROUND(LAN.TOT_CM/ROUND(LAN.SAL_CM,3),4)*GRU.QTDMOV END
            WHEN GRU.TIPMOV = 'A' 
               THEN ACM.VLRAJU
            ELSE GRU.FIS_CUSTO
       END AS FIS_CUSTO,
       CASE WHEN GRU.TIPMOV = 'V' 
               THEN CASE WHEN COALESCE(IVE.SAL_CM,0)=0 OR COALESCE(IVE.SAL_CM,0) = COALESCE(IVE.TOTCMG,0) THEN 0 ELSE  ROUND(IVE.TOTCMG/ROUND(IVE.SAL_CM,3),4) END
            WHEN GRU.TIPMOV = 'L' 
               THEN CASE WHEN COALESCE(LAN.SAL_CM,0)=0 OR COALESCE(LAN.SAL_CM,0) = COALESCE(LAN.TOTCMG,0) THEN 0 ELSE  ROUND(LAN.TOTCMG/ROUND(LAN.SAL_CM,3),4) END
            WHEN GRU.TIPMOV = 'A' 
               THEN CASE WHEN COALESCE(ACM.SAL_CM,0)=0 OR COALESCE(ACM.SAL_CM,0) = COALESCE(ACM.TOTCMG,0) THEN 0 ELSE  ROUND(ACM.TOTCMG/ROUND(ACM.SAL_CM,3),4) END
            ELSE GRU.GER_CUSTO_UNI
       END AS GER_CUSTO_UNI,
       CASE WHEN GRU.TIPMOV = 'V' 
               THEN CASE WHEN COALESCE(IVE.SAL_CM,0)=0 OR COALESCE(IVE.SAL_CM,0) = COALESCE(IVE.TOT_CM,0) THEN 0 ELSE ROUND(IVE.TOT_CM/ROUND(IVE.SAL_CM,3),4) END
            WHEN GRU.TIPMOV = 'L' 
               THEN CASE WHEN COALESCE(LAN.SAL_CM,0)=0 OR COALESCE(LAN.SAL_CM,0) = COALESCE(LAN.TOT_CM,0) THEN 0 ELSE ROUND(LAN.TOT_CM/ROUND(LAN.SAL_CM,3),4) END
            WHEN GRU.TIPMOV = 'A' 
               THEN CASE WHEN COALESCE(ACM.SAL_CM,0)=0 OR COALESCE(ACM.SAL_CM,0) = COALESCE(ACM.TOT_CM,0) THEN 0 ELSE ROUND(ACM.TOT_CM/ROUND(ACM.SAL_CM,3),4) END
            ELSE GRU.FIS_CUSTO_UNI
       END AS FIS_CUSTO_UNI,
       CASE WHEN GRU.TIPMOV = 'V' 
               THEN IVE.TOTCMG
            WHEN GRU.TIPMOV = 'L' 
               THEN LAN.TOTCMG
            WHEN GRU.TIPMOV = 'A' 
               THEN ACM.TOTCMG
            ELSE GRU.GER_FINANC
       END AS GER_FINANC,
       CASE WHEN GRU.TIPMOV = 'V' 
               THEN IVE.TOT_CM
            WHEN GRU.TIPMOV = 'L' 
               THEN LAN.TOT_CM
            WHEN GRU.TIPMOV = 'A' 
               THEN ACM.TOT_CM
            ELSE GRU.FIS_FINANC
       END AS FIS_FINANC,
       CASE WHEN GRU.TIPMOV = 'V' 
               THEN IVE.SAL_CM
            WHEN GRU.TIPMOV = 'L' 
               THEN LAN.SAL_CM
            WHEN GRU.TIPMOV = 'A' 
               THEN ACM.SAL_CM
            ELSE GRU.SAL_CM
       END AS SAL_CM,
       CASE WHEN GRU.TIPMOV = 'V' 
               THEN IVE.VLRMOV
            WHEN GRU.TIPMOV = 'L' 
               THEN LAN.VLRMOV
            WHEN GRU.TIPMOV = 'A' 
               THEN ACM.VLRAJU
            ELSE GRU.VLRMOV
       END AS VLRMOV,
       GRU.DATMOV AS DATFIS,
       CAST(NULL AS CHAR(2)) AS CODSER
FROM (SELECT MAX(LPAD(TO_CHAR(COALESCE(CM.ORD_CM,0)),10,' ')||CM.TIPMOV||CM.CODFIL||CM.SEQUEN||LPAD(TO_CHAR(COALESCE(CM.NUMITE,0)),5,' ')) AS CODIGO,
             CASE CM.TIPMOV WHEN 'C' THEN CM.DOCUME
                            WHEN 'I' THEN CM.DOCUME
                            WHEN 'N' THEN CM.DOCUME
                                     ELSE NULL
             END AS DOCUME,
             INITCAP(LOWER(CM.NATURE)) AS NATURE,
             CASE WHEN CM.CODSER IN ('CF','TK') THEN TRUNC(CM.DATFIS) 
                                                ELSE TRUNC(CM.DATMOV) 
             END AS DATMOV,
             CM.TIPMOV, CM.CODFIL,CM.FILMAT,CM.CODMAT,CM.CODCOR,CM.CODTAM, 
             INI.DATOPE AS DATINI, FIM.DATOPE AS DATFIM,
             SUM(QTDMOV) AS QTDMOV, 
             MIN(GER_CUSTO) AS GER_CUSTO,
             MIN(FIS_CUSTO) AS FIS_CUSTO,
             MIN(GER_CUSTO_UNI) AS GER_CUSTO_UNI,
             MIN(FIS_CUSTO_UNI) AS FIS_CUSTO_UNI,             
             MAX(GER_FINANC) AS GER_FINANC,
             MAX(FIS_FINANC) AS FIS_FINANC,
             MAX(SAL_CM) AS SAL_CM,
             MIN(VLRMOV) AS VLRMOV
      FROM TV_CUSMED CM, TT_DAT INI, TT_DAT FIM
      --COLOCA UM DIA A MAIS ANTES E DEPOIS PARA FILTRAR NO CASE ABAIXO (NECESARIO PARA UTILIZAR INDICE)
      WHERE CM.DATMOV >= ADD_DAY(INI.DATOPE,-1)
        AND CM.DATMOV <  ADD_DAY(FIM.DATOPE,2)
        AND CASE WHEN CM.CODSER IN ('CF','TK') THEN 
             CASE WHEN CM.DATFIS >= INI.DATOPE AND 
                       CM.DATFIS < ADD_DAY(FIM.DATOPE,1)
                  THEN 1
                  ELSE 0
             END 
        ELSE
             CASE WHEN CM.DATMOV >= INI.DATOPE AND 
                       CM.DATMOV < ADD_DAY(FIM.DATOPE,1)
                  THEN 1
                  ELSE 0
             END 
        END = 1
        GROUP BY INI.DATOPE, FIM.DATOPE,
                 CASE WHEN CM.CODSER IN ('CF','TK') THEN TRUNC(CM.DATFIS) 
                                                ELSE TRUNC(CM.DATMOV) 
                 END , 
                 CM.CODFIL,CM.FILMAT,CM.CODMAT,CM.CODCOR,CM.CODTAM, INITCAP(LOWER(CM.NATURE)), CM.TIPMOV,
                 CASE CM.TIPMOV WHEN 'C' THEN CM.DOCUME
                                WHEN 'I' THEN CM.DOCUME
                                WHEN 'N' THEN CM.DOCUME
                                         ELSE NULL
                 END) GRU LEFT JOIN TT_IVE IVE ON GRU.TIPMOV ='V'
                                              AND IVE.CODFIL = SUBSTR(GRU.CODIGO,12,3)
                                              AND IVE.SEQUEN = SUBSTR(GRU.CODIGO,15,10)
                                              AND IVE.NUMITE = TO_NUMBER(COALESCE(SUBSTR(GRU.CODIGO,25,5),'0')) 
                          LEFT JOIN TT_LAN LAN ON GRU.TIPMOV ='L' 
                                              AND LAN.CODFIL = SUBSTR(GRU.CODIGO,12,3)
                                              AND LAN.SEQUEN = SUBSTR(GRU.CODIGO,15,10)
                          LEFT JOIN TT_ACM ACM ON GRU.TIPMOV ='A' 
                                              AND ACM.CODFIL = SUBSTR(GRU.CODIGO,12,3)
                                              AND ACM.SEQUEN = SUBSTR(GRU.CODIGO,15,10)
;


/*-- SEQ 2758 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_DEV_ST CASCADE;

/*-- SEQ 2759 --*/
CREATE OR REPLACE VIEW TV_DEV_ST AS
SELECT TAB.CODFIL, -- AS "FILIAL", 
       TAB.NUMNOT_DEV, -- AS "NF DEV", 
       TAB.DATHOR, -- AS "DATA DE EMISSO",
       TAB.NOMPRO, -- AS "PRODUTO",
       TAB.REFPRO, -- AS "REFERENCIA",
       TAB.QTDDEV, -- AS "QUANTIDADE DEVOLVIDA",
       TAB.VLRICM, -- AS "ICMS DESTACADO", 
       TAB.NOTORI, -- AS "NF ORIGEM", 
       TAB.DATOPE, -- AS "DATA DE LANAMENTO", 
       TAB.VLR_ST, -- AS "ICMS-ST DESTACADO", 
       TAB.RET_ST, -- AS "ICMS-ST RETIDO"
       TAB.SEQUEN,
       TAB.FILCLI,
       TAB.CODCLI,
       TAB.NUMITE
FROM (
SELECT ROUND((SELECT MAX(ICO.VLR_ST/ICO.QTDMOV) 
          FROM TT_COM COM INNER JOIN TT_ICO ICO ON COM.CODFIL=ICO.CODFIL AND COM.SEQUEN=ICO.SEQUEN
         WHERE COM.FILFOR=VEN.FILCLI 
           AND COM.CODFOR=VEN.CODCLI 
           AND COALESCE(COM.FINNFE,'0') <> '2'--Desconsidera nota complementar
           AND INSTR(VEN.OBSFIS, 'Nota Origem:'||TRIM(COM.NUMNOT))>0
           AND ICO.FILMAT=IVE.FILMAT 
           AND ICO.CODMAT=IVE.CODMAT 
           AND ICO.CODCOR=IVE.CODCOR 
           AND ICO.CODTAM=IVE.CODTAM
       )*IVE.QTDMOV,2) AS VLR_ST,
       ROUND((SELECT MAX(ICO_VLRRET/ICO.QTDMOV) 
          FROM TT_COM COM INNER JOIN TT_ICO ICO ON COM.CODFIL=ICO.CODFIL AND COM.SEQUEN=ICO.SEQUEN
         WHERE COM.FILFOR=VEN.FILCLI 
           AND COM.CODFOR=VEN.CODCLI 
           AND COALESCE(COM.FINNFE,'0') <> '2'--Desconsidera nota complementar
           AND INSTR(VEN.OBSFIS, 'Nota Origem:'||TRIM(COM.NUMNOT))>0
           AND ICO.FILMAT=IVE.FILMAT 
           AND ICO.CODMAT=IVE.CODMAT 
           AND ICO.CODCOR=IVE.CODCOR 
           AND ICO.CODTAM=IVE.CODTAM
       )*IVE.QTDMOV,2) AS RET_ST,
       ROUND((SELECT MAX(CASE WHEN NVLZ(ICO.ICO_VLRRET,ICO.VLR_ST) >0 THEN ICO.VLRICM/ICO.QTDMOV END) 
          FROM TT_COM COM INNER JOIN TT_ICO ICO ON COM.CODFIL=ICO.CODFIL AND COM.SEQUEN=ICO.SEQUEN
         WHERE COM.FILFOR=VEN.FILCLI 
           AND COM.CODFOR=VEN.CODCLI 
           AND COALESCE(COM.FINNFE,'0') <> '2'--Desconsidera nota complementar
           AND INSTR(VEN.OBSFIS, 'Nota Origem:'||TRIM(COM.NUMNOT))>0
           AND ICO.FILMAT=IVE.FILMAT 
           AND ICO.CODMAT=IVE.CODMAT 
           AND ICO.CODCOR=IVE.CODCOR 
           AND ICO.CODTAM=IVE.CODTAM
       )*IVE.QTDMOV,2) AS VLRICM,
       (SELECT MAX(COM_DATOPE) 
          FROM TT_COM COM INNER JOIN TT_ICO ICO ON COM.CODFIL=ICO.CODFIL AND COM.SEQUEN=ICO.SEQUEN
         WHERE COM.FILFOR=VEN.FILCLI 
           AND COM.CODFOR=VEN.CODCLI 
           AND COALESCE(COM.FINNFE,'0') <> '2'--Desconsidera nota complementar
           AND INSTR(VEN.OBSFIS, 'Nota Origem:'||TRIM(COM.NUMNOT))>0
           AND ICO.FILMAT=IVE.FILMAT 
           AND ICO.CODMAT=IVE.CODMAT 
           AND ICO.CODCOR=IVE.CODCOR 
           AND ICO.CODTAM=IVE.CODTAM
       ) AS DATOPE,
       VEN.CODFIL, VEN.SEQUEN, VEN.FILCLI, VEN.CODCLI, IVE.NUMITE, IVE.QTDMOV,  IVE.FILMAT, IVE.CODMAT,
       CAST(SUBSTR(VEN.OBSFIS,INSTR(UPPER(OBSFIS),'NOTA ORIGEM:')+12,INSTR(UPPER(OBSFIS),'DATA:')-INSTR(UPPER(OBSFIS),'NOTA ORIGEM:')-13) AS VARCHAR(8)) AS NOTORI,
       VEN.OBSFIS,
       VEN.NUMNOT AS NUMNOT_DEV,
       VEN.DATHOR,
       IPR.NOMPRO, IPR.REFPRO, IVE.QTDMOV AS QTDDEV
   FROM TD_NAT NAT INNER JOIN TT_VEN VEN ON VEN.CODNAT=NAT.CODTAB
                   INNER JOIN TT_IVE IVE ON IVE.CODFIL=VEN.CODFIL
                                        AND IVE.SEQUEN=VEN.SEQUEN
                   INNER JOIN TV_IPR IPR ON IVE.FILMAT=IPR.FILMAT
                                        AND IVE.CODMAT=IPR.CODMAT
                                        AND IVE.CODCOR=IPR.CODCOR
                                        AND IVE.CODTAM=IPR.CODTAM
  WHERE NAT.TIPNAT = 'M'
    AND IVE.SITMOV <> 'C' ) TAB
 WHERE NVLZ(VLR_ST,RET_ST)>0
 ;


/*-- SEQ 2760 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ECAI CASCADE;

/*-- SEQ 2761 --*/
CREATE OR REPLACE VIEW TV_ECAI AS
    SELECT CAI.CODFIL, CAI.SEQUEN, CAI.SEQCAI, CAI.CODSER, CAI.ORIGEM, CAI.CODCAI,
           CAI.MEIO_P, CAI.MEIO_P_REDUZ, CAI.VLRLAN,
           CAST(CASE CAI.ORIGEM WHEN '1' THEN 'VENDA'
                                WHEN '2' THEN 'RECEBIMENTO'
                                WHEN '3' THEN 'SANGRIA'
                                WHEN '4' THEN 'REFORÇO'
                                WHEN '5' THEN 'DEPÓSITO C/C'
                                WHEN '6' THEN 'RERITADA C/C'
                                WHEN '7' THEN 'RECEBIMENTO DE DEVOLUÇÃO'
                                WHEN '8' THEN 'DEVOLUÇÃO DE VENDAS'
                                WHEN '9' THEN 'DIFERENÇA'
                                ELSE 'OUTRO'
           END AS VARCHAR(25)) AS NOMEORIGEM,
           DCAI.CX_DES
      FROM TV_CAI CAI LEFT OUTER JOIN TD_CAI DCAI ON CAI.CODCAI = DCAI.CODTAB  
 ;


/*-- SEQ 2762 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ECLI CASCADE;

/*-- SEQ 2763 --*/
CREATE OR REPLACE VIEW TV_ECLI AS
SELECT * FROM TV_EXPCLI;


/*-- SEQ 2764 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ECNT_EXP CASCADE;

/*-- SEQ 2765 --*/
CREATE OR REPLACE VIEW TV_ECNT_EXP AS
SELECT CLI.*
  FROM TV_ECNT CLI INNER JOIN TD_EXP DEXP ON DEXP.CODTAB = 1
 WHERE (CLI.FILCLI||CLI.CODCLI <> (SELECT VC_FILCLI||VC_CODCLI FROM TT_CFG));


/*-- SEQ 2766 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ECOM_EXP CASCADE;

/*-- SEQ 2767 --*/
CREATE OR REPLACE VIEW TV_ECOM_EXP AS
SELECT COM.*
  FROM TV_ECOM COM INNER JOIN TD_EXP DEXP ON DEXP.CODTAB = 1                  
WHERE COM.ATU_EM BETWEEN TO_DATE(TO_CHAR(TRUNC(DEXP.DATINI),'DD/MM/YYYY')||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                         TO_DATE(TO_CHAR(TRUNC(DEXP.DATFIM),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');


/*-- SEQ 2768 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ECON CASCADE;

/*-- SEQ 2769 --*/
CREATE OR REPLACE VIEW TV_ECON AS
select *
    from (
SELECT CAST(
       CAST(TO_CHAR(DATLAN,'DDMMYYYY') AS CHAR(8))||';'|| -- DAT
       LPAD(COALESCE(TRIM(CASE WHEN (SUM(VLRLAN)>0 AND MIN(TIPCTA)='N') OR
                                              (SUM(VLRLAN)<0 AND MIN(TIPCTA)='G') THEN
                                              CODCTA --INVERTE CONTAS
                                         ELSE CODCRT
                                    END),'0'),7,'0')||';'|| -- CONTRA-PARTIDA
       LPAD(COALESCE(TRIM(CASE WHEN (SUM(VLRLAN)>0 AND MIN(TIPCTA)='N') OR
                                      (SUM(VLRLAN)<0 AND MIN(TIPCTA)='G') THEN
                                      CODCRT --INVERTE CONTAS
                                 ELSE CODCTA
                            END),'0'),7,'0')||';'|| -- CONTA
       CAST(TRIM(TO_CHAR(ABS(SUM(VLRLAN))*100,'0000000000009')) AS CHAR(13))||';'|| -- VALOR
       CAST('000' AS CHAR(3))||';'|| -- CODIGO DE HISTORICO
       RPAD(CASE WHEN MAX(CONSUMIDOR) = 'F' and AGRUPA='F'
                      THEN MAX(NOMCLI)||
                           CASE WHEN ISNULL( REPLACE( REPLACE(TRIM(COALESCE(MIN(OBSERV),'')), CHR(10), '' ), CHR(13), '' )) = 'T'
                                THEN ''
                                ELSE ' ('||REPLACE(COALESCE(MIN(OBSERV),''), CHR(10), ' - ')||')'
                           END||' - '||MAX(DESCTA)||' '
                 WHEN AGRUPA = 'F' AND ISNULL( REPLACE( REPLACE(TRIM(COALESCE(MIN(OBSERV),'')), CHR(10), '' ), CHR(13), '' )) = 'F'
                      THEN REPLACE(COALESCE(MIN(OBSERV),''), CHR(10), ' - ')
                 WHEN MIN(DESCTA) IS NOT NULL
                      THEN MIN(CASE DESCTA WHEN 'Receita de Vendas (CF)' THEN 
                                CASE WHEN CTAREC=CODCRT THEN 'Receita de Vendas a Prazo (CF)' ELSE 'Receita de Vendas a Vista (CF)' END
                                ELSE DESCTA
                           END)
                 WHEN TIPDIF IS NOT NULL AND ORIGEM='CCC' THEN TIPDIF
                 WHEN MIN(TITCRT)=MAX(TITCRT) THEN MIN(TITCRT)
                 WHEN MIN(TITCTA)=MAX(TITCTA) THEN MIN(TITCTA)
                 WHEN TIPDIF IS NOT NULL AND ORIGEM='FIN' THEN TIPDIF
                 ELSE ''
            END ||
                 CASE WHEN AGRUPA = 'T' OR ISNULL(TRIM(MIN(DOCUME)))='T'
                      THEN ''
                      ELSE '(' || COALESCE(MIN(DOCUME),'') || ')'
                 END, 350, ' ')||';'|| -- HISTORICO
       RPAD(COALESCE(CASE WHEN AGRUPA = 'T'
            THEN ''
            ELSE COALESCE(MIN(DOCUME),'')
       END,' '), 15, ' ')||';'|| -- DOCUMENTO
       CAST('00000' AS CHAR(5))||';'|| -- NIVEL DE LANAMENTO
       CAST(substr(COALESCE(trim(CODEXT),RPAD(to_char(to_number(FILORI)), 2, ' ')),1,2) AS CHAR(2))
       AS CHAR(418)) AS LINHA,
       SUM(VLRLAN) AS VLRLAN,
       AGRUPA, ORIGEM, FILORI AS CODFIL, CODEXT, DATLAN, CODCTA, CODCRT, EXC_MULREC       
  FROM tv_expcon I2 
           WHERE CODCTA <> CODCRT
GROUP BY CASE WHEN AGRUPA = 'T'
              THEN CAST(LPAD('', 20, 'X') AS CHAR(20))
              ELSE ORIGEM || CODFIL || SEQUEN || NUMPAR || SUBPAR
         END,
         AGRUPA, ORIGEM, FILORI, CODEXT, DATLAN, CODCTA, CODCRT, EXC_MULREC, CTAREC, TIPDIF
  HAVING SUM(VLRLAN)<>0
) TAB
where EXC_MULREC='F';


/*-- SEQ 2770 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ECON_INT CASCADE;

/*-- SEQ 2771 --*/
CREATE OR REPLACE VIEW TV_ECON_INT AS
select *
    from (
SELECT VCON.DATLAN, -- DATA
       COALESCE(TRIM(CASE WHEN (VCON.VLRLAN>0 AND VCON.TIPCTA='N') OR
                               (VCON.VLRLAN<0 AND VCON.TIPCTA='G') 
                          THEN VCON.CODCTA --INVERTE CONTAS
                          ELSE VCON.CODCRT
                     END),'0') AS CRT_CODEXT, -- CONTRA-PARTIDA
       COALESCE(TRIM(CASE WHEN (VCON.VLRLAN>0 AND VCON.TIPCTA='N') OR
                               (VCON.VLRLAN<0 AND VCON.TIPCTA='G') 
                          THEN VCON.CODCRT --INVERTE CONTAS
                          ELSE VCON.CODCTA
                     END),'0') AS CTA_CODEXT, -- CONTA
       VCON.VLRLAN, -- VALOR
       CAST(0 AS Numeric(3)) AS CODHIS, -- CODIGO DE HISTORICO
       CASE WHEN VCON.CONSUMIDOR = 'F' and VCON.AGRUPA='F'
                 THEN VCON.NOMCLI||
                      CASE WHEN ISNULL( REPLACE( REPLACE(TRIM(COALESCE(VCON.OBSERV,'')), CHR(10), '' ), CHR(13), '' )) = 'T'
                           THEN ''
                           ELSE ' ('||REPLACE(COALESCE(VCON.OBSERV,''), CHR(10), ' - ')||')'
                      END||' - '||VCON.DESCTA||' '
            WHEN VCON.AGRUPA = 'F' AND ISNULL( REPLACE( REPLACE(TRIM(COALESCE(VCON.OBSERV,'')), CHR(10), '' ), CHR(13), '' )) = 'F'
                 THEN REPLACE(COALESCE(VCON.OBSERV,''), CHR(10), ' - ')
            WHEN VCON.DESCTA IS NOT NULL
                 THEN CASE VCON.DESCTA WHEN 'Receita de Vendas (CF)' THEN 
                           CASE WHEN VCON.CTAREC=VCON.CODCRT THEN 'Receita de Vendas a Prazo (CF)' ELSE 'Receita de Vendas a Vista (CF)' END
                           ELSE VCON.DESCTA
                      END
            WHEN VCON.TIPDIF IS NOT NULL AND VCON.ORIGEM='CCC' THEN VCON.TIPDIF
            WHEN VCON.TITCRT IS NOT NULL THEN VCON.TITCRT
            WHEN VCON.TITCTA IS NOT NULL THEN VCON.TITCTA
            WHEN VCON.TIPDIF IS NOT NULL AND VCON.ORIGEM='FIN' THEN VCON.TIPDIF
            ELSE ''
       END ||
            CASE WHEN VCON.AGRUPA = 'T' OR ISNULL(TRIM(VCON.DOCUME))='T'
                 THEN ''
                 ELSE '(' || COALESCE(VCON.DOCUME,'') || ')'
            END AS DESHIS, -- HISTORICO
       COALESCE(CASE WHEN VCON.AGRUPA = 'T'
                     THEN ''
                     ELSE COALESCE(VCON.DOCUME,'')
                END,' ') AS DOCUME, -- DOCUMENTO
       CAST(0 AS Numeric(5)) AS NIVLAN, -- NIVEL DE LANAMENTO
       substr(COALESCE(trim(VCON.CODEXT),RPAD(to_char(to_number(VCON.FILORI)), 2, ' ')),1,2)  AS FIL_CODEXT, -- CODIGO DA EMPRESA
       VCON.AGRUPA, VCON.ORIGEM, VCON.FILORI AS CODFIL, VCON.CODEXT, VCON.CODCTA, VCON.CODCRT, VCON.EXC_MULREC,
       CASE WHEN VCON.AGRUPA = 'T'
              THEN CAST(LPAD('', 20, 'X') AS CHAR(20))
              ELSE VCON.ORIGEM || VCON.CODFIL || VCON.SEQUEN || VCON.NUMPAR || VCON.SUBPAR
         END AS CHAVE_CONTA,
       VCON.RFIN_CODTAB,
       VCON.TIPCTA,
       VCON.TIPCRT,
       VCON.FILDES
  FROM TV_EXPCON VCON 
 WHERE coalesce(VCON.CODCTA,'X') <> COALESCE(VCON.CODCRT,'Y')
) TAB
;


/*-- SEQ 2772 --*/
/*-- IGNORE ERRO --*/
DROP VIEW tv_ect_rec CASCADE;

/*-- SEQ 2773 --*/
CREATE OR REPLACE VIEW tv_ect_rec AS
-- Ver detalhes sobre a macro em
-- \\tt2000\Docs\desenv\depto\Manuais\Ansi\connectby.mac
SELECT codfil,sequen
FROM connectby('(select to_char(''NULL'') as filho,
                        to_char(null) as pai,
                        0 as ordem
                   from dual
                 union all
                 select TO_CHAR(chvprj) as filho,
                        coalesce(TO_CHAR(chvpai),''NULL'') as pai,
                        0 as ordem
                   from tt_ect int) tab', 'filho', 'pai','ordem', (select chvprj from tt_ect where usocta='R'), 0, '~')
AS c (conn_codigo VARCHAR, conn_codpai VARCHAR, level int, arvore text, ordem int)
INNER JOIN tt_ect t ON c.conn_codigo  = (chvprj)
where conn_codigo<>'NULL'
order by ordem
;


/*-- SEQ 2774 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EDOP_EXP CASCADE;

/*-- SEQ 2775 --*/
CREATE OR REPLACE VIEW TV_EDOP_EXP AS
SELECT DOP.*
  FROM TV_EDOP DOP INNER JOIN TD_EXP DEXP ON DEXP.CODTAB = 1
 WHERE DOP.PAG_ATU_EM BETWEEN TO_DATE(TO_CHAR(TRUNC(DEXP.DATINI),'DD/MM/YYYY')||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                              TO_DATE(TO_CHAR(TRUNC(DEXP.DATFIM),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');


/*-- SEQ 2776 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EEND_EXP CASCADE;

/*-- SEQ 2777 --*/
CREATE OR REPLACE VIEW TV_EEND_EXP AS
SELECT ENDE.*
FROM TV_EEND ENDE INNER JOIN TD_EXP DEXP ON DEXP.CODTAB = 1
WHERE (ENDE.FILCLI||ENDE.CODCLI <> (SELECT VC_FILCLI||VC_CODCLI FROM TT_CFG));


/*-- SEQ 2778 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EICO CASCADE;

/*-- SEQ 2779 --*/
CREATE OR REPLACE VIEW TV_EICO AS
SELECT COM.CODFIL, COM.SEQUEN, COM.NUMNOT, COM.CODSER, CLI.CODEXT AS CODFOR, ICO.NUMITE,
       COALESCE(ICO.BASICMDIF,0) AS BASICM, DCFO.CODCFO, GRA.CODEXT AS CODMAT,
       DMOE.DESMOE AS CODMOE, COALESCE(ICO.CUSFRE,0) AS CUSFRE, COALESCE(ICO.FREFIS,0) AS FREFIS,
       COALESCE(ICO.ICMITEDIF,0) AS ICMITE, COALESCE(ICO.IPIITE,0) AS IPIITE,
       COALESCE(ICO.ISEICMDIF,0) AS ISEICM, COALESCE(ICO.OUTICMDIF,0) AS OUTICM,
       ICO.QTDMOV, ICO.SITMOV, ICO.TIPPRO, ICO.UNICOM, ICO.UNIVEN,
       ICO.VALCON, COALESCE(ICO.VLRICMDIF,0) AS VLRICM, COALESCE(ICO.VLRMOV,0) AS VLRMOV,
       ICO.LANEST,
       /*CASE WHEN VEN.SEQUEN IS NOT NULL THEN -- Transferencia
           CASE WHEN COM.DATOPE < COM.DATCMP
                THEN COM.DATCMP -- Entradas com a configuracao TRAORI="T" possuem DATOPE < DATCMP
                ELSE COM.DATOPE
           END
       ELSE
           COM.DATOPE
       END*/ COM.DATOPE AS COM_DATOPE,
       ICO.QTDCOM, ICO.DATANT, ICO.CUSANT, ICO.CUSREP,
       ICO.PERLUC, ICO.PREANT, ICO.PREATU, ICO.VLRCAL, ICO.EMBORI,
       ICO.EMBQTD, ICO.CODBUS, DMUL.DESMUL AS CODMUL, ICO.ORD_CM, ICO.QTD_CM,
       ICO.DATINC, 0 AS STATUS, TO_CHAR(' ') AS DATIMP,TO_CHAR(' ') AS MOTREJ,
       CAST(LPAD(COALESCE(ICO.SITIPI, '03'),2,'0') AS CHAR(2)) AS SITIPI,
       ICO.BASIPI, ICO.VLRIPI,
       -- RFMP 94119 CSTs sao ajustados com as mesmas regras do SPED
       CAST(CASE WHEN ICO.RETSUB = 'T' THEN
                 CASE WHEN (DFIL.REGTRI = 'S') AND (COALESCE(DFIL.TRISIM,'X') <> 'O') THEN
                      '500'
                 ELSE
                    COALESCE(ICO.CODORI, 0)||'60'
                 END
            ELSE
                 CASE WHEN LENGTH(TRIM(ICO.CODCSTDIF)) = 2 THEN
                      COALESCE(ICO.CODORI, 0)||LPAD(TRIM(ICO.CODCSTDIF),2,'0')
                 ELSE
                      LPAD(TRIM(ICO.CODCSTDIF),3,'0')
                 END
            END AS CHAR(3)) AS CODCST,
       ICO.ICMITEDIF AS TAXICM, ICO.VLRITE, PRO.DESMAT, MED.UNIMED,
       DFIL.REGTRI AS SIMPLE, ICO.CODORI, COM.ATU_EM,
       CASE WHEN ICO.CODCST = '51' THEN ICO.VLRICMDIF ELSE 0 END AS ICMDIF,
       CAST(LPAD(COALESCE(ICO.SITPIS, '98'),2,'0') AS CHAR(2)) AS SITPIS,
       ICO.VLRPIS, ICO.BASPIS, ICO.PERPIS,
       CAST(LPAD(COALESCE(ICO.SITCOF, '98'),2,'0') AS CHAR(2)) AS SITCOF,
       ICO.VLRCOF, ICO.BASCOF, ICO.PERCOF,
       BASSUBDIF AS BASSUB,
       VLR_STDIF AS VLR_ST,
       RED_STDIF AS RED_ST,
       (COALESCE(ICO.VLRMOV,0) / NVLZ(ICO.QTDMOV,1)) as VLRUNI,
       ICO.ICMTIP, COALESCE(ICO.ICO_VLRFRE,0) AS ICO_VLRFRE, COALESCE(ICO.ICO_OUTTAX,0) AS ICO_OUTTAX,
       PRO.REFBAS, GRA.REFPRO, GRA.CODFIS, GRA.FILMAT AS GRA_FILMAT, GRA.CODMAT AS GRA_CODMAT,
       GRA.CODCOR AS GRA_CODCOR, GRA.CODTAM AS GRA_CODTAM, NCM.CODEXT AS NCM_CODEXT,
       ICO.FILLOT, ICO.SEQLOT, ICO.EXPFIS,
       CAST(CASE WHEN LENGTH(TRIM(ICO.CSTXML)) = 2 THEN
                 COALESCE(ICO.CODORI, 0)||LPAD(TRIM(ICO.CSTXML),2,'0')
            ELSE
                 LPAD(TRIM(ICO.CSTXML),3,'0')
            END AS CHAR(3)) AS CSTXML,
       ICO.BASFCP,
       ICO.PERFCP,
       ICO.VLRFCP,
       ICO.BASFCP_ST,
       ICO.PERFCP_ST,
       ICO.VLRFCP_ST,
       ICO.BASFCP_RET,
       ICO.PERFCP_RET,
       ICO.VLRFCP_RET
  FROM TT_COM COM INNER JOIN TT_ICO ICO ON ICO.CODFIL = COM.CODFIL AND ICO.SEQUEN = COM.SEQUEN
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = ICO.FILMAT AND GRA.CODMAT = ICO.CODMAT
                                       AND GRA.CODCOR = ICO.CODCOR AND GRA.CODTAM = ICO.CODTAM
                  INNER JOIN TD_FIL DFIL ON DFIL.CODFIL = COM.CODFIL
                  INNER JOIN TD_MED MED ON MED.CODTAB = GRA.UNIDAD
                  INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = COM.FILFOR AND CLI.CODCLI = COM.CODFOR
                  INNER JOIN TD_MUL DMUL ON DMUL.CODTAB = ICO.CODMUL
                   LEFT JOIN TD_CFO DCFO ON DCFO.CODTAB = ICO.CODCFO
                  INNER JOIN TD_MOE DMOE ON DMOE.CODTAB = ICO.CODMOE
                   LEFT JOIN TT_NCM NCM ON PRO.CODNCM = NCM.CODNCM
                   LEFT JOIN TT_VEN VEN  ON VEN.CODFIL = COM.FILFOR
                                        AND VEN.NUMECF = COM.SUBSER
                                        AND VEN.CODSER = COM.CODSER
                                        AND VEN.NUMNOT = SUBSTR(COM.NUMNOT,3)
                                        AND VEN.FILCLI = COM.CODFIL
                                        AND VEN.CODCLI = COM.CODFOR
 WHERE COM.NUMNOT NOT LIKE '%#%';


/*-- SEQ 2780 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EICO_FIS CASCADE;

/*-- SEQ 2781 --*/
CREATE OR REPLACE VIEW TV_EICO_FIS AS
SELECT COM.CODFIL,
       COM.SEQUEN,
       COM.NUMNOT,
       COM.CODSER,
       COM.DATOPE AS COM_DATOPE,
       ICO.NUMITE,
       DCFO.CODCFO,
       CASE SUBSTR(DCFO.CODCFO,2,3)
         WHEN '556' THEN '1' -- Compra material p/ uso e consumo
         ELSE ICO.ICMTIP
       END AS ICMTIP,
       COALESCE(ICO.VLRITE,0) AS VLRITE,
       COALESCE(ICO.VLRMOV,0) AS VLRMOV,
       CASE SUBSTR(DCFO.CODCFO,2,3)
         WHEN '556' THEN 0 -- Compra material p/ uso e consumo
         ELSE COALESCE(ICO.ICMITEDIF,0)
       END AS TAXICM,
       COALESCE(ICO.BASICMDIF,0) AS BASICM,
       COALESCE(ICO.VLRICMDIF,0) AS VLRICM,
       COALESCE(ICO.BASSUBDIF,0) AS BASSUB,
       COALESCE(ICO.VLR_STDIF,0) AS VLR_ST,
       COALESCE(ICO.BASIPI,0) AS BASIPI,
       COALESCE(ICO.VLRIPI,0) AS VLRIPI,
       COALESCE(ICO.FREFIS,0) AS FREFIS,
       COALESCE(ICO.ICO_VLRFRE,0) AS ICO_VLRFRE,
       COALESCE(ICO.ICO_OUTTAX,0) AS ICO_OUTTAX,
       COALESCE(ICO.BASPIS,0) AS BASPIS,
       COALESCE(ICO.VLRPIS,0) AS VLRPIS,
       COALESCE(ICO.BASCOF,0) AS BASCOF,
       COALESCE(ICO.VLRCOF,0) AS VLRCOF,
       GRA.CODEXT AS CODMAT,
       ICO.QTDMOV,
       MED.UNIMED,
       (COALESCE(ICO.VLRMOV,0) / NVLZ(ICO.QTDMOV,1)) AS VLRUNI,
       PRO.REFBAS, GRA.REFPRO,
       GRA.CODFIS,
       GRA.FILMAT AS GRA_FILMAT,
       GRA.CODMAT AS GRA_CODMAT,
       GRA.CODCOR AS GRA_CODCOR,
       GRA.CODTAM AS GRA_CODTAM,
       ICO.EMBQTD,
       ICO.EMBORI,
       NCM.CODEXT AS NCM_CODEXT,
       -- RFMP 94119 CSTs sao ajustados com as mesmas regras do SPED
       CAST(CASE WHEN ICO.RETSUB = 'T' THEN
                 CASE WHEN (DFIL.REGTRI = 'S') AND (COALESCE(DFIL.TRISIM,'X') <> 'O') THEN
                      '500'
                 ELSE
                    COALESCE(ICO.CODORI, 0)||'60'
                 END
            ELSE
                 CASE WHEN LENGTH(TRIM(ICO.CODCSTDIF)) = 2 THEN
                      COALESCE(ICO.CODORI, 0)||LPAD(TRIM(ICO.CODCSTDIF),2,'0')
                 ELSE
                      LPAD(TRIM(ICO.CODCSTDIF),3,'0')
                 END
            END AS CHAR(3)) AS CODCST,
       CAST(LPAD(COALESCE(ICO.SITIPI, '03'),2,'0') AS CHAR(2)) AS SITIPI,
       CAST(LPAD(COALESCE(ICO.SITPIS, '98'),2,'0') AS CHAR(2)) AS SITPIS,
       CAST(LPAD(COALESCE(ICO.SITCOF, '98'),2,'0') AS CHAR(2)) AS SITCOF
  FROM TT_COM COM INNER JOIN TT_ICO ICO ON ICO.CODFIL = COM.CODFIL AND ICO.SEQUEN = COM.SEQUEN
                   LEFT JOIN TT_TRA TRA ON TRA.FILICO = COM.CODFIL AND TRA.SEQICO = COM.SEQUEN
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = ICO.FILMAT AND GRA.CODMAT = ICO.CODMAT
                                       AND GRA.CODCOR = ICO.CODCOR AND GRA.CODTAM = ICO.CODTAM
                  INNER JOIN TD_FIL DFIL ON DFIL.CODFIL = COM.CODFIL
                  INNER JOIN TD_MED MED ON MED.CODTAB = GRA.UNIDAD
                  INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = COM.FILFOR AND CLI.CODCLI = COM.CODFOR
                  INNER JOIN TD_MUL DMUL ON DMUL.CODTAB = ICO.CODMUL
                   LEFT JOIN TD_CFO DCFO ON DCFO.CODTAB = ICO.CODCFO
                  INNER JOIN TD_MOE DMOE ON DMOE.CODTAB = ICO.CODMOE
                   LEFT JOIN TT_NCM NCM ON PRO.CODNCM = NCM.CODNCM
 WHERE TRA.SEQICO IS NULL
   AND COM.NUMNOT NOT LIKE '%#%'
UNION ALL
SELECT COM.CODFIL,
       COM.SEQUEN,
       COM.NUMNOT,
       COM.CODSER,
       /*CASE WHEN VEN.SEQUEN IS NOT NULL THEN -- Transferencia
           CASE WHEN COM.DATOPE < COM.DATCMP
                THEN COM.DATCMP -- Entradas com a configuracao TRAORI="T" possuem DATOPE < DATCMP
                ELSE COM.DATOPE
           END
       ELSE
           COM.DATOPE
       END*/ COM.DATOPE AS COM_DATOPE,
       INF.inf_numite AS NUMITE,
       CASE SUBSTR(to_char(INF.inf_nu_cfop),1,1)
         WHEN '5' THEN CAST(1||SUBSTR(to_char(INF.inf_nu_cfop),2,3)||'00'  AS CHAR(6))
         WHEN '6' THEN CAST(2||SUBSTR(to_char(INF.inf_nu_cfop),2,3)||'00'  AS CHAR(6))
         ELSE CAST(INF.inf_nu_cfop||'00' AS CHAR(6))
       END AS CODCFO,
       CASE WHEN INF.inf_nu_icmscst IN (0,20,51,101,102) THEN '0'
            WHEN INF.inf_nu_icmscst IN (40,103,300) THEN '2'
            WHEN INF.inf_nu_icmscst IN (10,30,60,70,201,202,203,500) THEN '3'
            WHEN INF.inf_nu_icmscst IN (41,50,90,400,900) THEN '1'
       END AS ICMTIP,
       COALESCE(INF.inf_vl_prod,0) AS VLRITE,
       COALESCE(INF.inf_vl_prod-INF.inf_vl_desconto,0) AS VLRMOV,
       COALESCE(INF.inf_vl_icmsaliq,0) AS TAXICM,
       COALESCE(INF.inf_vl_icmsvbc,0) AS BASICM,
       COALESCE(INF.inf_vl_icms,0) AS VLRICM,
       COALESCE(INF.inf_vl_icmsstvbc,0) AS BASSUB,
       COALESCE(INF.inf_vl_icmsst,0) AS VLR_ST,
       COALESCE(INF.inf_vl_ipibc,0) AS BASIPI,
       COALESCE(INF.inf_vl_ipi,0) AS VLRIPI,
       0 AS FREFIS,
       COALESCE(INF.inf_vl_frete,0) AS ICO_VLRFRE,
       COALESCE(INF.inf_vl_outro,0) AS ICO_OUTTAX,
       COALESCE(INF.inf_vl_pisbc,0) AS BASPIS,
       COALESCE(INF.inf_vl_pis,0) AS VLRPIS,
       COALESCE(INF.inf_vl_cofinsbc,0) AS BASCOF,
       COALESCE(INF.inf_vl_cofins,0) AS VLRCOF,
       GRA.CODEXT AS CODMAT,
       INF.inf_nu_qTrib AS QTDMOV,
       MED.UNIMED,
       INF.inf_vl_vuncom AS VLRUNI,
       PRO.REFBAS, GRA.REFPRO,
       GRA.CODFIS,
       GRA.FILMAT AS GRA_FILMAT,
       GRA.CODMAT AS GRA_CODMAT,
       GRA.CODCOR AS GRA_CODCOR,
       CASE WHEN INF.inf_nu_qTrib <> INF.inf_nu_qCom  THEN COALESCE(DSUB.CODSAL,GRA.CODTAM)
            ELSE GRA.CODTAM
       END AS GRA_CODTAM,
       CASE WHEN INF.inf_nu_qTrib <> INF.inf_nu_qCom  THEN INF.inf_nu_qcom
       END AS EMBQTD,
       CASE WHEN INF.inf_nu_qTrib <> INF.inf_nu_qCom  THEN COALESCE(DSUB.CODSAL,GRA.CODTAM)
       END AS EMBORI,
       NCM.CODEXT AS NCM_CODEXT,
       CAST(CASE WHEN (DFIL.REGTRI = 'S') AND (COALESCE(DFIL.TRISIM,'X') <> 'O') THEN
                 LPAD(to_char(INF.inf_nu_icmscst),3,'0')
            ELSE
                 COALESCE(PRO.ORIPRO, '0')||LPAD(to_char(INF.inf_nu_icmscst),2,'0')
            END AS CHAR(3)) AS CODCST,
       CAST('03' AS CHAR(2)) AS SITIPI,
       CAST('98' AS CHAR(2)) AS SITPIS,
       CAST('98' AS CHAR(2)) AS SITCOF
  FROM TT_COM COM INNER JOIN TD_SER DSER ON DSER.CODSER = COM.CODSER
                  INNER JOIN TT_NFE NFE ON NFE.nfe_codfil = COM.FILFOR
                                       AND NFE.nfe_nu_serie = CAST(DSER.SEREXT AS Numeric)
                                       AND NFE.nfe_nu_nnf = CAST(TRIM(COM.NUMNOT) AS Numeric)
                  INNER JOIN TT_INF INF ON INF.nfe_id_doc = NFE.nfe_id_doc
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = INF.inf_filmat AND GRA.CODMAT = INF.inf_codmat
                                       AND GRA.CODCOR = INF.inf_codcor AND GRA.CODTAM = INF.inf_codtam
                  INNER JOIN TD_FIL DFIL ON DFIL.CODFIL = COM.FILFOR
                  INNER JOIN TD_MED MED ON MED.CODTAB = GRA.UNIDAD
                  INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = COM.FILFOR AND CLI.CODCLI = COM.CODFOR
                  INNER JOIN TT_SUB SUB ON SUB.CODITE = GRA.CODTAM
                  INNER JOIN TD_SUB DSUB ON DSUB.CODTAB = SUB.CODSUB
                   LEFT JOIN TT_NCM NCM ON PRO.CODNCM = NCM.CODNCM
                   LEFT JOIN TT_VEN VEN  ON VEN.CODFIL = COM.FILFOR
                                        AND VEN.NUMECF = COM.SUBSER
                                        AND VEN.CODSER = COM.CODSER
                                        AND VEN.NUMNOT = SUBSTR(COM.NUMNOT,4)
                                        AND VEN.FILCLI = COM.CODFIL
                                        AND VEN.CODCLI = COM.CODFOR
 WHERE EXISTS (SELECT TRA.FILICO, TRA.SEQICO
                 FROM TT_TRA TRA
                WHERE TRA.FILICO = COM.CODFIL
                  AND TRA.SEQICO = COM.SEQUEN)
   AND COM.NUMNOT NOT LIKE '%#%';


/*-- SEQ 2782 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EIPE CASCADE;

/*-- SEQ 2783 --*/
CREATE OR REPLACE VIEW TV_EIPE AS
SELECT IPE.CODFIL, IPE.NUMPED, IPE.NUMITE, IPE.FLGEST, IPE.FILENT, IPE.FILMAT, IPE.CODMAT, IPE.SEQUEN, IPE.ATU_EM, 
       IPE.IPIITE, IPE.QTDITE, IPE.VLRITE, IPE.VLRVEN, IPE.CODMOE, IPE.CODCOR, IPE.CODTAM, IPE.FILICO, IPE.SEQICO, 
       IPE.DATREB, IPE.QTDCAN, COALESCE(IPE.QTDENT,0) AS QTDENT, IPE.NUMICO, IPE.ICMITE, COALESCE(IPE.VLRDES,0) AS VLRDES,       
       IPE.CODBUS, IPE.UNICOM, IPE.UNIVEN, IPE.VALCON, IPE.ITEORI, IPE.FILIVE, IPE.SEQIVE, 
       IPE.NUMIVE, IPE.BASICM, IPE.VLRICM, IPE.OUTICM, IPE.ISEICM, IPE.FILORI, IPE.PEDORI, IPE.ORDITE, IPE.FILLOT, 
       IPE.SEQLOT, COALESCE(IPE.VLRFRE,0) AS VLRFRE, IPE.FLGENC, DMUL.DESMUL AS CODMUL, PRO.REFBAS, PRO.DESMAT, MED.UNIMED, 
       GRA.REFPRO, GRA.CODFIS, GRA.CODEXT AS GRA_CODEXT 
  FROM TT_PED PED INNER JOIN TT_IPE IPE ON IPE.CODFIL = PED.CODFIL 
                                       AND IPE.NUMPED = PED.NUMPED
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = IPE.FILMAT 
                                       AND GRA.CODMAT = IPE.CODMAT
                                       AND GRA.CODCOR = IPE.CODCOR 
                                       AND GRA.CODTAM = IPE.CODTAM
                  INNER JOIN TD_MED MED ON MED.CODTAB = GRA.UNIDAD
                  INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT 
                                       AND PRO.CODMAT = GRA.CODMAT
                  INNER JOIN TD_MUL DMUL ON DMUL.CODTAB = IPE.CODMUL
;                                       
                  


/*-- SEQ 2784 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EIVE CASCADE;

/*-- SEQ 2785 --*/
CREATE OR REPLACE VIEW TV_EIVE AS
SELECT TAB.CODFIL,TAB.SEQUEN,TAB.NUMNOT,TAB.NUMECF,TAB.CODSER,TAB.NUMITE,TAB.LANEST,TAB.CODMAT,TAB.VEN_DATHOR,TAB.QTDMOV,TAB.VLRMOV,TAB.ICMTIP,
       TAB.SITMOV,TAB.TIP001,TAB.PERICM,
       CASE WHEN TAB.CODSER = 'CF' THEN
          CASE WHEN TAB.ICMTIP = '0' AND TAB.SITMOV = 'N' THEN TAB.VLRICM ELSE 0 END
       ELSE
          CASE WHEN SUBSTR(TAB.CODCST,2,2) IN ('60', '40', '41') OR TAB.CODCST = '500' THEN 0 ELSE TAB.VLRICM END
       END AS VLRICM,
       TAB.PERIPI,TAB.VLRIPI,TAB.TAXISS,TAB.VLRISS,TAB.TAXIRR,TAB.VLRIRR,TAB.NATFIS,TAB.TIPPRO,
       TAB.VINCUL,TAB.SITKIT,TAB.FILORI,TAB.NOTORI,TAB.EMBORI,TAB.SERORI,TAB.ECFORI,TAB.ITEORI,TAB.NUMORI,TAB.CROORI,TAB.REDITE,TAB.EMBQTD,
       TAB.NUMEXT,TAB.COMISS,TAB.EXPORT,TAB.CODMUL,TAB.ORD_CM,TAB.QTD_CM,TAB.CODVDD,TAB.DATINC,TAB.FILBIC,TAB.SEQFIL,TAB.STATUS,TAB.DATIMP,
       TAB.MOTREJ,TAB.CNT_RO,TAB.TAXICM,TAB.TAXIPI,TAB.SITIPI,TAB.BASIPI,TAB.BASISS,TAB.SITPIS,TAB.PERPIS,TAB.BASPIS,TAB.VLRPIS,TAB.SITCOF,
       TAB.PERCOF,TAB.BASCOF,TAB.VLRCOF,TAB.VLRORI,TAB.NUMBLO,TAB.FILPED,TAB.TIPPED,TAB.NUMPED,TAB.ITEPED,TAB.NUMEXT_DEP,TAB.ATU_EM,
       TAB.IOR_NUMITE,TAB.SIMPLE,TAB.ICMDIF,TAB.DESMAT,TAB.UNIMED,TAB.CODORI,TAB.CODCST,TAB.FLGDEV,TAB.BASUBS,TAB.SUBSTT,TAB.VLRUNI,
       TAB.REFBAS, TAB.REFPRO, TAB.CODFIS, TAB.GRA_FILMAT, TAB.GRA_CODMAT, TAB.GRA_CODCOR, TAB.GRA_CODTAM, TAB.NCM_CODEXT,
       CASE WHEN TAB.CODSER = 'CF' THEN -- RFMP 86655
                -- Cálculo do desconto rateado
                CASE WHEN ((TAB.SITMOV = 'N') AND (COALESCE(TAB.RAT_DESRAT, 0) < 0)) THEN ABS(TAB.RAT_DESRAT) ELSE 0 END
           ELSE
                CASE WHEN (COALESCE(TAB.IVE_DESRAT,0) < 0 AND COALESCE(TAB.IVE_VLRLIQRAT, 0) > 0) OR -- 94581
                          (COALESCE(TAB.IVE_DESRAT,0) > 0 AND COALESCE(TAB.IVE_VLRLIQRAT, 0) < 0) THEN ABS(TAB.IVE_DESRAT) ELSE 0 END
       END AS DESRAT,
       TAB.VLRDES,
       CASE WHEN TAB.CODSER = 'CF' THEN -- RFMP 86655
                -- Cálculo do acréscimo rateado
                CASE WHEN  ((TAB.SITMOV='N') AND (COALESCE(TAB.RAT_DESRAT,0) > 0)) THEN ABS(TAB.RAT_DESRAT) ELSE 0 END
           ELSE
                CASE WHEN (COALESCE(TAB.IVE_DESRAT,0) > 0 AND COALESCE(TAB.IVE_VLRLIQRAT, 0) > 0) OR -- 94581
                          (COALESCE(TAB.IVE_DESRAT,0) < 0 AND COALESCE(TAB.IVE_VLRLIQRAT, 0) < 0) THEN ABS(TAB.IVE_DESRAT) ELSE 0 END
       END AS ACRRAT,
       CASE WHEN TAB.CODSER = 'CF' AND TAB.SITMOV='N' THEN
           ABS(TAB.RAT_OUTTAX)
       ELSE
           ABS(TAB.IVE_OUTTAX)
       END AS OUTTAX,
       CASE WHEN TAB.CODSER = 'CF' AND TAB.SITMOV='N' THEN
           ABS(TAB.RAT_VLRFRE)
       ELSE
           ABS(TAB.IVE_VLRFRE)
       END AS VLRFRE,
       CASE WHEN TAB.CODSER = 'CF' AND TAB.SITMOV='N' THEN
           ABS(TAB.RAT_VLRSEG)
       ELSE
           ABS(TAB.IVE_VLRSEG)
       END AS VLRSEG,
       CASE WHEN TAB.CODSER = 'CF' THEN -- RFMP 87922
         CASE WHEN TAB.ICMTIP = '0' AND TAB.SITMOV = 'N' THEN ABS(round(COALESCE(TAB.RAT_VLRLIQ, 0)*(100-TAB.REDITE)/100,2)) ELSE 0 END
       ELSE
         CASE WHEN SUBSTR(TAB.CODCST,2,2) IN ('60', '40', '41') OR TAB.CODCST = '500' THEN 0 ELSE ABS(TAB.IVE_BASICM) END
       END AS BASICM,
       CASE WHEN TAB.CODSER = 'CF' AND TAB.SITMOV='N' THEN ABS(COALESCE(TAB.RAT_VLRLIQ, 0)) ELSE TAB.IVE_VLRLIQRAT END AS VLRLIQ,
       (CASE WHEN TAB.ICMTIP = '3'
             THEN CASE WHEN TAB.CODSER = 'CF' AND TAB.SITMOV='N' -- RFMP 87922
                  THEN ABS(ROUND(COALESCE(TAB.RAT_VLRLIQ, 0),2))
                  ELSE ABS(TAB.IVE_VLRLIQRAT)
                  END
             ELSE TAB.IVE_OUTICM
        END) AS OUTICM,
       (CASE WHEN TAB.ICMTIP = '0' AND TAB.REDITE <> 0
             THEN CASE WHEN TAB.CODSER = 'CF' AND TAB.SITMOV='N' -- RFMP 87922
                       THEN ABS(ROUND(COALESCE(TAB.RAT_VLRLIQ, 0)*(TAB.REDITE)/100,2))
                       ELSE (TAB.IVE_VLRLIQRAT-TAB.IVE_BASICM)
                  END
             ELSE TAB.IVE_ISEICM
        END) AS ISEICM,
       TAB.TOTPAR,
       TAB.CUSREP_FREFIS,
       TAB.CUSMED_FIS,
       TAB.CUSSIM,
       TAB.TOT_CM,
       TAB.SAL_CM,
       TAB.FILPRE,
       TAB.CODPRE,
       TAB.FILLOT, TAB.SEQLOT,
       TAB.DATHORORI,
       TAB.MODORI,
       TAB.GRA_CODEXT,
       TAB.VEN_FLGEST,
       TAB.CLIENTE,
       TAB.CLI_CODEXT,
       TAB.ENTSAI,
       TAB.EXPFIS,
       TAB.ITEFIS, TAB.CODENQ, TAB.CODCES, TAB.VLRICMORI, TAB.PERFCPDES, TAB.VLRICMDES, TAB.BASICMDES,
       TAB.ICMINTDES, TAB.TAXICMDES, TAB.PERPARICM, TAB.VLRICMFCP,
       TAB.VLRPISRET,
       TAB.VLRCOFRET,
       TAB.VLRSOCRET,
       TAB.VLRSOC,
       TAB.BASCOFRET,
       TAB.TAXPISRET,
       TAB.TAXCOFRET,
       TAB.TAXSOCRET,
       TAB.SITISS,
       TAB.BASFCP,
       TAB.PERFCP,
       TAB.VLRFCP,
       TAB.PERCON_ST,
       TAB.BASFCP_ST,
       TAB.PERFCP_ST,
       TAB.VLRFCP_ST,
       TAB.BASFCP_RET,
       TAB.PERFCP_RET,
       TAB.VLRFCP_RET,
       TAB.REDEFE,
       TAB.BASEFE,
       TAB.PEREFE,
       TAB.VLREFE,
       TAB.ESTORN,
       TAB.VLRICM_COM
FROM (
SELECT VEN.CODFIL, VEN.SEQUEN, VEN.NUMNOT, VEN.NUMECF, VEN.CODSER, IVE.NUMITE, IVE.LANEST,
       COALESCE(GRA.CODEXT,GRA.CODFIS) AS CODMAT, VEN.DATHOR AS VEN_DATHOR, ABS(IVE.QTDMOV) AS QTDMOV, ABS(IVE.VLRMOV) AS VLRMOV,
       IVE.ICMTIP,
       CAST(CASE WHEN IVE.ESTORN = 'F' THEN IVE.SITMOV ELSE 'N' END AS CHAR(1)) AS SITMOV,
       IVE.TIP001,
       CASE WHEN SUBSTR(IVE.CODCST,2,2) IN ('60', '40', '41')
              OR IVE.CODCST = '500'
            THEN 0
            ELSE ABS(COALESCE(IVE.TAX001,0))
       END AS PERICM,
       ABS(COALESCE(IVE.VLRICM, IVE.VLR001)) AS VLRICM,
       ABS(COALESCE(IVE.TAX002,0)) AS PERIPI,
       ABS(COALESCE(IVE.VLRIPI, IVE.VLR002)) AS VLRIPI,
       ABS(COALESCE(IVE.TAXISS,0)) AS TAXISS, ABS(COALESCE(IVE.VLRISS,0)) AS VLRISS, ABS(COALESCE(IVE.TAXIRR,0)) AS TAXIRR,
       ABS(COALESCE(IVE.VLRIRR,0)) AS VLRIRR,
       CAST(
        CASE WHEN VEN.CODSER = 'CF'
             THEN
                  CASE WHEN IUF.CODCFP IS NOT NULL AND CFP.VENCON IS NOT NULL
                       THEN '5'||CFP.VENCON
                       ELSE
                            CASE WHEN CL1.NATCL1 IS NOT NULL AND NATCL1.NATDEN IS NOT NULL
                                 THEN NATCL1.NATDEN
                                 ELSE
                                      CASE WHEN PLA.CODNAT IS NOT NULL AND NATPLA.NATDEN IS NOT NULL
                                           THEN NATPLA.NATDEN
                                           ELSE CASE WHEN ((SUBSTR(IVE.NATFIS,1,4) = '5102') AND (IVE.ICMTIP <> '0')) OR (IVE.NATFIS IS NULL)
                                                THEN NATUREZAVENDA('T', IVE.ICMTIP, DNAT.NATDEN, DNAT.NATFOR, VEN.SUBSTT)||SUBSTR(DNAT.NATDEN,5,2)
                                                ELSE SUBSTR(IVE.NATFIS,1,4)||SUBSTR(DNAT.NATDEN,5,2)
                                                END
                                      END
                            END
                  END
             ELSE
                  -- CFOP de NF
                  SUBSTR(IVE.NATFIS,1,4)||SUBSTR(DNAT.NATDEN,5,2)
         END AS CHAR(6)) AS NATFIS,
       IVE.TIPPRO, IVE.VINCUL, IVE.SITKIT, IVE.EMBORI,
       /* Identificação Nota de Origem */
       COALESCE(IVE.FILORI, IVE.FILICOORI) AS FILORI,
       COALESCE(IVE.NUMORI, IVE.SEQICOORI) AS NUMORI,
       COALESCE(IVE.ITEORI, IVE.NUMICOORI) AS ITEORI,
       CAST(COALESCE(VDE.CODSER,CDE.CODSER) AS CHAR(2)) AS SERORI,
       CAST(COALESCE(VDE.NUMNOT, CDE.NUMNOT) AS CHAR(9)) AS NOTORI,
       CAST(COALESCE(VDE.NUMECF, CASE WHEN IVE.FILICOORI IS NOT NULL THEN '000' ELSE NULL END) AS CHAR(3)) AS ECFORI,
       COALESCE(VDE.DATHOR, CDE.DATOPE) AS DATHORORI,
       COALESCE(VEN.MODNOT, FISVDE.MODNOT, FISCDE.MODNOT) AS MODORI,
       CAST(CASE WHEN DECF.INTERV IS NOT NULL
                 THEN DECF.INTERV
                 ELSE COALESCE(VDE.CNT_RO, CASE WHEN IVE.FILICOORI IS NOT NULL THEN 0 ELSE NULL END)
            END AS CHAR(3)) AS CROORI,
       ABS(IVE.REDITE) AS REDITE, IVE.EMBQTD, IVE.NUMEXT, IVE.COMISS, IVE.EXPORT,
       DMUL.DESMUL AS CODMUL, ABS(IVE.ORD_CM) AS ORD_CM, ABS(IVE.QTD_CM) AS QTD_CM, VDD.CODEXT AS CODVDD,
       IVE.DATINC, IVE.FILBIC, IVE.SEQFIL, 0 AS STATUS, TO_CHAR(' ') AS DATIMP,TO_CHAR(' ') AS MOTREJ,
       CAST(CASE WHEN DECF.INTERV IS NOT NULL
                 THEN DECF.INTERV
                 ELSE VEN.CNT_RO
            END AS CHAR(3)) AS CNT_RO,
       CASE WHEN SUBSTR(IVE.CODCST,2,2) IN ('60', '40', '41')
              OR IVE.CODCST = '500'
            THEN 0
            ELSE ABS(IVE.TAXICM)
       END AS TAXICM,
       ABS(IVE.TAXIPI) AS TAXIPI, IVE.SITIPI, ABS(IVE.BASIPI) AS BASIPI,
       ABS(IVE.BASISS) AS BASISS, IVE.SITPIS,
       ABS(IVE.PERPIS) AS PERPIS, ABS(IVE.BASPIS) AS BASPIS, ABS(IVE.VLRPIS) AS VLRPIS, IVE.SITCOF,
       ABS(IVE.PERCOF) AS PERCOF, ABS(IVE.BASCOF) AS BASCOF, ABS(IVE.VLRCOF) AS VLRCOF, IVE.VLRORI,
       (SELECT ORC.NUMBLO
          FROM TT_ORC ORC INNER JOIN TT_IOR IOR ON ORC.CODFIL = IOR.CODFIL
                                               AND ORC.TIPPED =IOR.TIPPED
                                               AND ORC.NUMPED = IOR.NUMPED
         WHERE IOR.SEQIVE = IVE.SEQUEN
           AND IOR.FILIVE = IVE.CODFIL
           AND IOR.NUMIVE = IVE.NUMITE
         ) AS NUMBLO,
       IXD.FILPED, IXD.TIPPED, IXD.NUMPED, IXD.NUMITE AS ITEPED, IVE.NUMEXT_DEP,
       VEN.ATU_EM,
       (SELECT IOR.NUMITE AS IOR_NUMITE
          FROM TT_IOR IOR
         WHERE IOR.SEQIVE = IVE.SEQUEN
           AND IOR.FILIVE = IVE.CODFIL
           AND IOR.NUMIVE = IVE.NUMITE) AS IOR_NUMITE,
       DFIL.REGTRI AS SIMPLE,
       CASE WHEN IVE.CODCST IN ('051', '151', '251') THEN ABS(IVE.VLRICM) ELSE 0 END AS ICMDIF,
       PRO.DESMAT, MED.UNIMED, CAST(coalesce(TO_CHAR(IVE.CODORI),SUBSTR(IVE.CODCST, 1, 1)) AS VARCHAR(1)) AS CODORI,
       IVE.CODCST as CODCST,
       coalesce(Rateio_ValorLiquido_ECF(IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE,'DESRAT'),0) as RAT_DESRAT,
       IVE.DESRAT as IVE_DESRAT,
       coalesce(Rateio_ValorLiquido_ECF(IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE,'OUTTAX'),0) as RAT_OUTTAX,
       IVE.OUTTAX as IVE_OUTTAX,
       coalesce(Rateio_ValorLiquido_ECF(IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE,'VLRFRE'),0) as RAT_VLRFRE,
       IVE.VLRFRE AS IVE_VLRFRE,
       coalesce(Rateio_ValorLiquido_ECF(IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE,'VLRSEG'),0) as RAT_VLRSEG,
       IVE.VLRSEG as IVE_VLRSEG,
       Rateio_ValorLiquido_ECF(IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE) as RAT_VLRLIQ,
       IVE.VLRLIQRAT as IVE_VLRLIQRAT,
       CASE WHEN IVE.OUTICM IS NULL
         THEN CASE WHEN (SUBSTR(IVE.NATFIS,2,3) IN ( '922', '949') OR IVE.ICMTIP IN ('1','3')) AND SUBSTR(IVE.CODCST,2,2)<>'10'
                  THEN IVE.VLRLIQRAT
                  WHEN SUBSTR(IVE.NATFIS,2,3) NOT IN ( '922', '949') AND SUBSTR(IVE.CODCST,2,2)='10' THEN IVE.SUBSTT ELSE 0 END
         WHEN IVE.OUTICM = 0
         THEN CASE WHEN (SUBSTR(IVE.NATFIS,2,3) IN ( '922', '949') OR IVE.ICMTIP IN ('1','3')) AND SUBSTR(IVE.CODCST,2,2)<>'10'
                  THEN IVE.VLRLIQRAT
                  WHEN SUBSTR(IVE.NATFIS,2,3) NOT IN ( '922', '949') AND SUBSTR(IVE.CODCST,2,2)='10' THEN IVE.SUBSTT ELSE 0 END
       ELSE 0 END  AS IVE_OUTICM,
       COALESCE(IVE.ISEICM, CASE WHEN SUBSTR(IVE.NATFIS,2,3) <> '922' AND IVE.ICMTIP IN ('0', '2', '4')
                                 THEN IVE.VLRLIQRAT-IVE.BASICM
                                 ELSE 0
                            END) AS IVE_ISEICM,
       IVE.BASICM AS IVE_BASICM,
       CAST(CASE WHEN (DNAT.TIPNAT IN('D','M','R')) THEN 'T' ELSE 'F' END AS CHAR(1)) AS FLGDEV,
       ABS(IVE.BASUBS) AS BASUBS,
       ABS(IVE.SUBSTT) AS SUBSTT,
       IVE.VLRUNI,
       IVE.VLRDES,
       PRO.REFBAS,
       GRA.REFPRO,
       GRA.CODFIS,
       GRA.FILMAT AS GRA_FILMAT,
       GRA.CODMAT AS GRA_CODMAT,
       GRA.CODCOR AS GRA_CODCOR,
       GRA.CODTAM AS GRA_CODTAM,
       NCM.CODEXT AS NCM_CODEXT,
       CAST(CASE WHEN IVE.SITMOV = 'C'
                         THEN 'Can-T'
                    ELSE
                         CASE WHEN IVE.ICMTIP = '3' THEN 'F1'
                              WHEN IVE.ICMTIP IN ('2','4') THEN 'I1'
                              WHEN IVE.ICMTIP = '1' THEN 'N1'
                              ELSE 'T' || LPAD(to_char(TRUNC(ROUND(IVE.TAXICM * ((100-(COALESCE(IVE.REDITE,0)))/100),2)*100)),4,'0')
                         END
            END AS VARCHAR(7)) AS TOTPAR,
       IVE.CUSREP_FREFIS,
       IVE.CUSMED_FIS,
       IVE.CUSSIM,
       IVE.TOT_CM, IVE.SAL_CM, VEN.FILPRE, VEN.CODPRE,
       IVE.FILLOT, IVE.SEQLOT,
       COALESCE(GRA.CODEXT,GRA.CODFIS) AS GRA_CODEXT, --DN 103326
       /* Coluna deve seguir padrão da TV_EVEN - Foi disponibilizada na View para Ter Ganho de Performace na Integração da Casa Carneiro */
       VEN.FLGEST AS VEN_FLGEST,
       CLI.CODEXT AS CLI_CODEXT,
       CAST(VEN.FILCLI||TRIM(VEN.CODCLI) AS VARCHAR(20)) AS CLIENTE,
       CAST(CASE WHEN SUBSTR(DNAT.NATDEN, 1, 1) IN ('1', '2', '3') THEN 'E' ELSE 'S' END AS VARCHAR(1)) AS ENTSAI,
       /* Fim Coluna deve seguir padrão da TV_EVEN */
       IVE.EXPFIS, IVE.ITEFIS, IVE.CODENQ, IVE.CODCES, IVE.VLRICMORI, IVE.PERFCPDES, IVE.VLRICMDES, IVE.BASICMDES,
       IVE.ICMINTDES, IVE.TAXICMDES, IVE.PERPARICM, IVE.VLRICMFCP,
       IVE.VLRPISRET,
       IVE.VLRCOFRET,
       IVE.VLRSOCRET,
       IVE.VLRSOC,
       IVE.BASCOFRET,
       IVE.TAXPISRET,
       IVE.TAXCOFRET,
       IVE.TAXSOCRET,
       IVE.SITISS,
       IVE.BASFCP,
       IVE.PERFCP,
       IVE.VLRFCP,
       IVE.PERCON_ST,
       IVE.BASFCP_ST,
       IVE.PERFCP_ST,
       IVE.VLRFCP_ST,
       IVE.BASFCP_RET,
       IVE.PERFCP_RET,
       IVE.VLRFCP_RET,
       IVE.REDEFE,
       IVE.BASEFE,
       IVE.PEREFE,
       IVE.VLREFE,
       IVE.ESTORN,
       IVE.VLRICM_COM
  FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN
                   LEFT JOIN TD_ECF DECF ON DECF.FILECF = VEN.CODFIL AND DECF.NUMECF = VEN.NUMECF
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = IVE.FILMAT AND GRA.CODMAT = IVE.CODMAT
                                        AND GRA.CODCOR = IVE.CODCOR AND GRA.CODTAM = IVE.CODTAM
                  INNER JOIN TD_MED MED ON MED.CODTAB = GRA.UNIDAD
                  INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
                  INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                   LEFT JOIN TT_END ENDE ON ENDE.FILCLI = CLI.FILCLI AND ENDE.CODCLI = CLI.CODCLI AND ENDE.NUMEND = COALESCE(VEN.ENDENT,1)
                  INNER JOIN TD_MUL DMUL ON DMUL.CODTAB = IVE.CODMUL
                  INNER JOIN TD_FIL DFIL ON DFIL.CODFIL = VEN.CODFIL
                  INNER JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT AND PLA.CODPGT = VEN.CODPGT
                  INNER JOIN TT_IUF IUF ON DFIL.UFLOJA = IUF.ESTADO AND DFIL.REGESP = IUF.REGESP  AND PRO.FILMAT = IUF.FILMAT AND PRO.CODMAT = IUF.CODMAT
                   LEFT JOIN TD_CFP CFP ON IUF.CODCFP = CFP.CODTAB
                   LEFT JOIN TD_NAT NATPLA ON NATPLA.CODTAB = PLA.CODNAT
                   LEFT JOIN TD_CL1 CL1 ON CL1.CODTAB = PRO.CLASS1
                   LEFT JOIN TD_NAT NATCL1 ON NATCL1.CODTAB = CL1.NATCL1
                   /* Identificação Nota de Origem */
                   LEFT JOIN TT_VEN VDE ON VDE.CODFIL = IVE.FILORI AND VDE.SEQUEN = IVE.NUMORI
                   LEFT JOIN TT_FIS FISVDE ON FISVDE.ORIGEM = 'V'
                                          AND FISVDE.CODSER = VDE.CODSER
                                          AND FISVDE.SUBSER = VDE.NUMECF
                   LEFT JOIN TT_COM CDE ON CDE.CODFIL = IVE.FILICOORI AND CDE.SEQUEN = IVE.SEQICOORI
                   LEFT JOIN TT_FIS FISCDE ON FISCDE.ORIGEM = 'C'
                                          AND FISCDE.CODSER = CDE.CODSER
                                          AND FISCDE.SUBSER = COALESCE(CDE.SUBSER,'')
                   LEFT JOIN TT_IVEXIOR IXD ON IXD.FILIVE = IVE.CODFIL
                                           AND IXD.SEQIVE = IVE.SEQUEN
                                           AND IXD.NUMIVE = IVE.NUMITE
                   LEFT JOIN TT_USU VDD ON VDD.FILUSU = IVE.FILVDD AND IVE.CODVDD = VDD.CODUSU
                   LEFT JOIN TT_NCM NCM ON PRO.CODNCM = NCM.CODNCM
 WHERE VEN.NUMNOT NOT LIKE '%#%'
) TAB;


/*-- SEQ 2786 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EIVE_EXP CASCADE;

/*-- SEQ 2787 --*/
CREATE OR REPLACE VIEW TV_EIVE_EXP AS
SELECT *
FROM TV_EIVE IVE INNER JOIN TD_EXP DEXP ON DEXP.CODTAB = 1
WHERE IVE.ATU_EM BETWEEN TO_DATE(TO_CHAR(TRUNC(DEXP.DATINI),'DD/MM/YYYY')||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND TO_DATE(TO_CHAR(TRUNC(DEXP.DATFIM),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');


/*-- SEQ 2788 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EKIT_EXP CASCADE;

/*-- SEQ 2789 --*/
CREATE OR REPLACE VIEW TV_EKIT_EXP AS
SELECT KIT.*
  FROM TV_EKIT KIT INNER JOIN TD_EXP DEXP ON DEXP.CODTAB = 1
 WHERE KIT.ATU_EM BETWEEN TO_DATE(TO_CHAR(TRUNC(DEXP.DATINI),'DD/MM/YYYY')||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                          TO_DATE(TO_CHAR(TRUNC(DEXP.DATFIM),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');


/*-- SEQ 2790 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ELAN_EXP CASCADE;

/*-- SEQ 2791 --*/
CREATE OR REPLACE VIEW TV_ELAN_EXP AS
SELECT LAN.*
  FROM TV_ELAN LAN INNER JOIN TD_EXP DEXP ON DEXP.CODTAB = 1
 WHERE LAN.ATU_EM BETWEEN TO_DATE(TO_CHAR(TRUNC(DEXP.DATINI),'DD/MM/YYYY')||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                          TO_DATE(TO_CHAR(TRUNC(DEXP.DATFIM),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');


/*-- SEQ 2792 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ELIM_EXP CASCADE;

/*-- SEQ 2793 --*/
CREATE OR REPLACE VIEW TV_ELIM_EXP AS
SELECT LIM.*
  FROM TV_ELIM LIM INNER JOIN TD_EXP DEXP ON DEXP.CODTAB = 1
 WHERE LIM.ATU_EM BETWEEN TO_DATE(TO_CHAR(TRUNC(DEXP.DATINI),'DD/MM/YYYY')||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                          TO_DATE(TO_CHAR(TRUNC(DEXP.DATFIM),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');


/*-- SEQ 2794 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ELOT CASCADE;

/*-- SEQ 2795 --*/
CREATE OR REPLACE VIEW TV_ELOT AS
SELECT LOT.CODFIL, LOT.SEQUEN, LOT.FILMAT, LOT.CODMAT, LOT.CODCOR, LOT.CODTAM, LOT.FILFOR, LOT.CODFOR,
       LOT.NUMLOT, LOT.DATINC, LOT.ATU_EM, LOT.TONALI, LOT.TAMANH, LOT.DATVAL, 
       CAST(0 AS Numeric(12,4)) AS QTDINI, 
       CAST(0 AS Numeric(12,4)) AS QTDCOM,
       COALESCE((SELECT SUM(SLT.QTDEST)
                    FROM TV_SLT SLT
                   WHERE SLT.FILLOT = LOT.CODFIL
                     AND SLT.SEQLOT = LOT.SEQUEN),0) AS QTDEST,
       LOT.FLGPON, GRA.CODEXT AS GRA_CODEXT, LOT.CODEXT AS LOT_CODEXT, LOT.LOTATI
  FROM TT_PRO PRO INNER JOIN TT_GRA GRA ON GRA.FILMAT = PRO.FILMAT AND GRA.CODMAT = PRO.CODMAT
                  INNER JOIN TT_LOT LOT ON LOT.FILMAT = GRA.FILMAT
                                       AND LOT.CODMAT = GRA.CODMAT
                                       AND LOT.CODCOR = GRA.CODCOR
                                       AND LOT.CODTAM = GRA.CODTAM;



/*-- SEQ 2796 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EPAG_EXP CASCADE;

/*-- SEQ 2797 --*/
CREATE OR REPLACE VIEW TV_EPAG_EXP AS
SELECT PAG.*
  FROM TV_EPAG PAG INNER JOIN TD_EXP DEXP ON DEXP.CODTAB = 1
 WHERE PAG.ATU_EM BETWEEN TO_DATE(TO_CHAR(TRUNC(DEXP.DATINI),'DD/MM/YYYY')||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND
                          TO_DATE(TO_CHAR(TRUNC(DEXP.DATFIM),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');


/*-- SEQ 2798 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EPAR_EXP CASCADE;

/*-- SEQ 2799 --*/
CREATE OR REPLACE VIEW TV_EPAR_EXP AS
SELECT PAR.*
FROM TV_EPAR PAR INNER JOIN TD_EXP DEXP ON DEXP.CODTAB = 1
WHERE (PAR.FILCLI||PAR.CODCLI <> (SELECT VC_FILCLI||VC_CODCLI FROM TT_CFG));


/*-- SEQ 2800 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EPLA_EXP CASCADE;

/*-- SEQ 2801 --*/
CREATE OR REPLACE VIEW TV_EPLA_EXP AS
SELECT PLA.*
  FROM TV_EPLA PLA INNER JOIN TD_EXP DEXP ON DEXP.CODTAB = 1
 WHERE PLA.ATU_EM BETWEEN TO_DATE(TO_CHAR(TRUNC(DEXP.DATINI),'DD/MM/YYYY')||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                          TO_DATE(TO_CHAR(TRUNC(DEXP.DATFIM),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');


/*-- SEQ 2802 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EPRE_EXP CASCADE;

/*-- SEQ 2803 --*/
CREATE OR REPLACE VIEW TV_EPRE_EXP AS
SELECT PRE.*
  FROM TV_EPRE PRE INNER JOIN TD_EXP DEXP ON DEXP.CODTAB = 1
 WHERE PRE.ULTREA BETWEEN TO_DATE(TO_CHAR(TRUNC(DEXP.DATINI),'DD/MM/YYYY')||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                          TO_DATE(TO_CHAR(TRUNC(DEXP.DATFIM),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');


/*-- SEQ 2804 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EPRO_EXP CASCADE;

/*-- SEQ 2805 --*/
CREATE OR REPLACE VIEW TV_EPRO_EXP AS
SELECT PRO.*
  FROM TV_EPRO PRO INNER JOIN TD_EXP DEXP ON DEXP.CODTAB = 1
 WHERE PRO.ATU_EM BETWEEN TO_DATE(TO_CHAR(TRUNC(DEXP.DATINI),'DD/MM/YYYY')||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                          TO_DATE(TO_CHAR(TRUNC(DEXP.DATFIM),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');


/*-- SEQ 2806 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EREC_EXP CASCADE;

/*-- SEQ 2807 --*/
CREATE OR REPLACE VIEW TV_EREC_EXP AS
SELECT REC.*
  FROM TV_EREC REC INNER JOIN TD_EXP DEXP ON DEXP.CODTAB = 1              
 WHERE REC.ATU_EM BETWEEN TO_DATE(TO_CHAR(TRUNC(DEXP.DATINI),'DD/MM/YYYY')||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                          TO_DATE(TO_CHAR(TRUNC(DEXP.DATFIM),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');


/*-- SEQ 2808 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ESAL_EXP CASCADE;

/*-- SEQ 2809 --*/
CREATE OR REPLACE VIEW TV_ESAL_EXP AS
SELECT SAL.*
  FROM TV_ESAL SAL INNER JOIN TD_EXP DEXP ON DEXP.CODTAB = 1
 WHERE SAL.ATU_EM BETWEEN TO_DATE(TO_CHAR(TRUNC(DEXP.DATINI),'DD/MM/YYYY')||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                          TO_DATE(TO_CHAR(TRUNC(DEXP.DATFIM),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');


/*-- SEQ 2810 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ESEP CASCADE;

/*-- SEQ 2811 --*/
CREATE OR REPLACE VIEW TV_ESEP AS
-- Separaes de DAV e Venda
SELECT IVO.FILVOL AS SEP_CODFIL,
       IVO.SEQUEN AS SEP_SEQUEN,
       IVO.QTDSEP AS SEP_QTDSEP,
       IVO.TIPENT AS SEP_TIPENT,
       DENT.DESENT AS DENT_DESENT,
       IVO.ATU_EM AS SEP_ATU_EM,
       IVO.FLGEST AS SEP_FLGEST,
       IVO.REFBAS AS PRO_REFBAS,
       IVO.REFPRO AS GRA_REFPRO,
       IVO.DOCUME AS SEP_DOCUME,
       IVO.ORIGEM AS SEP_ORIGEM,
       IVO.FILIVE AS SEP_FILIVE,
       IVO.SEQIVE AS SEP_SEQIVE,
       IVO.NUMIVE AS SEP_NUMIVE,
       IVO.FILPED AS SEP_FILPED,
       IVO.TIPPED AS SEP_TIPPED,
       IVO.NUMPED AS SEP_NUMPED,
       IVO.NUMITE AS SEP_NUMITE,
       IVO.FILIPE AS SEP_FILIPE,
       IVO.NUMIPE AS SEP_NUMIPE,
       IVO.ITEIPE AS SEP_ITEIPE,
       IVO.CONTEM AS SEP_CONTEM,
       IVO.QTDFAL AS SEP_QTDFAL,
       IVO.ROM_CODEXT AS ROM_CODEXT,
       IVO.ORCECO AS SEP_ORCECO
  FROM TV_IVO IVO INNER JOIN TD_ENT DENT ON DENT.TIPENT = IVO.TIPENT
 WHERE IVO.ORIGEM IN ('O','V')
   AND IVO.FLGEST IN ('A','D','F','P')
   AND ((IVO.QTDSEP > 0 AND IVO.FLGEST <> 'D') OR
        (IVO.CONTEM > 0 AND IVO.FLGEST = 'D'))
   AND IVO.TIPENT IN ('2','3','5','7')
 UNION ALL
-- Separaes de Pedido de Reposio
SELECT IVO.FILVOL AS SEP_CODFIL,
       IVO.SEQUEN AS SEP_SEQUEN,
       IVO.QTDSEP AS SEP_QTDSEP,
       IVO.TIPENT AS SEP_TIPENT,
       NULL AS DENT_DESENT,
       IVO.ATU_EM AS SEP_ATU_EM,
       IVO.FLGEST AS SEP_FLGEST,
       IVO.REFBAS AS PRO_REFBAS,
       IVO.REFPRO AS GRA_REFPRO,
       IVO.DOCUME AS SEP_DOCUME,
       IVO.ORIGEM AS SEP_ORIGEM,
       IVO.FILIVE AS SEP_FILIVE,
       IVO.SEQIVE AS SEP_SEQIVE,
       IVO.NUMIVE AS SEP_NUMIVE,
       IVO.FILPED AS SEP_FILPED,
       IVO.TIPPED AS SEP_TIPPED,
       IVO.NUMPED AS SEP_NUMPED,
       IVO.NUMITE AS SEP_NUMITE,
       IVO.FILIPE AS SEP_FILIPE,
       IVO.NUMIPE AS SEP_NUMIPE,
       IVO.ITEIPE AS SEP_ITEIPE,
       IVO.CONTEM AS SEP_CONTEM,
       IVO.QTDFAL AS SEP_QTDFAL,
       IVO.ROM_CODEXT AS ROM_CODEXT,
       IVO.ORCECO AS SEP_ORCECO
  FROM TV_IVO IVO
 WHERE IVO.ORIGEM = 'P'
   AND IVO.FLGEST IN ('A','F','P')
   AND IVO.QTDSEP > 0;


/*-- SEQ 2812 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ESLT CASCADE;

/*-- SEQ 2813 --*/
CREATE OR REPLACE VIEW TV_ESLT AS
SELECT SLT.CODFIL, SLT.SEQUEN, SLT.CODMUL, SLT.FILLOT, SLT.SEQLOT, SLT.QTDEST, SLT.LOTATI,
       SLT.RESERV, SLT.ATU_EM, SLT.QTDINI, GRA.CODEXT AS GRA_CODEXT, DMUL.DESMUL AS DESEST
  FROM TV_SLT SLT INNER JOIN TT_LOT LOT ON LOT.CODFIL = SLT.FILLOT
                                       AND LOT.SEQUEN = SLT.SEQLOT
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = LOT.FILMAT
                                       AND GRA.CODMAT = LOT.CODMAT
                                       AND GRA.CODCOR = LOT.CODCOR
                                       AND GRA.CODTAM = LOT.CODTAM
                  INNER JOIN TD_MUL DMUL ON DMUL.CODTAB = SLT.CODMUL;


/*-- SEQ 2814 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EUSU_EXP CASCADE;

/*-- SEQ 2815 --*/
CREATE OR REPLACE VIEW TV_EUSU_EXP AS
SELECT USU.*
  FROM TV_EUSU USU INNER JOIN TD_EXP DEXP ON DEXP.CODTAB = 1
 WHERE USU.ATU_EM BETWEEN TO_DATE(TO_CHAR(TRUNC(DEXP.DATINI),'DD/MM/YYYY')||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND
                          TO_DATE(TO_CHAR(TRUNC(DEXP.DATFIM),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');


/*-- SEQ 2816 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVEN_EXP CASCADE;

/*-- SEQ 2817 --*/
CREATE OR REPLACE VIEW TV_EVEN_EXP AS
SELECT *
FROM TV_EVEN IVE INNER JOIN TD_EXP DEXP ON DEXP.CODTAB = 1
WHERE IVE.ATU_EM BETWEEN TO_DATE(TO_CHAR(TRUNC(DEXP.DATINI),'DD/MM/YYYY')||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND TO_DATE(TO_CHAR(TRUNC(DEXP.DATFIM),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');


/*-- SEQ 2818 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVEN_FIS CASCADE;

/*-- SEQ 2819 --*/
CREATE OR REPLACE VIEW TV_EVEN_FIS AS
SELECT EVEN.CODFIL,
       EVEN.NUMNOT,
       EVEN.CODSER,
       EVEN.NUMECF,
       EVEN.SEQUEN,
       EVEN.AVISTA,
       EVEN.DATFIS,
       EVEN.FLGEST,
       EVEN.CLIENTE,
       EVEN.FLGNFE,
       EVEN.ENTSAI,
       EVEN.FLGDEV,
       EVEN.INDFRE,
       EVEN.SIGEST,
       EVEN.SIGEST_FAT
  FROM TV_EVEN EVEN INNER JOIN TD_SER DSER ON DSER.CODSER = EVEN.CODSER
 WHERE DSER.MODNOT <> 55  
UNION ALL
SELECT EVEN.CODFIL,
       EVEN.NUMNOT,
       EVEN.CODSER,
       EVEN.NUMECF,
       EVEN.SEQUEN,
       EVEN.AVISTA,
       EVEN.DATFIS,
       EVEN.FLGEST,
       EVEN.CLIENTE,
       EVEN.FLGNFE,
       EVEN.ENTSAI,
       EVEN.FLGDEV,
       EVEN.INDFRE,
       EVEN.SIGEST,
       EVEN.SIGEST_FAT       
  FROM TV_EVEN EVEN INNER JOIN TD_SER DSER ON DSER.CODSER = EVEN.CODSER
                    INNER JOIN TT_NFE NFE ON NFE.nfe_codfil = EVEN.CODFIL
                                         AND NFE.nfe_nu_serie = CAST(DSER.SEREXT AS Numeric)
                                         AND NFE.nfe_nu_nnf = CAST(TRIM(EVEN.NUMNOT) AS Numeric)
 WHERE DSER.MODNOT = 55;



/*-- SEQ 2820 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_53C CASCADE;

/*-- SEQ 2821 --*/
CREATE OR REPLACE VIEW TV_FIS_53C AS
SELECT DATAOK, CODFIL, 
       COALESCE(CHAVE ,'')|| COALESCE(NUMDOC,'')|| COALESCE(INSEST,'')|| 
       COALESCE(DATOPE,'')|| COALESCE(UFNOTA,'')|| COALESCE(MODELO,'')|| 
       COALESCE(CODSER,'')|| COALESCE(NUMNOT,'')|| COALESCE(CODCFO,'')|| 
       COALESCE(EMITEN,'')|| COALESCE(BASSUB,'')|| COALESCE(VLRRET,'')|| 
       COALESCE(DESPES,'')|| COALESCE(FLGEST,'')|| COALESCE(CODANT,'')|| 
       COALESCE(BRANCO,'') AS LINHA
 FROM (                                   
        SELECT CAST('53' AS CHAR(2)) AS CHAVE,
               COM.DATOPE AS DATAOK,
               COM.CODFIL,
               LPAD(COM.NUMDOC, 14, '0') AS NUMDOC,
               RPAD(COM.INSEST, 14, ' ') AS INSEST,
               CAST(TO_CHAR(COM.DATOPE, 'YYYYMMDD') AS CHAR(8)) AS DATOPE,
               RPAD(CASE WHEN SUBSTR(COALESCE(COM.CODCFO,'    '), 1, 1) = '3'
                         THEN 'EX'
                         ELSE COM.UFNOTA
                     END, 2, ' ') AS UFNOTA,
               LPAD(COM.MODELO,2,'0') AS MODELO,
               COALESCE(RPAD(RTRIM(LTRIM(COALESCE(COM.CODSER,' '))),3,' '),'   ') AS CODSER,
               SUBSTR(LPAD(RTRIM(LTRIM(COM.NUMNOT)),9,'0'),-6,6) AS NUMNOT,
               COM.CODCFO,
               COM.EMITEN,
               LPAD(to_char(TRUNC(SUM(COM.BASSUB)*100)),13,'0') AS BASSUB,
               LPAD(to_char(TRUNC(SUM(COM.VLRRET)*100)),13,'0') AS VLRRET,
               LPAD(to_char(TRUNC(SUM(COM.DESPES)*100)),13,'0') AS DESPES,
               COM.FLGEST,
               LPAD(' ',01,' ') AS CODANT,
               LPAD(' ',29,' ') AS BRANCO
          FROM TV_FIS_53CINTERNO COM
 GROUP BY COM.DATOPE, COM.CODFIL, COM.NUMDOC, COM.INSEST, COM.DATOPE, COM.UFNOTA, 
          COM.MODELO, COM.CODSER, COM.NUMNOT, COM.CODCFO, COM.EMITEN, COM.FLGEST
) TAB
;


/*-- SEQ 2822 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_54C CASCADE;

/*-- SEQ 2823 --*/
CREATE OR REPLACE VIEW TV_FIS_54C AS
SELECT DISTINCT DATAOK, CODFIL,
       COALESCE(CHAVE ,'')|| COALESCE(CGC ,'')|| COALESCE(MODELO ,'')|| COALESCE(SERIE ,'')|| COALESCE(NUMNOT ,'')||
       COALESCE(CFOP ,'')|| COALESCE(CST ,'')|| COALESCE(TO_CHAR(NUMITE) ,'')|| COALESCE(CODMAT ,'')|| COALESCE(TO_CHAR(QTDMOV) ,'')||
       COALESCE(TO_CHAR(VLRMOV) ,'')|| COALESCE(DESPES ,'')|| COALESCE(BASICM ,'')|| COALESCE(TO_CHAR(VLRSUB) ,'')|| COALESCE(TO_CHAR(VLRIPI) ,'')||
       COALESCE(TO_CHAR(PERICM) ,'') AS LINHA
  FROM (SELECT TO_CHAR('54') AS CHAVE,
               COM.DATOPE AS DATAOK,
               COM.CODFIL,
               CASE WHEN SUBSTR(CASE WHEN TRA.SEQIVE IS NOT NULL AND TRA.SEQICO IS NOT NULL
                                     THEN CASE WHEN SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),1,1) = '5'
                                               THEN '1'||SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),2,3)
                                               ELSE CASE WHEN SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),1,1) = '6'
                                                         THEN '2'||SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),2,3)
                                                         ELSE ''
                                                     END
                                           END
                                      ELSE CASE WHEN SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),1,1) = '5'
                                                THEN '1'||SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),2,3)
                                                ELSE CASE WHEN SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),1,1) = '6'
                                                          THEN '2'||SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),2,3)
                                                          ELSE COALESCE(ICO.NATURE,COM.NATURE)
                                                      END
                                            END
                                 END,1,1) = '3'
                     THEN '00000000000000'
                     ELSE LPAD(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(COALESCE(LTRIM(RTRIM(COALESCE(ENDE.NUMDOC,COALESCE(CFO.NUMDOC,VIN.NUMDOC)))),'0'),',',''),'.',''),'/',''),'-',''),' ',''),14,'0')
                 END AS CGC,
               COALESCE(LPAD(RTRIM(LTRIM(COALESCE(COALESCE(ICO.MODNOT,COM.MODNOT),'01'))),2,'0'),'  ') AS MODELO,
               COALESCE(RPAD(RTRIM(LTRIM(COALESCE(COM.CODSER,' '))),3,' '),'   ') AS SERIE,
               /* PROBLEMA => NO BANCO, NUMNOT TEM 9 POSICOES, MAS A EXPORTACAO SO ACEITA 6 ! */
               SUBSTR(LPAD(RTRIM(LTRIM(COM.NUMNOT)),9,'0'),-6,6) AS NUMNOT,
               RPAD(SUBSTR(CASE WHEN TRA.SEQIVE IS NOT NULL AND TRA.SEQICO IS NOT NULL
                                THEN CASE WHEN SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),1,1) = '5'
                                          THEN '1'||SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),2,3)
                                          ELSE CASE WHEN SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),1,1) = '6'
                                                    THEN '2'||SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),2,3)
                                                    ELSE ''
                                                END
                                      END
                                 ELSE CASE WHEN SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),1,1) = '5'
                                           THEN '1'||SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),2,3)
                                           ELSE CASE WHEN SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),1,1) = '6'
                                                     THEN '2'||SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),2,3)
                                                     ELSE COALESCE(ICO.NATURE,COM.NATURE)
                                                 END
                                       END
                             END,1,4),4,' ') AS CFOP,			   
			   CASE WHEN ICO.CODCST IS NOT NULL THEN
                    CASE WHEN LENGTH(TRIM(ICO.CODCST)) = 2 THEN ICO.CODORI||TRIM(ICO.CODCST)
                                                              ELSE ICO.CODCST
                     END ELSE
			   CASE WHEN ICO.ICMTIP = '3' AND ICO.VLRICM > 0 THEN TO_CHAR('010') -- RFMP 79429
                    WHEN ICO.ICMTIP = '3' AND ICO.VLRICM = 0 THEN TO_CHAR('060')
                    WHEN ICO.ICMTIP = '2' THEN TO_CHAR('040')
                    ELSE TO_CHAR('000')	
			    END
                END AS CST,
               LPAD(to_char(ICO.NUMITE), 3, '0') AS NUMITE,
               GRA.FILMAT||REPLACE(GRA.SEQUEN,' ','0')||' ' AS CODMAT, /* DEFINIR A COMPOSIO */
               LPAD(to_char(TRUNC(ICO.QTDMOV * 1000)), 11, '0') AS QTDMOV,
               LPAD(to_char(ABS(TRUNC((RATEIO_VALORLIQUIDO_COMPRA(ICO.CODFIL, ICO.SEQUEN, ICO.NUMITE)-COALESCE(ICO.VLRIPI,0))*100))),12,'0') AS VLRMOV,
               TO_CHAR('000000000000') AS DESPES,
               /* VER SE CALCULA ICMS SOBRE IPI */
               /* BASE DE CALCULO DE ICMS */
               CASE WHEN ((DFIL.REGTRI = 'S') AND (COALESCE(DFIL.TRISIM,'X') <> 'O')) -- Simples
                    THEN LPAD('0',12,'0')
                    WHEN TRA.SEQIVE IS NOT NULL
                    THEN LPAD(to_char(TRUNC(COALESCE((ICO.BASICM * 100),CASE WHEN (COALESCE(IVE.TAX001,0) = 0) OR (VEN.TRIBUT = 'F')
                                                                     THEN 0
                                                                     ELSE CASE WHEN IUF.REDALI IS NOT NULL
                                                                               THEN IVE.VLRMOV * (100+((COALESCE(COM.DESCON,0)/CASE WHEN COM.VLRTOT = 0 THEN 1 ELSE COM.VLRTOT END)*100)) -
                                                                                           (IVE.VLRMOV * (IRE.ICMSRE/100)) *(100+((COALESCE(COM.DESCON,0)/CASE WHEN COM.VLRTOT = 0 THEN 1 ELSE COM.VLRTOT END)*100))
                                                                               ELSE (IVE.VLRMOV - ROUND((IVE.VLRMOV * IVE.REDITE / 100),2)) * 100
                                                                          END
                                                                END,0))),12,'0')
                    ELSE CASE WHEN ICO.ICMTIP = '3'
                              THEN LPAD('0',12,'0')
                              ELSE LPAD(to_char(TRUNC(COALESCE(ICO.BASICM * 100,0))),12,'0')
                         END
               END AS BASICM,
               /* BASE DE CALCULO DE ICMS SUBSTITUIDO */
               LPAD(to_char(TRUNC(ABS(CASE IUF.SUBTRI WHEN '3' THEN ROUND(COALESCE(ICO.BASSUB, COALESCE(COM.BASSUB,0) * (COALESCE(ICO.VLRMOV,0) + COALESCE(ICO.VLRIPI,0)) / CASE WHEN COM.VLRTOT = 0 THEN 1 ELSE COM.VLRTOT END),3)
                                                       ELSE 0
                              END ) * 100)),12,'0') AS VLRSUB,
               /* VALOR DE IPI, SOMENTE PARA PRODUTOS TRIBUTADOS */
               LPAD(to_char(TRUNC(CASE ICO.TIPPRO WHEN '0' THEN COALESCE(ICO.VLRIPI,0) * 100 --COALESCE(ICO.IPIITE*ICO.VLRMOV*(100+((COALESCE(COM.DESCON,0)/CASE WHEN COM.VLRTOT = 0 THEN 1 ELSE COM.VLRTOT END)*100))/100,0)
                                                   ELSE 0
                          END)),12,'0') AS VLRIPI,
               /* ALIQUOTA DE ICMS */
               LPAD(to_char(TRUNC(CASE WHEN ((DFIL.REGTRI = 'S') AND (COALESCE(DFIL.TRISIM,'X') <> 'O')) -- Simples
                                       THEN 0
                                       ELSE CASE COALESCE(ICO.ICMITE, 0) 
                                                 WHEN 0
                                                 THEN CASE COALESCE(IVE.TAX001, 0) WHEN 0 THEN 0 ELSE IVE.TAX001 * 100 END
                                                 ELSE CASE WHEN ICO.ICMTIP IN ('3') THEN 0 ELSE ICO.ICMITE * 100 END
                                            END
                                  END)), 4, '0') AS PERICM
          FROM TW_COM_FIS COM INNER JOIN TW_ICO_FIS ICO ON ICO.CODFIL = COM.CODFIL
                                          AND ICO.SEQUEN = COM.SEQUEN
                              INNER JOIN TD_FIL DFIL ON DFIL.CODFIL = ICO.CODFIL
                              LEFT OUTER JOIN TT_IUF IUF ON IUF.FILMAT = ICO.FILMAT AND IUF.CODMAT = ICO.CODMAT AND IUF.REGESP = DFIL.REGESP
                              LEFT OUTER JOIN TD_IRE IRE ON IRE.CODTAB = IUF.REDALI
                                   INNER JOIN TD_EST DEST ON DEST.ESTADO = DFIL.UFLOJA
                                   INNER JOIN TT_CLI CFO ON CFO.FILCLI = COM.FILFOR AND CFO.CODCLI = COM.CODFOR
                              LEFT OUTER JOIN TT_CLI VIN ON VIN.FILCLI = CFO.FILVIN AND VIN.CODCLI = CFO.CODVIN
                                   INNER JOIN TT_GRA GRA ON GRA.FILMAT = ICO.FILMAT
                                                        AND GRA.CODMAT = ICO.CODMAT
                                                        AND GRA.CODCOR = ICO.CODCOR
                                                        AND GRA.CODTAM = ICO.CODTAM
                              LEFT OUTER JOIN TT_TRA TRA ON TRA.FILICO = ICO.CODFIL AND TRA.SEQICO = ICO.SEQUEN AND TRA.NUMICO = ICO.NUMITE
                              LEFT OUTER JOIN TT_IVE IVE ON IVE.CODFIL = TRA.FILIVE AND IVE.SEQUEN = TRA.SEQIVE AND IVE.NUMITE = TRA.NUMIVE
                              LEFT OUTER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
                              LEFT OUTER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
                              LEFT OUTER JOIN TT_END ENDE ON ENDE.FILCLI = COM.FILFOR 
                                                         AND ENDE.CODCLI = COM.CODFOR 
                                                         AND ENDE.CODFIL = COALESCE(COM.FILEND,ENDE.CODFIL)
                                                         AND ENDE.NUMEND = COALESCE(COM.NUMEND,1)
         WHERE COM.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
           AND ICO.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
           AND COM.FLGEST <> 'D'
           AND COM.NUMNOT NOT LIKE '%#%'
           AND COALESCE(IUF.ESTADO,DFIL.UFLOJA) = DFIL.UFLOJA
         UNION ALL 
        SELECT TO_CHAR('54') AS CHAVE, /* 991 - REGISTRO DE FRETE */
               COM.DATOPE AS DATAOK,
               COM.CODFIL,
               MIN(CASE WHEN SUBSTR(CASE WHEN TRA.SEQIVE IS NOT NULL AND TRA.SEQICO IS NOT NULL
                                         THEN CASE WHEN SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),1,1) = '5'
                                                   THEN '1'||SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),2,3)
                                                   ELSE CASE WHEN SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),1,1) = '6'
                                                             THEN '2'||SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),2,3)
                                                             ELSE ''
                                                         END
                                               END
                                          ELSE CASE WHEN SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),1,1) = '5'
                                                    THEN '1'||SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),2,3)
                                                    ELSE CASE WHEN SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),1,1) = '6'
                                                              THEN '2'||SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),2,3)
                                                              ELSE COALESCE(ICO.NATURE,COM.NATURE)
                                                          END
                                                END
                                     END,1,1) = '3'
                         THEN '00000000000000'
                         ELSE TRIM(COM.NUMDOC)
                     END) AS CGC,
               COALESCE(LPAD(RTRIM(LTRIM(COALESCE(COM.MODNOT,'01'))),2,'0'),'  ') AS MODELO,
               COALESCE(RPAD(RTRIM(LTRIM(COALESCE(COM.CODSER,' '))),3,' '),'   ') AS SERIE,
               SUBSTR(LPAD(RTRIM(LTRIM(COM.NUMNOT)),9,'0'),-6,6) AS NUMNOT,
               MIN(RPAD(SUBSTR(CASE WHEN TRA.SEQIVE IS NOT NULL AND TRA.SEQICO IS NOT NULL
                                    THEN CASE WHEN SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),1,1) = '5'
                                              THEN '1'||SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),2,3)
                                              ELSE CASE WHEN SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),1,1) = '6'
                                                        THEN '2'||SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),2,3)
                                                        ELSE ''
                                                    END
                                          END
                                     ELSE CASE WHEN SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),1,1) = '5'
                                               THEN '1'||SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),2,3)
                                               ELSE CASE WHEN SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),1,1) = '6'
                                                         THEN '2'||SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),2,3)
                                                         ELSE COALESCE(ICO.NATURE,COM.NATURE)
                                                     END
                                           END
                                 END,1,4),4,' ')) AS CFOP,
               TO_CHAR('   ') AS CST,
               TO_CHAR('991') AS NUMITE,
               LPAD(' ',14,' ') AS CODMAT,
               LPAD('0',11,'0') AS QTDMOV,
               LPAD('0',12,'0') AS VLRMOV,
               LPAD(to_char(ABS(ROUND(COALESCE(COM.VLRFRE,0)*100))),12,'0') AS DESPES,
               LPAD('0',12,'0') AS BASICM,
               LPAD('0',12,'0') AS VLRSUB,
               LPAD('0',12,'0') AS VLRIPI,
               LPAD('0', 4,'0') AS PERICM
          FROM TW_COM_FIS COM INNER JOIN TW_ICO_FIS ICO ON ICO.CODFIL = COM.CODFIL
                                                       AND ICO.SEQUEN = COM.SEQUEN
                              INNER JOIN TD_FIL DFIL ON DFIL.CODFIL = ICO.CODFIL
                              LEFT  JOIN TT_IUF IUF ON IUF.FILMAT = ICO.FILMAT AND IUF.CODMAT = ICO.CODMAT AND IUF.REGESP = DFIL.REGESP
                              INNER JOIN TD_EST DEST ON DEST.ESTADO = DFIL.UFLOJA
                              INNER JOIN TT_CLI CFO ON CFO.FILCLI = COM.FILFOR AND CFO.CODCLI = COM.CODFOR
                              LEFT  JOIN TT_CLI VIN ON VIN.FILCLI = CFO.FILVIN AND VIN.CODCLI = CFO.CODVIN
                              INNER JOIN TT_GRA GRA ON GRA.FILMAT = ICO.FILMAT
                                                   AND GRA.CODMAT = ICO.CODMAT
                                                   AND GRA.CODCOR = ICO.CODCOR
                                                   AND GRA.CODTAM = ICO.CODTAM
                              LEFT  JOIN TT_TRA TRA ON TRA.FILICO = ICO.CODFIL AND TRA.SEQICO = ICO.SEQUEN AND TRA.NUMICO = ICO.NUMITE
                              LEFT  JOIN TT_IVE IVE ON IVE.CODFIL = TRA.FILIVE AND IVE.SEQUEN = TRA.SEQIVE AND IVE.NUMITE = TRA.NUMIVE
                              LEFT  JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
                              LEFT  JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
                              LEFT  JOIN TT_END ENDE ON ENDE.FILCLI = COM.FILFOR 
                                                    AND ENDE.CODCLI = COM.CODFOR 
                                                    AND ENDE.CODFIL = COALESCE(COM.FILEND,ENDE.CODFIL)
                                                    AND ENDE.NUMEND = COALESCE(COM.NUMEND,1)
         WHERE COM.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
           AND ICO.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
           AND COM.FLGEST <> 'D'
           AND COM.NUMNOT NOT LIKE '%#%'
           AND COALESCE(IUF.ESTADO,DFIL.UFLOJA) = DFIL.UFLOJA
           AND COALESCE(COM.VLRFRE,0) > 0
       GROUP BY COM.DATOPE, COM.CODFIL, COM.MODNOT, COM.CODSER, COM.NUMNOT, COM.VLRFRE
         UNION ALL 
        SELECT TO_CHAR('54') AS CHAVE, /* 999 - OUTRAS DESPESAS ACESSORIAS */
               COM.DATOPE AS DATAOK,
               COM.CODFIL,
               MIN(CASE WHEN SUBSTR(CASE WHEN TRA.SEQIVE IS NOT NULL AND TRA.SEQICO IS NOT NULL
                                         THEN CASE WHEN SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),1,1) = '5'
                                                   THEN '1'||SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),2,3)
                                                   ELSE CASE WHEN SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),1,1) = '6'
                                                             THEN '2'||SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),2,3)
                                                             ELSE ''
                                                         END
                                               END
                                          ELSE CASE WHEN SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),1,1) = '5'
                                                    THEN '1'||SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),2,3)
                                                    ELSE CASE WHEN SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),1,1) = '6'
                                                              THEN '2'||SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),2,3)
                                                              ELSE COALESCE(ICO.NATURE,COM.NATURE)
                                                          END
                                                END
                                     END,1,1) = '3'
                         THEN '00000000000000'
                         ELSE TRIM(COM.NUMDOC)
                     END) AS CGC,
               COALESCE(LPAD(RTRIM(LTRIM(COALESCE(COM.MODNOT,'01'))),2,'0'),'  ') AS MODELO,
               COALESCE(RPAD(RTRIM(LTRIM(COALESCE(COM.CODSER,' '))),3,' '),'   ') AS SERIE,
               SUBSTR(LPAD(RTRIM(LTRIM(COM.NUMNOT)),9,'0'),-6,6) AS NUMNOT,
               MIN(RPAD(SUBSTR(CASE WHEN TRA.SEQIVE IS NOT NULL AND TRA.SEQICO IS NOT NULL
                                    THEN CASE WHEN SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),1,1) = '5'
                                              THEN '1'||SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),2,3)
                                              ELSE CASE WHEN SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),1,1) = '6'
                                                        THEN '2'||SUBSTR(COALESCE(IVE.NATFIS,NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR, VEN.SUBSTT)),2,3)
                                                        ELSE ''
                                                    END
                                          END
                                     ELSE CASE WHEN SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),1,1) = '5'
                                               THEN '1'||SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),2,3)
                                               ELSE CASE WHEN SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),1,1) = '6'
                                                         THEN '2'||SUBSTR(COALESCE(ICO.NATURE,COM.NATURE),2,3)
                                                         ELSE COALESCE(ICO.NATURE,COM.NATURE)
                                                     END
                                           END
                                 END,1,4),4,' ')) AS CFOP,
               TO_CHAR('   ') AS CST,
               TO_CHAR('999') AS NUMITE,
               LPAD(' ',14,' ') AS CODMAT,
               LPAD('0',11,'0') AS QTDMOV,
               LPAD('0',12,'0') AS VLRMOV,
               LPAD(to_char(ABS(ROUND((COALESCE(COM.OUTTAX,0))*100))),12,'0') AS DESPES,
               LPAD('0',12,'0') AS BASICM,
               LPAD('0',12,'0') AS VLRSUB,
               LPAD('0',12,'0') AS VLRIPI,
               LPAD('0', 4,'0') AS PERICM
          FROM TW_COM_FIS COM INNER JOIN TW_ICO_FIS ICO ON ICO.CODFIL = COM.CODFIL
                                                       AND ICO.SEQUEN = COM.SEQUEN
                              INNER JOIN TD_FIL DFIL ON DFIL.CODFIL = ICO.CODFIL
                              LEFT  JOIN TT_IUF IUF ON IUF.FILMAT = ICO.FILMAT AND IUF.CODMAT = ICO.CODMAT AND IUF.REGESP = DFIL.REGESP
                              INNER JOIN TD_EST DEST ON DEST.ESTADO = DFIL.UFLOJA
                              INNER JOIN TT_CLI CFO ON CFO.FILCLI = COM.FILFOR AND CFO.CODCLI = COM.CODFOR
                              LEFT  JOIN TT_CLI VIN ON VIN.FILCLI = CFO.FILVIN AND VIN.CODCLI = CFO.CODVIN
                              INNER JOIN TT_GRA GRA ON GRA.FILMAT = ICO.FILMAT
                                                   AND GRA.CODMAT = ICO.CODMAT
                                                   AND GRA.CODCOR = ICO.CODCOR
                                                   AND GRA.CODTAM = ICO.CODTAM
                              LEFT  JOIN TT_TRA TRA ON TRA.FILICO = ICO.CODFIL AND TRA.SEQICO = ICO.SEQUEN AND TRA.NUMICO = ICO.NUMITE
                              LEFT  JOIN TT_IVE IVE ON IVE.CODFIL = TRA.FILIVE AND IVE.SEQUEN = TRA.SEQIVE AND IVE.NUMITE = TRA.NUMIVE
                              LEFT  JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
                              LEFT  JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT
                              LEFT  JOIN TT_END ENDE ON ENDE.FILCLI = COM.FILFOR 
                                                    AND ENDE.CODCLI = COM.CODFOR 
                                                    AND ENDE.CODFIL = COALESCE(COM.FILEND,ENDE.CODFIL)
                                                    AND ENDE.NUMEND = COALESCE(COM.NUMEND,1)
         WHERE COM.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
           AND ICO.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
           AND COM.FLGEST <> 'D'
           AND COM.NUMNOT NOT LIKE '%#%'
           AND COALESCE(IUF.ESTADO,DFIL.UFLOJA) = DFIL.UFLOJA
           AND COALESCE(COM.OUTTAX,0) > 0
       GROUP BY COM.DATOPE, COM.CODFIL, COM.MODNOT, COM.CODSER, COM.NUMNOT, COM.OUTTAX, COM.SUBSTT
  )TAB
 ;


/*-- SEQ 2824 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FPV_TOT CASCADE;

/*-- SEQ 2825 --*/
CREATE OR REPLACE VIEW TV_FPV_TOT AS SELECT CODTAB,CODFIL,SEQUEN,FILFRE,SEQFRE,FILFOR,TIPPAR,CODFOR,UF_FOR,DATOPE,DATCMP,
       DOCUME,ATU_EM,VLRFRE,VLRSEG,
       CASE WHEN SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4))
            THEN 0
            ELSE ICMFRE
       END AS ICMFRE,
       PISFRE,VLRTOT,DESCON,OUTTAX,
       VLRLIQ,OBSERV,NUMITE,FILMAT,CODMAT,CODCOR,CODTAM,QTDMOV,PAUTAF,
       VLRMOV,VLRBRU,VLRPRE,IPIITE,ICMITE,COMPIS,COMCOF,VENPIS,VENCOF,PERSOC, PERSOC_R,
       CASE WHEN SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4)) THEN 0 ELSE PERIVE END AS PERIVE,
       PERIVE AS PERIVE_PERTOT,
       PERCOM,PEROPE,PERIRE,PERIRE_R,PERLUC,PERENC,ICMCOM,IPICOM,
       VLRSUB,SUBITE,VLRUNI,CUSAQS,PERTOT,FREITE,SEGITE,DESITE,SUBFED,
       TAXITE,VLRICM,VLRIPI,VLR_COMPIS,VLR_COMCOF,VLR_VENPIS,VLR_VENCOF,VLRSOC,VLRIVE,VLROPE,
       VLRCOM,VLRLUC,PRECAL,CUSFIN,REFPRO,ORDDIV,ORDSUB,VLRIRE,
       DESMAT,ESPMAT,ITEDIV,ITESUB,CODSER,SUBSER,NUMNOT,VMVIPI,
       PRECOV,TOTCOMFRE,ATUCUS,
       (((PRECAL-PRECOV)/NVLZ(PRECAL,NULL))*100) AS PERDIF,
       CUSFIN-(VLRPRE-VLRICM) AS VLRENC,
       VLRUNI/NVLZ(CUSFIN,1)*100 AS PARVLR,
       DESITE/NVLZ(CUSFIN,1)*100 AS PARDES,
       VLRIPI/NVLZ(CUSFIN,1)*100 AS PARIPI,
       VLRICM/NVLZ(CUSFIN,1)*100 AS PARICM,
       VLRICMANT /NVLZ(CUSFIN,1)*100 AS PARVLRICMANT,
       SUBITE/NVLZ(CUSFIN,1)*100 AS PARSUB,
       FREITE/NVLZ(CUSFIN,1)*100 AS PARFRE,
       VLRDESESP/NVLZ(CUSFIN,1)*100 AS PARDESESP,
       TAXITE/NVLZ(CUSFIN,1)*100 AS PARTAX,
       VLR_COMPIS/NVLZ(CUSFIN,1)*100 AS PAR_COMPIS,
       VLR_COMCOF/NVLZ(CUSFIN,1)*100 AS PAR_COMCOF,
       VLR_VENPIS/NVLZ(CUSFIN,1)*100 AS PAR_VENPIS,
       VLR_VENCOF/NVLZ(CUSFIN,1)*100 AS PAR_VENCOF,
       VLRSOC/NVLZ(CUSFIN,1)*100 AS PARCTS,
       VLRIVE/NVLZ(CUSFIN,1)*100 AS PARIVE,
       VLRCOM/NVLZ(CUSFIN,1)*100 AS PARCOM,
       VLROPE/NVLZ(CUSFIN,1)*100 AS PAROPE,
       VLRIRE/NVLZ(CUSFIN,1)*100 AS PARIRE,
       SEGITE/NVLZ(CUSFIN,1)*100 AS PARSEG,
       CUSAQS/NVLZ(CUSFIN,1)*100 AS PARAQS,
       MARGEM/NVLZ(CUSFIN,1)*100 AS PARMAR,
       ALIINT/NVLZ(CUSFIN,1)*100 AS PARALI,
       VLRFCP/NVLZ(CUSFIN,1)*100 AS PARFCP,
       IUF_PERFCP AS PERFCP,
       VLRFCP,
       PERICMESPVEN,
       VLRICMESPVEN,
       VLRICMESPVEN/NVLZ(CUSFIN,1)*100 AS PARICMESPVEN,
       PERICMESPCOM,
       VLRICMESPCOM,
       VLRICMESPCOM/NVLZ(CUSFIN,1)*100 AS PARICMESPCOM,
       CASE WHEN SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4))
            THEN 0
            ELSE ICMFRE
       END/NVLZ(CUSFIN,1)*100 AS PICFRE,
       PISFRE/NVLZ(CUSFIN,1)*100 AS PFRPIS,
       ST_FRE/NVLZ(CUSFIN,1)*100 AS PSTFRE,
       (OUTDESITE + DESPARITE)/NVLZ(CUSFIN,1)*100 AS PAROUT,
       VLRICMAGR/NVLZ(CUSFIN,1)*100 AS PARICMAGR,
       (OUTDESITE + DESPARITE) AS OUTRAS,
       PRECAL AS PREATU,
       0 AS DIFPRE,
       PERLUC AS LUCATU,
       --44499
       CASE BASE_MARKUP WHEN 'R' THEN (PRECAL - COALESCE(VLRCMG, 0)) / NVLZ(PRECAL,NULL)*100
                        WHEN 'I' THEN (PRECAL - COALESCE(CUSREP, 0)) / NVLZ(PRECAL,NULL)*100
                        WHEN 'B' THEN (PRECAL - COALESCE(VLRBRU, 0)) / NVLZ(PRECAL,NULL)*100
                        WHEN 'C' THEN (PRECAL - COALESCE(PRECOM_CIPI, 0)) / PRECAL*100
                        WHEN '1' THEN (PRECAL - (VLRCMG + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0))) / NVLZ(PRECAL,NULL)*100
                        WHEN '2' THEN (PRECAL - (CUSREP + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0))) / NVLZ(PRECAL,NULL)*100
                        WHEN '3' THEN (PRECAL - (VLRBRU + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0))) / NVLZ(PRECAL,NULL)*100
                        WHEN '4' THEN (PRECAL - (PRECOM_CIPI + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0))) / NVLZ(PRECAL,NULL)*100
       END AS MARKUPCAL, MARKUP,
       CUSREP,VLRCMG,
       --44499
       CASE BASE_MARKUP WHEN 'R' THEN VLRCMG -- CUSTO MEDIO
                        WHEN 'I' THEN CUSREP -- CUSTO DE REPOSICAO
                        WHEN 'B' THEN VLRBRU -- VALOR BRUTO
                        WHEN 'C' THEN PRECOM_CIPI -- PRECO DE COMPRA + IPI
                        WHEN '1' THEN (VLRCMG + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0)) -- CUSTO MEDIO + FRETE - ICMS DO FRETE - PIS E COFINS DO FRETE
                        WHEN '2' THEN (CUSREP + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0)) -- CUSTO DE REPOSICAO + FRETE - ICMS DO FRETE - PIS E COFINS DO FRETE
                        WHEN '3' THEN (VLRBRU + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0)) -- VALOR BRUTO + FRETE - ICMS DO FRETE - PIS E COFINS DO FRETE
                        WHEN '4' THEN (PRECOM_CIPI + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0)) -- PRECO DE COMPRA + IPI + FRETE - ICMS DO FRETE - PIS E COFINS DO FRETE
       END AS VLRMRK,PREPSI,REPGRA, MARGEM, ALIINT,
       DEPART, CLASS1, CLASS2, CLASS3, CLASS4, ALIFRE, AFICUS, ACRFIN, ICMSRE, RESICM, FATCON, REGTRI, TIPLUC, TRISIM, SUBTRI, IPIFRE, OUTDES, DESPAR, REDITE, MVACOM,
       VLRRET_ITE, DESESP, VLRDESESP,
       VLRRET_UNI,
       VLRRET_UNI/NVLZ(CUSFIN,1)*100 AS VLRRET_PAR,GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM, GRA_DATFPV,ST_FRE,
       FILPRE, CODPRE, VAREJO, DESPRE, CODNCM, TIPMPB, ORIPRO, SUBSTITUTA, PEROPEFIX, VLROPEFIX,
       ALIICMAGR, VLRICMAGR, MULTIP, ULTELA, DIAELA, CODMOE, TPR_SIGNAT, PIS_S_ICMS_VEN, PISCOF_SEMIPISAIDA,FOR060, 
       APRBON, APRBON/NVLZ(CUSFIN,1)*100 AS PARAPRBON, CLAABC, CLAXYZ, NOMCLI, ULTNOM, VLRUNI_ANT, QTDMOV_ANT, NOMCLI_ANT, ULTNOM_ANT, PERDIF_ULTCOM,
       IUF_PERFCP, DICM_RESICM, DICM_PERESPINTCOM, DICM_PERESPESTCOM, DICM_PERESPINTVEN, DICM_PERESPESTVEN, VLRICMANT, PERICMANT,
       DICM_COM_RESICM, DICM_COM_PERESPINTCOM, DICM_COM_PERESPESTCOM, DICM_COM_PERESPINTVEN, DICM_COM_PERESPESTVEN, UTILIZA_ICMS_ESPECIFICO,
       UFLOJA
FROM (
SELECT CODTAB,CODFIL,SEQUEN,FILFRE,SEQFRE,FILFOR,TIPPAR,CODFOR,UF_FOR,DATOPE,DATCMP,
       DOCUME,ATU_EM,VLRFRE,VLRSEG,ICMFRE,PISFRE,VLRTOT,DESCON,OUTTAX,
       VLRLIQ,OBSERV,NUMITE,FILMAT,CODMAT,CODCOR,CODTAM,QTDMOV,PAUTAF,SUBTRI,
       VLRMOV,VLRBRU,VLRPRE,IPIITE,ICMITE,COMPIS,COMCOF,VENPIS,VENCOF,PERSOC,PERSOC_R,PERIVE,
       PERCOM,PEROPE,PERIRE,PERIRE_R,PERLUC,ICMCOM,IPICOM,
       VLRSUB,SUBITE,VLRUNI,CUSAQS,PERTOT,FREITE,SEGITE,DESITE,
       TAXITE,VLRICM,VLRIPI,REFPRO,ORDDIV,ORDSUB,DESMAT,
       ESPMAT,ITEDIV,ITESUB,CODSER,SUBSER,NUMNOT,VMVIPI,PRECOV,SUBFED,
       TOTCOMFRE, ATUCUS,
       COALESCE(100-PERTOT-PERLUC,0) AS PERENC,
       --COALESCE(CUSAQS*COMPIS/PERTOT,0) AS VLR_COMPIS,
       --COALESCE(CUSAQS*COMCOF/PERTOT,0) AS VLR_COMCOF,
       VLR_COMCOF,
       VLR_COMPIS,
       PERICMESPVEN,
       COALESCE(CUSAQS*PERICMESPVEN/NVLZ(PERTOT,NULL), 0) AS VLRICMESPVEN,
       PERICMESPCOM,
       VLRICMESPCOM,
       COALESCE(CUSAQS*VENPIS/NVLZ(PERTOT,NULL), 0) AS VLR_VENPIS,
       COALESCE(CUSAQS*VENCOF/NVLZ(PERTOT,NULL), 0) AS VLR_VENCOF,
       COALESCE(CUSAQS*PERSOC_R/NVLZ(PERTOT,NULL),0) AS VLRSOC,
       COALESCE(CUSAQS*IUF_PERFCP/NVLZ(PERTOT,NULL),0) AS VLRFCP,
       -- MN - 101618 - Regras para zerar ICMS de venda: 1) Filial no for substituta; 2) Tabela de preos for Varejo ou Qualquer; 3) Filial for substituta, todavia est configurada para forar o CST 060, ou seja, no quer destacar ICMS na venda
       COALESCE(CUSAQS*CASE WHEN SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4) OR ((COALESCE(SUBSTITUTA,'F') = 'T') AND FOR060 = 'T')) THEN 0 ELSE PERIVE END/NVLZ(PERTOT,NULL),0) AS VLRIVE,
       COALESCE(CUSAQS*PEROPE/NVLZ(PERTOT,NULL),0) AS VLROPE,
       COALESCE(CUSAQS*PEROPEFIX/NVLZ(PERTOT,NULL),0) AS VLROPEFIX,
       COALESCE(CUSAQS*PERIRE_R/NVLZ(PERTOT,NULL),0) AS VLRIRE,
       COALESCE(CUSAQS*PERCOM/NVLZ(PERTOT,NULL),0) AS VLRCOM,
       COALESCE(CUSAQS*PERLUC/NVLZ(PERTOT,NULL),0) AS VLRLUC,
       COALESCE(CUSAQS/(NVLZ(PERTOT,NULL)/100),0) * (1 + AFICUS / 100)  AS PRECAL,
       COALESCE(CUSAQS/(NVLZ(PERTOT,NULL)/100),0) * (AFICUS / 100)  AS ACRFIN,
       COALESCE(CUSAQS,0)+
       COALESCE(CUSAQS*VENPIS/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*VENCOF/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*IUF_PERFCP/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PERICMESPVEN/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PERSOC_R/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*CASE WHEN SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4)) THEN 0 ELSE PERIVE END/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PEROPE/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PEROPEFIX/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PERIRE_R/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PERCOM/NVLZ(PERTOT,NULL),0) AS CUSFIN,
       CUSREP,VLRCMG,BASE_MARKUP,PRECOM_CIPI,MARKUP,PREPSI,REPGRA,
       -- RFMP 97041
       -- No mostramos mais Base de ST Unitrio
       -- CASE WHEN ICMTIP = '0' AND SUBTRI = '3' AND (COALESCE(SUBSTITUTA,'F') = 'F') AND SUBITE > 0
       --      THEN ((VLRUNI + VLRIPI + FREITE) * MARGEM / 100)
       --      ELSE 0
       -- END AS MARGEM,
       0 AS MARGEM,
       ALIINT,
       DEPART, CLASS1, CLASS2, CLASS3, CLASS4, ALIFRE, AFICUS, ICMSRE, RESICM, FATCON, REGTRI, TIPLUC, TRISIM, IPIFRE, OUTDES, DESPAR, OUTDESITE, DESPARITE, REDITE, MVACOM,
       VLRRET_ITE, DESESP, VLRDESESP,
       VLRRET_UNI,GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM, GRA_DATFPV, ST_FRE,
       FILPRE, CODPRE, VAREJO, DESPRE, CODNCM, TIPMPB, ORIPRO, SUBSTITUTA, ICMTIP, ICMTIPDIF, PEROPEFIX,
       ALIICMAGR, VLRICMAGR, MULTIP, ULTELA, DIAELA, CODMOE, TPR_SIGNAT, PIS_S_ICMS_VEN, PISCOF_SEMIPISAIDA,FOR060, APRBON, CLAABC, CLAXYZ, NOMCLI, ULTNOM, VLRUNI_ANT, QTDMOV_ANT, NOMCLI_ANT, ULTNOM_ANT, PERDIF_ULTCOM,
       IUF_PERFCP, DICM_RESICM, DICM_PERESPINTCOM, DICM_PERESPESTCOM, DICM_PERESPINTVEN, DICM_PERESPESTVEN, VLRICMANT, PERICMANT,
       DICM_COM_RESICM, DICM_COM_PERESPINTCOM, DICM_COM_PERESPESTCOM, DICM_COM_PERESPINTVEN, DICM_COM_PERESPESTVEN, UTILIZA_ICMS_ESPECIFICO,
       UFLOJA
FROM (
SELECT CODTAB,CODFIL,SEQUEN,FILFRE,SEQFRE,FILFOR,TIPPAR,CODFOR,UF_FOR,DATOPE,DATCMP,
       DOCUME,ATU_EM,VLRFRE,VLRSEG,ICMFRE,PISFRE,VLRTOT,DESCON,OUTTAX,
       VLRLIQ,OBSERV,NUMITE,FILMAT,CODMAT,CODCOR,CODTAM,QTDMOV,PAUTAF,SUBTRI,ICMTIP,ICMTIPDIF,
       VLRMOV,VLRBRU,VLRPRE,IPIITE,ICMITE,COMPIS,COMCOF,VENPIS,VENCOF,PERSOC,PERSOC_R,PERIVE,
       PERCOM,PEROPE,PERIRE,PERIRE_R,PERTOT,PERLUC,ICMCOM, VLR_COMPIS, VLR_COMCOF,
       IPICOM,VLRSUB,SUBITE,VLRUNI,FREITE,SEGITE,DESITE,TAXITE,
       VLRICM,VLRIPI,REFPRO,ORDDIV,ORDSUB,DESMAT,ESPMAT,SUBFED,
       ITEDIV,ITESUB,CODSER,SUBSER,NUMNOT,VMVIPI,PRECOV,TOTCOMFRE, ATUCUS,
       -- RFMP 97041
       -- No mostramos mais ICMS Retido. O ICMS ST Retido  apresentado no prprio SUBITE.
       -- CASE WHEN ICMTIP = '0' AND SUBTRI = '3' AND RETSUB = 'F' AND (COALESCE(SUBSTITUTA,'F') = 'F')
       --      THEN ((((VLRUNI + VLRIPI + FREITE) + ((VLRUNI + VLRIPI + FREITE) * MARGEM / 100)) * PERIVE / 100) * (1 - REDITE / 100)) - COALESCE(VLRICM,0) - COALESCE(ICMFRE,0)
       --      ELSE 0
       --  END AS ALIINT,
       0 AS ALIINT,
       COALESCE(VLRPRE,0)
       + COALESCE(VLRIPI,0)
       + COALESCE(FREITE,0)
       + COALESCE(SEGITE,0)
       + COALESCE(TAXITE,0)
       + COALESCE(OUTDESITE,0)
       + COALESCE(DESPARITE,0)
       + COALESCE(DESITE,0)
       + COALESCE(ST_FRE,0)
       + COALESCE(VLRDESESP, 0)
       - COALESCE(CASE WHEN REGTRI = 'N'
                       THEN VLR_COMPIS
                       ELSE 0
                   END,0)
       - COALESCE(CASE WHEN REGTRI = 'N'
                       THEN VLR_COMCOF
                       ELSE 0
                   END,0)
       - CASE WHEN FILFRE IS NOT NULL
         THEN COALESCE(PISFRE,0) --GES-2021111729 S diminui se o frete estiver no conhecimento de frete. Caso no tenha conhecimento o valor est imbutido no VLR_PIS/VLR_COFINS
         ELSE 0 
			END
       -- RFMP 97041
       -- Considera ICMS ST sempre que tiver sido calculado
       + VALOR_ST_UNI
       + CASE WHEN VALOR_ST_UNI = 0
              THEN
                   CASE WHEN ICMTIPDIF = '0' AND SUBTRI = '3' AND (COALESCE(SUBSTITUTA,'F') = 'F')
                        THEN 0
                        ELSE - COALESCE(CASE WHEN (SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4))) or COALESCE(ST_FRE,0)>0
                                             THEN 0
                                             ELSE ICMFRE
                                        END,0)
                             - COALESCE(CASE WHEN ((REGTRI = 'N') OR (REGTRI = 'S' AND (COALESCE(TRISIM,'X') = 'O'))) AND (SUBTRI <> '3' OR (ICMTIPDIF = '0' AND (COALESCE(SUBSTITUTA,'F') = 'T')))
                                             THEN VLRICM
                                             ELSE 0
                                        END,0)
                   END
              ELSE 0
         END
       + COALESCE(VLRICMESPCOM, 0)
       + COALESCE(VLRICMANT, 0)
       - COALESCE(VLRICMAGR, 0) 
       - COALESCE(APRBON, 0) AS CUSAQS,
       CUSREP,VLRCMG,BASE_MARKUP,PRECOM_CIPI,MARKUP,PREPSI,REPGRA, MARGEM,
       DEPART, CLASS1, CLASS2, CLASS3, CLASS4, ALIFRE, AFICUS, ICMSRE, RESICM, FATCON, REGTRI, TIPLUC, TRISIM, IPIFRE, OUTDES, DESPAR, OUTDESITE, DESPARITE, REDITE, MVACOM,
       VLRRET_ITE, DESESP, VLRDESESP,
       VLRRET_UNI,GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM, GRA_DATFPV, ST_FRE,
       FILPRE, CODPRE, VAREJO, DESPRE, CODNCM, TIPMPB, ORIPRO, SUBSTITUTA, PEROPEFIX,
       ALIICMAGR, VLRICMAGR, MULTIP, ULTELA, DIAELA, CODMOE, TPR_SIGNAT, PIS_S_ICMS_VEN, PISCOF_SEMIPISAIDA,FOR060, APRBON, CLAABC, CLAXYZ, NOMCLI, ULTNOM, VLRUNI_ANT, QTDMOV_ANT, NOMCLI_ANT, ULTNOM_ANT, PERDIF_ULTCOM,
       IUF_PERFCP, DICM_RESICM, DICM_PERESPINTCOM, DICM_PERESPESTCOM, DICM_PERESPINTVEN, DICM_PERESPESTVEN, VLRICMANT, PERICMANT,
       DICM_COM_RESICM, DICM_COM_PERESPINTCOM, DICM_COM_PERESPESTCOM, DICM_COM_PERESPINTVEN, DICM_COM_PERESPESTVEN, UTILIZA_ICMS_ESPECIFICO,
       VLRICMESPCOM, PERICMESPVEN, PERICMESPCOM, UFLOJA
FROM ( SELECT CODTAB,CODFIL,SEQUEN,FILFRE,SEQFRE,FILFOR,TIPPAR,CODFOR,UF_FOR,DATOPE,DATCMP,DOCUME,ATU_EM,VLRFRE,VLRSEG,VLRTOT,DESCON,OUTTAX,VLRLIQ,OBSERV,
 NUMITE,FILMAT,CODMAT,CODCOR,CODTAM,QTDMOV,PAUTAF,SUBTRI,VLRMOV,VLRBRU,VLRPRE,IPIITE,ICMITE,COMPIS,COMCOF,VENPIS,VENCOF,PERSOC,PERSOC_R,PERIVE,PERCOM,PEROPE,
 PERIRE,PERIRE_R,PERLUC,PERTOT,REFPRO,VLR_COMPIS,VLR_COMCOF,ORDDIV,ORDSUB,DESMAT,ESPMAT,ITEDIV,ITESUB,VLRUNI,CODSER,SUBSER,NUMNOT,VMVIPI,PRECOV,TOTCOMFRE,
 ICMCOM,IPICOM,VLRICM,ICMTIP,ICMTIPDIF,MARGEM,VLRIPI,FREITE,SEGITE,ICMFRE,PISFRE,DESITE,TAXITE,OUTDESITE,DESPARITE,SUBFED,VLRSUB,SUBITE,CUSREP,VLRCMG,BASE_MARKUP,
 PRECOM_CIPI,REGTRI,TIPLUC,TRISIM,MARKUP,PREPSI,REPGRA,DEPART,CLASS1,CLASS2,CLASS3,CLASS4,ALIFRE,AFICUS,ICMSRE,RESICM,FATCON,IPIFRE,OUTDES,DESPAR,REDITE,MVACOM,
 VLRRET_ITE,DESESP, VLRDESESP, VLRRET_UNI,RETSUB,GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM, GRA_DATFPV,
 COALESCE(CASE WHEN (COALESCE(SUBSTITUTA,'F') = 'T') AND ICMTIPDIF='0' AND SUBTRI = '3' THEN
                  CASE WHEN VAREJO in (0, 2, 4)
                       THEN -- VAREJO
                           -- Calcular ST do frete a partir de um item tributado
                           -- Valor do Item = Valor do Frete
                           -- Base de ST = Valor do Item * (1 + percentual MVA) * (1 - percentual Reducao da Base de Calculo)
                           -- Valor de ST = (Base de ST * percentual ICMS para Venda) - ICMS Proprio
                           COALESCE(
                           ((FREITE+COALESCE(IPIFRE,0)) *
                           (1+(
                               MVAVEN --DN Deve pegar MVA interno pois a transferencia sera no estado
                               /100)) *
                           (1-(COALESCE(REDCON,0)/100)) * --DN  Esta reducao nao deve ser a da compra e sim a da venda
                           (RESICM/100)
                           )-ICMFRE,0)
                       ELSE -- ATACADO
                           ST_FRE
                  END
         ELSE
              ST_FRE
         END,0) AS ST_FRE,
 PERICMESPVEN, PERICMESPCOM, VLRICMESPCOM,
 ATUCUS, FILPRE, CODPRE, VAREJO, DESPRE, CODNCM, TIPMPB, ORIPRO, SUBSTITUTA, PEROPEFIX,
 ALIICMAGR, VLRICMAGR, MULTIP, ULTELA, DIAELA, CODMOE, TPR_SIGNAT, VALOR_ST_UNI, PIS_S_ICMS_VEN, PISCOF_SEMIPISAIDA,FOR060, APRBON, CLAABC, CLAXYZ, NOMCLI, ULTNOM, VLRUNI_ANT, QTDMOV_ANT, NOMCLI_ANT, ULTNOM_ANT, PERDIF_ULTCOM,
 UFLOJA, IUF_PERFCP, DICM_RESICM, DICM_PERESPINTCOM, DICM_PERESPESTCOM, DICM_PERESPINTVEN, DICM_PERESPESTVEN, VLRICMANT, PERICMANT,
 DICM_COM_RESICM, DICM_COM_PERESPINTCOM, DICM_COM_PERESPESTCOM, DICM_COM_PERESPINTVEN, DICM_COM_PERESPESTVEN, UTILIZA_ICMS_ESPECIFICO
 FROM TV_FPV_INT FPV ) TAB ) TAB ) TAB; 

/*-- SEQ 2826 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FPV_GRA_TOT CASCADE;

/*-- SEQ 2827 --*/
CREATE OR REPLACE VIEW TV_FPV_GRA_TOT AS SELECT CODTAB,CODFIL,SEQUEN,FILFRE,SEQFRE,FILFOR,TIPPAR,CODFOR,UF_FOR,DATOPE,DATCMP,
       DOCUME,ATU_EM,VLRFRE,VLRSEG,
       CASE WHEN SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4))
            THEN 0
            ELSE ICMFRE
       END AS ICMFRE,
       PISFRE,VLRTOT,DESCON,OUTTAX,
       VLRLIQ,OBSERV,NUMITE,FILMAT,CODMAT,CODCOR,CODTAM,QTDMOV,PAUTAF,
       VLRMOV,VLRBRU,VLRPRE,IPIITE,ICMITE,COMPIS,COMCOF,VENPIS,VENCOF,PERSOC, PERSOC_R,
       CASE WHEN SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4)) THEN 0 ELSE PERIVE END AS PERIVE,
       PERIVE AS PERIVE_PERTOT,
       PERCOM,PEROPE,PERIRE,PERIRE_R,PERLUC,PERENC,ICMCOM,IPICOM,
       VLRSUB,SUBITE,VLRUNI,CUSAQS,PERTOT,FREITE,SEGITE,DESITE,SUBFED,
       TAXITE,VLRICM,VLRIPI,VLR_COMPIS,VLR_COMCOF,VLR_VENPIS,VLR_VENCOF,VLRSOC,VLRIVE,VLROPE,
       VLRCOM,VLRLUC,PRECAL,CUSFIN,REFPRO,ORDDIV,ORDSUB,VLRIRE,
       DESMAT,ESPMAT,ITEDIV,ITESUB,CODSER,SUBSER,NUMNOT,VMVIPI,
       PRECOV,TOTCOMFRE,ATUCUS,
       (((PRECAL-PRECOV)/NVLZ(PRECAL,NULL))*100) AS PERDIF,
       CUSFIN-(VLRPRE-VLRICM) AS VLRENC,
       VLRUNI/NVLZ(CUSFIN,1)*100 AS PARVLR,
       DESITE/NVLZ(CUSFIN,1)*100 AS PARDES,
       VLRIPI/NVLZ(CUSFIN,1)*100 AS PARIPI,
       VLRICM/NVLZ(CUSFIN,1)*100 AS PARICM,
       VLRICMANT /NVLZ(CUSFIN,1)*100 AS PARVLRICMANT,
       SUBITE/NVLZ(CUSFIN,1)*100 AS PARSUB,
       FREITE/NVLZ(CUSFIN,1)*100 AS PARFRE,
       VLRDESESP/NVLZ(CUSFIN,1)*100 AS PARDESESP,
       TAXITE/NVLZ(CUSFIN,1)*100 AS PARTAX,
       VLR_COMPIS/NVLZ(CUSFIN,1)*100 AS PAR_COMPIS,
       VLR_COMCOF/NVLZ(CUSFIN,1)*100 AS PAR_COMCOF,
       VLR_VENPIS/NVLZ(CUSFIN,1)*100 AS PAR_VENPIS,
       VLR_VENCOF/NVLZ(CUSFIN,1)*100 AS PAR_VENCOF,
       VLRSOC/NVLZ(CUSFIN,1)*100 AS PARCTS,
       VLRIVE/NVLZ(CUSFIN,1)*100 AS PARIVE,
       VLRCOM/NVLZ(CUSFIN,1)*100 AS PARCOM,
       VLROPE/NVLZ(CUSFIN,1)*100 AS PAROPE,
       VLRIRE/NVLZ(CUSFIN,1)*100 AS PARIRE,
       SEGITE/NVLZ(CUSFIN,1)*100 AS PARSEG,
       CUSAQS/NVLZ(CUSFIN,1)*100 AS PARAQS,
       MARGEM/NVLZ(CUSFIN,1)*100 AS PARMAR,
       ALIINT/NVLZ(CUSFIN,1)*100 AS PARALI,
       VLRFCP/NVLZ(CUSFIN,1)*100 AS PARFCP,
       IUF_PERFCP AS PERFCP,
       VLRFCP,
       PERICMESPVEN,
       VLRICMESPVEN,
       VLRICMESPVEN/NVLZ(CUSFIN,1)*100 AS PARICMESPVEN,
       PERICMESPCOM,
       VLRICMESPCOM,
       VLRICMESPCOM/NVLZ(CUSFIN,1)*100 AS PARICMESPCOM,
       CASE WHEN SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4))
            THEN 0
            ELSE ICMFRE
       END/NVLZ(CUSFIN,1)*100 AS PICFRE,
       PISFRE/NVLZ(CUSFIN,1)*100 AS PFRPIS,
       ST_FRE/NVLZ(CUSFIN,1)*100 AS PSTFRE,
       (OUTDESITE + DESPARITE)/NVLZ(CUSFIN,1)*100 AS PAROUT,
       VLRICMAGR/NVLZ(CUSFIN,1)*100 AS PARICMAGR,
       (OUTDESITE + DESPARITE) AS OUTRAS,
       PRECAL AS PREATU,
       0 AS DIFPRE,
       PERLUC AS LUCATU,
       --44499
       CASE BASE_MARKUP WHEN 'R' THEN (PRECAL - COALESCE(VLRCMG, 0)) / NVLZ(PRECAL,NULL)*100
                        WHEN 'I' THEN (PRECAL - COALESCE(CUSREP, 0)) / NVLZ(PRECAL,NULL)*100
                        WHEN 'B' THEN (PRECAL - COALESCE(VLRBRU, 0)) / NVLZ(PRECAL,NULL)*100
                        WHEN 'C' THEN (PRECAL - COALESCE(PRECOM_CIPI, 0)) / PRECAL*100
                        WHEN '1' THEN (PRECAL - (VLRCMG + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0))) / NVLZ(PRECAL,NULL)*100
                        WHEN '2' THEN (PRECAL - (CUSREP + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0))) / NVLZ(PRECAL,NULL)*100
                        WHEN '3' THEN (PRECAL - (VLRBRU + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0))) / NVLZ(PRECAL,NULL)*100
                        WHEN '4' THEN (PRECAL - (PRECOM_CIPI + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0))) / NVLZ(PRECAL,NULL)*100
       END AS MARKUPCAL, MARKUP,
       CUSREP,VLRCMG,
       --44499
       CASE BASE_MARKUP WHEN 'R' THEN VLRCMG -- CUSTO MEDIO
                        WHEN 'I' THEN CUSREP -- CUSTO DE REPOSICAO
                        WHEN 'B' THEN VLRBRU -- VALOR BRUTO
                        WHEN 'C' THEN PRECOM_CIPI -- PRECO DE COMPRA + IPI
                        WHEN '1' THEN (VLRCMG + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0)) -- CUSTO MEDIO + FRETE - ICMS DO FRETE - PIS E COFINS DO FRETE
                        WHEN '2' THEN (CUSREP + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0)) -- CUSTO DE REPOSICAO + FRETE - ICMS DO FRETE - PIS E COFINS DO FRETE
                        WHEN '3' THEN (VLRBRU + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0)) -- VALOR BRUTO + FRETE - ICMS DO FRETE - PIS E COFINS DO FRETE
                        WHEN '4' THEN (PRECOM_CIPI + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0)) -- PRECO DE COMPRA + IPI + FRETE - ICMS DO FRETE - PIS E COFINS DO FRETE
       END AS VLRMRK,PREPSI,REPGRA, MARGEM, ALIINT,
       DEPART, CLASS1, CLASS2, CLASS3, CLASS4, ALIFRE, AFICUS, ACRFIN, ICMSRE, RESICM, FATCON, REGTRI, TIPLUC, TRISIM, SUBTRI, IPIFRE, OUTDES, DESPAR, REDITE, MVACOM,
       VLRRET_ITE, DESESP, VLRDESESP,
       VLRRET_UNI,
       VLRRET_UNI/NVLZ(CUSFIN,1)*100 AS VLRRET_PAR,GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM, GRA_DATFPV,ST_FRE,
       FILPRE, CODPRE, VAREJO, DESPRE, CODNCM, TIPMPB, ORIPRO, SUBSTITUTA, PEROPEFIX, VLROPEFIX,
       ALIICMAGR, VLRICMAGR, MULTIP, ULTELA, DIAELA, CODMOE, TPR_SIGNAT, PIS_S_ICMS_VEN, PISCOF_SEMIPISAIDA,FOR060, 
       APRBON, APRBON/NVLZ(CUSFIN,1)*100 AS PARAPRBON, CLAABC, CLAXYZ, NOMCLI, ULTNOM, VLRUNI_ANT, QTDMOV_ANT, NOMCLI_ANT, ULTNOM_ANT, PERDIF_ULTCOM,
       IUF_PERFCP, DICM_RESICM, DICM_PERESPINTCOM, DICM_PERESPESTCOM, DICM_PERESPINTVEN, DICM_PERESPESTVEN, VLRICMANT, PERICMANT,
       DICM_COM_RESICM, DICM_COM_PERESPINTCOM, DICM_COM_PERESPESTCOM, DICM_COM_PERESPINTVEN, DICM_COM_PERESPESTVEN, UTILIZA_ICMS_ESPECIFICO,
       UFLOJA
FROM (
SELECT CODTAB,CODFIL,SEQUEN,FILFRE,SEQFRE,FILFOR,TIPPAR,CODFOR,UF_FOR,DATOPE,DATCMP,
       DOCUME,ATU_EM,VLRFRE,VLRSEG,ICMFRE,PISFRE,VLRTOT,DESCON,OUTTAX,
       VLRLIQ,OBSERV,NUMITE,FILMAT,CODMAT,CODCOR,CODTAM,QTDMOV,PAUTAF,SUBTRI,
       VLRMOV,VLRBRU,VLRPRE,IPIITE,ICMITE,COMPIS,COMCOF,VENPIS,VENCOF,PERSOC,PERSOC_R,PERIVE,
       PERCOM,PEROPE,PERIRE,PERIRE_R,PERLUC,ICMCOM,IPICOM,
       VLRSUB,SUBITE,VLRUNI,CUSAQS,PERTOT,FREITE,SEGITE,DESITE,
       TAXITE,VLRICM,VLRIPI,REFPRO,ORDDIV,ORDSUB,DESMAT,
       ESPMAT,ITEDIV,ITESUB,CODSER,SUBSER,NUMNOT,VMVIPI,PRECOV,SUBFED,
       TOTCOMFRE, ATUCUS,
       COALESCE(100-PERTOT-PERLUC,0) AS PERENC,
       --COALESCE(CUSAQS*COMPIS/PERTOT,0) AS VLR_COMPIS,
       --COALESCE(CUSAQS*COMCOF/PERTOT,0) AS VLR_COMCOF,
       VLR_COMCOF,
       VLR_COMPIS,
       PERICMESPVEN,
       COALESCE(CUSAQS*PERICMESPVEN/NVLZ(PERTOT,NULL), 0) AS VLRICMESPVEN,
       PERICMESPCOM,
       VLRICMESPCOM,
       COALESCE(CUSAQS*VENPIS/NVLZ(PERTOT,NULL), 0) AS VLR_VENPIS,
       COALESCE(CUSAQS*VENCOF/NVLZ(PERTOT,NULL), 0) AS VLR_VENCOF,
       COALESCE(CUSAQS*PERSOC_R/NVLZ(PERTOT,NULL),0) AS VLRSOC,
       COALESCE(CUSAQS*IUF_PERFCP/NVLZ(PERTOT,NULL),0) AS VLRFCP,
       -- MN - 101618 - Regras para zerar ICMS de venda: 1) Filial no for substituta; 2) Tabela de preos for Varejo ou Qualquer; 3) Filial for substituta, todavia est configurada para forar o CST 060, ou seja, no quer destacar ICMS na venda
       COALESCE(CUSAQS*CASE WHEN SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4) OR ((COALESCE(SUBSTITUTA,'F') = 'T') AND FOR060 = 'T')) THEN 0 ELSE PERIVE END/NVLZ(PERTOT,NULL),0) AS VLRIVE,
       COALESCE(CUSAQS*PEROPE/NVLZ(PERTOT,NULL),0) AS VLROPE,
       COALESCE(CUSAQS*PEROPEFIX/NVLZ(PERTOT,NULL),0) AS VLROPEFIX,
       COALESCE(CUSAQS*PERIRE_R/NVLZ(PERTOT,NULL),0) AS VLRIRE,
       COALESCE(CUSAQS*PERCOM/NVLZ(PERTOT,NULL),0) AS VLRCOM,
       COALESCE(CUSAQS*PERLUC/NVLZ(PERTOT,NULL),0) AS VLRLUC,
       COALESCE(CUSAQS/(NVLZ(PERTOT,NULL)/100),0) * (1 + AFICUS / 100)  AS PRECAL,
       COALESCE(CUSAQS/(NVLZ(PERTOT,NULL)/100),0) * (AFICUS / 100)  AS ACRFIN,
       COALESCE(CUSAQS,0)+
       COALESCE(CUSAQS*VENPIS/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*VENCOF/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*IUF_PERFCP/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PERICMESPVEN/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PERSOC_R/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*CASE WHEN SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4)) THEN 0 ELSE PERIVE END/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PEROPE/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PEROPEFIX/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PERIRE_R/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PERCOM/NVLZ(PERTOT,NULL),0) AS CUSFIN,
       CUSREP,VLRCMG,BASE_MARKUP,PRECOM_CIPI,MARKUP,PREPSI,REPGRA,
       -- RFMP 97041
       -- No mostramos mais Base de ST Unitrio
       -- CASE WHEN ICMTIP = '0' AND SUBTRI = '3' AND (COALESCE(SUBSTITUTA,'F') = 'F') AND SUBITE > 0
       --      THEN ((VLRUNI + VLRIPI + FREITE) * MARGEM / 100)
       --      ELSE 0
       -- END AS MARGEM,
       0 AS MARGEM,
       ALIINT,
       DEPART, CLASS1, CLASS2, CLASS3, CLASS4, ALIFRE, AFICUS, ICMSRE, RESICM, FATCON, REGTRI, TIPLUC, TRISIM, IPIFRE, OUTDES, DESPAR, OUTDESITE, DESPARITE, REDITE, MVACOM,
       VLRRET_ITE, DESESP, VLRDESESP,
       VLRRET_UNI,GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM, GRA_DATFPV, ST_FRE,
       FILPRE, CODPRE, VAREJO, DESPRE, CODNCM, TIPMPB, ORIPRO, SUBSTITUTA, ICMTIP, ICMTIPDIF, PEROPEFIX,
       ALIICMAGR, VLRICMAGR, MULTIP, ULTELA, DIAELA, CODMOE, TPR_SIGNAT, PIS_S_ICMS_VEN, PISCOF_SEMIPISAIDA,FOR060, APRBON, CLAABC, CLAXYZ, NOMCLI, ULTNOM, VLRUNI_ANT, QTDMOV_ANT, NOMCLI_ANT, ULTNOM_ANT, PERDIF_ULTCOM,
       IUF_PERFCP, DICM_RESICM, DICM_PERESPINTCOM, DICM_PERESPESTCOM, DICM_PERESPINTVEN, DICM_PERESPESTVEN, VLRICMANT, PERICMANT,
       DICM_COM_RESICM, DICM_COM_PERESPINTCOM, DICM_COM_PERESPESTCOM, DICM_COM_PERESPINTVEN, DICM_COM_PERESPESTVEN, UTILIZA_ICMS_ESPECIFICO,
       UFLOJA
FROM (
SELECT CODTAB,CODFIL,SEQUEN,FILFRE,SEQFRE,FILFOR,TIPPAR,CODFOR,UF_FOR,DATOPE,DATCMP,
       DOCUME,ATU_EM,VLRFRE,VLRSEG,ICMFRE,PISFRE,VLRTOT,DESCON,OUTTAX,
       VLRLIQ,OBSERV,NUMITE,FILMAT,CODMAT,CODCOR,CODTAM,QTDMOV,PAUTAF,SUBTRI,ICMTIP,ICMTIPDIF,
       VLRMOV,VLRBRU,VLRPRE,IPIITE,ICMITE,COMPIS,COMCOF,VENPIS,VENCOF,PERSOC,PERSOC_R,PERIVE,
       PERCOM,PEROPE,PERIRE,PERIRE_R,PERTOT,PERLUC,ICMCOM, VLR_COMPIS, VLR_COMCOF,
       IPICOM,VLRSUB,SUBITE,VLRUNI,FREITE,SEGITE,DESITE,TAXITE,
       VLRICM,VLRIPI,REFPRO,ORDDIV,ORDSUB,DESMAT,ESPMAT,SUBFED,
       ITEDIV,ITESUB,CODSER,SUBSER,NUMNOT,VMVIPI,PRECOV,TOTCOMFRE, ATUCUS,
       -- RFMP 97041
       -- No mostramos mais ICMS Retido. O ICMS ST Retido  apresentado no prprio SUBITE.
       -- CASE WHEN ICMTIP = '0' AND SUBTRI = '3' AND RETSUB = 'F' AND (COALESCE(SUBSTITUTA,'F') = 'F')
       --      THEN ((((VLRUNI + VLRIPI + FREITE) + ((VLRUNI + VLRIPI + FREITE) * MARGEM / 100)) * PERIVE / 100) * (1 - REDITE / 100)) - COALESCE(VLRICM,0) - COALESCE(ICMFRE,0)
       --      ELSE 0
       --  END AS ALIINT,
       0 AS ALIINT,
       COALESCE(VLRPRE,0)
       + COALESCE(VLRIPI,0)
       + COALESCE(FREITE,0)
       + COALESCE(SEGITE,0)
       + COALESCE(TAXITE,0)
       + COALESCE(OUTDESITE,0)
       + COALESCE(DESPARITE,0)
       + COALESCE(DESITE,0)
       + COALESCE(ST_FRE,0)
       + COALESCE(VLRDESESP, 0)
       - COALESCE(CASE WHEN REGTRI = 'N'
                       THEN VLR_COMPIS
                       ELSE 0
                   END,0)
       - COALESCE(CASE WHEN REGTRI = 'N'
                       THEN VLR_COMCOF
                       ELSE 0
                   END,0)
       - CASE WHEN FILFRE IS NOT NULL
         THEN COALESCE(PISFRE,0) --GES-2021111729 S diminui se o frete estiver no conhecimento de frete. Caso no tenha conhecimento o valor est imbutido no VLR_PIS/VLR_COFINS
         ELSE 0 
			END
       -- RFMP 97041
       -- Considera ICMS ST sempre que tiver sido calculado
       + VALOR_ST_UNI
       + CASE WHEN VALOR_ST_UNI = 0
              THEN
                   CASE WHEN ICMTIPDIF = '0' AND SUBTRI = '3' AND (COALESCE(SUBSTITUTA,'F') = 'F')
                        THEN 0
                        ELSE - COALESCE(CASE WHEN (SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4))) or COALESCE(ST_FRE,0)>0
                                             THEN 0
                                             ELSE ICMFRE
                                        END,0)
                             - COALESCE(CASE WHEN ((REGTRI = 'N') OR (REGTRI = 'S' AND (COALESCE(TRISIM,'X') = 'O'))) AND (SUBTRI <> '3' OR (ICMTIPDIF = '0' AND (COALESCE(SUBSTITUTA,'F') = 'T')))
                                             THEN VLRICM
                                             ELSE 0
                                        END,0)
                   END
              ELSE 0
         END
       + COALESCE(VLRICMESPCOM, 0)
       + COALESCE(VLRICMANT, 0)
       - COALESCE(VLRICMAGR, 0) 
       - COALESCE(APRBON, 0) AS CUSAQS,
       CUSREP,VLRCMG,BASE_MARKUP,PRECOM_CIPI,MARKUP,PREPSI,REPGRA, MARGEM,
       DEPART, CLASS1, CLASS2, CLASS3, CLASS4, ALIFRE, AFICUS, ICMSRE, RESICM, FATCON, REGTRI, TIPLUC, TRISIM, IPIFRE, OUTDES, DESPAR, OUTDESITE, DESPARITE, REDITE, MVACOM,
       VLRRET_ITE, DESESP, VLRDESESP,
       VLRRET_UNI,GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM, GRA_DATFPV, ST_FRE,
       FILPRE, CODPRE, VAREJO, DESPRE, CODNCM, TIPMPB, ORIPRO, SUBSTITUTA, PEROPEFIX,
       ALIICMAGR, VLRICMAGR, MULTIP, ULTELA, DIAELA, CODMOE, TPR_SIGNAT, PIS_S_ICMS_VEN, PISCOF_SEMIPISAIDA,FOR060, APRBON, CLAABC, CLAXYZ, NOMCLI, ULTNOM, VLRUNI_ANT, QTDMOV_ANT, NOMCLI_ANT, ULTNOM_ANT, PERDIF_ULTCOM,
       IUF_PERFCP, DICM_RESICM, DICM_PERESPINTCOM, DICM_PERESPESTCOM, DICM_PERESPINTVEN, DICM_PERESPESTVEN, VLRICMANT, PERICMANT,
       DICM_COM_RESICM, DICM_COM_PERESPINTCOM, DICM_COM_PERESPESTCOM, DICM_COM_PERESPINTVEN, DICM_COM_PERESPESTVEN, UTILIZA_ICMS_ESPECIFICO,
       VLRICMESPCOM, PERICMESPVEN, PERICMESPCOM, UFLOJA
FROM ( SELECT CODTAB,CODFIL,SEQUEN,FILFRE,SEQFRE,FILFOR,TIPPAR,CODFOR,UF_FOR,DATOPE,DATCMP,DOCUME,ATU_EM,VLRFRE,VLRSEG,VLRTOT,DESCON,OUTTAX,VLRLIQ,OBSERV,
NUMITE,FILMAT,CODMAT,CODCOR,CODTAM,QTDMOV,PAUTAF,SUBTRI,VLRMOV,VLRBRU,VLRPRE,IPIITE,ICMITE,COMPIS,COMCOF,VENPIS,VENCOF,PERSOC,PERSOC_R,PERIVE,PERCOM,PEROPE,
PERIRE,PERIRE_R,PERLUC,PERTOT,REFPRO,VLR_COMPIS,VLR_COMCOF,ORDDIV,ORDSUB,DESMAT,ESPMAT,ITEDIV,ITESUB,VLRUNI,CODSER,SUBSER,NUMNOT,VMVIPI,PRECOV,TOTCOMFRE,
ICMCOM,IPICOM,VLRICM,ICMTIP,ICMTIPDIF,MARGEM,VLRIPI,FREITE,SEGITE,ICMFRE,PISFRE,DESITE,TAXITE,OUTDESITE,DESPARITE,SUBFED,VLRSUB,SUBITE,CUSREP,VLRCMG,BASE_MARKUP,
PRECOM_CIPI,REGTRI,TIPLUC,TRISIM,MARKUP,PREPSI,REPGRA,DEPART,CLASS1,CLASS2,CLASS3,CLASS4,ALIFRE,AFICUS,ICMSRE,RESICM,FATCON,IPIFRE,OUTDES,DESPAR,REDITE,MVACOM,
VLRRET_ITE,DESESP, VLRDESESP, VLRRET_UNI,RETSUB,GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM, GRA_DATFPV,
ST_FRE, PERICMESPVEN, PERICMESPCOM, VLRICMESPCOM,
ATUCUS, FILPRE, CODPRE, VAREJO, DESPRE, CODNCM, TIPMPB, ORIPRO, SUBSTITUTA, PEROPEFIX,
ALIICMAGR, VLRICMAGR, MULTIP, ULTELA, DIAELA, CODMOE, TPR_SIGNAT, VALOR_ST_UNI, PIS_S_ICMS_VEN, PISCOF_SEMIPISAIDA,FOR060, APRBON, CLAABC, CLAXYZ, NOMCLI, ULTNOM, VLRUNI_ANT, QTDMOV_ANT, NOMCLI_ANT, ULTNOM_ANT, PERDIF_ULTCOM,
UFLOJA, IUF_PERFCP, DICM_RESICM, DICM_PERESPINTCOM, DICM_PERESPESTCOM, DICM_PERESPINTVEN, DICM_PERESPESTVEN, VLRICMANT, PERICMANT,
DICM_COM_RESICM, DICM_COM_PERESPINTCOM, DICM_COM_PERESPESTCOM, DICM_COM_PERESPINTVEN, DICM_COM_PERESPESTVEN, UTILIZA_ICMS_ESPECIFICO
 FROM TV_FPV_GRA_INT FPV ) TAB ) TAB ) TAB; 

/*-- SEQ 2828 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FPV_PXF_TOT CASCADE;

/*-- SEQ 2829 --*/
CREATE OR REPLACE VIEW TV_FPV_PXF_TOT AS SELECT CODTAB,CODFIL,SEQUEN,FILFRE,SEQFRE,FILFOR,TIPPAR,CODFOR,UF_FOR,DATOPE,DATCMP,
       DOCUME,ATU_EM,VLRFRE,VLRSEG,
       CASE WHEN SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4))
            THEN 0
            ELSE ICMFRE
       END AS ICMFRE,
       PISFRE,VLRTOT,DESCON,OUTTAX,
       VLRLIQ,OBSERV,NUMITE,FILMAT,CODMAT,CODCOR,CODTAM,QTDMOV,PAUTAF,
       VLRMOV,VLRBRU,VLRPRE,IPIITE,ICMITE,COMPIS,COMCOF,VENPIS,VENCOF,PERSOC, PERSOC_R,
       CASE WHEN SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4)) THEN 0 ELSE PERIVE END AS PERIVE,
       PERIVE AS PERIVE_PERTOT,
       PERCOM,PEROPE,PERIRE,PERIRE_R,PERLUC,PERENC,ICMCOM,IPICOM,
       VLRSUB,SUBITE,VLRUNI,CUSAQS,PERTOT,FREITE,SEGITE,DESITE,SUBFED,
       TAXITE,VLRICM,VLRIPI,VLR_COMPIS,VLR_COMCOF,VLR_VENPIS,VLR_VENCOF,VLRSOC,VLRIVE,VLROPE,
       VLRCOM,VLRLUC,PRECAL,CUSFIN,REFPRO,ORDDIV,ORDSUB,VLRIRE,
       DESMAT,ESPMAT,ITEDIV,ITESUB,CODSER,SUBSER,NUMNOT,VMVIPI,
       PRECOV,TOTCOMFRE,ATUCUS,
       (((PRECAL-PRECOV)/NVLZ(PRECAL,NULL))*100) AS PERDIF,
       CUSFIN-(VLRPRE-VLRICM) AS VLRENC,
       VLRUNI/NVLZ(CUSFIN,1)*100 AS PARVLR,
       DESITE/NVLZ(CUSFIN,1)*100 AS PARDES,
       VLRIPI/NVLZ(CUSFIN,1)*100 AS PARIPI,
       VLRICM/NVLZ(CUSFIN,1)*100 AS PARICM,
       VLRICMANT /NVLZ(CUSFIN,1)*100 AS PARVLRICMANT,
       SUBITE/NVLZ(CUSFIN,1)*100 AS PARSUB,
       FREITE/NVLZ(CUSFIN,1)*100 AS PARFRE,
       VLRDESESP/NVLZ(CUSFIN,1)*100 AS PARDESESP,
       TAXITE/NVLZ(CUSFIN,1)*100 AS PARTAX,
       VLR_COMPIS/NVLZ(CUSFIN,1)*100 AS PAR_COMPIS,
       VLR_COMCOF/NVLZ(CUSFIN,1)*100 AS PAR_COMCOF,
       VLR_VENPIS/NVLZ(CUSFIN,1)*100 AS PAR_VENPIS,
       VLR_VENCOF/NVLZ(CUSFIN,1)*100 AS PAR_VENCOF,
       VLRSOC/NVLZ(CUSFIN,1)*100 AS PARCTS,
       VLRIVE/NVLZ(CUSFIN,1)*100 AS PARIVE,
       VLRCOM/NVLZ(CUSFIN,1)*100 AS PARCOM,
       VLROPE/NVLZ(CUSFIN,1)*100 AS PAROPE,
       VLRIRE/NVLZ(CUSFIN,1)*100 AS PARIRE,
       SEGITE/NVLZ(CUSFIN,1)*100 AS PARSEG,
       CUSAQS/NVLZ(CUSFIN,1)*100 AS PARAQS,
       MARGEM/NVLZ(CUSFIN,1)*100 AS PARMAR,
       ALIINT/NVLZ(CUSFIN,1)*100 AS PARALI,
       VLRFCP/NVLZ(CUSFIN,1)*100 AS PARFCP,
       IUF_PERFCP AS PERFCP,
       VLRFCP,
       PERICMESPVEN,
       VLRICMESPVEN,
       VLRICMESPVEN/NVLZ(CUSFIN,1)*100 AS PARICMESPVEN,
       PERICMESPCOM,
       VLRICMESPCOM,
       VLRICMESPCOM/NVLZ(CUSFIN,1)*100 AS PARICMESPCOM,
       CASE WHEN SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4))
            THEN 0
            ELSE ICMFRE
       END/NVLZ(CUSFIN,1)*100 AS PICFRE,
       PISFRE/NVLZ(CUSFIN,1)*100 AS PFRPIS,
       ST_FRE/NVLZ(CUSFIN,1)*100 AS PSTFRE,
       (OUTDESITE + DESPARITE)/NVLZ(CUSFIN,1)*100 AS PAROUT,
       VLRICMAGR/NVLZ(CUSFIN,1)*100 AS PARICMAGR,
       (OUTDESITE + DESPARITE) AS OUTRAS,
       PRECAL AS PREATU,
       0 AS DIFPRE,
       PERLUC AS LUCATU,
       --44499
       CASE BASE_MARKUP WHEN 'R' THEN (PRECAL - COALESCE(VLRCMG, 0)) / NVLZ(PRECAL,NULL)*100
                        WHEN 'I' THEN (PRECAL - COALESCE(CUSREP, 0)) / NVLZ(PRECAL,NULL)*100
                        WHEN 'B' THEN (PRECAL - COALESCE(VLRBRU, 0)) / NVLZ(PRECAL,NULL)*100
                        WHEN 'C' THEN (PRECAL - COALESCE(PRECOM_CIPI, 0)) / PRECAL*100
                        WHEN '1' THEN (PRECAL - (VLRCMG + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0))) / NVLZ(PRECAL,NULL)*100
                        WHEN '2' THEN (PRECAL - (CUSREP + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0))) / NVLZ(PRECAL,NULL)*100
                        WHEN '3' THEN (PRECAL - (VLRBRU + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0))) / NVLZ(PRECAL,NULL)*100
                        WHEN '4' THEN (PRECAL - (PRECOM_CIPI + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0))) / NVLZ(PRECAL,NULL)*100
       END AS MARKUPCAL, MARKUP,
       CUSREP,VLRCMG,
       --44499
       CASE BASE_MARKUP WHEN 'R' THEN VLRCMG -- CUSTO MEDIO
                        WHEN 'I' THEN CUSREP -- CUSTO DE REPOSICAO
                        WHEN 'B' THEN VLRBRU -- VALOR BRUTO
                        WHEN 'C' THEN PRECOM_CIPI -- PRECO DE COMPRA + IPI
                        WHEN '1' THEN (VLRCMG + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0)) -- CUSTO MEDIO + FRETE - ICMS DO FRETE - PIS E COFINS DO FRETE
                        WHEN '2' THEN (CUSREP + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0)) -- CUSTO DE REPOSICAO + FRETE - ICMS DO FRETE - PIS E COFINS DO FRETE
                        WHEN '3' THEN (VLRBRU + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0)) -- VALOR BRUTO + FRETE - ICMS DO FRETE - PIS E COFINS DO FRETE
                        WHEN '4' THEN (PRECOM_CIPI + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0)) -- PRECO DE COMPRA + IPI + FRETE - ICMS DO FRETE - PIS E COFINS DO FRETE
       END AS VLRMRK,PREPSI,REPGRA, MARGEM, ALIINT,
       DEPART, CLASS1, CLASS2, CLASS3, CLASS4, ALIFRE, AFICUS, ACRFIN, ICMSRE, RESICM, FATCON, REGTRI, TIPLUC, TRISIM, SUBTRI, IPIFRE, OUTDES, DESPAR, REDITE, MVACOM,
       VLRRET_ITE, DESESP, VLRDESESP,
       VLRRET_UNI,
       VLRRET_UNI/NVLZ(CUSFIN,1)*100 AS VLRRET_PAR,GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM, GRA_DATFPV,ST_FRE,
       FILPRE, CODPRE, VAREJO, DESPRE, CODNCM, TIPMPB, ORIPRO, SUBSTITUTA, PEROPEFIX, VLROPEFIX,
       ALIICMAGR, VLRICMAGR, MULTIP, ULTELA, DIAELA, CODMOE, TPR_SIGNAT, PIS_S_ICMS_VEN, PISCOF_SEMIPISAIDA,FOR060, 
       APRBON, APRBON/NVLZ(CUSFIN,1)*100 AS PARAPRBON, CLAABC, CLAXYZ, NOMCLI, ULTNOM, VLRUNI_ANT, QTDMOV_ANT, NOMCLI_ANT, ULTNOM_ANT, PERDIF_ULTCOM,
       IUF_PERFCP, DICM_RESICM, DICM_PERESPINTCOM, DICM_PERESPESTCOM, DICM_PERESPINTVEN, DICM_PERESPESTVEN, VLRICMANT, PERICMANT,
       DICM_COM_RESICM, DICM_COM_PERESPINTCOM, DICM_COM_PERESPESTCOM, DICM_COM_PERESPINTVEN, DICM_COM_PERESPESTVEN, UTILIZA_ICMS_ESPECIFICO,
       UFLOJA
FROM (
SELECT CODTAB,CODFIL,SEQUEN,FILFRE,SEQFRE,FILFOR,TIPPAR,CODFOR,UF_FOR,DATOPE,DATCMP,
       DOCUME,ATU_EM,VLRFRE,VLRSEG,ICMFRE,PISFRE,VLRTOT,DESCON,OUTTAX,
       VLRLIQ,OBSERV,NUMITE,FILMAT,CODMAT,CODCOR,CODTAM,QTDMOV,PAUTAF,SUBTRI,
       VLRMOV,VLRBRU,VLRPRE,IPIITE,ICMITE,COMPIS,COMCOF,VENPIS,VENCOF,PERSOC,PERSOC_R,PERIVE,
       PERCOM,PEROPE,PERIRE,PERIRE_R,PERLUC,ICMCOM,IPICOM,
       VLRSUB,SUBITE,VLRUNI,CUSAQS,PERTOT,FREITE,SEGITE,DESITE,
       TAXITE,VLRICM,VLRIPI,REFPRO,ORDDIV,ORDSUB,DESMAT,
       ESPMAT,ITEDIV,ITESUB,CODSER,SUBSER,NUMNOT,VMVIPI,PRECOV,SUBFED,
       TOTCOMFRE, ATUCUS,
       COALESCE(100-PERTOT-PERLUC,0) AS PERENC,
       --COALESCE(CUSAQS*COMPIS/PERTOT,0) AS VLR_COMPIS,
       --COALESCE(CUSAQS*COMCOF/PERTOT,0) AS VLR_COMCOF,
       VLR_COMCOF,
       VLR_COMPIS,
       PERICMESPVEN,
       COALESCE(CUSAQS*PERICMESPVEN/NVLZ(PERTOT,NULL), 0) AS VLRICMESPVEN,
       PERICMESPCOM,
       VLRICMESPCOM,
       COALESCE(CUSAQS*VENPIS/NVLZ(PERTOT,NULL), 0) AS VLR_VENPIS,
       COALESCE(CUSAQS*VENCOF/NVLZ(PERTOT,NULL), 0) AS VLR_VENCOF,
       COALESCE(CUSAQS*PERSOC_R/NVLZ(PERTOT,NULL),0) AS VLRSOC,
       COALESCE(CUSAQS*IUF_PERFCP/NVLZ(PERTOT,NULL),0) AS VLRFCP,
       -- MN - 101618 - Regras para zerar ICMS de venda: 1) Filial no for substituta; 2) Tabela de preos for Varejo ou Qualquer; 3) Filial for substituta, todavia est configurada para forar o CST 060, ou seja, no quer destacar ICMS na venda
       COALESCE(CUSAQS*CASE WHEN SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4) OR ((COALESCE(SUBSTITUTA,'F') = 'T') AND FOR060 = 'T')) THEN 0 ELSE PERIVE END/NVLZ(PERTOT,NULL),0) AS VLRIVE,
       COALESCE(CUSAQS*PEROPE/NVLZ(PERTOT,NULL),0) AS VLROPE,
       COALESCE(CUSAQS*PEROPEFIX/NVLZ(PERTOT,NULL),0) AS VLROPEFIX,
       COALESCE(CUSAQS*PERIRE_R/NVLZ(PERTOT,NULL),0) AS VLRIRE,
       COALESCE(CUSAQS*PERCOM/NVLZ(PERTOT,NULL),0) AS VLRCOM,
       COALESCE(CUSAQS*PERLUC/NVLZ(PERTOT,NULL),0) AS VLRLUC,
       COALESCE(CUSAQS/(NVLZ(PERTOT,NULL)/100),0) * (1 + AFICUS / 100)  AS PRECAL,
       COALESCE(CUSAQS/(NVLZ(PERTOT,NULL)/100),0) * (AFICUS / 100)  AS ACRFIN,
       COALESCE(CUSAQS,0)+
       COALESCE(CUSAQS*VENPIS/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*VENCOF/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*IUF_PERFCP/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PERICMESPVEN/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PERSOC_R/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*CASE WHEN SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4)) THEN 0 ELSE PERIVE END/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PEROPE/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PEROPEFIX/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PERIRE_R/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PERCOM/NVLZ(PERTOT,NULL),0) AS CUSFIN,
       CUSREP,VLRCMG,BASE_MARKUP,PRECOM_CIPI,MARKUP,PREPSI,REPGRA,
       -- RFMP 97041
       -- No mostramos mais Base de ST Unitrio
       -- CASE WHEN ICMTIP = '0' AND SUBTRI = '3' AND (COALESCE(SUBSTITUTA,'F') = 'F') AND SUBITE > 0
       --      THEN ((VLRUNI + VLRIPI + FREITE) * MARGEM / 100)
       --      ELSE 0
       -- END AS MARGEM,
       0 AS MARGEM,
       ALIINT,
       DEPART, CLASS1, CLASS2, CLASS3, CLASS4, ALIFRE, AFICUS, ICMSRE, RESICM, FATCON, REGTRI, TIPLUC, TRISIM, IPIFRE, OUTDES, DESPAR, OUTDESITE, DESPARITE, REDITE, MVACOM,
       VLRRET_ITE, DESESP, VLRDESESP,
       VLRRET_UNI,GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM, GRA_DATFPV, ST_FRE,
       FILPRE, CODPRE, VAREJO, DESPRE, CODNCM, TIPMPB, ORIPRO, SUBSTITUTA, ICMTIP, ICMTIPDIF, PEROPEFIX,
       ALIICMAGR, VLRICMAGR, MULTIP, ULTELA, DIAELA, CODMOE, TPR_SIGNAT, PIS_S_ICMS_VEN, PISCOF_SEMIPISAIDA,FOR060, APRBON, CLAABC, CLAXYZ, NOMCLI, ULTNOM, VLRUNI_ANT, QTDMOV_ANT, NOMCLI_ANT, ULTNOM_ANT, PERDIF_ULTCOM,
       IUF_PERFCP, DICM_RESICM, DICM_PERESPINTCOM, DICM_PERESPESTCOM, DICM_PERESPINTVEN, DICM_PERESPESTVEN, VLRICMANT, PERICMANT,
       DICM_COM_RESICM, DICM_COM_PERESPINTCOM, DICM_COM_PERESPESTCOM, DICM_COM_PERESPINTVEN, DICM_COM_PERESPESTVEN, UTILIZA_ICMS_ESPECIFICO,
       UFLOJA
FROM (
SELECT CODTAB,CODFIL,SEQUEN,FILFRE,SEQFRE,FILFOR,TIPPAR,CODFOR,UF_FOR,DATOPE,DATCMP,
       DOCUME,ATU_EM,VLRFRE,VLRSEG,ICMFRE,PISFRE,VLRTOT,DESCON,OUTTAX,
       VLRLIQ,OBSERV,NUMITE,FILMAT,CODMAT,CODCOR,CODTAM,QTDMOV,PAUTAF,SUBTRI,ICMTIP,ICMTIPDIF,
       VLRMOV,VLRBRU,VLRPRE,IPIITE,ICMITE,COMPIS,COMCOF,VENPIS,VENCOF,PERSOC,PERSOC_R,PERIVE,
       PERCOM,PEROPE,PERIRE,PERIRE_R,PERTOT,PERLUC,ICMCOM, VLR_COMPIS, VLR_COMCOF,
       IPICOM,VLRSUB,SUBITE,VLRUNI,FREITE,SEGITE,DESITE,TAXITE,
       VLRICM,VLRIPI,REFPRO,ORDDIV,ORDSUB,DESMAT,ESPMAT,SUBFED,
       ITEDIV,ITESUB,CODSER,SUBSER,NUMNOT,VMVIPI,PRECOV,TOTCOMFRE, ATUCUS,
       -- RFMP 97041
       -- No mostramos mais ICMS Retido. O ICMS ST Retido  apresentado no prprio SUBITE.
       -- CASE WHEN ICMTIP = '0' AND SUBTRI = '3' AND RETSUB = 'F' AND (COALESCE(SUBSTITUTA,'F') = 'F')
       --      THEN ((((VLRUNI + VLRIPI + FREITE) + ((VLRUNI + VLRIPI + FREITE) * MARGEM / 100)) * PERIVE / 100) * (1 - REDITE / 100)) - COALESCE(VLRICM,0) - COALESCE(ICMFRE,0)
       --      ELSE 0
       --  END AS ALIINT,
       0 AS ALIINT,
       COALESCE(VLRPRE,0)
       + COALESCE(VLRIPI,0)
       + COALESCE(FREITE,0)
       + COALESCE(SEGITE,0)
       + COALESCE(TAXITE,0)
       + COALESCE(OUTDESITE,0)
       + COALESCE(DESPARITE,0)
       + COALESCE(DESITE,0)
       + COALESCE(ST_FRE,0)
       + COALESCE(VLRDESESP, 0)
       - COALESCE(CASE WHEN REGTRI = 'N'
                       THEN VLR_COMPIS
                       ELSE 0
                   END,0)
       - COALESCE(CASE WHEN REGTRI = 'N'
                       THEN VLR_COMCOF
                       ELSE 0
                   END,0)
       - CASE WHEN FILFRE IS NOT NULL
         THEN COALESCE(PISFRE,0) --GES-2021111729 S diminui se o frete estiver no conhecimento de frete. Caso no tenha conhecimento o valor est imbutido no VLR_PIS/VLR_COFINS
         ELSE 0 
			END
       -- RFMP 97041
       -- Considera ICMS ST sempre que tiver sido calculado
       + VALOR_ST_UNI
       + CASE WHEN VALOR_ST_UNI = 0
              THEN
                   CASE WHEN ICMTIPDIF = '0' AND SUBTRI = '3' AND (COALESCE(SUBSTITUTA,'F') = 'F')
                        THEN 0
                        ELSE - COALESCE(CASE WHEN (SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4))) or COALESCE(ST_FRE,0)>0
                                             THEN 0
                                             ELSE ICMFRE
                                        END,0)
                             - COALESCE(CASE WHEN ((REGTRI = 'N') OR (REGTRI = 'S' AND (COALESCE(TRISIM,'X') = 'O'))) AND (SUBTRI <> '3' OR (ICMTIPDIF = '0' AND (COALESCE(SUBSTITUTA,'F') = 'T')))
                                             THEN VLRICM
                                             ELSE 0
                                        END,0)
                   END
              ELSE 0
         END
       + COALESCE(VLRICMESPCOM, 0)
       + COALESCE(VLRICMANT, 0)
       - COALESCE(VLRICMAGR, 0) 
       - COALESCE(APRBON, 0) AS CUSAQS,
       CUSREP,VLRCMG,BASE_MARKUP,PRECOM_CIPI,MARKUP,PREPSI,REPGRA, MARGEM,
       DEPART, CLASS1, CLASS2, CLASS3, CLASS4, ALIFRE, AFICUS, ICMSRE, RESICM, FATCON, REGTRI, TIPLUC, TRISIM, IPIFRE, OUTDES, DESPAR, OUTDESITE, DESPARITE, REDITE, MVACOM,
       VLRRET_ITE, DESESP, VLRDESESP,
       VLRRET_UNI,GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM, GRA_DATFPV, ST_FRE,
       FILPRE, CODPRE, VAREJO, DESPRE, CODNCM, TIPMPB, ORIPRO, SUBSTITUTA, PEROPEFIX,
       ALIICMAGR, VLRICMAGR, MULTIP, ULTELA, DIAELA, CODMOE, TPR_SIGNAT, PIS_S_ICMS_VEN, PISCOF_SEMIPISAIDA,FOR060, APRBON, CLAABC, CLAXYZ, NOMCLI, ULTNOM, VLRUNI_ANT, QTDMOV_ANT, NOMCLI_ANT, ULTNOM_ANT, PERDIF_ULTCOM,
       IUF_PERFCP, DICM_RESICM, DICM_PERESPINTCOM, DICM_PERESPESTCOM, DICM_PERESPINTVEN, DICM_PERESPESTVEN, VLRICMANT, PERICMANT,
       DICM_COM_RESICM, DICM_COM_PERESPINTCOM, DICM_COM_PERESPESTCOM, DICM_COM_PERESPINTVEN, DICM_COM_PERESPESTVEN, UTILIZA_ICMS_ESPECIFICO,
       VLRICMESPCOM, PERICMESPVEN, PERICMESPCOM, UFLOJA
FROM ( SELECT CODTAB,CODFIL,SEQUEN,FILFRE,SEQFRE,FILFOR,TIPPAR,CODFOR,UF_FOR,DATOPE,DATCMP,DOCUME,ATU_EM,VLRFRE,VLRSEG,VLRTOT,DESCON,OUTTAX,VLRLIQ,OBSERV,
NUMITE,FILMAT,CODMAT,CODCOR,CODTAM,QTDMOV,PAUTAF,SUBTRI,VLRMOV,VLRBRU,VLRPRE,IPIITE,ICMITE,COMPIS,COMCOF,VENPIS,VENCOF,PERSOC,PERSOC_R,PERIVE,PERCOM,PEROPE,
PERIRE,PERIRE_R,PERLUC,PERTOT,REFPRO,VLR_COMPIS,VLR_COMCOF,ORDDIV,ORDSUB,DESMAT,ESPMAT,ITEDIV,ITESUB,VLRUNI,CODSER,SUBSER,NUMNOT,VMVIPI,PRECOV,TOTCOMFRE,
ICMCOM,IPICOM,VLRICM,ICMTIP,ICMTIPDIF,MARGEM,VLRIPI,FREITE,SEGITE,ICMFRE,PISFRE,DESITE,TAXITE,OUTDESITE,DESPARITE,SUBFED,VLRSUB,SUBITE,CUSREP,VLRCMG,BASE_MARKUP,
PRECOM_CIPI,REGTRI,TIPLUC,TRISIM,MARKUP,PREPSI,REPGRA,DEPART,CLASS1,CLASS2,CLASS3,CLASS4,ALIFRE,AFICUS,ICMSRE,RESICM,FATCON,IPIFRE,OUTDES,DESPAR,REDITE,MVACOM,
VLRRET_ITE,DESESP, VLRDESESP, VLRRET_UNI,RETSUB,GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM, GRA_DATFPV,
ST_FRE, PERICMESPVEN, PERICMESPCOM, VLRICMESPCOM,
ATUCUS, FILPRE, CODPRE, VAREJO, DESPRE, CODNCM, TIPMPB, ORIPRO, SUBSTITUTA, PEROPEFIX,
ALIICMAGR, VLRICMAGR, MULTIP, ULTELA, DIAELA, CODMOE, TPR_SIGNAT, VALOR_ST_UNI, PIS_S_ICMS_VEN, PISCOF_SEMIPISAIDA,FOR060, APRBON, CLAABC, CLAXYZ, NOMCLI, ULTNOM, VLRUNI_ANT, QTDMOV_ANT, NOMCLI_ANT, ULTNOM_ANT, PERDIF_ULTCOM,
UFLOJA, IUF_PERFCP, DICM_RESICM, DICM_PERESPINTCOM, DICM_PERESPESTCOM, DICM_PERESPINTVEN, DICM_PERESPESTVEN,VLRICMANT, PERICMANT,
DICM_COM_RESICM, DICM_COM_PERESPINTCOM, DICM_COM_PERESPESTCOM, DICM_COM_PERESPINTVEN, DICM_COM_PERESPESTVEN, UTILIZA_ICMS_ESPECIFICO
 FROM TV_FPV_PXF_INT FPV ) TAB ) TAB ) TAB; 

/*-- SEQ 2830 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FPV_SIM_TOT CASCADE;

/*-- SEQ 2831 --*/
CREATE OR REPLACE VIEW TV_FPV_SIM_TOT AS SELECT CODTAB,CODFIL,SEQUEN,FILFRE,SEQFRE,FILFOR,TIPPAR,CODFOR,UF_FOR,DATOPE,DATCMP,
       DOCUME,ATU_EM,VLRFRE,VLRSEG,
       CASE WHEN SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4))
            THEN 0
            ELSE ICMFRE
       END AS ICMFRE,
       PISFRE,VLRTOT,DESCON,OUTTAX,
       VLRLIQ,OBSERV,NUMITE,FILMAT,CODMAT,CODCOR,CODTAM,QTDMOV,PAUTAF,
       VLRMOV,VLRBRU,VLRPRE,IPIITE,ICMITE,COMPIS,COMCOF,VENPIS,VENCOF,PERSOC, PERSOC_R,
       CASE WHEN SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4)) THEN 0 ELSE PERIVE END AS PERIVE,
       PERIVE AS PERIVE_PERTOT,
       PERCOM,PEROPE,PERIRE,PERIRE_R,PERLUC,PERENC,ICMCOM,IPICOM,
       VLRSUB,SUBITE,VLRUNI,CUSAQS,PERTOT,FREITE,SEGITE,DESITE,SUBFED,
       TAXITE,VLRICM,VLRIPI,VLR_COMPIS,VLR_COMCOF,VLR_VENPIS,VLR_VENCOF,VLRSOC,VLRIVE,VLROPE,
       VLRCOM,VLRLUC,PRECAL,CUSFIN,REFPRO,ORDDIV,ORDSUB,VLRIRE,
       DESMAT,ESPMAT,ITEDIV,ITESUB,CODSER,SUBSER,NUMNOT,VMVIPI,
       PRECOV,TOTCOMFRE,ATUCUS,
       (((PRECAL-PRECOV)/NVLZ(PRECAL,NULL))*100) AS PERDIF,
       CUSFIN-(VLRPRE-VLRICM) AS VLRENC,
       VLRUNI/NVLZ(CUSFIN,1)*100 AS PARVLR,
       DESITE/NVLZ(CUSFIN,1)*100 AS PARDES,
       VLRIPI/NVLZ(CUSFIN,1)*100 AS PARIPI,
       VLRICM/NVLZ(CUSFIN,1)*100 AS PARICM,
       VLRICMANT /NVLZ(CUSFIN,1)*100 AS PARVLRICMANT,
       SUBITE/NVLZ(CUSFIN,1)*100 AS PARSUB,
       FREITE/NVLZ(CUSFIN,1)*100 AS PARFRE,
       VLRDESESP/NVLZ(CUSFIN,1)*100 AS PARDESESP,
       TAXITE/NVLZ(CUSFIN,1)*100 AS PARTAX,
       VLR_COMPIS/NVLZ(CUSFIN,1)*100 AS PAR_COMPIS,
       VLR_COMCOF/NVLZ(CUSFIN,1)*100 AS PAR_COMCOF,
       VLR_VENPIS/NVLZ(CUSFIN,1)*100 AS PAR_VENPIS,
       VLR_VENCOF/NVLZ(CUSFIN,1)*100 AS PAR_VENCOF,
       VLRSOC/NVLZ(CUSFIN,1)*100 AS PARCTS,
       VLRIVE/NVLZ(CUSFIN,1)*100 AS PARIVE,
       VLRCOM/NVLZ(CUSFIN,1)*100 AS PARCOM,
       VLROPE/NVLZ(CUSFIN,1)*100 AS PAROPE,
       VLRIRE/NVLZ(CUSFIN,1)*100 AS PARIRE,
       SEGITE/NVLZ(CUSFIN,1)*100 AS PARSEG,
       CUSAQS/NVLZ(CUSFIN,1)*100 AS PARAQS,
       MARGEM/NVLZ(CUSFIN,1)*100 AS PARMAR,
       ALIINT/NVLZ(CUSFIN,1)*100 AS PARALI,
       VLRFCP/NVLZ(CUSFIN,1)*100 AS PARFCP,
       IUF_PERFCP AS PERFCP,
       VLRFCP,
       PERICMESPVEN,
       VLRICMESPVEN,
       VLRICMESPVEN/NVLZ(CUSFIN,1)*100 AS PARICMESPVEN,
       PERICMESPCOM,
       VLRICMESPCOM,
       VLRICMESPCOM/NVLZ(CUSFIN,1)*100 AS PARICMESPCOM,
       CASE WHEN SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4))
            THEN 0
            ELSE ICMFRE
       END/NVLZ(CUSFIN,1)*100 AS PICFRE,
       PISFRE/NVLZ(CUSFIN,1)*100 AS PFRPIS,
       ST_FRE/NVLZ(CUSFIN,1)*100 AS PSTFRE,
       (OUTDESITE + DESPARITE)/NVLZ(CUSFIN,1)*100 AS PAROUT,
       VLRICMAGR/NVLZ(CUSFIN,1)*100 AS PARICMAGR,
       (OUTDESITE + DESPARITE) AS OUTRAS,
       PRECAL AS PREATU,
       0 AS DIFPRE,
       PERLUC AS LUCATU,
       --44499
       CASE BASE_MARKUP WHEN 'R' THEN (PRECAL - COALESCE(VLRCMG, 0)) / NVLZ(PRECAL,NULL)*100
                        WHEN 'I' THEN (PRECAL - COALESCE(CUSREP, 0)) / NVLZ(PRECAL,NULL)*100
                        WHEN 'B' THEN (PRECAL - COALESCE(VLRBRU, 0)) / NVLZ(PRECAL,NULL)*100
                        WHEN 'C' THEN (PRECAL - COALESCE(PRECOM_CIPI, 0)) / PRECAL*100
                        WHEN '1' THEN (PRECAL - (VLRCMG + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0))) / NVLZ(PRECAL,NULL)*100
                        WHEN '2' THEN (PRECAL - (CUSREP + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0))) / NVLZ(PRECAL,NULL)*100
                        WHEN '3' THEN (PRECAL - (VLRBRU + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0))) / NVLZ(PRECAL,NULL)*100
                        WHEN '4' THEN (PRECAL - (PRECOM_CIPI + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0))) / NVLZ(PRECAL,NULL)*100
       END AS MARKUPCAL, MARKUP,
       CUSREP,VLRCMG,
       --44499
       CASE BASE_MARKUP WHEN 'R' THEN VLRCMG -- CUSTO MEDIO
                        WHEN 'I' THEN CUSREP -- CUSTO DE REPOSICAO
                        WHEN 'B' THEN VLRBRU -- VALOR BRUTO
                        WHEN 'C' THEN PRECOM_CIPI -- PRECO DE COMPRA + IPI
                        WHEN '1' THEN (VLRCMG + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0)) -- CUSTO MEDIO + FRETE - ICMS DO FRETE - PIS E COFINS DO FRETE
                        WHEN '2' THEN (CUSREP + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0)) -- CUSTO DE REPOSICAO + FRETE - ICMS DO FRETE - PIS E COFINS DO FRETE
                        WHEN '3' THEN (VLRBRU + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0)) -- VALOR BRUTO + FRETE - ICMS DO FRETE - PIS E COFINS DO FRETE
                        WHEN '4' THEN (PRECOM_CIPI + COALESCE(FREITE, 0) - COALESCE(ICMFRE, 0) - COALESCE(PISFRE, 0)) -- PRECO DE COMPRA + IPI + FRETE - ICMS DO FRETE - PIS E COFINS DO FRETE
       END AS VLRMRK,PREPSI,REPGRA, MARGEM, ALIINT,
       DEPART, CLASS1, CLASS2, CLASS3, CLASS4, ALIFRE, AFICUS, ACRFIN, ICMSRE, RESICM, FATCON, REGTRI, TIPLUC, TRISIM, SUBTRI, IPIFRE, OUTDES, DESPAR, REDITE, MVACOM,
       VLRRET_ITE, DESESP, VLRDESESP,
       VLRRET_UNI,
       VLRRET_UNI/NVLZ(CUSFIN,1)*100 AS VLRRET_PAR,GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM, GRA_DATFPV,ST_FRE,
       FILPRE, CODPRE, VAREJO, DESPRE, CODNCM, TIPMPB, ORIPRO, SUBSTITUTA, PEROPEFIX, VLROPEFIX,
       ALIICMAGR, VLRICMAGR, MULTIP, ULTELA, DIAELA, CODMOE, TPR_SIGNAT, PIS_S_ICMS_VEN, PISCOF_SEMIPISAIDA,FOR060, 
       APRBON, APRBON/NVLZ(CUSFIN,1)*100 AS PARAPRBON, CLAABC, CLAXYZ, NOMCLI, ULTNOM, VLRUNI_ANT, QTDMOV_ANT, NOMCLI_ANT, ULTNOM_ANT, PERDIF_ULTCOM,
       IUF_PERFCP, DICM_RESICM, DICM_PERESPINTCOM, DICM_PERESPESTCOM, DICM_PERESPINTVEN, DICM_PERESPESTVEN, VLRICMANT, PERICMANT,
       DICM_COM_RESICM, DICM_COM_PERESPINTCOM, DICM_COM_PERESPESTCOM, DICM_COM_PERESPINTVEN, DICM_COM_PERESPESTVEN, UTILIZA_ICMS_ESPECIFICO,
       UFLOJA
FROM (
SELECT CODTAB,CODFIL,SEQUEN,FILFRE,SEQFRE,FILFOR,TIPPAR,CODFOR,UF_FOR,DATOPE,DATCMP,
       DOCUME,ATU_EM,VLRFRE,VLRSEG,ICMFRE,PISFRE,VLRTOT,DESCON,OUTTAX,
       VLRLIQ,OBSERV,NUMITE,FILMAT,CODMAT,CODCOR,CODTAM,QTDMOV,PAUTAF,SUBTRI,
       VLRMOV,VLRBRU,VLRPRE,IPIITE,ICMITE,COMPIS,COMCOF,VENPIS,VENCOF,PERSOC,PERSOC_R,PERIVE,
       PERCOM,PEROPE,PERIRE,PERIRE_R,PERLUC,ICMCOM,IPICOM,
       VLRSUB,SUBITE,VLRUNI,CUSAQS,PERTOT,FREITE,SEGITE,DESITE,
       TAXITE,VLRICM,VLRIPI,REFPRO,ORDDIV,ORDSUB,DESMAT,
       ESPMAT,ITEDIV,ITESUB,CODSER,SUBSER,NUMNOT,VMVIPI,PRECOV,SUBFED,
       TOTCOMFRE, ATUCUS,
       COALESCE(100-PERTOT-PERLUC,0) AS PERENC,
       --COALESCE(CUSAQS*COMPIS/PERTOT,0) AS VLR_COMPIS,
       --COALESCE(CUSAQS*COMCOF/PERTOT,0) AS VLR_COMCOF,
       VLR_COMCOF,
       VLR_COMPIS,
       PERICMESPVEN,
       COALESCE(CUSAQS*PERICMESPVEN/NVLZ(PERTOT,NULL), 0) AS VLRICMESPVEN,
       PERICMESPCOM,
       VLRICMESPCOM,
       COALESCE(CUSAQS*VENPIS/NVLZ(PERTOT,NULL), 0) AS VLR_VENPIS,
       COALESCE(CUSAQS*VENCOF/NVLZ(PERTOT,NULL), 0) AS VLR_VENCOF,
       COALESCE(CUSAQS*PERSOC_R/NVLZ(PERTOT,NULL),0) AS VLRSOC,
       COALESCE(CUSAQS*IUF_PERFCP/NVLZ(PERTOT,NULL),0) AS VLRFCP,
       -- MN - 101618 - Regras para zerar ICMS de venda: 1) Filial no for substituta; 2) Tabela de preos for Varejo ou Qualquer; 3) Filial for substituta, todavia est configurada para forar o CST 060, ou seja, no quer destacar ICMS na venda
       COALESCE(CUSAQS*CASE WHEN SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4) OR ((COALESCE(SUBSTITUTA,'F') = 'T') AND FOR060 = 'T')) THEN 0 ELSE PERIVE END/NVLZ(PERTOT,NULL),0) AS VLRIVE,
       COALESCE(CUSAQS*PEROPE/NVLZ(PERTOT,NULL),0) AS VLROPE,
       COALESCE(CUSAQS*PEROPEFIX/NVLZ(PERTOT,NULL),0) AS VLROPEFIX,
       COALESCE(CUSAQS*PERIRE_R/NVLZ(PERTOT,NULL),0) AS VLRIRE,
       COALESCE(CUSAQS*PERCOM/NVLZ(PERTOT,NULL),0) AS VLRCOM,
       COALESCE(CUSAQS*PERLUC/NVLZ(PERTOT,NULL),0) AS VLRLUC,
       COALESCE(CUSAQS/(NVLZ(PERTOT,NULL)/100),0) * (1 + AFICUS / 100)  AS PRECAL,
       COALESCE(CUSAQS/(NVLZ(PERTOT,NULL)/100),0) * (AFICUS / 100)  AS ACRFIN,
       COALESCE(CUSAQS,0)+
       COALESCE(CUSAQS*VENPIS/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*VENCOF/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*IUF_PERFCP/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PERICMESPVEN/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PERSOC_R/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*CASE WHEN SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4)) THEN 0 ELSE PERIVE END/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PEROPE/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PEROPEFIX/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PERIRE_R/NVLZ(PERTOT,NULL),0)+
       COALESCE(CUSAQS*PERCOM/NVLZ(PERTOT,NULL),0) AS CUSFIN,
       CUSREP,VLRCMG,BASE_MARKUP,PRECOM_CIPI,MARKUP,PREPSI,REPGRA,
       -- RFMP 97041
       -- No mostramos mais Base de ST Unitrio
       -- CASE WHEN ICMTIP = '0' AND SUBTRI = '3' AND (COALESCE(SUBSTITUTA,'F') = 'F') AND SUBITE > 0
       --      THEN ((VLRUNI + VLRIPI + FREITE) * MARGEM / 100)
       --      ELSE 0
       -- END AS MARGEM,
       0 AS MARGEM,
       ALIINT,
       DEPART, CLASS1, CLASS2, CLASS3, CLASS4, ALIFRE, AFICUS, ICMSRE, RESICM, FATCON, REGTRI, TIPLUC, TRISIM, IPIFRE, OUTDES, DESPAR, OUTDESITE, DESPARITE, REDITE, MVACOM,
       VLRRET_ITE, DESESP, VLRDESESP,
       VLRRET_UNI,GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM, GRA_DATFPV, ST_FRE,
       FILPRE, CODPRE, VAREJO, DESPRE, CODNCM, TIPMPB, ORIPRO, SUBSTITUTA, ICMTIP, ICMTIPDIF, PEROPEFIX,
       ALIICMAGR, VLRICMAGR, MULTIP, ULTELA, DIAELA, CODMOE, TPR_SIGNAT, PIS_S_ICMS_VEN, PISCOF_SEMIPISAIDA,FOR060, APRBON, CLAABC, CLAXYZ, NOMCLI, ULTNOM, VLRUNI_ANT, QTDMOV_ANT, NOMCLI_ANT, ULTNOM_ANT, PERDIF_ULTCOM,
       IUF_PERFCP, DICM_RESICM, DICM_PERESPINTCOM, DICM_PERESPESTCOM, DICM_PERESPINTVEN, DICM_PERESPESTVEN, VLRICMANT, PERICMANT,
       DICM_COM_RESICM, DICM_COM_PERESPINTCOM, DICM_COM_PERESPESTCOM, DICM_COM_PERESPINTVEN, DICM_COM_PERESPESTVEN, UTILIZA_ICMS_ESPECIFICO,
       UFLOJA
FROM (
SELECT CODTAB,CODFIL,SEQUEN,FILFRE,SEQFRE,FILFOR,TIPPAR,CODFOR,UF_FOR,DATOPE,DATCMP,
       DOCUME,ATU_EM,VLRFRE,VLRSEG,ICMFRE,PISFRE,VLRTOT,DESCON,OUTTAX,
       VLRLIQ,OBSERV,NUMITE,FILMAT,CODMAT,CODCOR,CODTAM,QTDMOV,PAUTAF,SUBTRI,ICMTIP,ICMTIPDIF,
       VLRMOV,VLRBRU,VLRPRE,IPIITE,ICMITE,COMPIS,COMCOF,VENPIS,VENCOF,PERSOC,PERSOC_R,PERIVE,
       PERCOM,PEROPE,PERIRE,PERIRE_R,PERTOT,PERLUC,ICMCOM, VLR_COMPIS, VLR_COMCOF,
       IPICOM,VLRSUB,SUBITE,VLRUNI,FREITE,SEGITE,DESITE,TAXITE,
       VLRICM,VLRIPI,REFPRO,ORDDIV,ORDSUB,DESMAT,ESPMAT,SUBFED,
       ITEDIV,ITESUB,CODSER,SUBSER,NUMNOT,VMVIPI,PRECOV,TOTCOMFRE, ATUCUS,
       -- RFMP 97041
       -- No mostramos mais ICMS Retido. O ICMS ST Retido  apresentado no prprio SUBITE.
       -- CASE WHEN ICMTIP = '0' AND SUBTRI = '3' AND RETSUB = 'F' AND (COALESCE(SUBSTITUTA,'F') = 'F')
       --      THEN ((((VLRUNI + VLRIPI + FREITE) + ((VLRUNI + VLRIPI + FREITE) * MARGEM / 100)) * PERIVE / 100) * (1 - REDITE / 100)) - COALESCE(VLRICM,0) - COALESCE(ICMFRE,0)
       --      ELSE 0
       --  END AS ALIINT,
       0 AS ALIINT,
       COALESCE(VLRPRE,0)
       + COALESCE(VLRIPI,0)
       + COALESCE(FREITE,0)
       + COALESCE(SEGITE,0)
       + COALESCE(TAXITE,0)
       + COALESCE(OUTDESITE,0)
       + COALESCE(DESPARITE,0)
       + COALESCE(DESITE,0)
       + COALESCE(ST_FRE,0)
       + COALESCE(VLRDESESP, 0)
       - COALESCE(CASE WHEN REGTRI = 'N'
                       THEN VLR_COMPIS
                       ELSE 0
                   END,0)
       - COALESCE(CASE WHEN REGTRI = 'N'
                       THEN VLR_COMCOF
                       ELSE 0
                   END,0)
       - CASE WHEN FILFRE IS NOT NULL
         THEN COALESCE(PISFRE,0) --GES-2021111729 S diminui se o frete estiver no conhecimento de frete. Caso no tenha conhecimento o valor est imbutido no VLR_PIS/VLR_COFINS
         ELSE 0 
			END
       -- RFMP 97041
       -- Considera ICMS ST sempre que tiver sido calculado
       + VALOR_ST_UNI
       + CASE WHEN VALOR_ST_UNI = 0
              THEN
                   CASE WHEN ICMTIPDIF = '0' AND SUBTRI = '3' AND (COALESCE(SUBSTITUTA,'F') = 'F')
                        THEN 0
                        ELSE - COALESCE(CASE WHEN (SUBTRI = '3' AND ((COALESCE(SUBSTITUTA,'F') = 'F') OR VAREJO in (0, 2, 4))) or COALESCE(ST_FRE,0)>0
                                             THEN 0
                                             ELSE ICMFRE
                                        END,0)
                             - COALESCE(CASE WHEN ((REGTRI = 'N') OR (REGTRI = 'S' AND (COALESCE(TRISIM,'X') = 'O'))) AND (SUBTRI <> '3' OR (ICMTIPDIF = '0' AND (COALESCE(SUBSTITUTA,'F') = 'T')))
                                             THEN VLRICM
                                             ELSE 0
                                        END,0)
                   END
              ELSE 0
         END
       + COALESCE(VLRICMESPCOM, 0)
       + COALESCE(VLRICMANT, 0)
       - COALESCE(VLRICMAGR, 0) 
       - COALESCE(APRBON, 0) AS CUSAQS,
       CUSREP,VLRCMG,BASE_MARKUP,PRECOM_CIPI,MARKUP,PREPSI,REPGRA, MARGEM,
       DEPART, CLASS1, CLASS2, CLASS3, CLASS4, ALIFRE, AFICUS, ICMSRE, RESICM, FATCON, REGTRI, TIPLUC, TRISIM, IPIFRE, OUTDES, DESPAR, OUTDESITE, DESPARITE, REDITE, MVACOM,
       VLRRET_ITE, DESESP, VLRDESESP,
       VLRRET_UNI,GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM, GRA_DATFPV, ST_FRE,
       FILPRE, CODPRE, VAREJO, DESPRE, CODNCM, TIPMPB, ORIPRO, SUBSTITUTA, PEROPEFIX,
       ALIICMAGR, VLRICMAGR, MULTIP, ULTELA, DIAELA, CODMOE, TPR_SIGNAT, PIS_S_ICMS_VEN, PISCOF_SEMIPISAIDA,FOR060, APRBON, CLAABC, CLAXYZ, NOMCLI, ULTNOM, VLRUNI_ANT, QTDMOV_ANT, NOMCLI_ANT, ULTNOM_ANT, PERDIF_ULTCOM,
       IUF_PERFCP, DICM_RESICM, DICM_PERESPINTCOM, DICM_PERESPESTCOM, DICM_PERESPINTVEN, DICM_PERESPESTVEN, VLRICMANT, PERICMANT,
       DICM_COM_RESICM, DICM_COM_PERESPINTCOM, DICM_COM_PERESPESTCOM, DICM_COM_PERESPINTVEN, DICM_COM_PERESPESTVEN, UTILIZA_ICMS_ESPECIFICO,
       VLRICMESPCOM, PERICMESPVEN, PERICMESPCOM, UFLOJA
FROM ( SELECT CODTAB,CODFIL,SEQUEN,FILFRE,SEQFRE,FILFOR,TIPPAR,CODFOR,UF_FOR,DATOPE,DATCMP,DOCUME,ATU_EM,VLRFRE,VLRSEG,VLRTOT,DESCON,OUTTAX,VLRLIQ,OBSERV,
NUMITE,FILMAT,CODMAT,CODCOR,CODTAM,QTDMOV,PAUTAF,SUBTRI,VLRMOV,VLRBRU,VLRPRE,IPIITE,ICMITE,COMPIS,COMCOF,VENPIS,VENCOF,PERSOC,PERSOC_R,PERIVE,PERCOM,PEROPE,
PERIRE,PERIRE_R,PERLUC,PERTOT,REFPRO,VLR_COMPIS,VLR_COMCOF,ORDDIV,ORDSUB,DESMAT,ESPMAT,ITEDIV,ITESUB,VLRUNI,CODSER,SUBSER,NUMNOT,VMVIPI,PRECOV,TOTCOMFRE,
ICMCOM,IPICOM,VLRICM,ICMTIP,ICMTIPDIF,MARGEM,VLRIPI,FREITE,SEGITE,ICMFRE,PISFRE,DESITE,TAXITE,OUTDESITE,DESPARITE,SUBFED,VLRSUB,SUBITE,CUSREP,VLRCMG,BASE_MARKUP,
PRECOM_CIPI,REGTRI,TIPLUC,TRISIM,MARKUP,PREPSI,REPGRA,DEPART,CLASS1,CLASS2,CLASS3,CLASS4,ALIFRE,AFICUS,ICMSRE,RESICM,FATCON,IPIFRE,OUTDES,DESPAR,REDITE,MVACOM,
VLRRET_ITE,DESESP, VLRDESESP, VLRRET_UNI,RETSUB,GRA_FILCOM, GRA_SEQCOM, GRA_ITECOM, GRA_DATFPV,
ST_FRE, PERICMESPVEN, PERICMESPCOM, VLRICMESPCOM,
ATUCUS, FILPRE, CODPRE, VAREJO, DESPRE, CODNCM, TIPMPB, ORIPRO, SUBSTITUTA, PEROPEFIX,
ALIICMAGR, VLRICMAGR, MULTIP, ULTELA, DIAELA, CODMOE, TPR_SIGNAT, VALOR_ST_UNI, PIS_S_ICMS_VEN, PISCOF_SEMIPISAIDA,FOR060, APRBON, CLAABC, CLAXYZ, NOMCLI, ULTNOM, VLRUNI_ANT, QTDMOV_ANT, NOMCLI_ANT, ULTNOM_ANT, PERDIF_ULTCOM,
UFLOJA, IUF_PERFCP, DICM_RESICM, DICM_PERESPINTCOM, DICM_PERESPESTCOM, DICM_PERESPINTVEN, DICM_PERESPESTVEN,VLRICMANT, PERICMANT,
DICM_COM_RESICM, DICM_COM_PERESPINTCOM, DICM_COM_PERESPESTCOM, DICM_COM_PERESPINTVEN, DICM_COM_PERESPESTVEN, UTILIZA_ICMS_ESPECIFICO
 FROM TV_FPV_SIM_INT FPV ) TAB ) TAB ) TAB;


/*-- SEQ 2832 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_GRA_DET CASCADE;

/*-- SEQ 2833 --*/
CREATE OR REPLACE VIEW TV_GRA_DET AS
SELECT GRA.REFPRO,
       GRA.FILMAT,
       GRA.CODMAT,
       GRA.CODCOR,
       GRA.CODTAM,
       SAL.CODFIL,
       SAL.CODMUL,
       CLI.NOMCLI AS NOMFOR,
       ICO.QTDMOV AS OLDQTDCOM,
       COM.DATOPE AS DATCOM, 
       ICO.VLRMOV AS PRECOM,
       SAL.QTDEST, SAL.RESERV,
       (SAL.QTDEST - SAL.RESERV) AS SALREA,
       COALESCE(COM.CODSER,'')||'/'||lTrim(COALESCE(COM.SUBSER,''))||'-'||lTrim(COALESCE(COM.NUMNOT,'')) AS DOCUME,
       CAST((SELECT AGREGATXT(to_char(PAG.DATPGT,'DD/MM/YYYY')) AS PAGAMENTOS
               FROM TV_PGT PAG
              WHERE COM.CODFIL = PAG.CODFIL
                AND COM.SEQUEN = PAG.SEQUEN
              GROUP BY PAG.CODFIL, PAG.SEQUEN) AS VARCHAR(4000)) AS PAGAMENTOS,
       CAST((SELECT AGREGATXT(DDOP.DESDOP)
               FROM TV_PGT PGT LEFT JOIN TV_DPG DOP  ON PGT.FILDOP = DOP.CODFIL
                                                    AND PGT.SEQDOP = DOP.SEQUEN
                               LEFT JOIN TD_DOP DDOP ON DOP.STDDOP = DDOP.CODTAB
              WHERE COM.CODFIL = PGT.CODFIL
                AND COM.SEQUEN = PGT.SEQUEN
              GROUP BY PGT.CODFIL, PGT.SEQUEN) AS VARCHAR(4000)) AS DOCPAG,
       CAST((SELECT AGREGATXT(DISTINCT(IIPE.CODFIL||'/'||TRIM(IIPE.NUMPED)))
                      FROM TT_IPE IIPE
                     WHERE IIPE.FILMAT = GRA.FILMAT
                       AND IIPE.CODMAT = GRA.CODMAT
                       AND IIPE.CODCOR = GRA.CODCOR
                       AND IIPE.CODTAM = GRA.CODTAM
                       AND IIPE.FILICO = GRA.FILCOM
                       AND IIPE.SEQICO = GRA.SEQCOM) AS VARCHAR(4000)) AS OLDNUMPED
  FROM TT_GRA GRA INNER JOIN TT_ICO ICO ON ICO.CODFIL = GRA.FILCOM
                                       AND ICO.SEQUEN = GRA.SEQCOM
                                       AND ICO.NUMITE = GRA.ITECOM
                  INNER JOIN TV_CMP COM ON COM.CODFIL = ICO.CODFIL
                                       AND COM.SEQUEN = ICO.SEQUEN
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = COM.FILFOR
                                       AND CLI.CODCLI = COM.CODFOR
                  INNER JOIN TT_SAL SAL ON SAL.FILMAT = GRA.FILMAT
                                       AND SAL.CODMAT = GRA.CODMAT
                                       AND SAL.CODCOR = GRA.CODCOR
                                       AND SAL.CODTAM = GRA.CODTAM
UNION ALL
SELECT GRA.REFPRO,
       GRA.FILMAT,
       GRA.CODMAT,
       GRA.CODCOR,
       GRA.CODTAM,
       SAL.CODFIL,
       SAL.CODMUL,
       CAST(NULL AS VARCHAR(64)) AS NOMFOR,
       0 AS OLDQTDCOM,
       CAST(NULL AS Timestamp) AS DATCOM,
       0 AS PRECOM,
       SAL.QTDEST, SAL.RESERV,
       (SAL.QTDEST - SAL.RESERV) AS SALREA,
       CAST(NULL AS VARCHAR(10)) AS DOCUME,
       CAST(NULL AS VARCHAR(4000)) AS PAGAMENTOS,
       CAST(NULL AS VARCHAR(4000)) AS DOCPAG,
       CAST(NULL AS VARCHAR(4000)) AS OLDNUMPED
  FROM TT_GRA GRA INNER JOIN TT_SAL SAL ON SAL.FILMAT = GRA.FILMAT
                                       AND SAL.CODMAT = GRA.CODMAT
                                       AND SAL.CODCOR = GRA.CODCOR
                                       AND SAL.CODTAM = GRA.CODTAM
 WHERE GRA.FILCOM IS NULL
;


/*-- SEQ 2834 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_GRAF_FINA CASCADE;

/*-- SEQ 2835 --*/
CREATE OR REPLACE VIEW TV_GRAF_FINA AS
    SELECT SUM(VLRLIQ) AS VALOR,  
           TO_CHAR(DATHOR,'MM')||'/'||TO_CHAR(DATHOR,'YYYY')||' -' AS MESANO, 
           TRIM('V') as TIPO, 
           min(DATHOR) AS DATA,
           FILCLI,
           CODCLI,
           CODFIL,
           min(DATHOR) as DATHOR
      FROM TT_VEN                     
     WHERE FLGEST <> 'C'            
       AND LANVEN = 'T'             
     GROUP BY FILCLI, CODCLI, CODFIL, TO_CHAR(DATHOR,'YYYY'), TO_CHAR(DATHOR,'MM')
     UNION ALL                     
    SELECT SUM(VLRLIQ) AS VALOR, 
           TO_CHAR(DATCMP,'MM')||'/'||TO_CHAR(DATCMP,'YYYY') AS MESANO,
           TRIM('C') AS TIPO, 
           min(DATCMP) AS DATA,
           FILFOR AS FILCLI,
           CODFOR AS CODCLI,
           CODFIL,
           min(DATCMP) AS DATHOR
      FROM TV_CMP                                   
     WHERE FLGEST <> 'D'                          
    GROUP BY FILFOR, CODFOR, CODFIL, TO_CHAR(DATCMP,'YYYY'), TO_CHAR(DATCMP,'MM')
;


/*-- SEQ 2836 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ITE_EVE_VEN CASCADE;

/*-- SEQ 2837 --*/
CREATE OR REPLACE VIEW TV_ITE_EVE_VEN AS
SELECT IVE.SEQUEN,
       IVE.CALSUB, 
       IVE.DEVVIN, 
       IVE.FILDOU, 
       IVE.FILRCT, 
       IVE.QTDPRE, 
       IVE.SAL_CM, 
       IVE.SEQDOU, 
       IVE.SEQRCT, 
       IVE.TOTCMG, 
       IVE.TOT_CM, 
       SUBSTR(FLGFUT.DESDOM,1,30) AS FLGFUT_DOM, 
       IVE.QTDFUT, 
       IVE.QTDPEN, 
       IVE.ESTPEN, 
       SUBSTR(ICMTIP.DESDOM,1,30) AS ICMTIP_DOM, 
       IVE.CODFIL, 
       IVE.NUMEXT, 
       IVE.NUMITE, 
       IVE.COMISS, 
       IVE.EXPORT, 
       SUBSTR(VINCUL.DESDOM,1,30) AS VINCUL_DOM, 
       IVE1.APEUSU, 
       (SELECT P.CODFIL || '-' || P.NUMPED || ',' || LTRIM(TO_CHAR(P.NUMITE,'999')) FROM TT_IOR P WHERE P.FILIVE = IVE.CODFIL AND P.SEQIVE = IVE.SEQUEN AND P.NUMIVE = IVE.NUMITE) AS ITEPED, 
       (SELECT P.FILRES FROM TT_IOR P WHERE P.FILIVE = IVE.CODFIL AND P.SEQIVE = IVE.SEQUEN AND P.NUMIVE = IVE.NUMITE) AS FILRES, 
       IVE.IMPKIT, 
       IVE.FILMAT, 
       IVE.CODMAT, 
       SUBSTR(GETORIGEM(IVE.CODFIL,IVE.NUMORI,IVE.ITEORI),1,30) AS ORIGEM1, 
       SUBSTR(SITKIT.DESDOM,1,30) AS SITKIT_DOM, 
       SUBSTR(SITMOV.DESDOM,1,30) AS SITMOV_DOM, 
       SUBSTR(LANEST.DESDOM,1,30) AS LANEST_DOM, 
       SUBSTR(TIPPRO.DESDOM,1,30) AS TIPPRO_DOM, 
       IVE2.NOMITE, 
       NOTASVINCULADAS(IVE.CODFIL,IVE.SEQUEN,IVE.NUMITE) AS NOTVIN, 
       SUBSTR(GETORIGEM(IVE.FILORI,IVE.NUMORI,IVE.ITEORI),1,30) AS ORIGEM2, 
       IVE.ISEICM AS ISEICM, 
       IVE.OUTICM AS OUTICM, 
       IVE.VEN_DATHOR AS VEN_DATHOR, 
       IVE.DATINC AS DATINC, 
       IVE.REDITE AS REDITE, 
       COALESCE(VEN.VLRLIQ,0) * (CASE  VEN.VLRNOT  WHEN 0 THEN  0 ELSE  IVE.VLRMOV / VEN.VLRNOT  END) AS VLRLIQPROPOR, 
       IVE.TAX001 AS TAX001, 
       IVE.TAX002 AS TAX002, 
       IVE3.DESMUL AS DESMUL, 
       IVE.VLR001 AS VLR001, 
       IVE.VLR002 AS VLR002, 
       (CASE WHEN ((IVE.TOT_CM IS NULL) AND (IVE.LANEST <> 'N')) OR COALESCE(IVE.SAL_CM,0) = 0 THEN CUSTOMEDIO(IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,3,IVE.VEN_DATHOR) ELSE IVE.TOT_CM / IVE.SAL_CM END * IVE.QTDMOV) AS CUSFINFISTOT, 
       IVE.QTDMOV AS QTDMOV, 
       QTDCONVERTIDA(IVE.CODTAM, IVE.QTDMOV) AS QTDCONV, 
       (CASE WHEN (COALESCE(IVE.TOT_CM,0) = 0 AND (IVE.LANEST <> 'N')) OR COALESCE(IVE.SAL_CM,0) = 0 THEN CUSTOMEDIO(IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,3,IVE.VEN_DATHOR) ELSE IVE.TOT_CM / IVE.SAL_CM END) AS CUSMEDFIS, 
       QTDENTREGUE(IVE.CODFIL,IVE.SEQUEN,IVE.NUMITE) AS QTDENT, 
       QTDDEVOLVIDA(IVE.CODFIL,IVE.SEQUEN,IVE.NUMITE) AS QTDDEV, 
       IVE.VLRMOV AS VLRMOV, 
       IVE.EMBQTD AS EMBQTD, 
       IVE.ORD_CM AS ORD_CM, 
       (CASE WHEN ((IVE.TOTCMG IS NULL) AND (IVE.LANEST <> 'N')) OR (COALESCE(IVE.SAL_CM,0) = 0) THEN CUSTOMEDIO(IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,5,IVE.VEN_DATHOR) ELSE IVE.TOTCMG / IVE.SAL_CM END * IVE.QTDMOV) AS CUSFINGERTOT, 
       (CASE WHEN (COALESCE(IVE.TOTCMG,0) = 0 AND (IVE.LANEST <> 'N')) OR COALESCE(IVE.SAL_CM,0) = 0 THEN CUSTOMEDIO(IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,5,IVE.VEN_DATHOR) ELSE IVE.TOTCMG / IVE.SAL_CM END) AS CUSMEDGER, 
       IVE.QTD_CM AS QTD_CM, 
       (CASE WHEN IVE.TIP001 = 'M' AND IVE.TAX001 <> 0 THEN IVE.VLRMOV + ROUND((IVE.VLRMOV * VEN.DESCON / 100),2) ELSE 0 END) AS BASCAL, 
       IVE.TAXIRR AS TAXIRR, 
       IVE.TAXISS AS TAXISS, 
       IVE.VLRDES AS VLRDES, 
       IVE.VLRIRR AS VLRIRR, 
       IVE.VLRISS AS VLRISS, 
       (CASE WHEN IVE.SAL_CM < 0 THEN COALESCE(IVE.SAL_CM,0) ELSE 0 END) AS SALNEG, 
       ROUND(COALESCE(IVE.VLRUNI,COALESCE((IVE.VLRMOV / IVE.QTDMOV) + ((IVE.VLRMOV / IVE.QTDMOV) * VEN.DESCON / 100),0)),2) AS VLRLIQ, 
       PRECOPROMOCIONALPORIVE(IVE.CODFIL, IVE.SEQUEN, IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM) AS PREPROMO, 
       ROUND(IVE.VLRMOV/IVE.QTDMOV,4) AS VLRUNI, 
       IVE.BASICM AS BASICM, 
       IVE.VLRORI AS VLRORI, 
       COALESCE(IVE.NATFIS, CAST((SELECT NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, NAT.NATDEN, NAT.NATFOR,VEN.SUBSTT)||'00' FROM TT_VEN VEN INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT WHERE VEN.CODFIL = IVE.CODFIL  AND VEN.SEQUEN = IVE.SEQUEN) AS CHAR(6))) AS NATFIS, 
       IVE4.NATURE AS NATDENEST, 
       IVE5.NATURE AS NATFOREST, 
       IVE.SITIPI AS SITIPI, 
       IVE.BASIPI AS BASIPI, 
       IVE.VLRIPI AS VLRIPI, 
       IVE.BASISS AS BASISS, 
       IVE.VLRICM AS VLRICM, 
       IVE.SITPIS AS SITPIS, 
       IVE.PERPIS AS PERPIS, 
       IVE.BASPIS AS BASPIS, 
       IVE.VLRPIS AS VLRPIS, 
       IVE.SITCOF AS SITCOF, 
       IVE.PERCOF AS PERCOF, 
       IVE.BASCOF AS BASCOF, 
       IVE.VLRCOF AS VLRCOF, 
       IVE.TAXICM AS TAXICM, 
       IVE.TAXIPI AS TAXIPI, 
       SUBSTR(TIP001.DESDOM,1,30) AS TIP001_DOM, 
       COALESCE(FILVDD,(SELECT FILVEN FROM TT_VEN VEN WHERE VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN)) AS FILVDD, 
       COALESCE(CODVDD,(SELECT CODVEN FROM TT_VEN VEN WHERE VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN)) AS CODVDD, 
       IVE.PROMOC AS PROMOC, 
       SUBSTR(PENATU.DESDOM,1,30) AS PENATU_DOM, 
       IVE.SIGNAT AS SIGNAT, 
       IPR.REFPRO AS REFPRO,
       IPR.DESMAT AS DESMAT,
       IPR.ESPMAT AS ESPMAT,
       IPR.ITEDIV AS ITEDIV,
       IPR.ITESUB AS ITESUB
  FROM TT_IVE IVE 
        LEFT JOIN TT_DOM FLGFUT ON FLGFUT.CODARQ = 'IVE' AND FLGFUT.NOMCPO = 'FLGFUT' AND FLGFUT.CODCHR = IVE.FLGFUT
        LEFT JOIN TT_DOM ICMTIP ON ICMTIP.CODARQ = 'IVE' AND ICMTIP.NOMCPO = 'ICMTIP' AND ICMTIP.CODCHR = IVE.ICMTIP
        LEFT JOIN TT_DOM VINCUL ON VINCUL.CODARQ = 'IVE' AND VINCUL.NOMCPO = 'VINCUL' AND VINCUL.CODCHR = IVE.VINCUL
  LEFT OUTER JOIN TT_USU IVE1 ON IVE.FILVDD = IVE1.FILUSU AND IVE.CODVDD = IVE1.CODUSU
        LEFT JOIN TT_DOM SITKIT ON SITKIT.CODARQ = 'IVE' AND SITKIT.NOMCPO = 'SITKIT' AND SITKIT.CODCHR = IVE.SITKIT
        LEFT JOIN TT_DOM SITMOV ON SITMOV.CODARQ = 'IVE' AND SITMOV.NOMCPO = 'SITMOV' AND SITMOV.CODCHR = IVE.SITMOV
        LEFT JOIN TT_DOM LANEST ON LANEST.CODARQ = 'IVE' AND LANEST.NOMCPO = 'LANEST' AND LANEST.CODCHR = IVE.LANEST
        LEFT JOIN TT_DOM TIPPRO ON TIPPRO.CODARQ = 'IVE' AND TIPPRO.NOMCPO = 'TIPPRO' AND TIPPRO.CODCHR = IVE.TIPPRO
  LEFT OUTER JOIN TT_SUB IVE2 ON IVE.EMBORI = IVE2.CODITE
       INNER JOIN TD_MUL IVE3 ON IVE3.CODTAB = IVE.CODMUL
  LEFT OUTER JOIN TD_NAT IVE4 ON IVE4.NATDEN = IVE.NATFIS
  LEFT OUTER JOIN TD_NAT IVE5 ON IVE5.NATFOR = IVE.NATFIS
        LEFT JOIN TT_DOM TIP001 ON TIP001.CODARQ = 'IVE' AND TIP001.NOMCPO = 'TIP001' AND TIP001.CODCHR = IVE.TIP001
        LEFT JOIN TT_DOM PENATU ON PENATU.CODARQ = 'IVE' AND PENATU.NOMCPO = 'PENATU' AND PENATU.CODCHR = IVE.PENATU
       INNER JOIN TV_IPR IPR ON IPR.FILMAT = IVE.FILMAT AND IPR.CODMAT = IVE.CODMAT AND  IPR.CODCOR = IVE.CODCOR AND IPR.CODTAM = IVE.CODTAM
       INNER JOIN TT_VEN VEN ON IVE.CODFIL = VEN.CODFIL AND IVE.SEQUEN = VEN.SEQUEN 
WHERE IVE.SITKIT <> '3'
;


/*-- SEQ 2838 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_MEI_PGT_ECF CASCADE;

/*-- SEQ 2839 --*/
CREATE OR REPLACE VIEW TV_MEI_PGT_ECF AS
SELECT TAB.*
  FROM (
SELECT OPE.CODFIL,
       OPE.NUMECF,
       OPE.DATFIS AS DATHOR,
       OPE.TIPDOC,
       OPE.MEIO_PAGAMENTO,
       SUM(OPE.VLROPE) AS VLROPE
  FROM TV_LID_OPE OPE
 WHERE (OPE.CODSER IN ('CF','--'))
   AND (OPE.VLROPE > 0 OR (OPE.VLROPE < 0 AND OPE.TIPOPE IN ('CAN','LAN_REFSAN','GRAVASLDCC','VEN')))
 GROUP BY OPE.CODFIL, OPE.NUMECF, OPE.DATFIS, OPE.TIPDOC, OPE.MEIO_PAGAMENTO
) TAB
;


/*-- SEQ 2840 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_MOVECF_R01 CASCADE;

/*-- SEQ 2841 --*/
CREATE OR REPLACE VIEW TV_MOVECF_R01 AS
/* REGISTRO TIPO R01 - IDENTIFICAO DO ECF, DO USURIO, DO PAF-ECF E DA EMPRESA DESENVOLVEDORA E DADOS DO ARQUIVO */
SELECT TAB.FILECF,
       TAB.NUMECF,
       TAB.SERECF, --02
       TAB.ECFMFA, --03
       TAB.ECFTIP, --05
       TAB.MARECF, --06
       TAB.MODECF, --07
       TAB.VSWECF, --08
       TAB.DSWECF, --09 e 10
       TAB.CODORI, --11
       TAB.CGCFIL, --12
       TAB.IE_FIL, --13
       TAB.PAFECF_CGCTOT,
       TAB.PAFECF_NOMPAF,
       TAB.PAFECF_PRIARQ_MD5,
       TAB.DECF_FILECF,
       TAB.DECF_NUMECF,
       TAB.DECF_SERECF,
       TAB.DECF_ECFMFA,
       TAB.DECF_ECFTIP,
       TAB.DECF_MARECF,
       TAB.DECF_MODECF,
       TAB.DECF_VSWECF,
       TAB.DECF_DSWECF,
       TAB.DECF_CODORI,
       TAB.DECF_CODUID,
       TAB.DECF_ASSINA,
       UID_DECF.CODUID AS UID_DECF_CODUID,
       UID_DECF.USEROS AS UID_DECF_USEROS,
       UID_DECF.DATOPE AS UID_DECF_DATOPE,
       UID_DECF.NOMMAQ AS UID_DECF_NOMMAQ,
       UID_DECF.VERBAS AS UID_DECF_VERBAS,
       UID_DECF.VERSIS AS UID_DECF_VERSIS,
       UID_DECF.NOMSIS AS UID_DECF_NOMSIS,
       UID_DECF.SESSION_ID AS UID_DECF_SESSION_ID,
       UID_DECF.ASSINA AS UID_DECF_ASSINA,
       UID_DECF.CODEMP AS UID_DECF_CODEMP,
       TAB.DFIL_ASSINA,
       UID_DFIL.CODUID AS UID_DFIL_CODUID,
       UID_DFIL.USEROS AS UID_DFIL_USEROS,
       UID_DFIL.DATOPE AS UID_DFIL_DATOPE,
       UID_DFIL.NOMMAQ AS UID_DFIL_NOMMAQ,
       UID_DFIL.VERBAS AS UID_DFIL_VERBAS,
       UID_DFIL.VERSIS AS UID_DFIL_VERSIS,
       UID_DFIL.NOMSIS AS UID_DFIL_NOMSIS,
       UID_DFIL.SESSION_ID AS UID_DFIL_SESSION_ID,
       UID_DFIL.ASSINA AS UID_DFIL_ASSINA,
       UID_DFIL.CODEMP AS UID_DFIL_CODEMP,
       TAB.CFG_CODUID,
       TAB.CFG_PAFECF_ASSINA,
       UID_CFG.CODUID AS UID_CFG_CODUID,
       UID_CFG.USEROS AS UID_CFG_USEROS,
       UID_CFG.DATOPE AS UID_CFG_DATOPE,
       UID_CFG.NOMMAQ AS UID_CFG_NOMMAQ,
       UID_CFG.VERBAS AS UID_CFG_VERBAS,
       UID_CFG.VERSIS AS UID_CFG_VERSIS,
       UID_CFG.NOMSIS AS UID_CFG_NOMSIS,
       UID_CFG.SESSION_ID AS UID_CFG_SESSION_ID,
       UID_CFG.ASSINA AS UID_CFG_ASSINA,
       UID_CFG.CODEMP AS UID_CFG_CODEMP,
       TAB.CODFIL AS DFIL_CODFIL,
       TAB.CGCFIL AS DFIL_CGCFIL,
       TAB.IE_FIL AS DFIL_IE_FIL,
       TAB.INSMUN AS DFIL_INSMUN,
       TAB.RAZSOC AS DFIL_RAZSOC,
       TAB.DATEST AS DFIL_DATEST
  FROM (
SELECT DECF.FILECF,
       DECF.NUMECF,
       DECF.SERECF, --02
       DECF.ECFMFA, --03
       DECF.ECFTIP, --05
       DECF.MARECF, --06
       DECF.MODECF, --07
       DECF.VSWECF, --08
       (CASE WHEN (DECF.DSWECF IS NOT NULL) AND (DECF.DSWECF > TO_DATE('31/12/1899 00:00:00','DD/MM/YYYY HH24:MI:SS'))
                 THEN DECF.DSWECF
                 ELSE TO_DATE('31/12/1899 00:00:00','DD/MM/YYYY HH24:MI:SS')
            END) AS DSWECF, --09 e 10
       DECF.CODORI, --11
       DFIL.CGCFIL, --12
       DFIL.IE_FIL, --13
       DFIL.CODFIL,
       DFIL.INSMUN,
       DFIL.RAZSOC,
       DFIL.DATEST,
       DECF.TNCIEE,
       CFG.PAFECF_CGCTOT,
       CFG.PAFECF_NOMPAF,
       CFG.PAFECF_PRIARQ_MD5,
       CFG.CODUID AS CFG_CODUID,
       CFG.PAFECF_ASSINA AS CFG_PAFECF_ASSINA,
       DFIL.CODUID AS DFIL_CODUID,
       DFIL.ASSINA AS DFIL_ASSINA,
       DECF.FILECF AS DECF_FILECF,
       DECF.NUMECF AS DECF_NUMECF,
       DECF.SERECF AS DECF_SERECF,
       DECF.ECFMFA AS DECF_ECFMFA,
       DECF.ECFTIP AS DECF_ECFTIP,
       DECF.MARECF AS DECF_MARECF,
       DECF.MODECF AS DECF_MODECF,
       DECF.VSWECF AS DECF_VSWECF,
       DECF.DSWECF AS DECF_DSWECF,
       DECF.CODORI AS DECF_CODORI,
       DECF.CODUID AS DECF_CODUID,
       DECF.ASSINA AS DECF_ASSINA
  FROM TD_ECF DECF INNER JOIN TD_FIL DFIL ON DFIL.CODFIL = DECF.FILECF
                   CROSS JOIN TT_CFG CFG
) TAB LEFT JOIN TT_UID UID_DECF ON UID_DECF.CODUID = TAB.DECF_CODUID
      LEFT JOIN TT_UID UID_CFG ON UID_CFG.CODUID = TAB.CFG_CODUID
      LEFT JOIN TT_UID UID_DFIL ON UID_DFIL.CODUID = TAB.DFIL_CODUID
;


/*-- SEQ 2842 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_MOVECF_R02 CASCADE;

/*-- SEQ 2843 --*/
CREATE OR REPLACE VIEW TV_MOVECF_R02 AS
/* REGISTRO TIPO R02 - RELAO DE REDUES Z */
SELECT TAB.CODFIL,
       TAB.NUMECF,
       TAB.DATOPE, -- 09
       TAB.DATOPE AS DATFIS,
       TAB.SERECF, --02
       TAB.ECFMFA, --03
       TAB.MODECF, --04
       TAB.CODUSU, --05
       TAB.CNT_RZ, --06
       TAB.CUPFIM, --07
       TAB.CNT_RO, --08
       TAB.DATFEC, --10 e 11
       TAB.GT_DIF AS VL_VBD, --12
       TAB.DISSQN, -- 13
       TAB.DECF_FILECF,
       TAB.DECF_NUMECF,
       TAB.DECF_SERECF,
       TAB.DECF_ECFMFA,
       TAB.DECF_ECFTIP,
       TAB.DECF_MARECF,
       TAB.DECF_MODECF,
       TAB.DECF_VSWECF,
       TAB.DECF_DSWECF,
       TAB.DECF_CODORI,
       TAB.DECF_CODUID,
       TAB.DECF_ASSINA,
       UID_DECF.CODUID AS UID_DECF_CODUID,
       UID_DECF.USEROS AS UID_DECF_USEROS,
       UID_DECF.DATOPE AS UID_DECF_DATOPE,
       UID_DECF.NOMMAQ AS UID_DECF_NOMMAQ,
       UID_DECF.VERBAS AS UID_DECF_VERBAS,
       UID_DECF.VERSIS AS UID_DECF_VERSIS,
       UID_DECF.NOMSIS AS UID_DECF_NOMSIS,
       UID_DECF.SESSION_ID AS UID_DECF_SESSION_ID,
       UID_DECF.ASSINA AS UID_DECF_ASSINA,
       UID_DECF.CODEMP AS UID_DECF_CODEMP,
       TAB.RECF_CODFIL,
       TAB.RECF_NUMECF,
       TAB.RECF_DATOPE,
       TAB.RECF_CNT_RO,
       TAB.RECF_CNT_RZ,
       TAB.RECF_INTERV,
       TAB.RECF_CUPFIM,
       TAB.RECF_DATOPE_PAF,
       TAB.RECF_DATFEC,
       TAB.RECF_GT_FIM,
       TAB.RECF_GT_INI,
       TAB.RECF_CODUID,
       TAB.RECF_ASSINA,
       UID_RECF.CODUID AS UID_RECF_CODUID,
       UID_RECF.USEROS AS UID_RECF_USEROS,
       UID_RECF.DATOPE AS UID_RECF_DATOPE,
       UID_RECF.NOMMAQ AS UID_RECF_NOMMAQ,
       UID_RECF.VERBAS AS UID_RECF_VERBAS,
       UID_RECF.VERSIS AS UID_RECF_VERSIS,
       UID_RECF.NOMSIS AS UID_RECF_NOMSIS,
       UID_RECF.SESSION_ID AS UID_RECF_SESSION_ID,
       UID_RECF.ASSINA AS UID_RECF_ASSINA,
       UID_RECF.CODEMP AS UID_RECF_CODEMP,
       TAB.RCAI_CODFIL,
       TAB.RCAI_SEQUEN,
       TAB.RCAI_FILUSU,
       TAB.RCAI_CODUSU,
       TAB.RCAI_CODUID,
       TAB.RCAI_ASSINA,
       UID_RCAI.CODUID AS UID_RCAI_CODUID,
       UID_RCAI.USEROS AS UID_RCAI_USEROS,
       UID_RCAI.DATOPE AS UID_RCAI_DATOPE,
       UID_RCAI.NOMMAQ AS UID_RCAI_NOMMAQ,
       UID_RCAI.VERBAS AS UID_RCAI_VERBAS,
       UID_RCAI.VERSIS AS UID_RCAI_VERSIS,
       UID_RCAI.NOMSIS AS UID_RCAI_NOMSIS,
       UID_RCAI.SESSION_ID AS UID_RCAI_SESSION_ID,
       UID_RCAI.ASSINA AS UID_RCAI_ASSINA,
       UID_RCAI.CODEMP AS UID_RCAI_CODEMP
  FROM (
SELECT RECF.CODFIL,
       RECF.NUMECF,
       RECF.DATOPE_PAF AS DATOPE,
       DECF.SERECF, --02
       DECF.ECFMFA, --03
       DECF.MODECF, --04
       MOD(TO_NUMBER(RCAI.CODUSU),100) AS CODUSU, --05
       RECF.CNT_RZ, --06
       RECF.CUPFIM, --07
       RECF.INTERV AS CNT_RO, --08
       RECF.DATFEC, --10 e 11
       COALESCE(RECF.GT_FIM,0)-COALESCE(RECF.GT_INI,0) AS GT_DIF, --12
       CAST('S' AS CHAR(1)) AS DISSQN, -- 13
       DECF.FILECF AS DECF_FILECF,
       DECF.NUMECF AS DECF_NUMECF,
       DECF.SERECF AS DECF_SERECF,
       DECF.ECFMFA AS DECF_ECFMFA,
       DECF.ECFTIP AS DECF_ECFTIP,
       DECF.MARECF AS DECF_MARECF,
       DECF.MODECF AS DECF_MODECF,
       DECF.VSWECF AS DECF_VSWECF,
       DECF.DSWECF AS DECF_DSWECF,
       DECF.CODORI AS DECF_CODORI,
       DECF.CODUID AS DECF_CODUID,
       DECF.ASSINA AS DECF_ASSINA,
       RECF.CODFIL AS RECF_CODFIL,
       RECF.NUMECF AS RECF_NUMECF,
       RECF.DATOPE AS RECF_DATOPE,
       RECF.CNT_RO_PAF AS RECF_CNT_RO,
       RECF.CNT_RZ AS RECF_CNT_RZ,
       RECF.INTERV AS RECF_INTERV,
       RECF.CUPFIM AS RECF_CUPFIM,
       RECF.DATOPE_PAF AS RECF_DATOPE_PAF,
       RECF.DATFEC AS RECF_DATFEC,
       RECF.GT_FIM AS RECF_GT_FIM,
       RECF.GT_INI AS RECF_GT_INI,
       RECF.CODUID AS RECF_CODUID,
       RECF.ASSINA AS RECF_ASSINA,
       RCAI.CODFIL AS RCAI_CODFIL,
       RCAI.SEQUEN AS RCAI_SEQUEN,
       RCAI.FILUSU AS RCAI_FILUSU,
       RCAI.CODUSU AS RCAI_CODUSU,
       RCAI.CODUID AS RCAI_CODUID,
       RCAI.ASSINA AS RCAI_ASSINA
  FROM (SELECT IRECF.*,
               (SELECT MAX(RC1.SEQUEN)
				  FROM TR_CAI RC1
				 WHERE RC1.CODFIL = IRECF.CODFIL
				   AND RC1.NUMECF = IRECF.NUMECF
				   AND TRUNC(RC1.DATFEC) = IRECF.DATOPE) AS MAXRCAI
          FROM TR_ECF IRECF) RECF INNER JOIN TD_ECF DECF ON DECF.FILECF = RECF.CODFIL
                                         AND DECF.NUMECF = RECF.NUMECF
                    LEFT JOIN TR_CAI RCAI ON RCAI.CODFIL = RECF.CODFIL
                                         AND RCAI.SEQUEN = RECF.MAXRCAI
) TAB LEFT JOIN TT_UID UID_DECF ON UID_DECF.CODUID = TAB.DECF_CODUID
      LEFT JOIN TT_UID UID_RECF ON UID_RECF.CODUID = TAB.RECF_CODUID
      LEFT JOIN TT_UID UID_RCAI ON UID_RCAI.CODUID = TAB.RCAI_CODUID
;


/*-- SEQ 2844 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_MOVECF_R03 CASCADE;

/*-- SEQ 2845 --*/
CREATE OR REPLACE VIEW TV_MOVECF_R03 AS
/* REGISTRO TIPO R03 - DETALHE DA REDUO Z */
SELECT TAB.CODFIL,
       TAB.SERECF,
       TAB.NUMECF,
       TAB.DATOPE,
       TAB.DATOPE AS DATFIS,
       TAB.ECFMFA,
       TAB.MODECF,
       TAB.CODUSU,
       TAB.CNT_RZ,
       TAB.TOTALI,
       TAB.VLRDIG,
       TAB.ECF_CODFIL,
       TAB.ECF_NUMECF,
       TAB.ECF_DATOPE,
       TAB.ECF_TOTALI,
       TAB.ECF_TIPTOT,
       TAB.ECF_TOTPAR,
       TAB.ECF_CNT_RZ,
       TAB.ECF_VLRTOT,
       TAB.ECF_VLRBAS,
       TAB.ECF_CODUID,
       TAB.ECF_ASSINA,
       UID_ECF.CODUID AS UID_ECF_CODUID,
       UID_ECF.USEROS AS UID_ECF_USEROS,
       UID_ECF.DATOPE AS UID_ECF_DATOPE,
       UID_ECF.NOMMAQ AS UID_ECF_NOMMAQ,
       UID_ECF.VERBAS AS UID_ECF_VERBAS,
       UID_ECF.VERSIS AS UID_ECF_VERSIS,
       UID_ECF.NOMSIS AS UID_ECF_NOMSIS,
       UID_ECF.SESSION_ID AS UID_ECF_SESSION_ID,
       UID_ECF.ASSINA AS UID_ECF_ASSINA,
       UID_ECF.CODEMP AS UID_ECF_CODEMP,
       TAB.DECF_FILECF,
       TAB.DECF_NUMECF,
       TAB.DECF_SERECF,
       TAB.DECF_ECFMFA,
       TAB.DECF_ECFTIP,
       TAB.DECF_MARECF,
       TAB.DECF_MODECF,
       TAB.DECF_VSWECF,
       TAB.DECF_DSWECF,
       TAB.DECF_CODORI,
       TAB.DECF_CODUID,
       TAB.DECF_ASSINA,
       UID_DECF.CODUID AS UID_DECF_CODUID,
       UID_DECF.USEROS AS UID_DECF_USEROS,
       UID_DECF.DATOPE AS UID_DECF_DATOPE,
       UID_DECF.NOMMAQ AS UID_DECF_NOMMAQ,
       UID_DECF.VERBAS AS UID_DECF_VERBAS,
       UID_DECF.VERSIS AS UID_DECF_VERSIS,
       UID_DECF.NOMSIS AS UID_DECF_NOMSIS,
       UID_DECF.SESSION_ID AS UID_DECF_SESSION_ID,
       UID_DECF.ASSINA AS UID_DECF_ASSINA,
       UID_DECF.CODEMP AS UID_DECF_CODEMP
  FROM (
SELECT MAX(ECF.CODFIL) AS CODFIL,
       MAX(ECF.NUMECF) AS NUMECF,
       MAX(ECF.DATOPE) AS DATOPE,
       MAX(DECF.SERECF) AS SERECF, --02
       MAX(DECF.ECFMFA) AS ECFMFA, --03
       MAX(DECF.MODECF) AS MODECF, --04
       MAX(MOD(TO_NUMBER(RCAI.CODUSU),100)) AS CODUSU, --05
       MAX(ECF.CNT_RZ) AS CNT_RZ, --06
       ECF.TOTPAR AS TOTALI, --07
       SUM(CASE ECF.TIPTOT WHEN 'O'
                THEN ECF.VLRTOT
                ELSE ECF.VLRBAS
           END) AS VLRDIG, --08
       ECF.CODFIL AS ECF_CODFIL,
       ECF.NUMECF AS ECF_NUMECF,
       ECF.DATOPE AS ECF_DATOPE,
       ECF.TOTALI AS ECF_TOTALI,
       ECF.TIPTOT AS ECF_TIPTOT,
       ECF.TOTPAR AS ECF_TOTPAR,
       ECF.CNT_RZ AS ECF_CNT_RZ,
       SUM(ECF.VLRTOT) AS ECF_VLRTOT,
       SUM(ECF.VLRBAS) AS ECF_VLRBAS,
       ECF.CODUID AS ECF_CODUID,
       ECF.ASSINA AS ECF_ASSINA,
       DECF.FILECF AS DECF_FILECF,
       DECF.NUMECF AS DECF_NUMECF,
       DECF.SERECF AS DECF_SERECF,
       DECF.ECFMFA AS DECF_ECFMFA,
       DECF.ECFTIP AS DECF_ECFTIP,
       DECF.MARECF AS DECF_MARECF,
       DECF.MODECF AS DECF_MODECF,
       DECF.VSWECF AS DECF_VSWECF,
       DECF.DSWECF AS DECF_DSWECF,
       DECF.CODORI AS DECF_CODORI,
       DECF.CODUID AS DECF_CODUID,
       DECF.ASSINA AS DECF_ASSINA
  FROM TT_ECF ECF INNER JOIN TD_ECF DECF ON DECF.FILECF = ECF.CODFIL
                                        AND DECF.NUMECF = ECF.NUMECF
                  LEFT JOIN (SELECT DISTINCT CODFIL,NUMECF,TRUNC(MAX(DATFEC)) AS DATFEC,CODUSU
                               FROM TR_CAI
                              GROUP BY CODFIL,NUMECF,CODUSU) RCAI ON RCAI.CODFIL = ECF.CODFIL
                                                AND RCAI.NUMECF = ECF.NUMECF
                                                AND RCAI.DATFEC = ECF.DATOPE
 GROUP BY ECF.CODFIL, ECF.NUMECF, ECF.DATOPE, ECF.TOTALI, ECF.ORDALI, ECF.TIPTOT, ECF.TOTPAR, ECF.CNT_RZ, ECF.CODUID, ECF.ASSINA,
          DECF.FILECF, DECF.NUMECF, DECF.SERECF, DECF.ECFMFA, DECF.ECFTIP, DECF.MARECF, DECF.MODECF, DECF.VSWECF, DECF.DSWECF,
          DECF.CODUID, DECF.ASSINA, DECF.CODORI
) TAB LEFT JOIN TT_UID UID_ECF ON UID_ECF.CODUID = TAB.ECF_CODUID
      LEFT JOIN TT_UID UID_DECF ON UID_DECF.CODUID = TAB.DECF_CODUID
;


/*-- SEQ 2846 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_MOVECF_R04 CASCADE;

/*-- SEQ 2847 --*/
CREATE OR REPLACE VIEW TV_MOVECF_R04 AS
/* REGISTRO TIPO R04 - CUPOM FISCAL, NOTA FISCAL DE VENDA A CONSUMIDOR E BILHETE DE PASSAGEM */
SELECT TAB.CODFIL,
       TAB.SEQUEN,
       TAB.SERECF,
       TAB.NUMECF,
       TAB.DATOPE,
       TAB.DATFIS,
       TAB.ECFMFA,
       TAB.MODECF,
       TAB.CODUSU,
       TAB.NUMNOT,
       TAB.CONCOO,
       TAB.DATHOR,
       TAB.SUBTOT,
       TAB.DESCON,
       TAB.TIPDES,
       TAB.ACRESC,
       TAB.TIPACR,
       TAB.VLRLIQ,
       TAB.INDCAN,
       TAB.CAN_AD,
       TAB.ORDDES,
       TAB.NOMCLI,
       TAB.NUMDOC,
       TAB.DECF_FILECF,
       TAB.DECF_NUMECF,
       TAB.DECF_SERECF,
       TAB.DECF_ECFMFA,
       TAB.DECF_ECFTIP,
       TAB.DECF_MARECF,
       TAB.DECF_MODECF,
       TAB.DECF_VSWECF,
       TAB.DECF_DSWECF,
       TAB.DECF_CODORI,
       TAB.DECF_CODUID,
       TAB.DECF_ASSINA,
       UID_DECF.CODUID AS UID_DECF_CODUID,
       UID_DECF.USEROS AS UID_DECF_USEROS,
       UID_DECF.DATOPE AS UID_DECF_DATOPE,
       UID_DECF.NOMMAQ AS UID_DECF_NOMMAQ,
       UID_DECF.VERBAS AS UID_DECF_VERBAS,
       UID_DECF.VERSIS AS UID_DECF_VERSIS,
       UID_DECF.NOMSIS AS UID_DECF_NOMSIS,
       UID_DECF.SESSION_ID AS UID_DECF_SESSION_ID,
       UID_DECF.ASSINA AS UID_DECF_ASSINA,
       UID_DECF.CODEMP AS UID_DECF_CODEMP,
       TAB.VEN_CODFIL,
       TAB.VEN_NUMECF,
       TAB.VEN_CODSER,
       TAB.VEN_NUMNOT,
       TAB.VEN_CNT_RO,
       TAB.VEN_VLRLIQ,
       TAB.VEN_FLGEST,
       TAB.VEN_SEREXT,
       TAB.VEN_MODNOT,
       TAB.VEN_CHAVEA,
       TAB.VEN_FILUSU,
       TAB.VEN_CODUSU,
       TAB.VEN_VLRNOT,
       TAB.VEN_DOCNFP,
       TAB.VEN_DATHOR,
       TAB.VEN_NOTMAN,
       TAB.VEN_CODUID,
       TAB.VEN_ASSINA,
       UID_VEN.CODUID AS UID_VEN_CODUID,
       UID_VEN.USEROS AS UID_VEN_USEROS,
       UID_VEN.DATOPE AS UID_VEN_DATOPE,
       UID_VEN.NOMMAQ AS UID_VEN_NOMMAQ,
       UID_VEN.VERBAS AS UID_VEN_VERBAS,
       UID_VEN.VERSIS AS UID_VEN_VERSIS,
       UID_VEN.NOMSIS AS UID_VEN_NOMSIS,
       UID_VEN.SESSION_ID AS UID_VEN_SESSION_ID,
       UID_VEN.ASSINA AS UID_VEN_ASSINA,
       UID_VEN.CODEMP AS UID_VEN_CODEMP,
       TAB.LID_CODFIL,
       TAB.LID_NUMECF,
       TAB.LID_TRN_ID,
       TAB.LID_CONCCF,
       TAB.LID_CONCOO,
       TAB.LID_CONGNF,
       TAB.LID_CONCDC,
       TAB.LID_CONGRG,
       TAB.LID_TIPDOC,
       TAB.LID_DATHOR,
       TAB.LID_DATFIS,
       TAB.LID_CODUID,
       TAB.LID_ASSINA,
       UID_LID.CODUID AS UID_LID_CODUID,
       UID_LID.USEROS AS UID_LID_USEROS,
       UID_LID.DATOPE AS UID_LID_DATOPE,
       UID_LID.NOMMAQ AS UID_LID_NOMMAQ,
       UID_LID.VERBAS AS UID_LID_VERBAS,
       UID_LID.VERSIS AS UID_LID_VERSIS,
       UID_LID.NOMSIS AS UID_LID_NOMSIS,
       UID_LID.SESSION_ID AS UID_LID_SESSION_ID,
       UID_LID.ASSINA AS UID_LID_ASSINA,
       UID_LID.CODEMP AS UID_LID_CODEMP,
       TAB.CLI_FILCLI,
       TAB.CLI_CODCLI,
       TAB.CLI_NOMCLI,
       TAB.CLI_NUMDOC,
       TAB.CLI_ULTNOM,
       TAB.CLI_ASSINA,
       UID_CLI.CODUID AS UID_CLI_CODUID,
       UID_CLI.USEROS AS UID_CLI_USEROS,
       UID_CLI.DATOPE AS UID_CLI_DATOPE,
       UID_CLI.NOMMAQ AS UID_CLI_NOMMAQ,
       UID_CLI.VERBAS AS UID_CLI_VERBAS,
       UID_CLI.VERSIS AS UID_CLI_VERSIS,
       UID_CLI.NOMSIS AS UID_CLI_NOMSIS,
       UID_CLI.SESSION_ID AS UID_CLI_SESSION_ID,
       UID_CLI.ASSINA AS UID_CLI_ASSINA,
       UID_CLI.CODEMP AS UID_CLI_CODEMP
  FROM (
SELECT VEN.CODFIL,
       VEN.SEQUEN,
       VEN.NUMECF,
       VEN.DATHOR AS DATOPE,
       CASE WHEN VEN.CODSER='CF' THEN VEN.DATFIS ELSE TRUNC(VEN.DATHOR) END AS DATFIS,
       DECF.SERECF, --02
       DECF.ECFMFA, --03
       DECF.MODECF, --04
       MOD(TO_NUMBER(VEN.CODUSU),100) AS CODUSU, --05
       CASE WHEN VEN.CODSER = 'CF'
            THEN COALESCE(LID.CONCCF,0)
            ELSE 0
       END AS NUMNOT, --06
       LID.CONCOO AS CONCOO, --07
       VEN.DATHOR, --08
       CASE WHEN (SELECT COUNT(*)
                    FROM TT_LID LID
                   WHERE LID.CODFIL = VEN.CODFIL
                     AND LID.NUMECF = VEN.NUMECF
                     AND LID.CODSER = VEN.CODSER
                     AND LID.CUPFIS = VEN.NUMNOT
                     AND LID.CONCOO = CASE WHEN ISDIGIT(TRIM(LID.CUPFIS)) > 0 THEN TO_NUMBER(LID.CUPFIS) ELSE -1 END
                     AND LID.TIPDOC = 'NC') > 0 -- RFMP 73638. Venda cancelada antes de ser finalizada
            THEN 0
            ELSE VEN.VLRNOT
       END AS SUBTOT, --09
       CASE WHEN VEN.VLRLIQ-VEN.VLRNOT < 0 THEN (VEN.VLRLIQ-VEN.VLRNOT)*(-1) ELSE 0 END AS DESCON, --10
       CAST('V' AS CHAR(1)) AS TIPDES, --11
       CASE WHEN VEN.VLRLIQ-VEN.VLRNOT > 0 THEN VEN.VLRLIQ-VEN.VLRNOT ELSE 0 END AS ACRESC, --12
       CAST('V' AS CHAR(1)) AS TIPACR, --13
       CASE WHEN (SELECT COUNT(*)
                    FROM TT_LID LID
                   WHERE LID.CODFIL = VEN.CODFIL
                     AND LID.NUMECF = VEN.NUMECF
                     AND LID.CODSER = VEN.CODSER
                     AND LID.CUPFIS = VEN.NUMNOT
                     AND LID.CONCOO = CASE WHEN ISDIGIT(TRIM(LID.CUPFIS)) > 0 THEN TO_NUMBER(LID.CUPFIS) ELSE -1 END
                     AND LID.TIPDOC = 'NC') > 0 -- RFMP 73638. Venda cancelada antes de ser finalizada
            THEN 0
            ELSE VEN.VLRLIQ
       END AS VLRLIQ, --14
       CAST(CASE WHEN VEN.FLGEST = 'C' THEN 'S' ELSE 'N' END AS CHAR(1)) AS INDCAN, --15
       CAST(0 AS Numeric) AS CAN_AD, --16
       CAST(CASE WHEN VEN.VLRLIQ-VEN.VLRNOT < 0 THEN 'D'
                 WHEN VEN.VLRLIQ-VEN.VLRNOT > 0 THEN 'A'
                 ELSE ' '
            END AS CHAR(1)) AS ORDDES, --17
       TRIM(CLI.NOMCLI)||' '||TRIM(COALESCE(CLI.ULTNOM,'')) AS NOMCLI, --18
       COALESCE(VEN.DOCNFP,CLI.NUMDOC) AS NUMDOC, --19
       DECF.FILECF AS DECF_FILECF,
       DECF.NUMECF AS DECF_NUMECF,
       DECF.SERECF AS DECF_SERECF,
       DECF.ECFMFA AS DECF_ECFMFA,
       DECF.ECFTIP AS DECF_ECFTIP,
       DECF.MARECF AS DECF_MARECF,
       DECF.MODECF AS DECF_MODECF,
       DECF.VSWECF AS DECF_VSWECF,
       DECF.DSWECF AS DECF_DSWECF,
       DECF.CODORI AS DECF_CODORI,
       DECF.CODUID AS DECF_CODUID,
       DECF.ASSINA AS DECF_ASSINA,
       VEN.CODFIL AS VEN_CODFIL,
       VEN.NUMECF AS VEN_NUMECF,
       VEN.CODSER AS VEN_CODSER,
       VEN.NUMNOT AS VEN_NUMNOT,
       VEN.CNT_RO AS VEN_CNT_RO,
       VEN.VLRLIQ AS VEN_VLRLIQ,
       VEN.FLGEST AS VEN_FLGEST,
       VEN.SEREXT AS VEN_SEREXT,
       VEN.MODNOT AS VEN_MODNOT,
       VEN.CHAVEA AS VEN_CHAVEA,
       VEN.FILUSU AS VEN_FILUSU,
       VEN.CODUSU AS VEN_CODUSU,
       VEN.VLRNOT AS VEN_VLRNOT,
       VEN.DOCNFP AS VEN_DOCNFP,
       VEN.DATHOR AS VEN_DATHOR,
       VEN.NOTMAN AS VEN_NOTMAN,
       VEN.CODUID AS VEN_CODUID,
       VEN.ASSINA AS VEN_ASSINA,
       LID.CODFIL AS LID_CODFIL,
       LID.NUMECF AS LID_NUMECF,
       LID.TRN_ID AS LID_TRN_ID,
       LID.CONCCF AS LID_CONCCF,
       LID.CONCOO AS LID_CONCOO,
       LID.CONGNF AS LID_CONGNF,
       LID.CONCDC AS LID_CONCDC,
       LID.CONGRG AS LID_CONGRG,
       LID.TIPDOC AS LID_TIPDOC,
       LID.DATHOR AS LID_DATHOR,
       LID.DATFIS AS LID_DATFIS,
       LID.CODUID AS LID_CODUID,
       LID.ASSINA AS LID_ASSINA,
       CLI.FILCLI AS CLI_FILCLI,
       CLI.CODCLI AS CLI_CODCLI,
       CLI.NOMCLI AS CLI_NOMCLI,
       CLI.NUMDOC AS CLI_NUMDOC,
       CLI.ULTNOM AS CLI_ULTNOM,
       CLI.CODUID AS CLI_CODUID,
       CLI.ASSINA AS CLI_ASSINA
  FROM TT_VEN VEN INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI
                                       AND CLI.CODCLI = VEN.CODCLI
                  INNER JOIN TD_ECF DECF ON DECF.FILECF = VEN.CODFIL
                                        AND DECF.NUMECF = VEN.NUMECF
                  INNER JOIN TD_NAT NAT ON VEN.CODNAT = NAT.CODTAB
                  LEFT JOIN TT_LID VLID ON VLID.CODFIL = VEN.CODFIL
                                       AND VLID.NUMECF = VEN.NUMECF
                                       AND VLID.CODSER = VEN.CODSER
                                       AND VLID.CUPFIS = VEN.NUMNOT
                                       AND (VLID.CONCOO IS NOT NULL OR VLID.CONCCF IS NOT NULL)
                                       AND VLID.TIPOPE='VEN'
                  LEFT JOIN TT_LID LID ON LID.CODFIL = VEN.CODFIL
                                       AND LID.NUMECF = VEN.NUMECF
                                       AND LID.CODSER = VEN.CODSER
                                       AND LID.CUPFIS = VEN.NUMNOT
                                       AND (LID.CONCOO IS NOT NULL OR LID.CONCCF IS NOT NULL)
                                       AND LID.TIPOPE=CASE WHEN VLID.CODFIL IS NOT NULL THEN 'VEN' ELSE 'CAN' END
 WHERE VEN.NUMNOT NOT LIKE '%#%'
   AND COALESCE(VEN.FUNRUR,0) = 0
   AND ((VEN.CODSER = 'CF') OR
        (CASE WHEN VEN.UFLOJA = 'T' THEN NAT.NATDEN ELSE NAT.NATFOR END IN ('5102','6102')))
) TAB LEFT JOIN TT_UID UID_DECF ON UID_DECF.CODUID = TAB.DECF_CODUID
      LEFT JOIN TT_UID UID_VEN ON UID_VEN.CODUID = TAB.VEN_CODUID
      LEFT JOIN TT_UID UID_LID ON UID_LID.CODUID = TAB.LID_CODUID
      LEFT JOIN TT_UID UID_CLI ON UID_CLI.CODUID = TAB.CLI_CODUID
;


/*-- SEQ 2848 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_MOVECF_R05 CASCADE;

/*-- SEQ 2849 --*/
CREATE OR REPLACE VIEW TV_MOVECF_R05 AS
/* REGISTRO TIPO R05 - DETALHE DO CUPOM FISCAL, DA NOTA FISCAL DE VENDA A CONSUMIDOR OU DO BILHETE DE PASSAGEM */
SELECT TAB.CODFIL,
       TAB.SEQUEN,
       TAB.SERECF,
       TAB.NUMECF,
       TAB.DATOPE,
       TAB.DATFIS,
       TAB.ECFMFA,
       TAB.MODECF,
       TAB.CODUSU,
       TAB.NUMNOT,
       TAB.NUMITE,
       TAB.CONCOO,
       TAB.CODFIS,
       TAB.DESMAT,
       TAB.QTDMOV,
       TAB.MEDUNI,
       TAB.VLRORI,
       TAB.VLRDES,
       TAB.VLRACR,
       TAB.VLRMOV,
       TAB.TOTALI,
       TAB.INDCAN,
       TAB.QTDCAN,
       TAB.VL_CAN,
       TAB.VLACAN,
       TAB.ARRTRU,
       TAB.IIPTPR,
       TAB.DECQTD,
       TAB.DEC_VL,
       TAB.DECF_FILECF,
       TAB.DECF_NUMECF,
       TAB.DECF_SERECF,
       TAB.DECF_ECFMFA,
       TAB.DECF_ECFTIP,
       TAB.DECF_MARECF,
       TAB.DECF_MODECF,
       TAB.DECF_VSWECF,
       TAB.DECF_DSWECF,
       TAB.DECF_CODORI,
       TAB.DECF_CODUID,
       TAB.DECF_ASSINA,
       UID_DECF.CODUID AS UID_DECF_CODUID,
       UID_DECF.USEROS AS UID_DECF_USEROS,
       UID_DECF.DATOPE AS UID_DECF_DATOPE,
       UID_DECF.NOMMAQ AS UID_DECF_NOMMAQ,
       UID_DECF.VERBAS AS UID_DECF_VERBAS,
       UID_DECF.VERSIS AS UID_DECF_VERSIS,
       UID_DECF.NOMSIS AS UID_DECF_NOMSIS,
       UID_DECF.SESSION_ID AS UID_DECF_SESSION_ID,
       UID_DECF.ASSINA AS UID_DECF_ASSINA,
       UID_DECF.CODEMP AS UID_DECF_CODEMP,
       TAB.VEN_CODFIL,
       TAB.VEN_NUMECF,
       TAB.VEN_CODSER,
       TAB.VEN_NUMNOT,
       TAB.VEN_CNT_RO,
       TAB.VEN_VLRLIQ,
       TAB.VEN_FLGEST,
       TAB.VEN_SEREXT,
       TAB.VEN_MODNOT,
       TAB.VEN_CHAVEA,
       TAB.VEN_FILUSU,
       TAB.VEN_CODUSU,
       TAB.VEN_VLRNOT,
       TAB.VEN_DOCNFP,
       TAB.VEN_DATHOR,
       TAB.VEN_NOTMAN,
       TAB.VEN_CODUID,
       TAB.VEN_ASSINA,
       UID_VEN.CODUID AS UID_VEN_CODUID,
       UID_VEN.USEROS AS UID_VEN_USEROS,
       UID_VEN.DATOPE AS UID_VEN_DATOPE,
       UID_VEN.NOMMAQ AS UID_VEN_NOMMAQ,
       UID_VEN.VERBAS AS UID_VEN_VERBAS,
       UID_VEN.VERSIS AS UID_VEN_VERSIS,
       UID_VEN.NOMSIS AS UID_VEN_NOMSIS,
       UID_VEN.SESSION_ID AS UID_VEN_SESSION_ID,
       UID_VEN.ASSINA AS UID_VEN_ASSINA,
       UID_VEN.CODEMP AS UID_VEN_CODEMP,
       TAB.IVE_VEN_DATHOR AS IVE_VEN_DATHOR,
       TAB.IVE_NUMITE,
       TAB.IVE_FILMAT,
       TAB.IVE_CODMAT,
       TAB.IVE_CODCOR,
       TAB.IVE_CODTAM,
       TAB.IVE_QTDMOV,
       TAB.IVE_VLRORI,
       TAB.IVE_VLRMOV,
       TAB.IVE_TIPPRO,
       TAB.IVE_ICMTIP,
       TAB.IVE_TAX001,
       TAB.IVE_VLRDES,
       TAB.IVE_SITMOV,
       TAB.IVE_CODUID,
       TAB.IVE_ASSINA,
       UID_IVE.CODUID AS UID_IVE_CODUID,
       UID_IVE.USEROS AS UID_IVE_USEROS,
       UID_IVE.DATOPE AS UID_IVE_DATOPE,
       UID_IVE.NOMMAQ AS UID_IVE_NOMMAQ,
       UID_IVE.VERBAS AS UID_IVE_VERBAS,
       UID_IVE.VERSIS AS UID_IVE_VERSIS,
       UID_IVE.NOMSIS AS UID_IVE_NOMSIS,
       UID_IVE.SESSION_ID AS UID_IVE_SESSION_ID,
       UID_IVE.ASSINA AS UID_IVE_ASSINA,
       UID_IVE.CODEMP AS UID_IVE_CODEMP,
       TAB.PRO_FILMAT,
       TAB.PRO_CODMAT,
       TAB.PRO_DESMAT,
       TAB.PRO_ARRTRU,
       TAB.PRO_IIPTPR,
       TAB.PRO_TIPPRO,
       TAB.PRO_CODUID,
       TAB.PRO_ASSINA,
       UID_PRO.CODUID AS UID_PRO_CODUID,
       UID_PRO.USEROS AS UID_PRO_USEROS,
       UID_PRO.DATOPE AS UID_PRO_DATOPE,
       UID_PRO.NOMMAQ AS UID_PRO_NOMMAQ,
       UID_PRO.VERBAS AS UID_PRO_VERBAS,
       UID_PRO.VERSIS AS UID_PRO_VERSIS,
       UID_PRO.NOMSIS AS UID_PRO_NOMSIS,
       UID_PRO.SESSION_ID AS UID_PRO_SESSION_ID,
       UID_PRO.ASSINA AS UID_PRO_ASSINA,
       UID_PRO.CODEMP AS UID_PRO_CODEMP,
       TAB.GRA_FILMAT,
       TAB.GRA_CODMAT,
       TAB.GRA_CODCOR,
       TAB.GRA_CODTAM,
       TAB.GRA_REFPRO,
       TAB.GRA_CODFIS,
       TAB.GRA_CODUID,
       TAB.GRA_ASSINA,
       UID_GRA.CODUID AS UID_GRA_CODUID,
       UID_GRA.USEROS AS UID_GRA_USEROS,
       UID_GRA.DATOPE AS UID_GRA_DATOPE,
       UID_GRA.NOMMAQ AS UID_GRA_NOMMAQ,
       UID_GRA.VERBAS AS UID_GRA_VERBAS,
       UID_GRA.VERSIS AS UID_GRA_VERSIS,
       UID_GRA.NOMSIS AS UID_GRA_NOMSIS,
       UID_GRA.SESSION_ID AS UID_GRA_SESSION_ID,
       UID_GRA.ASSINA AS UID_GRA_ASSINA,
       UID_GRA.CODEMP AS UID_GRA_CODEMP,
       TAB.LID_CODFIL,
       TAB.LID_NUMECF,
       TAB.LID_TRN_ID,
       TAB.LID_CONCCF,
       TAB.LID_CONCOO,
       TAB.LID_CONGNF,
       TAB.LID_CONCDC,
       TAB.LID_CONGRG,
       TAB.LID_TIPDOC,
       TAB.LID_DATHOR,
       TAB.LID_DATFIS,
       TAB.LID_CODUID,
       TAB.LID_ASSINA,
       UID_LID.CODUID AS UID_LID_CODUID,
       UID_LID.USEROS AS UID_LID_USEROS,
       UID_LID.DATOPE AS UID_LID_DATOPE,
       UID_LID.NOMMAQ AS UID_LID_NOMMAQ,
       UID_LID.VERBAS AS UID_LID_VERBAS,
       UID_LID.VERSIS AS UID_LID_VERSIS,
       UID_LID.NOMSIS AS UID_LID_NOMSIS,
       UID_LID.SESSION_ID AS UID_LID_SESSION_ID,
       UID_LID.ASSINA AS UID_LID_ASSINA,
       UID_LID.CODEMP AS UID_LID_CODEMP,
       TAB.DMED_UNIMED,
       TAB.DMED_CODTAB,
       TAB.DMED_ASSINA,
       UID_DMED.CODUID AS UID_DMED_CODUID,
       UID_DMED.USEROS AS UID_DMED_USEROS,
       UID_DMED.DATOPE AS UID_DMED_DATOPE,
       UID_DMED.NOMMAQ AS UID_DMED_NOMMAQ,
       UID_DMED.VERBAS AS UID_DMED_VERBAS,
       UID_DMED.VERSIS AS UID_DMED_VERSIS,
       UID_DMED.NOMSIS AS UID_DMED_NOMSIS,
       UID_DMED.SESSION_ID AS UID_DMED_SESSION_ID,
       UID_DMED.ASSINA AS UID_DMED_ASSINA,
       UID_DMED.CODEMP AS UID_DMED_CODEMP
  FROM (
SELECT VEN.CODFIL,
       VEN.SEQUEN,
       VEN.NUMECF,
       VEN.DATHOR AS DATOPE,
       CASE WHEN VEN.CODSER='CF' THEN LID.DATFIS ELSE TRUNC(VEN.DATHOR) END AS DATFIS,
       DECF.SERECF, --02
       DECF.ECFMFA, --03
       DECF.MODECF, --04
       MOD(TO_NUMBER(VEN.CODUSU),100) AS CODUSU, --05
       LID.CONCOO AS CONCOO, --06
       CASE WHEN VEN.CODSER = 'CF'
            THEN COALESCE(LID.CONCCF,0)
            ELSE 0
       END AS NUMNOT, --07
       IVE.NUMITE, --08
       IPR.CODFIS, --09
       IPR.DESMAT, --10
       IVE.QTDMOV, --11
       IPR.MEDUNI, --12
       IVE.VLRORI, --13
       CASE WHEN COALESCE(IVE.VLRDES,0) < 0 THEN IVE.VLRDES ELSE 0 END AS VLRDES,
       CASE WHEN COALESCE(IVE.VLRDES,0) > 0 THEN IVE.VLRDES ELSE 0 END AS VLRACR,
       IVE.VLRMOV, --16
       CASE WHEN IVE.TIPPRO = '0' THEN -- material
                 CASE IVE.ICMTIP
                      WHEN '0' THEN '01T'||LPAD(to_char(TRUNC(COALESCE(IVE.TAX001,0)*100)),4,'0')
                      WHEN '1' THEN 'N1'
                      WHEN '2' THEN 'I1'
                      WHEN '4' THEN 'I1'
                      WHEN '3' THEN 'F1'
                      ELSE          ''
                 END
            ELSE '01S'||LPAD(to_char(TRUNC(COALESCE(IVE.TAX001,0)*100)),4,'0') -- servico
       END AS TOTALI, --17
       CAST(CASE WHEN IVE.SITMOV = 'C' THEN 'S' ELSE 'N' END AS CHAR(1)) AS INDCAN, --18
       CAST(0 AS Numeric) AS QTDCAN, --19
       CAST(0 AS Numeric) AS VL_CAN, --20
       CAST(0 AS Numeric) AS VLACAN, --21
       IPR.ARRTRU, --22
       IPR.IIPTPR, --23
       CAST(0 AS Numeric) AS DECQTD, -- 24 Casas decimais da quantidade
       CAST(0 AS Numeric) AS DEC_VL, -- 25 Casas decimais de valor unitrio
       DECF.FILECF AS DECF_FILECF,
       DECF.NUMECF AS DECF_NUMECF,
       DECF.SERECF AS DECF_SERECF,
       DECF.ECFMFA AS DECF_ECFMFA,
       DECF.ECFTIP AS DECF_ECFTIP,
       DECF.MARECF AS DECF_MARECF,
       DECF.MODECF AS DECF_MODECF,
       DECF.VSWECF AS DECF_VSWECF,
       DECF.DSWECF AS DECF_DSWECF,
       DECF.CODORI AS DECF_CODORI,
       DECF.CODUID AS DECF_CODUID,
       DECF.ASSINA AS DECF_ASSINA,
       VEN.CODFIL AS VEN_CODFIL,
       VEN.NUMECF AS VEN_NUMECF,
       VEN.CODSER AS VEN_CODSER,
       VEN.NUMNOT AS VEN_NUMNOT,
       VEN.CNT_RO AS VEN_CNT_RO,
       VEN.VLRLIQ AS VEN_VLRLIQ,
       VEN.FLGEST AS VEN_FLGEST,
       VEN.SEREXT AS VEN_SEREXT,
       VEN.MODNOT AS VEN_MODNOT,
       VEN.CHAVEA AS VEN_CHAVEA,
       VEN.FILUSU AS VEN_FILUSU,
       VEN.CODUSU AS VEN_CODUSU,
       VEN.VLRNOT AS VEN_VLRNOT,
       VEN.DOCNFP AS VEN_DOCNFP,
       VEN.DATHOR AS VEN_DATHOR,
       VEN.NOTMAN AS VEN_NOTMAN,
       VEN.CODUID AS VEN_CODUID,
       VEN.ASSINA AS VEN_ASSINA,
       IVE.VEN_DATHOR AS IVE_VEN_DATHOR,
       IVE.NUMITE AS IVE_NUMITE,
       IVE.FILMAT AS IVE_FILMAT,
       IVE.CODMAT AS IVE_CODMAT,
       IVE.CODCOR AS IVE_CODCOR,
       IVE.CODTAM AS IVE_CODTAM,
       IVE.QTDMOV AS IVE_QTDMOV,
       IVE.VLRORI AS IVE_VLRORI,
       IVE.VLRMOV AS IVE_VLRMOV,
       IVE.TIPPRO AS IVE_TIPPRO,
       IVE.ICMTIP AS IVE_ICMTIP,
       IVE.TAX001 AS IVE_TAX001,
       IVE.VLRDES AS IVE_VLRDES,
       IVE.SITMOV AS IVE_SITMOV,
       IVE.CODUID AS IVE_CODUID,
       IVE.ASSINA AS IVE_ASSINA,
       IPR.FILMAT AS PRO_FILMAT,
       IPR.CODMAT AS PRO_CODMAT,
       IPR.DESMAT AS PRO_DESMAT,
       IPR.ARRTRU AS PRO_ARRTRU,
       IPR.IIPTPR AS PRO_IIPTPR,
       IPR.TIPPRO AS PRO_TIPPRO,
       IPR.PRO_CODUID AS PRO_CODUID,
       IPR.PRO_ASSINA AS PRO_ASSINA,
       IPR.FILMAT AS GRA_FILMAT,
       IPR.CODMAT AS GRA_CODMAT,
       IPR.CODCOR AS GRA_CODCOR,
       IPR.CODTAM AS GRA_CODTAM,
       IPR.REFPRO AS GRA_REFPRO,
       IPR.CODFIS AS GRA_CODFIS,
       IPR.GRA_CODUID AS GRA_CODUID,
       IPR.GRA_ASSINA AS GRA_ASSINA,
       LID.CODFIL AS LID_CODFIL,
       LID.NUMECF AS LID_NUMECF,
       LID.TRN_ID AS LID_TRN_ID,
       LID.CONCCF AS LID_CONCCF,
       LID.CONCOO AS LID_CONCOO,
       LID.CONGNF AS LID_CONGNF,
       LID.CONCDC AS LID_CONCDC,
       LID.CONGRG AS LID_CONGRG,
       LID.TIPDOC AS LID_TIPDOC,
       LID.DATHOR AS LID_DATHOR,
       LID.DATFIS AS LID_DATFIS,
       LID.CODUID AS LID_CODUID,
       LID.ASSINA AS LID_ASSINA,
       DMED.UNIMED AS DMED_UNIMED,
       DMED.CODTAB AS DMED_CODTAB,
       DMED.CODUID AS DMED_CODUID,
       DMED.ASSINA AS DMED_ASSINA
  FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL
                                       AND IVE.SEQUEN = VEN.SEQUEN
                  INNER JOIN TV_IPR_FAST IPR ON IPR.FILMAT = IVE.FILMAT
                                            AND IPR.CODMAT = IVE.CODMAT
                                            AND IPR.CODCOR = IVE.CODCOR
                                            AND IPR.CODTAM = IVE.CODTAM
                  INNER JOIN TD_ECF DECF ON DECF.FILECF = VEN.CODFIL
                                        AND DECF.NUMECF = VEN.NUMECF
                  INNER JOIN TD_NAT NAT ON VEN.CODNAT = NAT.CODTAB
                  INNER JOIN TD_MED DMED ON DMED.CODTAB = IPR.UNIDAD
                  LEFT JOIN TT_LID VLID ON VLID.CODFIL = VEN.CODFIL
                                       AND VLID.NUMECF = VEN.NUMECF
                                       AND VLID.CODSER = VEN.CODSER
                                       AND VLID.CUPFIS = VEN.NUMNOT
                                       AND (VLID.CONCOO IS NOT NULL OR VLID.CONCCF IS NOT NULL)
                                       AND VLID.TIPOPE='VEN'
                  LEFT JOIN TT_LID LID ON LID.CODFIL = VEN.CODFIL
                                       AND LID.NUMECF = VEN.NUMECF
                                       AND LID.CODSER = VEN.CODSER
                                       AND LID.CUPFIS = VEN.NUMNOT
                                       AND (LID.CONCOO IS NOT NULL OR LID.CONCCF IS NOT NULL)
                                       AND LID.TIPOPE=CASE WHEN VLID.CODFIL IS NOT NULL THEN 'VEN' ELSE 'CAN' END
 WHERE VEN.NUMNOT NOT LIKE '%#%'
   AND COALESCE(VEN.FUNRUR,0) = 0
   AND ((VEN.CODSER = 'CF') OR
        (CASE WHEN VEN.UFLOJA = 'T' THEN NAT.NATDEN ELSE NAT.NATFOR END IN ('5102','6102')))
   AND IVE.SITKIT <> '1'
) TAB LEFT JOIN TT_UID UID_DECF ON UID_DECF.CODUID = TAB.DECF_CODUID
      LEFT JOIN TT_UID UID_VEN ON UID_VEN.CODUID = TAB.VEN_CODUID
      LEFT JOIN TT_UID UID_IVE ON UID_IVE.CODUID = TAB.IVE_CODUID
      LEFT JOIN TT_UID UID_PRO ON UID_PRO.CODUID = TAB.PRO_CODUID
      LEFT JOIN TT_UID UID_GRA ON UID_GRA.CODUID = TAB.GRA_CODUID
      LEFT JOIN TT_UID UID_LID ON UID_LID.CODUID = TAB.LID_CODUID
      LEFT JOIN TT_UID UID_DMED ON UID_DMED.CODUID = TAB.DMED_CODUID
;


/*-- SEQ 2850 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_MOVECF_R06 CASCADE;

/*-- SEQ 2851 --*/
CREATE OR REPLACE VIEW TV_MOVECF_R06 AS
/* REGISTRO TIPO R06 - DEMAIS DOCUMENTOS EMITIDOS PELO ECF */
SELECT TAB.CODFIL,
       TAB.SERECF,
       TAB.NUMECF,
       TAB.DATOPE,
       TAB.DATFIS,
       TAB.ECFMFA,
       TAB.MODECF,
       TAB.CODUSU,
       TAB.CUPFIS,
       TAB.CONCOO,
       TAB.CONGNF,
       TAB.CONGRG,
       TAB.CONCDC,
       TAB.TIPDOC,
       TAB.DATHOR,
       TAB.DECF_FILECF,
       TAB.DECF_NUMECF,
       TAB.DECF_SERECF,
       TAB.DECF_ECFMFA,
       TAB.DECF_ECFTIP,
       TAB.DECF_MARECF,
       TAB.DECF_MODECF,
       TAB.DECF_VSWECF,
       TAB.DECF_DSWECF,
       TAB.DECF_CODORI,
       TAB.DECF_CODUID,
       TAB.DECF_ASSINA,
       UID_DECF.CODUID AS UID_DECF_CODUID,
       UID_DECF.USEROS AS UID_DECF_USEROS,
       UID_DECF.DATOPE AS UID_DECF_DATOPE,
       UID_DECF.NOMMAQ AS UID_DECF_NOMMAQ,
       UID_DECF.VERBAS AS UID_DECF_VERBAS,
       UID_DECF.VERSIS AS UID_DECF_VERSIS,
       UID_DECF.NOMSIS AS UID_DECF_NOMSIS,
       UID_DECF.SESSION_ID AS UID_DECF_SESSION_ID,
       UID_DECF.ASSINA AS UID_DECF_ASSINA,
       UID_DECF.CODEMP AS UID_DECF_CODEMP,
       TAB.LID_CODFIL,
       TAB.LID_NUMECF,
       TAB.LID_TRN_ID,
       TAB.LID_CONCCF,
       TAB.LID_CONCOO,
       TAB.LID_CONGNF,
       TAB.LID_CONCDC,
       TAB.LID_CONGRG,
       TAB.LID_TIPDOC,
       TAB.LID_DATHOR,
       TAB.LID_DATFIS,
       TAB.LID_CODUID,
       TAB.LID_ASSINA,
       UID_LID.CODUID AS UID_LID_CODUID,
       UID_LID.USEROS AS UID_LID_USEROS,
       UID_LID.DATOPE AS UID_LID_DATOPE,
       UID_LID.NOMMAQ AS UID_LID_NOMMAQ,
       UID_LID.VERBAS AS UID_LID_VERBAS,
       UID_LID.VERSIS AS UID_LID_VERSIS,
       UID_LID.NOMSIS AS UID_LID_NOMSIS,
       UID_LID.SESSION_ID AS UID_LID_SESSION_ID,
       UID_LID.ASSINA AS UID_LID_ASSINA,
       UID_LID.CODEMP AS UID_LID_CODEMP,
       TAB.RCAI_CODFIL,
       TAB.RCAI_SEQUEN,
       TAB.RCAI_FILUSU,
       TAB.RCAI_CODUSU,
       TAB.RCAI_CODUID,
       TAB.RCAI_ASSINA,
       UID_RCAI.CODUID AS UID_RCAI_CODUID,
       UID_RCAI.USEROS AS UID_RCAI_USEROS,
       UID_RCAI.DATOPE AS UID_RCAI_DATOPE,
       UID_RCAI.NOMMAQ AS UID_RCAI_NOMMAQ,
       UID_RCAI.VERBAS AS UID_RCAI_VERBAS,
       UID_RCAI.VERSIS AS UID_RCAI_VERSIS,
       UID_RCAI.NOMSIS AS UID_RCAI_NOMSIS,
       UID_RCAI.SESSION_ID AS UID_RCAI_SESSION_ID,
       UID_RCAI.ASSINA AS UID_RCAI_ASSINA,
       UID_RCAI.CODEMP AS UID_RCAI_CODEMP,
       TAB.OPE_CODFIL,
       TAB.OPE_NUMECF,
       TAB.OPE_TRN_ID,
       TAB.OPE_VLROPE,
       TAB.OPE_FILREC,
       TAB.OPE_SEQREC,
       TAB.OPE_FILCCC,
       TAB.OPE_SEQCCC,
       TAB.OPE_FILCHR,
       TAB.OPE_SEQCHR,
       TAB.OPE_FILFIN,
       TAB.OPE_SEQFIN,
       TAB.OPE_FILTEF,
       TAB.OPE_SEQTEF,
       TAB.OPE_CARTAO,
       TAB.OPE_OUTROS,
       TAB.OPE_CAMBIO,
       TAB.OPE_FILDOP,
       TAB.OPE_SEQDOP,
       TAB.OPE_DOCTRO,
       TAB.OPE_FILUSU,
       TAB.OPE_CODUSU,
       TAB.OPE_CODUID,
       TAB.OPE_ASSINA,
       UID_OPE.CODUID AS UID_OPE_CODUID,
       UID_OPE.USEROS AS UID_OPE_USEROS,
       UID_OPE.DATOPE AS UID_OPE_DATOPE,
       UID_OPE.NOMMAQ AS UID_OPE_NOMMAQ,
       UID_OPE.VERBAS AS UID_OPE_VERBAS,
       UID_OPE.VERSIS AS UID_OPE_VERSIS,
       UID_OPE.NOMSIS AS UID_OPE_NOMSIS,
       UID_OPE.SESSION_ID AS UID_OPE_SESSION_ID,
       UID_OPE.ASSINA AS UID_OPE_ASSINA,
       UID_OPE.CODEMP AS UID_OPE_CODEMP,
       TAB.RECF_CODFIL,
       TAB.RECF_NUMECF,
       TAB.RECF_DATOPE,
       TAB.RECF_CNT_RO,
       TAB.RECF_CNT_RZ,
       TAB.RECF_INTERV,
       TAB.RECF_CUPFIM,
       TAB.RECF_DATOPE_PAF,
       TAB.RECF_DATFEC,
       TAB.RECF_GT_FIM,
       TAB.RECF_GT_INI,
       TAB.RECF_CODUID,
       TAB.RECF_ASSINA,
       UID_RECF.CODUID AS UID_RECF_CODUID,
       UID_RECF.USEROS AS UID_RECF_USEROS,
       UID_RECF.DATOPE AS UID_RECF_DATOPE,
       UID_RECF.NOMMAQ AS UID_RECF_NOMMAQ,
       UID_RECF.VERBAS AS UID_RECF_VERBAS,
       UID_RECF.VERSIS AS UID_RECF_VERSIS,
       UID_RECF.NOMSIS AS UID_RECF_NOMSIS,
       UID_RECF.SESSION_ID AS UID_RECF_SESSION_ID,
       UID_RECF.ASSINA AS UID_RECF_ASSINA,
       UID_RECF.CODEMP AS UID_RECF_CODEMP
  FROM (
SELECT LID.CODFIL,
       LID.NUMECF,
       LID.DATHOR AS DATOPE,
       LID.DATFIS,
       LID.CUPFIS,
       DECF.SERECF, --02
       DECF.ECFMFA, --03
       DECF.MODECF, --04
       MOD(TO_NUMBER(COALESCE(OPE.CODUSU, RCAI.CODUSU,'1')),100) AS CODUSU, --05
       LID.CONCOO, --06
       LID.CONGNF, --07
       LID.CONGRG, --08
       LID.CONCDC, --09
       LID.TIPDOC, --10
       LID.DATHOR, --11 e 12
       DECF.FILECF AS DECF_FILECF,
       DECF.NUMECF AS DECF_NUMECF,
       DECF.SERECF AS DECF_SERECF,
       DECF.ECFMFA AS DECF_ECFMFA,
       DECF.ECFTIP AS DECF_ECFTIP,
       DECF.MARECF AS DECF_MARECF,
       DECF.MODECF AS DECF_MODECF,
       DECF.VSWECF AS DECF_VSWECF,
       DECF.DSWECF AS DECF_DSWECF,
       DECF.CODORI AS DECF_CODORI,
       DECF.CODUID AS DECF_CODUID,
       DECF.ASSINA AS DECF_ASSINA,
       LID.CODFIL AS LID_CODFIL,
       LID.NUMECF AS LID_NUMECF,
       LID.TRN_ID AS LID_TRN_ID,
       LID.CONCCF AS LID_CONCCF,
       LID.CONCOO AS LID_CONCOO,
       LID.CONGNF AS LID_CONGNF,
       LID.CONCDC AS LID_CONCDC,
       LID.CONGRG AS LID_CONGRG,
       LID.TIPDOC AS LID_TIPDOC,
       LID.DATHOR AS LID_DATHOR,
       LID.DATFIS AS LID_DATFIS,
       LID.CODUID AS LID_CODUID,
       LID.ASSINA AS LID_ASSINA,
       RCAI.CODFIL AS RCAI_CODFIL,
       RCAI.SEQUEN AS RCAI_SEQUEN,
       RCAI.FILUSU AS RCAI_FILUSU,
       RCAI.CODUSU AS RCAI_CODUSU,
       RCAI.CODUID AS RCAI_CODUID,
       RCAI.ASSINA AS RCAI_ASSINA,
       OPE.CODFIL AS OPE_CODFIL,
       OPE.NUMECF AS OPE_NUMECF,
       OPE.TRN_ID AS OPE_TRN_ID,
       OPE.VLROPE AS OPE_VLROPE,
       OPE.FILREC AS OPE_FILREC,
       OPE.SEQREC AS OPE_SEQREC,
       OPE.FILCCC AS OPE_FILCCC,
       OPE.SEQCCC AS OPE_SEQCCC,
       OPE.FILCHR AS OPE_FILCHR,
       OPE.SEQCHR AS OPE_SEQCHR,
       OPE.FILFIN AS OPE_FILFIN,
       OPE.SEQFIN AS OPE_SEQFIN,
       OPE.FILTEF AS OPE_FILTEF,
       OPE.SEQTEF AS OPE_SEQTEF,
       OPE.CARTAO AS OPE_CARTAO,
       OPE.OUTROS AS OPE_OUTROS,
       OPE.CAMBIO AS OPE_CAMBIO,
       OPE.FILDOP AS OPE_FILDOP,
       OPE.SEQDOP AS OPE_SEQDOP,
       OPE.DOCTRO AS OPE_DOCTRO,
       OPE.FILUSU AS OPE_FILUSU,
       OPE.CODUSU AS OPE_CODUSU,
       OPE.CODUID AS OPE_CODUID,
       OPE.ASSINA AS OPE_ASSINA,
       RECF.CODFIL AS RECF_CODFIL,
       RECF.NUMECF AS RECF_NUMECF,
       RECF.DATOPE AS RECF_DATOPE,
       RECF.CNT_RO_PAF AS RECF_CNT_RO,
       RECF.CNT_RZ AS RECF_CNT_RZ,
       RECF.INTERV AS RECF_INTERV,
       RECF.CUPFIM AS RECF_CUPFIM,
       RECF.DATOPE_PAF AS RECF_DATOPE_PAF,
       RECF.DATFEC AS RECF_DATFEC,
       RECF.GT_FIM AS RECF_GT_FIM,
       RECF.GT_INI AS RECF_GT_INI,
       RECF.CODUID AS RECF_CODUID,
       RECF.ASSINA AS RECF_ASSINA
  FROM (SELECT ILID.*, (SELECT MAX(LRCAI.SEQUEN)
                         FROM TR_CAI LRCAI
                        WHERE LRCAI.CODFIL = ILID.CODFIL
                          AND LRCAI.NUMECF = ILID.NUMECF
                          AND TRUNC(LRCAI.DATFEC) = TRUNC(ILID.DATHOR)) AS MAXRCAI,
                       (SELECT MAX(LOPE.NUMITE)
                           FROM TT_OPE LOPE
                          WHERE LOPE.CODFIL = ILID.CODFIL
                            AND LOPE.NUMECF = ILID.NUMECF
                            AND LOPE.TRN_ID = ILID.TRN_ID) AS MAXOPE
          FROM TT_LID ILID) LID 
         INNER JOIN TD_ECF DECF ON DECF.FILECF = LID.CODFIL
                               AND DECF.NUMECF = LID.NUMECF
          LEFT JOIN TR_ECF RECF ON RECF.CODFIL = LID.CODFIL
                               AND RECF.NUMECF = LID.NUMECF
                               AND RECF.DATOPE = LID.DATFIS
          LEFT JOIN TR_CAI RCAI ON RCAI.CODFIL = LID.CODFIL
                               AND RCAI.SEQUEN = LID.MAXRCAI
          LEFT JOIN TT_OPE OPE ON OPE.CODFIL = LID.CODFIL
                              AND OPE.NUMECF = LID.NUMECF
                              AND OPE.TRN_ID = LID.TRN_ID
                              AND OPE.NUMITE = LID.MAXOPE
 WHERE LID.TIPDOC IN ('CC','CN','RG','RZ','LX','MF')
   AND ( (COALESCE(LID.CONGNF,0) > 0) OR 
         (COALESCE(LID.CONGRG,0) > 0) OR 
         (COALESCE(LID.CONCDC,0) > 0) OR 
         (COALESCE(LID.CONCOO,0) > 0) )
) TAB LEFT JOIN TT_UID UID_DECF ON UID_DECF.CODUID = TAB.DECF_CODUID
      LEFT JOIN TT_UID UID_LID ON UID_LID.CODUID = TAB.LID_CODUID
      LEFT JOIN TT_UID UID_RCAI ON UID_RCAI.CODUID = TAB.RCAI_CODUID
      LEFT JOIN TT_UID UID_OPE ON UID_OPE.CODUID = TAB.OPE_CODUID
      LEFT JOIN TT_UID UID_RECF ON UID_RECF.CODUID = TAB.RECF_CODUID
;


/*-- SEQ 2852 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_MOVECF_R07 CASCADE;

/*-- SEQ 2853 --*/
CREATE OR REPLACE VIEW TV_MOVECF_R07 AS
/* REGISTRO TIPO R07 - DETALHE DO CUPOM FISCAL E DO DOCUMENTO NO FISCAL - MEIO DE PAGAMENTO */
SELECT TAB.CODFIL,
       TAB.SERECF,
       TAB.NUMECF,
       TAB.DATOPE,
       TAB.DATFIS,
       TAB.ECFMFA,
       TAB.MODECF,
       TAB.CODUSU,
       TAB.CUPFIS,
       TAB.CONCOO,
       TAB.CONCCF,
       TAB.CONGNF,
       TAB.MEIO_PAGAMENTO,
       TAB.VLROPE,
       TAB.FLG_ESTORNO,
       TAB.VLR_ESTORNO,
       TAB.CODSER,
       TAB.TIPOPE,
       TAB.TIPDOC,
       TAB.REC_CARTAO,
       TAB.DECF_FILECF,
       TAB.DECF_NUMECF,
       TAB.DECF_SERECF,
       TAB.DECF_ECFMFA,
       TAB.DECF_ECFTIP,
       TAB.DECF_MARECF,
       TAB.DECF_MODECF,
       TAB.DECF_VSWECF,
       TAB.DECF_DSWECF,
       TAB.DECF_CODORI,
       TAB.DECF_CODUID,
       TAB.DECF_ASSINA,
       UID_DECF.CODUID AS UID_DECF_CODUID,
       UID_DECF.USEROS AS UID_DECF_USEROS,
       UID_DECF.DATOPE AS UID_DECF_DATOPE,
       UID_DECF.NOMMAQ AS UID_DECF_NOMMAQ,
       UID_DECF.VERBAS AS UID_DECF_VERBAS,
       UID_DECF.VERSIS AS UID_DECF_VERSIS,
       UID_DECF.NOMSIS AS UID_DECF_NOMSIS,
       UID_DECF.SESSION_ID AS UID_DECF_SESSION_ID,
       UID_DECF.ASSINA AS UID_DECF_ASSINA,
       UID_DECF.CODEMP AS UID_DECF_CODEMP,
       TAB.LID_CODFIL,
       TAB.LID_NUMECF,
       TAB.LID_TRN_ID,
       TAB.LID_CONCCF,
       TAB.LID_CONCOO,
       TAB.LID_CONGNF,
       TAB.LID_CONCDC,
       TAB.LID_CONGRG,
       TAB.LID_TIPDOC,
       TAB.LID_DATHOR,
       TAB.LID_DATFIS,
       TAB.LID_CODUID,
       TAB.LID_ASSINA,
       UID_LID.CODUID AS UID_LID_CODUID,
       UID_LID.USEROS AS UID_LID_USEROS,
       UID_LID.DATOPE AS UID_LID_DATOPE,
       UID_LID.NOMMAQ AS UID_LID_NOMMAQ,
       UID_LID.VERBAS AS UID_LID_VERBAS,
       UID_LID.VERSIS AS UID_LID_VERSIS,
       UID_LID.NOMSIS AS UID_LID_NOMSIS,
       UID_LID.SESSION_ID AS UID_LID_SESSION_ID,
       UID_LID.ASSINA AS UID_LID_ASSINA,
       UID_LID.CODEMP AS UID_LID_CODEMP,
       TAB.OPE_CODFIL,
       TAB.OPE_NUMECF,
       TAB.OPE_TRN_ID,
       TAB.OPE_VLROPE,
       TAB.OPE_FILREC,
       TAB.OPE_SEQREC,
       TAB.OPE_FILCCC,
       TAB.OPE_SEQCCC,
       TAB.OPE_FILCHR,
       TAB.OPE_SEQCHR,
       TAB.OPE_FILFIN,
       TAB.OPE_SEQFIN,
       TAB.OPE_FILTEF,
       TAB.OPE_SEQTEF,
       TAB.OPE_CARTAO,
       TAB.OPE_OUTROS,
       TAB.OPE_CAMBIO,
       TAB.OPE_FILDOP,
       TAB.OPE_SEQDOP,
       TAB.OPE_DOCTRO,
       TAB.OPE_FILUSU,
       TAB.OPE_CODUSU,
       TAB.OPE_CODUID,
       TAB.OPE_ASSINA,
       UID_OPE.CODUID AS UID_OPE_CODUID,
       UID_OPE.USEROS AS UID_OPE_USEROS,
       UID_OPE.DATOPE AS UID_OPE_DATOPE,
       UID_OPE.NOMMAQ AS UID_OPE_NOMMAQ,
       UID_OPE.VERBAS AS UID_OPE_VERBAS,
       UID_OPE.VERSIS AS UID_OPE_VERSIS,
       UID_OPE.NOMSIS AS UID_OPE_NOMSIS,
       UID_OPE.SESSION_ID AS UID_OPE_SESSION_ID,
       UID_OPE.ASSINA AS UID_OPE_ASSINA,
       UID_OPE.CODEMP AS UID_OPE_CODEMP,
       TAB.VEN_CODFIL,
       TAB.VEN_NUMECF,
       TAB.VEN_CODSER,
       TAB.VEN_NUMNOT,
       TAB.VEN_CNT_RO,
       TAB.VEN_VLRLIQ,
       TAB.VEN_FLGEST,
       TAB.VEN_SEREXT,
       TAB.VEN_MODNOT,
       TAB.VEN_CHAVEA,
       TAB.VEN_FILUSU,
       TAB.VEN_CODUSU,
       TAB.VEN_VLRNOT,
       TAB.VEN_DOCNFP,
       TAB.VEN_DATHOR,
       TAB.VEN_NOTMAN,
       TAB.VEN_CODUID,
       TAB.VEN_ASSINA,
       UID_VEN.CODUID AS UID_VEN_CODUID,
       UID_VEN.USEROS AS UID_VEN_USEROS,
       UID_VEN.DATOPE AS UID_VEN_DATOPE,
       UID_VEN.NOMMAQ AS UID_VEN_NOMMAQ,
       UID_VEN.VERBAS AS UID_VEN_VERBAS,
       UID_VEN.VERSIS AS UID_VEN_VERSIS,
       UID_VEN.NOMSIS AS UID_VEN_NOMSIS,
       UID_VEN.SESSION_ID AS UID_VEN_SESSION_ID,
       UID_VEN.ASSINA AS UID_VEN_ASSINA,
       UID_VEN.CODEMP AS UID_VEN_CODEMP
  FROM (
SELECT OPE.CODFIL,
       OPE.NUMECF,
       OPE.DATHOR AS DATOPE,
       OPE.DATFIS,
       OPE.CUPFIS,
       DECF.SERECF, --02
       DECF.ECFMFA, --03
       DECF.MODECF, --04
       MOD(TO_NUMBER(OPE.CODUSU),100) AS CODUSU, --05
       OPE.CONCOO, --06
       OPE.CONCCF, -- 07
       OPE.CONGNF, --08
       OPE.MEIO_PAGAMENTO, --09
       OPE.VLROPE, --10
       CASE WHEN OPE.FLGEST = 'C' THEN 'S' ELSE 'N' END AS FLG_ESTORNO, --11
       CASE WHEN OPE.FLGEST = 'C' THEN OPE.VLROPE ELSE 0 END AS VLR_ESTORNO, --12
       OPE.CODSER,
       OPE.TIPOPE,
       OPE.TIPDOC,
       OPE.REC_CARTAO,
       --TD_ECF
       DECF.FILECF AS DECF_FILECF,
       DECF.NUMECF AS DECF_NUMECF,
       DECF.SERECF AS DECF_SERECF,
       DECF.ECFMFA AS DECF_ECFMFA,
       DECF.ECFTIP AS DECF_ECFTIP,
       DECF.MARECF AS DECF_MARECF,
       DECF.MODECF AS DECF_MODECF,
       DECF.VSWECF AS DECF_VSWECF,
       DECF.DSWECF AS DECF_DSWECF,
       DECF.CODORI AS DECF_CODORI,
       DECF.CODUID AS DECF_CODUID,
       DECF.ASSINA AS DECF_ASSINA,
       --TT_LID
       OPE.LID_CODFIL AS LID_CODFIL,
       OPE.LID_NUMECF AS LID_NUMECF,
       OPE.LID_TRN_ID AS LID_TRN_ID,
       OPE.LID_CONCCF AS LID_CONCCF,
       OPE.LID_CONCOO AS LID_CONCOO,
       OPE.LID_CONGNF AS LID_CONGNF,
       OPE.LID_CONCDC AS LID_CONCDC,
       OPE.LID_CONGRG AS LID_CONGRG,
       OPE.LID_TIPDOC AS LID_TIPDOC,
       OPE.LID_DATHOR AS LID_DATHOR,
       OPE.LID_DATFIS AS LID_DATFIS,
       OPE.LID_CODUID AS LID_CODUID,
       OPE.LID_ASSINA AS LID_ASSINA,
       --TT_OPE
       OPE.OPE_CODFIL AS OPE_CODFIL,
       OPE.OPE_NUMECF AS OPE_NUMECF,
       OPE.OPE_TRN_ID AS OPE_TRN_ID,
       OPE.OPE_VLROPE AS OPE_VLROPE,
       OPE.OPE_FILREC AS OPE_FILREC,
       OPE.OPE_SEQREC AS OPE_SEQREC,
       OPE.OPE_FILCCC AS OPE_FILCCC,
       OPE.OPE_SEQCCC AS OPE_SEQCCC,
       OPE.OPE_FILCHR AS OPE_FILCHR,
       OPE.OPE_SEQCHR AS OPE_SEQCHR,
       OPE.OPE_FILFIN AS OPE_FILFIN,
       OPE.OPE_SEQFIN AS OPE_SEQFIN,
       OPE.OPE_FILTEF AS OPE_FILTEF,
       OPE.OPE_SEQTEF AS OPE_SEQTEF,
       OPE.OPE_CARTAO AS OPE_CARTAO,
       OPE.OPE_OUTROS AS OPE_OUTROS,
       OPE.OPE_CAMBIO AS OPE_CAMBIO,
       OPE.OPE_FILDOP AS OPE_FILDOP,
       OPE.OPE_SEQDOP AS OPE_SEQDOP,
       OPE.OPE_DOCTRO AS OPE_DOCTRO,
       OPE.OPE_FILUSU AS OPE_FILUSU,
       OPE.OPE_CODUSU AS OPE_CODUSU,
       OPE.OPE_CODUID AS OPE_CODUID,
       OPE.OPE_ASSINA AS OPE_ASSINA,
       --TT_VEN
       OPE.VEN_CODFIL,
       OPE.VEN_NUMECF,
       OPE.VEN_CODSER,
       OPE.VEN_NUMNOT,
       OPE.VEN_CNT_RO,
       OPE.VEN_VLRLIQ,
       OPE.VEN_FLGEST,
       OPE.VEN_SEREXT,
       OPE.VEN_MODNOT,
       OPE.VEN_CHAVEA,
       OPE.VEN_FILUSU,
       OPE.VEN_CODUSU,
       OPE.VEN_VLRNOT,
       OPE.VEN_DOCNFP,
       OPE.VEN_DATHOR,
       OPE.VEN_NOTMAN,
       OPE.VEN_CODUID,
       OPE.VEN_ASSINA
  FROM TV_LID_OPE OPE INNER JOIN TD_ECF DECF ON DECF.FILECF = OPE.CODFIL
                                            AND DECF.NUMECF = OPE.NUMECF
/* Pedro E. Braga - Transferidos Condies para Delphi para poder Validar Registro do CONGNF quando Venda carto */
-- WHERE (OPE.CODSER IN ('CF','--'))
--   AND (OPE.VLROPE > 0 OR (OPE.VLROPE < 0 AND OPE.TIPOPE IN (/*'CAN',*/'LAN_REFSAN','GRAVASLDCC','VEN')))
--   AND (OPE.CONCCF IS NOT NULL OR OPE.CONGNF IS NOT NULL)
 WHERE OPE.TIPDOC NOT IN ('RZ','LX','MF')
) TAB LEFT JOIN TT_UID UID_DECF ON UID_DECF.CODUID = TAB.DECF_CODUID
      LEFT JOIN TT_UID UID_LID ON UID_LID.CODUID = TAB.LID_CODUID
      LEFT JOIN TT_UID UID_OPE ON UID_OPE.CODUID = TAB.OPE_CODUID
      LEFT JOIN TT_UID UID_VEN ON UID_VEN.CODUID = TAB.VEN_CODUID
;


/*-- SEQ 2854 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PCIA_VEN_HP CASCADE;

/*-- SEQ 2855 --*/
CREATE OR REPLACE VIEW TV_PCIA_VEN_HP AS
SELECT VEN.CODFIL,
CASE VEN.CODFIL WHEN '012' THEN '3-9M2SI' 
            WHEN '013' THEN '3-FDK3BP'
       ELSE '3-FDK3KZ' END AS CODIGO_REVENDA,
       FILORI.CODEXT AS CODIGO_ORIGEM,
       --       CAST('PAPEL E CIA PREMIUM RESELLER' AS VARCHAR(28)) AS STORE_NAME,
       CAST('BRAZIL' AS VARCHAR(6)) AS PAIS,
       INI.DATOPE AS INICIO_SEMANA_VENDAS,
       FIM.DATOPE AS TERMINO_SEMANA_VENDAS,
       TRUNC(VEN.DATHOR) AS DATA_VENDA,
       TRIM(VEN.NUMNOT)  AS NUMERO_NOTA_FISCAL_VENDA, 
       (EAN.CODEAN) AS PARTE_NUMBER, 
       --CAST(NULL AS VARCHAR(1)) AS HP_PRODUT, --BRANCO POR ENQUANTO, MAIS TARDE SER EXIGIDO NUMERO DE SRIE
       (COALESCE(IVE.QTDMOV,0)) AS QUANTIDADE_VENDIDA, 
       --CAST(NULL AS VARCHAR(1)) AS PROGRAM_ID, --BRANCO
       (CLI.NOMCLI) AS NOME_CONSUMIDOR, 
       CASE COALESCE(LENGTH(TRIM(CLI.NUMDOC)),0) 
       WHEN 11 THEN SUBSTR(CLI.NUMDOC, 1, 3) || '.' ||
		  SUBSTR(CLI.NUMDOC, 4, 3) || '.' ||
		  SUBSTR(CLI.NUMDOC, 7, 3) || '-' ||
		  SUBSTR(CLI.NUMDOC, 10, 2)
       WHEN 0  THEN CLI.NUMDOC
       ELSE SUBSTR(CLI.NUMDOC, 1, 2) || '.' || 
		  SUBSTR(CLI.NUMDOC, 3, 3) || '.' ||
		  SUBSTR(CLI.NUMDOC, 6, 3) || '/' ||
		  SUBSTR(CLI.NUMDOC, 9, 4) || '-' ||
		  SUBSTR(CLI.NUMDOC, 13, 2)
       END AS CPF_CNPJ,
       (SUBSTR((SELECT MIN(LPAD(CODFIL,3)||LPAD(to_char(NUMEND),4)||(CASE WHEN CODDDD = NULL THEN NULL ELSE'('||CODDDD||') ' END)||substr(trim(NUMFON),1,4)||'-'||substr(trim(numfon),5,8)) FROM TT_END WHERE FILCLI = CLI.FILCLI AND CODCLI = CLI.CODCLI AND NUMFON IS NOT NULL), 8))  AS Telefone, 
       CLI.E_MCON AS E_MAIL,
       --CAST(CASE WHEN CLI.FLGTIP = 0 THEN 'CASA' ELSE 'ESCRITORIO' END AS VARCHAR(10)) AS PURCHE_TYPE,
       INI.DATOPE AS DATINI,
       FIM.DATOPE AS DATFIM,
       PLA.DESPGT AS FORMA_DE_PAGAMENTO,
       TMAR.DESMAR AS MARCA,
       PRO.CLASS2 AS CLASS2,
       PRO.CLASS3 AS CLASS3,
       VEN.CODNAT AS CODNAT,
       (IVE.VLRUNI) AS VALOR_DA_VENDA 
  FROM TV_VEN VEN INNER JOIN TT_IVE IVE ON IVE.SEQUEN = VEN.SEQUEN 
                                       AND IVE.CODFIL = VEN.CODFIL
                                       AND IVE.SITMOV<>'C'  -- ACRESCENTADO A CONDIO SITMOV POR ITEM / NF CANCELADOS 
                  INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT                      
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = IVE.FILMAT
                                       AND GRA.CODMAT = IVE.CODMAT
                                       AND GRA.CODCOR = IVE.CODCOR
                                       AND GRA.CODTAM = IVE.CODTAM
                  INNER JOIN TT_PRO PRO ON PRO.FILMAT = IVE.FILMAT 
                                       AND PRO.CODMAT = IVE.CODMAT
                  INNER JOIN TD_CL2 CL2 ON CL2.CODTAB = PRO.CLASS2
                  INNER JOIN TD_CL3 CL3 ON CL3.CODTAB = PRO.CLASS3                                                  
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI 
                                       AND CLI.CODCLI = VEN.CODCLI
                  INNER JOIN TT_EAN EAN ON EAN.FILMAT = IVE.FILMAT
                                       AND EAN.CODMAT = IVE.CODMAT
                                       AND EAN.CODCOR = IVE.CODCOR
                                       AND EAN.CODTAM = IVE.CODTAM
                  INNER JOIN TD_FIL FILORI ON FILORI.CODFIL = IVE.CODFIL                     
                  INNER JOIN TT_MAR TMAR ON TMAR.FILMAR = PRO.FILMAR 
                                        AND TMAR.CODMAR = PRO.CODMAR 
                                        AND TMAR.ITEMAR = PRO.ITEMAR 
                                                     INNER JOIN TT_PLA PLA ON VEN.FILPGT = PLA.FILPGT
                                                                      AND VEN.CODPGT = PLA.CODPGT
                  CROSS JOIN TT_DAT INI 
                  CROSS JOIN TT_DAT FIM 
 WHERE IVE.SITKIT <> '1'
   AND VEN.LANVEN = 'T'
   AND EAN.USOEAN = -3 -- PATHP
   AND TMAR.DESMAR LIKE 'HP%' -- HP
   /* AND VEN.CODFIL = '012' -- LOJA DE EQUIPAMENTOS HP */
   /* AND INI.DATOPE = TO_DATE('06/29/2009', 'MM/DD/YYYY') --  OBRIGATRIO USAR ESSE FILTRO NO BI */
   /* AND FIM.DATOPE = TO_DATE('07/01/2009', 'MM/DD/YYYY') --  OBRIGATRIO USAR ESSE FILTRO NO BI */   
   AND VEN.DATHOR BETWEEN INI.DATOPE
                      AND TO_DATE(TO_CHAR(FIM.DATOPE, 'DD/MM/YYYY')||' 23:59:59', 'DD/MM/YYYY HH24:MI:SS')
;


/*-- SEQ 2856 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_BASF_AE2_AE3 CASCADE;

/*-- SEQ 2857 --*/
CREATE OR REPLACE VIEW TV_PED_BASF_AE2_AE3 AS
 SELECT BAE.* FROM (
  SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA 
    FROM TV_PED_BASF_AE2 
   UNION ALL 
  SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA 
    FROM TV_PED_BASF_AE3 
  ORDER BY 1,2,7,9 
  ) BAE
 ;


/*-- SEQ 2858 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_TOTALL CASCADE;

/*-- SEQ 2859 --*/
CREATE OR REPLACE VIEW TV_PED_TOTALL AS
  SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA
    FROM TV_PED_TOTALL_0
   UNION ALL
  SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA
    FROM TV_PED_TOTALL_1
   UNION ALL
  SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA
    FROM TV_PED_TOTALL_2
;


/*-- SEQ 2860 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RECFIS CASCADE;

/*-- SEQ 2861 --*/
CREATE OR REPLACE VIEW TV_RECFIS AS
SELECT 
  NUMDOCUMENTO,
  MATERIAL,
  SERVICO,
  DATAOPERACAO,
  VALORTOTAL,
  QTDPARCELAS,
  NUMPARCELA,
  VALORPARCELA,
  VALORPAGO,
  CASE WHEN SALDO > 0 THEN SALDO ELSE 0 END AS SALDO,
  DATAVENCIMENTO,
  DATARECEBIMENTO,
  CODFIL,
  SEQUEN,
  FILREC
FROM (SELECT 
        /* NMERO DO DOCUMENTO */
        (COALESCE((SELECT NEV.DOCUME 
                     FROM TV_VEN NEV 
                    WHERE NEV.CODFIL = VEN.CODFIL 
                      AND NEV.SEQUEN = VEN.SEQFAT
                  ), VEN.DOCUME)) AS NUMDOCUMENTO,
        /* ALGUM DOS ITENS DA VENDA  MATERIAL? */
        (SELECT CASE WHEN SUM(CASE WHEN IPRO.TIPPRO = 0 THEN 1 ELSE 0 END) >= 1 THEN 'X' ELSE '' END
           FROM TT_IVE IIVE INNER JOIN TT_PRO IPRO ON IIVE.FILMAT = IPRO.FILMAT 
                                                  AND IIVE.CODMAT = IPRO.CODMAT
          WHERE VEN.CODFIL = IIVE.CODFIL
            AND VEN.SEQUEN = IIVE.SEQUEN
        ) AS MATERIAL,
        /* ALGUM DOS ITENS DA VENDA  SERVICO? */
        (SELECT CASE WHEN SUM(CASE WHEN IPRO.TIPPRO = 1 THEN 1 ELSE 0 END) >= 1 THEN 'X' ELSE '' END
           FROM TT_IVE IIVE INNER JOIN TT_PRO IPRO ON IIVE.FILMAT = IPRO.FILMAT 
                                                  AND IIVE.CODMAT = IPRO.CODMAT
          WHERE VEN.CODFIL = IIVE.CODFIL
            AND VEN.SEQUEN = IIVE.SEQUEN
        ) AS SERVICO,
        /* DATA DA OPERAO */
        VEN.DATHOR AS DATAOPERACAO,
        /* VALOR TOTAL */
        VEN.VLRLIQ AS VALORTOTAL,
        /* QUANTIDADE DE PARCELAS */
        (SELECT MAX(IREC.NUMPAR) 
           FROM TT_REC IREC 
          WHERE IREC.CODFIL = REC.CODFIL 
            AND IREC.SEQUEN = REC.SEQUEN 
         GROUP BY IREC.CODFIL, IREC.SEQUEN
        ) AS QTDPARCELAS,
        /* NMERO DA PARCELA */
        REC.NUMPAR AS NUMPARCELA,
        /* ESTADO */
        REC.FLGEST,
        /* VALOR DA PARCELA */
        (SELECT IREC.VLRPAR 
           FROM TT_REC IREC 
          WHERE IREC.CODFIL = REC.CODFIL 
            AND IREC.SEQUEN = REC.SEQUEN 
            AND IREC.NUMPAR = REC.NUMPAR 
            AND IREC.SUBPAR = ' 0'
        ) AS VALORPARCELA,
        /* VALOR PAGO */
        CASE WHEN (REC.FLGEST = 'P' OR REC.SEQCHE IS NOT NULL) THEN 
          COALESCE(REC.VLRPGT,0) + 
          COALESCE(REC.VLRTAX,0) - 
          DescontoParcela(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)
        ELSE 
          0
        END AS VALORPAGO,
        /* DESCONTO */
        DescontoParcela(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) AS DESCONTO,
        /* SALDO */
        CASE WHEN DescontoParcela(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) >= 0 THEN
          VLRPAR - 
          CASE WHEN (REC.FLGEST = 'P' OR REC.SEQCHE IS NOT NULL) THEN 
            COALESCE(REC.VLRPGT,0) + 
            COALESCE(REC.VLRTAX,0) - 
            DescontoParcela(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)
          ELSE 
            0
          END - 
          DescontoParcela(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)
        END AS SALDO,
        /* DATA DE VENCIMENTO */
        REC.DATVEN AS DATAVENCIMENTO,
        /* DATA DE RECEBIMENTO */
        REC.PAGAME AS DATARECEBIMENTO,
        VEN.CODFIL,
        VEN.SEQUEN, 
        VEN.CODSER, 
        REC.VLRPAR, 
        REC.FILREC
      FROM TV_VEN VEN INNER JOIN TT_REC REC ON VEN.CODFIL = REC.CODFIL 
                                           AND VEN.SEQUEN = REC.SEQUEN
     ) TAB
WHERE TAB.FLGEST IN ('A','P')
  AND (TAB.SALDO > 0 OR TAB.VALORPAGO > 0)
;


/*-- SEQ 2862 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RESU_FINA CASCADE;

/*-- SEQ 2863 --*/
CREATE OR REPLACE VIEW TV_RESU_FINA AS
SELECT CLI.FILCLI,
       CLI.CODCLI,
       COALESCE(RFF.VLRVEN,0) AS RFF_VLRVEN,
       COALESCE(RFF.VLRAVE,0) AS RFF_VLRAVE,
       COALESCE(RFF.VLRPGT,0) AS RFF_VLRPGT,
       COALESCE(RFC.VLRVEN,0) AS RFC_VLRVEN,
       COALESCE(RFC.VLRAVE,0) AS RFC_VLRAVE,
       COALESCE(RFC.VLRCAR,0) AS RFC_VLRCAR,
       COALESCE(RFC.VLRCHE,0) AS RFC_VLRCHE,
       COALESCE(RFC.VLRCCH,0) AS RFC_VLRCCH,
       COALESCE(RFC.VLRPGT,0) AS RFC_VLRPGT,
       COALESCE(RFC.VLRCCC,0) AS RFC_VLRCCC,
     ((COALESCE(RFC.VLRVEN,0) + COALESCE(RFC.VLRAVE,0) + COALESCE(RFC.VLRPGT,0) +
       COALESCE(RFC.VLRCAR,0) + COALESCE(RFC.VLRCHE,0) + COALESCE(RFC.VLRCCH,0)) -
      (COALESCE(RFF.VLRVEN,0) + COALESCE(RFF.VLRAVE,0) + COALESCE(RFF.VLRPGT,0)) +
       COALESCE(RFC.VLRCCC,0)) AS VLRSAL,
       CLI.TOTPAR, CLI.TOTATR, CLI.MAIATR, CLI.ULTCOM, CLI.VALOR1, CLI.LIMCHE,
       (COALESCE(CLI.VALOR1,0) - (COALESCE(RFC.VLRVEN,0) + COALESCE(RFC.VLRAVE,0) + COALESCE(RFC.VLRCHE,0) - COALESCE(RFC.VLRCCC,0))) AS VLRSALLIM,
       (COALESCE(CLI.LIMCHE,0) - COALESCE(RFC.VLRCHE,0)) AS VLRSALLIMCHE,
       CAST(COALESCE(TO_CHAR(CLI.ULTCOM,'DD/MM/YYYY'),'  /  /  ') AS VARCHAR(20)) as ULTCOMFORMAT,
       CAST(COALESCE(TO_CHAR(CLI.VALLIM,'DD/MM/YYYY'),'  /  /  ') AS VARCHAR(20)) as VALLIM,
       CAST(COALESCE(TO_CHAR(CLI.DATCRE,'DD/MM/YYYY HH24:MI:SS'),'  /  /  ') AS VARCHAR(20)) as DATCRE,
       CASE COALESCE(CLI.TOTPAR,0) WHEN 0 THEN 0
                               ELSE TRUNC(COALESCE(CLI.TOTATR,0)/CLI.TOTPAR,2)
       END as MEDATR
  FROM TT_CLI CLI LEFT OUTER JOIN TV_RFF RFF ON CLI.FILCLI = RFF.FILCLI AND CLI.CODCLI = RFF.CODCLI
                  LEFT OUTER JOIN TV_RFC RFC ON CLI.FILCLI = RFC.FILCLI AND CLI.CODCLI = RFC.CODCLI
;


/*-- SEQ 2864 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_REGISTROSPAFECF_A2 CASCADE;

/*-- SEQ 2865 --*/
CREATE OR REPLACE VIEW TV_REGISTROSPAFECF_A2 AS
/* REGISTRO TIPO A2 - TOTAL DIÁRIO DE MEIOS DE PAGAMENTO */
SELECT TAB.CODFIL,
       TAB.SERECF,
       TAB.NUMECF,
       TAB.DATOPE,
       TAB.DATFIS,
       TAB.ECFMFA,
       TAB.MODECF,
       TAB.CODUSU,
       TAB.CUPFIS,
       TAB.CONCOO,
       TAB.CONCCF,
       TAB.CONGNF,
       TAB.MEIO_PAGAMENTO,
       TAB.TIPDOC,
       TAB.TIPOPE,
       TAB.CODSER,
       TAB.VLROPE,
       TAB.DECF_FILECF,
       TAB.DECF_NUMECF,
       TAB.DECF_SERECF,
       TAB.DECF_ECFMFA,
       TAB.DECF_ECFTIP,
       TAB.DECF_MARECF,
       TAB.DECF_MODECF,
       TAB.DECF_VSWECF,
       TAB.DECF_DSWECF,
       TAB.DECF_CODORI,
       TAB.DECF_CODUID,
       TAB.DECF_ASSINA,
       UID_DECF.CODUID AS UID_DECF_CODUID,
       UID_DECF.USEROS AS UID_DECF_USEROS,
       UID_DECF.DATOPE AS UID_DECF_DATOPE,
       UID_DECF.NOMMAQ AS UID_DECF_NOMMAQ,
       UID_DECF.VERBAS AS UID_DECF_VERBAS,
       UID_DECF.VERSIS AS UID_DECF_VERSIS,
       UID_DECF.NOMSIS AS UID_DECF_NOMSIS,
       UID_DECF.SESSION_ID AS UID_DECF_SESSION_ID,
       UID_DECF.ASSINA AS UID_DECF_ASSINA,
       UID_DECF.CODEMP AS UID_DECF_CODEMP,
       TAB.LID_CODFIL,
       TAB.LID_NUMECF,
       TAB.LID_TRN_ID,
       TAB.LID_CONCCF,
       TAB.LID_CONCOO,
       TAB.LID_CONGNF,
       TAB.LID_CONCDC,
       TAB.LID_CONGRG,
       TAB.LID_TIPDOC,
       TAB.LID_DATHOR,
       TAB.LID_DATFIS,
       TAB.LID_CODUID,
       TAB.LID_ASSINA,
       UID_LID.CODUID AS UID_LID_CODUID,
       UID_LID.USEROS AS UID_LID_USEROS,
       UID_LID.DATOPE AS UID_LID_DATOPE,
       UID_LID.NOMMAQ AS UID_LID_NOMMAQ,
       UID_LID.VERBAS AS UID_LID_VERBAS,
       UID_LID.VERSIS AS UID_LID_VERSIS,
       UID_LID.NOMSIS AS UID_LID_NOMSIS,
       UID_LID.SESSION_ID AS UID_LID_SESSION_ID,
       UID_LID.ASSINA AS UID_LID_ASSINA,
       UID_LID.CODEMP AS UID_LID_CODEMP,
       TAB.OPE_CODFIL,
       TAB.OPE_NUMECF,
       TAB.OPE_TRN_ID,
       TAB.OPE_VLROPE,
       TAB.OPE_FILREC,
       TAB.OPE_SEQREC,
       TAB.OPE_FILCCC,
       TAB.OPE_SEQCCC,
       TAB.OPE_FILCHR,
       TAB.OPE_SEQCHR,
       TAB.OPE_FILFIN,
       TAB.OPE_SEQFIN,
       TAB.OPE_FILTEF,
       TAB.OPE_SEQTEF,
       TAB.OPE_CARTAO,
       TAB.OPE_OUTROS,
       TAB.OPE_CAMBIO,
       TAB.OPE_FILDOP,
       TAB.OPE_SEQDOP,
       TAB.OPE_DOCTRO,
       TAB.OPE_FILUSU,
       TAB.OPE_CODUSU,
       TAB.OPE_CODUID,
       TAB.OPE_ASSINA,
       UID_OPE.CODUID AS UID_OPE_CODUID,
       UID_OPE.USEROS AS UID_OPE_USEROS,
       UID_OPE.DATOPE AS UID_OPE_DATOPE,
       UID_OPE.NOMMAQ AS UID_OPE_NOMMAQ,
       UID_OPE.VERBAS AS UID_OPE_VERBAS,
       UID_OPE.VERSIS AS UID_OPE_VERSIS,
       UID_OPE.NOMSIS AS UID_OPE_NOMSIS,
       UID_OPE.SESSION_ID AS UID_OPE_SESSION_ID,
       UID_OPE.ASSINA AS UID_OPE_ASSINA,
       UID_OPE.CODEMP AS UID_OPE_CODEMP
  FROM (
SELECT OPE.CODFIL,
       OPE.NUMECF,
       OPE.DATHOR AS DATOPE, -- 02
       OPE.DATFIS,
       OPE.CUPFIS,
       DECF.SERECF,
       DECF.ECFMFA,
       DECF.MODECF,
       MOD(TO_NUMBER(OPE.CODUSU),100) AS CODUSU,
       OPE.CONCOO,
       OPE.CONCCF,
       OPE.CONGNF,
       OPE.MEIO_PAGAMENTO, -- 03
       OPE.TIPDOC, -- 04
       OPE.TIPOPE, -- 04
       OPE.CODSER, -- 04
       OPE.VLROPE*CASE WHEN OPE.TIPOPE IN ('LAN_REFSAN') THEN -1 ELSE 1 END AS VLROPE, -- 05
       DECF.FILECF AS DECF_FILECF,
       DECF.NUMECF AS DECF_NUMECF,
       DECF.SERECF AS DECF_SERECF,
       DECF.ECFMFA AS DECF_ECFMFA,
       DECF.ECFTIP AS DECF_ECFTIP,
       DECF.MARECF AS DECF_MARECF,
       DECF.MODECF AS DECF_MODECF,
       DECF.VSWECF AS DECF_VSWECF,
       DECF.DSWECF AS DECF_DSWECF,
       DECF.CODORI AS DECF_CODORI,
       DECF.CODUID AS DECF_CODUID,
       DECF.ASSINA AS DECF_ASSINA,
       OPE.LID_CODFIL AS LID_CODFIL,
       OPE.LID_NUMECF AS LID_NUMECF,
       OPE.LID_TRN_ID AS LID_TRN_ID,
       OPE.LID_CONCCF AS LID_CONCCF,
       OPE.LID_CONCOO AS LID_CONCOO,
       OPE.LID_CONGNF AS LID_CONGNF,
       OPE.LID_CONCDC AS LID_CONCDC,
       OPE.LID_CONGRG AS LID_CONGRG,
       OPE.LID_TIPDOC AS LID_TIPDOC,
       OPE.LID_DATHOR AS LID_DATHOR,
       OPE.LID_CODUID AS LID_CODUID,
       OPE.LID_ASSINA AS LID_ASSINA,
       OPE.LID_DATFIS AS LID_DATFIS,
       OPE.OPE_CODFIL AS OPE_CODFIL,
       OPE.OPE_NUMECF AS OPE_NUMECF,
       OPE.OPE_TRN_ID AS OPE_TRN_ID,
       OPE.OPE_VLROPE AS OPE_VLROPE,
       OPE.OPE_FILREC AS OPE_FILREC,
       OPE.OPE_SEQREC AS OPE_SEQREC,
       OPE.OPE_FILCCC AS OPE_FILCCC,
       OPE.OPE_SEQCCC AS OPE_SEQCCC,
       OPE.OPE_FILCHR AS OPE_FILCHR,
       OPE.OPE_SEQCHR AS OPE_SEQCHR,
       OPE.OPE_FILFIN AS OPE_FILFIN,
       OPE.OPE_SEQFIN AS OPE_SEQFIN,
       OPE.OPE_FILTEF AS OPE_FILTEF,
       OPE.OPE_SEQTEF AS OPE_SEQTEF,
       OPE.OPE_CARTAO AS OPE_CARTAO,
       OPE.OPE_OUTROS AS OPE_OUTROS,
       OPE.OPE_CAMBIO AS OPE_CAMBIO,
       OPE.OPE_FILDOP AS OPE_FILDOP,
       OPE.OPE_SEQDOP AS OPE_SEQDOP,
       OPE.OPE_DOCTRO AS OPE_DOCTRO,
       OPE.OPE_FILUSU AS OPE_FILUSU,
       OPE.OPE_CODUSU AS OPE_CODUSU,
       OPE.OPE_CODUID AS OPE_CODUID,
       OPE.OPE_ASSINA AS OPE_ASSINA
 FROM TV_LID_OPE OPE
  INNER JOIN TD_ECF DECF ON DECF.FILECF = OPE.CODFIL
                        AND DECF.NUMECF = OPE.NUMECF
 WHERE ((OPE.VLROPE > 0)  OR (OPE.VLROPE < 0 AND OPE.TIPOPE IN ('GRAVASLDCC','VEN')))
   AND ((OPE.TIPOPE <> 'GRAVASLDCC') OR (OPE.MEIO_PAGAMENTO<>'C/C'))
   AND OPE.TIPOPE NOT IN ('ESTORNO','CAN','LAN_REFSAN')
   AND OPE.FLGEST <> 'C'
) TAB LEFT JOIN TT_UID UID_DECF ON UID_DECF.CODUID = TAB.DECF_CODUID
      LEFT JOIN TT_UID UID_LID ON UID_LID.CODUID = TAB.LID_CODUID
      LEFT JOIN TT_UID UID_OPE ON UID_OPE.CODUID = TAB.OPE_CODUID
;


/*-- SEQ 2866 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_REN CASCADE;

/*-- SEQ 2867 --*/
CREATE OR REPLACE VIEW TV_REN AS
select ori.codfil, ori.sequen, ori.renego, ori.pagame,
    max(ori.filcli) as filcli, max(ori.codcli) as codcli,
    min(ori.vlrreg) as vlrreg,
    min(ori.totatr) as totatr,
    min(ori.a_venc) as a_venc,
    min(ori.vencid) as vencid,
    min(substr(usuario,1,3)) as filusu,
    min(substr(usuario,3,3)) as codusu,
    sum(des.vlrpar) as vlrfim,
    count(*) as totfim,
    max( add_day(des.datven,trunc(des.datven) - trunc(ori.pagame)) ) as przfim,
    sum( case when des.datven = ori.pagame then des.vlrpar else 0 end ) as vlrent
from (select rec.codfil, rec.sequen, rec.renego, rec.pagame,
       sum( rec.vlrpar ) as vlrreg,
       sum( case when datven < pagame then trunc(pagame) - trunc(datven) else 0 end) as totatr,
       sum( case when datven < pagame then 1 else 0 end) as a_venc,
       sum( case when datven < pagame then 0 else 1 end) as vencid,
       min( rec.filusu || rec.codusu) as usuario,
       max( ven.filcli) as filcli,
       max( ven.codcli) as codcli
   from tt_rec rec inner join tt_ven ven on rec.codfil = ven.codfil and rec.sequen = ven.sequen
   where rec.renego is not null
    and rec.flgest = 'C'
   group by rec.codfil, rec.sequen, rec.renego, rec.pagame) ori,
   tt_rec des
where des.codfil = ori.codfil
 and des.sequen = ori.sequen
 and des.renori = ori.renego
 and des.subpar = ' 0'
group by ori.codfil, ori.sequen, ori.renego, ori.pagame
;


/*-- SEQ 2868 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RES_001 CASCADE;

/*-- SEQ 2869 --*/
CREATE OR REPLACE VIEW TV_RES_001 AS
-- RFMP 76140
-- Views usadas pela TV_CLI_DIV devem mostrar as dvidas.
-- TV_RES e funo DIVIDA passaram a fazer o filtro pela NAODIV.
-- Mudana realizada para que a dvida do cliente aparecesse no histrico de parceiros.
SELECT 1 AS TIPRES,
       MIN(DIV.FLGTIP) AS FLGTIP,
       TO_CHAR('LIMITE DE CRDITO') AS RESTRI,
       DIV.NUMDOC,
       SUM(COALESCE(DIV.DIVIDA,0)) AS DIVIDA,
       SUM(COALESCE(DIV.OCORRE,0)) AS OCORRE,
       MIN(DIV.LIMITE) AS LIMITE
  FROM TV_CLI_DIV DIV INNER JOIN TT_CLI CLI ON CLI.FILCLI = DIV.FILCLI
                                           AND CLI.CODCLI = DIV.CODCLI
 WHERE CLI.NAODIV = 'F'
GROUP BY DIV.NUMDOC
UNION ALL
SELECT 1 AS TIPRES,
       CLI.FLGTIP AS FLGTIP,
       TO_CHAR('LIMITE DE CRDITO') AS RESTRI,
       CLI.NUMDOC,
       0 AS DIVIDA,
       0 AS OCORRE,
       CASE WHEN CLI.VALLIM IS NOT NULL AND CLI.VALLIM < TRUNC(AGORA()) -- Se limite tem validade e j expirou
            THEN 0
            ELSE CASE WHEN CFG.LIMDIA = 0 THEN CLI.VALOR1
                     ELSE CASE WHEN AGORA() > ADD_DAY(GREATEST(CLI.DATCRE, COALESCE(CLI.ULTCOM, CLI.DATCRE)),  CFG.LIMDIA) THEN 0
                               ELSE COALESCE(CLI.VALOR1,0)
                           END
                 END
       END AS LIMITE
   FROM TT_CLI CLI INNER JOIN TT_CFG CFG ON (COALESCE(CFG.VC_FILCLI,'')||COALESCE(CFG.VC_CODCLI,'')) <> (COALESCE(CLI.FILCLI,'')||COALESCE(CLI.CODCLI,''))
  WHERE (not exists (select 1 as ok from TV_CLI_DIV DIV where CLI.NUMDOC=div.NUMDOC)
          OR CLI.NAODIV = 'T')
;

/*-- SEQ 2870 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RES_002 CASCADE;

/*-- SEQ 2871 --*/
CREATE OR REPLACE VIEW TV_RES_002 AS
SELECT /*+ INDEX(CHR,I_LC_CHR_NUMDOC) */
       2 AS TIPRES,
       0 AS FLGTIP,
       TO_CHAR('CNPJ/CPF tem cheques devolvidos') AS RESTRI,
       CHR.NUMDOC,
       SUM(CHR.VLRCHE) AS DIVIDA,
       COUNT(*) AS OCORRE,
       0 AS LIMITE
  FROM TT_CHR CHR INNER JOIN TT_CLI CLI ON CLI.FILCLI = CHR.FILCLI
                                       AND CLI.CODCLI = CHR.CODCLI
 WHERE CHR.FLGEST = 'V'
   AND CLI.NAODIV = 'F'
 GROUP BY CHR.NUMDOC
;

/*-- SEQ 2872 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RES_003 CASCADE;

/*-- SEQ 2873 --*/
CREATE OR REPLACE VIEW TV_RES_003 AS
SELECT /*+ INDEX(CLI,AK_CLI_NUMDOC) INDEX(VEN,I_LC_VEN_CLI_FLGEST) INDEX(REC,PK_REC) */
       3 AS TIPRES,
       MIN(CLI.FLGTIP) AS FLGTIP,
       TO_CHAR('CLIENTE COM PARCELAS EM ATRASO') AS RESTRI,
       CLI.NUMDOC,
       SUM(REC.VLRPAR) AS DIVIDA,
       COUNT(*) AS OCORRE,
       CASE WHEN CLI.VALLIM IS NOT NULL AND CLI.VALLIM < TRUNC(AGORA()) -- Se limite tem validade e j expirou
            THEN 0
            ELSE CASE WHEN CFG.LIMDIA = 0 THEN CLI.VALOR1
                      ELSE CASE WHEN AGORA() > ADD_DAY(GREATEST(CLI.DATCRE, COALESCE(CLI.ULTCOM, CLI.DATCRE)),  CFG.LIMDIA) THEN 0
                                ELSE COALESCE(CLI.VALOR1,0)
                           END
                 END
        END AS LIMITE
  FROM TT_CLI CLI INNER JOIN TT_VEN VEN ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                  INNER JOIN TT_REC REC ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
                  INNER JOIN TT_CFG CFG ON (COALESCE(CFG.VC_FILCLI,'')||COALESCE(CFG.VC_CODCLI,'')) <> (COALESCE(CLI.FILCLI,'')||COALESCE(CLI.CODCLI,''))
WHERE REC.SEQCHE IS NULL
  AND REC.CARTAO IS NULL
  AND REC.FLGEST = 'A'
  AND TRUNC(AGORA()) > PROXIMODIAUTILBANCO((TRUNC(REC.DATVEN) + CAST(ABS(CFG.CARENCIA_RESTRI) AS INTEGER)))
  AND CLI.CODCLI <> '     0'
  AND VEN.FINANC = 'T'
  AND VEN.flgest = 'A'
  AND CLI.NAODIV = 'F'
GROUP BY CLI.NUMDOC, CFG.LIMDIA, CLI.VALLIM, CLI.VALOR1, CLI.DATCRE, CLI.ULTCOM
;

/*-- SEQ 2874 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RES_004 CASCADE;

/*-- SEQ 2875 --*/
CREATE OR REPLACE VIEW TV_RES_004 AS
SELECT /*+ INDEX(CLI,PK_CLI) INDEX(CHR,I_FK_CHR_CLI) */
       4 AS TIPRES,
       MIN(CLI.FLGTIP) AS FLGTIP,
       TO_CHAR('CHEQUES TERCEIROS DEVOLVIDOS') AS RESTRI,
       CLI.NUMDOC, SUM(CHR.VLRCHE) AS DIVIDA,
       COUNT(*) AS OCORRE,
       CASE WHEN CLI.VALLIM IS NOT NULL AND CLI.VALLIM < TRUNC(AGORA()) -- Se limite tem validade e j expirou
            THEN 0
            ELSE CASE WHEN CFG.LIMDIA = 0 THEN CLI.VALOR1
                      ELSE CASE WHEN AGORA() > ADD_DAY(GREATEST(CLI.DATCRE, COALESCE(CLI.ULTCOM, CLI.DATCRE)),  CFG.LIMDIA) THEN 0
                                ELSE COALESCE(CLI.VALOR1,0)
                            END
                 END
       END AS LIMITE
  FROM TT_CLI CLI INNER JOIN TT_CHR CHR ON CHR.FILCLI = CLI.FILCLI AND CHR.CODCLI = CLI.CODCLI
                  INNER JOIN TT_CFG CFG ON (COALESCE(CLI.FILCLI,'')||COALESCE(CLI.CODCLI,'')) <>
                                           (COALESCE(CFG.VC_FILCLI,'')||COALESCE(CFG.VC_CODCLI,''))
 WHERE CHR.FLGEST = 'V'
   AND CLI.CODCLI <> '   0'
   AND CHR.NUMDOC <> CLI.NUMDOC
   AND CLI.NAODIV = 'F'
 GROUP BY CLI.NUMDOC, CFG.LIMDIA, CLI.VALLIM, CLI.VALOR1, CLI.DATCRE, CLI.ULTCOM
;

/*-- SEQ 2876 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RES_006 CASCADE;

/*-- SEQ 2877 --*/
CREATE OR REPLACE VIEW TV_RES_006 AS
SELECT /*+ INDEX(CLI,AK_CLI_NUMDOC) INDEX(REC,PK_REC) INDEX(CHR,PK_CHR) */
       6 AS TIPRES,
       MIN(CLI.FLGTIP) AS FLGTIP,
       TO_CHAR('Consta no SPC') AS RESTRI,
       CLI.NUMDOC,
       SUM(CASE WHEN SPC.FILREC IS NOT NULL THEN REC.VLRPAR
                                            ELSE CHR.VLRCHE
           END) AS DIVIDA,
       COUNT(*) AS OCORRE,
       CASE WHEN CLI.VALLIM IS NOT NULL AND CLI.VALLIM < TRUNC(AGORA()) -- Se limite tem validade e j expirou
            THEN 0
            ELSE CASE WHEN CFG.LIMDIA = 0 THEN CLI.VALOR1
                      ELSE CASE WHEN AGORA() > ADD_DAY(GREATEST(CLI.DATCRE, COALESCE(CLI.ULTCOM, CLI.DATCRE)),  CFG.LIMDIA) THEN 0
                                ELSE COALESCE(CLI.VALOR1,0)
                            END
                 END
       END AS LIMITE
FROM TT_CLI CLI INNER JOIN      TT_DEV SPC ON SPC.FILCLI = CLI.FILCLI AND
                                              SPC.CODCLI = CLI.CODCLI
                INNER JOIN      TT_CFG CFG ON (COALESCE(CLI.FILCLI,'')||COALESCE(CLI.CODCLI,'')) <>
                                              (COALESCE(CFG.VC_FILCLI,'')||COALESCE(CFG.VC_CODCLI,''))
                LEFT OUTER JOIN TT_REC REC ON REC.CODFIL = SPC.FILREC AND
                                              REC.SEQUEN = SPC.SEQREC AND
                                              REC.NUMPAR = SPC.NUMPAR AND
                                              REC.SUBPAR = REC.SUBPAR
                LEFT OUTER JOIN TT_CHR CHR ON CHR.CODFIL = SPC.FILCHR AND
                                              CHR.SEQUEN = SPC.SEQCHR
 WHERE SPC.REGEXC IS NULL
   AND CLI.NAOSPC <> 'T' 
 GROUP BY CLI.NUMDOC, CFG.LIMDIA, CLI.VALLIM, CLI.VALOR1, CLI.DATCRE, CLI.ULTCOM
;

/*-- SEQ 2878 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RES_005 CASCADE;

/*-- SEQ 2879 --*/
CREATE OR REPLACE VIEW TV_RES_005 AS
SELECT 1 AS TIPRES,
    MIN(CRE.FLGTIP) AS FLGTIP,
    TO_CHAR('LIMITE DE CRDITO (vinculados)') AS RESTRI,
    CRE.NUMDOC,
    SUM(COALESCE(CRE.DIVIDA,0)) AS DIVIDA,
    SUM(COALESCE(CRE.OCORRE,0)) AS OCORRE,
    (SELECT CASE WHEN C.VALLIM IS NOT NULL AND C.VALLIM < TRUNC(AGORA()) -- Se limite tem validade e j expirou
            THEN 0
            ELSE CASE WHEN F.LIMDIA = 0 THEN C.VALOR1
                 ELSE CASE WHEN AGORA() > ADD_DAY(GREATEST(C.DATCRE, COALESCE(C.ULTCOM, C.DATCRE)), F.LIMDIA) THEN 0
                           ELSE COALESCE(C.VALOR1,0)
                       END
                 END
            END AS LIMITE
       FROM TW_VRES W, TT_CLI C, TT_CFG F
      WHERE C.NUMDOC = W.NUMDOC
        AND W.USERID = USERENV( 'SESSIONID' )
        AND W.TIPREG = 'M') AS LIMITE
     FROM (SELECT /*+ INDEX(CLI,AK_CLI_NUMDOC) INDEX(VEN,I_LC_VEN_CLI_FLGEST) INDEX(REC,PK_REC) INDEX(CHR,PK_CHR) */
                  MIN(CLI.FLGTIP) AS FLGTIP,
                  CLI.NUMDOC,
                  SUM(COALESCE(REC.VLRPAR,0)) AS DIVIDA,
                  COUNT(*) AS OCORRE
            FROM TT_CLI CLI LEFT OUTER JOIN TT_VEN VEN ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                            LEFT OUTER JOIN TT_REC REC ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
                            LEFT OUTER JOIN TT_CHR CHR ON REC.FILREC = CHR.CODFIL AND REC.SEQCHE = CHR.SEQUEN
                            INNER JOIN TT_CFG CFG ON (COALESCE(CLI.FILCLI,'')|| COALESCE(CLI.CODCLI,''))<> (COALESCE(CFG.VC_FILCLI,'')||COALESCE(CFG.VC_CODCLI,''))
           WHERE REC.CARTAO IS NULL
             AND VEN.FLGEST = 'A'
             AND (REC.SEQCHE IS NULL OR (REC.SEQCHE IS NOT NULL AND CHR.AUTORI IS NULL))
             AND REC.FLGEST = 'A'
             AND CLI.CODCLI <> '     0'
             AND CLI.NUMDOC IN (SELECT W.NUMDOC FROM TW_VRES W WHERE W.USERID = USERENV( 'SESSIONID' ) )
             AND ( (COALESCE(VEN.FINANC,'T') = 'T') OR VEN.CODSER='CC')
           GROUP BY CLI.NUMDOC
           UNION ALL
           SELECT /*+ INDEX(CLI,AK_CLI_NUMDOC) INDEX(LIM,PK_LIM)*/
                  MIN(CLI.FLGTIP) AS FLGTIP,
                  CLI.NUMDOC,
                  SUM(LIM.VSALDO*-1) AS DIVIDA,
                  0 AS OCORRE
             FROM TT_CLI CLI LEFT OUTER JOIN TT_LIM LIM ON CLI.FILCLI = LIM.FILCLI AND CLI.CODCLI = LIM.CODCLI
            WHERE LIM.VSALDO < 0
              AND CLI.NUMDOC IN (SELECT W.NUMDOC FROM TW_VRES W WHERE W.USERID = USERENV( 'SESSIONID' ) )
            GROUP BY CLI.NUMDOC
    ) CRE
GROUP BY CRE.NUMDOC
UNION ALL
SELECT * FROM TV_RES_002
 WHERE NUMDOC IN (SELECT W.NUMDOC
                    FROM TW_VRES W
                   WHERE W.USERID = USERENV( 'SESSIONID' )
                     AND W.TIPREG <> 'V')
UNION ALL
SELECT * FROM TV_RES_003
 WHERE NUMDOC IN (SELECT W.NUMDOC
                    FROM TW_VRES W
                   WHERE W.USERID = USERENV( 'SESSIONID' )
                     AND W.TIPREG <> 'V')
UNION ALL
SELECT * FROM TV_RES_004
WHERE NUMDOC IN (SELECT W.NUMDOC
                   FROM TW_VRES W
                  WHERE W.USERID = USERENV( 'SESSIONID' )
                    AND W.TIPREG <> 'V')
UNION ALL
SELECT * FROM TV_RES_006
WHERE NUMDOC IN (SELECT W.NUMDOC
                   FROM TW_VRES W
                  WHERE W.USERID = USERENV( 'SESSIONID' )
                    AND W.TIPREG <> 'V')
;

/*-- SEQ 2880 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RES CASCADE;

/*-- SEQ 2881 --*/
CREATE OR REPLACE VIEW TV_RES AS
SELECT * FROM TV_RES_001 UNION ALL
SELECT * FROM TV_RES_002 UNION ALL
SELECT * FROM TV_RES_003 UNION ALL
SELECT * FROM TV_RES_004 UNION ALL
SELECT * FROM TV_RES_006
;

-- Autor: Murilo
-- Finalidade(s):
-- 1) Atender necessidades do Checkout 4G
/*-- SEQ 2882 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RES_001_CK4G CASCADE;

/*-- SEQ 2883 --*/
CREATE OR REPLACE VIEW TV_RES_001_CK4G AS
-- RFMP 76140
-- Views usadas pela TV_CLI_DIV devem mostrar as dvidas.
-- TV_RES e funo DIVIDA passaram a fazer o filtro pela NAODIV.
-- Mudana realizada para que a dvida do cliente aparecesse no histrico de parceiros.
SELECT 1 AS TIPRES,
       CLI.FLGTIP,
       TO_CHAR('LIMITE DE CRDITO') AS RESTRI,
       CLI.NUMDOC, CLI.FILCLI, CLI.CODCLI,
       COALESCE(DIV.DIVIDA, 0) AS DIVIDA,
       COALESCE(DIV.OCORRE, 0) AS OCORRE,
       CASE WHEN CLI.VALLIM IS NOT NULL AND CLI.VALLIM < TRUNC(AGORA()) -- Se limite tem validade e j expirou
            THEN 0
            ELSE CASE WHEN CFG.LIMDIA = 0 THEN CLI.VALOR1
                     ELSE CASE WHEN AGORA() > ADD_DAY(GREATEST(CLI.DATCRE, COALESCE(CLI.ULTCOM, CLI.DATCRE)),  CFG.LIMDIA) THEN 0
                               ELSE COALESCE(CLI.VALOR1,0)
                          END
                 END
       END AS LIMITE
   FROM TT_CLI CLI  LEFT JOIN TV_CLI_DIV DIV ON CLI.FILCLI=DIV.FILCLI
                                            AND CLI.CODCLI=DIV.CODCLI
                                            AND CLI.NAODIV='F'
                   INNER JOIN TT_CFG CFG ON (CFG.VC_FILCLI||CFG.VC_CODCLI) <> (CLI.FILCLI||CLI.CODCLI)
;

/*-- SEQ 2884 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RES_002_CK4G CASCADE;

/*-- SEQ 2885 --*/
CREATE OR REPLACE VIEW TV_RES_002_CK4G AS
SELECT /*+ INDEX(CHR,I_LC_CHR_NUMDOC) */
       2 AS TIPRES,
       0 AS FLGTIP,
       TO_CHAR('CNPJ/CPF tem cheques devolvidos') AS RESTRI,
       CHR.NUMDOC,
       CAST(NULL AS CHAR(3)) AS FILCLI,
       CAST(NULL AS CHAR(6)) AS CODCLI,
       SUM(CHR.VLRCHE) AS DIVIDA,
       COUNT(*) AS OCORRE,
       0 AS LIMITE
  FROM TT_CHR CHR
 WHERE CHR.FLGEST = 'V'
 GROUP BY CHR.NUMDOC
;

/*-- SEQ 2886 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RES_003_CK4G CASCADE;

/*-- SEQ 2887 --*/
CREATE OR REPLACE VIEW TV_RES_003_CK4G AS
SELECT /*+ INDEX(CLI,AK_CLI_NUMDOC) INDEX(VEN,I_LC_VEN_CLI_FLGEST) INDEX(REC,PK_REC) */
       3 AS TIPRES,
       CLI.FLGTIP,
       TO_CHAR('CLIENTE COM PARCELAS EM ATRASO') AS RESTRI,
       CLI.NUMDOC, CLI.FILCLI, CLI.CODCLI,
       REC.VLRPAR AS DIVIDA,
       1 AS OCORRE,
       CASE WHEN CLI.VALLIM IS NOT NULL AND CLI.VALLIM < TRUNC(AGORA()) -- Se limite tem validade e j expirou
            THEN 0
            ELSE CASE WHEN CFG.LIMDIA = 0 THEN CLI.VALOR1
                      ELSE CASE WHEN AGORA() > ADD_DAY(GREATEST(CLI.DATCRE, COALESCE(CLI.ULTCOM, CLI.DATCRE)),  CFG.LIMDIA) THEN 0
                                ELSE COALESCE(CLI.VALOR1,0)
                            END
                 END
       END AS LIMITE
  FROM TT_CLI CLI INNER JOIN TT_VEN VEN ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                  INNER JOIN TT_REC REC ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
                  INNER JOIN TT_CFG CFG ON (CFG.VC_FILCLI||CFG.VC_CODCLI) <> (CLI.FILCLI||CLI.CODCLI)
WHERE REC.SEQCHE IS NULL
  AND REC.CARTAO IS NULL
  AND REC.FLGEST = 'A'
  AND TRUNC(AGORA()) > PROXIMODIAUTILBANCO((TRUNC(REC.DATVEN) + CAST(ABS(CFG.CARENCIA_RESTRI) AS INTEGER)))
  AND CLI.CODCLI <> '     0'
  AND VEN.FINANC = 'T'
  AND VEN.FLGEST = 'A'
  AND CLI.NAODIV = 'F'
;

/*-- SEQ 2888 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RES_004_CK4G CASCADE;

/*-- SEQ 2889 --*/
CREATE OR REPLACE VIEW TV_RES_004_CK4G AS
SELECT /*+ INDEX(CLI,PK_CLI) INDEX(CHR,I_FK_CHR_CLI) */
       4 AS TIPRES,
       CLI.FLGTIP,
       TO_CHAR('CHEQUES TERCEIROS DEVOLVIDOS') AS RESTRI,
       CLI.NUMDOC, CLI.FILCLI, CLI.CODCLI,
       CHR.VLRCHE AS DIVIDA,
       1 AS OCORRE,
       CASE WHEN CLI.VALLIM IS NOT NULL AND CLI.VALLIM < TRUNC(AGORA()) -- Se limite tem validade e j expirou
            THEN 0
            ELSE CASE WHEN CFG.LIMDIA = 0 THEN CLI.VALOR1
                      ELSE CASE WHEN AGORA() > ADD_DAY(GREATEST(CLI.DATCRE, COALESCE(CLI.ULTCOM, CLI.DATCRE)),  CFG.LIMDIA) THEN 0
                                ELSE COALESCE(CLI.VALOR1,0)
                            END
                 END
       END AS LIMITE
  FROM TT_CLI CLI INNER JOIN TT_CHR CHR ON CHR.FILCLI = CLI.FILCLI AND CHR.CODCLI = CLI.CODCLI
                  INNER JOIN TT_CFG CFG ON (CLI.FILCLI||CLI.CODCLI) <> (CFG.VC_FILCLI||CFG.VC_CODCLI)
 WHERE CHR.FLGEST = 'V'
   AND CLI.CODCLI <> '   0'
   AND CLI.NAODIV = 'F'
   AND CHR.NUMDOC <> CLI.NUMDOC
;

/*-- SEQ 2890 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RES_006_CK4G CASCADE;

/*-- SEQ 2891 --*/
CREATE OR REPLACE VIEW TV_RES_006_CK4G AS
SELECT /*+ INDEX(CLI,AK_CLI_NUMDOC) INDEX(REC,PK_REC) INDEX(CHR,PK_CHR) */
       6 AS TIPRES,
       CLI.FLGTIP,
       TO_CHAR('Consta no SPC') AS RESTRI,
       CLI.NUMDOC, CLI.FILCLI, CLI.CODCLI,
       CASE WHEN SPC.FILREC IS NOT NULL THEN REC.VLRPAR
                                        ELSE CHR.VLRCHE
        END AS DIVIDA,
       1 AS OCORRE,
       CASE WHEN CLI.VALLIM IS NOT NULL AND CLI.VALLIM < TRUNC(AGORA()) -- Se limite tem validade e j expirou
            THEN 0
            ELSE CASE WHEN CFG.LIMDIA = 0 THEN CLI.VALOR1
                      ELSE CASE WHEN AGORA() > ADD_DAY(GREATEST(CLI.DATCRE, COALESCE(CLI.ULTCOM, CLI.DATCRE)),  CFG.LIMDIA) THEN 0
                                ELSE COALESCE(CLI.VALOR1,0)
                            END
                 END
       END AS LIMITE
FROM TT_CLI CLI INNER JOIN      TT_DEV SPC ON SPC.FILCLI = CLI.FILCLI AND
                                              SPC.CODCLI = CLI.CODCLI
                INNER JOIN      TT_CFG CFG ON (CLI.FILCLI||CLI.CODCLI) <> (CFG.VC_FILCLI||CFG.VC_CODCLI)
                LEFT OUTER JOIN TT_REC REC ON REC.CODFIL = SPC.FILREC AND
                                              REC.SEQUEN = SPC.SEQREC AND
                                              REC.NUMPAR = SPC.NUMPAR AND
                                              REC.SUBPAR = REC.SUBPAR
                LEFT OUTER JOIN TT_CHR CHR ON CHR.CODFIL = SPC.FILCHR AND
                                              CHR.SEQUEN = SPC.SEQCHR
 WHERE SPC.REGEXC IS NULL
;

/*-- SEQ 2892 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RES_005_CK4G CASCADE;

/*-- SEQ 2893 --*/
CREATE OR REPLACE VIEW TV_RES_005_CK4G AS
SELECT 1 AS TIPRES,
    MIN(CRE.FLGTIP) AS FLGTIP,
    TO_CHAR('LIMITE DE CRDITO (vinculados)') AS RESTRI,
    CRE.NUMDOC, CRE.FILCLI, CRE.CODCLI,
    SUM(COALESCE(CRE.DIVIDA,0)) AS DIVIDA,
    SUM(COALESCE(CRE.OCORRE,0)) AS OCORRE,
    (SELECT CASE WHEN C.VALLIM IS NOT NULL AND C.VALLIM < TRUNC(AGORA()) -- Se limite tem validade e j expirou
            THEN 0
            ELSE CASE WHEN F.LIMDIA = 0 THEN C.VALOR1
                 ELSE CASE WHEN AGORA() > ADD_DAY(GREATEST(C.DATCRE, COALESCE(C.ULTCOM, C.DATCRE)), F.LIMDIA) THEN 0
                           ELSE COALESCE(C.VALOR1,0)
                       END
                 END
            END AS LIMITE
       FROM TW_VRES W, TT_CLI C, TT_CFG F
      WHERE C.NUMDOC = W.NUMDOC
        AND W.USERID = USERENV( 'SESSIONID' )
        AND W.TIPREG = 'M') AS LIMITE
     FROM (SELECT /*+ INDEX(CLI,AK_CLI_NUMDOC) INDEX(VEN,I_LC_VEN_CLI_FLGEST) INDEX(REC,PK_REC) INDEX(CHR,PK_CHR) */
                  MIN(CLI.FLGTIP) AS FLGTIP,
                  CLI.NUMDOC, CLI.FILCLI, CLI.CODCLI,
                  SUM(COALESCE(REC.VLRPAR,0)) AS DIVIDA,
                  COUNT(*) AS OCORRE
            FROM TT_CLI CLI LEFT OUTER JOIN TT_VEN VEN ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                            LEFT OUTER JOIN TT_REC REC ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
                            LEFT OUTER JOIN TT_CHR CHR ON REC.FILREC = CHR.CODFIL AND REC.SEQCHE = CHR.SEQUEN
                            INNER JOIN TT_CFG CFG ON (CLI.FILCLI||CLI.CODCLI) <> (CFG.VC_FILCLI||CFG.VC_CODCLI)
           WHERE REC.CARTAO IS NULL
             AND VEN.FLGEST = 'A'
             AND (REC.SEQCHE IS NULL OR (REC.SEQCHE IS NOT NULL AND CHR.AUTORI IS NULL))
             AND REC.FLGEST = 'A'
             AND CLI.CODCLI <> '     0'
             AND CLI.NUMDOC IN (SELECT W.NUMDOC FROM TW_VRES W WHERE W.USERID = USERENV( 'SESSIONID' ) )
             AND ( (COALESCE(VEN.FINANC,'T') = 'T') OR VEN.CODSER='CC')
           GROUP BY CLI.NUMDOC, CLI.FILCLI, CLI.CODCLI
           UNION ALL
           SELECT /*+ INDEX(CLI,AK_CLI_NUMDOC) INDEX(LIM,PK_LIM)*/
                  MIN(CLI.FLGTIP) AS FLGTIP,
                  CLI.NUMDOC, CLI.FILCLI, CLI.CODCLI,
                  SUM(LIM.VSALDO*-1) AS DIVIDA,
                  0 AS OCORRE
             FROM TT_CLI CLI LEFT OUTER JOIN TT_LIM LIM ON CLI.FILCLI = LIM.FILCLI AND CLI.CODCLI = LIM.CODCLI
            WHERE LIM.VSALDO < 0
              AND CLI.NUMDOC IN (SELECT W.NUMDOC FROM TW_VRES W WHERE W.USERID = USERENV( 'SESSIONID' ) )
            GROUP BY CLI.NUMDOC, CLI.FILCLI, CLI.CODCLI
    ) CRE
GROUP BY CRE.NUMDOC, CRE.FILCLI, CRE.CODCLI
UNION ALL
SELECT * FROM TV_RES_002_CK4G
 WHERE NUMDOC IN (SELECT W.NUMDOC
                    FROM TW_VRES W
                   WHERE W.USERID = USERENV( 'SESSIONID' )
                     AND W.TIPREG <> 'V')
UNION ALL
SELECT * FROM TV_RES_003_CK4G
 WHERE NUMDOC IN (SELECT W.NUMDOC
                    FROM TW_VRES W
                   WHERE W.USERID = USERENV( 'SESSIONID' )
                     AND W.TIPREG <> 'V')
UNION ALL
SELECT * FROM TV_RES_004_CK4G
WHERE NUMDOC IN (SELECT W.NUMDOC
                   FROM TW_VRES W
                  WHERE W.USERID = USERENV( 'SESSIONID' )
                    AND W.TIPREG <> 'V')
UNION ALL
SELECT * FROM TV_RES_006_CK4G
WHERE NUMDOC IN (SELECT W.NUMDOC
                   FROM TW_VRES W
                  WHERE W.USERID = USERENV( 'SESSIONID' )
                    AND W.TIPREG <> 'V')
;

/*-- SEQ 2894 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RES_CK4G CASCADE;

/*-- SEQ 2895 --*/
CREATE OR REPLACE VIEW TV_RES_CK4G AS
SELECT TIPRES AS TIPRES,
       MIN(FLGTIP) AS FLGTIP,
       MIN(RESTRI) AS RESTRI,
       RES.NUMDOC,
       SUM(DIVIDA) AS DIVIDA,
       SUM(OCORRE) AS OCORRE,
       MIN(LIMITE) AS LIMITE
FROM (SELECT * FROM TV_RES_001_CK4G UNION ALL
      SELECT * FROM TV_RES_002_CK4G UNION ALL
      SELECT * FROM TV_RES_003_CK4G UNION ALL
      SELECT * FROM TV_RES_004_CK4G UNION ALL
      SELECT * FROM TV_RES_006_CK4G) RES
GROUP BY NUMDOC, TIPRES
;



/*-- SEQ 2896 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RFIN_CCC CASCADE;

/*-- SEQ 2897 --*/
CREATE OR REPLACE VIEW TV_RFIN_CCC AS
SELECT CAST('CCC' AS VARCHAR(3)) AS ORIGEM,
       CAST('--' AS CHAR(2))      AS NUMPAR,
       CAST('--' AS CHAR(2))      AS SUBPAR,
       FILCTA, SEQCTA, TIPCTA, CODCTA, ORICTA,
       FILCRT, SEQCRT, TIPCRT, CODCRT, ORICRT,
       CODFIL, SEQUEN, DATLAN, TIPLAN,
       VLRLAN, FILCLI, CODCLI, FLGFLX, VLRCRT,
       CODFIL AS FILORI,
       CODFIL AS FILDES,
       FILUSU,
       CODUSU,
       ATU_EM, DATINC AS DATINCORI
FROM (-- DE "CCC" PARA "FATURAMENTO"
      SELECT TAB.CODFIL, TAB.SEQUEN, TAB.FILCLI, TAB.CODCLI,
             CAST('R' AS VARCHAR(1))   AS FLGFLX,
             TAB.DATLAN,
             NVLZ(TAB.SOMA_LAN, TAB.VLRLAN) * -1 AS VLRLAN,
             NVLZ(TAB.SOMA_LAN, TAB.VLRLAN) * -1 AS VLRCRT,
             TAB.FILCTA, 
             TAB.SEQCTA, 
             TAB.TIPCTA, 
             TAB.CODCTA,
             CAST('CCC' AS VARCHAR(3)) AS ORICTA,
             TAB.FILCRT,
             TAB.SEQCRT,
             TAB.TIPCRT,
             TAB.CODCRT,
             CAST('CTR' AS VARCHAR(3)) AS ORICRT,
             CAST('FAT' AS VARCHAR(3)) AS TIPLAN,
             TAB.FILUSU,
             TAB.CODUSU,
             TAB.ATU_EM,
             TAB.DATINC
        FROM 
      (SELECT CCC.CODFIL, CCC.SEQUEN, CCC.FILCLI, CCC.CODCLI, 
             COALESCE(CCC.DATFIS,CCC.DATOPE) AS DATLAN,
             CCC.VLRLAN,
             DCCC.FILCCC AS FILCTA,
             DCCC.SEQCCC AS SEQCTA,
             DCCC.TIPCCC AS TIPCTA,
             DCCC.CODTAB AS CODCTA,
             DCTR.CTRFIL AS FILCRT,
             DCTR.CTRSEQ AS SEQCRT,
             DCTR.CTRTIP AS TIPCRT,
             DCTR.CODTAB AS CODCRT,
             CCC.FILUSU,
             CCC.CODUSU,
             CCC.DATOPE AS ATU_EM,
             CCC.DATINC,
             CASE WHEN CCC.FILFAT IS NULL THEN 0
                                          ELSE COALESCE( ( SELECT SUM(CCC2.VLRLAN) 
                                                             FROM TT_CCC CCC2
                                                            WHERE CCC2.FILFAT = CCC.FILFAT
                                                              AND CCC2.SEQFAT = CCC.SEQFAT
                                                              AND CCC2.STATUS = 'F' -- FATURAMENTOS
                                                          ), 0) -- COALESCE
                                          END AS SOMA_LAN
      FROM TT_CCC CCC LEFT  JOIN TD_CCC DCCC ON DCCC.CODTAB = CCC.TIPCCC
                      LEFT  JOIN TT_VEN FAT  ON  FAT.CODFIL = CCC.CODFIL
                                            AND (FAT.CODSER = 'CC' OR CCC.SEQFAT = FAT.SEQUEN)
                                            AND  FAT.NUMECF = '000'
                                            AND  FAT.NUMNOT = CASE WHEN SUBSTR(CCC.NUMDOC,1,2)='CC'
                                                                   THEN SUBSTR(CCC.NUMDOC,3,6)
                                                                   ELSE SUBSTR(CCC.NUMDOC,1,6)
                                                              END
                      LEFT  JOIN TD_CTR DCTR ON DCTR.CODTAB = FAT.CODCTR
      WHERE CCC.STATUS = 'F'
        AND COALESCE(FAT.FLGEST,'X') <> 'C'
      ) TAB
      UNION ALL
      -- DE "CCC" PARA "DESCONTOS"
      SELECT TAB.CODFIL, TAB.SEQUEN, TAB.FILCLI, TAB.CODCLI,
             CAST('R' AS VARCHAR(1))   AS FLGFLX,
             TAB.DATLAN,
             TAB.VLRLAN,
             TAB.VLRNOT - TAB.VLRLIQ AS VLRCRT,
             TAB.FILCTA,
             TAB.SEQCTA,
             TAB.TIPCTA,
             TAB.CODCTA,
             CAST('CTR' AS VARCHAR(3)) AS ORICTA,
             TAB.FILCRT,
             TAB.SEQCRT,
             TAB.TIPCRT,
             TAB.CODCRT,
             CAST('CTA' AS VARCHAR(3)) AS ORICRT,
             CAST('DES' AS VARCHAR(3)) AS TIPLAN,
             TAB.FILUSU,
             TAB.CODUSU,
             TAB.ATU_EM,
             TAB.DATINC
        FROM 
      (
         SELECT CCC.CODFIL, CCC.SEQUEN, CCC.FILCLI, CCC.CODCLI,
                COALESCE(CCC.DATFIS,CCC.DATOPE) AS DATLAN,
                FAT.VLRNOT-FAT.VLRLIQ AS VLRLAN,
                FAT.VLRLIQ,
                DCTR.CTRFIL AS FILCTA,
                DCTR.CTRSEQ AS SEQCTA,
                DCTR.CTRTIP AS TIPCTA,
                DCTR.CODTAB AS CODCTA,
                DCTA.FILCTA AS FILCRT,
                DCTA.SEQCTA AS SEQCRT,
                DCTA.TIPCTA AS TIPCRT,
                DCTA.CODTAB AS CODCRT,
                CCC.FILUSU, CCC.CODUSU,
                CCC.DATOPE AS ATU_EM,
                CCC.DATINC,
                -- MN - No select de cima  obtido a soma porque  aplicado somente o *-1, mas aqui,  feito o valor da fatura - valor lquido pra obter o desconto
                -- Por isso, nesse subselect,  projetado o valor da fatura, FAT.VLRNOT ou a SOMA das TT_CCC, porque quando  produto + servio, so 2 notas, deve-se som-las para 
                -- se obter o total daquela fatura
                CASE WHEN CCC.FILFAT IS NULL THEN FAT.VLRNOT
                                             ELSE COALESCE( ( SELECT SUM(CCC2.VLRLAN) 
                                                                FROM TT_CCC CCC2
                                                               WHERE CCC2.FILFAT = CCC.FILFAT
                                                                 AND CCC2.SEQFAT = CCC.SEQFAT
                                                                 AND CCC2.STATUS = 'F' -- FATURAMENTOS
                                                             ), 0) -- COALESCE
                                             END AS VLRNOT
           FROM TT_CCC CCC INNER JOIN TT_VEN FAT ON FAT.CODFIL = CCC.CODFIL
                                                AND FAT.CODSER = 'CC'  AND FAT.NUMECF = '000'
                                  AND FAT.NUMNOT = CASE WHEN SUBSTR(CCC.NUMDOC,1,2)='CC'
                                                                      THEN SUBSTR(CCC.NUMDOC,3,6)
                                                                      ELSE SUBSTR(CCC.NUMDOC,1,6)
                                                                 END
                           INNER JOIN TD_CTR DCTR ON DCTR.CODTAB = FAT.CODCTR
                            LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL = CASE WHEN FAT.VLRLIQ-FAT.VLRNOT < 0
                                                                        THEN 'TIPCTA_DES_CON'
                                                                        ELSE 'TIPCTA_JUR_REC'
                                                                   END
         WHERE CCC.STATUS = 'F'
           AND FAT.FLGEST <> 'C'
           AND FAT.VLRLIQ-FAT.VLRNOT <> 0
      ) TAB
      UNION ALL
      -- DO PORTADOR ORIGINAL PARA "CCC". VALOR ORIGINAL
      SELECT CCC.CODFIL, CCC.SEQUEN, CCC.FILCLI, CCC.CODCLI,
             CAST('R' AS VARCHAR(1))   AS FLGFLX,
             COALESCE(CCC.DATFIS,CCC.DATOPE) AS DATLAN, 
             COALESCE(CCC.VLRORI,CCC.VLRLAN) *
               CASE WHEN CCC.FILCMS IS NOT NULL THEN -1
                    ELSE 1
               END AS VLRLAN,
             (CCC.VLRLAN + COALESCE((SELECT SUM(FIN.VLRMOV)
                                       FROM TT_FIN FIN
                                      WHERE FIN.FILCCC = CCC.CODFIL
                                        AND FIN.SEQCCC = CCC.SEQUEN
                                        AND FIN.SEQTRN IS NULL),0)) *
               CASE WHEN CCC.FILCMS IS NOT NULL THEN -1
                    ELSE 1
               END AS VLRCRT,
             CASE WHEN CCC.CONTRA IS NOT NULL THEN DCTA.FILCTA
                  WHEN CCC.FILDOP IS NOT NULL THEN DCTAC.FILCTA
                  WHEN CCC.FILRAT IS NOT NULL THEN COALESCE(UCLI.FILGER,DRAT.FILCTA)
                  WHEN CCC.FILCMS IS NOT NULL THEN DCOM.FILCTA
                  ELSE DCOB.FILCTA 
             END AS FILCTA, 
             CASE WHEN CCC.CONTRA IS NOT NULL THEN DCTA.SEQCTA 
                  WHEN CCC.FILDOP IS NOT NULL THEN DCTAC.SEQCTA
                  WHEN CCC.FILRAT IS NOT NULL THEN COALESCE(UCLI.SEQGER,DRAT.SEQCTA)
                  WHEN CCC.FILCMS IS NOT NULL THEN DCOM.SEQCTA
                  ELSE DCOB.SEQCTA 
             END AS SEQCTA, 
             CASE WHEN CCC.CONTRA IS NOT NULL THEN DCTA.TIPCTA 
                  WHEN CCC.FILDOP IS NOT NULL THEN DCTAC.TIPCTA
                  WHEN CCC.FILRAT IS NOT NULL THEN COALESCE(UCLI.TIPGER,DRAT.TIPCTA)
                  WHEN CCC.FILCMS IS NOT NULL THEN DCOM.TIPCTA
                  ELSE DCOB.TIPCTA 
             END AS TIPCTA, 
             DCOB.CODTAB                AS CODCTA,
             CAST('COB' AS VARCHAR(3)) AS ORICTA,
             DCCC.FILCCC                AS FILCRT,
             DCCC.SEQCCC                AS SEQCRT,
             DCCC.TIPCCC                AS TIPCRT,
             DCCC.CODTAB                AS CODCRT,
             CAST('CCC' AS VARCHAR(3)) AS ORICRT,
             CAST('CCC' AS VARCHAR(3)) AS TIPLAN,
             CCC.FILUSU,
             CCC.CODUSU,
             CCC.DATOPE AS ATU_EM,
             CCC.DATINC
      FROM TT_CCC CCC INNER JOIN TT_CLI CLI ON CLI.FILCLI=CCC.FILCLI AND CLI.CODCLI=CCC.CODCLI
                      LEFT JOIN TD_COB DCOB ON DCOB.CODTAB  = CCC.PORORI
                      LEFT JOIN TD_CCC DCCC ON DCCC.CODTAB  = CCC.TIPCCC
                      LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL  = 'CONTRATO'
                      LEFT JOIN TD_CTA DCTAC ON DCTAC.CFGCOL= 'CHEQUE_FORNEC'
                      LEFT JOIN TD_CTA DRAT ON DRAT.CFGCOL  = 'RAT'
                      LEFT JOIN TD_CTA DCOM ON DCOM.CFGCOL  = 'COMISSAO'
                      LEFT JOIN TT_USU UCLI ON UCLI.FILCLI=CLI.FILCLI AND UCLI.CODCLI=CLI.CODCLI
      WHERE CCC.STATUS <> 'F') tab
;
            


/*-- SEQ 2898 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RFIN_CHR CASCADE;

/*-- SEQ 2899 --*/
CREATE OR REPLACE VIEW TV_RFIN_CHR AS
SELECT CAST('CHR' AS VARCHAR(3)) AS ORIGEM,
       CAST('--' AS CHAR(2))      AS NUMPAR,
       CAST('--' AS CHAR(2))      AS SUBPAR,
       FILCTA, SEQCTA, TIPCTA, CODCTA, ORICTA,
       FILCRT, SEQCRT, TIPCRT, CODCRT, ORICRT,
       CODFIL, SEQUEN, DATLAN, TIPLAN,
       VLRLAN, FILCLI, CODCLI, FLGFLX, VLRCRT,
       CODFIL AS FILORI,
       FILLAN AS FILDES,
       FILUSU,
       CODUSU,
       ATU_EM, DATINC AS DATINCORI
FROM (-- Do portador original para "CHEQUES". Valor Original
      SELECT CHR.CODFIL, CHR.SEQUEN, CHR.FILCLI, CHR.CODCLI,
             CAST('R' AS VARCHAR(1))   AS FLGFLX,
             COALESCE(CHR.DATFIS,CHR.DATOPE) AS DATLAN,
             COALESCE(CHR.VLRORI,CHR.VLRCHE)*-1 AS VLRLAN,
             CHR.CODFIL                 AS FILLAN,
             DCOB.FILCTA                AS FILCTA,
             DCOB.SEQCTA                AS SEQCTA,
             DCOB.TIPCTA                AS TIPCTA,
             DCOB.CODTAB                AS CODCTA,
             CAST('CTA' AS VARCHAR(3)) AS ORICTA,
             DCRT.FILCTA                AS FILCRT,
             DCRT.SEQCTA                AS SEQCRT,
             DCRT.TIPCTA                AS TIPCRT,
             DCRT.CODTAB                AS CODCRT,             
             CAST('COB' AS VARCHAR(3)) AS ORICRT,
             COALESCE(CHR.VLRORI,CHR.VLRCHE)*-1 AS VLRCRT,
             CAST('CHR' AS VARCHAR(3)) AS TIPLAN,
             CHR.FILUSU,
             CHR.CODUSU,
             CHR.ATU_EM,
             CHR.DATINC
      FROM TT_CHR CHR INNER JOIN TD_COB DCOB ON DCOB.CODTAB = CHR.PORORI
                      LEFT  JOIN TD_CTA DCRT ON DCRT.CFGCOL = 'CHEQUES DE CLIENTES'
      WHERE CHR.FLGEST <> 'X' -- Ignora cheques X
      UNION ALL
      -- De cheque maior para "CHEQUES". Valor de cada parcela paga.
      SELECT CHR.CODFIL, CHR.SEQUEN, CHR.FILCLI, CHR.CODCLI,
             CAST('R' AS VARCHAR(1))   AS FLGFLX,
             COALESCE(CHR.DATFIS,CHR.DATOPE) AS DATLAN,
             COALESCE(CHR.VLRORI,CHR.VLRCHE) - REC.VLRPAR AS VLRLAN,
             CHR.CODFIL                 AS FILLAN,
             DCRT.FILCTA                AS FILCTA,
             DCRT.SEQCTA                AS SEQCTA,
             DCRT.TIPCTA                AS TIPCTA,
             DCRT.CODTAB                AS CODCTA,
             CAST('CTA' AS VARCHAR(3)) AS ORICTA,
             DCOB.FILCTA                AS FILCRT,
             DCOB.SEQCTA                AS SEQCRT,
             DCOB.TIPCTA                AS TIPCRT,
             DCOB.CODTAB                AS CODCRT,
             CAST('COB' AS VARCHAR(3)) AS ORICRT,
             COALESCE(CHR.VLRORI,CHR.VLRCHE) - REC.VLRPAR AS VLRCRT,
             CAST('MAI' AS VARCHAR(3)) AS TIPLAN,
             CHR.FILUSU,
             CHR.CODUSU,
             CHR.ATU_EM,
             CHR.DATINC
      FROM TT_CHR CHR INNER JOIN TD_COB DCOB ON DCOB.CODTAB = CHR.PORORI
                      INNER JOIN TT_REC REC  ON REC.FILREC = CHR.CODFIL AND REC.SEQCHE = CHR.SEQUEN
                      LEFT  JOIN TD_CTA DCRT ON DCRT.CFGCOL = 'CHEQUE_MAIOR'
      WHERE CHR.FLGEST <> 'X' -- Ignora cheques X
        AND REC.FLGEST = 'P'
      UNION ALL
      -- Retirada para Sangria de "CHEQUES". Valor de cada parcela paga.
      SELECT CHR.CODFIL, CHR.SEQUEN, CHR.FILCLI, CHR.CODCLI,
             CAST('R' AS VARCHAR(1))   AS FLGFLX,
             COALESCE(CHR.DATFIS,CHR.DATOPE) AS DATLAN,
             (COALESCE(CHR.VLRORI,CHR.VLRCHE) - REC.VLRPAR)*-1 AS VLRLAN,
             CHR.CODFIL                 AS FILLAN,
             DCRT.FILCTA                AS FILCTA,
             DCRT.SEQCTA                AS SEQCTA,
             DCRT.TIPCTA                AS TIPCTA,
             DCRT.CODTAB                AS CODCTA,
             CAST('CTA' AS VARCHAR(3)) AS ORICTA,
             DCOB.FILCTA                AS FILCRT,
             DCOB.SEQCTA                AS SEQCRT,
             DCOB.TIPCTA                AS TIPCRT,
             DCOB.CODTAB                AS CODCRT,
             CAST('COB' AS VARCHAR(3)) AS ORICRT,
             (COALESCE(CHR.VLRORI,CHR.VLRCHE) - REC.VLRPAR)*-1 AS VLRCRT,
             CAST('SAN' AS VARCHAR(3)) AS TIPLAN,
             CHR.FILUSU,
             CHR.CODUSU,
             CHR.ATU_EM,
             CHR.DATINC
      FROM TT_CHR CHR INNER JOIN TD_COB DCOB ON DCOB.CODTAB = CHR.PORORI
                      INNER JOIN TT_REC REC  ON REC.FILREC = CHR.CODFIL AND REC.SEQCHE = CHR.SEQUEN
                      LEFT  JOIN TD_CTA DCRT ON DCRT.CFGCOL = 'SANG_CHEQUE_MAIOR'
      WHERE CHR.FLGEST <> 'X' -- Ignora cheques X
        AND REC.FLGEST = 'P'
      UNION ALL
      -- De "CHEQUES" para o portador atual. Valor atual do cheque, menos taxa de pr-desconto
      SELECT CHR.CODFIL, CHR.SEQUEN, CHR.FILCLI, CHR.CODCLI,
             CASE WHEN CHR.FLGEST IN ('B','C','I','S','V') THEN CAST('R' AS VARCHAR(1))          ELSE CAST('A' AS VARCHAR(1)) END AS FLGFLX,
             CASE WHEN CHR.FLGEST IN ('B','C','I','S') THEN CHR.PAGAME 
                  WHEN CHR.FLGEST = 'V'                THEN CHR.DATOPE
                  ELSE CHR.DATVEN
             END AS DATLAN,
             (CHR.VLRCHE-COALESCE(CHR.VLRDIF,0))*-1 AS VLRLAN,
             CHR.CODFIL                 AS FILLAN,
             DCTA.FILCTA                AS FILCTA,
             DCTA.SEQCTA                AS SEQCTA,
             DCTA.TIPCTA                AS TIPCTA,
             DCTA.CODTAB                AS CODCTA,
             CAST('CTA' AS VARCHAR(3)) AS ORICTA,
             CASE WHEN CHR.FLGEST = 'I' THEN DPER.FILCTA 
                  WHEN CHR.FLGEST = 'V' THEN DDEV.FILCTA
             ELSE DCOB.FILCTA END AS FILCRT,
             CASE WHEN CHR.FLGEST = 'I' THEN DPER.SEQCTA 
                  WHEN CHR.FLGEST = 'V' THEN DDEV.SEQCTA
             ELSE DCOB.SEQCTA END AS SEQCRT,
             CASE WHEN CHR.FLGEST = 'I' THEN DPER.TIPCTA 
                  WHEN CHR.FLGEST = 'V' THEN DDEV.TIPCTA
             ELSE DCOB.TIPCTA END AS TIPCRT,
             CASE WHEN CHR.FLGEST = 'I' THEN DPER.CODTAB 
                  WHEN CHR.FLGEST = 'V' THEN DDEV.CODTAB
             ELSE DCOB.CODTAB END AS CODCRT,
             CAST(CASE WHEN CHR.FLGEST = 'I' THEN 'PER' 
                       WHEN CHR.FLGEST = 'V' THEN 'DEV'
                  ELSE 'COB' END AS VARCHAR(3)) AS ORICRT,
             CASE WHEN VLRORI IS NOT NULL
                   AND VLRORI<>VLRCHE
                   AND coalesce((select sum(fin.vlrmov)
                                   from tt_fin fin
                                  where fin.filchr = chr.codfil
                                    and fin.seqchr = chr.sequen
                                    and fin.seqtrn is null),0)=0 THEN
                   (CHR.VLRCHE-COALESCE(CHR.VLRDIF,0))*-1
              ELSE
                 (coalesce((select sum(fin.vlrmov*CASE FIN.TIPGER WHEN 'M' THEN 1 ELSE -1 END)
                              from tt_fin fin
                             where fin.filchr = chr.codfil
                               and fin.seqchr = chr.sequen
                               and fin.seqtrn is null),0) +
                    COALESCE(CHR.VLRORI,CHR.VLRCHE) -
                    COALESCE(CHR.VLRDIF,0) )*-1
              END as vlrcrt,
             CAST('CHR' AS VARCHAR(3)) AS TIPLAN,
             CHR.FILUSU,
             CHR.CODUSU,
             CHR.ATU_EM,
             CHR.DATINC
      FROM TT_CHR CHR INNER JOIN TD_COB DCOB ON DCOB.CODTAB = CHR.PORTAD
                      LEFT  JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'CHEQUES DE CLIENTES'
                      LEFT  JOIN TD_CTA DPER ON DPER.CFGCOL = 'CHEQUES_PERDIDOS'
                      LEFT  JOIN TD_CTA DDEV ON DDEV.CFGCOL = 'CHEQUES_DEVOLVIDOS'
      WHERE CHR.FLGEST <> 'X' -- Ignora cheques X
        AND	CHR.FLGEST <> 'S' -- e substituidos
      UNION ALL
      -- De "CHEQUES" para diferencas - Lanamento informal, de registros passados
      SELECT CHR.CODFIL, CHR.SEQUEN, CHR.FILCLI, CHR.CODCLI,
             CAST('R' AS VARCHAR(1))   AS FLGFLX,
             COALESCE(CHR.DATFIS,CHR.DATOPE) AS DATLAN,
             CHR.VLRCHE - CHR.VLRORI    AS VLRLAN,
             CHR.CODFIL                 AS FILLAN,
             DCTA.FILCTA                AS FILCTA,
             DCTA.SEQCTA                AS SEQCTA,
             DCTA.TIPCTA                AS TIPCTA,
             DCTA.CODTAB                AS CODCTA,
             CAST('CTA' AS VARCHAR(3)) AS ORICTA,
             DTAX.FILCTA                AS FILCRT,
             DTAX.SEQCTA                AS SEQCRT,
             DTAX.TIPCTA                AS TIPCRT,
             DTAX.CODTAB                AS CODCRT,
             CAST('CTA' AS VARCHAR(3)) AS ORICRT,
             CHR.VLRCHE - CHR.VLRORI    AS VLRCRT,
             CAST('DIF' AS VARCHAR(3)) AS TIPLAN,
             CHR.FILUSU,
             CHR.CODUSU,
             CHR.ATU_EM,
             CHR.DATINC
      FROM TT_CHR CHR LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'CHEQUES DE CLIENTES'
                      LEFT JOIN TD_CTA DTAX ON DTAX.CFGCOL = 'TIPCTA_TAX_PRE'
      WHERE COALESCE(CHR.FILDIF,'F') = 'T'
        AND COALESCE(CHR.VLRORI,0) <> CHR.VLRCHE
        AND CHR.FLGEST <> 'X' -- Ignora cheques estornados
      UNION ALL
      -- De "CHEQUES" para taxa de pr-desconto
      SELECT CHR.CODFIL, CHR.SEQUEN, CHR.FILCLI, CHR.CODCLI,
             CAST('R' AS VARCHAR(1))   AS FLGFLX,
             COALESCE(CHR.DATFIS,CHR.DATOPE) AS DATLAN,
             CHR.VLRDIF*-1              AS VLRLAN,
             CHR.CODFIL                 AS FILLAN,
             DCTA.FILCTA                AS FILCTA,
             DCTA.SEQCTA                AS SEQCTA,
             DCTA.TIPCTA                AS TIPCTA,
             DCTA.CODTAB                AS CODCTA,
             CAST('CTA' AS VARCHAR(3)) AS ORICTA,
             DTAX.FILCTA                AS FILCRT,
             DTAX.SEQCTA                AS SEQCRT,
             DTAX.TIPCTA                AS TIPCRT,
             DTAX.CODTAB                AS CODCRT,
             CAST('CTA' AS VARCHAR(3)) AS ORICRT,
             CHR.VLRDIF*-1              AS VLRCRT,
             CAST('DIF' AS VARCHAR(3)) AS TIPLAN,
             CHR.FILUSU,
             CHR.CODUSU,
             CHR.ATU_EM,
             CHR.DATINC
      FROM TT_CHR CHR LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'CHEQUES DE CLIENTES'
                      LEFT JOIN TD_CTA DTAX ON DTAX.CFGCOL = 'TIPCTA_TAX_PRE'
      WHERE CHR.VLRDIF <> 0
        AND CHR.FLGEST <> 'X' -- Ignora cheques estornados
 UNION ALL
      -- De "CHEQUES" para diferencas - Lanamento formal
      SELECT CHR.CODFIL, CHR.SEQUEN,
             CHR.FILCLI, CHR.CODCLI,
             CAST('R' AS VARCHAR(1))   AS FLGFLX,
             COALESCE(DES.DATFIS,DES.DATOPE) AS DATLAN,
             DES.VLRMOV*CASE WHEN ORI.CODFIL IS NULL THEN -1 ELSE 1 END AS VLRLAN,
             DES.CODFIL    AS FILLAN,
             CTA.FILCTA,
             CTA.SEQCTA,
             CTA.TIPCTA,
             CTA.CODTAB    AS CODCTA,
             CAST('CTA' AS VARCHAR(3)) AS ORICTA,
             ORI.FILNUM AS FILCRT,
             ORI.SEQNUM AS SEQCRT,
             ORI.TIPNUM AS TIPCRT,
             CAST(0 AS Numeric(5))       AS CODCRT,
             CAST('FIN' AS VARCHAR(3)) AS ORICRT,
             DES.VLRMOV*CASE WHEN ORI.CODFIL IS NULL THEN -1 ELSE 1 END AS VLRCRT,
             CAST('DIF' AS VARCHAR(3)) AS TIPLAN,
             CHR.FILUSU,
             CHR.CODUSU,
             CHR.ATU_EM,
             CHR.DATINC
      FROM TT_CHR CHR LEFT  JOIN TD_CTA CTA ON CTA.CFGCOL = 'CHEQUES DE CLIENTES'
                      INNER JOIN TT_FIN DES ON DES.FILCHR = CHR.CODFIL
                                           AND DES.SEQCHR = CHR.SEQUEN
                      LEFT  JOIN TT_FIN ORI ON DES.CODFIL = ORI.CODFIL
                                           AND DES.SEQUEN = ORI.SEQTRN
      WHERE COALESCE(CHR.FILDIF,'F') = 'F'
        AND DES.SEQTRN IS NULL
        AND CHR.FLGEST <> 'X' -- Ignora cheques estornados
      UNION ALL
      -- Entrada de troca de cheque
      SELECT CHR.CODFIL, CHR.SEQUEN, CHR.FILCLI, CHR.CODCLI,
             CAST('R' AS VARCHAR(1))   AS FLGFLX,
             COALESCE(CHR.DATFIS,CHR.DATOPE) AS DATLAN,
             COALESCE(CHR.VLRORI,CHR.VLRCHE) AS VLRLAN,
             CHR.CODFIL                 AS FILLAN,
             CAI.FILCAI                 AS FILCTA,
             CAI.SEQCAI                 AS SEQCTA,
             CAI.TIPCAI                 AS TIPCTA,
             CAI.CODTAB                 AS CODCTA,
             CAST('CAI' AS VARCHAR(3)) AS ORICTA,
             DCOB.FILCTA                AS FILCRT,
             DCOB.SEQCTA                AS SEQCRT,
             DCOB.TIPCTA                AS TIPCRT,
             DCOB.CODTAB                AS CODCRT,
             CAST('COB' AS VARCHAR(3)) AS ORICRT,
             COALESCE(CHR.VLRORI,CHR.VLRCHE) AS VLRCRT,
             CAST('TRO' AS VARCHAR(3)) AS TIPLAN,
             CHR.FILUSU,
             CHR.CODUSU,
             CHR.ATU_EM,
             CHR.DATINC
      FROM TT_CHR CHR INNER JOIN TD_COB DCOB ON DCOB.CODTAB = CHR.PORORI
                      CROSS JOIN TD_CAI CAI
                      LEFT JOIN TT_REC REC ON REC.FILREC=CHR.CODFIL AND REC.SEQCHE=CHR.SEQUEN
      WHERE CHR.FLGEST <> 'X' -- Ignora cheques X
        AND CAI.CODTAB=0
        AND REC.CODFIL IS NULL
        AND (SELECT COUNT(*)
               FROM TT_OPE OCHR INNER JOIN TT_OPE OPE ON OCHR.CODFIL=OPE.CODFIL AND OCHR.NUMECF=OPE.NUMECF AND OCHR.TRN_ID=OPE.TRN_ID
                                INNER JOIN TT_FIN FIN ON FIN.CODFIL=OPE.FILFIN AND FIN.SEQUEN=OPE.SEQFIN
                                LEFT  JOIN TD_CTA DCTA ON DCTA.FILCTA=FIN.FILGER AND DCTA.SEQCTA=FIN.SEQGER AND DCTA.CFGCOL='TAXA_TRO_CHEQUE'
               WHERE OCHR.FILCHR=CHR.CODFIL
                 AND OCHR.SEQCHR=CHR.SEQUEN
                 AND DCTA.CODTAB IS NULL
                 AND OPE.SEQFIN IS NOT NULL
                 AND OPE.CODCAI IS NOT NULL
             )>0
      UNION ALL
      -- Sada de troca de cheque
      SELECT CHR.CODFIL, CHR.SEQUEN, CHR.FILCLI, CHR.CODCLI,
             CAST('R' AS VARCHAR(1))   AS FLGFLX,
             COALESCE(CHR.DATFIS,CHR.DATOPE) AS DATLAN,
             MTOM(FIN.CODMOE,0,COALESCE(CHR.DATFIS,CHR.DATOPE),FIN.VLRMOV) AS VLRLAN,
             CHR.CODFIL                 AS FILLAN,
             CAI.FILCAI                 AS FILCTA,
             CAI.SEQCAI                 AS SEQCTA,
             CAI.TIPCAI                 AS TIPCTA,
             CAI.CODTAB                 AS CODCTA,
             CAST('CAI' AS VARCHAR(3)) AS ORICTA,
             DCOB.FILCTA                AS FILCRT,
             DCOB.SEQCTA                AS SEQCRT,
             DCOB.TIPCTA                AS TIPCRT,
             DCOB.CODTAB                AS CODCRT,
             CAST('COB' AS VARCHAR(3)) AS ORICRT,
             MTOM(FIN.CODMOE,0,COALESCE(CHR.DATFIS,CHR.DATOPE),FIN.VLRMOV) AS VLRLAN,
             CAST('TRO' AS VARCHAR(3)) AS TIPLAN,
             CHR.FILUSU,
             CHR.CODUSU,
             CHR.ATU_EM,
             CHR.DATINC
      FROM TT_CHR CHR INNER JOIN TD_COB DCOB ON DCOB.CODTAB = CHR.PORORI
                      CROSS JOIN TD_CAI CAI
                      INNER JOIN TT_OPE OCHR ON OCHR.FILCHR=CHR.CODFIL AND OCHR.SEQCHR=CHR.SEQUEN and OCHR.VLROPE>0
                      INNER JOIN TT_OPE OPE ON OCHR.CODFIL=OPE.CODFIL AND OCHR.NUMECF=OPE.NUMECF AND OCHR.TRN_ID=OPE.TRN_ID
                      INNER JOIN TT_FIN FIN ON FIN.CODFIL=OPE.FILFIN AND FIN.SEQUEN=OPE.SEQFIN
                       LEFT JOIN TT_REC REC ON REC.FILREC=CHR.CODFIL AND REC.SEQCHE=CHR.SEQUEN
                       LEFT  JOIN TD_CTA DCTA ON DCTA.FILCTA=FIN.FILGER AND DCTA.SEQCTA=FIN.SEQGER AND DCTA.CFGCOL='TAXA_TRO_CHEQUE'
      WHERE CHR.FLGEST <> 'X' -- Ignora cheques X
        AND CAI.CODTAB=0
        AND REC.CODFIL IS NULL
        AND DCTA.CODTAB IS NULL
        AND OPE.SEQFIN IS NOT NULL
        AND OPE.CODCAI IS NOT NULL
/* RFMP 87268
Esse tipo de lanamento foi criado na tarefa 86320 e comeou a gerar inconsistncias financeiras no PSC.
      UNION ALL
      -- Entrada extra na troca de cheque
      SELECT CHR.CODFIL, CHR.SEQUEN, CHR.FILCLI, CHR.CODCLI,
             CAST('R' AS VARCHAR(1))   AS FLGFLX,
             COALESCE(CHR.DATFIS,CHR.DATOPE) AS DATLAN,
             MTOM(MOE.CODTAB,0,COALESCE(CHR.DATFIS,CHR.DATOPE),OPE.VLROPE) AS VLRLAN,
             CHR.CODFIL                 AS FILLAN,
             DCTA.FILCTA                AS FILCTA,
             DCTA.SEQCTA                AS SEQCTA,
             DCTA.TIPCTA                AS TIPCTA,
             DCTA.CODTAB                AS CODCTA,
             CAST('CAI' AS VARCHAR(3)) AS ORICTA,
             DCOB.FILCTA                AS FILCRT,
             DCOB.SEQCTA                AS SEQCRT,
             DCOB.TIPCTA                AS TIPCRT,
             DCOB.CODTAB                AS CODCRT,
             CAST('COB' AS VARCHAR(3)) AS ORICRT,
             MTOM(MOE.CODTAB,0,COALESCE(CHR.DATFIS,CHR.DATOPE),OPE.VLROPE) AS VLRCRT,
             CAST('TAX' AS VARCHAR(3)) AS TIPLAN,
             CHR.FILUSU,
             CHR.CODUSU,
             CHR.ATU_EM
      FROM TT_CHR CHR INNER JOIN TD_COB DCOB ON DCOB.CODTAB = CHR.PORORI
                      INNER JOIN TT_OPE OCHR ON OCHR.FILCHR=CHR.CODFIL AND OCHR.SEQCHR=CHR.SEQUEN and OCHR.VLROPE>0
                      INNER JOIN TT_OPE OPE  ON OCHR.CODFIL=OPE.CODFIL AND OCHR.NUMECF=OPE.NUMECF AND OCHR.TRN_ID=OPE.TRN_ID
                      INNER JOIN TD_MOE MOE  ON MOE.CODTAB=OPE.CAMBIO
                       LEFT JOIN TT_REC REC  ON REC.FILREC=CHR.CODFIL AND REC.SEQCHE=CHR.SEQUEN
                       LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL='TAXA_TRO_CHEQUE'
                      CROSS JOIN TD_CAI CAI
      WHERE CHR.FLGEST <> 'X' -- Ignora cheques X
        AND CAI.CODTAB = 0
        AND REC.CODFIL  IS NULL
        AND DCTA.CODTAB IS NOT NULL
        AND OPE.CAMBIO  IS NOT NULL
        AND OPE.CODCAI  IS NULL
        AND OPE.MEIPGT = 'F'
        AND NOT EXISTS (SELECT 1 AS OK
                          FROM TT_OPE OREC
                         WHERE OREC.CODFIL = OPE.CODFIL
                           AND OREC.NUMECF = OPE.NUMECF
                           AND OREC.TRN_ID = OPE.TRN_ID
                           AND OREC.FILREC IS NOT NULL) */
   ) tab
;


/*-- SEQ 2900 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RFIN_COM CASCADE;

/*-- SEQ 2901 --*/
CREATE OR REPLACE VIEW TV_RFIN_COM AS
--
--   TIPO     CONTA                                         CONTRA-PARTIDA
--   -------  --------------------------------------------  -------------------------------------
--   Compras  <Conta informada, Mercadorias para Revendas>  <Fornecedores a Pagar OU Compras a Faturar>
--            OU <Conta do CFOP>
--   Titulos  <Conta informa OU Despesas diversas>          <Ttulos a Pagar OU Titulos a Faturar>
--   Fretes   <Conta informa OU Fretes de Mercadorias>      <Fretes a Pagar OU Fretes a Faturar>
--   Faturas  <Compras a Faturar OU Fretes a Faturar>       <Contas a Pagar>
--
SELECT CAST('COM' AS VARCHAR(3)) AS ORIGEM,
       DOC.CODFIL, DOC.SEQUEN,
       CAST('--' AS CHAR(2)) AS NUMPAR,
       CAST('--' AS CHAR(2)) AS SUBPAR,
       DOC.DATOPE AS DATLAN,
       (CASE WHEN CXC.FILCTA IS NOT NULL THEN CXC.VLRRAT ELSE DOC.VLRLIQ END -
           CASE WHEN DOC.TIPNOT = 'F' THEN 0
                WHEN DOC.TIPNOT = 'A' THEN
                   -- Retira juros de financiamento dos compromissos
                   CASE WHEN FIL.FILJUR IS NULL THEN 0 ELSE
                       CASE WHEN CXC.FILCTA IS NOT NULL THEN
                           Rateio_Contas_Compra(CXC.CODFIL,
                                                CXC.SEQUEN,
                                                CXC.FILCTA,
                                                CXC.SEQCTA,
                                                CXC.TIPCTA,
                                                DOC.VLRLIQ,
                                                (SELECT ROUND(SUM(COALESCE(PAG.VLRJUR,0)),2)
                                                   FROM TT_PAG PAG
                                                   WHERE PAG.CODFIL = DOC.CODFIL
                                                     AND PAG.SEQUEN = DOC.SEQUEN
                                                     AND PAG.SUBPAR = ' 0'
                                                     AND PAG.RENORI IS NULL) 
                                               )
                        ELSE
                           (SELECT ROUND(SUM(COALESCE(PAG.VLRJUR,0)),2)
                              FROM TT_PAG PAG
                              WHERE PAG.CODFIL = DOC.CODFIL
                                AND PAG.SEQUEN = DOC.SEQUEN
                                AND PAG.SUBPAR = ' 0'
                                AND PAG.RENORI IS NULL)                         
                        END                        
                    END
                ELSE 0
           END) * CASE DOC.TIPNOT WHEN 'F' THEN 1 ELSE -1 END AS VLRLAN,
       DOC.FILFOR AS FILCLI,
       DOC.CODFOR AS CODCLI,
       CAST('R' AS VARCHAR(1)) AS FLGFLX,
       CASE WHEN (DOC.FILCTA IS NULL AND CXC.FILCTA IS NULL) OR DOC.TIPNOT = 'F' THEN CASE WHEN CTACFO.SEQUEN IS NOT NULL THEN CAST('CFO' AS CHAR(3)) ELSE CAST('CTA' AS CHAR(3)) END ELSE CAST('---' AS CHAR(3)) END AS ORICTA,
       CASE WHEN (DOC.FILCTA IS NULL AND CXC.FILCTA IS NULL) OR DOC.TIPNOT = 'F' THEN CASE WHEN CTACFO.SEQUEN IS NOT NULL THEN CFO.CFOCTA_FIL         ELSE DCTA.FILCTA            END ELSE COALESCE(CXC.FILCTA,DOC.FILCTA) END AS FILCTA,
       CASE WHEN (DOC.FILCTA IS NULL AND CXC.FILCTA IS NULL) OR DOC.TIPNOT = 'F' THEN CASE WHEN CTACFO.SEQUEN IS NOT NULL THEN CFO.CFOCTA_SEQ         ELSE DCTA.SEQCTA            END ELSE COALESCE(CXC.SEQCTA,DOC.SEQCTA) END AS SEQCTA,
       CASE WHEN (DOC.FILCTA IS NULL AND CXC.FILCTA IS NULL) OR DOC.TIPNOT = 'F' THEN CASE WHEN CTACFO.SEQUEN IS NOT NULL THEN CFO.CFOCTA_TIP         ELSE DCTA.TIPCTA            END ELSE COALESCE(CXC.TIPCTA,DOC.TIPCTA) END AS TIPCTA,
       CASE WHEN (DOC.FILCTA IS NULL AND CXC.FILCTA IS NULL) OR DOC.TIPNOT = 'F' THEN CASE WHEN CTACFO.SEQUEN IS NOT NULL THEN CFO.CODTAB             ELSE DCTA.CODTAB            END ELSE CAST(0 AS Numeric(5))   END AS CODCTA,
       CASE WHEN (CTAD.FILVIN IS NULL AND CTAX.FILVIN IS NULL) OR DOC.TIPNOT = 'F' THEN DCRT.FILCTA ELSE CAST(COALESCE(CTAX.FILVIN,CTAD.FILVIN) AS CHAR(3)) END AS FILCRT,
       CASE WHEN (CTAD.FILVIN IS NULL AND CTAX.FILVIN IS NULL) OR DOC.TIPNOT = 'F' THEN DCRT.SEQCTA ELSE CAST(COALESCE(CTAX.SEQVIN,CTAD.SEQVIN) AS CHAR(10)) END AS SEQCRT,
       CASE WHEN (CTAD.FILVIN IS NULL AND CTAX.FILVIN IS NULL) OR DOC.TIPNOT = 'F' THEN DCRT.TIPCTA ELSE CAST(COALESCE(CTAX.TIPVIN,CTAD.TIPVIN) AS CHAR(1)) END AS TIPCRT,
       CAST('CTA' AS CHAR(3)) AS ORICRT,
       DCRT.CODTAB AS CODCRT,
       CAST(CASE WHEN DOC.TIPNOT='F' THEN 'FAT'
                 WHEN DOC.TIPPAR='T' THEN 'FRE'
                 WHEN DOC.TIPPAR='F' THEN 'COM'
                                     ELSE 'TIT'
            END AS VARCHAR(3)) AS TIPLAN,
       DOC.CODFIL AS FILORI,
       DOC.CODFIL AS FILDES,
       DOC.FILUSU,
       DOC.CODUSU,
       CASE WHEN DOC.TIPNOT IN ('A','F') THEN
               CASE WHEN CXC.FILCTA IS NOT NULL THEN
                  Rateio_Contas_Compra(CXC.CODFIL,
                                       CXC.SEQUEN,
                                       CXC.FILCTA,
                                       CXC.SEQCTA,
                                       CXC.TIPCTA,
                                       DOC.VLRLIQ,
                                       (SELECT ROUND(SUM(PAG.VLRPAR-CASE WHEN FIL.FILJUR IS NULL THEN 0 ELSE COALESCE(PAG.VLRJUR,0) END),2)
                                          FROM TT_PAG PAG
                                         WHERE PAG.CODFIL = DOC.CODFIL
                                           AND PAG.SEQUEN = DOC.SEQUEN
                                           AND PAG.SUBPAR = ' 0'
                                           AND PAG.RENORI IS NULL)                                       
                                       )                                    
               ELSE
                  (SELECT ROUND(SUM(PAG.VLRPAR-CASE WHEN FIL.FILJUR IS NULL THEN 0 ELSE COALESCE(PAG.VLRJUR,0) END),2)
                     FROM TT_PAG PAG
                    WHERE PAG.CODFIL = DOC.CODFIL
                      AND PAG.SEQUEN = DOC.SEQUEN
                      AND PAG.SUBPAR = ' 0'
                      AND PAG.RENORI IS NULL)
               END       
               - CASE WHEN CXC.FILCTA IS NOT NULL THEN Rateio_Contas_Compra(CXC.CODFIL,CXC.SEQUEN,CXC.FILCTA,CXC.SEQCTA,CXC.TIPCTA,DOC.VLRLIQ,COALESCE(DOC.DESPAR,0)) ELSE COALESCE(DOC.DESPAR,0) END
               -- Os campos abaixo nao precisam ser rateados pois so utilizados apenas na tela
               -- de compromissos a pagar, que no possui rateio de contas contabeis
               -- Caso passe a ter, deve-se ratear o valor entre as contas
               + CASE WHEN (DOC.FLGPIS = 'T') THEN COALESCE(DOC.VLRPIS,0) ELSE 0 END
               + CASE WHEN (DOC.FLGCOF = 'T') THEN COALESCE(DOC.VLRCOF,0) ELSE 0 END
               + CASE WHEN (DOC.RETCSS = 'T') THEN COALESCE(DOC.VLRCSS,0) ELSE 0 END
               + CASE WHEN (DOC.FLGICM = 'T') THEN COALESCE(DOC.VLRICM,0) ELSE 0 END
               + CASE WHEN (DOC.FLGISS = 'T') THEN COALESCE(DOC.VLRISS,0) ELSE 0 END
               + CASE WHEN (DOC.FLGINS = 'T') THEN COALESCE(DOC.VLRINS,0) ELSE 0 END
               + CASE WHEN (DOC.RETIRR = 'T') THEN COALESCE(DOC.VLRIRR,0) ELSE 0 END
               - CASE WHEN (COALESCE(VEN.FUNRUR,0) < 0) THEN VEN.FUNRUR ELSE 0 END
               - CASE WHEN (COALESCE(VEN.SENAR,0) < 0) THEN VEN.SENAR ELSE 0 END
               - CASE WHEN (COALESCE(VEN.SEGRUR,0) < 0) THEN VEN.SEGRUR ELSE 0 END
            ELSE CASE WHEN CXC.FILCTA IS NOT NULL THEN CXC.VLRRAT ELSE DOC.VLRLIQ END
       END * CASE DOC.TIPNOT WHEN 'F' THEN 1 ELSE -1 END AS VLRCRT,
       DOC.ATU_EM, DOC.DATINC AS DATINCORI
FROM TT_COM DOC INNER JOIN TD_FIL FIL ON FIL.CODFIL = DOC.CODFIL
                LEFT JOIN TT_COMXCTA CXC ON CXC.CODFIL = DOC.CODFIL 
                                        AND CXC.SEQUEN = DOC.SEQUEN
                LEFT JOIN TT_CTA CTAD ON DOC.FILCTA = CTAD.CODFIL
                                     AND DOC.SEQCTA = CTAD.SEQUEN
                LEFT JOIN TT_CTA CTAX ON CXC.FILCTA = CTAX.CODFIL
                                     AND CXC.SEQCTA = CTAX.SEQUEN
                LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL = CASE WHEN DOC.TIPNOT='F' THEN
                                                                 CASE WHEN DOC.TIPPAR='T'
                                                                      THEN 'FRETES A FATURAR'  -- Conhecimento de Fretes a faturar
                                                                      ELSE 'COMPRAS A FATURAR' -- Faturas
                                                                 END
                                                            WHEN DOC.TIPPAR='T' THEN 'TIPCTA_FRE_MER'    -- Fretes
                                                            WHEN DOC.TIPPAR='F' THEN 'TIPCTA_MER_REV'    -- Compras
                                                                                ELSE 'DESPESAS DIVERSAS' -- Ttulos
                                                       END
                LEFT JOIN TD_CTA DCRT ON DCRT.CFGCOL = CASE WHEN DOC.TIPNOT='N' THEN
                                                            CASE WHEN DOC.TIPPAR='T' THEN 'FRETES A FATURAR'  -- Conhecimento de Fretes a faturar
                                                                 WHEN DOC.TIPPAR='F' THEN 'COMPRAS A FATURAR' -- Notas de compra a Faturar
                                                                                     ELSE 'TITULOS A FATURAR' -- Titulos a Faturar
                                                            END
                                                       ELSE
                                                            CASE WHEN DOC.TIPPAR='T' THEN 'TIPCTA_FRE_PAG'    -- Fretes a pagar
                                                                 WHEN DOC.TIPPAR='F' THEN 'TIPCTA_FOR_PAG'    -- Fornecedores a pagar
                                                                                     ELSE 'TIPCTA_TIT_PAG'    -- Titulos a pagar
                                                            END
                                                       END
                LEFT JOIN TT_VEN VEN ON DOC.CODFIL = VEN.CODFIL
                                    AND DOC.CODSER = VEN.CODSER
                                    AND SUBSTR(DOC.NUMNOT, 4, 6) = VEN.NUMNOT
                                    AND DOC.FILFOR = VEN.FILCLI
                                    AND DOC.CODFOR = VEN.CODCLI
                LEFT JOIN TD_CFO CFO ON DOC.CODCFO = CFO.CODTAB
                LEFT JOIN TT_CTA CTACFO ON CFO.CFOCTA_FIL = CTACFO.CODFIL
                                       AND CFO.CFOCTA_SEQ = CTACFO.SEQUEN
                                       AND DOC.TIPPAR IN ('F','T') -- fornecedor ou transportadora
WHERE DOC.FLGEST <> 'D'
  and (exists (SELECT 1 AS OK
                  FROM TT_PAG PAG
                  WHERE PAG.CODFIL = DOC.CODFIL
                    AND PAG.SEQUEN = DOC.SEQUEN
                    AND PAG.SUBPAR = ' 0'
                    AND PAG.RENORI IS NULL) or DOC.TIPNOT<>'A')
UNION ALL
--
--   TIPO     CONTA                                         CONTRA-PARTIDA
--   -------  --------------------------------------------  -------------------------------------
--   Juros    <Juros de Financiamento>                      <Ttulos a Pagar OU Titulos a Faturar>
--   Financ.
SELECT CAST('COM' AS VARCHAR(3)) AS ORIGEM,
       DOC.CODFIL, DOC.SEQUEN,
       CAST('--' AS CHAR(2)) AS NUMPAR,
       CAST('--' AS CHAR(2)) AS SUBPAR,
       DOC.DATOPE AS DATLAN,
       CASE WHEN CXC.FILCTA IS NOT NULL THEN
           Rateio_Contas_Compra(CXC.CODFIL,
                                CXC.SEQUEN,
                                CXC.FILCTA,
                                CXC.SEQCTA,
                                CXC.TIPCTA,
                                DOC.VLRLIQ,                            
                                (SELECT ROUND(SUM(COALESCE(PAG.VLRJUR,0)),2)
                                   FROM TT_PAG PAG
                                   WHERE PAG.CODFIL = DOC.CODFIL
                                     AND PAG.SEQUEN = DOC.SEQUEN
                                     AND PAG.SUBPAR = ' 0'
                                     AND PAG.RENORI IS NULL)
                                )
        ELSE 
           (SELECT ROUND(SUM(COALESCE(PAG.VLRJUR,0)),2)
              FROM TT_PAG PAG
              WHERE PAG.CODFIL = DOC.CODFIL
                AND PAG.SEQUEN = DOC.SEQUEN
                AND PAG.SUBPAR = ' 0'
                AND PAG.RENORI IS NULL) 
        END * -1 AS VLRLAN,
       DOC.FILFOR AS FILCLI,
       DOC.CODFOR AS CODCLI,
       CAST('R' AS VARCHAR(1)) AS FLGFLX,
       CAST('---' AS CHAR(3)) AS ORICTA,
       FIL.FILJUR             AS FILCTA,
       FIL.SEQJUR             AS SEQCTA,
       FIL.TIPJUR             AS TIPCTA,
       CAST(0 AS Numeric(5))   AS CODCTA,
       CASE WHEN (CTAD.FILVIN IS NULL AND CTAX.FILVIN IS NULL) OR DOC.TIPNOT = 'F' THEN DCRT.FILCTA ELSE CAST(COALESCE(CTAX.FILVIN,CTAD.FILVIN) AS CHAR(3)) END AS FILCRT,
       CASE WHEN (CTAD.FILVIN IS NULL AND CTAX.FILVIN IS NULL) OR DOC.TIPNOT = 'F' THEN DCRT.SEQCTA ELSE CAST(COALESCE(CTAX.SEQVIN,CTAD.SEQVIN) AS CHAR(10)) END AS SEQCRT,
       CASE WHEN (CTAD.FILVIN IS NULL AND CTAX.FILVIN IS NULL) OR DOC.TIPNOT = 'F' THEN DCRT.TIPCTA ELSE CAST(COALESCE(CTAX.TIPVIN,CTAD.TIPVIN) AS CHAR(1)) END AS TIPCRT,
       CAST('CTA' AS CHAR(3)) AS ORICRT,
       DCRT.CODTAB AS CODCRT,
       CAST('JDF' AS VARCHAR(3)) AS TIPLAN,
       DOC.CODFIL AS FILORI,
       DOC.CODFIL AS FILDES,
       DOC.FILUSU,
       DOC.CODUSU,
       CASE WHEN CXC.FILCTA IS NOT NULL THEN
          Rateio_Contas_Compra(CXC.CODFIL,
                               CXC.SEQUEN,
                               CXC.FILCTA,
                               CXC.SEQCTA,
                               CXC.TIPCTA,
                               DOC.VLRLIQ,
                               (SELECT ROUND(SUM(COALESCE(PAG.VLRJUR,0)),2)
                                  FROM TT_PAG PAG
                                  WHERE PAG.CODFIL = DOC.CODFIL
                                    AND PAG.SEQUEN = DOC.SEQUEN
                                    AND PAG.SUBPAR = ' 0'
                                    AND PAG.RENORI IS NULL) 
                                ) 
        ELSE
           (SELECT ROUND(SUM(COALESCE(PAG.VLRJUR,0)),2)
              FROM TT_PAG PAG
              WHERE PAG.CODFIL = DOC.CODFIL
                AND PAG.SEQUEN = DOC.SEQUEN
                AND PAG.SUBPAR = ' 0'
                AND PAG.RENORI IS NULL) 
        END * -1 AS VLRCRT,
       DOC.ATU_EM, DOC.DATINC AS DATINCORI
FROM TT_COM DOC INNER JOIN TD_FIL FIL ON FIL.CODFIL = DOC.CODFIL
                LEFT JOIN TT_COMXCTA CXC ON CXC.CODFIL = DOC.CODFIL 
                                         AND CXC.SEQUEN = DOC.SEQUEN 
                LEFT JOIN TT_CTA CTAD ON DOC.FILCTA = CTAD.CODFIL
                                     AND DOC.SEQCTA = CTAD.SEQUEN
                LEFT JOIN TT_CTA CTAX ON CXC.FILCTA = CTAX.CODFIL
                                     AND CXC.SEQCTA = CTAX.SEQUEN
                LEFT JOIN TD_CTA DCRT ON DCRT.CFGCOL = CASE WHEN DOC.TIPNOT='N' THEN
                                                            CASE WHEN DOC.TIPPAR='T' THEN 'FRETES A FATURAR'  -- Conhecimento de Fretes a faturar
                                                                 WHEN DOC.TIPPAR='F' THEN 'COMPRAS A FATURAR' -- Notas de compra a Faturar
                                                                                     ELSE 'TITULOS A FATURAR' -- Titulos a Faturar
                                                            END
                                                       ELSE
                                                            CASE WHEN DOC.TIPPAR='T' THEN 'TIPCTA_FRE_PAG'    -- Fretes a pagar
                                                                 WHEN DOC.TIPPAR='F' THEN 'TIPCTA_FOR_PAG'    -- Fornecedores a pagar
                                                                                     ELSE 'TIPCTA_TIT_PAG'    -- Titulos a pagar
                                                            END
                                                       END
WHERE DOC.FLGEST <> 'D'
  AND DOC.TIPNOT = 'A'
  AND EXISTS (SELECT 1 AS OK
                FROM TT_PAG PAG
               WHERE PAG.CODFIL = DOC.CODFIL
                 AND PAG.SEQUEN = DOC.SEQUEN
                 AND PAG.SUBPAR = ' 0'
                 AND PAG.RENORI IS NULL
                 AND COALESCE(PAG.VLRJUR,0) > 0)
  AND FIL.FILJUR IS NOT NULL                 
UNION ALL
--
--   Especifico para tratar desconto ocorrido na emisso de fatura pelo fornecedor/transportador
--
--   CONTA                                                         CONTRA-PARTIDA
--   -----------------------------------------------------------   ----------------------------------
--   <Compras a Faturar OU Titulos a Faturar ou Fretes a Faturar>  <Descontos Obtidos OU Juros Pagos>
--
SELECT CAST('COM' AS VARCHAR(3)) AS ORIGEM,
       DOC.CODFIL, DOC.SEQUEN,
       CAST('--' AS CHAR(2)) AS NUMPAR,
       CAST('--' AS CHAR(2)) AS SUBPAR,
       DOC.DATOPE AS DATLAN,
       DOC.DESCON * -1 AS VLRLAN,
       DOC.FILFOR AS FILCLI,
       DOC.CODFOR AS CODCLI,
       CAST('R' AS VARCHAR(1)) AS FLGFLX,
       CAST('CTA' AS CHAR(3)) AS ORICTA,
       CASE WHEN DOC.FILCTA IS NULL OR DOC.TIPNOT = 'F' THEN DCTA.FILCTA ELSE CTA.FILVIN END AS FILCTA,
       CASE WHEN DOC.FILCTA IS NULL OR DOC.TIPNOT = 'F' THEN DCTA.SEQCTA ELSE CTA.SEQVIN END AS SEQCTA,
       CASE WHEN DOC.FILCTA IS NULL OR DOC.TIPNOT = 'F' THEN DCTA.TIPCTA ELSE CTA.TIPVIN END AS TIPCTA,
       DCTA.CODTAB AS CODCTA,
       DCRT.FILCTA AS FILCRT,
       DCRT.SEQCTA AS SEQCRT,
       DCRT.TIPCTA AS TIPCRT,
       CAST('CTA' AS CHAR(3)) AS ORICRT,
       DCRT.CODTAB AS CODCRT,
       CAST('JDP' AS VARCHAR(3)) AS TIPLAN,
       DOC.CODFIL AS FILORI,
       DOC.CODFIL AS FILDES,
       DOC.FILUSU,
       DOC.CODUSU,
       DOC.DESCON * -1 AS VLRCRT,
       DOC.ATU_EM, DOC.DATINC AS DATINCORI
FROM TT_COM DOC LEFT JOIN TT_CTA CTA ON DOC.FILCTA=CTA.CODFIL AND DOC.SEQCTA=CTA.SEQUEN
                LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL = CASE WHEN DOC.TIPPAR='T' THEN 'FRETES A FATURAR'  -- Conhecimento de Fretes a faturar
                                                            WHEN DOC.TIPPAR='F' THEN 'COMPRAS A FATURAR' -- Notas de compra a Faturar
                                                                                ELSE 'TITULOS A FATURAR' -- Titulos a Faturar
                                                       END
                LEFT JOIN TD_CTA DCRT ON DCRT.CFGCOL = CASE WHEN DOC.DESCON < 0 THEN 'TIPCTA_DES_OBT'    -- Descontos obtidos
                                                                                ELSE 'TIPCTA_JUR_PAG'    -- Juros cobrados
                                                       END
WHERE DOC.FLGEST <> 'D'
  AND DOC.TIPNOT = 'F'
  AND COALESCE(DOC.DESCON,0) <> 0
UNION ALL
--
--   Especifico para tratar imposto de renda
--
--   CONTA                                                         CONTRA-PARTIDA
--   -----------------------------------------------------------   ----------------------------------
--   IRRF a Pagar                                                  <Fornecedores a Pagar OU Compras a Faturar>
--                                                                 <Ttulos a Pagar OU Titulos a Faturar>
--                                                                 <Fretes a Pagar OU Fretes a Faturar>
--                                                                 <Contas a Pagar>
--
SELECT CAST('COM' AS VARCHAR(3)) AS ORIGEM,
       DOC.CODFIL, DOC.SEQUEN,
       CAST('--' AS CHAR(2)) AS NUMPAR,
       CAST('--' AS CHAR(2)) AS SUBPAR,
       DOC.DATOPE AS DATLAN,
       DOC.VLRIRR AS VLRLAN,
       DOC.FILFOR AS FILCLI,
       DOC.CODFOR AS CODCLI,
       CAST('R' AS VARCHAR(1)) AS FLGFLX,
       CAST('CTA' AS CHAR(3)) AS ORICTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.FILCTA ELSE CTA.FILVIN END AS FILCTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.SEQCTA ELSE CTA.SEQVIN END AS SEQCTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.TIPCTA ELSE CTA.TIPVIN END AS TIPCTA,
       DCRT.CODTAB AS CODCTA,
       DCTA.FILCTA AS FILCRT,
       DCTA.SEQCTA AS SEQCRT,
       DCTA.TIPCTA AS TIPCRT,
       CAST('CTA' AS CHAR(3)) AS ORICRT,
       DCTA.CODTAB AS CODCRT,
       CAST('IRR' AS VARCHAR(3)) AS TIPLAN,
       DOC.CODFIL AS FILORI,
       DOC.CODFIL AS FILDES,
       DOC.FILUSU,
       DOC.CODUSU,
       DOC.VLRIRR AS VLRCRT,
       DOC.ATU_EM, DOC.DATINC AS DATINCORI
FROM TT_COM DOC LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'IRRF_PAG'
                LEFT JOIN TT_CTA CTA  ON DOC.FILCTA = CTA.CODFIL
                                     AND DOC.SEQCTA = CTA.SEQUEN
                LEFT JOIN TD_CTA DCRT ON DCRT.CFGCOL = CASE WHEN DOC.TIPNOT='N' THEN
                                                            CASE WHEN DOC.TIPPAR='T' THEN 'FRETES A FATURAR'  -- Conhecimento de Fretes a faturar
                                                                 WHEN DOC.TIPPAR='F' THEN 'COMPRAS A FATURAR' -- Notas de compra a Faturar
                                                                                     ELSE 'TITULOS A FATURAR' -- Titulos a Faturar
                                                            END
                                                       ELSE
                                                            CASE WHEN DOC.TIPPAR='T' THEN 'TIPCTA_FRE_PAG'    -- Fretes a pagar
                                                                 WHEN DOC.TIPPAR='F' THEN 'TIPCTA_FOR_PAG'    -- Fornecedores a pagar
                                                                                     ELSE 'TIPCTA_TIT_PAG'    -- Titulos a pagar
                                                            END
                                                       END
WHERE DOC.FLGEST <> 'D'
  AND DOC.RETIRR = 'T'
  AND DOC.VLRIRR > 0
UNION ALL
--
--   Especifico para tratar PIS
--
--   CONTA                                                         CONTRA-PARTIDA
--   -----------------------------------------------------------   ----------------------------------
--   PIS/COFINS a Pagar                                            <Fornecedores a Pagar OU Compras a Faturar>
--                                                                 <Ttulos a Pagar OU Titulos a Faturar>
--                                                                 <Fretes a Pagar OU Fretes a Faturar>
--                                                                 <Contas a Pagar>
--
SELECT CAST('COM' AS VARCHAR(3)) AS ORIGEM,
       DOC.CODFIL, DOC.SEQUEN,
       CAST('--' AS CHAR(2)) AS NUMPAR,
       CAST('--' AS CHAR(2)) AS SUBPAR,
       DOC.DATOPE AS DATLAN,
       DOC.VLRPIS AS VLRLAN,
       DOC.FILFOR AS FILCLI,
       DOC.CODFOR AS CODCLI,
       CAST('R' AS VARCHAR(1)) AS FLGFLX,
       CAST('CTA' AS CHAR(3)) AS ORICTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.FILCTA ELSE CTA.FILVIN END AS FILCTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.SEQCTA ELSE CTA.SEQVIN END AS SEQCTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.TIPCTA ELSE CTA.TIPVIN END AS TIPCTA,
       DCRT.CODTAB AS CODCTA,
       DCTA.FILCTA AS FILCRT,
       DCTA.SEQCTA AS SEQCRT,
       DCTA.TIPCTA AS TIPCRT,
       CAST('CTA' AS CHAR(3)) AS ORICRT,
       DCTA.CODTAB AS CODCRT,
       CAST('PIS' AS VARCHAR(3)) AS TIPLAN,
       DOC.CODFIL AS FILORI,
       DOC.CODFIL AS FILDES,
       DOC.FILUSU,
       DOC.CODUSU,
       DOC.VLRPIS AS VLRCRT,
       DOC.ATU_EM, DOC.DATINC AS DATINCORI
FROM TT_COM DOC LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'PIS_COFINS_PAG'
                LEFT JOIN TT_CTA CTA  ON DOC.FILCTA = CTA.CODFIL
                                     AND DOC.SEQCTA = CTA.SEQUEN
                LEFT JOIN TD_CTA DCRT ON DCRT.CFGCOL = CASE WHEN DOC.TIPNOT='N' THEN
                                                            CASE WHEN DOC.TIPPAR='T' THEN 'FRETES A FATURAR'  -- Conhecimento de Fretes a faturar
                                                                 WHEN DOC.TIPPAR='F' THEN 'COMPRAS A FATURAR' -- Notas de compra a Faturar
                                                                                     ELSE 'TITULOS A FATURAR' -- Titulos a Faturar
                                                            END
                                                       ELSE
                                                            CASE WHEN DOC.TIPPAR='T' THEN 'TIPCTA_FRE_PAG'    -- Fretes a pagar
                                                                 WHEN DOC.TIPPAR='F' THEN 'TIPCTA_FOR_PAG'    -- Fornecedores a pagar
                                                                                     ELSE 'TIPCTA_TIT_PAG'    -- Titulos a pagar
                                                            END
                                                       END
WHERE DOC.FLGEST <> 'D'
  AND DOC.FLGPIS = 'T'
  AND DOC.VLRPIS > 0
UNION ALL
--
--   Especifico para tratar COFINS
--
--   CONTA                                                         CONTRA-PARTIDA
--   -----------------------------------------------------------   ----------------------------------
--   PIS/COFINS a Pagar                                            <Fornecedores a Pagar OU Compras a Faturar>
--                                                                 <Ttulos a Pagar OU Titulos a Faturar>
--                                                                 <Fretes a Pagar OU Fretes a Faturar>
--                                                                 <Contas a Pagar>
--
SELECT CAST('COM' AS VARCHAR(3)) AS ORIGEM,
       DOC.CODFIL, DOC.SEQUEN,
       CAST('--' AS CHAR(2)) AS NUMPAR,
       CAST('--' AS CHAR(2)) AS SUBPAR,
       DOC.DATOPE AS DATLAN,
       DOC.VLRCOF AS VLRLAN,
       DOC.FILFOR AS FILCLI,
       DOC.CODFOR AS CODCLI,
       CAST('R' AS VARCHAR(1)) AS FLGFLX,
       CAST('CTA' AS CHAR(3)) AS ORICTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.FILCTA ELSE CTA.FILVIN END AS FILCTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.SEQCTA ELSE CTA.SEQVIN END AS SEQCTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.TIPCTA ELSE CTA.TIPVIN END AS TIPCTA,
       DCRT.CODTAB AS CODCTA,
       DCTA.FILCTA AS FILCRT,
       DCTA.SEQCTA AS SEQCRT,
       DCTA.TIPCTA AS TIPCRT,
       CAST('CTA' AS CHAR(3)) AS ORICRT,
       DCTA.CODTAB AS CODCRT,
       CAST('COF' AS VARCHAR(3)) AS TIPLAN,
       DOC.CODFIL AS FILORI,
       DOC.CODFIL AS FILDES,
       DOC.FILUSU,
       DOC.CODUSU,
       DOC.VLRCOF AS VLRCRT,
       DOC.ATU_EM, DOC.DATINC AS DATINCORI
FROM TT_COM DOC LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'PIS_COFINS_PAG'
                LEFT JOIN TT_CTA CTA  ON DOC.FILCTA = CTA.CODFIL
                                     AND DOC.SEQCTA = CTA.SEQUEN
                LEFT JOIN TD_CTA DCRT ON DCRT.CFGCOL = CASE WHEN DOC.TIPNOT='N' THEN
                                                            CASE WHEN DOC.TIPPAR='T' THEN 'FRETES A FATURAR'  -- Conhecimento de Fretes a faturar
                                                                 WHEN DOC.TIPPAR='F' THEN 'COMPRAS A FATURAR' -- Notas de compra a Faturar
                                                                                     ELSE 'TITULOS A FATURAR' -- Titulos a Faturar
                                                            END
                                                       ELSE
                                                            CASE WHEN DOC.TIPPAR='T' THEN 'TIPCTA_FRE_PAG'    -- Fretes a pagar
                                                                 WHEN DOC.TIPPAR='F' THEN 'TIPCTA_FOR_PAG'    -- Fornecedores a pagar
                                                                                     ELSE 'TIPCTA_TIT_PAG'    -- Titulos a pagar
                                                            END
                                                       END
WHERE DOC.FLGEST <> 'D'
  AND DOC.FLGCOF = 'T'
  AND DOC.VLRCOF > 0
UNION ALL
--
--   Especifico para tratar Contribuio Social
--
--   CONTA                                                         CONTRA-PARTIDA
--   -----------------------------------------------------------   ----------------------------------
--   Contribuio Social a Pagar                                   <Fornecedores a Pagar OU Compras a Faturar>
--                                                                 <Ttulos a Pagar OU Titulos a Faturar>
--                                                                 <Fretes a Pagar OU Fretes a Faturar>
--                                                                 <Contas a Pagar>
--
SELECT CAST('COM' AS VARCHAR(3)) AS ORIGEM,
       DOC.CODFIL, DOC.SEQUEN,
       CAST('--' AS CHAR(2)) AS NUMPAR,
       CAST('--' AS CHAR(2)) AS SUBPAR,
       DOC.DATOPE AS DATLAN,
       DOC.VLRCSS AS VLRLAN,
       DOC.FILFOR AS FILCLI,
       DOC.CODFOR AS CODCLI,
       CAST('R' AS VARCHAR(1)) AS FLGFLX,
       CAST('CTA' AS CHAR(3)) AS ORICTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.FILCTA ELSE CTA.FILVIN END AS FILCTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.SEQCTA ELSE CTA.SEQVIN END AS SEQCTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.TIPCTA ELSE CTA.TIPVIN END AS TIPCTA,
       DCRT.CODTAB AS CODCTA,
       DCTA.FILCTA AS FILCRT,
       DCTA.SEQCTA AS SEQCRT,
       DCTA.TIPCTA AS TIPCRT,
       CAST('CTA' AS CHAR(3)) AS ORICRT,
       DCTA.CODTAB AS CODCRT,
       CAST('CSS' AS VARCHAR(3)) AS TIPLAN,
       DOC.CODFIL AS FILORI,
       DOC.CODFIL AS FILDES,
       DOC.FILUSU,
       DOC.CODUSU,
       DOC.VLRCSS AS VLRCRT,
       DOC.ATU_EM, DOC.DATINC AS DATINCORI
FROM TT_COM DOC LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'CONTRIB_PAG'
                LEFT JOIN TT_CTA CTA  ON DOC.FILCTA = CTA.CODFIL
                                     AND DOC.SEQCTA = CTA.SEQUEN
                LEFT JOIN TD_CTA DCRT ON DCRT.CFGCOL = CASE WHEN DOC.TIPNOT='N' THEN
                                                            CASE WHEN DOC.TIPPAR='T' THEN 'FRETES A FATURAR'  -- Conhecimento de Fretes a faturar
                                                                 WHEN DOC.TIPPAR='F' THEN 'COMPRAS A FATURAR' -- Notas de compra a Faturar
                                                                                     ELSE 'TITULOS A FATURAR' -- Titulos a Faturar
                                                            END
                                                       ELSE
                                                            CASE WHEN DOC.TIPPAR='T' THEN 'TIPCTA_FRE_PAG'    -- Fretes a pagar
                                                                 WHEN DOC.TIPPAR='F' THEN 'TIPCTA_FOR_PAG'    -- Fornecedores a pagar
                                                                                     ELSE 'TIPCTA_TIT_PAG'    -- Titulos a pagar
                                                            END
                                                       END
WHERE DOC.FLGEST <> 'D'
  AND DOC.RETCSS = 'T'
  AND DOC.VLRCSS > 0
UNION ALL
--
--   Especifico para tratar Bonificaes
--
--   CONTA                                                         CONTRA-PARTIDA
--   -----------------------------------------------------------   ----------------------------------
--   Compras  <Conta informa OU Mercadorias para Revendas>         Bonificaes
--
SELECT CAST('COM' AS VARCHAR(3)) AS ORIGEM,
       DOC.CODFIL, DOC.SEQUEN,
       CAST('--' AS CHAR(2)) AS NUMPAR,
       CAST('--' AS CHAR(2)) AS SUBPAR,
       DOC.DATOPE AS DATLAN,
       DOC.VLRBON AS VLRLAN,
       DOC.FILFOR AS FILCLI,
       DOC.CODFOR AS CODCLI,
       CAST('R' AS VARCHAR(1)) AS FLGFLX,
       CAST('CTA' AS CHAR(3)) AS ORICTA,
       DOC.FILCTA,
       DOC.SEQCTA,
       DOC.TIPCTA,
       CAST(0 AS Numeric(5)) AS CODCTA,
       DCTA.FILCTA AS FILCRT,
       DCTA.SEQCTA AS SEQCRT,
       DCTA.TIPCTA AS TIPCRT,
       CAST('CTA' AS CHAR(3)) AS ORICRT,
       DCTA.CODTAB AS CODCRT,
       CAST('BON' AS VARCHAR(3)) AS TIPLAN,
       DOC.CODFIL AS FILORI,
       DOC.CODFIL AS FILDES,
       DOC.FILUSU,
       DOC.CODUSU,
       DOC.VLRBON AS VLRCRT,
       DOC.ATU_EM, DOC.DATINC AS DATINCORI
FROM TT_COM DOC LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'BONIFICACOES'
WHERE DOC.FLGEST <> 'D'
  AND DOC.VLRBON > 0
UNION ALL
--
--   Especifico para tratar ICMS
--
--   CONTA                                                         CONTRA-PARTIDA
--   -----------------------------------------------------------   ----------------------------------
--   ICMS a Pagar                                                  <Fornecedores a Pagar OU Compras a Faturar>
--                                                                 <Ttulos a Pagar OU Titulos a Faturar>
--                                                                 <Fretes a Pagar OU Fretes a Faturar>
--                                                                 <Contas a Pagar>
--
SELECT CAST('COM' AS VARCHAR(3)) AS ORIGEM,
       DOC.CODFIL, DOC.SEQUEN,
       CAST('--' AS CHAR(2)) AS NUMPAR,
       CAST('--' AS CHAR(2)) AS SUBPAR,
       DOC.DATOPE AS DATLAN,
       DOC.VLRICM AS VLRLAN,
       DOC.FILFOR AS FILCLI,
       DOC.CODFOR AS CODCLI,
       CAST('R' AS VARCHAR(1)) AS FLGFLX,
       CAST('CTA' AS CHAR(3)) AS ORICTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.FILCTA ELSE CTA.FILVIN END AS FILCTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.SEQCTA ELSE CTA.SEQVIN END AS SEQCTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.TIPCTA ELSE CTA.TIPVIN END AS TIPCTA,
       DCRT.CODTAB AS CODCTA,
       DCTA.FILCTA AS FILCRT,
       DCTA.SEQCTA AS SEQCRT,
       DCTA.TIPCTA AS TIPCRT,
       CAST('CTA' AS CHAR(3)) AS ORICRT,
       DCTA.CODTAB AS CODCRT,
       CAST('ICM' AS VARCHAR(3)) AS TIPLAN,
       DOC.CODFIL AS FILORI,
       DOC.CODFIL AS FILDES,
       DOC.FILUSU,
       DOC.CODUSU,
       DOC.VLRICM AS VLRCRT,
       DOC.ATU_EM, DOC.DATINC AS DATINCORI
FROM TT_COM DOC LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'ICMS_PAG'
                LEFT JOIN TT_CTA CTA  ON DOC.FILCTA = CTA.CODFIL
                                     AND DOC.SEQCTA = CTA.SEQUEN
                LEFT JOIN TD_CTA DCRT ON DCRT.CFGCOL = CASE WHEN DOC.TIPNOT='N' THEN
                                                            CASE WHEN DOC.TIPPAR='T' THEN 'FRETES A FATURAR'  -- Conhecimento de Fretes a faturar
                                                                 WHEN DOC.TIPPAR='F' THEN 'COMPRAS A FATURAR' -- Notas de compra a Faturar
                                                                                     ELSE 'TITULOS A FATURAR' -- Titulos a Faturar
                                                            END
                                                       ELSE
                                                            CASE WHEN DOC.TIPPAR='T' THEN 'TIPCTA_FRE_PAG'    -- Fretes a pagar
                                                                 WHEN DOC.TIPPAR='F' THEN 'TIPCTA_FOR_PAG'    -- Fornecedores a pagar
                                                                                     ELSE 'TIPCTA_TIT_PAG'    -- Titulos a pagar
                                                            END
                                                       END
WHERE DOC.FLGEST <> 'D'
  AND DOC.FLGICM = 'T'
  AND DOC.VLRICM > 0
UNION ALL
--
--   Especifico para tratar ISS
--
--   CONTA                                                         CONTRA-PARTIDA
--   -----------------------------------------------------------   ----------------------------------
--   ISS a Pagar                                                   <Fornecedores a Pagar OU Compras a Faturar>
--                                                                 <Ttulos a Pagar OU Titulos a Faturar>
--                                                                 <Fretes a Pagar OU Fretes a Faturar>
--                                                                 <Contas a Pagar>
--
SELECT CAST('COM' AS VARCHAR(3)) AS ORIGEM,
       DOC.CODFIL, DOC.SEQUEN,
       CAST('--' AS CHAR(2)) AS NUMPAR,
       CAST('--' AS CHAR(2)) AS SUBPAR,
       DOC.DATOPE AS DATLAN,
       DOC.VLRISS AS VLRLAN,
       DOC.FILFOR AS FILCLI,
       DOC.CODFOR AS CODCLI,
       CAST('R' AS VARCHAR(1)) AS FLGFLX,
       CAST('CTA' AS CHAR(3)) AS ORICTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.FILCTA ELSE CTA.FILVIN END AS FILCTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.SEQCTA ELSE CTA.SEQVIN END AS SEQCTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.TIPCTA ELSE CTA.TIPVIN END AS TIPCTA,
       DCRT.CODTAB AS CODCTA,
       DCTA.FILCTA AS FILCRT,
       DCTA.SEQCTA AS SEQCRT,
       DCTA.TIPCTA AS TIPCRT,
       CAST('CTA' AS CHAR(3)) AS ORICRT,
       DCTA.CODTAB AS CODCRT,
       CAST('ISS' AS VARCHAR(3)) AS TIPLAN,
       DOC.CODFIL AS FILORI,
       DOC.CODFIL AS FILDES,
       DOC.FILUSU,
       DOC.CODUSU,
       DOC.VLRISS AS VLRCRT,
       DOC.ATU_EM, DOC.DATINC AS DATINCORI
FROM TT_COM DOC LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'ISS_PAG'
                LEFT JOIN TT_CTA CTA  ON DOC.FILCTA = CTA.CODFIL
                                     AND DOC.SEQCTA = CTA.SEQUEN
                LEFT JOIN TD_CTA DCRT ON DCRT.CFGCOL = CASE WHEN DOC.TIPNOT='N' THEN
                                                            CASE WHEN DOC.TIPPAR='T' THEN 'FRETES A FATURAR'  -- Conhecimento de Fretes a faturar
                                                                 WHEN DOC.TIPPAR='F' THEN 'COMPRAS A FATURAR' -- Notas de compra a Faturar
                                                                                     ELSE 'TITULOS A FATURAR' -- Titulos a Faturar
                                                            END
                                                       ELSE
                                                            CASE WHEN DOC.TIPPAR='T' THEN 'TIPCTA_FRE_PAG'    -- Fretes a pagar
                                                                 WHEN DOC.TIPPAR='F' THEN 'TIPCTA_FOR_PAG'    -- Fornecedores a pagar
                                                                                     ELSE 'TIPCTA_TIT_PAG'    -- Titulos a pagar
                                                            END
                                                       END
WHERE DOC.FLGEST <> 'D'
  AND DOC.FLGISS = 'T'
  AND DOC.VLRISS > 0
UNION ALL
--
--   Especifico para tratar INSS
--
--   CONTA                                                         CONTRA-PARTIDA
--   -----------------------------------------------------------   ----------------------------------
--   INSS a Pagar                                                  <Fornecedores a Pagar OU Compras a Faturar>
--                                                                 <Ttulos a Pagar OU Titulos a Faturar>
--                                                                 <Fretes a Pagar OU Fretes a Faturar>
--                                                                 <Contas a Pagar>
--
SELECT CAST('COM' AS VARCHAR(3)) AS ORIGEM,
       DOC.CODFIL, DOC.SEQUEN,
       CAST('--' AS CHAR(2)) AS NUMPAR,
       CAST('--' AS CHAR(2)) AS SUBPAR,
       DOC.DATOPE AS DATLAN,
       DOC.VLRINS AS VLRLAN,
       DOC.FILFOR AS FILCLI,
       DOC.CODFOR AS CODCLI,
       CAST('R' AS VARCHAR(1)) AS FLGFLX,
       CAST('CTA' AS CHAR(3)) AS ORICTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.FILCTA ELSE CTA.FILVIN END AS FILCTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.SEQCTA ELSE CTA.SEQVIN END AS SEQCTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.TIPCTA ELSE CTA.TIPVIN END AS TIPCTA,
       DCRT.CODTAB AS CODCTA,
       DCTA.FILCTA AS FILCRT,
       DCTA.SEQCTA AS SEQCRT,
       DCTA.TIPCTA AS TIPCRT,
       CAST('CTA' AS CHAR(3)) AS ORICRT,
       DCTA.CODTAB AS CODCRT,
       CAST('INS' AS VARCHAR(3)) AS TIPLAN,
       DOC.CODFIL AS FILORI,
       DOC.CODFIL AS FILDES,
       DOC.FILUSU,
       DOC.CODUSU,
       DOC.VLRINS AS VLRCRT,
       DOC.ATU_EM, DOC.DATINC AS DATINCORI
FROM TT_COM DOC LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'INSS_PAG'
                LEFT JOIN TT_CTA CTA  ON DOC.FILCTA = CTA.CODFIL
                                     AND DOC.SEQCTA = CTA.SEQUEN
                LEFT JOIN TD_CTA DCRT ON DCRT.CFGCOL = CASE WHEN DOC.TIPNOT='N' THEN
                                                            CASE WHEN DOC.TIPPAR='T' THEN 'FRETES A FATURAR'  -- Conhecimento de Fretes a faturar
                                                                 WHEN DOC.TIPPAR='F' THEN 'COMPRAS A FATURAR' -- Notas de compra a Faturar
                                                                                     ELSE 'TITULOS A FATURAR' -- Titulos a Faturar
                                                            END
                                                       ELSE
                                                            CASE WHEN DOC.TIPPAR='T' THEN 'TIPCTA_FRE_PAG'    -- Fretes a pagar
                                                                 WHEN DOC.TIPPAR='F' THEN 'TIPCTA_FOR_PAG'    -- Fornecedores a pagar
                                                                                     ELSE 'TIPCTA_TIT_PAG'    -- Titulos a pagar
                                                            END
                                                       END
WHERE DOC.FLGEST <> 'D'
  AND DOC.FLGINS = 'T'
  AND DOC.VLRINS > 0
UNION ALL
--
--   Especifico para tratar Outras Despesas Associadas
--   59309
--   CONTA                                                         CONTRA-PARTIDA
--   -----------------------------------------------------------   ----------------------------------
--   <Conta informada no compromisso>                              OUTRAS DESPESAS
--
SELECT CAST('COM' AS VARCHAR(3)) AS ORIGEM,
       DOC.CODFIL, DOC.SEQUEN,
       CAST('--' AS CHAR(2)) AS NUMPAR,
       CAST('--' AS CHAR(2)) AS SUBPAR,
       DOC.DATOPE AS DATLAN,
       COALESCE(DOC.DESPAR,0) * -1 AS VLRLAN,
       DOC.FILFOR AS FILCLI,
       DOC.CODFOR AS CODCLI,
       CAST('R' AS VARCHAR(1)) AS FLGFLX,
       CAST('CTA' AS CHAR(3)) AS ORICTA,
       DCTA.FILCTA,
       DCTA.SEQCTA,
       DCTA.TIPCTA,
       DCTA.CODTAB AS CODCTA,
       DCRT.FILCTA AS FILCRT,
       DCRT.SEQCTA AS SEQCRT,
       DCRT.TIPCTA AS TIPCRT,
       CAST('CTA' AS CHAR(3)) AS ORICRT,
       CAST(0 AS Numeric(5)) AS CODCRT,
       CAST('OUT' AS VARCHAR(3)) AS TIPLAN,
       DOC.CODFIL AS FILORI,
       DOC.CODFIL AS FILDES,
       DOC.FILUSU,
       DOC.CODUSU,
       COALESCE(DOC.DESPAR,0)  * -1 AS VLRCRT,
       DOC.ATU_EM, DOC.DATINC AS DATINCORI
FROM TT_COM DOC LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'OUTRAS DESPESAS'
                LEFT JOIN TD_CTA DCRT ON DCRT.CFGCOL = CASE WHEN DOC.TIPNOT='N' THEN
                                                            CASE WHEN DOC.TIPPAR='T' THEN 'FRETES A FATURAR'  -- Conhecimento de Fretes a faturar
                                                                 WHEN DOC.TIPPAR='F' THEN 'COMPRAS A FATURAR' -- Notas de compra a Faturar
                                                                                     ELSE 'TITULOS A FATURAR' -- Titulos a Faturar
                                                            END
                                                       ELSE
                                                            CASE WHEN DOC.TIPPAR='T' THEN 'TIPCTA_FRE_PAG'    -- Fretes a pagar
                                                                 WHEN DOC.TIPPAR='F' THEN 'TIPCTA_FOR_PAG'    -- Fornecedores a pagar
                                                                                     ELSE 'TIPCTA_TIT_PAG'    -- Titulos a pagar
                                                            END
                                                       END
WHERE DOC.FLGEST <> 'D'
  AND COALESCE(DOC.DESPAR,0) <> 0
--
--   CONTA                                                         CONTRA-PARTIDA
--   -----------------------------------------------------------   ----------------------------------
--   Fundo Rural                                                   <Fornecedores a Pagar OU Compras a Faturar>
--                                                                 <Ttulos a Pagar OU Titulos a Faturar>
--                                                                 <Fretes a Pagar OU Fretes a Faturar>
--                                                                 <Contas a Pagar>
--
UNION ALL
SELECT CAST('COM' AS VARCHAR(3)) AS ORIGEM,
       DOC.CODFIL, DOC.SEQUEN AS SEQUEN,
       CAST('--' AS CHAR(2)) AS NUMPAR,
       CAST('--' AS CHAR(2)) AS SUBPAR,
       DOC.DATOPE AS DATLAN,
       VEN.FUNRUR*-1 AS VLRLAN,
       DOC.FILFOR AS FILCLI,
       DOC.CODFOR AS CODCLI,
       CAST('R' AS VARCHAR(1)) AS FLGFLX,
       CAST('CTA' AS CHAR(3)) AS ORICTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.FILCTA ELSE CTA.FILVIN END AS FILCTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.SEQCTA ELSE CTA.SEQVIN END AS SEQCTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.TIPCTA ELSE CTA.TIPVIN END AS TIPCTA,
       DCRT.CODTAB AS CODCTA,
       DCTA.FILCTA AS FILCRT,
       DCTA.SEQCTA AS SEQCRT,
       DCTA.TIPCTA AS TIPCRT,
       CAST('CTA' AS CHAR(3)) AS ORICRT,
       DCTA.CODTAB AS CODCRT,
       CAST('FNR' AS VARCHAR(3)) AS TIPLAN,
       DOC.CODFIL AS FILORI,
       DOC.CODFIL AS FILDES,
       DOC.FILUSU,
       DOC.CODUSU,
       VEN.FUNRUR*-1 AS VLRCRT,
       DOC.ATU_EM, DOC.DATINC AS DATINCORI
  FROM TT_COM DOC INNER JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'FUNDO_RURAL_PAG'
                  INNER JOIN TT_VEN VEN ON DOC.CODFIL = VEN.CODFIL
                                       AND DOC.CODSER = VEN.CODSER
                                       AND SUBSTR(DOC.NUMNOT, 4, 6) = VEN.NUMNOT
                                       AND DOC.FILFOR = VEN.FILCLI
                                       AND DOC.CODFOR = VEN.CODCLI
                   LEFT JOIN TT_CTA CTA ON DOC.FILCTA = CTA.CODFIL
                                       AND DOC.SEQCTA = CTA.SEQUEN
                   LEFT JOIN TD_CTA DCRT ON DCRT.CFGCOL = CASE WHEN DOC.TIPNOT='N' THEN
                                                               CASE WHEN DOC.TIPPAR='T' THEN 'FRETES A FATURAR'  -- Conhecimento de Fretes a faturar
                                                                    WHEN DOC.TIPPAR='F' THEN 'COMPRAS A FATURAR' -- Notas de compra a Faturar
                                                                                        ELSE 'TITULOS A FATURAR' -- Titulos a Faturar
                                                               END
                                                          ELSE
                                                               CASE WHEN DOC.TIPPAR='T' THEN 'TIPCTA_FRE_PAG'    -- Fretes a pagar
                                                                    WHEN DOC.TIPPAR='F' THEN 'TIPCTA_FOR_PAG'    -- Fornecedores a pagar
                                                                                        ELSE 'TIPCTA_TIT_PAG'    -- Titulos a pagar
                                                               END
                                                          END
 WHERE DOC.FLGEST <> 'D'
   AND VEN.FUNRUR < 0
--
--   CONTA                                                         CONTRA-PARTIDA
--   -----------------------------------------------------------   ----------------------------------
--   Valor SENAR a Pagar                                           <Fornecedores a Pagar OU Compras a Faturar>
--                                                                 <Ttulos a Pagar OU Titulos a Faturar>
--                                                                 <Fretes a Pagar OU Fretes a Faturar>
--                                                                 <Contas a Pagar>
--
UNION ALL
SELECT CAST('COM' AS VARCHAR(3)) AS ORIGEM,
       DOC.CODFIL, DOC.SEQUEN AS SEQUEN,
       CAST('--' AS CHAR(2)) AS NUMPAR,
       CAST('--' AS CHAR(2)) AS SUBPAR,
       DOC.DATOPE AS DATLAN,
       VEN.SENAR*-1 AS VLRLAN,
       DOC.FILFOR AS FILCLI,
       DOC.CODFOR AS CODCLI,
       CAST('R' AS VARCHAR(1)) AS FLGFLX,
       CAST('CTA' AS CHAR(3)) AS ORICTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.FILCTA ELSE CTA.FILVIN END AS FILCTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.SEQCTA ELSE CTA.SEQVIN END AS SEQCTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.TIPCTA ELSE CTA.TIPVIN END AS TIPCTA,
       DCRT.CODTAB AS CODCTA,
       DCTA.FILCTA AS FILCRT,
       DCTA.SEQCTA AS SEQCRT,
       DCTA.TIPCTA AS TIPCRT,
       CAST('CTA' AS CHAR(3)) AS ORICRT,
       DCTA.CODTAB AS CODCRT,
       CAST('SEN' AS VARCHAR(3)) AS TIPLAN,
       DOC.CODFIL AS FILORI,
       DOC.CODFIL AS FILDES,
       DOC.FILUSU,
       DOC.CODUSU,
       VEN.SENAR*-1 AS VLRCRT,
       DOC.ATU_EM, DOC.DATINC AS DATINCORI
  FROM TT_COM DOC INNER JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'SENAR_PAG'
                  INNER JOIN TT_VEN VEN ON DOC.CODFIL = VEN.CODFIL
                                       AND DOC.CODSER = VEN.CODSER
                                       AND SUBSTR(DOC.NUMNOT, 4, 6) = VEN.NUMNOT
                                       AND DOC.FILFOR = VEN.FILCLI
                                       AND DOC.CODFOR = VEN.CODCLI
                   LEFT JOIN TT_CTA CTA ON DOC.FILCTA = CTA.CODFIL
                                       AND DOC.SEQCTA = CTA.SEQUEN
                   LEFT JOIN TD_CTA DCRT ON DCRT.CFGCOL = CASE WHEN DOC.TIPNOT='N' THEN
                                                               CASE WHEN DOC.TIPPAR='T' THEN 'FRETES A FATURAR'  -- Conhecimento de Fretes a faturar
                                                                    WHEN DOC.TIPPAR='F' THEN 'COMPRAS A FATURAR' -- Notas de compra a Faturar
                                                                                        ELSE 'TITULOS A FATURAR' -- Titulos a Faturar
                                                               END
                                                          ELSE
                                                               CASE WHEN DOC.TIPPAR='T' THEN 'TIPCTA_FRE_PAG'    -- Fretes a pagar
                                                                    WHEN DOC.TIPPAR='F' THEN 'TIPCTA_FOR_PAG'    -- Fornecedores a pagar
                                                                                        ELSE 'TIPCTA_TIT_PAG'    -- Titulos a pagar
                                                               END
                                                          END
 WHERE DOC.FLGEST <> 'D'
   AND VEN.SENAR < 0
--
--   CONTA                                                         CONTRA-PARTIDA
--   -----------------------------------------------------------   ----------------------------------
--   Valor Seguro Rural                                            <Fornecedores a Pagar OU Compras a Faturar>
--                                                                 <Ttulos a Pagar OU Titulos a Faturar>
--                                                                 <Fretes a Pagar OU Fretes a Faturar>
--                                                                 <Contas a Pagar>
--
UNION ALL
SELECT CAST('COM' AS VARCHAR(3)) AS ORIGEM,
       DOC.CODFIL, DOC.SEQUEN AS SEQUEN,
       CAST('--' AS CHAR(2)) AS NUMPAR,
       CAST('--' AS CHAR(2)) AS SUBPAR,
       DOC.DATOPE AS DATLAN,
       VEN.SEGRUR*-1 AS VLRLAN,
       DOC.FILFOR AS FILCLI,
       DOC.CODFOR AS CODCLI,
       CAST('R' AS VARCHAR(1)) AS FLGFLX,
       CAST('CTA' AS CHAR(3)) AS ORICTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.FILCTA ELSE CTA.FILVIN END AS FILCTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.SEQCTA ELSE CTA.SEQVIN END AS SEQCTA,
       CASE WHEN CTA.FILVIN IS NULL OR DOC.TIPNOT = 'F' THEN DCRT.TIPCTA ELSE CTA.TIPVIN END AS TIPCTA,
       DCRT.CODTAB AS CODCTA,
       DCTA.FILCTA AS FILCRT,
       DCTA.SEQCTA AS SEQCRT,
       DCTA.TIPCTA AS TIPCRT,
       CAST('CTA' AS CHAR(3)) AS ORICRT,
       DCTA.CODTAB AS CODCRT,
       CAST('SGR' AS VARCHAR(3)) AS TIPLAN,
       DOC.CODFIL AS FILORI,
       DOC.CODFIL AS FILDES,
       DOC.FILUSU,
       DOC.CODUSU,
       VEN.SEGRUR*-1 AS VLRCRT,
       DOC.ATU_EM, DOC.DATINC AS DATINCORI
  FROM TT_COM DOC INNER JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'SEGRUR_PAG'
                  INNER JOIN TT_VEN VEN ON DOC.CODFIL = VEN.CODFIL
                                       AND DOC.CODSER = VEN.CODSER
                                       AND SUBSTR(DOC.NUMNOT, 4, 6) = VEN.NUMNOT
                                       AND DOC.FILFOR = VEN.FILCLI
                                       AND DOC.CODFOR = VEN.CODCLI
                   LEFT JOIN TT_CTA CTA ON DOC.FILCTA = CTA.CODFIL
                                       AND DOC.SEQCTA = CTA.SEQUEN
                   LEFT JOIN TD_CTA DCRT ON DCRT.CFGCOL = CASE WHEN DOC.TIPNOT='N' THEN
                                                               CASE WHEN DOC.TIPPAR='T' THEN 'FRETES A FATURAR'  -- Conhecimento de Fretes a faturar
                                                                    WHEN DOC.TIPPAR='F' THEN 'COMPRAS A FATURAR' -- Notas de compra a Faturar
                                                                                        ELSE 'TITULOS A FATURAR' -- Titulos a Faturar
                                                               END
                                                          ELSE
                                                               CASE WHEN DOC.TIPPAR='T' THEN 'TIPCTA_FRE_PAG'    -- Fretes a pagar
                                                                    WHEN DOC.TIPPAR='F' THEN 'TIPCTA_FOR_PAG'    -- Fornecedores a pagar
                                                                                        ELSE 'TIPCTA_TIT_PAG'    -- Titulos a pagar
                                                               END
                                                          END
 WHERE DOC.FLGEST <> 'D'
   AND VEN.SEGRUR < 0
;


/*-- SEQ 2902 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RFIN_DOP CASCADE;

/*-- SEQ 2903 --*/
CREATE OR REPLACE VIEW TV_RFIN_DOP AS
--
--   TIPO          CONTA           CONTRA-PARTIDA
--   ------------  -------------   --------------
--   Cheque Troco  <Cheque Troco>  <Tesouraria>
--
SELECT CAST('DOP' AS VARCHAR(3)) AS ORIGEM,
       DOP.CODFIL, DOP.SEQUEN, 
       CAST('--' AS CHAR(2)) AS NUMPAR, 
       CAST('--' AS CHAR(2)) AS SUBPAR, 
       DOP.DATINC AS DATLAN, 
       DOP.VLRDOC AS VLRLAN,
       COALESCE(DOP.FILCLI,(SELECT min(COM.FILFOR)
                              FROM TT_COM COM INNER JOIN TT_PAG PAG ON PAG.CODFIL = COM.CODFIL
                                                                   AND PAG.SEQUEN = COM.SEQUEN
                             WHERE PAG.FILDOP = DOP.CODFIL 
                               AND PAG.SEQDOP = DOP.SEQUEN
                            HAVING MIN(COM.FILFOR||COM.CODFOR)=MAX(COM.FILFOR||COM.CODFOR)),CFG.VC_FILCLI) AS FILCLI, 
       COALESCE(DOP.CODCLI,(SELECT min(COM.CODFOR)
                              FROM TT_COM COM INNER JOIN TT_PAG PAG ON PAG.CODFIL = COM.CODFIL
                                                                   AND PAG.SEQUEN = COM.SEQUEN
                             WHERE PAG.FILDOP = DOP.CODFIL 
                               AND PAG.SEQDOP = DOP.SEQUEN
                            HAVING MIN(COM.FILFOR||COM.CODFOR)=MAX(COM.FILFOR||COM.CODFOR)),CFG.VC_CODCLI) AS CODCLI,
       CAST('R' AS VARCHAR(1)) AS FLGFLX,
       COALESCE(DCOB.FILCTA,DFIL.FIL_CT) AS FILCTA,
       COALESCE(DCOB.SEQCTA,DFIL.SEQ_CT) AS SEQCTA,
       COALESCE(DCOB.TIPCTA,DFIL.TIP_CT) AS TIPCTA,
       CAST('FIL' AS CHAR(3)) AS ORICTA,
       DFIL.CODTAB AS CODCTA,
       CAST('CTA' AS CHAR(3)) AS ORICRT,
       DCRT.FILCTA AS FILCRT,
       DCRT.SEQCTA AS SEQCRT,
       DCRT.TIPCTA AS TIPCRT,
       DCRT.CODTAB AS CODCRT,
       -- Coloca TIPLAN <> 'TRO' se no est compensado, pois ainda no tem contrapartida para validar a consistncia
       CAST( CASE WHEN COALESCE(DSTD.FLGFLX,'R')='R' THEN 'TRO' ELSE 'C-T' END AS CHAR(3)) AS TIPLAN,
       DOP.VLRDOC AS VLRCRT,
       DOP.CODFIL AS FILORI,
       DOP.CODFIL AS FILDES,
       DOP.FILUSU,
       DOP.CODUSU,
       DOP.ATU_EM, DOP.DATINC AS DATINCORI
  FROM TT_CFG CFG, 
       TT_DOP DOP LEFT JOIN TD_CTA DCRT ON DCRT.CFGCOL = 'CHEQUE TROCO'
                  LEFT JOIN TD_FIL DFIL ON DFIL.CODFIL = DOP.CODFIL
                  LEFT JOIN TD_STD DSTD ON DOP.DOMDOP = DSTD.DOMDOP 
                                       AND DOP.STDDOP = DSTD.CODTAB
                                       AND DOP.FLGEST = DSTD.USOSTD
                  LEFT JOIN TD_COB DCOB ON DOP.PORORI = DCOB.CODTAB
 WHERE DOP.FLGEST <> 'C' 
   AND COALESCE(DOP.CHETRO,'F') = 'T'
UNION ALL
--
--   TIPO      CONTA                CONTRA-PARTIDA
--   --------  -------------        ---------------------------
--   Qualquer  <Conta especificada> <Pagamentos / Cheque Troco>
--
SELECT DISTINCT 
       CAST('DOP' AS VARCHAR(3)) AS ORIGEM,
       DOP.CODFIL, DOP.SEQUEN, 
       CAST('--' AS CHAR(2)) AS NUMPAR, 
       CAST('--' AS CHAR(2)) AS SUBPAR, 
       DOP.DATPGT AS DATLAN,
       DOP.VLRDOC AS VLRLAN,
       COALESCE(DOP.FILCLI,(SELECT min(COM.FILFOR)
                              FROM TT_COM COM INNER JOIN TT_PAG PAG ON PAG.CODFIL = COM.CODFIL
                                                                   AND PAG.SEQUEN = COM.SEQUEN
                             WHERE PAG.FILDOP = DOP.CODFIL 
                               AND PAG.SEQDOP = DOP.SEQUEN
                            HAVING MIN(COM.FILFOR||COM.CODFOR)=MAX(COM.FILFOR||COM.CODFOR)),CFG.VC_FILCLI) AS FILCLI, 
       COALESCE(DOP.CODCLI,(SELECT min(COM.CODFOR)
                              FROM TT_COM COM INNER JOIN TT_PAG PAG ON PAG.CODFIL = COM.CODFIL
                                                                   AND PAG.SEQUEN = COM.SEQUEN
                             WHERE PAG.FILDOP = DOP.CODFIL 
                               AND PAG.SEQDOP = DOP.SEQUEN
                            HAVING MIN(COM.FILFOR||COM.CODFOR)=MAX(COM.FILFOR||COM.CODFOR)),CFG.VC_CODCLI) AS CODCLI,
       CAST( COALESCE(DSTD.FLGFLX,'R') AS VARCHAR(1)) AS FLGFLX,
       CASE WHEN CCC.CODFIL IS NOT NULL AND DOP.FILCTA IS NOT NULL THEN DCTAC.FILCTA ELSE DCTA.FILCTA END AS FILCRT,
       CASE WHEN CCC.CODFIL IS NOT NULL AND DOP.FILCTA IS NOT NULL THEN DCTAC.SEQCTA ELSE DCTA.SEQCTA END AS SEQCRT,
       CASE WHEN CCC.CODFIL IS NOT NULL AND DOP.FILCTA IS NOT NULL THEN DCTAC.TIPCTA ELSE DCTA.TIPCTA END AS TIPCRT,
       CAST('DOP' AS CHAR(3)) AS ORICTA,
       CAST(0 AS Numeric(5)) AS CODCTA,
       CAST('CTA' AS CHAR(3)) AS ORICRT,
       COALESCE(DOP.FILCTA,DCTAC.FILCTA) AS FILCRT,
       COALESCE(DOP.SEQCTA,DCTAC.SEQCTA) AS SEQCRT,
       COALESCE(DOP.TIPCTA,DCTAC.TIPCTA) AS TIPCRT,
       DCTA.CODTAB AS CODCRT,
       CAST( CASE WHEN COALESCE(DOP.CHETRO,'F') = 'F' THEN 'DOP' ELSE 'TRO' END AS CHAR(3)) AS TIPLAN,
       CASE WHEN COALESCE(DOP.CHETRO,'F') = 'T' OR CCC.CODFIL IS NOT NULL
            THEN DOP.VLRDOC
            ELSE (SELECT SUM(COALESCE(PAG.VLRPGT,0))
                  FROM TT_PAG PAG
                  WHERE PAG.FILDOP = DOP.CODFIL 
                    AND PAG.SEQDOP = DOP.SEQUEN)
       END AS VLRCRT,
       DOP.CODFIL AS FILORI,
       DOP.CODFIL AS FILDES,
       DOP.FILUSU,
       DOP.CODUSU,
       DOP.ATU_EM, DOP.DATINC AS DATINCORI
FROM TT_CFG CFG, 
     TT_DOP DOP LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL = CASE WHEN COALESCE(DOP.CHETRO,'F') = 'T'
                                                            THEN 'CHEQUE TROCO'
                                                            ELSE 'PAGAMENTOS'
                                                       END
                LEFT JOIN TD_STD DSTD ON DOP.DOMDOP = DSTD.DOMDOP 
                                     AND DOP.STDDOP = DSTD.CODTAB
                                     AND DOP.FLGEST = DSTD.USOSTD
                LEFT  JOIN TD_CTA DCTAC ON DCTAC.CFGCOL='CHEQUE_FORNEC'
                LEFT  JOIN TT_CCC CCC ON CCC.FILDOP=DOP.CODFIL AND CCC.SEQDOP=DOP.SEQUEN
WHERE DOP.FLGEST <> 'C' 
  AND ( ( COALESCE(DOP.CHETRO,'F') = 'T' AND COALESCE(DSTD.FLGFLX,'R')='R' ) OR 
        ( COALESCE(DOP.CHETRO,'F') = 'F') )
  AND ((SELECT COUNT(*)
          FROM TT_PAG PAG
         WHERE PAG.FILDOP=DOP.CODFIL 
           AND PAG.SEQDOP=DOP.SEQUEN
        )>1 OR 
        COALESCE(DOP.CHETRO,'F') = 'T' OR 
        (SELECT COUNT(*)
          FROM TT_PAG PAG
         WHERE PAG.FILDOP=DOP.CODFIL 
           AND PAG.SEQDOP=DOP.SEQUEN
           AND trunc(pag.datpgt)<>trunc(dop.datpgt)
        )>0 OR   
        DSTD.FLGFLX='A' OR
        (CCC.CODFIL IS NOT NULL and
        (SELECT COUNT(*)
           FROM TT_PAG PAG
          WHERE PAG.FILDOP=DOP.CODFIL 
            AND PAG.SEQDOP=DOP.SEQUEN
          )=0
        )
       )   
;


/*-- SEQ 2904 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RFIN_EST CASCADE;

/*-- SEQ 2905 --*/
CREATE OR REPLACE VIEW TV_RFIN_EST AS
SELECT CAST('EST' AS VARCHAR(3)) AS ORIGEM,
       SUBSTR(CTAMOV,01,03)       AS FILCTA,
       SUBSTR(CTAMOV,04,10)       AS SEQCTA,
       SUBSTR(CTAMOV,14,01)       AS TIPCTA,
       SUBSTR(CTAMOV,15,03)       AS ORICTA,
       SUBSTR(CTACON,01,03)       AS FILCRT,
       SUBSTR(CTACON,04,10)       AS SEQCRT,
       SUBSTR(CTACON,14,01)       AS TIPCRT,
       SUBSTR(CTACON,15,03)       AS ORICRT,
       TO_NUMBER(SUBSTR(CTACON,19,05)) AS CODCRT,
       TO_NUMBER(SUBSTR(CTAMOV,19,05)) AS CODCTA,
       CODFIL, SEQUEN, NUMPAR, SUBPAR,
       DATLAN, VLRLAN, FILCLI, CODCLI,
       FLGFLX, TIPLAN,
       COALESCE(VLRCRT,VLRLAN) AS VLRCRT,
       CODFIL AS FILORI,
       FILLAN AS FILDES,
       FILUSU,CODUSU,
       ATU_EM, DATINC AS DATINCORI
FROM (
--   Tratamento de estoque para itens de compra
--
--   TIPO     CONTA                                         CONTRA-PARTIDA
--   -------  --------------------------------------------  -------------------------------------
--   ICO      <Estoque para Compra do Produto> ou           <Estoque para Compra do Produto> ou
--            <Custo de Mercadoria para Compra>             <Estoque>
      SELECT ICO.CODFIL AS CODFIL, COM.DATSTR AS SEQUEN, CAST('--' AS CHAR(2)) AS NUMPAR, CAST('--' AS CHAR(2)) AS SUBPAR,
             ICO.CODFIL AS FILLAN,
             TRUNC(COM.DATOPE) AS DATLAN,
             SUM(ICO.VLR_CM) AS VLRLAN,
             CFG.VC_FILCLI AS FILCLI,
             CFG.VC_CODCLI AS CODCLI,
             CAST('R' AS VARCHAR(1)) AS FLGFLX,
             CASE WHEN PRO.FILCTA_COMEST IS NOT NULL THEN
                       PRO.FILCTA_COMEST || PRO.SEQCTA_COMEST || PRO.TIPCTA_COMEST || 'PRO' || TO_CHAR(DCUS.CODTAB,'99999')
                  ELSE DCUS.FILCTA || DCUS.SEQCTA || DCUS.TIPCTA || 'DCU' || TO_CHAR(DCUS.CODTAB,'99999')
             END AS CTAMOV,             
             CASE WHEN PRO.FILCTA_COMEST IS NOT NULL THEN
                  CASE WHEN CTAP.FILVIN IS NULL THEN
                     ESTQ.FILCTA || ESTQ.SEQCTA || ESTQ.TIPCTA || 'EST' || TO_CHAR(ESTQ.CODTAB,'99999') 
                  ELSE
                     CTAP.FILVIN || CTAP.SEQVIN || CTAP.TIPVIN || 'CPV' || TO_CHAR(0,'99999')
                  END     
             ELSE
                  CASE WHEN CTAD.FILVIN IS NULL THEN
                     ESTQ.FILCTA || ESTQ.SEQCTA || ESTQ.TIPCTA || 'EST' || TO_CHAR(ESTQ.CODTAB,'99999')
                  ELSE 
                     CTAD.FILVIN || CTAD.SEQVIN || CTAD.TIPVIN || 'CDV' || TO_CHAR(0,'99999') 
                  END 
             END AS CTACON,
             CAST('ICO' AS VARCHAR(3)) AS TIPLAN,
             SUM(ICO.VLR_CM) AS VLRCRT,
             USU.FILUSU,
             USU.CODUSU,
             TRUNC(COM.DATOPE) AS ATU_EM, TRUNC(COM.DATOPE) AS DATINC
      FROM TT_ICO ICO INNER JOIN TT_GRA GRA ON ICO.FILMAT=GRA.FILMAT AND ICO.CODMAT=GRA.CODMAT AND ICO.CODCOR=GRA.CODCOR AND ICO.CODTAM=GRA.CODTAM
                      INNER JOIN TT_PRO PRO ON PRO.FILMAT=GRA.FILMAT AND PRO.CODMAT=GRA.CODMAT
                      INNER JOIN TT_SAL SAL ON ICO.CODFIL=SAL.CODFIL
                                           AND ICO.FILMAT=SAL.FILMAT
                                           AND ICO.CODMAT=SAL.CODMAT
                                           AND ICO.CODCOR=SAL.CODCOR
                                           AND ICO.CODTAM=SAL.CODTAM
                                           AND SAL.CODMUL=0
                      INNER JOIN TT_COM COM ON COM.CODFIL = ICO.CODFIL AND COM.SEQUEN = ICO.SEQUEN
                      INNER JOIN TT_USU USU ON USU.APEUSU = QUALDONO()
                      LEFT  JOIN TD_CTA DCUS ON DCUS.CFGCOL = 'CUS_MER_ADQ'
                      LEFT  JOIN TD_CTA ESTQ ON ESTQ.CFGCOL = 'ESTOQUE'
                      LEFT  JOIN TT_CTA CTAP ON CTAP.CODFIL = PRO.FILCTA_COMEST
                                            AND CTAP.SEQUEN = PRO.SEQCTA_COMEST 
                                            AND CTAP.TIPCTA = PRO.TIPCTA_COMEST
                      LEFT  JOIN TT_CTA CTAD ON CTAD.CODFIL = DCUS.FILCTA
                                            AND CTAD.SEQUEN = DCUS.SEQCTA
                                            AND CTAD.TIPCTA = DCUS.TIPCTA
                      CROSS JOIN TT_CFG CFG
     WHERE ICO.SITMOV<>'C'
       AND ICO.LANEST IN ('S','C')
       AND ICO.COM_DATOPE>=CASE WHEN SAL.INI_CM IS NULL THEN TO_DATE('01/01/1800','DD/MM/YYYY')
                                ELSE ADD_DAY(SAL.INI_CM,1)
                           END
   GROUP BY ICO.CODFIL,  TRUNC(COM.DATOPE), COM.DATSTR,
         CASE WHEN PRO.FILCTA_COMEST IS NOT NULL THEN
                       PRO.FILCTA_COMEST || PRO.SEQCTA_COMEST || PRO.TIPCTA_COMEST || 'PRO' || TO_CHAR(DCUS.CODTAB,'99999')
                  ELSE DCUS.FILCTA || DCUS.SEQCTA || DCUS.TIPCTA || 'DCU' || TO_CHAR(DCUS.CODTAB,'99999')
             END,
         CASE WHEN PRO.FILCTA_COMEST IS NOT NULL THEN
              CASE WHEN CTAP.FILVIN IS NULL THEN
                 ESTQ.FILCTA || ESTQ.SEQCTA || ESTQ.TIPCTA || 'EST' || TO_CHAR(ESTQ.CODTAB,'99999') 
              ELSE
                 CTAP.FILVIN || CTAP.SEQVIN || CTAP.TIPVIN || 'CPV' || TO_CHAR(0,'99999') 
              END     
         ELSE
              CASE WHEN CTAD.FILVIN IS NULL THEN
                 ESTQ.FILCTA || ESTQ.SEQCTA || ESTQ.TIPCTA || 'EST' || TO_CHAR(ESTQ.CODTAB,'99999')
              ELSE 
                 CTAD.FILVIN || CTAD.SEQVIN || CTAD.TIPVIN || 'CDV' || TO_CHAR(0,'99999') 
              END 
         END,
         USU.FILUSU,
         USU.CODUSU,
         CFG.VC_FILCLI,CFG.VC_CODCLI
	UNION ALL
--   Tratamento de estoque para itens de venda
--
--   TIPO     CONTA                                         CONTRA-PARTIDA
--   -------  --------------------------------------------  -------------------------------------
--   IVE      <Estoque para Venda do Produto> ou            <Vinculada a Estoque para Venda do Produto> ou
--            <Custo de Mercadoria para Venda>              <Estoque>
      SELECT IVE.CODFIL AS CODFIL, VEN.DATSTR AS SEQUEN, CAST('--' AS CHAR(2)) AS NUMPAR, CAST('--' AS CHAR(2)) AS SUBPAR,
             IVE.CODFIL AS FILLAN,
             TRUNC(VEN.DATHOR) AS DATLAN,
             SUM(ROUND(CASE IVE.SAL_CM WHEN 0 THEN 0
                                       ELSE IVE.TOTCMG / IVE.SAL_CM
                       END * COALESCE(IVE.QTDMOV,0),2)*-1) AS VLRLAN,
             CFG.VC_FILCLI AS FILCLI,
             CFG.VC_CODCLI AS CODCLI,
             CAST('R' AS VARCHAR(1)) AS FLGFLX,
             CASE WHEN PRO.FILCTA_VENEST IS NOT NULL THEN
                       PRO.FILCTA_VENEST || PRO.SEQCTA_VENEST || PRO.TIPCTA_VENEST || 'PRO' || TO_CHAR(DCUS.CODTAB,'99999')
                  ELSE DCUS.FILCTA || DCUS.SEQCTA || DCUS.TIPCTA || 'DCU' || TO_CHAR(DCUS.CODTAB,'99999')
             END AS CTAMOV,             
             CASE WHEN PRO.FILCTA_COMEST IS NOT NULL THEN
                  CASE WHEN CTAP.FILVIN IS NULL THEN
                     ESTQ.FILCTA || ESTQ.SEQCTA || ESTQ.TIPCTA || 'EST' || TO_CHAR(ESTQ.CODTAB,'99999') 
                  ELSE
                     CTAP.FILVIN || CTAP.SEQVIN || CTAP.TIPVIN || 'CPV' || TO_CHAR(0,'99999') 
                  END     
             ELSE
                  CASE WHEN CTAD.FILVIN IS NULL THEN
                     ESTQ.FILCTA || ESTQ.SEQCTA || ESTQ.TIPCTA || 'EST' || TO_CHAR(ESTQ.CODTAB,'99999')
                  ELSE 
                     CTAD.FILVIN || CTAD.SEQVIN || CTAD.TIPVIN || 'CDV' || TO_CHAR(0,'99999') 
                  END 
             END AS CTACON,             
             CAST('IVE' AS VARCHAR(3)) AS TIPLAN,
             SUM(ROUND(CASE IVE.SAL_CM WHEN 0 THEN 0
                                       ELSE IVE.TOTCMG / IVE.SAL_CM
                       END * COALESCE(IVE.QTDMOV,0),2)*-1) AS VLRCRT,
             USU.FILUSU,
             USU.CODUSU,
             TRUNC(VEN.DATHOR) AS ATU_EM, TRUNC(VEN.DATHOR) AS DATINC
      FROM TT_IVE IVE INNER JOIN TT_GRA GRA ON IVE.FILMAT=GRA.FILMAT AND IVE.CODMAT=GRA.CODMAT AND IVE.CODCOR=GRA.CODCOR AND IVE.CODTAM=GRA.CODTAM
                      INNER JOIN TT_PRO PRO ON PRO.FILMAT=GRA.FILMAT AND PRO.CODMAT=GRA.CODMAT
                      INNER JOIN TT_SAL SAL ON IVE.CODFIL=SAL.CODFIL
                                           AND IVE.FILMAT=SAL.FILMAT
                                           AND IVE.CODMAT=SAL.CODMAT
                                           AND IVE.CODCOR=SAL.CODCOR
                                           AND IVE.CODTAM=SAL.CODTAM
                                           AND SAL.CODMUL=0
                      INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN
                      INNER JOIN TT_USU USU  ON USU.APEUSU = QUALDONO()
                      LEFT  JOIN TD_CTA DCUS ON DCUS.CFGCOL = 'CUS_MER_VEN'
                      LEFT  JOIN TD_CTA ESTQ ON ESTQ.CFGCOL = 'ESTOQUE'
                      LEFT  JOIN TT_CTA CTAP ON CTAP.CODFIL = PRO.FILCTA_VENEST
                                            AND CTAP.SEQUEN = PRO.SEQCTA_VENEST 
                                            AND CTAP.TIPCTA = PRO.TIPCTA_VENEST
                      LEFT  JOIN TT_CTA CTAD ON CTAD.CODFIL = DCUS.FILCTA
                                            AND CTAD.SEQUEN = DCUS.SEQCTA
                                            AND CTAD.TIPCTA = DCUS.TIPCTA
                      CROSS JOIN TT_CFG CFG
     WHERE IVE.SITMOV<>'C'
       AND IVE.LANEST IN ('S','C')
       AND IVE.SITKIT<>'1'
       AND IVE.VEN_DATHOR>=CASE WHEN SAL.INI_CM IS NULL THEN TO_DATE('01/01/1800','DD/MM/YYYY')
                                ELSE ADD_DAY(SAL.INI_CM,1)
                           END
GROUP BY IVE.CODFIL, TRUNC(VEN.DATHOR), VEN.DATSTR,
         CASE WHEN PRO.FILCTA_VENEST IS NOT NULL THEN
                       PRO.FILCTA_VENEST || PRO.SEQCTA_VENEST || PRO.TIPCTA_VENEST || 'PRO' || TO_CHAR(DCUS.CODTAB,'99999')
                  ELSE DCUS.FILCTA || DCUS.SEQCTA || DCUS.TIPCTA || 'DCU' || TO_CHAR(DCUS.CODTAB,'99999')
             END,
         CASE WHEN PRO.FILCTA_COMEST IS NOT NULL THEN
              CASE WHEN CTAP.FILVIN IS NULL THEN
                 ESTQ.FILCTA || ESTQ.SEQCTA || ESTQ.TIPCTA || 'EST' || TO_CHAR(ESTQ.CODTAB,'99999') 
              ELSE
                 CTAP.FILVIN || CTAP.SEQVIN || CTAP.TIPVIN || 'CPV' || TO_CHAR(0,'99999') 
              END     
         ELSE
              CASE WHEN CTAD.FILVIN IS NULL THEN
                 ESTQ.FILCTA || ESTQ.SEQCTA || ESTQ.TIPCTA || 'EST' || TO_CHAR(ESTQ.CODTAB,'99999')
              ELSE 
                 CTAD.FILVIN || CTAD.SEQVIN || CTAD.TIPVIN || 'CDV' || TO_CHAR(0,'99999') 
              END 
         END,
         USU.FILUSU,
         USU.CODUSU,
		 CFG.VC_FILCLI,CFG.VC_CODCLI
UNION ALL
--   Tratamento de estoque para lanamentos avulsos de estoque
--
--   TIPO     CONTA                                         CONTRA-PARTIDA
--   -------  --------------------------------------------  -------------------------------------
--   LAN      <Custo Mercadorias Produzidas> ou             <Estoque>
--            <Custo Mercadorias Consumidas>
      SELECT LAN.CODFIL AS CODFIL, LAN.DATSTR AS SEQUEN, CAST('--' AS CHAR(2)) AS NUMPAR, CAST('--' AS CHAR(2)) AS SUBPAR,
             LAN.CODFIL AS FILLAN,
             TRUNC(LAN.DATMOV) AS DATLAN,
             SUM(LAN.VLRMOV) AS VLRLAN,
             CFG.VC_FILCLI AS FILCLI,
             CFG.VC_CODCLI AS CODCLI,
             CAST('R' AS VARCHAR(1)) AS FLGFLX,
             CASE WHEN LAN.QTDMOV>0 THEN
                       DPRO.FILCTA || DPRO.SEQCTA || DPRO.TIPCTA || 'PRO' || TO_CHAR(DPRO.CODTAB,'99999')
                  ELSE DCON.FILCTA || DCON.SEQCTA || DCON.TIPCTA || 'CON' || TO_CHAR(DCON.CODTAB,'99999')
             END AS CTAMOV,
             ESTQ.FILCTA || ESTQ.SEQCTA || ESTQ.TIPCTA || 'EST' || TO_CHAR(ESTQ.CODTAB,'99999') AS CTACON,
             CAST('LAN' AS VARCHAR(3)) AS TIPLAN,
             SUM(LAN.VLRMOV) AS VLRCRT,
             USU.FILUSU,
             USU.CODUSU,
             TRUNC(LAN.DATMOV) AS ATU_EM, TRUNC(LAN.DATMOV) AS DATINC
      FROM TT_LAN LAN INNER JOIN TD_LAN DLAN ON LAN.TIPLAN=DLAN.CODTAB
                      INNER JOIN TT_USU USU  ON USU.APEUSU = QUALDONO()
                      INNER JOIN TT_SAL SAL ON LAN.CODFIL=SAL.CODFIL
                                           AND LAN.FILMAT=SAL.FILMAT
                                           AND LAN.CODMAT=SAL.CODMAT
                                           AND LAN.CODCOR=SAL.CODCOR
                                           AND LAN.CODTAM=SAL.CODTAM
                                           AND SAL.CODMUL=0
                      LEFT  JOIN TD_CTA DCON ON DCON.CFGCOL = 'CUS_MER_CON'
                      LEFT  JOIN TD_CTA DPRO ON DPRO.CFGCOL = 'CUS_MER_PROD'
                      LEFT  JOIN TD_CTA ESTQ ON ESTQ.CFGCOL = 'ESTOQUE'
                      CROSS JOIN TT_CFG CFG
     WHERE LAN.SITMOV<>'C'
       AND DLAN.MOVLEG='T'
       AND LAN.DATMOV>=CASE WHEN SAL.INI_CM IS NULL THEN TO_DATE('01/01/1800','DD/MM/YYYY')
                                ELSE ADD_DAY(SAL.INI_CM,1)
                           END
GROUP BY LAN.CODFIL, TRUNC(LAN.DATMOV), LAN.DATSTR,
         CASE WHEN LAN.QTDMOV>0 THEN
                       DPRO.FILCTA || DPRO.SEQCTA || DPRO.TIPCTA || 'PRO' || TO_CHAR(DPRO.CODTAB,'99999')
                  ELSE DCON.FILCTA || DCON.SEQCTA || DCON.TIPCTA || 'CON' || TO_CHAR(DCON.CODTAB,'99999')
         END,
         ESTQ.FILCTA || ESTQ.SEQCTA || ESTQ.TIPCTA || 'EST' || TO_CHAR(ESTQ.CODTAB,'99999'),
         USU.FILUSU,
         USU.CODUSU,
         CFG.VC_FILCLI,CFG.VC_CODCLI
) TAB
;


/*-- SEQ 2906 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RFIN_FIN CASCADE;

/*-- SEQ 2907 --*/
CREATE OR REPLACE VIEW TV_RFIN_FIN AS
SELECT CAST('FIN' AS VARCHAR(3)) AS ORIGEM,
       CAST('--' AS CHAR(2))      AS NUMPAR,
       CAST('--' AS CHAR(2))      AS SUBPAR,
       CAST('FIN' AS VARCHAR(3)) AS ORICTA,
       CAST('FIN' AS VARCHAR(3)) AS ORICRT,
       INT.TIPLAN,
       CAST(0 AS Numeric(5))       AS CODCTA,
       CAST(0 AS Numeric(5))       AS CODCRT,
       CAST('R' AS VARCHAR(1))   AS FLGFLX,
       CASE WHEN (INT.FILCCC IS NOT NULL) AND (INT.SEQCCC IS NOT NULL)
            THEN (SELECT CCC.FILCLI
                  FROM TT_CCC CCC
                  WHERE CCC.CODFIL = INT.FILCCC
                    AND CCC.SEQUEN = INT.SEQCCC)
            ELSE CFG.VC_FILCLI
       END AS FILCLI,
       CASE WHEN (INT.FILCCC IS NOT NULL) AND (INT.SEQCCC IS NOT NULL)
            THEN (SELECT CCC.CODCLI
                  FROM TT_CCC CCC
                  WHERE CCC.CODFIL = INT.FILCCC
                    AND CCC.SEQUEN = INT.SEQCCC)
            ELSE CFG.VC_CODCLI
       END AS CODCLI,
       INT.VLRLAN                 AS VLRCRT,
       INT.FILORI,
       INT.FILDES,
       INT.FILCTA, INT.SEQCTA, INT.TIPCTA,
       INT.FILCRT, INT.SEQCRT, INT.TIPCRT,
       INT.CODFIL, INT.SEQUEN, INT.DATLAN,
       INT.VLRLAN,
       INT.FILUSU,
       INT.CODUSU,
       INT.ATU_EM, INT.DATINC AS DATINCORI,
       ORICTA_CODEXT,
       DESCTA_CODEXT
FROM TT_CFG CFG,
     (SELECT FIN.CODFIL,
             FIN.SEQUEN,
             CAST('FIN' AS VARCHAR(3)) AS TIPLAN,
             FIN.FILCCC, FIN.SEQCCC,
             FIN.DATFIS    AS DATLAN,
             ROUND(MTOM(FIN.CODMOE,0,FIN.DATFIS,FIN.VLRMOV),2) AS VLRLAN,
             FIN.CODFIL    AS FILLAN,
             COALESCE(CTA1.CODFIL, CTA2.CODFIL, CTA3.CODFIL, CTA4.CODFIL) AS FILCRT,
             COALESCE(CTA1.SEQUEN, CTA2.SEQUEN, CTA3.SEQUEN, CTA4.SEQUEN) AS SEQCRT,
             COALESCE(CTA1.TIPCTA, CTA2.TIPCTA, CTA3.TIPCTA, CTA4.TIPCTA) AS TIPCRT,
             FIN.FILNUM    AS FILCTA,
             FIN.SEQNUM    AS SEQCTA,
             FIN.TIPNUM    AS TIPCTA,
             FIN.FILUSU,
             FIN.CODUSU,
             COALESCE(CTA.FILNUM, FIN.FILREC, FIN.CODFIL) AS FILORI,
             COALESCE(CTA1.FILNUM, CTA2.FILNUM, CTA3.FILNUM, CTA4.FILNUM, FIN.CODFIL) AS FILDES,
             FIN.ATU_EM, FIN.DATINC,
             CTA.CODEXT AS ORICTA_CODEXT,
             CTA1.CODEXT AS DESCTA_CODEXT
      FROM TT_FIN FIN INNER JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'TRANSF TRANSITO'
                      INNER JOIN TD_CTA DCTAX ON DCTAX.CFGCOL='TAXA_TRO_CHEQUE'
                      INNER JOIN TT_CTA CTA ON CTA.CODFIL=FIN.FILNUM AND CTA.SEQUEN=FIN.SEQNUM AND CTA.TIPCTA=FIN.TIPNUM -- RFMP 88898
                       LEFT JOIN TT_OPE OPE ON FIN.CODFIL=OPE.FILFIN AND FIN.SEQUEN=OPE.SEQFIN
                       LEFT JOIN TD_CAI DCAI ON OPE.CODCAI=DCAI.CODTAB
                       LEFT JOIN TT_FIN CRT ON CRT.CODFIL = FIN.CODFIL AND CRT.SEQTRN = FIN.SEQUEN
                       -- RFMP 88898 Tratamento para pegar FILNUM da CTA de contrapartida
                       -- Para evitar que as regras ficassem espalhadas utilizou-se dessa tcnica
                       LEFT JOIN TT_CTA CTA1 ON CTA1.CODFIL=FIN.FILGER  AND CTA1.SEQUEN=FIN.SEQGER  AND CTA1.TIPCTA=FIN.TIPGER
                                            AND FIN.TIPGER <> 'M'
                       LEFT JOIN TT_CTA CTA2 ON CTA2.CODFIL=DCAI.FILCAI AND CTA2.SEQUEN=DCAI.SEQCAI AND CTA2.TIPCTA=DCAI.TIPCAI
                                            AND FIN.TIPGER = 'M'
                                            AND DCAI.FILCAI IS NOT NULL
                       LEFT JOIN TT_CTA CTA3 ON CTA3.CODFIL=DCTA.FILCTA AND CTA3.SEQUEN=DCTA.SEQCTA AND CTA3.TIPCTA=DCTA.TIPCTA
                                            AND FIN.TIPGER = 'M'
                                            AND DCAI.FILCAI IS NULL
                                            AND (SELECT CFG2.USA_CTA_TRANSITO_TRANSF_IDENT FROM TT_CFG CFG2) = 'T'
                       LEFT JOIN TT_CTA CTA4 ON CTA4.CODFIL=CRT.FILNUM  AND CTA4.SEQUEN=CRT.SEQNUM  AND CTA4.TIPCTA=CRT.TIPNUM
                                            AND FIN.TIPGER = 'M'
                                            AND DCAI.FILCAI IS NULL
                                            AND (SELECT CFG2.USA_CTA_TRANSITO_TRANSF_IDENT FROM TT_CFG CFG2) <> 'T'
      WHERE FIN.TIPGER || FIN.FLGFIN <> 'MS' -- No pega transferencia simples
        AND FIN.SEQCHR IS NULL
        AND FIN.SEQTRN IS NULL               -- Primeiro lanamento transf. idenf ou lanamento avulsos
        AND ((DCTA.FILCTA<>FIN.FILGER OR DCTA.SEQCTA<>FIN.SEQGER) OR -- Tratar a troca de cheque e taxa de troca
             (SELECT COUNT(*)
                FROM TT_OPE OFIN INNER JOIN TT_OPE OCHR ON OFIN.CODFIL=OCHR.CODFIL AND OFIN.NUMECF=OCHR.NUMECF AND OFIN.TRN_ID=OCHR.TRN_ID
                                 INNER JOIN TT_CHR CHR ON OCHR.FILCHR=CHR.CODFIL AND OCHR.SEQCHR=CHR.SEQUEN
                                 LEFT JOIN TT_REC REC ON REC.FILREC=CHR.CODFIL AND REC.SEQCHE=CHR.SEQUEN
               WHERE REC.CODFIL IS NULL
                 AND OFIN.FILFIN=FIN.CODFIL
                 AND OFIN.SEQFIN=FIN.SEQUEN
              )=0
            )
        --RFMP 89931 Regra comentada porque o select no trs apenas movimentaes para conta em trnsito    
        --AND ((SELECT CFG2.USA_CTA_TRANSITO_TRANSF_IDENT FROM TT_CFG CFG2) = 'T' OR  -- Ignora conta em trnsito e mostra
        --   COALESCE(CRT.FLGFIN,'A') = 'R')             -- diretamente a conta que recebeu
        AND ((SELECT CFG2.USA_CTA_TRANSITO_TRANSF_IDENT FROM TT_CFG CFG2) = 'T' OR  -- Mostra conta em trnsito
             CRT.CODFIL IS NULL OR                       -- Se no tem outro lanamento  sinal que no h conta em trnsito
             FIN.FLGFIN = 'S' OR                         -- Transferncia simples no tem conta em trnsito
             COALESCE(CRT.FLGFIN,'A') = 'R')             -- S mostra depois que efetivou a operao
      UNION ALL
      SELECT FIN.CODFIL,
             FIN.SEQTRN,
             CAST('TRN' AS VARCHAR(3)) AS TIPLAN,
             FIN.FILCCC, FIN.SEQCCC,
             FIN.DATFIS    AS DATLAN,
             ROUND(MTOM(FIN.CODMOE,0,FIN.DATFIS,FIN.VLRMOV),2)    AS VLRLAN,
             FIN.CODFIL    AS FILLAN,
             COALESCE(CTA1.CODFIL, CTA2.CODFIL, CTA3.CODFIL) AS FILCRT,
             COALESCE(CTA1.SEQUEN, CTA2.SEQUEN, CTA3.SEQUEN) AS SEQCRT,
             COALESCE(CTA1.TIPCTA, CTA2.TIPCTA, CTA3.TIPCTA) AS TIPCRT,
             FIN.FILNUM    AS FILCTA,
             FIN.SEQNUM    AS SEQCTA,
             FIN.TIPNUM    AS TIPCTA,
             FIN.FILUSU,
             FIN.CODUSU,
             COALESCE(CTA.FILNUM,FIN.FILREC,FIN.CODFIL) AS FILORI,
             COALESCE(CTA1.FILNUM, CTA2.FILNUM, CTA3.FILNUM, FIN.CODFIL) AS FILDES,
             FIN.ATU_EM, FIN.DATINC,
             CTA.CODEXT AS ORICTA_CODEXT,
             CTA1.CODEXT AS DESCTA_CODEXT
      FROM TT_FIN FIN INNER JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'TRANSF TRANSITO'
                      INNER JOIN TT_CTA CTA ON CTA.CODFIL=FIN.FILNUM AND CTA.SEQUEN=FIN.SEQNUM AND CTA.TIPCTA=FIN.TIPNUM -- RFMP 88898
                       LEFT JOIN TT_OPE OPE ON FIN.CODFIL=OPE.FILFIN AND FIN.SEQTRN=OPE.SEQFIN
                       LEFT JOIN TD_CAI DCAI ON OPE.CODCAI=DCAI.CODTAB
                       -- RFMP 88898 Tratamento para pegar FILNUM da CTA de contrapartida
                       -- Para evitar que as regras ficassem espalhadas utilizou-se dessa tcnica
                       LEFT JOIN TT_CTA CTA1 ON CTA1.CODFIL=FIN.FILGER  AND CTA1.SEQUEN=FIN.SEQGER  AND CTA1.TIPCTA=FIN.TIPGER
                                            AND FIN.TIPGER <> 'M'
                       LEFT JOIN TT_CTA CTA2 ON CTA2.CODFIL=DCAI.FILCAI AND CTA2.SEQUEN=DCAI.SEQCAI AND CTA2.TIPCTA=DCAI.TIPCAI
                                            AND FIN.TIPGER = 'M'
                                            AND DCAI.FILCAI IS NOT NULL
                       LEFT JOIN TT_CTA CTA3 ON CTA3.CODFIL=DCTA.FILCTA AND CTA3.SEQUEN=DCTA.SEQCTA AND CTA3.TIPCTA=DCTA.TIPCTA
                                            AND FIN.TIPGER = 'M'
                                            AND DCAI.FILCAI IS NULL
      WHERE FIN.TIPGER || FIN.FLGFIN <> 'MS' -- No pega transferencia simples
        AND FIN.SEQCHR IS NULL
        AND FIN.SEQTRN IS NOT NULL           -- Segundo lanamento transf. idenf
        AND (SELECT CFG2.USA_CTA_TRANSITO_TRANSF_IDENT FROM TT_CFG CFG2) = 'T' -- Ignora conta em trnsito
      UNION ALL
      SELECT ORI.CODFIL,
             ORI.SEQUEN,
             CAST('SIM' AS VARCHAR(3)) AS TIPLAN,
             ORI.FILCCC, ORI.SEQCCC,
             ORI.DATFIS    AS DATLAN,
             ROUND(MTOM(ORI.CODMOE,0,ORI.DATFIS,ORI.VLRMOV),2)    AS VLRLAN,
             ORI.CODFIL    AS FILLAN,
             DES.FILNUM    AS FILCRT,
             DES.SEQNUM    AS SEQCRT,
             DES.TIPNUM    AS TIPCRT,
             ORI.FILNUM    AS FILCTA,
             ORI.SEQNUM    AS SEQCTA,
             ORI.TIPNUM    AS TIPCTA,
             ORI.FILUSU,
             ORI.CODUSU,
             COALESCE(CTA_ORI.FILNUM,ORI.FILREC,ORI.CODFIL) AS FILORI,
             COALESCE(CTA.FILNUM,DES.FILREC,DES.CODFIL) AS FILDES,
             DES.ATU_EM, DES.DATINC,
             CTA_ORI.CODEXT AS ORICTA_CODEXT,
             CTA.CODEXT AS DESCTA_CODEXT
      FROM TT_FIN DES INNER JOIN TT_FIN ORI ON DES.CODFIL = ORI.CODFIL
                                           AND DES.SEQTRN = ORI.SEQUEN
                      INNER JOIN TT_CTA CTA ON CTA.CODFIL=DES.FILNUM AND CTA.SEQUEN=DES.SEQNUM AND CTA.TIPCTA=DES.TIPNUM -- RFMP 88898
                      INNER JOIN TT_CTA CTA_ORI ON CTA_ORI.CODFIL=ORI.FILNUM AND CTA_ORI.SEQUEN=ORI.SEQNUM AND CTA_ORI.TIPCTA=ORI.TIPNUM -- RFMP 88898
      WHERE DES.TIPGER || DES.FLGFIN = 'MS' -- Somente pega transferencia simples
        AND DES.SEQCHR IS NULL
        AND ORI.SEQCHR IS NULL) INT
;


/*-- SEQ 2908 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RFIN_PAG CASCADE;

/*-- SEQ 2909 --*/
CREATE OR REPLACE VIEW TV_RFIN_PAG AS
--
--   Lanamento apenas de consistencia, no deve ser materializado na TR_FIN, pois a TV_RFIN_COM j o faz
-- 
--   TIPO      CONTA       CONTRA-PARTIDA
--   --------  ----------  -----------------------------------
--   Qualquer  <Qualquer>  <Fretes, Titulos ou Compras a Pagar>
--
SELECT /*+INDEX(PAG,PK_PAG) INDEX(DOC,PK_COM)*/
       PAG.CODFIL, PAG.SEQUEN, 
       PAG.NUMPAR, 
       PAG.SUBPAR, 
       CAST('PAG' AS VARCHAR(3)) AS ORIGEM,       
       DATOPE AS DATLAN,
       (PAG.VLRPAR-(SELECT coalesce(sum(VLRPAR),0)
                      FROM TT_PAG INT 
                     WHERE INT.CODFIL=PAG.CODFIL 
                       AND INT.SEQUEN=PAG.SEQUEN 
                       AND INT.NUMPAR=PAG.NUMPAR
                       AND INT.RENEGO IS NOT NULL)) * -1 AS VLRLAN,
       DOC.FILFOR AS FILCLI, 
       DOC.CODFOR AS CODCLI,
       CAST('R' AS VARCHAR(1)) AS FLGFLX,
       CASE WHEN CFO.CFOCTA_FIL IS NOT NULL 
             AND CFO.CFOCTA_SEQ IS NOT NULL 
             AND CFO.CFOCTA_TIP IS NOT NULL THEN CAST('CFO' AS CHAR(3)) ELSE CAST('CTA' AS CHAR(3)) END AS ORICTA,
       CASE WHEN CFO.CFOCTA_FIL IS NOT NULL 
             AND CFO.CFOCTA_SEQ IS NOT NULL 
             AND CFO.CFOCTA_TIP IS NOT NULL THEN CFO.CFOCTA_FIL         ELSE DCTA.FILCTA            END AS FILCTA,
       CASE WHEN CFO.CFOCTA_FIL IS NOT NULL 
             AND CFO.CFOCTA_SEQ IS NOT NULL 
             AND CFO.CFOCTA_TIP IS NOT NULL THEN CFO.CFOCTA_SEQ         ELSE DCTA.SEQCTA            END AS SEQCTA,
       CASE WHEN CFO.CFOCTA_FIL IS NOT NULL 
             AND CFO.CFOCTA_SEQ IS NOT NULL 
             AND CFO.CFOCTA_TIP IS NOT NULL THEN CFO.CFOCTA_TIP         ELSE DCTA.TIPCTA            END AS TIPCTA,
       CASE WHEN CFO.CFOCTA_FIL IS NOT NULL 
             AND CFO.CFOCTA_SEQ IS NOT NULL 
             AND CFO.CFOCTA_TIP IS NOT NULL THEN CFO.CODTAB             ELSE DCTA.CODTAB            END AS CODCTA,
       COALESCE(CTA.FILVIN, DCRT.FILCTA) AS FILCRT,
       COALESCE(CTA.SEQVIN, DCRT.SEQCTA) AS SEQCRT,
       COALESCE(CTA.TIPVIN, DCRT.TIPCTA) AS TIPCRT,
       CAST('CTA' AS CHAR(03)) AS ORICRT,
       DCRT.CODTAB AS CODCRT,
       CAST('NAO' AS CHAR(3)) AS TIPLAN,
       (PAG.VLRPAR-(SELECT coalesce(sum(VLRPAR),0)
                      FROM TT_PAG INT 
                     WHERE INT.CODFIL=PAG.CODFIL 
                       AND INT.SEQUEN=PAG.SEQUEN 
                       AND INT.NUMPAR=PAG.NUMPAR
                       AND INT.RENEGO IS NOT NULL)) * -1 AS VLRCRT,
       PAG.CODFIL AS FILORI,
       PAG.CODFIL AS FILDES,
       PAG.FILUSU,
       PAG.CODUSU,
       PAG.ATU_EM, PAG.DATINC AS DATINCORI
FROM TT_PAG PAG INNER JOIN TT_COM DOC  ON DOC.CODFIL  = PAG.CODFIL 
                                      AND DOC.SEQUEN  = PAG.SEQUEN
                LEFT  JOIN TT_CTA CTA  ON DOC.FILCTA  = CTA.CODFIL AND DOC.SEQCTA = CTA.SEQUEN
                LEFT  JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'TIPCTA_MER_REV'
                LEFT  JOIN TD_CTA DCRT ON DCRT.CFGCOL = CASE WHEN DOC.TIPPAR='T' THEN 'TIPCTA_FRE_PAG'    -- Fretes a pagar
                                                             WHEN DOC.TIPPAR='F' THEN 'TIPCTA_FOR_PAG'    -- Fornecedores a pagar
                                                                                 ELSE 'TIPCTA_TIT_PAG'    -- Titulos a pagar
                                                        END
                LEFT  JOIN TD_CFO CFO ON DOC.CODCFO = CFO.CODTAB
WHERE DOC.FLGEST <> 'D' 
  AND PAG.SUBPAR = ' 0'
  --AND PAG.RENEGO IS NULL
  --AND PAG.FLGEST NOT IN ('X','C')
UNION ALL
--
--   TIPO      CONTA              CONTRA-PARTIDA
--   --------  -----------------  --------------------
--   Frete     <Fretes a Pagar>   <Pagamentos>
--   Titulo    <Titulos a Pagar>  <Pagamentos>
--   Compras   <Compras a Pagar>  <Pagamentos>
--
SELECT /*+INDEX(PAG,PK_PAG) INDEX(DOC,PK_COM)*/
       PAG.CODFIL, PAG.SEQUEN, 
       PAG.NUMPAR, 
       PAG.SUBPAR, 
       CAST('PAG' AS VARCHAR(3)) AS ORIGEM,        
       CASE WHEN PAG.FLGEST in ('A','1','2') THEN PAG.DATVEN ELSE PAG.DATPGT END AS DATLAN,
       CASE WHEN PAG.FLGEST in ('A','1','2') THEN PAG.VLRPAR ELSE PAG.VLRPGT END AS VLRLAN,
       DOC.FILFOR AS FILCLI, 
       DOC.CODFOR AS CODCLI,
       CAST(CASE WHEN PAG.FLGEST in ('A','1','2') THEN 'A' ELSE 'R' END AS VARCHAR(1)) AS FLGFLX,
       CAST('CTA' AS CHAR(3)) AS ORICTA,
       COALESCE(CTA.FILVIN,DCTA.FILCTA) AS FILCTA,
       COALESCE(CTA.SEQVIN,DCTA.SEQCTA) AS SEQCTA,
       COALESCE(CTA.TIPVIN,DCTA.TIPCTA) AS TIPCTA,
       DCTA.CODTAB AS CODCTA,
       COALESCE(DadosDopUnica(PAG.FILDOP, PAG.SEQDOP, PAG.DATPGT, 'FILCTA'),DCRT.FILCTA) AS FILCRT,
       COALESCE(DadosDopUnica(PAG.FILDOP, PAG.SEQDOP, PAG.DATPGT, 'SEQCTA'),DCRT.SEQCTA) AS SEQCRT,
       COALESCE(DadosDopUnica(PAG.FILDOP, PAG.SEQDOP, PAG.DATPGT, 'TIPCTA'),DCRT.TIPCTA) AS TIPCRT,
       CAST('CTA' AS CHAR(3)) AS ORICRT,
       DCRT.CODTAB AS CODCRT,
       CAST('PAG' AS CHAR(3)) AS TIPLAN,
       CASE WHEN PAG.FLGEST in ('A','1','2') THEN PAG.VLRPAR ELSE PAG.VLRPGT END AS VLRCRT,
       PAG.CODFIL AS FILORI,
       CASE WHEN PAG.FLGEST = 'P' THEN PAG.FILDOP ELSE PAG.CODFIL END AS FILDES,
       PAG.FILUSU,
       PAG.CODUSU,
       PAG.ATU_EM, PAG.DATINC AS DATINCORI
FROM TT_PAG PAG INNER JOIN TT_COM DOC  ON DOC.CODFIL  = PAG.CODFIL 
                                      AND DOC.SEQUEN  = PAG.SEQUEN
                LEFT JOIN TT_CTA CTA ON DOC.FILCTA=CTA.CODFIL AND DOC.SEQCTA=CTA.SEQUEN
                LEFT  JOIN TD_CTA DCTA ON DCTA.CFGCOL = CASE WHEN DOC.TIPPAR='T' THEN 'TIPCTA_FRE_PAG'    -- Fretes a pagar
                                                             WHEN DOC.TIPPAR='F' THEN 'TIPCTA_FOR_PAG'    -- Fornecedores a pagar
                                                                                 ELSE 'TIPCTA_TIT_PAG'    -- Titulos a pagar
                                                        END
                LEFT  JOIN TD_CTA DCRT ON DCRT.CFGCOL = 'PAGAMENTOS'
WHERE DOC.FLGEST <> 'D' 
  AND PAG.FLGEST not in ('X','C')
UNION ALL
--
--   Situacao  CONTA                                CONTRA-PARTIDA
--   --------  -----------------------------------  --------------------
--   Paga      <Fretes, Titulos OU Compras A Pagar>  <Descontos OU Juros>
--   Cancelada <Fretes, Titulos OU Compras A Pagar>  <Descontos OU Juros>
--
SELECT /*+INDEX(PAG,PK_PAG) INDEX(DOC,PK_COM)+INDEX(SUB,PK_PAG)*/
       PAG.CODFIL, PAG.SEQUEN, 
       PAG.NUMPAR, 
       PAG.SUBPAR, 
       CAST('PAG' AS VARCHAR(3)) AS ORIGEM,       
       COALESCE( PAG.DATPGT, PAG.DATVEN ) AS DATLAN,
       CASE WHEN PAG.FLGEST = 'P' THEN PAG.VLRPGT + COALESCE(PAG.VLRDIF,0) - PAG.VLRPAR ELSE PAG.VLRDIF END * -1 AS VLRLAN,
       DOC.FILFOR AS FILCLI, 
       DOC.CODFOR AS CODCLI,
       CAST('R' AS VARCHAR(1)) AS FLGFLX,
       CAST('CTA' AS CHAR(3)) AS ORICTA,
       DCRT.FILCTA AS FILCTA,
       DCRT.SEQCTA AS SEQCTA,
       DCRT.TIPCTA AS TIPCTA,
       DCRT.CODTAB AS CODCTA,
       COALESCE(CTA.FILVIN,DCTA.FILCTA) AS FILCRT,
       COALESCE(CTA.SEQVIN,DCTA.SEQCTA) AS SEQCRT,
       COALESCE(CTA.TIPVIN,DCTA.TIPCTA) AS TIPCRT,
       CAST('CTA' AS CHAR(3)) AS ORICRT,
       DCTA.CODTAB AS CODCRT,
       CAST('JDP' AS CHAR(3)) AS TIPLAN,
       CASE WHEN PAG.FLGEST = 'P' THEN PAG.VLRPGT + COALESCE(PAG.VLRDIF,0) - PAG.VLRPAR ELSE PAG.VLRDIF END * -1 AS VLRCRT,
       PAG.CODFIL AS FILORI,
       PAG.CODFIL AS FILDES,
       PAG.FILUSU,
       PAG.CODUSU,
       PAG.ATU_EM, PAG.DATINC AS DATINCORI
FROM TT_PAG PAG INNER JOIN TT_COM DOC ON DOC.CODFIL = PAG.CODFIL 
                                     AND DOC.SEQUEN = PAG.SEQUEN
                LEFT JOIN TT_CTA CTA ON DOC.FILCTA=CTA.CODFIL AND DOC.SEQCTA=CTA.SEQUEN
                LEFT  JOIN TT_PAG SUB ON SUB.CODFIL = PAG.CODFIL
                                     AND SUB.SEQUEN = PAG.SEQUEN
                                     AND SUB.NUMPAR = PAG.NUMPAR
                                     AND SUB.SUBPAR = lpad(trim(to_char(to_number(PAG.SUBPAR)+1,'99')),2,' ')
                LEFT  JOIN TD_CTA DCTA ON DCTA.CFGCOL = CASE WHEN DOC.TIPPAR='T' THEN 'TIPCTA_FRE_PAG'    -- Fretes a pagar
                                                             WHEN DOC.TIPPAR='F' THEN 'TIPCTA_FOR_PAG'    -- Fornecedores a pagar
                                                                                 ELSE 'TIPCTA_TIT_PAG'    -- Titulos a pagar
                                                        END
                LEFT  JOIN TD_CTA DCRT ON DCRT.CFGCOL = CASE WHEN (CASE WHEN PAG.FLGEST = 'P' 
                                                                        THEN PAG.VLRPGT + COALESCE(PAG.VLRDIF,0) - PAG.VLRPAR 
                                                                        ELSE SUB.VLRPAR - PAG.VLRPAR 
                                                                   END) < 0 
                                                             THEN 'TIPCTA_DES_OBT'
                                                             ELSE 'TIPCTA_JUR_PAG'
                                                        END
WHERE DOC.FLGEST <> 'D'
  AND ((PAG.FLGEST = 'P' AND (PAG.VLRPGT + COALESCE(PAG.VLRDIF,0) - PAG.VLRPAR) <> 0)
    OR (PAG.FLGEST = 'C' AND COALESCE(PAG.VLRDIF,0) <> 0))
UNION ALL
--
--   Situacao  CONTA                                CONTRA-PARTIDA
--   --------  -----------------------------------  --------------------
--   <Descontos OU Juros> Cancelada <Fretes, Titulos OU Compras A Pagar>
--
SELECT SUB.CODFIL, SUB.SEQUEN, 
       SUBSTR((SELECT MIN(NUMPAR||SUBPAR) 
                 FROM TT_PAG 
                WHERE CODFIL = SUB.CODFIL 
                  AND SEQUEN = SUB.SEQUEN 
                  AND RENORI = SUB.RENEGO), 1, 2) AS NUMPAR, 
       SUBSTR((SELECT MIN(NUMPAR||SUBPAR) 
                 FROM TT_PAG 
                WHERE CODFIL = SUB.CODFIL 
                  AND SEQUEN = SUB.SEQUEN 
                  AND RENORI = SUB.RENEGO), 3, 2) AS SUBPAR, 
       CAST('PAG' AS CHAR(3)) AS ORIGEM,       
       SUB.DATPGT AS DATLAN,
       SUB.DIFREN * -1 AS VLRLAN,
       SUB.FILFOR AS FILCLI, 
       SUB.CODFOR AS CODCLI,
       CAST('R' AS VARCHAR(1)) AS FLGFLX,
       CAST('CTA' AS CHAR(3)) AS ORICTA,
       CASE WHEN SUB.DIFREN < 0
            THEN DCRT_DES.FILCTA 
            ELSE DCRT_JUR.FILCTA 
       END AS FILCTA,
       CASE WHEN SUB.DIFREN < 0
            THEN DCRT_DES.SEQCTA 
            ELSE DCRT_JUR.SEQCTA 
       END AS SEQCTA,
       CASE WHEN SUB.DIFREN < 0
            THEN DCRT_DES.TIPCTA 
            ELSE DCRT_JUR.TIPCTA 
       END AS TIPCTA,
       CASE WHEN SUB.DIFREN < 0
            THEN DCRT_DES.CODTAB 
            ELSE DCRT_JUR.CODTAB 
       END AS CODCTA,
       COALESCE(CTA.FILVIN,DCTA.FILCTA) AS FILCRT,
       COALESCE(CTA.SEQVIN,DCTA.SEQCTA) AS SEQCRT,
       COALESCE(CTA.TIPVIN,DCTA.TIPCTA) AS TIPCRT,
       CAST('CTA' AS CHAR(3)) AS ORICRT,
       DCTA.CODTAB AS CODCRT,
       CAST('JDP' AS CHAR(3)) AS TIPLAN,
       SUB.DIFREN * -1 AS VLRCRT,
       SUB.CODFIL AS FILORI,
       SUB.CODFIL AS FILDES,
       SUB.FILUSU,
       SUB.CODUSU,
       SUB.ATU_EM, SUB.DATINC
  FROM (
         SELECT /*+INDEX(PAG,PK_PAG) INDEX(DOC,PK_COM)*/
                PAG.CODFIL, PAG.SEQUEN, 
                PAG.DATPGT, DOC.FILFOR, DOC.CODFOR, PAG.RENEGO,
                PAG.FILUSU, PAG.CODUSU, PAG.ATU_EM, PAG.DATINC,
                DiferencaRenegociacao(PAG.CODFIL,PAG.SEQUEN,PAG.RENEGO) AS DIFREN,
                DOC.FILCTA, DOC.SEQCTA, DOC.TIPPAR
           FROM TT_PAG PAG INNER JOIN TT_COM DOC ON DOC.CODFIL = PAG.CODFIL 
                                                AND DOC.SEQUEN = PAG.SEQUEN
          WHERE DOC.FLGEST <> 'D'
            AND PAG.FLGEST = 'C'
            AND PAG.RENEGO > 0
            AND DiferencaRenegociacao(PAG.CODFIL,PAG.SEQUEN,PAG.RENEGO) <> 0
          GROUP BY PAG.CODFIL, PAG.SEQUEN, PAG.DATPGT, DOC.FILFOR, DOC.CODFOR, PAG.RENEGO,
                   PAG.FILUSU, PAG.CODUSU, PAG.ATU_EM, PAG.DATINC,
                   DOC.FILCTA, DOC.SEQCTA, DOC.TIPPAR
         ) SUB LEFT JOIN TT_CTA CTA ON SUB.FILCTA = CTA.CODFIL 
                                    AND SUB.SEQCTA = CTA.SEQUEN
                LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL = CASE WHEN SUB.TIPPAR='T' THEN 'TIPCTA_FRE_PAG'    -- Fretes a pagar
                                                            WHEN SUB.TIPPAR='F' THEN 'TIPCTA_FOR_PAG'    -- Fornecedores a pagar
                                                                                ELSE 'TIPCTA_TIT_PAG'    -- Titulos a pagar
                                                       END
                LEFT JOIN TD_CTA DCRT_DES ON DCRT_DES.CFGCOL = 'TIPCTA_DES_OBT'
                LEFT JOIN TD_CTA DCRT_JUR ON DCRT_JUR.CFGCOL = 'TIPCTA_JUR_PAG'
UNION ALL
--
--   Situacao  CONTA                                CONTRA-PARTIDA
--   --------  -----------------------------------  --------------------
--   <Fretes, Titulos OU Compras A Pagar> <Compras>
--
SELECT SUB.CODFIL, SUB.SEQUEN, 
       SUBSTR((SELECT MIN(NUMPAR||SUBPAR) 
                 FROM TT_PAG 
                WHERE CODFIL = SUB.CODFIL 
                  AND SEQUEN = SUB.SEQUEN 
                  AND RENORI = SUB.RENEGO), 1, 2) AS NUMPAR, 
       SUBSTR((SELECT MIN(NUMPAR||SUBPAR) 
                 FROM TT_PAG 
                WHERE CODFIL = SUB.CODFIL 
                  AND SEQUEN = SUB.SEQUEN 
                  AND RENORI = SUB.RENEGO), 3, 2) AS SUBPAR, 
       CAST('PAG' AS CHAR(3)) AS ORIGEM,       
       SUB.DATPGT AS DATLAN,
       SUB.DIFREN AS VLRLAN,
       SUB.FILFOR AS FILCLI, 
       SUB.CODFOR AS CODCLI,
       CAST('R' AS VARCHAR(1)) AS FLGFLX,
       CAST('CTA' AS CHAR(3)) AS ORICTA,
       COALESCE(CTA.FILVIN, DCTA.FILCTA) AS FILCTA,
       COALESCE(CTA.SEQVIN, DCTA.SEQCTA) AS SEQCTA,
       COALESCE(CTA.TIPVIN, DCTA.TIPCTA) AS TIPCTA,
       DCTA.CODTAB AS CODCTA,
       CASE WHEN CFO.CFOCTA_FIL IS NOT NULL 
             AND CFO.CFOCTA_SEQ IS NOT NULL 
             AND CFO.CFOCTA_TIP IS NOT NULL THEN CFO.CFOCTA_FIL          ELSE DCRT.FILCTA             END AS FILCRT,
       CASE WHEN CFO.CFOCTA_FIL IS NOT NULL 
             AND CFO.CFOCTA_SEQ IS NOT NULL 
             AND CFO.CFOCTA_TIP IS NOT NULL THEN CFO.CFOCTA_SEQ          ELSE DCRT.SEQCTA             END AS SEQCRT,
       CASE WHEN CFO.CFOCTA_FIL IS NOT NULL 
             AND CFO.CFOCTA_SEQ IS NOT NULL 
             AND CFO.CFOCTA_TIP IS NOT NULL THEN CFO.CFOCTA_TIP          ELSE DCRT.TIPCTA             END AS TIPCRT,
       CASE WHEN CFO.CFOCTA_FIL IS NOT NULL 
             AND CFO.CFOCTA_SEQ IS NOT NULL 
             AND CFO.CFOCTA_TIP IS NOT NULL THEN CAST('CFO' AS CHAR(03)) ELSE CAST('CTA' AS CHAR(03)) END AS ORICRT,
       CASE WHEN CFO.CFOCTA_FIL IS NOT NULL 
             AND CFO.CFOCTA_SEQ IS NOT NULL 
             AND CFO.CFOCTA_TIP IS NOT NULL THEN CFO.CODTAB              ELSE DCRT.CODTAB             END AS CODCRT,
       CAST('NAO' AS CHAR(3)) AS TIPLAN,
       SUB.DIFREN AS VLRCRT,
       SUB.CODFIL AS FILORI,
       SUB.CODFIL AS FILDES,
       SUB.FILUSU,
       SUB.CODUSU,
       SUB.ATU_EM, SUB.DATINC
  FROM (
         SELECT /*+INDEX(PAG,PK_PAG) INDEX(DOC,PK_COM)*/
                PAG.CODFIL, PAG.SEQUEN, 
                PAG.DATPGT, DOC.FILFOR, DOC.CODFOR, PAG.RENEGO,
                PAG.FILUSU, PAG.CODUSU, PAG.ATU_EM, PAG.DATINC,
                DiferencaRenegociacao(PAG.CODFIL,PAG.SEQUEN,PAG.RENEGO) AS DIFREN,
                DOC.FILCTA, DOC.SEQCTA, DOC.TIPPAR, DOC.CODCFO
           FROM TT_PAG PAG INNER JOIN TT_COM DOC ON DOC.CODFIL = PAG.CODFIL 
                                                AND DOC.SEQUEN = PAG.SEQUEN
          WHERE DOC.FLGEST <> 'D'
            AND PAG.FLGEST = 'C'
            AND PAG.RENEGO > 0
            AND DiferencaRenegociacao(PAG.CODFIL,PAG.SEQUEN,PAG.RENEGO) <> 0
          GROUP BY PAG.CODFIL, PAG.SEQUEN, PAG.DATPGT, DOC.FILFOR, DOC.CODFOR, PAG.RENEGO,
                   PAG.FILUSU, PAG.CODUSU, PAG.ATU_EM, PAG.DATINC,
                   DOC.FILCTA, DOC.SEQCTA, DOC.TIPPAR, 
                   DOC.CODCFO
         ) SUB LEFT JOIN TT_CTA CTA ON SUB.FILCTA = CTA.CODFIL 
                                    AND SUB.SEQCTA = CTA.SEQUEN
                LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL = CASE WHEN SUB.TIPPAR='T' THEN 'TIPCTA_FRE_PAG'    -- Fretes a pagar
                                                            WHEN SUB.TIPPAR='F' THEN 'TIPCTA_FOR_PAG'    -- Fornecedores a pagar
                                                                                ELSE 'TIPCTA_TIT_PAG'    -- Titulos a pagar
                                                       END
                LEFT JOIN TD_CTA DCRT ON DCRT.CFGCOL = 'TIPCTA_MER_REV'
                LEFT JOIN TD_CFO CFO  ON SUB.CODCFO  = CFO.CODTAB
;


/*-- SEQ 2910 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RFIN_PTR CASCADE;

/*-- SEQ 2911 --*/
CREATE OR REPLACE VIEW TV_RFIN_PTR AS
SELECT CAST('PTR' AS VARCHAR(3)) AS ORIGEM,
       FILCTA, SEQCTA, TIPCTA, ORICTA,
       CODCTA, FILCRT, SEQCRT, TIPCRT,
       ORICRT, CODCRT, CODFIL, SEQUEN, 
       NUMPAR, SUBPAR, FILLAN, DATLAN, 
       VLRLAN, FILCLI, CODCLI, FLGFLX, 
       TIPLAN,
       VLRLAN AS VLRCRT,
       CODFIL AS FILORI,
       CODFIL AS FILDES,
       FILUSU,
       CODUSU,
       ATU_EM, DATINC AS DATINCORI
FROM (SELECT PTR.CODFIL, PTR.SEQUEN, PTR.NUMPAR, PTR.SUBPAR,
             PTR.CODFIL AS FILLAN,
             TRC.FILPAR AS FILCLI,
             TRC.CODPAR AS CODCLI,
             TRC.DATOPE AS DATLAN,
             PTR.VLRPAR AS VLRLAN,
             CAST('R' AS VARCHAR(1)) AS FLGFLX,
             TRC.FILCTA, TRC.SEQCTA, TRC.TIPCTA,
             CAST('TRC' AS VARCHAR(3)) AS ORICTA,
             CAST( NULL AS Numeric(5))   AS CODCTA,
             CASE WHEN CTA.FILVIN IS NOT NULL THEN CTA.FILVIN ELSE DCTA.FILCTA END AS FILCRT,
             CASE WHEN CTA.FILVIN IS NOT NULL THEN CTA.SEQVIN ELSE DCTA.SEQCTA END AS SEQCRT,
             CASE WHEN CTA.FILVIN IS NOT NULL THEN CTA.TIPVIN ELSE DCTA.TIPCTA END AS TIPCRT,
             CAST('CTA' AS VARCHAR(3)) AS ORICRT,
             DCTA.CODTAB                AS CODCRT,
             CAST('TRC' AS VARCHAR(3)) AS TIPLAN,
             PTR.FILUSU,
             PTR.CODUSU,
             PTR.ATU_EM, PTR.DATINC
      FROM TT_PTR PTR INNER JOIN TT_TRC TRC  ON PTR.CODFIL  = TRC.CODFIL 
                                            AND PTR.SEQUEN  = TRC.SEQUEN
                      INNER JOIN TT_CTA CTA  ON TRC.FILCTA=CTA.CODFIL AND TRC.SEQCTA=CTA.SEQUEN
                      LEFT  JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'TIPCTA_TIT_REC'
      WHERE 1=0
 ) tab
;




/*-- SEQ 2912 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RFIN_REC CASCADE;

/*-- SEQ 2913 --*/
CREATE OR REPLACE VIEW TV_RFIN_REC AS
SELECT CAST('REC' AS VARCHAR(3)) AS ORIGEM,
       SUBSTR(CTAMOV,01,03)       AS FILCTA,
       SUBSTR(CTAMOV,04,10)       AS SEQCTA,
       SUBSTR(CTAMOV,14,01)       AS TIPCTA,
       SUBSTR(CTAMOV,15,03)       AS ORICTA,
       SUBSTR(CTACON,01,03)       AS FILCRT,
       SUBSTR(CTACON,04,10)       AS SEQCRT,
       SUBSTR(CTACON,14,01)       AS TIPCRT,
       SUBSTR(CTACON,15,03)       AS ORICRT,
       TO_NUMBER(SUBSTR(CTACON,19,05)) AS CODCRT,
       TO_NUMBER(SUBSTR(CTAMOV,19,05)) AS CODCTA,
       CODFIL, SEQUEN, NUMPAR, SUBPAR,
       DATLAN, VLRLAN, FILCLI, CODCLI,
       FLGFLX, TIPLAN,
       COALESCE(VLRCRT,VLRLAN) AS VLRCRT,
       CODFIL AS FILORI,
       CASE WHEN (SELECT DCTA.FILCTA || DCTA.SEQCTA || DCTA.TIPCTA
                    FROM TD_CTA DCTA
                   WHERE DCTA.CFGCOL = 'CONTAS A RECEBER'
                  ) = SUBSTR(CTACON,1,14) THEN CODFIL ELSE FILLAN END AS FILDES,
       FILUSU,CODUSU,
       ATU_EM, DATINC AS DATINCORI
FROM (SELECT REC.CODFIL, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR,
             COALESCE(REC.FILREC, REC.CODFIL) AS FILLAN,
             CASE WHEN REC.RENORI IS NOT NULL THEN trunc(REC.DATINC)
                  ELSE VEN.DATFIS
             END AS DATLAN,
             REC.VLRPAR AS VLRLAN,
             VEN.FILCLI, VEN.CODCLI,
             CAST('R' AS VARCHAR(1)) AS FLGFLX,
             CASE WHEN VEN.FILCTA IS NULL
                  THEN
                      CASE WHEN REC.RENORI IS NULL
                           THEN CASE WHEN SUBSTR(COALESCE(DNAT.NATDEN,'    '),1,4) IN ('1102','2102') THEN
                                          DCOM.FILCTA || DCOM.SEQCTA || DCOM.TIPCTA || 'COM' || TO_CHAR(DCOM.CODTAB,'99999')
                                     WHEN SUBSTR(COALESCE(DNAT.NATDEN,'    '),1,4) IN ('5202','6202') THEN
                                          DDEC.FILCTA || DDEC.SEQCTA || DDEC.TIPCTA || 'DEV' || TO_CHAR(DDEC.CODTAB,'99999')
                                     ELSE
                                          CASE WHEN VEN.VLRLIQ > 0 THEN
                                                    CASE WHEN CTANAT.SEQUEN IS NOT NULL THEN
                                                              CTANAT.CODFIL || CTANAT.SEQUEN || CTANAT.TIPCTA || 'NAT' || TO_CHAR(DNAT.CODTAB,'99999')
                                                         WHEN VEN.AVISTA = 'T' THEN
                                                              DCTR.CTRFIL || DCTR.CTRSEQ || DCTR.CTRTIP || 'CTR' || TO_CHAR(DCTR.CODTAB,'99999')
                                                         ELSE
                                                              DCTR.FILPRA || DCTR.SEQPRA || DCTR.TIPPRA || 'CTR' || TO_CHAR(DCTR.CODTAB,'99999')
                                                     END
                                               ELSE DDEV.FILCTA || DDEV.SEQCTA || DDEV.TIPCTA || 'CTA' || TO_CHAR(DDEV.CODTAB,'99999')
                                          END
                                END
                           ELSE DCRT.FILCTA || DCRT.SEQCTA || DCRT.TIPCTA || 'CTA' || TO_CHAR(DCRT.CODTAB,'99999')
                      END
                  ELSE
                      VEN.FILCTA || VEN.SEQCTA || VEN.TIPCTA || 'VEN' || TO_CHAR(0,'99999')
             END AS CTAMOV,
             CASE WHEN TRUNC(VEN.DATHOR) = TRUNC(COALESCE(REC.PAGAME,add_day(VEN.DATHOR,1)))
                       AND REC.FLGEST NOT IN ('X','C')
                       AND ABS(CASE WHEN REC.CARTAO IS NULL THEN COALESCE(REC.VLRPGT,0) ELSE COALESCE(REC.VLRPGT,0) + COALESCE(REC.VLRTAX,0) END) = ABS(REC.VLRPAR)
                       AND COALESCE(REC.VLRDES,0)=0
                       THEN CASE WHEN REC.FILCTA IS NULL
                                 THEN DCOB.FILCTA || DCOB.SEQCTA || DCOB.TIPCTA || 'COB' || TO_CHAR(DCOB.CODTAB,'99999')
                                 ELSE REC.FILCTA || REC.SEQCTA || REC.TIPCTA || 'REC' || TO_CHAR(0,'99999')
                            END
                  WHEN CFG.ARECEBER_PASSA_ECF = 'T' AND VEN.NUMECF <> '000' THEN
                       CASE WHEN REC.FILCTA IS NULL
                            THEN DCOB.FILCTA || DCOB.SEQCTA || DCOB.TIPCTA || 'COB' || TO_CHAR(DCOB.CODTAB,'99999')
                            ELSE REC.FILCTA || REC.SEQCTA || REC.TIPCTA || 'REC' || TO_CHAR(0,'99999')
                       END
                  WHEN CTANAT.FILVIN IS NOT NULL AND CTANAT.SEQVIN IS NOT NULL AND CTANAT.TIPVIN IS NOT NULL
                       THEN CTANAT.FILVIN||CTANAT.SEQVIN||CTANAT.TIPVIN|| 'NAT' || TO_CHAR(DNAT.CODTAB,'99999')
                  WHEN CTACTR.FILVIN IS NOT NULL AND CTACTR.SEQVIN IS NOT NULL AND CTACTR.TIPVIN IS NOT NULL
                       THEN CTACTR.FILVIN||CTACTR.SEQVIN||CTACTR.TIPVIN|| 'CTA' || TO_CHAR(DCTA.CODTAB,'99999')
                  ELSE DCTA.FILCTA || DCTA.SEQCTA || DCTA.TIPCTA || 'CTA' || TO_CHAR(DCTA.CODTAB,'99999')
             END AS CTACON,
             CAST(CASE WHEN REC.RENORI IS NULL
                       THEN 'VEN'
                       ELSE 'REN'
                   END AS VARCHAR(3)) AS TIPLAN,
             CASE WHEN REC.RENORI IS NULL
                  THEN REC.VLRPAR
                              - (SELECT SUM(TOT.VLRPAR) - MIN(VEN.VLRLIQ-COALESCE(VEN.VLRCOF,0)-COALESCE(VEN.FUNRUR,0)-COALESCE(VEN.SENAR,0)-COALESCE(VEN.SEGRUR,0)+COALESCE(VEN.VLRSAD,0))
                                 FROM TT_VEN VEN INNER JOIN TT_REC TOT ON TOT.CODFIL = VEN.CODFIL AND TOT.SEQUEN = VEN.SEQUEN
                                                 LEFT  JOIN  tt_rec subt on subt.codfil = tot.codfil
                                                                        and subt.sequen = tot.sequen
                                                                        and subt.numpar = tot.numpar
                                                                        and subt.subpar = lpad(trim(to_char(to_number(tot.SUBPAR)+1,'99')),2,' ')
                                WHERE VEN.CODFIL = REC.CODFIL
                                  AND VEN.SEQUEN = REC.SEQUEN
                                  AND TOT.SUBPAR = ' 0'
                                  AND TOT.RENORI IS NULL
                                  AND ((NOT (SUBT.CODFIL IS NULL AND TOT.FLGEST='C')) OR (TOT.RENEGO IS NOT NULL)) -- Tratamento para subdivisoes de parcelas antigas
                                GROUP BY VEN.CODFIL, VEN.SEQUEN)
                  ELSE REC.VLRPAR
              END AS VLRCRT,
             VEN.FILUSU,
             VEN.CODUSU,
             REC.ATU_EM, REC.DATINC
      FROM TT_REC REC INNER JOIN TT_VEN VEN  ON REC.CODFIL  = VEN.CODFIL
                                            AND REC.SEQUEN  = VEN.SEQUEN
                      INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
                      INNER JOIN TD_CTR DCTR ON DCTR.CODTAB = VEN.CODCTR
                      INNER JOIN TT_CTA CTACTR ON DCTR.CTRFIL=CTACTR.CODFIL AND DCTR.CTRSEQ=CTACTR.SEQUEN
                      INNER JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD
                      LEFT  JOIN  tt_rec sub on sub.codfil = rec.codfil
                                            and sub.sequen = rec.sequen
                                            and sub.numpar = rec.numpar
                                            and sub.subpar = lpad(trim(to_char(to_number(REC.SUBPAR)+1,'99')),2,' ')
                      LEFT  JOIN TT_CTM CTM  ON CTM.CODFIL = REC.CODFIL AND CTM.SEQUEN = REC.SEQUEN
                                            AND CTM.NUMPAR = REC.NUMPAR AND CTM.SUBPAR = REC.SUBPAR
                      LEFT  JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'CONTAS A RECEBER'
                      LEFT  JOIN TD_CTA DCRT ON DCRT.CFGCOL = 'RENEGOCIACOES'
                      LEFT  JOIN TD_CTA DDEC ON DDEC.CFGCOL = 'DEVOLUCAO COMPRAS'
                      LEFT  JOIN TD_CTA DCOM ON DCOM.CFGCOL = 'TIPCTA_MER_REV'
                      LEFT  JOIN TD_CTA DDEV ON DDEV.CFGCOL = 'DEVOLUCAO VENDAS'
                      LEFT  JOIN TT_CTA CTANAT ON (DNAT.NATDEN_FIL = CTANAT.CODFIL -- dentro
                                              AND  DNAT.NATDEN_SEQ = CTANAT.SEQUEN
                                              AND  VEN.UFLOJA      = 'T')
                                               OR (DNAT.NATFOR_FIL = CTANAT.CODFIL -- fora
                                              AND  DNAT.NATFOR_SEQ = CTANAT.SEQUEN
                                              AND  VEN.UFLOJA      = 'F')
                      CROSS JOIN TT_CFG CFG
      WHERE VEN.FLGEST <> 'C'
        AND REC.SUBPAR = ' 0'
        AND NOT (SUB.CODFIL IS NULL AND REC.FLGEST='C' AND REC.RENEGO IS NULL) -- Tratamento para subdivisoes de parcelas antigas
        AND COALESCE(VEN.FUNRUR,0) = 0
        AND VEN.FILEST IS NULL
      UNION ALL
     --Tratamento para enviar vendas para a conta de ECF
      SELECT REC.CODFIL, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR,
             COALESCE(REC.FILREC, REC.CODFIL) AS FILLAN,
             CASE WHEN REC.RENORI IS NOT NULL THEN trunc(REC.DATINC)
                  ELSE VEN.DATFIS
             END AS DATLAN,
             REC.VLRPAR * -1  AS VLRLAN,
             VEN.FILCLI, VEN.CODCLI,
             CAST('R' AS VARCHAR(1)) AS FLGFLX,
             CASE WHEN REC.FILCTA IS NULL
                  THEN DCOB.FILCTA || DCOB.SEQCTA || DCOB.TIPCTA || 'COB' || TO_CHAR(DCOB.CODTAB,'99999')
                  ELSE REC.FILCTA || REC.SEQCTA || REC.TIPCTA || 'REC' || TO_CHAR(0,'99999')
             END AS CTAMOV,
             CASE WHEN CTANAT.FILVIN IS NOT NULL AND CTANAT.SEQVIN IS NOT NULL AND CTANAT.TIPVIN IS NOT NULL THEN
                       CTANAT.FILVIN||CTANAT.SEQVIN||CTANAT.TIPVIN|| 'NAT' || TO_CHAR(DNAT.CODTAB,'99999')
                  WHEN CTACTR.FILVIN IS NOT NULL AND CTACTR.SEQVIN IS NOT NULL AND CTACTR.TIPVIN IS NOT NULL THEN
                       CTACTR.FILVIN||CTACTR.SEQVIN||CTACTR.TIPVIN|| 'CTA' || TO_CHAR(DCTA.CODTAB,'99999')
                  ELSE DCTA.FILCTA || DCTA.SEQCTA || DCTA.TIPCTA || 'CTA' || TO_CHAR(DCTA.CODTAB,'99999')
             END AS CTACON,
             CAST(CASE WHEN REC.RENORI IS NULL
                       THEN 'VPR'
                       ELSE 'REN'
                   END AS VARCHAR(3)) AS TIPLAN,
             CASE WHEN REC.RENORI IS NULL
                  THEN REC.VLRPAR
                            - (SELECT SUM(TOT.VLRPAR) - MIN(VEN.VLRLIQ-COALESCE(VEN.VLRCOF,0)+COALESCE(VEN.VLRSAD,0))
                                 FROM TT_VEN VEN INNER JOIN TT_REC TOT ON TOT.CODFIL = VEN.CODFIL AND TOT.SEQUEN = VEN.SEQUEN
                                                 LEFT  JOIN  tt_rec subt on subt.codfil = tot.codfil
                                                                        and subt.sequen = tot.sequen
                                                                        and subt.numpar = tot.numpar
                                                                        and subt.subpar = lpad(trim(to_char(to_number(tot.SUBPAR)+1,'99')),2,' ')
                                WHERE VEN.CODFIL = REC.CODFIL
                                  AND VEN.SEQUEN = REC.SEQUEN
                                  AND TOT.SUBPAR = ' 0'
                                  AND TOT.RENORI IS NULL
                                  AND ((NOT (SUBT.CODFIL IS NULL AND TOT.FLGEST='C')) OR (TOT.RENEGO IS NOT NULL)) -- Tratamento para subdivisoes de parcelas antigas
                                GROUP BY VEN.CODFIL, VEN.SEQUEN)
                  ELSE REC.VLRPAR
              END * -1  AS VLRCRT,
             VEN.FILUSU,
             VEN.CODUSU,
             REC.ATU_EM, REC.DATINC
      FROM TT_REC REC INNER JOIN TT_VEN VEN  ON REC.CODFIL  = VEN.CODFIL
                                            AND REC.SEQUEN  = VEN.SEQUEN
                      INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
                      LEFT  JOIN  tt_rec sub on sub.codfil = rec.codfil
                                            and sub.sequen = rec.sequen
                                            and sub.numpar = rec.numpar
                                            and sub.subpar = lpad(trim(to_char(to_number(REC.SUBPAR)+1,'99')),2,' ')
                      INNER JOIN TD_ECF DECF ON DECF.FILECF = VEN.CODFIL AND DECF.NUMECF = VEN.NUMECF
                      INNER JOIN TD_COB DCOB ON DCOB.CODTAB = DECF.PORECF
                      LEFT  JOIN TT_CTM CTM  ON CTM.CODFIL = REC.CODFIL AND CTM.SEQUEN = REC.SEQUEN
                                            AND CTM.NUMPAR = REC.NUMPAR AND CTM.SUBPAR = REC.SUBPAR
                      LEFT  JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'CONTAS A RECEBER'
                      INNER JOIN TD_CTR DCTR ON DCTR.CODTAB = VEN.CODCTR
                      INNER JOIN TT_CTA CTACTR ON DCTR.CTRFIL=CTACTR.CODFIL AND DCTR.CTRSEQ=CTACTR.SEQUEN
                      CROSS JOIN TT_CFG CFG
                      LEFT  JOIN TT_CTA CTANAT ON (DNAT.NATDEN_FIL = CTANAT.CODFIL -- dentro
                                              AND  DNAT.NATDEN_SEQ = CTANAT.SEQUEN
                                              AND  VEN.UFLOJA      = 'T')
                                               OR (DNAT.NATFOR_FIL = CTANAT.CODFIL -- fora
                                              AND  DNAT.NATFOR_SEQ = CTANAT.SEQUEN
                                              AND  VEN.UFLOJA      = 'F')
      WHERE VEN.FLGEST <> 'C'
        AND REC.SUBPAR = ' 0'
        AND CFG.ARECEBER_PASSA_ECF = 'T'
        AND VEN.NUMECF <> '000'
        AND NOT (TRUNC(VEN.DATHOR) = TRUNC(COALESCE(REC.PAGAME,add_day(VEN.DATHOR,1)))
                       AND REC.FLGEST NOT IN ('X','C')
                       AND ABS(CASE WHEN REC.CARTAO IS NULL THEN COALESCE(REC.VLRPGT,0) ELSE COALESCE(REC.VLRPGT,0) + COALESCE(REC.VLRTAX,0) END) = ABS(REC.VLRPAR)
                       AND COALESCE(REC.VLRDES,0)=0)
        AND NOT (SUB.CODFIL IS NULL AND REC.FLGEST='C' AND REC.RENEGO IS NULL) -- Tratamento para subdivisoes de parcelas antigas
        AND COALESCE(VEN.FUNRUR,0) = 0
        AND VEN.FILEST IS NULL
      UNION ALL
      -- Registro do recebimento
      SELECT REC.CODFIL, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR,
             COALESCE(REC.FILREC, REC.CODFIL) AS FILLAN,
             CASE WHEN (REC.FLGEST = 'P' OR REC.SEQCHE IS NOT NULL) THEN COALESCE(COALESCE(REC.DATFIS,REC.PAGAME), REC.DATVEN)
                  WHEN REC.RENEGO IS NOT NULL THEN TRUNC(REC.ESTCAN)
             ELSE
                  REC.DATVEN
             END AS DATLAN,
             (CASE WHEN (REC.FLGEST = 'P' OR REC.SEQCHE IS NOT NULL)
                   THEN CASE WHEN REC.CARTAO IS NULL
                             THEN --CASE WHEN DCOB.GERTIT = 'T'
                                  --     THEN COALESCE(REC.VLRPGT,0)
                                  --     ELSE COALESCE(REC.VLRPGT,0) - COALESCE(REC.VLRTAX,0)
                                  --END
                                  COALESCE(REC.VLRPGT,0)  -- RFMP 98820 Taxa vai para o "COB"
                             ELSE COALESCE(REC.VLRPGT,0) + COALESCE(REC.VLRTAX,0)
                        END
                   ELSE REC.VLRPAR + CASE WHEN REC.RENEGO IS NOT NULL THEN COALESCE(REC.VLRDES, 0) ELSE 0 END
             END) * -1 AS VLRLAN,
             VEN.FILCLI AS FILCLI,
             VEN.CODCLI AS CODCLI,
             CASE WHEN (REC.FLGEST = 'P' OR REC.SEQCHE IS NOT NULL OR RENEGO IS NOT NULL) THEN
                  CAST('R' AS VARCHAR(1))
             ELSE
                  CAST('A' AS VARCHAR(1))
             END AS FLGFLX,
             CASE WHEN CTANAT.FILVIN IS NOT NULL AND CTANAT.SEQVIN IS NOT NULL AND CTANAT.TIPVIN IS NOT NULL THEN
                       CTANAT.FILVIN||CTANAT.SEQVIN||CTANAT.TIPVIN|| 'NAT' || TO_CHAR(DNAT.CODTAB,'99999')
                  WHEN CTACTR.FILVIN IS NOT NULL AND CTACTR.SEQVIN IS NOT NULL AND CTACTR.TIPVIN IS NOT NULL THEN
                       CTACTR.FILVIN||CTACTR.SEQVIN||CTACTR.TIPVIN|| 'CTA' || TO_CHAR(DCTA.CODTAB,'99999')
                  ELSE DCTA.FILCTA || DCTA.SEQCTA || DCTA.TIPCTA  || 'CTA' || TO_CHAR(DCTA.CODTAB,'99999')
             END AS CTAMOV,
             CASE WHEN REC.RENEGO IS NOT NULL THEN
                  (SELECT DCRT.FILCTA || DCRT.SEQCTA || DCRT.TIPCTA || 'CTA' || TO_CHAR(DCRT.CODTAB,'99999')
                   FROM TD_CTA DCRT
                   WHERE DCRT.CFGCOL = 'DIVIDAS RENEGOCIADAS')
             ELSE
                 CASE WHEN REC.FILCTA IS NULL
                      THEN DCOB.FILCTA || DCOB.SEQCTA || DCOB.TIPCTA || 'COB' || TO_CHAR(DCOB.CODTAB,'99999')
                      ELSE REC.FILCTA || REC.SEQCTA || REC.TIPCTA || 'REC' || TO_CHAR(0,'99999')
                 END
             END AS CTACON,
             CAST(CASE WHEN REC.RENORI IS NULL
                       THEN 'REC'
                       ELSE 'RNV'
             END AS VARCHAR(3)) AS TIPLAN,
             CAST(NULL AS Numeric) AS VLRCRT,
             COALESCE(REC.FILUSU,VEN.FILUSU) AS FILUSU,
             COALESCE(REC.CODUSU,VEN.CODUSU) AS CODUSU,
             REC.ATU_EM, REC.DATINC
      FROM TT_REC REC INNER JOIN TT_VEN VEN  ON REC.CODFIL  = VEN.CODFIL
                                            AND REC.SEQUEN  = VEN.SEQUEN
                      INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
                      INNER JOIN TD_CTR DCTR ON DCTR.CODTAB = VEN.CODCTR
                      INNER JOIN TT_CTA CTACTR ON DCTR.CTRFIL=CTACTR.CODFIL AND DCTR.CTRSEQ=CTACTR.SEQUEN
                      INNER JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD
                      LEFT  JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'CONTAS A RECEBER'
                      LEFT  JOIN TT_CTA CTANAT ON (DNAT.NATDEN_FIL = CTANAT.CODFIL -- dentro
                                              AND  DNAT.NATDEN_SEQ = CTANAT.SEQUEN
                                              AND  VEN.UFLOJA      = 'T')
                                               OR (DNAT.NATFOR_FIL = CTANAT.CODFIL -- fora
                                              AND  DNAT.NATFOR_SEQ = CTANAT.SEQUEN
                                              AND  VEN.UFLOJA      = 'F')
      WHERE VEN.FLGEST <> 'C'
        AND REC.FLGEST <> 'X'
        AND (REC.FLGEST <> 'C' OR REC.RENEGO IS NOT NULL)
        AND ( ( COALESCE(REC.VLRDES,0) <> 0 AND (REC.FLGEST = 'P' OR REC.SEQCHE IS NOT NULL) ) -- Venda COM juros ou multa, necessrio 3 registros financeiros
           OR ( REC.SUBPAR<>' 0' ) -- Se mais de uma sub-parcela
           OR ( ABS(CASE WHEN REC.CARTAO IS NULL THEN COALESCE(REC.VLRPGT,0) ELSE COALESCE(REC.VLRPGT,0) + COALESCE(REC.VLRTAX,0) END) <> ABS(REC.VLRPAR) ) -- Valores indicam existencia de sub-parcela
           OR ( TRUNC(VEN.DATHOR) <> TRUNC(REC.PAGAME) ) -- Venda No  A Vista nem entrada
           OR ( REC.PAGAME IS NULL) -- Se no tem data de pagamento, no pode saber se foi a vista, ento define como se no fora
            )
        AND COALESCE(VEN.FUNRUR,0) = 0
        AND VEN.FILEST IS NULL
      UNION ALL
      -- Registro dos Juros e Descontos
      SELECT REC.CODFIL, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR,
             COALESCE(REC.FILREC, REC.CODFIL) AS FILLAN,
             COALESCE(COALESCE(REC.DATFIS,REC.PAGAME), REC.DATVEN)  AS DATLAN,
             DescontoParcela(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) AS VLRLAN,
             VEN.FILCLI AS FILCLI,
             VEN.CODCLI AS CODCLI,
             CASE WHEN (REC.FLGEST = 'P' OR REC.SEQCHE IS NOT NULL) THEN
                  CAST('R' AS VARCHAR(1))
             ELSE
                  CAST('A' AS VARCHAR(1))
             END AS FLGFLX,
             (SELECT CASE WHEN CTANAT.FILVIN IS NOT NULL AND CTANAT.SEQVIN IS NOT NULL AND CTANAT.TIPVIN IS NOT NULL AND DCTA.CFGCOL='CONTAS A RECEBER' THEN
                               CTANAT.FILVIN||CTANAT.SEQVIN||CTANAT.TIPVIN|| 'NAT' || TO_CHAR(DNAT.CODTAB,'99999')
                          WHEN CTACTR.FILVIN IS NOT NULL AND CTACTR.SEQVIN IS NOT NULL AND CTACTR.TIPVIN IS NOT NULL AND DCTA.CFGCOL='CONTAS A RECEBER' THEN
                               CTACTR.FILVIN || CTACTR.SEQVIN || CTACTR.TIPVIN || 'CTA' || TO_CHAR(DCTA.CODTAB,'99999')
                          ELSE DCTA.FILCTA || DCTA.SEQCTA || DCTA.TIPCTA || 'CTA' || TO_CHAR(DCTA.CODTAB,'99999')
                     END
                FROM TD_CTA DCTA
               WHERE DCTA.CFGCOL = CASE WHEN DescontoParcela(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) < 0
                                        THEN 'CONTAS A RECEBER'
                                        ELSE 'TIPCTA_JUR_REC'
                                   END -- Se houver desconto abate do contas a receber, caso contrario credita em juros
             ) AS CTAMOV,
             (SELECT CASE WHEN CTANAT.FILVIN IS NOT NULL AND CTANAT.SEQVIN IS NOT NULL AND CTANAT.TIPVIN IS NOT NULL AND DCRT.CFGCOL='CONTAS A RECEBER' THEN
                               CTANAT.FILVIN||CTANAT.SEQVIN||CTANAT.TIPVIN|| 'NAT' || TO_CHAR(DNAT.CODTAB,'99999')
                          WHEN CTACTR.FILVIN IS NOT NULL AND CTACTR.SEQVIN IS NOT NULL AND CTACTR.TIPVIN IS NOT NULL AND DCRT.CFGCOL='CONTAS A RECEBER' THEN
                               CTACTR.FILVIN || CTACTR.SEQVIN || CTACTR.TIPVIN || 'CTA' || TO_CHAR(DCRT.CODTAB,'99999')
                          ELSE DCRT.FILCTA || DCRT.SEQCTA || DCRT.TIPCTA || 'CTA' || TO_CHAR(DCRT.CODTAB,'99999')
                     END
                FROM TD_CTA DCRT
               WHERE DCRT.CFGCOL = CASE WHEN DescontoParcela(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) < 0
                                        THEN 'TIPCTA_DES_CON'
                                        ELSE 'CONTAS A RECEBER'
                                   END
             ) AS CTACON,
             CAST('JDR' AS VARCHAR(3)) AS TIPLAN,
             CAST(NULL AS Numeric) AS VLRCRT,
             COALESCE(REC.FILUSU,VEN.FILUSU) AS FILUSU,
             COALESCE(REC.CODUSU,VEN.CODUSU) AS CODUSU,
             REC.ATU_EM, REC.DATINC
      FROM TT_REC REC INNER JOIN TT_VEN VEN  ON REC.CODFIL  = VEN.CODFIL
                                            AND REC.SEQUEN  = VEN.SEQUEN
                      INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
                      INNER JOIN TD_CTR DCTR ON DCTR.CODTAB = VEN.CODCTR
                      INNER JOIN TT_CTA CTACTR ON DCTR.CTRFIL=CTACTR.CODFIL AND DCTR.CTRSEQ=CTACTR.SEQUEN
                      LEFT  JOIN TT_CTA CTANAT ON (DNAT.NATDEN_FIL = CTANAT.CODFIL -- dentro
                                              AND  DNAT.NATDEN_SEQ = CTANAT.SEQUEN
                                              AND  VEN.UFLOJA      = 'T')
                                               OR (DNAT.NATFOR_FIL = CTANAT.CODFIL -- fora
                                              AND  DNAT.NATFOR_SEQ = CTANAT.SEQUEN
                                              AND  VEN.UFLOJA      = 'F')
      WHERE VEN.FLGEST <> 'C'
        AND REC.FLGEST NOT IN ('C','X')
        AND (REC.FLGEST <> 'C' OR REC.RENEGO IS NOT NULL)
        AND COALESCE(VEN.FUNRUR,0) = 0
        AND VEN.FILEST IS NULL
      UNION ALL
      -- Registro de taxas de cobrana bancria
      SELECT REC.CODFIL, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR,
             COALESCE(REC.FILREC, REC.CODFIL) AS FILLAN,
             COALESCE(COALESCE(REC.DATFIS,REC.PAGAME), REC.DATVEN) AS DATLAN,
             (CASE WHEN COALESCE(REC.VLRPGT,0)<0 THEN -1 ELSE 1 END * ABS(COALESCE(REC.VLRTAX,0))) *-1 AS VLRLAN,
             VEN.FILCLI AS FILCLI,
             VEN.CODCLI AS CODCLI,
             CAST('R' AS VARCHAR(1)) AS FLGFLX,
             DCTA.FILCTA || DCTA.SEQCTA || DCTA.TIPCTA || 'CTA' || TO_CHAR(DCTA.CODTAB,'99999') AS CTAMOV,
             DCTA_REC.FILCTA || DCTA_REC.SEQCTA || DCTA_REC.TIPCTA || 'CTA' || TO_CHAR(DCTA_REC.CODTAB,'99999') AS CTACON,
             CAST('COB' AS VARCHAR(3)) AS TIPLAN,
             CAST(NULL AS Numeric) AS VLRCRT,
             COALESCE(REC.FILUSU,VEN.FILUSU) AS FILUSU,
             COALESCE(REC.CODUSU,VEN.CODUSU) AS CODUSU,
             REC.ATU_EM, REC.DATINC
      FROM TT_REC REC INNER JOIN TT_VEN VEN  ON REC.CODFIL  = VEN.CODFIL
                                            AND REC.SEQUEN  = VEN.SEQUEN
                      INNER JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD
                      LEFT  JOIN TD_CTA DCTA_REC ON DCTA_REC.CFGCOL = 'CONTAS A RECEBER'
                      LEFT  JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'TAXAS COBRANCA BANC.'
      WHERE VEN.FLGEST <> 'C'
        AND REC.CARTAO IS NULL
        AND (REC.FLGEST <> 'C' OR REC.RENEGO IS NOT NULL)
        AND COALESCE(REC.VLRTAX,0) <> 0
        AND REC.FLGEST = 'P'
        AND COALESCE(VEN.FUNRUR,0) = 0
        AND VEN.FILEST IS NULL
      UNION ALL
      -- Registro dos Juros e Descontos (Ajuste de Parcela)
      SELECT REC.CODFIL, REC.SEQUEN, REC.NUMPAR, REC.SUBPAR,
             COALESCE(REC.FILREC, REC.CODFIL) AS FILLAN,
             COALESCE(COALESCE(REC.DATFIS,REC.PAGAME), REC.DATVEN) AS DATLAN,
             DescontoParcela(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) AS VLRLAN,
             VEN.FILCLI AS FILCLI,
             VEN.CODCLI AS CODCLI,
             CAST('R' AS VARCHAR(1)) AS FLGFLX,
             CASE WHEN CTANAT.FILVIN IS NOT NULL AND CTANAT.SEQVIN IS NOT NULL AND CTANAT.TIPVIN IS NOT NULL THEN
                       CTANAT.FILVIN||CTANAT.SEQVIN||CTANAT.TIPVIN|| 'NAT' || TO_CHAR(DNAT.CODTAB,'99999')
                  WHEN CTACTR.FILVIN IS NOT NULL AND CTACTR.SEQVIN IS NOT NULL AND CTACTR.TIPVIN IS NOT NULL THEN
                       CTACTR.FILVIN || CTACTR.SEQVIN || CTACTR.TIPVIN || 'CTA' || TO_CHAR(DCTA.CODTAB,'99999')
                  ELSE DCTA.FILCTA || DCTA.SEQCTA || DCTA.TIPCTA || 'CTA' || TO_CHAR(DCTA.CODTAB,'99999')
             END AS CTAMOV,
             DCRT.FILCTA || DCRT.SEQCTA || DCRT.TIPCTA || 'CTA' || TO_CHAR(DCRT.CODTAB,'99999') AS CTACON,
             CAST('JDR' AS VARCHAR(3)) AS TIPLAN,
             CAST(NULL AS Numeric) AS VLRCRT,
             COALESCE(REC.FILUSU,VEN.FILUSU) AS FILUSU,
             COALESCE(REC.CODUSU,VEN.CODUSU) AS CODUSU,
             REC.ATU_EM, REC.DATINC
      FROM TT_REC REC INNER JOIN TT_VEN VEN  ON REC.CODFIL  = VEN.CODFIL
                                            AND REC.SEQUEN  = VEN.SEQUEN
                      INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
                      INNER JOIN TD_CTR DCTR ON DCTR.CODTAB = VEN.CODCTR
                      INNER JOIN TT_CTA CTACTR ON DCTR.CTRFIL=CTACTR.CODFIL AND DCTR.CTRSEQ=CTACTR.SEQUEN
                      LEFT  JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'CONTAS A RECEBER'
                      LEFT  JOIN TD_CTA DCRT ON DCRT.CFGCOL = 'TIPCTA_DES_CON'
                      LEFT  JOIN TT_CTA CTANAT ON (DNAT.NATDEN_FIL = CTANAT.CODFIL -- dentro
                                              AND  DNAT.NATDEN_SEQ = CTANAT.SEQUEN
                                              AND  VEN.UFLOJA      = 'T')
                                               OR (DNAT.NATFOR_FIL = CTANAT.CODFIL -- fora
                                              AND  DNAT.NATFOR_SEQ = CTANAT.SEQUEN
                                              AND  VEN.UFLOJA      = 'F')
      WHERE VEN.FLGEST <> 'C'
        AND REC.FLGEST = 'C'
        --AND DescontoParcela(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) <> 0
        --AND REC.RENEGO IS NULL
        AND COALESCE(VEN.FUNRUR,0) = 0
        AND VEN.FILEST IS NULL
      UNION ALL
      -- Vendas canceladas - Venda
      -- RFMP 93469
      -- O financeiro do cancelamento est tratado como se fosse uma parcela com todo o valor da venda.
      SELECT VEN.CODFIL, VEN.SEQUEN,
             Constante('NUMPAR_FIN_VENDAS_CANCELADAS') AS NUMPAR,
             Constante('SUBPAR_FIN_VENDAS_CANCELADAS') AS SUBPAR,
             VEN.CODFIL AS FILLAN,
             VEN.DATFIS AS DATLAN,
             VEN.VLRLIQ AS VLRLAN,
             VEN.FILCLI, VEN.CODCLI,
             CAST('R' AS VARCHAR(1)) AS FLGFLX,
             CASE WHEN VEN.FILCTA IS NULL
                  THEN
                    CASE WHEN CTANAT.SEQUEN IS NOT NULL THEN
                              CTANAT.CODFIL || CTANAT.SEQUEN || CTANAT.TIPCTA || 'NAT' || TO_CHAR(DNAT.CODTAB,'99999')
                         ELSE -- considera venda cancelada sempre a vista
                              DCTR.CTRFIL || DCTR.CTRSEQ || DCTR.CTRTIP || 'CTR' || TO_CHAR(DCTR.CODTAB,'99999')
                     END
                  ELSE
                     VEN.FILCTA || VEN.SEQCTA || VEN.TIPCTA || 'VEN' || TO_CHAR(0,'99999')
             END AS CTAMOV,
             DCOB.FILCTA || DCOB.SEQCTA || DCOB.TIPCTA || 'COB' || TO_CHAR(DCOB.CODTAB,'99999') AS CTACON,
             CAST('VEN' AS VARCHAR(3)) AS TIPLAN,
             VEN.VLRLIQ AS VLRCRT,
             VEN.FILUSU,
             VEN.CODUSU,
             VEN.ATU_EM, VEN.DATINC
      FROM TT_VEN VEN INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
                      INNER JOIN TD_CTR DCTR ON DCTR.CODTAB = VEN.CODCTR
                      INNER JOIN TD_ECF DECF ON DECF.FILECF = VEN.CODFIL AND DECF.NUMECF = VEN.NUMECF
                      INNER JOIN TD_COB DCOB ON DCOB.CODTAB = DECF.PORECF
                      LEFT  JOIN TT_CTA CTANAT ON (DNAT.NATDEN_FIL = CTANAT.CODFIL -- dentro
                                              AND  DNAT.NATDEN_SEQ = CTANAT.SEQUEN
                                              AND  VEN.UFLOJA      = 'T')
                                               OR (DNAT.NATFOR_FIL = CTANAT.CODFIL -- fora
                                              AND  DNAT.NATFOR_SEQ = CTANAT.SEQUEN
                                              AND  VEN.UFLOJA      = 'F')
                      CROSS JOIN TT_CFG CFG
      WHERE ((VEN.FLGEST = 'C') OR (VEN.FILEST IS NOT NULL))
        AND COALESCE(VEN.FUNRUR,0) = 0
        AND VEN.FINANC='T'
      UNION ALL
      -- Vendas canceladas - Cancelamento
      SELECT VEN.CODFIL, VEN.SEQUEN,
             Constante('NUMPAR_FIN_VENDAS_CANCELADAS') AS NUMPAR,
             Constante('SUBPAR_FIN_VENDAS_CANCELADAS') AS SUBPAR,
             VEN.CODFIL AS FILLAN,
             VEN.DATFIS AS DATLAN,
             VEN.VLRLIQ*-1 AS VLRLAN,
             VEN.FILCLI, VEN.CODCLI,
             CAST('R' AS VARCHAR(1)) AS FLGFLX,
             DCAN.FILCTA || DCAN.SEQCTA || DCAN.TIPCTA || 'CTA' || TO_CHAR(DCAN.CODTAB,'99999') AS CTAMOV,
             DCOB.FILCTA || DCOB.SEQCTA || DCOB.TIPCTA || 'COB' || TO_CHAR(DCOB.CODTAB,'99999') AS CTACON,
             CAST('CAN' AS VARCHAR(3)) AS TIPLAN,
             VEN.VLRLIQ*-1 AS VLRCRT,
             VEN.FILUSU,
             VEN.CODUSU,
             VEN.ATU_EM, VEN.DATINC
      FROM TT_VEN VEN INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
                      INNER JOIN TD_CTA DCAN ON DCAN.CFGCOL = 'VENDAS_CANCELADAS'
                      INNER JOIN TD_ECF DECF ON DECF.FILECF = VEN.CODFIL AND DECF.NUMECF = VEN.NUMECF
                      INNER JOIN TD_COB DCOB ON DCOB.CODTAB = DECF.PORECF
                      CROSS JOIN TT_CFG CFG
      WHERE ((VEN.FLGEST = 'C') OR (VEN.FILEST IS NOT NULL))
        AND COALESCE(VEN.FUNRUR,0) = 0
        AND VEN.FINANC='T'
) TAB
;


/*-- SEQ 2914 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RFIN_RTT CASCADE;

/*-- SEQ 2915 --*/
CREATE OR REPLACE VIEW TV_RFIN_RTT AS
SELECT 'RTT' AS ORIGEM,
       DCOB.FILCTA AS FILCTA,
       DCOB.SEQCTA AS SEQCTA,
       DCOB.TIPCTA AS TIPCTA,
       'ECF' AS ORICTA,
       DCOB.CODTAB AS CODCTA,
       DRTT.FILCTA_DRTT AS FILCRT,
       DRTT.SEQCTA_DRTT AS SEQCRT,
       DRTT.TIPCTA_DRTT AS TIPCRT,
       'RTT' AS ORICRT,
       DRTT.CODTAB AS CODCRT,
       RTT.CODFIL,
       RTT.SEQUEN,
       '--' AS NUMPAR,
       '--' AS SUBPAR,
       RTT.DATOPE AS DATLAN,
       RTT.VLRPGT AS VLRLAN,
       CFG.VC_FILCLI AS FILCLI,
       CFG.VC_CODCLI AS CODCLI,
       'R' AS FLGFLX,
       'RTT' AS TIPLAN,
       RTT.VLRPGT AS VLRCRT,
       RTT.CODFIL AS FILORI,
       RTT.CODFIL AS FILDES,
       RTT.FILUSU,
       RTT.CODUSU,
       RTT.ATU_EM, RTT.DATINC AS DATINCORI
  FROM TT_RTT RTT INNER JOIN TD_ECF ECF ON ECF.FILECF = RTT.CODFIL
                                       AND ECF.NUMECF = RTT.NUMECF
                  INNER JOIN TD_COB DCOB ON DCOB.CODTAB = ECF.PORECF
                                        AND DCOB.TIPCOB = ECF.COBECF
                  INNER JOIN TD_RTT DRTT ON RTT.TIPRTT = DRTT.CODTAB
                  CROSS JOIN TT_CFG CFG
 WHERE RTT.FLGEST IN ('P','S','E')
UNION ALL
SELECT 'RTT' AS ORIGEM,
       DCOB.FILCTA AS FILCTA,
       DCOB.SEQCTA AS SEQCTA,
       DCOB.TIPCTA AS TIPCTA,
       'ECF' AS ORICTA,
       DCOB.CODTAB AS CODCTA,
       DRTT.FILCTA_EST_DRTT AS FILCRT,
       DRTT.SEQCTA_EST_DRTT AS SEQCRT,
       DRTT.TIPCTA_EST_DRTT AS TIPCRT,
       'RTT' AS ORICRT,
       DRTT.CODTAB AS CODCRT,
       RTT.CODFIL,
       RTT.SEQUEN,
       '--' AS NUMPAR,
       '--' AS SUBPAR,
       RTT.DATEST AS DATLAN,
       (RTT.VLRPGT * -1) AS VLRLAN,
       CFG.VC_FILCLI AS FILCLI,
       CFG.VC_CODCLI AS CODCLI,
       'R' AS FLGFLX,
       'EST' AS TIPLAN,
       (RTT.VLRPGT * -1) AS VLRCRT,
       RTT.CODFIL AS FILORI,
       RTT.CODFIL AS FILDES,
       RTT.FILUSU_EST AS FILUSU,
       RTT.CODUSU_EST AS CODUSU,
       RTT.ATU_EM, RTT.DATINC AS DATINCORI
  FROM TT_RTT RTT INNER JOIN TD_ECF ECF ON ECF.FILECF = RTT.CODFIL
                                       AND ECF.NUMECF = RTT.NUMECF
                  INNER JOIN TD_COB DCOB ON DCOB.CODTAB = ECF.PORECF
                                        AND DCOB.TIPCOB = ECF.COBECF
                  INNER JOIN TD_RTT DRTT ON RTT.TIPRTT = DRTT.CODTAB
                  CROSS JOIN TT_CFG CFG
 WHERE RTT.FLGEST = 'E'
;


/*-- SEQ 2916 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RFIN_TEF CASCADE;

/*-- SEQ 2917 --*/
CREATE OR REPLACE VIEW TV_RFIN_TEF AS
SELECT CAST('TEF' AS VARCHAR(3))     AS ORIGEM,
       CAST(NUMITE AS CHAR(2) )        AS NUMPAR,
       FILCTA, SEQCTA, TIPCTA, CODCTA, ORICTA,
       FILCRT, SEQCRT, TIPCRT, CODCRT, ORICRT,
       CODFIL, SEQUEN, DATLAN, TIPLAN,
       VLRLAN, FILCLI, CODCLI, FLGFLX, SUBPAR,
       VLRLAN AS VLRCRT,
       CODFIL AS FILORI,
       CODFIL AS FILDES,
       FILUSU,
       CODUSU,
       ATU_EM, DATINC AS DATINCORI
FROM (-- Do portador original para "CARTOES". Valor Original
      SELECT ITF.CODFIL, ITF.SEQUEN, 
             ITF.NUMITE,
             TEF.FILCLI, TEF.CODCLI,
             CAST('R' AS VARCHAR(1))   AS FLGFLX,
             TEF.DATFIS                 AS DATLAN,
             ITF.VLRITE                 AS VLRLAN,
             CASE WHEN CTA.FILVIN IS NOT NULL THEN CTA.FILVIN ELSE DCTA.FILCTA END AS FILCTA, 
             CASE WHEN CTA.FILVIN IS NOT NULL THEN CTA.SEQVIN ELSE DCTA.SEQCTA END AS SEQCTA, 
             CASE WHEN CTA.FILVIN IS NOT NULL THEN CTA.TIPVIN ELSE DCTA.TIPCTA END AS TIPCTA, 
             DCTA.CODTAB                AS CODCTA,
             CAST('CTA' AS VARCHAR(3)) AS ORICTA,
             DCOB.FILCTA                AS FILCRT,
             DCOB.SEQCTA                AS SEQCRT,
             DCOB.TIPCTA                AS TIPCRT,
             DCOB.CODTAB                AS CODCRT,
             CAST('COB' AS VARCHAR(3)) AS ORICRT,
             CAST('TEF' AS VARCHAR(3)) AS TIPLAN,
             CAST('--' AS CHAR(2))      AS SUBPAR,
             TEF.FILUSU,
             TEF.CODUSU,
             TEF.ATU_EM, TEF.DATINC
      FROM TT_TEF TEF INNER JOIN TT_ITF ITF ON TEF.CODFIL=ITF.CODFIL AND TEF.SEQUEN=ITF.SEQUEN
                      INNER JOIN TD_COB DCOB ON DCOB.CODTAB = TEF.PORORI
                      INNER JOIN TD_CAR DCAR ON DCAR.CODTAB = TEF.CARTAO
                      INNER JOIN TT_CTA CTA ON DCAR.FILCAR=CTA.CODFIL AND DCAR.SEQCAR=CTA.SEQUEN
                      LEFT  JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'CARTOES A RECEBER'
      WHERE ITF.FLGEST <> 'C' -- Ignora TEF cancelado
      UNION ALL
      -- De "CARTOES" para o portador atual. Valor do TEF menos taxa de administracao
      SELECT ITF.CODFIL, ITF.SEQUEN, 
             ITF.NUMITE,             
             TEF.FILCLI, TEF.CODCLI,
             CAST( CASE ITF.FLGEST WHEN 'P' THEN 'R' ELSE 'A' END AS VARCHAR(1)) AS FLGFLX,
             TRUNC(COALESCE( ITF.DATPGT, ITF.DATVEN)) AS DATLAN,
             (ITF.VLRITE-COALESCE(ITF.VLRTAX,0)) * -1 AS VLRLAN,
             CASE WHEN CTA.FILVIN IS NOT NULL THEN CTA.FILVIN ELSE DCTA.FILCTA END AS FILCTA,
             CASE WHEN CTA.FILVIN IS NOT NULL THEN CTA.SEQVIN ELSE DCTA.SEQCTA END AS SEQCTA,
             CASE WHEN CTA.FILVIN IS NOT NULL THEN CTA.TIPVIN ELSE DCTA.TIPCTA END AS TIPCTA,
             DCTA.CODTAB                AS CODCTA,
             CAST('CTA' AS VARCHAR(3)) AS ORICTA,
             DCOB.FILCTA                AS FILCRT, 
             DCOB.SEQCTA                AS SEQCRT, 
             DCOB.TIPCTA                AS TIPCRT, 
             DCOB.CODTAB                AS CODCRT,
             CAST('COB' AS VARCHAR(3)) AS ORICRT,
             CAST('PGT' AS VARCHAR(3)) AS TIPLAN,
             CAST('--' AS CHAR(2))      AS SUBPAR,
             COALESCE(ITF.FILUSU,TEF.FILUSU) AS FILUSU,
             COALESCE(ITF.CODUSU,TEF.CODUSU) AS CODUSU,
             TEF.ATU_EM, TEF.DATINC
      FROM TT_TEF TEF INNER JOIN TT_ITF ITF ON TEF.CODFIL=ITF.CODFIL AND TEF.SEQUEN=ITF.SEQUEN
                      LEFT  JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'CARTOES A RECEBER'
                      INNER JOIN TD_CAR DCAR ON DCAR.CODTAB = TEF.CARTAO
                      INNER JOIN TT_CTA CTA ON DCAR.FILCAR=CTA.CODFIL AND DCAR.SEQCAR=CTA.SEQUEN
                      INNER JOIN TD_COB DCOB ON DCOB.CODTAB = DCAR.PORCAR
      WHERE ITF.FLGEST <> 'C' -- Ignora TEF cancelado
      UNION ALL
      -- De "CARTOES" para taxas. Valor da taxa de administracao      
      SELECT ITF.CODFIL, ITF.SEQUEN, 
             ITF.NUMITE,
             TEF.FILCLI, TEF.CODCLI,
             CAST( CASE ITF.FLGEST WHEN 'P' THEN 'R' ELSE 'A' END AS VARCHAR(1)) AS FLGFLX,
             TRUNC(COALESCE(ITF.DATPGT, ITF.DATVEN)) AS DATLAN,
             ITF.VLRTAX * -1 AS VLRLAN,
             DCAR.FILCAR                AS FILCTA,
             DCAR.SEQCAR                AS SEQCTA,
             DCAR.TIPCAR                AS TIPCTA,
             DCAR.CODTAB                AS CODCTA,
             CAST('CAR' AS VARCHAR(3)) AS ORICTA,
             CASE WHEN CTA.FILVIN IS NOT NULL THEN CTA.FILVIN ELSE DCTA.FILCTA END  AS FILCRT,
             CASE WHEN CTA.FILVIN IS NOT NULL THEN CTA.SEQVIN ELSE DCTA.SEQCTA END  AS SEQCRT,
             CASE WHEN CTA.FILVIN IS NOT NULL THEN CTA.TIPVIN ELSE DCTA.TIPCTA END  AS TIPCRT,
             DCTA.CODTAB                AS CODCRT,
             CAST('CTA' AS VARCHAR(3)) AS ORICRT,
             CAST('TAX' AS VARCHAR(3)) AS TIPLAN,
             CAST('--' AS CHAR(2))      AS SUBPAR,
             COALESCE(ITF.FILUSU,TEF.FILUSU) AS FILUSU,
             COALESCE(ITF.CODUSU,TEF.CODUSU) AS CODUSU,
             TEF.ATU_EM, TEF.DATINC
      FROM TT_TEF TEF INNER JOIN TT_ITF ITF ON TEF.CODFIL=ITF.CODFIL AND TEF.SEQUEN=ITF.SEQUEN
                      INNER JOIN TD_CAR DCAR ON DCAR.CODTAB = TEF.CARTAO
                      INNER JOIN TT_CTA CTA ON DCAR.FILCAR=CTA.CODFIL AND DCAR.SEQCAR=CTA.SEQUEN
                      LEFT JOIN TD_CTA DCTA ON DCTA.CFGCOL = 'CARTOES A RECEBER'                      
      WHERE ITF.FLGEST <> 'C' -- Ignora TEF cancelado
        AND COALESCE(ITF.VLRTAX,0) <> 0 
) tab
;


/*-- SEQ 2918 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_SEP_DOC CASCADE;

/*-- SEQ 2919 --*/
CREATE OR REPLACE VIEW TV_SEP_DOC AS
-- View criada para separacao web em genexus
SELECT DISTINCT 
       ORIGEM, DOCUME, FILCLI, CODCLI,
       CAST(CASE WHEN FLGEST='D' THEN 'D'
                 WHEN TIPENT='3' THEN 'R'
                 ELSE 'A'
            END AS VARCHAR(1)) AS TIPSEP,
       DATHOR,FILPED,TIPPED,NUMPED, NUMPED_RE,
       FILIVE,SEQIVE, DEPART, FILIPE, NUMIPE,
       FILRET, FILRET_NOME, TIPENT, SISORI, TELEVE, FLGECO, TIPPAG
  FROM TV_IVO
 WHERE FLGEST IN ('A','D')
   AND ORIGEM IN ('O','V', CASE WHEN (LeParametroBoo('SEPARACAO_REPOSICAO', CODFIL,'','','') = 'T') THEN 'P' ELSE 'O' END)
   AND QTDSEP <> 0
   AND COALESCE(IPE_FLGEST, 'X') <> 'C'
   AND COALESCE(FLGECO, 'P') <> '0';


/*-- SEQ 2920 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_SIM CASCADE;

/*-- SEQ 2921 --*/
CREATE OR REPLACE VIEW TV_SIM AS
select datmax, datope, ibserv, iblice, to_number(numenf) as numenf, NumNFES, max(to_number(vlrtot)) as vlrtot, max(to_number(qtdpar)) as qtdpar,
       to_number(numpar) as numpar, to_number(vlrpar) as vlrpar, max(datven) as datven, max(datrec) as datrec, sum(to_number(vlrpag)) as vlrpag,
       min(to_number(vsaldo)) as vsaldo, min(to_number(vincob)) as vincob, ibcanc, ibdevl, codfil, portad from (
select datmax,
       cast(trunc(dataoperacao) as Timestamp) as datope,
       case when flgcan='C' then 'X' else servico end     as ibserv,
       case when flgcan='C' then '' else material end     as iblice,
       numdocumento as numenf, NumNFES, flgcan, flgest,
       case when flgcan <> 'C' and (numparcela < 2 or numparcela is null) then to_char(valortotal)
                               else '0'
       end as vlrtot,
       case when (flgcan <> 'C' and codnat not in (5,13,23,30)) then to_char(qtdparcelas)
                                                                   else '0'
       end as qtdpar,
       case when (flgcan <> 'C' and codnat not in (5,13,23,30)) then to_char(numparcela)
                                                                   else '0'
       end as numpar,
       case when (flgcan <> 'C' and codnat not in (5,13,23,30)) then to_char(valorparcela)
                                                                   else '0'
       end as vlrpar,
       case when (flgcan <> 'C' and codnat not in (5,13,23,30)) then cast(trunc(datavencimento) as Timestamp)
                                                                   else cast(null as Timestamp)
       end as datven,
       case when (flgcan <> 'C' and codnat not in (5,13,23,30) and cast(trunc(datarecebimento) as Timestamp) <= datmax)
            then cast(trunc(datarecebimento) as Timestamp)
            else cast(null as Timestamp)
       end as datrec,
       case when (flgcan <> 'C' and codnat not in (5,13,23,30) and cast(trunc(datarecebimento) as Timestamp) <= datmax)
            then to_char(valorpago-case when  desconto < 0 then DESCONTO*-1 else 0 end)
            else '0'
       end as vlrpag,
       case when (flgcan <> 'C' and codnat not in (5,13,23,30) and cast(trunc(datarecebimento) as Timestamp) <= datmax)
            then to_char(case when saldo > 0 then saldo
            else 0
                                            end)
                               else '0'
       end as vsaldo,
       case when (flgcan <> 'C' and codnat not in (5,13,23,30) and cast(trunc(datarecebimento) as Timestamp) <= datmax)
            then to_char(case when  desconto < 0 then DESCONTO*-1    --numparcela = qtdparcelas  and
            else 0
                                            end)
                               else '0'
       end as vincob, -- Caso esteja quitada a fatura
       case when flgcan = 'C'  then 'X'
                               else ''
       end AS IBCANC,
       case when codnat in (5,13,23,30) then 'X'
                                           else ''
       end AS IBDEVL,
       codfil,
       coalesce(portad, -99) as portad
from ( -- Foi dividido entre servio e licena, fazendo o rateio dos valores
       -- O arredondamento serve para os casos de valor impar, para no perder 1 centavo, caso a terceira casa fique em 5, arredonda uma para cima e outro para baixo
       select dat.datope as datmax,
              TRIM(COALESCE((SELECT NEV.NUMNOT FROM TT_VEN NEV WHERE NEV.CODFIL = VEN.CODFIL AND NEV.SEQUEN = VEN.SEQFAT), SUBSTR(VEN.DOCUME, 8, 10)))
              AS NumDocumento,
              TRIM(to_char(COALESCE((SELECT RP1.NUMNFS FROM TT_RPS RP1 WHERE RP1.CODFIL = VEN.CODFIL AND RP1.SEQUEN = VEN.SEQFAT), RPS.NUMNFS)))
              AS NumNFES,
              COALESCE((SELECT NEV.CODSER FROM TV_VEN NEV WHERE NEV.CODFIL = VEN.CODFIL AND NEV.SEQUEN = VEN.SEQFAT), VEN.CODSER ) AS CODSER_FAT,
              'X' as Material,
              '' as servico,
              ven.dathor AS DataOperacao,
              round(ven.vlrliq * ((select sum(case when ipro.tippro=0 then iive.vlrmov else 0 end)
                               from tt_ive iive inner join tt_pro ipro on iive.filmat=ipro.filmat and iive.codmat=ipro.codmat
                              where iive.codfil = ven.codfil
                                and iive.sequen = ven.sequen
                                and (iive.sitmov = 'N' or (iive.sitmov = 'C' and ven.flgest = 'C'))
                                and iive.sitkit IN ('2','3')
                                ) / ven.vlrnot) +0.001, 2)
              AS ValorTotal,
              (SELECT count(*) FROM TT_REC R WHERE R.CODFIL = REC.CODFIL AND R.SEQUEN = REC.SEQUEN and r.flgest not in ('C', 'X') GROUP BY R.CODFIL, R.SEQUEN)
              AS QtdParcelas,
              1+coalesce((SELECT count(*) FROM TT_REC R WHERE (R.NUMPAR < REC.NUMPAR OR (R.NUMPAR = REC.NUMPAR AND R.SUBPAR < REC.SUBPAR)) AND R.CODFIL = REC.CODFIL AND R.SEQUEN = REC.SEQUEN and r.flgest not in ('C', 'X') GROUP BY R.CODFIL, R.SEQUEN), 0)
              as NumParcela,
              round((select irec.vlrpar from tt_rec irec where irec.codfil=rec.codfil and irec.sequen=rec.sequen and irec.numpar=rec.numpar and irec.subpar=' 0') *
                ((select sum(case when ipro.tippro=0 then iive.vlrmov else 0 end)
                    from tt_ive iive inner join tt_pro ipro on iive.filmat=ipro.filmat and iive.codmat=ipro.codmat
                   where iive.codfil = ven.codfil
                     and iive.sequen = ven.sequen
                     and (iive.sitmov = 'N' or (iive.sitmov = 'C' and ven.flgest = 'C'))
                     and iive.sitkit IN ('2','3')
                     ) / ven.vlrnot) +0.001, 2)
              as VALORparcela,
              round(CASE WHEN (REC.FLGEST = 'P' OR REC.SEQCHE IS NOT NULL) THEN COALESCE(REC.VLRPGT,0) + COALESCE(REC.VLRTAX,0) - DescontoParcela(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)
                   ELSE 0
              END * ((select sum(case when ipro.tippro=0 then iive.vlrmov else 0 end)
                        from tt_ive iive inner join tt_pro ipro on iive.filmat=ipro.filmat and iive.codmat=ipro.codmat
                       where iive.codfil = ven.codfil
                         and iive.sequen = ven.sequen
                         and (iive.sitmov = 'N' or (iive.sitmov = 'C' and ven.flgest = 'C'))
                         and iive.sitkit IN ('2','3')
                         ) / ven.vlrnot) +0.001, 2)
              as ValorPago,
              round(DescontoParcela(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) *
                ((select sum(case when ipro.tippro=0 then iive.vlrmov else 0 end)
                    from tt_ive iive inner join tt_pro ipro on iive.filmat=ipro.filmat and iive.codmat=ipro.codmat
                   where iive.codfil = ven.codfil
                     and iive.sequen = ven.sequen
                     and (iive.sitmov = 'N' or (iive.sitmov = 'C' and ven.flgest = 'C'))
                     and iive.sitkit IN ('2','3')
                     ) / ven.vlrnot) +0.001, 2)
              as Desconto,
              round(CASE WHEN DescontoParcela(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)>=0 THEN
                      VLRPAR-CASE WHEN (REC.FLGEST = 'P' OR REC.SEQCHE IS NOT NULL) THEN COALESCE(REC.VLRPGT,0) + COALESCE(REC.VLRTAX,0) - DescontoParcela(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)
                                  ELSE 0
                             END- DescontoParcela(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)
              end *
                ((select sum(case when ipro.tippro=0 then iive.vlrmov else 0 end)
                    from tt_ive iive inner join tt_pro ipro on iive.filmat=ipro.filmat and iive.codmat=ipro.codmat
                   where iive.codfil = ven.codfil
                     and iive.sequen = ven.sequen
                     and (iive.sitmov = 'N' or (iive.sitmov = 'C' and ven.flgest = 'C'))
                     and iive.sitkit IN ('2','3')
                     ) / ven.vlrnot) +0.001, 2)
              as Saldo,
              rec.datven as DataVencimento,
              rec.pagame as DataRecebimento,
              rec.flgest,
              ven.codfil,
              ven.sequen,
              ven.codser,
              rec.filrec,
              ven.flgest as flgcan,
              VEN.CODNAT,
              ven.codcli,
              cob.codtab as portad
   from tv_ven ven inner join td_nat nat on ven.codnat=nat.codtab
                    left join tt_rec rec on ven.codfil=rec.codfil and ven.sequen=rec.sequen and rec.flgest not in ('C', 'X')
                    left join td_cob cob on rec.portad=cob.codtab
                    left join tt_rps rps on rps.codfil=ven.codfil and rps.sequen=ven.sequen
                   cross join tt_dat dat
  where (select sum(case when ipro.tippro=0 then 1 else 0 end)
           from tt_ive iive inner join tt_pro ipro on iive.filmat=ipro.filmat and iive.codmat=ipro.codmat
          where iive.codfil = ven.codfil
            and iive.sequen = ven.sequen
            and (iive.sitmov = 'N' or (iive.sitmov = 'C' and ven.flgest = 'C'))
            and iive.sitkit IN ('2','3')
            ) > 0
UNION ALL
       select dat.datope as datmax,
              TRIM(COALESCE((SELECT NEV.NUMNOT FROM TT_VEN NEV WHERE NEV.CODFIL = VEN.CODFIL AND NEV.SEQUEN = VEN.SEQFAT), SUBSTR(VEN.DOCUME, 8, 10)))
              AS NumDocumento,
              TRIM(to_char(COALESCE((SELECT RP1.NUMNFS FROM TT_RPS RP1 WHERE RP1.CODFIL = VEN.CODFIL AND RP1.SEQUEN = VEN.SEQFAT), RPS.NUMNFS)))
              AS NumNFES,
              COALESCE((SELECT NEV.CODSER FROM TV_VEN NEV WHERE NEV.CODFIL = VEN.CODFIL AND NEV.SEQUEN = VEN.SEQFAT), VEN.CODSER ) AS CODSER_FAT,
              '' as material,
              'X' as Servico,
              ven.dathor AS DataOperacao,
              round(ven.vlrliq * ((select sum(case when ipro.tippro=1 then iive.vlrmov else 0 end)
                               from tt_ive iive inner join tt_pro ipro on iive.filmat=ipro.filmat and iive.codmat=ipro.codmat
                              where iive.codfil = ven.codfil
                                and iive.sequen = ven.sequen
                                and (iive.sitmov = 'N' or (iive.sitmov = 'C' and ven.flgest = 'C'))
                                and iive.sitkit IN ('2','3')
                                ) / ven.vlrnot) -0.001, 2)
              AS ValorTotal,
              (SELECT count(*) FROM TT_REC R WHERE R.CODFIL = REC.CODFIL AND R.SEQUEN = REC.SEQUEN and r.flgest not in ('C', 'X') GROUP BY R.CODFIL, R.SEQUEN)
              AS QtdParcelas,
              1+coalesce((SELECT count(*) FROM TT_REC R WHERE (R.NUMPAR < REC.NUMPAR OR (R.NUMPAR = REC.NUMPAR AND R.SUBPAR < REC.SUBPAR)) AND R.CODFIL = REC.CODFIL AND R.SEQUEN = REC.SEQUEN and r.flgest not in ('C', 'X') GROUP BY R.CODFIL, R.SEQUEN), 0)
              as NumParcela,
              round((select irec.vlrpar from tt_rec irec where irec.codfil=rec.codfil and irec.sequen=rec.sequen and irec.numpar=rec.numpar and irec.subpar=' 0') *
                ((select sum(case when ipro.tippro=1 then iive.vlrmov else 0 end)
                    from tt_ive iive inner join tt_pro ipro on iive.filmat=ipro.filmat and iive.codmat=ipro.codmat
                   where iive.codfil = ven.codfil
                     and iive.sequen = ven.sequen
                     and (iive.sitmov = 'N' or (iive.sitmov = 'C' and ven.flgest = 'C'))
                     and iive.sitkit IN ('2','3')
                     ) / ven.vlrnot) -0.001, 2)
              as VALORparcela,
              round(CASE WHEN (REC.FLGEST = 'P' OR REC.SEQCHE IS NOT NULL) THEN COALESCE(REC.VLRPGT,0) + COALESCE(REC.VLRTAX,0) - DescontoParcela(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)
                   ELSE 0
              END * ((select sum(case when ipro.tippro=1 then iive.vlrmov else 0 end)
                        from tt_ive iive inner join tt_pro ipro on iive.filmat=ipro.filmat and iive.codmat=ipro.codmat
                       where iive.codfil = ven.codfil
                         and iive.sequen = ven.sequen
                         and (iive.sitmov = 'N' or (iive.sitmov = 'C' and ven.flgest = 'C'))
                         and iive.sitkit IN ('2','3')
                         ) / ven.vlrnot) -0.001, 2)
              as ValorPago,
              round(DescontoParcela(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) *
                ((select sum(case when ipro.tippro=1 then iive.vlrmov else 0 end)
                    from tt_ive iive inner join tt_pro ipro on iive.filmat=ipro.filmat and iive.codmat=ipro.codmat
                   where iive.codfil = ven.codfil
                     and iive.sequen = ven.sequen
                     and (iive.sitmov = 'N' or (iive.sitmov = 'C' and ven.flgest = 'C'))
                     and iive.sitkit IN ('2','3')
                     ) / ven.vlrnot) -0.001, 2)
              as Desconto,
              round(CASE WHEN DescontoParcela(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)>=0 THEN
                      VLRPAR-CASE WHEN (REC.FLGEST = 'P' OR REC.SEQCHE IS NOT NULL) THEN COALESCE(REC.VLRPGT,0) + COALESCE(REC.VLRTAX,0) - DescontoParcela(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)
                                  ELSE 0
                             END- DescontoParcela(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)
              end *
                ((select sum(case when ipro.tippro=1 then iive.vlrmov else 0 end)
                    from tt_ive iive inner join tt_pro ipro on iive.filmat=ipro.filmat and iive.codmat=ipro.codmat
                   where iive.codfil = ven.codfil
                     and iive.sequen = ven.sequen
                     and (iive.sitmov = 'N' or (iive.sitmov = 'C' and ven.flgest = 'C'))
                     and iive.sitkit IN ('2','3')
                     ) / ven.vlrnot) -0.001, 2)
              as Saldo,
              rec.datven as DataVencimento,
              rec.pagame as DataRecebimento,
              rec.flgest,
              ven.codfil,
              ven.sequen,
              ven.codser,
              rec.filrec,
              ven.flgest as flgcan,
              VEN.CODNAT,
              ven.codcli,
              cob.codtab as portad
   from tv_ven ven inner join td_nat nat on ven.codnat=nat.codtab
                    left join tt_rec rec on ven.codfil=rec.codfil and ven.sequen=rec.sequen and rec.flgest not in ('C', 'X')
                    left join td_cob cob on rec.portad=cob.codtab
                    left join tt_rps rps on rps.codfil=ven.codfil and rps.sequen=ven.sequen
                   cross join tt_dat dat
  where (select sum(case when ipro.tippro=1 then 1 else 0 end)
           from tt_ive iive inner join tt_pro ipro on iive.filmat=ipro.filmat and iive.codmat=ipro.codmat
          where iive.codfil = ven.codfil
            and iive.sequen = ven.sequen
            and (iive.sitmov = 'N' or (iive.sitmov = 'C' and ven.flgest = 'C'))
            and iive.sitkit IN ('2','3')
            ) > 0
   ) tab
   where tab.codser not in ('ND','S1','U1')
     and tab.CODSER_FAT not in ('ND','S1','U1', 'CC')
     and (tab.datavencimento is not null or tab.codnat in (5,13,23,30,18,29) or tab.flgcan = 'C')
     and ((not (tab.flgest = 'C' and tab.flgcan = 'Q')) or tab.codnat in (5,13,23,30,18,19))
     and to_number(tab.codcli) <> 0
     and (codfil = '001' or CODSER_FAT not in ('UN'))
     and (((tab.codfil = '001') and (to_number(numdocumento) > 15000 or tab.codser_fat = 'SE')) -- 001
      or ((tab.codfil = '002') and (to_number(numdocumento) > 2500 or tab.codser_fat = 'SE'))) -- 002
     and DataOperacao > to_date('02/01/2009','dd/mm/yyyy')
) m
group by datmax, datope, ibserv, iblice, numenf, numnfes, numpar, vlrpar, ibcanc, ibdevl, codfil, portad
order by TO_NUMBER(numenf), ibserv, TO_NUMBER(numpar), (datope), (datrec);


/*-- SEQ 2922 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_STS_SINUELO CASCADE;

/*-- SEQ 2923 --*/
CREATE OR REPLACE VIEW TV_STS_SINUELO AS
-- situacao tributaria na caracterizacao para sinuelo
-- view elaborada para relatorio da sinuelo
-- tarefa: 71269
SELECT CAST('COM' AS CHAR(3)) AS TIPREG,
       VALORCRT_STRING('P',
                       (SELECT CODTAB 
                          FROM TD_CRT 
                         WHERE DESCRT = 'Situao Tributria'),
                       VCRP.FILMAT,
                       VCRP.CODMAT) AS SITTRI,
       ICO.SITMOV,
       ICO.VLRMOV,
       COM.CODFIL,
       COM.FILFOR||'-'||TRIM(COM.CODFOR)||'-'||COM.DOCUME AS DOCUME,
       CAST(COM.NATURE AS VARCHAR(6)) AS NATURE,
       COM.DATOPE AS DATFIS,
       COM.DATCMP AS DATMOV,
       COM.VLRTOT,
       COM.VLRLIQ,
       COM.VLRBON,
       COM.FILCTA,
       COM.SEQCTA,
       COM.TIPCTA,
       CTA.TITCTA,
       COALESCE(COM.VLRTOT,0) * ((ICO.VLRMOV*(1+COALESCE(ICO.IPIITE,0)/100)) / COM.VLRTOT) AS VLRTOT_ITEM,
       COALESCE(COM.VLRLIQ,0) * ((ICO.VLRMOV*(1+COALESCE(ICO.IPIITE,0)/100)) / COM.VLRTOT) AS VLRLIQ_ITEM,
       COALESCE(COM.VLRBON,0) * ((ICO.VLRMOV*(1+COALESCE(ICO.IPIITE,0)/100)) / COM.VLRTOT) AS VLRBON_ITEM
  FROM TV_CRTXPRO VCRP INNER JOIN TT_PRO PRO  ON VCRP.FILMAT = PRO.FILMAT 
                                             AND VCRP.CODMAT = PRO.CODMAT
                       INNER JOIN TT_GRA GRA  ON PRO.FILMAT = GRA.FILMAT 
                                             AND PRO.CODMAT = GRA.CODMAT
                       INNER JOIN TT_ICO ICO  ON GRA.FILMAT = ICO.FILMAT 
                                             AND GRA.CODMAT = ICO.CODMAT 
                                             AND GRA.CODCOR = ICO.CODCOR 
                                             AND GRA.CODTAM = ICO.CODTAM
                       INNER JOIN TV_COM COM  ON ICO.CODFIL = COM.CODFIL
                                             AND ICO.SEQUEN = COM.SEQUEN                                              
                       INNER JOIN TT_CTA CTA  ON CTA.CODFIL = COM.FILCTA 
                                             AND CTA.SEQUEN = COM.SEQCTA 
                                             AND CTA.TIPCTA = COM.TIPCTA
UNION ALL
SELECT CAST('VEN' AS CHAR(3)) AS TIPREG,
       VALORCRT_STRING('P',
                       (SELECT CODTAB 
                          FROM TD_CRT 
                         WHERE DESCRT = 'Situao Tributria'),
                       VCRP.FILMAT,
                       VCRP.CODMAT) AS SITTRI,
       IVE.SITMOV,
       IVE.VLRMOV,
       VEN.CODFIL,
       CAST(DECF.FILECF||' - '||DECF.NUMECF AS VARCHAR(15)) AS DOCUME, 
       CASE WHEN VEN.UFLOJA = 'T' THEN DNAT.NATDEN ELSE DNAT.NATFOR END AS NATURE,
       VEN.DATFIS,
       VEN.DATHOR AS DATMOV,
       VEN.VLRNOT AS VLRTOT,
       VEN.VLRLIQ,
       CAST(0 AS Numeric(12,2)) AS VLRBON,
       CTA.CODFIL AS FILCTA,
       CTA.SEQUEN AS SEQCTA,
       CTA.TIPCTA,
       CTA.TITCTA, 
       COALESCE(VEN.VLRNOT,0) * (CASE WHEN VEN.VLRNOT = 0 THEN 0 ELSE IVE.VLRMOV/VEN.VLRNOT END) AS VLRTOT_ITEM,
       COALESCE(VEN.VLRLIQ,0) * (CASE WHEN VEN.VLRNOT = 0 THEN 0 ELSE IVE.VLRMOV/VEN.VLRNOT END) AS VLRLIQ_ITEM,
       CAST(0 AS Numeric(12,2)) AS VLRBON_ITEM
  FROM TV_CRTXPRO VCRP INNER JOIN TT_PRO PRO  ON VCRP.FILMAT = PRO.FILMAT
                                             AND VCRP.CODMAT = PRO.CODMAT 
                       INNER JOIN TT_GRA GRA  ON PRO.FILMAT = GRA.FILMAT
                                             AND PRO.CODMAT = GRA.CODMAT
                       INNER JOIN TT_IVE IVE  ON GRA.FILMAT = IVE.FILMAT
                                             AND GRA.CODMAT = IVE.CODMAT
                                             AND GRA.CODCOR = IVE.CODCOR
                                             AND GRA.CODTAM = IVE.CODTAM
                       INNER JOIN TT_VEN VEN  ON IVE.CODFIL = VEN.CODFIL
                                             AND IVE.SEQUEN = VEN.SEQUEN
                       INNER JOIN TD_CTR DCTR ON VEN.CODCTR = DCTR.CODTAB
                       INNER JOIN TT_CTA CTA  ON CTA.CODFIL = DCTR.CTRFIL
                                             AND CTA.SEQUEN = DCTR.CTRSEQ
                                             AND CTA.TIPCTA = DCTR.CTRTIP
                                             AND CTA.USOCTA = DCTR.CTRUSO
                       INNER JOIN TD_ECF DECF ON DECF.FILECF = VEN.CODFIL
                                             AND DECF.NUMECF = VEN.NUMECF
                       INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
 WHERE IVE.SITKIT <> '1'
   AND IVE.SITMOV <> 'C'
   AND VEN.FLGEST in ('A', 'Q')
;


/*-- SEQ 2924 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_UNF CASCADE;

/*-- SEQ 2925 --*/
CREATE OR REPLACE VIEW TV_UNF AS
SELECT 'R'||COM.CODFIL||LPAD(TRIM(COM.SEQUEN),10,'0') AS DOC_CODIGO,
       COM.CODFIL AS DOC_CODFIL,
       COM.SEQUEN AS DOC_SEQUEN,
       COM.NUMNOT AS DOC_NUMNOT,
       CASE WHEN COM.DATCMP > COM.DATOPE THEN COM.DATOPE ELSE COM.DATCMP END AS DOC_DATDOC,
       COM.DATOPE AS DOC_DATOPE,
       NULL AS DOC_DOCNFP,
       NULL AS CTADOC_CODEXT,
       COM.VLRLIQ AS DOC_VLRLIQ,
       COM.DESCON AS DOC_DESCON,
       COM.VLRPIS AS DOC_VLRPIS,
       COM.VLRCOF AS DOC_VLRCOF,
       COM.VLRTOT AS DOC_VLRTOT,
       CAST('F' AS CHAR(1)) AS DOC_UFLOJA,
       '00' AS DOC_FLGEST,
       COM.BASICM AS DOC_BASICM,
       COM.VLRICM AS DOC_VLRICM,
       COM.VLRFRE AS COM_VLRFRE,
       COM.ISEICM AS DOC_ISEICM,
       0          AS DOC_VLRIPI,
       COM.CHAVEA AS DOC_CHAVEA,
       COM.VLRFRE AS DOC_VLRFRE,
       0          AS DOC_VLRSEG,
       COM.OUTTAX AS DOC_OUTTAX,
       (SELECT SUM(ICO2.BASSUBDIF)
          FROM TT_ICO ICO2
         WHERE ICO2.CODFIL = COM.CODFIL
           AND ICO2.SEQUEN = COM.SEQUEN) AS DOC_BASSUB,
       (SELECT SUM(ICO3.VLR_STDIF)
          FROM TT_ICO ICO3
         WHERE ICO3.CODFIL = COM.CODFIL
           AND ICO3.SEQUEN = COM.SEQUEN) AS DOC_SUBSTT,
       COM.TIPNOT AS DOC_TIPNOT,
       TRANSLATE(Rtf2txt(replace(replace(COALESCE(COM.OBSFAT,COM.OBSERV),chr(13),''),chr(10),'')),'',' ') AS DOC_OBSFIS,
       COM.PERICM AS DOC_PERICM,
       COM.PERFRE AS COM_PERFRE,
       COM.CODFCE AS COM_CODFCE,
       COM.TIPFRE AS DOC_TIPFRE,
       COM.TIPPAR AS COM_TIPPAR,
       0          AS DOC_BASISS,
       COM.VLRISS AS DOC_VLRISS,
       COM.PERISS AS DOC_PERISS,
       0          AS DOC_BASIRR,
       COM.VLRIRR AS DOC_VLRIRR,
       COM.PERIRR AS DOC_PERIRR,
       COM.BASFRE AS COM_BASFRE,
       COM.ICMFRE AS COM_ICMFRE,
       COM.CODFIL AS DOC_FILORI,
       COM.SEQFAT AS DOC_SEQORI,
       FIS.MODNOT AS FIS_MODNOT,
       TRIM(FIS.SEREXP) AS FIS_CODSER,
       FIS.SUBEXP AS FIS_SUBSER,
       'R'||ICO.CODFIL||LPAD(TRIM(ICO.SEQUEN),10,'0')||LPAD(to_char(ICO.NUMITE),5,'0') AS ITE_CODIGO,
       NULL AS ITE_NATFIS,
       COALESCE(ICO.CODORI, 0)||COALESCE(ICO.CODCST, '  ') AS ITE_CODCST,
       ICO.CODFIL AS ITE_CODFIL,
       ICO.NUMITE AS ITE_NUMITE,
       ICO.QTDMOV AS ITE_QTDMOV,
       ICO.VLRDES AS ITE_VLRDES,
       ICO.VLRMOV AS ITE_VLRMOV,
       ICO.TIPPRO AS ITE_TIPPRO,
       ICO.ICMTIP AS ITE_ICMTIP,
       ICO.REDITEDIF AS ITE_REDITE,
       ICO.BASICMDIF AS ITE_BASICM,
       ICO.VLRICMDIF AS ITE_VLRICM,
       0 AS ITE_CALSUB,
       ICO.ICMITEDIF AS ITE_TAXICM,
       0 AS ITE_VLRIPI,
       ICO.ISEICM AS ITE_ISEICM,
       ICO.LANEST AS ITE_LANEST,
       ICO.VLRPIS AS ITE_VLRPIS,
       ICO.VLRCOF AS ITE_VLRCOF,
       ICO.BASIPI AS ITE_BASIPI,
       ICO.IPIITE AS ITE_TAXIPI,
       ICO.SITPIS AS ITE_SITPIS,
       ICO.BASPIS AS ITE_BASPIS,
       ICO.PERPIS AS ITE_PERPIS,
       ICO.SITCOF AS ITE_SITCOF,
       ICO.BASCOF AS ITE_BASCOF,
       ICO.PERCOF AS ITE_PERCOF,
       ICO.BASSUBDIF AS ITE_BASSUB,
       ICO.VLR_STDIF AS ITE_VLR_ST,
       ICO.ICMVENDIF AS ITE_ICMVEN,
       ICO.RED_STDIF AS ITE_RED_ST,
       ICO.SITMOV AS ITE_SITMOV,
       ICO.IPIFRE AS ITE_IPIFRE,
       ICO.ICO_VLRFRE AS ITE_VLRFRE,
       ICO.VLRMOV/NVLZ(ICO.QTDMOV,1) AS ITE_VLRUNI,
       ICO.VLRMOV AS ICO_VLRMOV,
       ICO.VLRITE AS ICO_VLRITE,
       IPR.FILMAT||LPAD(TRIM(IPR.SEQUEN),10,'0') AS PRO_CODIGO,
       IPR.REFPRO AS PRO_REFPRO,
       NomeProduto(IPR.DESECF, IPR.DESMAT, IPR.CODCOR, IPR.ITEDIV,
                   IPR.CODTAM, IPR.ITESUB, IPR.ESPMAT, IPR.DESGRA) AS PRO_NOMPRO,
       (SELECT MIN(EAN.CODEAN)
          FROM TT_EAN EAN
         WHERE EAN.FILMAT = IPR.FILMAT
           AND EAN.CODMAT = IPR.CODMAT
           AND EAN.CODCOR = IPR.CODCOR
           AND EAN.CODTAM = IPR.CODTAM) AS PRO_CODEAN,
       IPR.CODFPS AS PRO_CODFPS,
       IPR.CODNCM AS PRO_CODNCM,
       IPR.COD_EX AS PRO_COD_EX,
       SUBSTR(IPR.CODNCM,1,2) AS PRO_GENNCM,
       IPR.CODSRV AS PRO_CODSRV,
       ICM.RESICM AS PRO_PERICM,
       IPR.CODANP AS PRO_CODANP,
       IPR.SITIPI AS PRO_SITIPI,
       IPR.CODEXT AS PRO_CODEXT,
       MED.CODTAB AS MED_CODTAB,
       MED.MEDATI AS MED_MEDATI,
       MED.UNIMED AS MED_UNIMED,
       MED.DESMED AS MED_DESMED,
       CLI.FILCLI||LPAD(TRIM(CLI.CODCLI),6,'0') AS PAR_CODIGO,
       CLI.FILCLI AS PAR_FILCLI,
       CLI.CODCLI AS PAR_CODCLI,
       CLI.NOMCLI AS PAR_NOMCLI,
       CLI.CODPAI AS PAR_CODPAI,
       COALESCE(CLI.NUMDOC, VIN.NUMDOC) AS PAR_NUMDOC,
       CASE WHEN CLI.TIPDOC='IE' THEN CLI.INSEST END AS PAR_INSEST,
       CLI.SUFRAM AS PAR_SUFRAM,
       CLI.FLGTIP AS PAR_FLGTIP,
       MUN.CODIBG AS MUN_CODIBG,
       ENDE.ENDERE AS ENC_ENDERE,
       (ENDE.ENDERE||' - '||ENDE.NOMCID||', '||DPAI.DESPAI) AS ENC_ENDERE_ESTRAN,
       ENDE.NUMERO AS ENC_NUMERO,
       ENDE.COMPLE AS ENC_COMPLE,
       ENDE.BAIRRO AS ENC_BAIRRO,
       ENDE.CODPAI AS ENC_CODPAI,
       ENDE.SIGEST AS ENC_SIGEST,
       ENDE.NUMDOC AS ENC_NUMDOC,
       CASE WHEN CLI.TIPDOC='IE' THEN ENDE.INSEST END AS ENC_INSEST,
       CLI.FILCLI||LPAD(TRIM(CLI.CODCLI),6,'0')||ENDE.CODFIL||LPAD(to_char(ENDE.NUMEND),4,'0') AS ENC_CODIGO,
       SUBORI.FATCON AS SUBORI_FATCON,
       MEDEMB.CODTAB AS MEDEMB_CODTAB,
       MEDEMB.MEDATI AS MEDEMB_MEDATI,
       MEDEMB.UNIMED AS MEDEMB_UNIMED,
       MEDEMB.DESMED AS MEDEMB_DESMED,
       TRI.CODTRI AS TRI_CODTRI,
       CFO.CODCFO AS DOC_CODNAT,
       CFO.DESCFO AS DOC_DESNAT,
       ICFO.CODCFO AS ITE_CODNAT,
       ICFO.DESCFO AS ITE_DESNAT,
       CFG.VC_FILCLI AS CFG_VC_FILCLI,
       CFG.VC_CODCLI AS CFG_VC_CODCLI,
       TRA.FILICO AS TRA_FILITE,
       0 AS ITE_VLRLIQ
  FROM (SELECT DISTINCT CODSER,
               CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER,
               SEREXP, SUBEXP, MODNOT, ORIGEM
          FROM TT_FIS
         WHERE ORIGEM IN ('C','F')
           AND EXPORT = 'T') FIS
       INNER JOIN TV_CMP COM ON FIS.CODSER = COM.CODSER
                          AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$')
                          AND FIS.ORIGEM = CASE WHEN COALESCE(COM.TIPPAR,'F') = 'T'
                                                THEN 'F' ELSE 'C' END
       INNER JOIN TT_CLI CLI ON CLI.FILCLI = COM.FILFOR
                            AND CLI.CODCLI = COM.CODFOR
       INNER JOIN TD_CFO CFO ON COM.CODCFO = CFO.CODTAB
       LEFT  JOIN TT_CLI VIN ON VIN.FILCLI = CLI.FILVIN
                            AND VIN.CODCLI = CLI.CODVIN
                            AND CLI.FLGTIP <> 0
       LEFT  JOIN TT_END ENDE ON ENDE.FILCLI = COM.FILFOR
                             AND ENDE.CODCLI = COM.CODFOR
                             AND ENDE.CODFIL = COALESCE(COM.FILEND, ENDE.CODFIL)
                             AND ENDE.NUMEND = COALESCE(COM.NUMEND,1)
       LEFT  JOIN TT_ICO ICO ON ICO.CODFIL = COM.CODFIL
                            AND ICO.SEQUEN = COM.SEQUEN
                            AND ICO.SITMOV = 'N'
       LEFT JOIN TT_TRA TRA ON ICO.CODFIL = TRA.FILICO
                           AND ICO.SEQUEN = TRA.SEQICO
                           AND ICO.NUMITE = TRA.NUMICO
       LEFT  JOIN TD_CFO ICFO ON ICO.CODCFO = ICFO.CODTAB
       LEFT  JOIN (SELECT GRA.FILMAT, GRA.SEQUEN, GRA.CODMAT,
                          GRA.CODCOR, GRA.CODTAM, PRO.CODNCM,
                          GRA.UNIDAD,
                          PRO.DESECF, PRO.DESMAT, PRO.ESPMAT,
                          PRO.CODFPS, PRO.COD_EX, PRO.CODSRV,
                          PRO.CODANP, PRO.SITIPI,
                          DIV.CODITE AS DIV_CODITE,
                          DIV.NOMITE AS ITEDIV,
                          SUB.CODITE AS SUB_CODITE,
                          SUB.NOMITE AS ITESUB,
                          GRA.CODEXT,
                          GRA.REFPRO,
                          GRA.DESGRA
                     FROM TT_GRA GRA LEFT JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT
                                                          AND PRO.CODMAT = GRA.CODMAT
                                     LEFT JOIN TT_DIV DIV ON GRA.CODCOR = DIV.CODITE
                                     LEFT JOIN TT_SUB SUB ON GRA.CODTAM = SUB.CODITE) IPR
                             ON IPR.FILMAT = ICO.FILMAT
                            AND IPR.CODMAT = ICO.CODMAT
                            AND IPR.CODCOR = ICO.CODCOR
                            AND IPR.CODTAM = ICO.CODTAM
       LEFT  JOIN TD_MED MED ON IPR.UNIDAD = MED.CODTAB
       LEFT  JOIN TD_FIL FIL ON FIL.CODFIL = COM.CODFIL
       LEFT  JOIN TT_IUF IUF ON IPR.FILMAT = IUF.FILMAT AND IPR.CODMAT = IUF.CODMAT
                            AND FIL.UFLOJA = IUF.ESTADO AND FIL.REGESP = IUF.REGESP
       LEFT  JOIN TD_ICM ICM ON IUF.RESICM = ICM.CODTAB
       LEFT  JOIN TT_MUN MUN ON MUN.CODIGO = ENDE.CODCID
       LEFT  JOIN TT_SUB SUBORI ON ICO.EMBORI = SUBORI.CODITE
       LEFT  JOIN TT_GRA GRAORI ON GRAORI.FILMAT = ICO.FILMAT
                               AND GRAORI.CODMAT = ICO.CODMAT
                               AND GRAORI.CODCOR = ICO.CODCOR
                               AND GRAORI.CODTAM = ICO.EMBORI
       LEFT  JOIN TD_MED MEDEMB ON GRAORI.UNIDAD = MEDEMB.CODTAB
       LEFT  JOIN TD_TRI TRI ON COM.CODTRI = TRI.CODTAB
       LEFT  JOIN TD_PAI DPAI ON ENDE.CODPAI = DPAI.CODPAI
       CROSS JOIN TT_CFG CFG
 WHERE 1=1
   --AND COM.CODFIL = '006'
   --AND COM.DATOPE BETWEEN TO_DATE('01/06/2011','DD/MM/YYYY') AND TO_DATE('30/06/2011','DD/MM/YYYY')
   AND COM.FLGEST <> 'D'
   AND COM.NUMNOT NOT LIKE '###%'
;


/*-- SEQ 2926 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_VND CASCADE;

/*-- SEQ 2927 --*/
CREATE OR REPLACE VIEW TV_VND AS
SELECT CLI.FILCLI, CLI.CODCLI, CLI.ATU_EM, CLI.NOMCLI, CLI.ULTNOM, CLI.NUMDOC, CLI.DOCCON, CLI.DATNAS, 
       CLI.ESTCIV, CLI.HOMPGE, CLI.FLGTIP, CLI.INSEST, CLI.CODSEX, CLI.CATEG1, CLI.CATEG2, CLI.CATEG3,
       CLI.DATA01, CLI.DATA02, CLI.DATA03, CLI.DATOPE, CLI.IMPRIM, CLI.VALOR1, CLI.TOTATR, CLI.TOTPAR,
       CLI.MAIATR, CLI.OBSERV, CLI.FILPLA, CLI.CODPLA, CLI.PORPAD, CLI.ULTCOM, CLI.SIGNAT, CLI.CONJUG, 
       CLI.NASCON, CLI.SEXCON, CLI.FILVEN, CLI.CODVEN
  FROM TV_IND CLI
UNION
SELECT CLI.FILCLI, CLI.CODCLI, CLI.ATU_EM, CLI.NOMCLI, CLI.ULTNOM, CLI.NUMDOC, CLI.DOCCON, CLI.DATNAS, 
       CLI.ESTCIV, CLI.HOMPGE, CLI.FLGTIP, CLI.INSEST, CLI.CODSEX, CLI.CATEG1, CLI.CATEG2, CLI.CATEG3,
       CLI.DATA01, CLI.DATA02, CLI.DATA03, CLI.DATOPE, CLI.IMPRIM, CLI.VALOR1, CLI.TOTATR, CLI.TOTPAR,
       CLI.MAIATR, CLI.OBSERV, CLI.FILPLA, CLI.CODPLA, CLI.PORPAD, CLI.ULTCOM, CLI.SIGNAT, CLI.CONJUG, 
       CLI.NASCON, CLI.SEXCON, CLI.FILVEN, CLI.CODVEN
  FROM TT_USU USU INNER JOIN TT_CLI CLI ON CLI.FILCLI = USU.FILCLI AND CLI.CODCLI = USU.CODCLI
 ;


/*-- SEQ 2928 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_WEB CASCADE;

/*-- SEQ 2929 --*/
CREATE OR REPLACE VIEW TV_WEB AS
SELECT /*+INDEX(pro,PK_PRO) INDEX(sal,PK_SAL) INDEX(gra, PK_GRA) INDEX(pre, AK_PRE_GRA)*/
       GRA.REFPRO,           /* CODIGO DO PRODUTO */
       PRO.REFBAS,           /* REFERENCIA BASICA DO PRODUTO */
       GRA.FILMAT||GRA.SEQUEN AS CHAVEPRO,
       GRA.ENVECO,
       GRA.CODCOR AS CODDIV, GRA.CODTAM AS CODSUB,
       CAST(GRA.FILMAT||GRA.CODMAT AS CHAR(13)) AS SEQUEN,
       CAST(INITCAP(LOWER(COALESCE(CL1.CLASS1,''))) AS VARCHAR(40)) AS CLASS1_LONG, /* 1O. CLASSIFICACAO COM 40 CARACTERES */
       CAST(INITCAP(LOWER(COALESCE(CL2.CLASS2,''))) AS VARCHAR(40)) AS CLASS2_LONG, /* 2O. CLASSIFICACAO COM 40 CARACTERES */
       CAST(INITCAP(LOWER(COALESCE(CL3.CLASS3,''))) AS VARCHAR(40)) AS CLASS3_LONG, /* 3O. CLASSIFICACAO COM 40 CARACTERES */
       CAST(INITCAP(LOWER(COALESCE(CL4.CLASS4,''))) AS VARCHAR(40)) AS CLASS4_LONG, /* 4O. CLASSIFICACAO COM 40 CARACTERES */
       CAST(INITCAP(LOWER(COALESCE(DEP.DESDEP,''))) AS VARCHAR(40)) AS DESDEP, /* DESCRICAO DEPARTAMENTO */
       CAST(INITCAP(LOWER(COALESCE(CFG.CLASS1,''))) AS VARCHAR(15)) AS NOMCL1, /* 1O. NOME DA CLASSIFICACAO */
       CAST(INITCAP(LOWER(COALESCE(CL1.CLASS1,''))) AS VARCHAR(15)) AS CLASS1, /* 1O. CLASSIFICACAO */
       CAST(INITCAP(LOWER(COALESCE(CFG.CLASS2,''))) AS VARCHAR(15)) AS NOMCL2, /* 2O. NOME DA CLASSIFICACAO */
       CAST(INITCAP(LOWER(COALESCE(CL2.CLASS2,''))) AS VARCHAR(15)) AS CLASS2, /* 2O. CLASSIFICACAO */
       CAST(INITCAP(LOWER(COALESCE(CFG.CLASS3,''))) AS VARCHAR(15)) AS NOMCL3, /* 3O. NOME DA CLASSIFICACAO */
       CAST(INITCAP(LOWER(COALESCE(CL3.CLASS3,''))) AS VARCHAR(15)) AS CLASS3, /* 3O. CLASSIFICACAO */
       CAST(INITCAP(LOWER(COALESCE(CFG.CLASS4,''))) AS VARCHAR(15)) AS NOMCL4, /* 4O. NOME DA CLASSIFICACAO */
       CAST(INITCAP(LOWER(COALESCE(CL4.CLASS4,''))) AS VARCHAR(15)) AS CLASS4, /* 4O. CLASSIFICACAO */
       CAST(INITCAP(CASE WHEN PRO.DESWEB IS NULL THEN TRIM(COALESCE(PRO.DESMAT,'')) || ' ' || COALESCE(PRO.ESPMAT ,'')
                                                 ELSE PRO.DESWEB
                     END) AS VARCHAR(100)) AS NOMPRO, /* NOME DO PRODUTO */
       CAST(INITCAP(LOWER(COALESCE(PRO.ESPMAT,''))) AS VARCHAR(30)) AS ESPMAT, /* ESPECIFICACAO DO PRODUTO */
       CAST(SUBSTR(INITCAP(CASE WHEN PRO.DESWEB IS NULL THEN TRIM(COALESCE(PRO.DESMAT,'')) || CASE DDIV.CODTAB WHEN 0 THEN ''
                                                                                                                     ELSE ' ' || TRIM(COALESCE(DIV.nomext,''))
                                                                                               END || CASE DSUB.CODTAB WHEN 0 THEN ''
                                                                                                                             ELSE ' ' || TRIM(COALESCE(SUB.nomext,''))
                                                                                                       END || ' ' || COALESCE(PRO.ESPMAT ,'')
                                                        ELSE PRO.DESWEB || CASE DDIV.CODTAB WHEN 0 THEN ''
                                                                                                  ELSE ' ' || TRIM(COALESCE(DIV.nomext,''))
                                                                            END || CASE DSUB.CODTAB WHEN 0 THEN ''
                                                                                                          ELSE ' ' || TRIM(COALESCE(SUB.nomext,''))
                                                                                    END
                            END) ,1,100) AS VARCHAR(100)) AS DESPRO, /* DESCRICAO DO PRODUTO */
       PRO.DESDET AS DETPRO, /* DETALHES DO PRODUTO */
       GREATEST((SELECT SUM(CASE WHEN (SELECT COUNT(*) 
                            FROM TT_KIT KIT 
                           WHERE KIT.FILMAT = SALI.FILMAT 
                             AND KIT.CODMAT = SALI.CODMAT 
                             AND KIT.CODCOR = SALI.CODCOR 
                             AND KIT.CODTAM = SALI.CODTAM) >0
                        THEN SALDOKIT(AGORA(),SALI.FILMAT,SALI.CODMAT,SALI.CODCOR,SALI.CODTAM,SALI.CODFIL,SALI.CODMUL)
                        ELSE COALESCE(SALI.QTDEST,0) - COALESCE(SALI.RESERV,0)
               END)
          FROM TT_SAL SALI INNER JOIN TD_FIL FILI ON SALI.CODFIL=FILI.CODFIL
                           INNER JOIN TD_MUL MULI ON SALI.CODMUL=MULI.CODTAB
	 WHERE SALI.FILMAT = GRA.FILMAT
	   AND SALI.CODMAT = GRA.CODMAT
	   AND SALI.CODCOR = GRA.CODCOR
	   AND SALI.CODTAM = GRA.CODTAM
       AND FILI.FILWEB='T'
       AND MULI.MULWEB='T'),0) AS QTDEST,  /* SALDO DE ESTOQUE */       
	   MTOM(MOE.CODTAB,CFG.CODMOE,AGORA(),PRE.PRECOV) * ((100-COALESCE(PRO.DESECO,0)) / 100) AS PREVEN /* VALOR DE VENDA */,
       MTOM(MOE.CODTAB,CFG.CODMOE,AGORA(),PRECOPROMOCIONAL(GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,CFG.VC_FILPGT,CFG.VC_CODPGT,PRE.FILPRE,PRE.SEQUEN)) AS PREPMC, /* PRECO PROMOCIONAL */
       VENCIMENTOPROMOCAO(GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,CFG.VC_FILPGT,CFG.VC_CODPGT,PRE.FILPRE,PRE.SEQUEN) AS VENPMC, /* VENCIMENTO DA PROMOCAO */
       CFG.DESMOE,           /* TIPO DE MOEDA */
       PRO.NOMIMG,            /* IMAGEM RELACIONADA AO PRODUTO */
       GRA.PESLIQ,
       GRA.PESBRU,
       DEP.CODTAB AS CODDEP,            /* CODIGO DO DEPARTAMENTO*/   
       CL1.CODTAB AS CODCL1,            /* CODIGO DO CLASS1*/
       CL2.CODTAB AS CODCL2,            /* CODIGO DO CLASS2*/
       CL3.CODTAB AS CODCL3,            /* CODIGO DO CLASS3*/
       CL4.CODTAB AS CODCL4,           /* CODIGO DO CLASS4*/
       (SELECT CAST(INITCAP(LOWER(COALESCE(MAR.DESMAR,''))) AS VARCHAR(30))
          FROM TT_MAR MAR
         WHERE MAR.FILMAR = PRO.FILMAR
           AND MAR.CODMAR = PRO.CODMAR
           AND MAR.ITEMAR = PRO.ITEMAR) AS MARCA,   /* MARCA DO PRODUTO */
       CAST(INITCAP(LOWER(COALESCE(DSUB.NOMSUB,''))) AS VARCHAR(20)) AS NOMSUB, /* SUBDIVISAO */
       CAST(INITCAP(LOWER(COALESCE(DDIV.NOMDIV,''))) AS VARCHAR(20)) AS NOMDIV, /* DIVISAO */
       CAST(INITCAP(LOWER(COALESCE(SUB.nomext,''))) AS VARCHAR(10)) AS ITESUB,  /* ITEM SE SUBDIVISAO */
       CAST(INITCAP(LOWER(COALESCE(DIV.nomext,''))) AS VARCHAR(10)) AS ITEDIV,   /* ITEM SE DIVISAO */
       CAST(TO_CHAR(GREATEST(PRO.ATU_EM,SAL.ATU_EM),'DD/MM/YYYY HH24:MI:SS') AS VARCHAR(20)) AS ATU_EM, /*ULTIMA ATUALIZACAO*/
	   GRA.ALTURA, GRA.LARGUR, GRA.PROFUN, GRA.VOLUME, GRA.DESTAQ,
       PRO.TERASS, PRO.DECIMA
FROM (SELECT DIN.CODTAB AS CODMOE,DIN.DESMOE,
             IDF.CODLOJ,
             CON.FILPRE,CON.CODPRE,
             CON.VC_FILPGT,CON.VC_CODPGT,
             CON.CLASS1, CON.CLASS2, CON.CLASS3, CON.CLASS4, CON.CL4WEB
        FROM TT_CFG CON, TT_IDF IDF, TD_MOE DIN
       WHERE DIN.CODTAB = 0) CFG,
     TT_PRO PRO INNER JOIN TT_GRA GRA  ON GRA.FILMAT  = PRO.FILMAT
                                      AND GRA.CODMAT  = PRO.CODMAT
                INNER JOIN TT_DIV DIV  ON DIV.CODITE  = GRA.CODCOR
                INNER JOIN TD_DIV DDIV ON DDIV.CODTAB = DIV.CODDIV
                INNER JOIN TT_SUB SUB  ON SUB.CODITE  = GRA.CODTAM
                INNER JOIN TD_SUB DSUB ON DSUB.CODTAB = SUB.CODSUB
                INNER JOIN TD_DEP DEP  ON DEP.CODTAB  = PRO.DEPART
                INNER JOIN TD_CL1 CL1  ON CL1.CODTAB  = PRO.CLASS1
                INNER JOIN TD_CL2 CL2  ON CL2.CODTAB  = PRO.CLASS2
                INNER JOIN TD_CL3 CL3  ON CL3.CODTAB  = PRO.CLASS3
                INNER JOIN TD_CL4 CL4  ON CL4.CODTAB  = PRO.CLASS4
                INNER JOIN TT_SAL SAL  ON SAL.FILMAT  = GRA.FILMAT
                                      AND SAL.CODMAT  = GRA.CODMAT
                                      AND SAL.CODCOR  = GRA.CODCOR
                                      AND SAL.CODTAM  = GRA.CODTAM
                                      AND SAL.CODMUL  = 0
                INNER JOIN TT_PRE PRE ON PRE.FILMAT   = GRA.FILMAT
                                      AND PRE.CODMAT  = GRA.CODMAT
                                      AND PRE.CODCOR  = GRA.CODCOR
                                      AND PRE.CODTAM  = GRA.CODTAM
                INNER JOIN TD_MOE MOE ON MOE.CODTAB   = PRE.CODMOE
WHERE PRE.FILPRE = CFG.FILPRE
  AND PRE.CODPRE = CFG.CODPRE
  AND SAL.CODFIL = CFG.CODLOJ
  AND ((GRA.ENVECO = 'T') OR 
       (CL1.CL1WEB='T' OR CL2.CL2WEB='T' OR CL3.CL3WEB='T' OR CL4.CL4WEB='T' OR DEP.DEPWEB='T'))
  
  AND GRA.FILMAT = GRA.FILMAT
  AND GRA.CODMAT = GRA.CODMAT
  AND GRA.CODCOR = GRA.CODCOR
  AND GRA.CODTAM = GRA.CODTAM
        AND PRO.SIGNAT >= 0
;


/*-- SEQ 2930 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_WEB_FULL CASCADE;

/*-- SEQ 2931 --*/
CREATE OR REPLACE VIEW TV_WEB_FULL AS
SELECT /*+INDEX(pro,PK_PRO) INDEX(sal,PK_SAL) INDEX(gra, PK_GRA) INDEX(pre, AK_PRE_GRA)*/
       GRA.REFPRO,           /* CODIGO DO PRODUTO */
       PRO.REFBAS,           /* REFERENCIA BASICA DO PRODUTO */
	   GRA.FILMAT||GRA.SEQUEN AS CHAVEPRO,
       GRA.CODCOR AS CODDIV, GRA.CODTAM AS CODSUB,
       GRA.ENVECO,
       CAST(GRA.FILMAT||GRA.CODMAT AS CHAR(13)) AS SEQUEN,
       CAST(INITCAP(LOWER(COALESCE(CL1.CLASS1,''))) AS VARCHAR(40)) AS CLASS1_LONG, /* 1O. CLASSIFICACAO COM 40 CARACTERES */
       CAST(INITCAP(LOWER(COALESCE(CL2.CLASS2,''))) AS VARCHAR(40)) AS CLASS2_LONG, /* 2O. CLASSIFICACAO COM 40 CARACTERES */
       CAST(INITCAP(LOWER(COALESCE(CL3.CLASS3,''))) AS VARCHAR(40)) AS CLASS3_LONG, /* 3O. CLASSIFICACAO COM 40 CARACTERES */
       CAST(INITCAP(LOWER(COALESCE(CL4.CLASS4,''))) AS VARCHAR(40)) AS CLASS4_LONG, /* 4O. CLASSIFICACAO COM 40 CARACTERES */
       CAST(INITCAP(LOWER(COALESCE(DEP.DESDEP,''))) AS VARCHAR(40)) AS DESDEP, /* DESCRICAO DEPARTAMENTO */
       CAST(INITCAP(LOWER(COALESCE(CFG.CLASS1,''))) AS VARCHAR(15)) AS NOMCL1, /* 1O. NOME DA CLASSIFICACAO */
       CAST(INITCAP(LOWER(COALESCE(CL1.CLASS1,''))) AS VARCHAR(15)) AS CLASS1, /* 1O. CLASSIFICACAO */
       CAST(INITCAP(LOWER(COALESCE(CFG.CLASS2,''))) AS VARCHAR(15)) AS NOMCL2, /* 2O. NOME DA CLASSIFICACAO */
       CAST(INITCAP(LOWER(COALESCE(CL2.CLASS2,''))) AS VARCHAR(15)) AS CLASS2, /* 2O. CLASSIFICACAO */
       CAST(INITCAP(LOWER(COALESCE(CFG.CLASS3,''))) AS VARCHAR(15)) AS NOMCL3, /* 3O. NOME DA CLASSIFICACAO */
       CAST(INITCAP(LOWER(COALESCE(CL3.CLASS3,''))) AS VARCHAR(15)) AS CLASS3, /* 3O. CLASSIFICACAO */
       CAST(INITCAP(LOWER(COALESCE(CFG.CLASS4,''))) AS VARCHAR(15)) AS NOMCL4, /* 4O. NOME DA CLASSIFICACAO */
       CAST(INITCAP(LOWER(COALESCE(CL4.CLASS4,''))) AS VARCHAR(15)) AS CLASS4, /* 4O. CLASSIFICACAO */
       CAST(INITCAP(CASE WHEN PRO.DESWEB IS NULL THEN TRIM(COALESCE(PRO.DESMAT,'')) || ' ' || COALESCE(PRO.ESPMAT ,'')
                                                 ELSE PRO.DESWEB
                     END) AS VARCHAR(100)) AS NOMPRO, /* NOME DO PRODUTO */
       CAST(INITCAP(LOWER(COALESCE(PRO.ESPMAT,''))) AS VARCHAR(30)) AS ESPMAT, /* ESPECIFICACAO DO PRODUTO */
       CAST(SUBSTR(INITCAP(CASE WHEN PRO.DESWEB IS NULL THEN TRIM(COALESCE(PRO.DESMAT,'')) || CASE DDIV.CODTAB WHEN 0 THEN ''
                                                                                                                     ELSE ' ' || TRIM(COALESCE(DIV.nomext,''))
                                                                                               END || CASE DSUB.CODTAB WHEN 0 THEN ''
                                                                                                                             ELSE ' ' || TRIM(COALESCE(SUB.nomext,''))
                                                                                                       END || ' ' || COALESCE(PRO.ESPMAT ,'')
                                                        ELSE PRO.DESWEB || CASE DDIV.CODTAB WHEN 0 THEN ''
                                                                                                  ELSE ' ' || TRIM(COALESCE(DIV.nomext,''))
                                                                            END || CASE DSUB.CODTAB WHEN 0 THEN ''
                                                                                                          ELSE ' ' || TRIM(COALESCE(SUB.nomext,''))
                                                                                    END
                            END) ,1,100) AS VARCHAR(100)) AS DESPRO, /* DESCRICAO DO PRODUTO */
       PRO.DESDET AS DETPRO, /* DETALHES DO PRODUTO */
       GREATEST((SELECT SUM(CASE WHEN (SELECT COUNT(*) 
                            FROM TT_KIT KIT 
                           WHERE KIT.FILMAT = SALI.FILMAT 
                             AND KIT.CODMAT = SALI.CODMAT 
                             AND KIT.CODCOR = SALI.CODCOR 
                             AND KIT.CODTAM = SALI.CODTAM) >0
                        THEN SALDOKIT(AGORA(),SALI.FILMAT,SALI.CODMAT,SALI.CODCOR,SALI.CODTAM,SALI.CODFIL,SALI.CODMUL)
                        ELSE COALESCE(SALI.QTDEST,0) - COALESCE(SALI.RESERV,0)
               END)
          FROM TT_SAL SALI INNER JOIN TD_FIL FILI ON SALI.CODFIL=FILI.CODFIL
                           INNER JOIN TD_MUL MULI ON SALI.CODMUL=MULI.CODTAB
	 WHERE SALI.FILMAT = GRA.FILMAT
	   AND SALI.CODMAT = GRA.CODMAT
	   AND SALI.CODCOR = GRA.CODCOR
	   AND SALI.CODTAM = GRA.CODTAM
       AND FILI.FILWEB='T'
       AND MULI.MULWEB='T'),0) AS QTDEST,  /* SALDO DE ESTOQUE */       
       CFG.DESMOE,           /* TIPO DE MOEDA */
       PRO.NOMIMG,            /* IMAGEM RELACIONADA AO PRODUTO */
       GRA.PESLIQ,
       GRA.PESBRU,
       DEP.CODTAB AS CODDEP,            /* CODIGO DO DEPARTAMENTO*/   
       CL1.CODTAB AS CODCL1,            /* CODIGO DO CLASS1*/
       CL2.CODTAB AS CODCL2,            /* CODIGO DO CLASS2*/
       CL3.CODTAB AS CODCL3,            /* CODIGO DO CLASS3*/
       CL4.CODTAB AS CODCL4,           /* CODIGO DO CLASS4*/
       (SELECT CAST(INITCAP(LOWER(COALESCE(MAR.DESMAR,''))) AS VARCHAR(30))
          FROM TT_MAR MAR
         WHERE MAR.FILMAR = PRO.FILMAR
           AND MAR.CODMAR = PRO.CODMAR
           AND MAR.ITEMAR = PRO.ITEMAR) AS MARCA,   /* MARCA DO PRODUTO */
       CAST(INITCAP(LOWER(COALESCE(DSUB.NOMSUB,''))) AS VARCHAR(20)) AS NOMSUB, /* SUBDIVISAO */
       CAST(INITCAP(LOWER(COALESCE(DDIV.NOMDIV,''))) AS VARCHAR(20)) AS NOMDIV, /* DIVISAO */
       CAST(INITCAP(LOWER(COALESCE(SUB.nomext,''))) AS VARCHAR(10)) AS ITESUB,  /* ITEM SE SUBDIVISAO */
       CAST(INITCAP(LOWER(COALESCE(DIV.nomext,''))) AS VARCHAR(10)) AS ITEDIV,   /* ITEM SE DIVISAO */
       CAST(TO_CHAR(GREATEST(PRO.ATU_EM,SAL.ATU_EM),'DD/MM/YYYY HH24:MI:SS') AS VARCHAR(20)) AS ATU_EM, /*ULTIMA ATUALIZACAO*/
       PRO.ATU_EM AS PRO_ATU_EM,
       SAL.ATU_EM AS SAL_ATU_EM,
	   GRA.ALTURA, GRA.LARGUR, GRA.PROFUN, GRA.VOLUME, GRA.DESTAQ,
       PRO.TERASS, PRO.DECIMA,
       CAST(CASE WHEN GRA.ENVECO = 'T' THEN 'T'
             ELSE
               CASE WHEN ((CL1.CL1WEB='T' OR CL2.CL2WEB='T' OR CL3.CL3WEB='T' OR CL4.CL4WEB='T' OR DEP.DEPWEB='T') 
                  AND PRO.SIGNAT >= 0
                  AND GRA.GRAATI='T') THEN 'T' 
                  ELSE 'F'
               END
            END AS VARCHAR(1)) AS ATIVO
FROM (SELECT DIN.CODTAB AS CODMOE,DIN.DESMOE,
             IDF.CODLOJ,
             CON.FILPRE,CON.CODPRE,
             CON.VC_FILPGT,CON.VC_CODPGT,
             CON.CLASS1, CON.CLASS2, CON.CLASS3, CON.CLASS4, CON.CL4WEB
        FROM TT_CFG CON, TT_IDF IDF, TD_MOE DIN
       WHERE DIN.CODTAB = 0) CFG,
     TT_PRO PRO INNER JOIN TT_GRA GRA  ON GRA.FILMAT  = PRO.FILMAT
                                      AND GRA.CODMAT  = PRO.CODMAT
                INNER JOIN TT_DIV DIV  ON DIV.CODITE  = GRA.CODCOR
                INNER JOIN TD_DIV DDIV ON DDIV.CODTAB = DIV.CODDIV
                INNER JOIN TT_SUB SUB  ON SUB.CODITE  = GRA.CODTAM
                INNER JOIN TD_SUB DSUB ON DSUB.CODTAB = SUB.CODSUB
                INNER JOIN TD_DEP DEP  ON DEP.CODTAB  = PRO.DEPART
                INNER JOIN TD_CL1 CL1  ON CL1.CODTAB  = PRO.CLASS1
                INNER JOIN TD_CL2 CL2  ON CL2.CODTAB  = PRO.CLASS2
                INNER JOIN TD_CL3 CL3  ON CL3.CODTAB  = PRO.CLASS3
                INNER JOIN TD_CL4 CL4  ON CL4.CODTAB  = PRO.CLASS4
                INNER JOIN TT_SAL SAL  ON SAL.FILMAT  = GRA.FILMAT
                                      AND SAL.CODMAT  = GRA.CODMAT
                                      AND SAL.CODCOR  = GRA.CODCOR
                                      AND SAL.CODTAM  = GRA.CODTAM
                                      AND SAL.CODMUL  = 0
WHERE SAL.CODFIL = CFG.CODLOJ
  
  AND GRA.FILMAT = GRA.FILMAT
  AND GRA.CODMAT = GRA.CODMAT
  AND GRA.CODCOR = GRA.CODCOR
  AND GRA.CODTAM = GRA.CODTAM
  ;


/*-- SEQ 2932 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_WEB_UEB CASCADE;

/*-- SEQ 2933 --*/
CREATE OR REPLACE VIEW TV_WEB_UEB AS
select /*+INDEX(pro,PK_PRO) INDEX(sal,PK_SAL) INDEX(gra, PK_GRA) INDEX(pre, AK_PRE_GRA)*/
       gra.refpro,           /* Codigo do produto */
       pro.refbas,           /* Referencia basica do produto */
       	   gra.filmat||gra.sequen as chavepro,
       gra.codcor as coddiv, gra.codtam as codsub,
       cast(gra.filmat||gra.codmat as char(13)) as sequen,
       cast(initcap(lower(coalesce(cl1.class1,''))) as VARCHAR(40)) as CLASS1_LONG, /* 1o. Classificacao com 40 caracteres */
       cast(initcap(lower(coalesce(cl2.class2,''))) as VARCHAR(40)) as CLASS2_LONG, /* 2o. Classificacao com 40 caracteres */
       cast(initcap(lower(coalesce(cl3.class3,''))) as VARCHAR(40)) as CLASS3_LONG, /* 3o. Classificacao com 40 caracteres */
       cast(initcap(lower(coalesce(cl4.class4,''))) as VARCHAR(40)) as CLASS4_LONG, /* 4o. Classificacao com 40 caracteres */
       cast(initcap(lower(coalesce(dep.desdep,''))) as VARCHAR(40)) as DESDEP, /* Descricao Departamento */
       cast(initcap(lower(coalesce(cfg.class1,''))) as VARCHAR(15)) as NOMCL1, /* 1o. Nome da Classificacao */
       cast(initcap(lower(coalesce(cl1.class1,''))) as VARCHAR(15)) as CLASS1, /* 1o. Classificacao */
       cast(initcap(lower(coalesce(cfg.class2,''))) as VARCHAR(15)) as NOMCL2, /* 2o. Nome da Classificacao */
       cast(initcap(lower(coalesce(cl2.class2,''))) as VARCHAR(15)) as CLASS2, /* 2o. Classificacao */
       cast(initcap(lower(coalesce(cfg.class3,''))) as VARCHAR(15)) as NOMCL3, /* 3o. Nome da Classificacao */
       cast(initcap(lower(coalesce(cl3.class3,''))) as VARCHAR(15)) as CLASS3, /* 3o. Classificacao */
       cast(initcap(lower(coalesce(cfg.class4,''))) as VARCHAR(15)) as NOMCL4, /* 4o. Nome da Classificacao */
       cast(initcap(lower(coalesce(cl4.class4,''))) as VARCHAR(15)) as CLASS4, /* 4o. Classificacao */
       cast(initcap(CASE WHEN pro.desweb is null THEN trim(coalesce(pro.desmat,'')) || ' ' || COALESCE(pro.espmat ,'')
                                                 ELSE pro.desweb
                     END) as VARCHAR(100)) as NOMPRO, /* Nome do produto */
       cast(initcap(lower(coalesce(pro.espmat,''))) as VARCHAR(30)) as ESPMAT, /* Especificacao do produto */
       cast(substr(initcap(CASE WHEN pro.desweb is null THEN trim(coalesce(pro.desmat,'')) || CASE ddiv.codtab WHEN 0 THEN ''
                                                                                                                     ELSE ' ' || trim(COALESCE(div.nomite,''))
                                                                                               END || CASE dsub.codtab WHEN 0 THEN ''
                                                                                                                             ELSE ' ' || trim(COALESCE(sub.nomite,''))
                                                                                                       END || ' ' || COALESCE(pro.espmat ,'')
                                                        ELSE pro.desweb || CASE ddiv.codtab WHEN 0 THEN ''
                                                                                                  ELSE ' ' || trim(COALESCE(div.nomite,''))
                                                                            END || CASE dsub.codtab WHEN 0 THEN ''
                                                                                                          ELSE ' ' || trim(COALESCE(sub.nomite,''))
                                                                                    END
                            END) ,1,100) as VARCHAR(100)) as DESPRO, /* Descrio do produto */
       pro.DESDET as DETPRO, /* Detalhes do produto */
                     (select sum(case when (select count(*) 
                            from TT_KIT KIT 
                           WHERE KIT.FILMAT = sali.FILMAT 
                             AND KIT.CODMAT = sali.CODMAT 
                             AND KIT.CODCOR = sali.CODCOR 
                             AND KIT.CODTAM = sali.CODTAM) >0
                        THEN SALDOKIT(agora(),sali.FILMAT,sali.CODMAT,sali.CODCOR,sali.CODTAM,sali.CODFIL,sali.codmul)
                        ELSE coalesce(sali.qtdest,0) - coalesce(sali.reserv,0)
               END)
          from tt_sal sali inner join td_fil fili on sali.codfil=fili.codfil
                           inner join td_mul muli on sali.codmul=muli.codtab
	 where sali.filmat = gra.filmat
	   and sali.codmat = gra.codmat
	   and sali.codcor = gra.codcor
	   and sali.codtam = gra.codtam
       and fili.filweb='T'
       and muli.mulweb='T') as qtdest,  /* Saldo de estoque */       
	   MtoM(moe.codtab,cfg.codmoe,agora(),pre.precov) * ((100-COALESCE(PRO.DESECO,0)) / 100) as PREVEN /* Valor de venda */,
       MtoM(moe.codtab,cfg.codmoe,agora(),CPM.PRECOP) as PREPMC, /* Preco promocional */
       VencimentoPromocao(gra.filmat,gra.codmat,gra.codcor,gra.codtam,cfg.vc_filpgt,cfg.vc_codpgt,pre.filpre,pre.sequen) as VENPMC, /* Vencimento da promocao */
       cfg.desmoe,           /* Tipo de moeda */
       pro.nomimg,            /* Imagem relacionada ao produto */
       gra.pesliq,
       gra.pesbru,
       dep.codtab as coddep,            /* codigo do departamento*/   
       cl1.codtab as codcl1,            /* codigo do class1*/
       cl2.codtab as codcl2,            /* codigo do class2*/
       cl3.codtab as codcl3,            /* codigo do class3*/
       cl4.codtab as codcl4,           /* codigo do class4*/ 
       tpr.despre as despre,           /* Nome Tabela de preo */        
       (select cast(initcap(lower(coalesce(mar.desmar,''))) as VARCHAR(30))
          from tt_mar mar
         where mar.filmar = pro.filmar
           and mar.codmar = pro.codmar
           and mar.itemar = pro.itemar) as marca,   /* marca do produto */
       cast(initcap(lower(coalesce(dsub.nomsub,''))) as VARCHAR(20)) as nomsub, /* subdivisao */
       cast(initcap(lower(coalesce(ddiv.nomdiv,''))) as VARCHAR(20)) as nomdiv, /* divisao */
       cast(initcap(lower(coalesce(sub.nomite,''))) as VARCHAR(10)) as itesub,  /* item se subdivisao */
       cast(initcap(lower(coalesce(div.nomite,''))) as VARCHAR(10)) as itediv,   /* item se divisao */
       cast(to_char(GREATEST(PRO.atu_em,SAL.atu_em),'dd/mm/yyyy hh24:mi:ss') as VARCHAR(20)) as atu_em, /*ultima atualizao*/
	   gra.altura, gra.largur, gra.profun, gra.volume, gra.destaq,
       pro.terass, pro.decima
from (select din.codtab as codmoe,din.desmoe,
             idf.codloj,
             con.filpre,con.codpre,
             con.vc_filpgt,con.vc_codpgt,
             con.class1, con.class2, con.class3, con.class4, con.cl4web
        from tt_cfg con, tt_idf idf, td_moe din
       where din.codtab = 0) cfg,
     tt_pro pro inner join tt_gra gra  on gra.filmat  = pro.filmat
                                      and gra.codmat  = pro.codmat
                inner join tt_div div  on div.codite  = gra.codcor
                inner join td_div ddiv on ddiv.codtab = div.coddiv
                inner join tt_sub sub  on sub.codite  = gra.codtam
                inner join td_sub dsub on dsub.codtab = sub.codsub
                inner join td_dep dep  on dep.codtab  = pro.depart
                inner join td_cl1 cl1  on cl1.codtab  = pro.class1
                inner join td_cl2 cl2  on cl2.codtab  = pro.class2
                inner join td_cl3 cl3  on cl3.codtab  = pro.class3
                inner join td_cl4 cl4  on cl4.codtab  = pro.class4
                inner join tt_sal sal  on sal.filmat  = gra.filmat
                                      and sal.codmat  = gra.codmat
                                      and sal.codcor  = gra.codcor
                                      and sal.codtam  = gra.codtam
                                      and sal.codmul  = 0
                inner join tt_pre pre on pre.FILMAT   = gra.FILMAT
                                      and pre.CODMAT  = gra.CODMAT
                                      and pre.CODCOR  = gra.CODCOR
                                      and pre.CODTAM  = gra.CODTAM
                inner join tt_tpr tpr on pre.filpre   = tpr.codfil
                                      and pre.codpre  = tpr.codpre    
                inner join td_moe moe on moe.codtab   = pre.codmoe
				left  join TT_CPM CPM ON PRE.FILPRE = CPM.FILPRE
                                      AND PRE.SEQUEN = CPM.SEQPRE 
where pre.FILPRE = cfg.FILPRE
  --and pre.CODPRE = cfg.codpre
  and sal.codfil = cfg.codloj
  and (cl1.cl1web='T' or cl2.cl2web='T' or cl3.cl3web='T' or cl4.cl4web='T' or dep.depweb='T')   
  and gra.filmat = gra.filmat
  and gra.codmat = gra.codmat
  and gra.codcor = gra.codcor
  and gra.codtam = gra.codtam
        and pro.signat >= 0
  AND ((CPM.FILPGT = cfg.vc_filpgt AND CPM.CODPGT = cfg.vc_codpgt) OR CPM.FILPGT IS NULL) 
;


-- Autor: Luciano
-- Cliente(s): Gimba
-- Finalidade(s):
-- 1) Retornar se cliente possui entidade para doao de troco e os valores de crdito e dbito de determinado perodo.
/*-- SEQ 2934 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CCC_SAL CASCADE;

/*-- SEQ 2935 --*/
CREATE OR REPLACE VIEW TV_CCC_SAL AS
SELECT 
    CODFIL, 
    FILCLI, 
    CODCLI, 
    TIPCCC,
    DATINI,
    DATFIM,
    ATIVO,
    Split_Part_Number(TAB.VALORES,';',1) AS CREDITO,
    Split_Part_Number(TAB.VALORES,';',2) AS DEBITO,
    Split_Part_Number(TAB.VALORES,';',3) AS SALDO
   FROM (
     SELECT
        INI.DATOPE AS DATINI,
        FIM.DATOPE AS DATFIM,
        CCC.CODFIL,
        CCC.FILCLI,
        CCC.CODCLI,
        CCC.TIPCCC,
        cast(coalesce(FilialClienteTrocoSolidario(CCC.FILCLI,CCC.CODCLI, CCC.CODFIL),'F') AS VARCHAR(1)) AS ATIVO,
        CreditosDebitosCCPeriodo(CCC.FILCLI,CCC.CODCLI,CCC.TIPCCC,INI.DATOPE,FIM.DATOPE,CCC.CODFIL) AS VALORES   
       FROM TT_CCC CCC
      CROSS JOIN TT_DAT INI
      CROSS JOIN TT_DAT FIM
      GROUP BY CCC.CODFIL, CCC.FILCLI, CCC.CODCLI, CCC.TIPCCC , DATINI, DATFIM, ATIVO, VALORES        ) AS TAB
;


/*-- SEQ 2936 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CONFIG_INCONSISTENCIAS CASCADE;

/*-- SEQ 2937 --*/
CREATE OR REPLACE VIEW TV_CONFIG_INCONSISTENCIAS AS
SELECT CAST(CODTAB AS CHAR(5)) AS CODTAB, TAB, MSG FROM
(
   SELECT TAB.CODTAB, 'TD_NAT' as Tab, 'Os valores para Natureza de Venda, Vnculo futuro e Reversa fora do estado, devem ser diferentes em  "'||TAB.NATURE|| '"' as Msg
     FROM TW_TAB TAB
     WHERE TRIM(TAB.NATURE) IS NOT NULL
       AND TRIM(TAB.NATFOR) IS NOT NULL
       AND TRIM(TAB.NATFUF) IS NOT NULL
       AND TRIM(TAB.NATREF) IS NOT NULL
       AND (TAB.NATFOR = TAB.NATFUF
         OR TAB.NATFOR = TAB.NATREF
         OR TAB.NATREF = TAB.NATFUF)
UNION ALL
   SELECT  CODTAB, 'TD_MUL' AS TAB, 'Em Mltiplos Estoques, Descrio: NOVO, no  uma descrio vlida.' as Msg
     FROM TW_TAB
    WHERE DESMUL = 'NOVO'
      AND CODTAB <> 0
UNION ALL
   SELECT CODTAB, 'TD_NAT' as Tab,'Permitido para o campo "Cdigo do Menu" somente os valores entre 1 e 99' as MSG
   FROM TW_TAB
   WHERE TRIM(NATURE) IS NOT NULL
     AND NATMEN IS NOT NULL
     AND (NATMEN < 1 or NATMEN > 99)
UNION ALL
   SELECT CODMAX AS CODTAB, 'TD_NAT' AS Tab, 'Cdigo do Menu "'||nat||'" est cadastrado "'||qtd|| '" vezes' AS Msg
   FROM (SELECT CODNAT AS nat, MAX(CODTAB) AS CODMAX, COUNT(*) AS QTD
      FROM (SELECT NATMEN AS CODNAT, CODTAB FROM TW_TAB
            WHERE NATMEN IS NOT NULL ) TABELA
      GROUP BY CODNAT) TABELA
   WHERE QTD > 1
UNION ALL
   SELECT TAB.CODTAB, 'TD_NAT' as Tab, 'No pode haver Natureza de Vnculo Futuro para DENTRO do Estado IGUAL a Natureza de Venda para FORA do Estado em  "'||TAB.NATURE|| '"' as Msg
     FROM TW_TAB TAB LEFT OUTER JOIN (SELECT NATFOR, CODTAB FROM TW_TAB) NAT ON TAB.NATFUD = NAT.NATFOR AND TRIM(TAB.NATFUD) = TRIM(NAT.NATFOR)
    WHERE TRIM(TAB.NATURE) IS NOT NULL
      AND TRIM(TAB.NATFOR) IS NOT NULL
      AND TRIM(TAB.NATFUD) IS NOT NULL
      AND TAB.NATFUD = NAT.NATFOR
 UNION ALL
   SELECT TAB.CODTAB, 'TD_NAT' as Tab, 'No existe natureza correspondente para o Vnculo Futuro para dentro do estado cadastrado em "'||TAB.NATURE|| '" ou est relacionada a ela mesma' as Msg
     FROM TW_TAB TAB LEFT OUTER JOIN (SELECT NATDEN, CODTAB FROM TW_TAB) NAT ON TAB.NATFUD = NAT.NATDEN
     WHERE TRIM(TAB.NATURE) IS NOT NULL
       AND TRIM(TAB.NATFUD) IS NOT NULL
       AND (TAB.CODTAB = NAT.CODTAB OR NAT.CODTAB IS NULL)
 UNION ALL
   SELECT TAB.CODTAB, 'TD_NAT' as Tab, 'No existe natureza correspondente para Natureza Reversa dentro do estado cadastrado em "'||TAB.NATURE|| '" ou est relacionada a ela mesma' as Msg
     FROM TW_TAB TAB LEFT OUTER JOIN (SELECT NATDEN, CODTAB FROM TW_TAB) NAT ON TAB.NATRED = NAT.NATDEN
     WHERE TRIM(TAB.NATURE) IS NOT NULL
       AND TRIM(TAB.NATRED) IS NOT NULL
       AND (TAB.CODTAB = NAT.CODTAB OR NAT.CODTAB IS NULL)
UNION ALL
   SELECT TAB.CODTAB, 'TD_NAT' as Tab, 'No existe natureza correspondente para Natureza Reversa ST dentro do estado cadastrado em "'||TAB.NATURE|| '" ou est relacionada a ela mesma' as Msg
     FROM TW_TAB TAB LEFT OUTER JOIN (SELECT NATDEN, CODTAB FROM TW_TAB) NAT ON TAB.NATRED_ST = NAT.NATDEN
     WHERE TRIM(TAB.NATURE) IS NOT NULL
       AND TRIM(TAB.NATRED_ST) IS NOT NULL
       AND (TAB.CODTAB = NAT.CODTAB OR NAT.CODTAB IS NULL)
  UNION ALL
   SELECT TAB.CODTAB, 'TD_NAT' as Tab, 'No existe natureza correspondente para Natureza Estorno dentro do estado cadastrado em "'||TAB.NATURE|| '" ou est relacionada a ela mesma' as Msg
     FROM TW_TAB TAB LEFT OUTER JOIN (SELECT NATDEN, CODTAB FROM TW_TAB) NAT ON TAB.NATESD = NAT.NATDEN
     WHERE TRIM(TAB.NATURE) IS NOT NULL
       AND TRIM(TAB.NATESD) IS NOT NULL
       AND TAB.TIPNAT <> 'B'
       AND (TAB.CODTAB = NAT.CODTAB OR NAT.CODTAB IS NULL)
 UNION ALL
   SELECT TAB.CODTAB, 'TD_NAT' as Tab, 'No existe natureza correspondente para o Vnculo Futuro para fora do estado cadastrado em "'||TAB.NATURE|| '" ou est relacionada a ela mesma' as Msg
      FROM TW_TAB TAB LEFT OUTER JOIN (SELECT NATFOR, CODTAB FROM TW_TAB) NAT ON TAB.NATFUF = NAT.NATFOR
      WHERE TRIM(TAB.NATURE) IS NOT NULL
        AND TRIM(TAB.NATFUF) IS NOT NULL
       AND (TAB.CODTAB = NAT.CODTAB OR NAT.CODTAB IS NULL)
 UNION ALL
   SELECT TAB.CODTAB, 'TD_NAT' as Tab, 'No existe srie correspondente para vinculo na natureza "'||TAB.NATURE|| '"' as Msg
     FROM TW_TAB TAB LEFT OUTER JOIN (SELECT CODSER, CODTAB FROM TW_TAB) SER ON TAB.SERVIN = SER.CODSER
     WHERE TRIM(TAB.NATURE) IS NOT NULL
       AND TRIM(TAB.SERVIN) IS NOT NULL
       AND TRIM(TAB.SERVIN) IS NOT NULL
       AND SER.CODTAB IS NULL
 UNION ALL
   SELECT TAB.CODTAB, 'TD_NAT' as Tab, 'No existe natureza correspondente para Natureza Reversa fora do estado cadastrado em "'||TAB.NATURE|| '" ou est relacionada a ela mesma' as Msg
     FROM TW_TAB TAB LEFT OUTER JOIN (SELECT NATFOR, CODTAB FROM TW_TAB) NAT ON TAB.NATREF = NAT.NATFOR
     WHERE TRIM(TAB.NATURE) IS NOT NULL
       AND TRIM(TAB.NATREF) IS NOT NULL
       AND (TAB.CODTAB = NAT.CODTAB OR NAT.CODTAB IS NULL)
 UNION ALL
   SELECT TAB.CODTAB, 'TD_NAT' as Tab, 'No existe natureza correspondente para Natureza Reversa ST fora do estado cadastrado em "'||TAB.NATURE|| '" ou est relacionada a ela mesma' as Msg
     FROM TW_TAB TAB LEFT OUTER JOIN (SELECT NATFOR, CODTAB FROM TW_TAB) NAT ON TAB.NATREF_ST = NAT.NATFOR
     WHERE TRIM(TAB.NATURE) IS NOT NULL
       AND TRIM(TAB.NATREF_ST) IS NOT NULL
       AND (TAB.CODTAB = NAT.CODTAB OR NAT.CODTAB IS NULL)
 UNION ALL
   SELECT TAB.CODTAB, 'TD_NAT' as Tab, 'No existe natureza correspondente para Natureza Estorno fora do estado cadastrado em "'||TAB.NATURE|| '" ou est relacionada a ela mesma' as Msg
     FROM TW_TAB TAB LEFT OUTER JOIN (SELECT NATFOR, CODTAB FROM TW_TAB) NAT ON TAB.NATESF = NAT.NATFOR
     WHERE TRIM(TAB.NATURE) IS NOT NULL
       AND TRIM(TAB.NATESF) IS NOT NULL
       AND TAB.TIPNAT <> 'B'
       AND (TAB.CODTAB = NAT.CODTAB OR NAT.CODTAB IS NULL)
 UNION ALL
   SELECT TAB.CODTAB, 'TD_NAT' as Tab, 'Os valores para o Vnculo Futuro para dentro e para fora do estado, devem estar cadastrados em "'||TAB.NATURE|| '" ' as Msg
     FROM  TW_TAB TAB
     WHERE  TRIM(TAB.NATURE) IS NOT NULL
       AND (TRIM(TAB.NATFUD) IS NOT NULL
            AND TRIM(TAB.NATFUF) IS NULL)
       OR (TRIM(TAB.NATFUF) IS NOT NULL
            AND TRIM(TAB.NATFUD) IS NULL)
 UNION ALL
   SELECT TAB.CODTAB, 'TD_NAT' as Tab, 'Os valores para Natureza Reversa dentro e fora do estado devem ser diferentes em  "'||TAB.NATURE|| '"' as Msg
     FROM TW_TAB TAB
     WHERE TRIM(TAB.NATURE) IS NOT NULL
       AND TRIM(TAB.NATRED) IS NOT NULL
       AND TRIM(TAB.NATREF) IS NOT NULL
       AND TAB.NATRED = TAB.NATREF
 UNION ALL
   SELECT TAB.CODTAB, 'TD_NAT' as Tab, 'Os valores para Natureza Estorno dentro e fora do estado devem ser diferentes em  "'||TAB.NATURE|| '"' as Msg
     FROM TW_TAB TAB
     WHERE TRIM(TAB.NATURE) IS NOT NULL
       AND TRIM(TAB.NATESD) IS NOT NULL
       AND TRIM(TAB.NATESF) IS NOT NULL
       AND TAB.NATESD = TAB.NATESF
 UNION ALL
   SELECT TAB.CODTAB, 'TD_NAT' as Tab, 'Os valores para Natureza Vnculo Futuro dentro e fora do estado devem ser diferentes em  "'||TAB.NATURE|| '"' as Msg
     FROM TW_TAB TAB
     WHERE TRIM(TAB.NATURE) IS NOT NULL
       AND TRIM(TAB.NATFUD) IS NOT NULL
       AND TRIM(TAB.NATFUF) IS NOT NULL
       AND TAB.NATFUD = TAB.NATFUF
 UNION ALL
   SELECT TAB.CODTAB, 'TD_NAT' as Tab, 'Os valores para Natureza de Venda, Vnculo futuro e Reversa dentro do estado, devem ser diferentes em  "'||TAB.NATURE|| '"' as Msg
     FROM TW_TAB TAB
     WHERE TRIM(TAB.NATURE) IS NOT NULL
       AND TRIM(TAB.NATDEN) IS NOT NULL
       AND TRIM(TAB.NATFUD) IS NOT NULL
       AND TRIM(TAB.NATRED) IS NOT NULL
       AND (TAB.NATDEN = TAB.NATFUD
         OR TAB.NATDEN = TAB.NATRED
         OR TAB.NATRED = TAB.NATFUD)
 UNION ALL
   SELECT TAB.CODTAB,'TD_NAT' as Tab, 'Os valores para Natureza Reversa para dentro e para fora do estado, devem estar cadastrados em "'||TAB.NATURE|| '" ' as Msg
     FROM TW_TAB TAB
     WHERE TRIM(TAB.NATURE) IS NOT NULL
       AND (TRIM(TAB.NATRED) IS NOT NULL
            AND TRIM(TAB.NATREF) IS NULL)
       OR (TRIM(TAB.NATREF) IS NOT NULL
            AND TRIM(TAB.NATRED) IS NULL)
 UNION ALL
   SELECT TAB.CODTAB,'TD_NAT' as Tab, 'Os valores para Natureza Estorno para dentro e para fora do estado, devem estar cadastrados em "'||TAB.NATURE|| '" ' as Msg
     FROM TW_TAB TAB
     WHERE TRIM(TAB.NATURE) IS NOT NULL
       AND (TRIM(TAB.NATESD) IS NOT NULL
            AND TRIM(TAB.NATESF) IS NULL)
       OR (TRIM(TAB.NATESF) IS NOT NULL
            AND TRIM(TAB.NATESD) IS NULL)
 UNION ALL
    SELECT TAB.CODTAB, 'TD_NAT' as Tab, 'Os valores para Natureza de Venda dentro e fora do estado, devem ser diferentes em  "'||TAB.NATURE|| '"' as Msg
     FROM TW_TAB TAB
     WHERE TRIM(TAB.NATURE) IS NOT NULL
       AND TRIM(TAB.NATDEN) IS NOT NULL
       AND TRIM(TAB.NATFOR) IS NOT NULL
       AND TAB.NATDEN = TAB.NATFOR
 UNION ALL
   SELECT TAB.CODTAB, 'TD_NAT' as Tab, 'Natureza de reimpresso de C.F. no pode movimentar estoque' as Msg
     FROM TW_CFG CFG INNER JOIN TW_TAB TAB ON CFG.CODNAT_REIMP_CF = TAB.CODTAB
     WHERE TRIM(NATURE) IS NOT NULL
       AND TAB.MOVEST = 'T'
 UNION ALL
   SELECT CODTAB, 'TD_NAT' as Tab, 'Obrigatrio para Natureza Estorno os campos "Devolve vnculo", "Gera dados Financeiros" e "Lana como venda", devem estar como Falso "'||COALESCE(NATURE,'')||'"' as Msg
     FROM TW_TAB
     WHERE TRIM(NATURE) IS NOT NULL
       AND (TIPNAT = 'B')
       AND (DEVVIN <> 'F' OR FINANC <> 'F' OR LANVEN <> 'F')
 UNION ALL
   SELECT CODTAB, 'TD_NAT' as Tab, 'Cdigos de natureza para dentro e fora do estado devem ser preenchidos com 6 nmeros' as Msg
     FROM TW_TAB
     WHERE TRIM(NATURE) IS NOT NULL
       AND ( (IsDigit(NATDEN) <> 1 OR Length(NATDEN) <> 6)
          OR (IsDigit(NATFOR) <> 1 OR Length(NATFOR) <> 6) )
 UNION ALL
   SELECT CODMAX AS CODTAB, 'TD_NAT' AS Tab, 'O Cdigo da natureza fora do estado "'||nat||'" est cadastrado "'||qtd|| '" vezes' AS Msg
   FROM (SELECT CODNAT AS nat, MAX(CODTAB) AS CODMAX, COUNT(*) AS QTD
      FROM (SELECT NATFOR AS CODNAT, CODTAB FROM TW_TAB
            WHERE TRIM(NATURE) IS NOT NULL
              AND NATFOR IS NOT NULL) TABELA
      GROUP BY CODNAT) TABELA
   WHERE QTD > 1
 UNION ALL
   SELECT CODMAX AS CODTAB, 'TD_NAT' AS Tab, 'O Cdigo da natureza dentro do estado "'||nat||'" est cadastrado "'||qtd|| '" vezes' AS Msg
   FROM (SELECT CODNAT AS nat, MAX(CODTAB) AS CODMAX, COUNT(*) AS QTD
      FROM (SELECT NATDEN AS CODNAT, CODTAB FROM TW_TAB
            WHERE TRIM(NATURE) IS NOT NULL
              AND NATDEN IS NOT NULL) TABELA
      GROUP BY CODNAT) TABELA
   WHERE QTD > 1
 UNION ALL
   SELECT CODTAB, 'TD_NAT' as Tab, 'A natureza "'||NATURE||'" possui vnculo, informe tambm uma srie padro' as Msg
   FROM TW_TAB
   WHERE TRIM(NATURE) IS NOT NULL
     AND (TRIM(NATFUD) IS NOT NULL
      OR TRIM(NATFUF) IS NOT NULL)
     AND TRIM(SERVIN) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_NAT' as Tab, 'Obrigatrio haver movimentao de estoque se a natureza lana como venda em nota complementar. Verifique a natureza "'||COALESCE(NATURE,'')||'"' as Msg
   FROM TW_TAB
   WHERE TRIM(NATURE) IS NOT NULL
     AND COALESCE(LANVEN,'X') = 'P'
     AND COALESCE(MOVEST,'X') = 'F'
 UNION ALL
   SELECT CODTAB, 'TD_NAT' as Tab, 'Obrigatrio preencher pelo menos um dos cdigos de natureza "'||NATURE||'"' as Msg
   FROM TW_TAB
   WHERE TRIM(NATURE) IS NOT NULL
     AND TRIM(NATFUD) IS NULL
     AND TRIM(NATFOR) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_MED' as Tab, 'Unidade de Medida '||UNIMED||'. A descrio deve ser diferente da sigla' as Msg
     FROM TW_TAB
    WHERE UNIMED = TRIM(DESMED)
      AND UNIMED IS NOT NULL
 UNION ALL
 SELECT CODTAB, 'TD_NAT' as Tab, 'No  possvel cadastrar o CFOP 6405,  necessrio informar um valor vlido. "'||NATURE||'"' as Msg
   FROM TW_TAB
   WHERE TRIM(NATDEN) LIKE '6405%'
 UNION ALL
 SELECT CODTAB, 'TD_NAT' as Tab, 'No  possvel cadastrar o CFOP 6405,  necessrio informar um valor vlido. "'||NATURE||'"' as Msg
   FROM TW_TAB
   WHERE TRIM(NATFOR) LIKE '6405%'
 UNION ALL
 SELECT CODTAB, 'TD_NAT' as Tab, 'No  possvel cadastrar o CFOP 6405,  necessrio informar um valor vlido. "'||NATURE||'"' as Msg
   FROM TW_TAB
   WHERE TRIM(NATFUD) LIKE '6405%'
 UNION ALL
 SELECT CODTAB, 'TD_NAT' as Tab, 'No  possvel cadastrar o CFOP 6405,  necessrio informar um valor vlido. "'||NATURE||'"' as Msg
   FROM TW_TAB
   WHERE TRIM(NATFUF) LIKE '6405%'
 UNION ALL
 SELECT CODTAB, 'TD_NAT' as Tab, 'No  possvel cadastrar o CFOP 6405,  necessrio informar um valor vlido. "'||NATURE||'"' as Msg
   FROM TW_TAB
   WHERE TRIM(NATRED) LIKE '6405%'
 UNION ALL
 SELECT CODTAB, 'TD_NAT' as Tab, 'No  possvel cadastrar o CFOP 6405,  necessrio informar um valor vlido. "'||NATURE||'"' as Msg
   FROM TW_TAB
   WHERE TRIM(NATREF) LIKE '6405%'
 UNION ALL
 SELECT CODTAB, 'TD_NAT' as Tab, 'No  possvel cadastrar o CFOP 6405,  necessrio informar um valor vlido. "'||NATURE||'"' as Msg
   FROM TW_TAB
   WHERE TRIM(NATRED_ST) LIKE '6405%'
 UNION ALL
 SELECT CODTAB, 'TD_NAT' as Tab, 'No  possvel cadastrar o CFOP 6405,  necessrio informar um valor vlido. "'||NATURE||'"' as Msg
   FROM TW_TAB
   WHERE TRIM(NATREF_ST) LIKE '6405%'
 UNION ALL
 SELECT CODTAB, 'TD_NAT' as Tab, 'No  possvel cadastrar o CFOP 6405,  necessrio informar um valor vlido. "'||NATURE||'"' as Msg
   FROM TW_TAB
   WHERE TRIM(EXTDEM) LIKE '6405%'
 UNION ALL
 SELECT CODTAB, 'TD_NAT' as Tab, 'No  possvel cadastrar o CFOP 6405,  necessrio informar um valor vlido. "'||NATURE||'"' as Msg
   FROM TW_TAB
   WHERE TRIM(EXTFOR) LIKE '6405%'
UNION ALL
SELECT TAB.CODTAB, 'TD_NAT' as Tab, 'O Cdigo de Situao Tributria para Produtos Normais deve ser (40 - Isenta, 41 - No tributada, 50 - Suspenso, 51 - Diferimento, 90 - Outras) em  "'||TAB.NATURE|| '"' as Msg
     FROM TW_TAB TAB
     WHERE TRIM(TAB.NATURE) IS NOT NULL
       AND TRIM(TAB.CSTNOR) IS NOT NULL
       AND TAB.CSTNOR NOT IN ('40','41','50','51','90')
       AND TAB.TRIBUT = 'F'
UNION ALL
SELECT TAB.CODTAB, 'TD_NAT' as Tab, 'O Cdigo de Situao Tributria para Produtos Normais deve ser (40 - Isenta, 41 - No tributada, 50 - Suspenso, 51 - Diferimento, 90 - Outras) em  "'||TAB.NATURE|| '"' as Msg
     FROM TW_TAB TAB
     WHERE TRIM(TAB.NATURE) IS NOT NULL
       AND TRIM(TAB.CSTNOR) IS NOT NULL
       AND TAB.CSTNOR NOT IN ('40', '41', '50','51','90')
       AND TAB.TRIBUT = 'T'
UNION ALL
SELECT TAB.CODTAB, 'TD_NAT' as Tab, 'O Cdigo de Situao Tributria para Produtos Substitudos deve ser (40 - Isenta, 41 - No tributada, 50 - Suspenso, 51 - Diferimento, 90 - Outras) em  "'||TAB.NATURE|| '"' as Msg
     FROM TW_TAB TAB
     WHERE TRIM(TAB.NATURE) IS NOT NULL
       AND TRIM(TAB.CST_ST) IS NOT NULL
       AND TAB.CST_ST NOT IN ('40','41','50','51','90')
       AND TAB.TRIBUT = 'F'
UNION ALL
SELECT TAB.CODTAB, 'TD_NAT' as Tab, 'O Cdigo de Situao Tributria para Produtos Substitudos deve ser (40 - Isenta, 41 - No tributada, 50 - Suspenso, 51 - Diferimento, 90 - Outras) em  "'||TAB.NATURE|| '"' as Msg
     FROM TW_TAB TAB
     WHERE TRIM(TAB.NATURE) IS NOT NULL
       AND TRIM(TAB.CST_ST) IS NOT NULL
       AND TAB.CST_ST NOT IN ('40','41','50','51','90')
       AND TAB.TRIBUT = 'T'
 UNION ALL
   SELECT CODTAB, 'TD_LIB' as Tab, 'Obrigatrio preencher todos os campos para Liberao' as Msg
   FROM TW_TAB
   WHERE TRIM(DESLIB) IS NOT NULL
     AND (TRIM(FILMAT) IS NULL
      OR  TRIM(CODMAT) IS NULL
      OR  CODCOR IS NULL
      OR  CODTAM IS NULL)
 UNION ALL
   SELECT CODTAB, 'TD_ECF' as Tab, 'Cdigo de Origem deve ser inteiro, de 000 a 999' as Msg
   FROM TW_TAB
   WHERE TRIM(SERECF) IS NOT NULL
     AND IsDigit(COALESCE(CODORI,'ZZZ')) <> 1
 UNION ALL
   SELECT CODTAB, 'TD_CCC' as Tab, 'Informe a filial de conta corrente' as Msg
   FROM TW_TAB
   WHERE TRIM(DESCCC) IS NOT NULL
     AND (TRIM(FILCCC) IS NULL
      OR  TRIM(COMCCC) IS NULL)
 UNION ALL
   SELECT CODTAB, 'TD_NIV' as Tab, 'Obrigatrio preencher o campo % Nvel de Servio' as Msg
   FROM TW_TAB
   WHERE TRIM(DESNIV) IS NOT NULL
     AND PERNIV IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_NIV' as Tab, 'Obrigatrio preencher o campo Fator de Servio' as Msg
   FROM TW_TAB
   WHERE TRIM(DESNIV) IS NOT NULL
     AND FATNIV IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_VEI' as Tab, 'Obrigatrio preencher descrio em Veculos' as Msg
   FROM TW_TAB
   WHERE TRIM(VEIATI) IS NOT NULL
     AND TRIM(DESVEI) IS NULL
     AND TRIM(DESVEI) <> 'NOVO'
 UNION ALL
   SELECT CODTAB, 'TD_VEI' as Tab, 'Descrio do veculo ' || DESCRICAO || ' j cadastrado para a mesma montadora ' || DESC_MONTADORA as Msg
     FROM (SELECT TAB.DESVEI AS DESCRICAO, TAB.CODMTD AS MONTADORA, DMTD.DESMTD AS DESC_MONTADORA, MAX(TAB.CODTAB) AS CODTAB, COUNT(*) AS QTD
             FROM TW_TAB TAB
            INNER JOIN TD_MTD DMTD ON DMTD.CODTAB = TAB.CODMTD
            WHERE TRIM(TAB.DESVEI) IS NOT NULL
              AND TAB.CODMTD IS NOT NULL
            GROUP BY TAB.DESVEI, TAB.CODMTD, DMTD.DESMTD) TABELA
    WHERE QTD > 1
 UNION ALL
   SELECT CODTAB, 'TD_VEI' as Tab, 'Obrigatrio preencher peso mximo em Veculos' as Msg
   FROM TW_TAB
   WHERE TRIM(VEIATI) IS NOT NULL
     AND TRIM(DESVEI) IS NULL
     AND TRIM(DESVEI) <> 'NOVO'
     AND PESMAX IS NULL
     AND CODMTD IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_VEI' as Tab, 'Obrigatrio preencher volume mximo em Veculos' as Msg
   FROM TW_TAB
   WHERE TRIM(VEIATI) IS NOT NULL
     AND TRIM(DESVEI) IS NULL
     AND TRIM(DESVEI) <> 'NOVO'
     AND VOLMAX IS NULL
     AND CODMTD IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_VEI' as Tab, 'Obrigatrio preencher placas em Veculos' as Msg
   FROM TW_TAB
   WHERE TRIM(VEIATI) IS NOT NULL
     AND TRIM(DESVEI) IS NULL 
     AND TRIM(DESVEI) <> 'NOVO'
     AND TRIM(PLACAS) IS NULL
     AND CODMTD IS NULL
-- Quando Definido Montadora deve exigir dados complementares e no exigir dados acima
-- UNION ALL
--   SELECT CODTAB, 'TD_VEI' as Tab, 'Obrigatrio preencher Montadora em Veculos' as Msg
--   FROM TW_TAB
--   WHERE TRIM(VEIATI) IS NOT NULL
--     AND CODMTD IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_VEI' as Tab, 'Obrigatrio preencher Tipo em Veculos' as Msg
   FROM TW_TAB
   WHERE TRIM(VEIATI) IS NOT NULL
     AND TRIM(DESVEI) IS NULL 
     AND TRIM(DESVEI) <> 'NOVO'
     AND TIPVEI IS NULL
     AND CODMTD IS NOT NULL
 UNION ALL
   SELECT CODTAB, 'TD_VEI' as Tab, 'Obrigatrio preencher Espcie em Veculos' as Msg
   FROM TW_TAB
   WHERE TRIM(VEIATI) IS NOT NULL
     AND TRIM(DESVEI) IS NULL 
     AND TRIM(DESVEI) <> 'NOVO'
     AND ESPVEI IS NULL
     AND CODMTD IS NOT NULL
 UNION ALL
   SELECT CODTAB, 'TD_VEI' as Tab, 'Obrigatrio preencher Condio em Veculos' as Msg
   FROM TW_TAB
   WHERE TRIM(VEIATI) IS NOT NULL
     AND TRIM(DESVEI) IS NULL 
     AND TRIM(DESVEI) <> 'NOVO'
     AND CONVEI IS NULL
     AND CODMTD IS NOT NULL
 UNION ALL
   SELECT CODTAB, 'TD_VEI' as Tab, 'Obrigatrio preencher Trao Mxima em Veculos' as Msg
   FROM TW_TAB
   WHERE TRIM(VEIATI) IS NOT NULL
     AND TRIM(DESVEI) IS NULL 
     AND TRIM(DESVEI) <> 'NOVO'
     AND MAXTRA IS NULL
     AND CODMTD IS NOT NULL
 UNION ALL
   SELECT CODTAB, 'TD_VEI' as Tab, 'Obrigatrio preencher Capacidade Mxima em Veculos' as Msg
   FROM TW_TAB
   WHERE TRIM(VEIATI) IS NOT NULL
     AND TRIM(DESVEI) IS NULL 
     AND TRIM(DESVEI) <> 'NOVO'
     AND CAPMAX IS NULL
     AND CODMTD IS NOT NULL
 UNION ALL
   SELECT WTAB.CODTAB, 'TD_VEI' as Tab, 'No  permitido configurar um veculo com poltica de frete aplicada a valor da venda' as Msg
   FROM TW_TAB WTAB INNER JOIN TW_TAB WTAB2 ON WTAB2.CODTAB = WTAB.CODFRE
   WHERE WTAB2.DFRE_TIPCOB = 'V'
 UNION ALL
   SELECT CODTAB, 'TD_MTD' as Tab, 'Obrigatrio preencher a descrio em Montadora de Veculos' as Msg
   FROM TW_TAB
   WHERE TRIM(MTDATI) IS NOT NULL
     AND TRIM(DESMTD) IS NULL 
     AND TRIM(DESMTD) <> 'NOVO'
 UNION ALL
   SELECT CODTAB, 'TD_MTD' as Tab, 'Descrio de montadora do veculo j cadastrado' as Msg
     FROM (SELECT DESMTD AS DESCRICAO, MAX(CODTAB) AS CODTAB, COUNT(*) AS QTD
             FROM TW_TAB
            WHERE TRIM(DESMTD) IS NOT NULL
            GROUP BY DESMTD) TABELA
    WHERE QTD > 1
 UNION ALL
   SELECT CODTAB, 'TD_MOT' as Tab, 'Obrigatrio preencher a descrio em Motor de Veculos' as Msg
   FROM TW_TAB
   WHERE TRIM(MTOATI) IS NOT NULL
     AND TRIM(DESCMO) IS NULL
     AND TRIM(DESCMO) <> 'NOVO'
 UNION ALL
   SELECT CODTAB, 'TD_MOT' as Tab, 'Descrio de motor do veculo j cadastrado' as Msg
     FROM (SELECT DESCMO AS DESCRICAO, MAX(CODTAB) AS CODTAB, COUNT(*) AS QTD
             FROM TW_TAB
            WHERE TRIM(DESCMO) IS NOT NULL
            GROUP BY DESCMO) TABELA
    WHERE QTD > 1
 UNION ALL
   SELECT CODTAB, 'TD_MOT' as Tab, 'Obrigatrio preencher o tipo de combustvel em Motor de Veculos' as Msg
   FROM TW_TAB
   WHERE TRIM(MTOATI) IS NOT NULL
     AND TRIM(DESCMO) IS NULL
     AND TRIM(DESCMO) <> 'NOVO'
     AND TRIM(TIPCOM) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_MOT' as Tab, 'Obrigatrio preencher as cilindradas em Motor de Veculos' as Msg
   FROM TW_TAB
   WHERE TRIM(MTOATI) IS NOT NULL
     AND TRIM(DESCMO) IS NULL
     AND TRIM(DESCMO) <> 'NOVO'
     AND TRIM(CILIND) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_MOT' as Tab, 'Obrigatrio preencher a potncia em Motor de Veculos' as Msg
   FROM TW_TAB
   WHERE TRIM(MTOATI) IS NOT NULL
     AND TRIM(DESCMO) IS NULL
     AND TRIM(DESCMO) <> 'NOVO'
     AND TRIM(POTENC) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_MDV' as Tab, 'Obrigatrio preencher a descrio em Modelos de Veculos' as Msg
   FROM TW_TAB
   WHERE TRIM(MDVATI) IS NOT NULL
     AND TRIM(DESMDV) IS NULL
     AND TRIM(DESMDV) <> 'NOVO'
 UNION ALL
   SELECT CODTAB, 'TD_MDV' as Tab, 'Descrio de modelo ' || DESCRICAO ||' j cadastrado para o mesmo veculo ' || DESC_VEICULO as Msg
     FROM (SELECT TAB.DESMDV AS DESCRICAO, TAB.CODVEI AS VEICULO, DVEI.DESVEI AS DESC_VEICULO, MAX(TAB.CODTAB) AS CODTAB, COUNT(*) AS QTD 
             FROM TW_TAB TAB
             INNER JOIN TD_VEI DVEI ON DVEI.CODTAB = TAB.CODVEI
            WHERE TRIM(TAB.DESMDV) IS NOT NULL
              AND TAB.CODVEI IS NOT NULL
            GROUP BY TAB.DESMDV, TAB.CODVEI, DVEI.DESVEI) TABELA
    WHERE QTD > 1
 UNION ALL
   SELECT CODTAB, 'TD_MDV' as Tab, 'Obrigatrio preencher o veculo em Modelos de Veculos' as Msg
   FROM TW_TAB
   WHERE TRIM(MDVATI) IS NOT NULL
     AND TRIM(DESMDV) IS NULL
     AND TRIM(DESMDV) <> 'NOVO'
     AND CODVEI IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_MDV' as Tab, 'Obrigatrio preencher a distncia do eixo em Modelos de Veculos' as Msg
   FROM TW_TAB
   WHERE TRIM(MDVATI) IS NOT NULL
     AND TRIM(DESMDV) IS NULL
     AND TRIM(DESMDV) <> 'NOVO'
     AND TRIM(DISEXI) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_MDV' as Tab, 'Obrigatrio preencher o cdigo da marca em Modelos de Veculos' as Msg
   FROM TW_TAB
   WHERE TRIM(MDVATI) IS NOT NULL
     AND TRIM(DESMDV) IS NULL
     AND TRIM(DESMDV) <> 'NOVO'
     AND CODMAR IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_CORVEI' as Tab, 'Obrigatrio preencher a descrio em Cor de Veculos' as Msg
   FROM TW_TAB
   WHERE TRIM(CORVEIATI) IS NOT NULL
     AND TRIM(DESCORVEI) IS NULL
     AND TRIM(DESCORVEI) <> 'NOVO'
 UNION ALL
   SELECT CODTAB, 'TD_CORVEI' as Tab, 'Descrio de cor do veculo j cadastrado' as Msg
     FROM (SELECT DESCORVEI AS DESCRICAO, MAX(CODTAB) AS CODTAB, COUNT(*) AS QTD
             FROM TW_TAB
            WHERE TRIM(DESCORVEI) IS NOT NULL
            GROUP BY DESCORVEI) TABELA
    WHERE QTD > 1
 UNION ALL
   SELECT CODTAB, 'TD_CORVEI' as Tab, 'Obrigatrio preencher a cdigo da cor em Cor de Veculos' as Msg
   FROM TW_TAB
   WHERE TRIM(CORVEIATI) IS NOT NULL
     AND TRIM(DESCORVEI) IS NULL
     AND TRIM(DESCORVEI) <> 'NOVO'
     AND CODCORDEN IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_EST' as Tab, 'Obrigatrio preencher a sigla da Unidade Federativa' as Msg
   FROM TW_TAB
   WHERE(TRIM(NOMEST) IS NOT NULL
      OR PERICM IS NOT NULL)
     AND TRIM(ESTADO) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_EST' as Tab, 'Obrigatrio preencher o nome do Estado' as Msg
   FROM TW_TAB
   WHERE(TRIM(ESTADO) IS NOT NULL
      OR PERICM IS NOT NULL)
     AND TRIM(NOMEST) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_EST' as Tab, 'Obrigatrio preencher o percentual de ICMS' as Msg
   FROM TW_TAB
   WHERE(TRIM(ESTADO) IS NOT NULL
      OR TRIM(NOMEST) IS NOT NULL)
     AND PERICM IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_ECF' as Tab, 'Obrigatrio preencher a filial de ECF' as Msg
   FROM TW_TAB
   WHERE TRIM(SERECF) IS NOT NULL
     AND TRIM(FILECF) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_ECF' as Tab, 'Obrigatrio preencher o modelo do ECF' as Msg
   FROM TW_TAB
   WHERE TRIM(SERECF) IS NOT NULL
     AND TRIM(MODECF) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_ECF' as Tab, 'Obrigatrio preencher o nmero do ECF' as Msg
   FROM TW_TAB
   WHERE TRIM(SERECF) IS NOT NULL
     AND TRIM(NUMECF) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_SER' as Tab, 'Os valores permitidos nesse campo so 0, 1, 2, 3, 4, 55, 59 ou 65.' as Msg
   FROM  TW_TAB
   WHERE TRIM(CODSER) IS NOT NULL
     AND MODNOT NOT IN (0, 1, 2, 3, 4, 55, 59, 65)
 UNION ALL
   SELECT CODTAB, 'TD_SER' as Tab, 'Necessrio preencher o campo Srie Fiscal Exportada se o modelo da nota for 55, 59 ou 65!' as Msg
   FROM  TW_TAB
   WHERE MODNOT IN (55, 59, 65)
      AND ((TRIM(SEREXT) = '') OR (SEREXT IS NULL))     
 UNION ALL
   SELECT CODTAB, 'TD_SER' as Tab, 'Obrigatrio preencher o campo Modelo de Nota.' as Msg
   FROM  TW_TAB
   WHERE TRIM(CODSER) IS NOT NULL
     AND MODNOT IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_SER' as Tab, 'Os cdigos CF, TT, XX, CK esto reservados para uso interno, no podem ser configurados' as Msg
   FROM  TW_TAB
   WHERE TRIM(CODSER) = 'CF'
      OR TRIM(CODSER) = 'TT'
      OR TRIM(CODSER) = 'XX'
      OR TRIM(CODSER) = 'CK'
 UNION ALL
 /*Paulo - 28/07/2008 - 64095*/
 SELECT CODTAB, 'TD_SER' as Tab, 'Os cdigos CC, 1, CF, UN no podem ser utilizados para ttulo avulso' as Msg
   FROM  TW_TAB
   WHERE CODSER in ('CC','1','CF','UN')
     AND TITAVU='T'
 UNION ALL
   SELECT CODTAB, 'TD_SER' as Tab, 'Obrigatrio preencher os campos Cdigo, N de itens, Descrio e Largura do extenso, no negativos, para incluir uma srie' as Msg
   FROM  TW_TAB
   WHERE TRIM(CODSER) IS NOT NULL
     AND (TRIM(DESSER) IS NULL
          OR COALESCE(QTDITS,-1) < 0
          OR COALESCE(QTDITP,-1) < 0
          OR COALESCE(EXTNOT,-1) < 0)
 UNION ALL
 SELECT CODTAB, 'TD_SER' as Tab, 'Informe uma srie de remessa existente.' as Msg
   FROM  TW_TAB
  WHERE COALESCE(SERREM, ' ') <> ' '
    AND NOT EXISTS (SELECT DSER.CODSER
                          FROM TD_SER DSER
                         WHERE TRIM(DSER.CODSER) = TRIM(TW_TAB.SERREM))
 UNION ALL
   SELECT CODTAB, 'TD_AMP' as Tab, 'Obrigatrio preencher todos os campos para cada ampliao' as Msg
   FROM  TW_TAB
   WHERE TRIM(PHOCOM) IS NOT NULL
     AND (COALESCE(PHOLAR,0) <=0
      OR  COALESCE(PHOALT,0) <=0
      OR  TRIM(PHOCOM) IS NULL)
 UNION ALL
   SELECT CODTAB, 'TD_DOC' as Tab, 'Obrigatrio preencher a sigla e a descrio do tipo de documento do parceiro' as Msg
   FROM  TW_TAB
   WHERE (TRIM(TIPDOC) IS NOT NULL
      OR TRIM(DESDOC) IS NOT NULL)
      AND (TRIM(TIPDOC) IS NULL
       OR  TRIM(DESDOC) IS NULL)
 UNION ALL
   SELECT CODTAB, 'TD_DOP' as Tab, 'Para o Pag-For somente foram homologadas as seguintes modalidades: Crdito em Conta e Ttulo de Terceiros.' as Msg
   FROM  TW_TAB
   WHERE MODPGT NOT IN (0,2,7)
 UNION ALL
   SELECT CODTAB, 'TD_DOP' as Tab, 'Obrigatrio preencher a descrio do tipo de documento de pagamento' as Msg
   FROM  TW_TAB
   WHERE TRIM(DESDOP) IS NOT NULL
     AND TRIM(DESDOP) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_CAI' as Tab, 'Obrigatrio preencher o cdigo e a descrio para a sangria/reforo' as Msg
   FROM  TW_TAB
   WHERE TRIM(CX_DES) IS NOT NULL
     AND (TRIM(CX_DES) IS NULL
      OR  TRIM(CX_COD) IS NULL)
 UNION ALL
   SELECT CODTAB, 'TD_CAI' as Tab, 'Cdigo 999  de uso interno do sistema' as Msg
   FROM  TW_TAB
   WHERE TRIM(CX_DES) IS NOT NULL
     AND TRIM(CX_COD) = '999'
 UNION ALL
   SELECT CODTAB, 'TD_CAI' as Tab, 'Obrigatrio preencher o Uso do Caixa para a sangria/reforo' as Msg
   FROM  TW_TAB
   WHERE TRIM(CX_DES) IS NOT NULL
     AND COALESCE(CX_USU,-1) < 0
 UNION ALL
   SELECT CODTAB, 'TD_BOM' as Tab, 'Obrigatrio preencher o Cdigo de Filial da Bomba' as Msg
   FROM TW_TAB
   WHERE TRIM(CODFIL) IS NULL AND
          (NUMBOM IS NOT NULL
           OR TRIM(NSERIE) IS NOT NULL
           OR TRIM(NOMFAB) IS NOT NULL
           OR TRIM(MODELO) IS NOT NULL
           OR TRIM(TIPMED) IS NOT NULL)
 UNION ALL
   SELECT CODMAX AS CODTAB, 'TD_EST' AS Tab, 'A sigla  "'||est||'" est cadastrada "'||qtd|| '" vezes' AS Msg
   FROM (SELECT ESTADO AS est, MAX(CODTAB) AS CODMAX, COUNT(*) AS QTD
      FROM TW_TAB
      WHERE TRIM(ESTADO) IS NOT NULL
      GROUP BY ESTADO) TABELA
   WHERE QTD > 1
 UNION ALL
   SELECT CODMAX AS CODTAB, 'TD_ECF' AS Tab, 'Existem "'||qtd|| '" ECFs com o mesmo nmero na mesma filial: "'||fil||'"' AS Msg
   FROM (SELECT FILECF AS fil, MAX(CODTAB) AS CODMAX, COUNT(*) AS QTD
      FROM TW_TAB
      WHERE TRIM(NUMECF) IS NOT NULL
        AND FILECF IS NOT NULL
      GROUP BY FILECF,NUMECF) TABELA
   WHERE QTD > 1
 UNION ALL
   SELECT CODMAX AS CODTAB, 'TD_ECF' AS Tab, 'O nmero de srie "'||ser||'" est cadastrado "'||qtd|| '" vezes' AS Msg
     FROM (SELECT MAX(CODTAB) AS CODMAX, TRIM(SERECF) AS ser , COUNT(*) AS QTD
             FROM TW_TAB
            WHERE TRIM(SERECF) IS NOT NULL
            GROUP BY TRIM(SERECF)) TABELA
   WHERE QTD > 1
 UNION ALL
   SELECT CODMAX AS CODTAB, 'TD_FIL' AS Tab, 'O cdigo de filial "'||ser||'" est cadastrado "'||qtd|| '" vezes' AS Msg
   FROM (SELECT CODSER AS ser, MAX(CODTAB) AS CODMAX, COUNT(*) AS QTD
      FROM TW_TAB
      WHERE TRIM(DESSER) IS NOT NULL
        AND CODSER IS NOT NULL
      GROUP BY CODSER) TABELA
   WHERE QTD > 1
 UNION ALL
   SELECT TAB.CODTAB, 'TD_CAI' as Tab, 'Conta no encontrada em Sangria/Reforo ou no informada' as Msg
     FROM TW_TAB TAB LEFT OUTER JOIN TT_CTA CTA ON TAB.FILCAI = CTA.CODFIL AND TAB.SEQCAI = CTA.SEQUEN AND TAB.TIPCAI = CTA.TIPCTA
     WHERE TRIM(TAB.CX_DES) IS NOT NULL
       AND CTA.SEQUEN IS NULL
 UNION ALL
   SELECT CODMAX AS CODTAB, 'TD_CAI' AS Tab, 'Existem "'||qtd|| '" registros com o cdigo "'||cod||'" em Sangria/Reforo' AS Msg
   FROM (SELECT CX_COD AS COD, MAX(CODTAB) AS CODMAX, COUNT(*) AS QTD
      FROM TW_TAB
      WHERE TRIM(CX_DES) IS NOT NULL
        AND TRIM(CX_COD) IS NOT NULL
      GROUP BY CX_COD) TABELA
   WHERE QTD > 1
 UNION ALL
   SELECT CODTAB, 'TD_SAZ' as Tab, 'Um Valor de Sazonalidade no pode ser negativo' as Msg
     FROM TW_TAB
     WHERE TRIM(DESSAZ) IS NOT NULL
      AND (COALESCE(SAZ001,0) < 0
       OR  COALESCE(SAZ002,0) < 0
       OR  COALESCE(SAZ003,0) < 0
       OR  COALESCE(SAZ004,0) < 0
       OR  COALESCE(SAZ005,0) < 0
       OR  COALESCE(SAZ006,0) < 0
       OR  COALESCE(SAZ007,0) < 0
       OR  COALESCE(SAZ008,0) < 0
       OR  COALESCE(SAZ009,0) < 0
       OR  COALESCE(SAZ010,0) < 0
       OR  COALESCE(SAZ011,0) < 0
       OR  COALESCE(SAZ012,0) < 0)
 UNION ALL
   SELECT CODTAB, 'TD_SAZ' as Tab, 'A sazonalidade em "'||DESSAZ||'"  no fecha em 100%' as Msg
     FROM TW_TAB
     WHERE TRIM(DESSAZ) IS NOT NULL
       AND (COALESCE(SAZ001,0) + COALESCE(SAZ002,0) + COALESCE(SAZ003,0) + COALESCE(SAZ004,0) + COALESCE(SAZ005,0) + COALESCE(SAZ006,0)
          + COALESCE(SAZ007,0) + COALESCE(SAZ008,0) + COALESCE(SAZ009,0) + COALESCE(SAZ010,0) + COALESCE(SAZ011,0) + COALESCE(SAZ012,0)) <> 100
 UNION ALL
   SELECT TO_NUMBER(MUN.CODIGO) AS CODTAB, '48' as Tab, 'No foi informado o Percentual de ICMS para "'||TRIM(MUN.NOMCID)||' - '||TRIM(MUN.SIGEST)||' "' as Msg
     FROM TT_MUN MUN INNER JOIN TT_ICM ICM ON  MUN.CODIGO = ICM.CODCID
    WHERE COALESCE(PERICM,0) = 0
 UNION ALL
   SELECT 5 as CODTAB, '5' as Tab, 'Os valores em Quantidade e Valor para ABC no podem ser nulos' as Msg
     FROM TW_CFG
     WHERE ABCQA IS NULL
        OR ABCQB IS NULL
        OR ABCQC IS NULL
        OR ABCVA IS NULL
        OR ABCVB IS NULL
        OR ABCVC IS NULL
 UNION ALL
   SELECT 5 as CODTAB, '5' as Tab, 'Quantidade para ABC no fecha em 100%' as Msg
     FROM TW_CFG
     WHERE  (COALESCE(ABCQA,0) + COALESCE(ABCQB,0) + COALESCE(ABCQC,0)) <> 100
 UNION ALL
   SELECT 5 as CODTAB, '5' as Tab, 'Os valores para ABC no fecha em 100%' as Msg
     FROM TW_CFG
     WHERE  (COALESCE(ABCVA,0) + COALESCE(ABCVB,0) + COALESCE(ABCVC,0)) <> 100
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher o nome da sua empresa' as Msg
     FROM TW_CFG
     WHERE  TRIM(NOMEMP) IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher os dados para venda ao consumidor' as Msg
     FROM TW_CFG
     WHERE TRIM(VC_FILCLI) IS NULL
        OR TRIM(VC_CODCLI) IS NULL
        OR TRIM(VC_FILPGT) IS NULL
        OR TRIM(VC_CODPGT) IS NULL
        OR TRIM(VC_SERIE)  IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '44' as Tab, 'Obrigatrio preencher os dados do nome da moeda' as Msg
     FROM TW_CFG
     WHERE TRIM(SINGULINT) IS NULL
        OR TRIM(PLURALINT) IS NULL
        OR TRIM(SINGULDEC) IS NULL
        OR TRIM(PLURALDEC) IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher o nome para cdigo livre do SAC em (Parceiro/SAC)' as Msg
     FROM TW_CFG
     WHERE TRIM(NOMCODSAC) IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher o nome para lista fixa do SAC em (Parceiro/SAC)' as Msg
     FROM TW_CFG
     WHERE TRIM(NOMLSTSAC) IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher o nome para sub-cdigo livre do SAC em (Parceiro/SAC)' as Msg
     FROM TW_CFG
     WHERE TRIM(SUBCODSAC) IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'O campo "Atualiza Preos" deve estar "verdadeiro" ou "falso"' as Msg
     FROM TW_CFG
     WHERE TRIM(PCOONLINE) IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher a Filial da tabela de preos para venda ao varejo' as Msg
     FROM TW_CFG
     WHERE TRIM(FILPRE) IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher o Cdigo da tabela de preos para venda ao varejo' as Msg
     FROM TW_CFG
     WHERE CODPRE IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher a descriao para o campo nmero de srie em (Sries)' as Msg
     FROM TW_CFG
     WHERE TRIM(NOMNUMSER) IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher a descrio para o campo nmero de registro em (Sries)' as Msg
     FROM TW_CFG
     WHERE TRIM(NOMNUMREG) IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher o Percentual de Imposto de Renda em (Venda/Net)' as Msg
     FROM TW_CFG
     WHERE PERIR IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher o campo Tranferncias recurso/dinheiro em (Contas/Taxas)' as Msg
     FROM TW_CFG
     WHERE TRIM(FILCTA_TRN) IS NULL
       OR  TRIM(SEQCTA_TRN) IS NULL
       OR  TRIM(TIPCTA_TRN) IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher o Nmero de dias de validade dos Oramentos em (Empresa)' as Msg
     FROM TW_CFG
     WHERE VLDORC IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher o Nmero mximo de perguntas ao parceiro em (Parceiro/SAC)' as Msg
     FROM TW_CFG
     WHERE MAXPER IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher o E-mail do emitente para o envio de mensagens de alerta do sistema em (Venda/Net)' as Msg
     FROM TW_CFG
     WHERE TRIM(MAI_FR) IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher o E-mail do destinatrio para o recebimento de mensagens de alerta do sistema em (Venda/Net)' as Msg
     FROM TW_CFG
     WHERE TRIM(MAI_TO) IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'O campo CPF/CNPJ Obrigatrio deve estar "verdadeiro" ou "falso" em (Empresa)' as Msg
     FROM TW_CFG
     WHERE TRIM(USADOC) IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'O campo Postos de Combustveis deve estar "verdadeiro" ou "falso" em (Geral)' as Msg
     FROM TW_CFG
     WHERE TRIM(TIPPOS) IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'O campo Farmcias ou Drogarias deve estar "verdadeiro" ou "falso" em (Geral)' as Msg
     FROM TW_CFG
     WHERE TRIM(TIPFAR) IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'O campo Softwarehouse deve estar "verdadeiro" ou "falso" em (Geral)' as Msg
     FROM TW_CFG
     WHERE TRIM(TIPSOFT) IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher o campo Taxa financeira diria em (Contas/Taxas)' as Msg
     FROM TW_CFG
     WHERE TAXFIN IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher o campo Prazo em dias em (Contas/Taxas)' as Msg
     FROM TW_CFG
     WHERE PRAFIN IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher o campo Srie para faturamento de c/c em (Sries)' as Msg
     FROM TW_CFG
     WHERE TRIM(SERIE_FAT_CC) IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher o campo Conta Corrente Cobrvel no CheckOut em (Parceiro/SAC)' as Msg
     FROM TW_CFG
     WHERE CC_CHECKOUT IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher o campo Natureza padro para faturamento c/c em (Sries)' as Msg
     FROM TW_CFG
     WHERE NAT_FAT_CC IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher o campo Carncia de recebimentos em (Venda/Net)' as Msg
     FROM TW_CFG
     WHERE CARENCIA IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'O campo Usa estoque externo mantido por outro sistema deve estar "verdadeiro" ou "falso" em (Geral)' as Msg
     FROM TW_CFG
     WHERE TRIM(VLDESTEXT) IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, ' o "Path para Biblioteca TTSEGUR no Servidor de Banco de Dados"  obrigatrio! - Aba Operao - Diversos - Sub aba Arquivos' as Msg
     FROM TW_CFG
      WHERE TRIM(coalesce(PATH_TTSEGUR,'')) = ''
UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher o campo %Tolerncia para limite de crdito' as Msg
     FROM TW_CFG
     WHERE LIM_TIPTOL = 'P' and LIM_PERTOL IS NULL
UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher o campo Valor de Tolerncia para limite de crdito' as Msg
     FROM TW_CFG
     WHERE LIM_TIPTOL = 'V' and LIM_VALTOL IS NULL
 UNION ALL
  SELECT 23 as CODTAB, '23' as Tab, 'No  permitido informar o mesmo cliente como consumidor padro e consumidor de entrega.' as Msg
    FROM TW_CFG
   WHERE VC_FILCLI = ENT_FILCLI
     AND VC_CODCLI = ENT_CODCLI
 UNION ALL
   SELECT CODTAB, 'TD_HOM' as Tab, 'Obrigatrio preencher a descrio da homologao ' as Msg
   FROM TW_TAB
   WHERE TRIM(CODHOM) IS NOT NULL
     AND TRIM(DESHOM) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_HOM' as Tab, 'Obrigatrio preencher o cdigo da homologao ' as Msg
   FROM TW_TAB
   WHERE TRIM(DESHOM) IS NOT NULL
     AND TRIM(CODHOM) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_ECF' as Tab, 'O nmero da Impressora Fiscal deve ser inteiro, de 000 a 999' as Msg
   FROM TW_TAB
   WHERE TRIM(SERECF) IS NOT NULL
     AND IsDigit(COALESCE(NUMECF,'ZZZ')) <> 1
 UNION ALL
   SELECT CODTAB, 'TD_BCO' as Tab, 'Obrigatrio preencher Cdigo do banco' as Msg
   FROM TW_TAB
   WHERE TRIM(NBANCO) IS NOT NULL
     AND TRIM(CBANCO) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_BCO' as Tab, 'Obrigatrio preencher Agncia do banco' as Msg
   FROM TW_TAB
   WHERE TRIM(NBANCO) IS NOT NULL
     AND TRIM(ABANCO) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_CAR' as Tab, 'O N de dias para crdito no deve ser negativo ou nulo' as Msg
   FROM TW_TAB
   WHERE TRIM(DESOUT) IS NOT NULL
     AND COALESCE(DIACAR,-1) < 0
 UNION ALL
   SELECT CODTAB, 'TD_COL' as Tab, 'Obrigatrio preencher posio inicial e final da Referncia e Quantidade' as Msg
   FROM TW_TAB
   WHERE TRIM(NOMCOL) IS NOT NULL
     AND COALESCE(DELIMI,-1) < 0
     AND (INIREF IS NULL
      OR  FIMREF IS NULL
      OR  INIQTD IS NULL
      OR  FIMQTD IS NULL)
 UNION ALL
   SELECT 200 as CODTAB, '200' as Tab, 'Obrigatrio Informar se o Valor Informado  Unitrio' as Msg
     FROM TW_CFG
     WHERE TRIM( CKVLRINFUN ) IS NULL
 UNION ALL
   SELECT 200 as CODTAB, '200' as Tab, 'Obrigatrio Informar se Usa Balana' as Msg
     FROM TW_CFG
     WHERE TRIM( CKUSABALAN ) IS NULL
 UNION ALL
   SELECT 200 as CODTAB, '200' as Tab, 'Obrigatrio Informar se Usa Nmeros Externos' as Msg
     FROM TW_CFG
     WHERE TRIM( CKPANUMEXT) IS NULL
 UNION ALL
   SELECT 200 as CODTAB, '200' as Tab, 'Obrigatrio Informar se Aceita Nmeros Externos Duplicados' as Msg
     FROM TW_CFG
     WHERE TRIM( CKNUMEXTDP ) IS NULL
 UNION ALL
   SELECT 200 as CODTAB, '200' as Tab, 'Obrigatrio Informar se Obriga a Informar Vendedor' as Msg
     FROM TW_CFG
     WHERE TRIM( CKPAOBRVEN ) IS NULL
 UNION ALL
   SELECT 200 as CODTAB, '200' as Tab, 'Obrigatrio Informar se Agrupa Produto com Grade na Impresso de Nota Fiscal' as Msg
     FROM TW_CFG
     WHERE TRIM( CKPAAGRUPA ) IS NULL
 UNION ALL
   SELECT 200 as CODTAB, '200' as Tab, 'Obrigatrio Informar se Trata todas as Vendas como Consumidor Final' as Msg
     FROM TW_CFG
     WHERE TRIM( CKPACONSFI ) IS NULL
 UNION ALL
   SELECT 200 as CODTAB, '200' as Tab, 'Obrigatrio Informar se Usa Apropriao no Recebimento de Dbitos' as Msg
     FROM TW_CFG
     WHERE TRIM( CKUSADEBAP ) IS NULL
 UNION ALL
   SELECT 200 as CODTAB, '200' as Tab, 'Obrigatrio Informar se Cliente  Fonte Pagadora de IRRF' as Msg
     FROM TW_CFG
     WHERE TRIM( CKPAPAGIRR ) IS NULL
 UNION ALL
   SELECT 200 as CODTAB, '200' as Tab, 'Obrigatrio Informar nmero de Casas Decimais da Quantidade' as Msg
     FROM TW_CFG
     WHERE CKPAQTDDEC IS NULL
 UNION ALL
   SELECT 200 as CODTAB, '200' as Tab, 'Obrigatrio Informar nmero de Casas Decimais do Preo Unitrio' as Msg
     FROM TW_CFG
     WHERE CKPAPREDEC IS NULL
 UNION ALL
   SELECT 200 as CODTAB, '200' as Tab, 'Obrigatrio Informar o nmero de Dias de Atraso do Cliente' as Msg
     FROM TW_CFG
     WHERE CKPADIASAT IS NULL
 UNION ALL
   SELECT 200 as CODTAB, '200' as Tab, 'Obrigatrio Informar o Preo Base de Subs. Tributria ( 1- Venda  2- Compra )' as Msg
     FROM TW_CFG
     WHERE CKPRECOSUB IS NULL
 UNION ALL
   SELECT 200 as CODTAB, '200' as Tab, 'Obrigatrio Informar se Permite Produto com Grade ser Pesvel?' as Msg
     FROM TW_CFG
     WHERE TRIM( CKGRADEPESAVEL ) IS NULL
 UNION ALL
   SELECT 200 as CODTAB, '200' as Tab, 'Obrigatrio Informar se Devolver Remessa junto com Fatura?' as Msg
     FROM TW_CFG
     WHERE TRIM( DEV_FATVIN ) IS NULL
 UNION ALL
   SELECT 200 as CODTAB, '200' as Tab, 'Obrigatrio Informar se Utiliza conta em trnsito na transferncia identificada.' as Msg
     FROM TW_CFG
     WHERE TRIM( USA_CTA_TRANSITO_TRANSF_IDENT ) IS NULL
 UNION ALL
   SELECT 201 as CODTAB, '201' as Tab, 'Obrigatrio Informar a Quantidade de vezes que pede Autenticao' as Msg
     FROM TW_CFG
     WHERE CKPAQTDAUT IS NULL
 UNION ALL
   SELECT 201 as CODTAB, '201' as Tab, 'Obrigatrio Informar se Imprime Promissria para Cheque Pr - Datado' as Msg
     FROM TW_CFG
     WHERE TRIM( CKPAMFIMPP ) IS NULL
 UNION ALL
   SELECT 201 as CODTAB, '201' as Tab, 'Obrigatrio Informar se Analisa Dgito do Cheque' as Msg
     FROM TW_CFG
     WHERE TRIM( CKPADIGCHE ) IS NULL
 UNION ALL
   SELECT 201 as CODTAB, '201' as Tab, 'Obrigatrio Informar se Preenche CPF/CNPJ do Cliente' as Msg
     FROM TW_CFG
     WHERE TRIM( CKPAPREDOC ) IS NULL
 UNION ALL
   SELECT 201 as CODTAB, '201' as Tab, 'Obrigatrio Informar se Altera o Valor a Apropriar do Cheque' as Msg
     FROM TW_CFG
     WHERE TRIM( CKPAVLRAPR ) IS NULL
 UNION ALL
   SELECT 201 as CODTAB, '201' as Tab, 'Obrigatrio Informar se nico Caixa Aberto' as Msg
     FROM TW_CFG
     WHERE TRIM( CKPAUNICAI ) IS NULL
 UNION ALL
   SELECT 203 as CODTAB, '203' as Tab, 'Obrigatrio Informar se Executa Sub-Frmula  1  a Cada Item' as Msg
     FROM TW_CFG
     WHERE TRIM( CKPACOML1 ) IS NULL
 UNION ALL
   SELECT 203 as CODTAB, '203' as Tab, 'Obrigatrio Informar se Executa Sub-Frmula  2  a Cada Item' as Msg
     FROM TW_CFG
     WHERE TRIM( CKPACOML2 ) IS NULL
 UNION ALL
   SELECT 203 as CODTAB, '203' as Tab, 'Obrigatrio Informar se Executa Sub-Frmula  3  a Cada Item' as Msg
     FROM TW_CFG
     WHERE TRIM( CKPACOML3 ) IS NULL
 UNION ALL
   SELECT 203 as CODTAB, '203' as Tab, 'Obrigatrio Informar se Executa Sub-Frmula  4  a Cada Item' as Msg
     FROM TW_CFG
     WHERE TRIM( CKPACOML4 ) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_CWS' as Tab, 'Obrigatrio preencher a Autorizao na classificao de Atendimentos e WorkFlow' as Msg
   FROM  TW_TAB
   WHERE TRIM(DESCWS) IS NOT NULL
     AND TRIM(PEDAUT) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_CWS' as Tab, 'Obrigatrio preencher o Tipo de classificao de Atendimentos e WorkFlow' as Msg
   FROM  TW_TAB
   WHERE TRIM(DESCWS) IS NOT NULL
     AND TRIM(TIPCWS) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_CWS' as Tab, 'Obrigatrio preencher a Natureza de Atendimentos e WorkFlow' as Msg
   FROM  TW_TAB
   WHERE TRIM(DESCWS) IS NOT NULL
     AND TRIM(TIPWOR) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_CWS' as Tab, 'Obrigatrio preencher a Origem de Atendimentos e WorkFlow' as Msg
   FROM  TW_TAB
   WHERE TRIM(ORICWS) IS NOT NULL
     AND TRIM(TIPWOR) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_PRI' as Tab, 'Obrigatrio preencher Horas para Transferncia de usurio em Severidades' as Msg
   FROM  TW_TAB
   WHERE TRIM(DESPRI) IS NOT NULL
     AND HORTRN IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_PRI' as Tab, 'Obrigatrio preencher Horas Padro em Severidades' as Msg
   FROM  TW_TAB
   WHERE TRIM(DESPRI) IS NOT NULL
     AND HORPAD IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_PRI' as Tab, 'Obrigatrio preencher o Tipo de Hora em Severidades' as Msg
   FROM  TW_TAB
   WHERE TRIM(DESPRI) IS NOT NULL
     AND TRIM(TIPHOR) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_PRI' as Tab, 'Obrigatrio preencher o Peso para clculo em Severidades' as Msg
   FROM  TW_TAB
   WHERE TRIM(DESPRI) IS NOT NULL
     AND PESPRI IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_PRI' as Tab, 'Obrigatrio preencher o Apelido em Severidades' as Msg
   FROM  TW_TAB
   WHERE TRIM(DESPRI) IS NOT NULL
     AND TRIM(APEPRI) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_PRI' as Tab, 'Obrigatrio preencher a prioridade mnima para a tarefa no Workflow' as Msg
   FROM  TW_TAB
   WHERE TRIM(DESPRI) IS NOT NULL
     AND WORPRI IS NULL
 UNION ALL
    SELECT CODTAB, 'TD_COB' as Tab, 'Cobrana somente pode gerar ttulos bancrios se a conta financeira vinculada a ela referir-se a uma conta bancria em "'||DESCOB||'" ' as Msg     FROM TW_TAB
     WHERE TRIM(DESCOB) IS NOT NULL
       AND TRIM(GERTIT) = 'T'
       AND TRIM(TIPCTB) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_COB' as Tab, 'Existe algum valor extenso menor ou igual a zero. Verifique' as Msg
   FROM  TW_TAB
   WHERE TRIM(DESCOB) IS NOT NULL
     AND COALESCE(LARUNI,0) <= 0
 UNION ALL
   SELECT CODTAB, 'TD_COB' as Tab, 'Obrigatrio preencher Carteira Padro se conta gerar ttulos bancrios em "'||DESCOB||'" ' as Msg
   FROM TW_TAB
   WHERE TRIM(DESCOB) IS NOT NULL
     AND (GERTIT = 'T' AND CODCCB IS NULL)
      OR (GERTIT = 'F' AND CODCCB IS NOT NULL)
 UNION ALL
   SELECT CODTAB, 'TD_COB' as Tab, 'O Valor Mnimo do Boleto dever ser preenchido quando o Valor Acrscimo do Boleto estiver preenchido' as Msg
     FROM TW_TAB
    WHERE TRIM(DESCOB) IS NOT NULL
      AND VLRMBL IS NULL
      AND VLRABL IS NOT NULL
 UNION ALL
   SELECT CODTAB, 'TD_COB' as Tab, 'O Valor Acrscimo do Boleto dever ser preenchido quando o Valor Mnimo do Boleto estiver preenchido' as Msg
     FROM TW_TAB
    WHERE TRIM(DESCOB) IS NOT NULL
      AND VLRABL IS NULL
      AND VLRMBL IS NOT NULL
 UNION ALL
   SELECT 205 as CODTAB, '205' as Tab, 'Obrigatrio preencher os dados para PHOTO - Outros' as Msg
     FROM TW_CFG
     WHERE TRIM(PAPHOTO) IS NULL
        OR PAPHODUPLO IS NULL
        OR PAPHOTEMPO IS NULL
 UNION ALL
   /*davi*/
   SELECT 23 as CODTAB, '23' as Tab, 'Selecione o gerente de cobrana' as Msg
     FROM TW_CFG
     WHERE (TRIM(COB_FIL_GERENTE) IS NULL
        AND TRIM(COB_COD_GERENTE) IS NULL)
        AND TRIM(COB_USA_SAC) = 'T'
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Selecione o gerente de cobrana' as Msg
     FROM TW_CFG
     WHERE (TRIM(COB_FIL_GERENTE) IS NULL
        AND TRIM(COB_COD_GERENTE) IS NULL)
        AND TRIM(COB_FORMA_REGISTRO) <> '0'
 UNION ALL
    SELECT CODTAB, 'TD_CTR' as Tab, 'Obrigatrio preencher a Conta a Vista para Unidade de Negcio "'||DESCTR|| '"' as Msg
   FROM TW_TAB
   WHERE TRIM(DESCTR) IS NOT NULL
     AND (TRIM(CTRTIP) IS NULL
      OR  TRIM(CTRSEQ) IS NULL
      OR  TRIM(CTRFIL) IS NULL)
 UNION ALL
    SELECT CODTAB, 'TD_CTR' as Tab, 'Obrigatrio preencher a Conta a Prazo para Unidade de Negcio "'||DESCTR|| '"' as Msg
   FROM TW_TAB
   WHERE TRIM(DESCTR) IS NOT NULL
     AND (TRIM(TIPPRA) IS NULL
      OR  TRIM(SEQPRA) IS NULL
      OR  TRIM(FILPRA) IS NULL)
 UNION ALL
    SELECT CODTAB, 'TD_IRE' as Tab, 'Obrigatrio preencher a Reduo ICMS para consumidor final' as Msg
   FROM TW_TAB
   WHERE REDCON IS NULL
     AND (APLCON IS NOT NULL OR
          ICMSRE IS NOT NULL OR
          REDTRA IS NOT NULL)
 UNION ALL
   /*davi*/
    SELECT CODTAB, 'TD_REG' as Tab, 'CEP inicial deve ser menor ou igual ao CEP final para a regio "'||REGIAO|| '"' as Msg
   FROM TW_TAB
   WHERE TRIM(REGIAO) IS NOT NULL
     AND LENGTH(TRIM(CEPINI)) <> 0
     AND LENGTH(TRIM(CEPFIM)) <> 0
     AND CEPINI > CEPFIM
 UNION ALL
   /*davi*/
    SELECT CODTAB, 'TD_REG' as Tab, 'CEP inicial e final devem estar preenchidos para a regio "'||REGIAO|| '"' as Msg
   FROM TW_TAB
   WHERE TRIM(REGIAO) IS NOT NULL
     AND (CEPINI IS NULL AND CEPFIM IS NOT NULL)
     OR  (CEPFIM IS NULL AND CEPINI IS NOT NULL)
 UNION ALL
  /*davi*/
    SELECT CODTAB, 'TD_REG' as Tab, 'CEP inicial e final devem ter 5 dgitos para a regio "'||REGIAO|| '"' as Msg
   FROM TW_TAB
   WHERE TRIM(REGIAO) IS NOT NULL
     AND (LENGTH(TRIM(CEPINI)) < 5
     OR   LENGTH(TRIM(CEPFIM)) < 5)
 UNION ALL
 /*davi*/
 SELECT CODTAB, 'TD_END' as Tab, 'Informe o uso no tipo de endereo "'||DESEND|| '"' as Msg
  FROM  TW_TAB
  WHERE TRIM(DESEND) IS NOT NULL
    AND TRIM(USOEND) IS NULL
 UNION ALL
 SELECT CODTAB, 'TD_STD' as Tab, 'Obrigatrio preencher o Tipo de Documento em Situao de Documentos' as Msg
  FROM  TW_TAB
  WHERE TRIM(DESSTD) IS NOT NULL
    AND DOMDOP IS NULL
 UNION ALL
    SELECT ITEM.CODTAB, 'TD_SUB' AS TAB, 'Para utilizar controle de embalagem,  preciso que todos os produtos da grade '||ITEM.NOMGRA||'  tenham a subdiviso  '||ITEM.ITESUB||'   faltam  '||ITEM.QTD||'  tens' as Msg
    FROM (
    SELECT  NOMGRA , MAX(CODTAB) AS CODTAB, MAX(ITESUB)AS ITESUB, COUNT(*) AS QTD
          FROM (
          SELECT MIN(IPR.ITEDIV), MIN(B.NOMGRA)AS NOMGRA , MAX(B.ITESUB) AS ITESUB, MIN(B.CODTAB) AS CODTAB
                   FROM TV_IPR_FAST IPR
                        INNER JOIN
                       (SELECT DISTINCT GRA.FILMAT,GRA.CODMAT,GRA.CODCOR, A.CODTAM,A.ITESUB,A.NOMGRA, A.CODTAB
                          FROM TT_GRA GRA INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
                               INNER JOIN
                               (SELECT DGRA.CODTAB AS CODGRA,
                                       DGRA.NOMGRA AS NOMGRA,
                                       DSUB.CODSAL AS CODTAM,
                                       DSUB.CODTAB AS CODTAB,
                                       SUB.NOMITE  AS ITESUB
                                 FROM TD_GRA DGRA INNER JOIN TW_TAB DSUB ON DSUB.CODTAB = DGRA.CODSUB
                                                  INNER JOIN TT_SUB SUB  ON DSUB.CODSAL = SUB.CODITE
                                 WHERE DSUB.CODSAL IS NOT NULL
                                )A ON A.CODGRA   = PRO.CODGRA
                          EXCEPT                          SELECT DISTINCT GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM, A.ITESUB, A.NOMGRA, A.CODTAB
                          FROM TT_GRA GRA INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
                               INNER JOIN
                               (SELECT DGRA.CODTAB AS CODGRA,
                                       DGRA.NOMGRA AS NOMGRA,
                                       DSUB.CODSAL AS CODTAM,
                                       DSUB.CODTAB AS CODTAB,
                                       SUB.NOMITE  AS ITESUB
                                 FROM TD_GRA DGRA INNER JOIN TW_TAB DSUB ON DSUB.CODTAB = DGRA.CODSUB
                                                  INNER JOIN TT_SUB SUB  ON DSUB.CODSAL = SUB.CODITE
                                 WHERE DSUB.CODSAL IS NOT NULL
                                ) A ON A.CODGRA = PRO.CODGRA AND A.CODTAM = GRA.CODTAM
                        )B
                        ON B.FILMAT = IPR.FILMAT
                       AND B.CODMAT = IPR.CODMAT
                       AND B.CODCOR = IPR.CODCOR
                GROUP BY IPR.ITEDIV
          ) ITEM
    GROUP BY NOMGRA ) ITEM
 UNION ALL
    SELECT CODMAX AS CODTAB, 'TD_CFO' AS TAB, 'O Cdigo CFOP "'||COD||'" com descrio "'||DES||'" est cadastrado "'||QTD||'" vezes' AS MSG
      FROM ( SELECT CODCFO AS COD, MAX(DESCFO) AS DES, MAX(CODTAB) AS CODMAX, COUNT(*) AS QTD  FROM TW_TAB
              WHERE TRIM(DESCFO) IS NOT NULL
              GROUP BY CODCFO) TABELA
     WHERE QTD > 1
 UNION ALL
 SELECT CODTAB, 'TD_CFO' as Tab, 'No  possvel cadastrar o CFOP 6405,  necessrio informar um valor vlido.' as Msg
   FROM TW_TAB
   WHERE TRIM(CODCFO) LIKE '6405%'
 UNION ALL
 SELECT CODTAB, 'TD_CFO' as Tab, 'No  possvel cadastrar o CFOP 6405,  necessrio informar um valor vlido.' as Msg
   FROM TW_TAB
   WHERE TRIM(EXTCFO) LIKE '6405%'
 UNION ALL
   SELECT CODMAX AS CODTAB, 'TD_BIC' AS Tab, 'O sequencial de bico de nmero "'||cod||'" est cadastrado "'||qtd|| '" vezes na mesma filial' AS Msg
   FROM (SELECT  MAX(SEQFIL) AS COD, MAX(CODTAB) AS CODMAX, COUNT(*) AS QTD
      FROM TW_TAB
      WHERE TRIM(FILBIC||SEQFIL) IS NOT NULL
      GROUP BY FILBIC||SEQFIL) TABELA
   WHERE QTD > 1
 UNION ALL
   SELECT CODMAX AS CODTAB, 'TD_BIC' AS Tab, 'O sequencial de bico de nmero "'||cod||'" est cadastrado "'||qtd|| '" vezes na para uma mesma bomba' AS Msg
   FROM (SELECT  MAX(SEQFIL) AS COD, MAX(CODTAB) AS CODMAX, COUNT(*) AS QTD
      FROM TW_TAB
      WHERE TRIM(FILBIC||CODBOM||SEQBOM) IS NOT NULL
      GROUP BY FILBIC||CODBOM||SEQBOM) TABELA
   WHERE QTD > 1
 UNION ALL
   SELECT CODMAX AS CODTAB, 'TD_TAN' AS Tab, 'O tanque de nmero "'||cod||'" est cadastrado "'||qtd|| '" vezes na mesma filial' AS Msg
   FROM (SELECT  MAX(TANQUE) AS COD, MAX(CODTAB) AS CODMAX, COUNT(*) AS QTD
      FROM TW_TAB
      WHERE TRIM(FILTAN||TANQUE) IS NOT NULL
      GROUP BY FILTAN||TANQUE) TABELA
   WHERE QTD > 1
 UNION ALL
   SELECT CODTAB, 'TD_TAN' as Tab, 'Obrigatrio preencher todos os campos para Tanques de Combustveis' as Msg
   FROM TW_TAB
   WHERE (TANQUE IS NOT NULL
      OR TRIM(FILTAN) IS NOT NULL)
     AND (TRIM(FILTAN) IS NULL
      OR  TANQUE IS NULL
      OR  TRIM(GRAFIL) IS NULL)
 UNION ALL
   SELECT CODTAB, 'TD_TER' as Tab, 'Obrigatrio preencher todos os campos para Terminais' as Msg
   FROM TW_TAB
   WHERE TRIM(TER_IP) IS NOT NULL
     AND (TRIM(FILTER) IS NULL)
 UNION ALL
   SELECT CODMAX AS CODTAB, 'TD_TER' AS Tab, 'O IP "'||ip||'" est cadastrado "'||qtd|| '" vezes' AS Msg
     FROM (SELECT TER_IP AS ip, MAX(CODTAB) AS CODMAX, COUNT(*) AS QTD
             FROM TW_TAB
            WHERE TRIM(TER_IP) IS NOT NULL
         GROUP BY TER_IP) TABELA
    WHERE QTD > 1
 UNION ALL
   SELECT 23 AS CODTAB, '23' AS Tab, 'Selecione a Validao dos Contatos' AS Msg
     FROM TW_CFG
     WHERE CLI_CONTAT IS NULL
        OR TRIM(CLI_CONTAT) = ''
 UNION ALL
   SELECT 23 AS CODTAB, '23' AS Tab, 'Tipo de Lanamento para Produo Prpria diferente de "+" (Entrada) - Aba Produto - Sub aba Estoque' AS Msg
     FROM TW_CFG
    WHERE TIPLAN_PPR IS NOT NULL
      AND EXISTS (SELECT 1 AS OK
                    FROM TW_TAB TAB
                   WHERE TAB.SINLAN <> '+'
                     AND TAB.DESLAN = (SELECT DLAN.DESLAN
                                         FROM TD_LAN DLAN
                                        WHERE DLAN.CODTAB = TIPLAN_PPR))
 UNION ALL
   SELECT 23 AS CODTAB, '23' AS Tab, 'Tipo de Lanamento para Produo Prpria sem "Movimenta Estoque Legal" - Aba Produto - Sub aba Estoque' AS Msg
     FROM TW_CFG
    WHERE TIPLAN_PPR IS NOT NULL
      AND EXISTS (SELECT 1 AS OK
                    FROM TW_TAB TAB
                   WHERE TAB.MOVLEG <> 'T'
                     AND TAB.DESLAN = (SELECT DLAN.DESLAN
                                         FROM TD_LAN DLAN
                                        WHERE DLAN.CODTAB = TIPLAN_PPR))
 UNION ALL
   SELECT 23 AS CODTAB, '23' AS Tab, 'Tipo de Lanamento para Produo Prpria no esta "Ativo" - Aba Produto - Sub aba Estoque' AS Msg
     FROM TW_CFG
    WHERE TIPLAN_PPR IS NOT NULL
      AND EXISTS (SELECT 1 AS OK
                    FROM TW_TAB TAB
                   WHERE TAB.LANATI <> 'T'
                     AND TAB.DESLAN = (SELECT DLAN.DESLAN
                                         FROM TD_LAN DLAN
                                        WHERE DLAN.CODTAB = TIPLAN_PPR))
 UNION ALL
   SELECT 23 AS CODTAB, '23' AS Tab, 'Tipo de Lanamento para Insumo diferente de "-" (Sada) - Aba Produto - Sub aba Estoque' AS Msg
     FROM TW_CFG
    WHERE TIPLAN_INS IS NOT NULL
      AND EXISTS (SELECT 1 AS OK
                    FROM TW_TAB TAB
                   WHERE TAB.SINLAN <> '-'
                     AND TAB.DESLAN = (SELECT DLAN.DESLAN
                                         FROM TD_LAN DLAN
                                        WHERE DLAN.CODTAB = TIPLAN_INS))
 UNION ALL
   SELECT 23 AS CODTAB, '23' AS Tab, 'Tipo de Lanamento para Insumo sem "Movimenta Estoque Legal" - Aba Produto - Sub aba Estoque' AS Msg
     FROM TW_CFG
    WHERE TIPLAN_INS IS NOT NULL
      AND EXISTS (SELECT 1 AS OK
                    FROM TW_TAB TAB
                   WHERE TAB.MOVLEG <> 'T'
                     AND TAB.DESLAN = (SELECT DLAN.DESLAN
                                         FROM TD_LAN DLAN
                                        WHERE DLAN.CODTAB = TIPLAN_INS))
 UNION ALL
   SELECT 23 AS CODTAB, '23' AS Tab, 'Tipo de Lanamento para Insumo no esta "Ativo" - Aba Produto - Sub aba Estoque' AS Msg
     FROM TW_CFG
    WHERE TIPLAN_INS IS NOT NULL
      AND EXISTS (SELECT 1 AS OK
                    FROM TW_TAB TAB
                   WHERE TAB.LANATI <> 'T'
                     AND TAB.DESLAN = (SELECT DLAN.DESLAN
                                         FROM TD_LAN DLAN
                                        WHERE DLAN.CODTAB = TIPLAN_INS))
 UNION ALL
   SELECT CODTAB, '227' as Tab, 'O campo ''Nome do Convnio p/ Recebimento Ttulos Terceiros'' deve ser preenchido - Aba Outros - Sub Aba Convnios para Recebimentos de Ttulos de Terceiros' as Msg
     FROM TW_TAB
       WHERE TRIM(Coalesce(DESRTT, '')) = '' AND
             RTTATI IS NOT NULL AND
             RTTEST IS NOT NULL
 UNION ALL
   SELECT CODTAB, 'TD_NAT' as Tab, 'Cdigo da Base de Clculo de Crdito de PIS/Cofins s pode ser informado quando CFOP no estado comear com 1, 2 ou 3' as Msg
     FROM TW_TAB
    WHERE (COALESCE(NATBCC, ' ') <> ' ')
      AND (SUBSTR(NATDEN, 1, 1) NOT IN ('1','2','3'))
 UNION ALL
   SELECT CODTAB, 'TD_NAT' as Tab, 'Cdigo da Base de Clculo de Crdito de PIS/Cofins s pode ser informado quando CFOP Gera Crdito' as Msg
     FROM TW_TAB
    WHERE (COALESCE(NATBCC, ' ') <> ' ')
      AND CFOPGeradorCredito(NATDEN) = 'F'
 UNION ALL
   SELECT CODTAB, 'TD_NAT' as Tab, 'Cdigo da Base de Clculo de Crdito de PIS/Cofins s pode ser informado quando CST de PIS/COFINS estiver entre 50 a 56 ou 60 a 66' as Msg
     FROM TW_TAB
    WHERE (COALESCE(NATBCC, ' ') <> ' ')
      AND (   (COALESCE(SITPIS, '0') NOT IN('50', '51', '52', '53', '54', '55', '56', '60', '61', '62', '63', '64', '65', '66') AND
               COALESCE(SITCOF, '0') NOT IN('50', '51', '52', '53', '54', '55', '56', '60', '61', '62', '63', '64', '65', '66')) OR
           (SITPIS IS NULL AND SITCOF IS NULL)
          )
 UNION ALL
   SELECT CODTAB, 'TD_ECF' as Tab, 'Obrigatrio preencher a "Mxima de Dinheiro em Caixa".' as Msg
     FROM TW_TAB
    WHERE TRIM(SERECF) IS NOT NULL
      AND MAXCAI IS NULL
 UNION ALL
     SELECT CODTAB, 'TD_STF' as Tab, 'O campo "Filial do Fornecedor" deve ser preenchido.' as Msg
     FROM TW_TAB
       WHERE TRIM(DESSTF) IS NOT NULL
         AND TRIM(STF_FILFOR) IS NULL
 UNION ALL
     SELECT CODTAB, 'TD_STF' as Tab, 'O campo "Cdigo do Fornecedor" deve ser preenchido.' as Msg
     FROM TW_TAB
       WHERE TRIM(DESSTF) IS NOT NULL
         AND TRIM(STF_CODFOR) IS NULL
 UNION ALL
     SELECT CODTAB, 'TD_STF' as Tab, 'O campo "Srie" deve ser preenchido.' as Msg
     FROM TW_TAB
       WHERE TRIM(DESSTF) IS NOT NULL
         AND TRIM(STF_CODSER) IS NULL
 UNION ALL
     SELECT CODTAB, 'TD_STF' as Tab, 'O campo "Srie" informado no est cadastrado em (Venda/Sries).' as Msg
     FROM TW_TAB
       WHERE TRIM(DESSTF) IS NOT NULL
         AND TRIM(STF_CODSER) IS NOT NULL
      AND NOT EXISTS (SELECT 1 AS OK
                                      FROM TD_SER DSER
                                   WHERE DSER.CODSER = STF_CODSER)
 UNION ALL
     SELECT CODTAB, 'TD_STF' as Tab, 'O campo "Setor" deve ser preenchido.' as Msg
     FROM TW_TAB
       WHERE TRIM(DESSTF) IS NOT NULL
         AND STF_CODSET IS NULL
 UNION ALL
     SELECT CODTAB, 'TD_STF' as Tab, 'O campo "Conta" deve ser preenchido.' as Msg
     FROM TW_TAB
       WHERE TRIM(DESSTF) IS NOT NULL
           AND (TRIM(STF_FILCTA) IS NULL OR TRIM(STF_SEQCTA) IS NULL OR TRIM(STF_TIPCTA) IS NULL)
 UNION ALL
     SELECT CODTAB, 'TD_STF' as Tab, 'O campo "Finalidade" deve ser preenchido.' as Msg
     FROM TW_TAB
       WHERE TRIM(DESSTF) IS NOT NULL
         AND TRIM(STF_CODFPS) IS NULL
 UNION ALL
     SELECT CODTAB, 'TD_STF' as Tab, 'O campo "Unidade de negcio" deve ser preenchido.' as Msg
     FROM TW_TAB
       WHERE TRIM(DESSTF) IS NOT NULL
         AND STF_CODCTR IS NULL
 UNION ALL
     SELECT CODTAB, 'TD_STF' as Tab, 'O campo "Centro de custo" deve ser preenchido.' as Msg
     FROM TW_TAB
       WHERE TRIM(DESSTF) IS NOT NULL
         AND STF_CODCUS IS NULL
 UNION ALL
     SELECT CODTAB, 'TD_STF' as Tab, 'O campo "Modelo DAR" deve ser preenchido.' as Msg
     FROM TW_TAB
       WHERE TRIM(DESSTF) IS NOT NULL
         AND TRIM(STF_CODDAR) IS NULL
 UNION ALL
     SELECT CODTAB, 'TD_STF' as Tab, 'O campo "Dia de vencimento" deve ser preenchido.' as Msg
     FROM TW_TAB
       WHERE TRIM(DESSTF) IS NOT NULL
         AND STF_DIAVEN IS NULL
UNION ALL
   SELECT CODTAB, 'TD_FRE' as Tab, 'O campo "Tipo de cobrana"  obrigatrio' as Msg
     FROM TW_TAB
       WHERE TRIM(DESFRE) IS NOT NULL
         AND TRIM(DFRE_TIPCOB) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_FRE' as Tab, 'O campo "% Sobre o valor" deve ser maior que 0 e menor que 100 para o tipo de cobrana selecionado ' as Msg
     FROM TW_TAB
       WHERE TRIM(DESFRE) IS NOT NULL
         AND DFRE_TIPCOB = 'V'
         AND NOT (COALESCE(DFRE_PERVEN,0) > 0 AND COALESCE(DFRE_PERVEN,0) < 100)
 UNION ALL
   SELECT CODTAB, 'TD_FRE' as Tab, 'O campo "Valor por entrega" deve ser maior que zero para o tipo de cobrana selecionado' as Msg
     FROM TW_TAB
       WHERE TRIM(DESFRE) IS NOT NULL
         AND DFRE_TIPCOB = 'E'
         AND (COALESCE(DFRE_VALENT,0) <= 0)
 UNION ALL
   SELECT CODTAB, 'TD_FRE' as Tab, 'O campo "Valor sobre peso" deve ser maior que zero para o tipo de cobrana selecionado' as Msg
     FROM TW_TAB
       WHERE TRIM(DESFRE) IS NOT NULL
         AND DFRE_TIPCOB = 'P'
         AND (COALESCE(DFRE_VALPES,0) <= 0)
 UNION ALL
   SELECT CODTAB, 'TD_FRE' as Tab, 'O campo "Valor sobre quantidade" deve ser maior que zero para o tipo de cobrana selecionado' as Msg
     FROM TW_TAB
       WHERE TRIM(DESFRE) IS NOT NULL
         AND DFRE_TIPCOB = 'Q'
         AND (COALESCE(DFRE_VALQTD,0) <= 0)
 UNION ALL
   SELECT CODTAB, 'TD_FRE' as Tab, 'O campo "Valor mnimo de frete" deve ser maior que zero, quando preenchido' as Msg
     FROM TW_TAB
       WHERE TRIM(DESFRE) IS NOT NULL
         AND (DFRE_FREMIN IS NOT NULL AND COALESCE(DFRE_FREMIN,0) <= 0)
 UNION ALL
   SELECT CODTAB, 'TD_FRE' as Tab, 'O campo "Valor mnimo para desconto" deve ser maior que zero, quando preenchido' as Msg
     FROM TW_TAB
       WHERE TRIM(DESFRE) IS NOT NULL
         AND (DFRE_MINDES IS NOT NULL AND COALESCE(DFRE_MINDES,0) <= 0)
 UNION ALL
   SELECT CODTAB, 'TD_FRE' as Tab, 'O campo "% Desconto no frete" deve ser maior que 0 e menor que 100, quando preenchido' as Msg
     FROM TW_TAB
       WHERE TRIM(DESFRE) IS NOT NULL
         AND (DFRE_PERDES IS NOT NULL AND  NOT (COALESCE(DFRE_PERDES,0) > 0 AND COALESCE(DFRE_PERDES,0) < 100))
 UNION ALL
   SELECT CODTAB, 'TD_PES' as Tab, 'Obrigatrio informar "Peso inicial"' as Msg
     FROM TW_TAB
    WHERE TRIM(DESPES) IS NOT NULL
      AND PESINI IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_PES' as Tab, 'Obrigatrio informar "Peso final"' as Msg
     FROM TW_TAB
    WHERE TRIM(DESPES) IS NOT NULL
      AND PESFIM IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_PES' as Tab, 'O campo "Peso final" deve ser maior que o campo "Peso inicial"' as Msg
     FROM TW_TAB
    WHERE TRIM(DESPES) IS NOT NULL
      AND PESINI IS NOT NULL
      AND PESFIM IS NOT NULL
      AND PESINI > PESFIM
 UNION ALL
   SELECT CODTAB, 'TD_PES' as Tab, 'Obrigatrio preencher descrio de "Faixas de pesos"' as Msg
    FROM TW_TAB
   WHERE TRIM(PESATI) IS NOT NULL
     AND TRIM(DESPES) IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio Informar o Valor Utilizado para Aquisio de Produtos' as Msg
     FROM TW_CFG
     WHERE TRIM( VALOR_AQUISICAO ) IS NULL
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'A soma dos valores informados no "Percentual de participao ABC" no alcanou o valor de 100%'  as Msg
     FROM TW_CFG
     WHERE  (PER_A + PER_B + PER_C) < 100
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'A soma dos valores informados no "Percentual de participao XYZ" no alcanou o valor de 100%'  as Msg
     FROM TW_CFG
     WHERE  (PER_X + PER_Y + PER_Z) < 100
  UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'A soma dos valores informados no "Percentual de participao ABC" excedeu o valor de 100%'  as Msg
     FROM TW_CFG
     WHERE  (PER_A + PER_B + PER_C) > 100
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'A soma dos valores informados no "Percentual de participao XYZ" excedeu o valor de 100%'  as Msg
     FROM TW_CFG
     WHERE  (PER_X + PER_Y + PER_Z) > 100
/* Tarefa - 104207
 UNION ALL
 SELECT  23 as CODTAB, '23' as Tab, ' necessrio informar o "Nmero de dias base para nmero de vendas", quando h alguma regra de classificao ABC/XYZ parametrizada.'  as Msg
     FROM TW_CFG
     WHERE  ((REGRA_CLSABC > 0) or (REGRA_CLSXYZ > 0))
     AND DIAS_NUMVEN IS NULL
*/
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Natureza de Ressarcimento de ST somente permite tipo "Complementar/Ajuste" ' as Msg
     FROM TW_CFG CFG INNER JOIN TW_TAB TAB ON CFG.NATRESSARCIMENTOST = TAB.CODTAB
     WHERE TRIM(NATURE) IS NOT NULL
       AND TAB.TIPNAT <> 'J'
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Natureza de Adjudicao (Apropriao) de Crdito de ICMS somente permite tipo "Complementar/Ajuste" ' as Msg
     FROM TW_CFG CFG INNER JOIN TW_TAB TAB ON CFG.NATADJUDICACAOICMS = TAB.CODTAB
     WHERE TRIM(NATURE) IS NOT NULL
       AND TAB.TIPNAT <> 'J'
 UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Permitido para o cdigo de matrcula somente os tamanhos  "5,6,7,9,10,12,15".' as Msg
     FROM  TW_CFG
     WHERE CFG_TAMANHOMATRICULA NOT IN ('5','6','7','9','10','12','15')
        OR CFG_TAMANHOMATRICULA IS NULL
 UNION ALL
   SELECT 25 AS CODTAB,
          '23' AS Tab,
          'Obrigatrio informar um Valor igual ou maior que zero para o campo "Dias para Recebimento dos Pedidos"' AS Msg
     FROM TW_CFG
     WHERE DIAS_REC_PEDIDOS IS NULL
        OR DIAS_REC_PEDIDOS < 0
 UNION ALL
   SELECT 26 AS CODTAB,
          '23' AS Tab,
          'Obrigatrio informar um Valor da lista para o campo "Regra para Calcular a Mdia de Vendas no Ponto de Pedido"' AS Msg
     FROM TW_CFG
     WHERE REGRA_MEDIA_VENDAS IS NULL
        OR REGRA_MEDIA_VENDAS NOT IN ('1','2')
 UNION ALL
   SELECT 25 AS CODTAB,
          '23' AS Tab,
          'Obrigatrio informar um Valor igual ou maior que zero para o campo "Dias para Variao do Preo"' AS Msg
     FROM TW_CFG
     WHERE DIAS_VARPRE IS NULL
        OR DIAS_VARPRE < 0
  union  all
  select 25 AS CODTAB,
         '23' AS Tab,
         'Obrigatrio informar um Valor da lista para o campo "Regra para Classificao ABC"' AS MSG
    from TW_CFG
   where REGRA_CLSABC is null
      or REGRA_CLSABC < 0
      or REGRA_CLSABC > 2
  union  all
  select 25 AS CODTAB,
         '23' AS Tab,
         'Obrigatrio informar um Valor da lista para o campo "Regra para Classificao XYZ"' AS MSG
    from TW_CFG
   where REGRA_CLSXYZ is null
      or REGRA_CLSXYZ < 0
      or REGRA_CLSXYZ > 2
 UNION ALL
   SELECT 25 AS CODTAB,
          '23' AS Tab,
          'Obrigatrio informar um valor da lista para o campo "Venda sem estoque do lote"' AS Msg
     FROM TW_CFG
     WHERE SEMESTLOTE IS NULL
        OR SEMESTLOTE not in (1,2,3)
  union  all
  select 25 as CODTAB,
         '23' as Tab,
         'Obrigatrio informar um Valor entre 1 e 999 para o campo "Nmero de Dias que Sero Considerados nas Classificaes ABC e XYZ"' as MSG
    from TW_CFG
   where DIAS_ABC_XYZ is null
      or DIAS_ABC_XYZ < 0
      or DIAS_ABC_XYZ > 999
  union  all
  select 25 as CODTAB,
         '23' as TAB,
         'O campo "Tamanho do Cdigo de Barras do Lote", se preenchido, deve ter um valor entre 0 e 99' as MSG
    from TW_CFG
   where TAMCODLOTE is not null
     and (TAMCODLOTE < 0 or TAMCODLOTE > 99)
 UNION ALL
   SELECT CODTAB, 'TD_ECF' as Tab, 'Permitido para o campo "Nvel de Log" somente os valores 0,1,2,3 e 9.' as Msg
   FROM  TW_TAB
   WHERE TRIM(SERECF) IS NOT NULL
     AND (NIVLOG NOT IN (0, 1, 2, 3, 9)
      OR NIVLOG IS NULL)
 UNION ALL
   SELECT CODTAB, 'TD_RTT' as Tab, 'Permitido para o campo "Tipo do correspondente bancrio" somente os valores 0,1,2,3,4.' as Msg
   FROM  TW_TAB
   WHERE TRIM(DESRTT) IS NOT NULL
     AND (RTTTIP NOT IN (0, 1, 2, 4)
      OR RTTTIP IS NULL)
 UNION ALL
   SELECT CODTAB, 'TD_COB' as Tab, 'Permitido para o campo "Nvel de Tela" somente os valores 1 e 2.' as Msg
   FROM  TW_TAB
     WHERE TRIM(DESCOB) IS NOT NULL
       AND (COBNIV NOT IN (1, 2)
        OR COBNIV IS NULL)
 UNION ALL
   SELECT CODTAB, 'TD_CAR' as Tab, 'Permitido para o Campo "Tamanho minimo da autorizao" somente os valores >= 0 ' as Msg
   FROM TW_TAB
   WHERE TRIM(DESOUT) IS NOT NULL
     AND (MINAUT < 0
      OR  MINAUT IS NULL)
 UNION ALL
   SELECT CODMAX AS CODTAB, 'TD_FCC' AS TAB, 'O percentual "'||TO_CHAR(PERATE)||'", utilizado para clculo de combustveis, est cadastrado "'||qtd|| '" vezes para a filial '||FCCFIL AS Msg
     FROM (SELECT MAX(CODTAB) AS CODMAX,PERATE,FCCFIL,COUNT(*) AS QTD
                   FROM TW_TAB
                 WHERE VLRTAX IS NOT NULL
                 GROUP BY PERATE,FCCFIL) TAB
   WHERE QTD > 1
 UNION ALL
   SELECT CODTAB, 'TD_IMG' as Tab, 'Obrigatrio preencher Descrio do "Grupo de Imagens"' as Msg
     FROM TW_TAB
   WHERE TRIM(IMGATI) IS NOT NULL
        AND CODTAB <> 0
        AND TRIM(DESIMG) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_IMG' as Tab, 'Obrigatrio preencher Letra do "Grupo de Imagens"' as Msg
     FROM  TW_TAB
   WHERE TRIM(IMGATI) IS NOT NULL
       AND CODTAB <> 0
       AND LETIMG IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_IMG' as Tab, 'Obrigatrio preencher Nome do Arquivo do "Grupo de Imagens"' as Msg
     FROM  TW_TAB
   WHERE TRIM(IMGATI) IS NOT NULL
        AND CODTAB <> 0
        AND NOMIMG IS NULL
 UNION ALL
  SELECT CODMAX AS CODTAB, 'TD_IMG' AS Tab, 'Letra "'||LET||'" est cadastrado "'||qtd|| '" vezes no "Grupo de Imagens"' AS Msg
    FROM (SELECT LETIMG AS LET, MAX(CODTAB) AS CODMAX, COUNT(*) AS QTD
                  FROM (SELECT LETIMG, CODTAB FROM TW_TAB  WHERE LETIMG IS NOT NULL ) TABELA
           GROUP BY LETIMG) TABELA
   WHERE QTD > 1
 UNION ALL
   SELECT CODTAB, 'TD_MVP' as Tab, 'Obrigatrio preencher Descrio do "Motivo de Variao de Preos"' as Msg
     FROM TW_TAB
   WHERE TRIM(MOTATI) IS NOT NULL
        AND CODTAB <> 0
        AND TRIM(DESMOT) IS NULL
 UNION ALL
   SELECT CODTAB, 'TD_MVP' as Tab, 'O campo "Desconto mximo" deve ser maior que 0 e menor que 100, quando preenchido' as Msg
     FROM TW_TAB
       WHERE TRIM(MOTATI) IS NOT NULL
         AND (DESMAXMOT IS NOT NULL AND  NOT (COALESCE(DESMAXMOT,0) > 0 AND COALESCE(DESMAXMOT,0) < 100))
 UNION ALL
   SELECT CODTAB, 'TD_MVP' as Tab, 'O campo "Acrscimo mximo" deve ser maior que 0 e menor que 100, quando preenchido' as Msg
     FROM TW_TAB
       WHERE TRIM(MOTATI) IS NOT NULL
         AND (ACRMAXMOT IS NOT NULL AND  NOT (COALESCE(ACRMAXMOT,0) > 0 AND COALESCE(ACRMAXMOT,0) < 100))
 UNION ALL
   SELECT 78 AS CODTAB,
          '200' AS Tab,
          'Obrigatrio informar um Valor igual ou maior que zero para o campo "% de IPI para Transferncias"' AS Msg
     FROM TW_CFG
     WHERE PERIPITRA IS NULL OR PERIPITRA < 0
UNION ALL
   SELECT 78 AS CODTAB,
          '200' AS Tab,
          'Obrigatrio informar um Valor igual ou maior que zero para o campo "% de IPI para Transferncias entre Filiais Atacadistas"' AS Msg
     FROM TW_CFG
     WHERE PERIPIATA IS NULL OR PERIPIATA < 0
UNION ALL
   SELECT CODTAB, 'TD_ECF' AS TAB, 'Modelo "2D-Cupom Fiscal" no admite contingncia - Aba "Totali POS"' AS MSG
     FROM TW_TAB
    WHERE TRIM(SERECF) IS NOT NULL
      AND CK4G_MODFIS_VC = '2D'
      AND CK4G_MODFIS_VC_CONT IS NOT NULL
UNION ALL
   SELECT CODTAB, 'TD_ECF' AS TAB, 'Modelo Fiscal e Contingncia no podem ser iguais - Aba "Totali POS"' AS MSG
     FROM TW_TAB
    WHERE TRIM(SERECF) IS NOT NULL
      AND CK4G_MODFIS_VC IS NOT NULL
      AND CK4G_MODFIS_VC_CONT IS NOT NULL
      AND CK4G_MODFIS_VC = CK4G_MODFIS_VC_CONT
UNION ALL
   SELECT CODTAB, 'TD_ECF' AS TAB, 'Contingncia offline s  permita com o uso de 65-NFC-e - Aba "Totali POS"' AS MSG
     FROM TW_TAB
    WHERE TRIM(SERECF) IS NOT NULL
      AND CK4G_USA_CONT_OFFLINE = 'T'
      AND COALESCE(CK4G_MODFIS_VC,'  ') <> '65'
      AND COALESCE(CK4G_MODFIS_VC_CONT,'  ') <> '65'
UNION ALL
   SELECT 25 AS CODTAB,
          '23' AS Tab,
          'Obrigatrio informar um Valor igual ou maior que zero para o campo "% da Partilha de ICMS para o Destino"' AS Msg
     FROM TW_CFG
     WHERE PERPARICM IS NULL OR PERPARICM < 0
UNION ALL
   SELECT 25 AS CODTAB,
          '23' AS Tab,
          'Obrigatrio selecionar um valor para o campo "Regra para Cdigo Fiscal"' AS Msg
     FROM TW_CFG
     WHERE REGRA_CODFIS IS NULL
UNION ALL
   SELECT CODTAB, 'TD_ECF' as Tab, 'Obrigatrio selecionar um valor para o campo "Forma Emisso CF-e"' AS Msg
     FROM TW_TAB
   WHERE TRIM(SERECF) IS NOT NULL
     AND FLGCFE IS NULL
UNION ALL
   SELECT CODTAB, 'TD_CAI' as Tab,'Permitido para o campo "Cdigo do Menu" somente os valores entre 1 e 99' as MSG
   FROM TW_TAB
   WHERE TRIM(CX_DES) IS NOT NULL
     AND CAIMEN IS NOT NULL
     AND (CAIMEN < 1 OR CAIMEN > 99)
UNION ALL
   SELECT CODMAX AS CODTAB, 'TD_CAI' AS Tab, 'Cdigo do Menu "'||CAIMEN||'" est cadastrado "'||QTD|| '" vezes' AS Msg
   FROM (SELECT CAIMEN, MAX(CODTAB) AS CODMAX, COUNT(*) AS QTD
      FROM (SELECT CAIMEN, CODTAB FROM TW_TAB
            WHERE CAIMEN IS NOT NULL ) TABELA
      GROUP BY CAIMEN) TABELA
   WHERE QTD > 1
UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'Obrigatrio preencher o Mensageria para Documento Fiscal Eletrnico em (N.F. Emitidas/Diversos)' as Msg
     FROM TW_CFG
     WHERE SISDFE IS NULL
-- MN - 101666
UNION ALL
   SELECT TAB.CODTAB as CODTAB, 'TD_NAT' as Tab, 'Natureza deve ser de Consumo Final quando estiver configurada como Consumo Local.' as Msg
     FROM TW_TAB TAB
     WHERE TAB.CONLOC = 'T'
       AND COALESCE(TAB.CONSFI, 'F') <> 'T'
-- MN - 103776
UNION ALL
   SELECT CODTAB, 'TD_OMI' AS TAB, 'Em Canal Omnichannel, Descrio: NOVO, no  uma descrio vlida.' as Msg
     FROM TW_TAB
    WHERE DESOMI = 'NOVO'
      AND CODTAB <> 0
UNION ALL
   SELECT CODTAB AS CODTAB,
          'TD_OMI' AS Tab,
          'Obrigatrio informar uma descrio para canal Omnichannel.' AS Msg
     FROM TW_TAB
     WHERE TRIM(COALESCE(DESOMI,'')) = ''
       AND OMIATI IS NOT NULL
UNION ALL
   SELECT CODTAB, 'TD_MOE' AS TAB, 'Em Moeda, Descrio: NOVO, no  uma descrio vlida.' as Msg
     FROM TW_TAB
    WHERE DESMOE = 'NOVO'
      AND CODTAB <> 0
UNION ALL
   SELECT CODTAB, 'TD_MOE' AS TAB, 'Obrigatrio preencher a Letra de atalho para Moeda.' as Msg
     FROM TW_TAB
    WHERE MOELET IS NULL
      AND DESMOE IS NOT NULL
      AND CODTAB <> 0
UNION ALL
   SELECT CODMAX AS CODTAB, 'TD_MOE' AS Tab, 'Moeda "'||DESMOE||'" est cadastrado "'||qtd|| '" vezes' AS Msg
     FROM (SELECT DESMOE AS DESMOE, MAX(CODTAB) AS CODMAX, COUNT(*) AS QTD
             FROM (SELECT DESMOE, CODTAB FROM TW_TAB  WHERE DESMOE IS NOT NULL ) TABELA
            GROUP BY DESMOE) TABELA
    WHERE QTD > 1
UNION ALL
   SELECT CODMAX AS CODTAB, 'TD_MOE' AS Tab, 'Letra de atalho "'||MOELET||'" est cadastrado "'||QTD|| '" vezes' AS Msg
     FROM (SELECT MOELET, MAX(CODTAB) AS CODMAX, COUNT(*) AS QTD
             FROM (SELECT MOELET, CODTAB FROM TW_TAB WHERE DESMOE IS NOT NULL AND CODTAB <> 0 AND MOELET IS NOT NULL ) TABELA
            GROUP BY MOELET) TABELA
    WHERE QTD > 1
UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'C/C padro para Devoluo (Outros >> Ambiente >> N.F. Emitidas) e Pendncias (Outros >> Ambiente >> C/C) no pode ser a mesma.' as Msg
     FROM TW_CFG
     WHERE CC_PENDENCIA IS NOT NULL
       AND CC_PENDENCIA = CC_DEVOLUCAO
UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'C/C padro para Pendncias (Outros >> Ambiente >> C/C) no pode ser a padro, deve ser criada uma conta corrente para pendncia.' as Msg
     FROM TW_CFG
     WHERE CC_PENDENCIA IS NOT NULL
       AND COALESCE(CC_PENDENCIA, 0) = 0
/* GES-2023034025
UNION ALL
   SELECT 23 as CODTAB, '23' as Tab, 'C/C padro para Pendncia (Outros >> Ambiente >> C/C) deve ser definida.' as Msg
     FROM TW_CFG
     WHERE CC_PENDENCIA IS NULL
*/     
UNION ALL
   SELECT CODTAB, 'TD_CAR' as Tab, 'Obrigatrio preencher "Administrador (parceiro)" no Carto "'||DESOUT|| '" (Venda >>> Caixa >>> Cartes).' as Msg
     FROM TW_TAB
    WHERE DESOUT IS NOT NULL
      AND (CLIADM IS NULL OR TIPADM IS NULL OR FILADM IS NULL OR CODADM IS NULL)
UNION ALL
   SELECT CODTAB, 'TD_NAT' as Tab, 'Obrigatrio preencher "Origem do preo usado pela Natureza (Totali POS)"' as Msg
     FROM  TW_TAB
    WHERE TRIM(NATURE) IS NOT NULL
      AND ISNULL(NATPRE) = 'T'
UNION ALL
   SELECT CODTAB, 'TD_RGC' as Tab, 'Regras de Comercializao "Somente Encomenda" devem ter tipo de entrega "Venda sob Encomenda"' as Msg
     FROM  TW_TAB
    WHERE TRIM(DESRGC) IS NOT NULL
      AND FLGENC = 'T'
      AND COALESCE(RGC_TIPENT, 'X') <> '7'
UNION ALL
   SELECT CODTAB, 'TD_RGC' as Tab, 'Regras de Comercializao com tipo de entrega "Venda sob Encomenda" devem ser "Somente Encomenda"' as Msg
     FROM  TW_TAB
    WHERE TRIM(DESRGC) IS NOT NULL
      AND FLGENC = 'F'
      AND COALESCE(RGC_TIPENT, 'X') = '7'
UNION ALL
   SELECT CODTAB, 'TD_PER' AS TAB, 'Em Perodos de Entrega no Order, Descrio: NOVO, no  uma descrio vlida.' as Msg
     FROM TW_TAB
    WHERE DESPER = 'NOVO'
      AND CODTAB <> 0
UNION ALL
   SELECT CODTAB AS CODTAB, 'TD_PER' AS Tab, 'Obrigatrio informar uma descrio para Perodos de Entrega no Order.' AS Msg
     FROM TW_TAB
     WHERE PERATI IS NOT NULL
       AND ((TRIM(COALESCE(DESPER,'')) = '') OR (DESPER IS NULL))
UNION ALL
   SELECT CODTAB AS CODTAB, 'TD_PER' AS Tab, 'Obrigatrio preencher "Cdigo para apresentao" para Perodos de Entrega no Order.' AS Msg
     FROM TW_TAB
     WHERE DESPER IS NOT NULL
       AND ((TRIM(COALESCE(PERCOD,'')) = '') OR (PERCOD IS NULL))
UNION ALL
   SELECT CODTAB AS CODTAB, 'TD_PER' AS Tab, 'Obrigatrio preencher "Ordem" para Perodos de Entrega no Order.' AS Msg
     FROM TW_TAB
     WHERE DESPER IS NOT NULL
       AND PERORD IS NULL
UNION ALL
   SELECT CODTAB AS CODTAB, 'TD_PER' AS Tab, 'Ordem para Perodos de Entrega no Order deve ser entre 1 e 9999.' AS Msg
     FROM TW_TAB
     WHERE DESPER IS NOT NULL
       AND (PERORD < 1 OR PERORD > 9999)
UNION ALL
   SELECT CODTAB AS CODTAB, 'TD_DEP' AS Tab, 'O Peso sobre o Preo de Venda no pode ser negativo.' AS Msg
     FROM TW_TAB
     WHERE DESDEP IS NOT NULL
       AND (COALESCE(PESPREVEN,0) < 0)
UNION ALL
   SELECT CODTAB AS CODTAB, 'TD_DEP' AS Tab, 'O Peso sobre o Prazo Entrega no pode ser negativo.' AS Msg
     FROM TW_TAB
     WHERE DESDEP IS NOT NULL
       AND (COALESCE(PESPRZENT,0) < 0)
UNION ALL
   SELECT CODTAB AS CODTAB, 'TD_DEP' AS Tab, 'A soma dos pesos deve ser igual a 100.' AS Msg
     FROM TW_TAB
     WHERE DESDEP IS NOT NULL
       AND (PESPRZENT IS NOT NULL or  PESPREVEN IS NOT NULL or  PESPREFOR IS NOT NULL )
       AND ((COALESCE(PESPRZENT,0) + COALESCE(PESPREVEN,0) + COALESCE(PESPREFOR,0)) <> 100)       
UNION ALL
   SELECT CODTAB AS CODTAB, 'TD_DEP' AS Tab, 'A Taxa de Juros ao Ms para Valor Presente no pode ser negativa.' AS Msg
     FROM TW_TAB
     WHERE DESDEP IS NOT NULL
       AND (COALESCE(TAXJURMES,0) < 0)
UNION ALL
   SELECT CODTAB AS CODTAB, 'TD_CCB' AS Tab, 'O campo "apelido" no pode estar em branco.' AS Msg
     FROM TW_TAB
     WHERE APECCB IS NULL
       AND DESCCB IS NOT NULL
  ) TABELA
 WHERE CODTAB <> 0
;


/*-- SEQ 2938 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_DOC_IVO CASCADE;

/*-- SEQ 2939 --*/
CREATE OR REPLACE VIEW TV_DOC_IVO AS
-- View criada para tela da impresso da separao do Commerce Web
SELECT TAB.* FROM (
SELECT DISTINCT VIVO.FILPED  AS FIL_PK,
                VIVO.TIPPED AS TIPPED_PK,
                VIVO.NUMPED AS NUMPED_PK,
                VIVO.FILPED, VIVO.TIPPED, VIVO.NUMPED, VIVO.FILIVE, VIVO.SEQIVE, VIVO.FILIPE, VIVO.NUMIPE,
                VIVO.ORIGEM, VIVO.FILCLI, VIVO.CODCLI, VIVO.FILVEN, VIVO.CODVEN, VIVO.VLRNOT, VIVO.DATHOR,
                VIVO.NUMPED_RE, VIVO.FILRET, VIVO.FILRET_NOME, VIVO.ORCECO, VIVO.IMPSEP,
                VIVO.EDE_FILCLI, VIVO.EDE_CODCLI, VIVO.EDE_CODFIL, VIVO.EDE_NUMEND, 
                -- Tabelas Trazidas por Joins
                USU.NOMUSU AS NOMVEN, CLI.E_MCON, CLI.NOMCLI, VIVO.FLGECO,  
                IVO_TotalmenteSeparada(VIVO.ORIGEM, VIVO.FILPED, VIVO.TIPPED, VIVO.NUMPED, VIVO.FILIVE, VIVO.SEQIVE, VIVO.FILIPE, VIVO.NUMIPE) AS SITUACAO_SEPARACAO,
                CASE WHEN COALESCE(ENDE.CODCEP, 'X') <> 'X' THEN ENDE.CODCEP || '-' || ENDE.CODLOG ELSE NULL END AS CODCEP,
                CASE WHEN COALESCE(ENDE.NUMFON, 'X') <> 'X' THEN CASE WHEN COALESCE(ENDE.CODDDD, 'X') <> 'X' THEN '(' || ENDE.CODDDD || ')' ELSE '' END ||  ENDE.NUMFON ELSE NULL END AS TELEFONE,
                PLA.DESPGT AS PLA_DESPGT,
                CAST((SELECT COALESCE(SUM(VLRSUB), 0)
                   FROM TT_IOR IOR
                  WHERE IOR.CODFIL = ORC.CODFIL
                    AND IOR.TIPPED = ORC.TIPPED
                    AND IOR.NUMPED = ORC.NUMPED
                    AND IOR.FLGEST <> 'C') 
                 AS Numeric(12, 2))AS TOTSUB,
                (  (ORC.VLRDES * 100) / NVLZ((ORC.VLRTOT-COALESCE(ORC.VLRFRE,0) - ORC.VLRDES) -
                   (SELECT COALESCE(SUM(VLRCUS),0)
                      FROM TT_IOR IOR
                      WHERE IOR.CODFIL = ORC.CODFIL
                        AND IOR.TIPPED = ORC.TIPPED
                        AND IOR.NUMPED = ORC.NUMPED
                        AND IOR.PROMOC <> 'N') - (CASE WHEN PLA.JURTOT = 'F' THEN CASE WHEN (ORC.VLRTOT-COALESCE(ORC.VLRFRE,0)-ORC.VLRDES) * PLA.PRIIDE <> 0 
                                                                                           THEN (((ORC.VLRTOT-COALESCE(ORC.VLRFRE,0)-ORC.VLRDES)) * PLA.PRIIDE / 100)
                                                                                           ELSE 0
                                                                                           END
                                                                              ELSE 0
                                                  END), 1)
                ) AS TAXDES,
                Rtf2Txt(ORC.OBSORC) AS OBSORC,
                ORC.VLRTOT,
                ENDE.ENDERE AS EENT_ENDERE, -- Endereo de Entrega
                ENDE.NUMERO AS EENT_NUMERO, -- Nmero de Entrega
                ENDE.NOMCID AS EENT_NOMCID, -- Cidade de Entrega
                ENDE.SIGEST AS EENT_SIGEST, -- Estado de Entrega
                ENDE.BAIRRO AS EENT_BAIRRO, -- Bairro de Entrega
                ENDE.COMPLE AS EENT_COMPLE, -- Complemento de Entrega
                CASE WHEN ENDE.CODCEP IS NOT NULL AND ENDE.CODLOG IS NOT NULL THEN ENDE.CODCEP || '-' || ENDE.CODLOG ELSE '' END AS EENT_CODCEP, -- CEP de Entrega
                CASE WHEN COALESCE(ENDE.CODDDD, 'X') <> 'X' THEN '(' ||ENDE.CODDDD ||') ' ELSE '' END || TRIM(ENDE.NUMFON) AS EENT_CONTATO, --  Telefone Contato de Entrega
                ENDE.CONTAT AS EENT_NOMECONTATO, --  Nome Contato de Entrega
                ENDC.ENDERE AS ECOB_ENDERE, -- Endereo de Cobrana
                ENDC.NUMERO AS ECOB_NUMERO, -- Nmero de Cobrana
                ENDC.NOMCID AS ECOB_NOMCID, -- Cidade de Cobrana
                ENDC.SIGEST AS ECOB_SIGEST, -- Estado de Cobrana
                ENDC.BAIRRO AS ECOB_BAIRRO, -- Bairro de Cobrana
                ENDC.COMPLE AS ECOB_COMPLE, -- Complemento de Cobrana
                CASE WHEN ENDC.CODCEP IS NOT NULL AND ENDC.CODLOG IS NOT NULL THEN ENDC.CODCEP || '-' || ENDC.CODLOG ELSE '' END AS ECOB_CODCEP, -- CEP de Cobrana
                CASE WHEN COALESCE(ENDC.CODDDD, 'X') <> 'X' THEN '(' ||ENDC.CODDDD ||') ' ELSE '' END || TRIM(ENDC.NUMFON) AS ECOB_CONTATO, -- Telefone Contato de Cobrana
                ENDC.CONTAT AS ECOB_NOMECONTATO, -- Nome Contato de Cobrana
                ENDF.ENDERE AS EFAT_ENDERE, -- Endereo de Fatura
                ENDF.NUMERO AS EFAT_NUMERO, -- Nmero de Fatura
                ENDF.NOMCID AS EFAT_NOMCID, -- Cidade de Fatura
                ENDF.SIGEST AS EFAT_SIGEST, -- Estado de Fatura
                ENDF.BAIRRO AS EFAT_BAIRRO, -- Bairro de Fatura
                ENDF.COMPLE AS EFAT_COMPLE, -- Complemento de Fatura
                CASE WHEN ENDF.CODCEP IS NOT NULL AND ENDF.CODLOG IS NOT NULL THEN ENDF.CODCEP || '-' || ENDF.CODLOG ELSE '' END AS EFAT_CODCEP, -- CEP de Fatura
                CASE WHEN COALESCE(ENDF.CODDDD, 'X') <> 'X' THEN '(' ||ENDF.CODDDD ||') ' ELSE '' END || TRIM(ENDF.NUMFON) AS EFAT_CONTATO, -- Telefone Contato de Fatura
                ENDF.CONTAT AS EFAT_NOMECONTATO, -- Nome Contato de Fatura
                CASE WHEN COALESCE(ENDE.CODDDD, 'X') <> 'X' THEN '(' ||ENDE.CODDDD ||') ' ELSE '' END || TRIM(ENDE.NUMFON) AS TELEFONE_CONTATO,
                ENDE.CONTAT AS NOME_CONTATO, 
                ENDE.ENDERE, ORC.VLRDES,
                CAST(TRIM(CLI.NOMCLI)||' '||TRIM(COALESCE(CLI.ULTNOM,''))AS VARCHAR(254)) AS NOME_COMPLETO, -- Nome Cliente
                CASE WHEN CLI.FLGTIP = 0 THEN 'CPF:' ELSE 'CNPJ: ' END || CLI.NUMDOC  AS DOCUMENTO,
                COALESCE(ENDE.ENDERE, '') || ' ' || COALESCE(ENDE.NUMERO, '') || ' ' || COALESCE(ENDE.BAIRRO, '') || ' ' || COALESCE(ENDE.CODCEP, '') AS LOGRADOURO,
                COALESCE(ENDE.NOMCID, '') || ' - ' || COALESCE(ENDE.SIGEST, '') AS CIDADE_UF,
                CAST(VIVO.NUMPED AS CHAR(10)) AS NUMPED_SEPARACAO, ORC.DATAPR, CAST(NULL AS Timestamp) AS DATENT,
                CAST(DescricaoDominio('ORC','SISORI', VIVO.SISORI) AS VARCHAR(50)) AS SISTEMA_ORIGEM,
                CAST(CASE WHEN DENT.DESENT IS NOT NULL THEN DENT.DESENT ELSE DescricaoDominio('ORC','TIPENT', ORC.TIPENT) END AS VARCHAR(50)) AS TIPO_ENTREGA,
                CAST(DescricaoDominio('ORC','FLGECO', ORC.FLGECO) AS VARCHAR(50)) AS SITUACAO_ECOMMERCE,
                VIVO.SISORI,
                ORC.TIPENT AS TIPENT,
                ORC.CODSER AS CODIGO_SERIE,
                VIVO.TELEVE, VIVO.TIPPAG
  FROM TV_IVO VIVO INNER JOIN TT_IOR IOR ON IOR.CODFIL = VIVO.FILPED
                                        AND IOR.TIPPED = VIVO.TIPPED
                                        AND IOR.NUMPED = VIVO.NUMPED
                                        AND IOR.NUMITE = VIVO.NUMITE
                   INNER JOIN TT_ORC ORC ON ORC.CODFIL = IOR.CODFIL
                                        AND ORC.TIPPED = IOR.TIPPED
                                        AND ORC.NUMPED = IOR.NUMPED
                    LEFT JOIN TT_PLA PLA ON ORC.FILPGT = PLA.FILPGT 
                                        AND ORC.CODPGT = PLA.CODPGT
                    LEFT JOIN TT_END ENDE ON VIVO.EDE_FILCLI = ENDE.FILCLI 
                                         AND VIVO.EDE_CODCLI = ENDE.CODCLI
                                         AND VIVO.EDE_CODFIL = ENDE.CODFIL
                                         AND VIVO.EDE_NUMEND = ENDE.NUMEND
                    LEFT JOIN TT_END ENDC ON VIVO.EDE_FILCLI = ENDC.FILCLI 
                                         AND VIVO.EDE_CODCLI = ENDC.CODCLI
                                         AND VIVO.EDE_FILCOB = ENDC.CODFIL
                                         AND VIVO.EDE_ENDCOB = ENDC.NUMEND
                    LEFT JOIN TT_END ENDF ON VIVO.EDE_FILCLI = ENDF.FILCLI 
                                         AND VIVO.EDE_CODCLI = ENDF.CODCLI
                                         AND VIVO.EDE_FILFAT = ENDF.CODFIL
                                         AND VIVO.EDE_ENDFAT = ENDF.NUMEND
                    LEFT JOIN TT_CLI CLI ON CLI.FILCLI = ORC.FILCLI --CASE WHEN VIVO.ORIGEM ='O' THEN VIVO.FILCLI ELSE VIVO.FILIPE END
                                        AND CLI.CODCLI = ORC.CODCLI --CASE WHEN VIVO.ORIGEM ='O' THEN VIVO.CODCLI ELSE VIVO.CODCLI END
                    LEFT JOIN TT_USU USU ON USU.FILUSU = ORC.FILVEN
                                        AND USU.CODUSU = ORC.CODVEN
                    LEFT JOIN TD_ENT DENT ON DENT.TIPENT = ORC.TIPENT
 WHERE VIVO.ORIGEM = 'O'
   AND VIVO.FLGEST <> 'C'
   AND VIVO.ORC_FLGEST = 'A'
   AND VIVO.ORC_APROVA = 'A'
   AND VIVO.ORC_APRCLI = '1'
   AND COALESCE(VIVO.FLGECO, 'P') <> '0'
 UNION ALL
SELECT DISTINCT VIVO.FILIPE  AS FIL_PK,
                'P' AS TIPPED_PK,
                VIVO.NUMIPE AS NUMPED_PK,
                VIVO.FILPED, VIVO.TIPPED, VIVO.NUMPED, VIVO.FILIVE, VIVO.SEQIVE, VIVO.FILIPE, VIVO.NUMIPE,
                VIVO.ORIGEM, VIVO.FILCLI, VIVO.CODCLI, VIVO.FILVEN, VIVO.CODVEN, VIVO.VLRNOT, VIVO.DATHOR,
                VIVO.NUMPED_RE, VIVO.FILRET, VIVO.FILRET_NOME, VIVO.ORCECO, VIVO.IMPSEP,
                VIVO.EDE_FILCLI, VIVO.EDE_CODCLI, VIVO.EDE_CODFIL, VIVO.EDE_NUMEND, 
                -- Tabelas Trazidas por Joins
                USU.NOMUSU AS NOMVEN, CLI.E_MCON, CLI.NOMCLI, VIVO.FLGECO,  
                IVO_TotalmenteSeparada(VIVO.ORIGEM, VIVO.FILPED, VIVO.TIPPED, VIVO.NUMPED, VIVO.FILIVE, VIVO.SEQIVE, VIVO.FILIPE, VIVO.NUMIPE) AS SITUACAO_SEPARACAO,
                CASE WHEN COALESCE(ENDE.CODCEP, 'X') <> 'X' THEN ENDE.CODCEP || '-' || ENDE.CODLOG ELSE NULL END AS CODCEP,
                CASE WHEN COALESCE(ENDE.NUMFON, 'X') <> 'X' THEN CASE WHEN COALESCE(ENDE.CODDDD, 'X') <> 'X' THEN '(' || ENDE.CODDDD || ')' ELSE '' END ||  ENDE.NUMFON ELSE NULL END AS TELEFONE,
                CAST(NULL AS VARCHAR(35)) AS PLA_DESPGT,
                CAST(NULL AS Numeric(12, 2)) AS TOTSUB,
                CAST(NULL AS Numeric(12, 2)) AS TAXDES,
                Rtf2Txt(PED.OBSERV) AS OBSORC,
                PED.VLRTOT,
                ENDE.ENDERE AS EENT_ENDERE, -- Endereo de Entrega
                ENDE.NUMERO AS EENT_NUMERO, -- Nmero de Entrega
                ENDE.NOMCID AS EENT_NOMCID, -- Cidade de Entrega
                ENDE.SIGEST AS EENT_SIGEST, -- Estado de Entrega
                ENDE.BAIRRO AS EENT_BAIRRO, -- Bairro de Entrega
                ENDE.COMPLE AS EENT_COMPLE, -- Complemento de Entrega
                CASE WHEN ENDE.CODCEP IS NOT NULL AND ENDE.CODLOG IS NOT NULL THEN ENDE.CODCEP || '-' || ENDE.CODLOG ELSE '' END AS EENT_CODCEP, -- CEP de Entrega
                CASE WHEN COALESCE(ENDE.CODDDD, 'X') <> 'X' THEN '(' ||ENDE.CODDDD ||') ' ELSE '' END || TRIM(ENDE.NUMFON) AS EENT_CONTATO, --  Telefone Contato de Entrega
                ENDE.CONTAT AS EENT_NOMECONTATO, --  Nome Contato de Entrega
                ENDE.ENDERE AS ECOB_ENDERE, -- Endereo de Cobrana
                ENDE.NUMERO AS ECOB_NUMERO, -- Nmero de Cobrana
                ENDE.NOMCID AS ECOB_NOMCID, -- Cidade de Cobrana
                ENDE.SIGEST AS ECOB_SIGEST, -- Estado de Cobrana
                ENDE.BAIRRO AS ECOB_BAIRRO, -- Bairro de Cobrana
                ENDE.COMPLE AS ECOB_COMPLE, -- Complemento de Cobrana
                CASE WHEN ENDE.CODCEP IS NOT NULL AND ENDE.CODLOG IS NOT NULL THEN ENDE.CODCEP || '-' || ENDE.CODLOG ELSE '' END AS ECOB_CODCEP, -- CEP de Cobrana
                CASE WHEN COALESCE(ENDE.CODDDD, 'X') <> 'X' THEN '(' ||ENDE.CODDDD ||') ' ELSE '' END || TRIM(ENDE.NUMFON) AS ECOB_CONTATO, -- Telefone Contato de Cobrana
                ENDE.CONTAT AS ECOB_NOMECONTATO, -- Nome Contato de Cobrana
                ENDE.ENDERE AS EFAT_ENDERE, -- Endereo de Fatura
                ENDE.NUMERO AS EFAT_NUMERO, -- Nmero de Fatura
                ENDE.NOMCID AS EFAT_NOMCID, -- Cidade de Fatura
                ENDE.SIGEST AS EFAT_SIGEST, -- Estado de Fatura
                ENDE.BAIRRO AS EFAT_BAIRRO, -- Bairro de Fatura
                ENDE.COMPLE AS EFAT_COMPLE, -- Complemento de Fatura
                CASE WHEN ENDE.CODCEP IS NOT NULL AND ENDE.CODLOG IS NOT NULL THEN ENDE.CODCEP || '-' || ENDE.CODLOG ELSE '' END AS EFAT_CODCEP, -- CEP de Fatura
                CASE WHEN COALESCE(ENDE.CODDDD, 'X') <> 'X' THEN '(' ||ENDE.CODDDD ||') ' ELSE '' END || TRIM(ENDE.NUMFON) AS EFAT_CONTATO, -- Telefone Contato de Fatura
                ENDE.CONTAT AS EFAT_NOMECONTATO, -- Nome Contato de Fatura
                CASE WHEN COALESCE(ENDE.CODDDD, 'X') <> 'X' THEN '(' ||ENDE.CODDDD ||') ' ELSE '' END || TRIM(ENDE.NUMFON) AS TELEFONE_CONTATO,
                ENDE.CONTAT AS NOME_CONTATO, ENDE.ENDERE, PED.DESCON AS VLRDES,
                CAST(TRIM(CLI.NOMCLI)||' '||TRIM(COALESCE(CLI.ULTNOM,''))AS VARCHAR(254)) AS NOME_COMPLETO, -- Nome Cliente
                CASE WHEN CLI.FLGTIP = 0 THEN 'CPF:' ELSE 'CNPJ: ' END || CLI.NUMDOC AS DOCUMENTO,
                COALESCE(ENDE.ENDERE, '') || ' ' || COALESCE(ENDE.NUMERO, '') || ' ' || COALESCE(ENDE.BAIRRO, '') || ' ' || COALESCE(ENDE.CODCEP, '') AS LOGRADOURO,
                COALESCE(ENDE.NOMCID, '') || ' - ' || COALESCE(ENDE.SIGEST, '') AS CIDADE_UF, 
                CAST(VIVO.NUMIPE AS CHAR(10)) AS NUMPED_SEPARACAO, CAST(NULL AS Timestamp) AS DATAPR, PED.DATENT,
                CAST(NULL AS VARCHAR(50)) AS SISTEMA_ORIGEM,
                CAST(NULL AS VARCHAR(50)) AS TIPO_ENTREGA,
                CAST(NULL AS VARCHAR(50)) AS SITUACAO_ECOMMERCE,
                CAST(NULL AS VARCHAR(1)) AS SISORI,
                CAST(NULL AS VARCHAR(1)) AS TIPENT,
                CAST('' AS VARCHAR(2)) CODIGO_SERIE,
                VIVO.TELEVE, VIVO.TIPPAG
  FROM TV_IVO VIVO  INNER JOIN TT_IPE IPE ON IPE.CODFIL = VIVO.FILIPE 
                                         AND IPE.NUMPED = VIVO.NUMIPE
                                         AND IPE.NUMITE = VIVO.ITEIPE
                    INNER JOIN TT_PED PED ON PED.CODFIL = IPE.CODFIL
                                         AND PED.NUMPED = IPE.NUMPED
                    LEFT JOIN TT_CLI CLI ON CLI.FILCLI = VIVO.FILIPE
                                        AND CLI.CODCLI = VIVO.CODCLI
                    LEFT JOIN TT_END ENDE ON CLI.FILCLI = ENDE.FILCLI -- MN - Deve trazer quem est separando os itens, no caso a filial que envia o produto 
                                         AND CLI.CODCLI = ENDE.CODCLI -- MN - Deve trazer '     0', pois  o fornecedor que envia o produto
                                         AND CLI.FILEND = ENDE.CODFIL
                                         AND CLI.NUMEND = ENDE.NUMEND
                    LEFT JOIN TT_USU USU ON USU.FILUSU = VIVO.FILVEN
                                        AND USU.CODUSU = VIVO.CODVEN
                    CROSS JOIN TT_CFG CFG
 WHERE VIVO.ORIGEM = 'P'
   AND VIVO.FLGEST <> 'C'
   AND VIVO.PED_FLGEST IN ('2', CASE WHEN CFG.PENAUT = 'T' THEN 'A' ELSE '2' END)
   AND LeParametroBoo('SEPARACAO_REPOSICAO', VIVO.FILIPE, '', '', '') = 'T'
   AND COALESCE(VIVO.FLGECO, 'P') <> '0'
  )TAB
 ORDER BY TAB.DATAPR, TAB.DATENT, TAB.DATHOR;


/*-- SEQ 2940 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ESAV CASCADE;

/*-- SEQ 2941 --*/
CREATE OR REPLACE VIEW TV_ESAV AS
SELECT SAV.NUMSEQ,
       SAV.VALSAD,
       SAV.DATINC,
       SAV.CODSAD,
       CLI.NUMDOC,
       CLI.ID_ORG,
       CLI.ID_EST,
       CLI.ID_DAT,
       CLI.NOMCLI,
       CLI.ULTNOM,
       CLI.DATNAS,
       CLI.CODSEX,
       CLI.ESTCIV,
       CAST(CLI.FILCLI || CLI.CODCLI AS VARCHAR(9)) AS CLI_CHAVECLI,
       CLI.CODEXT  AS CLI_CODEXT,
       ENDE.ENDERE,
       ENDE.NUMERO,
       ENDE.BAIRRO,
       ENDE.NOMCID,
       ENDE.CODCEP,
       ENDE.CODLOG,
       ENDE.SIGEST,
       IPR.CODEXT  AS GRA_CODEXT,
       IPR.CODFIS,
       IPR.DESMAT,
       IPR.ESPMAT,
       IPR.MARCA,
       IPR.REFPRO,
       VEN.CODFIL,
       VEN.CODSER,
       VEN.NUMNOT,
       IVE.NUMEXT,
       IVE.VLRORI,
       IVE.VLRMOV  AS IVE_VLRMOV,
       DSAD.CODTAB AS DSAD_CODTAB,
       DSAD.TIPVAL AS DSAD_TIPVAL,
       DSAD.VALIDA AS DSAD_VALIDA,
       DSAD.FLGPES AS DSAD_FLGPES,
       IPR.TIPVAL  AS GRA_TIPVAL,
       IPR.VALIDA  AS GRA_VALIDA,
       SAD.CODSEG  AS SAD_CODSEG,
       COALESCE(SAV.CODSEG, SAD.CODSEG)  AS CODSEG,
       CAST(CASE WHEN IVE.SITMOV = 'C' THEN 'C'
                 WHEN SAV.FLGEST IN ('C','D') THEN SAV.FLGEST -- Servio Cancelado ou Devoldido
                 ELSE 'N'                                     -- Servio Normal
            END AS CHAR(1)) AS SAV_FLGEST,
       CAST(CASE WHEN SAV.FLGEST IN ('C','D') THEN SAV.DATCAN -- Servio Cancelado ou Devolvido
                 ELSE NULL                                    -- Servio Normal
            END AS Timestamp) AS SAV_DATCAN,
       CASE WHEN SAV.FLGEST IN ('C','D') THEN SAV.VLRCAN
            ELSE NULL
       END AS SAV_VLRCAN,
       SAV.EXPORT  AS SAV_EXPORT,
       SAV.EXPCAN  AS SAV_EXPCAN,
       SAV.CODFIL  AS SAV_CODFIL,
       SAV.SEQUEN  AS SAV_SEQUEN,
       (SELECT REC.DATVEN
          FROM TT_REC REC
         WHERE REC.CODFIL = VEN.CODFIL
           AND REC.SEQUEN = VEN.SEQUEN
           AND REC.NUMPAR = ' 1'
           AND REC.SUBPAR = ' 0') AS DATVEN,
       SAV.NUMSER  AS SAV_NUMSER,
       VEN.OBSERV  AS VEN_OBSERV,
       SAV.OBSERV  AS SAV_OBSERV,
       SAV.CDIMEI  AS SAV_CDIMEI
  FROM TT_SAV SAV INNER JOIN TD_SAD DSAD ON SAV.CODSAD = DSAD.CODTAB
                  INNER JOIN TT_IOR IOR  ON IOR.CODFIL = SAV.FILPED
                                        AND IOR.TIPPED = SAV.TIPPED
                                        AND IOR.NUMPED = SAV.NUMPED
                                        AND IOR.NUMITE = SAV.NUMITE
                  INNER JOIN TT_IVE IVE  ON IVE.CODFIL = IOR.FILIVE
                                        AND IVE.SEQUEN = IOR.SEQIVE
                                        AND IVE.NUMITE = IOR.NUMIVE
                  INNER JOIN TT_VEN VEN  ON IVE.CODFIL = VEN.CODFIL
                                        AND IVE.SEQUEN = VEN.SEQUEN
                  INNER JOIN TV_IPR IPR  ON IVE.FILMAT = IPR.FILMAT
                                        AND IVE.CODMAT = IPR.CODMAT
                                        AND IVE.CODCOR = IPR.CODCOR
                                        AND IVE.CODTAM = IPR.CODTAM
                  INNER JOIN TT_CLI CLI  ON VEN.FILCLI = CLI.FILCLI
                                        AND VEN.CODCLI = CLI.CODCLI
                  INNER JOIN TT_END ENDE ON VEN.FILCLI = ENDE.FILCLI
                                        AND VEN.CODCLI = ENDE.CODCLI
                                        AND VEN.FILFAT = ENDE.CODFIL
                                        AND VEN.ENDFAT = ENDE.NUMEND
                  INNER JOIN TT_SAD SAD  ON SAV.FILSAD = SAD.CODFIL
                                        AND SAV.SEQSAD = SAD.SEQUEN
 ;


/*-- SEQ 2942 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_REGISTROSPAFECF_H2 CASCADE;

/*-- SEQ 2943 --*/
CREATE OR REPLACE VIEW TV_REGISTROSPAFECF_H2 AS
/* REGISTRO TIPO H2 - IDENTIFICAO DO TTULO, DO ADQUIRENTE, DO ECF E DA CREDENCIADORA */
SELECT TAB.CODFIL,
       TAB.NUMECF,
       TAB.DATOPE,
       TAB.DATFIS,
       
       TAB.CNPJ_CRED_CARTAO, -- 02       
       TAB.SERECF, -- 03
       TAB.ECFMFA, -- 04
       TAB.ECFTIP, -- 05
       TAB.MARECF, -- 06
       TAB.MODECF, -- 07
       
       TAB.CONCOO, -- 08
       TAB.CONCCF, -- 09
       TAB.VLRTRC, -- 10 
       TAB.DATTRC, -- 11
       
       TAB.CPF_ADQUIRENTE_DOADOR, -- 12
       TAB.TITULO_CAPITALIZACAO, -- 13
       TAB.CNPJ_ENTIDADE_RECEB_DOACAO, -- 14
       
       TAB.CLI_FILCLI,
       TAB.CLI_CODCLI,
       TAB.CLI_NOMCLI,
       TAB.CLI_NUMDOC,
       TAB.CLI_ULTNOM,
       TAB.CLI_ASSINA,
       UID_CLI.CODUID AS UID_CLI_CODUID,
       UID_CLI.USEROS AS UID_CLI_USEROS,
       UID_CLI.DATOPE AS UID_CLI_DATOPE,
       UID_CLI.NOMMAQ AS UID_CLI_NOMMAQ,
       UID_CLI.VERBAS AS UID_CLI_VERBAS,
       UID_CLI.VERSIS AS UID_CLI_VERSIS,
       UID_CLI.NOMSIS AS UID_CLI_NOMSIS,
       UID_CLI.SESSION_ID AS UID_CLI_SESSION_ID,
       UID_CLI.ASSINA AS UID_CLI_ASSINA,
       UID_CLI.CODEMP AS UID_CLI_CODEMP,
       
       TAB.DECF_FILECF,
       TAB.DECF_NUMECF,
       TAB.DECF_SERECF,
       TAB.DECF_ECFMFA,
       TAB.DECF_ECFTIP,
       TAB.DECF_MARECF,
       TAB.DECF_MODECF,
       TAB.DECF_VSWECF,
       TAB.DECF_DSWECF,
       TAB.DECF_CODORI,
       TAB.DECF_CODUID,
       TAB.DECF_ASSINA,
       UID_DECF.CODUID AS UID_DECF_CODUID,
       UID_DECF.USEROS AS UID_DECF_USEROS,
       UID_DECF.DATOPE AS UID_DECF_DATOPE,
       UID_DECF.NOMMAQ AS UID_DECF_NOMMAQ,
       UID_DECF.VERBAS AS UID_DECF_VERBAS,
       UID_DECF.VERSIS AS UID_DECF_VERSIS,
       UID_DECF.NOMSIS AS UID_DECF_NOMSIS,
       UID_DECF.SESSION_ID AS UID_DECF_SESSION_ID,
       UID_DECF.ASSINA AS UID_DECF_ASSINA,
       UID_DECF.CODEMP AS UID_DECF_CODEMP,
       
       TAB.OPE_CODFIL,
       TAB.OPE_NUMECF,
       TAB.OPE_TRN_ID,
       TAB.OPE_VLROPE,
       TAB.OPE_FILREC,
       TAB.OPE_SEQREC,
       TAB.OPE_FILCCC,
       TAB.OPE_SEQCCC,
       TAB.OPE_FILCHR,
       TAB.OPE_SEQCHR,
       TAB.OPE_FILFIN,
       TAB.OPE_SEQFIN,
       TAB.OPE_FILTEF,
       TAB.OPE_SEQTEF,
       TAB.OPE_CARTAO,
       TAB.OPE_OUTROS,
       TAB.OPE_CAMBIO,
       TAB.OPE_FILDOP,
       TAB.OPE_SEQDOP,
       TAB.OPE_DOCTRO,
       TAB.OPE_FILUSU,
       TAB.OPE_CODUSU,
       TAB.OPE_CODUID,
       TAB.OPE_ASSINA,
       UID_OPE.CODUID AS UID_OPE_CODUID,
       UID_OPE.USEROS AS UID_OPE_USEROS,
       UID_OPE.DATOPE AS UID_OPE_DATOPE,
       UID_OPE.NOMMAQ AS UID_OPE_NOMMAQ,
       UID_OPE.VERBAS AS UID_OPE_VERBAS,
       UID_OPE.VERSIS AS UID_OPE_VERSIS,
       UID_OPE.NOMSIS AS UID_OPE_NOMSIS,
       UID_OPE.SESSION_ID AS UID_OPE_SESSION_ID,
       UID_OPE.ASSINA AS UID_OPE_ASSINA,
       UID_OPE.CODEMP AS UID_OPE_CODEMP,
       
       TAB.LID_CODFIL,
       TAB.LID_NUMECF,
       TAB.LID_TRN_ID,
       TAB.LID_CONCCF,
       TAB.LID_CONCOO,
       TAB.LID_CONGNF,
       TAB.LID_CONCDC,
       TAB.LID_CONGRG,
       TAB.LID_TIPDOC,
       TAB.LID_DATHOR,
       TAB.LID_DATFIS,
       TAB.LID_CODUID,
       TAB.LID_ASSINA,
       UID_LID.CODUID AS UID_LID_CODUID,
       UID_LID.USEROS AS UID_LID_USEROS,
       UID_LID.DATOPE AS UID_LID_DATOPE,
       UID_LID.NOMMAQ AS UID_LID_NOMMAQ,
       UID_LID.VERBAS AS UID_LID_VERBAS,
       UID_LID.VERSIS AS UID_LID_VERSIS,
       UID_LID.NOMSIS AS UID_LID_NOMSIS,
       UID_LID.SESSION_ID AS UID_LID_SESSION_ID,
       UID_LID.ASSINA AS UID_LID_ASSINA,
       UID_LID.CODEMP AS UID_LID_CODEMP
  FROM (
SELECT OPE.CODFIL, 
       OPE.TRN_ID,
       OPE.DATOPE,
       LID.DATFIS,
       CLI.NUMDOC AS CNPJ_CRED_CARTAO, -- 02

       DECF.FILECF,
       DECF.NUMECF,
       DECF.SERECF, -- 03
       DECF.ECFMFA, -- 04
       DECF.ECFTIP, -- 05
       DECF.MARECF, -- 06
       DECF.MODECF, -- 07

       LID.CONCOO, -- 08
       LID.CONCCF, -- 09
       ABS(TRO.VLROPE) AS VLRTRC, -- 10 
       OPE.DATOPE AS DATTRC, -- 11
       
       CAST('' AS VARCHAR(14)) AS CPF_ADQUIRENTE_DOADOR, -- 12
       CAST('' AS VARCHAR(7)) AS TITULO_CAPITALIZACAO, -- 13
       CAST('' AS VARCHAR(14)) AS CNPJ_ENTIDADE_RECEB_DOACAO, -- 14
       
       -- Colunas utilizadas para validao da Assinatura das tabelas envolvidas
       CLI.FILCLI AS CLI_FILCLI,
       CLI.CODCLI AS CLI_CODCLI,
       CLI.NOMCLI AS CLI_NOMCLI,
       CLI.NUMDOC AS CLI_NUMDOC,
       CLI.ULTNOM AS CLI_ULTNOM,
       CLI.CODUID AS CLI_CODUID,
       CLI.ASSINA AS CLI_ASSINA,
       
       DECF.FILECF AS DECF_FILECF,
       DECF.NUMECF AS DECF_NUMECF,
       DECF.SERECF AS DECF_SERECF,
       DECF.ECFMFA AS DECF_ECFMFA,
       DECF.ECFTIP AS DECF_ECFTIP,
       DECF.MARECF AS DECF_MARECF,
       DECF.MODECF AS DECF_MODECF,
       DECF.VSWECF AS DECF_VSWECF,
       DECF.DSWECF AS DECF_DSWECF,
       DECF.CODORI AS DECF_CODORI,
       DECF.CODUID AS DECF_CODUID,
       DECF.ASSINA AS DECF_ASSINA,
       
       OPE.CODFIL AS OPE_CODFIL,
       OPE.NUMECF AS OPE_NUMECF,
       OPE.TRN_ID AS OPE_TRN_ID,
       OPE.VLROPE AS OPE_VLROPE,
       OPE.FILREC AS OPE_FILREC,
       OPE.SEQREC AS OPE_SEQREC,
       OPE.FILCCC AS OPE_FILCCC,
       OPE.SEQCCC AS OPE_SEQCCC,
       OPE.FILCHR AS OPE_FILCHR,
       OPE.SEQCHR AS OPE_SEQCHR,
       OPE.FILFIN AS OPE_FILFIN,
       OPE.SEQFIN AS OPE_SEQFIN,
       OPE.FILTEF AS OPE_FILTEF,
       OPE.SEQTEF AS OPE_SEQTEF,
       OPE.CARTAO AS OPE_CARTAO,
       OPE.OUTROS AS OPE_OUTROS,
       OPE.CAMBIO AS OPE_CAMBIO,
       OPE.FILDOP AS OPE_FILDOP,
       OPE.SEQDOP AS OPE_SEQDOP,
       OPE.DOCTRO AS OPE_DOCTRO,
       OPE.FILUSU AS OPE_FILUSU,
       OPE.CODUSU AS OPE_CODUSU,
       OPE.CODUID AS OPE_CODUID,
       OPE.ASSINA AS OPE_ASSINA,
       
       LID.CODFIL AS LID_CODFIL,
       LID.NUMECF AS LID_NUMECF,
       LID.TRN_ID AS LID_TRN_ID,
       LID.CONCCF AS LID_CONCCF,
       LID.CONCOO AS LID_CONCOO,
       LID.CONGNF AS LID_CONGNF,
       LID.CONCDC AS LID_CONCDC,
       LID.CONGRG AS LID_CONGRG,
       LID.TIPDOC AS LID_TIPDOC,
       LID.DATHOR AS LID_DATHOR,
       LID.DATFIS AS LID_DATFIS,
       LID.CODUID AS LID_CODUID,
       LID.ASSINA AS LID_ASSINA
  FROM TT_OPE OPE INNER JOIN TD_ECF DECF ON DECF.FILECF=OPE.CODFIL 
                                        AND DECF.NUMECF=OPE.NUMECF
                  INNER JOIN TT_LID LID ON OPE.CODFIL = LID.CODFIL
                                       AND OPE.NUMECF = LID.NUMECF
                                       AND OPE.TRN_ID = LID.TRN_ID
                  INNER JOIN TD_CAR DCAR ON DCAR.CODTAB = OPE.CARTAO
                  INNER JOIN TT_REL REL ON REL.FILPAR = DCAR.FILADM
                                       AND REL.CODPAR = DCAR.CODADM
                                       AND REL.TIPPAR = DCAR.TIPADM
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR
                                       AND CLI.CODCLI = REL.CODPAR
                  INNER JOIN TT_OPE TRO ON TRO.CODFIL = LID.CODFIL
                                       AND TRO.NUMECF = LID.NUMECF
                                       AND TRO.TRN_ID = LID.TRN_ID
                  LEFT JOIN TT_OPE DIN ON DIN.CODFIL = LID.CODFIL
                                       AND DIN.NUMECF = LID.NUMECF
                                       AND DIN.TRN_ID = LID.TRN_ID
                                       AND TRO.VLROPE > 0 
                                       AND DIN.CAMBIO='0'
 WHERE TRO.VLROPE < 0 
   AND TRO.MEIPGT = 'T'
   AND OPE.CARTAO IS NOT NULL
   AND DIN.CODFIL IS NULL
) TAB LEFT JOIN TT_UID UID_CLI ON UID_CLI.CODUID = TAB.CLI_CODUID
      LEFT JOIN TT_UID UID_DECF ON UID_DECF.CODUID = TAB.DECF_CODUID
      LEFT JOIN TT_UID UID_OPE ON UID_OPE.CODUID = TAB.OPE_CODUID
      LEFT JOIN TT_UID UID_LID ON UID_LID.CODUID = TAB.LID_CODUID
;


/*-- SEQ 2944 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_REGISTROSPAFECF_J1 CASCADE;

/*-- SEQ 2945 --*/
CREATE OR REPLACE VIEW TV_REGISTROSPAFECF_J1 AS
/* REGISTRO TIPO J1 - NOTA FISCAL EMITIDA PELO PAF E NOTA FISCAL EMITIDA MANUALMENTE */
SELECT TAB.CODFIL,
       TAB.SEQUEN,
       TAB.CGCFIL, -- 02
       TAB.DATOPE, -- 03
       TAB.DATFIS,
       TAB.SUBTOT, -- 04
       TAB.DESCON, -- 05
       TAB.TIPDES, -- 06
       TAB.ACRESC, -- 07
       TAB.TIPACR, -- 08
       TAB.VLRLIQ, -- 09
       TAB.INDCAN, -- 10
       TAB.CAN_AD, -- 11
       TAB.ORDDES, -- 12
       TAB.NOMCLI, -- 13
       TAB.NUMDOC, -- 14
       TAB.NUMNOT, -- 15
       TAB.CODSER, -- 16
       TAB.CHAVEA, -- 17
       TAB.TIPDOC, -- 18
       TAB.VEN_CODFIL,
       TAB.VEN_NUMECF,
       TAB.VEN_CODSER,
       TAB.VEN_NUMNOT,
       TAB.VEN_NOTMAN,
       TAB.VEN_CNT_RO,
       TAB.VEN_VLRLIQ,
       TAB.VEN_FLGEST,
       TAB.VEN_SEREXT,
       TAB.VEN_MODNOT,
       TAB.VEN_CHAVEA,
       TAB.VEN_FILUSU,
       TAB.VEN_CODUSU,
       TAB.VEN_VLRNOT,
       TAB.VEN_DOCNFP,
       TAB.VEN_DATHOR,
       TAB.VEN_CODUID,
       TAB.VEN_ASSINA,
       UID_VEN.CODUID AS UID_VEN_CODUID,
       UID_VEN.USEROS AS UID_VEN_USEROS,
       UID_VEN.DATOPE AS UID_VEN_DATOPE,
       UID_VEN.NOMMAQ AS UID_VEN_NOMMAQ,
       UID_VEN.VERBAS AS UID_VEN_VERBAS,
       UID_VEN.VERSIS AS UID_VEN_VERSIS,
       UID_VEN.NOMSIS AS UID_VEN_NOMSIS,
       UID_VEN.SESSION_ID AS UID_VEN_SESSION_ID,
       UID_VEN.ASSINA AS UID_VEN_ASSINA,
       UID_VEN.CODEMP AS UID_VEN_CODEMP,
       TAB.DFIL_CODFIL,
       TAB.DFIL_CGCFIL,
       TAB.DFIL_IE_FIL,
       TAB.DFIL_INSMUN,
       TAB.DFIL_RAZSOC,
       TAB.DFIL_DATEST,
       TAB.DFIL_CODUID,
       TAB.DFIL_ASSINA,
       UID_DFIL.CODUID AS UID_DFIL_CODUID,
       UID_DFIL.USEROS AS UID_DFIL_USEROS,
       UID_DFIL.DATOPE AS UID_DFIL_DATOPE,
       UID_DFIL.NOMMAQ AS UID_DFIL_NOMMAQ,
       UID_DFIL.VERBAS AS UID_DFIL_VERBAS,
       UID_DFIL.VERSIS AS UID_DFIL_VERSIS,
       UID_DFIL.NOMSIS AS UID_DFIL_NOMSIS,
       UID_DFIL.SESSION_ID AS UID_DFIL_SESSION_ID,
       UID_DFIL.ASSINA AS UID_DFIL_ASSINA,
       UID_DFIL.CODEMP AS UID_DFIL_CODEMP,
       TAB.CLI_FILCLI,
       TAB.CLI_CODCLI,
       TAB.CLI_NOMCLI,
       TAB.CLI_NUMDOC,
       TAB.CLI_ULTNOM,
       TAB.CLI_ASSINA,
       UID_CLI.CODUID AS UID_CLI_CODUID,
       UID_CLI.USEROS AS UID_CLI_USEROS,
       UID_CLI.DATOPE AS UID_CLI_DATOPE,
       UID_CLI.NOMMAQ AS UID_CLI_NOMMAQ,
       UID_CLI.VERBAS AS UID_CLI_VERBAS,
       UID_CLI.VERSIS AS UID_CLI_VERSIS,
       UID_CLI.NOMSIS AS UID_CLI_NOMSIS,
       UID_CLI.SESSION_ID AS UID_CLI_SESSION_ID,
       UID_CLI.ASSINA AS UID_CLI_ASSINA,
       UID_CLI.CODEMP AS UID_CLI_CODEMP
  FROM (
SELECT VEN.CODFIL,
       VEN.SEQUEN,
       DFIL.CGCFIL,
       VEN.DATHOR AS DATOPE,
       CASE WHEN VEN.CODSER='CF' THEN VEN.DATFIS ELSE TRUNC(VEN.DATHOR) END AS DATFIS,
       ABS(VEN.VLRNOT) AS SUBTOT,
       CASE WHEN ABS(VEN.VLRLIQ)-ABS(VEN.VLRNOT) < 0 THEN (ABS(VEN.VLRLIQ)-ABS(VEN.VLRNOT))*-1 ELSE 0 END AS DESCON,
       CAST('V' AS CHAR(1)) AS TIPDES,
       CASE WHEN ABS(VEN.VLRLIQ)-ABS(VEN.VLRNOT) > 0 THEN ABS(VEN.VLRLIQ)-ABS(VEN.VLRNOT) ELSE 0 END AS ACRESC,
       CAST('V' AS CHAR(1)) AS TIPACR,
       ABS(VEN.VLRLIQ) AS VLRLIQ,
       CAST(CASE WHEN VEN.FLGEST = 'C' THEN 'S' ELSE 'N' END AS CHAR(1)) AS INDCAN,
       CAST(0 AS Numeric) AS CAN_AD,
       CAST(CASE WHEN ABS(VEN.VLRLIQ)-ABS(VEN.VLRNOT) < 0 THEN 'D'
                 WHEN ABS(VEN.VLRLIQ)-ABS(VEN.VLRNOT) > 0 THEN 'A'
                 ELSE ' '
            END AS CHAR(1)) AS ORDDES,
       CAST(TRIM(CLI.NOMCLI)||' '||TRIM(COALESCE(CLI.ULTNOM,'')) AS VARCHAR(100)) AS NOMCLI,
       COALESCE(VEN.DOCNFP,CLI.NUMDOC) AS NUMDOC,
       CASE WHEN VEN.NOTMAN IS NOT NULL THEN VEN.NOTMAN
            ELSE VEN.NUMNOT
       END AS NUMNOT,
       CAST(CASE WHEN ISDIGIT(VEN.SEREXT) > 0
                           THEN TO_CHAR(TO_NUMBER(VEN.SEREXT))
                           ELSE VEN.SEREXT
            END AS VARCHAR(3)) AS CODSER,
       VEN.CHAVEA,
       CAST(CASE VEN.MODNOT WHEN '55' THEN '2' -- NF-e
                            WHEN '65' THEN '3' -- NFC-e
                 ELSE '1'           -- Nota Manual
            END AS CHAR(1)) AS TIPDOC,
       VEN.CODFIL AS VEN_CODFIL,
       VEN.NUMECF AS VEN_NUMECF,
       VEN.CODSER AS VEN_CODSER,
       VEN.NUMNOT AS VEN_NUMNOT,
       VEN.NOTMAN AS VEN_NOTMAN,
       VEN.CNT_RO AS VEN_CNT_RO,
       VEN.VLRLIQ AS VEN_VLRLIQ,
       VEN.FLGEST AS VEN_FLGEST,
       VEN.SEREXT AS VEN_SEREXT,
       VEN.MODNOT AS VEN_MODNOT,
       VEN.CHAVEA AS VEN_CHAVEA,
       VEN.FILUSU AS VEN_FILUSU,
       VEN.CODUSU AS VEN_CODUSU,
       VEN.VLRNOT AS VEN_VLRNOT,
       VEN.DOCNFP AS VEN_DOCNFP,
       VEN.DATHOR AS VEN_DATHOR,
       VEN.CODUID AS VEN_CODUID,
       VEN.ASSINA AS VEN_ASSINA,
       DFIL.CODFIL AS DFIL_CODFIL,
       DFIL.CGCFIL AS DFIL_CGCFIL,
       DFIL.IE_FIL AS DFIL_IE_FIL,
       DFIL.INSMUN AS DFIL_INSMUN,
       DFIL.RAZSOC AS DFIL_RAZSOC,
       DFIL.DATEST AS DFIL_DATEST,
       DFIL.CODUID AS DFIL_CODUID,
       DFIL.ASSINA AS DFIL_ASSINA,
       CLI.FILCLI AS CLI_FILCLI,
       CLI.CODCLI AS CLI_CODCLI,
       CLI.NOMCLI AS CLI_NOMCLI,
       CLI.NUMDOC AS CLI_NUMDOC,
       CLI.ULTNOM AS CLI_ULTNOM,
       CLI.CODUID AS CLI_CODUID,
       CLI.ASSINA AS CLI_ASSINA
  FROM TT_VEN VEN INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI
                                       AND CLI.CODCLI = VEN.CODCLI
                  INNER JOIN TD_FIL DFIL ON DFIL.CODFIL = VEN.CODFIL
                  INNER JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
 WHERE VEN.NUMNOT NOT LIKE '%#%'
   AND COALESCE(VEN.FUNRUR,0) = 0
   AND ((VEN.MODNOT IN ('55','65')) OR (DSER.SERMAN  = 'T') OR (VEN.NOTMAN IS NOT NULL)) -- NF-e, NFC-e ou Nota Manual
   AND 1 = CASE WHEN VEN.MODNOT = '55' -- NF-e
                THEN CASE WHEN (COALESCE(VEN.FLGNFE,'') IN ('1','3')) AND (VEN.CHAVEA IS NOT NULL) -- Autorizadas/Canceladas e com Chave de Acesso
                          THEN 1
                          ELSE 0
                     END
                WHEN VEN.MODNOT = '65' -- NFC-e
                THEN CASE WHEN VEN.CHAVEA IS NOT NULL -- Com Chave de Acesso
                          THEN 1
                          ELSE 0
                     END
                ELSE 1
           END
) TAB LEFT JOIN TT_UID UID_VEN ON UID_VEN.CODUID = TAB.VEN_CODUID
      LEFT JOIN TT_UID UID_DFIL ON UID_DFIL.CODUID = TAB.DFIL_CODUID
      LEFT JOIN TT_UID UID_CLI ON UID_CLI.CODUID = TAB.CLI_CODUID
;


/*-- SEQ 2946 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_REGISTROSPAFECF_J2 CASCADE;

/*-- SEQ 2947 --*/
CREATE OR REPLACE VIEW TV_REGISTROSPAFECF_J2 AS
/* REGISTRO TIPO J2  DETALHES DA NOTA FISCAL EMITIDA PELO PAF E NOTA FISCAL EMITIDA MANUALMENTE */
SELECT TAB.CODFIL,
       TAB.SEQUEN,
       TAB.CGCFIL, -- 02
       TAB.DATOPE, -- 03
       TAB.DATFIS,
       TAB.NUMITE, -- 04
       TAB.CODFIS, -- 05
       TAB.DESMAT, -- 06
       TAB.QTDMOV, -- 07
       TAB.MEDUNI, -- 08
       TAB.VLRORI, -- 09
       TAB.VLRDES, -- 10
       TAB.VLRACR, -- 11
       TAB.VLRMOV, -- 12
       TAB.TOTALI, -- 13
       TAB.DECQTD, -- 14
       TAB.DEC_VL, -- 15
       TAB.NUMNOT, -- 16
       TAB.CODSER, -- 17
       TAB.CHAVEA, -- 18
       TAB.TIPDOC, -- 19
       TAB.VEN_CODFIL,
       TAB.VEN_NUMECF,
       TAB.VEN_CODSER,
       TAB.VEN_NUMNOT,
       TAB.VEN_CNT_RO,
       TAB.VEN_VLRLIQ,
       TAB.VEN_FLGEST,
       TAB.VEN_SEREXT,
       TAB.VEN_MODNOT,
       TAB.VEN_CHAVEA,
       TAB.VEN_FILUSU,
       TAB.VEN_CODUSU,
       TAB.VEN_VLRNOT,
       TAB.VEN_DOCNFP,
       TAB.VEN_DATHOR,
       TAB.VEN_NOTMAN,
       TAB.VEN_CODUID,
       TAB.VEN_ASSINA,
       UID_VEN.CODUID AS UID_VEN_CODUID,
       UID_VEN.USEROS AS UID_VEN_USEROS,
       UID_VEN.DATOPE AS UID_VEN_DATOPE,
       UID_VEN.NOMMAQ AS UID_VEN_NOMMAQ,
       UID_VEN.VERBAS AS UID_VEN_VERBAS,
       UID_VEN.VERSIS AS UID_VEN_VERSIS,
       UID_VEN.NOMSIS AS UID_VEN_NOMSIS,
       UID_VEN.SESSION_ID AS UID_VEN_SESSION_ID,
       UID_VEN.ASSINA AS UID_VEN_ASSINA,
       UID_VEN.CODEMP AS UID_VEN_CODEMP,
       TAB.DFIL_CODFIL,
       TAB.DFIL_CGCFIL,
       TAB.DFIL_IE_FIL,
       TAB.DFIL_INSMUN,
       TAB.DFIL_RAZSOC,
       TAB.DFIL_DATEST,
       TAB.DFIL_CODUID,
       TAB.DFIL_ASSINA,
       UID_DFIL.CODUID AS UID_DFIL_CODUID,
       UID_DFIL.USEROS AS UID_DFIL_USEROS,
       UID_DFIL.DATOPE AS UID_DFIL_DATOPE,
       UID_DFIL.NOMMAQ AS UID_DFIL_NOMMAQ,
       UID_DFIL.VERBAS AS UID_DFIL_VERBAS,
       UID_DFIL.VERSIS AS UID_DFIL_VERSIS,
       UID_DFIL.NOMSIS AS UID_DFIL_NOMSIS,
       UID_DFIL.SESSION_ID AS UID_DFIL_SESSION_ID,
       UID_DFIL.ASSINA AS UID_DFIL_ASSINA,
       UID_DFIL.CODEMP AS UID_DFIL_CODEMP,
       TAB.IVE_VEN_DATHOR,
       TAB.IVE_NUMITE,
       TAB.IVE_FILMAT,
       TAB.IVE_CODMAT,
       TAB.IVE_CODCOR,
       TAB.IVE_CODTAM,
       TAB.IVE_QTDMOV,
       TAB.IVE_VLRORI,
       TAB.IVE_VLRMOV,
       TAB.IVE_TIPPRO,
       TAB.IVE_ICMTIP,
       TAB.IVE_TAX001,
       TAB.IVE_VLRDES,
       TAB.IVE_SITMOV,
       TAB.IVE_CODUID,
       TAB.IVE_ASSINA,
       UID_IVE.CODUID AS UID_IVE_CODUID,
       UID_IVE.USEROS AS UID_IVE_USEROS,
       UID_IVE.DATOPE AS UID_IVE_DATOPE,
       UID_IVE.NOMMAQ AS UID_IVE_NOMMAQ,
       UID_IVE.VERBAS AS UID_IVE_VERBAS,
       UID_IVE.VERSIS AS UID_IVE_VERSIS,
       UID_IVE.NOMSIS AS UID_IVE_NOMSIS,
       UID_IVE.SESSION_ID AS UID_IVE_SESSION_ID,
       UID_IVE.ASSINA AS UID_IVE_ASSINA,
       UID_IVE.CODEMP AS UID_IVE_CODEMP,
       TAB.PRO_FILMAT,
       TAB.PRO_CODMAT,
       TAB.PRO_DESMAT,
       TAB.PRO_ARRTRU,
       TAB.PRO_IIPTPR,
       TAB.PRO_TIPPRO,
       TAB.PRO_CODUID,
       TAB.PRO_ASSINA,
       UID_PRO.CODUID AS UID_PRO_CODUID,
       UID_PRO.USEROS AS UID_PRO_USEROS,
       UID_PRO.DATOPE AS UID_PRO_DATOPE,
       UID_PRO.NOMMAQ AS UID_PRO_NOMMAQ,
       UID_PRO.VERBAS AS UID_PRO_VERBAS,
       UID_PRO.VERSIS AS UID_PRO_VERSIS,
       UID_PRO.NOMSIS AS UID_PRO_NOMSIS,
       UID_PRO.SESSION_ID AS UID_PRO_SESSION_ID,
       UID_PRO.ASSINA AS UID_PRO_ASSINA,
       UID_PRO.CODEMP AS UID_PRO_CODEMP,
       TAB.GRA_FILMAT,
       TAB.GRA_CODMAT,
       TAB.GRA_CODCOR,
       TAB.GRA_CODTAM,
       TAB.GRA_REFPRO,
       TAB.GRA_CODFIS,
       TAB.GRA_CODUID,
       TAB.GRA_ASSINA,
       UID_GRA.CODUID AS UID_GRA_CODUID,
       UID_GRA.USEROS AS UID_GRA_USEROS,
       UID_GRA.DATOPE AS UID_GRA_DATOPE,
       UID_GRA.NOMMAQ AS UID_GRA_NOMMAQ,
       UID_GRA.VERBAS AS UID_GRA_VERBAS,
       UID_GRA.VERSIS AS UID_GRA_VERSIS,
       UID_GRA.NOMSIS AS UID_GRA_NOMSIS,
       UID_GRA.SESSION_ID AS UID_GRA_SESSION_ID,
       UID_GRA.ASSINA AS UID_GRA_ASSINA,
       UID_GRA.CODEMP AS UID_GRA_CODEMP,
       TAB.DMED_UNIMED,
       TAB.DMED_CODTAB,
       TAB.DMED_ASSINA,
       UID_DMED.CODUID AS UID_DMED_CODUID,
       UID_DMED.USEROS AS UID_DMED_USEROS,
       UID_DMED.DATOPE AS UID_DMED_DATOPE,
       UID_DMED.NOMMAQ AS UID_DMED_NOMMAQ,
       UID_DMED.VERBAS AS UID_DMED_VERBAS,
       UID_DMED.VERSIS AS UID_DMED_VERSIS,
       UID_DMED.NOMSIS AS UID_DMED_NOMSIS,
       UID_DMED.SESSION_ID AS UID_DMED_SESSION_ID,
       UID_DMED.ASSINA AS UID_DMED_ASSINA,
       UID_DMED.CODEMP AS UID_DMED_CODEMP
  FROM (
SELECT VEN.CODFIL,
       VEN.SEQUEN,
       DFIL.CGCFIL,
       VEN.DATHOR AS DATOPE,
       CASE WHEN VEN.CODSER='CF' THEN VEN.DATFIS ELSE TRUNC(VEN.DATHOR) END AS DATFIS,
       IVE.NUMITE,
       IPR.CODFIS,
       IPR.DESMAT,
       ABS(IVE.QTDMOV) AS QTDMOV,
       IPR.MEDUNI,
       ABS(IVE.VLRORI) AS VLRORI,
       CASE WHEN ((COALESCE(IVE.VLRDES,0) < 0) AND (IVE.VLRMOV > 0)) OR
                 ((COALESCE(IVE.VLRDES,0) > 0) AND (IVE.VLRMOV < 0))
            THEN IVE.VLRDES
            ELSE 0
       END AS VLRDES,
       CASE WHEN ((COALESCE(IVE.VLRDES,0) > 0) AND (IVE.VLRMOV > 0)) OR
                 ((COALESCE(IVE.VLRDES,0) < 0) AND (IVE.VLRMOV < 0))
            THEN IVE.VLRDES
            ELSE 0
       END AS VLRACR,
       ABS(IVE.VLRMOV) AS VLRMOV,
       CAST(CASE WHEN IVE.TIPPRO = '0' THEN -- material
                      CASE IVE.ICMTIP
                           WHEN '0' THEN '01T'||LPAD(to_char(TRUNC(COALESCE(IVE.TAX001,0)*100)),4,'0')
                           WHEN '1' THEN 'N1'
                           WHEN '2' THEN 'I1'
                           WHEN '4' THEN 'I1'
                           WHEN '3' THEN 'F1'
                           ELSE          ''
                      END
                 ELSE '01S'||LPAD(to_char(TRUNC(COALESCE(IVE.TAX001,0)*100)),4,'0') -- servico
            END AS VARCHAR(7)) AS TOTALI,
       CAST(4 AS Numeric) AS DECQTD,
       CAST(4 AS Numeric) AS DEC_VL,
       CASE WHEN VEN.NOTMAN IS NOT NULL THEN VEN.NOTMAN
            ELSE VEN.NUMNOT
       END AS NUMNOT,
       CAST(CASE WHEN ISDIGIT(VEN.SEREXT) > 0
                 THEN TO_CHAR(TO_NUMBER(VEN.SEREXT))
                 ELSE VEN.SEREXT
            END AS VARCHAR(3)) AS CODSER,
       VEN.CHAVEA,
       CAST(CASE VEN.MODNOT
                 WHEN '55' THEN '2' -- NF-e
                 WHEN '65' THEN '3' -- NFC-e
                 ELSE '1'           -- Nota Manual
            END AS CHAR(1)) AS TIPDOC,
       VEN.CODFIL AS VEN_CODFIL,
       VEN.NUMECF AS VEN_NUMECF,
       VEN.CODSER AS VEN_CODSER,
       VEN.NUMNOT AS VEN_NUMNOT,
       VEN.NOTMAN AS VEN_NOTMAN,
       VEN.CNT_RO AS VEN_CNT_RO,
       VEN.VLRLIQ AS VEN_VLRLIQ,
       VEN.FLGEST AS VEN_FLGEST,
       VEN.SEREXT AS VEN_SEREXT,
       VEN.MODNOT AS VEN_MODNOT,
       VEN.CHAVEA AS VEN_CHAVEA,
       VEN.FILUSU AS VEN_FILUSU,
       VEN.CODUSU AS VEN_CODUSU,
       VEN.VLRNOT AS VEN_VLRNOT,
       VEN.DOCNFP AS VEN_DOCNFP,
       VEN.DATHOR AS VEN_DATHOR,
       VEN.CODUID AS VEN_CODUID,
       VEN.ASSINA AS VEN_ASSINA,
       DFIL.CODFIL AS DFIL_CODFIL,
       DFIL.CGCFIL AS DFIL_CGCFIL,
       DFIL.IE_FIL AS DFIL_IE_FIL,
       DFIL.INSMUN AS DFIL_INSMUN,
       DFIL.RAZSOC AS DFIL_RAZSOC,
       DFIL.DATEST AS DFIL_DATEST,
       DFIL.CODUID AS DFIL_CODUID,
       DFIL.ASSINA AS DFIL_ASSINA,
       IVE.VEN_DATHOR AS IVE_VEN_DATHOR,
       IVE.NUMITE AS IVE_NUMITE,
       IVE.FILMAT AS IVE_FILMAT,
       IVE.CODMAT AS IVE_CODMAT,
       IVE.CODCOR AS IVE_CODCOR,
       IVE.CODTAM AS IVE_CODTAM,
       IVE.QTDMOV AS IVE_QTDMOV,
       IVE.VLRORI AS IVE_VLRORI,
       IVE.VLRMOV AS IVE_VLRMOV,
       IVE.TIPPRO AS IVE_TIPPRO,
       IVE.ICMTIP AS IVE_ICMTIP,
       IVE.TAX001 AS IVE_TAX001,
       IVE.VLRDES AS IVE_VLRDES,
       IVE.SITMOV AS IVE_SITMOV,
       IVE.CODUID AS IVE_CODUID,
       IVE.ASSINA AS IVE_ASSINA,
       IPR.FILMAT AS PRO_FILMAT,
       IPR.CODMAT AS PRO_CODMAT,
       IPR.DESMAT AS PRO_DESMAT,
       IPR.ARRTRU AS PRO_ARRTRU,
       IPR.IIPTPR AS PRO_IIPTPR,
       IPR.TIPPRO AS PRO_TIPPRO,
       IPR.PRO_CODUID AS PRO_CODUID,
       IPR.PRO_ASSINA AS PRO_ASSINA,
       IPR.FILMAT AS GRA_FILMAT,
       IPR.CODMAT AS GRA_CODMAT,
       IPR.CODCOR AS GRA_CODCOR,
       IPR.CODTAM AS GRA_CODTAM,
       IPR.REFPRO AS GRA_REFPRO,
       IPR.CODFIS AS GRA_CODFIS,
       IPR.GRA_CODUID AS GRA_CODUID,
       IPR.GRA_ASSINA AS GRA_ASSINA,
       DMED.UNIMED AS DMED_UNIMED,
       DMED.CODTAB AS DMED_CODTAB,
       DMED.CODUID AS DMED_CODUID,
       DMED.ASSINA AS DMED_ASSINA
  FROM TT_IVE IVE INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL
                                       AND VEN.SEQUEN = IVE.SEQUEN
                  INNER JOIN TV_IPR_FAST IPR ON IPR.FILMAT = IVE.FILMAT
                                            AND IPR.CODMAT = IVE.CODMAT
                                            AND IPR.CODCOR = IVE.CODCOR
                                            AND IPR.CODTAM = IVE.CODTAM
                  INNER JOIN TD_MED DMED ON DMED.CODTAB = IPR.UNIDAD
                  INNER JOIN TD_FIL DFIL ON DFIL.CODFIL = VEN.CODFIL
                  INNER JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
 WHERE VEN.NUMNOT NOT LIKE '%#%'
   AND COALESCE(VEN.FUNRUR,0) = 0
   AND ((VEN.MODNOT IN ('55','65')) OR (DSER.SERMAN  = 'T') OR (VEN.NOTMAN IS NOT NULL))
   AND 1 = CASE WHEN VEN.MODNOT = '55' -- NF-e
                THEN CASE WHEN (COALESCE(VEN.FLGNFE,'') IN ('1','3')) AND (VEN.CHAVEA IS NOT NULL) -- Autorizadas/Canceladas e com Chave de Acesso
                          THEN 1
                          ELSE 0
                     END
                WHEN VEN.MODNOT = '65' -- NFC-e
                THEN CASE WHEN VEN.CHAVEA IS NOT NULL -- Com Chave de Acesso
                          THEN 1
                          ELSE 0
                     END
                ELSE 1
           END
   AND IVE.SITKIT <> '1'
   AND IVE.SITMOV <> 'C'
) TAB LEFT JOIN TT_UID UID_VEN ON UID_VEN.CODUID = TAB.VEN_CODUID
      LEFT JOIN TT_UID UID_DFIL ON UID_DFIL.CODUID = TAB.DFIL_CODUID
      LEFT JOIN TT_UID UID_IVE ON UID_IVE.CODUID = TAB.IVE_CODUID
      LEFT JOIN TT_UID UID_PRO ON UID_PRO.CODUID = TAB.PRO_CODUID
      LEFT JOIN TT_UID UID_GRA ON UID_GRA.CODUID = TAB.GRA_CODUID
      LEFT JOIN TT_UID UID_DMED ON UID_DMED.CODUID = TAB.DMED_CODUID
;


/*-- SEQ 2948 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_REMESSA CASCADE;

/*-- SEQ 2949 --*/
CREATE OR REPLACE VIEW TV_REMESSA AS
-- Quando houver alterao na TV_REMESSA, tem que mexer nesse mtodo tambm TRemessaLoadQueryDAO.AbreQuery
-- View criada para Tela de Impresso de Simples Remessa no Commerce Web
   SELECT DISTINCT TAB.SEQUEN, TAB.CODFIL, TAB.CODSER, TAB.NUMECF, TAB.NUMNOT,                                                                             
                          TAB.FILCLI, TAB.CODCLI, TAB.DATHOR FROM (                                                                                                                                  
                     SELECT VEN.SEQUEN, VEN.CODFIL, VEN.CODSER, VEN.NUMECF, VEN.NUMNOT,                                                                             
                            VEN.FILCLI, VEN.CODCLI, VEN.DATHOR, IOR.TIPENT,                                                                                                                 
                            CASE WHEN IVO.FILVOL IS NULL THEN                                                                                           
                               CASE WHEN IVE.EMBORI IS NULL THEN COALESCE(QTDPENDENTE(IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE, IVE.QTDMOV),0)                
                                                            ELSE (IVE.EMBQTD *                                                                          
                                                                  COALESCE(QTDPENDENTE(IVE.CODFIL, IVE.SEQUEN, IVE.NUMITE, IVE.QTDMOV),0))/IVE.QTDMOV   
                                                            END                                                                                         
                               ELSE CASE WHEN IVE.EMBORI IS NULL THEN IVO.CONTEM                                                                        
                                                                 ELSE (IVE.EMBQTD*IVO.CONTEM)/IVE.QTDMOV                                                
                                                                 END                                                                                    
                            END AS QTDPEN                                                                                                               
                       FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL                                                                 
                                                            AND IVE.SEQUEN = VEN.SEQUEN                                                                 
                                       INNER JOIN TD_NAT NAT ON NAT.CODTAB = VEN.CODNAT                                                                 
                                       INNER JOIN TT_PRO PRO ON PRO.FILMAT=IVE.FILMAT AND PRO.CODMAT=IVE.CODMAT                                         
                                       INNER JOIN TT_IOR IOR ON IOR.FILIVE = IVE.CODFIL                                                                 
                                                            AND IOR.SEQIVE = IVE.SEQUEN                                                                 
                                                            AND IOR.NUMIVE = IVE.NUMITE                                                                 
                                        LEFT JOIN TT_IVO IVO ON  IVO.FILIVE = IVE.CODFIL                                                                
                                                            AND IVO.SEQIVE = IVE.SEQUEN                                                                 
                                                            AND IVO.NUMIVE = IVE.NUMITE                                                                 
                            WHERE NAT.TIPNAT = 'F'                                                                                                                                                                                                   
                              AND IVE.SITKIT <> '1'                                                                                                   
                              AND IVE.SITMOV <> 'C'                                                                                                   
                              -- No usa IVO, ou a IVO j foi separada (FILIMP)                                                                    
                              AND (IVO.FILVOL IS NULL OR (COALESCE(IVO.CONTEM, 0) > 0  AND COALESCE(IVO.FLGEST, 'X') = 'P' AND IVO.FILIMP IS NULL)) 
                              AND IOR.TIPENT <> '0'                                                                                                   
                     UNION ALL
                   SELECT VEN.SEQUEN, VEN.CODFIL, VEN.CODSER, VEN.NUMECF, VEN.NUMNOT,                                                                             
                          VEN.FILCLI, VEN.CODCLI, VEN.DATHOR, IOR.TIPENT,                                                                   
                          -- Se a nota de remessa para cliente leva ainda no foi emitida                                                          
                          --    a quantidade pendente  a quantidade total do item                                                                    
                          IVE.QTDMOV AS QTDPEN                                                                                                          
                     FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON IVE.CODFIL = VEN.CODFIL                                                                   
                                                          AND IVE.SEQUEN = VEN.SEQUEN                                                                   
                                     INNER JOIN TT_IOR IOR ON IOR.FILIVE = IVE.CODFIL                                                                   
                                                          AND IOR.SEQIVE = IVE.SEQUEN                                                                   
                                                          AND IOR.NUMIVE = IVE.NUMITE                                                                                                                             
                    WHERE 1 = 1                                                                                                                         
                      AND VEN.FLGEST <> 'C'                                                                                                           
                      AND IVE.SITMOV <> 'C'                                                                                                           
                      AND IVE.QTDPEN > 0                                                                                                                
                      AND IOR.TIPENT = '0'                                                                                                            
                      AND NOT EXISTS (SELECT 'OK'                                                                                                     
                                        FROM TT_IVE IVE_REM                                                                                             
                                       WHERE IVE_REM.FILORI = IVE.CODFIL                                                                                
                                         AND IVE_REM.NUMORI = IVE.SEQUEN                                                                                
                                         AND IVE_REM.ITEORI = IVE.NUMITE                                                                                
                                         AND IVE_REM.SITMOV <> 'C'                                                                                    
                                     )                                                                                                                  
                  ) TAB                                                                                                                                 
WHERE TAB.QTDPEN > 0;


-- Autor: Luciano Chiqueti 
-- Cliente(s): JRA
 
-- Finalidade(s):
-- 1) Viu para ser utilizada em relatrios para ver as mesmas entradas do SPED
/*-- SEQ 2950 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_SPED_ENTRADA CASCADE;

/*-- SEQ 2951 --*/
CREATE OR REPLACE VIEW TV_SPED_ENTRADA AS
SELECT
   CAST(CASE WHEN ITE_CODCST IS NULL
        THEN TRI_CODTRI
        ELSE CASE WHEN SUBSTR(ITE_CODCST,2,2) IN ('10','30','60','70') THEN SUBSTR(ITE_CODCST,1,1) || '60'
             ELSE ITE_CODCST END
   END AS VARCHAR(5)) AS SPE_CODCST,
   CAST(CASE WHEN ITE_CODNAT IS NULL THEN SUBSTR(DOC_CODNAT,1,4)
        ELSE SUBSTR(ITE_CODNAT,1,4) END AS VARCHAR(10)) AS CODNAT,
   ROUND(ICO_VLRMOV /DOC_VLRTOT * (DOC_VLRLIQ - DOC_VLRSEG - DOC_OUTTAX - DOC_VLRFRE -
                                   DOC_VLRTOT - COM_SUBSTT - DOC_VLRIPI_DEVOLVIDO), 4) AS SPE_DESRATNOTA,
   CASE WHEN COALESCE(ITE_VLRMOV,0) = 0 THEN DOC_VLRLIQ
        ELSE (ITE_VLRMOV+ITE_DESRAT+ITE_VLR_ST+ITE_VLRIPI+ITE_VLRFRE) 
   END SPE_VLROPE,
   CASE WHEN SUBSTR(ITE_CODCST,2,2) IN ('10','30','60','70') THEN 0
        ELSE ITE_TAXICM
   END AS SPE_TAXICM,
   CASE WHEN SUBSTR(ITE_CODCST,2,2) IN ('10','30','60','70') THEN 0
             ELSE ITE_BASICM
   END AS SPE_BASICM, 
   CASE WHEN SUBSTR(ITE_CODCST,2,2) IN ('10','30','60','70') THEN 0
        ELSE ITE_VLRICM
   END  AS SPE_VLRICM,
   CASE WHEN SUBSTR(ITE_CODCST,2,2) IN ('10','30','60','70') THEN 0
        ELSE ITE_BASSUB
   END AS SPE_BASSUB,
   CASE WHEN SUBSTR(ITE_CODCST,2,2) IN ('10','30','60','70') THEN 0
        ELSE ITE_VLR_ST
   END AS SPE_VLRSUB,
   CAST(DOC_CODIGO AS VARCHAR(30)) AS DOC_CODIGO,
   DOC_CODFIL,
   DOC_SEQUEN,
   DOC_NUMNOT,
   DOC_DATDOC,
   DOC_DATOPE,
   CAST(DOC_DOCNFP AS VARCHAR(30)) AS DOC_DOCNFP,
   CAST(CTADOC_CODEXT AS VARCHAR(30)) AS CTADOC_CODEXT,
   DOC_VLRLIQ,
   DOC_DESCON,
   DOC_VLRTOT,
   CAST(DOC_FLGEST AS VARCHAR(10)) AS DOC_FLGEST,
   DOC_BASICM,
   DOC_VLRICM,
   COM_VLRFRE,
   DOC_ISEICM,
   DOC_VLRIPI,
   CAST(DOC_CHAVEA AS VARCHAR(50)) AS DOC_CHAVEA, 
   DOC_VLRFRE,
   DOC_VLRSEG,
   DOC_OUTTAX,
   DOC_VLRPIS,
   DOC_VLRCOF,
   DOC_BASSUB,
   DOC_SUBSTT,
   COM_SUBSTT,
   DOC_TIPNOT,
   CAST(DOC_OBSFIS AS VARCHAR(250)) AS DOC_OBSFIS,
   DOC_PERICM,
   COM_PERFRE,
   COM_CODFCE,
   DOC_TIPFRE,
   COM_TIPPAR,
   DOC_BASISS,
   DOC_VLRISS,
   DOC_PERISS,
   DOC_BASIRR,
   DOC_VLRIRR,
   DOC_PERIRR,
   COM_BASFRE,
   COM_ICMFRE,
   DOC_FILORI,
   DOC_SEQORI,
   DOC_BSTFRE,
   DOC_ST_FRE,
   DOC_CODFPS,
   DOC_SITPIS,
   DOC_SITCOF,
   COM_NATFRE,
   DOC_VLRPIS_RET,
   DOC_VLRCOF_RET,
   CAST(DOC_FLGNFE AS VARCHAR(10)) AS DOC_FLGNFE,
   CAST(FIS_MODNOT AS VARCHAR(2)) AS FIS_MODNOT,
   CAST(FIS_CODSER AS VARCHAR(5)) AS FIS_CODSER,
   CAST(FIS_SUBSER AS VARCHAR(5)) AS FIS_SUBSER,
   CAST(ITE_CODIGO AS VARCHAR(30)) AS ITE_CODIGO,
   CAST(ITE_NATFIS AS VARCHAR(10)) AS ITE_NATFIS,
   CAST(ITE_CODCST AS VARCHAR(5)) AS ITE_CODCST,
   ITE_CODORI,
   ITE_CODFIL,
   ITE_NUMITE,
   ITE_QTDMOV,
   ITE_EMBQTD,
   ITE_VLRDES,
   ITE_VLRMOV,
   ITE_TIPPRO,
   ITE_ICMTIP,
   ITE_REDITE,
   ITE_BASICM,
   ITE_VLRICM,
   ITE_CALSUB,
   ITE_RATEIO_PROMOCAO,
   ITE_TAXICM,
   ITE_VLRIPI,
   ITE_ISEICM,
   ITE_LANEST,
   ITE_VLRPIS,
   ITE_VLRCOF,
   ITE_BASIPI,
   ITE_TAXIPI,
   ITE_SITPIS,
   ITE_BASPIS,
   ITE_PERPIS,
   ITE_SITCOF,
   ITE_BASCOF,
   ITE_PERCOF,
   ITE_BASSUB,
   ITE_VLR_ST,
   ITE_ICMVEN,
   ITE_RED_ST,
   ITE_SITMOV,
   ITE_IPIFRE,
   ITE_VLRFRE,
   ITE_VLRUNI,
   ICO_VLRMOV,
   CAST(ICO_VALCON AS VARCHAR(5)) AS ICO_VALCON,
   ITE_SITIPI,
   ICO_VLRITE,
   PRO_CODIGO,
   PRO_REFPRO,
   PRO_REFBAS,
   CAST(PRO_NOMPRO AS VARCHAR(120)) AS PRO_NOMPRO,
   CAST(PRO_CODEAN AS VARCHAR(30)) AS PRO_CODEAN,
   PRO_CODFPS,
   PRO_CODNCM,
   PRO_COD_EX,
   CAST(PRO_GENNCM AS VARCHAR(5)) AS PRO_GENNCM,
   PRO_CODSRV,
   PRO_PERICM,
   PRO_CODANP,
   PRO_CODEXT,
   CAST(PRO_NATBCC AS VARCHAR(5)) AS PRO_NATBCC,
   PRO_IIPTPR,
   MED_CODTAB,
   MED_MEDATI,
   MED_UNIMED,
   MED_DESMED,
   ICO_UNICOM,
   ICO_UNIVEN,
   ICO_QTDCOM,
   MEDFAT_MEDATI,
   MEDFAT_DESMED,
   CAST(MEDFAT_UNIMED AS VARCHAR(5)) AS MEDFAT_UNIMED,
   CAST(PAR_CODIGO AS VARCHAR(20)) AS PAR_CODIGO,
   PAR_FILCLI,
   PAR_CODCLI,
   PAR_NOMCLI,
   PAR_CODPAI,
   PAR_NUMDOC,
   PAR_INSEST,
   PAR_SUFRAM,
   PAR_FLGTIP,
   MUN_CODIBG,
   MUN_SIGEST,
   CAST(ENC_ENDERE AS VARCHAR(80)) AS ENC_ENDERE,
   CAST(ENC_ENDERE_ESTRAN AS VARCHAR(80)) AS ENC_ENDERE_ESTRAN,
   ENC_NUMERO,
   CAST(ENC_COMPLE AS VARCHAR(80)) AS ENC_COMPLE,
   ENC_BAIRRO,
   ENC_CODPAI,
   ENC_SIGEST,
   ENC_NUMDOC,
   ENC_INSMUN,
   ENC_INSEST,
   CAST(ENC_CODIGO AS VARCHAR(50)) AS ENC_CODIGO,
   SUBORI_FATCON,
   MEDEMB_CODTAB,
   MEDEMB_MEDATI,
   CAST(MEDEMB_UNIMED AS VARCHAR(10)) AS MEDEMB_UNIMED,
   MEDEMB_DESMED,
   TRI_CODTRI,
   SUBSTR(DOC_CODNAT,1,4) AS DOC_CODNAT,
   DOC_DESNAT,
   SUBSTR(ITE_CODNAT,1,4) AS ITE_CODNAT,
   ITE_DESNAT,
   CFG_VC_FILCLI,
   CFG_VC_CODCLI,
   TRA_FILITE,
   ITE_VLRLIQ,
   ITE_DESRAT,
   ITE_ACR_ORIGINAL,
   DOC_VLRIPI_DEVOLVIDO,
   CAST(PAR_SIMPLE AS VARCHAR(1)) AS  PAR_SIMPLE,
   FIL_PERPIS,
   FIL_PERCOF,
   FIL_TIPLUC,
   FIL_REGTRI,
   ITE_VALOR_FCP,
   ITE_VALOR_PARTILHA_DESTINO,
   ITE_VALOR_PARTILHA_REMETENTE,
   ITE_OUTTAX,
   DOC_NATBCC,
   DOC_CODDAR,
   DOC_FINNFE,
   PAR_REGESP,
   CAST(NAT_TIPNAT AS VARCHAR(10)) AS NAT_TIPNAT,
   CAST(DOC_ITENS_PROMOCAO AS VARCHAR(1)) AS DOC_ITENS_PROMOCAO,
   PRO_CODCES,
   DOC_MUN_DESTINO
  FROM (
SELECT 'R'||COM.CODFIL||LPAD(TRIM(COM.SEQUEN),10,'0') AS DOC_CODIGO,
       COM.CODFIL AS DOC_CODFIL,
       COM.SEQUEN AS DOC_SEQUEN,
       COM.NUMNOT AS DOC_NUMNOT,
       CASE WHEN COM.DATCMP > COM.DATOPE THEN COM.DATOPE ELSE COM.DATCMP END AS DOC_DATDOC,
       COM.DATOPE AS DOC_DATOPE,
       NULL AS DOC_DOCNFP,
       NULL AS CTADOC_CODEXT,
       COM.VLRLIQ + COALESCE(COM.VLRBON,0) AS DOC_VLRLIQ,
       COM.DESCON AS DOC_DESCON,
       COM.VLRTOT AS DOC_VLRTOT,
       '00' AS DOC_FLGEST,
       CASE WHEN ICO.RETSUB = 'T' THEN 0 ELSE COM.BASICM END AS DOC_BASICM,
       CASE WHEN ICO.RETSUB = 'T' THEN 0 ELSE COM.VLRICM END AS DOC_VLRICM,
       COM.VLRFRE AS COM_VLRFRE,
       COM.ISEICM AS DOC_ISEICM,
       COM.VLRIPI AS DOC_VLRIPI,
       CASE WHEN COM.CHAVEA IS NOT NULL
             AND LENGTH(COM.CHAVEA) = 44
            THEN COM.CHAVEA
            ELSE NULL  
        END AS DOC_CHAVEA,
       COM.VLRFRE AS DOC_VLRFRE,
       0          AS DOC_VLRSEG,
       COM.OUTTAX AS DOC_OUTTAX,
       COM.VLRPIS AS DOC_VLRPIS,
       COM.VLRCOF AS DOC_VLRCOF,
       (SELECT SUM(ICO2.BASSUBDIF)
          FROM TT_ICO ICO2
         WHERE ICO2.CODFIL = COM.CODFIL
           AND ICO2.SEQUEN = COM.SEQUEN) AS DOC_BASSUB,
       (SELECT SUM(ICO3.VLR_STDIF)
          FROM TT_ICO ICO3
         WHERE ICO3.CODFIL = COM.CODFIL
           AND ICO3.SEQUEN = COM.SEQUEN) AS DOC_SUBSTT,
       COM.SUBSTT AS COM_SUBSTT,
       COM.TIPNOT AS DOC_TIPNOT,
       TRANSLATE(RTF2TXT(REPLACE(REPLACE(COALESCE(COM.OBSFAT,COM.OBSERV),CHR(13),''),CHR(10),'')),'',' ') AS DOC_OBSFIS,
       COM.PERICM AS DOC_PERICM,
       COM.PERFRE AS COM_PERFRE,
       COM.CODFCE AS COM_CODFCE,
       COM.TIPFRE AS DOC_TIPFRE,
       COM.TIPPAR AS COM_TIPPAR,
       0          AS DOC_BASISS,
       COM.VLRISS AS DOC_VLRISS,
       COM.PERISS AS DOC_PERISS,
       0          AS DOC_BASIRR,
       COM.VLRIRR AS DOC_VLRIRR,
       COM.PERIRR AS DOC_PERIRR,
       COM.BASFRE AS COM_BASFRE,
       COM.ICMFRE AS COM_ICMFRE,
       COM.CODFIL AS DOC_FILORI,
       COM.SEQFAT AS DOC_SEQORI,
       COALESCE(COM.BSTFRE,0) AS DOC_BSTFRE,
       COALESCE(COM.ST_FRE,0) AS DOC_ST_FRE,
       COM.CODFPS AS DOC_CODFPS,
       COM.SITPIS AS DOC_SITPIS,
       COM.SITCOF AS DOC_SITCOF,
       COM.NATFRE AS COM_NATFRE,
       0          AS DOC_VLRPIS_RET,
       0          AS DOC_VLRCOF_RET,
       NULL       AS DOC_FLGNFE,
       CASE WHEN FIS.MODNOT = '57' AND COM.CHAVEA IS NOT NULL THEN '57'
            WHEN FIS.MODNOT <> '55' AND COM.CHAVEA IS NOT NULL THEN '55' ELSE FIS.MODNOT END AS FIS_MODNOT, 
       TRIM(FIS.SEREXP) AS FIS_CODSER,
       TRIM(FIS.SUBEXP) AS FIS_SUBSER,
       'R'||ICO.CODFIL||LPAD(TRIM(ICO.SEQUEN),10,'0')||LPAD(TO_CHAR(ICO.NUMITE),5,'0') AS ITE_CODIGO,     
       NULL AS ITE_NATFIS,
   CASE WHEN ICO.RETSUB = 'T' THEN
        CASE WHEN FIL.REGTRI = 'S' THEN
             COALESCE(ICO.CODORI, 0)||'500'
        ELSE
           COALESCE(ICO.CODORI, 0)||'60'
        END
   ELSE
     CASE WHEN LENGTH(TRIM(ICO.CODCSTDIF)) = 2 THEN
          COALESCE(ICO.CODORI, 0)||ICO.CODCSTDIF
     ELSE
          ICO.CODCSTDIF
     END
   END AS ITE_CODCST,
       ICO.CODORI AS ITE_CODORI,
       ICO.CODFIL AS ITE_CODFIL,
       ICO.NUMITE AS ITE_NUMITE,
       ICO.QTDMOV AS ITE_QTDMOV,
       COALESCE(ICO.EMBQTD, ICO.QTDMOV) AS ITE_EMBQTD,
       ICO.VLRDES AS ITE_VLRDES,
       ICO.VLRMOV AS ITE_VLRMOV,
       ICO.TIPPRO AS ITE_TIPPRO,
       ICO.ICMTIP AS ITE_ICMTIP,
       CASE WHEN ICO.RETSUB = 'T' THEN 0 ELSE ICO.REDITEDIF END AS ITE_REDITE,
       CASE WHEN ICO.RETSUB = 'T' THEN 0 ELSE ICO.BASICMDIF END AS ITE_BASICM,
       CASE WHEN ICO.RETSUB = 'T' THEN 0 ELSE ICO.VLRICMDIF END AS ITE_VLRICM,
       0             AS ITE_CALSUB,
       0             AS ITE_RATEIO_PROMOCAO,
       CASE WHEN ICO.RETSUB = 'T' THEN 0 ELSE ICO.ICMITEDIF END AS ITE_TAXICM,
       ICO.VLRIPI    AS ITE_VLRIPI,
       ICO.ISEICM AS ITE_ISEICM,
       ICO.LANEST AS ITE_LANEST,
       ICO.VLRPIS AS ITE_VLRPIS,
       ICO.VLRCOF AS ITE_VLRCOF,
       CASE COALESCE(ICO.IPIITE,0) WHEN 0 THEN
            0 ELSE ICO.BASIPI END AS ITE_BASIPI,
       ICO.IPIITE AS ITE_TAXIPI,
       ICO.SITPIS AS ITE_SITPIS,
       ICO.BASPIS AS ITE_BASPIS,
       ICO.PERPIS AS ITE_PERPIS,
       ICO.SITCOF AS ITE_SITCOF,
       ICO.BASCOF AS ITE_BASCOF,
       ICO.PERCOF AS ITE_PERCOF,
       ICO.BASSUBDIF AS ITE_BASSUB,
       ICO.VLR_STDIF AS ITE_VLR_ST,
       ICO.ICMVENDIF AS ITE_ICMVEN,
       ICO.RED_STDIF AS ITE_RED_ST,
       ICO.SITMOV AS ITE_SITMOV,
       ICO.IPIFRE AS ITE_IPIFRE,
       ICO.ICO_VLRFRE AS ITE_VLRFRE,
       ICO.VLRMOV/NVLZ(ICO.QTDMOV,1) AS ITE_VLRUNI,
       ICO.VLRMOV AS ICO_VLRMOV,
       ICO.VALCON AS ICO_VALCON,
       COALESCE(ICO.SITIPI, '03') AS ITE_SITIPI,
       NVLZ(ICO.VLRITE, ICO.VLRMOV) AS ICO_VLRITE,
       IPR.CODFIS AS PRO_CODIGO,              
       IPR.REFPRO AS PRO_REFPRO,
       IPR.REFBAS AS PRO_REFBAS,
       NOMEPRODUTO(IPR.DESECF, IPR.DESMAT, IPR.CODCOR, IPR.ITEDIV,
                   IPR.CODTAM, IPR.ITESUB, IPR.ESPMAT, IPR.DESGRA) AS PRO_NOMPRO,
       CASE WHEN ISDIGIT(IPR.REFPRO) = 1 THEN
                 CASE WHEN (LENGTH(IPR.REFPRO) = 8)  AND (EAN8(IPR.REFPRO) = IPR.REFPRO) THEN IPR.REFPRO
                      WHEN (LENGTH(IPR.REFPRO) = 13) AND (EAN(IPR.REFPRO) = IPR.REFPRO)  THEN IPR.REFPRO
                      ELSE NULL
                 END 
            ELSE NULL
       END AS PRO_CODEAN,
       IPR.CODFPS AS PRO_CODFPS,
       IPR.CODNCM AS PRO_CODNCM,
       IPR.COD_EX AS PRO_COD_EX,
       SUBSTR(IPR.CODNCM,1,2) AS PRO_GENNCM,
       CAST(TRIM(REPLACE(TO_CHAR(IPR.CODSRV,'00G00'),',','.')) AS VARCHAR(5)) AS PRO_CODSRV,
       ICM.RESICM AS PRO_PERICM,
       IPR.CODANP AS PRO_CODANP,
       IPR.CODEXT AS PRO_CODEXT,
       CASE WHEN CLI.FLGTIP = 0 THEN NULL
            ELSE COALESCE(ICO.NATBCC, COM.NATBCC)
       END AS PRO_NATBCC,
       IPR.IIPTPR AS PRO_IIPTPR,
       MED.CODTAB AS MED_CODTAB,
       MED.MEDATI AS MED_MEDATI,
       MED.UNIMED AS MED_UNIMED,
       MED.DESMED AS MED_DESMED,
       ICO.UNICOM AS ICO_UNICOM,
       ICO.UNIVEN AS ICO_UNIVEN,
       ICO.QTDCOM AS ICO_QTDCOM,
       MEDFAT.MEDATI AS MEDFAT_MEDATI,
       MEDFAT.DESMED AS MEDFAT_DESMED,
       CASE WHEN ICO.VALCON = 1 THEN
         MEDFAT.UNIMED
       ELSE
         CASE WHEN (ICO.VALCON - TRUNC(ICO.VALCON) > 0) THEN
           MEDFAT.UNIMED||SUBSTR(TO_CHAR(ICO.VALCON, 'FM9999999990D9999'),1,4)
         ELSE
           MEDFAT.UNIMED||SUBSTR(REPLACE(TO_CHAR(ICO.VALCON, 'FM9999999990D9999'),'.',''),1,4)
         END
       END AS MEDFAT_UNIMED,
       CLI.FILCLI||LPAD(TRIM(CLI.CODCLI),6,'0') AS PAR_CODIGO,
       CLI.FILCLI AS PAR_FILCLI,
       CLI.CODCLI AS PAR_CODCLI,
       CLI.NOMCLI AS PAR_NOMCLI,
       CLI.CODPAI AS PAR_CODPAI,
       COALESCE(CLI.NUMDOC, VIN.NUMDOC) AS PAR_NUMDOC,
       CASE WHEN CLI.TIPDOC='IE' THEN CLI.INSEST END AS PAR_INSEST,
       CLI.SUFRAM AS PAR_SUFRAM,
       CLI.FLGTIP AS PAR_FLGTIP,
       COALESCE(COM.CODIBG, ENDE.CODIBG, MUN.CODIBG) AS MUN_CODIBG,
       MUN.SIGEST AS MUN_SIGEST,
       REPLACE(ENDE.ENDERE,'|','-') AS ENC_ENDERE,
       (REPLACE(ENDE.ENDERE,'|','-')||', '||ENDE.NOMCID||', '||DPAI.DESPAI) AS ENC_ENDERE_ESTRAN, 
       ENDE.NUMERO AS ENC_NUMERO,
       REPLACE(ENDE.COMPLE,'|','-') AS ENC_COMPLE,
       ENDE.BAIRRO AS ENC_BAIRRO,
       ENDE.CODPAI AS ENC_CODPAI,
       ENDE.SIGEST AS ENC_SIGEST,
       ENDE.NUMDOC AS ENC_NUMDOC,
       ENDE.INSMUN AS ENC_INSMUN,
       CASE WHEN CLI.TIPDOC='IE' THEN ENDE.INSEST END AS ENC_INSEST,
       CLI.FILCLI||LPAD(TRIM(CLI.CODCLI),6,'0')||ENDE.CODFIL||LPAD(TO_CHAR(ENDE.NUMEND),4,'0') AS ENC_CODIGO,
       SUBORI.FATCON AS SUBORI_FATCON,
       MEDEMB.CODTAB AS MEDEMB_CODTAB,
       MEDEMB.MEDATI AS MEDEMB_MEDATI,
       CASE WHEN ICO.VALCON = 1 THEN
         MEDEMB.UNIMED
       ELSE
         CASE WHEN (ICO.VALCON - TRUNC(ICO.VALCON) > 0) THEN
           MEDEMB.UNIMED||SUBSTR(TO_CHAR(ICO.VALCON, 'FM9999999990D9999'),1,4)
         ELSE
           MEDEMB.UNIMED||SUBSTR(REPLACE(TO_CHAR(ICO.VALCON, 'FM9999999990D9999'),'.',''),1,4)
         END
       END AS MEDEMB_UNIMED,
       MEDEMB.DESMED AS MEDEMB_DESMED,
       TRI.CODTRI AS TRI_CODTRI,
       CFO.CODCFO AS DOC_CODNAT,
       CFO.DESCFO AS DOC_DESNAT,
       ICFO.CODCFO AS ITE_CODNAT,
       ICFO.DESCFO AS ITE_DESNAT,
       CFG.VC_FILCLI AS CFG_VC_FILCLI,
       CFG.VC_CODCLI AS CFG_VC_CODCLI,
       TRA.FILICO AS TRA_FILITE,
       0 AS ITE_VLRLIQ,
       0 AS ITE_DESRAT,
       0 AS ITE_ACR_ORIGINAL,
       0 AS DOC_VLRIPI_DEVOLVIDO,
       CASE WHEN CLI.CODCLI = '     0' THEN
           CASE WHEN FCLI.REGTRI = 'N' THEN 'F' ELSE 'T' END
       ELSE CLI.SIMPLE END AS PAR_SIMPLE,
       FIL.PERPIS AS FIL_PERPIS, FIL.PERCOF AS FIL_PERCOF,
       FIL.TIPLUC AS FIL_TIPLUC,
       CASE WHEN FIL.REGTRI = 'N' THEN 3
            ELSE CASE WHEN COALESCE(FIL.TRISIM,'X') = 'O' THEN 2
       ELSE 1
                 END
        END AS FIL_REGTRI,
       0 AS ITE_VALOR_FCP, 0 AS ITE_VALOR_PARTILHA_DESTINO,
       0 AS ITE_VALOR_PARTILHA_REMETENTE,
       ICO.ICO_OUTTAX AS ITE_OUTTAX,
       COM.NATBCC AS DOC_NATBCC,
       COM.CODDAR AS DOC_CODDAR,
       COM.FINNFE AS DOC_FINNFE,
       CLI.REGESP AS PAR_REGESP,
       CASE WHEN COALESCE(COM.FINNFE, 'X')  IN ('2', '3') THEN 'J'
       WHEN COALESCE(COM.FINNFE, 'X')  IN ('4') THEN 'D'
       ELSE NULL END AS NAT_TIPNAT,
       'F' AS DOC_ITENS_PROMOCAO,
       IPR.CODCES AS PRO_CODCES,
       FIL.CODIBG AS DOC_MUN_DESTINO
  FROM (SELECT DISTINCT CODSER,
               CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER,
               SEREXP, SUBEXP, MODNOT, ORIGEM
          FROM TT_FIS  
         WHERE ORIGEM IN ('C','F')
           AND EXPORT = 'T') FIS
       INNER JOIN TV_CMP COM ON FIS.CODSER = COM.CODSER
                          AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$')
                          AND FIS.ORIGEM = CASE WHEN COALESCE(COM.TIPPAR,'F') = 'T'
                                                THEN 'F' ELSE 'C' 
                                           END
       INNER JOIN TT_CLI CLI ON CLI.FILCLI = COM.FILFOR
                            AND CLI.CODCLI = COM.CODFOR
       LEFT JOIN TD_FIL FCLI ON FCLI.CODFIL = CLI.FILCLI
       INNER JOIN TD_FIL FIL ON FIL.CODFIL = COM.CODFIL
       LEFT  JOIN TD_CFO CFO ON COM.CODCFO = CFO.CODTAB
       LEFT  JOIN TT_CLI VIN ON VIN.FILCLI = CLI.FILVIN
                            AND VIN.CODCLI = CLI.CODVIN
                            AND CLI.FLGTIP <> 0
       LEFT  JOIN TT_END ENDE ON ENDE.FILCLI = COM.FILFOR
                             AND ENDE.CODCLI = COM.CODFOR
                          AND ENDE.CODFIL = COALESCE(COM.FILEND, CLI.FILEND)
                          AND ENDE.NUMEND = COALESCE(COM.NUMEND, CLI.NUMEND)
       LEFT  JOIN TT_ICO ICO ON ICO.CODFIL = COM.CODFIL
                            AND ICO.SEQUEN = COM.SEQUEN
                            AND ICO.SITMOV = 'N'
       LEFT JOIN TT_TRA TRA ON ICO.CODFIL = TRA.FILICO
                           AND ICO.SEQUEN = TRA.SEQICO
                           AND ICO.NUMITE = TRA.NUMICO
       LEFT  JOIN TD_CFO ICFO ON ICO.CODCFO = ICFO.CODTAB    
       LEFT  JOIN (SELECT GRA.FILMAT, GRA.SEQUEN, GRA.CODMAT,
                          GRA.CODCOR, GRA.CODTAM, PRO.CODNCM,
                          GRA.UNIDAD,
                          PRO.DESECF, PRO.DESMAT, PRO.ESPMAT,
                          PRO.CODFPS, PRO.COD_EX, PRO.CODSRV,
                          PRO.CODANP, PRO.SITIPI, PRO.REFBAS,
                       PRO.NATBCC,
                          DIV.CODITE AS DIV_CODITE,
                          DIV.NOMITE AS ITEDIV,
                          SUB.CODITE AS SUB_CODITE,
                          SUB.NOMITE AS ITESUB,
                          GRA.CODEXT,
                          GRA.CODFIS,
                          GRA.REFPRO,
                          PRO.IIPTPR,
                          PRO.CODCES,
                          GRA.DESGRA
                     FROM TT_GRA GRA LEFT JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT
                                                         AND PRO.CODMAT = GRA.CODMAT
                                     LEFT JOIN TT_DIV DIV ON GRA.CODCOR = DIV.CODITE
                                     LEFT JOIN TT_SUB SUB ON GRA.CODTAM = SUB.CODITE) IPR
                             ON IPR.FILMAT = ICO.FILMAT
                            AND IPR.CODMAT = ICO.CODMAT
                            AND IPR.CODCOR = ICO.CODCOR
                            AND IPR.CODTAM = ICO.CODTAM
       LEFT  JOIN TD_MED MED ON IPR.UNIDAD = MED.CODTAB
       LEFT  JOIN TD_MED MEDFAT ON ICO.UNICOM = MEDFAT.CODTAB
       LEFT  JOIN TT_IUF IUF ON IPR.FILMAT = IUF.FILMAT AND IPR.CODMAT = IUF.CODMAT
                            AND FIL.UFLOJA = IUF.ESTADO AND FIL.REGESP = IUF.REGESP
       LEFT  JOIN TD_ICM ICM ON IUF.RESICM = ICM.CODTAB
       LEFT  JOIN TT_MUN MUN ON MUN.CODIGO = ENDE.CODCID
       LEFT  JOIN TT_SUB SUBORI ON ICO.EMBORI = SUBORI.CODITE
       LEFT  JOIN TT_GRA GRAORI ON GRAORI.FILMAT = ICO.FILMAT
                               AND GRAORI.CODMAT = ICO.CODMAT
                               AND GRAORI.CODCOR = ICO.CODCOR
                               AND GRAORI.CODTAM = ICO.EMBORI
       LEFT  JOIN TD_MED MEDEMB ON GRAORI.UNIDAD = MEDEMB.CODTAB
       LEFT  JOIN TD_TRI TRI ON COM.CODTRI = TRI.CODTAB
       LEFT  JOIN TD_PAI DPAI ON ENDE.CODPAI = DPAI.CODPAI
       CROSS JOIN TT_CFG CFG
 WHERE 1 = 1
   AND COM.NUMNOT NOT LIKE '###%'
   AND COM.FLGEST <> 'D'
   AND NOT (COM.TIPPAR = 'T' AND COM.TIPNOT = 'F')
   AND COM.CODDAR IS NULL
 ORDER BY ICO.CODFIL, ICO.SEQUEN, ICO.NUMITE) TAB;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Documentos Referenciados" (Tabela Integrao Mult)
/*-- SEQ 2952 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_DOCTOREFERENCIADO CASCADE;

/*-- SEQ 2953 --*/
CREATE OR REPLACE VIEW TV_TIMU_DOCTOREFERENCIADO AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST('I' AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.FILREF, TAB.SEQREF, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.CHAVE,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.IndicadorOperacao, -- 0 - Entrada ou Aquisio / 1 - Sada ou Prestao
      TAB.IndicadorEmitente, -- 0 - Prpria / 1 - Terceiros
      TAB.NumeroDoctoRefer, -- Nmero do Documento Referenciado
      TAB.DataEmiDoctoRefer, -- Data de Emisso do Documento Referenciado
      TAB.CPFCNPJParticip, -- CPF ou CNPJ do Participante
      TAB.CodModeloDoctoRefer, -- Cdigo do Modelo do Documento Referenciado (01 a 65)
      TAB.TipoSerieRefer, -- Tipo da Srie do Documento Referenciado 1 - Prpria / 2 - Terceiros
      TAB.SerieDoctoRefer, -- Srie do Documento Referenciado
      TAB.SubSerie, -- Sub Srie do Documento Referenciado
      TAB.ChaveNFECTE, -- Chave NFE ou CTE do Documento Referenciado
      TAB.TipoDoctoRefer, -- 1 - Nota Fiscal / 2 - Nota Fiscal Eletrnica / 3 - Nota Fiscal Produtor / 4 - Cupom Fiscal / 5 - Conhecimento de Transporte Eletrnico / 6 - Despesa Pblica / 7 - Nota Fiscal de Consumidor Eletrnica / 8 - Declarao / 9 - Outros / 0 - NFe / CTe de Anulao de valores
      TAB.ValorDocumento, -- Valor do Documento Referenciado
      TAB.DataPrevEntrega, -- Data de previso de entrega do Documento Referenciado
      TAB.DescricaoDocumento, -- Descrio do Documento Referenciado
      TAB.PINSuframa -- PIN do Suframa
  FROM (-- Notas Emitidas (Reimpresso, Estorno, Devoluo de Venda)
        SELECT VEN.*
          FROM TV_TIMU_DOCTOREFERENCIADOEMIT VEN
         UNION ALL
        -- Notas Emitidas (Devoluo de Compra)
        SELECT VEN.*
          FROM TV_TIMU_DOCTOREFDEVCOMEMIT VEN
         UNION ALL
         -- Notas de Recebidas
         SELECT COM.*
          FROM TV_TIMU_DOCTOREFERENCIADORECEB COM
       ) TAB
 WHERE 1=1
 ORDER BY TAB.CODFIL, TAB.SEQUEN, TAB.FILREF, TAB.SEQREF, TAB.DataHoraAtuReg
;


/*-- SEQ 2954 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_88SP01 CASCADE;

/*-- SEQ 2955 --*/
CREATE OR REPLACE VIEW TV_88SP01 AS
SELECT TIPO||NUMSER||NUMECF||TIPEQU||BRANCOS AS LINHA
  FROM (SELECT TO_CHAR('88SP01') AS TIPO,
                RPAD(ECF.SERECF,20,' ') AS NUMSER,
                ECF.NUMECF,
                TO_CHAR('1') AS TIPEQU,
                RPAD(' ',96,' ') AS BRANCOS
           FROM TD_ECF ECF
          WHERE ECFATI = 'T') TAB
;


/*-- SEQ 2956 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_88SP02 CASCADE;

/*-- SEQ 2957 --*/
CREATE OR REPLACE VIEW TV_88SP02 AS
SELECT CODFIL, DATAOK, TIPO||DATA||CODMAT||DESMAT||UNIDAD||QTDSAL||VLRUNI||VLRTOT||CODPOSSE||NUMDOC||INSEST||UFLOJA AS LINHA
  FROM (SELECT /*+RULE*/TO_CHAR('88SP02') AS TIPO,
               TO_CHAR(INV.DATINV,'YYYYMMDD') AS DATA,
               INV.CODFIL AS CODFIL,
               INV.DATFIN AS DATAOK,
               GRA.FILMAT||REPLACE(GRA.SEQUEN,' ','0')||' ' AS CODMAT,
               REPLACE(RPAD(COALESCE(PRO.DESMAT ,'')|| ' ' || COALESCE(PRO.ESPMAT ,'')|| ' ' || RTRIM(COALESCE(DIV.NOMITE,'')) ||'/'||COALESCE(SUB.NOMITE,''), 53),'"',' ') AS DESMAT,
               RPAD(UPPER(COALESCE(MED.UNIMED,'  ')),6,' ') AS UNIDAD,
               LPAD(to_char(trunc(CustoMedio(INV.CODFIL,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,1,INV.DATINV)*1000)),13,'0') AS QTDSAL,
               LPAD(to_char(trunc(CustoMedio(INV.CODFIL,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,3,INV.DATINV)*100)),13,'0') AS VLRUNI,
               LPAD(to_char(trunc(CustoMedio(INV.CODFIL,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,2,INV.DATINV)*100)),13,'0') AS VLRTOT,
               TO_CHAR('1') AS CODPOSSE,
               RPAD(TRIM(DFIL.CGCFIL),14,' ') AS NUMDOC,
               RPAD(TRIM(DFIL.IE_FIL),14,' ') AS INSEST,
               DFIL.UFLOJA
          FROM TW_INV_FIS INV INNER JOIN TD_FIL DFIL ON DFIL.CODFIL = INV.CODFIL,
               TT_GRA GRA INNER JOIN TD_MED MED ON MED.CODTAB = GRA.UNIDAD
                          INNER JOIN TT_DIV DIV ON DIV.CODITE = GRA.CODCOR
                          INNER JOIN TT_SUB SUB ON SUB.CODITE = GRA.CODTAM
                          INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
         WHERE INV.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
           AND CustoMedio(INV.CODFIL,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,1,TO_DATE('31/12/'||TO_CHAR(TO_NUMBER(TO_CHAR(AGORA(),'YYYY')) - 1),'DD/MM/YYYY')) > 0
           AND CustoMedio(INV.CODFIL,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,2,TO_DATE('31/12/'||TO_CHAR(TO_NUMBER(TO_CHAR(AGORA(),'YYYY')) - 1),'DD/MM/YYYY')) > 0
           AND TO_CHAR(TO_DATE(TO_CHAR(INV.DATINV,'DD/MM/YYYY'),'DD/MM/YYYY'),'MM') = '02') TAB
;



/*-- SEQ 2958 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_88SP03 CASCADE;

/*-- SEQ 2959 --*/
CREATE OR REPLACE VIEW TV_88SP03 AS
  SELECT DATAOK, CODFIL, COALESCE(CHAVE ,'')|| COALESCE(CGC ,'')|| COALESCE(IE ,'')|| COALESCE(DATA ,'')|| COALESCE(UF ,'')||
         COALESCE(MODELO ,'')|| COALESCE(SERIE ,'')|| COALESCE(NUMNOT ,'')|| COALESCE(CFOP ,'')||
         COALESCE(EMITENTE ,'')|| COALESCE(TO_CHAR(VLRLIQ) ,'')|| COALESCE(TO_CHAR(BASICM) ,'')|| COALESCE(TO_CHAR(VLRICM) ,'')||
         COALESCE(TO_CHAR(BASINT) ,'')|| COALESCE(OUTRAS ,'')|| COALESCE(ICMITE ,'')|| COALESCE(FLGEST ,'')||COALESCE(BENEFI,'')||
         COALESCE(TO_CHAR(ALQINT),'')||COALESCE(EMISSAO,'')||COALESCE(POREMP,'')AS LINHA
 FROM (SELECT TO_CHAR('88SP03') AS CHAVE,
              I50.DATAOK,
              I50.CODFIL,
              CASE WHEN SUBSTR(COALESCE(I50.NATURE, '    '), 1, 1) = '3'
                   THEN '00000000000000'
                   ELSE LPAD(I50.NUMDOC, 14, '0')
               END AS CGC,
              RPAD(I50.INSEST, 14, ' ') AS IE,
              TO_CHAR(I50.DATAOK, 'YYYYMMDD') AS DATA,
              CASE WHEN SUBSTR(COALESCE(I50.NATURE,'    '),1,1) = '3'
                   THEN 'IM'
                   ELSE I50.UFNOTA
               END AS UF,
              CASE I50.TIPPAR WHEN 'T' THEN '08'
                                       ELSE COALESCE(RPAD(RTRIM(LTRIM(COALESCE(I50.MODNOT,' '))),2,' '),'  ')
              END AS MODELO,
              COALESCE(RPAD(RTRIM(LTRIM(COALESCE(COALESCE(I50.CODSER,' '),' '))),3,' '),'   ') AS SERIE,
              SUBSTR(LPAD(RTRIM(LTRIM(I50.NUMNOT)),9,'0'),-6,6) AS NUMNOT,
              RPAD(SUBSTR(COALESCE(I50.NATURE,'    '),1,4),4,' ') AS CFOP,
              TO_CHAR('T') AS EMITENTE,
              LPAD(to_char(COALESCE(ROUND((COALESCE(I50.VLRLIQ,0)) * 100), 0)), 13, '0') AS VLRLIQ,
              REPLACE(LPAD(to_char(ROUND(I50.BASICM * 100, 0)), 13, '0'),'-','0') AS BASICM,
              REPLACE(LPAD(to_char(ROUND(I50.VLRICM * 100, 0)), 13, '0'),'-','0') AS VLRICM,
              LPAD(to_char(ROUND(COALESCE(I50.BASINT*(100+((COALESCE(I50.DESCON,0)/I50.VLRTOT)*100)),0),0)),13,'0') AS BASINT,
              LPAD(to_char(ROUND(COALESCE((COALESCE(I50.OUTRAS,0)) * 100,0),0)),13,'0') AS OUTRAS,
              LPAD(to_char(ROUND(COALESCE(I50.ICMITE*100,0),0)),4,'0') AS ICMITE,
              CASE I50.FLGEST WHEN 'D'
                              THEN 'S'
                              ELSE 'N'
               END AS FLGEST,
              LPAD(to_char(ROUND(COALESCE(I50.ICMITE*100,0),0)),4,'0') AS ALQINT,
              CASE WHEN I50.UFNOTA = 'MG'
                   THEN '0'
                   ELSE '2'
               END AS BENEFI,
              TO_CHAR(I50.DATAOK, 'YYYYMMDD') AS EMISSAO,
              CASE WHEN I50.UFNOTA = 'MG'
                   THEN '0'
                   ELSE CASE WHEN I50.POREMP in ('P','M')
                             THEN '1'
                             ELSE '2'
                         END
               END AS POREMP
         FROM TV_FIS_50CINTERNO I50
        WHERE I50.TIPNOT IN ('A','N')) TAB
        GROUP BY TAB.DATAOK, TAB.CODFIL, TAB.CHAVE, TAB.CGC, TAB.IE, TAB.DATA, TAB.UF, TAB.MODELO, TAB.SERIE, TAB.NUMNOT, TAB.CFOP,
                 TAB.EMITENTE, TAB.VLRLIQ, TAB.BASICM, TAB.VLRICM, TAB.BASINT, TAB.OUTRAS, TAB.ICMITE, TAB.FLGEST, TAB.BENEFI,
                 TAB.ALQINT, TAB.POREMP, TAB.EMISSAO
 ;



/*-- SEQ 2960 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_88SP04 CASCADE;

/*-- SEQ 2961 --*/
CREATE OR REPLACE VIEW TV_88SP04 AS
SELECT DATAOK, CODFIL, COALESCE(CHAVE ,'')|| COALESCE(CGC ,'')|| COALESCE(IE ,'')|| COALESCE(DATA ,'')|| COALESCE(UF ,'')|| COALESCE(MODELO ,'')|| COALESCE(SERIE ,'')|| COALESCE(SUBSERIE ,'')||
       COALESCE(NUMNOT ,'')|| COALESCE(CFOP ,'')|| COALESCE(to_char(VLRLIQ) ,'')|| COALESCE(BASICM ,'')||
       COALESCE(to_char(VLRICM) ,'')|| COALESCE(to_char(BASINT) ,'')|| COALESCE(OUTRAS ,'')|| COALESCE(TIPOFRETE ,'')||
       COALESCE(FLGEST ,'')||COALESCE(TO_CHAR(PERFRE),'')||COALESCE(ALQINT,'')||COALESCE(EMISSAO,'')||COALESCE(POREMP,'') AS LINHA
FROM (SELECT to_char('88SP04') AS CHAVE,
       I70.DATAOK, I70.CODFIL,
       LPAD(I70.NUMDOC,14,'0') AS CGC,
       RPAD(I70.INSEST,14,' ') AS IE,
       TO_CHAR(I70.DATAOK, 'YYYYMMDD') AS DATA,
       COALESCE(I70.UFNOTA,'  ') AS UF,
       to_char('08') AS MODELO,
       COALESCE(RPAD(RTRIM(LTRIM(COALESCE(COALESCE(I70.CODSER,' '),' '))),1,' '),' ') AS SERIE,
       COALESCE(RPAD(RTRIM(LTRIM(COALESCE(I70.SUBSER,' '))),2,' '),'  ') AS SUBSERIE,
       /* PROBLEMA => NO BANCO, NUMNOT TEM 9 POSICOES, MAS A EXPORTACAO SO ACEITA 6 ! */
       SUBSTR(LPAD(RTRIM(LTRIM(I70.NUMNOT)),9,'0'),-6,6) AS NUMNOT,
       RPAD(SUBSTR(COALESCE(I70.NATURE,'   '),1,4),4,' ') AS CFOP,
       LPAD(to_char(COALESCE(ROUND(I70.VLRLIQ*100,0),0)),13,'0') AS VLRLIQ,
       LPAD(to_char(ROUND(COALESCE(I70.BASICM*100,0),0)),14,'0') AS BASICM,
       LPAD(to_char(ROUND(COALESCE(I70.VLRICM*100,0),0)),14,'0') AS VLRICM,
       LPAD(to_char(ROUND(COALESCE(I70.BASINT*100,0),0)),14,'0') AS BASINT,
       LPAD(to_char(ROUND(COALESCE(I70.OUTRAS*100,0),0)),14,'0') AS OUTRAS,
       to_char('2') AS TIPOFRETE,
       CASE I70.FLGEST WHEN 'D' THEN 'S'
                                ELSE 'N'
       END AS FLGEST,
       LPAD(to_char(ROUND(COALESCE(I70.PERFRE*100,0),0)),4,'0') AS PERFRE,
       TO_CHAR('0000') AS ALQINT,
       TO_CHAR(I70.DATAOK, 'YYYYMMDD') AS EMISSAO,
              CASE WHEN I70.UFNOTA = 'MG'
                   THEN '0'
                   ELSE CASE WHEN I70.POREMP in ('P','M')
                             THEN '1'
                             ELSE '2'
                         END
               END AS POREMP
  FROM TV_FIS_70CINTERNO I70
 WHERE I70.TIPNOT IN ('A','N')
) TAB
;


/*-- SEQ 2962 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_88STES CASCADE;

/*-- SEQ 2963 --*/
CREATE OR REPLACE VIEW TV_88STES AS
SELECT CODFIL, DATAOK, CAST(TIPO||NUMDOC||DATA||CODMAT||QTDSAL||VLR_ST||VLRICM||' ' AS VARCHAR(4000)) AS LINHA
  FROM (SELECT /*+RULE*/CAST(TO_CHAR('88STES') AS VARCHAR(7)) AS TIPO,
               CAST(TO_CHAR(TRUNC(LAST_DAY(ADD_MONTHS(INV.DATINI, -1))),'YYYYMMDD') AS VARCHAR(8)) AS DATA,
               CAST(RPAD(TRIM(DFIL.CGCFIL),14,' ') AS VARCHAR(14)) AS NUMDOC,
               INV.CODFIL AS CODFIL,
               INV.DATINI AS DATAOK,
               CAST(RPAD(GRA.FILMAT||RPAD(REPLACE(GRA.SEQUEN,' ','0'),10,'0'), 60, ' ') AS VARCHAR(60)) AS CODMAT,
               CAST(LPAD(TO_CHAR(TRUNC(INV_PRO.QTDSAL*1000)),13,'0') AS VARCHAR(13)) AS QTDSAL,
               CAST(LPAD((SELECT TO_CHAR(TRUNC(COALESCE(SUM(ICO.VLR_ST), 0) * 100))
                            FROM TW_INV_FIS_ICO_SUB ICO 
                           WHERE ICO.SESSION_ID = INV_PRO.SESSION_ID AND ICO.CODFIL = INV_PRO.CODFIL 
                             AND ICO.FILMAT = INV_PRO.FILMAT AND ICO.CODMAT = INV_PRO.CODMAT 
                             AND ICO.CODCOR = INV_PRO.CODCOR AND ICO.CODTAM = INV_PRO.CODTAM), 12, '0') AS VARCHAR(12)) AS VLR_ST,
               CAST(LPAD((SELECT TO_CHAR(TRUNC(COALESCE(SUM(ICO.VLRICM), 0) * 100))
                            FROM TW_INV_FIS_ICO_SUB ICO 
                           WHERE ICO.SESSION_ID = INV_PRO.SESSION_ID AND ICO.CODFIL = INV_PRO.CODFIL 
                             AND ICO.FILMAT = INV_PRO.FILMAT AND ICO.CODMAT = INV_PRO.CODMAT 
                             AND ICO.CODCOR = INV_PRO.CODCOR AND ICO.CODTAM = INV_PRO.CODTAM), 12, '0') AS VARCHAR(12)) AS VLRICM
          FROM TW_INV_FIS INV
          JOIN TW_INV_FIS_PRO_SUB INV_PRO ON INV_PRO.SESSION_ID = INV.SESSION_ID AND INV_PRO.CODFIL = INV.CODFIL
          JOIN TD_FIL DFIL ON DFIL.CODFIL = INV.CODFIL
          JOIN TT_GRA GRA ON GRA.FILMAT = INV_PRO.FILMAT AND GRA.CODMAT = INV_PRO.CODMAT AND GRA.CODCOR = INV_PRO.CODCOR AND GRA.CODTAM = INV_PRO.CODTAM
         WHERE INV.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
           AND EXISTS (SELECT 1 AS OK
                         FROM TW_INV_FIS_ICO_SUB ICO
                        WHERE ICO.SESSION_ID = INV_PRO.SESSION_ID 
                          AND ICO.CODFIL = INV_PRO.CODFIL
                          AND ICO.FILMAT = INV_PRO.FILMAT
                          AND ICO.CODMAT = INV_PRO.CODMAT
                          AND ICO.CODCOR = INV_PRO.CODCOR
                          AND ICO.CODTAM = INV_PRO.CODTAM)
        ) TAB
;


/*-- SEQ 2964 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_88STITNF CASCADE;

/*-- SEQ 2965 --*/
CREATE OR REPLACE VIEW TV_88STITNF AS
SELECT CODFIL, DATAOK, CAST(TIPO||NUMDOC||MODELO||SERIE||NUMNOT||CFOP||CST||NUMITE||DATOPE||CODMAT||QTDMOV||VLRBRU||DESPES||BASICM||BASSUB||PERSUB||PERICM||VLRIPI||CHAVEA||' ' AS VARCHAR(4000)) AS LINHA
  FROM (SELECT /*+RULE*/CAST(TO_CHAR('88STITNF') AS VARCHAR(8)) AS TIPO,
               ICO.CODFIL,
               INV.DATINI AS DATAOK,
               CAST(CASE WHEN SUBSTR(ICO.NATURE,1,1) = '3' THEN '00000000000000'
                         ELSE LPAD(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(COALESCE(LTRIM(RTRIM(COALESCE(ENDE.NUMDOC,PAR.NUMDOC,VIN.NUMDOC))),'0'),',',''),'.',''),'/',''),'-',''),' ',''),14,'0')
                    END AS VARCHAR(14)) AS NUMDOC,
               CAST(COALESCE(LPAD(RTRIM(LTRIM(COALESCE(ICO.MODNOT,'01'))),2,'0'),'  ') AS VARCHAR(14)) AS MODELO,
               CAST(COALESCE(RPAD(RTRIM(LTRIM(COALESCE(ICO.CODSER,' '))),3,' '),'   ')AS VARCHAR(3)) AS SERIE,
               CAST(LPAD(RTRIM(LTRIM(ICO.NUMNOT)),9,'0') AS VARCHAR(9)) AS NUMNOT,
               CAST(RPAD(SUBSTR(ICO.NATURE,1,4),4,' ') AS VARCHAR(4)) AS CFOP,
               CAST(RPAD(COALESCE(ICO.CODCST,'0'), 3, '0') AS VARCHAR(3)) AS CST,
               CAST(LPAD(TO_CHAR(ICO.NUMITE), 3, '0') AS VARCHAR(3)) AS NUMITE,
               CAST(TO_CHAR(ICO.DATOPE, 'YYYYMMDD') AS VARCHAR(8)) AS DATOPE,
               CAST(RPAD(GRA.FILMAT||RPAD(REPLACE(GRA.SEQUEN,' ','0'),10,'0'), 60, ' ') AS VARCHAR(60)) AS CODMAT,
               CAST(LPAD(TO_CHAR(TRUNC(ICO.QTDMOV * 1000)), 11, '0') AS VARCHAR(11)) AS QTDMOV,
               CAST(LPAD(TO_CHAR(ABS(TRUNC(ICO.VLRITE * 100))),12,'0') AS VARCHAR(12)) AS VLRBRU,
               CAST(LPAD(TO_CHAR(ABS(TRUNC((ICO.VLRDES + ICO.DESRAT)*100))), 12, '0') AS VARCHAR(12)) AS DESPES,
               /* BASE DE CALCULO DE ICMS */
               CAST(LPAD(TO_CHAR(TRUNC(ICO.BASICM * 100)), 12, '0') AS VARCHAR(12)) AS BASICM,
               /* BASE DE CALCULO DE ICMS SUBSTITUIDO */
               CAST(LPAD(TO_CHAR(TRUNC(ICO.BASSUB * 100)), 12, '0') AS VARCHAR(12)) AS BASSUB,
               /* ALIQUOTA DE ICMS SUBSTITUIDO*/
               CAST(LPAD(TO_CHAR(TRUNC(ICO.ICMVEN * 100)), 4, '0') AS VARCHAR(4)) AS PERSUB,
               /* ALIQUOTA DE ICMS */
               CAST(LPAD(TO_CHAR(TRUNC(CASE WHEN COALESCE(ICO.ICMITE, 0) = 0 THEN CASE WHEN COALESCE(ICO.TAX001, 0) = 0 THEN 0 ELSE ICO.TAX001 END
                                            ELSE CASE WHEN ICO.ICMTIP = '3' THEN 0 ELSE ICO.ICMITE END
                                       END * 100)), 4, '0') AS VARCHAR(4)) AS PERICM,
               /* VALOR DE IPI, SOMENTE PARA PRODUTOS TRIBUTADOS */
               CAST(LPAD(TO_CHAR(TRUNC(ICO.VLRIPI * 100)), 12, '0') AS VARCHAR(12)) AS VLRIPI,
               CAST(LPAD(COALESCE(ICO.CHAVEA,' '), 44 ,' ') AS VARCHAR(44)) AS CHAVEA
          FROM TW_INV_FIS_ICO_SUB ICO
          JOIN TW_INV_FIS INV ON INV.SESSION_ID = ICO.SESSION_ID AND INV.CODFIL = ICO.CODFIL
          JOIN TT_GRA GRA ON GRA.FILMAT = ICO.FILMAT AND GRA.CODMAT = ICO.CODMAT AND GRA.CODCOR = ICO.CODCOR AND GRA.CODTAM = ICO.CODTAM
          JOIN TT_CLI PAR ON PAR.FILCLI = ICO.FILFOR AND PAR.CODCLI = ICO.CODFOR
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN
          LEFT JOIN TT_END ENDE ON ENDE.FILCLI = ICO.FILFOR AND ENDE.CODCLI = ICO.CODFOR AND ENDE.CODFIL = COALESCE(ICO.FILEND,ENDE.CODFIL) AND ENDE.NUMEND = COALESCE(ICO.NUMEND, 1)
         WHERE ICO.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
        ) TAB
;



/*-- SEQ 2966 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_AUX_ECT_USO CASCADE;

/*-- SEQ 2967 --*/
CREATE OR REPLACE VIEW TV_AUX_ECT_USO AS
select chvprj, chvpai, titect
  from (select 'E'||ect.codigo as chvprj,
               case when ect.codpai is null then null
                                            else 'E' 
               end ||ect.codpai as chvpai,
               ect.titect
          from (-- Ver detalhes sobre a macro em
-- \\tt2000\Docs\desenv\depto\Manuais\Ansi\connectby.mac
SELECT c.conn_codigo as codigo, case c.conn_codpai when 'NULL' then null
                                           else c.conn_codpai
               end as codpai, c.level as nivel, c.ordem-1 as ordem ,codfil,sequen,titect,Aux_TV_ECT_USO(Codfil,Sequen) as qtd
FROM connectby('(select to_char(''NULL'') as filho,
                        to_char(null) as pai,
                        0 as ordem
                   from dual
                 union all
                 select TO_CHAR(chvprj) as filho,
                        coalesce(TO_CHAR(chvpai),''NULL'') as pai,
                        0 as ordem
                   from tt_ect int) tab', 'filho', 'pai','ordem', 'NULL', 0, '~')
AS c (conn_codigo VARCHAR, conn_codpai VARCHAR, level int, arvore text, ordem int)
INNER JOIN tt_ect t ON c.conn_codigo  = (chvprj)
where conn_codigo<>'NULL'
order by ordem
               ) ect
  where qtd > 0
  union all
  select 'C'||in2.codfil||in2.sequen as filprj,
         'E'||in2.filect||in2.seqect as chvpai,
         in2.titcta as titect
    from tt_cta in2
   where (in2.codfil, in2.sequen) in (select filcta,seqcta from tv_cta_uso)
  union all
  select 'U'||filcta||seqcta as filprj,
         'C'||filcta||seqcta as chvpai,
         '--> Nome: ' || nome || ', Uso: ' || uso || ', Configurao: '|| config  as titect
    from tv_cta_uso 
    ) fim
;




/*-- SEQ 2968 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ECMS CASCADE;

/*-- SEQ 2969 --*/
CREATE OR REPLACE VIEW TV_ECMS AS
SELECT CMS.FILIAL, CMS.DATA, CMS.FILVEN, CMS.CODVEN, CMS.VALORDOC, 
       CMS.DOCUMENTO, CMS.PARCELA, CMS.FILPGT, CMS.PERCENTUAL, 
       CMS.CODSER, CMS.CODPGT, CMS.COMSOB,
       CMS.COMISSAO, CMS.FLGPAR, 0 AS STATUS, 
       TO_CHAR(' ') AS DATIMP,TO_CHAR(' ') AS MOTREJ
  FROM TV_CMS CMS;


/*-- SEQ 2970 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ECON_AC_40 CASCADE;

/*-- SEQ 2971 --*/
CREATE OR REPLACE VIEW TV_ECON_AC_40 AS
SELECT CAST('0040' AS CHAR(4)) AS REGISTRO,
       FIN.CODFIL,
       FIN.DATLAN,
       ABS(FIN.VLRLAN) AS VLRLAN,
       FIN.DESHIS AS COMPLE,
       FIN.RFIN_CODTAB,
       FIN.FILDES,
       FIL.CGCFIL,
       DES.CGCFIL AS CGCFILDES
  FROM TV_ECON_INT FIN INNER JOIN TD_FIL FIL ON FIN.CODFIL = FIL.CODFIL
                       INNER JOIN TD_FIL DES ON DES.CODFIL = FIN.FILDES
;


/*-- SEQ 2972 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EICO_EXP CASCADE;

/*-- SEQ 2973 --*/
CREATE OR REPLACE VIEW TV_EICO_EXP AS
SELECT ICO.*
  FROM TV_EICO ICO INNER JOIN TD_EXP DEXP ON DEXP.CODTAB = 1
 WHERE ICO.ATU_EM BETWEEN TO_DATE(TO_CHAR(TRUNC(DEXP.DATINI),'DD/MM/YYYY')||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                          TO_DATE(TO_CHAR(TRUNC(DEXP.DATFIM),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');


/*-- SEQ 2974 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EIVE_EXP CASCADE;

/*-- SEQ 2975 --*/
CREATE OR REPLACE VIEW TV_EIVE_EXP AS
SELECT *
FROM TV_EIVE IVE INNER JOIN TD_EXP DEXP ON DEXP.CODTAB = 1
WHERE IVE.ATU_EM BETWEEN TO_DATE(TO_CHAR(TRUNC(DEXP.DATINI),'DD/MM/YYYY')||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND TO_DATE(TO_CHAR(TRUNC(DEXP.DATFIM),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');


/*-- SEQ 2976 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EIVE_FIS CASCADE;

/*-- SEQ 2977 --*/
CREATE OR REPLACE VIEW TV_EIVE_FIS AS
SELECT EIVE.CODFIL,
       EIVE.SEQUEN,
       EIVE.NUMECF,
       EIVE.CODSER,
       EIVE.NUMNOT,
       EIVE.NUMITE,
       EIVE.CODMAT,
       EIVE.UNIMED,
       EIVE.CODCST,
       EIVE.NATFIS,
       EIVE.TAXICM,
       (EIVE.VLRMOV/EIVE.QTDMOV) AS VLRUNI,
       EIVE.QTDMOV,
       EIVE.VLRMOV,
       EIVE.DESRAT,
       EIVE.ACRRAT,
       EIVE.VLRFRE,
       EIVE.VLRSEG,
       EIVE.OUTTAX,
       EIVE.BASICM,
       EIVE.VLRICM,
       EIVE.BASUBS,
       EIVE.SUBSTT,
       EIVE.BASPIS,
       EIVE.VLRPIS,
       EIVE.BASCOF,
       EIVE.VLRCOF,
       EIVE.VLRIPI,
       EIVE.ICMTIP,
       EIVE.SITMOV,
       EIVE.VEN_DATHOR,
       EIVE.REFBAS,
       EIVE.REFPRO,
       EIVE.CODFIS,
       EIVE.GRA_FILMAT,
       EIVE.GRA_CODMAT,
       EIVE.GRA_CODCOR,
       EIVE.GRA_CODTAM,
       EIVE.EMBQTD,
       EIVE.EMBORI,
       EIVE.NCM_CODEXT,
       0 AS MIN_NUMITE,
       EIVE.CUSREP_FREFIS,
       EIVE.CUSMED_FIS,
       EIVE.CUSSIM,
       EIVE.TOT_CM,
       EIVE.SAL_CM,
       EIVE.FILPRE,
       EIVE.CODPRE,
       CAST(EIVE.SITPIS AS CHAR(2)) AS SITPIS,
       CAST(EIVE.SITCOF AS CHAR(2)) AS SITCOF,
       EIVE.VEN_FLGEST,
       EIVE.FLGDEV,
       EIVE.CLIENTE,
       EIVE.CLI_CODEXT,
       EIVE.ENTSAI,
       /* Identificação Nota de Origem */
       EIVE.FILORI,
       EIVE.NUMORI,
       EIVE.ITEORI,
       EIVE.SERORI,
       EIVE.NOTORI,
       EIVE.ECFORI,
       EIVE.DATHORORI,
       EIVE.MODORI,
       EIVE.CROORI
  FROM TV_EIVE EIVE INNER JOIN TD_SER DSER ON DSER.CODSER = EIVE.CODSER
 WHERE DSER.MODNOT <> '55'
 UNION ALL
SELECT TAB.CODFIL,
       TAB.SEQUEN,
       TAB.NUMECF,
       TAB.CODSER,
       TAB.NUMNOT,
       TAB.NUMITE,
       TAB.CODMAT,
       TAB.UNIMED,
       TAB.CODCST,
       TAB.NATFIS,
       TAB.TAXICM,
       TAB.VLRUNI,
       TAB.QTDMOV,
       TAB.VLRMOV,
       TAB.DESRAT,
       TAB.ACRRAT,
       TAB.VLRFRE,
       TAB.VLRSEG,
       TAB.OUTTAX,
       TAB.BASICM,
       TAB.VLRICM,
       TAB.BASUBS,
       TAB.SUBSTT,
       TAB.BASPIS,
       TAB.VLRPIS,
       TAB.BASCOF,
       TAB.VLRCOF,
       TAB.VLRIPI,
       TAB.ICMTIP,
       TAB.SITMOV,
       TAB.VEN_DATHOR,
       TAB.REFBAS,
       TAB.REFPRO,
       TAB.CODFIS,
       TAB.GRA_FILMAT,
       TAB.GRA_CODMAT,
       TAB.GRA_CODCOR,
       TAB.GRA_CODTAM,
       TAB.EMBQTD,
       TAB.EMBORI,
       TAB.NCM_CODEXT,
       TAB.MIN_NUMITE,
       TAB.CUSREP_FREFIS,
       TAB.CUSMED_FIS,
       TAB.CUSSIM,
       TAB.TOT_CM,
       TAB.SAL_CM,
       TAB.FILPRE,
       TAB.CODPRE,
       TAB.SITPIS,
       TAB.SITCOF,
       TAB.VEN_FLGEST,
       TAB.FLGDEV,
       TAB.CLIENTE,
       TAB.CLI_CODEXT,
       TAB.ENTSAI,
       /* Identificação Nota de Origem */
       COALESCE(IVE.FILORI, IVE.FILICOORI) AS FILORI,
       COALESCE(IVE.NUMORI, IVE.SEQICOORI) AS NUMORI,
       COALESCE(IVE.ITEORI, IVE.NUMICOORI) AS ITEORI,
       CAST(COALESCE(VDE.CODSER,CDE.CODSER) AS CHAR(2)) AS SERORI,
       CAST(COALESCE(VDE.NUMNOT, CDE.NUMNOT) AS CHAR(9)) AS NOTORI,
       CAST(COALESCE(VDE.NUMECF, CASE WHEN IVE.FILICOORI IS NOT NULL THEN '000' ELSE NULL END) AS CHAR(3)) AS ECFORI,
       COALESCE(VDE.DATHOR, CDE.DATOPE) AS DATHORORI,
       COALESCE(FISVDE.MODNOT, FISCDE.MODNOT) AS MODORI,
       CAST(CASE WHEN DECF.INTERV IS NOT NULL
                 THEN DECF.INTERV
                 ELSE COALESCE(VDE.CNT_RO, CASE WHEN IVE.FILICOORI IS NOT NULL THEN 0 ELSE NULL END)
            END AS CHAR(3)) AS CROORI
 FROM(
SELECT VEN.CODFIL,
       VEN.SEQUEN,
       VEN.NUMECF,
       VEN.CODSER,
       VEN.NUMNOT,
       INF.inf_numite AS NUMITE,
       INF.inf_codmat AS CODMAT,
       COALESCE(MED.UNIMED,'') AS UNIMED,
       CAST(INF.inf_fl_icmsorig AS CHAR(1))||LPAD(CAST(INF.inf_nu_icmscst AS CHAR(2)),2,'0') AS CODCST,
       CAST(INF.inf_nu_cfop||SUBSTR(DNAT.NATDEN,5,2) AS CHAR(6)) AS NATFIS,
       INF.inf_vl_ICMSAliq AS TAXICM,
       COALESCE(INF.inf_vl_vuntrib,0) AS VLRUNI,
       COALESCE(INF.inf_nu_qtrib,0) AS QTDMOV,
       (INF.INF_vl_prod + COALESCE(INF.inf_vl_IPI,0)) AS VLRMOV,
       COALESCE(INF.inf_vl_desconto,0) as DESRAT,
       0 AS ACRRAT,
       COALESCE(INF.inf_vl_frete,0) AS VLRFRE,
       COALESCE(INF.inf_vl_seguro,0) AS VLRSEG,
       COALESCE(INF.inf_vl_outro,0) as OUTTAX,
       COALESCE(INF.inf_vl_ICMSvBC,0) AS BASICM,
       COALESCE(INF.inf_vl_ICMS,0) AS VLRICM,
       COALESCE(INF.inf_vl_ICMSSTvBC,0) AS BASUBS,
       COALESCE(INF.inf_vl_ICMSST,0) AS SUBSTT,
       COALESCE(INF.inf_vl_PISBC,0) AS BASPIS,
       COALESCE(INF.inf_vl_PIS,0) AS VLRPIS,
       COALESCE(INF.inf_vl_COFINSBC,0) AS BASCOF,
       COALESCE(INF.inf_vl_COFINS,0) AS VLRCOF,
       COALESCE(INF.inf_vl_ipi,0) AS VLRIPI,
       CASE WHEN COALESCE(INF.inf_nu_ICMSCST,90) IN (00,20,101,102) THEN '0'
            WHEN COALESCE(INF.inf_nu_ICMSCST,90) IN (41,400) THEN '1'
            WHEN COALESCE(INF.inf_nu_ICMSCST,90) IN (40,103,300) THEN '2'
            WHEN COALESCE(INF.inf_nu_ICMSCST,90) IN (10,30,60,70,201,202,203,500) THEN '3'
            ELSE '1'
       END AS ICMTIP,
       CASE WHEN VEN.FLGEST <> 'C' THEN 'N'
            ELSE 'C'
       END AS SITMOV,
       VEN.DATHOR AS VEN_DATHOR,
       PRO.REFBAS,
       GRA.REFPRO,
       GRA.CODFIS,
       GRA.FILMAT AS GRA_FILMAT,
       GRA.CODMAT AS GRA_CODMAT,
       GRA.CODCOR AS GRA_CODCOR,
       COALESCE(DSUB.CODSAL,SUB.CODITE) AS GRA_CODTAM,
       CASE WHEN DSUB.CODSAL IS NULL THEN NULL
            ELSE COALESCE(INF.inf_nu_qcom,0)
       END AS EMBQTD,
       CASE WHEN DSUB.CODSAL IS NULL THEN NULL
            ELSE SUB.CODITE
       END AS EMBORI,
       NCM.CODEXT AS NCM_CODEXT,
       (SELECT MIN(SUB.NUMITE)
          FROM TT_IVE SUB
         WHERE SUB.CODFIL = VEN.CODFIL
           AND SUB.SEQUEN = VEN.SEQUEN) AS MIN_NUMITE,
       INF.INF_CUSREP_FREFIS  AS CUSREP_FREFIS,
       INF.INF_CUSMED_FIS  AS CUSMED_FIS,
       INF.INF_CUSSIM AS CUSSIM,
       IVE.TOT_CM, IVE.SAL_CM, VEN.FILPRE, VEN.CODPRE,
       IVE.FILORI, IVE.NUMORI, IVE.FILICOORI, IVE.SEQICOORI,
       CAST(LPAD(CAST(INF.inf_nu_piscst AS CHAR(2)),2,'0') AS CHAR(2)) AS SITPIS,
       CAST(LPAD(CAST(INF.inf_nu_cofinscst AS CHAR(2)),2,'0') AS CHAR(2)) AS SITCOF,
       /* Coluna deve seguir padrão da TV_EVEN - Foi disponibilizada na View para Ter Ganho de Performace na Integração da Casa Carneiro */
       VEN.FLGEST AS VEN_FLGEST,
       CLI.CODEXT AS CLI_CODEXT,
       CAST(CASE WHEN (DNAT.TIPNAT IN('D','M','R')) THEN 'T' ELSE 'F' END AS CHAR(1)) AS FLGDEV,
       CAST(VEN.FILCLI||TRIM(VEN.CODCLI) AS VARCHAR(20)) AS CLIENTE,
       CAST(CASE WHEN SUBSTR(DNAT.NATDEN, 1, 1) IN ('1', '2', '3') THEN 'E' ELSE 'S' END AS VARCHAR(1)) AS ENTSAI
  FROM TT_VEN VEN INNER JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
                  INNER JOIN TT_NFE NFE ON NFE.nfe_codfil = VEN.CODFIL
                                       AND NFE.nfe_nu_serie = CAST(DSER.SEREXT AS Numeric)
                                       AND NFE.nfe_nu_nnf = to_number(TRIM(VEN.NUMNOT))
                  INNER JOIN TT_INF INF ON INF.nfe_id_doc = NFE.nfe_id_doc
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                  INNER JOIN TT_GRA GRA ON GRA.FILMAT = INF.inf_filmat
                                       AND GRA.CODMAT = INF.inf_codmat
                                       AND GRA.CODCOR = INF.inf_codcor
                                       AND GRA.CODTAM = INF.inf_codtam
                  INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
                  INNER JOIN TD_MED MED ON MED.CODTAB = GRA.UNIDAD
                  INNER JOIN TT_SUB SUB ON SUB.CODITE = GRA.CODTAM
                  INNER JOIN TD_SUB DSUB ON DSUB.CODTAB = SUB.CODSUB
                  INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
                   LEFT JOIN TT_NCM NCM ON PRO.CODNCM = NCM.CODNCM
                   LEFT JOIN TT_IVE IVE ON IVE.CODFIL = INF.IVE_CODFIL
                                       AND IVE.SEQUEN = INF.IVE_SEQUEN
                                       AND IVE.NUMITE = INF.IVE_NUMITE
 WHERE DSER.MODNOT = '55'
   AND COALESCE(VEN.FLGNFE,'0') IN ('1','3', '6')
   AND VEN.NUMNOT NOT LIKE '%#%'
) TAB LEFT JOIN TD_ECF DECF ON DECF.FILECF = TAB.CODFIL
                           AND DECF.NUMECF = TAB.NUMECF
      LEFT JOIN TT_IVE IVE  ON IVE.CODFIL = TAB.CODFIL
                           AND IVE.SEQUEN = TAB.SEQUEN
                           AND IVE.NUMITE = TAB.MIN_NUMITE
      LEFT JOIN TT_VEN VDE ON VDE.CODFIL = COALESCE(TAB.FILORI, IVE.FILORI)
                          AND VDE.SEQUEN = COALESCE(TAB.NUMORI, IVE.NUMORI)
      LEFT JOIN TT_FIS FISVDE ON FISVDE.ORIGEM = 'V'
                             AND FISVDE.CODSER = VDE.CODSER
                             AND FISVDE.SUBSER = VDE.NUMECF
      LEFT JOIN TT_COM CDE ON CDE.CODFIL = COALESCE(TAB.FILICOORI, IVE.FILICOORI)
                          AND CDE.SEQUEN = COALESCE(TAB.SEQICOORI, IVE.SEQICOORI)
      LEFT JOIN TT_FIS FISCDE ON FISCDE.ORIGEM = 'C'
                             AND FISCDE.CODSER = CDE.CODSER
                             AND FISCDE.SUBSER = COALESCE(CDE.SUBSER,'');


/*-- SEQ 2978 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIN CASCADE;

/*-- SEQ 2979 --*/
CREATE OR REPLACE VIEW TV_FIN AS
  SELECT RFIN.FILORI AS FILREC,
         RFIN.FILCTA,
         RFIN.SEQCTA,
         RFIN.TIPCTA,
         RFIN.FILCRT,
         RFIN.SEQCRT,
         RFIN.TIPCRT,
         RFIN.DATLAN AS DATPGT,
         RFIN.FILUSU,
         RFIN.CODUSU,
         RFIN.FILCLI,
         RFIN.CODCLI,
         CASE RFIN.ORIGEM WHEN 'DOP' THEN
           CASE WHEN RFIN.FILCLI = CFG.VC_FILCLI AND RFIN.CODCLI = CFG.VC_CODCLI THEN 'DIVERSOS' ELSE CLI.NOMCLI
           END ELSE CLI.NOMCLI
         END AS NOMCLI,
         CASE RFIN.ORIGEM WHEN 'DOP' THEN
           CASE WHEN RFIN.FILCLI = CFG.VC_FILCLI AND RFIN.CODCLI = CFG.VC_CODCLI THEN 'DIVERSOS' ELSE CLI.ULTNOM
           END ELSE CLI.ULTNOM
         END AS ULTNOM,
         ComplementoDadosFinanceiros(RFIN.ORIGEM, RFIN.CODFIL, RFIN.SEQUEN, RFIN.NUMPAR, RFIN.SUBPAR, 1) AS OBSERV,
         RFIN.CODFIL, RFIN.SEQUEN, RFIN.NUMPAR, RFIN.SUBPAR,
         CAST(CASE RFIN.FLGFLX WHEN 'R' THEN 'Realizado' ELSE 'A Realizar' END AS VARCHAR(10)) AS FLGEST,
         RFIN.ORIGEM AS TABORI,
         CAST(CASE RFIN.ORIGEM WHEN 'REC' THEN 'Recebimentos'
                               WHEN 'CCC' THEN 'Conta Corrente'
                               WHEN 'CHR' THEN 'Cheques'
                               WHEN 'FIN' THEN 'Financeira '||CASE RFIN.TIPCTA WHEN 'N' THEN 'Numeraria' ELSE 'Gerencial' END
                               WHEN 'PTR' THEN 'Ttulos a Receber'
                               WHEN 'COM' THEN 'Compras'
                               WHEN 'DOP' THEN 'Documentos'
                               WHEN 'PAG' THEN 'Pagamentos'
                               WHEN 'TEF' THEN 'Carto'
         END AS VARCHAR(20)) AS NOMORI,
         RFIN.VLRLAN AS VLRPGT,
         ComplementoDadosFinanceiros(RFIN.ORIGEM, RFIN.CODFIL, RFIN.SEQUEN, RFIN.NUMPAR, RFIN.SUBPAR, 3) AS DOCUME,
         COALESCE(RFIN.CODFIL,'')||COALESCE(RFIN.SEQUEN,'') AS CHVFIN,
         RFIN.FLGFLX,
         ComplementoDadosFinanceiros(RFIN.ORIGEM, RFIN.CODFIL, RFIN.SEQUEN, RFIN.NUMPAR, RFIN.SUBPAR, 2) AS COMPLE,
         RFIN.TIPLAN,
         RFIN.ATU_EM,
         ComplementoDadosFinanceiros(RFIN.ORIGEM, RFIN.CODFIL, RFIN.SEQUEN, RFIN.NUMPAR, RFIN.SUBPAR, 4) AS ESTORN,
         RFIN.CODTAB AS RFIN_CODTAB,
         CAST('L' AS CHAR(1)) AS ID_OPE, -- LANCAMENTO
         CAST(CASE WHEN (RFIN.VLRLAN > 0 AND RFIN.TIPCTA = 'N') OR
                        (RFIN.VLRLAN < 0 AND RFIN.TIPCTA = 'G')
                   THEN 'D'
                   ELSE 'C'
              END AS CHAR(1)) AS TIPOPE,
         RFIN.FILDES
    FROM TT_CFG CFG,
         TR_FIN RFIN LEFT JOIN TT_CLI CLI ON RFIN.FILCLI = CLI.FILCLI
                                         AND RFIN.CODCLI = CLI.CODCLI
UNION ALL
  SELECT RFIN.FILDES AS FILREC,
         RFIN.FILCRT AS FILCTA,
         RFIN.SEQCRT AS SEQCTA,
         RFIN.TIPCRT AS TIPCTA,
         RFIN.FILCTA AS FILCRT,
         RFIN.SEQCTA AS SEQCRT,
         RFIN.TIPCTA AS TIPCRT,
         RFIN.DATLAN AS DATPGT,
         RFIN.FILUSU,
         RFIN.CODUSU,
         RFIN.FILCLI,
         RFIN.CODCLI,
         CASE RFIN.ORIGEM WHEN 'DOP' THEN
           CASE WHEN RFIN.FILCLI = CFG.VC_FILCLI AND RFIN.CODCLI = CFG.VC_CODCLI THEN 'DIVERSOS' ELSE CLI.NOMCLI
           END ELSE CLI.NOMCLI
         END AS NOMCLI,
         CASE RFIN.ORIGEM WHEN 'DOP' THEN
           CASE WHEN RFIN.FILCLI = CFG.VC_FILCLI AND RFIN.CODCLI = CFG.VC_CODCLI THEN 'DIVERSOS' ELSE CLI.ULTNOM
           END ELSE CLI.ULTNOM
         END AS ULTNOM,
         ComplementoDadosFinanceiros(RFIN.ORIGEM, RFIN.CODFIL, RFIN.SEQUEN, RFIN.NUMPAR, RFIN.SUBPAR, 1) AS OBSERV,
         RFIN.CODFIL, RFIN.SEQUEN, RFIN.NUMPAR, RFIN.SUBPAR,
         CAST(CASE RFIN.FLGFLX WHEN 'R' THEN 'Realizado' ELSE 'A Realizar' END AS VARCHAR(10)) AS FLGEST,
         RFIN.ORIGEM AS TABORI,
         CAST(CASE RFIN.ORIGEM WHEN 'REC' THEN 'Recebimentos'
                               WHEN 'CCC' THEN 'Conta Corrente'
                               WHEN 'CHR' THEN 'Cheques'
                               WHEN 'FIN' THEN 'Financeira '||CASE RFIN.TIPCTA WHEN 'N' THEN 'Numeraria' ELSE 'Gerencial' END
                               WHEN 'PTR' THEN 'Ttulos a Receber'
                               WHEN 'COM' THEN 'Compras'
                               WHEN 'DOP' THEN 'Documentos'
                               WHEN 'PAG' THEN 'Pagamentos'
                               WHEN 'TEF' THEN 'Carto'
         END AS VARCHAR(20)) AS NOMORI,
         RFIN.VLRLAN * CASE WHEN RFIN.TIPCTA||RFIN.TIPCRT='NN' THEN -1 ELSE 1 END AS VLRPGT,
         ComplementoDadosFinanceiros(RFIN.ORIGEM, RFIN.CODFIL, RFIN.SEQUEN, RFIN.NUMPAR, RFIN.SUBPAR, 3) AS DOCUME,
         COALESCE(RFIN.CODFIL,'')||COALESCE(RFIN.SEQUEN,'') AS CHVFIN,
         RFIN.FLGFLX,
         ComplementoDadosFinanceiros(RFIN.ORIGEM, RFIN.CODFIL, RFIN.SEQUEN, RFIN.NUMPAR, RFIN.SUBPAR, 2) AS COMPLE,
	      RFIN.TIPLAN,
	      RFIN.ATU_EM,
         ComplementoDadosFinanceiros(RFIN.ORIGEM, RFIN.CODFIL, RFIN.SEQUEN, RFIN.NUMPAR, RFIN.SUBPAR, 4) AS ESTORN,
         RFIN.CODTAB AS RFIN_CODTAB,
         CAST('C' AS CHAR(1)) AS ID_OPE, -- CONTRA-LANCAMENTO
         CAST(CASE WHEN (RFIN.VLRLAN > 0 AND RFIN.TIPCTA = 'N') OR
                        (RFIN.VLRLAN < 0 AND RFIN.TIPCTA = 'G')
                   THEN 'C'
                   ELSE 'D'
              END AS CHAR(1)) AS TIPOPE,
         RFIN.FILORI AS FILDES
    FROM TT_CFG CFG,
         TR_FIN RFIN LEFT JOIN TT_CLI CLI ON RFIN.FILCLI = CLI.FILCLI
                                         AND RFIN.CODCLI = CLI.CODCLI
;


/*-- SEQ 2980 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIN_GER CASCADE;

/*-- SEQ 2981 --*/
CREATE OR REPLACE VIEW TV_FIN_GER AS
  SELECT FILREC,FILCTA,SEQCTA,TIPCTA,DATPGT,FILUSU,
         CODUSU,FILCLI,CODCLI,OBSERV,CODFIL,SEQUEN,
         NUMPAR,SUBPAR,FLGEST,TABORI,NOMORI,VLRPGT,
         DOCUME,CHVFIN,FLGFLX,COMPLE
    FROM TV_FIN_TRC
 UNION ALL
  SELECT FILREC,FILCTA,SEQCTA,TIPCTA,DATPGT,FILUSU,
         CODUSU,FILCLI,CODCLI,OBSERV,CODFIL,SEQUEN,
         NUMPAR,SUBPAR,FLGEST,TABORI,NOMORI,VLRPGT,
         DOCUME,CHVFIN,FLGFLX,COMPLE
    FROM TV_FIN_COM
 UNION ALL
  SELECT FILREC,FILCTA,SEQCTA,TIPCTA,DATPGT,FILUSU,
         CODUSU,FILCLI,CODCLI,OBSERV,CODFIL,SEQUEN,
         NUMPAR,SUBPAR,FLGEST,TABORI,NOMORI,VLRPGT,
         DOCUME,CHVFIN,FLGFLX,COMPLE
    FROM TV_FIN_VEN
 UNION ALL
  SELECT FILREC,FILCTA,SEQCTA,TIPCTA,DATPGT,FILUSU,
         CODUSU,FILCLI,CODCLI,OBSERV,CODFIL,SEQUEN,
         NUMPAR,SUBPAR,FLGEST,TABORI,NOMORI,VLRPGT,
         DOCUME,CHVFIN,FLGFLX,COMPLE
    FROM TV_FIN_F_G
 UNION ALL
  SELECT FILREC,FILCTA,SEQCTA,TIPCTA,DATPGT,FILUSU,
         CODUSU,FILCLI,CODCLI,OBSERV,CODFIL,SEQUEN,
         NUMPAR,SUBPAR,FLGEST,TABORI,NOMORI,VLRPGT,
         DOCUME,CHVFIN,FLGFLX,COMPLE
    FROM TV_FIN_JDP
 UNION ALL
  SELECT FILREC,FILCTA,SEQCTA,TIPCTA,DATPGT,FILUSU,
         CODUSU,FILCLI,CODCLI,OBSERV,CODFIL,SEQUEN,
         NUMPAR,SUBPAR,FLGEST,TABORI,NOMORI,VLRPGT,
         DOCUME,CHVFIN,FLGFLX,COMPLE
    FROM TV_FIN_JDR
 UNION ALL
  SELECT FILREC,FILCTA,SEQCTA,TIPCTA,DATPGT,FILUSU,
         CODUSU,FILCLI,CODCLI,OBSERV,CODFIL,SEQUEN,
         NUMPAR,SUBPAR,FLGEST,TABORI,NOMORI,VLRPGT,
         DOCUME,CHVFIN,FLGFLX,COMPLE
    FROM TV_FIN_JDT
 UNION ALL
  SELECT FILREC,FILCTA,SEQCTA,TIPCTA,DATPGT,FILUSU,
         CODUSU,FILCLI,CODCLI,OBSERV,CODFIL,SEQUEN,
         NUMPAR,SUBPAR,FLGEST,TABORI,NOMORI,VLRPGT,
         DOCUME,CHVFIN,FLGFLX,COMPLE
    FROM TV_FIN_TXC
 UNION ALL
  SELECT FILREC,FILCTA,SEQCTA,TIPCTA,DATPGT,FILUSU,
         CODUSU,FILCLI,CODCLI,OBSERV,CODFIL,SEQUEN,
         NUMPAR,SUBPAR,FLGEST,TABORI,NOMORI,VLRPGT,
         DOCUME,CHVFIN,FLGFLX,COMPLE
    FROM TV_FIN_TXP
 ;




/*-- SEQ 2982 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIN_NUM CASCADE;

/*-- SEQ 2983 --*/
CREATE OR REPLACE VIEW TV_FIN_NUM AS
  SELECT /*+RULE*/
       DOP.CODFIL AS FILREC,
       DOP.FILCTA, DOP.SEQCTA, DOP.TIPCTA,
       DOP.DATPGT,
       min(DOP.FILUSU) AS FILUSU, 
       min(DOP.CODUSU) AS CODUSU,
       CASE count(*) WHEN 1 THEN min(COM.FILFOR)
                     ELSE ' '
       END AS FILCLI,
       CASE count(*) WHEN 1 THEN min(COM.CODFOR) 
                     ELSE ' '
       END AS CODCLI,
       min(DOP.OBSERV) AS OBSERV,
       CAST(' ' AS VARCHAR(1)) AS COMPLE,
       min(DOP.OBSINT) AS OBSINT,
       DOP.CODFIL,DOP.SEQUEN,
       TO_CHAR(' ') AS NUMPAR,
       TO_CHAR(' ') AS SUBPAR,
       min(DSTD.DESSTD) AS FLGEST,
       TO_CHAR('DOP') AS TABORI,
       TO_CHAR('Doc. de Pagamento') AS NOMORI,
       min(DOP.VLRDOC)*-1 AS VLRPGT,
       DOP.NUMDOC AS DOCUME,
       COALESCE(DOP.CODFIL,'')||COALESCE(DOP.SEQUEN,'') AS CHVFIN,
       MIN(COALESCE(DSTD.FLGFLX,'R')) AS FLGFLX
  FROM TT_DOP DOP INNER JOIN TT_PAG PAG  ON PAG.FILDOP = DOP.CODFIL  AND PAG.SEQDOP = DOP.SEQUEN
                  INNER JOIN TT_COM COM  ON PAG.CODFIL = COM.CODFIL  AND PAG.SEQUEN = COM.SEQUEN  
                  INNER JOIN TD_STD DSTD ON DOP.DOMDOP = DSTD.DOMDOP 
                                        AND DOP.STDDOP = DSTD.CODTAB
                                        AND DOP.FLGEST = DSTD.USOSTD
 WHERE DOP.FLGEST <> 'C'
 GROUP BY DOP.NUMDOC,
          DOP.CODFIL, DOP.SEQUEN,
          DOP.FILCTA, DOP.SEQCTA,
          DOP.TIPCTA, DOP.DATPGT
 UNION ALL
SELECT /*+RULE*/
       DOP.CODFIL AS FILREC,
       DOP.FILCTA, DOP.SEQCTA, DOP.TIPCTA,
       DOP.DATPGT,
       min(DOP.FILUSU) AS FILUSU, 
       min(DOP.CODUSU) AS CODUSU,
       min(DOP.FILCLI) AS FILCLI,
       min(DOP.CODCLI) AS CODCLI,
       min(DOP.OBSERV) AS OBSERV,
       CAST(' ' AS VARCHAR(1)) AS COMPLE,
       min(DOP.OBSINT) AS OBSINT,
       DOP.CODFIL,DOP.SEQUEN,
       CAST(' ' AS VARCHAR(1)) AS NUMPAR,
       CAST(' ' AS VARCHAR(1)) AS SUBPAR,
       min(DSTD.DESSTD) AS FLGEST,
       CAST('DOP' AS VARCHAR(3)) AS TABORI,
       CAST('Doc. de Pagamento' AS VARCHAR(17)) AS NOMORI,
       min(DOP.VLRDOC)*-1 AS VLRPGT,
       DOP.NUMDOC AS DOCUME,
       COALESCE(DOP.CODFIL,'')||COALESCE(DOP.SEQUEN,'') AS CHVFIN,
       MIN(COALESCE(DSTD.FLGFLX,'R')) AS FLGFLX
  FROM TT_DOP DOP INNER JOIN TD_STD DSTD ON DOP.DOMDOP = DSTD.DOMDOP 
                                        AND DOP.STDDOP = DSTD.CODTAB
                                        AND DOP.FLGEST = DSTD.USOSTD
 WHERE DOP.FLGEST <> 'C' AND DOP.CHETRO = 'T'
 GROUP BY DOP.NUMDOC,
          DOP.CODFIL, DOP.SEQUEN,
          DOP.FILCTA, DOP.SEQCTA,
          DOP.TIPCTA, DOP.DATPGT
UNION ALL
  SELECT PTR.CODFIL AS FILREC,
         PTR.FILCTA, 
         PTR.SEQCTA, 
         PTR.TIPCTA,
         PTR.DATPGT AS DATPGT,
         PTR.FILUSU, 
         PTR.CODUSU,
         TRC.FILPAR AS FILCLI, 
         TRC.CODPAR AS CODCLI,
         TRC.OBSERV,
         CAST(' ' AS VARCHAR(1)) AS COMPLE,
         CAST(' ' AS VARCHAR(1)) AS OBSINT,
         PTR.CODFIL,
         PTR.SEQUEN,
         PTR.NUMPAR,
         PTR.SUBPAR, 
         TO_CHAR('Pago') AS FLGEST,
         TO_CHAR('PTR') AS TABORI,
         TO_CHAR('Parc. Ttulos Receber') AS NOMORI,
         PTR.VLRPGT AS VLRPGT,
         COALESCE(TRC.CODSER,'')||'-'||lTrim(COALESCE(TRC.NUMNOT,''))||' '||COALESCE(PTR.NUMPAR,'')||'/'||lTrim(COALESCE(PTR.SUBPAR,'')) AS DOCUME,
         COALESCE(PTR.CODFIL,'')||COALESCE(PTR.SEQUEN,'')||COALESCE(PTR.NUMPAR,'')||COALESCE(PTR.SUBPAR ,'') AS CHVFIN,
         TO_CHAR('R') AS FLGFLX
    FROM TT_TRC TRC INNER JOIN TT_PTR PTR ON PTR.CODFIL = TRC.CODFIL AND PTR.SEQUEN = TRC.SEQUEN
   WHERE PTR.FLGEST = 'P'
     AND TRC.FLGEST NOT IN ('X','C')
UNION ALL
  SELECT PTR.CODFIL AS FILREC,
         DCTA.FILCTA,
         DCTA.SEQCTA,
         DCTA.TIPCTA,
         PTR.DATVEN AS DATPGT,
         PTR.FILUSU, 
         PTR.CODUSU,
         TRC.FILPAR AS FILCLI, 
         TRC.CODPAR AS CODCLI,
         TRC.OBSERV,
         CAST(' ' AS VARCHAR(1)) AS COMPLE,
         CAST(' ' AS VARCHAR(1)) AS OBSINT,
         PTR.CODFIL,
         PTR.SEQUEN,
         PTR.NUMPAR, 
         PTR.SUBPAR,
         TO_CHAR('Em Aberto') AS FLGEST,
         TO_CHAR('PTR') AS TABORI,
         TO_CHAR('Parc. Ttulos Receber') AS NOMORI,
         PTR.VLRPAR AS VLRPGT,
         COALESCE(TRC.CODSER,'')||'-'||lTrim(COALESCE(TRC.NUMNOT,''))||' '||COALESCE(PTR.NUMPAR,'')||'/'||lTrim(COALESCE(PTR.SUBPAR,'')) AS DOCUME,
         COALESCE(PTR.CODFIL,'')||COALESCE(PTR.SEQUEN,'')||COALESCE(PTR.NUMPAR,'')||COALESCE(PTR.SUBPAR ,'') AS CHVFIN,
         TO_CHAR('A') AS FLGFLX
    FROM TT_TRC TRC INNER JOIN TT_PTR PTR ON PTR.CODFIL = TRC.CODFIL AND PTR.SEQUEN = TRC.SEQUEN,
         TD_CTA DCTA
   WHERE PTR.FLGEST NOT IN ('X','C','P')
     AND TRC.FLGEST NOT IN ('X','C')
     AND DCTA.CFGCOL='TIPCTA_TIT_REC'
 UNION ALL
 SELECT COALESCE( REC.FILREC, REC.CODFIL ) AS FILREC,
        DCOB.FILCTA, DCOB.SEQCTA, DCOB.TIPCTA,
        REC.PAGAME AS DATPGT,
        REC.FILUSU, 
        REC.CODUSU,
        CASE WHEN DCAR.FILADM IS NULL THEN VEN.FILCLI ELSE DCAR.FILADM END AS FILCLI,
        CASE WHEN DCAR.CODADM IS NULL THEN VEN.CODCLI ELSE DCAR.CODADM END AS CODCLI,
        VEN.OBSERV,
        CAST(' ' AS VARCHAR(1)) AS COMPLE,
        CAST(' ' AS VARCHAR(1)) AS OBSINT,
        REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR,
        TO_CHAR('Pago') AS FLGEST,
        TO_CHAR('REC') AS TABORI,
        TO_CHAR('Recebimentos') AS NOMORI,
        REC.VLRPGT AS VLRPGT,
        COALESCE(VEN.CODSER,'')||'/'||COALESCE(VEN.NUMECF,'')||'-'||LTRIM(COALESCE(VEN.NUMNOT,''))||'/'||COALESCE(REC.NUMPAR,'')||CASE WHEN LTRIM(RTRIM(COALESCE(REC.SUBPAR,''))) IS NULL THEN '' ELSE '-' END||lTrim(COALESCE(REC.SUBPAR,'')) AS DOCUME,
        COALESCE(REC.CODFIL,'')||COALESCE(REC.SEQUEN,'')||COALESCE(REC.NUMPAR,'')||COALESCE(REC.SUBPAR ,'') AS CHVFIN,
        TO_CHAR('R') AS FLGFLX
    FROM TT_REC REC INNER JOIN TT_VEN VEN ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
--               LEFT OUTER JOIN TT_BON BON ON REC.CODFIL = BON.FILREC AND REC.SEQUEN = BON.SEQREC AND REC.NUMPAR = BON.NUMPAR AND REC.SUBPAR = BON.SUBPAR
               LEFT OUTER JOIN TD_CAR DCAR ON REC.CARTAO = DCAR.CODTAB
               LEFT OUTER JOIN TD_CCC DCCC ON REC.TIPCCC = DCCC.CODTAB 
                    INNER JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD
   WHERE REC.FLGEST = 'P'
     AND REC.SEQCHE IS NULL
     AND REC.FLGEST NOT IN ('X','C')
     AND VEN.FLGEST NOT IN ('C')
UNION ALL
 SELECT COALESCE( REC.FILREC, REC.CODFIL ) AS FILREC,
        DCOB.FILCTA, DCOB.SEQCTA, DCOB.TIPCTA,
        REC.DATVEN AS DATPGT,
        REC.FILUSU, REC.CODUSU,
        CASE WHEN DCAR.FILADM IS NULL THEN VEN.FILCLI ELSE DCAR.FILADM END AS FILCLI,
        CASE WHEN DCAR.CODADM IS NULL THEN VEN.CODCLI ELSE DCAR.CODADM END AS CODCLI,
        VEN.OBSERV,
        CAST(' ' AS VARCHAR(1)) AS COMPLE,
        CAST(' ' AS VARCHAR(1)) AS OBSINT,
        REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR,
        TO_CHAR('Em Aberto') AS FLGEST,
        TO_CHAR('REC') AS TABORI,
        TO_CHAR('Recebimentos') AS NOMORI,
        REC.VLRPAR AS VLRPGT,
        COALESCE(VEN.CODSER,'')||'/'||COALESCE(VEN.NUMECF,'')||'-'||LTRIM(COALESCE(VEN.NUMNOT,''))||'/'||COALESCE(REC.NUMPAR,'')||CASE WHEN LTRIM(RTRIM(COALESCE(REC.SUBPAR,''))) IS NULL THEN '' ELSE '-' END||lTrim(COALESCE(REC.SUBPAR,'')) AS DOCUME,
        COALESCE(REC.CODFIL,'')||COALESCE(REC.SEQUEN,'')||COALESCE(REC.NUMPAR,'')||COALESCE(REC.SUBPAR ,'')AS CHVFIN,
        TO_CHAR('A') AS FLGFLX
    FROM TT_REC REC INNER JOIN TT_VEN VEN ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN
--               LEFT OUTER JOIN TT_BON BON ON REC.CODFIL = BON.FILREC AND REC.SEQUEN = BON.SEQREC AND REC.NUMPAR = BON.NUMPAR AND REC.SUBPAR = BON.SUBPAR
               LEFT OUTER JOIN TD_CAR DCAR ON REC.CARTAO = DCAR.CODTAB
               LEFT OUTER JOIN TD_CCC DCCC ON REC.TIPCCC = DCCC.CODTAB 
                    INNER JOIN TD_COB DCOB ON DCOB.CODTAB = REC.PORTAD
   WHERE REC.SEQCHE IS NULL
     AND REC.FLGEST NOT IN ('X','C','P')
     AND VEN.FLGEST NOT IN ('C')
 UNION ALL
  SELECT CCC.CODFIL AS FILREC,
         DCCC.FILCCC AS FILCTA, DCCC.SEQCCC AS SEQCTA, DCCC.TIPCCC AS TIPCTA,
         CCC.DATOPE AS DATPGT,
         CCC.FILUSU, CCC.CODUSU,
         CCC.FILCLI, CCC.CODCLI,
         CCC.COMPLE AS OBSERV,
         CAST(' ' AS VARCHAR(1)) AS COMPLE,
         CAST(' ' AS VARCHAR(1)) AS OBSINT,
         CCC.CODVEN AS CODFIL,
         CCC.SEQVEN AS SEQUEN,CCC.NUMPAR,CCC.SUBPAR,
         TO_CHAR('Pago') AS FLGEST,
         TO_CHAR('CCC') AS TABORI,
         TO_CHAR('Conta Corrente') AS NOMORI,
         CCC.VLRLAN AS VLRPGT,
         CCC.NUMDOC AS DOCUME,
         COALESCE(CCC.CODFIL,'')||COALESCE(CCC.SEQUEN ,'')AS CHVFIN,
         TO_CHAR('R') AS FLGFLX
    FROM TT_CCC CCC   INNER JOIN TD_CCC DCCC ON CCC.TIPCCC = DCCC.CODTAB
   WHERE CCC.STATUS <> 'F'                                                           -- Ignora lancamentos de Faturamento, pois gera tambem TT_REC
 UNION ALL
  SELECT FIN.CODFIL AS FILREC,
         FIN.FILNUM AS FILCTA, 
         FIN.SEQNUM AS SEQCTA, 
         FIN.TIPNUM AS TIPCTA,
         FIN.DATOPE AS DATPGT,
         FIN.FILUSU,
         FIN.CODUSU,
         CFG.VC_FILCLI AS FILCLI, 
         CFG.VC_CODCLI AS CODCLI,
         FIN.OBSERV,
         CAST(' ' AS VARCHAR(1)) AS COMPLE,
         CAST(' ' AS VARCHAR(1)) AS OBSINT,
         FIN.CODFIL, 
         FIN.SEQUEN, 
         TO_CHAR(' 1') AS NUMPAR, 
         TO_CHAR(' 0') AS SUBPAR,
         TO_CHAR('Pago') AS FLGEST,
         TO_CHAR('F_N') AS TABORI,
         TO_CHAR('Financeira Numeraria') AS NOMORI,
         FIN.VLRMOV AS VLRPGT,
         FIN.NUMDOC AS DOCUME,
         COALESCE(FIN.CODFIL,'')||COALESCE(FIN.SEQUEN ,'') AS CHVFIN,
         TO_CHAR('R') AS FLGFLX
    FROM TT_FIN FIN,
         TT_CFG CFG
 UNION ALL
  SELECT CHR.CODFIL AS FILREC,
         DCOB.FILCTA, DCOB.SEQCTA, DCOB.TIPCTA,
         CHR.PAGAME AS DATPGT,
         CHR.FILUSU, CHR.CODUSU,
         COALESCE( CLI.FILCLI, CFG.VC_FILCLI ) AS FILCLI,
         COALESCE( CLI.CODCLI, CFG.VC_CODCLI ) AS CODCLI,
         TO_CHAR(' ') AS OBSERV,
         CAST(' ' AS VARCHAR(1)) AS COMPLE,
         CAST(' ' AS VARCHAR(1)) AS OBSINT,
         CHR.CODFIL, 
         CHR.SEQUEN, 
         TO_CHAR(' 1') AS NUMPAR, 
         TO_CHAR(' 0') AS SUBPAR,
         CASE CHR.FLGEST WHEN 'A' THEN 'A Depositar'
                         WHEN 'U' THEN 'Custodiado'
                         WHEN 'B' THEN 'Cobrado'
                         WHEN 'C' THEN 'Compensado'
                         WHEN 'D' THEN 'Depositado'
                         WHEN 'P' THEN 'Pr-Descontado'
                         WHEN 'S' THEN 'Substitudo'
                         WHEN 'V' THEN 'Devolvido'
                         WHEN 'X' THEN 'Estornado'
                         WHEN 'R' THEN 'Em circulacao'
                         WHEN 'I' THEN 'Incobrvel'
         END AS FLGEST,
         TO_CHAR('CHR') AS TABORI,
         TO_CHAR('Cheques') AS NOMORI,
         COALESCE(CHR.VLRORI,CHR.VLRCHE)-COALESCE(CHR.VLRDIF,0) AS VLRPGT,
         RTRIM(LTRIM(COALESCE(CHR.CODBCO,'')))||'-'||
         RTRIM(LTRIM(COALESCE(CHR.CODAGE,'')))||'-'||
         RTRIM(LTRIM(COALESCE(CHR.NUMCON,'')))||'-'||
         RTRIM(LTRIM(COALESCE(CHR.NUMCHE,''))) AS DOCUME,
         COALESCE(CHR.CODFIL,'')||COALESCE(CHR.SEQUEN,'') AS CHVFIN,
         TO_CHAR('R') AS FLGFLX
    FROM TT_CHR CHR LEFT OUTER JOIN TT_CLI CLI  ON CHR.NUMDOC = CLI.NUMDOC
                         INNER JOIN TD_COB DCOB ON CHR.PORTAD = DCOB.CODTAB,
         TT_CFG CFG
   WHERE CHR.FLGEST IN ('P','C','B','I')
UNION ALL
  SELECT CHR.CODFIL AS FILREC,
         DCOB.FILCTA, DCOB.SEQCTA, DCOB.TIPCTA,
         CHR.DATVEN AS DATPGT,			
         CHR.FILUSU, CHR.CODUSU,
         COALESCE( CLI.FILCLI, CFG.VC_FILCLI ) AS FILCLI,
         COALESCE( CLI.CODCLI, CFG.VC_CODCLI ) AS CODCLI,
         TO_CHAR(' ') AS OBSERV,
         CAST(' ' AS VARCHAR(1)) AS COMPLE,
         CAST(' ' AS VARCHAR(1)) AS OBSINT,
         CHR.CODFIL, 
         CHR.SEQUEN, 
         TO_CHAR(' 1') AS NUMPAR, 
         TO_CHAR(' 0') AS SUBPAR,
         CASE CHR.FLGEST WHEN 'A' THEN 'A Depositar'
                         WHEN 'U' THEN 'Custodiado'
                         WHEN 'B' THEN 'Cobrado'
                         WHEN 'C' THEN 'Compensado'
                         WHEN 'D' THEN 'Depositado'
                         WHEN 'P' THEN 'Pr-Descontado'
                         WHEN 'S' THEN 'Substitudo'
                         WHEN 'V' THEN 'Em Compensao '
                         WHEN 'X' THEN 'Estornado'
                         WHEN 'R' THEN 'Em circulacao'
                         WHEN 'I' THEN 'Incobrvel'
         END AS FLGEST,
         TO_CHAR('CHR') AS TABORI,
         TO_CHAR('Cheques') AS NOMORI,
         COALESCE(CHR.VLRORI,CHR.VLRCHE) AS VLRPGT,
         RTRIM(LTRIM(COALESCE(CHR.CODBCO,'')))||'-'||
         RTRIM(LTRIM(COALESCE(CHR.CODAGE,'')))||'-'||
         RTRIM(LTRIM(COALESCE(CHR.NUMCON,'')))||'-'||
         RTRIM(LTRIM(COALESCE(CHR.NUMCHE,''))) AS DOCUME,
         COALESCE(CHR.CODFIL,'')||COALESCE(CHR.SEQUEN,'') AS CHVFIN,         
         TO_CHAR('A') AS FLGFLX
    FROM TT_CHR CHR LEFT OUTER JOIN TT_CLI CLI ON CHR.NUMDOC = CLI.NUMDOC
                         INNER JOIN TD_COB DCOB ON CHR.PORTAD = DCOB.CODTAB,
         TT_CFG CFG
   WHERE CHR.FLGEST NOT IN ('X','P','C')
 UNION ALL
   SELECT CHR.CODFIL AS FILREC,
         DCOB.FILCTA, DCOB.SEQCTA, DCOB.TIPCTA,
         CHR.DATVEN AS DATPGT,
         CHR.FILUSU, CHR.CODUSU,
         COALESCE( CLI.FILCLI, CFG.VC_FILCLI ) AS FILCLI,
         COALESCE( CLI.CODCLI, CFG.VC_CODCLI ) AS CODCLI,
         TO_CHAR(' ') AS OBSERV,
         CAST(' ' AS VARCHAR(1)) AS COMPLE,
         CAST(' ' AS VARCHAR(1)) AS OBSINT,
         CHR.CODFIL, 
         CHR.SEQUEN, 
         TO_CHAR(' 1') AS NUMPAR, 
         TO_CHAR(' 0') AS SUBPAR,
         'Devolvido ' AS FLGEST,					
         TO_CHAR('CHR') AS TABORI,
         TO_CHAR('Cheques') AS NOMORI,
         COALESCE(CHR.VLRORI,CHR.VLRCHE)*-1 AS VLRPGT,
         RTRIM(LTRIM(COALESCE(CHR.CODBCO,'')))||'-'||
         RTRIM(LTRIM(COALESCE(CHR.CODAGE,'')))||'-'||
         RTRIM(LTRIM(COALESCE(CHR.NUMCON,'')))||'-'||
         RTRIM(LTRIM(COALESCE(CHR.NUMCHE,''))) AS DOCUME,
         COALESCE(CHR.CODFIL,'')||COALESCE(CHR.SEQUEN,'') AS CHVFIN,         
         TO_CHAR('A') AS FLGFLX
    FROM TT_CHR CHR LEFT OUTER JOIN TT_CLI CLI ON CHR.NUMDOC = CLI.NUMDOC
                         INNER JOIN TD_COB DCOB ON CHR.PORTAD = DCOB.CODTAB,
         TT_CFG CFG
   WHERE CHR.FLGEST = ('V')
 UNION ALL
  SELECT IDF.CODLOJ AS FILREC,
         DCCC.FILCCC AS FILCTA, DCCC.SEQCCC AS SEQCTA, DCCC.TIPCCC AS TIPCTA,
         COALESCE(LIM.DATA,AGORA()) AS DATPGT,
         USU.FILUSU,
         USU.CODUSU,
         LIM.FILCLI,
         LIM.CODCLI,
         TO_CHAR(' ') AS OBSERV,
         CAST(' ' AS VARCHAR(1)) AS COMPLE,
         CAST(' ' AS VARCHAR(1)) AS OBSINT,
         LIM.FILCLI AS CODFIL,
         TO_CHAR(' ') AS SEQUEN,
         TO_CHAR(' ') as NUMPAR, 
         TO_CHAR(' ') as SUBPAR,
         TO_CHAR('Ativo') AS FLGEST,
         TO_CHAR('LIM') as  TABORI,
         TO_CHAR('Limite de C/C') as NOMORI,
         LIM.VSALDO*-1 AS VLRPGT,
         TO_CHAR(' ') AS DOCUME,
         COALESCE(LIM.FILCLI,'')||COALESCE(LIM.CODCLI,'')||COALESCE(TO_CHAR(LIM.TIPCCC),'') AS CHVFIN,
         TO_CHAR('A') as FLGFLX
    FROM (SELECT VSALDO, FILCLI, CODCLI, TIPCCC,
                 PROXIMOFATURAMENTO(FILCLI,CODCLI,TIPCCC,agora(),null) AS DATA
            FROM TT_LIM
           WHERE VSALDO <> 0) LIM INNER JOIN TD_CCC DCCC ON LIM.TIPCCC = DCCC.CODTAB
         ,TT_IDF IDF
         ,(select filusu, codusu 
            from tt_usu 
           where 1=1
           LIMIT 1     ) USU
 UNION ALL
  SELECT COM.CODFIL AS FILREC,
         DCTA.FILCTA, 
         DCTA.SEQCTA,
         DCTA.TIPCTA,
         PAG.DATVEN    AS DATPGT,
         PAG.FILUSU, 
         PAG.CODUSU,
         COM.FILFOR AS FILCLI,
         COM.CODFOR AS CODCLI,
         COM.OBSERV,
         CAST(' ' AS VARCHAR(1)) AS COMPLE,
         CAST(' ' AS VARCHAR(1)) AS OBSINT,
         PAG.CODFIL,PAG.SEQUEN, PAG.NUMPAR, PAG.SUBPAR,
         TO_CHAR('Em Aberto') AS FLGEST,
         TO_CHAR('PAG') AS TABORI,
         TO_CHAR('Parc. Compras') AS NOMORI,
         PAG.VLRPAR*-1 AS VLRPGT,
         COALESCE(COM.CODSER,'')||'/'||lTrim(COALESCE(COM.SUBSER,''))||'-'||lTrim(COALESCE(COM.NUMNOT,'')) AS DOCUME,
         COALESCE(PAG.CODFIL,'')||COALESCE(PAG.SEQUEN ,'') AS CHVFIN,
         TO_CHAR('A') AS FLGFLX
    FROM TT_PAG PAG INNER JOIN TT_COM COM ON PAG.CODFIL = COM.CODFIL AND PAG.SEQUEN = COM.SEQUEN,
         TD_CTA DCTA
   WHERE DCTA.CFGCOL='TIPCTA_FOR_PAG'
     AND PAG.FLGEST NOT IN ('C','X','P')
     AND COM.FLGEST <> 'D'           
     AND COM.TIPPAR = 'F'
 UNION ALL
  SELECT COM.CODFIL AS FILREC,
         DCTA.FILCTA, 
         DCTA.SEQCTA,
         DCTA.TIPCTA,
         PAG.DATVEN    AS DATPGT,
         PAG.FILUSU, 
         PAG.CODUSU,
         COM.FILFOR AS FILCLI, 
         COM.CODFOR AS CODCLI,
         COM.OBSERV,
         CAST(' ' AS VARCHAR(1)) AS COMPLE,
         CAST(' ' AS VARCHAR(1)) AS OBSINT,
         PAG.CODFIL,PAG.SEQUEN, PAG.NUMPAR, PAG.SUBPAR,
         TO_CHAR('Em Aberto') AS FLGEST,
         TO_CHAR('PAG') AS TABORI,
         TO_CHAR('Parc. Fretes') AS NOMORI,
         PAG.VLRPAR*-1 AS VLRPGT,
         COALESCE(COM.CODSER,'')||'/'||lTrim(COALESCE(COM.SUBSER,''))||'-'||lTrim(COALESCE(COM.NUMNOT,'')) AS DOCUME,
         COALESCE(PAG.CODFIL,'')||COALESCE(PAG.SEQUEN ,'')AS CHVFIN,
         TO_CHAR('A') AS FLGFLX
    FROM TT_COM COM INNER JOIN TT_PAG PAG ON PAG.CODFIL = COM.CODFIL AND PAG.SEQUEN = COM.SEQUEN,
         TD_CTA DCTA
   WHERE DCTA.CFGCOL='TIPCTA_FRE_PAG'
     AND PAG.FLGEST NOT IN ('C','X','P')
     AND COM.FLGEST <> 'D'           
     AND COM.TIPPAR = 'T'
 UNION ALL
  SELECT COM.CODFIL AS FILREC,
         DCTA.FILCTA, 
         DCTA.SEQCTA,
         DCTA.TIPCTA,
         PAG.DATVEN    AS DATPGT,
         PAG.FILUSU, 
         PAG.CODUSU,
         COM.FILFOR AS FILCLI, 
         COM.CODFOR AS CODCLI,
         COM.OBSERV,
         COM.OBSFAT AS COMPLE,
         CAST(' ' AS VARCHAR(1)) AS OBSINT,
         PAG.CODFIL,PAG.SEQUEN, PAG.NUMPAR, PAG.SUBPAR,
         TO_CHAR('Em Aberto') AS FLGEST,
         TO_CHAR('PAG') AS TABORI,
         TO_CHAR('Parc. Titulos') AS NOMORI,
         PAG.VLRPAR*-1 AS VLRPGT,
         COALESCE(COM.CODSER,'')||'/'||lTrim(COALESCE(COM.SUBSER,''))||'-'||lTrim(COALESCE(COM.NUMNOT,'')) AS DOCUME,
         COALESCE(PAG.CODFIL,'')||COALESCE(PAG.SEQUEN ,'') AS CHVFIN,
         TO_CHAR('A') AS FLGFLX
    FROM TT_PAG PAG INNER JOIN TT_COM COM ON PAG.CODFIL = COM.CODFIL AND PAG.SEQUEN = COM.SEQUEN,
         TD_CTA DCTA
   WHERE DCTA.CFGCOL='TIPCTA_TIT_PAG'
     AND PAG.FLGEST NOT IN ('C','X','P')
     AND COM.FLGEST <> 'D'           
     AND COM.TIPPAR IS NULL
;


/*-- SEQ 2984 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_50C CASCADE;

/*-- SEQ 2985 --*/
CREATE OR REPLACE VIEW TV_FIS_50C AS
  SELECT DATAOK, CODFIL, COALESCE(CHAVE ,'')|| COALESCE(CGC ,'')|| COALESCE(IE ,'')|| COALESCE(DATA ,'')|| COALESCE(UF ,'')||
         COALESCE(MODELO ,'')|| COALESCE(SERIE ,'')|| COALESCE(NUMNOT ,'')|| COALESCE(CFOP ,'')||
         COALESCE(EMITENTE ,'')|| COALESCE(TO_CHAR(VLRLIQ) ,'')|| COALESCE(TO_CHAR(BASICM) ,'')|| COALESCE(TO_CHAR(VLRICM) ,'')||
         COALESCE(TO_CHAR(BASINT) ,'')|| COALESCE(OUTRAS ,'')|| COALESCE(ICMITE ,'')|| COALESCE(FLGEST ,'')AS LINHA
    FROM (SELECT TO_CHAR('50') AS CHAVE,
           I50.DATAOK,
           I50.CODFIL,
           CASE WHEN SUBSTR(COALESCE(I50.NATURE,'    '),1,1) = '3'
                THEN '00000000000000'
                ELSE LPAD(I50.NUMDOC,14,'0')
            END AS CGC,
           RPAD(I50.INSEST, 14, ' ') AS IE,
           TO_CHAR(I50.DATAOK, 'YYYYMMDD') AS DATA,
           CASE WHEN SUBSTR(COALESCE(I50.NATURE,'    '),1,1) = '3'
                THEN 'EX'
                ELSE I50.UFNOTA
            END AS UF,
           CASE I50.TIPPAR WHEN 'T' THEN '08'
                                    ELSE COALESCE(LPAD(RTRIM(LTRIM(COALESCE(I50.MODNOT,'01'))),2,'0'),'  ')
           END AS MODELO,
           COALESCE(RPAD(RTRIM(LTRIM(COALESCE(COALESCE(I50.CODSER,' '),' '))),3,' '),'   ') AS SERIE,
           /* PROBLEMA => NO BANCO, NUMNOT TEM 9 POSICOES, MAS A EXPORTACAO SO ACEITA 6 ! */
           SUBSTR(LPAD(RTRIM(LTRIM(I50.NUMNOT)),9,'0'),-6,6) AS NUMNOT,
           RPAD(SUBSTR(COALESCE(I50.NATURE,'    '),1,4),4,' ') AS CFOP,
           TO_CHAR('T') AS EMITENTE,
           LPAD(to_char(COALESCE(ROUND((COALESCE(I50.VLRLIQ,0)) * 100), 0)), 13, '0') AS VLRLIQ,
           REPLACE(LPAD(to_char(ROUND(COALESCE(I50.BASICM,0) * 100, 0)), 13, '0'),'-','0') AS BASICM,
           REPLACE(LPAD(to_char(ROUND(COALESCE(I50.VLRICM,0) * 100, 0)), 13, '0'),'-','0') AS VLRICM,
           LPAD(to_char(ROUND(COALESCE(COALESCE(I50.BASINT,0)*(100+((COALESCE(I50.DESCON,0)/NVLZ(I50.VLRTOT,1))*100)),0),0)),13,'0') AS BASINT,
           LPAD(to_char(ROUND(COALESCE(I50.OUTRAS,0) * 100,0)),13,'0') AS OUTRAS,
           LPAD(to_char(ROUND(COALESCE(I50.ICMITE*100,0),0)),4,'0') AS ICMITE,
           CASE I50.FLGEST WHEN 'D' THEN 'S'
                                    ELSE 'N'
           END AS FLGEST
      FROM TV_FIS_50CINTERNO I50
     WHERE I50.TIPNOT IN ('A','N')
     ) TAB
    GROUP BY DATAOK, CODFIL, CHAVE, CGC, IE, DATA, UF, MODELO, SERIE,
             NUMNOT, CFOP, EMITENTE, VLRLIQ, BASICM, VLRICM, BASINT, OUTRAS, ICMITE, FLGEST
 ;


/*-- SEQ 2986 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_50V CASCADE;

/*-- SEQ 2987 --*/
CREATE OR REPLACE VIEW TV_FIS_50V AS
SELECT /*+RULE*/
    DATAOK,
    CODFIL,
    COALESCE(CHAVE ,'')|| COALESCE(CGC ,'')|| COALESCE(IE ,'')|| COALESCE(DATA ,'')||
    COALESCE(UF ,'')|| COALESCE(MODELO ,'')|| COALESCE(SERIE ,'')|| COALESCE(NUMNOT ,'')|| COALESCE(CFOP ,'')||
    COALESCE(EMITENTE ,'')|| COALESCE(VLRLIQ ,'')|| COALESCE(BASICM ,'')|| COALESCE(VLRICM ,'')||
    COALESCE(BASINT ,'')|| COALESCE(OUTRAS ,'')|| COALESCE(PERICM ,'')|| COALESCE(FLGEST ,'') AS LINHA
 FROM (
    SELECT TO_CHAR('50') AS CHAVE,
           I50.DATAOK, I50.CODFIL,
           LPAD(TRIM(I50.NUMDOC),14,'0') AS CGC,
           RPAD(TRIM(I50.INSEST),14,' ') AS IE,
           TO_CHAR(I50.DATAOK, 'YYYYMMDD') AS DATA,
           I50.UFNOTA AS UF,
           COALESCE(LPAD(RTRIM(LTRIM(COALESCE(I50.MODNOT,'01'))),2,'0'),'  ') AS MODELO,
           COALESCE(RPAD(RTRIM(LTRIM(COALESCE(I50.CODSER,' '))),3,' '),'   ') AS SERIE,
           SUBSTR(LPAD(RTRIM(LTRIM(to_char(I50.NUMNOT))),8,'0'),-6,6) AS NUMNOT,
           SUBSTR(I50.NATURE,1,4) AS CFOP,
           TO_CHAR('P') AS EMITENTE,
           LPAD(to_char(COALESCE(ROUND(ABS(COALESCE(I50.VLRLIQ,0))*100,0),0)),13,'0') AS VLRLIQ,
           LPAD(to_char(COALESCE(ROUND(ABS(COALESCE(I50.BASICM,0))*100,0),0)),13,'0') AS BASICM,
           LPAD(to_char(COALESCE(ROUND(ABS(COALESCE(I50.VLRICM,0))*100,0),0)),13,'0') AS VLRICM,
           LPAD(to_char(COALESCE(ROUND(ABS(COALESCE(I50.BASINT,0))*100,0),0)),13,'0') AS BASINT,
           LPAD(to_char(COALESCE(ROUND(ABS(COALESCE(I50.OUTRAS,0))*100,0),0)),13,'0') AS OUTRAS,
           LPAD(to_char(ROUND(COALESCE(I50.PERICM*100,0),0)),4,'0') AS PERICM,
           CASE I50.FLGEST WHEN 'C' THEN 'S'
                                    ELSE 'N'
           END AS FLGEST
      FROM TV_FIS_50VINTERNO I50
    ) TAB
;


/*-- SEQ 2988 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_51C CASCADE;

/*-- SEQ 2989 --*/
CREATE OR REPLACE VIEW TV_FIS_51C AS
SELECT to_date(null,'') as DATAOK, CAST(null AS CHAR(3)) as CODFIL, cast( null as text )
 AS LINHA from dual
 ;





/*-- SEQ 2990 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_51V CASCADE;

/*-- SEQ 2991 --*/
CREATE OR REPLACE VIEW TV_FIS_51V AS
SELECT to_date(null,'') as DATAOK, CAST(null AS CHAR(3)) as CODFIL, cast( null as text )
 AS LINHA from dual
;


/*-- SEQ 2992 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_53V CASCADE;

/*-- SEQ 2993 --*/
CREATE OR REPLACE VIEW TV_FIS_53V AS
SELECT DATAOK, CODFIL, COALESCE(CHAVE ,'')|| COALESCE(CGC ,'')|| COALESCE(IE ,'')|| 
       COALESCE(TO_CHAR(DATA) ,'')|| COALESCE(UF ,'')|| COALESCE(MODELO ,'')|| COALESCE(SERIE ,'')|| COALESCE(NUMNOT ,'')||
       COALESCE(CFOP ,'')|| COALESCE(EMITENTE ,'')|| COALESCE(BASUBS ,'')|| COALESCE(SUBSTT ,'')|| COALESCE(OUTRAS ,'') || 
       COALESCE(FLGEST ,'')|| COALESCE(BRANCOS ,'') AS LINHA
 FROM (
SELECT TO_CHAR('53') AS CHAVE,
       VEN.DATHOR AS DATAOK, 
       VEN.CODFIL AS CODFIL,
       LPAD(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(COALESCE(LTRIM(RTRIM(COALESCE(COALESCE(ENDE.NUMDOC,CLI.NUMDOC),VIN.NUMDOC))),'0'),',',''),'.',''),'/',''),'-',''),' ',''),14,'0') AS CGC,
       RPAD(REPLACE(REPLACE(REPLACE(REPLACE(COALESCE(CASE CLI.FLGTIP WHEN 0 THEN 'ISENTO'
                                                                            ELSE COALESCE(ENDE.INSEST,CLI.INSEST,VIN.INSEST)
                                                      END, ' '), ',', ''), '.', ''), '/', ''), '-', ''), 14, ' ') AS IE,
       TO_CHAR(VEN.DATHOR, 'YYYYMMDD') AS DATA,
       CASE WHEN ISNULL(COALESCE(LTRIM(MUN.CODIGO),''))='T' THEN FIL.UFLOJA
                                                            ELSE MUN.SIGEST
       END AS UF,
       COALESCE(RPAD(RTRIM(LTRIM(COALESCE(CASE WHEN FIS.MODNOT IS NULL THEN NAT.NATMOD ELSE FIS.MODNOT END,' '))),2,' '),'  ') AS MODELO,
       COALESCE(RPAD(RTRIM(LTRIM(COALESCE(FIS.SEREXP,' '))),3,' '),'   ') AS SERIE,
       SUBSTR(LPAD(RTRIM(LTRIM(to_char(VEN.NUMNOT))),8,'0'),-6,6) AS NUMNOT,
       RPAD(MAX(SUBSTR(NaturezaVenda( VEN.UFLOJA, IVE.ICMTIP, COALESCE(IVE.NATFIS,NAT.NATDEN), COALESCE(IVE.NATFIS,NAT.NATFOR)),1,4)),4,' ') AS CFOP,
       TO_CHAR('P') AS EMITENTE,
       LPAD(to_char(SUM(CASE WHEN COALESCE(IVE.TIP001,'M') = 'M' 
                      AND IVE.ICMTIP = '3' 
                     THEN ABS(ROUND((IVE.ITELIQ - IVE.VLR002 - IVE.REDVLR) * 100, 0))
                     ELSE 0
                END)), 13, '0') AS BASUBS,
       LPAD(to_char(SUM(CASE WHEN COALESCE(IVE.TIP001,'M') = 'M'
                      AND IVE.ICMTIP = '3' 
					  AND VEN.SUBSTT > 0 
                     THEN ABS(ROUND( CASE WHEN VEN.VLRLIQ > VEN.VLRNOT 
                                          THEN IVE.VLRMOV * 100 * ((VEN.VLRNOT - COALESCE(VEN.SUBSTT,0) - COALESCE(VEN.REDTOT,0)) / VEN.VLRNOT)
                                          ELSE IVE.VLRMOV * 100 * ((VEN.VLRLIQ - COALESCE(VEN.SUBSTT,0) - COALESCE(VEN.REDTOT,0)) / VEN.VLRNOT)
                                      END, 0))
                     ELSE 0
                END)), 13, '0') AS SUBSTT,
       LPAD(to_char(ROUND(ABS(COALESCE(0 /* DESPESAS ACESSORIAS */, 0) * 100), 0)), 13, '0') AS OUTRAS,
       CASE VEN.FLGEST WHEN 'C' THEN 'S' ELSE 'N' END AS FLGEST,
       LPAD(' ',30,' ') AS BRANCOS
  FROM TW_VEN_FIS VEN INNER JOIN TW_IVE_FIS IVE ON VEN.CODFIL = IVE.CODFIL
                                               AND VEN.SEQUEN = IVE.SEQUEN
                                               AND VEN.CODSER = IVE.CODSER
                                               AND VEN.NUMNOT = IVE.NUMNOT
                      INNER JOIN TT_FIS FIS ON VEN.CODSER = FIS.CODSER AND VEN.NUMECF = FIS.SUBSER
                      INNER JOIN TT_CLI CLI ON VEN.FILCLI = CLI.FILCLI AND VEN.CODCLI = CLI.CODCLI
                 LEFT OUTER JOIN TT_CLI VIN ON VIN.FILCLI = CLI.FILVIN AND VIN.CODCLI = CLI.CODVIN
                 LEFT OUTER JOIN TD_NAT NAT ON VEN.CODNAT = NAT.CODTAB
                 LEFT OUTER JOIN TT_END ENDE ON VEN.FILCLI = ENDE.FILCLI 
                                            AND VEN.CODCLI = ENDE.CODCLI 
                                            AND VEN.FILFAT = ENDE.CODFIL
                                            AND VEN.ENDFAT = ENDE.NUMEND
                      INNER JOIN TD_FIL FIL ON VEN.CODFIL = FIL.CODFIL
                 LEFT OUTER JOIN TT_MUN MUN ON ENDE.CODCID = MUN.CODIGO  
 WHERE VEN.CODSER   <> 'CF'                    
   AND VEN.FLGEST   <> 'C'                     
   AND VEN.SUBSTT > 0                          
   AND VEN.TRIBUT = 'T'
   AND VEN.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL) 
   AND FIS.ORIGEM    = 'V'                     
   AND FIS.EXPORT    = 'T'   
 GROUP BY VEN.DATHOR, VEN.CODFIL, ENDE.NUMDOC, CLI.NUMDOC, VIN.NUMDOC, CLI.FLGTIP, ENDE.INSEST, CLI.INSEST, VIN.INSEST,
          VEN.DATHOR, MUN.CODIGO, FIL.UFLOJA, MUN.SIGEST, FIS.MODNOT, FIS.SEREXP, VEN.NUMNOT, VEN.VLRLIQ, VEN.VLRNOT,
          VEN.UFLOJA, NAT.NATDEN, VEN.SUBSTT, VEN.REDTOT, VEN.FLGEST, NAT.NATMOD
) TAB
;


/*-- SEQ 2994 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_61V CASCADE;

/*-- SEQ 2995 --*/
CREATE OR REPLACE VIEW TV_FIS_61V AS
SELECT /*+RULE*/
    TAB.DATAOK,
    TAB.CODFIL,
    COALESCE(TAB.CHAVE ,'')||LPAD(' ',28,' ')||COALESCE(TAB.DATVEN,'')||
    COALESCE(TAB.MODELO,'')||COALESCE(TAB.SERIE ,'')||LPAD(' ',2,' ')||
    COALESCE(TAB.NUMINI,'')||COALESCE(TAB.NUMFIM,'')||
    COALESCE(TAB.VLRLIQ,'')||COALESCE(TAB.BASICM,'')||COALESCE(TAB.VLRICM,'')||
    COALESCE(TAB.BASINT,'')||COALESCE(TAB.OUTRAS,'')||COALESCE(TAB.PERICM,'')||LPAD(' ',1,' ') AS LINHA
 FROM (
    SELECT TO_CHAR('61') AS CHAVE,
           INT.DATAOK, 
           INT.CODFIL,
           TO_CHAR(INT.DATAOK, 'YYYYMMDD') AS DATVEN,
           INT.MODNOT AS MODELO,
           COALESCE(RPAD(RTRIM(LTRIM(COALESCE(INT.CODSER,' '))),3,' '),'   ') AS SERIE,
           SUBSTR(LPAD(RTRIM(LTRIM(to_char(MIN(INT.NUMNOT)))),8,'0'),-6,6) AS NUMINI,
           SUBSTR(LPAD(RTRIM(LTRIM(to_char(MAX(INT.NUMNOT)))),8,'0'),-6,6) AS NUMFIM,
           LPAD(to_char(COALESCE(ROUND(ABS(SUM(COALESCE(INT.VLRLIQ,0)))*100,0),0)),13,'0') AS VLRLIQ,
           LPAD(to_char(COALESCE(ROUND(ABS(SUM(COALESCE(INT.BASICM,0)))*100,0),0)),13,'0') AS BASICM,
           LPAD(to_char(COALESCE(ROUND(ABS(SUM(COALESCE(INT.VLRICM,0)))*100,0),0)),12,'0') AS VLRICM,
           LPAD(to_char(COALESCE(ROUND(ABS(SUM(COALESCE(INT.BASINT,0)))*100,0),0)),13,'0') AS BASINT,
           LPAD(to_char(COALESCE(ROUND(ABS(SUM(COALESCE(INT.OUTRAS,0)))*100,0),0)),13,'0') AS OUTRAS,
           LPAD(to_char(ROUND(COALESCE(INT.PERICM*100,0),0)),4,'0') AS PERICM
      FROM TV_FIS_61VINTERNO INT
     GROUP BY INT.CODFIL, INT.MODNOT, INT.CODSER, INT.DATAOK, INT.PERICM,
              TO_CHAR(INT.DATAOK, 'YYYYMMDD') -- Colocado porque sem isso ocorre erro na ordenao.
    ) TAB
;


/*-- SEQ 2996 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_70C CASCADE;

/*-- SEQ 2997 --*/
CREATE OR REPLACE VIEW TV_FIS_70C AS
SELECT DATAOK, CODFIL, COALESCE(CHAVE ,'')|| COALESCE(CGC ,'')|| COALESCE(IE ,'')|| COALESCE(DATA ,'')|| COALESCE(UF ,'')|| COALESCE(MODELO ,'')|| COALESCE(SERIE ,'')|| COALESCE(SUBSERIE ,'')||
       COALESCE(NUMNOT ,'')|| COALESCE(CFOP ,'')|| COALESCE(to_char(VLRLIQ) ,'')|| COALESCE(BASICM ,'')|| COALESCE(to_char(VLRICM) ,'')|| COALESCE(to_char(BASINT) ,'')|| COALESCE(OUTRAS ,'')|| COALESCE(TIPOFRETE ,'')|| COALESCE(FLGEST ,'')AS LINHA
FROM (SELECT to_char('70') AS CHAVE,
       I70.DATAOK, I70.CODFIL,
       LPAD(I70.NUMDOC,14,'0') AS CGC,
       RPAD(I70.INSEST,14,' ') AS IE,
       TO_CHAR(I70.DATAOK, 'YYYYMMDD') AS DATA,
       COALESCE(I70.UFNOTA,'  ') AS UF,
       to_char(coalesce(I70.MODNOT, '08')) AS MODELO,
       COALESCE(RPAD(RTRIM(LTRIM(COALESCE(COALESCE(I70.CODSER,' '),' '))),1,' '),' ') AS SERIE,
       COALESCE(RPAD(RTRIM(LTRIM(COALESCE(I70.SUBSER,' '))),2,' '),'  ') AS SUBSERIE,
       /* PROBLEMA => NO BANCO, NUMNOT TEM 9 POSICOES, MAS A EXPORTACAO SO ACEITA 6 ! */
       SUBSTR(LPAD(RTRIM(LTRIM(to_char(I70.NUMNOT))),9,'0'),-6,6) AS NUMNOT,
       RPAD(SUBSTR(COALESCE(I70.NATURE,'   '),1,4),4,' ') AS CFOP,
       LPAD(to_char(COALESCE(ROUND(I70.VLRLIQ*100,0),0)),13,'0') AS VLRLIQ,
       LPAD(to_char(ROUND(COALESCE(I70.BASICM*100,0),0)),14,'0') AS BASICM,
       LPAD(to_char(ROUND(COALESCE(I70.VLRICM*100,0),0)),14,'0') AS VLRICM,
       LPAD(to_char(ROUND(COALESCE(I70.BASINT*100,0),0)),14,'0') AS BASINT,
       LPAD(to_char(ROUND(COALESCE(I70.OUTRAS*100,0),0)),14,'0') AS OUTRAS,
       to_char('2') AS TIPOFRETE, 
       CASE I70.FLGEST WHEN 'D' THEN 'S'
                                ELSE 'N'
       END AS FLGEST
  FROM TV_FIS_70CINTERNO I70 INNER JOIN TT_CLI CFO ON CFO.FILCLI = I70.FILFOR AND CFO.CODCLI = I70.CODFOR
    LEFT OUTER JOIN TT_CLI VIN ON VIN.FILCLI = CFO.FILVIN AND VIN.CODCLI = CFO.CODVIN
 WHERE I70.TIPNOT IN ('A','N')
) TAB
;


/*-- SEQ 2998 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_75 CASCADE;

/*-- SEQ 2999 --*/
CREATE OR REPLACE VIEW TV_FIS_75 AS
SELECT * 
FROM (
    SELECT DATAOK, CODFIL, 
               COALESCE(CHAVE ,'')|| COALESCE(DATINI ,'')|| COALESCE(DATFIM ,'') || COALESCE(CODMAT ,'')|| COALESCE(NCM ,'')|| COALESCE(DESMAT ,'')||
               COALESCE(UNIDAD ,'')|| COALESCE(to_char(PERIPI) ,'')|| COALESCE(to_char(PERICM) ,'')|| 
               COALESCE(to_char(REDITE) ,'')|| COALESCE(BASSUB ,'') AS LINHA
      FROM (SELECT TRUNC(MAX(F75.DATAOK)) AS DATAOK,
                   INV.CODFIL,
                   to_char('75') AS CHAVE,
                   TO_CHAR(MIN(INV.DATINI), 'YYYYMMDD') AS DATINI,
                   TO_CHAR(MAX(INV.DATFIN), 'YYYYMMDD') AS DATFIM,
                   GRA.FILMAT||RPAD(REPLACE(GRA.SEQUEN,' ','0'),10,'0')||' ' AS CODMAT,
                   RPAD(COALESCE(PRO.CODNCM, ' '), 8, ' ') AS NCM,
                   REPLACE(RPAD(COALESCE(PRO.DESMAT ,'')|| ' ' || COALESCE(PRO.ESPMAT ,'')|| ' ' || RTRIM(COALESCE(DIV.NOMITE,'')) ||'/'||COALESCE(SUB.NOMITE,''), 53),'"',' ') AS DESMAT,
                   RPAD(UPPER(COALESCE(MED.UNIMED,'  ')),6,' ') AS UNIDAD,
                   LPAD(to_char(ROUND(COALESCE(IPI.RESIPI,0)*100,0)),5,'0') AS PERIPI,
                   LPAD(to_char(ROUND(COALESCE(ICM.RESICM,0)*100,0)),4,'0') AS PERICM,
                   LPAD(to_char(ROUND(COALESCE(IRE.ICMSRE,0)*100,0)),5,'0') AS REDITE,
    --               COALESCE(TRI.CODTRI,'000') AS SITTRI,
                   LPAD(to_char(SUM(COALESCE(F75.BASSUB,0))), 13, '0') AS BASSUB
              FROM TT_GRA GRA INNER JOIN TT_PRO PRO ON GRA.FILMAT = PRO.FILMAT AND GRA.CODMAT = PRO.CODMAT
                              INNER JOIN TW_FIS_75 F75 ON GRA.FILMAT = F75.FILMAT
                                                       AND GRA.CODMAT = F75.CODMAT
                                                       AND GRA.CODCOR = F75.CODCOR
                                                       AND GRA.CODTAM = F75.CODTAM
                              INNER JOIN TT_DIV DIV ON GRA.CODCOR = DIV.CODITE
                              INNER JOIN TT_SUB SUB ON GRA.CODTAM = SUB.CODITE
                              INNER JOIN TT_IUF IUF ON PRO.FILMAT = IUF.FILMAT AND PRO.CODMAT = IUF.CODMAT
                              INNER JOIN TD_FIL FIL ON FIL.UFLOJA = IUF.ESTADO AND FIL.REGESP = IUF.REGESP
                              INNER JOIN TW_INV_FIS INV ON INV.CODFIL = FIL.CODFIL
                              INNER JOIN TD_MED MED ON GRA.UNIDAD = MED.CODTAB
                         LEFT OUTER JOIN TD_IRE IRE ON IUF.REDALI = IRE.CODTAB
                         LEFT OUTER JOIN TD_TRI TRI ON IUF.CODTRI = TRI.CODTAB
                         LEFT OUTER JOIN TD_ICM ICM ON IUF.RESICM = ICM.CODTAB
                         LEFT OUTER JOIN TD_IPI IPI ON PRO.RESIPI = IPI.CODTAB
                   WHERE INV.SESSION_ID = (SELECT USERENV('SESSIONID') FROM DUAL)
                     AND ( ISNOTNULL(COALESCE(F75.CODFIL,'')||COALESCE(F75.CODFIL,''))='T' OR
                         (((INV.TEM_PRECOM = 'T' AND GRA.PRECOM > 0) OR
                           (INV.TEM_CUSREP = 'T' AND GRA.CUSREP > 0)) AND CustoMedio(INV.CODFIL,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,1,INV.DATFIN) > 0))
                   GROUP BY INV.CODFIL,
                            GRA.FILMAT||RPAD(REPLACE(GRA.SEQUEN,' ','0'),10,'0'),
                            LPAD(to_char(ROUND(COALESCE(IPI.RESIPI,0)*100,0)),5,'0'),
                            LPAD(to_char(ROUND(COALESCE(ICM.RESICM,0)*100,0)),4,'0'),
                            LPAD(to_char(ROUND(COALESCE(IRE.ICMSRE,0)*100,0)),5,'0'),
    --                        COALESCE(TRI.CODTRI,'000'),
                            REPLACE(RPAD(COALESCE(PRO.DESMAT ,'')|| ' ' || COALESCE(PRO.ESPMAT ,'')|| ' ' || RTRIM(COALESCE(DIV.NOMITE,'')) ||'/'||COALESCE(SUB.NOMITE,''), 53),'"',' '),
                            RPAD(UPPER(COALESCE(MED.UNIMED,'  ')),6,' '),
                            RPAD(COALESCE(PRO.CODNCM, ' '), 8, ' ')
              ) TAB
  ) INT
  ORDER BY SUBSTR(LINHA,19,14), SUBSTR(LINHA,3,8)
;


/*-- SEQ 3000 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FPV CASCADE;

/*-- SEQ 3001 --*/
CREATE OR REPLACE VIEW TV_FPV AS
SELECT *
  FROM TV_FPV_TOT
;


/*-- SEQ 3002 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FPV_GRA CASCADE;

/*-- SEQ 3003 --*/
CREATE OR REPLACE VIEW TV_FPV_GRA AS
SELECT *
  FROM TV_FPV_GRA_TOT
 ;


/*-- SEQ 3004 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FPV_PXF CASCADE;

/*-- SEQ 3005 --*/
CREATE OR REPLACE VIEW TV_FPV_PXF AS
SELECT *
  FROM TV_FPV_PXF_TOT
 ;


/*-- SEQ 3006 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FPV_SIM CASCADE;

/*-- SEQ 3007 --*/
CREATE OR REPLACE VIEW TV_FPV_SIM AS
SELECT *
  FROM TV_FPV_SIM_TOT
 ;


/*-- SEQ 3008 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PAP CASCADE;

/*-- SEQ 3009 --*/
CREATE OR REPLACE VIEW TV_PAP AS
-- Esta view apresenta a Previso de Contas a Pagar, baseado
-- no parcelamento (TT_PAG) das compras (TT_COM) e dos
-- pedidos autorizados... (TT_PED e FLGEST='2')
--
-- Para os pedidos autorizados que possuem entrega parcial, o
-- saldo dos itens restantes (sum(TT_IPE.VLR...*...))  rateado
-- proporcionalmente (/TT_PED.VLRTOT) sobre o parcelamento original. 
-- So selecionados  os itens de pedidos em aberto (TT_IPE e FLGEST='A')
-- dos pedidos autorizados (TT_PED e FLGEST='2')
--
-- Do (TT_PAG), somente as parcelas programadas, autorizadas e abertas 
--  que so consideradas (FLGEST in ['1','2','A'])
--
-- Ped.FLGEST = '2' /* Autorizado */
--
SELECT Pag.CODFIL, 
       pag.SEQUEN,
       COM.NUMNOT as NUMDOC, 
       Pag.NUMPAR, 
       Pag.SUBPAR, 
       Pag.DATVEN,
       Pag.DATPRE,
       Pag.VLRPAR, 
       coalesce( pag.vlrpre,
                CalcPag( COM.CODMOE, PAG.VLRPAR, COALESCE(PAG.DATPRE,PAG.DATVEN), COM.VLTXJU, 
                         COM.INCOJU, COM.INTPJU, COM.VLTXMU, COM.INTPMU, 
                         GREATEST( AGORA(), COALESCE(PAG.DATPRE,PAG.DATVEN) ), 1 ) ) AS VLRCAL,
       pag.vlrpre,
       ltrim(rtrim(COM.CODSER))
       ||CASE WHEN COM.SUBSER IS NULL THEN ''
              ELSE '/'||ltrim(rtrim(COM.SUBSER))
       END 
       ||'/'||ltrim(rtrim(COM.NUMNOT))
       ||CASE WHEN PAG.NUMPAR IS NULL THEN ''
              ELSE ' '||ltrim(rtrim(Pag.NUMPAR))
         END
       ||CASE WHEN PAG.SUBPAR IS NULL THEN ''
              ELSE '-'||ltrim(rtrim(Pag.SUBPAR))
         END AS DOCUME,
       COM.CODSER, COM.SUBSER, 
       trunc(COM.DATCMP) AS COMPET, COM.FILFOR, COM.CODFOR, COM.TIPPAR,
       COALESCE(COM.VLTXJU,0) AS VLTXJU, COALESCE(COM.VLTXMU,0) AS VLTXMU, 
       COM.INCOJU, COM.INTPJU, COM.INTPMU, 
       CAST('E'   AS CHAR(1)) AS STATUS, PAG.FLGFLU,
       CAST('PAG' AS CHAR(3)) AS TABORI,
       CASE COALESCE(COM.TIPPAR,'.') WHEN 'F' THEN CFOR.FILCTA
                                     WHEN 'T' THEN CFRE.FILCTA
                                     WHEN '.' THEN CTIT.FILCTA
                                              ELSE NULL 
       END AS FILCTA, 
       CASE COALESCE(COM.TIPPAR,'.') WHEN 'F' THEN CFOR.SEQCTA
                                     WHEN 'T' THEN CFRE.SEQCTA
                                     WHEN '.' THEN CTIT.SEQCTA
                                     ELSE NULL 
       END AS SEQCTA, 
       CASE COALESCE(COM.TIPPAR,'.') WHEN 'F' THEN CFOR.TIPCTA
                                     WHEN 'T' THEN CFRE.TIPCTA
                                     WHEN '.' THEN CTIT.TIPCTA
                                     ELSE NULL 
       END AS TIPCTA,
       Rtf2txt(TRIM(COM.OBSERV)) AS OBSERV
  FROM TD_CTA CFOR, 
       TD_CTA CFRE, 
       TD_CTA CTIT, 
       TT_COM COM INNER JOIN TT_PAG PAG ON Pag.SEQUEN = COM.SEQUEN
                                       AND Pag.CODFIL = COM.CODFIL
                                       AND Pag.FLGEST IN ('1','2','A') /* Programado,Autorizado,Aberto */
 WHERE CFOR.cfgcol='TIPCTA_FOR_PAG'
   AND CFRE.cfgcol='TIPCTA_FRE_PAG'
   AND CTIT.cfgcol='TIPCTA_TIT_PAG'
UNION ALL
SELECT Cpe.CODFIL, 
       cast(null as char(10)) as sequen,
       Cpe.NUMPED AS NUMDOC, 
       Cpe.NUMPAR, 
       CAST('  ' AS CHAR(2)) AS SUBPAR, 
       Cpe.DATVEN, 
       to_date(NULL,'dd/mm/yyyy') AS DATPRE,
       (SELECT SUM((IPE.VLRITE*(1+(IPE.IPIITE/100)))) AS PERITE
        FROM TT_IPE IPE
        WHERE IPE.CODFIL = PED.CODFIL
          AND IPE.NUMPED = PED.NUMPED
          AND IPE.FLGEST = 'A'
        GROUP BY IPE.CODFIL, IPE.NUMPED)/ PED.VLRTOT * Cpe.VLRPAR AS VLRPAR,
       to_number(NULL) AS VLRCAL,
       to_number(NULL) AS VLRPRE,
       Cpe.CODFIL||'/'||ltrim(rtrim(Cpe.NUMPED))||' '||Cpe.NUMPAR AS DOCUME, 
       null AS CODSER, 
       null AS SUBSER,
       trunc(Ped.DATENT) AS COMPET, 
       Ped.FILFOR, 
       Ped.CODFOR, 
       Ped.TIPFOR AS TIPPAR,
       0 AS VLTXJU, 
       0 AS VLTXMU, 
       null AS INCOJU, 
       null AS INTPJU, 
       null AS INTPMU, 
       CAST('P'   AS CHAR(1))     AS STATUS,
       CAST('T'   AS VARCHAR(1)) AS FLGFLU,
       CAST('PED' AS CHAR(3))     AS TABORI,
       null as FILCTA, NULL AS SEQCTA, NULL AS TIPCTA, Rtf2txt(TRIM(PED.OBSERV)) AS OBSERV
FROM  TT_PED PED INNER JOIN TT_CPE CPE ON PED.CODFIL = CPE.CODFIL
                                      AND PED.NUMPED = CPE.NUMPED
WHERE PED.FLGEST = '2'
UNION ALL
-- RFMP 70984
-- relacionar os cheques que foram emitidos mas que ainda no foram compensados
SELECT DOP.CODFIL, 
       CAST(NULL AS CHAR(10)) AS SEQUEN,
       CAST(NULL AS CHAR(8)) AS NUMDOC, 
       CAST('  ' AS CHAR(2)) AS NUMPAR, 
       CAST('  ' AS CHAR(2)) AS SUBPAR, 
       TRUNC(DOP.DATPGT) AS DATVEN, -- data do vencimento
       TO_DATE(NULL,'DD/MM/YYYY') AS DATPRE, -- data prevista
       DOP.VLRDOC AS VLRPAR,
       TO_NUMBER(NULL) AS VLRCAL,
       TO_NUMBER(NULL) AS VLRPRE,
       DOP.NUMDOC AS DOCUME,
       null AS CODSER, 
       null AS SUBSER, 
       TRUNC(DOP.DATINC) AS COMPET, 
       CAST('' AS CHAR(3)) AS FILFOR, 
       CAST('' AS CHAR(6)) AS CODFOR, 
       null AS TIPPAR,
       0 AS VLTXJU, 
       0 AS VLTXMU, 
       null AS INCOJU, 
       null AS INTPJU, 
       null AS INTPMU, 
       CAST('P'   AS CHAR(1))     AS STATUS, -- previsto
       CAST('T'   AS VARCHAR(1)) AS FLGFLU,
       CAST('DOP' AS CHAR(3))     AS TABORI,
       DOP.FILCTA, 
       DOP.SEQCTA, 
       DOP.TIPCTA,
       Rtf2txt(TRIM(DOP.OBSERV)) AS OBSERV
  FROM TT_DOP DOP INNER JOIN TD_STD STD ON DOP.DOMDOP = STD.DOMDOP AND DOP.STDDOP = STD.CODTAB AND DOP.FLGEST = STD.USOSTD
 WHERE STD.FLGFLX = 'A'
 ;


/*-- SEQ 3010 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_BASF CASCADE;

/*-- SEQ 3011 --*/
CREATE OR REPLACE VIEW TV_PED_BASF AS
  SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA 
    FROM TV_PED_BASF_ITP 
   UNION ALL 
  SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA 
    FROM TV_PED_BASF_AE1 
   UNION ALL 
  SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA 
    FROM TV_PED_BASF_AE2_AE3  
 ;


/*-- SEQ 3012 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_DIMED CASCADE;

/*-- SEQ 3013 --*/
CREATE OR REPLACE VIEW TV_PED_DIMED AS
  SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA
    FROM TV_PED_DIMED_0
   UNION ALL
  SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA
    FROM TV_PED_DIMED_1
   UNION ALL
  SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA
    FROM TV_PED_DIMED_2
   UNION ALL
  SELECT CNT.CODFIL, CNT.NUMPED, CNT.FILFOR, CNT.CODFOR, CNT.TIPFOR, CNT.DATENV, 99999 AS NUMITE, REFFOR, 
         (SELECT '9'||LPAD(TO_CHAR(COUNT(*) + 2),7,'0')
            FROM TV_PED_DIMED_2
           WHERE CODFIL = CNT.CODFIL
             AND NUMPED = CNT.NUMPED
             AND FILFOR = CNT.FILFOR
             AND CODFOR = CNT.CODFOR) AS LINHA
    FROM TV_PED_DIMED_0 CNT
;


/*-- SEQ 3014 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_DIMPER CASCADE;

/*-- SEQ 3015 --*/
CREATE OR REPLACE VIEW TV_PED_DIMPER AS
  SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA
    FROM TV_PED_DIMPER_1
   UNION ALL
  SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, '/' AS LINHA
    FROM TV_PED_DIMPER_1
   UNION ALL
  SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA
    FROM TV_PED_DIMPER_2
   UNION ALL
  SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, '#' AS LINHA
    FROM TV_PED_DIMPER_1
;


/*-- SEQ 3016 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_PANARELLO CASCADE;

/*-- SEQ 3017 --*/
CREATE OR REPLACE VIEW TV_PED_PANARELLO AS
 SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA
   FROM TV_PED_PANARELLO_1
  UNION ALL
 SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA
   FROM TV_PED_PANARELLO_3
  UNION ALL
 SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA
   FROM TV_PED_PANARELLO_4
  UNION ALL
 SELECT PD5.CODFIL, PD5.NUMPED, PD5.FILFOR, PD5.CODFOR, PD5.TIPFOR, PD5.DATENV, 9999 AS NUMITE, REFFOR, 
        '05'||
        (SELECT LPAD(TO_CHAR(MAX(NUMITE)),4,'0')
           FROM TV_PED_PANARELLO_4
          WHERE CODFIL = PD5.CODFIL
            AND NUMPED = PD5.NUMPED
            AND FILFOR = PD5.FILFOR
            AND CODFOR = PD5.CODFOR)||/*QUANTIDADE DE ITENS*/
        (SELECT LPAD(TO_CHAR(ROUND(SUM(QTDPED) * 100,0)),10,'0')
           FROM TV_PED_PANARELLO_4
          WHERE CODFIL = PD5.CODFIL
            AND NUMPED = PD5.NUMPED
            AND FILFOR = PD5.FILFOR
            AND CODFOR = PD5.CODFOR)/*QUANTIDADE DE ITENS*/
        ||'                             '    
   FROM TV_PED_PANARELLO_1 PD5
;


/*-- SEQ 3018 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_PROFARMA CASCADE;

/*-- SEQ 3019 --*/
CREATE OR REPLACE VIEW TV_PED_PROFARMA AS
 SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA
   FROM TV_PED_PROFARMA_1
  UNION ALL
 SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA
   FROM TV_PED_PROFARMA_2
  UNION ALL
 SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, '3' AS LINHA
   FROM TV_PED_PROFARMA_2
  UNION ALL
 SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, '4' AS LINHA
   FROM TV_PED_PROFARMA_2
  UNION ALL
 SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA
   FROM TV_PED_PROFARMA_5
  UNION ALL
 SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA
   FROM TV_PED_PROFARMA_6
  UNION ALL
 SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA
   FROM TV_PED_PROFARMA_7
  UNION ALL
 SELECT PD8.CODFIL, PD8.NUMPED, PD8.FILFOR, PD8.CODFOR, PD8.TIPFOR, PD8.DATENV, PD8.NUMITE, REFFOR, 
        '8'||
        (SELECT LPAD(TO_CHAR(ROUND(MAX(NUMITE),0)),10,'0')
           FROM TV_PED_PROFARMA_7
          WHERE CODFIL = PD8.CODFIL
            AND NUMPED = PD8.NUMPED
            AND FILFOR = PD8.FILFOR
            AND CODFOR = PD8.CODFOR)
   FROM TV_PED_PROFARMA_1 PD8
 ;


/*-- SEQ 3020 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PED_SANTACRUZ CASCADE;

/*-- SEQ 3021 --*/
CREATE OR REPLACE VIEW TV_PED_SANTACRUZ AS
   SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA
     FROM TV_PED_SANTACRUZ_1
    UNION ALL
   SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA
     FROM TV_PED_SANTACRUZ_2
    UNION ALL
   SELECT CODFIL, NUMPED, FILFOR, CODFOR, TIPFOR, DATENV, NUMITE, REFFOR, LINHA
     FROM TV_PED_SANTACRUZ_3
;








/*-- SEQ 3022 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_REL_ANA_PRE CASCADE;

/*-- SEQ 3023 --*/
CREATE OR REPLACE VIEW TV_REL_ANA_PRE AS
  SELECT TIPO, CODFIL, GRUPO, DATOPE,
         VLRCOMDIA, VLRCOMMES, VLRCOMANO, QTDCOMDIA, QTDCOMMES, QTDCOMANO,
         VLRVENDIA, VLRVENMES, VLRVENANO, QTDVENDIA, QTDVENMES, QTDVENANO
    FROM (SELECT CASE WHEN PRO.DEPART = -3 THEN 'Combustiveis' ELSE 'Outros'    END AS TIPO,
                 SAL.CODFIL,
                 CASE WHEN PRO.DEPART = -3 THEN PRO.DESMAT||' '||PRO.ESPMAT ELSE DDEP.DESDEP END AS GRUPO,
                 DAT.DATOPE,
                 SUM((SELECT SUM(ICO.VLRCMG)
                        FROM TT_ICO ICO
                       WHERE ICO.SITMOV = 'N'
                         AND ICO.CODFIL = SAL.CODFIL
                         AND ICO.FILMAT = SAL.FILMAT
                         AND ICO.CODMAT = SAL.CODMAT
                         AND ICO.CODCOR = SAL.CODCOR
                         AND ICO.CODTAM = SAL.CODTAM
                         AND ICO.CODMUL = SAL.CODMUL
                         AND ICO.COM_DATOPE BETWEEN DAT.DATOPE AND TO_DATE(TO_CHAR( DAT.DATOPE,'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS'))) AS VLRCOMDIA,
                 SUM((SELECT SUM(ICO.VLRCMG)
                        FROM TT_ICO ICO
                       WHERE ICO.SITMOV = 'N'
                         AND ICO.CODFIL = SAL.CODFIL
                         AND ICO.FILMAT = SAL.FILMAT
                         AND ICO.CODMAT = SAL.CODMAT
                         AND ICO.CODCOR = SAL.CODCOR
                         AND ICO.CODTAM = SAL.CODTAM
                         AND ICO.CODMUL = SAL.CODMUL
                         AND ICO.COM_DATOPE BETWEEN TRUNC_DATE('MONTH',DAT.DATOPE) AND TO_DATE(TO_CHAR( LAST_DAY(DAT.DATOPE),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS'))) AS VLRCOMMES,
                 SUM((SELECT SUM(ICO.VLRCMG)
                        FROM TT_ICO ICO
                       WHERE ICO.SITMOV = 'N'
                         AND ICO.CODFIL = SAL.CODFIL
                         AND ICO.FILMAT = SAL.FILMAT
                         AND ICO.CODMAT = SAL.CODMAT
                         AND ICO.CODCOR = SAL.CODCOR
                         AND ICO.CODTAM = SAL.CODTAM
                         AND ICO.CODMUL = SAL.CODMUL
                         AND ICO.COM_DATOPE BETWEEN TRUNC_DATE('YEAR',DAT.DATOPE) AND TO_DATE( '31/12/'||TO_CHAR(DAT.DATOPE, 'YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS'))) AS VLRCOMANO,
                 SUM((SELECT SUM(CASE IVE.SAL_CM WHEN 0 THEN 0 ELSE IVE.TOTCMG / IVE.SAL_CM END * IVE.QTDMOV)
                        FROM TT_IVE IVE inner join TT_VEN VEN on (VEN.CODFIL = IVE.CODFIL and VEN.SEQUEN = IVE.SEQUEN)
                       WHERE IVE.SITMOV = 'N'
                         AND IVE.CODFIL = SAL.CODFIL
                         AND IVE.FILMAT = SAL.FILMAT
                         AND IVE.CODMAT = SAL.CODMAT
                         AND IVE.CODCOR = SAL.CODCOR
                         AND IVE.CODTAM = SAL.CODTAM
                         AND IVE.CODMUL = SAL.CODMUL
                         AND VEN.LANVEN = 'T'
                         AND IVE.VEN_DATHOR BETWEEN DAT.DATOPE AND TO_DATE(TO_CHAR( DAT.DATOPE,'DD/MM/YYYY')||'23:59:59','DD/MM/YYYY HH24:MI:SS'))) AS VLRVENDIA,
                 SUM((SELECT SUM(CASE IVE.SAL_CM WHEN 0 THEN 0 ELSE IVE.TOTCMG / IVE.SAL_CM END * IVE.QTDMOV)
                        FROM TT_IVE IVE inner join TT_VEN VEN on (VEN.CODFIL = IVE.CODFIL and VEN.SEQUEN = IVE.SEQUEN)
                       WHERE IVE.SITMOV = 'N'
                         AND IVE.CODFIL = SAL.CODFIL
                         AND IVE.FILMAT = SAL.FILMAT
                         AND IVE.CODMAT = SAL.CODMAT
                         AND IVE.CODCOR = SAL.CODCOR
                         AND IVE.CODTAM = SAL.CODTAM
                         AND IVE.CODMUL = SAL.CODMUL
                         AND VEN.LANVEN = 'T'
                         AND IVE.VEN_DATHOR BETWEEN TRUNC_DATE('MONTH',DAT.DATOPE) AND TO_DATE(TO_CHAR( LAST_DAY(DAT.DATOPE),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS'))) AS VLRVENMES,
                 SUM((SELECT SUM(CASE IVE.SAL_CM WHEN 0 THEN 0 ELSE IVE.TOTCMG / IVE.SAL_CM END * IVE.QTDMOV)
                        FROM TT_IVE IVE inner join TT_VEN VEN on (VEN.CODFIL = IVE.CODFIL and VEN.SEQUEN = IVE.SEQUEN)
                       WHERE IVE.SITMOV = 'N'
                         AND IVE.CODFIL = SAL.CODFIL
                         AND IVE.FILMAT = SAL.FILMAT
                         AND IVE.CODMAT = SAL.CODMAT
                         AND IVE.CODCOR = SAL.CODCOR
                         AND IVE.CODTAM = SAL.CODTAM
                         AND IVE.CODMUL = SAL.CODMUL
                         AND VEN.LANVEN = 'T'                         
                         AND IVE.VEN_DATHOR BETWEEN TRUNC_DATE('YEAR',DAT.DATOPE) AND TO_DATE( '31/12/'||TO_CHAR(DAT.DATOPE, 'YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS'))) AS VLRVENANO,
                 SUM((SELECT SUM(MOV.QTDCOM)
                        FROM TR_MOV MOV
                       WHERE MOV.CODMAT = SAL.CODMAT
                         AND MOV.FILMAT = SAL.FILMAT
                         AND MOV.CODCOR = SAL.CODCOR
                         AND MOV.CODTAM = SAL.CODTAM
                         AND MOV.CODFIL = SAL.CODFIL
                         AND MOV.CODMUL = SAL.CODMUL
                         AND MOV.DATMOV BETWEEN DAT.DATOPE AND TO_DATE(TO_CHAR( DAT.DATOPE,'DD/MM/YYYY')||'23:59:59','DD/MM/YYYY HH24:MI:SS'))) AS QTDCOMDIA,
                 SUM((SELECT SUM(MOV.QTDCOM)
                        FROM TR_MOV MOV
                       WHERE MOV.CODMAT = SAL.CODMAT
                         AND MOV.FILMAT = SAL.FILMAT
                         AND MOV.CODCOR = SAL.CODCOR
                         AND MOV.CODTAM = SAL.CODTAM
                         AND MOV.CODFIL = SAL.CODFIL
                         AND MOV.CODMUL = SAL.CODMUL
                         AND MOV.DATMOV BETWEEN TRUNC_DATE('MONTH',DAT.DATOPE) AND TO_DATE(TO_CHAR( LAST_DAY(DAT.DATOPE),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS'))) AS QTDCOMMES,
                 SUM((SELECT SUM(MOV.QTDCOM)
                        FROM TR_MOV MOV
                       WHERE MOV.CODMAT = SAL.CODMAT
                         AND MOV.FILMAT = SAL.FILMAT
                         AND MOV.CODCOR = SAL.CODCOR
                         AND MOV.CODTAM = SAL.CODTAM
                         AND MOV.CODFIL = SAL.CODFIL
                         AND MOV.CODMUL = SAL.CODMUL
                         AND MOV.DATMOV BETWEEN TRUNC_DATE('YEAR',DAT.DATOPE) AND TO_DATE( '31/12/'||TO_CHAR(DAT.DATOPE, 'YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS'))) AS QTDCOMANO,
                 SUM((SELECT SUM(MOV.QTDVEN)
                        FROM TR_MOV MOV
                       WHERE MOV.CODMAT = SAL.CODMAT
                         AND MOV.FILMAT = SAL.FILMAT
                         AND MOV.CODCOR = SAL.CODCOR
                         AND MOV.CODTAM = SAL.CODTAM
                         AND MOV.CODFIL = SAL.CODFIL
                         AND MOV.CODMUL = SAL.CODMUL
                         AND MOV.DATMOV BETWEEN DAT.DATOPE AND TO_DATE(TO_CHAR( DAT.DATOPE,'DD/MM/YYYY')||'23:59:59','DD/MM/YYYY HH24:MI:SS'))) AS QTDVENDIA,
                 SUM((SELECT SUM(MOV.QTDVEN)
                        FROM TR_MOV MOV
                       WHERE MOV.CODMAT = SAL.CODMAT
                         AND MOV.FILMAT = SAL.FILMAT
                         AND MOV.CODCOR = SAL.CODCOR
                         AND MOV.CODTAM = SAL.CODTAM
                         AND MOV.CODFIL = SAL.CODFIL
                         AND MOV.CODMUL = SAL.CODMUL
                         AND MOV.DATMOV BETWEEN TRUNC_DATE('MONTH',DAT.DATOPE) AND TO_DATE(TO_CHAR( LAST_DAY(DAT.DATOPE),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS'))) AS QTDVENMES,
                 SUM((SELECT SUM(MOV.QTDVEN)
                        FROM TR_MOV MOV
                       WHERE MOV.CODMAT = SAL.CODMAT
                         AND MOV.FILMAT = SAL.FILMAT
                         AND MOV.CODCOR = SAL.CODCOR
                         AND MOV.CODTAM = SAL.CODTAM
                         AND MOV.CODFIL = SAL.CODFIL
                         AND MOV.CODMUL = SAL.CODMUL
                         AND MOV.DATMOV BETWEEN TRUNC_DATE('YEAR',DAT.DATOPE) AND TO_DATE( '31/12/'||TO_CHAR(DAT.DATOPE, 'YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS'))) AS QTDVENANO
            FROM TT_DAT DAT CROSS JOIN TT_SAL SAL 
                 INNER JOIN TT_PRO PRO ON PRO.FILMAT = SAL.FILMAT AND
                                          PRO.CODMAT = SAL.CODMAT
                 INNER JOIN TD_DEP DDEP ON (PRO.DEPART = DDEP.CODTAB)                 
           WHERE DDEP.DEPATI = 'T'
        --   AND DAT.DATOPE = TO_DATE('14/03/2005', 'DD/MM/YYYY')
           GROUP BY CASE WHEN PRO.DEPART = -3 THEN 'Combustiveis' ELSE 'Outros'    END,
                    SAL.CODFIL,
                    CASE WHEN PRO.DEPART = -3 THEN PRO.DESMAT||' '||PRO.ESPMAT     ELSE DDEP.DESDEP END,
                    DAT.DATOPE) TAB
   WHERE  ( (COALESCE(VLRCOMDIA*QTDCOMDIA,0)+COALESCE(VLRCOMMES*QTDCOMMES,0)+COALESCE(VLRCOMANO*QTDCOMANO,0)) +
            (COALESCE(VLRVENDIA*QTDVENDIA,0)+COALESCE(VLRVENMES*QTDVENMES,0)+COALESCE(VLRVENANO*QTDVENANO,0))) > 0
;


/*-- SEQ 3024 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_REL_FIN CASCADE;

/*-- SEQ 3025 --*/
CREATE OR REPLACE VIEW TV_REL_FIN AS
SELECT 1 AS ORDEM,
       TITECT AS GRUCTA,
       CAST(' ' AS VARCHAR(20)) AS SUBGRU,
       CASE WHEN CTA.NIVCRI = 1 THEN CAST('OUTROS' AS VARCHAR(250)) ELSE CTA.TITCTA END AS NOMCTA ,
       DAT.DATOPE,
       SUM( (SELECT SUM(FIN.VLRPGT)
             FROM TV_FIN FIN
             WHERE FIN.FILCTA = CTA.CODFIL
               AND FIN.SEQCTA = CTA.SEQUEN
               AND FIN.TIPCTA = CTA.TIPCTA
               AND FIN.DATPGT <= DAT.DATOPE) ) AS TOTACU,
       SUM( (SELECT SUM(FIN.VLRPGT)
             FROM TV_FIN FIN
             WHERE FIN.FILCTA = CTA.CODFIL
               AND FIN.SEQCTA = CTA.SEQUEN
               AND FIN.TIPCTA = CTA.TIPCTA
               AND FIN.DATPGT BETWEEN DAT.DATOPE 
                          AND TO_DATE(TO_CHAR( DAT.DATOPE,'DD/MM/YYYY' )||'23:59:59','DD/MM/YYYY HH24:MI:SS') ) ) AS TOTDIA
FROM TT_DAT DAT,
     TT_CTA CTA INNER JOIN TT_ECT ECT ON ECT.CODFIL = CTA.FILECT 
                                     AND ECT.SEQUEN = CTA.SEQECT
WHERE COALESCE(CTA.NIVCRI,0) <> 0
GROUP BY ECT.TITECT, CASE WHEN CTA.NIVCRI = 2 THEN CAST('OUTROS' AS VARCHAR(250)) ELSE CTA.TITCTA END, DAT.DATOPE,
         CTA.NIVCRI, CTA.TITCTA
UNION ALL
-- PARCELAS DE CONTAS A RECEBER
SELECT 2 AS ORDEM,
       MIN(CAST('CONTAS A RECEBER' AS VARCHAR(250))) AS GRUCTA,
       MIN(CAST('FATURAS' AS VARCHAR(20))) AS SUBGRU,
       MIN(CAST(DSER.DESSER ||' '||CASE WHEN REC.DATVEN < AGORA()
                                        THEN 'VENCIDAS'
                                        ELSE 'A VENCER'
                                    END AS VARCHAR(250))) AS NOMCTA,
       DAT.DATOPE,
       SUM(REC.VLRPAR) AS TOTACU,
       NULL AS TOTDIA
FROM TT_DAT DAT,
     TT_VEN VEN INNER JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
                INNER JOIN TT_REC REC  ON REC.CODFIL  = VEN.CODFIL 
                                      AND REC.SEQUEN  = VEN.SEQUEN
WHERE REC.FLGEST = 'A'
  AND REC.CARTAO IS NULL
  AND REC.SEQCHE IS NULL
GROUP BY DAT.DATOPE, DSER.DESSER, CASE WHEN REC.DATVEN < TRUNC( AGORA() ) THEN 1 ELSE 0 END 
UNION ALL
-- CONTA CORRENTE
SELECT 2 AS ORDEM, INT.GRUCTA, INT.SUBGRU, INT.NOMCTA, INT.DATOPE, INT.TOTACU,
       (SELECT SUM( CCC.VLRLAN * -1 )
        FROM TT_CCC CCC 
        WHERE CCC.DATOPE = INT.DATOPE
          AND CCC.TIPCCC = INT.TIPCCC) AS TOTDIA
FROM (SELECT LIM.TIPCCC,
             MIN(CAST('CONTAS A RECEBER' AS VARCHAR(250))) AS GRUCTA,
             MIN(CAST('C/C A FATURAR' AS VARCHAR(20))) AS SUBGRU,
             MIN(CAST(DCCC.DESCCC AS VARCHAR(250))) AS NOMCTA,
             DAT.DATOPE,
             SUM(LIM.VSALDO*-1) AS TOTACU
FROM TT_DAT DAT,
     TT_LIM LIM INNER JOIN TD_CCC DCCC ON DCCC.CODTAB = LIM.TIPCCC
WHERE LIM.VSALDO < 0
GROUP BY DAT.DATOPE, LIM.TIPCCC, DCCC.DESCCC) INT
UNION ALL
--CHEQUES
SELECT 2 AS ORDEM, MIN(CAST('CONTAS A RECEBER' AS VARCHAR(250))) AS GRUCTA,
       MIN(CAST('CHEQUES' AS  VARCHAR(250))) AS SUBGRU,
       MIN(CAST(CASE WHEN CHR.FLGEST = 'V'
                     THEN 'DEVOLVIDOS'
                     ELSE 'A DEPOSITAR'
                 END AS VARCHAR(250))) AS NOMCTA,
       DAT.DATOPE,
       SUM(CHR.VLRCHE) AS TOTACU,
       SUM(CASE WHEN TRUNC(CHR.DATVEN) = TRUNC(DAT.DATOPE)
                THEN CHR.VLRCHE
                ELSE 0
           END) AS TOTDIA
FROM TT_DAT DAT, TT_CHR CHR
WHERE CHR.FLGEST IN ('A','V','G')
GROUP BY DAT.DATOPE, CASE WHEN CHR.FLGEST = 'V' THEN 1 ELSE 0 END
UNION ALL
--CONTAS A PAGAR
SELECT 3 AS ORDEM, MIN(CAST('CONTAS A PAGAR' AS VARCHAR(250))) AS GRUCTA,
       MIN(CAST(' ' AS VARCHAR(20))) AS SUBGRU,
       MIN(CAST(CASE WHEN PAG.DATVEN < AGORA()
                     THEN 'VENCIDAS'
                     ELSE 'A VENCER'
                END AS VARCHAR(250))) AS NOMCTA,
       DAT.DATOPE,
       SUM(PAG.VLRPAR) AS TOTACU,
       NULL AS TOTDIA
FROM TT_DAT DAT,
     TT_PAG PAG
WHERE PAG.FLGEST = 'A'
GROUP BY DAT.DATOPE, CASE WHEN PAG.DATVEN < TRUNC( AGORA() ) THEN 1 ELSE 0 END 
UNION ALL
-- ESTOQUE
SELECT 4 AS ORDEM, MIN(CAST('ESTOQUES' AS VARCHAR(250))) AS GRUCTA,
       MIN(CAST(' ' AS VARCHAR(20))) AS SUBGRU,
       MIN(CAST('ESTOQUES' AS VARCHAR(20))) AS NOMCTA,
       DAT.DATOPE,
       -- 4 p/ Gerencial e 2 p/ Fiscal
       SUM( CustoMedio( SAL.CODFIL, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, 4 ) ) AS TOTACU,
       NULL AS TOTDIA
FROM TT_DAT DAT,
     TT_SAL SAL
WHERE COALESCE(SAL.QTDEST,0) <> 0
  AND SAL.CODMUL = 0
GROUP BY DAT.DATOPE
;


/*-- SEQ 3026 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_REL_RES_EST CASCADE;

/*-- SEQ 3027 --*/
CREATE OR REPLACE VIEW TV_REL_RES_EST AS
  SELECT 'Movimento em Litros' AS UNIDADE,
         SAL.CODFIL,
         PRO.NOMPRO AS GRUPO,
         DAT.DATOPE,
         SUM(CASE MOV.DATMOV                   WHEN DAT.DATOPE   THEN MOV.QTDVEN ELSE 0 END)                AS TOTDIA,
         SUM(CASE TO_CHAR(MOV.DATMOV, 'MM')    WHEN TO_CHAR(DAT.DATOPE, 'MM')   THEN MOV.QTDVEN ELSE 0 END) AS TOTMES,
         SUM(CASE TO_CHAR(MOV.DATMOV, 'YYYY')  WHEN TO_CHAR(DAT.DATOPE, 'YYYY') THEN MOV.QTDVEN ELSE 0 END) AS TOTANO
     FROM TT_DAT DAT, TV_IPR PRO
         INNER JOIN TD_DEP DDEP ON (PRO.DEPART = DDEP.CODTAB)
         INNER JOIN TT_SAL SAL  ON (PRO.FILMAT = SAL.FILMAT AND
                                    PRO.CODMAT = SAL.CODMAT AND
                                    PRO.CODCOR = SAL.CODCOR AND
                                    PRO.CODTAM = SAL.CODTAM)
         INNER JOIN TR_MOV MOV  ON (MOV.FILMAT = SAL.FILMAT AND
                                    MOV.CODMAT = SAL.CODMAT AND
                                    MOV.CODCOR = SAL.CODCOR AND
                                    MOV.CODTAM = SAL.CODTAM AND
                                    MOV.CODFIL = SAL.CODFIL AND
                                    MOV.CODMUL = SAL.CODMUL)
   WHERE DDEP.DEPATI = 'T'
     AND DDEP.CODTAB = -3
     AND MOV.DATMOV BETWEEN TO_DATE('01/01/'||TO_CHAR(DAT.DATOPE, 'YYYY')||' 00:00:00', 'DD/MM/YYYY HH24:MI:SS') AND TO_DATE('31/12/'||TO_CHAR(DAT.DATOPE, 'YYYY')||' 23:59:59', 'DD/MM/YYYY HH24:MI:SS')
--   AND DAT.DATOPE = TO_DATE('14/03/2005', 'DD/MM/YYYY')
  GROUP BY SAL.CODFIL, PRO.NOMPRO, DAT.DATOPE
  UNION ALL
  SELECT 'Movimento em R$' AS UNIDADE,
         SAL.CODFIL,
         PRO.NOMPRO AS GRUPO,
         DAT.DATOPE,
         SUM(CASE TRUNC(IVE.VEN_DATHOR)            WHEN DAT.DATOPE                  THEN SAL.VLRCMG ELSE 0 END) AS TOTDIA,
         SUM(CASE TO_CHAR(IVE.VEN_DATHOR, 'MM')    WHEN TO_CHAR(DAT.DATOPE, 'MM')   THEN SAL.VLRCMG ELSE 0 END) AS TOTMES,
         SUM(CASE TO_CHAR(IVE.VEN_DATHOR, 'YYYY')  WHEN TO_CHAR(DAT.DATOPE, 'YYYY') THEN SAL.VLRCMG ELSE 0 END) AS TOTANO
    FROM TT_DAT DAT, TV_IPR PRO
         INNER JOIN TD_DEP DDEP ON (PRO.DEPART = DDEP.CODTAB)
         INNER JOIN TT_SAL SAL  ON (PRO.FILMAT = SAL.FILMAT AND
                                    PRO.CODMAT = SAL.CODMAT AND
                                    PRO.CODCOR = SAL.CODCOR AND
                                    PRO.CODTAM = SAL.CODTAM)
         INNER JOIN TT_IVE IVE  ON (IVE.CODFIL = SAL.CODFIL AND
                                    IVE.FILMAT = SAL.FILMAT AND
                                    IVE.CODMAT = SAL.CODMAT AND
                                    IVE.CODCOR = SAL.CODCOR AND
                                    IVE.CODTAM = SAL.CODTAM AND
                                    IVE.CODMUL = SAL.CODMUL)
   WHERE DDEP.DEPATI = 'T'
     AND DDEP.CODTAB = -3
     AND IVE.SITMOV  = 'N'
     AND IVE.VEN_DATHOR BETWEEN TO_DATE('01/01/'||TO_CHAR(DAT.DATOPE, 'YYYY')||' 00:00:00', 'DD/MM/YYYY HH24:MI:SS') AND TO_DATE('31/12/'||TO_CHAR(DAT.DATOPE, 'YYYY')||' 23:59:59', 'DD/MM/YYYY HH24:MI:SS')
--   AND DAT.DATOPE = TO_DATE('14/03/2005', 'DD/MM/YYYY')
   GROUP BY SAL.CODFIL,
            PRO.NOMPRO,
            DAT.DATOPE
  UNION ALL
  SELECT 'Outras Receitas R$' AS UNIDADE,
         SAL.CODFIL,
         CASE WHEN PRO.TIPPRO = 0 THEN 'Produtos' WHEN PRO.TIPPRO = 1 THEN 'Servios' END,
         DAT.DATOPE,
         SUM(CASE TRUNC(IVE.VEN_DATHOR)            WHEN DAT.DATOPE                  THEN SAL.VLRCMG ELSE 0 END) AS TOTDIA,
         SUM(CASE TO_CHAR(IVE.VEN_DATHOR, 'MM')    WHEN TO_CHAR(DAT.DATOPE, 'MM')   THEN SAL.VLRCMG ELSE 0 END) AS TOTMES,
         SUM(CASE TO_CHAR(IVE.VEN_DATHOR, 'YYYY')  WHEN TO_CHAR(DAT.DATOPE, 'YYYY') THEN SAL.VLRCMG ELSE 0 END) AS TOTANO
    FROM TT_DAT DAT, TV_IPR PRO
         INNER JOIN TD_DEP DDEP ON (PRO.DEPART = DDEP.CODTAB)
         INNER JOIN TT_SAL SAL  ON (PRO.FILMAT = SAL.FILMAT AND
                                    PRO.CODMAT = SAL.CODMAT AND
                                    PRO.CODCOR = SAL.CODCOR AND
                                    PRO.CODTAM = SAL.CODTAM)
         INNER JOIN TT_IVE IVE  ON (IVE.CODFIL = SAL.CODFIL AND
                                    IVE.FILMAT = SAL.FILMAT AND
                                    IVE.CODMAT = SAL.CODMAT AND
                                    IVE.CODCOR = SAL.CODCOR AND
                                    IVE.CODTAM = SAL.CODTAM AND
                                    IVE.CODMUL = SAL.CODMUL)
   WHERE DDEP.DEPATI = 'T'
     AND DDEP.CODTAB <> -3
     AND IVE.SITMOV  = 'N'
     AND IVE.VEN_DATHOR BETWEEN TO_DATE('01/01/'||TO_CHAR(DAT.DATOPE, 'YYYY')||' 00:00:00', 'DD/MM/YYYY HH24:MI:SS') AND TO_DATE('31/12/'||TO_CHAR(DAT.DATOPE, 'YYYY')||' 23:59:59', 'DD/MM/YYYY HH24:MI:SS')
--   AND DAT.DATOPE = TO_DATE('14/03/2005', 'DD/MM/YYYY')
   GROUP BY SAL.CODFIL,
            CASE WHEN PRO.TIPPRO = 0 THEN 'Produtos' WHEN PRO.TIPPRO = 1 THEN 'Servios' END,
            DAT.DATOPE
;




/*-- SEQ 3028 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_SLE_EXT CASCADE;

/*-- SEQ 3029 --*/
CREATE OR REPLACE VIEW TV_SLE_EXT AS
SELECT CODFIL, FILMAT, CODMAT, CODCOR, CODTAM, CODMUL, 
    SALREA, TAMORI, REFPRO, rpad(' ',20,' ') AS CODLOT
FROM TV_SLE;


/*-- SEQ 3030 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_WEB_PRE CASCADE;

/*-- SEQ 3031 --*/
CREATE OR REPLACE VIEW TV_WEB_PRE AS
SELECT /*+INDEX(PRO, PK_PRO) INDEX(SAL, PK_SAL) INDEX(GRA, PK_GRA) INDEX(PRE, AK_PRE_GRA)*/
       GRA.REFPRO,           /* Codigo do produto */
       PRO.REFBAS,           /* Referencia basica do produto */
       GRA.FILMAT||GRA.SEQUEN AS CHAVEPRO,
       PRE.FILPRE||LPAD(TO_CHAR(PRE.CODPRE),10,'0') AS CHAVEPRE,
       CAST(GRA.FILMAT||GRA.CODMAT AS CHAR(13)) AS SEQUEN,
       MTOM(MOE.CODTAB,CFG.CODMOE,AGORA(),PRE.PRECOV) * ((100-COALESCE(PRO.DESECO,0)) / 100) AS PREVEN /* Valor de venda */,
       MTOM(MOE.CODTAB,CFG.CODMOE,AGORA(),PrecoPromocional(GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,CFG.VC_FILPGT,CFG.VC_CODPGT,PRE.FILPRE,PRE.SEQUEN)) AS PREPMC, /* Preco promocional */
       VencimentoPromocao(GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,CFG.VC_FILPGT,CFG.VC_CODPGT,PRE.FILPRE,PRE.SEQUEN) AS VENPMC, /* Vencimento da promocao */
       GRA.ENVECO,
       CFG.DESMOE,              /* Tipo de moeda */
       PRE.ATU_EM,              /* ltima atualizao da tabela de preo */
       PRO.ATU_EM AS PRO_ATU_EM /* ltima atualizao do produto */
FROM (SELECT DIN.CODTAB AS CODMOE,DIN.DESMOE,
             IDF.CODLOJ,
             CON.FILPRE,CON.CODPRE,
             CON.VC_FILPGT,CON.VC_CODPGT,
             CON.CLASS1, CON.CLASS2, CON.CLASS3, CON.CLASS4, CON.CL4WEB
        FROM TT_CFG CON, TT_IDF IDF, TD_MOE DIN
       WHERE DIN.CODTAB = 0) CFG,
     TT_PRO PRO INNER JOIN TT_GRA GRA  ON GRA.FILMAT  = PRO.FILMAT
                                      AND GRA.CODMAT  = PRO.CODMAT
                INNER JOIN TD_DEP DEP  ON DEP.CODTAB  = PRO.DEPART
                INNER JOIN TD_CL1 CL1  ON CL1.CODTAB  = PRO.CLASS1
                INNER JOIN TD_CL2 CL2  ON CL2.CODTAB  = PRO.CLASS2
                INNER JOIN TD_CL3 CL3  ON CL3.CODTAB  = PRO.CLASS3
                INNER JOIN TD_CL4 CL4  ON CL4.CODTAB  = PRO.CLASS4
                INNER JOIN TT_PRE PRE  ON PRE.FILMAT  = GRA.FILMAT
                                      AND PRE.CODMAT  = GRA.CODMAT
                                      AND PRE.CODCOR  = GRA.CODCOR
                                      AND PRE.CODTAM  = GRA.CODTAM
                INNER JOIN TD_MOE MOE ON MOE.CODTAB   = PRE.CODMOE
WHERE 1=1
  --AND (CL1.CL1WEB='T' OR CL2.CL2WEB='T' OR CL3.CL3WEB='T' OR CL4.CL4WEB='T' OR DEP.DEPWEB='T')
  
  AND GRA.FILMAT = GRA.FILMAT
  AND GRA.CODMAT = GRA.CODMAT
  AND GRA.CODCOR = GRA.CODCOR
  AND GRA.CODTAM = GRA.CODTAM
    --AND PRO.SIGNAT >= 0
  AND CASE WHEN GRA.ENVECO = 'T' THEN 'T'
           ELSE
                CASE WHEN ((CL1.CL1WEB='T' OR CL2.CL2WEB='T' OR CL3.CL3WEB='T' OR CL4.CL4WEB='T' OR DEP.DEPWEB='T')
                      AND PRO.SIGNAT >= 0
                      AND GRA.GRAATI='T') THEN 'T'
                ELSE 'F'
                END
      END  = 'T'
  -- RFMP 92038
  AND COALESCE(PRE.PRECOV,0) > 0
;


-- Autor: Luciano
-- Cliente(s): GIMBA
-- Finalidade(s):
-- 1) Executar a funo de custo mdio no SQL Server, cliente no consegue chamar a funo diretamente.
/*-- SEQ 3032 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ECUSTOMEDIO CASCADE;

/*-- SEQ 3033 --*/
CREATE OR REPLACE VIEW TV_ECUSTOMEDIO AS
SELECT EIVE.CODFIL, 
       EIVE.SEQUEN, 
       EIVE.NUMITE, 
       GRA.CUSREP,
       CAST(EIVE.CODMAT AS VARCHAR(20)) AS CODEXT, 
       TRUNC(CUSTOMEDIO(EIVE.CODFIL,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,3,TRUNC(EIVE.VEN_DATHOR)),4) AS VLR_CM
  FROM TV_EIVE EIVE INNER JOIN TT_GRA GRA ON GRA.CODEXT = EIVE.CODMAT;


/*-- SEQ 3034 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_FIS_61RV CASCADE;

/*-- SEQ 3035 --*/
CREATE OR REPLACE VIEW TV_FIS_61RV AS
SELECT DISTINCT
       TAB.CODFIL,
       COALESCE(TAB.CHAVE ,'')||
       COALESCE(TAB.MESANO ,'')||
       COALESCE(TAB.CODMAT ,'')||
       COALESCE(TO_CHAR(TAB.QTDMOV) ,'')||
       COALESCE(TO_CHAR(TAB.VLRMOV) ,'')||
       COALESCE(TAB.BASICM ,'')||
       COALESCE(to_char(TAB.PERICM) ,'')||
       LPAD(' ',54,' ') AS LINHA
FROM (
       SELECT INT.CHAVE,
              INT.CODFIL,
              INT.MESANO,
              INT.CODMAT,
              LPAD(TO_CHAR(ABS(ROUND(SUM(INT.QTDMOV) * 1000))), 13, '0') AS QTDMOV,
              LPAD(TO_CHAR(ABS(ROUND(SUM(INT.VLRMOV) * 100, 0))), 16, '0') AS VLRMOV,
              LPAD(TO_CHAR(ABS(ROUND(SUM(INT.BASICM) * 100, 0))), 16, '0') AS BASICM,
              LPAD(TO_CHAR(ABS(ROUND(INT.PERICM * 100, 0))), 4, '0') AS PERICM
         FROM TV_FIS_61RV_INTERNO INT
        GROUP BY INT.CHAVE, INT.CODFIL, INT.MESANO, INT.CODMAT, INT.PERICM
) TAB
 ;


/*-- SEQ 3036 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Atualiza_DW_Produto () CASCADE;

/*-- SEQ 3037 --*/
CREATE OR REPLACE FUNCTION Atualiza_DW_Produto ()
RETURNS VARCHAR AS $$
DECLARE

  regDW         RECORD;
BEGIN
  -- Marcar registros que sero processados
  UPDATE DW_Log_Produto
     SET DW_FLGEST = 'P'
   WHERE DW_FLGEST = 'N';

  FOR regDW IN (SELECT FILMAT, CODMAT, CODCOR, CODTAM
                  FROM DW_Log_Produto
                 WHERE DW_FLGEST = 'P')
  LOOP

    -- apagar na view/tabela materializada
    DELETE FROM DW_Produto
     WHERE FILMAT = regDW.FILMAT
       AND CODMAT = regDW.CODMAT
       AND CODCOR = regDW.CODCOR
       AND CODTAM = regDW.CODTAM;

    -- obter os dados na view normal e gravar na materializada
    INSERT INTO DW_Produto
        (COD_PRODUTO, PRODUTO, COD_CLASSE1, 
         COD_CLASSE2, COD_CLASSE3, COD_CLASSE4, 
         COD_DEPARTAMENTO, CLASSE1, CLASSE2, 
         CLASSE3, CLASSE4, DEPARTAMENTO, 
         FILMAT, CODMAT, CODCOR, 
         CODTAM) 
        (SELECT DWV.COD_PRODUTO, DWV.PRODUTO, DWV.COD_CLASSE1, 
                DWV.COD_CLASSE2, DWV.COD_CLASSE3, DWV.COD_CLASSE4, 
                DWV.COD_DEPARTAMENTO, DWV.CLASSE1, DWV.CLASSE2, 
                DWV.CLASSE3, DWV.CLASSE4, DWV.DEPARTAMENTO, 
                DWV.FILMAT, DWV.CODMAT, DWV.CODCOR, 
                DWV.CODTAM
           FROM DW_View_Produto DWV 
          WHERE DWV.FILMAT = regDW.FILMAT
            AND DWV.CODMAT = regDW.CODMAT
            AND DWV.CODCOR = regDW.CODCOR
            AND DWV.CODTAM = regDW.CODTAM);

  END LOOP;    

  -- Excluir j processados
  DELETE FROM DW_Log_Produto
   WHERE DW_FLGEST = 'P';

  RETURN 'OK';
END;
$$ language 'plpgsql';




/*-- SEQ 3038 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Atualiza_DW_Vendas () CASCADE;

/*-- SEQ 3039 --*/
CREATE OR REPLACE FUNCTION Atualiza_DW_Vendas ()
RETURNS VARCHAR AS $$
DECLARE

  regDW         RECORD;
BEGIN
  -- Marcar registros que sero processados
  UPDATE DW_Log_Vendas
     SET DW_FLGEST = 'P'
   WHERE DW_FLGEST = 'N';

  FOR regDW IN (SELECT FILIAL, COD_UNIDADE, DATA
                  FROM DW_Log_Vendas
                 WHERE DW_FLGEST = 'P')
  LOOP

    -- apagar na view/tabela materializada
    DELETE FROM DW_Vendas
     WHERE FILIAL      = regDW.FILIAL
       AND COD_UNIDADE = regDW.COD_UNIDADE
       AND DATA        = regDW.DATA;

    -- obter os dados na view normal e gravar na materializada
    INSERT INTO DW_Vendas
        (FILIAL, COD_UNIDADE, DATA, 
         QTD_ITENS, QTD_VENDAS, VALOR)
        (SELECT DWV.FILIAL, DWV.COD_UNIDADE, DWV.DATA, 
                DWV.QTD_ITENS, DWV.QTD_VENDAS, DWV.VALOR
           FROM DW_View_Vendas DWV 
          WHERE DWV.FILIAL      = regDW.FILIAL
            AND DWV.COD_UNIDADE = regDW.COD_UNIDADE
            AND DWV.DATA        = regDW.DATA);

  END LOOP;    

  -- Excluir j processados
  DELETE FROM DW_Log_Vendas
   WHERE DW_FLGEST = 'P';

  RETURN 'OK';
END;
$$ language 'plpgsql';




/*-- SEQ 3040 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Atualiza_DW_Vendas_Cliente () CASCADE;

/*-- SEQ 3041 --*/
CREATE OR REPLACE FUNCTION Atualiza_DW_Vendas_Cliente ()
RETURNS VARCHAR AS $$
DECLARE

  regDW         RECORD;
BEGIN
  -- Marcar registros que sero processados
  UPDATE DW_Log_Vendas_Cliente
     SET DW_FLGEST = 'P'
   WHERE DW_FLGEST = 'N';

  FOR regDW IN (SELECT FILIAL, FILIAL_CLIENTE, CODIGO_CLIENTE, ANO_MES
                  FROM DW_Log_Vendas_Cliente
                 WHERE DW_FLGEST = 'P')
  LOOP

    -- apagar na view/tabela materializada
    DELETE FROM DW_Vendas_Cliente
     WHERE FILIAL         = regDW.FILIAL
       AND FILIAL_CLIENTE = regDW.FILIAL_CLIENTE
       AND CODIGO_CLIENTE = regDW.CODIGO_CLIENTE
       AND ANO_MES        = regDW.ANO_MES;

    -- obter os dados na view normal e gravar na materializada
    INSERT INTO DW_Vendas_Cliente
        (FILIAL, FILIAL_CLIENTE, CODIGO_CLIENTE, NOME_COMPLETO,
         ANO_MES, VALOR, QTD_ITENS, 
         QTD_VENDAS, CONSUMIDOR, CATEGORIA1, 
         CATEGORIA2, CATEGORIA3, SEXO, 
         ESTADO_CIVIL, PROFISSAO, TIPO_PESSOA, 
         OCU_CODTAB, CT1_CODTAB, CT2_CODTAB, 
         CT3_CODTAB)
        (SELECT DWV.FILIAL, DWV.FILIAL_CLIENTE, DWV.CODIGO_CLIENTE, DWV.NOME_COMPLETO, 
                DWV.ANO_MES, DWV.VALOR, DWV.QTD_ITENS, 
                DWV.QTD_VENDAS, DWV.CONSUMIDOR, DWV.CATEGORIA1, 
                DWV.CATEGORIA2, DWV.CATEGORIA3, DWV.SEXO, 
                DWV.ESTADO_CIVIL, DWV.PROFISSAO, DWV.TIPO_PESSOA, 
                DWV.OCU_CODTAB, DWV.CT1_CODTAB, DWV.CT2_CODTAB, 
                DWV.CT3_CODTAB
           FROM DW_View_Vendas_Cliente DWV 
          WHERE DWV.FILIAL         = regDW.FILIAL
            AND DWV.FILIAL_CLIENTE = regDW.FILIAL_CLIENTE
            AND DWV.CODIGO_CLIENTE = regDW.CODIGO_CLIENTE
            AND DWV.ANO_MES        = regDW.ANO_MES);

  END LOOP;    

  -- Excluir j processados
  DELETE FROM DW_Log_Vendas_Cliente
   WHERE DW_FLGEST = 'P';

  RETURN 'OK';
END;
$$ language 'plpgsql';




/*-- SEQ 3042 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Atualiza_DW_Vendas_Grupos () CASCADE;

/*-- SEQ 3043 --*/
CREATE OR REPLACE FUNCTION Atualiza_DW_Vendas_Grupos ()
RETURNS VARCHAR AS $$
DECLARE

  regDW         RECORD;
BEGIN
  -- Marcar registros que sero processados
  UPDATE DW_Log_Vendas_Grupos
     SET DW_FLGEST = 'P'
   WHERE DW_FLGEST = 'N';

  FOR regDW IN (SELECT FILIAL, ANO_MES
                  FROM DW_Log_Vendas_Grupos
                 WHERE DW_FLGEST = 'P')
  LOOP                    

    -- apagar na view/tabela materializada
    DELETE FROM DW_Vendas_Grupos
     WHERE FILIAL  = regDW.FILIAL
       AND ANO_MES = regDW.ANO_MES;

    -- obter os dados na view normal e gravar na materializada
    INSERT INTO DW_Vendas_Grupos
        (FILIAL, ANO_MES, PLANO, 
         VENDEDOR, UNIDADE, CLASSE1, 
         CLASSE2, CLASSE3, CLASSE4, 
         DEPARTAMENTO, VALOR, QUANTIDADE, 
         ITENS, COD_CLASSE1, COD_CLASSE2, 
         COD_CLASSE3, COD_CLASSE4, COD_DEPARTAMENTO, 
         FILPGT, CODPGT)
        (SELECT DWV.FILIAL, DWV.ANO_MES, DWV.PLANO, 
                DWV.VENDEDOR, DWV.UNIDADE, DWV.CLASSE1, 
                DWV.CLASSE2, DWV.CLASSE3, DWV.CLASSE4, 
                DWV.DEPARTAMENTO, DWV.VALOR, DWV.QUANTIDADE, 
                DWV.ITENS, DWV.COD_CLASSE1, DWV.COD_CLASSE2, 
                DWV.COD_CLASSE3, DWV.COD_CLASSE4, DWV.COD_DEPARTAMENTO, 
                DWV.FILPGT, DWV.CODPGT
           FROM DW_View_Vendas_Grupos DWV 
          WHERE DWV.FILIAL  = regDW.FILIAL
            AND DWV.ANO_MES = regDW.ANO_MES);

  END LOOP;    

  -- Excluir j processados
  DELETE FROM DW_Log_Vendas_Grupos
   WHERE DW_FLGEST = 'P';

  RETURN 'OK';
END;
$$ language 'plpgsql';




/*-- SEQ 3044 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Atualiza_DW_Vendas_Hora () CASCADE;

/*-- SEQ 3045 --*/
CREATE OR REPLACE FUNCTION Atualiza_DW_Vendas_Hora ()
RETURNS VARCHAR AS $$
DECLARE

  regDW         RECORD;
BEGIN
  -- Marcar registros que sero processados
  UPDATE DW_Log_Vendas_Hora
     SET DW_FLGEST = 'P'
   WHERE DW_FLGEST = 'N';

  FOR regDW IN (SELECT FILIAL, DATA, HORA
                  FROM DW_Log_Vendas_Hora
                 WHERE DW_FLGEST = 'P')
  LOOP

    -- apagar na view/tabela materializada
    DELETE FROM DW_Vendas_Hora
     WHERE FILIAL      = regDW.FILIAL       
       AND DATA        = regDW.DATA
       AND HORA        = regDW.HORA;

    -- obter os dados na view normal e gravar na materializada
    INSERT INTO DW_Vendas_Hora
        (FILIAL, DATA, HORA, 
         VALOR, QTDVEN)
        (SELECT DWV.FILIAL, DWV.DATA, DWV.HORA, 
                DWV.VALOR, DWV.QTDVEN
           FROM DW_View_Vendas_Hora DWV 
          WHERE DWV.FILIAL      = regDW.FILIAL            
            AND DWV.DATA        = regDW.DATA
            AND DWV.HORA        = regDW.HORA);

  END LOOP;    

  -- Excluir j processados
  DELETE FROM DW_Log_Vendas_Hora
   WHERE DW_FLGEST = 'P';

  RETURN 'OK';
END;
$$ language 'plpgsql';




/*-- SEQ 3046 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Atualiza_DW_Vendas_Meio () CASCADE;

/*-- SEQ 3047 --*/
CREATE OR REPLACE FUNCTION Atualiza_DW_Vendas_Meio ()
RETURNS VARCHAR AS $$
DECLARE

  regDW         RECORD;
BEGIN
  -- Marcar registros que sero processados
  UPDATE DW_Log_Vendas_Meio
     SET DW_FLGEST = 'P'
   WHERE DW_FLGEST = 'N';

  FOR regDW IN (SELECT FILIAL, COD_UNIDADE, ANO_MES
                  FROM DW_Log_Vendas_Meio
                 WHERE DW_FLGEST = 'P')
  LOOP                    

    -- apagar na view/tabela materializada
    DELETE FROM DW_Vendas_Meio
     WHERE FILIAL      = regDW.FILIAL
       AND COD_UNIDADE = regDW.COD_UNIDADE
       AND ANO_MES     = regDW.ANO_MES;

    -- obter os dados na view normal e gravar na materializada
    INSERT INTO DW_Vendas_Meio
        (FILIAL, COD_UNIDADE, ANO_MES, 
         MEIO, VALOR, PRAZO, 
         DCOB_CODTAB, DCAR_CODTAB, DCCC_CODTAB, 
         DOUT_CODTAB, CHR_CODFIL, CHR_SEQUEN) 
        (SELECT DWV.FILIAL, DWV.COD_UNIDADE, DWV.ANO_MES, 
                DWV.MEIO, DWV.VALOR, DWV.PRAZO, 
                DWV.DCOB_CODTAB, DWV.DCAR_CODTAB, DWV.DCCC_CODTAB, 
                DWV.DOUT_CODTAB, DWV.CHR_CODFIL, DWV.CHR_SEQUEN
           FROM DW_View_Vendas_Meio DWV 
          WHERE DWV.FILIAL      = regDW.FILIAL
            AND DWV.COD_UNIDADE = regDW.COD_UNIDADE
            AND DWV.ANO_MES     = regDW.ANO_MES);

  END LOOP;    

  -- Excluir j processados
  DELETE FROM DW_Log_Vendas_Meio
   WHERE DW_FLGEST = 'P';

  RETURN 'OK';
END;
$$ language 'plpgsql';




/*-- SEQ 3048 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Atualiza_DW_Vendas_Produto () CASCADE;

/*-- SEQ 3049 --*/
CREATE OR REPLACE FUNCTION Atualiza_DW_Vendas_Produto ()
RETURNS VARCHAR AS $$
DECLARE

  regDW         RECORD;
BEGIN
  -- Marcar registros que sero processados
  UPDATE DW_Log_Vendas_Produto
     SET DW_FLGEST = 'P'
   WHERE DW_FLGEST = 'N';

  FOR regDW IN (SELECT FILIAL, ANO_MES
                  FROM DW_Log_Vendas_Produto
                 WHERE DW_FLGEST = 'P')
  LOOP                    

    -- apagar na view/tabela materializada
    DELETE FROM DW_Vendas_Produto
     WHERE FILIAL  = regDW.FILIAL
       AND ANO_MES = regDW.ANO_MES;

    -- obter os dados na view normal e gravar na materializada
    INSERT INTO DW_Vendas_Produto
        (FILIAL, ANO_MES, COD_PRODUTO, 
         VALOR, QUANTIDADE, ITENS)
        (SELECT DWV.FILIAL, DWV.ANO_MES, DWV.COD_PRODUTO, 
                DWV.VALOR, DWV.QUANTIDADE, DWV.ITENS
           FROM DW_View_Vendas_Produto DWV 
          WHERE DWV.FILIAL  = regDW.FILIAL
            AND DWV.ANO_MES = regDW.ANO_MES);

  END LOOP;    

  -- Excluir j processados
  DELETE FROM DW_Log_Vendas_Produto
   WHERE DW_FLGEST = 'P';

  RETURN 'OK';
END;
$$ language 'plpgsql';




/*-- SEQ 3050 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AuxProjetarTarefas (INTEGER,TT_PRJ.CODFIL%TYPE,TT_PRJ.SEQUEN%TYPE) CASCADE;

/*-- SEQ 3051 --*/
CREATE OR REPLACE FUNCTION AuxProjetarTarefas (INTEGER,TT_PRJ.CODFIL%TYPE,TT_PRJ.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
nPriori ALIAS FOR $1 ;
pFILPRJ ALIAS FOR $2 ;
pSEQPRJ ALIAS FOR $3 ;

  i INTEGER;  
  cFILWOR TT_WOR.CODFIL%TYPE;
  cSEQWOR TT_WOR.SEQUEN%TYPE;
  nTARFAL Numeric;
  cFILRES TT_WOR.FILRES%TYPE;
  cCODRES TT_WOR.CODRES%TYPE;
  dINIPRJ TT_PRJ.INIPRJ%TYPE;  
  dDATDEP TT_PRJ.FIMPRJ%TYPE;  
  nQtdDep Numeric;
  nCount integer;
  cAux VARCHAR(10);

  -- Todas as tarefas de prioridade menor ou igual a atual, que tenham dependentes, e nao dependam de tarefa aberta ainda nao processada em um projeto
  cr_Tarefas_dep CURSOR FOR
SELECT WOR.CODFIL,
           WOR.SEQUEN,
           WOR.TARFAL,
           WOR.FILRES,
           WOR.CODRES,
           InicioProjeto(WOR.FILPRJ,WOR.SEQPRJ) AS DATINIPRJ,
           (SELECT MAX(WDEP.FIMPRT)
                     FROM TW_WORXWOR DEP INNER JOIN TT_WOR WDEP ON WDEP.CODFIL=DEP.FILWOR 
                                                               AND WDEP.SEQUEN=DEP.SEQWOR      -- TAREFAS QUE ESTA DEPENDIA
                                         INNER JOIN TW_CROXWOR DPROC ON DEP.FILWOR=DPROC.CODFIL 
                                                                    AND DEP.SEQWOR=DPROC.SEQUEN 
                                                                    AND DPROC.USERID=USERENV('SESSIONID')
                    WHERE DEP.CODFIL=WOR.CODFIL
                      AND DEP.SEQUEN=WOR.SEQUEN
                      AND DPROC.PROCES='T' -- NAO DEPENDE DE NINGUEM QUE AINDA NAO FOI PROCESSADO                                                                     
           ) AS FIMPRT,
           (SELECT COUNT(*)
              FROM TW_WORXWOR WXW 
             WHERE WOR.CODFIL=WXW.FILWOR 
               AND WOR.SEQUEN=WXW.SEQWOR     
           ) AS QTDFIL -- OUTRAS TAREFA DEPENDEM DESTA
             FROM TV_WOR WOR INNER JOIN TW_CROXWOR PROC ON WOR.CODFIL=PROC.CODFIL AND WOR.SEQUEN=PROC.SEQUEN  -- NAO PROCESSADO                             
                             INNER JOIN TD_SIT SIT ON SIT.CODTAB=WOR.FLGSIT
     WHERE SIT.TIPSIT = 'A'
       AND WOR.PRIORI<=nPriori
       AND PROC.USERID=USERENV('SESSIONID')
       AND PROC.PROCES='F'     -- NAO FOI PROCESSADO       
       AND (WOR.CODFIL,WOR.SEQUEN)
           NOT IN (SELECT DEP.CODFIL, DEP.SEQUEN
                     FROM TW_WORXWOR DEP INNER JOIN TT_WOR WDEP ON WDEP.CODFIL=DEP.FILWOR 
                                                               AND WDEP.SEQUEN=DEP.SEQWOR      -- TAREFAS QUE ESTA DEPENDIA
                                         INNER JOIN TW_CROXWOR DPROC ON DEP.FILWOR=DPROC.CODFIL 
                                                                    AND DEP.SEQWOR=DPROC.SEQUEN 
                                                                    AND DPROC.USERID=USERENV('SESSIONID')
                    WHERE DPROC.PROCES='F' -- NAO DEPENDE DE NINGUEM QUE AINDA NAO FOI PROCESSADO                                                                     
                   ) -- TAREFAS QUE ESTA DEPENDIA
     ORDER BY CASE WHEN QTDFIL>0 THEN 0 ELSE 1 END,
         CASE WHEN WOR.DATPRO IS NOT NULL THEN 0 ELSE 1 END,
         WOR.DATPRO, 
         CASE WHEN DataPrometidaTarefa(WOR.FILPRJ,WOR.SEQPRJ) IS NOT NULL THEN 0 ELSE 1 END,
         DataPrometidaTarefa(WOR.FILPRJ,WOR.SEQPRJ),
         WOR.PRIORI;      
         
  -- Tarefas nao Processadas (Dependencia ciclica)
  cr_Tarefas_Nao_Proc CURSOR FOR
    select WOR.CODFIL,
           WOR.SEQUEN,
           WOR.TARFAL,
           WOR.FILRES,
           WOR.CODRES,
           InicioProjeto(WOR.FILPRJ,WOR.SEQPRJ) AS DATINIPRJ
      from tw_croxwor cro inner join tv_wor wor on cro.codfil=wor.codfil and cro.sequen=wor.sequen
                          inner join TW_WORXWOR DEP ON WOR.CODFIL=DEP.CODFIL AND WOR.SEQUEN=DEP.SEQUEN     -- TAREFAS QUE ESTA DEPENDIA
                          inner join TT_WOR WDEP ON WDEP.CODFIL=DEP.FILWOR AND WDEP.SEQUEN=DEP.SEQWOR      -- TAREFAS QUE ESTA DEPENDIA
                          inner join TW_CROXWOR DPROC ON DEP.FILWOR=DPROC.CODFIL AND DEP.SEQWOR=DPROC.SEQUEN AND DPROC.USERID=userenv('SESSIONID')
     where cro.userid=userenv('SESSIONID')    
       and CRO.proces='F'
       AND WOR.PRIORI<=nPriori
       AND WDEP.PRIORI<=nPriori
       AND DPROC.proces='F'
      GROUP BY  WOR.CODFIL,
                WOR.SEQUEN,
                WOR.TARFAL,
                WOR.FILRES,
                WOR.CODRES,
                WOR.FILPRJ,
                WOR.SEQPRJ;
         
BEGIN
 
  OPEN cr_Tarefas_dep;  
  LOOP  
     FETCH cr_Tarefas_dep INTO cFILWOR, cSEQWOR, nTARFAL, cFILRES, cCODRES, dINIPRJ, dDATDEP, nQtdDep;
     EXIT WHEN NOT FOUND;
     
     cAux:= AuxAlocaTarefa(cFILWOR, cSEQWOR, nTARFAL, cFILRES, cCODRES, GREATEST(coalesce(dINIPRJ,to_date('01/01/1900','dd/mm/yyyy')), coalesce(dDATDEP,to_date('01/01/1900','dd/mm/yyyy'))));
         
  END LOOP;
  CLOSE cr_Tarefas_dep;
  
  
  -- Exaurir tarefas com dependencia
  OPEN cr_Tarefas_dep;
  FETCH cr_Tarefas_dep INTO cFILWOR, cSEQWOR, nTARFAL, cFILRES, cCODRES, dINIPRJ, dDATDEP, nQtdDep;
  IF FOUND THEN
     CLOSE cr_Tarefas_dep;
     cAux:=AuxProjetarTarefas(nPriori,pFILPRJ,pSEQPRJ);
     RETURN cAux;
  ELSE
     CLOSE cr_Tarefas_dep;
  END IF; 
  
  -- Impedir o nao processamento de dependencias ciclicas
  IF nPriori=9 THEN  
      OPEN cr_Tarefas_Nao_Proc;
      FETCH cr_Tarefas_Nao_Proc INTO cFILWOR, cSEQWOR, nTARFAL, cFILRES, cCODRES, dINIPRJ;
      IF FOUND THEN     
         CLOSE cr_Tarefas_Nao_Proc;
         cAux:= AuxAlocaTarefa(cFILWOR, cSEQWOR, nTARFAL, cFILRES, cCODRES, dINIPRJ);
         cAux:=AuxProjetarTarefas(nPriori,pFILPRJ,pSEQPRJ);
         RETURN cAux;
      ELSE
         CLOSE cr_Tarefas_Nao_Proc;
      END IF; 
  END IF;
  
  RETURN 'OK';

END;
$$ language 'plpgsql';


/*-- SEQ 3052 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION AuxProjetarTarefas (INTEGER) CASCADE;

/*-- SEQ 3053 --*/
CREATE OR REPLACE FUNCTION AuxProjetarTarefas (INTEGER) 
RETURNS VARCHAR AS $$
BEGIN
RETURN AuxProjetarTarefas($1,NULL,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 3054 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CRIA_BALANCETE_COMPARATIVO (TT_CTA.CODFIL%TYPE,VARCHAR) CASCADE;

/*-- SEQ 3055 --*/
CREATE OR REPLACE FUNCTION CRIA_BALANCETE_COMPARATIVO (TT_CTA.CODFIL%TYPE,VARCHAR)
RETURNS VARCHAR AS $$
DECLARE
pCODFIL ALIAS FOR $1 ;
pDATANO ALIAS FOR $2 ;

  -- cria balancete comparativo

BEGIN
    
  INSERT INTO TW_CTA ( VLRTO1, VLRTO2, VLRTO3, VLRTO4, VLRTO5, VLRTO6, VLRTO7, VLRTO8, VLRTO9, VLRT10, VLRT11, VLRT12,
                       USERID, CHV_ID, CHVPAI, TIPCTA, FILCTA, SEQCTA, TITCTA,
                       VLRV01, VLRV02, VLRV03, VLRV04, VLRV05, VLRV06, VLRV07, 
                       VLRV08, VLRV09, VLRV10, VLRV11, VLRV12  ,ARVORE  )
      SELECT  COALESCE( TO1.VLRTO1, 0 ) AS VLRTO1,
              COALESCE( TO2.VLRTO2, 0 ) AS VLRTO2,
              COALESCE( TO3.VLRTO3, 0 ) AS VLRTO3,
              COALESCE( TO4.VLRTO4, 0 ) AS VLRTO4,
              COALESCE( TO5.VLRTO5, 0 ) AS VLRTO5,
              COALESCE( TO6.VLRTO6, 0 ) AS VLRTO6,
              COALESCE( TO7.VLRTO7, 0 ) AS VLRTO7,
              COALESCE( TO8.VLRTO8, 0 ) AS VLRTO8,
              COALESCE( TO9.VLRTO9, 0 ) AS VLRTO9,                                                      
              COALESCE( T10.VLRT10, 0 ) AS VLRT10,                                                      
              COALESCE( T11.VLRT11, 0 ) AS VLRT11,                                                      
              COALESCE( T12.VLRT12, 0 ) AS VLRT12,                                                      
              ECT.USERID,                                                                               
              ECT.CHV_ID,                                                                               
              ECT.CHVPAI,                                                                               
              ECT.TIPCTA,                                                                               
              ECT.FILCTA,                                                                               
              ECT.SEQCTA,                                                                               
              ECT.TITCTA,
              COALESCE( V01.VLRVER, 0 ) AS VLRVO1,
              COALESCE( V02.VLRVER, 0 ) AS VLRVO2,
              COALESCE( V03.VLRVER, 0 ) AS VLRVO3,
              COALESCE( V04.VLRVER, 0 ) AS VLRVO4,
              COALESCE( V05.VLRVER, 0 ) AS VLRVO5,
              COALESCE( V06.VLRVER, 0 ) AS VLRVO6,
              COALESCE( V07.VLRVER, 0 ) AS VLRVO7,
              COALESCE( V08.VLRVER, 0 ) AS VLRVO8,
              COALESCE( V09.VLRVER, 0 ) AS VLRVO9,                                                      
              COALESCE( V10.VLRVER, 0 ) AS VLRV10,                                                      
              COALESCE( V11.VLRVER, 0 ) AS VLRV11,                                                      
              COALESCE( V12.VLRVER, 0 ) AS VLRV12 
                 ,substr(ECT.TITCTA, 1, instr(titcta,' ')-1) as ARVORE              
         FROM TW_ECT ECT                                                                                
         LEFT OUTER JOIN                                                                                
              ( SELECT FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA, 
                      SUM(FIN.VLRPGT * CASE TIPO_DESPESA(CTA.FILECT, CTA.SEQECT)
                                       WHEN 'T' THEN -1 
                                       ELSE 1 
                                  END) AS VLRTO1
                  FROM TV_FIN FIN INNER JOIN TT_CTA CTA ON FIN.FILCTA=CTA.CODFIL AND FIN.SEQCTA=CTA.SEQUEN
                 WHERE FIN.DatPgt BETWEEN TO_DATE('01/01/'||pDATANO||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                                          TO_DATE('31/01/'||pDATANO||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
                   AND FIN.CODFIL = COALESCE(pCODFIL,FIN.CODFIL)
                   AND FIN.FLGFLX = 'R'
                 GROUP BY FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA ) TO1                                                  
           ON ECT.TIPCTA = TO1.TIPCTA AND ECT.FILCTA = TO1.FILCTA AND ECT.SEQCTA = TO1.SEQCTA           
         LEFT OUTER JOIN                                                                                
              ( SELECT FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA, 
                      SUM(FIN.VLRPGT * CASE TIPO_DESPESA(CTA.FILECT, CTA.SEQECT)
                                       WHEN 'T' THEN -1 
                                       ELSE 1 
                                  END) AS VLRTO2
                  FROM TV_FIN FIN INNER JOIN TT_CTA CTA ON FIN.FILCTA=CTA.CODFIL AND FIN.SEQCTA=CTA.SEQUEN
                 WHERE FIN.DatPgt BETWEEN TO_DATE('01/02/'||pDATANO||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                                          TO_DATE('28/02/'||pDATANO||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
                   AND FIN.CODFIL = COALESCE(pCODFIL,FIN.CODFIL)
                   AND FIN.FLGFLX = 'R'
              GROUP BY FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA) TO2                                                      
           ON ECT.TIPCTA = TO2.TIPCTA AND ECT.FILCTA = TO2.FILCTA AND ECT.SEQCTA = TO2.SEQCTA
         LEFT OUTER JOIN                                                                                
              ( SELECT FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA, 
                      SUM(FIN.VLRPGT * CASE TIPO_DESPESA(CTA.FILECT, CTA.SEQECT) 
                                       WHEN 'T' THEN -1 
                                       ELSE 1 
                                  END) AS VLRTO3
                  FROM TV_FIN FIN INNER JOIN TT_CTA CTA ON FIN.FILCTA=CTA.CODFIL AND FIN.SEQCTA=CTA.SEQUEN
                 WHERE FIN.DatPgt BETWEEN TO_DATE('01/03/'||pDATANO||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                                          TO_DATE('31/03/'||pDATANO||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
                   AND FIN.CODFIL = COALESCE(pCODFIL,FIN.CODFIL)
                   AND FIN.FLGFLX = 'R'
                 GROUP BY FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA ) TO3                                                  
           ON ECT.TIPCTA = TO3.TIPCTA AND ECT.FILCTA = TO3.FILCTA AND ECT.SEQCTA = TO3.SEQCTA           
         LEFT OUTER JOIN                                                                                
              ( SELECT FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA, 
                      SUM(FIN.VLRPGT * CASE TIPO_DESPESA(CTA.FILECT, CTA.SEQECT) 
                                       WHEN 'T' THEN -1 
                                       ELSE 1 
                                  END) AS VLRTO4
                  FROM TV_FIN FIN INNER JOIN TT_CTA CTA ON FIN.FILCTA=CTA.CODFIL AND FIN.SEQCTA=CTA.SEQUEN
                 WHERE FIN.DatPgt BETWEEN TO_DATE('01/04/'||pDATANO||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                                          TO_DATE('30/04/'||pDATANO||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
                   AND FIN.CODFIL = COALESCE(pCODFIL,FIN.CODFIL)
                   AND FIN.FLGFLX = 'R'
              GROUP BY FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA) TO4                                                      
           ON ECT.TIPCTA = TO4.TIPCTA AND ECT.FILCTA = TO4.FILCTA AND ECT.SEQCTA = TO4.SEQCTA           
         LEFT OUTER JOIN                                                                                
              ( SELECT FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA, 
                      SUM(FIN.VLRPGT * CASE TIPO_DESPESA(CTA.FILECT, CTA.SEQECT) 
                                       WHEN 'T' THEN -1 
                                       ELSE 1 
                                  END) AS VLRTO5
                  FROM TV_FIN FIN INNER JOIN TT_CTA CTA ON FIN.FILCTA=CTA.CODFIL AND FIN.SEQCTA=CTA.SEQUEN
                 WHERE FIN.DatPgt BETWEEN TO_DATE('01/05/'||pDATANO||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                                          TO_DATE('31/05/'||pDATANO||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
                   AND FIN.CODFIL = COALESCE(pCODFIL,FIN.CODFIL)
                   AND FIN.FLGFLX = 'R'
                 GROUP BY FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA ) TO5                                                  
           ON ECT.TIPCTA = TO5.TIPCTA AND ECT.FILCTA = TO5.FILCTA AND ECT.SEQCTA = TO5.SEQCTA           
         LEFT OUTER JOIN                                                                                
              ( SELECT FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA, 
                      SUM(FIN.VLRPGT * CASE TIPO_DESPESA(CTA.FILECT, CTA.SEQECT) 
                                       WHEN 'T' THEN -1 
                                       ELSE 1 
                                  END) AS VLRTO6
                  FROM TV_FIN FIN INNER JOIN TT_CTA CTA ON FIN.FILCTA=CTA.CODFIL AND FIN.SEQCTA=CTA.SEQUEN
                 WHERE FIN.DatPgt BETWEEN TO_DATE('01/06/'||pDATANO||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                                          TO_DATE('30/06/'||pDATANO||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
                   AND FIN.CODFIL = COALESCE(pCODFIL,FIN.CODFIL)
                   AND FIN.FLGFLX = 'R'
              GROUP BY FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA) TO6                                                      
           ON ECT.TIPCTA = TO6.TIPCTA AND ECT.FILCTA = TO6.FILCTA AND ECT.SEQCTA = TO6.SEQCTA           
         LEFT OUTER JOIN                                                                                
              ( SELECT FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA, 
                      SUM(FIN.VLRPGT * CASE TIPO_DESPESA(CTA.FILECT, CTA.SEQECT) 
                                       WHEN 'T' THEN -1 
                                       ELSE 1 
                                  END) AS VLRTO7
                  FROM TV_FIN FIN INNER JOIN TT_CTA CTA ON FIN.FILCTA=CTA.CODFIL AND FIN.SEQCTA=CTA.SEQUEN
                 WHERE FIN.DatPgt BETWEEN TO_DATE('01/07/'||pDATANO||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                                          TO_DATE('31/07/'||pDATANO||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
                   AND FIN.CODFIL = COALESCE(pCODFIL,FIN.CODFIL)
                   AND FIN.FLGFLX = 'R'
                 GROUP BY FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA ) TO7                                                  
           ON ECT.TIPCTA = TO7.TIPCTA AND ECT.FILCTA = TO7.FILCTA AND ECT.SEQCTA = TO7.SEQCTA           
         LEFT OUTER JOIN                                                                                
              ( SELECT FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA, 
                      SUM(FIN.VLRPGT * CASE TIPO_DESPESA(CTA.FILECT, CTA.SEQECT) 
                                       WHEN 'T' THEN -1 
                                       ELSE 1 
                                  END) AS VLRTO8
                  FROM TV_FIN FIN INNER JOIN TT_CTA CTA ON FIN.FILCTA=CTA.CODFIL AND FIN.SEQCTA=CTA.SEQUEN
                 WHERE FIN.DatPgt BETWEEN TO_DATE('01/08/'||pDATANO||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                                          TO_DATE('31/08/'||pDATANO||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
                   AND FIN.CODFIL = COALESCE(pCODFIL,FIN.CODFIL)
                   AND FIN.FLGFLX = 'R'
              GROUP BY FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA) TO8                                                      
           ON ECT.TIPCTA = TO8.TIPCTA AND ECT.FILCTA = TO8.FILCTA AND ECT.SEQCTA = TO8.SEQCTA           
         LEFT OUTER JOIN                                                                                
              ( SELECT FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA, 
                      SUM(FIN.VLRPGT * CASE TIPO_DESPESA(CTA.FILECT, CTA.SEQECT) 
                                       WHEN 'T' THEN -1 
                                       ELSE 1 
                                  END) AS VLRTO9
                  FROM TV_FIN FIN INNER JOIN TT_CTA CTA ON FIN.FILCTA=CTA.CODFIL AND FIN.SEQCTA=CTA.SEQUEN
                 WHERE FIN.DatPgt BETWEEN TO_DATE('01/09/'||pDATANO||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                                          TO_DATE('30/09/'||pDATANO||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
                   AND FIN.CODFIL = COALESCE(pCODFIL,FIN.CODFIL)
                   AND FIN.FLGFLX = 'R'
                 GROUP BY FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA ) TO9                                                  
           ON ECT.TIPCTA = TO9.TIPCTA AND ECT.FILCTA = TO9.FILCTA AND ECT.SEQCTA = TO9.SEQCTA           
         LEFT OUTER JOIN                                                                                
              ( SELECT FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA, 
                      SUM(FIN.VLRPGT * CASE TIPO_DESPESA(CTA.FILECT, CTA.SEQECT) 
                                       WHEN 'T' THEN -1 
                                       ELSE 1 
                                  END) AS VLRT10
                  FROM TV_FIN FIN INNER JOIN TT_CTA CTA ON FIN.FILCTA=CTA.CODFIL AND FIN.SEQCTA=CTA.SEQUEN
                 WHERE FIN.DatPgt BETWEEN TO_DATE('01/10/'||pDATANO||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                                          TO_DATE('31/10/'||pDATANO||' 23:59:59','DD/MM/YYYY HH24:MI:SS')     
                   AND FIN.CODFIL = COALESCE(pCODFIL,FIN.CODFIL)
                   AND FIN.FLGFLX = 'R'
              GROUP BY FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA) T10                                                      
           ON ECT.TIPCTA = T10.TIPCTA AND ECT.FILCTA = T10.FILCTA AND ECT.SEQCTA = T10.SEQCTA           
         LEFT OUTER JOIN                                                                                
              ( SELECT FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA, 
                      SUM(FIN.VLRPGT * CASE TIPO_DESPESA(CTA.FILECT, CTA.SEQECT) 
                                       WHEN 'T' THEN -1 
                                       ELSE 1 
                                  END) AS VLRT11
                  FROM TV_FIN FIN INNER JOIN TT_CTA CTA ON FIN.FILCTA=CTA.CODFIL AND FIN.SEQCTA=CTA.SEQUEN
                 WHERE FIN.DatPgt BETWEEN TO_DATE('01/11/'||pDATANO||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                                          TO_DATE('30/11/'||pDATANO||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
                   AND FIN.CODFIL = COALESCE(pCODFIL,FIN.CODFIL)
                   AND FIN.FLGFLX = 'R'
                 GROUP BY FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA ) T11                                                  
           ON ECT.TIPCTA = T11.TIPCTA AND ECT.FILCTA = T11.FILCTA AND ECT.SEQCTA = T11.SEQCTA           
         LEFT OUTER JOIN                                                                                
              ( SELECT FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA, 
                      SUM(FIN.VLRPGT * CASE TIPO_DESPESA(CTA.FILECT, CTA.SEQECT) 
                                       WHEN 'T' THEN -1 
                                       ELSE 1 
                                  END) AS VLRT12
                  FROM TV_FIN FIN INNER JOIN TT_CTA CTA ON FIN.FILCTA=CTA.CODFIL AND FIN.SEQCTA=CTA.SEQUEN
                 WHERE FIN.DatPgt BETWEEN TO_DATE('01/12/'||pDATANO||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND
                                          TO_DATE('31/12/'||pDATANO||' 23:59:59','DD/MM/YYYY HH24:MI:SS')
                   AND FIN.CODFIL = COALESCE(pCODFIL,FIN.CODFIL)
                   AND FIN.FLGFLX = 'R'
              GROUP BY FIN.TIPCTA, FIN.FILCTA, FIN.SEQCTA) T12                                                      
           ON ECT.TIPCTA = T12.TIPCTA AND ECT.FILCTA = T12.FILCTA AND ECT.SEQCTA = T12.SEQCTA
         LEFT JOIN TT_VER V01 ON V01.FILCTA = ECT.FILCTA
                             AND V01.SEQCTA = ECT.SEQCTA
                             AND V01.ANOVER = to_number(pDATANO)
                             AND V01.MESVER = 01
         LEFT JOIN TT_VER V02 ON V02.FILCTA = ECT.FILCTA
                             AND V02.SEQCTA = ECT.SEQCTA
                             AND V02.ANOVER = to_number(pDATANO)
                             AND V02.MESVER = 02
         LEFT JOIN TT_VER V03 ON V03.FILCTA = ECT.FILCTA
                             AND V03.SEQCTA = ECT.SEQCTA
                             AND V03.ANOVER = to_number(pDATANO)
                             AND V03.MESVER = 03
         LEFT JOIN TT_VER V04 ON V04.FILCTA = ECT.FILCTA
                             AND V04.SEQCTA = ECT.SEQCTA
                             AND V04.ANOVER = to_number(pDATANO)
                             AND V04.MESVER = 04
         LEFT JOIN TT_VER V05 ON V05.FILCTA = ECT.FILCTA
                             AND V05.SEQCTA = ECT.SEQCTA
                             AND V05.ANOVER = to_number(pDATANO)
                             AND V05.MESVER = 05
         LEFT JOIN TT_VER V06 ON V06.FILCTA = ECT.FILCTA
                             AND V06.SEQCTA = ECT.SEQCTA
                             AND V06.ANOVER = to_number(pDATANO)
                             AND V06.MESVER = 06
         LEFT JOIN TT_VER V07 ON V07.FILCTA = ECT.FILCTA
                             AND V07.SEQCTA = ECT.SEQCTA
                             AND V07.ANOVER = to_number(pDATANO)
                             AND V07.MESVER = 07
         LEFT JOIN TT_VER V08 ON V08.FILCTA = ECT.FILCTA
                             AND V08.SEQCTA = ECT.SEQCTA
                             AND V08.ANOVER = to_number(pDATANO)
                             AND V08.MESVER = 08
         LEFT JOIN TT_VER V09 ON V09.FILCTA = ECT.FILCTA
                             AND V09.SEQCTA = ECT.SEQCTA
                             AND V09.ANOVER = to_number(pDATANO)
                             AND V09.MESVER = 09
         LEFT JOIN TT_VER V10 ON V10.FILCTA = ECT.FILCTA
                             AND V10.SEQCTA = ECT.SEQCTA
                             AND V10.ANOVER = to_number(pDATANO)
                             AND V10.MESVER = 10
         LEFT JOIN TT_VER V11 ON V11.FILCTA = ECT.FILCTA
                             AND V11.SEQCTA = ECT.SEQCTA
                             AND V11.ANOVER = to_number(pDATANO)
                             AND V11.MESVER = 11
         LEFT JOIN TT_VER V12 ON V12.FILCTA = ECT.FILCTA
                             AND V12.SEQCTA = ECT.SEQCTA
                             AND V12.ANOVER = to_number(pDATANO)
                             AND V12.MESVER = 12
        WHERE ECT.USERID = USERENV('SESSIONID') ORDER BY ECT.TITCTA;
    
   RETURN 'OK';
END;
$$ language 'plpgsql';


/*-- SEQ 3056 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CRIA_BALANCETE_COMPARATIVO () CASCADE;

/*-- SEQ 3057 --*/
CREATE OR REPLACE FUNCTION CRIA_BALANCETE_COMPARATIVO () 
RETURNS VARCHAR AS $$
BEGIN
RETURN CRIA_BALANCETE_COMPARATIVO(1);
END;
$$ language 'plpgsql';


/*-- SEQ 3058 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DIVIDA (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,TT_CLI.NUMDOC%TYPE) CASCADE;

/*-- SEQ 3059 --*/
CREATE OR REPLACE FUNCTION DIVIDA (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE,TT_CLI.NUMDOC%TYPE)
RETURNS Numeric AS $$
DECLARE
pFILCLI ALIAS FOR $1 ;
pCODCLI ALIAS FOR $2 ;
pNUMDOC ALIAS FOR $3 ;
  nVal Numeric;
  cDoc TT_CLI.NUMDOC%TYPE;
  cTip Numeric;
  vNAODIV TT_CLI.NAODIV%TYPE;

BEGIN
  nVal := Null;
  cDoc := Null;
  cTip := 1;

  IF pNUMDOC IS NULL THEN
      -- Pesquisa pela Chave
      SELECT NUMDOC, FLGTIP, NAODIV
        INTO cDoc, cTip, vNAODIV
        FROM TT_CLI
       WHERE FILCLI = pFILCLI
         AND CODCLI = pCODCLI;
  ELSE
      -- Pesquisa pelo Documento
      SELECT NUMDOC, FLGTIP, NAODIV
        INTO cDoc, cTip, vNAODIV
        FROM TT_CLI
       WHERE NUMDOC = pNUMDOC;
  END IF;

  -- RFMP 76140
  -- Tratamento de clientes no
  -- sujeitos  restrio foi includa
  -- nesta funo para minimizar o impacto
  -- da retirada desta coluna das VIEWS:
  -- TV_CLI_DIV
  -- TV_CLI_DIV_FIL
  -- TV_CLI_DIV_VEN
  -- TV_CLI_DIV_CHR
  -- TV_CLI_DIV_LIM
  -- TV_CLI_DIV_CHT
  IF vNAODIV = 'F' THEN
          IF cDoc IS NOT NULL THEN
         IF (LENGTH( TRIM(cDoc) ) = 15)
         AND (cTip <> 0) THEN
            -- Busca por CNPJ
            SELECT SUM(DIV.DIVIDA+DIV.CHEDEV) INTO nVal
            FROM TV_CLI_DIV DIV
            WHERE DIV.NUMDOC BETWEEN substr(cDoc,1,8)||'000000' AND substr(cDoc,1,8)||'999999';
         ELSE
            -- Busca por CPF
            SELECT SUM(DIV.DIVIDA+DIV.CHEDEV) INTO nVal
            FROM TV_CLI_DIV DIV
            WHERE DIV.NUMDOC = cDoc;
        END IF;
      ELSE
        -- Busca por FILCLI e CODCLI
        SELECT SUM(DIV.DIVIDA+DIV.CHEDEV) INTO nVal
        FROM TV_CLI_DIV DIV
        WHERE DIV.FILCLI = pFILCLI
          AND DIV.CODCLI = pCODCLI;
      END IF;
      END IF;
  RETURN COALESCE(nVal,0);
END;
$$ language 'plpgsql';


/*-- SEQ 3060 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION DIVIDA (TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE) CASCADE;

/*-- SEQ 3061 --*/
CREATE OR REPLACE FUNCTION DIVIDA (TT_CLI.FILCLI%TYPE,
                               TT_CLI.CODCLI%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN DIVIDA($1,$2,NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 3062 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Extrato (TV_FIN.FILREC%TYPE,TV_FIN.FILCTA%TYPE,TV_FIN.SEQCTA%TYPE,TV_FIN.TIPCTA%TYPE,TV_FIN.FLGFLX%TYPE,TV_FIN.DATPGT%TYPE,TV_FIN.DATPGT%TYPE) CASCADE;

/*-- SEQ 3063 --*/
CREATE OR REPLACE FUNCTION Extrato (TV_FIN.FILREC%TYPE,TV_FIN.FILCTA%TYPE,TV_FIN.SEQCTA%TYPE,TV_FIN.TIPCTA%TYPE,TV_FIN.FLGFLX%TYPE,TV_FIN.DATPGT%TYPE,TV_FIN.DATPGT%TYPE)
RETURNS VARCHAR AS $$
DECLARE
vFILREC ALIAS FOR $1 ;
vFILCTA ALIAS FOR $2 ;
vSEQCTA ALIAS FOR $3 ;
vTIPCTA ALIAS FOR $4 ;
vFLGFLX ALIAS FOR $5 ;
vDATINI ALIAS FOR $6 ;
vDATFIM ALIAS FOR $7 ;
-- Popula a tw_ext para possibilitar a consulta de varias contas simultaneamente
BEGIN
   --DELETE FROM TW_EXT WHERE userid=userenv('SESSIONID');

   INSERT INTO TW_EXT
   (
      USERID, SALDO,  DATPGT, APEUSU, FILREC,
      DOCUME, HISTOR, FILCLI, CODCLI, NOMCLI,
      ULTNOM, TABORI, NUMDOC, VLRPGT, FLGEST,
      OBSINT, DEBITO, FILLAN, SEQLAN, PARLAN,
      SUBLAN, CREDIT, TITCRT, NOMORI, FILCTA,
      SEQCTA, TIPCTA, TITCTA, ESTORN
   )
   (
   SELECT userenv('SESSIONID') AS USERID,
          EXT.SALDO,  EXT.DATPGT, EXT.APEUSU, EXT.FILREC,
          EXT.DOCUME, EXT.HISTOR, EXT.FILCLI, EXT.CODCLI, EXT.NOMCLI,
          EXT.ULTNOM, EXT.TABORI, EXT.NUMDOC, EXT.VLRPGT, EXT.FLGEST,
          EXT.OBSINT, EXT.DEBITO, EXT.FILLAN, EXT.SEQLAN, EXT.PARLAN,
          EXT.SUBLAN, EXT.CREDIT, EXT.TITCRT, EXT.NOMORI, EXT.FILCTA,
          EXT.SEQCTA, EXT.TIPCTA, EXT.TITCTA, COALESCE(CAST(EXT.ESTORN AS CHAR(1)),'F') AS ESTORN
     FROM (
          SELECT
                                  
                 soma(INT.VLRPGT)
                                  AS SALDO,
                 INT.*, cast(COD_TITCTA(vFILCTA, vSEQCTA) as VARCHAR(255)) AS TITCTA
            FROM (
                 SELECT TAB.DATPGT, TAB.APEUSU, TAB.FILREC, Rtf2txt(TAB.DOCUME) AS DOCUME,
                        Rtf2txt(TAB.HISTOR) AS HISTOR,
                        CLI.FILCLI, CLI.CODCLI, CLI.NOMCLI, CLI.ULTNOM, TAB.TABORI, CLI.NUMDOC,
                        COALESCE(TAB.VLRPGT,0) AS VLRPGT, TAB.FLGEST, Rtf2txt(TAB.OBSINT) AS OBSINT,
                        CASE WHEN COALESCE(TAB.VLRPGT,0) < 0 THEN COALESCE(TAB.VLRPGT,0)
                        END AS DEBITO, TAB.SEQUEN, TAB.FILLAN, TAB.SEQLAN, TAB.PARLAN, TAB.SUBLAN,
                        CASE WHEN COALESCE(TAB.VLRPGT,0) >= 0 THEN COALESCE(TAB.VLRPGT,0)
                        END AS CREDIT,
                        TAB.TITCRT,
                        TAB.NOMORI,
                        vFILCTA AS FILCTA,
                        vSEQCTA AS SEQCTA,
                        vTIPCTA AS TIPCTA,
                        ESTORN  AS ESTORN 
                   FROM (
                        SELECT ADD_DAY(TRUNC(vDATINI),-1) AS DATPGT,
                               null AS TABORI,
                               null AS APEUSU,
                               COALESCE(vFILREC,CAST('   ' AS CHAR(3))) AS FILREC,
                               null AS DOCUME,
                               TO_CHAR('SALDO ANTERIOR') AS HISTOR,
                               vFLGFLX AS FLGEST,
                               SaldoConta(vFILCTA,
                                          vSEQCTA,
                                          vTIPCTA,
                                          ADD_DAY(TRUNC(vDATINI),-1),
                                          vFLGFLX,
                                          vFILREC)
                               AS VLRPGT,
                               null AS FILCLI,
                               null AS CODCLI,
                               null AS SEQUEN,
                               null AS FILLAN,
                               null AS SEQLAN,
                               null AS PARLAN,
                               null AS SUBLAN,
                               null AS OBSINT,                               
                               null AS TITCRT,
                               null AS NOMORI,
                               null AS ESTORN
                          FROM DUAL
                        UNION ALL
                        SELECT VFIN.DATPGT,
                               VFIN.TABORI,
                               USU.APEUSU,
                               VFIN.FILREC,
                               VFIN.DOCUME AS DOCUME,
                               VFIN.OBSERV AS HISTOR,
                               VFIN.FLGFLX AS FLGEST,
                               VFIN.VLRPGT,
                               VFIN.FILCLI,
                               VFIN.CODCLI,
                               COALESCE(VFIN.CODFIL,'')||COALESCE(VFIN.SEQUEN ,'') AS SEQUEN,
                               COALESCE(VFIN.CODFIL,'') AS FILLAN,
                               COALESCE(VFIN.SEQUEN,'') AS SEQLAN,
                               COALESCE(VFIN.NUMPAR,'') AS PARLAN,
                               COALESCE(VFIN.SUBPAR,'') AS SUBLAN,
                               VFIN.COMPLE AS OBSINT,                               
                               cast(COD_TITCTA(CRT.CODFIL, CRT.SEQUEN) as VARCHAR(255)) AS TITCRT,
                               VFIN.NOMORI,
                               VFIN.ESTORN AS ESTORN
                          FROM TV_FIN VFIN INNER JOIN TT_USU USU ON VFIN.FILUSU = USU.FILUSU
                                                                AND VFIN.CODUSU = USU.CODUSU
                                           INNER JOIN TT_CTA CRT ON VFIN.FILCRT = CRT.CODFIL
                                                                AND VFIN.SEQCRT = CRT.SEQUEN
                                                                AND VFIN.TIPCRT = CRT.TIPCTA
                         WHERE VFIN.FILCTA = vFILCTA
                           AND VFIN.SEQCTA = vSEQCTA
                           AND VFIN.TIPCTA = vTIPCTA
                           AND (VFIN.FLGFLX = vFLGFLX OR ISNULL(vFLGFLX)='T')
                           AND VFIN.DATPGT BETWEEN vDATINI
                                               AND vDATFIM
                           AND (VFIN.FILREC = vFILREC OR ISNULL(vFILREC)='T')

                        ) TAB LEFT JOIN TT_CLI CLI ON CLI.CODCLI = TAB.CODCLI
                                                  AND CLI.FILCLI = TAB.FILCLI
                 ORDER BY TAB.DATPGT, TAB.FILREC, TAB.FILLAN, TAB.SEQLAN, TAB.PARLAN                          
                 )INT 
          ) EXT
   );
   RETURN 'OK';
END;
$$ language 'plpgsql';


/*-- SEQ 3064 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Extrato () CASCADE;

/*-- SEQ 3065 --*/
CREATE OR REPLACE FUNCTION Extrato () 
RETURNS VARCHAR AS $$
BEGIN
RETURN Extrato(1);
END;
$$ language 'plpgsql';




/*-- SEQ 3066 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CTR CASCADE;

/*-- SEQ 3067 --*/
CREATE OR REPLACE VIEW TV_CTR AS
SELECT FIN.*, COALESCE(((FIN.VLRPGT * IVE.VLRMOV) / VEN.VLRNOT), FIN.VLRPGT) AS VLRRAT,
       COALESCE(PRO.CODCTR, VEN.CODCTR, 0) AS CODCTR
  FROM TV_FIN FIN CROSS JOIN TT_CFG CFG
                  INNER JOIN TT_REC REC ON REC.CODFIL=FIN.CODFIL AND REC.SEQUEN=FIN.SEQUEN AND REC.NUMPAR=FIN.NUMPAR AND REC.SUBPAR=FIN.SUBPAR
                  INNER JOIN TT_VEN VEN ON REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN                  
                  LEFT  JOIN TT_IVE IVE ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN 
                                       AND CFG.TIPO_CTR_VENDA = 'P' 
                                       AND IVE.SITMOV = 'N'
                                       AND IVE.SITKIT IN ('1','2')
                  LEFT  JOIN TT_PRO PRO ON PRO.FILMAT = IVE.FILMAT AND PRO.CODMAT = IVE.CODMAT                
 WHERE FIN.TABORI='REC'
   AND FIN.FLGFLX='R' 
   AND (FIN.TIPCTA='G' OR FIN.TIPCRT='G')
UNION ALL
SELECT FIN.*, FIN.VLRPGT AS VLRRAT,
       COALESCE(FAT.CODCTR,0)
  FROM TV_FIN FIN INNER JOIN TT_CCC CCC ON FIN.CODFIL=CCC.CODFIL AND FIN.SEQUEN=CCC.SEQUEN
                  INNER JOIN TT_VEN FAT ON FAT.CODFIL = CCC.CODFIL
                                       AND FAT.CODSER = 'CC'  
                                       AND FAT.NUMECF = '000'
                                       AND FAT.NUMNOT = CASE WHEN SUBSTR(CCC.NUMDOC,1,2)='CC'
                                                                         THEN SUBSTR(CCC.NUMDOC,3,6)
                                                                         ELSE SUBSTR(CCC.NUMDOC,1,6)
                                                                    END            
WHERE FIN.TABORI='CCC'
   AND FIN.FLGFLX='R' 
   AND (FIN.TIPCTA='G' OR FIN.TIPCRT='G')
UNION ALL
SELECT FIN.*, FIN.VLRPGT AS VLRRAT,
       COALESCE(TRC.CODCTR,0)
  FROM TV_FIN FIN INNER JOIN TT_TRC TRC ON FIN.CODFIL = TRC.CODFIL AND FIN.SEQUEN = TRC.SEQUEN
 WHERE FIN.TABORI='PTR'
   AND FIN.FLGFLX='R' 
   AND (FIN.TIPCTA='G' OR FIN.TIPCRT='G')
UNION ALL
SELECT FIN.*, FIN.VLRPGT AS VLRRAT,
       COALESCE(LAN.CODCTR,0)
  FROM TV_FIN FIN INNER JOIN TT_FIN LAN ON FIN.CODFIL = LAN.CODFIL AND FIN.SEQUEN = LAN.SEQUEN
 WHERE FIN.TABORI='FIN'
   AND FIN.FLGFLX='R' 
   AND (FIN.TIPCTA='G' OR FIN.TIPCRT='G')
UNION ALL
SELECT FIN.*, CASE WHEN COALESCE(CTR.VLRRAT,0) = 0 THEN FIN.VLRPGT ELSE ((FIN.VLRPGT * CTR.VLRRAT) / COM.VLRLIQ) END AS VLRRAT,
       COALESCE(CTR.CODCTR,0)
FROM TV_FIN FIN INNER JOIN TT_COM COM ON FIN.CODFIL = COM.CODFIL AND FIN.SEQUEN = COM.SEQUEN
                LEFT  JOIN TT_CTR CTR ON COM.CODFIL = CTR.CODFIL AND COM.SEQUEN = CTR.SEQUEN AND COM.TIPNOT = CTR.TIPNOT
 WHERE FIN.TABORI IN ('COM','PAG')
   AND FIN.FLGFLX='R' 
   AND (FIN.TIPCTA='G' OR FIN.TIPCRT='G')
UNION ALL
SELECT FIN.*, FIN.VLRPGT AS VLRRAT,
       0 AS CODCTR
FROM TV_FIN FIN 
 WHERE FIN.TABORI IN ('TEF','CHR','DOP','RTT')
   AND FIN.FLGFLX='R' 
   AND (FIN.TIPCTA='G' OR FIN.TIPCRT='G')   
;


/*-- SEQ 3068 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ECMS_EXP CASCADE;

/*-- SEQ 3069 --*/
CREATE OR REPLACE VIEW TV_ECMS_EXP AS
SELECT CMS.*
  FROM TV_ECMS CMS INNER JOIN TD_EXP DEXP ON DEXP.CODTAB = 1
 WHERE CMS.DATA BETWEEN TO_DATE(TO_CHAR(TRUNC(DEXP.DATINI),'DD/MM/YYYY')||' 00:00:00','DD/MM/YYYY HH24:MI:SS') AND 
                        TO_DATE(TO_CHAR(TRUNC(DEXP.DATFIM),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');


/*-- SEQ 3070 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ECT_USO CASCADE;

/*-- SEQ 3071 --*/
CREATE OR REPLACE VIEW TV_ECT_USO AS
select substr(lpad(' ',(nivel-1)*4) || titect,1,150) as local
from ( -- Ver detalhes sobre a macro em
-- \\tt2000\Docs\desenv\depto\Manuais\Ansi\connectby.mac
SELECT c.conn_codigo as codigo, case c.conn_codpai when 'NULL' then null
                                           else c.conn_codpai
               end as codpai, c.level as nivel, c.ordem-1 as ordem ,titect
FROM connectby('(select to_char(''NULL'') as filho,
                        to_char(null) as pai,
                        0 as ordem
                   from dual
                 union all
                 select TO_CHAR(chvprj) as filho,
                        coalesce(TO_CHAR(chvpai),''NULL'') as pai,
                        0 as ordem
                   from TV_AUX_ECT_USO int) tab', 'filho', 'pai','ordem', 'NULL', 0, '~')
AS c (conn_codigo VARCHAR, conn_codpai VARCHAR, level int, arvore text, ordem int)
INNER JOIN TV_AUX_ECT_USO t ON c.conn_codigo  = (chvprj)
where conn_codigo<>'NULL'
order by ordem
) tab
;


/*-- SEQ 3072 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EFIN CASCADE;

/*-- SEQ 3073 --*/
CREATE OR REPLACE VIEW TV_EFIN AS
SELECT FIN.CODFIL,
       FIN.SEQUEN,
       FIN.FILUSU,
       FIN.CODUSU,
       USU.CODEXT AS USU_CODEXT,
       FIN.DATOPE,
       CAST(CASE WHEN FIN.VLRMOV < 0 THEN '-' ELSE '+' END AS CHAR(1)) AS SINVLRMOV,
       ABS(FIN.VLRMOV) AS VLRMOV,
       FIN.NUMDOC,
       FIN.FLGFIN,
       FIN.DATFIS,
       COALESCE(FIN.ORILAN,'I') AS ORILAN,
       CAI.CX_DES,
       COALESCE(OPE.NUMECF,CAST(SUBSTR(CTA.TITCTA,16,3) AS CHAR(3))) AS NUMECF,
       FIN.ATU_EM,
       FIN.DOC_ID,
       FIN.FILUSU_REC,
       FIN.CODUSU_REC,
       FIN.DATREC
  FROM TT_FIN FIN  INNER JOIN TT_CTA CTA ON FIN.FILNUM = CTA.CODFIL
                                        AND FIN.SEQNUM = CTA.SEQUEN
                                        AND FIN.TIPNUM = CTA.TIPCTA
                   INNER JOIN TT_USU USU ON USU.FILUSU = FIN.FILUSU
                                        AND USU.CODUSU = FIN.CODUSU
                    LEFT JOIN TT_OPE OPE ON OPE.FILFIN = FIN.CODFIL
                                        AND OPE.SEQFIN = FIN.SEQUEN
                    LEFT JOIN TD_CAI CAI ON CAI.CODTAB = OPE.CODCAI
 WHERE CTA.USOCTA = 'E'
;


/*-- SEQ 3074 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ERFIN CASCADE;

/*-- SEQ 3075 --*/
CREATE OR REPLACE VIEW TV_ERFIN AS
SELECT RFIN.CODFIL,
       RFIN.SEQUEN,
       RFIN.NUMPAR,
       RFIN.SUBPAR,
       RFIN.FILUSU,
       RFIN.CODUSU,
       USU.CODEXT AS USU_CODEXT,
       RFIN.DATLAN AS DATOPE,
       CASE WHEN (RFIN.VLRLAN>0 AND RFIN.TIPCTA='N') OR  (RFIN.VLRLAN<0 AND RFIN.TIPCTA='G')
            THEN CTA.CODEXT --INVERTE CONTAS
            ELSE CRT.CODEXT
       END AS DEBITO,
       CASE WHEN (RFIN.VLRLAN>0 AND RFIN.TIPCTA='N') OR  (RFIN.VLRLAN<0 AND RFIN.TIPCTA='G')
            THEN CRT.CODEXT --INVERTE CONTAS
            ELSE CTA.CODEXT
       END AS CREDITO,
       CASE WHEN (RFIN.VLRLAN>0 AND RFIN.TIPCTA='N') OR  (RFIN.VLRLAN<0 AND RFIN.TIPCTA='G')
            THEN CTA.TITCTA --INVERTE CONTAS
            ELSE CRT.TITCTA
       END AS TIT_DEBITO,
       CASE WHEN (RFIN.VLRLAN>0 AND RFIN.TIPCTA='N') OR  (RFIN.VLRLAN<0 AND RFIN.TIPCTA='G')
            THEN CRT.TITCTA --INVERTE CONTAS
            ELSE CTA.TITCTA
       END AS TIT_CREDITO,
       CAST(CASE WHEN RFIN.VLRLAN < 0 THEN '-' ELSE '+' END AS CHAR(1)) AS SINVLRMOV,
       ABS(RFIN.VLRLAN) AS VLRMOV,
       RFIN.ORIGEM,
       RFIN.TIPLAN,
       RFIN.FILCLI,
       RFIN.CODCLI,
       RFIN.FILCTA,
       RFIN.SEQCTA,
       RFIN.TIPCTA,
       RFIN.FILCRT,
       RFIN.SEQCRT,
       RFIN.TIPCRT,
       RFIN.ATU_EM,
       RFIN.DATINCORI,
       ComplementoDadosFinanceiros(RFIN.ORIGEM, RFIN.CODFIL, RFIN.SEQUEN, RFIN.NUMPAR, RFIN.SUBPAR, 1) AS OBSERV,
       ComplementoDadosFinanceiros(RFIN.ORIGEM, RFIN.CODFIL, RFIN.SEQUEN, RFIN.NUMPAR, RFIN.SUBPAR, 3) AS DOCUME,
       ComplementoDadosFinanceiros(RFIN.ORIGEM, RFIN.CODFIL, RFIN.SEQUEN, RFIN.NUMPAR, RFIN.SUBPAR, 2) AS COMPLE,
       ComplementoDadosFinanceiros(RFIN.ORIGEM, RFIN.CODFIL, RFIN.SEQUEN, RFIN.NUMPAR, RFIN.SUBPAR, 5) AS EXPORTACAO_EME4,
       ComplementoDadosFinanceiros(RFIN.ORIGEM, RFIN.CODFIL, RFIN.SEQUEN, RFIN.NUMPAR, RFIN.SUBPAR, 6) AS CHAVE_ENDFAT,
       ComplementoDadosFinanceiros(RFIN.ORIGEM, RFIN.CODFIL, RFIN.SEQUEN, RFIN.NUMPAR, RFIN.SUBPAR, 7) AS EXPORTADO_EME4
  FROM TR_FIN RFIN  INNER JOIN TT_CTA CTA ON RFIN.FILCTA = CTA.CODFIL
                                         AND RFIN.SEQCTA = CTA.SEQUEN
                                         AND RFIN.TIPCTA = CTA.TIPCTA
                    INNER JOIN TT_CTA CRT  ON RFIN.FILCRT = CRT.CODFIL
                                          AND RFIN.SEQCRT = CRT.SEQUEN
                                          AND RFIN.TIPCRT = CRT.TIPCTA
                    INNER JOIN TT_USU USU ON USU.FILUSU = RFIN.FILUSU
                                         AND USU.CODUSU = RFIN.CODUSU
;


/*-- SEQ 3076 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE CASCADE;

/*-- SEQ 3077 --*/
CREATE OR REPLACE VIEW TV_EVE AS
SELECT TIPEVE,
       CAST(DESEVE AS VARCHAR(40)) AS DESEVE,
       CODFIL,
       CAST(EVE_ID AS VARCHAR(40)) AS EVE_ID,
       DATOPE,
       CAST(EVE_ID AS VARCHAR(30)) AS SITEVE,
       FILUSU,CODUSU,FILCLI,CODCLI,
       CAST(CHVEVE AS VARCHAR(30)) AS CHVEVE,
       VLREVE,FLGEST,MSGEVE,COREVE
FROM ( 
  SELECT  TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_WOR  UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_REC) UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_CHR) UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_LOG) UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_ORC) UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_OS ) UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_PRE) UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_COM) UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_PAG) UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_PED) UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_VEN) UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_SUP) UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_REG) UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_LRCP)UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_CCC) UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_BON) UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_MAI) UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_RES) UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_IRO) UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_COR) UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_COB) UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_DEV) UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_REN) UNION ALL
  (SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_DOP)
) TAB
 ;


/*-- SEQ 3078 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EVE_FIN CASCADE;

/*-- SEQ 3079 --*/
CREATE OR REPLACE VIEW TV_EVE_FIN AS
SELECT TIPEVE,
       CAST(DESEVE AS VARCHAR(40)) AS DESEVE,
       CODFIL,
       CAST(EVE_ID AS VARCHAR(40)) AS EVE_ID,
       DATOPE,
       CAST(EVE_ID AS VARCHAR(30)) AS SITEVE,
       FILUSU,CODUSU,FILCLI,CODCLI,
       CAST(CHVEVE AS VARCHAR(30)) AS CHVEVE,
       VLREVE,FLGEST,MSGEVE,COREVE
FROM ( 
 SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_VEN  UNION ALL
(SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_REC) UNION ALL
(SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_CHR) UNION ALL
(SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_COM) UNION ALL
(SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_PAG) UNION ALL
(SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_TRC) UNION ALL
(SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_PTR) UNION ALL
(SELECT TIPEVE,DESEVE,CODFIL,EVE_ID,DATOPE,SITEVE,FILUSU,CODUSU,FILCLI,CODCLI,CHVEVE,VLREVE,FLGEST,MSGEVE,COREVE FROM TV_EVE_CCC) 
) TAB
 ;




/*-- SEQ 3080 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ICO_ESP CASCADE;

/*-- SEQ 3081 --*/
CREATE OR REPLACE VIEW TV_ICO_ESP AS
SELECT ICO.CODFIL,
       ICO.COM_DATOPE,
       ICO.QTDMOV,
       TRIM(FPV.NUMNOT) AS NUMNOT,
       CAST (FPV.NUMNOT AS INTEGER) AS NUMNOT_PESQ, --GES-2022042528
       GXF.REFFOR,
       ICO.CODCFO,
       PRO.REFBAS,
       PRO.DESMAT,
       PRO.ESPMAT,
       MED.UNIMED,
       CAST((ICO.VLRMOV/NVLZ(ICO.QTDMOV,1)) AS Numeric(12,2)) AS VLRMOV_UNI,
       CUSTODATA('1',ICO.COM_DATOPE, ICO.FILMAT, ICO.CODMAT, ICO.CODCOR, ICO.CODTAM, ICO.CODFIL, ICO.CODMUL) AS CUSCOM,
       CUSTODATA('1',ADD_SECOND(ICO.COM_DATOPE, -1), ICO.FILMAT, ICO.CODMAT, ICO.CODCOR, ICO.CODTAM, ICO.CODFIL, ICO.CODMUL) AS ULTCOM,
       VFOR.NOMCLI,
       FPV.VLRLUC,
       FPV.CUSFIN,
       FPV.PRECAL,
       FPV.PRECOV,
       ((ICO.QTDCOM * ICO.CUSFRE) - ICO.ST_FRE) AS TOT_CUSFRE,
       ICO.ST_FRE, GRA.REFPRO, FPV.CUSAQS
       FROM TT_ICO ICO INNER JOIN TV_FPV_TOT FPV ON ICO.CODFIL = FPV.CODFIL
                                                AND ICO.SEQUEN = FPV.SEQUEN
                                                AND ICO.NUMITE = FPV.NUMITE
                                                AND ICO.FILMAT = FPV.FILMAT
                                                AND ICO.CODMAT = FPV.CODMAT
                                                AND ICO.CODCOR = FPV.CODCOR
                                                AND ICO.CODTAM = FPV.CODTAM
                            LEFT JOIN TT_REF GXF ON ICO.FILMAT = GXF.FILMAT
                                                AND ICO.CODMAT = GXF.CODMAT
                                                AND ICO.CODCOR = GXF.CODCOR
                                                AND ICO.CODTAM = GXF.CODTAM
                                                AND FPV.FILFOR = GXF.FILFOR
                                                AND FPV.CODFOR = GXF.CODFOR
                          INNER JOIN TV_FOR VFOR ON FPV.FILFOR = VFOR.FILCLI
                                                AND FPV.CODFOR = VFOR.CODCLI
                          INNER JOIN TT_PRO PRO  ON ICO.FILMAT = PRO.FILMAT
                                                AND ICO.CODMAT = PRO.CODMAT
                          INNER JOIN TD_MED MED  ON ICO.UNICOM = MED.CODTAB
                          INNER JOIN TT_GRA GRA  ON ICO.FILMAT = GRA.FILMAT  
                                                AND ICO.CODMAT = GRA.CODMAT
                                                AND ICO.CODTAM = GRA.CODTAM
                                                AND ICO.CODCOR = GRA.CODCOR
                          CROSS JOIN TT_CFG CFG
       WHERE VFOR.FLGTIP <> 5
         AND FPV.FILPRE = CFG.FILPRE
         AND FPV.CODPRE = CFG.CODPRE
;










/*-- SEQ 3082 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_SUP_MSG CASCADE;

/*-- SEQ 3083 --*/
CREATE OR REPLACE VIEW TV_SUP_MSG AS
SELECT MSG.CODFIL, 
       MSG.SEQUEN, 
       MSG.DATMSG,
       COALESCE(CON.NOMTRA,CON.CONTAT,USU.APEUSU) AS PESSOA,
       replace(MSG.MSGSUP,'\par'||chr(13)||chr(10),'[*PARAGRAFO*]'||chr(13)||chr(10)) as MSGSUP,
       MSG.DESMSG
  FROM TT_MSG MSG INNER JOIN TT_USU USU ON MSG.FILUSU = USU.FILUSU AND MSG.CODUSU = USU.CODUSU
             LEFT OUTER JOIN TT_CON CON ON MSG.FILCLI = CON.FILCLI AND MSG.CODCLI = CON.CODCLI AND MSG.NUMCON = CON.NUMCON
 ;






/*-- SEQ 3084 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_WOR_MSG CASCADE;

/*-- SEQ 3085 --*/
CREATE OR REPLACE VIEW TV_WOR_MSG AS
SELECT WOR.CODFIL, WOR.SEQUEN,
       SUP.CODFIL AS FILSUP,
       SUP.SEQUEN AS SEQSUP,
       MSG.DATMSG, 
       replace(MSG.MSGSUP,'\par'||chr(13)||chr(10),'[*PARAGRAFO*]'||chr(13)||chr(10)) as MSGSUP,
       COALESCE(CON.NOMTRA,CON.CONTAT,USU.APEUSU) AS PESSOA,
       MSG.DESMSG
  FROM TT_USU USU INNER JOIN TT_MSG MSG ON MSG.FILUSU = USU.FILUSU AND MSG.CODUSU = USU.CODUSU
                  INNER JOIN TT_SUP SUP ON SUP.CODFIL = MSG.CODFIL AND SUP.SEQUEN = MSG.SEQUEN
                  INNER JOIN TT_SUPxWOR SxW ON SUP.CODFIL = SxW.FILSUP AND SUP.SEQUEN = SxW.SEQSUP
                  INNER JOIN TT_WOR WOR ON WOR.CODFIL = SxW.FILWOR AND WOR.SEQUEN = SxW.SEQWOR
             LEFT OUTER JOIN TT_CON CON ON MSG.FILCLI = CON.FILCLI AND MSG.CODCLI = CON.CODCLI AND MSG.NUMCON = CON.NUMCON  
 ;




/*-- SEQ 3086 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CRIA_TW_ECT_CTA (VARCHAR,TT_CTA.CODFIL%TYPE,TT_DAT.DATOPE%TYPE,TT_DAT.DATOPE%TYPE,VARCHAR,TW_CTA.CHV_ID%TYPE) CASCADE;

/*-- SEQ 3087 --*/
CREATE OR REPLACE FUNCTION CRIA_TW_ECT_CTA (VARCHAR,TT_CTA.CODFIL%TYPE,TT_DAT.DATOPE%TYPE,TT_DAT.DATOPE%TYPE,VARCHAR,TW_CTA.CHV_ID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pTIPBAL ALIAS FOR $1 ;
pCODFIL ALIAS FOR $2 ;
pDATINI ALIAS FOR $3 ;
pDATFIM ALIAS FOR $4 ;
pDATANO ALIAS FOR $5 ;
pCHV_ID ALIAS FOR $6 ;

  cRETURN VARCHAR(2);

-- Popula a tw_ect e a tw_cta para visualizar o tipo de balancete escolhido

--            comparativo           analitico
-- pTIPBAL    "C"                   "A"
-- pCODFIL    filial ou null        filial ou null
-- pDATINI    null                  data inicial 
-- pDATFIM    null                  data final
-- pDATANO    ano                   null 
-- pCHV_ID    conta origem ou null  conta origem ou null
BEGIN

   DELETE FROM TW_ECT;
   
   DELETE FROM TW_CTA;
   
   INSERT INTO TW_ECT
   (USERID,CHV_ID,TIPCTA,SEQCTA,FILCTA,CHVPAI,TITCTA)
   SELECT USERID,
           CHV_ID,TIPCTA,SEQCTA,FILCTA,CHVPAI,
           CASE WHEN TIPCTA = 'T' THEN CODIGO_CONTA(filcta, seqcta,'E') ELSE  CODIGO_CONTA(filcta, seqcta, 'A') END ||' - ' ||TITCTA as TITCTA
     FROM TV_ECT ORDER BY TITCTA;

   IF ISNULL(pCHV_ID) = 'F' THEN
            
      DELETE FROM TW_ECT                              
       WHERE CHV_ID IN                                
            (SELECT CHV_ID                            
               FROM TW_CTA                            
              WHERE ARVORE LIKE (SELECT ARVORE||'%'
                                   FROM TW_CTA        
                                  WHERE CHV_ID = pCHV_ID
                                    AND USERID = USERENV('SESSIONID')))
         AND USERID = USERENV('SESSIONID');
         END IF;
   
   IF pTIPBAL = 'C' THEN
      cRETURN := CRIA_BALANCETE_COMPARATIVO(pCODFIL,pDATANO);
   ELSIF pTIPBAL = 'A' THEN 
      cRETURN := CRIA_BALANCETE_ANALITICO(pCODFIL,pDATINI,pDATFIM);
   END IF;
   
              
   IF Reordene_NO_WCTA(NULL,NULL,USERENV('SESSIONID')) <> NULL THEN
      cRETURN := NULL;
   END IF;
       
   RETURN cRETURN;
END;
$$ language 'plpgsql';


/*-- SEQ 3088 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CRIA_TW_ECT_CTA () CASCADE;

/*-- SEQ 3089 --*/
CREATE OR REPLACE FUNCTION CRIA_TW_ECT_CTA () 
RETURNS VARCHAR AS $$
BEGIN
RETURN CRIA_TW_ECT_CTA(1);
END;
$$ language 'plpgsql';


/*-- SEQ 3090 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION CargaConfig () CASCADE;

/*-- SEQ 3091 --*/
CREATE OR REPLACE FUNCTION CargaConfig ()
RETURNS VARCHAR AS $$
DECLARE

BEGIN
   -- 1) Limpa a TW_TAB;
   DELETE FROM TW_TAB;

   -- 2) Popula a TW_TAB a partir da TD_IND
   INSERT INTO TW_TAB (CODTAB) (SELECT CODTAB FROM TD_IND);

   -- 3) Update na TW_TAB com os dados de outras TDs
   UPDATE TW_TAB
   SET COBATI = B.COBATI,
        DESCOB = B.DESCOB,
        LARUNI = B.LARUNI,
        SAICAR = B.SAICAR,
        TIPCOB = B.TIPCOB,
        FILCTA = B.FILCTA,
        SEQCTA = B.SEQCTA,
        TIPCTA = B.TIPCTA,
        GERTIT = B.GERTIT,
        TIPCTB = B.TIPCTB,
        CODCCB = B.CODCCB,
        TITCTA = B.TITCTA,
        CARATI = B.CARATI,
        DESOUT = B.DESOUT,
        DIACAR = B.DIACAR,
        TAXCAR = B.TAXCAR,
        PROCAR = B.PROCAR,
        PORCAR = B.PORCAR,
        COBCAR = B.COBCAR,
        FILADM = B.FILADM,
        CODADM = B.CODADM,
        TIPADM = B.TIPADM,
        FILCAR = B.FILCAR,
        SEQCAR = B.SEQCAR,
        TIPCAR = B.TIPCAR,
        CTACAR = B.CTACAR,
        TAXDEB = B.TAXDEB,
        DIADEB = B.DIADEB,
        TITCAR = B.TITCAR,
        CLIADM = B.CLIADM,
        CX_ATI = B.CX_ATI,
        CX_COD = B.CX_COD,
        CX_DES = B.CX_DES,
        CX_USU = B.CX_USU,
        CX_HIS = B.CX_HIS,
        FILCAI = B.FILCAI,
        SEQCAI = B.SEQCAI,
        TIPCAI = B.TIPCAI,
        CTACAI = B.CTACAI,
        TRANSF = B.TRANSF,
        TITCAI = B.TITCAI,
        MODULO = B.MODULO,
        MODATI = B.MODATI,
        FILSAC = B.FILSAC,
        CODSAC = B.CODSAC,
        FILTST = B.FILTST,
        CODTST = B.CODTST,
        FILWOR = B.FILWOR,
        CODWOR = B.CODWOR,
        FILINT = B.FILINT,
        CODINT = B.CODINT,
        VERATU = B.VERATU,
        SACUSU = B.SACUSU,
        WORUSU = B.WORUSU,
        INTUSU = B.INTUSU,
        TSTUSU = B.TSTUSU,
        COMUSU = B.COMUSU,
        DOMDOP = B.DOMDOP,
        DESSTD = B.DESSTD,
        STDATI = B.STDATI,
        USOSTD = B.USOSTD,
        FLGFLX = B.FLGFLX,
        DESDOP_STD = B.DESDOP_STD,
        FILECF = B.FILECF,
        NUMECF = B.NUMECF,
        SERECF = B.SERECF,
        ECFATI = B.ECFATI,
        PORECF = B.PORECF,
        COBECF = B.COBECF,
        CODORI = B.CODORI,
        CODMUL = B.CODMUL,
        SAIENV = B.SAIENV,
        FILMAT = B.FILMAT,
        CODMAT = B.CODMAT,
        CODCOR = B.CODCOR,
        CODTAM = B.CODTAM,
        DESLIB = B.DESLIB,
        CODLIB = B.CODLIB,
        LIBATI = B.LIBATI,
        DESMAT = B.DESMAT,
        CCBTIT = B.CCBTIT,
        GRUMOD = B.GRUMOD,
        MAQECF = B.MAQECF,
        CODCTR = B.CODCTR,
        COBPAD = B.COBPAD,
        MARECF = B.MARECF,
        MODECF = B.MODECF,
        VSWECF = B.VSWECF,
        CODFAB = B.CODFAB,
        CODMOD = B.CODMOD,
        DSWECF = B.DSWECF,
        FITDET = B.FITDET,
        ECFUTL = B.ECFUTL,
        ECFMFA = B.ECFMFA,
        ECFTIP = B.ECFTIP,
        ECFCOL = B.ECFCOL,
        TNCIEE = B.TNCIEE,
        FILCOM = B.FILCOM,
        CODCOM = B.CODCOM,
        CODEXT_DECF = B.CODEXT_DECF,
        MAXCAI = B.MAXCAI,
        VLRMBL = B.VLRMBL,
        VLRABL = B.VLRABL,
        CK4G_MANMOV = B.CK4G_MANMOV,
        CK4G_MANLOG_DET = B.CK4G_MANLOG_DET,
        CK4G_MANLOG_GER = B.CK4G_MANLOG_GER,
        CK4G_HOMOL = B.CK4G_HOMOL,
        STATUS_DADOS = B.STATUS_DADOS,
        CARLET = B.CARLET,
        CARIMG = B.CARIMG,
        CARLIM = B.CARLIM,
        CARNIV = B.CARNIV,
        REGCAR = B.REGCAR,
        MINAUT = B.MINAUT,
        NIVLOG = B.NIVLOG,
        COBLET = B.COBLET,
        COBIMG = B.COBIMG,
        COBNIV = B.COBNIV,
        CK4G_BARRASALTURA = B.CK4G_BARRASALTURA,
        CK4G_BARRASLARGURA = B.CK4G_BARRASLARGURA,
        CK4G_BARRASPADRAO = B.CK4G_BARRASPADRAO,
        CK4G_INTERVALOCARGADESALDOS = B.CK4G_INTERVALOCARGADESALDOS,
        CK4G_ACAOPADRAO = B.CK4G_ACAOPADRAO,
        CK4G_USAFRETE = B.CK4G_USAFRETE,
        CK4G_ZSOMENTEAPOS24H = B.CK4G_ZSOMENTEAPOS24H,
        CK4G_VALIDADE = B.CK4G_VALIDADE,
        CK4G_MD5 = B.CK4G_MD5,
        CK4G_MODFIS_VC = B.CK4G_MODFIS_VC,
        CK4G_MODFIS_VC_CONT = B.CK4G_MODFIS_VC_CONT,
        CK4G_USA_CONT_OFFLINE = B.CK4G_USA_CONT_OFFLINE,
        FLGCFE = B.FLGCFE,
        CX_MAX = B.CX_MAX,
        DECF_NUMEXT = B.DECF_NUMEXT,
        CAIMEN = B.CAIMEN,
        CODCRE = B.CODCRE,
        EXTDEB = B.EXTDEB,
        EXTCRE = B.EXTCRE,
        CODEXT_DCOB = B.CODEXT_DCOB,
        BANDEB = B.BANDEB,
        BANCRE = B.BANCRE,
        DESMTD = B.DESMTD,
        MTDATI = B.MTDATI,
        DESCMO = B.DESCMO,
        TIPCOM = B.TIPCOM,
        CILIND = B.CILIND,
        POTENC = B.POTENC,
        MTOATI = B.MTOATI,
        CODVEI = B.CODVEI,
        DESMDV = B.DESMDV,
        DISEXI = B.DISEXI,
        CODMAR = B.CODMAR,
        MDVATI = B.MDVATI,
        DESCORVEI = B.DESCORVEI,
        CORVEIATI = B.CORVEIATI,
        CODCORDEN = B.CODCORDEN
  FROM TV_TAB_001 B
 WHERE TW_TAB.CODTAB = B.CODTAB;

   -- 4) Update na TW_TAB com os dados de outras TDs
   UPDATE TW_TAB
   SET SINLAN = B.SINLAN,
        DESLAN = B.DESLAN,
        LANATI = B.LANATI,
        LANVLR = B.LANVLR,
        LANEDI = B.LANEDI,
        LANNAT = B.LANNAT,
        MOVLEG = B.MOVLEG,
        FILLAN = B.FILLAN,
        ESPATI = B.ESPATI,
        ESPECI = B.ESPECI,
        NATATI = B.NATATI,
        NATURE = B.NATURE,
        TIPNAT = B.TIPNAT,
        USAICM = B.USAICM,
        USAIPI = B.USAIPI,
        MOVEST = B.MOVEST,
        USACUS = B.USACUS,
        LIMITE = B.LIMITE,
        COMENT = B.COMENT,
        NATDEN = B.NATDEN,
        NATFOR = B.NATFOR,
        NATFUD = B.NATFUD,
        NATFUF = B.NATFUF,
        SERVIN = B.SERVIN,
        FINANC = B.FINANC,
        OBSERV = B.OBSERV,
        NATOLN = B.NATOLN,
        TRIBUT = B.TRIBUT,
        LANVEN = B.LANVEN,
        NATRED = B.NATRED,
        NATREF = B.NATREF,
        EXTDEM = B.EXTDEM,
        EXTFOR = B.EXTFOR,
        NATMUL = B.NATMUL,
        MODNOT = B.MODNOT,
        SERATI = B.SERATI,
        CODSER = B.CODSER,
        DESSER = B.DESSER,
        EXTNOT = B.EXTNOT,
        DISSAI = B.DISSAI,
        IMPNOT = B.IMPNOT,
        QTDITP = B.QTDITP,
        QTDITS = B.QTDITS,
        SERMAN = B.SERMAN,
        RESTRI = B.RESTRI,
        DIVTRO = B.DIVTRO,
        SERINI = B.SERINI,
        SERFIM = B.SERFIM,
        OBSLIN = B.OBSLIN,
        OBSCOL = B.OBSCOL,
        ICMATI = B.ICMATI,
        RESICM = B.RESICM,
        IPIATI = B.IPIATI,
        RESIPI = B.RESIPI,
        ISSATI = B.ISSATI,
        RESISS = B.RESISS,
        IRRATI = B.IRRATI,
        RESIRR = B.RESIRR,
        ES_ATI = B.ES_ATI,
        ICMSES = B.ICMSES,
        ME_ATI = B.ME_ATI,
        ICMSME = B.ICMSME,
        RE_ATI = B.RE_ATI,
        ICMSRE = B.ICMSRE,
        APLCON = B.APLCON,
        REDTRA = B.REDTRA,
        R1_ATI = B.R1_ATI,
        ICMSR1 = B.ICMSR1,
        R2_ATI = B.R2_ATI,
        ICMSR2 = B.ICMSR2,
        FISATI = B.FISATI,
        CODFIS = B.CODFIS,
        MOEATI = B.MOEATI,
        DESMOE = B.DESMOE,
        PRIATI = B.PRIATI,
        DESPRI = B.DESPRI,
        OBSPRI = B.OBSPRI,
        HORTRN = B.HORTRN,
        HORPAD = B.HORPAD,
        TIPHOR = B.TIPHOR,
        PESPRI = B.PESPRI,
        APEPRI = B.APEPRI,
        FUNATI = B.FUNATI,
        DESFUN = B.DESFUN,
        CODFUN = B.CODFUN,
        TIPFUN = B.TIPFUN,
        CL1ATI = B.CL1ATI,
        CL1WEB = B.CL1WEB,
        CLASS1 = B.CLASS1,
        CODEX1 = B.CODEX1,
        CL2ATI = B.CL2ATI,
        CL2WEB = B.CL2WEB,
        CLASS2 = B.CLASS2,
        CODEX2 = B.CODEX2,
        CL3ATI = B.CL3ATI,
        CL3WEB = B.CL3WEB,
        CLASS3 = B.CLASS3,
        CODEX3 = B.CODEX3,
        CL4ATI = B.CL4ATI,
        CL4WEB = B.CL4WEB,
        CLASS4 = B.CLASS4,
        CODEX4 = B.CODEX4,
        ETIATI = B.ETIATI,
        DESETI = B.DESETI,
        RBFILE = B.RBFILE,
        CT1ATI = B.CT1ATI,
        NOMCT1 = B.NOMCT1,
        CODEXT_DCT1 = B.CODEXT_DCT1,
        CT2ATI = B.CT2ATI,
        NOMCT2 = B.NOMCT2,
        CODEXT_DCT2 = B.CODEXT_DCT2,
        CT3ATI = B.CT3ATI,
        NOMCT3 = B.NOMCT3,
        CODEXT_DCT3 = B.CODEXT_DCT3,
        MEDATI = B.MEDATI,
        UNIMED = B.UNIMED,
        DESMED = B.DESMED,
        SAZATI = B.SAZATI,
        DESSAZ = B.DESSAZ,
        SAZ001 = B.SAZ001,
        SAZ002 = B.SAZ002,
        SAZ003 = B.SAZ003,
        SAZ004 = B.SAZ004,
        SAZ005 = B.SAZ005,
        SAZ006 = B.SAZ006,
        SAZ007 = B.SAZ007,
        SAZ008 = B.SAZ008,
        SAZ009 = B.SAZ009,
        SAZ010 = B.SAZ010,
        SAZ011 = B.SAZ011,
        SAZ012 = B.SAZ012,
        OUTATI = B.OUTATI,
        DESCAR = B.DESCAR,
        DADREC = B.DADREC,
        COMATI = B.COMATI,
        DESCOM = B.DESCOM,
        NUMCOM = B.NUMCOM,
        DEPATI = B.DEPATI,
        DEPWEB = B.DEPWEB,
        DESDEP = B.DESDEP,
        IMGDEP = B.IMGDEP,
        CONTAB = B.CONTAB,
        REGATI = B.REGATI,
        REGIAO = B.REGIAO,
        CEPINI = B.CEPINI,
        CEPFIM = B.CEPFIM,
        PREATI = B.PREATI,
        DESPRE = B.DESPRE,
        NUMPRE = B.NUMPRE,
        USOPRE = B.USOPRE,
        CONATI = B.CONATI,
        DESCON = B.DESCON,
        TIPCON = B.TIPCON,
        CLACON = B.CLACON,
        DESFIN = B.DESFIN,
        FINATI = B.FINATI,
        CARTAO = B.CARTAO,
        TRIATI = B.TRIATI,
        CODTRI = B.CODTRI,
        MARATI = B.MARATI,
        PHOMAR = B.PHOMAR,
        TIPATI = B.TIPATI,
        PHOTIP = B.PHOTIP,
        ISOATI = B.ISOATI,
        PHOISO = B.PHOISO,
        PHOATI = B.PHOATI,
        PHOOUT = B.PHOOUT,
        AMPATI = B.AMPATI,
        PHOLAR = B.PHOLAR,
        PHOALT = B.PHOALT,
        PHOCOM = B.PHOCOM,
        TCCATI = B.TCCATI,
        TEFPRC = B.TEFPRC,
        TEFJRC = B.TEFJRC,
        TCDATI = B.TCDATI,
        TEFPRO = B.TEFPRO,
        TEFJRD = B.TEFJRD,
        TEFENT = B.TEFENT,
        ROSATI = B.ROSATI,
        RESULT = B.RESULT,
        OBSATI = B.OBSATI,
        USUOBS = B.USUOBS,
        DESOBS = B.DESOBS,
        TXTOBS = B.TXTOBS,
        GRAATI = B.GRAATI,
        NOMGRA = B.NOMGRA,
        CODDIV = B.CODDIV,
        CODSUB = B.CODSUB,
        DIVATI = B.DIVATI,
        NOMDIV = B.NOMDIV,
        ORDDIV = B.ORDDIV,
        SUBATI = B.SUBATI,
        NOMSUB = B.NOMSUB,
        ORDSUB = B.ORDSUB,
        CODSAL = B.CODSAL,
        DESATV = B.DESATV,
        TIPDES = B.TIPDES,
        DESVTP = B.DESVTP,
        VTPATI = B.VTPATI,
        ECBATI = B.ECBATI,
        DESECB = B.DESECB,
        INSATI = B.INSATI,
        DESINS = B.DESINS,
        QTDDIA = B.QTDDIA,
        REMATI = B.REMATI,
        DESREM = B.DESREM,
        RETATI = B.RETATI,
        DESRET = B.DESRET,
        FLGNEW = B.FLGNEW,
        CCBATI = B.CCBATI,
        DESCCB = B.DESCCB,
        APECCB = B.APECCB,
        TIPCCB = B.TIPCCB,
        ENVREM = B.ENVREM,
        DESHOM = B.DESHOM,
        ATIHOM = B.ATIHOM,
        CODHOM = B.CODHOM,
        DESMUL = B.DESMUL,
        MULATI = B.MULATI,
        CODEXT_DMUL = B.CODEXT_DMUL,
        MULWEB = B.MULWEB,
        LIVRE = B.LIVRE,
        DESDEV = B.DESDEV,
        DEVATI = B.DEVATI,
        DEVCOM = B.DEVCOM,
        DEVMON = B.DEVMON,
        DEVICM = B.DEVICM,
        MULDEV = B.MULDEV,
        DEVATE = B.DEVATE,
        USODEV = B.USODEV,
        VLRDEV = B.VLRDEV,
        CLIDEV = B.CLIDEV,
        DESOCU = B.DESOCU,
        BASOCU = B.BASOCU,
        DESMON = B.DESMON,
        MONURB = B.MONURB,
        MONINT = B.MONINT,
        MONDEN = B.MONDEN,
        MONCOR = B.MONCOR,
        MONATI = B.MONATI,
        DESINA = B.DESINA,
        INAATI = B.INAATI,
        USOINA = B.USOINA,
        DESARC = B.DESARC,
        ARCATV = B.ARCATV,
        TIPARC = B.TIPARC,
        TITCOR = B.TITCOR,
        RB_COR = B.RB_COR,
        CORATV = B.CORATV,
        CODDFC = B.CODDFC,
        DESDFC = B.DESDFC,
        DFCATI = B.DFCATI,
        DESCFO = B.DESCFO,
        CFOATI = B.CFOATI,
        CODCFO = B.CODCFO,
        EXTCFO = B.EXTCFO,
        DESEND = B.DESEND,
        ENDATV = B.ENDATV,
        DUPEND = B.DUPEND,
        USOEND = B.USOEND,
        DESAPR = B.DESAPR,
        APROVA = B.APROVA,
        APRATI = B.APRATI,
        FILTAN = B.FILTAN,
        TANQUE = B.TANQUE,
        GRAFIL = B.GRAFIL,
        GRACOD = B.GRACOD,
        GRACOR = B.GRACOR,
        GRATAM = B.GRATAM,
        TANATV = B.TANATV,
        QTDLTS = B.QTDLTS,
        FILBIC = B.FILBIC,
        CODTAN = B.CODTAN,
        SEQFIL = B.SEQFIL,
        SEQBOM = B.SEQBOM,
        QTDENC = B.QTDENC,
        NIVPRE = B.NIVPRE,
        MAXCHE = B.MAXCHE,
        BICATV = B.BICATV,
        CONSFI = B.CONSFI,
        SEQEXC = B.SEQEXC,
        DEVVIN = B.DEVVIN,
        DESAMB = B.DESAMB,
        AMBATI = B.AMBATI,
        NATCL1 = B.NATCL1,
        SUGEST = B.SUGEST,
        PRECAL = B.PRECAL,
        CFOMOD = B.CFOMOD,
        NATMOD = B.NATMOD,
        SERUTL = B.SERUTL,
        TITAVU = B.TITAVU,
        SERORD = B.SERORD,
        SERDOC = B.SERDOC,
        NATUTL = B.NATUTL,
        NATDEN_FIL = B.NATDEN_FIL,
        NATDEN_SEQ = B.NATDEN_SEQ,
        NATDEN_TIP = B.NATDEN_TIP,
        NATFOR_FIL = B.NATFOR_FIL,
        NATFOR_SEQ = B.NATFOR_SEQ,
        NATFOR_TIP = B.NATFOR_TIP,
        CFOCTA_FIL = B.CFOCTA_FIL,
        CFOCTA_SEQ = B.CFOCTA_SEQ,
        CFOCTA_TIP = B.CFOCTA_TIP,
        REDCON = B.REDCON,
        CODBOM = B.CODBOM,
        FILLAC = B.FILLAC,
        SEQLAC = B.SEQLAC,
        SEREXT = B.SEREXT,
        OCUATI = B.OCUATI,
        NATEST_FIL = B.NATEST_FIL,
        NATEST_SEQ = B.NATEST_SEQ,
        NATEST_TIP = B.NATEST_TIP,
        SITPIS = B.SITPIS,
        SITCOF = B.SITCOF,
        NATBCC = B.NATBCC,
        SERREM = B.SERREM,
        MOVEST_DCFO = B.MOVEST_DCFO,
        NATESD = B.NATESD,
        NATESF = B.NATESF,
        MOELET = B.MOELET,
        MOEIMG = B.MOEIMG,
        MOELIM = B.MOELIM,
        MOENIV = B.MOENIV,
        OUTLET = B.OUTLET,
        OUTIMG = B.OUTIMG,
        OUTLIM = B.OUTLIM,
        OUTNIV = B.OUTNIV,
        REGOUT = B.REGOUT,
        NATMEN = B.NATMEN,
        NATRED_ST = B.NATRED_ST,
        NATREF_ST = B.NATREF_ST,
        CSTNOR = B.CSTNOR,
        CST_ST = B.CST_ST,
        RECIBO = B.RECIBO,
        CONLOC = B.CONLOC,
        ENVNFS = B.ENVNFS,
        NATPRE = B.NATPRE,
        SERCON = B.SERCON,
        CFOFOR = B.CFOFOR,
        CODPOS_DMED = B.CODPOS_DMED,
        CODPOS_DDEP = B.CODPOS_DDEP,
        PESPREVEN = B.PESPREVEN,
        PESPREFOR = B.PESPREFOR,
        PESPRZENT = B.PESPRZENT,
        TAXJURMES = B.TAXJURMES,
        TIPCCM = B.TIPCCM,
        PERESPINTCOM = B.PERESPINTCOM,
        PERESPESTCOM = B.PERESPESTCOM,
        PERESPINTVEN = B.PERESPINTVEN,
        PERESPESTVEN = B.PERESPESTVEN
  FROM TV_TAB_002 B
 WHERE TW_TAB.CODTAB = B.CODTAB;

   -- 5) Update na TW_TAB com os dados de outras TDs
   UPDATE TW_TAB
   SET CODTAB = B.CODTAB,
        ESTATI = B.ESTATI,
        ESTADO = B.ESTADO,
        PERICM = B.PERICM,
        NOMEST = B.NOMEST,
        ICMCID = B.ICMCID,
        INSCST = B.INSCST,
        NORINT = B.NORINT,
        ALIINT = B.ALIINT,
        MARG00 = B.MARG00,
        MARG01 = B.MARG01,
        MARG02 = B.MARG02,
        MARG03 = B.MARG03,
        MARG04 = B.MARG04,
        MARG05 = B.MARG05,
        MARG06 = B.MARG06,
        MARG07 = B.MARG07,
        MARG08 = B.MARG08,
        MARG09 = B.MARG09,
        ONDCAL = B.ONDCAL,
        SOMBAS = B.SOMBAS,
        PERREP = B.PERREP,
        ICMINT = B.ICMINT,
        NBANCO = B.NBANCO,
        CBANCO = B.CBANCO,
        BCOATI = B.BCOATI,
        FBANCO = B.FBANCO,
        ABANCO = B.ABANCO,
        FILBCO = B.FILBCO,
        CODBCO = B.CODBCO,
        CUSATI = B.CUSATI,
        CENCUS = B.CENCUS,
        EXTCUS = B.EXTCUS,
        SETATI = B.SETATI,
        DESSET = B.DESSET,
        FILSET = B.FILSET,
        PRJSET = B.PRJSET,
        DOCATV = B.DOCATV,
        TIPDOC = B.TIPDOC,
        DESDOC = B.DESDOC,
        NOMCNC = B.NOMCNC,
        CNCATI = B.CNCATI,
        GRUATI = B.GRUATI,
        DESGRU = B.DESGRU,
        VEIATI = B.VEIATI,
        PESMAX = B.PESMAX,
        VOLMAX = B.VOLMAX,
        PLACAS = B.PLACAS,
        DESVEI = B.DESVEI,
        CODFRE = B.CODFRE,
        NOMCOL = B.NOMCOL,
        COLATI = B.COLATI,
        INIREF = B.INIREF,
        FIMREF = B.FIMREF,
        INIQTD = B.INIQTD,
        FIMQTD = B.FIMQTD,
        COLREF = B.COLREF,
        COLQTD = B.COLQTD,
        DELIMI = B.DELIMI,
        HEADER = B.HEADER,
        FOOTER = B.FOOTER,
        SEPDEC = B.SEPDEC,
        QTDDEC = B.QTDDEC,
        ZERESQ = B.ZERESQ,
        DESEAN = B.DESEAN,
        EANFIL = B.EANFIL,
        EANCOD = B.EANCOD,
        USAVEN = B.USAVEN,
        EANATI = B.EANATI,
        DESDOP = B.DESDOP,
        DOPATI = B.DOPATI,
        MODPGT = B.MODPGT,
        FILCCC = B.FILCCC,
        DESCCC = B.DESCCC,
        CCCATI = B.CCCATI,
        COMCCC = B.COMCCC,
        CLILIV = B.CLILIV,
        DIARET = B.DIARET,
        ASSCCC = B.ASSCCC,
        TXTCCC = B.TXTCCC,
        REGCCC = B.REGCCC,
        CTACCC = B.CTACCC,
        DESCWS = B.DESCWS,
        CWSATI = B.CWSATI,
        PEDAUT = B.PEDAUT,
        TIPCWS = B.TIPCWS,
        HORCWS = B.HORCWS,
        MOTVPE = B.MOTVPE,
        VPEATI = B.VPEATI,
        DESJUS = B.DESJUS,
        JUSATI = B.JUSATI,
        COMJUS = B.COMJUS,
        TIPJUS = B.TIPJUS,
        AVIJUS = B.AVIJUS,
        CORATI = B.CORATI,
        DESCOR = B.DESCOR,
        DESCLT = B.DESCLT,
        CLTATV = B.CLTATV,
        WORPRI = B.WORPRI,
        LPCATI = B.LPCATI,
        DESLPC = B.DESLPC,
        NUMEXT = B.NUMEXT,
        TIPRCE = B.TIPRCE,
        TERATI = B.TERATI,
        TER_IP = B.TER_IP,
        TERVEN = B.TERVEN,
        FILTER = B.FILTER,
        TERCTR = B.TERCTR,
        CARENC = B.CARENC,
        CFPATI = B.CFPATI,
        DESCFP = B.DESCFP,
        VENCON = B.VENCON,
        VENREV = B.VENREV,
        DEVCON = B.DEVCON,
        DEVREV = B.DEVREV,
        SAICON = B.SAICON,
        SAIREV = B.SAIREV,
        ENTCON = B.ENTCON,
        ENTREV = B.ENTREV,
        COMCON = B.COMCON,
        COMREV = B.COMREV,
        DVCCON = B.DVCCON,
        DVCREV = B.DVCREV,
        INTCON = B.INTCON,
        INTREV = B.INTREV,
        VENCON_FOR = B.VENCON_FOR,
        VENREV_FOR = B.VENREV_FOR,
        DEVCON_FOR = B.DEVCON_FOR,
        DEVREV_FOR = B.DEVREV_FOR,
        SAICON_FOR = B.SAICON_FOR,
        SAIREV_FOR = B.SAIREV_FOR,
        ENTCON_FOR = B.ENTCON_FOR,
        ENTREV_FOR = B.ENTREV_FOR,
        COMCON_FOR = B.COMCON_FOR,
        COMREV_FOR = B.COMREV_FOR,
        DVCCON_FOR = B.DVCCON_FOR,
        DVCREV_FOR = B.DVCREV_FOR,
        INTCON_FOR = B.INTCON_FOR,
        INTREV_FOR = B.INTREV_FOR,
        RELATI = B.RELATI,
        DESREL = B.DESREL,
        PRIMIN = B.PRIMIN,
        PRIMAX = B.PRIMAX,
        SITATI = B.SITATI,
        DESSIT = B.DESSIT,
        FLGRES = B.FLGRES,
        FLGREV = B.FLGREV,
        FLGREG = B.FLGREG,
        FLGMOD = B.FLGMOD,
        TIPSIT = B.TIPSIT,
        TIPADO = B.TIPADO,
        GER_CC = B.GER_CC,
        SITMAI = B.SITMAI,
        VLRTAX = B.VLRTAX,
        PERATE = B.PERATE,
        FCCATI = B.FCCATI,
        CTRATI = B.CTRATI,
        DESCTR = B.DESCTR,
        CTRTIP = B.CTRTIP,
        CTRSEQ = B.CTRSEQ,
        CTRFIL = B.CTRFIL,
        CTRUSO = B.CTRUSO,
        TITCTR = B.TITCTR,
        FILPRA = B.FILPRA,
        SEQPRA = B.SEQPRA,
        TIPPRA = B.TIPPRA,
        PATPED = B.PATPED,
        TITCTRPRA = B.TITCTRPRA,
        TIPWOR = B.TIPWOR,
        ORICWS = B.ORICWS,
        TITCTADEN = B.TITCTADEN,
        TITCTAFOR = B.TITCTAFOR,
        CFOCTA_TIT = B.CFOCTA_TIT,
        VLRCHE = B.VLRCHE,
        FLGSTR = B.FLGSTR,
        DESSTR = B.DESSTR,
        STRATI = B.STRATI,
        DESREQ = B.DESREQ,
        REQATI = B.REQATI,
        ABRREQ = B.ABRREQ,
        CLAREQ = B.CLAREQ,
        NUMBOM = B.NUMBOM,
        NSERIE = B.NSERIE,
        NOMFAB = B.NOMFAB,
        MODELO = B.MODELO,
        TIPMED = B.TIPMED,
        BOMATI = B.BOMATI,
        TIPTIT = B.TIPTIT,
        MAX_CF = B.MAX_CF,
        PERFCP = B.PERFCP,
        CTREST_FIL = B.CTREST_FIL,
        CTREST_SEQ = B.CTREST_SEQ,
        CTREST_TIP = B.CTREST_TIP,
        DESRTT = B.DESRTT,
        RTTATI = B.RTTATI,
        RTTEST = B.RTTEST,
        FILCTA_DRTT = B.FILCTA_DRTT,
        SEQCTA_DRTT = B.SEQCTA_DRTT,
        TIPCTA_DRTT = B.TIPCTA_DRTT,
        FILCTA_EST_DRTT = B.FILCTA_EST_DRTT,
        SEQCTA_EST_DRTT = B.SEQCTA_EST_DRTT,
        TIPCTA_EST_DRTT = B.TIPCTA_EST_DRTT,
        CODEXT = B.CODEXT,
        FCCFIL = B.FCCFIL,
        FCC_FILMAT = B.FCC_FILMAT,
        FCC_CODMAT = B.FCC_CODMAT,
        FCC_CODCOR = B.FCC_CODCOR,
        CODFIL = B.CODFIL_BOM,
        FCC_CODTAM = B.FCC_CODTAM,
        DESMPB = B.DESMPB,
        VLRMAX = B.VLRMAX,
        MPBATI = B.MPBATI,
        DESRGC = B.DESRGC,
        RGCATI = B.RGCATI,
        FLGENC = B.FLGENC,
        FLGDEV = B.FLGDEV,
        RGC_TIPENT = B.RGC_TIPENT,
        DESSTF = B.DESSTF,
        STFATI = B.STFATI,
        STF_FILFOR = B.STF_FILFOR,
        STF_CODFOR = B.STF_CODFOR,
        STF_CODSER = B.STF_CODSER,
        STF_SUBSER = B.STF_SUBSER,
        STF_DIAVEN = B.STF_DIAVEN,
        STF_CODDAR = B.STF_CODDAR,
        STF_CODSET = B.STF_CODSET,
        STF_FILCTA = B.STF_FILCTA,
        STF_SEQCTA = B.STF_SEQCTA,
        STF_TIPCTA = B.STF_TIPCTA,
        STF_CODFPS = B.STF_CODFPS,
        STF_CODCTR = B.STF_CODCTR,
        STF_CODCUS = B.STF_CODCUS,
        STF_CODCFO = B.STF_CODCFO,
        DESFRE = B.DESFRE,
        FREATI = B.FREATI,
        DFRE_TIPCOB = B.DFRE_TIPCOB,
        DFRE_PERVEN = B.DFRE_PERVEN,
        DFRE_VALENT = B.DFRE_VALENT,
        DFRE_VALPES = B.DFRE_VALPES,
        DFRE_VALQTD = B.DFRE_VALQTD,
        DFRE_FREMIN = B.DFRE_FREMIN,
        DFRE_MINDES = B.DFRE_MINDES,
        DFRE_PERDES = B.DFRE_PERDES,
        DESPES = B.DESPES,
        PESATI = B.PESATI,
        PESINI = B.PESINI,
        PESFIM = B.PESFIM,
        DESNIV = B.DESNIV,
        NIVATI = B.NIVATI,
        PERNIV = B.PERNIV,
        FATNIV = B.FATNIV,
        SQLCCC = B.SQLCCC,
        CCCLET = B.CCCLET,
        CCCIMG = B.CCCIMG,
        CCCLIM = B.CCCLIM,
        CCCNIV = B.CCCNIV,
        VLRBON = B.VLRBON,
        RTTDIG = B.RTTDIG,
        RTTTEF = B.RTTTEF,
        RTTBAR = B.RTTBAR,
        RTTTIP = B.RTTTIP,
        CCCCAI = B.CCCCAI,
        DESIMG = B.DESIMG,
        LETIMG = B.LETIMG,
        NOMIMG = B.NOMIMG,
        IMGATI = B.IMGATI,
        DESMOT = B.DESMOT,
        USOMOT = B.USOMOT,
        CONMOT = B.CONMOT,
        PERMOT = B.PERMOT,
        DESMAXMOT = B.DESMAXMOT,
        ACRMAXMOT = B.ACRMAXMOT,
        TIPMOT = B.TIPMOT,
        MOTATI = B.MOTATI,
        ICMIMP = B.ICMIMP,
        DESSAT = B.DESSAT,
        SATATI = B.SATATI,
        SAT_NUMSER = B.SAT_NUMSER,
        SAT_CODFIL = B.SAT_CODFIL,
        SAT_CODSER = B.SAT_CODSER,
        SAT_CNT_RO = B.SAT_CNT_RO,
        DESOMI = B.DESOMI,
        OMIATI = B.OMIATI,
        OMILIS = B.OMILIS,
        OMIRES = B.OMIRES,
        OMICON = B.OMICON,
        OMIFIL = B.OMIFIL,
        BASMAR = B.BASMAR,
        DESPER = B.DESPER,
        PERCOD = B.PERCOD,
        PERORD = B.PERORD,
        PERATI = B.PERATI,
        CODEXT_DCCC = B.CODEXT_DCCC,
        DESTIPxINT = B.DESTIPxINT,
        CODMTD = B.CODMTD,
        TIPVEI = B.TIPVEI,
        ESPVEI = B.ESPVEI,
        CONVEI = B.CONVEI,
        CAPMAX = B.CAPMAX,
        MAXTRA = B.MAXTRA
  FROM TV_TAB_003 B
 WHERE TW_TAB.CODTAB = B.CODTAB;

   RETURN NULL;

END;
$$ language 'plpgsql';




/*-- SEQ 3092 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Fluxo (INTEGER,Numeric,INTEGER,VARCHAR,VARCHAR,Numeric,Numeric) CASCADE;

/*-- SEQ 3093 --*/
CREATE OR REPLACE FUNCTION Fluxo (INTEGER,Numeric,INTEGER,VARCHAR,VARCHAR,Numeric,Numeric)
RETURNS VARCHAR AS $$
DECLARE
nDias ALIAS FOR $1 ;
nRelacaoAtrasoVencto ALIAS FOR $2 ;
nUsaMedAtraso ALIAS FOR $3 ;
nfilial ALIAS FOR $4 ;
pVencido ALIAS FOR $5 ;
pDiasParaProjecaoVendas ALIAS FOR $6 ;
pDiasParaProjecaoCompras ALIAS FOR $7 ;

-- Objetivos:
-- 1. Popula a tw_flu de acordo com os filtros para o fluxo que est sendo projetado.

-- Parmetros:
-- nDias:
--    Nmero de dias a serem projetados
-- nRelacaoAtrasoVencto:
--    Relao para vencimentos atrasados (padrao 1)
-- nUsaMedAtraso:
--    Utiliza Mdia de atraso para calculo? 0 false , 1 verdadeiro
-- nfilial:
--    Filial para filtro dos documentos
-- pVencido:
--    Desconsiderar a receber j vencido
-- pDiasParaProjecaoVendas:
--    Nmero de dias para trs que sero considerados para obter a mdia de recebimentos.
--    A mdia  utilizada para projetar os recebimentos futuros por dia e plano de pagamento.
--    Valor deve ser um nmero maior que 1.
-- pDiasParaProjecaoCompras:
--    Nmero de dias para trs que sero considerados para obter a mdia de pagamentos.
--    A mdia  utilizada para projetar os pagamentos futuros por dia.
--    Valor deve ser um nmero maior que 1.

-- Declarao de variveis e cursores
   dDataAnteriorIni              Timestamp;
   dDataAnteriorFim              Timestamp;
   dDataAnteriorAnoAnteriorIni   Timestamp;
   dDataAnteriorAnoAnteriorFim   Timestamp;
   dDataAnteriorIniPg            Timestamp;
   dDataAnteriorFimPg            Timestamp;
   dDataAnteriorAnoAnteriorIniPg Timestamp;
   dDataAnteriorAnoAnteriorFimPg Timestamp;
   dDataFuturaAnoAnteriorIni     Timestamp;
   dDataFuturaAnoAnteriorFim     Timestamp;
   dDataFuturaIni                Timestamp;
   dDataFuturaFim                Timestamp;

   nMediaA                       Numeric(12,4);
   nMediaB                       Numeric(12,4);
   nMediaN                       Numeric(12,4);
   nPERIOD                       TT_PLA.PERIOD%TYPE;
   nPRAIDE                       TT_PLA.PRAIDE%TYPE;
   nPRIIDE                       TT_PLA.PRIIDE%TYPE;
   nPARIDE                       TT_PLA.PARIDE%TYPE;
   dDATOPE                       Timestamp;

   nFatorCrescimento             Numeric(12,4);
   nNovaMedia                    Numeric(12,4);
   nParcelas                     Numeric(2);
   nContadorDocumentos           Numeric(9);

   nUSERID                       TW_FLU.USERID%TYPE;
   dDATCAL                       TW_FLU.DATCAL%TYPE;
   dDATPRE                       TW_FLU.DATPRE%TYPE;
   dDATVEN                       TW_FLU.DATVEN%TYPE;
   nVLRORI                       TW_FLU.VLRORI%TYPE;
   nVLRCAL                       TW_FLU.VLRCAL%TYPE;
   nVLRPRE                       TW_FLU.VLRPRE%TYPE;
   cNUMPAR                       TW_FLU.NUMPAR%TYPE;
   cSUBPAR                       TW_FLU.SUBPAR%TYPE;
   cCODFIL                       TW_FLU.CODFIL%TYPE;
   dCOMPET                       TW_FLU.COMPET%TYPE;
   cTABORI                       TW_FLU.TABORI%TYPE;
   cDOCUME                       TW_FLU.DOCUME%TYPE;
   cFILCLI                       TW_FLU.FILCLI%TYPE;
   cCODCLI                       TW_FLU.CODCLI%TYPE;
   cSTATUS                       TW_FLU.STATUS%TYPE;
   cTIPLAN                       TW_FLU.TIPLAN%TYPE;
   cFILCTA                       TW_FLU.FILCTA%TYPE;
   cSEQCTA                       TW_FLU.SEQCTA%TYPE;
   cTIPCTA                       TW_FLU.TIPCTA%TYPE;
   cSEQORI                       TW_FLU.SEQORI%TYPE;
   cNUMDOC                       TW_FLU.NUMDOC%TYPE;
   nVLRPRE_ANT                   TW_FLU.VLRPRE_ANT%TYPE;
   cFILPGT                       TW_FLU.FILPGT%TYPE;
   cCODPGT                       TW_FLU.CODPGT%TYPE;
   cFILMAR                       TW_FLU.FILMAR%TYPE;
   cCODMAR                       TW_FLU.CODMAR%TYPE;
   nITEMAR                       TW_FLU.ITEMAR%TYPE;

   dDataParcela                  Timestamp;

   CursorPrevisoes CURSOR(pDataAnteriorIni Timestamp,
           pDataAnteriorFim Timestamp,
           pDataAnteriorAnoAnteriorIni Timestamp,
           pDataAnteriorAnoAnteriorFim Timestamp,
           pDataFuturaAnoAnteriorIni Timestamp,
           pDataFuturaAnoAnteriorFim Timestamp,
           pDataFuturaIni Timestamp,
           pDataFuturaFim Timestamp,
           pFERABE TT_UTL.FERABE%TYPE,
           pDataAnteriorIniPg Timestamp,
           pDataAnteriorFimPg Timestamp,
           pDataAnteriorAnoAnteriorIniPg Timestamp,
           pDataAnteriorAnoAnteriorFimPg Timestamp) IS
   SELECT TAB.*,
          UTL.DATOPE
     FROM (
                  SELECT SUB.CODFIL,
                         SUB.FILPGT,
                         SUB.CODPGT,
                         CAST(NULL AS CHAR(3)) AS FILMAR,
                         CAST(NULL AS CHAR(6)) AS CODMAR,
                         CAST(NULL AS Numeric(4)) AS ITEMAR,
                         FluxoMediaRecebimentos(SUB.CODFIL, SUB.FILPGT, SUB.CODPGT, pDataAnteriorIni, pDataAnteriorFim) AS MEDIA_A,
                         FluxoMediaRecebimentos(SUB.CODFIL, SUB.FILPGT, SUB.CODPGT, pDataAnteriorAnoAnteriorIni, pDataAnteriorAnoAnteriorFim) AS MEDIA_B,
                         FluxoMediaRecebimentos(SUB.CODFIL, SUB.FILPGT, SUB.CODPGT, pDataFuturaAnoAnteriorIni, pDataFuturaAnoAnteriorFim) AS MEDIA_N,
                         SUB.PERIOD,
                         SUB.PRAIDE,
                         SUB.PRIIDE,
                         SUB.PARIDE,
                         CAST('PRE' AS CHAR(3)) AS TABORI,  -- Previso de Recebimento
                         CAST('R' AS CHAR(1)) AS TIPLAN     -- A Receber
                    FROM (SELECT FIL.CODFIL, PLA.FILPGT, PLA.CODPGT, PLA.PERIOD, PLA.PRAIDE, PLA.PRIIDE, PLA.PARIDE
                            FROM TT_PLA PLA CROSS JOIN TD_FIL FIL
                           WHERE FIL.CODFIL = COALESCE(nfilial, FIL.CODFIL)
                             AND FIL.FILATI = 'T'
                             AND PLA.SIGNAT >= 0
                           ORDER BY FIL.CODFIL, PLA.FILPGT, PLA.CODPGT) SUB
                  UNION ALL
                  SELECT PAG.CODFIL, PAG.FILPGT, PAG.CODPGT, PAG.FILMAR, PAG.CODMAR, PAG.ITEMAR,
                         PAG.MEDIA_A, PAG.MEDIA_B, PAG.MEDIA_N,
                         30 AS PERIOD,
                         0 AS PRAIDE,
                         100/PARCELA_MEDIA AS PRIIDE,
                         PARCELA_MEDIA AS PARIDE,
                         PAG.TABORI,
                         PAG.TIPLAN
                    FROM (
                           SELECT SUB.CODFIL,
                                  CAST(NULL AS CHAR(3)) AS FILPGT,
                                  CAST(NULL AS CHAR(3)) AS CODPGT,
                                  SUB.FILMAR,
                                  SUB.CODMAR,
                                  SUB.ITEMAR,
                                  FluxoMediaPagamentos(SUB.CODFIL, SUB.FILMAR, SUB.CODMAR, SUB.ITEMAR, pDataAnteriorIniPg, pDataAnteriorFimPg) AS MEDIA_A,
                                  FluxoMediaPagamentos(SUB.CODFIL, SUB.FILMAR, SUB.CODMAR, SUB.ITEMAR, pDataAnteriorAnoAnteriorIniPg, pDataAnteriorAnoAnteriorFimPg) AS MEDIA_B,
                                  FluxoMediaPagamentos(SUB.CODFIL, SUB.FILMAR, SUB.CODMAR, SUB.ITEMAR, pDataFuturaAnoAnteriorIni, pDataFuturaAnoAnteriorFim)
                                   - FluxoMediaPedidos(SUB.CODFIL, SUB.FILMAR, SUB.CODMAR, SUB.ITEMAR, pDataFuturaIni, pDataFuturaFim) AS MEDIA_N,
                                  FluxoMediaPrazoPagamentos(SUB.CODFIL, SUB.FILMAR, SUB.CODMAR, SUB.ITEMAR, pDataAnteriorIniPg, pDataAnteriorFimPg) AS PARCELA_MEDIA,
                                  CAST('PPA' AS CHAR(3)) AS TABORI,  -- Previso de Pagamentos
                                  CAST('P' AS CHAR(1)) AS TIPLAN     -- A Pagar
                             FROM (SELECT FIL.CODFIL, MAR.FILMAR, MAR.CODMAR, MAR.ITEMAR
                                     FROM TT_MAR MAR CROSS JOIN TD_FIL FIL
                                    WHERE FIL.CODFIL = COALESCE(nfilial, FIL.CODFIL)
                                      AND FIL.FILATI = 'T'
                                    ORDER BY FIL.CODFIL, MAR.FILMAR, MAR.CODMAR, MAR.ITEMAR) SUB
                   ) PAG
          ) TAB INNER JOIN TT_UTL UTL ON UTL.CODFIL = TAB.CODFIL
    WHERE UTL.DATOPE BETWEEN TRUNC(pDataFuturaIni) AND pDataFuturaFim
      AND 1 = CASE WHEN pFERABE = 'T' THEN 1
                   ELSE CASE WHEN UTL.FERABE = 'F' THEN 1
                             ELSE 0
                        END
              END
    ORDER BY TAB.CODFIL, TAB.FILPGT, TAB.CODPGT, TAB.FILMAR, TAB.CODMAR, TAB.ITEMAR, UTL.DATOPE;

-- Incio da funo
BEGIN

   DELETE FROM TW_FLU WHERE USERID = USERENV('SESSIONID');

   INSERT INTO TW_FLU
   (USERID, DATCAL, DATPRE, DATVEN,
    VLRORI, VLRCAL, VLRPRE, NUMPAR,
    SUBPAR, CODFIL, COMPET, TABORI,
    DOCUME, FILCLI, CODCLI, STATUS,
    TIPLAN, FILCTA, SEQCTA, TIPCTA,
    SEQORI, NUMDOC, VLRPRE_ANT,
    FILPGT, CODPGT)
   (SELECT TAB.USERID, ProximoDiaUtilBanco(Add_Day(TAB.DATCAL,-1)) AS DATCAL, TAB.DATPRE, TAB.DATVEN,
           TAB.VLRORI, TAB.VLRCAL, TAB.VLRPRE, TAB.NUMPAR,
           TAB.SUBPAR, TAB.CODFIL, TAB.COMPET, TAB.TABORI,
           TAB.DOCUME, TAB.FILCLI, TAB.CODCLI, TAB.STATUS,
           TAB.TIPLAN, TAB.FILCTA, TAB.SEQCTA, TAB.TIPCTA,
           TAB.SEQUEN, TAB.NUMDOC, TAB.VLRPRE,
           TAB.FILPGT, TAB.CODPGT
      FROM (-- A Pagar
            SELECT USERENV('SESSIONID') AS USERID,
                    CASE WHEN COALESCE(PAP.DATPRE, PAP.DATVEN) < TRUNC(Agora())
                         THEN Add_Day(TRUNC(Agora()),-1)
                         ELSE COALESCE(PAP.DATPRE, PAP.DATVEN)
                    END AS DATCAL,
                    PAP.DATPRE,
                    PAP.DATVEN,
                    PAP.VLRPAR AS VLRORI,
                    COALESCE(PAP.VLRPRE, PAP.VLRCAL, PAP.VLRPAR) AS VLRCAL,
                    PAP.VLRPRE, PAP.NUMPAR, PAP.SUBPAR,
                    PAP.CODFIL, PAP.COMPET, PAP.TABORI,
                    PAP.DOCUME,
                    PAP.FILFOR AS FILCLI,
                    PAP.CODFOR AS CODCLI,
                    PAP.STATUS, -- E=Efetivo / P=Previsto
                    CAST('P' AS CHAR(1)) AS TIPLAN, -- A Pagar
                    PAP.FILCTA, PAP.SEQCTA, PAP.TIPCTA,
                    PAP.SEQUEN,
                    PAP.NUMDOC,
                    CAST(NULL AS CHAR(3)) AS FILPGT,
                    CAST(NULL AS CHAR(3)) AS CODPGT
               FROM TV_PAP PAP
              WHERE COALESCE(PAP.FLGFLU,'T') = 'T'
                AND PAP.CODFIL = COALESCE(nfilial, PAP.CODFIL)
              UNION ALL
             -- A Receber
             SELECT USERENV('SESSIONID') AS USERID,
                    CASE WHEN COALESCE(ARE.DATPRE, Add_Day(ARE.DATVEN,ARE.MEDATR*nUsaMedAtraso)) < TRUNC(Agora())
                         THEN Add_Day( TRUNC(Agora()), (TRUNC(Agora()) - TRUNC(COALESCE(ARE.DATPRE, Add_Day(ARE.DATVEN,ARE.MEDATR*nUsaMedAtraso))))* nRelacaoAtrasoVencto )
                         ELSE COALESCE(ARE.DATPRE, Add_Day(ARE.DATVEN,ARE.MEDATR*nUsaMedAtraso))
                    END AS DATCAL,
                    ARE.DATPRE, ARE.DATVEN, ARE.VLRPAR AS VLRORI,
                    COALESCE(ARE.VLRPRE,
                             CASE ARE.TABORI WHEN 'REC' THEN CalcRecAtu(ARE.CODFIL, ARE.SEQUEN, ARE.NUMPAR, ARE.SUBPAR, 1, GREATEST(Agora(), COALESCE(ARE.DATPRE,Add_Day(ARE.DATVEN,ARE.MEDATR*nUsaMedAtraso))))
                             END,
                             ARE.VLRPAR) AS VLRCAL,
                    ARE.VLRPRE, ARE.NUMPAR, ARE.SUBPAR,
                    ARE.CODFIL, ARE.COMPET, ARE.TABORI,
                    ARE.DOCUME, ARE.FILCLI, ARE.CODCLI,
                    CAST('E' AS CHAR(1)) AS STATUS, -- E=Efetivo
                    CAST('R' AS CHAR(1)) AS TIPLAN, -- A Receber
                    ARE.FILCTA, ARE.SEQCTA, ARE.TIPCTA,
                    ARE.SEQUEN,
                    CAST(NULL AS CHAR(9)) AS NUMDOC,
                    CAST(NULL AS CHAR(3)) AS FILPGT,
                    CAST(NULL AS CHAR(3)) AS CODPGT
               FROM TV_ARE ARE
              WHERE COALESCE(ARE.FLGFLU,'T') = 'T'
                AND ARE.CODFIL = COALESCE(nfilial,ARE.CODFIL)
              UNION ALL
             -- Projeo Financeira
             SELECT USERENV('SESSIONID') AS USERID,
                    TOT.DATVEN AS DATCAL,
                    CAST(NULL AS Timestamp) AS DATPRE,
                    TOT.DATVEN,
                    TOT.VLRPRE AS VLRORI,
                    TOT.VLRPRE AS VLRCAL,
                    CAST(NULL AS Numeric) AS VLRPRE,
                    CAST(NULL AS CHAR(2)) AS NUMPAR, CAST(NULL AS CHAR(2)) AS SUBPAR,
                    TOT.CODFIL,
                    TOT.DATVEN AS COMPET, 'CTA' AS TABORI,
                    CAST(NULL AS CHAR(10)) AS DOCUME, CAST(NULL AS CHAR(3)) AS FILCLI, CAST(NULL AS CHAR(6)) AS CODCLI,
                    CAST('P' AS CHAR(1)) AS STATUS,                     -- P=Previsto
                    CASE WHEN TOT.VLRPRE > 0 THEN CAST('R' AS CHAR(1))  -- A Receber
                              ELSE CAST('P' AS CHAR(1))  -- A Pagar
                    END AS TIPLAN,
                    TOT.FILCTA, TOT.SEQCTA, TOT.TIPCTA,
                    TOT.SEQCTA AS SEQUEN, CAST(NULL AS CHAR(9)) AS NUMDOC,
                    CAST(NULL AS CHAR(3)) AS FILPGT,
                    CAST(NULL AS CHAR(3)) AS CODPGT
               FROM (SELECT INT.*,
                            CASE INT.PERIOD
                               WHEN 'D' THEN Add_Day(GREATEST(INT.DATPGT,TRUNC(Agora())),TO_NUMBER(CAST(INT.VEZ AS CHAR(3))))   -- Dirio
                               WHEN 'S' THEN Add_Day(GREATEST(INT.DATPGT,TRUNC(Agora())),7  * TO_NUMBER(CAST(INT.VEZ AS CHAR(3)))) -- Semanal
                               WHEN 'Q' THEN Add_Day(GREATEST(INT.DATPGT,TRUNC(Agora())),15 * TO_NUMBER(CAST(INT.VEZ AS CHAR(3)))) -- Quinzenal
                               WHEN 'M' THEN Add_Months(GREATEST(INT.DATPGT,TRUNC(Agora())),TO_NUMBER(CAST(INT.VEZ AS CHAR(3)))) -- Mensal
                               WHEN '2' THEN Add_Months(GREATEST(INT.DATPGT,TRUNC(Agora())),2  * TO_NUMBER(CAST(INT.VEZ AS CHAR(3)))) -- Bimestral
                               WHEN '3' THEN Add_Months(GREATEST(INT.DATPGT,TRUNC(Agora())),3  * TO_NUMBER(CAST(INT.VEZ AS CHAR(3)))) -- Trimestral
                               WHEN '4' THEN Add_Months(GREATEST(INT.DATPGT,TRUNC(Agora())),4  * TO_NUMBER(CAST(INT.VEZ AS CHAR(3)))) -- Quadrimestral
                               WHEN '6' THEN Add_Months(GREATEST(INT.DATPGT,TRUNC(Agora())),6  * TO_NUMBER(CAST(INT.VEZ AS CHAR(3)))) -- Semestral
                               WHEN 'A' THEN Add_Months(GREATEST(INT.DATPGT,TRUNC(Agora())),12 * TO_NUMBER(CAST(INT.VEZ AS CHAR(3)))) -- Anual
                            END AS DATVEN
                       FROM (
                             SELECT CTA.CODFIL, CTA.FILCTA, CTA.SEQCTA, CTA.TIPCTA, CTA.PERIOD, CTA.VLRPRE,
                                    (SELECT MAX(M.DATPGT)
                                       FROM TV_FIN M
                                      WHERE M.FILCTA = CTA.FILCTA AND M.SEQCTA = CTA.SEQCTA
                                        AND M.TIPCTA = CTA.TIPCTA AND M.CODFIL = CTA.CODFIL ) AS DATPGT,
                                    REPETE.VEZ
                               FROM TT_CTAxFIL CTA,
                                    (SELECT TRUNC(Agora()) - DAT.DATOPE AS VEZ
                                       FROM TT_DAT DAT
                                      WHERE DAT.DATOPE < Agora()
                                        AND DAT.DATOPE >= Add_Day(Agora(),-365)) REPETE
                              WHERE COALESCE(CTA.VLRPRE,0) <> 0
                            ) INT
                    ) TOT
              WHERE TOT.DATVEN <= Add_Day(Agora(),nDias)
                AND TOT.DATVEN >= TRUNC(Agora())
                AND TOT.CODFIL = COALESCE(nfilial,TOT.CODFIL)
           ) TAB
         WHERE TAB.DATCAL <= Add_Day(trunc(Agora()),nDias)
           AND 1 = CASE WHEN COALESCE(pVencido,'F') = 'F' THEN 1
                        WHEN pVencido = 'T' AND TAB.DATVEN < TRUNC(Agora()) AND TAB.TIPLAN = 'R' THEN 0
                        ELSE 1
                   END
   );

   IF pDiasParaProjecaoVendas = 0 OR pDiasParaProjecaoCompras = 0 THEN
      RETURN 'OK';
   END IF;

   -- Projees de A Receber e A Pagar

   -- Preparando as datas para A Receber
   dDataAnteriorIni              := ADD_DAY(TRUNC(Agora()),-pDiasParaProjecaoVendas);
   dDataAnteriorFim              := TRUNC(Agora());
   dDataAnteriorAnoAnteriorIni   := ADD_DAY(dDataAnteriorIni,-365);
   dDataAnteriorAnoAnteriorFim   := ADD_DAY(dDataAnteriorFim,-365);

   dDataAnteriorFim              := TO_DATE(TO_CHAR(TRUNC(dDataAnteriorFim), 'DD/MM/YYYY') || ' 23:59:59', 'DD/MM/YYYY HH24:MI:SS');
   dDataAnteriorAnoAnteriorFim   := TO_DATE(TO_CHAR(TRUNC(dDataAnteriorAnoAnteriorFim), 'DD/MM/YYYY') || ' 23:59:59', 'DD/MM/YYYY HH24:MI:SS');

   -- Preparando as datas para A Pagar
   dDataAnteriorIniPg            := ADD_DAY(TRUNC(Agora()),-pDiasParaProjecaoCompras);
   dDataAnteriorFimPg            := TRUNC(Agora());
   dDataAnteriorAnoAnteriorIniPg := ADD_DAY(dDataAnteriorIniPg,-365);
   dDataAnteriorAnoAnteriorFimPg := ADD_DAY(dDataAnteriorFimPg,-365);

   dDataAnteriorFimPg            := TO_DATE(TO_CHAR(TRUNC(dDataAnteriorFimPg), 'DD/MM/YYYY') || ' 23:59:59', 'DD/MM/YYYY HH24:MI:SS');
   dDataAnteriorAnoAnteriorFimPg := TO_DATE(TO_CHAR(TRUNC(dDataAnteriorAnoAnteriorFimPg), 'DD/MM/YYYY') || ' 23:59:59', 'DD/MM/YYYY HH24:MI:SS');

   -- Preparando as datas gerais
   dDataFuturaAnoAnteriorIni     := ADD_DAY(TRUNC(Agora()),-365);
   dDataFuturaAnoAnteriorFim     := ADD_DAY(TRUNC(Agora()),-(365-nDias));
   dDataFuturaIni                := ADD_DAY(TRUNC(Agora()),1);
   dDataFuturaFim                := ADD_DAY(TRUNC(Agora()),nDias);

   dDataFuturaAnoAnteriorFim     := TO_DATE(TO_CHAR(TRUNC(dDataFuturaAnoAnteriorFim), 'DD/MM/YYYY') || ' 23:59:59', 'DD/MM/YYYY HH24:MI:SS');
   dDataFuturaFim                := TO_DATE(TO_CHAR(TRUNC(dDataFuturaFim), 'DD/MM/YYYY') || ' 23:59:59', 'DD/MM/YYYY HH24:MI:SS');

   --
   nContadorDocumentos           := 0;

   OPEN CursorPrevisoes(dDataAnteriorIni,
                        dDataAnteriorFim,
                        dDataAnteriorAnoAnteriorIni,
                        dDataAnteriorAnoAnteriorFim,
                        dDataFuturaAnoAnteriorIni,
                        dDataFuturaAnoAnteriorFim,
                        dDataFuturaIni,
                        dDataFuturaFim,
                        'T',
                        dDataAnteriorIniPg,
                        dDataAnteriorFimPg,
                        dDataAnteriorAnoAnteriorIniPg,
                        dDataAnteriorAnoAnteriorFimPg);
   LOOP
      FETCH CursorPrevisoes INTO cCODFIL,
                                 cFILPGT,
                                 cCODPGT,
                                 cFILMAR,
                                 cCODMAR,
                                 nITEMAR,
                                 nMediaA, -- Mdia do perodo anterior
                                 nMediaB, -- Mdia do perodo anterior do ano anterior
                                 nMediaN, -- Mdia do perodo projetado mas no ano anterior
                                 nPERIOD,
                                 nPRAIDE,
                                 nPRIIDE,
                                 nPARIDE,
                                 cTABORI,
                                 cTIPLAN,
                                 dDATOPE;
      EXIT WHEN NOT FOUND;

      -- Define fator de crescimento
      nFatorCrescimento          := 0;
      nNovaMedia                 := 0;

      -- Frmula: ((Presente - Passado) / Passado) * 100
      IF nMediaA > 0 AND nMediaB > 0 THEN
         nFatorCrescimento := (nMediaA - nMediaB) / nMediaB * 100;
      END IF;

      -- A projeo  baseada nas vendas do ano anterior
      -- Se o plano/produtor no teve vendas no ano passado, ento  ignorado
      IF nMediaN = 0 THEN
         CONTINUE;
      END IF;

      -- Aplica o fator de crescimento no perodo projetado no ano anterior
      IF nFatorCrescimento >= 0 THEN
         nNovaMedia := nMediaN * (1 + nFatorCrescimento/100);
      ELSIF nFatorCrescimento < 0 THEN
         nNovaMedia := nMediaN * (1 - ABS(nFatorCrescimento)/100);
      END IF;

      IF nNovaMedia = 0 THEN
         CONTINUE;
      END IF;

      -- Valores gerais
      nUSERID              := USERENV('SESSIONID');
      dDataParcela         := ADD_DAY(TRUNC(dDATOPE), nPRAIDE);
      nContadorDocumentos  := nContadorDocumentos + 1;

      -- Cria as parcelas virtuais
      FOR nParcelas IN 1..nPARIDE LOOP

         -- Clculos por parcela
         dDATCAL     := ProximoDiaUtilBanco(Add_Day(dDataParcela,-1));
         dDATPRE     := NULL;
         dDATVEN     := dDATCAL;
         dCOMPET     := dDATOPE;

         -- Se a data j tiver passado do nmero dos dias projetado no incluir
         IF dDATCAL > ADD_DAY(Agora(), nDias) THEN
            CONTINUE;
         END IF;

         -- A vista
         IF nPARIDE = 1 THEN
            nVLRORI := nNovaMedia;
         ELSE
            -- Parcelado
            IF nParcelas = 1 THEN
               -- Entrada
               nVLRORI := nNovaMedia * (nPRIIDE / 100);
            ELSE
               -- Resto dividido pelo nmero de parcelas que sobraram
               nVLRORI := (nNovaMedia - (nNovaMedia * (nPRIIDE / 100))) / (nPARIDE-1);
            END IF;
         END IF;

         nVLRCAL     := nVLRORI;
         nVLRPRE     := NULL;
         cNUMPAR     := LPAD(TO_CHAR(nParcelas),2,' ');
         cSUBPAR     := ' 0';
         cTABORI     := cTABORI;
         cDOCUME     := 'Doc '||LPAD(TO_CHAR(nContadorDocumentos),9,'0')||' Parc '||LPAD(TO_CHAR(nParcelas),2,'0')||'/'||nPARIDE;
         cFILCLI     := NULL;
         cCODCLI     := NULL;
         cSTATUS     := 'P'; -- Previsto
         cTIPLAN     := cTIPLAN;
         cFILCTA     := NULL;
         cSEQCTA     := NULL;
         cTIPCTA     := NULL;
         cSEQORI     := NULL;
         cNUMDOC     := NULL;
         nVLRPRE_ANT := nVLRPRE;

         -- Insere parcela no fluxo
         INSERT INTO TW_FLU
         (USERID, DATCAL, DATPRE, DATVEN,
          VLRORI, VLRCAL, VLRPRE, NUMPAR,
          SUBPAR, CODFIL, COMPET, TABORI,
          DOCUME, FILCLI, CODCLI, STATUS,
          TIPLAN, FILCTA, SEQCTA, TIPCTA,
          SEQORI, NUMDOC, VLRPRE_ANT,
          FILPGT, CODPGT, FILMAR, CODMAR,
          ITEMAR)
         VALUES
         (nUSERID, dDATCAL, dDATPRE, dDATVEN,
          nVLRORI, nVLRCAL, nVLRPRE, cNUMPAR,
          cSUBPAR, cCODFIL, dCOMPET, cTABORI,
          cDOCUME, cFILCLI, cCODCLI, cSTATUS,
          cTIPLAN, cFILCTA, cSEQCTA, cTIPCTA,
          cSEQORI, cNUMDOC, nVLRPRE_ANT,
          cFILPGT, cCODPGT, cFILMAR, cCODMAR,
          nITEMAR);

         -- Calcula data da prxima parcela
         dDataParcela := ADD_DAY(dDataParcela, nPERIOD);

      END LOOP;

   END LOOP;
   CLOSE CursorPrevisoes;

   RETURN 'OK';

END;
$$ language 'plpgsql';




/*-- SEQ 3094 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION MaterializaViews (CHAR) CASCADE;

/*-- SEQ 3095 --*/
CREATE OR REPLACE FUNCTION MaterializaViews (CHAR)
RETURNS VARCHAR AS $$
DECLARE
pRefresh ALIAS FOR $1 ;
  cMANUT        VARCHAR(1);
  cDUMMY        VARCHAR(2);
  vCOMPLEMENTO  CONSTANT VARCHAR(254) := constante('complemento');

-- Objetivo:
-- 1) Atualizar (reresh) as views materializadas
-- 2) Repopular os dados das views materializadas

-- Parmetros
-- 1) pRefresh
-- a) "P": Parcial - atualiza apenas as alteraes
-- b) "C": Completo - reprocessa completamente as views materializadas

BEGIN
  SELECT MANUT INTO cMANUT
    FROM TT_IDF;

  IF cMANUT = 'F' THEN
    IF pRefresh = 'P' THEN
      cDUMMY := Atualiza_DW_Vendas_Meio();
      cDUMMY := Atualiza_DW_Produto();
      cDUMMY := Atualiza_DW_Vendas_Grupos();
      cDUMMY := Atualiza_DW_Vendas_Produto();
      cDUMMY := Atualiza_DW_Vendas_Cliente();
      cDUMMY := Atualiza_DW_Vendas();
      cDUMMY := Atualiza_DW_Vendas_Hora();
    ELSIF pRefresh = 'C' THEN
      DELETE FROM DW_Log_Vendas_Meio;
      DELETE FROM DW_Vendas_Meio;

      INSERT INTO DW_Vendas_Meio
          (FILIAL, COD_UNIDADE, ANO_MES,
           MEIO, VALOR, PRAZO,
           DCOB_CODTAB, DCAR_CODTAB, DCCC_CODTAB,
           DOUT_CODTAB, CHR_CODFIL, CHR_SEQUEN)
          (SELECT DWV.FILIAL, DWV.COD_UNIDADE, DWV.ANO_MES,
                  DWV.MEIO, DWV.VALOR, DWV.PRAZO,
                  DWV.DCOB_CODTAB, DWV.DCAR_CODTAB, DWV.DCCC_CODTAB,
                  DWV.DOUT_CODTAB, DWV.CHR_CODFIL, DWV.CHR_SEQUEN
             FROM DW_View_Vendas_Meio DWV);

      DELETE FROM DW_Log_Produto;
      DELETE FROM DW_Produto;

      INSERT INTO DW_Produto
          (COD_PRODUTO, PRODUTO, COD_CLASSE1,
           COD_CLASSE2, COD_CLASSE3, COD_CLASSE4,
           COD_DEPARTAMENTO, CLASSE1, CLASSE2,
           CLASSE3, CLASSE4, DEPARTAMENTO,
           FILMAT, CODMAT, CODCOR,
           CODTAM)
          (SELECT DWV.COD_PRODUTO, DWV.PRODUTO, DWV.COD_CLASSE1,
                  DWV.COD_CLASSE2, DWV.COD_CLASSE3, DWV.COD_CLASSE4,
                  DWV.COD_DEPARTAMENTO, DWV.CLASSE1, DWV.CLASSE2,
                  DWV.CLASSE3, DWV.CLASSE4, DWV.DEPARTAMENTO,
                  DWV.FILMAT, DWV.CODMAT, DWV.CODCOR,
                  DWV.CODTAM
             FROM DW_View_Produto DWV);

      DELETE FROM DW_Log_Vendas_Grupos;
      DELETE FROM DW_Vendas_Grupos;

      INSERT INTO DW_Vendas_Grupos
          (FILIAL, ANO_MES, PLANO,
           VENDEDOR, UNIDADE, CLASSE1,
           CLASSE2, CLASSE3, CLASSE4,
           DEPARTAMENTO, VALOR, QUANTIDADE,
           ITENS, COD_CLASSE1, COD_CLASSE2,
           COD_CLASSE3, COD_CLASSE4, COD_DEPARTAMENTO,
           FILPGT, CODPGT)
          (SELECT DWV.FILIAL, DWV.ANO_MES, DWV.PLANO,
                  DWV.VENDEDOR, DWV.UNIDADE, DWV.CLASSE1,
                  DWV.CLASSE2, DWV.CLASSE3, DWV.CLASSE4,
                  DWV.DEPARTAMENTO, DWV.VALOR, DWV.QUANTIDADE,
                  DWV.ITENS, DWV.COD_CLASSE1, DWV.COD_CLASSE2,
                  DWV.COD_CLASSE3, DWV.COD_CLASSE4, DWV.COD_DEPARTAMENTO,
                  DWV.FILPGT, DWV.CODPGT
             FROM DW_View_Vendas_Grupos DWV);

      DELETE FROM DW_Vendas_Produto;

      INSERT INTO DW_Vendas_Produto
          (FILIAL, ANO_MES, COD_PRODUTO,
           VALOR, QUANTIDADE, ITENS)
          (SELECT DWV.FILIAL, DWV.ANO_MES, DWV.COD_PRODUTO,
                  DWV.VALOR, DWV.QUANTIDADE, DWV.ITENS
             FROM DW_View_Vendas_Produto DWV);

      DELETE FROM DW_Log_Vendas_Cliente;
      DELETE FROM DW_Vendas_Cliente;

      INSERT INTO DW_Vendas_Cliente
          (FILIAL, FILIAL_CLIENTE, CODIGO_CLIENTE,
           ANO_MES, VALOR, QTD_ITENS,
           QTD_VENDAS, CONSUMIDOR, CATEGORIA1,
           CATEGORIA2, CATEGORIA3, SEXO,
           ESTADO_CIVIL, PROFISSAO, TIPO_PESSOA,
           OCU_CODTAB, CT1_CODTAB, CT2_CODTAB,
           CT3_CODTAB, NOME_COMPLETO)
          (SELECT DWV.FILIAL, DWV.FILIAL_CLIENTE, DWV.CODIGO_CLIENTE,
                  DWV.ANO_MES, DWV.VALOR, DWV.QTD_ITENS,
                  DWV.QTD_VENDAS, DWV.CONSUMIDOR, DWV.CATEGORIA1,
                  DWV.CATEGORIA2, DWV.CATEGORIA3, DWV.SEXO,
                  DWV.ESTADO_CIVIL, DWV.PROFISSAO, DWV.TIPO_PESSOA,
                  DWV.OCU_CODTAB, DWV.CT1_CODTAB, DWV.CT2_CODTAB,
                  DWV.CT3_CODTAB, NOME_COMPLETO
             FROM DW_View_Vendas_Cliente DWV);

      DELETE FROM DW_Log_Vendas;
      DELETE FROM DW_Vendas;

      INSERT INTO DW_Vendas
          (FILIAL, COD_UNIDADE, DATA,
           QTD_ITENS, QTD_VENDAS, VALOR)
          (SELECT DWV.FILIAL, DWV.COD_UNIDADE, DWV.DATA,
                  DWV.QTD_ITENS, DWV.QTD_VENDAS, DWV.VALOR
             FROM DW_View_Vendas DWV);

      DELETE FROM DW_Log_Vendas_Hora;
      DELETE FROM DW_Vendas_Hora;

      INSERT INTO DW_Vendas_Hora
          (FILIAL, DATA, HORA,
           VALOR, QTDVEN)
          (SELECT DWV.FILIAL, DWV.DATA, DWV.HORA,
                  DWV.VALOR, DWV.QTDVEN
             FROM DW_View_Vendas_Hora DWV);
    ELSE
      RAISE EXCEPTION 'PG-20010 Parmetro "%" invlido. %' , pRefresh,vCOMPLEMENTO;
    END IF;
  END IF;

  RETURN 'OK';
END;
$$ language 'plpgsql';


/*-- SEQ 3096 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION MaterializaViews () CASCADE;

/*-- SEQ 3097 --*/
CREATE OR REPLACE FUNCTION MaterializaViews () 
RETURNS VARCHAR AS $$
BEGIN
RETURN MaterializaViews('P');
END;
$$ language 'plpgsql';

/*-- SEQ 3098 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_MaterializaViews (TT_JOB.CODUID%TYPE) CASCADE;

/*-- SEQ 3099 --*/
CREATE OR REPLACE FUNCTION Job_MaterializaViews (TT_JOB.CODUID%TYPE)
RETURNS VARCHAR AS $$
DECLARE
pCODUID ALIAS FOR $1 ;
   vNOME                         TT_JOB.NOMJOB%TYPE;
   vDESC                         TT_JOB.DESJOB%TYPE;
   DUMMY                         VARCHAR(2);
BEGIN
   vNOME := 'JOB_MATERIALIZAVIEWS';
   vDESC := 'Rotina para materializar views para Decisor';
   BEGIN
      DUMMY := MaterializaViews();
      DUMMY := RegistraJob(vNOME, vDESC, NULL, pCODUID);
   EXCEPTION
      WHEN OTHERS THEN DUMMY := RegistraJob(vNOME, vDESC, SQLERRM, pCODUID);
   END;   
  RETURN NULL;

END;
$$ language 'plpgsql';


/*-- SEQ 3100 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION Job_MaterializaViews () CASCADE;

/*-- SEQ 3101 --*/
CREATE OR REPLACE FUNCTION Job_MaterializaViews () 
RETURNS VARCHAR AS $$
BEGIN
RETURN Job_MaterializaViews(NULL);
END;
$$ language 'plpgsql';


/*-- SEQ 3102 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RETORNA_CFOP (TV_CMP.CODFIL%TYPE,TV_CMP.SEQUEN%TYPE) CASCADE;

/*-- SEQ 3103 --*/
CREATE OR REPLACE FUNCTION RETORNA_CFOP (TV_CMP.CODFIL%TYPE,TV_CMP.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
PCODFIL ALIAS FOR $1 ;
PSEQUEN ALIAS FOR $2 ;
-- Objetivo
-- 1) CFOP de Compra Nas CFOPs de transferencia, listar 1152 para entradas nas filiais <> MATRIZ, e quando for = MATRIZ listar 1209
-- Somente feito para Grafipel
CCFOP  VARCHAR(6);
-- Principal
BEGIN    
  SELECT (CASE WHEN (COM.CODCFO IS NULL) AND (DFIL.CODFIL =  '001') THEN '1209'
               WHEN (COM.CODCFO IS NULL) AND (DFIL.CODFIL <> '001') THEN '1152'
               ELSE CFOP.CODCFO 
          END) INTO CCFOP
    FROM TV_CMP COM INNER JOIN TD_FIL DFIL ON COM.CODFIL = DFIL.CODFIL
                     LEFT JOIN TD_CFO CFOP ON CFOP.CODTAB = COM.CODCFO
  WHERE COM.CODFIL= PCODFIL
    AND COM.SEQUEN= PSEQUEN;
  RETURN CCFOP;
END;
$$ language 'plpgsql';




/*-- SEQ 3104 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION RETORNA_DEP (TV_CMP.CODFIL%TYPE,TV_CMP.SEQUEN%TYPE) CASCADE;

/*-- SEQ 3105 --*/
CREATE OR REPLACE FUNCTION RETORNA_DEP (TV_CMP.CODFIL%TYPE,TV_CMP.SEQUEN%TYPE)
RETURNS VARCHAR AS $$
DECLARE
PCODFIL ALIAS FOR $1 ;
PSEQUEN ALIAS FOR $2 ;
-- Objetivo
-- 1) Departamento Quando feito entrada de compra sem itens de compra, usar a descricao de unidade de negocio como DEPARTAMENTO.
-- Somente feito para Grafipel
CDEPTO  VARCHAR(40);
-- Principal
BEGIN    
 SELECT DCTR.DESCTR INTO CDEPTO
  FROM TV_CMP COM LEFT OUTER JOIN TT_CTR CTR ON COM.SEQUEN = CTR.SEQUEN 
                                            AND COM.CODFIL = CTR.CODFIL 
                                            AND COM.TIPNOT = CTR.TIPNOT
                  LEFT OUTER JOIN TD_FIL COMCODFIL ON COM.CODFIL = COMCODFIL.CODFIL
                  LEFT OUTER JOIN TD_CFO COMCODCFOP ON COMCODCFOP.CODTAB = COM.CODCFO
                  LEFT OUTER JOIN TD_CTR DCTR ON DCTR.CODTAB = CTR.CODCTR
                  LEFT OUTER JOIN TT_ICO ICO ON ICO.CODFIL = COM.CODFIL 
                                            AND ICO.SEQUEN = COM.SEQUEN
  WHERE COM.CODFIL= PCODFIL
    AND COM.SEQUEN= PSEQUEN
    AND ICO.CODFIL IS NULL;
  RETURN CDEPTO;
END;
$$ language 'plpgsql';






/*-- SEQ 3106 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ValoresProduto (CHAR,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE,TT_GRA.CUSREP%TYPE,TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE) CASCADE;

/*-- SEQ 3107 --*/
CREATE OR REPLACE FUNCTION ValoresProduto (CHAR,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE,TT_GRA.CUSREP%TYPE,TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE)
RETURNS Numeric AS $$
DECLARE
p_Tipo ALIAS FOR $1 ;
p_FILMAT ALIAS FOR $2 ;
p_CODMAT ALIAS FOR $3 ;
p_CODCOR ALIAS FOR $4 ;
p_CODTAM ALIAS FOR $5 ;
p_CODFIL ALIAS FOR $6 ;
p_CUSREP ALIAS FOR $7 ;
p_FILFOR ALIAS FOR $8 ;
p_CODFOR ALIAS FOR $9 ;
  nResult Numeric;
  vCUSTO_POR_FILIAL tt_cfg.CUSTO_POR_FILIAL%type;
  cCODTAM TT_GRA.CODTAM%TYPE;
  nFATCON TT_SUB.FATCON%TYPE;

/* * * * * * * * * * * * * * * * * * * * * * * * */
/*                                               */
/* Calcula o preco de venda, custo de reposicao  */
/* Preo de compra e custo mdio do produto      */
/*                                               */
/* * * * * * * * * * * * * * * * * * * * * * * * */
begin

nResult:=0;

SELECT TD.CODSAL, TT.FATCON INTO cCODTAM, nFATCON
  FROM TD_SUB TD INNER JOIN TT_SUB TT ON TD.CODTAB = TT.CODSUB
 WHERE TT.CODITE  = p_CODTAM;

 cCODTAM := COALESCE(cCODTAM, p_CODTAM);

 --(V)Preo de venda:
IF p_TIPO='V' THEN
    SELECT PRECOV INTO nResult
    FROM TV_VAR
    WHERE FILMAT = p_FILMAT
     AND CODMAT = p_CODMAT
     AND CODCOR = p_CODCOR
     AND CODTAM = cCODTAM
     LIMIT 1;

--(R) custo de reposio
ELSIF p_TIPO='R' THEN

    SELECT CUSTO_POR_FILIAL into vCUSTO_POR_FILIAL  from tt_cfg;

    IF p_CODFIL IS NULL or vCUSTO_POR_FILIAL='F' THEN
        SELECT CUSREP INTO nResult
        FROM TT_GRA
        WHERE FILMAT = p_FILMAT
         AND CODMAT = p_CODMAT
         AND CODCOR = p_CODCOR
         AND CODTAM = cCODTAM;
    ELSE
        SELECT REPCMP INTO nResult
          FROM TT_SAL
         WHERE CODFIL = p_CODFIL
           AND FILMAT = p_FILMAT
           AND CODMAT = p_CODMAT
           AND CODCOR = p_CODCOR
           AND CODTAM = cCODTAM;
    END IF;

--(C) Preo de compra
ELSIF p_TIPO='C' THEN

    SELECT CUSTO_POR_FILIAL into vCUSTO_POR_FILIAL  from tt_cfg;

    IF p_CODFIL IS NULL or vCUSTO_POR_FILIAL='F' THEN
        SELECT PRECOM INTO nResult
        FROM TT_GRA
        WHERE FILMAT = p_FILMAT
         AND CODMAT = p_CODMAT
         AND CODCOR = p_CODCOR
         AND CODTAM = cCODTAM;
    ELSE
        SELECT PRECMP INTO nResult
          FROM TT_SAL
         WHERE CODFIL = p_CODFIL
           AND FILMAT = p_FILMAT
           AND CODMAT = p_CODMAT
           AND CODCOR = p_CODCOR
           AND CODTAM = cCODTAM;
    END IF;

--(M) custo mdio
-- Implementao Futura
ELSIF p_TIPO='M' THEN

    SELECT CASE WHEN (COALESCE(SAL.EST_CM,0)<0 OR SAL.EST_CM IS NULL OR COALESCE(SAL.TOT_CM,0)=0)
                   THEN CUSTOMEDIO(SAL.CODFIL,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,3)
                WHEN COALESCE(SAL.EST_CM,0)=0
                   THEN SAL.TOT_CM ELSE SAL.TOT_CM/SAL.EST_CM END
                   INTO nResult
      FROM TT_SAL SAL
     WHERE SAL.CODFIL=CASE WHEN p_CODFIL IS NULL THEN (SELECT CODLOJ FROM TT_IDF) ELSE p_CODFIL END
       AND SAL.FILMAT=p_filmat
       AND SAL.CODMAT=p_codmat
       AND SAL.CODCOR=p_codcor
       AND SAL.CODTAM=cCODTAM
       AND SAL.CODMUL=0;

ELSIF p_TIPO='G' THEN

    SELECT CASE WHEN (COALESCE(SAL.EST_CM,0)<0 OR SAL.EST_CM IS NULL OR COALESCE(SAL.TOT_CM,0)=0)
                   THEN CUSTOMEDIO(SAL.CODFIL,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,5)
                WHEN COALESCE(SAL.EST_CM,0)=0
                   THEN SAL.TOTCMG ELSE SAL.TOTCMG/SAL.EST_CM END
                   INTO nResult
      FROM TT_SAL SAL
     WHERE SAL.CODFIL=CASE WHEN p_CODFIL IS NULL THEN (SELECT CODLOJ FROM TT_IDF) ELSE p_CODFIL END
       AND SAL.FILMAT=p_filmat
       AND SAL.CODMAT=p_codmat
       AND SAL.CODCOR=p_codcor
       AND SAL.CODTAM=cCODTAM
       AND SAL.CODMUL=0;

--(S) - Preo Simulado.
ELSIF p_TIPO='S' THEN
    IF p_FILFOR IS NULL THEN
        RAISE EXCEPTION 'PG-20100 O Parmetro p_FILFOR deve ser preenchida para Preo Simulado';
    END IF;
    IF p_CODFOR IS NULL THEN
        RAISE EXCEPTION 'PG-20110 O Parmetro p_CODFOR deve ser preenchida para Preo Simulado';
    END IF;

    SELECT CASE WHEN (p_CODFIL IS NULL)
                THEN COALESCE(COALESCE(PXF.PRESIM, PXF.PRECOM), GRA.PRECOM)
                ELSE COALESCE(COALESCE(COALESCE(PXF.PRESIM, PXF.PRECOM), SAL.PRECMP), GRA.PRECOM) END
           INTO nResult
      FROM TT_PXF PXF
INNER JOIN TT_GRA GRA ON GRA.FILMAT = PXF.FILMAT
                     AND GRA.CODMAT = PXF.CODMAT
                     AND GRA.CODCOR = PXF.CODCOR
                     AND GRA.CODTAM = PXF.CODTAM
INNER JOIN TT_SAL SAL ON SAL.CODFIL = CASE WHEN p_CODFIL IS NULL THEN (SELECT CODLOJ FROM TT_IDF) ELSE p_CODFIL END
                     AND SAL.FILMAT = PXF.FILMAT
                     AND SAL.CODMAT = PXF.CODMAT
                     AND SAL.CODCOR = PXF.CODCOR
                     AND SAL.CODTAM = PXF.CODTAM
                     AND SAL.CODMUL = 0
     WHERE PXF.FILMAT = p_FILMAT
       AND PXF.CODMAT = p_CODMAT
       AND PXF.CODCOR = p_CODCOR
       AND PXF.CODTAM = cCODTAM
       AND PXF.FILFOR = p_FILFOR
       AND PXF.CODFOR = p_CODFOR;

     -- MN - O cdigo acima no foi bem escrito, porque o coalesce que traria GRA.PRECOM no traz nada se no
     -- tem registro na TT_PXF daquele produto/fornecedor. Para contornar isso, se o preo for simulado (uso isso na tela de pedido de compra)
     -- e no trouxer nada, assume o preo da TT_GRA, na realidade o cdigo abaixo  o mesmo de chamar a funo com p_tipo = 'C'
    if (nResult = 0) or (nResult is null) then
      SELECT CUSTO_POR_FILIAL into vCUSTO_POR_FILIAL  from tt_cfg;

       IF p_CODFIL IS NULL or vCUSTO_POR_FILIAL='F' THEN
           SELECT PRECOM INTO nResult
           FROM TT_GRA
           WHERE FILMAT = p_FILMAT
            AND CODMAT = p_CODMAT
            AND CODCOR = p_CODCOR
            AND CODTAM = cCODTAM;
       ELSE
           SELECT PRECMP INTO nResult
             FROM TT_SAL
            WHERE CODFIL = p_CODFIL
              AND FILMAT = p_FILMAT
              AND CODMAT = p_CODMAT
              AND CODCOR = p_CODCOR
              AND CODTAM = cCODTAM;
       END IF; 
    end if;    
END IF;

-- Na carga (TT_OUT), assume o CUSREP caso no haja outro custo
IF coalesce(nResult,0) = 0 AND COALESCE(P_CUSREP,0) <> 0 THEN
   nResult := P_CUSREP;
END IF;

return trunc(nResult*nvlz(nFATCON,1),4);

END;
$$ language 'plpgsql';


/*-- SEQ 3108 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ValoresProduto (CHAR,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE,TT_GRA.CUSREP%TYPE) CASCADE;

/*-- SEQ 3109 --*/
CREATE OR REPLACE FUNCTION ValoresProduto (CHAR,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               TD_FIL.CODFIL%TYPE,
                               TT_GRA.CUSREP%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN ValoresProduto($1,$2,$3,$4,$5,$6,$7,null,null);
END;
$$ language 'plpgsql';


/*-- SEQ 3110 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ValoresProduto (CHAR,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 3111 --*/
CREATE OR REPLACE FUNCTION ValoresProduto (CHAR,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               TD_FIL.CODFIL%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN ValoresProduto($1,$2,$3,$4,$5,$6,null);
END;
$$ language 'plpgsql';


/*-- SEQ 3112 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ValoresProduto (CHAR,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE) CASCADE;

/*-- SEQ 3113 --*/
CREATE OR REPLACE FUNCTION ValoresProduto (CHAR,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN ValoresProduto($1,$2,$3,$4,$5,null);
END;
$$ language 'plpgsql';






/*-- SEQ 3114 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_AVA CASCADE;

/*-- SEQ 3115 --*/
CREATE OR REPLACE VIEW TV_AVA AS
select USU.NOMUSU, AVA.FILADO, AVA.CODADO, AVA.NOTAVA 
  from tt_ava AVA INNER JOIN TT_USU USU ON AVA.FILADO = USU.FILUSU AND AVA.CODADO = USU.CODUSU
;


/*-- SEQ 3116 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CLI_OUT CASCADE;

/*-- SEQ 3117 --*/
CREATE OR REPLACE VIEW TV_CLI_OUT AS
SELECT DISTINCT CHAVECLI,CHAVEVIN,CHAVEPLA,NUMDOC,TRANSP,PARNUM,OBSERV,DATNAS,DATOPE,ULTCOM,
       ATIVO,DIVIDA,CODFID,PERFID,NOMCLI,ULTNOM,ESTCIV,FLGTIP,SUFRAM,INSEST,
       CODSEX,CONJUG,VALOR1,TOTATR, TOTPAR,MAIATR,IMPRIM,CATEG1,ATU_EM,SIMPLE,REGMEI,
       E_MAIL,CODEXT,CATEG3,CCCPRE,TIPDOC,ID_DAT, ID_ORG,ID_EST,GLOBAL,ESTRAN,
       ISENTO,CODNAE,PRAZOCARFRE,LIMCHE,ISECHE,NAODIV,DETTIP,DATCRE,ENTISE,FILEND,
       NUMEND,CODGUI,DDDCEL,NUMCEL,E_MFIN,CODPAI,MAXBON,COD_RNTC,FIL_CK,ECF_CK,COD_CK, 
       EXPTOD,EXPORTA,FILCLI,CODCLI,CHV_FILCLI,CHV_CODCLI,CONTRIBUINTE
  FROM (
  SELECT CAST(CLI.FILCLI || CLI.CODCLI AS VARCHAR(9)) as CHAVECLI,
         CAST(CLI.FILVIN || CLI.CODVIN AS VARCHAR(9)) as CHAVEVIN,
         CAST(CLI.FILPLA || CLI.CODPLA AS VARCHAR(6)) as CHAVEPLA,
         CLI.FILCLI,
         CLI.CODCLI,
         CLI.FILCLI AS CHV_FILCLI,
         CLI.CODCLI AS CHV_CODCLI,
         COALESCE(CLI.NUMDOC,VIN.NUMDOC) AS NUMDOC,
         CAST(RPAD(TipoParceiro( CLI.FILCLI, CLI.CODCLI, 'T' ),1,' ') AS CHAR(1)) AS TRANSP,
         EAN.CODTAB AS PARNUM,
         CAST(TO_CHAR( CLI.DATNAS, 'DD/MM/YYYY' ) AS VARCHAR(10)) AS DATNAS,
         CAST(SUBSTR(CASE WHEN (CFG.ENVIADATFATURAMENTO = 'T' AND CLI.OBSOUT IS NULL) THEN TRAZDESCRICAOFATURAMENTO(CLI.FILCLI,CLI.CODCLI) ELSE CLI.OBSOUT END,1,4000) AS VARCHAR(4000)) AS OBSERV,
         CAST(TO_CHAR( CLI.DATOPE, 'DD/MM/YYYY' ) AS VARCHAR(10)) AS DATOPE,
         CAST(TO_CHAR( CLI.ULTCOM, 'DD/MM/YYYY' ) AS VARCHAR(10)) AS ULTCOM,
         CAST(CASE ABS(COALESCE(CLI.SIGNAT,0)) WHEN COALESCE(CLI.SIGNAT,0) THEN 'T' ELSE 'F' END AS CHAR(1)) AS ATIVO,
         CASE WHEN CLI.FILCLI || CLI.CODCLI = CFG.VC_FILCLI||CFG.VC_CODCLI THEN 0 ELSE Divida( CLI.FILCLI, CLI.CODCLI,COALESCE(CLI.NUMDOC,VIN.NUMDOC)) END AS DIVIDA,
         CAST(CASE WHEN CLI.FLGTIP = 0 THEN CLI.NOMCLI||' '||COALESCE(CLI.ULTNOM,'') ELSE CLI.NOMCLI END AS VARCHAR(95))AS NOMCLI,
         CAST(CASE WHEN CLI.FLGTIP = 0 THEN TO_CHAR('') ELSE CLI.ULTNOM END AS VARCHAR(30)) AS ULTNOM,
         CLI.CODFID,
         FID.PERFID,
         CLI.ESTCIV,
         CLI.FLGTIP,
         CLI.SUFRAM,
         CLI.INSEST,
         CLI.CODSEX,
         CLI.CONJUG,
         CLI.VALOR1,
         CLI.TOTATR,
         CLI.TOTPAR,
         CLI.MAIATR,
         CLI.CATEG2 AS IMPRIM,
         CLI.CATEG1,
         CAST(TO_CHAR(CLI.ATU_EM,'DD/MM/YYYY HH24:MI:SS') AS VARCHAR(21)) AS ATU_EM,
         CAST(TO_CHAR(CLI.CCCPRE) AS VARCHAR(255)) AS CCCPRE,
         CLI.SIMPLE,
         CLI.REGMEI,
         CASE WHEN CLI.FLGTIP = '0' THEN SPC.E_MAIL ELSE CLI.E_MCON END AS E_MAIL,
         CFG.EXPORTA_TODOS_CLIENTES AS EXPTOD,
         CLI.CODEXT,
         CLI.CATEG3,
         CLI.TIPDOC,
         CAST(TO_CHAR(CLI.ID_DAT,'DD/MM/YYYY') AS VARCHAR(10)) AS ID_DAT,
         CLI.ID_ORG,
         CLI.ID_EST,
         CASE WHEN CLI.ULTCOM>ADD_DAY(AGORA(),-90) THEN 'T' ELSE 'F' END AS VEN3ME,
         CLI.GLOBAL AS GLOBAL,
         CLI.ESTRAN AS ESTRAN,
         BUSCAEXPORTA(CLI.FILCLI, CLI.CODCLI) AS EXPORTA,
         CLI.ISENTO AS ISENTO,
         CLI.CODNAE,
         CASE WHEN (COALESCE(CFG.TIPPOS,'F') = 'T') AND (COALESCE(CFG.USA_PREATENDIMENTO,'F') = 'T')
              THEN (SELECT MIN(COALESCE(LIM.CARENC,0) + (CASE WHEN DXC.CODCLI IS NULL
                                                              THEN 0
                                                              ELSE CASE WHEN COALESCE(DXC.DIASEM,0) <> 0
                                                                        THEN 4
                                                                        ELSE 15
                                                                   END
                                                         END))
                      FROM TT_LIM LIM LEFT JOIN TT_DXC DXC ON DXC.FILCLI = LIM.FILCLI AND DXC.CODCLI = LIM.CODCLI AND DXC.CODCCC = LIM.TIPCCC
                     WHERE LIM.FILCLI = CLI.FILCLI AND LIM.CODCLI = CLI.CODCLI AND LIM.TIPCCC = CFG.CC_CARTAFRETE)
              ELSE 0
         END AS PRAZOCARFRE,
         CLI.LIMCHE,
         CLI.ISECHE,
         CLI.NAODIV,
         CLI.DETTIP,
         CAST(TO_CHAR(CLI.DATCRE,'DD/MM/YYYY HH24:MI:SS') AS VARCHAR(21)) AS DATCRE,
         CLI.ENTISE,
         CLI.FILEND,
         CLI.NUMEND,
         CAST(CASE WHEN CLI.FILGUI IS NULL
                   THEN NULL
                   ELSE COALESCE(CLI.FILGUI,'')||LPAD(LTRIM(COALESCE(CLI.CODGUI,'')),6,' ')
              END AS VARCHAR(9)) AS CODGUI,
         SPC.DDDCEL,
         SPC.NUMCEL,
         CLI.E_MFIN,
         CLI.CODPAI,
         CLI.MAXBON,
         CLI.COD_RNTC,
         CLI.FIL_CK,
         CLI.ECF_CK,
         CLI.COD_CK,
         CLI.CONTRIBUINTE
    FROM TT_CFG CFG, TT_CLI CLI LEFT OUTER JOIN TD_FID FID ON FID.CODTAB = CLI.CODFID
                                LEFT OUTER JOIN TD_EAN EAN ON EAN.EANFIL = CLI.FILCLI AND EAN.EANCOD = CLI.CODCLI
                                LEFT OUTER JOIN TT_CLI VIN ON VIN.FILCLI = CLI.FILVIN AND VIN.CODCLI = CLI.CODVIN
                                LEFT OUTER JOIN TT_SPC SPC ON SPC.FILCLI = CLI.FILCLI AND SPC.CODCLI = CLI.CODCLI
 ) CLI
;


/*-- SEQ 3118 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_CTR_NUM CASCADE;

/*-- SEQ 3119 --*/
CREATE OR REPLACE VIEW TV_CTR_NUM AS
SELECT FIN.FILREC,
	   FIN.FILCTA,
	   FIN.SEQCTA,
	   FIN.TIPCTA,
	   FIN.FILCRT,
	   FIN.SEQCRT,
	   FIN.TIPCRT,
	   FIN.DATPGT,
	   FIN.FILUSU,
	   FIN.CODUSU,
	   FIN.FILCLI,
	   FIN.CODCLI,
	   FIN.NOMCLI,
	   FIN.ULTNOM,
	   FIN.OBSERV,
	   FIN.CODFIL,
	   FIN.SEQUEN,
	   FIN.NUMPAR,
	   FIN.SUBPAR,
	   FIN.FLGEST,
	   FIN.TABORI,
	   FIN.NOMORI,
	   FIN.VLRPGT,
	   FIN.DOCUME,
	   FIN.CHVFIN,
	   FIN.FLGFLX,
	   FIN.COMPLE,
	   FIN.TIPLAN,
	   FIN.ATU_EM,
	   FIN.ESTORN,
	   FIN.RFIN_CODTAB,
	   FIN.ID_OPE,
	   FIN.TIPOPE,
	   FIN.VLRRAT,
	   FIN.CODCTR,
       FIN.FILDES
  FROM TV_CTR FIN
UNION ALL
SELECT FIN.FILREC,
	   FIN.FILCTA,
	   FIN.SEQCTA,
	   FIN.TIPCTA,
	   FIN.FILCRT,
	   FIN.SEQCRT,
	   FIN.TIPCRT,
	   FIN.DATPGT,
	   FIN.FILUSU,
	   FIN.CODUSU,
	   FIN.FILCLI,
	   FIN.CODCLI,
	   FIN.NOMCLI,
	   FIN.ULTNOM,
	   FIN.OBSERV,
	   FIN.CODFIL,
	   FIN.SEQUEN,
	   FIN.NUMPAR,
	   FIN.SUBPAR,
	   FIN.FLGEST,
	   FIN.TABORI,
	   FIN.NOMORI,
	   FIN.VLRPGT,
	   FIN.DOCUME,
	   FIN.CHVFIN,
	   FIN.FLGFLX,
	   FIN.COMPLE,
	   FIN.TIPLAN,
	   FIN.ATU_EM,
	   FIN.ESTORN,
	   FIN.RFIN_CODTAB,
	   FIN.ID_OPE,
	   FIN.TIPOPE,
	   FIN.VLRPGT AS VLRRAT,
       0 AS CODCTR,
       FIN.FILDES
  FROM TV_FIN FIN
WHERE  FIN.FLGFLX='R'
   AND FIN.TIPCTA='N'
   AND FIN.TIPCRT='N'
;


/*-- SEQ 3120 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_ECON_AC_50 CASCADE;

/*-- SEQ 3121 --*/
CREATE OR REPLACE VIEW TV_ECON_AC_50 AS
SELECT CAST('0050' AS CHAR(4)) AS REGISTRO,
       FIN.FILREC AS CODFIL,
       FIN.DATPGT AS DATLAN,
       ABS(SUM(FIN.VLRRAT)) AS VLRLAN,
       FIN.TIPOPE,
       COALESCE(CTAXFIL.CODEXT, CTA.CODEXT) AS CTA_CODEXT,
       COALESCE(CRTXFIL.CODEXT, CRT.CODEXT) AS CRT_CODEXT,
       FIL.CODEXT AS FIL_CODEXT,
       CTR.CODEXT AS CTR_CODEXT,
       FIN.RFIN_CODTAB,
       FIN.ID_OPE,
       FIN.FILDES,
       FIL.CGCFIL,
       DES.CGCFIL AS CGCFILDES,
       DES.CODEXT AS DES_CODEXT
  FROM TV_CTR_NUM FIN INNER JOIN TD_FIL FIL ON FIN.FILREC = FIL.CODFIL
					  INNER JOIN TT_CTA CTA ON FIN.FILCTA = CTA.CODFIL AND FIN.SEQCTA = CTA.SEQUEN AND FIN.TIPCTA = CTA.TIPCTA
					  INNER JOIN TT_CTA CRT ON FIN.FILCRT = CRT.CODFIL AND FIN.SEQCRT = CRT.SEQUEN AND FIN.TIPCRT = CRT.TIPCTA
					  INNER JOIN TD_CTR CTR ON CTR.CODTAB = FIN.CODCTR
                      INNER JOIN TD_FIL DES ON DES.CODFIL = FIN.FILDES
                       LEFT JOIN TT_CTAXFIL CTAXFIL ON CTA.CODFIL=CTAXFIL.FILCTA AND CTA.SEQUEN = CTAXFIL.SEQCTA AND CTA.TIPCTA = CTAXFIL.TIPCTA AND CTAXFIL.CODFIL=FIN.CODFIL
                       LEFT JOIN TT_CTAXFIL CRTXFIL ON CRT.CODFIL=CRTXFIL.FILCTA AND CRT.SEQUEN = CRTXFIL.SEQCTA AND CRT.TIPCTA = CRTXFIL.TIPCTA AND CRTXFIL.CODFIL=FIN.CODFIL
 WHERE COALESCE(CTA.CODEXT,CTA.SEQUEN) <> COALESCE(CRT.CODEXT,CRT.SEQUEN) -- DN - Trazer contas sem codigo externo
 GROUP BY FIN.FILREC, FIN.DATPGT, FIN.TIPOPE, CTA.CODEXT, CTAXFIL.CODEXT, CRT.CODEXT, CRTXFIL.CODEXT, FIL.CODEXT, CTR.CODEXT, FIN.RFIN_CODTAB, FIN.ID_OPE, FIN.FILDES,
   FIL.CGCFIL, DES.CGCFIL, DES.CODEXT
;


/*-- SEQ 3122 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_EXC CASCADE;

/*-- SEQ 3123 --*/
CREATE OR REPLACE VIEW TV_EXC AS
SELECT nivel,
       CAST (substr(lpad(' ',NIVEL*2,' ')||titcta,1,80) AS VARCHAR(80)) as Estrutura_e_Conta,
       CAST (case tipcta when 'T' then 'Cta. Ttulo'
                   when 'G' then 'Cta. Gerencial'
                   when 'M' then 'Cta. p/ Transf'
                   when 'N' then 'Cta. Numerria'
       end AS VARCHAR(20)) as tipo,
       filcta,seqcta, tipcta
FROM (
-- Ver detalhes sobre a macro em
-- \\tt2000\Docs\desenv\depto\Manuais\Ansi\connectby.mac
SELECT c.conn_codigo as codigo, case c.conn_codpai when 'NULL' then null
                                           else c.conn_codpai
               end as codpai, c.level as nivel, c.ordem-1 as ordem ,titcta,tipcta,filcta,seqcta
FROM connectby('(select to_char(''NULL'') as filho,
                        to_char(null) as pai,
                        0 as ordem
                   from dual
                 union all
                 select TO_CHAR(chv_id) as filho,
                        coalesce(TO_CHAR(chvpai),''NULL'') as pai,
                        0 as ordem
                   from tv_ect int) tab', 'filho', 'pai','ordem', 'NULL', 0, '~')
AS c (conn_codigo VARCHAR, conn_codpai VARCHAR, level int, arvore text, ordem int)
INNER JOIN tv_ect t ON c.conn_codigo  = (chv_id)
where conn_codigo<>'NULL'
order by ordem
) TAB
ORDER BY ORDEM


/*-- SEQ 3124 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IXT_CB01 CASCADE;

/*-- SEQ 3125 --*/
CREATE OR REPLACE VIEW TV_IXT_CB01 AS
SELECT BXC.LICENC,
       CTB.NUMAGE,
       CTB.NUMAGE_NOSNUM,
       CAST(CASE  WHEN CTB.CODBCO = '422'
                       THEN CTB.NUMAGE
                  WHEN CTB.CODBCO = '356' -- Numeric
                       THEN LPAD(TO_CHAR(TO_NUMBER(CTB.NUMAGE)),4,'0')
                  WHEN CTB.CODBCO = '033' -- SANTANDER
                       THEN LPAD(TO_CHAR(TO_NUMBER(CTB.NUMAGE)||(CTB.DIGAGE)),4,'0')
                  WHEN CTB.CODBCO = '237' -- BRADESCO
                       THEN LPAD(TO_CHAR(TO_NUMBER(CTB.NUMAGE)),4,'0')||'-'||CTB.DIGAGE
                  WHEN CTB.CODBCO = '104' -- CAIXA ECONOMICA FEDERAL
                       THEN LPAD(TO_CHAR(TO_NUMBER(CTB.NUMAGE)),4,'0')  -- 84970
                  ELSE TO_CHAR(TO_NUMBER(CTB.NUMAGE))||'-'||CTB.DIGAGE
             END AS VARCHAR(10)) AS AGENCIA,
       CAST(CASE  WHEN CTB.CODBCO = '409' -- UNIBANCO
                       THEN SUBSTR(TO_CHAR(TO_NUMBER(CTB.CTACRR)),1,3)||'.'||SUBSTR(TO_CHAR(TO_NUMBER(CTB.CTACRR)),4,3)||'-'||CTB.DIGCRR
                  WHEN CTB.CODBCO = '422' -- SAFRA
                       THEN LPAD(TO_CHAR(TO_NUMBER(CTB.CTACRR)),8,'0')||'-'||CTB.DIGCRR
                  WHEN CTB.CODBCO = '356' -- Numeric
                       THEN LPAD(TO_CHAR(TO_NUMBER(CTB.CTACRR)),7,'0')
                  WHEN CTB.CODBCO = '237' -- BRADESCO
                       THEN LPAD(TO_CHAR(TO_NUMBER(CTB.CTACRR)),7,'0')||'-'||CTB.DIGCRR
                  WHEN CTB.CODBCO = '104' -- CAIXA ECONOMICA FEDERAL
                       THEN LPAD(TO_CHAR(TO_NUMBER(CTB.CTACRR)),7,'0') -- 84970
                  ELSE TO_CHAR(TO_NUMBER(CTB.CTACRR))||'-'||CTB.DIGCRR
             END AS VARCHAR(15)) AS CONTAC,
       CAST(CASE  WHEN (CTB.CODBCO = '399') AND (CTB.DIGAGE = '0')
                       THEN ''
                  ELSE CTB.DIGAGE
             END AS VARCHAR(5)) AS DIGAGE,
       CTB.CTACRR,
       CTB.DIGCRR,
       FIL.CGCFIL,
       CAST(CASE  WHEN CTB.CODBCO = '237' -- BRADESCO
                  THEN CAST('00000000001' AS CHAR(11))
                  ELSE CAST('0000000001' AS CHAR(10))
             END AS VARCHAR(11)) AS INICIO,
       CAST(CASE  WHEN CTB.CODBCO = '237' -- BRADESCO
                  THEN CAST('09999999999' AS CHAR(11))
                  ELSE CAST('9999999999' AS CHAR(10))
             END AS VARCHAR(11)) AS FIM,
       CTB.PRXTIT,
       FormataConvenio(BXC.CODCNV, BXC.CODCCB, CRB.APECRB, CTB.CODBCO) AS CODCNV,
       BXC.CODCNV AS CONVENIO,
       CTB.CODBCO,
       FIL.CODFIL,
       CFG.LOGOBOLETO,
       BXC.CODCCB,
       CRB.APECRB,
       BXC.LAYPAD,
       BXC.LAYBOL,
       BXC.RECSAC,
       FIL.ENDERE AS FILENDERE,
       MFL.NOMCID AS FILNOMCID,
       FIL.COMPLE AS FILCOMPLE,
       FIL.BAIRRO AS FILBAIRRO,
       FIL.CODCEP AS FILCODCEP,
       FIL.UFLOJA AS FILUFLOJA,
       FIL.NUMERO AS FILNUMERO,
       BXC.SEQREM
  FROM TT_CTB CTB INNER JOIN TD_FIL FIL ON CTB.FILCTA = FIL.CODFIL
                  INNER JOIN TT_CTBXCCB BXC ON CTB.CODBCO = BXC.CODBCO
                                           AND CTB.NUMAGE = BXC.NUMAGE
                                           AND CTB.CTACRR = BXC.CTACRR
                  INNER JOIN TT_CCB CCB ON BXC.CODCCB = CCB.CODCCB AND BXC.CODBCO = CCB.CODBCO
                   LEFT JOIN TT_MUN MFL ON MFL.CODIGO = FIL.CODCID
                   LEFT JOIN TT_CRB CRB ON CCB.CODCRB = CRB.CODTAB
                  CROSS JOIN TT_CFG CFG
;


/*-- SEQ 3126 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_IXT_CB02 CASCADE;

/*-- SEQ 3127 --*/
CREATE OR REPLACE VIEW TV_IXT_CB02 AS
SELECT IXT.SEQUEN, IXT.SEQTIT, TIT.NOSNUM, CAST(LPAD(TO_CHAR(IXT.CODREM),2,'0') AS VARCHAR(2)) AS CODREM,
       CAST(LPAD(VEN.CODSER,2,' ')||LPAD(VEN.NUMNOT,6,' ')||LPAD(REC.NUMPAR,2,' ')||LPAD(REC.SUBPAR,2,' ') AS VARCHAR(12)) AS DOCUMENTO,
       CAST(TIT.CODFIL||'/'||TRIM(TIT.SEQUEN) AS VARCHAR(15)) AS CONTROLE,
       CLI.FILCLI AS CLI_FILCLI,
       CLI.CODCLI AS CLI_CODCLI,
       CLI.FLGTIP,
       CLI.NOMCLI,
       CLI.ULTNOM,
       CAST(SUBSTR(CASE WHEN CLI.FLGTIP = 0
                        THEN TRIM(CLI.NOMCLI)||' '||TRIM(coalesce(CLI.ULTNOM,''))
                        ELSE TRIM(CLI.NOMCLI)
                   END,1,45) AS VARCHAR(45)) AS NOME,
       CAST(CASE WHEN COALESCE(CLI.ESTRAN,'F') = 'F'
                 THEN CASE WHEN Equal(TRIM(COALESCE(ENDE.NUMDOC, CLI.NUMDOC) ),'') <> 1
                           THEN CASE WHEN CLI.FLGTIP = 0
                                     THEN MASKCPF(COALESCE(ENDE.NUMDOC, CLI.NUMDOC))
                                     ELSE MASKCNPJ(COALESCE(ENDE.NUMDOC,  CLI.NUMDOC))
                                END
                           ELSE CASE WHEN VIN.FLGTIP = 0
                                     THEN MASKCPF(VIN.NUMDOC)
                                     ELSE MASKCNPJ(VIN.NUMDOC)
                                END
                      END
                 ELSE ''
            END AS VARCHAR(18)) as NUMDOC,
       ENDE.CODFIL AS END_CODFIL,
       ENDE.NUMEND AS END_NUMEND,
       CAST(ENDE.ENDERE||' - '||ENDE.NUMERO AS VARCHAR(100)) AS ENDERECO,
       ENDE.ENDERE,
       ENDE.NUMERO,
       ENDE.BAIRRO,
       ENDE.NOMCID,
       ENDE.SIGEST,
       ENDE.COMPLE,
       ENDE.CODCEP,
       ENDE.CODLOG,
       COALESCE(ENDE.CODPAI,CLI.CODPAI) AS CODPAI,
       COALESCE(DPAI.DESPAI,DPAI_CLI.DESPAI) AS DESPAI,
       ENDE.CODCID,
       COALESCE(ENDE.CODIBG, MUN.CODIBG) AS CODIBG,
       CAST(LPAD(COALESCE(TRIM(ENDE.CODCEP), '0'),  5, '0')||LPAD(COALESCE(TRIM(ENDE.CODLOG), '0'),  3, '0') AS VARCHAR(8)) AS CEP,
       ENDE.CODDDD,
       ENDE.NUMFON,
       CAST(TO_CHAR(VEN.DATHOR,'DD/MM/YYYY') AS VARCHAR(10)) AS DT_DOC,
       TIT.DATVEN,
       TRUNC(AGORA()) AS DT_PROC,
       TIT.VLRPAR,
       COALESCE(TIT.JURMOR,0) AS JURMOR,
       COALESCE(PLA.VLTXMU, 0) AS MULTA,
       PLA.INTPMU AS TIPO_MULTA,
       COALESCE(TIT.JURDES,0) AS JURDES,
       CAST(0 AS FLOAT) AS OUTROS,
       CAST('Demonstrativo' AS CHAR(13)) AS DEMONSTRATIVO,
       -- RFMP 87135
       -- Codigo fonte do endereco do cedente se repete para os diversoes tipos de instrucao para nao ter que criar uma funcao para isso
      CAST(CASE WHEN TIT.CODPRT = 2
                THEN 'Protestar em '|| TIT.PRZPRT ||' dias teis aps vencimento <br>'||chr(13)||chr(10)||COALESCE(REM.DESINS1,'')||COALESCE(REM.DESINS2,'')
                     ||'<br><b>Endereo Cedente: </b>'||DFIL.ENDERE||','||DFIL.NUMERO||'-'||MFL.NOMCID||' '||DFIL.UFLOJA||' '||DFIL.CODCEP
                WHEN TIT.CODPRT = 1
                THEN 'Protestar em '|| TIT.PRZPRT ||' dias corridos aps vencimento <br>'||chr(13)||chr(10)||COALESCE(REM.DESINS1,'')||COALESCE(REM.DESINS2,'')
                     ||'<br><b>Endereo Cedente: </b>'||DFIL.ENDERE||','||DFIL.NUMERO||'-'||MFL.NOMCID||' '||DFIL.UFLOJA||' '||DFIL.CODCEP
                WHEN TIT.CODPRT IN (0, 3)
                THEN COALESCE(REM.DESINS1,'')||COALESCE(REM.DESINS2,'')
                     ||'<br><br><b>Endereo Cedente: </b>'||DFIL.ENDERE||','||DFIL.NUMERO||'-'||MFL.NOMCID||' '||DFIL.UFLOJA||' '||DFIL.CODCEP
                ELSE '<br><br><br><b>Endereo Cedente: </b>'||DFIL.ENDERE||','||DFIL.NUMERO||'-'||MFL.NOMCID||' '||DFIL.UFLOJA||' '||DFIL.CODCEP
           END AS VARCHAR(200)) AS INSTRUCAO,
       REM.DESINS1, REM.DESINS2,
       CTB.CODBCO,
       CTB.NUMAGE,
       CTB.CTACRR,
       CTB.NUMAGE_NOSNUM,
       TIT.CODFIL, TIT.FLGEST AS FLGTIT,
       REC.FLGEST AS FLGREC,
       REC.NUMPAR,
       REC.SUBPAR,
       CAST(COALESCE(CLI.ESTRAN,'F') AS VARCHAR(1)) AS ESTRAN,
       TIT.CODPRT,
       TIT.PRZPRT,
       TIT.CODMOR,
       CCB.CODCCB,
       CRB.APECRB,
       CAST(CASE WHEN TIT.CODPRT IN (2,0)
                  AND CTB.CODBCO <> '001'  THEN 'Opo para protesto em "Dias teis" e "Sem Instruo" no implementada para este banco e carteira, ser utilizado o padro "No protestar".'
                 WHEN CTB.CODBCO = '001'
                  AND TIT.PRZPRT <= 5
                  AND TIT.CODPRT <> 2 THEN 'O Banco do Brasil considera dias corridos somente a partir do 6 dia, ser utilizado "Protestar Dias teis".'
                 WHEN CTB.CODBCO = '001'
                  AND TIT.PRZPRT >= 6
                  AND TIT.CODPRT <> 1 THEN 'O Banco do Brasil considera dias teis somente at o 5 dia, ser utilizado "Protestar Dias Corridos".'
                 ELSE ''
            END AS VARCHAR(4000)) AS AVISO,
       CAST(LPAD(TO_CHAR(CFG.INT_INC_TIT),2,'0') AS VARCHAR(2)) AS INT_INC_TIT,
       CAST(LPAD(TO_CHAR(CFG.INT_ALT_DAT),2,'0') AS VARCHAR(2)) AS INT_ALT_DAT,
       TIT.ACEITE,
       TIT.PARREC,
       TIT.VLRABT,
       TIT.DATDES,
       TIT.DATMOR,
       ECB.SIGECB,
       CAST(CASE WHEN Equal(TRIM(CLI.NUMDOC),'') <> 1
                 THEN CASE WHEN CLI.FLGTIP = 0
                           THEN SPC.E_MAIL
                           ELSE CLI.E_MCON
                      END
                 ELSE CASE WHEN VIN.FLGTIP = 0
                           THEN SPCV.E_MAIL
                           ELSE VIN.E_MCON
                      END
            END AS VARCHAR(254)) AS E_MAIL,
       TIT.CODBAI,
       TIT.PRZBAI,
       (SELECT COUNT(*) FROM TT_TIT R WHERE R.FILREC = TIT.FILREC AND R.SEQREC = TIT.SEQREC AND R.FLGEST <> 'I' AND R.CODBCO = TIT.CODBCO) AS TOTPAR
  FROM TT_TIT TIT INNER JOIN TT_REC REC ON TIT.FILREC = REC.CODFIL AND TIT.SEQREC = REC.SEQUEN AND TIT.PARREC = REC.NUMPAR AND TIT.SUBREC = REC.SUBPAR
                  INNER JOIN TT_CTB CTB ON TIT.NUMAGE = CTB.NUMAGE AND TIT.CODBCO = CTB.CODBCO AND TIT.CTACRR = CTB.CTACRR
                  INNER JOIN TT_IXT IXT ON TIT.CODFIL = IXT.CODFIL AND TIT.SEQUEN = IXT.SEQTIT
                  INNER JOIN TT_CCB CCB ON IXT.CODCCB = CCB.CODCCB AND IXT.CCBBCO = CCB.CARBCO AND TIT.CODBCO = CCB.CODBCO
                  INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
                  INNER JOIN TT_PLA PLA ON PLA.FILPGT = VEN.FILPGT AND PLA.CODPGT = VEN.CODPGT
                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND CLI.CODCLI = VEN.CODCLI
                  INNER JOIN TD_FIL DFIL ON CTB.FILCTA = DFIL.CODFIL
                  INNER JOIN TT_END ENDE ON VEN.FILCLI = ENDE.FILCLI AND VEN.CODCLI = ENDE.CODCLI AND VEN.FILCOB = ENDE.CODFIL AND VEN.ENDCOB = ENDE.NUMEND
                  INNER JOIN (SELECT REM.*, INS1.DESINS AS DESINS1, INS2.DESINS AS DESINS2
                                FROM TT_REM REM INNER JOIN TT_CFG CFG  ON REM.CODREM = CFG.INT_INC_TIT
                                                 LEFT JOIN TD_INS INS1 ON REM.INSTR1 = INS1.CODTAB
                                                 LEFT JOIN TD_INS INS2 ON REM.INSTR2 = INS2.CODTAB
                             ) REM ON REM.CODBCO = TIT.CODBCO
                   LEFT JOIN TT_CLI VIN ON VIN.FILCLI = CLI.FILVIN
                                       AND VIN.CODCLI = CLI.CODVIN
                   LEFT JOIN TT_MUN MFL ON MFL.CODIGO = DFIL.CODCID
                   LEFT JOIN TT_CRB CRB ON CCB.CODCRB = CRB.CODTAB
                   LEFT JOIN TD_PAI DPAI ON DPAI.CODPAI = ENDE.CODPAI
                   LEFT JOIN TD_PAI DPAI_CLI ON DPAI_CLI.CODPAI = CLI.CODPAI
                   LEFT JOIN TT_MUN MUN ON MUN.CODIGO = ENDE.CODCID
                   LEFT JOIN TT_ECB ECB ON ECB.CODBCO = TIT.CODBCO
                                       AND ECB.CODECB = TIT.CODECB
                   LEFT JOIN TT_SPC SPC ON SPC.FILCLI = CLI.FILCLI
                                       AND SPC.CODCLI = CLI.CODCLI
                   LEFT JOIN TT_SPC SPCV ON SPCV.FILCLI = VIN.FILCLI
                                        AND SPCV.CODCLI = VIN.CODCLI
                   CROSS JOIN TT_CFG CFG
  WHERE VEN.FILCOB IS NOT NULL
    AND VEN.ENDCOB IS NOT NULL
    AND IXT.DATENV IS NULL
    AND TIT.FLGEST <> 'I'
;


/*-- SEQ 3128 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_LOG CASCADE;

/*-- SEQ 3129 --*/
CREATE OR REPLACE VIEW TV_LOG AS
select apeusu, filusu, codusu
from tt_usu
where apeusu=GetApeUsuAtual()
;


/*-- SEQ 3130 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PXC CASCADE;

/*-- SEQ 3131 --*/
CREATE OR REPLACE VIEW TV_PXC AS
SELECT ICO.FILMAT, ICO.CODMAT, ICO.CODCOR, ICO.CODTAM, PRE.FILPRE, PRE.SEQUEN,
       COALESCE(PRE.PRECOV,0) AS PRECOV, 
       PRECO_ANTERIOR(ICO.FILMAT, ICO.CODMAT, ICO.CODCOR, ICO.CODTAM, ICO.COM_DATOPE, PRE.FILPRE, PRE.CODPRE) AS PREANT,
       ICO.CODFIL AS FILICO,
       ICO.SEQUEN AS SEQICO,
       ICO.NUMITE AS NUMICO
  FROM TT_ICO ICO INNER JOIN TT_PRE PRE ON PRE.FILMAT = ICO.FILMAT AND PRE.CODMAT = ICO.CODMAT
                                       AND PRE.CODCOR = ICO.CODCOR AND PRE.CODTAM = ICO.CODTAM
;


/*-- SEQ 3132 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_RECXPRO CASCADE;

/*-- SEQ 3133 --*/
CREATE OR REPLACE VIEW TV_RECXPRO AS
SELECT IVE.CODFIL,IVE.SEQUEN,IVE.NUMITE,REC.NUMPAR,REC.SUBPAR,
       REC.FLGEST,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,
       IVE.CODMUL,
       CASE WHEN (REC.CARTAO IS NULL AND REC.SEQCHE IS NULL) THEN REC.PAGAME
            WHEN (REC.CARTAO IS NULL AND REC.SEQCHE IS NOT NULL) THEN CHR.PAGAME
            ELSE REC.DATVEN END AS PAGAME,
       ROUND((IVE.VLRMOV/VEN.VLRNOT)*REC.VLRPAR,4) AS VLRPAR_PRO, -- Valor de parcela ratedo por item de venda
       ROUND((IVE.VLRMOV/VEN.VLRNOT)*REC.VLRPGT,4) AS VLRPGT_PRO, -- Valor de recebimento ratedo por item de venda
       ROUND((IVE.VLRMOV/VEN.VLRNOT)*REC.vlrdes,4) AS VLRDES_PRO, -- Valor de desconto no recebimento ratedo por item de venda --03/11/2014 GABRIELR
       ROUND( CASE WHEN REC.FLGEST NOT IN ('C','X') THEN
                       ( CASE WHEN (REC.SUBPAR = ' 0') THEN REC.VLRPAR
                              ELSE (SELECT RECORI.VLRPAR
                                      FROM TT_REC RECORI
                                     WHERE RECORI.CODFIL = VEN.CODFIL
                                       AND RECORI.SEQUEN = VEN.SEQUEN
                                       AND RECORI.NUMPAR = REC.NUMPAR
                                       AND RECORI.SUBPAR = ' 0') END / (VEN.VLRLIQ - COALESCE(VEN.VLRCOF,0) - COALESCE(VEN.FUNRUR,0) - COALESCE(VEN.SENAR,0) - COALESCE(VEN.SEGRUR, 0) + COALESCE(VEN.VLRSAD,0)) ) * IVE.VLRFRE
                   ELSE 0 END ,4) AS VLRFRE_PRO, -- Valor do Frete ratedo por item de venda
       ROUND( CASE WHEN REC.FLGEST NOT IN ('C','X') THEN
                        ( CASE WHEN (REC.SUBPAR = ' 0') THEN REC.VLRPAR
                               ELSE (SELECT RECORI.VLRPAR
                                       FROM TT_REC RECORI
                                      WHERE RECORI.CODFIL = VEN.CODFIL
                                        AND RECORI.SEQUEN = VEN.SEQUEN
                                        AND RECORI.NUMPAR = REC.NUMPAR
                                        AND RECORI.SUBPAR = ' 0') END / (VEN.VLRLIQ - COALESCE(VEN.VLRCOF,0) - COALESCE(VEN.FUNRUR,0) - COALESCE(VEN.SENAR,0) - COALESCE(VEN.SEGRUR, 0) + COALESCE(VEN.VLRSAD,0)) ) * IVE.DESRAT
                   ELSE 0 END ,4) AS DESRAT_PRO  -- Valor do Acres./Desc. ratedo por item de venda
  FROM TT_VEN VEN INNER JOIN TT_IVE IVE ON VEN.CODFIL = IVE.CODFIL
                                       AND VEN.SEQUEN = IVE.SEQUEN
                  INNER JOIN TT_REC REC ON REC.CODFIL = VEN.CODFIL
                                       AND REC.SEQUEN = VEN.SEQUEN
                   LEFT JOIN TT_CHR CHR ON CHR.CODFIL = REC.FILREC
                                       AND CHR.SEQUEN = REC.SEQCHE
 ;


/*-- SEQ 3134 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_SAV CASCADE;

/*-- SEQ 3135 --*/
CREATE OR REPLACE VIEW TV_SAV AS
SELECT DISTINCT TAB.*
  FROM (SELECT SAV.*, VEN.CODFIL AS VEN_CODFIL, VEN.SEQUEN AS VEN_SEQUEN
          FROM TT_SAV SAV INNER JOIN TT_VEN VEN ON VEN.CODFIL = SAV.FILVEN
			         	                       AND VEN.SEQUEN = SAV.SEQVEN
         UNION ALL
        SELECT SAV.*, VEN.CODFIL AS VEN_CODFIL, VEN.SEQUEN AS VEN_SEQUEN
     	  FROM TT_SAV SAV INNER JOIN TT_IOR IOR ON IOR.CODFIL = SAV.FILPED
											   AND IOR.TIPPED = SAV.TIPPED
											   AND IOR.NUMPED = SAV.NUMPED						  
			              INNER JOIN TT_VEN VEN ON VEN.CODFIL = IOR.FILIVE
											   AND VEN.SEQUEN = IOR.SEQIVE											   
        ) TAB
;




/*-- SEQ 3136 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_PRO_OUT CASCADE;

/*-- SEQ 3137 --*/
CREATE OR REPLACE VIEW TV_PRO_OUT AS
SELECT CAST(RPAD( COALESCE(IPR.FILMAT ,'')|| COALESCE(IPR.CODMAT ,'')|| '-' || COALESCE(TO_CHAR(IPR.CODCOR),'')|| '-' || COALESCE(TO_CHAR(IPR.CODTAM),''), 21,' ' ) AS VARCHAR(21)) AS CHAVEPRO,
      IPR.FILMAT,
      IPR.CODMAT,
      IPR.CODCOR,
      IPR.CODTAM,
      IPR.PTOQTD,
      IPR.MEDUNI AS UNIDAD,
      IPR.UNIDAD AS UNIVEN,
      IPR.UNIFOR AS UNICOM,
      IPR.PERCOM,
      IPR.DESMAT,
      IPR.REFBAS,
      IPR.ESPMAT,
      IPR.MINQTD,
      IPR.DECIMA,
      IPR.VALCON,
      IPR.QTDMUL,
      CASE WHEN PCS.VALORTRANSFERENCIA IN ('C','G','M','V') THEN TRUNC(ValoresProduto(PCS.VALORTRANSFERENCIA, IPR.FILMAT, IPR.CODMAT, IPR.CODCOR, IPR.CODTAM, NULL, IPR.CUSREP),4)
           WHEN CFG.VALORTRANSFERENCIA = 'R' THEN IPR.CUSREP
           ELSE TRUNC(ValoresProduto(CFG.VALORTRANSFERENCIA, IPR.FILMAT, IPR.CODMAT, IPR.CODCOR, IPR.CODTAM, NULL, IPR.CUSREP),4)
      END AS CUSREP,
      IPR.PRECOM,
      CASE COALESCE(PRE.DESMAX,0) WHEN 0 THEN IPR.DESMAX ELSE PRE.DESMAX END as DESMAX,      
      CAST(Rtf2txt(SUBSTR(COALESCE(IPR.OBSERV,'')||COALESCE((SELECT AGREGATXT(ITE.DESMAT) FROM TT_KIT KIT INNER JOIN TT_PRO ITE ON KIT.FILITE = ITE.FILMAT AND KIT.CODITE = ITE.CODMAT WHERE KIT.FILMAT = PRD.FILMAT AND KIT.CODMAT = PRD.CODMAT AND KIT.FLGIMP = 'T'),''),1,4000)) AS VARCHAR(4000)) AS OBSERV,
      IPR.PERLUC,
      IPR.NUMEXT,
      IPR.BRINDE,
      IPR.REFPRO,
      IPR.ITEDIV,
      IPR.ITESUB,
      IPR.DESECF,
      TRI.CODTRI,
      COALESCE(PRE.PRECOV,0) AS PRECOV,
      PRE.CODMOE,
      IPR.CLASS1,
      IPR.CLASS2,
      IPR.CLASS3,
      IPR.CLASS4,
      IPI.RESIPI AS PERIPI,
      COALESCE(IRR.RESIRR,0) AS PERIRR,
      IPR.TIPPRO AS SERMAT,
      IPR.SEQUEN AS SEQUEN,
      PRE.FLGEST,
      COALESCE(IPR.NOMIMG,DEP.IMGDEP) AS IMAGEM,
      IPR.RETCOF,
      CAST(IPR.FILMAR||IPR.CODMAR AS VARCHAR(9)) AS CHAVEMAR,
      MAR.DESMAR,
      PRD.CODGRA,
      IPR.ORDDIV,
      IPR.ORDSUB,
      PRD.BALSIM,
      PRD.CONTRO,
      IPR.TIPDOC,
      PRD.ICMFED,
      PRD.ARRTRU,
      PRD.IIPTPR,
      CAST(TO_CHAR(PRD.CODLPC) AS VARCHAR(5)) AS CODLPC,
      CAST(TO_CHAR(IPR.ATU_EM,'DD/MM/YYYY HH24:MI:SS') AS VARCHAR(21)) AS ATU_EM,
      IPR.IMPKIT,
      IPR.CODANP,
      CAST(CASE WHEN COALESCE(NCM.FLGATI,'F') = 'T' THEN IPR.CODNCM ELSE NULL END AS VARCHAR(8)) AS CODNCM,
      CAST(CASE WHEN COALESCE(NCM.FLGATI,'F') = 'T' THEN NCM.QTDLIM_PJ ELSE NULL END AS DECIMAL(16,4))AS QTDLIM_PJ,
      CAST(CASE WHEN COALESCE(NCM.FLGATI,'F') = 'T' THEN NCM.QTDLIM_PF ELSE NULL END AS DECIMAL(16,4))AS QTDLIM_PF,   
      IPR.SITCOF,
      IPR.SITPIS,
      IPR.COD_EX,
      IPR.SITIPI,
      PRD.CODSRV,
      PRD.CODFPS,
      IPR.CODSAL,
      IPR.FATCON,
      IPR.ORIPRO,
      IPR.PREFIS,
      CASE WHEN PRD.ORIPRO = '4' AND PRD.TIPMPB in ('T','R','S') THEN PRD.TIPMPB
           WHEN PRD.ORIPRO = '4' THEN 'P'
           ELSE NULL
      END AS TIPMPB,
      IPR.PESBRU,IPR.PESLIQ,
      ROUND(ICO.BASSUBDIF/NVLZ(ICO.QTDMOV,1),4) AS BASSUB,
      ROUND(ICO.VLR_STDIF/NVLZ(ICO.QTDMOV,1),4) AS VLR_ST,
      COALESCE(round(ICO.BASIPI/NVLZ(ICO.QTDMOV,1),4), 0) AS BASIPI,
      COALESCE(round(ICO.VLRIPI/NVLZ(ICO.QTDMOV,1),4), 0) AS VLRIPI,
      COALESCE(round((ICO.ICO_VLRFRE + ICO.IPIFRE)/NVLZ(ICO.QTDMOV,1),4), 0) AS VLRFRE,
      ICO.CODFCI,
      IPR.VLRPIS,
      IPR.VLRCOF,
      IPR.VENPIS,
      IPR.VENCOF,
      IPR.OBSMPB,
      CASE WHEN RGC.RGCATI = 'T' THEN RGC.FLGDEV
           ELSE CAST('T' AS VARCHAR(1))
      END AS FLGDEV,
      IPR.DESFRE,
      IPR.SUBFRE,
      IPR.USALOT,
      IPR.PERIND,
      IPR.CODFIS,
      IPR.CONFER,
      IPR.CODCES, IPR.CODENQ,
      IPR.FOR060,
      IPR.LOTONL,
      ROUND(CASE WHEN COALESCE(ICO.BASFCP_ST,0)  > 0 THEN COALESCE(ICO.BASFCP_ST,0)
                 WHEN COALESCE(ICO.BASFCP_RET,0) > 0 THEN COALESCE(ICO.BASFCP_RET,0)
                 ELSE 0
             END / NVLZ(ICO.QTDMOV,1),4) AS BASFCP,
      CASE WHEN COALESCE(ICO.PERFCP_ST,0)  > 0 THEN COALESCE(ICO.PERFCP_ST,0)
           WHEN COALESCE(ICO.PERFCP_RET,0) > 0 THEN COALESCE(ICO.PERFCP_RET,0)
           ELSE 0
       END AS PERFCP,
      ROUND(CASE WHEN COALESCE(ICO.VLRFCP_ST,0)  > 0 THEN COALESCE(ICO.VLRFCP_ST,0)
                 WHEN COALESCE(ICO.VLRFCP_RET,0) > 0 THEN COALESCE(ICO.VLRFCP_RET,0)
                 ELSE 0
             END / NVLZ(ICO.QTDMOV,1),4) AS VLRFCP,
       IPR.SIGNAT,
       PRE.DESIDE AS PRE_DESIDE,
       ROUND(ICO.VLRICMDIF/NVLZ(ICO.QTDMOV,1),4) AS VLRICM,
       IPR.DESGRA,
       IPR.PROCON
  FROM TV_IPR_FAST IPR
 CROSS JOIN TT_CFG CFG
  LEFT JOIN TD_DEP DEP ON DEP.CODTAB = IPR.DEPART
  LEFT JOIN TD_TRI TRI ON TRI.CODTAB = IPR.CODTRI
  LEFT JOIN TD_IPI IPI ON IPI.CODTAB = IPR.RESIPI
  LEFT JOIN TD_IRR IRR ON IRR.CODTAB = IPR.RESIRR
  LEFT JOIN TT_PRE PRE ON PRE.FILMAT = IPR.FILMAT AND PRE.CODMAT = IPR.CODMAT AND PRE.CODCOR = IPR.CODCOR AND PRE.CODTAM = IPR.CODTAM AND PRE.FILPRE = CFG.FILPRE AND PRE.CODPRE = CFG.CODPRE
  LEFT JOIN TT_MAR MAR ON MAR.FILMAR = IPR.FILMAR AND MAR.CODMAR = IPR.CODMAR AND MAR.ITEMAR = IPR.ITEMAR
  LEFT JOIN TT_PRO PRD ON PRD.FILMAT = IPR.FILMAT AND PRD.CODMAT = IPR.CODMAT
  LEFT JOIN TT_ICO ICO ON IPR.FILCOM = ICO.CODFIL AND IPR.SEQCOM = ICO.SEQUEN AND IPR.ITECOM = ICO.NUMITE
  LEFT JOIN TD_RGC RGC ON RGC.CODTAB = IPR.CODRGC
  LEFT JOIN TT_NCM NCM ON NCM.CODNCM = IPR.CODNCM
  CROSS JOIN (SELECT LeParametroTxt('VALOR_TRANSF_CARGA', NULL, NULL, NULL, NULL) AS VALORTRANSFERENCIA FROM DUAL) PCS
;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Centro Custo Movimento Contabilidade" (Tabela Integrao Mult)
/*-- SEQ 3138 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_CCUSTOMOVCTB CASCADE;

/*-- SEQ 3139 --*/
CREATE OR REPLACE VIEW TV_TIMU_CCUSTOMOVCTB AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.NUMPAR, TAB.SUBPAR, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.CHAVE,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.DataLancamento, -- Data do Lanamento
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.ContaDebito, -- Cdigo da Conta Dbito
      TAB.ContaCredito, -- Cdigo da Conta Crdito
      TAB.CodigoCentroCusto, --Cdigo do Centro de Custo
      TAB.Valor --Valor do centro de custo
  FROM (-- Centro de Custo Notas Recebidas
        SELECT ERFIN.CODFIL, ERFIN.SEQUEN, ERFIN.NUMPAR, ERFIN.SUBPAR, CAST(ERFIN.ORIGEM AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_CCUSTOMOVCTB' AS VARCHAR(50)) AS DESTINO, COALESCE(ERFIN.DATINCORI, ERFIN.DATOPE) AS DATINC, ERFIN.ATU_EM, CAST('F' AS VARCHAR(1)) AS EXPORT,
               CAST(CASE WHEN ERFIN.ORIGEM IN ('VEN', 'REC') THEN 'VEN'
                         WHEN ERFIN.ORIGEM IN ('COM', 'FAT', 'FRE', 'TIT', 'PAG') THEN 'COM'
                         ELSE ERFIN.ORIGEM
                    END || ERFIN.CODFIL || ERFIN.SEQUEN AS VARCHAR(50)) AS CHAVE,
               COALESCE(ERFIN.DATINCORI, ERFIN.DATOPE) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               ERFIN.EXPORTADO_EME4 AS EXPEM4,
               CAST(CASE WHEN ERFIN.ORIGEM IN ('VEN', 'REC') THEN (SELECT -- Definido juntamente com a EME4 quando for cupom fiscal enviar tipo de operao fixo
                                                                          CASE WHEN (VEN.CODSER = 'CF') THEN 998
                                                                               WHEN (VEN.MODNOT = '65') THEN 997
                                                                               WHEN (VEN.MODNOT = '59') THEN 996
                                                                               WHEN (VEN.UFLOJA = 'T') THEN                                                                                                             TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTDEM, '[^0-9]', '', 'gi'), ''))                                                                               ELSE                                                                                     TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTFOR, '[^0-9]', '', 'gi'), ''))                                                                          END AS Tipo
                                                                    FROM TT_VEN VEN
                                                                    -- Natureza
                                                                    LEFT JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
                                                                   WHERE VEN.CODFIL = ERFIN.CODFIL AND VEN.SEQUEN = ERFIN.SEQUEN )
                         WHEN ERFIN.ORIGEM IN ('COM', 'FAT', 'FRE', 'TIT', 'PAG') THEN (SELECT                                                                           TO_NUMBER(NULLIF(regexp_replace(DCFO.EXTCFO, '[^0-9]', '', 'gi'), '')) AS Tipo
                                                                     FROM TT_COM COM
                                                                     -- Natureza
                                                                     LEFT JOIN TD_CFO DCFO ON DCFO.CODTAB = COM.CODCFO
                                                                    WHERE COM.CODFIL = ERFIN.CODFIL AND COM.SEQUEN = ERFIN.SEQUEN )
                         ELSE LeParametroNum('TP_OP_EXP_EME4_'||ERFIN.ORIGEM, ERFIN.CODFIL, '', '', '') 
                    END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST(TO_NUMBER(ERFIN.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = ERFIN.FILCLI AND REL.CODPAR = ERFIN.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                         ELSE 'C' 
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST(TO_CHAR(TO_NUMBER(TRIM(CASE WHEN (ISNOTNULL(ERFIN.EXPORTACAO_EME4)='T') AND (INSTR(ERFIN.EXPORTACAO_EME4, '#') = 0) THEN ERFIN.EXPORTACAO_EME4 ELSE ERFIN.SEQUEN END))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST(CASE WHEN ERFIN.ORIGEM IN ('VEN', 'REC') THEN '1'
                         WHEN ERFIN.ORIGEM IN ('COM', 'FAT', 'FRE', 'TIT', 'PAG') THEN '2'
                         ELSE NULL
                    END AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST(CASE WHEN ERFIN.ORIGEM IN ('VEN', 'REC') THEN (SELECT TRIM(CASE WHEN VEN.CODSER='CF' THEN VEN.CODSER
                                                                                    WHEN ( (VEN.MODNOT = '65' OR VEN.MODNOT = '59') AND VEN.NUMECF >= '400' ) THEN VEN.NUMECF
                                                                                    WHEN VEN.CODSER<>'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN DSER.SEREXT
                                                                                    ELSE NULL
                                                                               END) AS CODSER
                                                                    FROM TT_VEN VEN
                                                                    -- Srie de Emisso
                                                                    JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
                                                                   WHERE VEN.CODFIL = ERFIN.CODFIL AND VEN.SEQUEN = ERFIN.SEQUEN )
                         WHEN ERFIN.ORIGEM IN ('COM', 'FAT', 'FRE', 'TIT', 'PAG') THEN (SELECT CASE WHEN ISNOTNULL(FIS.SEREXP)='T' THEN LPAD(TRIM(FIS.SEREXP), 3, '0')||CASE WHEN COM.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(FIS.SUBEXP),'0'), 2, '0') END
                                                                               ELSE LPAD(TRIM(COM.CODSER), 2, '0')||CASE WHEN COM.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(COM.SUBSER),'0'), 3, '0') END
                                                                          END AS CODSER
                                                                     FROM TT_COM COM
                                                                     -- Srie de Emisso
                                                                     LEFT JOIN (SELECT DISTINCT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT, ORIGEM
                                                                                  FROM TT_FIS
                                                                                 WHERE ORIGEM IN ('C','F')) FIS ON FIS.CODSER = COM.CODSER AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$') AND FIS.ORIGEM = CASE WHEN COALESCE(COM.TIPPAR,'F') = 'T' THEN 'F' ELSE 'C' END
                                                                    WHERE COM.CODFIL = ERFIN.CODFIL AND COM.SEQUEN = ERFIN.SEQUEN )
                         ELSE NULL
                    END AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(ERFIN.DATOPE AS Timestamp) AS DataLancamento, -- Data do Lanamento
               -- Definido juntamente com a EME4 quando o cdigo da conta financeira no possuir um "-" devemos exportar para uma Conta fixa para posterior reviso
               CAST(TRIM(CASE WHEN INSTR(ERFIN.DEBITO, '-') > 0 THEN SUBSTR(ERFIN.DEBITO,1,20) ELSE '99999-1' END) AS VARCHAR(20)) AS ContaDebito, -- Cdigo da Conta Dbito
               CAST(TRIM(CASE WHEN INSTR(ERFIN.CREDITO, '-') > 0 THEN SUBSTR(ERFIN.CREDITO,1,20) ELSE '99999-2' END) AS VARCHAR(20)) AS ContaCredito, -- Cdigo da Conta Crdito
               CAST(TRIM(SUBSTR(COALESCE(DCUS.EXTCUS, DCUS.CENCUS),1,15)) AS VARCHAR(15)) AS CodigoCentroCusto, -- Cdigo do Centro de Custo
               CAST(ABS(ERFIN.VLRMOV) AS Numeric(15,2)) AS Valor -- Valor do centro de custo
          FROM TV_ERFIN ERFIN 
          -- Cliente
          LEFT JOIN TT_CLI PAR ON PAR.FILCLI = ERFIN.FILCLI AND PAR.CODCLI = ERFIN.CODCLI
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = ERFIN.FILCLI AND ENDFAT.CODCLI = ERFIN.CODCLI AND ENDFAT.CODFIL = SUBSTR(ERFIN.CHAVE_ENDFAT, 1, 3) AND ENDFAT.NUMEND = TO_NUMBER(SUBSTR(ERFIN.CHAVE_ENDFAT, 4, LENGTH(ERFIN.CHAVE_ENDFAT)))
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          -- Centro de Custo
          JOIN TT_CUS CUS ON CUS.CODFIL = ERFIN.CODFIL AND CUS.SEQUEN = ERFIN.SEQUEN
          JOIN TD_CUS DCUS ON DCUS.CODTAB = CUS.CODCUS
          WHERE ERFIN.ORIGEM = 'COM'
            AND ERFIN.TIPLAN IN ('COM', 'FAT', 'FRE', 'TIT')
            AND ERFIN.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',ERFIN.CODFIL,'','','') 
            AND (LeParametroTXT('TIPO_EXP_EME4', ERFIN.CODFIL, '', '', '') = 'C')
            AND ERFIN.EXPORTACAO_EME4 NOT LIKE '%#%'
            AND ERFIN.EXPORTADO_EME4 = 'F'
       ) TAB
;


-- Autor: Bruno B.
-- Cliente(s): EME4
-- Finalidade(s):
-- 1)Retornar os lanamentos contbeis.
-- Arquivo Pai: TIMU_DOCUMENTO
/*-- SEQ 3140 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_LANC_CONTABEIS CASCADE;

/*-- SEQ 3141 --*/
CREATE OR REPLACE VIEW TV_TIMU_LANC_CONTABEIS AS
   SELECT
         --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
         CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
         CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
         CAST('T' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
         --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
         CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
         --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
         TAB.CODFIL, TAB.SEQUEN, TAB.NUMPAR, TAB.SUBPAR, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.EXPEM4, TAB.NUMDOC, TAB.DATAFILTRO, 
         TAB.CODSER, TAB.SUBSER, TAB.NUMECF, TAB.NUMNOT, TAB.NUMPED, TAB.TIPPED,
         TAB.TEM_ITEM, TAB.TEM_PARCELA, TAB.TEM_LIQUIDACAO, TAB.TEM_MOVCONTABIL, TAB.TEM_CCUSTOCONTABIL, TAB.TEM_FRETE, TAB.TEM_OPERACAOFINANCEIRA, TAB.TEM_CONTAFINANCEIRA, TAB.TEM_CCUSTOFINANCEIRO, TAB.CHAVE, TAB.VLRNOT_VALIDACAO, TAB.VLRLIQ_VALIDACAO,
         TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
         TAB.TipoOperacao, -- Cdigo do Tipo de Operao
         TAB.Filial, -- Cdigo da Filial
         TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
         TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
         TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
         TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
         TAB.Serie, -- Srie do Documento
         TAB.NumeroDocumento, -- Nmero do documento
         TAB.DataEntrada, -- Data de Entrada
         TAB.DataSaida, -- Data de Sada
         TAB.DataEntSai, -- Data de Entrada ou Sada
         TAB.DataEmissao, -- Data de Emisso
         TAB.ValorContabil, -- Valor Contbil Original do Documento (Tesouraria)
         TAB.ValorDescontos, -- Valor Desconto dos Produtos
         TAB.ValorOutrasDespesas, -- Valor Outras Despesas dos Produtos
         TAB.ValorDescontosServ, -- Valor Desconto dos Servios
         TAB.ValorOutrasDespesasServ, -- Valor Outras Despesas dos Servios
         TAB.SituacaoNFE, -- {3=Autorizada;5=Cancelada;7=Inutilizada;8=Substituida;9=Denegada;A=Contingncia}
         TAB.SituacaoDOC, -- {0=Normal;1=Cancelada;2=Devoluo Parcial;3=Devoluo Total;4=Crdito Bloqueado;5=Inadimplncia;6=Cred. Bloq/Inad.;7=Bloqueio nos Itens;8=Faturado;A=Bloq. Val. Parcela;B=Bloq. Val. Min. Venda}
         TAB.ObsFiscal, -- Observao Fiscal do Documento
         TAB.Observacoes, -- Observaes da Nota
         TAB.InfoComplementares, -- Informaes Complementares da Nota
         TAB.TextoFiscal, -- Texto Fiscal do Documento
         TAB.NumPedCliente, -- Nmero do Pedido no Cliente
         TAB.NumPedRepresentante, -- Nmero do Pedido no Representante
         TAB.IndNaturezaFrete, -- {0=Operaes de vendas, com nus suportado pelo estabelecimento vendedor;1=Operaes de vendas, com nus suportado pelo adquirente;2=Operaes de compras (bens para revenda, matrias prima e outros produtos, geradores de crdito);3=Operaes de compras (bens para revenda, matrias prima e outros produtos, no geradores de crdito);4=Transferncia de produtos acabados entre estabelecimentos da pessoa jurdica;5=Transferncia de produtos entre estabelecimentos da pessoa jurdica;9=Outras}
         TAB.ChaveNFE, -- Chave NFE
         TAB.ChaveNFERefer, -- Chave NFE Referenciada
         TAB.CodContaTes, -- Cdigo da Conta Tesouraria
         TAB.Justificativa, -- Justificativa do documento Contbil
         TAB.TipoFrete, -- {F=Por conta do emitente;T=Por conta do destinatrio;A=Por conta de terceiros;B=Sem frete}
         TAB.CodTransportadora, -- Cdigo da Transportadora do Documento
         TAB.CpfCnpjTransportadora, -- CPF ou CNPJ da Transportadora do Documento
         TAB.PlacaVeiculo, -- Placa do Veculo de Entrega
         TAB.CodTranspRedespacho, -- Cdigo da Transportadora de Redespacho do Documento
         TAB.CpfCnpjTranspRedespacho, -- CPF ou CNPJ da Transportadora de Redespacho do Documento
         TAB.CodigoModelo, -- Cdigo do Modelo de Documento (01 ou 65)
         TAB.LogradouroEnt, -- Logradouro do Endereo de Entrega
         TAB.NumeroEnt, -- Nmero do Endereo de Entrega
         TAB.ComplementoEnt, -- Complemento do Endereo de Entrega
         TAB.CEPEnt, -- CEP do Endereo de Entrega
         TAB.CodMunicipioIBGEEnt, -- GeoCodigo do M3 - caso esteja informado dever importar o vnculo do municpio por este cdigo (Endereo)
         TAB.CidadeEndEnt, -- Cidade do Endereo de Entrega
         TAB.BairroEnt, -- Bairro do Endereo de Entrega
         TAB.EstadoEnt, -- Estado do Endereo de Entrega
         TAB.CodigoPaisEnt, -- Codigo do Banco Central para o Pais da Cidade de Entrega
         TAB.PaisEnt, -- Nome do Pais do Endereo de Entrega
         TAB.ValorFrete, -- Valor do Frete
         TAB.ValorFreteTerceiros, -- Valor do Frete Terceiros
         TAB.ICMSFreteTerceiros, -- Valor ICMS do Frete Terceiros
         TAB.DifaFreteTerceiros, -- Valor DIFA do Frete Terceiros
         TAB.ValorSeguro, -- Valor do Seguro
         TAB.ValorAcrescimos, -- Valor Acrescimos
         TAB.ValorTHC, -- Valor THC
         TAB.ValorAFRMM, -- Valor AFRMM
         TAB.ValorDemurrage, -- Valor Demurrage
         TAB.ValorDesestiva, -- Valro Desestiva
         TAB.ValorDesembaraco, -- Valor Desembarao
         TAB.ValorSiscomex, -- Valor Siscomex
         TAB.ValorPISImport, -- Valro PIS Importao
         TAB.ValorCofinsImport, -- Valro Cofins Importao
         TAB.ValorDespAduaneira, -- Valor Despesa Aduaneira
         TAB.SimboloMoeda, -- Smbolo da Moeda
         TAB.ValorCotacaoMoeda, -- Valor Cotao Moeda
         TAB.DataCotacaoMoeda, -- Data Cotao Moeda
         TAB.CPFCNPJRepresentante, -- CPF ou CNPJ do Representante
         TAB.COO, -- COO Cupom
         TAB.NroECF, -- Nmero do ECF
         TAB.NroSerieECF, -- Nmero de rie do ECF
         TAB.ModeloECF, -- Modelo do ECF
         TAB.MarcaECF, -- Marca do ECF
         TAB.CPFCNPJCupom -- CPF ou CNPJ do cliente no identificado no cupom
     FROM (
   SELECT ERFIN.CODFIL, 
          ERFIN.SEQUEN, 
          CAST(NULL AS CHAR(8)) AS NUMPED,
          CAST(NULL AS CHAR(1)) AS TIPPED,
          CAST(NULL AS CHAR(2)) AS NUMPAR,
          CAST(NULL AS CHAR(2)) AS SUBPAR,
          CAST(NULL AS VARCHAR(3)) AS CODSER, CAST(NULL AS VARCHAR(3)) AS SUBSER, CAST(NULL AS CHAR(3)) AS NUMECF, CAST(NULL AS VARCHAR(10)) AS NUMNOT,
          CAST(ERFIN.ORIGEM AS VARCHAR(3)) AS ORIGEM, 
          CAST('TIMU_DOCUMENTO' AS VARCHAR(50)) AS DESTINO,
          CAST('F' AS CHAR(1)) AS TEM_ITEM,
          CAST('F' AS CHAR(1)) AS TEM_PARCELA,
          CAST('F' AS CHAR(1)) AS TEM_LIQUIDACAO,
          CAST('T' AS CHAR(1)) AS TEM_MOVCONTABIL,
          CAST('F' AS CHAR(1)) AS TEM_CCUSTOCONTABIL,
          CAST('F' AS CHAR(1)) AS TEM_FRETE,
          CAST('F' AS CHAR(1)) AS TEM_OPERACAOFINANCEIRA,
          CAST('F' AS CHAR(1)) AS TEM_CONTAFINANCEIRA,
          CAST('F' AS CHAR(1)) AS TEM_CCUSTOFINANCEIRO,
          CAST(ERFIN.ORIGEM || ERFIN.CODFIL || ERFIN.SEQUEN AS VARCHAR(50)) AS CHAVE,
          ABS(ERFIN.VLRMOV) AS VLRNOT_VALIDACAO, ABS(ERFIN.VLRMOV) AS VLRLIQ_VALIDACAO,
          COALESCE(ERFIN.DATINCORI, ERFIN.DATOPE) AS DATINC, 
          ERFIN.ATU_EM, 
          CAST('F' AS VARCHAR(1)) AS EXPORT,
          ERFIN.EXPORTADO_EME4 AS EXPEM4,
          ERFIN.DATOPE AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
          COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC) AS NUMDOC,
          COALESCE(ERFIN.DATINCORI, ERFIN.DATOPE) AS DATAFILTRO,
          CAST(ERFIN.TipoOperacao AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
          CAST(TO_NUMBER(ERFIN.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
          CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                     ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                          THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                    ELSE SUBSTR(TO_CHAR(CAST(                                                                             NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                               END
                                          ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                    ELSE SUBSTR(TO_CHAR(CAST(                                                                             NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                               END
                                     END)
                 END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
          CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
          CAST(CASE WHEN EXISTS(SELECT 1 AS OK 
                                      FROM TT_REL REL 
                                     WHERE REL.FILPAR = ERFIN.FILCLI 
                                       AND REL.CODPAR = ERFIN.CODCLI 
                                       AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                   ELSE 'C' 
                   END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
          CAST(NULL AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
          CAST(NULL AS VARCHAR(5)) AS Serie, -- Srie do Documento
          CAST(TO_CHAR(TO_NUMBER(TRIM(CASE WHEN (ISNOTNULL(ERFIN.EXPORTACAO_EME4)='T') AND (INSTR(ERFIN.EXPORTACAO_EME4, '#') = 0) THEN ERFIN.EXPORTACAO_EME4 ELSE ERFIN.SEQUEN END))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
          CAST(TRUNC(ERFIN.DATOPE) AS Timestamp) AS DataEntrada, -- Data de Entrada
          CAST(TRUNC(ERFIN.DATOPE) AS Timestamp) AS DataSaida, -- Data de Sada
          CAST(TRUNC(ERFIN.DATOPE) AS Timestamp) AS DataEntSai, -- Data de Entrada ou Sada
          CAST(TRUNC(ERFIN.DATOPE) AS Timestamp) AS DataEmissao, -- Data de Emisso
          CAST(ABS(ERFIN.VLRMOV) AS Numeric(15,2)) AS ValorContabil, -- Valor Contbil Original do Documento (Tesouraria)
          CAST(NULL AS Numeric(15,2)) AS ValorDescontos, -- Valor Desconto dos Produtos
          CAST(NULL AS Numeric(15,2)) AS ValorOutrasDespesas, -- Valor Outras Despesas dos Produtos
          CAST(NULL AS Numeric(15,2)) AS ValorDescontosServ, -- Valor Desconto dos Servios
          CAST(NULL AS Numeric(15,2)) AS ValorOutrasDespesasServ, -- Valor Outras Despesas dos Servios
          CAST(NULL AS VARCHAR(1)) AS SituacaoNFE, -- {3=Autorizada;5=Cancelada;7=Inutilizada;8=Substituida;9=Denegada;A=Contingncia}
          CAST(NULL AS VARCHAR(1)) AS SituacaoDOC, -- {0=Normal;1=Cancelada;2=Devoluo Parcial;3=Devoluo Total;4=Crdito Bloqueado;5=Inadimplncia;6=Cred. Bloq/Inad.;7=Bloqueio nos Itens;8=Faturado;A=Bloq. Val. Parcela;B=Bloq. Val. Min. Venda}
          CAST(NULL AS VARCHAR(50)) AS ObsFiscal, -- Observao Fiscal do Documento
          CAST(NULL AS VARCHAR(150)) AS Observacoes, -- Observaes da Nota
          CAST(NULL AS VARCHAR(4000)) AS InfoComplementares, -- Informaes Complementares da Nota
          CAST(NULL AS VARCHAR(4000)) AS TextoFiscal, -- Texto Fiscal do Documento
          CAST(NULL AS VARCHAR(200)) AS NumPedCliente, -- Nmero do Pedido no Cliente
          CAST(NULL AS VARCHAR(100)) AS NumPedRepresentante, -- Nmero do Pedido no Representante
          CAST(NULL AS VARCHAR(1)) AS IndNaturezaFrete, -- {0=Operaes de vendas, com nus suportado pelo estabelecimento vendedor;1=Operaes de vendas, com nus suportado pelo adquirente;2=Operaes de compras (bens para revenda, matrias prima e outros produtos, geradores de crdito);3=Operaes de compras (bens para revenda, matrias prima e outros produtos, no geradores de crdito);4=Transferncia de produtos acabados entre estabelecimentos da pessoa jurdica;5=Transferncia de produtos entre estabelecimentos da pessoa jurdica;9=Outras}
          CAST(NULL AS VARCHAR(60)) AS ChaveNFE, -- Chave NFE
          CAST(NULL AS VARCHAR(60)) AS ChaveNFERefer, -- Chave NFE Referenciada
          CAST(NULL AS VARCHAR(20)) AS CodContaTes, -- Cdigo da Conta Tesouraria
          -- Justificativa utilizada em Testes de Integrao pela EME4
          CAST('Financeiro ('||ERFIN.ORIGEM||') - Chave: '||ERFIN.CODFIL||'/'||ERFIN.SEQUEN AS VARCHAR(200)) AS Justificativa, -- Justificativa do documento Contbil
          --CAST(NULL AS VARCHAR(200)) AS Justificativa, -- Justificativa do documento Contbil
          CAST(NULL AS VARCHAR(1)) AS TipoFrete, -- {F=Por conta do emitente;T=Por conta do destinatrio;A=Por conta de terceiros;B=Sem frete}
          CAST(NULL AS Numeric(9)) AS CodTransportadora, -- Cdigo da Transportadora do Documento
          CAST(NULL AS VARCHAR(18)) AS CpfCnpjTransportadora, -- CPF ou CNPJ da Transportadora do Documento
          CAST(NULL AS VARCHAR(10)) AS PlacaVeiculo, -- Placa do Veculo de Entrega
          CAST(NULL AS Numeric(9)) AS CodTranspRedespacho, -- Cdigo da Transportadora de Redespacho do Documento
          CAST(NULL AS VARCHAR(18)) AS CpfCnpjTranspRedespacho, -- CPF ou CNPJ da Transportadora de Redespacho do Documento
          CAST(NULL AS VARCHAR(2)) AS CodigoModelo, -- Cdigo do Modelo de Documento (01 ou 65)
          CAST(NULL AS VARCHAR(120)) AS LogradouroEnt, -- Logradouro do Endereo de Entrega
          CAST(NULL AS Numeric(10)) AS NumeroEnt, -- Nmero do Endereo de Entrega
          CAST(NULL AS VARCHAR(30)) AS ComplementoEnt, -- Complemento do Endereo de Entrega
          CAST(NULL AS VARCHAR(10)) AS CEPEnt, -- CEP do Endereo de Entrega
          CAST(NULL AS VARCHAR(80)) AS BairroEnt, -- Bairro do Endereo de Entrega
          CAST(NULL AS Numeric(10)) AS CodMunicipioIBGEEnt, -- GeoCodigo do M3 - caso esteja informado dever importar o vnculo do municpio por este cdigo (Endereo)
          CAST(NULL AS VARCHAR(100)) AS CidadeEndEnt, -- Cidade do Endereo de Entrega
          CAST(NULL AS VARCHAR(2)) AS EstadoEnt, -- Estado do Endereo de Entrega
          CAST(NULL AS Numeric(9)) AS CodigoPaisEnt, -- Codigo do Banco Central para o Pais da Cidade de Entrega
          CAST(NULL AS VARCHAR(80)) AS PaisEnt, -- Nome do Pais do Endereo de Entrega
          CAST(NULL AS Numeric(15,2)) AS ValorFrete, -- Valor do Frete
          CAST(NULL AS Numeric(15,2)) AS ValorFreteTerceiros, -- Valor do Frete Terceiros
          CAST(NULL AS Numeric(15,2)) AS ICMSFreteTerceiros, -- Valor ICMS do Frete Terceiros
          CAST(NULL AS Numeric(15,2)) AS DifaFreteTerceiros, -- Valor DIFA do Frete Terceiros
          CAST(NULL AS Numeric(15,2)) AS ValorSeguro, -- Valor do Seguro
          CAST(NULL AS Numeric(15,2)) AS ValorAcrescimos, -- Valor Acrescimos
          -- Valores relativo a Nota de Importao
          CAST(NULL AS Numeric(15,2)) AS ValorTHC, -- Valor THC
          CAST(NULL AS Numeric(15,2)) AS ValorAFRMM, -- Valor AFRMM
          CAST(NULL AS Numeric(15,2)) AS ValorDemurrage, -- Valor Demurrage
          CAST(NULL AS Numeric(15,2)) AS ValorDesestiva, -- Valro Desestiva
          CAST(NULL AS Numeric(15,2)) AS ValorDesembaraco, -- Valor Desembarao
          CAST(NULL AS Numeric(15,2)) AS ValorSiscomex, -- Valor Siscomex
          CAST(NULL AS Numeric(15,2)) AS ValorPISImport, -- Valro PIS Importao
          CAST(NULL AS Numeric(15,2)) AS ValorCofinsImport, -- Valro Cofins Importao
          CAST(NULL AS Numeric(15,2)) AS ValorDespAduaneira, -- Valor Despesa Aduaneira
          CAST(NULL AS VARCHAR(10)) AS SimboloMoeda, -- Smbolo da Moeda
          CAST(NULL AS Numeric(15,4)) AS ValorCotacaoMoeda, -- Valor Cotao Moeda
          CAST(NULL AS Timestamp) AS DataCotacaoMoeda, -- Data Cotao Moeda
          CAST(NULL AS VARCHAR(18)) AS CPFCNPJRepresentante, -- CPF ou CNPJ do Representante
          CAST(NULL AS Numeric(8)) AS COO, -- COO Cupom
          CAST(NULL AS Numeric(8)) AS NroECF, -- Nmero do ECF
          CAST(NULL AS VARCHAR(50)) AS NroSerieECF, -- Nmero de rie do ECF
          CAST(NULL AS VARCHAR(20)) AS ModeloECF, -- Modelo do ECF
          CAST(NULL AS VARCHAR(20)) AS MarcaECF, -- Marca do ECF
          CAST(NULL AS VARCHAR(18)) as CPFCNPJCupom -- CPF ou CNPJ do cliente no identificado no cupom	
     FROM (
            SELECT 
                   ERFIN.CODFIL,
                   ERFIN.SEQUEN,
                   ERFIN.ORIGEM,
                   ERFIN.FILCLI,
                   ERFIN.CODCLI,
                   ENDFAT.NUMDOC AS ENDFAT_NUMDOC,
                   PAR.NUMDOC AS PAR_NUMDOC,
                   VIN.NUMDOC AS VIN_NUMDOC,
                   ERFIN.CHAVE_ENDFAT,
                   ERFIN.EXPORTACAO_EME4,
                   ERFIN.EXPORTADO_EME4,
                   CAST(LeParametroNum('TP_OP_EXP_EME4_'||ERFIN.ORIGEM, ERFIN.CODFIL, '', '', '') AS Numeric(3)) AS TipoOperacao,
                   MIN(ERFIN.DATINCORI) AS DATINCORI,
                   MIN(ERFIN.ATU_EM) AS ATU_EM,
                   MIN(ERFIN.DATOPE) AS DATOPE,
                   SUM(ABS(ERFIN.VLRMOV)) AS VLRMOV
              FROM TV_ERFIN ERFIN 
              -- Cliente
              LEFT JOIN TT_CLI PAR ON PAR.FILCLI = ERFIN.FILCLI AND PAR.CODCLI = ERFIN.CODCLI
              --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
              -- Endereo de Faturamento
              LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = ERFIN.FILCLI AND ENDFAT.CODCLI = ERFIN.CODCLI AND ENDFAT.CODFIL = SUBSTR(ERFIN.CHAVE_ENDFAT, 1, 3) AND ENDFAT.NUMEND = TO_NUMBER(SUBSTR(ERFIN.CHAVE_ENDFAT, 4, LENGTH(ERFIN.CHAVE_ENDFAT)))
              -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
              LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
              -- Obs: Origem de TEF por hora no sero exportadas devido ao grande fluxo de movimentao posteriormente ser avaliado a possibilidade de exportao de um registro por dia.
             WHERE (LeParametroTXT('TIPO_EXP_EME4', ERFIN.CODFIL, '', '', '') = 'C')
               AND ERFIN.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',ERFIN.CODFIL,'','','')
               AND ERFIN.ORIGEM NOT IN ('VEN', 'REC', 'COM', 'FAT', 'FRE', 'TIT', 'PAG', 'TEF')
               AND ERFIN.EXPORTACAO_EME4 NOT LIKE '%#%'
               AND ERFIN.EXPORTADO_EME4 = 'F'
             GROUP BY ERFIN.CODFIL, ERFIN.SEQUEN, ERFIN.ORIGEM, LeParametroNum('TP_OP_EXP_EME4_'||ERFIN.ORIGEM, ERFIN.CODFIL, '', '', ''), ERFIN.EXPORTADO_EME4, ERFIN.EXPORTACAO_EME4, 
                      ERFIN.FILCLI, ERFIN.CODCLI, ENDFAT.NUMDOC, PAR.NUMDOC, VIN.NUMDOC, ERFIN.CHAVE_ENDFAT
      ) ERFIN 
     -- Cliente
     LEFT JOIN TT_CLI PAR ON PAR.FILCLI = ERFIN.FILCLI AND PAR.CODCLI = ERFIN.CODCLI
     --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
     -- Endereo de Faturamento
     LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = ERFIN.FILCLI AND ENDFAT.CODCLI = ERFIN.CODCLI AND ENDFAT.CODFIL = SUBSTR(ERFIN.CHAVE_ENDFAT, 1, 3) AND ENDFAT.NUMEND = TO_NUMBER(SUBSTR(ERFIN.CHAVE_ENDFAT, 4, LENGTH(ERFIN.CHAVE_ENDFAT)))
     -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
     LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
     -- Obs: Origem de TEF por hora no sero exportadas devido ao grande fluxo de movimentao posteriormente ser avaliado a possibilidade de exportao de um registro por dia.
     WHERE 1=1
     ) TAB
   ;


-- Autor: Pedro E. Braga
-- Cliente(s): EME4
-- Finalidade(s):
-- 1) Gerar Tabela de Integrao de "Movimento Contabilidade" (Tabela Integrao Mult)
/*-- SEQ 3142 --*/
/*-- IGNORE ERRO --*/
DROP VIEW TV_TIMU_MOVCTB CASCADE;

/*-- SEQ 3143 --*/
CREATE OR REPLACE VIEW TV_TIMU_MOVCTB AS
SELECT 
      --CAST(NULL AS Numeric(8)) AS ID, -- Id do registro na tabela Deve ser tratado como Generetor via Trigger
      CAST('TOT' AS VARCHAR(3)) AS SistemaOrigem, -- M - M3 / O - Outros / TOT - Totall
      CAST(CASE WHEN (COALESCE(TAB.EXPEM4, 'T') = 'T') THEN 'A' ELSE 'I' END AS VARCHAR(1)) AS Acao, -- I - Incluir / E - Excluir / A - Alterar / X - Incluso/Alterao Automtica para Cadastros
      CAST('A' AS VARCHAR(1)) AS StatusM3, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroM3, -- Descrio da inconsistncia
      CAST('A' AS VARCHAR(1)) AS StatusOutros, -- A - Aguardando Importao / I - Importando / E - Erro / R - Registro Importado
      --CAST(NULL AS VARCHAR(200)) AS ErroOutros, -- Descrio da inconsistncia
      TAB.CODFIL, TAB.SEQUEN, TAB.NUMPAR, TAB.SUBPAR, TAB.ORIGEM, TAB.DESTINO, TAB.DATINC, TAB.ATU_EM, TAB.EXPORT, TAB.CHAVE,
      TAB.DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro (pode ser atualizado por trigger)
      TAB.TipoOperacao, -- Cdigo do Tipo de Operao
      TAB.Filial, -- Cdigo da Filial
      TAB.NumeroDocumento, -- Nmero do documento
      TAB.DataLancamento, -- Data do Lanamento
      TAB.CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
      TAB.CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
      TAB.TipoIdentificacao, -- C - Cliente ou F - Fornecedor
      TAB.TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
      TAB.Serie, -- Srie do Documento
      TAB.ContaDebito, -- Cdigo da Conta Dbito
      TAB.ContaCredito, -- Cdigo da Conta Crdito
      TAB.ValorLancamento, -- Valor do Lanamento
      TAB.NomeLancto, -- Nome do Lanamento
      TAB.Complemento -- Complemento do histrico
  FROM (
        -- Lanamentos Contabilidade
        SELECT
               ERFIN.CODFIL, ERFIN.SEQUEN, ERFIN.NUMPAR, ERFIN.SUBPAR, CAST(ERFIN.ORIGEM AS VARCHAR(3)) AS ORIGEM, CAST('TIMU_MOVCTB' AS VARCHAR(50)) AS DESTINO, COALESCE(ERFIN.DATINCORI, ERFIN.DATOPE) AS DATINC, ERFIN.ATU_EM, CAST('F' AS VARCHAR(1)) AS EXPORT,
               CAST(CASE WHEN ERFIN.ORIGEM IN ('VEN', 'REC') THEN 'VEN'
                         WHEN ERFIN.ORIGEM IN ('COM', 'FAT', 'FRE', 'TIT', 'PAG') THEN 'COM'
                         ELSE ERFIN.ORIGEM
                    END || ERFIN.CODFIL || ERFIN.SEQUEN AS VARCHAR(50)) AS CHAVE,
               COALESCE(ERFIN.DATINCORI, ERFIN.DATOPE) AS DataHoraAtuReg, -- Data e Hora da ltima atualizao do registro
               ERFIN.EXPORTADO_EME4 AS EXPEM4,
               CAST(CASE WHEN ERFIN.ORIGEM IN ('VEN', 'REC') THEN (SELECT -- Definido juntamente com a EME4 quando for cupom fiscal enviar tipo de operao fixo
                                                                          CASE WHEN (VEN.CODSER = 'CF') THEN 998
                                                                               WHEN (VEN.MODNOT = '65') THEN 997
                                                                               WHEN (VEN.MODNOT = '59') THEN 996
                                                                               WHEN (VEN.UFLOJA = 'T') THEN                                                                                                             TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTDEM, '[^0-9]', '', 'gi'), ''))                                                                               ELSE                                                                                     TO_NUMBER(NULLIF(regexp_replace(DNAT.EXTFOR, '[^0-9]', '', 'gi'), ''))                                                                          END AS Tipo
                                                                    FROM TT_VEN VEN
                                                                    -- Natureza
                                                                    LEFT JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
                                                                   WHERE VEN.CODFIL = ERFIN.CODFIL AND VEN.SEQUEN = ERFIN.SEQUEN )
                         WHEN ERFIN.ORIGEM IN ('COM', 'FAT', 'FRE', 'TIT', 'PAG') THEN (SELECT                                                                           TO_NUMBER(NULLIF(regexp_replace(DCFO.EXTCFO, '[^0-9]', '', 'gi'), '')) AS Tipo
                                                                     FROM TT_COM COM
                                                                     -- Natureza
                                                                     LEFT JOIN TD_CFO DCFO ON DCFO.CODTAB = COM.CODCFO
                                                                    WHERE COM.CODFIL = ERFIN.CODFIL AND COM.SEQUEN = ERFIN.SEQUEN )
                         ELSE LeParametroNum('TP_OP_EXP_EME4_'||ERFIN.ORIGEM, ERFIN.CODFIL, '', '', '') 
                    END AS Numeric(3)) AS TipoOperacao, -- Cdigo do Tipo de Operao
               CAST(TO_NUMBER(ERFIN.CODFIL) AS Numeric(3)) AS Filial, -- Cdigo da Filial
               CAST(CASE WHEN (ISNOTNULL(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC))='T') THEN NULL
                         ELSE TO_NUMBER(CASE WHEN (ISNOTNULL(PAR.NUMDOC)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG))
                                             THEN CASE WHEN (ISNULL(PAR.CODEXT)='T') OR (PAR.CODCLI = LPAD('0', 6, ' ')) OR (PAR.FILCLI||PAR.CODCLI = (SELECT CFG.VC_FILCLI||CFG.VC_CODCLI FROM TT_CFG CFG)) THEN PAR.FILCLI||LPAD(TRIM(PAR.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(PAR.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                             ELSE CASE WHEN (ISNULL(VIN.CODEXT)='T') THEN VIN.FILCLI||LPAD(TRIM(VIN.CODCLI), 6, '0')
                                                       ELSE SUBSTR(TO_CHAR(CAST(                                                                                NULLIF(regexp_replace(VIN.CODEXT, '[^0-9]', '', 'gi'), '') AS Numeric(20))), 1, 9)
                                                  END
                                        END)
                    END AS Numeric(9)) AS CodigoCliFor, -- Cdigo do Cliente ou Fornecedor
               CAST(TRIM(COALESCE(COALESCE(ENDFAT.NUMDOC, PAR.NUMDOC), VIN.NUMDOC)) AS VARCHAR(18)) AS CPFCNPJCliFor, -- CPF ou CNPJ do Cliente ou Fornecedor
               CAST(CASE WHEN EXISTS(SELECT 1 AS OK FROM TT_REL REL WHERE REL.FILPAR = ERFIN.FILCLI AND REL.CODPAR = ERFIN.CODCLI AND REL.TIPPAR IN ('A', 'F', 'T')) THEN 'F'
                         ELSE 'C' 
                    END AS VARCHAR(1)) AS TipoIdentificacao, -- C - Cliente ou F - Fornecedor
               CAST(TO_CHAR(TO_NUMBER(TRIM(CASE WHEN (ISNOTNULL(ERFIN.EXPORTACAO_EME4)='T') AND (INSTR(ERFIN.EXPORTACAO_EME4, '#') = 0) THEN ERFIN.EXPORTACAO_EME4 ELSE ERFIN.SEQUEN END))) AS VARCHAR(10)) AS NumeroDocumento, -- Nmero do documento
               CAST(CASE WHEN ERFIN.ORIGEM IN ('VEN', 'REC') THEN '1'
                         WHEN ERFIN.ORIGEM IN ('COM', 'FAT', 'FRE', 'TIT', 'PAG') THEN '2'
                         ELSE NULL
                    END AS VARCHAR(1)) AS TipoSerie, -- Tipo da Srie do Documento 1 - Prpria / 2 - Terceiros
               CAST(CASE WHEN ERFIN.ORIGEM IN ('VEN', 'REC') THEN (SELECT TRIM(CASE WHEN VEN.CODSER='CF' THEN VEN.CODSER
                                                                                    WHEN ( (VEN.MODNOT = '65' OR VEN.MODNOT = '59') AND VEN.NUMECF >= '400' ) THEN VEN.NUMECF
                                                                                    WHEN VEN.CODSER<>'CF' AND ISNOTNULL(DSER.SEREXT)='T' THEN DSER.SEREXT
                                                                                    ELSE NULL
                                                                               END) AS CODSER
                                                                    FROM TT_VEN VEN
                                                                    -- Srie de Emisso
                                                                    JOIN TD_SER DSER ON DSER.CODSER = VEN.CODSER
                                                                   WHERE VEN.CODFIL = ERFIN.CODFIL AND VEN.SEQUEN = ERFIN.SEQUEN )
                         WHEN ERFIN.ORIGEM IN ('COM', 'FAT', 'FRE', 'TIT', 'PAG') THEN (SELECT CASE WHEN ISNOTNULL(FIS.SEREXP)='T' THEN LPAD(TRIM(FIS.SEREXP), 3, '0')||CASE WHEN COM.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(FIS.SUBEXP),'0'), 2, '0') END
                                                                               ELSE LPAD(TRIM(COM.CODSER), 2, '0')||CASE WHEN COM.TIPPAR = 'T' THEN '' ELSE LPAD(COALESCE(TRIM(COM.SUBSER),'0'), 3, '0') END
                                                                          END AS CODSER
                                                                     FROM TT_COM COM
                                                                     -- Srie de Emisso
                                                                     LEFT JOIN (SELECT DISTINCT CODSER, CASE WHEN LPAD(SUBSER,3,' ') = '   ' THEN '$$$' ELSE SUBSER END AS SUBSER, SEREXP, SUBEXP, MODNOT, ORIGEM
                                                                                  FROM TT_FIS
                                                                                 WHERE ORIGEM IN ('C','F')) FIS ON FIS.CODSER = COM.CODSER AND FIS.SUBSER = COALESCE(COM.SUBSER,'$$$') AND FIS.ORIGEM = CASE WHEN COALESCE(COM.TIPPAR,'F') = 'T' THEN 'F' ELSE 'C' END
                                                                    WHERE COM.CODFIL = ERFIN.CODFIL AND COM.SEQUEN = ERFIN.SEQUEN )
                         ELSE NULL
                    END AS VARCHAR(5)) AS Serie, -- Srie do Documento
               CAST(ERFIN.DATOPE AS Timestamp) AS DataLancamento, -- Data do Lanamento
               -- Definido juntamente com a EME4 quando o cdigo da conta financeira no possuir um "-" devemos exportar para uma Conta fixa para posterior reviso
               CAST(TRIM(CASE WHEN INSTR(ERFIN.DEBITO, '-') > 0 THEN SUBSTR(ERFIN.DEBITO,1,20) ELSE '99999-1' END) AS VARCHAR(20)) AS ContaDebito, -- Cdigo da Conta Dbito
               CAST(TRIM(CASE WHEN INSTR(ERFIN.CREDITO, '-') > 0 THEN SUBSTR(ERFIN.CREDITO,1,20) ELSE '99999-2' END) AS VARCHAR(20)) AS ContaCredito, -- Cdigo da Conta Crdito
               CAST(ABS(ERFIN.VLRMOV) AS Numeric(15,2)) AS ValorLancamento, -- Valor do Lanamento
               CAST(NULL AS VARCHAR(30)) AS NomeLancto, -- Nome do Lanamento
               CAST(ERFIN.COMPLE AS VARCHAR(400)) AS Complemento -- Complemento do histrico
          FROM TV_ERFIN ERFIN 
          -- Cliente
          LEFT JOIN TT_CLI PAR ON PAR.FILCLI = ERFIN.FILCLI AND PAR.CODCLI = ERFIN.CODCLI
          --JOIN TT_END ENDE ON ENDE.FILCLI = PAR.FILCLI AND ENDE.CODCLI = PAR.CODCLI AND ENDE.CODFIL = PAR.FILEND AND ENDE.NUMEND = PAR.NUMEND
          -- Endereo de Faturamento
          LEFT JOIN TT_END ENDFAT ON ENDFAT.FILCLI = ERFIN.FILCLI AND ENDFAT.CODCLI = ERFIN.CODCLI AND ENDFAT.CODFIL = SUBSTR(ERFIN.CHAVE_ENDFAT, 1, 3) AND ENDFAT.NUMEND = TO_NUMBER(SUBSTR(ERFIN.CHAVE_ENDFAT, 4, LENGTH(ERFIN.CHAVE_ENDFAT)))
          -- Parceiro Vinculado - S buscar o vnculo se a pessoa no for fsica
          LEFT JOIN TT_CLI VIN ON VIN.FILCLI = PAR.FILVIN AND VIN.CODCLI = PAR.CODVIN AND PAR.FLGTIP <> 0
          -- Obs: Origem de TEF por hora no sero exportadas devido ao grande fluxo de movimentao posteriormente ser avaliado a possibilidade de exportao de um registro por dia.
          WHERE ERFIN.ORIGEM NOT IN (/*'VEN', 'REC', 'COM', 'FAT', 'FRE', 'TIT', 'PAG',*/ 'TEF')
            AND ERFIN.DATOPE >= LeParametroDat('DAT_PRI_MOV_EXP_EME4',ERFIN.CODFIL,'','','')
            AND (LeParametroTXT('TIPO_EXP_EME4', ERFIN.CODFIL, '', '', '') = 'C')
            AND ERFIN.EXPORTACAO_EME4 NOT LIKE '%#%'
            AND ERFIN.EXPORTADO_EME4 = 'F'
       ) TAB
;


/*-- SEQ 3144 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ValoresProdutoKit (CHAR,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE,TT_GRA.CUSREP%TYPE,TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE) CASCADE;

/*-- SEQ 3145 --*/
CREATE OR REPLACE FUNCTION ValoresProdutoKit (CHAR,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE,TT_GRA.CUSREP%TYPE,TT_CLI.FILCLI%TYPE,TT_CLI.CODCLI%TYPE)
RETURNS Numeric AS $$
DECLARE
p_Tipo ALIAS FOR $1 ;
p_FILMAT ALIAS FOR $2 ;
p_CODMAT ALIAS FOR $3 ;
p_CODCOR ALIAS FOR $4 ;
p_CODTAM ALIAS FOR $5 ;
p_CODFIL ALIAS FOR $6 ;
p_CUSREP ALIAS FOR $7 ;
p_FILFOR ALIAS FOR $8 ;
p_CODFOR ALIAS FOR $9 ;
-- Objetivo:
-- 1) Calcula o preco de venda, custo de reposicao, Preo de compra e custo mdio de um Kit de produto

-- Parmetros
   -- p_Tipo
   -- (V)Preo de venda:
   -- (R) custo de reposio
   -- (C) Preo de compra
   -- (M) custo mdio
   -- (S) - Preo Simulado.

   nResult                       Numeric;
   cFILITE                       TT_KIT.FILITE%TYPE;
   cCODITE                       TT_KIT.CODITE%TYPE;
   nCORITE                       TT_KIT.CORITE%TYPE;
   nTAMITE                       TT_KIT.TAMITE%TYPE;
   nQTDITE                       TT_KIT.QTDITE%TYPE;

CursorComposicaoKit CURSOR(pFILMAT TT_GRA.FILMAT%TYPE,
           pCODMAT TT_GRA.CODMAT%TYPE,
           pCODCOR TT_GRA.CODCOR%TYPE,
           pCODTAM TT_GRA.CODTAM%TYPE) IS
   SELECT KIT.FILITE, KIT.CODITE, KIT.CORITE, KIT.TAMITE, KIT.QTDITE
     FROM TT_KIT KIT 
    WHERE KIT.FILMAT = pFILMAT
      AND KIT.CODMAT = pCODMAT
      AND KIT.CODCOR = pCODCOR
      AND KIT.CODTAM = pCODTAM;
BEGIN
   nResult := 0;

   OPEN CursorComposicaoKit(p_FILMAT, p_CODMAT, p_CODCOR, p_CODTAM);
   LOOP
      FETCH CursorComposicaoKit
       INTO cFILITE, cCODITE, nCORITE, nTAMITE, nQTDITE;
      EXIT WHEN NOT FOUND;

     nResult := nResult + (ValoresProduto(p_Tipo, cFILITE, cCODITE, nCORITE, nTAMITE,
                                          p_CODFIL, p_CUSREP, p_FILFOR, p_CODFOR) * nQTDITE);

   END LOOP;
   CLOSE CursorComposicaoKit;

   IF nResult <= 0 THEN
      nResult := ValoresProduto(p_Tipo, p_FILMAT, p_CODMAT, p_CODCOR, p_CODTAM,
                                p_CODFIL, p_CUSREP, p_FILFOR, p_CODFOR);
   END IF;

   IF nResult <= 0 THEN
      nResult := p_CUSREP;
   END IF;

   RETURN COALESCE(nResult, 0);

END;
$$ language 'plpgsql';


/*-- SEQ 3146 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ValoresProdutoKit (CHAR,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE,TT_GRA.CUSREP%TYPE) CASCADE;

/*-- SEQ 3147 --*/
CREATE OR REPLACE FUNCTION ValoresProdutoKit (CHAR,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               TD_FIL.CODFIL%TYPE,
                               TT_GRA.CUSREP%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN ValoresProdutoKit($1,$2,$3,$4,$5,$6,$7,null,null);
END;
$$ language 'plpgsql';


/*-- SEQ 3148 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ValoresProdutoKit (CHAR,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE,TD_FIL.CODFIL%TYPE) CASCADE;

/*-- SEQ 3149 --*/
CREATE OR REPLACE FUNCTION ValoresProdutoKit (CHAR,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE,
                               TD_FIL.CODFIL%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN ValoresProdutoKit($1,$2,$3,$4,$5,$6,null);
END;
$$ language 'plpgsql';


/*-- SEQ 3150 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION ValoresProdutoKit (CHAR,TT_GRA.FILMAT%TYPE,TT_GRA.CODMAT%TYPE,TT_GRA.CODCOR%TYPE,TT_GRA.CODTAM%TYPE) CASCADE;

/*-- SEQ 3151 --*/
CREATE OR REPLACE FUNCTION ValoresProdutoKit (CHAR,
                               TT_GRA.FILMAT%TYPE,
                               TT_GRA.CODMAT%TYPE,
                               TT_GRA.CODCOR%TYPE,
                               TT_GRA.CODTAM%TYPE) 
RETURNS Numeric AS $$
BEGIN
RETURN ValoresProdutoKit($1,$2,$3,$4,$5,null);
END;
$$ language 'plpgsql';



CREATE OR REPLACE FUNCTION GX_SALDOKIT (p_DATREF IN Timestamp, p_FILMAT IN TT_GRA.FILMAT%TYPE, p_CODMAT IN TT_GRA.CODMAT%TYPE, p_CODCOR IN TT_GRA.CODCOR%TYPE, p_CODTAM IN TT_GRA.CODTAM%TYPE, p_CODFIL IN TT_GRA.FILMAT%TYPE, p_CODMUL IN TD_MUL.CODTAB%TYPE,p_SALDO OUT Numeric) AS $$
BEGIN
  p_SALDO = SALDOKIT(p_DATREF, p_FILMAT, p_CODMAT, p_CODCOR, p_CODTAM, p_CODFIL, p_CODMUL);
END;
$$ language 'plpgsql';



CREATE OR REPLACE FUNCTION GX_ValoresProduto (p_Tipo IN CHAR,p_FILMAT IN TT_GRA.FILMAT%TYPE,p_CODMAT IN TT_GRA.CODMAT%TYPE,p_CODCOR IN TT_GRA.CODCOR%TYPE,p_CODTAM IN TT_GRA.CODTAM%TYPE,p_CODFIL IN TD_FIL.CODFIL%TYPE,p_CUSREP IN TT_GRA.CUSREP%TYPE,p_FILFOR IN TT_CLI.FILCLI%TYPE,p_CODFOR IN TT_CLI.CODCLI%TYPE,p_VALOR OUT Numeric) AS $$
DECLARE
cFILFOR TT_CLI.FILCLI%TYPE;
cCODFOR TT_CLI.CODCLI%TYPE;
cCODFIL TD_FIL.CODFIL%TYPE;
BEGIN
  IF p_FILFOR='' THEN
     cFILFOR:=null;
  ELSE
     cFILFOR:=p_FILFOR;
  END IF;
  IF p_CODFOR='' THEN
     cCODFOR:=null;
  ELSE
	 cCODFOR:=p_CODFOR;
  END IF;
  IF p_CODFIL='' THEN
     cCODFIL:=null;
  ELSE
     cCODFIL:=p_CODFIL;
  END IF;
  p_VALOR = ValoresProduto(p_Tipo,p_FILMAT,p_CODMAT,p_CODCOR,p_CODTAM,
                                    cCODFIL,p_CUSREP,cFILFOR,cCODFOR);
END;
$$ language 'plpgsql';



CREATE OR REPLACE FUNCTION GX_ValoresProdutoKit (p_Tipo IN CHAR,p_FILMAT IN TT_GRA.FILMAT%TYPE,p_CODMAT IN TT_GRA.CODMAT%TYPE,p_CODCOR IN TT_GRA.CODCOR%TYPE,p_CODTAM IN TT_GRA.CODTAM%TYPE,p_CODFIL IN TD_FIL.CODFIL%TYPE,p_CUSREP IN TT_GRA.CUSREP%TYPE,p_FILFOR IN TT_CLI.FILCLI%TYPE,p_CODFOR IN TT_CLI.CODCLI%TYPE,p_VALOR OUT Numeric) AS $$
DECLARE
cFILFOR TT_CLI.FILCLI%TYPE;
cCODFOR TT_CLI.CODCLI%TYPE;
cCODFIL TD_FIL.CODFIL%TYPE;
BEGIN
  IF p_FILFOR='' THEN
     cFILFOR:=null;
  ELSE
     cFILFOR:=p_FILFOR;
  END IF;
  IF p_CODFOR='' THEN
     cCODFOR:=null;
  ELSE
     cCODFOR:=p_CODFOR;
  END IF;
  IF p_CODFIL='' THEN
     cCODFIL:=null;
  ELSE
     cCODFIL:=p_CODFIL;
  END IF;
  p_VALOR = ValoresProdutoKit(p_Tipo, p_FILMAT, p_CODMAT, p_CODCOR, p_CODTAM,
                              cCODFIL, p_CUSREP, cFILFOR, cCODFOR);
END;
$$ language 'plpgsql';



/*-- SEQ 3152 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGABA() CASCADE;

/*-- SEQ 3153 --*/
CREATE OR REPLACE FUNCTION TGABA() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

  --LEO 84337
  vSESSIONID    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

  vFLGNEW       TT_ABA.FLGEST%TYPE;
  -- RFMP 85136
  WK_UID  TPC_UID_Retorno%ROWTYPE;

BEGIN
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
   NEW.DATINC := agora();
  END IF;

  -- Popula a coluna ATU_EM
  IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
     NEW.ATU_EM := agora();
  END IF;

  -- Atualiza Situao
  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     NEW.FLGEST := TGR_ABA_Flgest(NEW.CODFIL, NEW.CODABA, NEW.FLGEST);
  END IF;  
  -- Se a funo no conseguir encontrar um FLGEST vlido ento deve deixar o que j estava.
  IF (TG_OP = 'UPDATE') THEN     
     IF NEW.FLGEST = '?' THEN 
        NEW.FLGEST := OLD.FLGEST;
     END IF;
  END IF;

  -- Inicializa dados para assinatura

  -- RFMP 85136
  WK_UID := GetUidAtual();

  IF (TG_OP = 'INSERT') THEN
    IF WK_UID.BLQ_SEM_UID = 'T' AND WK_UID.CODUID IS NULL THEN
      RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
    -- Douglas - 83441
    NEW.CODUID := WK_UID.CODUID;
    NEW.ASSINA := COALESCE(AssinaTabela('TT_ABA',
                                      ConcatenaABA(NEW.CODFIL,
                                                     NEW.CODABA,
                                                     NEW.ENCINI,
                                                     NEW.ENCFIM,
                                                     NEW.FLGEST,
                                                     NEW.CODTAN,
                                                     NEW.CODBOM,
                                                     NEW.CODBIC,
                                                     NEW.VOLABS),
                                                  null, null, null),NEW.ASSINA);

  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF ConcatenaABA(NEW.CODFIL,NEW.CODABA,NEW.ENCINI,NEW.ENCFIM,NEW.FLGEST, NEW.CODTAN, NEW.CODBOM, NEW.CODBIC, NEW.VOLABS) <>
	    ConcatenaABA(OLD.CODFIL,OLD.CODABA,OLD.ENCINI,OLD.ENCFIM,OLD.FLGEST, NEW.CODTAN, NEW.CODBOM, NEW.CODBIC, NEW.VOLABS) THEN

      IF WK_UID.BLQ_SEM_UID = 'T' AND WK_UID.CODUID IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;

	    -- Douglas - 83441
      NEW.CODUID := WK_UID.CODUID;
      NEW.ASSINA := COALESCE(AssinaTabela('TT_ABA',
	                                         ConcatenaABA(NEW.CODFIL,
                                                          NEW.CODABA,
                                                          NEW.ENCINI,
                                                          NEW.ENCFIM,
                                                          NEW.FLGEST,
                                                          NEW.CODTAN,
                                                          NEW.CODBOM,
                                                          NEW.CODBIC,
                                                          NEW.VOLABS),
                                                      OLD.CODUID,
	                                         ConcatenaABA(OLD.CODFIL,
                                                          OLD.CODABA,
                                                          OLD.ENCINI,
                                                          OLD.ENCFIM,
                                                          OLD.FLGEST,
                                                          OLD.CODTAN,
                                                          OLD.CODBOM,
                                                          OLD.CODBIC,
                                                          OLD.VOLABS),
                                                      OLD.ASSINA
                                                     ),NEW.ASSINA);
	 END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3154 --*/
CREATE TRIGGER TGABA
BEFORE INSERT OR UPDATE ON TT_ABA 
FOR EACH ROW EXECUTE PROCEDURE TGABA();

/*-- SEQ 3155 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGABA_ASS() CASCADE;

/*-- SEQ 3156 --*/
CREATE OR REPLACE FUNCTION TGABA_ASS() RETURNS TRIGGER AS $$
-- 83073
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
DECLARE

 WK_DUMMY VARCHAR(2);

  -- RFMP 85136
  WK_UID TPC_UID_Retorno%ROWTYPE;

BEGIN

  IF ExisteFilialNaUF('SC') THEN 
     IF (TG_OP = 'INSERT') THEN
       -- RFMP 85136 Tratamento para no dar lock na TT_ASS
       WK_UID := GetUidAtual();
     
       IF WK_UID.ASSINS = 'T' THEN
         UPDATE TT_ASS
            SET QTDREG = QTDREG + 1
          WHERE NOMTAB = 'TT_ABA';
       ELSE
         WK_DUMMY := Insere_MASS('TT_ABA');
       END IF;
     END IF;
     
     IF (TG_OP = 'DELETE') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG - 1
        WHERE NOMTAB = 'TT_ABA';
     END IF;
  END IF;   

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3157 --*/
CREATE TRIGGER TGABA_ASS
AFTER INSERT OR DELETE ON TT_ABA 
FOR EACH ROW EXECUTE PROCEDURE TGABA_ASS();

/*-- SEQ 3158 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGABA2() CASCADE;

/*-- SEQ 3159 --*/
CREATE OR REPLACE FUNCTION TGABA2() RETURNS TRIGGER AS $$
DECLARE
  --LEO 84337
  vCODUID_ATUAL VARCHAR(22);
  vBLQ_SEM_UID  TT_CFG.BLQ_SEM_UID%TYPE;
  vSESSIONID    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');
BEGIN

  IF (TG_OP = 'DELETE') THEN
    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3160 --*/
CREATE TRIGGER TGABA2
BEFORE DELETE ON TT_ABA 
FOR EACH ROW EXECUTE PROCEDURE TGABA2();


/*-- SEQ 3161 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGABM() CASCADE;

/*-- SEQ 3162 --*/
CREATE OR REPLACE FUNCTION TGABM() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN:=ProximoCodigo('TT_ABM',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3163 --*/
CREATE TRIGGER TGABM
BEFORE INSERT ON TT_ABM 
FOR EACH ROW EXECUTE PROCEDURE TGABM();




/*-- SEQ 3164 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGACM2() CASCADE;

/*-- SEQ 3165 --*/
CREATE OR REPLACE FUNCTION TGACM2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Impede exclusão
-- 2) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 3) Permitir apenas alterações de SITMOV, DOCUME e OBSERV
-- 4) Atualiza DATINC
-- 5) Atualiza ATU_EM
-- 6) Atualiza FILUSU e CODUSU

  cDUMMY        VARCHAR(1);
  vComplemento  constant VARCHAR(100) := constante('complemento');
  bCalculaCusto boolean:=false;
  inRec         TT_ACM%ROWTYPE;
  
    
    QuemLogou TRetQuemLogou%ROWTYPE;
  -- Principal
BEGIN

   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20027 Nao e permitido deletar registros de ajuste de custo medio. %' , vComplemento;
   END IF;

   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN := ProximoCodigo('TT_ACM',NEW.CODFIL);
      END IF;
      NEW.DATINC := AGORA();
      
      NEW.ATU_EM := AGORA();
      
      select * into QuemLogou from DadosLogon();
      NEW.FILUSU := QuemLogou.FILUSU;
      NEW.CODUSU := QuemLogou.CODUSU; 

      bCalculaCusto:=true;      
   END IF;
   
  -- Impede alteracões
  IF (TG_OP = 'UPDATE') THEN
     IF (OLD.CODFIL <> NEW.CODFIL) OR
        (OLD.SEQUEN <> NEW.SEQUEN) OR
        (OLD.FILUSU <> NEW.FILUSU) OR
        (OLD.CODUSU <> NEW.CODUSU) OR
        (OLD.FILMAT <> NEW.FILMAT) OR
        (OLD.CODMAT <> NEW.CODMAT) OR
        (OLD.CODCOR <> NEW.CODCOR) OR
        (OLD.CODTAM <> NEW.CODTAM) OR
        (OLD.DATAJU <> NEW.DATAJU) OR
        (OLD.VLRAJU <> NEW.VLRAJU) OR
        (OLD.DATINC <> NEW.DATINC) THEN
       RAISE EXCEPTION 'PG-20012 Nao e possivel alterar registros de ajuste de custo medio. %' , vComplemento;
    END IF;
    
	 IF (Equal(OLD.SITMOV,NEW.SITMOV)<>1) then
		bCalculaCusto:=true;
	 END IF;    
  END IF;
  
  -- Força a gravação sem a hora
  IF NOT (TG_OP = 'DELETE') THEN
    NEW.DATAJU := TRUNC(NEW.DATAJU);
  END IF;
  
  -- Se mudou situação ou é inserção, atualiza CAL_CM e ATU_CM da TT_SAL
  IF bCalculaCusto THEN
		   inRec.CODFIL := NEW.CODFIL;
	   inRec.SEQUEN := NEW.SEQUEN;
	   inRec.DATAJU := NEW.DATAJU;
	   inRec.FILMAT := NEW.FILMAT;       
	   inRec.CODMAT := NEW.CODMAT;       
	   inRec.CODCOR := NEW.CODCOR;       
	   inRec.CODTAM := NEW.CODTAM;           
	   
	   cDUMMY := PC_ACM_AUX_UPDATE(inREC.DATAJU,
								   inREC.CODFIL,
								   inREC.FILMAT,
								   inREC.CODMAT,
								   inREC.CODCOR,
								   inREC.CODTAM);
	   	  END IF;   
   
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3166 --*/
CREATE TRIGGER TGACM2
BEFORE INSERT OR UPDATE OR DELETE ON TT_ACM 
FOR EACH ROW EXECUTE PROCEDURE TGACM2();



/*-- SEQ 3167 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGACR() CASCADE;

/*-- SEQ 3168 --*/
CREATE OR REPLACE FUNCTION TGACR() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
BEGIN
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    IF ISNULL(NEW.SEQUEN)='T' THEN
      NEW.SEQUEN:=ProximoCodigo('TT_ACR',NEW.CODFIL);
    END IF;
   NEW.DATINC := agora();
  END IF;

  -- Popula a coluna ATU_EM
  IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
     NEW.ATU_EM := agora();
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3169 --*/
CREATE TRIGGER TGACR
BEFORE INSERT OR UPDATE ON TT_ACR 
FOR EACH ROW EXECUTE PROCEDURE TGACR();

/*-- SEQ 3170 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGACR2() CASCADE;

/*-- SEQ 3171 --*/
CREATE OR REPLACE FUNCTION TGACR2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 2) Registrar mudanca dos dados num "log"
   vLOG    VARCHAR(4000)     := '';
   vFILUSU VARCHAR(3);
   vCODUSU VARCHAR(3);
   cNulo   CONSTANT CHAR(1)   := '0';
   CRLF    CONSTANT CHAR(1)   := CHR(10);
    
    QuemLogou TRetQuemLogou%ROWTYPE;
    WK_CODUID TT_UID.CODUID%TYPE;
BEGIN
  WK_CODUID := GetCoduidAtual();

  select * into QuemLogou from DadosLogon();
  vFILUSU := QuemLogou.FILUSU;
  vCODUSU := QuemLogou.CODUSU;

  -- Tratamento de "log"
  IF (TG_OP = 'DELETE') THEN
     DELETE FROM TL_ACR WHERE FILACR = OLD.CODFIL AND SEQACR = OLD.SEQUEN;
  END IF;

  -- Tratamento de log
  IF (TG_OP = 'INSERT') THEN
     vLOG := 'Inclusao';
     INSERT INTO TL_ACR (FILACR,SEQACR,ORIACR,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
          VALUES(NEW.CODFIL,NEW.SEQUEN,NEW.ORIACR,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);
  ELSIF (TG_OP = 'UPDATE') THEN

     IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
        vLOG := vLOG||'Filial da Anlise de Crdito: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
        vLOG := vLOG||'Sequenciador da Anlise de Crdito: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.FILCLI,NEW.FILCLI) <> 1 THEN
        vLOG := vLOG||'Filial do Cliente da Anlise de Crdito: de '||COALESCE(OLD.FILCLI,cNulo)||' para '||COALESCE(NEW.FILCLI,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.CODCLI,NEW.CODCLI) <> 1 THEN
        vLOG := vLOG||'Cdigo do Cliente da Anlise de Crdito: de '||COALESCE(OLD.CODCLI,cNulo)||' para '||COALESCE(NEW.CODCLI,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.PLACAS,NEW.PLACAS) <> 1 THEN
        vLOG := vLOG||'Placa do Veculo Abastecido: de '||COALESCE(OLD.PLACAS,cNulo)||' para '||COALESCE(NEW.PLACAS,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.FLGACR,NEW.FLGACR) <> 1 THEN
        vLOG := vLOG||'Situao da Anlise de Crdito: de '||COALESCE(OLD.FLGACR,cNulo)||' para '||COALESCE(NEW.FLGACR,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.FLGSER,NEW.FLGSER) <> 1 THEN
        vLOG := vLOG||'Situao da Consulta ao Serasa: de '||COALESCE(OLD.FLGSER,cNulo)||' para '||COALESCE(NEW.FLGSER,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATINC,NEW.DATINC) <> 1 THEN
        vLOG := vLOG||'Data Incluso da Anlise de Crdito: de '||COALESCE(to_char(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.ATU_EM,NEW.ATU_EM) <> 1 THEN
        vLOG := vLOG||'Data Alterao Anlise de Crdito: de '||COALESCE(to_char(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.FILAUT,NEW.FILAUT) <> 1 THEN
        vLOG := vLOG||'Filial do Usurio que Autorizou: de '||COALESCE(OLD.FILAUT,cNulo)||' para '||COALESCE(NEW.FILAUT,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.CODAUT,NEW.CODAUT) <> 1 THEN
        vLOG := vLOG||'Cdigo do Usurio que Autorizou: de '||COALESCE(OLD.CODAUT,cNulo)||' para '||COALESCE(NEW.CODAUT,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATAUT,NEW.DATAUT) <> 1 THEN
        vLOG := vLOG||'Data e hora da Autorizao: de '||COALESCE(to_char(OLD.DATAUT,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.DATAUT,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.CODBCO,NEW.CODBCO) <> 1 THEN
        vLOG := vLOG||'Cdigo do Banco do Cheque: de '||COALESCE(OLD.CODBCO,cNulo)||' para '||COALESCE(NEW.CODBCO,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.CODAGE,NEW.CODAGE) <> 1 THEN
        vLOG := vLOG||'Cdigo da Agncia do Cheque: de '||COALESCE(OLD.CODAGE,cNulo)||' para '||COALESCE(NEW.CODAGE,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.NUMCON,NEW.NUMCON) <> 1 THEN
        vLOG := vLOG||'Nmero da C/C do Cheque: de '||COALESCE(OLD.NUMCON,cNulo)||' para '||COALESCE(NEW.NUMCON,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.NUMCHE,NEW.NUMCHE) <> 1 THEN
        vLOG := vLOG||'Nmero do Cheque: de '||COALESCE(OLD.NUMCHE,cNulo)||' para '||COALESCE(NEW.NUMCHE,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SERCHE,NEW.SERCHE) <> 1 THEN
        vLOG := vLOG||'Srie do Cheque: de '||COALESCE(OLD.SERCHE,cNulo)||' para '||COALESCE(NEW.SERCHE,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.CDCMC7,NEW.CDCMC7) <> 1 THEN
        vLOG := vLOG||'Cdigo CMC7 do Cheque: de '||COALESCE(OLD.CDCMC7,cNulo)||' para '||COALESCE(NEW.CDCMC7,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.VLRCHE,NEW.VLRCHE) <> 1 THEN
        vLOG := vLOG||'Valor do Cheque: de '||COALESCE(OLD.VLRCHE,0)||' para '||COALESCE(NEW.VLRCHE,0)||CRLF;
     END IF;
     IF Equal(OLD.NUMDOC,NEW.NUMDOC) <> 1 THEN
        vLOG := vLOG||'Documento do Cheque: de '||COALESCE(OLD.NUMDOC,cNulo)||' para '||COALESCE(NEW.NUMDOC,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATSER,NEW.DATSER) <> 1 THEN
        vLOG := vLOG||'Data e hora da consulta ao Serasa: de '||COALESCE(to_char(OLD.DATSER,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.DATSER,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;
     --IF Equal(OLD.MOTSER,NEW.MOTSER) <> 1 THEN
     --   vLOG := vLOG||'Motivo de Negativao no Serasa: de '||COALESCE(OLD.MOTSER,cNulo)||' para '||COALESCE(NEW.MOTSER,cNulo)||CRLF;
     --END IF;
     --IF Equal(OLD.MOTLIM,NEW.MOTLIM) <> 1 THEN
     --   vLOG := vLOG||'Motivo da Restrio no Limite de Crdito: de '||COALESCE(OLD.MOTLIM,cNulo)||' para '||COALESCE(NEW.MOTLIM,cNulo)||CRLF;
     --END IF;
     --IF Equal(OLD.OBSERV,NEW.OBSERV) <> 1 THEN
     --   vLOG := vLOG||'Observao da Anlise de Crdito/Motivo da Reijeio: de '||COALESCE(OLD.OBSERV,cNulo)||' para '||COALESCE(NEW.OBSERV,cNulo)||CRLF;
     --END IF;
     --IF Equal(OLD.OBSERV,NEW.OBSERV) <> 1 THEN
     --   vLOG := vLOG||'Observao da Anlise de Crdito/Motivo da Reijeio: de '||COALESCE(OLD.OBSERV,cNulo)||' para '||COALESCE(NEW.OBSERV,cNulo)||CRLF;
     --END IF;
     IF Equal(OLD.ORIACR,NEW.ORIACR) <> 1 THEN
        vLOG := vLOG||'Origem com Domnio: de '||COALESCE(OLD.ORIACR,cNulo)||' para '||COALESCE(NEW.ORIACR,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.LIMACR,NEW.LIMACR) <> 1 THEN
        vLOG := vLOG||'Limite de Crdito: de '||COALESCE(OLD.LIMACR,0)||' para '||COALESCE(NEW.LIMACR,0)||CRLF;
     END IF;
     IF Equal(OLD.NOVLIM,NEW.NOVLIM) <> 1 THEN
        vLOG := vLOG||'Novo Limite: de '||COALESCE(OLD.NOVLIM,0)||' para '||COALESCE(NEW.NOVLIM,0)||CRLF;
     END IF;
     IF Equal(OLD.SENACR,NEW.SENACR) <> 1 THEN
        vLOG := vLOG||'Senha de Liberao: de '||COALESCE(OLD.SENACR,cNulo)||' para '||COALESCE(NEW.SENACR,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATCHR,NEW.DATCHR) <> 1 THEN
        vLOG := vLOG||'Data e hora da Emisso do Cheque: de '||COALESCE(to_char(OLD.DATCHR,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.DATCHR,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATCON,NEW.DATCON) <> 1 THEN
        vLOG := vLOG||'Data e hora do Incio da Conta: de '||COALESCE(to_char(OLD.DATCON,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.DATCON,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATVEN,NEW.DATVEN) <> 1 THEN
        vLOG := vLOG||'Data e hora do Vencimento do Cheque: de '||COALESCE(to_char(OLD.DATVEN,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.DATVEN,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;

     IF Equal(OLD.IMGCHR,NEW.IMGCHR) <> 1 THEN
        vLOG := vLOG||'Imagem do Cheque: de '||COALESCE(OLD.IMGCHR,cNulo)||' para '||COALESCE(NEW.IMGCHR, cNulo)||CRLF;
     END IF;

     IF ISNOTNULL(trim(vLOG)) = 'T' THEN
        -- cadastra o LOG.
        INSERT INTO TL_ACR (FILACR,SEQACR,ORIACR,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                 VALUES (NEW.CODFIL,NEW.SEQUEN,NEW.ORIACR,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);
     END IF;

     IF Equal(OLD.OBSERV,NEW.OBSERV) <> 1 THEN
        vLOG := 'Observao da Anlise de Crdito/Motivo da Rejeio';
        INSERT INTO TL_ACR (FILACR,SEQACR,ORIACR,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                 VALUES (NEW.CODFIL,NEW.SEQUEN,NEW.ORIACR,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);
        vLOG := OLD.OBSERV;
        INSERT INTO TL_ACR (FILACR,SEQACR,ORIACR,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                 VALUES (NEW.CODFIL,NEW.SEQUEN,NEW.ORIACR,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);
     END IF;

     IF Equal(OLD.MOTLIM,NEW.MOTLIM) <> 1 THEN
        vLOG := 'Motivo da Restrio no Limite de Crdito';
        INSERT INTO TL_ACR (FILACR,SEQACR,ORIACR,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                 VALUES (NEW.CODFIL,NEW.SEQUEN,NEW.ORIACR,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);
        vLOG := OLD.MOTLIM;
        INSERT INTO TL_ACR (FILACR,SEQACR,ORIACR,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                 VALUES (NEW.CODFIL,NEW.SEQUEN,NEW.ORIACR,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);
     END IF;

     IF Equal(OLD.MOTSER,NEW.MOTSER) <> 1 THEN
        vLOG := 'Motivo de Negativao no Serasa';
        INSERT INTO TL_ACR (FILACR,SEQACR,ORIACR,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                 VALUES (NEW.CODFIL,NEW.SEQUEN,NEW.ORIACR,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);
        vLOG := OLD.MOTSER;
        INSERT INTO TL_ACR (FILACR,SEQACR,ORIACR,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                 VALUES (NEW.CODFIL,NEW.SEQUEN,NEW.ORIACR,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);
     END IF;

     IF Equal(OLD.OBSCHE,NEW.OBSCHE) <> 1 THEN
        vLOG := 'Observao do Cheque';
        INSERT INTO TL_ACR (FILACR,SEQACR,ORIACR,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                 VALUES (NEW.CODFIL,NEW.SEQUEN,NEW.ORIACR,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);
        vLOG := OLD.OBSCHE;
        INSERT INTO TL_ACR (FILACR,SEQACR,ORIACR,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                 VALUES (NEW.CODFIL,NEW.SEQUEN,NEW.ORIACR,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);
     END IF;

  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3172 --*/
CREATE TRIGGER TGACR2
AFTER INSERT OR UPDATE OR DELETE ON TT_ACR 
FOR EACH ROW EXECUTE PROCEDURE TGACR2();


/*-- SEQ 3173 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGAFE() CASCADE;

/*-- SEQ 3174 --*/
CREATE OR REPLACE FUNCTION TGAFE() RETURNS TRIGGER AS $$
DECLARE
  QuemLogou TRetQuemLogou%ROWTYPE;
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN:=ProximoCodigo('TT_AFE',NEW.CODFIL);
    END IF;
    -- preenche dados do usurio de registro
    select * into QuemLogou from DadosLogon();
    IF ((NEW.FILREG IS NULL) AND (NEW.CODREG IS NULL)) THEN
      NEW.FILREG := QuemLogou.FILUSU;
      NEW.CODREG := QuemLogou.CODUSU;
    END IF;
    NEW.DATREG := agora();
  END IF;

  IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
     NEW.ATU_EM := agora(); 
     NEW.DATAFE := trunc(NEW.DATAFE);
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3175 --*/
CREATE TRIGGER TGAFE
BEFORE INSERT OR DELETE OR UPDATE ON TT_AFE 
FOR EACH ROW EXECUTE PROCEDURE TGAFE();


/*-- SEQ 3176 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGAGC() CASCADE;

/*-- SEQ 3177 --*/
CREATE OR REPLACE FUNCTION TGAGC() RETURNS TRIGGER AS $$
DECLARE
-- Tabela Agendamento de Compromissos Repetitivos
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Atualiza DATINC
-- 3) Atualiza ATU_EM
-- 4) Impedir exclusao
  
  vComplemento  VARCHAR(254) := constante('complemento'); 
  QuemLogou TRetQuemLogou%ROWTYPE;

-- Principal
BEGIN
  IF (TG_OP = 'DELETE') THEN
     RAISE EXCEPTION 'PG-20001 Nao e permitida a exclusao. %' , vComplemento;     
  END IF;

  IF (TG_OP = 'INSERT') THEN
     IF NEW.SEQUEN IS NULL THEN
        NEW.SEQUEN := ProximoCodigo('TL_CTF', NEW.CODFIL);
     END IF;
     select * into QuemLogou from DadosLogon();
     NEW.FILUSU := QuemLogou.FILUSU;
     NEW.CODUSU := QuemLogou.CODUSU;
     NEW.DATINC := agora();
  END IF;

  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     NEW.ATU_EM := agora();
  END IF;  

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3178 --*/
CREATE TRIGGER TGAGC
BEFORE INSERT OR DELETE OR UPDATE ON TT_AGC 
FOR EACH ROW EXECUTE PROCEDURE TGAGC();


/*-- SEQ 3179 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGAGE() CASCADE;

/*-- SEQ 3180 --*/
CREATE OR REPLACE FUNCTION TGAGE() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Obter FILUSU e CODUSU a partir do usuario logado
-- 2) Manter ATU_EM
  vComplemento CONSTANT VARCHAR(254):= constante('complemento');
  QuemLogou TRetQuemLogou%ROWTYPE;
BEGIN
  IF (TG_OP = 'INSERT') THEN
    -- Gera codigo sequencial
    IF (NEW.SEQUEN IS NULL) THEN
      NEW.SEQUEN:=ProximoCodigo('TT_AGE',NEW.CODFIL);
    END IF;
  END IF;

  IF (NEW.FILUSU IS NULL) OR (NEW.CODUSU IS NULL) THEN
    select * into QuemLogou from DadosLogon();
    -- Pega CODFIL e SEQUEN do usuario logado
    IF not QuemLogou.Encontrou THEN
      RAISE EXCEPTION 'PG-20050 Voce nao e um usuario cadastrado no sistema %' , vComplemento;
    END IF;  
    NEW.FILUSU := QuemLogou.FILUSU;
    NEW.CODUSU := QuemLogou.CODUSU;
  END IF;

  NEW.ATU_EM := agora();

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3181 --*/
CREATE TRIGGER TGAGE
BEFORE INSERT OR UPDATE ON TT_AGE 
FOR EACH ROW EXECUTE PROCEDURE TGAGE();


/*-- SEQ 3182 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGAGExUSU() CASCADE;

/*-- SEQ 3183 --*/
CREATE OR REPLACE FUNCTION TGAGExUSU() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
BEGIN
  IF (TG_OP = 'INSERT') THEN
    -- Gera codigo sequencial
    IF (NEW.SEQUEN IS NULL) THEN
      NEW.SEQUEN:=ProximoCodigo('TT_AGEXUSU',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3184 --*/
CREATE TRIGGER TGAGExUSU
BEFORE INSERT ON TT_AGExUSU 
FOR EACH ROW EXECUTE PROCEDURE TGAGExUSU();


/*-- SEQ 3185 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGANX() CASCADE;

/*-- SEQ 3186 --*/
CREATE OR REPLACE FUNCTION TGANX() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN:=ProximoCodigo('TT_ANX',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3187 --*/
CREATE TRIGGER TGANX
BEFORE INSERT ON TT_ANX 
FOR EACH ROW EXECUTE PROCEDURE TGANX();


/*-- SEQ 3188 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGAQV() CASCADE;

/*-- SEQ 3189 --*/
CREATE OR REPLACE FUNCTION TGAQV() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Gerar um cdigo sequencial exclusivo para compor a chave primria.
-- 2. Atualiza controles de data.

-- Declarao de variveis e cursores
   cCOMPLEMENTO                  CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.ID_AQV IS NULL THEN
         SELECT NEXTVAL('SQAQV') INTO NEW.ID_AQV FROM DUAL;
      END IF;
      NEW.DATINC := Agora();
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3190 --*/
CREATE TRIGGER TGAQV
BEFORE INSERT OR UPDATE OR DELETE ON TT_AQV 
FOR EACH ROW EXECUTE PROCEDURE TGAQV();


/*-- SEQ 3191 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGASS() CASCADE;

/*-- SEQ 3192 --*/
CREATE OR REPLACE FUNCTION TGASS() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Atualizar ATU_EM
-- Atualizar a coluna CODUID e ASSINA.

  --LEO 84337
  vCODUID_ATUAL VARCHAR(22);
  vBLQ_SEM_UID  TT_CFG.BLQ_SEM_UID%TYPE;
  vSESSIONID    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

BEGIN

  -- Atualizar ATU_EM
  NEW.ATU_EM := AGORA(); 
  
  vCODUID_ATUAL := GetCoduidAtual();
  
   -- LEO 84337
   SELECT BLQ_SEM_UID
     INTO vBLQ_SEM_UID
     FROM TT_CFG;  
  
  IF (TG_OP = 'INSERT') THEN
   
   IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
      RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
   END IF;
  
   -- Douglas - 83441 
   NEW.CODUID := vCODUID_ATUAL;	     
   NEW.ASSINA := COALESCE(AssinaTabela('TT_ASS', 
	                                    ConcatenaASS(NEW.NOMTAB,
                                                     NEW.QTDREG),
                                                  null, null, null),NEW.ASSINA);
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF ConcatenaASS(NEW.NOMTAB,NEW.QTDREG) <>
	    ConcatenaASS(OLD.NOMTAB,OLD.QTDREG) THEN
		
        IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
           RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
        END IF;
		
	    -- Douglas - 83441 
        NEW.CODUID := vCODUID_ATUAL;	     
        NEW.ASSINA := COALESCE(AssinaTabela('TT_ASS', 
	                                         ConcatenaASS(NEW.NOMTAB,
                                                          NEW.QTDREG),
                                                      OLD.CODUID,
	                                         ConcatenaASS(OLD.NOMTAB,
                                                          OLD.QTDREG),
                                                      OLD.ASSINA
                                                     ),NEW.ASSINA);
	 END IF; 											 
  END IF;  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3193 --*/
CREATE TRIGGER TGASS
BEFORE INSERT OR UPDATE ON TT_ASS 
FOR EACH ROW EXECUTE PROCEDURE TGASS();

/*-- SEQ 3194 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGASS2() CASCADE;

/*-- SEQ 3195 --*/
CREATE OR REPLACE FUNCTION TGASS2() RETURNS TRIGGER AS $$
DECLARE
  --LEO 84337
  vCODUID_ATUAL VARCHAR(22);
  vBLQ_SEM_UID  TT_CFG.BLQ_SEM_UID%TYPE;
  vSESSIONID    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

BEGIN

  IF (TG_OP = 'DELETE') THEN
    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3196 --*/
CREATE TRIGGER TGASS2
BEFORE DELETE ON TT_ASS 
FOR EACH ROW EXECUTE PROCEDURE TGASS2();


/*-- SEQ 3197 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGAUS() CASCADE;

/*-- SEQ 3198 --*/
CREATE OR REPLACE FUNCTION TGAUS() RETURNS TRIGGER AS $$
DECLARE
  -- Tratamento de usuario nao cadastrado
  -- Check de Permissao para alterar horas que nao sao suas.

  FILIAL    TT_USU.FILUSU%TYPE;
  USUARIO   TT_USU.CODUSU%TYPE;
  WK_PERMIS CHAR(1);
  QuemLogou TRetQuemLogou%ROWTYPE;
  vComplemento constant VARCHAR(100) := constante('complemento');

BEGIN
    
  -- Pega CODFIL e SEQUEN do usuario logado
  select * into QuemLogou from DadosLogon();
  IF ((QualDono() != GetApeUsuAtual()) AND (not QuemLogou.Encontrou)) THEN
    RAISE EXCEPTION 'PG-20051 Usuario nao esta cadastrado no Totali. %s' , vComplemento;
  END IF;
  
  Filial:=QuemLogou.FILUSU;
  Usuario:=QuemLogou.CODUSU;
  
  IF (TG_OP = 'INSERT') THEN
    IF (NEW.SEQUEN IS NULL) THEN
      NEW.SEQUEN:=ProximoCodigo('TT_AUS',NEW.CODFIL);
    END IF;    
  END IF;  

  IF (TG_OP = 'UPDATE') OR (TG_OP = 'DELETE') THEN
    IF (Equal(OLD.FILUSU,FILIAL) <> 1 )
    OR (Equal(OLD.CODUSU,USUARIO) <> 1) THEN

       SELECT SUBSTR(PERMISSOESUSUARIO(FILUSU,CODUSU),125,1) INTO WK_PERMIS FROM TT_USU
       WHERE FILUSU = Filial
         AND CODUSU = Usuario;

       if WK_PERMIS = 'N' THEN
          RAISE EXCEPTION 'PG-20050 Sem privilegio para alterar ou remover ausencias de outro usuario. %s' , vComplemento;
       END IF;

     END IF;
  END IF;

  IF (TG_OP = 'INSERT') THEN
    IF (Equal(NEW.FILUSU,FILIAL) <> 1 )
    OR (Equal(NEW.CODUSU,USUARIO) <> 1) THEN

       SELECT SUBSTR(PERMISSOESUSUARIO(FILUSU,CODUSU),125,1) INTO WK_PERMIS FROM TT_USU
       WHERE FILUSU = Filial
         AND CODUSU = Usuario;

       if WK_PERMIS = 'N' THEN
          RAISE EXCEPTION 'PG-20050 Sem privilegio para alterar ou remover ausencias de outro usuario. %s' , vComplemento;
       END IF;

     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3199 --*/
CREATE TRIGGER TGAUS
BEFORE INSERT OR DELETE OR UPDATE ON TT_AUS 
FOR EACH ROW EXECUTE PROCEDURE TGAUS();


/*-- SEQ 3200 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGAUT() CASCADE;

/*-- SEQ 3201 --*/
CREATE OR REPLACE FUNCTION TGAUT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN := ProximoCodigo('TT_AUT',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3202 --*/
CREATE TRIGGER TGAUT
BEFORE INSERT ON TT_AUT 
FOR EACH ROW EXECUTE PROCEDURE TGAUT();


/*-- SEQ 3203 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGAVA() CASCADE;

/*-- SEQ 3204 --*/
CREATE OR REPLACE FUNCTION TGAVA() RETURNS TRIGGER AS $$
DECLARE
  vComplemento CONSTANT VARCHAR(254):= constante('complemento');
  QuemLogou TRetQuemLogou%ROWTYPE;
-- Principal
BEGIN
  IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
    select * into QuemLogou from DadosLogon();
    IF not QuemLogou.Encontrou THEN
      RAISE EXCEPTION 'PG-20001 Voce nao e um usuario cadastrado no sistema %' , vComplemento;
    END IF;  
    IF (NEW.FILAVA||NEW.CODAVA <> QuemLogou.FILUSU||QuemLogou.CODUSU) THEN
      RAISE EXCEPTION 'PG-20002 Usuario avaliador e diferente do usuario logado no sistema %' , vComplemento;
    END IF;
  END IF;

  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODFIL IS NULL THEN
       NEW.CODFIL := NEW.FILWOR;
    END IF;
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN:=ProximoCodigo('TT_AVA',NEW.CODFIL);
    END IF;    
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3205 --*/
CREATE TRIGGER TGAVA
BEFORE INSERT OR UPDATE ON TT_AVA 
FOR EACH ROW EXECUTE PROCEDURE TGAVA();


/*-- SEQ 3206 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGAVI() CASCADE;

/*-- SEQ 3207 --*/
CREATE OR REPLACE FUNCTION TGAVI() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN := ProximoCodigo('TT_AVI',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3208 --*/
CREATE TRIGGER TGAVI
BEFORE INSERT ON TT_AVI 
FOR EACH ROW EXECUTE PROCEDURE TGAVI();


/*-- SEQ 3209 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGBICXECF() CASCADE;

/*-- SEQ 3210 --*/
CREATE OR REPLACE FUNCTION TGBICXECF() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
   cRet VARCHAR(2);
BEGIN
  IF (TG_OP = 'DELETE') THEN
     cRet := LogExclusao((TG_OP = 'DELETE'),'TT_BICXECF', OLD.codfil, OLD.sequen);
  END IF;
  IF (TG_OP = 'INSERT') THEN
     --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
     cRet := LogExclusao((TG_OP = 'DELETE'),'TT_BICXECF', NEW.codfil, NEW.sequen);
  END IF;
  IF NOT (TG_OP = 'DELETE') THEN
    NEW.ATU_EM := AGORA();
    -- Gera um codigo automaticamente
    IF (TG_OP = 'INSERT') THEN 
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN:=ProximoCodigo('TT_BICXECF',NEW.CODFIL);
      END IF;
    END IF;
    IF (TG_OP = 'UPDATE') THEN
       UPDATE TD_ECF SET ATU_EM = AGORA() WHERE CODTAB = NEW.CODECF;
       IF NEW.CODECF <> OLD.CODECF THEN
         UPDATE TD_ECF SET ATU_EM = AGORA() WHERE CODTAB = OLD.CODECF;
       END IF;
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3211 --*/
CREATE TRIGGER TGBICXECF
BEFORE INSERT OR UPDATE OR DELETE ON TT_BICXECF 
FOR EACH ROW EXECUTE PROCEDURE TGBICXECF();




/*-- SEQ 3212 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGBON2() CASCADE;

/*-- SEQ 3213 --*/
CREATE OR REPLACE FUNCTION TGBON2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Impedir a alteracao e exclusao
-- 3) Atualizar o saldo do cliente
--
  vComplemento constant VARCHAR(100) := constante('complemento');
  vVem_de_UNIAO_PARCEIROS  constant VARCHAR(1) := constante('UNIAO_PARCEIROS');
  vVem_de_RESGATE_BONUS  constant VARCHAR(1) := constante('RESGATE_BONUS');
BEGIN

  -- Impede exclusoes
  IF (TG_OP = 'DELETE') THEN
     RAISE EXCEPTION 'PG-20037 Nao e possivel excluir o bonus. %' , vComplemento;
  END IF;

  -- se nao vier da uniao de parceiros
  IF (Equal(NEW.DUMMY, vVem_de_UNIAO_PARCEIROS) <> 1) and (Equal(NEW.DUMMY, vVem_de_RESGATE_BONUS) <> 1)  THEN
    -- Impede alteracoes
    IF (TG_OP = 'UPDATE') THEN
      RAISE EXCEPTION 'PG-20036 Nao e permitido alterar o bonus. %' , vComplemento;
    END IF;
  END IF;

  -- Gera codigo sequencial
  IF (TG_OP = 'INSERT') THEN
     NEW.SEQUEN := ProximoCodigo('TT_BON',NEW.CODFIL);

     -- Atualiza saldo do cliente
     UPDATE tt_cli
        SET salbon = COALESCE(salbon,0) + NEW.VLRLAN
      WHERE filcli = NEW.FILCLI AND CODCLI = NEW.CODCLI;

     -- Valores "default"
     NEW.DATOPE := COALESCE(NEW.DATOPE,agora());
     NEW.DATINC := Agora();
  END IF;

  IF (NOT (TG_OP = 'DELETE')) THEN
    NEW.DUMMY := Null;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3214 --*/
CREATE TRIGGER TGBON2
BEFORE INSERT OR DELETE OR UPDATE ON TT_BON 
FOR EACH ROW EXECUTE PROCEDURE TGBON2();


/*-- SEQ 3215 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGBON_DW() CASCADE;

/*-- SEQ 3216 --*/
CREATE OR REPLACE FUNCTION TGBON_DW() RETURNS TRIGGER AS $$
DECLARE
  vComplemento  CONSTANT VARCHAR(100) := Constante('Complemento');

-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Vendas_Meio

BEGIN
  -- (TG_OP = 'INSERT'): no faz porque ainda no est em nenhuma venda
  -- (TG_OP = 'DELETE'): no faz para no violar FK e impedido por trigger
  IF (TG_OP = 'UPDATE') THEN
    IF Equal(OLD.FILREC,NEW.FILREC) <> 1 -- impedido por trigger a menos que seja unio de parceiros, porm, unio de parceiros apenas altera FILCLI, CODCLI
    OR Equal(OLD.SEQREC,NEW.SEQREC) <> 1 -- impedido por trigger a menos que seja unio de parceiros, porm, unio de parceiros apenas altera FILCLI, CODCLI
    OR Equal(OLD.NUMPAR,NEW.NUMPAR) <> 1 -- impedido por trigger a menos que seja unio de parceiros, porm, unio de parceiros apenas altera FILCLI, CODCLI
    OR Equal(OLD.SUBPAR,NEW.SUBPAR) <> 1 -- impedido por trigger a menos que seja unio de parceiros, porm, unio de parceiros apenas altera FILCLI, CODCLI
    THEN
      RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3217 --*/
CREATE TRIGGER TGBON_DW
AFTER UPDATE ON TT_BON 
FOR EACH ROW EXECUTE PROCEDURE TGBON_DW();


/*-- SEQ 3218 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGBONXCLI() CASCADE;

/*-- SEQ 3219 --*/
CREATE OR REPLACE FUNCTION TGBONXCLI() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
BEGIN
   -- Gera um codigo automaticamente
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN := ProximoCodigo('TT_BONXCLI',NEW.FILCLI);
      END IF;
   END IF;

   IF NOT (TG_OP = 'DELETE') THEN
      NEW.ATU_EM := AGORA();
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3220 --*/
CREATE TRIGGER TGBONXCLI
BEFORE INSERT ON TT_BONXCLI 
FOR EACH ROW EXECUTE PROCEDURE TGBONXCLI();

/*-- SEQ 3221 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGBONXCLI2() CASCADE;

/*-- SEQ 3222 --*/
CREATE OR REPLACE FUNCTION TGBONXCLI2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Registrar mudanca dos dados num "log"
   cLOG                          VARCHAR(4000)     := '';
   cLogChave                     VARCHAR(30)       := '';
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   
BEGIN
   -- Tratamento de log
   IF (TG_OP = 'INSERT') 
   OR (TG_OP = 'UPDATE') THEN
      cLogChave := 'Bônus Concedidos [' || NEW.SEQUEN || ']';
   END IF;
   IF (TG_OP = 'INSERT') THEN
      cLOG := 'Inclusão de ' || cLogChave;
   ELSIF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.FILCLI,NEW.FILCLI) <> 1 THEN
         cLOG := cLOG||'Filial: de '||COALESCE(OLD.FILCLI,cNulo)||' para '||COALESCE(NEW.FILCLI,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCLI,NEW.CODCLI) <> 1 THEN
         cLOG := cLOG||'Cod. Cli: de '||COALESCE(OLD.CODCLI,cNulo)||' para '||COALESCE(NEW.CODCLI,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
         cLOG := cLOG||'Sequenciador: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILVEN,NEW.FILVEN) <> 1 THEN
         cLOG := cLOG||'Filial do Vendedor: de '||COALESCE(OLD.FILVEN,cNulo)||' para '||COALESCE(NEW.FILVEN,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CLASS1,NEW.CLASS1) <> 1 THEN
         cLOG := cLOG||'1a Classe: de '||COALESCE(TO_CHAR(OLD.CLASS1),iNulo)||' para '||COALESCE(TO_CHAR(NEW.CLASS1),iNulo)||CRLF;
      END IF;
      IF Equal(OLD.CLASS2,NEW.CLASS2) <> 1 THEN
         cLOG := cLOG||'2a Classe: de '||COALESCE(TO_CHAR(OLD.CLASS2),iNulo)||' para '||COALESCE(TO_CHAR(NEW.CLASS2),iNulo)||CRLF;
      END IF;
      IF Equal(OLD.CLASS3,NEW.CLASS3) <> 1 THEN
         cLOG := cLOG||'3a Classe: de '||COALESCE(TO_CHAR(OLD.CLASS3),iNulo)||' para '||COALESCE(TO_CHAR(NEW.CLASS3),iNulo)||CRLF;
      END IF;
      IF Equal(OLD.CLASS4,NEW.CLASS4) <> 1 THEN
         cLOG := cLOG||'4a Classe: de '||COALESCE(TO_CHAR(OLD.CLASS4),iNulo)||' para '||COALESCE(TO_CHAR(NEW.CLASS4),iNulo)||CRLF;
      END IF;
      IF Equal(OLD.QTDVEN,NEW.QTDVEN) <> 1 THEN
         cLOG := cLOG||'Quant. Vendida: de '||COALESCE(OLD.QTDVEN,iNulo)||' para '||COALESCE(NEW.QTDVEN,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.QTDBON,NEW.QTDBON) <> 1 THEN
         cLOG := cLOG||'Quant. Bonificacao: de '||COALESCE(OLD.QTDBON,iNulo)||' para '||COALESCE(NEW.QTDBON,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.TIPPAR,NEW.TIPPAR) <> 1 THEN
         cLOG := cLOG||'Tipo de Parceiro: de '||COALESCE(OLD.TIPPAR,cNulo)||' para '||COALESCE(NEW.TIPPAR,cNulo)||CRLF;
      END IF;
      
      IF ISNOTNULL(cLOG) = 'T' THEN
         cLOG := cLogChave || ' >> ' || cLOG;
      END IF;
   END IF;
   IF (TG_OP = 'INSERT') 
   OR (TG_OP = 'UPDATE') THEN
      IF ISNOTNULL(cLOG) = 'T' THEN
         INSERT INTO TL_CLI (FILCLI,CODCLI,DATOPE,MSGLOG)
                     VALUES (NEW.FILCLI,NEW.CODCLI,agora(),cLOG);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3223 --*/
CREATE TRIGGER TGBONXCLI2
AFTER INSERT OR UPDATE ON TT_BONXCLI 
FOR EACH ROW EXECUTE PROCEDURE TGBONXCLI2();


/*-- SEQ 3224 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGBRU() CASCADE;

/*-- SEQ 3225 --*/
CREATE OR REPLACE FUNCTION TGBRU() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
    
    QuemLogou TRetQuemLogou%ROWTYPE;
  BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN := ProximoCodigo('TT_BRU',NEW.CODFIL);
    END IF;
    NEW.DATINC := AGORA();
    NEW.ATU_EM := AGORA();
  END IF;
  
  IF (TG_OP = 'UPDATE') THEN 
     NEW.ATU_EM := AGORA();
  END IF;
 
  IF (TG_OP = 'DELETE') THEN     
     RAISE EXCEPTION 'PG-20039 Nao e possivel excluir uma Receita Bruta.';
  END IF;
  
  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     select * into QuemLogou from DadosLogon();
     IF NEW.APROVA = 'T' THEN
        NEW.FILAUT := QuemLogou.FILUSU;
        NEW.CODAUT := QuemLogou.CODUSU;
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3226 --*/
CREATE TRIGGER TGBRU
BEFORE INSERT OR UPDATE OR DELETE ON TT_BRU 
FOR EACH ROW EXECUTE PROCEDURE TGBRU();

/*-- SEQ 3227 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGBRU2() CASCADE;

/*-- SEQ 3228 --*/
CREATE OR REPLACE FUNCTION TGBRU2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 2) Registrar mudanca dos dados num "log"
   vLOG    VARCHAR(4000)     := '';
   vFILUSU VARCHAR(3);    
   vCODUSU VARCHAR(3); 
   cNulo   CONSTANT CHAR(1)   := '0';
   CRLF    CONSTANT CHAR(1)   := CHR(10);  
    
    QuemLogou TRetQuemLogou%ROWTYPE;
    WK_CODUID TT_UID.CODUID%TYPE;
BEGIN 
  WK_CODUID := GetCoduidAtual();

  select * into QuemLogou from DadosLogon();
  vFILUSU := QuemLogou.FILUSU;
  vCODUSU := QuemLogou.CODUSU;
 
  -- Tratamento de "log"
  IF (TG_OP = 'DELETE') THEN
     DELETE FROM TL_BRU WHERE FILBRU = OLD.CODFIL AND SEQBRU = OLD.SEQUEN;
  END IF;

  -- Tratamento de log
  IF (TG_OP = 'INSERT') THEN
     vLOG := 'Inclusao';
     INSERT INTO TL_BRU (FILBRU,SEQBRU,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
          VALUES(NEW.CODFIL,NEW.SEQUEN,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);
  ELSIF (TG_OP = 'UPDATE') THEN

     IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
        vLOG := vLOG||'Filial da Receita Bruta: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
        vLOG := vLOG||'Sequncia da Receita Bruta: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATINC,NEW.DATINC) <> 1 THEN
        vLOG := vLOG||'Data Incluso da Receita Bruta: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
	 IF Equal(OLD.ATU_EM,NEW.ATU_EM) <> 1 THEN
        vLOG := vLOG||'Data Alterao da Receita Bruta: de '||COALESCE(TO_CHAR(OLD.ATU_EM,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ATU_EM,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.ANOREF,NEW.ANOREF) <> 1 THEN
        vLOG := vLOG||'Ano da Receita Bruta: de '||COALESCE(OLD.ANOREF,0)||' para '||COALESCE(NEW.ANOREF,0)||CRLF;
     END IF;
	 IF Equal(OLD.MESREF,NEW.MESREF) <> 1 THEN
        vLOG := vLOG||'Ms da Receita Bruta: de '||COALESCE(OLD.MESREF,0)||' para '||COALESCE(NEW.MESREF,0)||CRLF;
     END IF;
	 IF Equal(OLD.VLRBRU,NEW.VLRBRU) <> 1 THEN
        vLOG := vLOG||'Valor Bruto Apurado pelo Sistema da Receita Bruta: de '||COALESCE(OLD.VLRBRU,0)||' para '||COALESCE(NEW.VLRBRU,0)||CRLF;
     END IF;
	 IF Equal(OLD.VLRINF,NEW.VLRINF) <> 1 THEN
        vLOG := vLOG||'Valor Bruto Informado Manualmente da Receita Bruta: de '||COALESCE(OLD.VLRINF,0)||' para '||COALESCE(NEW.VLRINF,0)||CRLF;
     END IF;
	 IF Equal(OLD.APROVA,NEW.APROVA) <> 1 THEN
        vLOG := vLOG||'Aprovado da Receita Bruta: de '||COALESCE(OLD.APROVA,cNulo)||' para '||COALESCE(NEW.APROVA,cNulo)||CRLF;
     END IF;
	 IF Equal(OLD.FILAUT,NEW.FILAUT) <> 1 THEN
        vLOG := vLOG||'Filial do Usurio que Aprovou da Receita Bruta: de '||COALESCE(OLD.FILAUT,cNulo)||' para '||COALESCE(NEW.FILAUT,cNulo)||CRLF;
     END IF;
	 IF Equal(OLD.CODAUT,NEW.CODAUT) <> 1 THEN
        vLOG := vLOG||'Cdigo do Usurio que Aprovou da Receita Bruta: de '||COALESCE(OLD.CODAUT,cNulo)||' para '||COALESCE(NEW.CODAUT,cNulo)||CRLF;
     END IF;
	 IF Equal(OLD.NUMDOC,NEW.NUMDOC) <> 1 THEN
        vLOG := vLOG||'Radical do CNPJ da Receita Bruta: de '||COALESCE(OLD.NUMDOC,0)||' para '||COALESCE(NEW.NUMDOC,0)||CRLF;
     END IF;
	 
     IF ISNOTNULL(trim(vLOG)) = 'T' THEN
        -- cadastra o LOG.
        INSERT INTO TL_BRU (FILBRU,SEQBRU,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                 VALUES (NEW.CODFIL,NEW.SEQUEN,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);
     END IF;   
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3229 --*/
CREATE TRIGGER TGBRU2
AFTER INSERT OR UPDATE OR DELETE ON TT_BRU 
FOR EACH ROW EXECUTE PROCEDURE TGBRU2(); 


/*-- SEQ 3230 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGBSC() CASCADE;

/*-- SEQ 3231 --*/
CREATE OR REPLACE FUNCTION TGBSC() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    IF NEW.ID IS NULL THEN
      NEW.ID :=ProximoCodigo('TT_BSC',NEW.CODFIL);
    END IF;
    -- "default"
    IF NEW.DATINC IS NULL THEN
      NEW.DATINC := agora(); 
    END IF;
  END IF;
  
  -- Popula a coluna ATU_EM
  IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
     NEW.ATU_EM := agora();      
  END IF;
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3232 --*/
CREATE TRIGGER TGBSC
BEFORE INSERT ON TT_BSC 
FOR EACH ROW EXECUTE PROCEDURE TGBSC();


/*-- SEQ 3233 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCAI() CASCADE;

/*-- SEQ 3234 --*/
CREATE OR REPLACE FUNCTION TGCAI() RETURNS TRIGGER AS $$
DECLARE

-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primria

  vComplemento  VARCHAR(254); 

-- Principal
BEGIN

  vComplemento := constante('complemento');

  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
     NEW.SEQCAI := ProximoCodigo('TT_CAI',NEW.CODFIL);
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3235 --*/
CREATE TRIGGER TGCAI
BEFORE INSERT ON TT_CAI 
FOR EACH ROW EXECUTE PROCEDURE TGCAI();


/*-- SEQ 3236 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCAM() CASCADE;

/*-- SEQ 3237 --*/
CREATE OR REPLACE FUNCTION TGCAM() RETURNS TRIGGER AS $$
-- Objetivo:
-- Atualizar ATU_EM
DECLARE
   cRet                          VARCHAR(2);
BEGIN
   IF (TG_OP = 'DELETE') THEN
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_CAM', TO_CHAR(OLD.CODMOE), TO_CHAR(OLD.DATREF,'DD/MM/YYYY'));
   END IF;
   IF (TG_OP = 'INSERT') THEN
      --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_CAM', TO_CHAR(NEW.CODMOE), TO_CHAR(NEW.DATREF,'DD/MM/YYYY'));
   END IF;
   IF NOT (TG_OP = 'DELETE') THEN
      NEW.ATU_EM := AGORA();
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3238 --*/
CREATE TRIGGER TGCAM
BEFORE UPDATE OR INSERT OR DELETE ON TT_CAM 
FOR EACH ROW EXECUTE PROCEDURE TGCAM();

/*-- SEQ 3239 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCAM2() CASCADE;

/*-- SEQ 3240 --*/
CREATE OR REPLACE FUNCTION TGCAM2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3241 --*/
CREATE TRIGGER TGCAM2
AFTER INSERT OR UPDATE OR DELETE ON TT_CAM 
FOR EACH ROW EXECUTE PROCEDURE TGCAM2();


/*-- SEQ 3242 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCAR() CASCADE;

/*-- SEQ 3243 --*/
CREATE OR REPLACE FUNCTION TGCAR() RETURNS TRIGGER AS $$
DECLARE

-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primria
-- 2) Fazer um "update cascade" na tabela de volumes numa excluso
-- 3) Impedir alterao da chave primaria uma vez que no h foreig key com tt_vol

  proximo       CHAR(10);
  vComplemento  VARCHAR(254); 

-- Principal
BEGIN

  vComplemento := constante('complemento');

  IF (TG_OP = 'UPDATE') THEN
     IF (OLD.FILCAR <> NEW.FILCAR) OR
        (OLD.SEQUEN <> NEW.SEQUEN) THEN
        RAISE EXCEPTION 'PG-20006 Nao  permitido mudar a chave. %' , vComplemento;
     END IF;
  END IF;

  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
     NEW.SEQUEN := ProximoCodigo('TT_CAR',NEW.FILCAR);
  END IF;

  -- Update cascade
  IF (TG_OP = 'DELETE') THEN
     UPDATE TT_VOL 
        SET FILCAR = NULL, SEQCAR = NULL
      WHERE FILCAR = OLD.FILCAR
        AND SEQCAR = OLD.SEQUEN;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3244 --*/
CREATE TRIGGER TGCAR
BEFORE INSERT OR DELETE OR UPDATE ON TT_CAR 
FOR EACH ROW EXECUTE PROCEDURE TGCAR();


/*-- SEQ 3245 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCBP() CASCADE;

/*-- SEQ 3246 --*/
CREATE OR REPLACE FUNCTION TGCBP() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
   -- Gera um codigo automaticamente
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN := ProximoCodigo('TT_CBP',NEW.CODFIL);
      END IF;

      NEW.DATINC := AGORA();
      NEW.ATU_EM := AGORA();
   END IF;

   IF (TG_OP = 'UPDATE') THEN 
      NEW.ATU_EM := AGORA();
   END IF;
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3247 --*/
CREATE TRIGGER TGCBP
BEFORE INSERT OR UPDATE ON TT_CBP 
FOR EACH ROW EXECUTE PROCEDURE TGCBP();

/*-- SEQ 3248 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCBP2() CASCADE;

/*-- SEQ 3249 --*/
CREATE OR REPLACE FUNCTION TGCBP2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gravar log de alteraes em TL_CLI
   cLOG                          VARCHAR(4000)     := '';
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   WK_CODUID                     TT_UID.CODUID%TYPE; 
   cDESEND                       TD_END.DESEND%TYPE;
  
      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
   BEGIN
   WK_CODUID := GetCoduidAtual();

   select * into QuemLogou from DadosLogon();

   IF (TG_OP = 'INSERT') 
   OR (TG_OP = 'UPDATE') THEN
          SELECT DEND.DESEND 
            INTO cDESEND 
            FROM TT_END TEND 
      INNER JOIN TD_END DEND ON DEND.CODTAB = TEND.TIPEND
           WHERE TEND.CODFIL = NEW.FILEND AND TEND.NUMEND = NEW.NUMEND
             AND TEND.FILCLI = NEW.FILCLI AND TEND.CODCLI = NEW.CODCLI;
   END IF;
  
   IF (TG_OP = 'INSERT') THEN      
      cLOG := 'Incluso de Conta Bancria - Endereo ' || cDESEND || 
              ' - Banco: ' || NEW.CODBCO || ' - Ag.: ' || NEW.NUMAGE || ' - Conta: ' || NEW.CTACRR;      
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF (Equal(OLD.CODFIL,NEW.CODFIL) = 0) THEN
         cLOG := cLOG||'Cdigo da Filial: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.SEQUEN,NEW.SEQUEN) = 0) THEN
         cLOG := cLOG||'Sequenciador: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.DATINC,NEW.DATINC) = 0) THEN
         cLOG := cLOG||'Data de Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY'),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.ATU_EM,NEW.ATU_EM) = 0) THEN
         cLOG := cLOG||'Atualizado Em: de '||COALESCE(TO_CHAR(OLD.ATU_EM,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ATU_EM,'DD/MM/YYYY'),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.CODBCO,NEW.CODBCO) = 0) THEN
         cLOG := cLOG||'Cdigo do Banco: de '||COALESCE(OLD.CODBCO,cNulo)||' para '||COALESCE(NEW.CODBCO,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.CTACRR,NEW.CTACRR) = 0) THEN
         cLOG := cLOG||'Conta: de '||COALESCE(OLD.CTACRR,cNulo)||' para '||COALESCE(NEW.CTACRR,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.DIGCRR,NEW.DIGCRR) = 0) THEN
         cLOG := cLOG||'Digito Conta: de '||COALESCE(OLD.DIGCRR,cNulo)||' para '||COALESCE(NEW.DIGCRR,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.DIGA_C,NEW.DIGA_C) = 0) THEN
         cLOG := cLOG||'Digito Agencia/Conta: de '||COALESCE(OLD.DIGA_C,cNulo)||' para '||COALESCE(NEW.DIGA_C,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.NUMAGE,NEW.NUMAGE) = 0) THEN
         cLOG := cLOG||'Agncia: de '||COALESCE(OLD.NUMAGE,cNulo)||' para '||COALESCE(NEW.NUMAGE,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.DIGAGE,NEW.DIGAGE) = 0) THEN
         cLOG := cLOG||'Dgito Agncia: de '||COALESCE(OLD.DIGAGE,cNulo)||' para '||COALESCE(NEW.DIGAGE,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.FILCLI,NEW.FILCLI) = 0) THEN
         cLOG := cLOG||'Filial do Cliente: de '||COALESCE(OLD.FILCLI,cNulo)||' para '||COALESCE(NEW.FILCLI,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.CODCLI,NEW.CODCLI) = 0) THEN
         cLOG := cLOG||'Cdigo do Cliente: de '||COALESCE(OLD.CODCLI,cNulo)||' para '||COALESCE(NEW.CODCLI,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.FILEND,NEW.FILEND) = 0) THEN
         cLOG := cLOG||'Filial Endereo: de '||COALESCE(OLD.FILEND,cNulo)||' para '||COALESCE(NEW.FILEND,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.NUMEND,NEW.NUMEND) = 0) THEN
         cLOG := cLOG||'Nmero Endereo: de '||COALESCE(OLD.NUMEND,iNulo)||' para '||COALESCE(NEW.NUMEND,iNulo)||CRLF;
      END IF;

      IF ISNOTNULL(cLOG) = 'T' THEN
         cLOG := 'Conta Bancria do End. ' || cDESEND || 
                 ' [' || NEW.CODFIL || '-' || NEW.SEQUEN || '] >> ' || cLOG;
      END IF;
   END IF;
   
   IF (TG_OP = 'INSERT') 
   OR (TG_OP = 'UPDATE') THEN
      IF ISNOTNULL(cLOG) = 'T' THEN
         INSERT INTO TL_CLI (FILCLI, CODCLI, FILUSU, CODUSU, DATOPE, MSGLOG, CODUID)
                     VALUES (NEW.FILCLI, NEW.CODCLI, QuemLogou.FILUSU, QuemLogou.CODUSU, agora(), cLOG, WK_CODUID);
      END IF;
   END IF;
   
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3250 --*/
CREATE TRIGGER TGCBP2
AFTER INSERT OR UPDATE ON TT_CBP 
FOR EACH ROW EXECUTE PROCEDURE TGCBP2();


/*-- SEQ 3251 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCBS() CASCADE;

/*-- SEQ 3252 --*/
CREATE OR REPLACE FUNCTION TGCBS() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Tarefa  73454 --
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria.
BEGIN
  IF (TG_OP = 'INSERT') THEN
     IF NEW.SEQUEN IS NULL THEN
        NEW.SEQUEN := ProximoCodigo('TT_CBS', NEW.CODFIL);
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3253 --*/
CREATE TRIGGER TGCBS
BEFORE INSERT ON TT_CBS 
FOR EACH ROW EXECUTE PROCEDURE TGCBS();


/*-- SEQ 3254 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCCB() CASCADE;

/*-- SEQ 3255 --*/
CREATE OR REPLACE FUNCTION TGCCB() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Registrar mudanas dos dados na TT_CCB.

-- Declarao de variveis e cursores
   cLog                          VARCHAR(4000) := '';
   cFILUSU                       TT_USU.FILUSU%TYPE;
   cCODUSU                       TT_USU.CODUSU%TYPE;
   cNulo                         CONSTANT CHAR(04) := 'Nulo';
   iNulo                         CONSTANT Numeric(01) := 0;
   CRLF                          CONSTANT CHAR(01) := CHR(10);
   nCODUID                       TT_UID.CODUID%TYPE;
      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
   
-- Principal
BEGIN
   nCODUID := GetCoduidAtual();

   select * into QuemLogou from DadosLogon();
   cFILUSU := QuemLogou.FILUSU;
   cCODUSU := QuemLogou.CODUSU;

   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CARBCO,NEW.CARBCO) <> 1 THEN
         cLog := cLog||'Carteira no Banco: de '||COALESCE(OLD.CARBCO,iNulo)||' para '||COALESCE(NEW.CARBCO,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODBCO,NEW.CODBCO) <> 1 THEN
         cLog := cLog||'Cdigo do Banco: de '||COALESCE(OLD.CODBCO,cNulo)||' para '||COALESCE(NEW.CODBCO,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCCB,NEW.CODCCB) <> 1 THEN
         cLog := cLog||'Cdigo Carteira: de '||COALESCE(OLD.CODCCB,iNulo)||' para '||COALESCE(NEW.CODCCB,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.DESCCB,NEW.DESCCB) <> 1 THEN
         cLog := cLog||'Descrio da Carteira: de '||COALESCE(OLD.DESCCB,cNulo)||' para '||COALESCE(NEW.DESCCB,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CARCCB,NEW.CARCCB) <> 1 THEN
         cLog := cLog||'Caracterstica da Carteira: de '||COALESCE(OLD.CARCCB,cNulo)||' para '||COALESCE(NEW.CARCCB,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DTRBLQ,NEW.DTRBLQ) <> 1 THEN
         cLog := cLog||'Distribuio do Bloqueto: de '||COALESCE(OLD.DTRBLQ,cNulo)||' para '||COALESCE(NEW.DTRBLQ,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.EMIBLQ,NEW.EMIBLQ) <> 1 THEN
         cLog := cLog||'Emisso Bloqueto: de '||COALESCE(OLD.EMIBLQ,cNulo)||' para '||COALESCE(NEW.EMIBLQ,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FRMCAD,NEW.FRMCAD) <> 1 THEN
         cLog := cLog||'Forma de Cadastramento: de '||COALESCE(OLD.FRMCAD,cNulo)||' para '||COALESCE(NEW.FRMCAD,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TIPDOC,NEW.TIPDOC) <> 1 THEN
         cLog := cLog||'Tipo Documento: de '||COALESCE(OLD.TIPDOC,cNulo)||' para '||COALESCE(NEW.TIPDOC,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.LOCPAG,NEW.LOCPAG) <> 1 THEN
         cLog := cLog||'Local de Pagamento: de '||COALESCE(OLD.LOCPAG,cNulo)||' para '||COALESCE(NEW.LOCPAG,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PREDES,NEW.PREDES) <> 1 THEN
         cLog := cLog||'Pr Desconto?: de '||COALESCE(OLD.PREDES,cNulo)||' para '||COALESCE(NEW.PREDES,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ENVNOS,NEW.ENVNOS) <> 1 THEN
         cLog := cLog||'Indica se o sistema deve enviar o Nosso-Nmero para o banco: de '||COALESCE(OLD.ENVNOS,cNulo)||' para '||COALESCE(NEW.ENVNOS,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.GERSGR,NEW.GERSGR) <> 1 THEN
         cLog := cLog||'Gera Segmento R no CNAB 240?: de '||COALESCE(OLD.GERSGR,cNulo)||' para '||COALESCE(NEW.GERSGR,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCRB,NEW.CODCRB) <> 1 THEN
         cLog := cLog||'Cdigo na Lista de Carteiras de Banco: de '||COALESCE(OLD.CODCRB,iNulo)||' para '||COALESCE(NEW.CODCRB,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.DEDTAX,NEW.DEDTAX) <> 1 THEN
         cLog := cLog||'Deduz Taxa do Ttulo?: de '||COALESCE(OLD.DEDTAX,cNulo)||' para '||COALESCE(NEW.DEDTAX,cNulo)||CRLF;
      END IF;

      IF ISNOTNULL(TRIM(cLog)) = 'T' THEN
         INSERT INTO TL_CCB (CODBCO, CODCCB, FILUSU, CODUSU, MSGLOG, CODUID)
                     VALUES (NEW.CODBCO, NEW.CODCCB, cFILUSU, cCODUSU, cLog, nCODUID);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3256 --*/
CREATE TRIGGER TGCCB
AFTER UPDATE ON TT_CCB 
FOR EACH ROW EXECUTE PROCEDURE TGCCB();

/*-- SEQ 3257 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCCB2() CASCADE;

/*-- SEQ 3258 --*/
CREATE OR REPLACE FUNCTION TGCCB2() RETURNS TRIGGER AS $$
-- Objetivos:
-- 1. Atualiza controles de data.
  
-- Principal
BEGIN
   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') THEN
      NEW.DATINC := Agora();
   END IF;
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3259 --*/
CREATE TRIGGER TGCCB2
BEFORE INSERT OR UPDATE OR DELETE ON TT_CCB 
FOR EACH ROW EXECUTE PROCEDURE TGCCB2();

/*-- SEQ 3260 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCCB3() CASCADE;

/*-- SEQ 3261 --*/
CREATE OR REPLACE FUNCTION TGCCB3() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3262 --*/
CREATE TRIGGER TGCCB3
AFTER INSERT OR DELETE OR UPDATE ON TT_CCB 
FOR EACH ROW EXECUTE PROCEDURE TGCCB3();




/*-- SEQ 3263 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCCC2() CASCADE;

/*-- SEQ 3264 --*/
CREATE OR REPLACE FUNCTION TGCCC2() RETURNS TRIGGER AS $$
DECLARE
   vAspa                         CONSTANT CHAR(1) := CHR(39);
   vComplemento                  CONSTANT VARCHAR(100) := constante('complemento');
   vAux                          CHAR;
   vLOG                          VARCHAR(4000)   := '';
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1) := CHR(10);
   inRec                         TT_CCC%ROWTYPE;
   inRec2                        TT_CCC%ROWTYPE;
   vVLRSALDO                     TT_LIM.VSALDO%TYPE;

      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
   
   vFILDIF                       TT_CTA.CODFIL%TYPE;
   vSEQDIF                       TT_CTA.SEQUEN%TYPE;
   vTIPDIF                       TT_CTA.TIPCTA%TYPE;
   vFILTRN                       TT_CTA.CODFIL%TYPE;
   vSEQTRN                       TT_CTA.SEQUEN%TYPE;
   vTIPTRN                       TT_CTA.TIPCTA%TYPE;
   vFILCTA_CCC                   TT_CTA.CODFIL%TYPE;
   vSEQCTA_CCC                   TT_CTA.SEQUEN%TYPE;
   vTIPCTA_CCC                   TT_CTA.TIPCTA%TYPE;
   vSEQFIN                       TT_FIN.SEQUEN%type;
   cDUMMY                        VARCHAR(10);
   WK_CODUID                     TT_UID.CODUID%TYPE;

   cOLD_FILCLI_DE                TL_CCC.FILCLI_DE%TYPE;
   cOLD_CODCLI_DE                TL_CCC.CODCLI_DE%TYPE;
   cOLD_TIPCCC_DE                TL_CCC.TIPCCC_DE%TYPE;
   cOLD_FILCLI_PARA              TL_CCC.FILCLI_PARA%TYPE;
   cOLD_CODCLI_PARA              TL_CCC.CODCLI_PARA%TYPE;
   cOLD_TIPCCC_PARA              TL_CCC.TIPCCC_PARA%TYPE;

   oldDESCCC                     TD_CCC.DESCCC%TYPE; --rodrigo 56112
   newDESCCC                     TD_CCC.DESCCC%TYPE; --rodrigo 56112

BEGIN

  -- Objetivo:
  -- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
  -- 2) Impedir a alteracao e exclusao

  -- MN - 2023065617	- Na devoluo, quando a nota  inutilizada, pode ser possvel excluir a atualizar a Conta Corrente
  --                   O middleware seta essa flag na unit TTUTransacaoSaveDao
  IF (TG_OP = 'INSERT') OR ((TG_OP = 'UPDATE') AND COALESCE(NEW.COMPLE, 'X') <> 'VEM_DE_DEVOLUCAO') OR ((TG_OP = 'DELETE') AND COALESCE(OLD.COMPLE, 'X') <> 'VEM_DE_DEVOLUCAO') THEN
     -- Impede alteracoes de determinadas colunas
      IF (TG_OP = 'UPDATE') THEN
         IF (OLD.CODFIL <> NEW.CODFIL) or
            (OLD.SEQUEN <> NEW.SEQUEN) or
            (OLD.DATOPE <> NEW.DATOPE) or
   --        (OLD.NUMDOC <> NEW.NUMDOC) or --PTulio f2 davi 33620
            (OLD.FILUSU <> NEW.FILUSU) or
            (OLD.CODUSU <> NEW.CODUSU) or
   --        (OLD.VLRLAN <> NEW.VLRLAN) or -- PTulio f2 Daniel 001/ 33619
   --        (OLD.TIPCCC <> NEW.TIPCCC) or -- PTulio f2 Daniel 001/ 33619
   --        (OLD.COMPLE <> NEW.COMPLE) OR --PTulio f2 davi 33620
   --        (OLD.PLACAS <> NEW.PLACAS) OR --PTulio f2 davi 33620
            (COALESCE(OLD.OLDSTT,'##') <> COALESCE(NEW.OLDSTT,'##')) or
   --        (((OLD.FILCLI <> NEW.FILCLI) or   --davi - ptulio - 37080 - 04/08/05
   --          (OLD.CODCLI <> NEW.CODCLI)) and COALESCE(NEW.dummy,'##')<>CONSTANTE('VEM_DE_TGVEN')) or
            (COALESCE(OLD.CODVEN,'##') <> COALESCE(NEW.CODVEN,'##')) or
            (COALESCE(OLD.SEQVEN,'##') <> COALESCE(NEW.SEQVEN,'##')) or
            (COALESCE(OLD.NUMPAR,'##') <> COALESCE(NEW.NUMPAR,'##')) or
            (COALESCE(OLD.SUBPAR,'##') <> COALESCE(NEW.SUBPAR,'##')) THEN
            RAISE EXCEPTION 'PG-20036 Nao e % permitido alterar esta conta corrente. %' , vAspa,vComplemento;
         END IF;

         -- PTulio f2 Daniel
         IF ((OLD.FILCLI <> NEW.FILCLI) or
             (OLD.CODCLI <> NEW.CODCLI)) and
             NEW.status='P' then
            RAISE EXCEPTION 'PG-20040 Nao e % permitido alterar o cliente de uma conta corrente paga. %' , vAspa,vComplemento;
         END IF;

         -- Tranfere o valor de um cliente para outro ou de uma conta para outra
         -- Altera Saldo na Alterao do "Valor do Lanamento" ou ao alterar a Flag "Atualiza limite de saldo"
         IF (OLD.TIPCCC <> NEW.TIPCCC)
         OR (OLD.FILCLI <> NEW.FILCLI)
         OR (OLD.CODCLI <> NEW.CODCLI)
         OR (OLD.VLRLAN <> NEW.VLRLAN)
         OR (OLD.ATULIM <> NEW.ATULIM) THEN
            IF (OLD.ATULIM = 'T') THEN
               UPDATE TT_LIM SET VSALDO = COALESCE(VSALDO,0) - OLD.VLRLAN,
                                DUMMY=CONSTANTE('VEM_DE_TGCCC')
                WHERE FILCLI = OLD.FILCLI
                  AND CODCLI = OLD.CODCLI
                  AND TIPCCC = OLD.TIPCCC;
            END IF;

            IF TGR_ExisteLimite(NEW.FILCLI,NEW.CODCLI,NEW.TIPCCC) THEN
               IF (NEW.ATULIM = 'T') THEN
                   UPDATE TT_LIM SET VSALDO = COALESCE(VSALDO,0) + NEW.VLRLAN,
                                    DUMMY=CONSTANTE('VEM_DE_TGCCC')
                    WHERE FILCLI = NEW.FILCLI
                      AND CODCLI = NEW.CODCLI
                      AND TIPCCC = NEW.TIPCCC;
               END IF;
            ELSE
               vAux := TGR_IncluiLimite(NEW.FILCLI,NEW.CODCLI,(CASE WHEN NEW.ATULIM = 'T' THEN NEW.VLRLAN ELSE 0 END),NEW.TIPCCC);
            END IF;
         END IF;

         IF (OLD.VLRLAN <> NEW.VLRLAN) THEN

            IF NEW.VLRORI IS NULL THEN
               NEW.VLRORI := OLD.VLRLAN;
            END IF;

            --Conta de Diferenca
                            SELECT USU.FILDIF, USU.SEQDIF, USU.TIPDIF
                  INTO vFILDIF, vSEQDIF, vTIPDIF
                  FROM TT_USU USU
                 WHERE USU.FILUSU = NEW.FILUSU
                   AND USU.CODUSU = NEW.CODUSU;
            
            IF vFILDIF IS NULL THEN
              RAISE EXCEPTION 'PG-20040  Usurio sem conta de diferena. Cadastre uma conta de diferena para este usurio e tente novamente.%' , vComplemento;
            END IF;

            --Conta de Transferencia (M)
            select CFG.FILCTA_TRN, CFG.SEQCTA_TRN, CFG.TIPCTA_TRN INTO vFILTRN, vSEQTRN, vTIPTRN
              from tt_cfg cfg;

            --Conta da CCC (N)
            select FILCCC, SEQCCC, TIPCCC INTO vFILCTA_CCC, vSEQCTA_CCC, vTIPCTA_CCC
              from TD_CCC
             WHERE CODTAB=NEW.TIPCCC;

            IF vTIPDIF = 'G' THEN
               --Conta gerencial -> Numeraria (1 lanamento)
               INSERT INTO TT_FIN (CODFIL, FILUSU, CODUSU, DATOPE,
                                   FILNUM, SEQNUM, TIPNUM,
                                   FILGER, SEQGER, TIPGER,
                                   VLRMOV, OBSERV, NUMDOC, FLGFIN,
                                   FILCCC, SEQCCC, ORILAN)
                           VALUES (OLD.CODFIL, NEW.FILUSU, NEW.CODUSU, AGORA(),
                                   vFILCTA_CCC, vSEQCTA_CCC, vTIPCTA_CCC,
                                   vFILDIF    , vSEQDIF    , vTIPDIF,
                                   (OLD.VLRLAN-NEW.VLRLAN)*-1,
                                   'ALTERACAO NO VALOR DE LANCAMENTO CC:'||NEW.FILCLI||'-'||NEW.CODCLI||'/'||NEW.TIPCCC,
                                   'DIFERENCA CCC','S',
                                   NEW.CODFIL, NEW.SEQUEN,'I');
            ELSE
               select proximocodigo('TT_FIN',OLD.CODFIL) into VSEQFIN from dual;
               --Conta Numeraria -> Numeraria (2 lanamentos)
               INSERT INTO TT_FIN (CODFIL, SEQUEN, FILUSU, CODUSU, DATOPE,
                                   FILNUM, SEQNUM, TIPNUM,
                                   FILGER, SEQGER, TIPGER,
                                   VLRMOV, OBSERV, NUMDOC, FLGFIN,
                                   FILCCC, SEQCCC, ORILAN)
                           VALUES (OLD.CODFIL, VSEQFIN, NEW.FILUSU, NEW.CODUSU, AGORA(),
                                   vFILCTA_CCC, vSEQCTA_CCC, vTIPCTA_CCC,
                                   vFILTRN, vSEQTRN, vTIPTRN,
                                   (OLD.VLRLAN-NEW.VLRLAN),
                                   'ALTERACAO NO VALOR DE LANCAMENTO CC:'||NEW.FILCLI||'-'||NEW.CODCLI||'/'||NEW.TIPCCC,
                                   'DIFERENCA CCC','S',
                                   NEW.CODFIL, NEW.SEQUEN, 'I');
               INSERT INTO TT_FIN (CODFIL, FILUSU, CODUSU, DATOPE,
                                   FILNUM, SEQNUM, TIPNUM,
                                   FILGER, SEQGER, TIPGER,
                                   VLRMOV, OBSERV, NUMDOC, FLGFIN, SEQTRN,
                                   FILCCC, SEQCCC, ORILAN)
                           VALUES (OLD.CODFIL, NEW.FILUSU, NEW.CODUSU, AGORA(),
                                   vFILDIF, vSEQDIF, vTIPDIF,
                                   vFILTRN, vSEQTRN, vTIPTRN,
                                   (OLD.VLRLAN-NEW.VLRLAN) * -1,
                                  'ALTERACAO NO VALOR DE LANCAMENTO CC:'||NEW.FILCLI||'-'||NEW.CODCLI||'/'||NEW.TIPCCC,
                                  'DIFERENCA CCC','S',VSEQFIN,
                                  NEW.CODFIL, NEW.SEQUEN, 'I');
            END IF;
         END IF;
         -- FIM PTulio f2 Daniel
      END IF;

      -- Impede exclusoes
      IF (TG_OP = 'DELETE') THEN
         RAISE EXCEPTION 'PG-20037 Nao e % possivel excluir esta conta corrente. %' , vAspa,vComplemento;
      END IF;

         -- Gera codigo sequencial
         IF (TG_OP = 'INSERT') THEN
            if NEW.SEQUEN is null then
               NEW.SEQUEN := ProximoCodigo('TT_CCC',NEW.CODFIL);
            end if;

            -- Valores "default"
            NEW.DATINC := agora();
            NEW.DATOPE := COALESCE(NEW.DATOPE,agora());
            NEW.OLDSTT := NULL;
            IF NEW.DATFIS IS NULL THEN
              NEW.DATFIS := TRUNC(NEW.DATOPE); -- PTulio - davi - 27/04/05 - 33733
            END IF;
         END IF;

         -- Atualiza status
         IF (TG_OP = 'INSERT') THEN
         -- Gera auto-relacionamento de TT_CCC para lanamentos de descontos
           IF (NEW.FILCCC IS NULL) AND (NEW.COMPLE like 'Desconto ref ao debito:%') then
              NEW.FILCCC := SUBSTR(NEW.COMPLE,25,03);
              NEW.SEQCCC := LPAD(TRIM(SUBSTR(NEW.COMPLE,28,10)),10,' ');
              NEW.TIPREL := 'D';
           end if;
         -- Gera auto-relacionamento de TT_CCC para lanamentos de pagamento
           IF (NEW.FILCCC IS NULL) AND (NEW.COMPLE like 'Pgto ref ao debito:%') then
              NEW.FILCCC := SUBSTR(NEW.COMPLE,21,03);
              NEW.SEQCCC := LPAD(TRIM(SUBSTR(NEW.COMPLE,24,10)),10,' ');
              NEW.TIPREL := 'P';
            end if;


         -- Se esta faturando entao forca status = P
            IF (NEW.SEQFAT is NOT NULL) AND (NEW.STATUS <> 'F') THEN
               NEW.STATUS := 'P';
               NEW.OLDSTT := 'P';
            END IF;

         -- Atualiza saldo do cliente
            IF TGR_ExisteLimite(NEW.FILCLI,NEW.CODCLI,NEW.TIPCCC) THEN
               IF (NEW.ATULIM = 'T') THEN
                  UPDATE TT_LIM SET VSALDO = COALESCE(VSALDO,0) + NEW.VLRLAN,
                                    DUMMY=CONSTANTE('VEM_DE_TGCCC')
                   WHERE FILCLI = NEW.FILCLI
                     AND CODCLI = NEW.CODCLI
                     AND TIPCCC = NEW.TIPCCC;
               END IF;
            ELSE
               vAux := TGR_IncluiLimite(NEW.FILCLI,NEW.CODCLI,(CASE WHEN NEW.ATULIM = 'T' THEN NEW.VLRLAN ELSE 0 END),NEW.TIPCCC);
            END IF;

        ELSIF (TG_OP = 'UPDATE') THEN
         -- Se esta faturando entao forca status = P
            IF  (OLD.SEQFAT is NULL)
            AND (NEW.SEQFAT is NOT NULL)
            AND (OLD.STATUS <> 'F') THEN
                 NEW.OLDSTT := OLD.STATUS;
                 NEW.STATUS := 'P';
            END IF;

          -- Se esta cancelando faturamento entao forca status para o valor salvo
            IF  (OLD.SEQFAT is NOT NULL)
            AND (NEW.SEQFAT is NULL)
            AND (OLD.STATUS <> 'F') THEN
                 NEW.STATUS := OLD.OLDSTT;
            ELSE
               IF (NEW.STATUS = 'A' AND OLD.STATUS = 'P') THEN
                  RAISE EXCEPTION 'PG-20038 Nao e % possivel reabrir um lancamento pago. %' , vAspa,vComplemento;
               END IF;
            END IF;

         -- Nao permite mudar status="F"
            IF (OLD.STATUS = 'F' AND NEW.STATUS <> 'F') THEN
                NEW.STATUS := 'F';
            END IF;
         END IF;

         --davi - ptulio - 37080 - 04/08/05 - LOG
         IF (TG_OP = 'UPDATE') THEN
            IF (Equal(OLD.FILCLI,NEW.FILCLI) = 0 OR
                Equal(OLD.CODCLI,NEW.CODCLI) = 0) THEN
               vLOG := vLOG||'Cliente: de '||COALESCE(OLD.FILCLI||'/'||TRIM(OLD.CODCLI),'Nulo')||' para '||COALESCE(NEW.FILCLI||'/'||TRIM(NEW.CODCLI),'Nulo')||CRLF;
               cOLD_FILCLI_DE := OLD.FILCLI;
               cOLD_CODCLI_DE := OLD.CODCLI;
               cOLD_FILCLI_PARA := NEW.FILCLI;
               cOLD_CODCLI_PARA := NEW.CODCLI;
            END IF;

            IF (Equal(OLD.VLRLAN,NEW.VLRLAN) = 0) THEN
              vLOG := vLOG||'Valor do lanamento: de '||TO_CHAR(COALESCE(OLD.VLRLAN,0),'fm9G999G999G990D00')||' para '||TO_CHAR(COALESCE(NEW.VLRLAN,0),'fm9G999G999G990D00')||CRLF;
            END IF;

            IF (Equal(OLD.TIPCCC,NEW.TIPCCC) = 0) THEN

              SELECT DESCCC
                INTO oldDESCCC
                FROM TD_CCC
               WHERE CODTAB = OLD.TIPCCC;

               SELECT DESCCC
                 INTO newDESCCC
                 FROM TD_CCC
                WHERE CODTAB = NEW.TIPCCC;

               vLOG := vLOG||'Tipo: de '||oldDESCCC||' para '||newDESCCC||CRLF; --rodrigo 56112
               cOLD_TIPCCC_DE   := OLD.TIPCCC;
               cOLD_TIPCCC_PARA := NEW.TIPCCC;
            END IF;

            IF (Equal(OLD.OLDSTT,NEW.OLDSTT) = 0) THEN
              vLOG := vLOG||'Old Status: de '||COALESCE(OLD.OLDSTT,cNulo)||' para '||COALESCE(NEW.OLDSTT,cNulo)||CRLF;
            END IF;

            IF (Equal(OLD.STATUS,NEW.STATUS) = 0) THEN
               vLOG := vLOG||'Status: de '||COALESCE(DescricaoDominio('CCC','STATUS',OLD.STATUS),cNulo)||' para '||COALESCE(DescricaoDominio('CCC','STATUS',NEW.STATUS),cNulo)||CRLF;
            END IF;

            IF (Equal(OLD.COMPLE,NEW.COMPLE) = 0) THEN
               vLOG := vLOG||'Complemento: de '||COALESCE(OLD.COMPLE,cNulo)||' para '||COALESCE(NEW.COMPLE,cNulo)||CRLF;
            END IF;

            IF (Equal(OLD.FILFAT,NEW.FILFAT) = 0) THEN
               vLOG := vLOG||'Cod Faturamento: de '||COALESCE(OLD.FILFAT||OLD.SEQFAT,cNulo)||' para '||COALESCE(NEW.FILFAT||NEW.SEQFAT,cNulo)||CRLF;
            END IF;

            IF (Equal(OLD.PLACAS,NEW.PLACAS) = 0) THEN
               vLOG := vLOG||'Placas: de '||COALESCE(OLD.PLACAS,cNulo)||' para '||COALESCE(NEW.PLACAS,cNulo)||CRLF;
            END IF;

            IF (Equal(OLD.ATULIM,NEW.ATULIM) = 0) THEN
               vLOG := vLOG||'Atualiza limite de saldo: de '||COALESCE(OLD.ATULIM,cNulo)||' para '||COALESCE(NEW.ATULIM,cNulo)||CRLF;
            END IF;

            IF (Equal(OLD.DATINC,NEW.DATINC) <> 1) THEN
               vLOG := vLOG||'Data Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
            END IF;

            WK_CODUID := GetCoduidAtual();

            IF vLOG IS NOT NULL THEN
                select * into QuemLogou from DadosLogon();
                INSERT INTO TL_CCC (FILCCC,SEQCCC,FILUSU,CODUSU,DATOPE,MSGLOG,CODUID,FILCLI_DE,CODCLI_DE,TIPCCC_DE,FILCLI_PARA,CODCLI_PARA,TIPCCC_PARA)
                            VALUES (NEW.CODFIL,NEW.SEQUEN,QuemLogou.FILUSU,QuemLogou.CODUSU,agora(),vLog,WK_CODUID,cOLD_FILCLI_DE,cOLD_CODCLI_DE,cOLD_TIPCCC_DE,cOLD_FILCLI_PARA,cOLD_CODCLI_PARA,cOLD_TIPCCC_PARA);
            END IF;
         END IF;
         
         -- Se nao possuir Limite inclui o mesmo
         IF (TG_OP = 'INSERT') THEN
           -- No PostgreSQL nao se pode fazer update em uma trigger que altere a linha atual
           -- Por isso ele atualiza o status direto e o Oracle por Mutanting via package
            SELECT VSALDO INTO vVLRSALDO
              FROM TT_LIM
             WHERE FILCLI = NEW.FILCLI
               AND CODCLI = NEW.CODCLI
               AND TIPCCC = NEW.TIPCCC;

           -- Pedro E. Braga - 93852 - No era aplicado a condio NEW.STATUS='A',
           -- com isso ao gerar uma devoluo de Faturamente gerava o registro de estorno em aberto deixando assim
           -- o Saldo devedor do parceiro duplicado.
           -- analizando o processo em oracle o mesmo aplica as mesmas condies e no ocorria o problema descrito
           -- com isso apliquei a mesma regra e o problema foi sanado.
            IF (vVLRSALDO>=0) AND (NEW.VLRLAN<0) AND (NEW.STATUS='A') THEN
               NEW.STATUS='P';
            END IF;

            IF (vVLRSALDO>=0) AND (NEW.VLRLAN>0) AND (NEW.STATUS<>'F') THEN
               UPDATE TT_CCC
                  SET STATUS = 'P'
                WHERE FILCLI = NEW.FILCLI
                  AND CODCLI = NEW.CODCLI
                  AND TIPCCC = NEW.TIPCCC
                  AND VLRLAN < 0
                  AND STATUS = 'A';
            END IF;

         END IF;
      
                 
         -- MN - Preenche a FK da CCC para REC via package em oracle. Perceba que em oracle coloca na lista, e postgre
         -- executa direto, por esse motivo, em postgre deve ser tratada na trigger AFTER, para que tenha a TT_CCC criada
         -- para que ao atualizar a TT_REC no gere erro de FK_REC_CCC
         
        -- DN 45679 - Tabelas Financeiras
        IF (TG_OP = 'INSERT') THEN
           cDUMMY:=INSERE_LFIN_LAN('CCC',NEW.CODFIL,NEW.SEQUEN,'--','--');
        END IF;
        IF (TG_OP = 'UPDATE') THEN
           IF (Equal(OLD.STATUS,NEW.STATUS) <> 1) OR
              (Equal(OLD.DATOPE,NEW.DATOPE) <> 1) OR
              (Equal(OLD.VLRLAN,NEW.VLRLAN) <> 1) OR
              (Equal(OLD.FILCLI,NEW.FILCLI) <> 1) OR
              (Equal(OLD.CODCLI,NEW.CODCLI) <> 1) OR
              (Equal(OLD.CODVEN,NEW.CODVEN) <> 1) OR
              (Equal(OLD.SEQVEN,NEW.SEQVEN) <> 1) OR
              (Equal(OLD.NUMPAR,NEW.NUMPAR) <> 1) OR
              (Equal(OLD.SUBPAR,NEW.SUBPAR) <> 1) OR
              (Equal(OLD.FILFAT,NEW.FILFAT) <> 1) OR
              (Equal(OLD.SEQFAT,NEW.SEQFAT) <> 1) OR
              (Equal(OLD.NUMDOC,NEW.NUMDOC) <> 1) OR
              (Equal(OLD.DATFIS,NEW.DATFIS) <> 1) OR
              (Equal(OLD.TIPCCC,NEW.TIPCCC) <> 1) THEN
              cDUMMY:=INSERE_LFIN_LAN('CCC',NEW.CODFIL,NEW.SEQUEN,'--','--');
           END IF;

           --IF (Equal(OLD.FILFAT,NEW.FILFAT) <> 1)
           --OR (Equal(OLD.SEQFAT,NEW.SEQFAT) <> 1) THEN
           --              --   
           --   cDUMMY := PC_CCC_UPDATE(NEW.CODFIL,
           --                           NEW.SEQUEN,
           --                           NEW.FILCLI,
           --                           NEW.CODCLI,
           --                           NEW.TIPCCC,
           --                           'R',
           --                           NEW.FILRAT,
           --                           NEW.SEQRAT);
           --              --END IF;
        END IF;

         --Incio Controle do Indicador de Exportao
         IF (COALESCE(NEW.INDEXP, 'X') = 'I') THEN
            NEW.INDEXP := 'N';
         ELSE 
            NEW.INDEXP := 'E';
         END IF;
         -- Fim Controle do Indicador de Exportao

        IF NEW.NUMECF IS NOT NULL THEN
               SELECT PORECF INTO NEW.PORORI
                 FROM TD_ECF
                WHERE FILECF=NEW.CODFIL
                  AND NUMECF=NEW.NUMECF;
        END IF;

        IF NEW.PORORI IS NULL THEN
              -- portador
              SELECT COALESCE(LXF.CODCOB,LIM.CODCOB) INTO NEW.PORORI
                FROM TT_LIM LIM LEFT JOIN TT_LIMXFIL LXF ON LIM.FILCLI=LXF.FILCLI
                                                        AND LIM.CODCLI=LXF.CODCLI
                                                        AND LIM.TIPCCC=LXF.TIPCCC
                                                        AND LXF.CODFIL = NEW.CODFIL
               WHERE LIM.FILCLI = NEW.FILCLI
                 AND LIM.CODCLI = NEW.CODCLI
                 AND LIM.TIPCCC = NEW.TIPCCC;
        END IF;


        -- DN 45679 - Fim Tabelas Financeiras

        IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
           NEW.dummy:=NULL;
        END IF;
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3265 --*/
CREATE TRIGGER TGCCC2
BEFORE INSERT OR DELETE OR UPDATE ON TT_CCC 
FOR EACH ROW EXECUTE PROCEDURE TGCCC2();


/*-- SEQ 3266 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCCC3() CASCADE;

/*-- SEQ 3267 --*/
CREATE OR REPLACE FUNCTION TGCCC3() RETURNS TRIGGER AS $$
DECLARE
  -- Objetivo:
  -- 1) Atualizar o saldo do cliente
  -- 2) Criar limite de credito se nao existir
  vAux CHAR;
  cDUMMY                VARCHAR(10);
  inRec3                TT_CCC%ROWTYPE;
BEGIN
   -- Se nao possuir Limite inclui o mesmo
   IF (TG_OP = 'INSERT') THEN


      IF (NEW.PLACAS IS NOT NULL) THEN
         vAux := TGR_AtualizaSaldoNoVeiculo(NEW.PLACAS,NEW.CODFIL,NEW.SEQUEN,NEW.VLRLAN,NEW.TIPCCC);
      END IF;
   END IF;

   
   -- MN - Preenche a FK da CCC para REC via package em oracle, ou chama a funo direto em postgre
   IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN     
      IF NEW.CODVEN IS NOT NULL AND NEW.SEQVEN IS NOT NULL THEN
         inRec3.CODFIL := NEW.CODFIL;
         inRec3.SEQUEN := NEW.SEQUEN;
         inRec3.CODVEN := NEW.CODVEN;
         inRec3.SEQVEN := NEW.SEQVEN;
         inRec3.NUMPAR := NEW.NUMPAR;
         inRec3.SUBPAR := NEW.SUBPAR;
         inRec3.DUMMY  := 'R';

         -- MN - Postgre executa direto, pois no tem o problema de objeto mutante do oracle
         cDummy = PC_CCC2_Update(inREC3.CODFIL,
                                 inREC3.SEQUEN,
                                 inREC3.CODVEN,
                                 inREC3.SEQVEN,
                                 inREC3.NUMPAR,
                                 inREC3.SUBPAR);
         
      END IF;
   END IF;
   
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3268 --*/
CREATE TRIGGER TGCCC3
AFTER INSERT ON TT_CCC 
FOR EACH ROW EXECUTE PROCEDURE TGCCC3();




/*-- SEQ 3269 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCCX() CASCADE;

/*-- SEQ 3270 --*/
CREATE OR REPLACE FUNCTION TGCCX() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
BEGIN
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    IF ISNULL(NEW.SEQUEN)='T' THEN
      NEW.SEQUEN:=ProximoCodigo('TT_CCX',NEW.SEQUEN);
    END IF;
   NEW.DATINC := agora(); 
  END IF;

  -- Popula a coluna ATU_EM
  IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
     NEW.ATU_EM := agora();      
  END IF;
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3271 --*/
CREATE TRIGGER TGCCX
BEFORE INSERT OR UPDATE ON TT_CCX 
FOR EACH ROW EXECUTE PROCEDURE TGCCX();  


/*-- SEQ 3272 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCEE() CASCADE;

/*-- SEQ 3273 --*/
CREATE OR REPLACE FUNCTION TGCEE() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
      NEW.SEQUEN:=ProximoCodigo('TT_CEE',NEW.CODFIL);
    END IF;
    -- "default"
    NEW.DATINC := agora(); 
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3274 --*/
CREATE TRIGGER TGCEE
BEFORE INSERT ON TT_CEE 
FOR EACH ROW EXECUTE PROCEDURE TGCEE();


/*-- SEQ 3275 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCES() CASCADE;

/*-- SEQ 3276 --*/
CREATE OR REPLACE FUNCTION TGCES() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Define a data de incluso

-- Declarao de variveis e cursores

-- Principal
BEGIN

   IF (TG_OP = 'INSERT') THEN
      NEW.DATINC := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3277 --*/
CREATE TRIGGER TGCES
BEFORE INSERT ON TT_CES 
FOR EACH ROW EXECUTE PROCEDURE TGCES();


/*-- SEQ 3278 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCFC() CASCADE;

/*-- SEQ 3279 --*/
CREATE OR REPLACE FUNCTION TGCFC() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impede excluso.
-- 2. Atualiza controles de data.

-- Declarao de variveis e cursores
   cCOMPLEMENTO                  CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Impede excluso.
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20000 Registro no pode ser excludo. %' , cCOMPLEMENTO;
   END IF;

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      NEW.DATINC := Agora();
   END IF;


 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3280 --*/
CREATE TRIGGER TGCFC
BEFORE INSERT OR UPDATE OR DELETE ON TT_CFC 
FOR EACH ROW EXECUTE PROCEDURE TGCFC();




/*-- SEQ 3281 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCFG2() CASCADE;

/*-- SEQ 3282 --*/
CREATE OR REPLACE FUNCTION TGCFG2() RETURNS TRIGGER AS $$
DECLARE

-- Declarao de variveis e cursores
   vComplemento                  VARCHAR(254);
   cRet                          VARCHAR(2);
   --LEO 84337
   vCODUID_ATUAL                 VARCHAR(22);
   vBLQ_SEM_UID                  TT_CFG.BLQ_SEM_UID%TYPE;
   vSESSIONID                    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');
   -- Pedro E. Braga - 92722
   cRETORNO                      VARCHAR(4);

   
-- Principal
BEGIN
   vComplemento := constante('complemento');

   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20001 Registro de uso interno. Nao pode ser excluido';
   END IF;

   NEW.ATU_EM := AGORA();

   IF (TG_OP = 'UPDATE') THEN
      IF  ((OLD.VC_FILCLI <> NEW.VC_FILCLI)
      OR  (OLD.VC_CODCLI <> NEW.VC_CODCLI))
      AND (OLD.VC_FILCLI is NOT NULL) THEN
         RAISE EXCEPTION 'PG-20006 Nao se pode atribuir outro codigo para a venda ao consumidor. %' , vComplemento;
      END IF;

      IF (OLD.PAFECF_NROLAU <> NEW.PAFECF_NROLAU) OR
         (OLD.PAFECF_NOMCOM <> NEW.PAFECF_NOMCOM) OR
         (OLD.PAFECF_PRIARQ <> NEW.PAFECF_PRIARQ) OR
         (OLD.PAFECF_PRIARQ_MD5 <> NEW.PAFECF_PRIARQ_MD5) OR
         (OLD.PAFECF_OUTARQ <> NEW.PAFECF_OUTARQ) OR
         (OLD.PAFECF_ASSINA <> NEW.PAFECF_ASSINA) THEN
         RAISE EXCEPTION 'PG-20006 Informaes de PAF-ECF no podem ser alteradas. %' , vComplemento;
      END IF;
   END IF;

   -- Uma vez definido valores para os produtos de fotografia, no de pode
   -- mais muda-los. A trigger mantem os valores originais
   IF ((NEW.PAPHOCODREVELA IS NULL) AND (OLD.PAPHOCODREVELA IS NULL)) THEN
      NEW.PAPHOCODREVELA := OLD.PAPHOCODREVELA;
   END IF;
   IF ((NEW.PAPHOCODAMPLIA IS NULL) AND (OLD.PAPHOCODAMPLIA IS NULL)) THEN
      NEW.PAPHOCODAMPLIA := OLD.PAPHOCODAMPLIA;
   END IF;
   IF ((NEW.PAPHOCODREVAMP IS NULL) AND (OLD.PAPHOCODREVAMP IS NULL)) THEN
      NEW.PAPHOCODREVAMP := OLD.PAPHOCODREVAMP;
   END IF;
   IF ((NEW.PAPHOFILREVELA IS NULL) AND (OLD.PAPHOFILREVELA IS NULL)) THEN
      NEW.PAPHOFILREVELA := OLD.PAPHOFILREVELA;
   END IF;
   IF ((NEW.PAPHOFILAMPLIA IS NULL) AND (OLD.PAPHOFILAMPLIA IS NULL)) THEN
      NEW.PAPHOFILAMPLIA := OLD.PAPHOFILAMPLIA;
   END IF;
   IF ((NEW.PAPHOFILREVAMP IS NULL) AND (OLD.PAPHOFILREVAMP IS NULL)) THEN
      NEW.PAPHOFILREVAMP := OLD.PAPHOFILREVAMP;
   END IF;

   NEW.ATU_EM := AGORA();

   IF (TG_OP = 'UPDATE') THEN
      -- Esta instruo est gerando "mutante", vai ser necessrio criar um PACKAGE
      IF (COALESCE(OLD.PAPHOTO,'X') <> COALESCE(NEW.PAPHOTO,'X')) THEN
         
         cRet := PC_ATU_EM_Atualiza('TD_ECF',null);
                        END IF;

     IF ((OLD.FILPRE||OLD.CODPRE) <> (NEW.FILPRE||NEW.CODPRE)) THEN
        
        cRet := PC_ATU_EM_Atualiza('TT_PRE','FILPRE = '||chr(39)||OLD.FILPRE||chr(39)||' AND CODPRE = '||OLD.CODPRE);
                
        
        cRet := PC_ATU_EM_Atualiza('TT_PRE','FILPRE = '||chr(39)||NEW.FILPRE||chr(39)||' AND CODPRE = '||NEW.CODPRE);
                     END IF;

     -- Esta instruo est gerando "mutante", vai ser necessrio criar um PACKAGE
     IF (COALESCE( OLD.PAPHOFILREVELA || OLD.PAPHOCODREVELA, '-X-') <> COALESCE( NEW.PAPHOFILREVELA || NEW.PAPHOCODREVELA, '-X-')) THEN
        
        cRet := PC_ATU_EM_Atualiza('TT_GRA','FILMAT = '||chr(39)||OLD.PAPHOFILREVELA||chr(39)||' AND CODMAT = '||chr(39)||OLD.PAPHOCODREVELA||chr(39));
                
        
        cRet := PC_ATU_EM_Atualiza('TT_GRA','FILMAT = '||chr(39)||NEW.PAPHOFILREVELA||chr(39)||' AND CODMAT = '||chr(39)||NEW.PAPHOCODREVELA||chr(39));
                     END IF;

     IF (Equal(OLD.PaEstoqueVenda,NEW.PaEstoqueVenda) <> 1) THEN
        UPDATE TT_SAL SET ATU_EM = AGORA() WHERE CODMUL = NEW.PaEstoqueVenda;
     END IF;

     -- Esta instruo est gerando "mutante", vai ser necessrio criar um PACKAGE
     IF ((COALESCE( OLD.CICLOPRE,'X') <> COALESCE( NEW.CICLOPRE,'X'))
     OR (COALESCE( OLD.PAPHOTO,'X')  <> COALESCE( NEW.PAPHOTO,'X'))
     OR (COALESCE( OLD.PAPHOFILREVELA || OLD.PAPHOCODREVELA, '-X-') <> COALESCE( NEW.PAPHOFILREVELA || NEW.PAPHOCODREVELA, '-X-'))
     OR (COALESCE( OLD.PAPHOFILREVAMP || OLD.PAPHOCODREVAMP, '-X-') <> COALESCE( NEW.PAPHOFILREVAMP || NEW.PAPHOCODREVAMP, '-X-'))
     OR (COALESCE( OLD.PAPHOFILAMPLIA || OLD.PAPHOCODAMPLIA, '-X-') <> COALESCE( NEW.PAPHOFILAMPLIA || NEW.PAPHOCODAMPLIA, '-X-'))) THEN

        
        cRet := PC_ATU_EM_Atualiza('TT_PRE',null);
                
        
        cRet := PC_ATU_EM_Atualiza('TT_PRO',null);
                
     END IF;

     IF (OLD.VC_FILCLI||OLD.VC_CODCLI) <> (NEW.VC_FILCLI||NEW.VC_CODCLI) THEN
        UPDATE TT_CLI SET ATU_EM = AGORA() WHERE FILCLI = NEW.VC_FILCLI AND CODCLI = NEW.VC_CODCLI;
        UPDATE TT_CLI SET ATU_EM = AGORA() WHERE FILCLI = OLD.VC_FILCLI AND CODCLI = OLD.VC_CODCLI;
     END IF;

     -- RFMP 72339
     IF (Equal(OLD.PATH_BASE,NEW.PATH_BASE) <> 1) AND
        (ISNOTNULL(NEW.PATH_BASE) = 'T')
     THEN
        NEW.PATH_BASE := TRIM(NEW.PATH_BASE);
        -- RFMP 72339 - Append Trailing Backslash
        IF SUBSTR(NEW.PATH_BASE,LENGTH(NEW.PATH_BASE),1) <> CHR(92) THEN
           NEW.PATH_BASE := NEW.PATH_BASE || TO_PATH('/');
        END IF;
        NEW.RBPATH              := NEW.PATH_BASE || PATH_DEFAULT('TT_CFG','RBPATH');
        NEW.PATH_PROJETOS       := NEW.PATH_BASE || PATH_DEFAULT('TT_CFG','PATH_PROJETOS');
        NEW.PATH_ARQUIVOS       := NEW.PATH_BASE || PATH_DEFAULT('TT_CFG','PATH_ARQUIVOS');
        NEW.PATH_ANEXOS         := NEW.PATH_BASE || PATH_DEFAULT('TT_CFG','PATH_ANEXOS');
        NEW.PDA_PATH_IMPORTACAO := NEW.PATH_BASE || PATH_DEFAULT('TT_CFG','PDA_PATH_IMPORTACAO');
        NEW.PDA_PATH_EXPORTACAO := NEW.PATH_BASE || PATH_DEFAULT('TT_CFG','PDA_PATH_EXPORTACAO');
        NEW.DADOS_PATH_EXPORTA  := NEW.PATH_BASE || PATH_DEFAULT('TT_CFG','DADOS_PATH_EXPORTA');
        NEW.DADOS_PATH_IMPORTA  := NEW.PATH_BASE || PATH_DEFAULT('TT_CFG','DADOS_PATH_IMPORTA');
     END IF;

   IF (TG_OP = 'UPDATE') THEN
      -- Pedro E. Braga - 92722
      IF (Equal(OLD.FILCMP, NEW.FILCMP) <> 1)
      OR ((Equal(OLD.FPV_PRECO_SIMULADO, NEW.FPV_PRECO_SIMULADO) <> 1) AND (NEW.FPV_PRECO_SIMULADO = 'T'))  THEN
         cRETORNO := INSERE_MIFC('CFG',CAST(NEW.CODTAB AS VARCHAR));
      END IF;
   END IF;

   IF (TG_OP = 'DELETE') THEN
      -- LEO 84337
      vBLQ_SEM_UID  := NEW.BLQ_SEM_UID;
      vCODUID_ATUAL := GetCoduidAtual();
      IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;
   END IF;

   IF (TG_OP = 'INSERT') THEN

      -- LEO 84337
      vBLQ_SEM_UID  := NEW.BLQ_SEM_UID;
      vCODUID_ATUAL := GetCoduidAtual();
      IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;

      -- Douglas - 83441
      NEW.CODUID := GetCoduidAtual();
      NEW.PAFECF_ASSINA := COALESCE(AssinaTabela('TT_CFG',
                                                  ConcatenaCFG(NEW.CKPAPREDEC),
                                                  null, null, null),NEW.PAFECF_ASSINA);
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      -- Douglas - 83441
      IF ConcatenaCFG(NEW.CKPAPREDEC) <>
         ConcatenaCFG(OLD.CKPAPREDEC) THEN

         -- LEO 84337
         vBLQ_SEM_UID  := NEW.BLQ_SEM_UID;
         vCODUID_ATUAL := GetCoduidAtual();
         IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;

         NEW.CODUID := GetCoduidAtual();
         NEW.PAFECF_ASSINA := COALESCE(AssinaTabela('TT_CFG',
                                                     ConcatenaCFG(NEW.CKPAPREDEC),
                                                     OLD.CODUID,
                                                     ConcatenaCFG(OLD.CKPAPREDEC),
                                                     OLD.PAFECF_ASSINA
                                                    ),NEW.PAFECF_ASSINA);
      END IF;
   END IF;
END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3283 --*/
CREATE TRIGGER TGCFG2
BEFORE INSERT OR UPDATE OR DELETE ON TT_CFG 
FOR EACH ROW EXECUTE PROCEDURE TGCFG2();

/*-- SEQ 3284 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCFG3() CASCADE;

/*-- SEQ 3285 --*/
CREATE OR REPLACE FUNCTION TGCFG3() RETURNS TRIGGER AS $$
DECLARE

-- Declarao de variveis e cursores
   vPaPhoto                      TT_CFG.PaPhoto%TYPE;
   vPaPhoDuplo                   TT_CFG.PaPhoDuplo%TYPE;
   wk_individual                 Numeric(5);
   wk_exposicao                  Numeric(5);
   wk_revelacao                  Numeric(5);
   wk_ampliacao                  Numeric(5);
   wk_gra_revamp                 Numeric(5);
   wk_gra_revela                 Numeric(5);
   wk_gra_amplia                 Numeric(5);
   wk_revamp                     TT_PRO.CODMAT%TYPE;
   wk_revela                     TT_PRO.CODMAT%TYPE;
   wk_amplia                     TT_PRO.CODMAT%TYPE;
   wk_codloj                     TT_IDF.CODLOJ%TYPE;
   WK_CODTAB                     TD_DIV.CODTAB%TYPE;
   wk_path                       TT_CFG.PATH_BASE%TYPE;

-- Principal
BEGIN
   SELECT COUNT(*) AS QTD
     INTO WK_CODTAB
     FROM TD_DIV
    WHERE NOMDIV like 'Ampliao';


   SELECT PaPhoto,PaPhoDuplo, PAPHOCODREVELA, PAPHOCODAMPLIA, PAPHOCODREVAMP, PATH_BASE
     INTO vPaPhoto,vPaPhoDuplo, wk_revela, wk_amplia, wk_revamp, wk_path
     FROM TT_CFG;


   IF vPaPhoto = 'T' AND (wk_revela is null) AND (wk_amplia is null) AND (wk_revamp is null)
   AND (wk_codtab = 0) THEN

      -- CODIGO DA LOJA - Define o CODLOJ
      select codloj into wk_codloj from tt_idf;

      -- EXPOSICAO (Sub-Diviso) - Usado para Produto Rev/Amp e Revelacao

      -- +--------------+
      -- |12|15|24|27|36| Grade de sub-divises correspondentes a nmero de poses (exposies)
      -- +--------------+

      -- Obtem o maior indice disponivel
      select max(codtab)+1 into wk_exposicao  from td_sub;

      -- Cria novos indice se preciso
      INSERT INTO TD_IND (CODTAB)
      (SELECT wk_exposicao
         FROM DUAL
        WHERE wk_exposicao not in (SELECT CODTAB FROM TD_IND));

      -- Cria TD_SUB = Exposies
      INSERT INTO TD_SUB (CODTAB, SUBATI, NOMSUB, ORDSUB)
      VALUES (wk_exposicao,'T','Exposicoes',1);

      -- Cria TT_SUB para as Exposicoes
      INSERT INTO TT_SUB (CODITE, CODSUB, NOMITE, ORDSUB, NOMEXT, TAMPHO, QTDPHO)
      VALUES (to_number(ProximoCodigo('TT_SUB',wk_codloj)), wk_exposicao, '12', 1, '12', 1, 12);

      INSERT INTO TT_SUB (CODITE, CODSUB, NOMITE, ORDSUB, NOMEXT, TAMPHO, QTDPHO)
      VALUES (to_number(ProximoCodigo('TT_SUB',wk_codloj)), wk_exposicao, '15', 2, '15', 2, 15);

      INSERT INTO TT_SUB (CODITE, CODSUB, NOMITE, ORDSUB, NOMEXT, TAMPHO, QTDPHO)
      VALUES (to_number(ProximoCodigo('TT_SUB',wk_codloj)), wk_exposicao, '24', 3, '24', 3, 24);

      INSERT INTO TT_SUB (CODITE, CODSUB, NOMITE, ORDSUB, NOMEXT, TAMPHO, QTDPHO)
      VALUES (to_number(ProximoCodigo('TT_SUB',wk_codloj)), wk_exposicao, '27', 4, '27', 4, 27);

      INSERT INTO TT_SUB (CODITE, CODSUB, NOMITE, ORDSUB, NOMEXT, TAMPHO, QTDPHO)
      VALUES (to_number(ProximoCodigo('TT_SUB',wk_codloj)), wk_exposicao, '36', 5, '36', 5, 36);


      -- AMPLIAO (Diviso) - Usado para produto Rev/Amp e Ampliacao

      -- +-----+ Cria uma diviso chamada "Ampliao", que ser relacionada com
      -- |10x15| com a tabela de ampliaes (TD_AMP), conforme exemplos ao lado.
      -- |-----| Quando for inclusa uma nova TD_AMP a trigger da mesma gera a
      -- |18x21| correspondncia em TT_DIV e em TT_GRA (para os produtos Rev/Amp
      -- +-----+ e Revelao)

      -- Obtem o maior indice disponivel para ampliacao
      select max(codtab)+1 into wk_ampliacao from td_div;

      -- Cria novos indice se preciso
      INSERT INTO TD_IND (CODTAB)
      (SELECT wk_ampliacao
         FROM DUAL
        WHERE wk_ampliacao not in (SELECT CODTAB FROM TD_IND));

      -- Cria TD_DIV = ampliacao
      INSERT INTO TD_DIV (CODTAB, DIVATI, NOMDIV, ORDDIV)
      VALUES (wk_ampliacao,'T','Ampliao',1);

      -- Marca em TT_CFG
      UPDATE TT_CFG SET PaDivAmpliacao = wk_ampliacao;

      -- PRODUTO REVELAO

      -- +---+--------------+ O produto revelao utiliza uma diviso com um nico registro
      -- |   |12|15|24|27|36| que identifica revelao unitria de um filme. Esta revelao
      -- +---+--------------+ tem variao por nmero de poses do filme (exposies), definida
      -- | 1 |itens de grade| na tabela de sub-divises.
      -- +---+--------------+

      -- DIVISO REVELAO

      -- Obtem o maior indice disponivel para ampliacao
      select max(codtab)+1 into wk_revelacao from td_div;

      -- Cria novos indice se preciso
      INSERT INTO TD_IND (CODTAB)
      (SELECT wk_revelacao
         FROM DUAL
        WHERE wk_revelacao not in (SELECT CODTAB FROM TD_IND));

      -- Cria TD_DIV = ampliacao
      INSERT INTO TD_DIV (CODTAB, DIVATI, NOMDIV, ORDDIV)
      VALUES (wk_revelacao,'T','Revelao',1);

      INSERT INTO TT_DIV (CODITE, CODDIV, NOMITE, ORDDIV, NOMEXT)
      VALUES (to_number(ProximoCodigo('TT_DIV',wk_codloj)), wk_revelacao, '1', 1, '1');

      -- GRADE P/ REVELACAO

      -- Obtem o maior indice disponivel de grade
      select max(codtab)+1 into wk_gra_revela  from td_gra;

      -- Cria novos indice se preciso
      INSERT INTO TD_IND (CODTAB)
      (SELECT wk_gra_revela
         FROM DUAL
        WHERE wk_gra_revela not in (SELECT CODTAB FROM TD_IND));

      -- Cria TD_GRA para Exposicoes
      INSERT INTO TD_GRA (CODTAB, GRAATI, NOMGRA, CODDIV, CODSUB )
      VALUES (wk_gra_revela, 'T', 'Revelao', wk_revelacao, wk_exposicao);

      -- GRAVA PRODUTO REVELACAO

      wk_revela := lpad(TGR_WUSU_ProximoCodigo('PRO',wk_codloj,null),5,' ');

      INSERT INTO TT_PRO
      (FILMAT, CODMAT, DESMAT, UNIDAD, UNIFOR, RESIRR, TIPPRO, CLSXYZ, CODGRA, DESECF,
       ETIQUE, CLASS1, CLASS2, CLASS3, CLASS4, REFBAS, IMPKIT)
      (SELECT wk_codloj, wk_revela, 'REVELAO',
              0, 0, 0, 1, 2, wk_gra_revela, 'REVELAO', 0, 0, 0, 0, 0, 'REFBAS'||wk_revela, 'F'
        FROM DUAL);

      UPDATE TT_CFG SET PAPHOFILREVELA = wk_codloj, PAPHOCODREVELA = wk_revela;

      -- PRODUTO AMPLIACAO

      -- +-----+-----+ O produto ampliao utiliza uma diviso que  relacionada com
      -- |     |  1  | com o contedo da tabela de ampliaes (TD_AMP), replicada na
      -- +-----+-----+ tabela de divises (TT_DIV), veja para isto o item acima
      -- |10x15|itens| "AMPLIAO". As ampliaes so unitrias, e por isto tem um
      -- |-----|  de | item de sub-diviso (TT_DIV) fixo.
      -- |18x21|grade|
      -- +-----+-----+

      -- INDIVIDUAL (Sub-Diviso)

      -- Obtem o maior indice disponivel para individual
      select max(codtab)+1 into wk_individual from td_sub;

      -- Cria novos indice se preciso
      INSERT INTO TD_IND (CODTAB)
      (SELECT wk_individual
         FROM DUAL
        WHERE wk_individual not in (SELECT CODTAB FROM TD_IND));

      -- Cria TD_SUB = individual
      INSERT INTO TD_SUB (CODTAB, SUBATI, NOMSUB, ORDSUB)
      VALUES (wk_individual,'T','Individual',1);

      -- Cria TT_SUB para as individual
      INSERT INTO TT_SUB (CODITE, CODSUB, NOMITE, ORDSUB, NOMEXT, TAMPHO)
      VALUES (to_number(ProximoCodigo('TT_SUB',wk_codloj)), wk_individual, '1', 1, '1', 1);

      -- GRADE P/ AMPLIACAO

      -- Obtem o maior indice disponivel de grade
      select max(codtab)+1 into wk_gra_amplia  from td_gra;

      -- Cria novos indice se preciso
      INSERT INTO TD_IND (CODTAB)
      (SELECT wk_gra_amplia
         FROM DUAL
        WHERE wk_gra_amplia not in (SELECT CODTAB FROM TD_IND));

      -- Cria TD_GRA para Ampliacao
      INSERT INTO TD_GRA (CODTAB, GRAATI, NOMGRA, CODDIV, CODSUB )
      VALUES (wk_gra_amplia, 'T', 'Ampliao', wk_ampliacao, wk_individual);

      -- GRAVA PRODUTO AMPLIACAO

      wk_amplia := lpad(TGR_WUSU_ProximoCodigo('PRO',wk_codloj,null),5,' ');

      INSERT INTO TT_PRO
      (FILMAT, CODMAT, DESMAT, UNIDAD, UNIFOR, RESIRR, TIPPRO, CLSXYZ, CODGRA, DESECF,
       ETIQUE, CLASS1, CLASS2, CLASS3, CLASS4, REFBAS, DEPART,IMPKIT)
      (SELECT wk_codloj, wk_amplia, 'AMPLIAO',
              0, 0, 0, 1, 2, wk_gra_amplia, 'AMPLIAO', 0, 0, 0, 0, 0, 'REFBAS'||wk_amplia,0,'T'
         FROM DUAL);

       UPDATE TT_CFG SET PAPHOFILAMPLIA = wk_codloj, PAPHOCODAMPLIA = wk_amplia;

      -- PRODUTO REV/AMP

      -- +-----+--------------+ O produto revelao/ampliao utiliza uma diviso que 
      -- |     |12|15|24|27|36| relacionada com o contedo da tabela de ampliaes (TD_AMP),
      -- +-----+--------------+ replicada na tabela de divises (TT_DIV), veja para isto o
      -- |10x15|itens de grade| item acima  "AMPLIAO". As ampliaes tem variao por
      -- |-----|--------------| nmero de poses do filme (exposies), definida na tabela
      -- |18x21|itens de grade| de sub-divises.
      -- +-----+--------------+

      -- GRADE P/ REV/AMP

      -- Obtem o maior indice disponivel de grade
      select max(codtab)+1 into wk_gra_revamp from td_gra;

      -- Cria novos indice se preciso
      INSERT INTO TD_IND (CODTAB)
      (SELECT wk_gra_revamp
         FROM DUAL
        WHERE wk_gra_revamp not in (SELECT CODTAB FROM TD_IND));

        -- Cria TD_GRA para Exposicoes
        INSERT INTO TD_GRA (CODTAB, GRAATI, NOMGRA, CODDIV, CODSUB )
        VALUES (wk_gra_revamp, 'T', 'Revelao/Ampliao', wk_ampliacao, wk_exposicao);

      -- GRAVA PRODUTO REV/AMP

      wk_revamp := lpad(TGR_WUSU_ProximoCodigo('PRO',wk_codloj,null),5,' ');

      INSERT INTO TT_PRO
      (FILMAT, CODMAT, DESMAT, UNIDAD, UNIFOR, RESIRR, TIPPRO, CLSXYZ, CODGRA, DESECF,
       ETIQUE, CLASS1, CLASS2, CLASS3, CLASS4, REFBAS,IMPKIT)
      (SELECT wk_codloj, wk_revamp, 'REVELAO E AMPLIAO',
              0, 0, 0, 1, 2, wk_gra_revamp, 'REV. E AMP.', 0, 0, 0, 0, 0, 'REFBAS'||wk_revamp,'T'
         FROM DUAL);

      UPDATE TT_CFG SET PAPHOFILREVAMP = wk_codloj,PAPHOCODREVAMP = wk_revamp;

   END IF;

   -- Mantem em TD_SUP um numero de linhas correspondente a PaPhoDuplo
   DELETE FROM TD_DUP WHERE CODTAB > vPaPhoDuplo;

   INSERT INTO TD_DUP (CODTAB)
   (SELECT CODTAB FROM TD_IND
     WHERE CODTAB >= 1
       AND CODTAB <= vPaPhoDuplo
       AND CODTAB NOT IN (SELECT CODTAB FROM TD_DUP));

   -- Gera registros em TT_PHO para cada combinacao das tabelas de sub-itens.
   -- Para isto  feito propositadamente um produto cartesiano
   INSERT INTO TT_PHO
   (CODMAR,CODISO, CODPHO, CODEXP, CODTIP, CODDUP)
   (SELECT MAR.CODTAB AS CODMAR,
           ISO.CODTAB AS CODISO,
           PHO.CODTAB AS CODPHO,
           AMP.CODITE AS CODEXP,
           TIP.CODTAB AS CODTIP,
           DUP.CODTAB AS CODDUP
      FROM TD_MAR MAR, TD_ISO ISO, TD_PHO PHO,
           TD_TIP TIP, TD_DUP DUP,
           (SELECT SUB.CODITE
              FROM TT_GRA GRA, TT_SUB SUB
             WHERE SUB.CODITE = GRA.CODTAM
               AND (GRA.FILMAT, GRA.CODMAT) = (SELECT PAPHOFILREVELA, PAPHOCODREVELA FROM TT_CFG)) AMP
     WHERE (MAR.CODTAB, ISO.CODTAB, PHO.CODTAB,
            AMP.CODITE, TIP.CODTAB, DUP.CODTAB)
    NOT IN (SELECT CODMAR,CODISO, CODPHO, CODEXP, CODTIP, CODDUP
              FROM TT_PHO));

   -- RFMP 72339
   IF ISNOTNULL(wk_path) = 'T' THEN
      UPDATE TD_FIL SET PATCAR = wk_path || PATH_DEFAULT('TD_FIL','PATCAR',CODFIL);
      UPDATE TD_FIL SET PATPED = wk_path || PATH_DEFAULT('TD_FIL','PATPED',CODFIL);
      UPDATE TD_FIL SET PAT_AA = wk_path || PATH_DEFAULT('TD_FIL','PAT_AA',CODFIL);
      UPDATE TD_FIL SET PATNOT = wk_path || PATH_DEFAULT('TD_FIL','PATNOT',CODFIL);
      UPDATE TD_FIL SET PATCON = wk_path || PATH_DEFAULT('TD_FIL','PATCON',CODFIL);
      UPDATE TD_FIL SET PATTKE = wk_path || PATH_DEFAULT('TD_FIL','PATTKE',CODFIL);
      UPDATE TT_USU SET PATNDB = wk_path || PATH_DEFAULT('TT_USU','PATNDB');
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3286 --*/
CREATE TRIGGER TGCFG3
AFTER INSERT OR UPDATE ON TT_CFG 
FOR STATEMENT EXECUTE PROCEDURE TGCFG3();


/*-- SEQ 3287 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCFG5() CASCADE;

/*-- SEQ 3288 --*/
CREATE OR REPLACE FUNCTION TGCFG5() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3289 --*/
CREATE TRIGGER TGCFG5
AFTER INSERT OR UPDATE ON TT_CFG 
FOR EACH ROW EXECUTE PROCEDURE TGCFG5();

/*-- SEQ 3290 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCFG_DW() CASCADE;

/*-- SEQ 3291 --*/
CREATE OR REPLACE FUNCTION TGCFG_DW() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar log para view/tabela materializadas DW_Vendas_Cliente

-- Declarao de variveis e cursores
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');
BEGIN
   -- (TG_OP = 'INSERT'): No faz nada porque no est relacionado a nenhum registro pai
   -- (TG_OP = 'DELETE'): Garantido pela trigger
   -- (TG_OP = 'UPDATE'): Garantido pela trigger
   -- A coluna USA_VM_DECISOR no  controlada aqui porque quando o usurio ativar essa opo o sistema no deve popular imediatamente as views.
   IF (TG_OP = 'UPDATE') THEN
      IF NEW.USA_VM_DECISOR = 'T' THEN
         IF Equal(OLD.VC_FILCLI,NEW.VC_FILCLI) <> 1
         OR Equal(OLD.VC_CODCLI,NEW.VC_CODCLI) <> 1 THEN
            RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
         END IF;
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3292 --*/
CREATE TRIGGER TGCFG_DW
AFTER UPDATE ON TT_CFG 
FOR EACH ROW EXECUTE PROCEDURE TGCFG_DW();

/*-- SEQ 3293 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCFG_ASS() CASCADE;

/*-- SEQ 3294 --*/
CREATE OR REPLACE FUNCTION TGCFG_ASS() RETURNS TRIGGER AS $$
-- 83073
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN
   IF ExisteFilialNaUF('SC') THEN
      IF (TG_OP = 'INSERT') THEN
         UPDATE TT_ASS
            SET QTDREG = QTDREG + 1
          WHERE NOMTAB = 'TT_CFG';
      END IF;
      
      IF (TG_OP = 'DELETE') THEN
         UPDATE TT_ASS
            SET QTDREG = QTDREG - 1
          WHERE NOMTAB = 'TT_CFG';
      END IF;   
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3295 --*/
CREATE TRIGGER TGCFG_ASS
AFTER INSERT OR DELETE ON TT_CFG 
FOR EACH ROW EXECUTE PROCEDURE TGCFG_ASS();



/*-- SEQ 3296 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCHR2() CASCADE;

/*-- SEQ 3297 --*/
CREATE OR REPLACE FUNCTION TGCHR2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir exclusoes
-- 2) Impedir alteracoes em algumas colunas
-- 3) Permitir ou nao mudancas no estado (FLGEST) do cheque
-- 4) Gerar codigo sequencial exclusivo para compor a chave primaria
-- 5) Confirmar/estornar recebimentos (TT_REC)
-- 6) Lancar "log" quando preciso
-- 7) Obrigar o preenchimento da alinea se o cheque for devolvido
-- 8) Salva valor original do cheque (somente na primeira vez)
--
-- IMPORTANTE: se esta trigger passar a permitir alteracoes na chave primaria ou
--             exclusoes, sera preciso fazer o "update/delete cascade" em TL_CHR
--             ou impedir de faze-lo. Este cuidado e necessario porque TL_CHR
--             nao possui "foreign key" (ela foi eliminada para evitar o erro de
--             "mutating table")
DECLARE
   tem_log                       BOOLEAN := False;
   linha                         INTEGER;
   Nulo                          CONSTANT CHAR(1)   := '0';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   vLOG                          TL_CHR.MSGLOG%TYPE := '';
   vComplemento                  VARCHAR(254);
   vVem_de_TGVEN                 VARCHAR(254);
   vAux                          CHAR;
   vAspa                         CONSTANT CHAR(1) := CHR(39);
  
   cCOB_USA_SAC                  TT_CFG.COB_USA_SAC%TYPE;
   iCOB_DIAS_VENCTO              TT_CFG.COB_DIAS_VENCTO%TYPE;
 
   cCODFIL                       TT_SUP.CODFIL%TYPE;
   cSEQUEN                       TT_SUP.SEQUEN%TYPE;

   vFILDIF                       TT_CTA.CODFIL%TYPE;
   vSEQDIF                       TT_CTA.SEQUEN%TYPE;
   vTIPDIF                       TT_CTA.TIPCTA%TYPE;
   vAPEUSU                       TT_USU.APEUSU%TYPE;
   vFILTRN                       TT_CTA.CODFIL%TYPE;
   vSEQTRN                       TT_CTA.SEQUEN%TYPE;
   vTIPTRN                       TT_CTA.TIPCTA%TYPE;
   vFILCTA_CHR                   TT_CTA.CODFIL%TYPE;
   vSEQCTA_CHR                   TT_CTA.SEQUEN%TYPE;
   vTIPCTA_CHR                   TT_CTA.TIPCTA%TYPE;
   vSEQFIN                       TT_FIN.SEQUEN%type;
   --bCHEQUE_PAGA_PARCELA          CHAR(1);
   cDUMMY                        VARCHAR(10);

   
   
   wk_reg_chr                    record;
   
      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
   
 SupCobrancas CURSOR(pCODFIL TT_REC.CODFIL%TYPE,
           pSEQUEN TT_REC.SEQUEN%TYPE) IS
 SELECT SUP.CODFIL,SUP.SEQUEN
   FROM TT_CHR CHR INNER JOIN TT_COB COB ON CHR.CODFIL = COB.FILCHR
                                        AND CHR.SEQUEN = COB.SEQCHR                                        
                   INNER JOIN TT_SUP SUP ON COB.FILSUP=SUP.CODFIL
                                        AND COB.SEQSUP=SUP.SEQUEN
 WHERE SUP.SITUAC in ('A','N')
   AND CHR.CODFIL=pCODFIL
   AND CHR.SEQUEN=pSEQUEN;
  
BEGIN

  vComplemento  := constante('complemento');
  vVem_de_TGVEN := constante('vem_de_TGVEN');

  -- Impede exclusoes
  IF (TG_OP = 'DELETE') THEN
     RAISE EXCEPTION 'PG-20028 Um cheque nao pode ser excluido. %' , vComplemento;
  END IF;

  -- Valida ou nao as mudancas no "flag"
  IF (TG_OP = 'UPDATE') THEN
     IF (NEW.CODFIL <> OLD.CODFIL) OR
        (NEW.SEQUEN <> OLD.SEQUEN) THEN
        RAISE EXCEPTION 'PG-20029 Um cheque nao pode ser modificado. %' , vComplemento;
     END IF;
 
     IF ((OLD.FLGEST = 'X') AND (OLD.CODAGE <> NEW.CODAGE) AND (OLD.NUMCHE <> NEW.NUMCHE) AND (OLD.VLRCHE <> NEW.VLRCHE) AND (OLD.CODBCO <> NEW.CODBCO)
     AND (OLD.NUMCON <> NEW.NUMCON) AND (OLD.NUMDOC <> NEW.NUMDOC) AND (OLD.DATVEN <> NEW.DATVEN) AND (OLD.PORTAD <> NEW.PORTAD) AND (OLD.NUMDEP <> NEW.NUMDEP)
	 AND (OLD.SERCHE <> NEW.SERCHE) AND (OLD.DATFIS <> NEW.DATFIS) AND (OLD.PORORI <> NEW.PORORI) AND (OLD.TIPCOB <> NEW.TIPCOB) AND (OLD.SEQCAN <> NEW.SEQCAN)
	 AND (OLD.CODUSU <> NEW.CODUSU) AND (OLD.FILUSU <> NEW.FILUSU) AND (OLD.PAGAME <> NEW.PAGAME)) THEN
        RAISE EXCEPTION 'PG-20030 Um cheque cancelado nao pode ser modificado. %' , vComplemento;
     END IF;
 

     IF (NEW.FLGEST NOT IN ('A','X','U')) THEN
        /* DN - Retirado tratamento para facilitar a persistncia no Middleware
        IF    (OLD.FLGEST = 'A') AND (NEW.FLGEST NOT IN ('D','S','P'))      THEN
              RAISE EXCEPTION 'PG-20031 Um cheque em aberto so pode ser depositado, substituido ou pre-descontado. %' , vComplemento;
        ELSIF (OLD.FLGEST = 'U') AND (NEW.FLGEST NOT IN ('D','S','P'))      THEN
              RAISE EXCEPTION 'PG-20031 Um cheque em aberto so pode ser depositado, substituido ou pre-descontado. %' , vComplemento;
        ELSIF (OLD.FLGEST = 'D') AND (NEW.FLGEST NOT IN ('D','V','C'))      THEN
              RAISE EXCEPTION 'PG-20032 Um cheque depositado so pode ser devolvido ou compensado. %' , vComplemento;
        ELSIF (OLD.FLGEST = 'V') AND (NEW.FLGEST NOT IN ('V','D','S','B','I')) THEN
              RAISE EXCEPTION 'PG-20033 Um cheque devolvido so pode ser modificado para depositado, substituido, cobrado ou incobravel. %' , vComplemento;
        ELSIF (OLD.FLGEST = 'P') AND (NEW.FLGEST NOT IN ('P','V','C'))      THEN
              RAISE EXCEPTION 'PG-20034 Um cheque pre-descontado so pode ser devolvido ou compensado. %' , vComplemento;
        ELS */
        IF (OLD.FLGEST IN ('C','B','S')) AND (OLD.FLGEST <> NEW.FLGEST) THEN
              RAISE EXCEPTION 'PG-20035 Cheque compensado, cobrado ou substituido nao pode ter a sua situacao modificada. %' , vComplemento;
        END IF;
     END IF;

     IF (OLD.FLGEST = 'C' and NEW.FLGEST = 'C') 
     OR (OLD.FLGEST = 'B' and NEW.FLGEST = 'B')
     OR (OLD.FLGEST = 'I' and NEW.FLGEST = 'I') THEN
        IF (OLD.PAGAME <> NEW.PAGAME) OR
           (OLD.DATVEN <> NEW.DATVEN) THEN
           RAISE EXCEPTION 'PG-20038 Datas nao podem ser modificadas para cheques cobrados ou compensados. %' , vComplemento;
        END IF;
     END IF;    

  END IF;

  -- Obriga o preenchimento da alinea
  IF (NEW.FLGEST = 'V') AND (NEW.ALINEA IS NULL) THEN
      RAISE EXCEPTION 'PG-20039 Numa devolucao e % preciso informar a alinea. %' , vAspa,vComplemento;
  END IF;

  IF  (COALESCE(NEW.DUMMY,' ') = constante('VEM_DE_TGVEN')) 
  AND (NEW.FLGEST = 'X') THEN
     linha := 0;
     
         SELECT COUNT(*) INTO linha
       FROM TT_REC REC
      WHERE REC.FILREC = NEW.CODFIL
        AND REC.SEQCHE = NEW.SEQUEN
        AND REC.FLGEST != 'X';
       	


      IF linha > 0 THEN
         NEW.flgest := OLD.flgest;
      END IF;
  END IF;

  -- Gera sequenciador de cancelamento
  IF ((NEW.FLGEST = 'X') OR (NEW.FLGEST = 'S'))  AND (NEW.SEQCAN is null) THEN
     NEW.SEQCAN := ProximoCodigo('TT_CHR_CANCELAMENTO',NEW.CODFIL);
     -- Improvavel mas...
     IF (NEW.SEQCAN IS NULL) THEN
        RAISE EXCEPTION 'PG-20040 Falha na geracao do sequenciador de cancelamento. %' , vComplemento;
     END IF;
  END IF;


  -- Verifica data de pagamento
  IF (TG_OP = 'UPDATE') THEN
      IF  NEW.FLGEST IN ('B','I','C')
      AND (Equal(NEW.FLGEST, OLD.FLGEST) <> 1) THEN
         IF NEW.PAGAME IS NULL THEN
            RAISE EXCEPTION 'PG-20037 Data de pagamento nao foi informada. %' , vComplemento;
         END IF;
         --davi - ptulio - 37085 - 03/08/05
         NEW.DATFIS := COALESCE(NEW.DATFIS,COALESCE(OLD.DATFIS,trunc(NEW.DATOPE)));
         NEW.DATREA := agora();
      END IF;
  END IF;

  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
     -- NOTA ASSUMIR NA INCLUSAO FLGEST = "A" ...

     IF NEW.SEQUEN IS NULL THEN
        NEW.SEQUEN := ProximoCodigo('TT_CHR',NEW.CODFIL);
     END IF;

     NEW.DATINC := agora();
     -- Impede um valor original para o cheque num INSERT
     NEW.VLRORI := NULL;


     IF (NEW.NUMECF IS NOT NULL) and (NEW.PORORI IS NULL) THEN
         SELECT PORECF INTO NEW.PORORI
           FROM TD_ECF
          WHERE FILECF = NEW.CODFIL
            AND NUMECF = NEW.NUMECF;
     END IF;
 
  END IF;

  -- Determina acoes possiveis diante da mudanca de alguns valores
  IF (TG_OP = 'UPDATE') THEN
    -- Checa mudanca no documento, na data de vencimento ou nos valores
    IF Equal(OLD.CODBCO,NEW.CODBCO) <> 1 OR
       Equal(OLD.CODAGE,NEW.CODAGE) <> 1 OR
       Equal(OLD.NUMCON,NEW.NUMCON) <> 1 OR
       Equal(OLD.NUMCHE,NEW.NUMCHE) <> 1 OR
       Equal(OLD.DATVEN,NEW.DATVEN) <> 1 OR
       Equal(OLD.PAGAME,NEW.PAGAME) <> 1 OR
       Equal(OLD.VLRCHE,NEW.VLRCHE) <> 1 OR
       Equal(OLD.FILCLI,NEW.FILCLI) <> 1 OR
       Equal(OLD.PORTAD,NEW.PORTAD) <> 1 OR
       Equal(OLD.FLGEST,NEW.FLGEST) <> 1 OR
       Equal(OLD.CODCLI,NEW.CODCLI) <> 1 THEN
        tem_log := True;
     END IF;
     
     -- DANIEL 33618 PTULIOF2
     /*
     IF (((OLD.FILCLI <> NEW.FILCLI) or 
          (OLD.CODCLI <> NEW.CODCLI)) 
     and COALESCE(NEW.dummy,'##')<>CONSTANTE('VEM_DE_TGVEN')
     and COALESCE(NEW.dummy,'##')<>CONSTANTE('UNIAO_PARCEIROS')) THEN
          -- Somente se o cheque esta vinculado a parcela
               SELECT COUNT(*) INTO linha
                 FROM TT_REC REC
                WHERE REC.FILREC = NEW.CODFIL
                  AND REC.SEQCHE = NEW.SEQUEN
                  AND REC.FLGEST != 'X';
         IF (LINHA > 0) THEN
            RAISE EXCEPTION 'PG-20036 Nao e % permitido alterar o cliente de um cheque vinculado a parcela. %' , vAspa,vComplemento;
         END IF;
     END IF;  */
     -- DANIEL 33618 PTULIOF2
  
     -- Checa diferenca sobre o valor do cheque
     IF (OLD.VLRDIF IS NOT NULL) AND (NEW.FLGEST IN ('A','V','U')) THEN
        -- "Zera" diferenca
        NEW.VLRDIF := NULL;
        tem_log := True;
     ELSIF (OLD.VLRDIF <> NEW.VLRDIF) THEN
        IF (NEW.FLGEST NOT IN ('P','B','I')) THEN
          -- Impede mudanca
          NEW.VLRDIF := OLD.VLRDIF;
        ELSE
          tem_log := True;
        END IF;
     END IF;

    -- Salva valor original do cheque se for o caso
    IF (OLD.VLRCHE <> NEW.VLRCHE) AND (OLD.VLRORI IS NULL) THEN
      NEW.VLRORI := OLD.VLRCHE;
      tem_log := True;
    ELSE
      -- Nao deixa mudar
      NEW.VLRORI := OLD.VLRORI; 
    END IF;
    
/*  lanar a diferena como lanamento avulso financeiro  (PTulio) */
    
    IF Equal(OLD.VLRCHE,NEW.VLRCHE) <> 1 THEN 
	
    	select * into QuemLogou from DadosLogon();
    	
    	--Conta de diferena do CheckOut (N,G).
    	SELECT USU.FILDIF, 
    	       USU.SEQDIF,
    	       USU.TIPDIF,
               USU.APEUSU
    	  INTO vFILDIF, vSEQDIF, vTIPDIF, vAPEUSU  
    	  FROM TT_USU USU
    	 WHERE USU.FILUSU = NEW.FILUSU
    	   AND USU.CODUSU = NEW.CODUSU;
    	
    	IF  (vFILDIF IS NULL)
    	AND (vSEQDIF IS NULL)
    	AND (vTIPDIF IS NULL) THEN  
        RAISE EXCEPTION 'PG-20050 Usuario % sem conta diferenca. %' , vAPEUSU,vComplemento;
      END IF;

-- 443322   	   AND USU.FILUSU=QuemLogou.FILUSU
--    	   AND USU.CODUSU=QuemLogou.CODUSU;
    	   
        --Conta de Transferncia (M)
    	select CFG.FILCTA_TRN, CFG.SEQCTA_TRN, CFG.TIPCTA_TRN INTO vFILTRN, vSEQTRN, vTIPTRN
    	  from tt_cfg cfg;
    	
    	--Conta do cheque (N)
    	select FILCTA, SEQCTA, TIPCTA INTO vFILCTA_CHR, vSEQCTA_CHR, vTIPCTA_CHR
    	  from TD_COB
    	 WHERE CODTAB=NEW.PORTAD
    	   AND TIPCOB=NEW.TIPCOB;
    	  
    	IF vTIPDIF = 'G' THEN 
        	--Conta gerencial -> Numeraria (1 lanamento)
        	INSERT INTO TT_FIN (CODFIL, FILUSU, CODUSU, DATOPE,
        	                    FILNUM, SEQNUM, TIPNUM,
        	                    FILGER, SEQGER, TIPGER,
        			            VLRMOV, OBSERV, NUMDOC, FLGFIN,
                                FILCHR, SEQCHR, ORILAN)
        	            VALUES ( OLD.CODFIL, QuemLogou.FILUSU, QuemLogou.CODUSU, AGORA(),
        	             vFILCTA_CHR, vSEQCTA_CHR, vTIPCTA_CHR,
       		  	     vFILDIF    , vSEQDIF    , vTIPDIF,
        			     (OLD.VLRCHE-NEW.VLRCHE)*-1,
        			     'ALTERACAO NO VALOR DO CHEQUE:'||NEW.CODBCO||'.'||NEW.CODAGE||'.'||NEW.NUMCON||'.'||NEW.NUMCHE,
        			     'DIFERENCA CHEQUE','S',
                         NEW.CODFIL, NEW.SEQUEN, 'I');

    	ELSE

        	select proximocodigo('TT_FIN',OLD.CODFIL) into VSEQFIN from dual;
        	
        	--Conta Numeraria -> Numeraria (2 lanamentos)
        	INSERT INTO TT_FIN (CODFIL, SEQUEN, FILUSU, CODUSU, DATOPE,
        	                    FILNUM, SEQNUM, TIPNUM,
        	                    FILGER, SEQGER, TIPGER,
        			            VLRMOV, OBSERV, NUMDOC, FLGFIN,
                                FILCHR, SEQCHR, ORILAN)
        	            VALUES ( OLD.CODFIL, VSEQFIN, QuemLogou.FILUSU, QuemLogou.CODUSU, AGORA(),
        	             vFILCTA_CHR, vSEQCTA_CHR, vTIPCTA_CHR,
        	             vFILTRN, vSEQTRN, vTIPTRN,
        			     (OLD.VLRCHE-NEW.VLRCHE)*-1,
        			     'ALTERACAO NO VALOR DO CHEQUE:'||NEW.CODBCO||'.'||NEW.CODAGE||'.'||NEW.NUMCON||'.'||NEW.NUMCHE,
        			     'DIFERENCA CHEQUE','S',
                         NEW.CODFIL, NEW.SEQUEN,'I');
        			     	
        	INSERT INTO TT_FIN (CODFIL, FILUSU, CODUSU, DATOPE,
        	                    FILNUM, SEQNUM, TIPNUM,
        	                    FILGER, SEQGER, TIPGER,
        			            VLRMOV, OBSERV, NUMDOC, FLGFIN, SEQTRN,
                                FILCHR, SEQCHR, ORILAN)
        	            VALUES ( OLD.CODFIL, QuemLogou.FILUSU, QuemLogou.CODUSU, AGORA(),
        		  	     vFILDIF, vSEQDIF, vTIPDIF,
        		  	     vFILTRN, vSEQTRN, vTIPTRN,
        			     OLD.VLRCHE-NEW.VLRCHE,
        			     'ALTERACAO NO VALOR DO CHEQUE:'||NEW.CODBCO||'.'||NEW.CODAGE||'.'||NEW.NUMCON||'.'||NEW.NUMCHE,
        			     'DIFERENCA CHEQUE','S',VSEQFIN,
                         NEW.CODFIL, NEW.SEQUEN,'I');
    	END IF;
    END IF;


			      
/*  fim lanar a diferena como lanamento avulso financeiro  (PTulio) */
    
	--     RAISE EXCEPTION 'PG-20072 antes % %' , OLD.FLGEST,NEW.FLGEST;   

/*    --42769 VERIFICA SE CHEQUE_PAGA_PARCELA
    SELECT CHEQUE_PAGA_PARCELA INTO bCHEQUE_PAGA_PARCELA 
      FROM TT_CFG;

    IF bCHEQUE_PAGA_PARCELA = 'F' THEN


	     -- Checa "flag"
	     IF ((OLD.FLGEST <> 'A') AND (NEW.FLGEST = 'A')) OR
		((OLD.FLGEST <> 'U') AND (NEW.FLGEST = 'U')) THEN
		-- O cheque voltou a situacao original
		tem_log := True;
		IF (OLD.FLGEST IN ('C','B')) THEN
		   -- Estorna pagamento
		   		  
		    vAux:=PC_CHR_UPDATE('R',NEW.CODFIL,NEW.SEQUEN,NEW.FILUSU||NEW.CODUSU,NEW.DATOPE,
					NEW.NUMCON,NEW.NUMDOC,NEW.CODBCO,NEW.CODAGE,NEW.NUMCHE,NEW.ATU_EM,
					NEW.DATVEN,NEW.VLRCHE,NEW.PORTAD,NEW.PAGAME,NEW.NUMDEP,NEW.ALINEA,NEW.VLRDIF,
					--NEW.DUMMY,
					NEW.SEQCAN,NEW.AUTORI,NEW.TIPCOB,NEW.OBSLOG,NEW.NUMECF,
					NEW.CDCMC7,NEW.FILCLI||NEW.CODCLI,NEW.VLRORI,NEW.PLACAS,NEW.SERCHE,
					NEW.FILDEP||NEW.SEQDEP,NEW.DATFIS,NEW.DATREA,NEW.PORORI);				
		  		END IF;
	     ELSIF (NEW.FLGEST = 'C' AND OLD.FLGEST <> 'C') OR
		   (NEW.FLGEST = 'B' AND OLD.FLGEST <> 'B') THEN
		   -- Confirma pagamento
		   		  
		    vAux:=PC_CHR_UPDATE('X',NEW.CODFIL,NEW.SEQUEN,NEW.FILUSU||NEW.CODUSU,NEW.DATOPE,
					NEW.NUMCON,NEW.NUMDOC,NEW.CODBCO,NEW.CODAGE,NEW.NUMCHE,NEW.ATU_EM,
					NEW.DATVEN,NEW.VLRCHE,NEW.PORTAD,NEW.PAGAME,NEW.NUMDEP,NEW.ALINEA,NEW.VLRDIF,
					--NEW.DUMMY,
					NEW.SEQCAN,NEW.AUTORI,NEW.TIPCOB,NEW.OBSLOG,NEW.NUMECF,
					NEW.CDCMC7,NEW.FILCLI||NEW.CODCLI,NEW.VLRORI,NEW.PLACAS,NEW.SERCHE,
					NEW.FILDEP||NEW.SEQDEP,NEW.DATFIS,NEW.DATREA,NEW.PORORI);
		  	     ELSIF (NEW.FLGEST = 'D' AND OLD.FLGEST <> 'D') OR
		   (NEW.FLGEST = 'P' AND OLD.FLGEST <> 'P') THEN
		-- Incrementa numero de depositos
		NEW.NUMDEP := COALESCE(OLD.NUMDEP,0) + 1;
	     END IF;

	     IF (OLD.FLGEST = 'C' AND NEW.FLGEST <> 'C') OR
		(OLD.FLGEST = 'B' AND NEW.FLGEST <> 'B') THEN
		  --davi - ptulio - 37085 - 03/08/05 
		  --incluir um cheque semelhante a anterior, porm, cancelada
		  		 
		   vAux:=PC_CHR_UPDATE('J',OLD.CODFIL,ProximoCodigo('TT_CHR',OLD.CODFIL),
				       OLD.FILUSU||OLD.CODUSU,OLD.DATOPE,OLD.NUMCON,
				       OLD.NUMDOC,OLD.CODBCO,OLD.CODAGE,OLD.NUMCHE,OLD.ATU_EM,OLD.DATVEN,OLD.VLRCHE,
				       OLD.PORTAD,OLD.PAGAME,OLD.NUMDEP,OLD.ALINEA,OLD.VLRDIF,
				       --OLD.DUMMY,
				       ProximoCodigo('TT_CHR_CANCELAMENTO',OLD.CODFIL),OLD.AUTORI,
				       OLD.TIPCOB,OLD.OBSLOG,OLD.NUMECF,OLD.CDCMC7,OLD.FILCLI||OLD.CODCLI,
				       OLD.VLRORI,OLD.PLACAS,OLD.SERCHE,OLD.FILDEP||OLD.SEQDEP,OLD.DATFIS,
				       OLD.DATREA,NEW.PORORI);
			     END IF;
     END IF;  --bCHEQUE_PAGA_PARCELA 
     */

     --59342
      IF NOT (TG_OP = 'DELETE') THEN
        IF (NEW.FLGEST IN ('B','I','C')) AND (NEW.PAGAME IS NULL) THEN
          NEW.PAGAME := agora();
        ELSIF (NEW.FLGEST NOT IN ('B','I','C')) AND (NEW.PAGAME IS NOT NULL) THEN 
          NEW.PAGAME := null; 
        END IF;
      END IF;
     
     --Tratamento para retirar da cobranca
      IF (TG_OP = 'UPDATE') THEN
         IF (OLD.FLGEST = 'V' ) AND (NEW.FLGEST <> 'V') THEN
            SELECT COB_USA_SAC INTO cCOB_USA_SAC
              FROM TT_CFG;
             IF (cCOB_USA_SAC= 'T') THEN
                vAux:=PC_CHR_UPDATE(CAST(' ' AS CHAR(1)),NEW.CODFIL,NEW.SEQUEN,
                                     NULL,NULL,
                                     NULL,NULL,NULL,NULL,NULL,NULL,
                                     NULL,NULL,NULL,NULL,NULL,NULL,
                                     NULL,NULL,NULL,NULL,NULL,
                                     NULL,NULL,NULL,NULL,NULL,
                                     NULL,NULL,NULL,NULL,NULL);
             END IF;
         END IF;
      END IF;
    
 
     -- Grava ocorrencia
     -- Registra mudancas significativas de TT_CHR em TL_CHR
     IF (tem_log) THEN
    	select * into QuemLogou from DadosLogon();
        IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
          vLOG := vLOG||'Situacao: de '||COALESCE(DescricaoDominio('CHR','FLGEST',OLD.FLGEST),Nulo)||' para '||COALESCE(DescricaoDominio('CHR','FLGEST',NEW.FLGEST),Nulo)||CRLF;
        END IF;
        IF Equal(OLD.CODBCO,NEW.CODBCO) <> 1 THEN
          vLOG := vLOG||'Banco: de '||COALESCE(OLD.CODBCO,Nulo)||' para '||COALESCE(NEW.CODBCO,Nulo)||CRLF;
        END IF;
        IF Equal(OLD.CODAGE,NEW.CODAGE) <> 1 THEN
          vLOG := vLOG||'Agencia: de '||COALESCE(OLD.CODAGE,Nulo)||' para '||COALESCE(NEW.CODAGE,Nulo)||CRLF;
        END IF;
        IF Equal(OLD.NUMCON,NEW.NUMCON) <> 1 THEN
          vLOG := vLOG||'Conta corrente: de '||COALESCE(OLD.NUMCON,Nulo)||' para '||COALESCE(NEW.NUMCON,Nulo)||CRLF;
        END IF;
        IF Equal(OLD.NUMDOC,NEW.NUMDOC) <> 1 THEN
          vLOG := vLOG||'CNPJ/CPF: de '||COALESCE(OLD.NUMDOC,Nulo)||' para '||COALESCE(NEW.NUMDOC,Nulo)||CRLF;
        END IF;
        IF Equal(OLD.NUMCHE,NEW.NUMCHE) <> 1 THEN
          vLOG := vLOG||'Cheque: de '||COALESCE(OLD.NUMCHE,Nulo)||' para '||COALESCE(NEW.NUMCHE,Nulo)||CRLF;
        END IF;
        IF Equal(OLD.ALINEA,NEW.ALINEA) <> 1 THEN
          vLOG := vLOG||'Alinea: de '||TO_CHAR(COALESCE(OLD.ALINEA,0))||' para '||TO_CHAR(COALESCE(NEW.ALINEA,0))||CRLF;
        END IF;
        IF Equal(OLD.VLRDIF,NEW.VLRDIF) <> 1 THEN
          vLOG := vLOG||'Diferenca: de '||TO_CHAR(COALESCE(OLD.VLRDIF,0),'FM9G999G990D00')||' para '||TO_CHAR(COALESCE(NEW.VLRDIF,0),'FM9G999G990D00')||CRLF;
        END IF;
        IF (Equal(OLD.VLRORI,NEW.VLRORI) <> 1) AND (OLD.VLRORI > 0) THEN
          vLOG := vLOG||'Vlr. Original: de '||TO_CHAR(COALESCE(OLD.VLRORI,0),'FM9G999G990D00')||' para '||TO_CHAR(COALESCE(NEW.VLRORI,0),'FM9G999G990D00')||CRLF;
        END IF;
        IF Equal(OLD.VLRCHE,NEW.VLRCHE) <> 1 THEN
          vLOG := vLOG||'Vlr. do Cheque: de '||TO_CHAR(COALESCE(OLD.VLRCHE,0),'FM9G999G990D00')||' para '||TO_CHAR(COALESCE(NEW.VLRCHE,0),'FM9G999G990D00')||CRLF;
        END IF;
        IF Equal(OLD.DATVEN,NEW.DATVEN) <> 1 THEN
          vLOG := vLOG||'Vencimento: de '||COALESCE(TO_CHAR(OLD.DATVEN,'DD/MM/YYYY'),Nulo)||' para '||COALESCE(TO_CHAR(NEW.DATVEN,'DD/MM/YYYY'),Nulo)||CRLF;
        END IF;
        IF Equal(OLD.PORTAD,NEW.PORTAD) <> 1 OR Equal(OLD.TIPCOB,NEW.TIPCOB) <> 1 THEN
          vLOG := vLOG||'Portador: de '||COALESCE(OLD.PORTAD,-9999)||'-'||COALESCE(DescricaoDominio('CHR','TIPCOB',OLD.TIPCOB),Nulo)||' para '||COALESCE(NEW.PORTAD,-9999)||'-'||COALESCE(DescricaoDominio('CHR','TIPCOB',NEW.TIPCOB),Nulo)||CRLF;
        END IF;
        IF Equal(OLD.PAGAME,NEW.PAGAME) <> 1 THEN
          vLOG := vLOG||'Pagamento: de '||COALESCE(TO_CHAR(OLD.PAGAME,'DD/MM/YYYY'),Nulo)||' para '||COALESCE(TO_CHAR(NEW.PAGAME,'DD/MM/YYYY'),Nulo)||CRLF;
        END IF;
        IF Equal(OLD.AUTORI,NEW.AUTORI) <> 1 THEN
         vLOG := vLOG||'Autorizacao: de '||COALESCE(OLD.AUTORI,Nulo)||' para '||COALESCE(NEW.AUTORI,Nulo)||CRLF;
        END IF;
        IF (Equal(OLD.FILCLI,NEW.FILCLI) <> 1) OR (Equal(OLD.CODCLI,NEW.CODCLI) <> 1) THEN
              vLOG := vLOG||'Cliente: de '||COALESCE(OLD.FILCLI,Nulo)||'/'||COALESCE(OLD.CODCLI,Nulo)||' para '||COALESCE(NEW.FILCLI,Nulo)||'/'||COALESCE(NEW.CODCLI,Nulo)||CRLF;
        END IF; 
        IF (Equal(OLD.FILUSU,NEW.FILUSU) <> 1) OR (Equal(OLD.CODUSU,NEW.CODUSU) <> 1) THEN
              vLOG := vLOG||'Usuario: de '||COALESCE(OLD.FILUSU,Nulo)||'/'||COALESCE(OLD.CODUSU,Nulo)||' para '||COALESCE(NEW.FILUSU,Nulo)||'/'||COALESCE(NEW.CODUSU,Nulo)||CRLF;
        END IF;
        IF (Equal(OLD.NUMDEP,NEW.NUMDEP) <> 1) THEN
              vLOG := vLOG||'Numero de depositos: de '||COALESCE(OLD.NUMDEP,0)||' para '||COALESCE(NEW.NUMDEP,0)||CRLF;
        END IF;  
        IF (Equal(OLD.SEQCAN,NEW.SEQCAN) <> 1) THEN
              vLOG := vLOG||'Sequencia de cancelamento: de '||COALESCE(OLD.SEQCAN,nulo)||' para '||COALESCE(NEW.SEQCAN,nulo)||CRLF;
        END IF;  
        IF (Equal(OLD.DATOPE,NEW.DATOPE) <> 1) THEN
              vLOG := vLOG||'data de Operacao: de '||COALESCE(TO_CHAR(OLD.DATOPE,'DD/MM/YYYY'),Nulo)||' para '||COALESCE(TO_CHAR(NEW.DATOPE,'DD/MM/YYYY'),Nulo)||CRLF;
        END IF;
        IF Equal(OLD.NUMECF,NEW.NUMECF) <> 1 THEN
          vLOG := vLOG||'Numero de ECF: de '||COALESCE(OLD.NUMECF,Nulo)||' para '||COALESCE(NEW.NUMECF,Nulo)||CRLF;
        END IF;
        IF Equal(OLD.CDCMC7,NEW.CDCMC7) <> 1 THEN
          vLOG := vLOG||'Codigo CMC7 cheque : de '||COALESCE(OLD.CDCMC7,Nulo)||' para '||COALESCE(NEW.CDCMC7,Nulo)||CRLF;
        END IF;
        IF Equal(OLD.PLACAS,NEW.PLACAS) <> 1 THEN
          vLOG := vLOG||'Placa : de '||COALESCE(OLD.PLACAS,Nulo)||' para '||COALESCE(NEW.PLACAS,Nulo)||CRLF;
        END IF;
        IF Equal(OLD.SERCHE,NEW.SERCHE) <> 1 THEN
          vLOG := vLOG||'Serie do Cheque: de '||COALESCE(OLD.SERCHE,Nulo)||' para '||COALESCE(NEW.SERCHE,Nulo)||CRLF;
        END IF;
        IF (Equal(OLD.FILDEP,NEW.FILDEP) <> 1) OR (Equal(OLD.SEQDEP,NEW.SEQDEP) <> 1) THEN
              vLOG := vLOG||'Deposito: de '||COALESCE(OLD.FILDEP,Nulo)||'/'||COALESCE(OLD.SEQDEP,Nulo)||' para '||COALESCE(NEW.FILDEP,Nulo)||'/'||COALESCE(NEW.SEQDEP,Nulo)||CRLF;
        END IF;
        IF (NEW.OBSLOG is not null) THEN
          vLOG := vLOG||'Anotacoes: '||NEW.OBSLOG;
          --NEW.OBSLOG := NULL;
        END IF;
        IF Equal(OLD.TRN_ID,NEW.TRN_ID) <> 1 THEN
          vLOG := vLOG||'ID Transao: de '||COALESCE(OLD.TRN_ID,iNulo)||' para '||COALESCE(NEW.TRN_ID,iNulo)||CRLF;
        END IF;
        IF (Equal(OLD.DATINC,NEW.DATINC) <> 1) THEN
          vLOG := vLOG||'Data Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),Nulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),Nulo)||CRLF;
        END IF;
   
        -- Por seguranca
        IF vLOG IS NOT NULL THEN
          INSERT INTO TL_CHR (CODFIL,SEQCHE,DATOPE,FILUSU,CODUSU,MSGLOG)
          VALUES (NEW.CODFIL,NEW.SEQUEN,agora(),QuemLogou.FILUSU, QuemLogou.CODUSU,vLOG);
        END IF;
     END IF;
  END IF;

  -- "Default"
  if NEW.DATOPE is null then
     NEW.DATOPE := agora();
  end if;

  NEW.ATU_EM := agora();
  NEW.DATVEN := Trunc(NEW.DATVEN);
  NEW.DUMMY  := Null;
  -- Coloca zeros a esquerda nos dados chaves do Cheque
  NEW.CODBCO := LPAD(ltrim(rtrim(NEW.CODBCO)), 3,'0');
  NEW.CODAGE := LPAD(ltrim(rtrim(NEW.CODAGE)), 5,'0');
  NEW.NUMCON := LPAD(ltrim(rtrim(NEW.NUMCON)),10,'0');
  NEW.NUMCHE := LPAD(ltrim(rtrim(NEW.NUMCHE)), 6,'0');

    -- DN 45679 - Tabelas Financeiras
    IF (TG_OP = 'INSERT') THEN    
       cDUMMY:=INSERE_LFIN_LAN('CHR',NEW.CODFIL,NEW.SEQUEN,'--','--');
    END IF;
    IF (TG_OP = 'UPDATE') THEN
       IF (Equal(OLD.FLGEST,NEW.FLGEST) <> 1) OR 
          (Equal(OLD.PAGAME,NEW.PAGAME) <> 1) OR 
          (Equal(OLD.DATVEN,NEW.DATVEN) <> 1) OR 
          (Equal(OLD.VLRCHE,NEW.VLRCHE) <> 1) OR 
          (Equal(OLD.VLRDIF,NEW.VLRDIF) <> 1) OR 
          (Equal(OLD.PORTAD,NEW.PORTAD) <> 1) OR 
          (Equal(OLD.FILCLI,NEW.FILCLI) <> 1) OR 
          (Equal(OLD.CODCLI,NEW.CODCLI) <> 1) OR 
          (Equal(OLD.DATFIS,NEW.DATFIS) <> 1) THEN 
          cDUMMY:=INSERE_LFIN_LAN('CHR',NEW.CODFIL,NEW.SEQUEN,'--','--');
       END IF;
    END IF;
    -- DN 45679 - Fim Tabelas Financeiras

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3298 --*/
CREATE TRIGGER TGCHR2
BEFORE INSERT OR DELETE OR UPDATE ON TT_CHR 
FOR EACH ROW EXECUTE PROCEDURE TGCHR2();



/*-- SEQ 3299 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCHR_DW() CASCADE;

/*-- SEQ 3300 --*/
CREATE OR REPLACE FUNCTION TGCHR_DW() RETURNS TRIGGER AS $$
DECLARE
  bProcessa     BOOLEAN DEFAULT False;
  regDW         RECORD;
  cDUMMY        VARCHAR(2);
  vCODFIL       TT_CHR.CODFIL%TYPE;  
  vSEQUEN       TT_CHR.SEQUEN%TYPE;  
  vComplemento  CONSTANT VARCHAR(100) := Constante('Complemento');

-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Vendas_Meio

BEGIN
  IF UsaVMDecisor() = 'T' THEN
     -- (TG_OP = 'INSERT'): no faz nada porque ainda no est em nenhuma venda
     -- (TG_OP = 'DELETE'): impedido por trigger
     IF (TG_OP = 'UPDATE') THEN
       IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 -- PK
       OR Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 -- PK
       THEN
         RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
       END IF;
       IF Equal(OLD.DATVEN,NEW.DATVEN) <> 1 THEN
         bProcessa := True;
         vCODFIL   := NEW.CODFIL;
         vSEQUEN   := NEW.SEQUEN;
       END IF;
     END IF;
     IF bProcessa THEN
       FOR regDW IN (SELECT DISTINCT DW.FILIAL, 
                                     DW.COD_UNIDADE,
                                     DW.ANO_MES
                       FROM DW_Vendas_Meio DW
                      WHERE DW.CHR_CODFIL = vCODFIL
                        AND DW.CHR_SEQUEN = vSEQUEN)
       LOOP
         cDUMMY := Insere_DW_Log_Vendas_Meio(regDW.FILIAL, regDW.COD_UNIDADE, regDW.ANO_MES);
       END LOOP;    
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3301 --*/
CREATE TRIGGER TGCHR_DW
AFTER UPDATE ON TT_CHR 
FOR EACH ROW EXECUTE PROCEDURE TGCHR_DW();


/*-- SEQ 3302 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCLA() CASCADE;

/*-- SEQ 3303 --*/
CREATE OR REPLACE FUNCTION TGCLA() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN:=ProximoCodigo('TT_CLA',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3304 --*/
CREATE TRIGGER TGCLA
BEFORE INSERT ON TT_CLA 
FOR EACH ROW EXECUTE PROCEDURE TGCLA();


/*-- SEQ 3305 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCLI1() CASCADE;

/*-- SEQ 3306 --*/
CREATE OR REPLACE FUNCTION TGCLI1() RETURNS TRIGGER AS $$ 
DECLARE
  pg_dummy VARCHAR(5)
;
BEGIN
      IF PC_TRIGGERS_ENABLED('PC_CONJUGE') THEN
      pg_dummy := PC_CLEAR_LIST('PC_CONJUGE')
;
   END IF;
   --davi - 41296 - 21/11/06
   IF PC_TRIGGERS_ENABLED('PC_PROxNOM') THEN
      pg_dummy := PC_CLEAR_LIST('PC_PROxNOM')
;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3307 --*/
CREATE TRIGGER TGCLI1
BEFORE INSERT OR UPDATE ON TT_CLI 
FOR STATEMENT EXECUTE PROCEDURE TGCLI1();

/*-- SEQ 3308 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCLI2() CASCADE;

/*-- SEQ 3309 --*/
CREATE OR REPLACE FUNCTION TGCLI2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Recalcular conta corrente e bonus
--
-- Principal
BEGIN
  -- Recalculo de bonus e conta corrente
  IF (TG_OP = 'UPDATE') THEN
                IF COALESCE(OLD.SALBON,0) <> COALESCE(NEW.SALBON,0) THEN
             NEW.SALBON := TGR_CalculaBonus(NEW.FILCLI,NEW.CODCLI);
           END IF;
       END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3310 --*/
CREATE TRIGGER TGCLI2
BEFORE UPDATE ON TT_CLI 
FOR EACH ROW EXECUTE PROCEDURE TGCLI2();

/*-- SEQ 3311 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCLI3() CASCADE;

/*-- SEQ 3312 --*/
CREATE OR REPLACE FUNCTION TGCLI3() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Assumir valores "default"
-- 2) "Delete cascade" na tabela de "log"
-- 3) Registrar Pendncias para Atualizar os Impostos de Fornecedores Calculados
--
      inRec                         TT_CLI%ROWTYPE;
   
   cDUMMY                        VARCHAR(2);
      vCodigo                       CONSTANT CHAR(6)   := '     0';
   vComplemento                  CONSTANT VARCHAR(100) := constante('complemento');
   vMudancaSituacao              boolean;
   vUSUARIO                      TT_USU.APEUSU%TYPE;
   WK_GERA_CODEXT_INTEGRACAO     TT_CFG.GERA_CODEXT_INTEGRACAO%TYPE;
   pg_dummy VARCHAR(5)
;
   cRet                          VARCHAR(2);
      
     QuemLogou                   TRetQuemLogou%ROWTYPE;
   
   --LEO 84337
   vCODUID_ATUAL                 VARCHAR(22);
   vBLQ_SEM_UID                  TT_CFG.BLQ_SEM_UID%TYPE;
   vSESSIONID                    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');
   -- Pedro E. Braga - 92722
   cRETORNO                      VARCHAR(4);
   -- Pedro E. Braga - 93794
   cFPVPRECOSIMULADO             TT_CFG.FPV_PRECO_SIMULADO%TYPE;
   VParametro                    VARCHAR(50);
BEGIN
  IF (TG_OP = 'DELETE') THEN
     cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_CLI', OLD.filcli, OLD.codcli);
  END IF;
  IF (TG_OP = 'INSERT') THEN
     --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
     cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_CLI', NEW.filcli, NEW.codcli);
     -- Paulo : 70789 - Se o campo ESTRAN estiver nulo insere default "F".
     IF NEW.ESTRAN IS NULL THEN
        NEW.ESTRAN := 'F';
     END IF;
  END IF;
  IF NOT (TG_OP = 'DELETE') THEN
  
    IF (ISNULL(NEW.CONTRIBUINTE) = 'T') THEN 
        NEW.CONTRIBUINTE := 'F';
        IF (COALESCE(NEW.ISENTO, 'T') = 'F') OR -- Revenda
           ((COALESCE(NEW.TIPDOC, 'X')= 'IE') AND 
            (COALESCE(NEW.INSEST, 'X') <> 'X') AND 
            (NEW.INSEST <> 'ISENTO') AND 
            (NEW.INSEST <> 'ISENTA')) THEN
            NEW.CONTRIBUINTE := 'T';
        END IF;
    END IF;
  
     IF (TG_OP = 'INSERT') THEN
       NEW.ATU_EM := agora();
       SELECT GERA_CODEXT_INTEGRACAO INTO WK_GERA_CODEXT_INTEGRACAO FROM TT_CFG;
       IF (NEW.CODEXT IS NULL) AND (WK_GERA_CODEXT_INTEGRACAO = 'T') THEN
          NEW.CODEXT := NEW.FILCLI||TRIM(NEW.CODCLI);
       END IF;
       IF NEW.NAODIV IS NULL THEN
          NEW.NAODIV := 'F';
       END IF;
     END IF;
     IF (TG_OP = 'UPDATE') THEN
       IF Equal(OLD.FILCLI,NEW.FILCLI) = 0 OR
          Equal(OLD.CODCLI,NEW.CODCLI) = 0 OR
          Equal(OLD.NOMCLI,NEW.NOMCLI) = 0 OR
          Equal(OLD.ULTNOM,NEW.ULTNOM) = 0 OR
          Equal(OLD.NUMDOC,NEW.NUMDOC) = 0 OR
          Equal(OLD.DOCCON,NEW.DOCCON) = 0 OR
          Equal(OLD.DATNAS,NEW.DATNAS) = 0 OR
          Equal(OLD.ESTCIV,NEW.ESTCIV) = 0 OR
          Equal(OLD.HOMPGE,NEW.HOMPGE) = 0 OR
          Equal(OLD.FLGTIP,NEW.FLGTIP) = 0 OR
          Equal(OLD.INSEST,NEW.INSEST) = 0 OR
          Equal(OLD.CODSEX,NEW.CODSEX) = 0 OR
          Equal(OLD.CATEG1,NEW.CATEG1) = 0 OR
          Equal(OLD.CATEG2,NEW.CATEG2) = 0 OR
          Equal(OLD.CATEG3,NEW.CATEG3) = 0 OR
          Equal(OLD.DATA01,NEW.DATA01) = 0 OR
          Equal(OLD.DATA02,NEW.DATA02) = 0 OR
          Equal(OLD.DATA03,NEW.DATA03) = 0 OR
          Equal(OLD.DATOPE,NEW.DATOPE) = 0 OR
          Equal(OLD.IMPRIM,NEW.IMPRIM) = 0 OR
          Equal(OLD.VALOR1,NEW.VALOR1) = 0 OR
          Equal(OLD.OBSERV,NEW.OBSERV) = 0 OR
          Equal(OLD.FILPLA,NEW.FILPLA) = 0 OR
          Equal(OLD.CODPLA,NEW.CODPLA) = 0 OR
          Equal(OLD.PORPAD,NEW.PORPAD) = 0 OR
          Equal(OLD.SIGNAT,NEW.SIGNAT) = 0 OR
          Equal(OLD.CONJUG,NEW.CONJUG) = 0 OR
          Equal(OLD.NASCON,NEW.NASCON) = 0 OR
          Equal(OLD.SEXCON,NEW.SEXCON) = 0 OR
          Equal(OLD.FILVEN,NEW.FILVEN) = 0 OR
          Equal(OLD.CODVEN,NEW.CODVEN) = 0 OR
          Equal(OLD.CODEXT,NEW.CODEXT) = 0 OR
          Equal(OLD.FILVIN,NEW.FILVIN) = 0 OR
          Equal(OLD.CODVIN,NEW.CODVIN) = 0 OR
          Equal(OLD.TIPDOC,NEW.TIPDOC) = 0 OR
          Equal(OLD.NOMIMG,NEW.NOMIMG) = 0 OR
          Equal(OLD.ICM_CF,NEW.ICM_CF) = 0 OR
          Equal(OLD.CALL_C,NEW.CALL_C) = 0 OR
          Equal(OLD.TIPCOB,NEW.TIPCOB) = 0 OR
          Equal(OLD.OBSOUT,NEW.OBSOUT) = 0 OR
          Equal(OLD.CODFID,NEW.CODFID) = 0 OR
          Equal(OLD.CONBOL,NEW.CONBOL) = 0 OR
          Equal(OLD.DDTCON,NEW.DDTCON) = 0 OR
          Equal(OLD.TELCON,NEW.TELCON) = 0 OR
          Equal(OLD.DDCCON,NEW.DDCCON) = 0 OR
          Equal(OLD.CELCON,NEW.CELCON) = 0 OR
          Equal(OLD.E_MCON,NEW.E_MCON) = 0 OR
          Equal(OLD.NOMTRA,NEW.NOMTRA) = 0 OR
          Equal(OLD.ID_ORG,NEW.ID_ORG) = 0 OR
          Equal(OLD.ID_EST,NEW.ID_EST) = 0 OR
          Equal(OLD.ID_DAT,NEW.ID_DAT) = 0 OR
          Equal(OLD.LIMPAR,NEW.LIMPAR) = 0 OR
          Equal(OLD.EDICRE,NEW.EDICRE) = 0 OR
          Equal(OLD.GLOBAL,NEW.GLOBAL) = 0 OR
          Equal(OLD.SIMPLE,NEW.SIMPLE) = 0 OR
          Equal(OLD.PP_FLG,NEW.PP_FLG) = 0 OR
          Equal(OLD.PP_INI,NEW.PP_INI) = 0 OR
          Equal(OLD.PP_FIM,NEW.PP_FIM) = 0 OR
          Equal(OLD.PP_FIL,NEW.PP_FIL) = 0 OR
          Equal(OLD.PP_COD,NEW.PP_COD) = 0 OR
          Equal(OLD.CODINA,NEW.CODINA) = 0 OR
          Equal(OLD.NAOSPC,NEW.NAOSPC) = 0 OR
          Equal(OLD.ATUCUS,NEW.ATUCUS) = 0 OR
          Equal(OLD.FILCON,NEW.FILCON) = 0 OR
          Equal(OLD.CODCON,NEW.CODCON) = 0 OR
          Equal(OLD.CCCPRE,NEW.CCCPRE) = 0 OR
          Equal(OLD.PEDELE,NEW.PEDELE) = 0 OR
          Equal(OLD.USAREF,NEW.USAREF) = 0 OR
          Equal(OLD.REPASE,NEW.REPASE) = 0 OR
          Equal(OLD.POREMP,NEW.POREMP) = 0 OR
          Equal(OLD.TIPEMP,NEW.TIPEMP) = 0 OR
          Equal(OLD.ESTRAN,NEW.ESTRAN) = 0 OR
          Equal(OLD.FILGUI,NEW.FILGUI) = 0 OR
          Equal(OLD.CODGUI,NEW.CODGUI) = 0 OR
          Equal(OLD.NAODIV,NEW.NAODIV) = 0 OR
          Equal(OLD.CODCUS,NEW.CODCUS) = 0 OR
          Equal(OLD.ISENTO,NEW.ISENTO) = 0 OR
          Equal(OLD.REGESP,NEW.REGESP) = 0 OR
          Equal(OLD.PERVDD,NEW.PERVDD) = 0 OR
          Equal(OLD.CMSIND,NEW.CMSIND) = 0 OR
          Equal(OLD.TOTPAR,NEW.TOTPAR) = 0 OR
          Equal(OLD.TOTATR,NEW.TOTATR) = 0 OR
          Equal(OLD.MAIATR,NEW.MAIATR) = 0 OR
          Equal(OLD.REGMEI,NEW.REGMEI) = 0 OR
          Equal(OLD.CONTRIBUINTE,NEW.CONTRIBUINTE) = 0 OR
          Equal(OLD.LABORATORIO,NEW.LABORATORIO) = 0 THEN
          IF NEW.ATU_EM=OLD.ATU_EM THEN
            NEW.ATU_EM := agora();
          END IF;
       END IF;
     END IF;
     NEW.DATOPE := COALESCE(NEW.DATOPE,agora());

     -- Obriga sempre CAIXA ALTA
     NEW.NOMCLI := Upper(NEW.NOMCLI);
     NEW.ULTNOM := Upper(NEW.ULTNOM);
     NEW.CONJUG := Upper(NEW.CONJUG);
     NEW.NOMTRA := Upper(NEW.NOMTRA);

     -- MN - 2023025306 - Se vier a palavra ISENTA converte para ISENTO
     IF ((TG_OP = 'INSERT') OR (TG_OP = 'UPDATE')) AND (UPPER(COALESCE(NEW.INSEST, 'X')) = 'ISENTA') THEN
       NEW.INSEST := 'ISENTO';
     END IF;

     IF (TG_OP = 'INSERT') THEN
        IF COALESCE(NEW.SIGNAT,0)<0 THEN
           vMudancaSituacao:=true;
        END IF;
     END IF;

     IF (TG_OP = 'UPDATE') THEN
        IF ((COALESCE(OLD.SIGNAT,0)>=0) and (COALESCE(NEW.SIGNAT,0)<0)) OR    -- Estava Ativo e foi Desativado
           ((COALESCE(OLD.SIGNAT,0)<0)  and (COALESCE(NEW.SIGNAT,0)>=0)) THEN -- Estava Desativado e foi Ativado
           vMudancaSituacao:=true;
        END IF;

        IF (NEW.FILCLI||NEW.CODCLI) <> (OLD.FILCLI||OLD.CODCLI) THEN

           UPDATE TT_PRO SET ATU_EM = AGORA()
            WHERE FILMAR = NEW.FILCLI AND CODMAR = NEW.CODCLI;

           UPDATE TT_PRO SET ATU_EM = AGORA()
            WHERE FILMAR = OLD.FILCLI
              AND CODMAR = OLD.CODCLI;

        END IF;

     END IF;

     SELECT GetApeUsuAtual() INTO vUSUARIO FROM DUAL;
     -- So aceita desativacao se o usuario tiver a permissao especifica
     IF vMudancaSituacao AND (Permissao(vUSUARIO,148) <> 1) THEN
         RAISE EXCEPTION 'PG-20025 Usuario "%" nao possui a permissao "148 - Ativar/Desativar Parceiro". %' , vUSUARIO,vComplemento;
     END IF;

     -- So aceita digitos
     IF (TG_OP = 'INSERT') THEN
        NEW.NUMDOC := GetDigit(NEW.NUMDOC);
     ELSIF (TG_OP = 'UPDATE') THEN
        IF COALESCE(OLD.NUMDOC,'#ERR#') <> COALESCE(NEW.NUMDOC,'#ERR#') THEN
           NEW.NUMDOC := GetDigit(LTRIM(RTRIM(NEW.NUMDOC)));
        END IF;

        -- Nao deixa alterar algumas informacoes se o cliente for uma filial e
        -- se a alteracao nao partiu da trigger de TD_FIL
        IF (OLD.CODCLI = vCodigo) THEN
          IF (TRIM(NEW.DUMMY) <> Constante('vem_de_TGDFIL')) THEN
            IF Equal(OLD.NOMCLI,NEW.NOMCLI) <> 1 OR
               Equal(OLD.ULTNOM,NEW.ULTNOM) <> 1 OR
               Equal(OLD.NUMDOC,NEW.NUMDOC) <> 1 THEN
              RAISE EXCEPTION 'PG-20022 Esse cliente e uma filial. Alguns de seus dados so podem ser modificados no cadastro de filiais. %' , vComplemento;
            END IF;
          END IF;
        END IF;
     END IF;

     -- Transferido Regra da CK_CLI_REGRA pois em PG no respeitava os parentes aplicados.
     -- Regra CK ((FLGTIP = 5 AND (CODCLI = "     0" OR SIGNAT < 0)) OR (FLGTIP <> 5 AND CODCLI <> "     0"))
     IF ((NEW.FLGTIP = 5 AND (NEW.CODCLI <> '     0' and NEW.SIGNAT >= 0)) OR (NEW.FLGTIP <> 5 AND NEW.CODCLI = '     0')) THEN
        RAISE EXCEPTION 'PG-20023 No  permitido esse Tipo de pessoa para o parceiro. %' , vComplemento;
     END IF;

     IF NEW.FLGTIP = 0 AND NEW.FILCON IS NOT NULL AND NEW.CODCON IS NOT NULL THEN
       IF PC_TRIGGERS_ENABLED('PC_CONJUGE') THEN
          pg_dummy := PC_NEXT_GROUP('PC_CONJUGE');
pg_dummy := PC_ADD_LIST('PC_CONJUGE','FILCLI',true,NEW.FILCLI);
pg_dummy := PC_ADD_LIST('PC_CONJUGE','CODCLI',true,NEW.CODCLI);
pg_dummy := PC_ADD_LIST('PC_CONJUGE','FILCON',false,NEW.FILCON);
pg_dummy := PC_ADD_LIST('PC_CONJUGE','CODCON',false,NEW.CODCON);
pg_dummy := PC_FIND_LIST('PC_CONJUGE')
;
       END IF;
     END IF;

     -- Controle do indicador de Exportao
     IF (COALESCE(NEW.INDEXP, 'X') = 'I') THEN
       NEW.INDEXP := 'N';
     ELSE
       NEW.INDEXP := 'E';
     END IF;

     IF (TRIM(NEW.DUMMY) <> Constante('VEM_DE_TGWCLI')) OR (TRIM(NEW.DUMMY) = NULL) THEN
        select * into QuemLogou from DadosLogon();
        NEW.FILUSU := QuemLogou.FILUSU;
        NEW.CODUSU := QuemLogou.CODUSU;
     END IF;
     NEW.DUMMY := NULL;
  END IF;

  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     IF NEW.ESTRAN = 'F' AND NEW.CODPAI IS NULL THEN
        NEW.CODPAI := 1058;
     END IF;
  END IF;

  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     IF NEW.NAODIV = 'F' THEN
        NEW.LIMCHE := NULL;
     END IF;

     --CHECA SE EXISTE RECURSIVIDADE ENTRE PARCEIRO E VINCULO FINANCEIRO
     IF (ISNOTNULL(NEW.FILVIN) = 'T') AND (ISNOTNULL(NEW.CODVIN) = 'T') THEN
                   inRec.FILCLI := NEW.FILCLI;
           inRec.CODCLI := NEW.CODCLI;
           inRec.FILVIN := NEW.FILVIN;
           inRec.CODVIN := NEW.CODVIN;
           
             cDUMMY := PC_CLI_Vinculado_Update(inRec.FILCLI, inRec.CODCLI,inRec.FILVIN,inRec.CODVIN);
                    
     END IF;

  END IF;
  
  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
  -- VERIFICA SE EST SENDO SETADO O CLIENTE COMO OPTANTE PELO MEI QUANDO NO  SIMPLES NACIONAL
    IF(NEW.REGMEI = 'T') AND (NEW.SIMPLE = 'F') THEN
      RAISE EXCEPTION 'PG-20027 No  permitido definir o participante como "Optante pelo MEI" quando seu regime fiscal no  "Simples Nacional". Sesso: %' , vSessionID;  
    END IF;
  END IF;

  -- Paulo : 82147
  IF (TG_OP = 'UPDATE') THEN
     IF Equal(OLD.VALOR1,NEW.VALOR1) = 0 THEN
        NEW.DATCRE := Agora();
     END IF;

     --Pedro E. Braga - 93794
     SELECT FPV_PRECO_SIMULADO INTO cFPVPRECOSIMULADO FROM TT_CFG;
     IF (cFPVPRECOSIMULADO = 'T') THEN
        -- Pedro E. Braga - 92722 --Mateus 92861
        IF (Equal(OLD.DESCON, NEW.DESCON) <> 1)
        OR (Equal(OLD.CODFRE, NEW.CODFRE) <> 1)
        OR (Equal(OLD.CODFRE_ENC, NEW.CODFRE_ENC) <> 1) THEN
          cRETORNO := INSERE_MIFC('CLI',NEW.FILCLI || NEW.CODCLI);
        END IF;
     END IF;
  END IF;

  -- Paulo : 82147
  IF (TG_OP = 'INSERT') THEN
     NEW.DATCRE := Agora();
  END IF;

  -- 84801
  IF (TG_OP = 'INSERT') THEN
     NEW.FILEND := NEW.FILCLI;
     NEW.NUMEND := 1;
  END IF;

  IF (TG_OP = 'DELETE') THEN
    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
  END IF;

   IF (TG_OP = 'INSERT') THEN

    -- VERIFICA SE CATEGORIA 1 EST VAZIA E APLICA AUTOMATICAMENTE VALOR DO PARMETRO COMO PADRO
    IF(NEW.CATEG1 IS NULL) THEN
      VParametro := LeParametroTXT('CAT1CLI_NOVO', '', null, null, null);
      IF(ISNOTNULL(Trim(VParametro)) = 'T') THEN 
         NEW.CATEG1 := IMPORTA_TDS('TD_CT1', 'CT1ATI', 'NOMCT1', 'CODTAB', VParametro, NULL, NULL, NULL, NULL, NULL, NULL);
      END IF;
    END IF;
    
    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;

    -- Douglas - 83441
    NEW.CODUID := GetCoduidAtual();
    NEW.ASSINA := COALESCE(AssinaTabela('TT_CLI',
                                         ConcatenaCLI(NEW.FILCLI,
                                                      NEW.CODCLI,
                                                      NEW.NOMCLI,
                                                      NEW.NUMDOC,
                                                      NEW.ULTNOM),
                                                      null, null, null),NEW.ASSINA);
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF ConcatenaCLI(NEW.FILCLI,NEW.CODCLI,NEW.NOMCLI,NEW.NUMDOC,NEW.ULTNOM) <>
         ConcatenaCLI(OLD.FILCLI,OLD.CODCLI,OLD.NOMCLI,OLD.NUMDOC,OLD.ULTNOM) THEN

         -- LEO 84337
         SELECT BLQ_SEM_UID
           INTO vBLQ_SEM_UID
           FROM TT_CFG;
         vCODUID_ATUAL := GetCoduidAtual();
         IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;

         -- Douglas - 83441
         NEW.CODUID := GetCoduidAtual();
         NEW.ASSINA := COALESCE(AssinaTabela('TT_CLI',
                                              ConcatenaCLI(NEW.FILCLI,
                                                           NEW.CODCLI,
                                                           NEW.NOMCLI,
                                                           NEW.NUMDOC,
                                                           NEW.ULTNOM),
                                                           OLD.CODUID,
                                              ConcatenaCLI(OLD.FILCLI,
                                                           OLD.CODCLI,
                                                           OLD.NOMCLI,
                                                           OLD.NUMDOC,
                                                           OLD.ULTNOM),
                                                           OLD.ASSINA
                                              ),NEW.ASSINA);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3313 --*/
CREATE TRIGGER TGCLI3
BEFORE INSERT OR DELETE OR UPDATE ON TT_CLI 
FOR EACH ROW EXECUTE PROCEDURE TGCLI3();


/*-- SEQ 3314 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCLI4() CASCADE;

/*-- SEQ 3315 --*/
CREATE OR REPLACE FUNCTION TGCLI4() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Fazer parte do papel de uma "foreign key"
-- 2) Registrar mudanca dos dados num "log"

   codigo                        CONSTANT CHAR(6)   := '     0';
   vLOG                          VARCHAR(4000)     := '';
   cNulo                         CONSTANT CHAR(1)   := '0';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   UsaCodExt                     VARCHAR(1)      := 'F';
   linha                         INTEGER;
   vComplemento                  CONSTANT VARCHAR(100) := constante('complemento');
   cRet                          VARCHAR(2);
         
     QuemLogou                   TRetQuemLogou%ROWTYPE;
   BEGIN

  --Atualiza TT_PROxNOM
  --davi - 21/11/06 - 41296
  IF (TG_OP = 'UPDATE') THEN
    IF Equal(OLD.ULTNOM,NEW.ULTNOM) = 0 THEN
      
      cRet := PC_PROxNOM_Atualiza('IPR.FILMAR = '||chr(39)||NEW.FILCLI||chr(39)||' '||
                                  'AND IPR.CODMAR = '||chr(39)||NEW.CODCLI||chr(39)||' '||
                                  'AND IPR.TIPMAR = '||chr(39)||'M'||chr(39),
                                  null, null, null, null );
                END IF;
  END IF;
  -- Tratamento de "log"
  IF (TG_OP = 'DELETE') THEN
     DELETE FROM TL_CLI WHERE FILCLI = OLD.FILCLI AND CODCLI = OLD.CODCLI;
  END IF;

  -- Se o codigo for zero dispensa verificacao na inclusao
  IF (TG_OP = 'UPDATE') OR ((TG_OP = 'INSERT') AND NEW.CODCLI <> codigo) THEN

     -- Testa se existe a filial
     SELECT COUNT(*) INTO linha FROM TD_FIL WHERE CODFIL = NEW.FILCLI;
     IF LINHA = 0 THEN
        RAISE EXCEPTION 'PG-20023 Filial % nao existe. %' , NEW.FILCLI,vComplemento;
     END IF;

     -- 80434 - A tela de Cadastro j faz essa verificao.
     --SELECT CLICODEXT INTO UsaCodExt FROM TT_CFG;
     --IF (UsaCodExt = 'T') AND (NEW.CODEXT is null) THEN
     --   RAISE EXCEPTION 'PG-20024 Preencha o codigo externo (NRC). %' , vComplemento;
     --END IF;

  END IF;

  -- Tratamento de log
  IF (TG_OP = 'INSERT') THEN
     vLOG := 'Inclusao';
     INSERT INTO TL_CLI (FILUSU,CODUSU,FILCLI,CODCLI,DATOPE,MSGLOG)
                 VALUES (NEW.FILUSU,NEW.CODUSU,NEW.FILCLI,NEW.CODCLI,agora(),vLOG);
  ELSIF (TG_OP = 'UPDATE') THEN
     IF Equal(OLD.NOMCLI,NEW.NOMCLI) <> 1 THEN
        vLOG := vLOG||'Nome: de '||COALESCE(OLD.NOMCLI,cNulo)||' para '||COALESCE(NEW.NOMCLI,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.ULTNOM,NEW.ULTNOM) <> 1 THEN
        vLOG := vLOG||'Sobrenome/fantasia: de '||COALESCE(OLD.ULTNOM,cNulo)||' para '||COALESCE(NEW.ULTNOM,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.NUMDOC,NEW.NUMDOC) <> 1 THEN
        vLOG := vLOG||'CGC/CPF: de '||COALESCE(OLD.NUMDOC,cNulo)||' para '||COALESCE(NEW.NUMDOC,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DOCCON,NEW.DOCCON) <> 1 THEN
        vLOG := vLOG||'Doc. conjuge/contato: de '||COALESCE(OLD.DOCCON,cNulo)||' para '||COALESCE(NEW.DOCCON,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATNAS,NEW.DATNAS) <> 1 THEN
        vLOG := vLOG||'Nascimento: de '||COALESCE(TO_CHAR(OLD.DATNAS,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATNAS,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.ESTCIV,NEW.ESTCIV) <> 1 THEN
        vLOG := vLOG||'Estado civil: de '||COALESCE(DescricaoDominio('CLI','ESTCIV',TO_CHAR(OLD.ESTCIV)),cNulo)||' para '||COALESCE(DescricaoDominio('CLI','ESTCIV',TO_CHAR(NEW.ESTCIV)),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.HOMPGE,NEW.HOMPGE) <> 1 THEN
        vLOG := vLOG||'Home Page: de '||COALESCE(OLD.HOMPGE,cNulo)||' para '||COALESCE(NEW.HOMPGE,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.FLGTIP,NEW.FLGTIP) <> 1 THEN
        vLOG := vLOG||'Tipo de pessoa: de '||COALESCE(DescricaoDominio('CLI','FLGTIP',TO_CHAR(OLD.FLGTIP)),cNulo)||' para '||COALESCE(DescricaoDominio('CLI','FLGTIP',TO_CHAR(NEW.FLGTIP)),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.INSEST,NEW.INSEST) <> 1 THEN
        vLOG := vLOG||'Inscricao estadual/identidade: de '||COALESCE(OLD.INSEST,cNulo)||' para '||COALESCE(NEW.INSEST,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.CODSEX,NEW.CODSEX) <> 1 THEN
        vLOG := vLOG||'Sexo: de '||COALESCE(DescricaoDominio('CLI','CODSEX',TO_CHAR(OLD.CODSEX)),cNulo)||' para '||COALESCE(DescricaoDominio('CLI','CODSEX',TO_CHAR(NEW.CODSEX)),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.CATEG1,NEW.CATEG1) <> 1 THEN
        vLOG := vLOG||'1a. Categoria: de '||COALESCE(OLD.CATEG1,iNulo)||' para '||COALESCE(NEW.CATEG1,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.CATEG2,NEW.CATEG2) <> 1 THEN
        vLOG := vLOG||'2a. Categoria: de '||COALESCE(OLD.CATEG2,iNulo)||' para '||COALESCE(NEW.CATEG2,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.CATEG3,NEW.CATEG3) <> 1 THEN
        vLOG := vLOG||'3a. Categoria: de '||COALESCE(OLD.CATEG3,iNulo)||' para '||COALESCE(NEW.CATEG3,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATA01,NEW.DATA01) <> 1 THEN
        vLOG := vLOG||'1a. Data livre: de '||COALESCE(TO_CHAR(OLD.DATA01,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATA01,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATA02,NEW.DATA02) <> 1 THEN
        vLOG := vLOG||'2a. Data livre: de '||COALESCE(TO_CHAR(OLD.DATA02,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATA02,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATA03,NEW.DATA03) <> 1 THEN
        vLOG := vLOG||'3a. Data livre: de '||COALESCE(TO_CHAR(OLD.DATA03,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATA03,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.IMPRIM,NEW.IMPRIM) <> 1 THEN
        vLOG := vLOG||'Livre para customizacao: de '||COALESCE(OLD.IMPRIM,iNulo)||' para '||COALESCE(NEW.IMPRIM,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.VALOR1,NEW.VALOR1) <> 1 THEN
        vLOG := vLOG||'Limite credito: de '||TO_CHAR(COALESCE(OLD.VALOR1,0),'fm9G999G990D00')||' para '||TO_CHAR(COALESCE(NEW.VALOR1,0),'fm9G999G990D00')||CRLF;
     END IF;
     IF Equal(OLD.MAIATR,NEW.MAIATR) <> 1 THEN
        vLOG := vLOG||'Maior atraso registrado: de '||TO_CHAR(COALESCE(OLD.MAIATR,0),'fm9G999G990D00')||' para '||TO_CHAR(COALESCE(NEW.MAIATR,0),'fm9G999G990D00')||CRLF;
     END IF;
     IF Equal(OLD.FILPLA,NEW.FILPLA) <> 1 OR Equal(OLD.CODPLA,NEW.CODPLA) <> 1 THEN
        vLOG := vLOG||'Plano padrao: de '||COALESCE(OLD.FILPLA,cNulo)||'-'||COALESCE(OLD.CODPLA,cNulo)||' para '||COALESCE(NEW.FILPLA,cNulo)||'-'||COALESCE(NEW.CODPLA,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.CONJUG,NEW.CONJUG) <> 1 THEN
        vLOG := vLOG||'Conjuge/contato: de '||COALESCE(OLD.CONJUG,cNulo)||' para '||COALESCE(NEW.CONJUG,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.NASCON,NEW.NASCON) <> 1 THEN
        vLOG := vLOG||'Nascimento do conjuge/contato: de '||COALESCE(TO_CHAR(OLD.NASCON,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.NASCON,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SEXCON,NEW.SEXCON) <> 1 THEN
        vLOG := vLOG||'Sexo conjuge: de '||COALESCE(DescricaoDominio('CLI','SEXCON',TO_CHAR(OLD.SEXCON)),cNulo)||' para '||COALESCE(DescricaoDominio('CLI','SEXCON',TO_CHAR(NEW.SEXCON)),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.FILVEN,NEW.FILVEN) <> 1 OR Equal(OLD.CODVEN,NEW.CODVEN) <> 1 THEN
        vLOG := vLOG||'Vendedor padrao: de '||COALESCE(OLD.FILVEN,cNulo)||'-'||COALESCE(OLD.CODVEN,cNulo)||' para '||COALESCE(NEW.FILVEN,cNulo)||'-'||COALESCE(NEW.CODVEN,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.PORPAD,NEW.PORPAD) <> 1 OR Equal(OLD.TIPCOB,NEW.TIPCOB) <> 1 THEN
        vLOG := vLOG||'Portador padrao: de '||COALESCE(OLD.PORPAD,iNulo)||'-'||COALESCE(DescricaoDominio('CLI','TIPCOB',OLD.TIPCOB),cNulo)||' para '||COALESCE(NEW.PORPAD,iNulo)||'-'||COALESCE(DescricaoDominio('CLI','TIPCOB',NEW.TIPCOB),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.LIMPAR,NEW.LIMPAR) <> 1 THEN
        vLOG := vLOG||'Limite maximo de parcela: de '||COALESCE(OLD.LIMPAR,iNulo)||' para '||COALESCE(NEW.LIMPAR,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.EDICRE,NEW.EDICRE) <> 1 THEN
        vLOG := vLOG||'Limite de credito editavel : de '||COALESCE(OLD.EDICRE,cNulo)||' para '||COALESCE(NEW.EDICRE,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.PP_FLG,NEW.PP_FLG) <> 1 THEN
        vLOG := vLOG||'Prospeccao : de '||OLD.PP_FLG||' para '||NEW.PP_FLG||CRLF;
     END IF;
     IF Equal(OLD.PP_INI,NEW.PP_INI) <> 1 THEN
        vLOG := vLOG||'Inicio prospeccao: de '||COALESCE(TO_CHAR(OLD.PP_INI,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PP_INI,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.PP_FIM,NEW.PP_FIM) <> 1 THEN
        vLOG := vLOG||'Fim prospeccao: de '||COALESCE(TO_CHAR(OLD.PP_FIM,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PP_FIM,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.PP_FIL,NEW.PP_FIL) <> 1 OR Equal(OLD.PP_COD,NEW.PP_COD) <> 1 THEN
        vLOG := vLOG||'Quem prospectou: de '||COALESCE(OLD.PP_FIL,cNulo)||'/'||COALESCE(OLD.PP_COD,cNulo)||' para '||COALESCE(NEW.PP_FIL,cNulo)||'/'||COALESCE(NEW.PP_COD,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SIMPLE,NEW.SIMPLE) <> 1 THEN
        vLOG := vLOG||'Optante pelo Simples?: de '||COALESCE(OLD.SIMPLE,cNulo)||' para '||COALESCE(NEW.SIMPLE,cNulo)||CRLF;
     END IF;
     IF (OLD.SIGNAT<0 AND NEW.SIGNAT>=0) THEN
        vLOG := vLOG||'Cliente Ativado'||CRLF;
     END IF;
     IF (OLD.SIGNAT>=0 AND NEW.SIGNAT<0) THEN
        vLOG := vLOG||'Cliente Desativado'||CRLF;
     END IF;
     IF Equal(OLD.CODEXT,NEW.CODEXT) <> 1 THEN
        vLOG := vLOG||'Codigo Externo: de '||COALESCE(OLD.CODEXT,cNulo)||' para '||COALESCE(NEW.CODEXT,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.TIPDOC,NEW.TIPDOC) <> 1 THEN
        vLOG := vLOG||'Tipo Documento: de '||COALESCE(OLD.TIPDOC,cNulo)||' para '||COALESCE(NEW.TIPDOC,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.FILVIN,NEW.FILVIN) <> 1 OR Equal(OLD.CODVIN,NEW.CODVIN) <> 1 THEN
        vLOG := vLOG||'Vinculo: de '||COALESCE(OLD.FILVIN,cNulo)||'-'||COALESCE(OLD.CODVIN,cNulo)||' para '||COALESCE(NEW.FILVIN,cNulo)||'-'||COALESCE(NEW.CODVIN,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATOPE,NEW.DATOPE) <> 1 THEN
        vLOG := vLOG||'Data Inclusao: de '||COALESCE(TO_CHAR(OLD.DATOPE,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATOPE,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.NOMIMG,NEW.NOMIMG) <> 1 THEN
        vLOG := vLOG||'Nome Imagem: de '||COALESCE(OLD.NOMIMG,cNulo)||' para '||COALESCE(NEW.NOMIMG,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.ICM_CF,NEW.ICM_CF) <> 1 THEN
        vLOG := vLOG||'Reimprimir Cupom Fiscal em Nota Fiscal?: de '||COALESCE(OLD.ICM_CF,cNulo)||' para '||COALESCE(NEW.ICM_CF,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.CALL_C,NEW.CALL_C) <> 1 THEN
        vLOG := vLOG||'Aceita Contato Telefonico?: de '||COALESCE(OLD.CALL_C,cNulo)||' para '||COALESCE(NEW.CALL_C,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.OBSOUT,NEW.OBSOUT) <> 1 THEN
        vLOG := vLOG||'OBS. CheckOut: de '||COALESCE(OLD.OBSOUT,cNulo)||' para '||COALESCE(NEW.OBSOUT,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.CODFID,NEW.CODFID) <> 1 THEN
        vLOG := vLOG||'Fidelizao: de '||COALESCE(OLD.CODFID,iNulo)||' para '||COALESCE(NEW.CODFID,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.CONBOL,NEW.CONBOL) <> 1 THEN
        vLOG := vLOG||'Boleto: de '||COALESCE(OLD.CONBOL,iNulo)||' para '||COALESCE(NEW.CONBOL,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.DDTCON,NEW.DDTCON) <> 1 THEN
        vLOG := vLOG||'DDD Telefone Cnjuge: de '||COALESCE(OLD.DDTCON,cNulo)||' para '||COALESCE(NEW.DDTCON,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.TELCON,NEW.TELCON) <> 1 THEN
        vLOG := vLOG||'Telefone Cnjuge: de '||COALESCE(OLD.TELCON,cNulo)||' para '||COALESCE(NEW.TELCON,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DDCCON,NEW.DDCCON) <> 1 THEN
        vLOG := vLOG||'DDD Celular Cnjuge: de '||COALESCE(OLD.DDCCON,cNulo)||' para '||COALESCE(NEW.DDCCON,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.CELCON,NEW.CELCON) <> 1 THEN
        vLOG := vLOG||'Celular Cnjuge: de '||COALESCE(OLD.CELCON,cNulo)||' para '||COALESCE(NEW.CELCON,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.E_MCON,NEW.E_MCON) <> 1 THEN
        vLOG := vLOG||'E-mail Cnjuge: de '||COALESCE(OLD.E_MCON,cNulo)||' para '||COALESCE(NEW.E_MCON,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.NOMTRA,NEW.NOMTRA) <> 1 THEN
        vLOG := vLOG||'Apelido: de '||COALESCE(OLD.NOMTRA,cNulo)||' para '||COALESCE(NEW.NOMTRA,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.ID_ORG,NEW.ID_ORG) <> 1 THEN
        vLOG := vLOG||'Orgao Expeditor: de '||COALESCE(OLD.ID_ORG,cNulo)||' para '||COALESCE(NEW.ID_ORG,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.ID_EST,NEW.ID_EST) <> 1 THEN
        vLOG := vLOG||'UF do RG: de '||COALESCE(OLD.ID_EST,cNulo)||' para '||COALESCE(NEW.ID_EST,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.ID_DAT,NEW.ID_DAT) <> 1 THEN
        vLOG := vLOG||'Data RG: de '||COALESCE(TO_CHAR(OLD.ID_DAT,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ID_DAT,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.GLOBAL,NEW.GLOBAL) <> 1 THEN
        vLOG := vLOG||'Faturamento Global: de '||COALESCE(DescricaoDominio('CLI','GLOBAL',OLD.GLOBAL),cNulo)||' para '||COALESCE(DescricaoDominio('CLI','GLOBAL',NEW.GLOBAL),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.CODINA,NEW.CODINA) <> 1 THEN
        vLOG := vLOG||'Motivo Inatividade: de '||COALESCE(OLD.CODINA,iNulo)||' para '||COALESCE(NEW.CODINA,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.NAOSPC,NEW.NAOSPC) <> 1 THEN
        vLOG := vLOG||'Nao sujeito a cobranca (SPC): de '||COALESCE(OLD.NAOSPC,cNulo)||' para '||COALESCE(NEW.NAOSPC,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.ATUCUS,NEW.ATUCUS) <> 1 THEN
        vLOG := vLOG||'Atualiza Custos?: de '||COALESCE(OLD.ATUCUS,cNulo)||' para '||COALESCE(NEW.ATUCUS,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.FILCON,NEW.FILCON) <> 1 OR Equal(OLD.CODCON,NEW.CODCON) <> 1 THEN
        vLOG := vLOG||'Reg. Conjuge: de '||COALESCE(OLD.FILCON,cNulo)||'-'||COALESCE(OLD.CODCON,cNulo)||' para '||COALESCE(NEW.FILCON,cNulo)||'-'||COALESCE(NEW.CODCON,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.CCCPRE,NEW.CCCPRE) <> 1 THEN
        vLOG := vLOG||'Conta corrente preferencial: de '||COALESCE(OLD.CCCPRE,iNulo)||' para '||COALESCE(NEW.CCCPRE,iNulo)||CRLF;
     END IF;
     -- 84801
     IF (Equal(OLD.FILEND,NEW.FILEND) <> 1) OR
        (Equal(OLD.NUMEND,NEW.NUMEND) <> 1) THEN
        vLOG := vLOG||'Endereo Principal: de '||COALESCE(OLD.FILEND,cNulo)||'-'||COALESCE(OLD.NUMEND,iNulo)||' para '||COALESCE(NEW.FILEND,cNulo)||'-'||COALESCE(NEW.NUMEND,iNulo)||CRLF;
     END IF;
     --rodrigo 59007
     IF (Equal(OLD.FILGUI,NEW.FILGUI) <> 1) OR
        (Equal(OLD.CODGUI,NEW.CODGUI) <> 1) THEN
         vLOG := vLOG||'Indicador de Venda: de '||COALESCE(OLD.FILGUI,cNulo)||'/'||COALESCE(OLD.CODGUI,cNulo)||' para '||COALESCE(NEW.FILGUI,cNulo)||'/'||COALESCE(NEW.CODGUI,cNulo)||CRLF;
     END IF;
     --Manoel - 86015
     IF Equal(OLD.ISECHE,NEW.ISECHE) <> 1 THEN
        vLOG := vLOG||'Isenta taxa na troca de cheque?: de '||COALESCE(OLD.ISECHE,cNulo)||' para '||COALESCE(NEW.ISECHE,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.NAODIV,NEW.NAODIV) <> 1 THEN
        vLOG := vLOG||'Nao sujeito a restricao?: de '||COALESCE(OLD.NAODIV,cNulo)||' para '||COALESCE(NEW.NAODIV,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.ENTISE,NEW.ENTISE) <> 1 THEN
        vLOG := vLOG||'Entidade isenta de Imposto?: de '||COALESCE(OLD.ENTISE,cNulo)||' para '||COALESCE(NEW.ENTISE,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.E_MFIN,NEW.E_MFIN) <> 1 THEN
        vLOG := vLOG||'E-mail do Financeiro: de '||COALESCE(OLD.E_MFIN,cNulo)||' para '||COALESCE(NEW.E_MFIN,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DEPART,NEW.DEPART) <> 1 THEN
        vLOG := vLOG||'Departamento: de '||COALESCE(OLD.DEPART,iNulo)||' para '||COALESCE(NEW.DEPART,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.CLASS1,NEW.CLASS1) <> 1 THEN
        vLOG := vLOG||'Classe1: de '||COALESCE(OLD.CLASS1,iNulo)||' para '||COALESCE(NEW.CLASS1,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.CLASS2,NEW.CLASS2) <> 1 THEN
        vLOG := vLOG||'Classe2: de '||COALESCE(OLD.CLASS2,iNulo)||' para '||COALESCE(NEW.CLASS2,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.CLASS3,NEW.CLASS3) <> 1 THEN
        vLOG := vLOG||'Classe3: de '||COALESCE(OLD.CLASS3,iNulo)||' para '||COALESCE(NEW.CLASS3,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.CLASS4,NEW.CLASS4) <> 1 THEN
        vLOG := vLOG||'Classe4: de '||COALESCE(OLD.CLASS4,iNulo)||' para '||COALESCE(NEW.CLASS4,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.PARPED,NEW.PARPED) <> 1 THEN
        vLOG := vLOG||'Parcelas para pedido: de '||COALESCE(OLD.PARPED,iNulo)||' para '||COALESCE(NEW.PARPED,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.PREENT,NEW.PREENT) <> 1 THEN
        vLOG := vLOG||'Previso de entrega: de '||COALESCE(OLD.PREENT,iNulo)||' para '||COALESCE(NEW.PREENT,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.PRIPAR,NEW.PRIPAR) <> 1 THEN
        vLOG := vLOG||'Dias para primeira parcela: de '||COALESCE(OLD.PRIPAR,iNulo)||' para '||COALESCE(NEW.PRIPAR,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.PERIOD,NEW.PERIOD) <> 1 THEN
        vLOG := vLOG||'Intervalo dias entre parcelas: de '||COALESCE(OLD.PERIOD,iNulo)||' para '||COALESCE(NEW.PERIOD,iNulo)||CRLF;
     END IF;
     IF Equal(COALESCE(OLD.DESCON,0),COALESCE(NEW.DESCON,0)) <> 1 THEN
        vLOG := vLOG||'% Desconto/Acrscimo: de '||COALESCE(TO_CHAR(OLD.DESCON),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DESCON),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.TIPDES,NEW.TIPDES) <> 1 THEN
        vLOG := vLOG||'Tipo Desconto: de '||COALESCE(OLD.TIPDES,iNulo)||' para '||COALESCE(NEW.TIPDES,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.FILFIA,NEW.FILFIA) <> 1) OR
        (Equal(OLD.CODFIA,NEW.CODFIA) <> 1) THEN
         vLOG := vLOG||'Fiador: de '||COALESCE(OLD.FILFIA,cNulo)||'/'||COALESCE(OLD.CODFIA,cNulo)||' para '||COALESCE(NEW.FILFIA,cNulo)||'/'||COALESCE(NEW.CODFIA,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.MAXBON,NEW.MAXBON) <> 1 THEN
        vLOG := vLOG||'Quantidade mxima de bnus: de '||COALESCE(OLD.MAXBON,iNulo)||' para '||COALESCE(NEW.MAXBON,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.VENBON,NEW.VENBON) <> 1 THEN
        vLOG := vLOG||'Vendas acumuladas para clculo de bnus: de '||COALESCE(OLD.VENBON,iNulo)||' para '||COALESCE(NEW.VENBON,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.CODFRE,NEW.CODFRE) <> 1 THEN
        vLOG := vLOG||'Poltica de Frete Padro: de '||COALESCE(OLD.CODFRE,iNulo)||' para '||COALESCE(NEW.CODFRE,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.CODFRE_ENC,NEW.CODFRE_ENC) <> 1 THEN
        vLOG := vLOG||'Poltica de Frete p/ Prod. Somente Encomendas: de '||COALESCE(OLD.CODFRE_ENC,iNulo)||' para '||COALESCE(NEW.CODFRE_ENC,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.COD_RNTC,NEW.COD_RNTC) <> 1 THEN
        vLOG := vLOG||'Cdigo RNTC: de '||COALESCE(OLD.COD_RNTC,cNulo)||' para '||COALESCE(NEW.COD_RNTC,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.FIL_CK,NEW.FIL_CK) <> 1 THEN
        vLOG := vLOG||'Filial para cliente cadastrado no Checkout: de '||COALESCE(OLD.FIL_CK,cNulo)||' para '||COALESCE(NEW.FIL_CK,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.ECF_CK,NEW.ECF_CK) <> 1 THEN
        vLOG := vLOG||'ECF para cliente cadastrado no Checkout: de '||COALESCE(OLD.ECF_CK,cNulo)||' para '||COALESCE(NEW.ECF_CK,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.COD_CK,NEW.COD_CK) <> 1 THEN
        vLOG := vLOG||'Cdigo para cliente cadastrado no Checkout: de '||COALESCE(OLD.COD_CK,iNulo)||' para '||COALESCE(NEW.COD_CK,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.REGESP,NEW.REGESP) <> 1 THEN
        vLOG := vLOG||'Fornecedor possui Regime Especial?: de '||COALESCE(OLD.REGESP,cNulo)||' para '||COALESCE(NEW.REGESP,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.LABORATORIO,NEW.LABORATORIO) <> 1 THEN
        vLOG := vLOG||'Laboratrio: de '||COALESCE(OLD.LABORATORIO,iNulo)||' para '||COALESCE(NEW.LABORATORIO,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.VALLIM,NEW.VALLIM) <> 1 THEN
        vLOG := vLOG||'Validade do Limite: de '||COALESCE(TO_CHAR(OLD.VALLIM,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VALLIM,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;     
     IF Equal(OLD.DENEGA,NEW.DENEGA) <> 1 THEN
        vLOG := vLOG||'Cliente Denegado?: de '||COALESCE(DescricaoDominio('CLI','DENEGA',TO_CHAR(OLD.DENEGA)),cNulo)||' para '||COALESCE(DescricaoDominio('CLI','DENEGA',TO_CHAR(NEW.DENEGA)), cNulo)||CRLF;
     END IF;
     IF Equal(OLD.VLRMIN_PEDCOM,NEW.VLRMIN_PEDCOM) <> 1 THEN
        vLOG := vLOG||'Valor Mnimo para Pedido de Compra: de '||TO_CHAR(COALESCE(OLD.VLRMIN_PEDCOM,0),'fm999G999G999G990D00')||' para '||TO_CHAR(COALESCE(NEW.VLRMIN_PEDCOM,0),'fm999G999G999G990D00')||CRLF;
     END IF;
     IF Equal(OLD.REGMEI,NEW.REGMEI) <> 1 THEN
        vLOG := vLOG||'Optante pelo MEI?: de '||COALESCE(OLD.REGMEI,cNulo)||' para '||COALESCE(NEW.REGMEI,cNulo)||CRLF;
     END IF;
	 IF Equal(OLD.CLISER,NEW.CLISER) <> 1 THEN
        vLOG := vLOG||'Serie padro: de '||COALESCE(OLD.CLISER,cNulo)||' para '||COALESCE(NEW.CLISER,cNulo)||CRLF;
     END IF;
     -- Campo no adicionado ao Log pois  um campo interno de controle da exportao assim no se faz necessrio gravar log
     --IF Equal(OLD.INDEXP,NEW.INDEXP) <> 1 THEN
     --   vLOG := vLOG||'Indicador de Exportao: de '||COALESCE(DescricaoDominio('CLI','INDEXP',TO_CHAR(OLD.INDEXP)),cNulo)||' para '||COALESCE(DescricaoDominio('CLI','INDEXP',TO_CHAR(NEW.INDEXP)), cNulo)||CRLF;
     --END IF;
     --
     -- Atencao: as colunas TOTATR, TOTPAR, ISENHA, ULTCOM, SALBON, INDEXP  no devem estar no LOG
     --
     IF (TRIM(NEW.DUMMY) <> Constante('VEM_DE_TGWCLI')) OR (TRIM(NEW.DUMMY) = NULL) THEN
        select * into QuemLogou from DadosLogon();
     END IF;
     
     IF ISNOTNULL(trim(vLOG)) = 'T' THEN
        -- cadastra o LOG.
        INSERT INTO TL_CLI (FILUSU,CODUSU,FILCLI,CODCLI,DATOPE,MSGLOG)
                    VALUES (QuemLogou.FILUSU,QuemLogou.CODUSU,NEW.FILCLI,NEW.CODCLI,agora(),vLOG);
     END IF;
     IF COALESCE(OLD.OBSERV,'XXX')<>COALESCE(NEW.OBSERV,'XXX') THEN
        -- cadastra o LOG.
        INSERT INTO TL_CLI (FILUSU,CODUSU,FILCLI,CODCLI,DATOPE,MSGLOG)
                    VALUES (QuemLogou.FILUSU,QuemLogou.CODUSU,NEW.FILCLI,NEW.CODCLI,agora(),CASE WHEN ISNOTNULL(TRIM(OLD.OBSERV))='T' THEN OLD.OBSERV ELSE '<NULO>' END);
     END IF;
     IF COALESCE(OLD.OBSFOR,'XXX')<>COALESCE(NEW.OBSFOR,'XXX') THEN
        -- cadastra o LOG da OBSFOR.
        INSERT INTO TL_CLI (FILUSU,CODUSU,FILCLI,CODCLI,DATOPE,MSGLOG)
                    VALUES (QuemLogou.FILUSU,QuemLogou.CODUSU,NEW.FILCLI,NEW.CODCLI,agora(),'Obs. Fornecedor: '||CASE WHEN ISNOTNULL(TRIM(OLD.OBSFOR))='T' THEN OLD.OBSFOR ELSE '<NULO>' END);
     END IF;

  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3316 --*/
CREATE TRIGGER TGCLI4
AFTER INSERT OR UPDATE ON TT_CLI 
FOR EACH ROW EXECUTE PROCEDURE TGCLI4();

/*-- SEQ 3317 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCLI5() CASCADE;

/*-- SEQ 3318 --*/
CREATE OR REPLACE FUNCTION TGCLI5() RETURNS TRIGGER AS $$
DECLARE
  pg_dummy VARCHAR(5)
;
BEGIN
  IF PC_TRIGGERS_ENABLED('PC_CONJUGE') THEN
    pg_dummy := PC_INIT('PC_CONJUGE',FALSE);
pg_dummy := PC_EXECUTE('PC_CONJUGE','ATUALIZACONJUGE');
pg_dummy := PC_INIT('PC_CONJUGE')
;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3319 --*/
CREATE TRIGGER TGCLI5
AFTER INSERT OR UPDATE ON TT_CLI 
FOR STATEMENT EXECUTE PROCEDURE TGCLI5();


/*-- SEQ 3320 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCLI_DW() CASCADE;

/*-- SEQ 3321 --*/
CREATE OR REPLACE FUNCTION TGCLI_DW() RETURNS TRIGGER AS $$
DECLARE
   bProcessa                     BOOLEAN DEFAULT False;
      
      regDW                      RECORD;
      cDUMMY                        VARCHAR(2);
   vFILCLI                       TT_CLI.FILCLI%TYPE;
   vCODCLI                       TT_CLI.CODCLI%TYPE;
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');

-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Vendas_Cliente

BEGIN
  IF UsaVMDecisor() = 'T' THEN
     -- (TG_OP = 'INSERT'): No faz nada porque no est relacionado a nenhum registro pai
     -- (TG_OP = 'DELETE'): Garantido pela FK
     IF (TG_OP = 'UPDATE') THEN
       IF Equal(OLD.FILCLI,NEW.FILCLI) <> 1 --PK
       OR Equal(OLD.CODCLI,NEW.CODCLI) <> 1 --PK
       THEN
         RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
       END IF;
       IF Equal(OLD.FLGTIP,NEW.FLGTIP) <> 1
       OR Equal(OLD.CODSEX,NEW.CODSEX) <> 1
       OR Equal(OLD.ESTCIV,NEW.ESTCIV) <> 1
       OR Equal(OLD.CATEG1,NEW.CATEG1) <> 1
       OR Equal(OLD.CATEG2,NEW.CATEG2) <> 1
       OR Equal(OLD.CATEG3,NEW.CATEG3) <> 1 THEN
         bProcessa := True;
         vFILCLI   := NEW.FILCLI;
         vCODCLI   := NEW.CODCLI;
       END IF;
     END IF;

     IF bProcessa THEN
       FOR regDW IN (SELECT DW.Filial,
                            DW.Filial_Cliente,
                            DW.Codigo_Cliente,
                            DW.Ano_Mes
                       FROM DW_Vendas_Cliente DW
                      WHERE DW.Filial_Cliente = vFILCLI
                        AND DW.Codigo_Cliente = vCODCLI)
       LOOP
         cDUMMY := Insere_DW_Log_Vendas_Cliente(regDW.FILIAL, regDW.Filial_Cliente, regDW.Codigo_Cliente, regDW.ANO_MES);
       END LOOP;
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3322 --*/
CREATE TRIGGER TGCLI_DW
AFTER UPDATE ON TT_CLI 
FOR EACH ROW EXECUTE PROCEDURE TGCLI_DW();

/*-- SEQ 3323 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCLI_ASS() CASCADE;

/*-- SEQ 3324 --*/
CREATE OR REPLACE FUNCTION TGCLI_ASS() RETURNS TRIGGER AS $$
-- 83073
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN
  
  IF ExisteFilialNaUF('SC') THEN 
     IF (TG_OP = 'INSERT') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG + 1
        WHERE NOMTAB = 'TT_CLI';
     END IF;
     
     IF (TG_OP = 'DELETE') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG - 1
        WHERE NOMTAB = 'TT_CLI';
     END IF;  
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3325 --*/
CREATE TRIGGER TGCLI_ASS
AFTER INSERT OR DELETE ON TT_CLI 
FOR EACH ROW EXECUTE PROCEDURE TGCLI_ASS();



/*-- SEQ 3326 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCLIXINT() CASCADE;

/*-- SEQ 3327 --*/
CREATE OR REPLACE FUNCTION TGCLIXINT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Gerar um cdigo sequencial exclusivo para compor a chave primria.
-- 2. Atualiza controles de data.

-- Declarao de variveis e cursores

-- Principal
BEGIN

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.ID_CLIxINT IS NULL THEN
         SELECT NEXTVAL('SQCLXI') INTO NEW.ID_CLIxINT FROM DUAL;
      END IF;
      NEW.DATINC := Agora();
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3328 --*/
CREATE TRIGGER TGCLIXINT
BEFORE INSERT OR UPDATE OR DELETE ON TT_CLIXINT 
FOR EACH ROW EXECUTE PROCEDURE TGCLIXINT();

/*-- SEQ 3329 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCLIXINT2() CASCADE;

/*-- SEQ 3330 --*/
CREATE OR REPLACE FUNCTION TGCLIXINT2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Registrar mudanas dos dados no log (TL_CLI).

-- Declarao de variveis e cursores
   cLog                          VARCHAR(4000) := '';
   cFILUSU                       TT_USU.FILUSU%TYPE;
   cCODUSU                       TT_USU.CODUSU%TYPE;
   cNulo                         CONSTANT CHAR(04) := 'Nulo';
   CRLF                          CONSTANT CHAR(01) := CHR(10);
   nCODUID                       TT_UID.CODUID%TYPE;
   cDESTIPXINT                   TD_TIPXINT.DESTIPXINT%TYPE;
      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
   
   cOld                          VARCHAR(255);
   cNew                          VARCHAR(255);
   
-- Principal
BEGIN
         SELECT MAX(CODUID)
        INTO nCODUID
        FROM TT_UID
       WHERE SESSION_ID = USERENV('SESSIONID');
   
   select * into QuemLogou from DadosLogon();
   cFILUSU := QuemLogou.FILUSU;
   cCODUSU := QuemLogou.CODUSU;

   IF (TG_OP = 'INSERT') THEN
     SELECT DESTIPXINT INTO cDESTIPXINT FROM TD_TIPXINT WHERE CODTAB = NEW.TIPINT;
     
     cLog := 'Incluso da Identificao do Intermediador "' || cDESTIPXINT || '".';
     
     INSERT INTO TL_CLI (FILUSU,CODUSU,FILCLI,CODCLI,DATOPE,MSGLOG)
                 VALUES (cFILUSU,cCODUSU,NEW.FILCLI,NEW.CODCLI,agora(),cLog);
   ELSIF (TG_OP = 'DELETE') THEN
     SELECT DESTIPXINT INTO cDESTIPXINT FROM TD_TIPXINT WHERE CODTAB = OLD.TIPINT;
     
     cLog := 'Excluso da Identificao do Intermediador "' || cDESTIPXINT || '".';
     
     INSERT INTO TL_CLI (FILUSU,CODUSU,FILCLI,CODCLI,DATOPE,MSGLOG)
                 VALUES (cFILUSU,cCODUSU,OLD.FILCLI,OLD.CODCLI,agora(),cLog);   
   ELSIF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.ATU_EM,NEW.ATU_EM) <> 1 THEN
         cLog := cLog||'Data de Atualizao da Identificao do Intermediador: de '||COALESCE(TO_CHAR(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
      END IF;
	   IF Equal(OLD.FILCLI,NEW.FILCLI) <> 1 THEN
         cLog := cLog||'Filial do Parceiro da Identificao do Intermediador: de '||COALESCE(OLD.FILCLI,cNulo)||' para '||COALESCE(NEW.FILCLI,cNulo)||CRLF;
      END IF;
	   IF Equal(OLD.CODCLI,NEW.CODCLI) <> 1 THEN
         cLog := cLog||'Cdigo do Parceiro da Identificao do Intermediador: de '||COALESCE(OLD.CODCLI,cNulo)||' para '||COALESCE(NEW.CODCLI,cNulo)||CRLF;
      END IF;
	   IF Equal(OLD.TIPINT,NEW.TIPINT) <> 1 THEN
         IF OLD.TIPINT IS NULL THEN
           cOld := cNulo;
         ELSE
           SELECT DESTIPxINT INTO cOld FROM TD_TIPxINT WHERE CODTAB = OLD.TIPINT;
         END IF;
         IF NEW.TIPINT IS NULL THEN
           cNew := cNulo;
         ELSE
           SELECT DESTIPxINT INTO cNew FROM TD_TIPxINT WHERE CODTAB = NEW.TIPINT;
         END IF;
         
         cLog := cLog||'Tipo da Identificao do Intermediador: de '||cOld||' para '||cNew||CRLF;      
      END IF;
      IF Equal(OLD.CODINT,NEW.CODINT) <> 1 THEN
         cLog := cLog||'Cdigo da Identificao do Intermediador: de '||COALESCE(OLD.CODINT,cNulo)||' para '||COALESCE(NEW.CODINT,cNulo)||CRLF;
      END IF;
     
      IF ISNOTNULL(TRIM(cLog)) = 'T' THEN
         -- cadastra o LOG.
         INSERT INTO TL_CLI (FILUSU,CODUSU,FILCLI,CODCLI,DATOPE,MSGLOG)
                     VALUES (cFILUSU, cCODUSU, NEW.FILCLI, NEW.CODCLI, agora(), cLog);
      END IF;
   END IF;
   
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3331 --*/
CREATE TRIGGER TGCLIXINT2
AFTER INSERT OR UPDATE OR DELETE ON TT_CLIXINT 
FOR EACH ROW EXECUTE PROCEDURE TGCLIXINT2();


/*-- SEQ 3332 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCMS() CASCADE;

/*-- SEQ 3333 --*/
CREATE OR REPLACE FUNCTION TGCMS() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Tarefa  67463 --
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

  vComplemento       VARCHAR(100) := constante('complemento');

BEGIN
  IF (TG_OP = 'INSERT') THEN
     IF NEW.SEQUEN IS NULL THEN
        NEW.SEQUEN := ProximoCodigo('TT_CMS', NEW.CODFIL);
     END IF;
     NEW.DATINC := agora();
  END IF;
  IF (TG_OP = 'UPDATE') THEN  
     IF NEW.NROCAN > 0 THEN -- RFMP 73337
        RAISE EXCEPTION 'PG-20010 No  permitido modificar uma comisso cancelada ou alterada por outro usurio. %' , vComplemento;
     END IF;
     IF OLD.FLGEST <> 'C' AND NEW.FLGEST = 'C' THEN 
        SELECT NEXTVAL('SQCMSNROCAN') INTO NEW.NROCAN FROM DUAL;
     END IF;
  END IF;

  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     NEW.ATU_EM := agora();
  END IF;  

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3334 --*/
CREATE TRIGGER TGCMS
BEFORE INSERT OR UPDATE ON TT_CMS 
FOR EACH ROW EXECUTE PROCEDURE TGCMS();


/*-- SEQ 3335 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCOB() CASCADE;

/*-- SEQ 3336 --*/
CREATE OR REPLACE FUNCTION TGCOB() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
  WK_COUNT Numeric(5);
  vLOG          VARCHAR(4000)     := '';                      -- LOG GERAL

BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN := ProximoCodigo('TT_COB',NEW.CODFIL);       
    END IF;
    NEW.DATOPE:=AGORA();        
  END IF;
  IF (TG_OP = 'UPDATE') THEN
    IF (Equal(NEW.NAOSPC, OLD.NAOSPC) <> 1) THEN
       NEW.QTDNAO := COALESCE(OLD.QTDNAO,0)+1;
    ELSE
       NEW.QTDNAO := OLD.QTDNAO;
    END IF;
    
    IF ((COALESCE(OLD.FILCLI,'Nulo') <> COALESCE(NEW.FILCLI,'Nulo')) OR (COALESCE(OLD.CODCLI,'Nulo') <> COALESCE(NEW.CODCLI,'Nulo'))) THEN
      vLOG := vLOG||'Cliente Cobranca : de '||COALESCE(OLD.FILCLI,'Nulo')||'-'||COALESCE(OLD.CODCLI,'Nulo')||
             ' para '||COALESCE(NEW.FILCLI,'Nulo')||'-'||COALESCE(NEW.CODCLI,'Nulo')||chr(13)||chr(10);
    END IF;
    
    IF ((COALESCE(OLD.FILREC,'Nulo') <> COALESCE(NEW.FILREC,'Nulo')) OR 
    (COALESCE(OLD.SEQREC,'Nulo') <> COALESCE(NEW.SEQREC,'Nulo')) OR 
    (COALESCE(OLD.NUMPAR,'Nulo') <> COALESCE(NEW.NUMPAR,'Nulo')) OR 
    (COALESCE(OLD.SUBPAR,'Nulo') <> COALESCE(NEW.SUBPAR,'Nulo'))) THEN
      vLOG := vLOG||'Parcela Recebimento Cobranca: de '||COALESCE(OLD.FILREC,'Nulo')||'-'||COALESCE(OLD.SEQREC,'Nulo')||'/'||COALESCE(OLD.NUMPAR,'Nulo')||'-'||COALESCE(OLD.SUBPAR,'Nulo')||
             ' para '||COALESCE(NEW.FILREC,'Nulo')||'-'||COALESCE(NEW.SEQREC,'Nulo')||'/'||COALESCE(NEW.NUMPAR,'Nulo')||'-'||COALESCE(NEW.SUBPAR,'Nulo')||chr(13)||chr(10);
    END IF;
    
    IF ((COALESCE(OLD.FILCHR,'Nulo') <> COALESCE(NEW.FILCHR,'Nulo')) OR (COALESCE(OLD.SEQCHR,'Nulo') <> COALESCE(NEW.SEQCHR,'Nulo'))) THEN
      vLOG := vLOG||'Cheque Cobranca : de '||COALESCE(OLD.FILCHR,'Nulo')||'-'||COALESCE(OLD.SEQCHR,'Nulo')||
             ' para '||COALESCE(NEW.FILCHR,'Nulo')||'-'||COALESCE(NEW.SEQCHR,'Nulo')||chr(13)||chr(10);
    END IF;

    IF ((COALESCE(OLD.FILSUP,'Nulo') <> COALESCE(NEW.FILSUP,'Nulo')) OR (COALESCE(OLD.SEQSUP,'Nulo') <> COALESCE(NEW.SEQSUP,'Nulo'))) THEN
      vLOG := vLOG||'Suporte Cobranca : de '||COALESCE(OLD.FILSUP,'Nulo')||'-'||COALESCE(OLD.SEQSUP,'Nulo')||
             ' para '||COALESCE(NEW.FILSUP,'Nulo')||'-'||COALESCE(NEW.SEQSUP,'Nulo')||chr(13)||chr(10);
    END IF;
    
    IF (Equal(NEW.DATOPE, OLD.DATOPE) <> 1) THEN
      vLOG := vLOG||'Data Operao Cobrana : de '||TO_CHAR(OLD.DATOPE,'DD/MM/YYYY HH24:MI:SS')||' para '||TO_CHAR(NEW.DATOPE,'DD/MM/YYYY HH24:MI:SS')||chr(13)||chr(10);
    END IF;    

    IF (Equal(NEW.DATVEN, OLD.DATVEN) <> 1) THEN
      vLOG := vLOG||'Data Venda para Cobrana : de '||TO_CHAR(OLD.DATVEN,'DD/MM/YYYY HH24:MI:SS')||' para '||TO_CHAR(NEW.DATVEN,'DD/MM/YYYY HH24:MI:SS')||chr(13)||chr(10);
    END IF;    
    
    IF (Equal(NEW.NAOSPC, OLD.NAOSPC) <> 1) THEN
      vLOG := vLOG||'No SPC alterado: de '||TO_CHAR(OLD.NAOSPC,'DD/MM/YYYY HH24:MI:SS')||' para '||TO_CHAR(NEW.NAOSPC,'DD/MM/YYYY HH24:MI:SS')||chr(13)||chr(10);
    END IF;

    IF ( ISNOTNULL(vLOG)='T') THEN
      INSERT into TL_SUP (CODFIL,SEQUEN,MSGLOG,FLGMUD)
      VALUES (NEW.FILSUP,NEW.SEQSUP,vLOG,'O');
    END IF;
    
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3337 --*/
CREATE TRIGGER TGCOB
BEFORE INSERT OR UPDATE ON TT_COB 
FOR EACH ROW EXECUTE PROCEDURE TGCOB();


/*-- SEQ 3338 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCOD1() CASCADE;

/*-- SEQ 3339 --*/
CREATE OR REPLACE FUNCTION TGCOD1() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Popular SEQUEN

-- Principal
BEGIN

  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
      NEW.SEQUEN := ProximoCodigo('TT_COD', NEW.FILCOD);
    END IF;
  END IF; 

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3340 --*/
CREATE TRIGGER TGCOD1
BEFORE INSERT ON TT_COD 
FOR EACH ROW EXECUTE PROCEDURE TGCOD1();

/*-- SEQ 3341 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCOD2() CASCADE;

/*-- SEQ 3342 --*/
CREATE OR REPLACE FUNCTION TGCOD2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Evitar mais do que um contador de codigos EAN no banco

   maximo        Numeric;
   vComplemento  VARCHAR(254);
-- Principal
BEGIN

   vComplemento  := constante('complemento');
   SELECT COUNT(*) INTO maximo FROM TT_COD WHERE CODTAB = 'EAN';

   IF maximo > 1 THEN
      RAISE EXCEPTION 'PG-20001 Nao pode haver mais do que um contador para EAN. %' , vComplemento;
   END IF; 

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3343 --*/
CREATE TRIGGER TGCOD2
AFTER INSERT OR UPDATE ON TT_COD 
FOR STATEMENT EXECUTE PROCEDURE TGCOD2();


/*-- SEQ 3344 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCOM1() CASCADE;

/*-- SEQ 3345 --*/
CREATE OR REPLACE FUNCTION TGCOM1() RETURNS TRIGGER AS $$
-- Nota essa trigger foi quebrada em 3 partes para resolver
-- os seguintes problemas:
-- 1) Erro da integridade FK_COM_FRM numa alteracao
-- 2) Erro ORA-03114 numa alteracao

-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
DECLARE
   vComplemento  VARCHAR(254):= constante('complemento');
   cDUMMY     VARCHAR(10);
   vDATOPE    TT_COM.DATOPE%TYPE;
BEGIN
  -- Gera um codigo automaticamente
  IF NEW.SEQUEN IS NULL THEN
    NEW.SEQUEN:=ProximoCodigo('TT_COM',NEW.CODFIL);
  END IF;
  IF (TG_OP = 'INSERT') THEN
    NEW.DATINC  := agora();
  END IF;

  -- DN - Financeiro Estoque
  IF ((TG_OP = 'INSERT') OR (TG_OP = 'UPDATE')) THEN
     NEW.DATSTR:=TO_CHAR(NEW.DATOPE,'DD/MM/YYYY');
  END IF;

-- Busca a data da SAIDA DA TRANSFERENCIA
  IF (NEW.CODFOR = '     0') THEN
        -- 80735
        select CASE WHEN ORI.TRAORI='F' OR DES.TRAORI='F'
                    THEN NEW.DATOPE
					ELSE ven.dathor
               END AS DATHOR
        INTO vDATOPE
        from tt_ven ven INNER JOIN TD_FIL ORI ON VEN.CODFIL=ORI.CODFIL
		                INNER JOIN TD_FIL DES ON VEN.FILCLI=DES.CODFIL
        where ven.codfil = NEW.FILFOR
          and ven.numecf = NEW.SUBSER
          and ven.codser = NEW.CODSER
          and ven.numnot = substr(NEW.NUMNOT,4)
          and ven.filcli = NEW.CODFIL
          and ven.codcli = NEW.CODFOR;

       NEW.DATOPE := COALESCE(vDATOPE,NEW.DATOPE);

   END IF;

  -- Complementa FK_COM_CTA quando a nota nao for fatura e a FK estiver vazia
  IF (NEW.TIPNOT <> 'F') AND
     ((NEW.FILCTA is NULL) OR (NEW.SEQCTA is NULL)) THEN
     SELECT FILCTA, SEQCTA, TIPCTA
     INTO NEW.FILCTA,NEW.SEQCTA,NEW.TIPCTA
     FROM TD_CTA
     WHERE CFGCOL='TIPCTA_GER';
  END IF;

  -- Anula FK_COM_CTA quando a nota for fatura
  IF (NEW.TIPNOT = 'F') THEN
     NEW.FILCTA := NULL;
     NEW.SEQCTA := NULL;
     NEW.TIPCTA := 'G';
  END IF;

  -- Gera proximo sequenciador de cancelamento e cancela tambem os itens da compra
  IF (NEW.FLGEST = 'D') THEN
    NEW.SEQCAN:=ProximoCodigo('TT_COM_CANCELAMENTO',NEW.CODFIL);
    -- Improvavel mas...
    IF (NEW.SEQCAN IS NULL) THEN
      RAISE EXCEPTION 'PG-20026 Falha na geracao do sequenciador de cancelamento.%' , vComplemento;
    END IF;
  END IF;

  IF NEW.TIPNOT = 'A' THEN
    IF (NEW.SEQFAT IS NULL) OR (NEW.SEQUEN != NEW.SEQFAT) THEN
      NEW.SEQFAT := NEW.SEQUEN;
    END IF;
  END IF;

  -- Evita espacos no codigo de serie
  IF LENGTH(LTRIM(RTRIM(NEW.CODSER))) != 2 THEN
    NEW.CODSER := LTRIM(RTRIM(NEW.CODSER));
  END IF;

  -- Alinhar a subserie
  NEW.SUBSER := lpad(LTRIM(RTRIM(NEW.SUBSER)),3,' ');

  -- davi - 42372 - 06/02/06
  IF (NEW.POREMP is NULL) OR (NEW.TIPEMP is NULL) THEN
        SELECT POREMP,TIPEMP
       INTO NEW.POREMP,NEW.TIPEMP
       FROM TT_CLI
      WHERE FILCLI = NEW.FILFOR
        AND CODCLI = NEW.CODFOR;
     END IF;

  -- Evita "brancos" na subserie
  IF LTRIM(RTRIM(NEW.SUBSER)) IS NULL THEN
    NEW.SUBSER := Null;
  END IF;

  -- DN 45679 - Tabelas Financeiras
  IF (TG_OP = 'INSERT') THEN
     cDUMMY:=INSERE_LFIN_CLI('COM',NEW.CODFIL,NEW.SEQUEN,NEW.FILFOR,NEW.CODFOR);
  END IF;
  -- DN 45679 - Fim Tabelas Financeiras

  -- "Default"
  NEW.ATU_EM := agora();

  IF NEW.FLGEST = 'D' THEN
    NEW.EXPORT := 'F';
  END IF;

  --RATEIO_FRETE da TT_COM recebe RATEIO_FRETE da TT_CFG.
  IF NEW.RATEIO_FRETE IS NULL THEN
     SELECT RATEIO_FRETE INTO NEW.RATEIO_FRETE FROM TT_CFG;
  END IF;

  -- Fora a finalidade de um frete para "09 - Servios"
  IF (TG_OP = 'INSERT') THEN
     IF (NEW.TIPPAR = 'T') AND (NEW.CODFPS IS NULL) THEN
        NEW.CODFPS := '09';
     END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3346 --*/
CREATE TRIGGER TGCOM1
BEFORE INSERT ON TT_COM 
FOR EACH ROW EXECUTE PROCEDURE TGCOM1();

/*-- SEQ 3347 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCOM2() CASCADE;

/*-- SEQ 3348 --*/
CREATE OR REPLACE FUNCTION TGCOM2() RETURNS TRIGGER AS $$
BEGIN
  IF NEW.TIPNOT = 'A' THEN
    IF (NEW.SEQFAT IS NULL) OR (NEW.SEQUEN != NEW.SEQFAT) THEN
      NEW.SEQFAT := NEW.SEQUEN;
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3349 --*/
CREATE TRIGGER TGCOM2
BEFORE UPDATE ON TT_COM 
FOR EACH ROW EXECUTE PROCEDURE TGCOM2();

/*-- SEQ 3350 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCOM3() CASCADE;

/*-- SEQ 3351 --*/
CREATE OR REPLACE FUNCTION TGCOM3() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir exclusao
-- 2) Impedir alteracao nas colunas que nao se referem ao status
-- 3) Realizar "update cascade" no TT_ICO para unificacao dos status
-- 4) Tratamento para Bonificao do Futura do Fornecedor
--
-- IMPORTANTE: se esta trigger passar a permitir alteracoes na chave primaria ou
--             exclusoes, sera preciso fazer o "update/delete cascade" em TT_ICO
--             ou impedir de faze-lo. Este cuidado e necessario porque TT_ICO
--             nao possui "foreign key" (ela foi eliminada para evitar o erro de
--             "mutating table")
DECLARE
   vComplemento  VARCHAR(254):= constante('complemento');
   cDUMMY        VARCHAR(10);

   --rodrigo 58983
   vLOG          VARCHAR(4000)     := '';
   WK_CODUID     TT_UID.CODUID%TYPE;
   cNulo         CONSTANT CHAR(4)   := 'Nulo';
   iNulo         CONSTANT Numeric(1) := 0;
   CRLF          CONSTANT CHAR(1)   := CHR(10);
   vVem_de_UNIAO_PARCEIROS  constant VARCHAR(1) := constante('UNIAO_PARCEIROS');
   nSoma         Numeric(10, 2);
   cATUCUS       TT_COM.ATUCUS%TYPE;
   --Bruno Berticelli
   cOld                          VARCHAR(50); -- colocar Descrio no lugar dos codtab
   cNew                          VARCHAR(50);

   QuemLogou TRetQuemLogou%ROWTYPE;

BEGIN
  -- Impede excluses
  IF (TG_OP = 'DELETE') THEN
    RAISE EXCEPTION 'PG-20027 Exclusao so pode ser feita atraves da rotina manutencao.%' , vComplemento;
  END IF;

  -- Manoel 92174 Fazer uma validacao muito importante, pois a soma dos valores TEM que fechar com o Valor Liquido
  -- Isso evita updates mal construidos e futuras falhas do sistema
  IF (TG_OP = 'UPDATE') THEN
    IF (  (COALESCE(OLD.VLRTOT, 0) <> COALESCE(NEW.VLRTOT, 0)) OR
          (COALESCE(OLD.SUBSTT, 0) <> COALESCE(NEW.SUBSTT, 0)) OR
          (COALESCE(OLD.OUTTAX, 0) <> COALESCE(NEW.OUTTAX, 0)) OR
          (COALESCE(OLD.VLRFRE, 0) <> COALESCE(NEW.VLRFRE, 0)) OR
          (COALESCE(OLD.DESCON, 0) <> COALESCE(NEW.DESCON, 0)) OR
          (COALESCE(OLD.VLRBON, 0) <> COALESCE(NEW.VLRBON, 0))
       ) THEN
      nSoma := (COALESCE(NEW.VLRTOT, 0) + COALESCE(NEW.SUBSTT, 0) + COALESCE(NEW.OUTTAX, 0) + COALESCE(NEW.VLRFRE, 0) + COALESCE(NEW.DESCON, 0) - COALESCE(NEW.VLRBON, 0));
      IF ((nSoma) <> NEW.VLRLIQ) THEN
        vComplemento := 'SOMA '   || nSoma       || '|' ||
                        'VLRTOT ' || NEW.VLRTOT || '|' ||
                        'SUBSTT ' || NEW.SUBSTT || '|' ||
                        'OUTTAX ' || NEW.OUTTAX || '|' ||
                        'VLRFRE ' || NEW.VLRFRE || '|' ||
                        'DESCON ' || NEW.DESCON || '|' ||
                        'VLRBON ' || NEW.VLRBON || '|' ||
                        'VLRLIQ ' || NEW.VLRLIQ || '|';
        RAISE EXCEPTION 'PG-20099 A soma dos itens mais impostos, nao fecha com o Valor Liquido.%' , vComplemento;
      END IF;
    END IF;
  END IF;
  
   select * into QuemLogou from DadosLogon();

  -- RFMP 71024
  -- Desfazer vnculo com a transferncia em caso de cancelamento de compra
  IF (TG_OP = 'UPDATE') THEN
     IF  (Equal(OLD.FLGEST,NEW.FLGEST) = 0)
     AND (NEW.FLGEST = 'D') THEN
        UPDATE TT_TRA
           SET FILICO = NULL,
               SEQICO = NULL,
               NUMICO = NULL
         WHERE FILICO = NEW.CODFIL
           AND SEQICO = NEW.SEQUEN;
     END IF;
  END IF;

  -- Fora a finalidade de um frete para "09 - Servios"
  IF (TG_OP = 'UPDATE') THEN
     IF (NEW.TIPPAR = 'T') AND (NEW.CODFPS IS NULL) THEN
        NEW.CODFPS := '09';
     END IF;
  END IF;
  
   IF (TG_OP = 'DELETE') THEN
      -- Tratamento para Bonificao do Futura do Fornecedor
      -- Realiza o Estorno do Lanamento
      IF ((OLD.CODFOR <> '     0') AND (OLD.VLRBONFUT > 0) AND (OLD.FLGEST <> 'D')) THEN
         INSERT INTO TT_CCC (CODFIL, FILUSU, CODUSU, FILCLI, CODCLI, NUMDOC, DATOPE,
                          TIPCCC, VLRLAN, VLRORI, COMPLE, PORORI, TIPLAN, ATULIM, STATUS)
                  VALUES (OLD.CODFIL, QuemLogou.FILUSU, QuemLogou.CODUSU, OLD.FILFOR, OLD.CODFOR, OLD.CODFIL || OLD.SEQUEN, OLD.DATINC,
                          0, OLD.VLRBONFUT, OLD.VLRBONFUT, 'COM ' || OLD.CODFIL || OLD.SEQUEN, 0, '3', 'F', 'S');
      END IF;
   END IF;

  --rodrigo 58938
  IF (TG_OP = 'UPDATE') THEN

    WK_CODUID := GetCoduidAtual();

    IF (Equal(OLD.ATUCUS,NEW.ATUCUS) = 0) THEN
        vLOG := vLOG||'Atualiza Custo Gerencial?: de '||COALESCE(OLD.ATUCUS,cNulo)||' para '||COALESCE(NEW.ATUCUS,cNulo)||CRLF;
    END IF;
    IF Equal(OLD.TIPCCM,NEW.TIPCCM) <> 1 THEN
        vLOG := vLOG||'Tipo de Custo Mdio: de '||COALESCE(DescricaoDominio('COM','TIPCCM',OLD.TIPCCM),cNulo)||' para '||COALESCE(DescricaoDominio('COM','TIPCCM',NEW.TIPCCM),cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.DATINC,NEW.DATINC) = 0) THEN
        vLOG := vLOG||'Data Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.ATU_EM,NEW.ATU_EM) = 0) THEN
        vLOG := vLOG||'Data Atualizao: de '||COALESCE(TO_CHAR(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.BASFRE,NEW.BASFRE) = 0) THEN
        vLOG := vLOG||'Base de ICM do frete: de '||COALESCE(OLD.BASFRE,iNulo)||' para '||COALESCE(NEW.BASFRE,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.BASSUB,NEW.BASSUB) = 0) THEN
        vLOG := vLOG||'Base de Substituio: de '||COALESCE(OLD.BASSUB,iNulo)||' para '||COALESCE(NEW.BASSUB,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.CODCFO,NEW.CODCFO) = 0) THEN
        vLOG := vLOG||'Descrio CFOP: de '||COALESCE(TO_CHAR(OLD.CODCFO),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODCFO),cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.CODFIL,NEW.CODFIL) = 0) THEN
        vLOG := vLOG||'Filial: de '||COALESCE(DescricaoDominio('DFIL','CODFIL',OLD.CODFIL),cNulo)||' para '||COALESCE(DescricaoDominio('DFIL','CODFIL',NEW.CODFIL),cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.CODFOR,NEW.CODFOR) = 0) THEN
        vLOG := vLOG||'Cdigo~Fornecedor: de '||COALESCE(OLD.CODFOR,cNulo)||' para '||COALESCE(NEW.CODFOR,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.CODMOE,NEW.CODMOE) = 0) THEN
        vLOG := vLOG||'Moeda: de '||COALESCE(DescricaoDominio('DMOE','CODMOE',TO_CHAR(OLD.CODMOE)),cNulo)||' para '||COALESCE(DescricaoDominio('DMOE','CODMOE',TO_CHAR(NEW.CODMOE)),cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.CODSER,NEW.CODSER) = 0) THEN
        vLOG := vLOG||'Srie: de '||COALESCE(DescricaoDominio('VFIS','CODSER',OLD.CODSER),cNulo)||' para '||COALESCE(DescricaoDominio('VFIS','CODSER',NEW.CODSER),cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.CODSET,NEW.CODSET) = 0) THEN
        vLOG := vLOG||'Setor: de '||COALESCE(DescricaoDominio('DSET','CODSET',TO_CHAR(OLD.CODSET)),cNulo)||' para '||COALESCE(DescricaoDominio('DSET','CODSET',TO_CHAR(NEW.CODSET)),cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.CODUSU,NEW.CODUSU) = 0) THEN
        vLOG := vLOG||'Usurio: de '||COALESCE(DescricaoDominio('USU ','CODUSU',OLD.CODUSU),cNulo)||' para '||COALESCE(DescricaoDominio('USU ','CODUSU',NEW.CODUSU),cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.CONPGT,NEW.CONPGT) = 0) THEN
        vLOG := vLOG||'Cond. Pagto.: de '||COALESCE(OLD.CONPGT,cNulo)||' para '||COALESCE(NEW.CONPGT,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.DATCMP,NEW.DATCMP) = 0) THEN
        vLOG := vLOG||'Data Compra: de '||COALESCE(TO_CHAR(OLD.DATCMP,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATCMP,'DD/MM/YYYY'),cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.DATOPE,NEW.DATOPE) = 0) THEN
        vLOG := vLOG||'Data Lanto: de '||COALESCE(TO_CHAR(OLD.DATOPE,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATOPE,'DD/MM/YYYY'),cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.DESCON,NEW.DESCON) = 0) THEN
        vLOG := vLOG||'Desconto: de '||COALESCE(OLD.DESCON,iNulo)||' para '||COALESCE(NEW.DESCON,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.DESPAR,NEW.DESPAR) = 0) THEN
        vLOG := vLOG||'Despesas na parcela: de '||COALESCE(OLD.DESPAR,iNulo)||' para '||COALESCE(NEW.DESPAR,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.ESPDOC,NEW.ESPDOC) = 0) THEN
        vLOG := vLOG||'Espcie Docto: de '||COALESCE(OLD.ESPDOC,cNulo)||' para '||COALESCE(NEW.ESPDOC,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.FILCTA,NEW.FILCTA) = 0) THEN
        vLOG := vLOG||'Filial Conta: de '||COALESCE(OLD.FILCTA,cNulo)||' para '||COALESCE(NEW.FILCTA,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.FILEND,NEW.FILEND) = 0) THEN
        vLOG := vLOG||'Filial endereo: de '||COALESCE(OLD.FILEND,cNulo)||' para '||COALESCE(NEW.FILEND,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.FILFOR,NEW.FILFOR) = 0) THEN
        vLOG := vLOG||'Filial do fornecedor: de '||COALESCE(OLD.FILFOR,cNulo)||' para '||COALESCE(NEW.FILFOR,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.FILFRE,NEW.FILFRE) = 0) THEN
        vLOG := vLOG||': de '||COALESCE(OLD.FILFRE,cNulo)||' para '||COALESCE(NEW.FILFRE,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.FILUSU,NEW.FILUSU) = 0) THEN
        vLOG := vLOG||'Filial do )fornecedor: de '||COALESCE(OLD.FILUSU,cNulo)||' para '||COALESCE(NEW.FILUSU,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.FLGCOF,NEW.FLGCOF) = 0) THEN
        vLOG := vLOG||'Inside COFINS?: de '||COALESCE(OLD.FLGCOF,cNulo)||' para '||COALESCE(NEW.FLGCOF,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.FLGCSS,NEW.FLGCSS) = 0) THEN
        vLOG := vLOG||'Inside Contr.Social?: de '||COALESCE(OLD.FLGCSS,cNulo)||' para '||COALESCE(NEW.FLGCSS,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.FLGEST,NEW.FLGEST) = 0) THEN
        vLOG := vLOG||'Situao: de '||COALESCE(OLD.FLGEST,cNulo)||' para '||COALESCE(NEW.FLGEST,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.FLGICM,NEW.FLGICM) = 0) THEN
        vLOG := vLOG||': de '||COALESCE(OLD.FLGICM,cNulo)||' para '||COALESCE(NEW.FLGICM,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.FLGINS,NEW.FLGINS) = 0) THEN
        vLOG := vLOG||'Inside INSS?: de '||COALESCE(OLD.FLGINS,cNulo)||' para '||COALESCE(NEW.FLGINS,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.FLGISS,NEW.FLGISS) = 0) THEN
        vLOG := vLOG||': de '||COALESCE(OLD.FLGISS,cNulo)||' para '||COALESCE(NEW.FLGISS,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.FLGPIS,NEW.FLGPIS) = 0) THEN
        vLOG := vLOG||'Inside PIS?: de '||COALESCE(OLD.FLGPIS,cNulo)||' para '||COALESCE(NEW.FLGPIS,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.ICMFRE,NEW.ICMFRE) = 0) THEN
        vLOG := vLOG||'ICMS Frete: de '||COALESCE(OLD.ICMFRE,iNulo)||' para '||COALESCE(NEW.ICMFRE,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.INCOJU,NEW.INCOJU) = 0) THEN
        vLOG := vLOG||'Correo: de '||COALESCE(OLD.INCOJU,cNulo)||' para '||COALESCE(NEW.INCOJU,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.INTPJU,NEW.INTPJU) = 0) THEN
        vLOG := vLOG||'Tipo Juros: de '||COALESCE(OLD.INTPJU,cNulo)||' para '||COALESCE(NEW.INTPJU,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.INTPMU,NEW.INTPMU) = 0) THEN
        vLOG := vLOG||'Tipo Multa: de '||COALESCE(OLD.INTPMU,cNulo)||' para '||COALESCE(NEW.INTPMU,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.ISEICM,NEW.ISEICM) = 0) THEN
        vLOG := vLOG||'Isento ICMS: de '||COALESCE(OLD.ISEICM,iNulo)||' para '||COALESCE(NEW.ISEICM,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.MOEJUR,NEW.MOEJUR) = 0) THEN
        vLOG := vLOG||'Moeda Correo: de '||COALESCE(DescricaoDominio('DMOE','MOEJUR',TO_CHAR(OLD.MOEJUR)),cNulo)||' para '||COALESCE(DescricaoDominio('DMOE','MOEJUR',TO_CHAR(NEW.MOEJUR)),cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.NOTESP,NEW.NOTESP) = 0) THEN
        vLOG := vLOG||'Nota Especial?: de '||COALESCE(OLD.NOTESP,cNulo)||' para '||COALESCE(NEW.NOTESP,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.NUMEND,NEW.NUMEND) = 0) THEN
        vLOG := vLOG||'Nmero de Endereos: de '||COALESCE(OLD.NUMEND,iNulo)||' para '||COALESCE(NEW.NUMEND,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.NUMNOT,NEW.NUMNOT) = 0) THEN
        vLOG := vLOG||'Nmero: de '||COALESCE(OLD.NUMNOT,cNulo)||' para '||COALESCE(NEW.NUMNOT,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.NUMVOL,NEW.NUMVOL) = 0) THEN
        vLOG := vLOG||'Nmero de Volumes: de '||COALESCE(OLD.NUMVOL,iNulo)||' para '||COALESCE(NEW.NUMVOL,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.OBSERV,NEW.OBSERV) = 0) THEN
        vLOG := vLOG||'Observaes: de '||COALESCE(OLD.OBSERV,cNulo)||' para '||COALESCE(NEW.OBSERV,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.OBSFAT,NEW.OBSFAT) = 0) THEN
        vLOG := vLOG||'Observao Fatura: de '||COALESCE(OLD.OBSFAT,cNulo)||' para '||COALESCE(NEW.OBSFAT,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.OUTDES,NEW.OUTDES) = 0) THEN
        vLOG := vLOG||'Despesas avulso: de '||COALESCE(OLD.OUTDES,iNulo)||' para '||COALESCE(NEW.OUTDES,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.OUTICM,NEW.OUTICM) = 0) THEN
        vLOG := vLOG||'Outros ICMS Compras: de '||COALESCE(OLD.OUTICM,iNulo)||' para '||COALESCE(NEW.OUTICM,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.OUTTAX,NEW.OUTTAX) = 0) THEN
        vLOG := vLOG||'Outras Taxas: de '||COALESCE(OLD.OUTTAX,iNulo)||' para '||COALESCE(NEW.OUTTAX,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.PERCSS,NEW.PERCSS) = 0) THEN
        vLOG := vLOG||'%Contribuio~Social: de '||COALESCE(OLD.PERCSS,iNulo)||' para '||COALESCE(NEW.PERCSS,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.PERFRE,NEW.PERFRE) = 0) THEN
        vLOG := vLOG||'% do ICM do frete: de '||COALESCE(OLD.PERFRE,iNulo)||' para '||COALESCE(NEW.PERFRE,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.PERICM,NEW.PERICM) = 0) THEN
        vLOG := vLOG||'% ICMS: de '||COALESCE(OLD.PERICM,iNulo)||' para '||COALESCE(NEW.PERICM,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.PERINS,NEW.PERINS) = 0) THEN
        vLOG := vLOG||'% INSS: de '||COALESCE(OLD.PERINS,iNulo)||' para '||COALESCE(NEW.PERINS,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.PERIRR,NEW.PERIRR) = 0) THEN
        vLOG := vLOG||'% IRRF: de) '||COALESCE(OLD.PERIRR,iNulo)||' para '||COALESCE(NEW.PERIRR,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.PERISS,NEW.PERISS) = 0) THEN
        vLOG := vLOG||'% ISS: de '||COALESCE(OLD.PERISS,iNulo)||' para '||COALESCE(NEW.PERISS,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.POREMP,NEW.POREMP) = 0) THEN
        vLOG := vLOG||'Porte da Empresa: de '||COALESCE(OLD.POREMP,cNulo)||' para '||COALESCE(NEW.POREMP,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.QTDTOT,NEW.QTDTOT) = 0) THEN
        vLOG := vLOG||'Qtd. Total: de '||COALESCE(OLD.QTDTOT,iNulo)||' para '||COALESCE(NEW.QTDTOT,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.RETCOF,NEW.RETCOF) = 0) THEN
        vLOG := vLOG||'Reteno de COFINS: de '||COALESCE(OLD.RETCOF,iNulo)||' para '||COALESCE(NEW.RETCOF,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.RETCSS,NEW.RETCSS) = 0) THEN
        vLOG := vLOG||'Retm Cont. Social: de '||COALESCE(OLD.RETCSS,cNulo)||' para '||COALESCE(NEW.RETCSS,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.RETIRR,NEW.RETIRR) = 0) THEN
        vLOG := vLOG||'Retm Imp. de Renda: de '||COALESCE(OLD.RETIRR,cNulo)||' para '||COALESCE(NEW.RETIRR,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.SEQCAN,NEW.SEQCAN) = 0) THEN
        vLOG := vLOG||'Sequenciador de canc: de '||COALESCE(OLD.SEQCAN,cNulo)||' para '||COALESCE(NEW.SEQCAN,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.SEQCTA,NEW.SEQCTA) = 0) THEN
        vLOG := vLOG||'Sequenciador Contato: de '||COALESCE(OLD.SEQCTA,cNulo)||' para '||COALESCE(NEW.SEQCTA,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.SEQFAT,NEW.SEQFAT) = 0) THEN
        vLOG := vLOG||'Sequncia NF Fatura: de '||COALESCE(OLD.SEQFAT,cNulo)||' para '||COALESCE(NEW.SEQFAT,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.SEQFRE,NEW.SEQFRE) = 0) THEN
        vLOG := vLOG||'Sequncia Frete: de '||COALESCE(OLD.SEQFRE,cNulo)||' para '||COALESCE(NEW.SEQFRE,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.SEQUEN,NEW.SEQUEN) = 0) THEN
        vLOG := vLOG||'Sequenciador: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.SIGNAT,NEW.SIGNAT) = 0) THEN
        vLOG := vLOG||'Ativo?: de '||COALESCE(OLD.SIGNAT,iNulo)||' para '||COALESCE(NEW.SIGNAT,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.SUBSER,NEW.SUBSER) = 0) THEN
        vLOG := vLOG||'Sub-Srie: de '||COALESCE(OLD.SUBSER,cNulo)||' para '||COALESCE(NEW.SUBSER,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.SUBSTT,NEW.SUBSTT) = 0) THEN
        vLOG := vLOG||'Substit. Tributria: de '||COALESCE(OLD.SUBSTT,iNulo)||' para '||COALESCE(NEW.SUBSTT,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.TIPCTA,NEW.TIPCTA) = 0) THEN
        vLOG := vLOG||'Tipo Conta: de '||COALESCE(OLD.TIPCTA,cNulo)||' para '||COALESCE(NEW.TIPCTA,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.TIPEMP,NEW.TIPEMP) = 0) THEN
        vLOG := vLOG||'Tipo da Empresa: de '||COALESCE(OLD.TIPEMP,cNulo)||' para '||COALESCE(NEW.TIPEMP,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.TIPNOT,NEW.TIPNOT) = 0) THEN
        vLOG := vLOG||'Tipo de Documento: de '||COALESCE(OLD.TIPNOT,cNulo)||' para '||COALESCE(NEW.TIPNOT,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.TIPPAR,NEW.TIPPAR) = 0) THEN
        vLOG := vLOG||'Tipo de Parceiro: de '||COALESCE(OLD.TIPPAR,cNulo)||' para '||COALESCE(NEW.TIPPAR,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.TIPTRP,NEW.TIPTRP) = 0) THEN
        vLOG := vLOG||'Tipo Transp. Frete: de '||COALESCE(OLD.TIPTRP,cNulo)||' para '||COALESCE(NEW.TIPTRP,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.UFNOTA,NEW.UFNOTA) = 0) THEN
        vLOG := vLOG||'UF da Nota: de '||COALESCE(OLD.UFNOTA,cNulo)||' para '||COALESCE(NEW.UFNOTA,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.VLRBON,NEW.VLRBON) = 0) THEN
        vLOG := vLOG||'Valor Bonificao: de '||COALESCE(OLD.VLRBON,iNulo)||' para '||COALESCE(NEW.VLRBON,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.VLRCOF,NEW.VLRCOF) = 0) THEN
        vLOG := vLOG||': de '||COALESCE(OLD.VLRCOF,iNulo)||' para '||COALESCE(NEW.VLRCOF,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.VLRCSS,NEW.VLRCSS) = 0) THEN
        vLOG := vLOG||'Valor Contr.Social: de '||COALESCE(OLD.VLRCSS,iNulo)||' para '||COALESCE(NEW.VLRCSS,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.VLRFRE,NEW.VLRFRE) = 0) THEN
        vLOG := vLOG||'Valor do frete: de '||COALESCE(OLD.VLRFRE,iNulo)||' para '||COALESCE(NEW.VLRFRE,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.VLRICM,NEW.VLRICM) = 0) THEN
        vLOG := vLOG||'Valor ICMS: de '||COALESCE(OLD.VLRICM,iNulo)||' para '||COALESCE(NEW.VLRICM,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.VLRINS,NEW.VLRINS) = 0) THEN
        vLOG := vLOG||'Valor INSS: de '||COALESCE(OLD.VLRINS,iNulo)||' para '||COALESCE(NEW.VLRINS,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.VLRIPI,NEW.VLRIPI) = 0) THEN
        vLOG := vLOG||'Valor do IPI: de '||COALESCE(OLD.VLRIPI,iNulo)||' para '||COALESCE(NEW.VLRIPI,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.VLRIRR,NEW.VLRIRR) = 0) THEN
        vLOG := vLOG||'Valor IRRF: de '||COALESCE(OLD.VLRIRR,iNulo)||' para '||COALESCE(NEW.VLRIRR,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.VLRISS,NEW.VLRISS) = 0) THEN
        vLOG := vLOG||'Valor ISS: de '||COALESCE(OLD.VLRISS,iNulo)||' para '||COALESCE(NEW.VLRISS,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.VLRLIQ,NEW.VLRLIQ) = 0) THEN
        vLOG := vLOG||'Valor Lquido: de '||COALESCE(OLD.VLRLIQ,iNulo)||' para '||COALESCE(NEW.VLRLIQ,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.VLRNOT,NEW.VLRNOT) = 0) THEN
        vLOG := vLOG||'Valor Total da Nota: de '||COALESCE(OLD.VLRNOT,iNulo)||' para '||COALESCE(NEW.VLRNOT,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.VLRPIS,NEW.VLRPIS) = 0) THEN
        vLOG := vLOG||': de '||COALESCE(OLD.VLRPIS,iNulo)||' para '||COALESCE(NEW.VLRPIS,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.VLRRET,NEW.VLRRET) = 0) THEN
        vLOG := vLOG||'Valor Reteno: de '||COALESCE(OLD.VLRRET,iNulo)||' para '||COALESCE(NEW.VLRRET,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.VLRTOT,NEW.VLRTOT) = 0) THEN
        vLOG := vLOG||'Valor Total: de '||COALESCE(OLD.VLRTOT,iNulo)||' para '||COALESCE(NEW.VLRTOT,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.VLTXJU,NEW.VLTXJU) = 0) THEN
        vLOG := vLOG||'Juros: de '||COALESCE(OLD.VLTXJU,iNulo)||' para '||COALESCE(NEW.VLTXJU,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.VLTXMU,NEW.VLTXMU) = 0) THEN
        vLOG := vLOG||'Multa: de '||COALESCE(OLD.VLTXMU,iNulo)||' para '||COALESCE(NEW.VLTXMU,iNulo)||CRLF;
    END IF;
    IF (Equal(OLD.SITPIS,NEW.SITPIS) = 0) THEN
        vLOG := vLOG||'CST do PIS: de '||COALESCE(OLD.SITPIS,cNulo)||' para '||COALESCE(NEW.SITPIS,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.SITCOF,NEW.SITCOF) = 0) THEN
        vLOG := vLOG||'CST do COFINS: de '||COALESCE(OLD.SITCOF,cNulo)||' para '||COALESCE(NEW.SITCOF,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.CODFPS,NEW.CODFPS) = 0) THEN
        vLOG := vLOG||'Finalidade: de '||COALESCE(OLD.CODFPS,cNulo)||' para '||COALESCE(NEW.CODFPS,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.NATFRE,NEW.NATFRE) = 0) THEN
        vLOG := vLOG||'Natureza do Frete: de '||COALESCE(OLD.NATFRE,cNulo)||' para '||COALESCE(NEW.NATFRE,cNulo)||CRLF;
    END IF;
    IF (Equal(OLD.VLRSRV,NEW.VLRSRV) = 0) THEN
        vLOG := vLOG||'Valor do Servio: de '||COALESCE(OLD.VLRSRV,iNulo)||' para '||COALESCE(NEW.VLRSRV,iNulo)||CRLF;
    END IF;
	-- Paulo K. - 88209
	IF (Equal(OLD.CODDAR,NEW.CODDAR) = 0) THEN
        vLOG := vLOG||'Cod. modelo documento arrecadao: de '||COALESCE(OLD.CODDAR,cNulo)||' para '||COALESCE(NEW.CODDAR,cNulo)||CRLF;
    END IF;
	IF (Equal(OLD.FINNFE,NEW.FINNFE) = 0) THEN
        vLOG := vLOG||'Finalidade da NF-e: de '||COALESCE(DescricaoDominio('COM','FINNFE',OLD.FINNFE),cNulo)||' para '||COALESCE(DescricaoDominio('COM','FINNFE',NEW.FINNFE),cNulo)||CRLF;
   END IF;
   -- Andrei - Tckt: 2020113442
   IF (Equal(OLD.CODIBG,NEW.CODIBG) = 0) THEN
        vLOG := vLOG||'Cdigo do IBGE: de '||COALESCE(TO_CHAR(OLD.CODIBG),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODIBG),cNulo)||CRLF;
   END IF;   
    
   IF (Equal(OLD.EXPORT,NEW.EXPORT) <> 1) THEN
      SELECT CASE OLD.EXPORT WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                              ELSE cNulo
      END INTO cOld FROM DUAL;
      SELECT CASE NEW.EXPORT WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                              ELSE cNulo
      END INTO cNew FROM DUAL;
      vLOG := vLOG||'Exportado?: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
   END IF;
      
   IF Equal(OLD.EXPFIS,NEW.EXPFIS) <> 1 THEN
      SELECT CASE OLD.EXPFIS WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                              ELSE cNulo
      END INTO cOld FROM DUAL;
      SELECT CASE NEW.EXPFIS WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                              ELSE cNulo
      END INTO cNew FROM DUAL;
      vLOG := vLOG||'Exportado Fiscal?: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
   END IF;
         
    IF ISNOTNULL(vLOG) = 'T' THEN
       vLOG := 'Alteraes em TT_COM -> ' || vLOG;

       INSERT INTO TL_COM
       (CODFIL, SEQUEN, FILUSU, CODUSU, DATOPE, MSGLOG, CODUID)
       VALUES
       (NEW.CODFIL, NEW.SEQUEN, QuemLogou.FILUSU, QuemLogou.CODUSU, agora(), vLog, WK_CODUID);
     END IF;

  END IF;

  -- Impede cancelamento de Notas Fiscais de Transferncia
  IF (TG_OP = 'UPDATE') THEN
      IF (NEW.FLGEST = 'D') AND
         (NEW.CODFOR = '     0') AND
         (NEW.NUMNOT = ('###'||NEW.CODFIL)) THEN
         RAISE EXCEPTION 'PG-20030 No  permitido o cancelamento de nota fiscal de transferencia. %' , vComplemento;
      END IF;
  END IF;

  -- Impede alteraces
  IF (TG_OP = 'UPDATE') THEN
    -- IMPORTANTE: nao e feita referencia a coluna OBSERV porque ela
    --             e do tipo TEXT e uma trigger nao pode fazer referencia
    --             a uma coluna desse tipo.
    IF((OLD.SEQUEN <> NEW.SEQUEN) OR
       (OLD.CODFIL <> NEW.CODFIL) OR
       (OLD.FILFOR <> NEW.FILFOR) OR
       (OLD.CODFOR <> NEW.CODFOR) OR
       (OLD.CODSER <> NEW.CODSER) OR
       (OLD.NUMNOT <> NEW.NUMNOT) OR
       /*     (OLD.DATOPE <> NEW.DATOPE) OR */
       /*     (OLD.DATCMP <> NEW.DATCMP) OR */
       (OLD.QTDTOT <> NEW.QTDTOT) OR
       /*     (OLD.VLRTOT <> NEW.VLRTOT) OR */
       (OLD.NOTESP <> NEW.NOTESP) OR
       /*(OLD.OUTTAX <> NEW.OUTTAX) OR*/
       /*(OLD.DESCON <> NEW.DESCON) OR*/
       /*     (OLD.VLRLIQ <> NEW.VLRLIQ) OR */
       (OLD.FILUSU <> NEW.FILUSU) OR
       (OLD.CODUSU <> NEW.CODUSU) OR
       /*     (OLD.CODMOE <> NEW.CODMOE) OR */
       /*     (OLD.VLTXJU <> NEW.VLTXJU) OR */
       /*     (OLD.INCOJU <> NEW.INCOJU) OR */
       /*     (OLD.INTPJU <> NEW.INTPJU) OR */
       /*     (OLD.VLTXMU <> NEW.VLTXMU) OR */
       /*     (OLD.INTPMU <> NEW.INTPMU) OR */
       (OLD.CONPGT <> NEW.CONPGT) OR
       /*     (OLD.NATURE <> NEW.NATURE) OR */
       /*     (OLD.ESPDOC <> NEW.ESPDOC) OR */
       /*     (OLD.MOEJUR <> NEW.MOEJUR) OR */
       (OLD.TIPNOT <> NEW.TIPNOT) OR
       (OLD.TIPPAR <> NEW.TIPPAR) OR
       (OLD.SEQCAN <> NEW.SEQCAN) OR
       (LTRIM(RTRIM(OLD.SUBSER)) <> LTRIM(RTRIM(NEW.SUBSER))))
          AND (NEW.CODFOR<>'     0')
          AND (OLD.NUMNOT<>('###'||OLD.CODFIL))
          AND (OLD.DATOPE<>TRUNC(OLD.DATOPE))
          AND (Equal(NEW.DUMMY, vVem_de_UNIAO_PARCEIROS) <> 1) -- se nao vier da uniao de parceiros
    THEN
       RAISE EXCEPTION 'PG-20024 Uma compra nao pode ser modificada.%' , vComplemento;
    END IF;

    IF (OLD.FLGEST = 'D') AND (NEW.FLGEST <> OLD.FLGEST) THEN
       RAISE EXCEPTION 'PG-20025 Uma compra devolvida nao pode ser modificada.%' , vComplemento;
    END IF;

    -- Evita lancamentos fora do perodo de validade
    IF NOT (Livre(NEW.CODFIL,'TT_COM',NEW.DATOPE) = 1) THEN
       RAISE EXCEPTION 'PG-20039 Lancamento fora do periodo de validade de uso do sistema.%' , vComplemento;
    END IF;

    -- Alinhar a subserie
    NEW.SUBSER := lpad(LTRIM(RTRIM(NEW.SUBSER)),3,' ');

    -- Evita "brancos" na subserie
    IF LTRIM(RTRIM(NEW.SUBSER)) IS NULL THEN
      NEW.SUBSER := Null;
    END IF;

    -- Evita espacos no codigo de serie
    IF LENGTH(LTRIM(RTRIM(NEW.CODSER))) != 2 THEN
      NEW.CODSER := LTRIM(RTRIM(NEW.CODSER));
    END IF;

    -- Gera proximo sequenciador de cancelamento e cancela tambem os itens da compra
    IF (NEW.FLGEST = 'D') AND (NEW.FLGEST <> OLD.FLGEST) THEN
      NEW.SEQCAN:=ProximoCodigo('TT_COM_CANCELAMENTO',NEW.CODFIL);
      -- Improvavel mas...
      IF (NEW.SEQCAN IS NULL) THEN
         RAISE EXCEPTION 'PG-20026 Falha na geracao do sequenciador de cancelamento.%' , vComplemento;
      END IF;

      --Pedro E. Braga - 98995
      /* Quando finalidade for Nota Complementar deve passar para TGR_ICO_Atualiza_Movimento - pATUCUS=F para no atualizar o ID da ultima compra assim atualiza apenas o Valor acumulado de custo */
      IF (COALESCE(NEW.FINNFE,'0') = '2') THEN
         cATUCUS := 'F';
      ELSE
         cATUCUS := NEW.ATUCUS;
      END IF;

      -- "update cascade"
      UPDATE TT_ICO SET SITMOV = 'C', COM_ATUCUS = cATUCUS,DUMMY = Constante('vem_de_TGCOM')
      WHERE SEQUEN = NEW.SEQUEN
        AND CODFIL = NEW.CODFIL
        AND SITMOV <> 'C';

      -- remove os vinculos da ico com a tr_mov
      IF NEW.TIPPAR = 'T' THEN
        cDummy := RETIRA_FRETE_MOV(NEW.CODFIL,NEW.SEQUEN);
      ELSE
        cDummy := RETIRA_CUSTO_MOV(NEW.CODFIL,NEW.SEQUEN);
      END IF;

      -- Cancela pagamentos
      UPDATE TT_PAG SET FLGEST = 'C',DUMMY = Constante('vem_de_TGCOM')
      WHERE SEQUEN = NEW.SEQUEN
        AND CODFIL = NEW.CODFIL
        AND FLGEST NOT IN ('C','P','X');

      -- Estorna pagamentos
      UPDATE TT_PAG SET FLGEST = 'X',DUMMY = Constante('vem_de_TGCOM')
      WHERE SEQUEN = NEW.SEQUEN
        AND CODFIL = NEW.CODFIL
        AND FLGEST NOT IN ('X','C');
    END IF;

    -- "Default"
    IF (COALESCE(NEW.DUMMY, 'X') <> '%') THEN
      IF (NEW.ATU_EM = OLD.ATU_EM) THEN
        NEW.ATU_EM := agora();
      END IF;
    END IF;

    -- DN 45679 - Tabelas Financeiras
    IF (TG_OP = 'UPDATE') THEN
          cDUMMY:=INSERE_LFIN_CLI('COM',NEW.CODFIL,NEW.SEQUEN,NEW.FILFOR,NEW.CODFOR);
    END IF;
    -- DN 45679 - Fim Tabelas Financeiras

    IF (NEW.FLGEST = 'D') AND (OLD.FLGEST <> NEW.FLGEST) THEN
       NEW.EXPORT := 'F';
       NEW.EXPFIS := 'F';
    END IF;
  END IF;

  IF (NOT (TG_OP = 'DELETE')) THEN
    NEW.DUMMY := Null;
  END IF;

/*
  IF (TG_OP = 'INSERT') THEN
    NEW.DATSTR:=TRUNC(NEW.DATOPE);
  END IF;
*/

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3352 --*/
CREATE TRIGGER TGCOM3
BEFORE DELETE OR UPDATE ON TT_COM 
FOR EACH ROW EXECUTE PROCEDURE TGCOM3();

/*-- SEQ 3353 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCOM4() CASCADE;

/*-- SEQ 3354 --*/
CREATE OR REPLACE FUNCTION TGCOM4() RETURNS TRIGGER AS $$
  -- Objetivo:
  -- 1) Tratamento para Bonificao do Futura do Fornecedor
DECLARE
   bGeraEstorno                  BOOLEAN;
   bGeraNovoCredito              BOOLEAN;
      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
   BEGIN
   select * into QuemLogou from DadosLogon();

   -- Tratamento para Bonificao do Futura do Fornecedor
   IF (TG_OP = 'INSERT') THEN
      IF ((NEW.CODFOR <> '     0') AND (NEW.VLRBONFUT > 0) AND 
          (NEW.FLGEST NOT IN ('0','C'))) THEN
         INSERT INTO TT_CCC (CODFIL, FILUSU, CODUSU, FILCLI, CODCLI, NUMDOC, DATOPE,
                             TIPCCC, VLRLAN, VLRORI, COMPLE, PORORI, TIPLAN, ATULIM, STATUS)
                     VALUES (NEW.CODFIL, QuemLogou.FILUSU, QuemLogou.CODUSU, NEW.FILFOR, NEW.CODFOR, NEW.CODFIL || NEW.SEQUEN, NEW.DATINC,
                             0, NEW.VLRBONFUT * (-1), NEW.VLRBONFUT * (-1), 'COM ' || NEW.CODFIL || NEW.SEQUEN, 0, '2', 'F', 'S');
      END IF;
   ELSIF (TG_OP = 'UPDATE') THEN
      IF (Equal(OLD.FLGEST,NEW.FLGEST) <> 1) OR
         (Equal(OLD.VLRBONFUT,NEW.VLRBONFUT) <> 1) THEN
         -- Realiza o Estorno do Lanamento
         bGeraEstorno := ((OLD.CODFOR <> '     0') AND (OLD.VLRBONFUT > 0) AND (OLD.FLGEST <> 'D'));
         IF bGeraEstorno THEN
            INSERT INTO TT_CCC (CODFIL, FILUSU, CODUSU, FILCLI, CODCLI, NUMDOC, DATOPE,
                             TIPCCC, VLRLAN, VLRORI, COMPLE, PORORI, TIPLAN, ATULIM, STATUS)
                     VALUES (OLD.CODFIL, QuemLogou.FILUSU, QuemLogou.CODUSU, OLD.FILFOR, OLD.CODFOR, OLD.CODFIL || OLD.SEQUEN, OLD.DATINC,
                             0, OLD.VLRBONFUT, OLD.VLRBONFUT, 'COM ' || OLD.CODFIL || OLD.SEQUEN, 0, '3', 'F', 'S');
         END IF;
         -- Realiza a incluso se novos valores so vlidos
         bGeraNovoCredito := ((NEW.CODFOR <> '     0') AND (NEW.VLRBONFUT > 0) AND (NEW.FLGEST <> 'D'));
         IF bGeraNovoCredito THEN
            INSERT INTO TT_CCC (CODFIL, FILUSU, CODUSU, FILCLI, CODCLI, NUMDOC, DATOPE,
                                TIPCCC, VLRLAN, VLRORI, COMPLE, PORORI, TIPLAN, ATULIM, STATUS)
                        VALUES (NEW.CODFIL, QuemLogou.FILUSU, QuemLogou.CODUSU, NEW.FILFOR, NEW.CODFOR, NEW.CODFIL || NEW.SEQUEN, NEW.DATINC,
                                0, NEW.VLRBONFUT * (-1), NEW.VLRBONFUT * (-1), 'COM ' || NEW.CODFIL || NEW.SEQUEN, 0, '2', 'F', 'S');
         END IF;
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3355 --*/
CREATE TRIGGER TGCOM4
AFTER UPDATE OR INSERT ON TT_COM 
FOR EACH ROW EXECUTE PROCEDURE TGCOM4();


/*-- SEQ 3356 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCOMXCOM() CASCADE;

/*-- SEQ 3357 --*/
CREATE OR REPLACE FUNCTION TGCOMXCOM() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN:=ProximoCodigo('TT_COMXCOM',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3358 --*/
CREATE TRIGGER TGCOMXCOM
BEFORE INSERT ON TT_COMXCOM 
FOR EACH ROW EXECUTE PROCEDURE TGCOMXCOM();


/*-- SEQ 3359 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCON() CASCADE;

/*-- SEQ 3360 --*/
CREATE OR REPLACE FUNCTION TGCON() RETURNS TRIGGER AS $$

/******************************************************************************
*
*  Title:       TGEND1
*  Created:     November 01, 2001  16:51:04
*  Author:      SRNS
*
*  Description: Ajusta os valores para Telefone e DDD
*
******************************************************************************/

begin
   NEW.DDDCON := TO_DDD(NEW.DDDCON);
   NEW.TELCON := TO_PHONE(NEW.TELCON);
   NEW.CELCON := TO_PHONE(NEW.CELCON);
   NEW.NOMTRA := UPPER(NEW.NOMTRA);
   NEW.CONTAT := UPPER(NEW.CONTAT);
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3361 --*/
CREATE TRIGGER TGCON
BEFORE INSERT OR UPDATE ON TT_CON 
FOR EACH ROW EXECUTE PROCEDURE TGCON();


/*-- SEQ 3362 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCON2() CASCADE;

/*-- SEQ 3363 --*/
CREATE OR REPLACE FUNCTION TGCON2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_CLI
   cRetorno                      VARCHAR(2);
   cWhere                        TM_ATU.FILTRO%TYPE;
   cFILCLI                       TT_CLI.FILCLI%TYPE;
   cCODCLI                       TT_CLI.CODCLI%TYPE;
   
BEGIN
   --Tratamento para Atualizar Tabela Pai
   IF (TG_OP = 'INSERT') THEN
      cFILCLI := NEW.FILCLI;
      cCODCLI := NEW.CODCLI;
   ELSIF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.RETPRO,NEW.RETPRO) <> 1 THEN
         cFILCLI := NEW.FILCLI;
         cCODCLI := NEW.CODCLI;
      END IF;
   ELSIF (TG_OP = 'DELETE') THEN
      cFILCLI := OLD.FILCLI;
      cCODCLI := OLD.CODCLI;
   END IF;
   IF ISNOTNULL(TO_CHAR(cFILCLI))='T' THEN
      cWhere := 'FILCLI = ' || CHR(39) || cFILCLI  || CHR(39) || ' AND CODCLI = ' || CHR(39) || cCODCLI || CHR(39);
      cRetorno := INSERE_MATU('TT_CON', 'TT_CLI', cWhere);
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3364 --*/
CREATE TRIGGER TGCON2
AFTER INSERT OR DELETE OR UPDATE ON TT_CON 
FOR EACH ROW EXECUTE PROCEDURE TGCON2();



/*-- SEQ 3365 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCOR() CASCADE;

/*-- SEQ 3366 --*/
CREATE OR REPLACE FUNCTION TGCOR() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
WK_COUNT Numeric(5);

BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN := ProximoCodigo('TT_COR',NEW.CODFIL);       
    END IF;
    NEW.DATOPE:=AGORA();        
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF (Equal(OLD.CODARC,NEW.CODARC)<>1) THEN
        
        SELECT COUNT(*) INTO WK_COUNT
          FROM TD_ARC
         WHERE CODTAB=NEW.CODARC
           AND TIPARC='F';
           
        IF WK_COUNT=1 THEN
           UPDATE TT_END
              SET TIPARC='F',
                  CODARC=NEW.CODARC
            WHERE FILCLI=NEW.FILCLI
              AND CODCLI=NEW.CODCLI;
        END IF;          
     END IF;     
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3367 --*/
CREATE TRIGGER TGCOR
BEFORE INSERT OR UPDATE ON TT_COR 
FOR EACH ROW EXECUTE PROCEDURE TGCOR();


/*-- SEQ 3368 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCORXCOB() CASCADE;

/*-- SEQ 3369 --*/
CREATE OR REPLACE FUNCTION TGCORXCOB() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TT_CORXCOB',NEW.FILCOR);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3370 --*/
CREATE TRIGGER TGCORXCOB
BEFORE INSERT ON TT_CORXCOB 
FOR EACH ROW EXECUTE PROCEDURE TGCORXCOB();


/*-- SEQ 3371 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCOS() CASCADE;

/*-- SEQ 3372 --*/
CREATE OR REPLACE FUNCTION TGCOS() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
BEGIN
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    NEW.SEQUEN:=ProximoCodigo('TT_COS',NEW.CODFIL);
  END IF; 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3373 --*/
CREATE TRIGGER TGCOS
BEFORE INSERT ON TT_COS 
FOR EACH ROW EXECUTE PROCEDURE TGCOS();


/*-- SEQ 3374 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCPF() CASCADE;

/*-- SEQ 3375 --*/
CREATE OR REPLACE FUNCTION TGCPF() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impede excluso.
-- 2. Gerar um cdigo sequencial exclusivo para compor a chave primria.
-- 3. Atualiza controles de data.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Impede excluso.
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20000 Registro no pode ser excludo. %' , COMPLEMENTO;
   END IF;

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN := ProximoCodigo('TT_CPF',NEW.CODFIL);
      END IF;
      NEW.DATINC := Agora();
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3376 --*/
CREATE TRIGGER TGCPF
BEFORE INSERT OR UPDATE OR DELETE ON TT_CPF 
FOR EACH ROW EXECUTE PROCEDURE TGCPF();


/*-- SEQ 3377 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCPF2() CASCADE;

/*-- SEQ 3378 --*/
CREATE OR REPLACE FUNCTION TGCPF2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Registrar mudanas dos dados na TT_CPF.

-- Declarao de variveis e cursores
   cLog                          VARCHAR(4000) := '';
   cFILUSU                       TT_USU.FILUSU%TYPE;
   cCODUSU                       TT_USU.CODUSU%TYPE;
   cNulo                         CONSTANT CHAR(04) := 'Nulo';
   iNulo                         CONSTANT Numeric(01) := 0;
   CRLF                          CONSTANT CHAR(01) := CHR(10);
   nCODUID                       TT_UID.CODUID%TYPE;
      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
   
-- Principal
BEGIN
         SELECT MAX(CODUID)
        INTO nCODUID
        FROM TT_UID
       WHERE SESSION_ID = USERENV('SESSIONID');
   
   select * into QuemLogou from DadosLogon();
   cFILUSU := QuemLogou.FILUSU;
   cCODUSU := QuemLogou.CODUSU;

   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
         cLog := cLog||'Filial: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
         cLog := cLog||'Sequnciador: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
      END IF;
      IF Equal(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS')) <> 1 THEN
         cLog := cLog||'Data Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
      END IF;
      /*IF Equal(TO_CHAR(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),TO_CHAR(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS')) <> 1 THEN
         cLog := cLog||'Data Atualizao: de '||COALESCE(TO_CHAR(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
      END IF;*/
      IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
         cLog := cLog||'Situao: de '||COALESCE(DescricaoDominio('CPF','FLGEST',TO_CHAR(OLD.FLGEST)),cNulo)||' para '||COALESCE(DescricaoDominio('CPF','FLGEST',TO_CHAR(NEW.FLGEST)),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DESCRI,NEW.DESCRI) <> 1 THEN
         cLog := cLog||'Descrio: de '||COALESCE(OLD.DESCRI,cNulo)||' para '||COALESCE(NEW.DESCRI,cNulo)||CRLF;
      END IF;

      IF ISNOTNULL(TRIM(cLog)) = 'T' THEN
         INSERT INTO TL_CPF (FILCPF, SEQCPF, DATOPE, FILUSU, CODUSU, MSGLOG, CODUID)
                     VALUES (NEW.CODFIL, NEW.SEQUEN, Agora(), cFILUSU, cCODUSU, cLog, nCODUID);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3379 --*/
CREATE TRIGGER TGCPF2
AFTER UPDATE ON TT_CPF 
FOR EACH ROW EXECUTE PROCEDURE TGCPF2();


/*-- SEQ 3380 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCPXF() CASCADE;

/*-- SEQ 3381 --*/
CREATE OR REPLACE FUNCTION TGCPXF() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Atualiza controles de data.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Marcar data de incluso.
   IF (TG_OP = 'INSERT') THEN
      NEW.DATINC := Agora();
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3382 --*/
CREATE TRIGGER TGCPXF
BEFORE INSERT OR UPDATE OR DELETE ON TT_CPFXFOR 
FOR EACH ROW EXECUTE PROCEDURE TGCPXF();


/*-- SEQ 3383 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCPXF2() CASCADE;

/*-- SEQ 3384 --*/
CREATE OR REPLACE FUNCTION TGCPXF2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Registrar mudanas dos dados na TT_CPFXFOR.

-- Declarao de variveis e cursores
   cLog                          VARCHAR(4000) := '';
   cLogChave                     VARCHAR(30)   := '';
   cFILUSU                       TT_USU.FILUSU%TYPE;
   cCODUSU                       TT_USU.CODUSU%TYPE;
   cNulo                         CONSTANT CHAR(04) := 'Nulo';
   iNulo                         CONSTANT Numeric(01) := 0;
   CRLF                          CONSTANT CHAR(01) := CHR(10);
   nCODUID                       TT_UID.CODUID%TYPE;
      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
   
-- Principal
BEGIN
         SELECT MAX(CODUID)
        INTO nCODUID
        FROM TT_UID
       WHERE SESSION_ID = USERENV('SESSIONID');
   
   select * into QuemLogou from DadosLogon();
   cFILUSU := QuemLogou.FILUSU;
   cCODUSU := QuemLogou.CODUSU;

   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
         cLog := cLog||'Filial: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
         cLog := cLog||'Sequnciador: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILFOR,NEW.FILFOR) <> 1 THEN
         cLog := cLog||'Filial Fornecedor: de '||COALESCE(OLD.FILFOR,cNulo)||' para '||COALESCE(NEW.FILFOR,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODFOR,NEW.CODFOR) <> 1 THEN
         cLog := cLog||'Cdigo Fornecedor: de '||COALESCE(OLD.CODFOR,cNulo)||' para '||COALESCE(NEW.CODFOR,cNulo)||CRLF;
      END IF;
      IF Equal(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS')) <> 1 THEN
         cLog := cLog||'Data Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
      END IF;
      /*IF Equal(TO_CHAR(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),TO_CHAR(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS')) <> 1 THEN
         cLog := cLog||'Data Atualizao: de '||COALESCE(TO_CHAR(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
      END IF;*/
      IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
         cLog := cLog||'Situao: de '||COALESCE(DescricaoDominio('CPXF','FLGEST',OLD.FLGEST),cNulo)||' para '||COALESCE(DescricaoDominio('CPXF','FLGEST',NEW.FLGEST),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TIPEXP,NEW.TIPEXP) <> 1 THEN
         cLog := cLog||'Tipo de Exportao: de '||COALESCE(DescricaoDominio('CPXF','TIPEXP',OLD.TIPEXP),cNulo)||' para '||COALESCE(DescricaoDominio('CPXF','TIPEXP',NEW.TIPEXP),cNulo)||CRLF;
      END IF;

      IF ISNOTNULL(TRIM(cLog)) = 'T' THEN
         cLogChave := OLD.CODFIL || '-' || OLD.SEQUEN || '-' || OLD.FILFOR ||'/' || OLD.CODFOR;
         cLog := cLog || 'Fornecedor >> ' || cLogChave || CRLF;

         INSERT INTO TL_CPF (FILCPF, SEQCPF, DATOPE, FILUSU, CODUSU, MSGLOG, CODUID)
                     VALUES (NEW.CODFIL, NEW.SEQUEN, Agora(), cFILUSU, cCODUSU, cLog, nCODUID);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3385 --*/
CREATE TRIGGER TGCPXF2
AFTER UPDATE ON TT_CPFXFOR 
FOR EACH ROW EXECUTE PROCEDURE TGCPXF2();


/*-- SEQ 3386 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCPM1() CASCADE;

/*-- SEQ 3387 --*/
CREATE OR REPLACE FUNCTION TGCPM1() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Formatar data de validade
-- 3) Registrar mudanca dos dados num "log"
--
   cLOG                          TL_PRE.MSGLOG%TYPE := '';
   iNulo                         CONSTANT Numeric(1) := 0;
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   cRetorno                      VARCHAR(2);
   fQTDVEN                       Numeric := 0;
BEGIN
   -- Gera codigo sequencial exclusivo
   IF (TG_OP = 'INSERT') THEN
      NEW.SEQUEN:=ProximoCodigo('TT_CPM',NEW.FILCPM);
      -- "default"
      IF NEW.DATINC IS NULL THEN
         NEW.DATINC := agora();
      END IF;
   END IF;

   -- Tratamento de "log"
   IF (TG_OP = 'DELETE') THEN
      cLOG := 'Promoo (antes da exclusao) - ';
      cLOG := cLOG||'Operador era '||COALESCE(OLD.FILUSU,cNulo)||'-'||COALESCE(OLD.CODUSU,cNulo)||CRLF;
      cLOG := cLOG||'Plano era '||COALESCE(OLD.FILPGT,cNulo)||'-'||COALESCE(OLD.CODPGT,cNulo)||CRLF;
      cLOG := cLOG||'Preco promocional era '||TO_CHAR(COALESCE(OLD.PRECOP,iNulo),'fm9G999G990D00')||CRLF;
      cLOG := cLOG||'Validade era '||COALESCE(TO_CHAR(OLD.DATVAL,'DD/MM/YYYY'),cNulo)||CRLF;
      cLOG := cLOG||'Filial era '||COALESCE(OLD.FILPRO,cNulo)||CRLF;

      INSERT INTO TL_PRE (FILPRE,SEQPRE,DATOPE,MSGLOG)
                  VALUES (OLD.FILPRE,OLD.SEQPRE,agora(),cLOG);
   END IF;

   -- Tratamento para permitir alterar a Quantidade Disponivel apenas se no existir Quantidade Vendida
   IF (TG_OP = 'UPDATE') THEN
      IF (COALESCE(OLD.QTDCPM,0) <> COALESCE(NEW.QTDCPM,0)) THEN
          SELECT COALESCE(SUM(IVE.QTDMOV),0) 
            INTO fQTDVEN
            FROM TT_IVE IVE 
           WHERE IVE.FILCPM = OLD.FILCPM
             AND IVE.SEQCPM = OLD.SEQUEN;
             
           IF (COALESCE(OLD.QTDCPM,0) = 0) AND (fQTDVEN = 0) THEN
             IF (NEW.QTDCPM < 0) THEN
                RAISE EXCEPTION 'PG-20000 Informe uma quantidade disponvel maior que zero.';
             END IF;
           END IF;
          
           IF (COALESCE(OLD.QTDCPM,0) = 0) AND (fQTDVEN > 0) THEN
              IF (OLD.QTDCPM <> NEW.QTDCPM) THEN
               RAISE EXCEPTION 'PG-20000 A Quantidade Disponvel no pode ser mais definida pois j possui itens vendidos. Crie uma nova promoo e informe a quantidade desejada.';
              END IF;
           END IF;
          
           IF (COALESCE(NEW.QTDCPM,0) >= 0) AND (fQTDVEN > 0) THEN
              IF (NEW.QTDCPM < fQTDVEN) THEN
               RAISE EXCEPTION 'PG-20000 A quantidade mnima aceitvel para este item, deve ser igual ou superior a quantidade vendida.';
              END IF;
           END IF;
      END IF;
   END IF;

   IF (TG_OP = 'DELETE') THEN
      cRetorno := LogExclusao((TG_OP = 'DELETE'), 'TT_CPM', OLD.filcpm, OLD.sequen);
   END IF;
   IF (TG_OP = 'INSERT') THEN
      --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
      cRetorno := LogExclusao((TG_OP = 'DELETE'), 'TT_CPM', NEW.filcpm, NEW.sequen);
   END IF;

   IF NOT (TG_OP = 'DELETE') THEN
      -- Rhuan - 100907 - Permitir informar hora na data de validade da promoo
      --NEW.DATVAL := TRUNC(NEW.DATVAL);
      NEW.ATU_EM := AGORA();
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3388 --*/
CREATE TRIGGER TGCPM1
BEFORE DELETE OR INSERT OR UPDATE ON TT_CPM 
FOR EACH ROW EXECUTE PROCEDURE TGCPM1();

/*-- SEQ 3389 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCPM2() CASCADE;

/*-- SEQ 3390 --*/
CREATE OR REPLACE FUNCTION TGCPM2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Registrar mudanca dos dados num "log"
-- 2) Atualiza ATU_EM da TT_PRE
--
   cLOG                          TL_PRE.MSGLOG%TYPE := '';
   iNulo                         CONSTANT Numeric(1) := 0;
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   cRetorno                      VARCHAR(2);
   cWhere                        TM_ATU.FILTRO%TYPE;

-- Principal
BEGIN
   --Tratamento para Atualizar Tabela Pai
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN
      cWhere := 'FILPRE = ' || CHR(39) || NEW.FILPRE  || CHR(39) || ' AND SEQUEN = ' || CHR(39) || NEW.SEQPRE || CHR(39);
   ELSIF (TG_OP = 'DELETE') THEN
      cWhere := 'FILPRE = ' || CHR(39) || OLD.FILPRE  || CHR(39) || ' AND SEQUEN = ' || CHR(39) || OLD.SEQPRE || CHR(39);
   END IF;
   cRetorno := INSERE_MATU('TT_CPM', 'TT_PRE', cWhere);

   -- Tratamento de log
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.FILUSU,NEW.FILUSU) <> 1 OR Equal(OLD.CODUSU,NEW.CODUSU) <> 1 THEN
         cLOG := cLOG||'Operador: de '||COALESCE(OLD.FILUSU,cNulo)||'-'||COALESCE(OLD.CODUSU,cNulo)||' para '||COALESCE(NEW.FILUSU,cNulo)||'-'||COALESCE(NEW.CODUSU,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILPGT,NEW.FILPGT) <> 1 OR Equal(OLD.CODPGT,NEW.CODPGT) <> 1 THEN
         cLOG := cLOG||'Plano: de '||COALESCE(OLD.FILPGT,cNulo)||'-'||COALESCE(OLD.CODPGT,cNulo)||' para '||COALESCE(NEW.FILPGT,cNulo)||'-'||COALESCE(NEW.CODPGT,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PRECOP,NEW.PRECOP) <> 1 THEN
         cLOG := cLOG||'Preco: de '||TO_CHAR(COALESCE(OLD.PRECOP,iNulo),'fm9G999G990D00')||' para '||TO_CHAR(COALESCE(NEW.PRECOP,iNulo),'fm9G999G990D00')||CRLF;
      END IF;
      IF Equal(OLD.DATVAL,NEW.DATVAL) <> 1 THEN
         cLOG := cLOG||'Validade: de '||COALESCE(TO_CHAR(OLD.DATVAL,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATVAL,'DD/MM/YYYY'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILPRO,NEW.FILPRO) <> 1 THEN
         cLOG := cLOG||'Filial: de '||COALESCE(OLD.FILPRO,cNulo)||' para '||COALESCE(NEW.FILPRO,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILLOT,NEW.FILLOT) <> 1 THEN
         cLOG := cLOG||'Filial do Lote: de '||COALESCE(OLD.FILLOT,cNulo)||' para '||COALESCE(NEW.FILLOT,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SEQLOT,NEW.SEQLOT) <> 1 THEN
         cLOG := cLOG||'Sequenciador do Lote: de '||COALESCE(OLD.SEQLOT,cNulo)||' para '||COALESCE(NEW.SEQLOT,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DATINC,NEW.DATINC) <> 1 THEN
         cLOG := cLOG||'Data da incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.QTDCPM,NEW.QTDCPM) <> 1 THEN
         cLOG := cLOG||'Quantidade disponvel para promoo: de '||TO_CHAR(COALESCE(OLD.QTDCPM,iNulo),'fm9G999G990D0000')||' para '||TO_CHAR(COALESCE(NEW.QTDCPM,iNulo),'fm9G999G990D0000')||CRLF;
      END IF;
      IF Equal(OLD.QTDMIN,NEW.QTDMIN) <> 1 THEN
         cLOG := cLOG||'Quantidade mnima: de '||TO_CHAR(COALESCE(OLD.QTDMIN,iNulo),'fm9G999G990D0000')||' para '||TO_CHAR(COALESCE(NEW.QTDMIN,iNulo),'fm9G999G990D0000')||CRLF;
      END IF;
      IF Equal(OLD.CLILEV,NEW.CLILEV) <> 1 THEN
         cLOG := cLOG||'Promoo somente quando o cliente leva: de '||COALESCE(OLD.CLILEV,cNulo)||' para '||COALESCE(NEW.CLILEV,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TEMDES,NEW.TEMDES) <> 1 THEN
         cLOG := cLOG||'Aceita Desconto: de '||COALESCE(DescricaoDominio('CPM','TEMDES',OLD.TEMDES),cNulo)||' para '||COALESCE(DescricaoDominio('CPM','TEMDES',NEW.TEMDES),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILPRE,NEW.FILPRE) <> 1 THEN
         cLOG := cLOG||'Filial da Tabela de Preo: de '||COALESCE(OLD.FILPRE,cNulo)||' para '||COALESCE(NEW.FILPRE,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SEQPRE,NEW.SEQPRE) <> 1 THEN
         cLOG := cLOG||'Sequenciador da Tabela de Preo: de '||COALESCE(OLD.SEQPRE,cNulo)||' para '||COALESCE(NEW.SEQPRE,cNulo)||CRLF;
      END IF;

      IF ISNOTNULL(cLOG) = 'T' THEN
         cLOG := 'Promoo - '|| cLOG;
         INSERT INTO TL_PRE (FILPRE,SEQPRE,DATOPE,MSGLOG)
         VALUES (NEW.FILPRE,NEW.SEQPRE,agora(),cLOG);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3391 --*/
CREATE TRIGGER TGCPM2
AFTER INSERT OR UPDATE OR DELETE ON TT_CPM 
FOR EACH ROW EXECUTE PROCEDURE TGCPM2();


/*-- SEQ 3392 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCPR() CASCADE;

/*-- SEQ 3393 --*/
CREATE OR REPLACE FUNCTION TGCPR() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Controle de datas

-- Principal
BEGIN
   
  -- Gera codigo sequencial exclusivo
  IF (TG_OP = 'INSERT') THEN
     NEW.SEQUEN := ProximoCodigo('TT_CPR',NEW.CODFIL);
     NEW.DATINC := agora();
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3394 --*/
CREATE TRIGGER TGCPR
BEFORE INSERT OR UPDATE ON TT_CPR 
FOR EACH ROW EXECUTE PROCEDURE TGCPR();

/*-- SEQ 3395 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCPR2() CASCADE;

/*-- SEQ 3396 --*/
CREATE OR REPLACE FUNCTION TGCPR2() RETURNS TRIGGER AS $$
DECLARE

  -- Objetivos
  -- 1) Registrar Log de alteraes
  -- Principal
  cLOG                          VARCHAR(4000)     := '';
  cNulo                         CONSTANT CHAR(4)   := 'Nulo';
  iNulo                         CONSTANT Numeric(1) := 0;
  CRLF                          CONSTANT CHAR(1)   := CHR(10);
  wk_coduid                     TT_UID.CODUID%TYPE;
  
    
    QuemLogou                     TRetQuemLogou%ROWTYPE;
  BEGIN
   IF (TG_OP = 'UPDATE') THEN     
     IF Equal(OLD.CPRATI,NEW.CPRATI) <> 1 THEN
       cLOG := cLOG||'Ativo?: '||COALESCE(OLD.CPRATI, cNulo)||' para '||COALESCE(NEW.CPRATI, cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DESCRI,NEW.DESCRI) <> 1 THEN
       cLOG := cLOG||'Descrio: '||COALESCE(OLD.DESCRI, cNulo)||' para '||COALESCE(NEW.DESCRI, cNulo)||CRLF;
     END IF;
     IF Equal(OLD.FILAPL,NEW.FILAPL) <> 1 THEN
       cLOG := cLOG||'Filial de Aplicao: '||COALESCE(OLD.FILAPL, cNulo)||' para '||COALESCE(NEW.FILAPL, cNulo)||CRLF;
     END IF;
     IF Equal(OLD.TIPAPL,NEW.TIPAPL) <> 1 THEN
       cLOG := cLOG||'Tipo de Aplicao: '||COALESCE(OLD.TIPAPL, cNulo)||' para '||COALESCE(NEW.TIPAPL, cNulo)||CRLF;
     END IF;
     IF Equal(OLD.CANAPL,NEW.CANAPL) <> 1 THEN
       cLOG := cLOG||'Canal de aplicao da campanha: '||COALESCE(OLD.CANAPL, cNulo)||' para '||COALESCE(NEW.CANAPL, cNulo)||CRLF;
     END IF;
     IF Equal(OLD.USOOUT,NEW.USOOUT) <> 1 THEN
       cLOG := cLOG||'Permitir uso com produtos com outro desconto?: '||COALESCE(OLD.USOOUT, cNulo)||' para '||COALESCE(NEW.USOOUT, cNulo)||CRLF;
     END IF;
     IF Equal(OLD.VENCUS,NEW.VENCUS) <> 1 THEN
       cLOG := cLOG||'Solicitar permisso quando valor de venda ficar abaixo do Custo de Reposio?: '||COALESCE(OLD.VENCUS, cNulo)||' para '||COALESCE(NEW.VENCUS, cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATINI, NEW.DATINI) <> 1 THEN
        cLOG := cLOG||'Data Incio: de '||COALESCE(TO_CHAR(OLD.DATINI,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINI,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATFIM, NEW.DATFIM) <> 1 THEN
        cLOG := cLOG||'Data Final: de '||COALESCE(TO_CHAR(OLD.DATFIM,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATFIM,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.VLRMIN,NEW.VLRMIN) <> 1 THEN
         cLOG := cLOG||'Valor mnimo da compra: de '||COALESCE(TO_CHAR(OLD.VLRMIN),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRMIN),cNulo)||CRLF;
      END IF;
     
    WK_CODUID := GetCoduidAtual();

    -- MN - Grava Log
    IF ISNOTNULL(cLOG) = 'T' THEN
         cLOG := 'Campanha de Promoo >> '||cLOG||CRLF;
         
         select * into QuemLogou from DadosLogon();
         INSERT INTO TL_CPR (FILCPR,SEQCPR,FILUSU,CODUSU,DATOPE,MSGLOG,CODUID)
                     VALUES (NEW.CODFIL,NEW.SEQUEN,QuemLogou.FILUSU,QuemLogou.CODUSU,agora(),cLOG,WK_CODUID);
    END IF;
    
  END IF; -- Fim IF do (TG_OP = 'UPDATE')
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3397 --*/
CREATE TRIGGER TGCPR2
AFTER INSERT OR DELETE OR UPDATE ON TT_CPR 
FOR EACH ROW EXECUTE PROCEDURE TGCPR2();


/*-- SEQ 3398 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCPRXDFIL() CASCADE;

/*-- SEQ 3399 --*/
CREATE OR REPLACE FUNCTION TGCPRXDFIL() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Controlar Datas e Sequenciadores

-- Principal
BEGIN
  -- Gera codigo sequencial exclusivo
  IF (TG_OP = 'INSERT') THEN
    NEW.SEQUEN := ProximoCodigo('TT_CPRXDFIL',NEW.FILCPR);
    NEW.DATINC := agora();
  END IF; 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3400 --*/
CREATE TRIGGER TGCPRXDFIL
BEFORE INSERT OR UPDATE ON TT_CPRXDFIL 
FOR EACH ROW EXECUTE PROCEDURE TGCPRXDFIL();


/*-- SEQ 3401 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCPRXGAT() CASCADE;

/*-- SEQ 3402 --*/
CREATE OR REPLACE FUNCTION TGCPRXGAT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Controlar Datas e Sequenciadores

-- Principal
BEGIN
  -- Gera codigo sequencial exclusivo
  IF (TG_OP = 'INSERT') THEN
    NEW.SEQUEN := ProximoCodigo('TT_CPRXGAT',NEW.FILCPR);
    NEW.DATINC := agora();
  END IF; 

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3403 --*/
CREATE TRIGGER TGCPRXGAT
BEFORE INSERT OR UPDATE ON TT_CPRXGAT 
FOR EACH ROW EXECUTE PROCEDURE TGCPRXGAT();

/*-- SEQ 3404 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCPRXGAT2() CASCADE;

/*-- SEQ 3405 --*/
CREATE OR REPLACE FUNCTION TGCPRXGAT2() RETURNS TRIGGER AS $$
DECLARE

  -- Objetivos
  -- 1) Registrar Log de alteraes
  -- 2) Atualiza ATU_EM da TT_CPR
  -- Principal
  cRetorno                      VARCHAR(2);
  cWhere                        TM_ATU.FILTRO%TYPE;
  cFILCPR                       TT_CPR.CODFIL%TYPE;
  cSEQCPR                       TT_CPR.SEQUEN%TYPE;
  cLOG                          VARCHAR(4000)     := '';
  cNulo                         CONSTANT CHAR(4)   := 'Nulo';
  iNulo                         CONSTANT Numeric(1) := 0;
  CRLF                          CONSTANT CHAR(1)   := CHR(10);
  wk_coduid                     TT_UID.CODUID%TYPE;
  
    
    QuemLogou                     TRetQuemLogou%ROWTYPE;
  BEGIN
   --Tratamento para Atualizar Tabela Pai
   IF (TG_OP = 'INSERT') THEN
      cFILCPR := NEW.FILCPR;
      cSEQCPR := NEW.SEQCPR;
   ELSIF (TG_OP = 'UPDATE') THEN
      cFILCPR := NEW.FILCPR;
      cSEQCPR := NEW.SEQCPR;
   ELSIF (TG_OP = 'DELETE') THEN
      cFILCPR := OLD.FILCPR;
      cSEQCPR := OLD.SEQCPR;
   END IF;
   IF ISNOTNULL(TO_CHAR(cFILCPR))='T' THEN
      cWhere := 'CODFIL = ' || CHR(39) || cFILCPR  || CHR(39) || ' AND SEQUEN = ' || CHR(39) || cSEQCPR || CHR(39);
      cRetorno := INSERE_MATU('TT_CPRXGAT', 'TT_CPR', cWhere);
   END IF;

   -- Tratamento para Log
   IF (TG_OP = 'UPDATE') THEN
     IF Equal(OLD.TIPGAT,NEW.TIPGAT) <> 1 THEN
       cLOG := cLOG||'Tipo de Gatilho: '||COALESCE(OLD.TIPGAT, cNulo)||' para '||COALESCE(NEW.TIPGAT, cNulo)||CRLF;
     END IF;
     IF Equal(OLD.FILCPRFUT,NEW.FILCPRFUT) <> 1 THEN
       cLOG := cLOG||'Filial da Campanha Futura: '||COALESCE(OLD.FILCPRFUT, cNulo)||' para '||COALESCE(NEW.FILCPRFUT, cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SEQCPRFUT,NEW.SEQCPRFUT) <> 1 THEN
       cLOG := cLOG||'Sequenciador da Campanha Futura: '||COALESCE(OLD.SEQCPRFUT, cNulo)||' para '||COALESCE(NEW.SEQCPRFUT, cNulo)||CRLF;
     END IF;
     IF Equal(OLD.TIPOBG,NEW.TIPOBG) <> 1 THEN
       cLOG := cLOG||'Tipo de Obrigatoriedade: '||COALESCE(OLD.TIPOBG, cNulo)||' para '||COALESCE(NEW.TIPOBG, cNulo)||CRLF;
     END IF;
     IF Equal(OLD.GATATI,NEW.GATATI) <> 1 THEN
       cLOG := cLOG||'Gatilho Ativo?: '||COALESCE(OLD.GATATI, cNulo)||' para '||COALESCE(NEW.GATATI, cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DESCRI,NEW.DESCRI) <> 1 THEN
       cLOG := cLOG||'Descrio: '||COALESCE(OLD.DESCRI, cNulo)||' para '||COALESCE(NEW.DESCRI, cNulo)||CRLF;
     END IF;

    WK_CODUID := GetCoduidAtual();

    -- MN - Grava Log
    IF ISNOTNULL(cLOG) = 'T' THEN
         cLOG := 'Gatilhos de Campanha  >> '||cLOG||CRLF;
         
         select * into QuemLogou from DadosLogon();
         INSERT INTO TL_CPR (FILCPR,SEQCPR,FILUSU,CODUSU,DATOPE,MSGLOG,CODUID)
                     VALUES (NEW.FILCPR,NEW.SEQCPR,QuemLogou.FILUSU,QuemLogou.CODUSU,agora(),cLOG,WK_CODUID);
    END IF;
  END IF; -- Fim IF do (TG_OP = 'UPDATE')
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3406 --*/
CREATE TRIGGER TGCPRXGAT2
AFTER INSERT OR DELETE OR UPDATE ON TT_CPRXGAT 
FOR EACH ROW EXECUTE PROCEDURE TGCPRXGAT2();


/*-- SEQ 3407 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCPRXPLA() CASCADE;

/*-- SEQ 3408 --*/
CREATE OR REPLACE FUNCTION TGCPRXPLA() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Controlar Datas e Sequenciadores

-- Principal
BEGIN
  -- Gera codigo sequencial exclusivo
  IF (TG_OP = 'INSERT') THEN
    NEW.SEQUEN := ProximoCodigo('TT_CPRXPLA',NEW.FILCPR);
    NEW.DATINC := agora();
  END IF; 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3409 --*/
CREATE TRIGGER TGCPRXPLA
BEFORE INSERT OR UPDATE ON TT_CPRXPLA 
FOR EACH ROW EXECUTE PROCEDURE TGCPRXPLA();


/*-- SEQ 3410 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCPRXTPR() CASCADE;

/*-- SEQ 3411 --*/
CREATE OR REPLACE FUNCTION TGCPRXTPR() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Controlar Datas e Sequenciadores

-- Principal
BEGIN
  -- Gera codigo sequencial exclusivo
  IF (TG_OP = 'INSERT') THEN
    NEW.SEQUEN := ProximoCodigo('TT_CPRXTPR',NEW.FILCPR);
    NEW.DATINC := agora();
  END IF; 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3412 --*/
CREATE TRIGGER TGCPRXTPR
BEFORE INSERT OR UPDATE ON TT_CPRXTPR 
FOR EACH ROW EXECUTE PROCEDURE TGCPRXTPR();


/*-- SEQ 3413 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCRB() CASCADE;

/*-- SEQ 3414 --*/
CREATE OR REPLACE FUNCTION TGCRB() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Impede alterao/excluso
   cComplemento                  CONSTANT VARCHAR(254) := Constante('complemento');
-- Principal
BEGIN

   -- Impede alterao/excluses
   IF (TG_OP = 'DELETE') OR (TG_OP = 'UPDATE') THEN
      IF (TG_OP = 'DELETE') THEN
         RAISE EXCEPTION 'PG-20001 Registro de uso interno. Nao pode ser excluido. %' , cComplemento;
      ELSIF (TG_OP = 'UPDATE') THEN
         RAISE EXCEPTION 'PG-20002 Registro de uso interno. Nao pode ser modificado. %' , cComplemento;
      END IF;
   END IF;

   IF (TG_OP = 'INSERT') THEN
      IF NEW.CODTAB IS NULL THEN
         NEW.CODTAB := ProximoCodigo('TT_CRB','');
      END IF;
   END IF;
   
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN
      NEW.APECRB := UPPER(NEW.APECRB);
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3415 --*/
CREATE TRIGGER TGCRB
BEFORE INSERT OR UPDATE OR DELETE ON TT_CRB 
FOR EACH ROW EXECUTE PROCEDURE TGCRB();

/*-- SEQ 3416 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCRB2() CASCADE;

/*-- SEQ 3417 --*/
CREATE OR REPLACE FUNCTION TGCRB2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3418 --*/
CREATE TRIGGER TGCRB2
AFTER INSERT OR DELETE OR UPDATE ON TT_CRB 
FOR EACH ROW EXECUTE PROCEDURE TGCRB2();


/*-- SEQ 3419 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCRE() CASCADE;

/*-- SEQ 3420 --*/
CREATE OR REPLACE FUNCTION TGCRE() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
BEGIN
  IF (TG_OP = 'INSERT') THEN
    -- Gera codigo sequencial
    IF (NEW.SEQUEN IS NULL) THEN
      NEW.SEQUEN:=ProximoCodigo('TT_CRE',NEW.CODFIL);
    END IF;
  END IF;

  IF NEW.TIPDAD <> 'D' THEN
    NEW.DESCRI := NULL;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3421 --*/
CREATE TRIGGER TGCRE
BEFORE INSERT OR UPDATE ON TT_CRE 
FOR EACH ROW EXECUTE PROCEDURE TGCRE();


/*-- SEQ 3422 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCRTXCLI() CASCADE;

/*-- SEQ 3423 --*/
CREATE OR REPLACE FUNCTION TGCRTXCLI() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Salvar alteraes do registro na tabela de log TT_CRTXCLI

  vLOG  VARCHAR(4000)   := '';
  CRLF  CONSTANT CHAR(1) := CHR(10);
  NULO  CONSTANT CHAR(4) := 'Nulo';
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  cDesCrt VARCHAR(254);
  Logon  TRetQuemLogou%ROWTYPE;
  vComplemento VARCHAR(100);
  iACHOU INTEGER;
BEGIN
  -- Tratamento de vLOG
  IF (TG_OP = 'UPDATE') THEN
    -- Dados do usuario
    select * into Logon from DadosLogon();
    if (Logon.Encontrou) THEN
      cFilUsu := Logon.FILUSU;
      cCodUsu := Logon.CODUSU;
    ELSE
      RAISE EXCEPTION 'PG-20039 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
    END IF;
    
    SELECT DESCRT INTO cDesCrt FROM TD_CRT WHERE CODTAB = NEW.CODCRT;

    IF Equal(OLD.DESCRT,NEW.DESCRT) <> 1 THEN
      vLOG := vLOG||'Caracterizacao de cliente '||cDesCrt||' de: '||COALESCE(OLD.DESCRT,NULO)||' para '||COALESCE(NEW.DESCRT,NULO)||CRLF;
    END IF;

    IF ISNOTNULL(vLOG) = 'T' THEN
      
      INSERT INTO TL_CLI (FILUSU,CODUSU,FILCLI,CODCLI,DATOPE,MSGLOG)
                  VALUES (cFilUsu,cCodUsu,NEW.FILCLI,NEW.CODCLI,agora(),vLOG);
    END IF;

  ELSIF (TG_OP = 'DELETE') THEN
    iACHOU := TGR_Cliente_Existe(OLD.filcli, OLD.CODCli); /* retornos possiveis 0 e 1 E -1 */
    IF (iACHOU = 0) THEN
      DELETE FROM TL_CLI WHERE FILCLI = OLD.FILCLI AND CODCLI = OLD.CODCLI;
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3424 --*/
CREATE TRIGGER TGCRTXCLI
BEFORE INSERT OR DELETE OR UPDATE ON TT_CRTXCLI 
FOR EACH ROW EXECUTE PROCEDURE TGCRTXCLI();


/*-- SEQ 3425 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCRTXEND() CASCADE;

/*-- SEQ 3426 --*/
CREATE OR REPLACE FUNCTION TGCRTXEND() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Salvar alteraes do registro na tabela de log TT_CRTXEND

  vLOG  VARCHAR(4000)   := '';
  CRLF  CONSTANT CHAR(1) := CHR(10);
  NULO  CONSTANT CHAR(4) := 'Nulo';
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  cDesCrt VARCHAR(254);
  Logon  TRetQuemLogou%ROWTYPE;
  vComplemento VARCHAR(100);
BEGIN
  -- Tratamento de vLOG
  IF (TG_OP = 'UPDATE') THEN
    -- Dados do usuario
    select * into Logon from DadosLogon();
    if (Logon.Encontrou) THEN
      cFilUsu := Logon.FILUSU;
      cCodUsu := Logon.CODUSU;
    ELSE
      RAISE EXCEPTION 'PG-20039 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
    END IF;
    
    SELECT DESCRT INTO cDesCrt FROM TD_CRT WHERE CODTAB = NEW.CODCRT;

    IF Equal(OLD.DESCRT,NEW.DESCRT) <> 1 THEN
      vLOG := vLOG||'Caracterizacao de endereco '||cDesCrt||' de: '||COALESCE(OLD.DESCRT,NULO)||' para '||COALESCE(NEW.DESCRT,NULO)||CRLF;
    END IF;

    IF ISNOTNULL(vLOG) = 'T' THEN
      
      INSERT INTO TL_CLI (FILUSU,CODUSU,FILCLI,CODCLI,DATOPE,MSGLOG)
                  VALUES (cFilUsu,cCodUsu,NEW.FILCLI,NEW.CODCLI,agora(),vLOG);
    END IF;

  ELSIF (TG_OP = 'DELETE') THEN
    DELETE FROM TL_CLI WHERE FILCLI = OLD.FILCLI AND CODCLI = OLD.CODCLI;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3427 --*/
CREATE TRIGGER TGCRTXEND
BEFORE INSERT OR DELETE OR UPDATE ON TT_CRTXEND 
FOR EACH ROW EXECUTE PROCEDURE TGCRTXEND();


/*-- SEQ 3428 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCRTXGRA() CASCADE;

/*-- SEQ 3429 --*/
CREATE OR REPLACE FUNCTION TGCRTXGRA() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Salvar alteraes do registro na tabela de log TT_CRTXGRA

  vLOG  VARCHAR(4000)   := '';
  CRLF  CONSTANT CHAR(1) := CHR(10);
  NULO  CONSTANT CHAR(4) := 'Nulo';
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  cDesCrt VARCHAR(254);
  Logon  TRetQuemLogou%ROWTYPE;
  vComplemento VARCHAR(100);
BEGIN
  -- Tratamento de vLOG
  IF (TG_OP = 'UPDATE') THEN
    -- Dados do usuario
    select * into Logon from DadosLogon();
    if (Logon.Encontrou) THEN
      cFilUsu := Logon.FILUSU;
      cCodUsu := Logon.CODUSU;
    ELSE
      RAISE EXCEPTION 'PG-20039 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
    END IF;
    
    SELECT DESCRT INTO cDesCrt FROM TD_CRT WHERE CODTAB = NEW.CODCRT;

    IF Equal(OLD.DESCRT,NEW.DESCRT) <> 1 THEN
      vLOG := vLOG||'Caracterizacao de grade '||cDesCrt||' de: '||COALESCE(OLD.DESCRT,NULO)||' para '||COALESCE(NEW.DESCRT,NULO)||CRLF;
    END IF;

    IF ISNOTNULL(vLOG) = 'T' THEN
      
      INSERT INTO TL_GRA (FILUSU,CODUSU,FILMAT,CODMAT,CODCOR,CODTAM,DATOPE,MSGLOG)
                  VALUES (cFilUsu,cCodUsu,NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,agora(),vLOG);
    END IF;

  ELSIF (TG_OP = 'DELETE') THEN
    DELETE FROM TL_GRA WHERE FILMAT = OLD.FILMAT 
                         AND CODMAT = OLD.CODMAT
                         AND CODCOR = OLD.CODCOR
                         AND CODTAM = OLD.CODTAM;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3430 --*/
CREATE TRIGGER TGCRTXGRA
BEFORE INSERT OR DELETE OR UPDATE ON TT_CRTXGRA 
FOR EACH ROW EXECUTE PROCEDURE TGCRTXGRA();


/*-- SEQ 3431 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCRTXPRO() CASCADE;

/*-- SEQ 3432 --*/
CREATE OR REPLACE FUNCTION TGCRTXPRO() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Salvar alteraes do registro na tabela de log TT_CRTXPRO

  vLOG  VARCHAR(4000)   := '';
  CRLF  CONSTANT CHAR(1) := CHR(10);
  NULO  CONSTANT CHAR(4) := 'Nulo';
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  cDesCrt VARCHAR(254);
  Logon  TRetQuemLogou%ROWTYPE;
  vComplemento VARCHAR(100);
BEGIN

    -- Dados do usuario
    select * into Logon from DadosLogon();
    if (Logon.Encontrou) THEN
      cFilUsu := Logon.FILUSU;
      cCodUsu := Logon.CODUSU;
    ELSE
      RAISE EXCEPTION 'PG-20039 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
   END IF;
	
  -- Tratamento de vLOG
  IF (TG_OP = 'UPDATE') THEN    
    
    SELECT DESCRT INTO cDesCrt FROM TD_CRT WHERE CODTAB = NEW.CODCRT;

    IF Equal(OLD.DESCRT,NEW.DESCRT) <> 1 THEN
      vLOG := vLOG||'Caracterizacao de produto '||cDesCrt||' de: '||COALESCE(OLD.DESCRT,NULO)||' para '||COALESCE(NEW.DESCRT,NULO)||CRLF;
    END IF;

    IF ISNOTNULL(vLOG) = 'T' THEN
      
      INSERT INTO TL_PRO (FILUSU,CODUSU,FILMAT,CODMAT,DATOPE,MSGLOG)
                  VALUES (cFilUsu,cCodUsu,NEW.FILMAT,NEW.CODMAT,agora(),vLOG);
    END IF;
  ELSIF (TG_OP = 'INSERT') THEN
    SELECT DESCRT INTO cDesCrt FROM TD_CRT WHERE CODTAB = NEW.CODCRT;
	INSERT INTO TL_PRO (FILUSU,CODUSU,FILMAT,CODMAT,DATOPE,MSGLOG)
                VALUES (cFilUsu,cCodUsu,NEW.FILMAT,NEW.CODMAT,agora(),'Incluso de caracterizacao de produto:'||cDesCrt);

  ELSIF (TG_OP = 'DELETE') THEN
    DELETE FROM TL_PRO WHERE FILMAT = OLD.FILMAT 
                         AND CODMAT = OLD.CODMAT;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3433 --*/
CREATE TRIGGER TGCRTXPRO
BEFORE INSERT OR DELETE OR UPDATE ON TT_CRTXPRO 
FOR EACH ROW EXECUTE PROCEDURE TGCRTXPRO();


/*-- SEQ 3434 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCTA() CASCADE;

/*-- SEQ 3435 --*/
CREATE OR REPLACE FUNCTION TGCTA() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Trata dados padroes na inclusao
DECLARE
   cRet VARCHAR(2);
-- Principal
BEGIN
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN := ProximoCodigo('TT_CTA',NEW.CODFIL);
      END IF;
      IF NEW.APLNUM IS NULL THEN
         IF NEW.TIPCTA = 'G' THEN
            NEW.APLNUM := 'G';
         ELSE
            NEW.APLNUM := 'N';
         END IF;
      END IF;
      NEW.ATU_EM := AGORA();
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF (Equal(OLD.CODFIL,NEW.CODFIL) = 0 OR
         Equal(OLD.SEQUEN,NEW.SEQUEN) = 0 OR
         Equal(OLD.TIPCTA,NEW.TIPCTA) = 0 OR
         Equal(OLD.FILECT,NEW.FILECT) = 0 OR
         Equal(OLD.SEQECT,NEW.SEQECT) = 0 OR
         Equal(OLD.TITCTA,NEW.TITCTA) = 0 OR
         Equal(OLD.ULTDOC,NEW.ULTDOC) = 0 OR
         Equal(OLD.CODEXT,NEW.CODEXT) = 0 OR
         Equal(OLD.PREFIX,NEW.PREFIX) = 0 OR
         Equal(OLD.USOCTA,NEW.USOCTA) = 0 OR
         Equal(OLD.NIVCRI,NEW.NIVCRI) = 0 OR
         Equal(OLD.APLNUM,NEW.APLNUM) = 0 ) then
         UPDATE TD_COB SET ATU_EM = AGORA() WHERE FILCTA = NEW.CODFIL AND SEQCTA = NEW.SEQUEN;
         UPDATE TD_COB SET ATU_EM = AGORA() WHERE FILCTA = OLD.CODFIL AND SEQCTA = OLD.SEQUEN;

         NEW.ATU_EM := AGORA();
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3436 --*/
CREATE TRIGGER TGCTA
BEFORE INSERT OR UPDATE ON TT_CTA 
FOR EACH ROW EXECUTE PROCEDURE TGCTA();

/*-- SEQ 3437 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCTA2() CASCADE;

/*-- SEQ 3438 --*/
CREATE OR REPLACE FUNCTION TGCTA2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   IF (TG_OP = 'UPDATE') THEN
      IF (Equal(OLD.TITCTA,NEW.TITCTA) = 0) THEN
         cRetorno := AtualizaData('CONFIGURACAO',Agora());
      END IF;
   ELSE
      cRetorno := AtualizaData('CONFIGURACAO',Agora());
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3439 --*/
CREATE TRIGGER TGCTA2
AFTER INSERT OR UPDATE OR DELETE ON TT_CTA 
FOR EACH ROW EXECUTE PROCEDURE TGCTA2();


/*-- SEQ 3440 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCTAXFIL() CASCADE;

/*-- SEQ 3441 --*/
CREATE OR REPLACE FUNCTION TGCTAXFIL() RETURNS TRIGGER AS $$
DECLARE
-- Declarao de variveis e cursores
   vUpdNew                       BOOLEAN;
   vUpdOld                       BOOLEAN;
   vAux                          CHAR(2);
   vFILCTA                       TT_CTAXFIL.FILCTA%TYPE;
   vSEQCTA                       TT_CTAXFIL.SEQCTA%TYPE;

-- Principal
BEGIN
   vUpdNew := False;
   vUpdOld := False;

   IF (TG_OP = 'UPDATE') THEN
      IF NEW.TIPCTA = 'N' THEN
         IF TRUNC(NEW.DATA_INICIAL) <> TRUNC(OLD.DATA_INICIAL)
         OR COALESCE(NEW.SALDO_INICIAL_A,0) <> COALESCE(OLD.SALDO_INICIAL_A,0)
         OR COALESCE(NEW.SALDO_INICIAL_R,0) <> COALESCE(OLD.SALDO_INICIAL_R,0) THEN
            vUpdNew := True;
         END IF;
      END IF;
   END IF;

   IF (TG_OP = 'UPDATE') THEN
      IF NEW.TIPCTA = 'N' THEN
         IF NEW.CODFIL <> OLD.CODFIL THEN
            vUpdOld := True;
            vUpdNew := True;
         END IF;
      END IF;
   END IF;

   IF (TG_OP = 'INSERT') THEN
      IF NEW.TIPCTA = 'N' THEN
         IF NEW.SALDO_INICIAL_A IS NOT NULL
         OR NEW.SALDO_INICIAL_R IS NOT NULL THEN
            vUpdNew := True;
         END IF;
      END IF;
   END IF;

   IF (TG_OP = 'DELETE') THEN
      IF OLD.SALDO_INICIAL_A IS NOT NULL
      OR OLD.SALDO_INICIAL_R IS NOT NULL THEN
         vUpdOld := True;
      END IF;
   END IF;

   IF vUpdOld THEN
      vFILCTA := OLD.FILCTA;
      vSEQCTA := OLD.SEQCTA;
      vAux := TGR_CTAXFIL_RecriaRCTA(OLD.FILCTA,
                                     OLD.SEQCTA,
                                     OLD.TIPCTA,
                                     OLD.CODFIL,
                                     null,
                                     null,
                                     null);
   END IF;

   IF vUpdNew THEN
      vFILCTA := NEW.FILCTA;
      vSEQCTA := NEW.SEQCTA;
      vAux := TGR_CTAXFIL_RecriaRCTA(NEW.FILCTA,
                                     NEW.SEQCTA,
                                     NEW.TIPCTA,
                                     NEW.CODFIL,
                                     NEW.DATA_INICIAL,
                                     NEW.SALDO_INICIAL_A,
                                     NEW.SALDO_INICIAL_R);
   END IF;

   IF vUpdOld OR vUpdNew THEN
      --prepara tt_cta para atualizao de saldo
      UPDATE TT_CTA
         SET ATUREA = 'F',
             ATUARE = 'F',
             DATARE = NULL,
             DATREA = NULL
       WHERE CODFIL = vFILCTA
         AND SEQUEN = vSEQCTA;

      --atualiza saldo
      vAux := AtualizaSaldoContas();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3442 --*/
CREATE TRIGGER TGCTAXFIL
BEFORE INSERT OR UPDATE OR DELETE ON TT_CTAXFIL 
FOR EACH ROW EXECUTE PROCEDURE TGCTAXFIL();


/*-- SEQ 3443 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCTB1() CASCADE;

/*-- SEQ 3444 --*/
CREATE OR REPLACE FUNCTION TGCTB1() RETURNS TRIGGER AS $$
-- 1) Incluir uma conta automaticamente
DECLARE
  cRet VARCHAR(2);
BEGIN
  IF (TG_OP = 'DELETE') THEN
     cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_CTB', OLD.CODBCO || substr(OLD.NUMAGE,2,4)||OLD.digage, substr(OLD.CTACRR,2,9)||OLD.digcrr);
  END IF;
  IF (TG_OP = 'INSERT') THEN
     --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
     cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_CTB', NEW.CODBCO || substr(NEW.NUMAGE,2,4)||NEW.digage, substr(NEW.CTACRR,2,9)||NEW.digcrr);
  END IF;

  IF NOT (TG_OP = 'DELETE') THEN
    NEW.ATU_EM := AGORA();
    NEW.NUMAGE := LPAD(LTRIM(RTRIM(NEW.NUMAGE)),5,'0');
    NEW.CTACRR := LPAD(LTRIM(RTRIM(NEW.CTACRR)),10,'0');
  END IF;

  IF (TG_OP = 'UPDATE') THEN
    IF NEW.PRXTIT = OLD.PRXTIT then
        UPDATE TT_DOP SET ATU_EM = AGORA()
         WHERE FILCTA = NEW.FILCTA
           AND SEQCTA = NEW.SEQCTA
           AND TIPCTA = NEW.TIPCTA
           AND FLGEST <> 'C';

        UPDATE TT_DOP SET ATU_EM = AGORA()
         WHERE FILCTA = OLD.FILCTA
           AND SEQCTA = OLD.SEQCTA
           AND TIPCTA = OLD.TIPCTA
           AND FLGEST <> 'C';
    END IF;
  END IF;

  -- Gera uma conta no plano de contas
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQCTA IS NULL THEN
      NEW.SEQCTA := ProximaConta(NEW.FILCTA,'CONTA BANCO - '||NEW.NOMAGE,NEW.TIPCTA,NEW.CTACTB,'');
    END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3445 --*/
CREATE TRIGGER TGCTB1
BEFORE INSERT OR UPDATE OR DELETE ON TT_CTB 
FOR EACH ROW EXECUTE PROCEDURE TGCTB1();

/*-- SEQ 3446 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCTB2() CASCADE;

/*-- SEQ 3447 --*/
CREATE OR REPLACE FUNCTION TGCTB2() RETURNS TRIGGER AS $$
-- 1) Incluir um portador automaticamente
DECLARE
  wk_ultimo_codigo TD_COB.CODTAB%TYPE;
BEGIN
  IF (TG_OP = 'INSERT') THEN
       SELECT MAX(CODTAB) INTO wk_ultimo_codigo FROM TD_COB;
  -- Cria um novo indice se preciso
  INSERT INTO TD_IND (CODTAB)
  SELECT wk_ultimo_codigo+1
    FROM DUAL
   WHERE wk_ultimo_codigo+1 not in (SELECT CODTAB FROM TD_IND);

     INSERT INTO TD_COB
             (CODTAB, COBATI, DESCOB, LARUNI, FILCTA, SEQCTA, TIPCTA, TIPCOB, GERTIT, TIPCTB)
      VALUES (wk_ultimo_codigo+1, 'T', NEW.NOMAGE, 1, NEW.FILCTA, NEW.SEQCTA, NEW.TIPCTA, 'B', 'F', 'T');
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3448 --*/
CREATE TRIGGER TGCTB2
AFTER INSERT OR UPDATE ON TT_CTB 
FOR EACH ROW EXECUTE PROCEDURE TGCTB2();

/*-- SEQ 3449 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCTB3() CASCADE;

/*-- SEQ 3450 --*/
CREATE OR REPLACE FUNCTION TGCTB3() RETURNS TRIGGER AS $$
-- 1) Excluir tabelas-pai se possivel
BEGIN
    DELETE FROM TT_CTA
     WHERE CODFIL = OLD.FILCTA
       AND SEQUEN = OLD.SEQCTA
       AND TIPCTA = OLD.TIPCTA;
--    DELETE FROM TD_BCO
--     WHERE CBANCO = OLD.CODBCO;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3451 --*/
CREATE TRIGGER TGCTB3
AFTER DELETE ON TT_CTB 
FOR EACH ROW EXECUTE PROCEDURE TGCTB3();

/*-- SEQ 3452 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCTB4() CASCADE;

/*-- SEQ 3453 --*/
CREATE OR REPLACE FUNCTION TGCTB4() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   IF (TG_OP = 'UPDATE') THEN
      IF (Equal(OLD.CODBCO,NEW.CODBCO) = 0) OR
         (Equal(OLD.NUMAGE,NEW.NUMAGE) = 0) OR
         (Equal(OLD.DIGAGE,NEW.DIGAGE) = 0) OR
         (Equal(OLD.CTACRR,NEW.CTACRR) = 0) OR
         (Equal(OLD.DIGCRR,NEW.DIGCRR) = 0) THEN
         cRetorno := AtualizaData('CONFIGURACAO',Agora());
      END IF;
   ELSE
      cRetorno := AtualizaData('CONFIGURACAO',Agora());
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3454 --*/
CREATE TRIGGER TGCTB4
AFTER INSERT OR DELETE OR UPDATE ON TT_CTB 
FOR EACH ROW EXECUTE PROCEDURE TGCTB4();


/*-- SEQ 3455 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCTBXCCB() CASCADE;

/*-- SEQ 3456 --*/
CREATE OR REPLACE FUNCTION TGCTBXCCB() RETURNS TRIGGER AS $$
DECLARE
-- Tabela Conta Bancaria X Carteira
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Atualiza DATINC
-- 3) Atualiza ATU_EM
-- 4) Impedir exclusao
  
  vComplemento  VARCHAR(254) := constante('complemento'); 
  QuemLogou TRetQuemLogou%ROWTYPE;

-- Principal
BEGIN
--  IF (TG_OP = 'DELETE') THEN
--     RAISE EXCEPTION 'PG-20001 Nao e permitida a exclusao. %' , vComplemento;     
--  END IF;

  IF (TG_OP = 'INSERT') THEN
     IF NEW.SEQUEN IS NULL THEN
        NEW.SEQUEN := ProximoCodigo('TT_CTBXCCB', NEW.CODFIL);
     END IF;
     select * into QuemLogou from DadosLogon();
     NEW.DATINC := agora();
  END IF;

  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     NEW.ATU_EM := agora();
  END IF;  

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3457 --*/
CREATE TRIGGER TGCTBXCCB
BEFORE INSERT OR DELETE OR UPDATE ON TT_CTBXCCB 
FOR EACH ROW EXECUTE PROCEDURE TGCTBXCCB();

/*-- SEQ 3458 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCTBXCCB2() CASCADE;

/*-- SEQ 3459 --*/
CREATE OR REPLACE FUNCTION TGCTBXCCB2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configuração
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3460 --*/
CREATE TRIGGER TGCTBXCCB2
AFTER INSERT OR DELETE OR UPDATE ON TT_CTBXCCB 
FOR EACH ROW EXECUTE PROCEDURE TGCTBXCCB2();


/*-- SEQ 3461 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCTF() CASCADE;

/*-- SEQ 3462 --*/
CREATE OR REPLACE FUNCTION TGCTF() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Gerar um cdigo sequencial exclusivo para compor a chave primria.
-- 2. Atualiza controles de data.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF COALESCE(NEW.ID_CTF,0)=0 THEN
         SELECT NEXTVAL('SQCTF') INTO NEW.ID_CTF FROM DUAL;
      END IF;
      NEW.DATINC := Agora();
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3463 --*/
CREATE TRIGGER TGCTF
BEFORE INSERT OR UPDATE OR DELETE ON TT_CTF 
FOR EACH ROW EXECUTE PROCEDURE TGCTF();


/*-- SEQ 3464 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCTT1() CASCADE;

/*-- SEQ 3465 --*/
CREATE OR REPLACE FUNCTION TGCTT1() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Tratar campos automaticos na inclusao
-- 2) Impedir Exclusao
-- 3) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 4) Lancar no VLOG TL_CTT
-- 5) Ha tratamentos especificos da Telefonica. Revisao Futura
DECLARE
  vComplemento constant VARCHAR(100) := constante('complemento');
    wk_filcli       TT_CCC.FILCLI%TYPE;
    wk_codcli       TT_CCC.CODCLI%TYPE;
    wk_vlrlan       TT_CCC.VLRLAN%TYPE;
    wk_cc_workflow  TT_CFG.CC_WORKFLOW%TYPE;
    wk_qtdlan       TT_CCC.QTDLAN%TYPE;
    wk_filial       TT_CCC.FILUSU%TYPE;
    wk_usuario      TT_CCC.CODUSU%TYPE;
    wk_comple       TT_CCC.COMPLE%TYPE;
    wk_reg_filcli   TT_REG.FILCLI%TYPE;
    wk_reg_codcli   TT_REG.CODCLI%TYPE;
--    wk_reg_numser   TT_REG.NUMSER%TYPE;
    wk_hom_deshom   TD_HOM.DESHOM%TYPE;
    wk_nome_cliente TT_CCC.COMPLE%TYPE;
    dPREFAT         Timestamp;
    nCODCOB         TT_LIM.CODCOB%TYPE;
	nAntecipacao    Numeric(1,0);

  QuemLogou TRetQuemLogou%ROWTYPE;

-- Principal
BEGIN
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'DELETE') THEN
     RAISE EXCEPTION 'PG-20039 Nao e possivel excluir um contrato existente.%' , vComplemento;
  ELSIF (TG_OP = 'INSERT') THEN
    NEW.DATCAD := agora();
    -- Dados do usuario
    select * into QuemLogou from DadosLogon();
    IF QuemLogou.Encontrou THEN
      NEW.FILUSU := QuemLogou.FILUSU;
      NEW.CODUSU := QuemLogou.CODUSU;
    ELSE
      RAISE EXCEPTION 'PG-20037 Voce nao e um usuario cadastrado no sistema.%' , vComplemento;
    END IF;

    IF NEW.SEQUEN IS NULL THEN
    NEW.SEQUEN:=ProximoCodigo('TT_CTT',NEW.CODFIL);
    END IF;

    IF (isnull(NEW.CONTRA)='T') THEN
       NEW.CONTRA := NEW.CODFIL||LPAD(LTRIM(NEW.SEQUEN),10,'0');
    END IF;

    NEW.DATFAT := null;
  /*    NEW.DATFIM := add_months(NEW.DATINI,12);  Esta coluna e especifica para controle atual da Telefonica */

    IF (NEW.PRIVEN is null) THEN
       NEW.PRIVEN := NEW.DATINI;
    END IF;

    IF (NEW.FLGEST = 'C') THEN
       RAISE EXCEPTION 'PG-20041 Nao e possivel incluir contratos cancelados.%' , vComplemento;
    END IF;

  ELSIF (TG_OP = 'UPDATE') THEN
     IF Equal(NEW.DATCAD,OLD.DATCAD) <> 1 THEN
        RAISE EXCEPTION 'PG-20038 Dados nao podem ser alterados: Numero Contrato.%' , vComplemento;
     END IF;

     -- Se ja foi faturado, nao permite mudancas em algumas colunas
     IF (OLD.DATFAT is not null) THEN
        IF Equal(NEW.DATINI,OLD.DATINI) <> 1
        OR Equal(NEW.DATFIM,OLD.DATFIM) <> 1
        OR Equal(NEW.CARENC,OLD.CARENC) <> 1
        OR Equal(NEW.PRIVEN,OLD.PRIVEN) <> 1 THEN
           RAISE EXCEPTION 'PG-20040 Nao e possivel alterar contratos faturados.%' , vComplemento;
        END IF;
     END IF;

    -- Dados do usuario
    select * into QuemLogou from DadosLogon();
    IF QuemLogou.Encontrou THEN
      NEW.FILUSU := QuemLogou.FILUSU;
      NEW.CODUSU := QuemLogou.CODUSU;
    ELSE
      RAISE EXCEPTION 'PG-20037 Voce nao e um usuario cadastrado no sistema.%' , vComplemento;
    END IF;

    -- PRE FATURAMENTO DE CONTRATO
    IF  (NEW.FLGEST IN ('X','0','1','2','3','4','5','6','7','8','9','10','11','12'))
    AND (Equal(NEW.FLGEST, OLD.FLGEST) <> 1) THEN

	    IF NEW.FLGEST = 'X' THEN
		   NEW.FLGEST := '0';
		END IF;

		nAntecipacao := To_Number(NEW.FLGEST);
		NEW.FLGEST  := OLD.FLGEST;

        SELECT CC_WORKFLOW INTO wk_cc_workflow FROM TT_CFG;

        IF COALESCE(NEW.QTDLAN,0) = 0 THEN
            wk_qtdlan := 1;
        ELSIF NEW.PARTOT = COALESCE(NEW.PARFAT,0) + 1 THEN
            wk_qtdlan := COALESCE(NEW.QTDLAN,0) - COALESCE(NEW.QTDFAT,0);
        ELSE
            wk_qtdlan := TRUNC(COALESCE(NEW.QTDLAN,0)/NVLZ(NEW.PARTOT,1));
        END IF;

        NEW.QTDFAT := wk_qtdlan;
        NEW.DATFAT := add_months(agora(),nAntecipacao);
        NEW.PARFAT := COALESCE(NEW.PARFAT,0) + 1;
        wk_vlrlan   := NEW.VLRMES * NEW.PERIOD * -1;
        select * into QuemLogou from DadosLogon();
        wk_filial   := QuemLogou.FILUSU;
        wk_usuario  := QuemLogou.CODUSU;

        -- Relacionado com cfg para sempre trazer no minimo uma linha
        SELECT TD_HOM.DESHOM, TT_CLI.FILCLI, TT_CLI.CODCLI,
               COALESCE(TRIM(TT_CLI.ULTNOM),TRIM(TT_CLI.NOMCLI)) AS NOME
          INTO wk_hom_deshom, wk_reg_filcli, wk_reg_codcli, wk_nome_cliente
          FROM TT_CFG CFG LEFT OUTER JOIN TT_CLI ON TT_CLI.FILCLI=NEW.FILEMP AND TT_CLI.CODCLI=NEW.CODEMP
                          LEFT OUTER JOIN TD_HOM ON TD_HOM.CODHOM=NEW.CODHOM;

        SELECT MAX(case when Aux_ProximaData(DIASEM,DIAMES,add_months(trunc(agora()),1),nAntecipacao) > agora() then
                             Aux_ProximaData(DIASEM,DIAMES,add_months(add_day(trunc(agora()),CASE WHEN DIAMES>0 THEN -30 ELSE -7 END),nAntecipacao),1)
                        else Aux_ProximaData(DIASEM,DIAMES,add_months(trunc(agora()),nAntecipacao),1)
                   end) INTO dPREFAT
          FROM (SELECT DIASEM,
                       CASE WHEN DIAMES IS NOT NULL THEN DIAMES
                            WHEN DIASEM IS NOT NULL THEN DIAMES
                            ELSE TO_NUMBER(TO_CHAR(agora(),'DD'))
                       END AS DIAMES,
                       CODCCC
                 FROM TT_DXC
                WHERE FILCLI=wk_reg_filcli
                  AND CODCLI=wk_reg_codcli
                  AND CODCCC=COALESCE( NEW.TIPCCC, wk_cc_workflow )
                ) INT;

        IF dPREFAT IS NULL THEN
           dPREFAT := add_months(TRUNC(AGORA()),nAntecipacao);
        END IF;

        IF NEW.TIPCTT = 'M' then
            wk_comple := 'Manuteno ' ;
        ELSIF NEW.TIPCTT = 'L' then
            wk_comple := 'Locao ' ;
        ELSE
            wk_comple := '';
        END IF;

        IF (wk_reg_filcli IS NOT NULL) AND (wk_reg_codcli IS NOT NULL) THEN
           IF  (wk_reg_filcli = NEW.FILCLI AND wk_reg_codcli = NEW.CODCLI) THEN
              --O contrato  diretamente com o cliente
              wk_comple := wk_comple || wk_hom_deshom;
           ELSE
              IF (COALESCE(NEW.COMISS,0) > 0) THEN
                 -- portador
                 BEGIN
                    SELECT COALESCE(LXF.CODCOB,LIM.CODCOB) INTO nCODCOB
                      FROM TT_LIM LIM LEFT JOIN TT_LIMXFIL LXF ON LIM.FILCLI=LXF.FILCLI
                                                              AND LIM.CODCLI=LXF.CODCLI
                                                              AND LIM.TIPCCC=LXF.TIPCCC
                                                              AND LXF.CODFIL = NEW.CODFIL
                     WHERE LIM.FILCLI = NEW.filcli
                       AND LIM.CODCLI = NEW.codcli
                       AND LIM.TIPCCC = COALESCE( NEW.TIPCCC, wk_cc_workflow );
                 EXCEPTION
                                      
                   WHEN others THEN NULL;
                                    END;
                  -- Credita comisso
                 INSERT INTO TT_CCC (CODFIL, FILCLI, CODCLI, DATOPE, NUMDOC, FILUSU, CODUSU, VLRLAN,
                                     TIPCCC, COMPLE,PORORI, TIPLAN)
                      VALUES (NEW.CODFIL,NEW.filcli,NEW.codcli,
                              ADD_DAY(dPREFAT,-1),
                              'COMISSO',
                              wk_filial,wk_usuario,NEW.COMISS, COALESCE( NEW.TIPCCC, wk_cc_workflow ),
                              'Comisso de ' || COALESCE(wk_comple,'') || COALESCE(wk_nome_cliente,''),COALESCE(nCODCOB,0),'J');
                    -- O contrato  diretamente com o cliente
                 wk_comple := wk_comple || wk_hom_deshom ||' cliente '|| wk_nome_cliente;
              ELSE
                 --O contrato foi firmado com a revenda
                 wk_comple := wk_comple || wk_hom_deshom ||' cliente '|| wk_nome_cliente;
                 wk_reg_filcli := NEW.FILCLI;
                 wk_reg_codcli := NEW.CODCLI;
              END IF;
           END IF;
        ELSE
           wk_reg_filcli := NEW.FILCLI;
           wk_reg_codcli := NEW.CODCLI;
        END IF;

        -- portador
        BEGIN
           SELECT COALESCE(LXF.CODCOB,LIM.CODCOB) INTO nCODCOB
             FROM TT_LIM LIM LEFT JOIN TT_LIMXFIL LXF ON LIM.FILCLI=LXF.FILCLI
                                                     AND LIM.CODCLI=LXF.CODCLI
                                                     AND LIM.TIPCCC=LXF.TIPCCC
                                                     AND LXF.CODFIL = NEW.CODFIL
            WHERE LIM.FILCLI = wk_reg_filcli
              AND LIM.CODCLI = wk_reg_codcli
              AND LIM.TIPCCC = COALESCE( NEW.TIPCCC, wk_cc_workflow );
        EXCEPTION
                      
           WHEN others THEN NULL;
                   END;
        INSERT INTO TT_CCC (CODFIL, FILCLI, CODCLI, DATOPE, NUMDOC, FILUSU, CODUSU, VLRLAN,
                            TIPCCC, FILMAT, CODMAT, CODCOR, CODTAM, COMPLE, QTDLAN, CONTRA, PORORI, TIPLAN)
                    VALUES (NEW.CODFIL,wk_reg_filcli,wk_reg_codcli,
                            ADD_DAY(dPREFAT,-1),
                            COALESCE(NEW.FILREG||NEW.SEQREG,'SEM REGISTRO'),
                            wk_filial,wk_usuario,wk_vlrlan, COALESCE( NEW.TIPCCC, wk_cc_workflow ),NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,
                            wk_comple,wk_qtdlan,NEW.CONTRA,COALESCE(nCODCOB,0),'A');
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3466 --*/
CREATE TRIGGER TGCTT1
BEFORE INSERT OR DELETE OR UPDATE ON TT_CTT 
FOR EACH ROW EXECUTE PROCEDURE TGCTT1();

/*-- SEQ 3467 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCTT2() CASCADE;

/*-- SEQ 3468 --*/
CREATE OR REPLACE FUNCTION TGCTT2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Registrar mudana dos dados num "vlog"
--
DECLARE
  VLOG VARCHAR(500)     := '';
  Nulo CONSTANT CHAR(1) := '0';
  CRLF CONSTANT CHAR(1) := CHR(10);
  wk_Old_Refpro TT_GRA.REFPRO%TYPE;
  wk_New_Refpro TT_GRA.REFPRO%TYPE;
BEGIN
  IF (TG_OP = 'INSERT') THEN
    VLOG := 'Inclusao';
    INSERT INTO TL_CTT (CODFIL,SEQUEN,MSGLOG)
           VALUES (NEW.CODFIL,NEW.SEQUEN,vlog);

  ELSIF (TG_OP = 'UPDATE') THEN
     -- Registra no VLOG quem autoriza a mudanca

     IF Equal(OLD.FILMAT,NEW.FILMAT) <> 1
     OR Equal(OLD.CODMAT,NEW.CODMAT) <> 1
     OR Equal(OLD.CODCOR,NEW.CODCOR) <> 1
     OR Equal(OLD.CODTAM,NEW.CODTAM) <> 1 THEN

        SELECT REFPRO INTO wk_Old_Refpro
        FROM TT_GRA
        WHERE FILMAT = OLD.FILMAT
          AND CODMAT = OLD.CODMAT
          AND CODCOR = OLD.CODCOR
          AND CODTAM = OLD.CODTAM;

        SELECT REFPRO INTO wk_New_Refpro
        FROM TT_GRA
        WHERE FILMAT = NEW.FILMAT
          AND CODMAT = NEW.CODMAT
          AND CODCOR = NEW.CODCOR
          AND CODTAM = NEW.CODTAM;

         VLOG := VLOG||'Produto: de '||COALESCE(wk_Old_Refpro,Nulo)||' para '||COALESCE(wk_New_Refpro,Nulo)||CRLF;
     END IF;

     IF Equal(OLD.FILUSU,NEW.FILUSU) <> 1
     OR Equal(OLD.CODUSU,NEW.CODUSU) <> 1 THEN
        VLOG := VLOG||'Autorizado por: '||COALESCE(NEW.FILUSU,Nulo)||'-'||COALESCE(NEW.CODUSU,Nulo)||CRLF;
     END IF;
     IF Equal(OLD.FILCLI,NEW.FILCLI) <> 1
     OR Equal(OLD.CODCLI,NEW.CODCLI) <> 1 THEN
         VLOG := VLOG||'Cliente: de '||COALESCE(OLD.FILCLI,Nulo)||'/'||COALESCE(OLD.CODCLI,Nulo)||' para '||COALESCE(NEW.FILCLI,Nulo)||'/'||COALESCE(NEW.CODCLI,Nulo)||CRLF;
     END IF;
     IF Equal(OLD.FILREG,NEW.FILREG) <> 1
     OR Equal(OLD.SEQREG,NEW.SEQREG) <> 1 THEN
         VLOG := VLOG||'Num.Registro: de '||COALESCE(OLD.FILREG,Nulo)||'/'||COALESCE(OLD.SEQREG,Nulo)||' para '||COALESCE(NEW.FILREG,Nulo)||'/'||COALESCE(NEW.SEQREG,Nulo)||CRLF;
     END IF;
     IF Equal(OLD.CONTRA,NEW.CONTRA) <> 1 THEN
         VLOG := VLOG||'Numero: de '||COALESCE(OLD.CONTRA,Nulo)||' para '||COALESCE(NEW.CONTRA,Nulo)||CRLF;
     END IF;
     IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
         VLOG := VLOG||'Status: de '||COALESCE(OLD.FLGEST,Nulo)||' para '||COALESCE(NEW.FLGEST,Nulo)||CRLF;
     END IF;
     IF Equal(OLD.CARENC,NEW.CARENC) <> 1 THEN
         VLOG := VLOG||'Carencia: de '||TO_CHAR(COALESCE(OLD.CARENC,0))||' para '||TO_CHAR(COALESCE(NEW.CARENC,0))||CRLF;
     END IF;
     IF Equal(OLD.PRIVEN,NEW.PRIVEN) <> 1 THEN
         VLOG := VLOG||'Primeiro vencimento: de '||COALESCE(OLD.PRIVEN,Nulo)||' para '||COALESCE(NEW.PRIVEN,Nulo)||CRLF;
     END IF;
     IF Equal(OLD.TIPCTT,NEW.TIPCTT) <> 1 THEN
         VLOG := VLOG||'Tipo: de '||COALESCE(OLD.TIPCTT,Nulo)||' para '||COALESCE(NEW.TIPCTT,Nulo)||CRLF;
     END IF;
     IF Equal(OLD.DATINI,NEW.DATINI) <> 1 THEN
         VLOG := VLOG||'Inicio Vigencia: de '||COALESCE(TO_CHAR(OLD.DATINI,'DD/MM/YYYY'),Nulo)||' para '||COALESCE(TO_CHAR(NEW.DATINI,'DD/MM/YYYY'),Nulo)||CRLF;
     END IF;
     IF Equal(OLD.DATFIM,NEW.DATFIM) <> 1 THEN
         VLOG := VLOG||'Fim Vigencia: de '||COALESCE(TO_CHAR(OLD.DATFIM,'DD/MM/YYYY'),Nulo)||' para '||COALESCE(TO_CHAR(NEW.DATFIM,'DD/MM/YYYY'),Nulo)||CRLF;
     END IF;
     IF Equal(OLD.DATFAT,NEW.DATFAT) <> 1 THEN
         VLOG := VLOG||'Faturamento: de '||COALESCE(TO_CHAR(OLD.DATFAT,'DD/MM/YYYY'),Nulo)||' para '||COALESCE(TO_CHAR(NEW.DATFAT,'DD/MM/YYYY'),Nulo)||CRLF;
     END IF;
     IF Equal(OLD.VLRMES,NEW.VLRMES) <> 1 THEN
         VLOG := VLOG||'Valor Mensal: de '||TO_CHAR(COALESCE(OLD.VLRMES,0),'fm9G999G990D00')||' para '||TO_CHAR(COALESCE(NEW.VLRMES,0),'fm9G999G990D00')||CRLF;
     END IF;
     IF Equal(OLD.COMISS,NEW.COMISS) <> 1 THEN
         VLOG := VLOG||'Comisso: de '||TO_CHAR(COALESCE(OLD.COMISS,0),'fm9G999G990D00')||' para '||TO_CHAR(COALESCE(NEW.COMISS,0),'fm9G999G990D00')||CRLF;
     END IF;
     IF Equal(OLD.PERIOD,NEW.PERIOD) <> 1 THEN
         VLOG := VLOG||'Cobranca: de '||TO_CHAR(COALESCE(OLD.PERIOD,0))||' para '||TO_CHAR(COALESCE(NEW.PERIOD,0))||CRLF;
     END IF;
     IF Equal(OLD.PARTOT,NEW.PARTOT) <> 1 THEN
         VLOG := VLOG||'Quantidade de parcelas: de '||TO_CHAR(COALESCE(OLD.PARTOT,0))||' para '||TO_CHAR(COALESCE(NEW.PARTOT,0))||CRLF;
     END IF;
     IF Equal(OLD.PARFAT,NEW.PARFAT) <> 1 THEN
         VLOG := VLOG||'Parcelas faturadas: de '||TO_CHAR(COALESCE(OLD.PARFAT,0))||' para '||TO_CHAR(COALESCE(NEW.PARFAT,0))||CRLF;
     END IF;
     IF Equal(OLD.QTDFAT,NEW.QTDFAT) <> 1 THEN
         VLOG := VLOG||'Quantidade faturada: de '||TO_CHAR(COALESCE(OLD.QTDFAT,0))||' para '||TO_CHAR(COALESCE(NEW.QTDFAT,0))||CRLF;
     END IF;
     IF Equal(OLD.QTDLAN,NEW.QTDLAN) <> 1 THEN
         VLOG := VLOG||'Quantidade lancada no item: de '||TO_CHAR(COALESCE(OLD.QTDLAN,0))||' para '||TO_CHAR(COALESCE(NEW.QTDLAN,0))||CRLF;
     END IF;
     IF Equal(OLD.ULTREA,NEW.ULTREA) <> 1 THEN
         VLOG := VLOG||'Ultimo reajuste: de '||to_char(OLD.ULTREA,'DD/MM/YYYY')||' para '||TO_CHAR(NEW.ULTREA,'DD/MM/YYYY')||CRLF;
     END IF;
     IF ISNOTNULL(VLOG)='T' THEN
        INSERT INTO TL_CTT (CODFIL,SEQUEN,MSGLOG)
               VALUES (NEW.CODFIL,NEW.SEQUEN,vlog);

     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3469 --*/
CREATE TRIGGER TGCTT2
AFTER INSERT OR UPDATE ON TT_CTT 
FOR EACH ROW EXECUTE PROCEDURE TGCTT2();


/*-- SEQ 3470 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCUP() CASCADE;

/*-- SEQ 3471 --*/
CREATE OR REPLACE FUNCTION TGCUP() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Controlar Datas e Sequenciadores

   cComplemento                  CONSTANT VARCHAR(254) := Constante('complemento');

-- Principal
BEGIN
  -- Gera codigo sequencial exclusivo
  IF (TG_OP = 'INSERT') THEN
    NEW.SEQUEN := ProximoCodigo('TT_CUP',NEW.CODFIL);
    NEW.DATINC := agora();
  END IF; 

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;
   
   -- Impede alterao/excluses
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20001 No  possvel excluir um cupom de desconto. Desative-o.. %' , cComplemento;
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3472 --*/
CREATE TRIGGER TGCUP
BEFORE INSERT OR UPDATE OR DELETE ON TT_CUP 
FOR EACH ROW EXECUTE PROCEDURE TGCUP();


/*-- SEQ 3473 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCUP2() CASCADE;

/*-- SEQ 3474 --*/
CREATE OR REPLACE FUNCTION TGCUP2() RETURNS TRIGGER AS $$
DECLARE

  -- Objetivos
  -- 1) Registrar Log de alteraes
  -- Principal
  cLOG                          VARCHAR(4000)     := '';
  cNulo                         CONSTANT CHAR(4)   := 'Nulo';
  iNulo                         CONSTANT Numeric(1) := 0;
  CRLF                          CONSTANT CHAR(1)   := CHR(10);
  wk_coduid                     TT_UID.CODUID%TYPE;
  vComplemento                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');
  
    
    QuemLogou                     TRetQuemLogou%ROWTYPE;
  BEGIN
   IF (TG_OP = 'UPDATE') THEN
      -- MN - No permite atualizar numero do cupom na campanha
      IF Equal(OLD.NUMERO,NEW.NUMERO) <> 1 THEN
         RAISE EXCEPTION 'PG-20001 No  permitido alterar o nmero do cupom. %' , vComplemento;
      END IF;

      IF Equal(OLD.TIPCOD,NEW.TIPCOD) <> 1 THEN
         cLOG := cLOG||'Tipo de Cdigo Impresso : '||COALESCE(OLD.TIPCOD, cNulo)||' para '||COALESCE(NEW.TIPCOD, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DESCRI,NEW.DESCRI) <> 1 THEN
         cLOG := cLOG||'Descrio: de '||COALESCE(OLD.DESCRI,cNulo)||' para '||COALESCE(NEW.DESCRI,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CUPATI,NEW.CUPATI) <> 1 THEN
         cLOG := cLOG||'Ativo?: de '||COALESCE(OLD.CUPATI,cNulo)||' para '||COALESCE(NEW.CUPATI,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DATINI, NEW.DATINI) <> 1 THEN
        cLOG := cLOG||'Data Incio: de '||COALESCE(TO_CHAR(OLD.DATINI,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINI,'DD/MM/YYYY'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DATFIM, NEW.DATFIM) <> 1 THEN
        cLOG := cLOG||'Data Final: de '||COALESCE(TO_CHAR(OLD.DATFIM,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATFIM,'DD/MM/YYYY'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.USOMAX,NEW.USOMAX) <> 1 THEN
         cLOG := cLOG||'Nmero mximo de uso: de '||COALESCE(TO_CHAR(OLD.USOMAX),cNulo)||' para '||COALESCE(TO_CHAR(NEW.USOMAX),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.USOCLI,NEW.USOCLI) <> 1 THEN
         cLOG := cLOG||'Nmero mximo de uso por cliente: de '||COALESCE(TO_CHAR(OLD.USOCLI),cNulo)||' para '||COALESCE(TO_CHAR(NEW.USOCLI),cNulo)||CRLF;
      END IF;

      WK_CODUID := GetCoduidAtual();

      -- MN - Grava Log
      IF ISNOTNULL(cLOG) = 'T' THEN
         cLOG := 'Cupom de Desconto >> '||cLOG||CRLF;
         
         select * into QuemLogou from DadosLogon();
         INSERT INTO TL_CUP (FILCUP,SEQCUP,FILUSU,CODUSU,DATOPE,MSGLOG,CODUID)
                     VALUES (NEW.CODFIL,NEW.SEQUEN,QuemLogou.FILUSU,QuemLogou.CODUSU,agora(),cLOG,WK_CODUID);
      END IF;
   END IF; -- Fim IF do (TG_OP = 'UPDATE')
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3475 --*/
CREATE TRIGGER TGCUP2
AFTER INSERT OR DELETE OR UPDATE ON TT_CUP 
FOR EACH ROW EXECUTE PROCEDURE TGCUP2();


/*-- SEQ 3476 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCUPXUSO() CASCADE;

/*-- SEQ 3477 --*/
CREATE OR REPLACE FUNCTION TGCUPXUSO() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Controlar Datas e Sequenciadores

-- Principal
BEGIN
  -- Gera codigo sequencial exclusivo
  IF NEW.SEQUEN IS NULL THEN
    NEW.SEQUEN := ProximoCodigo('TT_CUPXUSO',NEW.FILCUP);
    NEW.DATINC := agora();
  END IF; 

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3478 --*/
CREATE TRIGGER TGCUPXUSO
BEFORE INSERT OR UPDATE ON TT_CUPXUSO 
FOR EACH ROW EXECUTE PROCEDURE TGCUPXUSO();

/*-- SEQ 3479 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCUPXUSO2() CASCADE;

/*-- SEQ 3480 --*/
CREATE OR REPLACE FUNCTION TGCUPXUSO2() RETURNS TRIGGER AS $$
DECLARE

  -- Objetivos
  -- 1) Registrar Log de alteraes
  -- Principal
  cLOG                          VARCHAR(4000)     := '';
  cNulo                         CONSTANT CHAR(4)   := 'Nulo';
  iNulo                         CONSTANT Numeric(1) := 0;
  CRLF                          CONSTANT CHAR(1)   := CHR(10);
  wk_coduid                     TT_UID.CODUID%TYPE;
  
    
    QuemLogou                     TRetQuemLogou%ROWTYPE;
  BEGIN
   IF (TG_OP = 'UPDATE') THEN
     IF Equal(OLD.FILCLI,NEW.FILCLI) <> 1 THEN
       cLOG := cLOG||'Filial do Cliente : '||COALESCE(OLD.FILCLI, cNulo)||' para '||COALESCE(NEW.FILCLI, cNulo)||CRLF;
     END IF;
     IF Equal(OLD.CODCLI,NEW.CODCLI) <> 1 THEN
         cLOG := cLOG||'Cdigo do Cliente: de '||COALESCE(OLD.CODCLI,cNulo)||' para '||COALESCE(NEW.CODCLI,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.FILVEN,NEW.FILVEN) <> 1 THEN
       cLOG := cLOG||'Filial da Venda: '||COALESCE(OLD.FILVEN, cNulo)||' para '||COALESCE(NEW.FILVEN, cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SEQVEN,NEW.SEQVEN) <> 1 THEN
         cLOG := cLOG||'Sequenciador da venda: de '||COALESCE(OLD.SEQVEN,cNulo)||' para '||COALESCE(NEW.SEQVEN,cNulo)||CRLF;
     END IF;

    WK_CODUID := GetCoduidAtual();

    -- MN - Grava Log
    IF ISNOTNULL(cLOG) = 'T' THEN
         cLOG := 'Uso do Cupom de Desconto >> '||cLOG||CRLF;
         
         select * into QuemLogou from DadosLogon();
         INSERT INTO TL_CUP (FILCUP,SEQCUP,FILUSU,CODUSU,DATOPE,MSGLOG,CODUID)
                     VALUES (NEW.FILCUP,NEW.SEQCUP,QuemLogou.FILUSU,QuemLogou.CODUSU,agora(),cLOG,WK_CODUID);
    END IF;
  END IF; -- Fim IF do (TG_OP = 'UPDATE')
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3481 --*/
CREATE TRIGGER TGCUPXUSO2
AFTER INSERT OR DELETE OR UPDATE ON TT_CUPXUSO 
FOR EACH ROW EXECUTE PROCEDURE TGCUPXUSO2();


/*-- SEQ 3482 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCXG() CASCADE;

/*-- SEQ 3483 --*/
CREATE OR REPLACE FUNCTION TGCXG() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
--

-- Principal
BEGIN
  -- Gera codigo sequencial
  IF (TG_OP = 'INSERT') THEN
    IF (NEW.SEQUEN IS NULL) THEN
      NEW.SEQUEN:=ProximoCodigo('TT_CXG',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3484 --*/
CREATE TRIGGER TGCXG
BEFORE INSERT ON TT_CXG 
FOR EACH ROW EXECUTE PROCEDURE TGCXG();


/*-- SEQ 3485 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCXN() CASCADE;

/*-- SEQ 3486 --*/
CREATE OR REPLACE FUNCTION TGCXN() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Gerar um cdigo sequencial exclusivo para compor a chave primria.
-- 2. Atualiza data de incluso

-- Declarao de variveis e cursores

-- Principal
BEGIN

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.CODTAB IS NULL THEN
         NEW.CODTAB := ProximoCodigo('TT_CESXNCM',NULL);
      END IF;
      NEW.DATINC := Agora();
   END IF;

    IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3487 --*/
CREATE TRIGGER TGCXN
BEFORE INSERT ON TT_CESXNCM 
FOR EACH ROW EXECUTE PROCEDURE TGCXN();


/*-- SEQ 3488 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDAMP1() CASCADE;

/*-- SEQ 3489 --*/
CREATE OR REPLACE FUNCTION TGDAMP1() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1)impedir que se deixe nula a cor e divisao em td_amp
  -- Atualizar TD_IND
  TD_IND_OK VARCHAR(2);
BEGIN
  IF (TG_OP = 'UPDATE') THEN 
    IF (OLD.CORAMP IS NOT NULL) AND 
       (NEW.CORAMP IS NULL) THEN
       RAISE EXCEPTION 'PG-20000 Nao e permitida a alteracao da cor de ampliacao para nulo.';
    END IF;
    IF (OLD.DIVAMP IS NOT NULL) AND 
       (NEW.DIVAMP IS NULL) THEN
        RAISE EXCEPTION 'PG-20000 Nao e permitida a alteracao da divisao de ampliacao para nulo.';
    END IF;
  END IF;
  IF (TG_OP = 'INSERT') THEN
    TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3490 --*/
CREATE TRIGGER TGDAMP1
BEFORE UPDATE OR INSERT ON TD_AMP 
FOR EACH ROW EXECUTE PROCEDURE TGDAMP1();

/*-- SEQ 3491 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDAMP2() CASCADE;

/*-- SEQ 3492 --*/
CREATE OR REPLACE FUNCTION TGDAMP2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Popular a grade e divisao de acordo com a td_amp
BEGIN

UPDATE TT_CFG SET PATIPOREF=3;

UPDATE TD_AMP SET CORAMP = NEXTVAL('sqdamp') WHERE CORAMP IS NULL;

UPDATE TD_AMP
SET DIVTMP = TO_NUMBER(ProximoCodigo('TT_DIV','001'))
WHERE DIVAMP IS NULL;
 
 INSERT INTO TT_DIV (CODITE, CODDIV, NOMITE, ORDDIV, NOMEXT)
(SELECT AMP.DIVTMP, CFG.PaDivAmpliacao, AMP.PHOCOM, AMP.CODTAB, AMP.PHOCOM
 FROM TD_AMP AMP, TT_CFG CFG
 WHERE AMP.DIVAMP IS NULL);

INSERT INTO TT_GRA
(FILMAT, CODMAT, CODCOR, CODTAM, UNIDAD, UNIFOR, VALCON)
(SELECT INT.*, 0, 0, 1
 FROM (SELECT CFG.PAPHOFILAMPLIA AS FILMAT,
       CFG.PAPHOCODAMPLIA AS CODMAT,
       AMP.DIVTMP     AS CODCOR,
       SUB.CODITE     AS CODTAM
    FROM TT_PRO PRO, TT_CFG CFG, TD_AMP AMP, TD_GRA GRA, TT_SUB SUB
    WHERE PRO.FILMAT = CFG.PAPHOFILAMPLIA
     AND PRO.CODMAT = CFG.PAPHOCODAMPLIA
     AND GRA.CODTAB = PRO.CODGRA
     AND SUB.CODSUB = GRA.CODSUB
     AND AMP.DIVAMP IS NULL
    UNION ALL
    SELECT CFG.PAPHOFILREVELA AS FILMAT,
       CFG.PAPHOCODREVELA AS CODMAT,
       DIV.CODITE     AS CODCOR,
       SUB.CODITE     AS CODTAM
    FROM TT_PRO PRO, TT_CFG CFG, TT_DIV DIV, TD_GRA GRA, TT_SUB SUB
    WHERE PRO.FILMAT = CFG.PAPHOFILREVELA
     AND PRO.CODMAT = CFG.PAPHOCODREVELA
     AND GRA.CODTAB = PRO.CODGRA
     AND SUB.CODSUB = GRA.CODSUB
     AND DIV.CODDIV = GRA.CODDIV
    UNION ALL
    SELECT CFG.PAPHOFILREVAMP AS FILMAT,
       CFG.PAPHOCODREVAMP AS CODMAT,
       AMP.DIVTMP     AS CODCOR,
       SUB.CODITE     AS CODTAM
    FROM TT_PRO PRO, TT_CFG CFG, TD_AMP AMP, TD_GRA GRA, TT_SUB SUB
    WHERE PRO.FILMAT = CFG.PAPHOFILREVAMP
     AND PRO.CODMAT = CFG.PAPHOCODREVAMP
     AND GRA.CODTAB = PRO.CODGRA
     AND SUB.CODSUB = GRA.CODSUB
     AND AMP.DIVAMP IS NULL) INT LEFT OUTER JOIN TT_GRA GRA ON INT.FILMAT = GRA.FILMAT 
                                                           AND INT.CODMAT = GRA.CODMAT
                                                           AND INT.CODCOR = GRA.CODCOR
                                                           AND INT.CODTAM = GRA.CODTAM
 WHERE GRA.FILMAT IS NULL) ;

UPDATE TD_AMP
SET DIVAMP = DIVTMP
WHERE DIVAMP IS NULL;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3493 --*/
CREATE TRIGGER TGDAMP2
AFTER INSERT ON TD_AMP 
FOR STATEMENT EXECUTE PROCEDURE TGDAMP2();


/*-- SEQ 3494 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDBCO() CASCADE;

/*-- SEQ 3495 --*/
CREATE OR REPLACE FUNCTION TGDBCO() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3496 --*/
CREATE TRIGGER TGDBCO
AFTER INSERT OR UPDATE OR DELETE ON TD_BCO 
FOR EACH ROW EXECUTE PROCEDURE TGDBCO();


/*-- SEQ 3497 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDBIC() CASCADE;

/*-- SEQ 3498 --*/
CREATE OR REPLACE FUNCTION TGDBIC() RETURNS TRIGGER AS $$
DECLARE
  cRet VARCHAR(2);
  --LEO 84337
  vCODUID_ATUAL VARCHAR(22);
  vBLQ_SEM_UID  TT_CFG.BLQ_SEM_UID%TYPE;
  vSESSIONID    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');
  
BEGIN
  IF (TG_OP = 'DELETE') THEN
     cRet := LogExclusao((TG_OP = 'DELETE'), 'TD_BIC', OLD.filbic || to_char(OLD.codbom), to_char(OLD.seqbom));
  END IF;
  IF (TG_OP = 'INSERT') THEN
     --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
     cRet := LogExclusao((TG_OP = 'DELETE'), 'TD_BIC', NEW.filbic || to_char(NEW.codbom), to_char(NEW.seqbom));
  END IF;

  IF NOT (TG_OP = 'DELETE') THEN
     NEW.ATU_EM := AGORA();
  END IF; 

  IF (TG_OP = 'DELETE') THEN
    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
  END IF;  
  
  IF (TG_OP = 'INSERT') THEN
  
    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF; 
  
    -- Douglas - 83441 
    NEW.CODUID := GetCoduidAtual();	     
    NEW.ASSINA := COALESCE(AssinaTabela('TD_BIC', 
	                                    ConcatenaDBIC(NEW.SEQBOM,
                                                      NEW.SEQFIL,
                                                      NEW.CODTAB),
                                                   null, null, null),NEW.ASSINA);
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF ConcatenaDBIC(NEW.CODTAB,NEW.SEQFIL, NEW.SEQBOM) <>
	     ConcatenaDBIC(OLD.CODTAB,OLD.SEQFIL, OLD.SEQBOM) THEN
		 
		 -- LEO 84337
         SELECT BLQ_SEM_UID
           INTO vBLQ_SEM_UID
           FROM TT_CFG;
         vCODUID_ATUAL := GetCoduidAtual();
         IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF; 
		 
	     -- Douglas - 83441 
         NEW.CODUID := GetCoduidAtual();	     
         NEW.ASSINA := COALESCE(AssinaTabela('TD_BIC', 
 	                                         ConcatenaDBIC(NEW.SEQBOM,
                                                           NEW.SEQFIL,
                                                           NEW.CODTAB),
                                                       OLD.CODUID, 
	                                         ConcatenaDBIC(OLD.SEQBOM,
                                                           OLD.SEQFIL,
                                                           OLD.CODTAB),
                                                      OLD.ASSINA
                                                     ),NEW.ASSINA);
	  END IF; 											
   END IF;    
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3499 --*/
CREATE TRIGGER TGDBIC
BEFORE INSERT OR UPDATE OR DELETE ON TD_BIC 
FOR EACH ROW EXECUTE PROCEDURE TGDBIC();

/*-- SEQ 3500 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDBIC_ASS() CASCADE;

/*-- SEQ 3501 --*/
CREATE OR REPLACE FUNCTION TGDBIC_ASS() RETURNS TRIGGER AS $$
-- 83073
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN

  IF ExisteFilialNaUF('SC') THEN 
     IF (TG_OP = 'INSERT') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG + 1
        WHERE NOMTAB = 'TD_BIC';
     END IF;  
     
     IF (TG_OP = 'DELETE') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG - 1
        WHERE NOMTAB = 'TD_BIC';
     END IF;  
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3502 --*/
CREATE TRIGGER TGDBIC_ASS
AFTER INSERT OR DELETE ON TD_BIC 
FOR EACH ROW EXECUTE PROCEDURE TGDBIC_ASS();


/*-- SEQ 3503 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDBOM() CASCADE;

/*-- SEQ 3504 --*/
CREATE OR REPLACE FUNCTION TGDBOM() RETURNS TRIGGER AS $$
-- 83073
DECLARE
  --LEO 84337
  vCODUID_ATUAL VARCHAR(22);
  vBLQ_SEM_UID  TT_CFG.BLQ_SEM_UID%TYPE;
  vSESSIONID    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

BEGIN 

  IF (TG_OP = 'DELETE') THEN
    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
  END IF;
  
  IF (TG_OP = 'INSERT') THEN
  
    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
  
    -- Douglas - 83441 
    NEW.CODUID := GetCoduidAtual();	     
    NEW.ASSINA := COALESCE(AssinaTabela('TD_BOM', 
	                                    ConcatenaDBOM(NEW.CODTAB,
                                                      NEW.NUMBOM),
                                                   null, null, null),NEW.ASSINA);
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF ConcatenaDBOM(NEW.CODTAB,NEW.NUMBOM) <>
	     ConcatenaDBOM(OLD.CODTAB,OLD.NUMBOM) THEN
		 
		 -- LEO 84337
         SELECT BLQ_SEM_UID
           INTO vBLQ_SEM_UID
           FROM TT_CFG;
         vCODUID_ATUAL := GetCoduidAtual();
         IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;
		 
	     -- Douglas - 83441 
         NEW.CODUID := GetCoduidAtual();	     
         NEW.ASSINA := COALESCE(AssinaTabela('TD_BOM', 
 	                                         ConcatenaDBOM(NEW.CODTAB,
                                                           NEW.NUMBOM),
                                                       OLD.CODUID, 
	                                         ConcatenaDBOM(OLD.CODTAB,
                                                           OLD.NUMBOM),
                                                      OLD.ASSINA
                                                     ),NEW.ASSINA);
      END IF;												  
   END IF; 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3505 --*/
CREATE TRIGGER TGDBOM
BEFORE INSERT OR UPDATE OR DELETE ON TD_BOM 
FOR EACH ROW EXECUTE PROCEDURE TGDBOM();

/*-- SEQ 3506 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDBOM_ASS() CASCADE;

/*-- SEQ 3507 --*/
CREATE OR REPLACE FUNCTION TGDBOM_ASS() RETURNS TRIGGER AS $$
-- 83073
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN

  IF ExisteFilialNaUF('SC') THEN 
     IF (TG_OP = 'INSERT') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG + 1
	    WHERE NOMTAB = 'TD_BOM';
     END IF;  
     
     IF (TG_OP = 'DELETE') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG - 1
        WHERE NOMTAB = 'TD_BOM';
     END IF;  
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3508 --*/
CREATE TRIGGER TGDBOM_ASS
AFTER INSERT OR DELETE ON TD_BOM 
FOR EACH ROW EXECUTE PROCEDURE TGDBOM_ASS();


/*-- SEQ 3509 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCAI() CASCADE;

/*-- SEQ 3510 --*/
CREATE OR REPLACE FUNCTION TGDCAI() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir delete ou update do CODTAB = 0
-- 2) Gerar conta do plano de contas automaticamente
-- 3) Atualizar TD_IND
DECLARE
   vcomplemento                  VARCHAR(254) := Constante('complemento');
   TD_IND_OK                     VARCHAR(2);
BEGIN
   -- Impede exclusoes
   IF (TG_OP = 'DELETE') OR (TG_OP = 'UPDATE') THEN
      IF (TG_OP = 'DELETE') THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido. %' , vComplemento;
      ELSIF ((TG_OP = 'UPDATE') AND NEW.CODTAB <> 0 AND OLD.CODTAB = 0) THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser modificado. %' , vComplemento;
      END IF;
   END IF;

   -- Gera uma conta no plano de contas
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQCAI IS NULL THEN
         NEW.SEQCAI := ProximaConta(NEW.FILCAI,'' || COALESCE(NEW.CX_DES,  ''), 
                                     NEW.TIPCAI, NEW.CTACAI, '');
      END IF;

      TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );

   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3511 --*/
CREATE TRIGGER TGDCAI
BEFORE DELETE OR INSERT OR UPDATE ON TD_CAI 
FOR EACH ROW EXECUTE PROCEDURE TGDCAI();

/*-- SEQ 3512 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCAI2() CASCADE;

/*-- SEQ 3513 --*/
CREATE OR REPLACE FUNCTION TGDCAI2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3514 --*/
CREATE TRIGGER TGDCAI2
AFTER INSERT OR UPDATE OR DELETE ON TD_CAI 
FOR EACH ROW EXECUTE PROCEDURE TGDCAI2();


/*-- SEQ 3515 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCAR1() CASCADE;

/*-- SEQ 3516 --*/
CREATE OR REPLACE FUNCTION TGDCAR1() RETURNS TRIGGER AS $$
-- Objetivo:
-- Manter um limite de itens
DECLARE
   vLimite                       CONSTANT Numeric := Constante('limite');
   vQtd                          Numeric;
BEGIN
   SELECT COUNT(*) INTO vQtd FROM TD_CAR;
   IF vQtd > vLimite then
      RAISE EXCEPTION 'PG-20007 Quantidade de registros atingida. Nao pode haver mais inclusoes';
   END IF;    
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3517 --*/
CREATE TRIGGER TGDCAR1
BEFORE INSERT ON TD_CAR 
FOR STATEMENT EXECUTE PROCEDURE TGDCAR1();

/*-- SEQ 3518 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCAR2() CASCADE;

/*-- SEQ 3519 --*/
CREATE OR REPLACE FUNCTION TGDCAR2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir delete ou update do CODTAB = 0
-- 2) Incluir uma conta automaticamente
-- 3) Atualizar TD_IND
DECLARE
   wk_filial                     CHAR(3);
   TD_IND_OK                     VARCHAR(2);
BEGIN

   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20001 Registro de uso interno. Nao pode ser excluido';
   END IF;

   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1 THEN -- RFMP 68895
         RAISE EXCEPTION 'PG-20005 No  permitido alterar a chave primria da tabela';
      END IF;
      IF NEW.CODTAB <> 0 and OLD.CODTAB = 0 THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser modificado';
      END IF; 
   END IF;

   -- Gera item de cobranca
   IF (TG_OP = 'INSERT') THEN
      IF (NEW.PORCAR IS NULL) THEN
         NEW.PORCAR := ProximaCobranca('CARTAO - '||NEW.DESOUT,'C');
      END IF;
      IF (NEW.FILCAR IS NULL) THEN
         SELECT CODLOJ INTO WK_FILIAL FROM TT_IDF;
         NEW.FILCAR := wk_filial;
      END IF;
      IF (NEW.SEQCAR IS NULL) THEN
         NEW.TIPCAR := 'G';
         NEW.SEQCAR := ProximaConta(NEW.FILCAR,'Taxa adm. cartao '||TRIM(NEW.DESOUT),NEW.TIPCAR,NEW.CTACAR,'');
      END IF;
      TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
      NEW.DATINC := AGORA();
   END IF;
   IF NOT (TG_OP = 'DELETE') THEN
      NEW.ATU_EM := AGORA();
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3520 --*/
CREATE TRIGGER TGDCAR2
BEFORE INSERT OR DELETE OR UPDATE ON TD_CAR 
FOR EACH ROW EXECUTE PROCEDURE TGDCAR2();

/*-- SEQ 3521 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCAR3() CASCADE;

/*-- SEQ 3522 --*/
CREATE OR REPLACE FUNCTION TGDCAR3() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3523 --*/
CREATE TRIGGER TGDCAR3
AFTER INSERT OR UPDATE OR DELETE ON TD_CAR 
FOR EACH ROW EXECUTE PROCEDURE TGDCAR3();

/*-- SEQ 3524 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCAR_DW() CASCADE;

/*-- SEQ 3525 --*/
CREATE OR REPLACE FUNCTION TGDCAR_DW() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar log para views/tabelas materializadas
-- 2) Alterar diretamente a descrio da cobrana na view materializada
DECLARE
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');
BEGIN
   -- (TG_OP = 'INSERT'): no faz nada porque ainda no est em nenhuma venda
   -- (TG_OP = 'DELETE'): impedido por trigger
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1 THEN -- PK
         RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
      END IF;
      IF Equal(OLD.DESOUT,NEW.DESOUT) <> 1 THEN
         UPDATE DW_Vendas_Meio
            SET MEIO        = InitCap(NEW.DESOUT)
          WHERE DCAR_CODTAB = OLD.CODTAB;
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3526 --*/
CREATE TRIGGER TGDCAR_DW
AFTER UPDATE ON TD_CAR 
FOR EACH ROW EXECUTE PROCEDURE TGDCAR_DW();


/*-- SEQ 3527 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCCC() CASCADE;

/*-- SEQ 3528 --*/
CREATE OR REPLACE FUNCTION TGDCCC() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar conta do plano de contas automaticamente
-- 2) Atualizar TD_IND
DECLARE
   TD_IND_OK                     VARCHAR(2);
-- Principal
BEGIN
   -- Gera uma conta do plano de contas
   IF ((TG_OP = 'INSERT')) AND (NEW.SEQCCC IS NULL) THEN
      NEW.SEQCCC := ProximaConta(NEW.FILCCC,'CONTA CORRENTE'||' - '||NEW.DESCCC,NEW.TIPCCC,NEW.CTACCC,'');
   END IF;
   IF (TG_OP = 'INSERT') THEN
      TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
      NEW.DATINC := AGORA();
   END IF;
   IF NOT (TG_OP = 'DELETE') THEN
      NEW.ATU_EM := AGORA();
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1 THEN -- RFMP 68895
         RAISE EXCEPTION 'PG-20005 No  permitido alterar a chave primria da tabela';
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3529 --*/
CREATE TRIGGER TGDCCC
BEFORE INSERT ON TD_CCC 
FOR EACH ROW EXECUTE PROCEDURE TGDCCC();

/*-- SEQ 3530 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCCC2() CASCADE;

/*-- SEQ 3531 --*/
CREATE OR REPLACE FUNCTION TGDCCC2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3532 --*/
CREATE TRIGGER TGDCCC2
AFTER INSERT OR UPDATE OR DELETE ON TD_CCC 
FOR EACH ROW EXECUTE PROCEDURE TGDCCC2();

/*-- SEQ 3533 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCCC_DW() CASCADE;

/*-- SEQ 3534 --*/
CREATE OR REPLACE FUNCTION TGDCCC_DW() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Vendas_Meio
DECLARE
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');
BEGIN
   -- (TG_OP = 'INSERT'): no faz nada porque ainda no est em nenhuma venda
   -- (TG_OP = 'DELETE'): impedido por trigger
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1 THEN -- PK
         RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
      END IF;
      IF Equal(OLD.DESCCC,NEW.DESCCC) <> 1 THEN
         UPDATE DW_Vendas_Meio
            SET MEIO        = InitCap(NEW.DESCCC)
          WHERE DCCC_CODTAB = OLD.CODTAB;
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3535 --*/
CREATE TRIGGER TGDCCC_DW
AFTER UPDATE ON TD_CCC 
FOR EACH ROW EXECUTE PROCEDURE TGDCCC_DW();


/*-- SEQ 3536 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCFP() CASCADE;

/*-- SEQ 3537 --*/
CREATE OR REPLACE FUNCTION TGDCFP() RETURNS TRIGGER AS $$
DECLARE
  -- Objetivo:
  -- Atualizar TD_IND
  TD_IND_OK VARCHAR(2);
BEGIN
   IF (TG_OP = 'INSERT') THEN
     TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3538 --*/
CREATE TRIGGER TGDCFP
BEFORE INSERT ON TD_CFP 
FOR EACH ROW EXECUTE PROCEDURE TGDCFP();



/*-- SEQ 3539 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCL12() CASCADE;

/*-- SEQ 3540 --*/
CREATE OR REPLACE FUNCTION TGDCL12() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir delete ou update do CODTAB = 0
-- 2) Atualizar TD_IND
DECLARE
   cRet                          VARCHAR(2);
   TD_IND_OK                     VARCHAR(2);
BEGIN
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido!';
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF (NEW.CODTAB <> 0) AND (OLD.CODTAB = 0) THEN
            RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser modificado!';
      END IF;
      UPDATE TT_PRO SET ATU_EM = AGORA() WHERE CLASS1 = NEW.CODTAB;
   END IF;
   IF (TG_OP = 'INSERT') THEN
      TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3541 --*/
CREATE TRIGGER TGDCL12
BEFORE INSERT OR UPDATE OR DELETE ON TD_CL1 
FOR EACH ROW EXECUTE PROCEDURE TGDCL12();

/*-- SEQ 3542 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCL13() CASCADE;

/*-- SEQ 3543 --*/
CREATE OR REPLACE FUNCTION TGDCL13() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualizar tabela TT_PROxNOM
-- 2) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
   -- Principal
BEGIN
   --Atualiza TT_PROxNOM
   --davi - 21/11/06 - 41296
   IF ((TG_OP = 'UPDATE')) THEN
      IF (Equal(OLD.CLASS1,NEW.CLASS1) = 0) THEN
         
         cRetorno := PC_PROxNOM_Atualiza('IPR.CLASS1 = '||NEW.CODTAB, null, null, null, null );
                        END IF;
   END IF;
   
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
   
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3544 --*/
CREATE TRIGGER TGDCL13
AFTER INSERT OR UPDATE OR DELETE ON TD_CL1 
FOR EACH ROW EXECUTE PROCEDURE TGDCL13();


/*-- SEQ 3545 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCL1_DW() CASCADE;

/*-- SEQ 3546 --*/
CREATE OR REPLACE FUNCTION TGDCL1_DW() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Produto
-- 2) Gerar log para view/tabela materializadas DW_Vendas_Grupos
DECLARE
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');
BEGIN
   -- (TG_OP = 'INSERT'): No faz nada porque ainda no est relacionado a nenhum produto
   -- (TG_OP = 'DELETE'): Garantido pela FK
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1 THEN -- PK
         RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
      END IF;
      IF Equal(OLD.CLASS1,NEW.CLASS1) <> 1 THEN
         UPDATE DW_Produto
            SET Classe1     = InitCap(NEW.CLASS1)
          WHERE Cod_Classe1 = OLD.CODTAB;
         UPDATE DW_Vendas_Grupos
            SET Classe1     = InitCap(NEW.CLASS1)
          WHERE Cod_Classe1 = OLD.CODTAB;
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3547 --*/
CREATE TRIGGER TGDCL1_DW
AFTER UPDATE ON TD_CL1 
FOR EACH ROW EXECUTE PROCEDURE TGDCL1_DW();



/*-- SEQ 3548 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCL22() CASCADE;

/*-- SEQ 3549 --*/
CREATE OR REPLACE FUNCTION TGDCL22() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir delete ou update do CODTAB = 0
-- 2) Atualizar TD_IND
DECLARE
   cRet                          VARCHAR(2);  
   TD_IND_OK                     VARCHAR(2);
BEGIN
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido!';
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF (NEW.CODTAB <> 0) AND (OLD.CODTAB = 0) THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser modificado!';
      END IF;
      UPDATE TT_PRO SET ATU_EM = AGORA() WHERE CLASS2 = NEW.CODTAB;
   END IF;
   IF (TG_OP = 'INSERT') THEN
      TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3550 --*/
CREATE TRIGGER TGDCL22
BEFORE INSERT OR UPDATE OR DELETE ON TD_CL2 
FOR EACH ROW EXECUTE PROCEDURE TGDCL22();

/*-- SEQ 3551 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCL23() CASCADE;

/*-- SEQ 3552 --*/
CREATE OR REPLACE FUNCTION TGDCL23() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualizar tabela TT_PROxNOM
-- 2) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
   -- Principal
BEGIN
   --Atualiza TT_PROxNOM
   --davi - 21/11/06 - 41296
   IF ((TG_OP = 'UPDATE')) THEN
      IF (Equal(OLD.CLASS2,NEW.CLASS2) = 0) THEN
         
         cRetorno := PC_PROxNOM_Atualiza('IPR.CLASS2 = '||NEW.CODTAB, null, null, null, null );
                        END IF;
   END IF;
   
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
   
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3553 --*/
CREATE TRIGGER TGDCL23
AFTER INSERT OR UPDATE OR DELETE ON TD_CL2 
FOR EACH ROW EXECUTE PROCEDURE TGDCL23();


/*-- SEQ 3554 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCL2_DW() CASCADE;

/*-- SEQ 3555 --*/
CREATE OR REPLACE FUNCTION TGDCL2_DW() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Produto
-- 2) Gerar log para view/tabela materializadas DW_Vendas_Grupos
DECLARE
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');
BEGIN
   -- (TG_OP = 'INSERT'): No faz nada porque ainda no est relacionado a nenhum produto
   -- (TG_OP = 'DELETE'): Garantido pela FK
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1 THEN -- PK
         RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
      END IF;
      IF Equal(OLD.CLASS2,NEW.CLASS2) <> 1 THEN
         UPDATE DW_Produto
            SET Classe2     = InitCap(NEW.CLASS2)
          WHERE Cod_Classe2 = OLD.CODTAB;
         UPDATE DW_Vendas_Grupos
            SET Classe2     = InitCap(NEW.CLASS2)
          WHERE Cod_Classe2 = OLD.CODTAB;
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3556 --*/
CREATE TRIGGER TGDCL2_DW
AFTER UPDATE ON TD_CL2 
FOR EACH ROW EXECUTE PROCEDURE TGDCL2_DW();



/*-- SEQ 3557 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCL32() CASCADE;

/*-- SEQ 3558 --*/
CREATE OR REPLACE FUNCTION TGDCL32() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir delete ou update do CODTAB = 0
-- 2) Atualizar TD_IND
DECLARE
   TD_IND_OK                     VARCHAR(2);
BEGIN
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido!';
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF (NEW.CODTAB <> 0) AND (OLD.CODTAB = 0) THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser modificado!';
      END IF;
      UPDATE TT_PRO SET ATU_EM = AGORA() WHERE CLASS3 = NEW.CODTAB;
   END IF;
   IF (TG_OP = 'INSERT') THEN
      TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3559 --*/
CREATE TRIGGER TGDCL32
BEFORE INSERT OR UPDATE OR DELETE ON TD_CL3 
FOR EACH ROW EXECUTE PROCEDURE TGDCL32();

/*-- SEQ 3560 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCL33() CASCADE;

/*-- SEQ 3561 --*/
CREATE OR REPLACE FUNCTION TGDCL33() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualizar tabela TT_PROxNOM
-- 2) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
   -- Principal
BEGIN
   --Atualiza TT_PROxNOM
   --davi - 21/11/06 - 41296
   IF ((TG_OP = 'UPDATE')) THEN
      IF (Equal(OLD.CLASS3,NEW.CLASS3) = 0) THEN
         
         cRetorno := PC_PROxNOM_Atualiza('IPR.CLASS3 = '||NEW.CODTAB, null, null, null, null );
                        END IF;
   END IF;
   
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
   
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3562 --*/
CREATE TRIGGER TGDCL33
AFTER INSERT OR UPDATE OR DELETE ON TD_CL3 
FOR EACH ROW EXECUTE PROCEDURE TGDCL33();


/*-- SEQ 3563 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCL3_DW() CASCADE;

/*-- SEQ 3564 --*/
CREATE OR REPLACE FUNCTION TGDCL3_DW() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Produto
-- 2) Gerar log para view/tabela materializadas DW_Vendas_Grupos
DECLARE
   vComplemento  CONSTANT VARCHAR(100) := Constante('Complemento');
BEGIN
   -- (TG_OP = 'INSERT'): No faz nada porque ainda no est relacionado a nenhum produto
   -- (TG_OP = 'DELETE'): Garantido pela FK
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1 THEN -- PK
         RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
      END IF;
      IF Equal(OLD.CLASS3,NEW.CLASS3) <> 1 THEN
         UPDATE DW_Produto
            SET Classe3     = InitCap(NEW.CLASS3)
          WHERE Cod_Classe3 = OLD.CODTAB;
         UPDATE DW_Vendas_Grupos
            SET Classe3     = InitCap(NEW.CLASS3)
          WHERE Cod_Classe3 = OLD.CODTAB;
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3565 --*/
CREATE TRIGGER TGDCL3_DW
AFTER UPDATE ON TD_CL3 
FOR EACH ROW EXECUTE PROCEDURE TGDCL3_DW();



/*-- SEQ 3566 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCL42() CASCADE;

/*-- SEQ 3567 --*/
CREATE OR REPLACE FUNCTION TGDCL42() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir delete ou update do CODTAB = 0
-- 2) Atualizar TD_IND
DECLARE
   TD_IND_OK                     VARCHAR(2);
BEGIN
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido!';
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF (NEW.CODTAB <> 0) AND (OLD.CODTAB = 0) THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser modificado!';
      END IF;
      UPDATE TT_PRO SET ATU_EM = AGORA() WHERE CLASS4 = NEW.CODTAB;
   END IF;
   IF (TG_OP = 'INSERT') THEN
      TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3568 --*/
CREATE TRIGGER TGDCL42
BEFORE INSERT OR UPDATE OR DELETE ON TD_CL4 
FOR EACH ROW EXECUTE PROCEDURE TGDCL42();

/*-- SEQ 3569 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCL43() CASCADE;

/*-- SEQ 3570 --*/
CREATE OR REPLACE FUNCTION TGDCL43() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualizar tabela TT_PROxNOM
-- 2) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
   -- Principal
BEGIN
   --Atualiza TT_PROxNOM
   --davi - 21/11/06 - 41296
   IF ((TG_OP = 'UPDATE')) THEN
      IF (Equal(OLD.CLASS4,NEW.CLASS4) = 0) THEN
         
         cRetorno := PC_PROxNOM_Atualiza('IPR.CLASS4 = '||NEW.CODTAB, null, null, null, null );
                        END IF;
   END IF;
   
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
   
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3571 --*/
CREATE TRIGGER TGDCL43
AFTER INSERT OR UPDATE OR DELETE ON TD_CL4 
FOR EACH ROW EXECUTE PROCEDURE TGDCL43();


/*-- SEQ 3572 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCL4_DW() CASCADE;

/*-- SEQ 3573 --*/
CREATE OR REPLACE FUNCTION TGDCL4_DW() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Produto
-- 2) Gerar log para view/tabela materializadas DW_Vendas_Grupos
DECLARE
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');
BEGIN
   -- (TG_OP = 'INSERT'): No faz nada porque ainda no est relacionado a nenhum produto
   -- (TG_OP = 'DELETE'): Garantido pela FK
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1 THEN -- PK
         RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
      END IF;
      IF Equal(OLD.CLASS4,NEW.CLASS4) <> 1 THEN
         UPDATE DW_Produto
            SET Classe4     = InitCap(NEW.CLASS4)
          WHERE Cod_Classe4 = OLD.CODTAB;
         UPDATE DW_Vendas_Grupos
            SET Classe4     = InitCap(NEW.CLASS4)
          WHERE Cod_Classe4 = OLD.CODTAB;
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3574 --*/
CREATE TRIGGER TGDCL4_DW
AFTER UPDATE ON TD_CL4 
FOR EACH ROW EXECUTE PROCEDURE TGDCL4_DW();


/*-- SEQ 3575 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCOB1() CASCADE;

/*-- SEQ 3576 --*/
CREATE OR REPLACE FUNCTION TGDCOB1() RETURNS TRIGGER AS $$
-- Objetivo:
-- Manter um limite de itens
DECLARE
   vLimite                       CONSTANT Numeric := Constante('limite');
   vQtd                          Numeric;
   vComplemento                  CONSTANT VARCHAR(254):= Constante('complemento');

BEGIN
   -- MN - 105130 - Hoje existe essa validao de registros das TDs por limitao do checkout. Para tirar a limitao  necessrio tratar
   -- a TV_TAB para no enviar a TD_COB na tv_tab e enviar ela de modo separado, mas isso no  to simples. Desse modo, o Daniel disse para 
   -- tirar esse limite nesse momento, e com isso, se passar do limite e alguma TD_COB ativa no aparecer, o cliente deve tirar manualmente TD_COBs desativadas.
   SELECT COUNT(*) INTO vQtd FROM TD_COB;
   --IF (vQtd > vLimite) then
   --   RAISE EXCEPTION 'PG-20007 Quantidade de registros atingida. Nao pode haver mais inclusoes. %' , vComplemento;
   --END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3577 --*/
CREATE TRIGGER TGDCOB1
BEFORE INSERT ON TD_COB 
FOR STATEMENT EXECUTE PROCEDURE TGDCOB1();

/*-- SEQ 3578 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCOB2() CASCADE;

/*-- SEQ 3579 --*/
CREATE OR REPLACE FUNCTION TGDCOB2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir delete ou update do CODTAB = 0
-- 2) Incluir uma conta automaticamente
-- 3) Atualizar TD_IND
DECLARE
   TD_IND_OK                     VARCHAR(2);
   vComplemento                  CONSTANT VARCHAR(254):= Constante('complemento');

BEGIN
   IF NOT (TG_OP = 'DELETE') THEN
      IF (NEW.CODTAB < -1) THEN
         RAISE EXCEPTION 'PG-20006 Cdigos negativos no podem ser utilizados.%' , vComplemento;
      END IF;
      NEW.ATU_EM := AGORA();
   END IF;

   IF (TG_OP = 'DELETE') THEN
      IF (OLD.CODTAB in (-1,0)) THEN
         RAISE EXCEPTION 'PG-20007 Registro de uso interno. Nao pode ser excluido.%' , vComplemento;
      END IF;
   END IF;


   IF (TG_OP = 'UPDATE') THEN 
      IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1 THEN -- RFMP 68895
         RAISE EXCEPTION 'PG-20008 No  permitido alterar a chave primria da tabela. %' , vComplemento;
      END IF;
      IF (NEW.CODTAB <> 0 AND OLD.CODTAB = 0) 
      OR (NEW.CODTAB <> -1 AND OLD.CODTAB = -1) THEN
         RAISE EXCEPTION 'PG-20009 Registro de uso interno. Nao pode ser excluido.%' , vComplemento;
      END IF;
      UPDATE TD_ECF SET ATU_EM = AGORA() WHERE PORECF = NEW.CODTAB;
      IF OLD.CODTAB <> NEW.CODTAB THEN
         UPDATE TD_ECF SET ATU_EM = AGORA() WHERE PORECF = OLD.CODTAB;
      END IF;
   END IF;

   -- Gera uma conta no plano de contas
   IF (TG_OP = 'INSERT') THEN
      IF NEW.FILCTA IS NULL THEN
         SELECT FilialPadrao() INTO NEW.FILCTA from DUAL;
      END IF;
      
      IF NEW.TIPCTA IS NULL THEN 
         NEW.TIPCTA := 'N';
      END IF;

      IF NEW.TIPCOB IS NULL THEN 
         NEW.TIPCOB := 'P';
      END IF;

      IF NEW.SEQCTA IS NULL THEN
         NEW.SEQCTA := ProximaConta(NEW.FILCTA,'COBRANCA - '||COALESCE(NEW.DESCOB,''),NEW.TIPCTA,NEW.TIPCOB,'');
      END IF;

      TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3580 --*/
CREATE TRIGGER TGDCOB2
BEFORE INSERT OR DELETE OR UPDATE ON TD_COB 
FOR EACH ROW EXECUTE PROCEDURE TGDCOB2();

/*-- SEQ 3581 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCOB3() CASCADE;

/*-- SEQ 3582 --*/
CREATE OR REPLACE FUNCTION TGDCOB3() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3583 --*/
CREATE TRIGGER TGDCOB3
AFTER INSERT OR UPDATE OR DELETE ON TD_COB 
FOR EACH ROW EXECUTE PROCEDURE TGDCOB3();

/*-- SEQ 3584 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCOB_DW() CASCADE;

/*-- SEQ 3585 --*/
CREATE OR REPLACE FUNCTION TGDCOB_DW() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Vendas_Meio
DECLARE
   bProcessa                     BOOLEAN DEFAULT False;
      
   regDW                         RECORD;
      cDUMMY                        VARCHAR(2);
   vCODTAB                       TD_COB.CODTAB%TYPE;  
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');
BEGIN
  IF UsaVMDecisor() = 'T' THEN
     -- (TG_OP = 'INSERT'): no faz porque ainda no est em nenhuma venda
     -- (TG_OP = 'DELETE'): no faz para no violar FK
     IF (TG_OP = 'UPDATE') THEN
        IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1 THEN --PK
           RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
        END IF;
        IF Equal(OLD.TIPCOB,NEW.TIPCOB) <> 1 THEN
           -- processa s se alterar o tipo de cobrana que envolva "B"
           IF Equal(OLD.TIPCOB,'B') <> 1 
           OR Equal('B', NEW.TIPCOB) <> 1 THEN 
              bProcessa := True;
              vCODTAB   := NEW.CODTAB;
           END IF;
        END IF;
        -- altera diretamente a descrio de cobrana 
        IF Equal(OLD.DESCOB,NEW.DESCOB) <> 1 THEN
           UPDATE DW_Vendas_Meio
              SET MEIO        = InitCap(NEW.DESCOB)
            WHERE DCOB_CODTAB = OLD.CODTAB;
        END IF;    
     END IF;
     IF bProcessa THEN
        FOR regDW IN (SELECT DISTINCT DW.FILIAL, 
                                      DW.COD_UNIDADE,
                                      DW.ANO_MES
                        FROM DW_Vendas_Meio DW
                       WHERE DW.DCOB_CODTAB = vCODTAB)
        LOOP
           cDUMMY := Insere_DW_Log_Vendas_Meio(regDW.FILIAL, regDW.COD_UNIDADE, regDW.ANO_MES);
        END LOOP;    
     END IF;
  END IF; 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3586 --*/
CREATE TRIGGER TGDCOB_DW
AFTER UPDATE ON TD_COB 
FOR EACH ROW EXECUTE PROCEDURE TGDCOB_DW();


/*-- SEQ 3587 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCORVEI1() CASCADE;

/*-- SEQ 3588 --*/
CREATE OR REPLACE FUNCTION TGDCORVEI1() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impedir excluses.
-- 2. Impedir atualizaes de registros internos.
-- 3. Atualizar TD_CORVEI.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');
   cRet                          VARCHAR(2);

-- Principal
BEGIN
   -- Impedir excluses.
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20000 Registro de uso interno. No pode ser excludo. %' , COMPLEMENTO;
   END IF;

   -- Impedir atualizaes de registros internos.
   IF (TG_OP = 'UPDATE') THEN
      IF NEW.CODTAB <= 0 THEN
         RAISE EXCEPTION 'PG-20001 Registro de uso interno. No pode ser modificado. %' , COMPLEMENTO;
      END IF;
      NEW.ATU_EM := AGORA();
   END IF;

   -- Atualizar TD_IND.
   IF (TG_OP = 'INSERT') THEN
      cRet := Atualiza_TD_IND(NEW.CODTAB);
      NEW.DATINC := AGORA();
      NEW.ATU_EM := AGORA();
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3589 --*/
CREATE TRIGGER TGDCORVEI1
BEFORE DELETE OR INSERT OR UPDATE ON TD_CORVEI 
FOR EACH ROW EXECUTE PROCEDURE TGDCORVEI1();


/*-- SEQ 3590 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCRT() CASCADE;

/*-- SEQ 3591 --*/
CREATE OR REPLACE FUNCTION TGDCRT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Registrar na tabela do Totall BI (TT_LAY) uma linha em TT_LAY para cada registro de TD_CRT

-- Principal

vAUX VARCHAR(2);
vComplemento VARCHAR(100);
BEGIN

   vAUX:=CARGAPERSONALIZADO();
    
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3592 --*/
CREATE TRIGGER TGDCRT
AFTER INSERT OR UPDATE ON TD_CRT 
FOR STATEMENT EXECUTE PROCEDURE TGDCRT();

/*-- SEQ 3593 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCRT2() CASCADE;

/*-- SEQ 3594 --*/
CREATE OR REPLACE FUNCTION TGDCRT2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Salvar alteraes do registro na tabela de log TL_CRT

  vLOG  VARCHAR(4000)   := '';
  CRLF  CONSTANT CHAR(1) := CHR(10);
  NULO  CONSTANT CHAR(4) := 'Nulo';
  cOld	VARCHAR(255);
  cNew 	VARCHAR(255);
  vTab  CHAR(3); 
  wk_coduid tt_uid.coduid%type;

BEGIN
  -- Tratamento de vLOG
  IF (TG_OP = 'UPDATE') THEN
    IF Equal(OLD.CODDET,NEW.CODDET) <> 1 THEN
      SELECT COALESCE(TRIM(DESDET),Nulo) INTO cNew FROM TD_DET WHERE CODTAB = NEW.CODDET;
      SELECT COALESCE(TRIM(DESDET),Nulo) INTO cOld FROM TD_DET WHERE CODTAB = OLD.CODDET;
      vLOG := vLOG||'Detalhamento: de '||COALESCE(cOld,NULO)||' para '||COALESCE(cNew,NULO)||CRLF;
    END IF;

    IF Equal(OLD.USODET,NEW.USODET) <> 1 THEN
      select CASE OLD.USODET WHEN 'C' THEN 'Cliente'
                              WHEN 'P' THEN 'Produto'
                              WHEN 'E' THEN 'Endereo'
                              WHEN 'G' THEN 'Grade'
                                                  ELSE Nulo
      END into cOld from dual;
      select CASE NEW.USODET WHEN 'C' THEN 'Cliente'
                              WHEN 'P' THEN 'Produto'
                              WHEN 'E' THEN 'Endereo'
                              WHEN 'G' THEN 'Grade'
                                                  ELSE Nulo
      END into cNew from dual;    
      vLOG := vLOG||'Uso: de '||COALESCE(cOld,NULO)||' para '||COALESCE(cNew,NULO)||CRLF;
    END IF;

    IF Equal(OLD.TIPCRT,NEW.TIPCRT) <> 1 THEN
      select CASE OLD.TIPCRT WHEN 'C' THEN 'Combo'
                              WHEN 'D' THEN 'Data'
                              WHEN 'L' THEN 'Logico'
                              WHEN 'N' THEN 'Numero'
                              WHEN 'S' THEN 'String'
                                                  ELSE Nulo
      END into cOld from dual;
      select CASE NEW.TIPCRT WHEN 'C' THEN 'Combo'
                              WHEN 'D' THEN 'Data'
                              WHEN 'L' THEN 'Logico'
                              WHEN 'N' THEN 'Numero'
                              WHEN 'S' THEN 'String'
                                                  ELSE Nulo
      END into cNew from dual;    
      vLOG := vLOG||'Uso: de '||COALESCE(cOld,NULO)||' para '||COALESCE(cNew,NULO)||CRLF;
    END IF;

    IF Equal(OLD.NN_CRT,NEW.NN_CRT) <> 1 THEN
      select CASE OLD.NN_CRT WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'Nao'
                                                  ELSE Nulo
      END into cOld from dual;
      select CASE NEW.NN_CRT WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'Nao'
                                                  ELSE Nulo
      END into cNew from dual;
      vLOG := vLOG||'Obrigatorio: de '||COALESCE(cOld,NULO)||' para '||COALESCE(cNew,NULO)||CRLF;
    END IF;

    IF Equal(OLD.DESCRT,NEW.DESCRT) <> 1 THEN
      vLOG := vLOG||'Descricao: de '||COALESCE(OLD.DESCRT,NULO)||' para '||COALESCE(NEW.DESCRT,NULO)||CRLF;
    END IF;

    IF Equal(OLD.MINCRT,NEW.MINCRT) <> 1 THEN
      vLOG := vLOG||'Valor minimo: de '||COALESCE(OLD.MINCRT,NULO)||' para '||COALESCE(NEW.MINCRT,NULO)||CRLF;
    END IF;

    IF Equal(OLD.MAXCRT,NEW.MAXCRT) <> 1 THEN
      vLOG := vLOG||'Valor maximo: de '||COALESCE(OLD.MAXCRT,NULO)||' para '||COALESCE(NEW.MAXCRT,NULO)||CRLF;
    END IF;

    IF Equal(OLD.DECCRT,NEW.DECCRT) <> 1 THEN
      vLOG := vLOG||'Decimais: de '||COALESCE(TO_CHAR(OLD.DECCRT,'fm9999999990'),nulo)||' para '||COALESCE(TO_CHAR(NEW.DECCRT,'fm9999999990'),nulo)||CRLF;
    END IF;

    IF Equal(OLD.ORDCRT,NEW.ORDCRT) <> 1 THEN
      vLOG := vLOG||'Ordem: de '||COALESCE(TO_CHAR(OLD.ORDCRT,'fm9999999990'),nulo)||' para '||COALESCE(TO_CHAR(NEW.ORDCRT,'fm9999999990'),nulo)||CRLF;
    END IF;

    IF ISNOTNULL(vLOG) = 'T' THEN
      select CASE NEW.USODET WHEN 'C' THEN 'CLI'
                              WHEN 'P' THEN 'PRO'
                              WHEN 'E' THEN 'END'
                              WHEN 'G' THEN 'GRA'
                                                  ELSE Nulo
      END into vTab from dual;  
      
      vLOG := 'Caracterizacao:'||CRLF||vLOG;

      WK_CODUID := GetCoduidAtual();

      INSERT INTO TL_CRT (CODTAB,TABELA,MSGLOG,CODUID)
                  VALUES (NEW.CODTAB,vTab,vLOG,WK_CODUID);
    END IF;

  ELSIF (TG_OP = 'DELETE') THEN
    DELETE FROM TL_CRT WHERE CODTAB = OLD.CODTAB;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3595 --*/
CREATE TRIGGER TGDCRT2
BEFORE INSERT OR DELETE OR UPDATE ON TD_CRT 
FOR EACH ROW EXECUTE PROCEDURE TGDCRT2();


/*-- SEQ 3596 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCT1() CASCADE;

/*-- SEQ 3597 --*/
CREATE OR REPLACE FUNCTION TGDCT1() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Manter um limite de itens
DECLARE
   vQtd                          Numeric;
   vLimite                       CONSTANT Numeric := Constante('limite');
BEGIN
   SELECT COUNT(*) INTO vQtd FROM TD_CT1;
   IF (vQtd > vLimite) then
      RAISE EXCEPTION 'PG-20007 Quantidade de registros atingida. Nao pode haver mais inclusoes';
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3598 --*/
CREATE TRIGGER TGDCT1
BEFORE INSERT ON TD_CT1 
FOR STATEMENT EXECUTE PROCEDURE TGDCT1();

/*-- SEQ 3599 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCT12() CASCADE;

/*-- SEQ 3600 --*/
CREATE OR REPLACE FUNCTION TGDCT12() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualizar TD_IND
DECLARE
   TD_IND_OK                     VARCHAR(2);
BEGIN
   IF (TG_OP = 'INSERT') THEN
      TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3601 --*/
CREATE TRIGGER TGDCT12
BEFORE INSERT ON TD_CT1 
FOR EACH ROW EXECUTE PROCEDURE TGDCT12();

/*-- SEQ 3602 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCT13() CASCADE;

/*-- SEQ 3603 --*/
CREATE OR REPLACE FUNCTION TGDCT13() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3604 --*/
CREATE TRIGGER TGDCT13
AFTER INSERT OR UPDATE OR DELETE ON TD_CT1 
FOR EACH ROW EXECUTE PROCEDURE TGDCT13();

/*-- SEQ 3605 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCT1_DW() CASCADE;

/*-- SEQ 3606 --*/
CREATE OR REPLACE FUNCTION TGDCT1_DW() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Vendas_Cliente
DECLARE
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');
BEGIN
   -- (TG_OP = 'INSERT'): No faz nada porque no est relacionado a nenhum registro pai
   -- (TG_OP = 'DELETE'): Garantido pela FK
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1 THEN --PK
         RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
      END IF;
      IF Equal(OLD.NOMCT1,NEW.NOMCT1) <> 1 THEN
         UPDATE DW_Vendas_Cliente
            SET Categoria1  = InitCap(COALESCE(NEW.NOMCT1, CAST('No Informado' AS VARCHAR(40))))
          WHERE ct1_codtab  = OLD.CODTAB;
      END IF;
   END IF;      
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3607 --*/
CREATE TRIGGER TGDCT1_DW
AFTER UPDATE ON TD_CT1 
FOR EACH ROW EXECUTE PROCEDURE TGDCT1_DW();


/*-- SEQ 3608 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCT2() CASCADE;

/*-- SEQ 3609 --*/
CREATE OR REPLACE FUNCTION TGDCT2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualizar TD_IND
DECLARE
   TD_IND_OK                     VARCHAR(2);
BEGIN
   IF (TG_OP = 'INSERT') THEN
      TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3610 --*/
CREATE TRIGGER TGDCT2
BEFORE INSERT ON TD_CT2 
FOR EACH ROW EXECUTE PROCEDURE TGDCT2();

/*-- SEQ 3611 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCT22() CASCADE;

/*-- SEQ 3612 --*/
CREATE OR REPLACE FUNCTION TGDCT22() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3613 --*/
CREATE TRIGGER TGDCT22
AFTER INSERT OR UPDATE OR DELETE ON TD_CT2 
FOR EACH ROW EXECUTE PROCEDURE TGDCT22();

/*-- SEQ 3614 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCT2_DW() CASCADE;

/*-- SEQ 3615 --*/
CREATE OR REPLACE FUNCTION TGDCT2_DW() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Vendas_Cliente
DECLARE
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');
BEGIN
   -- (TG_OP = 'INSERT'): No faz nada porque no est relacionado a nenhum registro pai
   -- (TG_OP = 'DELETE'): Garantido pela FK
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1 THEN--PK
         RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
      END IF;
      IF Equal(OLD.NOMCT2,NEW.NOMCT2) <> 1 THEN
         UPDATE DW_Vendas_Cliente
            SET Categoria2  = InitCap(COALESCE(NEW.NOMCT2, CAST('No Informado' AS VARCHAR(40))))
          WHERE ct2_codtab  = OLD.CODTAB;
      END IF;
   END IF;      
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3616 --*/
CREATE TRIGGER TGDCT2_DW
AFTER UPDATE ON TD_CT2 
FOR EACH ROW EXECUTE PROCEDURE TGDCT2_DW();


/*-- SEQ 3617 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCT3() CASCADE;

/*-- SEQ 3618 --*/
CREATE OR REPLACE FUNCTION TGDCT3() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualizar TD_IND
DECLARE
   TD_IND_OK                     VARCHAR(2);
BEGIN
   IF (TG_OP = 'INSERT') THEN
      TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3619 --*/
CREATE TRIGGER TGDCT3
BEFORE INSERT ON TD_CT3 
FOR EACH ROW EXECUTE PROCEDURE TGDCT3();

/*-- SEQ 3620 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCT32() CASCADE;

/*-- SEQ 3621 --*/
CREATE OR REPLACE FUNCTION TGDCT32() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3622 --*/
CREATE TRIGGER TGDCT32
AFTER INSERT OR UPDATE OR DELETE ON TD_CT3 
FOR EACH ROW EXECUTE PROCEDURE TGDCT32();

/*-- SEQ 3623 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCT3_DW() CASCADE;

/*-- SEQ 3624 --*/
CREATE OR REPLACE FUNCTION TGDCT3_DW() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Vendas_Cliente
DECLARE
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');
BEGIN
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1 THEN --PK
         RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
      END IF;
      IF Equal(OLD.NOMCT3,NEW.NOMCT3) <> 1 THEN
         UPDATE DW_Vendas_Cliente
            SET Categoria3  = InitCap(COALESCE(NEW.NOMCT3, CAST('No Informado' AS VARCHAR(40))))
          WHERE ct3_codtab  = OLD.CODTAB;
      END IF;
   END IF;      
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3625 --*/
CREATE TRIGGER TGDCT3_DW
AFTER UPDATE ON TD_CT3 
FOR EACH ROW EXECUTE PROCEDURE TGDCT3_DW();


/*-- SEQ 3626 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCTA() CASCADE;

/*-- SEQ 3627 --*/
CREATE OR REPLACE FUNCTION TGDCTA() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) No permitir mudar a tabela 
-- Principal
  vComplemento CONSTANT VARCHAR(100) := constante('complemento');
BEGIN
  IF NOT (TG_OP = 'UPDATE') THEN 
      RAISE EXCEPTION 'PG-20027 Tabela de uso interno, no pode ser alterada.%' , vComplemento;
  END IF;
  
  IF (TG_OP = 'UPDATE') THEN
     IF (NEW.CODTAB <> OLD.CODTAB) OR
        (NEW.TIPCTA <> OLD.TIPCTA) OR 
        (NEW.DESCTA <> OLD.DESCTA) OR
        (NEW.CFGCOL <> OLD.CFGCOL) OR 
        (NEW.DUMMY  <> OLD.DUMMY)  OR
        (NEW.USOCTA <> OLD.USOCTA) THEN
       RAISE EXCEPTION 'PG-20027 Tabela de uso interno, no pode ser alterada.%' , vComplemento;
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3628 --*/
CREATE TRIGGER TGDCTA
BEFORE INSERT OR DELETE OR UPDATE ON TD_CTA 
FOR EACH ROW EXECUTE PROCEDURE TGDCTA();


/*-- SEQ 3629 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCTR() CASCADE;

/*-- SEQ 3630 --*/
CREATE OR REPLACE FUNCTION TGDCTR() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir delete ou update do CODTAB = 0
-- 2) Incluir uma conta automaticamente
-- PL/SQL Block
DECLARE
   bErro                         BOOLEAN;
-- Principal
BEGIN
   bErro := False;

   IF (TG_OP = 'DELETE') THEN
      IF OLD.CODTAB = 0 THEN
         bErro := True;
      END IF;
   ELSIF (TG_OP = 'UPDATE') THEN 
      IF (NEW.CODTAB <> 0 AND OLD.CODTAB = 0) THEN
         bErro := True;
      END IF;
   END IF;

   IF bErro THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
   END IF;

   -- Gera uma conta no plano de contas
   IF (TG_OP = 'INSERT') THEN
      IF NEW.CTRSEQ IS NULL THEN
         NEW.CTRSEQ := ProximaConta(NEW.CTRFIL,'RECEITA - '||NEW.DESCTR,NEW.CTRTIP,NEW.CTRUSO,'');
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3631 --*/
CREATE TRIGGER TGDCTR
BEFORE INSERT OR DELETE OR UPDATE ON TD_CTR 
FOR EACH ROW EXECUTE PROCEDURE TGDCTR();

/*-- SEQ 3632 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCTR2() CASCADE;

/*-- SEQ 3633 --*/
CREATE OR REPLACE FUNCTION TGDCTR2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3634 --*/
CREATE TRIGGER TGDCTR2
AFTER INSERT OR UPDATE OR DELETE ON TD_CTR 
FOR EACH ROW EXECUTE PROCEDURE TGDCTR2();

/*-- SEQ 3635 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCTR_DW() CASCADE;

/*-- SEQ 3636 --*/
CREATE OR REPLACE FUNCTION TGDCTR_DW() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar log para view/tabela materializadas DW_Vendas_Grupos
DECLARE
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');
BEGIN
   -- (TG_OP = 'INSERT'): No faz nada porque no est relacionado a nenhum registro pai
   -- (TG_OP = 'DELETE'): Garantido pela FK
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1 THEN -- PK
         RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
      END IF;
      IF Equal(OLD.DESCTR,NEW.DESCTR) <> 1 THEN
         UPDATE DW_Vendas_Grupos
            SET unidade = InitCap(NEW.DESCTR)
          WHERE unidade = InitCap(OLD.DESCTR); -- UQ
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3637 --*/
CREATE TRIGGER TGDCTR_DW
AFTER UPDATE ON TD_CTR 
FOR EACH ROW EXECUTE PROCEDURE TGDCTR_DW();


/*-- SEQ 3638 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCUS() CASCADE;

/*-- SEQ 3639 --*/
CREATE OR REPLACE FUNCTION TGDCUS() RETURNS TRIGGER AS $$
-- Objetivo:
-- Impedir delete ou update do CODTAB = 0
BEGIN
  IF (TG_OP = 'DELETE') then
    RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
  END IF;
  IF (TG_OP = 'UPDATE') THEN 
     IF NEW.CODTAB <> 0 and OLD.CODTAB = 0 THEN 
       RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3640 --*/
CREATE TRIGGER TGDCUS
BEFORE UPDATE OR DELETE ON TD_CUS 
FOR EACH ROW EXECUTE PROCEDURE TGDCUS();


/*-- SEQ 3641 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDCWS() CASCADE;

/*-- SEQ 3642 --*/
CREATE OR REPLACE FUNCTION TGDCWS() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao

-- Declarao de variveis e cursores
   cRetorno                      VARCHAR(2);

-- Principal
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3643 --*/
CREATE TRIGGER TGDCWS
AFTER INSERT OR UPDATE OR DELETE ON TD_CWS 
FOR EACH ROW EXECUTE PROCEDURE TGDCWS();



/*-- SEQ 3644 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDDEP2() CASCADE;

/*-- SEQ 3645 --*/
CREATE OR REPLACE FUNCTION TGDDEP2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir delete ou update do CODTAB = 0
BEGIN
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF NEW.CODTAB <> 0 and OLD.CODTAB = 0 THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
      END IF;
      UPDATE TT_PRO SET ATU_EM = AGORA() WHERE DEPART = NEW.CODTAB;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3646 --*/
CREATE TRIGGER TGDDEP2
BEFORE UPDATE OR DELETE ON TD_DEP 
FOR EACH ROW EXECUTE PROCEDURE TGDDEP2();

/*-- SEQ 3647 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDDEP3() CASCADE;

/*-- SEQ 3648 --*/
CREATE OR REPLACE FUNCTION TGDDEP3() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualizar tabela TT_PROxNOM
-- 2) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
   -- Principal
BEGIN
   --Atualiza TT_PROxNOM
   --davi - 21/11/06 - 41296
   IF ((TG_OP = 'UPDATE')) THEN
      IF (Equal(OLD.DESDEP,NEW.DESDEP) = 0) THEN
         
         cRetorno := PC_PROxNOM_Atualiza('IPR.DEPART = '||NEW.CODTAB, null, null, null, null );
                        END IF;
   END IF;
   
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
   
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3649 --*/
CREATE TRIGGER TGDDEP3
AFTER INSERT OR UPDATE OR DELETE ON TD_DEP 
FOR EACH ROW EXECUTE PROCEDURE TGDDEP3();


/*-- SEQ 3650 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDDEP_DW() CASCADE;

/*-- SEQ 3651 --*/
CREATE OR REPLACE FUNCTION TGDDEP_DW() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Produto
-- 2) Gerar log para view/tabela materializadas DW_Vendas_Grupos
DECLARE
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');
BEGIN
   -- (TG_OP = 'INSERT'): No faz nada porque ainda no est relacionado a nenhum produto
   -- (TG_OP = 'DELETE'): Garantido pela FK
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1 THEN -- PK
         RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
      END IF;
      IF Equal(OLD.DESDEP,NEW.DESDEP) <> 1 THEN
         UPDATE DW_Produto
            SET Departamento     = InitCap(NEW.DESDEP)
          WHERE Cod_Departamento = OLD.CODTAB;
         UPDATE DW_Vendas_Grupos
            SET Departamento     = InitCap(NEW.DESDEP)
          WHERE Cod_Departamento = OLD.CODTAB;
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3652 --*/
CREATE TRIGGER TGDDEP_DW
AFTER UPDATE ON TD_DEP 
FOR EACH ROW EXECUTE PROCEDURE TGDDEP_DW();


/*-- SEQ 3653 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDDEV() CASCADE;

/*-- SEQ 3654 --*/
CREATE OR REPLACE FUNCTION TGDDEV() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualizar TD_IND
DECLARE
   TD_IND_OK                     VARCHAR(2);
BEGIN
   IF (TG_OP = 'INSERT') THEN
      TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3655 --*/
CREATE TRIGGER TGDDEV
BEFORE INSERT ON TD_DEV 
FOR EACH ROW EXECUTE PROCEDURE TGDDEV();

/*-- SEQ 3656 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDDEV2() CASCADE;

/*-- SEQ 3657 --*/
CREATE OR REPLACE FUNCTION TGDDEV2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3658 --*/
CREATE TRIGGER TGDDEV2
AFTER INSERT OR UPDATE OR DELETE ON TD_DEV 
FOR EACH ROW EXECUTE PROCEDURE TGDDEV2();


/*-- SEQ 3659 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDDIV() CASCADE;

/*-- SEQ 3660 --*/
CREATE OR REPLACE FUNCTION TGDDIV() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir delete ou update do CODTAB = 0
DECLARE
   cMensagem                     CONSTANT CHAR(60) := 'Registro de uso interno. Nao pode ser excluido ou modificado';
BEGIN
   IF ((TG_OP = 'DELETE')) THEN
      RAISE EXCEPTION 'PG-20006 %' , cMensagem;      
   ELSIF ((TG_OP = 'UPDATE')) THEN
      IF (NEW.CODTAB <> 0 and OLD.CODTAB = 0) THEN
         RAISE EXCEPTION 'PG-20006 %' , cMensagem; 
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3661 --*/
CREATE TRIGGER TGDDIV
BEFORE UPDATE OR DELETE ON TD_DIV 
FOR EACH ROW EXECUTE PROCEDURE TGDDIV();

/*-- SEQ 3662 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDDIV2() CASCADE;

/*-- SEQ 3663 --*/
CREATE OR REPLACE FUNCTION TGDDIV2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_GRA
DECLARE
   cRetorno                      VARCHAR(2);
   cWhere                        TM_ATU.FILTRO%TYPE;
   nCODDIV                       TT_DIV.CODDIV%TYPE;
   nCODITE                       TT_DIV.CODITE%TYPE;
   
   crDivisao CURSOR(pCODDIV TT_DIV.CODDIV%TYPE) IS
        SELECT DIV.CODITE
          FROM TT_DIV DIV
         WHERE DIV.CODDIV = pCODDIV;
BEGIN
   --Tratamento para Atualizar Tabela Pai   
   IF (TG_OP = 'INSERT') THEN
      nCODDIV := NEW.CODTAB;
   ELSIF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1
      OR Equal(OLD.NOMDIV,NEW.NOMDIV) <> 1
      OR Equal(OLD.CODEXT,NEW.CODEXT) <> 1
      OR Equal(OLD.ORDDIV,NEW.ORDDIV) <> 1
      OR Equal(OLD.DIVATI,NEW.DIVATI) <> 1 THEN
         nCODDIV := NEW.CODTAB;
      ELSE
         nCODDIV := NULL;
      END IF;
   ELSIF (TG_OP = 'DELETE') THEN
      nCODDIV := OLD.CODTAB;
   END IF;
   IF ISNOTNULL(TO_CHAR(nCODDIV))='T' THEN
      OPEN crDivisao(nCODDIV);
      LOOP
         FETCH crDivisao INTO nCODITE;
         EXIT WHEN NOT FOUND;
         cWhere := 'CODCOR = ' || TO_CHAR(nCODITE);
         cRetorno := INSERE_MATU('TD_DIV', 'TT_GRA', cWhere);
      END LOOP;
      CLOSE crDivisao;  
   END IF; 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3664 --*/
CREATE TRIGGER TGDDIV2
AFTER INSERT OR DELETE OR UPDATE ON TD_DIV 
FOR EACH ROW EXECUTE PROCEDURE TGDDIV2();


/*-- SEQ 3665 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDDOC() CASCADE;

/*-- SEQ 3666 --*/
CREATE OR REPLACE FUNCTION TGDDOC() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_CLI
DECLARE
   cRetorno                      VARCHAR(2);
   cWhere                        TM_ATU.FILTRO%TYPE;
   cTIPDOC                       TT_CLI.TIPDOC%TYPE;
BEGIN
   --Tratamento para Atualizar Tabela Pai
   IF (TG_OP = 'INSERT') THEN
      cTIPDOC := NEW.TIPDOC;
   ELSIF (TG_OP = 'UPDATE') THEN 
      IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1
      OR Equal(OLD.DESDOC,NEW.DESDOC) <> 1
      OR Equal(OLD.TIPDOC,NEW.TIPDOC) <> 1
      OR Equal(OLD.DOCATV,NEW.DOCATV) <> 1 THEN
         cTIPDOC := NEW.TIPDOC;
      ELSE
         cTIPDOC := NULL;
      END IF;
   ELSIF (TG_OP = 'DELETE') THEN
      cTIPDOC := OLD.TIPDOC;
   END IF;
   IF ISNOTNULL(cTIPDOC)='T' THEN
      cWhere := 'TIPDOC = ' || CHR(39) || cTIPDOC  || CHR(39);
      cRetorno := INSERE_MATU('TD_DOC', 'TT_CLI', cWhere);
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3667 --*/
CREATE TRIGGER TGDDOC
AFTER INSERT OR UPDATE OR DELETE ON TD_DOC 
FOR EACH ROW EXECUTE PROCEDURE TGDDOC();


/*-- SEQ 3668 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDEAN1() CASCADE;

/*-- SEQ 3669 --*/
CREATE OR REPLACE FUNCTION TGDEAN1() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1)uPDATE DE TT_EAN.ATU_EM
BEGIN
   IF (COALESCE(OLD.USAVEN,'X')) <> (COALESCE(NEW.USAVEN,'X')) THEN
      UPDATE TT_EAN SET ATU_EM = AGORA() WHERE USOEAN = NEW.CODTAB;
   END IF;
   UPDATE TT_CLI SET ATU_EM = AGORA() WHERE FILCLI = NEW.EANFIL AND CODCLI = NEW.EANCOD;
   UPDATE TT_CLI SET ATU_EM = AGORA() WHERE FILCLI = OLD.EANFIL AND CODCLI = OLD.EANCOD;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3670 --*/
CREATE TRIGGER TGDEAN1
BEFORE UPDATE ON TD_EAN 
FOR EACH ROW EXECUTE PROCEDURE TGDEAN1();


/*-- SEQ 3671 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDECF1() CASCADE;

/*-- SEQ 3672 --*/
CREATE OR REPLACE FUNCTION TGDECF1() RETURNS TRIGGER AS $$
DECLARE
   -- Objetivo:
   -- Manter um limite de itens
   vLimite                       constant Numeric := constante('limite');
   vQtd                          Numeric;

BEGIN
   SELECT count(*) INTO vQtd FROM TD_ECF;
   IF (vQtd > vLimite) then
      RAISE EXCEPTION 'PG-20007 Quantidade de registros atingida. Nao pode haver mais inclusoes';
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3673 --*/
CREATE TRIGGER TGDECF1
BEFORE INSERT ON TD_ECF 
FOR STATEMENT EXECUTE PROCEDURE TGDECF1();


/*-- SEQ 3674 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDECF2() CASCADE;

/*-- SEQ 3675 --*/
CREATE OR REPLACE FUNCTION TGDECF2() RETURNS TRIGGER AS $$
DECLARE
   -- Objetivo:
   -- 1) Incluir uma conta automaticamente
   cTIPCTA_ECF                   CHAR(1);
   -- Atualizar TD_IND
   TD_IND_OK                     VARCHAR(2);
   vComplemento                  CONSTANT VARCHAR(100) := constante('complemento');

   --LEO 84337
   vCODUID_ATUAL                 VARCHAR(22);
   vBLQ_SEM_UID                  TT_CFG.BLQ_SEM_UID%TYPE;
   vSESSIONID                    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

BEGIN
   SELECT TIPCTA_ECF INTO cTIPCTA_ECF FROM TT_CFG;

   IF (TG_OP = 'INSERT') THEN
      NEW.ATU_EM := AGORA();
   END IF;


   IF (TG_OP = 'UPDATE') THEN
      IF (OLD.CODTAB <> NEW.CODTAB) or
         (OLD.COBECF <> NEW.COBECF) or
         (OLD.FILECF <> NEW.FILECF) or
         (OLD.NUMECF <> NEW.NUMECF) or
         (OLD.PORECF <> NEW.PORECF) or
         (OLD.ECFATI <> NEW.ECFATI) or
         (OLD.CODORI <> NEW.CODORI) or
         (OLD.CODMUL <> NEW.CODMUL) or
         (OLD.CTADIF <> NEW.CTADIF) or
         (OLD.CTAABE <> NEW.CTAABE) or
         (OLD.CTAFEC <> NEW.CTAFEC) or
         (OLD.CTATRO <> NEW.CTATRO) or
         (OLD.SAIENV <> NEW.SAIENV) or
         (OLD.MAQECF <> NEW.MAQECF) or
         (OLD.CODCTR <> NEW.CODCTR) or
         (OLD.MARECF <> NEW.MARECF) or
         (OLD.MODECF <> NEW.MODECF) or
         (OLD.VSWECF <> NEW.VSWECF) or
         (OLD.CODFAB <> NEW.CODFAB) or
         (OLD.CODMOD <> NEW.CODMOD) or
         (OLD.DSWECF <> NEW.DSWECF) or
         (OLD.FITDET <> NEW.FITDET) or
         (OLD.ECFUTL <> NEW.ECFUTL) or
         (OLD.ECFMFA <> NEW.ECFMFA) or
         (OLD.ECFTIP <> NEW.ECFTIP) or
         (OLD.ECFCOL <> NEW.ECFCOL) or
         (OLD.TNCIEE <> NEW.TNCIEE) or
         (OLD.ASSINA <> NEW.ASSINA) or
         (OLD.CODUID <> NEW.CODUID) or
         (OLD.CRZINI <> NEW.CRZINI) or
         (OLD.INTERV <> NEW.INTERV) or
         (OLD.CODEXT_DECF <> NEW.CODEXT_DECF) or
         (OLD.MAXCAI <> NEW.MAXCAI) or
         (OLD.ARRTRU <> NEW.ARRTRU) THEN

         NEW.ATU_EM := AGORA();
         UPDATE TT_CFG SET ATU_EM = AGORA();

      END IF;
   END IF;

   IF (TG_OP = 'UPDATE') THEN
      IF NEW.CODTAB <> 0 and OLD.CODTAB = 0 THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser modificado';
      END IF;
   END IF;

   IF (TG_OP = 'DELETE') THEN
      IF OLD.CODTAB = 0 THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido';
      END IF;
   END IF;


   IF (TG_OP = 'INSERT') THEN
      -- Gera item de cobranca
      IF NEW.PORECF IS NULL THEN
         NEW.PORECF := ProximaCobranca('ECF '||NEW.NUMECF||' da Filial '||NEW.FILECF,'E');
      END IF;

      -- Cria uma Serie
      IF NEW.SERECF IS NULL THEN
         NEW.SERECF := 'INDEFINIDO: '||NEW.FILECF||'/'||NEW.NUMECF;
      END IF;

      -- Default
      IF NEW.CODORI IS NULL THEN
         NEW.CODORI := NEW.NUMECF;
      END IF;

      TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
   END IF;

  IF (TG_OP = 'UPDATE') THEN
     -- Default
     IF NEW.CODORI IS NULL THEN
        NEW.CODORI := OLD.CODORI;
     END IF;
  END IF;

   IF (TG_OP = 'DELETE') THEN
      -- LEO 84337
      SELECT BLQ_SEM_UID
        INTO vBLQ_SEM_UID
        FROM TT_CFG;
      vCODUID_ATUAL := GetCoduidAtual();
      IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;
   END IF;

   IF (TG_OP = 'INSERT') THEN

      -- LEO 84337
      SELECT BLQ_SEM_UID
        INTO vBLQ_SEM_UID
        FROM TT_CFG;
      vCODUID_ATUAL := GetCoduidAtual();
      IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;

    -- Douglas - 83441
    NEW.CODUID := GetCoduidAtual();
    NEW.ASSINA := COALESCE(AssinaTabela('TD_ECF',
                                        ConcatenaDECF(NEW.FILECF,
                                                      NEW.NUMECF,
                                                      NEW.SERECF,
                                                      NEW.ECFMFA,
                                                      NEW.ECFTIP,
                                                      NEW.MARECF,
                                                      NEW.MODECF,
                                                      NEW.VSWECF,
                                                      NEW.DSWECF,
                                                      NEW.CODORI),
                                                   null, null, null),NEW.ASSINA);
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF ConcatenaDECF(OLD.FILECF,OLD.NUMECF,OLD.SERECF,OLD.ECFMFA,OLD.ECFTIP,OLD.MARECF,OLD.MODECF,OLD.VSWECF,OLD.DSWECF,OLD.CODORI) <>
         ConcatenaDECF(NEW.FILECF,NEW.NUMECF,NEW.SERECF,NEW.ECFMFA,NEW.ECFTIP,NEW.MARECF,NEW.MODECF,NEW.VSWECF,NEW.DSWECF,NEW.CODORI) THEN

         -- LEO 84337
         SELECT BLQ_SEM_UID
           INTO vBLQ_SEM_UID
           FROM TT_CFG;
         vCODUID_ATUAL := GetCoduidAtual();
         IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;

         -- Douglas - 83441
         NEW.CODUID := GetCoduidAtual();
         NEW.ASSINA := COALESCE(AssinaTabela('TD_ECF',
                                             ConcatenaDECF(NEW.FILECF,
                                                           NEW.NUMECF,
                                                           NEW.SERECF,
                                                           NEW.ECFMFA,
                                                           NEW.ECFTIP,
                                                           NEW.MARECF,
                                                           NEW.MODECF,
                                                           NEW.VSWECF,
                                                           NEW.DSWECF,
                                                           NEW.CODORI),
                                                       OLD.CODUID,
                                             ConcatenaDECF(OLD.FILECF,
                                                           OLD.NUMECF,
                                                           OLD.SERECF,
                                                           OLD.ECFMFA,
                                                           OLD.ECFTIP,
                                                           OLD.MARECF,
                                                           OLD.MODECF,
                                                           OLD.VSWECF,
                                                           OLD.DSWECF,
                                                           OLD.CODORI),
                                                      OLD.ASSINA
                                                     ),NEW.ASSINA);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3676 --*/
CREATE TRIGGER TGDECF2
BEFORE INSERT OR DELETE OR UPDATE ON TD_ECF 
FOR EACH ROW EXECUTE PROCEDURE TGDECF2();

/*-- SEQ 3677 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDECF_ASS() CASCADE;

/*-- SEQ 3678 --*/
CREATE OR REPLACE FUNCTION TGDECF_ASS() RETURNS TRIGGER AS $$
-- 83073
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN

   IF ExisteFilialNaUF('SC') THEN
      IF (TG_OP = 'INSERT') THEN
         UPDATE TT_ASS
            SET QTDREG = QTDREG + 1
          WHERE NOMTAB = 'TD_ECF';
      END IF;
      
      IF (TG_OP = 'DELETE') THEN
         UPDATE TT_ASS
            SET QTDREG = QTDREG - 1
          WHERE NOMTAB = 'TD_ECF';
      END IF;   
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3679 --*/
CREATE TRIGGER TGDECF_ASS
AFTER INSERT OR DELETE ON TD_ECF 
FOR EACH ROW EXECUTE PROCEDURE TGDECF_ASS();


/*-- SEQ 3680 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDEL() CASCADE;

/*-- SEQ 3681 --*/
CREATE OR REPLACE FUNCTION TGDEL() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TT_DEL',NEW.FILUSU);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3682 --*/
CREATE TRIGGER TGDEL
BEFORE INSERT ON TT_DEL 
FOR EACH ROW EXECUTE PROCEDURE TGDEL();


/*-- SEQ 3683 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDEND() CASCADE;

/*-- SEQ 3684 --*/
CREATE OR REPLACE FUNCTION TGDEND() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_CLI
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   -- MN - Atualiza tabela TT_CFG.ATU_EM para que o wsLocal faa a carga para o PoS
   IF (TG_OP = 'INSERT')  THEN
      cRetorno := INSERE_MATU('TD_END', 'TT_CFG', '');
   END IF; 
   
   IF (TG_OP = 'UPDATE') THEN 
      IF (Equal(OLD.CODTAB,NEW.CODTAB) <> 1) OR 
         (Equal(OLD.DESEND,NEW.DESEND) <> 1) OR 
         (Equal(OLD.USOEND,NEW.USOEND) <> 1) OR 
         (Equal(OLD.ENDATV,NEW.ENDATV) <> 1) THEN
         cRetorno := INSERE_MATU('TD_END', 'TT_CFG', '');
      END IF;
   END IF;   
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3685 --*/
CREATE TRIGGER TGDEND
AFTER INSERT OR UPDATE OR DELETE ON TD_END 
FOR EACH ROW EXECUTE PROCEDURE TGDEND();


/*-- SEQ 3686 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDENT() CASCADE;

/*-- SEQ 3687 --*/
CREATE OR REPLACE FUNCTION TGDENT() RETURNS TRIGGER AS $$
-- 84378
BEGIN
   IF (TG_OP = 'INSERT') OR (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20027 No  permitido Inserir ou Excluir registros desta tabela';
   END IF;
   IF (TG_OP = 'INSERT') THEN
      NEW.DATINC := AGORA();
   END IF;
   IF NOT (TG_OP = 'DELETE') THEN
      NEW.ATU_EM := AGORA();
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3688 --*/
CREATE TRIGGER TGDENT
BEFORE INSERT OR DELETE ON TD_ENT 
FOR EACH ROW EXECUTE PROCEDURE TGDENT();

/*-- SEQ 3689 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDENT2() CASCADE;

/*-- SEQ 3690 --*/
CREATE OR REPLACE FUNCTION TGDENT2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao

-- Declarao de variveis e cursores
   cRetorno                      VARCHAR(2);

   -- Principal
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3691 --*/
CREATE TRIGGER TGDENT2
AFTER INSERT OR UPDATE OR DELETE ON TD_ENT 
FOR EACH ROW EXECUTE PROCEDURE TGDENT2();


/*-- SEQ 3692 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDEP() CASCADE;

/*-- SEQ 3693 --*/
CREATE OR REPLACE FUNCTION TGDEP() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Nao permitir alteracoes se nao vierem da conciliacao

-- Principal
  vComplemento CONSTANT VARCHAR(254):= constante('complemento');
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN := ProximoCodigo('TT_DEP',NEW.CODFIL);
    END IF;
  END IF;
  IF (TG_OP = 'UPDATE') THEN  
    IF COALESCE(NEW.DUMMY,'XXX')<>CONSTANTE('VEM_DE_PCLEX') 
       AND OLD.VLRTOT>0 THEN -- Atualiza valor na primeira vez apos vincular os cheques
       RAISE EXCEPTION 'PG-20050 Deposito nao pode se modificado fora da conciliacao.%' , vComplemento;
    END IF;
  END IF;
  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     NEW.DUMMY:=NULL;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3694 --*/
CREATE TRIGGER TGDEP
BEFORE INSERT OR UPDATE ON TT_DEP 
FOR EACH ROW EXECUTE PROCEDURE TGDEP();


/*-- SEQ 3695 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDES() CASCADE;

/*-- SEQ 3696 --*/
CREATE OR REPLACE FUNCTION TGDES() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Grava a data e usurio da ultima atualizao
DECLARE
  Quemlogou TRetQuemLogou%ROWTYPE;
BEGIN
  
  select * into QuemLogou from DadosLogon();  

  NEW.ATU_EM := agora();
  NEW.FILUSU := Quemlogou.FILUSU;
  NEW.CODUSU := Quemlogou.CODUSU; 

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3697 --*/
CREATE TRIGGER TGDES
BEFORE INSERT OR UPDATE ON TT_DES 
FOR EACH ROW EXECUTE PROCEDURE TGDES();


/*-- SEQ 3698 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDEST() CASCADE;

/*-- SEQ 3699 --*/
CREATE OR REPLACE FUNCTION TGDEST() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Manter um limite de itens
   vLimite                       CONSTANT Numeric := Constante('limite');
   vQtd                          Numeric;
BEGIN
   SELECT COUNT(*) INTO vQtd FROM TD_EST;
   IF (vQtd > vLimite) then
      RAISE EXCEPTION 'PG-20007 Quantidade de registros atingida. Nao pode haver mais inclusoes';
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3700 --*/
CREATE TRIGGER TGDEST
BEFORE INSERT ON TD_EST 
FOR STATEMENT EXECUTE PROCEDURE TGDEST();

/*-- SEQ 3701 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDEST2() CASCADE;

/*-- SEQ 3702 --*/
CREATE OR REPLACE FUNCTION TGDEST2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Atualizar TD_IND
   TD_IND_OK                     VARCHAR(2);
BEGIN
   IF (TG_OP = 'INSERT') THEN
      TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
      NEW.ATU_EM := AGORA();
   END IF;

   -- Popula a coluna ATU_EM
   IF  (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := AGORA();  
   END IF;    
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3703 --*/
CREATE TRIGGER TGDEST2
BEFORE INSERT OR UPDATE ON TD_EST 
FOR EACH ROW EXECUTE PROCEDURE TGDEST2();

/*-- SEQ 3704 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDEST3() CASCADE;

/*-- SEQ 3705 --*/
CREATE OR REPLACE FUNCTION TGDEST3() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3706 --*/
CREATE TRIGGER TGDEST3
AFTER INSERT OR UPDATE OR DELETE ON TD_EST 
FOR EACH ROW EXECUTE PROCEDURE TGDEST3();


/*-- SEQ 3707 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDESXCLI() CASCADE;

/*-- SEQ 3708 --*/
CREATE OR REPLACE FUNCTION TGDESXCLI() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
   cRet                          VARCHAR(2);
   cLOG                          VARCHAR(4000)     := '';
BEGIN
   -- Gera um codigo automaticamente
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN := ProximoCodigo('TT_DESXCLI',NEW.FILCLI);
      END IF;
      IF NEW.VLRVEN IS NULL THEN
         NEW.VLRVEN := 0;
      END IF;
   END IF;

   IF (TG_OP = 'DELETE') THEN
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_DESXCLI', OLD.FILCLI || OLD.CODCLI, OLD.SEQUEN);
      -- Tratamento de log
      cLOG := 'Excluso de Acordo Comercial [' || OLD.SEQUEN || ']';
      INSERT INTO TL_CLI (FILCLI,CODCLI,DATOPE,MSGLOG) 
                 VALUES (OLD.FILCLI,OLD.CODCLI,agora(),cLOG);
   END IF;
   IF (TG_OP = 'INSERT') THEN
      --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_DESXCLI', NEW.FILCLI || NEW.CODCLI, NEW.SEQUEN);
   END IF;


   IF NOT (TG_OP = 'DELETE') THEN
      NEW.ATU_EM := AGORA();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3709 --*/
CREATE TRIGGER TGDESXCLI
BEFORE INSERT OR UPDATE OR DELETE ON TT_DESXCLI 
FOR EACH ROW EXECUTE PROCEDURE TGDESXCLI();

/*-- SEQ 3710 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDESXCLI2() CASCADE;

/*-- SEQ 3711 --*/
CREATE OR REPLACE FUNCTION TGDESXCLI2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Registrar mudanca dos dados num "log"
   cLOG                          VARCHAR(4000)     := '';
   cLogChave                     VARCHAR(40)       := '';
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
BEGIN
   -- Tratamento de log
   IF (TG_OP = 'INSERT') 
   OR (TG_OP = 'UPDATE') THEN      
      cLogChave := 'Acordo Comercial [' || NEW.SEQUEN || ']';
   END IF;
  
   IF (TG_OP = 'INSERT') THEN
      cLOG := 'Incluso de ' || cLogChave;     
   ELSIF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.FILCLI,NEW.FILCLI) <> 1 THEN
         cLOG := cLOG||'Filial: de '||COALESCE(OLD.FILCLI,cNulo)||' para '||COALESCE(NEW.FILCLI,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCLI,NEW.CODCLI) <> 1 THEN
         cLOG := cLOG||'Cod. Cli: de '||COALESCE(OLD.CODCLI,cNulo)||' para '||COALESCE(NEW.CODCLI,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILVEN,NEW.FILVEN) <> 1 THEN
         cLOG := cLOG||'Filial do Vendedor: de '||COALESCE(OLD.FILVEN,cNulo)||' para '||COALESCE(NEW.FILVEN,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CLASS1,NEW.CLASS1) <> 1 THEN
         cLOG := cLOG||'1a Classe: de '||COALESCE(OLD.CLASS1,iNulo)||' para '||COALESCE(NEW.CLASS1,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.CLASS2,NEW.CLASS2) <> 1 THEN
         cLOG := cLOG||'2a Classe: de '||COALESCE(OLD.CLASS2,iNulo)||' para '||COALESCE(NEW.CLASS2,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.CLASS3,NEW.CLASS3) <> 1 THEN
         cLOG := cLOG||'3a Classe: de '||COALESCE(OLD.CLASS3,iNulo)||' para '||COALESCE(NEW.CLASS3,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.CLASS4,NEW.CLASS4) <> 1 THEN
         cLOG := cLOG||'4a Classe: de '||COALESCE(OLD.CLASS4,iNulo)||' para '||COALESCE(NEW.CLASS4,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRVEN,NEW.VLRVEN) <> 1 THEN
         cLOG := cLOG||'Quant. Vendida: de '||COALESCE(OLD.VLRVEN,iNulo)||' para '||COALESCE(NEW.VLRVEN,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.ACORDO,NEW.ACORDO) <> 1 THEN
         cLOG := cLOG||'Valor do Acordo: de '||COALESCE(OLD.ACORDO,iNulo)||' para '||COALESCE(NEW.ACORDO,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.TIPACO,NEW.TIPACO) <> 1 THEN
         cLOG := cLOG||'Tipo de Acordo: de '||COALESCE(DescricaoDominio('DSC','TIPACO', OLD.TIPACO),cNulo)||' para '||COALESCE(DescricaoDominio('DSC','TIPACO', NEW.TIPACO),cNulo)||CRLF;
      END IF;  
      IF Equal(OLD.FILMAT,NEW.FILMAT) <> 1 or Equal(OLD.CODMAT,NEW.CODMAT) <> 1 or
         Equal(OLD.CODCOR,NEW.CODCOR) <> 1 or Equal(OLD.CODTAM,NEW.CODTAM) <> 1 THEN
         cLOG := cLOG||'Produto: de '||COALESCE(OLD.FILMAT,cNulo)||COALESCE(OLD.CODMAT,cNulo)||'-'||COALESCE(OLD.CODCOR,iNulo)||'-'||COALESCE(OLD.CODTAM,iNulo)||' para '||
                                                 COALESCE(NEW.FILMAT,cNulo)||COALESCE(NEW.CODMAT,cNulo)||'-'||COALESCE(NEW.CODCOR,iNulo)||'-'||COALESCE(NEW.CODTAM,iNulo)||CRLF;
      END IF;
      
      IF ISNOTNULL(cLOG) = 'T' THEN
         cLOG := cLogChave || ' >> ' || cLOG;
      END IF;
   END IF;
   IF (TG_OP = 'INSERT') 
   OR (TG_OP = 'UPDATE') THEN
      IF ISNOTNULL(cLOG) = 'T' THEN
         INSERT INTO TL_CLI (FILCLI,CODCLI,DATOPE,MSGLOG)
                     VALUES (NEW.FILCLI,NEW.CODCLI,agora(),cLOG);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3712 --*/
CREATE TRIGGER TGDESXCLI2
AFTER INSERT OR UPDATE ON TT_DESXCLI 
FOR EACH ROW EXECUTE PROCEDURE TGDESXCLI2();


/*-- SEQ 3713 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDESxDCCC() CASCADE;

/*-- SEQ 3714 --*/
CREATE OR REPLACE FUNCTION TGDESxDCCC() RETURNS TRIGGER AS $$
-- Objetivos:
-- Atualizar ATU_EM
-- Manter log de excluso
DECLARE
  cRet VARCHAR(2);
BEGIN
  IF (TG_OP = 'DELETE') THEN
     cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_DESxDCCC', to_char(OLD.codccc), OLD.codfil || to_char(OLD.pgtate));
  END IF;
  IF (TG_OP = 'INSERT') THEN
     --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
     cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_DESxDCCC', to_char(NEW.codccc), NEW.codfil || to_char(NEW.pgtate));
  END IF;

  IF NOT (TG_OP = 'DELETE') THEN
    NEW.ATU_EM := AGORA();
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3715 --*/
CREATE TRIGGER TGDESxDCCC
BEFORE UPDATE OR INSERT OR DELETE ON TT_DESxDCCC 
FOR EACH ROW EXECUTE PROCEDURE TGDESxDCCC();


/*-- SEQ 3716 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDETI() CASCADE;

/*-- SEQ 3717 --*/
CREATE OR REPLACE FUNCTION TGDETI() RETURNS TRIGGER AS $$
-- Objetivo:
-- Impedir delete ou update do CODTAB = 0
BEGIN
  IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF NEW.CODTAB <> 0 and OLD.CODTAB = 0 THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3718 --*/
CREATE TRIGGER TGDETI
BEFORE UPDATE OR DELETE ON TD_ETI 
FOR EACH ROW EXECUTE PROCEDURE TGDETI();



/*-- SEQ 3719 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDEV() CASCADE;

/*-- SEQ 3720 --*/
CREATE OR REPLACE FUNCTION TGDEV() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
  WK_COUNT Numeric(5);
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN := ProximoCodigo('TT_DEV',NEW.CODFIL);       
    END IF;
    NEW.REGINC := agora();
  END IF; 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3721 --*/
CREATE TRIGGER TGDEV
BEFORE INSERT ON TT_DEV 
FOR EACH ROW EXECUTE PROCEDURE TGDEV();


/*-- SEQ 3722 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDEXT() CASCADE;

/*-- SEQ 3723 --*/
CREATE OR REPLACE FUNCTION TGDEXT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Tabela read only

-- Principal
BEGIN
    RAISE EXCEPTION 'PG-20000 Tabela no pode ser alterada.';
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3724 --*/
CREATE TRIGGER TGDEXT
BEFORE INSERT OR UPDATE OR DELETE ON TD_EXT 
FOR EACH ROW EXECUTE PROCEDURE TGDEXT();


/*-- SEQ 3725 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDFCC() CASCADE;

/*-- SEQ 3726 --*/
CREATE OR REPLACE FUNCTION TGDFCC() RETURNS TRIGGER AS $$
DECLARE
-- Tabela Faixa Calculo Combustivel
-- Objetivo:
-- 1)  Atualiza ATU_EM
-- Principal
BEGIN
  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
    NEW.ATU_EM := AGORA();
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3727 --*/
CREATE TRIGGER TGDFCC
BEFORE INSERT OR UPDATE ON TD_FCC 
FOR EACH ROW EXECUTE PROCEDURE TGDFCC();


/*-- SEQ 3728 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDFCE() CASCADE;

/*-- SEQ 3729 --*/
CREATE OR REPLACE FUNCTION TGDFCE() RETURNS TRIGGER AS $$
-- Objetivo:
-- Impedir delete ou update
BEGIN   
  IF (TG_OP = 'UPDATE') THEN    
        RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser modificado';     
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3730 --*/
CREATE TRIGGER TGDFCE
BEFORE UPDATE ON TD_FCE 
FOR EACH ROW EXECUTE PROCEDURE TGDFCE();




/*-- SEQ 3731 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDFID() CASCADE;

/*-- SEQ 3732 --*/
CREATE OR REPLACE FUNCTION TGDFID() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
--    Obs.: Ao contrario de outras TDs, esta nao utiliza o padrao de CODTAB
--          relacionado com TD_IND do Totall Config
-- Principal
   nProximo                       Numeric;
BEGIN
   -- Gera um codigo automaticamente
   IF (TG_OP = 'INSERT') THEN
      IF NEW.CODTAB IS NULL THEN
         SELECT NEXTVAL('sqDFID') INTO nProximo FROM DUAL;
         NEW.CODTAB := nProximo;
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3733 --*/
CREATE TRIGGER TGDFID
BEFORE INSERT OR UPDATE ON TD_FID 
FOR EACH ROW EXECUTE PROCEDURE TGDFID();

/*-- SEQ 3734 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDFID2() CASCADE;

/*-- SEQ 3735 --*/
CREATE OR REPLACE FUNCTION TGDFID2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_CLI
--
DECLARE
   cRetorno                      VARCHAR(2);
   cWhere                        TM_ATU.FILTRO%TYPE;
   nCODTAB                       TD_FID.CODTAB%TYPE;   
-- Principal
BEGIN
   --Tratamento para Atualizar Tabela Pai   
   IF (TG_OP = 'INSERT') THEN
      nCODTAB := NEW.CODTAB;
   ELSIF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1
      OR Equal(OLD.DESFID,NEW.DESFID) <> 1
      OR Equal(OLD.PERFID,NEW.PERFID) <> 1
      OR Equal(OLD.IMGFID,NEW.IMGFID) <> 1
      OR Equal(OLD.ATIFID,NEW.ATIFID) <> 1 THEN
         nCODTAB := NEW.CODTAB;
      ELSE
         nCODTAB := NULL;
      END IF;
   ELSIF (TG_OP = 'DELETE') THEN
      nCODTAB := OLD.CODTAB;
   END IF;
   IF ISNOTNULL(TO_CHAR(nCODTAB))='T' THEN
      cWhere := 'CODFID = ' || TO_CHAR(nCODTAB);
      cRetorno := INSERE_MATU('TD_FID', 'TT_CLI', cWhere);  
   END IF; 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3736 --*/
CREATE TRIGGER TGDFID2
AFTER INSERT OR UPDATE OR DELETE ON TD_FID 
FOR EACH ROW EXECUTE PROCEDURE TGDFID2();




/*-- SEQ 3737 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDFIL2() CASCADE;

/*-- SEQ 3738 --*/
CREATE OR REPLACE FUNCTION TGDFIL2() RETURNS TRIGGER AS $$
-- Objetivo
-- 1) Registrar Pendncias para Atualizar os Impostos de Fornecedores Calculados
DECLARE
   inDFIL                        TD_FIL%ROWTYPE;
   cDUMMY                        VARCHAR(1);
   cPathBase                     TT_CFG.PATH_BASE%TYPE;
   nDUMMY                        INTEGER;
   cRet                          VARCHAR(2);

   --LEO 84337
   vCODUID_ATUAL                 TT_VEN.CODUID%TYPE;
   vBLQ_SEM_UID                  TT_CFG.BLQ_SEM_UID%TYPE;
   vSESSIONID                    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

   -- Pedro E. Braga - 92722
   cRETORNO                      VARCHAR(4);
   -- Pedro E. Braga - 93794
   cFPVPRECOSIMULADO             TT_CFG.FPV_PRECO_SIMULADO%TYPE;
BEGIN
   
   IF NOT (TG_OP = 'DELETE') THEN
      -- Assumindo valor "default"
      IF NEW.CODDEP IS NULL THEN
         NEW.CODDEP := NEW.CODFIL;
      END IF;

      IF NEW.CODCID IS NULL THEN
         SELECT CODCID INTO NEW.CODCID
           FROM TT_IDF;
      END IF;

      
      IF NOT (TG_OP = 'INSERT') THEN
      
         IF Equal(OLD.INIFIL,NEW.INIFIL) <> 1 OR
            Equal(OLD.EXP_BO,NEW.EXP_BO) <> 1 THEN
            nDummy := Adiciona_TT_DAT( NEW.INIFIL, NEW.EXP_BO );
         END IF;

      
      END IF;
      
      IF (TG_OP = 'UPDATE') THEN
         UPDATE TD_ECF SET ATU_EM = AGORA() WHERE FILECF = NEW.CODFIL;
         IF OLD.CODFIL <> NEW.CODFIL THEN
            UPDATE TD_ECF SET ATU_EM = AGORA() WHERE FILECF = OLD.CODFIL;
         END IF;

         --Pedro E. Braga - 93794
         SELECT FPV_PRECO_SIMULADO INTO cFPVPRECOSIMULADO FROM TT_CFG;
         IF (cFPVPRECOSIMULADO = 'T') THEN
            -- Pedro E. Braga - 92722
            IF (Equal(OLD.REGTRI, NEW.REGTRI) <> 1)
            OR (Equal(OLD.IE_FIL, NEW.IE_FIL) <> 1)
            OR (Equal(OLD.UFLOJA, NEW.UFLOJA) <> 1) THEN
               cRETORNO := INSERE_MIFC('DFIL',NEW.CODFIL);
            END IF;
         END IF;
      END IF;
      -- RFMP 72339
      IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
         SELECT PATH_BASE into cPathBase from TT_CFG;
         IF ISNOTNULL(cPathBase) = 'T' THEN
            IF ISNULL(TRIM(NEW.PATCAR)) = 'T' THEN
               NEW.PATCAR := cPathBase || PATH_DEFAULT('TD_FIL','PATCAR',NEW.CODFIL);
            END IF;
            IF ISNULL(TRIM(NEW.PATPED)) = 'T' THEN
               NEW.PATPED := cPathBase || PATH_DEFAULT('TD_FIL','PATPED',NEW.CODFIL);
            END IF;
            IF ISNULL(TRIM(NEW.PAT_AA)) = 'T' THEN
               NEW.PAT_AA := cPathBase || PATH_DEFAULT('TD_FIL','PAT_AA',NEW.CODFIL);
            END IF;
            IF ISNULL(TRIM(NEW.PATNOT)) = 'T' THEN
               NEW.PATNOT := cPathBase || PATH_DEFAULT('TD_FIL','PATNOT',NEW.CODFIL);
            END IF;
            IF ISNULL(TRIM(NEW.PATCON)) = 'T' THEN
               NEW.PATCON := cPathBase || PATH_DEFAULT('TD_FIL','PATCON',NEW.CODFIL);
            END IF;
            IF ISNULL(TRIM(NEW.PATTKE)) = 'T' THEN
               NEW.PATTKE := cPathBase || PATH_DEFAULT('TD_FIL','PATTKE',NEW.CODFIL);
            END IF;
            IF ISNULL(TRIM(NEW.PATNFE)) = 'T' THEN
               NEW.PATNFE := cPathBase || PATH_DEFAULT('TD_FIL','PATNFE',NEW.CODFIL);
            END IF;
         END IF;
      END IF;

      IF (TG_OP = 'INSERT') THEN
         --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
         cRet := LogExclusao((TG_OP = 'DELETE'), 'TD_FIL', TO_CHAR(NEW.CODFIL), NULL);
      END IF;

      NEW.ATU_EM := AGORA();
   END IF;

   IF (TG_OP = 'DELETE') THEN
      -- LEO 84337
      SELECT BLQ_SEM_UID
        INTO vBLQ_SEM_UID
        FROM TT_CFG;
      vCODUID_ATUAL := GetCoduidAtual();
      IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;
   END IF;

   IF (TG_OP = 'INSERT') THEN

      -- LEO 84337
      SELECT BLQ_SEM_UID
        INTO vBLQ_SEM_UID
        FROM TT_CFG;
      vCODUID_ATUAL := GetCoduidAtual();
      IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;

      -- Douglas - 83441
      NEW.CODUID := GetCoduidAtual();
      NEW.ASSINA := COALESCE(AssinaTabela('TD_FIL',
                                       ConcatenaDFIL(NEW.CODFIL,
                                                     NEW.DATEST,
                                                     NEW.CGCFIL,
                                                     NEW.IE_FIL,
                                                     NEW.INSMUN,
                                                     NEW.RAZSOC),
                                                   null, null, null),NEW.ASSINA);
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF ConcatenaDFIL(NEW.CODFIL,NEW.DATEST,NEW.CGCFIL,NEW.IE_FIL,NEW.INSMUN,NEW.RAZSOC) <>
         ConcatenaDFIL(OLD.CODFIL,OLD.DATEST,OLD.CGCFIL,OLD.IE_FIL,OLD.INSMUN,OLD.RAZSOC) THEN

         -- LEO 84337
         SELECT BLQ_SEM_UID
           INTO vBLQ_SEM_UID
           FROM TT_CFG;
         vCODUID_ATUAL := GetCoduidAtual();
         IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;

         -- Douglas - 83441
         NEW.CODUID := GetCoduidAtual();
         NEW.ASSINA := COALESCE(AssinaTabela('TD_FIL',
                                            ConcatenaDFIL(NEW.CODFIL,
                                                          NEW.DATEST,
                                                          NEW.CGCFIL,
                                                          NEW.IE_FIL,
                                                          NEW.INSMUN,
                                                          NEW.RAZSOC),
                                             OLD.CODUID,
                                            ConcatenaDFIL(OLD.CODFIL,
                                                          OLD.DATEST,
                                                          OLD.CGCFIL,
                                                          OLD.IE_FIL,
                                                          OLD.INSMUN,
                                                          OLD.RAZSOC),
                                             OLD.ASSINA
                                             ),NEW.ASSINA);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3739 --*/
CREATE TRIGGER TGDFIL2
BEFORE INSERT OR DELETE OR UPDATE ON TD_FIL 
FOR EACH ROW EXECUTE PROCEDURE TGDFIL2();


/*-- SEQ 3740 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDFIL4() CASCADE;

/*-- SEQ 3741 --*/
CREATE OR REPLACE FUNCTION TGDFIL4() RETURNS TRIGGER AS $$
DECLARE
   cDUMMY                        VARCHAR(1);
   inDFIL                        TD_FIL%ROWTYPE;
BEGIN
   IF (TG_OP = 'DELETE') THEN
      inDFIL.CODFIL := OLD.CODFIL;
      inDFIL.RAZSOC := OLD.RAZSOC;
      inDFIL.NOMFIL := OLD.NOMFIL;
      inDFIL.CGCFIL := OLD.CGCFIL;
      inDFIL.IE_FIL := OLD.IE_FIL;
   ELSE
      inDFIL.CODFIL := NEW.CODFIL;
      inDFIL.RAZSOC := NEW.RAZSOC;
      inDFIL.NOMFIL := NEW.NOMFIL;
      inDFIL.CGCFIL := NEW.CGCFIL;
      inDFIL.ENDERE := NEW.ENDERE;
      inDFIL.NUMERO := NEW.NUMERO;
      inDFIL.COMPLE := NEW.COMPLE;
      inDFIL.DDDFIL := NEW.DDDFIL;
      inDFIL.NUMFON := NEW.NUMFON;
      inDFIL.CODCEP := NEW.CODCEP;
      inDFIL.BAIRRO := NEW.BAIRRO;
      inDFIL.FAXFIL := NEW.FAXFIL;
      inDFIL.UFLOJA := NEW.UFLOJA;
      inDFIL.IE_FIL := NEW.IE_FIL;
      inDFIL.REGESP := NEW.REGESP;
      inDFIL.CODCID := NEW.CODCID;
      inDFIL.TIPEND := NEW.TIPEND;
      inDFIL.CODIBG := NEW.CODIBG;
      inDFIl.REGTRI := NEW.REGTRI;
   END IF;

   -- Aproveita FILATI para definir a acao a ser tomada
   IF (TG_OP = 'INSERT') THEN
      inDFIL.FILATI := 'I';
   ELSIF (TG_OP = 'UPDATE')  THEN
      inDFIL.FILATI := 'U';
   ELSE
      inDFIL.FILATI := 'D';
   END IF;

   inDFIL.REGESP := NEW.REGESP;
   IF (TG_OP = 'INSERT') THEN
      inDFIL.REGESP := -1; -- Sinaliza para criar registros na TT_IUF
   ELSIF (TG_OP = 'UPDATE')  THEN
      IF Equal(OLD.REGESP,NEW.REGESP)=0 OR
         Equal(OLD.UFLOJA,NEW.UFLOJA)=0 THEN
         inDFIL.REGESP := -1; -- Sinaliza para criar registros na TT_IUF
      END IF;
   END IF;
   cDUMMY := PC_DFIL_Principal(inDFIL.RAZSOC,inDFIL.FILATI,inDFIL.CODFIL,inDFIL.NOMFIL,inDFIL.CGCFIL,
                              inDFIL.ENDERE,inDFIL.COMPLE,inDFIL.NUMERO,inDFIL.DDDFIL,inDFIL.NUMFON,
                              inDFIL.CODCEP,inDFIL.BAIRRO,inDFIL.UFLOJA,inDFIL.FAXFIL,inDFIL.IE_FIL,inDFIL.REGESP,inDFIL.CODCID,
                              inDFIL.TIPEND,inDFIL.CODIBG, inDFIl.REGTRI);
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3742 --*/
CREATE TRIGGER TGDFIL4
AFTER INSERT OR UPDATE OR DELETE ON TD_FIL 
FOR EACH ROW EXECUTE PROCEDURE TGDFIL4();

/*-- SEQ 3743 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDFIL5() CASCADE;

/*-- SEQ 3744 --*/
CREATE OR REPLACE FUNCTION TGDFIL5() RETURNS TRIGGER AS $$
-- Objetivo
-- 1) Insere dias teis para a filial (TT_UTL)
-- 2) Atualiza ATU_EM da TT_ATU de configurao
-- 3) Atualiza ATU_EM da TT_CLI
DECLARE
   cRetorno                      VARCHAR(2);
   cWhere                        TM_ATU.FILTRO%TYPE;
BEGIN
   IF (TG_OP = 'INSERT') THEN
      cRetorno := InsereDiasUteisFilial(NEW.CODFIL);
   END IF;

   cRetorno := AtualizaData('CONFIGURACAO',Agora());

   --Tratamento para Atualizar Tabela Pai
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN
      cWhere := 'FILCLI = ' || CHR(39) || NEW.CODFIL  || CHR(39) || ' AND CODCLI = ' || CHR(39) || LPAD('0', 6, ' ') || CHR(39);
   ELSIF (TG_OP = 'DELETE') THEN
      cWhere := 'FILCLI = ' || CHR(39) || OLD.CODFIL  || CHR(39) || ' AND CODCLI = ' || CHR(39) || LPAD('0', 6, ' ') || CHR(39);
   END IF;
   cRetorno := INSERE_MATU('TD_FIL', 'TT_CLI', cWhere);

   -- Atualiza o ATU_EM de todos os produtos que tenham IPI, para que seja feita a carga dos preos no frente de caixa
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.DESIPI,NEW.DESIPI) <> 1 THEN
         cWhere := 'COALESCE(RESIPI,0) <> 0';
         cRetorno := INSERE_MATU('TD_FIL', 'TT_PRO', cWhere);      
      END IF;
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3745 --*/
CREATE TRIGGER TGDFIL5
AFTER INSERT OR UPDATE OR DELETE ON TD_FIL 
FOR EACH ROW EXECUTE PROCEDURE TGDFIL5();

/*-- SEQ 3746 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDFIL_ASS() CASCADE;

/*-- SEQ 3747 --*/
CREATE OR REPLACE FUNCTION TGDFIL_ASS() RETURNS TRIGGER AS $$
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN

   IF (TG_OP = 'INSERT') THEN
      UPDATE TT_ASS
         SET QTDREG = QTDREG + 1
       WHERE NOMTAB = 'TD_FIL';
   END IF;

   IF (TG_OP = 'DELETE') THEN
      UPDATE TT_ASS
          SET QTDREG = QTDREG - 1
      WHERE NOMTAB = 'TD_FIL';
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3748 --*/
CREATE TRIGGER TGDFIL_ASS
AFTER INSERT OR DELETE ON TD_FIL 
FOR EACH ROW EXECUTE PROCEDURE TGDFIL_ASS();


/*-- SEQ 3749 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDFIN() CASCADE;

/*-- SEQ 3750 --*/
CREATE OR REPLACE FUNCTION TGDFIN() RETURNS TRIGGER AS $$
-- Objetivo:
-- Impedir delete ou update do CODTAB = 0
BEGIN
  IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF NEW.CODTAB <> 0 and OLD.CODTAB = 0 THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3751 --*/
CREATE TRIGGER TGDFIN
BEFORE UPDATE OR DELETE ON TD_FIN 
FOR EACH ROW EXECUTE PROCEDURE TGDFIN();


/*-- SEQ 3752 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDFIS() CASCADE;

/*-- SEQ 3753 --*/
CREATE OR REPLACE FUNCTION TGDFIS() RETURNS TRIGGER AS $$
-- Objetivo:
-- Atualizar TT_IUF.ATU_EM
BEGIN
  IF (Equal(OLD.FISATI,NEW.FISATI) <> 1 ) OR
     (Equal(OLD.CODFIS,NEW.CODFIS) <> 1 ) THEN
    UPDATE TT_IUF SET ATU_EM = AGORA() WHERE CODFIS = NEW.CODTAB;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3754 --*/
CREATE TRIGGER TGDFIS
BEFORE UPDATE ON TD_FIS 
FOR EACH ROW EXECUTE PROCEDURE TGDFIS();


/*-- SEQ 3755 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDFPS() CASCADE;

/*-- SEQ 3756 --*/
CREATE OR REPLACE FUNCTION TGDFPS() RETURNS TRIGGER AS $$
-- Objetivo:
-- Impedir delete ou update
BEGIN  
  IF (TG_OP = 'UPDATE') THEN   
        RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser modificado';    
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3757 --*/
CREATE TRIGGER TGDFPS
BEFORE UPDATE ON TD_FPS 
FOR EACH ROW EXECUTE PROCEDURE TGDFPS();


/*-- SEQ 3758 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDFRE() CASCADE;

/*-- SEQ 3759 --*/
CREATE OR REPLACE FUNCTION TGDFRE() RETURNS TRIGGER AS $$
DECLARE
  -- Objetivo:
  -- 1) Impedir delete ou update do CODTAB = 0
  -- 2) Atualizar TD_IND
  -- 3) Tratamento de valores conforme dependendo da situação do DFRE_TIPCOB
  -- 4) Tratamento de valores para campos preenchidos
  -- 5) Registrar Pendências para Atualizar os Impostos de Fornecedores Calculados
 
  vComplemento VARCHAR(254);
  TD_IND_OK VARCHAR(2);
  -- Mateus 92861
  cRETORNO VARCHAR(4); 
  -- Pedro E. Braga - 93794
  cFPVPRECOSIMULADO TT_CFG.FPV_PRECO_SIMULADO%TYPE;
BEGIN
  vComplemento := constante('complemento');
 
  -- Impede exclusões
  IF (TG_OP = 'DELETE') OR (TG_OP = 'UPDATE') THEN
     IF (TG_OP = 'DELETE') THEN
        RAISE EXCEPTION 'PG-20001 Registro de uso interno. Nao pode ser excluido. %' , vComplemento;
     ELSIF ((TG_OP = 'UPDATE') and NEW.CODTAB <> 0 and OLD.CODTAB = 0) THEN
        RAISE EXCEPTION 'PG-20002 Registro de uso interno. Nao pode ser modificado. %' , vComplemento;
     END IF;
  END IF;
 
  IF (TG_OP = 'INSERT') THEN
    TD_IND_OK := Atualiza_TD_IND(NEW.CODTAB);
  END IF;
  
  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
    IF (NEW.DFRE_TIPCOB = 'V')
    AND((COALESCE(NEW.DFRE_PERVEN,0) <= 0) OR (COALESCE(NEW.DFRE_PERVEN,0) >= 100)) THEN
      RAISE EXCEPTION 'PG-20040 Valor invalido para "Percentual sobre a venda". %' , vComplemento;
    ELSIF (NEW.DFRE_TIPCOB = 'E')
    AND(COALESCE(NEW.DFRE_VALENT,0) <= 0) THEN
      RAISE EXCEPTION 'PG-20041 Valor invalido para "Valor por entrega". %' , vComplemento;    
    ELSIF (NEW.DFRE_TIPCOB = 'P')
    AND(COALESCE(NEW.DFRE_VALPES,0) <= 0) THEN
      RAISE EXCEPTION 'PG-20042 Valor invalido para "Valor por peso". %' , vComplemento;    
    ELSIF (NEW.DFRE_TIPCOB = 'Q')
    AND(COALESCE(NEW.DFRE_VALQTD,0) <= 0) THEN
      RAISE EXCEPTION 'PG-20043 Valor invalido para "Valor por quantidade". %' , vComplemento;          
    ELSIF (NEW.DFRE_FREMIN IS NOT NULL)
    AND(COALESCE(NEW.DFRE_FREMIN,0) <= 0) THEN
      RAISE EXCEPTION 'PG-20044 Valor invalido para "Valor minimo de frete". %' , vComplemento;          
    ELSIF (NEW.DFRE_MINDES IS NOT NULL)
    AND(COALESCE(NEW.DFRE_MINDES,0) <= 0) THEN
      RAISE EXCEPTION 'PG-20045 Valor invalido para "Valor minimo para desconto". %' , vComplemento;          
    ELSIF (NEW.DFRE_PERDES IS NOT NULL)
    AND((COALESCE(NEW.DFRE_PERDES,0) <= 0) OR (COALESCE(NEW.DFRE_PERDES,0) >= 100)) THEN
      RAISE EXCEPTION 'PG-20046 Valor invalido para "Percentual de desconto no frete". %' , vComplemento;                
    END IF; 

    --Mateus 92861
    IF (TG_OP = 'UPDATE') THEN
      --Pedro E. Braga - 93794
      SELECT FPV_PRECO_SIMULADO INTO cFPVPRECOSIMULADO FROM TT_CFG;     
      IF (cFPVPRECOSIMULADO = 'T') THEN    
        cRETORNO := INSERE_MIFC('DFRE', CAST(NEW.CODTAB AS VARCHAR));
      END IF;
    END IF;
  END IF;
   
  IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3760 --*/
CREATE TRIGGER TGDFRE
BEFORE DELETE OR INSERT OR UPDATE ON TD_FRE 
FOR EACH ROW EXECUTE PROCEDURE TGDFRE();


/*-- SEQ 3761 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDGRA() CASCADE;

/*-- SEQ 3762 --*/
CREATE OR REPLACE FUNCTION TGDGRA() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1. Impedir mudancas na tabela de grade se ja houver algum produto ligado a ela
-- 2. Nao permitir excluir ou alterar o registro CODTAB = 0
DECLARE
  complemento CONSTANT CHAR(20) := ' Operacao cancelada.';
  linha INTEGER;

BEGIN
  IF (TG_OP = 'DELETE') THEN
    RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
  END IF;
  IF (TG_OP = 'UPDATE') THEN 
     IF NEW.CODTAB <> 0 and OLD.CODTAB = 0 THEN
        RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
     END IF;
     -- Retorna a quantidade de procdutos vinculados.
     SELECT COUNT(*) INTO LINHA FROM TT_PRO WHERE CODGRA = OLD.CODTAB;

     -- Confirma se os codigos foram efetivamente mudados
     IF ((OLD.CODDIV <> NEW.CODDIV)  OR
         (OLD.CODSUB <> NEW.CODSUB)) AND
         Linha > 0 THEN
         RAISE EXCEPTION 'PG-20006 Ha produtos vinculados ao codigo de grade.%' , complemento;
     END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3763 --*/
CREATE TRIGGER TGDGRA
BEFORE UPDATE ON TD_GRA 
FOR EACH ROW EXECUTE PROCEDURE TGDGRA();


/*-- SEQ 3764 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDICM() CASCADE;

/*-- SEQ 3765 --*/
CREATE OR REPLACE FUNCTION TGDICM() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Impedir delete ou update do CODTAB = 0

  --LEO 84337
  vCODUID_ATUAL VARCHAR(22);
  vBLQ_SEM_UID  TT_CFG.BLQ_SEM_UID%TYPE;
  vSESSIONID    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

BEGIN
  
  IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF NEW.CODTAB <> 0 and OLD.CODTAB = 0 THEN
        RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
     END IF;
     IF (Equal(OLD.ICMATI,NEW.ICMATI) <> 1 ) OR
        (Equal(OLD.RESICM,NEW.RESICM) <> 1 ) OR
        (Equal(OLD.PERESPINTCOM,NEW.PERESPINTCOM) <> 1 ) THEN
     UPDATE TT_IUF SET ATU_EM = AGORA() WHERE RESICM = NEW.CODTAB;
     END IF;
  END IF;
  
  IF (TG_OP = 'DELETE') THEN
    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
  END IF;
  
  IF (TG_OP = 'INSERT') THEN
  
    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
  
    -- Douglas - 83441 
    NEW.CODUID := GetCoduidAtual();	     
    NEW.ASSINA := COALESCE(AssinaTabela('TD_ICM', 
	                                    ConcatenaDICM(NEW.CODTAB,
													  NEW.RESICM),
                                                   null, null, null),NEW.ASSINA);
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF ConcatenaDICM(NEW.CODTAB,NEW.RESICM) <>
	     ConcatenaDICM(OLD.CODTAB,OLD.RESICM) THEN
		 
		 -- LEO 84337
         SELECT BLQ_SEM_UID
           INTO vBLQ_SEM_UID
           FROM TT_CFG;
         vCODUID_ATUAL := GetCoduidAtual();
         IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;
		 
	     -- Douglas - 83441 
         NEW.CODUID := GetCoduidAtual();	     
         NEW.ASSINA := COALESCE(AssinaTabela('TD_ICM', 
 	                                         ConcatenaDICM(NEW.CODTAB,
			   											NEW.RESICM),
                                                       OLD.CODUID, 
	                                         ConcatenaDICM(OLD.CODTAB,
			   											OLD.RESICM),
                                                      OLD.ASSINA
                                                     ),NEW.ASSINA);
	  END IF; 												 
   END IF;       
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3766 --*/
CREATE TRIGGER TGDICM
BEFORE INSERT OR UPDATE OR DELETE ON TD_ICM 
FOR EACH ROW EXECUTE PROCEDURE TGDICM();

/*-- SEQ 3767 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDICM_ASS() CASCADE;

/*-- SEQ 3768 --*/
CREATE OR REPLACE FUNCTION TGDICM_ASS() RETURNS TRIGGER AS $$
-- 83073
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN

  IF ExisteFilialNaUF('SC') THEN
     IF (TG_OP = 'INSERT') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG + 1
        WHERE NOMTAB = 'TD_ICM';
     END IF;  
     
     IF (TG_OP = 'DELETE') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG - 1
        WHERE NOMTAB = 'TD_ICM';
     END IF;
  END IF;  

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3769 --*/
CREATE TRIGGER TGDICM_ASS
AFTER INSERT OR DELETE ON TD_ICM 
FOR EACH ROW EXECUTE PROCEDURE TGDICM_ASS();


/*-- SEQ 3770 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDIES() CASCADE;

/*-- SEQ 3771 --*/
CREATE OR REPLACE FUNCTION TGDIES() RETURNS TRIGGER AS $$
-- Objetivo:
-- Impedir delete ou update do CODTAB = 0
BEGIN
  IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF NEW.CODTAB <> 0 and OLD.CODTAB = 0 THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
     END IF;
     IF (Equal(OLD.ICMSES,NEW.ICMSES) <> 1 ) OR
        (Equal(OLD.ES_ATI,NEW.ES_ATI) <> 1 ) THEN
       UPDATE TT_IUF SET ATU_EM = AGORA() WHERE REDESP = NEW.CODTAB;
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3772 --*/
CREATE TRIGGER TGDIES
BEFORE UPDATE OR DELETE ON TD_IES 
FOR EACH ROW EXECUTE PROCEDURE TGDIES();



/*-- SEQ 3773 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDIME() CASCADE;

/*-- SEQ 3774 --*/
CREATE OR REPLACE FUNCTION TGDIME() RETURNS TRIGGER AS $$
-- Objetivo:
-- Impedir delete ou update do CODTAB = 0
BEGIN
  IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF NEW.CODTAB <> 0 and OLD.CODTAB = 0 THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
     END IF;
     IF (Equal(OLD.ICMSME,NEW.ICMSME) <> 1 ) OR
        (Equal(OLD.ME_ATI,NEW.ME_ATI) <> 1 ) THEN
       UPDATE TT_IUF SET ATU_EM = AGORA() WHERE REDUME = NEW.CODTAB;
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3775 --*/
CREATE TRIGGER TGDIME
BEFORE UPDATE OR DELETE ON TD_IME 
FOR EACH ROW EXECUTE PROCEDURE TGDIME();


/*-- SEQ 3776 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDIMG() CASCADE;

/*-- SEQ 3777 --*/
CREATE OR REPLACE FUNCTION TGDIMG() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir delete ou update do CODTAB = 0
-- 2) Atualizar TD_IND
DECLARE
   vComplemento                  VARCHAR(254) := Constante('complemento');
   TD_IND_OK                     VARCHAR(2);
BEGIN
   IF (TG_OP = 'DELETE') OR (TG_OP = 'UPDATE') THEN
      IF ((TG_OP = 'DELETE') AND OLD.CODTAB = 0) THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido. %' , vComplemento;
      ELSIF ((TG_OP = 'UPDATE') AND OLD.CODTAB = 0) THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser modificado. %' , vComplemento;
      END IF;
   END IF;

   IF (TG_OP = 'INSERT') THEN
      TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3778 --*/
CREATE TRIGGER TGDIMG
BEFORE UPDATE OR DELETE OR INSERT ON TD_IMG 
FOR EACH ROW EXECUTE PROCEDURE TGDIMG();

/*-- SEQ 3779 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDIMG2() CASCADE;

/*-- SEQ 3780 --*/
CREATE OR REPLACE FUNCTION TGDIMG2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3781 --*/
CREATE TRIGGER TGDIMG2
AFTER INSERT OR UPDATE OR DELETE ON TD_IMG 
FOR EACH ROW EXECUTE PROCEDURE TGDIMG2();



/*-- SEQ 3782 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDIND() CASCADE;

/*-- SEQ 3783 --*/
CREATE OR REPLACE FUNCTION TGDIND() RETURNS TRIGGER AS $$
-- Objetivo:
-- Impedir delete ou update do CODTAB = 0
BEGIN
  IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF NEW.CODTAB <> 0 and OLD.CODTAB = 0 THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
     END IF;
  END IF;
  IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
     NEW.ATU_EM := AGORA();
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3784 --*/
CREATE TRIGGER TGDIND
BEFORE INSERT OR UPDATE OR DELETE ON TD_IND 
FOR EACH ROW EXECUTE PROCEDURE TGDIND();


/*-- SEQ 3785 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDINS() CASCADE;

/*-- SEQ 3786 --*/
CREATE OR REPLACE FUNCTION TGDINS() RETURNS TRIGGER AS $$
-- Objetivos:
-- 1. Atualiza controles de data.
  
-- Principal
BEGIN
   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') THEN
      NEW.DATINC := Agora();
   END IF;
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3787 --*/
CREATE TRIGGER TGDINS
BEFORE INSERT OR UPDATE OR DELETE ON TD_INS 
FOR EACH ROW EXECUTE PROCEDURE TGDINS();

/*-- SEQ 3788 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDINS2() CASCADE;

/*-- SEQ 3789 --*/
CREATE OR REPLACE FUNCTION TGDINS2() RETURNS TRIGGER AS $$
-- Objetivos:
-- 1. Atualiza ATU_EM da TT_ATU de configuração
DECLARE
   cRetorno                      VARCHAR(2);
  
-- Principal
BEGIN
   
   cRetorno := AtualizaData('CONFIGURACAO',Agora());

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3790 --*/
CREATE TRIGGER TGDINS2
AFTER INSERT OR UPDATE OR DELETE ON TD_INS 
FOR EACH ROW EXECUTE PROCEDURE TGDINS2();


/*-- SEQ 3791 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDIPI() CASCADE;

/*-- SEQ 3792 --*/
CREATE OR REPLACE FUNCTION TGDIPI() RETURNS TRIGGER AS $$
-- Objetivo:
-- Impedir delete ou update do CODTAB = 0
BEGIN
  IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF NEW.CODTAB <> 0 and OLD.CODTAB = 0 THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
     END IF;
     UPDATE TT_PRO SET ATU_EM = AGORA() WHERE RESIPI = NEW.CODTAB;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3793 --*/
CREATE TRIGGER TGDIPI
BEFORE UPDATE OR DELETE ON TD_IPI 
FOR EACH ROW EXECUTE PROCEDURE TGDIPI();



/*-- SEQ 3794 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDIR1() CASCADE;

/*-- SEQ 3795 --*/
CREATE OR REPLACE FUNCTION TGDIR1() RETURNS TRIGGER AS $$
-- Objetivo:
-- Impedir delete ou update do CODTAB = 0
BEGIN
  IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF NEW.CODTAB <> 0 and OLD.CODTAB = 0 THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
     END IF;
     IF (Equal(OLD.R1_ATI,NEW.R1_ATI) <> 1 ) OR
        (Equal(OLD.ICMSR1,NEW.ICMSR1) <> 1 ) THEN
        UPDATE TT_IUF SET ATU_EM = AGORA() WHERE REDUC2 = NEW.CODTAB;
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3796 --*/
CREATE TRIGGER TGDIR1
BEFORE UPDATE OR DELETE ON TD_IR1 
FOR EACH ROW EXECUTE PROCEDURE TGDIR1();


/*-- SEQ 3797 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDIR2() CASCADE;

/*-- SEQ 3798 --*/
CREATE OR REPLACE FUNCTION TGDIR2() RETURNS TRIGGER AS $$
-- Objetivo:
-- Impedir delete ou update do CODTAB = 0
BEGIN
  IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF NEW.CODTAB <> 0 and OLD.CODTAB = 0 THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
     END IF;
     UPDATE TT_PRO SET ATU_EM = AGORA() WHERE RESIRR = NEW.CODTAB;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3799 --*/
CREATE TRIGGER TGDIR2
BEFORE UPDATE OR DELETE ON TD_IR2 
FOR EACH ROW EXECUTE PROCEDURE TGDIR2();


/*-- SEQ 3800 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDIRE() CASCADE;

/*-- SEQ 3801 --*/
CREATE OR REPLACE FUNCTION TGDIRE() RETURNS TRIGGER AS $$
-- Objetivo:
-- Impedir delete ou update do CODTAB = 0
BEGIN
  IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF NEW.CODTAB <> 0 and OLD.CODTAB = 0 THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
     END IF;
     IF (Equal(OLD.RE_ATI,NEW.RE_ATI) <> 1 ) OR
        (Equal(OLD.ICMSRE,NEW.ICMSRE) <> 1 ) OR
        (Equal(OLD.APLCON,NEW.APLCON) <> 1 ) OR
        (Equal(OLD.REDTRA,NEW.REDTRA) <> 1 ) OR
        (Equal(OLD.REDCON,NEW.REDCON) <> 1 ) THEN
        UPDATE TT_IUF SET ATU_EM = AGORA() WHERE REDALI = NEW.CODTAB;
     END IF;
  END IF;
  IF (TG_OP = 'INSERT') THEN
     IF NEW.REDCON IS NULL THEN
         NEW.REDCON := NEW.ICMSRE;
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3802 --*/
CREATE TRIGGER TGDIRE
BEFORE INSERT OR UPDATE OR DELETE ON TD_IRE 
FOR EACH ROW EXECUTE PROCEDURE TGDIRE();


/*-- SEQ 3803 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDIRR() CASCADE;

/*-- SEQ 3804 --*/
CREATE OR REPLACE FUNCTION TGDIRR() RETURNS TRIGGER AS $$
-- Objetivo:
-- Impedir delete ou update do CODTAB = 0
BEGIN
  IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF NEW.CODTAB <> 0 and OLD.CODTAB = 0 THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
     END IF;
     UPDATE TT_PRO SET ATU_EM = AGORA() WHERE RESIRR = NEW.CODTAB;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3805 --*/
CREATE TRIGGER TGDIRR
BEFORE UPDATE OR DELETE ON TD_IRR 
FOR EACH ROW EXECUTE PROCEDURE TGDIRR();


/*-- SEQ 3806 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDIS() CASCADE;

/*-- SEQ 3807 --*/
CREATE OR REPLACE FUNCTION TGDIS() RETURNS TRIGGER AS $$
DECLARE
  QuemLogou TRetQuemLogou%ROWTYPE;
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN:=ProximoCodigo('TT_DIS',NEW.CODFIL);
    END IF;
    -- preenche dados do usurio de registro
    select * into QuemLogou from DadosLogon();
    IF ((NEW.FILUSU IS NULL) AND (NEW.CODUSU IS NULL)) THEN
      NEW.FILUSU := QuemLogou.FILUSU;
      NEW.CODUSU := QuemLogou.CODUSU;
    END IF;
    NEW.DATOPE := agora();
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3808 --*/
CREATE TRIGGER TGDIS
BEFORE INSERT OR DELETE OR UPDATE ON TT_DIS 
FOR EACH ROW EXECUTE PROCEDURE TGDIS();


/*-- SEQ 3809 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDISO() CASCADE;

/*-- SEQ 3810 --*/
CREATE OR REPLACE FUNCTION TGDISO() RETURNS TRIGGER AS $$
DECLARE
  -- Objetivo:
  -- Atualizar TD_IND
  TD_IND_OK VARCHAR(2);
BEGIN
   IF (TG_OP = 'INSERT') THEN
     TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3811 --*/
CREATE TRIGGER TGDISO
BEFORE INSERT ON TD_ISO 
FOR EACH ROW EXECUTE PROCEDURE TGDISO();


/*-- SEQ 3812 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDISS() CASCADE;

/*-- SEQ 3813 --*/
CREATE OR REPLACE FUNCTION TGDISS() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Impedir delete ou update do CODTAB = 0

  --LEO 84337
  vCODUID_ATUAL VARCHAR(22);
  vBLQ_SEM_UID  TT_CFG.BLQ_SEM_UID%TYPE;
  vSESSIONID    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

BEGIN
  IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF NEW.CODTAB <> 0 and OLD.CODTAB = 0 THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
     END IF;
     UPDATE TT_IMU SET ATU_EM = AGORA() WHERE RESISS = NEW.CODTAB;
  END IF;
  
  IF (TG_OP = 'DELETE') THEN
    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
  END IF;
  
  -- Paulo : 83615
  IF (TG_OP = 'INSERT') THEN  

    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
  
    NEW.CODUID := GetCoduidAtual();	     
    NEW.ASSINA := COALESCE(AssinaTabela('TD_ISS', 
	                                    ConcatenaDISS(NEW.CODTAB,
                                                     NEW.RESISS),
                                                   null, null),NEW.ASSINA);
   END IF;
   
   -- Paulo : 83615
   IF (TG_OP = 'UPDATE') THEN 
      IF ConcatenaDISS(NEW.CODTAB,NEW.RESISS) <>
	     ConcatenaDISS(OLD.CODTAB,OLD.RESISS) THEN
		 
		 -- LEO 84337
         SELECT BLQ_SEM_UID
           INTO vBLQ_SEM_UID
           FROM TT_CFG;
         vCODUID_ATUAL := GetCoduidAtual();
         IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;
		 
         NEW.CODUID := GetCoduidAtual();	     
         NEW.ASSINA := COALESCE(AssinaTabela('TD_ISS', 
 	                                      ConcatenaDISS(NEW.CODTAB,
                                                       NEW.RESISS),
                                                    OLD.CODUID, 
	                                      ConcatenaDISS(OLD.CODTAB,
                                                       OLD.RESISS),
                                                   OLD.ASSINA
                                                  ),NEW.ASSINA);
	  END IF; 											  
   END IF; 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3814 --*/
CREATE TRIGGER TGDISS
BEFORE UPDATE OR DELETE ON TD_ISS 
FOR EACH ROW EXECUTE PROCEDURE TGDISS();

/*-- SEQ 3815 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDISS_ASS() CASCADE;

/*-- SEQ 3816 --*/
CREATE OR REPLACE FUNCTION TGDISS_ASS() RETURNS TRIGGER AS $$
-- 83615
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN

  IF ExisteFilialNaUF('SC') THEN
     IF (TG_OP = 'INSERT') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG + 1
        WHERE NOMTAB = 'TD_ISS';
     END IF;  
     
     IF (TG_OP = 'DELETE') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG - 1
        WHERE NOMTAB = 'TD_ISS';
     END IF;
  END IF;  

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3817 --*/
CREATE TRIGGER TGDISS_ASS
AFTER INSERT OR DELETE ON TD_ISS 
FOR EACH ROW EXECUTE PROCEDURE TGDISS_ASS();




/*-- SEQ 3818 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDIV2() CASCADE;

/*-- SEQ 3819 --*/
CREATE OR REPLACE FUNCTION TGDIV2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo
-- 2) Impedir a mudanca de um item de divisao se ele ja estiver sendo utilizado
DECLARE
   vComplemento                  CONSTANT VARCHAR(100) := Constante('complemento');
   vLinha                        INTEGER;
   cRet                          VARCHAR(2);
   BEGIN

   IF ((TG_OP = 'INSERT')) THEN
      IF NEW.CODITE IS NULL THEN
         NEW.CODITE := ProximoCodigo('TT_DIV','');
      END IF;
   END IF;

   IF (TG_OP = 'UPDATE') THEN
      IF (Equal(OLD.CODDIV,NEW.CODDIV) = 0) THEN
         -- Verifica se ja nao existe um item de grade utilizando este item de divisao
         SELECT COUNT(*) INTO vLinha FROM TT_GRA WHERE CODCOR = OLD.CODITE;

         -- Confirma se o codigo foi efetivamente mudado
         IF (OLD.CODDIV <> NEW.CODDIV) AND (vLinha > 0) THEN
            RAISE EXCEPTION 'PG-20004 Ha itens de grade vinculados ao item de divisao. %' , vComplemento;
         END IF;
      END IF;
   END IF;

   -- Default
   IF NEW.NOMEXT IS NULL THEN
      NEW.NOMEXT := NEW.NOMITE;
   END IF;    
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3820 --*/
CREATE TRIGGER TGDIV2
BEFORE INSERT OR UPDATE ON TT_DIV 
FOR EACH ROW EXECUTE PROCEDURE TGDIV2();

/*-- SEQ 3821 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDIV3() CASCADE;

/*-- SEQ 3822 --*/
CREATE OR REPLACE FUNCTION TGDIV3() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualizar tabela TT_PROxNOM
-- 2) Atualiza ATU_EM da TT_GRA
--
DECLARE
      cRetorno                      VARCHAR(2);
   cWhere                        TM_ATU.FILTRO%TYPE;
   nCODCOR                       TT_GRA.CODCOR%TYPE;
   
-- Principal
BEGIN
   --Atualiza TT_PROxNOM
   --davi - 21/11/06 - 41296
   IF ((TG_OP = 'UPDATE')) THEN
      IF (Equal(OLD.NOMITE,NEW.NOMITE) = 0) THEN
         
         cRetorno := PC_PROxNOM_Atualiza('IPR.CODCOR = '||NEW.CODITE, null, null, null, null );
                        END IF;
   END IF;
   
   --Tratamento para Atualizar Tabela Pai 
   IF (TG_OP = 'INSERT') THEN
      nCODCOR := NEW.CODITE;
   ELSIF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.NOMITE,NEW.NOMITE) <> 1
      OR Equal(OLD.NOMEXT,NEW.NOMEXT) <> 1
      OR Equal(OLD.CODDIV,NEW.CODDIV) <> 1
      OR Equal(OLD.CODEXT,NEW.CODEXT) <> 1
      OR Equal(OLD.ORDDIV,NEW.ORDDIV) <> 1
      OR Equal(OLD.NUMRGB,NEW.NUMRGB) <> 1
      OR Equal(OLD.IMAGEM,NEW.IMAGEM) <> 1 THEN
         nCODCOR := NEW.CODITE;
      ELSE
         nCODCOR := NULL;
      END IF;
   ELSIF (TG_OP = 'DELETE') THEN
      nCODCOR := OLD.CODITE;
   END IF;
   IF ISNOTNULL(TO_CHAR(nCODCOR))='T' THEN
      cWhere := 'CODCOR = ' || TO_CHAR(nCODCOR);
      cRetorno := INSERE_MATU('TT_DIV', 'TT_GRA', cWhere);  
   END IF; 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3823 --*/
CREATE TRIGGER TGDIV3
AFTER INSERT OR UPDATE OR DELETE ON TT_DIV 
FOR EACH ROW EXECUTE PROCEDURE TGDIV3();



/*-- SEQ 3824 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDIV_DW() CASCADE;

/*-- SEQ 3825 --*/
CREATE OR REPLACE FUNCTION TGDIV_DW() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Produto
DECLARE
      
   regDW                         RECORD;
      cDUMMY                        VARCHAR(2);
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');
BEGIN
  IF UsaVMDecisor() = 'T' THEN
     -- (TG_OP = 'INSERT'): No faz nada porque ainda no est relacionado a nenhum produto
     -- (TG_OP = 'DELETE'): Garantido pela FK
     IF (TG_OP = 'UPDATE') THEN
        IF Equal(OLD.CODITE,NEW.CODITE) <> 1 THEN -- PK
           RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
        END IF;
        IF Equal(OLD.NOMITE,NEW.NOMITE) <> 1 THEN
           FOR regDW IN (SELECT DISTINCT DW.FILMAT, DW.CODMAT, DW.CODCOR, DW.CODTAM
                           FROM DW_Produto DW
                          WHERE DW.CODCOR = OLD.CODITE)
           LOOP
              cDUMMY := Insere_DW_Log_Produto(regDW.FILMAT,regDW.CODMAT,regDW.CODCOR,regDW.CODTAM);
           END LOOP;
        END IF;
     END IF;
  END IF;   
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3826 --*/
CREATE TRIGGER TGDIV_DW
AFTER UPDATE ON TT_DIV 
FOR EACH ROW EXECUTE PROCEDURE TGDIV_DW();


/*-- SEQ 3827 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDLCR1() CASCADE;

/*-- SEQ 3828 --*/
CREATE OR REPLACE FUNCTION TGDLCR1() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1)  Atualizar TT_DOM e as tabelas de caracterizacao em caso de alteracao ou exclusao

vComplemento        VARCHAR(254) := constante('complemento');

-- Principal
BEGIN
  
  IF (TG_OP = 'DELETE') THEN
    DELETE FROM TT_DOM 
     WHERE CODARQ IN ('VCRP','VCRG','VCRC','VCRE')
       AND NOMCPO = 'CAMPO'||OLD.CODCRT
       AND DESDOM = OLD.DESLES;
  END IF; 

  IF (TG_OP = 'UPDATE') THEN 
    IF (Equal(OLD.CODCRT,NEW.CODCRT) = 0) THEN
      RAISE EXCEPTION 'PG-20010 No  permitido alterar o cdigo da lista de caracterizao. %' , vComplemento; 
    END IF;

    IF (Equal(OLD.DESLES,NEW.DESLES) = 0) THEN
      UPDATE TT_DOM
         SET DESDOM = NEW.DESLES,
             CODSTR = NEW.DESLES
       WHERE CODARQ IN ('VCRP','VCRG','VCRC','VCRE')
         AND NOMCPO = 'CAMPO'||OLD.CODCRT
         AND DESDOM = OLD.DESLES
         AND CODSTR = OLD.DESLES;

      UPDATE TT_CRTXPRO
         SET DESCRT = NEW.DESLES 
       WHERE DESCRT = OLD.DESLES 
         AND CODCRT = OLD.CODCRT;

      UPDATE TT_CRTXGRA
         SET DESCRT = NEW.DESLES 
       WHERE DESCRT = OLD.DESLES 
         AND CODCRT = OLD.CODCRT;

      UPDATE TT_CRTXCLI
         SET DESCRT = NEW.DESLES 
       WHERE DESCRT = OLD.DESLES 
         AND CODCRT = OLD.CODCRT;

      UPDATE TT_CRTXEND
         SET DESCRT = NEW.DESLES 
       WHERE DESCRT = OLD.DESLES 
         AND CODCRT = OLD.CODCRT;
    END IF;
  END IF; 
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3829 --*/
CREATE TRIGGER TGDLCR1
BEFORE UPDATE OR DELETE ON TD_LCR 
FOR EACH ROW EXECUTE PROCEDURE TGDLCR1();

/*-- SEQ 3830 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDLCR2() CASCADE;

/*-- SEQ 3831 --*/
CREATE OR REPLACE FUNCTION TGDLCR2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Registrar na tabela do Totall BI (TT_LAY) uma linha em TT_LAY para cada registro de TD_CRT

-- Principal

vAUX                VARCHAR(2);

BEGIN

   IF (TG_OP = 'INSERT') THEN 
     INSERT INTO TT_DOM 
     (CODARQ,NOMCPO,DESDOM,SEQUEN,CODSTR,CODINT,CODCHR) 
     (SELECT INT.* 
        FROM (SELECT 'VCR'||CRT.USODET AS CODARQ,
	                 'CAMPO'||CRT.CODTAB AS NOMCPO,
	                 LCR.DESLES AS DESDOM,
	                 LCR.ORDLIS*10 AS SEQUEN,
	                 LCR.DESLES AS CODSTR,
	                 0 AS CODINT,
	                 TO_CHAR(' ') AS CODCHR
			    FROM TD_LCR LCR INNER JOIN TD_CRT CRT ON LCR.CODCRT=CRT.CODTAB
			   WHERE CRT.USODET IN ('P','G','C','E')
			 ) INT LEFT JOIN TT_DOM DOM ON INT.CODARQ = DOM.CODARQ
                                       AND INT.NOMCPO = DOM.NOMCPO
                                       AND INT.DESDOM = DOM.DESDOM 
       WHERE DOM.DESDOM IS NULL);
   END IF; 

   IF (TG_OP = 'UPDATE') THEN
     UPDATE TT_IDF SET VERMET=TRUNC(VERMET)+MOD(VERMET+0.01,1);
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3832 --*/
CREATE TRIGGER TGDLCR2
AFTER INSERT OR UPDATE ON TD_LCR 
FOR STATEMENT EXECUTE PROCEDURE TGDLCR2();


/*-- SEQ 3833 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDMAR() CASCADE;

/*-- SEQ 3834 --*/
CREATE OR REPLACE FUNCTION TGDMAR() RETURNS TRIGGER AS $$
DECLARE
  -- Objetivo:
  -- Atualizar TD_IND
  TD_IND_OK VARCHAR(2);
BEGIN
   IF (TG_OP = 'INSERT') THEN
     TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3835 --*/
CREATE TRIGGER TGDMAR
BEFORE INSERT ON TD_MAR 
FOR EACH ROW EXECUTE PROCEDURE TGDMAR();


/*-- SEQ 3836 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDMDV1() CASCADE;

/*-- SEQ 3837 --*/
CREATE OR REPLACE FUNCTION TGDMDV1() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impedir excluses.
-- 2. Impedir atualizaes de registros internos.
-- 3. Atualizar TD_MDV.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');
   cRet                          VARCHAR(2);

-- Principal
BEGIN
   -- Impedir excluses.
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20000 Registro de uso interno. No pode ser excludo. %' , COMPLEMENTO;
   END IF;

   -- Impedir atualizaes de registros internos.
   IF (TG_OP = 'UPDATE') THEN
      IF NEW.CODTAB <= 0 THEN
         RAISE EXCEPTION 'PG-20001 Registro de uso interno. No pode ser modificado. %' , COMPLEMENTO;
      END IF;
      NEW.ATU_EM := AGORA();
   END IF;

   -- Atualizar TD_IND.
   IF (TG_OP = 'INSERT') THEN
      cRet := Atualiza_TD_IND(NEW.CODTAB);
      NEW.DATINC := AGORA();
      NEW.ATU_EM := AGORA();
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3838 --*/
CREATE TRIGGER TGDMDV1
BEFORE DELETE OR INSERT OR UPDATE ON TD_MDV 
FOR EACH ROW EXECUTE PROCEDURE TGDMDV1();


/*-- SEQ 3839 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDMED() CASCADE;

/*-- SEQ 3840 --*/
CREATE OR REPLACE FUNCTION TGDMED() RETURNS TRIGGER AS $$
-- Objetivo:
-- Impedir delete ou update do CODTAB = 0
DECLARE
  vCODUID_ATUAL                  VARCHAR(22);
  vBLQ_SEM_UID                   TT_CFG.BLQ_SEM_UID%TYPE;
  vSESSIONID                     TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

BEGIN
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF NEW.CODTAB <> 0 and OLD.CODTAB = 0 THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
      END IF;
   END IF;
   IF (TG_OP = 'INSERT') THEN
      IF NEW.DESMED IS NULL THEN
         NEW.DESMED := NEW.UNIMED;
      END IF;
   END IF;

   IF (TG_OP = 'DELETE') THEN
      SELECT BLQ_SEM_UID
        INTO vBLQ_SEM_UID
        FROM TT_CFG;
      vCODUID_ATUAL := GetCoduidAtual();
      IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;
   END IF;

   IF (TG_OP = 'INSERT') THEN
      SELECT BLQ_SEM_UID
        INTO vBLQ_SEM_UID
        FROM TT_CFG;
      vCODUID_ATUAL := GetCoduidAtual();
      IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;

      -- Douglas - 83441
      NEW.CODUID := GetCoduidAtual();
      NEW.ASSINA := COALESCE(AssinaTabela('TD_MED',
                                         ConcatenaDMED(NEW.CODTAB,
                                                       NEW.UNIMED),
                                                   null, null, null),NEW.ASSINA);
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF ConcatenaDMED(NEW.CODTAB,NEW.UNIMED) <>
         ConcatenaDMED(OLD.CODTAB,OLD.UNIMED) THEN

         -- LEO 84337
         SELECT BLQ_SEM_UID
           INTO vBLQ_SEM_UID
           FROM TT_CFG;
         vCODUID_ATUAL := GetCoduidAtual();
         IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;

         -- Douglas - 83441
         NEW.CODUID := GetCoduidAtual();
         NEW.ASSINA := COALESCE(AssinaTabela('TD_MED',
                                             ConcatenaDMED(NEW.CODTAB,
                                                           NEW.UNIMED),
                                                       OLD.CODUID,
                                             ConcatenaDMED(OLD.CODTAB,
                                                           OLD.UNIMED),
                                                      OLD.ASSINA
                                                     ),NEW.ASSINA);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3841 --*/
CREATE TRIGGER TGDMED
BEFORE UPDATE OR INSERT OR DELETE ON TD_MED 
FOR EACH ROW EXECUTE PROCEDURE TGDMED();

/*-- SEQ 3842 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDMED2() CASCADE;

/*-- SEQ 3843 --*/
CREATE OR REPLACE FUNCTION TGDMED2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_PRO
-- 2) Atualiza ATU_EM da TT_GRA
DECLARE
  cRetorno                       VARCHAR(2);
  cWhere                         TM_ATU.FILTRO%TYPE;
  nCODTAB                        TD_MED.CODTAB%TYPE;

BEGIN
   --Tratamento para Atualizar Tabela Pai
   IF (TG_OP = 'INSERT') THEN
      nCODTAB := NEW.CODTAB;
   ELSIF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1
      OR Equal(OLD.DESMED,NEW.DESMED) <> 1
      OR Equal(OLD.UNIMED,NEW.UNIMED) <> 1
      OR Equal(OLD.MEDATI,NEW.MEDATI) <> 1 THEN
         nCODTAB := NEW.CODTAB;
      ELSE
         nCODTAB := NULL;
      END IF;
   ELSIF (TG_OP = 'DELETE') THEN
      nCODTAB := OLD.CODTAB;
   END IF;

   IF ISNOTNULL(TO_CHAR(nCODTAB))='T' THEN
      cWhere := 'UNIDAD = ' || TO_CHAR(nCODTAB) || ' OR UNIFOR = ' || TO_CHAR(nCODTAB);
      cRetorno := INSERE_MATU('TD_MED', 'TT_PRO', cWhere);

      cWhere := 'UNIEMB = ' || TO_CHAR(nCODTAB) || ' OR UNIFOR = ' || TO_CHAR(nCODTAB) ||
                ' OR UNIAPL = ' || TO_CHAR(nCODTAB) || ' OR UNIDAD = ' || TO_CHAR(nCODTAB);
      cRetorno := INSERE_MATU('TD_MED', 'TT_GRA', cWhere);
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3844 --*/
CREATE TRIGGER TGDMED2
AFTER INSERT OR DELETE OR UPDATE ON TD_MED 
FOR EACH ROW EXECUTE PROCEDURE TGDMED2();

/*-- SEQ 3845 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDMED_ASS() CASCADE;

/*-- SEQ 3846 --*/
CREATE OR REPLACE FUNCTION TGDMED_ASS() RETURNS TRIGGER AS $$
-- 83073
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN

   IF ExisteFilialNaUF('SC') THEN
      IF (TG_OP = 'INSERT') THEN
         UPDATE TT_ASS
            SET QTDREG = QTDREG + 1
          WHERE NOMTAB = 'TD_MED';
      END IF;   
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3847 --*/
CREATE TRIGGER TGDMED_ASS
AFTER INSERT OR DELETE ON TD_MED 
FOR EACH ROW EXECUTE PROCEDURE TGDMED_ASS();


/*-- SEQ 3848 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDMOD() CASCADE;

/*-- SEQ 3849 --*/
CREATE OR REPLACE FUNCTION TGDMOD() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao

-- Declarao de variveis e cursores
   cRetorno                      VARCHAR(2);

-- Principal
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3850 --*/
CREATE TRIGGER TGDMOD
AFTER INSERT OR UPDATE OR DELETE ON TD_MOD 
FOR EACH ROW EXECUTE PROCEDURE TGDMOD();


/*-- SEQ 3851 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDMOE() CASCADE;

/*-- SEQ 3852 --*/
CREATE OR REPLACE FUNCTION TGDMOE() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir delete ou update do CODTAB = 0
-- 2) Atualizar TD_IND

DECLARE
   TD_IND_OK                     VARCHAR(2);
BEGIN
   IF (TG_OP = 'DELETE') THEN
      IF OLD.CODTAB = 0 THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
      END IF;   
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF NEW.CODTAB <> 0 AND OLD.CODTAB = 0 THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
      END IF;
   END IF;
   IF (TG_OP = 'INSERT') THEN
      TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
      NEW.DATINC := AGORA();
   END IF;
   IF NOT (TG_OP = 'DELETE') THEN
      NEW.ATU_EM := AGORA();
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3853 --*/
CREATE TRIGGER TGDMOE
BEFORE UPDATE OR DELETE OR INSERT ON TD_MOE 
FOR EACH ROW EXECUTE PROCEDURE TGDMOE();

/*-- SEQ 3854 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDMOE2() CASCADE;

/*-- SEQ 3855 --*/
CREATE OR REPLACE FUNCTION TGDMOE2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3856 --*/
CREATE TRIGGER TGDMOE2
AFTER INSERT OR UPDATE OR DELETE ON TD_MOE 
FOR EACH ROW EXECUTE PROCEDURE TGDMOE2();


/*-- SEQ 3857 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDMOT1() CASCADE;

/*-- SEQ 3858 --*/
CREATE OR REPLACE FUNCTION TGDMOT1() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impedir excluses.
-- 2. Impedir atualizaes de registros internos.
-- 3. Atualizar TD_MOT.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');
   cRet                          VARCHAR(2);

-- Principal
BEGIN
   -- Impedir excluses.
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20000 Registro de uso interno. No pode ser excludo. %' , COMPLEMENTO;
   END IF;

   -- Impedir atualizaes de registros internos.
   IF (TG_OP = 'UPDATE') THEN
      IF NEW.CODTAB <= 0 THEN
         RAISE EXCEPTION 'PG-20001 Registro de uso interno. No pode ser modificado. %' , COMPLEMENTO;
      END IF;
      NEW.ATU_EM := AGORA();
   END IF;

   -- Atualizar TD_IND.
   IF (TG_OP = 'INSERT') THEN
      cRet := Atualiza_TD_IND(NEW.CODTAB);
      NEW.DATINC := AGORA();
      NEW.ATU_EM := AGORA();
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3859 --*/
CREATE TRIGGER TGDMOT1
BEFORE DELETE OR INSERT OR UPDATE ON TD_MOT 
FOR EACH ROW EXECUTE PROCEDURE TGDMOT1();


/*-- SEQ 3860 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDMTD1() CASCADE;

/*-- SEQ 3861 --*/
CREATE OR REPLACE FUNCTION TGDMTD1() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impedir excluses.
-- 2. Impedir atualizaes de registros internos.
-- 3. Atualizar TD_MTD.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');
   cRet                          VARCHAR(2);

-- Principal
BEGIN
   -- Impedir excluses.
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20000 Registro de uso interno. No pode ser excludo. %' , COMPLEMENTO;
   END IF;

   -- Impedir atualizaes de registros internos.
   IF (TG_OP = 'UPDATE') THEN
      IF NEW.CODTAB <= 0 THEN
         RAISE EXCEPTION 'PG-20001 Registro de uso interno. No pode ser modificado. %' , COMPLEMENTO;
      END IF;
      NEW.ATU_EM := AGORA();
   END IF;

   -- Atualizar TD_IND.
   IF (TG_OP = 'INSERT') THEN
      cRet := Atualiza_TD_IND(NEW.CODTAB);
      NEW.DATINC := AGORA();
      NEW.ATU_EM := AGORA();
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3862 --*/
CREATE TRIGGER TGDMTD1
BEFORE DELETE OR INSERT OR UPDATE ON TD_MTD 
FOR EACH ROW EXECUTE PROCEDURE TGDMTD1();


/*-- SEQ 3863 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDMTDXDCORVEI1() CASCADE;

/*-- SEQ 3864 --*/
CREATE OR REPLACE FUNCTION TGDMTDXDCORVEI1() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impede excluso.
-- 2. Atualiza controles de data.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Impede excluso.
   /*IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20000 Registro no pode ser excludo. %' , COMPLEMENTO;
   END IF; */

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      NEW.DATINC := Agora();
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3865 --*/
CREATE TRIGGER TGDMTDXDCORVEI1
BEFORE INSERT OR UPDATE OR DELETE ON TT_DMTDXDCORVEI 
FOR EACH ROW EXECUTE PROCEDURE TGDMTDXDCORVEI1();


/*-- SEQ 3866 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDMUL() CASCADE;

/*-- SEQ 3867 --*/
CREATE OR REPLACE FUNCTION TGDMUL() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Atualizar TD_IND.
-- 2. Criar novos registros na TT_SAL.
-- 3. Criar novos registros na TT_SLT.

-- Declarao de variveis e cursores
   TD_IND_OK                     VARCHAR(2);
   vComplemento                  INTEGER := 1;

-- Incio da trigger
BEGIN
   IF (TG_OP = 'INSERT') THEN
      TD_IND_OK := Atualiza_TD_IND(NEW.CODTAB);
      IF NEW.MULATI = 'T' THEN
         INSERT INTO TT_SAL (CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,CODMUL,DUMMY)
            (SELECT /*+ INDEX(FIL,PK_DFIL) INDEX(GRA,PK_GRA)  */
                    FIL.CODFIL,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,NEW.CODTAB,vComplemento
               FROM TT_GRA GRA, TD_FIL FIL
              WHERE FIL.FILATI = 'T'
                AND NOT EXISTS (SELECT /*+ INDEX(SAL,AK_SAL)  */
                                       CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,CODMUL
                                  FROM TT_SAL SAL
                                 WHERE SAL.CODFIL = FIL.CODFIL
                                   AND SAL.CODMUL = NEW.CODTAB
                                   AND SAL.FILMAT = GRA.FILMAT
                                   AND SAL.CODMAT = GRA.CODMAT
                                   AND SAL.CODCOR = GRA.CODCOR
                                   AND SAL.CODTAM = GRA.CODTAM));

         -- RFMP 96855
         INSERT INTO TT_SLT (CODFIL, CODMUL, FILLOT, SEQLOT, QTDEST, RESERV)
            (SELECT /*+ INDEX(FIL,PK_DFIL) INDEX(LOT,PK_LOT)  */
                    FIL.CODFIL, NEW.CODTAB, LOT.CODFIL, LOT.SEQUEN, 0, 0
               FROM TT_LOT LOT, TD_FIL FIL
              WHERE FIL.FILATI = 'T'
                AND NOT EXISTS (SELECT /*+ INDEX(SLT,I_UQ_SLT)  */
                                       SLT.FILLOT, SLT.SEQLOT, SLT.CODFIL, SLT.CODMUL
                                  FROM TT_SLT SLT
                                 WHERE SLT.CODFIL = FIL.CODFIL
                                   AND SLT.CODMUL = NEW.CODTAB
                                   AND SLT.FILLOT = LOT.CODFIL
                                   AND SLT.SEQLOT = LOT.SEQUEN));

      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3868 --*/
CREATE TRIGGER TGDMUL
AFTER INSERT ON TD_MUL 
FOR EACH ROW EXECUTE PROCEDURE TGDMUL();

/*-- SEQ 3869 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDMUL2() CASCADE;

/*-- SEQ 3870 --*/
CREATE OR REPLACE FUNCTION TGDMUL2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3871 --*/
CREATE TRIGGER TGDMUL2
AFTER INSERT OR UPDATE OR DELETE ON TD_MUL 
FOR EACH ROW EXECUTE PROCEDURE TGDMUL2();


/*-- SEQ 3872 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDMVP() CASCADE;

/*-- SEQ 3873 --*/
CREATE OR REPLACE FUNCTION TGDMVP() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir delete ou update do CODTAB = 0
-- 2) Atualizar TD_IND
DECLARE
   vComplemento                  VARCHAR(254) := Constante('complemento');
   TD_IND_OK                     VARCHAR(2);
BEGIN
   IF (TG_OP = 'DELETE') OR (TG_OP = 'UPDATE') THEN
      IF ((TG_OP = 'DELETE')) THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido. %' , vComplemento;
      ELSIF ((TG_OP = 'UPDATE') and OLD.CODTAB = 0) THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser modificado. %' , vComplemento;
      END IF;
   END IF;
 
   IF (TG_OP = 'INSERT') THEN
      TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
   END IF;
   
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3874 --*/
CREATE TRIGGER TGDMVP
BEFORE UPDATE OR DELETE OR INSERT ON TD_MVP 
FOR EACH ROW EXECUTE PROCEDURE TGDMVP();

/*-- SEQ 3875 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDMVP2() CASCADE;

/*-- SEQ 3876 --*/
CREATE OR REPLACE FUNCTION TGDMVP2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3877 --*/
CREATE TRIGGER TGDMVP2
AFTER INSERT OR UPDATE OR DELETE ON TD_MVP 
FOR EACH ROW EXECUTE PROCEDURE TGDMVP2();


/*-- SEQ 3878 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDNAT1() CASCADE;

/*-- SEQ 3879 --*/
CREATE OR REPLACE FUNCTION TGDNAT1() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Manter um limite de itens
-- 2) Atualizar TD_IND
DECLARE
   vLimite                       CONSTANT Numeric        := Constante('limite');
   vComplemento                  CONSTANT VARCHAR(100) := Constante('complemento');
   vQtd                          Numeric;
   WK_SEQEXC                     TD_NAT.SEQEXC%TYPE;
   TD_IND_OK                     VARCHAR(2);
BEGIN
   SELECT COUNT(*) INTO vQtd FROM TD_NAT;
   IF (vQtd > vLimite) then
      RAISE EXCEPTION 'PG-20007 Quantidade de registros atingida. Nao pode haver mais inclusoes. %' , vComplemento;
   END IF;
   IF ((TG_OP = 'INSERT')) THEN
      --Este sequenciador foi criado para ser usado no processo de integrao da Marcolino Madeiras
      SELECT LPAD(TRIM(TO_CHAR(NEXTVAL('SQDNATEXC'))),10,' ') INTO WK_SEQEXC FROM DUAL;
      NEW.SEQEXC := WK_SEQEXC; 

      TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );

   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3880 --*/
CREATE TRIGGER TGDNAT1
BEFORE INSERT ON TD_NAT 
FOR EACH ROW EXECUTE PROCEDURE TGDNAT1();


/*-- SEQ 3881 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDNAT2() CASCADE;

/*-- SEQ 3882 --*/
CREATE OR REPLACE FUNCTION TGDNAT2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Checando exclusividade das naturezas
-- 2) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   vComplemento                  CONSTANT VARCHAR(100) := Constante('complemento');
   vQtd                          Numeric;
   cRetorno                      VARCHAR(2);
BEGIN
   IF (TG_OP = 'INSERT') 
   OR (TG_OP = 'UPDATE') THEN
      BEGIN  
         SELECT COUNT(*) INTO vQtd FROM TD_NAT
          WHERE NATFOR IN (SELECT NATFUD FROM TD_NAT)
             OR NATFUD IN (SELECT NATFOR FROM TD_NAT);
       
      END;        
      IF (COALESCE(vQtd,0) > 0) then
         RAISE EXCEPTION 'PG-20008 Nao pode haver "Natureza de Vinculo Futuro para DENTRO do Estado" IGUAL a "Natureza de Venda para FORA do Estado". %' , vComplemento;
      END IF; 
   END IF;
   
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
   
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3883 --*/
CREATE TRIGGER TGDNAT2
AFTER INSERT OR UPDATE OR DELETE ON TD_NAT 
FOR STATEMENT EXECUTE PROCEDURE TGDNAT2();


/*-- SEQ 3884 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDNIV1() CASCADE;

/*-- SEQ 3885 --*/
CREATE OR REPLACE FUNCTION TGDNIV1() RETURNS TRIGGER AS $$
DECLARE
  -- Objetivo:
  -- 1) Impedir delete ou update do CODTAB = 0
  -- 2) Atualizar TD_IND
 
  vComplemento VARCHAR(254);
  TD_IND_OK VARCHAR(2);
BEGIN
  vComplemento := constante('complemento');
 
  -- Impede exclusões
  IF (TG_OP = 'DELETE') OR (TG_OP = 'UPDATE') THEN
     IF (TG_OP = 'DELETE') THEN
        RAISE EXCEPTION 'PG-20001 Registro de uso interno. Nao pode ser excluido. %' , vComplemento;
     ELSIF ((TG_OP = 'UPDATE') and NEW.CODTAB <> 0 and OLD.CODTAB = 0) THEN
        RAISE EXCEPTION 'PG-20002 Registro de uso interno. Nao pode ser modificado. %' , vComplemento;
     END IF;
  END IF;
 
  IF (TG_OP = 'INSERT') THEN
    TD_IND_OK := Atualiza_TD_IND(NEW.CODTAB);
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3886 --*/
CREATE TRIGGER TGDNIV1
BEFORE UPDATE OR DELETE OR INSERT ON TD_NIV 
FOR EACH ROW EXECUTE PROCEDURE TGDNIV1();


/*-- SEQ 3887 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDOBS() CASCADE;

/*-- SEQ 3888 --*/
CREATE OR REPLACE FUNCTION TGDOBS() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualizar TD_IND
DECLARE
   TD_IND_OK                     VARCHAR(2);
BEGIN
   IF (TG_OP = 'INSERT') THEN
      TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3889 --*/
CREATE TRIGGER TGDOBS
BEFORE INSERT ON TD_OBS 
FOR EACH ROW EXECUTE PROCEDURE TGDOBS();

/*-- SEQ 3890 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDOBS2() CASCADE;

/*-- SEQ 3891 --*/
CREATE OR REPLACE FUNCTION TGDOBS2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3892 --*/
CREATE TRIGGER TGDOBS2
AFTER INSERT OR UPDATE OR DELETE ON TD_OBS 
FOR EACH ROW EXECUTE PROCEDURE TGDOBS2();


/*-- SEQ 3893 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDOCU_DW() CASCADE;

/*-- SEQ 3894 --*/
CREATE OR REPLACE FUNCTION TGDOCU_DW() RETURNS TRIGGER AS $$
DECLARE
  vComplemento  CONSTANT VARCHAR(100) := Constante('Complemento');

-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Vendas_Cliente

BEGIN
  -- (TG_OP = 'INSERT'): No faz nada porque no est relacionado a nenhum registro pai
  -- (TG_OP = 'DELETE'): Garantido pela FK
  IF (TG_OP = 'UPDATE') THEN
    IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1 --PK
    THEN
      RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
    END IF;
    IF Equal(OLD.DESOCU,NEW.DESOCU) <> 1 THEN
      UPDATE DW_Vendas_Cliente
         SET Profissao   = InitCap(NEW.DESOCU)
       WHERE OCU_CODTAB  = OLD.CODTAB;
    END IF;
  END IF;      
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3895 --*/
CREATE TRIGGER TGDOCU_DW
AFTER UPDATE ON TD_OCU 
FOR EACH ROW EXECUTE PROCEDURE TGDOCU_DW();


/*-- SEQ 3896 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDOE() CASCADE;

/*-- SEQ 3897 --*/
CREATE OR REPLACE FUNCTION TGDOE() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar codigo sequencial exclusivo
DECLARE
-- Principal
BEGIN
   -- Gera codigo sequencial exclusivo
   IF (TG_OP = 'INSERT') THEN
     IF (NEW.SEQUEN IS NULL) THEN
       NEW.SEQUEN:=ProximoCodigo('TT_DOE',NEW.CODFIL);
     END IF;
   END IF;

   -- Default
   NEW.ATU_EM := agora();
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3898 --*/
CREATE TRIGGER TGDOE
BEFORE INSERT OR UPDATE ON TT_DOE 
FOR EACH ROW EXECUTE PROCEDURE TGDOE();


/*-- SEQ 3899 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDOM() CASCADE;

/*-- SEQ 3900 --*/
CREATE OR REPLACE FUNCTION TGDOM() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TT_DOM','001');
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3901 --*/
CREATE TRIGGER TGDOM
BEFORE INSERT ON TT_DOM 
FOR EACH ROW EXECUTE PROCEDURE TGDOM();


/*-- SEQ 3902 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDOMI() CASCADE;

/*-- SEQ 3903 --*/
CREATE OR REPLACE FUNCTION TGDOMI() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impedir excluses.
-- 2. Impedir atualizaes de registros internos.
-- 3. Atualizar TD_IND.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');
   cRet                          VARCHAR(2);

-- Principal
BEGIN
   -- Impedir excluses.
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20000 Registro de uso interno. No pode ser excludo. %' , COMPLEMENTO;
   END IF;

   -- Impedir atualizaes de registros internos.
   IF (TG_OP = 'UPDATE') THEN
      IF NEW.CODTAB <= 0 THEN
         RAISE EXCEPTION 'PG-20001 Registro de uso interno. No pode ser modificado. %' , COMPLEMENTO;
      END IF;
   END IF;

   -- Atualizar TD_IND.
   IF (TG_OP = 'INSERT') THEN
      cRet := Atualiza_TD_IND(NEW.CODTAB);
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3904 --*/
CREATE TRIGGER TGDOMI
BEFORE DELETE OR INSERT OR UPDATE ON TD_OMI 
FOR EACH ROW EXECUTE PROCEDURE TGDOMI();

/*-- SEQ 3905 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDOMI2() CASCADE;

/*-- SEQ 3906 --*/
CREATE OR REPLACE FUNCTION TGDOMI2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO', Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3907 --*/
CREATE TRIGGER TGDOMI2
AFTER INSERT OR UPDATE OR DELETE ON TD_OMI 
FOR EACH ROW EXECUTE PROCEDURE TGDOMI2();




/*-- SEQ 3908 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDOP2() CASCADE;

/*-- SEQ 3909 --*/
CREATE OR REPLACE FUNCTION TGDOP2() RETURNS TRIGGER AS $$
DECLARE
  -- Objetivo:
  -- 1) Impedir exclusoes
  -- 2) Gerar um codigo sequencial exclusivo para compor a chave primaria
  -- 3) Impedir mudancas se o status for de cancelado
  -- 4) Estornar os pagamentos
  -- 5) Registrar o log das mudancas

  OBS    TL_DOP.MSGLOG%TYPE;
  inRec  TT_DOP%ROWTYPE;
  inLog  TL_DOP%ROWTYPE;
  CRLF   CONSTANT CHAR(2) := CHR(10);
  Nulo   CONSTANT CHAR(1) := '0';
  vComplemento CONSTANT VARCHAR(100) := constante('complemento');
  cDummy VARCHAR(10);
  nPode  INTEGER;
  WK_SEQEXC TT_DOP.SEQEXC%TYPE;

-- Principal
BEGIN
  NEW.DUMMY := NULL;

  IF ((TG_OP = 'DELETE')) THEN
     RAISE EXCEPTION 'PG-20001 Nao e permitido excluir um documento. %' , vComplemento;
  END IF;

  IF ((TG_OP = 'INSERT')) THEN
     -- Gera codigo sequencial exclusivo
     IF (NEW.SEQUEN IS NULL) THEN
        NEW.SEQUEN := ProximoCodigo('TT_DOP',NEW.CODFIL);
     END IF;
     NEW.DATINC := AGORA();
     --Este sequenciador foi criado para ser usado no processo de integrao da Marcolino Madeiras
     SELECT LPAD(TRIM(TO_CHAR(NEXTVAL('SQDOPEXC'))),10,' ') INTO WK_SEQEXC FROM DUAL;
     NEW.SEQEXC := WK_SEQEXC;
  END IF;

  IF ((TG_OP = 'UPDATE')) THEN
     -- Impede mudancas na chave primaria
     IF (OLD.CODFIL <> NEW.CODFIL)
     or (OLD.SEQUEN <> NEW.SEQUEN) THEN
        RAISE EXCEPTION 'PG-20002 Nao e permitido modificar a chave primaria desta tabela. %' , vComplemento;
     END IF;

     -- Impede mudar a data de pagamento
     IF (OLD.DATPGT) <> (NEW.DATPGT) THEN

        SELECT COUNT(FLGFLX) INTO nPode
          FROM TD_STD
         WHERE CODTAB = OLD.STDDOP
           AND DOMDOP = OLD.DOMDOP
           AND USOSTD = OLD.FLGEST
           AND FLGFLX = 'A';

        IF (nPode = 0) THEN
          RAISE EXCEPTION 'PG-20004 Nao e permitido modificar a data de pagamento. %' , vComplemento;
        END IF;
     END IF;

     -- Impede mudar o usuario que lancou o documento de pagamento
     IF (OLD.FILUSU) <> (NEW.FILUSU)
     OR (OLD.CODUSU) <> (NEW.CODUSU) THEN
        RAISE EXCEPTION 'PG-20005 Usuario que registrou o documento nao pode ser modificado. %' , vComplemento;
     END IF;

     -- Impede incremento de impressao maior do que 1
     IF ABS(OLD.NUMIMP) != ABS(NEW.NUMIMP) THEN
        IF ABS(OLD.NUMIMP) + 1 != ABS(NEW.NUMIMP) THEN
           RAISE EXCEPTION 'PG-20006 Numero da impressao nao e o esperado. %' , vComplemento;
        END IF;
     END IF;


     -- Impede mudancas nas demais colunas se o status for cancelado
     IF (OLD.FLGEST = 'C') THEN
        IF (OLD.ATU_EM <> NEW.ATU_EM)
        or (OLD.FLGEST <> NEW.FLGEST)
        or (OLD.DOMDOP <> NEW.DOMDOP)
        or (OLD.VLRDOC <> NEW.VLRDOC)
        or (OLD.FILCTA <> NEW.FILCTA)
        or (OLD.SEQCTA <> NEW.SEQCTA)
        or (OLD.TIPCTA <> NEW.TIPCTA)
        or (OLD.OBSERV <> NEW.OBSERV)
        or (OLD.NUMDOC <> NEW.NUMDOC)
        or (OLD.NUMIMP <> NEW.NUMIMP) THEN
           RAISE EXCEPTION 'PG-20003 Nao e permitido modicar os dados de um documento cancelado. %' , vComplemento;
        END IF;
     END IF;

     -- Utilizando o package...

             -- Manda estornar as parcelas
        IF (OLD.FLGEST = 'A') and (NEW.FLGEST = 'C') THEN
           inRec.CODFIL := NEW.CODFIL;
           inRec.SEQUEN := NEW.SEQUEN;
           inRec.FLGEST := NEW.FLGEST;

                      
            NEW.DUMMY := 'A' ;
            -- cDummy := PC_DOP_AtualizePAG(inRec.CODFIL, inRec.SEQUEN,inRec.FLGEST);
           
        END IF;

        -- Inclui dados para log se necessario
        Obs := '';
        IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
           Obs := Obs || 'Status: de '||COALESCE(OLD.FLGEST,Nulo)||' para '||COALESCE(NEW.FLGEST,Nulo)||CRLF;
        END IF;
        IF Equal(OLD.DOMDOP,NEW.DOMDOP) <> 1 THEN
           Obs := Obs || 'Tipo: de '||COALESCE(OLD.DOMDOP,0)||' para '||COALESCE(NEW.DOMDOP,0)||CRLF;
        END IF;
        IF Equal(OLD.STDDOP,NEW.STDDOP) <> 1 THEN
           Obs := Obs || 'Situacao: de '||COALESCE(OLD.STDDOP,0)||' para '||COALESCE(NEW.STDDOP,0)||CRLF;
        END IF;
        IF Equal(OLD.VLRDOC,NEW.VLRDOC) <> 1 THEN
           Obs := Obs || 'Valor: de '||TO_CHAR(COALESCE(OLD.VLRDOC,0),'fm9G999G999G990D00')||' para '||TO_CHAR(COALESCE(NEW.VLRDOC,0),'fm9G999G999G990D00')||CRLF;
        END IF;
        IF Equal(OLD.FILCTA,NEW.FILCTA) <> 1 OR Equal(OLD.SEQCTA,NEW.SEQCTA) <> 1 THEN
           Obs := Obs || 'Conta numeraria: de '||COALESCE(OLD.FILCTA,Nulo||'/')||COALESCE(OLD.SEQCTA,Nulo)||' para '||COALESCE(NEW.FILCTA,Nulo||'/')||COALESCE(NEW.SEQCTA,Nulo)||CRLF;
        END IF;
        IF Equal(OLD.NUMDOC,NEW.NUMDOC) <> 1 THEN
           Obs := Obs || 'Documento: de '||COALESCE(OLD.NUMDOC,Nulo)||' para '||COALESCE(NEW.NUMDOC,Nulo)||CRLF;
        END IF;
        IF Equal(OLD.NUMIMP,NEW.NUMIMP) <> 1 THEN
           Obs := Obs || 'Impressao: de '||TO_CHAR(COALESCE(OLD.NUMIMP,0),'99')||' para '||TO_CHAR(COALESCE(NEW.NUMIMP,0),'99')||CRLF;
        END IF;
        IF Equal(OLD.DATPGT,NEW.DATPGT) <> 1 THEN
           Obs := Obs || 'Data pagamento: de '||TO_CHAR(OLD.DATPGT,'DD/MM/YYYY HH24:MI:SS')||' para '||TO_CHAR(NEW.DATPGT,'DD/MM/YYYY HH24:MI:SS')||CRLF;
        END IF;
        IF Equal(OLD.DATTRA,NEW.DATTRA) <> 1 THEN
           Obs := Obs || 'Data Transmisso: de '||TO_CHAR(OLD.DATTRA,'DD/MM/YYYY HH24:MI:SS')||' para '||TO_CHAR(NEW.DATTRA,'DD/MM/YYYY HH24:MI:SS')||CRLF;
        END IF;
        IF Equal(OLD.DATRET,NEW.DATRET) <> 1 THEN
           Obs := Obs || 'Data Retorno: de '||TO_CHAR(OLD.DATRET,'DD/MM/YYYY HH24:MI:SS')||' para '||TO_CHAR(NEW.DATRET,'DD/MM/YYYY HH24:MI:SS')||CRLF;
        END IF;
        IF Equal(OLD.FILCBP,NEW.FILCBP) <> 1 OR Equal(OLD.SEQCBP,NEW.SEQCBP) <> 1 THEN
           Obs := Obs || 'Conta Bancria do Parceiro: de '||COALESCE(OLD.FILCBP,Nulo||'/')||COALESCE(OLD.SEQCBP,Nulo)||' para '||COALESCE(NEW.FILCBP,Nulo||'/')||COALESCE(NEW.SEQCBP,Nulo)||CRLF;
        END IF;
        IF Equal(OLD.CODBAR,NEW.CODBAR) <> 1 THEN
           Obs := Obs || 'Cdigo de Barras ou Linha Digitvel: de '||COALESCE(OLD.CODBAR,Nulo)||' para '||COALESCE(NEW.CODBAR,Nulo)||CRLF;
        END IF;
        IF Equal(OLD.TIPTED,NEW.TIPTED) <> 1 THEN
           Obs := Obs || 'Finalidade DOC/TED: de '||COALESCE(OLD.TIPTED,0)||' para '||COALESCE(NEW.TIPTED,0)||CRLF;
        END IF;
        IF Equal(OLD.NUMREM,NEW.NUMREM) <> 1 THEN
           Obs := Obs || 'Nmero Remessa: de '||COALESCE(OLD.NUMREM,0)||' para '||COALESCE(NEW.NUMREM,0)||CRLF;
        END IF;
        IF Equal(OLD.CODEXT,NEW.CODEXT) <> 1 THEN
           Obs := Obs || 'Cd Externo: de '||COALESCE(OLD.CODEXT,Nulo)||' para '||COALESCE(NEW.CODEXT,Nulo)||CRLF;
        END IF;

        IF ISNOTNULL(OBS) = 'T' THEN
           inLog.FILDOP := NEW.CODFIL;
           inLog.SEQDOP := NEW.SEQUEN;
           inLog.MSGLOG := OBS;

                      
             cDummy := PC_DOP_AtualizeLDOP(inLog.FILDOP,inLog.SEQDOP,inLog.MSGLOG);
           
       END IF;
     
     -- Desconsidera mudancas no usuario
     NEW.FILUSU := OLD.FILUSU;
     NEW.CODUSU := OLD.CODUSU;

  END IF;

  -- Default
  NEW.ATU_EM := agora();
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3910 --*/
CREATE TRIGGER TGDOP2
BEFORE INSERT OR DELETE OR UPDATE ON TT_DOP 
FOR EACH ROW EXECUTE PROCEDURE TGDOP2();


/*-- SEQ 3911 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDOP4() CASCADE;

/*-- SEQ 3912 --*/
CREATE OR REPLACE FUNCTION TGDOP4() RETURNS TRIGGER AS $$
DECLARE
  -- Objetivo:
  cDummy VARCHAR(10);

-- Principal
BEGIN

  -- DN 45679 - Tabelas Financeiras
  IF (TG_OP = 'INSERT') THEN
     cDUMMY:=INSERE_LFIN_LAN('DOP',NEW.CODFIL,NEW.SEQUEN,'--','--');
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF (Equal(OLD.FLGEST,NEW.FLGEST) <> 1) OR
        (Equal(OLD.DATPGT,NEW.DATPGT) <> 1) OR
        (Equal(OLD.FILCTA,NEW.FILCTA) <> 1) OR
        (Equal(OLD.SEQCTA,NEW.SEQCTA) <> 1) OR
        (Equal(OLD.NUMIMP,NEW.NUMIMP) <> 1) OR
        (Equal(OLD.VLRDOC,NEW.VLRDOC) <> 1) OR
        (Equal(OLD.DATINC,NEW.DATINC) <> 1) OR
        (Equal(OLD.FILCLI,NEW.FILCLI) <> 1) OR
        (Equal(OLD.CODCLI,NEW.CODCLI) <> 1) OR
        (Equal(OLD.DOMDOP,NEW.DOMDOP) <> 1) OR
        (Equal(OLD.PORORI,NEW.PORORI) <> 1) OR
        (Equal(OLD.STDDOP,NEW.STDDOP) <> 1) THEN
        cDUMMY:=INSERE_LFIN_LAN('DOP',NEW.CODFIL,NEW.SEQUEN,'--','--');
     END IF;
  END IF;
  -- DN 45679 - Fim Tabelas Financeiras

  IF ((TG_OP = 'UPDATE')) THEN
      -- Manda estornar as parcelas

      IF (NEW.DUMMY = 'A') and (NEW.FLGEST = 'C') THEN
         cDummy := PC_DOP_AtualizePAG(NEW.CODFIL, NEW.SEQUEN,new.FLGEST);
      END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3913 --*/
CREATE TRIGGER TGDOP4
AFTER INSERT OR DELETE OR UPDATE ON TT_DOP 
FOR EACH ROW EXECUTE PROCEDURE TGDOP4();





/*-- SEQ 3914 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDOU() CASCADE;

/*-- SEQ 3915 --*/
CREATE OR REPLACE FUNCTION TGDOU() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Atulizar Data

-- Principal
BEGIN
   -- Gera um codigo automaticamente
   IF (TG_OP = 'INSERT') THEN 
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN:=ProximoCodigo('TT_DOU',NEW.CODFIL);
      END IF;
   END IF;

   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3916 --*/
CREATE TRIGGER TGDOU
BEFORE INSERT OR UPDATE ON TT_DOU 
FOR EACH ROW EXECUTE PROCEDURE TGDOU();

/*-- SEQ 3917 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDOU2() CASCADE;

/*-- SEQ 3918 --*/
CREATE OR REPLACE FUNCTION TGDOU2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3919 --*/
CREATE TRIGGER TGDOU2
AFTER INSERT OR UPDATE OR DELETE ON TT_DOU 
FOR EACH ROW EXECUTE PROCEDURE TGDOU2();


/*-- SEQ 3920 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDOUT() CASCADE;

/*-- SEQ 3921 --*/
CREATE OR REPLACE FUNCTION TGDOUT() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Manter um limite de itens
DECLARE
   vLimite                       CONSTANT Numeric := Constante('limite');
   vQtd                          Numeric;
BEGIN
   SELECT COUNT(*) INTO vQtd FROM TD_OUT;
   IF (vQtd > vLimite) then
      RAISE EXCEPTION 'PG-20007 Quantidade de registros atingida. Nao pode haver mais inclusoes';
   END IF;    
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3922 --*/
CREATE TRIGGER TGDOUT
BEFORE INSERT ON TD_OUT 
FOR STATEMENT EXECUTE PROCEDURE TGDOUT();

/*-- SEQ 3923 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDOUT2() CASCADE;

/*-- SEQ 3924 --*/
CREATE OR REPLACE FUNCTION TGDOUT2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualizar TD_IND
DECLARE
   TD_IND_OK                     VARCHAR(2);
BEGIN
   IF (TG_OP = 'INSERT') THEN
      TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
      NEW.DATINC := AGORA();
   END IF;
   IF NOT (TG_OP = 'DELETE') THEN
      NEW.ATU_EM := AGORA();
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1 THEN -- RFMP 68895
         RAISE EXCEPTION 'PG-20005 No  permitido alterar a chave primria da tabela';
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3925 --*/
CREATE TRIGGER TGDOUT2
BEFORE INSERT OR UPDATE ON TD_OUT 
FOR EACH ROW EXECUTE PROCEDURE TGDOUT2();

/*-- SEQ 3926 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDOUT3() CASCADE;

/*-- SEQ 3927 --*/
CREATE OR REPLACE FUNCTION TGDOUT3() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3928 --*/
CREATE TRIGGER TGDOUT3
AFTER INSERT OR UPDATE OR DELETE ON TD_OUT 
FOR EACH ROW EXECUTE PROCEDURE TGDOUT3();

/*-- SEQ 3929 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDOUT_DW() CASCADE;

/*-- SEQ 3930 --*/
CREATE OR REPLACE FUNCTION TGDOUT_DW() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Vendas_Meio
DECLARE
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');
BEGIN
   -- (TG_OP = 'INSERT'): no faz nada porque ainda no est em nenhuma venda
   -- (TG_OP = 'DELETE'): garantido por FK
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1 THEN -- PK
         RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
      END IF;
      IF Equal(OLD.DESCAR,NEW.DESCAR) <> 1 THEN
         UPDATE DW_Vendas_Meio
            SET MEIO        = InitCap(NEW.DESCAR)
          WHERE DOUT_CODTAB = OLD.CODTAB;
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3931 --*/
CREATE TRIGGER TGDOUT_DW
AFTER UPDATE ON TD_OUT 
FOR EACH ROW EXECUTE PROCEDURE TGDOUT_DW();


/*-- SEQ 3932 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDOW() CASCADE;

/*-- SEQ 3933 --*/
CREATE OR REPLACE FUNCTION TGDOW() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.SEQDOW IS NULL THEN
      NEW.SEQDOW:=ProximoCodigo('TT_DOW',NULL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3934 --*/
CREATE TRIGGER TGDOW
BEFORE INSERT ON TT_DOW 
FOR EACH ROW EXECUTE PROCEDURE TGDOW();



/*-- SEQ 3935 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDPAI() CASCADE;

/*-- SEQ 3936 --*/
CREATE OR REPLACE FUNCTION TGDPAI() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Trata dados padroes na inclusao 

-- Principal
BEGIN
   IF (TG_OP = 'INSERT') THEN
      NEW.ATU_EM := AGORA(); 
   END IF;
   IF (TG_OP = 'UPDATE') THEN     
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser modificado.'; 
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3937 --*/
CREATE TRIGGER TGDPAI
BEFORE INSERT OR UPDATE ON TD_PAI 
FOR EACH ROW EXECUTE PROCEDURE TGDPAI();

/*-- SEQ 3938 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDPAI2() CASCADE;

/*-- SEQ 3939 --*/
CREATE OR REPLACE FUNCTION TGDPAI2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3940 --*/
CREATE TRIGGER TGDPAI2
AFTER INSERT OR UPDATE OR DELETE ON TD_PAI 
FOR EACH ROW EXECUTE PROCEDURE TGDPAI2();


/*-- SEQ 3941 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDPER() CASCADE;

/*-- SEQ 3942 --*/
CREATE OR REPLACE FUNCTION TGDPER() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impedir excluses.
-- 2. Impedir atualizaes de registros internos.
-- 3. Atualizar TD_IND.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');
   cRet                          VARCHAR(2);

-- Principal
BEGIN
   -- Impedir excluses.
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20000 Registro de uso interno. No pode ser excludo. %' , COMPLEMENTO;
   END IF;

   -- Impedir atualizaes de registros internos.
   IF (TG_OP = 'UPDATE') THEN
      IF NEW.CODTAB <= 0 THEN
         RAISE EXCEPTION 'PG-20001 Registro de uso interno. No pode ser modificado. %' , COMPLEMENTO;
      END IF;
   END IF;

   -- Atualizar TD_IND.
   IF (TG_OP = 'INSERT') THEN
      cRet := Atualiza_TD_IND(NEW.CODTAB);
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3943 --*/
CREATE TRIGGER TGDPER
BEFORE DELETE OR INSERT OR UPDATE ON TD_PER 
FOR EACH ROW EXECUTE PROCEDURE TGDPER();

/*-- SEQ 3944 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDPER2() CASCADE;

/*-- SEQ 3945 --*/
CREATE OR REPLACE FUNCTION TGDPER2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao

-- Declarao de variveis e cursores
   cRetorno                      VARCHAR(2);

   -- Principal
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO', Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3946 --*/
CREATE TRIGGER TGDPER2
AFTER INSERT OR UPDATE OR DELETE ON TD_PER 
FOR EACH ROW EXECUTE PROCEDURE TGDPER2();


/*-- SEQ 3947 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDPES() CASCADE;

/*-- SEQ 3948 --*/
CREATE OR REPLACE FUNCTION TGDPES() RETURNS TRIGGER AS $$
DECLARE
  -- Objetivo:
  -- 1) Impedir delete ou update do CODTAB = 0
  -- 2) Atualizar TD_IND
 
  vComplemento VARCHAR(254);
  TD_IND_OK VARCHAR(2);
BEGIN
  vComplemento := constante('complemento');
 
  -- Impede exclusões
  IF (TG_OP = 'DELETE') OR (TG_OP = 'UPDATE') THEN
     IF (TG_OP = 'DELETE') THEN
        RAISE EXCEPTION 'PG-20001 Registro de uso interno. Nao pode ser excluido. %' , vComplemento;
     ELSIF ((TG_OP = 'UPDATE') and NEW.CODTAB <> 0 and OLD.CODTAB = 0) THEN
        RAISE EXCEPTION 'PG-20002 Registro de uso interno. Nao pode ser modificado. %' , vComplemento;
     END IF;
  END IF;
 
  IF (TG_OP = 'INSERT') THEN
    TD_IND_OK := Atualiza_TD_IND(NEW.CODTAB);
  END IF;
     
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3949 --*/
CREATE TRIGGER TGDPES
BEFORE DELETE OR INSERT OR UPDATE ON TD_PES 
FOR EACH ROW EXECUTE PROCEDURE TGDPES();


/*-- SEQ 3950 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDPHO() CASCADE;

/*-- SEQ 3951 --*/
CREATE OR REPLACE FUNCTION TGDPHO() RETURNS TRIGGER AS $$
DECLARE
  -- Objetivo:
  -- Atualizar TD_IND
  TD_IND_OK VARCHAR(2);
BEGIN
   IF (TG_OP = 'INSERT') THEN
     TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3952 --*/
CREATE TRIGGER TGDPHO
BEFORE INSERT ON TD_PHO 
FOR EACH ROW EXECUTE PROCEDURE TGDPHO();


/*-- SEQ 3953 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDREG() CASCADE;

/*-- SEQ 3954 --*/
CREATE OR REPLACE FUNCTION TGDREG() RETURNS TRIGGER AS $$
-- Objetivo:
-- Impedir delete ou update do CODTAB = 0
BEGIN
  IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF NEW.CODTAB <> 0 and OLD.CODTAB = 0 THEN
         RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3955 --*/
CREATE TRIGGER TGDREG
BEFORE UPDATE OR DELETE ON TD_REG 
FOR EACH ROW EXECUTE PROCEDURE TGDREG();


/*-- SEQ 3956 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDREJ() CASCADE;

/*-- SEQ 3957 --*/
CREATE OR REPLACE FUNCTION TGDREJ() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
BEGIN
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    IF NEW.CODTAB IS NULL THEN
      NEW.CODTAB:=ProximoCodigo('TD_REJ',null);
    END IF;
  END IF; 
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3958 --*/
CREATE TRIGGER TGDREJ
BEFORE INSERT ON TD_REJ 
FOR EACH ROW EXECUTE PROCEDURE TGDREJ();


/*-- SEQ 3959 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDRGC() CASCADE;

/*-- SEQ 3960 --*/
CREATE OR REPLACE FUNCTION TGDRGC() RETURNS TRIGGER AS $$
DECLARE
  -- Objetivo:
  -- 1) Impedir delete ou update do CODTAB = 0
  -- 2) Atualizar TD_IND
  -- 3) Registrar Pendncias para Atualizar os Impostos de Fornecedores Calculados

  vComplemento VARCHAR(254);
  TD_IND_OK VARCHAR(2);
   -- Mateus 92861
  cRETORNO VARCHAR(4);
  -- Pedro E. Braga - 93794
  cFPVPRECOSIMULADO TT_CFG.FPV_PRECO_SIMULADO%TYPE;
BEGIN
  vComplemento := constante('complemento');

  -- Impede excluses
  IF (TG_OP = 'DELETE') OR (TG_OP = 'UPDATE') THEN
     IF (TG_OP = 'DELETE') THEN
        RAISE EXCEPTION 'PG-20001 Registro de uso interno. Nao pode ser excluido. %' , vComplemento;
     ELSIF ((TG_OP = 'UPDATE') and NEW.CODTAB <> 0 and OLD.CODTAB = 0) THEN
        RAISE EXCEPTION 'PG-20002 Registro de uso interno. Nao pode ser modificado. %' , vComplemento;
     END IF;
  END IF;

  IF (TG_OP = 'INSERT') THEN
    TD_IND_OK := Atualiza_TD_IND(NEW.CODTAB);
  END IF;

  IF (TG_OP = 'UPDATE') THEN
    --Pedro E. Braga - 93794
    SELECT FPV_PRECO_SIMULADO INTO cFPVPRECOSIMULADO FROM TT_CFG;
    IF (cFPVPRECOSIMULADO = 'T') THEN
        -- Mateus 92861
        IF (Equal(OLD.FLGENC, NEW.FLGENC) <> 1) THEN
          cRETORNO := INSERE_MIFC('DRGC', CAST(NEW.CODTAB AS VARCHAR));
        END IF;
    END IF;
    
    IF (NEW.FLGENC = 'T') AND (ISNULL(NEW.RGC_TIPENT) = 'T') THEN
       NEW.RGC_TIPENT := '7'; -- Venda Sob Encomenda
    END IF;
  END IF;

  IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3961 --*/
CREATE TRIGGER TGDRGC
BEFORE DELETE OR INSERT OR UPDATE ON TD_RGC 
FOR EACH ROW EXECUTE PROCEDURE TGDRGC();


/*-- SEQ 3962 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDROS() CASCADE;

/*-- SEQ 3963 --*/
CREATE OR REPLACE FUNCTION TGDROS() RETURNS TRIGGER AS $$
DECLARE
  -- Objetivo:
  -- Atualizar TD_IND
  TD_IND_OK VARCHAR(2);
BEGIN
   IF (TG_OP = 'INSERT') THEN
     TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3964 --*/
CREATE TRIGGER TGDROS
BEFORE INSERT ON TD_ROS 
FOR EACH ROW EXECUTE PROCEDURE TGDROS();


/*-- SEQ 3965 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDRTT2() CASCADE;

/*-- SEQ 3966 --*/
CREATE OR REPLACE FUNCTION TGDRTT2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3967 --*/
CREATE TRIGGER TGDRTT2
AFTER INSERT OR UPDATE OR DELETE ON TD_RTT 
FOR EACH ROW EXECUTE PROCEDURE TGDRTT2();


/*-- SEQ 3968 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDRU() CASCADE;

/*-- SEQ 3969 --*/
CREATE OR REPLACE FUNCTION TGDRU() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar codigo sequencial exclusivo
BEGIN
   -- Gera codigo sequencial exclusivo
   IF (TG_OP = 'INSERT') THEN
     IF (NEW.SEQUEN IS NULL) THEN
       NEW.SEQUEN:=ProximoCodigo('TT_DRU',NEW.CODFIL);
     END IF;
   END IF;

   -- Default
   NEW.ATU_EM := agora();
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3970 --*/
CREATE TRIGGER TGDRU
BEFORE INSERT OR UPDATE ON TT_DRU 
FOR EACH ROW EXECUTE PROCEDURE TGDRU();



/*-- SEQ 3971 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDSAD() CASCADE;

/*-- SEQ 3972 --*/
CREATE OR REPLACE FUNCTION TGDSAD() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Verificar a consistncia de alguns campos.
-- 2. Atualizar TD_IND

-- Declarao de variveis e cursores
  TD_IND_OK                      VARCHAR(2);

-- Principal
BEGIN
  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     --RFMP 96813
     -- Por limitao do Oracle no  possvel validar coluna TEXT na trigger
     -- No  possvel validar coluna TEXT
     
     IF (NEW.IMPDOC = 'T') AND (NEW.FORIMP IS NULL) THEN
        RAISE EXCEPTION 'PG-20006 A frmula para impresso deve ser preenchida quando a impresso de documento estiver marcada.';
     END IF;
     
     IF (NEW.TIPVAL > 0) AND (NEW.VALIDA IS NULL) THEN
        RAISE EXCEPTION 'PG-20006 A Garantia/Validade deve ser preenchida quando controlar o tempo de validade do servio.';
     END IF;
  END IF;
  
  IF (TG_OP = 'INSERT') THEN
     TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
  END IF;  
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3973 --*/
CREATE TRIGGER TGDSAD
BEFORE UPDATE OR INSERT ON TD_SAD 
FOR EACH ROW EXECUTE PROCEDURE TGDSAD();


/*-- SEQ 3974 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDSAD_CAN() CASCADE;

/*-- SEQ 3975 --*/
CREATE OR REPLACE FUNCTION TGDSAD_CAN() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Atualizar TD_IND

-- Declarao de variveis e cursores
  TD_IND_OK                      VARCHAR(2);
  
-- Principal  
BEGIN
   IF (TG_OP = 'INSERT') THEN
     TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3976 --*/
CREATE TRIGGER TGDSAD_CAN
BEFORE INSERT ON TD_SAD_CAN 
FOR EACH ROW EXECUTE PROCEDURE TGDSAD_CAN();


/*-- SEQ 3977 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDSAT() CASCADE;

/*-- SEQ 3978 --*/
CREATE OR REPLACE FUNCTION TGDSAT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impedir excluses.
-- 2. Impedir atualizaes de registros internos.
-- 3. Atualizar TD_IND.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');
   cRet                          VARCHAR(2);

-- Principal
BEGIN
   -- Impedir excluses.
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20000 Registro de uso interno. No pode ser excludo. %' , COMPLEMENTO;
   END IF;

   -- Impedir atualizaes de registros internos.
   IF (TG_OP = 'UPDATE') THEN
      IF NEW.CODTAB <= 0 THEN
         RAISE EXCEPTION 'PG-20001 Registro de uso interno. No pode ser modificado. %' , COMPLEMENTO;
      END IF;
   END IF;

   -- Atualizar TD_IND.
   IF (TG_OP = 'INSERT') THEN
      cRet := Atualiza_TD_IND(NEW.CODTAB);
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3979 --*/
CREATE TRIGGER TGDSAT
BEFORE DELETE OR INSERT OR UPDATE ON TD_SAT 
FOR EACH ROW EXECUTE PROCEDURE TGDSAT();


/*-- SEQ 3980 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDSER1() CASCADE;

/*-- SEQ 3981 --*/
CREATE OR REPLACE FUNCTION TGDSER1() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Manter um limite de itens
DECLARE
   vLimite                       CONSTANT Numeric := Constante('limite');
   vQtd                          Numeric;
BEGIN
   SELECT COUNT(*) INTO vQtd FROM TD_SER;
   IF (vQtd > vLimite) then
      RAISE EXCEPTION 'PG-20007 Quantidade de registros atingida. Nao pode haver mais inclusoes';
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3982 --*/
CREATE TRIGGER TGDSER1
BEFORE INSERT ON TD_SER 
FOR STATEMENT EXECUTE PROCEDURE TGDSER1();

/*-- SEQ 3983 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDSER2() CASCADE;

/*-- SEQ 3984 --*/
CREATE OR REPLACE FUNCTION TGDSER2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir delete ou update do CODTAB = 0
-- 2) Atualizar TD_IND
DECLARE
   TD_IND_OK                     VARCHAR(2);
BEGIN
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido';
   END IF;
   IF (TG_OP = 'UPDATE') THEN
   IF NEW.CODTAB <> 0 and OLD.CODTAB = 0 THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser modificado';
   END IF;
   END IF;
   IF (TG_OP = 'INSERT') THEN
      TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3985 --*/
CREATE TRIGGER TGDSER2
BEFORE DELETE OR UPDATE OR INSERT ON TD_SER 
FOR EACH ROW EXECUTE PROCEDURE TGDSER2();

/*-- SEQ 3986 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDSER3() CASCADE;

/*-- SEQ 3987 --*/
CREATE OR REPLACE FUNCTION TGDSER3() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3988 --*/
CREATE TRIGGER TGDSER3
AFTER INSERT OR UPDATE OR DELETE ON TD_SER 
FOR EACH ROW EXECUTE PROCEDURE TGDSER3();


/*-- SEQ 3989 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDSIT() CASCADE;

/*-- SEQ 3990 --*/
CREATE OR REPLACE FUNCTION TGDSIT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao

-- Declarao de variveis e cursores
   cRetorno                      VARCHAR(2);

-- Principal
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3991 --*/
CREATE TRIGGER TGDSIT
AFTER INSERT OR UPDATE OR DELETE ON TD_SIT 
FOR EACH ROW EXECUTE PROCEDURE TGDSIT();


/*-- SEQ 3992 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDSP() CASCADE;

/*-- SEQ 3993 --*/
CREATE OR REPLACE FUNCTION TGDSP() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Gerar um cdigo sequencial exclusivo para compor a chave primria.
-- 2. Atualiza controles de data.
-- 3. Tratamento para excluso e reintroduo de registro excludo

-- Declarao de variveis e cursores
   cComplemento                  CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');
   cRet                          VARCHAR(2);
   
-- Principal
BEGIN
   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN := ProximoCodigo('TT_DSP',NEW.CODFIL);
      END IF;
      
      NEW.DATINC := Agora();
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;
   
   -- Tratamento para excluso de registro
   IF (TG_OP = 'DELETE') THEN
      cRet := LogExclusao(TRUE,'TT_DSP', OLD.CODFIL, OLD.SEQUEN);
   END IF;   

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3994 --*/
CREATE TRIGGER TGDSP
BEFORE INSERT OR UPDATE OR DELETE ON TT_DSP 
FOR EACH ROW EXECUTE PROCEDURE TGDSP();


/*-- SEQ 3995 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDSTD() CASCADE;

/*-- SEQ 3996 --*/
CREATE OR REPLACE FUNCTION TGDSTD() RETURNS TRIGGER AS $$
-- Objetivo:
-- Tratar
BEGIN
  IF ((TG_OP = 'INSERT')) AND (ISNULL(NEW.FLGFLX)='T') then
     IF NEW.USOSTD = 'C' THEN
        NEW.FLGFLX := 'C';
     ELSE
        NEW.FLGFLX := 'R';
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 3997 --*/
CREATE TRIGGER TGDSTD
BEFORE INSERT ON TD_STD 
FOR EACH ROW EXECUTE PROCEDURE TGDSTD();


/*-- SEQ 3998 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDSTF() CASCADE;

/*-- SEQ 3999 --*/
CREATE OR REPLACE FUNCTION TGDSTF() RETURNS TRIGGER AS $$
DECLARE
  -- Objetivo:
  -- 1) Impedir delete ou update do CODTAB = 0
  -- 2) Atualizar TD_IND
 
  vComplemento VARCHAR(254);
  TD_IND_OK VARCHAR(2);
BEGIN
  vComplemento := constante('complemento');
 
  -- Impede excluses
  IF (TG_OP = 'DELETE') OR (TG_OP = 'UPDATE') THEN
     IF (TG_OP = 'DELETE') THEN
        RAISE EXCEPTION 'PG-20001 Registro de uso interno. Nao pode ser excluido. %' , vComplemento;
     ELSIF ((TG_OP = 'UPDATE') and NEW.CODTAB <> 0 and OLD.CODTAB = 0) THEN
        RAISE EXCEPTION 'PG-20002 Registro de uso interno. Nao pode ser modificado. %' , vComplemento;
     END IF;
  END IF;
 
  IF (TG_OP = 'INSERT') THEN
    TD_IND_OK := Atualiza_TD_IND(NEW.CODTAB);
  END IF;
 
  IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4000 --*/
CREATE TRIGGER TGDSTF
BEFORE DELETE OR INSERT OR UPDATE ON TD_STF 
FOR EACH ROW EXECUTE PROCEDURE TGDSTF();


/*-- SEQ 4001 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDSUB1() CASCADE;

/*-- SEQ 4002 --*/
CREATE OR REPLACE FUNCTION TGDSUB1() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir delete ou update do CODTAB = 0
DECLARE
   cMensagem                     CONSTANT CHAR(60) := 'Registro de uso interno. Nao pode ser excluido ou modificado';
BEGIN
   IF ((TG_OP = 'DELETE')) THEN
      IF (OLD.CODTAB = 0) THEN
         RAISE EXCEPTION 'PG-20006 %' , cMensagem;
      END IF;
   ELSIF ((TG_OP = 'UPDATE')) THEN
      IF (NEW.CODTAB <> 0 AND OLD.CODTAB = 0) THEN
         RAISE EXCEPTION 'PG-20006 %' , cMensagem;
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4003 --*/
CREATE TRIGGER TGDSUB1
BEFORE INSERT OR DELETE OR UPDATE ON TD_SUB 
FOR EACH ROW EXECUTE PROCEDURE TGDSUB1();

/*-- SEQ 4004 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDSUB2() CASCADE;

/*-- SEQ 4005 --*/
CREATE OR REPLACE FUNCTION TGDSUB2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Verificar se o fator de conversao e igual a 1 para poder prosseguir
-- 2) Fazer "update cascade" na tabela de grade
--
DECLARE
   linha                         INTEGER;
   vComplemento                  CONSTANT VARCHAR(254):= Constante('complemento');
BEGIN
   IF NEW.CODSAL IS NOT NULL THEN
      SELECT COUNT(*) INTO linha
        FROM TT_SUB
       WHERE CODITE = NEW.CODSAL
         AND FATCON = 1;

      IF linha <> 1 THEN
         RAISE EXCEPTION 'PG-20006 Fator de conversao nao e 1 para 1. %' , vComplemento;
      END IF;

      -- "Update cascade" para indicar que o produto segue o controle da embalagem
      IF (NEW.CODSAL <> coalesce(OLD.CODSAL,NEW.CODSAL * -1)) THEN
         UPDATE TT_GRA SET UNIDAD = UNIFOR, VALCON = 1
          WHERE CODTAM IN (SELECT CODITE FROM TT_SUB WHERE CODSUB = NEW.CODTAB);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4006 --*/
CREATE TRIGGER TGDSUB2
AFTER UPDATE ON TD_SUB 
FOR EACH ROW EXECUTE PROCEDURE TGDSUB2();

/*-- SEQ 4007 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDSUB3() CASCADE;

/*-- SEQ 4008 --*/
CREATE OR REPLACE FUNCTION TGDSUB3() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Impedir que haja controle de embalagem se a subdivisao nao
--    existir para todas as divisoes da grade de um produto
--
-- Nota: este bloco PL/SQL e identico ao usado para a grade
--
   achou                         INTEGER;
   mensagem                      VARCHAR(255);
   vComplemento                  CONSTANT VARCHAR(100) := Constante('complemento');
BEGIN
   -- Checa a inexistencia de subdivisoes,
   -- mas apenas a primeira ocorrncia

   SELECT COUNT(NOMITE),MIN(NOMITE) INTO achou,mensagem 
     FROM (SELECT 'Para o item "'||LOWER(RTRIM(COALESCE(IPR.DESMAT,'')))||
                 ' '||LOWER(RTRIM(CASE IPR.ESPMAT WHEN IPR.DESMAT THEN ''
                                                  ELSE IPR.ESPMAT
                                  END))||
                 ' ('||LOWER(RTRIM(COALESCE(IPR.ITEDIV,'')))||')", referencia "'||
                 RTRIM(COALESCE(IPR.REFPRO,''))||'", falta a subdivisao "'||
                 LOWER(RTRIM(COALESCE(B.ITESUB,'')))||'"' AS NOMITE
            FROM TV_IPR IPR 
                 INNER JOIN
                 (SELECT DISTINCT GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,A.CODTAM,A.ITESUB
                   FROM TT_GRA GRA INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
                        INNER JOIN 
                        (SELECT DGRA.CODTAB AS CODGRA,
                                DSUB.CODSAL AS CODTAM,
                                SUB.NOMITE  AS ITESUB
                          FROM TD_GRA DGRA INNER JOIN TD_SUB DSUB ON DSUB.CODTAB = DGRA.CODSUB
                                           INNER JOIN TT_SUB SUB  ON DSUB.CODSAL = SUB.CODITE                        
                          WHERE DSUB.CODSAL IS NOT NULL
                         )A ON A.CODGRA   = PRO.CODGRA
      
                   EXCEPT
                      SELECT DISTINCT GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,A.ITESUB
                   FROM TT_GRA GRA INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT
                        INNER JOIN 
                        (SELECT DGRA.CODTAB AS CODGRA,
                                DSUB.CODSAL AS CODTAM,
                                SUB.NOMITE  AS ITESUB
                          FROM TD_GRA DGRA INNER JOIN TD_SUB DSUB ON DSUB.CODTAB = DGRA.CODSUB
                                           INNER JOIN TT_SUB SUB  ON DSUB.CODSAL = SUB.CODITE                        
                          WHERE DSUB.CODSAL IS NOT NULL
                         ) A ON A.CODGRA = PRO.CODGRA AND A.CODTAM = GRA.CODTAM
                 )B
                 ON B.FILMAT = IPR.FILMAT 
                AND B.CODMAT = IPR.CODMAT
                AND B.CODCOR = IPR.CODCOR 
      
                LIMIT 1
             ) TAB;

   -- Erro: ha divisoes sem subdivisao = codsal
   IF (achou > 0) THEN
      RAISE EXCEPTION 'PG-20007 % %' , mensagem,vComplemento;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4009 --*/
CREATE TRIGGER TGDSUB3
AFTER INSERT OR UPDATE ON TD_SUB 
FOR STATEMENT EXECUTE PROCEDURE TGDSUB3();

/*-- SEQ 4010 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDSUB4() CASCADE;

/*-- SEQ 4011 --*/
CREATE OR REPLACE FUNCTION TGDSUB4() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_GRA
DECLARE
   cRetorno                      VARCHAR(2);
   cWhere                        TM_ATU.FILTRO%TYPE;
   nCODSUB                       TT_SUB.CODSUB%TYPE;
   nCODITE                       TT_SUB.CODITE%TYPE;
   
   crSubDivisao CURSOR(pCODSUB TT_SUB.CODSUB%TYPE) IS
        SELECT SUB.CODITE
          FROM TT_SUB SUB     
         WHERE SUB.CODSUB = pCODSUB;
BEGIN
   --Tratamento para Atualizar Tabela Pai   
   IF (TG_OP = 'INSERT') THEN
      nCODSUB := NEW.CODTAB;
   ELSIF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODTAB,NEW.CODTAB) <> 1
      OR Equal(OLD.NOMSUB,NEW.NOMSUB) <> 1
      OR Equal(OLD.CODSAL,NEW.CODSAL) <> 1
      OR Equal(OLD.CODEXT,NEW.CODEXT) <> 1
      OR Equal(OLD.ORDSUB,NEW.ORDSUB) <> 1
      OR Equal(OLD.SUBATI,NEW.SUBATI) <> 1 THEN
         nCODSUB := NEW.CODTAB;
      ELSE
         nCODSUB := NULL;
      END IF;
   ELSIF (TG_OP = 'DELETE') THEN
      nCODSUB := OLD.CODTAB;
   END IF;
   IF ISNOTNULL(TO_CHAR(nCODSUB))='T' THEN
      OPEN crSubDivisao(nCODSUB);
      LOOP
         FETCH crSubDivisao INTO nCODITE;
         EXIT WHEN NOT FOUND;
         cWhere := 'CODTAM = ' || TO_CHAR(nCODITE);
         cRetorno := INSERE_MATU('TD_SUB', 'TT_GRA', cWhere);
      END LOOP;
      CLOSE crSubDivisao;  
   END IF; 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4012 --*/
CREATE TRIGGER TGDSUB4
AFTER INSERT OR DELETE OR UPDATE ON TD_SUB 
FOR EACH ROW EXECUTE PROCEDURE TGDSUB4();


/*-- SEQ 4013 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDTAN() CASCADE;

/*-- SEQ 4014 --*/
CREATE OR REPLACE FUNCTION TGDTAN() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Atualizar TD_BIC.ATU_EM

  --LEO 84337
  vCODUID_ATUAL VARCHAR(22);
  vBLQ_SEM_UID  TT_CFG.BLQ_SEM_UID%TYPE;
  vSESSIONID    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

BEGIN
  UPDATE TD_BIC SET ATU_EM = AGORA() WHERE CODTAN = NEW.CODTAB;
  IF (TG_OP = 'UPDATE') THEN 
     IF NEW.CODTAB <> OLD.CODTAB THEN
        UPDATE TD_BIC SET ATU_EM = AGORA() WHERE CODTAN = OLD.CODTAB;
     END IF;
  END IF;  
  
  IF (TG_OP = 'INSERT') THEN
  
    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
  
    -- Douglas - 83441 
    NEW.CODUID := GetCoduidAtual();	     
    NEW.ASSINA := COALESCE(AssinaTabela('TD_TAN', 
	                                    ConcatenaDTAN(NEW.CODTAB,
                                                      NEW.TANQUE),
                                                   null, null, null),NEW.ASSINA);
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF ConcatenaDTAN(NEW.CODTAB,NEW.TANQUE) <>
	     ConcatenaDTAN(OLD.CODTAB,OLD.TANQUE) THEN
		 
		 -- LEO 84337
         SELECT BLQ_SEM_UID
           INTO vBLQ_SEM_UID
           FROM TT_CFG;
         vCODUID_ATUAL := GetCoduidAtual();
         IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;
		 
	     -- Douglas - 83441 
         NEW.CODUID := GetCoduidAtual();	     
         NEW.ASSINA := COALESCE(AssinaTabela('TD_TAN', 
 	                                         ConcatenaDTAN(NEW.CODTAB,
                                                           NEW.TANQUE),
                                                       OLD.CODUID, 
	                                         ConcatenaDTAN(OLD.CODTAB,
                                                           OLD.TANQUE),
                                                      OLD.ASSINA
                                                     ),NEW.ASSINA);
	  END IF;											  
   END IF;         
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4015 --*/
CREATE TRIGGER TGDTAN
BEFORE INSERT OR UPDATE ON TD_TAN 
FOR EACH ROW EXECUTE PROCEDURE TGDTAN();

/*-- SEQ 4016 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDTAN_ASS() CASCADE;

/*-- SEQ 4017 --*/
CREATE OR REPLACE FUNCTION TGDTAN_ASS() RETURNS TRIGGER AS $$
-- 83073
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN

  IF ExisteFilialNaUF('SC') THEN
     IF (TG_OP = 'INSERT') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG + 1
        WHERE NOMTAB = 'TD_TAN';
     END IF;  
     
     IF (TG_OP = 'DELETE') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG - 1
        WHERE NOMTAB = 'TD_TAN';
     END IF;  
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4018 --*/
CREATE TRIGGER TGDTAN_ASS
AFTER INSERT OR DELETE ON TD_TAN 
FOR EACH ROW EXECUTE PROCEDURE TGDTAN_ASS();

/*-- SEQ 4019 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDTAN2() CASCADE;

/*-- SEQ 4020 --*/
CREATE OR REPLACE FUNCTION TGDTAN2() RETURNS TRIGGER AS $$
DECLARE
  --LEO 84337
  vCODUID_ATUAL VARCHAR(22);
  vBLQ_SEM_UID  TT_CFG.BLQ_SEM_UID%TYPE;
  vSESSIONID    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

-- 83073
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN

  IF (TG_OP = 'DELETE') THEN
    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4021 --*/
CREATE TRIGGER TGDTAN2
BEFORE DELETE ON TD_TAN 
FOR EACH ROW EXECUTE PROCEDURE TGDTAN2();


/*-- SEQ 4022 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDTED() CASCADE;

/*-- SEQ 4023 --*/
CREATE OR REPLACE FUNCTION TGDTED() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Tarefa  70833 --
-- impede INSERT e UPDATE

-- Principal
BEGIN

  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser modificado';
  END IF; 

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4024 --*/
CREATE TRIGGER TGDTED
BEFORE INSERT OR UPDATE ON TD_TED 
FOR EACH ROW EXECUTE PROCEDURE TGDTED();


/*-- SEQ 4025 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDTIP() CASCADE;

/*-- SEQ 4026 --*/
CREATE OR REPLACE FUNCTION TGDTIP() RETURNS TRIGGER AS $$
DECLARE
  -- Objetivo:
  -- Atualizar TD_IND
  TD_IND_OK VARCHAR(2);
BEGIN
   IF (TG_OP = 'INSERT') THEN
     TD_IND_OK := Atualiza_TD_IND( NEW.CODTAB );
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4027 --*/
CREATE TRIGGER TGDTIP
BEFORE INSERT ON TD_TIP 
FOR EACH ROW EXECUTE PROCEDURE TGDTIP();


/*-- SEQ 4028 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDTIPXINT() CASCADE;

/*-- SEQ 4029 --*/
CREATE OR REPLACE FUNCTION TGDTIPXINT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impedir excluses.
-- 2. Impedir atualizaes de registros internos.
-- 3. Atualizar TD_IND.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');
   cRet                          VARCHAR(2);

-- Principal
BEGIN
   -- Impedir excluses.
   IF (TG_OP = 'DELETE') THEN
      IF (Equal(OLD.CODTAB,0) = 1) OR
         (Equal(OLD.CODTAB,1) = 1) OR
         (Equal(OLD.CODTAB,2) = 1) OR
         (Equal(OLD.CODTAB,3) = 1) OR
         (Equal(OLD.CODTAB,4) = 1) OR
         (Equal(OLD.CODTAB,5) = 1) THEN             
         RAISE EXCEPTION 'PG-20000 Registro no pode ser excludo. %' , COMPLEMENTO;
      END IF;
   END IF;

   -- Impedir atualizaes de registros internos.
   IF (TG_OP = 'UPDATE') THEN
      IF NEW.CODTAB IN (0,1,2,3,4,5) THEN
         RAISE EXCEPTION 'PG-20001 Registro de uso interno. No pode ser modificado. %' , COMPLEMENTO;
      END IF;
   END IF;

   -- Atualizar TD_IND.
   IF (TG_OP = 'INSERT') THEN
      cRet := Atualiza_TD_IND(NEW.CODTAB);
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4030 --*/
CREATE TRIGGER TGDTIPXINT
BEFORE DELETE OR INSERT OR UPDATE ON TD_TIPXINT 
FOR EACH ROW EXECUTE PROCEDURE TGDTIPXINT();


/*-- SEQ 4031 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDTRI() CASCADE;

/*-- SEQ 4032 --*/
CREATE OR REPLACE FUNCTION TGDTRI() RETURNS TRIGGER AS $$
-- Objetivo:
-- Atualizar TT_IUF.ATU_EM
BEGIN
  IF (Equal(OLD.TRIATI,NEW.TRIATI) <> 1 ) OR
     (Equal(OLD.CODTRI,NEW.CODTRI) <> 1 ) THEN
    UPDATE TT_IUF SET ATU_EM = AGORA() WHERE CODTRI = NEW.CODTAB;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4033 --*/
CREATE TRIGGER TGDTRI
BEFORE UPDATE ON TD_TRI 
FOR EACH ROW EXECUTE PROCEDURE TGDTRI();


/*-- SEQ 4034 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDVCR() CASCADE;

/*-- SEQ 4035 --*/
CREATE OR REPLACE FUNCTION TGDVCR() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Nao permitir excluir ou alterar linhas reservadas
DECLARE
   vComplemento VARCHAR(100);   
BEGIN
  vComplemento:=constante('Complemento');
  IF (OLD.CODTAB BETWEEN 1 AND 15) THEN
    IF (TG_OP = 'UPDATE') THEN  
       IF   (OLD.CODTAB <> NEW.CODTAB
          OR OLD.CORATI <> NEW.CORATI
          OR OLD.DESCOR <> NEW.DESCOR) THEN
          RAISE EXCEPTION 'PG-20001 Registro de uso interno. Nao pode ser excluido ou modificado. %' , vComplemento;
       END IF;
    END IF;
    IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20001 Registro de uso interno. Nao pode ser excluido ou modificado. %' , vComplemento;
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4036 --*/
CREATE TRIGGER TGDVCR
BEFORE UPDATE OR DELETE ON TD_VCR 
FOR EACH ROW EXECUTE PROCEDURE TGDVCR();



/*-- SEQ 4037 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDVEI1() CASCADE;

/*-- SEQ 4038 --*/
CREATE OR REPLACE FUNCTION TGDVEI1() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impedir excluses.
-- 2. Impedir atualizaes de registros internos.
-- 3. Atualizar TD_VEI.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');
   cRet                          VARCHAR(2);

-- Principal
BEGIN

   IF (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := AGORA();
   END IF;

   -- Atualizar TD_IND.
   IF (TG_OP = 'INSERT') THEN
      cRet := Atualiza_TD_IND(NEW.CODTAB);
      NEW.DATINC := AGORA();
      NEW.ATU_EM := AGORA();
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4039 --*/
CREATE TRIGGER TGDVEI1
BEFORE INSERT OR UPDATE ON TD_VEI 
FOR EACH ROW EXECUTE PROCEDURE TGDVEI1();


/*-- SEQ 4040 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDVTP() CASCADE;

/*-- SEQ 4041 --*/
CREATE OR REPLACE FUNCTION TGDVTP() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Nao permitir excluir ou alterar linhas reservadas
DECLARE
   vComplemento VARCHAR(100);   
BEGIN
  vComplemento:=constante('Complemento');
  
  -- Manoel - 86101 - Conforme conversado com daniel, no h motivos para
  -- que no se possa desativar um tipo de veculo.
  IF (OLD.CODTAB BETWEEN 1 AND 23) OR (OLD.CODTAB IN (28,31,99)) THEN
    IF (TG_OP = 'DELETE') THEN 
       RAISE EXCEPTION 'PG-20001 Tipo de Veiculo nao pode excluido, apenas desativado.%' , vComplemento;
    END IF;
    IF (TG_OP = 'UPDATE') THEN
       IF (COALESCE(NEW.DESVTP,'ERR#') != OLD.DESVTP) THEN
  /*   OR COALESCE(NEW.VTPATI,'#'   ) != OLD.VTPATI)*/
           RAISE EXCEPTION 'PG-20001 Tipo de Veiculo nao pode ter sua descricao alterada, apenas pode ser desativado.%' , vComplemento;
       END IF;
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4042 --*/
CREATE TRIGGER TGDVTP
BEFORE UPDATE OR DELETE ON TD_VTP 
FOR EACH ROW EXECUTE PROCEDURE TGDVTP();


/*-- SEQ 4043 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDXC() CASCADE;

/*-- SEQ 4044 --*/
CREATE OR REPLACE FUNCTION TGDXC() RETURNS TRIGGER AS $$
-- Objetivos:
-- 1) Gerar codigo sequencial exclusivo
-- 2) Impedir mudancas na chave primaria
-- 3) Impedir lancamentos para cliente "venda ao consumidor"
-- 4) Registrar mudanca dos dados num "log"
-- 5) "Delete cascade" na tabela de "log"
DECLARE
   cLOG                          VARCHAR(4000)     := '';
   cLogChave                     VARCHAR(70)       := '';
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   cDESCCC                       TD_CCC.DESCCC%TYPE;
   cOld                          VARCHAR(50); -- colocar Descrição no lugar dos codtab
   cNew                          VARCHAR(50); 
   
   cVC_FILCLI                    TT_CFG.VC_FILCLI%TYPE;
   cVC_CODCLI                    TT_CFG.VC_CODCLI%TYPE;
   vComplemento                  CONSTANT VARCHAR(100) := Constante('complemento');
   vAspas                        CONSTANT VARCHAR(1)   := CHR(39);  
   vVem_de_UNIAO_PARCEIROS       CONSTANT VARCHAR(1)   := Constante('UNIAO_PARCEIROS');
BEGIN
   -- Gera codigo sequencial exclusivo
   IF (TG_OP = 'INSERT') THEN
      IF (ISNULL(NEW.SEQUEN)='T') THEN
         NEW.SEQUEN:=ProximoCodigo('TT_DXC',NEW.CODFIL);
      END IF;
   END IF;

   IF (TG_OP = 'INSERT') 
   OR (TG_OP = 'UPDATE') THEN 
      SELECT DCCC.DESCCC INTO cDESCCC FROM TD_CCC DCCC WHERE DCCC.CODTAB = NEW.CODCCC;
      cLogChave := 'Dias para Faturamento ' || cDESCCC || ' [' || NEW.CODFIL || '-' || NEW.SEQUEN || ']';
   END IF;
   
   IF (TG_OP = 'INSERT') THEN
      -- Nao permite que dados de faturamento sejam lancados para o "venda ao consumidor"
      SELECT VC_FILCLI, VC_CODCLI INTO cVC_FILCLI, cVC_CODCLI FROM TT_CFG;
      IF  ((NEW.FILCLI = cVC_FILCLI)
      AND  (NEW.CODCLI = cVC_CODCLI)) THEN
         RAISE EXCEPTION 'PG-20039 Nao e% possivel incluir dados de vencimento para o "Venda ao Consumidor".%' , vAspas,vComplemento;    
      END IF;

      -- Tratamento de log
      cLOG := 'Inclusão de ' || cLogChave;
   ELSIF (TG_OP = 'UPDATE') THEN
      -- se nao vier da uniao de parceiros
      IF (Equal(NEW.DUMMY, vVem_de_UNIAO_PARCEIROS) <> 1) THEN
         -- Impede mudancas na chave primaria e no cliente
         IF (NEW.CODFIL <> OLD.CODFIL) OR
            (NEW.SEQUEN <> OLD.SEQUEN) OR
            (NEW.FILCLI <> OLD.FILCLI) OR
            (NEW.CODCLI <> OLD.CODCLI) THEN
            RAISE EXCEPTION 'PG-20040 Alguns dados de vencimento nao podem ser modificados.%' , vComplemento;
         END IF;
      END IF;
      
      IF Equal(OLD.CODCCC,NEW.CODCCC) <> 1 THEN
         SELECT DCCC.DESCCC INTO cOld FROM TD_CCC DCCC WHERE DCCC.CODTAB = OLD.CODCCC;
         SELECT DCCC.DESCCC INTO cNew FROM TD_CCC DCCC WHERE DCCC.CODTAB = NEW.CODCCC;
         cLOG := cLOG||'Tipo C/C: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DIAMES,NEW.DIAMES) <> 1 THEN
         cLOG := cLOG||'Dia Mes: de '||COALESCE(OLD.DIAMES,iNulo)||' para '||COALESCE(NEW.DIAMES,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.DIASEM,NEW.DIASEM) <> 1 THEN
         cLOG := cLOG||'Dia Semana: de '||COALESCE(DescricaoDominio('DXC','DIASEM',TO_CHAR(OLD.DIASEM)),cNulo)||' para '||COALESCE(DescricaoDominio('DXC','DIASEM',TO_CHAR(NEW.DIASEM)),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DIAVEN,NEW.DIAVEN) <> 1 THEN
         cLOG := cLOG||'Vencimento: de '||COALESCE(OLD.DIAVEN,iNulo)||' para '||COALESCE(NEW.DIAVEN,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.DIAFIX,NEW.DIAFIX) <> 1 THEN
         cLOG := cLOG||'Dia Fixo do Vencimento: de '||COALESCE(OLD.DIAFIX,iNulo)||' para '||COALESCE(NEW.DIAFIX,iNulo)||CRLF;
      END IF;
      
      IF ISNOTNULL(cLOG) = 'T' THEN
         cLOG := cLogChave || ' >> ' || cLOG;
      END IF;
   END IF;
   IF (TG_OP = 'INSERT') 
   OR (TG_OP = 'UPDATE') THEN
      IF ISNOTNULL(cLOG) = 'T' THEN
         INSERT INTO TL_CLI (FILCLI,CODCLI,DATOPE,MSGLOG)
                     VALUES (NEW.FILCLI,NEW.CODCLI,agora(),cLOG);
      END IF;
   END IF;

   IF (NOT (TG_OP = 'DELETE')) THEN
      NEW.DUMMY := NULL;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4045 --*/
CREATE TRIGGER TGDXC
BEFORE INSERT OR UPDATE ON TT_DXC 
FOR EACH ROW EXECUTE PROCEDURE TGDXC();


/*-- SEQ 4046 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGDXG() CASCADE;

/*-- SEQ 4047 --*/
CREATE OR REPLACE FUNCTION TGDXG() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
BEGIN
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    NEW.SEQUEN:=ProximoCodigo('TT_DXG',NEW.CODFIL);
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4048 --*/
CREATE TRIGGER TGDXG
BEFORE INSERT ON TT_DXG 
FOR EACH ROW EXECUTE PROCEDURE TGDXG();


/*-- SEQ 4049 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGEAN() CASCADE;

/*-- SEQ 4050 --*/
CREATE OR REPLACE FUNCTION TGEAN() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Evitar codigos repetidos
-- 2) Atualiza ATU_EM da TT_GRA

-- Declarao de variveis e cursores
   msg                           CHAR(100);
   referencia                    CHAR(50);
   vComplemento                  VARCHAR(254);

   cMantemAtuEm                  VARCHAR(1);
   cRetorno                      VARCHAR(2);
   cWhere                        TM_ATU.FILTRO%TYPE;
   
-- Principal
BEGIN
   -- Inicializao de variveis e regras
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN
      IF COALESCE(TRIM(NEW.DUMMY),'#') = Constante('MANTEM_ATU_EM') THEN
         cMantemAtuEm := 'T';
      ELSE
         cMantemAtuEm := 'F';
      END IF;
   ELSIF (TG_OP = 'DELETE') THEN
      cMantemAtuEm := 'F';
   END IF;
   
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN := ProximoCodigo('TT_EAN', NEW.CODFIL);
      END IF;
      NEW.DATINC := agora();
      IF NEW.CODFIL IS NULL THEN
         SELECT CODLOJ INTO NEW.CODFIL
           FROM TT_IDF;
      END IF;
   END IF;

   IF NOT (TG_OP = 'DELETE') THEN
      vComplemento  := constante('complemento');
      -- Trata dados padroes na inclusao
      SELECT REFBAS
        INTO referencia
        FROM (SELECT 0 AS dummy1 FROM dual) d1
                LEFT OUTER JOIN
             (SELECT 0 AS dummy2,REFBAS FROM TT_PRO WHERE REFBAS = NEW.CODEAN) d2
             ON d1.dummy1 = d2.dummy2;

      IF referencia IS NOT NULL THEN
         msg := 'produto com a referencia basica';
         RAISE EXCEPTION 'PG-20001 Existe um % %.%' , msg,NEW.CODEAN,vComplemento;
      END IF;

      SELECT REFPRO
        INTO referencia
        FROM (SELECT 0 AS dummy1 FROM dual) d1
                LEFT OUTER JOIN
             (SELECT 0 AS dummy2,REFPRO FROM TT_GRA WHERE REFPRO = NEW.CODEAN) d2
                  ON d1.dummy1 = d2.dummy2;

      IF referencia IS NOT NULL THEN
         msg := 'item de grade com a referencia';
         RAISE EXCEPTION 'PG-20001 Existe um % %.%' , msg,NEW.CODEAN,vComplemento;
      END IF;

      IF (TG_OP = 'INSERT') OR (cMantemAtuEm = 'F') THEN
         NEW.ATU_EM := agora();
      END IF;
   END IF;

   IF (TG_OP = 'DELETE') THEN
      cRetorno := LogExclusao((TG_OP = 'DELETE'), 'TT_EAN', OLD.CODEAN,
                              rpad(OLD.FILMAT || OLD.CODMAT || '-' || TO_CHAR(OLD.CODCOR) || '-' || TO_CHAR(OLD.CODTAM), 20, ' ' ));
   END IF;
   IF (TG_OP = 'INSERT') THEN
      --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
      cRetorno := LogExclusao((TG_OP = 'DELETE'), 'TT_EAN', NEW.CODEAN,
                              rpad(NEW.FILMAT || NEW.CODMAT || '-' || TO_CHAR(NEW.CODCOR) || '-' || TO_CHAR(NEW.CODTAM), 20, ' ' ));
   END IF;
   
   -- Trazendo para trigger BEFORE tratamento de atualizao do ATU_EM porque
   -- ele depende do DUMMY que ser apagado no final da trigger
   IF cMantemAtuEm = 'F' THEN
      -- Tratamento para Atualizar Tabela Pai
      IF (TG_OP = 'INSERT')
      OR (TG_OP = 'UPDATE') THEN
         cWhere := 'FILMAT = ' || CHR(39) || NEW.FILMAT  || CHR(39) || ' AND CODMAT = ' || CHR(39) || NEW.CODMAT || CHR(39) ||
                   ' AND CODCOR = ' || TO_CHAR(NEW.CODCOR) || ' AND CODTAM = ' || TO_CHAR(NEW.CODTAM);
      ELSIF (TG_OP = 'DELETE') THEN
         cWhere := 'FILMAT = ' || CHR(39) || OLD.FILMAT  || CHR(39) || ' AND CODMAT = ' || CHR(39) || OLD.CODMAT || CHR(39) ||
                   ' AND CODCOR = ' || TO_CHAR(OLD.CODCOR) || ' AND CODTAM = ' || TO_CHAR(OLD.CODTAM);
      END IF;
      cRetorno := INSERE_MATU('TT_EAN', 'TT_GRA', cWhere);
   END IF;

   -- Apagando dados do DUMMY para garantir que um novo processo no utilizar seu valor
   -- de maneira equivocada
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.DUMMY := NULL;
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4051 --*/
CREATE TRIGGER TGEAN
BEFORE INSERT OR UPDATE OR DELETE ON TT_EAN 
FOR EACH ROW EXECUTE PROCEDURE TGEAN();

/*-- SEQ 4052 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGEAN2() CASCADE;

/*-- SEQ 4053 --*/
CREATE OR REPLACE FUNCTION TGEAN2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Registrar mudanas dos dados na TT_TAB.

-- Declarao de variveis e cursores
   cLog                          VARCHAR(4000) := '';
   cFILUSU                       TT_USU.FILUSU%TYPE;
   cCODUSU                       TT_USU.CODUSU%TYPE;
   cNulo                         CONSTANT CHAR(04) := 'Nulo';
   iNulo                         CONSTANT Numeric(01) := 0;
   CRLF                          CONSTANT CHAR(01) := CHR(10);
   nCODUID                       TT_UID.CODUID%TYPE;
      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
   
-- Principal
BEGIN
         SELECT MAX(CODUID)
        INTO nCODUID
        FROM TT_UID
       WHERE SESSION_ID = USERENV('SESSIONID');
   
   select * into QuemLogou from DadosLogon();
   cFILUSU := QuemLogou.FILUSU;
   cCODUSU := QuemLogou.CODUSU;

   IF (TG_OP = 'INSERT') THEN
      cLOG := 'Inclusao da Referncia de Venda: ' || NEW.CODEAN;

      INSERT INTO TL_GRA (FILMAT, CODMAT, CODCOR, CODTAM, DATOPE, MSGLOG, FILUSU, CODUSU, CODUID)
                  VALUES (NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM, Agora(), cLOG, cFILUSU, cCODUSU, nCODUID);
   ELSIF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODEAN,NEW.CODEAN) <> 1 THEN
         cLog := cLog||'Atualizando referencia de Venda: '||COALESCE(OLD.CODEAN,cNulo)||' para '||COALESCE(NEW.CODEAN,cNulo)||CRLF;
      END IF;

      IF ISNOTNULL(TRIM(cLog)) = 'T' THEN
         INSERT INTO TL_GRA (FILMAT, CODMAT, CODCOR, CODTAM, DATOPE, MSGLOG, FILUSU, CODUSU, CODUID)
                  VALUES (NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM, Agora(), cLOG, cFILUSU, cCODUSU, nCODUID);
      END IF;
   ELSIF (TG_OP = 'DELETE') THEN
      cLOG := 'Excluindo Referncia de Venda: ' || OLD.CODEAN;

      INSERT INTO TL_GRA (FILMAT, CODMAT, CODCOR, CODTAM, DATOPE, MSGLOG, FILUSU, CODUSU, CODUID)
                  VALUES (OLD.FILMAT, OLD.CODMAT, OLD.CODCOR, OLD.CODTAM, Agora(), cLOG, cFILUSU, cCODUSU, nCODUID);
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4054 --*/
CREATE TRIGGER TGEAN2
AFTER INSERT OR UPDATE OR DELETE ON TT_EAN 
FOR EACH ROW EXECUTE PROCEDURE TGEAN2();





/*-- SEQ 4055 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGECF2() CASCADE;

/*-- SEQ 4056 --*/
CREATE OR REPLACE FUNCTION TGECF2() RETURNS TRIGGER AS $$

-- Objetivo:
-- Nao permitir exclusao
-- Atualizar PC_RECF

DECLARE

  vComplemento CONSTANT VARCHAR(100) := constante('complemento');

  --LEO 84337
  vCODUID_ATUAL TT_VEN.CODUID%TYPE; 
  vBLQ_SEM_UID  TT_CFG.BLQ_SEM_UID%TYPE;
  vSESSIONID    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');
  
-- Principal
BEGIN
  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     IF NEW.TIPTOT IS NULL THEN
        IF NEW.TOTALI IN ('DESC','CANC','I_NT','SUBS','ACRE') THEN
           NEW.TIPTOT := 'O';
        ELSE
           NEW.TIPTOT := 'M';
        END IF;
     END IF;
     
     NEW.DATOPE := TRUNC(NEW.DATOPE);
     IF (TG_OP = 'INSERT') THEN   
       IF NEW.ATU_EM IS NULL THEN
         NEW.ATU_EM := agora();
       END IF;
     ELSE
       NEW.ATU_EM := agora();
     END IF;
  END IF;

  IF (TG_OP = 'DELETE') THEN
     RAISE EXCEPTION 'PG-20001 Um lancamento de ECF nao pode ser excluido. %' , vComplemento;
  END IF;
  
  IF (TG_OP = 'INSERT') THEN
     NEW.TOTPAR :=  CASE NEW.TIPTOT WHEN 'O'
     							THEN CASE NEW.TOTALI WHEN 'SUBS' THEN 'F'||COALESCE(TO_CHAR(NEW.ORDALI),'1')
     								     			  WHEN 'ISEN' THEN 'I'||COALESCE(TO_CHAR(NEW.ORDALI),'1')
     												  WHEN 'NAOT' THEN 'N'||COALESCE(TO_CHAR(NEW.ORDALI),'1')
     												  WHEN 'CANC' THEN 'Can-T'
     												  WHEN 'DESC' THEN 'DT'
													  WHEN 'ACRE' THEN 'AT'
     												  ELSE NEW.TOTALI 
     								 END 
     					ELSE
     						CASE WHEN NEW.TIPTOT = 'M'
     						          THEN LPAD(COALESCE(TO_CHAR(NEW.ORDALI),'01'),2,'0')||'T'||SUBSTR(NEW.TOTALI,1,4)
     							 ELSE LPAD(COALESCE(TO_CHAR(NEW.ORDALI),'01'),2,'0')||'S'||SUBSTR(NEW.TOTALI,1,4)
     						END
     				  END;
  END IF;   
  
  IF (TG_OP = 'DELETE') THEN
    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
  END IF;
  
  IF (TG_OP = 'INSERT') THEN
  
    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;  
  
    -- Douglas - 83441 
    NEW.CODUID := GetCoduidAtual();	     
    NEW.ASSINA := COALESCE(AssinaTabela('TT_ECF', 
	                                    ConcatenaECF(NEW.CODFIL,
													 NEW.NUMECF,
													 NEW.DATOPE,
													 NEW.TOTALI,
													 NEW.TIPTOT,
													 NEW.TOTPAR,
													 NEW.CNT_RZ,
                                                     NEW.VLRTOT,
                                                     NEW.VLRBAS),
                                                   null, null, null),NEW.ASSINA);
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF ConcatenaECF(NEW.CODFIL,NEW.NUMECF,NEW.DATOPE,NEW.TOTALI,NEW.TIPTOT,
                      NEW.TOTPAR,NEW.CNT_RZ,NEW.VLRTOT,NEW.VLRBAS) <>
		 ConcatenaECF(OLD.CODFIL,OLD.NUMECF,OLD.DATOPE,OLD.TOTALI,OLD.TIPTOT,
                      OLD.TOTPAR,OLD.CNT_RZ,OLD.VLRTOT,OLD.VLRBAS) THEN	

         -- LEO 84337
         SELECT BLQ_SEM_UID
           INTO vBLQ_SEM_UID
           FROM TT_CFG;
         vCODUID_ATUAL := GetCoduidAtual();
         IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;  
					  
	     -- Douglas - 83441 
         NEW.CODUID := GetCoduidAtual();	     
         NEW.ASSINA := COALESCE(AssinaTabela('TT_ECF', 
 	                                         ConcatenaECF(NEW.CODFIL,
			   										      NEW.NUMECF,
			   										      NEW.DATOPE,
			   										      NEW.TOTALI,
			   										      NEW.TIPTOT,
			   										      NEW.TOTPAR,
			   										      NEW.CNT_RZ,
                                                          NEW.VLRTOT,
                                                          NEW.VLRBAS),
                                                          OLD.CODUID, 
	                                         ConcatenaECF(OLD.CODFIL,
			   										      OLD.NUMECF,
			   										      OLD.DATOPE,
			   										      OLD.TOTALI,
			   										      OLD.TIPTOT,
			   										      OLD.TOTPAR,
			   										      OLD.CNT_RZ,
                                                          OLD.VLRTOT,
                                                          OLD.VLRBAS),
                                                          OLD.ASSINA
                                                     ),NEW.ASSINA);
	  END IF;											  
   END IF;           
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4057 --*/
CREATE TRIGGER TGECF2
BEFORE INSERT OR DELETE OR UPDATE ON TT_ECF 
FOR EACH ROW EXECUTE PROCEDURE TGECF2();


/*-- SEQ 4058 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGECF3() CASCADE;

/*-- SEQ 4059 --*/
CREATE OR REPLACE FUNCTION TGECF3() RETURNS TRIGGER AS $$

-- Objetivo:
-- Nao permitir exclusao
-- Atualizar PC_RECF

DECLARE

  Reg  Record;

  cDummy VARCHAR(1);

-- Principal
BEGIN

  IF (TG_OP = 'INSERT') THEN
             SELECT NEW.CODFIl as CODFIL,NEW.NUMECF as NUMECF,NEW.DATOPE as DATOPE, NEW.CNT_RO as CNT_RO into Reg FROM DUAL;
                
         cDummy := PC_RECF_UPDATE(Reg.CODFIL,Reg.NUMECF,Reg.DATOPE,Reg.CNT_RO);
               ELSE
           SELECT NEW.CODFIl as CODFIL,NEW.NUMECF as NUMECF,NEW.DATOPE as DATOPE, NEW.CNT_RO as CNT_RO into Reg FROM DUAL;
              
         cDummy := PC_RECF_UPDATE(Reg.CODFIL,Reg.NUMECF,Reg.DATOPE, Reg.CNT_RO);
       

       SELECT NEW.CODFIl as CODFIL,NEW.NUMECF as NUMECF,NEW.DATOPE as DATOPE, NEW.CNT_RO as CNT_RO into Reg FROM DUAL;
              
         cDummy := PC_RECF_UPDATE(Reg.CODFIL,Reg.NUMECF,Reg.DATOPE,Reg.CNT_RO);
           END IF;
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4060 --*/
CREATE TRIGGER TGECF3
AFTER INSERT OR UPDATE ON TT_ECF 
FOR EACH ROW EXECUTE PROCEDURE TGECF3();



/*-- SEQ 4061 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGECF_ASS() CASCADE;

/*-- SEQ 4062 --*/
CREATE OR REPLACE FUNCTION TGECF_ASS() RETURNS TRIGGER AS $$
-- 83073
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN

  IF ExisteFilialNaUF('SC') THEN
     IF (TG_OP = 'INSERT') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG + 1
        WHERE NOMTAB = 'TT_ECF';
     END IF;  
     
     IF (TG_OP = 'DELETE') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG - 1
        WHERE NOMTAB = 'TT_ECF';
     END IF;  
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4063 --*/
CREATE TRIGGER TGECF_ASS
AFTER INSERT OR DELETE ON TT_ECF 
FOR EACH ROW EXECUTE PROCEDURE TGECF_ASS();


/*-- SEQ 4064 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGECT() CASCADE;

/*-- SEQ 4065 --*/
CREATE OR REPLACE FUNCTION TGECT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
BEGIN
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
     IF NEW.SEQUEN IS NULL THEN
        NEW.SEQUEN := ProximoCodigo('TT_ECT',NEW.CODFIL);
     END IF;
  END IF;

  IF NOT (TG_OP = 'DELETE') THEN
     NEW.CHVPRJ := NEW.CODFIL||NEW.SEQUEN;
     NEW.CHVPAI := NEW.FILECT||NEW.SEQECT;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4066 --*/
CREATE TRIGGER TGECT
BEFORE INSERT OR UPDATE ON TT_ECT 
FOR EACH ROW EXECUTE PROCEDURE TGECT();


/*-- SEQ 4067 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGEND1() CASCADE;

/*-- SEQ 4068 --*/
CREATE OR REPLACE FUNCTION TGEND1() RETURNS TRIGGER AS $$
DECLARE
   pg_dummy VARCHAR(5)
;
BEGIN
   IF PC_TRIGGERS_ENABLED('PC_CONJUGE') THEN
      pg_dummy := PC_CLEAR_LIST('PC_CONJUGE')
;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4069 --*/
CREATE TRIGGER TGEND1
BEFORE INSERT OR UPDATE ON TT_END 
FOR STATEMENT EXECUTE PROCEDURE TGEND1();

/*-- SEQ 4070 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGEND2() CASCADE;

/*-- SEQ 4071 --*/
CREATE OR REPLACE FUNCTION TGEND2() RETURNS TRIGGER AS $$
DECLARE
      cDUMMY                        VARCHAR(5);
   cFILCON                       TT_CLI.FILCON%TYPE;
   cCODCON                       TT_CLI.CODCON%TYPE;
   pg_dummy VARCHAR(5)
;
   cRet                          VARCHAR(2);
   vComplemento                  CONSTANT VARCHAR(254) := constante('complemento');
BEGIN
   -- RFMP 86079
   IF (TG_OP = 'INSERT') THEN
      IF NEW.NUMEND = 0 THEN
         RAISE EXCEPTION 'PG-20010 Cdigo do endereo "NUMEND" no pode ser zero.%' , vComplemento;
      END IF;
   END IF;
   IF NOT (TG_OP = 'DELETE') THEN
      IF PC_TRIGGERS_ENABLED('PC_CONJUGE') THEN
                    SELECT FILCON,CODCON INTO cFILCON,cCODCON
             FROM TT_CLI
            WHERE FILCLI = NEW.FILCLI
              AND CODCLI = NEW.CODCLI
              AND FILCON IS NOT NULL
              AND CODCON IS NOT NULL
              AND FLGTIP = 0;
                  IF (cFILCON IS NOT NULL) AND (cCODCON IS NOT NULL) THEN
            pg_dummy := PC_NEXT_GROUP('PC_CONJUGE');
pg_dummy := PC_ADD_LIST('PC_CONJUGE','FILCLI',true,NEW.FILCLI);
pg_dummy := PC_ADD_LIST('PC_CONJUGE','CODCLI',true,NEW.CODCLI);
pg_dummy := PC_ADD_LIST('PC_CONJUGE','FILCON',false,cFILCON);
pg_dummy := PC_ADD_LIST('PC_CONJUGE','CODCON',false,cCODCON);
pg_dummy := PC_FIND_LIST('PC_CONJUGE')
;
         END IF;
      END IF;

     IF NOT PC_TRIGGERS_ENABLED('PC_CONJUGE') THEN
       UPDATE TT_CLI SET ATU_EM = AGORA() WHERE FILCLI = NEW.FILCLI AND CODCLI = NEW.CODCLI;
     END IF;

      IF ((TG_OP = 'UPDATE')) THEN
         IF ((NEW.FILCLI || NEW.CODCLI) <> (OLD.FILCLI || OLD.CODCLI)) THEN
            UPDATE TT_CLI SET ATU_EM = AGORA() WHERE FILCLI = OLD.FILCLI AND CODCLI = OLD.CODCLI;
         END IF;
      END IF;
   END IF;

   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      IF (NEW.FLGNAC = 'F') AND (NEW.CODPAI IS NULL) THEN
         NEW.CODPAI := '1058';
      END IF;
      IF (NEW.CLI_CK IS NULL) AND (NEW.COD_CK IS NOT NULL) THEN
         NEW.CLI_CK := 0;
      END IF;
   END IF;

   IF (TG_OP = 'DELETE') THEN
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_END', OLD.FILCLI||OLD.CODCLI, OLD.CODFIL||TO_CHAR(OLD.NUMEND));
   END IF;
   IF (TG_OP = 'INSERT') THEN
      --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_END', NEW.FILCLI||NEW.CODCLI, NEW.CODFIL||TO_CHAR(NEW.NUMEND));
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4072 --*/
CREATE TRIGGER TGEND2
BEFORE INSERT OR UPDATE OR DELETE ON TT_END 
FOR EACH ROW EXECUTE PROCEDURE TGEND2();

/*-- SEQ 4073 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGEND3() CASCADE;

/*-- SEQ 4074 --*/
CREATE OR REPLACE FUNCTION TGEND3() RETURNS TRIGGER AS $$
DECLARE
      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
   -- Objetivo:
-- 1) Ajusta os valores para Telefone e DDD
-- 2) Evita brancos na coluna de CEP
--
BEGIN
   NEW.CODDDD := TO_DDD(NEW.CODDDD);
   NEW.NUMFON := TO_PHONE(NEW.NUMFON,'FORCE','BIG');
   NEW.DDDFAX := TO_DDD(NEW.DDDFAX);
   NEW.NUMFAX := TO_PHONE(NEW.NUMFAX);
   NEW.CODCEP := LTRIM(RTRIM(NEW.CODCEP));
   IF ISNULL(RTRIM(LTRIM(NEW.CODCID)))='T' THEN
      NEW.CODCID := NULL;
   END IF;

   -- So aceita digitos
   IF (TG_OP = 'INSERT') THEN
      NEW.NUMDOC := GetDigit(LTRIM(RTRIM(NEW.NUMDOC)));

      IF NEW.SIGNAT IS NULL THEN
         NEW.SIGNAT := 0;
      END IF;
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF COALESCE(OLD.NUMDOC,'#ERR#') <> COALESCE(NEW.NUMDOC,'#ERR#') THEN
         NEW.NUMDOC := GetDigit(LTRIM(RTRIM(NEW.NUMDOC)));
      END IF;
   END IF;

   IF (TRIM(NEW.DUMMY) <> Constante('VEM_DE_TGWCLI')) OR (TRIM(NEW.DUMMY) = NULL) THEN
      select * into QuemLogou from DadosLogon();
      NEW.FILUSU := QuemLogou.FILUSU;
      NEW.CODUSU := QuemLogou.CODUSU;
   END IF;
   NEW.DUMMY := NULL;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4075 --*/
CREATE TRIGGER TGEND3
BEFORE INSERT OR UPDATE ON TT_END 
FOR EACH ROW EXECUTE PROCEDURE TGEND3();

/*-- SEQ 4076 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGEND4() CASCADE;

/*-- SEQ 4077 --*/
CREATE OR REPLACE FUNCTION TGEND4() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Registrar mudanca dos dados num "log"
-- 2) "Delete cascade" na tabela de "log"
DECLARE
   cLOG                          VARCHAR(4000)     := '';
   cLogChave                     VARCHAR(40)       := '';
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   cDESEND                       TD_END.DESEND%TYPE;
   cOld                          VARCHAR(50); -- colocar Descrio no lugar dos codtab
   cNew                          VARCHAR(50);

   cVC_FILCLI                    TT_CFG.VC_FILCLI%TYPE;
   cVC_CODCLI                    TT_CFG.VC_CODCLI%TYPE;
   vComplemento                  CONSTANT VARCHAR(254)  := Constante('complemento');
   vAspas                        CONSTANT VARCHAR(1)    := CHR(39);
   iACHOU                        INTEGER;
   cRetorno                      VARCHAR(2);
   cWhere                        TM_ATU.FILTRO%TYPE;
BEGIN
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'DELETE') THEN
      SELECT VC_FILCLI, VC_CODCLI INTO cVC_FILCLI, cVC_CODCLI FROM TT_CFG;
   END IF;

   IF (TG_OP = 'INSERT') THEN
      -- Nao permite novos enderecos para o "venda ao consumidor"
      IF  ((NEW.FILCLI = cVC_FILCLI)
      AND  (NEW.CODCLI = cVC_CODCLI)) THEN
         RAISE EXCEPTION 'PG-20039 Nao e% possivel incluir novos enderecos para o "Venda ao Consumidor".%' , vAspas,vComplemento;
      END IF;
   ELSIF (TG_OP = 'DELETE') THEN
      -- Nao permite excluir enderecos para o "venda ao consumidor"
      IF  ((OLD.FILCLI = cVC_FILCLI)
      AND  (OLD.CODCLI = cVC_CODCLI)) THEN
         RAISE EXCEPTION 'PG-20039 Nao e% possivel excluir o endereco de "Venda ao Consumidor".%' , vAspas,vComplemento;
      END IF;
      -- Exclui o LOG
      iACHOU := TGR_Cliente_Existe(OLD.FILCLI, OLD.CODCLI); /* retornos possiveis 0 e 1 E -1 */
      IF (iACHOU = 0) THEN
         DELETE FROM TL_CLI WHERE FILCLI = OLD.FILCLI AND CODCLI = OLD.CODCLI;
      END IF;
   END IF;

   --Tratamento para Atualizar Tabela Pai
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN
      cWhere := 'FILCLI = ' || CHR(39) || NEW.FILCLI  || CHR(39) || ' AND CODCLI = ' || CHR(39) || NEW.CODCLI || CHR(39);
   ELSIF (TG_OP = 'DELETE') THEN
      cWhere := 'FILCLI = ' || CHR(39) || OLD.FILCLI  || CHR(39) || ' AND CODCLI = ' || CHR(39) || OLD.CODCLI || CHR(39);
   END IF;
   cRetorno := INSERE_MATU('TT_END', 'TT_CLI', cWhere);

   -- Tratamento de LOG
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN
              SELECT DEND.DESEND
          INTO cDESEND
          FROM TD_END DEND
         WHERE DEND.CODTAB = NEW.TIPEND;
      
      cLogChave := 'Endereo ' || cDESEND || ' [' || TO_CHAR(NEW.NUMEND) || ']';
   END IF;

   IF (TG_OP = 'INSERT') THEN
      cLOG := 'Incluso de ' || cLogChave;
   ELSIF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.TIPEND,NEW.TIPEND) <> 1 THEN
                     SELECT DEND.DESEND
              INTO cOld
              FROM TD_END DEND
             WHERE DEND.CODTAB = OLD.TIPEND;
         
                     SELECT DEND.DESEND INTO cNew
              FROM TD_END DEND
             WHERE DEND.CODTAB = NEW.TIPEND;
         
         cLOG := cLOG||'Descricao endereco: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCEP,NEW.CODCEP) <> 1 THEN
         cLOG := cLOG||'CEP endereco: de '||COALESCE(OLD.CODCEP,cNulo)||' para '||COALESCE(NEW.CODCEP,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCID,NEW.CODCID) <> 1 THEN
         cLOG := cLOG||'Codigo cidade: de '||COALESCE(OLD.CODCID,cNulo)||' para '||COALESCE(NEW.CODCID,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODDDD,NEW.CODDDD) <> 1 THEN
         cLOG := cLOG||'DDD: de '||COALESCE(OLD.CODDDD,cNulo)||' para '||COALESCE(NEW.CODDDD,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODLOG,NEW.CODLOG) <> 1 THEN
         cLOG := cLOG||'Logradouro endereco: de '||COALESCE(OLD.CODLOG,cNulo)||' para '||COALESCE(NEW.CODLOG,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.COMPLE,NEW.COMPLE) <> 1 THEN
         cLOG := cLOG||'Complemento endereco: de '||COALESCE(OLD.COMPLE,cNulo)||' para '||COALESCE(NEW.COMPLE,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ENDCOB,NEW.ENDCOB) <> 1 THEN
         cLOG := cLOG||'Cobranca: de '||COALESCE(OLD.ENDCOB,cNulo)||' para '||COALESCE(NEW.ENDCOB,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ENDCOR,NEW.ENDCOR) <> 1 THEN
         cLOG := cLOG||'Correspondencia: de '||COALESCE(OLD.ENDCOR,cNulo)||' para '||COALESCE(NEW.ENDCOR,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ENDERE,NEW.ENDERE) <> 1 THEN
         cLOG := cLOG||'Endereco: de '||COALESCE(OLD.ENDERE,cNulo)||' para '||COALESCE(NEW.ENDERE,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ESTRAN,NEW.ESTRAN) <> 1 THEN
         cLOG := cLOG||'Endereco estrangeiro: de '||COALESCE(OLD.ESTRAN,cNulo)||' para '||COALESCE(NEW.ESTRAN,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FLGNAC,NEW.FLGNAC) <> 1 THEN
         cLOG := cLOG||'Nacionalidade: de '||COALESCE(DescricaoDominio('EDE','FLGNAC',OLD.FLGNAC),cNulo)||' para '||COALESCE(DescricaoDominio('EDE','FLGNAC',NEW.FLGNAC),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.INSEST,NEW.INSEST) <> 1 THEN
         cLOG := cLOG||'2o. Documento: de '||COALESCE(OLD.INSEST,cNulo)||' para '||COALESCE(NEW.INSEST,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.LOCTRA,NEW.LOCTRA) <> 1 THEN
         cLOG := cLOG||'Local proximo ao endereco: de '||COALESCE(OLD.LOCTRA,cNulo)||' para '||COALESCE(NEW.LOCTRA,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NUMDOC,NEW.NUMDOC) <> 1 THEN
         cLOG := cLOG||'1o. Documento: de '||COALESCE(OLD.NUMDOC,cNulo)||' para '||COALESCE(NEW.NUMDOC,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NUMEND,NEW.NUMEND) <> 1 THEN
         cLOG := cLOG||'Ultimo endereco: de '||COALESCE(OLD.NUMEND,iNulo)||' para '||COALESCE(NEW.NUMEND,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.DDDFAX,NEW.DDDFAX) <> 1 THEN
         cLOG := cLOG||'DDD Fax: de '||COALESCE(OLD.DDDFAX,cNulo)||' para '||COALESCE(NEW.DDDFAX,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NUMFAX,NEW.NUMFAX) <> 1 THEN
         cLOG := cLOG||'Fax: de '||COALESCE(OLD.NUMFAX,cNulo)||' para '||COALESCE(NEW.NUMFAX,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NUMFON,NEW.NUMFON) <> 1 THEN
         cLOG := cLOG||'Telefone: de '||COALESCE(OLD.NUMFON,cNulo)||' para '||COALESCE(NEW.NUMFON,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.REGIAO,NEW.REGIAO) <> 1 THEN
         SELECT DREG.REGIAO INTO cOld FROM TD_REG DREG WHERE DREG.CODTAB = COALESCE(OLD.REGIAO,iNulo);
         SELECT DREG.REGIAO INTO cNew FROM TD_REG DREG WHERE DREG.CODTAB = COALESCE(NEW.REGIAO,iNulo);
         cLOG := cLOG||'Regiao endereco: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NUMERO,NEW.NUMERO) <> 1 THEN
         cLOG := cLOG||'Numero: de '||COALESCE(OLD.NUMERO,cNulo)||' para '||COALESCE(NEW.NUMERO,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.BAIRRO,NEW.BAIRRO) <> 1 THEN
         cLOG := cLOG||'Bairro: de '||COALESCE(OLD.BAIRRO,cNulo)||' para '||COALESCE(NEW.BAIRRO,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CONTAT,NEW.CONTAT) <> 1 THEN
         cLOG := cLOG||'Contato: de '||COALESCE(OLD.CONTAT,cNulo)||' para '||COALESCE(NEW.CONTAT,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NOMCID,NEW.NOMCID) <> 1 THEN
         cLOG := cLOG||'Cidade: de '||COALESCE(OLD.NOMCID,cNulo)||' para '||COALESCE(NEW.NOMCID,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SIGEST,NEW.SIGEST) <> 1 THEN
         cLOG := cLOG||'UF: de '||COALESCE(OLD.SIGEST,cNulo)||' para '||COALESCE(NEW.SIGEST,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.USA_NF,NEW.USA_NF) <> 1 THEN
         cLOG := cLOG||'Usa Nota Fiscal?: de '||COALESCE(OLD.USA_NF,cNulo)||' para '||COALESCE(NEW.USA_NF,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.CODARC,NEW.CODARC) <> 1)
      OR (Equal(OLD.TIPARC,NEW.TIPARC) <> 1) THEN
         cLOG := cLOG||'A.R.C.: de '||COALESCE(OLD.CODARC,iNulo)||'/'||COALESCE(DescricaoDominio('EDE','TIPARC',OLD.TIPARC),cNulo)||' para '||COALESCE(OLD.CODARC,iNulo)||'/'||COALESCE(DescricaoDominio('EDE','TIPARC',NEW.TIPARC),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FIL_CK,NEW.FIL_CK) <> 1 THEN
        cLOG := cLOG||'Filial para endereo cadastrado no Checkout: de '||COALESCE(OLD.FIL_CK,cNulo)||' para '||COALESCE(NEW.FIL_CK,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ECF_CK,NEW.ECF_CK) <> 1 THEN
        cLOG := cLOG||'ECF para endereo cadastrado no Checkout: de '||COALESCE(OLD.ECF_CK,cNulo)||' para '||COALESCE(NEW.ECF_CK,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.COD_CK,NEW.COD_CK) <> 1 THEN
        cLOG := cLOG||'Cdigo para endereo cadastrado no Checkout: de '||COALESCE(TO_CHAR(OLD.COD_CK),cNulo)||' para '||COALESCE(TO_CHAR(NEW.COD_CK),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CLI_CK,NEW.CLI_CK) <> 1 THEN
        cLOG := cLOG||'Cdigo para Cliente cadastrado no Checkout: de '||COALESCE(TO_CHAR(OLD.CLI_CK),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CLI_CK),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODIBG,NEW.CODIBG) <> 1 THEN
        cLOG := cLOG||'Cdigo IBGE: de '||COALESCE(OLD.CODIBG,iNulo)||' para '||COALESCE(NEW.CODIBG,iNulo)||CRLF;
      END IF;
      IF (Equal(OLD.SIGNAT,NEW.SIGNAT) <> 1) THEN
         IF NEW.SIGNAT >= 0 THEN
            cLOG := cLOG||'Ativou Endereco'||CRLF;
         ELSE
            cLOG := cLOG||'Desativou Endereco'||CRLF;
         END IF;
      END IF;
      IF (Equal(OLD.CODECO,NEW.CODECO) <> 1) THEN
         cLOG := cLOG||'Cdigo no E-commerce: de '||COALESCE(TO_CHAR(OLD.CODECO),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODECO),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODEXT,NEW.CODEXT) <> 1 THEN
         cLOG := cLOG||'Cdigo Externo: de '||COALESCE(OLD.CODEXT,cNulo)||' para '||COALESCE(NEW.CODEXT,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NOMREC,NEW.NOMREC) <> 1 THEN
         cLOG := cLOG||'Nome do Recebedor: de '||COALESCE(OLD.NOMREC,cNulo)||' para '||COALESCE(NEW.NOMREC,cNulo)||CRLF;
      END IF;
      
      
      IF ISNOTNULL(cLOG) = 'T' THEN
         cLOG := cLogChave || ' >> ' || cLOG;
      END IF;
   END IF;
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN
      IF ISNOTNULL(cLOG) = 'T' THEN
         INSERT INTO TL_CLI (FILUSU,CODUSU,FILCLI,CODCLI,DATOPE,MSGLOG)
                     VALUES (NEW.FILUSU,NEW.CODUSU,NEW.FILCLI,NEW.CODCLI,agora(),cLOG);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4078 --*/
CREATE TRIGGER TGEND4
AFTER INSERT OR UPDATE OR DELETE ON TT_END 
FOR EACH ROW EXECUTE PROCEDURE TGEND4();

/*-- SEQ 4079 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGEND5() CASCADE;

/*-- SEQ 4080 --*/
CREATE OR REPLACE FUNCTION TGEND5() RETURNS TRIGGER AS $$
DECLARE
   pg_dummy VARCHAR(5)
;
BEGIN
   IF PC_TRIGGERS_ENABLED('PC_CONJUGE') THEN
      pg_dummy := PC_INIT('PC_CONJUGE',FALSE);
pg_dummy := PC_EXECUTE('PC_CONJUGE','ATUALIZACONJUGE');
pg_dummy := PC_INIT('PC_CONJUGE')
;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4081 --*/
CREATE TRIGGER TGEND5
AFTER INSERT OR UPDATE ON TT_END 
FOR STATEMENT EXECUTE PROCEDURE TGEND5();


/*-- SEQ 4082 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGENP() CASCADE;

/*-- SEQ 4083 --*/
CREATE OR REPLACE FUNCTION TGENP() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
      NEW.SEQUEN := ProximoCodigo('TT_ENP',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4084 --*/
CREATE TRIGGER TGENP
BEFORE INSERT ON TT_ENP 
FOR EACH ROW EXECUTE PROCEDURE TGENP();


/*-- SEQ 4085 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGENV() CASCADE;

/*-- SEQ 4086 --*/
CREATE OR REPLACE FUNCTION TGENV() RETURNS TRIGGER AS $$
BEGIN
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN 
         NEW.SEQUEN := PROXIMOCODIGO('TT_ENV',NEW.CODFIL);
      END IF;
   END IF;
   NEW.DATOPE := AGORA();
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4087 --*/
CREATE TRIGGER TGENV
BEFORE INSERT ON TT_ENV 
FOR EACH ROW EXECUTE PROCEDURE TGENV();


/*-- SEQ 4088 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGEQP() CASCADE;

/*-- SEQ 4089 --*/
CREATE OR REPLACE FUNCTION TGEQP() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN := ProximoCodigo('TT_EQP',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4090 --*/
CREATE TRIGGER TGEQP
BEFORE INSERT OR DELETE OR UPDATE ON TT_EQP 
FOR EACH ROW EXECUTE PROCEDURE TGEQP();

/*-- SEQ 4091 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGEQP2() CASCADE;

/*-- SEQ 4092 --*/
CREATE OR REPLACE FUNCTION TGEQP2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Registrar mudanca dos dados num "log"
--
  vLOG VARCHAR(500)    := '';
--  CRLF CONSTANT CHAR(1) := CHR(10);
  CRLF CONSTANT VARCHAR(3) := ' - ';
  Nulo CONSTANT CHAR(1) := '0';
  vComplemento  VARCHAR(254);
  cOld VARCHAR(250);
  cNew VARCHAR(250);
  Logon  TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;

-- Principal
BEGIN
  -- Tratamento de log
  IF (TG_OP = 'UPDATE') THEN
    vComplemento  := constante('complemento');
    -- Dados do usuario
    select * into Logon from DadosLogon();
    if NOT (Logon.Encontrou) THEN
      RAISE EXCEPTION 'PG-20039 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
    END IF;
    IF Equal(OLD.FILEQP,NEW.FILEQP) <> 1
    OR Equal(OLD.SEQEQP,NEW.SEQEQP) <> 1 THEN
      IF ISNOTNULL(vLOG) = 'F' THEN
        vLOG := 'Componente: de '||OLD.FILEQP||'/'||OLD.SEQEQP||' para '||NEW.FILEQP||'/'||NEW.SEQEQP;
      ELSE
        vLOG := vLOG||CRLF||'Componente: de '||OLD.FILEQP||'/'||OLD.SEQEQP||' para '||NEW.FILEQP||'/'||NEW.SEQEQP;
      END IF;
    END IF;
    IF Equal(OLD.SIGNAT,NEW.SIGNAT) <> 1 THEN
      IF ISNOTNULL(vLOG) = 'F' THEN
        vLOG := 'Ativo?: de '||COALESCE(TO_CHAR(OLD.SIGNAT),Nulo)||' para '||COALESCE(TO_CHAR(NEW.SIGNAT),Nulo);
      ELSE
        vLOG := vLOG||CRLF||'Ativo?: de '||COALESCE(TO_CHAR(OLD.SIGNAT),Nulo)||' para '||COALESCE(TO_CHAR(NEW.SIGNAT),Nulo);
      END IF;
    END IF;
    IF Equal(OLD.FILCLI,NEW.FILCLI) <> 1
    OR Equal(OLD.CODCLI,NEW.CODCLI) <> 1
    OR Equal(OLD.FILEND,NEW.FILEND) <> 1
    OR Equal(OLD.NUMEND,NEW.NUMEND) <> 1 THEN
      IF ISNOTNULL(vLOG) = 'F' THEN
        vLOG := 'Endereco: de '||' Filial='||OLD.FILCLI||' Cliente='||OLD.CODCLI||' Filial End='||OLD.FILEND||' Numero End='||COALESCE(TO_CHAR(OLD.NUMEND),Nulo)||' para '||' Filial='||NEW.FILCLI||' Cliente='||NEW.CODCLI||' Filial End='||NEW.FILEND||' Numero End='||COALESCE(TO_CHAR(NEW.NUMEND),Nulo);
      ELSE
        vLOG := vLOG||CRLF||'Endereco: de '||' Filial='||OLD.FILCLI||' Cliente='||OLD.CODCLI||' Filial End='||OLD.FILEND||' Numero End='||COALESCE(TO_CHAR(OLD.NUMEND),Nulo)||' para '||' Filial='||NEW.FILCLI||' Cliente='||NEW.CODCLI||' Filial End='||NEW.FILEND||' Numero End='||COALESCE(TO_CHAR(NEW.NUMEND),Nulo);
      END IF;
    END IF;
    IF Equal(OLD.NUMSER,NEW.NUMSER) <> 1 THEN
      IF ISNOTNULL(vLOG) = 'F' THEN
        vLOG := 'Numero de Serie: de '||OLD.NUMSER||' para '||NEW.NUMSER;
      ELSE
        vLOG := vLOG||CRLF||'Numero de Serie: de '||OLD.NUMSER||' para '||NEW.NUMSER;
      END IF;
    END IF;
    IF Equal(OLD.DATLIM,NEW.DATLIM) <> 1 THEN
      IF ISNOTNULL(vLOG) = 'F' THEN
        vLOG := 'Data Limite: de '||COALESCE(TO_CHAR(OLD.DATLIM,'DD/MM/YYYY'),Nulo)||' para '||COALESCE(TO_CHAR(NEW.DATLIM,'DD/MM/YYYY'),Nulo);
      ELSE
        vLOG := vLOG||CRLF||'Data Limite: de '||COALESCE(TO_CHAR(OLD.DATLIM,'DD/MM/YYYY'),Nulo)||' para '||COALESCE(TO_CHAR(NEW.DATLIM,'DD/MM/YYYY'),Nulo);
      END IF;
    END IF;
    IF Equal(OLD.DESEQP,NEW.DESEQP) <> 1 THEN
      IF ISNOTNULL(vLOG) = 'F' THEN
        vLOG := 'Descricao: de '|| OLD.DESEQP||' para '||NEW.DESEQP;
      ELSE
        vLOG := vLOG||CRLF||'Descricao: de '||OLD.DESEQP||' para '||NEW.DESEQP;
      END IF;
    END IF;
    IF Equal(OLD.DATAQU,NEW.DATAQU) <> 1 THEN
      IF ISNOTNULL(vLOG) = 'F' THEN
        vLOG := 'Data de Aquisicao: de '||COALESCE(TO_CHAR(OLD.DATAQU,'DD/MM/YYYY'),Nulo)||' para '||COALESCE(TO_CHAR(NEW.DATAQU,'DD/MM/YYYY'),Nulo);
      ELSE
        vLOG := vLOG||CRLF||'Data de Aquisicao: de '||COALESCE(TO_CHAR(OLD.DATAQU,'DD/MM/YYYY'),Nulo)||' para '||COALESCE(TO_CHAR(NEW.DATAQU,'DD/MM/YYYY'),Nulo);
      END IF;
    END IF;
    IF Equal(OLD.FILCTT,NEW.FILCTT) <> 1
    OR Equal(OLD.SEQCTT,NEW.SEQCTT) <> 1 THEN
      IF ISNOTNULL(vLOG) = 'F' THEN
        vLOG := 'Contrato: de '||' Filial='||OLD.FILCTT||' Seq='||OLD.SEQCTT||' para '||' Filial='||NEW.FILCTT||' Seq='||NEW.SEQCTT;
      ELSE
        vLOG := vLOG||CRLF||'Contrato: de '||' Filial='||OLD.FILCTT||' Seq='||OLD.SEQCTT||' para '||' Filial='||NEW.FILCTT||' Seq='||NEW.SEQCTT;
      END IF;
    END IF;
    IF Equal(OLD.FILTEQ,NEW.FILTEQ) <> 1
    OR Equal(OLD.SEQTEQ,NEW.SEQTEQ) <> 1 THEN
      IF ISNOTNULL(vLOG) = 'F' THEN
        vLOG := 'Tipo de Equipamento: de '||' Filial='||OLD.FILTEQ||' Seq='||OLD.SEQTEQ || ' para '||' Filial='||NEW.FILTEQ||' Seq='||NEW.SEQTEQ;
      ELSE
        vLOG := vLOG||CRLF||'Tipo de Equipamento: de '||' Filial='||OLD.FILTEQ||' Seq='||OLD.SEQTEQ || ' para '||' Filial='||NEW.FILTEQ||' Seq='||NEW.SEQTEQ;
      END IF;
    END IF;
    IF Equal(OLD.DESMAR,NEW.DESMAR) <> 1 THEN
      IF ISNOTNULL(vLOG) = 'F' THEN
        vLOG := 'Descrio da Marca (Livre): de '|| OLD.DESMAR||' para '||NEW.DESMAR;
      ELSE
        vLOG := vLOG||CRLF||'Descrio da Marca (Livre): de '||OLD.DESMAR||' para '||NEW.DESMAR;
      END IF;
    END IF;

    WK_CODUID := GetCoduidAtual();

    IF ISNOTNULL(vLOG) = 'T' THEN
      -- Cadastra o LOG
      INSERT INTO TL_EQP (FILEQP,SEQEQP,FILUSU,CODUSU,DATOPE,MSGLOG,CODUID)
      VALUES (NEW.CODFIL,NEW.SEQUEN,Logon.FILUSU,Logon.CODUSU,agora(),vLOG,WK_CODUID);
    END IF;
    IF (COALESCE(OLD.OBSERV,'XXX')<>COALESCE(NEW.OBSERV,'XXX'))
    AND (ISNOTNULL(COALESCE(OLD.OBSERV,'<NULO>')) = 'T') THEN
        -- cadastra o LOG.
      INSERT INTO TL_EQP (FILEQP,SEQEQP,FILUSU,CODUSU,DATOPE,MSGLOG,CODUID)
      VALUES (NEW.CODFIL,NEW.SEQUEN,Logon.FILUSU,Logon.CODUSU,agora(),COALESCE(OLD.OBSERV,'<NULO>'),WK_CODUID);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4093 --*/
CREATE TRIGGER TGEQP2
AFTER INSERT OR UPDATE OR DELETE ON TT_EQP 
FOR EACH ROW EXECUTE PROCEDURE TGEQP2();


/*-- SEQ 4094 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGERR() CASCADE;

/*-- SEQ 4095 --*/
CREATE OR REPLACE FUNCTION TGERR() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Gerar um cdigo sequencial exclusivo para compor a chave primria.
-- 2. Atualiza data de incluso (INSERT)

-- Declarao de variveis e cursores
   cComplemento                  CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN := ProximoCodigo('TT_ERR',NEW.CODFIL);
      END IF;
      NEW.DATINC := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4096 --*/
CREATE TRIGGER TGERR
BEFORE INSERT OR UPDATE ON TT_ERR 
FOR EACH ROW EXECUTE PROCEDURE TGERR();


/*-- SEQ 4097 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGEST() CASCADE;

/*-- SEQ 4098 --*/
CREATE OR REPLACE FUNCTION TGEST() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

  --LEO 84337
  vCODUID_ATUAL TT_VEN.CODUID%TYPE; 
  vBLQ_SEM_UID  TT_CFG.BLQ_SEM_UID%TYPE;
  vSESSIONID    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

BEGIN
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    IF ISNULL(NEW.SEQUEN)='T' THEN
      NEW.SEQUEN:=ProximoCodigo('TT_EST',NEW.CODFIL);
    END IF;   
  END IF;   
  
  IF (TG_OP = 'INSERT') THEN
  
    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
  
    -- Douglas - 83441 
    NEW.CODUID := GetCoduidAtual();	     
    NEW.ASSINA := COALESCE(AssinaTabela('TT_EST', 
	                                    ConcatenaEST(NEW.CODFIL,
                                                     NEW.SEQUEN,
                                                     NEW.QTDEST),
                                                   null, null, null),NEW.ASSINA);
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF ConcatenaEST(NEW.CODFIL,NEW.SEQUEN,NEW.QTDEST) <>
	     ConcatenaEST(OLD.CODFIL,OLD.SEQUEN,OLD.QTDEST) THEN
		 
		 -- LEO 84337
         SELECT BLQ_SEM_UID
           INTO vBLQ_SEM_UID
           FROM TT_CFG;
         vCODUID_ATUAL := GetCoduidAtual();
         IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;
		 
	     -- Douglas - 83441 
         NEW.CODUID := GetCoduidAtual();	     
         NEW.ASSINA := COALESCE(AssinaTabela('TT_EST', 
 	                                         ConcatenaEST(NEW.CODFIL,
                                                          NEW.SEQUEN,
                                                          NEW.QTDEST),
                                                       OLD.CODUID, 
	                                         ConcatenaEST(OLD.CODFIL,
                                                          OLD.SEQUEN,
                                                          OLD.QTDEST),
                                                      OLD.ASSINA
                                                     ),NEW.ASSINA);
	  END IF;											 
   END IF;             
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4099 --*/
CREATE TRIGGER TGEST
BEFORE INSERT OR UPDATE ON TT_EST 
FOR EACH ROW EXECUTE PROCEDURE TGEST();

/*-- SEQ 4100 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGEST2() CASCADE;

/*-- SEQ 4101 --*/
CREATE OR REPLACE FUNCTION TGEST2() RETURNS TRIGGER AS $$
DECLARE
  --LEO 84337
  vCODUID_ATUAL VARCHAR(22);
  vBLQ_SEM_UID  TT_CFG.BLQ_SEM_UID%TYPE;
  vSESSIONID    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

BEGIN

  IF (TG_OP = 'DELETE') THEN
    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4102 --*/
CREATE TRIGGER TGEST2
BEFORE DELETE ON TT_EST 
FOR EACH ROW EXECUTE PROCEDURE TGEST2();


/*-- SEQ 4103 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGETI() CASCADE;

/*-- SEQ 4104 --*/
CREATE OR REPLACE FUNCTION TGETI() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
DECLARE
BEGIN
  NEW.SEQUEN:=ProximoCodigo('TT_ETI',NEW.CODFIL);
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4105 --*/
CREATE TRIGGER TGETI
BEFORE INSERT ON TT_ETI 
FOR EACH ROW EXECUTE PROCEDURE TGETI();



/*-- SEQ 4106 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGEXP() CASCADE;

/*-- SEQ 4107 --*/
CREATE OR REPLACE FUNCTION TGEXP() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

DECLARE

-- Principal
BEGIN
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    NEW.SEQUEN:=ProximoCodigo('TT_EXP',NEW.CODFIL);
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4108 --*/
CREATE TRIGGER TGEXP
BEFORE INSERT ON TT_EXP 
FOR EACH ROW EXECUTE PROCEDURE TGEXP();



/*-- SEQ 4109 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGEXT() CASCADE;

/*-- SEQ 4110 --*/
CREATE OR REPLACE FUNCTION TGEXT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Gravar o usuario que importou o arquivo

-- Principal
  QuemLogou TRetQuemLogou%ROWTYPE;
  vComplemento CONSTANT VARCHAR(254):= constante('complemento');
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN := ProximoCodigo('TT_EXT',NEW.CODFIL);
    END IF;
    select * into QuemLogou from DadosLogon();
    -- Pega CODFIL e SEQUEN do usuario logado
    IF not QuemLogou.Encontrou THEN
       RAISE EXCEPTION 'PG-20050 Voce nao e um usuario cadastrado no sistema %' , vComplemento;
    END IF;     
    NEW.FILIMP := QuemLogou.FILUSU;
    NEW.CODIMP := QuemLogou.CODUSU;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4111 --*/
CREATE TRIGGER TGEXT
BEFORE INSERT ON TT_EXT 
FOR EACH ROW EXECUTE PROCEDURE TGEXT();


/*-- SEQ 4112 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGFCP() CASCADE;

/*-- SEQ 4113 --*/
CREATE OR REPLACE FUNCTION TGFCP() RETURNS TRIGGER AS $$
DECLARE
  QuemLogou TRetQuemLogou%ROWTYPE;
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN:=ProximoCodigo('TT_FCP',NEW.CODFIL);
    END IF;
    -- preenche dados do usurio de registro
    select * into QuemLogou from DadosLogon();
    IF ((NEW.FILREG IS NULL) AND (NEW.CODREG IS NULL)) THEN
      NEW.FILREG := QuemLogou.FILUSU;
      NEW.CODREG := QuemLogou.CODUSU;
    END IF;
    NEW.DATREG := agora();
  END IF;
  
  IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
     NEW.ATU_EM := agora();
     NEW.DATMED := TRUNC(NEW.DATMED);
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4114 --*/
CREATE TRIGGER TGFCP
BEFORE INSERT OR DELETE OR UPDATE ON TT_FCP 
FOR EACH ROW EXECUTE PROCEDURE TGFCP();



/*-- SEQ 4115 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGFER2() CASCADE;

/*-- SEQ 4116 --*/
CREATE OR REPLACE FUNCTION TGFER2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
DECLARE
-- Principal
BEGIN
   IF (TG_OP = 'INSERT') THEN
      NEW.SEQUEN:=ProximoCodigo('TT_FER',NEW.CODFIL);
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4117 --*/
CREATE TRIGGER TGFER2
BEFORE INSERT ON TT_FER 
FOR EACH ROW EXECUTE PROCEDURE TGFER2();

/*-- SEQ 4118 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGFER3() CASCADE;

/*-- SEQ 4119 --*/
CREATE OR REPLACE FUNCTION TGFER3() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Manter dados da TT_UTL atualizados
-- 2) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cDUMMY                        CHAR(2);
   cOperacao                     CHAR(1);
   cRetorno                      VARCHAR(2);

   -- Principal
BEGIN
   IF (TG_OP = 'INSERT') THEN

      -- Se for feriado com loja aberta, insere dias uteis. Senao, elimina
      IF NEW.LOJABR = 'T' THEN
         cOperacao := 'I';
      ELSE
         cOperacao := 'D';
      END IF;

      -- Postgres
      
      cDUMMY := PC_FER_AUX_UPDATE(NEW.CODFIL,NEW.SEQUEN,NEW.DIAFER,NEW.MESFER,NEW.ANOFER,NEW.FILFER,NEW.LOJABR,cOperacao);
          
      -- Oracle
      
   ELSIF (TG_OP = 'DELETE') THEN

      -- Se feriado foi excluido elimina da TT_UTL e insere somente os dias que sao uteis

      -- Postgres 
      
      cDUMMY := PC_FER_AUX_UPDATE(OLD.CODFIL,OLD.SEQUEN,OLD.DIAFER,OLD.MESFER,OLD.ANOFER,OLD.FILFER,'F','U');
          
      -- Oracle
          
   ELSE -- (TG_OP = 'UPDATE')

      -- Se for uma atualizacao:
      -- 1) Elimina da TT_UTL os registros de OLD
      -- 2) Insere novamente na TT_UTL os registros de OLD que sao dias uteis
      -- 3) Insere na TT_UTL os registros de NEW

      -- Postgres
      
      cDUMMY := PC_FER_AUX_UPDATE(OLD.CODFIL,OLD.SEQUEN,OLD.DIAFER,OLD.MESFER,OLD.ANOFER,OLD.FILFER,OLD.LOJABR,'D');
      cDUMMY := PC_FER_AUX_UPDATE(OLD.CODFIL,OLD.SEQUEN,OLD.DIAFER,OLD.MESFER,OLD.ANOFER,OLD.FILFER,'F','I');    
          
      -- Oracle
      
      -- Postgres
      
      cDUMMY := PC_FER_AUX_UPDATE(NEW.CODFIL,NEW.SEQUEN,NEW.DIAFER,NEW.MESFER,NEW.ANOFER,NEW.FILFER,NEW.LOJABR,'I');
          
      -- Oracle
          
   END IF;
   
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
   
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4120 --*/
CREATE TRIGGER TGFER3
AFTER INSERT OR UPDATE OR DELETE ON TT_FER 
FOR EACH ROW EXECUTE PROCEDURE TGFER3();



/*-- SEQ 4121 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGFILXPLA() CASCADE;

/*-- SEQ 4122 --*/
CREATE OR REPLACE FUNCTION TGFILXPLA() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Declarao de variveis e cursores
   cRet                          VARCHAR(2);

-- Principal
BEGIN
   -- Gera um codigo automaticamente
   IF (TG_OP = 'INSERT') THEN
     IF NEW.SEQUEN IS NULL THEN
        NEW.SEQUEN := ProximoCodigo('TT_FILXPLA',NEW.CODFIL);
     END IF;
   END IF;
   
   IF (TG_OP = 'INSERT') THEN
      cRet := LogExclusao((TG_OP = 'DELETE'),'TT_FILXPLA', NEW.codfil, NEW.sequen);
   END IF;
   
   IF NOT (TG_OP = 'DELETE') THEN
     NEW.ATU_EM := AGORA();
   END IF;  
   
   IF (TG_OP = 'DELETE') THEN
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_FILXPLA', OLD.codfil, OLD.sequen);
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4123 --*/
CREATE TRIGGER TGFILXPLA
BEFORE INSERT OR UPDATE OR DELETE ON TT_FILXPLA 
FOR EACH ROW EXECUTE PROCEDURE TGFILXPLA();

/*-- SEQ 4124 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGFILXPLA2() CASCADE;

/*-- SEQ 4125 --*/
CREATE OR REPLACE FUNCTION TGFILXPLA2() RETURNS TRIGGER AS $$
DECLARE
   vLOG                          VARCHAR(4000)   := '';
   cNulo                         CONSTANT CHAR(4) := 'Nulo';
   CRLF                          CONSTANT CHAR(1) := CHR(10);
   cFILUSU                       VARCHAR(3);
   cCODUSU                       VARCHAR(3);    
   WK_CODUID                     TT_UID.CODUID%TYPE;

   QuemLogou TRetQuemLogou%ROWTYPE;

BEGIN
   WK_CODUID := GetCoduidAtual();
   
   select * into QuemLogou from DadosLogon();
   cFILUSU := QuemLogou.FILUSU;
   cCODUSU := QuemLogou.CODUSU;

   IF (TG_OP = 'INSERT') THEN
      vLOG := vLOG||'Unidade de negcios: '||COALESCE(TO_CHAR(NEW.codctr),cNulo)||CRLF;
      vLOG := vLOG||'Filial Selecionada: '||COALESCE(NEW.filsel,cNulo)||CRLF;
   
      IF ISNOTNULL(vLOG) = 'T' THEN
         vLOG:='Inserindo em TT_FILXPLA'||CRLF||vLOG;
      END IF;
   END IF;

   IF (TG_OP = 'UPDATE') THEN
      IF (Equal(OLD.codctr,NEW.codctr) = 0) THEN
         vLOG := vLOG||'Unidade de negcios: de '||COALESCE(TO_CHAR(OLD.codctr),cNulo)||' para '||COALESCE(TO_CHAR(NEW.codctr),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.filsel,NEW.filsel) = 0) THEN
         vLOG := vLOG||'Filial Selecionada: de '||COALESCE(OLD.filsel,cNulo)||' para '||COALESCE(NEW.filsel,cNulo)||CRLF;
      END IF;

      IF ISNOTNULL(vLOG) = 'T' THEN
         vLOG:='Alteraes em TT_FILXPLA'||CRLF||vLOG;
      END IF;
   END IF;
   
   IF (TG_OP = 'DELETE') THEN
      vLOG := vLOG||'Unidade de negcios: '||COALESCE(TO_CHAR(OLD.codctr),cNulo)||CRLF;
      vLOG := vLOG||'Filial Selecionada: '||COALESCE(OLD.filsel,cNulo)||CRLF;
   
      IF ISNOTNULL(vLOG) = 'T' THEN
         vLOG:='Deletando em TT_FILXPLA'||CRLF||vLOG;
      END IF;
   END IF;
   
   IF ISNOTNULL(vLOG) = 'T' THEN
      IF (TG_OP = 'DELETE') THEN
         INSERT INTO TL_PLA (FILPLA, CODPLA, DATOPE, FILUSU, CODUSU, MSGLOG, CODUID)
                     VALUES (OLD.FILPGT, OLD.CODPGT, Agora(), cFILUSU, cCODUSU, vLOG, WK_CODUID);
      ELSE
         INSERT INTO TL_PLA (FILPLA, CODPLA, DATOPE, FILUSU, CODUSU, MSGLOG, CODUID)
                     VALUES (NEW.FILPGT, NEW.CODPGT, Agora(), cFILUSU, cCODUSU, vLOG, WK_CODUID);
      END IF;               
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4126 --*/
CREATE TRIGGER TGFILXPLA2
AFTER INSERT OR UPDATE OR DELETE ON TT_FILXPLA 
FOR EACH ROW EXECUTE PROCEDURE TGFILXPLA2();




/*-- SEQ 4127 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGFIN2() CASCADE;

/*-- SEQ 4128 --*/
CREATE OR REPLACE FUNCTION TGFIN2() RETURNS TRIGGER AS $$
DECLARE
  -- Objetivo:
  -- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
  -- 2) Calcular e obter as chaves de transferencias identificadas

   wk_chave1                     TT_FIN.CHVTRN%TYPE;
   wk_chave2                     TT_FIN.CHVTRN%TYPE;
   vComplemento                  constant VARCHAR(100) := constante('complemento');
   wk_AplNumGer                  CHAR(1);
   wk_AplNumNum                  CHAR(1);
   vUser                         TT_USU.APEUSU%TYPE;
   cDUMMY                        VARCHAR(10);
   cNulo                         CONSTANT CHAR(4) := 'Nulo';
   cLOG                          VARCHAR(4000) := '';
   cOBSERV                       VARCHAR(4000) := '';

   CRLF CONSTANT                 CHAR(1) := CHR(10);
   cAPEUSU                       TT_USU.APEUSU%TYPE;

BEGIN

  -- PTulio - davi - 02/05/05 - 33744 - INICIO
  SELECT GetApeUsuAtual() INTO vUser FROM DUAL;

  SELECT APLNUM INTO wk_AplNumGer
    FROM TT_CTA
   WHERE CODFIL = NEW.FILGER
     AND SEQUEN = NEW.SEQGER
     AND TIPCTA = NEW.TIPGER;

  SELECT APLNUM INTO wk_AplNumNum
    FROM TT_CTA
   WHERE CODFIL = NEW.FILNUM
     AND SEQUEN = NEW.SEQNUM
     AND TIPCTA = NEW.TIPNUM;

  IF (wk_AplNumGer = 'B') AND
     (wk_AplNumNum = 'C') AND
     (PERMISSAO(vUser,183) = 0) THEN
    RAISE EXCEPTION 'PG-20043 Voce nao tem permissao para realizar transferencias de Conta Bancaria para Conta Caixa. %' , vComplemento;
  END IF;

  IF (wk_AplNumGer = 'C') AND
     (wk_AplNumNum = 'B') AND
     (PERMISSAO(vUser,184) = 0) THEN
    RAISE EXCEPTION 'PG-20044 Voce nao tem permissao para realizar transferencias de Conta Caixa para Conta Bancaria. %' , vComplemento;
  END IF;

  IF (wk_AplNumGer = 'D') AND
     (wk_AplNumNum = 'D') AND
     (PERMISSAO(vUser,185) = 0) THEN
    RAISE EXCEPTION 'PG-20045 Voce nao tem permissao para realizar transferencias entre contas de diferenca. %' , vComplemento;
  END IF;

  IF (wk_AplNumGer = 'C') AND
     (wk_AplNumNum = 'D') AND
     (PERMISSAO(vUser,186) = 0) THEN
    RAISE EXCEPTION 'PG-20046 Voce nao tem permissao para realizar transferencias de Conta Caixa para Conta de diferenca. %' , vComplemento;
  END IF;

  IF (wk_AplNumGer = 'D') AND
     (wk_AplNumNum = 'C') AND
     (PERMISSAO(vUser,187) = 0) THEN
    RAISE EXCEPTION 'PG-20047 Voce nao tem permissao para realizar transferencias de Conta de diferenca para Conta Caixa. %' , vComplemento;
  END IF;

  IF (wk_AplNumGer = 'B') AND
     (wk_AplNumNum = 'B') AND
     (PERMISSAO(vUser,188) = 0) THEN
    RAISE EXCEPTION 'PG-20048 Voce nao tem permissao para realizar transferencias entre contas bancarias %' , vComplemento;
  END IF;

  -- PTulio - davi - 02/05/05 - 33744 - FIM
  IF (TG_OP = 'DELETE') THEN
     RAISE EXCEPTION 'PG-20001 Um lancamento financeiro nao pode ser excluido. %' , vComplemento;
  END IF;

  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
     IF NEW.SEQUEN IS NULL THEN
        NEW.SEQUEN := ProximoCodigo('TT_FIN',NEW.CODFIL);
     END IF;

     NEW.DATINC := agora();

     IF NEW.CODCUS IS NULL THEN
        NEW.CODCUS := 0;
     END IF;

     IF NEW.DATFIS IS NULL THEN
       NEW.DATFIS := TRUNC(NEW.DATOPE); -- PTulio - davi - 27/04/05 - 33733
     END IF;
  END IF;

/*
R - Reforo Confirmado
I - Reforo Sangria(Negativo)
A - Reforo em Aberto(Positivo)
S - Simples(No Identificada)
*/
  -- Calcular a chave
  IF NEW.FLGFIN = 'I' THEN

     -- RFMP 90003 Exclusao da validacao da chave de transferencia
     -- Foi excluida porque o codigo PLSQL nao era exatamente igual ao codigo FOX.
     -- Tarefas 93923, 93925, 93926 e 93927 tratam a nova maneira.

     --wk_chave1 := CalcTransf(NEW.DATOPE,NEW.VLRMOV,NEW.NUMDOC,1);
     wk_chave2 := CalcTransf(NEW.DATOPE,NEW.VLRMOV,NEW.NUMDOC,2);
     --IF (NEW.CHVTRN IS NOT NULL) AND ((NEW.CHVTRN <> wk_chave1) AND (NEW.CHVTRN <> wk_chave2)) THEN
     --   RAISE EXCEPTION 'PG-20002 Chave nao confere. %' , vComplemento;
     --ELSE
       IF NEW.CHVTRN IS NULL THEN
          NEW.CHVTRN := wk_chave2;
       END IF;
     --END IF;
  END IF;

  -- Novo
  IF NEW.FLGFIN IN ('A','R') THEN
     -- Evita violacao de constraint
     IF NEW.CHVTRN IS NULL THEN
        NEW.CHVTRN := '#####';
     END IF;

  END IF;

  IF NOT (TG_OP = 'DELETE') THEN
    NEW.ATU_EM := AGORA();
  END IF;

  IF (TG_OP = 'UPDATE') THEN
    IF OLD.SIGNAT <> NEW.SIGNAT THEN
       RAISE EXCEPTION 'PG-20003 Registro foi alterado por outro usurio, refaa a consulta e tente gravar novamente. %' , vComplemento;
    END IF;
    NEW.SIGNAT := MOD(OLD.SIGNAT + 1,100000);
  END IF;

  IF (TG_OP = 'UPDATE') THEN -- log no observ RFMP 52661
     cOBSERV := TRIM(NEW.OBSERV);

     IF (Equal(OLD.FILUSU,NEW.FILUSU) <> 1) THEN
        cLOG := cLOG||'Filial Usuario: de '||COALESCE(OLD.FILUSU,cNulo)||' para '||COALESCE(NEW.FILUSU,cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.CODUSU,NEW.CODUSU) <> 1) THEN
        cLOG := cLOG||'Codigo Usuario: de '||COALESCE(OLD.CODUSU,cNulo)||' para '||COALESCE(NEW.CODUSU,cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.FILGER,NEW.FILGER) <> 1) THEN
        cLOG := cLOG||'Fil. Ger.: de '||COALESCE(OLD.FILGER,cNulo)||' para '||COALESCE(NEW.FILGER,cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.TIPGER,NEW.TIPGER) <> 1) THEN
        cLOG := cLOG||'Tipo Ger.: de '||COALESCE(OLD.TIPGER,cNulo)||' para '||COALESCE(NEW.TIPGER,cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.SEQGER,NEW.SEQGER) <> 1) THEN
        cLOG := cLOG||'Seq. Ger.: de '||COALESCE(OLD.SEQGER,cNulo)||' para '||COALESCE(NEW.SEQGER,cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.FILNUM,NEW.FILNUM) <> 1) THEN
        cLOG := cLOG||'Fil. Num.: de '||COALESCE(OLD.FILNUM,cNulo)||' para '||COALESCE(NEW.FILNUM,cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.TIPNUM,NEW.TIPNUM) <> 1) THEN
        cLOG := cLOG||'Tipo Num.: de '||COALESCE(OLD.TIPNUM,cNulo)||' para '||COALESCE(NEW.TIPNUM,cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.SEQNUM,NEW.SEQNUM) <> 1) THEN
        cLOG := cLOG||'Seq. Num.: de '||COALESCE(OLD.SEQNUM,cNulo)||' para '||COALESCE(NEW.SEQNUM,cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.DATOPE,NEW.DATOPE) <> 1) THEN
        cLOG := cLOG||'Data Ope.: de '||COALESCE(TO_CHAR(OLD.DATOPE,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATOPE,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.SEQTRN,NEW.SEQTRN) <> 1) THEN
        cLOG := cLOG||'Seq. Transf: de '||COALESCE(OLD.SEQTRN,cNulo)||' para '||COALESCE(NEW.SEQTRN,cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.VLRMOV,NEW.VLRMOV) <> 1) THEN
        cLOG := cLOG||'Val. mov.: de '||COALESCE(TO_CHAR(OLD.VLRMOV),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRMOV),cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.CODCTR,NEW.CODCTR) <> 1) THEN
        cLOG := cLOG||'Unid. Neg.: de '||COALESCE(TO_CHAR(OLD.CODCTR),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODCTR),cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.CODCUS,NEW.CODCUS) <> 1) THEN
        cLOG := cLOG||'Centro Cust.: de '||COALESCE(TO_CHAR(OLD.CODCUS),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODCUS),cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.NUMDOC,NEW.NUMDOC) <> 1) THEN
        cLOG := cLOG||'Documento.: de '||COALESCE(OLD.NUMDOC,cNulo)||' para '||COALESCE(NEW.NUMDOC,cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.FLGFIN,NEW.FLGFIN) <> 1) THEN
        cLOG := cLOG||'Est. Fin.: de '||COALESCE(OLD.FLGFIN,cNulo)||' para '||COALESCE(NEW.FLGFIN,cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.CHVTRN,NEW.CHVTRN) <> 1) THEN
        cLOG := cLOG||'Chave Transf.: de '||COALESCE(OLD.CHVTRN,cNulo)||' para '||COALESCE(NEW.CHVTRN,cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.DATFIS,NEW.DATFIS) <> 1) THEN
        cLOG := cLOG||'Data Fis.: de '||COALESCE(TO_CHAR(OLD.DATFIS,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATFIS,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.CODMOE,NEW.CODMOE) <> 1) THEN
        cLOG := cLOG||'Moeda.: de '||COALESCE(TO_CHAR(OLD.CODMOE),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODMOE),cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.FILCHR,NEW.FILCHR) <> 1) THEN
        cLOG := cLOG||'Fil. Chr.: de '||COALESCE(OLD.FILCHR,cNulo)||' para '||COALESCE(NEW.FILCHR,cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.SEQCHR,NEW.SEQCHR) <> 1) THEN
        cLOG := cLOG||'Seq. Chr.: de '||COALESCE(OLD.SEQCHR,cNulo)||' para '||COALESCE(NEW.SEQCHR,cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.FILCCC,NEW.FILCCC) <> 1) THEN
        cLOG := cLOG||'Fil. CCC.: de '||COALESCE(OLD.FILCCC,cNulo)||' para '||COALESCE(NEW.FILCCC,cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.SEQCCC,NEW.SEQCCC) <> 1) THEN
        cLOG := cLOG||'Seq. CCC.: de '||COALESCE(OLD.SEQCCC,cNulo)||' para '||COALESCE(NEW.SEQCCC,cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.ORILAN,NEW.ORILAN) <> 1) THEN
        cLOG := cLOG||'Origem.: de '||COALESCE(OLD.ORILAN,cNulo)||' para '||COALESCE(NEW.ORILAN,cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.CHVTRN2,NEW.CHVTRN2) <> 1) THEN
        cLOG := cLOG||'Chave Transf. 2: de '||COALESCE(OLD.CHVTRN2,cNulo)||' para '||COALESCE(NEW.CHVTRN2,cNulo)||CRLF;
     END IF;

     IF Equal(OLD.TRN_ID,NEW.TRN_ID) <> 1 THEN
        cLOG := cLOG||'ID Transao: de '||COALESCE(TO_CHAR(OLD.TRN_ID),cNulo)||' para '||COALESCE(TO_CHAR(NEW.TRN_ID),cNulo)||CRLF;
     END IF;

     IF Equal(OLD.DOC_ID,NEW.DOC_ID) <> 1 THEN
        cLOG := cLOG||'Identificador do Documento: de '||COALESCE(OLD.DOC_ID,cNulo)||' para '||COALESCE(NEW.DOC_ID,cNulo)||CRLF;
     END IF;

     IF Equal(OLD.FILUSU_REC,NEW.FILUSU_REC) <> 1 THEN
        cLOG := cLOG||'Filial Usurio Recebimento: de '||COALESCE(OLD.FILUSU_REC,cNulo)||' para '||COALESCE(NEW.FILUSU_REC,cNulo)||CRLF;
     END IF;

     IF Equal(OLD.CODUSU_REC,NEW.CODUSU_REC) <> 1 THEN
        cLOG := cLOG||'Cdigo Usurio Recebimento: de '||COALESCE(OLD.CODUSU_REC,cNulo)||' para '||COALESCE(NEW.CODUSU_REC,cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.DATREC,NEW.DATREC) <> 1) THEN
        cLOG := cLOG||'Data Recebimento: de '||COALESCE(TO_CHAR(OLD.DATREC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATREC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.DATINC,NEW.DATINC) <> 1) THEN
        cLOG := cLOG||'Data Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;

     IF ISNOTNULL(cLOG) = 'T' THEN
        SELECT GetApeUsuAtual() INTO cAPEUSU FROM DUAL;
        cOBSERV := cOBSERV||CRLF||cAPEUSU||' - '||TO_CHAR(AGORA(),'DD/MM/YYYY HH24:MI:SS')||CRLF||cLOG;
     END IF;

     cOBSERV := SUBSTR(cOBSERV,1,4000);
     
     NEW.OBSERV := cOBSERV;
  END IF;

  -- DN 45679 - Tabelas Financeiras
  IF (TG_OP = 'INSERT') THEN
     cDUMMY:=INSERE_LFIN_LAN('FIN',NEW.CODFIL,COALESCE(NEW.SEQTRN,NEW.SEQUEN),'--','--');
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF (Equal(OLD.DATOPE,NEW.DATOPE) <> 1) OR
        (Equal(OLD.DATFIS,NEW.DATFIS) <> 1) OR
        (Equal(OLD.VLRMOV,NEW.VLRMOV) <> 1) OR
        (Equal(OLD.FILGER,NEW.FILGER) <> 1) OR
        (Equal(OLD.SEQGER,NEW.SEQGER) <> 1) OR
        (Equal(OLD.TIPGER,NEW.TIPGER) <> 1) OR
        (Equal(OLD.FILNUM,NEW.FILNUM) <> 1) OR
        (Equal(OLD.SEQNUM,NEW.SEQNUM) <> 1) OR
        (Equal(OLD.TIPNUM,NEW.TIPNUM) <> 1) OR
        (Equal(OLD.SEQTRN,NEW.SEQTRN) <> 1) OR
        (Equal(OLD.DATFIS,NEW.DATFIS) <> 1) THEN
        cDUMMY:=INSERE_LFIN_LAN('FIN',NEW.CODFIL,COALESCE(NEW.SEQTRN,NEW.SEQUEN),'--','--');
     END IF;
  END IF;
  -- DN 45679 - Fim Tabelas Financeiras

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4129 --*/
CREATE TRIGGER TGFIN2
BEFORE INSERT OR DELETE OR UPDATE ON TT_FIN 
FOR EACH ROW EXECUTE PROCEDURE TGFIN2();



/*-- SEQ 4130 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGFIN3() CASCADE;

/*-- SEQ 4131 --*/
CREATE OR REPLACE FUNCTION TGFIN3() RETURNS TRIGGER AS $$
DECLARE
  cDUMMY             CHAR(1);
  bMudou             Boolean;
  wk_reg             TT_FIN%ROWTYPE;
  vChave             TT_FIN.CHVTRN%TYPE;
  vComplemento constant VARCHAR(100) := constante('complemento');
BEGIN

  -- Novo
  IF NEW.FLGFIN IN ('A','R') THEN

             wk_reg.CODFIL := NEW.CODFIL;
        wk_reg.SEQUEN := NEW.SEQUEN;
        wk_reg.SEQTRN := NEW.SEQTRN;
        wk_reg.CHVTRN := NEW.CHVTRN;
        wk_reg.FLGFIN := NEW.FLGFIN;
               
         bMudou := False;
         IF (TG_OP = 'UPDATE') THEN
            IF (Equal(OLD.SEQTRN,NEW.SEQTRN) = 0) OR
               (Equal(OLD.FLGFIN,NEW.FLGFIN) = 0) THEN
               bMudou := True;
            END IF;
         END IF;

         IF (TG_OP = 'INSERT') or bMudou THEN
	    SELECT CHVTRN INTO vChave
              FROM TT_FIN
             WHERE CODFIL = wk_reg.CODFIL
               AND SEQUEN = wk_reg.SEQTRN;

            IF ISNULL(TRIM(vChave))='T' THEN
               RAISE EXCEPTION 'PG-20003 Nao existe chave no lancamento de envio. %' , vComplemento;
            END IF;

            IF (wk_reg.CHVTRN IS NOT NULL) AND (wk_reg.CHVTRN <> '#####') AND (wk_reg.CHVTRN <> vChave) THEN
                RAISE EXCEPTION 'PG-20004 Chave nao confere com a do lancamento de envio. %' , vComplemento;
            ELSE
              UPDATE TT_FIN
                 SET CHVTRN = vChave
               WHERE CODFIL = wk_reg.CODFIL
                 AND SEQUEN = wk_reg.SEQUEN;
            END IF;

--            cDummy := PC_FIN_UPDATE(wk_reg.CODFIL, wk_reg.SEQUEN, wk_reg.SEQTRN, wk_reg.CHVTRN);
         END IF;

            
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4132 --*/
CREATE TRIGGER TGFIN3
AFTER INSERT OR DELETE OR UPDATE ON TT_FIN 
FOR EACH ROW EXECUTE PROCEDURE TGFIN3();





/*-- SEQ 4133 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGFLW() CASCADE;

/*-- SEQ 4134 --*/
CREATE OR REPLACE FUNCTION TGFLW() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN:=ProximoCodigo('TT_FLW',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4135 --*/
CREATE TRIGGER TGFLW
BEFORE INSERT ON TT_FLW 
FOR EACH ROW EXECUTE PROCEDURE TGFLW();

/*-- SEQ 4136 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGFLW2() CASCADE;

/*-- SEQ 4137 --*/
CREATE OR REPLACE FUNCTION TGFLW2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao

-- Declarao de variveis e cursores
   cRetorno                      VARCHAR(2);

-- Principal
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4138 --*/
CREATE TRIGGER TGFLW2
AFTER INSERT OR UPDATE OR DELETE ON TT_FLW 
FOR EACH ROW EXECUTE PROCEDURE TGFLW2();


/*-- SEQ 4139 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGFREXCOM() CASCADE;

/*-- SEQ 4140 --*/
CREATE OR REPLACE FUNCTION TGFREXCOM() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Gerar um cdigo sequencial exclusivo para compor a chave primria.
-- 2. Atualiza controles de data.

-- Principal
BEGIN

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.ID_FREXCOM IS NULL THEN
         SELECT NEXTVAL('SQFREXCOM') INTO NEW.ID_FREXCOM FROM DUAL;
      END IF;
      NEW.DATINC := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4141 --*/
CREATE TRIGGER TGFREXCOM
BEFORE INSERT OR UPDATE OR DELETE ON TT_FREXCOM 
FOR EACH ROW EXECUTE PROCEDURE TGFREXCOM();


/*-- SEQ 4142 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGFRM() CASCADE;

/*-- SEQ 4143 --*/
CREATE OR REPLACE FUNCTION TGFRM() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1)UPDATE DE TT_CLI.ATU_EM
BEGIN
   UPDATE TT_CLI SET ATU_EM = AGORA() WHERE FILCLI = NEW.FILCLI AND CODCLI = NEW.CODCLI;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4144 --*/
CREATE TRIGGER TGFRM
BEFORE INSERT OR UPDATE OR DELETE ON TT_FRM 
FOR EACH ROW EXECUTE PROCEDURE TGFRM();


/*-- SEQ 4145 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGFRO() CASCADE;

/*-- SEQ 4146 --*/
CREATE OR REPLACE FUNCTION TGFRO() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 2) Registrar mudanca dos dados num "log"
   vLOG    VARCHAR(4000)     := '';
   vFILUSU VARCHAR(3);   
   vCODUSU VARCHAR(3);
   cNulo   CONSTANT CHAR(1)   := '0';
   CRLF    CONSTANT CHAR(1)   := CHR(10); 
    
    QuemLogou TRetQuemLogou%ROWTYPE;
    WK_CODUID TT_UID.CODUID%TYPE;
BEGIN
  WK_CODUID := GetCoduidAtual();

  select * into QuemLogou from DadosLogon();
  vFILUSU := QuemLogou.FILUSU;
  vCODUSU := QuemLogou.CODUSU;
 
  -- Tratamento de "log"
  IF (TG_OP = 'DELETE') THEN
     DELETE FROM TL_FRO WHERE CODFRO = OLD.CODFRO; 
  END IF;

  -- Tratamento de log
  IF (TG_OP = 'INSERT') THEN
     vLOG := 'Inclusao';
     INSERT INTO TL_FRO (CODFRO,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
          VALUES(NEW.CODFRO,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);
  ELSIF (TG_OP = 'UPDATE') THEN

     IF Equal(OLD.CODFRO,NEW.CODFRO) <> 1 THEN
        vLOG := vLOG||'Cdigo da Frmula: de '||COALESCE(OLD.CODFRO,0)||' para '||COALESCE(NEW.CODFRO,0)||CRLF;
     END IF;     
  
     IF Equal(OLD.DESFRO,NEW.DESFRO) <> 1 THEN
        vLOG := vLOG||'Frmula: de '||COALESCE(OLD.DESFRO,cNulo)||' para '||COALESCE(NEW.DESFRO,cNulo)||CRLF;
     END IF;
         IF ISNOTNULL(trim(vLOG)) = 'T' THEN
        -- cadastra o LOG.
        INSERT INTO TL_FRO (CODFRO,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                 VALUES (NEW.CODFRO,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);
     END IF;  
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4147 --*/
CREATE TRIGGER TGFRO
AFTER INSERT OR UPDATE OR DELETE ON TT_FRO 
FOR EACH ROW EXECUTE PROCEDURE TGFRO();


/*-- SEQ 4148 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGFRP() CASCADE;

/*-- SEQ 4149 --*/
CREATE OR REPLACE FUNCTION TGFRP() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Atualiza DATINC
-- 3) Atualiza ATU_EM
 
-- Principal
BEGIN
  
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN := ProximoCodigo('TT_FRP',NEW.CODFIL);
      END IF;
      NEW.DATINC := AGORA();
   END IF;
  
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := AGORA();
   END IF;  
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4150 --*/
CREATE TRIGGER TGFRP
BEFORE INSERT OR UPDATE ON TT_FRP 
FOR EACH ROW EXECUTE PROCEDURE TGFRP();


/*-- SEQ 4151 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGFTR() CASCADE;

/*-- SEQ 4152 --*/
CREATE OR REPLACE FUNCTION TGFTR() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Gerar um cdigo sequencial exclusivo para compor a chave primria.
-- 2. Atualiza controles de data.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.ID_FTR IS NULL THEN
         SELECT NEXTVAL('SQFTR') INTO NEW.ID_FTR FROM DUAL;
      END IF;
      NEW.DATINC := Agora();
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4153 --*/
CREATE TRIGGER TGFTR
BEFORE INSERT OR UPDATE OR DELETE ON TT_FTR 
FOR EACH ROW EXECUTE PROCEDURE TGFTR();


/*-- SEQ 4154 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGFUN() CASCADE;

/*-- SEQ 4155 --*/
CREATE OR REPLACE FUNCTION TGFUN() RETURNS TRIGGER AS $$
DECLARE
   cRet                          VARCHAR(2);
BEGIN
   IF (TG_OP = 'DELETE') THEN
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_FUN', OLD.NOMFUN, NULL);
   END IF;
   IF (TG_OP = 'INSERT') THEN
      --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_FUN', NEW.NOMFUN, NULL);
   END IF;
   IF NOT (TG_OP = 'DELETE') THEN
      NEW.ATU_EM := AGORA();
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4156 --*/
CREATE TRIGGER TGFUN
BEFORE INSERT OR UPDATE OR DELETE ON TT_FUN 
FOR EACH ROW EXECUTE PROCEDURE TGFUN();


/*-- SEQ 4157 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGFXC() CASCADE;

/*-- SEQ 4158 --*/
CREATE OR REPLACE FUNCTION TGFXC() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir mudancas na chave primaria
-- 2) Impedir lancamentos para cliente venda ao consumidor
-- 3) Registrar mudanca dos dados num log
-- 4) Delete cascade na tabela de log
DECLARE
   cLOG                          VARCHAR(4000)     := '';
   cLogChave                     VARCHAR(70)       := '';
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   cDESCCC                       TD_CCC.DESCCC%TYPE;
   cOld                          VARCHAR(50); -- colocar Descrição no lugar dos codtab
   cNew                          VARCHAR(50); 
   
   cVC_FILCLI                    TT_CFG.VC_FILCLI%TYPE;
   cVC_CODCLI                    TT_CFG.VC_CODCLI%TYPE;
   vComplemento                  VARCHAR(254)        := Constante('complemento');
   vAspas                        CONSTANT VARCHAR(1) := CHR(39);
   vVem_de_UNIAO_PARCEIROS       CONSTANT VARCHAR(1) := Constante('UNIAO_PARCEIROS');
BEGIN  
   IF (TG_OP = 'INSERT') THEN
      -- Nao permite que dados de faturamento sejam lancados para o venda ao consumidor
      SELECT VC_FILCLI, VC_CODCLI INTO cVC_FILCLI, cVC_CODCLI FROM TT_CFG;
      IF  ((NEW.FILCLI = cVC_FILCLI)
      AND  (NEW.CODCLI = cVC_CODCLI)) THEN
         RAISE EXCEPTION 'PG-20039 Nao e% possivel incluir dados de faturamento para o %Venda ao Consumidor%.%' , vAspas,vAspas,vAspas,vComplemento;
      END IF;
   END IF;
   
   -- Tratamento de LOG      
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN
      SELECT DCCC.DESCCC INTO cDESCCC FROM TD_CCC DCCC WHERE DCCC.CODTAB = NEW.CODCCC;
      cLogChave := 'Dados de Faturamento ' || cDESCCC || ' [' || TO_CHAR(NEW.CODCCC) || ']';
   END IF;
   IF (TG_OP = 'INSERT') THEN
      cLOG := 'Inclusão de ' || cLogChave;      
   ELSIF (TG_OP = 'UPDATE') THEN
      -- se nao vier da uniao de parceiros
      IF (Equal(NEW.DUMMY, vVem_de_UNIAO_PARCEIROS) <> 1) THEN
         -- Impede mudancas na chave primaria
         IF (NEW.FILCLI <> OLD.FILCLI) OR
            (NEW.CODCLI <> OLD.CODCLI) OR
            (NEW.CODCCC <> OLD.CODCCC) THEN
            RAISE EXCEPTION 'PG-20040 Alguns dados de faturamento nao podem ser modificados.%' , vComplemento;
         END IF;
      END IF;

      IF Equal(OLD.CODCCC,NEW.CODCCC) <> 1 THEN
         SELECT DCCC.DESCCC INTO cOld FROM TD_CCC DCCC WHERE DCCC.CODTAB = OLD.CODCCC;
         SELECT DCCC.DESCCC INTO cNew FROM TD_CCC DCCC WHERE DCCC.CODTAB = NEW.CODCCC;
         cLOG := cLOG||'Tipo C/C: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ULTFAT,NEW.ULTFAT) <> 1 THEN
         cLOG := cLOG||'Faturamento: de '||COALESCE(TO_CHAR(OLD.ULTFAT,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ULTFAT,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
      END IF;

      IF ISNOTNULL(cLOG) = 'T' THEN
         cLOG := cLogChave || ' >> ' || cLOG;
      END IF;
   ELSIF (TG_OP = 'DELETE') THEN
      -- Exclui logs.
      DELETE FROM TL_CLI WHERE FILCLI = OLD.FILCLI AND CODCLI = OLD.CODCLI;
   END IF;   
   IF (TG_OP = 'INSERT') 
   OR (TG_OP = 'UPDATE') THEN
      IF ISNOTNULL(cLOG) = 'T' THEN
         INSERT INTO TL_CLI (FILCLI,CODCLI,DATOPE,MSGLOG)
                     VALUES (NEW.FILCLI,NEW.CODCLI,agora(),cLOG);
      END IF;
   END IF;

   IF (NOT (TG_OP = 'DELETE')) THEN
      NEW.DUMMY := NULL;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4159 --*/
CREATE TRIGGER TGFXC
BEFORE INSERT OR DELETE OR UPDATE ON TT_FXC 
FOR EACH ROW EXECUTE PROCEDURE TGFXC();


/*-- SEQ 4160 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGGAB() CASCADE;

/*-- SEQ 4161 --*/
CREATE OR REPLACE FUNCTION TGGAB() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impede excluso.
-- 2. Gerar um cdigo sequencial exclusivo para compor a chave primria.
-- 3. Atualiza controles de data.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN := ProximoCodigo('TT_GAB',NEW.CODFIL);
      END IF;
      NEW.DATINC := Agora();
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;
   
   -- Controle para Concorrencia de Transao
   IF (TG_OP = 'UPDATE') THEN
      IF (COALESCE(OLD.SIGNAT,0) <> COALESCE(NEW.SIGNAT,0)) THEN
         RAISE EXCEPTION 'PG-20003 Registro foi alterado por outro usurio, refaa a consulta e tente gravar novamente. %' , COMPLEMENTO;
      END IF;
      NEW.SIGNAT := MOD(COALESCE(OLD.SIGNAT,0) + 1,100000);
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4162 --*/
CREATE TRIGGER TGGAB
BEFORE INSERT OR UPDATE OR DELETE ON TT_GAB 
FOR EACH ROW EXECUTE PROCEDURE TGGAB();

/*-- SEQ 4163 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGGAB2() CASCADE;

/*-- SEQ 4164 --*/
CREATE OR REPLACE FUNCTION TGGAB2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Registrar mudanas dos dados na TT_GAB.

-- Declarao de variveis e cursores
   cLog                          VARCHAR(4000) := '';
   cFILUSU                       TT_USU.FILUSU%TYPE;
   cCODUSU                       TT_USU.CODUSU%TYPE;
   cNulo                         CONSTANT CHAR(04) := 'Nulo';
   iNulo                         CONSTANT Numeric(01) := 0;
   CRLF                          CONSTANT CHAR(01) := CHR(10);
   nCODUID                       TT_UID.CODUID%TYPE;
      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
   
-- Principal
BEGIN
   nCODUID := GetCoduidAtual();

   select * into QuemLogou from DadosLogon();
   cFILUSU := QuemLogou.FILUSU;
   cCODUSU := QuemLogou.CODUSU;

   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
         cLog := cLog||'Filial: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DATINC,NEW.DATINC) <> 1 THEN
         cLog := cLog||'Data Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DESGAB,NEW.DESGAB) <> 1 THEN
         cLog := cLog||'Descrio do Gabarito: de '||COALESCE(OLD.DESGAB,cNulo)||' para '||COALESCE(NEW.DESGAB,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TIPGAB,NEW.TIPGAB) <> 1 THEN
         cLog := cLog||'Tipo de Gabarito: de '||COALESCE(DescricaoDominio('GAB','TIPGAB',OLD.TIPGAB),cNulo)||' para '||COALESCE(DescricaoDominio('GAB','TIPGAB',NEW.TIPGAB),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TAMMAX,NEW.TAMMAX) <> 1 THEN
         cLog := cLog||'Tamanho Mximo do Gabarito: de '||COALESCE(OLD.TAMMAX,iNulo)||' para '||COALESCE(NEW.TAMMAX,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.TAMMIN,NEW.TAMMIN) <> 1 THEN
         cLog := cLog||'Tamanho Minimo do Gabarito: de '||COALESCE(OLD.TAMMIN,iNulo)||' para '||COALESCE(NEW.TAMMIN,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.TAMPRE,NEW.TAMPRE) <> 1 THEN
         cLog := cLog||'Tamanho do Prefixo: de '||COALESCE(OLD.TAMPRE,iNulo)||' para '||COALESCE(NEW.TAMPRE,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.ESTRUR,NEW.ESTRUR) <> 1 THEN
         cLog := cLog||'Estrutura do Gabarito: de '||COALESCE(OLD.ESTRUR,cNulo)||' para '||COALESCE(NEW.ESTRUR,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SIGNAT,NEW.SIGNAT) <> 1 THEN
         cLog := cLog||'Ativo?: de '||COALESCE(OLD.SIGNAT,iNulo)||' para '||COALESCE(NEW.SIGNAT,iNulo)||CRLF;
      END IF;

      IF ISNOTNULL(TRIM(cLog)) = 'T' THEN
         INSERT INTO TL_GAB (FILGAB, SEQGAB, DATOPE, FILUSU, CODUSU, MSGLOG, CODUID)
                     VALUES (NEW.CODFIL, NEW.SEQUEN, Agora(), cFILUSU, cCODUSU, cLog, nCODUID);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4165 --*/
CREATE TRIGGER TGGAB2
AFTER UPDATE ON TT_GAB 
FOR EACH ROW EXECUTE PROCEDURE TGGAB2();


/*-- SEQ 4166 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGGATXAPL() CASCADE;

/*-- SEQ 4167 --*/
CREATE OR REPLACE FUNCTION TGGATXAPL() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Controlar Datas e Sequenciadores

-- Principal
BEGIN
  -- Gera codigo sequencial exclusivo
  IF (TG_OP = 'INSERT') THEN
    NEW.SEQUEN := ProximoCodigo('TT_GATXAPL',NEW.FILCPR);
    NEW.DATINC := agora();
  END IF; 

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4168 --*/
CREATE TRIGGER TGGATXAPL
BEFORE INSERT OR UPDATE ON TT_GATXAPL 
FOR EACH ROW EXECUTE PROCEDURE TGGATXAPL();

/*-- SEQ 4169 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGGATXAPL2() CASCADE;

/*-- SEQ 4170 --*/
CREATE OR REPLACE FUNCTION TGGATXAPL2() RETURNS TRIGGER AS $$
DECLARE

  -- Objetivos
  -- 1) Registrar Log de alteraes
  -- 2) Atualiza ATU_EM da TT_GAT
  -- Principal
  cRetorno                      VARCHAR(2);
  cWhere                        TM_ATU.FILTRO%TYPE;
  cFILCPR                       TT_CPRXGAT.FILCPR%TYPE;
  cSEQCPR                       TT_CPRXGAT.SEQCPR%TYPE;
  cSEQGAT                       TT_CPRXGAT.SEQUEN%TYPE;
  cLOG                          VARCHAR(4000)     := '';
  cNulo                         CONSTANT CHAR(4)   := 'Nulo';
  CRLF                          CONSTANT CHAR(1)   := CHR(10);
  wk_coduid                     TT_UID.CODUID%TYPE;
  
    
    QuemLogou                     TRetQuemLogou%ROWTYPE;
  BEGIN
   --Tratamento para Atualizar Tabela Pai
   IF (TG_OP = 'INSERT') THEN
      cFILCPR := NEW.FILCPR;
      cSEQCPR := NEW.SEQCPR;
      cSEQGAT := NEW.SEQGAT;
   ELSIF (TG_OP = 'UPDATE') THEN
      cFILCPR := NEW.FILCPR;
      cSEQCPR := NEW.SEQCPR;
      cSEQGAT := NEW.SEQGAT;
   ELSIF (TG_OP = 'DELETE') THEN
      cFILCPR := OLD.FILCPR;
      cSEQCPR := OLD.SEQCPR;
      cSEQGAT := OLD.SEQGAT;
   END IF;
   IF ISNOTNULL(TO_CHAR(cFILCPR))='T' THEN
      cWhere := 'FILCPR = ' || CHR(39) || cFILCPR  || CHR(39) || ' AND SEQCPR = ' || CHR(39) || cSEQCPR || CHR(39)|| ' AND SEQUEN = ' || CHR(39) || cSEQGAT || CHR(39);
      cRetorno := INSERE_MATU('TT_GATXAPL', 'TT_CPRXGAT', cWhere);
   END IF;

   -- Tratamento para Log
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.TIPAPL,NEW.TIPAPL) <> 1 THEN
        cLOG := cLOG||'Tipo de Aplicao: '||COALESCE(OLD.TIPAPL, cNulo)||' para '||COALESCE(NEW.TIPAPL, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODDEP,NEW.CODDEP) <> 1 THEN
         cLOG := cLOG||'Cdigo do Departamento: de '||COALESCE(TO_CHAR(OLD.CODDEP),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODDEP),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCL1,NEW.CODCL1) <> 1 THEN
         cLOG := cLOG||'Cdigo do Classe 1: de '||COALESCE(TO_CHAR(OLD.CODCL1),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODCL1),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCL2,NEW.CODCL2) <> 1 THEN
         cLOG := cLOG||'Cdigo do Classe 2: de '||COALESCE(TO_CHAR(OLD.CODCL2),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODCL2),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCL3,NEW.CODCL3) <> 1 THEN
         cLOG := cLOG||'Cdigo do Classe 3: de '||COALESCE(TO_CHAR(OLD.CODCL3),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODCL3),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCL4,NEW.CODCL4) <> 1 THEN
         cLOG := cLOG||'Cdigo do Classe 4: de '||COALESCE(TO_CHAR(OLD.CODCL4),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODCL4),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRAPL,NEW.VLRAPL) <> 1 THEN
         cLOG := cLOG||'Valor aplicado para o Desconto: de '||COALESCE(TO_CHAR(OLD.VLRAPL),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRAPL),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.QTDAPL,NEW.QTDAPL) <> 1 THEN
         cLOG := cLOG||'Aplicar somente sobre a quantidade de produtos: de '||COALESCE(TO_CHAR(OLD.QTDAPL),cNulo)||' para '||COALESCE(TO_CHAR(NEW.QTDAPL),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.MULAPL,NEW.MULAPL) <> 1 THEN
         cLOG := cLOG||'Aplicao realizada sobre mltiplos?: '||COALESCE(OLD.MULAPL, cNulo)||' para '||COALESCE(NEW.MULAPL, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILMAT,NEW.FILMAT) <> 1 or Equal(OLD.CODMAT,NEW.CODMAT) <> 1 or
         Equal(OLD.CODCOR,NEW.CODCOR) <> 1 or Equal(OLD.CODTAM,NEW.CODTAM) <> 1 THEN
         cLOG := cLOG||'Produto: de '||COALESCE(OLD.FILMAT,cNulo)||COALESCE(OLD.CODMAT,cNulo)||'-'||COALESCE(TO_CHAR(OLD.CODCOR),cNulo)||'-'||COALESCE(TO_CHAR(OLD.CODTAM),cNulo)||' para '||
                                                 COALESCE(NEW.FILMAT,cNulo)||COALESCE(NEW.CODMAT,cNulo)||'-'||COALESCE(TO_CHAR(NEW.CODCOR),cNulo)||'-'||COALESCE(TO_CHAR(NEW.CODTAM),cNulo)||CRLF;
      END IF;

    WK_CODUID := GetCoduidAtual();

    -- MN - Grava Log
   IF ISNOTNULL(cLOG) = 'T' THEN
      cLOG := 'Aplicao do Gatilho sobre Produtos  >> '||cLOG||CRLF;
         
      select * into QuemLogou from DadosLogon();
      INSERT INTO TL_CPR (FILCPR,SEQCPR,FILUSU,CODUSU,DATOPE,MSGLOG,CODUID)
                  VALUES (NEW.FILCPR,NEW.SEQCPR,QuemLogou.FILUSU,QuemLogou.CODUSU,agora(),cLOG,WK_CODUID);
   END IF;
    
   END IF; -- Fim IF do (TG_OP = 'UPDATE')
   
   IF (TG_OP = 'DELETE') THEN
      WK_CODUID := GetCoduidAtual();
      
      cLOG := 'Aplicao do Gatilho sobre Produtos - Registro Excludo >> '||OLD.FILCPR ||'/'||OLD.SEQCPR ||'/'||OLD.SEQGAT||'/'||OLD.SEQUEN||CRLF;
      
      select * into QuemLogou from DadosLogon();
         INSERT INTO TL_CPR (FILCPR,SEQCPR,FILUSU,CODUSU,DATOPE,MSGLOG,CODUID)
                     VALUES (OLD.FILCPR,OLD.SEQCPR,QuemLogou.FILUSU,QuemLogou.CODUSU,agora(),cLOG,WK_CODUID);
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4171 --*/
CREATE TRIGGER TGGATXAPL2
AFTER INSERT OR DELETE OR UPDATE ON TT_GATXAPL 
FOR EACH ROW EXECUTE PROCEDURE TGGATXAPL2();


/*-- SEQ 4172 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGGATXCLI() CASCADE;

/*-- SEQ 4173 --*/
CREATE OR REPLACE FUNCTION TGGATXCLI() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Controlar Datas e Sequenciadores

-- Principal
BEGIN
  -- Gera codigo sequencial exclusivo
  IF (TG_OP = 'INSERT') THEN
    NEW.SEQUEN := ProximoCodigo('TT_GATXCLI',NEW.FILCPR);
    NEW.DATINC := agora();
  END IF; 

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4174 --*/
CREATE TRIGGER TGGATXCLI
BEFORE INSERT OR UPDATE ON TT_GATXCLI 
FOR EACH ROW EXECUTE PROCEDURE TGGATXCLI();

/*-- SEQ 4175 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGGATXCLI2() CASCADE;

/*-- SEQ 4176 --*/
CREATE OR REPLACE FUNCTION TGGATXCLI2() RETURNS TRIGGER AS $$
DECLARE

  -- Objetivos
  -- 1) Registrar Log de alteraes
  -- 2) Atualiza ATU_EM da TT_GAT
  -- Principal
  cRetorno                      VARCHAR(2);
  cWhere                        TM_ATU.FILTRO%TYPE;
  cFILCPR                       TT_CPRXGAT.FILCPR%TYPE;
  cSEQCPR                       TT_CPRXGAT.SEQCPR%TYPE;
  cSEQGAT                       TT_CPRXGAT.SEQUEN%TYPE;
  cLOG                          VARCHAR(4000)     := '';
  cNulo                         CONSTANT CHAR(4)   := 'Nulo';
  iNulo                         CONSTANT Numeric(1) := 0;
  CRLF                          CONSTANT CHAR(1)   := CHR(10);
  wk_coduid                     TT_UID.CODUID%TYPE;
  
    
    QuemLogou                     TRetQuemLogou%ROWTYPE;
  BEGIN
   --Tratamento para Atualizar Tabela Pai
   IF (TG_OP = 'INSERT') THEN
      cFILCPR := NEW.FILCPR;
      cSEQCPR := NEW.SEQCPR;
      cSEQGAT := NEW.SEQGAT;
   ELSIF (TG_OP = 'UPDATE') THEN
      cFILCPR := NEW.FILCPR;
      cSEQCPR := NEW.SEQCPR;
      cSEQGAT := NEW.SEQGAT;
   ELSIF (TG_OP = 'DELETE') THEN
      cFILCPR := OLD.FILCPR;
      cSEQCPR := OLD.SEQCPR;
      cSEQGAT := OLD.SEQGAT;
   END IF;
   IF ISNOTNULL(TO_CHAR(cFILCPR))='T' THEN
      cWhere := 'FILCPR = ' || CHR(39) || cFILCPR  || CHR(39) || ' AND SEQCPR = ' || CHR(39) || cSEQCPR || CHR(39)|| ' AND SEQUEN = ' || CHR(39) || cSEQGAT || CHR(39);
      cRetorno := INSERE_MATU('TT_GATXCLI', 'TT_CPRXGAT', cWhere);
   END IF;

   -- Tratamento para Log
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.FILCLI,NEW.FILCLI) <> 1 THEN
         cLOG := cLOG||'Filial do Cliente: '||COALESCE(OLD.FILCLI, cNulo)||' para '||COALESCE(NEW.FILCLI, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCLI,NEW.CODCLI) <> 1 THEN
         cLOG := cLOG||'Cdigo do Cliente: '||COALESCE(OLD.CODCLI, cNulo)||' para '||COALESCE(NEW.CODCLI, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCT1,NEW.CODCT1) <> 1 THEN
         cLOG := cLOG||'Cdigo do Categoria 1: de '||COALESCE(TO_CHAR(OLD.CODCT1),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODCT1),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCT2,NEW.CODCT2) <> 1 THEN
         cLOG := cLOG||'Cdigo do Categoria 2: de '||COALESCE(TO_CHAR(OLD.CODCT2),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODCT2),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCT3,NEW.CODCT3) <> 1 THEN
         cLOG := cLOG||'Cdigo do Categoria 3: de '||COALESCE(TO_CHAR(OLD.CODCT3),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODCT3),cNulo)||CRLF;
      END IF;

      WK_CODUID := GetCoduidAtual();

      -- MN - Grava Log
      IF ISNOTNULL(cLOG) = 'T' THEN
         cLOG := 'Regras Aplicao Cliente  >> '||cLOG||CRLF;
         
         select * into QuemLogou from DadosLogon();
         INSERT INTO TL_CPR (FILCPR,SEQCPR,FILUSU,CODUSU,DATOPE,MSGLOG,CODUID)
                     VALUES (NEW.FILCPR,NEW.SEQCPR,QuemLogou.FILUSU,QuemLogou.CODUSU,agora(),cLOG,WK_CODUID);
      END IF;
   END IF; -- Fim IF do (TG_OP = 'UPDATE')

   IF (TG_OP = 'DELETE') THEN
      WK_CODUID := GetCoduidAtual();
      
      cLOG := 'Regras Aplicao Cliente - Registro Excludo >> '|| OLD.FILCPR ||'/'||OLD.SEQCPR ||'/'||OLD.SEQGAT||'/'||OLD.SEQUEN||CRLF;
      
      select * into QuemLogou from DadosLogon();
         INSERT INTO TL_CPR (FILCPR,SEQCPR,FILUSU,CODUSU,DATOPE,MSGLOG,CODUID)
                     VALUES (OLD.FILCPR,OLD.SEQCPR,QuemLogou.FILUSU,QuemLogou.CODUSU,agora(),cLOG,WK_CODUID);
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4177 --*/
CREATE TRIGGER TGGATXCLI2
AFTER INSERT OR DELETE OR UPDATE ON TT_GATXCLI 
FOR EACH ROW EXECUTE PROCEDURE TGGATXCLI2();


/*-- SEQ 4178 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGGATXPRO() CASCADE;

/*-- SEQ 4179 --*/
CREATE OR REPLACE FUNCTION TGGATXPRO() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Controlar Datas e Sequenciadores

-- Principal
BEGIN
  -- Gera codigo sequencial exclusivo
  IF (TG_OP = 'INSERT') THEN
    NEW.SEQUEN := ProximoCodigo('TT_GATXPRO',NEW.FILCPR);
    NEW.DATINC := agora();
  END IF; 

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4180 --*/
CREATE TRIGGER TGGATXPRO
BEFORE INSERT OR UPDATE ON TT_GATXPRO 
FOR EACH ROW EXECUTE PROCEDURE TGGATXPRO();

/*-- SEQ 4181 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGGATXPRO2() CASCADE;

/*-- SEQ 4182 --*/
CREATE OR REPLACE FUNCTION TGGATXPRO2() RETURNS TRIGGER AS $$
DECLARE

  -- Objetivos
  -- 1) Registrar Log de alteraes
  -- 2) Atualiza ATU_EM da TT_GAT
  -- Principal
  cRetorno                      VARCHAR(2);
  cWhere                        TM_ATU.FILTRO%TYPE;
  cFILCPR                       TT_CPRXGAT.FILCPR%TYPE;
  cSEQCPR                       TT_CPRXGAT.SEQCPR%TYPE;
  cSEQGAT                       TT_CPRXGAT.SEQUEN%TYPE;
  cLOG                          VARCHAR(4000)     := '';
  cNulo                         CONSTANT CHAR(4)   := 'Nulo';
  CRLF                          CONSTANT CHAR(1)   := CHR(10);
  wk_coduid                     TT_UID.CODUID%TYPE;
  
    
    QuemLogou                     TRetQuemLogou%ROWTYPE;
  BEGIN
   --Tratamento para Atualizar Tabela Pai
   IF (TG_OP = 'INSERT') THEN
      cFILCPR := NEW.FILCPR;
      cSEQCPR := NEW.SEQCPR;
      cSEQGAT := NEW.SEQGAT;
   ELSIF (TG_OP = 'UPDATE') THEN
      cFILCPR := NEW.FILCPR;
      cSEQCPR := NEW.SEQCPR;
      cSEQGAT := NEW.SEQGAT;
   ELSIF (TG_OP = 'DELETE') THEN
      cFILCPR := OLD.FILCPR;
      cSEQCPR := OLD.SEQCPR;
      cSEQGAT := OLD.SEQGAT;
   END IF;
   IF ISNOTNULL(TO_CHAR(cFILCPR))='T' THEN
      cWhere := 'FILCPR = ' || CHR(39) || cFILCPR  || CHR(39) || ' AND SEQCPR = ' || CHR(39) || cSEQCPR || CHR(39)|| ' AND SEQUEN = ' || CHR(39) || cSEQGAT || CHR(39);
      cRetorno := INSERE_MATU('TT_GATXPRO', 'TT_CPRXGAT', cWhere);
   END IF;

   -- Tratamento para Log
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.QTDMIN,NEW.QTDMIN) <> 1 THEN
         cLOG := cLOG||'Quantidade mnimo de compra: de '||COALESCE(TO_CHAR(OLD.QTDMIN),cNulo)||' para '||COALESCE(TO_CHAR(NEW.QTDMIN),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.QTDMAX,NEW.QTDMAX) <> 1 THEN
         cLOG := cLOG||'Quantidade mxima de compra: de '||COALESCE(TO_CHAR(OLD.QTDMAX),cNulo)||' para '||COALESCE(TO_CHAR(NEW.QTDMAX),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODDEP,NEW.CODDEP) <> 1 THEN
         cLOG := cLOG||'Cdigo do Departamento: de '||COALESCE(TO_CHAR(OLD.CODDEP),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODDEP),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCL1,NEW.CODCL1) <> 1 THEN
         cLOG := cLOG||'Cdigo de Classe 1: de '||COALESCE(TO_CHAR(OLD.CODCL1),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODCL1),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCL2,NEW.CODCL2) <> 1 THEN
         cLOG := cLOG||'Cdigo de Classe 2: de '||COALESCE(TO_CHAR(OLD.CODCL2),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODCL2),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCL3,NEW.CODCL3) <> 1 THEN
         cLOG := cLOG||'Cdigo de Classe 3: de '||COALESCE(TO_CHAR(OLD.CODCL3),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODCL3),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCL4,NEW.CODCL4) <> 1 THEN
         cLOG := cLOG||'Cdigo de Classe 4: de '||COALESCE(TO_CHAR(OLD.CODCL4),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODCL4),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILMAT,NEW.FILMAT) <> 1 or Equal(OLD.CODMAT,NEW.CODMAT) <> 1 or
         Equal(OLD.CODCOR,NEW.CODCOR) <> 1 or Equal(OLD.CODTAM,NEW.CODTAM) <> 1 THEN
         cLOG := cLOG||'Produto: de '||COALESCE(OLD.FILMAT,cNulo)||COALESCE(OLD.CODMAT,cNulo)||'-'||COALESCE(TO_CHAR(OLD.CODCOR),cNulo)||'-'||COALESCE(TO_CHAR(OLD.CODTAM),cNulo)||' para '||
                                                 COALESCE(NEW.FILMAT,cNulo)||COALESCE(NEW.CODMAT,cNulo)||'-'||COALESCE(TO_CHAR(NEW.CODCOR),cNulo)||'-'||COALESCE(TO_CHAR(NEW.CODTAM),cNulo)||CRLF;
      END IF;

      WK_CODUID := GetCoduidAtual();

      -- MN - Grava Log
      IF ISNOTNULL(cLOG) = 'T' THEN
         cLOG := 'Regras aplicao Produto  >> '||cLOG||CRLF;
         
         select * into QuemLogou from DadosLogon();
         INSERT INTO TL_CPR (FILCPR,SEQCPR,FILUSU,CODUSU,DATOPE,MSGLOG,CODUID)
                     VALUES (NEW.FILCPR,NEW.SEQCPR,QuemLogou.FILUSU,QuemLogou.CODUSU,agora(),cLOG,WK_CODUID);
      END IF;
   END IF; -- Fim IF do (TG_OP = 'UPDATE')

   IF (TG_OP = 'DELETE') THEN
      WK_CODUID := GetCoduidAtual();
      
      cLOG := 'Regras Aplicao Produto - Registro Excludo >> '||OLD.FILCPR ||'/'||OLD.SEQCPR ||'/'||OLD.SEQGAT||'/'||OLD.SEQUEN||CRLF;
      
      select * into QuemLogou from DadosLogon();
         INSERT INTO TL_CPR (FILCPR,SEQCPR,FILUSU,CODUSU,DATOPE,MSGLOG,CODUID)
                     VALUES (OLD.FILCPR,OLD.SEQCPR,QuemLogou.FILUSU,QuemLogou.CODUSU,agora(),cLOG,WK_CODUID);
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4183 --*/
CREATE TRIGGER TGGATXPRO2
AFTER INSERT OR DELETE OR UPDATE ON TT_GATXPRO 
FOR EACH ROW EXECUTE PROCEDURE TGGATXPRO2();



/*-- SEQ 4184 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGGRA2() CASCADE;

/*-- SEQ 4185 --*/
CREATE OR REPLACE FUNCTION TGGRA2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Impedir o lancamento de itens de divisao ou subdivisao que nao estejam vinculados a grade
-- 2) Impedir a utilizacao de uma referencia identica a referencia basica de um produto
-- 3) "Delete cascade" na tabela de "log"
-- 4) Impedir que a unidade de compra seja diferente da unidade de venda
--    e que o valor de conversao seja diferente de 1, mas desde que o produto
--    controle embalagem
-- 5) Checar a referencia
-- 6) Atualizar custos na TR_MOV
-- 7) Registrar Pendncias para Atualizar os Impostos de Fornecedores Calculados
--

   -- Testes quanto ao conteudo da referencia
   SOMENTE_ALFANUMERICO          CONSTANT INTEGER := 0;
   SOMENTE_NUMERICO              CONSTANT INTEGER := 1;
   EAN_OU_ALFANUMERICO           CONSTANT INTEGER := 2;
   EAN_OU_NUMERICO               CONSTANT INTEGER := 3;
   Tipo                          TT_CFG.PATIPOREF%TYPE;

   -- Demais testes
   codigo_divisao                TD_GRA.CODDIV%TYPE;
   codigo_divisao_auxiliar       TD_GRA.CODDIV%TYPE;
   cod_subdivisao                TD_GRA.CODSUB%TYPE;
   cod_subdivisao_auxiliar       TD_GRA.CODSUB%TYPE;
   cod_embalagem                 TD_SUB.CODSAL%TYPE;
   grade                         TD_GRA.NOMGRA%TYPE;
   nome_divisao                  TD_DIV.NOMDIV%TYPE;
   nome_divisao_auxiliar         TD_DIV.NOMDIV%TYPE;
   nome_subdivisao               TD_SUB.NOMSUB%TYPE;
   nome_subdivisao_auxiliar      TD_SUB.NOMSUB%TYPE;
   nome_item_divisao             TT_DIV.NOMITE%TYPE;
   nome_item_subdivisao          TT_SUB.NOMITE%TYPE;
   regra_codfis_aux              TT_CFG.REGRA_CODFIS%TYPE;
   codigo_saldo                  TD_SUB.CODSAL%TYPE;
   mensagem                      VARCHAR(155);
   erro                          Numeric(1) := 0;

   prefixo                       Numeric;
   bAux                          BOOLEAN := false;
   vComplemento                  CONSTANT VARCHAR(254) := Constante('complemento');
   vLixo                         VARCHAR(1);
   vAspas                        VARCHAR(1) := CHR(39);
   WK_GERA_CODEXT_INTEGRACAO     TT_CFG.GERA_CODEXT_INTEGRACAO%TYPE;
      
   vTemp                         VARCHAR(2);
      
   cRetorno                      VARCHAR(2);

   
   --LEO 84337
   vCODUID_ATUAL                 TT_VEN.CODUID%TYPE;
   vBLQ_SEM_UID                  TT_CFG.BLQ_SEM_UID%TYPE;
   vSESSIONID                    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

   -- Pedro E. Braga - 93794
   cFPVPRECOSIMULADO             TT_CFG.FPV_PRECO_SIMULADO%TYPE;
   cMantemAtuEm                  VARCHAR(1);
   cWhere                        TM_ATU.FILTRO%TYPE;

   -- MMC -> 2023029237
   cFILMAT                       VARCHAR(3);
   cCODMAT                       VARCHAR(6);
   nCODTAM                       Numeric;
   nCODCOR                       Numeric;
   
-- Principal
BEGIN
   -- Inicializao de variveis e regras
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN
      IF COALESCE(TRIM(NEW.DUMMY),'#') = Constante('MANTEM_ATU_EM') THEN
         cMantemAtuEm := 'T';
      ELSE
         cMantemAtuEm := 'F';
      END IF;
   ELSIF (TG_OP = 'DELETE') THEN
      cMantemAtuEm := 'F';
   END IF;

   
   IF NOT (TG_OP = 'DELETE') THEN
      -- MMC -> 2023029237
      cFILMAT := NEW.FILMAT;
      cCODMAT := NEW.CODMAT;
      nCODCOR := NEW.CODCOR;
      nCODTAM := NEW.CODTAM;

      -- RFMP 101132
      IF (TG_OP = 'INSERT') OR (cMantemAtuEm = 'F') THEN
         NEW.ATU_EM := AGORA();
      END IF;
      IF COALESCE(NEW.VALCON,0)=0 THEN
         NEW.VALCON:=1;
      END IF;
      IF (TG_OP = 'INSERT') THEN
         SELECT GERA_CODEXT_INTEGRACAO INTO WK_GERA_CODEXT_INTEGRACAO FROM TT_CFG;
         IF (NEW.CODEXT IS NULL) AND (WK_GERA_CODEXT_INTEGRACAO = 'T') THEN
            NEW.CODEXT := TRIM(NEW.FILMAT)||'-'||TRIM(NEW.CODMAT)||'-'||TO_CHAR(NEW.CODCOR)||'-'||TO_CHAR(NEW.CODTAM);
         END IF;
      END IF;

      -- Obriga sempre CAIXA ALTA
      NEW.DESGRA := Upper(NEW.DESGRA);
   END IF;

   IF (TG_OP = 'DELETE') THEN
      -- MMC -> 2023029237
      cFILMAT := OLD.FILMAT;
      cCODMAT := OLD.CODMAT;
      nCODCOR := OLD.CODCOR;
      nCODTAM := OLD.CODTAM;

      cRetorno := LogExclusao((TG_OP = 'DELETE'), 'TT_GRA', RPAD( OLD.FILMAT || OLD.CODMAT || '-' || TO_CHAR(OLD.CODCOR) || '-' || TO_CHAR(OLD.CODTAM), 20,' ' ), NULL);
   END IF;
   
   IF (TG_OP = 'INSERT') THEN
      --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
      cRetorno := LogExclusao((TG_OP = 'DELETE'), 'TT_GRA', RPAD( NEW.FILMAT || NEW.CODMAT || '-' || TO_CHAR(NEW.CODCOR) || '-' || TO_CHAR(NEW.CODTAM), 20,' ' ), NULL);
   END IF;
   
   IF (TG_OP = 'UPDATE') THEN
      -- MMC - 2023029237
      cFILMAT := NEW.FILMAT;
      cCODMAT := NEW.CODMAT;
      nCODCOR := NEW.CODCOR;
      nCODTAM := NEW.CODTAM;

		IF Equal(OLD.SKYHUB,NEW.SKYHUB) <> 1 THEN
			IF NEW.SKYHUB = 'T' THEN 
				cRetorno := LogExclusao(FALSE, 'GRA.SKYHUB', RPAD( NEW.FILMAT || NEW.CODMAT || '-' || TO_CHAR(NEW.CODCOR) || '-' || TO_CHAR(NEW.CODTAM), 20,' ' ), NULL);				
			ELSE
				cRetorno := LogExclusao(TRUE, 'GRA.SKYHUB', RPAD( NEW.FILMAT || NEW.CODMAT || '-' || TO_CHAR(NEW.CODCOR) || '-' || TO_CHAR(NEW.CODTAM), 20,' ' ), NULL);
			END IF;
		END IF;
   END IF;

   -- Obtem o formato possivel de referencia basica e Checa o tipo de referencia
   SELECT PATIPOREF INTO Tipo FROM TT_CFG;

   -- MN - Carrega informaes de diviso e subdiviso que usadas em algumas validaes
   SELECT NOMGRA,CODDIV,CODSUB,NOMDIV,NOMSUB
     INTO GRADE,CODIGO_DIVISAO,COD_SUBDIVISAO,NOME_DIVISAO,NOME_SUBDIVISAO
     FROM (SELECT 0 AS DUMMY1 FROM DUAL) D1
             LEFT OUTER JOIN
         (SELECT 0 AS DUMMY2, DGRA.NOMGRA, DGRA.CODDIV, DGRA.CODSUB, DDIV.NOMDIV, DSUB.NOMSUB
          FROM TT_PRO PRO INNER JOIN TD_GRA DGRA ON PRO.CODGRA  = DGRA.CODTAB
                          INNER JOIN TD_DIV DDIV ON DGRA.CODDIV = DDIV.CODTAB
                          INNER JOIN TD_SUB DSUB ON DGRA.CODSUB = DSUB.CODTAB
          WHERE PRO.FILMAT = cFILMAT AND PRO.CODMAT = cCODMAT) D2
         ON D1.DUMMY1 = D2.DUMMY2;

   SELECT NOMITE,CODDIV,NOMDIV
     INTO NOME_ITEM_DIVISAO, CODIGO_DIVISAO_AUXILIAR, NOME_DIVISAO_AUXILIAR
     FROM (SELECT 0 AS DUMMY1 FROM DUAL) D1
      LEFT OUTER JOIN
      (SELECT 0 AS DUMMY2,DIV.NOMITE,DIV.CODDIV,DDIV.NOMDIV
       FROM TT_DIV DIV INNER JOIN TD_DIV DDIV ON DIV.CODDIV = DDIV.CODTAB
       WHERE DIV.CODITE = nCODCOR) D2
      ON D1.DUMMY1 = D2.DUMMY2;

   -- Confirma se o item de subdivisao pertence ao grupo de grade e tambem se controla embalagem
     SELECT SUB.NOMITE, SUB.CODSUB, DSUB.NOMSUB, DSUB.CODSAL
       INTO NOME_ITEM_SUBDIVISAO, COD_SUBDIVISAO_AUXILIAR, NOME_SUBDIVISAO_AUXILIAR, COD_EMBALAGEM
       FROM TT_SUB SUB INNER JOIN TD_SUB DSUB ON SUB.CODSUB = DSUB.CODTAB
      WHERE SUB.CODITE = nCODTAM;

   IF (TG_OP = 'INSERT') THEN
      bAux:=true;
   END IF;

   IF (TG_OP = 'UPDATE') THEN
      IF COALESCE(OLD.REFPRO,'#ERR1') <> COALESCE(NEW.REFPRO,'#ERR2') THEN
         bAux:=true;
      END IF;
      --Pedro E. Braga - 93794
      SELECT FPV_PRECO_SIMULADO INTO cFPVPRECOSIMULADO FROM TT_CFG;
      IF (cFPVPRECOSIMULADO = 'T') THEN
         -- Mateus 92861
         IF (Equal(OLD.PESBRU, NEW.PESBRU) <> 1) THEN
            cRetorno := INSERE_MIFC('GRA',NEW.FILMAT || NEW.CODMAT || RPAD(TO_CHAR(NEW.CODCOR),5,' ') || RPAD(TO_CHAR(NEW.CODTAM),5,' '));
         END IF;
      END IF;
   END IF;

   IF bAux THEN
      IF (NEW.REFPRO IS NULL) THEN
         IF (Tipo = EAN_OU_ALFANUMERICO) OR (Tipo = EAN_OU_NUMERICO) THEN
            -- Calcula e grava o codigo EAN
            NEW.REFPRO := TGR_Grava_EAN(NEW.REFPRO);
            NEW.REFPRO := EAN8(TO_CHAR(NEW.REFPRO));

            -- Se outro usa: desconsidera
            Mensagem := TGR_Referencia_Existe(NEW.REFPRO);
            IF COALESCE(mensagem,'#') <> '#' THEN
               NEW.REFPRO := Null;
            END IF;
         END IF;
      ELSE
         IF  (ISDIGIT(NEW.REFPRO) = 0)
         AND ((Tipo = SOMENTE_NUMERICO) OR (Tipo = EAN_OU_NUMERICO)) THEN
            RAISE EXCEPTION 'PG-20004 Referencia so pode conter digitos.%' , vComplemento;
         END IF;

         Mensagem := TGR_Referencia_Existe(NEW.REFPRO);
      END IF;

      IF COALESCE(mensagem,'#') <> '#' THEN
         RAISE EXCEPTION 'PG-20005 % %' , mensagem,vComplemento;
      END IF;
   END IF;

   -- Confirma se o item de divisao pertence ao grupo de grade
   IF (TG_OP = 'INSERT') or ((TG_OP = 'UPDATE') and (OLD.CODCOR <> NEW.CODCOR)) THEN
      IF (codigo_divisao_auxiliar <> codigo_divisao) THEN
         erro := 2;
      END IF;
   END IF;

   -- Confirma se o item de subdivisao pertence ao grupo de grade
   IF (TG_OP = 'INSERT') OR ((TG_OP = 'UPDATE') AND (OLD.CODTAM <> NEW.CODTAM)) THEN
      IF (cod_subdivisao_auxiliar <> cod_subdivisao) THEN
         erro := erro + 1;
      END IF;

      -- Assume a mesma unidade quando o controle for por embalagem
      IF (cod_embalagem IS NOT NULL) THEN
         NEW.UNIDAD := NEW.UNIFOR;
         NEW.VALCON := 1;
      END IF;
   END IF;

   -- Tratamento de erros (1)
   IF (erro > 2)    THEN
      RAISE EXCEPTION 'PG-20003 Os itens "%" e "%" nao pertencem, respectivamente, a divisao "%" e subdivisao "%" que estao vinculadas a grade "%". Eles pertencem a divisao "%" e subdivisao "%".%' , nome_item_divisao,nome_item_subdivisao,nome_divisao,nome_subdivisao,grade,nome_divisao_auxiliar,nome_subdivisao_auxiliar,vComplemento;
   ELSIF (erro = 2) THEN
      RAISE EXCEPTION 'PG-20002 O item "%" nao pertence a divisao "%" que esta vinculada a grade "%". Ele pertence a divisao "%".%' , nome_item_divisao,nome_divisao,grade,nome_divisao_auxiliar,vComplemento;
   ELSIF (erro = 1) THEN
      RAISE EXCEPTION 'PG-20001 O item "%" nao pertence a subdivisao "%" que esta vinculada a grade "%". Ele pertence a subdivisao "%".%' , nome_item_subdivisao,nome_subdivisao,grade,nome_subdivisao_auxiliar,vComplemento;
   END IF;

   -- Tratamento de erros (2):
   -- Nao aceita mudanca nas unidades se houver controle por embalagem
   IF (TG_OP = 'UPDATE') THEN
      IF ((NEW.UNIDAD <> NEW.UNIFOR) OR (NEW.VALCON <> 1)) THEN
       -- Confirma se o item de subdivisao pertence ao grupo de grade
       -- e tambem se controla embalagem

         
         

         Mensagem := PC_SUB_SELECT(NEW.CODTAM);
         IF COALESCE(mensagem,'#') <> '#' THEN
            RAISE EXCEPTION 'PG-20005 % %' , mensagem,vComplemento;
         END IF;
         
      END IF;
   END IF;

   -- Gera codigo sequencial da chave alternativa
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN:=ProximoCodigo('TT_GRA',NEW.FILMAT);
      END IF;

      IF NEW.VOLUME IS NULL THEN
         NEW.VOLUME := 0;
      END IF;
   END IF;

   IF (TG_OP = 'DELETE') THEN
      --Atualiza TT_PROxNOM
      --davi - 21/11/06 - 41296
      DELETE FROM TT_PROXNOM
       WHERE FILMAT = OLD.FILMAT
         AND CODMAT = OLD.CODMAT
         AND CODCOR = OLD.CODCOR
         AND CODTAM = OLD.CODTAM;
   END IF;

      -- Atualiza movimentacao
   IF ((TG_OP = 'UPDATE')) THEN
      IF (NEW.DATCOM IS NOT NULL) AND
         (Equal(NEW.CUSREP,OLD.CUSREP) = 0 OR
         Equal(NEW.PRECOM,OLD.PRECOM) = 0 OR
         Equal(NEW.CUSFRE,OLD.CUSFRE) = 0) THEN
         vLixo:=TGR_Atualiza_Custos(NEW.filmat, NEW.codmat, NEW.codcor, NEW.codtam,
                                    NEW.FILCOM, NEW.DATCOM, NEW.CUSREP, NEW.PRECOM,
                                    NEW.CUSFRE, NEW.DESICO);
      END IF;
      -- Atualiza a Penltima Compra
      IF Equal(OLD.FILCOM,NEW.FILCOM) <> 1 OR
         Equal(OLD.SEQCOM,NEW.SEQCOM) <> 1 OR
         Equal(OLD.ITECOM,NEW.ITECOM) <> 1 THEN
         NEW.FILCOM_ANT := OLD.FILCOM;
         NEW.SEQCOM_ANT := OLD.SEQCOM;
         NEW.ITECOM_ANT := OLD.ITECOM;
      END IF;
   END IF;

   IF (TG_OP = 'DELETE') THEN
      -- LEO 84337
      SELECT BLQ_SEM_UID
        INTO vBLQ_SEM_UID
        FROM TT_CFG;
      vCODUID_ATUAL := GetCoduidAtual();
      IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;
   END IF;

   IF (TG_OP = 'INSERT') THEN

      -- LEO 84337
      SELECT BLQ_SEM_UID
        INTO vBLQ_SEM_UID
        FROM TT_CFG;
      vCODUID_ATUAL := GetCoduidAtual();
      IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;

      IF ISNULL(NEW.CODFIS)='T' THEN
         --Mateus 93158
         SELECT REGRA_CODFIS INTO regra_codfis_aux FROM TT_CFG;

         IF regra_codfis_aux = 2 THEN -- Referncia bsica do produto
            SELECT PRO.REFBAS
              INTO NEW.CODFIS
              FROM TT_PRO PRO
             WHERE NEW.FILMAT = PRO.FILMAT
               AND NEW.CODMAT = PRO.CODMAT;
         ELSIF regra_codfis_aux = 3 THEN -- Referncia de grade
            NEW.CODFIS := NEW.REFPRO;
         ELSIF (regra_codfis_aux = 4) AND ISNULL(NEW.CODEXT)='F' THEN -- Cdigo externo
            NEW.CODFIS := NEW.CODEXT;
         ELSE -- Chave interna da grade
            SELECT DSUB.CODSAL
              INTO codigo_saldo
              FROM TT_SUB SUB INNER JOIN TD_SUB DSUB ON DSUB.CODTAB = SUB.CODSUB
                                              WHERE SUB.CODITE = NEW.CODTAM;

            NEW.CODFIS := (NEW.FILMAT || NEW.CODMAT || '-' ||
                                           NEW.CODCOR || '-' ||
                                           COALESCE(codigo_saldo, NEW.CODTAM));
         END IF;
      END IF;

      -- Douglas - 83441
      NEW.CODUID := GetCoduidAtual();
      NEW.ASSINA := COALESCE(AssinaTabela('TT_GRA',
                                       ConcatenaGRA(NEW.FILMAT,
                                                    NEW.CODMAT,
                                                    NEW.CODCOR,
                                                    NEW.CODTAM,
                                                    NEW.REFPRO,
                                                    NEW.CODFIS),
                                          null, null, null),NEW.ASSINA);
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF ConcatenaGRA(NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,NEW.REFPRO,NEW.CODFIS) <>
         ConcatenaGRA(OLD.FILMAT,OLD.CODMAT,OLD.CODCOR,OLD.CODTAM,OLD.REFPRO,OLD.CODFIS) THEN

         -- LEO 84337
         SELECT BLQ_SEM_UID
           INTO vBLQ_SEM_UID
           FROM TT_CFG;
         vCODUID_ATUAL := GetCoduidAtual();
         IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;

         -- Douglas - 83441
         NEW.CODUID := GetCoduidAtual();
         NEW.ASSINA := COALESCE(AssinaTabela('TT_GRA',
                                            ConcatenaGRA(NEW.FILMAT,
                                                         NEW.CODMAT,
                                                         NEW.CODCOR,
                                                         NEW.CODTAM,
                                                         NEW.REFPRO,
                                                         NEW.CODFIS),
                                              OLD.CODUID,
                                            ConcatenaGRA(OLD.FILMAT,
                                                         OLD.CODMAT,
                                                         OLD.CODCOR,
                                                         OLD.CODTAM,
                                                         OLD.REFPRO,
                                                         OLD.CODFIS),
                                              OLD.ASSINA ),NEW.ASSINA);
      END IF;
   END IF;

   -- RFMP 101132
   -- Trazendo para trigger BEFORE tratamento de atualizao do ATU_EM porque
   -- ele depende do DUMMY que ser apagado no final da trigger
   IF cMantemAtuEm = 'F' THEN
      -- Tratamento para Atualizar Tabela Pai
      IF (TG_OP = 'INSERT')
      OR (TG_OP = 'UPDATE') THEN
         cWhere := 'FILMAT = ' || CHR(39) || NEW.FILMAT  || CHR(39) || ' AND CODMAT = ' || CHR(39) || NEW.CODMAT || CHR(39);
      ELSIF (TG_OP = 'DELETE') THEN
         cWhere := 'FILMAT = ' || CHR(39) || OLD.FILMAT  || CHR(39) || ' AND CODMAT = ' || CHR(39) || OLD.CODMAT || CHR(39);
      END IF;
      cRetorno := INSERE_MATU('TT_GRA', 'TT_PRO', cWhere);
   END IF;

   -- RFMP 101132
   -- Apagando dados do DUMMY para garantir que um novo processo no utilizar seu valor
   -- de maneira equivocada
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.DUMMY := NULL;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4186 --*/
CREATE TRIGGER TGGRA2
BEFORE DELETE OR INSERT OR UPDATE ON TT_GRA 
FOR EACH ROW EXECUTE PROCEDURE TGGRA2();

/*-- SEQ 4187 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGGRA3() CASCADE;

/*-- SEQ 4188 --*/
CREATE OR REPLACE FUNCTION TGGRA3() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Registrar mudanca dos dados num "log"
-- 2) Atualiza ATU_EM da TT_PRO
--
   cLOG                          VARCHAR(4000)      := '';
   cNulo                         CONSTANT CHAR(1)    := '0';
   iNulo                         CONSTANT Numeric(1)  := 0;
   cNuloStr                      CONSTANT CHAR(4)    := 'Nulo';
   CRLF                          CONSTANT CHAR(1)    := CHR(10);
   cOld                          CHAR(50); -- davi - 37941 - 05/09/2005 - colocar descrio no lugar dos codtabs
   cNew                          CHAR(50); -- davi - 37941 - 05/09/2005 - colocar descrio no lugar dos codtabs

   
   vTemp                         VARCHAR(2);
         cRetorno                      VARCHAR(2);
   
   cDESECF                       TT_PRO.DESECF%TYPE;
   cDESMAT                       TT_PRO.DESMAT%TYPE;
   cESPMAT                       TT_PRO.ESPMAT%TYPE;
-- Principal
BEGIN

   
   IF NOT (TG_OP = 'DELETE') THEN
      vTemp:=PC_GRA_UPDATE (NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM);
   END IF;
   
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODCOR,NEW.CODCOR) = 0 OR
         Equal(OLD.CODTAM,NEW.CODTAM) = 0 OR
         Equal(OLD.DESGRA,NEW.DESGRA) = 0 THEN
         --Atualiza TT_PROxNOM
         --davi - 21/11/06 - 41296
         
         cRetorno := PC_PROxNOM_Atualiza(NULL, NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM);
                        END IF;
   END IF;

   -- Apaga dados no log
   IF (TG_OP = 'DELETE') THEN
      -- Exclui qualquer referencia do "log" a grade atual
      DELETE FROM TL_GRA WHERE FILMAT = OLD.FILMAT AND CODMAT = OLD.CODMAT
                         AND CODCOR = OLD.CODCOR AND CODTAM = OLD.CODTAM;
   END IF;

   -- Tratamento de log
   IF (TG_OP = 'INSERT') THEN
      --Atualiza TT_PROxNOM
      --davi - 21/11/06 - 41296
      
      cRetorno := PC_PROxNOM_Atualiza( NULL, NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM );
                  cLOG := 'Inclusao';
      -- Inclui uma linha em TL_GRA
      INSERT INTO TL_GRA (FILMAT,CODMAT,CODCOR,CODTAM,DATOPE,MSGLOG)
      VALUES (NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,agora(),cLOG);
   ELSIF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CUSREP,NEW.CUSREP) <> 1 THEN
         cLOG := cLOG||'Custo reposicao: de '||COALESCE(OLD.CUSREP,iNulo)||' para '||COALESCE(NEW.CUSREP,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.CUSFRE,NEW.CUSFRE) <> 1 THEN
         cLOG := cLOG||'Custo frete: de '||COALESCE(OLD.CUSFRE,iNulo)||' para '||COALESCE(NEW.CUSFRE,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.DATCOM,NEW.DATCOM) <> 1 THEN
         cLOG := cLOG||'Entrada: de '||COALESCE(TO_CHAR(OLD.DATCOM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATCOM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DESIDE,NEW.DESIDE) <> 1 THEN
         cLOG := cLOG||'Desconto sugerido: de '||COALESCE(OLD.DESIDE,iNulo)||' para '||COALESCE(NEW.DESIDE,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.DESMAX,NEW.DESMAX) <> 1 THEN
         cLOG := cLOG||'Desconto maximo: de '||COALESCE(OLD.DESMAX,iNulo)||' para '||COALESCE(NEW.DESMAX,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.LOCALI,NEW.LOCALI) <> 1 THEN
         cLOG := cLOG||'Localizacao: de '||COALESCE(OLD.LOCALI,cNulo)||' para '||COALESCE(NEW.LOCALI,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.MINQTD,NEW.MINQTD) <> 1 THEN
         cLOG := cLOG||'Estoque minimo: de '||COALESCE(OLD.MINQTD,iNulo)||' para '||COALESCE(NEW.MINQTD,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERCOM,NEW.PERCOM) <> 1 THEN
         cLOG := cLOG||'% Comissao: de '||COALESCE(OLD.PERCOM,iNulo)||' para '||COALESCE(NEW.PERCOM,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERLUC,NEW.PERLUC) <> 1 THEN
         cLOG := cLOG||'Lucro bruto: de '||COALESCE(OLD.PERLUC,iNulo)||' para '||COALESCE(NEW.PERLUC,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.PESBRU,NEW.PESBRU) <> 1 THEN
         cLOG := cLOG||'Peso bruto: de '||COALESCE(OLD.PESBRU,iNulo)||' para '||COALESCE(NEW.PESBRU,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.PESLIQ,NEW.PESLIQ) <> 1 THEN
         cLOG := cLOG||'Peso liquido: de '||COALESCE(OLD.PESLIQ,iNulo)||' para '||COALESCE(NEW.PESLIQ,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.PRECOM,NEW.PRECOM) <> 1 THEN
         cLOG := cLOG||'Preco compra: de '||TO_CHAR(COALESCE(OLD.PRECOM,0),'fm9G999G990D0000')||' para '||TO_CHAR(COALESCE(NEW.PRECOM,0),'fm9G999G990D0000')||CRLF;
      END IF;
      IF Equal(OLD.PROMOC,NEW.PROMOC) <> 1 THEN
         cLOG := cLOG||'Promocao: de '||COALESCE(OLD.PROMOC,cNulo)||' para '||COALESCE(NEW.PROMOC,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PTOQTD,NEW.PTOQTD) <> 1 THEN
         cLOG := cLOG||'Ponto de pedido: de '||COALESCE(OLD.PTOQTD,iNulo)||' para '||COALESCE(NEW.PTOQTD,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.QTDREP,NEW.QTDREP) <> 1 THEN
         cLOG := cLOG||'Qtd. ideal reposicao: de '||COALESCE(OLD.QTDREP,iNulo)||' para '||COALESCE(NEW.QTDREP,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.REFPRO,NEW.REFPRO) <> 1 THEN
         cLOG := cLOG||'Referencia: de '||COALESCE(OLD.REFPRO,cNulo)||' para '||COALESCE(NEW.REFPRO,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TEMREP,NEW.TEMREP) <> 1 THEN
         cLOG := cLOG||'Tempo reposicao: de '||COALESCE(OLD.TEMREP,iNulo)||' para '||COALESCE(NEW.TEMREP,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.TIPVAL,NEW.TIPVAL) <> 1 THEN
         cLOG := cLOG||'Validade expressa: de '||COALESCE(DescricaoDominio('GRA','TIPVAL',TO_CHAR(OLD.TIPVAL)),cNulo)||' para '||COALESCE(DescricaoDominio('GRA','TIPVAL',TO_CHAR(NEW.TIPVAL)),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VALIDA,NEW.VALIDA) <> 1 THEN
         cLOG := cLOG||'Garantia/validade: de '||COALESCE(OLD.VALIDA,iNulo)||' para '||COALESCE(NEW.VALIDA,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERTOLREP,NEW.PERTOLREP) <> 1 THEN
         cLOG := cLOG||'Margem Tolerncia Custo Reposio: de '||COALESCE(TO_CHAR(OLD.PERTOLREP,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERTOLREP,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRTOLREP,NEW.VLRTOLREP) <> 1 THEN
         cLOG := cLOG||'Valor Tolerncia Custo Reposio: de '||COALESCE(TO_CHAR(OLD.VLRTOLREP,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRTOLREP,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DESTAQ,NEW.DESTAQ) <> 1 THEN
         select CASE OLD.DESTAQ WHEN 'T' THEN 'Sim'
                                 WHEN 'F' THEN 'No'
                                 ELSE cNulo
         END into cOld from dual;
         select CASE NEW.DESTAQ WHEN 'T' THEN 'Sim'
                                 WHEN 'F' THEN 'No'
                                 ELSE cNulo
         END into cNew from dual;

         cLOG := cLOG||'Destaque: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ALTURA,NEW.ALTURA) <> 1 THEN
         cLOG := cLOG||'Altura: de '||COALESCE(TO_CHAR(OLD.ALTURA,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ALTURA,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.LARGUR,NEW.LARGUR) <> 1 THEN
         cLOG := cLOG||'Largura: de '||COALESCE(TO_CHAR(OLD.LARGUR,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.LARGUR,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PROFUN,NEW.PROFUN) <> 1 THEN
         cLOG := cLOG||'Profundidade: de '||COALESCE(TO_CHAR(OLD.PROFUN,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PROFUN,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.UNIDAD,NEW.UNIDAD) <> 1 THEN
      SELECT COALESCE(TO_CHAR(MIN(UNIMED)),cNulo) INTO cOld FROM TD_MED WHERE CODTAB = OLD.UNIDAD;
      SELECT COALESCE(TO_CHAR(MIN(UNIMED)),cNulo) INTO cNew FROM TD_MED WHERE CODTAB = NEW.UNIDAD;
         cLOG := cLOG||'Unidade de venda: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.UNIFOR,NEW.UNIFOR) <> 1 THEN
         SELECT COALESCE(TO_CHAR(MIN(UNIMED)),cNulo) INTO cOld FROM TD_MED WHERE CODTAB = OLD.UNIFOR;
         SELECT COALESCE(TO_CHAR(MIN(UNIMED)),cNulo) INTO cNew FROM TD_MED WHERE CODTAB = NEW.UNIFOR;
         cLOG := cLOG||'Unidade de compra: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VALCON,NEW.VALCON) <> 1 THEN
         cLOG := cLOG||'Valor conversao: de '||COALESCE(OLD.VALCON,iNulo)||' para '||COALESCE(NEW.VALCON,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILCOM,NEW.FILCOM) <> 1 OR
         Equal(OLD.SEQCOM,NEW.SEQCOM) <> 1 OR
         Equal(OLD.ITECOM,NEW.ITECOM) <> 1 THEN
         cLOG := cLOG||'ltima compra: de '||COALESCE(OLD.FILCOM,cNulo) || '/' || COALESCE(OLD.SEQCOM,cNulo) ||' para '||COALESCE(NEW.FILCOM,cNulo) || '/' || COALESCE(NEW.SEQCOM,cNulo) ||CRLF;
         cLOG := cLOG||'Numero item da ltima compra: de '||COALESCE(OLD.ITECOM,iNulo)||' para '||COALESCE(NEW.ITECOM,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILCOM_ANT,NEW.FILCOM_ANT) <> 1 OR
         Equal(OLD.SEQCOM_ANT,NEW.SEQCOM_ANT) <> 1 OR
         Equal(OLD.ITECOM_ANT,NEW.ITECOM_ANT) <> 1 THEN
         cLOG := cLOG||'Penltima compra: de '||COALESCE(OLD.FILCOM_ANT,cNulo) || '/' || COALESCE(OLD.SEQCOM_ANT,cNulo) ||' para '||COALESCE(NEW.FILCOM_ANT,cNulo) || '/' || COALESCE(NEW.SEQCOM_ANT,cNulo) ||CRLF;
         cLOG := cLOG||'Numero item da penltima compra: de '||COALESCE(OLD.ITECOM_ANT,iNulo)||' para '||COALESCE(NEW.ITECOM_ANT,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.ICMCOM,NEW.ICMCOM) <> 1 THEN
         cLOG := cLOG||'Valor ICMS ultima compra: de '||COALESCE(TO_CHAR(OLD.ICMCOM,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ICMCOM,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.IPICOM,NEW.IPICOM) <> 1 THEN
         cLOG := cLOG||'Valor IPI ultima compra: de '||COALESCE(TO_CHAR(OLD.IPICOM,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.IPICOM,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TAXCOM,NEW.TAXCOM) <> 1 THEN
         cLOG := cLOG||'Valor taxas ltima compra: de '||COALESCE(TO_CHAR(OLD.TAXCOM,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.TAXCOM,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DESCOM,NEW.DESCOM) <> 1 THEN
         cLOG := cLOG||'Valor descontos ltima compra: de '||COALESCE(TO_CHAR(OLD.DESCOM,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DESCOM,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SUBCOM,NEW.SUBCOM) <> 1 THEN
         cLOG := cLOG||'Valor subst. tribut. ltima compra: de '||COALESCE(TO_CHAR(OLD.SUBCOM,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.SUBCOM,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SEGFRE,NEW.SEGFRE) <> 1 THEN
         cLOG := cLOG||'Valor seguro de frete: de '||COALESCE(TO_CHAR(OLD.SEGFRE,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.SEGFRE,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ICMFRE,NEW.ICMFRE) <> 1 THEN
         cLOG := cLOG||'Valor ICMS do frete: de '||COALESCE(TO_CHAR(OLD.ICMFRE,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(OLD.ICMFRE,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FORLIN,NEW.FORLIN) <> 1 THEN
         cLOG := cLOG||'Fora de linha: de '||COALESCE(OLD.FORLIN,cNulo)||' para '||COALESCE(NEW.FORLIN,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VOLUNI,NEW.VOLUNI) <> 1 THEN
         cLOG := cLOG||'Volume nico?: de '||COALESCE(OLD.VOLUNI,cNulo)||' para '||COALESCE(NEW.VOLUNI,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.UNIEMB,NEW.UNIEMB) <> 1 THEN
         cLOG := cLOG||'Unidade Embalagem: de '||COALESCE(TO_CHAR(OLD.UNIEMB,'fm9G999G999G990'),cNulo)||' para '||COALESCE(TO_CHAR(OLD.UNIEMB,'fm9G999G999G990'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.UNIAPL,NEW.UNIAPL) <> 1 THEN
         cLOG := cLOG||'Unidade Aplicao: de '||COALESCE(TO_CHAR(OLD.UNIAPL,'fm9G999G999G990'),cNulo)||' para '||COALESCE(TO_CHAR(OLD.UNIAPL,'fm9G999G999G990'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.QTDEMB,NEW.QTDEMB) <> 1 THEN
         cLOG := cLOG||'Contedo Embalagem: de '||COALESCE(TO_CHAR(OLD.QTDEMB,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(OLD.QTDEMB,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CONAPL,NEW.CONAPL) <> 1 THEN
         cLOG := cLOG||'Unidade Embalagem: de '||COALESCE(TO_CHAR(OLD.CONAPL,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(OLD.CONAPL,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CONAPL,NEW.CONAPL) <> 1 THEN
         cLOG := cLOG||'Unidade Embalagem: de '||COALESCE(TO_CHAR(OLD.CONAPL,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(OLD.CONAPL,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.QTDCOM,NEW.QTDCOM) <> 1 THEN
         cLOG := cLOG||'Quantidade Compra: de '||COALESCE(TO_CHAR(OLD.QTDCOM,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(OLD.QTDCOM,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.MARKUP,NEW.MARKUP) <> 1 THEN
         cLOG := cLOG||'Markup: de '||COALESCE(TO_CHAR(OLD.MARKUP,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(OLD.MARKUP,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PREPSI,NEW.PREPSI) <> 1 THEN
         cLOG := cLOG||'Preo Psicolgico?: de '||COALESCE(OLD.PREPSI,cNulo)||' para '||COALESCE(NEW.PREPSI,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.GRAATI,NEW.GRAATI) <> 1 THEN
         IF (OLD.GRAATI = 'T') AND (NEW.GRAATI = 'F') THEN
            cLOG := cLOG||'Item de Grade desativado'||CRLF;
         ELSIF (OLD.GRAATI = 'F') AND (NEW.GRAATI = 'T') THEN
            cLOG := cLOG||'Item de Grade ativado'||CRLF;
         END IF;
      END IF;
      IF Equal(OLD.ORICUS,NEW.ORICUS) <> 1 THEN
         cLOG := cLOG||'Origem dos Custos: de '||COALESCE(OLD.ORICUS,cNulo)||' para '||COALESCE(NEW.ORICUS,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.IPICUS,NEW.IPICUS) <> 1 THEN
         cLOG := cLOG||'% de IPI para Formao do Preo de Venda: de '||COALESCE(TO_CHAR(OLD.IPICUS,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.IPICUS,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ICMCUS,NEW.ICMCUS) <> 1 THEN
         cLOG := cLOG||'% de ICMS para Formao do Preo de Venda: de '||COALESCE(TO_CHAR(OLD.ICMCUS,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ICMCUS,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.OUTCUS,NEW.OUTCUS) <> 1 THEN
         cLOG := cLOG||'Outros Custos: de '||COALESCE(TO_CHAR(OLD.OUTCUS,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.OUTCUS,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DACCUS,NEW.DACCUS) <> 1 THEN
         cLOG := cLOG||'Desconto/Acrscimo para clculo de Preo de Venda: de '||COALESCE(TO_CHAR(OLD.DACCUS,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DACCUS,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.AFICUS,NEW.AFICUS) <> 1 THEN
         cLOG := cLOG||'Acrscimo Financeiro: de '||COALESCE(TO_CHAR(OLD.AFICUS,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.AFICUS,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ICMTIP,NEW.ICMTIP) <> 1 THEN
         cLOG := cLOG||'Tipo de Tributao para a Formao do Preo de Venda: de '||COALESCE(OLD.ICMTIP,cNulo)||' para '||COALESCE(NEW.ICMTIP,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERFRE,NEW.PERFRE) <> 1 THEN
         cLOG := cLOG||'% Frete: de '||COALESCE(TO_CHAR(OLD.PERFRE,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERFRE,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.USABON,NEW.USABON) <> 1 THEN
         select CASE OLD.USABON WHEN 'T' THEN 'Sim'
                                 WHEN 'F' THEN 'No'
                                 ELSE cNulo
         END into cOld from dual;
         select CASE NEW.USABON WHEN 'T' THEN 'Sim'
                                 WHEN 'F' THEN 'No'
                                 ELSE cNulo
         END into cNew from dual;

         cLOG := cLOG||'Usa bnus?: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.QTDBON,NEW.QTDBON) <> 1 THEN
         cLOG := cLOG||'Quantidade de bnus para o produto: de '||COALESCE(TO_CHAR(OLD.QTDBON,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.QTDBON,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILRES,NEW.FILRES) <> 1 THEN
         cLOG := cLOG||'Filial de reserva: de '||COALESCE(OLD.FILRES,cNulo)||' para '||COALESCE(NEW.FILRES,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODFIS,NEW.CODFIS) <> 1 THEN
         cLOG := cLOG||'Codigo Fiscal: de '||COALESCE(OLD.CODFIS,cNulo)||' para '||COALESCE(NEW.CODFIS,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ENVECO,NEW.ENVECO) <> 1 THEN
         cLOG := cLOG||'Envia p/ E-commerce?: de '||COALESCE(OLD.ENVECO,cNulo)||' para '||COALESCE(NEW.ENVECO,cNulo)||CRLF;
      END IF;
	  IF Equal(OLD.SKYHUB,NEW.SKYHUB) <> 1 THEN
         cLOG := cLOG||'Envia p/ skyhub?: de '||COALESCE(OLD.SKYHUB,cNulo)||' para '||COALESCE(NEW.SKYHUB,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.BALTAR,NEW.BALTAR) <> 1 THEN
         cLOG := cLOG||'Tara para Balana: de '||COALESCE(TO_CHAR(OLD.BALTAR),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BALTAR),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.MAXPAR,NEW.MAXPAR) <> 1 THEN
         cLOG := cLOG||'Nmero mximo de parcelas: de '||COALESCE(TO_CHAR(OLD.MAXPAR),cNuloStr)||' para '||COALESCE(TO_CHAR(NEW.MAXPAR),cNuloStr)||CRLF;
      END IF;

    -- Rhuan - 92964 - Retirado log das colunas GRAABC e GRAXYZ
    -- Motivo: A cada execuo do JOB para classificar os produtos estas colunas so apagadas e refeitas
    -- Isto iria deixar o log da grade muito grande e com informaes desnecessrias
/*
      --92950 begin
      IF Equal(OLD.GRAABC,NEW.GRAABC) <> 1 THEN
         cLOG := cLOG||'ABC Calculado: de '||COALESCE(OLD.GRAABC,cNulo)||' para '||COALESCE(NEW.GRAABC,cNulo)||CRLF;
      END IF;

      IF Equal(OLD.GRAXYZ,NEW.GRAXYZ) <> 1 THEN
         cLOG := cLOG||'XYZ Calculado: de '||COALESCE(OLD.GRAXYZ,cNulo)||' para '||COALESCE(NEW.GRAXYZ,cNulo)||CRLF;
      END IF;
      --92950 end
*/
      IF Equal(OLD.IMGGRU,NEW.IMGGRU) <> 1 THEN
         cLOG := cLOG||'Nome da imagem: de '||COALESCE(OLD.IMGGRU,cNulo)||' para '||COALESCE(NEW.IMGGRU,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.QTDMUL,NEW.QTDMUL) <> 1 THEN
         cLOG := cLOG||'Quantidade mltipla: de '||COALESCE(TO_CHAR(OLD.QTDMUL,'fmG99G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.QTDMUL,'fmG99G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DESGRA,NEW.DESGRA) <> 1 THEN
         cLOG := cLOG||'Descrio da Grade: de '||COALESCE(TO_CHAR(OLD.DESGRA),cNuloStr)||' para '||COALESCE(TO_CHAR(NEW.DESGRA),cNuloStr)||CRLF;
      END IF;
      IF Equal(OLD.CODPOS_GRA,NEW.CODPOS_GRA) <> 1 THEN
         cLOG := cLOG||'Cdigo POS CONTROLE: de '||COALESCE(TO_CHAR(OLD.CODPOS_GRA),cNuloStr)||' para '||COALESCE(TO_CHAR(NEW.CODPOS_GRA),cNuloStr)||CRLF;
      END IF;

      IF ISNOTNULL(cLOG)='T' THEN
         -- Inclui uma linha em TL_GRA
         INSERT INTO TL_GRA (FILMAT,CODMAT,CODCOR,CODTAM,DATOPE,MSGLOG)
         VALUES (NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,agora(),cLOG);
      END IF;

      IF COALESCE(OLD.OBSERV,'XXX')<>COALESCE(NEW.OBSERV,'XXX') AND ISNOTNULL(OLD.OBSERV)='T' THEN
         INSERT INTO TL_GRA (FILMAT,CODMAT,CODCOR,CODTAM,DATOPE,MSGLOG)
                     VALUES (NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,agora(),OLD.OBSERV);
      END IF;

      -- MN - Se mudar QUALQUER campo que faa parte do nome do produto, tem que registrar log. A funo  chamada assim:
      --CAST(NomeProduto(PRO.DESECF, PRO.DESMAT, GRA.CODCOR, DIV.NOMITE, GRA.CODTAM, SUB.NOMITE, PRO.ESPMAT, GRA.DESGRA, DIV.NOMEXT, SUB.NOMEXT) AS VARCHAR(254)) AS NOMPRO 
      IF (TG_OP = 'UPDATE') THEN
         IF Equal(OLD.CODCOR, NEW.CODCOR) <> 1 OR Equal(OLD.CODTAM, NEW.CODTAM) <> 1 OR 
            Equal(OLD.DESGRA, NEW.DESGRA) <> 1 OR Equal(OLD.CODFIS, NEW.CODFIS) <> 1 THEN
            SELECT DESMAT, ESPMAT, DESECF
              INTO cDESMAT, cESPMAT, cDESECF
              FROM TT_PRO
             WHERE FILMAT = OLD.FILMAT
               AND CODMAT = OLD.CODMAT;

            IF Equal(OLD.CODFIS, NEW.CODFIS) <> 1 THEN 
              INSERT INTO TL_PRO_SPED (FILMAT, CODMAT, TIPLOG, DESECF, DESMAT, ESPMAT, CODCOR, CODTAM, DESGRA, CODFIS)
                 VALUES (OLD.FILMAT, OLD.CODMAT, 'C', NULL, NULL, NULL, OLD.CODCOR, OLD.CODTAM, NULL, OLD.CODFIS);
            ELSE
              INSERT INTO TL_PRO_SPED (FILMAT, CODMAT, TIPLOG, DESECF, DESMAT, ESPMAT, CODCOR, CODTAM, DESGRA, CODFIS)
                 VALUES (OLD.FILMAT, OLD.CODMAT, 'C', cDESECF, cDESMAT, cESPMAT, OLD.CODCOR, OLD.CODTAM, OLD.DESGRA, NULL);
            END IF;
         END IF;
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4189 --*/
CREATE TRIGGER TGGRA3
AFTER INSERT OR UPDATE OR DELETE ON TT_GRA 
FOR EACH ROW EXECUTE PROCEDURE TGGRA3();


/*-- SEQ 4190 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGGRA_DW() CASCADE;

/*-- SEQ 4191 --*/
CREATE OR REPLACE FUNCTION TGGRA_DW() RETURNS TRIGGER AS $$
DECLARE
   bProcessa_New                 BOOLEAN DEFAULT False;
   bProcessa_Old                 BOOLEAN DEFAULT False;
   cDUMMY                        VARCHAR(2);
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');

-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Produto

BEGIN
  IF UsaVMDecisor() = 'T' THEN
     -- (TG_OP = 'UPDATE'): apenas so utilizadas as colunas da PK
     IF (TG_OP = 'INSERT') THEN
        bProcessa_New := True;
     ELSIF (TG_OP = 'UPDATE') THEN
        IF Equal(OLD.FILMAT,NEW.FILMAT) <> 1
        OR Equal(OLD.CODMAT,NEW.CODMAT) <> 1
        OR Equal(OLD.CODCOR,NEW.CODCOR) <> 1
        OR Equal(OLD.CODTAM,NEW.CODTAM) <> 1 THEN -- PK
           RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
        END IF;
     ELSIF (TG_OP = 'DELETE') THEN
        bProcessa_Old := True;
     END IF;
     IF bProcessa_New THEN
        cDUMMY := Insere_DW_Log_Produto(NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM);
     END IF;
     IF bProcessa_Old THEN
        cDUMMY := Insere_DW_Log_Produto(OLD.FILMAT,OLD.CODMAT,OLD.CODCOR,OLD.CODTAM);
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4192 --*/
CREATE TRIGGER TGGRA_DW
AFTER INSERT OR UPDATE OR DELETE ON TT_GRA 
FOR EACH ROW EXECUTE PROCEDURE TGGRA_DW();

/*-- SEQ 4193 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGGRA_ASS() CASCADE;

/*-- SEQ 4194 --*/
CREATE OR REPLACE FUNCTION TGGRA_ASS() RETURNS TRIGGER AS $$
-- 83073
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN

   IF ExisteFilialNaUF('SC') THEN
      IF (TG_OP = 'INSERT') THEN
         UPDATE TT_ASS
            SET QTDREG = QTDREG + 1
          WHERE NOMTAB = 'TT_GRA';
      END IF;
      
      IF (TG_OP = 'DELETE') THEN
         UPDATE TT_ASS
            SET QTDREG = QTDREG - 1
          WHERE NOMTAB = 'TT_GRA';
      END IF;   
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4195 --*/
CREATE TRIGGER TGGRA_ASS
AFTER INSERT OR DELETE ON TT_GRA 
FOR EACH ROW EXECUTE PROCEDURE TGGRA_ASS();


/*-- SEQ 4196 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGGRAXDCAR() CASCADE;

/*-- SEQ 4197 --*/
CREATE OR REPLACE FUNCTION TGGRAXDCAR() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
BEGIN
   -- Trata dados padroes na inclusao
   IF (TG_OP = 'INSERT') THEN
      IF ISNULL(NEW.SEQUEN)='T' THEN
         NEW.SEQUEN:=ProximoCodigo('TT_GRAXDCAR',NEW.CODFIL);
      END IF;
      NEW.DATINC := agora(); 
   END IF;

   -- Popula a coluna ATU_EM
   IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
      NEW.ATU_EM := agora();      
   END IF;  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4198 --*/
CREATE TRIGGER TGGRAXDCAR
BEFORE INSERT OR UPDATE ON TT_GRAXDCAR 
FOR EACH ROW EXECUTE PROCEDURE TGGRAXDCAR();  

/*-- SEQ 4199 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGGRAXDCAR2() CASCADE;

/*-- SEQ 4200 --*/
CREATE OR REPLACE FUNCTION TGGRAXDCAR2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 2) Registrar mudanca dos dados num "log"
   cLOG                          VARCHAR(4000)     := '';
   cLogChave                     VARCHAR(55)       := '';
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   cFILUSU                       CHAR(3);
   cCODUSU                       CHAR(3);

      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
      WK_CODUID                     TT_UID.CODUID%TYPE;
BEGIN
   WK_CODUID := GetCoduidAtual();

   select * into QuemLogou from DadosLogon();
   cFILUSU := QuemLogou.FILUSU;
   cCODUSU := QuemLogou.CODUSU;
 
   -- Tratamento de log
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN
      cLogChave := 'Carto ' || DescricaoDominio('GRAC','TIPCAR',NEW.TIPCAR) || ' [' || NEW.CODFIL || '-' || NEW.SEQUEN || ']';      
   END IF;
   IF (TG_OP = 'INSERT') THEN
      cLOG := 'Incluso de ' || cLogChave;      
   ELSIF (TG_OP = 'UPDATE') THEN    
      IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
         cLOG := cLOG||'Filial do Lacre: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
         cLOG := cLOG||'Sequncia do Lacre: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DATINC,NEW.DATINC) <> 1 THEN
         cLOG := cLOG||'Data Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TIPCAR,NEW.TIPCAR) <> 1 THEN
         cLOG := cLOG||'Tipo de Carto: de '||COALESCE(OLD.TIPCAR,cNulo)||' para '||COALESCE(NEW.TIPCAR,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILMAT,NEW.FILMAT) <> 1 or Equal(OLD.CODMAT,NEW.CODMAT) <> 1 or
         Equal(OLD.CODCOR,NEW.CODCOR) <> 1 or Equal(OLD.CODTAM,NEW.CODTAM) <> 1 THEN
         cLOG := cLOG||'Produto: de '||COALESCE(OLD.FILMAT,cNulo)||COALESCE(OLD.CODMAT,cNulo)||'-'||COALESCE(OLD.CODCOR,iNulo)||'-'||COALESCE(OLD.CODTAM,iNulo)||' para '||
                       COALESCE(NEW.FILMAT,cNulo)||COALESCE(NEW.CODMAT,cNulo)||'-'||COALESCE(NEW.CODCOR,iNulo)||'-'||COALESCE(NEW.CODTAM,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.PROTEF,NEW.PROTEF) <> 1 THEN
         cLOG := cLOG||'Cdigo do Produto Cadastrado no TEF: de '||COALESCE(OLD.PROTEF,cNulo)||' para '||COALESCE(NEW.PROTEF,cNulo)||CRLF;
      END IF;
      
      IF ISNOTNULL(cLOG) = 'T' THEN
         cLOG := cLogChave || ' >> ' || cLOG;
      END IF;
   END IF;
   IF (TG_OP = 'INSERT') 
   OR (TG_OP = 'UPDATE') THEN
      IF ISNOTNULL(cLOG) = 'T' THEN
         INSERT INTO TL_GRA (FILMAT,CODMAT,CODCOR,CODTAM,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                     VALUES (NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,agora(),cFILUSU,cCODUSU,cLOG,WK_CODUID);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4201 --*/
CREATE TRIGGER TGGRAXDCAR2
AFTER INSERT OR UPDATE OR DELETE ON TT_GRAXDCAR 
FOR EACH ROW EXECUTE PROCEDURE TGGRAXDCAR2();


/*-- SEQ 4202 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGGRAXMDV1() CASCADE;

/*-- SEQ 4203 --*/
CREATE OR REPLACE FUNCTION TGGRAXMDV1() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impede excluso.
-- 2. Atualiza controles de data.

-- Declarao de variveis e cursores
   cCOMPLEMENTO                  CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');
   nPROXIMO                      Numeric;

-- Principal
BEGIN
      
   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      NEW.DATINC := Agora();
      SELECT NEXTVAL('sqGRAXMDV') INTO nPROXIMO FROM DUAL;
      IF(nPROXIMO > 9999999999) THEN
         RAISE EXCEPTION 'PG-20000 Cdigo atingiu o limite mximo de 10 posies. %' , cCOMPLEMENTO;
      ELSE
         NEW.CODTAB := nPROXIMO;
      END IF;
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;
   
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      IF NEW.ANOINIPROD <= TO_DATE('30/12/1899','DD/MM/YYYY') THEN
         NEW.ANOINIPROD := NULL;
      END IF;
      IF NEW.ANOFIMPROD <= TO_DATE('30/12/1899','DD/MM/YYYY') THEN
         NEW.ANOFIMPROD := NULL;
      END IF;
   END IF;
   

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4204 --*/
CREATE TRIGGER TGGRAXMDV1
BEFORE INSERT OR UPDATE OR DELETE ON TT_GRAXMDV 
FOR EACH ROW EXECUTE PROCEDURE TGGRAXMDV1();


/*-- SEQ 4205 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGGRAXSC() CASCADE;

/*-- SEQ 4206 --*/
CREATE OR REPLACE FUNCTION TGGRAXSC() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
   -- Trata dados padroes na inclusao
   IF (TG_OP = 'INSERT') THEN
      IF COALESCE(NEW.ID,0) = 0 THEN
         NEW.ID :=ProximoCodigo('TT_GRAXSC',NEW.CODFIL);
      END IF;
   END IF;  
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      --NEW.CODMAT := LPAD(TRIM(TO_ASCII(NEW.CODMAT)),5,' '); --,CHR(160),CHR(32));
      NEW.CODMAT := LPAD(TRIM(REPLACE(NEW.CODMAT,CHR(160),CHR(32))),5,' ');
   END IF;  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4207 --*/
CREATE TRIGGER TGGRAXSC
BEFORE INSERT OR UPDATE ON TT_GRAXSC 
FOR EACH ROW EXECUTE PROCEDURE TGGRAXSC();


/*-- SEQ 4208 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGGXLOG() CASCADE;

/*-- SEQ 4209 --*/
CREATE OR REPLACE FUNCTION TGGXLOG() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
BEGIN
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    IF ISNULL(TRIM(TO_CHAR(NEW.GX_LogId)))='T' THEN
      NEW.GX_LogId:=ProximoCodigo('GX_LOG',null);
    END IF;
  END IF;
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4210 --*/
CREATE TRIGGER TGGXLOG
BEFORE INSERT ON GX_LOG 
FOR EACH ROW EXECUTE PROCEDURE TGGXLOG();  


/*-- SEQ 4211 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGHND() CASCADE;

/*-- SEQ 4212 --*/
CREATE OR REPLACE FUNCTION TGHND() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

  Filial  TT_IDF.CODLOJ%TYPE;

-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
     IF NEW.CODFIL IS NULL THEN
       SELECT CODLOJ INTO Filial FROM TT_IDF;
       NEW.CODFIL := Filial;
     END IF;

    IF NEW.SEQUEN IS NULL THEN
      NEW.SEQUEN:=ProximoCodigo('TT_HND',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4213 --*/
CREATE TRIGGER TGHND
BEFORE INSERT ON TT_HND 
FOR EACH ROW EXECUTE PROCEDURE TGHND();



/*-- SEQ 4214 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGHOR() CASCADE;

/*-- SEQ 4215 --*/
CREATE OR REPLACE FUNCTION TGHOR() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Verificar se o usuario pode mudar ou remover os horarios
--

  CODIGO_GERENTE_SAC INTEGER := 128;
  CODIGO_GERENTE_PRJ INTEGER := 113;
  
  wk_priv CHAR(1);
  QuemLogou TRetQuemLogou%ROWTYPE;

  vComplemento constant VARCHAR(100) := constante('complemento');
  vSTATUS char(1);
  
BEGIN

  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
   -- Joga o proximo codigo no sequen
    IF isnull(trim(NEW.SEQUEN))='T' THEN
      NEW.SEQUEN:=ProximoCodigo('TT_HOR',NEW.CODFIL);
    END IF;
    -- Assume sempre a data de hoje
    NEW.DATREG := agora();    
  ELSIF (TG_OP = 'UPDATE') THEN
    NEW.DATREG := OLD.DATREG;    
  END IF;
  
  IF (TG_OP = 'UPDATE') OR (TG_OP = 'DELETE') THEN
     IF (OLD.FILRAT IS NOT NULL) AND (OLD.SEQRAT IS NOT NULL) THEN
        SELECT STATUS INTO vSTATUS 
        FROM TT_RAT
        WHERE CODFIL = OLD.FILRAT AND SEQUEN = OLD.SEQRAT;
       IF (TG_OP = 'UPDATE') THEN
         IF (vSTATUS = 'C') THEN
            RAISE EXCEPTION 'PG-20052 Nao e possivel alterar um registro de hora vinculado a RAT com status concluido %s' , vComplemento;
         END IF;
       END IF;
       IF (TG_OP = 'DELETE') THEN
         IF (vSTATUS = 'C') THEN
            RAISE EXCEPTION 'PG-20053 Nao e possivel excluir um registro de hora vinculado a RAT com status concluido %s' , vComplemento;
         END IF;
       END IF;
    END IF;

    Quemlogou:=DadosLogon();
    IF (QualDono() != GetApeUsuAtual()) THEN
      IF (QuemLogou.Encontrou) THEN
        -- Se nao for o mesmo usuario, so vai deixar mudar se for gerente
        IF (QuemLogou.FILUSU != OLD.FILUSU) OR (QuemLogou.CODUSU != OLD.CODUSU) THEN
          SELECT CASE WHEN SUBSTR(PERMISSOESUSUARIO(FILUSU,CODUSU),CODIGO_GERENTE_SAC,1)='S' THEN 'S'
                      WHEN SUBSTR(PERMISSOESUSUARIO(FILUSU,CODUSU),CODIGO_GERENTE_PRJ,1)='S' THEN 'S'
                 ELSE 'N'
                 END INTO wk_priv
            FROM TT_USU
           WHERE FILUSU = QuemLogou.FILUSU
             AND CODUSU = QuemLogou.CODUSU;
            
          IF wk_priv = 'N' THEN
             RAISE EXCEPTION 'PG-20050 Sem privilegio para alterar ou remover horario de outro usuario %s' , vComplemento;
          END IF;    
        END IF;      
      ELSE
         RAISE EXCEPTION 'PG-20051 Usuario nao esta cadastrado no Totali %s' , vComplemento;
      END IF;
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4216 --*/
CREATE TRIGGER TGHOR
BEFORE INSERT ON TT_HOR 
FOR EACH ROW EXECUTE PROCEDURE TGHOR();


/*-- SEQ 4217 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGHRE() CASCADE;

/*-- SEQ 4218 --*/
CREATE OR REPLACE FUNCTION TGHRE() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN := ProximoCodigo('TT_HRE',NEW.CODFIL);
    END IF;
    
    NEW.DATINC := AGORA();
    NEW.ATU_EM := AGORA();
  END IF;
  
  IF (TG_OP = 'UPDATE') THEN 
     NEW.ATU_EM := AGORA();
  END IF;
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4219 --*/
CREATE TRIGGER TGHRE
BEFORE INSERT OR UPDATE ON TT_HRE 
FOR EACH ROW EXECUTE PROCEDURE TGHRE();



/*-- SEQ 4220 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIAG2() CASCADE;

/*-- SEQ 4221 --*/
CREATE OR REPLACE FUNCTION TGIAG2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Atualizar TT_AGE

  inRec      TT_IAG%ROWTYPE;
  cDUMMY     VARCHAR(1);  

-- Principal
BEGIN
    -- Atualiza TT_AGE
    inRec.CODFIL := NEW.CODFIL;
    inRec.SEQUEN := NEW.SEQUEN;
    inRec.DATINI := NEW.DATINI;
    inRec.DATFIM := NEW.DATFIM;
  cDUMMY := PC_IAG_UPDATE(inRec.CODFIL,inRec.SEQUEN);

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4222 --*/
CREATE TRIGGER TGIAG2
AFTER INSERT OR DELETE OR UPDATE ON TT_IAG 
FOR EACH ROW EXECUTE PROCEDURE TGIAG2();



/*-- SEQ 4223 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIBG() CASCADE;

/*-- SEQ 4224 --*/
CREATE OR REPLACE FUNCTION TGIBG() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Trata dados padroes na inclusao 

-- Principal
BEGIN    
   -- Trata dados padroes na inclusao  
   IF (TG_OP = 'INSERT') THEN
      NEW.ATU_EM := AGORA(); 
   END IF;
   IF (TG_OP = 'UPDATE') THEN     
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser modificado.';     
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4225 --*/
CREATE TRIGGER TGIBG
BEFORE INSERT OR UPDATE ON TT_IBG 
FOR EACH ROW EXECUTE PROCEDURE TGIBG();

/*-- SEQ 4226 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIBG2() CASCADE;

/*-- SEQ 4227 --*/
CREATE OR REPLACE FUNCTION TGIBG2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4228 --*/
CREATE TRIGGER TGIBG2
AFTER INSERT OR UPDATE OR DELETE ON TT_IBG 
FOR EACH ROW EXECUTE PROCEDURE TGIBG2();


/*-- SEQ 4229 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIBP() CASCADE;

/*-- SEQ 4230 --*/
CREATE OR REPLACE FUNCTION TGIBP() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Atualizar TT_CFG.ATU_EM, fazendo com que o PoS entenda que tem que fazer carga e atualizar a tabela IBP
   cRetorno                      VARCHAR(2);

BEGIN
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    IF ISNULL(NEW.SEQUEN)='T' THEN
      NEW.SEQUEN:=ProximoCodigo('TT_IBP', NEW.CODFIL);
    END IF;
   NEW.DATINC := agora(); 
  END IF;

  -- MN - Popula a coluna ATU_EM e altera TT_CFG.ATU_EM para forar a carga no PoS da tabela IBP
  IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
     NEW.ATU_EM := agora();
     
     cRetorno := INSERE_MATU('TD_END', 'TT_CFG', '');
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4231 --*/
CREATE TRIGGER TGIBP
BEFORE INSERT OR UPDATE ON TT_IBP 
FOR EACH ROW EXECUTE PROCEDURE TGIBP();  


/*-- SEQ 4232 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGICCC() CASCADE;

/*-- SEQ 4233 --*/
CREATE OR REPLACE FUNCTION TGICCC() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Atualiar DATCRI e STATUS na inserção;

   -- Declaração de variáveis e cursores
   nProximo                      Numeric(10);
   -- Principal
BEGIN
   --  Trata dados padroes na inclusao
   IF (TG_OP = 'INSERT') THEN
      IF (COALESCE(NEW.ID_ICCC, 0) = 0) THEN
         SELECT NEXTVAL('SQICCC')  INTO nProximo FROM DUAL;
         NEW.ID_ICCC := nProximo;
      END IF;
      -- necessário para não gerar erro de NOT NULL no insert
      NEW.DATCRI := Agora();
      NEW.STATUS := 0; 
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4234 --*/
CREATE TRIGGER TGICCC
BEFORE INSERT OR UPDATE ON TI_CCC 
FOR EACH ROW EXECUTE PROCEDURE TGICCC();


/*-- SEQ 4235 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGICLI() CASCADE;

/*-- SEQ 4236 --*/
CREATE OR REPLACE FUNCTION TGICLI() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Gerar um cdigo sequencial exclusivo para garantir que a order de insero na tabela TI_CLI seja a de leitura para importao
BEGIN
  NEW.SEQUEN:=ProximoCodigo('TI_CLI','   ');
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4237 --*/
CREATE TRIGGER TGICLI
BEFORE INSERT ON TI_CLI 
FOR EACH ROW EXECUTE PROCEDURE TGICLI();



/*-- SEQ 4238 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGICO2() CASCADE;

/*-- SEQ 4239 --*/
CREATE OR REPLACE FUNCTION TGICO2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Impedir exclusoes
-- 2) Permitir apenas alteracao na coluna SITMOV
-- 3) Atualizar saldos
-- 4) Atualizar a movimentacao diaria
-- 5) Sincronizar datas entre TT_COM e TT_ICO
-- 6) Converter embalagens numa inclusao
--
   -- Para controle de embalagens
   NovoCODTAM                    TT_ICO.CODTAM%TYPE;
   NovoQTDMOV                    TT_ICO.QTDMOV%TYPE;
   NovoEMBORI                    TT_ICO.EMBORI%TYPE;
   NovoEMBQTD                    TT_ICO.EMBQTD%TYPE;
   vComplemento                  VARCHAR(254);
   vlixo                         VARCHAR(1);
   cDUMMY                        VARCHAR(1);
   nQTDMOV                       TT_ICO.QTDMOV%TYPE;
   nVLRMOV                       TT_ICO.VLRMOV%TYPE;

   bCalculaCusto                 boolean:=false;
   inRec                         TT_ICO%ROWTYPE;
   vVLRLIQ                       TT_COM.VLRLIQ%TYPE;
   vVLRTOT                       TT_COM.VLRTOT%TYPE;
   vCOMPIS                       TD_FIL.COMPIS%TYPE;
   vCOMCOF                       TD_FIL.COMCOF%TYPE;

   vVLRIPI                       TT_COM.VLRTOT%TYPE;
   vVLRITE                       TT_COM.VLRTOT%TYPE;

   vTCMIPI                       TD_FIL.TCMIPI%TYPE;

   vVem_de_CALCUSME              constant VARCHAR(1) := constante('vem_de_calcusmed');
   VEM_DE_REMOVEITEMTRANSFAUTOM  CONSTANT VARCHAR(1) := Constante('VEM_DE_REMOVEITEMTA');

   vFILORI                       TD_FIL.CODFIL%TYPE;
   vEH_TRANS                     CHAR(1);

   vDATCMP                       TT_COM.DATCMP%TYPE;

   vSUBFED                       TT_PRO.SUBFED%TYPE;
   vISEPIS                       TT_PRO.ISEPIS%TYPE;
   vSITIPI                       TT_PRO.SITIPI%TYPE;

   WK_MOVEST                     TT_SAL.MOVEST%TYPE;
   WK_MOVEST_OLD                 TT_SAL.MOVEST%TYPE;

   -- RFMP 69655
   vUFNOTA                       TT_COM.UFNOTA%TYPE;
   vUFLOJA                       TD_FIL.UFLOJA%TYPE;
   vREGESP                       TD_FIL.REGESP%TYPE;
   vMVAVEN                       TT_IUF.MVAVEN%TYPE;
   vMVAC04                       TT_IUF.MVAC04%TYPE;
   vMVAC07                       TT_IUF.MVAC07%TYPE;
   vMVAC12                       TT_IUF.MVAC12%TYPE;

   vBaseCM                       TT_ICO.VLR_CM%TYPE;
   nVlr_CM								TT_ICO.VLR_CM%TYPE;
   nVlrCMG								TT_ICO.VLRCMG%TYPE;	
   nVlr_STDIF                    TT_ICO.VLR_STDIF%TYPE;
   nVlr_ICM                      TT_ICO.VLRICM%TYPE;   
	
   vREGTRI                       TD_FIL.REGTRI%TYPE;
   vSUBTRI                       TT_IUF.SUBTRI%TYPE;
   vSUBITE                       TT_ICO.VLRMOV%TYPE;
   vSUBSTT                       TT_COM.SUBSTT%TYPE;
   vOUTDESITE                    TT_ICO.OUTDES%TYPE;
   vVLRICMANT                    TT_ICO.VLRICMANT%TYPE;
   vDESPARITE                    TT_COM.DESPAR%TYPE;
   cATUCUS                       TT_ICO.COM_ATUCUS%TYPE;
   cTIPCCM                       TT_ICO.COM_TIPCCM%TYPE;
   cFINNFE                       TT_COM.FINNFE%TYPE;
   vVem_de_TGCOM                 Constant VARCHAR(1) := constante('vem_de_TGCOM');
   cTRISIM                       TD_FIL.TRISIM%TYPE;
   cSUBSTITUTA                   TD_FIL.SUBSTITUTA%TYPE;
   
   cMOVEST_DCFO                  TD_CFO.MOVEST_DCFO%TYPE;

BEGIN
   vComplemento  := constante('complemento');

   -- Impede exclusoes
   IF (TG_OP = 'DELETE') THEN
            
      RAISE NOTICE 'Exclusao so pode ser feita atraves da rotina Manutencao.';
         END IF;

   -- Manoel - 22-12-2011 - Alterei para no permitir nulo nas colunas DIFs
   -- NO colocar regrinhas aqui, pois mascara problemas.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.VLRICMDIF:=coalesce(NEW.VLRICMDIF, NEW.VLRICM);
      NEW.BASICMDIF:=coalesce(NEW.BASICMDIF, NEW.BASICM);
      NEW.ICMITEDIF:=coalesce(NEW.ICMITEDIF, NEW.ICMITE);
      NEW.MVACOMDIF:=coalesce(NEW.MVACOMDIF, NEW.MVACOM);
      NEW.ICMVENDIF:=coalesce(NEW.ICMVENDIF, NEW.ICMVEN);
      NEW.RED_STDIF:=coalesce(NEW.RED_STDIF, NEW.RED_ST);
      NEW.BASSUBDIF:=coalesce(NEW.BASSUBDIF, NEW.BASSUB);
      NEW.VLR_STDIF:=coalesce(NEW.VLR_STDIF, NEW.VLR_ST);
      NEW.REDITEDIF:=coalesce(NEW.REDITEDIF, NEW.REDITE);
      NEW.ISEICMDIF:=coalesce(NEW.ISEICMDIF, NEW.ISEICM);
      NEW.OUTICMDIF:=coalesce(NEW.OUTICMDIF, NEW.OUTICM);
      NEW.CODCSTDIF:=coalesce(NEW.CODCSTDIF, NEW.CODCST);
   END IF;

   -- Impede alteracoes em determinadas colunas
   IF (TG_OP = 'UPDATE') THEN
      -- Impede mudancas na situacao de um item de compra cancelado
      IF (OLD.SITMOV = 'C') AND (NEW.SITMOV = 'N') THEN
                  
         RAISE NOTICE 'Um item cancelado nao pode ser reativado.';
               END IF;

      IF (OLD.EXPORT <> NEW.EXPORT) THEN
         IF NOT ( (OLD.EXPORT = 'F') AND (NEW.EXPORT = 'T') OR
            (OLD.EXPORT = 'T') AND (NEW.EXPORT = 'R') OR
            (OLD.EXPORT = 'R') AND (NEW.EXPORT = 'C') ) THEN
                        
            RAISE NOTICE 'Esta alteracao do controle de exportacao nao eh permitida.';
                     END IF;
      END IF;

   END IF;

   -- Atualiza LANEST se mudou o CFOP
   IF (TG_OP = 'UPDATE') THEN
      IF (NEW.CODCFO IS NOT NULL) AND (NEW.CODCFO <> OLD.CODCFO) THEN
        SELECT MOVEST_DCFO
          INTO cMOVEST_DCFO
          FROM TD_CFO
         WHERE CODTAB = NEW.CODCFO;

        IF cMOVEST_DCFO = 'T' THEN
           NEW.LANEST := 'S';
        ELSE
           NEW.LANEST := 'N';
        END IF;
      END IF;
   END IF;

  -- dummy is null ou no vem de customedio #1
  IF (NEW.DUMMY is null ) or (NEW.DUMMY<>vVem_de_CALCUSME) THEN

      IF ((TG_OP = 'INSERT')) OR ((TG_OP = 'UPDATE')) THEN
         -- RFMP 59685 Verifica se movimenta estoque
         WK_MOVEST := MovimentaEstoque(NEW.CODFIL,NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,NEW.CODMUL);
         -- MMC 2022048918 - Alterao de Sub-Estoque na tela de compras
         IF  ((TG_OP = 'UPDATE')) then
           WK_MOVEST_OLD := MovimentaEstoque(OLD.CODFIL,OLD.FILMAT,OLD.CODMAT,OLD.CODCOR,OLD.CODTAM,OLD.CODMUL);
         END IF;  
      END IF;

    IF (TG_OP = 'INSERT') THEN
       IF NEW.BASICM IS NULL THEN
           NEW.BASICM:=CASE NEW.ICMITEDIF WHEN 0 THEN 0
                                                   ELSE NEW.VLRMOV
                                                   END;
       END IF;

       IF NEW.OUTICM IS NULL THEN
            NEW.OUTICM:=CASE NEW.TIPPRO WHEN '1' THEN 0
                                          WHEN '4' THEN 0
                                                   ELSE CASE NEW.ICMITEDIF WHEN 0 THEN NEW.VLRMOV
                                                                                   ELSE 0
                                                                                   END
                                                   END;
       END IF;

       IF NEW.ISEICM IS NULL THEN
            NEW.ISEICM:=CASE NEW.TIPPRO WHEN '1' THEN NEW.VLRMOV
                                          WHEN '4' THEN NEW.VLRMOV
                                                              ELSE 0
                                                              END;
       END IF;
  END IF; -- final do dummy is null ou no vem de customedio #1

      IF ((TG_OP = 'UPDATE')) THEN  -- Incio do  (TG_OP = 'UPDATE') #4
         -- MMC 2022048918
         -- Se alterar o sub-estoque atualizar o saldo para o sub-estoque selecionado
         -- Tambem vai atualizar a movimentacao diaria

        -- Somente realiza processo quando Situao Normal e Item no for Servio
        IF  (NEW.TIPPRO <> '1') AND (NEW.SITMOV = 'N') THEN
          IF  (OLD.CODMUL <> NEW.CODMUL) OR (OLD.COM_DATOPE <> NEW.COM_DATOPE) THEN
            -- Movimenta Estoque para os antigos parmetros de Sub-Estoque e Data
            IF (OLD.LANEST = 'S') AND (WK_MOVEST_OLD = 'T') THEN
              vlixo:=TGR_ICO_Atualiza_Saldo(OLD.QTDMOV * -1, OLD.CODFIL, OLD.FILMAT,OLD.CODMAT,OLD.CODCOR,OLD.CODTAM,OLD.CODMUL);

              vlixo:=TGR_ICO_Atualiza_Movimento(OLD.QTDMOV * -1,OLD.VLRMOV * -1,OLD.CODFIL,OLD.SEQUEN,OLD.NUMITE,OLD.FILMAT,OLD.CODMAT,OLD.CODCOR,
                                               OLD.CODTAM, OLD.CODMUL, OLD.COM_DATOPE, cATUCUS, OLD.CUSFRE);

              IF (NEW.FILLOT IS NOT NULL) AND (NEW.SEQLOT IS NOT NULL) THEN
                 vlixo := TGR_ICO_Atualiza_Saldo_Lote(OLD.QTDMOV * -1, OLD.CODFIL, OLD.CODMUL, OLD.FILLOT, OLD.SEQLOT);
              END IF;
            END IF;

            -- Movimenta Estoque para os novos parmetros de Sub-Estoque e Data
            IF (NEW.LANEST='S') AND (WK_MOVEST = 'T') THEN
              vlixo:=TGR_ICO_Atualiza_Saldo(NEW.QTDMOV, NEW.CODFIL, NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,NEW.CODMUL);

              vlixo:=TGR_ICO_Atualiza_Movimento(NEW.QTDMOV, NEW.VLRMOV, NEW.CODFIL, NEW.SEQUEN, NEW.NUMITE, NEW.FILMAT, NEW.CODMAT, NEW.CODCOR,
                                                NEW.CODTAM, NEW.CODMUL, NEW.COM_DATOPE, cATUCUS, NEW.CUSFRE);

              IF (NEW.FILLOT IS NOT NULL) AND (NEW.SEQLOT IS NOT NULL) THEN
                 vlixo := TGR_ICO_Atualiza_Saldo_Lote(NEW.QTDMOV, NEW.CODFIL, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT);
              END IF;
            END IF;
          END IF; 
        END IF;
      
      
        -- Vai diminuir o saldo porque o item de compra foi cancelado
        -- Tambem vai atualizar a movimentacao diaria

        IF (OLD.SITMOV = 'N') AND (NEW.SITMOV = 'C') THEN

          -- RFMP 95450
          -- Quando o cancelamento  feito pela funo RemoveItemTransfAutom no deve processar o pedido,
          -- pois se trata de uma entrada de transferncia que no tem pedido vinculado.
          IF COALESCE(NEW.DUMMY, ' ') <> VEM_DE_REMOVEITEMTRANSFAUTOM THEN
             -- Reabre os itens de pedido se houver
             vlixo:=TGR_ICO_Atualiza_Pedido(OLD.CODFIL, OLD.SEQUEN, OLD.NUMITE, OLD.QTDMOV);
          END IF;

          IF  (NEW.LANEST = 'S') AND (WK_MOVEST   = 'T') AND
              (NEW.TIPPRO <> '1') THEN
            vlixo:=TGR_ICO_Atualiza_Saldo(OLD.QTDMOV * -1,NEW.CODFIL, NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,NEW.CODMUL);

            --Pedro E. Braga - 98995
            IF (NEW.DUMMY<>vVem_de_TGCOM) THEN
               --Busca finalidade da entrada
               SELECT COALESCE(COM.FINNFE,'0')
                 INTO cFINNFE
                 FROM TT_COM COM
                WHERE COM.CODFIL = NEW.CODFIL
                  AND COM.SEQUEN = NEW.SEQUEN;
            ELSE
               cFINNFE := '0';
            END IF;
            --Quando finalidade for Nota Complementar deve passar para TGR_ICO_Atualiza_Movimento - pATUCUS=F para no atualizar o ID da ultima compra assim atualiza apenas o Valor acumulado de custo
            IF (cFINNFE = '2') THEN
               cATUCUS := 'F';
            ELSE
               cATUCUS := NEW.COM_ATUCUS;
            END IF;

            vlixo:=TGR_ICO_Atualiza_Movimento(OLD.QTDMOV * -1,OLD.VLRMOV * -1,NEW.CODFIL,NEW.SEQUEN,NEW.NUMITE,NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,
                                              NEW.CODTAM,NEW.CODMUL,NEW.COM_DATOPE,cATUCUS,NEW.CUSFRE);

             IF (NEW.FILLOT IS NOT NULL) AND (NEW.SEQLOT IS NOT NULL) THEN
                vlixo := TGR_ICO_Atualiza_Saldo_Lote(OLD.QTDMOV * -1, NEW.CODFIL, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT);
             END IF;
          END IF;

          --NEW.DATINC := AGORA();
          NEW.ATU_EM := AGORA();
          NEW.COM_ATUCUS := 'F';
          NEW.COM_TIPCCM := 'Z'; -- Zera o Custo mdio para a entrada ao cancelar o item dentro da compra
          NEW.ATUFRE := 'F';

          IF OLD.EXPORT = 'T' THEN
             NEW.EXPORT := 'R';
          END IF;

          -- Rhuan - 103896 - Cancela os lotes do item de compra
          UPDATE TT_ICOXLOT
             SET SITMOV = 'C'
           WHERE FILICO = NEW.CODFIL
             AND SEQICO = NEW.SEQUEN
             AND ITEICO = NEW.NUMITE
             AND SITMOV <> 'C';
        END IF;

        -- "Flag" para evitar acessar TT_COM
        IF (NEW.DUMMY IS NULL) THEN
          -- Atualiza compras
          UPDATE TT_COM SET ATU_EM = agora()
          WHERE SEQUEN = OLD.SEQUEN
          AND CODFIL = OLD.CODFIL;
        END IF;

        -- Ha novo valor de frete, mas o custo medio nao foi informado.
        -- Assim, retira-se o valor de frete anterior e acrescenta-se o novo
        IF COALESCE(NEW.FREFIS,0) <> COALESCE(OLD.FREFIS,0)
           AND COALESCE(NEW.VLR_CM,0) = COALESCE(OLD.VLR_CM,0) THEN
           NEW.VLR_CM := COALESCE(OLD.VLR_CM,0) - (COALESCE(OLD.FREFIS,0)*NVLZ(OLD.QTDMOV,1)) + (COALESCE(NEW.FREFIS,0)*NVLZ(NEW.QTDMOV,1));
        END IF;
        IF COALESCE(NEW.CUSFRE,0) <> COALESCE(OLD.CUSFRE,0)
           AND COALESCE(NEW.VLRCMG,0) = COALESCE(OLD.VLRCMG,0) THEN
           -- Ha novo valor de frete, mas o custo medio gerencial nao foi informado.
           -- Assim, retira-se o valor de frete anterior e acrescenta-se o novo
           NEW.VLRCMG := COALESCE(OLD.VLRCMG,0) - (COALESCE(OLD.CUSFRE,0)*NVLZ(OLD.QTDMOV,1)) + (COALESCE(NEW.CUSFRE,0)*NVLZ(NEW.QTDMOV,1));
        END IF;
      END IF; -- Fim do  (TG_OP = 'UPDATE') #4

      IF (TG_OP = 'INSERT') THEN
        -- Corrige os dados passados de acordo com a embalagem
        SELECT COALESCE(DSUB.CODSAL,SUB.CODITE) AS CODTAM,
               NEW.QTDMOV * CASE WHEN DSUB.CODSAL IS NULL THEN 1 ELSE SUB.FATCON END AS QTDMOV,
               CASE WHEN DSUB.CODSAL IS NULL THEN NULL ELSE SUB.CODITE  END AS EMBORI,
               CASE WHEN DSUB.CODSAL IS NULL THEN NULL ELSE NEW.QTDMOV END AS EMBQTD
        INTO NovoCODTAM, NovoQTDMOV, NovoEMBORI, NovoEMBQTD
        FROM TD_SUB DSUB, TT_SUB SUB
        WHERE SUB.CODSUB = DSUB.CODTAB
          AND SUB.CODITE = NEW.CODTAM;

        NEW.CODTAM := NovoCODTAM;
        NEW.QTDMOV := NovoQTDMOV;
        NEW.EMBORI := NovoEMBORI;
        NEW.EMBQTD := NovoEMBQTD;

        --74127
        IF NEW.ICO_VLRFRE IS NULL THEN
           NEW.ICO_VLRFRE := 0;
        END IF;

        -- Obtem a data da compra
        SELECT CASE WHEN INSTR( COM.NUMNOT, '###' ) > 0 THEN AGORA() ELSE COM.DATOPE END, -- Para transf. automatica mantem a data atual no item
               COM.VLRLIQ,COM.VLRTOT,coalesce(FIL.COMPIS,0),coalesce(FIL.COMCOF,0),
               CASE WHEN (SELECT COUNT(*)
                            FROM TT_TRA TRA
                           WHERE TRA.FILICO=COM.CODFIL
                             AND TRA.SEQICO=COM.SEQUEN)>0
                    THEN 'T'
                    ELSE 'F'
               END, COM.FILFOR,
               DATCMP, COM.ATUCUS, COM.TIPCCM,
               COM.UFNOTA, FIL.UFLOJA, COALESCE(FIL.REGTRI,'N'), REGESP,
               COALESCE(CASE WHEN NEW.ICMTIP = '3' AND COALESCE(COM.BASSUB,0) > 0 THEN
                          (COM.SUBSTT *
                               (NEW.VLRMOV + NEW.ICO_VLRFRE + NEW.VLRIPI + COALESCE(NEW.IPIFRE,0)) * (1+(COALESCE(NEW.MVACOMDIF,0)/100)) -- (Valor + Frete + IPI)  * % MVA
                                    / Nvlz(COM.BASSUB,1))
                          ELSE NULL
                END,0) AS SUBITE,
                COM.SUBSTT,
                COALESCE(NEW.OUTDES, CASE WHEN COALESCE(COM.VLRNOT,0) <> 0 THEN COALESCE(COALESCE(COM.OUTDES,0)*(NEW.VLRMOV/COM.VLRNOT),0) ELSE 0 END),
                COALESCE(NEW.VLRICMANT, 0),
                CASE WHEN COALESCE(COM.VLRNOT,0) <> 0 THEN COALESCE(COM.DESPAR*(NEW.VLRMOV/COM.VLRNOT),0) ELSE 0 END,
                COALESCE(FIL.TRISIM,'X')
          INTO NEW.COM_DATOPE, vVLRLIQ, vVLRTOT, vCOMPIS, vCOMCOF, vEH_TRANS, vFILORI, vDATCMP, NEW.COM_ATUCUS, NEW.COM_TIPCCM,
               vUFNOTA, vUFLOJA, vREGTRI, vREGESP, vSUBITE, vSUBSTT, vOUTDESITE, vVLRICMANT, vDESPARITE, cTRISIM
          FROM TT_COM COM INNER JOIN TD_FIL FIL ON COM.CODFIL = FIL.CODFIL
         WHERE COM.CODFIL = NEW.CODFIL
           AND COM.SEQUEN = NEW.SEQUEN;

        -- busca impostos estaduais
           SELECT IUF.MVAVEN, IUF.MVAC04, IUF.MVAC07, IUF.MVAC12, IUF.SUBTRI
             INTO vMVAVEN, vMVAC04, vMVAC07, vMVAC12, vSUBTRI
             FROM TT_IUF IUF
            WHERE IUF.FILMAT = NEW.FILMAT
              AND IUF.CODMAT = NEW.CODMAT
              AND IUF.ESTADO = vUFLOJA
              and IUF.REGESP = vREGESP;

        -- RFMP 69655 - % MVA
        IF ((Equal(NEW.ICMTIP,'3')=1) -- substitudo
        OR  (Equal(NEW.RETSUB,'T')=1)) -- RFMP 71114 - retm ICMS na fonte por substituio tributria
        AND (ISNOTNULL(TRIM(vUFNOTA)) = 'T')
        AND (ISNOTNULL(TRIM(vUFLOJA)) = 'T') THEN

           -- descobre % MVA do item
           -- operaes interestaduais que tenham MVA diferenciada para compra
           IF (Equal(vUFLOJA,vUFNOTA)<>1) THEN -- diferente
              IF NEW.ICMITEDIF = 4 AND vMVAC04 <> 0 THEN
                 NEW.MVACOMDIF := vMVAC04;
              ELSIF NEW.ICMITEDIF = 7 AND vMVAC07 <> 0 THEN
                 NEW.MVACOMDIF := vMVAC07;
              ELSIF NEW.ICMITEDIF = 12 AND vMVAC12 <> 0 THEN
                 NEW.MVACOMDIF := vMVAC12;
              END IF;
           END IF;
           -- caso no tenham encontrado % MVA diferenciado para compra aplica-se o padro
           IF COALESCE(NEW.MVACOMDIF,0) = 0 THEN
              NEW.MVACOMDIF := vMVAVEN;
           END IF;
        END IF;

       NEW.DATINC := AGORA();
       NEW.ATU_EM := AGORA();

        IF vVLRTOT = 0 THEN
           vVLRTOT := 1;
        END IF;

        SELECT TCMIPI INTO vTCMIPI
          FROM TD_FIL
         WHERE CODFIL=NEW.CODFIL;
         
         SELECT COALESCE(SUBSTITUTA,'F') INTO cSUBSTITUTA
          FROM TD_FIL
         WHERE CODFIL=vFILORI;

        SELECT COALESCE(SUBFED,'F'),
               COALESCE(ISEPIS,'F'),
                        SITIPI INTO vSUBFED, vISEPIS, vSITIPI
          FROM TT_PRO
         WHERE FILMAT=NEW.FILMAT
           AND CODMAT=NEW.CODMAT;

        -- Manoel - 86370 - Tratamento para servicos
        vVLRIPI:=0;
        IF vEH_TRANS = 'F'  THEN
           IF  NEW.TIPPRO <> '1' THEN
             vVLRIPI     := COALESCE(NEW.VLRIPI,0);          -- Valor do ipi
             NEW.BASIPI := COALESCE(NEW.ICO_VLRFRE,0) + NEW.VLRMOV;
             NEW.SITIPI := COALESCE(NEW.SITIPI,vSITIPI);
           END IF;
        END IF;

      NEW.QTD_CM := NEW.QTDMOV;
      NEW.VLR_CM := 0;
      NEW.VLRCMG := 0;		
   
      --Na insert do registro deve passar os mesmos valores para os campos do CM, 
      --posteriormente se for necessrio alterar algum dos valores abaixo ao inv?de alterar direto na coluna da nota altera o campo do CM 
      NEW.BASICM_CM := COALESCE(NEW.BASICM_CM, NEW.BASICMDIF);
      NEW.VLRICM_CM := COALESCE(NEW.VLRICM_CM, NEW.VLRICMDIF);
      NEW.BAS_ST_CM := COALESCE(NEW.BAS_ST_CM, NEW.BASSUBDIF);
      NEW.VLR_ST_CM := COALESCE(NEW.VLR_ST_CM, NEW.VLR_STDIF);

            -- Condio Anterior
            --IF (NEW.COM_ATUCUS='T' AND LeParametroBoo('ZERA_CUSTO_BONIFIC', NEW.CODFIL, null, null, null)='T') or
            --   (LeParametroBoo('ZERA_CUSTO_BONIFIC', NEW.CODFIL, null, null, null)='F') or
            --   (vEH_TRANS = 'T') THEN
      -- Tipo de Custo Mdio Calculado ou no definido o qual entende-se que  calculado
      -- Ou  uma Transferncia
      IF (COALESCE(NEW.COM_TIPCCM,'C')='C') OR
         (vEH_TRANS = 'T') THEN

			vVLRITE:=((vVLRLIQ-COALESCE(vSUBSTT,0))*(NEW.VLRMOV+vVLRIPI)/Nvlz(vVLRTOT,1))-vVLRIPI; -- Valor do item rateado

			IF vEH_TRANS = 'F'  THEN

			   IF NEW.LANEST='N' THEN
				   NEW.QTD_CM := 0;
				   NEW.VLRCMG := vVLRIPI;
				   NEW.VLR_CM := vVLRIPI;

				   IF LeParametroBoo('CM_SEM_MOVEST', NEW.CODFIL, null, null, null)='T' THEN
					   NEW.VLR_CM := NEW.VLR_CM -
									  CASE WHEN vREGTRI = 'S' THEN 0 ELSE COALESCE(NEW.VLRPIS,0) END -
									  CASE WHEN vREGTRI = 'S' THEN 0 ELSE COALESCE(NEW.VLRCOF,0) END;
				   END IF;
			   ELSE
					vBaseCM := vVLRITE -- Valor do Item
								+ (COALESCE(NEW.FREFIS,0)*NVLZ(NEW.QTDMOV,1)) -- Valor Frete
								+ vVLRIPI; -- IPI
					IF NEW.ICMTIP = '0' AND vSUBTRI = '3' AND NEW.RETSUB = 'T' THEN
					  NEW.VLR_CM := vBaseCM
									 + COALESCE(NEW.ICO_VLRRET,0)
									 - CASE WHEN vREGTRI = 'S' THEN 0 ELSE COALESCE(NEW.VLRPIS,0) END
									 - CASE WHEN vREGTRI = 'S' THEN 0 ELSE COALESCE(NEW.VLRCOF,0) END
									 + vOUTDESITE
                            + vVLRICMANT
									 + vDESPARITE;
					ELSE
					  NEW.VLR_CM := vBaseCM
									 + COALESCE(NEW.VLR_STDIF,vSUBITE,0)
									 + COALESCE(NEW.ICO_VLRRET,0)
									 - CASE WHEN vREGTRI = 'S' THEN 0 ELSE
										  COALESCE(CASE WHEN NEW.CODCSTDIF NOT IN ('10','30','60','70','201','202') -- RFMP PCIA CLIENTE SUBSTITUTO
														THEN NEW.VLRICMDIF
														ELSE 0
												   END,0)
									   END
									 - CASE WHEN vREGTRI = 'S' THEN 0 ELSE COALESCE(NEW.VLRPIS,0) END
									 - CASE WHEN vREGTRI = 'S' THEN 0 ELSE COALESCE(NEW.VLRCOF,0) END
									 + vOUTDESITE
                            + vVLRICMANT
									 + vDESPARITE;
					END IF;
				   NEW.VLRCMG := vVLRITE  -- Valor do Item
									+ (COALESCE(NEW.CUSFRE,0)*NVLZ(NEW.QTDMOV,1))  -- Valor Frete
									+ vVLRIPI -- IPI
									+ COALESCE(NEW.VLR_STDIF,vSUBITE,0)
									+ COALESCE(NEW.ICO_VLRRET,0)
									+ vOUTDESITE
                           + vVLRICMANT
									+ vDESPARITE;
			   END IF;
			ELSE
				IF COALESCE(NEW.VLR_CM,0)=0 THEN
					NEW.VLR_CM := (CustoMedio(vFILORI, NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM, 3,vDATCMP)*NVLZ(NEW.QTDMOV,1))+
					           COALESCE(NEW.ICO_VLRRET,0) +
                          CASE WHEN cSUBSTITUTA='T' AND COALESCE(NEW.VLR_STDIF,0) > 0
                               THEN COALESCE(NEW.VLR_STDIF,0) + COALESCE(NEW.VLRICM,0)
                               ELSE 0
                          END;
				END IF;						
				
				IF COALESCE(NEW.VLRCMG,0)=0 THEN
					NEW.VLRCMG := (CustoMedio(vFILORI, NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM, 5,vDATCMP)*NVLZ(NEW.QTDMOV,1))+
									COALESCE(NEW.ICO_VLRRET,0) +
                           CASE WHEN cSUBSTITUTA='T' AND COALESCE(NEW.VLR_STDIF,0) > 0
                               THEN COALESCE(NEW.VLR_STDIF,0) + COALESCE(NEW.VLRICM,0)
                               ELSE 0
                          END;
			   END IF;
			END IF;
      -- Mantem o custo mdio atual incluindo nova quantidade
      ELSIF (COALESCE(NEW.COM_TIPCCM,'C')='M') THEN
         IF COALESCE(NEW.VLR_CM,0)=0 THEN
           NEW.VLR_CM := (CustoMedio(NEW.CODFIL, NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM, 3,vDATCMP)*NVLZ(NEW.QTDMOV,1))+COALESCE(NEW.ICO_VLRRET,0);
         END IF;
         IF COALESCE(NEW.VLRCMG,0)=0 THEN
           NEW.VLRCMG := (CustoMedio(NEW.CODFIL, NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM, 5,vDATCMP)*NVLZ(NEW.QTDMOV,1))+COALESCE(NEW.ICO_VLRRET,0);
         END IF;
      -- Zero o custo mdio para o item
      ELSIF (COALESCE(NEW.COM_TIPCCM,'C')='Z') THEN
         NEW.QTD_CM := NEW.QTDMOV;
         NEW.VLR_CM := 0;
         NEW.VLRCMG := 0;
		END IF;
      -- Grava Valores originais do Custo Mdio com sua primeira informao aplicada
      NEW.VLR_CMORI := COALESCE(NEW.VLR_CMORI, NEW.VLR_CM);
      NEW.VLRCMGORI := COALESCE(NEW.VLRCMGORI, NEW.VLRCMG);

        -- Vai aumentar o saldo porque e uma nova compra
        -- Tambem vai atualizar a movimentacao diaria
        IF  (NEW.SITMOV <> 'C')
        AND (NEW.LANEST = 'S')
        AND (WK_MOVEST   = 'T') THEN
          vlixo:=TGR_ICO_Atualiza_Saldo(NEW.QTDMOV,NEW.CODFIL,NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,NEW.CODMUL);
          --vlixo:=TGR_ICO_Atualiza_Movimento(NEW.QTDMOV,NEW.VLRMOV,NEW.CODFIL,NEW.SEQUEN,NEW.NUMITE,NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,
          --                           NEW.CODTAM,NEW.CODMUL,NEW.COM_DATOPE,NEW.COM_ATUCUS,NEW.CUSFRE);

        IF (NEW.FILLOT IS NOT NULL) AND (NEW.SEQLOT IS NOT NULL) THEN
           vlixo := TGR_ICO_Atualiza_Saldo_Lote(NEW.QTDMOV, NEW.CODFIL, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT);
        END IF;
      END IF;
      END IF;

      -- Tratamento para atualizar saldo quando LANEST for alterado
      IF (TG_OP = 'UPDATE') THEN
         IF  (NEW.SITMOV <> 'C')
         AND (NEW.LANEST <> OLD.LANEST)
         AND (WK_MOVEST   = 'T') THEN

           IF NEW.LANEST = 'N' THEN
               -- Diminui saldo
               nQTDMOV := NEW.QTDMOV * -1;
               nVLRMOV := NEW.VLRMOV * -1;
            ELSE
               -- Aumenta saldo
               nQTDMOV := NEW.QTDMOV;
               nVLRMOV := NEW.VLRMOV;
            END IF;

            cDUMMY := TGR_ICO_Atualiza_Saldo(nQTDMOV,NEW.CODFIL,NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,NEW.CODMUL);

            --Quando finalidade for Nota Complementar deve passar para TGR_ICO_Atualiza_Movimento - pATUCUS=F para no atualizar o ID da ultima compra assim atualiza apenas o Valor acumulado de custo
            IF (cFINNFE = '2') THEN
               cATUCUS := 'F';
            ELSE
               cATUCUS := NEW.COM_ATUCUS;
            END IF;

            cDUMMY := TGR_ICO_Atualiza_Movimento(nQTDMOV,nVLRMOV,NEW.CODFIL,NEW.SEQUEN,NEW.NUMITE,NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,
                                                 NEW.CODTAM,NEW.CODMUL,NEW.COM_DATOPE,cATUCUS,NEW.CUSFRE);

            IF (NEW.FILLOT IS NOT NULL) AND (NEW.SEQLOT IS NOT NULL) THEN
               cDUMMY := TGR_ICO_Atualiza_Saldo_Lote(nQTDMOV, NEW.CODFIL, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT);
            END IF;
         END IF;
      END IF;

      -- Recalcula a data para CustoMedio
      IF (TG_OP = 'INSERT') THEN
         bCalculaCusto:=true;
      END IF;

      /* 77357 */
      IF (TG_OP = 'UPDATE') THEN
        IF (NEW.DUMMY IS NULL) THEN
            -- Obtem a data da compra
            SELECT CASE WHEN INSTR( COM.NUMNOT, '###' ) > 0 THEN AGORA() ELSE COM.DATOPE END, -- Para transf. automatica mantem a data atual no item
                   COM.VLRLIQ,COM.VLRTOT,coalesce(FIL.COMPIS,0),coalesce(FIL.COMCOF,0),
                   CASE WHEN (SELECT COUNT(*)
                         FROM TT_TRA TRA
                     WHERE TRA.FILICO=COM.CODFIL
                       AND TRA.SEQICO=COM.SEQUEN)>0
                   THEN 'T'
                        ELSE 'F'
                   END, COM.FILFOR,
                   DATCMP, COM.ATUCUS, COM.TIPCCM,
                   COM.UFNOTA, FIL.UFLOJA, COALESCE(FIL.REGTRI,'N'), REGESP,
                   COALESCE(CASE WHEN NEW.ICMTIP = '3' AND COALESCE(COM.BASSUB,0) > 0 THEN
                              (COM.SUBSTT *
                                   (NEW.VLRMOV + NEW.ICO_VLRFRE + NEW.VLRIPI + COALESCE(NEW.IPIFRE,0)) * (1+(COALESCE(NEW.MVACOMDIF,0)/100)) -- (Valor + Frete + IPI)  * % MVA
                                        / Nvlz(COM.BASSUB,1))
                              ELSE NULL
                    END,0) AS SUBITE,
                    COM.SUBSTT,
                    COALESCE(NEW.OUTDES, CASE WHEN COALESCE(COM.VLRNOT,0) <> 0 THEN COALESCE(COALESCE(COM.OUTDES,0)*(NEW.VLRMOV/COM.VLRNOT),0) ELSE 0 END),
                    COALESCE(NEW.VLRICMANT, 0),
                    CASE WHEN COALESCE(COM.VLRNOT,0) <> 0 THEN COALESCE(COM.DESPAR*(NEW.VLRMOV/COM.VLRNOT),0) ELSE 0 END,
                    COALESCE(FIL.TRISIM,'X')
              INTO NEW.COM_DATOPE, vVLRLIQ, vVLRTOT, vCOMPIS, vCOMCOF, vEH_TRANS, vFILORI, vDATCMP, NEW.COM_ATUCUS, NEW.COM_TIPCCM,
                   vUFNOTA, vUFLOJA, vREGTRI, vREGESP, vSUBITE, vSUBSTT, vOUTDESITE, vVLRICMANT, vDESPARITE, cTRISIM
              FROM TT_COM COM INNER JOIN TD_FIL FIL ON COM.CODFIL = FIL.CODFIL
             WHERE COM.CODFIL = NEW.CODFIL
               AND COM.SEQUEN = NEW.SEQUEN;

            -- busca impostos estaduais
            SELECT IUF.MVAVEN, IUF.MVAC04, IUF.MVAC07, IUF.MVAC12, IUF.SUBTRI
              INTO vMVAVEN, vMVAC04, vMVAC07, vMVAC12, vSUBTRI
              FROM TT_IUF IUF
             WHERE IUF.FILMAT = NEW.FILMAT
               AND IUF.CODMAT = NEW.CODMAT
               AND IUF.ESTADO = vUFLOJA
               AND IUF.REGESP = vREGESP;

            -- Manoel - 86370 - Tratamento para servicos
            vVLRIPI:=0;
            IF  (NEW.TIPPRO <> '1') THEN
              vVLRIPI:=COALESCE(NEW.VLRIPI,0); -- Valor do ipi
            END IF;

            vVLRITE:=((vVLRLIQ-COALESCE(vSUBSTT,0))*(NEW.VLRMOV+vVLRIPI)/Nvlz(vVLRTOT,1))-vVLRIPI; -- Valor do item rateado

            SELECT TCMIPI INTO vTCMIPI
              FROM TD_FIL
             WHERE CODFIL=NEW.CODFIL;

            SELECT COALESCE(SUBSTITUTA,'F') INTO cSUBSTITUTA
              FROM TD_FIL
             WHERE CODFIL=vFILORI;

            SELECT COALESCE(SUBFED,'F'),
                   COALESCE(ISEPIS,'F'),
                            SITIPI INTO vSUBFED, vISEPIS, vSITIPI
              FROM TT_PRO
             WHERE FILMAT=NEW.FILMAT
               AND CODMAT=NEW.CODMAT;

         NEW.QTD_CM := NEW.QTDMOV;
         NEW.VLR_CM := 0;
         NEW.VLRCMG := 0;


            -- Condio Anterior
            --IF (NEW.COM_ATUCUS='T' AND LeParametroBoo('ZERA_CUSTO_BONIFIC', NEW.CODFIL, null, null, null)='T') or
            --   (LeParametroBoo('ZERA_CUSTO_BONIFIC', NEW.CODFIL, null, null, null)='F') or
            --   (vEH_TRANS = 'T') THEN
      -- Tipo de Custo Mdio Calculado ou no definido o qual entende-se que  calculado
      -- Ou  uma Transferncia
      IF (COALESCE(NEW.COM_TIPCCM,'C')='C') OR
         (vEH_TRANS = 'T') THEN
            IF vEH_TRANS = 'F'  THEN

               IF NEW.LANEST='N' THEN
                  NEW.QTD_CM := 0;
                  NEW.VLRCMG := vVLRIPI;
                  NEW.VLR_CM := vVLRIPI;

                  IF LeParametroBoo('CM_SEM_MOVEST', NEW.CODFIL, null, null, null)='T' THEN
                     NEW.VLR_CM := NEW.VLR_CM -
                                    CASE WHEN vREGTRI = 'S' THEN 0 ELSE COALESCE(NEW.VLRPIS,0) END -
                                    CASE WHEN vREGTRI = 'S' THEN 0 ELSE COALESCE(NEW.VLRCOF,0) END;
                  END IF;


               ELSE
                  vBaseCM := vVLRITE -- Valor do Item
                               + (COALESCE(NEW.FREFIS,0)*NVLZ(NEW.QTDMOV,1)) -- Valor Frete
                               + vVLRIPI; -- IPI
                  IF NEW.ICMTIP = '0' AND vSUBTRI = '3' AND NEW.RETSUB = 'T' THEN
                     NEW.VLR_CM := vBaseCM
                               + COALESCE(NEW.ICO_VLRRET,0)
                               - CASE WHEN vREGTRI = 'S' THEN 0 ELSE COALESCE(NEW.VLRPIS,0) END
                               - CASE WHEN vREGTRI = 'S' THEN 0 ELSE COALESCE(NEW.VLRCOF,0) END
                               + vOUTDESITE
                               + vVLRICMANT
                               + vDESPARITE;
                  ELSE
                     NEW.VLR_CM := vBaseCM
                               + COALESCE(NEW.VLR_STDIF,vSUBITE,0)
                               + COALESCE(NEW.ICO_VLRRET,0)
                               - CASE WHEN vREGTRI = 'S' THEN 0 ELSE
                                    COALESCE(CASE WHEN NEW.CODCSTDIF NOT IN ('10','30','60','70','201','202') -- RFMP PCIA CLIENTE SUBSTITUTO
                                                  THEN NEW.VLRICMDIF
                                                  ELSE 0
                                              END,0)
                                 END
                               - CASE WHEN vREGTRI = 'S' THEN 0 ELSE COALESCE(NEW.VLRPIS,0) END
                               - CASE WHEN vREGTRI = 'S' THEN 0 ELSE COALESCE(NEW.VLRCOF,0) END
                               + vOUTDESITE
                               + vVLRICMANT
                               + vDESPARITE;
                  END IF;
                  NEW.VLRCMG := vVLRITE  -- Valor do Item
                              + (COALESCE(NEW.CUSFRE,0)*NVLZ(NEW.QTDMOV,1))  -- Valor Frete
                              + vVLRIPI -- IPI
                              + COALESCE(NEW.VLR_STDIF,vSUBITE,0)
                              + COALESCE(NEW.ICO_VLRRET,0)
                              + vOUTDESITE
                              + vVLRICMANT
                              + vDESPARITE;

               END IF;

            ELSE
               IF (COALESCE(NEW.VLR_CM,0)=0) OR (COALESCE(NEW.VLRCMG,0)=0) OR (COALESCE(OLD.ICO_VLRRET,0)<>COALESCE(NEW.ICO_VLRRET,0)) THEN
                  nVlr_CM := (CustoMedio(vFILORI, NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM, 3,vDATCMP)*NVLZ(NEW.QTDMOV,1));
                  -- Realiza novo calculo dos impostos
                  IF (LeParametroBoo('USACM_BASE_IMP_TRANS', NEW.CODFIL, null, null, null)='T') THEN
                     -- Majorar Valor de Item Substitudos em Transferncia?
                     IF ((LeParametroBoo('TRANSF_VLRITE_ST_MAJ', NEW.CODFIL, null, null, null)='T') AND (COALESCE(NEW.ICMVENDIF,0) > 0) AND (NEW.ICMTIP = '3')) THEN
                        NEW.BASICM_CM := nVlr_CM / (1 - (COALESCE(NEW.ICMVENDIF,0) / 100)); -- Define o Valor Base
                        NEW.BAS_ST_CM := nVlr_CM / (1 - (COALESCE(NEW.ICMVENDIF,0) / 100)); -- Define o Valor Base
                     ELSE 
                        NEW.BASICM_CM := nVlr_CM; -- Define o Valor Base
                        NEW.BAS_ST_CM := nVlr_CM; -- Define o Valor Base
                     END IF;
                     -- Calculo do Novo ICMS
                     NEW.BASICM_CM := ROUND(COALESCE(NEW.BASICM_CM, 0) - (COALESCE(NEW.BASICM_CM, 0) * (COALESCE(NEW.REDITEDIF,0) / 100)), 4); -- Aplica Reduo de Base de ICMS
                     NEW.VLRICM_CM := ROUND(COALESCE(NEW.BASICM_CM, 0) * (COALESCE(NEW.ICMITEDIF,0) / 100), 4); -- Calcula Valor do ICMS
                     -- Calculo do Novo ICMS ST
                     NEW.BAS_ST_CM := (COALESCE(NEW.BAS_ST_CM, 0) + (COALESCE(NEW.BAS_ST_CM, 0) * (COALESCE(NEW.MVACOMDIF,0) / 100))); -- Adiciona o MVA
                     NEW.BAS_ST_CM := ROUND(COALESCE(NEW.BAS_ST_CM, 0) - (COALESCE(NEW.BAS_ST_CM, 0) * COALESCE(NEW.RED_STDIF,0)), 4); -- Aplica Reduo da Base de ICMS ST
                     NEW.VLR_ST_CM := ROUND((COALESCE(NEW.BAS_ST_CM, 0) * (COALESCE(NEW.ICMVENDIF,0) / 100)) - COALESCE(NEW.VLRICM_CM, 0), 4); -- Calcula Valor do ICMS ST
                  ELSE
                     NEW.BASICM_CM := NEW.BASICMDIF;
                     NEW.VLRICM_CM := NEW.VLRICMDIF;
                     NEW.BAS_ST_CM := NEW.BASSUBDIF;
                     NEW.VLR_ST_CM := NEW.VLR_STDIF;
                  END IF; 
               END IF; 
               
               IF (COALESCE(NEW.VLR_CM,0)=0) OR (COALESCE(OLD.ICO_VLRRET,0)<>COALESCE(NEW.ICO_VLRRET,0)) THEN
                  IF (LeParametroBoo('USACM_BASE_IMP_TRANS', NEW.CODFIL, null, null, null)='T') THEN
                     nVlr_STDIF := COALESCE(NEW.VLR_ST_CM,0);
                     nVlr_ICM   := COALESCE(NEW.VLRICM_CM,0);
                  ELSE 
                     nVlr_STDIF := COALESCE(NEW.VLR_STDIF,0);
                     nVlr_ICM   := COALESCE(NEW.VLRICM,0);
                  END IF; 

                  nVlr_CM := nVlr_CM + COALESCE(NEW.ICO_VLRRET,0) + 
                                       CASE WHEN cSUBSTITUTA='T' AND nVlr_STDIF > 0
                                             THEN nVlr_STDIF + nVlr_ICM
                                             ELSE 0
                                       END;

                  NEW.VLR_CM := nVlr_CM;
               END IF;

               IF (COALESCE(NEW.VLRCMG,0)=0) OR (COALESCE(OLD.ICO_VLRRET,0)<>COALESCE(NEW.ICO_VLRRET,0)) THEN
                  nVlrCmg := (CustoMedio(vFILORI, NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM, 5,vDATCMP)*NVLZ(NEW.QTDMOV,1))+
                              COALESCE(NEW.ICO_VLRRET,0);

                  IF (LeParametroBoo('USACM_BASE_IMP_TRANS', NEW.CODFIL, null, null, null)='T') THEN
                     nVlr_STDIF := COALESCE(NEW.VLR_ST_CM,0);
                     nVlr_ICM   := COALESCE(NEW.VLRICM_CM,0);
                  ELSE 
                     nVlr_STDIF := COALESCE(NEW.VLR_STDIF,0);
                     nVlr_ICM   := COALESCE(NEW.VLRICM,0);
                  END IF; 

                  nVlrCmg := nVlrCmg + CASE WHEN cSUBSTITUTA='T' AND nVlr_STDIF > 0
                                             THEN nVlr_STDIF + nVlr_ICM
                                             ELSE 0
                                       END;	

                  NEW.VLRCMG := nVlrCmg;
               END IF;
            END IF;
         -- Mantem o custo mdio atual incluindo nova quantidade
         ELSIF (COALESCE(NEW.COM_TIPCCM,'C')='M') THEN
            IF (COALESCE(NEW.VLR_CM,0)=0) OR (COALESCE(OLD.ICO_VLRRET,0)<>COALESCE(NEW.ICO_VLRRET,0)) THEN
              NEW.VLR_CM := (CustoMedio(NEW.CODFIL, NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM, 3,vDATCMP)*NVLZ(NEW.QTDMOV,1))+COALESCE(NEW.ICO_VLRRET,0);
            END IF;
            IF (COALESCE(NEW.VLRCMG,0)=0) OR (COALESCE(OLD.ICO_VLRRET,0)<>COALESCE(NEW.ICO_VLRRET,0)) THEN
              NEW.VLRCMG := (CustoMedio(NEW.CODFIL, NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM, 5,vDATCMP)*NVLZ(NEW.QTDMOV,1))+COALESCE(NEW.ICO_VLRRET,0);
            END IF;
         -- Zero o custo mdio para o item
         ELSIF (COALESCE(NEW.COM_TIPCCM,'C')='Z') THEN
            NEW.QTD_CM := NEW.QTDMOV;
            NEW.VLR_CM := 0;
            NEW.VLRCMG := 0;
			END IF;
        END IF;
      END IF;
      -- Grava Valores originais do Custo Mdio com sua primeira informao aplicada
      NEW.VLR_CMORI := COALESCE(NEW.VLR_CMORI, NEW.VLR_CM);
      NEW.VLRCMGORI := COALESCE(NEW.VLRCMGORI, NEW.VLRCMG);
      NEW.TOT_CMORI := COALESCE(NEW.TOT_CMORI, NEW.TOT_CM);
      NEW.TOTCMGORI := COALESCE(NEW.TOTCMGORI, NEW.TOTCMG);
      NEW.SAL_CMORI := COALESCE(NEW.SAL_CMORI, NEW.SAL_CM);
  END IF;

  IF (TG_OP = 'UPDATE') THEN
    IF (Equal(OLD.QTD_CM,NEW.QTD_CM)<>1) or
       (Equal(OLD.VLR_CM,NEW.VLR_CM)<>1) or
       (Equal(OLD.VLRCMG,NEW.VLRCMG)<>1) or
       (Equal(OLD.VLR_ST,NEW.VLR_ST)<>1) or
       (Equal(OLD.VLRICM,NEW.VLRICM)<>1) or
       (Equal(OLD.SITMOV,NEW.SITMOV)<>1) or
       (Equal(OLD.CODMUL,NEW.CODMUL)<>1) or
       (Equal(OLD.COM_DATOPE,NEW.COM_DATOPE)<>1) then
      bCalculaCusto:=true;
    END IF;
  END IF;
  IF bCalculaCusto THEN
         IF (TG_OP = 'UPDATE') THEN
         inRec.CODFIL := OLD.CODFIL;
         inRec.SEQUEN := OLD.SEQUEN;
         inRec.NUMITE := OLD.NUMITE;
         inRec.COM_DATOPE := OLD.COM_DATOPE;
         inRec.FILMAT := OLD.FILMAT;
         inRec.CODMAT := OLD.CODMAT;
         inRec.CODCOR := OLD.CODCOR;
         inRec.CODTAM := OLD.CODTAM;
         inRec.CODMUL := OLD.CODMUL;
         
           cDUMMY := PC_ICO_AUX_UPDATE(inREC.COM_DATOPE,
                              inREC.CODFIL,
                              inREC.FILMAT,
                              inREC.CODMAT,
                              inREC.CODCOR,
                              inREC.CODTAM,
                              inREC.CODMUL);
                        END IF;
      inRec.CODFIL := NEW.CODFIL;
      inRec.SEQUEN := NEW.SEQUEN;
      inRec.NUMITE := NEW.NUMITE;
      inRec.COM_DATOPE := NEW.COM_DATOPE;
      inRec.FILMAT := NEW.FILMAT;
      inRec.CODMAT := NEW.CODMAT;
      inRec.CODCOR := NEW.CODCOR;
      inRec.CODTAM := NEW.CODTAM;
      inRec.CODMUL := NEW.CODMUL;
      
      
         cDUMMY := PC_ICO_AUX_UPDATE(inREC.COM_DATOPE,
                              inREC.CODFIL,
                              inREC.FILMAT,
                              inREC.CODMAT,
                              inREC.CODCOR,
                              inREC.CODTAM,
                              inREC.CODMUL);
      
         
   -- GES-2019098910 - Tratamento para atualizar o custo da filial de origem da transferncia
   -- para acrescentar os custos de ST
   IF vEH_TRANS = 'T'  THEN
               IF (TG_OP = 'UPDATE') THEN
            inRec.CODFIL := vFILORI;
            inRec.SEQUEN := OLD.SEQUEN;
            inRec.NUMITE := OLD.NUMITE;
            inRec.COM_DATOPE := OLD.COM_DATOPE;
            inRec.FILMAT := OLD.FILMAT;
            inRec.CODMAT := OLD.CODMAT;
            inRec.CODCOR := OLD.CODCOR;
            inRec.CODTAM := OLD.CODTAM;
            inRec.CODMUL := OLD.CODMUL;
            
            cDUMMY := PC_ICO_AUX_UPDATE(inREC.COM_DATOPE,
                                 inREC.CODFIL,
                                 inREC.FILMAT,
                                 inREC.CODMAT,
                                 inREC.CODCOR,
                                 inREC.CODTAM,
                                 inREC.CODMUL);
                                 END IF;
      inRec.CODFIL := vFILORI;
      inRec.SEQUEN := NEW.SEQUEN;
      inRec.NUMITE := NEW.NUMITE;
      inRec.COM_DATOPE := NEW.COM_DATOPE;
      inRec.FILMAT := NEW.FILMAT;
      inRec.CODMAT := NEW.CODMAT;
      inRec.CODCOR := NEW.CODCOR;
      inRec.CODTAM := NEW.CODTAM;
      inRec.CODMUL := NEW.CODMUL;
      
         cDUMMY := PC_ICO_AUX_UPDATE(inREC.COM_DATOPE,
                              inREC.CODFIL,
                              inREC.FILMAT,
                              inREC.CODMAT,
                              inREC.CODCOR,
                              inREC.CODTAM,
                              inREC.CODMUL);
               END IF;
  END IF;

  -- "Default"
  NEW.ATUFRE := CASE WHEN COALESCE(NEW.CUSFRE,0) > 0 THEN 'T' ELSE 'F' END;
  NEW.DUMMY := Null;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4240 --*/
CREATE TRIGGER TGICO2
BEFORE INSERT OR DELETE OR UPDATE ON TT_ICO 
FOR EACH ROW EXECUTE PROCEDURE TGICO2();


/*-- SEQ 4241 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGICO4() CASCADE;

/*-- SEQ 4242 --*/
CREATE OR REPLACE FUNCTION TGICO4() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Atualizar movimento
--
   vlixo                         VARCHAR(1);
   cATUCUS                       TT_ICO.COM_ATUCUS%TYPE;
   cFINNFE                       TT_COM.FINNFE%TYPE;
   vVem_de_CALCUSME              constant VARCHAR(1) := constante('vem_de_calcusmed');   
BEGIN
   IF ((TG_OP = 'INSERT')) THEN
     
      IF (NEW.SITMOV <> 'C')
      AND(NEW.LANEST = 'S')
      AND(MovimentaEstoque(NEW.CODFIL,NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,NEW.CODMUL) = 'T') THEN
         --Pedro E. Braga - 98995
         --Busca finalidade da entrada
         SELECT COALESCE(COM.FINNFE,'0')
           INTO cFINNFE
           FROM TT_COM COM
          WHERE COM.CODFIL = NEW.CODFIL
            AND COM.SEQUEN = NEW.SEQUEN;
         --Quando finalidade for Nota Complementar deve passar para TGR_ICO_Atualiza_Movimento - pATUCUS=F para no atualizar o ID da ultima compra assim atualiza apenas o Valor acumulado de custo
         IF (cFINNFE = '2') THEN
            cATUCUS := 'F';
         ELSE
            cATUCUS := NEW.COM_ATUCUS;
         END IF;
         vlixo := TGR_ICO_Atualiza_Movimento(NEW.QTDMOV,NEW.VLRMOV,NEW.CODFIL,NEW.SEQUEN,NEW.NUMITE,NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,
                                             NEW.CODTAM,NEW.CODMUL,NEW.COM_DATOPE,cATUCUS,NEW.CUSFRE);
      ELSE
         --DN - DES-96 - Criar a TR_MOV para calculo de Custo mdio sem movimentao de estoque
         vlixo := TGR_ICO_Atualiza_Movimento(0,0,NEW.CODFIL,NEW.SEQUEN,NEW.NUMITE,NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,
                                             NEW.CODTAM,NEW.CODMUL,NEW.COM_DATOPE,cATUCUS,NEW.CUSFRE);
      END IF;
   END IF;

   IF ((TG_OP = 'UPDATE')) THEN
      IF (NEW.CUSFRE > 0) AND Equal(OLD.CUSFRE,NEW.CUSFRE) <> 1 THEN -- AND (vVem_de_CALCUSME <> NEW.DUMMY)
         UPDATE TR_MOV
            SET FILFRE = NEW.CODFIL,
                SEQFRE = NEW.SEQUEN,
                NUMFRE = NEW.NUMITE
          WHERE FILMAT = NEW.FILMAT
            AND CODMAT = NEW.CODMAT
            AND CODCOR = NEW.CODCOR
            AND CODTAM = NEW.CODTAM
            AND DATMOV = TRUNC(NEW.COM_DATOPE);
      END IF; 
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4243 --*/
CREATE TRIGGER TGICO4
AFTER INSERT OR UPDATE ON TT_ICO 
FOR EACH ROW EXECUTE PROCEDURE TGICO4();

/*-- SEQ 4244 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGICO5() CASCADE;

/*-- SEQ 4245 --*/
CREATE OR REPLACE FUNCTION TGICO5() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo
-- 1) Registrar mudanca dos dados num "log" na TL_COM

   cLOG                          VARCHAR(4000)     := '';
   cLogChave                     CHAR(20)           := '';
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   cOld                          VARCHAR(20);
   cNew                          VARCHAR(20);
   cFILUSU                       VARCHAR(3);
   cCODUSU                       VARCHAR(3);
      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
      WK_CODUID                     TT_UID.CODUID%TYPE;
BEGIN
   WK_CODUID := GetCoduidAtual();

   select * into QuemLogou from DadosLogon();
   cFILUSU := QuemLogou.FILUSU;
   cCODUSU := QuemLogou.CODUSU;

   IF Equal(OLD.LANEST,NEW.LANEST) <> 1 THEN
      cLOG := cLOG||'Situao no Estoque: de '||COALESCE(DescricaoDominio('ICO','LANEST',OLD.LANEST),cNulo)||' para '||COALESCE(DescricaoDominio('ICO','LANEST',NEW.LANEST),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.SITMOV,NEW.SITMOV) <> 1 THEN
      cLOG := cLOG||'Situao: de '||COALESCE(DescricaoDominio('ICO','SITMOV',OLD.SITMOV),cNulo)||' para '||COALESCE(DescricaoDominio('ICO','SITMOV',NEW.SITMOV),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.TIPPRO,NEW.TIPPRO) <> 1 THEN
      cLOG := cLOG||'Tipo de produto: de '||COALESCE(DescricaoDominio('ICO','TIPPRO',OLD.TIPPRO),cNulo)||' para '||COALESCE(DescricaoDominio('ICO','TIPPRO',NEW.TIPPRO),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.FILMAT,NEW.FILMAT) <> 1 THEN
      cLOG := cLOG||'Filial do Produto: de '||COALESCE(OLD.FILMAT,cNulo)||' para '||COALESCE(NEW.FILMAT,cNulo)||CRLF;
   END IF;
   IF Equal(OLD.CODMAT,NEW.CODMAT) <> 1 THEN
      cLOG := cLOG||'Cdigo do Produto: de '||COALESCE(OLD.CODMAT,cNulo)||' para '||COALESCE(NEW.CODMAT,cNulo)||CRLF;
   END IF;
   IF Equal(OLD.CODCOR,NEW.CODCOR) <> 1 THEN
      cLOG := cLOG||'Cdigo da Diviso: de '||COALESCE(OLD.CODCOR,iNulo)||' para '||COALESCE(NEW.CODCOR,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.CODTAM,NEW.CODTAM) <> 1 THEN
      cLOG := cLOG||'Cdigo da Sub-Diviso: de '||COALESCE(OLD.CODTAM,iNulo)||' para '||COALESCE(NEW.CODTAM,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.COM_DATOPE,NEW.COM_DATOPE) <> 1 THEN
      cLOG := cLOG||'Data de Operao da Compra: de '||COALESCE(TO_CHAR(OLD.COM_DATOPE,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.COM_DATOPE,'DD/MM/YYYY'),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.QTDMOV,NEW.QTDMOV) <> 1 THEN
      cLOG := cLOG||'Quantidade: de '||COALESCE(OLD.QTDMOV,iNulo)||' para '||COALESCE(NEW.QTDMOV,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRMOV,NEW.VLRMOV) <> 1 THEN
      cLOG := cLOG||'Valor total: de '||COALESCE(OLD.VLRMOV,iNulo)||' para '||COALESCE(NEW.VLRMOV,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.CODMOE,NEW.CODMOE) <> 1 THEN
      cLOG := cLOG||'Moeda do preo de venda: de '||COALESCE(OLD.CODMOE,iNulo)||' para '||COALESCE(NEW.CODMOE,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.UNICOM,NEW.UNICOM) <> 1 THEN
      cLOG := cLOG||'Unidade de Compras: de '||COALESCE(OLD.UNICOM,iNulo)||' para '||COALESCE(NEW.UNICOM,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.UNIVEN,NEW.UNIVEN) <> 1 THEN
      cLOG := cLOG||'Unidade de Vendas: de '||COALESCE(OLD.UNIVEN,iNulo)||' para '||COALESCE(NEW.UNIVEN,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.VALCON,NEW.VALCON) <> 1 THEN
      cLOG := cLOG||'Valor de converso entre as unidades de Venda/Compra: de '||COALESCE(OLD.VALCON,iNulo)||' para '||COALESCE(NEW.VALCON,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.QTDCOM,NEW.QTDCOM) <> 1 THEN
      cLOG := cLOG||'Quantidade: de '||COALESCE(OLD.QTDCOM,iNulo)||' para '||COALESCE(NEW.QTDCOM,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.DATANT,NEW.DATANT) <> 1 THEN
      cLOG := cLOG||'Data do ltimo Custo: de '||COALESCE(TO_CHAR(OLD.DATANT,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATANT,'DD/MM/YYYY'),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.CUSANT,NEW.CUSANT) <> 1 THEN
      cLOG := cLOG||'Custo Anterior: de '||COALESCE(OLD.CUSANT,iNulo)||' para '||COALESCE(NEW.CUSANT,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.CUSREP,NEW.CUSREP) <> 1 THEN
      cLOG := cLOG||'Custo de reposio atual: de '||COALESCE(OLD.CUSREP,iNulo)||' para '||COALESCE(NEW.CUSREP,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.ICMITE,NEW.ICMITE) <> 1 THEN
      cLOG := cLOG||'% ICMS: de '||COALESCE(OLD.ICMITE,iNulo)||' para '||COALESCE(NEW.ICMITE,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.IPIITE,NEW.IPIITE) <> 1 THEN
      cLOG := cLOG||'% de IPI: de '||COALESCE(OLD.IPIITE,iNulo)||' para '||COALESCE(NEW.IPIITE,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.PERLUC,NEW.PERLUC) <> 1 THEN
      cLOG := cLOG||'Percentual de lucro cadastrado no produto: de '||COALESCE(OLD.PERLUC,iNulo)||' para '||COALESCE(NEW.PERLUC,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.PREANT,NEW.PREANT) <> 1 THEN
      cLOG := cLOG||'Preo de venda antes da compra: de '||COALESCE(OLD.PREANT,iNulo)||' para '||COALESCE(NEW.PREANT,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.PREATU,NEW.PREATU) <> 1 THEN
      cLOG := cLOG||'Preo Atual de Venda: de '||COALESCE(OLD.PREATU,iNulo)||' para '||COALESCE(NEW.PREATU,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRCAL,NEW.VLRCAL) <> 1 THEN
      cLOG := cLOG||'Valor da diferena de preos: de '||COALESCE(OLD.VLRCAL,iNulo)||' para '||COALESCE(NEW.VLRCAL,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.EMBORI,NEW.EMBORI) <> 1 THEN
      cLOG := cLOG||'Embalagem Original: de '||COALESCE(OLD.EMBORI,iNulo)||' para '||COALESCE(NEW.EMBORI,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.EMBQTD,NEW.EMBQTD) <> 1 THEN
      cLOG := cLOG||'Quantidade Original Embalagem: de '||COALESCE(OLD.EMBQTD,iNulo)||' para '||COALESCE(NEW.EMBQTD,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.CODBUS,NEW.CODBUS) <> 1 THEN
      cLOG := cLOG||'Cdigo de Busca: de '||COALESCE(OLD.CODBUS,cNulo)||' para '||COALESCE(NEW.CODBUS,cNulo)||CRLF;
   END IF;
   IF Equal(OLD.CODMUL,NEW.CODMUL) <> 1 THEN
      cLOG := cLOG||'Sub-Estoque: de '||COALESCE(OLD.CODMUL,iNulo)||' para '||COALESCE(NEW.CODMUL,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.CUSFRE,NEW.CUSFRE) <> 1 THEN
      cLOG := cLOG||'Custo do Frete: de '||COALESCE(OLD.CUSFRE,iNulo)||' para '||COALESCE(NEW.CUSFRE,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.ORD_CM,NEW.ORD_CM) <> 1 THEN
      cLOG := cLOG||'Ordem Custo Mdio: de '||COALESCE(OLD.ORD_CM,iNulo)||' para '||COALESCE(NEW.ORD_CM,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.QTD_CM,NEW.QTD_CM) <> 1 THEN
      cLOG := cLOG||'Quantidade Custo Mdio: de '||COALESCE(OLD.QTD_CM,iNulo)||' para '||COALESCE(NEW.QTD_CM,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLR_CM,NEW.VLR_CM) <> 1 THEN
      cLOG := cLOG||'Valor Custo Mdio: de '||COALESCE(OLD.VLR_CM,iNulo)||' para '||COALESCE(NEW.VLR_CM,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.CODCFO,NEW.CODCFO) <> 1 THEN
      cOld := NULL;
      cNew := NULL;
      IF OLD.CODCFO IS NOT NULL THEN
        SELECT DCFO.CODCFO INTO cOld FROM TD_CFO DCFO WHERE DCFO.CODTAB = OLD.CODCFO;
      END IF;
      IF NEW.CODCFO IS NOT NULL THEN
        SELECT DCFO.CODCFO INTO cNew FROM TD_CFO DCFO WHERE DCFO.CODTAB = NEW.CODCFO;
      END IF;
      cLOG := cLOG||'CFOP: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
   END IF;
   IF Equal(OLD.BASICM,NEW.BASICM) <> 1 THEN
      cLOG := cLOG||'Base Clculo ICMS: de '||COALESCE(OLD.BASICM,iNulo)||' para '||COALESCE(NEW.BASICM,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRICM,NEW.VLRICM) <> 1 THEN
      cLOG := cLOG||'Valor ICMS: de '||COALESCE(OLD.VLRICM,iNulo)||' para '||COALESCE(NEW.VLRICM,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.OUTICM,NEW.OUTICM) <> 1 THEN
      cLOG := cLOG||'Outros ICMS: de '||COALESCE(OLD.OUTICM,iNulo)||' para '||COALESCE(NEW.OUTICM,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.ISEICM,NEW.ISEICM) <> 1 THEN
      cLOG := cLOG||'Iseno ICMS: de '||COALESCE(OLD.ISEICM,iNulo)||' para '||COALESCE(NEW.ISEICM,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRCMG,NEW.VLRCMG) <> 1 THEN
      cLOG := cLOG||'Vlr.C.MdioGerencial: de '||COALESCE(OLD.VLRCMG,iNulo)||' para '||COALESCE(NEW.VLRCMG,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.FREFIS,NEW.FREFIS) <> 1 THEN
      cLOG := cLOG||'Vlr.Frete Fiscal: de '||COALESCE(OLD.FREFIS,iNulo)||' para '||COALESCE(NEW.FREFIS,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.DATINC,NEW.DATINC) <> 1 THEN
      cLOG := cLOG||'Data Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.ATU_EM,NEW.ATU_EM) <> 1 THEN
      cLOG := cLOG||'Data Atualizao: de '||COALESCE(TO_CHAR(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.TOT_CM,NEW.TOT_CM) <> 1 THEN
      cLOG := cLOG||'Valor Total do Custo Mdio Fiscal: de '||COALESCE(OLD.TOT_CM,iNulo)||' para '||COALESCE(NEW.TOT_CM,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.TOTCMG,NEW.TOTCMG) <> 1 THEN
      cLOG := cLOG||'Valor Total do Custo Mdio Gerencial: de '||COALESCE(OLD.TOTCMG,iNulo)||' para '||COALESCE(NEW.TOTCMG,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.SAL_CM,NEW.SAL_CM) <> 1 THEN
      cLOG := cLOG||'Saldo Custo Mdio: de '||COALESCE(OLD.SAL_CM,iNulo)||' para '||COALESCE(NEW.SAL_CM,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.EXPORT,NEW.EXPORT) <> 1 THEN
      cLOG := cLOG||'Exportado?: de '||COALESCE(OLD.EXPORT,cNulo)||' para '||COALESCE(NEW.EXPORT,cNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRIPI,NEW.VLRIPI) <> 1 THEN
      cLOG := cLOG||'Valor do IPI: de '||COALESCE(OLD.VLRIPI,iNulo)||' para '||COALESCE(NEW.VLRIPI,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.COM_ATUCUS,NEW.COM_ATUCUS) <> 1 THEN
      cLOG := cLOG||'Atualiza Custo Gerencial?: de '||COALESCE(OLD.COM_ATUCUS,cNulo)||' para '||COALESCE(NEW.COM_ATUCUS,cNulo)||CRLF;
   END IF;
   IF Equal(OLD.COM_TIPCCM,NEW.COM_TIPCCM) <> 1 THEN
      cLOG := cLOG||'Tipo de Custo Mdio: de '||COALESCE(DescricaoDominio('ICO','COM_TIPCCM',OLD.COM_TIPCCM),cNulo)||' para '||COALESCE(DescricaoDominio('ICO','COM_TIPCCM',NEW.COM_TIPCCM),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.ATUFRE,NEW.ATUFRE) <> 1 THEN
      cLOG := cLOG||'Atualiza Frete?: de '||COALESCE(OLD.ATUFRE,cNulo)||' para '||COALESCE(NEW.ATUFRE,cNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRDES,NEW.VLRDES) <> 1 THEN
      cLOG := cLOG||'Valor Desconto: de '||COALESCE(OLD.VLRDES,iNulo)||' para '||COALESCE(NEW.VLRDES,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRITE,NEW.VLRITE) <> 1 THEN
      cLOG := cLOG||'Valor Total: de '||COALESCE(OLD.VLRITE,iNulo)||' para '||COALESCE(NEW.VLRITE,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.ICMTIP,NEW.ICMTIP) <> 1 THEN
      cLOG := cLOG||'Tipo de Tributao do Produto: de '||COALESCE(DescricaoDominio('ICO','ICMTIP',OLD.ICMTIP),cNulo)||' para '||COALESCE(DescricaoDominio('ICO','ICMTIP',NEW.ICMTIP),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.REDITE,NEW.REDITE) <> 1 THEN
      cLOG := cLOG||'Base reduzida ICMS: de '||COALESCE(OLD.REDITE,iNulo)||' para '||COALESCE(NEW.REDITE,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.IPIFRE,NEW.IPIFRE) <> 1 THEN
      cLOG := cLOG||'Valor IPI do Frete: de '||COALESCE(OLD.IPIFRE,iNulo)||' para '||COALESCE(NEW.IPIFRE,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.MVACOM,NEW.MVACOM) <> 1 THEN
      cLOG := cLOG||'% MVA para compra: de '||COALESCE(OLD.MVACOM,iNulo)||' para '||COALESCE(NEW.MVACOM,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.RETSUB,NEW.RETSUB) <> 1 THEN
      cLOG := cLOG||'Retm ICMS na Fonte por Substituio Tributria?: de '||COALESCE(OLD.RETSUB,cNulo)||' para '||COALESCE(NEW.RETSUB,cNulo)||CRLF;
   END IF;
   IF Equal(OLD.ICO_BASRET,NEW.ICO_BASRET) <> 1 THEN
      cLOG := cLOG||'Rateio da Base da Reteno de Substituio Tributria na Fonte: de '||COALESCE(OLD.ICO_BASRET,iNulo)||' para '||COALESCE(NEW.ICO_BASRET,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.ICO_VLRRET,NEW.ICO_VLRRET) <> 1 THEN
      cLOG := cLOG||'Rateio de Outras Taxas: de '||COALESCE(OLD.ICO_VLRRET,iNulo)||' para '||COALESCE(NEW.ICO_VLRRET,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.ICO_VLRFRE,NEW.ICO_VLRFRE) <> 1 THEN
      cLOG := cLOG||'Rateio do Frete: de '||COALESCE(OLD.ICO_VLRFRE,iNulo)||' para '||COALESCE(NEW.ICO_VLRFRE,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.ICO_OUTTAX,NEW.ICO_OUTTAX) <> 1 THEN
      cLOG := cLOG||'Rateio da Reteno de Substituio Tributria na Fonte: de '||COALESCE(OLD.ICO_OUTTAX,iNulo)||' para '||COALESCE(NEW.ICO_OUTTAX,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.SITIPI,NEW.SITIPI) <> 1 THEN
      cLOG := cLOG||'Situao Tributria do IPI: de '||COALESCE(OLD.SITIPI,cNulo)||' para '||COALESCE(NEW.SITIPI,cNulo)||CRLF;
   END IF;
   IF Equal(OLD.BASIPI,NEW.BASIPI) <> 1 THEN
      cLOG := cLOG||'Base de Clculo do IPI: de '||COALESCE(OLD.BASIPI,iNulo)||' para '||COALESCE(NEW.BASIPI,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.BSTFRE,NEW.BSTFRE) <> 1 THEN
      cLOG := cLOG||'Base de Substituio do Conhecimento de Frete: de '||COALESCE(OLD.BSTFRE,iNulo)||' para '||COALESCE(NEW.BSTFRE,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.ST_FRE,NEW.ST_FRE) <> 1 THEN
      cLOG := cLOG||'Valor de Substituio do Conhecimento de Frete: de '||COALESCE(OLD.ST_FRE,iNulo)||' para '||COALESCE(NEW.ST_FRE,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.BASSUB,NEW.BASSUB) <> 1 THEN
      cLOG := cLOG||'Base de Substituio: de '||COALESCE(OLD.BASSUB,iNulo)||' para '||COALESCE(NEW.BASSUB,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLR_ST,NEW.VLR_ST) <> 1 THEN
      cLOG := cLOG||'Valor de Substituio: de '||COALESCE(OLD.VLR_ST,iNulo)||' para '||COALESCE(NEW.VLR_ST,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.CODCST,NEW.CODCST) <> 1 THEN
      cLOG := cLOG||'CST ICMS: de '||COALESCE(DescricaoDominio('ICO','CODCST',OLD.CODCST),cNulo)||' para '||COALESCE(DescricaoDominio('ICO','CODCST',NEW.CODCST),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.CODORI,NEW.CODORI) <> 1 THEN
      cLOG := cLOG||'Origem: de '||COALESCE(DescricaoDominio('ICO','CODORI',TO_CHAR(OLD.CODORI)),cNulo)||' para '||COALESCE(DescricaoDominio('ICO','CODORI',TO_CHAR(NEW.CODORI)),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRPIS,NEW.VLRPIS) <> 1 THEN
      cLOG := cLOG||'Valor de PIS: de '||COALESCE(OLD.VLRPIS,iNulo)||' para '||COALESCE(NEW.VLRPIS,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRCOF,NEW.VLRCOF) <> 1 THEN
      cLOG := cLOG||'Valor de COFINS: de '||COALESCE(OLD.VLRCOF,iNulo)||' para '||COALESCE(NEW.VLRCOF,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.SITPIS,NEW.SITPIS) <> 1 THEN
      cLOG := cLOG||'CST PIS: de '||COALESCE(DescricaoDominio('ICO','SITPIS',OLD.SITPIS),cNulo)||' para '||COALESCE(DescricaoDominio('ICO','SITPIS',NEW.SITPIS),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.SITCOF,NEW.SITCOF) <> 1 THEN
      cLOG := cLOG||'CST Cofins: de '||COALESCE(DescricaoDominio('ICO','SITCOF',OLD.SITCOF),cNulo)||' para '||COALESCE(DescricaoDominio('ICO','SITCOF',NEW.SITCOF),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.PERCOF,NEW.PERCOF) <> 1 THEN
      cLOG := cLOG||'Percentual Cofins: de '||COALESCE(OLD.PERCOF,iNulo)||' para '||COALESCE(NEW.PERCOF,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.BASCOF,NEW.BASCOF) <> 1 THEN
      cLOG := cLOG||'Base Cofins: de '||COALESCE(OLD.BASCOF,iNulo)||' para '||COALESCE(NEW.BASCOF,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.PERPIS,NEW.PERPIS) <> 1 THEN
      cLOG := cLOG||'Percentual PIS: de '||COALESCE(OLD.PERPIS,iNulo)||' para '||COALESCE(NEW.PERPIS,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.BASPIS,NEW.BASPIS) <> 1 THEN
      cLOG := cLOG||'Base PIS: de '||COALESCE(OLD.BASPIS,iNulo)||' para '||COALESCE(NEW.BASPIS,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.ICMVEN,NEW.ICMVEN) <> 1 THEN
      cLOG := cLOG||'ICMS Interno para ST: de '||COALESCE(OLD.ICMVEN,iNulo)||' para '||COALESCE(NEW.ICMVEN,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.RED_ST,NEW.RED_ST) <> 1 THEN
      cLOG := cLOG||'Reduo de Base de ST: de '||COALESCE(OLD.RED_ST,iNulo)||' para '||COALESCE(NEW.RED_ST,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.MVACOMDIF,NEW.MVACOMDIF) <> 1 THEN
      cLOG := cLOG||'% de MVA Diferenciado: de '||COALESCE(OLD.MVACOMDIF,iNulo)||' para '||COALESCE(NEW.MVACOMDIF,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.ICMVENDIF,NEW.ICMVENDIF) <> 1 THEN
      cLOG := cLOG||'% do ICMS para Venda Diferenciado: de '||COALESCE(OLD.ICMVENDIF,iNulo)||' para '||COALESCE(NEW.ICMVENDIF,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.RED_STDIF,NEW.RED_STDIF) <> 1 THEN
      cLOG := cLOG||'% de Reduo de Base de ST Diferenciado: de '||COALESCE(OLD.RED_STDIF,iNulo)||' para '||COALESCE(NEW.RED_STDIF,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRICMDIF,NEW.VLRICMDIF) <> 1 THEN
      cLOG := cLOG||'Valor do ICMS Diferenciado: de '||COALESCE(OLD.VLRICMDIF,iNulo)||' para '||COALESCE(NEW.VLRICMDIF,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.ICMITEDIF,NEW.ICMITEDIF) <> 1 THEN
      cLOG := cLOG||'% do ICMS Diferenciado: de '||COALESCE(OLD.ICMITEDIF,iNulo)||' para '||COALESCE(NEW.ICMITEDIF,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.BASICMDIF,NEW.BASICMDIF) <> 1 THEN
      cLOG := cLOG||'Base do ICMS Diferenciado: de '||COALESCE(OLD.BASICMDIF,iNulo)||' para '||COALESCE(NEW.BASICMDIF,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.BASSUBDIF,NEW.BASSUBDIF) <> 1 THEN
      cLOG := cLOG||'Base Substituio Diferenciado: de '||COALESCE(OLD.BASSUBDIF,iNulo)||' para '||COALESCE(NEW.BASSUBDIF,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLR_STDIF,NEW.VLR_STDIF) <> 1 THEN
      cLOG := cLOG||'Valor de Substituio Diferenciado: de '||COALESCE(OLD.VLR_STDIF,iNulo)||' para '||COALESCE(NEW.VLR_STDIF,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.REDITEDIF,NEW.REDITEDIF) <> 1 THEN
      cLOG := cLOG||'Reduo de Base de ICMS Diferenciado: de '||COALESCE(OLD.REDITEDIF,iNulo)||' para '||COALESCE(NEW.REDITEDIF,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.ISEICMDIF,NEW.ISEICMDIF) <> 1 THEN
      cLOG := cLOG||'Iseno ICMS Diferenciado: de '||COALESCE(OLD.ISEICMDIF,iNulo)||' para '||COALESCE(NEW.ISEICMDIF,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.OUTICMDIF,NEW.OUTICMDIF) <> 1 THEN
      cLOG := cLOG||'Outros ICMS Diferenciado: de '||COALESCE(OLD.OUTICMDIF,iNulo)||' para '||COALESCE(NEW.OUTICMDIF,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.PAUTAF,NEW.PAUTAF) <> 1 THEN
      cLOG := cLOG||'Pauta Fiscal: de '||COALESCE(OLD.PAUTAF,iNulo)||' para '||COALESCE(NEW.PAUTAF,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.CODCSTDIF,NEW.CODCSTDIF) <> 1 THEN
      cLOG := cLOG||'CST ICMS Dif.: de '||COALESCE(DescricaoDominio('ICO','CODCSTDIF',OLD.CODCSTDIF),cNulo)||' para '||COALESCE(DescricaoDominio('ICO','CODCSTDIF',NEW.CODCSTDIF),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRISS,NEW.VLRISS) <> 1 THEN
      cLOG := cLOG||'Valor de ISS: de '||COALESCE(OLD.VLRISS,iNulo)||' para '||COALESCE(NEW.VLRISS,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.BASISS,NEW.BASISS) <> 1 THEN
      cLOG := cLOG||'Base de ISS: de '||COALESCE(OLD.BASISS,iNulo)||' para '||COALESCE(NEW.BASISS,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.PERISS,NEW.PERISS) <> 1 THEN
      cLOG := cLOG||'Percentual de ISS: de '||COALESCE(OLD.PERISS,iNulo)||' para '||COALESCE(NEW.PERISS,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.NATBCC,NEW.NATBCC) <> 1 THEN
      cLOG := cLOG||'Demo: de '||COALESCE(DescricaoDominio('ICO','NATBCC',OLD.NATBCC),cNulo)||' para '||COALESCE(DescricaoDominio('ICO','NATBCC',NEW.NATBCC),cNulo)||CRLF;
   END IF;
   IF (Equal(OLD.FILLOT,NEW.FILLOT) <> 1 OR
      Equal(OLD.SEQLOT,NEW.SEQLOT) <> 1) THEN
      cLOG := cLOG||'Lote: de '||COALESCE(OLD.FILLOT||'/'||TRIM(OLD.SEQLOT),cNulo)||' para '||COALESCE(NEW.FILLOT||'/'||TRIM(NEW.SEQLOT),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.BASICMAGR,NEW.BASICMAGR) <> 1 THEN
      cLOG := cLOG||'Base de ICMS Agregado: de '||COALESCE(OLD.BASICMAGR,iNulo)||' para '||COALESCE(NEW.BASICMAGR,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.ALIICMAGR,NEW.ALIICMAGR) <> 1 THEN
      cLOG := cLOG||'Alquota de ICMS Agregado: de '||COALESCE(OLD.ALIICMAGR,iNulo)||' para '||COALESCE(NEW.ALIICMAGR,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRICMAGR,NEW.VLRICMAGR) <> 1 THEN
      cLOG := cLOG||'Valor de ICMS Agregado: de '||COALESCE(OLD.VLRICMAGR,iNulo)||' para '||COALESCE(NEW.VLRICMAGR,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.TAXIPICAL,NEW.TAXIPICAL) <> 1 THEN
      cLOG := cLOG||'Taxa de IPI Calculado: de '||COALESCE(OLD.TAXIPICAL,iNulo)||' para '||COALESCE(NEW.TAXIPICAL,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.BASIPICAL,NEW.BASIPICAL) <> 1 THEN
      cLOG := cLOG||'Base do IPI Calculado: de '||COALESCE(OLD.BASIPICAL,iNulo)||' para '||COALESCE(NEW.BASIPICAL,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRIPICAL,NEW.VLRIPICAL) <> 1 THEN
      cLOG := cLOG||'Valor do IPI Calculado: de '||COALESCE(OLD.VLRIPICAL,iNulo)||' para '||COALESCE(NEW.VLRIPICAL,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRFILDES,NEW.VLRFILDES) <> 1 THEN
      cLOG := cLOG||'Preo na Filial de Destino: de '||COALESCE(OLD.VLRFILDES,iNulo)||' para '||COALESCE(NEW.VLRFILDES,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.IPITRA,NEW.IPITRA) <> 1 THEN
      cLOG := cLOG||'Frao do IPI na Transferncia: de '||COALESCE(OLD.IPITRA,iNulo)||' para '||COALESCE(NEW.IPITRA,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.PERCRESN,NEW.PERCRESN) <> 1 THEN
      cLOG := cLOG||'Alquota aplicvel para clculo do crdito de ICMS (Simples Nacional): de '||COALESCE(OLD.PERCRESN,iNulo)||' para '||COALESCE(NEW.PERCRESN,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRCRESN,NEW.VLRCRESN) <> 1 THEN
      cLOG := cLOG||'Valor do crdito de ICMS que pode ser aproveitado pelo destinatrio: de '||COALESCE(OLD.VLRCRESN,iNulo)||' para '||COALESCE(NEW.VLRCRESN,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.CSTXML,NEW.CSTXML) <> 1 THEN
      cLOG := cLOG||'CST ICMS XML: de '||COALESCE(DescricaoDominio('ICO','CSTXML',OLD.CSTXML),cNulo)||' para '||COALESCE(DescricaoDominio('ICO','CSTXML',NEW.CSTXML),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.PERDIF,NEW.PERDIF) <> 1 THEN
      cLOG := cLOG||'% Diferimento de ICMS: de '||COALESCE(OLD.PERDIF,iNulo)||' para '||COALESCE(NEW.PERDIF,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRDIF,NEW.VLRDIF) <> 1 THEN
      cLOG := cLOG||'Valor do ICMS Diferido: de '||COALESCE(OLD.VLRDIF,iNulo)||' para '||COALESCE(NEW.VLRDIF,iNulo)||CRLF;
   END IF;
   IF Equal(OLD.CODFCI,NEW.CODFCI) <> 1 THEN
      cLOG := cLOG||'Cdigo FCI: de '||COALESCE(OLD.CODFCI,cNulo)||' para '||COALESCE(NEW.CODFCI,cNulo)||CRLF;
   END IF;
   IF Equal(OLD.BASFCP,NEW.BASFCP) <> 1 THEN
      cLOG := cLOG||'Valor da Base de Clculo do FCP: de '||COALESCE(TO_CHAR(OLD.BASFCP,'fm999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASFCP,'fm999G999G999G990D00'),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.PERFCP,NEW.PERFCP) <> 1 THEN
      cLOG := cLOG||'Percentual do ICMS relativo ao FCP: de '||COALESCE(TO_CHAR(OLD.PERFCP,'fm90D0099'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERFCP,'fm90D0099'),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRFCP,NEW.VLRFCP) <> 1 THEN
      cLOG := cLOG||'Valor do ICMS relativo ao FCP: de '||COALESCE(TO_CHAR(OLD.VLRFCP,'fm999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRFCP,'fm999G999G999G990D00'),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.BASFCP_ST,NEW.BASFCP_ST) <> 1 THEN
      cLOG := cLOG||'Valor da Base de Clculo do FCP retido por ST: de '||COALESCE(TO_CHAR(OLD.BASFCP_ST,'fm999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASFCP_ST,'fm999G999G999G990D00'),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.PERFCP_ST,NEW.PERFCP_ST) <> 1 THEN
      cLOG := cLOG||'Percentual do FCP retido por ST: de '||COALESCE(TO_CHAR(OLD.PERFCP_ST,'fm90D0099'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERFCP_ST,'fm90D0099'),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRFCP_ST,NEW.VLRFCP_ST) <> 1 THEN
      cLOG := cLOG||'Valor do FCP retido por ST: de '||COALESCE(TO_CHAR(OLD.VLRFCP_ST,'fm999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRFCP_ST,'fm999G999G999G990D00'),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.BASFCP_RET,NEW.BASFCP_RET) <> 1 THEN
      cLOG := cLOG||'Valor da Base de Clculo do FCP retido anteriormente por ST: de '||COALESCE(TO_CHAR(OLD.BASFCP_RET,'fm999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASFCP_RET,'fm999G999G999G990D00'),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.PERFCP_RET,NEW.PERFCP_RET) <> 1 THEN
      cLOG := cLOG||'Percentual do FCP retido anteriormente por ST: de '||COALESCE(TO_CHAR(OLD.PERFCP_RET,'fm90D0099'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERFCP_RET,'fm90D0099'),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRFCP_RET,NEW.VLRFCP_RET) <> 1 THEN
      cLOG := cLOG||'Valor do FCP retido anteriormente por ST: de '||COALESCE(TO_CHAR(OLD.VLRFCP_RET,'fm999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRFCP_RET,'fm999G999G999G990D00'),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.APRBON,NEW.APRBON) <> 1 THEN
      cLOG := cLOG||'Apropriao de Bonificao: de '||COALESCE(TO_CHAR(OLD.APRBON,'fm9G999G999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.APRBON,'fm9G999G999G999G999G990D00'),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRICM_CRE,NEW.VLRICM_CRE) <> 1 THEN
      cLOG := cLOG||'Valor do crdito de ICMS na nota de transferncia: de '||COALESCE(TO_CHAR(OLD.VLRICM_CRE,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRICM_CRE,'fm9G999G999G990D00'),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRICM_EST,NEW.VLRICM_EST) <> 1 THEN
      cLOG := cLOG||'Estorno do crdito de ICMS na nota de transferncia: de '||COALESCE(TO_CHAR(OLD.VLRICM_EST,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRICM_EST,'fm9G999G999G990D00'),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.CODBEN,NEW.CODBEN) <> 1 THEN
      cLOG := cLOG||' Cdigo de Benefcio Fiscal: de '||COALESCE(OLD.CODBEN,cNulo)||' para '||COALESCE(NEW.CODBEN,cNulo)||CRLF;
   END IF;
   IF Equal(OLD.MOTDESON,NEW.MOTDESON) <> 1 THEN
      cLOG := cLOG||'Motivo da desonerao do ICMS: de '||COALESCE(DescricaoDominio('ICO','MOTDESON',TO_CHAR(OLD.MOTDESON)),cNulo)||' para '||COALESCE(DescricaoDominio('ICO','MOTDESON',TO_CHAR(NEW.MOTDESON)),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRDESON,NEW.VLRDESON) <> 1 THEN
      cLOG := cLOG||'Valor do ICMS desonerado: de '||COALESCE(TO_CHAR(OLD.VLRDESON,'fm9G999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRDESON,'fm9G999G999G999G990D00'),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.OUTDES,NEW.OUTDES) <> 1 THEN
      cLOG := cLOG||'Valor da Despesas de Pagamento avulso: de '||COALESCE(TO_CHAR(OLD.OUTDES,'fm9G999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.OUTDES,'fm9G999G999G999G990D00'),cNulo)||CRLF;
   END IF;
   IF Equal(OLD.BASICM_CM,NEW.BASICM_CM) <> 1 THEN
      cLOG := cLOG||'Base ICMS Custo Mdio: de '||COALESCE(TO_CHAR(OLD.BASICM_CM,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASICM_CM,'fm9G999G999G990D00'), cNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRICM_CM,NEW.VLRICM_CM) <> 1 THEN
      cLOG := cLOG||'Valor de ICMS Custo Mdio: de '||COALESCE(TO_CHAR(OLD.VLRICM_CM,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRICM_CM,'fm9G999G999G990D00'), cNulo)||CRLF;
   END IF;
   IF Equal(OLD.BAS_ST_CM,NEW.BAS_ST_CM) <> 1 THEN
      cLOG := cLOG||'Base ST Custo Mdio: de '||COALESCE(TO_CHAR(OLD.BAS_ST_CM,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.BAS_ST_CM,'fm9G999G999G990D00'), cNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLR_ST_CM,NEW.VLR_ST_CM) <> 1 THEN
      cLOG := cLOG||'Valor ST Custo Mdio: de '||COALESCE(TO_CHAR(OLD.VLR_ST_CM,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLR_ST_CM,'fm9G999G999G990D00'), cNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLR_CMORI,NEW.VLR_CMORI) <> 1 THEN
      cLOG := cLOG||'Valor Custo Mdio Original: de '||COALESCE(TO_CHAR(OLD.VLR_CMORI,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLR_CMORI,'fm9G999G999G990D00'), cNulo)||CRLF;
   END IF;
   IF Equal(OLD.VLRCMGORI,NEW.VLRCMGORI) <> 1 THEN
      cLOG := cLOG||'Valor Custo Mdio Geral Original: de '||COALESCE(TO_CHAR(OLD.VLRCMGORI,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRCMGORI,'fm9G999G999G990D00'), cNulo)||CRLF;
   END IF;
   IF Equal(OLD.TOT_CMORI,NEW.TOT_CMORI) <> 1 THEN
      cLOG := cLOG||'Total Custo Mdio Original: de '||COALESCE(TO_CHAR(OLD.TOT_CMORI,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.TOT_CMORI,'fm9G999G999G990D00'), cNulo)||CRLF;
   END IF;
   IF Equal(OLD.TOTCMGORI,NEW.TOTCMGORI) <> 1 THEN
      cLOG := cLOG||'Total Custo Mdio Geral Original: de '||COALESCE(TO_CHAR(OLD.TOTCMGORI,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.TOTCMGORI,'fm9G999G999G990D00'), cNulo)||CRLF;
   END IF;
   IF Equal(OLD.SAL_CMORI,NEW.SAL_CMORI) <> 1 THEN
      cLOG := cLOG||'Saldo Custo Mdio Original: de '||COALESCE(TO_CHAR(OLD.SAL_CMORI,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.SAL_CMORI,'fm9G999G999G990D00'), cNulo)||CRLF;
   END IF;

   IF Equal(OLD.EXPFIS,NEW.EXPFIS) <> 1 THEN
      SELECT CASE OLD.EXPFIS WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                              ELSE cNulo
      END INTO cOld FROM DUAL;
      SELECT CASE NEW.EXPFIS WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                              ELSE cNulo
      END INTO cNew FROM DUAL;
      cLOG := cLOG||'Exportado Fiscal?: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
   END IF;

   IF ISNOTNULL(cLOG) = 'T' THEN
      cLogChave:= OLD.CODFIL||'-'||OLD.SEQUEN||'-'||to_char(OLD.NUMITE);
      cLOG := cLOG||'ITEM >> '||cLogChave||CRLF;
      INSERT INTO TL_COM(CODFIL, SEQUEN, FILUSU, CODUSU, DATOPE, MSGLOG, CODUID)
                 VALUES (NEW.CODFIL, NEW.SEQUEN, cFILUSU, cCODUSU, agora(), cLOG, WK_CODUID);
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4246 --*/
CREATE TRIGGER TGICO5
AFTER UPDATE ON TT_ICO 
FOR EACH ROW EXECUTE PROCEDURE TGICO5();


/*-- SEQ 4247 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGICOM() CASCADE;

/*-- SEQ 4248 --*/
CREATE OR REPLACE FUNCTION TGICOM() RETURNS TRIGGER AS $$
DECLARE
  proximo      Numeric;
BEGIN
  
  IF (TG_OP = 'INSERT') THEN    
     IF COALESCE(NEW.ID_ICOM,0)=0 THEN
        SELECT NEXTVAL('SQICOM')  INTO proximo FROM DUAL;
        NEW.ID_ICOM := proximo;
     END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4249 --*/
CREATE TRIGGER TGICOM
BEFORE INSERT ON TI_COM 
FOR EACH ROW EXECUTE PROCEDURE TGICOM();


/*-- SEQ 4250 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGICOXIRC() CASCADE;

/*-- SEQ 4251 --*/
CREATE OR REPLACE FUNCTION TGICOXIRC() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
    -- Trata dados padroes na inclusao
    IF (TG_OP = 'INSERT') THEN
        IF NEW.SEQUEN IS NULL THEN
        NEW.SEQUEN:=ProximoCodigo('TT_ICOXIRC',NEW.CODFIL);
        END IF;
        -- "default"
        NEW.DATINC := AGORA(); 
    END IF;

    IF (TG_OP = 'UPDATE') THEN
        NEW.ATU_EM := AGORA();
    END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4252 --*/
CREATE TRIGGER TGICOXIRC
BEFORE INSERT OR UPDATE ON TT_ICOXIRC 
FOR EACH ROW EXECUTE PROCEDURE TGICOXIRC();


/*-- SEQ 4253 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGICOXLOT() CASCADE;

/*-- SEQ 4254 --*/
CREATE OR REPLACE FUNCTION TGICOXLOT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impede excluso.
-- 2. Gerar um cdigo sequencial exclusivo para compor a chave primria.
-- 3. Atualiza controles de data.
-- 4. Atualiza saldo de lotes.

-- Declarao de variveis e cursores
   cComplemento                  CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');
   cDummy                        VARCHAR(1);
   bChaveDevolucaoValida         BOOLEAN;
   nQTDMOV                       TT_ICOXLOT.QTDMOV%TYPE;

-- Principal
BEGIN

   -- Impede excluso.
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20000 Registro no pode ser excludo. %' , cComplemento;
   END IF;

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN := ProximoCodigo('TT_ICOXLOT',NEW.CODFIL);
      END IF;
      NEW.DATINC := Agora();
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

   -- Impede alteraces nas colunas abaixo
   IF (TG_OP = 'UPDATE') THEN
      IF (Equal(OLD.FILLOT,NEW.FILLOT) <> 1) OR
         (Equal(OLD.SEQLOT,NEW.SEQLOT) <> 1) OR
         (Equal(OLD.FILICO,NEW.FILICO) <> 1) OR
         (Equal(OLD.SEQICO,NEW.SEQICO) <> 1) OR
         (Equal(OLD.ITEICO,NEW.ITEICO) <> 1) THEN
         RAISE EXCEPTION 'PG-20012 Um item de compra por lote nao pode ser modificado. %' , cComplemento;
      END IF;

      -- Valida se a FK informada  vlida (tudo preenchido ou tudo vazio)
      bChaveDevolucaoValida := (
                                (ISNOTNULL(TRIM(NEW.FILDEV)) = 'T') AND
                                (ISNOTNULL(TRIM(NEW.SEQDEV)) = 'T') AND
                                (ISNOTNULL(TRIM(NEW.ITEDEV)) = 'T')
                               ) OR
                               (
                                (ISNULL(TRIM(NEW.FILDEV)) = 'T') AND
                                (ISNULL(TRIM(NEW.SEQDEV)) = 'T') AND
                                (ISNULL(TRIM(NEW.ITEDEV)) = 'T')
                               );

       IF NOT bChaveDevolucaoValida THEN
          RAISE EXCEPTION 'PG-20012 Chave da Devoluo informada incorretamente. %' , cComplemento;
       END IF;

      -- Alterou situao
      IF Equal(OLD.SITMOV,NEW.SITMOV) <> 1 THEN
         -- Cancelando item
         IF (OLD.SITMOV = 'N') AND (NEW.SITMOV = 'C') THEN
            nQTDMOV := OLD.QTDMOV*-1;
         ELSE -- Descancelando item
            nQTDMOV := OLD.QTDMOV;
         END IF;
         cDummy := TGR_ICO_Atualiza_Saldo_Lote(nQTDMOV, NEW.CODFIL, 0, NEW.FILLOT, NEW.SEQLOT);
      ELSE
         -- Se mudou a quantidade ou a chave de devoluo
         IF (Equal(OLD.QTDMOV,NEW.QTDMOV) <> 1) OR
            (Equal(OLD.FILDEV,NEW.FILDEV) <> 1) OR
            (Equal(OLD.SEQDEV,NEW.SEQDEV) <> 1) OR
            (Equal(OLD.ITEDEV,NEW.ITEDEV) <> 1) THEN
             -- Estava vazio e foi preenchido
             IF (ISNULL(TRIM(OLD.SEQDEV)) = 'T') AND
                (ISNULL(TRIM(NEW.SEQDEV)) = 'F') THEN
                  -- Diminui o saldo do lote
                 cDummy := TGR_ICO_Atualiza_Saldo_Lote(OLD.QTDMOV*-1, NEW.CODFIL, 0, NEW.FILLOT, NEW.SEQLOT);
             END IF;
             -- Estava preenchido e ficou vazio
             IF (ISNULL(TRIM(OLD.SEQDEV)) = 'F') AND
                (ISNULL(TRIM(NEW.SEQDEV)) = 'T') THEN
                 cDummy := TGR_ICO_Atualiza_Saldo_Lote(NEW.QTDMOV, NEW.CODFIL, 0, NEW.FILLOT, NEW.SEQLOT);
             END IF;
             -- Mudou apenas a quantidade
             IF (ISNULL(TRIM(OLD.SEQDEV)) = 'T') AND
                (ISNULL(TRIM(NEW.SEQDEV)) = 'T') AND
                (Equal(OLD.QTDMOV,NEW.QTDMOV) <> 1) THEN
                 -- Diminui a quantidade anterior e soma a nova
                 cDummy := TGR_ICO_Atualiza_Saldo_Lote(OLD.QTDMOV*-1, NEW.CODFIL, 0, NEW.FILLOT, NEW.SEQLOT);
                 cDummy := TGR_ICO_Atualiza_Saldo_Lote(NEW.QTDMOV, NEW.CODFIL, 0, NEW.FILLOT, NEW.SEQLOT);
             END IF;
         END IF;
      END IF;
   END IF;

   IF (TG_OP = 'INSERT') THEN
      -- Aumenta o saldo do lote
      cDummy := TGR_ICO_Atualiza_Saldo_Lote(NEW.QTDMOV, NEW.CODFIL, 0, NEW.FILLOT, NEW.SEQLOT);
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4255 --*/
CREATE TRIGGER TGICOXLOT
BEFORE INSERT OR UPDATE OR DELETE ON TT_ICOXLOT 
FOR EACH ROW EXECUTE PROCEDURE TGICOXLOT();


/*-- SEQ 4256 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGICP() CASCADE;

/*-- SEQ 4257 --*/
CREATE OR REPLACE FUNCTION TGICP() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Atualiza controles de data.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Marcar data de incluso.
   IF (TG_OP = 'INSERT') THEN
      NEW.DATINC := Agora();
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4258 --*/
CREATE TRIGGER TGICP
BEFORE INSERT OR UPDATE OR DELETE ON TT_ICP 
FOR EACH ROW EXECUTE PROCEDURE TGICP();


/*-- SEQ 4259 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGICP2() CASCADE;

/*-- SEQ 4260 --*/
CREATE OR REPLACE FUNCTION TGICP2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Registrar mudanas dos dados na TT_ICP.

-- Declarao de variveis e cursores
   cLog                          VARCHAR(4000) := '';
   cLogChave                     VARCHAR(30)   := '';
   cFILUSU                       TT_USU.FILUSU%TYPE;
   cCODUSU                       TT_USU.CODUSU%TYPE;
   cNulo                         CONSTANT CHAR(04) := 'Nulo';
   iNulo                         CONSTANT Numeric(01) := 0;
   CRLF                          CONSTANT CHAR(01) := CHR(10);
   nCODUID                       TT_UID.CODUID%TYPE;
      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
   
-- Principal
BEGIN
         SELECT MAX(CODUID)
        INTO nCODUID
        FROM TT_UID
       WHERE SESSION_ID = USERENV('SESSIONID');
   
   select * into QuemLogou from DadosLogon();
   cFILUSU := QuemLogou.FILUSU;
   cCODUSU := QuemLogou.CODUSU;

   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
         cLog := cLog||'Filial: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
         cLog := cLog||'Sequnciador: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NUMITE,NEW.NUMITE) <> 1 THEN
         cLog := cLog||'Nmero do Item: de '||COALESCE(OLD.NUMITE,iNulo)||' para '||COALESCE(NEW.NUMITE,iNulo)||CRLF;
      END IF;
      IF Equal(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS')) <> 1 THEN
         cLog := cLog||'Data Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
      END IF;
      /*IF Equal(TO_CHAR(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),TO_CHAR(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS')) <> 1 THEN
         cLog := cLog||'Data Atualizao: de '||COALESCE(TO_CHAR(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
      END IF;*/
      IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
         cLog := cLog||'Situao: de '||COALESCE(DescricaoDominio('ICP','FLGEST',OLD.FLGEST),cNulo)||' para '||COALESCE(DescricaoDominio('ICP','FLGEST',NEW.FLGEST),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILENT,NEW.FILENT) <> 1 THEN
         cLog := cLog||'Filial de Entrega: de '||COALESCE(OLD.FILENT,cNulo)||' para '||COALESCE(NEW.FILENT,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILMAT,NEW.FILMAT) <> 1 THEN
         cLog := cLog||'Filial do Produto: de '||COALESCE(OLD.FILMAT,cNulo)||' para '||COALESCE(NEW.FILMAT,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODMAT,NEW.CODMAT) <> 1 THEN
         cLog := cLog||'Cdigo do Produto: de '||COALESCE(OLD.CODMAT,cNulo)||' para '||COALESCE(NEW.CODMAT,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCOR,NEW.CODCOR) <> 1 THEN
         cLog := cLog||'Cdigo da Diviso: de '||COALESCE(OLD.CODCOR,iNulo)||' para '||COALESCE(NEW.CODCOR,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODTAM,NEW.CODTAM) <> 1 THEN
         cLog := cLog||'Cdigo da Sub-Diviso: de '||COALESCE(OLD.CODTAM,iNulo)||' para '||COALESCE(NEW.CODTAM,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.QTDITE,NEW.QTDITE) <> 1 THEN
         cLog := cLog||'Quantidade: de '||COALESCE(TO_CHAR(OLD.QTDITE,'fm999G999G999G990D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.QTDITE,'fm999G999G999G990D0000'),cNulo)||CRLF;
      END IF;

      IF ISNOTNULL(TRIM(cLog)) = 'T' THEN
         cLogChave := OLD.CODFIL || '-' || OLD.SEQUEN || '-' || TO_CHAR(OLD.NUMITE);
         cLog := cLog || 'Item >> ' || cLogChave || CRLF;

         INSERT INTO TL_CPF (FILCPF, SEQCPF, DATOPE, FILUSU, CODUSU, MSGLOG, CODUID)
                     VALUES (NEW.CODFIL, NEW.SEQUEN, Agora(), cFILUSU, cCODUSU, cLog, nCODUID);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4261 --*/
CREATE TRIGGER TGICP2
AFTER UPDATE ON TT_ICP 
FOR EACH ROW EXECUTE PROCEDURE TGICP2();


/*-- SEQ 4262 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCIXF() CASCADE;

/*-- SEQ 4263 --*/
CREATE OR REPLACE FUNCTION TGCIXF() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Atualiza controles de data.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Marcar data de incluso.
   IF (TG_OP = 'INSERT') THEN
      NEW.DATINC := Agora();
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4264 --*/
CREATE TRIGGER TGCIXF
BEFORE INSERT OR UPDATE OR DELETE ON TT_ICPXFOR 
FOR EACH ROW EXECUTE PROCEDURE TGCIXF();


/*-- SEQ 4265 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGCIXF2() CASCADE;

/*-- SEQ 4266 --*/
CREATE OR REPLACE FUNCTION TGCIXF2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Registrar mudanas dos dados na TT_ICPXFOR.

-- Declarao de variveis e cursores
   cLog                          VARCHAR(4000) := '';
   cLogChave                     VARCHAR(30)   := '';
   cFILUSU                       TT_USU.FILUSU%TYPE;
   cCODUSU                       TT_USU.CODUSU%TYPE;
   cNulo                         CONSTANT CHAR(04) := 'Nulo';
   iNulo                         CONSTANT Numeric(01) := 0;
   CRLF                          CONSTANT CHAR(01) := CHR(10);
   nCODUID                       TT_UID.CODUID%TYPE;
      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
   
-- Principal
BEGIN
         SELECT MAX(CODUID)
        INTO nCODUID
        FROM TT_UID
       WHERE SESSION_ID = USERENV('SESSIONID');
   
   select * into QuemLogou from DadosLogon();
   cFILUSU := QuemLogou.FILUSU;
   cCODUSU := QuemLogou.CODUSU;

   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
         cLog := cLog||'Filial: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
         cLog := cLog||'Sequnciador: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILFOR,NEW.FILFOR) <> 1 THEN
         cLog := cLog||'Filial Fornecedor: de '||COALESCE(OLD.FILFOR,cNulo)||' para '||COALESCE(NEW.FILFOR,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODFOR,NEW.CODFOR) <> 1 THEN
         cLog := cLog||'Cdigo Fornecedor: de '||COALESCE(OLD.CODFOR,cNulo)||' para '||COALESCE(NEW.CODFOR,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NUMICP,NEW.NUMICP) <> 1 THEN
         cLog := cLog||'Nmero do Item do Produto: de '||COALESCE(OLD.NUMICP,iNulo)||' para '||COALESCE(NEW.NUMICP,iNulo)||CRLF;
      END IF;
      IF Equal(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS')) <> 1 THEN
         cLog := cLog||'Data Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
      END IF;
      /*IF Equal(TO_CHAR(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),TO_CHAR(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS')) <> 1 THEN
         cLog := cLog||'Data Atualizao: de '||COALESCE(TO_CHAR(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
      END IF;*/
      IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
         cLog := cLog||'Situao: de '||COALESCE(DescricaoDominio('CIXF','FLGEST',OLD.FLGEST),cNulo)||' para '||COALESCE(DescricaoDominio('CIXF','FLGEST',NEW.FLGEST),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRUNI,NEW.VLRUNI) <> 1 THEN
         cLog := cLog||'Valor Unitrio: de '||COALESCE(TO_CHAR(OLD.VLRUNI,'fm99G999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRUNI,'fm99G999G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.QTDITE,NEW.QTDITE) <> 1 THEN
         cLog := cLog||'Quantidade: de '||COALESCE(TO_CHAR(OLD.QTDITE,'fm999G999G999G990D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.QTDITE,'fm999G999G999G990D0000'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRITE,NEW.VLRITE) <> 1 THEN
         cLog := cLog||'Valor Total: de '||COALESCE(TO_CHAR(OLD.VLRITE,'fm99G999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRITE,'fm99G999G999G999G990D00'),cNulo)||CRLF;
      END IF;      
      IF Equal(OLD.BASIPI,NEW.BASIPI) <> 1 THEN
         cLog := cLog||'Base de IPI: de '||COALESCE(TO_CHAR(OLD.BASIPI,'fm99G999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASIPI,'fm99G999G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TAXIPI,NEW.TAXIPI) <> 1 THEN
         cLog := cLog||'% IPI: de '||COALESCE(TO_CHAR(OLD.TAXIPI,'fm990D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.TAXIPI,'fm990D0000'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRIPI,NEW.VLRIPI) <> 1 THEN
         cLog := cLog||'Valor IPI: de '||COALESCE(TO_CHAR(OLD.VLRIPI,'fm99G999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRIPI,'fm99G999G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.BASICM,NEW.BASICM) <> 1 THEN
         cLog := cLog||'Base de ICMS: de '||COALESCE(TO_CHAR(OLD.BASICM,'fm99G999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASICM,'fm99G999G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TAXRED,NEW.TAXRED) <> 1 THEN
         cLog := cLog||'% Reduo Base ICMS: de '||COALESCE(TO_CHAR(OLD.TAXRED,'fm990D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.TAXRED,'fm990D0000'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TAXICM,NEW.TAXICM) <> 1 THEN
         cLog := cLog||'% ICMS: de '||COALESCE(TO_CHAR(OLD.VLRITE,'fm990D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRITE,'fm990D0000'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRICM,NEW.VLRICM) <> 1 THEN
         cLog := cLog||'Valor ICMS: de '||COALESCE(TO_CHAR(OLD.VLRICM,'fm99G999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRICM,'fm99G999G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ISEICM,NEW.ISEICM) <> 1 THEN
         cLog := cLog||'Valor ICMS Isento: de '||COALESCE(TO_CHAR(OLD.ISEICM,'fm99G999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ISEICM,'fm99G999G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.BASSTT,NEW.BASSTT) <> 1 THEN
         cLog := cLog||'Base ST: de '||COALESCE(TO_CHAR(OLD.BASSTT,'fm99G999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASSTT,'fm99G999G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.REDSTT,NEW.REDSTT) <> 1 THEN
         cLog := cLog||'% Reduo Base ST: de '||COALESCE(TO_CHAR(OLD.REDSTT,'fm990D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.REDSTT,'fm990D0000'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TAXMVA,NEW.TAXMVA) <> 1 THEN
         cLog := cLog||'% MVA: de '||COALESCE(TO_CHAR(OLD.TAXMVA,'fm990D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.TAXMVA,'fm990D0000'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TAXSTT,NEW.TAXSTT) <> 1 THEN
         cLog := cLog||'% ICMS ST: de '||COALESCE(TO_CHAR(OLD.TAXSTT,'fm990D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.TAXSTT,'fm990D0000'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRSTT,NEW.VLRSTT) <> 1 THEN
         cLog := cLog||'Valor ST: de '||COALESCE(TO_CHAR(OLD.VLRSTT,'fm99G999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRSTT,'fm99G999G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.BASPIS,NEW.BASPIS) <> 1 THEN
         cLog := cLog||'Base PIS: de '||COALESCE(TO_CHAR(OLD.BASPIS,'fm99G999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASPIS,'fm99G999G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TAXPIS,NEW.TAXPIS) <> 1 THEN
         cLog := cLog||'% PIS: de '||COALESCE(TO_CHAR(OLD.TAXPIS,'fm990D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.TAXPIS,'fm990D0000'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRPIS,NEW.VLRPIS) <> 1 THEN
         cLog := cLog||'Valor PIS: de '||COALESCE(TO_CHAR(OLD.VLRPIS,'fm99G999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRPIS,'fm99G999G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.BASCOF,NEW.BASCOF) <> 1 THEN
         cLog := cLog||'Base COFINS: de '||COALESCE(TO_CHAR(OLD.BASCOF,'fm99G999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASCOF,'fm99G999G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TAXCOF,NEW.TAXCOF) <> 1 THEN
         cLog := cLog||'% COFINS: de '||COALESCE(TO_CHAR(OLD.TAXCOF,'fm990D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.TAXCOF,'fm990D0000'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRCOF,NEW.VLRCOF) <> 1 THEN
         cLog := cLog||'Valor COFINS: de '||COALESCE(TO_CHAR(OLD.VLRCOF,'fm99G999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRCOF,'fm99G999G999G999G990D00'),cNulo)||CRLF;
      END IF;

      IF ISNOTNULL(TRIM(cLog)) = 'T' THEN
         cLogChave := OLD.CODFIL || '-' || OLD.SEQUEN || '-' || OLD.FILFOR || '/' || OLD.CODFOR || '-' || TO_CHAR(OLD.NUMICP);
         cLog := cLog || 'Itens do Fornecedor >> ' || cLogChave || CRLF;

         INSERT INTO TL_CPF (FILCPF, SEQCPF, DATOPE, FILUSU, CODUSU, MSGLOG, CODUID)
                     VALUES (NEW.CODFIL, NEW.SEQUEN, Agora(), cFILUSU, cCODUSU, cLog, nCODUID);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4267 --*/
CREATE TRIGGER TGCIXF2
AFTER UPDATE ON TT_ICPXFOR 
FOR EACH ROW EXECUTE PROCEDURE TGCIXF2();


/*-- SEQ 4268 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIDF() CASCADE;

/*-- SEQ 4269 --*/
CREATE OR REPLACE FUNCTION TGIDF() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM
-- 2) Atualiza ATU_EM da TT_ATU de configuração
/*-- ATENÇÃO --*/
--Não se pode utilizar a função Equal enquanto a Base estiver em Manutenção pois o Wizard a cada comando atualiza a TT_IDF 
--assim quando a função for excluida na migração ira gerar erro sendo assim a comparação na IDF deve ser feita diretamente.
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   NEW.ATU_EM := AGORA();
   IF (TG_OP = 'UPDATE') THEN
      IF (OLD.MANUT = 'T') AND (NEW.MANUT = 'F') THEN
         cRetorno := AtualizaData('CONFIGURACAO',Agora());
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4270 --*/
CREATE TRIGGER TGIDF
BEFORE UPDATE OR INSERT ON TT_IDF 
FOR EACH ROW EXECUTE PROCEDURE TGIDF();


/*-- SEQ 4271 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIEAN() CASCADE;

/*-- SEQ 4272 --*/
CREATE OR REPLACE FUNCTION TGIEAN() RETURNS TRIGGER AS $$
DECLARE
  proximo      Numeric;
BEGIN
  
  IF (TG_OP = 'INSERT') THEN    
     IF COALESCE(NEW.ID_IEAN,0)=0 THEN
        SELECT NEXTVAL('SQIEAN')  INTO proximo FROM DUAL;
        NEW.ID_IEAN := proximo;
     END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4273 --*/
CREATE TRIGGER TGIEAN
BEFORE INSERT ON TI_EAN 
FOR EACH ROW EXECUTE PROCEDURE TGIEAN();


/*-- SEQ 4274 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIEN() CASCADE;

/*-- SEQ 4275 --*/
CREATE OR REPLACE FUNCTION TGIEN() RETURNS TRIGGER AS $$
BEGIN
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQIEN IS NULL THEN 
         NEW.SEQIEN := PROXIMOCODIGO('TT_IEN',NEW.CODFIL);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4276 --*/
CREATE TRIGGER TGIEN
BEFORE INSERT ON TT_IEN 
FOR EACH ROW EXECUTE PROCEDURE TGIEN();


/*-- SEQ 4277 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIEX() CASCADE;

/*-- SEQ 4278 --*/
CREATE OR REPLACE FUNCTION TGIEX() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Preencher dados de conciliacao

-- Principal
  QuemLogou TRetQuemLogou%ROWTYPE;
  vComplemento CONSTANT VARCHAR(254):= constante('complemento');
BEGIN
  -- Se esta conciliado grava data de conciliacao
  IF (TG_OP = 'UPDATE') THEN   
    select * into QuemLogou from DadosLogon();
    -- Pega CODFIL e SEQUEN do usuario logado
    IF not QuemLogou.Encontrou THEN
       RAISE EXCEPTION 'PG-20050 Voce nao e um usuario cadastrado no sistema %' , vComplemento;
    END IF;   
    IF OLD.SITCON = 'F' and NEW.SITCON = 'T' THEN
       NEW.DATCON := AGORA();
       NEW.FILCON := QuemLogou.FILUSU;
       NEW.CODCON := QuemLogou.CODUSU;
    END IF;
    IF OLD.SITCON = 'T' and NEW.SITCON = 'F' THEN
       NEW.DATCON := NULL;
       NEW.FILCON := NULL;
       NEW.CODCON := NULL;
    END IF;    
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4279 --*/
CREATE TRIGGER TGIEX
BEFORE UPDATE ON TT_IEX 
FOR EACH ROW EXECUTE PROCEDURE TGIEX();


/*-- SEQ 4280 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIFO() CASCADE;

/*-- SEQ 4281 --*/
CREATE OR REPLACE FUNCTION TGIFO() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Registrar Pendências para Atualizar os Impostos de Fornecedores Calculados 

   -- Pedro E. Braga - 92722
   cRETORNO VARCHAR(4); 
   -- Pedro E. Braga - 93794
   cFPVPRECOSIMULADO TT_CFG.FPV_PRECO_SIMULADO%TYPE;
-- Principal
BEGIN
   --Pedro E. Braga - 93794
   SELECT FPV_PRECO_SIMULADO INTO cFPVPRECOSIMULADO FROM TT_CFG; 
   
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN := ProximoCodigo('TT_IFO',NEW.CODFIL);
      END IF;   
      --Pedro E. Braga - 93794     
      IF (cFPVPRECOSIMULADO = 'T') THEN 
          -- Pedro E. Braga - 92722
          cRETORNO := INSERE_MIFC('IFO',NEW.CODFIL || NEW.SEQUEN);
      END IF;
   END IF;
   
   IF (TG_OP = 'UPDATE') THEN
      --Pedro E. Braga - 93794     
      IF (cFPVPRECOSIMULADO = 'T') THEN   
          -- Pedro E. Braga - 92722
          IF (Equal(OLD.UF_ORI, NEW.UF_ORI) <> 1)
          OR (Equal(OLD.FLGSUB, NEW.FLGSUB) <> 1)      
          OR (Equal(OLD.PERICM_INT_DEST, NEW.PERICM_INT_DEST) <> 1)
          OR (Equal(OLD.PERIPI, NEW.PERIPI) <> 1)
          OR (Equal(OLD.PERICM_INT_ORIG, NEW.PERICM_INT_ORIG) <> 1)
          OR (Equal(OLD.ICMTIP, NEW.ICMTIP) <> 1)
          OR (Equal(OLD.PERMVA, NEW.PERMVA) <> 1)
          OR (Equal(OLD.PERICM_FOR_DEST, NEW.PERICM_FOR_DEST) <> 1)
          OR (Equal(OLD.REDICM, NEW.REDICM) <> 1)
          OR (Equal(OLD.FLGRED_ICM_P_ST, NEW.FLGRED_ICM_P_ST) <> 1)
          OR (Equal(OLD.ORIPRO, NEW.ORIPRO) <> 1) THEN      
            cRETORNO := INSERE_MIFC('IFO',NEW.CODFIL || NEW.SEQUEN);
          END IF;
      END IF;
   END IF;
   
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4282 --*/
CREATE TRIGGER TGIFO
BEFORE INSERT OR UPDATE OR DELETE ON TT_IFO 
FOR EACH ROW EXECUTE PROCEDURE TGIFO();


/*-- SEQ 4283 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIICO() CASCADE;

/*-- SEQ 4284 --*/
CREATE OR REPLACE FUNCTION TGIICO() RETURNS TRIGGER AS $$
DECLARE
  proximo      Numeric;
BEGIN
  
  IF (TG_OP = 'INSERT') THEN    
     IF COALESCE(NEW.ID_IICO,0)=0 THEN
        SELECT NEXTVAL('SQIICO')  INTO proximo FROM DUAL;
        NEW.ID_IICO := proximo;
     END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4285 --*/
CREATE TRIGGER TGIICO
BEFORE INSERT ON TI_ICO 
FOR EACH ROW EXECUTE PROCEDURE TGIICO();


/*-- SEQ 4286 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIIIN() CASCADE;

/*-- SEQ 4287 --*/
CREATE OR REPLACE FUNCTION TGIIIN() RETURNS TRIGGER AS $$
--  ------------------------------------ 
--  Gatilho para tratar dados antes de inserir ou alterar na TI_IIN.
--  - Atualiar DATCRI na inserção;
--  - Validar se um dos campos, GRA_CODEXT ou GRA_REFUNI, está preenchido;
--  ------------------------------------
declare
    vComplemento  CONSTANT VARCHAR(100) := Constante('Complemento');
--  ------------------------------------
begin
  --  Trata dados padroes na inclusao  
  if  (TG_OP = 'INSERT') then
      NEW.DATCRI := Agora();
      NEW.STATUS := 0; -- necessário para não gerar erro de NOT NULL no insert
end if;
  --  Validar se um dos campos, GRA_CODEXT ou GRA_REFUNI, está preenchido
  if  (TG_OP = 'INSERT') or (TG_OP = 'UPDATE') then
      if  NEW.GRA_CODEXT is null
      and NEW.GRA_REFUNI is null then
          RAISE EXCEPTION 'PG-20001 E obrigatorio preencher um dos campos: GRA_CODEXT ou GRA_REFUNI. %' , vComplemento;
      end if;
end if;
--  ------------------------------------
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4288 --*/
CREATE TRIGGER TGIIIN
BEFORE INSERT OR UPDATE ON TI_IIN 
FOR EACH ROW EXECUTE PROCEDURE TGIIIN();


/*-- SEQ 4289 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIIMU() CASCADE;

/*-- SEQ 4290 --*/
CREATE OR REPLACE FUNCTION TGIIMU() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Atualiar DATCRI e STATUS na insero;

   -- Declarao de variveis e cursores
   nProximo                      Numeric(10);
   -- Principal
BEGIN
   --  Trata dados padroes na inclusao
   IF (TG_OP = 'INSERT') THEN
      IF (COALESCE(NEW.ID_IIMU, 0) = 0) THEN
         SELECT NEXTVAL('SQIIMU')  INTO nProximo FROM DUAL;
         NEW.ID_IIMU := nProximo;
      END IF;
      -- necessrio para no gerar erro de NOT NULL no insert
      NEW.DATCRI := Agora();
      NEW.STATUS := 0; 
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4291 --*/
CREATE TRIGGER TGIIMU
BEFORE INSERT ON TI_IMU 
FOR EACH ROW EXECUTE PROCEDURE TGIIMU();


/*-- SEQ 4292 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIIN() CASCADE;

/*-- SEQ 4293 --*/
CREATE OR REPLACE FUNCTION TGIIN() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Evitar mudanca direta no valor original da primeira contagem
-- 2) Identificar a primeira contagem 

   vComplemento  VARCHAR(254);
BEGIN
  vComplemento  := constante('complemento');
  IF (TG_OP = 'UPDATE') THEN    
    -- Evita mudanca direta no valor original da primeira contagem
    IF OLD.CONPRI <> NULL THEN
       IF (Equal(OLD.CONPRI,NEW.CONPRI)=0) THEN
         RAISE EXCEPTION 'PG-20001 Primeira contagem nao pode ser modificada. %' , vComplemento; 
       END IF;
    END IF;
    IF OLD.CONSEG <> NULL THEN
       IF (Equal(OLD.CONSEG,NEW.CONSEG)=0) THEN
         RAISE EXCEPTION 'PG-20001 Segunda contagem nao pode ser modificada. %' , vComplemento; 
       END IF;
    END IF;
    IF OLD.CONTER <> NULL THEN
       IF (Equal(OLD.CONTER,NEW.CONTER)=0) THEN
          RAISE EXCEPTION 'PG-20001 Terceira contagem nao pode ser modificada. %' , vComplemento; 
       END IF;
    END IF;
    IF OLD.CONQUA <> NULL THEN
       IF(Equal(OLD.CONQUA,NEW.CONQUA)=0) THEN
         RAISE EXCEPTION 'PG-20001 Quarta contagem nao pode ser modificada. %' , vComplemento; 
       END IF;    
    END IF;
    
    -- Move ate a quarta vez (efetivamente e a primeira contagem)
    IF (NEW.CONPRI IS NULL AND NEW.CONULT IS NOT NULL) THEN
      NEW.CONPRI := NEW.CONULT;
      NEW.CONULT := NULL;
    ELSIF (NEW.CONSEG IS NULL AND NEW.CONULT IS NOT NULL) THEN
      NEW.CONSEG := NEW.CONULT;
      NEW.CONULT := NULL;
    ELSIF (NEW.CONTER IS NULL AND NEW.CONULT IS NOT NULL) THEN
      NEW.CONTER := NEW.CONULT;
      NEW.CONULT := NULL;
    ELSIF (NEW.CONQUA IS NULL AND NEW.CONULT IS NOT NULL) THEN
      NEW.CONQUA := NEW.CONULT;
      NEW.CONULT := NULL;
    END IF;
    
  END IF;
    
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4294 --*/
CREATE TRIGGER TGIIN
BEFORE UPDATE ON TT_IIN 
FOR EACH ROW EXECUTE PROCEDURE TGIIN();

/*-- SEQ 4295 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIIN2() CASCADE;

/*-- SEQ 4296 --*/
CREATE OR REPLACE FUNCTION TGIIN2() RETURNS TRIGGER AS $$
  -- Objetivo:
DECLARE
  vLOG    VARCHAR(4000)     := '';
  CRLF    CONSTANT CHAR(1)   := CHR(10); 
  cNulo   CONSTANT CHAR(4)   := 'Nulo';
  iNulo   CONSTANT Numeric(1) := 0;  
  vItem   VARCHAR(200)  := '';
  wk_coduid tt_uid.coduid%type;  

  QuemLogou TRetQuemLogou%ROWTYPE;
  
BEGIN
  WK_CODUID := GetCoduidAtual();

  IF (TG_OP = 'UPDATE') THEN  
    IF Equal(OLD.NUMITE,NEW.NUMITE) <> 1 THEN
        vLOG := vLOG||'Número de Itens: de '||COALESCE(OLD.NUMITE,iNulo)||' para '||COALESCE(NEW.NUMITE,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.FILMAT,NEW.FILMAT) <> 1 THEN
        vLOG := vLOG||'Filial Material: de '||COALESCE(TO_CHAR(OLD.FILMAT),cNulo)||' para '||COALESCE(TO_CHAR(NEW.FILMAT),cNulo)||CRLF;
     END IF;
    IF Equal(OLD.CODMAT,NEW.CODMAT) <> 1 THEN
        vLOG := vLOG||'Código interno do produto: de '||COALESCE(TO_CHAR(OLD.CODMAT),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODMAT),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.CODCOR,NEW.CODCOR) <> 1 THEN
        vLOG := vLOG||'Divisão do produto: de '||COALESCE(OLD.CODCOR,iNulo)||' para '||COALESCE(NEW.CODCOR,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.CODTAM,NEW.CODTAM) <> 1 THEN
        vLOG := vLOG||'Sub-Divisão do produto: de '||COALESCE(OLD.CODTAM,iNulo)||' para '||COALESCE(NEW.CODTAM,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.CONPRI,NEW.CONPRI) <> 1 THEN
        vLOG := vLOG||'Primeira Contagem: de '||COALESCE(OLD.CONPRI,iNulo)||' para '||COALESCE(NEW.CONPRI,iNulo)||CRLF;
     END IF;
    IF Equal(OLD.CONULT,NEW.CONULT) <> 1 THEN
        vLOG := vLOG||'Última Contagem: de '||COALESCE(OLD.CONULT,iNulo)||' para '||COALESCE(NEW.CONULT,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.QTDEST,NEW.QTDEST) <> 1 THEN
        vLOG := vLOG||'Quantidade de Estoque: de '||COALESCE(OLD.QTDEST,iNulo)||' para '||COALESCE(NEW.QTDEST,iNulo)||CRLF;
     END IF;
    IF Equal(OLD.CONSEG,NEW.CONSEG) <> 1 THEN
        vLOG := vLOG||'Segunda Contagem: de '||COALESCE(OLD.CONSEG,iNulo)||' para '||COALESCE(NEW.CONSEG,iNulo)||CRLF;
     END IF;
    IF Equal(OLD.CONTER,NEW.CONTER) <> 1 THEN
        vLOG := vLOG||'Terceira Contagem: de '||COALESCE(OLD.CONTER,iNulo)||' para '||COALESCE(NEW.CONTER,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.CONQUA,NEW.CONQUA) <> 1 THEN
        vLOG := vLOG||'Quarta Contagem: de '||COALESCE(OLD.CONQUA,iNulo)||' para '||COALESCE(NEW.CONQUA,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.RESERV,NEW.RESERV) <> 1 THEN
        vLOG := vLOG||'Reserva: de '||COALESCE(OLD.RESERV,iNulo)||' para '||COALESCE(NEW.RESERV,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.CODEXT,NEW.CODEXT) <> 1 THEN
        vLOG := vLOG||'Código Externo: de '||COALESCE(TO_CHAR(OLD.CODEXT),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODEXT),cNulo)||CRLF;
     END IF;
 

     IF ISNOTNULL(vLOG) = 'T' THEN
       vItem:= OLD.CODFIL||'-'||OLD.SEQUEN||'-'||to_char(OLD.NUMITE);       
       vLOG := vLOG||' ITEM >> '||vItem||CRLF;
       select * into QuemLogou from DadosLogon();
       INSERT INTO TL_INV (FILINV, SEQINV, MSGLOG, DATOPE, FILUSU, CODUSU, CODUID)
                     VALUES (NEW.CODFIL,NEW.SEQUEN,vLog,agora(),QuemLogou.FILUSU,QuemLogou.CODUSU,WK_CODUID);       
     END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4297 --*/
CREATE TRIGGER TGIIN2
AFTER INSERT OR UPDATE ON TT_IIN 
FOR EACH ROW EXECUTE PROCEDURE TGIIN2();


/*-- SEQ 4298 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIINV() CASCADE;

/*-- SEQ 4299 --*/
CREATE OR REPLACE FUNCTION TGIINV() RETURNS TRIGGER AS $$
declare
--  ------------------------------------ 
--  Gatilho para tratar dados antes de inserir ou alterar na TI_INV.
--  - Atualiar DATCRI na inserção;
--  ------------------------------------
begin
  --  Trata dados padroes na inclusao  
  if  (TG_OP = 'INSERT') then
      NEW.DATCRI := Agora();
      NEW.STATUS := 0; -- necessário para não gerar erro de NOT NULL no insert
  end if;
--  ------------------------------------ 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4300 --*/
CREATE TRIGGER TGIINV
BEFORE INSERT OR UPDATE ON TI_INV 
FOR EACH ROW EXECUTE PROCEDURE TGIINV();


/*-- SEQ 4301 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIITF() CASCADE;

/*-- SEQ 4302 --*/
CREATE OR REPLACE FUNCTION TGIITF() RETURNS TRIGGER AS $$
DECLARE
  proximo      Numeric;
BEGIN
  
  IF (TG_OP = 'INSERT') THEN    
     IF COALESCE(NEW.ID_ITF,0)=0 THEN
        SELECT NEXTVAL('SQIITF')  INTO proximo FROM DUAL;
        NEW.ID_ITF := proximo;
     END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4303 --*/
CREATE TRIGGER TGIITF
BEFORE INSERT ON TI_ITF 
FOR EACH ROW EXECUTE PROCEDURE TGIITF();


/*-- SEQ 4304 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIITFRO() CASCADE;

/*-- SEQ 4305 --*/
CREATE OR REPLACE FUNCTION TGIITFRO() RETURNS TRIGGER AS $$
DECLARE
  proximo      Numeric;
BEGIN
  
  IF (TG_OP = 'INSERT') THEN    
     IF NEW.ID_ITF IS NULL THEN
        SELECT NEXTVAL('SQIITF')  INTO proximo FROM DUAL;
        NEW.ID_ITF := proximo;
     END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4306 --*/
CREATE TRIGGER TGIITFRO
BEFORE INSERT ON ti_itf_ro 
FOR EACH ROW EXECUTE PROCEDURE TGIITFRO();


/*-- SEQ 4307 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIIVE() CASCADE;

/*-- SEQ 4308 --*/
CREATE OR REPLACE FUNCTION TGIIVE() RETURNS TRIGGER AS $$
DECLARE
  proximo      Numeric;
BEGIN
  
  IF (TG_OP = 'INSERT') THEN    
     IF COALESCE(NEW.ID_IIVE,0)=0 THEN
        SELECT NEXTVAL('SQIIVE')  INTO proximo FROM DUAL;
        NEW.ID_IIVE := proximo;
     END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4309 --*/
CREATE TRIGGER TGIIVE
BEFORE INSERT ON TI_IVE 
FOR EACH ROW EXECUTE PROCEDURE TGIIVE();


/*-- SEQ 4310 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIKIT() CASCADE;

/*-- SEQ 4311 --*/
CREATE OR REPLACE FUNCTION TGIKIT() RETURNS TRIGGER AS $$
DECLARE
  proximo Numeric;
BEGIN
  
  IF (TG_OP = 'INSERT') THEN    
     IF COALESCE(NEW.ID_IKIT,0) = 0 THEN
        SELECT NEXTVAL('SQIKIT')  INTO proximo FROM DUAL;
        NEW.ID_IKIT := proximo;
        NEW.DATCRI  := AGORA();
     END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4312 --*/
CREATE TRIGGER TGIKIT
BEFORE INSERT ON TI_KIT 
FOR EACH ROW EXECUTE PROCEDURE TGIKIT();


/*-- SEQ 4313 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGILI() CASCADE;

/*-- SEQ 4314 --*/
CREATE OR REPLACE FUNCTION TGILI() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN:=ProximoCodigo('TT_ILI',NEW.CODFIL);
    END IF;
  END IF;
 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4315 --*/
CREATE TRIGGER TGILI
BEFORE INSERT OR UPDATE ON TT_ILI 
FOR EACH ROW EXECUTE PROCEDURE TGILI();


/*-- SEQ 4316 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGILM() CASCADE;

/*-- SEQ 4317 --*/
CREATE OR REPLACE FUNCTION TGILM() RETURNS TRIGGER AS $$
DECLARE
  QuemLogou TRetQuemLogou%ROWTYPE;
-- Principal
BEGIN
    -- preenche dados do usurio de registro
  IF (TG_OP = 'INSERT') THEN


    select * into QuemLogou from DadosLogon();
    IF ((NEW.FILEMI IS NULL) AND (NEW.CODEMI IS NULL)) THEN
      NEW.FILEMI := QuemLogou.FILUSU;
      NEW.CODEMI := QuemLogou.CODUSU;
    END IF;
  END IF;

  IF (NEW.DATEMI IS NULL) THEN
    NEW.DATEMI := TRUNC(agora());
  ELSE
    NEW.DATEMI := TRUNC(NEW.DATEMI);
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4318 --*/
CREATE TRIGGER TGILM
BEFORE INSERT OR UPDATE OR DELETE ON TT_ILM 
FOR EACH ROW EXECUTE PROCEDURE TGILM();


/*-- SEQ 4319 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGILOT() CASCADE;

/*-- SEQ 4320 --*/
CREATE OR REPLACE FUNCTION TGILOT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Atualizar Dados-- Principal
BEGIN
   -- Trata dados padroes na incluso
   IF (TG_OP = 'INSERT') THEN
      IF COALESCE(NEW.ID_ILOT,0)=0 THEN
         NEW.ID_ILOT := TO_NUMBER(ProximoCodigo('TI_LOT',NEW.CODFIL));
      END IF;
      NEW.DATCRI := AGORA();
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4321 --*/
CREATE TRIGGER TGILOT
BEFORE INSERT OR UPDATE ON TI_LOT 
FOR EACH ROW EXECUTE PROCEDURE TGILOT();


/*-- SEQ 4322 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIMU() CASCADE;

/*-- SEQ 4323 --*/
CREATE OR REPLACE FUNCTION TGIMU() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo
-- 1) Registrar mudanca dos dados num "log"
-- 2) Impedir alteracao da chave primaria

-- Declarao de variveis e cursores
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');
   cLogChave                     VARCHAR(60)       := '';
   cLOG                          VARCHAR(4000)     := '';
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   cNOMCID                       TT_MUN.NOMCID%TYPE;
   iOld                          Numeric; -- colocar Valor no lugar dos codtab
   iNew                          Numeric;
   cRetorno                      VARCHAR(2);
   cWhere                        TM_ATU.FILTRO%TYPE;

-- Principal
BEGIN
   -- Tratamento de LOG
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN
      SELECT MUN.NOMCID INTO cNOMCID FROM TT_MUN MUN WHERE MUN.CODIGO = NEW.CODCID;
      cLogChave := 'Impostos Municipais de ' || cNOMCID;
   END IF;
   IF (TG_OP = 'INSERT') THEN
      cLOG := 'Incluso - ' || cLogChave;
   ELSIF (TG_OP = 'UPDATE') THEN
      IF (OLD.FILMAT <> NEW.FILMAT) OR
         (OLD.CODMAT <> NEW.CODMAT) OR
         (OLD.CODCID <> NEW.CODCID) THEN
         RAISE EXCEPTION 'PG-20001 Dados dos impostos municipais nao podem mudar de produto.%' , vComplemento;
      END IF;

      IF Equal(OLD.SITTRI,NEW.SITTRI) <> 1 THEN
         cLOG := cLOG||'Cdigo de Tributao do ISSQN: de '||COALESCE(DescricaoDominio('IMU','SITTRI',OLD.SITTRI),cNulo)||' para '||COALESCE(DescricaoDominio('IMU','SITTRI',NEW.SITTRI),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.RESISS,NEW.RESISS) <> 1 THEN
         SELECT MIN(RESISS) INTO iOld FROM TD_ISS WHERE CODTAB = OLD.RESISS;
         SELECT MIN(RESISS) INTO iNew FROM TD_ISS WHERE CODTAB = NEW.RESISS;
         cLOG := cLOG||'Aliquota ISS: de '||COALESCE(iOld,iNulo)||' para '||COALESCE(iNew,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODIBG, NEW.CODIBG) <> 1 THEN
        cLOG := cLOG || 'Cdigo IBGE: de ' || COALESCE(OLD.CODIBG, iNulo) || ' para ' || COALESCE(NEW.CODIBG, iNulo) || CRLF;
      END IF;
      IF Equal(OLD.EXIISS,NEW.EXIISS) <> 1 THEN
         cLOG := cLOG||'Exigibilidade ISS para NFSe: de '||COALESCE(DescricaoDominio('IMU','EXIISS',TO_CHAR(OLD.EXIISS)),cNulo)||' para '||COALESCE(DescricaoDominio('IMU','EXIISS',TO_CHAR(NEW.EXIISS)),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DESRPS,NEW.DESRPS) <> 1 THEN
         cLOG := cLOG||'Dados complementares do RPS: de '||COALESCE(OLD.DESRPS,cNulo)||' para '||COALESCE(NEW.DESRPS,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NATNFS,NEW.NATNFS) <> 1 THEN
         cLOG := cLOG||'Natureza ou Operao da NFSe: de '||COALESCE(DescricaoDominio('IMU','NATNFS',TO_CHAR(OLD.NATNFS)),cNulo)||' para '||COALESCE(DescricaoDominio('IMU','NATNFS',TO_CHAR(NEW.NATNFS)),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TRINFS,NEW.TRINFS) <> 1 THEN
         cLOG := cLOG||'Tipo de Tributao: de '||COALESCE(DescricaoDominio('IMU','TRINFS',TO_CHAR(OLD.TRINFS)),cNulo)||' para '||COALESCE(DescricaoDominio('IMU','TRINFS',TO_CHAR(NEW.TRINFS)),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODSRV,NEW.CODSRV) <> 1 THEN
         cLOG := cLOG||'Cdigo do Servio no Municpio: de '||COALESCE(OLD.CODSRV,cNulo)||' para '||COALESCE(NEW.CODSRV,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DESSRV,NEW.DESSRV) <> 1 THEN
         cLOG := cLOG||'Descrio do Servio no Municpio: de '||COALESCE(OLD.DESSRV,cNulo)||' para '||COALESCE(NEW.DESSRV,cNulo)||CRLF;
      END IF;
      IF (ISNOTNULL(cLOG)='T') THEN
         cLOG := cLogChave || ' >> ' || cLOG;
      END IF;
   END IF;

   --Tratamento para Atualizar Tabela Pai
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      cWhere := 'FILMAT = ' || CHR(39) || NEW.FILMAT  || CHR(39) || ' AND CODMAT = ' || CHR(39) || NEW.CODMAT || CHR(39);
   ELSIF (TG_OP = 'DELETE') THEN
      cWhere := 'FILMAT = ' || CHR(39) || OLD.FILMAT  || CHR(39) || ' AND CODMAT = ' || CHR(39) || OLD.CODMAT || CHR(39);
   END IF;
   cRetorno := INSERE_MATU('TT_IMU', 'TT_PRO', cWhere);

   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN
      IF (ISNOTNULL(cLOG)='T') THEN
         INSERT INTO TL_PRO (FILMAT,CODMAT,DATOPE,MSGLOG)
                     VALUES (NEW.FILMAT,NEW.CODMAT,agora(),cLOG);
      END IF;
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4324 --*/
CREATE TRIGGER TGIMU
AFTER INSERT OR UPDATE OR DELETE ON TT_IMU 
FOR EACH ROW EXECUTE PROCEDURE TGIMU();

/*-- SEQ 4325 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIMU2() CASCADE;

/*-- SEQ 4326 --*/
CREATE OR REPLACE FUNCTION TGIMU2() RETURNS TRIGGER AS $$
DECLARE
   cRet                          VARCHAR(2);

   --LEO 84337
   vCODUID_ATUAL                 VARCHAR(22);
   vBLQ_SEM_UID                  TT_CFG.BLQ_SEM_UID%TYPE;
   vSESSIONID                    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

BEGIN
   IF (TG_OP = 'DELETE') THEN
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_IMU', OLD.FILMAT || OLD.CODMAT, TO_CHAR(OLD.CODCID));
   END IF;
   IF (TG_OP = 'INSERT') THEN
      --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_IMU', NEW.FILMAT || NEW.CODMAT, TO_CHAR(NEW.CODCID));
   END IF;
   IF NOT (TG_OP = 'DELETE') THEN
      NEW.ATU_EM := AGORA();
   END IF;

   IF (TG_OP = 'DELETE') THEN
      -- LEO 84337
      SELECT BLQ_SEM_UID
        INTO vBLQ_SEM_UID
        FROM TT_CFG;
      vCODUID_ATUAL := GetCoduidAtual();
      IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;
   END IF;

   -- Paulo : 83615
   IF (TG_OP = 'INSERT') THEN

      -- LEO 84337
      SELECT BLQ_SEM_UID
        INTO vBLQ_SEM_UID
        FROM TT_CFG;
      vCODUID_ATUAL := GetCoduidAtual();
      IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;

      NEW.CODUID := GetCoduidAtual();
      NEW.ASSINA := COALESCE(AssinaTabela('TT_IMU',
                                             ConcatenaIMU(NEW.FILMAT,
                                                          NEW.CODMAT,
                                                          NEW.CODCID,
                                                          NEW.RESISS),
                                             null, null, null),NEW.ASSINA);
   END IF;

   -- Paulo : 83615
   IF (TG_OP = 'UPDATE') THEN
      IF ConcatenaIMU(NEW.FILMAT,NEW.CODMAT,NEW.CODCID,NEW.RESISS) <>
         ConcatenaIMU(OLD.FILMAT,OLD.CODMAT,OLD.CODCID,OLD.RESISS) THEN

         -- LEO 84337
         SELECT BLQ_SEM_UID
           INTO vBLQ_SEM_UID
           FROM TT_CFG;
         vCODUID_ATUAL := GetCoduidAtual();
         IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;

         NEW.CODUID := GetCoduidAtual();
         NEW.ASSINA := COALESCE(AssinaTabela('TT_IMU',
                                             ConcatenaIMU(NEW.FILMAT,
                                                          NEW.CODMAT,
                                                          NEW.CODCID,
                                                          NEW.RESISS),
                                                       OLD.CODUID,
                                             ConcatenaIMU(OLD.FILMAT,
                                                          OLD.CODMAT,
                                                          OLD.CODCID,
                                                          OLD.RESISS),
                                                      OLD.ASSINA
                                                     ),NEW.ASSINA);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4327 --*/
CREATE TRIGGER TGIMU2
BEFORE INSERT OR UPDATE OR DELETE ON TT_IMU 
FOR EACH ROW EXECUTE PROCEDURE TGIMU2();

/*-- SEQ 4328 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIMU_ASS() CASCADE;

/*-- SEQ 4329 --*/
CREATE OR REPLACE FUNCTION TGIMU_ASS() RETURNS TRIGGER AS $$
-- 83615
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN

   IF ExisteFilialNaUF('SC') THEN
      IF (TG_OP = 'INSERT') THEN
         UPDATE TT_ASS
            SET QTDREG = QTDREG + 1
          WHERE NOMTAB = 'TT_IMU';
      END IF;
      
      IF (TG_OP = 'DELETE') THEN
         UPDATE TT_ASS
            SET QTDREG = QTDREG - 1
          WHERE NOMTAB = 'TT_IMU';
      END IF;
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4330 --*/
CREATE TRIGGER TGIMU_ASS
AFTER INSERT OR DELETE ON TT_IMU 
FOR EACH ROW EXECUTE PROCEDURE TGIMU_ASS();


/*-- SEQ 4331 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGINB() CASCADE;

/*-- SEQ 4332 --*/
CREATE OR REPLACE FUNCTION TGINB() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria.
BEGIN  
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    IF ISNULL(NEW.SEQUEN)='T' THEN
      NEW.SEQUEN:=ProximoCodigo('TT_INB',NEW.CODFIL);	  
    END IF;   
  END IF;
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4333 --*/
CREATE TRIGGER TGINB
BEFORE INSERT ON TT_INB 
FOR EACH ROW EXECUTE PROCEDURE TGINB();


/*-- SEQ 4334 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGINT() CASCADE;

/*-- SEQ 4335 --*/
CREATE OR REPLACE FUNCTION TGINT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
BEGIN
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    IF ISNULL(NEW.SEQUEN)='T' THEN
      NEW.SEQUEN:=ProximoCodigo('TT_INT',NEW.CODFIL);
    END IF;   
  END IF;
    
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4336 --*/
CREATE TRIGGER TGINT
BEFORE INSERT OR UPDATE ON TT_INT 
FOR EACH ROW EXECUTE PROCEDURE TGINT();  


/*-- SEQ 4337 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGINU() CASCADE;

/*-- SEQ 4338 --*/
CREATE OR REPLACE FUNCTION TGINU() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impede excluso.
-- 2. Gerar um cdigo sequencial exclusivo para compor a chave primria.
-- 3. Atualiza controles de data.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Impede excluso.
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20000 Registro no pode ser excludo. %' , COMPLEMENTO;
   END IF;

   -- Impede alteracoes
   -- Permite apenas alterao do EXPEM4 pois deve ser alterado aps integrao
    IF (TG_OP = 'UPDATE') THEN
      IF (NEW.CODFIL <> OLD.CODFIL) OR
         (NEW.SEQUEN <> OLD.SEQUEN) OR 
         (NEW.DATINC <> OLD.DATINC) OR
         (NEW.NUMDOC <> OLD.NUMDOC) OR 
         (NEW.JUSTIF <> OLD.JUSTIF) OR
         (NEW.NUMINI <> OLD.NUMINI) OR
         (NEW.NUMFIM <> OLD.NUMFIM) OR
         (NEW.MODNOT <> OLD.MODNOT) OR
         (NEW.PROINU <> OLD.PROINU) OR
         (NEW.TIPAMB <> OLD.TIPAMB) OR
         (NEW.CODSER <> OLD.CODSER) THEN        
         RAISE EXCEPTION 'PG-20036 No  permitido alterao no registro. %' , COMPLEMENTO;
      END IF;
    END IF;

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN := ProximoCodigo('TT_INU',NEW.CODFIL);
      END IF;
      NEW.DATINC := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4339 --*/
CREATE TRIGGER TGINU
BEFORE INSERT OR UPDATE OR DELETE ON TT_INU 
FOR EACH ROW EXECUTE PROCEDURE TGINU();


/*-- SEQ 4340 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGINV() CASCADE;

/*-- SEQ 4341 --*/
CREATE OR REPLACE FUNCTION TGINV() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Desconsiderar mudancas nos dados do criador do inventario 

-- Principal
BEGIN
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
      NEW.SEQUEN:=ProximoCodigo('TT_INV',NEW.CODFIL);
   END IF;
   -- "default"
    NEW.DATCRI := agora();
    NEW.ATU_EM := Agora();
  END IF; 

  -- Mantem alguns dados originais da criacao
  IF (TG_OP = 'UPDATE') THEN
    NEW.FILCRI := OLD.FILCRI;
    NEW.CODCRI := OLD.CODCRI;
    NEW.DATCRI := OLD.DATCRI;
    NEW.ATU_EM := Agora();
 END IF;  

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4342 --*/
CREATE TRIGGER TGINV
BEFORE INSERT OR UPDATE ON TT_INV 
FOR EACH ROW EXECUTE PROCEDURE TGINV();

/*-- SEQ 4343 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGINV2() CASCADE;

/*-- SEQ 4344 --*/
CREATE OR REPLACE FUNCTION TGINV2() RETURNS TRIGGER AS $$
  -- Objetivo:
DECLARE
  vLOG    VARCHAR(4000)     := '';
  CRLF    CONSTANT CHAR(1)   := CHR(10); 
  cNulo   CONSTANT CHAR(4)   := 'Nulo';
  iNulo   CONSTANT Numeric(1) := 0;  
  vItem   CHAR(20)  := '';
  wk_coduid tt_uid.coduid%type;  

  QuemLogou TRetQuemLogou%ROWTYPE;

BEGIN
  IF (TG_OP = 'UPDATE') THEN  
     IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
        vLOG := vLOG||'Situação: de '||COALESCE(DescricaoDominio('INV','FLGEST',OLD.FLGEST),cNulo)||' para '||COALESCE(DescricaoDominio('INV','FLGEST',NEW.FLGEST),cNulo)||CRLF;
     END IF;  
     IF Equal(OLD.CODCRI,NEW.CODCRI) <> 1 THEN
    	vLOG := vLOG||'Código Criação: de '||COALESCE(OLD.CODCRI,cNulo)||' para '||COALESCE(NEW.CODCRI,cNulo)||CRLF;
     END IF;  
     IF Equal(OLD.FILCRI,NEW.FILCRI) <> 1 THEN
    	vLOG := vLOG||'Filial Encomenda: de '||COALESCE(OLD.FILCRI,cNulo)||' para '||COALESCE(NEW.FILCRI,cNulo)||CRLF;
     END IF;  
     IF Equal(OLD.DATCRI,NEW.DATCRI) <> 1 THEN
        vLOG := vLOG||'Data Criação: de '||COALESCE(to_char(OLD.DATCRI,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(to_char(NEW.DATCRI,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;  
     IF Equal(OLD.TITINV,NEW.TITINV) <> 1 THEN
        vLOG := vLOG||'Título Inventário: de '||COALESCE(OLD.TITINV,cNulo)||' para '||COALESCE(NEW.TITINV,cNulo)||CRLF;
     END IF; 
     IF Equal(OLD.CODENC,NEW.CODENC) <> 1 THEN
    	vLOG := vLOG||'Código Encomenda: de '||COALESCE(OLD.CODENC,cNulo)||' para '||COALESCE(NEW.CODENC,cNulo)||CRLF;
     END IF; 
     IF Equal(OLD.FILENC,NEW.FILENC) <> 1 THEN
    	vLOG := vLOG||'Filial Encomenda: de '||COALESCE(OLD.FILENC,cNulo)||' para '||COALESCE(NEW.FILENC,cNulo)||CRLF;
     END IF; 
     IF Equal(OLD.DATENC,NEW.DATENC) <> 1 THEN
        vLOG := vLOG||'Data Encomenda: de '||COALESCE(to_char(OLD.DATENC,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(to_char(NEW.DATENC,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;  
     IF Equal(OLD.CODMUL,NEW.CODMUL) <> 1 THEN
        vLOG := vLOG||'Nome do Sub-Estoque: de '||COALESCE(TO_CHAR(OLD.CODMUL),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODMUL),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.CODEXT,NEW.CODEXT) <> 1 THEN
        vLOG := vLOG||'Código Externo: de '||COALESCE(OLD.CODEXT,cNulo)||' para '||COALESCE(NEW.CODEXT,cNulo)||CRLF;
     END IF;  
     IF Equal(OLD.ATU_EM,NEW.ATU_EM) <> 1 THEN
        vLOG := vLOG||'Data Atualização: de '||COALESCE(to_char(OLD.ATU_EM,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(to_char(NEW.ATU_EM,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;  

     WK_CODUID := GetCoduidAtual();

     IF ISNOTNULL(vLOG) = 'T' THEN
       select * into QuemLogou from DadosLogon();
       INSERT INTO TL_INV (FILINV, SEQINV, MSGLOG, DATOPE, FILUSU, CODUSU, CODUID)
                     VALUES (NEW.CODFIL,NEW.SEQUEN,vLog,agora(),QuemLogou.FILUSU,QuemLogou.CODUSU,WK_CODUID);
     END IF;  
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4345 --*/
CREATE TRIGGER TGINV2
AFTER INSERT OR UPDATE ON TT_INV 
FOR EACH ROW EXECUTE PROCEDURE TGINV2();



/*-- SEQ 4346 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIOR2() CASCADE;

/*-- SEQ 4347 --*/
CREATE OR REPLACE FUNCTION TGIOR2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Permitir apenas alteracao na coluna FLGEST no caso do item nao estar aberto
-- 2) Fazer o papel de uma "foreign key"
-- 3) Fazer parte do papel de uma "foreign key"
-- 4) Gerar logs de Alterao/Excluso para PAF-ECF

  achou  INTEGER;
  vComplemento  VARCHAR(254);
  vAux          VARCHAR(1);
  vAspas  VARCHAR(1);
  vVerifica  VARCHAR(1);
  vENVIAR_ENTREGA  VARCHAR(1);

  inRec TT_IOR%ROWTYPE;
  inRecPlus Record;

  WK_QTD   Numeric;
  vTIPPRO TT_PRO.CODMAT%TYPE;
  cFILUSU TT_USU.FILUSU%TYPE;
  cCODUSU TT_USU.CODUSU%TYPE;
  iCODCFO TT_CFG.TRANSFER_CODCFO%TYPE;
  cSEQVEN TT_VEN.SEQUEN%TYPE;
  cSEQCOM TT_COM.SEQUEN%TYPE;
  cDUMMY VARCHAR(20);
  bGRAVA_NFT BOOLEAN;
  bCANCELA_NFT BOOLEAN;
  nCUSREP TT_GRA.CUSREP%TYPE;
  cFILCLI TT_CLI.FILCLI%TYPE;
  cCODCLI TT_CLI.CODCLI%TYPE;
  cTIPCCC TT_LIM.TIPCCC%TYPE;
  cVC_FILCLI TT_CLI.FILCLI%TYPE;
  cVC_CODCLI TT_CLI.CODCLI%TYPE;
  vFILIVE TM_IORXIVE.FILIVE%TYPE;
  vSEQIVE TM_IORXIVE.SEQIVE%TYPE;
  vNUMIVE TM_IORXIVE.NUMIVE%TYPE;
 
  QuemLogou TRetQuemLogou%ROWTYPE;

  WK_MOVEST  TT_SAL.MOVEST%TYPE;

  --LEO 84337
  vCODUID_ATUAL TT_VEN.CODUID%TYPE;
  vBLQ_SEM_UID  TT_CFG.BLQ_SEM_UID%TYPE;
  vSESSIONID    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

  -- Pedro E. Braga - 93400
  vINDCAN TL_IOR_PAF.INDCAN%TYPE;
  NovoCODTAM TT_IOR.CODTAM%TYPE;
  NovoQTDITE TT_IOR.QTDITE%TYPE;
  OldQTDITE TT_IOR.QTDITE%TYPE;

   bTrocouProduto                VARCHAR(1);
   iOldCODTAM                    TT_IOR.CODTAM%TYPE;

   cAPROVA                       TT_ORC.APROVA%TYPE;
BEGIN

  vAspas := CHR(39);
  vComplemento  := constante('complemento');

  IF (TG_OP = 'DELETE') THEN
     IF OLD.TIPPED = 'P' THEN
        RAISE EXCEPTION 'PG-20003 No  permitido excluir itens de pr-venda. %' , vComplemento;
     END IF;
  END IF;

  -- Incluir no select abaixo todas as informaes da TT_ORC que sero necessrias no (TG_OP = 'UPDATE') da trigger.
  -- Isso evita que sejam feitas vrias consultas para situaes distintas.
  IF (TG_OP = 'UPDATE') THEN
     cAPROVA := NULL;
     
     IF Equal(NEW.DUMMY, Constante('VEM_DE_TGORC')) <> 1 THEN
        SELECT APROVA
          INTO cAPROVA
          FROM TT_ORC
         WHERE CODFIL = NEW.CODFIL
           AND TIPPED = NEW.TIPPED
           AND NUMPED = NEW.NUMPED;
     END IF;
  END IF;

  -- Controle para Concorrencia de Transao
  IF (TG_OP = 'UPDATE') THEN
    IF (COALESCE(OLD.SIGNAT,0) <> COALESCE(NEW.SIGNAT,0)) THEN
       RAISE EXCEPTION 'PG-20003 Registro foi alterado por outro usurio, refaa a consulta e tente gravar novamente. %' , vComplemento;
    END IF;

    -- RFMP  - 102342 - O UPDATE na TT_IOR dentro da TGIVEXIPE ocorre antes do UPDATE na prpria TT_IOR.
    -- Rhuan - 102661 - Quando vier do boto de lucratividade do Order tambm no atualiza.
    -- Quando houver alguma situao assim, tratar para no incrementar o SIGNAT.
    IF (Equal(NEW.DUMMY, Constante('VEM_DE_TGIVEXIPE')) <> 1) AND
       (Equal(NEW.DUMMY, Constante('VEM_DE_LUCRATIVIDADE')) <> 1) THEN
       NEW.SIGNAT := MOD(COALESCE(OLD.SIGNAT,0) + 1,100000);
    END IF;
  END IF;

  -- data de inclusao do item de orcamento
  IF (TG_OP = 'INSERT') THEN
     NEW.DATINC := AGORA();
  END IF;

  SELECT ENVIAR_ENTREGA
    INTO vENVIAR_ENTREGA
    FROM TT_CFG;

  IF (TG_OP = 'INSERT') THEN
    -- Verifica se j existe um registro na TM_IORXIVE
          SELECT FILIVE, SEQIVE, NUMIVE INTO vFILIVE, vSEQIVE, vNUMIVE
        FROM TM_IORXIVE
       WHERE FILIVE = NEW.FILIVE
         AND SEQIVE = NEW.SEQIVE
         AND NUMIVE = NEW.NUMIVE;

    
     -- Se existe, vincula a TT_IOR com a TT_IVE e e excluir o registro da TM_IORXIVE
      IF vFILIVE IS NOT NULL THEN

        NEW.FILIVE := vFILIVE;
        NEW.SEQIVE := vSEQIVE;
        NEW.NUMIVE := vNUMIVE;

      DELETE
        FROM TM_IORXIVE
       WHERE FILIVE = NEW.FILIVE
         AND SEQIVE = NEW.SEQIVE
         AND NUMIVE = NEW.NUMIVE;
    END IF;
  END IF;

  IF (TG_OP = 'UPDATE') THEN


     IF (OLD.FLGEST = 'C') AND
        (NEW.FLGEST <> 'C') THEN
          SELECT COUNT(*) INTO WK_QTD
            FROM TT_ORC
           WHERE CODFIL =NEW.CODFIL
             AND TIPPED =NEW.TIPPED
             AND NUMPED =NEW.NUMPED
             AND FLGEST='C';

          IF WK_QTD>0 THEN
             RAISE EXCEPTION 'PG-20017 Um item de orcamento/OS cancelado nao pode ser modificado.%' , vComplemento;
          END IF;
     END IF;
      -- Restrio removida RFMP 67571
      --No permite que o vnculo do item de um oramento seja alterado com o item de venda
      --IF ((NEW.FILIVE is not null) and (NEW.FILIVE <> OLD.FILIVE) and (OLD.FILIVE is not null))
      --or ((NEW.SEQIVE is not null) and (NEW.SEQIVE <> OLD.SEQIVE) and (OLD.SEQIVE is not null))
      --or ((NEW.NUMIVE is not null) and (NEW.NUMIVE <> OLD.NUMIVE) and (OLD.NUMIVE is not null)) then
      --       RAISE EXCEPTION 'PG-20018 Item de oramento j vinculado a um item de venda.%' , vComplemento;
      --END IF;

      -- Define FLGEST = 'T' (Em andamento) ao receber tecnico alocado
      IF  (NEW.FILPAR is not null)
      AND (OLD.FILPAR is null)
      AND (OLD.FLGEST = 'A') THEN
          NEW.FLGEST := 'T';
      END IF;

      -- Define FLGEST = 'A' (Em aberto) ao eliminar tecnico alocado
      IF  (NEW.FILPAR is null)
      AND (OLD.FILPAR is not null)
      AND (OLD.FLGEST = 'T') THEN
          NEW.FLGEST := 'A';
      END IF;

      IF Equal(NEW.DUMMY, Constante('VEM_DE_PC_IVO')) <> 1 THEN
        -- ao cancelar um orcamento
        IF  (Equal(OLD.FLGEST,NEW.FLGEST) <> 1)
        AND (NEW.FLGEST = 'C') THEN
          UPDATE TT_IVO
             SET FLGEST = 'D',
                 FILROM = NULL,
                 SEQROM = NULL
           WHERE FILPED = NEW.CODFIL
             AND TIPPED = NEW.TIPPED
             AND NUMPED = NEW.NUMPED
             AND NUMITE = NEW.NUMITE
             AND FLGEST = 'P';
        END IF;
      END IF;

  END IF;

  IF NOT (TG_OP = 'DELETE') THEN
      -- Verifica o tipo do produto para nao reservar servico
      SELECT TIPPRO INTO vTIPPRO
           FROM TT_PRO
          WHERE FILMAT=NEW.FILMAT
            AND CODMAT=NEW.CODMAT;
  END IF;

  IF (TG_OP = 'INSERT') THEN
      IF (NEW.TIPENT IN ('1','2','3','5','7')) THEN
          NEW.FLGIVO := 'A';
      END IF;
  END IF;

  -- alteracao de tipo de entrega
  IF (TG_OP = 'UPDATE') THEN
    IF Equal(OLD.TIPENT,NEW.TIPENT) <> 1 THEN
      IF (NEW.TIPENT IN ('0','6')) THEN
        NEW.FLGIVO := NULL;
        IF OLD.FLGIVO = 'P' THEN
          UPDATE TT_IVO
             SET FLGEST = 'C',
                 FILROM = NULL,
                 SEQROM = NULL,
                 QTDFAL = 0
           WHERE FILPED = NEW.CODFIL
             AND TIPPED = NEW.TIPPED
             AND NUMPED = NEW.NUMPED
             AND NUMITE = NEW.NUMITE
             AND FLGEST IN ('A','F','N');
        END IF;
      ELSE
        NEW.FLGIVO := 'A';
      END IF;
    ELSE
      -- RFMP 71453
      IF  (NEW.TIPENT = '2') AND (Equal(OLD.FILIVE,NEW.FILIVE) <> 1) THEN
        NEW.FLGIVO := 'A';
      END IF;
    END IF;
  END IF;

  -- alteracao para "em aprovacao"
  IF (TG_OP = 'UPDATE') THEN

    IF COALESCE(cAPROVA,'X') IN ('E','R') THEN
      -- Cancela as separaes que esto Abertas, Em Falta e No Separar
      UPDATE TT_IVO
         SET FLGEST = 'C',
             FILROM = NULL,
             SEQROM = NULL,
             QTDFAL = 0
       WHERE FILPED = NEW.CODFIL
         AND TIPPED = NEW.TIPPED
         AND NUMPED = NEW.NUMPED
         AND NUMITE = NEW.NUMITE
         AND FLGEST IN ('A','F','N');

      -- Devolve as separaes j separadas
      UPDATE TT_IVO
         SET FLGEST = 'D',
             FILROM = NULL,
             SEQROM = NULL
       WHERE FILPED = NEW.CODFIL
         AND TIPPED = NEW.TIPPED
         AND NUMPED = NEW.NUMPED
         AND NUMITE = NEW.NUMITE
         AND FLGEST = 'P';

      -- Retorna a flag de separao para Aberta.
      IF (ISNULL(OLD.FLGIVO) = 'F') THEN
        NEW.FLGIVO := 'A';
      END IF;
    END IF;
  END IF;

  IF NOT (TG_OP = 'DELETE') THEN
    -- RFMP 59685 Verifica se movimenta estoque
    WK_MOVEST := MovimentaEstoque(NEW.CODFIL,NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,NEW.CODMUL);
  ELSE
    -- 66369 permitir que WK_MOVEST seja = T para Atualizar Reserva
    WK_MOVEST := MovimentaEstoque(OLD.CODFIL,OLD.FILMAT,OLD.CODMAT,OLD.CODCOR,OLD.CODTAM,OLD.CODMUL);
  END IF;

  IF NOT (TG_OP = 'DELETE') THEN
     -- Manoel -  necessrio converter a quantidade de embalagem para sempre reservar na unidade,  necessrio converter tanto a varivel NEW.qtdite quanto
     -- OLD.qtdite, pois pode acontecer de usurio reservar mais ou menos itens, nesse caso, teria que desreservar o que est em old, convertendo, e depois
     -- reservar o que estiver em NEW, convertendo.
     SELECT COALESCE(DSUB.CODSAL,SUB.CODITE) AS CODTAM,
               NEW.QTDITE * (CASE WHEN DSUB.CODSAL IS NULL THEN 1
                                   ELSE SUB.FATCON
                              END) AS QTDITE
          INTO NovoCODTAM, NovoQTDITE
          FROM TD_SUB DSUB INNER JOIN TT_SUB SUB ON SUB.CODSUB = DSUB.CODTAB
         WHERE SUB.CODITE = NEW.CODTAM;
  END IF;

  -- Liberando reserva ao excluir
  IF (TG_OP = 'DELETE') THEN
     IF  (OLD.FLGEST = 'R')
     AND (WK_MOVEST = 'T') THEN
         -- Manoel - 101399 - Necessrio pegar o qtdite que pode estar em embalagem e pegar na unidade final
         SELECT COALESCE(DSUB.CODSAL,SUB.CODITE) AS CODTAM,
               OLD.QTDITE * (CASE WHEN DSUB.CODSAL IS NULL THEN 1
                                   ELSE SUB.FATCON
                              END) AS QTDITE
          INTO NovoCODTAM, OldQTDITE
          FROM TD_SUB DSUB INNER JOIN TT_SUB SUB ON SUB.CODSUB = DSUB.CODTAB
         WHERE SUB.CODITE = OLD.CODTAM;

        vAux:=TGR_IOR_Atualiza_Reserva(OldQTDITE * -1,OLD.FILRES,OLD.FILMAT,OLD.CODMAT,OLD.CODCOR, NovoCODTAM,OLD.CODMUL);

        IF (OLD.FILLOT IS NOT NULL) AND (OLD.SEQLOT IS NOT NULL) THEN
           vAux:=TGR_IOR_Atualiza_Reserva_Lote(OldQTDITE * -1, OLD.FILRES, OLD.CODMUL, OLD.FILLOT, OLD.SEQLOT);
        END IF;
     END IF;
  END IF;

  IF NOT (TG_OP = 'DELETE') THEN
  vVerifica:='F';

    -- Faz o papel de uma "foreign key"
    IF ((NEW.FILIVE IS NOT NULL) OR
        (NEW.SEQIVE IS NOT NULL) OR
        (NEW.NUMIVE IS NOT NULL)) THEN
        IF (TG_OP = 'INSERT') THEN
           vVerifica:='T';
        ELSIF ((COALESCE(OLD.FILIVE,'ERRO') <> NEW.FILIVE) OR
               (COALESCE(OLD.SEQIVE,'ERRO') <> NEW.SEQIVE) OR
               (COALESCE(OLD.NUMIVE,-9999) <> NEW.NUMIVE)) THEN
           vVerifica:='T';
        END IF;
    END IF;


    IF vVerifica='T' THEN
      Achou := TGR_IOR_Item_Existe(NEW.FILIVE,
                                   NEW.SEQIVE,
                                   NEW.NUMIVE); /* retornos possiveis 0 e 1 E -1*/

      IF (achou = 0) then
         RAISE EXCEPTION 'PG-20022 Item de venda nao foi encontrado.%' , vComplemento;
      END IF;
    END IF;

    IF (NEW.FLGEST IN ('E','S')) AND
       ((NEW.FILIVE IS NULL) OR
        (NEW.SEQIVE IS NULL) OR
        (NEW.NUMIVE IS NULL)) AND (NEW.TIPPGT IS NULL) THEN
        RAISE EXCEPTION 'PG-20020 E% preciso informar o item de venda.%' , vAspas,vComplemento;
    ELSIF (NEW.FLGEST IN ('A','O','R')) AND
          ((NEW.FILIVE IS NOT NULL) OR
           (NEW.SEQIVE IS NOT NULL) OR
           (NEW.NUMIVE IS NOT NULL)) AND
           (Equal(NEW.DUMMY, 'A') <> 1) THEN --57914
        RAISE EXCEPTION 'PG-20021 Ha% um item de venda ligado a este orcamento.%' , vAspas,vComplemento;
    END IF;

    bGRAVA_NFT:=false;

    IF (TG_OP = 'INSERT') THEN
        IF (NEW.SEQIVE IS NOT NULL) and
           (NEW.CODFIL<>NEW.FILRES) THEN
           --Pedro E. Braga - Impede Gerao de Transferencia Automatica quando FILRES da TT_IVE estiver informado
           SELECT COUNT(*) INTO achou
             FROM TT_IVE
            WHERE CODFIL = NEW.FILIVE
              AND SEQUEN = NEW.SEQIVE
              AND NUMITE = NEW.NUMIVE
              AND FILRES IS NOT NULL;
           IF (achou = 0) THEN
            bGRAVA_NFT := true;
           END IF;
        END IF;
    END IF;

    IF (TG_OP = 'UPDATE') THEN
        IF (OLD.SEQIVE IS NULL) and
           (NEW.SEQIVE IS NOT NULL) and
           (NEW.CODFIL<>NEW.FILRES) THEN
           --Pedro E. Braga - Impede Gerao de Transferencia Automatica quando FILRES da TT_IVE estiver informado
           SELECT COUNT(*) INTO achou
             FROM TT_IVE
            WHERE CODFIL = NEW.FILIVE
              AND SEQUEN = NEW.SEQIVE
              AND NUMITE = NEW.NUMIVE
              AND FILRES IS NOT NULL;
           IF (achou = 0) THEN
            bGRAVA_NFT := true;
           END IF;
        END IF;
    END IF;

    IF (TG_OP = 'INSERT')
    OR (TG_OP = 'UPDATE') THEN
      -- RFMP - 20/12/2007 - 57923
      -- Esta restricao devera ser retirada no futuro quando for tratada a transferencia automatica para entrega futura e encomenda
      IF  NEW.TIPENT IN ('5','7') THEN
          IF  (NEW.CODFIL <> NEW.FILRES)
          AND ((NEW.FLGEST = 'R') AND (NEW.FLGENC <> 'T'))
          AND (vENVIAR_ENTREGA = 'T') THEN
              RAISE EXCEPTION 'PG-20018 Nao e% permitido reservar orcamento com entrega futura ou encomenda. %' , vAspas,vComplemento;
          END IF;
      END IF;
    END IF;

    -- Tratamento NFT
    -- Cria NFT para item de oramento de outra filial
    -- MN - Transferncia automtica somente executa se estiver parametrizado 
    IF LeParametroBoo('USA_TRANS_AUTOMATICA', '', '', '', '') = 'T' THEN
       IF (bGRAVA_NFT) AND (NEW.TIPENT <> '7') THEN

          -- RFMP 95450
          nCUSREP := ValoresProdutoTransfAutom(NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM, NEW.FILRES);
          cDummy := GeraTransfAutom(NEW.CODFIL, NEW.FILMAT, NEW.CODMAT,
                                    NEW.CODCOR, NEW.CODTAM, NEW.FILRES,
                                    NEW.QTDITE, nCUSREP);

          cSEQVEN := NotaAbertaTransfAutom('V', NEW.CODFIL, NEW.FILRES);
          cSEQCOM := NotaAbertaTransfAutom('C', NEW.CODFIL, NEW.FILRES);

                                       
                cDUMMY := PC_IOR_PLUS_UPDATE(NEW.CODFIL,NEW.FILRES,cSEQVEN,cSEQCOM,NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,
                                             NEW.CODTAM,NEW.QTDITE,nCUSREP,'E',NEW.CODMUL,NULL,NULL,NULL,
                                             NEW.FILLOT,NEW.SEQLOT,NEW.TIPENT);
                                END IF;

       bCANCELA_NFT:=false;

       IF (TG_OP = 'UPDATE') THEN
           IF (OLD.SEQIVE IS NOT NULL) and
              (NEW.SEQIVE IS NULL) and
              (NEW.CODFIL<>NEW.FILRES) THEN
              IF COALESCE(NEW.DUMMY,'XX') <> Constante('vem_de_TGIVE') THEN
                 RAISE EXCEPTION 'PG-20055 Item de oramento ja vendido nao pode ser alterado.%' , vComplemento;
              END IF;
              --Pedro E. Braga - Impede Gerao de Transferencia Automatica quando FILRES da TT_IVE estiver informado
              SELECT COUNT(*) INTO achou
                FROM TT_IVE
               WHERE CODFIL = OLD.FILIVE
                 AND SEQUEN = OLD.SEQIVE
                 AND NUMITE = OLD.NUMIVE
                 AND FILRES IS NOT NULL;
              IF (achou = 0) THEN
               bCANCELA_NFT := true;
              END IF;
           END IF;
          -- Restrio removida RFMP 67571
          -- IF (OLD.FILIVE <> NEW.FILIVE) or
          --    (OLD.SEQIVE <> NEW.SEQIVE) or
          --    (OLD.NUMIVE <> NEW.NUMIVE) THEN
          --    RAISE EXCEPTION 'PG-20056 Vinculo com a venda nao pode ser alterado.%' , vComplemento;
          -- END IF;
       END IF;

       -- Cancela item de NFT
       IF (bCANCELA_NFT) THEN

          -- RFMP 95450
          cSEQVEN := NotaAbertaTransfAutom('V', NEW.CODFIL, NEW.FILRES);
          cSEQCOM := NotaAbertaTransfAutom('C', NEW.CODFIL, NEW.FILRES);

          IF cSEQVEN IS NOT NULL THEN

                                       
                cDUMMY := PC_IOR_PLUS_UPDATE(NEW.CODFIL,NEW.FILRES,cSEQVEN,cSEQCOM,NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,
                                             NEW.CODTAM,NEW.QTDITE,NULL,'C',NEW.CODMUL,NULL,NULL,NULL,
                                             NEW.FILLOT,NEW.SEQLOT,NEW.TIPENT);
                                   ELSE
             cDummy := EmailTransfAutom(NEW.CODFIL,OLD.FILIVE,OLD.SEQIVE,
                                        OLD.FILMAT,OLD.CODMAT,OLD.CODCOR,OLD.CODTAM,
                                        null,null,null);
          END IF;
       END IF;
    END IF;

    -- Incrementa reserva
    IF  ((TG_OP = 'INSERT'))
    AND (NEW.FLGEST = 'R')
    AND (WK_MOVEST   = 'T') THEN
       IF vTIPPRO NOT IN ('1','2') THEN
           vAux:=TGR_IOR_Atualiza_Reserva(NovoQTDITE,NEW.FILRES,NEW.FILMAT,NEW.CODMAT,NEW.CODCOR, NovoCODTAM,NEW.CODMUL);
           IF (NEW.FILLOT IS NOT NULL) AND (NEW.SEQLOT IS NOT NULL) THEN
              vAux:=TGR_IOR_Atualiza_Reserva_Lote(NovoQTDITE, NEW.FILRES, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT);
           END IF;
       END IF;
    END IF;

  END IF;

  IF  ((TG_OP = 'UPDATE'))
  AND (vTIPPRO NOT IN ('1','2'))
  AND (WK_MOVEST = 'T') THEN
     -- Manoel - 101399 - Necessrio pegar o qtdite que pode estar em embalagem e pegar na unidade final
     SELECT COALESCE(DSUB.CODSAL,SUB.CODITE) AS CODTAM,
            OLD.QTDITE * (CASE WHEN DSUB.CODSAL IS NULL THEN 1
                                                         ELSE SUB.FATCON
                           END) AS QTDITE
       INTO NovoCODTAM, OldQTDITE
       FROM TD_SUB DSUB INNER JOIN TT_SUB SUB ON SUB.CODSUB = DSUB.CODTAB
      WHERE SUB.CODITE = NEW.CODTAM;

     iOldCODTAM := NovoCODTAM;

     IF (OLD.FILMAT <> NEW.FILMAT) OR
        (OLD.CODMAT <> NEW.CODMAT) OR
        (OLD.CODCOR <> NEW.CODCOR) OR
        (OLD.CODTAM <> NEW.CODTAM) THEN
        bTrocouProduto := 'T';

        -- Se trocou o produto, busca o CODTAM antigo para tratar a reserva.
        SELECT COALESCE(DSUB.CODSAL,SUB.CODITE) AS CODTAM
          INTO iOldCODTAM
          FROM TD_SUB DSUB INNER JOIN TT_SUB SUB ON SUB.CODSUB = DSUB.CODTAB
         WHERE SUB.CODITE = OLD.CODTAM;
     END IF;

     -- Nao era reservado e passou a ser, entao reserva o novo produto com a nova quantidade
     IF (OLD.FLGEST <> 'R' AND NEW.FLGEST = 'R') THEN
       vAux:=TGR_IOR_Atualiza_Reserva(NovoQTDITE,NEW.FILRES,NEW.FILMAT,NEW.CODMAT,NEW.CODCOR, NovoCODTAM,NEW.CODMUL);

       IF (NEW.FILLOT IS NOT NULL) AND (NEW.SEQLOT IS NOT NULL) THEN
          vAux:=TGR_IOR_Atualiza_Reserva_Lote(NovoQTDITE, NEW.FILRES, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT);
       END IF;

     -- Era reservado, e deixou de ser, entao retira a reserva do produto anterior com a quantidade anterior
     ELSIF (OLD.FLGEST = 'R' AND NEW.FLGEST <> 'R') THEN
       vAux:=TGR_IOR_Atualiza_Reserva(OldQTDITE * -1,OLD.FILRES,OLD.FILMAT,OLD.CODMAT,OLD.CODCOR, iOldCODTAM, OLD.CODMUL);

      IF ((NEW.FILLOT IS NOT NULL) AND (NEW.SEQLOT IS NOT NULL)) AND (OLD.FILLOT IS NOT NULL) THEN
          vAux:=TGR_IOR_Atualiza_Reserva_Lote(OldQTDITE * -1, OLD.FILRES, OLD.CODMUL, OLD.FILLOT, OLD.SEQLOT);
       -- Paulo K. - 91127 : Se retirou o lote tira a reserva.
       ELSIF ((OLD.FILLOT IS NOT NULL) AND (OLD.SEQLOT IS NOT NULL)) AND ((NEW.FILLOT IS NULL) AND (NEW.SEQLOT IS NULL)) THEN
          vAux:=TGR_IOR_Atualiza_Reserva_Lote(OldQTDITE * -1, OLD.FILRES, OLD.CODMUL, OLD.FILLOT, OLD.SEQLOT);
       END IF;
     ELSIF (OLD.FLGEST = 'R' AND NEW.FLGEST = 'R') THEN
       IF ( (OLD.QTDITE <> NEW.QTDITE)
         OR (OLD.CODFIL <> NEW.CODFIL)
         OR (bTrocouProduto = 'T')
         OR (OLD.CODMUL <> NEW.CODMUL)
         OR (OLD.FILRES <> NEW.FILRES)
         OR (OLD.FILLOT <> NEW.FILLOT)
         OR (OLD.SEQLOT <> NEW.SEQLOT) ) THEN
         -- Manoel - Tira a quantidade antiga da reserva
         vAux:=TGR_IOR_Atualiza_Reserva(OldQTDITE * -1,OLD.FILRES,OLD.FILMAT,OLD.CODMAT,OLD.CODCOR,iOldCODTAM,OLD.CODMUL);

         -- Manoel - Coloca a nova quantidade como reservada reserva
         vAux:=TGR_IOR_Atualiza_Reserva(NovoQTDITE,     NEW.FILRES,NEW.FILMAT,NEW.CODMAT,NEW.CODCOR, NovoCODTAM,NEW.CODMUL);

         IF (NEW.FILLOT IS NOT NULL) AND (NEW.SEQLOT IS NOT NULL) THEN
            IF ((OLD.FILLOT IS NOT NULL) AND (OLD.SEQLOT IS NOT NULL)) THEN
               vAux:=TGR_IOR_Atualiza_Reserva_Lote(OldQTDITE * -1, OLD.FILRES, OLD.CODMUL, OLD.FILLOT, OLD.SEQLOT);
            END IF;
            vAux:=TGR_IOR_Atualiza_Reserva_Lote(NovoQTDITE, NEW.FILRES, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT);
         -- Paulo K. - 91127 : Se retirou o lote tira a reserva.
         ELSIF ((OLD.FILLOT IS NOT NULL) AND (OLD.SEQLOT IS NOT NULL)) AND ((NEW.FILLOT IS NULL) AND (NEW.SEQLOT IS NULL)) THEN
            vAux:=TGR_IOR_Atualiza_Reserva_Lote(OldQTDITE * -1, OLD.FILRES, OLD.CODMUL, OLD.FILLOT, OLD.SEQLOT);
         END IF;
       END IF;
     END IF;

  END IF;

  IF (TG_OP = 'INSERT')
  OR (TG_OP = 'UPDATE') THEN
     -- 83054 Em caso de alterao no Oramento popula a coluna TT_IOR.DESCON
     NEW.DESCON := ROUND((NEW.VLRPGT - NEW.VLRCUS),2);
  END IF;

  IF (TG_OP = 'INSERT') THEN
    NEW.NUMITE_PAF := NEW.NUMITE;
    NEW.FLGEST_PAF := NEW.FLGEST;
  END IF;

  IF (TG_OP = 'UPDATE') THEN
    IF Equal(NEW.DUMMY,'B') = 1 THEN
      -- RFMP 86081 Veio do boto desistncia do Order e o campo ainda est nulo...
      NEW.FLGEST_PAF := COALESCE(NEW.FLGEST_PAF,OLD.FLGEST);
    ELSE
      -- RFMP 86081 Veio do boto desistncia do Order
      NEW.FLGEST_PAF := NEW.FLGEST;
    END IF;
  END IF;

  IF NOT (TG_OP = 'DELETE') THEN
    NEW.DUMMY := NULL;
  END IF;

  -- Pegando usurio
  SELECT FILUSU,CODUSU into cFILUSU,cCODUSU
    FROM TT_USU
    WHERE APEUSU = QUALDONO();

  IF (TG_OP = 'DELETE') THEN
    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;

    -- Pedro E. Braga - 93400 - Gera Log PAF-ECF
    IF (OLD.FLGEST = 'C') THEN
    vINDCAN := 'T';
    ELSE
    vINDCAN := 'F';
    END IF;
    INSERT INTO TL_IOR_PAF ( CODFIL, TIPPED, NUMPED, NUMITE, TIPLOG, INDCAN,
                           FILMAT, CODMAT, CODCOR, CODTAM,
                           QTDITE, VLRITE, DESCON, VLRPGT,
                           FILUSU, CODUSU, CODUID, NUMCRE, ORICRE)
                  VALUES ( OLD.CODFIL, OLD.TIPPED, OLD.NUMPED, OLD.NUMITE, 'E', vINDCAN,
                           OLD.FILMAT, OLD.CODMAT, OLD.CODCOR, OLD.CODTAM,
                           OLD.QTDITE, OLD.VLRITE, COALESCE(OLD.DESCON, 0), OLD.VLRPGT,
                           COALESCE(OLD.FILUSU, cFILUSU), COALESCE(OLD.CODUSU, cCODUSU), OLD.CODUID, OLD.NUMCRE, OLD.ORICRE );

  END IF;

   IF (TG_OP = 'INSERT') THEN

        -- LEO 84337
        SELECT BLQ_SEM_UID
          INTO vBLQ_SEM_UID
          FROM TT_CFG;
        vCODUID_ATUAL := GetCoduidAtual();
        IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
           RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
        END IF;

        -- Douglas - 83441
        NEW.CODUID := GetCoduidAtual();
        NEW.ASSINA := COALESCE(AssinaTabela('TT_IOR',
                                            ConcatenaIOR(NEW.CODFIL,
                                                         NEW.TIPPED,
                                                         NEW.NUMPED,
                                                         NEW.NUMITE,
                                                         NEW.COOVEN,
                                                         NEW.ECFVEN,
                                                         NEW.QTDITE,
                                                         NEW.VLRITE,
                                                         NEW.DESCON,
                                                         NEW.VLRPGT,
                                                         NEW.FLGEST,
                                                         NEW.NUMITE_PAF,
                                                         NEW.FLGEST_PAF,
                                                         NEW.DATINC),
                                                       null, null, null),NEW.ASSINA);
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF ConcatenaIOR(NEW.CODFIL,NEW.TIPPED,NEW.NUMPED,NEW.NUMITE,
                      NEW.COOVEN,NEW.ECFVEN,NEW.QTDITE,NEW.VLRITE,
                      NEW.DESCON,NEW.VLRPGT,NEW.FLGEST,NEW.NUMITE_PAF,
                      NEW.FLGEST_PAF,NEW.DATINC) <>
         ConcatenaIOR(OLD.CODFIL,OLD.TIPPED,OLD.NUMPED,OLD.NUMITE,
                      OLD.COOVEN,OLD.ECFVEN,OLD.QTDITE,OLD.VLRITE,
                      OLD.DESCON,OLD.VLRPGT,OLD.FLGEST,OLD.NUMITE_PAF,
                      OLD.FLGEST_PAF,OLD.DATINC) THEN

         -- LEO 84337
         SELECT BLQ_SEM_UID
           INTO vBLQ_SEM_UID
           FROM TT_CFG;
         vCODUID_ATUAL := GetCoduidAtual();
         IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;

         -- Douglas - 83441
         NEW.CODUID := GetCoduidAtual();
         NEW.ASSINA := COALESCE(AssinaTabela('TT_IOR',
                                              ConcatenaIOR(NEW.CODFIL,
                                                           NEW.TIPPED,
                                                           NEW.NUMPED,
                                                           NEW.NUMITE,
                                                           NEW.COOVEN,
                                                           NEW.ECFVEN,
                                                           NEW.QTDITE,
                                                           NEW.VLRITE,
                                                           NEW.DESCON,
                                                           NEW.VLRPGT,
                                                           NEW.FLGEST,
                                                           NEW.NUMITE_PAF,
                                                           NEW.FLGEST_PAF,
                                                           NEW.DATINC),
                                              OLD.CODUID,
                                              ConcatenaIOR(OLD.CODFIL,
                                                           OLD.TIPPED,
                                                           OLD.NUMPED,
                                                           OLD.NUMITE,
                                                           OLD.COOVEN,
                                                           OLD.ECFVEN,
                                                           OLD.QTDITE,
                                                           OLD.VLRITE,
                                                           OLD.DESCON,
                                                           OLD.VLRPGT,
                                                           OLD.FLGEST,
                                                           OLD.NUMITE_PAF,
                                                           OLD.FLGEST_PAF,
                                                           OLD.DATINC),
                                              OLD.ASSINA
                                              ),
                                 NEW.ASSINA);
      END IF;
      -- Pedro E. Braga - 93400 - Gera Log PAF-ECF
      IF (Equal(OLD.CODFIL,NEW.CODFIL) <> 1) OR (Equal(OLD.TIPPED,NEW.TIPPED) <> 1)
      OR (Equal(OLD.NUMPED,NEW.NUMPED) <> 1) OR (Equal(OLD.NUMITE,NEW.NUMITE) <> 1)
      OR (Equal(OLD.FILMAT,NEW.FILMAT) <> 1) OR (Equal(OLD.CODMAT,NEW.CODMAT) <> 1)
      OR (Equal(OLD.CODCOR,NEW.CODCOR) <> 1) OR (Equal(OLD.CODTAM,NEW.CODTAM) <> 1)
      OR (Equal(OLD.QTDITE,NEW.QTDITE) <> 1)
--      OR (Equal(OLD.VLRITE,NEW.VLRITE) <> 1)
      --OR (Equal(OLD.DESCON,NEW.DESCON) <> 1) OR (Equal(OLD.VLRPGT,NEW.VLRPGT) <> 1)
      --OR (Equal(OLD.FILUSU,NEW.FILUSU) <> 1) OR (Equal(OLD.CODUSU,NEW.CODUSU) <> 1)
      --OR (Equal(OLD.CODUID,NEW.CODUID) <> 1) OR (Equal(OLD.FLGEST,NEW.FLGEST) <> 1)
      THEN
          IF (NEW.FLGEST = 'C') THEN
            vINDCAN := 'T';
          ELSE
            vINDCAN := 'F';
          END IF;
          INSERT INTO TL_IOR_PAF ( CODFIL, TIPPED, NUMPED, NUMITE, TIPLOG, INDCAN,
                                   FILMAT, CODMAT, CODCOR, CODTAM,
                                   QTDITE, VLRITE, DESCON, VLRPGT,
                                   FILUSU, CODUSU, CODUID, NUMCRE, ORICRE)
                          VALUES ( NEW.CODFIL, NEW.TIPPED, NEW.NUMPED, NEW.NUMITE, 'A', vINDCAN,
                                   NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM,
                                   NEW.QTDITE, NEW.VLRITE, COALESCE(NEW.DESCON, 0), NEW.VLRPGT,
                                   COALESCE(NEW.FILUSU, cFILUSU), COALESCE(NEW.CODUSU, cCODUSU), NEW.CODUID, NEW.NUMCRE, NEW.ORICRE );
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4348 --*/
CREATE TRIGGER TGIOR2
BEFORE INSERT OR UPDATE OR DELETE ON TT_IOR 
FOR EACH ROW EXECUTE PROCEDURE TGIOR2();

/*-- SEQ 4349 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIOR3() CASCADE;

/*-- SEQ 4350 --*/
CREATE OR REPLACE FUNCTION TGIOR3() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Realizar C/C a partir de IOR
-- 2) Gerar logs de incluso para PAF-ECF

  cFILCLI TT_CLI.FILCLI%TYPE;
  cCODCLI TT_CLI.CODCLI%TYPE;
  cTIPCCC TT_LIM.TIPCCC%TYPE;
  cVC_FILCLI TT_CLI.FILCLI%TYPE;
  cVC_CODCLI TT_CLI.CODCLI%TYPE;
  vComplemento  VARCHAR(254) := constante('complemento');
 
  QuemLogou TRetQuemLogou%ROWTYPE;

  inRec Record;
--
  inRecIveIvo Record;


  CRLF    CONSTANT CHAR(1)   := CHR(10);
  vItem   CHAR(20)  := '';
  wk_coduid tt_uid.coduid%type;
  vENDE INTEGER;

  cLog    VARCHAR(4000)     := '';
  cNulo   CONSTANT CHAR(4)   := 'Nulo';
  iNulo   CONSTANT Numeric(1) := 0;

  bVerifica boolean;
  inRec_IVExIPE         TT_IVExIPE%ROWTYPE;
  cDUMMY                VARCHAR(1);
  iTEM_PEDIDO INTEGER;

  --Pedro E. Braga - 93400 - Gera Log de Incluso
  cFILUSU TT_USU.FILUSU%TYPE;
  cCODUSU TT_USU.CODUSU%TYPE;

  vFILIVE TM_IORXIVE.FILIVE%TYPE;
  vSEQIVE TM_IORXIVE.SEQIVE%TYPE;
  vNUMIVE TM_IORXIVE.NUMIVE%TYPE;
  
   cFLGEST                       TT_IOR.FLGEST%TYPE;
   nVendaRegistradaCheckoutPoS   INTEGER;
   cTELEVE                       TT_ORC.TELEVE%TYPE;
   cFLGECO                       TT_ORC.FLGECO%TYPE;
   cENVECO                       TT_ORC.ENVECO%TYPE;
   cNUMPED_RE                    TT_ORC.NUMPED_RE%TYPE;
BEGIN

  bVerifica:=false;

  IF (TG_OP = 'INSERT') THEN -- 64504 - Igor - 15/08/2008
     IF (NEW.FILEND IS NOT NULL AND NEW.NUMEND IS NOT NULL) THEN
         bVerifica:=true;
     END IF;
  END IF;

  IF (TG_OP = 'UPDATE') THEN -- 64504 - Igor - 15/08/2008
     IF (NEW.FILEND IS NOT NULL AND NEW.NUMEND IS NOT NULL) AND
        (Equal(OLD.FILEND,NEW.FILEND) <> 1 OR Equal(OLD.NUMEND,NEW.NUMEND) <> 1)  THEN
         bVerifica:=true;
     END IF;
  END IF;


  IF bVerifica THEN -- 64504 - Igor - 15/08/2008
      SELECT ORC.FILCLI, ORC.CODCLI
        INTO cFILCLI, cCODCLI
        FROM TT_ORC ORC
       WHERE CODFIL =NEW.CODFIL
         AND TIPPED =NEW.TIPPED
         AND NUMPED =NEW.NUMPED;

        SELECT COUNT(*) INTO vENDE
          FROM TT_END
         WHERE FILCLI=cFILCLI
           AND CODCLI=cCODCLI
           AND CODFIL=NEW.FILEND
           AND NUMEND=NEW.NUMEND;
      if (vENDE =0) then  --  Validar se existe endereo
             RAISE EXCEPTION 'PG-20057 Endereo inexistente. %' , vComplemento;
      END IF;
  END IF;

  IF (TG_OP = 'UPDATE') THEN

    -- DN45460 Tratamento OS
    IF Equal(OLD.TIPPGT,NEW.TIPPGT) <> 1 AND
       (OLD.TIPPGT='F' or NEW.TIPPGT='F') THEN

         SELECT ORC.FILCLI, ORC.CODCLI, CFG.CC_WORKFLOW, vc_filcli, vc_codcli
             INTO cFILCLI, cCODCLI, cTIPCCC, cVC_FILCLI, cVC_CODCLI
            FROM TT_ORC ORC CROSS JOIN TT_CFG CFG
           WHERE CODFIL =NEW.CODFIL
             AND TIPPED =NEW.TIPPED
             AND NUMPED =NEW.NUMPED;

       select * into QuemLogou from DadosLogon();

       IF cTIPCCC is null then
             RAISE EXCEPTION 'PG-20023 Para realizar um faturamento de OS  necessrio configurar uma conta de faturamento de WF, no Config em Ambiente->C/C. %' , vComplemento;
       END IF;

       IF cFILCLI=cVC_FILCLI and cCODCLI=cVC_CODCLI then
             RAISE EXCEPTION 'PG-20024 No  permitido faturar para o cliente venda ao consumidor. %' , vComplemento;
       END IF;

       IF NEW.TIPPGT='F' THEN
          INSERT INTO TT_CCC (CODFIL,FILUSU,CODUSU,FILCLI,CODCLI,
                              NUMDOC,DATOPE,TIPCCC,VLRLAN,COMPLE,STATUS,
                              FILPED,TIPPED,NUMPED,ITEPED,TIPLAN)
          VALUES (NEW.CODFIL, QuemLogou.FILUSU, QuemLogou.CODUSU, cFILCLI, cCODCLI,
                  NEW.NUMPED,AGORA(),cTIPCCC,NEW.VLRITE*-1,'Fatura referente a OS','A',
                  NEW.CODFIL, NEW.TIPPED, NEW.NUMPED, NEW.NUMITE,'O');
       END IF;
       IF OLD.TIPPGT='F' THEN
          INSERT INTO TT_CCC (CODFIL,FILUSU,CODUSU,FILCLI,CODCLI,
                              NUMDOC,DATOPE,TIPCCC,VLRLAN,COMPLE,STATUS,
                              FILPED,TIPPED,NUMPED,ITEPED,TIPLAN)
          VALUES (NEW.CODFIL, QuemLogou.FILUSU, QuemLogou.CODUSU, cFILCLI, cCODCLI,
                  NEW.NUMPED,AGORA(),cTIPCCC,OLD.VLRITE,'Fatura referente a OS','A',
                  OLD.CODFIL, OLD.TIPPED, OLD.NUMPED, OLD.NUMITE,'O');
       END IF;
    END IF;

    -- Douglas - 80744
    IF ISNULL(OLD.FILIVE)='T' AND ISNOTNULL(NEW.FILIVE)='T' THEN
       INSERT INTO TT_IVEXIOR (CODFIL, FILIVE, SEQIVE, NUMIVE, FILPED, TIPPED, NUMPED, NUMITE)
       SELECT NEW.CODFIL, NEW.FILIVE, NEW.SEQIVE, NEW.NUMIVE, NEW.CODFIL, NEW.TIPPED, NEW.NUMPED, NEW.NUMITE
         FROM DUAL
        WHERE NOT EXISTS (SELECT 1 AS OK
                            FROM TT_IVEXIOR SUB
                           WHERE SUB.FILIVE = NEW.FILIVE
                             AND SUB.SEQIVE = NEW.SEQIVE
                             AND SUB.NUMIVE = NEW.NUMIVE);

      -- Realiza incluso da marcao de Faturamento para pedidos do E-Commerce que forem faturados pelo Checkout ou PoS
               SELECT ORC.TELEVE, ORC.FLGECO, ORC.ENVECO, ORC.NUMPED_RE INTO cTELEVE, cFLGECO, cENVECO, cNUMPED_RE
           FROM TT_ORC ORC
          WHERE ORC.CODFIL =NEW.CODFIL
            AND ORC.TIPPED =NEW.TIPPED
            AND ORC.NUMPED =NEW.NUMPED
            AND ORC.FLGEST <> 'C';
      
      IF (((cTELEVE = 'T') AND (ISNOTNULL(cFLGECO)='T')) OR
          ((cENVECO = 'T') AND (ISNOTNULL(cNUMPED_RE)='T')))
      AND (ISNOTNULL(NEW.FILIVE)='T') THEN
                     SELECT COUNT(*) INTO nVendaRegistradaCheckoutPoS
              FROM TT_IVE IVE
              JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL AND VEN.SEQUEN = IVE.SEQUEN AND VEN.NUMECF <> '000'
             WHERE IVE.CODFIL = NEW.FILIVE
               AND IVE.SEQUEN = NEW.SEQIVE
               AND IVE.NUMITE = NEW.NUMIVE;
                  -- Caso encontre a Venda e a emisso no tenho sido pelo CommerceWeb inclui indicador de Faturamento
         IF (nVendaRegistradaCheckoutPoS <> 0) THEN
            INSERT INTO TT_ORC_ECO (FILORC, TIPORC, NUMORC, FLGECO, DATOPE)
                           (SELECT NEW.CODFIL, NEW.TIPPED, NEW.NUMPED, 'V', Agora()
                              FROM DUAL
                             WHERE NOT EXISTS(SELECT 1 AS OK 
                                                FROM TT_ORC_ECO ECO 
                                               WHERE ECO.FILORC = NEW.CODFIL AND ECO.TIPORC = NEW.TIPPED
                                                 AND ECO.NUMORC = NEW.NUMPED AND ECO.FLGECO = 'V'
                                              ));
         END IF;
      END IF;
    END IF;

    IF ISNOTNULL(OLD.FILIVE)= 'T' AND ISNULL(NEW.FILIVE)= 'T' THEN
       DELETE FROM TT_IVEXIOR
        WHERE FILIVE = OLD.FILIVE
          AND SEQIVE = OLD.SEQIVE
          AND NUMIVE = OLD.NUMIVE
          AND FILPED = NEW.CODFIL
          AND TIPPED = NEW.TIPPED
          AND NUMPED = NEW.NUMPED
          AND NUMITE = NEW.NUMITE;
    END IF;

  END IF;

  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
          inRec_IVExIPE.CODFIL := NEW.CODFIL;
          inRec_IVExIPE.FLGEST := NULL;
          IF  (TG_OP = 'INSERT') THEN
              -- Incluso de oramento que gera encomenda
              IF  (NEW.FLGENC = 'T')
              AND (ISNULL(NEW.FILORI) = 'T') THEN
                  inRec_IVExIPE.FLGEST := 'I';
              END IF;
          ELSE
              -- Oramento passou a gerar encomenda
              IF  (Equal(OLD.FLGENC,NEW.FLGENC) <> 1)
              AND (NEW.FLGENC = 'T') THEN
                  inRec_IVExIPE.FLGEST := 'I';
              ELSIF (Equal(OLD.FLGEST,NEW.FLGEST) <> 1)
                AND (NEW.FLGENC = 'T')
                AND (NEW.FLGEST = 'C') THEN
                    inRec_IVExIPE.FLGEST := 'C';
              ELSIF (Equal(OLD.QTDITE,NEW.QTDITE) <> 1)
                AND (NEW.QTDITE > OLD.QTDITE)
                AND (NEW.FLGENC = 'T') THEN

                  SELECT COUNT(*)
                    INTO iTEM_PEDIDO
                    FROM TT_IVEXIPE ENC
                   WHERE ENC.FILPED = NEW.CODFIL
                     AND ENC.TIPPED = NEW.TIPPED
                     AND ENC.NUMPED = NEW.NUMPED
                     AND ENC.NUMITE = NEW.NUMITE
                     AND ENC.FILIPE IS NOT NULL
                     AND ENC.FLGEST <> 'C';

                  IF iTEM_PEDIDO > 0 THEN
                     RAISE EXCEPTION 'PG-20030 No  permitido aumentar a quantidade de uma encomenda que esteja vinculada a um pedido. %' , vComplemento;
                  END IF;
              END IF;
          END IF;
          inRec_IVExIPE.QTDENC := ABS(NEW.QTDITE);
          inRec_IVExIPE.FILMAT := NEW.FILMAT;
          inRec_IVExIPE.CODMAT := NEW.CODMAT;
          inRec_IVExIPE.CODCOR := NEW.CODCOR;
          inRec_IVExIPE.CODTAM := NEW.CODTAM;
          inRec_IVExIPE.FILPED := NEW.CODFIL;
          inRec_IVExIPE.TIPPED := NEW.TIPPED;
          inRec_IVExIPE.NUMPED := NEW.NUMPED;
          inRec_IVExIPE.NUMITE := NEW.NUMITE;
          inRec_IVExIPE.FILIVE := NULL;
          inRec_IVExIPE.SEQIVE := NULL;
          inRec_IVExIPE.NUMIVE := NULL;
          IF inRec_IVExIPE.FLGEST IS NOT NULL THEN
              cDUMMY := PC_IVExIPE_UPDATE(inRec_IVExIPE.CODFIL,
                                          inRec_IVExIPE.FILIVE,
                                          inRec_IVExIPE.SEQIVE,
                                          inRec_IVExIPE.NUMIVE,
                                          inRec_IVExIPE.FLGEST,
                                          inRec_IVExIPE.QTDENC,
                                          inRec_IVExIPE.FILMAT,
                                          inRec_IVExIPE.CODMAT,
                                          inRec_IVExIPE.CODCOR,
                                          inRec_IVExIPE.CODTAM,
                                          inRec_IVExIPE.FILPED,
                                          inRec_IVExIPE.TIPPED,
                                          inRec_IVExIPE.NUMPED,
                                          inRec_IVExIPE.NUMITE);
          END IF;

      -- No executa a package quando item estiver cancelado
      IF (TG_OP = 'DELETE') THEN
         cFLGEST := OLD.FLGEST;
      ELSE
         cFLGEST := NEW.FLGEST;
      END IF;

      IF cFLGEST <> 'C' THEN
                     
              cDUMMY := PC_IOR_IVO_UPDATE(NEW.CODFIL,NEW.TIPPED,NEW.NUMPED,NEW.NUMITE);
                           END IF;

      
      IF ISNOTNULL(NEW.FILIVE) = 'T' THEN
              -- RFMP 78580 - Em Oracle as IVOs continuam sendo criadas pelo CRIA_SEPARACAO
        --        --              
             cDUMMY := PC_IVE_IVO_UPDATE(NEW.FILIVE,NEW.SEQIVE,NEW.NUMIVE);
                   --      
      END IF;
      
  END IF;

  --57914

  WK_CODUID := GetCoduidAtual();

  -- Pedro E. Braga - 93400 - Gera Log PAF-ECF
  -- Pegando usurio
  SELECT FILUSU, CODUSU INTO cFILUSU, cCODUSU
    FROM TT_USU
   WHERE APEUSU = QUALDONO();

  IF (TG_OP = 'INSERT') THEN
        INSERT INTO TL_IOR_PAF ( CODFIL, TIPPED, NUMPED, NUMITE, TIPLOG, INDCAN,
                               FILMAT, CODMAT, CODCOR, CODTAM,
                               QTDITE, VLRITE, DESCON, VLRPGT,
                               FILUSU, CODUSU, CODUID, NUMCRE, ORICRE)
                      VALUES ( NEW.CODFIL, NEW.TIPPED, NEW.NUMPED, NEW.NUMITE, 'I', 'F',
                               NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM,
                               NEW.QTDITE, NEW.VLRITE, COALESCE(NEW.DESCON, 0), NEW.VLRPGT,
                               COALESCE(NEW.FILUSU, cFILUSU), COALESCE(NEW.CODUSU, cCODUSU), NEW.CODUID, NEW.NUMCRE, NEW.ORICRE );
  END IF;
  
   IF (TG_OP = 'UPDATE') THEN
      -- MN - 2021015062 - Ao cancelar um item do oramento, cancela tambm a TT_IVO vincula aquele item, a menos que a TT_IVO esteja como separada ou como Devolvida
      -- No pode cancelar ivo a devolver, porque o operador tem que fazer a devoluo, mesmo que o oramento tenha sido reaberto
      IF (OLD.FLGEST <> 'C') AND (NEW.FLGEST = 'C') THEN
         UPDATE TT_IVO 
            SET FLGEST = 'C'
          WHERE FILPED = NEW.CODFIL
            AND TIPPED = NEW.TIPPED
            AND NUMPED = NEW.NUMPED
            AND NUMITE = NEW.NUMITE
            AND FLGEST NOT IN ('P','D');
      END IF;
   END IF;

  IF (TG_OP = 'UPDATE') THEN

     IF Equal(OLD.QTDITE,NEW.QTDITE) <> 1 THEN
        cLog := cLog||'Quantidade Item: de '||COALESCE(OLD.QTDITE,iNulo)||' para '||COALESCE(NEW.QTDITE,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.QTDENT,NEW.QTDENT) <> 1 THEN
        cLog := cLog||'Quantidade Entrega: de '||COALESCE(OLD.QTDENT,iNulo)||' para '||COALESCE(NEW.QTDENT,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.VLRITE,NEW.VLRITE) <> 1 THEN
        cLog := cLog||'Valor Item: de '||COALESCE(OLD.VLRITE,iNulo)||' para '||COALESCE(NEW.VLRITE,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.VLRENT,NEW.VLRENT) <> 1 THEN
        cLog := cLog||'Valor Entrega: de '||COALESCE(OLD.VLRENT,iNulo)||' para '||COALESCE(NEW.VLRENT,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.TIPENT,NEW.TIPENT) <> 1 THEN
        cLog := cLog||'Tipo Entrega: de '||COALESCE(OLD.TIPENT,cNulo)||' para '||COALESCE(NEW.TIPENT,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.FILIVE,NEW.FILIVE) <> 1
     OR Equal(OLD.SEQIVE,NEW.SEQIVE) <> 1
     OR Equal(OLD.NUMIVE,NEW.NUMIVE) <> 1 THEN
        cLog := cLog||'Vnculo: de '||COALESCE(OLD.FILIVE||'/'||OLD.SEQIVE||'-'||OLD.NUMIVE,cNulo)||' para '||COALESCE(NEW.FILIVE||'/'||NEW.SEQIVE||'-'||NEW.NUMIVE,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.FILLOT,NEW.FILLOT) <> 1 OR
         Equal(OLD.SEQLOT,NEW.SEQLOT) <> 1) THEN
        cLog := cLog||'Lote: de '||COALESCE(OLD.FILLOT||'/'||TRIM(OLD.SEQLOT),cNulo)||' para '||COALESCE(NEW.FILLOT||'/'||TRIM(NEW.SEQLOT),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.VLRFRE,NEW.VLRFRE) <> 1 THEN
        cLog := cLog||' Valor do Frete: de '||COALESCE(OLD.VLRFRE,iNulo)||' para '||COALESCE(NEW.VLRFRE,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.SUBFRE,NEW.SUBFRE) <> 1 THEN
        cLog := cLog||' % Subsdio Frete: de '||COALESCE(OLD.SUBFRE,iNulo)||' para '||COALESCE(NEW.SUBFRE,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.ICMTIP,NEW.ICMTIP) <> 1 THEN
        cLog := cLog||'Tributao: de '||COALESCE(OLD.ICMTIP,cNulo)||' para '||COALESCE(NEW.ICMTIP,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DESRAT,NEW.DESRAT) <> 1 THEN
        cLog := cLog||'Desc/Acrsc Rateado: de '||COALESCE(OLD.DESRAT,iNulo)||' para '||COALESCE(NEW.DESRAT,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.VLRSEG,NEW.VLRSEG) <> 1 THEN
        cLog := cLog||'Valor do Seguro: de '||COALESCE(OLD.VLRSEG,iNulo)||' para '||COALESCE(NEW.VLRSEG,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.BASIPI,NEW.BASIPI) <> 1 THEN
        cLog := cLog||'Base de IPI: de '||COALESCE(OLD.BASIPI,iNulo)||' para '||COALESCE(NEW.BASIPI,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.VLRIPI,NEW.VLRIPI) <> 1 THEN
        cLog := cLog||'Valor de IPI: de '||COALESCE(OLD.VLRIPI,iNulo)||' para '||COALESCE(NEW.VLRIPI,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.FILILI,NEW.FILILI) <> 1 THEN
        cLog := cLog||'Filial Presente: de '||COALESCE(OLD.FILILI,cNulo)||' para '||COALESCE(NEW.FILILI,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SEQILI,NEW.SEQILI) <> 1 THEN
       cLog := cLog||'Seq Presente: de '||COALESCE(OLD.SEQILI,cNulo)||' para '||COALESCE(NEW.SEQILI,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.NUMILI,NEW.NUMILI) <> 1 THEN
        cLog := cLog||'Item Presente: de '||COALESCE(TO_CHAR(OLD.NUMILI),cNulo)||' para '||COALESCE(TO_CHAR(NEW.NUMILI),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.PROSUG,NEW.PROSUG) <> 1 THEN
        cLog := cLog||'Produto sugerido?: de '||COALESCE(OLD.PROSUG,cNulo)||' para '||COALESCE(NEW.PROSUG,cNulo)||CRLF;
     END IF;
     --  96087
     IF Equal(OLD.CUSPRO,NEW.CUSPRO) <> 1 THEN
        cLog := cLog||'Custo Produto: de '||COALESCE(OLD.CUSPRO,iNulo)||' para '||COALESCE(NEW.CUSPRO,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.BASPIS,NEW.BASPIS) <> 1 THEN
        cLog := cLog||'Base PIS: de '||COALESCE(OLD.BASPIS,iNulo)||' para '||COALESCE(NEW.BASPIS,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.BASCOF,NEW.BASCOF) <> 1 THEN
        cLog := cLog||'Base COFINS: de '||COALESCE(OLD.BASCOF,iNulo)||' para '||COALESCE(NEW.BASCOF,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.VLRPIS,NEW.VLRPIS) <> 1 THEN
        cLog := cLog||'Valor PIS: de '||COALESCE(OLD.VLRPIS,iNulo)||' para '||COALESCE(NEW.VLRPIS,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.VLRCOF,NEW.VLRCOF) <> 1 THEN
        cLog := cLog||'Valor COFINS: de '||COALESCE(OLD.VLRCOF,iNulo)||' para '||COALESCE(NEW.VLRCOF,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.VLRIRR,NEW.VLRIRR) <> 1 THEN
        cLog := cLog||'Valor IRRF: de '||COALESCE(OLD.VLRIRR,iNulo)||' para '||COALESCE(NEW.VLRIRR,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.VLRSOC,NEW.VLRSOC) <> 1 THEN
        cLog := cLog||'Valor Contribuio Social: de '||COALESCE(OLD.VLRSOC,iNulo)||' para '||COALESCE(NEW.VLRSOC,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.VLRCOM,NEW.VLRCOM) <> 1 THEN
        cLog := cLog||'Valor Comisso: de '||COALESCE(OLD.VLRCOM,iNulo)||' para '||COALESCE(NEW.VLRCOM,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.VLROPE,NEW.VLROPE) <> 1 THEN
        cLog := cLog||'Valor Despesas Operacionais: de '||COALESCE(OLD.VLROPE,iNulo)||' para '||COALESCE(NEW.VLROPE,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.VLROPEFIX,NEW.VLROPEFIX) <> 1 THEN
        cLog := cLog||'Valor Despesas Operacionais Fixas: de '||COALESCE(OLD.VLROPEFIX,iNulo)||' para '||COALESCE(NEW.VLROPEFIX,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.VLRLUC,NEW.VLRLUC) <> 1 THEN
        cLog := cLog||'Valor Lucro: de '||COALESCE(OLD.VLRLUC,iNulo)||' para '||COALESCE(NEW.VLRLUC,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.PERLUC,NEW.PERLUC) <> 1 THEN
        cLog := cLog||'Percentual de Lucro: de '||COALESCE(OLD.PERLUC,iNulo)||' para '||COALESCE(NEW.PERLUC,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.CUSMAR,NEW.CUSMAR) <> 1 THEN
        cLog := cLog||'Custo Markup: de '||COALESCE(OLD.CUSMAR,iNulo)||' para '||COALESCE(NEW.CUSMAR,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.TIPDET,NEW.TIPDET) <> 1 THEN
        cLog := cLog||'Tipo de Detalhe do Produto: de '||COALESCE(DescricaoDominio('IOR','TIPDET',OLD.TIPDET),cNulo)||' para '||COALESCE(DescricaoDominio('IOR','TIPDET',NEW.TIPDET),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SUBTSF,NEW.SUBTSF) <> 1 THEN
        cLog := cLog||'% de Subsdio da Tabela de Subsdios de Frete: de '||COALESCE(OLD.SUBTSF,iNulo)||' para '||COALESCE(NEW.SUBTSF,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.PEROPEFIX,NEW.PEROPEFIX) <> 1 THEN
        cLog := cLog||'% Despesas Operacionais Fixas: de '||COALESCE(TO_CHAR(OLD.PEROPEFIX,'fm990D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PEROPEFIX,'fm990D0000'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.PERMCP,NEW.PERMCP) <> 1 THEN
        cLog := cLog||'% Margem de Contribuio do Produto: de '||COALESCE(TO_CHAR(OLD.PERMCP,'fm990D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERMCP,'fm990D0000'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.VLRMCP,NEW.VLRMCP) <> 1 THEN
        cLog := cLog||'Valor Margem de Contribuio do Produto: de '||COALESCE(TO_CHAR(OLD.VLRMCP,'fm9G999G999G990D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRMCP,'fm9G999G999G990D0000'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.PERMCO,NEW.PERMCO) <> 1 THEN
        cLog := cLog||'% Margem de Contribuio no Oramento: de '||COALESCE(TO_CHAR(OLD.PERMCO,'fm990D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERMCO,'fm990D0000'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.VLRMCO,NEW.VLRMCO) <> 1 THEN
        cLog := cLog||'Valor Margem de Contribuio no Oramento: de '||COALESCE(TO_CHAR(OLD.VLRMCO,'fm9G999G999G990D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRMCO,'fm9G999G999G990D0000'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.PERENT,NEW.PERENT) <> 1 THEN
        cLog := cLog||'Perodo da Entrega: de '||COALESCE(DescricaoDominio('IOR','PERENT',OLD.PERENT),cNulo)||' para '||COALESCE(DescricaoDominio('IOR','PERENT',NEW.PERENT),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SIGNAT,NEW.SIGNAT) <> 1 THEN
        cLog := cLog||'Controle de "lock": de '||COALESCE(TO_CHAR(OLD.SIGNAT,'fm99990'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.SIGNAT,'fm99990'),cNulo)||CRLF;
     END IF;
     -- Manoel - 101807 - Tentar identificar problema de gerar problema de transf. automatica
     IF Equal(OLD.FILRES,NEW.FILRES) <> 1 THEN
        cLog := cLog||'Filial Reserva: de '||COALESCE(OLD.FILRES, cNulo)||' para '||COALESCE(NEW.FILRES, cNulo)||CRLF;
     END IF;
     IF Equal(OLD.GARANT,NEW.GARANT) <> 1 THEN
        cLog := cLog||'Na Garantia?: de '||COALESCE(OLD.GARANT,cNulo)||' para '||COALESCE(NEW.GARANT,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
        cLog := cLog||'Situao: de '||COALESCE(DescricaoDominio('IOR','FLGEST',OLD.FLGEST),cNulo)||' para '||COALESCE(DescricaoDominio('IOR','FLGEST',NEW.FLGEST),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.NUMCRE,NEW.NUMCRE) <> 1 THEN
        cLog := cLog||'Contador de Requisio Externa: de '||COALESCE(OLD.NUMCRE,cNulo)||' para '||COALESCE(NEW.NUMCRE,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.ORICRE,NEW.ORICRE) <> 1 THEN
        cLog := cLog||'Origem da Requisio Externa: de '||COALESCE(DescricaoDominio('IOR','ORICRE',OLD.ORICRE),cNulo)||' para '||COALESCE(DescricaoDominio('IOR','ORICRE',NEW.ORICRE),cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.FILCPM,NEW.FILCPM) <> 1 OR
         Equal(OLD.SEQCPM,NEW.SEQCPM) <> 1) THEN
        cLog := cLog||'Promoo: de '||COALESCE(OLD.FILCPM||'/'||TRIM(OLD.SEQCPM),cNulo)||' para '||COALESCE(NEW.FILCPM||'/'||TRIM(NEW.SEQCPM),cNulo)||CRLF;
     END IF;
      IF Equal(OLD.NUMPEDCOM,NEW.NUMPEDCOM) <> 1 THEN
         cLOG := cLOG||'Nmero do Pedido de Compra do Cliente: de '||COALESCE(OLD.NUMPEDCOM,cNulo)||' para '||COALESCE(NEW.NUMPEDCOM,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ITEPEDCOM,NEW.ITEPEDCOM) <> 1 THEN
         cLOG := cLOG||'Item do Pedido de Compra do Cliente: de '||COALESCE(TO_CHAR(OLD.ITEPEDCOM), cNulo)||' para '||COALESCE(TO_CHAR(NEW.ITEPEDCOM), cNulo)||CRLF;
      END IF;
      IF Equal(OLD.BASINSS,NEW.BASINSS) <> 1 THEN
         cLog := cLog||'Base INSS: de '||COALESCE(TO_CHAR(OLD.BASINSS,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASINSS,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERINSS,NEW.PERINSS) <> 1 THEN
         cLog := cLog||'% INSS: de '||COALESCE(TO_CHAR(OLD.PERINSS,'fm990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERINSS,'fm990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRINSS,NEW.VLRINSS) <> 1 THEN
         cLog := cLog||'Valor INSS: de '||COALESCE(TO_CHAR(OLD.VLRINSS,'fm9G999G999G990D000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRINSS,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SITISS,NEW.SITISS) <> 1 THEN
         cLog := cLog||'Cdigo de Tributao do ISS: de '||COALESCE(DescricaoDominio('IOR','SITISS',OLD.SITISS),cNulo)||' para '||COALESCE(DescricaoDominio('IOR','SITISS',NEW.SITISS),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERREDISS,NEW.PERREDISS) <> 1 THEN
         cLog := cLog||'% Reduo ISS: de '||COALESCE(TO_CHAR(OLD.PERREDISS,'fm990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERREDISS,'fm990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERDEDISS,NEW.PERDEDISS) <> 1 THEN
         cLog := cLog||'% Deduo ISS: de '||COALESCE(TO_CHAR(OLD.PERDEDISS,'fm990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERDEDISS,'fm990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRDEDISS,NEW.VLRDEDISS) <> 1 THEN
         cLog := cLog||'Valor Deduo ISS: de '||COALESCE(TO_CHAR(OLD.VLRDEDISS,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRDEDISS,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.BASISS,NEW.BASISS) <> 1 THEN
         cLog := cLog||'Base ISS: de '||COALESCE(TO_CHAR(OLD.BASISS,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASISS,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERISS,NEW.PERISS) <> 1 THEN
         cLog := cLog||'% ISS: de '||COALESCE(TO_CHAR(OLD.PERISS,'fm990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERISS,'fm990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRISS,NEW.VLRISS) <> 1 THEN
         cLog := cLog||'Valor ISS: de '||COALESCE(TO_CHAR(OLD.VLRISS,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRISS,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRISSRET,NEW.VLRISSRET) <> 1 THEN
         cLog := cLog||'Valor ISS Retido: de '||COALESCE(TO_CHAR(OLD.VLRISSRET,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRISSRET,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.BASIRRF,NEW.BASIRRF) <> 1 THEN
         cLog := cLog||'Base IRRF para Servio: de '||COALESCE(TO_CHAR(OLD.BASIRRF,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASIRRF,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERIRRF,NEW.PERIRRF) <> 1 THEN
         cLog := cLog||'% IRRF para Servio: de '||COALESCE(TO_CHAR(OLD.PERIRRF,'fm990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERIRRF,'fm990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRIRRF,NEW.VLRIRRF) <> 1 THEN
         cLog := cLog||'Valor IRRF para Servio: de '||COALESCE(TO_CHAR(OLD.VLRIRRF,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRIRRF,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PREORICAM,NEW.PREORICAM) <> 1 THEN
         cLog := cLog||'Preo Original da Campanha: de '||COALESCE(TO_CHAR(OLD.PREORICAM,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PREORICAM,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PREMANCAM,NEW.PREMANCAM) <> 1 THEN
        cLog := cLog||'Preo Manual na Campanha?: de '||COALESCE(OLD.PREMANCAM,cNulo)||' para '||COALESCE(NEW.PREMANCAM,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRSUB,NEW.VLRSUB) <> 1 THEN
         cLog := cLog||'Valor de Substituio: de '||COALESCE(TO_CHAR(OLD.VLRSUB,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRSUB,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;

     IF ISNOTNULL(cLog) = 'T' THEN
       cLog := 'ITEM '||NEW.NUMITE||' >> '||CRLF||cLog;
       select * into QuemLogou from DadosLogon();
      INSERT INTO TL_ORC (CODFIL,TIPPED,NUMPED,TIPLOG,DATOPE,MSGLOG)
                  VALUES (NEW.CODFIL,NEW.TIPPED,NEW.NUMPED,'D',Agora(),cLog);
     END IF;


  END IF;



 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4351 --*/
CREATE TRIGGER TGIOR3
AFTER INSERT OR UPDATE OR DELETE ON TT_IOR 
FOR EACH ROW EXECUTE PROCEDURE TGIOR3();


/*-- SEQ 4352 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIOR_ASS() CASCADE;

/*-- SEQ 4353 --*/
CREATE OR REPLACE FUNCTION TGIOR_ASS() RETURNS TRIGGER AS $$
-- 83073
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN

  IF ExisteFilialNaUF('SC') THEN
     IF (TG_OP = 'INSERT') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG + 1
        WHERE NOMTAB = 'TT_IOR';
     END IF;

     IF (TG_OP = 'DELETE') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG - 1
        WHERE NOMTAB = 'TT_IOR';
     END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4354 --*/
CREATE TRIGGER TGIOR_ASS
AFTER INSERT OR DELETE ON TT_IOR 
FOR EACH ROW EXECUTE PROCEDURE TGIOR_ASS();


/*-- SEQ 4355 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIORXCPR() CASCADE;

/*-- SEQ 4356 --*/
CREATE OR REPLACE FUNCTION TGIORXCPR() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Controlar Datas e Sequenciadores

-- Principal
BEGIN
  -- Gera codigo sequencial exclusivo
  IF NEW.ID_OXC IS NULL THEN
    NEW.ID_OXC := TO_NUMBER(TRIM(ProximoCodigo('TT_IORXCPR',COALESCE(NEW.FILCPR, NEW.FILIOR))));
  END IF; 


 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4357 --*/
CREATE TRIGGER TGIORXCPR
BEFORE INSERT OR UPDATE ON TT_IORXCPR 
FOR EACH ROW EXECUTE PROCEDURE TGIORXCPR();


/*-- SEQ 4358 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIORXDET() CASCADE;

/*-- SEQ 4359 --*/
CREATE OR REPLACE FUNCTION TGIORXDET() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
   -- Trata dados padroes na inclusao
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN:=ProximoCodigo('TT_IORXDET',NEW.CODFIL);
      END IF;
      -- "default"
      NEW.DATINC := AGORA();
   END IF;

   IF (TG_OP = 'INSERT') 
   OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := AGORA();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4360 --*/
CREATE TRIGGER TGIORXDET
BEFORE INSERT OR UPDATE ON TT_IORXDET 
FOR EACH ROW EXECUTE PROCEDURE TGIORXDET();


/*-- SEQ 4361 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIORXIVE() CASCADE;

/*-- SEQ 4362 --*/
CREATE OR REPLACE FUNCTION TGIORXIVE() RETURNS TRIGGER AS $$
DECLARE
-- Tabela de Item de Venda sem Oramento Inserido
-- Objetivo:
-- 2) Atualiza DATINC

-- Principal
BEGIN
  IF (TG_OP = 'INSERT') THEN
    NEW.DATINC := AGORA();
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4363 --*/
CREATE TRIGGER TGIORXIVE
BEFORE INSERT ON TM_IORXIVE 
FOR EACH ROW EXECUTE PROCEDURE TGIORXIVE();


/*-- SEQ 4364 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIPC() CASCADE;

/*-- SEQ 4365 --*/
CREATE OR REPLACE FUNCTION TGIPC() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impede excluso.
-- 2. Gerar um cdigo sequencial exclusivo para compor a chave primria.
-- 3. Atualiza controles de data.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Impede excluso.
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20000 Registro no pode ser excludo. %' , COMPLEMENTO;
   END IF;

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF COALESCE(NEW.ID_IPC,0) = 0 THEN
         SELECT NEXTVAL('SQIPC') INTO NEW.ID_IPC FROM DUAL;
      END IF;
      NEW.DATINC := Agora();
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4366 --*/
CREATE TRIGGER TGIPC
BEFORE INSERT OR UPDATE OR DELETE ON TT_IPC 
FOR EACH ROW EXECUTE PROCEDURE TGIPC();

/*-- SEQ 4367 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIPC2() CASCADE;

/*-- SEQ 4368 --*/
CREATE OR REPLACE FUNCTION TGIPC2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4369 --*/
CREATE TRIGGER TGIPC2
AFTER INSERT OR UPDATE OR DELETE ON TT_IPC 
FOR EACH ROW EXECUTE PROCEDURE TGIPC2();


/*-- SEQ 4370 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIPE2() CASCADE;

/*-- SEQ 4371 --*/
CREATE OR REPLACE FUNCTION TGIPE2() RETURNS TRIGGER AS $$
DECLARE

  -- Objetivo
  -- 1) Manter o mesmo codigo de moeda tanto para o pedido quanto para seus itens
  -- 2) Gerar um sequenciador que ir compor uma chave alternativa

achou                         INTEGER;
   saldo_can                     TT_PED.QTDTOT%TYPE;
   MOEDA                         TD_MOE.CODTAB%TYPE;
   vFILLOT                       TT_LOT.CODFIL%TYPE;
   vSEQLOT                       TT_LOT.SEQUEN%TYPE;

   vComplemento                  CONSTANT VARCHAR(100) := constante('complemento');
   vModificou                    BOOLEAN;

  -- Principal
BEGIN
   -- RFMP 75328
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      IF NEW.ORDITE IS NULL THEN
         NEW.ORDITE := NEW.NUMITE;
      END IF;
   END IF;
   

   IF (TG_OP = 'INSERT') AND (NEW.FLGEST = 'C')  THEN
         SELECT PED.QTDTOT - SUM(IPE.QTDCAN) INTO saldo_can
           FROM TT_PED PED 
     INNER JOIN TT_IPE IPE ON PED.CODFIL = IPE.CODFIL AND PED.NUMPED = IPE.NUMPED           
          WHERE IPE.FLGEST = 'C'                                         
            AND PED.CODFIL = NEW.CODFIL
            AND PED.NUMPED = NEW.NUMPED
          GROUP BY PED.QTDTOT;
          
      IF saldo_can<0 THEN
         RAISE EXCEPTION 'PG-20023 A quantidade de itens cancelados  maior do que a quantidade pedida. %' , vComplemento;
      END IF;
   END IF;   
   
   IF (TG_OP = 'UPDATE') THEN
      IF (Equal(OLD.CODFIL,NEW.CODFIL) = 0)  OR
         (Equal(NEW.NUMPED,NEW.NUMPED) = 0)  THEN
         RAISE EXCEPTION 'PG-20023 Item de pedido nao pode mudar de pedido. %' , vComplemento;
      END IF;
   END IF;

   IF NOT (TG_OP = 'DELETE') THEN
      IF NEW.DUMMY IS NULL THEN
         SELECT COUNT(*) INTO achou
           FROM TT_PED
          WHERE EXPORT = 'T'
            AND CODFIL = NEW.CODFIL
            AND NUMPED = NEW.NUMPED;

      IF achou > 0 THEN
         IF (TG_OP = 'UPDATE') THEN
            IF (Equal(OLD.CODFIL,NEW.CODFIL) <> 1) OR
               (Equal(OLD.NUMPED,NEW.NUMPED) <> 1) OR
               (Equal(OLD.NUMITE,NEW.NUMITE) <> 1) OR
               (Equal(OLD.FILMAT,NEW.FILMAT) <> 1) OR
               (Equal(OLD.CODMAT,NEW.CODMAT) <> 1) OR
               (Equal(OLD.CODCOR,NEW.CODCOR) <> 1) OR
               (Equal(OLD.CODTAM,NEW.CODTAM) <> 1) OR
               (Equal(OLD.DATREB,NEW.DATREB) <> 1) OR
               (Equal(OLD.QTDITE,NEW.QTDITE) <> 1) OR
               (Equal(OLD.VLRITE,NEW.VLRITE) <> 1) OR
               (Equal(OLD.QTDCAN,NEW.QTDCAN) <> 1) OR
               (Equal(OLD.QTDENT,NEW.QTDENT) <> 1) OR
               (Equal(OLD.IPIITE,NEW.IPIITE) <> 1) OR
               (Equal(OLD.VLRVEN,NEW.VLRVEN) <> 1) OR
               (Equal(OLD.CODMOE,NEW.CODMOE) <> 1) OR
               (Equal(OLD.CODBUS,NEW.CODBUS) <> 1) OR
               (Equal(OLD.ICMITE,NEW.ICMITE) <> 1) OR
               (Equal(OLD.VLRICM,NEW.VLRICM) <> 1) OR
               (Equal(OLD.BASICM,NEW.BASICM) <> 1) OR
               (Equal(OLD.OUTICM,NEW.OUTICM) <> 1) OR
               (Equal(OLD.ISEICM,NEW.ISEICM) <> 1) OR
               (Equal(OLD.VLRDES,NEW.VLRDES) <> 1) OR
               (Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1) OR
               (Equal(OLD.FILENT,NEW.FILENT) <> 1) OR
               (Equal(OLD.UNICOM,NEW.UNICOM) <> 1) OR
               (Equal(OLD.UNIVEN,NEW.UNIVEN) <> 1) OR
               (Equal(OLD.VALCON,NEW.VALCON) <> 1) OR
               (Equal(OLD.ITEORI,NEW.ITEORI) <> 1) OR               
               (Equal(OLD.QTDPED,NEW.QTDPED) <> 1) OR
               (Equal(OLD.VLRUNI,NEW.VLRUNI) <> 1) OR               
               (Equal(OLD.CODMUL,NEW.CODMUL) <> 1) THEN
               RAISE EXCEPTION 'PG-20023 Esse item pertence a um pedido encerrado. Nao pode haver modificacoes. %' , vComplemento;
            END IF;
         ELSE
            RAISE EXCEPTION 'PG-20023 Esse item pertence a um pedido encerrado. Nao pode haver modificacoes. %' , vComplemento;
         END IF;
      END IF;
      END IF;
   END IF;

   IF (TG_OP = 'INSERT') THEN
      IF (NEW.SEQUEN is null) THEN
         NEW.SEQUEN := ProximoCodigo('TT_IPE',NEW.CODFIL);
      END IF;
   END IF;


   vModificou := False;
   IF (TG_OP = 'UPDATE') THEN
      IF (OLD.CODMOE <> NEW.CODMOE) AND (NEW.DUMMY IS NULL) THEN
         vModificou := True;
      END IF;
   END IF;

   IF NOT (TG_OP = 'DELETE') THEN
   
      -- Fator de Converso deve ter valor superior a zero
      IF (COALESCE(NEW.VALCON, 0) <= 0) THEN
         NEW.VALCON := 1;
      END IF;
   
      -- Verifica as condicoes para nao checar TT_PED
      IF ((TG_OP = 'INSERT') AND (NEW.DUMMY IS NULL)) OR vModificou THEN
         -- Obtem o codigo da moeda existente no pedido
         SELECT CODMOE INTO MOEDA
           FROM TT_PED
          WHERE CODFIL = NEW.CODFIL AND NUMPED = NEW.NUMPED;

         -- Impede que a moeda do item seja diferente do pedido
         IF (NEW.CODMOE IS NULL) or (MOEDA <> NEW.CODMOE) THEN
            NEW.CODMOE := MOEDA;
         END IF;
      END IF;

      -- Faz o papel de uma "foreign key"
      IF ((NEW.FILICO IS NOT NULL) OR
         (NEW.SEQICO IS NOT NULL) OR
         (NEW.NUMICO IS NOT NULL)) THEN

         vModificou := False;
         IF (TG_OP = 'UPDATE') THEN
            IF (Equal(OLD.FILICO,NEW.FILICO) = 0) OR
               (Equal(OLD.SEQICO,NEW.SEQICO) = 0) OR
               (Equal(OLD.NUMICO,NEW.NUMICO) = 0) THEN
               vModificou := True;
            END IF;
         END IF;

         IF (TG_OP = 'INSERT') or vModificou THEN
            Achou := TGR_IPE_Item_Existe(NEW.FILICO, NEW.SEQICO, NEW.NUMICO); /* retornos possiveis 0 e 1 E -1*/
            IF (achou = 0) then
               RAISE EXCEPTION 'PG-20022 Item de compra nao foi encontrado. %' , vComplemento;
            END IF;
         END IF; 
         
      END IF;

      -- Se todas as quantidades foram canceladas, entao o item foi cancelado
      IF Equal(NEW.QTDCAN,NEW.QTDITE) = 1 THEN
         NEW.FLGEST := 'C';
      END IF;

      IF (NEW.FLGEST = 'E')    AND
         ((NEW.FILICO IS NULL) OR
          (NEW.SEQICO IS NULL) OR
          (NEW.NUMICO IS NULL)) AND
         ((NEW.FILIVE IS NULL) OR
          (NEW.SEQIVE IS NULL) OR
          (NEW.NUMIVE IS NULL)) THEN
         RAISE EXCEPTION 'PG-20004 Para ser considerado entregue, este item precisa estar ligado a uma compra ou venda. %' , vComplemento;
      ELSIF (NEW.FLGEST = 'A') AND
            ((NEW.FILICO IS NOT NULL) OR
             (NEW.SEQICO IS NOT NULL) OR
             (NEW.NUMICO IS NOT NULL)) THEN
        RAISE EXCEPTION 'PG-20005 Para ficar em aberto, este item nao pode estar ligado a uma compra. %' , vComplemento;
      END IF;

      IF (NEW.FLGEST = 'E')    AND
         ((NEW.FILICO IS NOT NULL) OR
          (NEW.SEQICO IS NOT NULL) OR
          (NEW.NUMICO IS NOT NULL)) THEN
         -- Paulo K. - 91129 Busca a chave do lote na TT_ICO para popular na Encomenda.
         SELECT FILLOT, SEQLOT
           INTO vFILLOT, vSEQLOT
           FROM TT_ICO
          WHERE CODFIL = NEW.FILICO
            AND SEQUEN = NEW.SEQICO
            AND NUMITE = NEW.NUMICO;

          -- atualiza o qtdenc com o que foi realmente pedido
          -- caso exista diferenca entre o que foi encomendado e comprado o form de compras gera um pedido novo
          UPDATE TT_IVExIPE
             SET FLGEST = 'R',
                 QTDENC = CASE WHEN COALESCE(NEW.QTDENT,0) > COALESCE(QTDENC,0)
                               THEN COALESCE(QTDENC,0)
                               ELSE COALESCE(NEW.QTDENT,0)
                          END,
                 FILLOT = COALESCE(vFILLOT, NULL),
                 SEQLOT = COALESCE(vSEQLOT, NULL),
                 FILICO = NEW.FILICO,
                 SEQICO = NEW.SEQICO,
                 NUMICO = NEW.NUMICO
           WHERE FILIPE = NEW.CODFIL
             AND NUMIPE = NEW.NUMPED
             AND ITEIPE = NEW.NUMITE
             AND FLGEST NOT IN ('R', 'C');
      END IF;

      IF (NEW.FLGEST = 'C') THEN
       UPDATE TT_IVExIPE SET FILIPE = NULL, NUMIPE = NULL, ITEIPE = NULL, FLGEST = 'A'
        WHERE FILIPE = NEW.CODFIL
          AND NUMIPE = NEW.NUMPED
          AND ITEIPE = NEW.NUMITE
          AND FLGEST NOT IN ('R', 'C');

         -- Tarefa PJ7277
         UPDATE TT_IDI
            SET FILPED = NULL,
                NUMPED = NULL,
                ITEPED = NULL,
                FLGEST = 'A'
         WHERE FILPED  = NEW.CODFIL
            AND NUMPED = NEW.NUMPED
            AND ITEPED = NEW.NUMITE
            AND FLGEST NOT IN ('R', 'C');
      END IF;

   END IF;

   IF (TG_OP = 'DELETE') THEN
      -- RFMP 75392
      UPDATE TT_IVExIPE
         SET FILIPE = NULL,
             NUMIPE = NULL,
             ITEIPE = NULL,
             FLGEST = CASE WHEN FLGEST = 'E'
                           THEN 'A'
                           ELSE FLGEST
                      END
       WHERE FILIPE = OLD.CODFIL
         AND NUMIPE = OLD.NUMPED
         AND ITEIPE = OLD.NUMITE
         AND FLGEST IN ('A','C','E');
         
      -- Tarefa PJ7277
      UPDATE TT_IDI
         SET FILPED = NULL,
             NUMPED = NULL,
             ITEPED = NULL,
             FLGEST = 'A'
       WHERE FILPED = OLD.CODFIL
         AND NUMPED = OLD.NUMPED
         AND ITEPED = OLD.NUMITE
         AND FLGEST IN ('A','C','E');
   END IF;


   IF (TG_OP = 'UPDATE') THEN
      -- RFMP 75110
      -- Ao reabrir um pedido entregue atualizar encomenda tambm
      IF  (OLD.FLGEST = 'E')
      AND (NEW.FLGEST = 'A') THEN
         UPDATE TT_IVExIPE
            SET FLGEST = 'E'
          WHERE FILIPE = NEW.CODFIL
            AND NUMIPE = NEW.NUMPED
            AND ITEIPE = NEW.NUMITE
            AND FLGEST = 'R';
      END IF;
   END IF;

   IF NOT (TG_OP = 'DELETE') THEN
      -- Impede gravar o codigo negativo usado como "flag"
      NEW.DUMMY := NULL;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4372 --*/
CREATE TRIGGER TGIPE2
BEFORE INSERT OR DELETE OR UPDATE ON TT_IPE 
FOR EACH ROW EXECUTE PROCEDURE TGIPE2();


/*-- SEQ 4373 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIPE3() CASCADE;

/*-- SEQ 4374 --*/
CREATE OR REPLACE FUNCTION TGIPE3() RETURNS TRIGGER AS $$
DECLARE

  -- Objetivos
  -- 1) Fazer delete cascade com TT_DXI
  -- 2) MN - 102058 - Registrar log das tabelas TT_PED e TT_IPE
  -- Principal
  cLOG                          VARCHAR(4000)     := '';
  cNulo                         CONSTANT CHAR(4)   := 'Nulo';
  iNulo                         CONSTANT Numeric(1) := 0;
  CRLF                          CONSTANT CHAR(1)   := CHR(10);
  vItem                         CHAR(20)           := '';
  wk_coduid                     TT_UID.CODUID%TYPE;
  
    
    QuemLogou                     TRetQuemLogou%ROWTYPE;
  BEGIN

   -- Delete Cascade
   IF (TG_OP = 'DELETE') THEN
      DELETE FROM TT_DXI WHERE CODFIL=OLD.CODFIL AND SEQIPE=OLD.SEQUEN;
   END IF;
   
   IF (TG_OP = 'UPDATE') THEN     
     IF Equal(OLD.FILLOT,NEW.FILLOT) <> 1 THEN
       cLOG := cLOG||'Filial do Lote: '||COALESCE(OLD.FILLOT, cNulo)||' para '||COALESCE(NEW.FILLOT, cNulo)||CRLF;
     END IF;
     
     IF Equal(OLD.FILORI,NEW.FILORI) <> 1 THEN
       cLOG := cLOG||'Filial de Origem: de '||COALESCE(OLD.FILORI, cNulo)||' para '||COALESCE(NEW.FILORI, cNulo)||CRLF;
     END IF;
     
     IF Equal(OLD.FILIVE,NEW.FILIVE) <> 1 THEN
       cLOG := cLOG||'Filial Itens de Venda: de '||COALESCE(OLD.FILIVE, cNulo)||' para '||COALESCE(NEW.FILIVE, cNulo)||CRLF;
     END IF;
     
     IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
       cLOG := cLOG||'Situao: de '||COALESCE(DescricaoDominio('IPE','FLGEST',OLD.FLGEST),cNulo)||' para '||COALESCE(DescricaoDominio('IPE','FLGEST',NEW.FLGEST),cNulo)||CRLF;
     END IF;
     
     IF Equal(OLD.FILICO,NEW.FILICO) <> 1 THEN
       cLOG := cLOG||'Filial do item de compra: de '||COALESCE(OLD.FILICO, cNulo)||' para '||COALESCE(NEW.FILICO, cNulo)||CRLF;
     END IF;
     
     IF Equal(OLD.PEDORI,NEW.PEDORI) <> 1 THEN
       cLOG := cLOG||'Pedido de Origem: de '||COALESCE(OLD.PEDORI, cNulo)||' para '||COALESCE(NEW.PEDORI, cNulo)||CRLF;
     END IF;
     
     IF Equal(OLD.SEQICO,NEW.SEQICO) <> 1 THEN
       cLOG := cLOG||'Sequencial do item de compra: de '||COALESCE(OLD.SEQICO, cNulo)||' para '||COALESCE(NEW.SEQICO, cNulo)||CRLF;
     END IF;
     
     IF Equal(OLD.SEQLOT,NEW.SEQLOT) <> 1 THEN
       cLOG := cLOG||'Sequenciador do Lote: de '||COALESCE(OLD.SEQLOT, cNulo)||' para '||COALESCE(NEW.SEQLOT, cNulo)||CRLF;
     END IF;
     
     IF Equal(OLD.SEQIVE,NEW.SEQIVE) <> 1 THEN
       cLOG := cLOG||'Sequenciador Itens de Venda: de '||COALESCE(OLD.SEQIVE, cNulo)||' para '||COALESCE(NEW.SEQIVE, cNulo)||CRLF;
     END IF;
     
     IF Equal(OLD.DATREB, NEW.DATREB) <> 1 THEN
      cLOG := cLOG||'Data de recebimento: de '||COALESCE(TO_CHAR(OLD.DATREB,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATREB,'DD/MM/YYYY'),cNulo)||CRLF;
    END IF;

    IF Equal(OLD.FLGENC,NEW.FLGENC) <> 1 THEN
       cLOG := cLOG||'Para Encomenda?: de '||COALESCE(OLD.FLGENC, cNulo)||' para '||COALESCE(NEW.FLGENC, cNulo)||CRLF;
    END IF;  

    IF Equal(OLD.BASICM, NEW.BASICM) <> 1 THEN
      cLog := cLog || 'Base Clculo ICMS: de ' || COALESCE(OLD.BASICM, iNulo) || ' para ' || COALESCE(NEW.BASICM, iNulo) || CRLF;
    END IF;

    IF Equal(OLD.CODMUL, NEW.CODMUL) <> 1 THEN
      cLog := cLog || 'Nome do Sub-Estoque: de ' || COALESCE(OLD.CODMUL, iNulo) || ' para ' || COALESCE(NEW.CODMUL, iNulo) || CRLF;
    END IF;

    IF Equal(OLD.IPIITE, NEW.IPIITE) <> 1 THEN
      cLog := cLog || 'Percentual do IPI do item: de ' || COALESCE(OLD.IPIITE, iNulo) || ' para ' || COALESCE(NEW.IPIITE, iNulo) || CRLF;
    END IF;

    IF Equal(OLD.ITEORI, NEW.ITEORI) <> 1 THEN
      cLog := cLog || 'Item de Origem: de ' || COALESCE(OLD.ITEORI, iNulo) || ' para ' || COALESCE(NEW.ITEORI, iNulo) || CRLF;
    END IF;

    IF Equal(OLD.ICMITE, NEW.ICMITE) <> 1 THEN
      cLog := cLog || 'ICMS sobre Item: de ' || COALESCE(OLD.ICMITE, iNulo) || ' para ' || COALESCE(NEW.ICMITE, iNulo) || CRLF;
    END IF;

    IF Equal(OLD.ISEICM, NEW.ISEICM) <> 1 THEN
      cLog := cLog || 'Iseno ICMS: de ' || COALESCE(OLD.ISEICM, iNulo) || ' para ' || COALESCE(NEW.ISEICM, iNulo) || CRLF;
    END IF;

    IF Equal(OLD.NUMICO, NEW.NUMICO) <> 1 THEN
      cLog := cLog || 'Nmero do item de compra: de ' || COALESCE(OLD.NUMICO, iNulo) || ' para ' || COALESCE(NEW.NUMICO, iNulo) || CRLF;
    END IF;

    IF Equal(OLD.NUMIVE, NEW.NUMIVE) <> 1 THEN
      cLog := cLog || 'Nmero Itens de Venda: de ' || COALESCE(OLD.NUMIVE, iNulo) || ' para ' || COALESCE(NEW.NUMIVE, iNulo) || CRLF;
    END IF;

    IF Equal(OLD.OUTICM, NEW.OUTICM) <> 1 THEN
      cLog := cLog || 'Outros ICMS: de ' || COALESCE(OLD.OUTICM, iNulo) || ' para ' || COALESCE(NEW.OUTICM, iNulo) || CRLF;
    END IF;

    IF Equal(OLD.ORDITE, NEW.ORDITE) <> 1 THEN
      cLog := cLog || 'Ordem do Item no Pedido: de ' || COALESCE(OLD.ORDITE, iNulo) || ' para ' || COALESCE(NEW.ORDITE, iNulo) || CRLF;
    END IF;

    IF Equal(OLD.QTDITE, NEW.QTDITE) <> 1 THEN
      cLog := cLog || 'Quantidade Movimentada do item: de ' || COALESCE(OLD.QTDITE, iNulo) || ' para ' || COALESCE(NEW.QTDITE, iNulo) || CRLF;
    END IF;

    IF Equal(OLD.QTDPED, NEW.QTDPED) <> 1 THEN
      cLog := cLog || 'Quantidade Pedida do item: de ' || COALESCE(OLD.QTDPED, iNulo) || ' para ' || COALESCE(NEW.QTDPED, iNulo) || CRLF;
    END IF;

    IF Equal(OLD.QTDCAN, NEW.QTDCAN) <> 1 THEN
      cLog := cLog || 'Quantidade cancelada: de ' || COALESCE(OLD.QTDCAN, iNulo) || ' para ' || COALESCE(NEW.QTDCAN, iNulo) || CRLF;
    END IF;

    IF Equal(OLD.QTDENT, NEW.QTDENT) <> 1 THEN
      cLog := cLog || 'Quantidade entregue: de ' || COALESCE(OLD.QTDENT, iNulo) || ' para ' || COALESCE(NEW.QTDENT, iNulo) || CRLF;
    END IF;

    IF Equal(OLD.VLRUNI, NEW.VLRUNI) <> 1 THEN
      cLog := cLog || 'Valor Unitrio do item: de ' || COALESCE(OLD.VLRUNI, iNulo) || ' para ' || COALESCE(NEW.VLRUNI, iNulo) || CRLF;
    END IF;

    IF Equal(OLD.VLRFRE, NEW.VLRFRE) <> 1 THEN
      cLog := cLog || 'Valor Frete: de ' || COALESCE(OLD.VLRFRE, iNulo) || ' para ' || COALESCE(NEW.VLRFRE, iNulo) || CRLF;
    END IF;

    IF Equal(OLD.VLRITE, NEW.VLRITE) <> 1 THEN
      cLog := cLog || 'Valor do item: de ' || COALESCE(OLD.VLRITE, iNulo) || ' para ' || COALESCE(NEW.VLRITE, iNulo) || CRLF;
    END IF;

    IF Equal(OLD.VLRVEN, NEW.VLRVEN) <> 1 THEN
      cLog := cLog || 'Valor de venda do item: de ' || COALESCE(OLD.VLRVEN, iNulo) || ' para ' || COALESCE(NEW.VLRVEN, iNulo) || CRLF;
    END IF;

    IF Equal(OLD.VLRICM, NEW.VLRICM) <> 1 THEN
      cLog := cLog || 'Valor ICMS: de ' || COALESCE(OLD.VLRICM, iNulo) || ' para ' || COALESCE(NEW.VLRICM, iNulo) || CRLF;
    END IF;

    IF Equal(OLD.VALCON, NEW.VALCON) <> 1 THEN
      cLog := cLog || 'Valor de converso entre as unidades de Venda/Compra: de ' || COALESCE(OLD.VALCON, iNulo) || ' para ' || COALESCE(NEW.VALCON, iNulo) || CRLF;
    END IF;

    IF Equal(OLD.VLRDES, NEW.VLRDES) <> 1 THEN
      cLog := cLog || 'Valor Desconto: de ' || COALESCE(OLD.VLRDES, iNulo) || ' para ' || COALESCE(NEW.VLRDES, iNulo) || CRLF;
    END IF;
    
    IF Equal(OLD.FILENT,NEW.FILENT) <> 1 THEN
       cLOG := cLOG||'Filial Entrega: '||COALESCE(OLD.FILENT, cNulo)||' para '||COALESCE(NEW.FILENT, cNulo)||CRLF;
    END IF;
    
    IF Equal(OLD.FILMAT,NEW.FILMAT) <> 1 THEN
       cLOG := cLOG||'Filial do material: '||COALESCE(OLD.FILMAT, cNulo)||' para '||COALESCE(NEW.FILMAT, cNulo)||CRLF;
    END IF;
    
    IF Equal(OLD.CODMAT,NEW.CODMAT) <> 1 THEN
       cLOG := cLOG||'Cdigo do material: '||COALESCE(OLD.CODMAT, cNulo)||' para '||COALESCE(NEW.CODMAT, cNulo)||CRLF;
    END IF;
    
    IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
       cLOG := cLOG||'Sequenciador: '||COALESCE(OLD.SEQUEN, cNulo)||' para '||COALESCE(NEW.SEQUEN, cNulo)||CRLF;
    END IF;
    
    IF Equal(OLD.CODBUS,NEW.CODBUS) <> 1 THEN
       cLOG := cLOG||'Cdigo de Busca: '||COALESCE(OLD.CODBUS, cNulo)||' para '||COALESCE(NEW.CODBUS, cNulo)||CRLF;
    END IF;
    
    IF Equal(OLD.CODMOE, NEW.CODMOE) <> 1 THEN
      cLog := cLog || 'Cdigo da moeda utilizada no preo do item: de ' || COALESCE(OLD.CODMOE, iNulo) || ' para ' || COALESCE(NEW.CODMOE, iNulo) || CRLF;
    END IF;
    
    IF Equal(OLD.CODCOR, NEW.CODCOR) <> 1 THEN
      cLog := cLog || 'Diviso do Produto: de ' || COALESCE(OLD.CODCOR, iNulo) || ' para ' || COALESCE(NEW.CODCOR, iNulo) || CRLF;
    END IF;
    
    IF Equal(OLD.CODTAM, NEW.CODTAM) <> 1 THEN
      cLog := cLog || 'Sub-Diviso do produto: de ' || COALESCE(OLD.CODTAM, iNulo) || ' para ' || COALESCE(NEW.CODTAM, iNulo) || CRLF;
    END IF;
    
    IF Equal(OLD.UNICOM, NEW.UNICOM) <> 1 THEN
      cLog := cLog || 'Unidade Compra: de ' || COALESCE(OLD.UNICOM, iNulo) || ' para ' || COALESCE(NEW.UNICOM, iNulo) || CRLF;
    END IF;
    
    IF Equal(OLD.UNIVEN, NEW.UNIVEN) <> 1 THEN
      cLog := cLog || 'Unidade Venda: de ' || COALESCE(OLD.UNIVEN, iNulo) || ' para ' || COALESCE(NEW.UNIVEN, iNulo) || CRLF;
    END IF;

    WK_CODUID := GetCoduidAtual();

    -- MN - Registra log na TL_PED
    IF ISNOTNULL(cLOG) = 'T' THEN
         vItem:= NEW.CODFIL||'-'||NEW.NUMPED||'-'||NEW.NUMITE;
         
         cLOG := 'Item do Pedido >> '||vItem||': '||cLOG||CRLF;
         
         select * into QuemLogou from DadosLogon();
         INSERT INTO TL_PED (FILPED,NUMPED,FILUSU,CODUSU,DATOPE,MSGLOG,CODUID)
                     VALUES (NEW.CODFIL,NEW.NUMPED,QuemLogou.FILUSU,QuemLogou.CODUSU,agora(),cLOG,WK_CODUID);
    END IF;
    
  END IF; -- Fim IF do (TG_OP = 'UPDATE')
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4375 --*/
CREATE TRIGGER TGIPE3
AFTER INSERT OR DELETE OR UPDATE ON TT_IPE 
FOR EACH ROW EXECUTE PROCEDURE TGIPE3();

/*-- SEQ 4376 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIPE4() CASCADE;

/*-- SEQ 4377 --*/
CREATE OR REPLACE FUNCTION TGIPE4() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo
-- 1) Fazer o primerio lanamento do produto na TT_SAL apenas para constar
--
-- Principal
   wk_existe integer;
BEGIN

   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      SELECT COUNT(*) INTO wk_existe
        FROM TT_SAL
       WHERE CODFIL = NEW.CODFIL
         AND FILMAT = NEW.FILMAT
         AND CODMAT = NEW.CODMAT
         AND CODCOR = NEW.CODCOR
         AND CODTAM = NEW.CODTAM
         AND CODMUL = NEW.CODMUL;

      IF wk_existe = 0 THEN
         INSERT INTO TT_SAL (CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,CODMUL)
                     VALUES (NEW.CODFIL,NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,NEW.CODMUL);
      END IF;
   ELSE
      SELECT COUNT(*) INTO wk_existe FROM TT_SAL
       WHERE CODFIL = OLD.CODFIL
         AND FILMAT = OLD.FILMAT
         AND CODMAT = OLD.CODMAT
         AND CODCOR = OLD.CODCOR
         AND CODTAM = OLD.CODTAM
         AND CODMUL = OLD.CODMUL;

      IF wk_existe = 0 THEN
         INSERT INTO TT_SAL (CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,CODMUL)
                     VALUES (OLD.CODFIL,OLD.FILMAT,OLD.CODMAT,OLD.CODCOR,OLD.CODTAM,OLD.CODMUL);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4378 --*/
CREATE TRIGGER TGIPE4
BEFORE INSERT OR DELETE OR UPDATE ON TT_IPE 
FOR EACH ROW EXECUTE PROCEDURE TGIPE4();


/*-- SEQ 4379 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIPF() CASCADE;

/*-- SEQ 4380 --*/
CREATE OR REPLACE FUNCTION TGIPF() RETURNS TRIGGER AS $$
DECLARE
-- MN - 02/12/2019 - PJ7477 - Tabela Preos por Fornecedor - Itens da tabela
-- Objetivo:
-- 1) Atualiza DATINC
-- 2) Atualiza ATU_EM
-- 3) Impedir exclusao
  
   -- Declarao de variveis e cursores
   cComplemento  VARCHAR(254) := constante('complemento'); 

-- Principal
BEGIN
   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.ID_IPF IS NULL THEN
         SELECT NEXTVAL('sqIPF') INTO NEW.ID_IPF FROM DUAL;
      END IF;
      
      NEW.DATINC := Agora();
   END IF;

   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF; 

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4381 --*/
CREATE TRIGGER TGIPF
BEFORE INSERT OR DELETE OR UPDATE ON TT_IPF 
FOR EACH ROW EXECUTE PROCEDURE TGIPF();


/*-- SEQ 4382 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIPLA() CASCADE;

/*-- SEQ 4383 --*/
CREATE OR REPLACE FUNCTION TGIPLA() RETURNS TRIGGER AS $$
DECLARE
  proximo      Numeric;
BEGIN
  
  IF (TG_OP = 'INSERT') THEN    
     IF COALESCE(NEW.ID_IPLA,0)=0 THEN
        SELECT NEXTVAL('SQIPLA')  INTO proximo FROM DUAL;
        NEW.ID_IPLA := proximo;
     END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4384 --*/
CREATE TRIGGER TGIPLA
BEFORE INSERT ON TI_PLA 
FOR EACH ROW EXECUTE PROCEDURE TGIPLA();


/*-- SEQ 4385 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIPRE() CASCADE;

/*-- SEQ 4386 --*/
CREATE OR REPLACE FUNCTION TGIPRE() RETURNS TRIGGER AS $$
DECLARE
  proximo      Numeric;
BEGIN
  
  IF (TG_OP = 'INSERT') THEN    
     IF COALESCE(NEW.ID_IPRE,0)=0 THEN
        SELECT NEXTVAL('SQIPRE')  INTO proximo FROM DUAL;
        NEW.ID_IPRE := proximo;
     END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4387 --*/
CREATE TRIGGER TGIPRE
BEFORE INSERT ON TI_PRE 
FOR EACH ROW EXECUTE PROCEDURE TGIPRE();


/*-- SEQ 4388 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIPRO() CASCADE;

/*-- SEQ 4389 --*/
CREATE OR REPLACE FUNCTION TGIPRO() RETURNS TRIGGER AS $$
DECLARE
  proximo      Numeric;
BEGIN
  
  IF (TG_OP = 'INSERT') THEN    
     IF COALESCE(NEW.ID_IPRO,0)=0 THEN
        SELECT NEXTVAL('SQIPRO')  INTO proximo FROM DUAL;
        NEW.ID_IPRO := proximo;
     END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4390 --*/
CREATE TRIGGER TGIPRO
BEFORE INSERT ON TI_PRO 
FOR EACH ROW EXECUTE PROCEDURE TGIPRO();


/*-- SEQ 4391 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIPT() CASCADE;

/*-- SEQ 4392 --*/
CREATE OR REPLACE FUNCTION TGIPT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
BEGIN

-- data de inclusao do item
  IF (TG_OP = 'INSERT') THEN    
     NEW.DATINC := agora();
  END IF;

-- Popula a coluna ATU_EM
IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
   NEW.ATU_EM := agora();      
END IF;
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4393 --*/
CREATE TRIGGER TGIPT
BEFORE INSERT OR UPDATE ON TT_IPT 
FOR EACH ROW EXECUTE PROCEDURE TGIPT();  

/*-- SEQ 4394 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIPT2() CASCADE;

/*-- SEQ 4395 --*/
CREATE OR REPLACE FUNCTION TGIPT2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 2) Registrar mudanca dos dados num "log"
   vLOG    VARCHAR(4000)     := '';
   vFILUSU VARCHAR(3);    
   vCODUSU VARCHAR(3); 
   cNulo   CONSTANT CHAR(1)   := '0';
   CRLF    CONSTANT CHAR(1)   := CHR(10);  
    
    QuemLogou TRetQuemLogou%ROWTYPE;
    WK_CODUID TT_UID.CODUID%TYPE;
BEGIN
  WK_CODUID := GetCoduidAtual();

  select * into QuemLogou from DadosLogon();
  vFILUSU := QuemLogou.FILUSU;
  vCODUSU := QuemLogou.CODUSU;
 
  -- Tratamento de "log"
  --IF (TG_OP = 'DELETE') THEN
  --   DELETE FROM TL_PTC WHERE CODFIL = OLD.CODFIL AND SEQUEN = OLD.SEQUEN;
  --END IF;
                              
  -- Tratamento de log
  IF (TG_OP = 'INSERT') THEN
     vLOG := 'Inclusao';
     INSERT INTO TL_PTC (CODFIL,SEQUEN,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
          VALUES(NEW.CODFIL,NEW.SEQUEN,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);  
  ELSIF (TG_OP = 'UPDATE') THEN

     IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
        vLOG := vLOG||'Cdigo da Filial: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
       vLOG := vLOG||'Sequenciador: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.NUMITE,NEW.NUMITE) <> 1 THEN
        vLOG := vLOG||'Nmero do item: de '||COALESCE(OLD.NUMITE,cNulo)||' para '||COALESCE(NEW.NUMITE,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DESIPT,NEW.DESIPT) <> 1 THEN
        vLOG := vLOG||'Descrio do Item: de '||COALESCE(OLD.DESIPT,cNulo)||' para '||COALESCE(NEW.DESIPT,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATINC,NEW.DATINC) <> 1 THEN
        vLOG := vLOG||'Data Incluso: de '||COALESCE(to_char(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.ATU_EM,NEW.ATU_EM) <> 1 THEN
        vLOG := vLOG||'Data Alterao: de '||COALESCE(to_char(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;
     IF ISNOTNULL(trim(vLOG)) = 'T' THEN
        -- cadastra o LOG.
        INSERT INTO TL_PTC (CODFIL,SEQUEN,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                 VALUES (NEW.CODFIL,NEW.SEQUEN,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);     
     END IF;   
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4396 --*/
CREATE TRIGGER TGIPT2
AFTER INSERT OR UPDATE OR DELETE ON TT_IPT 
FOR EACH ROW EXECUTE PROCEDURE TGIPT2();


/*-- SEQ 4397 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIPTXEST() CASCADE;

/*-- SEQ 4398 --*/
CREATE OR REPLACE FUNCTION TGIPTXEST() RETURNS TRIGGER AS $$
DECLARE
-- Principal
BEGIN
  --Popula a coluna DATINC
  IF (TG_OP = 'INSERT') THEN     
    NEW.DATINC := agora();
  END IF;

  -- Popula a coluna ATU_EM
  IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
     NEW.ATU_EM := agora();      
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4399 --*/
CREATE TRIGGER TGIPTXEST
BEFORE INSERT OR UPDATE ON TT_IPTXEST 
FOR EACH ROW EXECUTE PROCEDURE TGIPTXEST();

/*-- SEQ 4400 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIPTXEST2() CASCADE;

/*-- SEQ 4401 --*/
CREATE OR REPLACE FUNCTION TGIPTXEST2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 2) Registrar mudanca dos dados num "log"
   vLOG    VARCHAR(4000)     := '';
   vFILUSU VARCHAR(3);    
   vCODUSU VARCHAR(3); 
   cNulo   CONSTANT CHAR(1)   := '0';
   CRLF    CONSTANT CHAR(1)   := CHR(10);  
    
    QuemLogou TRetQuemLogou%ROWTYPE;
    WK_CODUID TT_UID.CODUID%TYPE;
BEGIN
  WK_CODUID := GetCoduidAtual();

  select * into QuemLogou from DadosLogon();
  vFILUSU := QuemLogou.FILUSU;
  vCODUSU := QuemLogou.CODUSU;
 
                              
  -- Tratamento de log
  IF (TG_OP = 'INSERT') THEN
     vLOG := 'Inclusao';
     INSERT INTO TL_PTC (CODFIL,SEQUEN,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
          VALUES(NEW.CODFIL,NEW.SEQUEN,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);  
  ELSIF (TG_OP = 'UPDATE') THEN

     IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
        vLOG := vLOG||'Cdigo da Filial: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
       vLOG := vLOG||'Sequenciador: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.NUMITE,NEW.NUMITE) <> 1 THEN
        vLOG := vLOG||'Nmero do item: de '||COALESCE(OLD.NUMITE,cNulo)||' para '||COALESCE(NEW.NUMITE,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SIGEST,NEW.SIGEST) <> 1 THEN
        vLOG := vLOG||'Estado Signatrio: de '||COALESCE(OLD.SIGEST,cNulo)||' para '||COALESCE(NEW.SIGEST,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATINC,NEW.DATINC) <> 1 THEN
        vLOG := vLOG||'Data Incluso: de '||COALESCE(to_char(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.ATU_EM,NEW.ATU_EM) <> 1 THEN
        vLOG := vLOG||'Data Alterao: de '||COALESCE(to_char(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;
     IF ISNOTNULL(trim(vLOG)) = 'T' THEN
        -- cadastra o LOG.
        INSERT INTO TL_PTC (CODFIL,SEQUEN,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                 VALUES (NEW.CODFIL,NEW.SEQUEN,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);     
     END IF;   
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4402 --*/
CREATE TRIGGER TGIPTXEST2
AFTER INSERT OR UPDATE OR DELETE ON TT_IPTXEST 
FOR EACH ROW EXECUTE PROCEDURE TGIPTXEST2();


/*-- SEQ 4403 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIPTXEXC() CASCADE;

/*-- SEQ 4404 --*/
CREATE OR REPLACE FUNCTION TGIPTXEXC() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
BEGIN

-- data de inclusao do item
  IF (TG_OP = 'INSERT') THEN    
     NEW.DATINC := agora();
  END IF;

-- Popula a coluna ATU_EM
IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
   NEW.ATU_EM := agora();      
END IF;
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4405 --*/
CREATE TRIGGER TGIPTXEXC
BEFORE INSERT OR UPDATE ON TT_IPTXEXC 
FOR EACH ROW EXECUTE PROCEDURE TGIPTXEXC();  

/*-- SEQ 4406 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIPTXEXC2() CASCADE;

/*-- SEQ 4407 --*/
CREATE OR REPLACE FUNCTION TGIPTXEXC2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 2) Registrar mudanca dos dados num "log"
   vLOG    VARCHAR(4000)     := '';
   vFILUSU VARCHAR(3);    
   vCODUSU VARCHAR(3); 
   cNulo   CONSTANT CHAR(1)   := '0';
   CRLF    CONSTANT CHAR(1)   := CHR(10);  
    
    QuemLogou TRetQuemLogou%ROWTYPE;
    WK_CODUID TT_UID.CODUID%TYPE;
BEGIN
  WK_CODUID := GetCoduidAtual();

  select * into QuemLogou from DadosLogon();
  vFILUSU := QuemLogou.FILUSU;
  vCODUSU := QuemLogou.CODUSU;
 
                             
  -- Tratamento de log
  IF (TG_OP = 'INSERT') THEN
     vLOG := 'Inclusao';
     INSERT INTO TL_PTC (CODFIL,SEQUEN,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
          VALUES(NEW.CODFIL,NEW.SEQUEN,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);  
  ELSIF (TG_OP = 'UPDATE') THEN

     IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
        vLOG := vLOG||'Cdigo da Filial: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
       vLOG := vLOG||'Sequenciador: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.NUMITE,NEW.NUMITE) <> 1 THEN
        vLOG := vLOG||'Nmero do item: de '||COALESCE(OLD.NUMITE,cNulo)||' para '||COALESCE(NEW.NUMITE,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.ITEEXC,NEW.ITEEXC) <> 1 THEN
        vLOG := vLOG||'Nmero do item da exceo: de '||COALESCE(OLD.ITEEXC,cNulo)||' para '||COALESCE(NEW.ITEEXC,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SIGEST,NEW.SIGEST) <> 1 THEN
        vLOG := vLOG||'Estado: de '||COALESCE(OLD.SIGEST,cNulo)||' para '||COALESCE(NEW.SIGEST,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.CODNCM,NEW.CODNCM) <> 1 THEN
        vLOG := vLOG||'Nomenclatura Comum do Mercosul: de '||COALESCE(OLD.CODNCM,cNulo)||' para '||COALESCE(NEW.CODNCM,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATINC,NEW.DATINC) <> 1 THEN
        vLOG := vLOG||'Data Incluso: de '||COALESCE(to_char(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.ATU_EM,NEW.ATU_EM) <> 1 THEN
        vLOG := vLOG||'Data Alterao: de '||COALESCE(to_char(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.TIPEXC,NEW.TIPEXC) <> 1 THEN
        vLOG := vLOG||'Tipo Excluso: de '||COALESCE(OLD.TIPEXC,cNulo)||' para '||COALESCE(NEW.TIPEXC,cNulo)||CRLF;
     END IF;
     IF ISNOTNULL(trim(vLOG)) = 'T' THEN
        -- cadastra o LOG.
        INSERT INTO TL_PTC (CODFIL,SEQUEN,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                 VALUES (NEW.CODFIL,NEW.SEQUEN,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);     
     END IF;   
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4408 --*/
CREATE TRIGGER TGIPTXEXC2
AFTER INSERT OR UPDATE OR DELETE ON TT_IPTXEXC 
FOR EACH ROW EXECUTE PROCEDURE TGIPTXEXC2();


/*-- SEQ 4409 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIPTXNCM() CASCADE;

/*-- SEQ 4410 --*/
CREATE OR REPLACE FUNCTION TGIPTXNCM() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Popular colunas DATINC e ATU_EM
BEGIN
  -- Popula a coluna DATINC 
  IF (TG_OP = 'INSERT') THEN    
   NEW.DATINC := agora(); 
  END IF;

  -- Popula a coluna ATU_EM
  IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
     NEW.ATU_EM := agora();      
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4411 --*/
CREATE TRIGGER TGIPTXNCM
BEFORE INSERT OR UPDATE ON TT_IPTXNCM 
FOR EACH ROW EXECUTE PROCEDURE TGIPTXNCM();  

/*-- SEQ 4412 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIPTXNCM2() CASCADE;

/*-- SEQ 4413 --*/
CREATE OR REPLACE FUNCTION TGIPTXNCM2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 2) Registrar mudanca dos dados num "log"
   vLOG    VARCHAR(4000)     := '';
   vFILUSU VARCHAR(3);    
   vCODUSU VARCHAR(3); 
   cNulo   CONSTANT CHAR(1)   := '0';
   CRLF    CONSTANT CHAR(1)   := CHR(10);  
    
    QuemLogou TRetQuemLogou%ROWTYPE;
    WK_CODUID TT_UID.CODUID%TYPE;
BEGIN
  WK_CODUID := GetCoduidAtual();

  select * into QuemLogou from DadosLogon();
  vFILUSU := QuemLogou.FILUSU;
  vCODUSU := QuemLogou.CODUSU;
                            
  -- Tratamento de log
  IF (TG_OP = 'INSERT') THEN
     vLOG := 'Inclusao';
     INSERT INTO TL_PTC (CODFIL,SEQUEN,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
          VALUES(NEW.CODFIL,NEW.SEQUEN,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);  
  ELSIF (TG_OP = 'UPDATE') THEN

     IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
        vLOG := vLOG||'Cdigo da Filial: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
       vLOG := vLOG||'Sequenciador: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.NUMITE,NEW.NUMITE) <> 1 THEN
        vLOG := vLOG||'Nmero do item: de '||COALESCE(OLD.NUMITE,cNulo)||' para '||COALESCE(NEW.NUMITE,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.CODNCM,NEW.CODNCM) <> 1 THEN
        vLOG := vLOG||'Cdigo da Nomenclatura Comum do Mercosul: de '||COALESCE(OLD.CODNCM,cNulo)||' para '||COALESCE(NEW.CODNCM,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATINC,NEW.DATINC) <> 1 THEN
        vLOG := vLOG||'Data Incluso: de '||COALESCE(to_char(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.ATU_EM,NEW.ATU_EM) <> 1 THEN
        vLOG := vLOG||'Data Alterao: de '||COALESCE(to_char(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;
     IF ISNOTNULL(trim(vLOG)) = 'T' THEN
        -- cadastra o LOG.
        INSERT INTO TL_PTC (CODFIL,SEQUEN,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                 VALUES (NEW.CODFIL,NEW.SEQUEN,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);     
     END IF;   
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4414 --*/
CREATE TRIGGER TGIPTXNCM2
AFTER INSERT OR UPDATE OR DELETE ON TT_IPTXNCM 
FOR EACH ROW EXECUTE PROCEDURE TGIPTXNCM2();


/*-- SEQ 4415 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIPTXPRO() CASCADE;

/*-- SEQ 4416 --*/
CREATE OR REPLACE FUNCTION TGIPTXPRO() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Popular colunas DATINC e ATU_EM
BEGIN
  -- Popula a coluna DATINC 
  IF (TG_OP = 'INSERT') THEN    
   NEW.DATINC := agora(); 
  END IF;

  -- Popula a coluna ATU_EM
  IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
     NEW.ATU_EM := agora();      
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4417 --*/
CREATE TRIGGER TGIPTXPRO
BEFORE INSERT OR UPDATE ON TT_IPTXPRO 
FOR EACH ROW EXECUTE PROCEDURE TGIPTXPRO();  


/*-- SEQ 4418 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIRCXIPE() CASCADE;

/*-- SEQ 4419 --*/
CREATE OR REPLACE FUNCTION TGIRCXIPE() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
    -- Trata dados padroes na inclusao
    IF (TG_OP = 'INSERT') THEN
        IF NEW.SEQUEN IS NULL THEN
        NEW.SEQUEN:=ProximoCodigo('TT_IRCXIPE',NEW.CODFIL);
        END IF;
        -- "default"
        NEW.DATINC := AGORA(); 
    END IF;

    IF (TG_OP = 'UPDATE') THEN
        NEW.ATU_EM := AGORA();
    END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4420 --*/
CREATE TRIGGER TGIRCXIPE
BEFORE INSERT OR UPDATE ON TT_IRCXIPE 
FOR EACH ROW EXECUTE PROCEDURE TGIRCXIPE();


/*-- SEQ 4421 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIREC() CASCADE;

/*-- SEQ 4422 --*/
CREATE OR REPLACE FUNCTION TGIREC() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Atualizar Dados-- Principal
BEGIN
   -- Trata dados padroes na incluso
   IF (TG_OP = 'INSERT') THEN
      IF COALESCE(NEW.ID_IREC,0)=0 THEN
         NEW.ID_IREC := TO_NUMBER(ProximoCodigo('TI_REC',NEW.CODFIL));
      END IF;
      NEW.DATCRI := AGORA();
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4423 --*/
CREATE TRIGGER TGIREC
BEFORE INSERT OR UPDATE ON TI_REC 
FOR EACH ROW EXECUTE PROCEDURE TGIREC();


/*-- SEQ 4424 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIRO1() CASCADE;

/*-- SEQ 4425 --*/
CREATE OR REPLACE FUNCTION TGIRO1() RETURNS TRIGGER AS $$
DECLARE
-- Tabela item de romaneio
-- Objetivo:
-- 1) Atualiza ATU_EM, FILUSU e CODUSU 
-- 2) Impedir exclusao
  
  vComplemento  VARCHAR(254);
  
  wk_Cli_Filial TT_IRO.FILCLI%TYPE;
  wk_Cli_Codigo TT_IRO.CODCLI%TYPE; 
  wk_Quando     TT_IRO.DATOPE%TYPE;
  wk_atualiza   boolean;
  vVem_de_UNIAO_PARCEIROS  constant VARCHAR(1) := constante('UNIAO_PARCEIROS');

  QuemLogou TRetQuemLogou%ROWTYPE;

-- Principal
BEGIN

  vComplemento := constante('complemento');

  IF (TG_OP = 'DELETE') THEN
    RAISE EXCEPTION 'PG-20001 Nao e permitida a exclusao. %' , vComplemento;     
  END IF;
  
  IF (TG_OP = 'UPDATE') THEN
    IF (NEW.CODFIL<>OLD.CODFIL) or
       (NEW.SEQUEN<>OLD.SEQUEN) or 
       (NEW.FILVEN<>OLD.FILVEN) or
       (NEW.SEQVEN<>OLD.SEQVEN) or
       (NEW.FILUSU<>OLD.FILUSU) or 
       (NEW.CODUSU<>OLD.CODUSU) THEN
      RAISE EXCEPTION 'PG-20002 Nao e permitida a alteracao da chave primaria, venda ou usuario. %' , vComplemento; 
    END IF;
  END IF;
  
  select * into QuemLogou from DadosLogon();

  wk_atualiza:=false;
  
  IF (TG_OP = 'INSERT') THEN      
    wk_atualiza:=true;
    NEW.FILUSU:=QuemLogou.FILUSU;
    NEW.CODUSU:=QuemLogou.CODUSU;
    NEW.SEQCAN:='     0';      
  END IF;
  
  IF (TG_OP = 'UPDATE') THEN
     IF (Equal(OLD.SEQCAN,NEW.SEQCAN) <> 1) or
        (Equal(OLD.OBSERV,NEW.OBSERV) <> 1) or 
        (Equal(OLD.ATU_EM,NEW.ATU_EM) <> 1) or 
        (Equal(OLD.FLGEST,NEW.FLGEST) <> 1) or 
        (Equal(OLD.ENTREG,NEW.ENTREG) <> 1) or 
        (Equal(OLD.FILALT,NEW.FILALT) <> 1) or 
        (Equal(OLD.CODALT,NEW.CODALT) <> 1) or 
        (Equal(OLD.FILCLI,NEW.FILCLI) <> 1) or 
        (Equal(OLD.CODCLI,NEW.CODCLI) <> 1) or 
        (Equal(OLD.DATOPE,NEW.DATOPE) <> 1) or 
        (Equal(OLD.DATENT,NEW.DATENT) <> 1)  THEN        
          wk_atualiza:=true;
     END IF;
  END IF;
  
  IF wk_atualiza THEN 
     NEW.ATU_EM := agora();
     IF ((NEW.FILALT IS NULL) AND (NEW.CODALT IS NULL)) THEN
       NEW.FILALT:=QuemLogou.FILUSU;
       NEW.CODALT:=QuemLogou.CODUSU;
     END IF;
  END IF;  
  
  IF (TG_OP = 'UPDATE') THEN  
    IF  (NEW.FLGEST = 'C')
    AND (Equal(NEW.FLGEST, OLD.FLGEST) <> 1) THEN
      NEW.SEQCAN := ProximoCodigo('TT_IRO_CANCELAMENTO',NEW.CODFIL);
    END IF;
  END IF;

  -- se nao vier da uniao de parceiros
  IF (Equal(NEW.DUMMY, vVem_de_UNIAO_PARCEIROS) <> 1) THEN
          SELECT FILCLI,CODCLI,DATHOR
        INTO wk_Cli_Filial,wk_Cli_Codigo,wk_Quando
        FROM TT_VEN
       WHERE CODFIL = NEW.FILVEN
         AND SEQUEN = NEW.SEQVEN;
                                         
      NEW.FILCLI := wk_Cli_Filial;
      NEW.CODCLI := wk_Cli_Codigo;
      NEW.DATOPE := wk_Quando;                                   
      END IF;

  IF (NOT (TG_OP = 'DELETE')) THEN
    NEW.DUMMY := Null;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4426 --*/
CREATE TRIGGER TGIRO1
BEFORE INSERT OR DELETE OR UPDATE ON TT_IRO 
FOR EACH ROW EXECUTE PROCEDURE TGIRO1();

/*-- SEQ 4427 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIRO2() CASCADE;

/*-- SEQ 4428 --*/
CREATE OR REPLACE FUNCTION TGIRO2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Registrar mudanca dos dados num "log"
--
DECLARE
  vLOG   VARCHAR(4000)   := '';
  CRLF   CONSTANT CHAR(1) := CHR(10);
  Nulo   CONSTANT CHAR(4) := 'Nulo';
  cData  CHAR(21)         := 'DD/MM/YYYY HH24:MI:SS';

-- Principal
BEGIN

  -- Tratamento de log
  IF (TG_OP = 'DELETE') THEN
    DELETE FROM TL_IRO
     WHERE CODFIL = OLD.CODFIL
       AND SEQUEN = OLD.SEQUEN
       AND FILVEN = OLD.FILVEN
       AND SEQVEN = OLD.SEQVEN
       AND SEQCAN = OLD.SEQCAN;
  END IF;

  -- Tratamento de vLOG
  IF (TG_OP = 'UPDATE') THEN
    IF Equal(OLD.ENTREG,NEW.ENTREG) <> 1 THEN
      vLOG := vLOG||'Entrega: de '||COALESCE(OLD.ENTREG,Nulo)||' para '||COALESCE(NEW.ENTREG,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1  THEN
      vLOG := vLOG||'Status: de '||COALESCE(OLD.FLGEST,Nulo)||' para '||COALESCE(NEW.FLGEST,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.FILALT,NEW.FILALT) <> 1 OR
       Equal(OLD.CODALT,NEW.CODALT) <> 1 THEN
      vLOG := vLOG||'Quem alterou: de '||COALESCE(OLD.FILALT,Nulo)||'/'
                                                  ||COALESCE(OLD.CODALT,Nulo)||' para '
                                                  ||COALESCE(NEW.FILALT,Nulo)||'/'
                                                  ||COALESCE(NEW.CODALT,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.FILUSU,NEW.FILUSU) <> 1 OR
       Equal(OLD.CODUSU,NEW.CODUSU) <> 1 THEN
      vLOG := vLOG||'Usuario: de '||COALESCE(OLD.FILUSU,Nulo)||'/'
                                             ||COALESCE(OLD.CODUSU,Nulo)||' para '
                                             ||COALESCE(NEW.FILUSU,Nulo)||'/'
                                             ||COALESCE(NEW.CODUSU,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.FILCLI,NEW.FILCLI) <> 1 OR
       Equal(OLD.CODCLI,NEW.CODCLI) <> 1 THEN
      vLOG := vLOG||'Cliente: de '||COALESCE(OLD.FILCLI,Nulo)||'/'
                                             ||COALESCE(OLD.CODCLI,Nulo)||' para '
                                             ||COALESCE(NEW.FILCLI,Nulo)||'/'
                                             ||COALESCE(NEW.CODCLI,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.DATOPE,NEW.DATOPE) <> 1 THEN
      vLOG := vLOG||'Data operacao: de '||COALESCE(TO_CHAR(OLD.DATOPE,cData),Nulo)||' para '||COALESCE(TO_CHAR(NEW.DATOPE,cData),Nulo)||CRLF;
    END IF;
    IF Equal(OLD.DATENT,NEW.DATENT) <> 1 THEN
      vLOG := vLOG||'Data de entrega: de '||COALESCE(TO_CHAR(OLD.DATENT,cData),Nulo)||' para '||COALESCE(TO_CHAR(NEW.DATENT,cData),Nulo)||CRLF;
    END IF;
    IF Equal(OLD.OBSERV,NEW.OBSERV) <> 1  THEN
      vLOG := vLOG||'Observacao: de '||COALESCE(OLD.OBSERV,Nulo)||' para '||COALESCE(NEW.OBSERV,Nulo)||CRLF;
    END IF;

    IF ISNOTNULL(vLOG) = 'T' THEN
      -- Inclui uma linha em TL_IRO
      INSERT INTO TL_IRO (CODFIL,SEQUEN,FILVEN,SEQVEN,SEQCAN,DATOPE,MSGLOG)
      VALUES (NEW.CODFIL,NEW.SEQUEN,NEW.FILVEN,NEW.SEQVEN,NEW.SEQCAN,agora(),vLOG);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4429 --*/
CREATE TRIGGER TGIRO2
AFTER DELETE OR UPDATE ON TT_IRO 
FOR EACH ROW EXECUTE PROCEDURE TGIRO2();


/*-- SEQ 4430 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGISAL() CASCADE;

/*-- SEQ 4431 --*/
CREATE OR REPLACE FUNCTION TGISAL() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Gerar um cdigo sequencial exclusivo para compor a chave primria.

-- Declarao de variveis e cursores
   nProximo                      Numeric;

-- Principal
BEGIN

  IF (TG_OP = 'INSERT') THEN
     IF COALESCE(NEW.ID_ISAL,0)=0 THEN
        SELECT NEXTVAL('SQISAL') INTO nProximo FROM DUAL;
        NEW.ID_ISAL := nProximo;
     END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4432 --*/
CREATE TRIGGER TGISAL
BEFORE INSERT ON TI_SAL 
FOR EACH ROW EXECUTE PROCEDURE TGISAL();


/*-- SEQ 4433 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGISEP() CASCADE;

/*-- SEQ 4434 --*/
CREATE OR REPLACE FUNCTION TGISEP() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Atualiza DATCRI

-- Principal
BEGIN
  -- Trata dados padroes na inclusao  
  IF (TG_OP = 'INSERT') THEN
     NEW.DATCRI := AGORA();
  END IF;  

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4435 --*/
CREATE TRIGGER TGISEP
BEFORE INSERT OR UPDATE ON TI_SEP 
FOR EACH ROW EXECUTE PROCEDURE TGISEP();


/*-- SEQ 4436 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGISL() CASCADE;

/*-- SEQ 4437 --*/
CREATE OR REPLACE FUNCTION TGISL() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Atualiza ATU_EM da tabela pai.

-- Declarao de variveis
   cRetorno                      VARCHAR(2);
   cWhere                        TM_ATU.FILTRO%TYPE;

-- Principal
BEGIN

   -- Atualiza ATU_EM da tabela pai
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN
      cWhere := 'CODFIL = ' || CHR(39) || NEW.CODFIL  || CHR(39) || ' AND SEQUEN = ' || CHR(39) || NEW.SEQUEN || CHR(39);
   ELSIF (TG_OP = 'DELETE') THEN
      cWhere := 'CODFIL = ' || CHR(39) || OLD.CODFIL  || CHR(39) || ' AND SEQUEN = ' || CHR(39) || OLD.SEQUEN || CHR(39);
   END IF;
   cRetorno := INSERE_MATU('TT_ISL', 'TT_SLI', cWhere);

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4438 --*/
CREATE TRIGGER TGISL
AFTER INSERT OR UPDATE OR DELETE ON TT_ISL 
FOR EACH ROW EXECUTE PROCEDURE TGISL();


/*-- SEQ 4439 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGISLT() CASCADE;

/*-- SEQ 4440 --*/
CREATE OR REPLACE FUNCTION TGISLT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Atualizar Dados-- Principal
BEGIN
   -- Trata dados padroes na incluso
   IF (TG_OP = 'INSERT') THEN
      IF COALESCE(NEW.ID_ISLT,0)=0 THEN
         NEW.ID_ISLT := TO_NUMBER(ProximoCodigo('TI_SLT',NEW.CODFIL));
      END IF;
      NEW.DATCRI := AGORA();
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4441 --*/
CREATE TRIGGER TGISLT
BEFORE INSERT OR UPDATE ON TI_SLT 
FOR EACH ROW EXECUTE PROCEDURE TGISLT();


/*-- SEQ 4442 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGITF1() CASCADE;

/*-- SEQ 4443 --*/
CREATE OR REPLACE FUNCTION TGITF1() RETURNS TRIGGER AS $$
DECLARE
  vComplemento       VARCHAR(100) := constante('complemento');
  cDUMMY             CHAR(2);
  QuemLogou TRetQuemLogou%ROWTYPE;

   cFLGEST                       TT_REC.FLGEST%TYPE;
BEGIN

  IF (TG_OP = 'UPDATE') THEN
     NEW.ATU_EM := AGORA();

          SELECT MIN(FLGEST) INTO cFLGEST
       FROM TT_REC 
      WHERE FILITF = OLD.CODFIL  
        AND SEQITF = OLD.SEQUEN
        AND ITEITF = OLD.NUMITE;
     
     IF ISNULL(cFLGEST) = 'T' THEN
        cFLGEST := 'C';
     END IF;
     
     IF OLD.FLGEST = 'C' AND (COALESCE(cFLGEST, 'C') IN ('X', 'C')) THEN
       RAISE EXCEPTION 'PG-20001 No  permitida alterao de um carto cancelado. %' , vComplemento;
     END IF;

     IF  Equal(OLD.FLGEST,NEW.FLGEST) <> 1
     AND Equal(NEW.FLGEST,'P') = 0 THEN
       select * into QuemLogou from DadosLogon();
       NEW.FILUSU := QuemLogou.FILUSU;
       NEW.CODUSU := QuemLogou.CODUSU;
     END IF;
  END IF;

  -- DN 45679 - Tabelas Financeiras
  IF (TG_OP = 'INSERT') THEN
     cDUMMY:=INSERE_LFIN_LAN('TEF',NEW.CODFIL,NEW.SEQUEN,to_char(NEW.numite),'--');
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF (Equal(OLD.FLGEST,NEW.FLGEST) <> 1) OR
        (Equal(OLD.FILUSU,NEW.FILUSU) <> 1) OR
        (Equal(OLD.CODUSU,NEW.CODUSU) <> 1) OR
        (Equal(OLD.VLRITE,NEW.VLRITE) <> 1) OR
        (Equal(OLD.VLRTAX,NEW.VLRTAX) <> 1) OR
        (Equal(OLD.DATVEN,NEW.DATVEN) <> 1) OR
        (Equal(OLD.DATPGT,NEW.DATPGT) <> 1) OR
        (Equal(OLD.ATU_EM,NEW.ATU_EM) <> 1) THEN
        cDUMMY:=INSERE_LFIN_LAN('TEF',NEW.CODFIL,NEW.SEQUEN,to_char(NEW.numite),'--');
     END IF;
  END IF;
  -- DN 45679 - Fim Tabelas Financeiras

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4444 --*/
CREATE TRIGGER TGITF1
BEFORE INSERT OR UPDATE OR DELETE ON TT_ITF 
FOR EACH ROW EXECUTE PROCEDURE TGITF1();


/*-- SEQ 4445 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGITF2() CASCADE;

/*-- SEQ 4446 --*/
CREATE OR REPLACE FUNCTION TGITF2() RETURNS TRIGGER AS $$
DECLARE
  vComplemento       VARCHAR(100) := constante('complemento');

  cDUMMY             CHAR(1);
  vLOG    VARCHAR(4000)     := '';
  cNulo   CONSTANT CHAR(4)   := 'Nulo';
  iNulo   CONSTANT Numeric(1) := 0;
  CRLF    CONSTANT CHAR(1)   := CHR(10);
  cOld VARCHAR(250);
  cNew VARCHAR(250);
  QuemLogou TRetQuemLogou%ROWTYPE;

BEGIN

  IF (TG_OP = 'UPDATE') THEN
     IF (Equal(OLD.VLRITE,NEW.VLRITE) = 0) THEN
        vLOG := vLOG||'Valor do tem: de '||COALESCE(OLD.VLRITE,iNulo)||' para '||COALESCE(NEW.VLRITE,iNulo)||CRLF;
     END IF;

     IF (Equal(OLD.VLRTAX,NEW.VLRTAX) = 0) THEN
        vLOG := vLOG||'Valor da taxa: de '||COALESCE(OLD.VLRTAX,iNulo)||' para '||COALESCE(NEW.VLRTAX,iNulo)||CRLF;
     END IF;

     IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
        vLOG := vLOG||'Situacao: de '||COALESCE(DescricaoDominio('ITF','FLGEST',OLD.FLGEST),cNulo)||' para '||COALESCE(DescricaoDominio('ITF','FLGEST',NEW.FLGEST),cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.FILUSU,NEW.FILUSU) = 0 OR
        Equal(OLD.CODUSU,NEW.CODUSU) = 0) THEN
        vLOG := vLOG||'Usurio: de '||COALESCE(OLD.FILUSU||'/'||TRIM(OLD.CODUSU),cNulo)||' para '||COALESCE(NEW.FILUSU||'/'||TRIM(NEW.CODUSU),cNulo)||CRLF;
     END IF;

     IF Equal(OLD.DATVEN,NEW.DATVEN) <> 1 THEN
        vLOG := vLOG||'Data de vencimento: de '||COALESCE(TO_CHAR(OLD.DATVEN,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATVEN,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;

     IF Equal(OLD.DATPGT,NEW.DATPGT) <> 1 THEN
        vLOG := vLOG||'Data do pagamento: de '||COALESCE(TO_CHAR(OLD.DATPGT,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATPGT,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;

     IF ISNOTNULL(vLOG) = 'T' THEN
       select * into QuemLogou from DadosLogon();
       INSERT INTO TL_TEF (CODFIL,SEQTEF,FILUSU,CODUSU,DATOPE,MSGLOG)
                     VALUES (NEW.CODFIL,NEW.SEQUEN,QuemLogou.FILUSU,QuemLogou.CODUSU,agora(),vLog);
     END IF;



  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4447 --*/
CREATE TRIGGER TGITF2
AFTER INSERT OR UPDATE ON TT_ITF 
FOR EACH ROW EXECUTE PROCEDURE TGITF2();


/*-- SEQ 4448 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGITFXCTF() CASCADE;

/*-- SEQ 4449 --*/
CREATE OR REPLACE FUNCTION TGITFXCTF() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Gerar um cdigo sequencial exclusivo para compor a chave primria.
-- 2. Atualiza controles de data.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF COALESCE(NEW.ID_ITFXCTF,0)=0 THEN
         SELECT NEXTVAL('SQIXC') INTO NEW.ID_ITFXCTF FROM DUAL;
      END IF;
      NEW.DATINC := Agora();
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4450 --*/
CREATE TRIGGER TGITFXCTF
BEFORE INSERT OR UPDATE OR DELETE ON TT_ITFXCTF 
FOR EACH ROW EXECUTE PROCEDURE TGITFXCTF();


/*-- SEQ 4451 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGITI() CASCADE;

/*-- SEQ 4452 --*/
CREATE OR REPLACE FUNCTION TGITI() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Atualiza FLGATI para corrigir erro de violao na "ck_iti_flgati" ao atualizar frmula de tintas.

-- Declarao de variveis e cursores
   --COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   IF (TG_OP = 'INSERT') THEN
      IF NEW.FLGATI IS NULL THEN
         NEW.FLGATI := 'T';
      END IF;
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4453 --*/
CREATE TRIGGER TGITI
BEFORE INSERT ON TT_ITI 
FOR EACH ROW EXECUTE PROCEDURE TGITI();


/*-- SEQ 4454 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGITP() CASCADE;

/*-- SEQ 4455 --*/
CREATE OR REPLACE FUNCTION TGITP() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
BEGIN
  -- Popula as colunas SEQUEN e DATINC
  IF (TG_OP = 'INSERT') THEN
   IF NEW.SEQUEN IS NULL THEN
      NEW.SEQUEN := ProximoCodigo('TT_ITP',NEW.CODFIL);
   END IF;
   NEW.DATINC := agora(); 
  END IF;

  -- Popula a coluna ATU_EM
  IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
     NEW.ATU_EM := agora();      
  END IF;  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4456 --*/
CREATE TRIGGER TGITP
BEFORE INSERT OR UPDATE ON TT_ITP 
FOR EACH ROW EXECUTE PROCEDURE TGITP();  


/*-- SEQ 4457 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIUF1() CASCADE;

/*-- SEQ 4458 --*/
CREATE OR REPLACE FUNCTION TGIUF1() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo
-- 1) Atualiza ATU_EM da TT_PRO
--
   cRet                          VARCHAR(2);

   --LEO 84337
   vCODUID_ATUAL                 TT_VEN.CODUID%TYPE;
   vBLQ_SEM_UID                  TT_CFG.BLQ_SEM_UID%TYPE;
   vSESSIONID                    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');
   
   cRetorno                      VARCHAR(2);
   cWhere                        TM_ATU.FILTRO%TYPE;
   cMantemAtuEm                  VARCHAR(1);
BEGIN
   -- Inicializao de variveis e regras
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN
      IF COALESCE(TRIM(NEW.DUMMY),'#') = Constante('MANTEM_ATU_EM') THEN
         cMantemAtuEm := 'T';
      ELSE
         cMantemAtuEm := 'F';
      END IF;
   ELSIF (TG_OP = 'DELETE') THEN
      cMantemAtuEm := 'F';
   END IF;

   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN -- RFMP 71137
      NEW.MVAVEN := COALESCE(NEW.MVAVEN,0);
      NEW.MVAC07 := COALESCE(NEW.MVAC07,0);
      NEW.MVAC12 := COALESCE(NEW.MVAC12,0);
      NEW.MVAC04 := COALESCE(NEW.MVAC04,0);
      NEW.ICMISE := COALESCE(NEW.ICMISE,'F'); -- MMC 2023015721
   END IF;

   IF NOT (TG_OP = 'DELETE') THEN
      IF (COALESCE(TRIM(NEW.DUMMY),'#') <> Constante('vem_de_TGPRO')) THEN
         -- Altera porcentagem do valor do produto correspondente a servico para zero
         SELECT CASE WHEN TIPPRO <> 0 OR CODMON IS NULL THEN 0 ELSE NEW.PERSRV END INTO NEW.PERSRV
           FROM TT_PRO
          WHERE FILMAT = NEW.FILMAT
            AND CODMAT = NEW.CODMAT;

         IF (TG_OP = 'INSERT') OR (cMantemAtuEm = 'F') THEN
           NEW.ATU_EM := AGORA();
         END IF;
      END IF;
   END IF;

   IF (TG_OP = 'DELETE') THEN
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_IUF', OLD.filmat || OLD.codmat, OLD.estado);
   END IF;
   IF (TG_OP = 'INSERT') THEN
      --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_IUF', NEW.filmat || NEW.codmat, NEW.estado);
   END IF;

   IF (TG_OP = 'DELETE') THEN
      -- LEO 84337
      SELECT BLQ_SEM_UID
        INTO vBLQ_SEM_UID
        FROM TT_CFG;
      vCODUID_ATUAL := GetCoduidAtual();
      IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;
   END IF;

   IF (TG_OP = 'INSERT') THEN

      -- LEO 84337
      SELECT BLQ_SEM_UID
        INTO vBLQ_SEM_UID
       FROM TT_CFG;
      vCODUID_ATUAL := GetCoduidAtual();
      IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;

      -- Douglas - 83441
      NEW.CODUID := GetCoduidAtual();
      NEW.ASSINA := COALESCE(AssinaTabela('TT_IUF',
                                       ConcatenaIUF(NEW.FILMAT,
                                             NEW.CODMAT,
                                             NEW.ESTADO,
                                             NEW.REGESP,
                                                   NEW.SUBTRI,
                                                     NEW.RESICM),
                                                   null, null, null),NEW.ASSINA);
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF ConcatenaIUF(NEW.FILMAT,NEW.CODMAT,NEW.ESTADO,
                      NEW.REGESP,NEW.SUBTRI,NEW.RESICM) <>
         ConcatenaIUF(OLD.FILMAT,OLD.CODMAT,OLD.ESTADO,
                      OLD.REGESP,OLD.SUBTRI,OLD.RESICM) THEN

         -- LEO 84337
         SELECT BLQ_SEM_UID
           INTO vBLQ_SEM_UID
           FROM TT_CFG;
         vCODUID_ATUAL := GetCoduidAtual();
         IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;

         -- Douglas - 83441
         NEW.CODUID := GetCoduidAtual();
         NEW.ASSINA := COALESCE(AssinaTabela('TT_IUF',
                                          ConcatenaIUF(NEW.FILMAT,
                                                       NEW.CODMAT,
                                                       NEW.ESTADO,
                                                       NEW.REGESP,
                                                       NEW.SUBTRI,
                                                       NEW.RESICM),
                                                    OLD.CODUID,
                                          ConcatenaIUF(OLD.FILMAT,
                                                       OLD.CODMAT,
                                                       OLD.ESTADO,
                                                       OLD.REGESP,
                                                       OLD.SUBTRI,
                                                       OLD.RESICM),
                                                   OLD.ASSINA
                                                  ),NEW.ASSINA);
      END IF;
   END IF;

   -- Trazendo para trigger BEFORE tratamento de atualizao do ATU_EM porque
   -- ele depende do DUMMY que ser apagado no final da trigger
   IF cMantemAtuEm = 'F' THEN
      --Tratamento para Atualizar Tabela Pai
      IF (TG_OP = 'INSERT')
      OR (TG_OP = 'UPDATE') THEN
         cWhere := 'FILMAT = ' || CHR(39) || NEW.FILMAT  || CHR(39) || ' AND CODMAT = ' || CHR(39) || NEW.CODMAT || CHR(39);
      ELSIF (TG_OP = 'DELETE') THEN
         cWhere := 'FILMAT = ' || CHR(39) || OLD.FILMAT  || CHR(39) || ' AND CODMAT = ' || CHR(39) || OLD.CODMAT || CHR(39);
      END IF;
      cRetorno := INSERE_MATU('TT_IUF', 'TT_PRO', cWhere);
   END IF;
   
   -- Apagando dados do DUMMY para garantir que um novo processo no utilizar seu valor
   -- de maneira equivocada
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.DUMMY := NULL;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4459 --*/
CREATE TRIGGER TGIUF1
BEFORE INSERT OR UPDATE OR DELETE ON TT_IUF 
FOR EACH ROW EXECUTE PROCEDURE TGIUF1();

/*-- SEQ 4460 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIUF2() CASCADE;

/*-- SEQ 4461 --*/
CREATE OR REPLACE FUNCTION TGIUF2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo
-- 1) Registrar mudanca dos dados num "log"
-- 2) Impedir alteracao da chave primaria
--
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');
   cLogChave                     VARCHAR(25)       := '';
   cLOG                          VARCHAR(4000)     := '';
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   cOld                          VARCHAR(50); -- colocar Descrio no lugar dos codtab
   cNew                          VARCHAR(50);
   iOld                          Numeric; -- colocar Valor no lugar dos codtab
   iNew                          Numeric;

-- Principal
BEGIN
   -- Tratamento de log
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN
      cLogChave := 'Impostos de ' || NEW.ESTADO;
      IF NEW.REGESP <> 0 THEN
         cLogChave := cLogChave || ' (Especial)';
      END IF;
   END IF;
   IF (TG_OP = 'INSERT') THEN
      cLOG := 'Incluso - ' || cLogChave;
   ELSIF (TG_OP = 'UPDATE') THEN
      IF (OLD.FILMAT <> NEW.FILMAT) OR
         (OLD.CODMAT <> NEW.CODMAT) THEN
         --(OLD.ESTADO <> NEW.ESTADO) THEN
         RAISE EXCEPTION 'PG-20001 Dados dos impostos estaduais nao podem mudar de produto.%' , vComplemento;
      END IF;

      IF Equal(OLD.CODFIS,NEW.CODFIS) <> 1 THEN
         SELECT MIN(CODFIS) INTO cOld FROM TD_FIS WHERE CODTAB = OLD.CODFIS;
         SELECT MIN(CODFIS) INTO cNew FROM TD_FIS WHERE CODTAB = NEW.CODFIS;
         cLOG := cLOG||'Codigo fiscal: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.RESICM,NEW.RESICM) <> 1 THEN
         SELECT MIN(RESICM) INTO iOld FROM TD_ICM WHERE CODTAB = OLD.RESICM;
         SELECT MIN(RESICM) INTO iNew FROM TD_ICM WHERE CODTAB = NEW.RESICM;
         cLOG := cLOG||'ICMS: de '||COALESCE(iOld,iNulo)||' para '||COALESCE(iNew,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.REDESP,NEW.REDESP) <> 1 THEN
         SELECT MIN(ICMSES) INTO iOld FROM TD_IES WHERE CODTAB = OLD.REDESP;
         SELECT MIN(ICMSES) INTO iNew FROM TD_IES WHERE CODTAB = NEW.REDESP;
         cLOG := cLOG||'Reducao cliente especial: de '||COALESCE(iOld,iNulo)||' para '||COALESCE(iNew,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.REDUME,NEW.REDUME) <> 1 THEN
         SELECT MIN(ICMSME) INTO iOld FROM TD_IME WHERE CODTAB = OLD.REDUME;
         SELECT MIN(ICMSME) INTO iNew FROM TD_IME WHERE CODTAB = NEW.REDUME;
         cLOG := cLOG||'Reducao micro empresa: de '||COALESCE(iOld,iNulo)||' para '||COALESCE(iNew,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.REDALI,NEW.REDALI) <> 1 THEN
         SELECT MIN(ICMSRE) INTO iOld FROM TD_IRE WHERE CODTAB = OLD.REDALI;
         SELECT MIN(ICMSRE) INTO iNew FROM TD_IRE WHERE CODTAB = NEW.REDALI;
         cLOG := cLOG||'Reducao ICMS: de '||COALESCE(iOld,iNulo)||' para '||COALESCE(iNew,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.REDUC1,NEW.REDUC1) <> 1 THEN
         SELECT MIN(ICMSR1) INTO iOld FROM TD_IR1 WHERE CODTAB = OLD.REDUC1;
         SELECT MIN(ICMSR1) INTO iNew FROM TD_IR1 WHERE CODTAB = NEW.REDUC1;
         cLOG := cLOG||'Reducao estados c/12%: de '||COALESCE(iOld,iNulo)||' para '||COALESCE(iNew,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.REDUC2,NEW.REDUC2) <> 1 THEN
         SELECT MIN(ICMSR2) INTO iOld FROM TD_IR2 WHERE CODTAB = OLD.REDUC2;
         SELECT MIN(ICMSR2) INTO iNew FROM TD_IR2 WHERE CODTAB = NEW.REDUC2;
         cLOG := cLOG||'Reducao estados c/7%: de '||COALESCE(iOld,iNulo)||' para '||COALESCE(iNew,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.LUCSUB,NEW.LUCSUB) <> 1 THEN
         cLOG := cLOG||'Margem lucro subst.: de '||COALESCE(OLD.LUCSUB,iNulo)||' para '||COALESCE(NEW.LUCSUB,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.MVAVEN,NEW.MVAVEN) <> 1 THEN -- RFMP 71137
         cLOG := cLOG||'% MVA: de '||COALESCE(OLD.MVAVEN,iNulo)||' para '||COALESCE(NEW.MVAVEN,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.MVAC07,NEW.MVAC07) <> 1 THEN -- RFMP 71137
         cLOG := cLOG||'% MVA (Interest. 7%): de '||COALESCE(OLD.MVAC07,iNulo)||' para '||COALESCE(NEW.MVAC07,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.MVAC12,NEW.MVAC12) <> 1 THEN -- RFMP 71137
         cLOG := cLOG||'% MVA (Interest. 12%): de '||COALESCE(OLD.MVAC12,iNulo)||' para '||COALESCE(NEW.MVAC12,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.SUBTRI,NEW.SUBTRI) <> 1 THEN
         cLOG := cLOG||'Substituicao tributaria: de '||COALESCE(DescricaoDominio('IUF','SUBTRI',OLD.SUBTRI),cNulo)||' para '||COALESCE(DescricaoDominio('IUF','SUBTRI',NEW.SUBTRI),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.INSAGR,NEW.INSAGR) <> 1 THEN
         SELECT CASE OLD.INSAGR WHEN 'T' THEN 'Sim'
                                 WHEN 'F' THEN 'No'
                                 ELSE cNulo
         END INTO cOld FROM DUAL;
         SELECT CASE NEW.INSAGR WHEN 'T' THEN 'Sim'
                                 WHEN 'F' THEN 'No'
                                 ELSE cNulo
         END INTO cNew FROM DUAL;
         cLOG := cLOG||'Insumo agricola: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERSRV,NEW.PERSRV) <> 1 THEN
         cLOG := cLOG||'Percentual de servico: de '||COALESCE(OLD.PERSRV,iNulo)||' para '||COALESCE(NEW.PERSRV,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.CALSUB,NEW.CALSUB) <> 1 THEN
         cLOG := cLOG||'Produto Substituicao: de '||COALESCE(OLD.CALSUB,cNulo)||' para '||COALESCE(NEW.CALSUB,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODTRI,NEW.CODTRI) <> 1 THEN
         cLOG := cLOG||'Cod tributario: de '||COALESCE(OLD.CODTRI,iNulo)||' para '||COALESCE(NEW.CODTRI,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.REGESP,NEW.REGESP) <> 1 THEN
         cLOG := cLOG||'Regime Tributario: de '||COALESCE(OLD.REGESP,iNulo)||' para '||COALESCE(NEW.REGESP,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.REDINT,NEW.REDINT) <> 1 THEN
         cLOG := cLOG||'% Red. ICMS Interest: de '||COALESCE(OLD.REDINT,iNulo)||' para '||COALESCE(NEW.REDINT,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.REGESPIMP,NEW.REGESPIMP) <> 1 THEN
         SELECT CASE OLD.REGESPIMP WHEN 'T' THEN 'Sim'
                                    WHEN 'F' THEN 'No'
                                    ELSE cNulo
         END INTO cOld FROM DUAL;
         SELECT CASE NEW.REGESPIMP WHEN 'T' THEN 'Sim'
                                    WHEN 'F' THEN 'No'
                                    ELSE cNulo
         END INTO cNew FROM DUAL;
         cLOG := cLOG||'Regime Especial Imp: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.REDICM,NEW.REDICM) <> 1 THEN
         SELECT CASE OLD.REDICM WHEN 'T' THEN 'Sim'
                                 WHEN 'F' THEN 'No'
                                 ELSE cNulo
         END INTO cOld FROM DUAL;
         SELECT CASE NEW.REDICM WHEN 'T' THEN 'Sim'
                                 WHEN 'F' THEN 'No'
                                 ELSE cNulo
         END INTO cNew FROM DUAL;
         cLOG := cLOG||'Red ICMS na ST: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERFCP,NEW.PERFCP) <> 1 THEN
         cLOG := cLOG||'% do Fundo de Combate  Pobreza: de '||COALESCE(TO_CHAR(OLD.PERFCP),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERFCP),cNulo)||CRLF;
      END IF;      
      IF Equal(OLD.MVAC04,NEW.MVAC04) <> 1 THEN
         cLOG := cLOG||'% MVA para Compra 4% (Margem de Valor Agregado ou Lucro Substitudo): de '||COALESCE(OLD.MVAC04,iNulo)||' para '||COALESCE(NEW.MVAC04,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODBEN_00,NEW.CODBEN_00) <> 1 THEN
         cLOG := cLOG||' Cdigo de Benefcio Fiscal no CST 00: de '||COALESCE(OLD.CODBEN_00,cNulo)||' para '||COALESCE(NEW.CODBEN_00,cNulo)||CRLF;
      END IF;      
      IF Equal(OLD.CODBEN_10,NEW.CODBEN_10) <> 1 THEN
         cLOG := cLOG||' Cdigo de Benefcio Fiscal no CST 10: de '||COALESCE(OLD.CODBEN_10,cNulo)||' para '||COALESCE(NEW.CODBEN_10,cNulo)||CRLF;
      END IF;      
      IF Equal(OLD.CODBEN_20,NEW.CODBEN_20) <> 1 THEN
         cLOG := cLOG||' Cdigo de Benefcio Fiscal no CST 20: de '||COALESCE(OLD.CODBEN_20,cNulo)||' para '||COALESCE(NEW.CODBEN_20,cNulo)||CRLF;
      END IF;      
      IF Equal(OLD.CODBEN_30,NEW.CODBEN_30) <> 1 THEN
         cLOG := cLOG||' Cdigo de Benefcio Fiscal no CST 30: de '||COALESCE(OLD.CODBEN_30,cNulo)||' para '||COALESCE(NEW.CODBEN_30,cNulo)||CRLF;
      END IF;      
      IF Equal(OLD.CODBEN_40,NEW.CODBEN_40) <> 1 THEN
         cLOG := cLOG||' Cdigo de Benefcio Fiscal no CST 40: de '||COALESCE(OLD.CODBEN_40,cNulo)||' para '||COALESCE(NEW.CODBEN_40,cNulo)||CRLF;
      END IF;      
      IF Equal(OLD.CODBEN_41,NEW.CODBEN_41) <> 1 THEN
         cLOG := cLOG||' Cdigo de Benefcio Fiscal no CST 41: de '||COALESCE(OLD.CODBEN_41,cNulo)||' para '||COALESCE(NEW.CODBEN_41,cNulo)||CRLF;
      END IF;      
      IF Equal(OLD.CODBEN_50,NEW.CODBEN_50) <> 1 THEN
         cLOG := cLOG||' Cdigo de Benefcio Fiscal no CST 50: de '||COALESCE(OLD.CODBEN_50,cNulo)||' para '||COALESCE(NEW.CODBEN_50,cNulo)||CRLF;
      END IF;      
      IF Equal(OLD.CODBEN_51,NEW.CODBEN_51) <> 1 THEN
         cLOG := cLOG||' Cdigo de Benefcio Fiscal no CST 51: de '||COALESCE(OLD.CODBEN_51,cNulo)||' para '||COALESCE(NEW.CODBEN_51,cNulo)||CRLF;
      END IF;      
      IF Equal(OLD.CODBEN_60,NEW.CODBEN_60) <> 1 THEN
         cLOG := cLOG||' Cdigo de Benefcio Fiscal no CST 60: de '||COALESCE(OLD.CODBEN_60,cNulo)||' para '||COALESCE(NEW.CODBEN_60,cNulo)||CRLF;
      END IF;      
      IF Equal(OLD.CODBEN_70,NEW.CODBEN_70) <> 1 THEN
         cLOG := cLOG||' Cdigo de Benefcio Fiscal no CST 70: de '||COALESCE(OLD.CODBEN_70,cNulo)||' para '||COALESCE(NEW.CODBEN_70,cNulo)||CRLF;
      END IF;      
      IF Equal(OLD.CODBEN_90,NEW.CODBEN_90) <> 1 THEN
         cLOG := cLOG||' Cdigo de Benefcio Fiscal no CST 90: de '||COALESCE(OLD.CODBEN_90,cNulo)||' para '||COALESCE(NEW.CODBEN_90,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERDIF,NEW.PERDIF) <> 1 THEN
         cLOG := cLOG||'% ICMS Diferimento: de '||COALESCE(TO_CHAR(OLD.PERDIF),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERDIF),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ALIDIF,NEW.ALIDIF) <> 1 THEN
         SELECT MIN(RESICM) INTO iOld FROM TD_ICM WHERE CODTAB = OLD.ALIDIF;
         SELECT MIN(RESICM) INTO iNew FROM TD_ICM WHERE CODTAB = NEW.ALIDIF;
         cLOG := cLOG||'Alquota Interna Diferenciada: de '||COALESCE(iOld,iNulo)||' para '||COALESCE(iNew,iNulo)||CRLF;
      END IF;
       IF Equal(OLD.REGDIF,NEW.REGDIF) <> 1 THEN
         cLOG := cLOG||'Regra para Alquota Diferenciada: de '||COALESCE(DescricaoDominio('IUF','REGDIF',OLD.REGDIF),cNulo)||' para '||COALESCE(DescricaoDominio('IUF','REGDIF',NEW.REGDIF),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.REDDIFAL,NEW.REDDIFAL) <> 1 THEN
         cLog := cLog||'Percentual de Reduo do DIFAL/Partilha: de '||COALESCE(TO_CHAR(OLD.REDDIFAL,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.REDDIFAL,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      

      IF (ISNOTNULL(cLOG)='T') THEN
         cLOG := cLogChave || ' >> ' || cLOG;
      END IF;
      
      -- MN - Trata log de alteraes de impostos do produto.  exportado no registro H020 do SPED com motivo do inventrio 02
      IF Equal(OLD.ESTADO, NEW.ESTADO) <> 1 OR Equal(OLD.REGESP, NEW.REGESP) <> 1 OR 
         Equal(OLD.SUBTRI, NEW.SUBTRI) <> 1 OR Equal(OLD.RESICM, NEW.RESICM) <> 1 OR 
         Equal(OLD.REDALI, NEW.REDALI) <> 1 OR Equal(OLD.REDICM, NEW.REDICM) <> 1 OR 
         Equal(OLD.REDINT, NEW.REDINT) <> 1 OR Equal(OLD.REDSIM, NEW.REDSIM) <> 1 OR 
         Equal(OLD.MVAVEN, NEW.MVAVEN) <> 1 OR Equal(OLD.PERFCP, NEW.PERFCP) <> 1 THEN
            INSERT INTO TL_PRO_SPED (FILMAT, CODMAT, TIPLOG, SIGLAUF, REGESP, SUBTRI, RESICM, REDALI, 
                                     REDICM, REDINT, REDSIM, MVAVEN, PERFCP)
               VALUES (OLD.FILMAT, OLD.CODMAT, 'I', OLD.ESTADO, OLD.REGESP, OLD.SUBTRI, OLD.RESICM, OLD.REDALI, 
                       OLD.REDICM, OLD.REDINT, OLD.REDSIM, OLD.MVAVEN, OLD.PERFCP);
      END IF;
   END IF;
   
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN
      IF (ISNOTNULL(cLOG)='T') THEN
         INSERT INTO TL_PRO (FILMAT,CODMAT,DATOPE,MSGLOG)
                     VALUES (NEW.FILMAT,NEW.CODMAT,agora(),cLOG);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4462 --*/
CREATE TRIGGER TGIUF2
AFTER INSERT OR UPDATE OR DELETE ON TT_IUF 
FOR EACH ROW EXECUTE PROCEDURE TGIUF2();

/*-- SEQ 4463 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIUF_ASS() CASCADE;

/*-- SEQ 4464 --*/
CREATE OR REPLACE FUNCTION TGIUF_ASS() RETURNS TRIGGER AS $$
-- 83073
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN

  IF ExisteFilialNaUF('SC') THEN
     IF (TG_OP = 'INSERT') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG + 1
        WHERE NOMTAB = 'TT_IUF';
     END IF;
     
     IF (TG_OP = 'DELETE') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG - 1
        WHERE NOMTAB = 'TT_IUF';
     END IF;  
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4465 --*/
CREATE TRIGGER TGIUF_ASS
AFTER INSERT OR DELETE ON TT_IUF 
FOR EACH ROW EXECUTE PROCEDURE TGIUF_ASS();


/*-- SEQ 4466 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIUSU() CASCADE;

/*-- SEQ 4467 --*/
CREATE OR REPLACE FUNCTION TGIUSU() RETURNS TRIGGER AS $$
DECLARE
  proximo      Numeric;
BEGIN
  
  IF (TG_OP = 'INSERT') THEN    
     IF COALESCE(NEW.ID_IUSU,0)=0 THEN
        SELECT NEXTVAL('SQIUSU')  INTO proximo FROM DUAL;
        NEW.ID_IUSU := proximo;
     END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4468 --*/
CREATE TRIGGER TGIUSU
BEFORE INSERT ON TI_USU 
FOR EACH ROW EXECUTE PROCEDURE TGIUSU();



/*-- SEQ 4469 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIVE2() CASCADE;

/*-- SEQ 4470 --*/
CREATE OR REPLACE FUNCTION TGIVE2() RETURNS TRIGGER AS $$

  -- Objetivo:
  -- 1) Permitir apenas alteracao de SITMOV
  -- 2) Atualizar saldos
  -- 3) Ajusta "flag" do orcamento (se houver)
  -- 4) Atualizar saldos
  -- 5) Atualizar a movimentacao diaria
  -- 6) Sincronizar datas entre TT_VEN e TT_IVE
  -- 7) Fazer parte do papel de uma "foreign key"
  -- 8) Converter embalagens numa incluso
  -- 9) Validar se existe FILCPM e SEQCPM na tabela TT_CPM
DECLARE
  wk_Data                        TT_IVE.VEN_DATHOR%TYPE;
  wk_Vinculo                     TT_IVE.VINCUL%TYPE;

  flag                           TT_IOR.FLGEST%TYPE;

  -- Para controle de embalagens
  NovoCODTAM                     TT_IVE.CODTAM%TYPE;
  NovoQTDMOV                     TT_IVE.QTDMOV%TYPE;
  NovoEMBORI                     TT_IVE.EMBORI%TYPE;
  NovoEMBQTD                     TT_IVE.EMBQTD%TYPE;

  inRec                          TT_IVE%ROWTYPE;

  vComplemento                   CONSTANT VARCHAR(100) := constante('complemento');
  vVem_de_TGVEN_TT               CONSTANT VARCHAR(1) := constante('vem_de_tgven_tt');
  vVem_de_TGVEN_TF               CONSTANT VARCHAR(1) := constante('vem_de_tgven_tf');
  vVem_de_TGVEN_FT               CONSTANT VARCHAR(1) := constante('vem_de_tgven_ft');
  vVem_de_TGVEN_FF               CONSTANT VARCHAR(1) := constante('vem_de_tgven_ff');
  vVem_de_CALCUSME               CONSTANT VARCHAR(1) := constante('vem_de_calcusmed');
  vVem_de_ATU_RES_PEND           CONSTANT VARCHAR(1) := constante('VEM_DE_ATU_RES_PEND');
  vALTERA_TIPENT                 CONSTANT VARCHAR(1) := constante('ALTERA_TIPENT');
  vVEM_DE_TGVEN_DV               CONSTANT VARCHAR(100) := constante('vem_de_tgven_dv');
  vVEM_DE_TGVEN_DV_CMS           CONSTANT VARCHAR(100) := constante('vem_de_tgven_dv_cms');

  cCODFIL                        TT_IOR.CODFIL%TYPE;
  cTIPPED                        TT_IOR.TIPPED%TYPE;
  cNUMPED                        TT_IOR.NUMPED%TYPE;

  vModificou                     BOOLEAN;
  cDUMMY                         VARCHAR(1);

  bCalculaCusto                  BOOLEAN;
  wk_achou                       INTEGER;

  WK_REGESP                      TD_FIL.REGESP%TYPE;
  WK_UFLOJA                      TD_FIL.UFLOJA%TYPE;
  WK_CALSUB                      TT_IUF.CALSUB%TYPE;
  WK_SITTRI                      TT_IVE.SITTRI%TYPE;

  WK_MOVEST                      TT_SAL.MOVEST%TYPE;
  WK_RESERVA_VENDA               CHAR(1);

  iQTD_GRADE                     INTEGER;
  -- 84616
  iCODABA                        INTEGER;
  WK_ENCONTROU                   CHAR(1) := 'F';
  WK_FILMAT                      TT_IVE.FILMAT%TYPE;
  WK_CODMAT                      TT_IVE.CODMAT%TYPE;
  WK_CODCOR                      TT_IVE.CODCOR%TYPE;
  WK_CODTAM                      TT_IVE.CODTAM%TYPE;

  vBASUBS                        TT_VEN.BASUBS%TYPE;

  WK_RESERVA_ENT_FUT             TT_CFG.RESERVA_ENT_FUT%TYPE;
  WK_VALORTRANSFERENCIA          TT_CFG.VALORTRANSFERENCIA%TYPE;
  WK_OLD_QTDFUT                  TT_IVE.QTDFUT%TYPE;
  WK_NEW_QTDFUT                  TT_IVE.QTDFUT%TYPE;

   nVLR_CM_ORI                   TT_ICO.VLR_CM%TYPE;
   nVLR_CMG_ORI                  TT_ICO.VLRCMG%TYPE;
   nVlr_CM                       TT_ICO.VLR_CM%TYPE;
   nVlrCMG                       TT_ICO.VLRCMG%TYPE;
   nBASICM_CM_ORI                TT_ICO.BASICM_CM%TYPE; 
   nVLRICM_CM_ORI                TT_ICO.VLRICM_CM%TYPE; 
   nBAS_ST_CM_ORI                TT_ICO.BAS_ST_CM%TYPE;
   nVLR_ST_CM_ORI                TT_ICO.VLR_ST_CM%TYPE;  

   cTipNat                        TD_NAT.TIPNAT%TYPE;

  --LEO 84337
  vSESSIONID                     TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

  -- RFMP 85136
  WK_UID                         TPC_UID_Retorno%ROWTYPE;

  bGeraNFT                       BOOLEAN;
  
  WK_FILCPM                      TT_IVE.FILCPM%TYPE;
  WK_SEQCPM                      TT_IVE.SEQCPM%TYPE;
  iQTD_CPM                       INTEGER;
  
  vTIPNAT                        TD_NAT.TIPNAT%TYPE;    
  
-- Principal
BEGIN
  -- Impede exclusoes
  IF (TG_OP = 'DELETE') THEN
     RAISE EXCEPTION 'PG-20027 Exclusao so pode ser feita atraves da rotina Manutencao. % ' , vComplemento;
  END IF;

  -- MN - 2024044856 - O checkout insere errado QTDFUT em nota de remessa, isso gera uma dor de cabea gigantesca
  -- porque o sistema movimenta a TR_MOV, que faz com que o saldo fique errado de tabela, e gere problema no estoque do Cliente
  -- por esse motivo, quando estiver inserindo, se for remessa, deve zerar qtdfut
  IF (TG_OP = 'INSERT') THEN 
    SELECT TIPNAT
      INTO vTIPNAT
     FROM TD_NAT 
    WHERE NATDEN = NEW.NATFIS
       OR NATFOR = NEW.NATFIS;
       
    IF COALESCE(vTIPNAT, 'X') = 'A' AND COALESCE(NEW.QTDFUT, 0) > 0 THEN
      NEW.QTDFUT := NULL;    
      NEW.FLGFUT := NULL;
    END IF;
  END IF;

  IF (COALESCE(NEW.DUMMY, 'X') <> '%') THEN
  IF (TG_OP = 'UPDATE') THEN
    IF OLD.SIGNAT <> NEW.SIGNAT THEN
       RAISE EXCEPTION 'PG-20003 Registro foi alterado por outro usurio, refaa a consulta e tente gravar novamente. %' , vComplemento;
    END IF;
    NEW.SIGNAT := MOD(OLD.SIGNAT + 1,100000);
  END IF;

  -- Impede alteraces
  IF (TG_OP = 'UPDATE') THEN
     IF (OLD.CODFIL <> NEW.CODFIL) OR
        (OLD.NUMITE <> NEW.NUMITE) OR
        (OLD.FILMAT <> NEW.FILMAT) OR
        (OLD.CODMAT <> NEW.CODMAT) OR
        (OLD.CODCOR <> NEW.CODCOR) OR
        (OLD.CODTAM <> NEW.CODTAM) OR
        (OLD.CODMUL <> NEW.CODMUL) OR
--        (OLD.QTDMOV <> NEW.QTDMOV) OR
--        (OLD.VLRMOV <> NEW.VLRMOV) OR
--        (OLD.EMBQTD <> NEW.EMBQTD) OR
        ((OLD.QTDMOV <> NEW.QTDMOV) AND (COALESCE(NEW.DUMMY,'XX') <> vALTERA_TIPENT)) OR  --57914
        ((OLD.VLRMOV <> NEW.VLRMOV) AND (COALESCE(NEW.DUMMY,'XX') <> vALTERA_TIPENT)) OR
        ((OLD.EMBQTD <> NEW.EMBQTD) AND (COALESCE(NEW.DUMMY,'XX') <> vALTERA_TIPENT)) OR
        (OLD.SITKIT <> NEW.SITKIT) OR
        (OLD.FILORI <> NEW.FILORI) OR
        (OLD.NUMORI <> NEW.NUMORI) OR
        (OLD.ITEORI <> NEW.ITEORI) OR
        (OLD.NUMEXT <> NEW.NUMEXT) OR
        (OLD.LANEST <> NEW.LANEST) OR
        (OLD.EMBORI <> NEW.EMBORI) OR
        (OLD.DATINC <> NEW.DATINC) OR
        (OLD.VEN_DATHOR <> NEW.VEN_DATHOR) THEN
       RAISE EXCEPTION 'PG-20012 Um item de venda nao pode ser modificado. %' , vComplemento;
    END IF;

/*
    IF (OLD.SITMOV = 'C') AND (NEW.SITMOV = 'N') THEN
       RAISE EXCEPTION 'PG-20013 Um item de venda cancelado nao pode ser reativado. %' , vComplemento;
    END IF;
*/

    IF (OLD.EXPORT <> NEW.EXPORT) THEN
       IF NOT ( (OLD.EXPORT = 'F') AND (NEW.EXPORT = 'T') OR
                (OLD.EXPORT = 'T') AND (NEW.EXPORT = 'R') OR
                (OLD.EXPORT = 'R') AND (NEW.EXPORT = 'C') ) THEN
       RAISE EXCEPTION 'PG-20015 Esta alteracao do controle de exportacao nao eh permitida. %' , vComplemento;
       END IF;
    END IF;

  END IF;

  -- NAO FAZER NENHUMA OPERACAO QUE DEPENDA DE FILMAT , CODMAT, CODCOR, CODTAM ANTES DESSE BLOCO
  -- RFMP 70299 uniao de grade
  -- tratamento para pegar novo filmat, codmat, codcor, codtam caso a grade tenha sido unida a outra
  IF ((TG_OP = 'INSERT')) OR ((TG_OP = 'UPDATE')) THEN
    -- verifica se grade existe
    SELECT COUNT(*)
      INTO iQTD_GRADE
      FROM TT_GRA
     WHERE FILMAT = NEW.FILMAT
       AND CODMAT = NEW.CODMAT
       AND CODCOR = NEW.CODCOR
       AND CODTAM = NEW.CODTAM;
    IF iQTD_GRADE = 0 THEN
      WK_FILMAT := NEW.FILMAT;
      WK_CODMAT := NEW.CODMAT;
      WK_CODCOR := NEW.CODCOR;
      WK_CODTAM := NEW.CODTAM;
      -- procura se grade foi unida a outra
      FOR i IN 1..10 LOOP -- numero de tentativas
                  SELECT MGRA.FILMAT, MGRA.CODMAT, MGRA.CODCOR, MGRA.CODTAM, CASE WHEN GRA.FILMAT IS NULL THEN 'F' ELSE 'T' END
            INTO WK_FILMAT, WK_CODMAT, WK_CODCOR, WK_CODTAM, WK_ENCONTROU
            FROM TM_GRA MGRA LEFT JOIN TT_GRA GRA ON MGRA.FILMAT = GRA.FILMAT
                                                 AND MGRA.CODMAT = GRA.CODMAT
                                                 AND MGRA.CODCOR = GRA.CODCOR
                                                 AND MGRA.CODTAM = GRA.CODTAM
           WHERE MGRA.FILOLD = WK_FILMAT
             AND MGRA.CODOLD = WK_CODMAT
             AND MGRA.COROLD = WK_CODCOR
             AND MGRA.TAMOLD = WK_CODTAM;
                EXIT WHEN (WK_ENCONTROU = 'T') OR (WK_FILMAT IS NULL); -- encontrou ora/pg ou nao encontrou no postgree
      END LOOP;
      IF WK_ENCONTROU = 'T' THEN
         NEW.FILMAT := WK_FILMAT;
         NEW.CODMAT := WK_CODMAT;
         NEW.CODCOR := WK_CODCOR;
         NEW.CODTAM := WK_CODTAM;
      ELSE
         RAISE EXCEPTION 'PG-20020 Produto informado na venda no existe na base de dados. Chave: [%-%-%-%] %' , NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,vComplemento;
      END IF;
    END IF;
  END IF;

--58442 saiu daqui

  IF (TG_OP = 'UPDATE') THEN

    
    -- se mudou qtdpen e nao foi atualizado pela funcao atu_reservapendente
    IF (Equal(NEW.QTDPEN,OLD.QTDPEN) <> 1)
    AND(Equal(NEW.DUMMY,vVem_de_ATU_RES_PEND) <> 1)
    AND(Equal(NEW.DUMMY,vVem_de_CALCUSME) <> 1) THEN
      NEW.QTDPEN := COALESCE(CalculaQTDPendente(NEW.CODFIL, NEW.SEQUEN, NEW.NUMITE, NEW.QTDMOV),0);
    END IF;
    
    -- RFMP 71241 - Cancelou item
    IF (OLD.SITMOV = 'N') AND (NEW.SITMOV = 'C') THEN
      IF COALESCE(NEW.QTDPEN,0) > 0 THEN
        NEW.QTDPEN := 0;
      END IF;
      NEW.DATCAN:=agora();

      -- Rhuan - 103896 - Limpa o vnculo com TT_ICOXLOT
      UPDATE TT_ICOXLOT
         SET FILDEV = NULL,
             SEQDEV = NULL,
             ITEDEV = NULL
       WHERE FILDEV = NEW.CODFIL
         AND SEQDEV = NEW.SEQUEN
         AND ITEDEV = NEW.NUMITE;
    END IF;

    -- o qtdfut nunca deve ser maior que o qtdpen ao atualizar
    -- fazer isso antes de qualquer atualizao de estoque
    IF COALESCE(NEW.QTDFUT,0)>COALESCE(NEW.QTDPEN,0) THEN
      IF COALESCE(NEW.QTDPEN,0) < 0 THEN
        NEW.QTDFUT := 0;
      ELSE
        NEW.QTDFUT := NEW.QTDPEN;
      END IF;
    END IF;

    IF (COALESCE(NEW.QTDPEN,0) > 0) AND (COALESCE(OLD.FLGFUT,'XX') <> 'E')  THEN  --57914
      NEW.FLGFUT := 'A';
    ELSIF (NEW.QTDFUT = NEW.QTDPEN) AND (NEW.QTDPEN = 0) THEN
      NEW.FLGFUT := 'P';
    END IF;

    -- se mudou qtdpen abrir o orcamento para poder criar uma nova separacao
    IF ((Equal(NEW.QTDPEN,OLD.QTDPEN) <> 1)
    OR  (Equal(NEW.QTDFUT,OLD.QTDFUT) <> 1))
    AND (COALESCE(NEW.QTDPEN,0)-COALESCE(NEW.QTDFUT,0) > 0) THEN
      UPDATE TT_IOR
         SET FLGIVO = 'A'
       WHERE FILIVE = NEW.CODFIL
         AND SEQIVE = NEW.SEQUEN
         AND NUMIVE = NEW.NUMITE
         AND FLGIVO <> 'A';   --57914
    END IF;
  END IF;

  IF ((TG_OP = 'INSERT')) OR ((TG_OP = 'UPDATE')) THEN
    IF (NEW.NUMORI IS NOT NULL) AND (NEW.FILORI IS NULL) THEN
      NEW.FILORI := NEW.CODFIL;
    END IF;

    -- Pedro E. Braga - 97773 - Impedir Inclusso de Remessa sem vinculo completo com a Fatura.
    IF  (NEW.LANEST = 'C')
    AND (ISNULL(NEW.FILORI)='T' OR ISNULL(NEW.NUMORI)='T' OR ISNULL(TO_CHAR(NEW.ITEORI))='T') THEN
      IF ((TG_OP = 'INSERT')) THEN
         RAISE EXCEPTION 'PG-20015 Para nota de Remessa deve ser informado vinculo com a Nota de Fatura. %' , vComplemento;
      ELSIF ((TG_OP = 'UPDATE')) THEN
         IF (Equal(OLD.LANEST,NEW.LANEST) <> 1)
         OR (Equal(OLD.FILORI,NEW.FILORI) <> 1)
         OR (Equal(OLD.NUMORI,NEW.NUMORI) <> 1)
         OR (Equal(OLD.ITEORI,NEW.ITEORI) <> 1) THEN
            RAISE EXCEPTION 'PG-20015 Para nota de Remessa deve ser informado vinculo com a Nota de Fatura. %' , vComplemento;
         END IF;
      END IF;
    END IF;

    IF (NEW.TIPPRO = '1') THEN
       NEW.LANEST := 'N';
       NEW.TRAIMP := null;
    END IF;
  END IF;

  IF ((TG_OP = 'INSERT')) OR ((TG_OP = 'UPDATE')) THEN
    -- RFMP 59685 Verifica se movimenta estoque
    WK_MOVEST := MovimentaEstoque(NEW.CODFIL,NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,NEW.CODMUL);

    -- RFMP 65536 PCIA Verifica se deve reservar venda
    WK_RESERVA_VENDA := ReservaVenda();

    -- RFMP - 78593 - Reserva entrega futura
    SELECT RESERVA_ENT_FUT, VALORTRANSFERENCIA
      INTO WK_RESERVA_ENT_FUT, WK_VALORTRANSFERENCIA
      FROM TT_CFG;
  END IF;

  -- Validar se existe FILCPM e SEQCPM na tabela TT_CPM
  IF ((TG_OP = 'INSERT')) OR ((TG_OP = 'UPDATE')) THEN
      IF (ISNOTNULL(NEW.FILCPM) = 'T') AND (ISNOTNULL(NEW.SEQCPM) = 'T') THEN
         SELECT COUNT(*) INTO iQTD_CPM
           FROM TT_CPM
          WHERE FILCPM = NEW.FILCPM
            AND SEQUEN = NEW.SEQCPM;

         IF (iQTD_CPM = 0) THEN
            NEW.FILCPM := NULL;
            NEW.SEQCPM := NULL;
         END IF;
      END IF;
  END IF;

  IF (TG_OP = 'UPDATE') THEN
     -- Cancelando
     IF ((OLD.SITMOV = 'N') AND (NEW.SITMOV = 'C')) or
        ((OLD.SITMOV = 'C') AND (NEW.SITMOV = 'N')) THEN -- Descancelando
     -- Ao cancelar uma devoluo (SITMOV = C AND VLRMOV < 0), indicar que consignao no possui devoluo / 80198
        IF (NEW.VLRMOV < 0) THEN
          UPDATE TT_IVEXCSG
             SET NF_DEV = 'F'
           WHERE NF_DEV = 'T'
             AND FILREM = NEW.FILORI
             AND SEQREM = NEW.NUMORI
             AND ITEREM = NEW.ITEORI;
        END IF;

        UPDATE TT_IVEXCSG
           SET FILFAT = NULL,
               SEQFAT = NULL,
               ITEFAT = NULL
         WHERE FILFAT = NEW.CODFIL
           AND SEQFAT = NEW.SEQUEN
           AND ITEFAT = NEW.NUMITE;


        --36925
        --verificar se h uma LAN vinculada
        SELECT count(*) INTO wk_achou
          FROM TT_LAN
         WHERE FILIVE = NEW.CODFIL  AND SEQIVE = NEW.SEQUEN  AND NUMIVE = NEW.NUMITE;

        IF  wk_achou > 0 THEN
          INSERT INTO TT_LAN (CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,DATMOV,ATU_EM,QTDMOV,VLRMOV,
                              FILUSU,CODUSU,TIPMOV,NUMEXT,SITMOV,DOCUME,TIPLAN,OBSERV,EMBORI,
                              CODMUL,DATINC,FILIVE,SEQIVE,NUMIVE,EMBQTD)
                      (SELECT CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,DATMOV,ATU_EM,QTDMOV*-1 ,VLRMOV*-1,
                              FILUSU,CODUSU,TIPMOV,NUMEXT,SITMOV,DOCUME,TIPLAN,OBSERV,EMBORI,
                              CODMUL,DATINC,FILIVE,SEQIVE,NUMIVE,EMBQTD FROM TT_LAN
                        WHERE FILIVE = NEW.CODFIL  AND SEQIVE = NEW.SEQUEN  AND NUMIVE = NEW.NUMITE);
        END IF;
        --36925
        IF OLD.EXPORT = 'T' THEN
           NEW.EXPORT := 'R';
        END IF;

        -- Limpa vnculo com a fatura. Em Oracle esse processo  feito na funo Atu_ReservaPendente
        
        IF NEW.VINCUL<>'N' THEN
           -- Cancela auto relacionamento
           NEW.FILORI := Null;
           NEW.NUMORI := Null;
           NEW.ITEORI := Null;
        END IF;
        
        --NEW.DATINC := AGORA();

                   inRec.CODFIL := NEW.CODFIL;
           inRec.SEQUEN := NEW.SEQUEN;
           inRec.NUMITE := NEW.NUMITE;
           inRec.FILORI := OLD.FILORI;
           inRec.NUMORI := OLD.NUMORI;
           inRec.ITEORI := OLD.ITEORI;
           inRec.SITMOV := NEW.SITMOV;
           
             cDUMMY := PC_IVE_UPDATE(inREC.CODFIL,inREC.SEQUEN,inREC.NUMITE,inREC.FILORI,inREC.NUMORI,inREC.ITEORI,inREC.SITMOV);
                   
        -- Vai aumentar o saldo porque a venda (ou saida) sera estornada
        IF  (NEW.LANEST <> 'N')
        AND (WK_MOVEST = 'T') THEN
           IF  (NEW.SITKIT <> '1')
           AND (NEW.LANEST IN ('C','S')) THEN

               cDUMMY := TGR_IVE_Atualiza_Saldo(OLD.QTDMOV, NEW.CODFIL, NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM, NEW.CODMUL);

               cDUMMY := TGR_IVE_Atualiza_Movimento(OLD.QTDMOV * -1,OLD.VLRMOV * -1, NEW.CODFIL, NEW.SEQUEN, NEW.FILMAT, NEW.CODMAT,
                                                    NEW.CODCOR, NEW.CODTAM, NEW.CODMUL, NEW.VEN_DATHOR, NEW.DUMMY, NEW.PROMOC);

               IF  (NEW.FILLOT IS NOT NULL)
               AND (NEW.SEQLOT IS NOT NULL) THEN
                  cDUMMY := TGR_IVE_Atualiza_Saldo_Lote(OLD.QTDMOV, NEW.CODFIL, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT);
               END IF;
           END IF;

           IF (NEW.LANEST = 'C') and (NEW.SITKIT <> '1') and (Equal(NEW.DUMMY,vVem_de_CALCUSME) <> 1) THEN
                             inRec.CODFIL      := NEW.CODFIL;
                inRec.SEQUEN      := NEW.SEQUEN;
                inRec.NUMITE      := NEW.NUMITE;
                inRec.VEN_DATHOR  := NEW.VEN_DATHOR;
                inRec.FILMAT      := NEW.FILMAT;
                inRec.CODMAT      := NEW.CODMAT;
                inRec.CODCOR      := NEW.CODCOR;
                inRec.CODTAM      := NEW.CODTAM;
                inRec.DUMMY       := 'X';
                inRec.QTDMOV      := NEW.QTDMOV;
                inRec.FILRES      := NEW.FILRES;
                inRec.FILLOT      := NEW.FILLOT;
                inRec.SEQLOT      := NEW.SEQLOT;
                inRec.CODMUL      := NEW.CODMUL;
                inRec.NUMEXT      := NEW.NUMEXT; -- MN - 103975

                
                cDUMMY := PC_IVE_AUX_UPDATE(inREC.VEN_DATHOR,
                                            inREC.CODFIL,
                                            inREC.FILMAT,
                                            inREC.CODMAT,
                                            inREC.CODCOR,
                                            inREC.CODTAM,
                                            inRec.DUMMY,
                                            inRec.SEQUEN,
                                            inRec.NUMITE,
                                            inRec.QTDMOV,
                                            inRec.FILRES,
                                            inRec.FILLOT,
                                            inRec.SEQLOT,
                                            inRec.CODMUL,
                                            inRec.NUMEXT);
                                        END IF;
           IF (NEW.LANEST = 'R' and NEW.SITKIT <> '1') and (Equal(NEW.DUMMY,vVem_de_CALCUSME) <> 1) THEN
             IF NEW.FILORI IS NULL THEN
               IF WK_RESERVA_VENDA = 'T' THEN
                 -- RFMP 80324
                 -- RFMP 78593
                 -- Ao efetivar a venda de Entrega Futura o sistema deve reservar a mercadoria.
                 -- Sistema no deve reservar em caso de Venda sob Encomenda.
                 IF  (WK_RESERVA_ENT_FUT = 'T')
                 AND (NEW.FLGFUT <> 'E') THEN
                    WK_OLD_QTDFUT := 0;
                    WK_NEW_QTDFUT := 0;
                 ELSE
                    WK_OLD_QTDFUT := COALESCE(OLD.QTDFUT,0);
                    WK_NEW_QTDFUT := COALESCE(NEW.QTDFUT,0);
                 END IF;
                 -- RFMP 71241
                 cDUMMY := TGR_IVE_Atualiza_Reserva(((COALESCE(NEW.QTDPEN,0)-WK_NEW_QTDFUT) - (COALESCE(OLD.QTDPEN,0)-WK_OLD_QTDFUT)), NEW.codfil, NEW.FILMAT, NEW.CODMAT,
                                                    NEW.CODCOR, NEW.CODTAM, NEW.CODMUL, NEW.FILRES);

                 IF (NEW.FILLOT IS NOT NULL) AND (NEW.SEQLOT IS NOT NULL) THEN
                    cDUMMY:=TGR_IVE_Atualiza_Reserva_Lote(((COALESCE(NEW.QTDPEN,0)-WK_NEW_QTDFUT) - (COALESCE(OLD.QTDPEN,0)-WK_OLD_QTDFUT)), NEW.codfil, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT, NEW.FILRES);
                 END IF;
               END IF;
             ELSE
                                 inRec.CODFIL      := NEW.CODFIL;
                  inRec.SEQUEN      := NEW.SEQUEN;
                  inRec.NUMITE      := NEW.NUMITE;
                  inRec.VEN_DATHOR  := NEW.VEN_DATHOR;
                  inRec.FILMAT      := NEW.FILMAT;
                  inRec.CODMAT      := NEW.CODMAT;
                  inRec.CODCOR      := NEW.CODCOR;
                  inRec.CODTAM      := NEW.CODTAM;
                  inRec.DUMMY       := CASE WHEN (Equal(NEW.DUMMY,vVem_de_CALCUSME) = 1) THEN NEW.DUMMY ELSE 'R' END;
                  inRec.QTDMOV      := NEW.QTDMOV * -1;
                  inRec.FILRES      := NEW.FILRES;
                  inRec.FILLOT      := NEW.FILLOT;
                  inRec.SEQLOT      := NEW.SEQLOT;
                  inRec.CODMUL      := NEW.CODMUL;
                  inRec.NUMEXT      := NEW.NUMEXT; -- MN - 103975

                  
                  cDUMMY := PC_IVE_AUX_UPDATE(inREC.VEN_DATHOR,
                                              inREC.CODFIL,
                                              inREC.FILMAT,
                                              inREC.CODMAT,
                                              inREC.CODCOR,
                                              inREC.CODTAM,
                                              inRec.DUMMY,
                                              inRec.SEQUEN,
                                              inRec.NUMITE,
                                              inRec.QTDMOV,
                                              inRec.FILRES,
                                              inRec.FILLOT,
                                              inRec.SEQLOT,
                                              inRec.CODMUL,
                                              inRec.NUMEXT);
                                              END IF;
           END IF;
           -- Pedro E. Braga - 97964
           IF (NEW.LANEST = 'S') AND (NEW.TIPPRO <> '1') AND (NEW.TRAIMP = '1') THEN
             IF (NEW.SITMOV = 'C') THEN -- Cancelando
                cDUMMY := TGR_IVE_Atualiza_Reserva(NEW.QTDMOV, NEW.CODFIL, NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM, NEW.CODMUL, NEW.FILRES);

                IF (NEW.FILLOT IS NOT NULL) AND (NEW.SEQLOT IS NOT NULL) THEN
                  cDUMMY:=TGR_IVE_Atualiza_Reserva_Lote(NEW.QTDMOV, NEW.CODFIL, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT, NEW.FILRES);
                END IF;
             ELSIF (NEW.SITMOV = 'N') THEN -- Descancelando
               cDUMMY := TGR_IVE_Atualiza_Reserva(NEW.QTDMOV * -1, NEW.CODFIL, NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM, NEW.CODMUL, NEW.FILRES);

                IF (NEW.FILLOT IS NOT NULL) AND (NEW.SEQLOT IS NOT NULL) THEN
                  cDUMMY:=TGR_IVE_Atualiza_Reserva_Lote(NEW.QTDMOV * -1, NEW.CODFIL, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT, NEW.FILRES);
                END IF;
             END IF;
           END IF;
        END IF;

        -- Exclui as transferencias pendentes
        delete from tt_tra
         where filive=NEW.codfil
           and seqive=NEW.sequen
           and numive=NEW.numite
           and seqico is null;

     END IF;

     NEW.ATU_EM := AGORA();

     -- "Flag" para evitar acessar TT_VEN
     IF ((NEW.DUMMY IS NULL) or (NEW.DUMMY not in (vVem_de_TGVEN_TT,
                                                     vVem_de_TGVEN_TF,
                                                     vVem_de_TGVEN_FT,
                                                     vVem_de_TGVEN_FF,
                                                     vVem_de_CALCUSME,
                                                     vVEM_DE_TGVEN_DV,
                                                     vVEM_DE_TGVEN_DV_CMS))) THEN
        -- RFMP 96851
        -- Passar DUMMY para TGVEN no chamar package de devoluo de comisso
        -- que faz select na TT_IVE.
        UPDATE TT_VEN
           SET ATU_EM = agora(),
               DUMMY  = Constante('VEM_DE_TGIVE')
         WHERE SEQUEN = OLD.SEQUEN
           AND CODFIL = OLD.CODFIL;
     END IF;

    -- Ignorando mudanca no vinculo
/*     IF NEW.VINCUL != OLD.VINCUL THEN
        -- Sincroniza data e vinculo
        SELECT CASE VINCUL WHEN 'T'  THEN 'A'
                           ELSE 'N'
               END
          INTO wk_Vinculo
          FROM TT_VEN
         WHERE CODFIL = NEW.CODFIL
           AND SEQUEN = NEW.SEQUEN;
        NEW.VINCUL     := wk_Vinculo;
     END IF;
*/

    IF (COALESCE(OLD.QTDFUT,0) <> COALESCE(NEW.QTDFUT,0))
    OR (COALESCE(OLD.QTDPEN,0) <> COALESCE(NEW.QTDPEN,0)) THEN
      NEW.PENATU := 'T';
      IF (NEW.SITMOV <> 'C') THEN
        IF  (NEW.LANEST <> 'N')
        AND (WK_MOVEST = 'T') THEN
          IF  (NEW.SITKIT <> '1')
          AND (NEW.LANEST IN ('C','S')) THEN

            cDUMMY := TGR_IVE_Atualiza_Saldo(NEW.QTDMOV * -1, NEW.CODFIL, NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM, NEW.CODMUL);

            cDUMMY := TGR_IVE_Atualiza_Movimento(NEW.QTDMOV ,NEW.VLRMOV, NEW.CODFIL, NEW.SEQUEN, NEW.FILMAT, NEW.CODMAT,
                                                 NEW.CODCOR, NEW.CODTAM, NEW.CODMUL, NEW.VEN_DATHOR, NEW.DUMMY, NEW.PROMOC );

            IF  (NEW.FILLOT IS NOT NULL)
            AND (NEW.SEQLOT IS NOT NULL) THEN
                cDUMMY := TGR_IVE_Atualiza_Saldo_Lote(NEW.QTDMOV * -1, NEW.CODFIL, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT);
            END IF;
          END IF;

          IF (NEW.LANEST = 'C') and (NEW.SITKIT <> '1') and (Equal(NEW.DUMMY,vVem_de_CALCUSME) <> 1) THEN
                           inRec.CODFIL      := NEW.CODFIL;
               inRec.SEQUEN      := NEW.SEQUEN;
               inRec.NUMITE      := NEW.NUMITE;
               inRec.VEN_DATHOR  := NEW.VEN_DATHOR;
               inRec.FILMAT      := NEW.FILMAT;
               inRec.CODMAT      := NEW.CODMAT;
               inRec.CODCOR      := NEW.CODCOR;
               inRec.CODTAM      := NEW.CODTAM;
               inRec.DUMMY       := 'X';
               inRec.QTDMOV      := NEW.QTDMOV * -1;
               inRec.FILRES      := NEW.FILRES;
               inRec.FILLOT      := NEW.FILLOT;
               inRec.SEQLOT      := NEW.SEQLOT;
               inRec.CODMUL      := NEW.CODMUL;
               inRec.NUMEXT      := NEW.NUMEXT; -- MN - 103975

               
               cDUMMY := PC_IVE_AUX_UPDATE(inREC.VEN_DATHOR,
                                           inREC.CODFIL,
                                           inREC.FILMAT,
                                           inREC.CODMAT,
                                           inREC.CODCOR,
                                           inREC.CODTAM,
                                           inRec.DUMMY,
                                           inRec.SEQUEN,
                                           inRec.NUMITE,
                                           inRec.QTDMOV,
                                           inRec.FILRES,
                                           inRec.FILLOT,
                                           inRec.SEQLOT,
                                           inRec.CODMUL,
                                           inRec.NUMEXT);
                                     END IF;
          IF (NEW.LANEST = 'R') and (NEW.SITKIT <> '1') and (Equal(NEW.DUMMY,vVem_de_CALCUSME) <> 1) THEN
            IF NEW.FILORI IS NULL THEN
              IF WK_RESERVA_VENDA = 'T' THEN
                 -- RFMP 80324
                 -- RFMP 78593
                 -- Ao efetivar a venda de Entrega Futura o sistema deve reservar a mercadoria.
                 -- Sistema no deve reservar em caso de Venda sob Encomenda.
                 IF  (WK_RESERVA_ENT_FUT = 'T')
                 AND (NEW.FLGFUT <> 'E') THEN
                    WK_OLD_QTDFUT := 0;
                    WK_NEW_QTDFUT := 0;
                 ELSE
                    WK_OLD_QTDFUT := COALESCE(OLD.QTDFUT,0);
                    WK_NEW_QTDFUT := COALESCE(NEW.QTDFUT,0);
                 END IF;
                cDUMMY := TGR_IVE_Atualiza_Reserva((COALESCE(NEW.QTDPEN,0)-WK_NEW_QTDFUT) - (COALESCE(OLD.QTDPEN,0)-WK_OLD_QTDFUT), NEW.codfil, NEW.FILMAT, NEW.CODMAT,
                                                   NEW.CODCOR, NEW.CODTAM, NEW.CODMUL, NEW.FILRES);

                IF (Equal(NEW.FILLOT,OLD.FILLOT) = 0 or
                    Equal(NEW.SEQLOT,OLD.SEQLOT) = 0) THEN
                   IF (NEW.FLGFUT <> 'E') THEN
                     IF (OLD.FILLOT IS NOT NULL) AND (OLD.SEQLOT IS NOT NULL) THEN
                        cDUMMY:=TGR_IVE_Atualiza_Reserva_Lote((COALESCE(NEW.QTDPEN,0))*-1, NEW.codfil, NEW.CODMUL, OLD.FILLOT, OLD.SEQLOT, NEW.FILRES);
                     END IF;
                     IF (NEW.FILLOT IS NOT NULL) AND (NEW.SEQLOT IS NOT NULL) THEN
                        cDUMMY:=TGR_IVE_Atualiza_Reserva_Lote(COALESCE(NEW.QTDPEN,0), NEW.codfil, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT, NEW.FILRES);
                     END IF;
                   ELSIF (NEW.FILLOT IS NOT NULL) AND (NEW.SEQLOT IS NOT NULL) THEN
                      cDUMMY:=TGR_IVE_Atualiza_Reserva_Lote(((COALESCE(NEW.QTDPEN,0)-WK_NEW_QTDFUT) - (COALESCE(OLD.QTDPEN,0)-WK_OLD_QTDFUT)), NEW.codfil, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT, NEW.FILRES);
                   END IF;
                ELSIF (NEW.FILLOT IS NOT NULL) AND (NEW.SEQLOT IS NOT NULL) THEN
                   cDUMMY:=TGR_IVE_Atualiza_Reserva_Lote(((COALESCE(NEW.QTDPEN,0)-WK_NEW_QTDFUT) - (COALESCE(OLD.QTDPEN,0)-WK_OLD_QTDFUT)), NEW.codfil, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT, NEW.FILRES);
                END IF;
               END IF;
            ELSE
                               inRec.CODFIL      := NEW.CODFIL;
                 inRec.SEQUEN      := NEW.SEQUEN;
                 inRec.NUMITE      := NEW.NUMITE;
                 inRec.VEN_DATHOR  := NEW.VEN_DATHOR;
                 inRec.FILMAT      := NEW.FILMAT;
                 inRec.CODMAT      := NEW.CODMAT;
                 inRec.CODCOR      := NEW.CODCOR;
                 inRec.CODTAM      := NEW.CODTAM;
                 inRec.DUMMY       := 'R';
                 inRec.QTDMOV      := NEW.QTDMOV;
                 inRec.FILRES      := NEW.FILRES;
                 inRec.FILLOT      := NEW.FILLOT;
                 inRec.SEQLOT      := NEW.SEQLOT;
                 inRec.CODMUL      := NEW.CODMUL;
                 inRec.NUMEXT      := NEW.NUMEXT; -- MN - 103975

                 
                 cDUMMY := PC_IVE_AUX_UPDATE(inREC.VEN_DATHOR,
                                             inREC.CODFIL,
                                             inREC.FILMAT,
                                             inREC.CODMAT,
                                             inREC.CODCOR,
                                             inREC.CODTAM,
                                             inRec.DUMMY,
                                             inRec.SEQUEN,
                                             inRec.NUMITE,
                                             inRec.QTDMOV,
                                             inRec.FILRES,
                                             inRec.FILLOT,
                                             inRec.SEQLOT,
                                             inRec.CODMUL,
                                             inRec.NUMEXT);
                                           END IF;
          END IF;
        END IF;
      END IF;
    ELSIF (Equal(NEW.FILLOT,OLD.FILLOT) = 0 or
           Equal(NEW.SEQLOT,OLD.SEQLOT) = 0) THEN
	   /* Paulo K. - Caso troque o lote muda a reserva */
	   IF WK_RESERVA_VENDA = 'T' THEN
		  IF (OLD.FILLOT IS NOT NULL) AND (OLD.SEQLOT IS NOT NULL)
        AND (OLD.LANEST = 'R') and (OLD.SITKIT <> '1') THEN
			 cDUMMY:=TGR_IVE_Atualiza_Reserva_Lote((COALESCE(NEW.QTDPEN,0))*-1, NEW.codfil, NEW.CODMUL, OLD.FILLOT, OLD.SEQLOT, NEW.FILRES);
		  END IF;
		  IF (NEW.FILLOT IS NOT NULL) AND (NEW.SEQLOT IS NOT NULL)
        AND (NEW.LANEST = 'R') and (NEW.SITKIT <> '1') THEN
			 cDUMMY:=TGR_IVE_Atualiza_Reserva_Lote(COALESCE(NEW.QTDPEN,0), NEW.codfil, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT, NEW.FILRES);
		  END IF;
	   END IF;
	END IF;
      -- Pedro E. Braga - 97964
      IF (Equal(NEW.TRAIMP,OLD.TRAIMP) = 0)
      AND (NEW.SITMOV <> 'C') THEN -- Cancelando
         IF (NEW.LANEST = 'S') AND (NEW.TIPPRO <> '1') AND (NEW.TRAIMP = '1') THEN
            cDUMMY := TGR_IVE_Atualiza_Reserva(NEW.QTDMOV * -1, NEW.CODFIL, NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM, NEW.CODMUL, NEW.FILRES);
            IF (Equal(NEW.FILLOT,OLD.FILLOT) = 0 or
                Equal(NEW.SEQLOT,OLD.SEQLOT) = 0) THEN
              IF (OLD.FILLOT IS NOT NULL) AND (OLD.SEQLOT IS NOT NULL) THEN
                cDUMMY:=TGR_IVE_Atualiza_Reserva_Lote(OLD.QTDMOV, NEW.codfil, NEW.CODMUL, OLD.FILLOT, OLD.SEQLOT, NEW.FILRES);
              END IF;
            END IF;
            IF (NEW.FILLOT IS NOT NULL) AND (NEW.SEQLOT IS NOT NULL) THEN
              cDUMMY:=TGR_IVE_Atualiza_Reserva_Lote(NEW.QTDMOV * -1, NEW.codfil, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT, NEW.FILRES);
            END IF;
         END IF;
         IF (NEW.LANEST = 'S') AND (NEW.TIPPRO <> '1') AND (NEW.TRAIMP = '2') THEN
            cDUMMY := TGR_IVE_Atualiza_Reserva(NEW.QTDMOV, NEW.CODFIL, NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM, NEW.CODMUL, NEW.FILRES);
            IF (Equal(NEW.FILLOT,OLD.FILLOT) = 0 or
                Equal(NEW.SEQLOT,OLD.SEQLOT) = 0) THEN
              IF (OLD.FILLOT IS NOT NULL) AND (OLD.SEQLOT IS NOT NULL) THEN
                cDUMMY:=TGR_IVE_Atualiza_Reserva_Lote(OLD.QTDMOV, NEW.codfil, NEW.CODMUL, OLD.FILLOT, OLD.SEQLOT, NEW.FILRES);
              END IF;
            ELSIF (NEW.FILLOT IS NOT NULL) AND (NEW.SEQLOT IS NOT NULL) THEN
              cDUMMY:=TGR_IVE_Atualiza_Reserva_Lote(NEW.QTDMOV, NEW.codfil, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT, NEW.FILRES);
            END IF;
         END IF;
      END IF;
      -- Pedro E. Braga - 97967
      -- Espera se que os valores sejam sempre positivo idem ao aplicado para as colunas VLRPIS e VLRCOF, onde mesmo na devoluo apresenta valores positivos.
      IF (Equal(NEW.VLRMOV,OLD.VLRMOV) = 0)
      OR (Equal(NEW.VLRSEG,OLD.VLRSEG) = 0)
      OR (Equal(NEW.VLRFRE,OLD.VLRFRE) = 0)
      OR (Equal(NEW.VLR_II,OLD.VLR_II) = 0)
      OR (Equal(NEW.VLRPIS,OLD.VLRPIS) = 0)
      OR (Equal(NEW.VLRCOF,OLD.VLRCOF) = 0)
      OR (Equal(NEW.VLRANT,OLD.VLRANT) = 0)
      OR (Equal(NEW.VLRADU,OLD.VLRADU) = 0)
      OR (Equal(NEW.VLRICM,OLD.VLRICM) = 0)
      OR (Equal(NEW.VLRPISCRE,OLD.VLRPISCRE) = 0)
      OR (Equal(NEW.VLRCOFCRE,OLD.VLRCOFCRE) = 0)       
      OR (Equal(NEW.FILICOORI,OLD.FILICOORI) = 0)
      OR (Equal(NEW.SEQICOORI,OLD.SEQICOORI) = 0)
      OR (Equal(NEW.NUMICOORI,OLD.NUMICOORI) = 0)
      THEN
         --NEW.VLR_CM := COALESCE(NEW.BAS_II,0) + COALESCE(NEW.VLR_II,0) + COALESCE(NEW.VLRANT,0) + COALESCE(NEW.VLRADU,0) + COALESCE(NEW.VLRPIS,0) + COALESCE(NEW.VLRCOF,0) - COALESCE(NEW.VLRPISCRE,0) - COALESCE(NEW.VLRCOFCRE,0);
         --NEW.VLRCMG := COALESCE(NEW.BAS_II,0) + COALESCE(NEW.VLR_II,0) + COALESCE(NEW.VLRANT,0) + COALESCE(NEW.VLRADU,0);

         -- Tratamento no processo de Atualizao do Registro
         --Berticelli - GES-2022012492
         IF (ISNOTNULL(NEW.SEQICOORI)='T') THEN
            SELECT DNAT.TIPNAT 
              INTO cTipNat
              FROM TT_VEN VEN
              JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT 
             WHERE VEN.CODFIL = NEW.CODFIL 
               AND VEN.SEQUEN = NEW.SEQUEN;
         ELSE
            cTipNat := '0';
         END IF;
         
         -- Se for Devoluo de transferncia ento deve assumir o mesmo custo mdio/custo mdio geral da origem
         IF cTipNat = 'R' THEN
                           SELECT ABS(ICO.VLR_CM / ICO.QTD_CM) AS VLR_CM_ORI, 
                      ABS(ICO.VLRCMG/ ICO.QTD_CM) AS VLR_CMG_ORI,
                      ABS(ICO.BASICM_CM/ ICO.QTD_CM) AS BASICM_CM_ORI,
                      ABS(ICO.VLRICM_CM/ ICO.QTD_CM) AS VLRICM_CM_ORI,
                      ABS(ICO.BAS_ST_CM/ ICO.QTD_CM) AS BAS_ST_CM_ORI,
                      ABS(ICO.VLR_ST_CM/ ICO.QTD_CM) AS VLR_ST_CM_ORI
                 INTO nVLR_CM_ORI, nVLR_CMG_ORI, nBASICM_CM_ORI, nVLRICM_CM_ORI, nBAS_ST_CM_ORI, nVLR_ST_CM_ORI
                 FROM TT_ICO ICO
                WHERE ICO.CODFIL = NEW.FILICOORI
                  AND ICO.SEQUEN = NEW.SEQICOORI
                  AND ICO.NUMITE = NEW.NUMICOORI;
                     END IF;

         IF (cTipNat = 'R') AND (nVLR_CM_ORI <> 0)  THEN   
            NEW.VLR_CM := (nVLR_CM_ORI * NEW.QTD_CM) * -1;
            NEW.VLRCMG := (nVLR_CMG_ORI * NEW.QTD_CM) * -1;
            NEW.BASICM_CM := (nBASICM_CM_ORI * NEW.QTD_CM);
            NEW.VLRICM_CM := (nVLRICM_CM_ORI * NEW.QTD_CM);
            NEW.BAS_ST_CM := (nBAS_ST_CM_ORI * NEW.QTD_CM);
            NEW.VLR_ST_CM := (nVLR_ST_CM_ORI * NEW.QTD_CM);
         ELSE 
            -- RFMP 101480
            -- Clculo de CM na Importao
            nVlr_CM := ABS(NEW.VLRMOV)                 -- Valor Total NF + IPI
                       + COALESCE(NEW.VLRSEG,0)        -- Seguro
                       + COALESCE(NEW.VLRFRE,0)        -- Frete
                       + COALESCE(NEW.VLR_II,0)        -- Imposto de Importao
                       + COALESCE(NEW.VLRPIS,0)        -- PIS com Alq Especial para Importao
                       + COALESCE(NEW.VLRCOF,0)        -- COFINS com Alq Especial para Importao
                       + COALESCE(NEW.VLRANT,0)        -- Anti Dumping
                       + COALESCE(NEW.VLRADU,0)        -- Valor das Despesas Aduaneiras Tributveis
                       + ABS(COALESCE(NEW.VLRICM,0))   -- ICMS
                       - COALESCE(NEW.VLRPISCRE,0)     -- PIS com Alq de Venda
                       - COALESCE(NEW.VLRCOFCRE,0);    -- COFINS com Alq de Venda

            --IF (LeParametroBoo('USACM_BASE_IMP_TRANS', NEW.CODFIL, null, null, null)='T') THEN
            --	nVlr_CM   := nVlr_CM + ABS(COALESCE(NEW.VLRICM_CM,0));
            --ELSE
            --	nVlr_CM   := nVlr_CM + ABS(COALESCE(NEW.VLRICM,0));
            --END IF;

            nVlrCMG := ABS(NEW.VLRMOV)                 -- Valor Total NF + IPI
                       + COALESCE(NEW.VLRSEG,0)        -- Seguro
                       + COALESCE(NEW.VLRFRE,0)        -- Frete
                       + COALESCE(NEW.VLR_II,0)        -- Imposto de Importao
                       + COALESCE(NEW.VLRANT,0)        -- Anti Dumping
                       + COALESCE(NEW.VLRADU,0)        -- Valor das Despesas Aduaneiras Tributveis
                       + ABS(COALESCE(NEW.VLRICM,0));  -- ICMS

            --IF (LeParametroBoo('USACM_BASE_IMP_TRANS', NEW.CODFIL, null, null, null)='T') THEN
            --	nVlrCMG   := nVlrCMG + ABS(COALESCE(NEW.VLRICM_CM,0));
            --ELSE
            --	nVlrCMG   := nVlrCMG + ABS(COALESCE(NEW.VLRICM,0));
            --END IF;

            NEW.VLR_CM := nVlr_CM;
            NEW.VLRCMG := nVlrCMG;
         END IF;  
      END IF;
      
      -- Grava Valores originais do Custo Mdio com sua primeira informao aplicada
      NEW.VLR_CMORI := COALESCE(NEW.VLR_CMORI, NEW.VLR_CM);
      NEW.VLRCMGORI := COALESCE(NEW.VLRCMGORI, NEW.VLRCMG);
      NEW.TOT_CMORI := COALESCE(NEW.TOT_CMORI, NEW.TOT_CM);
      NEW.TOTCMGORI := COALESCE(NEW.TOTCMGORI, NEW.TOTCMG);
      NEW.SAL_CMORI := COALESCE(NEW.SAL_CMORI, NEW.SAL_CM);
  END IF;

  IF (TG_OP = 'INSERT') THEN
    -- Pedro E. Braga - 97964
    IF (NEW.LANEST <> 'S') AND (ISNOTNULL(NEW.TRAIMP) = 'T') THEN
       RAISE EXCEPTION 'PG-20016 Flag de estoque invlido para essa operao. LANEST deve ser "S - Baixa Estoque". %' , vComplemento;
    END IF;

     -- Corrige os dados passados de acordo com a embalagem
     SELECT COALESCE(DSUB.CODSAL,SUB.CODITE) AS CODTAM,
            NEW.QTDMOV * (CASE WHEN DSUB.CODSAL IS NULL THEN 1
                                ELSE SUB.FATCON
                           END) AS QTDMOV,
            CASE WHEN DSUB.CODSAL IS NULL THEN NULL
                 ELSE SUB.CODITE
            END AS EMBORI,
            CASE WHEN DSUB.CODSAL IS NULL THEN NULL
                 ELSE NEW.QTDMOV
            END AS EMBQTD
       INTO NovoCODTAM, NovoQTDMOV, NovoEMBORI, NovoEMBQTD
       FROM TD_SUB DSUB, TT_SUB SUB
      WHERE SUB.CODSUB = DSUB.CODTAB
        AND SUB.CODITE = NEW.CODTAM;

     NEW.CODTAM := NovoCODTAM;
     NEW.QTDMOV := NovoQTDMOV;
     NEW.EMBORI := NovoEMBORI;
     NEW.EMBQTD := NovoEMBQTD;

     NEW.QTD_CM := NEW.QTDMOV;

     --Na insert do registro deve passar os mesmos valores para os campos do CM, 
     --posteriormente se for necesso alterar, deve ser alterado algum dos valores abaixo ao invs de alterar direto na coluna da nota altera o campo do CM 
     NEW.BASICM_CM := COALESCE(NEW.BASICM_CM,NEW.BASICM);
     NEW.VLRICM_CM := COALESCE(NEW.VLRICM_CM,NEW.VLRICM);
     NEW.BAS_ST_CM := COALESCE(NEW.BAS_ST_CM,NEW.BASUBS);
     NEW.VLR_ST_CM := COALESCE(NEW.VLR_ST_CM,NEW.SUBSTT);

     NEW.DATINC := AGORA();
     NEW.ATU_EM := AGORA();

     -- Sincroniza data e vinculo
     SELECT CASE WHEN INSTR( NUMNOT, '###' ) > 0 THEN AGORA() ELSE DATHOR END, -- Para transf. automatica mantem a data atual no item
            CASE VINCUL WHEN 'T' THEN 'A' ELSE 'N' END,
            BASUBS
       INTO NEW.VEN_DATHOR, NEW.VINCUL, vBASUBS
       FROM TT_VEN
      WHERE CODFIL = NEW.CODFIL
        AND SEQUEN = NEW.SEQUEN;

     --Busca a Situao Tributria do Produto
     SELECT UFLOJA, REGESP
       INTO WK_UFLOJA, WK_REGESP
       FROM TD_FIL
      WHERE CODFIL = NEW.CODFIL;

     SELECT DTRI.CODTAB
       INTO WK_SITTRI
       FROM TT_IUF IUF LEFT JOIN TD_TRI DTRI ON DTRI.CODTAB = IUF.CODTRI
      WHERE IUF.FILMAT = NEW.FILMAT
        AND IUF.CODMAT = NEW.CODMAT
        AND IUF.ESTADO = WK_UFLOJA
        AND IUF.REGESP = WK_REGESP;

     NEW.SITTRI := WK_SITTRI;

     --58442
     -- todos os itens estao pendentes ao inserir
     IF  (NEW.LANEST = 'R')
     AND (WK_MOVEST   = 'T')
     AND (NEW.SITKIT <> '1')
     AND (NEW.FILORI IS NULL)
     AND (COALESCE(NEW.DUMMY,'XX') <> vALTERA_TIPENT)        --57914
     AND (COALESCE(NEW.QTDPEN,0) = 0) THEN
       NEW.QTDPEN := NEW.QTDMOV;
     END IF;
     -- Atualiza o qtdfut para tratar embalagem.
     IF NEW.QTDPEN>0 AND NEW.QTDFUT>0 THEN
        NEW.QTDFUT := NEW.QTDPEN;
     END IF;

     -- Pedro E. Braga - 97967
     -- Espera se que os valores sejam sempre positivo idem ao aplicado para as colunas VLRPIS e VLRCOF, onde mesmo na devoluo apresenta valores positivos.
     --NEW.VLR_CM := COALESCE(NEW.BAS_II,0) + COALESCE(NEW.VLR_II,0) + COALESCE(NEW.VLRPIS,0) + COALESCE(NEW.VLRCOF,0) + COALESCE(NEW.VLRANT,0) + COALESCE(NEW.VLRADU,0) - COALESCE(NEW.VLRPISCRE,0) - COALESCE(NEW.VLRCOFCRE,0);
     --NEW.VLRCMG := COALESCE(NEW.BAS_II,0) + COALESCE(NEW.VLR_II,0) + COALESCE(NEW.VLRANT,0) + COALESCE(NEW.VLRADU,0);

     --Berticelli - GES-2022012492
      IF (ISNOTNULL(NEW.SEQICOORI)='T') THEN
         SELECT DNAT.TIPNAT 
           INTO cTipNat
           FROM TT_VEN VEN
           JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT 
          WHERE VEN.CODFIL = NEW.CODFIL 
            AND VEN.SEQUEN = NEW.SEQUEN;
      ELSE
         cTipNat := '0';
      END IF;
      
      -- Se for Devoluo de transferncia ento deve assumir o mesmo custo mdio/custo mdio geral da origem
      IF cTipNat = 'R' THEN
                     SELECT ABS(ICO.VLR_CM / ICO.QTD_CM) AS VLR_CM_ORI, 
                   ABS(ICO.VLRCMG / ICO.QTD_CM) AS ICO_VLRCMG, 
                   ABS(ICO.BASICM_CM/ ICO.QTD_CM) AS BASICM_CM_ORI,
                   ABS(ICO.VLRICM_CM/ ICO.QTD_CM) AS VLRICM_CM_ORI,
                   ABS(ICO.BAS_ST_CM/ ICO.QTD_CM) AS BAS_ST_CM_ORI,
                   ABS(ICO.VLR_ST_CM/ ICO.QTD_CM) AS VLR_ST_CM_ORI
              INTO nVLR_CM_ORI, nVLR_CMG_ORI, nBASICM_CM_ORI, nVLRICM_CM_ORI, nBAS_ST_CM_ORI, nVLR_ST_CM_ORI
              FROM TT_ICO ICO
             WHERE ICO.CODFIL = NEW.FILICOORI
               AND ICO.SEQUEN = NEW.SEQICOORI
               AND ICO.NUMITE = NEW.NUMICOORI;
               END IF;

      IF (cTipNat = 'R') AND (nVLR_CM_ORI <> 0 )  THEN
         NEW.VLR_CM    := (nVLR_CM_ORI * NEW.QTD_CM) * -1;
         NEW.VLRCMG    := (nVLR_CMG_ORI * NEW.QTD_CM) * -1;
         NEW.BASICM_CM := (nBASICM_CM_ORI * NEW.QTD_CM);
         NEW.VLRICM_CM := (nVLRICM_CM_ORI * NEW.QTD_CM);
         NEW.BAS_ST_CM := (nBAS_ST_CM_ORI * NEW.QTD_CM);
         NEW.VLR_ST_CM := (nVLR_ST_CM_ORI * NEW.QTD_CM);
      ELSE         
         -- RFMP 101480
         -- Clculo de CM na Importao
         nVlr_CM := ABS(NEW.VLRMOV)                 -- Valor Total NF + IPI
                    + COALESCE(NEW.VLRSEG,0)        -- Seguro
                    + COALESCE(NEW.VLRFRE,0)        -- Frete
                    + COALESCE(NEW.VLR_II,0)        -- Imposto de Importao
                    + COALESCE(NEW.VLRPIS,0)        -- PIS com Alq Especial para Importao
                    + COALESCE(NEW.VLRCOF,0)        -- COFINS com Alq Especial para Importao
                    + COALESCE(NEW.VLRANT,0)        -- Anti Dumping
                    + COALESCE(NEW.VLRADU,0)        -- Valor das Despesas Aduaneiras Tributveis
                    + ABS(COALESCE(NEW.VLRICM,0))   -- ICMS
                    - COALESCE(NEW.VLRPISCRE,0)     -- PIS com Alq de Venda
                    - COALESCE(NEW.VLRCOFCRE,0);    -- COFINS com Alq de Venda

         nVlrCMG := ABS(NEW.VLRMOV)                 -- Valor Total NF + IPI
                    + COALESCE(NEW.VLRSEG,0)        -- Seguro
                    + COALESCE(NEW.VLRFRE,0)        -- Frete
                    + COALESCE(NEW.VLR_II,0)        -- Imposto de Importao
                    + COALESCE(NEW.VLRANT,0)        -- Anti Dumping
                    + COALESCE(NEW.VLRADU,0)        -- Valor das Despesas Aduaneiras Tributveis
                    + ABS(COALESCE(NEW.VLRICM,0));  -- ICMS

         NEW.VLR_CM := nVlr_CM;
         NEW.VLRCMG := nVlrCMG;
      END IF;
      -- No deve Grava Valores originais do Custo Mdio com sua primeira informao aplicada pois nas operaes de sada o CM  calculado pelo custo do dia anterior 
      -- calculado na funo "CalculaCustoMedio"
      --NEW.VLR_CMORI := COALESCE(NEW.VLR_CMORI, NEW.VLR_CM);
      --NEW.VLRCMGORI := COALESCE(NEW.VLRCMGORI, NEW.VLRCMG);
      --NEW.TOT_CMORI := COALESCE(NEW.TOT_CMORI, NEW.TOT_CM);
      --NEW.TOTCMGORI := COALESCE(NEW.TOTCMGORI, NEW.TOTCMG);
      --NEW.SAL_CMORI := COALESCE(NEW.SAL_CMORI, NEW.SAL_CM);

     -- Vai diminuir o saldo porque a venda (ou saida) sera confirmada
     IF (NEW.SITMOV <> 'C') THEN
        IF  (NEW.LANEST <> 'N')
        AND (WK_MOVEST = 'T') THEN
           IF  (NEW.SITKIT <> '1')
           AND (NEW.LANEST IN ('C','S')) THEN

                cDUMMY := TGR_IVE_Atualiza_Saldo(NEW.QTDMOV * -1, NEW.CODFIL, NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM, NEW.CODMUL);

                cDUMMY := TGR_IVE_Atualiza_Movimento(NEW.QTDMOV ,NEW.VLRMOV, NEW.CODFIL, NEW.SEQUEN, NEW.FILMAT, NEW.CODMAT,
                                                     NEW.CODCOR, NEW.CODTAM, NEW.CODMUL, NEW.VEN_DATHOR, NEW.DUMMY, NEW.PROMOC );

                IF  (NEW.FILLOT IS NOT NULL)
                AND (NEW.SEQLOT IS NOT NULL) THEN
                    cDUMMY := TGR_IVE_Atualiza_Saldo_Lote(NEW.QTDMOV * -1, NEW.CODFIL, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT);
                END IF;
           END IF;

           IF (NEW.LANEST = 'C') and (NEW.SITKIT <> '1') THEN
                             inRec.CODFIL      := NEW.CODFIL;
                inRec.SEQUEN      := NEW.SEQUEN;
                inRec.NUMITE      := NEW.NUMITE;
                inRec.VEN_DATHOR  := NEW.VEN_DATHOR;
                inRec.FILMAT      := NEW.FILMAT;
                inRec.CODMAT      := NEW.CODMAT;
                inRec.CODCOR      := NEW.CODCOR;
                inRec.CODTAM      := NEW.CODTAM;
                inRec.DUMMY       := 'R';
                inRec.QTDMOV      := NEW.QTDMOV * -1;
                        END IF;
           IF (NEW.LANEST = 'R') and (NEW.SITKIT <> '1') THEN
             IF NEW.FILORI IS NULL THEN
               IF WK_RESERVA_VENDA = 'T' THEN
                 -- RFMP 80324
                 -- RFMP 78593
                 -- Ao efetivar a venda de Entrega Futura o sistema deve reservar a mercadoria.
                 -- Sistema no deve reservar em caso de Venda sob Encomenda.
                 IF  (WK_RESERVA_ENT_FUT = 'T')
                 AND (NEW.FLGFUT <> 'E') THEN
                    WK_NEW_QTDFUT := 0;
                 ELSE
                    WK_NEW_QTDFUT := COALESCE(NEW.QTDFUT,0);
                 END IF;
                 cDUMMY := TGR_IVE_Atualiza_Reserva((COALESCE(NEW.QTDPEN,0)-WK_NEW_QTDFUT), NEW.codfil, NEW.FILMAT, NEW.CODMAT,
                                                    NEW.CODCOR, NEW.CODTAM, NEW.CODMUL, NEW.FILRES);

                 IF (NEW.FILLOT IS NOT NULL) AND (NEW.SEQLOT IS NOT NULL) THEN
                   cDUMMY:=TGR_IVE_Atualiza_Reserva_Lote((COALESCE(NEW.QTDPEN,0)-WK_NEW_QTDFUT), NEW.codfil, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT, NEW.FILRES);
                 END IF;
               END IF;
             ELSE
                                 inRec.CODFIL      := NEW.CODFIL;
                  inRec.SEQUEN      := NEW.SEQUEN;
                  inRec.NUMITE      := NEW.NUMITE;
                  inRec.VEN_DATHOR  := NEW.VEN_DATHOR;
                  inRec.FILMAT      := NEW.FILMAT;
                  inRec.CODMAT      := NEW.CODMAT;
                  inRec.CODCOR      := NEW.CODCOR;
                  inRec.CODTAM      := NEW.CODTAM;
                  inRec.DUMMY       := 'R';
                  inRec.QTDMOV      := NEW.QTDMOV;
                            END IF;
           END IF;
           -- Pedro E. Braga - 97964
           IF (NEW.LANEST = 'S') AND (NEW.TIPPRO <> '1') AND (NEW.TRAIMP = '1') THEN
             cDUMMY := TGR_IVE_Atualiza_Reserva(NEW.QTDMOV * -1, NEW.CODFIL, NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM, NEW.CODMUL, NEW.FILRES);

             IF (NEW.FILLOT IS NOT NULL) AND (NEW.SEQLOT IS NOT NULL) THEN
               cDUMMY:=TGR_IVE_Atualiza_Reserva_Lote(NEW.QTDMOV * -1, NEW.CODFIL, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT, NEW.FILRES);
             END IF;
           END IF;
       END IF;
     END IF;

     IF (NEW.NUMORI IS NOT NULL) AND (NEW.ITEORI IS NOT NULL) THEN
                   inRec.CODFIL := NEW.CODFIL;
           inRec.SEQUEN := NEW.SEQUEN;
           inRec.NUMITE := NEW.NUMITE;
           inRec.FILORI := NEW.FILORI;
           inRec.NUMORI := NEW.NUMORI;
           inRec.ITEORI := NEW.ITEORI;
           inRec.SITMOV := NEW.SITMOV;

           
             cDUMMY := PC_IVE_UPDATE(inREC.CODFIL,inREC.SEQUEN,inREC.NUMITE,inREC.FILORI,inREC.NUMORI,inREC.ITEORI,inREC.SITMOV);
                        END IF;

  END IF;


  -- Rhuan - 97440 - Quando FILDEV estiver preenchido
  -- Gera uma transferncia automtica da filial que registrou a devoluo (CODFIL) para filial onde est a mercadoria (FILDEV)
  -- Ao cancelar o item deve fazer a transferncia inversa
  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN

    bGeraNFT := false;

    -- Condies para gerar transferncia automtica:
    -- Se Filial da Devoluo estiver preenchida
    -- Se produto movimenta estoque
    -- Se no for header de kit
    -- Se for Remessa ou Baixa Estoque
    -- Se Filial for diferente de Filial da Devoluo
    IF (ISNULL(NEW.FILDEV) = 'F') AND
       (WK_MOVEST = 'T') AND
       (NEW.SITKIT <> '1') AND
       (NEW.LANEST IN ('C','S')) AND
       (Equal(NEW.CODFIL,NEW.FILDEV) <> 1) THEN
      bGeraNFT := true;
    END IF;

    -- Define DUMMY para passar na Package
    IF (TG_OP = 'INSERT') THEN
      cDUMMY := 'I';
    ELSE
      IF (OLD.SITMOV = 'N') AND (NEW.SITMOV = 'C') THEN
        cDUMMY := 'C';
      ELSE
        bGeraNFT := false;
      END IF;
    END IF;

    IF bGeraNFT THEN

               inRec.CODFIL      := NEW.CODFIL;
         inRec.SEQUEN      := NEW.SEQUEN;
         inRec.NUMITE      := NEW.NUMITE;
         inRec.VEN_DATHOR  := NEW.VEN_DATHOR;
         inRec.FILMAT      := NEW.FILMAT;
         inRec.CODMAT      := NEW.CODMAT;
         inRec.CODCOR      := NEW.CODCOR;
         inRec.CODTAM      := NEW.CODTAM;
         inRec.DUMMY       := cDUMMY;
         inRec.QTDMOV      := NEW.QTDMOV;
         inRec.FILRES      := NEW.FILDEV;
         inRec.FILLOT      := NEW.FILLOT;
         inRec.SEQLOT      := NEW.SEQLOT;
         inRec.CODMUL      := NEW.CODMUL;
         inRec.NUMEXT      := NEW.NUMEXT; -- MN - 103975

         
         cDUMMY := PC_IVE_AUX_UPDATE(inREC.VEN_DATHOR,
                                     inREC.CODFIL,
                                     inREC.FILMAT,
                                     inREC.CODMAT,
                                     inREC.CODCOR,
                                     inREC.CODTAM,
                                     inRec.DUMMY,
                                     inRec.SEQUEN,
                                     inRec.NUMITE,
                                     inRec.QTDMOV,
                                     inRec.FILRES,
                                     inRec.FILLOT,
                                     inRec.SEQLOT,
                                     inRec.CODMUL,
                                     inRec.NUMEXT);
                   END IF;
  END IF;

  --Bloco criado para gravar CALSUB e eliminar joins com TT_IUF da gerao do SINTEGRA

  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     IF NEW.CALSUB IS NULL THEN
        SELECT UFLOJA, REGESP
          INTO WK_UFLOJA, WK_REGESP
          FROM TD_FIL
         WHERE CODFIL = NEW.CODFIL;

        SELECT CALSUB
          INTO WK_CALSUB
          FROM TT_IUF
         WHERE FILMAT = NEW.FILMAT
           AND CODMAT = NEW.CODMAT
           AND REGESP = WK_REGESP
           AND ESTADO = WK_UFLOJA;

        NEW.CALSUB := WK_CALSUB;
     END IF;
   END IF;


  -- "Default"
  IF (NOT (TG_OP = 'DELETE')) THEN
     NEW.DUMMY := Null;
     vModificou := False;
     IF (TG_OP = 'UPDATE') THEN
        IF (Equal(NEW.SEQUEN,OLD.SEQUEN) = 0 OR
            Equal(NEW.CODFIL,OLD.CODFIL) = 0 OR
            Equal(NEW.NUMITE,OLD.NUMITE) = 0 OR
            Equal(NEW.FILMAT,OLD.FILMAT) = 0 OR
            Equal(NEW.CODMAT,OLD.CODMAT) = 0 OR
            Equal(NEW.CODCOR,OLD.CODCOR) = 0 OR
            Equal(NEW.CODTAM,OLD.CODTAM) = 0 OR
            Equal(NEW.CODMUL,OLD.CODMUL) = 0 OR
            Equal(NEW.QTDMOV,OLD.QTDMOV) = 0 OR
            Equal(NEW.VLRMOV,OLD.VLRMOV) = 0 OR
            Equal(NEW.SITKIT,OLD.SITKIT) = 0 OR
            Equal(NEW.FILORI,OLD.FILORI) = 0 OR
            Equal(NEW.NUMORI,OLD.NUMORI) = 0 OR
            Equal(NEW.ITEORI,OLD.ITEORI) = 0 OR
            Equal(NEW.NUMEXT,OLD.NUMEXT) = 0 OR
            Equal(NEW.SITMOV,OLD.SITMOV) = 0 OR
            Equal(NEW.LANEST,OLD.LANEST) = 0 OR
            Equal(NEW.TIPPRO,OLD.TIPPRO) = 0 OR
            Equal(NEW.REDITE,OLD.REDITE) = 0 OR
            Equal(NEW.ICMTIP,OLD.ICMTIP) = 0 OR
            Equal(NEW.VEN_DATHOR,OLD.VEN_DATHOR) = 0 OR
            Equal(NEW.EMBORI,OLD.EMBORI) = 0 OR
            Equal(NEW.EMBQTD,OLD.EMBQTD) = 0 OR
            Equal(NEW.TAX001,OLD.TAX001) = 0 OR
            Equal(NEW.TAX002,OLD.TAX002) = 0 OR
            Equal(NEW.TIP001,OLD.TIP001) = 0 OR
            Equal(NEW.VLR001,OLD.VLR001) = 0 OR
            Equal(NEW.VLR002,OLD.VLR002) = 0 OR
            Equal(NEW.VINCUL,OLD.VINCUL) = 0 OR
            Equal(NEW.DATINC,OLD.DATINC) = 0 OR
            Equal(NEW.COMISS,OLD.COMISS) = 0) THEN
            vModificou := True;
        END IF;
     END IF;
     IF (TG_OP = 'INSERT') OR vModificou THEN
        NEW.EXPORT := 'F';
     END IF;
  END IF;

  -- Recalcula a data para CustoMedio
  IF (TG_OP = 'INSERT') THEN
     IF NEW.SITKIT<>'1' THEN
        bCalculaCusto:=true;
     END IF;
  END IF;

  IF (TG_OP = 'UPDATE') THEN
     IF ((Equal(OLD.QTD_CM,NEW.QTD_CM)<>1) or
         (Equal(OLD.SITMOV,NEW.SITMOV)<>1)) AND
        NEW.SITKIT<>'1' then
        bCalculaCusto:=true;
     END IF;
  END IF;
  IF bCalculaCusto THEN
           inRec.CODFIL := NEW.CODFIL;
       inRec.SEQUEN := NEW.SEQUEN;
       inRec.NUMITE := NEW.NUMITE;
       inRec.VEN_DATHOR := NEW.VEN_DATHOR;
       inRec.FILMAT := NEW.FILMAT;
       inRec.CODMAT := NEW.CODMAT;
       inRec.CODCOR := NEW.CODCOR;
       inRec.CODTAM := NEW.CODTAM;
       inRec.DUMMY  := 'M';
       inRec.QTDMOV := NEW.QTDMOV;
       inRec.FILRES := NEW.FILRES;
       inRec.FILLOT := NEW.FILLOT;
       inRec.SEQLOT := NEW.SEQLOT;
       inRec.CODMUL := NEW.CODMUL;
       inRec.NUMEXT := NEW.NUMEXT; -- MN - 103975

       
         cDUMMY := PC_IVE_AUX_UPDATE(inREC.VEN_DATHOR,
                                     inREC.CODFIL,
                                     inREC.FILMAT,
                                     inREC.CODMAT,
                                     inREC.CODCOR,
                                     inREC.CODTAM,
                                     inRec.DUMMY,
                                     inRec.SEQUEN,
                                     inRec.NUMITE,
                                     inRec.QTDMOV,
                                     inRec.FILRES,
                                     inRec.FILLOT,
                                     inRec.SEQLOT,
                                     inRec.CODMUL,
                                     inRec.NUMEXT);
             END IF;

  -- RFMP 84603
  -- Tratamento para impedir que seja feita mais remessa do que fatura.
  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     IF COALESCE(NEW.QTDPEN,0) < 0 THEN
        RAISE EXCEPTION 'PG-20030 Quantidade pendente no pode ser negativa. Verifique se j existe remessa para este item da fatura [%/%-%]. %' , NEW.CODFIL,NEW.SEQUEN,NEW.NUMITE,vComplemento;
     END IF;
  END IF;

  -- Inicializa dados para assinatura

  -- RFMP 85136
  WK_UID := GetUidAtual();

  IF (TG_OP = 'DELETE') THEN
    IF WK_UID.BLQ_SEM_UID = 'T' AND WK_UID.CODUID IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
  END IF;

  -- 90691 - Retirada verificao da NEW.CODABA na TT_ABA.
  -- 84618
/*  IF  NEW.CODABA IS NOT NULL
  AND ((TG_OP = 'INSERT') OR (TG_OP = 'UPDATE')) THEN

     -- Busca pelo cdigo de abastecimento informado.
     SELECT COUNT(*)
       INTO iCODABA
       FROM TT_ABA
      WHERE CODFIL = NEW.CODFIL
        AND CODABA = NEW.CODABA;

     -- Verifica a existencia do cdigo de abastecimento.
     IF iCODABA = 0 THEN
        RAISE EXCEPTION 'PG-20027 Registro de abastecimento (TT_ABA) %-% no encontrado. Verifique os abastacimentos gerados pelo Console. %' , NEW.CODFIL,NEW.CODABA,vSessionID;
     END IF;

  END IF;*/

  IF (TG_OP = 'INSERT') THEN
    IF WK_UID.BLQ_SEM_UID = 'T' AND WK_UID.CODUID IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
    -- Douglas - 83441
    NEW.CODUID := WK_UID.CODUID;
    NEW.ASSINA := COALESCE(AssinaTabela('TT_IVE',
                                      ConcatenaIVE(NEW.VEN_DATHOR,
                                                   NEW.NUMITE,
                                                   NEW.FILMAT,
                                                   NEW.CODMAT,
                                                   NEW.CODCOR,
                                                   NEW.CODTAM,
                                                   NEW.QTDMOV,
                                                   NEW.VLRORI,
                                                   NEW.VLRMOV,
                                                   NEW.TIPPRO,
                                                   NEW.ICMTIP,
                                                   NEW.TAX001,
                                                   NEW.SITMOV,
                                                   NEW.VLRDES),
                                      null, null, null),NEW.ASSINA);
  END IF;
  IF (TG_OP = 'UPDATE') THEN
    IF ConcatenaIVE(NEW.VEN_DATHOR,NEW.NUMITE,NEW.FILMAT,NEW.CODMAT,
                            NEW.CODCOR,NEW.CODTAM,NEW.QTDMOV,NEW.VLRORI,NEW.VLRMOV,
                            NEW.TIPPRO,NEW.ICMTIP,NEW.TAX001,NEW.SITMOV,NEW.VLRDES) <>
           ConcatenaIVE(OLD.VEN_DATHOR,OLD.NUMITE,OLD.FILMAT,OLD.CODMAT,
                            OLD.CODCOR,OLD.CODTAM,OLD.QTDMOV,OLD.VLRORI,OLD.VLRMOV,
                            OLD.TIPPRO,OLD.ICMTIP,OLD.TAX001,OLD.SITMOV,OLD.VLRDES)
    THEN
      IF WK_UID.BLQ_SEM_UID = 'T' AND WK_UID.CODUID IS NULL THEN
        RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;

        -- Douglas - 83441
      NEW.CODUID := WK_UID.CODUID;
      NEW.ASSINA := COALESCE(AssinaTabela('TT_IVE',
                                              ConcatenaIVE(NEW.VEN_DATHOR,
                                                        NEW.NUMITE,
                                                        NEW.FILMAT,
                                                        NEW.CODMAT,
                                                        NEW.CODCOR,
                                                        NEW.CODTAM,
                                                        NEW.QTDMOV,
                                                        NEW.VLRORI,
                                                        NEW.VLRMOV,
                                                        NEW.TIPPRO,
                                                        NEW.ICMTIP,
                                                        NEW.TAX001,
                                                        NEW.SITMOV,
                                                        NEW.VLRDES),
                                           OLD.CODUID,
                                             ConcatenaIVE(OLD.VEN_DATHOR,
                                                        OLD.NUMITE,
                                                        OLD.FILMAT,
                                                        OLD.CODMAT,
                                                        OLD.CODCOR,
                                                        OLD.CODTAM,
                                                        OLD.QTDMOV,
                                                        OLD.VLRORI,
                                                        OLD.VLRMOV,
                                                        OLD.TIPPRO,
                                                        OLD.ICMTIP,
                                                        OLD.TAX001,
                                                        OLD.SITMOV,
                                                        OLD.VLRDES),
                                           OLD.ASSINA),
                              NEW.ASSINA);
      END IF;
  END IF;
  ELSE
    NEW.DUMMY := NULL;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4471 --*/
CREATE TRIGGER TGIVE2
BEFORE INSERT OR DELETE OR UPDATE ON TT_IVE 
FOR EACH ROW EXECUTE PROCEDURE TGIVE2();


/*-- SEQ 4472 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIVE3() CASCADE;

/*-- SEQ 4473 --*/
CREATE OR REPLACE FUNCTION TGIVE3() RETURNS TRIGGER AS $$

  -- Objetivo:
  -- 1) Informar que h uma transferncia entre filiais na TT_TRA
DECLARE
   wk_achou                      INTEGER;
   vAux                          VARCHAR(1);
   vSacPosVenda                  VARCHAR(1);
   cDUMMY                        VARCHAR(1);
   inRec                         TT_IVE%ROWTYPE;
   inRec_IVExIPE                 TT_IVExIPE%ROWTYPE;
   vVem_de_ATU_RES_PEND          CONSTANT VARCHAR(1) := Constante('VEM_DE_ATU_RES_PEND');

   cLOG                          VARCHAR(4000)     := '';
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   vItem                         CHAR(20)           := '';
   cOld                          VARCHAR(50); -- colocar Descrio no lugar dos codtab
   cNew                          VARCHAR(50);
   wk_coduid                     TT_UID.CODUID%TYPE;

   vNEW_APEUSU                   TT_USU.APEUSU%TYPE;
   vOLD_APEUSU                   TT_USU.APEUSU%TYPE;

   nQTDENC                       Numeric(10);

   QuemLogou                     TRetQuemLogou%ROWTYPE;
-- RFMP 78580 - Em Oracle as IVOs continuam sendo criadas pelo CRIA_SEPARACAO
--
   inRecIveIvo                   Record;

BEGIN
   IF (TG_OP = 'INSERT') THEN

     SELECT COUNT(*) INTO wk_achou
       FROM TT_VEN VEN INNER JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN.CODNAT
      CROSS JOIN TT_CFG CFG
      WHERE VEN.CODFIL = NEW.CODFIL
        AND VEN.SEQUEN = NEW.SEQUEN
        AND VEN.CODCLI = '     0'
        AND ((DNAT.TIPNAT IN ('S','R')) OR -- Tipos de Naturezas "Sada via Transferncia" ou "Devolucao de Transferencia"
             ((DNAT.TIPNAT = 'V') AND (DNAT.LANVEN = 'F') AND (DNAT.CODTAB = CFG.TRANSFER_NATCOL)) -- Tipos de Natureza "Venda" e "Lana registro como sendo do tipo Venda?" e "Natureza de Transferncia entre Filiais Coligadas"
            );

      IF wk_achou > 0 and NEW.SITKIT <> '1' THEN
       INSERT INTO TT_TRA (FILIVE,SEQIVE,NUMIVE,FILMAT,CODMAT,CODCOR,CODTAM)
        VALUES (NEW.CODFIL,NEW.SEQUEN,NEW.NUMITE,NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM);
      END IF;

      SELECT SAC_POS_VENDA INTO vSacPosVenda FROM TT_CFG;

      IF vSacPosVenda='T' THEN
         -- Gera SAC Pos Venda
         -- Somente se LANVEN="T" e nao tiver sido lancado ainda

         SELECT count(*) INTO wk_achou
          FROM TT_VEN VEN LEFT OUTER JOIN TT_SUP SUP ON VEN.CODFIL=SUP.FILVEN AND
                                                    VEN.SEQUEN=SUP.SEQVEN
                         INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI AND
                                               CLI.CODCLI = VEN.CODCLI
          WHERE VEN.CODFIL = NEW.CODFIL
           AND VEN.SEQUEN = NEW.SEQUEN
           AND VEN.LANVEN='T'
           AND CLI.CALL_C='T'
           AND SUP.SEQUEN IS NULL;

         IF (wk_achou>0) and (NEW.LANEST IN ('S', 'C')) and (NEW.SITKIT <> '3') THEN
             vAux:=SAC_POS_VENDA('V',NEW.CODFIL,NEW.SEQUEN);
         END IF;
      END IF;
   END IF;


  
  IF (TG_OP = 'INSERT') THEN
    IF (NEW.SITMOV <> 'C') THEN
      IF  (NEW.LANEST <> 'N')
      AND (MovimentaEstoque(NEW.CODFIL,NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,NEW.CODMUL) = 'T')
      AND (ReservaVenda() = 'T') THEN
        IF (NEW.LANEST = 'C' and NEW.SITKIT <> '1') THEN
          inRec.CODFIL      := NEW.CODFIL;
          inRec.SEQUEN      := NEW.SEQUEN;
          inRec.NUMITE      := NEW.NUMITE;
          inRec.VEN_DATHOR  := NEW.VEN_DATHOR;
          inRec.FILMAT      := NEW.FILMAT;
          inRec.CODMAT      := NEW.CODMAT;
          inRec.CODCOR      := NEW.CODCOR;
          inRec.CODTAM      := NEW.CODTAM;
          inRec.DUMMY       := 'X';
          inRec.QTDMOV      := NEW.QTDMOV * -1;
          inRec.FILRES      := NEW.FILRES;
          inRec.FILLOT      := NEW.FILLOT;
          inRec.SEQLOT      := NEW.SEQLOT;
          inRec.CODMUL      := NEW.CODMUL;
          inRec.NUMEXT      := NEW.NUMEXT; -- MN - 103975

          cDUMMY := PC_IVE_AUX_UPDATE(inREC.VEN_DATHOR,
                                      inREC.CODFIL,
                                      inREC.FILMAT,
                                      inREC.CODMAT,
                                      inREC.CODCOR,
                                      inREC.CODTAM,
                                      inRec.DUMMY,
                                      inRec.SEQUEN,
                                      inRec.NUMITE,
                                      inRec.QTDMOV,
                                      inRec.FILRES,
                                      inRec.FILLOT,
                                      inRec.SEQLOT,
                                      inRec.CODMUL,
                                      inRec.NUMEXT);
        END IF;
        IF (NEW.LANEST = 'R' and NEW.SITKIT <> '1') THEN
          IF NEW.FILORI IS NOT NULL THEN
            inRec.CODFIL      := NEW.CODFIL;
            inRec.SEQUEN      := NEW.SEQUEN;
            inRec.NUMITE      := NEW.NUMITE;
            inRec.VEN_DATHOR  := NEW.VEN_DATHOR;
            inRec.FILMAT      := NEW.FILMAT;
            inRec.CODMAT      := NEW.CODMAT;
            inRec.CODCOR      := NEW.CODCOR;
            inRec.CODTAM      := NEW.CODTAM;
            inRec.DUMMY       := 'R';
            inRec.QTDMOV      := NEW.QTDMOV;
            inRec.FILRES      := NEW.FILRES;
            inRec.FILLOT      := NEW.FILLOT;
            inRec.SEQLOT      := NEW.SEQLOT;
            inRec.CODMUL      := NEW.CODMUL;
            inRec.NUMEXT      := NEW.NUMEXT; -- MN - 103975

            cDUMMY := PC_IVE_AUX_UPDATE(inREC.VEN_DATHOR,
                                        inREC.CODFIL,
                                        inREC.FILMAT,
                                        inREC.CODMAT,
                                        inREC.CODCOR,
                                        inREC.CODTAM,
                                        inRec.DUMMY,
                                        inRec.SEQUEN,
                                        inRec.NUMITE,
                                        inRec.QTDMOV,
                                        inRec.FILRES,
                                        inRec.FILLOT,
                                        inRec.SEQLOT,
                                        inRec.CODMUL,
                                        inRec.NUMEXT);
          END IF;
        END IF;
      END IF;
    END IF;
  END IF;
  
   IF NOT (TG_OP = 'DELETE') AND (Equal(NEW.DUMMY,vVem_de_ATU_RES_PEND) <> 1) THEN
      IF (NEW.LANEST IN ('R','C')) THEN
                        inRec_IVExIPE.CODFIL := COALESCE(NEW.FILRES, NEW.CODFIL);

              IF (TG_OP = 'INSERT') THEN
                  IF (NEW.SITMOV = 'N') AND (NEW.LANEST = 'R') AND (NEW.FLGFUT = 'E') THEN
                      inRec_IVExIPE.FLGEST := 'I';
                      inRec_IVExIPE.FILIVE := NEW.CODFIL;
                      inRec_IVExIPE.SEQIVE := NEW.SEQUEN;
                      inRec_IVExIPE.NUMIVE := NEW.NUMITE;
                  ELSIF (/*(NEW.DEVVIN = 'T') or*/ (NEW.QTDMOV < 0)) THEN
                      inRec_IVExIPE.FLGEST := 'D';
                      inRec_IVExIPE.FILIVE := NEW.FILORI;
                      inRec_IVExIPE.SEQIVE := NEW.NUMORI;
                      inRec_IVExIPE.NUMIVE := NEW.ITEORI;
                  END IF;
              ELSE
                  IF (OLD.SITMOV = 'N') AND (NEW.SITMOV = 'C') AND (NEW.QTDMOV > 0) THEN
                      inRec_IVExIPE.FLGEST := 'C';
                      inRec_IVExIPE.FILIVE := NEW.CODFIL;
                      inRec_IVExIPE.SEQIVE := NEW.SEQUEN;
                      inRec_IVExIPE.NUMIVE := NEW.NUMITE;
                  ELSIF (OLD.SITMOV = 'N') AND (NEW.SITMOV = 'C') AND (NEW.QTDMOV < 0)  THEN

                      -- DN - VERIFICA SE O ORCAMENTO EH ENCOMENDA
                      SELECT COUNT(*) INTO nQTDENC
                        FROM TT_IOR
                       WHERE FILIVE=NEW.FILORI
                         AND SEQIVE=NEW.NUMORI
                         AND NUMIVE=NEW.ITEORI
                         AND FLGEST<>'C'
                         AND TIPENT='7';

                      IF (nQTDENC>0) THEN
                          inRec_IVExIPE.FLGEST := 'I';
                          inRec_IVExIPE.FILIVE := NEW.FILORI;
                          inRec_IVExIPE.SEQIVE := NEW.NUMORI;
                          inRec_IVExIPE.NUMIVE := NEW.ITEORI;
                      END IF;

                  END IF;
              END IF;
              inRec_IVExIPE.QTDENC := ABS(NEW.QTDMOV);
              inRec_IVExIPE.FILMAT := NEW.FILMAT;
              inRec_IVExIPE.CODMAT := NEW.CODMAT;
              inRec_IVExIPE.CODCOR := NEW.CODCOR;
              inRec_IVExIPE.CODTAM := NEW.CODTAM;
              inRec_IVExIPE.FILPED := NULL;
              inRec_IVExIPE.TIPPED := NULL;
              inRec_IVExIPE.NUMPED := NULL;
              inRec_IVExIPE.NUMITE := NULL;
              
              IF inRec_IVExIPE.FILIVE IS NOT NULL THEN
                  cDUMMY := PC_IVExIPE_UPDATE(inRec_IVExIPE.CODFIL,
                                              inRec_IVExIPE.FILIVE,
                                              inRec_IVExIPE.SEQIVE,
                                              inRec_IVExIPE.NUMIVE,
                                              inRec_IVExIPE.FLGEST,
                                              inRec_IVExIPE.QTDENC,
                                              inRec_IVExIPE.FILMAT,
                                              inRec_IVExIPE.CODMAT,
                                              inRec_IVExIPE.CODCOR,
                                              inRec_IVExIPE.CODTAM,
                                              inRec_IVExIPE.FILPED,
                                              inRec_IVExIPE.TIPPED,
                                              inRec_IVExIPE.NUMPED,
                                              inRec_IVExIPE.NUMITE);
              END IF;
                                  END IF;
   END IF;

  --57914

   WK_CODUID := GetCoduidAtual();

   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.QTDFUT,NEW.QTDFUT) <> 1 THEN
         cLOG := cLOG||'Quantidade Entrega Futura: de '||COALESCE(OLD.QTDFUT,iNulo)||' para '||COALESCE(NEW.QTDFUT,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.QTDPEN,NEW.QTDPEN) <> 1 THEN
         cLOG := cLOG||'Quantidade Pendente: de '||COALESCE(OLD.QTDPEN,iNulo)||' para '||COALESCE(NEW.QTDPEN,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRMOV,NEW.VLRMOV) <> 1 THEN
         cLOG := cLOG||'Valor Movimentado: de '||COALESCE(OLD.VLRMOV,iNulo)||' para '||COALESCE(NEW.VLRMOV,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.QTDMOV,NEW.QTDMOV) <> 1 THEN
         cLOG := cLOG||'Quantidade Movimentada: de '||COALESCE(OLD.QTDMOV,iNulo)||' para '||COALESCE(NEW.QTDMOV,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.ICMTIP,NEW.ICMTIP) <> 1 THEN
         cLOG := cLOG||'Tipo de Tributao: de '||COALESCE(OLD.ICMTIP,cNulo)||' para '||COALESCE(NEW.ICMTIP,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCST,NEW.CODCST) <> 1 THEN
         cLOG := cLOG||'CST de ICMS: de '||COALESCE(OLD.CODCST,cNulo)||' para '||COALESCE(NEW.CODCST,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODORI,NEW.CODORI) <> 1 THEN
         cLOG := cLOG||'Origem da Mercadoria: de '||COALESCE(OLD.CODORI,iNulo)||' para '||COALESCE(NEW.CODORI,iNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.REDITE,0),COALESCE(NEW.REDITE,0)) <> 1 THEN
         cLOG := cLOG||'% Reduo de ICMS: de '||COALESCE(TO_CHAR(OLD.REDITE),cNulo)||' para '||COALESCE(TO_CHAR(NEW.REDITE),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.SUBSTT,0),COALESCE(NEW.SUBSTT,0)) <> 1 THEN
         cLOG := cLOG||'Valor de ICMS ST: de '||COALESCE(TO_CHAR(OLD.SUBSTT),cNulo)||' para '||COALESCE(TO_CHAR(NEW.SUBSTT),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.BASUBS,0),COALESCE(NEW.BASUBS,0)) <> 1 THEN
         cLOG := cLOG||'Base de ICMS ST: de '||COALESCE(TO_CHAR(OLD.BASUBS),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASUBS),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.REDSUB,0),COALESCE(NEW.REDSUB,0)) <> 1 THEN
         cLOG := cLOG||'% Reduo de ICMS ST: de '||COALESCE(TO_CHAR(OLD.REDSUB),cNulo)||' para '||COALESCE(TO_CHAR(NEW.REDSUB),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.MVAVEN,0),COALESCE(NEW.MVAVEN,0)) <> 1 THEN
         cLOG := cLOG||'% de MVA: de '||COALESCE(TO_CHAR(OLD.MVAVEN),cNulo)||' para '||COALESCE(TO_CHAR(NEW.MVAVEN),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.BAS_ST_COM,0),COALESCE(NEW.BAS_ST_COM,0)) <> 1 THEN
         cLOG := cLOG||'Base de ICMS ST Retido Anteriormente: de '||COALESCE(TO_CHAR(OLD.BAS_ST_COM),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BAS_ST_COM),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.VLR_ST_COM,0),COALESCE(NEW.VLR_ST_COM,0)) <> 1 THEN
         cLOG := cLOG||'Valor de ICMS ST Retido Anteriormente: de '||COALESCE(TO_CHAR(OLD.VLR_ST_COM),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLR_ST_COM),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.TAXICM,0),COALESCE(NEW.TAXICM,0)) <> 1 THEN
         cLOG := cLOG||'% de ICMS: de '||COALESCE(TO_CHAR(OLD.TAXICM),cNulo)||' para '||COALESCE(TO_CHAR(NEW.TAXICM),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.TAX001,0),COALESCE(NEW.TAX001,0)) <> 1 THEN
         cLOG := cLOG||'% de ICMS (001): de '||COALESCE(TO_CHAR(OLD.TAX001),cNulo)||' para '||COALESCE(TO_CHAR(NEW.TAX001),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.BASICM,0),COALESCE(NEW.BASICM,0)) <> 1 THEN
         cLOG := cLOG||'Base de ICMS: de '||COALESCE(TO_CHAR(OLD.BASICM),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASICM),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.VLRICM,0),COALESCE(NEW.VLRICM,0)) <> 1 THEN
         cLOG := cLOG||'Valor de ICMS: de '||COALESCE(TO_CHAR(OLD.VLRICM),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRICM),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.VLR001,0),COALESCE(NEW.VLR001,0)) <> 1 THEN
         cLOG := cLOG||'Valor de ICMS (001): de '||COALESCE(TO_CHAR(OLD.VLR001),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLR001),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.BASISS,0),COALESCE(NEW.BASISS,0)) <> 1 THEN
         cLOG := cLOG||'Base de ISSQN: de '||COALESCE(TO_CHAR(OLD.BASISS),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASISS),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.TAXISS,0),COALESCE(NEW.TAXISS,0)) <> 1 THEN
         cLOG := cLOG||'% de ISSQN: de '||COALESCE(TO_CHAR(OLD.TAXISS),cNulo)||' para '||COALESCE(TO_CHAR(NEW.TAXISS),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.VLRISS,0),COALESCE(NEW.VLRISS,0)) <> 1 THEN
         cLOG := cLOG||'Valor de ISSQN: de '||COALESCE(TO_CHAR(OLD.VLRISS),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRISS),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.VLRIPI,0),COALESCE(NEW.VLRIPI,0)) <> 1 THEN
         cLOG := cLOG||'Valor de IPI: de '||COALESCE(TO_CHAR(OLD.VLRIPI),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRIPI),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.VLR002,0),COALESCE(NEW.VLR002,0)) <> 1 THEN
         cLOG := cLOG||'Valor de IPI (002): de '||COALESCE(TO_CHAR(OLD.VLR002),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLR002),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.TAXIPI,0),COALESCE(NEW.TAXIPI,0)) <> 1 THEN
         cLOG := cLOG||'% de IPI: de '||COALESCE(TO_CHAR(OLD.TAXIPI),cNulo)||' para '||COALESCE(TO_CHAR(NEW.TAXIPI),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.TAX002,0),COALESCE(NEW.TAX002,0)) <> 1 THEN
         cLOG := cLOG||'% de IPI (002): de '||COALESCE(TO_CHAR(OLD.TAX002),cNulo)||' para '||COALESCE(TO_CHAR(NEW.TAX002),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.BASIPI,0),COALESCE(NEW.BASIPI,0)) <> 1 THEN
         cLOG := cLOG||'Base de IPI: de '||COALESCE(TO_CHAR(OLD.BASIPI),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASIPI),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SITIPI,NEW.SITIPI) <> 1 THEN
         cLOG := cLOG||'CST de IPI: de '||COALESCE(OLD.SITIPI,cNulo)||' para '||COALESCE(NEW.SITIPI,cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.VLRPIS,0),COALESCE(NEW.VLRPIS,0)) <> 1 THEN
         cLOG := cLOG||'Valor do PIS: de '||COALESCE(TO_CHAR(OLD.VLRPIS),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRPIS),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.VLRCOF,0),COALESCE(NEW.VLRCOF,0)) <> 1 THEN
         cLOG := cLOG||'Valor do COFINS: de '||COALESCE(TO_CHAR(OLD.VLRCOF),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRCOF),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SITPIS,NEW.SITPIS) <> 1 THEN
         cLOG := cLOG||'CST de PIS: de '||COALESCE(OLD.SITPIS,cNulo)||' para '||COALESCE(NEW.SITPIS,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SITCOF,NEW.SITCOF) <> 1 THEN
         cLOG := cLOG||'CST de COFINS: de '||COALESCE(OLD.SITCOF,cNulo)||' para '||COALESCE(NEW.SITCOF,cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.BASPIS,0),COALESCE(NEW.BASPIS,0)) <> 1 THEN
         cLOG := cLOG||'Base de PIS: de '||COALESCE(TO_CHAR(OLD.BASPIS),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASPIS),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.BASCOF,0),COALESCE(NEW.BASCOF,0)) <> 1 THEN
         cLOG := cLOG||'Base de COFINS: de '||COALESCE(TO_CHAR(OLD.BASCOF),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASCOF),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.PERPIS,0),COALESCE(NEW.PERPIS,0)) <> 1 THEN
         cLOG := cLOG||'% de PIS: de '||COALESCE(TO_CHAR(OLD.PERPIS),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERPIS),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.PERCOF,0),COALESCE(NEW.PERCOF,0)) <> 1 THEN
         cLOG := cLOG||'% de COFINS: de '||COALESCE(TO_CHAR(OLD.PERCOF),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERCOF),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.ALIPISVLR,0),COALESCE(NEW.ALIPISVLR,0)) <> 1 THEN
         cLOG := cLOG||'% de PIS por Valor: de '||COALESCE(TO_CHAR(OLD.ALIPISVLR),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ALIPISVLR),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.ALICOFVLR,0),COALESCE(NEW.ALICOFVLR,0)) <> 1 THEN
         cLOG := cLOG||'% de COFINS por Valor: de '||COALESCE(TO_CHAR(OLD.ALICOFVLR),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ALICOFVLR),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.ALISIM,0),COALESCE(NEW.ALISIM,0)) <> 1 THEN
         cLOG := cLOG||'% de ICMS de Crdito de Simples: de '||COALESCE(TO_CHAR(OLD.ALISIM),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ALISIM),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.VLRSIM,0),COALESCE(NEW.VLRSIM,0)) <> 1 THEN
         cLOG := cLOG||'Valor de ICMS de Crdito de Simples: de '||COALESCE(TO_CHAR(OLD.VLRSIM),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRSIM),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NATFIS,NEW.NATFIS) <> 1 THEN
         cLOG := cLOG||'CFOP: de '||COALESCE(OLD.NATFIS,cNulo)||' para '||COALESCE(NEW.NATFIS,cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.VLRFRE,0),COALESCE(NEW.VLRFRE,0)) <> 1 THEN
         cLOG := cLOG||'Valor de Frete: de '||COALESCE(TO_CHAR(OLD.VLRFRE),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRFRE),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.VLRSEG,0),COALESCE(NEW.VLRSEG,0)) <> 1 THEN
         cLOG := cLOG||'Valor de Seguro: de '||COALESCE(TO_CHAR(OLD.VLRSEG),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRSEG),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.DESRAT,0),COALESCE(NEW.DESRAT,0)) <> 1 THEN
         cLOG := cLOG||'Desconto Rateado: de '||COALESCE(TO_CHAR(OLD.DESRAT),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DESRAT),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.OUTTAX,0),COALESCE(NEW.OUTTAX,0)) <> 1 THEN
         cLOG := cLOG||'Outras Taxas: de '||COALESCE(TO_CHAR(OLD.OUTTAX),cNulo)||' para '||COALESCE(TO_CHAR(NEW.OUTTAX),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.VLRIBP,0),COALESCE(NEW.VLRIBP,0)) <> 1 THEN
         cLOG := cLOG||'Valor do Imposto: de '||COALESCE(TO_CHAR(OLD.VLRIBP),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRIBP),cNulo)||CRLF;
      END IF;
      IF Equal(COALESCE(OLD.SUBSTT_FUT,0),COALESCE(NEW.SUBSTT_FUT,0)) <> 1 THEN
         cLOG := cLOG||'Valor de ST Embutido em Outras Taxas: de '||COALESCE(TO_CHAR(OLD.SUBSTT_FUT),cNulo)||' para '||COALESCE(TO_CHAR(NEW.SUBSTT_FUT),cNulo)||CRLF;
      END IF;
      vOLD_APEUSU := NULL;
      vNEW_APEUSU := NULL;
      IF Equal(OLD.CODVDD,NEW.CODVDD) <> 1 THEN
         IF (OLD.CODVDD IS NOT NULL) THEN
            Select apeusu into vOLD_APEUSU from tt_usu where filusu = OLD.FILVDD and codusu = OLD.CODVDD;
         END IF;
         IF (NEW.CODVDD IS NOT NULL) THEN
            Select apeusu into vNEW_APEUSU from tt_usu where filusu = NEW.FILVDD and codusu =  NEW.CODVDD;
         END IF;
         cLOG := cLOG||'Nome do Vendedor Item: de '||COALESCE(vOLD_APEUSU,cNulo)||' para '||COALESCE(vNEW_APEUSU,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILVDD,NEW.FILVDD) <> 1 THEN
         cLOG := cLOG||'Filial Vendedor: de '||COALESCE(OLD.FILVDD,cNulo)||' para '||COALESCE(NEW.FILVDD,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODABA,NEW.CODABA) <> 1 THEN
         cLOG := cLOG||'Cdigo do Abastecimento: de '||COALESCE(OLD.CODABA,cNulo)||' para '||COALESCE(NEW.CODABA,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.FILLOT,NEW.FILLOT) <> 1 OR
         Equal(OLD.SEQLOT,NEW.SEQLOT) <> 1) THEN
         cLOG := cLOG||'Lote: de '||COALESCE(OLD.FILLOT||'/'||TRIM(OLD.SEQLOT),cNulo)||' para '||COALESCE(NEW.FILLOT||'/'||TRIM(NEW.SEQLOT),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SUBFRE,NEW.SUBFRE) <> 1 THEN
         cLOG := cLOG||' % Subsdio p/ Frete: de '||COALESCE(OLD.SUBFRE,iNulo)||' para '||COALESCE(NEW.SUBFRE,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRFLX,NEW.VLRFLX) <> 1 THEN
         cLOG := cLOG||'Valor juros FLEX: de '||COALESCE(OLD.VLRFLX,iNulo)||' para '||COALESCE(NEW.VLRFLX,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.ITEFIS,NEW.ITEFIS) <> 1 THEN
         cLOG := cLOG||'Nmero do item Fiscal: de '||COALESCE(TO_CHAR(OLD.ITEFIS),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ITEFIS),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ESTORN,NEW.ESTORN) <> 1 THEN
         cLOG := cLOG||'Item estornado: de '||COALESCE(TO_CHAR(OLD.ESTORN),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ESTORN),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DESITE,NEW.DESITE) <> 1 THEN
         cLOG := cLOG||'Descrio do Item: de '||COALESCE(TO_CHAR(OLD.DESITE),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DESITE),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRABA,NEW.VLRABA) <> 1 THEN
         cLOG := cLOG||'Vlr. Abatimento Lote: de '||COALESCE(OLD.VLRABA,iNulo)||' para '||COALESCE(NEW.VLRABA,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODMOT,NEW.CODMOT) <> 1 THEN
         cLOG := cLOG||'Cdigo do Motivo da Variao de Preos: de '||COALESCE(OLD.CODMOT,cNulo)||' para '||COALESCE(NEW.CODMOT,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCNC,NEW.CODCNC) <> 1 THEN
         cLOG := cLOG||'Cdigo do Concorrente que motivou a Variao de Preos: de '||COALESCE(OLD.CODCNC,cNulo)||' para '||COALESCE(NEW.CODCNC,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILRES,NEW.FILRES) <> 1 THEN
         cLOG := cLOG||'Filial de Reserva: de '||COALESCE(OLD.FILRES,cNulo)||' para '||COALESCE(NEW.FILRES,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRIBPFED,NEW.VLRIBPFED) <> 1 THEN
         cLOG := cLOG||'Valor de Impostos Federais: de '||COALESCE(OLD.VLRIBPFED,iNulo)||' para '||COALESCE(NEW.VLRIBPFED,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRIBPEST,NEW.VLRIBPEST) <> 1 THEN
         cLOG := cLOG||'Valor de Impostos Estaduais: de '||COALESCE(OLD.VLRIBPEST,iNulo)||' para '||COALESCE(NEW.VLRIBPEST,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRIBPMUN,NEW.VLRIBPMUN) <> 1 THEN
         cLOG := cLOG||'Valor de Impostos Municipais: de '||COALESCE(OLD.VLRIBPMUN,iNulo)||' para '||COALESCE(NEW.VLRIBPMUN,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRCOMSUG,NEW.VLRCOMSUG) <> 1 THEN
         cLOG := cLOG||'Valor de Comisso para Produtos Sugeridos: de '||COALESCE(OLD.VLRCOMSUG,iNulo)||' para '||COALESCE(NEW.VLRCOMSUG,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.PROSUG,NEW.PROSUG) <> 1 THEN
         SELECT CASE OLD.PROSUG WHEN 'T' THEN 'Sim'
                                 WHEN 'F' THEN 'No'
                                 ELSE cNulo
         END INTO cOld FROM DUAL;
         SELECT CASE NEW.PROSUG WHEN 'T' THEN 'Sim'
                                 WHEN 'F' THEN 'No'
                                 ELSE cNulo
         END INTO cNew FROM DUAL;
        cLOG := cLOG||'Produto sugerido?: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TAXIPICAL,NEW.TAXIPICAL) <> 1 THEN
         cLOG := cLOG||'Taxa de IPI Calculado: de '||COALESCE(OLD.TAXIPICAL,iNulo)||' para '||COALESCE(NEW.TAXIPICAL,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.BASIPICAL,NEW.BASIPICAL) <> 1 THEN
         cLOG := cLOG||'Base do IPI Calculado: de '||COALESCE(OLD.BASIPICAL,iNulo)||' para '||COALESCE(NEW.BASIPICAL,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRIPICAL,NEW.VLRIPICAL) <> 1 THEN
         cLOG := cLOG||'Valor do IPI Calculado: de '||COALESCE(OLD.VLRIPICAL,iNulo)||' para '||COALESCE(NEW.VLRIPICAL,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRFILDES,NEW.VLRFILDES) <> 1 THEN
         cLOG := cLOG||'Preo na Filial de Destino: de '||COALESCE(OLD.VLRFILDES,iNulo)||' para '||COALESCE(NEW.VLRFILDES,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.IPITRA,NEW.IPITRA) <> 1 THEN
         cLOG := cLOG||'Frao do IPI na Transferncia: de '||COALESCE(OLD.IPITRA,iNulo)||' para '||COALESCE(NEW.IPITRA,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILDEV,NEW.FILDEV) <> 1 THEN
         cLOG := cLOG||'Filial em que foi feita a devoluo: de '||COALESCE(OLD.FILDEV,cNulo)||' para '||COALESCE(NEW.FILDEV,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CUSPRO,NEW.CUSPRO) <> 1 THEN
         cLOG := cLOG||'Custo do produto: de '||COALESCE(TO_CHAR(OLD.CUSPRO,'fm9G999G999G990D0099'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CUSPRO,'fm9G999G999G990D0099'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRSOC,NEW.VLRSOC) <> 1 THEN
         cLOG := cLOG||'Valor Contribuio Social: de '||COALESCE(TO_CHAR(OLD.VLRSOC,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRSOC,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLROPE,NEW.VLROPE) <> 1 THEN
         cLOG := cLOG||'Valor Despesas Operacionais: de '||COALESCE(TO_CHAR(OLD.VLROPE,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLROPE,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLROPEFIX,NEW.VLROPEFIX) <> 1 THEN
         cLOG := cLOG||'Valor Despesas Operacionais Fixas: de '||COALESCE(TO_CHAR(OLD.VLROPEFIX,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLROPEFIX,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRLUC,NEW.VLRLUC) <> 1 THEN
         cLOG := cLOG||'Valor Lucro: de '||COALESCE(TO_CHAR(OLD.VLRLUC,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRLUC,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERLUC,NEW.PERLUC) <> 1 THEN
         cLOG := cLOG||'Percentual de Lucro: de '||COALESCE(TO_CHAR(OLD.PERLUC,'fm9G990D0099'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERLUC,'fm9G990D0099'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CUSMAR,NEW.CUSMAR) <> 1 THEN
         cLOG := cLOG||'Custo Markup: de '||COALESCE(TO_CHAR(OLD.CUSMAR,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CUSMAR,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FRMPRE,NEW.FRMPRE) <> 1 THEN
         cLOG := cLOG||'Formador de Preo: de '||COALESCE(DescricaoDominio('IVE','FRMPRE',OLD.FRMPRE),cNulo)||' para '||COALESCE(DescricaoDominio('IVE','FRMPRE',NEW.FRMPRE),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERFCPDES,NEW.PERFCPDES) <> 1 THEN
         cLOG := cLOG||'% do Fundo de Pobreza na UF de Destino: de '||COALESCE(TO_CHAR(OLD.PERFCPDES,'fm990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERFCPDES,'fm990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRICMFCP,NEW.VLRICMFCP) <> 1 THEN
         cLOG := cLOG||'Valor de ICMS para Fundo de Pobreza na UF de Destino: de '||COALESCE(TO_CHAR(OLD.VLRICMFCP,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRICMFCP,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRICMDES,NEW.VLRICMDES) <> 1 THEN
         cLOG := cLOG||'Valor de ICMS para UF de Destino: de '||COALESCE(TO_CHAR(OLD.VLRICMDES,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRICMDES,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRICMORI,NEW.VLRICMORI) <> 1 THEN
         cLOG := cLOG||'Valor de ICMS para UF de Origem: de '||COALESCE(TO_CHAR(OLD.VLRICMORI,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRICMORI,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCES,NEW.CODCES) <> 1 THEN
         cLOG := cLOG||'CEST: de '||COALESCE(OLD.CODCES,cNulo)||' para '||COALESCE(NEW.CODCES,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODENQ,NEW.CODENQ) <> 1 THEN
         cLOG := cLOG||'Cdigo de Enquadramento Legal do IPI: de '||COALESCE(OLD.CODENQ, iNulo)||' para '||COALESCE(NEW.CODENQ, iNulo)||CRLF;
      END IF;
      IF Equal(OLD.BASICMDES,NEW.BASICMDES) <> 1 THEN
         cLOG := cLOG||'Base de ICMS na UF de Destino (Valor Integral): de '||COALESCE(TO_CHAR(OLD.BASICMDES,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASICMDES,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERPARICM,NEW.PERPARICM) <> 1 THEN
         cLOG := cLOG||'% da Partilha de ICMS para UF de Destino: de '||COALESCE(TO_CHAR(OLD.PERPARICM,'fm990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERPARICM,'fm990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ICMINTDES,NEW.ICMINTDES) <> 1 THEN
         cLOG := cLOG||'Alquota nas Operaes Internas UF do Destinatrio para Partilha de ICMS: de '||COALESCE(TO_CHAR(OLD.ICMINTDES,'fm90D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ICMINTDES,'fm90D0000'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TAXICMDES,NEW.TAXICMDES) <> 1 THEN
         cLOG := cLOG||'Alquota Interestadual da Partilha de ICMS: de '||COALESCE(TO_CHAR(OLD.TAXICMDES,'fm90D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.TAXICMDES,'fm90D0000'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.BAS_II,NEW.BAS_II) <> 1 THEN
         cLOG := cLOG||'Valor da Base de Clculo do Imposto de Importao: de '||COALESCE(TO_CHAR(OLD.BAS_II,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BAS_II,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLR_II,NEW.VLR_II) <> 1 THEN
         cLOG := cLOG||'Valor do Imposto de Importao: de '||COALESCE(TO_CHAR(OLD.VLR_II,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLR_II,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRADU,NEW.VLRADU) <> 1 THEN
         cLOG := cLOG||'Valor das Despesas Aduaneiras: de '||COALESCE(TO_CHAR(OLD.VLRADU,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRADU,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERPISCRE,NEW.PERPISCRE) <> 1 THEN
         cLOG := cLOG||'% PIS Creditvel: de '||COALESCE(TO_CHAR(OLD.PERPISCRE,'fm90D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERPISCRE,'fm90D0000'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRPISCRE,NEW.VLRPISCRE) <> 1 THEN
         cLOG := cLOG||'Valor PIS Creditvel: de '||COALESCE(TO_CHAR(OLD.VLRPISCRE,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRPISCRE,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERCOFCRE,NEW.PERCOFCRE) <> 1 THEN
         cLOG := cLOG||'% COFINS Creditvel: de '||COALESCE(TO_CHAR(OLD.PERCOFCRE,'fm90D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERCOFCRE,'fm90D0000'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRCOFCRE,NEW.VLRCOFCRE) <> 1 THEN
         cLOG := cLOG||'Valor COFINS Creditvel: de '||COALESCE(TO_CHAR(OLD.VLRCOFCRE,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRCOFCRE,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRANT,NEW.VLRANT) <> 1 THEN
         cLOG := cLOG||'Valor Anti Dumping: de '||COALESCE(TO_CHAR(OLD.VLRANT,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRANT,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TRAIMP,NEW.TRAIMP) <> 1 THEN
         cLOG := cLOG||'Situao de Trnsito de Importao: de '||COALESCE(DescricaoDominio('IVE','TRAIMP',OLD.TRAIMP),cNulo)||' para '||COALESCE(DescricaoDominio('IVE','TRAIMP',NEW.TRAIMP),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLR_CM,NEW.VLR_CM) <> 1 THEN
         cLOG := cLOG||'Valor para Custo Mdio Fiscal: de '||COALESCE(TO_CHAR(OLD.VLR_CM,'fm999G999G999G990D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLR_CM,'fm999G999G999G990D0000'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRCMG,NEW.VLRCMG) <> 1 THEN
         cLOG := cLOG||'Valor para Custo Mdio Gerencial: de '||COALESCE(TO_CHAR(OLD.VLRCMG,'fm999G999G999G990D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRCMG,'fm999G999G999G990D0000'),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.FILOIP,NEW.FILOIP) <> 1 OR
          Equal(OLD.SEQOIP,NEW.SEQOIP) <> 1) THEN
         cLOG := cLOG||'Declarao de Importao: de '||COALESCE(OLD.FILOIP||'/'||TRIM(OLD.SEQOIP),cNulo)||' para '||COALESCE(NEW.FILOIP||'/'||TRIM(NEW.SEQOIP),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NUMADI,NEW.NUMADI) <> 1 THEN
         cLOG := cLOG||'Adio da DI: de '||COALESCE(OLD.NUMADI, iNulo)||' para '||COALESCE(NEW.NUMADI, iNulo)||CRLF;
      END IF;
      IF Equal(OLD.SEQMER,NEW.SEQMER) <> 1 THEN
         cLOG := cLOG||'Seq Mercadoria da DI: de '||COALESCE(OLD.SEQMER, iNulo)||' para '||COALESCE(NEW.SEQMER, iNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRAFR,NEW.VLRAFR) <> 1 THEN
         cLOG := cLOG||'Valor da AFRMM: de '||COALESCE(TO_CHAR(OLD.VLRAFR,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRAFR,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERDIF,NEW.PERDIF) <> 1 THEN
         cLOG := cLOG||'% Diferimento de ICMS: de '||COALESCE(TO_CHAR(OLD.PERDIF,'fm990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERDIF,'fm990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRDIF,NEW.VLRDIF) <> 1 THEN
         cLOG := cLOG||'Valor do ICMS Diferido: de '||COALESCE(TO_CHAR(OLD.VLRDIF,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRDIF,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRPISRET,NEW.VLRPISRET) <> 1 THEN
         cLOG := cLOG||'Valor de PIS retido: de '||COALESCE(TO_CHAR(OLD.VLRPISRET,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRPISRET,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRCOFRET,NEW.VLRCOFRET) <> 1 THEN
         cLOG := cLOG||'Valor de COFINS retido: de '||COALESCE(TO_CHAR(OLD.VLRCOFRET,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRCOFRET,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRSOCRET,NEW.VLRSOCRET) <> 1 THEN
         cLOG := cLOG||'Valor de CSLL retido: de '||COALESCE(TO_CHAR(OLD.VLRSOCRET,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRSOCRET,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.BASCOFRET,NEW.BASCOFRET) <> 1 THEN
         cLOG := cLOG||'Base de PIS/COFINS/CSLL retido: de '||COALESCE(TO_CHAR(OLD.BASCOFRET,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASCOFRET,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TAXPISRET,NEW.TAXPISRET) <> 1 THEN
         cLOG := cLOG||'% de PIS retido: de '||COALESCE(TO_CHAR(OLD.TAXPISRET,'fm990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.TAXPISRET,'fm990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TAXCOFRET,NEW.TAXCOFRET) <> 1 THEN
         cLOG := cLOG||'% de COFINS retido: de '||COALESCE(TO_CHAR(OLD.TAXCOFRET,'fm990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.TAXCOFRET,'fm990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TAXSOCRET,NEW.TAXSOCRET) <> 1 THEN
         cLOG := cLOG||'% de CSLL retido: de '||COALESCE(TO_CHAR(OLD.TAXSOCRET,'fm990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.TAXSOCRET,'fm990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.BASFCP,NEW.BASFCP) <> 1 THEN
         cLOG := cLOG||'Valor da Base de Clculo do FCP: de '||COALESCE(TO_CHAR(OLD.BASFCP,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASFCP,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERFCP,NEW.PERFCP) <> 1 THEN
         cLOG := cLOG||'Percentual do ICMS relativo ao FCP: de '||COALESCE(TO_CHAR(OLD.PERFCP,'fm90D0099'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERFCP,'fm90D0099'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRFCP,NEW.VLRFCP) <> 1 THEN
         cLOG := cLOG||'Valor do ICMS relativo ao FCP: de '||COALESCE(TO_CHAR(OLD.VLRFCP,'fm999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRFCP,'fm999G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERCON_ST,NEW.PERCON_ST) <> 1 THEN
         cLOG := cLOG||'Alquota suportada pelo Consumidor Final: de '||COALESCE(TO_CHAR(OLD.PERCON_ST,'fm90D0099'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERCON_ST,'fm90D0099'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.BASFCP_ST,NEW.BASFCP_ST) <> 1 THEN
         cLOG := cLOG||'Valor da Base de Clculo do FCP retido por ST: de '||COALESCE(TO_CHAR(OLD.BASFCP_ST,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASFCP_ST,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERFCP_ST,NEW.PERFCP_ST) <> 1 THEN
         cLOG := cLOG||'Percentual do FCP retido por ST: de '||COALESCE(TO_CHAR(OLD.PERFCP_ST,'fm90D0099'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERFCP_ST,'fm90D0099'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRFCP_ST,NEW.VLRFCP_ST) <> 1 THEN
         cLOG := cLOG||'Valor do FCP retido por ST: de '||COALESCE(TO_CHAR(OLD.VLRFCP_ST,'fm999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRFCP_ST,'fm999G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.BASFCP_RET,NEW.BASFCP_RET) <> 1 THEN
         cLOG := cLOG||'Valor da Base de Clculo do FCP retido ant. por ST: de '||COALESCE(TO_CHAR(OLD.BASFCP_RET,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASFCP_RET,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERFCP_RET,NEW.PERFCP_RET) <> 1 THEN
         cLOG := cLOG||'Percentual do FCP retido ant. por ST: de '||COALESCE(TO_CHAR(OLD.PERFCP_RET,'fm90D0099'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERFCP_RET,'fm90D0099'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRFCP_RET,NEW.VLRFCP_RET) <> 1 THEN
         cLOG := cLOG||'Valor do FCP retido ant. por ST: de '||COALESCE(TO_CHAR(OLD.VLRFCP_RET,'fm999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRFCP_RET,'fm999G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.REDEFE,NEW.REDEFE) <> 1 THEN
         cLOG := cLOG||'Percentual de reduo da base de clculo efetiva: de '||COALESCE(TO_CHAR(OLD.REDEFE,'fm990D0099'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.REDEFE,'fm990D0099'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.BASEFE,NEW.BASEFE) <> 1 THEN
         cLOG := cLOG||'Valor da base de clculo efetiva: de '||COALESCE(TO_CHAR(OLD.BASEFE,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASEFE,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PEREFE,NEW.PEREFE) <> 1 THEN
         cLOG := cLOG||'Alquota do ICMS efetiva: de '||COALESCE(TO_CHAR(OLD.PEREFE,'fm90D0099'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PEREFE,'fm90D0099'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLREFE,NEW.VLREFE) <> 1 THEN
         cLOG := cLOG||'Valor do ICMS efetivo: de '||COALESCE(TO_CHAR(OLD.VLREFE,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLREFE,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DATINC,NEW.DATINC) <> 1 THEN
         cLOG := cLOG||'Data Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ATU_EM,NEW.ATU_EM) <> 1 THEN
         cLOG := cLOG||'Data Atualizao: de '||COALESCE(TO_CHAR(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TEMDES,NEW.TEMDES) <> 1 THEN
         cLOG := cLOG||'Aceita Desconto: de '||COALESCE(DescricaoDominio('IVE','TEMDES',OLD.TEMDES),cNulo)||' para '||COALESCE(DescricaoDominio('IVE','TEMDES',NEW.TEMDES),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRICM_COM,NEW.VLRICM_COM) <> 1 THEN
         cLOG := cLOG||'Valor do ICMS Prprio do Substituto cobrado em op. ant.: de '||COALESCE(TO_CHAR(OLD.VLRICM_COM,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRICM_COM,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRICM_CRE,NEW.VLRICM_CRE) <> 1 THEN
         cLOG := cLOG||'Valor do crdito de ICMS na nota de transferncia: de '||COALESCE(TO_CHAR(OLD.VLRICM_CRE,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRICM_CRE,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRICM_EST,NEW.VLRICM_EST) <> 1 THEN
         cLOG := cLOG||'Estorno do crdito de ICMS na nota de transferncia: de '||COALESCE(TO_CHAR(OLD.VLRICM_EST,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRICM_EST,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODBEN,NEW.CODBEN) <> 1 THEN
         cLOG := cLOG||' Cdigo de Benefcio Fiscal: de '||COALESCE(OLD.CODBEN,cNulo)||' para '||COALESCE(NEW.CODBEN,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.MOTDESON,NEW.MOTDESON) <> 1 THEN
         cLOG := cLOG||'Motivo da desonerao do ICMS: de '||COALESCE(DescricaoDominio('IVE','MOTDESON',TO_CHAR(OLD.MOTDESON)),cNulo)||' para '||COALESCE(DescricaoDominio('IVE','MOTDESON',TO_CHAR(NEW.MOTDESON)),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRDESON,NEW.VLRDESON) <> 1 THEN
            cLOG := cLOG||'Valor do ICMS desonerado: de '||COALESCE(TO_CHAR(OLD.VLRDESON,'fm9G999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRDESON,'fm9G999G999G999G990D00'),cNulo)||CRLF;
      END IF;
      
      IF Equal(OLD.EXPORT,NEW.EXPORT) <> 1 THEN
         cLOG := cLOG||'Exportado?: de '||COALESCE(OLD.EXPORT,cNulo)||' para '||COALESCE(NEW.EXPORT,cNulo)||CRLF;
      END IF;
      
      IF Equal(OLD.NUMPEDCOM,NEW.NUMPEDCOM) <> 1 THEN
         cLOG := cLOG||'Nmero do Pedido de Compra do Cliente: de '||COALESCE(OLD.NUMPEDCOM,cNulo)||' para '||COALESCE(NEW.NUMPEDCOM,cNulo)||CRLF;
      END IF;
      
      IF Equal(OLD.ITEPEDCOM,NEW.ITEPEDCOM) <> 1 THEN
         cLOG := cLOG||'Item do Pedido de Compra do Cliente: de '||COALESCE(TO_CHAR(OLD.ITEPEDCOM), cNulo)||' para '||COALESCE(TO_CHAR(NEW.ITEPEDCOM), cNulo)||CRLF;
      END IF;
      
      IF Equal(OLD.EXPFIS,NEW.EXPFIS) <> 1 THEN
         SELECT CASE OLD.EXPFIS WHEN 'T' THEN 'Sim'
                                 WHEN 'F' THEN 'No'
                                 ELSE cNulo
         END INTO cOld FROM DUAL;
         SELECT CASE NEW.EXPFIS WHEN 'T' THEN 'Sim'
                                 WHEN 'F' THEN 'No'
                                 ELSE cNulo
         END INTO cNew FROM DUAL;
         cLOG := cLOG||'Exportado Fiscal?: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.BASICM_CM,NEW.BASICM_CM) <> 1 THEN
         cLOG := cLOG||'Base ICMS Custo Mdio: de '||COALESCE(TO_CHAR(OLD.BASICM_CM,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASICM_CM,'fm9G999G999G990D00'), cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRICM_CM,NEW.VLRICM_CM) <> 1 THEN
         cLOG := cLOG||'Valor de ICMS Custo Mdio: de '||COALESCE(TO_CHAR(OLD.VLRICM_CM,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRICM_CM,'fm9G999G999G990D00'), cNulo)||CRLF;
      END IF;
      IF Equal(OLD.BAS_ST_CM,NEW.BAS_ST_CM) <> 1 THEN
         cLOG := cLOG||'Base ST Custo Mdio: de '||COALESCE(TO_CHAR(OLD.BAS_ST_CM,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.BAS_ST_CM,'fm9G999G999G990D00'), cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLR_ST_CM,NEW.VLR_ST_CM) <> 1 THEN
         cLOG := cLOG||'Valor ST Custo Mdio: de '||COALESCE(TO_CHAR(OLD.VLR_ST_CM,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLR_ST_CM,'fm9G999G999G990D00'), cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLR_CMORI,NEW.VLR_CMORI) <> 1 THEN
         cLOG := cLOG||'Valor Custo Mdio Original: de '||COALESCE(TO_CHAR(OLD.VLR_CMORI,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLR_CMORI,'fm9G999G999G990D00'), cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRCMGORI,NEW.VLRCMGORI) <> 1 THEN
         cLOG := cLOG||'Valor Custo Mdio Geral Original: de '||COALESCE(TO_CHAR(OLD.VLRCMGORI,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRCMGORI,'fm9G999G999G990D00'), cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TOT_CMORI,NEW.TOT_CMORI) <> 1 THEN
         cLOG := cLOG||'Total Custo Mdio Original: de '||COALESCE(TO_CHAR(OLD.TOT_CMORI,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.TOT_CMORI,'fm9G999G999G990D00'), cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TOTCMGORI,NEW.TOTCMGORI) <> 1 THEN
         cLOG := cLOG||'Total Custo Mdio Geral Original: de '||COALESCE(TO_CHAR(OLD.TOTCMGORI,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.TOTCMGORI,'fm9G999G999G990D00'), cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SAL_CMORI,NEW.SAL_CMORI) <> 1 THEN
         cLOG := cLOG||'Saldo Custo Mdio Original: de '||COALESCE(TO_CHAR(OLD.SAL_CMORI,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.SAL_CMORI,'fm9G999G999G990D00'), cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERREDISS,NEW.PERREDISS) <> 1 THEN
         cLog := cLog||'% Reduo ISS: de '||COALESCE(TO_CHAR(OLD.PERREDISS,'fm990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERREDISS,'fm990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERDEDISS,NEW.PERDEDISS) <> 1 THEN
         cLog := cLog||'% Deduo ISS: de '||COALESCE(TO_CHAR(OLD.PERDEDISS,'fm990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERDEDISS,'fm990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRDEDISS,NEW.VLRDEDISS) <> 1 THEN
         cLog := cLog||'Valor Deduo ISS: de '||COALESCE(TO_CHAR(OLD.VLRDEDISS,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRDEDISS,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRISSRET,NEW.VLRISSRET) <> 1 THEN
         cLog := cLog||'Valor ISS Retido: de '||COALESCE(TO_CHAR(OLD.VLRISSRET,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRISSRET,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERSOC,NEW.PERSOC) <> 1 THEN
         cLog := cLog||'% Contribuio Social: de '||COALESCE(TO_CHAR(OLD.PERSOC,'fm990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERSOC,'fm990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.BASSOC,NEW.BASSOC) <> 1 THEN
         cLog := cLog||'Base Contribuio Social: de '||COALESCE(TO_CHAR(OLD.BASSOC,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASSOC,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODIBG_INCIDENCIA,NEW.CODIBG_INCIDENCIA) <> 1 THEN
         cLOG := cLOG||'Municpio de Incidncia: de '||COALESCE(TO_CHAR(OLD.CODIBG_INCIDENCIA), cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODIBG_INCIDENCIA), cNulo)||CRLF;
      END IF;
      IF Equal(OLD.OBSERV,NEW.OBSERV) <> 1 THEN
         cLOG := cLOG||'Observao: de '||COALESCE(OLD.OBSERV, cNulo)||' para '||COALESCE(NEW.OBSERV, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILCPM,NEW.FILCPM) <> 1 THEN
         cLOG := cLOG||'Filial Promoo: de '||COALESCE(TO_CHAR(OLD.FILCPM), cNulo)||' para '||COALESCE(TO_CHAR(NEW.FILCPM), cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SEQCPM,NEW.SEQCPM) <> 1 THEN
         cLOG := cLOG||'Sequncia Promoo: de '||COALESCE(TO_CHAR(OLD.SEQCPM), cNulo)||' para '||COALESCE(TO_CHAR(NEW.SEQCPM), cNulo)||CRLF;
      END IF;
      IF Equal(OLD.BASIRR,NEW.BASIRR) <> 1 THEN
         cLog := cLog||'Base IRRF: de '||COALESCE(TO_CHAR(OLD.BASIRR,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASIRR,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TAXIRR,NEW.TAXIRR) <> 1 THEN
         cLog := cLog||'% IRRF: de '||COALESCE(TO_CHAR(OLD.TAXIRR,'fm990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.TAXIRR,'fm990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRIRR,NEW.VLRIRR) <> 1 THEN
         cLog := cLog||'Valor IRRF: de '||COALESCE(TO_CHAR(OLD.VLRIRR,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRIRR,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;

      IF ISNOTNULL(cLOG) = 'T' THEN
         vItem:= OLD.CODFIL||'-'||OLD.SEQUEN||'-'||to_char(OLD.NUMITE);
         cLOG := cLOG||'ITEM >> '||vItem||CRLF;
         select * into QuemLogou from DadosLogon();
         INSERT INTO TL_VEN (FILVEN,SEQVEN,FILUSU,CODUSU,DATOPE,MSGLOG,CODUID)
                     VALUES (NEW.CODFIL,NEW.SEQUEN,QuemLogou.FILUSU,QuemLogou.CODUSU,agora(),cLOG,WK_CODUID);
      END IF;
   END IF;

   -- RFMP 78580 - Em Oracle as IVOs continuam sendo criadas pelo CRIA_SEPARACAO
   --   --         
       cDUMMY := PC_IVE_IVO_UPDATE(NEW.CODFIL,NEW.SEQUEN,NEW.NUMITE);
         --
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4474 --*/
CREATE TRIGGER TGIVE3
AFTER INSERT OR UPDATE ON TT_IVE 
FOR EACH ROW EXECUTE PROCEDURE TGIVE3();


/*-- SEQ 4475 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIVE_DW() CASCADE;

/*-- SEQ 4476 --*/
CREATE OR REPLACE FUNCTION TGIVE_DW() RETURNS TRIGGER AS $$
DECLARE
  bProc_DW_Vendas_Grupos   BOOLEAN DEFAULT False;
  bProc_DW_Vendas_Produto  BOOLEAN DEFAULT False;
  regDW         RECORD;
  cDUMMY                   VARCHAR(2);
  vCODFIL                  TT_IVE.CODFIL%TYPE;
  vSEQUEN                  TT_IVE.SEQUEN%TYPE;
  vComplemento             CONSTANT VARCHAR(100) := Constante('Complemento');

-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Vendas_Grupos
-- 2) Gerar log para view/tabela materializada DW_Vendas_Produto

BEGIN
  IF UsaVMDecisor() = 'T' THEN
     -- (TG_OP = 'DELETE'): Garantido pela FK
     IF (TG_OP = 'INSERT') THEN
       bProc_DW_Vendas_Grupos  := True;
       bProc_DW_Vendas_Produto := True;
       vCODFIL   := NEW.CODFIL;
       vSEQUEN   := NEW.SEQUEN;
     ELSIF (TG_OP = 'UPDATE') THEN
       IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 --PK
       OR Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 --PK
       OR Equal(OLD.FILMAT,NEW.FILMAT) <> 1 -- Impedido pela trigger
       OR Equal(OLD.CODMAT,NEW.CODMAT) <> 1 -- Impedido pela trigger
       OR Equal(OLD.CODCOR,NEW.CODCOR) <> 1 -- Impedido pela trigger
       OR Equal(OLD.CODTAM,NEW.CODTAM) <> 1 -- Impedido pela trigger
       OR Equal(OLD.SITKIT,NEW.SITKIT) <> 1 -- Impedido pela trigger
       THEN
         RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
       END IF;
       IF Equal(OLD.VLRMOV,NEW.VLRMOV) <> 1
       OR Equal(OLD.QTDMOV,NEW.QTDMOV) <> 1
       OR Equal(OLD.SITMOV,NEW.SITMOV) <> 1 THEN
         bProc_DW_Vendas_Grupos  := True;
         vCODFIL   := NEW.CODFIL;
         vSEQUEN   := NEW.SEQUEN;
       END IF;
       IF Equal(OLD.VLRMOV,NEW.VLRMOV) <> 1
       OR Equal(OLD.QTDMOV,NEW.QTDMOV) <> 1
       OR Equal(OLD.SITMOV,NEW.SITMOV) <> 1 THEN
         bProc_DW_Vendas_Produto := True;
         vCODFIL   := NEW.CODFIL;
         vSEQUEN   := NEW.SEQUEN;
       END IF;
     END IF;
     IF bProc_DW_Vendas_Grupos AND (UsaVMDecisor() = 'T') THEN
       FOR regDW IN (SELECT VEN.CODFIL AS FILIAL,
                            ANO_MES(VEN.DATFIS) AS ANO_MES
                       FROM TT_VEN VEN
                      WHERE VEN.CODFIL = vCODFIL
                        AND VEN.SEQUEN = vSEQUEN)
       LOOP
         cDUMMY := Insere_DW_Log_Vendas_Grupos(regDW.FILIAL, regDW.ANO_MES);
       END LOOP;
     END IF;
     IF bProc_DW_Vendas_Produto AND (UsaVMDecisor() = 'T') THEN
       FOR regDW IN (SELECT VEN.CODFIL AS FILIAL,
                            ANO_MES(VEN.DATFIS) AS ANO_MES
                       FROM TT_VEN VEN
                      WHERE VEN.CODFIL = vCODFIL
                        AND VEN.SEQUEN = vSEQUEN)
       LOOP
         cDUMMY := Insere_DW_Log_Vendas_Produto(regDW.FILIAL, regDW.ANO_MES);
       END LOOP;
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4477 --*/
CREATE TRIGGER TGIVE_DW
AFTER INSERT OR UPDATE ON TT_IVE 
FOR EACH ROW EXECUTE PROCEDURE TGIVE_DW();

/*-- SEQ 4478 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIVE_ASS() CASCADE;

/*-- SEQ 4479 --*/
CREATE OR REPLACE FUNCTION TGIVE_ASS() RETURNS TRIGGER AS $$
DECLARE

 WK_DUMMY VARCHAR(2);

  -- RFMP 85136
  WK_UID TPC_UID_Retorno%ROWTYPE;

-- 83073
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN

  IF ExisteFilialNaUF('SC') THEN
     IF (TG_OP = 'INSERT') THEN
       -- RFMP 85136 Tratamento para no dar lock na TT_ASS
       WK_UID := GetUidAtual();
     
       IF WK_UID.ASSINS = 'T' THEN
         UPDATE TT_ASS
            SET QTDREG = QTDREG + 1
          WHERE NOMTAB = 'TT_IVE';
       ELSE
         WK_DUMMY := Insere_MASS('TT_IVE');
       END IF;
     END IF;
     
     IF (TG_OP = 'DELETE') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG - 1
        WHERE NOMTAB = 'TT_IVE';
     END IF;  
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4480 --*/
CREATE TRIGGER TGIVE_ASS
AFTER INSERT OR DELETE ON TT_IVE 
FOR EACH ROW EXECUTE PROCEDURE TGIVE_ASS();


/*-- SEQ 4481 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIVEN() CASCADE;

/*-- SEQ 4482 --*/
CREATE OR REPLACE FUNCTION TGIVEN() RETURNS TRIGGER AS $$
DECLARE
  proximo      Numeric;
BEGIN
  
  IF (TG_OP = 'INSERT') THEN    
     IF COALESCE(NEW.ID_IVEN,0)=0 THEN
        SELECT NEXTVAL('SQIVEN')  INTO proximo FROM DUAL;
        NEW.ID_IVEN := proximo;
     END IF;
     
     NEW.CODCLI := TRIM(NEW.CODCLI);
     NEW.DOCNFP := TRIM(NEW.DOCNFP);
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4483 --*/
CREATE TRIGGER TGIVEN
BEFORE INSERT ON TI_VEN 
FOR EACH ROW EXECUTE PROCEDURE TGIVEN();


/*-- SEQ 4484 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIVEXCPR() CASCADE;

/*-- SEQ 4485 --*/
CREATE OR REPLACE FUNCTION TGIVEXCPR() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Controlar Datas e Sequenciadores

-- Principal
BEGIN
  -- Gera codigo sequencial exclusivo
  IF NEW.ID_VXC IS NULL THEN
    NEW.ID_VXC := TO_NUMBER(TRIM(ProximoCodigo('TT_IVEXCPR',COALESCE(NEW.FILIVE, NEW.FILCPR))));
  END IF; 

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4486 --*/
CREATE TRIGGER TGIVEXCPR
BEFORE INSERT OR UPDATE ON TT_IVEXCPR 
FOR EACH ROW EXECUTE PROCEDURE TGIVEXCPR();


/*-- SEQ 4487 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIVEXCSG() CASCADE;

/*-- SEQ 4488 --*/
CREATE OR REPLACE FUNCTION TGIVEXCSG() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Popular Datope e no permitir alterao e excluso apenas incluso
-- Principal
BEGIN
  IF (TG_OP = 'INSERT') THEN
     NEW.DATINC := agora();
	 NEW.ATU_EM := agora();

	 IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN:=ProximoCodigo('TT_IVEXCSG','001');
     END IF;
  END IF;

  IF (TG_OP = 'UPDATE') THEN    
     NEW.ATU_EM := agora();
     
  END IF;

  IF (TG_OP = 'DELETE') THEN  
     RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido';
  END IF; 

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4489 --*/
CREATE TRIGGER TGIVEXCSG
BEFORE INSERT OR UPDATE OR DELETE ON TT_IVEXCSG 
FOR EACH ROW EXECUTE PROCEDURE TGIVEXCSG();


/*-- SEQ 4490 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIVEXIOR() CASCADE;

/*-- SEQ 4491 --*/
CREATE OR REPLACE FUNCTION TGIVEXIOR() RETURNS TRIGGER AS $$
DECLARE
  vComplemento Constant VARCHAR(100) := Constante('Complemento');
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal  
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN := ProximoCodigo('TT_IVEXIOR',NEW.CODFIL);
    END IF;    
    NEW.DATINC := AGORA();    
  END IF;
  
  -- Popula a coluna ATU_EM
  IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
     NEW.ATU_EM := AGORA();
  END IF;
  
  --Impede alterao
  IF (TG_OP = 'UPDATE') THEN 
     RAISE EXCEPTION 'PG-20010 No  possvel alterar dados. % ' , vComplemento;
  END IF;  


 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4492 --*/
CREATE TRIGGER TGIVEXIOR
BEFORE INSERT OR UPDATE ON TT_IVEXIOR 
FOR EACH ROW EXECUTE PROCEDURE TGIVEXIOR();



/*-- SEQ 4493 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIVEXIPE2() CASCADE;

/*-- SEQ 4494 --*/
CREATE OR REPLACE FUNCTION TGIVEXIPE2() RETURNS TRIGGER AS $$
DECLARE
   vLOG                          VARCHAR(4000)     := '';
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   vItem                         CHAR(20)  := '';
   wk_coduid                     TT_UID.CODUID%TYPE;
      
      QuemLogou                  TRetQuemLogou%ROWTYPE;
   
   iReservaEstoque               INTEGER;

-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN:=ProximoCodigo('TT_IVEXIPE',NEW.CODFIL);
    END IF;
    NEW.ATU_EM := AGORA();
    NEW.DATINC := AGORA();
    IF NEW.DATOPE IS NULL THEN
       NEW.DATOPE := TRUNC(AGORA());
    END IF;
  END IF;
  -- RFMP 95450
  -- Trata vínculo com compra.
  IF (TG_OP = 'INSERT')
  OR (TG_OP = 'UPDATE') THEN
     IF NEW.FLGEST NOT IN ('R', 'C') THEN
        NEW.FILICO := null;
        NEW.SEQICO := null;
        NEW.NUMICO := null;
     END IF;
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     NEW.ATU_EM := AGORA();

     /* Geração de Log para acompanhamento detalhado do processo de encomenda */
     WK_CODUID := GetCoduidAtual();

     IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
        vLOG := vLOG||'Filial: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
        vLOG := vLOG||'Sequenciador: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.FILIVE,NEW.FILIVE) <> 1
     OR Equal(OLD.SEQIVE,NEW.SEQIVE) <> 1
     OR Equal(OLD.NUMIVE,NEW.NUMIVE) <> 1 THEN
        vLOG := vLOG||'Vínculo Venda: de '||COALESCE(OLD.FILIVE||'/'||OLD.SEQIVE||'-'||OLD.NUMIVE,cNulo)||' para '||COALESCE(NEW.FILIVE||'/'||NEW.SEQIVE||'-'||NEW.NUMIVE,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
        vLOG := vLOG||'Situação: de '||COALESCE(DescricaoDominio('IXI','FLGEST',OLD.FLGEST),cNulo)||' para '||COALESCE(DescricaoDominio('IXI','FLGEST',NEW.FLGEST),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.QTDENC,NEW.QTDENC) <> 1 THEN
        vLOG := vLOG||'Quantidade: de '||COALESCE(OLD.QTDENC,iNulo)||' para '||COALESCE(NEW.QTDENC,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.FILIPE,NEW.FILIPE) <> 1
     OR Equal(OLD.NUMIPE,NEW.NUMIPE) <> 1
     OR Equal(OLD.ITEIPE,NEW.ITEIPE) <> 1 THEN
        vLOG := vLOG||'Vínculo Pedido: de '||COALESCE(OLD.FILIPE||'/'||OLD.NUMIPE||'-'||OLD.ITEIPE,cNulo)||' para '||COALESCE(NEW.FILIPE||'/'||NEW.NUMIPE||'-'||NEW.ITEIPE,cNulo)||CRLF;
     END IF;

     IF Equal(OLD.FILPED,NEW.FILPED) <> 1
     OR Equal(OLD.TIPPED,NEW.TIPPED) <> 1
     OR Equal(OLD.NUMPED,NEW.NUMPED) <> 1
     OR Equal(OLD.NUMITE,NEW.NUMITE) <> 1 THEN
        vLOG := vLOG||'Vínculo Orçamento: de '||COALESCE(OLD.FILPED||'/'||OLD.TIPPED||'/'||OLD.NUMPED||'-'||OLD.NUMITE,cNulo)||' para '||COALESCE(NEW.FILPED||'/'||NEW.TIPPED||'/'||NEW.NUMPED||'-'||NEW.NUMITE,cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.FILLOT,NEW.FILLOT) <> 1 OR
         Equal(OLD.SEQLOT,NEW.SEQLOT) <> 1) THEN
        vLOG := vLOG||'Lote: de '||COALESCE(OLD.FILLOT||'/'||TRIM(OLD.SEQLOT),cNulo)||' para '||COALESCE(NEW.FILLOT||'/'||TRIM(NEW.SEQLOT),cNulo)||CRLF;
     END IF;

     IF Equal(OLD.FILICO,NEW.FILICO) <> 1
     OR Equal(OLD.SEQICO,NEW.SEQICO) <> 1
     OR Equal(OLD.NUMICO,NEW.NUMICO) <> 1 THEN
        vLOG := vLOG||'Vínculo Compra: de '||COALESCE(OLD.FILICO||'/'||OLD.SEQICO||'-'||OLD.NUMICO,cNulo)||' para '||COALESCE(NEW.FILICO||'/'||NEW.SEQICO||'-'||NEW.NUMICO,cNulo)||CRLF;
     END IF;

     IF ISNOTNULL(vLOG) = 'T' THEN
        IF NEW.FILIVE IS NOT NULL THEN
           vItem:= OLD.FILIVE||'-'||OLD.SEQIVE||'-'||to_char(OLD.NUMIVE);
           vLOG := vLOG||' ENCOMENDA >> '||vItem||CRLF;
           select * into QuemLogou from DadosLogon();
           INSERT INTO TL_VEN (FILVEN,SEQVEN,FILUSU,CODUSU,DATOPE,MSGLOG,CODUID)
                         VALUES (NEW.FILIVE,NEW.SEQIVE,QuemLogou.FILUSU,QuemLogou.CODUSU,agora(),vLog,WK_CODUID);
        ELSE
           vItem:= OLD.FILPED||'-'||OLD.TIPPED||'-'||OLD.NUMPED||'-'||to_char(OLD.NUMITE);
           vLOG := ' ENCOMENDA >> '||vItem||' >> '||CRLF||vLOG;
           select * into QuemLogou from DadosLogon();
           INSERT INTO TL_ORC (CODFIL,TIPPED,NUMPED,TIPLOG,DATOPE,MSGLOG)
                      VALUES (NEW.FILPED,NEW.TIPPED,NEW.NUMPED,'D',Agora(),vLOG);
        END IF;
     END IF;

    --rodrigo 57460
     IF (NEW.FLGEST = 'R') AND (OLD.FLGEST = 'E') THEN
        IF NEW.FILIVE IS NOT NULL THEN
          UPDATE TT_IVE IVE
              SET QTDFUT = CASE WHEN QTDFUT > NEW.QTDENC
                                THEN QTDFUT - NEW.QTDENC
                                ELSE 0
                            END,
               FILLOT = COALESCE(NEW.FILLOT, NULL),
               SEQLOT = COALESCE(NEW.SEQLOT, NULL)
            WHERE CODFIL = NEW.FILIVE
              AND SEQUEN = NEW.SEQIVE
              AND NUMITE = NEW.NUMIVE;

           UPDATE TT_IVO SET FLGEST = 'A'
            WHERE FILIVE = NEW.FILIVE
              AND SEQIVE = NEW.SEQIVE
              AND NUMIVE = NEW.NUMIVE
              AND FLGEST = 'O';

           UPDATE TT_IOR IOR
              SET FILLOT = COALESCE(NEW.FILLOT, NULL),
                  SEQLOT = COALESCE(NEW.SEQLOT, NULL),
                  DUMMY  = Constante('VEM_DE_TGIVEXIPE') -- RFMP 102342
            WHERE FILIVE = NEW.FILIVE
              AND SEQIVE = NEW.SEQIVE
              AND NUMIVE = NEW.NUMIVE;
        ELSE
         UPDATE TT_IOR IOR
              SET FILLOT = COALESCE(NEW.FILLOT, NULL),
                  SEQLOT = COALESCE(NEW.SEQLOT, NULL),
                  DUMMY  = Constante('VEM_DE_TGIVEXIPE') -- RFMP 102342
            WHERE CODFIL = NEW.FILPED
              AND TIPPED = NEW.TIPPED
              AND NUMPED = NEW.NUMPED
              AND NUMITE = NEW.NUMITE;
        END IF;
     END IF;
     IF  NEW.FLGEST = 'C' AND OLD.FLGEST <> 'C' THEN
        IF NEW.FILIVE IS NOT NULL THEN
         UPDATE TT_IVE IVE
              SET QTDFUT = QTDFUT + NEW.QTDENC,
                  FILLOT = NULL,
                  SEQLOT = NULL
            WHERE CODFIL = NEW.FILIVE
              AND SEQUEN = NEW.SEQIVE
              AND NUMITE = NEW.NUMIVE
              AND SITMOV <> 'C';

         UPDATE TT_IOR IOR
              SET FILLOT =  NULL,
                  SEQLOT =  NULL,
                  DUMMY  = Constante('VEM_DE_TGIVEXIPE') -- RFMP 102342
            WHERE FILIVE = NEW.FILIVE
              AND SEQIVE = NEW.SEQIVE
              AND NUMIVE = NEW.NUMIVE
              AND FILLOT IS NOT NULL;
        ELSE
         UPDATE TT_IOR IOR
              SET FILLOT = NULL,
                  SEQLOT = NULL,
                  DUMMY  = Constante('VEM_DE_TGIVEXIPE') -- RFMP 102342
            WHERE CODFIL = NEW.FILPED
              AND TIPPED = NEW.TIPPED
              AND NUMPED = NEW.NUMPED
              AND NUMITE = NEW.NUMITE
              AND FILLOT IS NOT NULL;
      END IF;
     END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4495 --*/
CREATE TRIGGER TGIVEXIPE2
BEFORE INSERT OR UPDATE ON TT_IVEXIPE 
FOR EACH ROW EXECUTE PROCEDURE TGIVEXIPE2();

/*-- SEQ 4496 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIVEXIPE3() CASCADE;

/*-- SEQ 4497 --*/
CREATE OR REPLACE FUNCTION TGIVEXIPE3() RETURNS TRIGGER AS $$
DECLARE
   inRec_IVExIPE                 TT_IVExIPE%ROWTYPE;
   cDUMMY                        VARCHAR(1);

      
   inRecPlus                     RECORD;
   
BEGIN
  IF (TG_OP = 'UPDATE') THEN
      IF  (Equal(NEW.FLGEST,OLD.FLGEST) <> 1)
      AND (NEW.FLGEST IN ('R', 'C', 'E')) THEN
                    inRec_IVExIPE.CODFIL := NEW.CODFIL;
          inRec_IVExIPE.SEQUEN := NEW.SEQUEN;
          inRec_IVExIPE.FLGEST := NEW.FLGEST;
          inRec_IVExIPE.QTDENC := NEW.QTDENC;
          inRec_IVExIPE.FILMAT := NEW.FILMAT;
          inRec_IVExIPE.CODMAT := NEW.CODMAT;
          inRec_IVExIPE.CODCOR := NEW.CODCOR;
          inRec_IVExIPE.CODTAM := NEW.CODTAM;
          inRec_IVExIPE.FILPED := NEW.FILPED;
          inRec_IVExIPE.TIPPED := NEW.TIPPED;
          inRec_IVExIPE.NUMPED := NEW.NUMPED;
          inRec_IVExIPE.NUMITE := NEW.NUMITE;
          inRec_IVExIPE.FILIVE := NEW.FILIVE;
          inRec_IVExIPE.SEQIVE := NEW.SEQIVE;
          inRec_IVExIPE.NUMIVE := NEW.NUMIVE;
          
              cDUMMY := PC_IVExIPE_ESTOQUE_UPDATE(inRec_IVExIPE.FLGEST,
                                                  inRec_IVExIPE.FILPED,
                                                  inRec_IVExIPE.TIPPED,
                                                  inRec_IVExIPE.NUMPED,
                                                  inRec_IVExIPE.NUMITE);
                          END IF;
  END IF;

  -- Transferência automática
  -- RFMP 95450
  IF (TG_OP = 'UPDATE') THEN
      IF  Equal(NEW.FLGEST,OLD.FLGEST) <> 1 THEN
                                    
               cDUMMY := PC_IVEXIPE_PLUS_UPDATE(NEW.CODFIL,NEW.SEQUEN,NEW.FILMAT,
                                                NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,
                                                NEW.QTDENC,NEW.FLGEST,0,
                                                NULL,NULL,NULL,
                                                NEW.FILLOT,NEW.SEQLOT,OLD.FLGEST,
                                                NEW.FILICO,NEW.SEQICO,NEW.NUMICO);
                             END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4498 --*/
CREATE TRIGGER TGIVEXIPE3
AFTER UPDATE ON TT_IVEXIPE 
FOR EACH ROW EXECUTE PROCEDURE TGIVEXIPE3();




/*-- SEQ 4499 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIVO2() CASCADE;

/*-- SEQ 4500 --*/
CREATE OR REPLACE FUNCTION TGIVO2() RETURNS TRIGGER AS $$
DECLARE
   QuemLogou                     TRetQuemLogou;
   vComplemento                  CONSTANT VARCHAR(254) := Constante('complemento');
   vFILUSU                       TT_USU.FILUSU%TYPE;
   vCODUSU                       TT_USU.CODUSU%TYPE;
   inRec                         TT_IVO%ROWTYPE;
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
BEGIN
   -- Trata dados padroes na inclusao
   IF (TG_OP = 'UPDATE') THEN
      IF OLD.SIGNAT <> NEW.SIGNAT THEN
         RAISE EXCEPTION 'PG-20003 Registro foi alterado por outro usurio, refaa a consulta e tente gravar novamente. %' , vComplemento;
      END IF;
      NEW.SIGNAT := MOD(OLD.SIGNAT + 1,100000);
   END IF;
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN:=ProximoCodigo('TT_IVO',NEW.FILVOL);
      END IF;
      -- "default"
      NEW.DATHOR := agora(); 
      IF NEW.FILIVE IS NOT NULL THEN 
         NEW.ORIGEM:='V';
      ELSIF NEW.FILPED IS NOT NULL THEN 
         NEW.ORIGEM:='O';
      ELSIF NEW.FILIPE IS NOT NULL THEN 
         NEW.ORIGEM:='P';
      END IF;
   END IF; 
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      IF NEW.FILROM IS NULL THEN
         NEW.TEMROM := 'F';
      ELSE
         NEW.TEMROM := 'T';
      END IF; 
   END IF;  

   -- "default"
   NEW.ATU_EM := agora();

   IF (TG_OP = 'INSERT') 
   OR (TG_OP = 'UPDATE') THEN
      select * into QuemLogou from DadosLogon();
      IF QuemLogou.Encontrou THEN
         vFILUSU := QuemLogou.FILUSU;
         vCODUSU := QuemLogou.CODUSU;
      ELSE
         RAISE EXCEPTION 'PG-20005 Usuario logado nao encontrado. %' , VComplemento;  
      END IF;     
      NEW.FILUSU := vFILUSU;
      NEW.CODUSU := vCODUSU;
   END IF;
  
   IF (TG_OP = 'UPDATE') THEN    
      -- PROJETO PAVIN - rfmp - 58863 - 30/01/2008
      IF  NEW.FILIMP IS NOT NULL
      AND NEW.SEQIMP IS NOT NULL
      AND NEW.NUMIMP IS NOT NULL THEN
         IF (Equal(NEW.FILROM,OLD.FILROM) <> 1)
         OR (Equal(NEW.SEQROM,OLD.SEQROM) <> 1) THEN
            RAISE EXCEPTION 'PG-20010 Nao se pode alterar a carga de uma separacao ja impressa. %' , VComplemento;  
         END IF;
         IF (Equal(NEW.FLGEST,OLD.FLGEST) <> 1)
         AND(NEW.FLGEST NOT IN ('P','E','C')) THEN
            RAISE EXCEPTION 'PG-20011 Somente e permitido alterar a situacao de uma separacao ja impressa para Separada, Cancelada ou Entregue. %' , VComplemento;  
         END IF; 
         -- RFMP 73696   
         IF  (ISNOTNULL(OLD.FILIMP) = 'T')
         AND ((Equal(NEW.FILIMP,OLD.FILIMP) <> 1) OR 
              (Equal(NEW.SEQIMP,OLD.SEQIMP) <> 1) OR 
              (Equal(NEW.NUMIMP,OLD.NUMIMP) <> 1)) THEN
            RAISE EXCEPTION 'PG-20012 Esta separacao ja foi impressa na nota %/%-%. %' , OLD.FILIMP,TRIM(OLD.SEQIMP),OLD.NUMIMP,VComplemento;  
         END IF;
      END IF;
   END IF;  
  
   IF (TG_OP = 'UPDATE') THEN
      IF (Equal(NEW.FLGEST,OLD.FLGEST) <> 1) THEN
         -- PROJETO PAVIN - rfmp - 62990 - 28/05/2008
         -- Item separado nao pode ter quantidade em falta
         IF (NEW.FLGEST = 'P') THEN
            NEW.QTDFAL := 0;
         END IF;
         -- Item em Falta no pode estar vinculado a um Romaneio
         IF (NEW.FLGEST = 'F') THEN
            NEW.FILROM := NULL;
            NEW.SEQROM := NULL;
         END IF;
      END IF;
   END IF;

     

   -- Paulo - 80846 : Inclui data da separacao se estiver mudando para o estado "Separado". 
   --                 Se estiver mudando de "Separado" para outro estado, exclui a data.
   IF (TG_OP = 'UPDATE') THEN
      IF (NEW.DATSEP IS NULL) AND (NEW.FLGEST = 'P') THEN
         NEW.DATSEP := agora();
      END IF;
      IF (OLD.FLGEST = 'P') AND 
      (Equal(NEW.FLGEST,OLD.FLGEST) <> 1) THEN
         NEW.DATSEP := NULL;
      END IF;
   END IF;
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4501 --*/
CREATE TRIGGER TGIVO2
BEFORE INSERT OR UPDATE ON TT_IVO 
FOR EACH ROW EXECUTE PROCEDURE TGIVO2();

/*-- SEQ 4502 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIVO3() CASCADE;

/*-- SEQ 4503 --*/
CREATE OR REPLACE FUNCTION TGIVO3() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Registrar mudanca dos dados num "log"

  vLOG         VARCHAR(4000)     := '';
  cNulo        CONSTANT CHAR(4)   := 'Nulo';
  iNulo        CONSTANT Numeric(1) := 0;
  CRLF         CONSTANT CHAR(1)   := CHR(10);
  v_mail_est   TT_CFG.E_MAIL_ESTOQUE%TYPE; --e-mail do responsvel pelo estoque
  v_mail_ven   TT_USU.E_MAIL%TYPE; --e-mail do vendedor   
  v_texto      VARCHAR(1000);     --corpo do e-mail
  v_nompro     TV_IPR.NOMPRO%TYPE; --nome do produto para o e-mail
  v_nom_ven    TT_USU.NOMUSU%TYPE;
  v_nom_cli    TT_CLI.NOMCLI%TYPE;
  v_qtd_ite    TT_IVE.EMBQTD%TYPE := 0;
  v_des_pgt    TT_PLA.DESPGT%TYPE;
  v_docume     VARCHAR(30);
  
    
     QuemLogou TRetQuemLogou%ROWTYPE;
    
  WK_CODUID TT_UID.CODUID%TYPE;
  
  bEmFalta BOOLEAN := False;
  cDUMMY             VARCHAR(100);
  inRec              TT_IVO%ROWTYPE;
  
BEGIN
   WK_CODUID := GetCoduidAtual();

   select * into QuemLogou from DadosLogon(); 
          
    -- Tratamento de log
   IF (TG_OP = 'INSERT') THEN
    
      vLog :=  'Inseriu novo registro em TT_IVO. Filial: '||NEW.FILVOL||'Sequenciador: '||NEW.SEQUEN;

      INSERT INTO TL_IVO
      (FILIVO, SEQIVO, DATOPE, FILUSU, CODUSU, MSGLOG, CODUID)
      VALUES
      (NEW.FILVOL, NEW.SEQUEN, AGORA(), QuemLogou.FILUSU, QuemLogou.CODUSU, vLog, WK_CODUID);   

   ELSIF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.FILUSU,NEW.FILUSU) <> 1 THEN
        vLOG := vLOG||'Filial do Usurio: de '||COALESCE(OLD.FILUSU,cNulo)||' para '||COALESCE(NEW.FILUSU,cNulo)||CRLF;
      END IF;

      IF Equal(OLD.FILPED,NEW.FILPED) <> 1 THEN
         vLOG := vLOG||'Filial do Pedido: de '||COALESCE(OLD.FILPED,cNulo)||' para '||COALESCE(NEW.FILPED,cNulo)||CRLF;
      END IF;

      IF Equal(OLD.FILIPE,NEW.FILIPE) <> 1 THEN
         vLOG := vLOG||'Filial do Item de Pedido: de '||COALESCE(OLD.FILIPE,cNulo)||' para '||COALESCE(NEW.FILIPE,cNulo)||CRLF;
      END IF;

      IF Equal(OLD.NUMIPE,NEW.NUMIPE) <> 1 THEN
         vLOG := vLOG||'Nmero do Item de Pedido: de '||COALESCE(OLD.NUMIPE,cNulo)||' para '||COALESCE(NEW.NUMIPE,cNulo)||CRLF;
      END IF;

      IF Equal(OLD.ITEIPE,NEW.ITEIPE) <> 1 THEN
         vLOG := vLOG||'Item de Pedido: de '||COALESCE(OLD.ITEIPE,iNulo)||' para '||COALESCE(NEW.ITEIPE,iNulo)||CRLF;
      END IF;

      IF Equal(OLD.FILIVE,NEW.FILIVE) <> 1 THEN
         vLOG := vLOG||'Filial da Venda: de '||COALESCE(OLD.FILIVE,cNulo)||' para '||COALESCE(NEW.FILIVE,cNulo)||CRLF;
      END IF;

      IF Equal(OLD.SEQIVE,NEW.SEQIVE) <> 1 THEN
         vLOG := vLOG||'Sequenciador da venda: de '||COALESCE(OLD.SEQIVE,cNulo)||' para '||COALESCE(NEW.SEQIVE,cNulo)||CRLF;
      END IF;

      IF Equal(OLD.FILROM,NEW.FILROM) <> 1 THEN
         vLOG := vLOG||'Filial do Romaneio: de '||COALESCE(OLD.FILROM,cNulo)||' para '||COALESCE(NEW.FILROM,cNulo)||CRLF;
      END IF;

      IF Equal(OLD.SEQROM,NEW.SEQROM) <> 1 THEN
         vLOG := vLOG||'Sequenciador do Romaneiro: de '||COALESCE(OLD.SEQROM,cNulo)||' para '||COALESCE(NEW.SEQROM,cNulo)||CRLF;
      END IF;

      IF Equal(OLD.SEQVOL,NEW.SEQVOL) <> 1 THEN
         vLOG := vLOG||'Sequenciador de Volume: de '||COALESCE(OLD.SEQVOL,cNulo)||' para '||COALESCE(NEW.SEQVOL,cNulo)||CRLF;
      END IF;

      IF Equal(OLD.CODUSU,NEW.CODUSU) <> 1 THEN
         vLOG := vLOG||'Usurio: de '||COALESCE(OLD.CODUSU,cNulo)||' para '||COALESCE(NEW.CODUSU,cNulo)||CRLF;
      END IF;

      IF Equal(OLD.CONTEM,NEW.CONTEM) <> 1 THEN
         vLOG := vLOG||'Contem: de '||COALESCE(OLD.CONTEM,iNulo)||' para '||COALESCE(NEW.CONTEM,iNulo)||CRLF;
      END IF;

      IF Equal(OLD.FILVOL,NEW.FILVOL) <> 1 THEN
         vLOG := vLOG||'Filial do Volume: de '||COALESCE(OLD.FILVOL,cNulo)||' para '||COALESCE(NEW.FILVOL,cNulo)||CRLF;
      END IF;

      IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
         vLOG := vLOG||'Estado da separao: de '||COALESCE(OLD.FLGEST,cNulo)||' para '||COALESCE(NEW.FLGEST,cNulo)||CRLF;
      END IF;

      IF Equal(OLD.NUMITE,NEW.NUMITE) <> 1 THEN
         vLOG := vLOG||'Item: de '||COALESCE(OLD.NUMITE,iNulo)||' para '||COALESCE(NEW.NUMITE,iNulo)||CRLF;
      END IF;

      IF Equal(OLD.NUMIVE,NEW.NUMIVE) <> 1 THEN
         vLOG := vLOG||'Nmero Inventrio: de '||COALESCE(OLD.NUMIVE,iNulo)||' para '||COALESCE(NEW.NUMIVE,iNulo)||CRLF;
      END IF;

      IF Equal(OLD.NUMPED,NEW.NUMPED) <> 1 THEN
         vLOG := vLOG||'Nmero Pedido/OS: de '||COALESCE(OLD.NUMPED,cNulo)||' para '||COALESCE(NEW.NUMPED,cNulo)||CRLF;
      END IF;

      IF Equal(OLD.QTDFAL,NEW.QTDFAL) <> 1 THEN
         vLOG := vLOG||'Quantidade Faltante: de '||COALESCE(OLD.QTDFAL,iNulo)||' para '||COALESCE(NEW.QTDFAL,iNulo)||CRLF;
      END IF;

      IF Equal(OLD.TIPPED,NEW.TIPPED) <> 1 THEN
         vLOG := vLOG||'Tipo Pedido/OS: de '||COALESCE(OLD.TIPPED,cNulo)||' para '||COALESCE(NEW.TIPPED,cNulo)||CRLF;
      END IF;

      IF ISNOTNULL(trim(vLOG)) = 'T' THEN
         -- insere o LOG.
         INSERT INTO TL_IVO
         (FILIVO, SEQIVO, DATOPE, FILUSU, CODUSU, MSGLOG, CODUID)
         VALUES
         (NEW.FILVOL, NEW.SEQUEN, AGORA(), QuemLogou.FILUSU, QuemLogou.CODUSU, vLog, WK_CODUID);   
      END IF;

   END IF;
  
   IF (TG_OP = 'INSERT') THEN
      IF NEW.FLGEST = 'F' THEN
         bEmFalta := True;
      END IF;  
   ELSIF (TG_OP = 'UPDATE') THEN
      IF  (Equal(NEW.FLGEST,OLD.FLGEST) <> 1) 
      AND (NEW.FLGEST = 'F') THEN
         bEmFalta := True;
      END IF;
   END IF;  
   IF bEmFalta THEN
      SELECT E_MAIL_ESTOQUE 
        INTO v_mail_est
        FROM TT_CFG;
      IF v_mail_est IS NOT NULL THEN
        --rodrigo 57899
        SELECT TAB.MAIL, TAB.NOMPRO, TAB.DOCUME, TAB.NOMUSU, TAB.NOMCLI, TAB.QTDITE, TAB.DESPGT
          INTO v_mail_ven, v_nompro, v_docume, v_nom_ven, v_nom_cli, v_qtd_ite, v_des_pgt
          FROM (
               (SELECT USU.E_MAIL AS MAIL,   
                       IPR.NOMPRO AS NOMPRO,
                       'NF '||VEN.CODFIL||'/'||TRIM(VEN.CODSER)||'-'||TRIM(VEN.NUMNOT) AS DOCUME, 
                       USU.NOMUSU, CLI.NOMCLI, IVE.EMBQTD AS QTDITE, PLA.DESPGT
                  FROM TT_IVE IVE INNER JOIN TT_VEN VEN ON VEN.CODFIL = IVE.CODFIL
                                                       AND VEN.SEQUEN = IVE.SEQUEN 
                                  INNER JOIN TT_USU USU ON USU.FILUSU = VEN.FILVEN
                                                       AND USU.CODUSU = VEN.CODVEN
                                  INNER JOIN TV_IPR IPR ON IPR.FILMAT = IVE.FILMAT
                                                       AND IPR.CODMAT = IVE.CODMAT
                                                       AND IPR.CODCOR = IVE.CODCOR
                                                       AND IPR.CODTAM = IVE.CODTAM
                                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI
                                                       AND CLI.CODCLI = VEN.CODCLI
                                  INNER JOIN TT_PLA PLA ON PLA.CODPGT = VEN.CODPGT
                                                       AND PLA.FILPGT = VEN.FILPGT
                WHERE IVE.CODFIL = NEW.FILIVE
                  AND IVE.SEQUEN = NEW.SEQIVE
                  AND IVE.NUMITE = NEW.NUMIVE)
                UNION ALL
               (SELECT USU.E_MAIL AS MAIL,   
                       IPR.NOMPRO AS NOMPRO,
                       'PED '||ORC.CODFIL||'/'||ORC.NUMPED AS DOCUME, 
                       USU.NOMUSU, CLI.NOMCLI, IOR.QTDITE, PLA.DESPGT
                  FROM TT_IOR IOR INNER JOIN TT_ORC ORC ON ORC.CODFIL = IOR.CODFIL
                                                       AND ORC.TIPPED = IOR.TIPPED
                                                       AND ORC.NUMPED = IOR.NUMPED
                                  INNER JOIN TT_USU USU ON USU.FILUSU = ORC.FILVEN
                                                       AND USU.CODUSU = ORC.CODVEN
                                  INNER JOIN TV_IPR IPR ON IPR.FILMAT = IOR.FILMAT
                                                       AND IPR.CODMAT = IOR.CODMAT
                                                       AND IPR.CODCOR = IOR.CODCOR
                                                       AND IPR.CODTAM = IOR.CODTAM
                                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = ORC.FILCLI
                                                       AND CLI.CODCLI = ORC.CODCLI
                                  INNER JOIN TT_PLA PLA ON PLA.CODPGT = ORC.CODPGT
                                                       AND PLA.FILPGT = ORC.FILPGT
                  WHERE IOR.CODFIL = NEW.FILPED
                    AND IOR.TIPPED = NEW.TIPPED
                    AND IOR.NUMPED = NEW.NUMPED
                    AND IOR.NUMITE = NEW.NUMITE)
                UNION ALL
               (SELECT USU.E_MAIL AS MAIL,   
                       IPR.NOMPRO AS NOMPRO,
                       'REP '||PED.CODFIL||'/'||PED.NUMPED AS DOCUME,
                       USU.NOMUSU, CLI.NOMCLI, IPE.QTDITE, NULL AS DESPGT
                  FROM TT_IPE IPE INNER JOIN TT_PED PED ON PED.CODFIL = IPE.CODFIL
                                                       AND PED.NUMPED = IPE.NUMPED
                                  INNER JOIN TT_USU USU ON USU.FILUSU = PED.FILUSU
                                                       AND USU.CODUSU = PED.CODUSU
                                  INNER JOIN TV_IPR IPR ON IPR.FILMAT = IPE.FILMAT
                                                       AND IPR.CODMAT = IPE.CODMAT
                                                       AND IPR.CODCOR = IPE.CODCOR
                                                       AND IPR.CODTAM = IPE.CODTAM
                                  INNER JOIN TT_CLI CLI ON CLI.FILCLI = PED.FILFOR
                                                       AND CLI.CODCLI = PED.CODFOR
        	         WHERE IPE.CODFIL = NEW.FILIPE
                       AND IPE.NUMPED = NEW.NUMIPE
                       AND IPE.NUMITE = NEW.ITEIPE)) TAB;    

         v_texto := 'O Totali Commerce informa que est em falta!'||chr(13)||chr(10)||chr(13)||chr(10)||
             'Produto: '||COALESCE(v_nompro,' ')||chr(13)||chr(10)||
             'Quantidade Faltante: '||COALESCE(NEW.QTDFAL,0)||chr(13)||chr(10)||
             'Documento: '||COALESCE(v_docume,' ')||chr(13)||chr(10)||
             'Cliente: '||COALESCE(v_nom_cli,' ')||chr(13)||chr(10)||
             'Vendedor: '||COALESCE(v_nom_ven,' ');
        IF v_des_pgt IS NOT NULL THEN
          v_texto := v_texto||chr(13)||chr(10)||'Plano: '||COALESCE(v_des_pgt,' '); 
        END IF;

        INSERT INTO TT_MAI
        (DATSOL, EXCLUI, MAI_TO, MAI_CC, MAI_FR, TEXTOS, ASSUNT)
        VALUES 
        (agora(), 'F', v_mail_est , v_mail_ven,'[Totali Commerce]' , v_texto, '[Totali Commerce] - Produto em Falta.');
      END IF;  
   END IF;
  
   
   IF  (TG_OP = 'INSERT') THEN
      IF  NEW.FILPED IS NOT NULL 
      AND NEW.TIPPED IS NOT NULL 
      AND NEW.NUMPED IS NOT NULL 
      AND NEW.NUMITE IS NOT NULL THEN
         inRec.FILVOL      := NEW.FILVOL;
         inRec.SEQUEN      := NEW.SEQUEN;
         inRec.FILPED      := NEW.FILPED;
         inRec.TIPPED      := NEW.TIPPED;
         inRec.NUMPED      := NEW.NUMPED;
         inRec.NUMITE      := NEW.NUMITE;
         cDUMMY := PC_IVO_UPDATE(inREC.FILVOL,
                                 inREC.SEQUEN,
                                 inREC.FILPED,
                                 inREC.TIPPED,
                                 inREC.NUMPED,
                                 inREC.NUMITE);
      END IF;  
   END IF;
     
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4504 --*/
CREATE TRIGGER TGIVO3
AFTER INSERT OR UPDATE ON TT_IVO 
FOR EACH ROW EXECUTE PROCEDURE TGIVO3();



/*-- SEQ 4505 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIXT() CASCADE;

/*-- SEQ 4506 --*/
CREATE OR REPLACE FUNCTION TGIXT() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir exclusoes
-- 2) Impedir alteracoes
-- 3) Gerar um codigo sequencial exclusivo para compor a chave primaria

DECLARE
   vComplemento  VARCHAR(254);
BEGIN
  vComplemento  := constante('complemento');
  IF (TG_OP = 'DELETE') THEN
    RAISE EXCEPTION 'PG-20001 Uma instrucao de titulo nao pode ser excluida.%' , vComplemento;
  END IF;

  IF (TG_OP = 'UPDATE') THEN
    IF OLD.DATENV IS NOT NULL THEN
    RAISE EXCEPTION 'PG-20001 Uma instrucao de titulo enviada nao pode ser modificada.%' , vComplemento;
    END IF;
  END IF;

  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    NEW.DATSOL := agora();
    IF NEW.SEQUEN IS NULL THEN
      NEW.SEQUEN:=ProximoCodigo('TT_IXT',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4507 --*/
CREATE TRIGGER TGIXT
BEFORE INSERT OR DELETE OR UPDATE ON TT_IXT 
FOR EACH ROW EXECUTE PROCEDURE TGIXT();


/*-- SEQ 4508 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGJOB() CASCADE;

/*-- SEQ 4509 --*/
CREATE OR REPLACE FUNCTION TGJOB() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Impedir exclusao
-- 2) Permitir apenas valores validos

  vComplemento  VARCHAR(254);

-- Principal
BEGIN

  vComplemento := constante('complemento');

  IF (TG_OP = 'DELETE') THEN
    RAISE EXCEPTION 'PG-20001 JOB nao pode ser excluido. %' , vComplemento;
  ELSE
    NEW.ULTEXE := Agora();
    NEW.NOMJOB := Upper(Trim(NEW.NOMJOB));    
    NEW.QTDERR := ABS(COALESCE(NEW.QTDERR,0));
  END IF;

  IF (TG_OP = 'UPDATE') THEN
    IF Equal(OLD.NOMJOB,NEW.NOMJOB) <> 1 THEN
      RAISE EXCEPTION 'PG-20002 Nome do JOB nao pode ser modificado. %' , vComplemento;
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4510 --*/
CREATE TRIGGER TGJOB
BEFORE INSERT OR UPDATE OR DELETE ON TT_JOB 
FOR EACH ROW EXECUTE PROCEDURE TGJOB();


/*-- SEQ 4511 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGKIT() CASCADE;

/*-- SEQ 4512 --*/
CREATE OR REPLACE FUNCTION TGKIT() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir que produto seja kit dele mesmo
-- 2) Gerar um codigo sequencial exclusivo para compor a chave primaria
DECLARE
   vComplemento                  VARCHAR(254) := Constante('complemento');
   cRet                          VARCHAR(2);
BEGIN
   IF NOT (TG_OP = 'DELETE') THEN
      NEW.ATU_EM := AGORA();
      IF (NEW.FILMAT = NEW.FILITE) and (NEW.CODMAT = NEW.CODITE) and 
         (NEW.CODCOR = NEW.CORITE) and (NEW.CODTAM = NEW.TAMITE) then
         RAISE EXCEPTION 'PG-20021 Um kit nao pode ser um item dele mesmo. %' , vComplemento;
      END IF;
   END IF;

   IF (TG_OP = 'INSERT') THEN
      NEW.SEQUEN:=ProximoCodigo('TT_KIT',NEW.FILMAT);
   END IF;

   IF (TG_OP = 'DELETE') THEN
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_KIT', 
                           RPAD(SUBSTR(OLD.FILMAT || OLD.CODMAT || '-' || TO_CHAR(OLD.CODCOR) || '-' || TO_CHAR(OLD.CODTAM), 1, 20),20, ' '),
                           RPAD(SUBSTR(OLD.FILITE || OLD.CODITE || '-' || TO_CHAR(OLD.CORITE) || '-' || TO_CHAR(OLD.TAMITE), 1, 20),20, ' '));
   END IF;
   IF (TG_OP = 'INSERT') THEN
      --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_KIT', 
                           RPAD(SUBSTR(NEW.FILMAT || NEW.CODMAT || '-' || TO_CHAR(NEW.CODCOR) || '-' || TO_CHAR(NEW.CODTAM), 1, 20),20, ' '),
                           RPAD(SUBSTR(NEW.FILITE || NEW.CODITE || '-' || TO_CHAR(NEW.CORITE) || '-' || TO_CHAR(NEW.TAMITE), 1, 20),20, ' '));
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4513 --*/
CREATE TRIGGER TGKIT
BEFORE INSERT OR UPDATE OR DELETE ON TT_KIT 
FOR EACH ROW EXECUTE PROCEDURE TGKIT();

/*-- SEQ 4514 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGKIT2() CASCADE;

/*-- SEQ 4515 --*/
CREATE OR REPLACE FUNCTION TGKIT2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_GRA
DECLARE
   cRetorno                      VARCHAR(2);
   cWhere                        TM_ATU.FILTRO%TYPE;
   
BEGIN
   --Tratamento para Atualizar Tabela Pai
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN      
      cWhere := 'FILMAT = ' || CHR(39) || NEW.FILMAT  || CHR(39) || ' AND CODMAT = ' || CHR(39) || NEW.CODMAT || CHR(39) ||
                ' AND CODCOR = ' || TO_CHAR( NEW.CODCOR ) || ' AND CODTAM = ' || TO_CHAR( NEW.CODTAM );
   ELSIF (TG_OP = 'DELETE') THEN      
      cWhere := 'FILMAT = ' || CHR(39) || OLD.FILMAT  || CHR(39) || ' AND CODMAT = ' || CHR(39) || OLD.CODMAT || CHR(39) ||
                ' AND CODCOR = ' || TO_CHAR( OLD.CODCOR ) || ' AND CODTAM = ' || TO_CHAR( OLD.CODTAM );
   END IF;
   cRetorno := INSERE_MATU('TT_KIT', 'TT_GRA', cWhere);
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4516 --*/
CREATE TRIGGER TGKIT2
AFTER INSERT OR UPDATE OR DELETE ON TT_KIT 
FOR EACH ROW EXECUTE PROCEDURE TGKIT2();


/*-- SEQ 4517 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLAC1() CASCADE;

/*-- SEQ 4518 --*/
CREATE OR REPLACE FUNCTION TGLAC1() RETURNS TRIGGER AS $$
DECLARE
    
    QuemLogou TRetQuemLogou%ROWTYPE;
  -- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN  
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    IF ISNULL(NEW.SEQUEN)='T' THEN
      NEW.SEQUEN:=ProximoCodigo('TT_LAC',NEW.CODFIL);
    END IF;
    NEW.DATINC := agora();
    select * into QuemLogou from DadosLogon();
    NEW.FILUSU := QuemLogou.FILUSU;
    NEW.CODUSU := QuemLogou.CODUSU; 
  END IF;

  -- Popula a coluna ATU_EM
  IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
     NEW.ATU_EM := agora();      
  END IF;    
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4519 --*/
CREATE TRIGGER TGLAC1
BEFORE INSERT OR UPDATE ON TT_LAC 
FOR EACH ROW EXECUTE PROCEDURE TGLAC1();

/*-- SEQ 4520 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLAC2() CASCADE;

/*-- SEQ 4521 --*/
CREATE OR REPLACE FUNCTION TGLAC2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 2) Registrar mudanca dos dados num "log"
   vLOG    VARCHAR(4000)     := '';
   vFILUSU VARCHAR(3);    
   vCODUSU VARCHAR(3); 
   cNulo   CONSTANT CHAR(1)   := '0';
   CRLF    CONSTANT CHAR(1)   := CHR(10);  
    
    QuemLogou TRetQuemLogou%ROWTYPE;
    WK_CODUID TT_UID.CODUID%TYPE;
BEGIN
  WK_CODUID := GetCoduidAtual();

  IF (TG_OP = 'INSERT') THEN 
     UPDATE TD_BIC
        SET FILLAC = NEW.CODFIL,
            SEQLAC = NEW.SEQUEN
      WHERE FILLAC = NEW.FILLAC 
	    AND SEQLAC = NEW.SEQLAC;
		
	 --83454
     UPDATE TD_BIC
        SET FILLAC = NEW.CODFIL,
            SEQLAC = NEW.SEQUEN
      WHERE FILLAC IS NULL
        AND CODTAB = NEW.CODBIC;		
  END IF;
 
  select * into QuemLogou from DadosLogon();
  vFILUSU := QuemLogou.FILUSU;
  vCODUSU := QuemLogou.CODUSU;
 
  -- Tratamento de "log"
  IF (TG_OP = 'DELETE') THEN
     DELETE FROM TL_LAC WHERE FILLAC = OLD.CODFIL AND SEQLAC = OLD.SEQUEN;
  END IF;

  -- Tratamento de log
  IF (TG_OP = 'INSERT') THEN
     vLOG := 'Inclusao';
     INSERT INTO TL_LAC (FILLAC,SEQLAC,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
          VALUES(NEW.CODFIL,NEW.SEQUEN,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);
  ELSIF (TG_OP = 'UPDATE') THEN
     IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
        vLOG := vLOG||'Filial do Lacre: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
        vLOG := vLOG||'Sequncia do Lacre: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.NUMLAC,NEW.NUMLAC) <> 1 THEN
        vLOG := vLOG||'Nmero do Lacre Associado na Bomba: de '||COALESCE(OLD.NUMLAC,cNulo)||' para '||COALESCE(NEW.NUMLAC,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATAPL,NEW.DATAPL) <> 1 THEN
        vLOG := vLOG||'Data de aplicao do Lacre: de '||COALESCE(OLD.DATAPL,cNulo)||' para '||COALESCE(NEW.DATAPL,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.LACATI,NEW.LACATI) <> 1 THEN
        vLOG := vLOG||'Ativo: de '||COALESCE(OLD.LACATI,cNulo)||' para '||COALESCE(NEW.LACATI,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.CODBOM,NEW.CODBOM) <> 1 THEN
        vLOG := vLOG||'Cdigo de Bomba: de '||COALESCE(OLD.CODBOM,0)||' para '||COALESCE(NEW.CODBOM,0)||CRLF;
     END IF;
     IF ISNOTNULL(trim(vLOG)) = 'T' THEN
        -- cadastra o LOG.
        INSERT INTO TL_LAC (FILLAC,SEQLAC,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                 VALUES (NEW.CODFIL,NEW.SEQUEN,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);
     END IF;   
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4522 --*/
CREATE TRIGGER TGLAC2
AFTER INSERT OR UPDATE OR DELETE ON TT_LAC 
FOR EACH ROW EXECUTE PROCEDURE TGLAC2(); 
  


/*-- SEQ 4523 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLACR() CASCADE;

/*-- SEQ 4524 --*/
CREATE OR REPLACE FUNCTION TGLACR() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Popular Datope e no permitir alterao e excluso apenas incluso
-- Principal
BEGIN  
  IF (TG_OP = 'INSERT') THEN
       NEW.DATOPE := agora();
  END IF;    

  IF (TG_OP = 'UPDATE') THEN    
       RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser alterado';     
  END IF;

  IF (TG_OP = 'DELETE') THEN  
     RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido';     
  END IF; 

  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_ACR','001');
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4525 --*/
CREATE TRIGGER TGLACR
BEFORE INSERT OR UPDATE OR DELETE ON TL_ACR 
FOR EACH ROW EXECUTE PROCEDURE TGLACR();



/*-- SEQ 4526 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLAN2() CASCADE;

/*-- SEQ 4527 --*/
CREATE OR REPLACE FUNCTION TGLAN2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Impedir exclusoes
-- 2) Permitir apenas alteracao nas colunas SITMOV e EXPORT
-- 3) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 4) Atualizar saldos
-- 5) Atualizar a movimentacao diaria
-- 6) Converter embalagens numa inclusao
--

  -- Para controle de embalagens
  NovoCODTAM TT_LAN.CODTAM%TYPE;
  NovoQTDMOV TT_LAN.QTDMOV%TYPE;
  NovoEMBORI TT_LAN.EMBORI%TYPE;
  NovoEMBQTD TT_LAN.EMBQTD%TYPE;
  vComplemento Constant VARCHAR(100) := Constante('Complemento');
  WK_NADA VARCHAR(100);

  QuemLogou TRetQuemLogou%ROWTYPE;

  LANCAMENTOK Numeric(1);

  bCalculaCusto boolean:=false;

  vMOVLEG TD_LAN.MOVLEG%TYPE;
  inRec      TT_LAN%ROWTYPE;
  cDUMMY       VARCHAR(1);

-- Principal
BEGIN
  -- Impede exclusoes
  IF (TG_OP = 'DELETE') THEN
     RAISE EXCEPTION 'PG-20027 Exclusao so pode ser feita atraves da rotina Manutencao. %' , vComplemento;
  END IF;

  -- Pega CODFIL e SEQUEN do usuario logado
  select * into QuemLogou from DadosLogon();
  IF ((QualDono() != GetApeUsuAtual()) AND (not QuemLogou.Encontrou)) THEN
    RAISE EXCEPTION 'PG-20051 Usuario nao esta cadastrado no Totali. %s' , vComplemento;
  END IF;

  -- DN - Financeiro Estoque
  IF ((TG_OP = 'INSERT') OR (TG_OP = 'UPDATE')) THEN
     NEW.DATSTR:=TO_CHAR(NEW.DATMOV,'DD/MM/YYYY');
  END IF;

  IF NOT (TG_OP = 'DELETE') THEN
     SELECT MOVLEG INTO vMOVLEG
    FROM TD_LAN
    WHERE CODTAB=NEW.TIPLAN;
  END IF;

  IF (TG_OP = 'INSERT') THEN
    -- Verifica se o lancamento esta na data permitida
    SELECT COUNT(*) INTO LANCAMENTOK
    FROM TT_USU
    WHERE FILUSU=QuemLogou.filusu
      AND CODUSU=QuemLogou.codusu
      AND NEW.DATMOV BETWEEN to_date(to_char(ADD_DAY(agora(),cast(-COALESCE(MINDAT,0) as integer)),'DD/MM/YYYY')||' 00:00:00','DD/MM/YYYY HH24:MI:SS')
                          AND to_date(to_char(ADD_DAY(agora(),cast( COALESCE(MAXDAT,0) as integer)),'DD/MM/YYYY')||' 23:59:59','DD/MM/YYYY HH24:MI:SS');

    --IF LANCAMENTOK=0 THEN
    --  RAISE EXCEPTION 'PG-20051 Lancamento fora do limite de dias aceitos para este usuario. %s' , vComplemento;
    --END IF;
  END IF;

  IF (TG_OP = 'UPDATE') THEN
    IF (OLD.CODFIL <> NEW.CODFIL) or
       (OLD.FILMAT <> NEW.FILMAT) or
       (OLD.CODMAT <> NEW.CODMAT) or
       (OLD.CODCOR <> NEW.CODCOR) or
       (OLD.CODTAM <> NEW.CODTAM) or
       (OLD.CODMUL <> NEW.CODMUL) or
       (OLD.DATMOV <> NEW.DATMOV) or
--       (OLD.ATU_EM <> NEW.ATU_EM) or
       (OLD.QTDMOV <> NEW.QTDMOV) or
--       (OLD.VLRMOV <> NEW.VLRMOV) or
       (OLD.FILUSU <> NEW.FILUSU) or
       (OLD.CODUSU <> NEW.CODUSU) or
       (OLD.TIPMOV <> NEW.TIPMOV) or
       (OLD.NUMEXT <> NEW.NUMEXT) or
       (OLD.QTDMOV <> NEW.QTDMOV) or
       (OLD.EMBORI <> NEW.EMBORI) or
       (OLD.EMBQTD <> NEW.EMBQTD) or
       (OLD.DATINC <> NEW.DATINC) or
       (OLD.DOCUME <> NEW.DOCUME) THEN
      RAISE EXCEPTION 'PG-20014 Um lancamento nao pode ser modificado. %' , vComplemento;
    END IF;

    IF (OLD.SITMOV = 'C') AND (NEW.SITMOV = 'N') THEN
      RAISE EXCEPTION 'PG-20015 Um lancamento cancelado nao pode ser reativado. %' , vComplemento;
    END IF;
    IF (OLD.EXPORT <> NEW.EXPORT) THEN
       IF NOT ( (OLD.EXPORT = 'F') AND (NEW.EXPORT = 'T') OR
                (OLD.EXPORT = 'T') AND (NEW.EXPORT = 'R') OR
                (OLD.EXPORT = 'R') AND (NEW.EXPORT = 'C') ) THEN
              RAISE EXCEPTION 'PG-20015 Esta alteracao do controle de exportacao nao eh permitida. %' , vComplemento;
       END IF;
    END IF;


  END IF;

  IF (TG_OP = 'INSERT') THEN
    -- Gera um codigo automaticamente
    NEW.SEQUEN := ProximoCodigo('TT_LAN',NEW.CODFIL);

    -- Corrige os dados passados de acordo com a embalagem
    SELECT COALESCE(DSUB.CODSAL,SUB.CODITE) AS CODTAM,
           NEW.QTDMOV * (CASE COALESCE(DSUB.CODSAL,0) WHEN 0 THEN 1 ELSE SUB.FATCON END) AS QTDMOV,
           CASE COALESCE(DSUB.CODSAL,0) WHEN 0 THEN NULL ELSE SUB.CODITE END AS EMBORI,
           CASE COALESCE(DSUB.CODSAL,0) WHEN 0 THEN NULL ELSE NEW.QTDMOV END AS EMBQTD
    INTO NovoCODTAM, NovoQTDMOV, NovoEMBORI, NovoEMBQTD
    FROM TD_SUB DSUB, TT_SUB SUB
    WHERE SUB.CODSUB = DSUB.CODTAB
      AND SUB.CODITE = NEW.CODTAM;

    NEW.CODTAM := NovoCODTAM;
    NEW.QTDMOV := NovoQTDMOV;
    NEW.EMBORI := NovoEMBORI;
    NEW.EMBQTD := NovoEMBQTD;

    NEW.DATINC := AGORA();
    NEW.QTD_CM := NEW.QTDMOV;
  END IF;

  -- Estorna o saldo
  -- Tambem atualiza a movimentacao diaria
  IF (TG_OP = 'UPDATE') then
    if (OLD.SITMOV = 'N') AND (NEW.SITMOV = 'C') THEN
      IF MovimentaEstoque(NEW.CODFIL,NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,NEW.CODMUL) = 'T' THEN
        WK_NADA := TGR_LAN_Atualiza_Saldo(OLD.QTDMOV * -1,NEW.CODFIL,NEW.FILMAT,NEW.CODMAT,
                                          NEW.CODCOR,NEW.CODTAM,NEW.CODMUL);
        WK_NADA := TGR_LAN_Atualiza_Movimento(OLD.QTDMOV * -1,OLD.VLRMOV * -1,NEW.CODFIL,NEW.FILMAT,NEW.CODMAT,
                                              NEW.CODCOR,NEW.CODTAM,NEW.CODMUL,NEW.DATMOV,vMOVLEG);
        /* Atualiza saldo do Lote */

        IF  ISNOTNULL(TRIM(NEW.FILLOT)) = 'T'
        AND ISNOTNULL(TRIM(NEW.SEQLOT)) = 'T' THEN
           WK_NADA := TGR_LAN_Atualiza_Saldo_Lote(OLD.QTDMOV * -1, NEW.CODFIL, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT);
        END IF;

     END IF;

      NEW.DATINC := AGORA();

      IF OLD.EXPORT = 'T' THEN
         NEW.EXPORT := 'R';
      END IF;


    end if;

    -- Aumenta/diminui o saldo
    -- Tambem atualiza a movimentacao diaria
  ELSIF (TG_OP = 'INSERT') THEN
    IF  (NEW.SITMOV <> 'C')
    AND (MovimentaEstoque(NEW.CODFIL,NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,NEW.CODMUL) = 'T') THEN
      WK_NADA := TGR_LAN_Atualiza_Saldo(NEW.QTDMOV,NEW.CODFIL,NEW.FILMAT,NEW.CODMAT,
                                            NEW.CODCOR,NEW.CODTAM,NEW.CODMUL);
      WK_NADA := TGR_LAN_Atualiza_Movimento(NEW.QTDMOV,NEW.VLRMOV,NEW.CODFIL,NEW.FILMAT,NEW.CODMAT,
                                            NEW.CODCOR,NEW.CODTAM,NEW.CODMUL,NEW.DATMOV,vMOVLEG);

      /* Atualiza saldo do Lote */
      IF  ISNOTNULL(TRIM(NEW.FILLOT)) = 'T'
      AND ISNOTNULL(TRIM(NEW.SEQLOT)) = 'T' THEN
         WK_NADA := TGR_LAN_Atualiza_Saldo_Lote(NEW.QTDMOV, NEW.CODFIL, NEW.CODMUL, NEW.FILLOT, NEW.SEQLOT);
      END IF;
   END IF;


  END IF;
  -- Recalcula a data para CustoMedio
  IF (TG_OP = 'INSERT') THEN
     bCalculaCusto:=true;
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF (Equal(OLD.QTD_CM,NEW.QTD_CM)<>1) or
        (Equal(OLD.SITMOV,NEW.SITMOV)<>1) or
        (Equal(OLD.TIPLAN,NEW.TIPLAN)<>1) or
        (Equal(OLD.DATMOV,NEW.DATMOV)<>1) or
      (Equal(OLD.VLRMOV,NEW.VLRMOV)<>1) then
        bCalculaCusto:=true;
     END IF;
  END IF;
  IF bCalculaCusto THEN
      /* Atualiza a data do custo medio na TT_SAL */
                 inRec.CODFIL := NEW.CODFIL;
           inRec.SEQUEN := NEW.SEQUEN;
           inRec.DATMOV := NEW.DATMOV;
           inRec.FILMAT := NEW.FILMAT;
           inRec.CODMAT := NEW.CODMAT;
           inRec.CODCOR := NEW.CODCOR;
           inRec.CODTAM := NEW.CODTAM;
           
           cDUMMY := PC_LAN_AUX_UPDATE(inREC.DATMOV,
                                       inREC.CODFIL,
                                       inREC.FILMAT,
                                       inREC.CODMAT,
                                       inREC.CODCOR,
                                       inREC.CODTAM);
                      END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4528 --*/
CREATE TRIGGER TGLAN2
BEFORE INSERT OR DELETE OR UPDATE ON TT_LAN 
FOR EACH ROW EXECUTE PROCEDURE TGLAN2();




/*-- SEQ 4529 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLAYXLGPD() CASCADE;

/*-- SEQ 4530 --*/
CREATE OR REPLACE FUNCTION TGLAYXLGPD() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Controle de datas

-- Principal
BEGIN
   
   -- Gera codigo sequencial exclusivo
   IF (TG_OP = 'INSERT') THEN
      IF NEW.ID_LAYXLGPD IS NULL THEN
         NEW.ID_LAYXLGPD := ProximoCodigo('TT_LAYXLGPD', NULL);
      END IF;
      
      NEW.DATINC := agora();
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4531 --*/
CREATE TRIGGER TGLAYXLGPD
BEFORE INSERT OR UPDATE ON TT_LAYXLGPD 
FOR EACH ROW EXECUTE PROCEDURE TGLAYXLGPD();

/*-- SEQ 4532 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLAYXLGPD2() CASCADE;

/*-- SEQ 4533 --*/
CREATE OR REPLACE FUNCTION TGLAYXLGPD2() RETURNS TRIGGER AS $$
DECLARE

   -- Objetivos
   -- 1) Registrar Log de alteraes
   -- Principal
   cLOG                          VARCHAR(4000)     := '';
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   nCODUID                       TT_UID.CODUID%TYPE;
   cTIP_LGPD                     TT_LAY.TIP_LGPD%TYPE;
   cCODTAB                       TT_LAY.CODTAB%TYPE;
   cNOMCPO                       TT_LAY.NOMCPO%TYPE;
   
    
    QuemLogou                     TRetQuemLogou%ROWTYPE;
  BEGIN
   IF (TG_OP = 'DELETE') THEN 
      RAISE EXCEPTION 'PG-20001 No  permitido deletar registro da tabela "TT_LAYXLGPD"';
   END IF;

   nCODUID := GetCoduidAtual();
   
   cCODTAB := COALESCE(NEW.CODTAB, OLD.CODTAB);
   cNOMCPO := COALESCE(NEW.NOMCPO, OLD.NOMCPO);
   
         SELECT TIP_LGPD
        INTO cTIP_LGPD
        FROM TT_LAY
       WHERE CODTAB = cCODTAB
         AND NOMCPO = cNOMCPO;
   
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.TIP_LGPD,NEW.TIP_LGPD) <> 1 THEN
         IF OLD.TIP_LGPD = cTIP_LGPD THEN
            cLOG := cLOG||COALESCE(DescricaoDominio('GPD','TIP_LGPD',OLD.TIP_LGPD), cNulo)||' (padro) para '||COALESCE(DescricaoDominio('GPD','TIP_LGPD',NEW.TIP_LGPD), cNulo)||CRLF;
         ELSE
            cLOG := cLOG||COALESCE(DescricaoDominio('GPD','TIP_LGPD',OLD.TIP_LGPD), cNulo)||' para '||COALESCE(DescricaoDominio('GPD','TIP_LGPD',NEW.TIP_LGPD), cNulo)||CRLF;
         END IF;
      END IF;
   END IF;
   
   -- MN - Grava Log
   IF ISNOTNULL(cLOG) = 'T' THEN
      cLOG := cLOG||CRLF;
         
      select * into QuemLogou from DadosLogon();
      INSERT INTO TL_LAYXLGPD (ID_LAYXLGPD, FILUSU, CODUSU, DATOPE, MSGLOG, CODUID) VALUES
                              (COALESCE(NEW.ID_LAYXLGPD, OLD.ID_LAYXLGPD), QuemLogou.FILUSU, QuemLogou.CODUSU, agora(), cLOG, nCODUID);
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4534 --*/
CREATE TRIGGER TGLAYXLGPD2
AFTER INSERT OR DELETE OR UPDATE ON TT_LAYXLGPD 
FOR EACH ROW EXECUTE PROCEDURE TGLAYXLGPD2();


/*-- SEQ 4535 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLBRU() CASCADE;

/*-- SEQ 4536 --*/
CREATE OR REPLACE FUNCTION TGLBRU() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB := ProximoCodigo('TL_BRU',NEW.FILBRU);
    END IF;
    NEW.DATOPE := AGORA();
  END IF; 
  IF (TG_OP = 'DELETE') THEN     
     RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido.';
  END IF;
  IF (TG_OP = 'UPDATE') THEN     
     RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser alterado.';
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4537 --*/
CREATE TRIGGER TGLBRU
BEFORE INSERT OR UPDATE OR DELETE ON TL_BRU 
FOR EACH ROW EXECUTE PROCEDURE TGLBRU();


/*-- SEQ 4538 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLCCB() CASCADE;

/*-- SEQ 4539 --*/
CREATE OR REPLACE FUNCTION TGLCCB() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impedir excluses.
-- 2. Impedir atualizaes.
-- 3. Gerar um cdigo sequencial exclusivo para compor a chave primria.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');
   cCODLOJ                       TT_IDF.CODLOJ%TYPE;

-- Principal
BEGIN

   -- Impede excluso.
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20000 Registro de uso interno. No pode ser excludo. %' , COMPLEMENTO;
   END IF;

   -- Impedir atualizaes.
   IF (TG_OP = 'UPDATE') THEN
      RAISE EXCEPTION 'PG-20001 Registro de uso interno. No pode ser modificado. %' , COMPLEMENTO;
   END IF;

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.CODTAB IS NULL THEN
         SELECT CODLOJ INTO cCODLOJ FROM TT_IDF;
         NEW.CODTAB := ProximoCodigo('TL_CCB',cCODLOJ);
      END IF;
      NEW.DATOPE := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4540 --*/
CREATE TRIGGER TGLCCB
BEFORE INSERT OR UPDATE OR DELETE ON TL_CCB 
FOR EACH ROW EXECUTE PROCEDURE TGLCCB();


/*-- SEQ 4541 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLCCC() CASCADE;

/*-- SEQ 4542 --*/
CREATE OR REPLACE FUNCTION TGLCCC() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_CCC',NEW.FILCCC);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4543 --*/
CREATE TRIGGER TGLCCC
BEFORE INSERT ON TL_CCC 
FOR EACH ROW EXECUTE PROCEDURE TGLCCC();


/*-- SEQ 4544 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLCF() CASCADE;

/*-- SEQ 4545 --*/
CREATE OR REPLACE FUNCTION TGLCF() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir exclusoes
-- 2) Impedir alteracao de determinadas colunas
-- 3) Gerar codigo sequencial exclusivo para compor a chave primaria
-- 4) Atualizar ATU_EM
--
DECLARE

   vComplemento                  VARCHAR(100);
   Logon                         TRetQuemLogou%ROWTYPE;
-- Principal
begin
   vComplemento := Constante('Complemento');

   -- Impede exclusoes
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20036 Lancamento de Cupon Fiscal nao pode ser excluida. %' , vComplemento;
   END IF;

   -- Checa quem logou
   -- Dados do usuario
   select * into Logon from DadosLogon();
   IF not Logon.Encontrou THEN
      RAISE EXCEPTION 'PG-20037 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
   END IF;

   -- Gera um codigo automaticamente
   IF (TG_OP = 'INSERT') THEN
      NEW.SEQUEN := ProximoCodigo('TT_LCF',NEW.CODFIL);
   END IF;

   -- Impede alteracoes
   IF (TG_OP = 'UPDATE') THEN
      IF (OLD.CODFIL <> NEW.CODFIL) OR
         (OLD.SEQUEN <> NEW.SEQUEN) OR
         (OLD.CODSER <> NEW.CODSER) OR
         (OLD.NUMECF <> NEW.NUMECF) OR
         (OLD.TIPOPE <> NEW.TIPOPE) OR
         (OLD.DATHOR <> NEW.DATHOR) OR
         (OLD.CUPFIS <> NEW.CUPFIS) OR
         (OLD.CODERR <> NEW.CODERR) OR
         (OLD.DATFIS <> NEW.DATFIS) THEN
         RAISE EXCEPTION 'PG-20002 Lancamento de Cupom Fiscal nao pode ser alterado. %' , vComplemento;
      END IF;
      NEW.FILUSU := Logon.FILUSU;
      NEW.CODUSU := Logon.CODUSU;
   END IF;
   
   IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
      
      -- Garantir que DATFIS recebe apenas Data
      IF NEW.DATFIS IS NULL THEN
         NEW.DATFIS := TRUNC(NEW.DATHOR);
      ELSE
         NEW.DATFIS := TRUNC(NEW.DATFIS);
      END IF;
      
      -- Valores "default"
      NEW.ATU_EM := agora();
   END IF;
   
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4546 --*/
CREATE TRIGGER TGLCF
BEFORE INSERT OR DELETE OR UPDATE ON TT_LCF 
FOR EACH ROW EXECUTE PROCEDURE TGLCF();


/*-- SEQ 4547 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLCHR() CASCADE;

/*-- SEQ 4548 --*/
CREATE OR REPLACE FUNCTION TGLCHR() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir exclusoes
-- 2) Impedir alteracoes
-- 3) Fazer parte do papel de uma "foreign key"
DECLARE
  dummy1 TL_CHR.CODFIL%TYPE;
  dummy2 TL_CHR.SEQCHE%TYPE;

  vComplemento VARCHAR(100);

  wk_coduid tt_uid.coduid%type;


  cheque CURSOR(filial TL_CHR.CODFIL%TYPE,
           sequencia TL_CHR.SEQCHE%TYPE) IS   
    SELECT CODFIL,SEQUEN
    FROM TT_CHR
    WHERE CODFIL = filial
      AND SEQUEN = sequencia;

BEGIN
  vComplemento := Constante('Complemento');
  -- So permite inclusoes
  IF ((TG_OP = 'DELETE')) OR ((TG_OP = 'UPDATE')) THEN
    RAISE EXCEPTION 'PG-20036 Tabelas de "log" nao podem ter seus dados modificados ou excluidos. %' , vComplemento;
  END IF;

  -- Faz o papel da "foreign key" verificando se o cheque existe
  OPEN cheque (NEW.CODFIL,NEW.SEQCHE);
  FETCH cheque INTO dummy1,dummy2;
  IF NOT FOUND THEN
    CLOSE cheque;
    RAISE EXCEPTION 'PG-20037 Cheque nao foi encontrado. %' , vComplemento;
  END IF;
  CLOSE cheque;

  -- "Default"
  NEW.DATOPE := agora();

  WK_CODUID := GetCoduidAtual();

  NEW.coduid := wk_coduid;


IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_CHR',NEW.CODFIL);
    END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4549 --*/
CREATE TRIGGER TGLCHR
BEFORE INSERT OR DELETE OR UPDATE ON TL_CHR 
FOR EACH ROW EXECUTE PROCEDURE TGLCHR();


/*-- SEQ 4550 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLCLI() CASCADE;

/*-- SEQ 4551 --*/
CREATE OR REPLACE FUNCTION TGLCLI() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Impedir alteracoes
-- 2) Obter o codigo do usuario logado e associa-lo ao TT_USU
-- 3) Fazer parte do papel de uma "foreign key"

  achou   INTEGER;
  vComplemento VARCHAR(100);
    Logon  TRetQuemLogou%ROWTYPE;

  wk_coduid tt_uid.coduid%type;


-- Principal
BEGIN
   vComplemento := Constante('Complemento');
   
    -- So permite inclusoes
   IF (TG_OP = 'UPDATE') THEN
      IF NEW.Dummy <> Constante('VEM_DE_ANONIMIZACAO') THEN
         RAISE EXCEPTION 'PG-20036 Tabelas de "log" nao podem ter seus dados modificados ou excluidos. %' , vComplemento;
      END IF;
   END IF;

   -- MN - 2021018889 - Permite deletar o registro se vier da anonimizao de dados
   IF (TG_OP = 'DELETE') THEN
      IF NEW.Dummy <> Constante('VEM_DE_ANONIMIZACAO') THEN
         ACHOU := TGR_Cliente_Existe(OLD.filcli, OLD.CODCli); /* retornos possiveis 0 e 1 E -1 */
         
         IF (achou = 1) THEN
           RAISE EXCEPTION 'PG-20039 Nao e possivel excluir o log de um cliente existente. %' , vComplemento;
         END IF;
      END IF;
   END IF;

  IF (TG_OP = 'INSERT') THEN

   IF NEW.CODTAB IS NULL THEN
      NEW.CODTAB:=ProximoCodigo('TL_CLI',NEW.FILCLI);
   END IF;

      -- Dados do usuario
    select * into Logon from DadosLogon();
    IF Logon.Encontrou THEN
      IF (NEW.FILUSU IS NULL) OR (NEW.CODUSU IS NULL) THEN
        NEW.FILUSU := Logon.FILUSU;
        NEW.CODUSU := Logon.CODUSU;
      END IF;
    ELSE
      RAISE EXCEPTION 'PG-20037 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
    END IF;

    -- "Default"
    NEW.DATOPE := agora();

    WK_CODUID := GetCoduidAtual();

   NEW.coduid := wk_coduid;

  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4552 --*/
CREATE TRIGGER TGLCLI
BEFORE INSERT OR DELETE OR UPDATE ON TL_CLI 
FOR EACH ROW EXECUTE PROCEDURE TGLCLI();


/*-- SEQ 4553 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLCOM() CASCADE;

/*-- SEQ 4554 --*/
CREATE OR REPLACE FUNCTION TGLCOM() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_COM',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4555 --*/
CREATE TRIGGER TGLCOM
BEFORE INSERT ON TL_COM 
FOR EACH ROW EXECUTE PROCEDURE TGLCOM();


/*-- SEQ 4556 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLCPF() CASCADE;

/*-- SEQ 4557 --*/
CREATE OR REPLACE FUNCTION TGLCPF() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impedir excluses.
-- 2. Impedir atualizaes.
-- 3. Gerar um cdigo sequencial exclusivo para compor a chave primria.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Impede excluso.
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20000 Registro de uso interno. No pode ser excludo. %' , COMPLEMENTO;
   END IF;

   -- Impedir atualizaes.
   IF (TG_OP = 'UPDATE') THEN
      RAISE EXCEPTION 'PG-20001 Registro de uso interno. No pode ser modificado. %' , COMPLEMENTO;
   END IF;

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.CODTAB IS NULL THEN
         NEW.CODTAB := ProximoCodigo('TL_CPF',NEW.FILCPF);
      END IF;
      NEW.DATOPE := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4558 --*/
CREATE TRIGGER TGLCPF
BEFORE INSERT OR UPDATE OR DELETE ON TL_CPF 
FOR EACH ROW EXECUTE PROCEDURE TGLCPF();


/*-- SEQ 4559 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLCPR() CASCADE;

/*-- SEQ 4560 --*/
CREATE OR REPLACE FUNCTION TGLCPR() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Controlar Datas e Sequenciadores

-- Principal
BEGIN
  -- Gera codigo sequencial exclusivo
  IF NEW.ID_LCPR IS NULL THEN
    NEW.ID_LCPR := TO_NUMBER(TRIM(ProximoCodigo('TL_CPR',NEW.FILCPR)));
    NEW.DATOPE := agora();
  END IF; 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4561 --*/
CREATE TRIGGER TGLCPR
BEFORE INSERT OR UPDATE ON TL_CPR 
FOR EACH ROW EXECUTE PROCEDURE TGLCPR();


/*-- SEQ 4562 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLCRT() CASCADE;

/*-- SEQ 4563 --*/
CREATE OR REPLACE FUNCTION TGLCRT() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir alteracoes
-- 2) Obter o codigo do usuario logado e associa-lo ao TT_USU
-- 3) Fazer parte do papel de uma "foreign key"
DECLARE
  vComplemento VARCHAR(100);
  Logon        TRetQuemLogou%ROWTYPE;

  wk_coduid tt_uid.coduid%type;


-- Principal
BEGIN
  vComplemento := Constante('Complemento');

  IF (TG_OP = 'UPDATE') THEN
    RAISE EXCEPTION 'PG-20036 Tabelas de "log" nao podem ter seus dados modificados ou excluidos. %' , vComplemento;
  END IF;

  IF (TG_OP = 'INSERT') THEN

    -- Dados do usuario
    select * into Logon from DadosLogon();

    IF Logon.Encontrou THEN
      NEW.FILUSU := Logon.FILUSU;
      NEW.CODUSU := Logon.CODUSU;
    ELSE
      RAISE EXCEPTION 'PG-20037 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
    END IF;

    -- "Default"
    NEW.DATOPE := agora();

    WK_CODUID := GetCoduidAtual();

   NEW.coduid := wk_coduid;

  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4564 --*/
CREATE TRIGGER TGLCRT
BEFORE INSERT OR DELETE OR UPDATE ON TL_CRT 
FOR EACH ROW EXECUTE PROCEDURE TGLCRT();


/*-- SEQ 4565 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLCTF() CASCADE;

/*-- SEQ 4566 --*/
CREATE OR REPLACE FUNCTION TGLCTF() RETURNS TRIGGER AS $$
DECLARE
-- Tabela item de romaneio
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Atualiza DATINC
-- 3) Colocar valores padrao para FILUSU e CODUSU 
-- 4) Impedir exclusao
  
  vComplemento  VARCHAR(254) := constante('complemento'); 
  QuemLogou TRetQuemLogou%ROWTYPE;

-- Principal
BEGIN
  IF (TG_OP = 'DELETE') THEN
     RAISE EXCEPTION 'PG-20001 Nao e permitida a exclusao. %' , vComplemento;     
  END IF;

  IF (TG_OP = 'INSERT') THEN
     IF NEW.SEQUEN IS NULL THEN
        NEW.SEQUEN := ProximoCodigo('TL_CTF', NEW.CODFIL);
     END IF;
     select * into QuemLogou from DadosLogon();
     NEW.FILUSU := QuemLogou.FILUSU;
     NEW.CODUSU := QuemLogou.CODUSU;
     NEW.DATINC := agora();
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4567 --*/
CREATE TRIGGER TGLCTF
BEFORE INSERT OR DELETE ON TL_CTF 
FOR EACH ROW EXECUTE PROCEDURE TGLCTF();


/*-- SEQ 4568 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLCTT() CASCADE;

/*-- SEQ 4569 --*/
CREATE OR REPLACE FUNCTION TGLCTT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Impedir alteracoes
-- 2) Obter o codigo do usuario logado e associa-lo ao TT_USU
-- 3) Fazer parte do papel de uma "foreign key"
  achou   INTEGER;
  vComplemento VARCHAR(100);
  Logon  TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;

-- Principal
BEGIN
  vComplemento := Constante('Complemento');
  -- So permite inclusoes
  IF (TG_OP = 'UPDATE') THEN
    RAISE EXCEPTION 'PG-20036 Tabelas de "log" nao podem ter seus dados modificados ou excluidos. %' , vComplemento;

  ELSIF (TG_OP = 'DELETE') THEN
    RAISE EXCEPTION 'PG-20039 Nao e possivel excluir o log de um cliente existente. %' , vComplemento;

  ELSIF (TG_OP = 'INSERT') THEN
    Achou := TGR_Contrato_Existe(NEW.codfil, NEW.sequen); /* retornos possiveis 0 e 1 e -1*/
    IF (achou = 0) THEN
      RAISE EXCEPTION 'PG-20040 Contrato nao foi encontrado. %' , vComplemento;
    END IF;

  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_CTT',NEW.CODFIL);
    END IF;
  END IF;

    -- Dados do usuario
    select * into Logon from DadosLogon();
    IF Logon.Encontrou THEN
      NEW.FILUSU := Logon.FILUSU;
      NEW.CODUSU := Logon.CODUSU;
    ELSE
      RAISE EXCEPTION 'PG-20037 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
    END IF;
    -- "Default"
    NEW.DATALT := agora();

    WK_CODUID := GetCoduidAtual();

    NEW.coduid := wk_coduid;

  END IF; 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4570 --*/
CREATE TRIGGER TGLCTT
BEFORE INSERT OR UPDATE OR DELETE ON TL_CTT 
FOR EACH ROW EXECUTE PROCEDURE TGLCTT();


/*-- SEQ 4571 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLCUP() CASCADE;

/*-- SEQ 4572 --*/
CREATE OR REPLACE FUNCTION TGLCUP() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Controlar Datas e Sequenciadores

-- Principal
BEGIN
  -- Gera codigo sequencial exclusivo
  IF (TG_OP = 'INSERT') THEN
     IF NEW.ID_LCUP IS NULL THEN
       NEW.ID_LCUP := TO_NUMBER(TRIM(ProximoCodigo('TL_CUP',NEW.FILCUP)));
       NEW.DATOPE := agora();
     END IF; 
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4573 --*/
CREATE TRIGGER TGLCUP
BEFORE INSERT OR UPDATE ON TL_CUP 
FOR EACH ROW EXECUTE PROCEDURE TGLCUP();


/*-- SEQ 4574 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLDOP() CASCADE;

/*-- SEQ 4575 --*/
CREATE OR REPLACE FUNCTION TGLDOP() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Impedir exclusoes e alteracoes
-- 2) Registrar mudancas feitas na tabela TT_DOP

  vComplemento VARCHAR(100);
  Logon  TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN
  vComplemento := Constante('Complemento');
  -- Impede mudancas
  IF (TG_OP = 'UPDATE') OR (TG_OP = 'DELETE') THEN
     RAISE EXCEPTION 'PG-20001 Os dados de log nao podem ser modificados ou excluidos. %' , vComplemento;
  END IF;

  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_DOP',NEW.FILUSU);
    END IF;
  END IF;

  -- Checa quem logou
  select * into Logon from DadosLogon();
  if (not Logon.Encontrou) THEN
     RAISE EXCEPTION 'PG-20001 Usuario nao cadastrado no sistema. %' , vComplemento;
  END IF;

  -- Default
  NEW.DATOPE := agora();
  NEW.FILUSU := Logon.FILUSU;
  NEW.CODUSU := Logon.CODUSU;

  WK_CODUID := GetCoduidAtual();

  NEW.coduid := wk_coduid;


 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4576 --*/
CREATE TRIGGER TGLDOP
BEFORE INSERT OR UPDATE OR DELETE ON TL_DOP 
FOR EACH ROW EXECUTE PROCEDURE TGLDOP();


/*-- SEQ 4577 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLECF() CASCADE;

/*-- SEQ 4578 --*/
CREATE OR REPLACE FUNCTION TGLECF() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_ECF',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4579 --*/
CREATE TRIGGER TGLECF
BEFORE INSERT ON TL_ECF 
FOR EACH ROW EXECUTE PROCEDURE TGLECF();


/*-- SEQ 4580 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLEQP() CASCADE;

/*-- SEQ 4581 --*/
CREATE OR REPLACE FUNCTION TGLEQP() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_EQP',NEW.FILEQP);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4582 --*/
CREATE TRIGGER TGLEQP
BEFORE INSERT ON TL_EQP 
FOR EACH ROW EXECUTE PROCEDURE TGLEQP();



/*-- SEQ 4583 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLEX2() CASCADE;

/*-- SEQ 4584 --*/
CREATE OR REPLACE FUNCTION TGLEX2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Chamar pc_lex para tratar vinculo e desvinculo de conciliacao
cDUMMY VARCHAR(1);
vComplemento CONSTANT VARCHAR(100) := constante('complemento');
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN := ProximoCodigo('TT_LEX',NEW.CODFIL);
    END IF;
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF Equal(NEW.CODFIL,OLD.CODFIL)<>1 OR
        Equal(NEW.SEQUEN,OLD.SEQUEN)<>1 OR  
        Equal(NEW.FILIEX,OLD.FILIEX)<>1 OR  
        Equal(NEW.SEQIEX,OLD.SEQIEX)<>1 OR  
        Equal(NEW.NUMIEX,OLD.NUMIEX)<>1 OR  
        Equal(NEW.FILREC,OLD.FILREC)<>1 OR  
        Equal(NEW.SEQREC,OLD.SEQREC)<>1 OR  
        Equal(NEW.NUMPAR,OLD.NUMPAR)<>1 OR  
        Equal(NEW.SUBPAR,OLD.SUBPAR)<>1 OR  
        Equal(NEW.FILCCC,OLD.FILCCC)<>1 OR  
        Equal(NEW.SEQCCC,OLD.SEQCCC)<>1 OR  
        Equal(NEW.FILCHR,OLD.FILCHR)<>1 OR  
        Equal(NEW.SEQCHR,OLD.SEQCHR)<>1 OR  
        Equal(NEW.FILFIN,OLD.FILFIN)<>1 OR  
        Equal(NEW.SEQFIN,OLD.SEQFIN)<>1 OR  
        Equal(NEW.FILDOP,OLD.FILDOP)<>1 OR  
        Equal(NEW.SEQDOP,OLD.SEQDOP)<>1 OR  
        Equal(NEW.FILTIT,OLD.FILTIT)<>1 OR  
        Equal(NEW.SEQTIT,OLD.SEQTIT)<>1 OR 
        Equal(NEW.FILDEP,OLD.FILDEP)<>1 OR  
        Equal(NEW.SEQDEP,OLD.SEQDEP)<>1 OR  
        Equal(NEW.OLDFLG,OLD.OLDFLG)<>1 OR  
        Equal(NEW.OLDPOR,OLD.OLDPOR)<>1 OR  
        Equal(NEW.OLDSTD,OLD.OLDSTD)<>1 THEN 
       RAISE EXCEPTION 'PG-20001 Lancamento de extrado nao pode ser alterado. %' , vComplemento;
     END IF;
  END IF;
  IF (TG_OP = 'INSERT') THEN
          
       cDUMMY := PC_LEX_INS_UPDATE(NEW.CODFIL,NEW.SEQUEN,NEW.FILIEX,NEW.SEQIEX,NEW.NUMIEX,NEW.VLRLAN,
                                   NEW.FILREC,NEW.SEQREC,NEW.NUMPAR,NEW.SUBPAR,NEW.FILCCC,NEW.SEQCCC,
                                   NEW.FILCHR,NEW.SEQCHR,NEW.FILFIN,NEW.SEQFIN,NEW.FILDOP,NEW.SEQDOP,
                                   NEW.FILTIT,NEW.SEQTIT,NEW.FILDEP,NEW.SEQDEP,NEW.OLDFLG,NEW.OLDPOR,NEW.OLDSTD);
       END IF;
  IF (TG_OP = 'DELETE') THEN
          
       cDUMMY := PC_LEX_DEL_UPDATE(OLD.CODFIL,OLD.SEQUEN,OLD.FILIEX,OLD.SEQIEX,OLD.NUMIEX,OLD.VLRLAN,
                                   OLD.FILREC,OLD.SEQREC,OLD.NUMPAR,OLD.SUBPAR,OLD.FILCCC,OLD.SEQCCC,
                                   OLD.FILCHR,OLD.SEQCHR,OLD.FILFIN,OLD.SEQFIN,OLD.FILDOP,OLD.SEQDOP,
                                   OLD.FILTIT,OLD.SEQTIT,OLD.FILDEP,OLD.SEQDEP,OLD.OLDFLG,OLD.OLDPOR,OLD.OLDSTD);
       END IF; 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4585 --*/
CREATE TRIGGER TGLEX2
BEFORE INSERT OR DELETE OR UPDATE ON TT_LEX 
FOR EACH ROW EXECUTE PROCEDURE TGLEX2();



/*-- SEQ 4586 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLFIN() CASCADE;

/*-- SEQ 4587 --*/
CREATE OR REPLACE FUNCTION TGLFIN() RETURNS TRIGGER AS $$
DECLARE
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.FIN_ID IS NULL THEN
       NEW.FIN_ID:=to_number(trim(ProximoCodigo('TL_FIN',NULL)));
    END IF;
    IF NEW.DATINC IS NULL THEN
       NEW.DATINC := agora();
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4588 --*/
CREATE TRIGGER TGLFIN
BEFORE INSERT ON TL_FIN 
FOR EACH ROW EXECUTE PROCEDURE TGLFIN();


/*-- SEQ 4589 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLFRO() CASCADE;

/*-- SEQ 4590 --*/
CREATE OR REPLACE FUNCTION TGLFRO() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Popular Datope e no permitir alterao e excluso apenas incluso
-- Principal
BEGIN 
  IF (TG_OP = 'INSERT') THEN
       NEW.DATOPE := agora();
  END IF;

  IF (TG_OP = 'UPDATE') THEN   
       RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser alterado';    
  END IF;

  IF (TG_OP = 'DELETE') THEN 
       RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido';    
  END IF; 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4591 --*/
CREATE TRIGGER TGLFRO
BEFORE INSERT OR UPDATE OR DELETE ON TL_FRO 
FOR EACH ROW EXECUTE PROCEDURE TGLFRO();


/*-- SEQ 4592 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLGAB() CASCADE;

/*-- SEQ 4593 --*/
CREATE OR REPLACE FUNCTION TGLGAB() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impedir excluses.
-- 2. Impedir atualizaes.
-- 3. Gerar um cdigo sequencial exclusivo para compor a chave primria.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Impede excluso.
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20000 Registro de uso interno. No pode ser excludo. %' , COMPLEMENTO;
   END IF;

   -- Impedir atualizaes.
   IF (TG_OP = 'UPDATE') THEN
      RAISE EXCEPTION 'PG-20001 Registro de uso interno. No pode ser modificado. %' , COMPLEMENTO;
   END IF;

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.CODTAB IS NULL THEN
         NEW.CODTAB := ProximoCodigo('TL_GAB',NEW.FILGAB);
      END IF;
      NEW.DATOPE := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4594 --*/
CREATE TRIGGER TGLGAB
BEFORE INSERT OR UPDATE OR DELETE ON TL_GAB 
FOR EACH ROW EXECUTE PROCEDURE TGLGAB();


/*-- SEQ 4595 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION  TGLGRA() CASCADE;

/*-- SEQ 4596 --*/
CREATE OR REPLACE FUNCTION  TGLGRA() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Impedir alteracoes
-- 2) Obter o codigo do usuario logado e associa-lo ao TT_USU
-- 3) Fazer parte do papel de uma "foreign key"

  achou   INTEGER;
  Logon  TRetQuemLogou%ROWTYPE;
  vComplemento VARCHAR(100);
  wk_coduid tt_uid.coduid%type;


-- Principal
BEGIN
  vComplemento := Constante('Complemento');
  -- So permite inclusoes
  IF (TG_OP = 'UPDATE') THEN
    RAISE EXCEPTION 'PG-20036 Tabelas de "log" nao podem ter seus dados modificados ou excluidos. %' , vComplemento;
  END IF;

  IF (TG_OP = 'DELETE') THEN
    ACHOU := TGR_Grade_Existe(OLD.FILMAT, OLD.CODMAT, OLD.CODCOR, OLD.CODTAM); /* retornos possiveis 0 e 1 E -1 */
    IF (achou = 1) THEN
      RAISE EXCEPTION 'PG-20037 Nao e possivel excluir o log de uma grade existente. %' , vComplemento;
    END IF;
  END IF;

  IF (TG_OP = 'INSERT') THEN
    ACHOU := TGR_Grade_Existe(NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM); /* retornos possiveis 0 e 1 E -1 */
    IF (achou = 0) THEN
      RAISE EXCEPTION 'PG-20038 Grade nao foi encontrada. %' , vComplemento;
    END IF;

  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_GRA',NEW.FILUSU);
    END IF;
  END IF;

    -- Dados do usuario
    select * into Logon from DadosLogon();
    if (Logon.Encontrou) THEN
      NEW.FILUSU := Logon.FILUSU;
      NEW.CODUSU := Logon.CODUSU;
    ELSE
      RAISE EXCEPTION 'PG-20039 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
    END IF;

    -- "Default"
    NEW.DATOPE := agora();

    WK_CODUID := GetCoduidAtual();

    NEW.coduid := wk_coduid;

  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4597 --*/
CREATE TRIGGER TGLGRA
BEFORE INSERT OR DELETE OR UPDATE ON TL_GRA 
FOR EACH ROW EXECUTE PROCEDURE TGLGRA();


/*-- SEQ 4598 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLIB1() CASCADE;

/*-- SEQ 4599 --*/
CREATE OR REPLACE FUNCTION TGLIB1() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Impedir Exclusao
-- 2) Impedir alteracao da chave primaria
--
  vComplemento  VARCHAR(254):= constante('complemento');

-- Principal
BEGIN
  -- Impede exclusoes
  IF (TG_OP = 'DELETE') THEN
      INSERT INTO TL_REG (CODFIL,SEQUEN,MSGLOG)
                VALUES (OLD.CODFIL,OLD.SEQUEN,'Exclusao por repersonalizacao de numero de serie');    
  ELSIF (TG_OP = 'UPDATE') THEN
     IF (OLD.CODFIL <> NEW.CODFIL)
     OR (OLD.SEQUEN <> NEW.SEQUEN)
     OR (OLD.NUMITE <> NEW.NUMITE) THEN
       RAISE EXCEPTION 'PG-20027 Atualizacao invalida.%' , vComplemento;
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4600 --*/
CREATE TRIGGER TGLIB1
BEFORE DELETE OR UPDATE ON TT_LIB 
FOR EACH ROW EXECUTE PROCEDURE TGLIB1();

/*-- SEQ 4601 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLIB2() CASCADE;

/*-- SEQ 4602 --*/
CREATE OR REPLACE FUNCTION TGLIB2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Lancar no LOG TL_REG

  vLOG            VARCHAR(500) := '';
  Nulo CONSTANT  CHAR(1)       := '0';
  CRLF CONSTANT  CHAR(1)       := CHR(10);

-- Principal
BEGIN
  IF (TG_OP = 'INSERT') THEN
    vLOG := 'INCLUSAO';
    -- Inclui uma linha em TL_REG
    INSERT INTO TL_REG (CODFIL,SEQUEN,MSGLOG)
    VALUES (NEW.CODFIL,NEW.SEQUEN,vLOG);
  ELSIF (TG_OP = 'UPDATE') THEN
     IF Equal(OLD.CODLIB,NEW.CODLIB) <> 1 OR Equal(OLD.NUMLIB,NEW.NUMLIB) <> 1 THEN
       vLOG := vLOG||'Liberacao: de '||COALESCE(OLD.CODLIB,Nulo)||'-'||COALESCE(OLD.NUMLIB,Nulo)||' para '||COALESCE(NEW.CODLIB,Nulo)||'-'||COALESCE(NEW.NUMLIB,Nulo)||CRLF;
     END IF;

     IF Equal(OLD.FILUSU,NEW.FILUSU) <> 1 OR Equal(OLD.CODUSU,NEW.CODUSU) <> 1 THEN
       vLOG := vLOG||'Usuario: de '||COALESCE(OLD.FILUSU,Nulo)||'-'||COALESCE(OLD.CODUSU,Nulo)||' para '||COALESCE(NEW.FILUSU,Nulo)||'-'||COALESCE(NEW.CODUSU,Nulo)||CRLF;
     END IF;

     IF Equal(OLD.QTDMOD,NEW.QTDMOD) <> 1 THEN
       vLOG := vLOG||'Numero de copias: de '||COALESCE(OLD.QTDMOD,Nulo)||' para '||COALESCE(NEW.QTDMOD,Nulo)||CRLF;
     END IF;

     IF Equal(OLD.EXPMOD,NEW.EXPMOD) <> 1 THEN
       vLOG := vLOG||'Vencimento do modulo: de '||COALESCE(TO_CHAR(OLD.EXPMOD,'DD/MM/YYYY'),Nulo)||' para '||COALESCE(TO_CHAR(NEW.EXPMOD,'DD/MM/YYYY'),Nulo)||CRLF;
     END IF;

     IF Equal(OLD.HOMMOD,NEW.HOMMOD) <> 1 THEN
       vLOG := vLOG||'Autorizacao: de '||COALESCE(OLD.HOMMOD,Nulo)||' para '||COALESCE(NEW.HOMMOD,Nulo)||CRLF;
     END IF;

     IF (vLOG IS NOT NULL) THEN
       -- Inclui uma linha em TL_REG
       INSERT INTO TL_REG (CODFIL,SEQUEN,MSGLOG)
       VALUES (NEW.CODFIL,NEW.SEQUEN,vLOG);
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4603 --*/
CREATE TRIGGER TGLIB2
AFTER INSERT OR UPDATE ON TT_LIB 
FOR EACH ROW EXECUTE PROCEDURE TGLIB2();


/*-- SEQ 4604 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLID() CASCADE;

/*-- SEQ 4605 --*/
CREATE OR REPLACE FUNCTION TGLID() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Evitar lancamentos fora do periodo de validade
-- 2) Atualizar o campo COOORC da TT_ORC (83468)
   vComplemento                  VARCHAR(100);

   --LEO 84337
   vSESSIONID                    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

   -- RFMP 85136
      
   WK_UID                        TPC_UID_Retorno%ROWTYPE;
   
-- Principal
begin
   vComplemento := Constante('Complemento');

   -- Evitar lancamentos fora do periodo de validade
   IF not (TG_OP = 'DELETE') THEN
      IF not (Livre(NEW.CODFIL,'TT_LID',NEW.DATHOR) = 1) THEN
         RAISE EXCEPTION 'PG-20039 Lancamento fora do periodo de validade de uso do sistema. %' , vComplemento;
      END IF;
   END IF;

   IF (TG_OP = 'INSERT') THEN
      NEW.DATEXE:= AGORA();
   END IF;

   IF (TG_OP = 'INSERT') THEN
      IF NEW.INSTAL IS NULL THEN
         NEW.INSTAL:= 0;
      END IF;
   END IF;

   -- Gera um codigo automaticamente
   IF (TG_OP = 'INSERT') THEN
      IF NEW.C4G_ID IS NULL THEN
         NEW.C4G_ID:=ProximoCodigo('TT_LID',NEW.CODFIL);
      END IF;
   END IF;

   IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
      -- Gustavo em 08/10/2011 WF: 83468 - Colocar o numero do COO e ECF do relatorio gerencial impresso na TT_ORC
      IF NEW.NUMPED IS NOT NULL and NEW.TIPOPE = 'DOCECF' THEN
         UPDATE TT_ORC
            SET COOORC = NEW.CONCOO,
                NUMECF = NEW.NUMECF,
                ORCIMP = 'T'
          WHERE TT_ORC.CODFIL = NEW.FILPED
            AND TT_ORC.TIPPED = NEW.TIPPED
            AND TT_ORC.NUMPED = NEW.NUMPED;
      END IF;
      
      -- Garantir que DATFIS recebe apenas Data
      IF NEW.DATFIS IS NULL THEN
         NEW.DATFIS := TRUNC(NEW.DATHOR);
      ELSE
         NEW.DATFIS := TRUNC(NEW.DATFIS);
      END IF;
      
   END IF;

   -- Inicializa dados para assinatura

   -- RFMP 85136
   WK_UID := GetUidAtual();

   IF (TG_OP = 'INSERT') THEN
      IF WK_UID.BLQ_SEM_UID = 'T' AND WK_UID.CODUID IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;
      -- Douglas - 83441
      NEW.CODUID := WK_UID.CODUID;
      NEW.ASSINA := COALESCE(AssinaTabela('TT_LID',
                                        ConcatenaLID(NEW.CODFIL,
                                                     NEW.NUMECF,
                                                     NEW.TRN_ID,
                                                     NEW.CONCCF,
                                                     NEW.CONCOO,
                                                     NEW.CONGNF,
                                                     NEW.CONCDC,
                                                     NEW.TIPDOC,
                                                     NEW.DATHOR,
                                                     NEW.CONGRG,
                                                     NEW.DATFIS),
                                                   null, null, null),NEW.ASSINA);
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF ConcatenaLID(NEW.CODFIL,NEW.NUMECF,NEW.TRN_ID,
                    NEW.CONCCF,NEW.CONCOO,NEW.CONGNF,
                    NEW.CONCDC,NEW.TIPDOC,NEW.DATHOR,
                    NEW.CONGRG,NEW.DATFIS) <>
       ConcatenaLID(OLD.CODFIL,OLD.NUMECF,OLD.TRN_ID,
                    OLD.CONCCF,OLD.CONCOO,OLD.CONGNF,
                    OLD.CONCDC,OLD.TIPDOC,OLD.DATHOR,
                    OLD.CONGRG,OLD.DATFIS)
      THEN
         IF WK_UID.BLQ_SEM_UID = 'T' AND WK_UID.CODUID IS NULL THEN
           RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;

         -- Douglas - 83441
         NEW.CODUID := WK_UID.CODUID;
         NEW.ASSINA := COALESCE(AssinaTabela('TT_LID',
                                       ConcatenaLID(NEW.CODFIL,
                                                    NEW.NUMECF,
                                                    NEW.TRN_ID,
                                                    NEW.CONCCF,
                                                    NEW.CONCOO,
                                                    NEW.CONGNF,
                                                    NEW.CONCDC,
                                                    NEW.TIPDOC,
                                                    NEW.DATHOR,
                                                    NEW.CONGRG,
                                                    NEW.DATFIS),
                                                 OLD.CODUID,
                                       ConcatenaLID(OLD.CODFIL,
                                                    OLD.NUMECF,
                                                    OLD.TRN_ID,
                                                    OLD.CONCCF,
                                                    OLD.CONCOO,
                                                    OLD.CONGNF,
                                                    OLD.CONCDC,
                                                    OLD.TIPDOC,
                                                    OLD.DATHOR,
                                                    OLD.CONGRG,
                                                    OLD.DATFIS),
                                                OLD.ASSINA
                                               ),NEW.ASSINA);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4606 --*/
CREATE TRIGGER TGLID
BEFORE INSERT OR UPDATE OR DELETE ON TT_LID 
FOR EACH ROW EXECUTE PROCEDURE TGLID();

/*-- SEQ 4607 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLID_ASS() CASCADE;

/*-- SEQ 4608 --*/
CREATE OR REPLACE FUNCTION TGLID_ASS() RETURNS TRIGGER AS $$
-- 83073
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
DECLARE

   WK_DUMMY                      VARCHAR(2);

   -- RFMP 85136
      
   WK_UID                        TPC_UID_Retorno%ROWTYPE;
   
BEGIN

   IF ExisteFilialNaUF('SC') THEN 
      IF (TG_OP = 'INSERT') THEN
         -- RFMP 85136 Tratamento para no dar lock na TT_ASS
         WK_UID := GetUidAtual();
      
         IF WK_UID.ASSINS = 'T' THEN
            UPDATE TT_ASS
               SET QTDREG = QTDREG + 1
             WHERE NOMTAB = 'TT_LID';
         ELSE
            WK_DUMMY := Insere_MASS('TT_LID');
         END IF;      
      END IF;
      
      IF (TG_OP = 'DELETE') THEN
         UPDATE TT_ASS
            SET QTDREG = QTDREG - 1
          WHERE NOMTAB = 'TT_LID';
      END IF;
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4609 --*/
CREATE TRIGGER TGLID_ASS
AFTER INSERT OR DELETE ON TT_LID 
FOR EACH ROW EXECUTE PROCEDURE TGLID_ASS();

/*-- SEQ 4610 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLID2() CASCADE;

/*-- SEQ 4611 --*/
CREATE OR REPLACE FUNCTION TGLID2() RETURNS TRIGGER AS $$
DECLARE
   --LEO 84337
   vCODUID_ATUAL                 VARCHAR(22);
   vBLQ_SEM_UID                  TT_CFG.BLQ_SEM_UID%TYPE;
   vSESSIONID                    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

BEGIN

   IF (TG_OP = 'DELETE') THEN
      -- LEO 84337
      SELECT BLQ_SEM_UID
        INTO vBLQ_SEM_UID
        FROM TT_CFG;
      vCODUID_ATUAL := GetCoduidAtual();
      IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4612 --*/
CREATE TRIGGER TGLID2
BEFORE DELETE ON TT_LID 
FOR EACH ROW EXECUTE PROCEDURE TGLID2();


/*-- SEQ 4613 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLIM1() CASCADE;

/*-- SEQ 4614 --*/
CREATE OR REPLACE FUNCTION TGLIM1() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Recalcular conta corrente
   vDummy                        CHAR;
   cRet                          VARCHAR(2);
BEGIN
   -- Recalculo de conta corrente
   IF (TG_OP = 'UPDATE') THEN     
      -- Conta corrente
      IF (NEW.DUMMY IS NULL) THEN
         IF COALESCE(OLD.VSALDO,0) <> COALESCE(NEW.VSALDO,0) THEN
         
            -- CALCULO DO SALDO DA CC
            SELECT COALESCE(SUM(COALESCE(VLRLAN,0)),0) INTO NEW.VSALDO
              FROM TT_CCC
             WHERE FILCLI = NEW.FILCLI
               AND CODCLI = NEW.CODCLI
               AND TIPCCC = NEW.TIPCCC
               AND STATUS IN ('A', 'P', 'S')
               AND FILFAT IS NULL;
               
            IF COALESCE(NEW.VSALDO,0) >= 0 THEN
               vDummy := TGR_ZeraSaldoDoVeiculo(NEW.FILCLI,NEW.CODCLI,NEW.TIPCCC);
            END IF;
            
         END IF;
      END IF;
   END IF;
   
   IF (TG_OP = 'DELETE') THEN
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_LIM', OLD.FILCLI || OLD.CODCLI, TO_CHAR(OLD.TIPCCC));
   END IF;
   IF (TG_OP = 'INSERT') THEN
      --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_LIM', NEW.FILCLI || NEW.CODCLI, TO_CHAR(NEW.TIPCCC));
   END IF;
   IF NOT (TG_OP = 'DELETE') THEN
      NEW.ATU_EM := AGORA();
      NEW.VSALDO := COALESCE(NEW.VSALDO,0);
      NEW.DUMMY  := NULL;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4615 --*/
CREATE TRIGGER TGLIM1
BEFORE INSERT OR UPDATE OR DELETE ON TT_LIM 
FOR EACH ROW EXECUTE PROCEDURE TGLIM1();

/*-- SEQ 4616 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLIM2() CASCADE;

/*-- SEQ 4617 --*/
CREATE OR REPLACE FUNCTION TGLIM2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Impedir mudancas na chave primaria
-- 2) Registrar mudanca dos dados num "log"
-- 3) "Delete cascade" na tabela de "log"
-- 4) Atualiza ATU_EM da TT_CLI
   cLOG                          VARCHAR(4000)     := '';
   cLogChave                     VARCHAR(70)       := '';
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   cDESCCC                       TD_CCC.DESCCC%TYPE;
   vAspa                         CONSTANT CHAR(1)       := CHR(39);
   vComplemento                  CONSTANT VARCHAR(100) := Constante('complemento');
   cRetorno                      VARCHAR(2);
   cWhere                        TM_ATU.FILTRO%TYPE;
   
BEGIN
   --Tratamento para Atualizar Tabela Pai
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN      
      cWhere := 'FILCLI = ' || CHR(39) || NEW.FILCLI  || CHR(39) || ' AND CODCLI = ' || CHR(39) || NEW.CODCLI || CHR(39);
   ELSIF (TG_OP = 'DELETE') THEN      
      cWhere := 'FILCLI = ' || CHR(39) || OLD.FILCLI  || CHR(39) || ' AND CODCLI = ' || CHR(39) || OLD.CODCLI || CHR(39);
   END IF;
   cRetorno := INSERE_MATU('TT_LIM', 'TT_CLI', cWhere);

   -- Tratamento de LOG
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN
      SELECT DCCC.DESCCC INTO cDESCCC FROM TD_CCC DCCC WHERE DCCC.CODTAB = NEW.TIPCCC;
      cLogChave := 'Limite de C/C ' || cDESCCC || ' [' || TO_CHAR(NEW.TIPCCC) || ']';
   END IF;
   IF (TG_OP = 'INSERT') THEN
      cLOG := 'Incluso de ' || cLogChave;      
   ELSIF (TG_OP = 'UPDATE') THEN
      -- Impede mudancas na chave primaria
      IF (NEW.FILCLI <> OLD.FILCLI) OR
         (NEW.CODCLI <> OLD.CODCLI) OR
         (NEW.TIPCCC <> OLD.TIPCCC) THEN
         RAISE EXCEPTION 'PG-20040 Alguns dados de limite nao podem ser modificados. %' , vComplemento;
      END IF;

      -- Atencao: Nao deve ter cLOG de saldo (VSALDO). O proprio lancamento ja e o LOG

      IF Equal(OLD.LIMCCC,NEW.LIMCCC) <> 1 THEN
         cLOG := cLOG||'Limite: de '||TO_CHAR(COALESCE(OLD.LIMCCC,iNulo),'fm9G999G999G990D00')||' para '||TO_CHAR(COALESCE(NEW.LIMCCC,iNulo),'fm9G999G999G990D00')||CRLF;
      END IF;
      IF (Equal(OLD.FILCOB,NEW.FILCOB)) <> 1 OR (Equal(OLD.ENDCOB,NEW.ENDCOB) <> 1) THEN
         cLOG := cLOG||'Endereco: de '||COALESCE(OLD.FILCLI,cNulo)||'/'||COALESCE(OLD.CODCLI,cNulo)||'/'||COALESCE(OLD.FILCOB,cNulo)||'/'||COALESCE(TO_CHAR(OLD.ENDCOB),cNulo)||
                       ' para '||COALESCE(NEW.FILCLI,cNulo)||'/'||COALESCE(NEW.CODCLI,cNulo)||'/'||COALESCE(NEW.FILCOB,cNulo)||'/'||COALESCE(TO_CHAR(NEW.ENDCOB),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.OBSERV,NEW.OBSERV) <> 1 THEN
         cLOG := cLOG||'Observacao: de "'||COALESCE(OLD.OBSERV,cNulo)||'" para "'||COALESCE(NEW.OBSERV,cNulo)||'"'||CRLF;
      END IF;
      IF (Equal(OLD.FILPGT,NEW.FILPGT)) <> 1 OR (Equal(OLD.CODPGT,NEW.CODPGT) <> 1) THEN
         cLOG := cLOG||'Plano Padrao: de '||COALESCE(OLD.FILPGT,cNulo)||'/'||COALESCE(OLD.CODPGT,cNulo)||
                       ' para '||COALESCE(NEW.FILPGT,cNulo)||'/'||COALESCE(NEW.CODPGT,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCOB,NEW.CODCOB) <> 1 THEN
         cLOG := cLOG||'Codigo Cobranca: de '||TO_CHAR(COALESCE(OLD.CODCOB,iNulo),'fm9G999G999G990D00')||' para '||TO_CHAR(COALESCE(NEW.CODCOB,iNulo),'fm9G999G999G990D00')||CRLF;
      END IF;
      IF Equal(OLD.CARENC,NEW.CARENC) <> 1 THEN
         cLOG := cLOG||'Carencia: de '||TO_CHAR(COALESCE(OLD.CARENC,iNulo),'fm9G999G999G990')||' para '||TO_CHAR(COALESCE(NEW.CARENC,iNulo),'fm9G999G999G990')||CRLF;
      END IF;
      IF Equal(OLD.DESCON,NEW.DESCON) <> 1 THEN
         cLOG := cLOG||'Desconto: de '||TO_CHAR(COALESCE(OLD.DESCON,iNulo),'fm9G999G999G990D00')||' para '||TO_CHAR(COALESCE(NEW.DESCON,iNulo),'fm9G999G999G990D00')||CRLF;
      END IF;
      IF Equal(OLD.DIAFIX,NEW.DIAFIX) <> 1 THEN
         cLOG := cLOG||'Dia Fixo do Vencimento: de '||TO_CHAR(COALESCE(OLD.DIAFIX,iNulo),'fm9G999G999G990')||' para '||TO_CHAR(COALESCE(NEW.DIAFIX,iNulo),'fm9G999G999G990')||CRLF;
      END IF;
      IF ISNOTNULL(cLOG) = 'T' THEN
         cLOG := cLogChave || ' >> ' || cLOG;
      END IF;
   END IF;
   IF (TG_OP = 'INSERT') 
   OR (TG_OP = 'UPDATE') THEN
      IF ISNOTNULL(cLOG) = 'T' THEN
         INSERT INTO TL_CLI (FILCLI,CODCLI,DATOPE,MSGLOG)
                     VALUES (NEW.FILCLI,NEW.CODCLI,agora(),cLOG);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4618 --*/
CREATE TRIGGER TGLIM2
AFTER INSERT OR DELETE OR UPDATE ON TT_LIM 
FOR EACH ROW EXECUTE PROCEDURE TGLIM2();


/*-- SEQ 4619 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLIMXFIL() CASCADE;

/*-- SEQ 4620 --*/
CREATE OR REPLACE FUNCTION TGLIMXFIL() RETURNS TRIGGER AS $$
DECLARE

-- Objetivo:
-- Tarefa  71868 --
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria.
-- 2) Popular as colunas DATINC e ATU_EM.

BEGIN
  IF (TG_OP = 'INSERT') THEN
     IF NEW.SEQUEN IS NULL THEN
        NEW.SEQUEN := ProximoCodigo('TT_LIMXFIL', NEW.CODFIL);
     END IF;
     NEW.DATINC := Agora();
  END IF;
  NEW.ATU_EM := Agora();

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4621 --*/
CREATE TRIGGER TGLIMXFIL
BEFORE INSERT OR UPDATE ON TT_LIMXFIL 
FOR EACH ROW EXECUTE PROCEDURE TGLIMXFIL();


/*-- SEQ 4622 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLINV() CASCADE;

/*-- SEQ 4623 --*/
CREATE OR REPLACE FUNCTION TGLINV() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Popular Datope, Codtab e no permitir alterao e excluso apenas incluso 
-- Principal
BEGIN  

  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_INV',NEW.FILINV);
    END IF;
    IF NEW.DATOPE IS NULL THEN
	   NEW.DATOPE := agora();
    END IF;
  END IF;
  
  IF (TG_OP = 'UPDATE') THEN    
       RAISE EXCEPTION 'PG-20006 Registro de uso interno. No pode ser alterado';     
  END IF;

  IF (TG_OP = 'DELETE') THEN  
     RAISE EXCEPTION 'PG-20006 Registro de uso interno. No pode ser excludo';     
  END IF;  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4624 --*/
CREATE TRIGGER TGLINV
BEFORE INSERT OR UPDATE OR DELETE ON TL_INV 
FOR EACH ROW EXECUTE PROCEDURE TGLINV();


/*-- SEQ 4625 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLIORPAF() CASCADE;

/*-- SEQ 4626 --*/
CREATE OR REPLACE FUNCTION TGLIORPAF() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Impede alterao/excluso
-- 2) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 3) Atualiza DATOPE
-- 4) Assinar Registro

   vBLQ_SEM_UID  TT_CFG.BLQ_SEM_UID%TYPE;
   vCODUID_ATUAL TL_IOR_PAF.CODUID%TYPE;
   vSESSIONID    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');
   
-- Principal
BEGIN

   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20001 Registro no pode ser excludo.';
   END IF;

   IF (TG_OP = 'UPDATE') THEN   
      RAISE EXCEPTION 'PG-20001 Registro no pode ser alterado.';
      
      IF ConcatenaLIOR(NEW.CODFIL,NEW.TIPPED,NEW.NUMPED,NEW.NUMITE,
                     NEW.TIPLOG,NEW.INDCAN,NEW.QTDITE,NEW.VLRITE,
                     NEW.DESCON,NEW.VLRPGT,NEW.DATOPE) <>
         ConcatenaLIOR(OLD.CODFIL,OLD.TIPPED,OLD.NUMPED,OLD.NUMITE,
                     OLD.TIPLOG,OLD.INDCAN,OLD.QTDITE,OLD.VLRITE,
                     OLD.DESCON,OLD.VLRPGT,OLD.DATOPE) THEN

         SELECT BLQ_SEM_UID
           INTO vBLQ_SEM_UID
           FROM TT_CFG;
         vCODUID_ATUAL := GetCoduidAtual();
         IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;

         NEW.CODUID := GetCoduidAtual();
         NEW.ASSINA := COALESCE(AssinaTabela('TL_IOR_PAF',
                                              ConcatenaLIOR(NEW.CODFIL,
                                                         NEW.TIPPED,
                                                         NEW.NUMPED,
                                                         NEW.NUMITE,
                                                         NEW.TIPLOG,
                                                         NEW.INDCAN,
                                                         NEW.QTDITE,
                                                         NEW.VLRITE,
                                                         NEW.DESCON,
                                                         NEW.VLRPGT,
                                                         NEW.DATOPE),
                                              OLD.CODUID,
                                              ConcatenaLIOR(OLD.CODFIL,
                                                         OLD.TIPPED,
                                                         OLD.NUMPED,
                                                         OLD.NUMITE,
                                                         OLD.TIPLOG,
                                                         OLD.INDCAN,
                                                         OLD.QTDITE,
                                                         OLD.VLRITE,
                                                         OLD.DESCON,
                                                         OLD.VLRPGT,
                                                         OLD.DATOPE),
                                              OLD.ASSINA
                                              ),
                                 NEW.ASSINA);
      END IF;
   END IF;

   IF (TG_OP = 'INSERT') THEN
      IF NEW.CODTAB IS NULL THEN
         NEW.CODTAB := ProximoCodigo('TL_IOR_PAF',NEW.CODFIL);
      END IF;
      NEW.DATOPE := AGORA();

      SELECT BLQ_SEM_UID
        INTO vBLQ_SEM_UID
        FROM TT_CFG;
      vCODUID_ATUAL := GetCoduidAtual();
      IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;

      NEW.CODUID := GetCoduidAtual();
      NEW.ASSINA := COALESCE(AssinaTabela('TL_IOR_PAF',
                                            ConcatenaLIOR(NEW.CODFIL,
                                                         NEW.TIPPED,
                                                         NEW.NUMPED,
                                                         NEW.NUMITE,
                                                         NEW.TIPLOG,
                                                         NEW.INDCAN,
                                                         NEW.QTDITE,
                                                         NEW.VLRITE,
                                                         NEW.DESCON,
                                                         NEW.VLRPGT,
                                                         NEW.DATOPE),
                                                       null, null, null),NEW.ASSINA);
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4627 --*/
CREATE TRIGGER TGLIORPAF
BEFORE INSERT OR UPDATE OR DELETE ON TL_IOR_PAF 
FOR EACH ROW EXECUTE PROCEDURE TGLIORPAF();

/*-- SEQ 4628 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLIORPAF_ASS() CASCADE;

/*-- SEQ 4629 --*/
CREATE OR REPLACE FUNCTION TGLIORPAF_ASS() RETURNS TRIGGER AS $$
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN

  IF ExisteFilialNaUF('SC') THEN
     IF (TG_OP = 'INSERT') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG + 1
        WHERE NOMTAB = 'TL_IOR_PAF';
     END IF;
     
     IF (TG_OP = 'DELETE') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG - 1
        WHERE NOMTAB = 'TL_IOR_PAF';
     END IF;
  END IF;  

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4630 --*/
CREATE TRIGGER TGLIORPAF_ASS
AFTER INSERT OR DELETE ON TL_IOR_PAF 
FOR EACH ROW EXECUTE PROCEDURE TGLIORPAF_ASS();


/*-- SEQ 4631 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLIRO() CASCADE;

/*-- SEQ 4632 --*/
CREATE OR REPLACE FUNCTION TGLIRO() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir alteracoes
-- 2) Obter o codigo do usuario logado e associa-lo ao TT_USU
-- 3) Fazer parte do papel de uma "foreign key"
DECLARE
  achou        INTEGER;
  vComplemento VARCHAR(100);
  Logon        TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;

-- Principal
BEGIN
  vComplemento := Constante('Complemento');

  -- So permite inclusoes
  IF (TG_OP = 'UPDATE') THEN
    RAISE EXCEPTION 'PG-20036 Tabelas de "log" nao podem ter seus dados modificados ou excluidos. %' , vComplemento;
  END IF;

  IF (TG_OP = 'DELETE') THEN
    Achou := TGR_ItemRomaneio_Existe(OLD.codfil,OLD.sequen,OLD.filven,OLD.seqven,OLD.seqcan); /* retornos possiveis 0 e 1 e -1*/
    IF (achou = 1) THEN
       RAISE EXCEPTION 'PG-20039 Nao e possivel excluir o log de um item de romaneio existente. %' , vComplemento;
    END IF;
  END IF;

  IF (TG_OP = 'INSERT') THEN
    Achou := TGR_ItemRomaneio_Existe(NEW.codfil,NEW.sequen,NEW.filven,NEW.seqven,NEW.seqcan); /* retornos possiveis 0 e 1 e -1*/
    IF (achou = 0) THEN
      RAISE EXCEPTION 'PG-20038 Item de romaneio nao foi encontrado. %' , vComplemento;      
    END IF;

  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_IRO',NEW.CODFIL);
    END IF;
  END IF;

    -- Dados do usuario
    select * into Logon from DadosLogon();

    IF Logon.Encontrou THEN
      NEW.FILUSU := Logon.FILUSU;
      NEW.CODUSU := Logon.CODUSU;
    ELSE
      RAISE EXCEPTION 'PG-20037 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
    END IF;

    -- "Default"
    NEW.DATOPE := agora();

    WK_CODUID := GetCoduidAtual();

    NEW.coduid := wk_coduid;

  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4633 --*/
CREATE TRIGGER TGLIRO
BEFORE INSERT OR DELETE OR UPDATE ON TL_IRO 
FOR EACH ROW EXECUTE PROCEDURE TGLIRO();


/*-- SEQ 4634 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLIS() CASCADE;

/*-- SEQ 4635 --*/
CREATE OR REPLACE FUNCTION TGLIS() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Atualiza DATINC
-- 3) Atualiza ATU_EM

-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN:=ProximoCodigo('TT_LIS',NEW.CODFIL);
    END IF;
  END IF;

  -- Trata dados padroes na inclusao  
  IF (TG_OP = 'INSERT') THEN
   NEW.DATINC := AGORA();
  END IF;

  -- Popula a coluna ATU_EM
  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     NEW.ATU_EM := AGORA();  
  END IF; 
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4636 --*/
CREATE TRIGGER TGLIS
BEFORE INSERT OR UPDATE ON TT_LIS 
FOR EACH ROW EXECUTE PROCEDURE TGLIS();


/*-- SEQ 4637 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGIVEXCSG2() CASCADE;

/*-- SEQ 4638 --*/
CREATE OR REPLACE FUNCTION TGIVEXCSG2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 2) Registrar mudanca dos dados num "log"
   vLOG    VARCHAR(4000)     := '';
   vFILUSU VARCHAR(3);    
   vCODUSU VARCHAR(3); 
   cOld CHAR(50);
   cNew CHAR(50);
   cNulo   CONSTANT CHAR(1)   := '0';
   CRLF    CONSTANT CHAR(1)   := CHR(10);  
    
    QuemLogou TRetQuemLogou%ROWTYPE;
    WK_CODUID TT_UID.CODUID%TYPE;
BEGIN
  WK_CODUID := GetCoduidAtual();

  select * into QuemLogou from DadosLogon();
  vFILUSU := QuemLogou.FILUSU;
  vCODUSU := QuemLogou.CODUSU;
 
  -- Tratamento de "log"
  IF (TG_OP = 'DELETE') THEN
     DELETE FROM TL_VEN WHERE FILVEN = OLD.CODFIL AND SEQVEN = OLD.SEQUEN;
  END IF;

  -- Tratamento de log
  IF (TG_OP = 'UPDATE') THEN 

    IF Equal(OLD.ITEREM,NEW.ITEREM) <> 1 THEN
      vLOG := vLOG||'Consignao: Item da Remessa  de '||COALESCE(OLD.ITEREM,0)||' para '||COALESCE(NEW.ITEREM,0)||CRLF;
    END IF;

    IF Equal(OLD.ITEFAT,NEW.ITEFAT) <> 1 THEN
      vLOG := vLOG||'Consignao: Item da Fatura de '||COALESCE(OLD.ITEFAT,0)||' para '||COALESCE(NEW.ITEFAT,0)||CRLF;
    END IF;
  
    IF Equal(OLD.QTDDEV,NEW.QTDDEV) <> 1 THEN
      vLOG := vLOG||'Consignao: Quantidade Devolvida de '||COALESCE(TO_CHAR(OLD.QTDDEV,'fm9G999G999G990D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.QTDDEV,'fm9G999G999G990D0000'),cNulo)||CRLF;
    END IF;
  
    IF Equal(OLD.DATINC,NEW.DATINC) <> 1 THEN
       vLOG := vLOG||'Consignao: Data de Incluso de '||COALESCE(to_char(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
    END IF;
  
    IF Equal(OLD.NF_DEV,NEW.NF_DEV) <> 1 THEN
      select CASE OLD.NF_DEV WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                                                  ELSE cNulo
      END into cOld from dual;
      select CASE NEW.NF_DEV WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                                                  ELSE cNulo
      END into cNew from dual;
      vLOG := vLOG||'Consignao: Devoluo j Emitida? de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
    END IF;  
  
     IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
        vLOG := vLOG||'Consignao: Filial de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
     END IF;
	 
     IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
        vLOG := vLOG||'Consignao: Sequncia de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
	 END IF;
	 
	 IF Equal(OLD.FILREM,NEW.FILREM) <> 1 THEN
        vLOG := vLOG||'Consignao: Filial da Remessa de '||COALESCE(OLD.FILREM,cNulo)||' para '||COALESCE(NEW.FILREM,cNulo)||CRLF;
	 END IF;
	 
	 IF Equal(OLD.SEQREM,NEW.SEQREM) <> 1 THEN
        vLOG := vLOG||'Consignao: Seq. da Remessa de '||COALESCE(OLD.SEQREM,cNulo)||' para '||COALESCE(NEW.SEQREM,cNulo)||CRLF;
	 END IF;
	 
	 IF Equal(OLD.FILFAT,NEW.FILFAT) <> 1 THEN
        vLOG := vLOG||'Consignao: Filial da Fatura de '||COALESCE(OLD.FILFAT,cNulo)||' para '||COALESCE(NEW.FILFAT,cNulo)||CRLF;
	 END IF;
	 
	 IF Equal(OLD.SEQFAT,NEW.SEQFAT) <> 1 THEN
        vLOG := vLOG||'Consignao: Filial da Fatura de '||COALESCE(OLD.SEQFAT,cNulo)||' para '||COALESCE(NEW.SEQFAT,cNulo)||CRLF;
	 END IF;
	 
	 IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
        vLOG := vLOG||'Consignao: Situao da consignao de '||COALESCE(OLD.FLGEST,cNulo)||' para '||COALESCE(NEW.FLGEST,cNulo)||CRLF;
	 END IF;
	 	
     IF ISNOTNULL(trim(vLOG)) = 'T' THEN
        -- cadastra o LOG.
        INSERT INTO TL_VEN (FILVEN,SEQVEN,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                 VALUES (NEW.CODFIL,NEW.SEQUEN,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);
     END IF;   
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4639 --*/
CREATE TRIGGER TGIVEXCSG2
AFTER INSERT OR UPDATE OR DELETE ON TT_IVEXCSG 
FOR EACH ROW EXECUTE PROCEDURE TGIVEXCSG2(); 
  


/*-- SEQ 4640 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLIVO() CASCADE;

/*-- SEQ 4641 --*/
CREATE OR REPLACE FUNCTION TGLIVO() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_IVO',NEW.FILIVO);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4642 --*/
CREATE TRIGGER TGLIVO
BEFORE INSERT ON TL_IVO 
FOR EACH ROW EXECUTE PROCEDURE TGLIVO();


/*-- SEQ 4643 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLLAC() CASCADE;

/*-- SEQ 4644 --*/
CREATE OR REPLACE FUNCTION TGLLAC() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Popular Datope e no permitir alterao e excluso apenas incluso
-- Principal
BEGIN  
  IF (TG_OP = 'INSERT') THEN
       NEW.DATOPE := agora();
  END IF;    

  IF (TG_OP = 'UPDATE') THEN    
       RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser alterado';     
  END IF;

  IF (TG_OP = 'DELETE') THEN  
     RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido';     
  END IF;  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4645 --*/
CREATE TRIGGER TGLLAC
BEFORE INSERT OR UPDATE OR DELETE ON TL_LAC 
FOR EACH ROW EXECUTE PROCEDURE TGLLAC();


/*-- SEQ 4646 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLLAYXLGPD() CASCADE;

/*-- SEQ 4647 --*/
CREATE OR REPLACE FUNCTION TGLLAYXLGPD() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Controle de sequenciador ao incluir novo log

-- Principal
BEGIN
   
   -- Gera codigo sequencial exclusivo
   IF (TG_OP = 'INSERT') THEN
      NEW.ID_LLAYXLGPD := ProximoCodigo('TL_LAYXLGPD', NULL);
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4648 --*/
CREATE TRIGGER TGLLAYXLGPD
BEFORE INSERT OR UPDATE ON TL_LAYXLGPD 
FOR EACH ROW EXECUTE PROCEDURE TGLLAYXLGPD();


/*-- SEQ 4649 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLLCF() CASCADE;

/*-- SEQ 4650 --*/
CREATE OR REPLACE FUNCTION TGLLCF() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir exclusoes
-- 2) Impedir alteracoes
-- 
DECLARE
  vComplemento VARCHAR(100);
  Logon  TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;

BEGIN
  vComplemento := Constante('Complemento');
  -- So permite inclusoes
  IF ((TG_OP = 'DELETE')) OR ((TG_OP = 'UPDATE')) THEN
    RAISE EXCEPTION 'PG-20001 Tabelas de "log" nao podem ter seus dados modificados ou excluidos. %' , vComplemento;
  END IF;

  -- Dados do usuario
  select * into Logon from DadosLogon();
  IF Logon.Encontrou THEN
    NEW.FILUSU := Logon.FILUSU;
    NEW.CODUSU := Logon.CODUSU;
  ELSE
    RAISE EXCEPTION 'PG-20002 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
  END IF;

  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_LCF',NEW.CODFIL);
    END IF;
  END IF;

  -- "Default"
  NEW.DATOPE := agora();

  WK_CODUID := GetCoduidAtual();

  NEW.coduid := wk_coduid;


 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4651 --*/
CREATE TRIGGER TGLLCF
BEFORE INSERT OR DELETE OR UPDATE ON TL_LCF 
FOR EACH ROW EXECUTE PROCEDURE TGLLCF();


/*-- SEQ 4652 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLLOT() CASCADE;

/*-- SEQ 4653 --*/
CREATE OR REPLACE FUNCTION TGLLOT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Atualiza DATOPE

  WK_CODUID TT_UID.CODUID%TYPE;
  Logon  TRetQuemLogou%ROWTYPE;
  vComplemento VARCHAR(100);
-- Principal
BEGIN

  IF (TG_OP = 'DELETE') OR (TG_OP = 'UPDATE') THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido ou modificado';
  END IF;

   IF (TG_OP = 'INSERT') THEN
      IF NEW.CODTAB IS NULL THEN
         NEW.CODTAB := ProximoCodigo('TL_LOT',NEW.FILUSU);
      END IF;

      -- Dados do usuario
      select * into Logon from DadosLogon();
      if (Logon.Encontrou) THEN
        NEW.FILUSU := Logon.FILUSU;
        NEW.CODUSU := Logon.CODUSU;
      ELSE
        RAISE EXCEPTION 'PG-20039 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
      END IF;

      NEW.DATOPE := AGORA();

      WK_CODUID := GetCoduidAtual();

      NEW.CODUID := WK_CODUID;

   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4654 --*/
CREATE TRIGGER TGLLOT
BEFORE INSERT OR UPDATE OR DELETE ON TL_LOT 
FOR EACH ROW EXECUTE PROCEDURE TGLLOT();


/*-- SEQ 4655 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLMC() CASCADE;

/*-- SEQ 4656 --*/
CREATE OR REPLACE FUNCTION TGLMC() RETURNS TRIGGER AS $$
DECLARE
  QuemLogou TRetQuemLogou%ROWTYPE;
-- Principal
BEGIN
    -- preenche dados do usurio de registro
  IF (TG_OP = 'INSERT') THEN

    -- Gera um codigo automaticamente
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN:=ProximoCodigo('TT_LMC',NEW.CODFIL);
    END IF;

    select * into QuemLogou from DadosLogon();
    IF ((NEW.FILREG IS NULL) AND (NEW.CODREG IS NULL)) THEN
      NEW.FILREG := QuemLogou.FILUSU;
      NEW.CODREG := QuemLogou.CODUSU;
    END IF;
  END IF;

  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
    NEW.ATU_EM := agora(); 

    IF (NEW.DATINI IS NULL) THEN
      NEW.DATINI := TRUNC(agora());
    ELSE
      NEW.DATINI := TRUNC(NEW.DATINI);
    END IF;
  END IF;


 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4657 --*/
CREATE TRIGGER TGLMC
BEFORE INSERT OR UPDATE OR DELETE ON TT_LMC 
FOR EACH ROW EXECUTE PROCEDURE TGLMC();


/*-- SEQ 4658 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLMON() CASCADE;

/*-- SEQ 4659 --*/
CREATE OR REPLACE FUNCTION TGLMON() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir alteracoes
-- 2) Obter o codigo do usuario logado e associa-lo ao TT_USU
-- 3) Fazer parte do papel de uma "foreign key"
DECLARE
  achou        INTEGER;
  vComplemento VARCHAR(100);
  Logon         TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;

-- Principal
BEGIN
  vComplemento := Constante('Complemento');

  -- So permite inclusoes
  IF (TG_OP = 'UPDATE') THEN
    RAISE EXCEPTION 'PG-20036 Tabelas de "log" nao podem ter seus dados modificados ou excluidos. %' , vComplemento;
  END IF;

  IF (TG_OP = 'DELETE') THEN
    Achou := TGR_Montagem_Existe(OLD.codfil,OLD.sequen); /* retornos possiveis 0 e 1 e -1*/
    IF (achou = 1) THEN
       RAISE EXCEPTION 'PG-20039 Nao e possivel excluir o log de uma montagem existente. %' , vComplemento;
    END IF;
  END IF;

  IF (TG_OP = 'INSERT') THEN
    Achou := TGR_Montagem_Existe(NEW.codfil,NEW.sequen); /* retornos possiveis 0 e 1 e -1*/
    IF (achou = 0) THEN
      RAISE EXCEPTION 'PG-20038 Montagem nao foi encontrada. %' , vComplemento;      
    END IF;

  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_MON',NEW.CODFIL);
    END IF;
  END IF;

    -- Dados do usuario
    select * into Logon from DadosLogon();

    IF Logon.Encontrou THEN
      NEW.FILUSU := Logon.FILUSU;
      NEW.CODUSU := Logon.CODUSU;
    ELSE
      RAISE EXCEPTION 'PG-20037 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
    END IF;

    -- "Default"
    NEW.DATOPE := agora();

    WK_CODUID := GetCoduidAtual();

    NEW.coduid := wk_coduid;

  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4660 --*/
CREATE TRIGGER TGLMON
BEFORE INSERT OR DELETE OR UPDATE ON TL_MON 
FOR EACH ROW EXECUTE PROCEDURE TGLMON();


/*-- SEQ 4661 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLMPR() CASCADE;

/*-- SEQ 4662 --*/
CREATE OR REPLACE FUNCTION TGLMPR() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Popular Datope, Codtab e no permitir alterao e excluso apenas incluso
-- Principal
BEGIN  

  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_MPR',NEW.FILMPR);
	   NEW.DATOPE := agora();
    END IF;
  END IF;
  
  IF (TG_OP = 'UPDATE') THEN    
       RAISE EXCEPTION 'PG-20006 Registro de uso interno. No pode ser alterado';     
  END IF;

  IF (TG_OP = 'DELETE') THEN  
     RAISE EXCEPTION 'PG-20006 Registro de uso interno. No pode ser excludo';     
  END IF;  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4663 --*/
CREATE TRIGGER TGLMPR
BEFORE INSERT OR UPDATE OR DELETE ON TL_MPR 
FOR EACH ROW EXECUTE PROCEDURE TGLMPR();


/*-- SEQ 4664 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLOBS() CASCADE;

/*-- SEQ 4665 --*/
CREATE OR REPLACE FUNCTION TGLOBS() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Popular Datope e no permitir alterao e excluso apenas incluso
-- Principal
BEGIN 
  IF (TG_OP = 'INSERT') THEN
       NEW.DATOPE := agora();
  END IF;

  IF (TG_OP = 'UPDATE') THEN   
       RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser alterado';    
  END IF;

  IF (TG_OP = 'DELETE') THEN 
       RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido';    
  END IF; 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4666 --*/
CREATE TRIGGER TGLOBS
BEFORE INSERT OR UPDATE OR DELETE ON TL_OBS 
FOR EACH ROW EXECUTE PROCEDURE TGLOBS();


/*-- SEQ 4667 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLOG() CASCADE;

/*-- SEQ 4668 --*/
CREATE OR REPLACE FUNCTION TGLOG() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TT_LOG','001');
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4669 --*/
CREATE TRIGGER TGLOG
BEFORE INSERT ON TT_LOG 
FOR EACH ROW EXECUTE PROCEDURE TGLOG();


/*-- SEQ 4670 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLOI() CASCADE;

/*-- SEQ 4671 --*/
CREATE OR REPLACE FUNCTION TGLOI() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Gerar um cdigo sequencial exclusivo para compor a chave primria.
-- 2. Atualiza controles de data.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN
   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF ISNULL(TRIM(NEW.SEQUEN))='T' THEN
         NEW.SEQUEN := ProximoCodigo('TT_LOI',NEW.CODFIL);
      END IF;
      NEW.DATINC := Agora();
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4672 --*/
CREATE TRIGGER TGLOI
BEFORE INSERT OR UPDATE OR DELETE ON TT_LOI 
FOR EACH ROW EXECUTE PROCEDURE TGLOI();


/*-- SEQ 4673 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLORC() CASCADE;

/*-- SEQ 4674 --*/
CREATE OR REPLACE FUNCTION TGLORC() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir alteracoes
-- 2) Obter o codigo do usuario logado e associa-lo ao TT_USU
-- 3) Fazer parte do papel de uma "foreign key"
DECLARE
  achou        INTEGER;
  vComplemento VARCHAR(100);
  Logon        TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;

-- Principal
BEGIN
  vComplemento := Constante('Complemento');

  -- So permite inclusoes
  IF (TG_OP = 'UPDATE') THEN
    RAISE EXCEPTION 'PG-20036 Tabelas de "log" nao podem ter seus dados modificados ou excluidos. %' , vComplemento;
  END IF;

  IF (TG_OP = 'DELETE') THEN
    Achou := TGR_Orcamento_Existe(OLD.codfil,OLD.tipped,OLD.numped); /* retornos possiveis 0 e 1 e -1*/
    IF (achou = 1) THEN
       RAISE EXCEPTION 'PG-20039 Nao e possivel excluir o log de um orcamento existente. %' , vComplemento;
    END IF;
  END IF;

  IF (TG_OP = 'INSERT') THEN
    Achou := TGR_Orcamento_Existe(NEW.codfil,NEW.tipped,NEW.numped); /* retornos possiveis 0 e 1 e -1*/
    IF (achou = 0) THEN
      RAISE EXCEPTION 'PG-20038 Orcamento nao foi encontrado. %' , vComplemento;      
    END IF;

  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_ORC',NEW.CODFIL);
    END IF;
  END IF;

    -- Dados do usuario
    select * into Logon from DadosLogon();

    IF Logon.Encontrou THEN
      NEW.FILUSU := Logon.FILUSU;
      NEW.CODUSU := Logon.CODUSU;
    ELSE
      RAISE EXCEPTION 'PG-20037 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
    END IF;

    -- "Default"
    NEW.DATOPE := agora();

    WK_CODUID := GetCoduidAtual();

    NEW.coduid := wk_coduid;


  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4675 --*/
CREATE TRIGGER TGLORC
BEFORE INSERT OR DELETE OR UPDATE ON TL_ORC 
FOR EACH ROW EXECUTE PROCEDURE TGLORC();


/*-- SEQ 4676 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLOT() CASCADE;

/*-- SEQ 4677 --*/
CREATE OR REPLACE FUNCTION TGLOT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Atualiza DATINC
-- 3) Atualiza ATU_EM
-- 4) Atualiza QTDEST

-- Principal
BEGIN

   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN := ProximoCodigo('TT_LOT',NEW.CODFIL);
      END IF;
      NEW.DATINC := AGORA();

      IF NEW.QTDEST IS NULL THEN
         NEW.QTDEST := 0;
      END IF;
   END IF;

   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := AGORA();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4678 --*/
CREATE TRIGGER TGLOT
BEFORE INSERT OR UPDATE ON TT_LOT 
FOR EACH ROW EXECUTE PROCEDURE TGLOT();

/*-- SEQ 4679 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLOT2() CASCADE;

/*-- SEQ 4680 --*/
CREATE OR REPLACE FUNCTION TGLOT2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Registrar mudana dos dados num "vlog"^~
-- 2) Registar o saldo do lote na TT_SLT quando informado Quantidade Inicial
--
DECLARE
  VLOG VARCHAR(500)     := '';
  iNulo CONSTANT Numeric(1) := 0;
  cNulo CONSTANT CHAR(4) := 'Nulo';
  CRLF CONSTANT CHAR(1)  := CHR(10);
  wk_Old_Refpro TT_GRA.REFPRO%TYPE;
  wk_New_Refpro TT_GRA.REFPRO%TYPE;

BEGIN

  IF (TG_OP = 'INSERT') THEN

     -- RFMP 96855 - Tratamento retirado
     -- Pedro E. Braga - 93232 - Controle para Incluso na TT_SLT quando QTDINI > 0
     --IF (NEW.QTDINI > 0) THEN
     --    /* Insere saldo de lote */
     --    INSERT INTO TT_SLT
     --        (CODFIL,CODMUL,FILLOT,SEQLOT,QTDEST)
     --    VALUES
     --        (NEW.CODFIL,0,NEW.CODFIL,NEW.SEQUEN,0);
     --END IF;

     VLOG := 'Inclusao';
     INSERT INTO TL_LOT (FILLOT, SEQLOT, MSGLOG)
          VALUES (NEW.CODFIL, NEW.SEQUEN, vLOG);

  ELSIF (TG_OP = 'UPDATE') THEN
     IF Equal(OLD.FILMAT,NEW.FILMAT) <> 1
     OR Equal(OLD.CODMAT,NEW.CODMAT) <> 1
     OR Equal(OLD.CODCOR,NEW.CODCOR) <> 1
     OR Equal(OLD.CODTAM,NEW.CODTAM) <> 1 THEN

        SELECT REFPRO INTO wk_Old_Refpro
        FROM TT_GRA
        WHERE FILMAT = OLD.FILMAT
          AND CODMAT = OLD.CODMAT
          AND CODCOR = OLD.CODCOR
          AND CODTAM = OLD.CODTAM;

        SELECT REFPRO INTO wk_New_Refpro
        FROM TT_GRA
        WHERE FILMAT = NEW.FILMAT
          AND CODMAT = NEW.CODMAT
          AND CODCOR = NEW.CODCOR
          AND CODTAM = NEW.CODTAM;

         VLOG := VLOG||'Produto: de '||COALESCE(wk_Old_Refpro,cNulo)||' para '||COALESCE(wk_New_Refpro,cNulo)||CRLF;
     END IF;

     IF Equal(OLD.FILFOR||OLD.CODFOR,NEW.FILFOR||NEW.CODFOR) <> 1 THEN
         VLOG := VLOG||'Fornecedor: de '||COALESCE(OLD.FILFOR||'/'||TRIM(OLD.CODFOR),cNulo)||' para '||COALESCE(NEW.FILFOR||'/'||TRIM(NEW.CODFOR),cNulo)||CRLF;
     END IF;

     IF Equal(OLD.NUMLOT,NEW.NUMLOT) <> 1 THEN
         VLOG := VLOG||'Nmero do Lote: de '||COALESCE(OLD.NUMLOT,cNulo)||' para '||COALESCE(NEW.NUMLOT,cNulo)||CRLF;
     END IF;

     IF Equal(OLD.DATINC,NEW.DATINC) <> 1 THEN
         vLOG := vLOG||'Data da Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;

     IF Equal(OLD.TONALI,NEW.TONALI) <> 1 THEN
         VLOG := VLOG||'Tonalidade: de '||COALESCE(OLD.TONALI,cNulo)||' para '||COALESCE(NEW.TONALI,cNulo)||CRLF;
     END IF;

     IF Equal(OLD.TAMANH,NEW.TAMANH) <> 1 THEN
         VLOG := VLOG||'Tamanho: de '||COALESCE(OLD.TAMANH,cNulo)||' para '||COALESCE(NEW.TAMANH,cNulo)||CRLF;
     END IF;

     IF Equal(OLD.DATVAL,NEW.DATVAL) <> 1 THEN
         vLOG := vLOG||'Data de validade: de '||COALESCE(TO_CHAR(OLD.DATVAL,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATVAL,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;

     IF Equal(OLD.QTDINI,NEW.QTDINI) <> 1 THEN
         VLOG := VLOG||'Quantidade em estoque inicial: de '||COALESCE(OLD.QTDINI,iNulo)||' para '||COALESCE(NEW.QTDINI,iNulo)||CRLF;
     END IF;

     IF Equal(OLD.QTDCOM,NEW.QTDCOM) <> 1 THEN
         VLOG := VLOG||'Qtd. total Comprada: de '||COALESCE(OLD.QTDCOM,iNulo)||' para '||COALESCE(NEW.QTDCOM,iNulo)||CRLF;
     END IF;

     IF Equal(OLD.FLGPON,NEW.FLGPON) <> 1 THEN
         VLOG := VLOG||'Ponta de estoque: de '||COALESCE(OLD.FLGPON,cNulo)||' para '||COALESCE(NEW.FLGPON,cNulo)||CRLF;
     END IF;

     IF Equal(OLD.CODEXT,NEW.CODEXT) <> 1 THEN
         VLOG := VLOG||'Cdigo Externo: de '||COALESCE(OLD.CODEXT,cNulo)||' para '||COALESCE(NEW.CODEXT,cNulo)||CRLF;
     END IF;

     IF Equal(OLD.PERABA,NEW.PERABA) <> 1 THEN
         VLOG := VLOG||'% Abatimento de '||COALESCE(OLD.PERABA,iNulo)||' para '||COALESCE(NEW.PERABA,iNulo)||CRLF;
     END IF;

     IF Equal(OLD.LOTATI,NEW.LOTATI) <> 1 THEN
         VLOG := VLOG||'Lote Ativo?: de '||COALESCE(OLD.LOTATI,cNulo)||' para '||COALESCE(NEW.LOTATI,cNulo)||CRLF;
     END IF;
     
     IF Equal(OLD.CODALT,NEW.CODALT) <> 1 THEN
         VLOG := VLOG||'Cdigo alternativo: de '||COALESCE(OLD.CODALT,cNulo)||' para '||COALESCE(NEW.CODALT,cNulo)||CRLF;
     END IF;

     IF ISNOTNULL(VLOG)='T' THEN
        INSERT INTO TL_LOT (FILLOT, SEQLOT, MSGLOG)
             VALUES (NEW.CODFIL, NEW.SEQUEN, vLOG);
     END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4681 --*/
CREATE TRIGGER TGLOT2
AFTER INSERT OR UPDATE ON TT_LOT 
FOR EACH ROW EXECUTE PROCEDURE TGLOT2();


/*-- SEQ 4682 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLPED() CASCADE;

/*-- SEQ 4683 --*/
CREATE OR REPLACE FUNCTION TGLPED() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impedir excluses.
-- 2. Impedir atualizaes.
-- 3. Gerar um cdigo sequencial exclusivo para compor a chave primria.

-- Declarao de variveis e cursores
   COMPLEMENTO CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Impede excluso.
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20000 Registro de uso interno. No pode ser excludo. %' , COMPLEMENTO;
   END IF;

   -- Impedir atualizaes.
   IF (TG_OP = 'UPDATE') THEN
      RAISE EXCEPTION 'PG-20001 Registro de uso interno. No pode ser modificado. %' , COMPLEMENTO;
   END IF;

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.CODTAB IS NULL THEN
         NEW.CODTAB := ProximoCodigo('TL_PED', NEW.FILPED);
      END IF;
      NEW.DATOPE := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4684 --*/
CREATE TRIGGER TGLPED
BEFORE INSERT OR UPDATE OR DELETE ON TL_PED 
FOR EACH ROW EXECUTE PROCEDURE TGLPED();


/*-- SEQ 4685 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLPLA() CASCADE;

/*-- SEQ 4686 --*/
CREATE OR REPLACE FUNCTION TGLPLA() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impedir excluses.
-- 2. Impedir atualizaes.
-- 3. Gerar um cdigo sequencial exclusivo para compor a chave primria.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Impede excluso.
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20000 Registro de uso interno. No pode ser excludo. %' , COMPLEMENTO;
   END IF;

   -- Impedir atualizaes.
   IF (TG_OP = 'UPDATE') THEN
      RAISE EXCEPTION 'PG-20001 Registro de uso interno. No pode ser modificado. %' , COMPLEMENTO;
   END IF;
   
   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.CODTAB IS NULL THEN
         NEW.CODTAB := ProximoCodigo('TL_PLA',NEW.FILPLA);
      END IF;
      NEW.DATOPE := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4687 --*/
CREATE TRIGGER TGLPLA
BEFORE INSERT OR UPDATE OR DELETE ON TL_PLA 
FOR EACH ROW EXECUTE PROCEDURE TGLPLA();


/*-- SEQ 4688 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLPRE() CASCADE;

/*-- SEQ 4689 --*/
CREATE OR REPLACE FUNCTION TGLPRE() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir alteracoes
-- 2) Obter o codigo do usuario logado e associa-lo ao TT_USU
-- 3) Fazer parte do papel de uma "foreign key"
DECLARE
  achou   INTEGER;
  vComplemento VARCHAR(100);
  Logon  TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;


-- Principal
BEGIN
  vComplemento := Constante('Complemento');

  -- So permite inclusoes
  IF (TG_OP = 'UPDATE') THEN
    RAISE EXCEPTION 'PG-20036 Tabelas de "log" nao podem ter seus dados modificados ou excluidos. %' , vComplemento;
  END IF;

  IF (TG_OP = 'DELETE') THEN
    Achou := TGR_Preco_Existe(OLD.filpre,OLD.seqpre); /* retornos possiveis 0 e 1 e -1*/
    IF (achou = 1) THEN
       RAISE EXCEPTION 'PG-20039 Nao e possivel excluir o log de um preco existente. %' , vComplemento;
    END IF;
  END IF;

  IF (TG_OP = 'INSERT') THEN
    Achou := TGR_Preco_Existe(NEW.filpre,NEW.seqpre); /* retornos possiveis 0 e 1 e -1*/
    IF (achou = 0) THEN
      RAISE EXCEPTION 'PG-20038 Preco nao foi encontrado. %' , vComplemento;      
    END IF;

  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_PRE',NEW.FILPRE);
    END IF;
  END IF;

    -- Dados do usuario
    select * into Logon from DadosLogon();

    IF Logon.Encontrou THEN
      NEW.FILUSU := Logon.FILUSU;
      NEW.CODUSU := Logon.CODUSU;
    ELSE
      RAISE EXCEPTION 'PG-20037 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
    END IF;

    -- "Default"
    NEW.DATOPE := agora();

    WK_CODUID := GetCoduidAtual();

    NEW.coduid := wk_coduid;

  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4690 --*/
CREATE TRIGGER TGLPRE
BEFORE INSERT OR DELETE OR UPDATE ON TL_PRE 
FOR EACH ROW EXECUTE PROCEDURE TGLPRE();


/*-- SEQ 4691 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLPRJ() CASCADE;

/*-- SEQ 4692 --*/
CREATE OR REPLACE FUNCTION TGLPRJ() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir alteracoes
-- 2) Obter o codigo do usuario logado e associa-lo ao TT_USU
-- 3) Fazer parte do papel de uma "foreign key"
DECLARE
  achou   INTEGER;

  vComplemento VARCHAR(100);
  Logon  TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;

-- Principal
BEGIN
  vComplemento := Constante('Complemento');

  -- So permite inclusoes
  IF (TG_OP = 'UPDATE') THEN
    RAISE EXCEPTION 'PG-20036 Tabelas de "log" nao podem ter seus dados modificados ou excluidos. %' , vComplemento;
  END IF;

  IF (TG_OP = 'DELETE') THEN
    Achou := TGR_Projeto_Existe( OLD.codfil,OLD.sequen); /* retornos possiveis 0 e 1 */
    IF (achou = 1) THEN
      RAISE EXCEPTION 'PG-20039 Nao e possivel excluir o log de um projeto existente. %' , vComplemento;
    END IF;
  END IF;

  IF (TG_OP = 'INSERT') THEN
    Achou := TGR_Projeto_Existe( NEW.codfil,NEW.sequen); /* retornos possiveis 0 e 1 */
    IF (achou = 0) THEN
      RAISE EXCEPTION 'PG-20038 Projeto nao foi encontrado. %' , vComplemento;
    END IF;

  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_PRJ',NEW.CODFIL);
    END IF;
  END IF;

    -- Dados do usuario
    select * into Logon from DadosLogon();
    IF Logon.Encontrou THEN
      NEW.FILUSU := Logon.FILUSU;
      NEW.CODUSU := Logon.CODUSU;
    ELSE
      RAISE EXCEPTION 'PG-20037 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
    END IF;

    -- "Default"
    NEW.DATHOR := agora();

    WK_CODUID := GetCoduidAtual();

    NEW.coduid := wk_coduid;

  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4693 --*/
CREATE TRIGGER TGLPRJ
BEFORE INSERT OR DELETE OR UPDATE ON TL_PRJ 
FOR EACH ROW EXECUTE PROCEDURE TGLPRJ();


/*-- SEQ 4694 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLPRO() CASCADE;

/*-- SEQ 4695 --*/
CREATE OR REPLACE FUNCTION TGLPRO() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir alteracoes
-- 2) Obter o codigo do usuario logado e associa-lo ao TT_USU
-- 3) Fazer parte do papel de uma "foreign key"
DECLARE
  vComplemento VARCHAR(100);
  Logon  TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;

  -- Principal
begin
  vComplemento := Constante('Complemento');

  -- So permite inclusoes
  IF (TG_OP = 'UPDATE') THEN
    RAISE EXCEPTION 'PG-20036 Tabelas de "log" nao podem ter seus dados modificados ou excluidos. %' , vComplemento;
  END IF;

  IF (TG_OP = 'INSERT') THEN

    -- Dados do usuario
    select * into Logon from DadosLogon();
    IF Logon.Encontrou THEN
      NEW.FILUSU := Logon.FILUSU;
      NEW.CODUSU := Logon.CODUSU;
    ELSE
      RAISE EXCEPTION 'PG-20037 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
    END IF;

  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_PRO',NEW.FILUSU);
    END IF;
  END IF;

    -- "Default"
    NEW.DATOPE := agora();

    WK_CODUID := GetCoduidAtual();

    NEW.coduid := wk_coduid;

  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4696 --*/
CREATE TRIGGER TGLPRO
BEFORE INSERT OR DELETE OR UPDATE ON TL_PRO 
FOR EACH ROW EXECUTE PROCEDURE TGLPRO();


/*-- SEQ 4697 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGL_PRO_SPED() CASCADE;

/*-- SEQ 4698 --*/
CREATE OR REPLACE FUNCTION TGL_PRO_SPED() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    NEW.CODTAB:=ProximoCodigo('TL_PRO_SPED', '');
    
    IF NEW.DATOPE IS NULL THEN
       NEW.DATOPE := AGORA();
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4699 --*/
CREATE TRIGGER TGL_PRO_SPED
BEFORE INSERT ON TL_PRO_SPED 
FOR EACH ROW EXECUTE PROCEDURE TGL_PRO_SPED();


/*-- SEQ 4700 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLPTC() CASCADE;

/*-- SEQ 4701 --*/
CREATE OR REPLACE FUNCTION TGLPTC() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Popular Datope e no permitir alterao e excluso apenas incluso
-- Principal
BEGIN  
  IF (TG_OP = 'INSERT') THEN
       NEW.DATOPE := agora();
  END IF;    

  IF (TG_OP = 'UPDATE') THEN    
       RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser alterado';     
  END IF;

  IF (TG_OP = 'DELETE') THEN  
     RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido';     
  END IF; 

  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_PTC','001');
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4702 --*/
CREATE TRIGGER TGLPTC
BEFORE INSERT OR UPDATE OR DELETE ON TL_PTC 
FOR EACH ROW EXECUTE PROCEDURE TGLPTC();


/*-- SEQ 4703 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLRAT() CASCADE;

/*-- SEQ 4704 --*/
CREATE OR REPLACE FUNCTION TGLRAT() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_RAT',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4705 --*/
CREATE TRIGGER TGLRAT
BEFORE INSERT ON TL_RAT 
FOR EACH ROW EXECUTE PROCEDURE TGLRAT();


/*-- SEQ 4706 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLRCP() CASCADE;

/*-- SEQ 4707 --*/
CREATE OR REPLACE FUNCTION TGLRCP() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir exclusoes
-- 2) Impedir alteracoes
-- 3) Fazer parte do papel de uma "foreign key"
DECLARE
   wk_coduid                     TT_UID.CODUID%TYPE;
   vVem_de_UNIAO_PARCEIROS       CONSTANT VARCHAR(1) := Constante('UNIAO_PARCEIROS');

   filial                        TL_RCP.FILCAN%TYPE;
   usuario                       TL_RCP.CODCAN%TYPE;

   Logon                         TRetQuemLogou%ROWTYPE;
   vComplemento                  VARCHAR(100);

   
   --Pedro E. Braga - 98002 - Não faz sintido fazer o papel de uma "foreign key" pois ira quardar dados de exclusão
   /*
   dummy1                        TL_RCP.FILFOR%TYPE;
   dummy2                        TL_RCP.CODFOR%TYPE;
   dummy3                        TL_RCP.CODSER%TYPE;
   dummy4                        TL_RCP.SUBSER%TYPE;
   dummy5                        TL_RCP.NUMNOT%TYPE;
   
   recepcao CURSOR(filial TL_RCP.FILFOR%TYPE,
           codigo TL_RCP.CODFOR%TYPE,
           serie TL_RCP.CODSER%TYPE,
           subserie TL_RCP.SUBSER%TYPE,
           nota TL_RCP.NUMNOT%TYPE) IS
    SELECT FILFOR,CODFOR,CODSER,SUBSER,NUMNOT
    FROM TT_RCP
    WHERE FILFOR = filial
      AND CODFOR = codigo
      AND CODSER = serie
      AND SUBSER = subserie
      AND NUMNOT = nota;
   */

  -- Principal
BEGIN
   vComplemento := Constante('Complemento');

   -- So permite inclusoes          -- se nao vier da uniao de parceiros
   IF ((TG_OP = 'DELETE')) OR (((TG_OP = 'UPDATE')) AND (Equal(NEW.DUMMY, vVem_de_UNIAO_PARCEIROS) <> 1)) THEN
      RAISE EXCEPTION 'PG-20036 Tabelas de "log" nao podem ter seus dados modificados ou excluidos. %' , vComplemento;
   END IF;

   IF (TG_OP = 'INSERT') THEN
      --Pedro E. Braga - 98002 - Não faz sintido fazer o papel de uma "foreign key" pois ira quardar dados de exclusão
      -- Faz o papel da "foreign key" verificando se a recepcao existe
      /*
      OPEN recepcao (NEW.FILFOR, NEW.CODFOR,
                     NEW.CODSER, NEW.SUBSER,
                     NEW.NUMNOT);
         FETCH recepcao INTO dummy1,dummy2,dummy3,dummy4,dummy5;
         IF NOT FOUND THEN
            CLOSE recepcao;
            RAISE EXCEPTION 'PG-20037 Nota nao foi encontrada. %' , vComplemento;
         END IF;
      CLOSE recepcao;
      */

      select * into Logon from DadosLogon();

      IF Logon.Encontrou THEN
         NEW.FILCAN := Logon.FILUSU;
         NEW.CODCAN := Logon.CODUSU;
      ELSE
         RAISE EXCEPTION 'PG-20037 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
      END IF;

   END IF;
  
   IF (TG_OP = 'INSERT') THEN 
      IF NEW.CODTAB IS NULL THEN
         NEW.CODTAB:=ProximoCodigo('TL_RCP',NEW.CODFIL);
      END IF;
   END IF;

   IF ((TG_OP = 'INSERT')) OR ((TG_OP = 'UPDATE')) THEN
      -- se nao vier da uniao de parceiros  
      IF (Equal(NEW.DUMMY, vVem_de_UNIAO_PARCEIROS) <> 1) THEN
         -- "Default"
         NEW.DATHOR := agora();

         WK_CODUID := GetCoduidAtual();

         NEW.CODUID := wk_coduid;
      END IF;
   END IF;

   IF (NOT (TG_OP = 'DELETE')) THEN
      NEW.DUMMY := Null;
   END IF;

    IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4708 --*/
CREATE TRIGGER TGLRCP
BEFORE INSERT OR DELETE OR UPDATE ON TL_RCP 
FOR EACH ROW EXECUTE PROCEDURE TGLRCP();


/*-- SEQ 4709 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLRDV() CASCADE;

/*-- SEQ 4710 --*/
CREATE OR REPLACE FUNCTION TGLRDV() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Popular Datope e no permitir alterao e excluso apenas incluso
-- Principal
BEGIN  
  IF (TG_OP = 'INSERT') THEN
       NEW.DATOPE := agora();
  END IF;    

  IF (TG_OP = 'UPDATE') THEN    
       RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser alterado';     
  END IF;

  IF (TG_OP = 'DELETE') THEN  
     RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido';     
  END IF; 

  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_RDV','001');
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4711 --*/
CREATE TRIGGER TGLRDV
BEFORE INSERT OR UPDATE OR DELETE ON TL_RDV 
FOR EACH ROW EXECUTE PROCEDURE TGLRDV();


/*-- SEQ 4712 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLREG() CASCADE;

/*-- SEQ 4713 --*/
CREATE OR REPLACE FUNCTION TGLREG() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir alteracoes
-- 2) Obter o codigo do usuario logado e associa-lo ao TT_USU
-- 3) Fazer parte do papel de uma "foreign key"
DECLARE

  achou   INTEGER;
  vComplemento VARCHAR(100);
  Logon  TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;


  -- Principal
begin
  vComplemento := Constante('Complemento');

  -- So permite inclusoes
  IF (TG_OP = 'UPDATE') THEN
    RAISE EXCEPTION 'PG-20036 Tabelas de "log" nao podem ter seus dados modificados ou excluidos. %' , vComplemento;
  END IF;

  IF (TG_OP = 'DELETE') THEN
    ACHOU := TGR_Registro_Existe( OLD.CODFIL,OLD.SEQUEN ); /* retornos possiveis 0 e 1 */

    IF (achou = 1) THEN
      RAISE EXCEPTION 'PG-20037 Nao e possivel excluir o log de um registro existente. %' , vComplemento;
    END IF;
  END IF;

  IF (TG_OP = 'INSERT') THEN
    ACHOU := TGR_Registro_Existe( NEW.CODFIL,NEW.SEQUEN ); /* retornos possiveis 0 e 1 */

    IF (achou = 0) THEN
      RAISE EXCEPTION 'PGcod erro RAISE codigo_nao_existe. %' , vComplemento;
    END IF;

    IF (TG_OP = 'INSERT') THEN 
      IF NEW.CODTAB IS NULL THEN
         NEW.CODTAB:=ProximoCodigo('TL_REG',NEW.CODFIL);
      END IF;
    END IF;

    -- Dados do usuario
    select * into Logon from DadosLogon();
    IF Logon.Encontrou THEN
      NEW.FILUSU := Logon.FILUSU;
      NEW.CODUSU := Logon.CODUSU;
    ELSE
      RAISE EXCEPTION 'PG-20037 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
    END IF;

    -- "Default"
    NEW.DATALT := agora();

    WK_CODUID := GetCoduidAtual();

    NEW.coduid := wk_coduid;

  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4714 --*/
CREATE TRIGGER TGLREG
BEFORE INSERT OR DELETE OR UPDATE ON TL_REG 
FOR EACH ROW EXECUTE PROCEDURE TGLREG();


/*-- SEQ 4715 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLROM() CASCADE;

/*-- SEQ 4716 --*/
CREATE OR REPLACE FUNCTION TGLROM() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_ROM',NEW.FILUSU);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4717 --*/
CREATE TRIGGER TGLROM
BEFORE INSERT ON TL_ROM 
FOR EACH ROW EXECUTE PROCEDURE TGLROM();


/*-- SEQ 4718 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLRPS() CASCADE;

/*-- SEQ 4719 --*/
CREATE OR REPLACE FUNCTION TGLRPS() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB := ProximoCodigo('TL_RPS',NEW.FILRPS);
    END IF;
    NEW.DATOPE := AGORA();
  END IF; 
  IF (TG_OP = 'DELETE') THEN     
     RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido.';
  END IF;
  IF (TG_OP = 'UPDATE') THEN     
     RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser alterado.';
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4720 --*/
CREATE TRIGGER TGLRPS
BEFORE INSERT OR UPDATE OR DELETE ON TL_RPS 
FOR EACH ROW EXECUTE PROCEDURE TGLRPS();


/*-- SEQ 4721 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLRTT() CASCADE;

/*-- SEQ 4722 --*/
CREATE OR REPLACE FUNCTION TGLRTT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Popular Datope, Codtab e no permitir alterao e excluso apenas incluso
-- Principal
BEGIN  

  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_RTT',NEW.FILRTT);
	   NEW.DATOPE := agora();
    END IF;
  END IF;
  
  IF (TG_OP = 'UPDATE') THEN    
       RAISE EXCEPTION 'PG-20006 Registro de uso interno. No pode ser alterado';     
  END IF;

  IF (TG_OP = 'DELETE') THEN  
     RAISE EXCEPTION 'PG-20006 Registro de uso interno. No pode ser excludo';     
  END IF;  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4723 --*/
CREATE TRIGGER TGLRTT
BEFORE INSERT OR UPDATE OR DELETE ON TL_RTT 
FOR EACH ROW EXECUTE PROCEDURE TGLRTT();


/*-- SEQ 4724 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLSAV() CASCADE;

/*-- SEQ 4725 --*/
CREATE OR REPLACE FUNCTION TGLSAV() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Impedir alteraes e excluses
DECLARE
  vComplemento VARCHAR(100);
    
BEGIN
  vComplemento := Constante('Complemento');
  -- So permite inclusoes
  IF ((TG_OP = 'DELETE')) OR ((TG_OP = 'UPDATE')) THEN
    RAISE EXCEPTION 'PG-20001 Tabelas de "log" nao podem ter seus dados modificados ou excluidos. %' , vComplemento;
  END IF;  

  -- Populando a chave primria
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_SAV',NEW.FILSAV);
    END IF;
  END IF;

  -- "Default"
  NEW.DATOPE := agora();  
 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4726 --*/
CREATE TRIGGER TGLSAV
BEFORE INSERT OR DELETE OR UPDATE ON TL_SAV 
FOR EACH ROW EXECUTE PROCEDURE TGLSAV();


/*-- SEQ 4727 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLSUP() CASCADE;

/*-- SEQ 4728 --*/
CREATE OR REPLACE FUNCTION TGLSUP() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir alteracoes
-- 2) Obter o codigo do usuario logado e associa-lo ao TT_USU
-- 3) Fazer parte do papel de uma "foreign key"
DECLARE
  achou   INTEGER;
  vComplemento VARCHAR(100);
  Logon  TRetQuemLogou%ROWTYPE;
  cLF     char(1) := chr(13);
  wk_coduid tt_uid.coduid%type;

-- Principal
BEGIN
  vComplemento := Constante('Complemento');

  IF (TG_OP = 'UPDATE') THEN
    ACHOU := TGR_Chamado_Existe( NEW.CODFIL,NEW.SEQUEN); /* retornos possiveis 0 e 1 */
    IF (achou = 0) THEN
       RAISE EXCEPTION 'PG-20037 Chamado nao foi encontrado. %' , vComplemento;
    END IF;

    IF   Equal(NEW.CODFIL, OLD.CODFIL) = 1
    AND  Equal(NEW.SEQUEN, OLD.SEQUEN) = 1 THEN
      RAISE EXCEPTION 'PG-20036 Tabelas de "log" nao podem ter seus dados modificados ou excluidos. %' , vComplemento;
    ELSE
      IF   Equal(NEW.MSGLOG, OLD.MSGLOG) = 1
      AND  Equal(NEW.FLGMUD, OLD.FLGMUD) = 1
      AND  Equal(NEW.FILUSU, OLD.FILUSU) = 1
      AND  Equal(NEW.CODUSU, OLD.CODUSU) = 1
      AND  Equal(NEW.DATHOR, OLD.DATHOR) = 1       THEN
        NEW.MSGLOG := 'Uniao de Chamados. Chamado anterior: ' || OLD.codfil || '/' || TRIM(OLD.sequen) || '.' || cLF;

        -- Dados do usuario
        select * into Logon from DadosLogon();
        IF not Logon.Encontrou THEN
          RAISE EXCEPTION 'PG-20036 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
        END IF;

        NEW.MSGLOG := NEW.MSGLOG || 'Usuario que fez a uniao: ' || Logon.filUSU || '/' || Logon.Codusu || '.' || CLF;
        NEW.MSGLOG := NEW.MSGLOG || 'Data da uniao: ' || TO_CHAR(agora(),'DD/MM/YYYY HH24:MI:SS') || CLF;
        NEW.MSGLOG := NEW.MSGLOG || OLD.MSGLOG;
      else
        RAISE EXCEPTION 'PG-20036 Tabelas de "log" nao podem ter seus dados modificados ou excluidos. %' , vComplemento;
      end if;
    END IF;
  END IF;

  IF (TG_OP = 'DELETE') THEN
    ACHOU := TGR_Chamado_Existe( OLD.CODFIL,OLD.SEQUEN); /* retornos possiveis 0 e 1 */

    IF (achou = 1) THEN
      RAISE EXCEPTION 'PG-20039 Nao e possivel excluir o log de uma Tarefa existente. %' , vComplemento;
    END IF;
  END IF;

  IF (TG_OP = 'INSERT') THEN
    ACHOU := TGR_Chamado_Existe( NEW.CODFIL,NEW.SEQUEN); /* retornos possiveis 0 e 1 */
    IF (achou = 0) THEN
       RAISE EXCEPTION 'PG-20037 Chamado nao foi encontrado. %' , vComplemento;
    END IF;

  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_SUP',NEW.CODFIL);
    END IF;
  END IF;

    -- Dados do usuario
    select * into Logon from DadosLogon();
    IF Logon.Encontrou THEN
      NEW.FILUSU := Logon.FILUSU;
      NEW.CODUSU := Logon.CODUSU;
    ELSE
      RAISE EXCEPTION 'PG-20036 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
    END IF;

    -- "Default"
    NEW.DATHOR := agora();

    WK_CODUID := GetCoduidAtual();

    NEW.coduid := wk_coduid;


  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4729 --*/
CREATE TRIGGER TGLSUP
BEFORE INSERT OR DELETE OR UPDATE ON TL_SUP 
FOR EACH ROW EXECUTE PROCEDURE TGLSUP();


/*-- SEQ 4730 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLSVM() CASCADE;

/*-- SEQ 4731 --*/
CREATE OR REPLACE FUNCTION TGLSVM() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impedir excluses.
-- 2. Impedir atualizaes.
-- 3. Gerar um cdigo sequencial exclusivo para compor a chave primria.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Bruno Berticelli - GES-2020025741 - Permitir a excluso de LOGS.
   -- Impede excluso.
   --IF (TG_OP = 'DELETE') THEN
   --   RAISE EXCEPTION 'PG-20000 Registro de uso interno. No pode ser excludo. %' , COMPLEMENTO;
   --END IF;

   -- Impedir atualizaes.
   IF (TG_OP = 'UPDATE') THEN
      RAISE EXCEPTION 'PG-20001 Registro de uso interno. No pode ser modificado. %' , COMPLEMENTO;
   END IF;

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.CODTAB IS NULL THEN
         SELECT NEXTVAL('SQLSVM') INTO NEW.CODTAB FROM DUAL;
      END IF;
      NEW.DATOPE := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4732 --*/
CREATE TRIGGER TGLSVM
BEFORE INSERT OR UPDATE OR DELETE ON TL_SRV_MID 
FOR EACH ROW EXECUTE PROCEDURE TGLSVM();


/*-- SEQ 4733 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLTEF() CASCADE;

/*-- SEQ 4734 --*/
CREATE OR REPLACE FUNCTION TGLTEF() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gravar o CODUID
DECLARE
  wk_coduid tt_uid.coduid%type;
BEGIN
  WK_CODUID := GetCoduidAtual();

IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_TEF',NEW.CODFIL);
    END IF;
  END IF;
 
  NEW.coduid := wk_coduid;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4735 --*/
CREATE TRIGGER TGLTEF
BEFORE INSERT OR DELETE OR UPDATE ON TL_TEF 
FOR EACH ROW EXECUTE PROCEDURE TGLTEF();


/*-- SEQ 4736 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLVEN() CASCADE;

/*-- SEQ 4737 --*/
CREATE OR REPLACE FUNCTION TGLVEN() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TL_VEN',NEW.FILUSU);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4738 --*/
CREATE TRIGGER TGLVEN
BEFORE INSERT ON TL_VEN 
FOR EACH ROW EXECUTE PROCEDURE TGLVEN();


/*-- SEQ 4739 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGLWOR() CASCADE;

/*-- SEQ 4740 --*/
CREATE OR REPLACE FUNCTION TGLWOR() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir alteracoes
-- 2) Obter o codigo do usuario logado e associa-lo ao TT_USU
-- 3) Fazer parte do papel de uma "foreign key"
DECLARE
  achou   INTEGER;
  vComplemento VARCHAR(100);

  Logon  TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;


-- Principal
begin
  vComplemento := Constante('Complemento');

  -- So permite inclusoes
  IF (TG_OP = 'UPDATE') THEN
    RAISE EXCEPTION 'PG-20036 Tabelas de "log" nao podem ter seus dados modificados ou excluidos. %' , vComplemento;
  END IF;

  IF (TG_OP = 'DELETE') THEN
    Achou := TGR_Tarefa_Existe( OLD.CODFIL,OLD.SEQUEN ); /* retornos possiveis 0 e 1 */

    IF (achou = 1) THEN
       RAISE EXCEPTION 'PG-20039 Nao e possivel excluir o log de uma Tarefa existente. % ' , vComplemento;
    END IF;
  END IF;

  IF (TG_OP = 'INSERT') THEN
    Achou := TGR_Tarefa_Existe( NEW.CODFIL,NEW.SEQUEN ); /* retornos possiveis 0 e 1 */
    IF (achou = 0) THEN
      RAISE EXCEPTION 'PG-20038 Tarefa nao foi encontrada. %' , vComplemento;
    END IF;

    IF (TG_OP = 'INSERT') THEN 
      IF NEW.CODTAB IS NULL THEN
         NEW.CODTAB:=ProximoCodigo('TL_WOR',NEW.CODFIL);
      END IF;
    END IF;

    -- Dados do usuario
    select * into Logon from DadosLogon();

    IF Logon.Encontrou THEN
      NEW.FILUSU := Logon.FILUSU;
      NEW.CODUSU := Logon.CODUSU;
    ELSE
      RAISE EXCEPTION 'PG-20037 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
    END IF;

    -- "Default"
    NEW.DATHOR := agora();

    WK_CODUID := GetCoduidAtual();

    NEW.coduid := wk_coduid;

  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4741 --*/
CREATE TRIGGER TGLWOR
BEFORE INSERT OR DELETE OR UPDATE ON TL_WOR 
FOR EACH ROW EXECUTE PROCEDURE TGLWOR();


/*-- SEQ 4742 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGMABA() CASCADE;

/*-- SEQ 4743 --*/
CREATE OR REPLACE FUNCTION TGMABA() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Atualiza SEQUEN

-- Principal
BEGIN
 
   IF (TG_OP = 'INSERT') THEN
     IF NEW.SEQUEN IS NULL THEN
        NEW.SEQUEN := ProximoCodigo('TM_ABA',NEW.CODFIL);
     END IF;   
   END IF;
    
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4744 --*/
CREATE TRIGGER TGMABA
BEFORE INSERT OR UPDATE OR DELETE ON TM_ABA 
FOR EACH ROW EXECUTE PROCEDURE TGMABA();


/*-- SEQ 4745 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGMAI() CASCADE;

/*-- SEQ 4746 --*/
CREATE OR REPLACE FUNCTION TGMAI() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
    Filial TT_IDF.CODLOJ%TYPE;
-- Principal
BEGIN
  -- Gera codigo sequencial
  IF (TG_OP = 'INSERT') THEN
     IF NEW.CODFIL IS NULL THEN
       SELECT CODLOJ INTO Filial FROM TT_IDF;
       NEW.CODFIL := Filial;
     END IF;    

     IF NEW.SEQUEN IS NULL THEN 
       NEW.SEQUEN := ProximoCodigo('TT_MAI',NEW.CODFIL);
     END IF;
  END IF;

  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     IF NEW.DATENV IS NOT NULL THEN
        NEW.MAIENV:='T';
     ELSE 
        NEW.MAIENV:='F';
     END IF;    
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4747 --*/
CREATE TRIGGER TGMAI
BEFORE INSERT OR UPDATE ON TT_MAI 
FOR EACH ROW EXECUTE PROCEDURE TGMAI();




/*-- SEQ 4748 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGMAR2() CASCADE;

/*-- SEQ 4749 --*/
CREATE OR REPLACE FUNCTION TGMAR2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo

-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN := ProximoCodigo('TT_MAR',NEW.FILMAR);
    END IF;
  END IF;

  IF (TG_OP = 'UPDATE') THEN

     UPDATE TT_PRO SET ATU_EM = AGORA() 
      WHERE FILMAR = OLD.FILMAR 
        AND CODMAR = OLD.CODMAR 
        AND ITEMAR = OLD.ITEMAR;

     UPDATE TT_PRO SET ATU_EM = AGORA() 
      WHERE FILMAR = NEW.FILMAR 
        AND CODMAR = NEW.CODMAR 
        AND ITEMAR = NEW.ITEMAR;

  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4750 --*/
CREATE TRIGGER TGMAR2
BEFORE INSERT OR UPDATE ON TT_MAR 
FOR EACH ROW EXECUTE PROCEDURE TGMAR2();

/*-- SEQ 4751 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGMAR3() CASCADE;

/*-- SEQ 4752 --*/
CREATE OR REPLACE FUNCTION TGMAR3() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualizar tabela TT_PROxNOM
--
DECLARE
  cRet VARCHAR(2);
  -- Principal
BEGIN
  --Atualiza TT_PROxNOM
  --davi - 21/11/06 - 41296
  IF ((TG_OP = 'UPDATE')) AND (Equal(OLD.DESMAR,NEW.DESMAR) = 0) THEN
    
    cRet := PC_PROxNOM_Atualiza('IPR.FILMAR = '||chr(39)||NEW.FILMAR||chr(39)||' '||
                            'AND IPR.CODMAR = '||chr(39)||NEW.CODMAR||chr(39)||' '||
                            'AND IPR.TIPMAR = '||chr(39)||NEW.TIPMAR||chr(39), 
			    null, null, null, null );
   


          END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4753 --*/
CREATE TRIGGER TGMAR3
AFTER UPDATE ON TT_MAR 
FOR EACH ROW EXECUTE PROCEDURE TGMAR3();




/*-- SEQ 4754 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGMASS() CASCADE;

/*-- SEQ 4755 --*/
CREATE OR REPLACE FUNCTION TGMASS() RETURNS TRIGGER AS $$
DECLARE
  vSESSIONID    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');
  
  WK_UID        TPC_UID_Retorno%ROWTYPE;
  
BEGIN

  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    IF NEW.MASSID IS NULL THEN
      NEW.MASSID := ProximoCodigo('TM_ASS',null);
    END IF;
    NEW.FLGEST   := 'N'; -- RFMP Assinar com "N"
  END IF;
  
  -- Inicializa dados para assinatura
  
  -- RFMP 85136
  WK_UID := GetUidAtual();  
  
  IF (TG_OP = 'INSERT') THEN
    IF WK_UID.BLQ_SEM_UID = 'T' AND WK_UID.CODUID IS NULL THEN
      RAISE EXCEPTION 'PG-20000 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
    NEW.CODUID := WK_UID.CODUID;	     
    NEW.ASSINA := COALESCE(AssinaTabela('TM_ASS', 
                                         ConcatenaMASS(NEW.MASSID,
                                                       NEW.TABELA,
                                                       NEW.FLGEST),
                                         null, null, null),NEW.ASSINA);
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4756 --*/
CREATE TRIGGER TGMASS
BEFORE INSERT ON TM_ASS 
FOR EACH ROW EXECUTE PROCEDURE TGMASS();  


/*-- SEQ 4757 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGMATU() CASCADE;

/*-- SEQ 4758 --*/
CREATE OR REPLACE FUNCTION TGMATU() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
   nUSERID                       TM_ATU.USERID%TYPE := USERENV( 'SESSIONID' );
      
   WK_UID                        TPC_UID_Retorno%ROWTYPE;
   -- Principal
BEGIN
   -- Gera um codigo automaticamente
   IF (TG_OP = 'INSERT') THEN
      IF NEW.ID IS NULL THEN
         NEW.ID := TO_NUMBER(TRIM(ProximoCodigo('TM_ATU',NULL)));
      END IF;
      NEW.DATINC := Agora();
   END IF;

   WK_UID := GetUidAtual();

   NEW.USERID := nUSERID;
   NEW.CODUID := WK_UID.CODUID;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4759 --*/
CREATE TRIGGER TGMATU
BEFORE INSERT OR UPDATE ON TM_ATU 
FOR EACH ROW EXECUTE PROCEDURE TGMATU();


/*-- SEQ 4760 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGMCLI() CASCADE;

/*-- SEQ 4761 --*/
CREATE OR REPLACE FUNCTION TGMCLI() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo
-- 1) Gerar um codigo sequencial exclusivo como chave primaria
-- 2) Considerar sempre a data do banco
-- 3) Impedir alteracoes/exclusoes se o item ja foi processado
  vComplemento VARCHAR(100);
  -- Principal
begin
  vComplemento := Constante('Complemento');
  -- Nao permite exclusoes
  IF ((TG_OP = 'DELETE')) THEN
    IF (OLD.DATOPE is not null) THEN
      RAISE EXCEPTION 'PG-20036 Nao se pode excluir um item ja processado. %' , vComplemento;
    end if;
  END IF;

  -- Nao permite alteracoes se ja foi processado
  IF ((TG_OP = 'UPDATE')) THEN
    IF (OLD.DATOPE is not null) THEN
       RAISE EXCEPTION 'PG-20037 Nao se pode alterar um item ja processado. %' , vComplemento;
    END IF;
  END IF;
  
  -- Chave primaria
  IF (TG_OP = 'INSERT') THEN
    NEW.SEQUEN := ProximoCodigo('TM_CLI',NEW.CODFIL);
  END IF;

  -- Assume a data do dia
  IF (NOT (TG_OP = 'DELETE')) THEN
    NEW.DATHOR := agora();

    IF (NEW.DATOPE IS NOT NULL) THEN
      NEW.DATOPE := agora();
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4762 --*/
CREATE TRIGGER TGMCLI
BEFORE INSERT OR DELETE OR UPDATE ON TM_CLI 
FOR EACH ROW EXECUTE PROCEDURE TGMCLI();


/*-- SEQ 4763 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGMDT() CASCADE;

/*-- SEQ 4764 --*/
CREATE OR REPLACE FUNCTION TGMDT() RETURNS TRIGGER AS $$
DECLARE
  QuemLogou TRetQuemLogou%ROWTYPE;
-- Principal
BEGIN
    -- preenche dados do usurio de registro
  IF (TG_OP = 'INSERT') THEN
    select * into QuemLogou from DadosLogon();
    IF ((NEW.FILREG IS NULL) AND (NEW.CODREG IS NULL)) THEN
      NEW.FILREG := QuemLogou.FILUSU;
      NEW.CODREG := QuemLogou.CODUSU;
    END IF;
    NEW.DATREG := agora();

    IF COALESCE(NEW.PREBOM,0)=0 THEN
       select max(PrecoVendaBomba('P',null,fil.codfil,ufloja,GRAFIL,GRACOD,GRACOR,GRATAM,null)) INTO NEW.PREBOM
         from td_tan tan cross join td_fil fil
        where fil.codfil=NEW.CODFIL
          AND TAN.TANQUE=NEW.NUMTAN;
    END IF;

  END IF;
  
  IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
     NEW.ATU_EM := agora();
     NEW.DATMED := TRUNC(NEW.DATMED);
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4765 --*/
CREATE TRIGGER TGMDT
BEFORE INSERT OR DELETE OR UPDATE ON TT_MDT 
FOR EACH ROW EXECUTE PROCEDURE TGMDT();


/*-- SEQ 4766 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGMEND() CASCADE;

/*-- SEQ 4767 --*/
CREATE OR REPLACE FUNCTION TGMEND() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo
-- 1) Gravar qualquer alteracao em TO_CLI
-- 2) Impedir alteracoes/exclusoes se o item ja foi processado
  data Timestamp;
  vComplemento VARCHAR(100);
  vVem_de_UNIAO_PARCEIROS  constant VARCHAR(1) := constante('UNIAO_PARCEIROS');
  -- Principal
begin
  vComplemento := Constante('Complemento');
  -- Checa se e permitido alterar
  
  IF ((TG_OP = 'INSERT') OR (TG_OP = 'UPDATE')) THEN
    select datope into data
    from tm_cli cli
    where cli.codfil = NEW.CODFIL
      and cli.sequen = NEW.SEQUEN; 
  ELSE 
    select datope into data
    from tm_cli cli
    where cli.codfil = OLD.CODFIL
      and cli.sequen = OLD.SEQUEN; 
  END IF;

  -- Nao permite exclusoes
  IF ((TG_OP = 'DELETE')) and (data is not null) THEN
    RAISE EXCEPTION 'PG-20036 Nao se pode excluir um item ja processado. %' , vComplemento;
  END IF;

  -- se nao vier da uniao de parceiros
  IF (NOT (TG_OP = 'DELETE')) THEN
    IF (Equal(NEW.DUMMY, vVem_de_UNIAO_PARCEIROS) <> 1) THEN
      -- Nao permite alteracoes se ja foi processado
      IF ((TG_OP = 'UPDATE')) and (data is not null) THEN
        RAISE EXCEPTION 'PG-20037 Nao se pode alterar um item ja processado. %' , vComplemento;
      END IF;
    END IF;
  END IF;
  
  IF (NOT (TG_OP = 'DELETE')) THEN
    -- Assume a data do dia
    update tm_cli set DATHOR = agora()
    where codfil = NEW.CODFIL
      and sequen = NEW.SEQUEN;

    NEW.DUMMY := Null;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4768 --*/
CREATE TRIGGER TGMEND
BEFORE INSERT OR UPDATE OR DELETE ON TM_END 
FOR EACH ROW EXECUTE PROCEDURE TGMEND();


/*-- SEQ 4769 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGMGRA() CASCADE;

/*-- SEQ 4770 --*/
CREATE OR REPLACE FUNCTION TGMGRA() RETURNS TRIGGER AS $$
-- Objetivo
-- 1) Gerar um codigo sequencial exclusivo como chave primaria
-- 2) Considerar sempre a data do banco
-- 3) Impedir alteracoes/exclusoes se o item ja foi processado
DECLARE
   vComplemento CONSTANT VARCHAR(254):= constante('complemento');
BEGIN
  -- Nao permite exclusoes
  IF (TG_OP = 'DELETE') THEN 
    IF (OLD.DATOPE is not null) THEN
        RAISE EXCEPTION 'PG-20036 Nao se pode excluir um item ja processado.%' , vComplemento;
    END IF;
  END IF;

  -- Nao permite alteracoes se ja foi processado
  IF ((TG_OP = 'UPDATE')) THEN 
     IF (OLD.DATOPE is not null) THEN
       RAISE EXCEPTION 'PG-20037 Nao se pode alterar um item ja processado.%' , vComplemento;
     END IF;
  END IF;
  
  -- Chave primaria
  IF (TG_OP = 'INSERT') THEN
    NEW.SEQUEN:=ProximoCodigo('TM_GRA',NEW.CODFIL);
  END IF;

  -- Assume a data do dia
  IF (NOT (TG_OP = 'DELETE')) THEN
    NEW.DATHOR := agora();

    IF (NEW.DATOPE IS NOT NULL) THEN
      NEW.DATOPE := agora();
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4771 --*/
CREATE TRIGGER TGMGRA
BEFORE INSERT OR DELETE OR UPDATE ON TM_GRA 
FOR EACH ROW EXECUTE PROCEDURE TGMGRA();


/*-- SEQ 4772 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGMIFC() CASCADE;

/*-- SEQ 4773 --*/
CREATE OR REPLACE FUNCTION TGMIFC() RETURNS TRIGGER AS $$
DECLARE
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.ID IS NULL THEN
       NEW.ID:=to_number(trim(ProximoCodigo('TM_IFC',NULL)));
    END IF;
    IF NEW.DATINC IS NULL THEN
       NEW.DATINC := agora();
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4774 --*/
CREATE TRIGGER TGMIFC
BEFORE INSERT ON TM_IFC 
FOR EACH ROW EXECUTE PROCEDURE TGMIFC();


/*-- SEQ 4775 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGMON1() CASCADE;

/*-- SEQ 4776 --*/
CREATE OR REPLACE FUNCTION TGMON1() RETURNS TRIGGER AS $$
DECLARE
-- Tabela item de romaneio
-- Objetivo:
-- 1) Gerar sequenciador exclusivo
-- 2) Impedir a alteracao de alguns valores
-- 3) Atualizar ATU_EM, FILUSU e CODUSU 
-- 4) Impedir exclusoes
  
  vComplemento  VARCHAR(254);
  
  QuemLogou TRetQuemLogou%ROWTYPE;

-- Principal
BEGIN

  vComplemento := constante('complemento');

  -- Impede exclusoes
  IF (TG_OP = 'DELETE') THEN
     RAISE EXCEPTION 'PG-20001 Nao e possivel excluir uma montagem. %' , vComplemento;
  END IF;

  IF (TG_OP = 'INSERT') THEN      
    IF NEW.SEQUEN IS NULL THEN
      NEW.SEQUEN := ProximoCodigo('TT_MON',NEW.CODFIL);
    END IF;

    NEW.DATHOR := agora();
  END IF;

  IF (TG_OP = 'UPDATE') THEN
    IF (NEW.CODFIL<>OLD.CODFIL) or
       (NEW.SEQUEN<>OLD.SEQUEN) or 
       (NEW.FILUSU<>OLD.FILUSU) or
       (NEW.CODUSU<>OLD.CODUSU) or
       (NEW.DATHOR<>OLD.DATHOR) or 
       (NEW.FILIVE<>OLD.FILIVE) or 
       (NEW.SEQIVE<>OLD.SEQIVE) or
       (NEW.ITEIVE<>OLD.ITEIVE) THEN
      RAISE EXCEPTION 'PG-20002 Nao e permitida a alteracao da chave primaria, venda ou usuario. %' , vComplemento; 
    END IF;
  END IF;
  
  select * into QuemLogou from DadosLogon();
  
  NEW.FILUSU := QuemLogou.FILUSU;
  NEW.CODUSU := QuemLogou.CODUSU;

  NEW.ATU_EM := agora();
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4777 --*/
CREATE TRIGGER TGMON1
BEFORE INSERT OR UPDATE OR DELETE ON TT_MON 
FOR EACH ROW EXECUTE PROCEDURE TGMON1();

/*-- SEQ 4778 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGMON2() CASCADE;

/*-- SEQ 4779 --*/
CREATE OR REPLACE FUNCTION TGMON2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Registrar mudanca dos dados num "log"
--
DECLARE
  vLOG   VARCHAR(4000)   := '';
  CRLF   CONSTANT CHAR(1) := CHR(10);
  Nulo   CONSTANT CHAR(4) := 'Nulo';
  cData  CHAR(21)         := 'DD/MM/YYYY HH24:MI:SS';

-- Principal
BEGIN

  -- Tratamento de log
  IF (TG_OP = 'DELETE') THEN
    DELETE FROM TL_MON WHERE CODFIL = OLD.CODFIL AND SEQUEN = OLD.SEQUEN;
  END IF;

  -- Tratamento de vLOG
  IF (TG_OP = 'UPDATE') THEN
    IF Equal(OLD.LOCALI,NEW.LOCALI) <> 1 THEN
      vLOG := vLOG||'Localizacao: de '||COALESCE(OLD.LOCALI,Nulo)||' para '||COALESCE(NEW.LOCALI,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.TIPMON,NEW.TIPMON) <> 1  THEN
      vLOG := vLOG||'Tipo de montagem: de '||COALESCE(OLD.TIPMON,Nulo)||' para '||COALESCE(NEW.TIPMON,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.FILMAT,NEW.FILMAT) <> 1 OR
       Equal(OLD.CODMAT,NEW.CODMAT) <> 1 OR
       Equal(OLD.CODCOR,NEW.CODCOR) <> 1 OR
       Equal(OLD.CODTAM,NEW.CODTAM) <> 1 THEN
      vLOG := vLOG||'Produto: de '||COALESCE(OLD.FILMAT,Nulo)||'/'
                                             ||COALESCE(OLD.CODMAT,Nulo)||'/'
                                             ||COALESCE(OLD.CODCOR,0)||'/'
                                             ||COALESCE(OLD.CODTAM,0)||' para '
                                             ||COALESCE(NEW.FILMAT,Nulo)||'/'
                                             ||COALESCE(NEW.CODMAT,Nulo)||'/'
                                             ||COALESCE(NEW.CODCOR,0)||'/'
                                             ||COALESCE(NEW.CODTAM,0)||CRLF;
    END IF;
    IF Equal(OLD.FILUSU,NEW.FILUSU) <> 1 OR
       Equal(OLD.CODUSU,NEW.CODUSU) <> 1 THEN
      vLOG := vLOG||'Usuario: de '||COALESCE(OLD.FILUSU,Nulo)||'/'
                                             ||COALESCE(OLD.CODUSU,Nulo)||' para '
                                             ||COALESCE(NEW.FILUSU,Nulo)||'/'
                                             ||COALESCE(NEW.CODUSU,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.FILRES,NEW.FILRES) <> 1 OR
       Equal(OLD.CODRES,NEW.CODRES) <> 1 THEN
      vLOG := vLOG||'Responsavel: de '||COALESCE(OLD.FILRES,Nulo)||'/'
                                                 ||COALESCE(OLD.CODRES,Nulo)||' para '
                                                 ||COALESCE(NEW.FILRES,Nulo)||'/'
                                                 ||COALESCE(NEW.CODRES,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.FILCLI,NEW.FILCLI) <> 1 OR
       Equal(OLD.CODCLI,NEW.CODCLI) <> 1 THEN
      vLOG := vLOG||'Cliente: de '||COALESCE(OLD.FILCLI,Nulo)||'/'
                                             ||COALESCE(OLD.CODCLI,Nulo)||' para '
                                             ||COALESCE(NEW.FILCLI,Nulo)||'/'
                                             ||COALESCE(NEW.CODCLI,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.FILIVE,NEW.FILIVE) <> 1 OR
       Equal(OLD.SEQIVE,NEW.SEQIVE) <> 1 OR
       Equal(OLD.ITEIVE,NEW.ITEIVE) <> 1 THEN
      vLOG := vLOG||'Venda: de '||COALESCE(OLD.FILIVE,Nulo)||'/'
                                           ||COALESCE(OLD.SEQIVE,Nulo)||'/'
                                           ||COALESCE(OLD.ITEIVE,0)||' para '
                                           ||COALESCE(NEW.FILIVE,Nulo)||'/'
                                           ||COALESCE(NEW.SEQIVE,Nulo)||'/'
                                           ||COALESCE(NEW.ITEIVE,0)||CRLF;
    END IF;
    IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1  THEN
      vLOG := vLOG||'Status: de '||COALESCE(OLD.FLGEST,Nulo)||' para '||COALESCE(NEW.FLGEST,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.DATHOR,NEW.DATHOR) <> 1 THEN
      vLOG := vLOG||'Data: de '||COALESCE(TO_CHAR(OLD.DATHOR,cData),Nulo)||' para '||COALESCE(TO_CHAR(NEW.DATHOR,cData),Nulo)||CRLF;
    END IF;
    IF Equal(OLD.OBSERV,NEW.OBSERV) <> 1  THEN
      vLOG := vLOG||'Observacao: de '||COALESCE(OLD.OBSERV,Nulo)||' para '||COALESCE(NEW.OBSERV,Nulo)||CRLF;
    END IF;

    IF ISNOTNULL(vLOG) = 'T' THEN
      -- Inclui uma linha em TL_MON
      INSERT INTO TL_MON (CODFIL,SEQUEN,DATOPE,MSGLOG)
      VALUES (NEW.CODFIL,NEW.SEQUEN,agora(),vLOG);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4780 --*/
CREATE TRIGGER TGMON2
AFTER DELETE OR UPDATE ON TT_MON 
FOR EACH ROW EXECUTE PROCEDURE TGMON2();


/*-- SEQ 4781 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGMPB() CASCADE;

/*-- SEQ 4782 --*/
CREATE OR REPLACE FUNCTION TGMPB() RETURNS TRIGGER AS $$
DECLARE
  vComplemento constant VARCHAR(100) := constante('complemento');
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
BEGIN
  IF (TG_OP = 'INSERT') THEN
    -- Gera codigo sequencial
    IF (NEW.SEQUEN IS NULL) THEN
      NEW.SEQUEN:=TO_NUMBER(TRIM(ProximoCodigo('TT_MPB',NULL)));
    END IF;
  END IF;

  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
    IF NEW.TIPCONJ IN (1,2) AND ((NEW.ITETEC IS NOT NULL) OR (NEW.ITEMOU IS NOT NULL) OR (NEW.ITEMON IS NOT NULL)) THEN
      RAISE EXCEPTION 'PG-20010 Conjuntos do tipo Inciso I ou II devem conter apenas CPU. %' , vComplemento;
    ELSIF NEW.TIPCONJ = 3 AND ((NEW.ITETEC IS NULL) OR (NEW.ITEMOU IS NULL) OR (NEW.ITEMON IS NULL)) THEN
      RAISE EXCEPTION 'PG-20020 Conjuntos do tipo Inciso III devem conter CPU, Teclado, Mouse e Monitor. %' , vComplemento;
    ELSIF NEW.TIPCONJ = 4 AND ((NEW.ITETEC IS NULL) OR (NEW.ITEMOU IS NULL) OR (NEW.ITEMON IS NOT NULL)) THEN
      RAISE EXCEPTION 'PG-20030 Conjuntos do tipo Inciso IV devem conter apenas CPU, Teclado e Mouse. %' , vComplemento;
    END IF;
  END IF;
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4783 --*/
CREATE TRIGGER TGMPB
BEFORE INSERT ON TT_MPB 
FOR EACH ROW EXECUTE PROCEDURE TGMPB();


/*-- SEQ 4784 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGMPR() CASCADE;

/*-- SEQ 4785 --*/
CREATE OR REPLACE FUNCTION TGMPR() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 2) Registrar mudanca dos dados num "log"
   vLOG    VARCHAR(4000)     := '';
   vFILUSU VARCHAR(3);    
   vCODUSU VARCHAR(3); 
   cNulo   CONSTANT CHAR(1)   := '0';
   CRLF    CONSTANT CHAR(1)   := CHR(10);  
    
    QuemLogou TRetQuemLogou%ROWTYPE;
    WK_CODUID TT_UID.CODUID%TYPE;
BEGIN 
  WK_CODUID := GetCoduidAtual();

  select * into QuemLogou from DadosLogon();
  vFILUSU := QuemLogou.FILUSU;
  vCODUSU := QuemLogou.CODUSU;
 
  -- Tratamento de "log"
  IF (TG_OP = 'DELETE') THEN
     DELETE FROM TL_MPR WHERE FILMPR = OLD.CODFIL AND DATMPR = OLD.DATOPE;
  END IF;
                              
  -- Tratamento de log
  IF (TG_OP = 'UPDATE') THEN
     IF Equal(OLD.NUMERO,NEW.NUMERO) <> 1 THEN
        vLOG := vLOG||'Nmero do Mapa: de '||COALESCE(OLD.NUMERO,0)||' para '||COALESCE(NEW.NUMERO,0)||CRLF;
     END IF;
     IF ISNOTNULL(trim(vLOG)) = 'T' THEN
        -- cadastra o LOG.
        INSERT INTO TL_MPR (FILMPR,DATMPR,FILUSU,CODUSU,MSGLOG,CODUID)
          VALUES(NEW.CODFIL,NEW.DATOPE,vFILUSU,vCODUSU,vLOG,WK_CODUID);      
     END IF;   
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4786 --*/
CREATE TRIGGER TGMPR
AFTER INSERT OR UPDATE OR DELETE ON TT_MPR 
FOR EACH ROW EXECUTE PROCEDURE TGMPR();




/*-- SEQ 4787 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGMUN() CASCADE;

/*-- SEQ 4788 --*/
CREATE OR REPLACE FUNCTION TGMUN() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
DECLARE
   proximo                       Numeric;  
BEGIN
   NEW.ATU_EM := AGORA();
   IF NEW.CODIGO IS NULL THEN
      SELECT LPAD(NEXTVAL('sqMUN'),5) INTO proximo FROM DUAL;
      NEW.CODIGO := proximo;
   END IF;

   IF (TG_OP = 'INSERT') THEN
      IF LENGTH(NEW.CODIGO)<>5 THEN
         NEW.CODIGO:=LPAD(NEW.CODIGO,5);
      END IF;
   END IF;

   IF (TG_OP = 'UPDATE') THEN   
      UPDATE TD_ECF SET ATU_EM = AGORA() 
       WHERE (FILECF) IN (SELECT FIL.CODFIL FROM TD_FIL FIL WHERE FIL.CODCID = OLD.CODIGO);
      UPDATE TD_ECF SET ATU_EM = AGORA()
       WHERE (FILECF) IN (SELECT FIL.CODFIL FROM TD_FIL FIL WHERE FIL.CODCID = NEW.CODIGO);
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4789 --*/
CREATE TRIGGER TGMUN
BEFORE INSERT OR UPDATE ON TT_MUN 
FOR EACH ROW EXECUTE PROCEDURE TGMUN();

/*-- SEQ 4790 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGMUN2() CASCADE;

/*-- SEQ 4791 --*/
CREATE OR REPLACE FUNCTION TGMUN2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_CLI
DECLARE
   cRetorno                      VARCHAR(2);
   cWhere                        TM_ATU.FILTRO%TYPE;
   cCODCID                       TT_END.CODCID%TYPE;
   cFILCLI                       TT_END.FILCLI%TYPE;
   cCODCLI                       TT_END.CODCLI%TYPE;
   
   crEnderecos CURSOR(pCODCID TT_END.CODCID%TYPE) IS
      SELECT FILCLI, CODCLI
        FROM TT_END 
       WHERE CODCID = pCODCID
    GROUP BY FILCLI, CODCLI;
BEGIN
   --Tratamento para Atualizar Tabela Pai
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN 
      cCODCID := NEW.CODIGO;
   ELSIF (TG_OP = 'DELETE') THEN
      cCODCID := OLD.CODIGO;
   END IF;
   OPEN crEnderecos(cCODCID);
   LOOP
      FETCH crEnderecos INTO cFILCLI, cCODCLI;
      EXIT WHEN NOT FOUND;
      cWhere := 'FILCLI = ' || CHR(39) || cFILCLI  || CHR(39) || ' AND CODCLI = ' || CHR(39) || cCODCLI || CHR(39);
      cRetorno := INSERE_MATU('TT_MUN', 'TT_CLI', cWhere);
   END LOOP;
   CLOSE crEnderecos;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4792 --*/
CREATE TRIGGER TGMUN2
AFTER INSERT OR UPDATE OR DELETE ON TT_MUN 
FOR EACH ROW EXECUTE PROCEDURE TGMUN2();


/*-- SEQ 4793 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGMVA() CASCADE;

/*-- SEQ 4794 --*/
CREATE OR REPLACE FUNCTION TGMVA() RETURNS TRIGGER AS $$
DECLARE
-- Principal
BEGIN
  --Popula a coluna DATINC
  IF (TG_OP = 'INSERT') THEN     
    NEW.DATINC := agora();
  END IF;

  -- Popula a coluna ATU_EM
  IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
     NEW.ATU_EM := agora();      
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4795 --*/
CREATE TRIGGER TGMVA
BEFORE INSERT OR UPDATE ON TT_MVA 
FOR EACH ROW EXECUTE PROCEDURE TGMVA();

/*-- SEQ 4796 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGMVA2() CASCADE;

/*-- SEQ 4797 --*/
CREATE OR REPLACE FUNCTION TGMVA2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 2) Registrar mudanca dos dados num "log"
   vLOG    VARCHAR(4000)     := '';
   vFILUSU VARCHAR(3);    
   vCODUSU VARCHAR(3);
   iNulo   CONSTANT Numeric(1) := 0;      
   cNuloChar CONSTANT CHAR(1) := '0';
   cNulo   CONSTANT CHAR(4)   := 'Nulo';
   CRLF    CONSTANT CHAR(1)   := CHR(10);  
    
    QuemLogou TRetQuemLogou%ROWTYPE;
    WK_CODUID TT_UID.CODUID%TYPE;
BEGIN
  WK_CODUID := GetCoduidAtual();

  select * into QuemLogou from DadosLogon();
  vFILUSU := QuemLogou.FILUSU;
  vCODUSU := QuemLogou.CODUSU;
                             
  -- Tratamento de log
  IF (TG_OP = 'INSERT') THEN
     vLOG := 'Inclusao';
     INSERT INTO TL_PTC (CODFIL,SEQUEN,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
          VALUES(NEW.CODFIL,NEW.SEQUEN,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);  
  ELSIF (TG_OP = 'UPDATE') THEN

     IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
        vLOG := vLOG||'Cdigo da Filial: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
       vLOG := vLOG||'Sequenciador: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.NUMITE,NEW.NUMITE) <> 1 THEN
        vLOG := vLOG||'Nmero do item: de '||COALESCE(OLD.NUMITE,iNulo)||' para '||COALESCE(NEW.NUMITE,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.ITEMVA,NEW.ITEMVA) <> 1 THEN
        vLOG := vLOG||'Nmero do item da exceo: de '||COALESCE(OLD.ITEMVA,iNulo)||' para '||COALESCE(NEW.ITEMVA,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.PERMVA,NEW.PERMVA) <> 1 THEN
        vLOG := vLOG||'Margem de Valor Agregado: de '||COALESCE(OLD.PERMVA,iNulo)||' para '||COALESCE(NEW.PERMVA,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.ALIINT,NEW.ALIINT) <> 1 THEN
        vLOG := vLOG||'Aliquota Interna: de '||COALESCE(OLD.ALIINT,iNulo)||' para '||COALESCE(NEW.ALIINT,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.ALIEST,NEW.ALIEST) <> 1 THEN
        vLOG := vLOG||'Aliquota Interestadual: de '||COALESCE(OLD.ALIEST,iNulo)||' para '||COALESCE(NEW.ALIEST,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.TIPOPE,NEW.TIPOPE) <> 1 THEN
        vLOG := vLOG||'Tipo de Operao: de '||COALESCE(OLD.TIPOPE,cNuloChar)||' para '||COALESCE(NEW.TIPOPE,cNuloChar)||CRLF;
     END IF;
     IF Equal(OLD.DATINC,NEW.DATINC) <> 1 THEN
        vLOG := vLOG||'Data Incluso: de '||COALESCE(to_char(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.ATU_EM,NEW.ATU_EM) <> 1 THEN
        vLOG := vLOG||'Data Alterao: de '||COALESCE(to_char(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;
     IF ISNOTNULL(trim(vLOG)) = 'T' THEN
        -- cadastra o LOG.
        INSERT INTO TL_PTC (CODFIL,SEQUEN,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                 VALUES (NEW.CODFIL,NEW.SEQUEN,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);     
     END IF;   
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4798 --*/
CREATE TRIGGER TGMVA2
AFTER INSERT OR UPDATE OR DELETE ON TT_MVA 
FOR EACH ROW EXECUTE PROCEDURE TGMVA2();


/*-- SEQ 4799 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGNCM() CASCADE;

/*-- SEQ 4800 --*/
CREATE OR REPLACE FUNCTION TGNCM() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1. Registrar mudanca dos dados em um "log"

   cLOG                          VARCHAR(4000)     := '';
   vFILUSU                       VARCHAR(3);
   vCODUSU                       VARCHAR(3);
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
      WK_CODUID                     TT_UID.CODUID%TYPE;
BEGIN 
   WK_CODUID := GetCoduidAtual();

   select * into QuemLogou from DadosLogon();
   vFILUSU := QuemLogou.FILUSU;
   vCODUSU := QuemLogou.CODUSU;

   -- Tratamento de log:
   -- 1 - No insert gera log para modelo
   -- 2 - No update gera log deixando de ser modelo para OLD e se tornando modelo para NEW
   -- 3 - No delete gera log deixando de ser modelo
   IF (TG_OP = 'INSERT') THEN
      IF ISNOTNULL(NEW.FILMAT)='T' THEN
      cLOG := cLOG || 'Se tornou modelo para NCM '||COALESCE(NEW.CODNCM,cNulo)||CRLF;
      END IF;
   ELSIF (TG_OP = 'UPDATE') THEN
      IF (Equal(OLD.FILMAT,NEW.FILMAT) <> 1) OR
         (Equal(OLD.CODMAT,NEW.CODMAT) <> 1) THEN

         cLOG := cLOG || 'Deixou de ser modelo para NCM '||COALESCE(NEW.CODNCM,cNulo)||CRLF;

         IF ISNOTNULL(NEW.FILMAT)='T' THEN
            cLOG := cLOG || 'Se tornou modelo para NCM '||COALESCE(NEW.CODNCM,cNulo)||CRLF;
         END IF; 
      END IF;

      -- Comentado pois atualmente no existe tabela especifica de LOG para NCM, 
      -- desta forma estava gravando na TL_PRO sem a chave do produto.
      --IF Equal(OLD.QTDLIM_PJ,NEW.QTDLIM_PJ) <> 1 THEN
      --   cLOG := cLOG ||'Quantidade Limite para Pessoa Jurdica: de '||COALESCE(TO_CHAR(OLD.QTDLIM_PJ,'fm999G999G999G990D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.QTDLIM_PJ,'fm999G999G999G990D0000'),cNulo)||CRLF;
      --END IF;

      --IF Equal(OLD.QTDLIM_PF,NEW.QTDLIM_PF) <> 1 THEN
      --   cLOG := cLOG ||'Quantidade Limite para Pessoa Fsica: de '||COALESCE(TO_CHAR(OLD.QTDLIM_PF,'fm999G999G999G990D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.QTDLIM_PF,'fm999G999G999G990D0000'),cNulo)||CRLF;
      --END IF;
   ELSIF (TG_OP = 'DELETE') THEN
      cLOG := cLOG || 'Deixou de ser modelo para NCM '||COALESCE(OLD.CODNCM,cNulo)||CRLF;
   END IF;

   -- Inclui uma linha em TL_PRO
   IF ISNOTNULL(cLOG)='T'  THEN
      IF (TG_OP = 'DELETE') THEN
         INSERT INTO TL_PRO (FILMAT,CODMAT,DATOPE,MSGLOG,FILUSU,CODUSU,CODUID)
         VALUES (OLD.FILMAT,OLD.CODMAT,agora(),cLOG,vFILUSU,vCODUSU,WK_CODUID);
      ELSE
         INSERT INTO TL_PRO (FILMAT,CODMAT,DATOPE,MSGLOG,FILUSU,CODUSU,CODUID)
         VALUES (NEW.FILMAT,NEW.CODMAT,agora(),cLOG,vFILUSU,vCODUSU,WK_CODUID);
      END IF;
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4801 --*/
CREATE TRIGGER TGNCM
AFTER INSERT OR UPDATE OR DELETE ON TT_NCM 
FOR EACH ROW EXECUTE PROCEDURE TGNCM(); 

/*-- SEQ 4802 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGNCM2() CASCADE;

/*-- SEQ 4803 --*/
CREATE OR REPLACE FUNCTION TGNCM2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Atualiza controles de data.

-- Principal
BEGIN

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') THEN
      NEW.DATINC := Agora();
   END IF;
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4804 --*/
CREATE TRIGGER TGNCM2
BEFORE INSERT OR UPDATE OR DELETE ON TT_NCM 
FOR EACH ROW EXECUTE PROCEDURE TGNCM2();


/*-- SEQ 4805 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGNMF1() CASCADE;

/*-- SEQ 4806 --*/
CREATE OR REPLACE FUNCTION TGNMF1() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Atualiza controles de data.

-- Declarao de variveis e cursores
   cCOMPLEMENTO                  CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');
   nPROXIMO                      Numeric;

-- Principal
BEGIN
      
   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      NEW.DATINC := Agora();
      SELECT NEXTVAL('SQNMF') INTO nPROXIMO FROM DUAL;
      IF(nPROXIMO > 9999999999) THEN
         RAISE EXCEPTION 'PG-20000 Cdigo atingiu o limite mximo de 10 posies. %' , cCOMPLEMENTO;
      ELSE
         NEW.ID_TAB := nPROXIMO;
      END IF;
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;


 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4807 --*/
CREATE TRIGGER TGNMF1
BEFORE INSERT OR UPDATE OR DELETE ON TT_NMF 
FOR EACH ROW EXECUTE PROCEDURE TGNMF1();


/*-- SEQ 4808 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGNUT() CASCADE;

/*-- SEQ 4809 --*/
CREATE OR REPLACE FUNCTION TGNUT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 2) Atualiza DATINC
-- 3) Atualiza ATU_EM

-- Principal
BEGIN

  IF (TG_OP = 'INSERT') THEN
     NEW.DATINC := AGORA();
  END IF;

  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     NEW.ATU_EM := AGORA();
  END IF;  

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4810 --*/
CREATE TRIGGER TGNUT
BEFORE INSERT OR UPDATE ON TT_NUT 
FOR EACH ROW EXECUTE PROCEDURE TGNUT();


/*-- SEQ 4811 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGOBS1() CASCADE;

/*-- SEQ 4812 --*/
CREATE OR REPLACE FUNCTION TGOBS1() RETURNS TRIGGER AS $$ 
DECLARE
BEGIN
  IF (TG_OP = 'INSERT') THEN 
     IF NEW.CODOBS IS NULL THEN
        NEW.CODOBS:=ProximoCodigo('TT_OBS',NEW.CODOBS);
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4813 --*/
CREATE TRIGGER TGOBS1
BEFORE INSERT ON TT_OBS 
FOR EACH ROW EXECUTE PROCEDURE TGOBS1();

/*-- SEQ 4814 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGOBS2() CASCADE;

/*-- SEQ 4815 --*/
CREATE OR REPLACE FUNCTION TGOBS2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 2) Registrar mudanca dos dados num "log"
   vLOG    VARCHAR(4000)     := '';
   vFILUSU VARCHAR(3);   
   vCODUSU VARCHAR(3);
   cNulo   CONSTANT CHAR(1)   := '0';
   CRLF    CONSTANT CHAR(1)   := CHR(10); 
    
    QuemLogou TRetQuemLogou%ROWTYPE;
    WK_CODUID TT_UID.CODUID%TYPE;
BEGIN
  WK_CODUID := GetCoduidAtual();

  select * into QuemLogou from DadosLogon();
  vFILUSU := QuemLogou.FILUSU;
  vCODUSU := QuemLogou.CODUSU;
   -- Tratamento de "log"
  IF (TG_OP = 'DELETE') THEN
     DELETE FROM TL_OBS WHERE CODOBS = OLD.CODOBS;
  END IF;
  -- Tratamento de log
  
  IF (TG_OP = 'INSERT') THEN
     vLOG := 'Inclusao';
     INSERT INTO TL_OBS (CODOBS,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
          VALUES(NEW.CODOBS,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);
  ELSIF (TG_OP = 'UPDATE') THEN IF Equal(OLD.CODOBS,NEW.CODOBS) <> 1 THEN
        vLOG := vLOG||'Cdigo da Observao: de '||COALESCE(OLD.CODOBS,0)||' para '||COALESCE(NEW.CODOBS,0)||CRLF;
     END IF;
     IF Equal(OLD.DESOBS,NEW.DESOBS) <> 1 THEN
        vLOG := vLOG||'Observao: de '||COALESCE(OLD.DESOBS,cNulo)||' para '||COALESCE(NEW.DESOBS,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.CODINT,NEW.CODINT) <> 1 THEN
        vLOG := vLOG||'Cdigo Interno da Observao na Totali: de '||COALESCE(OLD.CODINT,0)||' para '||COALESCE(NEW.CODINT,0)||CRLF;
     END IF;
     IF ISNOTNULL(trim(vLOG)) = 'T' THEN
        -- cadastra o LOG.
       INSERT INTO TL_OBS (CODOBS,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
          VALUES(NEW.CODOBS,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);
    END IF;  
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4816 --*/
CREATE TRIGGER TGOBS2
AFTER INSERT OR UPDATE OR DELETE ON TT_OBS 
FOR EACH ROW EXECUTE PROCEDURE TGOBS2(); 


/*-- SEQ 4817 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGOIP() CASCADE;

/*-- SEQ 4818 --*/
CREATE OR REPLACE FUNCTION TGOIP() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
   -- Gera um codigo automaticamente
   IF (TG_OP = 'INSERT') THEN 
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN:=ProximoCodigo('TT_OIP',NEW.CODFIL);
      END IF;
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      NEW.DATINC := Agora();
   END IF;
   IF (TG_OP = 'UPDATE') or (TG_OP = 'INSERT') THEN
      NEW.ATU_EM := Agora();
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4819 --*/
CREATE TRIGGER TGOIP
BEFORE INSERT OR UPDATE ON TT_OIP 
FOR EACH ROW EXECUTE PROCEDURE TGOIP();


/*-- SEQ 4820 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGOPE() CASCADE;

/*-- SEQ 4821 --*/
CREATE OR REPLACE FUNCTION TGOPE() RETURNS TRIGGER AS $$
DECLARE
  WK_UID TPC_UID_Retorno%ROWTYPE;

  vSESSIONID    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');
-- Principal
BEGIN

  WK_UID := GetUidAtual();

  IF (TG_OP = 'DELETE') THEN
    IF WK_UID.BLQ_SEM_UID = 'T' AND WK_UID.CODUID IS NULL THEN
       RAISE EXCEPTION 'PG-20027 Não é permitido deletar esse registro sem uma sessão de banco de dados válida. Sessão: %' , vSessionID;
    END IF;
  END IF;

  IF (TG_OP = 'INSERT') THEN
    IF WK_UID.BLQ_SEM_UID = 'T' AND WK_UID.CODUID IS NULL THEN
       RAISE EXCEPTION 'PG-20027 Não é permitido inserir um registro sem uma sessão de banco de dados válida. Sessão: %' , vSessionID;
    END IF;

    NEW.CODUID := WK_UID.CODUID;
    NEW.ASSINA := COALESCE(AssinaTabela('TT_OPE',
                                         ConcatenaOPE(NEW.CODFIL,
                                                      NEW.NUMECF,
                                                      NEW.TRN_ID,
                                                      NEW.VLROPE,
                                                      NEW.FILREC,
                                                      NEW.SEQREC,
                                                      NEW.FILCCC,
                                                      NEW.SEQCCC,
                                                      NEW.FILCHR,
                                                      NEW.SEQCHR,
                                                      NEW.FILFIN,
                                                      NEW.SEQFIN,
                                                      NEW.FILTEF,
                                                      NEW.SEQTEF,
                                                      NEW.CARTAO,
                                                      NEW.OUTROS,
                                                      NEW.CAMBIO,
                                                      NEW.FILDOP,
                                                      NEW.SEQDOP,
                                                      NEW.DOCTRO,
                                                      NEW.FILUSU,
                                                      NEW.CODUSU),
                                         null, null, null),NEW.ASSINA);
  END IF;


  IF (TG_OP = 'UPDATE') THEN
     IF ConcatenaOPE(NEW.CODFIL,NEW.NUMECF,NEW.TRN_ID,NEW.VLROPE,NEW.FILREC,NEW.SEQREC,
                     NEW.FILCCC,NEW.SEQCCC,NEW.FILCHR,NEW.SEQCHR,NEW.FILFIN,NEW.SEQFIN,NEW.FILTEF,
                     NEW.SEQTEF,NEW.CARTAO,NEW.OUTROS,NEW.CAMBIO,NEW.FILDOP,NEW.SEQDOP,NEW.DOCTRO,
                     NEW.FILUSU,NEW.CODUSU) <>
        ConcatenaOPE(OLD.CODFIL,OLD.NUMECF,OLD.TRN_ID,OLD.VLROPE,OLD.FILREC,OLD.SEQREC,
                     OLD.FILCCC,OLD.SEQCCC,OLD.FILCHR,OLD.SEQCHR,OLD.FILFIN,OLD.SEQFIN,OLD.FILTEF,
                     OLD.SEQTEF,OLD.CARTAO,OLD.OUTROS,OLD.CAMBIO,OLD.FILDOP,OLD.SEQDOP,OLD.DOCTRO,
                     OLD.FILUSU,OLD.CODUSU)
     THEN
        IF WK_UID.BLQ_SEM_UID = 'T' AND WK_UID.CODUID IS NULL THEN
          RAISE EXCEPTION 'PG-20027 Não é permitido modificar esse registro sem uma sessão de banco de dados válida. Sessão: %' , vSessionID;
        END IF;

          -- Douglas - 83441
        NEW.CODUID := WK_UID.CODUID;
        NEW.ASSINA := COALESCE(AssinaTabela('TT_OPE',
                                             ConcatenaOPE(NEW.CODFIL,
                                                          NEW.NUMECF,
                                                          NEW.TRN_ID,
                                                          NEW.VLROPE,
                                                          NEW.FILREC,
                                                          NEW.SEQREC,
                                                          NEW.FILCCC,
                                                          NEW.SEQCCC,
                                                          NEW.FILCHR,
                                                          NEW.SEQCHR,
                                                          NEW.FILFIN,
                                                          NEW.SEQFIN,
                                                          NEW.FILTEF,
                                                          NEW.SEQTEF,
                                                          NEW.CARTAO,
                                                          NEW.OUTROS,
                                                          NEW.CAMBIO,
                                                          NEW.FILDOP,
                                                          NEW.SEQDOP,
                                                          NEW.DOCTRO,
                                                          NEW.FILUSU,
                                                          NEW.CODUSU),
                                             OLD.CODUID,
                                             ConcatenaOPE(OLD.CODFIL,
                                                          OLD.NUMECF,
                                                          OLD.TRN_ID,
                                                          OLD.VLROPE,
                                                          OLD.FILREC,
                                                          OLD.SEQREC,
                                                          OLD.FILCCC,
                                                          OLD.SEQCCC,
                                                          OLD.FILCHR,
                                                          OLD.SEQCHR,
                                                          OLD.FILFIN,
                                                          OLD.SEQFIN,
                                                          OLD.FILTEF,
                                                          OLD.SEQTEF,
                                                          OLD.CARTAO,
                                                          OLD.OUTROS,
                                                          OLD.CAMBIO,
                                                          OLD.FILDOP,
                                                          OLD.SEQDOP,
                                                          OLD.DOCTRO,
                                                          OLD.FILUSU,
                                                          OLD.CODUSU),
                                             OLD.ASSINA),
                                NEW.ASSINA);
        END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4822 --*/
CREATE TRIGGER TGOPE
BEFORE INSERT OR DELETE OR UPDATE ON TT_OPE 
FOR EACH ROW EXECUTE PROCEDURE TGOPE();

/*-- SEQ 4823 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGOPE_ASS() CASCADE;

/*-- SEQ 4824 --*/
CREATE OR REPLACE FUNCTION TGOPE_ASS() RETURNS TRIGGER AS $$
DECLARE

 WK_DUMMY VARCHAR(2);

  -- RFMP 85136
  WK_UID TPC_UID_Retorno%ROWTYPE;

-- Atualiza a QTDREG.TT_ASS, Caso exista exclusão ou inclusão de registros.
BEGIN

  IF ExisteFilialNaUF('SC') THEN
     IF (TG_OP = 'INSERT') THEN
       -- RFMP 85136 Tratamento para não dar lock na TT_ASS
       WK_UID := GetUidAtual();
     
       IF WK_UID.ASSINS = 'T' THEN
         UPDATE TT_ASS
            SET QTDREG = QTDREG + 1
          WHERE NOMTAB = 'TT_OPE';
       ELSE
         WK_DUMMY := Insere_MASS('TT_OPE');
       END IF;
     END IF;
     
     IF (TG_OP = 'DELETE') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG - 1
        WHERE NOMTAB = 'TT_OPE';
     END IF;  
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4825 --*/
CREATE TRIGGER TGOPE_ASS
AFTER INSERT OR DELETE ON TT_OPE 
FOR EACH ROW EXECUTE PROCEDURE TGOPE_ASS();


/*-- SEQ 4826 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGORC() CASCADE;

/*-- SEQ 4827 --*/
CREATE OR REPLACE FUNCTION TGORC() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Tratar que NUMSER seja sempre informado ao concluir a OS
DECLARE
  Nome    TT_CFG.NOMNUMSER%TYPE;
  cFilCli TT_CFG.VC_FILCLI%TYPE;
  cCodCli TT_CFG.VC_CODCLI%TYPE;
  vComplemento Constant VARCHAR(100) := Constante('Complemento');
  LINHA     Numeric(5);
  vAberto   Numeric(5);
  vEntregue Numeric(5);
  vTotal    Numeric(5);

  vLOG  VARCHAR(4000)   := '';
  CRLF  CONSTANT CHAR(1) := CHR(10);
  NULO  CONSTANT CHAR(4) := 'Nulo';
  cOld	VARCHAR(255);
  cNew 	VARCHAR(255);

  --LEO 84337
  vCODUID_ATUAL TT_VEN.CODUID%TYPE;
  vBLQ_SEM_UID  TT_CFG.BLQ_SEM_UID%TYPE;
  vSESSIONID    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');
  
-- Principal
BEGIN

  if not (TG_OP = 'DELETE') then

    IF (TG_OP = 'UPDATE') THEN
      IF OLD.SIGNAT <> NEW.SIGNAT THEN
         RAISE EXCEPTION 'PG-20003 Oramento foi alterado por outro usurio. Refaa a consulta e tente gravar novamente.';
      END IF;
      IF NEW.FLGEST <> 'Z' THEN -- RFMP 76575 Para caso a package PCIVE ser acionada antes da gravao do oramento pelo Order (caso de alterao do tipo de entrega).
         NEW.SIGNAT := MOD(OLD.SIGNAT + 1,100000);
      END IF;
    END IF;

    -- "Desativa" FK com TD_APR quando for o caso
    IF NEW.APROVA = 'E' AND NEW.CHVAPR IS NOT NULL THEN
      NEW.CHVAPR := NULL;
    END IF;

	-- No permite alterar o campo ORCIMP
	IF (TG_OP = 'UPDATE') THEN
      IF (OLD.ORCIMP = 'T')  AND
	     (NEW.ORCIMP = 'F') THEN
	     RAISE EXCEPTION 'PG-20018 DAV j foi impressa, essa operao no pode ser desfeita.%' , vComplemento;
      END IF;
    END IF;

    -- Usado pelo Checkout
    IF NEW.FLGEST IN ('Y','Z') THEN
       SELECT SUM(CASE WHEN FLGEST in ('A','R') THEN 1 ELSE 0 END),
              SUM(CASE WHEN FLGEST in ('E') THEN 1 ELSE 0 END),
              COUNT(*) INTO vAberto, vEntregue,vTotal
         FROM TT_IOR
        WHERE CODFIL = NEW.CODFIL
          AND TIPPED = NEW.TIPPED
          AND NUMPED = NEW.NUMPED;

       IF (vAberto > 0) THEN
          NEW.FLGEST := 'A';
          vLOG := 'Faturamento parcial';
	   ELSE
          IF (vEntregue > 0) THEN
             NEW.FLGEST := 'E';
             vLOG := 'Faturamento total';
          ELSE
             NEW.FLGEST := 'C';
             vLOG := 'Cancelado';
          END IF;
       END IF;

       -- Voltar nmero do bloco ao reabrir comanda
       IF (TG_OP = 'UPDATE') THEN
         IF OLD.FLGEST='E' AND NEW.FLGEST='A'
            AND NEW.COMAND='T'
            AND NEW.NUMBLO IS NULL AND LENGTH(NEW.OBSERV)=8 THEN
             NEW.NUMBLO:=NEW.OBSERV;
             NEW.OBSERV:=null;
         END IF;
       END IF;
    ELSE
      -- Evitar que comandas entregues sejam reabertas
      IF (TG_OP = 'UPDATE') THEN
        IF OLD.FLGEST='E' AND NEW.FLGEST='A'
           AND NEW.COMAND='T' THEN
               RAISE EXCEPTION 'PG-20060 Comanda Entregue no pode ser re-aberta. %' , vComplemento;
        END IF;
      END IF;
    END IF;

    if NEW.FLGEST = 'X' then
       NEW.FLGEST := 'C';
    elsif NEW.FLGEST = 'C' then
        UPDATE TT_IOR
           SET FLGEST='C',
               DUMMY = Constante('VEM_DE_TGORC')
         WHERE CODFIL=NEW.codfil
           AND TIPPED=NEW.tipped
           AND NUMPED=NEW.numped;
    end if;

    NEW.NUMSER := lTrim( rTrim( NEW.NUMSER ));

/* DN 71830 - Tratamento antigo para Telefnica
    if  (NEW.NUMSER is null)
    and (NEW.FLGEST = 'E')
    and (NEW.TIPPED = 'S') THEN
      select NOMNUMSER into Nome from TT_CFG;
      RAISE EXCEPTION 'PG-20027 O.S. concluidas obrigam que seja informado %. %' , Nome,vComplemento;
    end if;
*/

    if NEW.FILALC is null THEN
       NEW.FILALC := NEW.CODFIL;
    end if;

    if (NEW.PED_EM IS NULL) then
      NEW.PED_EM := agora();
    end if;

    IF (TG_OP = 'UPDATE') then
      if (NEW.ATU_EM <> COALESCE(OLD.ATU_EM,ADD_DAY(NEW.ATU_EM,1))) then
        NEW.ATU_EM := agora();
      end if;
    end if;
    
    -- Controle da Data de Atualizao  realizado pela aplicao adicionado na Trigger para deixar documentado o contexto
    --IF (COALESCE(NEW.DUMMY, 'X') <> '%') THEN
    --  IF (NEW.ATU_EM = OLD.ATU_EM) THEN
    --    NEW.ATU_EM := agora();
    --END IF;
    
    IF (TG_OP = 'INSERT') THEN
      NEW.EXPORT := 'F';
    ELSIF  (Equal(NEW.CODFIL,OLD.CODFIL) = 0 OR
            Equal(NEW.TIPPED,OLD.TIPPED) = 0 OR
            Equal(NEW.NUMPED,OLD.NUMPED) = 0 OR
            Equal(NEW.FILCLI,OLD.FILCLI) = 0 OR
            Equal(NEW.CODCLI,OLD.CODCLI) = 0 OR
            Equal(NEW.FLGEST,OLD.FLGEST) = 0 OR
            Equal(NEW.FILUSU,OLD.FILUSU) = 0 OR
            Equal(NEW.CODUSU,OLD.CODUSU) = 0 OR
            Equal(NEW.FILVEN,OLD.FILVEN) = 0 OR
            Equal(NEW.CODVEN,OLD.CODVEN) = 0 OR
            Equal(NEW.FILPGT,OLD.FILPGT) = 0 OR
            Equal(NEW.CODPGT,OLD.CODPGT) = 0 OR
            Equal(NEW.VLRPAR,OLD.VLRPAR) = 0 OR
            Equal(NEW.VLRTOT,OLD.VLRTOT) = 0 OR
            Equal(NEW.VLRDES,OLD.VLRDES) = 0 OR
            Equal(NEW.TIPENT,OLD.TIPENT) = 0 OR
            Equal(NEW.NUMENT,OLD.NUMENT) = 0 OR
            Equal(NEW.NUMCOB,OLD.NUMCOB) = 0 OR
            Equal(NEW.NUMFAT,OLD.NUMFAT) = 0 OR
            Equal(NEW.CODPRE,OLD.CODPRE) = 0 OR
            Equal(NEW.QTDPAR,OLD.QTDPAR) = 0 OR
            Equal(NEW.VLRFRE,OLD.VLRFRE) = 0 OR
            Equal(NEW.VLRSEG,OLD.VLRSEG) = 0 OR
            Equal(NEW.APROVA,OLD.APROVA) = 0 OR
            Equal(NEW.APRCLI,OLD.APRCLI) = 0 OR
            Equal(NEW.TELEVE,OLD.TELEVE) = 0 OR
            Equal(NEW.VLRADI,OLD.VLRADI) = 0 OR
            Equal(NEW.VLRSAD,OLD.VLRSAD) = 0 OR
            Equal(NEW.TRNECF,OLD.TRNECF) = 0 OR
            Equal(NEW.TRN_ID,OLD.TRN_ID) = 0 OR
            Equal(NEW.NUMPED_RE,OLD.NUMPED_RE) = 0
            ) AND (COALESCE(NEW.DUMMY, 'X') <> '%') THEN
      NEW.EXPORT := 'F';
    END IF;
  end if;

  -- altera flgivo para reprocessar as separacoes
  IF (TG_OP = 'UPDATE') THEN
    UPDATE TT_IOR
       SET FLGIVO = CASE WHEN NEW.TIPENT IN ('0','6')
                         THEN NULL
                         ELSE 'A'
                    END,
                    DUMMY = Constante('VEM_DE_TGORC') -- Rhuan - 102894
     WHERE CODFIL = NEW.CODFIL
       AND TIPPED = NEW.TIPPED
       AND NUMPED = NEW.NUMPED
       AND FLGIVO = 'P'
       AND FLGEST IN ('A','T','R');
  END IF;

  -- Evitar lancamentos fora do periodo de validade
  IF not (TG_OP = 'DELETE') THEN
    IF NEW.TIPPED IN ('O','P') THEN
      IF not (Livre(NEW.CODFIL,'TT_ORC',NEW.PED_EM) = 1) THEN
        RAISE EXCEPTION 'PG-20039 Lancamento fora do periodo de validade de uso do sistema. %' , vComplemento;
      END IF;
    ELSE
      IF not (Livre(NEW.CODFIL,'TT_ORC*',NEW.PED_EM) = 1) THEN
        RAISE EXCEPTION 'PG-20039 Lancamento fora do periodo de validade de uso do sistema. %' , vComplemento;
      END IF;
    END IF;
  END IF;

  -- Tratamento de vLOG
  IF (TG_OP = 'UPDATE') THEN
    IF ISNOTNULL(vLOG) = 'T' THEN
      INSERT INTO TL_ORC (CODFIL,TIPPED,NUMPED,TIPLOG,DATOPE,MSGLOG)
                  VALUES (NEW.CODFIL,NEW.TIPPED,NEW.NUMPED,'F',Agora(),vLOG);

    ELSIF Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
      vLOG := 'Situao: de '||COALESCE(DescricaoDominio('ORC','FLGEST',OLD.FLGEST),Nulo)||' para '||COALESCE(DescricaoDominio('ORC','FLGEST',NEW.FLGEST),Nulo);

      INSERT INTO TL_ORC (CODFIL,TIPPED,NUMPED,TIPLOG,DATOPE,MSGLOG)
                  VALUES (NEW.CODFIL,NEW.TIPPED,NEW.NUMPED,'F',Agora(),vLOG);
    END IF;

    IF Equal(OLD.APRCLI,NEW.APRCLI) <> 1 THEN
      vLOG := 'Aprovacao do cliente: de '||COALESCE(DescricaoDominio('ORC','APRCLI',OLD.APRCLI),Nulo)||' para '||COALESCE(DescricaoDominio('ORC','APRCLI',NEW.APRCLI),Nulo);

      INSERT INTO TL_ORC (CODFIL,TIPPED,NUMPED,TIPLOG,DATOPE,MSGLOG)
                  VALUES (NEW.CODFIL,NEW.TIPPED,NEW.NUMPED,'F',Agora(),vLOG);
    END IF;

    IF Equal(OLD.APROVA,NEW.APROVA) <> 1 THEN
      vLOG := 'Tipo de aprovacao: de '||COALESCE(DescricaoDominio('ORC','APROVA',OLD.APROVA),Nulo)||' para '||COALESCE(DescricaoDominio('ORC','APROVA',NEW.APROVA),Nulo);

      INSERT INTO TL_ORC (CODFIL,TIPPED,NUMPED,TIPLOG,DATOPE,MSGLOG)
                  VALUES (NEW.CODFIL,NEW.TIPPED,NEW.NUMPED,'F',Agora(),vLOG);
    END IF;

    vLOG := '';

    IF Equal(OLD.OBSORC,NEW.OBSORC) <> 1 THEN
      INSERT INTO TL_ORC (CODFIL,TIPPED,NUMPED,TIPLOG,DATOPE,MSGLOG)
                  VALUES (NEW.CODFIL,NEW.TIPPED,NEW.NUMPED,'F',Agora(),CASE WHEN ISNULL(OLD.OBSORC)='T' THEN Nulo ELSE OLD.OBSORC END);
    END IF;
    IF Equal(OLD.DATSEG,NEW.DATSEG) <> 1 THEN
      vLOG := vLOG||'Data da 2.a parcela: de '||COALESCE(TO_CHAR(OLD.DATSEG,'DD/MM/YYYY'),NULO)||' para '||COALESCE(TO_CHAR(NEW.DATSEG,'DD/MM/YYYY'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.CHVAPR,NEW.CHVAPR) <> 1 THEN
      vLOG := vLOG||'Chave Aprovacao: de '||COALESCE(TO_CHAR(OLD.CHVAPR,'fm99990'),NULO)||' para '||COALESCE(TO_CHAR(NEW.CHVAPR,'fm99990'),NULO)||CRLF;
    END IF;
    IF (Equal(OLD.FILTRA,NEW.FILTRA) <> 1) OR (Equal(OLD.CODTRA,NEW.CODTRA) <> 1) THEN
      IF ISNULL(NEW.FILTRA)='T' OR ISNULL(NEW.CODTRA)='T' THEN
        cNew := NULO;
      ELSE
        SELECT COALESCE(NOMCLI,Nulo) INTO cNew FROM TT_CLI WHERE FILCLI = NEW.FILTRA AND CODCLI = NEW.CODTRA;
      END IF;
      IF ISNULL(OLD.FILTRA)='T' OR ISNULL(OLD.CODTRA)='T' THEN
        cOld := NULO;
      ELSE
        SELECT COALESCE(NOMCLI,Nulo) INTO cOld FROM TT_CLI WHERE FILCLI = OLD.FILTRA AND CODCLI = OLD.CODTRA;
      END IF;
      vLOG := vLOG||'Transportadora: de '||COALESCE(OLD.FILTRA||'/'||TRIM(OLD.CODTRA)||' - '||cOld,NULO)||' para '||COALESCE(NEW.FILTRA||'/'||TRIM(NEW.CODTRA)||' - '||cNew,NULO)||CRLF;
    END IF;
    IF Equal(OLD.EMIDES,NEW.EMIDES) <> 1 THEN
      select CASE OLD.EMIDES WHEN 'T' THEN 'Destinatario'
                              WHEN 'F' THEN 'Emitente'
                                                  ELSE Nulo
      END into cOld from dual;
      select CASE NEW.EMIDES WHEN 'T' THEN 'Destinatario'
                              WHEN 'F' THEN 'Emitente'
                                                  ELSE Nulo
      END into cNew from dual;
      vLOG := vLOG||'Frete pelo emitente ou pelo destinatario: de '||COALESCE(cOld,NULO)||' para '||COALESCE(cNew,NULO)||CRLF;
    END IF;
    IF Equal(OLD.NUMNOT,NEW.NUMNOT) <> 1 THEN
      vLOG := vLOG||'Nota do fornecedor terceirizado: de '||COALESCE(OLD.NUMNOT,NULO)||' para '||COALESCE(NEW.NUMNOT,NULO)||CRLF;
    END IF;
    IF Equal(OLD.NUMLOT,NEW.NUMLOT) <> 1 THEN
      vLOG := vLOG||'Numero do lote: de '||COALESCE(TO_CHAR(OLD.NUMLOT,'fm9999999990'),nulo)||' para '||COALESCE(TO_CHAR(NEW.NUMLOT,'fm9999999990'),nulo)||CRLF;
    END IF;
    IF Equal(OLD.LOJORI,NEW.LOJORI) <> 1 THEN
      vLOG := vLOG||'Loja de origem: de '||COALESCE(OLD.LOJORI,NULO)||' para '||COALESCE(NEW.LOJORI,NULO)||CRLF;
    END IF;
    IF Equal(OLD.NUMORI,NEW.NUMORI) <> 1 THEN
      vLOG := vLOG||'Numero da loja de origem: de '||COALESCE(OLD.NUMORI,NULO)||' para '||COALESCE(NEW.NUMORI,NULO)||CRLF;
    END IF;
    IF Equal(OLD.CODPGT,NEW.CODPGT) <> 1 THEN
      SELECT COALESCE(TRIM(APEPGT),Nulo) INTO cNew FROM TT_PLA WHERE FILPGT = NEW.FILPGT AND CODPGT = NEW.CODPGT;
      SELECT COALESCE(TRIM(APEPGT),Nulo) INTO cOld FROM TT_PLA WHERE FILPGT = OLD.FILPGT AND CODPGT = OLD.CODPGT;
      vLOG := vLOG||'Plano: de '||COALESCE(cOld,NULO)||' para '||COALESCE(cNew,NULO)||CRLF;
    END IF;
    IF Equal(OLD.SINALP,NEW.SINALP) <> 1 THEN
      vLOG := vLOG||'Sinal pago ou valor dos itens: de '||COALESCE(TO_CHAR(OLD.SINALP,'fm999G999G990D00'),nulo)||' para '||COALESCE(TO_CHAR(NEW.SINALP,'fm999G999G990D00'),nulo)||CRLF;
    END IF;
    IF Equal(OLD.SINAL ,NEW.SINAL ) <> 1 THEN
      vLOG := vLOG||'Sinal ou entrada: de '||COALESCE(TO_CHAR(OLD.SINAL,'fm999G999G990D00'),NULO)||' para '||COALESCE(TO_CHAR(NEW.SINAL,'fm999G999G990D00'),NULO)||CRLF;
    END IF;

    IF Equal(OLD.DESCLI,NEW.DESCLI) <> 1 THEN
      select CASE OLD.DESCLI WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                                                  ELSE Nulo
      END into cOld from dual;
      select CASE NEW.DESCLI WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                                                  ELSE Nulo
      END into cNew from dual;
      vLOG := vLOG||'Desconto especial para cliente: de '||COALESCE(cOld,NULO)||' para '||COALESCE(cNew,NULO)||CRLF;
    END IF;
    IF Equal(OLD.VLRPAR,NEW.VLRPAR) <> 1 THEN
      vLOG := vLOG||'Valor da parcela: de '||COALESCE(TO_CHAR(OLD.VLRPAR,'fm999G999G990D00'),NULO)||' para '||COALESCE(TO_CHAR(NEW.VLRPAR,'fm999G999G990D00'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.TIPENT,NEW.TIPENT) <> 1 THEN
      vLOG := vLOG||'Tipo de entrega: de '||COALESCE(DescricaoDominio('ORC','TIPENT',OLD.TIPENT),Nulo)||' para '||COALESCE(DescricaoDominio('ORC','TIPENT',NEW.TIPENT),Nulo)||CRLF;
    END IF;
    IF Equal(OLD.QTDPAR,NEW.QTDPAR) <> 1 THEN
      vLOG := vLOG||'Quantidade de parcelas: de '||COALESCE(TO_CHAR(OLD.QTDPAR,'fm9G990'),NULO)||' para '||COALESCE(TO_CHAR(NEW.QTDPAR,'fm9G990'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.VLRDES,NEW.VLRDES) <> 1 THEN
      vLOG := vLOG||'Valor do desconto: de '||COALESCE(TO_CHAR(OLD.VLRDES,'fm999G999G990D00'),NULO)||' para '||COALESCE(TO_CHAR(NEW.VLRDES,'fm999G999G990D00'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.DATPRI,NEW.DATPRI) <> 1 THEN
      vLOG := vLOG||'Data da 1.a parcela: de '||COALESCE(TO_CHAR(OLD.DATPRI,'DD/MM/YYYY'),NULO)||' para '||COALESCE(TO_CHAR(NEW.DATPRI,'DD/MM/YYYY'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.NATURE,NEW.NATURE) <> 1 THEN
      vLOG := vLOG||'Natureza do pagamento: de '||COALESCE(DescricaoDominio('ORC','NATURE',OLD.NATURE),Nulo)||' para '||COALESCE(DescricaoDominio('ORC','NATURE',NEW.NATURE),Nulo)||CRLF;
    END IF;
    IF Equal(OLD.CODFIN,NEW.CODFIN) <> 1 THEN
      SELECT COALESCE(TRIM(DESFIN),Nulo) INTO cNew FROM TD_FIN WHERE CODTAB = NEW.CODFIN;
      SELECT COALESCE(TRIM(DESFIN),Nulo) INTO cOld FROM TD_FIN WHERE CODTAB = OLD.CODFIN;
      vLOG := vLOG||'Financeira: de '||COALESCE(cNew,NULO)||' para '||COALESCE(cOld,NULO)||CRLF;
    END IF;
    IF (Equal(OLD.FILPRE,NEW.FILPRE) <> 1) OR (Equal(OLD.CODPRE,NEW.CODPRE) <> 1) THEN
      SELECT COALESCE(TRIM(DESPRE),Nulo) INTO cNew FROM TT_TPR WHERE CODFIL = NEW.FILPRE AND CODPRE = NEW.CODPRE;
      SELECT COALESCE(TRIM(DESPRE),Nulo) INTO cOld FROM TT_TPR WHERE CODFIL = OLD.FILPRE AND CODPRE = OLD.CODPRE;
      vLOG := vLOG||'Tabela de precos: de '||COALESCE(cOld,NULO)||' para '||COALESCE(cNew,NULO)||CRLF;
    END IF;
    IF Equal(OLD.LABORI,NEW.LABORI) <> 1 THEN
      vLOG := vLOG||'Laboratorio de origem: de '||COALESCE(OLD.LABORI,NULO)||' para '||COALESCE(NEW.LABORI,NULO)||CRLF;
    END IF;
    IF Equal(OLD.NUMLOR,NEW.NUMLOR) <> 1 THEN
      vLOG := vLOG||'Numero do lote de retorno: de '||COALESCE(TO_CHAR(OLD.NUMLOR,'fm9G999G999G990'),NULO)||' para '||COALESCE(TO_CHAR(NEW.NUMLOR,'fm9G999G999G990'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.FILVEN,NEW.FILVEN) <> 1 THEN
      vLOG := vLOG||'Filial do vendedor: de '||COALESCE(OLD.FILVEN,NULO)||' para '||COALESCE(NEW.FILVEN,NULO)||CRLF;
    END IF;
    IF (Equal(OLD.FILVEN,NEW.FILVEN) <> 1) OR (Equal(OLD.CODVEN,NEW.CODVEN) <> 1) THEN
      SELECT COALESCE(TRIM(APEUSU),Nulo) INTO cNew FROM TT_USU WHERE FILUSU = NEW.FILVEN AND CODUSU = NEW.CODVEN;
      SELECT COALESCE(TRIM(APEUSU),Nulo) INTO cOld FROM TT_USU WHERE FILUSU = OLD.FILVEN AND CODUSU = OLD.CODVEN;
      vLOG := vLOG||'Vendedor: de '||COALESCE(cOld,NULO)||' para '||COALESCE(cNew,NULO)||CRLF;
    END IF;
    IF (Equal(OLD.FILUSU,NEW.FILUSU) <> 1) OR (Equal(OLD.CODUSU,NEW.CODUSU) <> 1) THEN
      SELECT COALESCE(TRIM(APEUSU),Nulo) INTO cNew FROM TT_USU WHERE FILUSU = NEW.FILUSU AND CODUSU = NEW.CODUSU;
      SELECT COALESCE(TRIM(APEUSU),Nulo) INTO cOld FROM TT_USU WHERE FILUSU = OLD.FILUSU AND CODUSU = OLD.CODUSU;
      vLOG := vLOG||'Usuario: de '||COALESCE(cOld,NULO)||' para '||COALESCE(cNew,NULO)||CRLF;
    END IF;
    IF (Equal(OLD.FILAPR,NEW.FILAPR) <> 1) OR (Equal(OLD.CODAPR,NEW.CODAPR) <> 1) THEN
      SELECT COALESCE(TRIM(APEUSU),Nulo) INTO cNew FROM TT_USU WHERE FILUSU = NEW.FILAPR AND CODUSU = NEW.CODAPR;
      SELECT COALESCE(TRIM(APEUSU),Nulo) INTO cOld FROM TT_USU WHERE FILUSU = OLD.FILAPR AND CODUSU = OLD.CODAPR;
      vLOG := vLOG||'Aprovacao feita por: de '||COALESCE(cOld,NULO)||' para '||COALESCE(cNew,NULO)||CRLF;
    END IF;
    IF Equal(OLD.OBSERV,NEW.OBSERV) <> 1 THEN
      INSERT INTO TL_ORC (CODFIL,TIPPED,NUMPED,TIPLOG,DATOPE,MSGLOG)
                  VALUES (NEW.CODFIL,NEW.TIPPED,NEW.NUMPED,'F',Agora(),CASE WHEN ISNULL(OLD.OBSERV)='T' THEN Nulo ELSE OLD.OBSERV END);
    END IF;
    IF Equal(OLD.NUMAUT,NEW.NUMAUT) <> 1 THEN
      vLOG := vLOG||'Numero da aprovacao: de '||COALESCE(OLD.NUMAUT,NULO)||' para '||COALESCE(NEW.NUMAUT,NULO)||CRLF;
    END IF;
    IF Equal(OLD.NUMRES,NEW.NUMRES) <> 1 THEN
      vLOG := vLOG||'Numero de reserva: de '||COALESCE(OLD.NUMRES,NULO)||' para '||COALESCE(NEW.NUMRES,NULO)||CRLF;
    END IF;
    IF Equal(OLD.TIPOBS,NEW.TIPOBS) <> 1 THEN
      vLOG := vLOG||'Observacao padrao: de '||COALESCE(OLD.TIPOBS,NULO)||' para '||COALESCE(NEW.TIPOBS,NULO)||CRLF;
    END IF;
    IF Equal(OLD.RESERV,NEW.RESERV) <> 1 THEN
      vLOG := vLOG||'Reserva o estoque (Verdadeiro/Falso): de '||COALESCE(OLD.RESERV,NULO)||' para '||COALESCE(NEW.RESERV,NULO)||CRLF;
    END IF;
    IF Equal(OLD.SIGNAT,NEW.SIGNAT) <> 1 THEN
      vLOG := vLOG||'Controle de "lock": de '||COALESCE(TO_CHAR(OLD.SIGNAT,'fm99990'),NULO)||' para '||COALESCE(TO_CHAR(NEW.SIGNAT,'fm99990'),NULO)||CRLF;
    END IF;
    IF (Equal(OLD.FILENT,NEW.FILENT) <> 1) OR (Equal(OLD.NUMENT,NEW.NUMENT) <> 1) THEN
      SELECT COALESCE(TRIM(ENDERE),Nulo) INTO cNew FROM TT_END WHERE FILCLI = NEW.FILCLI AND CODCLI = NEW.CODCLI AND CODFIL = NEW.FILENT AND NUMEND = NEW.NUMENT;
      SELECT COALESCE(TRIM(ENDERE),Nulo) INTO cOld FROM TT_END WHERE FILCLI = OLD.FILCLI AND CODCLI = OLD.CODCLI AND CODFIL = OLD.FILENT AND NUMEND = OLD.NUMENT;
      vLOG := vLOG||'Endereco de Entrega: de '||COALESCE(cOld,NULO)||' para '||COALESCE(cNew,NULO)||CRLF;
    END IF;
    IF (Equal(OLD.FILFAT,NEW.FILFAT) <> 1) OR (Equal(OLD.NUMFAT,NEW.NUMFAT) <> 1) THEN
      IF ((NEW.FILFAT IS NULL) OR (NEW.NUMFAT IS NULL)) THEN cNew := Nulo; ELSE
	     SELECT COALESCE(TRIM(ENDERE),Nulo) INTO cNew FROM TT_END WHERE FILCLI = NEW.FILCLI AND CODCLI = NEW.CODCLI AND CODFIL = NEW.FILFAT AND NUMEND = NEW.NUMFAT;
	  END IF;
	  IF ((OLD.FILFAT IS NULL) OR (OLD.NUMFAT IS NULL)) THEN cOld := Nulo; ELSE
	     SELECT COALESCE(TRIM(ENDERE),Nulo) INTO cOld FROM TT_END WHERE FILCLI = OLD.FILCLI AND CODCLI = OLD.CODCLI AND CODFIL = OLD.FILFAT AND NUMEND = OLD.NUMFAT;
	  END IF;
	  vLOG := vLOG||'Endereco de Fatura: de '||COALESCE(cOld,NULO)||' para '||COALESCE(cNew,NULO)||CRLF;
    END IF;
    IF (Equal(OLD.FILCOB,NEW.FILCOB) <> 1) OR (Equal(OLD.NUMCOB,NEW.NUMCOB) <> 1) THEN
      SELECT COALESCE(TRIM(ENDERE),Nulo) INTO cNew FROM TT_END WHERE FILCLI = NEW.FILCLI AND CODCLI = NEW.CODCLI AND CODFIL = NEW.FILCOB AND NUMEND = NEW.NUMCOB;
      SELECT COALESCE(TRIM(ENDERE),Nulo) INTO cOld FROM TT_END WHERE FILCLI = OLD.FILCLI AND CODCLI = OLD.CODCLI AND CODFIL = OLD.FILCOB AND NUMEND = OLD.NUMCOB;
      vLOG := vLOG||'Endereco de Fatura: de '||COALESCE(cOld,NULO)||' para '||COALESCE(cNew,NULO)||CRLF;
    END IF;
    IF Equal(OLD.NUMSER,NEW.NUMSER) <> 1 THEN
      vLOG := vLOG||'Numero de serie: de '||COALESCE(OLD.NUMSER,NULO)||' para '||COALESCE(NEW.NUMSER,NULO)||CRLF;
    END IF;
    IF Equal(OLD.FILALC,NEW.FILALC) <> 1 THEN
      vLOG := vLOG||'Filial alocada: de '||COALESCE(OLD.FILALC,NULO)||' para '||COALESCE(NEW.FILALC,NULO)||CRLF;
    END IF;
    IF Equal(OLD.FILREG,NEW.FILREG) <> 1 THEN
      vLOG := vLOG||'Codigo da filial do registro: de '||COALESCE(OLD.FILREG,NULO)||' para '||COALESCE(NEW.FILREG,NULO)||CRLF;
    END IF;
    IF Equal(OLD.CODREG,NEW.CODREG) <> 1 THEN
      vLOG := vLOG||'Codigo registro: de '||COALESCE(OLD.CODREG,NULO)||' para '||COALESCE(NEW.CODREG,NULO)||CRLF;
    END IF;
    IF Equal(OLD.ABATIM,NEW.ABATIM) <> 1 THEN
      vLOG := vLOG||'Abatimento: de '||COALESCE(TO_CHAR(OLD.ABATIM,'fm9G999G999G990D00'),NULO)||' para '||COALESCE(TO_CHAR(NEW.ABATIM,'fm9G999G999G990D00'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.CODEXT,NEW.CODEXT) <> 1 THEN
      vLOG := vLOG||'Codigo externo: de '||COALESCE(OLD.CODEXT,NULO)||' para '||COALESCE(NEW.CODEXT,NULO)||CRLF;
    END IF;
    IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
      vLOG := vLOG||'Codigo da filial de origem: de '||COALESCE(OLD.CODFIL,NULO)||' para '||COALESCE(NEW.CODFIL,NULO)||CRLF;
    END IF;
    IF Equal(OLD.TIPPED,NEW.TIPPED) <> 1 THEN
      vLOG := vLOG||'Tipo do pedido: de '||COALESCE(DescricaoDominio('ORC','TIPPED',OLD.TIPPED),Nulo)||' para '||COALESCE(DescricaoDominio('ORC','TIPPED',NEW.TIPPED),Nulo)||CRLF;
    END IF;
    IF Equal(OLD.NUMPED,NEW.NUMPED) <> 1 THEN
      vLOG := vLOG||'Numero do pedido: de '||COALESCE(OLD.NUMPED,NULO)||' para '||COALESCE(NEW.NUMPED,NULO)||CRLF;
    END IF;
    IF (Equal(OLD.FILCLI,NEW.FILCLI) <> 1) OR (Equal(OLD.CODCLI,NEW.CODCLI) <> 1) THEN
      SELECT COALESCE(TRIM(NOMCLI||' '||ULTNOM),Nulo) INTO cNew FROM TT_CLI WHERE FILCLI = NEW.FILCLI AND CODCLI = NEW.CODCLI;
      SELECT COALESCE(TRIM(NOMCLI||' '||ULTNOM),Nulo) INTO cOld FROM TT_CLI WHERE FILCLI = OLD.FILCLI AND CODCLI = OLD.CODCLI;
      vLOG := vLOG||'Cliente: de '||COALESCE(OLD.FILCLI||'/'||TRIM(OLD.CODCLI)||' - '||cOld,NULO)||' para '||COALESCE(NEW.FILCLI||'/'||TRIM(NEW.CODCLI)||' - '||cNew,NULO)||CRLF;
    END IF;
    IF Equal(OLD.PED_EM,NEW.PED_EM) <> 1 THEN
      vLOG := vLOG||'Data e hora do pedido: de '||COALESCE(TO_CHAR(OLD.PED_EM,'DD/MM/YYYY HH24:MI:SS'),NULO)||' para '||COALESCE(TO_CHAR(NEW.PED_EM,'DD/MM/YYYY HH24:MI:SS'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.DATENT,NEW.DATENT) <> 1 THEN
      vLOG := vLOG||'Data da entrega (prevista): de '||COALESCE(TO_CHAR(OLD.DATENT,'DD/MM/YYYY'),NULO)||' para '||COALESCE(TO_CHAR(NEW.DATENT,'DD/MM/YYYY'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.NUMECF,NEW.NUMECF) <> 1 THEN
      vLOG := vLOG||'Numero do ECF: de '||COALESCE(OLD.NUMECF,NULO)||' para '||COALESCE(NEW.NUMECF,NULO)||CRLF;
    END IF;
    IF Equal(OLD.CUPFIS,NEW.CUPFIS) <> 1 THEN
      vLOG := vLOG||'Numero do cupom fiscal: de '||COALESCE(OLD.CUPFIS,NULO)||' para '||COALESCE(NEW.CUPFIS,NULO)||CRLF;
    END IF;
    IF Equal(OLD.DATVAL,NEW.DATVAL) <> 1 THEN
      vLOG := vLOG||'Data de validade do pedido: de '||COALESCE(TO_CHAR(OLD.DATVAL,'DD/MM/YYYY'),NULO)||' para '||COALESCE(TO_CHAR(NEW.DATVAL,'DD/MM/YYYY'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.VLRTOT,NEW.VLRTOT) <> 1 THEN
      vLOG := vLOG||'Valor total do pedido: de '||COALESCE(TRIM(TO_CHAR(OLD.VLRTOT,'9G999G999G990D00')),NULO)||' para '||COALESCE(TRIM(TO_CHAR(NEW.VLRTOT,'9G999G999G990D00')),NULO)||CRLF;
    END IF;
    IF Equal(OLD.NUMBLO,NEW.NUMBLO) <> 1 THEN
      vLOG := vLOG||'Numero do Bloco: de '||COALESCE(OLD.NUMBLO,NULO)||' para '||COALESCE(NEW.NUMBLO,NULO)||CRLF;
    END IF;
    IF Equal(OLD.NUMVOL,NEW.NUMVOL) <> 1 THEN
      vLOG := vLOG||'Numero de Volumes: de '||COALESCE(TO_CHAR(OLD.NUMVOL,'9G999G999G990'),NULO)||' para '||COALESCE(TO_CHAR(NEW.NUMVOL,'9G999G999G990'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.MARCAS,NEW.MARCAS) <> 1 THEN
      vLOG := vLOG||'Marcas: de '||COALESCE(OLD.MARCAS,NULO)||' para '||COALESCE(NEW.MARCAS,NULO)||CRLF;
    END IF;
    IF Equal(OLD.VLRSEG,NEW.VLRSEG) <> 1 THEN
      vLOG := vLOG||'Valor do seguro: de '||COALESCE(TO_CHAR(OLD.VLRSEG,'9G999G999G990D00'),NULO)||' para '||COALESCE(TO_CHAR(NEW.VLRSEG,'9G999G999G990D00'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.VLRFRE,NEW.VLRFRE) <> 1 THEN
      vLOG := vLOG||'Valor do frete: de '||COALESCE(TO_CHAR(OLD.VLRFRE,'9G999G999G990D00'),NULO)||' para '||COALESCE(TO_CHAR(NEW.VLRFRE,'9G999G999G990D00'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.PESBRU,NEW.PESBRU) <> 1 THEN
      vLOG := vLOG||'Peso bruto: de '||COALESCE(TO_CHAR(OLD.PESBRU,'9G999G999G990D0000'),NULO)||' para '||COALESCE(TO_CHAR(NEW.PESBRU,'9G999G999G990D0000'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.PESBRU_ENT,NEW.PESBRU_ENT) <> 1 THEN
      vLOG := vLOG||'Peso bruto p/ Entrega: de '||COALESCE(TO_CHAR(OLD.PESBRU_ENT,'9G999G999G990D0000'),NULO)||' para '||COALESCE(TO_CHAR(NEW.PESBRU_ENT,'9G999G999G990D0000'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.PESLIQ,NEW.PESLIQ) <> 1 THEN
      vLOG := vLOG||'Peso liquido: de '||COALESCE(TO_CHAR(OLD.PESLIQ,'9G999G999G990D0000'),NULO)||' para '||COALESCE(TO_CHAR(NEW.PESLIQ,'9G999G999G990D0000'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.ESPECI,NEW.ESPECI) <> 1 THEN
      vLOG := vLOG||'Especie de volume: de '||COALESCE(TO_CHAR(OLD.ESPECI,'99999'),NULO)||' para '||COALESCE(TO_CHAR(NEW.ESPECI,'99999'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.PLACAS,NEW.PLACAS) <> 1 THEN
      vLOG := vLOG||'Placas: de '||COALESCE(OLD.PLACAS,NULO)||' para '||COALESCE(NEW.PLACAS,NULO)||CRLF;
    END IF;
    IF Equal(OLD.QTD_KM,NEW.QTD_KM) <> 1 THEN
      vLOG := vLOG||'Quilometros: de '||COALESCE(TO_CHAR(OLD.QTD_KM,'9G999G999'),NULO)||' para '||COALESCE(TO_CHAR(NEW.QTD_KM,'9G999G999'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.TELEVE,NEW.TELEVE) <> 1 THEN
      vLOG := vLOG||'Televendas: de '||COALESCE(OLD.TELEVE,NULO)||' para '||COALESCE(NEW.TELEVE,NULO)||CRLF;
    END IF;
	 IF Equal(OLD.COOORC,NEW.COOORC) <> 1 THEN
	  vLOG := vLOG||'COO da Impresso do DAV: de '||COALESCE(OLD.COOORC,0)||' para '||COALESCE(NEW.COOORC,0)||CRLF;
    END IF;
    IF Equal(OLD.FILEQP,NEW.FILEQP) <> 1 THEN
      vLOG := vLOG||'Filial Equipamento: de '||COALESCE(OLD.FILEQP,NULO)||' para '||COALESCE(NEW.FILEQP,NULO)||CRLF;
    END IF;
    IF Equal(OLD.SEQEQP,NEW.SEQEQP) <> 1 THEN
      vLOG := vLOG||'Seq Equipamento: de '||COALESCE(OLD.SEQEQP,NULO)||' para '||COALESCE(NEW.SEQEQP,NULO)||CRLF;
    END IF;
    IF Equal(OLD.FILWOR,NEW.FILWOR) <> 1 THEN
      vLOG := vLOG||'Filial Tarefa: de '||COALESCE(OLD.FILWOR,NULO)||' para '||COALESCE(NEW.FILWOR,NULO)||CRLF;
    END IF;
    IF Equal(OLD.SEQWOR,NEW.SEQWOR) <> 1 THEN
      vLOG := vLOG||'Seq Tarefa: de '||COALESCE(OLD.SEQWOR,NULO)||' para '||COALESCE(NEW.SEQWOR,NULO)||CRLF;
    END IF;
    IF Equal(OLD.TRNECF,NEW.TRNECF) <> 1 THEN
      vLOG := vLOG||'ECF do ID da Transao: de '||COALESCE(OLD.TRNECF,NULO)||' para '||COALESCE(NEW.TRNECF,NULO)||CRLF;
    END IF;
    IF Equal(OLD.TRN_ID,NEW.TRN_ID) <> 1 THEN
      vLOG := vLOG||'ID da Transao: de '||COALESCE(TO_CHAR(OLD.TRN_ID),NULO)||' para '||COALESCE(TO_CHAR(NEW.TRN_ID),NULO)||CRLF;
    END IF;

	IF Equal(OLD.FLGECO,NEW.FLGECO) <> 1 THEN
      select CASE OLD.FLGECO WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                                                  ELSE 'Nulo'
      END into cOld from dual;
      select CASE NEW.FLGECO WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                                                  ELSE 'Nulo'
      END into cNew from dual;

      vLOG := vLOG||'Situao da DAV no E-Commerce: de '||COALESCE(cOld,Nulo)||' para '||COALESCE(cNew,Nulo)||CRLF;
    END IF;

	IF Equal(OLD.CODRAS,NEW.CODRAS) <> 1 THEN
      vLOG := vLOG||'Cdigo de Rastreamento: de '||COALESCE(OLD.CODRAS,NULO)||' para '||COALESCE(NEW.CODRAS,NULO)||CRLF;
    END IF;

    IF Equal(OLD.ENVECO,NEW.ENVECO) <> 1 THEN
      select CASE OLD.ENVECO WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                                                  ELSE Nulo
      END into cOld from dual;
      select CASE NEW.ENVECO WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                                                  ELSE Nulo
      END into cNew from dual;
      vLOG := vLOG||'Pendente de Envio para E-Commerce: de '||COALESCE(cOld,NULO)||' para '||COALESCE(cNew,NULO)||CRLF;
    END IF;

	IF Equal(OLD.PRZENT,NEW.PRZENT) <> 1 THEN
      vLOG := vLOG||'Nmero de dias para entrega: de '||COALESCE(OLD.PRZENT,0)||' para '||COALESCE(NEW.PRZENT,0)||CRLF;
    END IF;

	IF Equal(OLD.CODSVE,NEW.CODSVE) <> 1 THEN
      vLOG := vLOG||'Cdigo de Servio dos Correios: de '||COALESCE(OLD.CODSVE,0)||' para '||COALESCE(NEW.CODSVE,0)||CRLF;
    END IF;

	IF Equal(OLD.DATENV,NEW.DATENV) <> 1 THEN
        vLOG := vLOG||'Data de Envio ao Cliente: de '||COALESCE(to_char(OLD.DATENV,'DD/MM/YYYY HH24:MI:SS'),Nulo)||' para '||COALESCE(to_char(NEW.DATENV,'DD/MM/YYYY HH24:MI:SS'),Nulo)||CRLF;
     END IF;

	-- Paulo Koglin : 88183
	IF Equal(OLD.VLRSAD,NEW.VLRSAD) <> 1 THEN
       vLOG := vLOG||'Valor Servios Adicionais Total: de '||COALESCE(TO_CHAR(OLD.VLRSAD,'9G999G999G990D00'),NULO)||' para '||COALESCE(TO_CHAR(NEW.VLRSAD,'9G999G999G990D00'),NULO)||CRLF;
    END IF;

	IF Equal(OLD.CODVEI,NEW.CODVEI) <> 1 THEN
      vLOG := vLOG||'Veculo: de '||COALESCE(TO_CHAR(OLD.CODVEI),NULO)||' para '||COALESCE(TO_CHAR(NEW.CODVEI),NULO)||CRLF;
    END IF;
    -- RFMP 90316
    IF Equal(OLD.CODFRE,NEW.CODFRE) <> 1 THEN
      IF OLD.CODFRE IS NULL THEN
        cOld := NULO;
      ELSE
        SELECT COALESCE(TRIM(DESFRE),Nulo) INTO cOld FROM TD_FRE WHERE CODTAB = OLD.CODFRE;
      END IF;
      IF NEW.CODFRE IS NULL THEN
        cNew := NULO;
      ELSE
        SELECT COALESCE(TRIM(DESFRE),Nulo) INTO cNew FROM TD_FRE WHERE CODTAB = NEW.CODFRE;
      END IF;
      vLOG := vLOG||'Poltica de Frete: de '||cOld||' para '||cNew||CRLF;
    END IF;

    IF Equal(OLD.JURPAR,NEW.JURPAR) <> 1 THEN
      vLOG := vLOG||'Juros das Parcelas: de '||COALESCE(TO_CHAR(OLD.JURPAR,'fm999G999G990D00'),NULO)||' para '||COALESCE(TO_CHAR(NEW.JURPAR,'fm999G999G990D00'),NULO)||CRLF;
    END IF;

    IF Equal(OLD.DESVOL,NEW.DESVOL) <> 1 THEN
      vLOG := vLOG||'Numerao dos volumes: de '||COALESCE(OLD.DESVOL,NULO)||' para '||COALESCE(NEW.DESVOL,NULO)||CRLF;
    END IF;

    IF Equal(OLD.PLACAT,NEW.PLACAT) <> 1 THEN
      vLOG := vLOG||'Placa transportadora: de '||COALESCE(OLD.PLACAT,NULO)||' para '||COALESCE(NEW.PLACAT,NULO)||CRLF;
    END IF;

    IF Equal(OLD.FLGBON,NEW.FLGBON) <> 1 THEN
      select CASE OLD.FLGBON WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                                                  ELSE 'Nulo'
      END into cOld from dual;
      select CASE NEW.FLGBON WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                                                  ELSE 'Nulo'
      END into cNew from dual;

      vLOG := vLOG||'DAV bnus?: de '||COALESCE(cOld,Nulo)||' para '||COALESCE(cNew,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.PERMCPTOT,NEW.PERMCPTOT) <> 1 THEN
      vLOG := vLOG||'% Margem de Contribuio do Produto: de '||COALESCE(TO_CHAR(OLD.PERMCPTOT,'fm990D0000'),NULO)||' para '||COALESCE(TO_CHAR(NEW.PERMCPTOT,'fm990D0000'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.VLRMCPTOT,NEW.VLRMCPTOT) <> 1 THEN
      vLOG := vLOG||'Valor Margem de Contribuio do Produto: de '||COALESCE(TO_CHAR(OLD.VLRMCPTOT,'fm9G999G999G990D0000'),NULO)||' para '||COALESCE(TO_CHAR(NEW.VLRMCPTOT,'fm9G999G999G990D0000'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.PERMCOTOT,NEW.PERMCOTOT) <> 1 THEN
      vLOG := vLOG||'% Margem de Contribuio no Oramento: de '||COALESCE(TO_CHAR(OLD.PERMCOTOT,'fm990D0000'),NULO)||' para '||COALESCE(TO_CHAR(NEW.PERMCOTOT,'fm990D0000'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.VLRMCOTOT,NEW.VLRMCOTOT) <> 1 THEN
      vLOG := vLOG||'Valor Margem de Contribuio no Oramento: de '||COALESCE(TO_CHAR(OLD.VLRMCOTOT,'fm9G999G999G990D0000'),NULO)||' para '||COALESCE(TO_CHAR(NEW.VLRMCOTOT,'fm9G999G999G990D0000'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.PERLUCTOT,NEW.PERLUCTOT) <> 1 THEN
      vLOG := vLOG||'% Lucro no Oramento: de '||COALESCE(TO_CHAR(OLD.PERLUCTOT,'fm990D0000'),NULO)||' para '||COALESCE(TO_CHAR(NEW.PERLUCTOT,'fm990D0000'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.VLRLUCTOT,NEW.VLRLUCTOT) <> 1 THEN
      vLOG := vLOG||'Valor Lucro no Oramento: de '||COALESCE(TO_CHAR(OLD.VLRLUCTOT,'fm9G999G999G990D0000'),NULO)||' para '||COALESCE(TO_CHAR(NEW.VLRLUCTOT,'fm9G999G999G990D0000'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.NUMPED_RE,NEW.NUMPED_RE) <> 1 THEN
      vLOG := vLOG||'Nmero do Pedido da Requisio Externa: de '||COALESCE(OLD.NUMPED_RE,NULO)||' para '||COALESCE(NEW.NUMPED_RE,NULO)||CRLF;
    END IF;
    IF (Equal(OLD.DATINC,NEW.DATINC) <> 1) THEN
      vLOG := vLOG||'Data Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),NULO)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),NULO)||CRLF;
    END IF;
    IF Equal(OLD.EXPORT,NEW.EXPORT) <> 1 THEN
      SELECT CASE OLD.EXPORT WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                              ELSE NULO
      END INTO cOld FROM DUAL;
      SELECT CASE NEW.EXPORT WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                              ELSE NULO
      END INTO cNew FROM DUAL;
      vLOG := vLOG||'Exportado?: de '||COALESCE(cOld,NULO)||' para '||COALESCE(cNew,NULO)||CRLF;
    END IF;
    IF Equal(OLD.TIPPAG,NEW.TIPPAG) <> 1 THEN
      vLOG := vLOG||'Tipo de Pagamento: de '||COALESCE(DescricaoDominio('ORC','TIPPAG',OLD.TIPPAG),NULO)||' para '||COALESCE(DescricaoDominio('ORC','TIPPAG',NEW.TIPPAG),NULO)||CRLF;
    END IF;
    IF Equal(OLD.CODCCC,NEW.CODCCC) <> 1 THEN
      vLOG := vLOG||'Conta Corrente: de '||COALESCE(TO_CHAR(OLD.CODCCC),NULO)||' para '||COALESCE(TO_CHAR(NEW.CODCCC),NULO)||CRLF;
    END IF;
    IF Equal(OLD.FILCUP,NEW.FILCUP) <> 1 OR
       Equal(OLD.SEQCUP,NEW.SEQCUP) <> 1 THEN
      vLOG := vLOG||'Cupom de Desconto: de '||COALESCE(TO_CHAR(OLD.FILCUP),NULO)||'/'||COALESCE(TO_CHAR(OLD.SEQCUP),NULO)||' para '||COALESCE(TO_CHAR(NEW.FILCUP),NULO)||'/'||COALESCE(TO_CHAR(NEW.SEQCUP),NULO)||CRLF;
    END IF;
    IF Equal(OLD.FILRET,NEW.FILRET) <> 1 THEN
      vLOG := vLOG||'Filial de Retirada: de '||COALESCE(TO_CHAR(OLD.FILRET),NULO)||' para '||COALESCE(TO_CHAR(NEW.FILRET),NULO)||CRLF;
    END IF;
    IF Equal(OLD.NUMPEDCOM,NEW.NUMPEDCOM) <> 1 THEN
       vLOG := vLOG||' Nmero do Pedido de Compra do Cliente: de '||COALESCE(OLD.NUMPEDCOM,NULO)||' para '||COALESCE(NEW.NUMPEDCOM,NULO)||CRLF;
    END IF;
    IF Equal(OLD.TIPINT,NEW.TIPINT) <> 1 THEN
      IF OLD.TIPINT IS NULL THEN
        cOld := NULO;
      ELSE
        SELECT DESTIPxINT INTO cOld FROM TD_TIPxINT WHERE CODTAB = OLD.TIPINT;
      END IF;
      IF NEW.TIPINT IS NULL THEN
        cNew := NULO;
      ELSE
        SELECT DESTIPxINT INTO cNew FROM TD_TIPxINT WHERE CODTAB = NEW.TIPINT;
      END IF;
      
      vLOG := vLOG||'Tipo da Intermediao: de '||cOld||' para '||cNew||CRLF;
    END IF;

    IF ISNOTNULL(vLOG) = 'T' THEN
      INSERT INTO TL_ORC (CODFIL,TIPPED,NUMPED,TIPLOG,DATOPE,MSGLOG)
                  VALUES (NEW.CODFIL,NEW.TIPPED,NEW.NUMPED,'D',Agora(),vLOG);
    END IF;

  ELSIF (TG_OP = 'DELETE') THEN
    DELETE FROM TL_ORC WHERE CODFIL = OLD.CODFIL
                         AND TIPPED = OLD.TIPPED
                         AND NUMPED = OLD.NUMPED;
  END IF;

  IF (TG_OP = 'INSERT') THEN
    NEW.DATINC := agora();
    IF NEW.APROVA='A' THEN
       NEW.DATAPR:= AGORA();
    END IF;
  END IF;

  -- Paulo : 71326
  IF (TG_OP = 'INSERT') THEN
    IF NEW.TIPPED IN ('O','S') THEN
         NEW.PREDAV:='D';
    ELSE
      NEW.PREDAV:='P';
    END IF;
  END IF;

  IF (TG_OP = 'UPDATE') THEN
    IF OLD.APROVA<>NEW.APROVA THEN
      IF NEW.APROVA='A' THEN
         NEW.DATAPR:= AGORA();
      END IF;
      -- 94274 - Limpa data de aprovao se situao no for Aprovado
      IF NEW.APROVA IN ('E','R') THEN
         NEW.DATAPR:= NULL;
      END IF;
    END IF;
  END IF;

  -- Leo : 79489
  IF (TG_OP = 'INSERT') THEN
     NEW.NUMPED_PAF := NEW.NUMPED;
  END IF;

   IF (TG_OP = 'INSERT') or (TG_OP = 'UPDATE') THEN
      NEW.DUMMY:=NULL;
   END IF;

  IF (TG_OP = 'DELETE') THEN
    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
  END IF;

  IF (TG_OP = 'INSERT') THEN

    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;

    -- Douglas - 83441
    NEW.CODUID := GetCoduidAtual();
    NEW.ASSINA := COALESCE(AssinaTabela('TT_ORC',
	                                    ConcatenaORC(NEW.CODFIL,
                                                    NEW.TIPPED,
                                                    NEW.NUMPED,
                                                    NEW.NUMPED_PAF,
                                                    NEW.PED_EM,
                                                    NEW.VLRTOT,
                                                    NEW.CODEMP,
                                                    NEW.COOORC,
                                                    NEW.NUMECF),
                                                   null, null, null),NEW.ASSINA);
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF ConcatenaORC(NEW.CODFIL,NEW.TIPPED,NEW.NUMPED,NEW.NUMPED_PAF,
					  NEW.PED_EM,NEW.VLRTOT,NEW.CODEMP,NEW.COOORC,NEW.NUMECF) <>
		 ConcatenaORC(OLD.CODFIL,OLD.TIPPED,OLD.NUMPED,OLD.NUMPED_PAF,
					  OLD.PED_EM,OLD.VLRTOT,OLD.CODEMP,OLD.COOORC,OLD.NUMECF) THEN

         -- LEO 84337
         SELECT BLQ_SEM_UID
           INTO vBLQ_SEM_UID
           FROM TT_CFG;
         vCODUID_ATUAL := GetCoduidAtual();
         IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;

	     -- Douglas - 83441
         NEW.CODUID := GetCoduidAtual();
         NEW.ASSINA := COALESCE(AssinaTabela('TT_ORC',
 	                                      ConcatenaORC(NEW.CODFIL,
                                                      NEW.TIPPED,
                                                      NEW.NUMPED,
                                                      NEW.NUMPED_PAF,
                                                      NEW.PED_EM,
                                                      NEW.VLRTOT,
                                                      NEW.CODEMP,
                                                      NEW.COOORC,
                                                      NEW.NUMECF),
                                                    OLD.CODUID,
	                                      ConcatenaORC(OLD.CODFIL,
                                                      OLD.TIPPED,
                                                      OLD.NUMPED,
                                                      OLD.NUMPED_PAF,
                                                      OLD.PED_EM,
                                                      OLD.VLRTOT,
                                                      OLD.CODEMP,
                                                      OLD.COOORC,
                                                      OLD.NUMECF),
                                                   OLD.ASSINA
                                                  ),NEW.ASSINA);
	  END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4828 --*/
CREATE TRIGGER TGORC
BEFORE INSERT OR DELETE OR UPDATE ON TT_ORC 
FOR EACH ROW EXECUTE PROCEDURE TGORC();

/*-- SEQ 4829 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGORC_ASS() CASCADE;

/*-- SEQ 4830 --*/
CREATE OR REPLACE FUNCTION TGORC_ASS() RETURNS TRIGGER AS $$
-- 83073
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN

  IF ExisteFilialNaUF('SC') THEN
     IF (TG_OP = 'INSERT') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG + 1
        WHERE NOMTAB = 'TT_ORC';
     END IF;
     
     IF (TG_OP = 'DELETE') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG - 1
        WHERE NOMTAB = 'TT_ORC';
     END IF;  
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4831 --*/
CREATE TRIGGER TGORC_ASS
AFTER INSERT OR DELETE ON TT_ORC 
FOR EACH ROW EXECUTE PROCEDURE TGORC_ASS();


/*-- SEQ 4832 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGORC_ECO() CASCADE;

/*-- SEQ 4833 --*/
CREATE OR REPLACE FUNCTION TGORC_ECO() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impede excluso.
-- 2. Gerar um cdigo sequencial exclusivo para compor a chave primria.
-- 3. Atualiza controles de data.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Impede excluso.
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20000 Registro no pode ser excludo. %' , COMPLEMENTO;
   END IF;

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF COALESCE(NEW.ORCECO_ID,0) = 0 THEN
         SELECT NEXTVAL('SQORCECO') INTO NEW.ORCECO_ID FROM DUAL;
      END IF;
      NEW.DATINC := Agora();

      IF NEW.DATOPE IS NULL THEN 
         NEW.DATOPE := NEW.DATINC;
      END IF;

   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4834 --*/
CREATE TRIGGER TGORC_ECO
BEFORE INSERT OR UPDATE OR DELETE ON TT_ORC_ECO 
FOR EACH ROW EXECUTE PROCEDURE TGORC_ECO();


/*-- SEQ 4835 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGOUT() CASCADE;

/*-- SEQ 4836 --*/
CREATE OR REPLACE FUNCTION TGOUT() RETURNS TRIGGER AS $$
DECLARE
  cRet VARCHAR(2);
BEGIN
  IF (TG_OP = 'DELETE') THEN
     cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_OUT', OLD.codtab, to_char(OLD.codexp));
  END IF;
  IF (TG_OP = 'INSERT') THEN
     --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
     cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_OUT', NEW.codtab, to_char(NEW.codexp));
  END IF;
  IF NOT (TG_OP = 'DELETE') THEN
     NEW.ATU_EM := AGORA();
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4837 --*/
CREATE TRIGGER TGOUT
BEFORE UPDATE OR INSERT OR DELETE ON TT_OUT 
FOR EACH ROW EXECUTE PROCEDURE TGOUT();



/*-- SEQ 4838 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPAG2() CASCADE;

/*-- SEQ 4839 --*/
CREATE OR REPLACE FUNCTION TGPAG2() RETURNS TRIGGER AS $$
DECLARE

  -- Objetivo:
  -- 1) Impedir exclusao
  -- 2) Impedir alteracao nas colunas que nao se referem ao status
  --
  status        TT_COM.FLGEST%TYPE;
  proximo       CHAR(10);
  vComplemento  constant VARCHAR(100) := constante('complemento');
  vVem_de_TGCOM constant VARCHAR(100) := constante('vem_de_tgcom');
  vAJUSTE_VAL_PARCELA constant VARCHAR(100) := constante('AJUSTE_VAL_PARCELA'); -- RFMP 71247 usado no form de compromissos
  cDUMMY        VARCHAR(10);
  
   --rodrigo 58983
   vLOG          VARCHAR(4000)     := '';
   WK_CODUID     TT_UID.CODUID%TYPE; 
   cNulo         CONSTANT CHAR(4)   := 'Nulo';
   iNulo         CONSTANT Numeric(1) := 0;
   CRLF          CONSTANT CHAR(1)   := CHR(10);
   
   bVerifica boolean;
   
   QuemLogou TRetQuemLogou%ROWTYPE;
  
  
BEGIN
  IF (TG_OP = 'INSERT') THEN  
    NEW.DATINC := agora(); 
    NEW.SIGNAT := 0;
  END IF;

  -- Impede exclusoes
  IF  (TG_OP = 'DELETE') THEN
    IF OLD.FLGEST IN ('P','X','1') THEN
      RAISE EXCEPTION 'PG-20027 Exclusao so pode ser feita atraves da rotina manutencao. %' , vComplemento;
    END IF;
  END IF;

  -- Impede alteracoes
  IF (TG_OP = 'UPDATE') THEN
    IF (OLD.SEQUEN <> NEW.SEQUEN) OR
       (OLD.CODFIL <> NEW.CODFIL) OR
       (OLD.NUMPAR <> NEW.NUMPAR) OR
       (LTRIM(RTRIM(OLD.SUBPAR)) <> LTRIM(RTRIM(NEW.SUBPAR))) THEN
       RAISE EXCEPTION 'PG-20028 Dado da parcela de compra nao pode ser modificado. %' , vComplemento;
    END IF;

    -- Verifica se a mudanca do "flag" e permitida
    IF (OLD.FLGEST IN ('C','X')) AND (NEW.VLRDIF = OLD.VLRDIF) AND (NEW.DUMMY <> vAJUSTE_VAL_PARCELA) THEN
       RAISE EXCEPTION 'PG-20029 Parcela de compra cancelada ou estornada nao pode ser modificada. %' , vComplemento;
    ELSIF (OLD.FLGEST = 'A') AND (NEW.FLGEST NOT IN ('A','P','C','1','2')) THEN
       RAISE EXCEPTION 'PG-20030 Esta parcela de compra so pode ser paga ou cancelada. %' , vComplemento;
    ELSIF (OLD.FLGEST = 'P') AND (NEW.FLGEST <> 'X') AND (NEW.DUMMY <> vAJUSTE_VAL_PARCELA) THEN -- RFMP 71247 usado no form de compromissos
       RAISE EXCEPTION 'PG-20031 Parcelas de compra pagas so podem ser estornadas. % ' , vComplemento;
    -- davi - 47785 - 21/09/06 - FINANC
    ELSIF (OLD.FLGEST = 'P') AND 
          (NEW.FLGEST in ('P','X')) AND          
          (NEW.DUMMY <> vAJUSTE_VAL_PARCELA) AND 
          ((COALESCE(NEW.VLRPGT,-999999999) <>  COALESCE(OLD.VLRPGT,-999999999)) OR
           (COALESCE(NEW.VLRPAR,-999999999) <>  COALESCE(OLD.VLRPAR,-999999999)) OR
           (COALESCE(NEW.VLRPRE,-999999999) <>  COALESCE(OLD.VLRPRE,-999999999)) OR
           (COALESCE(TO_CHAR(NEW.DATPGT,'dd/mm/yyyy HH24:mi:ss'),'NULO') <>  COALESCE(TO_CHAR(OLD.DATPGT,'dd/mm/yyyy HH24:mi:ss'),'NULO')) OR
           (COALESCE(TO_CHAR(NEW.DATPRE,'dd/mm/yyyy HH24:mi:ss'),'NULO') <>  COALESCE(TO_CHAR(OLD.DATPRE,'dd/mm/yyyy HH24:mi:ss'),'NULO')) OR
           (COALESCE(TO_CHAR(NEW.DATVEN,'dd/mm/yyyy HH24:mi:ss'),'NULO') <>  COALESCE(TO_CHAR(OLD.DATVEN,'dd/mm/yyyy HH24:mi:ss'),'NULO'))) THEN
           RAISE EXCEPTION 'PG-20041 Parcela de compra paga nao pode ser modificada. %' , vComplemento;
    END IF;

    --Se FLGEST passa a ser X ou C e no era, e se NEW.DATPGT for nulo, assumir data atual     
    IF (NEW.FLGEST <> OLD.FLGEST) AND 
       ((NEW.FLGEST  = 'X') OR (NEW.FLGEST  = 'C')) AND 
       ((OLD.FLGEST <> 'X') OR (OLD.FLGEST <> 'C')) THEN
       IF (NEW.DATPGT is null) THEN
         NEW.DATPGT := agora();
       END IF;
    END IF;

    -- Verificacoes quanto a data de pagamento
    IF NEW.FLGEST  = 'P' AND NEW.DATPGT is null then
       RAISE EXCEPTION 'PG-20035 Data de pagamento nao foi informada. % ' , vComplemento;
    END IF;    
    
    IF NEW.DATINC IS NULL THEN
       RAISE EXCEPTION 'PG-20037 Data de Inclusao nao pode ser nula. %' , vComplemento;
    END IF;

    IF NEW.DATINC <> OLD.DATINC THEN
       NEW.DATINC := OLD.DATINC;
    END IF;

  END IF;
  
  -- P4.1F 38603
  IF NOT (TG_OP = 'DELETE') THEN
    bVerifica :=FALSE;
    IF (TG_OP = 'INSERT') THEN
       bVerifica:=TRUE;
    ELSIF (Equal(NEW.FLGEST,OLD.FLGEST) = 0) THEN
       bVerifica:=TRUE;
    END IF;
       
    IF bVerifica THEN
       IF NEW.FLGEST = 'C' THEN
          NEW.ESTCAN := COALESCE(NEW.ESTCAN,NEW.DATPGT,AGORA());         
       END IF; 
	   IF NEW.FLGEST = 'X' THEN
          NEW.ESTCAN := COALESCE(NEW.ESTCAN,AGORA());
       END IF;
    END IF;
  END IF;
  

  IF (TG_OP = 'INSERT')
  OR (TG_OP = 'UPDATE') THEN
     -- Dispensa restante do teste se a atualizacao tiver sido solicitada pela trigger TGCOM
     IF (NEW.DUMMY <> vVem_de_TGCOM) THEN
        -- Traz o "status" atual da compra
        SELECT FLGEST
          INTO status
          FROM TT_COM
         WHERE CODFIL = NEW.CODFIL
           AND SEQUEN = NEW.SEQUEN
                      
            FOR UPDATE;
                
        IF (status = 'D') AND (NEW.FLGEST NOT IN ('C','X')) THEN
           RAISE EXCEPTION 'PG-20036 Compra cancelada so permite parcelas canceladas ou estornadas. %' , vComplemento;
        END IF;
     END IF;
  END IF;
  
  -- DN 45679 - Tabelas Financeiras
  IF (TG_OP = 'INSERT') THEN    
     cDUMMY:=INSERE_LFIN_LAN('PAG',NEW.CODFIL,NEW.SEQUEN,NEW.NUMPAR,NEW.SUBPAR);
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF (Equal(OLD.VLRPAR,NEW.VLRPAR) <> 1) OR 
        (Equal(OLD.DATINC,NEW.DATINC) <> 1) OR 
        (Equal(OLD.DATPGT,NEW.DATPGT) <> 1) OR 
        (Equal(OLD.SEQDOP,NEW.SEQDOP) <> 1) OR 
        (Equal(OLD.FILDOP,NEW.FILDOP) <> 1) OR 
        (Equal(OLD.FLGEST,NEW.FLGEST) <> 1) OR 
        (Equal(OLD.VLRDIF,NEW.VLRDIF) <> 1) OR 
        (Equal(OLD.VLRPGT,NEW.VLRPGT) <> 1) OR 
        (Equal(OLD.VLRDES,NEW.VLRDES) <> 1) OR 
        (Equal(OLD.DATVEN,NEW.DATVEN) <> 1) THEN 
        cDUMMY:=INSERE_LFIN_LAN('PAG',NEW.CODFIL,NEW.SEQUEN,NEW.NUMPAR,NEW.SUBPAR);
     END IF;
  END IF;
  -- DN 45679 - Fim Tabelas Financeiras

  IF (TG_OP = 'INSERT')
  OR (TG_OP = 'UPDATE') THEN
     -- "Default"
     NEW.ATU_EM := agora();
     NEW.DATVEN := Trunc(NEW.DATVEN);
     NEW.DUMMY  := Null;
     NEW.SUBPAR := LPAD( COALESCE(LTRIM(RTRIM(NEW.SUBPAR)),'0'),2,' ');
  END IF;

  IF (TG_OP = 'UPDATE') THEN
    IF (Equal(NEW.SIGNAT,9999) <> 1) THEN
	   IF (Equal(OLD.SIGNAT,NEW.SIGNAT) <> 1) THEN
          RAISE EXCEPTION 'PG-20003 Registro foi alterado por outro usurio, refaa a consulta e tente gravar novamente. %' , vComplemento;
       END IF;
	END IF;    
    NEW.SIGNAT := MOD(COALESCE(OLD.SIGNAT,0) + 1,100000);
  END IF;
  
  IF (TG_OP = 'UPDATE') THEN

      WK_CODUID := GetCoduidAtual();

      vLOG := 'Alteraes em TT_PAG '||CRLF;  

     IF (Equal(OLD.ATU_EM,NEW.ATU_EM) = 0) THEN 
         vLOG := vLOG||'Data~Atualizao: de '||COALESCE(TO_CHAR(OLD.ATU_EM,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ATU_EM,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;    
     IF (Equal(OLD.CODAUT,NEW.CODAUT) = 0) THEN 
         vLOG := vLOG||'Cdigo Autorizao: de '||COALESCE(OLD.CODAUT,cNulo)||' para '||COALESCE(NEW.CODAUT,cNulo)||CRLF;
     END IF;    
     IF (Equal(OLD.CODBCO,NEW.CODBCO) = 0) THEN 
         vLOG := vLOG||'Cdigo do Banco: de '||COALESCE(OLD.CODBCO,iNulo)||' para '||COALESCE(NEW.CODBCO,iNulo)||CRLF;
     END IF;    
     IF (Equal(OLD.CODFIL,NEW.CODFIL) = 0) THEN 
         vLOG := vLOG||'Filial: de '||COALESCE(DescricaoDominio('DFIL','CODFIL',OLD.CODFIL),cNulo)||' para '||COALESCE(DescricaoDominio('DFIL','CODFIL',NEW.CODFIL),cNulo)||CRLF;
     END IF;    
     IF (Equal(OLD.CODUSU,NEW.CODUSU) = 0) THEN 
         vLOG := vLOG||'Usurio: de '||COALESCE(DescricaoDominio('USU ','CODUSU',OLD.CODUSU),cNulo)||' para '||COALESCE(DescricaoDominio('USU ','CODUSU',NEW.CODUSU),cNulo)||CRLF;
     END IF;    
     IF (Equal(OLD.CONPGT,NEW.CONPGT) = 0) THEN 
         vLOG := vLOG||'Conta Pagto.: de '||COALESCE(OLD.CONPGT,cNulo)||' para '||COALESCE(NEW.CONPGT,cNulo)||CRLF;
     END IF;    
     IF (Equal(OLD.DATINC,NEW.DATINC) = 0) THEN 
         vLOG := vLOG||'Data de Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;    
     IF (Equal(OLD.DATPGT,NEW.DATPGT) = 0) THEN 
         vLOG := vLOG||'Pagamento: de '||COALESCE(TO_CHAR(OLD.DATPGT,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATPGT,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;    
     IF (Equal(OLD.DATPRX,NEW.DATPRX) = 0) THEN 
         vLOG := vLOG||'Data Prximo Vencto: de '||COALESCE(TO_CHAR(OLD.DATPRX,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATPRX,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;    
     IF (Equal(OLD.DATVEN,NEW.DATVEN) = 0) THEN 
         vLOG := vLOG||'Data de Vencimento: de '||COALESCE(TO_CHAR(OLD.DATVEN,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATVEN,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;    
     IF (Equal(OLD.DOCPGT,NEW.DOCPGT) = 0) THEN 
         vLOG := vLOG||'Documento Pagamento: de '||COALESCE(OLD.DOCPGT,cNulo)||' para '||COALESCE(NEW.DOCPGT,cNulo)||CRLF;
     END IF;    
     IF (Equal(OLD.FILAUT,NEW.FILAUT) = 0) THEN 
         vLOG := vLOG||'Filial Autoriazao: de '||COALESCE(OLD.FILAUT,cNulo)||' para '||COALESCE(NEW.FILAUT,cNulo)||CRLF;
     END IF;    
     IF (Equal(OLD.FILDOP,NEW.FILDOP) = 0) THEN 
         vLOG := vLOG||'Filial Doc. PGTO: de '||COALESCE(OLD.FILDOP,cNulo)||' para '||COALESCE(NEW.FILDOP,cNulo)||CRLF;
     END IF;    
     IF (Equal(OLD.FLGEST,NEW.FLGEST) = 0) THEN 
         vLOG := vLOG||'Situao: de '||COALESCE(OLD.FLGEST,cNulo)||' para '||COALESCE(NEW.FLGEST,cNulo)||CRLF;
     END IF;    
     IF (Equal(OLD.NUMPAR,NEW.NUMPAR) = 0) THEN 
         vLOG := vLOG||'Parcela: de '||COALESCE(OLD.NUMPAR,cNulo)||' para '||COALESCE(NEW.NUMPAR,cNulo)||CRLF;
     END IF;    
     IF (Equal(OLD.RENEGO,NEW.RENEGO) = 0) THEN 
         vLOG := vLOG||'Num. renegociao: de '||COALESCE(OLD.RENEGO,iNulo)||' para '||COALESCE(NEW.RENEGO,iNulo)||CRLF;
     END IF;    
     IF (Equal(OLD.RENORI,NEW.RENORI) = 0) THEN 
         vLOG := vLOG||'Reneg. Original: de '||COALESCE(OLD.RENORI,iNulo)||' para '||COALESCE(NEW.RENORI,iNulo)||CRLF;
     END IF;    
     IF (Equal(OLD.SIGNAT,NEW.SIGNAT) = 0) THEN 
         vLOG := vLOG||'Ativo?: de '||COALESCE(OLD.SIGNAT,iNulo)||' para '||COALESCE(NEW.SIGNAT,iNulo)||CRLF;
     END IF;    
     IF (Equal(OLD.SUBPAR,NEW.SUBPAR) = 0) THEN 
         vLOG := vLOG||'Sub-Parcela: de '||COALESCE(OLD.SUBPAR,cNulo)||' para '||COALESCE(NEW.SUBPAR,cNulo)||CRLF;
     END IF;    
     IF (Equal(OLD.VLRDES,NEW.VLRDES) = 0) THEN 
         vLOG := vLOG||'Valor Desconto: de '||COALESCE(OLD.VLRDES,iNulo)||' para '||COALESCE(NEW.VLRDES,iNulo)||CRLF;
     END IF;    
     IF (Equal(OLD.VLRDIF,NEW.VLRDIF) = 0) THEN 
         vLOG := vLOG||'Saldo: de '||COALESCE(OLD.VLRDIF,iNulo)||' para '||COALESCE(NEW.VLRDIF,iNulo)||CRLF;
     END IF;    
     IF (Equal(OLD.VLRPAR,NEW.VLRPAR) = 0) THEN 
         vLOG := vLOG||'Valor Parcela: de '||COALESCE(OLD.VLRPAR,iNulo)||' para '||COALESCE(NEW.VLRPAR,iNulo)||CRLF;
     END IF;    
     IF (Equal(OLD.VLRPGT,NEW.VLRPGT) = 0) THEN 
         vLOG := vLOG||'Valor Pagamento: de '||COALESCE(OLD.VLRPGT,iNulo)||' para '||COALESCE(NEW.VLRPGT,iNulo)||CRLF;
     END IF;
	 -- Paulo K. - 88214
	 IF (Equal(OLD.AUTBAN,NEW.AUTBAN) = 0) THEN 
         vLOG := vLOG||'Cod. completo autenticao bancria: de '||COALESCE(OLD.AUTBAN,cNulo)||' para '||COALESCE(NEW.AUTBAN,cNulo)||CRLF;
     END IF; 
	 -- Paulo K. - 88547
	 IF (Equal(OLD.VLRJUR,NEW.VLRJUR) = 0) THEN 
         vLOG := vLOG||'Valor de Juros para Financiamento: de '||COALESCE(OLD.VLRJUR,iNulo)||' para '||COALESCE(NEW.VLRJUR,iNulo)||CRLF;
     END IF;
     
     IF ISNOTNULL(vLOG) = 'T' THEN
        select * into QuemLogou from DadosLogon();
        INSERT INTO TL_COM 
        (CODFIL, SEQUEN, FILUSU, CODUSU, DATOPE, MSGLOG, CODUID)
        VALUES
        (NEW.CODFIL, NEW.SEQUEN, QuemLogou.FILUSU, QuemLogou.CODUSU, agora(), vLog, WK_CODUID);
     END IF;
     
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4840 --*/
CREATE TRIGGER TGPAG2
BEFORE INSERT OR DELETE OR UPDATE ON TT_PAG 
FOR EACH ROW EXECUTE PROCEDURE TGPAG2();


/*-- SEQ 4841 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPAG3() CASCADE;

/*-- SEQ 4842 --*/
CREATE OR REPLACE FUNCTION TGPAG3() RETURNS TRIGGER AS $$
DECLARE
  inRec      TT_PAG%ROWTYPE;
  bMudou     Boolean;
  cDUMMY     VARCHAR(1);
BEGIN

  bMudou := False;
  IF (TG_OP = 'UPDATE') THEN
     IF OLD.FLGEST <> NEW.FLGEST THEN
        bMudou := True;
     END IF;
  END IF;

  IF ((TG_OP = 'INSERT') OR bMudou) AND
     ((NEW.FLGEST = 'X') or (NEW.FLGEST = 'P')) THEN

     
        inRec.CODFIL := NEW.CODFIL;
        inRec.SEQUEN := NEW.SEQUEN;
        inRec.NUMPAR := NEW.NUMPAR;
        inRec.SUBPAR := NEW.SUBPAR;
        inRec.FLGEST := NEW.FLGEST;
        inRec.DATVEN := NEW.DATVEN;
        inRec.DATPGT := NEW.DATPGT;
        inRec.DATPRX := NEW.DATPRX;
        inRec.VLRPAR := NEW.VLRPAR;
        inRec.VLRPGT := NEW.VLRPGT;
        inRec.VLRDIF := NEW.VLRDIF;
        inRec.DOCPGT := NEW.DOCPGT;
        inRec.FILDOP := NEW.FILDOP;
        inRec.SEQDOP := NEW.SEQDOP; 
          
     cDUMMY := PC_PAG_UPDATE(inRec.CODFIL,inRec.SEQUEN,inRec.NUMPAR,
                             inRec.DATPRX,inRec.VLRDIF,inRec.FILDOP,
                             inRec.SEQDOP,inRec.FLGEST,inRec.DOCPGT,
                             inRec.VLRPGT,inRec.DATPGT,inRec.DATVEN,
                             inRec.VLRPAR,inRec.SUBPAR);
     
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4843 --*/
CREATE TRIGGER TGPAG3
AFTER INSERT OR UPDATE ON TT_PAG 
FOR EACH ROW EXECUTE PROCEDURE TGPAG3();





/*-- SEQ 4844 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPAP() CASCADE;

/*-- SEQ 4845 --*/
CREATE OR REPLACE FUNCTION TGPAP() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN := ProximoCodigo('TT_PAP',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4846 --*/
CREATE TRIGGER TGPAP
BEFORE INSERT ON TT_PAP 
FOR EACH ROW EXECUTE PROCEDURE TGPAP();

/*-- SEQ 4847 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPAP2() CASCADE;

/*-- SEQ 4848 --*/
CREATE OR REPLACE FUNCTION TGPAP2() RETURNS TRIGGER AS $$

-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
   
   cLog                          VARCHAR(4000) := '';
   cFILUSU                       TT_USU.FILUSU%TYPE;
   cCODUSU                       TT_USU.CODUSU%TYPE;
   cNulo                         CONSTANT CHAR(04) := 'Nulo';
   iNulo                         CONSTANT Numeric(01) := 0;
   CRLF                          CONSTANT CHAR(01) := CHR(10);
   nCODUID                       TT_UID.CODUID%TYPE;
      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
      cLFILUSU                      TT_USU.FILUSU%TYPE;
   cLCODUSU                      TT_USU.CODUSU%TYPE;
   cFILCLI                       TT_USU.FILCLI%TYPE;
   cCODCLI                       TT_USU.CODCLI%TYPE;

   crUsuarios CURSOR(pFILPAP TT_PAPXUSU.FILPAP%TYPE,
           pSEQPAP TT_PAPXUSU.SEQPAP%TYPE) IS
   SELECT PxU.FILUSU, PxU.CODUSU, USU.FILCLI, USU.CODCLI 
     FROM TT_PAPXUSU PxU
     JOIN TT_USU USU ON USU.FILUSU = PxU.FILUSU AND USU.CODUSU = PxU.CODUSU
    WHERE PxU.FILPAP = pFILPAP
      AND PxU.SEQPAP = pSEQPAP;

-- Principal
BEGIN
         SELECT MAX(CODUID)
        INTO nCODUID
        FROM TT_UID
       WHERE SESSION_ID = USERENV('SESSIONID');
   
   select * into QuemLogou from DadosLogon();
   cFILUSU := QuemLogou.FILUSU;
   cCODUSU := QuemLogou.CODUSU;
   
         

   IF (TG_OP = 'UPDATE') THEN
      IF (Equal(OLD.PERMIS,NEW.PERMIS) <> 1)
      OR (Equal(OLD.PERAUT,NEW.PERAUT) <> 1) THEN
         cRetorno := AtualizaData('CONFIGURACAO',Agora());

         -- Percorre os usurios vinculados ao papel e atualiza o ATU_EM de cada um
         OPEN crUsuarios(NEW.CODFIL,NEW.SEQUEN);
         LOOP
            FETCH crUsuarios INTO cLFILUSU, cLCODUSU, cFILCLI, cCODCLI;
            EXIT WHEN NOT FOUND;

            IF (Equal(OLD.PERMIS,NEW.PERMIS) <> 1) THEN
               cLog := 'Alterao nas permisses do Papel '||NEW.CODFIL||'/'||NEW.SEQUEN||'-'||NEW.DESPAP||' do Usurio '||cLFILUSU||'/'||cLCODUSU||CRLF||
                       'Permisses alteradas: '|| PermissoesUsuarioAlteradas(COALESCE(OLD.PERMIS,''), COALESCE(NEW.PERMIS,''));				 

               IF (ISNOTNULL(cFILCLI)='T') AND (ISNOTNULL(cCODCLI)='T') THEN
                  INSERT INTO TL_CLI (FILUSU, CODUSU, FILCLI, CODCLI, DATOPE, MSGLOG, CODUID)
                             VALUES (cFILUSU, cCODUSU, cFILCLI, cCODCLI, Agora(), cLog, nCODUID);
               END IF;
            END IF;
            IF (Equal(OLD.PERAUT,NEW.PERAUT) <> 1) THEN
               cLog := 'Alterao nas permisses automticas do Papel '||NEW.CODFIL||'/'||NEW.SEQUEN||'-'||NEW.DESPAP||' do Usurio '||cLFILUSU||'/'||cLCODUSU||CRLF||
                       'Permisses alteradas: '|| PermissoesUsuarioAlteradas(COALESCE(OLD.PERAUT,''), COALESCE(NEW.PERAUT,''));				 
               IF (ISNOTNULL(cFILCLI)='T') AND (ISNOTNULL(cCODCLI)='T') THEN
                  INSERT INTO TL_CLI (FILUSU, CODUSU, FILCLI, CODCLI, DATOPE, MSGLOG, CODUID)
                             VALUES (cFILUSU, cCODUSU, cFILCLI, cCODCLI, Agora(), cLog, nCODUID);
               END IF;
            END IF;
         END LOOP;
         CLOSE crUsuarios;
      END IF;
   ELSE
      cRetorno := AtualizaData('CONFIGURACAO',Agora());
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4849 --*/
CREATE TRIGGER TGPAP2
AFTER INSERT OR UPDATE OR DELETE ON TT_PAP 
FOR EACH ROW EXECUTE PROCEDURE TGPAP2();

/*-- SEQ 4850 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPAP3() CASCADE;

/*-- SEQ 4851 --*/
CREATE OR REPLACE FUNCTION TGPAP3() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_USU

-- Declarao de variveis e cursores         
   cCODFIL                       TT_PAP.CODFIL%TYPE;
   cSEQUEN                       TT_PAP.SEQUEN%TYPE;
   cFILUSU                       TT_USU.FILUSU%TYPE;
   cCODUSU                       TT_USU.CODUSU%TYPE;
   cWhere                        TM_ATU.FILTRO%TYPE;
   cRetorno                      VARCHAR(2);

   crUsuarios CURSOR(pFILPAP TT_PAPXUSU.FILPAP%TYPE,
           pSEQPAP TT_PAPXUSU.SEQPAP%TYPE) IS
   SELECT PxU.FILUSU, PxU.CODUSU
     FROM TT_PAPXUSU PxU
    WHERE PxU.FILPAP = pFILPAP
      AND PxU.SEQPAP = pSEQPAP;
            
-- Principal
BEGIN
            
      cCODFIL := NULL;
      cSEQUEN := NULL;
                     

   IF (TG_OP = 'INSERT') THEN
         
               
         cCODFIL := NEW.CODFIL;
         cSEQUEN := NEW.SEQUEN;
                  
   ELSIF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.PERMIS,NEW.PERMIS) <> 1 THEN
            
                  
            cCODFIL := NEW.CODFIL;
            cSEQUEN := NEW.SEQUEN;
          
      END IF;
   ELSIF (TG_OP = 'DELETE') THEN
         
               
         cCODFIL := OLD.CODFIL;
         cSEQUEN := OLD.SEQUEN;
          
   END IF;
            
   cWhere := NULL;
      IF ISNULL(cCODFIL) = 'F' THEN
         -- Percorre os usurios vinculados ao papel e atualiza o ATU_EM de cada um
         OPEN crUsuarios(cCODFIL,cSEQUEN);
         LOOP
            FETCH crUsuarios INTO cFILUSU, cCODUSU;
            EXIT WHEN NOT FOUND;
            cWhere := 'FILUSU = ' || CHR(39) || cFILUSU || CHR(39) || ' AND CODUSU = ' || CHR(39) || cCODUSU || CHR(39);
            cRetorno := INSERE_MATU('TT_PAP', 'TT_USU', cWhere);
         END LOOP;
         CLOSE crUsuarios;
      END IF;
          

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4852 --*/
CREATE TRIGGER TGPAP3
BEFORE DELETE OR INSERT OR UPDATE ON TT_PAP 
FOR EACH ROW EXECUTE PROCEDURE TGPAP3();



/*-- SEQ 4853 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPAPXUSU() CASCADE;

/*-- SEQ 4854 --*/
CREATE OR REPLACE FUNCTION TGPAPXUSU() RETURNS TRIGGER AS $$

-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);

   cLog                          VARCHAR(4000) := '';
   cFILUSU                       TT_USU.FILUSU%TYPE;
   cCODUSU                       TT_USU.CODUSU%TYPE;
   cNulo                         CONSTANT CHAR(04) := 'Nulo';
   iNulo                         CONSTANT Numeric(01) := 0;
   CRLF                          CONSTANT CHAR(01) := CHR(10);
   nCODUID                       TT_UID.CODUID%TYPE;
      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
   
   cFILCLI                       TT_USU.FILCLI%TYPE;
   cCODCLI                       TT_USU.CODCLI%TYPE;
   cDESPAP                       TT_PAP.DESPAP%TYPE;
   
-- Principal
BEGIN
         SELECT MAX(CODUID)
        INTO nCODUID
        FROM TT_UID
       WHERE SESSION_ID = USERENV('SESSIONID');
   
   select * into QuemLogou from DadosLogon();
   cFILUSU := QuemLogou.FILUSU;
   cCODUSU := QuemLogou.CODUSU;

   cRetorno := AtualizaData('CONFIGURACAO',Agora());

   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      SELECT USU.FILCLI, USU.CODCLI 
        INTO cFILCLI, cCODCLI
        FROM TT_USU USU
       WHERE USU.FILUSU = NEW.FILUSU
         AND USU.CODUSU = NEW.CODUSU;
   ELSIF (TG_OP = 'DELETE') THEN
      SELECT USU.FILCLI, USU.CODCLI 
        INTO cFILCLI, cCODCLI
        FROM TT_USU USU
       WHERE USU.FILUSU = OLD.FILUSU
         AND USU.CODUSU = OLD.CODUSU;

   END IF;

   IF (TG_OP = 'INSERT') THEN
      IF (ISNOTNULL(cFILCLI)='T') AND (ISNOTNULL(cCODCLI)='T') THEN
         SELECT PAP.DESPAP
           INTO cDESPAP
           FROM TT_PAP PAP
          WHERE PAP.CODFIL = NEW.FILPAP AND PAP.SEQUEN = NEW.SEQPAP;
         INSERT INTO TL_CLI (FILUSU, CODUSU, FILCLI, CODCLI, DATOPE, MSGLOG, CODUID)
                     VALUES (cFILUSU, cCODUSU, cFILCLI, cCODCLI, Agora(), 
                               'Usurio '||NEW.FILUSU||'/'||NEW.CODUSU||' foi includo no papel de '||COALESCE(NEW.FILPAP,cNulo)||'/'||COALESCE(NEW.SEQPAP,cNulo)||'-'||cDESPAP, nCODUID);
      END IF;
   ELSIF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.FILPAP,NEW.FILPAP) <> 1
      OR Equal(OLD.SEQPAP,NEW.SEQPAP) <> 1 THEN
         IF (ISNOTNULL(cFILCLI)='T') AND (ISNOTNULL(cCODCLI)='T') THEN
            SELECT PAP.DESPAP
              INTO cDESPAP
              FROM TT_PAP PAP
             WHERE PAP.CODFIL = OLD.FILPAP AND PAP.SEQUEN = OLD.SEQPAP;
            INSERT INTO TL_CLI (FILUSU, CODUSU, FILCLI, CODCLI, DATOPE, MSGLOG, CODUID)
                        VALUES (cFILUSU, cCODUSU, cFILCLI, cCODCLI, Agora(), 
                               'Usurio '||NEW.FILUSU||'/'||NEW.CODUSU||' foi excludo do papel de '||COALESCE(OLD.FILPAP,cNulo)||'/'||COALESCE(OLD.SEQPAP,cNulo)||'-'||cDESPAP, nCODUID);

            SELECT PAP.DESPAP
              INTO cDESPAP
              FROM TT_PAP PAP
             WHERE PAP.CODFIL = NEW.FILPAP AND PAP.SEQUEN = NEW.SEQPAP;
            INSERT INTO TL_CLI (FILUSU, CODUSU, FILCLI, CODCLI, DATOPE, MSGLOG, CODUID)
                        VALUES (cFILUSU, cCODUSU, cFILCLI, cCODCLI, Agora(), 
                               'Usurio '||NEW.FILUSU||'/'||NEW.CODUSU||' foi includo no papel de '||COALESCE(NEW.FILPAP,cNulo)||'/'||COALESCE(NEW.SEQPAP,cNulo)||'-'||cDESPAP, nCODUID);
         END IF;
      END IF;
   ELSIF (TG_OP = 'DELETE') THEN
      IF (ISNOTNULL(cFILCLI)='T') AND (ISNOTNULL(cCODCLI)='T') THEN
         SELECT PAP.DESPAP
              INTO cDESPAP
              FROM TT_PAP PAP
             WHERE PAP.CODFIL = OLD.FILPAP AND PAP.SEQUEN = OLD.SEQPAP;
         INSERT INTO TL_CLI (FILUSU, CODUSU, FILCLI, CODCLI, DATOPE, MSGLOG, CODUID)
                        VALUES (cFILUSU, cCODUSU, cFILCLI, cCODCLI, Agora(), 
                               'Usurio '||OLD.FILUSU||'/'||OLD.CODUSU||' foi excludo do papel de '||COALESCE(OLD.FILPAP,cNulo)||'/'||COALESCE(OLD.SEQPAP,cNulo)||'-'||cDESPAP, nCODUID);
      END IF;
   END IF;
   
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4855 --*/
CREATE TRIGGER TGPAPXUSU
AFTER INSERT OR UPDATE OR DELETE ON TT_PAPXUSU 
FOR EACH ROW EXECUTE PROCEDURE TGPAPXUSU();

/*-- SEQ 4856 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPAPXUSU4() CASCADE;

/*-- SEQ 4857 --*/
CREATE OR REPLACE FUNCTION TGPAPXUSU4() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_USU

-- Declarao de variveis e cursores
   cWhere                        TM_ATU.FILTRO%TYPE;
   cRetorno                      VARCHAR(2);

-- Principal
BEGIN
   IF (TG_OP = 'INSERT') THEN
      cWhere := 'FILUSU = ' || CHR(39) || NEW.FILUSU || CHR(39) || ' AND CODUSU = ' || CHR(39) || NEW.CODUSU || CHR(39);
   ELSIF (TG_OP = 'DELETE') THEN
      cWhere := 'FILUSU = ' || CHR(39) || OLD.FILUSU || CHR(39) || ' AND CODUSU = ' || CHR(39) || OLD.CODUSU || CHR(39);
   END IF;

   cRetorno := INSERE_MATU('TT_PAPXUSU', 'TT_USU', cWhere);

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4858 --*/
CREATE TRIGGER TGPAPXUSU4
BEFORE DELETE OR INSERT ON TT_PAPXUSU 
FOR EACH ROW EXECUTE PROCEDURE TGPAPXUSU4();


/*-- SEQ 4859 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPCLI() CASCADE;

/*-- SEQ 4860 --*/
CREATE OR REPLACE FUNCTION TGPCLI() RETURNS TRIGGER AS $$
-- Objetivo:
-- Atualizar ATU_EM
BEGIN
  NEW.ATU_EM := AGORA();
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4861 --*/
CREATE TRIGGER TGPCLI
BEFORE INSERT OR UPDATE ON TP_CLI 
FOR EACH ROW EXECUTE PROCEDURE TGPCLI();


/*-- SEQ 4862 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPCS() CASCADE;

/*-- SEQ 4863 --*/
CREATE OR REPLACE FUNCTION TGPCS() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impede excluso.
-- 2. Gerar um cdigo sequencial exclusivo para compor a chave primria.
-- 3. Atualiza controles de data.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Impede excluso.
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20000 Registro no pode ser excludo. %' , COMPLEMENTO;
   END IF;

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF COALESCE(NEW.ID_PCS,0) = 0 THEN
         SELECT NEXTVAL('SQPCS') INTO NEW.ID_PCS FROM DUAL;
      END IF;
      NEW.DATINC := Agora();
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4864 --*/
CREATE TRIGGER TGPCS
BEFORE INSERT OR UPDATE OR DELETE ON TT_PCS 
FOR EACH ROW EXECUTE PROCEDURE TGPCS();

/*-- SEQ 4865 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPCS2() CASCADE;

/*-- SEQ 4866 --*/
CREATE OR REPLACE FUNCTION TGPCS2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4867 --*/
CREATE TRIGGER TGPCS2
AFTER INSERT OR UPDATE OR DELETE ON TT_PCS 
FOR EACH ROW EXECUTE PROCEDURE TGPCS2();



/*-- SEQ 4868 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPED() CASCADE;

/*-- SEQ 4869 --*/
CREATE OR REPLACE FUNCTION TGPED() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Impedir mudancas se o pedido ja foi exportado
-- 2) Manter o mesmo codigo de moeda tanto para o pedido quanto para seus itens
-- 3) Tratamento para Bonificao do Futura do Fornecedor
   vComplemento                  Constant VARCHAR(100) := Constante('Complemento');
   vTT_PED_FLGEST                TT_PED.FLGEST%TYPE;
   cPENAUT                       TT_CFG.PENAUT%TYPE;
      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
   BEGIN
   select * into QuemLogou from DadosLogon();

   IF (TG_OP = 'UPDATE') THEN
      IF (Equal(OLD.EXPORT,NEW.EXPORT) = 1) AND (NEW.EXPORT = 'T') THEN
         IF (Equal(OLD.CODFIL,NEW.CODFIL) = 0) OR
            (Equal(OLD.NUMPED,NEW.NUMPED) = 0) OR
            (Equal(OLD.DATPED,NEW.DATPED) = 0) OR
            (Equal(OLD.FLGEST,NEW.FLGEST) = 0 AND NEW.FLGEST <> 'E') OR
            (Equal(OLD.ATU_EM,NEW.ATU_EM) = 0) OR
            (Equal(OLD.FILFOR,NEW.FILFOR) = 0) OR
            (Equal(OLD.CODFOR,NEW.CODFOR) = 0) OR
            (Equal(OLD.QTDTOT,NEW.QTDTOT) = 0) OR
            (Equal(OLD.VLRTOT,NEW.VLRTOT) = 0) OR
            (Equal(OLD.OUTTAX,NEW.OUTTAX) = 0) OR
            (Equal(OLD.DESCON,NEW.DESCON) = 0) OR
            (Equal(OLD.VLRLIQ,NEW.VLRLIQ) = 0) OR
            (Equal(OLD.FILUSU,NEW.FILUSU) = 0) OR
            (Equal(OLD.CODUSU,NEW.CODUSU) = 0) OR
            (Equal(OLD.OBSERV,NEW.OBSERV) = 0) OR
            (Equal(OLD.CODMOE,NEW.CODMOE) = 0) OR
            (Equal(OLD.CONPGT,NEW.CONPGT) = 0) OR
            (Equal(OLD.SIGNAT,NEW.SIGNAT) = 0) OR
            (Equal(OLD.DATENT,NEW.DATENT) = 0) OR
            (Equal(OLD.TIPFOR,NEW.TIPFOR) = 0) OR
            (Equal(OLD.FILAPR,NEW.FILAPR) = 0) OR
            (Equal(OLD.CODAPR,NEW.CODAPR) = 0) OR
            (Equal(OLD.VLRBON,NEW.VLRBON) = 0) OR
            (Equal(OLD.VLRFRE,NEW.VLRFRE) = 0) OR
            (Equal(OLD.FREORI,NEW.FREORI) = 0) THEN
            RAISE EXCEPTION 'PG-20001 Pedido ja foi encerrado. Nao pode ser mais modificado. %' , vComplemento;
         END IF;
      END IF;

      -- "Update cascade" dos itens do pedido
      -- Nota: o valor negativo para TT_IPE.NUMITE e para impedir
      --       que a "trigger" TGIPE faca uma consulta a TT_PED
      IF OLD.CODMOE <> NEW.CODMOE THEN
         UPDATE TT_IPE SET DUMMY = Constante('vem_de_TGPED'),CODMOE = NEW.CODMOE
         WHERE CODFIL = OLD.CODFIL
           AND NUMPED = OLD.NUMPED
           AND CODMOE <> NEW.CODMOE;
      END IF;

      -- RFMP 75328
      IF (NEW.FLGEST = 'Y') AND (Equal(OLD.FLGEST,NEW.FLGEST) <> 1) THEN
         SELECT CASE (SELECT MAX(CASE IPE.FLGEST WHEN 'A' THEN 3
                                                 WHEN 'E' THEN 2
                                                                     ELSE 1
                               END) 
                      FROM TT_IPE IPE 
                     WHERE IPE.CODFIL = NEW.CODFIL 
                       AND IPE.NUMPED = NEW.NUMPED) WHEN 3 THEN CASE OLD.FLGEST WHEN 'E' THEN '2'
                                                                                  ELSE OLD.FLGEST -- pode ser aberto, autorizado ou reprovado
                                                                 END
                                                     WHEN 2 THEN 'E'
                                                     ELSE 'C'
                       END
         INTO vTT_PED_FLGEST
         FROM DUAL;

       NEW.FLGEST := vTT_PED_FLGEST;
      END IF;
   END IF;

   IF (TG_OP = 'DELETE') THEN
      IF OLD.EXPORT = 'T' THEN
         RAISE EXCEPTION 'PG-20002 Pedido ja foi encerrado. Nao pode ser excluido. %' , vComplemento;
      END IF;

      -- Tratamento para Bonificao do Futura do Fornecedor
       -- Realiza o Estorno do Lanamento
      SELECT PENAUT INTO cPENAUT FROM TT_CFG;
      IF ((OLD.CODFOR <> '     0') AND (OLD.VLRBONFUT > 0) AND 
          (((cPENAUT = 'F') AND (OLD.FLGEST NOT IN ('0','C'))) OR ((cPENAUT='T') AND (OLD.FLGEST IN ('2','E'))))) THEN
         INSERT INTO TT_CCC (CODFIL, FILUSU, CODUSU, FILCLI, CODCLI, NUMDOC, DATOPE,
                          TIPCCC, VLRLAN, VLRORI, COMPLE, PORORI, TIPLAN, ATULIM, STATUS)
                  VALUES (OLD.CODFIL, QuemLogou.FILUSU, QuemLogou.CODUSU, OLD.FILFOR, OLD.CODFOR, 'PD' || OLD.CODFIL || OLD.NUMPED, OLD.DATPED,
                          0, OLD.VLRBONFUT * (-1), OLD.VLRBONFUT * (-1), 'PED ' || OLD.CODFIL || OLD.NUMPED, 0, '3', 'F', 'S');
      END IF;
   END IF;
   
   IF NOT (TG_OP = 'DELETE') THEN
      NEW.ATU_EM := AGORA();
   END IF;
   
   IF (TG_OP = 'INSERT') THEN
      IF (NEW.FLGEST = '2') THEN
         NEW.DATAPR := AGORA();
      END IF;
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF (Equal(OLD.FLGEST,NEW.FLGEST) <> 1) AND (NEW.FLGEST = '2') THEN
         NEW.DATAPR := AGORA();
      ELSE
         NEW.DATAPR := NULL;
      END IF;
   END IF;
   
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4870 --*/
CREATE TRIGGER TGPED
BEFORE INSERT OR UPDATE OR DELETE ON TT_PED 
FOR EACH ROW EXECUTE PROCEDURE TGPED();

/*-- SEQ 4871 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPED2() CASCADE;

/*-- SEQ 4872 --*/
CREATE OR REPLACE FUNCTION TGPED2() RETURNS TRIGGER AS $$
  -- Objetivo:
  -- 1) MN - 102058 - Registrar log das tabelas TT_PED e TT_IPE
  -- 2) Tratamento para Bonificao do Futura do Fornecedor
  -- 3) Cancelar TT_IPE quando cancelar o pedido
DECLARE
   cLOG                          VARCHAR(4000)     := '';
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   vPedido                       CHAR(20)           := '';
   wk_coduid                     TT_UID.CODUID%TYPE;
   cPENAUT                       TT_CFG.PENAUT%TYPE;
   bGeraEstorno                  BOOLEAN;
   bGeraNovoCredito              BOOLEAN;
   cDUMMY                        VARCHAR(20);

      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
   
   inRec Record;
BEGIN
   select * into QuemLogou from DadosLogon();

   -- Tratamento para Bonificao do Futura do Fornecedor
   SELECT PENAUT INTO cPENAUT FROM TT_CFG; -- Considerar como pendente somente os pedidos autorizados?
   IF (TG_OP = 'INSERT') THEN
      IF ((NEW.CODFOR <> '     0') AND (NEW.VLRBONFUT > 0) AND 
          (((cPENAUT = 'F') AND (NEW.FLGEST NOT IN ('0','C'))) OR ((cPENAUT='T') AND (NEW.FLGEST IN ('2','E'))))) THEN
         INSERT INTO TT_CCC (CODFIL, FILUSU, CODUSU, FILCLI, CODCLI, NUMDOC, DATOPE,
                             TIPCCC, VLRLAN, VLRORI, COMPLE, PORORI, TIPLAN, ATULIM, STATUS)
                     VALUES (NEW.CODFIL, QuemLogou.FILUSU, QuemLogou.CODUSU, NEW.FILFOR, NEW.CODFOR, 'PD' || NEW.CODFIL || NEW.NUMPED, NEW.DATPED,
                             0, NEW.VLRBONFUT, NEW.VLRBONFUT, 'PED ' || NEW.CODFIL || NEW.NUMPED, 0, '1', 'F', 'S');
      END IF;
   ELSIF (TG_OP = 'UPDATE') THEN
      IF (Equal(OLD.FLGEST,NEW.FLGEST) <> 1) OR
         (Equal(OLD.VLRBONFUT,NEW.VLRBONFUT) <> 1) OR 
         (Equal(OLD.FILFOR,NEW.FILFOR) <> 1) OR
         (Equal(OLD.CODFOR,NEW.CODFOR) <> 1) THEN
         -- Realiza o Estorno do Lanamento
         bGeraEstorno := ((OLD.CODFOR <> '     0') AND (OLD.VLRBONFUT > 0) AND
                          (((cPENAUT = 'F') AND (OLD.FLGEST NOT IN ('0','C'))) OR ((cPENAUT='T') AND (OLD.FLGEST IN ('2','E')))));
         IF bGeraEstorno THEN
            INSERT INTO TT_CCC (CODFIL, FILUSU, CODUSU, FILCLI, CODCLI, NUMDOC, DATOPE,
                             TIPCCC, VLRLAN, VLRORI, COMPLE, PORORI, TIPLAN, ATULIM, STATUS)
                     VALUES (OLD.CODFIL, QuemLogou.FILUSU, QuemLogou.CODUSU, OLD.FILFOR, OLD.CODFOR, 'PD' || OLD.CODFIL || OLD.NUMPED, OLD.DATPED,
                             0, OLD.VLRBONFUT * (-1), OLD.VLRBONFUT * (-1), 'PED ' || OLD.CODFIL || OLD.NUMPED, 0, '3', 'F', 'S');
         END IF;
         -- Realiza a incluso se novos valores so vlidos
         bGeraNovoCredito := ((NEW.CODFOR <> '     0') AND (NEW.VLRBONFUT > 0) AND
                              (((cPENAUT = 'F') AND (NEW.FLGEST NOT IN ('0','C'))) OR ((cPENAUT='T') AND (NEW.FLGEST IN ('2','E')))));
         IF bGeraNovoCredito THEN
            INSERT INTO TT_CCC (CODFIL, FILUSU, CODUSU, FILCLI, CODCLI, NUMDOC, DATOPE,
                                TIPCCC, VLRLAN, VLRORI, COMPLE, PORORI, TIPLAN, ATULIM, STATUS)
                        VALUES (NEW.CODFIL, QuemLogou.FILUSU, QuemLogou.CODUSU, NEW.FILFOR, NEW.CODFOR, 'PD' || NEW.CODFIL || NEW.NUMPED, NEW.DATPED,
                                0, NEW.VLRBONFUT, NEW.VLRBONFUT, 'PED ' || NEW.CODFIL || NEW.NUMPED, 0, '1', 'F', 'S');
         END IF;
      END IF;

      -- Tratar chamada do processo de gerao dos registros da TT_IVO para o Pedido de Reposio na alterao da situao do pedido o qual necessita estar autorizado (FLGEST = 2) para permitir emisso da nota de transferncia pelo Commerce Web
      IF (LeParametroBoo('SEPARACAO_REPOSICAO', NEW.CODFIL,'','','') = 'T') THEN
         IF (Equal(OLD.FLGEST,NEW.FLGEST) <> 1) AND
            (NEW.CODFOR = '     0') THEN -- Reposio
            IF (NEW.FLGEST = '2') OR -- Autorizados
               (OLD.FLGEST = '2') THEN -- Pedido estava autorizado e foi cancelado, reaberto ou reprovado
                              
                 cDUMMY := PC_PED_IVO_UPDATE(NEW.CODFIL,NEW.NUMPED);
                                          END IF;
         END IF;
      END IF;
      
      --GES-2022061597 - Cancelar item do pedido quando cancelar o pedido.
      IF (Equal(OLD.FLGEST,NEW.FLGEST) <> 1) AND (NEW.FLGEST = 'C') THEN
         UPDATE TT_IPE 
            SET DUMMY = Constante('vem_de_TGPED'),
                FLGEST = NEW.FLGEST
         WHERE CODFIL = OLD.CODFIL
           AND NUMPED = OLD.NUMPED
           AND FLGEST <> 'C';

      END IF;
   END IF;

   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
         cLOG := cLOG||'Situao: de '||COALESCE(DescricaoDominio('PED','FLGEST',OLD.FLGEST),cNulo)||' para '||COALESCE(DescricaoDominio('PED','FLGEST',NEW.FLGEST),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CONPGT,NEW.CONPGT) <> 1 THEN
         cLOG := cLOG||'Condio de pagamento: de '||COALESCE(OLD.CONPGT, cNulo)||' para '||COALESCE(NEW.CONPGT, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.EXPORT,NEW.EXPORT) <> 1 THEN
         cLOG := cLOG||'Exportar: de '||COALESCE(OLD.EXPORT, cNulo)||' para '||COALESCE(NEW.EXPORT, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DATENT, NEW.DATENT) <> 1 THEN
         cLOG := cLOG||'Data prevista para a entrega: de '||COALESCE(TO_CHAR(OLD.DATENT,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATENT,'DD/MM/YYYY'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DATPED, NEW.DATPED) <> 1 THEN
         cLOG := cLOG||'Data do pedido: de '||COALESCE(TO_CHAR(OLD.DATPED,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATPED,'DD/MM/YYYY'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DATENV, NEW.DATENV) <> 1 THEN
         cLOG := cLOG||'Data do envio do pedido eletrnico: de '||COALESCE(TO_CHAR(OLD.DATENV,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATENV,'DD/MM/YYYY'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRLIQ, NEW.VLRLIQ) <> 1 THEN
         cLOG := cLOG||'Valor lquido do pedido: de '||COALESCE(OLD.VLRLIQ, iNulo)||' para '||COALESCE(NEW.VLRLIQ, iNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRTOT, NEW.VLRTOT) <> 1 THEN
         cLOG := cLOG||'Valor total do pedido: de '||COALESCE(OLD.VLRTOT, iNulo)||' para '||COALESCE(NEW.VLRTOT, iNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRBON, NEW.VLRBON) <> 1 THEN
         cLOG := cLOG||'Valor bnus: de '||COALESCE(OLD.VLRBON, iNulo)||' para '||COALESCE(NEW.VLRBON, iNulo)||CRLF;
      END IF;
      IF Equal(OLD.DESCON, NEW.DESCON) <> 1 THEN
         cLOG := cLOG||'Desconto/Acrscimos: de '||COALESCE(OLD.DESCON, iNulo)||' para '||COALESCE(NEW.DESCON, iNulo)||CRLF;
      END IF;
      IF Equal(OLD.OUTTAX, NEW.OUTTAX) <> 1 THEN
         cLOG := cLOG||'Outras Taxas: de '||COALESCE(OLD.OUTTAX, iNulo)||' para '||COALESCE(NEW.OUTTAX, iNulo)||CRLF;
      END IF;
      IF Equal(OLD.QTDTOT, NEW.QTDTOT) <> 1 THEN
         cLOG := cLOG||'Quantidade total do pedido: de '||COALESCE(OLD.QTDTOT, iNulo)||' para '||COALESCE(NEW.QTDTOT, iNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRBON, NEW.VLRBON) <> 1 THEN
         cLOG := cLOG||'Valor Bnus: de '||COALESCE(OLD.VLRBON, iNulo)||' para '||COALESCE(NEW.VLRBON, iNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRFRE, NEW.VLRFRE) <> 1 THEN
         cLOG := cLOG||'Valor do Frete: de '||COALESCE(OLD.VLRFRE, iNulo)||' para '||COALESCE(NEW.VLRFRE, iNulo)||CRLF;
      END IF;
      IF Equal(OLD.DESESP, NEW.DESESP) <> 1 THEN
         cLOG := cLOG||'% Desconto/Acrscimo Financeiro Especial: de '||COALESCE(OLD.DESESP, iNulo)||' para '||COALESCE(NEW.DESESP, iNulo)||CRLF;
      END IF;
      IF Equal(OLD.TIPFOR,NEW.TIPFOR) <> 1 THEN
         cLOG := cLOG||'Tipo de Cliente: de '||COALESCE(OLD.TIPFOR, cNulo)||' para '||COALESCE(NEW.TIPFOR, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODUSU,NEW.CODUSU) <> 1 THEN
         cLOG := cLOG||'Usurio: de '||COALESCE(OLD.CODUSU, cNulo)||' para '||COALESCE(NEW.CODUSU, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILFOR,NEW.FILFOR) <> 1 THEN
         cLOG := cLOG||'Filial do fornecedor: de '||COALESCE(OLD.FILFOR, cNulo)||' para '||COALESCE(NEW.FILFOR, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILUSU,NEW.FILUSU) <> 1 THEN
         cLOG := cLOG||'Filial do usurio: de '||COALESCE(OLD.FILUSU, cNulo)||' para '||COALESCE(NEW.FILUSU, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODFOR,NEW.CODFOR) <> 1 THEN
         cLOG := cLOG||'Cdigo do Fornecedor: de '||COALESCE(OLD.CODFOR, cNulo)||' para '||COALESCE(NEW.CODFOR, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODMOE, NEW.CODMOE) <> 1 THEN
         cLOG := cLOG||'Cdigo da moeda utilizada no pedido: de '||COALESCE(OLD.CODMOE, iNulo)||' para '||COALESCE(NEW.CODMOE, iNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODAPR,NEW.CODAPR) <> 1 THEN
         cLOG := cLOG||'Aprovador: de '||COALESCE(OLD.CODAPR, cNulo)||' para '||COALESCE(NEW.CODAPR, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILAPR,NEW.FILAPR) <> 1 THEN
         cLOG := cLOG||'Cdigo da filial do aprovador: de '||COALESCE(OLD.FILAPR, cNulo)||' para '||COALESCE(NEW.FILAPR, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.OBSERV,NEW.OBSERV) <> 1 THEN
         cLOG := cLOG||'Observaes: de '||RTF2TXT(COALESCE(OLD.OBSERV, cNulo))||' para '||RTF2TXT(COALESCE(NEW.OBSERV, cNulo))||CRLF;
      END IF;
      IF Equal(OLD.PEDFOR,NEW.PEDFOR) <> 1 THEN
         cLOG := cLOG||'Pedido Fornecedor: de '||COALESCE(OLD.PEDFOR, cNulo)||' para '||COALESCE(NEW.PEDFOR, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VENENT,NEW.VENENT) <> 1 THEN
         cLOG := cLOG||'Entrega?: de '||COALESCE(OLD.VENENT, cNulo)||' para '||COALESCE(NEW.VENENT, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PEDEXT,NEW.PEDEXT) <> 1 THEN
         cLOG := cLOG||'Cdigo externo para pedido eletrnico: de '||COALESCE(OLD.PEDEXT, cNulo)||' para '||COALESCE(NEW.PEDEXT, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CONVEN,NEW.CONVEN) <> 1 THEN
         cLOG := cLOG||'Cdigo da Promoo: de '||COALESCE(OLD.CONVEN, cNulo)||' para '||COALESCE(NEW.CONVEN, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILEND,NEW.FILEND) <> 1 THEN
         cLOG := cLOG||'Filial do endereo: de '||COALESCE(OLD.FILEND, cNulo)||' para '||COALESCE(NEW.FILEND, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NUMEND, NEW.NUMEND) <> 1 THEN
         cLOG := cLOG||'Nmero do endereo: de '||COALESCE(OLD.NUMEND, iNulo)||' para '||COALESCE(NEW.NUMEND, iNulo)||CRLF;
      END IF;
      IF Equal(OLD.PROMOC,NEW.PROMOC) <> 1 THEN
         cLOG := cLOG||'Promoo: de '||COALESCE(OLD.PROMOC, cNulo)||' para '||COALESCE(NEW.PROMOC, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NOMARQ,NEW.NOMARQ) <> 1 THEN
         cLOG := cLOG||'Nome do arquivo que o pedido ser exportado: de '||COALESCE(OLD.NOMARQ, cNulo)||' para '||COALESCE(NEW.NOMARQ, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ATUPED,NEW.ATUPED) <> 1 THEN
         cLOG := cLOG||'Atualiza dados para a formao de preo?: de '||COALESCE(OLD.ATUPED, cNulo)||' para '||COALESCE(NEW.ATUPED, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODDOP, NEW.CODDOP) <> 1 THEN
         cLOG := cLOG||'Tipo Documento: de '||COALESCE(OLD.CODDOP, iNulo)||' para '||COALESCE(NEW.CODDOP, iNulo)||CRLF;
      END IF;
      IF Equal(OLD.FREORI,NEW.FREORI) <> 1 THEN
         cLOG := cLOG||'Origem do Clculo do Frete: de '||COALESCE(OLD.FREORI, cNulo)||' para '||COALESCE(NEW.FREORI, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCON,NEW.CODCON) <> 1 THEN
         cLOG := cLOG||'Cdigo na Negociao: de '||COALESCE(OLD.CODCON, cNulo)||' para '||COALESCE(NEW.CODCON, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TRAAUT,NEW.TRAAUT) <> 1 THEN
         cLOG := cLOG||'Tranferncia Automtica?: de '||COALESCE(OLD.TRAAUT, cNulo)||' para '||COALESCE(NEW.TRAAUT, cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DATAPR, NEW.DATAPR) <> 1 THEN
         cLOG := cLOG||'Data de Aprovao: de '||COALESCE(TO_CHAR(OLD.DATAPR,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATAPR,'DD/MM/YYYY'),cNulo)||CRLF;
      END IF;

      IF ISNOTNULL(cLOG) = 'T' THEN
         WK_CODUID := GetCoduidAtual();
         INSERT INTO TL_PED (FILPED,NUMPED,FILUSU,CODUSU,DATOPE,MSGLOG,CODUID)
                     VALUES (NEW.CODFIL, NEW.NUMPED,QuemLogou.FILUSU,QuemLogou.CODUSU,agora(),cLOG,WK_CODUID);
      END IF;
   END IF; -- Fim IF do (TG_OP = 'UPDATE')
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4873 --*/
CREATE TRIGGER TGPED2
AFTER UPDATE OR INSERT ON TT_PED 
FOR EACH ROW EXECUTE PROCEDURE TGPED2();



/*-- SEQ 4874 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPER() CASCADE;

/*-- SEQ 4875 --*/
CREATE OR REPLACE FUNCTION TGPER() RETURNS TRIGGER AS $$
BEGIN
  -- Default
  NEW.ATU_EM := agora();
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4876 --*/
CREATE TRIGGER TGPER
BEFORE INSERT OR UPDATE ON TT_PER 
FOR EACH ROW EXECUTE PROCEDURE TGPER();


/*-- SEQ 4877 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPHO() CASCADE;

/*-- SEQ 4878 --*/
CREATE OR REPLACE FUNCTION TGPHO() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODFIL IS NULL THEN
       SELECT CODLOJ INTO NEW.CODFIL FROM TT_IDF;
    END IF;
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN:=ProximoCodigo('TT_PHO',NEW.CODFIL);
    END IF;
  END IF;
  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN 
     NEW.CODBAR := LTRIM(RTRIM(NEW.CODBAR));
 
     UPDATE TT_GRA SET ATU_EM = AGORA()
      WHERE CODTAM = (SELECT CODITE FROM TT_SUB WHERE CODITE = NEW.CODEXP);

     UPDATE TT_GRA SET ATU_EM = AGORA()
      WHERE CODTAM = (SELECT CODITE FROM TT_SUB WHERE CODITE = OLD.CODEXP);

  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4879 --*/
CREATE TRIGGER TGPHO
BEFORE INSERT OR UPDATE ON TT_PHO 
FOR EACH ROW EXECUTE PROCEDURE TGPHO();


/*-- SEQ 4880 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPIV() CASCADE;

/*-- SEQ 4881 --*/
CREATE OR REPLACE FUNCTION TGPIV() RETURNS TRIGGER AS $$
DECLARE

-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
     IF NEW.SEQUEN IS NULL THEN
        NEW.SEQUEN := ProximoCodigo('TT_PIV',NEW.CODFIL);
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4882 --*/
CREATE TRIGGER TGPIV
BEFORE INSERT ON TT_PIV 
FOR EACH ROW EXECUTE PROCEDURE TGPIV();


/*-- SEQ 4883 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPLA() CASCADE;

/*-- SEQ 4884 --*/
CREATE OR REPLACE FUNCTION TGPLA() RETURNS TRIGGER AS $$
-- Objetivo:
-- Atualizar ATU_EM e gravar log de excluso
DECLARE
   cRet                          VARCHAR(2);
BEGIN
   IF (TG_OP = 'DELETE') THEN
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_PLA', OLD.FILPGT, OLD.CODPGT);
   END IF;
   IF (TG_OP = 'INSERT') THEN
      --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_PLA', NEW.FILPGT, NEW.CODPGT);
   END IF;

   IF NOT (TG_OP = 'DELETE') THEN
      NEW.ATU_EM := AGORA();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4885 --*/
CREATE TRIGGER TGPLA
BEFORE INSERT OR UPDATE OR DELETE ON TT_PLA 
FOR EACH ROW EXECUTE PROCEDURE TGPLA();

/*-- SEQ 4886 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPLA2() CASCADE;

/*-- SEQ 4887 --*/
CREATE OR REPLACE FUNCTION TGPLA2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4888 --*/
CREATE TRIGGER TGPLA2
AFTER INSERT OR UPDATE OR DELETE ON TT_PLA 
FOR EACH ROW EXECUTE PROCEDURE TGPLA2();

/*-- SEQ 4889 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPLA_DW() CASCADE;

/*-- SEQ 4890 --*/
CREATE OR REPLACE FUNCTION TGPLA_DW() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar log para view/tabela materializadas DW_Vendas_Grupos
DECLARE
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');
BEGIN
   -- (TG_OP = 'INSERT'): No faz nada porque ainda no est relacionado a nenhum produto
   -- (TG_OP = 'DELETE'): Garantido pela FK
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.FILPGT,NEW.FILPGT) <> 1 
      OR Equal(OLD.CODPGT,NEW.CODPGT) <> 1 THEN -- PK
         RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
      END IF;
      IF Equal(OLD.APEPGT,NEW.APEPGT) <> 1 THEN
         UPDATE DW_Vendas_Grupos
            SET Plano = InitCap(NEW.APEPGT)
          WHERE FILPGT = NEW.FILPGT
            AND CODPGT = NEW.CODPGT;
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4891 --*/
CREATE TRIGGER TGPLA_DW
AFTER UPDATE ON TT_PLA 
FOR EACH ROW EXECUTE PROCEDURE TGPLA_DW();

/*-- SEQ 4892 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPLA3() CASCADE;

/*-- SEQ 4893 --*/
CREATE OR REPLACE FUNCTION TGPLA3() RETURNS TRIGGER AS $$
DECLARE
   vLOG           VARCHAR(4000)   := '';
   cNulo          CONSTANT CHAR(4) := 'Nulo';
   CRLF           CONSTANT CHAR(1) := CHR(10);
   cFILUSU        VARCHAR(3);
   cCODUSU        VARCHAR(3);   
   WK_CODUID      TT_UID.CODUID%TYPE;
   
   QuemLogou TRetQuemLogou%ROWTYPE;
  

BEGIN
   IF (TG_OP = 'UPDATE') THEN
      
      WK_CODUID := GetCoduidAtual();
      
      select * into QuemLogou from DadosLogon();
      cFILUSU := QuemLogou.FILUSU;
      cCODUSU := QuemLogou.CODUSU;
      
      IF (Equal(OLD.preinf,NEW.preinf) = 0) THEN
         vLOG := vLOG||'Preo Informado?: de '||COALESCE(OLD.preinf,cNulo)||' para '||COALESCE(NEW.preinf,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.tipcob,NEW.tipcob) = 0) THEN
         vLOG := vLOG||'Tipo Cobrana: de '||COALESCE(descricaodominio('PLA','TIPCOB',OLD.tipcob),cNulo)||' para '||COALESCE(descricaodominio('PLA','TIPCOB',OLD.tipcob),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.datmax,NEW.datmax) = 0 THEN
         vLOG := vLOG||'Validade (final): de '||COALESCE(TO_CHAR(OLD.datmax,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.datmax,'DD/MM/YYYY'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.datmin,NEW.datmin) = 0 THEN
         vLOG := vLOG||'Validade (inicial): de '||COALESCE(TO_CHAR(OLD.datmin,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.datmin,'DD/MM/YYYY'),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.aplica,NEW.aplica) = 0) THEN
         vLOG := vLOG||'Aplica Plano Vlido: de '||COALESCE(descricaodominio('PLA','APLICA',TO_CHAR(OLD.aplica)),cNulo)||' para '||COALESCE(descricaodominio('PLA','APLICA',TO_CHAR(NEW.aplica)),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.codmoe,NEW.codmoe) = 0) THEN
         vLOG := vLOG||'Moeda: de '||COALESCE(TO_CHAR(OLD.codmoe),cNulo)||' para '||COALESCE(TO_CHAR(NEW.codmoe),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.moecor,NEW.moecor) = 0) THEN
         vLOG := vLOG||'Moeda Correo: de '||COALESCE(TO_CHAR(OLD.moecor),cNulo)||' para '||COALESCE(TO_CHAR(NEW.moecor),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.atrmax,NEW.atrmax) = 0) THEN
         vLOG := vLOG||'Tolera atraso at: de '||COALESCE(TO_CHAR(OLD.atrmax),cNulo)||' para '||COALESCE(TO_CHAR(NEW.atrmax),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.carmax,NEW.carmax) = 0) THEN
         vLOG := vLOG||'Carncia Mxima: de '||COALESCE(TO_CHAR(OLD.carmax),cNulo)||' para '||COALESCE(TO_CHAR(NEW.carmax),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.codcob,NEW.codcob) = 0) THEN
         vLOG := vLOG||'Cobrana: de '||COALESCE(TO_CHAR(OLD.codcob),cNulo)||' para '||COALESCE(TO_CHAR(NEW.codcob),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.comsob,NEW.comsob) = 0) THEN
         vLOG := vLOG||'Comisso Sobre: de '||COALESCE(descricaodominio('PLA','COMSOB',TO_CHAR(OLD.comsob)),cNulo)||' para '||COALESCE(descricaodominio('PLA','COMSOB',TO_CHAR(NEW.comsob)),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.diaant,NEW.diaant) = 0) THEN
         vLOG := vLOG||'Dias para Desc Antec: de '||COALESCE(TO_CHAR(OLD.diaant),cNulo)||' para '||COALESCE(TO_CHAR(NEW.diaant),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.flgjur,NEW.flgjur) = 0) THEN
         vLOG := vLOG||'Tipo de Juros: de '||COALESCE(descricaodominio('PLA','FLGJUR',TO_CHAR(OLD.flgjur)),cNulo)||' para '||COALESCE(descricaodominio('PLA','FLGJUR',TO_CHAR(NEW.flgjur)),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.formul,NEW.formul) = 0) THEN
         vLOG := vLOG||'Frmula Comisso: de '||COALESCE(descricaodominio('PLA','FORMUL',TO_CHAR(OLD.formul)),cNulo)||' para '||COALESCE(descricaodominio('PLA','FORMUL',TO_CHAR(NEW.formul)),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.medmax,NEW.medmax) = 0) THEN
         vLOG := vLOG||'Maior Mdia Atraso: de '||COALESCE(TO_CHAR(OLD.medmax),cNulo)||' para '||COALESCE(TO_CHAR(NEW.medmax),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.nivusu,NEW.nivusu) = 0) THEN
         vLOG := vLOG||'Nvel Autorizado: de '||COALESCE(descricaodominio('PLA','NIVUSU',TO_CHAR(OLD.nivusu)),cNulo)||' para '||COALESCE(descricaodominio('PLA','NIVUSU',TO_CHAR(NEW.nivusu)),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.paride,NEW.paride) = 0) THEN
         vLOG := vLOG||'Nm Parcelas (ide): de '||COALESCE(TO_CHAR(OLD.paride),cNulo)||' para '||COALESCE(TO_CHAR(NEW.paride),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.parmax,NEW.parmax) = 0) THEN
         vLOG := vLOG||'Nm Parcelas (max): de '||COALESCE(TO_CHAR(OLD.parmax),cNulo)||' para '||COALESCE(TO_CHAR(NEW.parmax),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.parmin,NEW.parmin) = 0) THEN
         vLOG := vLOG||'Nm Parcelas (min): de '||COALESCE(TO_CHAR(OLD.parmin),cNulo)||' para '||COALESCE(TO_CHAR(NEW.parmin),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.parven,NEW.parven) = 0) THEN
         vLOG := vLOG||'Nmero de Parcelas: de '||COALESCE(TO_CHAR(OLD.parven),cNulo)||' para '||COALESCE(TO_CHAR(NEW.parven),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.period,NEW.period) = 0) THEN
         vLOG := vLOG||'Intervalo Parcelas: de '||COALESCE(TO_CHAR(OLD.period),cNulo)||' para '||COALESCE(TO_CHAR(NEW.period),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.pordem,NEW.pordem) = 0) THEN
         vLOG := vLOG||'Portador das Parcela: de '||COALESCE(TO_CHAR(OLD.pordem),cNulo)||' para '||COALESCE(TO_CHAR(NEW.pordem),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.porent,NEW.porent) = 0) THEN
         vLOG := vLOG||'Portador da Entrada: de '||COALESCE(TO_CHAR(OLD.porent),cNulo)||' para '||COALESCE(TO_CHAR(NEW.porent),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.praide,NEW.praide) = 0) THEN
         vLOG := vLOG||'1 Recebimento (ide): de '||COALESCE(TO_CHAR(OLD.praide),cNulo)||' para '||COALESCE(TO_CHAR(NEW.praide),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.pramax,NEW.pramax) = 0) THEN
         vLOG := vLOG||'1 Recebimento (max): de '||COALESCE(TO_CHAR(OLD.pramax),cNulo)||' para '||COALESCE(TO_CHAR(NEW.pramax),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.pramin,NEW.pramin) = 0) THEN
         vLOG := vLOG||'1 Recebimento (min): de '||COALESCE(TO_CHAR(OLD.pramin),cNulo)||' para '||COALESCE(TO_CHAR(NEW.pramin),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.pzoide,NEW.pzoide) = 0) THEN
         vLOG := vLOG||'Prazo Mdio (ide): de '||COALESCE(TO_CHAR(OLD.pzoide),cNulo)||' para '||COALESCE(TO_CHAR(NEW.pzoide),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.pzomax,NEW.pzomax) = 0) THEN
         vLOG := vLOG||'Prazo Mdio (max): de '||COALESCE(TO_CHAR(OLD.pzomax),cNulo)||' para '||COALESCE(TO_CHAR(NEW.pzomax),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.pzomin,NEW.pzomin) = 0) THEN
         vLOG := vLOG||'Prazo Mdio (min): de '||COALESCE(TO_CHAR(OLD.pzomin),cNulo)||' para '||COALESCE(TO_CHAR(NEW.pzomin),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.signat,NEW.signat) = 0) THEN
         vLOG := vLOG||'Ativo?: de '||COALESCE(TO_CHAR(OLD.signat),cNulo)||' para '||COALESCE(TO_CHAR(NEW.signat),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.tippla,NEW.tippla) = 0) THEN
         vLOG := vLOG||'Tipo de Plano: de '||COALESCE(TO_CHAR(OLD.tippla),cNulo)||' para '||COALESCE(TO_CHAR(NEW.tippla),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.totlim,NEW.totlim) = 0) THEN
         vLOG := vLOG||'Total Limitao: de '||COALESCE(TO_CHAR(OLD.totlim),cNulo)||' para '||COALESCE(TO_CHAR(NEW.totlim),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.abamax,NEW.abamax) = 0) THEN
         vLOG := vLOG||'Arredondamento (max): de '||COALESCE(TO_CHAR(OLD.abamax),cNulo)||' para '||COALESCE(TO_CHAR(NEW.abamax), cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.abamin,NEW.abamin) = 0) THEN
         vLOG := vLOG||'Arredondamento (min): de '||COALESCE(TO_CHAR(OLD.abamin),cNulo)||' para '||COALESCE(TO_CHAR(NEW.abamin),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.percom,NEW.percom) = 0) THEN
         vLOG := vLOG||'% Comisso Parcelas: de '||COALESCE(TO_CHAR(OLD.percom),cNulo)||' para '||COALESCE(TO_CHAR(NEW.percom),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.perent,NEW.perent) = 0) THEN
         vLOG := vLOG||'% Comisso Entrada: de '||COALESCE(TO_CHAR(OLD.perent),cNulo)||' para '||COALESCE(TO_CHAR(NEW.perent),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.vlrmax,NEW.vlrmax) = 0) THEN
         vLOG := vLOG||'Valor Compra (max): de '||COALESCE(TO_CHAR(OLD.vlrmax),cNulo)||' para '||COALESCE(TO_CHAR(NEW.vlrmax),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.vlrmin,NEW.vlrmin) = 0) THEN
         vLOG := vLOG||'Valor Compra (min): de '||COALESCE(TO_CHAR(OLD.vlrmin),cNulo)||' para '||COALESCE(TO_CHAR(NEW.vlrmin),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.caronl,NEW.caronl) = 0) THEN
         vLOG := vLOG||'Impr Carn OnLine?: de '||COALESCE(OLD.caronl,cNulo)||' para '||COALESCE(NEW.caronl,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.entvlr,NEW.entvlr) = 0) THEN
         vLOG := vLOG||'Valor Fixo na Entr?: de '||COALESCE(OLD.entvlr,cNulo)||' para '||COALESCE(NEW.entvlr,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.fatura,NEW.fatura) = 0) THEN
         vLOG := vLOG||'Formato Imp Fatura?: de '||COALESCE(OLD.fatura,cNulo)||' para '||COALESCE(NEW.fatura,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.flgesp,NEW.flgesp) = 0) THEN
         vLOG := vLOG||'Parcelas Livres?: de '||COALESCE(OLD.flgesp,cNulo)||' para '||COALESCE(NEW.flgesp,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.jurtot,NEW.jurtot) = 0) THEN
         vLOG := vLOG||'Juros Sobre?: de '||COALESCE(OLD.jurtot,cNulo)||' para '||COALESCE(NEW.jurtot,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.apepgt,NEW.apepgt) = 0) THEN
         vLOG := vLOG||'Apelido: de '||COALESCE(OLD.apepgt,cNulo)||' para '||COALESCE(NEW.apepgt,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.despgt,NEW.despgt) = 0) THEN
         vLOG := vLOG||'Descrio: de '||COALESCE(OLD.despgt,cNulo)||' para '||COALESCE(NEW.despgt,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.datpre,NEW.datpre) = 0) THEN
         vLOG := vLOG||'Data Pre-Datamento: de '||COALESCE(TO_CHAR(OLD.datpre,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.datpre,'DD/MM/YYYY'),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.class1,NEW.class1) = 0) THEN
         vLOG := vLOG||'Categoria: de '||COALESCE(TO_CHAR(OLD.class1),cNulo)||' para '||COALESCE(TO_CHAR(NEW.class1),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.class2,NEW.class2) = 0) THEN
         vLOG := vLOG||'Grupo: de '||COALESCE(TO_CHAR(OLD.class2),cNulo)||' para '||COALESCE(TO_CHAR(NEW.class2),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.class3,NEW.class3) = 0) THEN
         vLOG := vLOG||'Estoque: de '||COALESCE(TO_CHAR(OLD.class3),cNulo)||' para '||COALESCE(TO_CHAR(NEW.class3),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.class4,NEW.class4) = 0) THEN
         vLOG := vLOG||'Seo: de '||COALESCE(TO_CHAR(OLD.class4),cNulo)||' para '||COALESCE(TO_CHAR(NEW.class4),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.codnat,NEW.codnat) = 0) THEN
         vLOG := vLOG||'Natureza: de '||COALESCE(TO_CHAR(OLD.codnat),cNulo)||' para '||COALESCE(TO_CHAR(NEW.codnat),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.propor,NEW.propor) = 0) THEN
         vLOG := vLOG||'Proporo?: de '||COALESCE(OLD.propor,cNulo)||' para '||COALESCE(NEW.propor,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.usacam,NEW.usacam) = 0) THEN
         vLOG := vLOG||'Usa Cmbio?: de '||COALESCE(OLD.usacam,cNulo)||' para '||COALESCE(NEW.usacam,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.usache,NEW.usache) = 0) THEN
         vLOG := vLOG||'Usa Cheque?: de '||COALESCE(OLD.usache,cNulo)||' para '||COALESCE(NEW.usache,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.usacre,NEW.usacre) = 0) THEN
         vLOG := vLOG||'Usa Carto Crdito?: de '||COALESCE(OLD.usacre,cNulo)||' para '||COALESCE(NEW.usacre,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.usac_c,NEW.usac_c) = 0) THEN
         vLOG := vLOG||'Usa Conta Corrente?: de '||COALESCE(OLD.usac_c,cNulo)||' para '||COALESCE(NEW.usac_c,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.usadin,NEW.usadin) = 0) THEN
         vLOG := vLOG||'Usa Dinheiro?: de '||COALESCE(OLD.usadin,cNulo)||' para '||COALESCE(NEW.usadin,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.usaout,NEW.usaout) = 0) THEN
         vLOG := vLOG||'Usa Outros?: de '||COALESCE(OLD.usaout,cNulo)||' para '||COALESCE(NEW.usaout,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.usatef,NEW.usatef) = 0) THEN
         vLOG := vLOG||'Usa T.E.F.?: de '||COALESCE(OLD.usatef,cNulo)||' para '||COALESCE(NEW.usatef,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.codext,NEW.codext) = 0) THEN
         vLOG := vLOG||'Codigo Externo: de '||COALESCE(TO_CHAR(OLD.codext),cNulo)||' para '||COALESCE(TO_CHAR(NEW.codext),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.codprt,NEW.codprt) = 0) THEN
         vLOG := vLOG||'Instruo Protesto: de '||COALESCE(TO_CHAR(OLD.codprt),cNulo)||' para '||COALESCE(TO_CHAR(NEW.codprt),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.przprt,NEW.przprt) = 0) THEN
         vLOG := vLOG||'Prazo de Protesto: de '||COALESCE(TO_CHAR(OLD.przprt),cNulo)||' para '||COALESCE(TO_CHAR(NEW.przprt),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.codbai,NEW.codbai) = 0) THEN
         vLOG := vLOG||'Instruo de Baixa: de '||COALESCE(DescricaoDominio('PLA','CODBAI',TO_CHAR(OLD.codbai)),cNulo)||' para '||COALESCE(DescricaoDominio('PLA','CODBAI',TO_CHAR(NEW.codbai)),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.przbai,NEW.przbai) = 0) THEN
         vLOG := vLOG||'Prazo dias de Baixa: de '||COALESCE(TO_CHAR(OLD.przbai),cNulo)||' para '||COALESCE(TO_CHAR(NEW.przbai),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.de1min,NEW.de1min) = 0) THEN
         vLOG := vLOG||'% Desc Acres (min): de '||COALESCE(TO_CHAR(OLD.de1min),cNulo)||' para '||COALESCE(TO_CHAR(NEW.de1min),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.de1max,NEW.de1max) = 0) THEN
         vLOG := vLOG||'% Desc Acres (max): de '||COALESCE(TO_CHAR(OLD.de1max),cNulo)||' para '||COALESCE(TO_CHAR(NEW.de1max),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.de1ide,NEW.de1ide) = 0) THEN
         vLOG := vLOG||'% Desc Acres (ide): de '||COALESCE(TO_CHAR(OLD.de1ide),cNulo)||' para '||COALESCE(TO_CHAR(NEW.de1ide),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.acrdia,NEW.acrdia) = 0) THEN
         vLOG := vLOG||'Acrscimo ao Dia): de '||COALESCE(TO_CHAR(OLD.acrdia),cNulo)||' para '||COALESCE(TO_CHAR(NEW.acrdia),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.desant,NEW.desant) = 0) THEN
         vLOG := vLOG||'% Desc Antecipado: de '||COALESCE(TO_CHAR(OLD.desant),cNulo)||' para '||COALESCE(TO_CHAR(NEW.desant),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.chrrec,NEW.chrrec) = 0) THEN
         vLOG := vLOG||'N Mx Dias Cheque: de '||COALESCE(TO_CHAR(OLD.chrrec),cNulo)||' para '||COALESCE(TO_CHAR(NEW.chrrec),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.desrec,NEW.desrec) = 0) THEN
         vLOG := vLOG||'Desconto Antecipado?: de '||COALESCE(OLD.desrec,cNulo)||' para '||COALESCE(NEW.desrec,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.renego,NEW.renego) = 0) THEN
         vLOG := vLOG||'Renegociao?: de '||COALESCE(OLD.renego,cNulo)||' para '||COALESCE(NEW.renego,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.jurren,NEW.jurren) = 0) THEN
         vLOG := vLOG||'Juros Renegociao: de '||COALESCE(TO_CHAR(OLD.jurren),cNulo)||' para '||COALESCE(TO_CHAR(NEW.jurren),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.rensob,NEW.rensob) = 0) THEN
         vLOG := vLOG||'Calculado Sobre: de '||COALESCE(DescricaoDominio('PLA','RENSOB',OLD.rensob),cNulo)||' para '||COALESCE(DescricaoDominio('PLA','RENSOB',NEW.rensob),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.priide,NEW.priide) = 0) THEN
         vLOG := vLOG||'% 1 Recto (ideal): de '||COALESCE(TO_CHAR(OLD.priide),cNulo)||' para '||COALESCE(TO_CHAR(NEW.priide),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.primax,NEW.primax) = 0) THEN
         vLOG := vLOG||'% 1 Recto (max): de '||COALESCE(TO_CHAR(OLD.primax),cNulo)||' para '||COALESCE(TO_CHAR(NEW.primax),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.primin,NEW.primin) = 0) THEN
         vLOG := vLOG||'% 1 Recto (min): de '||COALESCE(TO_CHAR(OLD.primin),cNulo)||' para '||COALESCE(TO_CHAR(NEW.primin),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.desjur,NEW.desjur) = 0) THEN
         vLOG := vLOG||'% Desc sobre Juros: de '||COALESCE(TO_CHAR(OLD.desjur),cNulo)||' para '||COALESCE(TO_CHAR(NEW.desjur),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.diatit,NEW.diatit) = 0) THEN
         vLOG := vLOG||'Dias para Ttulos: de '||COALESCE(TO_CHAR(OLD.diatit),cNulo)||' para '||COALESCE(TO_CHAR(NEW.diatit),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.vltxmu,NEW.vltxmu) = 0) THEN
         vLOG := vLOG||'Valor Total x Multa: de '||COALESCE(TO_CHAR(OLD.vltxmu),cNulo)||' para '||COALESCE(TO_CHAR(NEW.vltxmu),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.intpmu,NEW.intpmu) = 0) THEN
         vLOG := vLOG||'Tipo Multa: de '||COALESCE(DescricaoDominio('PLA','INTPMU',OLD.intpmu),cNulo)||' para '||COALESCE(DescricaoDominio('PLA','INTPMU',NEW.intpmu),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.usacpp,NEW.usacpp) = 0) THEN
         vLOG := vLOG||'Carto Prprio Parc?: de '||COALESCE(OLD.usacpp,cNulo)||' para '||COALESCE(NEW.usacpp,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.bonpgt,NEW.bonpgt) = 0) THEN
         vLOG := vLOG||'Bnus Pgt Antec: de '||COALESCE(TO_CHAR(OLD.bonpgt),cNulo)||' para '||COALESCE(TO_CHAR(NEW.bonpgt),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.carfat,NEW.carfat) = 0) THEN
         vLOG := vLOG||'Carncia Fat dias: de '||COALESCE(TO_CHAR(OLD.carfat),cNulo)||' para '||COALESCE(TO_CHAR(NEW.carfat),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.tipccc,NEW.tipccc) = 0) THEN
         vLOG := vLOG||'Tipo Conta Corrente: de '||COALESCE(TO_CHAR(OLD.tipccc),cNulo)||' para '||COALESCE(TO_CHAR(NEW.tipccc),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.categ1,NEW.categ1) = 0) THEN
         vLOG := vLOG||'Setor: de '||COALESCE(TO_CHAR(OLD.categ1),cNulo)||' para '||COALESCE(TO_CHAR(NEW.categ1),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.categ2,NEW.categ2) = 0) THEN
         vLOG := vLOG||'Segmento: de '||COALESCE(TO_CHAR(OLD.categ2),cNulo)||' para '||COALESCE(TO_CHAR(NEW.categ2),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.categ3,NEW.categ3) = 0) THEN
         vLOG := vLOG||'Int paper: de '||COALESCE(TO_CHAR(OLD.categ3),cNulo)||' para '||COALESCE(TO_CHAR(NEW.categ3),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.jurflx,NEW.jurflx) = 0) THEN
         vLOG := vLOG||'Juros FLEX: de '||COALESCE(TO_CHAR(OLD.jurflx),cNulo)||' para '||COALESCE(TO_CHAR(NEW.jurflx),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.diaflx,NEW.diaflx) = 0) THEN
         vLOG := vLOG||'Dias flexveis: de '||COALESCE(TO_CHAR(OLD.diaflx),cNulo)||' para '||COALESCE(TO_CHAR(NEW.diaflx),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.plaout,NEW.plaout) = 0) THEN
         vLOG := vLOG||'Tipo Outros: de '||COALESCE(TO_CHAR(OLD.plaout),cNulo)||' para '||COALESCE(TO_CHAR(NEW.plaout),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.acrbol,NEW.acrbol) = 0) THEN
         vLOG := vLOG||'Acrs venda boleto: de '||COALESCE(TO_CHAR(OLD.acrbol),cNulo)||' para '||COALESCE(TO_CHAR(NEW.acrbol),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.usadeb,NEW.usadeb) = 0) THEN
         vLOG := vLOG||'Usa dbito em C/C: de '||COALESCE(OLD.usadeb,cNulo)||' para '||COALESCE(NEW.usadeb,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.codfin,NEW.codfin) = 0) THEN
         vLOG := vLOG||'Financeira: de '||COALESCE(TO_CHAR(OLD.codfin),cNulo)||' para '||COALESCE(TO_CHAR(NEW.codfin),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.sobneg,NEW.sobneg) = 0) THEN
         vLOG := vLOG||'Sob negociao: de '||COALESCE(OLD.sobneg,cNulo)||' para '||COALESCE(NEW.sobneg,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.minpar,NEW.minpar) = 0) THEN
         vLOG := vLOG||'Valor mnimo parcela: de '||COALESCE(TO_CHAR(OLD.minpar),cNulo)||' para '||COALESCE(TO_CHAR(NEW.minpar),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.inddes,NEW.inddes) = 0) THEN
         vLOG := vLOG||'ndice Desconto (%): de '||COALESCE(TO_CHAR(OLD.inddes),cNulo)||' para '||COALESCE(TO_CHAR(NEW.inddes),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.desesp,NEW.desesp) = 0) THEN
         vLOG := vLOG||'Desconto Especial: de '||COALESCE(TO_CHAR(OLD.desesp),cNulo)||' para '||COALESCE(TO_CHAR(NEW.desesp),cNulo)||CRLF;
      END IF;
      
      IF ISNOTNULL(TRIM(vLOG)) = 'T' THEN
         vLOG:='Alteraes em TT_PLA'||CRLF||vLOG;
         INSERT INTO TL_PLA (FILPLA, CODPLA, DATOPE, FILUSU, CODUSU, MSGLOG, CODUID)
                     VALUES (NEW.FILPGT, NEW.CODPGT, Agora(), cFILUSU, cCODUSU, vLOG, WK_CODUID);
      END IF;
   END IF;   
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4894 --*/
CREATE TRIGGER TGPLA3
AFTER UPDATE ON TT_PLA 
FOR EACH ROW EXECUTE PROCEDURE TGPLA3();


/*-- SEQ 4895 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPLAXCAR() CASCADE;

/*-- SEQ 4896 --*/
CREATE OR REPLACE FUNCTION TGPLAXCAR() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN:=ProximoCodigo('TT_PLAXCAR',NEW.CODFIL);
    END IF;
    NEW.DATINC := AGORA();
    NEW.ATU_EM := AGORA();
  END IF;
  IF (TG_OP = 'UPDATE') THEN
    NEW.ATU_EM := AGORA();
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4897 --*/
CREATE TRIGGER TGPLAXCAR
BEFORE INSERT OR UPDATE ON TT_PLAXCAR 
FOR EACH ROW EXECUTE PROCEDURE TGPLAXCAR();

/*-- SEQ 4898 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPLAXCAR2() CASCADE;

/*-- SEQ 4899 --*/
CREATE OR REPLACE FUNCTION TGPLAXCAR2() RETURNS TRIGGER AS $$
DECLARE
   vLOG           VARCHAR(4000)   := '';
   cNulo          CONSTANT CHAR(4) := 'Nulo';
   CRLF           CONSTANT CHAR(1) := CHR(10);
   cFILUSU        VARCHAR(3);
   cCODUSU        VARCHAR(3);    
   WK_CODUID      TT_UID.CODUID%TYPE;
   
   QuemLogou TRetQuemLogou%ROWTYPE;

BEGIN
   WK_CODUID := GetCoduidAtual();
     
   select * into QuemLogou from DadosLogon();
   cFILUSU := QuemLogou.FILUSU;
   cCODUSU := QuemLogou.CODUSU;
   
   IF (TG_OP = 'INSERT') THEN
      vLOG := vLOG||'Carto: '||COALESCE(TO_CHAR(NEW.cartao),cNulo)||CRLF;
      vLOG := vLOG||'Crdito?: '||COALESCE(NEW.flgcre,cNulo)||CRLF;
      vLOG := vLOG||'Dbito?: '||COALESCE(NEW.flgdeb,cNulo)||CRLF;
      
      IF ISNOTNULL(vLOG) = 'T' THEN
         vLOG:='Inserindo em TT_PLAXCAR'||CRLF||vLOG;
      END IF;
   END IF;

   IF (TG_OP = 'UPDATE') THEN
      IF (Equal(OLD.cartao,NEW.cartao) = 0) THEN
         vLOG := vLOG||'Carto: de '||COALESCE(TO_CHAR(OLD.cartao),cNulo)||' para '||COALESCE(TO_CHAR(NEW.cartao),cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.flgcre,NEW.flgcre) = 0) THEN
         vLOG := vLOG||'Crdito?: de '||COALESCE(OLD.flgcre,cNulo)||' para '||COALESCE(NEW.flgcre,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.flgdeb,NEW.flgdeb) = 0) THEN
         vLOG := vLOG||'Dbito?: de '||COALESCE(OLD.flgdeb,cNulo)||' para '||COALESCE(NEW.flgdeb,cNulo)||CRLF;
      END IF;
     
      IF ISNOTNULL(vLOG) = 'T' THEN
         vLOG:='Alteraes em TT_PLAXCAR'||CRLF||vLOG;
      END IF;
   END IF;
   
   IF (TG_OP = 'DELETE') THEN
      vLOG := vLOG||'Carto: '||COALESCE(TO_CHAR(OLD.cartao),cNulo)||CRLF;
      vLOG := vLOG||'Crdito?: '||COALESCE(OLD.flgcre,cNulo)||CRLF;
      vLOG := vLOG||'Dbito?: '||COALESCE(OLD.flgdeb,cNulo)||CRLF;
      
      IF ISNOTNULL(vLOG) = 'T' THEN
         vLOG:='Deletando em TT_PLAXCAR'||CRLF||vLOG;
      END IF;
   END IF;
   
   IF ISNOTNULL(vLOG) = 'T' THEN
      IF (TG_OP = 'DELETE') THEN
         INSERT INTO TL_PLA (FILPLA, CODPLA, DATOPE, FILUSU, CODUSU, MSGLOG, CODUID)
                     VALUES (OLD.FILPGT, OLD.CODPGT, Agora(), cFILUSU, cCODUSU, vLOG, WK_CODUID);
      ELSE
         INSERT INTO TL_PLA (FILPLA, CODPLA, DATOPE, FILUSU, CODUSU, MSGLOG, CODUID)
                     VALUES (NEW.FILPGT, NEW.CODPGT, Agora(), cFILUSU, cCODUSU, vLOG, WK_CODUID);
      END IF;
   END IF;
   
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4900 --*/
CREATE TRIGGER TGPLAXCAR2
AFTER INSERT OR UPDATE OR DELETE ON TT_PLAXCAR 
FOR EACH ROW EXECUTE PROCEDURE TGPLAXCAR2();


/*-- SEQ 4901 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPLAY() CASCADE;

/*-- SEQ 4902 --*/
CREATE OR REPLACE FUNCTION TGPLAY() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
DECLARE
  proximo Numeric;  
BEGIN
  IF NEW.SEQUEN IS NULL THEN
    SELECT NEXTVAL('sqPLAY') INTO proximo FROM DUAL;
    NEW.SEQUEN := LPAD(RTRIM(proximo),10,' ');
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4903 --*/
CREATE TRIGGER TGPLAY
BEFORE INSERT ON TP_LAY 
FOR EACH ROW EXECUTE PROCEDURE TGPLAY();


/*-- SEQ 4904 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPPR() CASCADE;

/*-- SEQ 4905 --*/
CREATE OR REPLACE FUNCTION TGPPR() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Atualiza coluna ATU_EM, DATINI, DATFIM

      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
   
BEGIN
   -- Popula as colunas SEQUEN e DATINC
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN := ProximoCodigo('TT_PPR', NEW.CODFIL);
      END IF;
      NEW.DATINC := Agora();

      if NEW.FILUSU IS NULL THEN
         select * into QuemLogou from DadosLogon();
         NEW.FILUSU := QuemLogou.FILUSU;
         NEW.CODUSU := QuemLogou.CODUSU;
      END IF;
   END IF;

   -- Popula a coluna ATU_EM, DATINI, DATFIM
   IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
      NEW.ATU_EM := Agora();
      NEW.EXPORT := 'F';

      IF NEW.DATINI IS NULL THEN
         NEW.DATINI := Agora();
      END IF;
      IF NEW.DATFIM IS NULL THEN
         NEW.DATFIM := Agora();
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4906 --*/
CREATE TRIGGER TGPPR
BEFORE INSERT OR UPDATE ON TT_PPR 
FOR EACH ROW EXECUTE PROCEDURE TGPPR();  


/*-- SEQ 4907 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPRE1() CASCADE;

/*-- SEQ 4908 --*/
CREATE OR REPLACE FUNCTION TGPRE1() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Assumir sempre a data do banco
-- 3) "Delete cascade" na tabela de "log"

   cRet                          VARCHAR(2);
   wk_DECIMA                     TT_PRO.DECIMA%TYPE;

   --LEO 84337
   vCODUID_ATUAL                 TT_VEN.CODUID%TYPE;
   vBLQ_SEM_UID                  TT_CFG.BLQ_SEM_UID%TYPE;
   vSESSIONID                    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

BEGIN
   -- Gera codigo sequencial exclusivo
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN := ProximoCodigo('TT_PRE',NEW.FILPRE);
      END IF;

      --Almir R Borges 93888
      IF NEW.DATINC IS NULL THEN
         NEW.DATINC := agora();
      END IF;

      IF NEW.FLGEST IS NULL THEN
         IF AuxDisponivelVenda(NEW.FILMAT,NEW.CODMAT) THEN
            NEW.FLGEST := 'T';
         ELSE
            NEW.FLGEST := 'F';
         END IF;
      END IF;
   END IF;

   IF (TG_OP = 'DELETE') THEN
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_PRE', rpad(OLD.FILMAT || OLD.CODMAT || '-' || TO_CHAR(OLD.CODCOR) || '-' || TO_CHAR(OLD.CODTAM), 20,' '),
                         OLD.FILPRE || OLD.CODPRE);
   END IF;
   IF (TG_OP = 'INSERT') THEN
      --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_PRE', rpad(NEW.FILMAT || NEW.CODMAT || '-' || TO_CHAR(NEW.CODCOR) || '-' || TO_CHAR(NEW.CODTAM), 20,' '),
                         NEW.FILPRE || NEW.CODPRE);
   END IF;

   -- Almir R Borges 93887
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.PRECOV,NEW.PRECOV) <> 1 THEN
         NEW.ULTREA := agora();
      END IF;
   END IF;

   IF NOT (TG_OP = 'DELETE') THEN
      -- "default"
      NEW.ATU_EM := AGORA();
   END IF;

   -- RFMP 83838 - Tratamento para amenizar problemas com quantidade no Checkout
   IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
      SELECT PRO.DECIMA
        INTO wk_DECIMA
        FROM TT_PRO PRO
       WHERE PRO.FILMAT = NEW.FILMAT
         AND PRO.CODMAT = NEW.CODMAT;
      IF wk_DECIMA = 'F' THEN
         NEW.PRECOV := ROUND(NEW.PRECOV,2);
      END IF;
   END IF;

   IF (TG_OP = 'DELETE') THEN
      -- LEO 84337
      SELECT BLQ_SEM_UID
        INTO vBLQ_SEM_UID
        FROM TT_CFG;
      vCODUID_ATUAL := GetCoduidAtual();
      IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;
   END IF;

   IF (TG_OP = 'INSERT') THEN

      -- LEO 84337
      SELECT BLQ_SEM_UID
        INTO vBLQ_SEM_UID
        FROM TT_CFG;
      vCODUID_ATUAL := GetCoduidAtual();
      IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;

      -- Douglas - 83441
      NEW.CODUID := GetCoduidAtual();
      NEW.ASSINA := COALESCE(AssinaTabela('TT_PRE',
                                       ConcatenaPRE(NEW.FILPRE,
                                                    NEW.CODPRE,
                                                    NEW.FILMAT,
                                                    NEW.CODMAT,
                                                    NEW.CODCOR,
                                                    NEW.CODTAM,
                                                    NEW.PRECOV),
                                       null, null, null),NEW.ASSINA);
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF ConcatenaPRE(NEW.FILPRE,NEW.CODPRE,NEW.FILMAT,NEW.CODMAT,
                     NEW.CODCOR,NEW.CODTAM,NEW.PRECOV) <>
         ConcatenaPRE(OLD.FILPRE,OLD.CODPRE,OLD.FILMAT,OLD.CODMAT,
                     OLD.CODCOR,OLD.CODTAM,OLD.PRECOV) THEN

         -- LEO 84337
         SELECT BLQ_SEM_UID
           INTO vBLQ_SEM_UID
           FROM TT_CFG;
         vCODUID_ATUAL := GetCoduidAtual();
         IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;

         -- Douglas - 83441
         NEW.CODUID := GetCoduidAtual();
         NEW.ASSINA := COALESCE(AssinaTabela('TT_PRE',
                                         ConcatenaPRE(NEW.FILPRE,
                                                      NEW.CODPRE,
                                                      NEW.FILMAT,
                                                      NEW.CODMAT,
                                                      NEW.CODCOR,
                                                      NEW.CODTAM,
                                                      NEW.PRECOV),
                                         OLD.CODUID,
                                         ConcatenaPRE(OLD.FILPRE,
                                                      OLD.CODPRE,
                                                      OLD.FILMAT,
                                                      OLD.CODMAT,
                                                      OLD.CODCOR,
                                                      OLD.CODTAM,
                                                      OLD.PRECOV),
                                         OLD.ASSINA ),NEW.ASSINA);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4909 --*/
CREATE TRIGGER TGPRE1
BEFORE INSERT OR DELETE OR UPDATE ON TT_PRE 
FOR EACH ROW EXECUTE PROCEDURE TGPRE1();

/*-- SEQ 4910 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPRE2() CASCADE;

/*-- SEQ 4911 --*/
CREATE OR REPLACE FUNCTION TGPRE2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Registrar mudanca dos dados num "log"
--
DECLARE
   vLOG                          VARCHAR(4000)     := '';
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;               
   vPREANT                       Numeric(12,4) := Null;
   vCUSANT                       Numeric(12,4) := Null;
   vCUSVENANT                    Numeric(12,4) := Null;
   vDESFIXANT                    Numeric(12,4) := Null;
   vLUCPRJANT                    Numeric(12,4) := Null;
   cRetorno                      VARCHAR(2);
   --cWhere                        TM_ATU.FILTRO%TYPE;
-- Principal
BEGIN
   --Tratamento para Atualizar Tabela Pai
   --IF (TG_OP = 'INSERT')
   --OR (TG_OP = 'UPDATE') THEN
   --   cWhere := 'FILMAT = ' || CHR(39) || NEW.FILMAT  || CHR(39) || ' AND CODMAT = ' || CHR(39) || NEW.CODMAT || CHR(39) ||
   --             ' AND CODCOR = ' || TO_CHAR( NEW.CODCOR ) || ' AND CODTAM = ' || TO_CHAR( NEW.CODTAM );
   --ELSIF (TG_OP = 'DELETE') THEN
   --   cWhere := 'FILMAT = ' || CHR(39) || OLD.FILMAT  || CHR(39) || ' AND CODMAT = ' || CHR(39) || OLD.CODMAT || CHR(39) ||
   --             ' AND CODCOR = ' || TO_CHAR( OLD.CODCOR ) || ' AND CODTAM = ' || TO_CHAR( OLD.CODTAM );
   --END IF;
   --cRetorno := INSERE_MATU('TT_PRE', 'TT_GRA', cWhere);

   -- RFMP 101993
   -- Atualizao do ATU_EM da TT_GRA foi removido porque o preo  muito mais atualizado que o cadastro de produtos.
   -- Provavelmente, foi feito esse tratamento porque o PRECOV  um dado da TV_IPR.

   -- Tratamento de log
   IF (TG_OP = 'DELETE') THEN
      DELETE FROM TL_PRE WHERE FILPRE = OLD.FILPRE AND SEQPRE = OLD.SEQUEN;
   ELSIF (TG_OP = 'UPDATE') THEN     
      IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
         vLOG := vLOG||'Flag: de '||COALESCE(OLD.FLGEST,cNulo)||' para '||COALESCE(NEW.FLGEST,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODMOE,NEW.CODMOE) <> 1  THEN
         vLOG := vLOG||'Moeda: de '||COALESCE(OLD.CODMOE,iNulo)||' para '||COALESCE(NEW.CODMOE,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.PRECOV,NEW.PRECOV) <> 1 THEN
         vLOG := vLOG||'Preco: de '||TO_CHAR(COALESCE(OLD.PRECOV,iNulo),'fm99G999G990D00')||' para '||TO_CHAR(COALESCE(NEW.PRECOV,iNulo),'fm99G999G990D00')||CRLF;
         vPREANT := OLD.PRECOV;
      END IF;
      IF Equal(OLD.DESMAX,NEW.DESMAX) <> 1 THEN
         vLOG := vLOG||'Desconto maximo: de '||TO_CHAR(COALESCE(OLD.DESMAX,iNulo),'fm9G999G999G990D00')||' para '||TO_CHAR(COALESCE(NEW.DESMAX,iNulo),'fm9G999G999G990D00')||CRLF;
      END IF;
      IF Equal(OLD.MULTIP,NEW.MULTIP) <> 1 THEN
         vLOG := vLOG||'Multiplicador: de '||TO_CHAR(COALESCE(OLD.MULTIP,iNulo),'fm99D9999')||' para '||TO_CHAR(COALESCE(NEW.MULTIP,iNulo),'fm99D9999')||CRLF;
      END IF;
      IF Equal(OLD.PERLUC,NEW.PERLUC) <> 1 THEN
         vLOG := vLOG||'% Lucro: de '||TO_CHAR(COALESCE(OLD.PERLUC,iNulo),'fm990D00')||' para '||TO_CHAR(COALESCE(NEW.PERLUC,iNulo),'fm990D00')||CRLF;
      END IF;
      IF Equal(OLD.CUSREP,NEW.CUSREP) <> 1 THEN
         vLOG := vLOG||'% Custo de Reposio na FPV: de '||TO_CHAR(COALESCE(OLD.CUSREP,iNulo),'fm990D00')||' para '||TO_CHAR(COALESCE(NEW.CUSREP,iNulo),'fm990D00')||CRLF;
      END IF;
      IF Equal(OLD.ULTELA,NEW.ULTELA) <> 1 THEN
         vLOG := vLOG||'Elasticidade: de '||TO_CHAR(COALESCE(OLD.ULTELA,iNulo),'fm9G999G999G990D00')||' para '||TO_CHAR(COALESCE(NEW.ULTELA,iNulo),'fm9G999G999G990D00')||CRLF;
      END IF;
      IF Equal(OLD.DIAELA,NEW.DIAELA) <> 1 THEN
         vLOG := vLOG||'Nm Dias Elastici: de '||TO_CHAR(COALESCE(OLD.DIAELA,iNulo),'fm9990')||' para '||TO_CHAR(COALESCE(NEW.DIAELA,iNulo),'fm9990')||CRLF;
      END IF;
      IF Equal(OLD.CUSVEN,NEW.CUSVEN) <> 1 THEN
         vLOG := vLOG||'Custo Total de Venda: de '||TO_CHAR(COALESCE(OLD.CUSVEN,iNulo),'fm99G999G990D0000')||' para '||TO_CHAR(COALESCE(NEW.CUSVEN,iNulo),'fm99G999G990D0000')||CRLF;
      END IF;
      IF Equal(OLD.DESFIX,NEW.DESFIX) <> 1 THEN
         vLOG := vLOG||'Despesa Operacional Fixa: de '||TO_CHAR(COALESCE(OLD.DESFIX,iNulo),'fm99G999G990D0000')||' para '||TO_CHAR(COALESCE(NEW.DESFIX,iNulo),'fm99G999G990D0000')||CRLF;
      END IF;
      IF Equal(OLD.LUCPRJ,NEW.LUCPRJ) <> 1 THEN
         vLOG := vLOG||'Lucro Projetado: de '||TO_CHAR(COALESCE(OLD.LUCPRJ,iNulo),'fm99G999G990D0000')||' para '||TO_CHAR(COALESCE(NEW.LUCPRJ,iNulo),'fm99G999G990D0000')||CRLF;
      END IF;
      IF Equal(OLD.DATINC,NEW.DATINC) <> 1 THEN
         vLOG := vLOG||'Data da Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PEROPEFIX,NEW.PEROPEFIX) <> 1 THEN
         vLOG := vLOG||'% Despesas Operacionais Fixas: de '||TO_CHAR(COALESCE(OLD.PEROPEFIX,iNulo),'fm9G999G990D0000')||' para '||TO_CHAR(COALESCE(NEW.PEROPEFIX,iNulo),'fm9G999G990D0000')||CRLF;
      END IF;
      IF Equal(OLD.PERLUCPRJ,NEW.PERLUCPRJ) <> 1 THEN
         vLOG := vLOG||'% Lucro FPV: de '||TO_CHAR(COALESCE(OLD.PERLUCPRJ,iNulo),'fm9G999G990D0000')||' para '||TO_CHAR(COALESCE(NEW.PERLUCPRJ,iNulo),'fm9G999G990D0000')||CRLF;
      END IF;
      IF Equal(OLD.DESIDE,NEW.DESIDE) <> 1 THEN
         vLOG := vLOG||'% Desconto Ideal: de '||TO_CHAR(COALESCE(OLD.DESIDE,iNulo),'fm90D0099')||' para '||TO_CHAR(COALESCE(NEW.DESIDE,iNulo),'fm90D0099')||CRLF;
      END IF;

      vCUSVENANT := OLD.CUSVEN;
      vDESFIXANT := OLD.DESFIX;
      vLUCPRJANT := OLD.LUCPRJ;
      vCUSANT    := OLD.CUSREP;

      IF ISNOTNULL(vLOG) = 'T' THEN
         -- Inclui uma linha em TL_PRE
         INSERT INTO TL_PRE (FILPRE,SEQPRE,DATOPE,MSGLOG,PREANT,CUSANT,CUSVENANT,DESFIXANT,LUCPRJANT )
                     VALUES (NEW.FILPRE,NEW.SEQUEN,agora(),vLOG,vPREANT,vCUSANT,vCUSVENANT,vDESFIXANT,vLUCPRJANT);
      END IF;
      
      -- MN - GES-2019093529 - Trata Auditoria
      IF Equal(OLD.PRECOV,NEW.PRECOV) <> 1 THEN
        cRetorno := InsereAuditoriaPreco(NEW.FILPRE, NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM, OLD.PRECOV, NEW.PRECOV);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4912 --*/
CREATE TRIGGER TGPRE2
AFTER INSERT OR UPDATE OR DELETE ON TT_PRE 
FOR EACH ROW EXECUTE PROCEDURE TGPRE2();

/*-- SEQ 4913 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPRE_ASS() CASCADE;

/*-- SEQ 4914 --*/
CREATE OR REPLACE FUNCTION TGPRE_ASS() RETURNS TRIGGER AS $$
-- 83073
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN

   IF ExisteFilialNaUF('SC') THEN
      IF (TG_OP = 'INSERT') THEN
         UPDATE TT_ASS
            SET QTDREG = QTDREG + 1
          WHERE NOMTAB = 'TT_PRE';
      END IF;
      
      IF (TG_OP = 'DELETE') THEN
         UPDATE TT_ASS
            SET QTDREG = QTDREG - 1
          WHERE NOMTAB = 'TT_PRE';
      END IF;   
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4915 --*/
CREATE TRIGGER TGPRE_ASS
AFTER INSERT OR DELETE ON TT_PRE 
FOR EACH ROW EXECUTE PROCEDURE TGPRE_ASS();


/*-- SEQ 4916 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPREXDIF() CASCADE;

/*-- SEQ 4917 --*/
CREATE OR REPLACE FUNCTION TGPREXDIF() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar codigo sequencial exclusivo para compor a chave primaria
DECLARE
  Quemlogou TRetQuemLogou%ROWTYPE;
BEGIN
  
  select * into QuemLogou from DadosLogon();
  
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN := ProximoCodigo('TT_PREXDIF',NEW.CODFIL);
    END IF;
    NEW.FILREG := Quemlogou.FILUSU;
    NEW.CODREG := Quemlogou.CODUSU;
  END IF;


  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
    NEW.ATU_EM := agora();
    NEW.FILATU := Quemlogou.FILUSU;
    NEW.CODATU := Quemlogou.CODUSU; 
  END IF;


 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4918 --*/
CREATE TRIGGER TGPREXDIF
BEFORE INSERT OR DELETE OR UPDATE ON TT_PREXDIF 
FOR EACH ROW EXECUTE PROCEDURE TGPREXDIF();



/*-- SEQ 4919 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPRJ2() CASCADE;

/*-- SEQ 4920 --*/
CREATE OR REPLACE FUNCTION TGPRJ2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Colocar valores Defaults

DECLARE
  wk_formato_requisito TT_CFG.FMTREQ%TYPE;
  wk_formato_documento TT_CFG.FMTDOC%TYPE;

  vComplemento VARCHAR(100);
  Logon  TRetQuemLogou%ROWTYPE;
  inRec TT_PRJ%ROWTYPE;
  vDummy VARCHAR(5);
  
  -- Principal
begin
  vComplemento := Constante('Complemento');

  -- Tratamento de "log"
  IF (TG_OP = 'DELETE') THEN
    -- Exclui qualquer referencia do "log" ao cliente atual
    DELETE FROM TL_PRJ WHERE CODFIL = OLD.CODFIL AND SEQUEN = OLD.SEQUEN;

    --Trata o delete cascade (mutante)
    UPDATE TT_WOR SET DUMMY = Constante('VEM_DE_TGPRJ') WHERE FILPRJ = OLD.CODFIL AND SEQPRJ = OLD.SEQUEN;
    DELETE FROM TT_WOR WHERE FILPRJ = OLD.CODFIL AND SEQPRJ = OLD.SEQUEN;

  END IF;

  -- Dados do usuario
  IF NOT (TG_OP = 'DELETE') THEN
    -- Dados do usuario
    select * into Logon from DadosLogon();
    IF Logon.Encontrou THEN
      NEW.FILATU := Logon.FILUSU;
      NEW.CODATU := Logon.CODUSU;
    ELSE
      RAISE EXCEPTION 'PG-20037 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
    END IF;
  END IF;

  -- Gera codigo sequencial
  IF (TG_OP = 'INSERT') THEN
    IF (NEW.SEQUEN IS NULL) then
       NEW.SEQUEN := ProximoCodigo('TT_PRJ',NEW.CODFIL);
    end if;

    NEW.DATREG := agora();
    NEW.FILREG := NEW.FILATU;
    NEW.CODREG := NEW.CODATU;

    IF (NEW.MSGREQ IS NULL) OR (NEW.DOCUME IS NULL) THEN
       SELECT FMTREQ,FMTDOC
        INTO wk_formato_requisito,wk_formato_documento
        FROM TT_CFG
       LIMIT 1;

       IF NEW.MSGREQ IS NULL THEN
         NEW.MSGREQ := wk_formato_requisito;
       END IF;

       IF NEW.DOCUME IS NULL THEN
         NEW.DOCUME := wk_formato_documento;
       END IF;
    END IF;    
   
        
        vDummy:=PC_PRJ_UPDATE(NEW.CODFIL,NEW.SEQUEN,NEW.FILATU,NEW.CODATU,NEW.FILPAI,NEW.SEQPAI);
        
    
  END IF;
  
  IF NOT (TG_OP = 'DELETE') THEN
    NEW.ATU_EM := agora();
    NEW.CHVPRJ := NEW.CODFIL||NEW.SEQUEN;
    NEW.CHVPAI := NEW.FILPAI||NEW.SEQPAI;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4921 --*/
CREATE TRIGGER TGPRJ2
BEFORE INSERT OR DELETE OR UPDATE ON TT_PRJ 
FOR EACH ROW EXECUTE PROCEDURE TGPRJ2();

/*-- SEQ 4922 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPRJ3() CASCADE;

/*-- SEQ 4923 --*/
CREATE OR REPLACE FUNCTION TGPRJ3() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Fazer parte do papel de uma "foreign key"
-- 2) Registrar mudanca dos dados num "log"
--
  vLOG        VARCHAR(4000) := '';
  LOG_MSGREQ VARCHAR(4000) := '';
  LOG_DOCUME VARCHAR(4000) := '';
  LOG_REVISA VARCHAR(4000) := '';
  LOG_ANEXOS VARCHAR(4000) := '';
  CRLF CONSTANT     CHAR(1) := CHR(10);
  Nulo CONSTANT     CHAR(1) := '0';

-- Principal
BEGIN
  -- Tratamento de log
  IF (TG_OP = 'INSERT') THEN
    vLOG := 'Inclusao';
    -- Inclui uma linha em TL_PRJ
    INSERT INTO TL_PRJ (CODFIL,SEQUEN,DATHOR,MSGLOG)
    VALUES (NEW.CODFIL,NEW.SEQUEN,agora(),vLOG);
  ELSIF (TG_OP = 'UPDATE') THEN
    IF (Equal(NEW.CODFIL,OLD.CODFIL) = 0) OR (Equal(NEW.SEQUEN,OLD.SEQUEN) = 0) THEN
      vLOG := vLOG||'Chave: de '||COALESCE(OLD.CODFIL,Nulo)||'-'||COALESCE(OLD.SEQUEN,Nulo)||' para '||COALESCE(NEW.CODFIL,Nulo)||'-'||COALESCE(NEW.SEQUEN,Nulo)||CRLF;
    END IF;
    IF (Equal(NEW.FILPAI,OLD.FILPAI) = 0) OR (Equal(NEW.SEQPAI,OLD.SEQPAI) = 0) THEN
      vLOG := vLOG||'Pai: de '||COALESCE(OLD.FILPAI,Nulo)||'-'||COALESCE(OLD.SEQPAI,Nulo)||' para '||COALESCE(NEW.FILPAI,Nulo)||'-'||COALESCE(NEW.SEQPAI,Nulo)||CRLF;
    END IF;
    IF (Equal(NEW.NOMPRJ,OLD.NOMPRJ) = 0) THEN
      vLOG := vLOG||'Projeto: de '||COALESCE(OLD.NOMPRJ,Nulo)||' para '||COALESCE(NEW.NOMPRJ,Nulo)||CRLF;
    END IF;
    IF (Equal(NEW.FILREG,OLD.FILREG) = 0) OR (Equal(NEW.CODREG,OLD.CODREG) = 0) THEN
      vLOG := vLOG||'Quem registrou: de '||COALESCE(OLD.FILREG,Nulo)||'-'||COALESCE(OLD.CODREG,Nulo)||' para '||COALESCE(NEW.FILREG,Nulo)||'-'||COALESCE(NEW.CODREG,Nulo)||CRLF;
    END IF;
    IF (Equal(NEW.DATREG,OLD.DATREG) = 0) THEN
      vLOG := vLOG||'Data do registro: de '||COALESCE(TO_CHAR(OLD.DATREG,'DD/MM/YYYY HH24:MI:SS'),Nulo)||' para '||COALESCE(TO_CHAR(NEW.DATREG,'DD/MM/YYYY HH24:MI:SS'),Nulo)||CRLF;
    END IF;
    IF (Equal(NEW.FILATU,OLD.FILATU) = 0) OR (Equal(NEW.CODATU,OLD.CODATU) = 0) THEN
      vLOG := vLOG||'Quem mexeu: de '||COALESCE(OLD.FILATU,Nulo)||'-'||COALESCE(OLD.CODATU,Nulo)||' para '||COALESCE(NEW.FILATU,Nulo)||'-'||COALESCE(NEW.CODATU,Nulo)||CRLF;
    END IF;
    IF (Equal(NEW.FILCLI,OLD.FILCLI) = 0) OR (Equal(NEW.CODCLI,OLD.CODCLI) = 0) THEN
      vLOG := vLOG||'Cliente: de '||COALESCE(OLD.FILATU,Nulo)||'-'||COALESCE(OLD.CODATU,Nulo)||' para '||COALESCE(NEW.FILCLI,Nulo)||'-'||COALESCE(NEW.CODCLI,Nulo)||CRLF;
    END IF;
    IF (Equal(NEW.FILUSU,OLD.FILUSU) = 0) OR (Equal(NEW.CODUSU,OLD.CODUSU) = 0) THEN
      vLOG := vLOG||'Quem inclui no SAC: de '||COALESCE(OLD.FILUSU,Nulo)||'-'||COALESCE(OLD.CODUSU,Nulo)||' para '||COALESCE(NEW.FILUSU,Nulo)||'-'||COALESCE(NEW.CODUSU,Nulo)||CRLF;
    END IF;
    IF (Equal(NEW.FILACT,OLD.FILACT) = 0) OR (Equal(NEW.CODACT,OLD.CODACT) = 0) THEN
      vLOG := vLOG||'Contato: de '||COALESCE(OLD.FILACT,Nulo)||'-'||COALESCE(OLD.CODACT,Nulo)||' para '||COALESCE(NEW.FILACT,Nulo)||'-'||COALESCE(NEW.CODACT,Nulo)||CRLF;
    END IF;
    IF (Equal(NEW.NUMACT,OLD.NUMACT) = 0) THEN
      vLOG := vLOG||'Numero do contato: de '||COALESCE(OLD.NUMACT,Nulo)||' para '||COALESCE(NEW.NUMACT,Nulo)||CRLF;
    END IF;
    IF (Equal(NEW.TIPACT,OLD.TIPACT) = 0) THEN
      vLOG := vLOG||'Tipo de contato: de '||COALESCE(OLD.TIPACT,Nulo)||' para '||COALESCE(NEW.TIPACT,Nulo)||CRLF;
    END IF;
    IF (Equal(NEW.DATACT,OLD.DATACT) = 0) THEN
      vLOG := vLOG||'Data do contato: de '||COALESCE(TO_CHAR(OLD.DATACT,'DD/MM/YYYY HH24:MI:SS'),Nulo)||' para '||COALESCE(TO_CHAR(NEW.DATACT,'DD/MM/YYYY HH24:MI:SS'),Nulo)||CRLF;
    END IF;
    IF (Equal(NEW.DATSOL,OLD.DATSOL) = 0) THEN
      vLOG := vLOG||'Solicitacao: de '||COALESCE(TO_CHAR(OLD.DATSOL,'DD/MM/YYYY HH24:MI:SS'),Nulo)||' para '||COALESCE(TO_CHAR(NEW.DATSOL,'DD/MM/YYYY HH24:MI:SS'),Nulo)||CRLF;
    END IF;
    IF (Equal(NEW.DATPRO,OLD.DATPRO) = 0) THEN
      vLOG := vLOG||'Programacao: de '||COALESCE(TO_CHAR(OLD.DATPRO,'DD/MM/YYYY HH24:MI:SS'),Nulo)||' para '||COALESCE(TO_CHAR(NEW.DATPRO,'DD/MM/YYYY HH24:MI:SS'),Nulo)||CRLF;
    END IF;
    IF (Equal(NEW.PRIORI,OLD.PRIORI) = 0) THEN
      vLOG := vLOG||'Projeto: de '||COALESCE(OLD.PRIORI,Nulo)||' para '||COALESCE(NEW.PRIORI,Nulo)||CRLF;
    END IF;
    IF (Equal(NEW.MSGREQ,OLD.MSGREQ) = 0) THEN
      LOG_MSGREQ := 'Requisitos: de "'||COALESCE(OLD.MSGREQ,Nulo)||'" para "'||COALESCE(NEW.MSGREQ,Nulo)||'"'||CRLF;
    END IF;
    IF (Equal(NEW.DOCUME,OLD.DOCUME) = 0) THEN
      LOG_DOCUME := 'Documentos: de "'||COALESCE(OLD.DOCUME,Nulo)||'" para "'||COALESCE(NEW.DOCUME,Nulo)||'"'||CRLF;
    END IF;
    IF (Equal(NEW.ANEXOS,OLD.ANEXOS) = 0) THEN
      LOG_ANEXOS := 'Anexos: de "'||COALESCE(OLD.ANEXOS,Nulo)||'" para "'||COALESCE(NEW.ANEXOS,Nulo)||'"'||CRLF;
    END IF;
    IF (Equal(NEW.REVISA,OLD.REVISA) = 0) THEN
      LOG_REVISA := 'Revisao: de "'||COALESCE(OLD.REVISA,Nulo)||'" para "'||COALESCE(NEW.REVISA,Nulo)||'"'||CRLF;
    END IF;
    IF (Equal(NEW.PRICLI,OLD.PRICLI) = 0) THEN
      vLOG := vLOG||'Prioridade do Cliente: de "'||COALESCE(OLD.PRICLI,Nulo)||'" para "'||COALESCE(NEW.PRICLI,Nulo)||'"'||CRLF;
    END IF;
    IF (Equal(NEW.RESPON,OLD.RESPON) = 0) THEN
      vLOG := vLOG||'Resonsavel: de "'||COALESCE(OLD.RESPON,Nulo)||'" para "'||COALESCE(NEW.RESPON,Nulo)||'"'||CRLF;
    END IF;
    IF (Equal(NEW.AVIINT,OLD.AVIINT) = 0) THEN
      vLOG := vLOG||'Avisos Internos: de "'||COALESCE(OLD.AVIINT,Nulo)||'" para "'||COALESCE(NEW.AVIINT,Nulo)||'"'||CRLF;
    END IF;
    IF (Equal(NEW.AVIEXT,OLD.AVIEXT) = 0) THEN
      vLOG := vLOG||'Avisos Externos: de "'||COALESCE(OLD.AVIEXT,Nulo)||'" para "'||COALESCE(NEW.AVIEXT,Nulo)||'"'||CRLF;
    END IF;

    IF (ISNOTNULL(vLOG)='T') OR (ISNOTNULL(LOG_MSGREQ)='T') OR (ISNOTNULL(vLOG)='T') OR (ISNOTNULL(LOG_ANEXOS)='T') THEN
      -- Inclui uma linha em TL_PRJ
      INSERT INTO TL_PRJ (CODFIL,SEQUEN,DATHOR,MSGLOG)
      VALUES (NEW.CODFIL,NEW.SEQUEN,agora(),coalesce(vLOG,'')||coalesce(LOG_MSGREQ,'')||coalesce(LOG_DOCUME,'')||coalesce(LOG_ANEXOS,'')||coalesce(LOG_REVISA,''));
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4924 --*/
CREATE TRIGGER TGPRJ3
AFTER INSERT OR DELETE OR UPDATE ON TT_PRJ 
FOR EACH ROW EXECUTE PROCEDURE TGPRJ3();









/*-- SEQ 4925 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPRO2() CASCADE;

/*-- SEQ 4926 --*/
CREATE OR REPLACE FUNCTION TGPRO2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Impedir alteracoes no codigo da grade se ja houver itens lancados para ela
-- 2) Impedir a utilizacao de uma referencia basica identica a referencia de um item de grade
-- 3) Registrar Pendncias para Atualizar os Impostos de Fornecedores Calculados
--
   mensagem                      VARCHAR(155);
   vcomplemento                  CONSTANT VARCHAR(254):= constante('complemento');
   bAux                          BOOLEAN := false;
   qtd                           Numeric(1) := 0;
   pREFPRO                       TT_GRA.REFPRO%TYPE;


   --LEO 84337
   vCODUID_ATUAL                 TT_VEN.CODUID%TYPE;
   vBLQ_SEM_UID                  TT_CFG.BLQ_SEM_UID%TYPE;
   vSESSIONID                    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

   -- Pedro E. Braga - 92722
   cRETORNO                      VARCHAR(4);
   -- Pedro E. Braga - 93794
   cFPVPRECOSIMULADO             TT_CFG.FPV_PRECO_SIMULADO%TYPE;

   cMantemAtuEm                  VARCHAR(1);
   cWhere                        TM_ATU.FILTRO%TYPE;
-- Principal
BEGIN   
   -- Inicializao de variveis e regras
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN
      IF COALESCE(TRIM(NEW.DUMMY),'#') = Constante('MANTEM_ATU_EM') THEN
         cMantemAtuEm := 'T';
      ELSE
         cMantemAtuEm := 'F';
      END IF;
   ELSIF (TG_OP = 'DELETE') THEN
      cMantemAtuEm := 'F';
   END IF;


  IF (TG_OP = 'UPDATE') THEN
    -- Confirma se o codigo foi efetivamente mudado
    IF (Equal(OLD.CODGRA,NEW.CODGRA) <> 1) THEN
       mensagem := TGR_Itens_Vinculados(NEW.FILMAT,NEW.CODMAT,NEW.CODGRA);
       IF (COALESCE(MENSAGEM,'#') <> '#') THEN
         RAISE EXCEPTION 'PG-20007 % %' , mensagem,vComplemento;
       END IF;
    END IF;
  END IF;

  -- Caso o produto for pesavel, o DECIMA (Usa Decimais) deve estar com T
  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     IF NEW.BALSIM = 'T' THEN
        IF NEW.DECIMA <> 'T' THEN
           mensagem := 'Produto pesavel deve aceitar decimais';
           IF (COALESCE(MENSAGEM,'#') <> '#') THEN
              RAISE EXCEPTION 'PG-20005 % %' , mensagem,vComplemento;
           END IF;
        END IF;
     END IF;
  END IF;

  -- Tratamento de "log"
  IF (TG_OP = 'DELETE') THEN
    -- Exclui qualquer referencia do "log" ao produto atual
    DELETE FROM TL_PRO WHERE FILMAT = OLD.FILMAT AND CODMAT = OLD.CODMAT;
  END IF;

  IF NOT (TG_OP = 'DELETE') THEN
    -- Obriga sempre CAIXA ALTA
    NEW.DESMAT := Upper(NEW.DESMAT);
    NEW.ESPMAT := Upper(NEW.ESPMAT);

    -- "Default"
    IF (TG_OP = 'INSERT') OR (cMantemAtuEm = 'F') THEN
       NEW.ATU_EM := agora();
    END IF;
  END IF;

  IF (TG_OP = 'INSERT') THEN
     bAux:=true;
     NEW.DATCAD := agora();
  END IF;

  IF (TG_OP = 'UPDATE') THEN
     IF COALESCE(OLD.REFBAS,'#ERR1') <> COALESCE(NEW.REFBAS,'#ERR2') THEN
        bAux:=true;
     END IF;

    --Pedro E. Braga - 93794
    SELECT FPV_PRECO_SIMULADO INTO cFPVPRECOSIMULADO FROM TT_CFG;
    IF (cFPVPRECOSIMULADO = 'T') THEN
        -- Pedro E. Braga - 92722 -- Mateus 92861
        IF (Equal(OLD.ORIPRO,NEW.ORIPRO) <> 1)
        OR (Equal(OLD.TIPPRO,NEW.TIPPRO) <> 1)
        OR (Equal(OLD.SUBFRE,NEW.SUBFRE) <> 1)
        OR (Equal(OLD.DESFRE,NEW.DESFRE) <> 1)
        OR (OLD.SIGNAT <  0 AND NEW.SIGNAT >= 0) -- Ativou    RFMP 102514
        OR (OLD.SIGNAT >= 0 AND NEW.SIGNAT <  0) -- Desativou RFMP 102514
        THEN
            cRETORNO := INSERE_MIFC('PRO',NEW.FILMAT || NEW.CODMAT);
        END IF;
    END IF;

    -- Rhuan - 93079 - Quando  material no retm PIS/COFINS
    IF NEW.TIPPRO = 0 THEN
       NEW.RETCOF := 'F';
    END IF;

  END IF;

  IF bAux THEN

     SELECT count(*), min(refpro)
       INTO QTD, pREFPRO
       FROM TT_GRA WHERE TRIM(REFPRO) = TRIM(NEW.REFBAS);

     Mensagem := null;
     IF QTD > 0 THEN
       Mensagem := 'Essa referencia  "'||NEW.REFBAS||'" ja e utilizada como referencia do produto "'||pREFPRO||'"';
     END IF;

     IF (COALESCE(MENSAGEM,'#') <> '#') THEN
        RAISE EXCEPTION 'PG-20005 % %' , mensagem,vComplemento;
     END IF;
  END IF;

  IF (TG_OP = 'INSERT') THEN

    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;

    -- Douglas - 83441
    NEW.CODUID := GetCoduidAtual();
    NEW.ASSINA := COALESCE(AssinaTabela('TT_PRO',
                                         ConcatenaPRO(NEW.FILMAT,
                                                      NEW.CODMAT,
                                                      NEW.DESMAT,
                                                      NEW.ARRTRU,
                                                      NEW.IIPTPR,
                                                      NEW.TIPPRO),
                                         null, null, null),NEW.ASSINA);
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF ConcatenaPRO(NEW.FILMAT,NEW.CODMAT,NEW.DESMAT,NEW.ARRTRU,NEW.IIPTPR,NEW.TIPPRO) <>
         ConcatenaPRO(OLD.FILMAT,OLD.CODMAT,OLD.DESMAT,OLD.ARRTRU,OLD.IIPTPR,OLD.TIPPRO) THEN

         -- LEO 84337
         SELECT BLQ_SEM_UID
           INTO vBLQ_SEM_UID
           FROM TT_CFG;
         vCODUID_ATUAL := GetCoduidAtual();
         IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;

         -- Douglas - 83441
         NEW.CODUID := GetCoduidAtual();
         NEW.ASSINA := COALESCE(AssinaTabela('TT_PRO',
                                              ConcatenaPRO(NEW.FILMAT,
                                                           NEW.CODMAT,
                                                           NEW.DESMAT,
                                                           NEW.ARRTRU,
                                                           NEW.IIPTPR,
                                                           NEW.TIPPRO),
                                              OLD.CODUID,
                                              ConcatenaPRO(OLD.FILMAT,
                                                           OLD.CODMAT,
                                                           OLD.DESMAT,
                                                           OLD.ARRTRU,
                                                           OLD.IIPTPR,
                                                           OLD.TIPPRO),
                                              OLD.ASSINA
                                             ),NEW.ASSINA);
      END IF;
   END IF;

   -- Paulo : 83521 - Grava sempre True.
   IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
      NEW.IMPKIT := 'T';
   END IF;

   -- Trazendo para trigger BEFORE tratamento de atualizao do ATU_EM porque
   -- ele depende do DUMMY que ser apagado no final da trigger
   -- Rhuan - Ticket 2020083225 - Tratamento para atualizar o ATU_EM da TT_PRE quando IPI for alterado, mesmo que cMantemAtuEm vier True.
   -- Necessrio pois o IPI altera o preo e precisa ser atualizado na carga do POS.

   IF (cMantemAtuEm = 'F') OR (Equal(OLD.RESIPI,NEW.RESIPI) <> 1) THEN
      -- Tratamento para Atualizar Tabela Pai
      IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
         cWhere := 'FILMAT = ' || CHR(39) || NEW.FILMAT  || CHR(39) || ' AND CODMAT = ' || CHR(39) || NEW.CODMAT || CHR(39);
      ELSIF (TG_OP = 'DELETE') THEN
         cWhere := 'FILMAT = ' || CHR(39) || OLD.FILMAT  || CHR(39) || ' AND CODMAT = ' || CHR(39) || OLD.CODMAT || CHR(39);
      END IF;
      cRetorno := INSERE_MATU('TT_PRO', 'TT_PRE', cWhere);
   END IF;

   IF (TG_OP = 'UPDATE') THEN
      -- Atualiza o ATU_EM dos saldos quando a flag de controle de estoque  alterada.
      IF (Equal(OLD.ESTCHE,NEW.ESTCHE) <> 1) THEN
         cWhere := 'FILMAT = ' || CHR(39) || NEW.FILMAT  || CHR(39) || ' AND CODMAT = ' || CHR(39) || NEW.CODMAT || CHR(39);
         cRetorno := INSERE_MATU('TT_PRO', 'TT_SAL', cWhere);
      END IF;
   END IF;

   -- Apagando dados do DUMMY para garantir que um novo processo no utilizar seu valor
   -- de maneira equivocada
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.DUMMY := NULL;
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4927 --*/
CREATE TRIGGER TGPRO2
BEFORE INSERT OR UPDATE ON TT_PRO 
FOR EACH ROW EXECUTE PROCEDURE TGPRO2();

/*-- SEQ 4928 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPRO3() CASCADE;

/*-- SEQ 4929 --*/
CREATE OR REPLACE FUNCTION TGPRO3() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo
-- 1) Registrar mudanca dos dados num "log"
-- 2) Zerar percentual equivalente a servicos, se necessario

   vLOG                          VARCHAR(4000) := '';
   Nulo                          CONSTANT CHAR(1) := '0';
   cNulo                         CONSTANT CHAR(4) := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1) := CHR(10);
   cOld                          VARCHAR(250); -- davi - 37941 - 06/09/2005 - colocar descrio no lugar dos codtabs
   cNew                          VARCHAR(250); -- davi - 37941 - 06/09/2005 - colocar descrio no lugar dos codtabs
   cRet                          VARCHAR(2);
   
   --rProduto                      TT_PRO%ROWTYPE;
   --cDUMMY                         VARCHAR(1);

-- Principal
BEGIN
  --Atualiza TT_PROxNOM
  --davi - 21/11/06 - 41296
  IF (TG_OP = 'UPDATE') THEN
    IF Equal(OLD.DESMAT,NEW.DESMAT) = 0 OR
       Equal(OLD.ESPMAT,NEW.ESPMAT) = 0 OR
       Equal(OLD.DESECF,NEW.DESECF) = 0 OR
       Equal(OLD.TERASS,NEW.TERASS) = 0 OR
       Equal(OLD.CLASS1,NEW.CLASS1) = 0 OR
       Equal(OLD.CLASS2,NEW.CLASS2) = 0 OR
       Equal(OLD.CLASS3,NEW.CLASS3) = 0 OR
       Equal(OLD.CLASS4,NEW.CLASS4) = 0 OR
       Equal(OLD.DEPART,NEW.DEPART) = 0 OR
       Equal(OLD.FILMAR,NEW.FILMAR) = 0 OR
       Equal(OLD.CODMAR,NEW.CODMAR) = 0 OR
       Equal(OLD.TIPMAR,NEW.TIPMAR) = 0 THEN
      
      cRet := PC_PROxNOM_Atualiza(null, NEW.FILMAT, NEW.CODMAT, null, null);
                END IF;
    -- Pedro E. Braga - 104287 - Comando de update na TT_PRE foi transferido para o controle atravs da funo "Insere_MATU".
    -- Rhuan - 101970
    /*       rProduto.FILMAT := NEW.FILMAT;
       rProduto.CODMAT := NEW.CODMAT;
       
       cDUMMY := PC_PRO_AUX_Update(rProduto.FILMAT, rProduto.CODMAT);
           */
  END IF;


  -- Tratamento de vLOG
  IF (TG_OP = 'INSERT') THEN
    vLOG := 'Inclusao';
    -- Inclui uma linha em TL_PRO
    INSERT INTO TL_PRO (FILMAT,CODMAT,DATOPE,MSGLOG)
    VALUES (NEW.FILMAT,NEW.CODMAT,agora(),vLOG);
  ELSIF (TG_OP = 'UPDATE') THEN
    IF Equal(OLD.BRINDE,NEW.BRINDE) <> 1 THEN
      select CASE OLD.TIPPRO WHEN 0 THEN 'No  brinde'
                              WHEN 1 THEN 'Pode ser brinde'
                                     ELSE ' brinde'
      END into cOld from dual;
      select CASE NEW.TIPPRO WHEN 0 THEN 'No  brinde'
                              WHEN 1 THEN 'Pode ser brinde'
                                     ELSE ' brinde'
      END into cNew from dual;
      vLOG := vLOG||'Brinde: de '||COALESCE(cOld,Nulo)||' para '||COALESCE(cNew,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.CLASS1,NEW.CLASS1) <> 1 THEN
      SELECT COALESCE(TO_CHAR(MIN(CLASS1)),'Nulo') INTO cOld FROM TD_CL1 WHERE CODTAB = OLD.CLASS1;
      SELECT COALESCE(TO_CHAR(MIN(CLASS1)),'Nulo') INTO cNew FROM TD_CL1 WHERE CODTAB = NEW.CLASS1;
      vLOG := vLOG||'1a. Classe: de '||COALESCE(cOld,Nulo)||' para '||COALESCE(cNew,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.CLASS2,NEW.CLASS2) <> 1 THEN
      SELECT COALESCE(TO_CHAR(MIN(CLASS2)),'Nulo') INTO cOld FROM TD_CL2 WHERE CODTAB = OLD.CLASS2;
      SELECT COALESCE(TO_CHAR(MIN(CLASS2)),'Nulo') INTO cNew FROM TD_CL2 WHERE CODTAB = NEW.CLASS2;
      vLOG := vLOG||'2a. Classe: de '||COALESCE(cOld,Nulo)||' para '||COALESCE(cNew,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.CLASS3,NEW.CLASS3) <> 1 THEN
      SELECT COALESCE(TO_CHAR(MIN(CLASS3)),'Nulo') INTO cOld FROM TD_CL3 WHERE CODTAB = OLD.CLASS3;
      SELECT COALESCE(TO_CHAR(MIN(CLASS3)),'Nulo') INTO cNew FROM TD_CL3 WHERE CODTAB = NEW.CLASS3;
      vLOG := vLOG||'3a. Classe: de '||COALESCE(cOld,Nulo)||' para '||COALESCE(cNew,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.CLASS4,NEW.CLASS4) <> 1 THEN
      SELECT COALESCE(TO_CHAR(MIN(CLASS4)),'Nulo') INTO cOld FROM TD_CL4 WHERE CODTAB = OLD.CLASS4;
      SELECT COALESCE(TO_CHAR(MIN(CLASS4)),'Nulo') INTO cNew FROM TD_CL4 WHERE CODTAB = NEW.CLASS4;
      vLOG := vLOG||'4a. Classe: de '||COALESCE(cOld,Nulo)||' para '||COALESCE(cNew,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.CLSXYZ,NEW.CLSXYZ) <> 1 THEN
     select CASE OLD.CLSXYZ WHEN 0 THEN 'X'
                             WHEN 1 THEN 'Y'
                             WHEN 2 THEN 'Z'
                                    ELSE 'Nulo'
        END into cOld from dual;
     select CASE NEW.CLSXYZ WHEN 0 THEN 'X'
                             WHEN 1 THEN 'Y'
                             WHEN 2 THEN 'Z'
                                    ELSE 'Nulo'
        END into cNew from dual;
      vLOG := vLOG||'Classe XYZ: de '||COALESCE(cOld,Nulo)||' para '||COALESCE(cNew,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.FILMAR,NEW.FILMAR) <> 1 OR Equal(OLD.CODMAR,NEW.CODMAR) <> 1 THEN
      SELECT COALESCE(TO_CHAR(MIN(NOMCLI)),'Nulo') INTO cOld FROM TV_MAR WHERE FILCLI = OLD.FILMAR AND CODCLI = OLD.CODMAR;
      SELECT COALESCE(TO_CHAR(MIN(NOMCLI)),'Nulo') INTO cNew FROM TV_MAR WHERE FILCLI = NEW.FILMAR AND CODCLI = NEW.CODMAR;
      vLOG := vLOG||'Marca: de '||COALESCE(cOld,Nulo)||' para '||COALESCE(cNew,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.CODGRA,NEW.CODGRA) <> 1 THEN
      SELECT COALESCE(TO_CHAR(MIN(NOMGRA)),'Nulo') INTO cOld FROM TD_GRA WHERE CODTAB = OLD.CODGRA;
      SELECT COALESCE(TO_CHAR(MIN(NOMGRA)),'Nulo') INTO cNew FROM TD_GRA WHERE CODTAB = NEW.CODGRA;
      vLOG := vLOG||'Grade: de '||COALESCE(cOld,Nulo)||' para '||COALESCE(cNew,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.CODSAZ,NEW.CODSAZ) <> 1 THEN
      SELECT COALESCE(TO_CHAR(MIN(DESSAZ)),'Nulo') INTO cOld FROM TD_SAZ WHERE CODTAB = OLD.CODSAZ;
      SELECT COALESCE(TO_CHAR(MIN(DESSAZ)),'Nulo') INTO cNew FROM TD_SAZ WHERE CODTAB = NEW.CODSAZ;
      vLOG := vLOG||'Sazonalidade: de '||COALESCE(cOld,Nulo)||' para '||COALESCE(cNew,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.CODTRI,NEW.CODTRI) <> 1 THEN
      SELECT COALESCE(TO_CHAR(MIN(CODTRI)),'Nulo') INTO cOld FROM TD_TRI WHERE CODTAB = OLD.CODTRI;
      SELECT COALESCE(TO_CHAR(MIN(CODTRI)),'Nulo') INTO cNew FROM TD_TRI WHERE CODTAB = NEW.CODTRI;
      vLOG := vLOG||'Tributacao: de '||COALESCE(cOld,Nulo)||' para '||COALESCE(cNew,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.CONTRA,NEW.CONTRA) <> 1 THEN
      vLOG := vLOG||'Contrato: de '||COALESCE(OLD.CONTRA,Nulo)||' para '||COALESCE(NEW.CONTRA,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.DATCAD,NEW.DATCAD) <> 1 THEN
      vLOG := vLOG||'Cadastro: de '||COALESCE(TO_CHAR(OLD.DATCAD,'DD/MM/YYYY HH24:MI:SS'),Nulo)||' para '||COALESCE(TO_CHAR(NEW.DATCAD,'DD/MM/YYYY HH24:MI:SS'),Nulo)||CRLF;
    END IF;
    IF Equal(OLD.DECIMA,NEW.DECIMA) <> 1 THEN
      select CASE OLD.DECIMA WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                                                  ELSE 'Nulo'
      END into cOld from dual;
      select CASE NEW.DECIMA WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                                                  ELSE 'Nulo'
      END into cNew from dual;
      vLOG := vLOG||'Decimais: de '||COALESCE(cOld,Nulo)||' para '||COALESCE(cNew,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.DEPART,NEW.DEPART) <> 1 THEN
      SELECT COALESCE(TO_CHAR(MIN(DESDEP)),'Nulo') INTO cOld FROM TD_DEP WHERE CODTAB = OLD.DEPART;
      SELECT COALESCE(TO_CHAR(MIN(DESDEP)),'Nulo') INTO cNew FROM TD_DEP WHERE CODTAB = NEW.DEPART;
      vLOG := vLOG||'Departamento: de '||COALESCE(cOld,Nulo)||' para '||COALESCE(cNew,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.DESECF,NEW.DESECF) <> 1 THEN
      vLOG := vLOG||'ECF: de '||COALESCE(OLD.DESECF,Nulo)||' para '||COALESCE(NEW.DESECF,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.DESMAT,NEW.DESMAT) <> 1 THEN
      vLOG := vLOG||'Descricao: de '||COALESCE(OLD.DESMAT,Nulo)||' para '||COALESCE(NEW.DESMAT,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.ESPMAT,NEW.ESPMAT) <> 1 THEN
      vLOG := vLOG||'Especificacao: de '||COALESCE(OLD.ESPMAT,Nulo)||' para '||COALESCE(NEW.ESPMAT,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.ETIQUE,NEW.ETIQUE) <> 1 THEN
      SELECT COALESCE(TO_CHAR(MIN(DESETI)),'Nulo') INTO cOld FROM TD_ETI WHERE CODTAB = OLD.ETIQUE;
      SELECT COALESCE(TO_CHAR(MIN(DESETI)),'Nulo') INTO cNew FROM TD_ETI WHERE CODTAB = NEW.ETIQUE;
      vLOG := vLOG||'Etiqueta: de '||COALESCE(cOld,Nulo)||' para '||COALESCE(cNew,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.MONTAR,NEW.MONTAR) <> 1 THEN
      select CASE OLD.MONTAR WHEN 'I' THEN 'Montagem Interna'
                              WHEN 'T' THEN 'Montagem na Entrega'
                              WHEN 'F' THEN 'Sem Montagem'
                                                  ELSE 'Nulo'
      END into cOld from dual;
      select CASE NEW.MONTAR WHEN 'I' THEN 'Montagem Interna'
                              WHEN 'T' THEN 'Montagem na Entrega'
                              WHEN 'F' THEN 'Sem Montagem'
                                                  ELSE 'Nulo'
      END into cNew from dual;
      vLOG := vLOG||'Tipo de Montagem: de '||COALESCE(cOld,Nulo)||' para '||COALESCE(cNew,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.NOMIMG,NEW.NOMIMG) <> 1 THEN
      vLOG := vLOG||'Imagem: de '||COALESCE(OLD.NOMIMG,Nulo)||' para '||COALESCE(NEW.NOMIMG,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.NUMEXT,NEW.NUMEXT) <> 1 THEN
      select CASE OLD.NUMEXT WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                                                  ELSE 'Nulo'
      END into cOld from dual;
      select CASE NEW.NUMEXT WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                                                  ELSE 'Nulo'
      END into cNew from dual;
      vLOG := vLOG||'N externo: de '||COALESCE(cOld,Nulo)||' para '||COALESCE(cNew,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.NUMITE,NEW.NUMITE) <> 1 THEN
      vLOG := vLOG||'Itens kit: de '||COALESCE(TO_CHAR(OLD.NUMITE),Nulo)||' para '||COALESCE(TO_CHAR(NEW.NUMITE),Nulo)||CRLF;
    END IF;
    IF Equal(OLD.REFBAS,NEW.REFBAS) <> 1 THEN
      vLOG := vLOG||'Referencia basica: de '||COALESCE(OLD.REFBAS,Nulo)||' para '||COALESCE(NEW.REFBAS,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.RESIPI,NEW.RESIPI) <> 1 THEN
      SELECT COALESCE(TO_CHAR(MIN(RESIPI)),'Nulo') INTO cOld FROM TD_IPI WHERE CODTAB = OLD.RESIPI;
      SELECT COALESCE(TO_CHAR(MIN(RESIPI)),'Nulo') INTO cNew FROM TD_IPI WHERE CODTAB = NEW.RESIPI;
      vLOG := vLOG||'IPI: de '||COALESCE(cOld,Nulo)||' para '||COALESCE(cNew,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.RESIRR,NEW.RESIRR) <> 1 THEN
      SELECT COALESCE(TO_CHAR(MIN(RESIRR)),'Nulo') INTO cOld FROM TD_IRR WHERE CODTAB = OLD.RESIRR;
      SELECT COALESCE(TO_CHAR(MIN(RESIRR)),'Nulo') INTO cNew FROM TD_IRR WHERE CODTAB = NEW.RESIRR;
      vLOG := vLOG||'IRR: de '||COALESCE(cOld,Nulo)||' para '||COALESCE(cNew,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.TIPPRO,NEW.TIPPRO) <> 1 THEN
     select CASE OLD.TIPPRO WHEN 0 THEN 'Material'
                             WHEN 1 THEN 'Servio'
                             WHEN 2 THEN 'Terceirizado'
                                    ELSE 'Nulo'
        END into cOld from dual;
     select CASE NEW.TIPPRO WHEN 0 THEN 'Material'
                             WHEN 1 THEN 'Servio'
                             WHEN 2 THEN 'Terceirizado'
                                    ELSE 'Nulo'
        END into cNew from dual;
      vLOG := vLOG||'Tipo: de '||COALESCE(cOld,Nulo)||' para '||COALESCE(cNew,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.VALCON,NEW.VALCON) <> 1 THEN
      vLOG := vLOG||'Valor de conversao: de '||COALESCE(TO_CHAR(OLD.VALCON),Nulo)||' para '||COALESCE(TO_CHAR(NEW.VALCON),Nulo)||CRLF;
    END IF;
    IF Equal(OLD.UNIDAD,NEW.UNIDAD) <> 1 THEN
      vLOG := vLOG||'Unidade de Negocios: de '||COALESCE(TO_CHAR(OLD.UNIDAD),Nulo)||' para '||COALESCE(TO_CHAR(NEW.UNIDAD),Nulo)||CRLF;
    END IF;
    IF Equal(OLD.UNIFOR,NEW.UNIFOR) <> 1 THEN
      vLOG := vLOG||'Unidade de compra: de '||COALESCE(TO_CHAR(OLD.UNIFOR),Nulo)||' para '||COALESCE(TO_CHAR(NEW.UNIFOR),Nulo)||CRLF;
    END IF;
    IF (OLD.SIGNAT<0 AND NEW.SIGNAT>=0) THEN
      vLOG := vLOG||'Produto Ativado'||CRLF;
    END IF;
    IF (OLD.SIGNAT>=0 AND NEW.SIGNAT<0) THEN
      vLOG := vLOG||'Produto Desativado'||CRLF;
    END IF;
    IF Equal(OLD.CONTRO,NEW.CONTRO) <> 1 THEN
      vLOG := vLOG||'Controla Produtos?: de '||COALESCE(OLD.CONTRO,Nulo)||' para '||COALESCE(NEW.CONTRO,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.CODCTR,NEW.CODCTR) <> 1 THEN
      vLOG := vLOG||'Caracterizacao: de '||COALESCE(TO_CHAR(OLD.CODCTR),Nulo)||' para '||COALESCE(TO_CHAR(NEW.CODCTR),Nulo)||CRLF;
    END IF;
    IF Equal(OLD.ENTREG,NEW.ENTREG) <> 1 THEN
      vLOG := vLOG||'Entrega?: de '||COALESCE(OLD.ENTREG,Nulo)||' para '||COALESCE(NEW.ENTREG,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.CODMON,NEW.CODMON) <> 1 THEN
      vLOG := vLOG||'Montagem: de '||COALESCE(TO_CHAR(OLD.CODMON),Nulo)||' para '||COALESCE(TO_CHAR(NEW.CODMON),Nulo)||CRLF;
    END IF;
    IF Equal(OLD.RETCOF,NEW.RETCOF) <> 1 THEN
      vLOG := vLOG||'Reteno de COFINS?: de '||COALESCE(OLD.RETCOF,Nulo)||' para '||COALESCE(NEW.RETCOF,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.CODINA,NEW.CODINA) <> 1 THEN
      vLOG := vLOG||'Motivo Inatividade: de '||COALESCE(TO_CHAR(OLD.CODINA),Nulo)||' para '||COALESCE(TO_CHAR(NEW.CODINA),Nulo)||CRLF;
    END IF;
    IF Equal(OLD.TIPMAR,NEW.TIPMAR) <> 1 THEN
      vLOG := vLOG||'Tipo Marca: de '||COALESCE(DescricaoDominio('PRO','TIPMAR',OLD.TIPMAR),Nulo)||' para '||COALESCE(DescricaoDominio('PRO','TIPMAR',NEW.TIPMAR),Nulo)||CRLF;
    END IF;
    IF Equal(OLD.SUBFED,NEW.SUBFED) <> 1 THEN
      vLOG := vLOG||'Substituicao Federal: de '||COALESCE(OLD.SUBFED,Nulo)||' para '||COALESCE(NEW.SUBFED,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.DESWEB,NEW.DESWEB) <> 1 THEN
      vLOG := vLOG||'Descrio E-commerce: de '||COALESCE(OLD.DESWEB, Nulo)||' para '||COALESCE(NEW.DESWEB, Nulo)||CRLF;
    END IF;
    IF Equal(OLD.NATBCC,NEW.NATBCC) <> 1 THEN
      vLOG := vLOG||'Cdigo da Base de Clculo do Crdito (PIS/Cofins): de '||COALESCE(OLD.NATBCC,Nulo)||' para '||COALESCE(NEW.NATBCC,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.VENPIS,NEW.VENPIS) <> 1 THEN
      vLOG := vLOG||'% de PIS para Venda: de '||COALESCE(TO_CHAR(OLD.VENPIS),Nulo)||' para '||COALESCE(TO_CHAR(NEW.VENPIS),Nulo)||CRLF;
    END IF;
    IF Equal(OLD.VENCOF,NEW.VENCOF) <> 1 THEN
      vLOG := vLOG||'% de COFINS para Venda: de '||COALESCE(TO_CHAR(OLD.VENCOF),Nulo)||' para '||COALESCE(TO_CHAR(NEW.VENCOF),Nulo)||CRLF;
    END IF;
    IF Equal(OLD.OBSMPB,NEW.OBSMPB) <> 1 THEN
      vLOG := vLOG||'Observao Legal para MP do BEM: de '||COALESCE(TO_CHAR(OLD.OBSMPB),cNulo)||' para '||COALESCE(TO_CHAR(NEW.OBSMPB),cNulo)||CRLF;
    END IF;
    IF Equal(OLD.CODRGC,NEW.CODRGC) <> 1 THEN
      vLOG := vLOG||'Regra para Comercializao: de '||COALESCE(TO_CHAR(OLD.CODRGC),Nulo)||' para '||COALESCE(TO_CHAR(NEW.CODRGC),Nulo)||CRLF;
    END IF;
    IF Equal(OLD.DESFRE,NEW.DESFRE) <> 1 THEN
      vLOG := vLOG||'% Des/Acr Frete Or: de '||COALESCE(TO_CHAR(OLD.DESFRE),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DESFRE),cNulo)||CRLF;
    END IF;
    IF Equal(OLD.SUBFRE,NEW.SUBFRE) <> 1 THEN
      vLOG := vLOG||'% Subsdio p/ Frete: de '||COALESCE(TO_CHAR(OLD.SUBFRE),cNulo)||' para '||COALESCE(TO_CHAR(NEW.SUBFRE),cNulo)||CRLF;
    END IF;
    IF Equal(OLD.USALOT,NEW.USALOT) <> 1 THEN
      select CASE OLD.USALOT WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                                                  ELSE 'Nulo'
      END into cOld from dual;
      select CASE NEW.USALOT WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
                                                  ELSE 'Nulo'
      END into cNew from dual;
      vLOG := vLOG||'Usa lote?: de '||COALESCE(cOld,Nulo)||' para '||COALESCE(cNew,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.SITPISCOM,NEW.SITPISCOM) <> 1 THEN
      vLOG := vLOG||'Cdigo de Situao Tributria do PIS para Compra: de '||COALESCE(OLD.SITPISCOM,cNulo)||' para '||COALESCE(NEW.SITPISCOM,cNulo)||CRLF;
    END IF;
    IF Equal(OLD.SITCOFCOM,NEW.SITCOFCOM) <> 1 THEN
      vLOG := vLOG||'Cdigo de Situao Tributria do PIS para Compra: de '||COALESCE(OLD.SITCOFCOM,cNulo)||' para '||COALESCE(NEW.SITCOFCOM,cNulo)||CRLF;
    END IF;
    IF Equal(OLD.CODNCM,NEW.CODNCM) <> 1 THEN
      vLOG := vLOG||'Cdigo NCM: de '||COALESCE(TO_CHAR(OLD.CODNCM),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODNCM),cNulo)||CRLF;
    END IF;
    -- 92950
    IF Equal(OLD.CLSABC,NEW.CLSABC) <> 1 THEN
      vLOG := vLOG||'ABC: de '||COALESCE(TO_CHAR(OLD.CLSABC),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CLSABC),cNulo)||CRLF;
    END IF;
    -- 93896 Mark Fazolin
    IF Equal(OLD.CODNIV,NEW.CODNIV) <> 1 THEN
      vLOG := vLOG||'Nvel do Servio: de '||COALESCE(TO_CHAR(OLD.CODNIV),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODNIV),cNulo)||CRLF;
    END IF;
    -- 95229 Mark Fazolin
    IF Equal(OLD.LOTONL,NEW.LOTONL) <> 1 THEN
      vLOG := vLOG||'Lote Individualizado (DNA): de '||COALESCE(OLD.LOTONL,cNulo)||' para '||COALESCE(NEW.LOTONL,cNulo)||CRLF;
    END IF;
    -- 91221 Almir Borges
    IF Equal(OLD.CODIMG,NEW.CODIMG) <> 1 THEN
      vLOG := vLOG||'% Cdigo da imagem do grupo: de '||COALESCE(TO_CHAR(OLD.CODIMG),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODIMG),cNulo)||CRLF;
    END IF;
    IF Equal(OLD.OBIMEI,NEW.OBIMEI) <> 1 THEN
      vLOG := vLOG||'Obriga IMEI?: de '||COALESCE(OLD.OBIMEI,cNulo)||' para '||COALESCE(NEW.OBIMEI,cNulo)||CRLF;
    END IF;
    IF Equal(OLD.CONFER,NEW.CONFER) <> 1 THEN
      vLOG := vLOG||'Conferir na venda?: de '||COALESCE(OLD.CONFER,cNulo)||' para '||COALESCE(NEW.CONFER,cNulo)||CRLF;
    END IF;
    IF Equal(OLD.ESTCHE,NEW.ESTCHE) <> 1 THEN
      vLOG := vLOG||'Controle de Estoque no Checkout 4G: de '||COALESCE(DescricaoDominio('PRO','ESTCHE',TO_CHAR(OLD.ESTCHE)),cNulo)||' para '||COALESCE(DescricaoDominio('PRO','ESTCHE',TO_CHAR(NEW.ESTCHE)),cNulo)||CRLF;
    END IF;
    IF Equal(OLD.CODCES,NEW.CODCES) <> 1 THEN
      vLOG := vLOG||'CEST: de '||COALESCE(OLD.CODCES,cNulo)||' para '||COALESCE(NEW.CODCES,cNulo)||CRLF;
    END IF;
    IF Equal(OLD.CODENQ,NEW.CODENQ) <> 1 THEN
       vLOG := vLOG||'Cdigo de Enquadramento Legal do IPI: de '||COALESCE(TO_CHAR(OLD.CODENQ), cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODENQ), cNulo)||CRLF;
    END IF;
    IF Equal(OLD.VENPISIMP,NEW.VENPISIMP) <> 1 THEN
      vLOG := vLOG||'% PIS na Importao: de '||COALESCE(TO_CHAR(OLD.VENPISIMP),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VENPISIMP),cNulo)||CRLF;
    END IF;
    IF Equal(OLD.VENCOFIMP,NEW.VENCOFIMP) <> 1 THEN
      vLOG := vLOG||'% COFINS na Importao: de '||COALESCE(TO_CHAR(OLD.VENCOFIMP),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VENCOFIMP),cNulo)||CRLF;
    END IF;
    IF Equal(OLD.PER_II,NEW.PER_II) <> 1 THEN
      vLOG := vLOG||'% de Imposto sobre Importao: de '||COALESCE(TO_CHAR(OLD.PER_II),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PER_II),cNulo)||CRLF;
    END IF;
    IF Equal(OLD.FOR060,NEW.FOR060) <> 1 THEN
      vLOG := vLOG||'Forar substitudo (60) mesmo para empresa substituta: de '||COALESCE(OLD.FOR060,cNulo)||' para '||COALESCE(NEW.FOR060,cNulo)||CRLF;
    END IF;
    IF Equal(OLD.LABORATORIO,NEW.LABORATORIO) <> 1 THEN
      vLOG := vLOG||'Laboratrio: de '||COALESCE(OLD.LABORATORIO,iNulo)||' para '||COALESCE(NEW.LABORATORIO,iNulo)||CRLF;
    END IF;
    IF Equal(OLD.PROCON,NEW.PROCON) <> 1 THEN
      select CASE OLD.PROCON WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
             ELSE 'Nulo'
      END into cOld from dual;
      select CASE NEW.PROCON WHEN 'T' THEN 'Sim'
                              WHEN 'F' THEN 'No'
             ELSE 'Nulo'
      END into cNew from dual;
      vLOG := vLOG||'Produto Controlado?: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
    END IF;

    IF ISNOTNULL(vLOG)='T'  THEN
      -- Inclui uma linha em TL_PRO
      INSERT INTO TL_PRO (FILMAT,CODMAT,DATOPE,MSGLOG)
      VALUES (NEW.FILMAT,NEW.CODMAT,agora(),vLOG);
    END IF;

    IF COALESCE(OLD.OBSERV,'XXX')<>COALESCE(NEW.OBSERV,'XXX') THEN
      IF ISNOTNULL(OLD.OBSERV)='T'  THEN
         INSERT INTO TL_PRO (FILMAT,CODMAT,DATOPE,MSGLOG)
         VALUES (NEW.FILMAT,NEW.CODMAT,agora(),COALESCE(OLD.OBSERV,'Nulo'));
      END IF;
    END IF;

    IF Equal(OLD.DESDET,NEW.DESDET) <> 1 THEN
      IF ISNOTNULL(OLD.DESDET)='T' THEN
         INSERT INTO TL_PRO (FILMAT,CODMAT,DATOPE,MSGLOG)
         VALUES (NEW.FILMAT,NEW.CODMAT,agora(),'Descrio detalhada (em HTML): '||COALESCE(SUBSTR(OLD.DESDET,1,1000),'Nulo'));
      END IF;
    END IF;

    -- MN - Se mudar QUALQUER campo que faa parte do nome do produto, tem que registrar log. A funo  chamada assim:
    --CAST(NomeProduto(PRO.DESECF, PRO.DESMAT, GRA.CODCOR, DIV.NOMITE, GRA.CODTAM, SUB.NOMITE, PRO.ESPMAT, GRA.DESGRA, DIV.NOMEXT, SUB.NOMEXT) AS VARCHAR(254)) AS NOMPRO 
      IF (TG_OP = 'UPDATE') THEN
         IF Equal(OLD.DESECF, NEW.DESECF) <> 1 OR Equal(OLD.DESMAT, NEW.DESMAT) <> 1 OR 
            Equal(OLD.ESPMAT, NEW.ESPMAT) <> 1 THEN
            INSERT INTO TL_PRO_SPED (FILMAT, CODMAT, TIPLOG, DESECF, DESMAT, ESPMAT, CODCOR, CODTAM, DESGRA, CODFIS)
               VALUES (OLD.FILMAT, OLD.CODMAT, 'C', OLD.DESECF, OLD.DESMAT, OLD.ESPMAT, NULL, NULL, NULL, NULL);
         END IF;
      END IF;

    IF Equal(OLD.TIPPRO,NEW.TIPPRO) <> 1 OR Equal(OLD.CODMON,NEW.CODMON) <> 1 THEN
      IF NEW.TIPPRO <> 0 OR NEW.CODMON IS NULL THEN
        -- Manda zerar percentual equivalente a servicos
        UPDATE TT_IUF SET DUMMY  = Constante('vem_de_TGPRO'),
                          PERSRV = 0
         WHERE FILMAT = NEW.FILMAT
           AND CODMAT = NEW.CODMAT;
      END IF;
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4930 --*/
CREATE TRIGGER TGPRO3
AFTER INSERT OR UPDATE ON TT_PRO 
FOR EACH ROW EXECUTE PROCEDURE TGPRO3();



/*-- SEQ 4931 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPRO_DW() CASCADE;

/*-- SEQ 4932 --*/
CREATE OR REPLACE FUNCTION TGPRO_DW() RETURNS TRIGGER AS $$
DECLARE
   bProc_DW_Produto              BOOLEAN DEFAULT False;
   bProc_DW_Vendas_Grupos        BOOLEAN DEFAULT False;
   cDUMMY                        VARCHAR(2);
   regDWPro                      RECORD;
   regDWVenGru                   RECORD;
   vFILMAT                       TT_PRO.FILMAT%TYPE;
   vCODMAT                       TT_PRO.CODMAT%TYPE;
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');

-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Produto
-- 2) Gerar log para view/tabela materializada DW_Vendas_Grupos

BEGIN
  IF UsaVMDecisor() = 'T' THEN
     -- DW_Produto
     -- (TG_OP = 'INSERT'): Controle realizado na grade
     -- DW_Vendas_Grupos
     -- (TG_OP = 'INSERT'): No est em nenhuma venda
     -- (TG_OP = 'DELETE'): Garantido pela FK
     IF (TG_OP = 'UPDATE') THEN
       IF Equal(OLD.FILMAT,NEW.FILMAT) <> 1 -- PK
       OR Equal(OLD.CODMAT,NEW.CODMAT) <> 1 -- PK
       THEN
         RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
       END IF;
       -- DW_Produto
       IF Equal(OLD.DESECF,NEW.DESECF) <> 1
       OR Equal(OLD.DESMAT,NEW.DESMAT) <> 1
       OR Equal(OLD.ESPMAT,NEW.ESPMAT) <> 1
       OR Equal(OLD.CLASS1,NEW.CLASS1) <> 1
       OR Equal(OLD.CLASS2,NEW.CLASS2) <> 1
       OR Equal(OLD.CLASS3,NEW.CLASS3) <> 1
       OR Equal(OLD.CLASS4,NEW.CLASS4) <> 1
       OR Equal(OLD.DEPART,NEW.DEPART) <> 1 THEN
         bProc_DW_Produto        := True;
       END IF;
       -- DW_Vendas_Grupos
       IF Equal(OLD.CLASS1,NEW.CLASS1) <> 1
       OR Equal(OLD.CLASS2,NEW.CLASS2) <> 1
       OR Equal(OLD.CLASS3,NEW.CLASS3) <> 1
       OR Equal(OLD.CLASS4,NEW.CLASS4) <> 1
       OR Equal(OLD.DEPART,NEW.DEPART) <> 1 THEN
         bProc_DW_Vendas_Grupos  := True;
       END IF;
       IF bProc_DW_Produto
       OR bProc_DW_Vendas_Grupos THEN
         vFILMAT                 := NEW.FILMAT;
         vCODMAT                 := NEW.CODMAT;
       END IF;
     ELSIF (TG_OP = 'DELETE') THEN
       bProc_DW_Produto        := True;
       vFILMAT                 := OLD.FILMAT;
       vCODMAT                 := OLD.CODMAT;
     END IF;
     IF bProc_DW_Produto THEN
       FOR regDWPro IN (SELECT DISTINCT DW.FILMAT, DW.CODMAT, DW.CODCOR, DW.CODTAM
                          FROM DW_Produto DW
                         WHERE DW.FILMAT = vFILMAT
                           AND DW.CODMAT = vCODMAT)
       LOOP
         cDUMMY := Insere_DW_Log_Produto(regDWPro.FILMAT,regDWPro.CODMAT,regDWPro.CODCOR,regDWPro.CODTAM);
       END LOOP;
     END IF;
     IF bProc_DW_Vendas_Grupos THEN
       FOR regDWVenGru IN (SELECT DISTINCT FILIAL, ANO_MES
                             FROM DW_Vendas_Grupos
                            WHERE Cod_Classe1 = OLD.CLASS1
                              AND Equal(OLD.CLASS1,NEW.CLASS1) <> 1
                            UNION ALL
                           SELECT DISTINCT FILIAL, ANO_MES
                             FROM DW_Vendas_Grupos
                            WHERE Cod_Classe2 = OLD.CLASS2
                              AND Equal(OLD.CLASS2,NEW.CLASS2) <> 1
                            UNION ALL
                           SELECT DISTINCT FILIAL, ANO_MES
                             FROM DW_Vendas_Grupos
                            WHERE Cod_Classe2 = OLD.CLASS2
                              AND Equal(OLD.CLASS3,NEW.CLASS3) <> 1
                            UNION ALL
                           SELECT DISTINCT FILIAL, ANO_MES
                             FROM DW_Vendas_Grupos
                            WHERE Cod_Classe3 = OLD.CLASS3
                              AND Equal(OLD.CLASS4,NEW.CLASS4) <> 1
                            UNION ALL
                           SELECT DISTINCT FILIAL, ANO_MES
                             FROM DW_Vendas_Grupos
                            WHERE Cod_Classe4 = OLD.CLASS4
                              AND Equal(OLD.DEPART,NEW.DEPART) <> 1
                            UNION ALL
                           SELECT DISTINCT FILIAL, ANO_MES
                             FROM DW_Vendas_Grupos
                            WHERE Cod_Departamento = OLD.DEPART
                              AND Equal(OLD.DEPART,NEW.DEPART) <> 1)
       LOOP
         cDUMMY := Insere_DW_Log_Vendas_Grupos(regDWVenGru.FILIAL, regDWVenGru.ANO_MES);
       END LOOP;
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4933 --*/
CREATE TRIGGER TGPRO_DW
AFTER DELETE OR UPDATE ON TT_PRO 
FOR EACH ROW EXECUTE PROCEDURE TGPRO_DW();

/*-- SEQ 4934 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPRO_ASS() CASCADE;

/*-- SEQ 4935 --*/
CREATE OR REPLACE FUNCTION TGPRO_ASS() RETURNS TRIGGER AS $$
-- 83073
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN

  IF ExisteFilialNaUF('SC') THEN
     IF (TG_OP = 'INSERT') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG + 1
        WHERE NOMTAB = 'TT_PRO';
     END IF;
     
     IF (TG_OP = 'DELETE') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG - 1
        WHERE NOMTAB = 'TT_PRO';
     END IF;  
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4936 --*/
CREATE TRIGGER TGPRO_ASS
AFTER INSERT OR DELETE ON TT_PRO 
FOR EACH ROW EXECUTE PROCEDURE TGPRO_ASS();

/*-- SEQ 4937 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPRO5() CASCADE;

/*-- SEQ 4938 --*/
CREATE OR REPLACE FUNCTION TGPRO5() RETURNS TRIGGER AS $$
DECLARE
   --LEO 84337
   vCODUID_ATUAL                 VARCHAR(22);
   vBLQ_SEM_UID                  TT_CFG.BLQ_SEM_UID%TYPE;
   vSESSIONID                    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

BEGIN

  IF (TG_OP = 'DELETE') THEN
    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4939 --*/
CREATE TRIGGER TGPRO5
BEFORE DELETE ON TT_PRO 
FOR EACH ROW EXECUTE PROCEDURE TGPRO5();


/*-- SEQ 4940 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPROXNOM() CASCADE;

/*-- SEQ 4941 --*/
CREATE OR REPLACE FUNCTION TGPROXNOM() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TT_PROXNOM',NEW.FILMAT);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4942 --*/
CREATE TRIGGER TGPROXNOM
BEFORE INSERT ON TT_PROXNOM 
FOR EACH ROW EXECUTE PROCEDURE TGPROXNOM();


/*-- SEQ 4943 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPTC() CASCADE;

/*-- SEQ 4944 --*/
CREATE OR REPLACE FUNCTION TGPTC() RETURNS TRIGGER AS $$
DECLARE
-- Principal
BEGIN
  --Popula a coluna SEQUEN e DATINC
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.SEQUEN IS NULL THEN
      NEW.SEQUEN := ProximoCodigo('TT_PTC',NEW.CODFIL); 
    END IF;       
    NEW.DATINC := agora();
  END IF;

  -- Popula a coluna ATU_EM
  IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
     NEW.ATU_EM := agora();      
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4945 --*/
CREATE TRIGGER TGPTC
BEFORE INSERT OR UPDATE ON TT_PTC 
FOR EACH ROW EXECUTE PROCEDURE TGPTC();

/*-- SEQ 4946 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPTC2() CASCADE;

/*-- SEQ 4947 --*/
CREATE OR REPLACE FUNCTION TGPTC2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 2) Registrar mudanca dos dados num "log"
   vLOG    VARCHAR(4000)     := '';
   vFILUSU VARCHAR(3);    
   vCODUSU VARCHAR(3); 
   cNulo   CONSTANT CHAR(4)   := 'Nulo';
   iNulo   CONSTANT Numeric(1) := 0;   
   CRLF    CONSTANT CHAR(1)   := CHR(10);  
    
    QuemLogou TRetQuemLogou%ROWTYPE;
    WK_CODUID TT_UID.CODUID%TYPE;
BEGIN
  WK_CODUID := GetCoduidAtual();

  select * into QuemLogou from DadosLogon();
  vFILUSU := QuemLogou.FILUSU;
  vCODUSU := QuemLogou.CODUSU;
                              
  -- Tratamento de log
  IF (TG_OP = 'INSERT') THEN
     vLOG := 'Inclusao';
     INSERT INTO TL_PTC (CODFIL,SEQUEN,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
          VALUES(NEW.CODFIL,NEW.SEQUEN,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);  
  ELSIF (TG_OP = 'UPDATE') THEN

     IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
        vLOG := vLOG||'Cdigo da Filial: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
       vLOG := vLOG||'Sequenciador: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.TIPPTC,NEW.TIPPTC) <> 1 THEN
        vLOG := vLOG||'Tipo: de '||COALESCE(OLD.TIPPTC,cNulo)||' para '||COALESCE(NEW.TIPPTC,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DESPTC,NEW.DESPTC) <> 1 THEN
        vLOG := vLOG||'Descrio de Protocolos e Convnios: de '||COALESCE(OLD.DESPTC,cNulo)||' para '||COALESCE(NEW.DESPTC,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATINC,NEW.DATINC) <> 1 THEN
        vLOG := vLOG||'Data Incluso: de '||COALESCE(to_char(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.ATU_EM,NEW.ATU_EM) <> 1 THEN
        vLOG := vLOG||'Data Atualizao: de '||COALESCE(to_char(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SIGNAT,NEW.SIGNAT) <> 1 THEN
        vLOG := vLOG||'Ativo: de '||COALESCE(OLD.SIGNAT,iNulo)||' para '||COALESCE(NEW.SIGNAT,iNulo)||CRLF;
     END IF;
     IF ISNOTNULL(trim(vLOG)) = 'T' THEN
        -- cadastra o LOG.
        INSERT INTO TL_PTC (CODFIL,SEQUEN,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                 VALUES (NEW.CODFIL,NEW.SEQUEN,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);     
     END IF;   
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4948 --*/
CREATE TRIGGER TGPTC2
AFTER INSERT OR UPDATE OR DELETE ON TT_PTC 
FOR EACH ROW EXECUTE PROCEDURE TGPTC2();



/*-- SEQ 4949 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPTR2() CASCADE;

/*-- SEQ 4950 --*/
CREATE OR REPLACE FUNCTION TGPTR2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Impedir exclusao
-- 2) Impedir alteracao nas colunas que nao se referem ao status
--
  status        TT_TRC.FLGEST%TYPE;
  proximo       CHAR(10);
  vComplemento  constant VARCHAR(100) := constante('complemento');
  vVem_de_TGTRC constant VARCHAR(100) := constante('VEM_DE_TGTRC');
  cDUMMY        VARCHAR(10);
  
  c_status_aberto            CONSTANT CHAR(1) := 'A';
  c_status_cancelado         CONSTANT CHAR(1) := 'C';
  c_status_pago              CONSTANT CHAR(1) := 'P';
  c_status_estornado         CONSTANT CHAR(1) := 'X';  

BEGIN

  -- Impede exclusoes
  IF (TG_OP = 'DELETE') THEN
     RAISE EXCEPTION 'PG-20027 Exclusao so pode ser feita atraves da rotina manutencao. %' , vComplemento;
  END IF;

  -- Impede alteracoes
  IF (TG_OP = 'UPDATE') THEN
    IF (OLD.SEQUEN <> NEW.SEQUEN) OR
       (OLD.CODFIL <> NEW.CODFIL) OR
       (OLD.NUMPAR <> NEW.NUMPAR) OR
       (LTRIM(RTRIM(OLD.SUBPAR)) <> LTRIM(RTRIM(NEW.SUBPAR))) THEN
       RAISE EXCEPTION 'PG-20028 Dado da parcela de ttulo a receber nao pode ser modificado. %' , vComplemento;
    END IF;

    -- Verifica se a mudanca do "flag" e permitida
    IF (OLD.FLGEST IN ('C','X')) THEN
       RAISE EXCEPTION 'PG-20029 Parcela de ttulo a receber cancelada ou estornada nao pode ser modificada % ' , vComplemento;
    ELSIF (OLD.FLGEST = 'A') AND (NEW.FLGEST NOT IN ('A','P','C')) THEN
       RAISE EXCEPTION 'PG-20030 Esta parcela de ttulo a receber so pode ser paga ou cancelada %' , vComplemento;
    ELSIF (OLD.FLGEST = 'P') AND (NEW.FLGEST <> 'X') THEN
       RAISE EXCEPTION 'PG-20031 Parcelas de ttulo a receber pagas so podem ser estornadas %' , vComplemento;
    END IF;
    
    --Se FLGEST passa a ser X ou C e no era, e se NEW.PAGAME for nulo, assumir data atual     
    IF (NEW.FLGEST <> OLD.FLGEST) AND 
       ((NEW.FLGEST  = c_status_estornado) OR (NEW.FLGEST  = c_status_cancelado)) AND 
       ((OLD.FLGEST <> c_status_estornado) OR (OLD.FLGEST <> c_status_cancelado)) THEN
       IF (NEW.DATPGT is null) THEN
         NEW.DATPGT := agora();
       END IF;
    END IF; 
       
    -- Verificacoes quanto a data de pagamento
    IF (NEW.DATPGT is null) and not (NEW.FLGEST IN ('C','A')) then
       RAISE EXCEPTION 'PG-20034 Data de pagamento nao foi informada. %' , vComplemento;
    END IF;
  END IF;

  -- Dispensa restante do teste se a atualizacao tiver sido solicitada pela trigger TGTRC
  IF (NEW.DUMMY <> vVem_de_TGTRC) THEN
     -- Traz o "status" atual do ttulo a receber
     SELECT FLGEST
       INTO status
       FROM TT_TRC
      WHERE CODFIL = NEW.CODFIL
        AND SEQUEN = NEW.SEQUEN
                
        FOR UPDATE;
             IF (status = 'D') AND (NEW.FLGEST NOT IN ('C','X')) THEN
        RAISE EXCEPTION 'PG-20035 Titulo a receber cancelado so permite parcelas canceladas ou estornadas. %' , vComplemento;
     END IF;
  END IF;

  -- "Default"
  NEW.ATU_EM := agora();
  NEW.DATVEN := Trunc(NEW.DATVEN);
  NEW.DUMMY  := Null;
  NEW.SUBPAR := LPAD( COALESCE(LTRIM(RTRIM(NEW.SUBPAR)),'0'),2,' ');

  -- Evitar lanamentos fora do perodo de validade
  IF not (TG_OP = 'DELETE') THEN
     IF not (Livre(NEW.CODFIL,'TT_PTR',NEW.DATVEN) = 1) THEN
        RAISE EXCEPTION 'PG-20039 Lancamento fora do periodo de validade de uso do sistema. %' , vComplemento;
     END IF;
  END IF;
  
  -- DN 45679 - Tabelas Financeiras
  IF (TG_OP = 'INSERT') THEN
    NEW.DATINC := agora();
    cDUMMY      := INSERE_LFIN_LAN('PTR',NEW.CODFIL,NEW.SEQUEN,NEW.NUMPAR,NEW.SUBPAR);
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF (Equal(OLD.FLGEST,NEW.FLGEST) <> 1) OR 
        (Equal(OLD.VLRPAR,NEW.VLRPAR) <> 1) OR
        (Equal(OLD.DATPGT,NEW.DATPGT) <> 1) OR
        (Equal(OLD.DATVEN,NEW.DATVEN) <> 1) OR
        (Equal(OLD.VLRPGT,NEW.VLRPGT) <> 1) OR
        (Equal(OLD.FILCTA,NEW.FILCTA) <> 1) OR
        (Equal(OLD.SEQCTA,NEW.SEQCTA) <> 1) OR
        (Equal(OLD.TIPCTA,NEW.TIPCTA) <> 1) THEN
        cDUMMY:=INSERE_LFIN_LAN('PTR',NEW.CODFIL,NEW.SEQUEN,NEW.NUMPAR,NEW.SUBPAR);
     END IF;
  END IF;
  -- DN 45679 - Fim Tabelas Financeiras

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4951 --*/
CREATE TRIGGER TGPTR2
BEFORE INSERT OR DELETE OR UPDATE ON  TT_PTR 
FOR EACH ROW EXECUTE PROCEDURE TGPTR2();


/*-- SEQ 4952 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPTR3() CASCADE;

/*-- SEQ 4953 --*/
CREATE OR REPLACE FUNCTION TGPTR3() RETURNS TRIGGER AS $$
DECLARE
  inRec      TT_PTR%ROWTYPE;
  bMudou     Boolean;
  cDUMMY     VARCHAR(1);
BEGIN

  bMudou := False;
  IF (TG_OP = 'UPDATE') THEN
     IF OLD.FLGEST <> NEW.FLGEST THEN
        bMudou := True;
     END IF;
  END IF;

  IF ((TG_OP = 'INSERT') OR bMudou) AND
     ((NEW.FLGEST = 'X') or (NEW.FLGEST = 'P')) THEN

             inRec.CODFIL := NEW.CODFIL;
        inRec.SEQUEN := NEW.SEQUEN;
        inRec.NUMPAR := NEW.NUMPAR;
        inRec.SUBPAR := NEW.SUBPAR;
        inRec.FLGEST := NEW.FLGEST;
        inRec.DATVEN := NEW.DATVEN;
        inRec.DATPGT := NEW.DATPGT;
        inRec.DATPRX := NEW.DATPRX;
        inRec.VLRPAR := NEW.VLRPAR;
        inRec.VLRPGT := NEW.VLRPGT;
        inRec.VLRDIF := NEW.VLRDIF;
        inRec.VLRDES := NEW.VLRDES;
          
      cDUMMY := PC_PTR_UPDATE(inRec.CODFIL,inRec.SEQUEN,inRec.NUMPAR,
                              inRec.SUBPAR,inRec.FLGEST,inRec.DATVEN,
                              inRec.DATPGT,inRec.DATPRX,inRec.VLRPAR,
                              inRec.VLRPGT,inRec.VLRDIF,inRec.VLRDES);
       END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4954 --*/
CREATE TRIGGER TGPTR3
AFTER INSERT OR UPDATE ON TT_PTR 
FOR EACH ROW EXECUTE PROCEDURE TGPTR3();




/*-- SEQ 4955 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPXF1() CASCADE;

/*-- SEQ 4956 --*/
CREATE OR REPLACE FUNCTION TGPXF1() RETURNS TRIGGER AS $$
BEGIN
   NEW.ATU_EM := AGORA();
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4957 --*/
CREATE TRIGGER TGPXF1
BEFORE INSERT OR UPDATE ON TT_PXF 
FOR EACH ROW EXECUTE PROCEDURE TGPXF1();

/*-- SEQ 4958 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPXF2() CASCADE;

/*-- SEQ 4959 --*/
CREATE OR REPLACE FUNCTION TGPXF2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo
-- 1) Registrar mudanca dos dados num "log"
-- 2) Registrar Pendncias para Atualizar os Impostos de Fornecedores Calculados 
   cLOG                          VARCHAR(4000)     := '';
   cLogChave                     VARCHAR(25)       := '';
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   cRETORNO                      VARCHAR(4);
   cFPVPRECOSIMULADO             TT_CFG.FPV_PRECO_SIMULADO%TYPE;  
-- Principal
BEGIN
   SELECT FPV_PRECO_SIMULADO INTO cFPVPRECOSIMULADO FROM TT_CFG;  
   
   IF (TG_OP = 'INSERT') THEN
      IF (cFPVPRECOSIMULADO = 'T') THEN 
         cRETORNO := INSERE_MIFC('PXF',NEW.FILMAT || NEW.CODMAT || RPAD(TO_CHAR(NEW.CODCOR),5,' ') || RPAD(TO_CHAR(NEW.CODTAM),5,' ') || NEW.FILFOR || NEW.CODFOR);
      END IF;
   ELSIF (TG_OP = 'UPDATE') THEN
      IF (cFPVPRECOSIMULADO = 'T') THEN
         IF (Equal(OLD.PRESIM, NEW.PRESIM) <> 1)
         OR (Equal(OLD.DACSIM, NEW.DACSIM) <> 1)
         OR (Equal(OLD.FRESIM, NEW.FRESIM) <> 1) THEN      
            cRETORNO := INSERE_MIFC('PXF',NEW.FILMAT || NEW.CODMAT || RPAD(TO_CHAR(NEW.CODCOR),5,' ') || RPAD(TO_CHAR(NEW.CODTAM),5,' ') || NEW.FILFOR || NEW.CODFOR);
         END IF;
      END IF;
   END IF;
   
   -- Tratamento de LOG
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN
      cLogChave := 'Fornecedor ' || NEW.FILFOR || '-' || NEW.CODFOR;
   END IF;
   IF (TG_OP = 'INSERT') THEN
      cLOG := 'Incluso de ' || cLogChave;
   ELSIF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.ORICUS,NEW.ORICUS) <> 1 THEN
         cLOG := cLOG||'Origem dos Custos: de '||COALESCE(OLD.ORICUS,cNulo)||' para '||COALESCE(NEW.ORICUS,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ICMTIP,NEW.ICMTIP) <> 1 THEN
         cLOG := cLOG||'Tipo de Tributao: de '||COALESCE(OLD.ICMTIP,cNulo)||' para '||COALESCE(NEW.ICMTIP,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.OUTCUS,NEW.OUTCUS) <> 1 THEN
         cLOG := cLOG||'Outros Custos: de '||COALESCE(TO_CHAR(OLD.OUTCUS,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.OUTCUS,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DACCUS,NEW.DACCUS) <> 1 THEN
         cLOG := cLOG||'% de Desconto/Acrscimo: de '||COALESCE(TO_CHAR(OLD.DACCUS,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DACCUS,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.AFICUS,NEW.AFICUS) <> 1 THEN
         cLOG := cLOG||'% Acrscimo Financeiro: de '||COALESCE(TO_CHAR(OLD.AFICUS,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.AFICUS,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ICMCUS,NEW.ICMCUS) <> 1 THEN
         cLOG := cLOG||'% ICMS: de '||COALESCE(TO_CHAR(OLD.ICMCUS,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ICMCUS,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.IPICUS,NEW.IPICUS) <> 1 THEN
         cLOG := cLOG||'% IPI: de '||COALESCE(TO_CHAR(OLD.IPICUS,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.IPICUS,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PRECOM,NEW.PRECOM) <> 1 THEN
         cLOG := cLOG||'Preo de Compra: de '||COALESCE(TO_CHAR(OLD.PRECOM,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PRECOM,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERFRE,NEW.PERFRE) <> 1 THEN
         cLOG := cLOG||'% de ICMS do Frete: de '||COALESCE(TO_CHAR(OLD.PERFRE,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERFRE,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ICMFRE,NEW.ICMFRE) <> 1 THEN
         cLOG := cLOG||'Valor do ICMS do Frete: de '||COALESCE(TO_CHAR(OLD.ICMFRE,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ICMFRE,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;    
      IF Equal(OLD.CUSFRE,NEW.CUSFRE) <> 1 THEN
         cLOG := cLOG||'Custo do Frete: de '||COALESCE(TO_CHAR(OLD.CUSFRE,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CUSFRE,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;    
      IF Equal(OLD.DACSIM,NEW.DACSIM) <> 1 THEN
         cLOG := cLOG||'% A/D Simulao Compra: de '||COALESCE(TO_CHAR(OLD.DACSIM,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DACSIM,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;    
      IF Equal(OLD.PRESIM,NEW.PRESIM) <> 1 THEN
         cLOG := cLOG||'Preo Simulado para Compra: de '||COALESCE(TO_CHAR(OLD.PRESIM,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PRESIM,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.MEDENT,NEW.MEDENT) <> 1 THEN
         cLOG := cLOG||'Mdia Rec Pedidos: de '||COALESCE(TO_CHAR(OLD.MEDENT,'fm99G999G990D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.MEDENT,'fm99G999G990D0000'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DP_ENT,NEW.DP_ENT) <> 1 THEN
         cLOG := cLOG||'Desv Padro Rec Ped: de '||COALESCE(TO_CHAR(OLD.DP_ENT,'fm99G999G990D0000'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DP_ENT,'fm99G999G990D0000'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FRESIM,NEW.FRESIM) <> 1 THEN
         cLOG := cLOG||'Frete Simul. Compra: de '||COALESCE(TO_CHAR(OLD.FRESIM,'fm99G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.FRESIM,'fm99G999G990D00'),cNulo)||CRLF;
      END IF;
      
      IF ISNOTNULL(cLOG) = 'T' THEN
         cLOG := cLogChave || ' >> ' || cLOG;
      END IF;
   END IF;
   IF (TG_OP = 'INSERT') 
   OR (TG_OP = 'UPDATE') THEN
      IF ISNOTNULL(cLOG) = 'T' THEN
         INSERT INTO TL_GRA (FILMAT,CODMAT,CODCOR,CODTAM,DATOPE,MSGLOG)
                     VALUES (NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,agora(),cLOG);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4960 --*/
CREATE TRIGGER TGPXF2
AFTER INSERT OR UPDATE ON TT_PXF 
FOR EACH ROW EXECUTE PROCEDURE TGPXF2();


/*-- SEQ 4961 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGPXR() CASCADE;

/*-- SEQ 4962 --*/
CREATE OR REPLACE FUNCTION TGPXR() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
BEGIN
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
      NEW.SEQUEN:=ProximoCodigo('TT_PXR',NEW.CODFIL);
    END IF;
  END IF; 
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4963 --*/
CREATE TRIGGER TGPXR
BEFORE INSERT OR UPDATE ON TT_PXR 
FOR EACH ROW EXECUTE PROCEDURE TGPXR();


/*-- SEQ 4964 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGQRY() CASCADE;

/*-- SEQ 4965 --*/
CREATE OR REPLACE FUNCTION TGQRY() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Gerar um cdigo sequencial exclusivo para compor a chave primria.
-- 2. Atualiza controles de data.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.ID_QRY IS NULL THEN
         SELECT NEXTVAL('sqQRY') INTO NEW.ID_QRY FROM DUAL;
      END IF;
      NEW.DATINC := Agora();
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4966 --*/
CREATE TRIGGER TGQRY
BEFORE INSERT OR UPDATE OR DELETE ON TT_QRY 
FOR EACH ROW EXECUTE PROCEDURE TGQRY();

/*-- SEQ 4967 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGQRY2() CASCADE;

/*-- SEQ 4968 --*/
CREATE OR REPLACE FUNCTION TGQRY2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao

-- Declarao de variveis e cursores
   cRetorno                      VARCHAR(2);

-- Principal
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4969 --*/
CREATE TRIGGER TGQRY2
AFTER INSERT OR UPDATE OR DELETE ON TT_QRY 
FOR EACH ROW EXECUTE PROCEDURE TGQRY2();


/*-- SEQ 4970 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGQUE() CASCADE;

/*-- SEQ 4971 --*/
CREATE OR REPLACE FUNCTION TGQUE() RETURNS TRIGGER AS $$
BEGIN
  -- Default
  NEW.ATU_EM := agora();
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4972 --*/
CREATE TRIGGER TGQUE
BEFORE INSERT OR UPDATE ON TT_QUE 
FOR EACH ROW EXECUTE PROCEDURE TGQUE();


/*-- SEQ 4973 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRAT1() CASCADE;

/*-- SEQ 4974 --*/
CREATE OR REPLACE FUNCTION TGRAT1() RETURNS TRIGGER AS $$
DECLARE

-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primria
-- 2) RATs somente possam ser aprovadas pelos usuarios que tenham permissao de revisar tarefas

-- Principal

 vComplemento CONSTANT VARCHAR(100) := constante('complemento');
 VPER Numeric;
 LANCA_RAT_EM_CC  CHAR(1);
BEGIN

  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
     IF NEW.SEQUEN IS NULL THEN
        NEW.SEQUEN := ProximoCodigo('TT_RAT',NEW.CODFIL);
     END IF;
     NEW.DATOPE:=agora();      
  END IF;

  vPER:=PERMISSAOPROJETO(NEW.FILPRJ,NEW.SEQPRJ,NULL,constante('WF_REVISOR'));

  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN        
     IF (Equal(OLD.STATUS,NEW.STATUS)<>1) AND 
        (NEW.STATUS IN ('C','R')) AND
        (PERMISSAOPROJETO(NEW.FILPRJ,NEW.SEQPRJ,NULL,constante('WF_VALIDAR_RAT'))=0) THEN
        RAISE EXCEPTION 'PG-20001 Usurio no tem permisso para aprovar RAT. %' , vComplemento;
     END IF;
     IF (Equal(OLD.STATUS,NEW.STATUS)<>1) AND (OLD.STATUS = 'C') AND
         PERMISSAOPROJETO(NEW.FILPRJ,NEW.SEQPRJ,null,CONSTANTE('wf_gerenciar')) = 0 THEN
        RAISE EXCEPTION 'PG-20002 Voc no tem permisso para alterar uma concluida. %' , vComplemento;
     END IF;

  END IF;

  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN        
    IF (Equal(OLD.SITFAT,NEW.SITFAT)<>1) THEN
      SELECT CASE WHEN TIPCCC_RAT IS NOT NULL THEN 'T' ELSE 'F' END
        INTO LANCA_RAT_EM_CC
        FROM TT_CFG;
      IF LANCA_RAT_EM_CC = 'T' THEN
        IF NEW.SITFAT = 'F' THEN
          NEW.SITFAT := '1';
        ELSIF NEW.SITFAT = 'Z' THEN
          NEW.SITFAT := 'C';
        END IF;
      END IF;
    END IF; 
  END IF;

 IF (TG_OP = 'DELETE') THEN
   IF (NEW.STATUS = 'C') THEN
        RAISE EXCEPTION 'PG-20003 Depois de concluida RAT nao pode ser excluida. %' , vComplemento;
   END IF;
 END IF;   
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4975 --*/
CREATE TRIGGER TGRAT1
BEFORE INSERT OR UPDATE ON TT_RAT 
FOR EACH ROW EXECUTE PROCEDURE TGRAT1();

/*-- SEQ 4976 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRAT2() CASCADE;

/*-- SEQ 4977 --*/
CREATE OR REPLACE FUNCTION TGRAT2() RETURNS TRIGGER AS $$
DECLARE

-- Objetivo:
-- 1) Registrar alteracoes em log

-- Principal

vLOG    VARCHAR(4000)     := '';
  QuemLogou TRetQuemLogou%ROWTYPE;
  
  cFILUSU TT_USU.FILUSU%TYPE;
  cCODUSU TT_USU.CODUSU%TYPE;
  vComplemento CONSTANT VARCHAR(100) := constante('complemento');
  CRLF    CONSTANT CHAR(1)   := CHR(10);
  wk_coduid tt_uid.coduid%type;
  cNulo   CONSTANT CHAR(4)   := 'Nulo';
  iNulo   CONSTANT Numeric(1) := 0;

BEGIN
  
  IF Equal(OLD.CODCLI,NEW.CODCLI) <> 1 THEN     
     vLOG := vLOG||'Codigo do cliente: de '||COALESCE(OLD.CODCLI,cNulo)||' para '||COALESCE(NEW.CODCLI,cNulo)||CRLF;
  END IF;
  IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN     
     vLOG := vLOG||'Codigo da filial: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
  END IF;
  IF Equal(OLD.CODRES,NEW.CODRES) <> 1 THEN     
     vLOG := vLOG||'Codigo do responsavel: de '||COALESCE(OLD.CODRES,cNulo)||' para '||COALESCE(NEW.CODRES,cNulo)||CRLF;
  END IF;
  IF Equal(OLD.DATOPE,NEW.DATOPE) <> 1 THEN     
     vLOG := vLOG||'Codigo da operacao: de '||COALESCE(OLD.DATOPE,cNulo)||' para '||COALESCE(NEW.DATOPE,cNulo)||CRLF;
  END IF;
  IF Equal(OLD.FILCLI,NEW.FILCLI) <> 1 THEN     
     vLOG := vLOG||'Filial do cliente: de '||COALESCE(OLD.FILCLI,cNulo)||' para '||COALESCE(NEW.FILCLI,cNulo)||CRLF;
  END IF;
  IF Equal(OLD.FILRES,NEW.FILRES) <> 1 THEN     
     vLOG := vLOG||'Filial do responsavel: de '||COALESCE(OLD.FILRES,cNulo)||' para '||COALESCE(NEW.FILRES,cNulo)||CRLF;
  END IF;
  IF Equal(OLD.NUMCON,NEW.NUMCON) <> 1 THEN     
     vLOG := vLOG||'Numero do contato: de '||COALESCE(OLD.NUMCON,iNulo)||' para '||COALESCE(NEW.NUMCON,iNulo)||CRLF;
  END IF;     
  IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN     
     vLOG := vLOG||'Numero da RAT: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
  END IF;  
  IF Equal(OLD.STATUS,NEW.STATUS) <> 1 THEN     
     vLOG := vLOG||'Status: de '||COALESCE(OLD.STATUS,cNulo)||' para '||COALESCE(NEW.STATUS,cNulo)||CRLF;
  END IF; 
  IF Equal(OLD.CODREV,NEW.CODREV) <> 1 THEN     
     vLOG := vLOG||'Codigo da revenda: de '||COALESCE(OLD.CODREV,cNulo)||' para '||COALESCE(NEW.CODREV,cNulo)||CRLF;
  END IF;
  IF Equal(OLD.FILREV,NEW.FILREV) <> 1 THEN     
     vLOG := vLOG||'Filial da revenda: de '||COALESCE(OLD.FILREV,cNulo)||' para '||COALESCE(NEW.FILREV,cNulo)||CRLF;
  END IF;
  IF Equal(OLD.NUMREV,NEW.NUMREV) <> 1 THEN     
     vLOG := vLOG||'Numero da revenda: de '||COALESCE(OLD.NUMREV,iNulo)||' para '||COALESCE(NEW.NUMREV,iNulo)||CRLF;
  END IF;    
  IF Equal(OLD.CODAPR,NEW.CODAPR) <> 1 THEN     
     vLOG := vLOG||'Aprovacao feita por: de '||COALESCE(OLD.CODAPR,cNulo)||' para '||COALESCE(NEW.CODAPR,cNulo)||CRLF;
  END IF;
  IF Equal(OLD.COMENT,NEW.COMENT) <> 1 THEN     
     vLOG := vLOG||'Comentarios: de '||COALESCE(OLD.COMENT,cNulo)||' para '||COALESCE(NEW.COMENT,cNulo)||CRLF;
  END IF;
  IF Equal(OLD.FILAPR,NEW.FILAPR) <> 1 THEN     
     vLOG := vLOG||'Filial do aprovador: de '||COALESCE(OLD.FILAPR,cNulo)||' para '||COALESCE(NEW.FILAPR,cNulo)||CRLF;
  END IF;
  IF Equal(OLD.SITFAT,NEW.SITFAT) <> 1 THEN     
     vLOG := vLOG||'Situacao de faturamento: de '||
               COALESCE(DescricaoDominio('RAT','SITFAT',TO_CHAR(OLD.SITFAT)),cNulo)
               ||' para '||
               COALESCE(DescricaoDominio('RAT','SITFAT',TO_CHAR(NEW.SITFAT)),cNulo) 
               ||CRLF;
  END IF;
  IF Equal(OLD.SITPAG,NEW.SITPAG) <> 1 THEN     
     vLOG := vLOG||'Situacao de pagamento: de '||
               CASE OLD.SITPAG WHEN 'A' THEN 'aberto'
                                WHEN 'P' THEN 'a pagar'
                                WHEN '1' THEN 'paga'
                                WHEN '2' THEN 'reprovada'
               END ||' para '||
               CASE NEW.SITPAG WHEN 'A' THEN 'aberto'
                                WHEN 'P' THEN 'a pagar'
                                WHEN '1' THEN 'paga'
                                WHEN '2' THEN 'reprovada'
               END ||CRLF;
  END IF;
  IF Equal(OLD.FILPRJ,NEW.FILPRJ) <> 1 THEN     
     vLOG := vLOG||'Filial do projeto: de '||COALESCE(OLD.FILPRJ,cNulo)||' para '||COALESCE(NEW.FILPRJ,cNulo)||CRLF;
  END IF;  
  IF Equal(OLD.SEQPRJ,NEW.SEQPRJ) <> 1 THEN     
     vLOG := vLOG||'Sequenciador do projeto: de '||COALESCE(OLD.SEQPRJ,cNulo)||' para '||COALESCE(NEW.SEQPRJ,cNulo)||CRLF;
  END IF;
  IF Equal(OLD.CODCRI,NEW.CODCRI) <> 1 THEN     
     vLOG := vLOG||'Codigo do Parceiro que criou a RAT: de '||COALESCE(OLD.CODCRI,cNulo)||' para '||COALESCE(NEW.CODCRI,cNulo)||CRLF;
  END IF;    
  IF Equal(OLD.CODPAR,NEW.CODPAR) <> 1 THEN     
     vLOG := vLOG||'Codigo do Parceiro: de '||COALESCE(OLD.CODPAR,cNulo)||' para '||COALESCE(NEW.CODPAR,cNulo)||CRLF;
  END IF;  
  IF Equal(OLD.FILCRI,NEW.FILCRI) <> 1 THEN     
     vLOG := vLOG||'Filial do Parceiro que criou a RAT: de '||COALESCE(OLD.FILCRI,cNulo)||' para '||COALESCE(NEW.FILCRI,cNulo)||CRLF;
  END IF;
  IF Equal(OLD.FILPAR,NEW.FILPAR) <> 1 THEN     
     vLOG := vLOG||'Filial do Parceiro: de '||COALESCE(OLD.FILPAR,cNulo)||' para '||COALESCE(NEW.FILPAR,cNulo)||CRLF;
  END IF;    
  IF Equal(OLD.NUMCRI,NEW.NUMCRI) <> 1 THEN     
     vLOG := vLOG||'Numero de criacao da RAT: de '||COALESCE(OLD.NUMCRI,iNulo)||' para '||COALESCE(NEW.NUMCRI,iNulo)||CRLF;
  END IF;  
  IF Equal(OLD.TIPPAR,NEW.TIPPAR) <> 1 THEN     
     vLOG := vLOG||'Tipo de parceiro: de '||COALESCE(OLD.TIPPAR,cNulo)||' para '||COALESCE(NEW.TIPPAR,cNulo)||CRLF;
  END IF;   
  IF Equal(OLD.VLRHOR,NEW.VLRHOR) <> 1 THEN     
     vLOG := vLOG||'Valor hora: de '||COALESCE(OLD.VLRHOR,iNulo)||' para '||COALESCE(NEW.VLRHOR,iNulo)||CRLF;
  END IF;  
  IF Equal(OLD.VLRCON,NEW.VLRCON) <> 1 THEN     
     vLOG := vLOG||'Valor para consultor: de '||COALESCE(OLD.VLRCON,iNulo)||' para '||COALESCE(NEW.VLRCON,iNulo)||CRLF;
  END IF;  
  IF Equal(OLD.VLRCONCAL,NEW.VLRCONCAL) <> 1 THEN     
     vLOG := vLOG||'Valor calculado para consultor: de '||COALESCE(OLD.VLRCONCAL,iNulo)||' para '||COALESCE(NEW.VLRCONCAL,iNulo)||CRLF;
  END IF;  
  IF Equal(OLD.VLRTOT,NEW.VLRTOT) <> 1 THEN     
     vLOG := vLOG||'Valor total calculado para cliente: de '||COALESCE(OLD.VLRTOT,iNulo)||' para '||COALESCE(NEW.VLRTOT,iNulo)||CRLF;
  END IF;
  IF Equal(OLD.VLRTOTCAL,NEW.VLRTOTCAL) <> 1 THEN     
     vLOG := vLOG||'Valor total para cliente: de '||COALESCE(OLD.VLRTOTCAL,iNulo)||' para '||COALESCE(NEW.VLRTOTCAL,iNulo)||CRLF;
  END IF;

  WK_CODUID := GetCoduidAtual();

  IF ISNOTNULL(vLOG) = 'T' THEN
      select * into QuemLogou from DadosLogon();
      -- Pega CODFIL e SEQUEN do usuario logado
      IF not QuemLogou.Encontrou THEN
         RAISE EXCEPTION 'PG-20050 Voce nao e um usuario cadastrado no sistema %' , vComplemento;
      END IF;
      cFILUSU := QuemLogou.FILUSU;
      cCODUSU := QuemLogou.CODUSU; 
       
     -- cadastra o LOG.
     INSERT INTO TL_RAT (CODFIL,SEQUEN,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                 VALUES (NEW.CODFIL,NEW.SEQUEN,agora(),cFILUSU,cCODUSU,vLOG,WK_CODUID);
                 
  END IF;  
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4978 --*/
CREATE TRIGGER TGRAT2
AFTER INSERT OR UPDATE ON TT_RAT 
FOR EACH ROW EXECUTE PROCEDURE TGRAT2();


/*-- SEQ 4979 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRCAI() CASCADE;

/*-- SEQ 4980 --*/
CREATE OR REPLACE FUNCTION TGRCAI() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo(s):
-- 1) Nao permitir alterar
-- 2) Nao permitir excluir
-- 3) Gerar codigo sequencial exclusivo para compor a chave primaria
-- 4) Assinar Registro

-- Declarao de variveis e cursores
   vComplemento                  Constant VARCHAR(100) := Constante('Complemento');
   vBLQ_SEM_UID                  TT_CFG.BLQ_SEM_UID%TYPE;
   vCODUID_ATUAL                 TR_CAI.CODUID%TYPE;
   vSESSIONID                    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

-- Incio da funo
BEGIN
   -- Impede exclusoes
   IF (TG_OP = 'DELETE') THEN
     RAISE EXCEPTION 'PG-20028 Movimentacao de caixa nao pode ser excluida. %' , vComplemento;
   END IF;

   -- Impede alteracoes
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(NEW.CODFIL,OLD.CODFIL) = 0 OR
         Equal(NEW.SEQUEN,OLD.SEQUEN) = 0 OR
         Equal(NEW.DATABE,OLD.DATABE) = 0 OR
         Equal(NEW.DATFEC,OLD.DATFEC) = 0 OR
         Equal(NEW.FILUSU,OLD.FILUSU) = 0 OR
         Equal(NEW.CODUSU,OLD.CODUSU) = 0 OR
         Equal(NEW.VLRFEC,OLD.VLRFEC) = 0 OR
         Equal(NEW.VLRDIF,OLD.VLRDIF) = 0 OR
         Equal(NEW.ARQCAI,OLD.ARQCAI) = 0 OR
         Equal(NEW.ARQXLS,OLD.ARQXLS) = 0 OR
         Equal(NEW.CUPINI,OLD.CUPINI) = 0 OR
         Equal(NEW.CUPFIM,OLD.CUPFIM) = 0 THEN
         RAISE EXCEPTION 'PG-20003 Alguns dados da Movimentacao de Caixa nao podem ser alterados. %' , vComplemento;
      END IF;

      IF ConcatenaRCAI(OLD.CODFIL,OLD.SEQUEN,OLD.FILUSU,OLD.CODUSU) <> ConcatenaRCAI(NEW.CODFIL,NEW.SEQUEN,NEW.FILUSU,NEW.CODUSU) THEN

         SELECT BLQ_SEM_UID
           INTO vBLQ_SEM_UID
           FROM TT_CFG;

         vCODUID_ATUAL := GetCoduidAtual();

         IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;

         NEW.CODUID := GetCoduidAtual();
         NEW.ASSINA := COALESCE(AssinaTabela('TR_CAI',
                                             ConcatenaRCAI(NEW.CODFIL,
                                                           NEW.SEQUEN,
                                                           NEW.FILUSU,
                                                           NEW.CODUSU),
                                                       OLD.CODUID,
                                             ConcatenaRCAI(OLD.CODFIL,
                                                           OLD.SEQUEN,
                                                           OLD.FILUSU,
                                                           OLD.CODUSU),
                                                      OLD.ASSINA
                                             ),NEW.ASSINA);
      END IF;
   END IF;

   -- Gera um codigo automaticamente
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN := ProximoCodigo('TR_CAI',NEW.CODFIL);
      END IF;

      SELECT BLQ_SEM_UID
        INTO vBLQ_SEM_UID
        FROM TT_CFG;

      vCODUID_ATUAL := GetCoduidAtual();

      IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;

      NEW.CODUID := GetCoduidAtual();
      NEW.ASSINA := COALESCE(AssinaTabela('TR_CAI',
                                            ConcatenaRCAI(NEW.CODFIL,
                                                          NEW.SEQUEN,
                                                          NEW.FILUSU,
                                                          NEW.CODUSU),
                                                       null, null, null),NEW.ASSINA);

   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4981 --*/
CREATE TRIGGER TGRCAI
BEFORE INSERT OR DELETE OR UPDATE ON TR_CAI 
FOR EACH ROW EXECUTE PROCEDURE TGRCAI();

/*-- SEQ 4982 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRCAI_ASS() CASCADE;

/*-- SEQ 4983 --*/
CREATE OR REPLACE FUNCTION TGRCAI_ASS() RETURNS TRIGGER AS $$
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN

   IF (TG_OP = 'INSERT') THEN
     UPDATE TT_ASS
        SET QTDREG = QTDREG + 1
      WHERE NOMTAB = 'TR_CAI';
   END IF;

   IF (TG_OP = 'DELETE') THEN
     UPDATE TT_ASS
        SET QTDREG = QTDREG - 1
      WHERE NOMTAB = 'TR_CAI';
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4984 --*/
CREATE TRIGGER TGRCAI_ASS
AFTER INSERT OR DELETE ON TR_CAI 
FOR EACH ROW EXECUTE PROCEDURE TGRCAI_ASS();


/*-- SEQ 4985 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRCP() CASCADE;

/*-- SEQ 4986 --*/
CREATE OR REPLACE FUNCTION TGRCP() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Salvar os dados na tabela de "log" (TL_RCP) antes de excluir
-- 2) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 3) Assumir sempre alguns valores
DECLARE
BEGIN

   -- Gera um codigo automaticamente
   IF (TG_OP = 'INSERT') THEN
      NEW.SEQUEN := ProximoCodigo('TT_RCP',NEW.CODFIL);
   END IF;

   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      -- Evita espacos no codigo de serie
      IF LENGTH(LTRIM(RTRIM(NEW.CODSER))) != 2 THEN
         NEW.CODSER := LTRIM(RTRIM(NEW.CODSER));
      END IF;  

      -- Alinhar a subserie
      NEW.SUBSER := lpad(LTRIM(RTRIM(NEW.SUBSER)),3,' ');   

      -- Evita "brancos" na subserie
      IF ISNULL(LTRIM(RTRIM(NEW.SUBSER)))='T' THEN
         NEW.SUBSER := Null;
      END IF;   
   END IF;  

   -- Grava no "log"
   IF (TG_OP = 'DELETE') THEN
      -- Nota: FILCAN, CODCAN e DATHOR serao preenchidos pela trigger TGLRCP
      --       mas se eles nao forem passados agora, as constraints not null
      --       impedirao de continuar
      INSERT INTO TL_RCP (CODFIL,FILFOR,CODFOR,CODSER,SUBSER,NUMNOT,
                          DATRCP,FILUSU,CODUSU,OBSERV,TIPFOR,FLGEST,
                          FILSUP,CODSUP,FILCAN,CODCAN,DATHOR)
      VALUES (OLD.CODFIL,OLD.FILFOR,OLD.CODFOR,OLD.CODSER,OLD.SUBSER,OLD.NUMNOT,
              OLD.DATRCP,OLD.FILUSU,OLD.CODUSU,OLD.OBSERV,OLD.TIPFOR,OLD.FLGEST,
              OLD.FILSUP,OLD.CODSUP,OLD.FILUSU,OLD.CODUSU,agora());
   ELSE
      -- "Default"
      NEW.ATU_EM := agora();
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4987 --*/
CREATE TRIGGER TGRCP
BEFORE INSERT OR DELETE OR UPDATE ON TT_RCP 
FOR EACH ROW EXECUTE PROCEDURE TGRCP();


/*-- SEQ 4988 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRCT() CASCADE;

/*-- SEQ 4989 --*/
CREATE OR REPLACE FUNCTION TGRCT() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN := ProximoCodigo('TT_RCT',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4990 --*/
CREATE TRIGGER TGRCT
BEFORE INSERT ON TT_RCT 
FOR EACH ROW EXECUTE PROCEDURE TGRCT();


/*-- SEQ 4991 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRCXG() CASCADE;

/*-- SEQ 4992 --*/
CREATE OR REPLACE FUNCTION TGRCXG() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TR_CXG',NEW.FILMAT);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4993 --*/
CREATE TRIGGER TGRCXG
BEFORE INSERT ON TR_CXG 
FOR EACH ROW EXECUTE PROCEDURE TGRCXG();


/*-- SEQ 4994 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRDP() CASCADE;

/*-- SEQ 4995 --*/
CREATE OR REPLACE FUNCTION TGRDP() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar codigo sequencial exclusivo para compor a chave primaria
--
DECLARE

-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF (NEW.CODFIL IS NOT NULL) and (NEW.SEQUEN IS NULL) THEN
       NEW.SEQUEN := ProximoCodigo('TT_RDP',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4996 --*/
CREATE TRIGGER TGRDP
BEFORE INSERT ON TT_RDP 
FOR EACH ROW EXECUTE PROCEDURE TGRDP();


/*-- SEQ 4997 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRDV() CASCADE;

/*-- SEQ 4998 --*/
CREATE OR REPLACE FUNCTION TGRDV() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN := ProximoCodigo('TT_RDV',NEW.CODFIL);
    END IF;
    
    NEW.DATINC := AGORA();
    NEW.ATU_EM := AGORA();
  END IF;
  
  IF (TG_OP = 'UPDATE') THEN 
     NEW.ATU_EM := AGORA();
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 4999 --*/
CREATE TRIGGER TGRDV
BEFORE INSERT OR UPDATE ON TT_RDV 
FOR EACH ROW EXECUTE PROCEDURE TGRDV();

/*-- SEQ 5000 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRDV2() CASCADE;

/*-- SEQ 5001 --*/
CREATE OR REPLACE FUNCTION TGRDV2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 2) Registrar mudanca dos dados num "log"
   vLOG    VARCHAR(4000)     := '';
   vFILUSU VARCHAR(3);    
   vCODUSU VARCHAR(3); 
   cNulo   CONSTANT CHAR(1)   := '0';
   CRLF    CONSTANT CHAR(1)   := CHR(10);  
    
    QuemLogou TRetQuemLogou%ROWTYPE;
    WK_CODUID TT_UID.CODUID%TYPE;
BEGIN
  WK_CODUID := GetCoduidAtual();

  select * into QuemLogou from DadosLogon();
  vFILUSU := QuemLogou.FILUSU;
  vCODUSU := QuemLogou.CODUSU;

  -- Tratamento de "log"
  IF (TG_OP = 'DELETE') THEN
     RAISE EXCEPTION 'PG-20001 Nao e permitida a exclusao da tabela TT_RDV.';     
  END IF;
                      
  -- Tratamento de log
  IF (TG_OP = 'UPDATE') THEN
     IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
        vLOG := vLOG||'Codigo da Filial: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
     END IF;
    IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
        vLOG := vLOG||'Sequenciador: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
     END IF;
    IF Equal(OLD.TIPPED,NEW.TIPPED) <> 1 THEN
        vLOG := vLOG||'Tipo de Pedido: de '||COALESCE(OLD.TIPPED,cNulo)||' para '||COALESCE(NEW.TIPPED,cNulo)||CRLF;
     END IF;
    IF Equal(OLD.NUMPED,NEW.NUMPED) <> 1 THEN
        vLOG := vLOG||'Numero de Pedido: de '||COALESCE(OLD.NUMPED,cNulo)||' para '||COALESCE(NEW.NUMPED,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATINC,NEW.DATINC) <> 1 THEN
        vLOG := vLOG||'Data Inclusao: de '||COALESCE(to_char(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;
    IF Equal(OLD.TIPRDV,NEW.TIPRDV) <> 1 THEN
        vLOG := vLOG||'Tipo de Recebimento: de '||COALESCE(OLD.TIPRDV,cNulo)||' para '||COALESCE(NEW.TIPRDV,cNulo)||CRLF;
     END IF;
    IF Equal(OLD.NUMDOC,NEW.NUMDOC) <> 1 THEN
        vLOG := vLOG||'Numero de Pedido: de '||COALESCE(OLD.NUMDOC,cNulo)||' para '||COALESCE(NEW.NUMDOC,cNulo)||CRLF;      
     END IF;
    IF Equal(OLD.DATVEN,NEW.DATVEN) <> 1 THEN
        vLOG := vLOG||'Data do Vencimento: de '||COALESCE(to_char(OLD.DATVEN,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.DATVEN,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATEMI,NEW.DATEMI) <> 1 THEN
        vLOG := vLOG||'Data e Hora da Emissao: de '||COALESCE(to_char(OLD.DATEMI,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.DATEMI,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.VLRDOC,NEW.VLRDOC) <> 1 THEN
        vLOG := vLOG||'Valor do Documento: de '||COALESCE(OLD.VLRDOC,0)||' para '||COALESCE(NEW.VLRDOC,0)||CRLF;
     END IF;
    IF Equal(OLD.QTDPAR,NEW.QTDPAR) <> 1 THEN
        vLOG := vLOG||'Numero de Parcelas: de '||COALESCE(OLD.QTDPAR,0)||' para '||COALESCE(NEW.QTDPAR,0)||CRLF;
     END IF;
    IF Equal(OLD.VLRJUR,NEW.VLRJUR) <> 1 THEN
        vLOG := vLOG||'Juros: de '||COALESCE(OLD.VLRJUR,0)||' para '||COALESCE(NEW.VLRJUR,0)||CRLF;
     END IF;
    IF Equal(OLD.DATPAG,NEW.DATPAG) <> 1 THEN
        vLOG := vLOG||'Data e Hora do Pagamento: de '||COALESCE(to_char(OLD.DATPAG,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.DATPAG,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;
    IF Equal(OLD.NUMAUT,NEW.NUMAUT) <> 1 THEN
        vLOG := vLOG||'Autorizacao: de '||COALESCE(OLD.NUMAUT,cNulo)||' para '||COALESCE(NEW.NUMAUT,cNulo)||CRLF;
     END IF;
    IF Equal(OLD.NUMCPV,NEW.NUMCPV) <> 1 THEN
        vLOG := vLOG||'Numero do Comprovante de Venda: de '||COALESCE(OLD.NUMCPV,0)||' para '||COALESCE(NEW.NUMCPV,0)||CRLF;
     END IF;
    IF Equal(OLD.NUMCAR,NEW.NUMCAR) <> 1 THEN
        vLOG := vLOG||'Numero do Cartao: de '||COALESCE(OLD.NUMCAR,cNulo)||' para '||COALESCE(NEW.NUMCAR,cNulo)||CRLF;
     END IF;
    IF Equal(OLD.CODNAC,NEW.CODNAC) <> 1 THEN
        vLOG := vLOG||'Codigo da Nacionalidade do Emissor: de '||COALESCE(OLD.CODNAC,cNulo)||' para '||COALESCE(NEW.CODNAC,cNulo)||CRLF;
     END IF;
    IF Equal(OLD.LOGREF,NEW.LOGREF) <> 1 THEN
        vLOG := vLOG||'LogRef: de '||COALESCE(OLD.LOGREF,0)||' para '||COALESCE(NEW.LOGREF,0)||CRLF;
     END IF;
    IF Equal(OLD.BANEMI,NEW.BANEMI) <> 1 THEN
        vLOG := vLOG||'Codigo do Banco Emissor: de '||COALESCE(OLD.BANEMI,0)||' para '||COALESCE(NEW.BANEMI,0)||CRLF;
     END IF;
    IF Equal(OLD.CIDTIT,NEW.CIDTIT) <> 1 THEN
        vLOG := vLOG||'Cidade do Titular: de '||COALESCE(OLD.CIDTIT,cNulo)||' para '||COALESCE(NEW.CIDTIT, cNulo)||CRLF;
     END IF;
    IF Equal(OLD.ENDTIT,NEW.ENDTIT) <> 1 THEN
        vLOG := vLOG||'Endereco do Titular: de '||COALESCE(OLD.ENDTIT,cNulo)||' para '||COALESCE(NEW.ENDTIT,cNulo)||CRLF;
     END IF;
    IF Equal(OLD.CEPTIT,NEW.CEPTIT) <> 1 THEN
        vLOG := vLOG||'CEP do Titular: de '||COALESCE(OLD.CEPTIT,cNulo)||' para '||COALESCE(NEW.CEPTIT,cNulo)||CRLF;
     END IF;
    IF Equal(OLD.ESTTIT,NEW.ESTTIT) <> 1 THEN
        vLOG := vLOG||'Estado do Titular: de '||COALESCE(OLD.ESTTIT,cNulo)||' para '||COALESCE(NEW.ESTTIT,cNulo)||CRLF;
     END IF;
    IF Equal(OLD.NUMTRN,NEW.NUMTRN) <> 1 THEN
        vLOG := vLOG||'Numero da Autenticacao / TID / Numero da Transacao: de '||COALESCE(OLD.NUMTRN,cNulo)||' para '||COALESCE(NEW.NUMTRN,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.ID_TRN,NEW.ID_TRN) <> 1 THEN
        vLOG := vLOG||'Numero Sequencial unico / Codigo de identificacao da Transacao: de '||COALESCE(OLD.ID_TRN,cNulo)||' para '||COALESCE(NEW.ID_TRN,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.EXTCAR,NEW.EXTCAR) <> 1 THEN
        vLOG := vLOG||'Cdigo Externo da Bandeira do Carto: de '||COALESCE(OLD.EXTCAR,cNulo)||' para '||COALESCE(NEW.EXTCAR,cNulo)||CRLF;
     END IF;
    IF Equal(OLD.NOSNUM,NEW.NOSNUM) <> 1 THEN
        vLOG := vLOG||'Nosso nmero: de '||COALESCE(OLD.NOSNUM,cNulo)||' para '||COALESCE(NEW.NOSNUM,cNulo)||CRLF;
     END IF;
    IF Equal(OLD.VLDCAR,NEW.VLDCAR) <> 1 THEN
        vLOG := vLOG||'Ms e Ano de Validade Carto: de '||COALESCE(OLD.VLDCAR,cNulo)||' para '||COALESCE(NEW.VLDCAR,cNulo)||CRLF;
     END IF;

     IF ISNOTNULL(trim(vLOG)) = 'T' THEN
        -- cadastra o LOG.
        INSERT INTO TL_RDV (FILRDV, SEQRDV, FILUSU, CODUSU, MSGLOG, CODUID)
          VALUES(NEW.CODFIL, NEW.SEQUEN, vFILUSU, vCODUSU, vLOG, WK_CODUID);  
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5002 --*/
CREATE TRIGGER TGRDV2
AFTER INSERT OR UPDATE OR DELETE ON TT_RDV 
FOR EACH ROW EXECUTE PROCEDURE TGRDV2();



/*-- SEQ 5003 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGREC2() CASCADE;

/*-- SEQ 5004 --*/
CREATE OR REPLACE FUNCTION TGREC2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Impedir exclusao
-- 2) Impedir alteracao nas colunas que nao se referem ao status
--
  wk_status                  TT_VEN.FLGEST%TYPE;

  wk_filial_usuario          TT_REC.FILUSU%TYPE;
  wk_codigo_usuario          TT_REC.CODUSU%TYPE;

  c_status_aberto            CONSTANT CHAR(1) := 'A';
  c_status_cancelado         CONSTANT CHAR(1) := 'C';
  c_status_pago              CONSTANT CHAR(1) := 'P';
  c_status_estornado         CONSTANT CHAR(1) := 'X';

  vComplemento               CONSTANT VARCHAR(100) := constante('complemento');
  cVEM_DE_TGVEN              CONSTANT VARCHAR(100) := constante('vem_de_tgven');
  vVEM_DE_PCRECCAS   VARCHAR(1) := constante('VEM_DE_PCRECCAS');
  vALT_TITAVU   VARCHAR(1)      := constante('ALT_TITAVU');
  vOLD_VEM_DE_PCRECCAS VARCHAR(1) := constante('OLD_VEM_DE_PCRECCAS');
  vTG_REC_VAZIO        VARCHAR(1) := constante('TG_REC_VAZIO');

  cDUMMY VARCHAR(20);

  Logon  TRetQuemLogou%ROWTYPE;

 
 cInst1 CHAR(1);
 cInst2 CHAR(1);

 cCOB_USA_SAC     TT_CFG.COB_USA_SAC%TYPE;
 iCOB_DIAS_VENCTO TT_CFG.COB_DIAS_VENCTO%TYPE;

 cCODFIL TT_SUP.CODFIL%TYPE;
 cSEQUEN TT_SUP.SEQUEN%TYPE;

 bVerifica boolean;
 bDesconto TT_REC.VLRPAR%TYPE;
 bCARTAO boolean;
 
 cFILECF TD_ECF.FILECF%TYPE;
BEGIN
   IF NOT (TG_OP = 'DELETE')  THEN
      IF (COALESCE(NEW.DUMMY, 'X') <> '%') THEN
         -- "Default"
         IF (TG_OP = 'INSERT') THEN
            IF NEW.DATINC is null THEN
               NEW.DATINC := agora();
            END IF;
         END IF;

         IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
            IF NEW.PORTAD is null THEN
               NEW.PORTAD := 0;
            END IF;
         END IF;

         IF NEW.DUMMY IN (vTG_REC_VAZIO,vOLD_VEM_DE_PCRECCAS) THEN
            NEW.DUMMY:=NULL;
         END IF;

         -- Impede alteracoes
         IF (TG_OP = 'UPDATE') THEN
           IF ((OLD.SEQUEN <> NEW.SEQUEN) OR
              (OLD.CODFIL <> NEW.CODFIL) OR
              (OLD.NUMPAR <> NEW.NUMPAR) OR
              (LTRIM(RTRIM(OLD.SUBPAR)) <> LTRIM(RTRIM(NEW.SUBPAR)))) AND
              (coalesce(NEW.DUMMY,'XX')<>vALT_TITAVU) THEN
              RAISE EXCEPTION 'PG-20028 Dado da parcela de venda nao pode ser modificado. %' , vComplemento;
           END IF;


           -- Verifica se a mudanca do "flag" e permitida
           IF (OLD.NUMECF <> NEW.NUMECF) AND (OLD.FLGEST = NEW.FLGEST) THEN
              -- NAO FAZ NADA
                        ELSE
             IF ((COALESCE(NEW.DUMMY,'NULO') <> 'R') AND (COALESCE(OLD.DUMMY,'NULO') <> 'R')) THEN
                IF (OLD.FLGEST IN (c_status_cancelado,c_status_estornado) ) THEN
                   IF not (COALESCE(NEW.CODFIL,'NULO')          =  COALESCE(OLD.CODFIL,'NULO')
                   AND COALESCE(NEW.SEQUEN,'NULO')          =  COALESCE(OLD.SEQUEN,'NULO')
                   AND COALESCE(NEW.NUMPAR,'NULO')          =  COALESCE(OLD.NUMPAR,'NULO')
                   AND COALESCE(NEW.SUBPAR,'NULO')          =  COALESCE(OLD.SUBPAR,'NULO')
                   AND COALESCE(NEW.FLGEST,'NULO')          =  COALESCE(OLD.FLGEST,'NULO')
                   AND COALESCE(TO_CHAR(NEW.ATU_EM,'dd/mm/yyyy HH24:mi:ss'),'NULO') =  COALESCE(TO_CHAR(OLD.ATU_EM,'dd/mm/yyyy HH24:mi:ss'),'NULO')
                   AND COALESCE(TO_CHAR(NEW.DATVEN,'dd/mm/yyyy HH24:mi:ss'),'NULO') =  COALESCE(TO_CHAR(OLD.DATVEN,'dd/mm/yyyy HH24:mi:ss'),'NULO')
                   AND COALESCE(NEW.VLRPAR,-999999999)      =  COALESCE(OLD.VLRPAR,-999999999)
                   AND COALESCE(NEW.CODMOE,-999999999)      =  COALESCE(OLD.CODMOE,-999999999)
                   AND COALESCE(NEW.PORTAD,-999999999)      =  COALESCE(OLD.PORTAD,-999999999)
                   AND COALESCE(NEW.SIGNAT,-999999999)      =  COALESCE(OLD.SIGNAT,-999999999)
                   AND COALESCE(NEW.SEQCHE,'NULO')          =  COALESCE(OLD.SEQCHE,'NULO')
                   AND COALESCE(NEW.CODUSU,'NULO')          =  COALESCE(OLD.CODUSU,'NULO')
                   AND COALESCE(NEW.FILREC,'NULO')          =  COALESCE(OLD.FILREC,'NULO')
                   AND COALESCE(NEW.FILUSU,'NULO')          =  COALESCE(OLD.FILUSU,'NULO')
                   AND COALESCE(NEW.CUPFIS,'NULO')          =  COALESCE(OLD.CUPFIS,'NULO')
                   AND COALESCE(TO_CHAR(NEW.PAGAME,'dd/mm/yyyy HH24:mi:ss'),'NULO') =  COALESCE(TO_CHAR(OLD.PAGAME,'dd/mm/yyyy HH24:mi:ss'),'NULO')
                   AND COALESCE(NEW.VLRDES,-999999999)      =  COALESCE(OLD.VLRDES,-999999999)
                   AND COALESCE(NEW.VLRPGT,-999999999)      =  COALESCE(OLD.VLRPGT,-999999999)
                   AND COALESCE(NEW.CARTAO,-999999999)      =  COALESCE(OLD.CARTAO,-999999999)
                   AND COALESCE(NEW.DUMMY ,'NULO') =  COALESCE(OLD.DUMMY ,'NULO')
                   AND COALESCE(NEW.TIPCCC,-999999999)      =  COALESCE(OLD.TIPCCC,-999999999))
                   AND (coalesce(NEW.DUMMY,'XX')<>vALT_TITAVU) THEN
                       RAISE EXCEPTION 'PG-20029 Parcela de venda cancelada ou estornada nao pode ser modificada. %' , vComplemento;
                   END IF;
                ELSIF (OLD.FLGEST = c_status_aberto) AND (NEW.FLGEST NOT IN (c_status_aberto,c_status_pago,c_status_cancelado)) AND (COALESCE(NEW.DUMMY,'NULO') <> 'R') THEN
                   RAISE EXCEPTION 'PG-20030 Esta parcela de venda so pode ser paga ou cancelada %' , vComplemento;
                ELSIF (OLD.FLGEST = c_status_pago) AND (NEW.FLGEST NOT IN (c_status_pago,c_status_estornado)) AND (COALESCE(NEW.DUMMY,'NULO') <> 'R') THEN
                   RAISE EXCEPTION 'PG-20031 Parcelas de venda pagas so podem ser estornadas %' , vComplemento;
                -- davi - 47785 - 21/09/06 - FINANC
                ELSIF (coalesce(NEW.DUMMY,'XX')<>vALT_TITAVU) AND
                      (OLD.FLGEST = c_status_Pago) AND
                     (NEW.FLGEST in (c_status_pago,c_status_estornado)) AND
                      ((COALESCE(NEW.VLRPGT,-999999999) <>  COALESCE(OLD.VLRPGT,-999999999)) OR
                       (COALESCE(NEW.VLRPAR,-999999999) <>  COALESCE(OLD.VLRPAR,-999999999)) OR
                     (COALESCE(NEW.VLRPRE,-999999999) <>  COALESCE(OLD.VLRPRE,-999999999)) OR
                       (COALESCE(TO_CHAR(NEW.PAGAME,'dd/mm/yyyy HH24:mi:ss'),'NULO') <>  COALESCE(TO_CHAR(OLD.PAGAME,'dd/mm/yyyy HH24:mi:ss'),'NULO')) OR
                       (COALESCE(TO_CHAR(NEW.DATPRE,'dd/mm/yyyy HH24:mi:ss'),'NULO') <>  COALESCE(TO_CHAR(OLD.DATPRE,'dd/mm/yyyy HH24:mi:ss'),'NULO')) OR
                       (COALESCE(TO_CHAR(NEW.DATVEN,'dd/mm/yyyy HH24:mi:ss'),'NULO') <>  COALESCE(TO_CHAR(OLD.DATVEN,'dd/mm/yyyy HH24:mi:ss'),'NULO'))) THEN
                   RAISE EXCEPTION 'PG-20041 Parcela de venda paga nao pode ser modificada. %' , vComplemento;
                END IF;
             END IF;
             -- Ajuste por conta do Checkout
             IF (OLD.FLGEST = c_status_aberto) AND (NEW.FLGEST = c_status_cancelado) AND (NEW.SEQCHE IS NOT NULL) THEN
                NEW.FLGEST := c_status_estornado;
             END IF;
           END IF;

           -- Impede mudancas em determinadas colunas quando nao for pagamento
           IF ((OLD.FLGEST <> c_status_Aberto) AND (NEW.FLGEST <> c_status_pago)) OR
              ((OLD.FLGEST = c_status_Pago   ) AND (NEW.FLGEST = c_status_pago )) THEN

              IF ((OLD.CUPFIS <> NEW.CUPFIS) OR
                 (OLD.FILREC <> NEW.FILREC)  OR
                 (OLD.PAGAME <> NEW.PAGAME)  OR
                 --(OLD.VLRDES <> NEW.VLRDES) OR -- 001/ 39072
                 (OLD.VLRPGT <> NEW.VLRPGT)) AND
                 (coalesce(NEW.DUMMY,'XX')<>vALT_TITAVU) THEN
                 RAISE EXCEPTION 'PG-20032 Dados so podem ser modificados se a parcela de venda for paga. %' , vComplemento;
              END IF;

           ELSE
              -- Verificacoes quanto a data de pagamento
              IF (NEW.FLGEST = c_status_Pago) AND (NEW.PAGAME is null) THEN
                 RAISE EXCEPTION 'PG-20035 Data de pagamento nao foi informada. %' , vComplemento;
              END IF;
           END IF;

           IF (NEW.FLGEST = c_status_Pago) THEN
              IF (NEW.PAGAME is null) THEN
                  RAISE EXCEPTION 'PG-20035 Data de pagamento nao foi informada. %' , vComplemento;
              END IF;

              IF (NEW.FILREC is null) THEN
                  RAISE EXCEPTION 'PG-20040 Filial de recebimento nao foi informada. %' , vComplemento;
              END IF;
           END IF;

         END IF;

         --Se recebido em CARTAO ou CHEQUE e no informada a data, assume agora();

         --Se FLGEST passa a ser X ou C e no era, e se NEW.PAGAME for nulo, assumir data atual
         IF (NEW.FLGEST IN (c_status_estornado,c_status_cancelado)) AND
            (NEW.PAGAME is null) THEN
            IF (TG_OP = 'INSERT') THEN
               NEW.PAGAME := agora();
            ELSIF (Equal(NEW.FLGEST,OLD.FLGEST) = 0) THEN -- Alterado por causa do old no postgreSQL
               NEW.PAGAME := agora();
            END IF;
         END IF;

         bCARTAO:=FALSE;
         IF (TG_OP = 'INSERT') AND (NEW.CARTAO IS NOT NULL OR NEW.SEQCHE IS NOT NULL) THEN
            bCARTAO:=TRUE;
         END IF;

         IF (TG_OP = 'UPDATE') THEN
            IF (NEW.CARTAO IS NOT NULL AND OLD.CARTAO IS NULL) OR
               (NEW.SEQCHE IS NOT NULL AND OLD.SEQCHE IS NULL) THEN
               bCARTAO:=TRUE;
            END IF;
         END IF;

         IF bCARTAO THEN
            NEW.FLGEST := 'P';
            NEW.VLRPGT := CASE WHEN NEW.VLRPGT = 0 THEN NEW.VLRPAR - COALESCE(NEW.VLRTAX,0)
                                                     ELSE NEW.VLRPGT
                           END;
            IF NEW.NUMECF IS NULL THEN
               SELECT NUMECF INTO NEW.NUMECF
                 FROM TT_VEN
                WHERE CODFIL=NEW.CODFIL
                  AND SEQUEN=NEW.SEQUEN;
            END IF;

                         cFILECF := COALESCE(NEW.FILREC,NEW.CODFIL);
              SELECT PORECF INTO NEW.PORTAD
                FROM TD_ECF
               WHERE FILECF = cFILECF
                 AND NUMECF = NEW.NUMECF;
           
         END IF;

         IF ((NEW.CARTAO IS NOT NULL) OR (NEW.SEQCHE IS NOT NULL)) AND (NEW.PAGAME IS NULL) THEN
            NEW.PAGAME := agora();
         END IF;

         IF (NEW.SEQCHE IS NOT NULL) /*AND (bCHEQUE_PAGA_PARCELA = 'T') */ AND (NEW.FLGEST = 'A') THEN
            NEW.FLGEST := 'P';
         END IF;

         -- Dispensa restante do teste se a atualizacao tiver sido solicitada pela trigger TGVEN
         IF (NEW.DUMMY IS NULL) THEN
          -- Traz o "status" atual da venda
          SELECT FLGEST
            INTO wk_status
            FROM TT_VEN
           WHERE CODFIL = NEW.CODFIL
             AND SEQUEN = NEW.SEQUEN
                    
             FOR UPDATE;
          
            IF (wk_status = c_status_Cancelado) AND (NEW.FLGEST NOT IN (c_status_Cancelado,c_status_Estornado)) THEN
               RAISE EXCEPTION 'PG-20038 Venda cancelada so permite parcelas canceladas ou estornadas. %' , vComplemento;
            END IF;
         END IF;

         -- Havendo cheque a moeda precisa ser a corrente
         IF (NEW.CODMOE <> 0) AND (NEW.SEQCHE IS NOT NULL) THEN
            RAISE EXCEPTION 'PG-20033 Para associar uma parcela de venda a um cheque e preciso que a moeda seja a corrente do pais. %' , vComplemento;
         END IF;

         -- Faz o papel da "foreign key" verificando se o cheque existe
         IF (TG_OP = 'UPDATE') THEN
            IF (OLD.SEQCHE = NEW.SEQCHE) THEN
               IF (NEW.SEQCHE IS NOT NULL) THEN
                  IF (OLD.DATVEN <> NEW.DATVEN) OR
                     (OLD.VLRPAR <> NEW.VLRPAR) THEN
                     RAISE EXCEPTION 'PG-20034 Dados so podem ser modificados se a parcela de venda nao estiver associada a um cheque. %' , vComplemento;
                  END IF;
               END IF;
            END IF;
         END IF;

         -- "Default"
         IF (TG_OP = 'INSERT') THEN
            NEW.ATU_EM := agora();
            NEW.DATFIS := TRUNC(COALESCE(NEW.DATFIS,NEW.PAGAME));
         END IF;
         IF (TG_OP = 'UPDATE') THEN
            IF NEW.ATU_EM=OLD.ATU_EM THEN
               NEW.ATU_EM := agora();
            END IF;

            IF NEW.DATINC is null THEN
               NEW.DATINC := agora();
            END IF;

            IF (NEW.VLRPGT = 0) AND (NEW.FLGEST = 'A') THEN
               NEW.VLRPGT := NULL;
            END IF;

            IF NEW.DATINC <> OLD.DATINC THEN
               RAISE EXCEPTION 'PG-20041 Data da inclusao nao pode ser modificado. %' , vComplemento;
            END IF;

            IF (NEW.PAGAME is not null and NEW.DATFIS is null) THEN
               NEW.DATFIS := TRUNC(NEW.PAGAME); -- PTulio - davi - 27/04/05 - 33733
            END IF;

            -- davi - 41398 - 10/01/06 - preecher nova coluna VLRTAX
            IF (NEW.CARTAO IS NOT NULL) AND (OLD.CARTAO IS NULL) AND (NEW.VLRTAX IS NULL) THEN
               NEW.VLRTAX := NEW.VLRDES;
               NEW.VLRDES := NULL;
            END IF;
         END IF;

         NEW.DATVEN := Trunc(NEW.DATVEN);
         NEW.SUBPAR := LPAD( COALESCE(LTRIM(RTRIM(NEW.SUBPAR)),'0'),2,' ');

         
         -- Descobre o codigo do usuario
         IF (NEW.FLGEST <> c_status_aberto)
         AND (NEW.FILUSU IS NULL OR NEW.CODUSU IS NULL) THEN
            -- Checa quem logou
            -- Dados do usuario
            select * into Logon from DadosLogon();
            IF Logon.Encontrou THEN
               NEW.FILUSU := Logon.FILUSU;
               NEW.CODUSU := Logon.CODUSU;
            ELSE
               RAISE EXCEPTION 'PG-20040 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
            END IF;
         END IF;

         --Tratamento para retirar da cobranca
         IF (TG_OP = 'UPDATE') THEN
            IF (OLD.FLGEST <> c_status_pago) AND (NEW.FLGEST = c_status_pago) THEN
               SELECT COB_USA_SAC,COB_DIAS_VENCTO INTO cCOB_USA_SAC,iCOB_DIAS_VENCTO
                 FROM TT_CFG;
               IF (cCOB_USA_SAC= 'T') AND ((TRUNC(NEW.PAGAME)-TRUNC(NEW.DATVEN))>iCOB_DIAS_VENCTO) THEN
                                    
                  cDUMMY := PC_REC_CASCADE_DATA(new.CODFIL,new.SEQUEN,'RR',NULL,AGORA(),'S');
                                 END IF;
            END IF;
         END IF;

         IF (TG_OP = 'UPDATE') THEN
                           -- So Gera uma nova parcela se alterar valor
               IF (NEW.FLGEST not in (c_status_estornado))   --54448  ->tirado em 52806(,c_status_pago)
               AND (NEW.VLRPAR != OLD.VLRPAR)
               AND (coalesce(NEW.DUMMY,'XX')<>vVEM_DE_PCRECCAS)
               AND (coalesce(NEW.DUMMY,'XX')<>vALT_TITAVU) THEN

                  bDesconto:= (NEW.VLRPAR - OLD.VLRPAR);

                  
                  
                  cDUMMY := PC_REC_AUX_UPDATE(new.CODFIL,new.SEQUEN,new.NUMPAR,
                                              new.SUBPAR,new.FLGEST,new.PAGAME,
                                              new.DATVEN,new.CUPFIS,new.VLRPGT,
                                              new.VLRPAR,new.FILUSU,new.CODUSU,
                                              new.PORTAD,new.CODMOE,new.SIGNAT,
                                              new.VLRDES,new.NUMECF,new.FILREC,
                                              new.SEQCHE,new.CARTAO,new.TIPCCC,
                                              new.DATFIS,old.SUBPAR,old.PORTAD,
                                              new.FILCTA,new.SEQCTA,new.TIPCTA);

                  NEW.SUBPAR := OLD.SUBPAR;
                  NEW.FLGEST := 'C';
                  NEW.PAGAME := agora();
                  NEW.DATVEN := OLD.DATVEN;
                  NEW.CUPFIS := OLD.CUPFIS;
                  NEW.VLRPGT := OLD.VLRPGT;
                  NEW.VLRPAR := OLD.VLRPAR;
                  NEW.FILUSU := OLD.FILUSU;
                  NEW.CODUSU := OLD.CODUSU;
                  NEW.PORTAD := OLD.PORTAD;
                  NEW.CODMOE := OLD.CODMOE;
                  NEW.SIGNAT := OLD.SIGNAT;
                  NEW.VLRDES := bDesconto;
                  NEW.NUMECF := OLD.NUMECF;
                  NEW.DATFIS := trunc(agora());
                  NEW.FILREC := OLD.FILREC;
                  NEW.SEQCHE := OLD.SEQCHE;
                  NEW.CARTAO := OLD.CARTAO;
                  NEW.TIPCCC := OLD.TIPCCC;
                  NEW.FILCTA := OLD.FILCTA;
                  NEW.SEQCTA := OLD.SEQCTA;
                  NEW.TIPCTA := OLD.TIPCTA;
                  
                  
               END IF;

                     END IF;
         -- Fim tratamento estorno

         IF NEW.DUMMY IS NOT NULL THEN
            IF NEW.DUMMY not in (vVEM_DE_PCRECCAS,cVEM_DE_TGVEN) THEN

               IF NEW.DUMMY not in (CONSTANTE('vem_de_tgrtb')) THEN            --56100
                  NEW.DUMMY:= vTG_REC_VAZIO;
               END IF;

            ELSE
               NEW.DUMMY:=vOLD_VEM_DE_PCRECCAS;
            END IF;
         END IF;

         -- P4.1F 38603
         bVerifica :=FALSE;
         IF (TG_OP = 'INSERT') THEN
            bVerifica:=TRUE;
         ELSIF (Equal(NEW.FLGEST,OLD.FLGEST) = 0) THEN
            bVerifica:=TRUE;
         END IF;

         IF bVerifica THEN
            IF NEW.FLGEST = 'C' THEN
               NEW.ESTCAN := COALESCE(NEW.ESTCAN,NEW.PAGAME,AGORA());
               IF (TG_OP = 'INSERT') THEN
                  NEW.PAGAME := NULL;
               ELSIF (Equal(NEW.PAGAME,OLD.PAGAME) = 0) THEN
                  NEW.PAGAME := OLD.PAGAME;
               END IF;
            END IF;

            IF NEW.FLGEST = 'X' THEN
               NEW.ESTCAN := COALESCE(NEW.ESTCAN,AGORA());
            END IF;
         END IF;

         -- DN 45679 - Tabelas Financeiras
         IF (TG_OP = 'INSERT') THEN
            cDUMMY:=INSERE_LFIN_LAN('REC',NEW.CODFIL,NEW.SEQUEN,NEW.NUMPAR,NEW.SUBPAR);
         END IF;
         IF (TG_OP = 'UPDATE') THEN
            IF (Equal(OLD.VLRPAR,NEW.VLRPAR) <> 1) OR
               (Equal(OLD.DATINC,NEW.DATINC) <> 1) OR
               (Equal(OLD.RENORI,NEW.RENORI) <> 1) OR
               (Equal(OLD.PAGAME,NEW.PAGAME) <> 1) OR
               (Equal(OLD.SEQCHE,NEW.SEQCHE) <> 1) OR
               (Equal(OLD.CARTAO,NEW.CARTAO) <> 1) OR
               (Equal(OLD.FLGEST,NEW.FLGEST) <> 1) OR
               (Equal(OLD.VLRTAX,NEW.VLRTAX) <> 1) OR
               (Equal(OLD.VLRPGT,NEW.VLRPGT) <> 1) OR
               (Equal(OLD.VLRDES,NEW.VLRDES) <> 1) OR
               (Equal(OLD.DATVEN,NEW.DATVEN) <> 1) OR
               (Equal(OLD.DATFIS,NEW.DATFIS) <> 1) OR
               (Equal(OLD.PORTAD,NEW.PORTAD) <> 1) OR
               (Equal(OLD.FILCTA,NEW.FILCTA) <> 1) OR
               (Equal(OLD.SEQCTA,NEW.SEQCTA) <> 1) OR
               (Equal(OLD.TIPCTA,NEW.TIPCTA) <> 1) THEN
               cDUMMY:=INSERE_LFIN_LAN('REC',NEW.CODFIL,NEW.SEQUEN,NEW.NUMPAR,NEW.SUBPAR);
            END IF;
         END IF;
         -- DN 45679 - Fim Tabelas Financeiras

         -- DN 54512 - Reestruturao de Titulos
         IF (TG_OP = 'INSERT') THEN
            IF TGR_GeraTitulo(NEW.PORTAD) THEN
               cDUMMY:=INSERE_MTIT(NEW.CODFIL,NEW.SEQUEN,NEW.NUMPAR,NEW.FLGEST);
            END IF;
         END IF;
         IF (TG_OP = 'UPDATE') THEN
            -- Rhuan - 101038 - Se mudou o portador, limpar o NOSNUM para gerar um novo.
            IF Equal(OLD.PORTAD,NEW.PORTAD) <> 1 THEN
              NEW.NOSNUM := NULL;
            END IF;

            IF ((Equal(OLD.VLRPAR,NEW.VLRPAR) <> 1) OR
                (Equal(OLD.RENORI,NEW.RENORI) <> 1) OR
                (Equal(OLD.FLGEST,NEW.FLGEST) <> 1) OR
                (Equal(OLD.DATVEN,NEW.DATVEN) <> 1) OR
                (Equal(OLD.PORTAD,NEW.PORTAD) <> 1)) AND
               (TGR_GeraTitulo(OLD.PORTAD) or TGR_GeraTitulo(NEW.PORTAD)) THEN
               cDUMMY:=INSERE_MTIT(OLD.CODFIL,OLD.SEQUEN,OLD.NUMPAR,OLD.FLGEST);
            END IF;
         END IF;
         -- DN 54512 - Fim Reestruturao de Titulos
			
			-- Incio Controle do Indicador de Exportao
			IF (COALESCE(NEW.INDEXP, 'X') = 'I') THEN
			  NEW.INDEXP := 'N';
			ELSE 
			  NEW.INDEXP := 'E';
			END IF;
			-- Fim Controle do Indicador de Exportao
			
      ELSE
         NEW.DUMMY := NULL;
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5005 --*/
CREATE TRIGGER TGREC2
BEFORE INSERT OR DELETE OR UPDATE ON TT_REC 
FOR EACH ROW EXECUTE PROCEDURE TGREC2();


/*-- SEQ 5006 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGREC3() CASCADE;

/*-- SEQ 5007 --*/
CREATE OR REPLACE FUNCTION TGREC3() RETURNS TRIGGER AS $$
DECLARE

 
   cInst1                        CHAR(1);
   cInst2                        CHAR(1);

   c_status_aberto               CONSTANT CHAR(1) := 'A';
   c_status_cancelado            CONSTANT CHAR(1) := 'C';
   c_status_pago                 CONSTANT CHAR(1) := 'P';
   c_status_estornado            CONSTANT CHAR(1) := 'X';

   cDUMMY                        CHAR(1);

   cVEM_DE_TGVEN                 CONSTANT VARCHAR(100) := constante('vem_de_tgven');
   vVEM_DE_PCRECCAS              VARCHAR(1) := constante('VEM_DE_PCRECCAS');
   vOLD_VEM_DE_PCRECCAS          VARCHAR(1) := constante('OLD_VEM_DE_PCRECCAS');
   vTG_REC_VAZIO                 VARCHAR(1) := constante('TG_REC_VAZIO');

   bMudou                        BOOLEAN;

   bNOVO_TIT_PAG_AJ_PARC         VARCHAR(1);

   WK_FILCLI                     TT_VEN.FILCLI%TYPE;
   WK_CODCLI                     TT_VEN.CODCLI%TYPE;
   WK_MAIATR                     TT_CLI.MAIATR%TYPE;
   WK_ATRASO                     TT_CLI.MAIATR%TYPE;

   vVEM_DE_TGVEN                 VARCHAR(1) := constante('VEM_DE_TGVEN');

   WK_VC_FILCLI                  TT_VEN.FILCLI%TYPE;
   WK_VC_CODCLI                  TT_VEN.CODCLI%TYPE;

   /* variveis de log - incio */
      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
      vLOG                          VARCHAR(4000)     := '';
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   vREC                          CHAR(20)           := '';
   wk_coduid                     tt_uid.coduid%type;
   
   --Bruno Berticelli
   cOld                          VARCHAR(50); -- colocar Descrio no lugar dos codtab
   cNew                          VARCHAR(50);   
   /* variveis de log - fim */
BEGIN

  IF NEW.DUMMY IS NULL THEN
     SELECT FILCLI, CODCLI
       INTO WK_FILCLI, WK_CODCLI
       FROM TT_VEN
      WHERE CODFIL = NEW.CODFIL
        AND SEQUEN = NEW.SEQUEN;

     SELECT VC_FILCLI, VC_CODCLI INTO WK_VC_FILCLI, WK_VC_CODCLI
       FROM TT_CFG;

     IF (WK_FILCLI||WK_CODCLI) <> (WK_VC_FILCLI||WK_VC_CODCLI) THEN
        SELECT COALESCE(MAIATR,0)
          INTO WK_MAIATR
          FROM TT_CLI
         WHERE FILCLI = WK_FILCLI
           AND CODCLI = WK_CODCLI;

        IF COALESCE(TRUNC(NEW.PAGAME) - TRUNC(NEW.DATVEN),0)<99999 THEN
            IF (TG_OP = 'INSERT') THEN
               WK_ATRASO := COALESCE(TRUNC(NEW.PAGAME) - TRUNC(NEW.DATVEN),0);
            ELSE
               WK_ATRASO := COALESCE(TRUNC(NEW.PAGAME) - TRUNC(OLD.DATVEN),0);
            END IF;
        ELSE
            WK_ATRASO := 0;
        END IF;

        IF WK_ATRASO > WK_MAIATR THEN
           WK_MAIATR := WK_ATRASO;
        END IF;

        IF (TG_OP = 'INSERT') THEN

          UPDATE TT_CLI SET TOTPAR = COALESCE(TOTPAR,0) + 1,
                            MAIATR = WK_MAIATR
           WHERE FILCLI = WK_FILCLI
             AND CODCLI = WK_CODCLI;

        END IF;

        IF (TG_OP = 'UPDATE') THEN
          IF (Equal(OLD.FLGEST,NEW.FLGEST) = 0) THEN
             IF (NEW.FLGEST = 'X') THEN
               UPDATE TT_CLI SET TOTPAR = COALESCE(TOTPAR,0) - 1,
                                 TOTATR = COALESCE(TOTATR,0) - CASE WHEN OLD.PAGAME IS NOT NULL AND OLD.DATVEN IS NOT NULL
                                                                    THEN (TRUNC(OLD.PAGAME) - TRUNC(OLD.DATVEN))
                                                                    ELSE 0
                                                               END,
                                 MAIATR = WK_MAIATR
                WHERE FILCLI = WK_FILCLI
                  AND CODCLI = WK_CODCLI;

             END IF;

             IF (NEW.FLGEST = 'C') THEN
               UPDATE TT_CLI SET TOTPAR = COALESCE(TOTPAR,0) - 1,
                                 TOTATR = COALESCE(TOTATR,0) - CASE WHEN OLD.PAGAME IS NOT NULL AND OLD.DATVEN IS NOT NULL
                                                                    THEN (TRUNC(OLD.PAGAME) - TRUNC(OLD.DATVEN))
                                                                    ELSE 0
                                                               END
                WHERE FILCLI = WK_FILCLI
                  AND CODCLI = WK_CODCLI;

             END IF;


             IF (NEW.FLGEST = 'P') THEN
               UPDATE TT_CLI SET TOTATR = COALESCE(TOTATR,0) + (TRUNC(NEW.PAGAME) - TRUNC(OLD.DATVEN)),
                                 MAIATR = WK_MAIATR
                WHERE FILCLI = WK_FILCLI
                  AND CODCLI = WK_CODCLI;
             END IF;
          END IF;
        END IF;
     END IF;
  END IF;

  
  IF (TG_OP = 'UPDATE') THEN
     IF (NEW.DUMMY IS NULL) OR (NEW.DUMMY not in (vOLD_VEM_DE_PCRECCAS)) THEN
             cDUMMY := PC_REC_CASCADE_DATA(new.CODFIL,new.SEQUEN,new.NUMPAR,new.SUBPAR,new.ATU_EM,new.DUMMY);
     END IF;
  END IF;

/* DN - No faz sentido
  IF (TG_OP = 'INSERT') THEN
    UPDATE TT_REC SET DATVEN = NEW.DATVEN
     WHERE CODFIL = NEW.CODFIL
       AND SEQUEN = NEW.SEQUEN
       AND NUMPAR = NEW.NUMPAR
       AND SUBPAR = NEW.SUBPAR;
  END IF;
*/
  
  bMudou := False;
  IF (TG_OP = 'UPDATE') THEN
     IF OLD.FLGEST != NEW.FLGEST THEN
        bMudou := True;
     END IF;
  END IF;

  -- Rhuan - 104010
  bNOVO_TIT_PAG_AJ_PARC := LeParametroBoo('NOVO_TIT_PAG_AJ_PARC', NEW.CODFIL, NULL, NULL, NULL);

  IF ((TG_OP = 'INSERT') OR (bMudou AND (bNOVO_TIT_PAG_AJ_PARC = 'T'))) AND
     ((NEW.FLGEST = c_status_Aberto) or (NEW.FLGEST = c_status_Pago)) THEN

        
     cDUMMY := PC_REC_UPDATE(new.CODFIL,new.SEQUEN,new.DUMMY);   --56100
      END IF;

  -- rfmp 67319
  IF (TG_OP = 'UPDATE') THEN
     IF (Equal(OLD.CARTAO,NEW.CARTAO) = 0) THEN
        vLOG := vLOG||'Carto: de '||COALESCE(OLD.CARTAO,iNulo)||' para '||COALESCE(NEW.CARTAO,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.CODEXT,NEW.CODEXT) = 0) THEN
        vLOG := vLOG||'Cdigo Alternativo: de '||COALESCE(OLD.CODEXT,cNulo)||' para '||COALESCE(NEW.CODEXT,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.CODMOE,NEW.CODMOE) = 0) THEN
        vLOG := vLOG||'Moeda: de '||COALESCE(OLD.CODMOE,iNulo)||' para '||COALESCE(NEW.CODMOE,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.CODOUT,NEW.CODOUT) = 0) THEN
        vLOG := vLOG||'Outros Meios Pag.: de '||COALESCE(OLD.CODOUT,iNulo)||' para '||COALESCE(NEW.CODOUT,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.CUPFIS,NEW.CUPFIS) = 0) THEN
        vLOG := vLOG||'Cupom Fiscal: de '||COALESCE(OLD.CUPFIS,cNulo)||' para '||COALESCE(NEW.CUPFIS,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.DATFIS,NEW.DATFIS) = 0) THEN
        vLOG := vLOG||'Data Fiscal: de '||COALESCE(TO_CHAR(OLD.DATFIS,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATFIS,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.DATINC,NEW.DATINC) = 0) THEN
        vLOG := vLOG||'Data Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.DATPRE,NEW.DATPRE) = 0) THEN
        vLOG := vLOG||'Data Prevista: de '||COALESCE(TO_CHAR(OLD.DATPRE,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATPRE,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.DATVEN,NEW.DATVEN) = 0) THEN
        vLOG := vLOG||'Vencimento: de '||COALESCE(TO_CHAR(OLD.DATVEN,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATVEN,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.ESTCAN,NEW.ESTCAN) = 0) THEN
        vLOG := vLOG||'Data Cancela/Estorno: de '||COALESCE(TO_CHAR(OLD.ESTCAN,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ESTCAN,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.FILCTA||OLD.SEQCTA||OLD.TIPCTA,NEW.FILCTA||NEW.SEQCTA||NEW.TIPCTA) = 0) THEN
        vLOG := vLOG||'Conta: de '||COALESCE(OLD.FILCTA||OLD.SEQCTA||OLD.TIPCTA,cNulo)||' para '||COALESCE(NEW.FILCTA||NEW.SEQCTA||NEW.TIPCTA,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.FILREC,NEW.FILREC) = 0) THEN
        vLOG := vLOG||'Filial Recebimento: de '||COALESCE(OLD.FILREC,cNulo)||' para '||COALESCE(NEW.FILREC,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.FILUSU||OLD.CODUSU,NEW.FILUSU||NEW.CODUSU) = 0) THEN
        vLOG := vLOG||'Usurio: de '||COALESCE(OLD.FILUSU||OLD.CODUSU,cNulo)||' para '||COALESCE(NEW.FILUSU||NEW.CODUSU,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.FLGEST,NEW.FLGEST) = 0) THEN
        vLOG := vLOG||'Situao: de '||COALESCE(OLD.FLGEST,cNulo)||' para '||COALESCE(NEW.FLGEST,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.FLGFLU,NEW.FLGFLU) = 0) THEN
        vLOG := vLOG||'Fluxo: de '||COALESCE(OLD.FLGFLU,cNulo)||' para '||COALESCE(NEW.FLGFLU,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.NUMECF,NEW.NUMECF) = 0) THEN
        vLOG := vLOG||'ECF: de '||COALESCE(OLD.NUMECF,cNulo)||' para '||COALESCE(NEW.NUMECF,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.ORIREC,NEW.ORIREC) = 0) THEN
        vLOG := vLOG||'Rec Origem: de '||COALESCE(OLD.ORIREC,cNulo)||' para '||COALESCE(NEW.ORIREC,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.PAGAME,NEW.PAGAME) = 0) THEN
        vLOG := vLOG||'Data Pgto: de '||COALESCE(TO_CHAR(OLD.PAGAME,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PAGAME,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.PORTAD,NEW.PORTAD) = 0) THEN
        vLOG := vLOG||'Portador: de '||COALESCE(OLD.PORTAD,iNulo)||' para '||COALESCE(NEW.PORTAD,iNulo)||CRLF;
        IF TGR_GeraTitulo(OLD.PORTAD) <> TGR_GeraTitulo(NEW.PORTAD) THEN
           vLOG := vLOG||'Gera Ttulo?: de '||CASE WHEN TGR_GeraTitulo(OLD.PORTAD) THEN 'T' ELSE 'F' END||' para '||CASE WHEN TGR_GeraTitulo(NEW.PORTAD) THEN 'T' ELSE 'F' END||CRLF;
        END IF;
     END IF;
     IF (Equal(OLD.PROCES,NEW.PROCES) = 0) THEN
        vLOG := vLOG||'Processados: de '||COALESCE(OLD.PROCES,iNulo)||' para '||COALESCE(NEW.PROCES,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.RENEGO,NEW.RENEGO) = 0) THEN
        vLOG := vLOG||'Renegociao: de '||COALESCE(OLD.RENEGO,iNulo)||' para '||COALESCE(NEW.RENEGO,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.RENORI,NEW.RENORI) = 0) THEN
        vLOG := vLOG||'Origem Renegociao: de '||COALESCE(OLD.RENORI,iNulo)||' para '||COALESCE(NEW.RENORI,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.SEQCHE,NEW.SEQCHE) = 0) THEN
        vLOG := vLOG||'Chave Cheque: de '||COALESCE(OLD.SEQCHE,cNulo)||' para '||COALESCE(NEW.SEQCHE,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.SUBORI,NEW.SUBORI) = 0) THEN
        vLOG := vLOG||'Sub-Parcela de Origem: de '||COALESCE(OLD.SUBORI,cNulo)||' para '||COALESCE(NEW.SUBORI,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.TIPCCC,NEW.TIPCCC) = 0) THEN
        vLOG := vLOG||'Tipo Conta Corrente: de '||COALESCE(TO_CHAR(OLD.TIPCCC),cNulo)||' para '||COALESCE(TO_CHAR(NEW.TIPCCC),cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.VLRDES,NEW.VLRDES) = 0) THEN
        vLOG := vLOG||'Vlr. Desconto: de '||COALESCE(OLD.VLRDES,iNulo)||' para '||COALESCE(NEW.VLRDES,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.VLRPAR,NEW.VLRPAR) = 0) THEN
        vLOG := vLOG||'Vlr. Parcela: de '||COALESCE(OLD.VLRPAR,iNulo)||' para '||COALESCE(NEW.VLRPAR,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.VLRPGT,NEW.VLRPGT) = 0) THEN
        vLOG := vLOG||'Vlr. Pago: de '||COALESCE(OLD.VLRPGT,iNulo)||' para '||COALESCE(NEW.VLRPGT,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.VLRPRE,NEW.VLRPRE) = 0) THEN
        vLOG := vLOG||'Valor Previsto: de '||COALESCE(OLD.VLRPRE,iNulo)||' para '||COALESCE(NEW.VLRPRE,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.VLRTAX,NEW.VLRTAX) = 0) THEN
        vLOG := vLOG||'Vlr. Taxas: de '||COALESCE(OLD.VLRTAX,iNulo)||' para '||COALESCE(NEW.VLRTAX,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.AVISTA,NEW.AVISTA) = 0) THEN
        vLOG := vLOG||'Parcela Paga  Vista?: de '||COALESCE(OLD.AVISTA,CNulo)||' para '||COALESCE(NEW.AVISTA,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.FILPGT||OLD.CODPGT,NEW.FILPGT||NEW.CODPGT) = 0) THEN
        vLOG := vLOG||'Plano de Pagamento: de '||COALESCE(OLD.FILPGT||OLD.CODPGT,cNulo)||' para '||COALESCE(NEW.FILPGT||NEW.CODPGT,cNulo)||CRLF;
     END IF;
      IF (Equal(OLD.EXPORT,NEW.EXPORT) <> 1) THEN
         SELECT CASE OLD.EXPORT WHEN 'T' THEN 'Sim'
                                 WHEN 'F' THEN 'No'
                                 ELSE cNulo
         END INTO cOld FROM DUAL;
         SELECT CASE NEW.EXPORT WHEN 'T' THEN 'Sim'
                                 WHEN 'F' THEN 'No'
                                 ELSE cNulo
         END INTO cNew FROM DUAL;
         vLOG := vLOG||'Exportado?: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRMULTA,NEW.VLRMULTA) <> 1 THEN
         vLOG := vLOG||'Valor de multa por atrazo no pagamento: de '||COALESCE(TO_CHAR(OLD.VLRMULTA,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRMULTA,'fm9G999G999G990D00'), cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRJUROS,NEW.VLRJUROS) <> 1 THEN
         vLOG := vLOG||'Valor de Juros por atrazo no pagamento: de '||COALESCE(TO_CHAR(OLD.VLRJUROS,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRJUROS,'fm9G999G999G990D00'), cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRDESPAG,NEW.VLRDESPAG) <> 1 THEN
         vLOG := vLOG||'Valor de desconto no pagamento: de '||COALESCE(TO_CHAR(OLD.VLRDESPAG,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRDESPAG,'fm9G999G999G990D00'), cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRACRES,NEW.VLRACRES) <> 1 THEN
         vLOG := vLOG||'Valor de acrscimo no pagamento: de '||COALESCE(TO_CHAR(OLD.VLRACRES,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRACRES,'fm9G999G999G990D00'), cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRABATIMENTO,NEW.VLRABATIMENTO) <> 1 THEN
         vLOG := vLOG||'Valor de abatimento no pagamento: de '||COALESCE(TO_CHAR(OLD.VLRABATIMENTO,'fm9G999G999G990D00'), cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRABATIMENTO,'fm9G999G999G990D00'), cNulo)||CRLF;
      END IF;
   END IF;
  IF (TG_OP = 'INSERT') THEN
     vLOG := 'Includa';
  END IF;
  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     IF ISNOTNULL(vLOG) = 'T' THEN
        WK_CODUID := GetCoduidAtual();
        vREC := NEW.CODFIL||'-'||NEW.SEQUEN||'-'||NEW.NUMPAR||'-'||NEW.SUBPAR;
        vLOG := 'REC ['||TRIM(vREC)||']: '||CRLF||vLOG;
        select * into QuemLogou from DadosLogon();
        INSERT INTO TL_VEN (FILVEN, SEQVEN, FILUSU, CODUSU, DATOPE, MSGLOG, CODUID)
                    VALUES (NEW.CODFIL, NEW.SEQUEN, QuemLogou.FILUSU, QuemLogou.CODUSU, agora(), vLog, WK_CODUID);
     END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5008 --*/
CREATE TRIGGER TGREC3
AFTER INSERT OR UPDATE ON TT_REC 
FOR EACH ROW EXECUTE PROCEDURE TGREC3();



/*-- SEQ 5009 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGREC_DW() CASCADE;

/*-- SEQ 5010 --*/
CREATE OR REPLACE FUNCTION TGREC_DW() RETURNS TRIGGER AS $$
DECLARE
  bProcessa     BOOLEAN DEFAULT False;
  regDW         RECORD;
  cDUMMY        VARCHAR(2);
  vCODFIL       TT_REC.CODFIL%TYPE;
  vSEQUEN       TT_REC.SEQUEN%TYPE;
  vComplemento  CONSTANT VARCHAR(100) := Constante('Complemento');

-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Vendas_Meio

BEGIN
  IF UsaVMDecisor() = 'T' THEN
     IF (TG_OP = 'INSERT') THEN
       IF NEW.SUBPAR = ' 0' THEN
         bProcessa := True;
         vCODFIL   := NEW.CODFIL;
         vSEQUEN   := NEW.SEQUEN;
       END IF;
     ELSIF (TG_OP = 'UPDATE') THEN
       IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 --PK
       OR Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 --PK
       OR Equal(OLD.NUMPAR,NEW.NUMPAR) <> 1 --PK
       OR Equal(OLD.SUBPAR,NEW.SUBPAR) <> 1 --PK
       THEN
         RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
       END IF;
       IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1
       OR Equal(OLD.PAGAME,NEW.PAGAME) <> 1
       OR Equal(OLD.CARTAO,NEW.CARTAO) <> 1
       OR Equal(OLD.SEQCHE,NEW.SEQCHE) <> 1
       OR Equal(OLD.TIPCCC,NEW.TIPCCC) <> 1
       OR Equal(OLD.CODOUT,NEW.CODOUT) <> 1
       OR Equal(OLD.VLRPAR,NEW.VLRPAR) <> 1
       OR Equal(OLD.DATVEN,NEW.DATVEN) <> 1
       OR Equal(OLD.PORTAD,NEW.PORTAD) <> 1 THEN
         IF NEW.SUBPAR = ' 0' THEN
           bProcessa := True;
           vCODFIL   := NEW.CODFIL;
           vSEQUEN   := NEW.SEQUEN;
         END IF;
       END IF;
     ELSIF (TG_OP = 'DELETE') THEN -- no deveria acontecer, mas no existe restrio
       IF OLD.SUBPAR = ' 0' THEN
         bProcessa := True;
         vCODFIL   := OLD.CODFIL;
         vSEQUEN   := OLD.SEQUEN;
       END IF;
     END IF;

     IF bProcessa AND (UsaVMDecisor() = 'T') THEN
       FOR regDW IN (SELECT VEN.CODFIL AS FILIAL,
                            VEN.CODCTR AS COD_UNIDADE,
                            ANO_MES(VEN.DATFIS) AS ANO_MES
                       FROM TT_VEN VEN
                      WHERE VEN.CODFIL = vCODFIL
                        AND VEN.SEQUEN = vSEQUEN)
       LOOP
         cDUMMY := Insere_DW_Log_Vendas_Meio(regDW.FILIAL, regDW.COD_UNIDADE, regDW.ANO_MES);
       END LOOP;
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5011 --*/
CREATE TRIGGER TGREC_DW
AFTER INSERT OR DELETE OR UPDATE ON TT_REC 
FOR EACH ROW EXECUTE PROCEDURE TGREC_DW();




/*-- SEQ 5012 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRECF2() CASCADE;

/*-- SEQ 5013 --*/
CREATE OR REPLACE FUNCTION TGRECF2() RETURNS TRIGGER AS $$
  -- Objetivos
  -- Vincular fechamentos de caixa com a reducao Z
DECLARE
  WK_CONTATTECF Numeric(12);
  WK_CONTATRCAI Numeric(12);
  vComplemento  constant VARCHAR(100) := constante('complemento');
  Registro      TR_ECF%RowType ;
  cDUMMY        VARCHAR(2);
  vLOG          VARCHAR(4000) := '';
  vMotivo       TR_ECF.OBSERV%TYPE := '';
  vMotivoFiscal TR_ECF.OBSERV%TYPE := '';
  cFilUsu       CHAR(3);
  cCodUsu       CHAR(3);
  CRLF          CONSTANT CHAR(1) := CHR(10);
  Nulo          CONSTANT CHAR(1) := '0';
  Logon         TRetQuemLogou%ROWTYPE;
  wk_coduid     tt_uid.coduid%type;

  --LEO 84337
  vCODUID_ATUAL TT_VEN.CODUID%TYPE;
  vBLQ_SEM_UID  TT_CFG.BLQ_SEM_UID%TYPE;
  vSESSIONID    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

BEGIN

  IF (TG_OP = 'DELETE') THEN
     -- Conta registros em TT_ECF
     SELECT COUNT(*) INTO WK_CONTATTECF
       FROM TT_ECF
      WHERE CODFIL = OLD.CODFIL
        AND NUMECF = OLD.NUMECF
        AND TRUNC(DATOPE) = TRUNC(OLD.DATOPE)
        AND CNT_RO = OLD.CNT_RO;

     -- conta Registros em TR_CAI
     SELECT COUNT(*) INTO WK_CONTATRCAI
       FROM TR_CAI
      WHERE CODFIL = OLD.CODFIL
        AND NUMECF = OLD.NUMECF
        AND TRUNC(DATOPE) = TRUNC(OLD.DATOPE)
        AND CNT_RO = OLD.CNT_RO;

     IF WK_CONTATTECF > 0 OR WK_CONTATRCAI > 0 then
        RAISE EXCEPTION 'PG-20004 Um Relatorio de ECF nao pode ser excluido. %' , vComplemento;
     END IF;

     -- Tratamento de "log"
     -- Exclui qualquer referencia do "log" ao produto atual
     DELETE FROM TL_ECF WHERE CODFIL = OLD.CODFIL AND NUMECF = OLD.NUMECF AND DATOPE = OLD.DATOPE AND CNT_RO = OLD.CNT_RO;

  ELSE
    IF (TG_OP = 'UPDATE') THEN
          /* Verifica contedos vlidos para DIAFEC */
        IF COALESCE(NEW.DIAFEC,'NULO') NOT IN ('NULO','S','F','X') THEN
           RAISE EXCEPTION 'PG-20003 Valor para DIAFEC nao e valido. %' , vComplemento;
        END IF;

        /* Verifica Mudana da flag DIAFEC */
        IF COALESCE(NEW.DIAFEC,'NULO') <> COALESCE(OLD.DIAFEC,'NULO') THEN
           IF (((OLD.DIAFEC = 'S') OR (OLD.DIAFEC = 'F')) AND (NEW.DIAFEC IS NULL)) THEN
              RAISE EXCEPTION 'PG-20001 Um movimento encerrado nao pode ser aberto novamente. %' , vComplemento;
           END IF;

           IF (OLD.DIAFEC = 'S' AND NEW.DIAFEC = 'F') OR (OLD.DIAFEC = 'F' AND NEW.DIAFEC = 'S') THEN
              RAISE EXCEPTION 'PG-20002 Nao e permitido mudar a forma de fechamento de um movimento. %' , vComplemento;
           END IF;

           IF (OLD.DIAFEC IS NULL) AND (NEW.DIAFEC = 'S') THEN
             RAISE EXCEPTION 'PG-20003 Um movimento aberto nao pode ser considerado fechado sem validacao. %' , vComplemento;
           END IF;
        END IF;
       END IF;

    /* Verifica o Fechamento com as Vendas */
    IF (NEW.DIAFEC = 'X' ) THEN
       NEW.DIAFEC     := NULL;
       Registro.CODFIL := NEW.CODFIL;
       Registro.NUMECF := NEW.NUMECF;
       Registro.DATOPE := NEW.DATOPE;
       Registro.CUPINI := NEW.CUPINI;
       Registro.CUPFIM := NEW.CUPFIM;
       Registro.CNT_RZ := NEW.CNT_RZ;
       Registro.GT_INI := NEW.GT_INI;
       Registro.GT_FIM := NEW.GT_FIM;
       Registro.DATFEC := NEW.DATFEC;
       Registro.CODSER := NEW.CODSER;
       Registro.CNT_RO := NEW.CNT_RO;
            
/*       cDUMMY := PC_RECF_PLUS_UPDATE(Registro.CODFIL,Registro.NUMECF,
                                Registro.DATOPE,Registro.CUPINI,
                                Registro.CUPFIM,Registro.CNT_RZ,
                                Registro.GT_INI,Registro.GT_FIM,
                                Registro.DATFEC,Registro.CODSER);
*/

       vMotivo := DiaFechado(Registro.CODFIL,Registro.NUMECF, Registro.DATOPE, Registro.CNT_RO, 'T');
   	   IF isnull(vMotivo) = 'T' THEN
          NEW.DIAFEC := 'S';
          NEW.OBSERV := NULL;
	   ELSE
	      NEW.DIAFEC := NULL;
	      NEW.OBSERV := vMotivo;
       END IF;

       -- RFMP 93817
       -- Validar dia fiscal somente se dia estiver consistente
       -- (sem transacoes invlidas, com GT consistente, etc.)
       IF TemFun('REG_MFEC') = 'T' THEN
          vMotivoFiscal := DiaFechadoFiscal(Registro.CODFIL,Registro.NUMECF, Registro.DATOPE, Registro.CNT_RO);
          IF IsNotNull(vMotivoFiscal) = 'T' THEN
             cDummy := TGR_RECF_DadosFechamento(Registro.CODFIL,Registro.NUMECF, Registro.DATOPE);
          END IF;
       END IF;

          END IF;

  END IF;

  -- Dados do usuario
  select * into Logon from DadosLogon();
  IF Logon.Encontrou THEN
    cFilUsu := Logon.FILUSU;
    cCodUsu := Logon.CODUSU;
  ELSE
    RAISE EXCEPTION 'PG-20037 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
  END IF;

   select max(CODUID)
     INTO WK_CODUID
     FROM TT_UID
    WHERE SESSION_ID = USERENV('SESSIONID');

  IF (TG_OP = 'DELETE') THEN
    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
  END IF;

  -- Tratamento de vLOG
  IF (TG_OP = 'INSERT') THEN
    vLOG := 'Inclusao';
    -- Inclui uma linha em TL_PRO
    INSERT INTO TL_ECF (CODFIL,NUMECF,DATOPE,FILUSU,CODUSU,MSGLOG,DATHOR,CODUID,CNT_RO)
                VALUES (NEW.CODFIL,NEW.NUMECF,NEW.DATOPE,cFilUsu,cCodusu,vLOG,agora(),WK_CODUID, NEW.CNT_RO);
  ELSIF (TG_OP = 'UPDATE') THEN
    IF (Equal(OLD.DATINC,NEW.DATINC) <> 1) THEN
      vLOG := vLOG||'Data Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),Nulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),Nulo)||CRLF;
    END IF;
    IF (Equal(OLD.ATU_EM,NEW.ATU_EM) <> 1) THEN
      vLOG := vLOG||'Data Atualizao: de '||COALESCE(TO_CHAR(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),Nulo)||' para '||COALESCE(TO_CHAR(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),Nulo)||CRLF;
    END IF;
    IF Equal(OLD.CUPINI,NEW.CUPINI) <> 1 THEN
      vLOG := vLOG||'Cupom inicial: de '||COALESCE(OLD.CUPINI,0)||' para '||COALESCE(NEW.CUPINI,0)||CRLF;
    END IF;
    IF Equal(OLD.CUPFIM,NEW.CUPFIM) <> 1 THEN
      vLOG := vLOG||'Cupom final: de '||COALESCE(OLD.CUPFIM,0)||' para '||COALESCE(NEW.CUPFIM,0)||CRLF;
    END IF;
    IF Equal(OLD.CNT_RZ,NEW.CNT_RZ) <> 1 THEN
      vLOG := vLOG||'Contador Reduo Z: de '||COALESCE(OLD.CNT_RZ,0)||' para '||COALESCE(NEW.CNT_RZ,0)||CRLF;
    END IF;
    IF Equal(OLD.GT_INI,NEW.GT_INI) <> 1 THEN
      vLOG := vLOG||'Grande Total Inicial: de '||COALESCE(OLD.GT_INI,0)||' para '||COALESCE(NEW.GT_INI,0)||CRLF;
    END IF;
    IF Equal(OLD.GT_FIM,NEW.GT_FIM) <> 1 THEN
      vLOG := vLOG||'Grande Total fINAL: de '||COALESCE(OLD.GT_FIM,0)||' para '||COALESCE(NEW.GT_FIM,0)||CRLF;
    END IF;
    IF Equal(OLD.DATFEC,NEW.DATFEC) <> 1 THEN
      vLOG := vLOG||'Data de Fechamento: de '||COALESCE(to_char(OLD.DATFEC,'dd/mm/yyyy hh24:mi:ss'),Nulo)||' para '||COALESCE(to_char(NEW.DATFEC,'dd/mm/yyyy hh24:mi:ss'),Nulo)||CRLF;
    END IF;
    IF Equal(OLD.DIAFEC,NEW.DIAFEC) <> 1 THEN
      vLOG := vLOG||'Fechou Caixa: de '||COALESCE(OLD.DIAFEC,Nulo)||' para '||COALESCE(NEW.DIAFEC,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.QTD_NF,NEW.QTD_NF) <> 1 THEN
      vLOG := vLOG||'Qtde NF Emitidas: de '||COALESCE(OLD.QTD_NF,0)||' para '||COALESCE(NEW.QTD_NF,0)||CRLF;
    END IF;
    IF Equal(OLD.EXPORT,NEW.EXPORT) <> 1 THEN
      vLOG := vLOG||'Exporta: de '||COALESCE(OLD.EXPORT,Nulo)||' para '||COALESCE(NEW.EXPORT,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.SEQCRE,NEW.SEQCRE) <> 1 THEN
      vLOG := vLOG||'Sequenciador: de '||COALESCE(OLD.SEQCRE,Nulo)||' para '||COALESCE(NEW.SEQCRE,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.CODSER,NEW.CODSER) <> 1 THEN
      vLOG := vLOG||'Srie: de '||COALESCE(OLD.CODSER,'Nulo')||' para '||COALESCE(NEW.CODSER,'Nulo')||CRLF;
    END IF;
	IF Equal(OLD.PELAFD,NEW.PELAFD) <> 1 THEN
	  vLOG := vLOG||'Corrigido pela Fita Detalhe: de '||COALESCE(OLD.PELAFD,Nulo)||' para '||COALESCE(NEW.PELAFD,Nulo)||CRLF;
    END IF;

    IF ISNOTNULL(vLOG) = 'T' THEN
       -- cadastra o LOG.
       INSERT INTO TL_ECF (CODFIL,NUMECF,DATOPE,FILUSU,CODUSU,MSGLOG,DATHOR,CODUID,CNT_RO)
                   VALUES (NEW.CODFIL,NEW.NUMECF,NEW.DATOPE,cFilUsu,cCodusu,vLOG,agora(),WK_CODUID,NEW.CNT_RO);
    END IF;
    IF COALESCE(OLD.OBSERV,'XXX') <> COALESCE(NEW.OBSERV,'XXX') THEN
       -- cadastra o LOG.
       INSERT INTO TL_ECF (CODFIL,NUMECF,DATOPE,FILUSU,CODUSU,MSGLOG,DATHOR,CODUID,CNT_RO)
                   VALUES (NEW.CODFIL,NEW.NUMECF,NEW.DATOPE,cFilUsu,cCodusu,COALESCE(OLD.OBSERV,'<NULO>'),agora(),WK_CODUID,NEW.CNT_RO);
    END IF;
  END IF;

  -- Hugo : 79488
  IF (TG_OP = 'INSERT') THEN
     NEW.DATOPE_PAF := NEW.DATOPE;
     NEW.CNT_RO_PAF := NEW.CNT_RO;
     NEW.DATINC     := agora();
     NEW.ATU_EM     := agora();

    -- LEO 84337
    SELECT BLQ_SEM_UID
      INTO vBLQ_SEM_UID
      FROM TT_CFG;
    vCODUID_ATUAL := GetCoduidAtual();
    IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
       RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;

    -- Douglas - 83441
    NEW.CODUID := GetCoduidAtual();
    NEW.ASSINA := COALESCE(AssinaTabela('TR_ECF',
	                                    ConcatenaRECF(NEW.CODFIL,
													  NEW.NUMECF,
													  NEW.DATOPE,
													  NEW.CNT_RO,
													  NEW.CNT_RZ,
													  NEW.INTERV,
													  NEW.CUPFIM,
													  NEW.DATOPE_PAF,
													  NEW.DATFEC,
													  NEW.GT_FIM,
													  NEW.GT_INI),
                                                   null, null, null),NEW.ASSINA);
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF ConcatenaRECF(NEW.CODFIL,NEW.NUMECF,NEW.DATOPE,NEW.CNT_RO,
					   NEW.CNT_RZ,NEW.INTERV,NEW.CUPFIM,NEW.DATOPE_PAF,
					   NEW.DATFEC,NEW.GT_FIM,NEW.GT_INI) <>
		 ConcatenaRECF(OLD.CODFIL,OLD.NUMECF,OLD.DATOPE,OLD.CNT_RO,
					   OLD.CNT_RZ,OLD.INTERV,OLD.CUPFIM,OLD.DATOPE_PAF,
					   OLD.DATFEC,OLD.GT_FIM,OLD.GT_INI) THEN

         -- LEO 84337
         SELECT BLQ_SEM_UID
           INTO vBLQ_SEM_UID
           FROM TT_CFG;
         vCODUID_ATUAL := GetCoduidAtual();
         IF vBLQ_SEM_UID = 'T' AND vCODUID_ATUAL IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;

	     -- Douglas - 83441
         NEW.CODUID := GetCoduidAtual();
         NEW.ASSINA := COALESCE(AssinaTabela('TR_ECF',
 	                                      ConcatenaRECF(NEW.CODFIL,
													    NEW.NUMECF,
													    NEW.DATOPE,
													    NEW.CNT_RO,
													    NEW.CNT_RZ,
													    NEW.INTERV,
													    NEW.CUPFIM,
													    NEW.DATOPE_PAF,
													    NEW.DATFEC,
													    NEW.GT_FIM,
													    NEW.GT_INI),
                                                    OLD.CODUID,
	                                      ConcatenaRECF(OLD.CODFIL,
													    OLD.NUMECF,
													    OLD.DATOPE,
													    OLD.CNT_RO,
													    OLD.CNT_RZ,
													    OLD.INTERV,
													    OLD.CUPFIM,
													    OLD.DATOPE_PAF,
													    OLD.DATFEC,
													    OLD.GT_FIM,
													    OLD.GT_INI),
                                                   OLD.ASSINA
                                                  ),NEW.ASSINA);
      END IF;
      
      IF (COALESCE(NEW.DUMMY, 'X') <> '%') THEN
         IF (NEW.ATU_EM = OLD.ATU_EM) THEN
            NEW.ATU_EM := agora();
         END IF;
      END IF;
   END IF;

   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.DUMMY := NULL;
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5014 --*/
CREATE TRIGGER TGRECF2
BEFORE INSERT OR DELETE OR UPDATE ON TR_ECF 
FOR EACH ROW EXECUTE PROCEDURE TGRECF2();

/*-- SEQ 5015 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRECF3() CASCADE;

/*-- SEQ 5016 --*/
CREATE OR REPLACE FUNCTION TGRECF3() RETURNS TRIGGER AS $$
  -- Objetivos
  -- Atualizar a tr_cai
BEGIN
    IF (TG_OP = 'INSERT') THEN
       -- Atualiza TR_CAI
       UPDATE TR_CAI
          SET DATOPE = TRUNC(NEW.DATOPE)
        WHERE CODFIL = NEW.CODFIL
          AND NUMECF = NEW.NUMECF
          AND TRUNC(DATABE) = TRUNC(NEW.DATOPE)
          AND CNT_RO = NEW.CNT_RO;
    ELSIF  (TG_OP = 'UPDATE') THEN
       IF Equal(OLD.DATOPE,NEW.DATOPE) <> 1 THEN
          -- Quando alterar a data, deve-se retirar a relao da antiga
          -- e colocar na nova
          UPDATE TR_CAI
             SET DATOPE = NULL
           WHERE CODFIL = OLD.CODFIL
             AND NUMECF = OLD.NUMECF
             AND TRUNC(DATOPE) = TRUNC(OLD.DATOPE)
             AND CNT_RO = OLD.CNT_RO;

          UPDATE TR_CAI SET DATOPE = TRUNC(NEW.DATOPE)
           WHERE CODFIL = NEW.CODFIL
             AND NUMECF = NEW.NUMECF
             AND TRUNC(DATABE) = TRUNC(NEW.DATOPE)
             AND CNT_RO = NEW.CNT_RO;
       END IF;
    END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5017 --*/
CREATE TRIGGER TGRECF3
AFTER INSERT OR DELETE OR UPDATE ON TR_ECF 
FOR EACH ROW EXECUTE PROCEDURE TGRECF3();


/*-- SEQ 5018 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRECF_ASS() CASCADE;

/*-- SEQ 5019 --*/
CREATE OR REPLACE FUNCTION TGRECF_ASS() RETURNS TRIGGER AS $$
-- 83073
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
BEGIN

  IF ExisteFilialNaUF('SC') THEN
     IF (TG_OP = 'INSERT') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG + 1
        WHERE NOMTAB = 'TR_ECF';
     END IF;
     
     IF (TG_OP = 'DELETE') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG - 1
        WHERE NOMTAB = 'TR_ECF';
     END IF;  
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5020 --*/
CREATE TRIGGER TGRECF_ASS
AFTER INSERT OR DELETE ON TR_ECF 
FOR EACH ROW EXECUTE PROCEDURE TGRECF_ASS();


/*-- SEQ 5021 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRED() CASCADE;

/*-- SEQ 5022 --*/
CREATE OR REPLACE FUNCTION TGRED() RETURNS TRIGGER AS $$
DECLARE
  cRet VARCHAR(2);
BEGIN
  IF (TG_OP = 'DELETE') THEN
     cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_RED', OLD.mesano, null);
  END IF;
  IF (TG_OP = 'INSERT') THEN
     --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
     cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_RED', NEW.mesano, null);
  END IF;
  IF NOT (TG_OP = 'DELETE') THEN
     NEW.ATU_EM := AGORA();
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5023 --*/
CREATE TRIGGER TGRED
BEFORE INSERT OR UPDATE OR DELETE ON TT_RED 
FOR EACH ROW EXECUTE PROCEDURE TGRED();


/*-- SEQ 5024 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGREF() CASCADE;

/*-- SEQ 5025 --*/
CREATE OR REPLACE FUNCTION TGREF() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
DECLARE
BEGIN
  NEW.SEQUEN:=ProximoCodigo('TT_REF',NEW.FILMAT);
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5026 --*/
CREATE TRIGGER TGREF
BEFORE INSERT ON TT_REF 
FOR EACH ROW EXECUTE PROCEDURE TGREF();


/*-- SEQ 5027 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGREG1() CASCADE;

/*-- SEQ 5028 --*/
CREATE OR REPLACE FUNCTION TGREG1() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Tratar campos automaticos na inclusao
-- 2) Impedir Exclusao
-- 3) Gerar um codigo sequencial exclusivo para compor a chave primaria

  vcomplemento CONSTANT VARCHAR(254):= constante('complemento');

-- Principal
BEGIN
  -- Impede exclusoes
  IF (TG_OP = 'DELETE') THEN
    RAISE EXCEPTION 'PG-20027 Exclusao so pode ser feita atraves da rotina manutencao.%' , vComplemento;
  ELSIF (TG_OP = 'INSERT') THEN
    -- Gera um codigo automaticamente
    IF NEW.SEQUEN IS NULL THEN
      NEW.SEQUEN:=ProximoCodigo('TT_REG',NEW.CODFIL);
    END IF;
    NEW.DATCAD := agora();
  ELSIF (TG_OP = 'UPDATE') THEN
     IF (OLD.DATCAD <> NEW.DATCAD)
     OR (OLD.CODFIL <> NEW.CODFIL)
     OR (OLD.SEQUEN <> NEW.SEQUEN) THEN
        RAISE EXCEPTION 'PG-20027 Atualizacao invalida.%' , vComplemento;
     END IF;
  END IF;

  -- "Default"
  NEW.ATU_EM := agora();
  NEW.NUMSER := ltrim( rtrim( NEW.NUMSER ));

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5029 --*/
CREATE TRIGGER TGREG1
BEFORE INSERT OR UPDATE OR DELETE ON TT_REG 
FOR EACH ROW EXECUTE PROCEDURE TGREG1();

/*-- SEQ 5030 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGREG2() CASCADE;

/*-- SEQ 5031 --*/
CREATE OR REPLACE FUNCTION TGREG2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Registrar mudanca dos dados num "log"
--
DECLARE
  vLOG           VARCHAR(500) := '';
  CRLF CONSTANT CHAR(1)       := CHR(10);
  Nulo CONSTANT CHAR(1)       := '0';

BEGIN
  IF (TG_OP = 'INSERT') THEN
    vLOG := 'Inclusao';
    -- Inclui uma linha em TL_CTT
    INSERT INTO TL_REG (CODFIL,SEQUEN,MSGLOG)
    VALUES (NEW.CODFIL,NEW.SEQUEN,vLOG);
  ELSIF (TG_OP = 'UPDATE') THEN
    IF Equal(OLD.NUMSER,NEW.NUMSER) <> 1 THEN
      vLOG := vLOG||'Numero: de '||COALESCE(OLD.NUMSER,'')||' para '||COALESCE(NEW.NUMSER,'')||chr(13)||chr(10);
    END IF;

    IF Equal(OLD.FILCLI,NEW.FILCLI) <> 1 OR
       Equal(OLD.CODCLI,NEW.CODCLI) <> 1 OR
       Equal(OLD.FILEND,NEW.FILEND) <> 1 OR
       Equal(OLD.NUMEND,NEW.NUMEND) <> 1 THEN
      vLOG := vLOG||'Cliente/Endereco: de '||
                  COALESCE(OLD.FILCLI,Nulo)||'-'||COALESCE(rTrim(lTrim(OLD.CODCLI)),Nulo)||'-'||COALESCE(OLD.FILEND,Nulo)||'-'||COALESCE(OLD.NUMEND,Nulo)||' para '||
                  COALESCE(NEW.FILCLI,Nulo)||'-'||COALESCE(rTrim(lTrim(NEW.CODCLI)),Nulo)||'-'||COALESCE(NEW.FILEND,Nulo)||'-'||COALESCE(NEW.NUMEND,Nulo)||CRLF;
    END IF;

    IF Equal(OLD.REGATV,NEW.REGATV) <> 1 THEN
      vLOG := vLOG||'Ativo: de '||COALESCE(OLD.REGATV,Nulo)||' para '||COALESCE(NEW.REGATV,Nulo)||CRLF;
    END IF;

    IF Equal(OLD.NUMREG,NEW.NUMREG) <> 1 THEN
      vLOG := vLOG||'Registro: de '||COALESCE(OLD.NUMREG,Nulo)||' para '||COALESCE(NEW.NUMREG,Nulo)||CRLF;
    END IF;

    IF ISNOTNULL(vLOG)='T' THEN
      -- Inclui uma linha em TL_CTT
      INSERT INTO TL_REG (CODFIL,SEQUEN,MSGLOG)
      VALUES (NEW.CODFIL,NEW.SEQUEN,vLOG);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5032 --*/
CREATE TRIGGER TGREG2
AFTER INSERT OR UPDATE ON TT_REG 
FOR EACH ROW EXECUTE PROCEDURE TGREG2();


/*-- SEQ 5033 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGREL() CASCADE;

/*-- SEQ 5034 --*/
CREATE OR REPLACE FUNCTION TGREL() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gravar log de excluso
DECLARE
   cRet                          VARCHAR(2);
   cValorAntigo                  VARCHAR(1);
   cTipoParceiro                 VARCHAR(30);
   cNulo                         CONSTANT CHAR(1) := '';
   CRLF                          CONSTANT CHAR(1) := CHR(10);
   VLOG                          VARCHAR(4000)      := '';
BEGIN
   IF (TG_OP = 'DELETE') THEN
      cTipoParceiro := CASE OLD.TIPPAR 
                           WHEN 'C' THEN 'Cartoes'
                           WHEN 'A' THEN 'Transportadora'  
                           WHEN 'F' THEN 'Fornecedor' 
                           WHEN 'I' THEN 'Indicador Venda' 
                           WHEN 'M' THEN 'Produtor' 
                           WHEN 'O' THEN 'Motorista' 
                           WHEN 'R' THEN 'Representante' 
                           WHEN 'N' THEN 'Tcnico Interno' 
                           WHEN 'X' THEN 'Tcnico Externo' 
                           WHEN 'T' THEN 'Transportador' 
                       END;

      vLOG := vLOG||'Parceiro deixou de ser: '||COALESCE(cTipoParceiro,cNulo)||CRLF;
      vLOG := ' DADOS DE TIPO DE RELACIONAMENTO '||CRLF||vLOG;
      INSERT INTO TL_CLI (FILCLI,CODCLI,DATOPE,MSGLOG)
                  VALUES (OLD.FILPAR,OLD.CODPAR,agora(),vLOG);
   END IF;

   IF (TG_OP = 'DELETE') THEN
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_REL', OLD.filpar || OLD.codpar, OLD.tippar);
   END IF;
  
   IF (TG_OP = 'INSERT') THEN
      --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_REL', NEW.filpar || NEW.codpar, NEW.tippar);
     
      cTipoParceiro := CASE NEW.TIPPAR 
                           WHEN 'C' THEN 'Cartes'
                           WHEN 'A' THEN 'Transportadora' 
                           WHEN 'F' THEN 'Fornecedor' 
                           WHEN 'I' THEN 'Indicador Venda' 
                           WHEN 'M' THEN 'Produtor'
                           WHEN 'O' THEN 'Motorista'
                           WHEN 'R' THEN 'Representante' 
                           WHEN 'N' THEN 'Tcnico Prprio' 
                           WHEN 'X' THEN 'Tcnico Externo' 
                           WHEN 'T' THEN 'Transportador'
                       END;

      vLOG := vLOG||'Parceiro passou a ser: '||COALESCE(cTipoParceiro,cNulo)||CRLF;
      vLOG := ' DADOS DE TIPO DE RELACIONAMENTO '||CRLF||vLOG;
      INSERT INTO TL_CLI (FILCLI,CODCLI,DATOPE,MSGLOG)
           VALUES (NEW.FILPAR,NEW.CODPAR,agora(),vLOG);
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5035 --*/
CREATE TRIGGER TGREL
BEFORE INSERT OR UPDATE OR DELETE ON TT_REL 
FOR EACH ROW EXECUTE PROCEDURE TGREL();

/*-- SEQ 5036 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGREL2() CASCADE;

/*-- SEQ 5037 --*/
CREATE OR REPLACE FUNCTION TGREL2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_CLI
   cRetorno                      VARCHAR(2);
   cWhere                        TM_ATU.FILTRO%TYPE;
BEGIN
   --Tratamento para Atualizar Tabela Pai
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN      
      cWhere := 'FILCLI = ' || CHR(39) || NEW.FILPAR  || CHR(39) || ' AND CODCLI = ' || CHR(39) || NEW.CODPAR || CHR(39);
   ELSIF (TG_OP = 'DELETE') THEN      
      cWhere := 'FILCLI = ' || CHR(39) || OLD.FILPAR  || CHR(39) || ' AND CODCLI = ' || CHR(39) || OLD.CODPAR || CHR(39);
   END IF;
   cRetorno := INSERE_MATU('TT_REL', 'TT_CLI', cWhere);

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5038 --*/
CREATE TRIGGER TGREL2
AFTER INSERT OR UPDATE OR DELETE ON TT_REL 
FOR EACH ROW EXECUTE PROCEDURE TGREL2();


/*-- SEQ 5039 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGREM() CASCADE;

/*-- SEQ 5040 --*/
CREATE OR REPLACE FUNCTION TGREM() RETURNS TRIGGER AS $$
-- Objetivos:
-- 1. Atualiza controles de data.

-- Principal
BEGIN
   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') THEN
      NEW.DATINC := Agora();
   END IF;
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5041 --*/
CREATE TRIGGER TGREM
BEFORE INSERT OR UPDATE OR DELETE ON TT_REM 
FOR EACH ROW EXECUTE PROCEDURE TGREM();

/*-- SEQ 5042 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGREM2() CASCADE;

/*-- SEQ 5043 --*/
CREATE OR REPLACE FUNCTION TGREM2() RETURNS TRIGGER AS $$
-- Objetivos:
-- 1. Atualiza ATU_EM da TT_ATU de configuração
DECLARE
   cRetorno                      VARCHAR(2);  
-- Principal
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5044 --*/
CREATE TRIGGER TGREM2
AFTER INSERT OR UPDATE OR DELETE ON TT_REM 
FOR EACH ROW EXECUTE PROCEDURE TGREM2();


/*-- SEQ 5045 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGREN() CASCADE;

/*-- SEQ 5046 --*/
CREATE OR REPLACE FUNCTION TGREN() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

  proximo       CHAR(10);

-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
     NEW.SEQUEN := ProximoCodigo('TT_REN',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5047 --*/
CREATE TRIGGER TGREN
BEFORE INSERT ON TT_REN 
FOR EACH ROW EXECUTE PROCEDURE TGREN();


/*-- SEQ 5048 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGREQ() CASCADE;

/*-- SEQ 5049 --*/
CREATE OR REPLACE FUNCTION TGREQ() RETURNS TRIGGER AS $$
DECLARE
-- Tabela Requisitos de Sistema
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Atualiza DATINC
-- 3) Atualiza ATU_EM
-- 4) Impedir exclusao
  
  vComplemento  VARCHAR(254) := constante('complemento'); 
  QuemLogou TRetQuemLogou%ROWTYPE;

-- Principal
BEGIN
  IF (TG_OP = 'DELETE') THEN
     RAISE EXCEPTION 'PG-20001 Nao e permitida a exclusao. %' , vComplemento;     
  END IF;

  IF (TG_OP = 'INSERT') THEN
     IF NEW.SEQUEN IS NULL THEN
        NEW.SEQUEN := ProximoCodigo('TT_REQ', NEW.CODFIL);
     END IF;
     select * into QuemLogou from DadosLogon();
     NEW.FILUSU := QuemLogou.FILUSU;
     NEW.CODUSU := QuemLogou.CODUSU;
     NEW.DATINC := AGORA();
  END IF;

  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     NEW.ATU_EM := AGORA();
  END IF;  

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5050 --*/
CREATE TRIGGER TGREQ
BEFORE INSERT OR DELETE OR UPDATE ON TT_REQ 
FOR EACH ROW EXECUTE PROCEDURE TGREQ();


/*-- SEQ 5051 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGREQXREQ() CASCADE;

/*-- SEQ 5052 --*/
CREATE OR REPLACE FUNCTION TGREQXREQ() RETURNS TRIGGER AS $$
DECLARE
-- Tabela Vinculo entre Requisitos
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Atualiza DATINC
-- 3) Atualiza ATU_EM
-- 4) Impedir exclusao
  
  vComplemento  VARCHAR(254) := constante('complemento'); 
  QuemLogou TRetQuemLogou%ROWTYPE;

-- Principal
BEGIN
  IF (TG_OP = 'DELETE') THEN
     RAISE EXCEPTION 'PG-20001 Nao e permitida a exclusao. %' , vComplemento;     
  END IF;

  IF (TG_OP = 'INSERT') THEN
     IF NEW.SEQUEN IS NULL THEN
        NEW.SEQUEN := ProximoCodigo('TT_REQXREQ', NEW.CODFIL);
     END IF;
--     select * into QuemLogou from DadosLogon();
--     NEW.FILUSU := QuemLogou.FILUSU;
--     NEW.CODUSU := QuemLogou.CODUSU;
     NEW.DATINC := AGORA();
  END IF;

  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     NEW.ATU_EM := AGORA();
  END IF;  

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5053 --*/
CREATE TRIGGER TGREQXREQ
BEFORE INSERT OR DELETE OR UPDATE ON TT_REQXREQ 
FOR EACH ROW EXECUTE PROCEDURE TGREQXREQ();


/*-- SEQ 5054 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRES() CASCADE;

/*-- SEQ 5055 --*/
CREATE OR REPLACE FUNCTION TGRES() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos
-- Gerar um TT_SUP e um TT_MSG se FILRES, CODRES, MODULO e PRIORI estiverem preenchidas

  WK_SEQUEN    TT_SUP.SEQUEN%TYPE;
  FILIAL       TT_USU.FILUSU%TYPE;               -- Usado Para pegar o e-mail do usuario
  USUARIO      TT_USU.CODUSU%TYPE;               -- Usado Para pegar o e-mail do usuario
  WK_CONTA     Numeric(2);
  WK_FILRES    TT_OPC.FILRES%TYPE;
  WK_CODRES    TT_OPC.CODRES%TYPE;
  WK_PRIORI    TT_OPC.PRIORI%TYPE;
  WK_MODULO    TT_OPC.MODULO%TYPE;
  WK_NOMOPC    VARCHAR(400);
  WK_DESCRICAO VARCHAR(4000);
  WK_OPCOES    VARCHAR(200);
  c_LF         CHAR(2) := chr(13)||chr(10);
  WK_TITQUE    TT_QUE.TITQUE%TYPE;
  WK_PRIPER    TT_PER.PRIPER%TYPE;
  WK_NUMIQU    TT_IQU.NUMIQV%TYPE;
  WK_TITPER    TT_PER.TITPER%TYPE;
  WK_FILPRJ    TT_PRJ.CODFIL%TYPE;     -- davi - PTulio - 33738 - 23/06/05
  WK_SEQPRJ    TT_PRJ.SEQUEN%TYPE;     -- davi - PTulio - 33738 - 23/06/05
  Logon        TRetQuemLogou%ROWTYPE;
  vComplemento Constant VARCHAR(100) := Constante('Complemento');
  
    Res RECORD;
    
-- Principal
begin

  IF (TG_OP = 'INSERT') THEN
     NEW.SEQUEN := ProximoCodigo('TT_RES',NEW.CODFIL);
  END IF;

   -- Dados do usuario
  select * into Logon from DadosLogon();
  IF Logon.Encontrou THEN
     Filial := Logon.FILUSU;
     Usuario := Logon.CODUSU;
  ELSE
     RAISE EXCEPTION 'PG-20037 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
  END IF;

  SELECT FILRES, CODRES, PRIORI, MODULO,
         CASE NEW.COMENT WHEN NULL THEN NOMOPC
                          ELSE TRIM(NOMOPC)
         END || ' Comentario: ' || NEW.Coment
    INTO WK_FILRES, WK_CODRES, WK_PRIORI, WK_MODULO, WK_NOMOPC
    FROM TT_OPC
   WHERE FILPER = NEW.FILPER
     AND CODPER = NEW.CODPER
     AND CODOPC = NEW.CODOPC;

  IF (WK_FILRES IS NOT NULL) AND
     (WK_CODRES IS NOT NULL) AND
     (WK_PRIORI IS NOT NULL) AND
     (WK_MODULO IS NOT NULL) THEN

     SELECT QUE.TITQUE, PER.PRIPER, IQU.NUMIQV, PER.TITPER
       INTO WK_TITQUE,  WK_PRIPER,  WK_NUMIQU,  WK_TITPER
       FROM TT_IQU IQU INNER JOIN TT_QUE QUE ON IQU.FILQUE = QUE.FILQUE AND IQU.CODQUE = QUE.CODQUE
                       INNER JOIN TT_PER PER ON IQU.FILPER = PER.FILPER AND IQU.CODPER = PER.CODPER
      WHERE IQU.FILQUE = NEW.FILQUE
        AND IQU.CODQUE = NEW.CODQUE
        AND IQU.NUMIQV = NEW.NUMIQU;

     -- Respostas possiveis
     WK_Opcoes := '';
          
     FOR Res IN SELECT NOMOPC FROM TT_OPC WHERE FILPER = NEW.FILPER AND CODPER = NEW.CODPER LOOP
               WK_Opcoes := WK_Opcoes || '   - ' || Res.NOMOPC || C_LF;
     END LOOP;
     -- Montando a mensagem:
     WK_DESCRICAO := 'Titulo do Questionario: ' || WK_TITQUE || c_LF
                  || 'Numero da Pergunta: '     || WK_NUMIQU || c_LF
                  || 'Prioridade da Pergunta: ' || WK_PRIPER || c_LF
                  || 'Titulo da Pergunta: '     || WK_TITPER || c_LF
                  || 'Respostas possiveis: '    || c_LF      || WK_Opcoes
                  || c_LF
                  || 'Cliente respondeu: '      || WK_NOMOPC;

    /* -- davi - PTulio - 33738 - 23/06/05 - no gera mais SUP, somente WOR
       --Sequen a ser utilizado
       SELECT LPAD(TRIM(NEXTVAL('SQSUP')),10,' ') INTO WK_SEQUEN FROM DUAL;
       -- Cadastrando tt_sup
       INSERT INTO TT_SUP
           (CODFIL,SEQUEN,FILCLI,CODCLI,FILEND,NUMEND,DATREG,
            MODULO,VERSAO,CODPRI,SITUAC,
            FILRES,CODRES,DESSUP,
            QTDFAT,E_MAIL,FLGCOB,ATU_EM,CODFUN, TIPSUP, TIPCWS)
            SELECT NEW.FILCLI,WK_SEQUEN,NEW.FILCLI,NEW.CODCLI,
                   EDE.CODFIL,EDE.NUMEND,NEW.DATHOR,
                   DMOD.CODTAB, COALESCE(DMOD.VERATU,'0'), WK_PRIORI, 'N',
                   WK_FILRES, WK_CODRES, substr('[Quest] ' || WK_TITPER,1,254),
                   0, COALESCE(CON.E_MAIL,'E-mail nao encontrado'), 'D', agora(), 0, 0, 'A'
              FROM TD_MOD DMOD,
                   TT_END EDE left outer join TT_CON CON on (CON.FILCLI = EDE.FILCLI AND CON.CODCLI = EDE.CODCLI)
             WHERE DMOD.CODTAB = WK_MODULO
               AND EDE.FILCLI = NEW.FILCLI
               AND EDE.CODCLI = NEW.CODCLI
                      
               LIMIT 1;
           
       -- Inserindo em TT_MSG
       SELECT COUNT(*) INTO WK_CONTA
         FROM TT_SUP
        WHERE CODFIL = NEW.FILCLI
          AND SEQUEN = WK_SEQUEN;

       IF WK_CONTA > 0 THEN
          INSERT INTO TT_MSG
             (CODFIL,SEQUEN,SEQMSG,FILUSU,CODUSU,DATMSG,DESMSG,MSGSUP,ANEXOS,RESPOS)
          VALUES
             (NEW.FILCLI,WK_SEQUEN,1,filial,usuario,NEW.DATHOR, Substr('Resposta: '||wk_NOMOPC,1,40), subStr(WK_DESCRICAO,1,4000), NULL,'A');
       END IF;
     END IF;*/
     -- davi - PTulio - 33738 - 23/06/05 - inicio
     SELECT FILPRJ, SEQPRJ INTO WK_FILPRJ, WK_SEQPRJ
       FROM TT_CFG;
 
     IF (WK_SEQPRJ IS NULL) THEN
           RAISE EXCEPTION 'PG-20038 Voce deve definir um projeto padrao no Totali Config, opo ambiente, aba SAC e WF. %' , vComplemento;	
     END IF;

     SELECT LPAD(TRIM(NEXTVAL('SQWOR')),10,' ') INTO WK_SEQUEN FROM DUAL;
         
     INSERT INTO TT_WOR
          (CODFIL, SEQUEN, MODULO, VERSAO, 
           TIPTAR, FATURA, FILRES, CODRES, FILREG, CODREG, FILTST, CODTST, 
           DESTAR, TAREFA, REVISA, PRIORI, 
           FILPRJ, SEQPRJ, ATU_EM, DATREG, CONCLU, FLGSIT, CLATAR, 
	   FILCLI, CODCLI, DATFIX, TIPCWS)
           SELECT NEW.FILCLI,WK_SEQUEN,DMOD.CODTAB,COALESCE(DMOD.VERATU,'0'),
	          '0','D',WK_FILRES, WK_CODRES,FILIAL,USUARIO,FILIAL,USUARIO,
	          substr('[Quest] ' || WK_TITPER,1,254),WK_DESCRICAO,'',WK_PRIORI,
                  WK_FILPRJ,WK_SEQPRJ,agora(),NEW.DATHOR,0,(SELECT CODTAB FROM TD_SIT WHERE TIPSIT = 'A'),'0',
                  NEW.FILCLI,NEW.CODCLI,'F','A'
             FROM TD_MOD DMOD
            WHERE DMOD.CODTAB = WK_MODULO
                    
              LIMIT 1;
              -- davi - PTulio - 33738 - 23/06/05 - fim
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5056 --*/
CREATE TRIGGER TGRES
BEFORE INSERT ON TT_RES 
FOR EACH ROW EXECUTE PROCEDURE TGRES();


/*-- SEQ 5057 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRFC() CASCADE;

/*-- SEQ 5058 --*/
CREATE OR REPLACE FUNCTION TGRFC() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 2) Atualiza DATINC
-- 3) Atualiza ATU_EM

-- Principal
BEGIN

  IF (TG_OP = 'INSERT') THEN
     NEW.DATINC := AGORA();
  END IF;

  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     NEW.ATU_EM := AGORA();
  END IF;  

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5059 --*/
CREATE TRIGGER TGRFC
BEFORE INSERT OR UPDATE ON TT_RFC 
FOR EACH ROW EXECUTE PROCEDURE TGRFC();


/*-- SEQ 5060 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRFIN() CASCADE;

/*-- SEQ 5061 --*/
CREATE OR REPLACE FUNCTION TGRFIN() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
   -- Gera um codigo automaticamente
   IF (TG_OP = 'INSERT') THEN 
      IF NEW.CODTAB IS NULL THEN
         NEW.CODTAB := ProximoCodigo('TR_FIN', NEW.CODFIL);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5062 --*/
CREATE TRIGGER TGRFIN
BEFORE INSERT ON TR_FIN 
FOR EACH ROW EXECUTE PROCEDURE TGRFIN();


/*-- SEQ 5063 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRMOV() CASCADE;

/*-- SEQ 5064 --*/
CREATE OR REPLACE FUNCTION TGRMOV() RETURNS TRIGGER AS $$
-- Objetivo
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Nao considerar a hora no momento de gravar a data de movimentacao
-- 3) Impedir exclusoes
DECLARE
   vComplemento                  VARCHAR(254):= constante('complemento');

   vSESSIONID                    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

   WK_UID                        TPC_UID_Retorno%ROWTYPE;
BEGIN
   -- Nao permite exclusoes
   IF (TG_OP = 'DELETE') THEN
      -- Saldo anterior -99999999 utilizada para permitir exclusao pela funcao Atualizamov
      IF OLD.SALANT<>-99999999 THEN
         RAISE EXCEPTION 'PG-20036 A movimentacao diaria nao pode ser excluida.%' , vComplemento;
      END IF;
   END IF;

   IF (TG_OP = 'INSERT') THEN
      NEW.SEQUEN:=ProximoCodigo('TR_MOV',NEW.CODFIL);
   END IF;

   -- "Default"
   IF NOT (TG_OP = 'DELETE') THEN
      NEW.DATMOV := TRUNC(NEW.DATMOV);
   END IF;

   -- Inicializa dados para assinatura

   WK_UID := GetUidAtual();

   IF (TG_OP = 'DELETE') THEN
      IF WK_UID.BLQ_SEM_UID = 'T' AND WK_UID.CODUID IS NULL THEN
         RAISE EXCEPTION 'PG-20027 Não é permitido deletar esse registro sem uma sessão de banco de dados válida. Sessão: %' , vSessionID;
      END IF;
   END IF;
  
   IF (TG_OP = 'INSERT') THEN
      IF WK_UID.BLQ_SEM_UID = 'T' AND WK_UID.CODUID IS NULL THEN
         RAISE EXCEPTION 'PG-20027 Não é permitido inserir um registro sem uma sessão de banco de dados válida. Sessão: %' , vSessionID;
      END IF;

      NEW.CODUID := WK_UID.CODUID;
      NEW.ASSINA := COALESCE(AssinaTabela('TR_MOV',
                                            ConcatenaRMOV(NEW.CODFIL,
                                                          NEW.SEQUEN,
                                                          NEW.FILMAT,
                                                          NEW.CODMAT,
                                                          NEW.CODCOR,
                                                          NEW.CODTAM,
                                                          NEW.DATMOV,
                                                          NEW.SALANT,
                                                          NEW.CODMUL,
                                                          NEW.QTDCOM,
                                                          NEW.QTDVEN,
                                                          NEW.VENFIS,
                                                          NEW.QTDOUT),
                                                   null, null, null),NEW.ASSINA);
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF ConcatenaRMOV(NEW.CODFIL, NEW.SEQUEN, NEW.FILMAT, NEW.CODMAT, NEW.CODCOR, NEW.CODTAM, NEW.DATMOV, NEW.SALANT, NEW.CODMUL, NEW.QTDCOM, NEW.QTDVEN, NEW.VENFIS, NEW.QTDOUT) <>
         ConcatenaRMOV(OLD.CODFIL, OLD.SEQUEN, OLD.FILMAT, OLD.CODMAT, OLD.CODCOR, OLD.CODTAM, OLD.DATMOV, OLD.SALANT, OLD.CODMUL, OLD.QTDCOM, OLD.QTDVEN, OLD.VENFIS, OLD.QTDOUT)
      THEN
         IF WK_UID.BLQ_SEM_UID = 'T' AND WK_UID.CODUID IS NULL THEN
            RAISE EXCEPTION 'PG-20027 Não é permitido modificar esse registro sem uma sessão de banco de dados válida. Sessão: %' , vSessionID;
         END IF;

         NEW.CODUID := WK_UID.CODUID;
         NEW.ASSINA := COALESCE(AssinaTabela('TR_MOV', 
                                               ConcatenaRMOV(NEW.CODFIL,
                                                             NEW.SEQUEN,
                                                             NEW.FILMAT,
                                                             NEW.CODMAT,
                                                             NEW.CODCOR,
                                                             NEW.CODTAM,
                                                             NEW.DATMOV,
                                                             NEW.SALANT,
                                                             NEW.CODMUL,
                                                             NEW.QTDCOM,
                                                             NEW.QTDVEN,
                                                             NEW.VENFIS,
                                                             NEW.QTDOUT),
                                                OLD.CODUID, 
                                               ConcatenaRMOV(OLD.CODFIL,
                                                             OLD.SEQUEN,
                                                             OLD.FILMAT,
                                                             OLD.CODMAT,
                                                             OLD.CODCOR,
                                                             OLD.CODTAM,
                                                             OLD.DATMOV,
                                                             OLD.SALANT,
                                                             OLD.CODMUL,
                                                             OLD.QTDCOM,
                                                             OLD.QTDVEN,
                                                             OLD.VENFIS,
                                                             OLD.QTDOUT),
                                           OLD.ASSINA),NEW.ASSINA);
      END IF;
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5065 --*/
CREATE TRIGGER TGRMOV
BEFORE INSERT OR DELETE OR UPDATE ON TR_MOV 
FOR EACH ROW EXECUTE PROCEDURE TGRMOV();


/*-- SEQ 5066 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRMOV_ASS() CASCADE;

/*-- SEQ 5067 --*/
CREATE OR REPLACE FUNCTION TGRMOV_ASS() RETURNS TRIGGER AS $$
-- Atualiza a QTDREG.TT_ASS, Caso exista exclusão ou inclusão de registros.
DECLARE
   WK_DUMMY                      VARCHAR(2);

   WK_UID                        TPC_UID_Retorno%ROWTYPE;

BEGIN

   IF ExisteFilialNaUF('SC') THEN
      IF (TG_OP = 'INSERT') THEN
         -- RFMP 85136 Tratamento para não dar lock na TT_ASS
         WK_UID := GetUidAtual();
      
         IF WK_UID.ASSINS = 'T' THEN
            UPDATE TT_ASS
               SET QTDREG = QTDREG + 1
             WHERE NOMTAB = 'TR_MOV';
         ELSE
            WK_DUMMY := Insere_MASS('TR_MOV');
         END IF;
      END IF;
      
      IF (TG_OP = 'DELETE') THEN
         UPDATE TT_ASS
            SET QTDREG = QTDREG - 1
          WHERE NOMTAB = 'TR_MOV';
      END IF;   
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5068 --*/
CREATE TRIGGER TGRMOV_ASS
AFTER INSERT OR DELETE ON TR_MOV 
FOR EACH ROW EXECUTE PROCEDURE TGRMOV_ASS();



/*-- SEQ 5069 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGROM() CASCADE;

/*-- SEQ 5070 --*/
CREATE OR REPLACE FUNCTION TGROM() RETURNS TRIGGER AS $$
DECLARE
-- Tabela item de romaneio
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Atualiza ATU_EM
-- 3) Colocar valores padrao para DATOPE, FILUSU e CODUSU 
-- 4) Impedir exclusao
  
  vComplemento             VARCHAR(254) := constante('complemento'); 
  iQtd_ivos_nao_canceladas INTEGER;
  QuemLogou TRetQuemLogou%ROWTYPE;

-- Principal
BEGIN
  
  IF (TG_OP = 'DELETE') THEN
     RAISE EXCEPTION 'PG-20001 Nao e permitida a exclusao. %' , vComplemento;     
  END IF;
  IF (TG_OP = 'UPDATE') THEN
    IF OLD.SIGNAT <> NEW.SIGNAT THEN
       RAISE EXCEPTION 'PG-20002 Registro foi alterado por outro usurio, refaa a consulta e tente gravar novamente. %' , vComplemento;
    END IF;
    NEW.SIGNAT := MOD(OLD.SIGNAT + 1,100000);
  END IF;

  --IF (TG_OP = 'UPDATE') THEN
      -- Impede alterao de estado de  "Fechada/Entregue" para "Aberto"
      --IF NEW.FLGEST = 'A' AND OLD.FLGEST <> 'A' THEN
        --RAISE EXCEPTION 'PG-20005 Nao e permitida a alteracao do estado de "Fechada, Entregue ou Cancelado" para "Aberto". %' , vComplemento;  
      --END IF;
  --END IF;
    
  IF (TG_OP = 'INSERT') THEN
     if NEW.SEQUEN is null then
        NEW.SEQUEN := ProximoCodigo('TT_ROM',NEW.CODFIL);
     end if;
     select * into QuemLogou from DadosLogon();
     NEW.FILUSU:=QuemLogou.FILUSU;
     NEW.CODUSU:=QuemLogou.CODUSU;
     NEW.DATOPE := agora();
  END IF;
  
  IF (TG_OP = 'INSERT') 
  OR (TG_OP = 'UPDATE') THEN  
    NEW.ATU_EM := agora();
  END IF;  

  IF (TG_OP = 'UPDATE') THEN  
    -- rfmp 67861
    IF (NEW.FLGEST = 'C') AND (NEW.FLGEST <> OLD.FLGEST) THEN
      SELECT COUNT(*) 
        INTO iQtd_ivos_nao_canceladas
        FROM TT_IVO
       WHERE FILROM = NEW.CODFIL
         AND SEQROM = NEW.SEQUEN
         AND FLGEST <> 'C';
    END IF;  
    IF iQtd_ivos_nao_canceladas > 0 THEN 
      RAISE EXCEPTION 'PG-20010 No  permitido cancelar uma carga que possui itens no cancelados. %' , vComplemento;
    END IF;
  END IF;  

  
  -- Feito apenas para PostgreSQL, para garantir que no d Mutating Table, j que no existe cliente Oracle que tenha essa parte de Romaneios.
  -- Caso no futuro venha a ter, essa rotina deve ser verificada e preparada para funcionar em Oracle para melhora de performance.
  -- 76947
  IF (TG_OP = 'UPDATE') THEN  
    IF (NEW.FLGEST = 'E') AND (NEW.FLGEST <> OLD.FLGEST) THEN
      UPDATE TT_IVO 
         SET FLGEST = 'E'
       WHERE FILROM = NEW.CODFIL
         AND SEQROM = NEW.SEQUEN;
    END IF;  
  END IF;  
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5071 --*/
CREATE TRIGGER TGROM
BEFORE INSERT OR DELETE OR UPDATE ON TT_ROM 
FOR EACH ROW EXECUTE PROCEDURE TGROM();


/*-- SEQ 5072 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGROM2() CASCADE;

/*-- SEQ 5073 --*/
CREATE OR REPLACE FUNCTION TGROM2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Registrar mudanca dos dados num "log"
--
DECLARE
  vLOG   VARCHAR(4000)   := '';
  CRLF   CONSTANT CHAR(1) := CHR(10);
  Nulo   CONSTANT CHAR(7) := 'Nulo';
  cData  CHAR(21)         := 'DD/MM/YYYY HH24:MI:SS';
  iNulo   CONSTANT Numeric(1) := 0;

-- Principal
BEGIN
  -- Tratamento de vLOG
  IF (TG_OP = 'UPDATE') THEN

    IF Equal(OLD.PLACAS,NEW.PLACAS) <> 1  THEN
      vLOG := vLOG||'Placa: de '||COALESCE(OLD.PLACAS,Nulo)||' para '||COALESCE(NEW.PLACAS,Nulo)||CRLF;
    END IF;

    IF Equal(OLD.VLRFRE,NEW.VLRFRE) <> 1 THEN
       vLOG := vLOG||'Valor Frete: de '||COALESCE(OLD.VLRFRE,iNulo)||' para '||COALESCE(NEW.VLRFRE,iNulo)||CRLF;
    END IF;

    IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1  THEN
      vLOG := vLOG||'Status: de '||COALESCE(OLD.FLGEST,Nulo)||' para '||COALESCE(NEW.FLGEST,Nulo)||CRLF;
    END IF;

    IF Equal(OLD.FILMOT,NEW.FILMOT) <> 1 OR
       Equal(OLD.CODMOT,NEW.CODMOT) <> 1 OR
       Equal(OLD.TIPMOT,NEW.TIPMOT) <> 1 THEN
      vLOG := vLOG||'Motorista: de '||COALESCE(OLD.FILMOT,Nulo)||'/'
                                               ||COALESCE(OLD.CODMOT,Nulo)||'/'
                                               ||COALESCE(OLD.TIPMOT,Nulo)||' para '
                                               ||COALESCE(NEW.FILMOT,Nulo)||'/'
                                               ||COALESCE(NEW.CODMOT,Nulo)||'/'
                                               ||COALESCE(NEW.TIPMOT,Nulo)||CRLF;
    END IF;

    IF Equal(OLD.FILTRA,NEW.FILTRA) <> 1 OR
       Equal(OLD.CODTRA,NEW.CODTRA) <> 1 OR
       Equal(OLD.TIPTRA,NEW.TIPTRA) <> 1 THEN
      vLOG := vLOG||'Transportadora: de '||COALESCE(OLD.FILTRA,Nulo)||'/'
                                                    ||COALESCE(OLD.CODTRA,Nulo)||'/'
                                                    ||COALESCE(OLD.TIPTRA,Nulo)||' para '
                                                    ||COALESCE(NEW.FILTRA,Nulo)||'/'
                                                    ||COALESCE(NEW.CODTRA,Nulo)||'/'
                                                    ||COALESCE(NEW.TIPTRA,Nulo)||CRLF;
    END IF;
    IF Equal(OLD.FILUSU,NEW.FILUSU) <> 1 OR
       Equal(OLD.CODUSU,NEW.CODUSU) <> 1 THEN
      vLOG := vLOG||'Usuario: de '||COALESCE(OLD.FILUSU,Nulo)||'/'
                                             ||COALESCE(OLD.CODUSU,Nulo)||' para '
                                             ||COALESCE(NEW.FILUSU,Nulo)||'/'
                                             ||COALESCE(NEW.CODUSU,Nulo)||CRLF;
    END IF;

    IF Equal(OLD.OBSERV,NEW.OBSERV) <> 1  THEN
      vLOG := vLOG||'Observacao: de '||COALESCE(OLD.OBSERV,Nulo)||' para '||COALESCE(NEW.OBSERV,Nulo)||CRLF;
    END IF;

    IF Equal(OLD.DATOPE,NEW.DATOPE) <> 1 THEN
      vLOG := vLOG||'Data operacao: de '||COALESCE(TO_CHAR(OLD.DATOPE,cData),Nulo)||' para '||COALESCE(TO_CHAR(NEW.DATOPE,cData),Nulo)||CRLF;
    END IF;

    IF ISNOTNULL(vLOG) = 'T' THEN
      -- Inclui uma linha em TL_ROM
      INSERT INTO TL_ROM (FILROM,SEQROM,DATOPE,FILUSU,CODUSU,MSGLOG)
      VALUES (NEW.CODFIL,NEW.SEQUEN,agora(),NEW.FILUSU,NEW.CODUSU,vLOG);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5074 --*/
CREATE TRIGGER TGROM2
AFTER DELETE OR UPDATE ON TT_ROM 
FOR EACH ROW EXECUTE PROCEDURE TGROM2();


/*-- SEQ 5075 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRPS() CASCADE;

/*-- SEQ 5076 --*/
CREATE OR REPLACE FUNCTION TGRPS() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN    
    NEW.DATINC := AGORA();
    NEW.ATU_EM := AGORA();
  END IF;
  
  IF (TG_OP = 'UPDATE') THEN 
     NEW.ATU_EM := AGORA();
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5077 --*/
CREATE TRIGGER TGRPS
BEFORE INSERT OR UPDATE ON TT_RPS 
FOR EACH ROW EXECUTE PROCEDURE TGRPS();

/*-- SEQ 5078 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRPS2() CASCADE;

/*-- SEQ 5079 --*/
CREATE OR REPLACE FUNCTION TGRPS2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 2) Registrar mudanca dos dados num "log"
   vLOG    VARCHAR(4000)     := '';
   vFILUSU VARCHAR(3);    
   vCODUSU VARCHAR(3); 
   cNulo   CONSTANT CHAR(1)   := '0';
   CRLF    CONSTANT CHAR(1)   := CHR(10);  
    
    QuemLogou TRetQuemLogou%ROWTYPE;
    WK_CODUID TT_UID.CODUID%TYPE;
BEGIN
  WK_CODUID := GetCoduidAtual();

  select * into QuemLogou from DadosLogon();
  vFILUSU := QuemLogou.FILUSU;
  vCODUSU := QuemLogou.CODUSU;
 
  -- Tratamento de "log"
  IF (TG_OP = 'DELETE') THEN
     DELETE FROM TL_RPS WHERE FILRPS = OLD.CODFIL AND SEQRPS = OLD.SEQUEN;
  END IF;

  -- Tratamento de log
  IF (TG_OP = 'INSERT') THEN
     vLOG := 'Inclusao';
     INSERT INTO TL_RPS (FILRPS,SEQRPS,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
          VALUES(NEW.CODFIL,NEW.SEQUEN,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);
  ELSIF (TG_OP = 'UPDATE') THEN

     IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
        vLOG := vLOG||'Cdigo da Filial: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
        vLOG := vLOG||'Sequenciador: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATINC,NEW.DATINC) <> 1 THEN
        vLOG := vLOG||'Data Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
	 IF Equal(OLD.ATU_EM,NEW.ATU_EM) <> 1 THEN
        vLOG := vLOG||'Data Alterao: de '||COALESCE(TO_CHAR(OLD.ATU_EM,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ATU_EM,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
     IF Equal(OLD.SERRPS,NEW.SERRPS) <> 1 THEN
        vLOG := vLOG||'Srie do RPS: de '||COALESCE(OLD.SERRPS,cNulo)||' para '||COALESCE(NEW.SERRPS,cNulo)||CRLF;
     END IF;
	 IF Equal(OLD.NUMRPS,NEW.NUMRPS) <> 1 THEN
        vLOG := vLOG||'Nmero do RPS: de '||COALESCE(OLD.NUMRPS,cNulo)||' para '||COALESCE(NEW.NUMRPS,cNulo)||CRLF;	         
     END IF;
	 IF Equal(OLD.DATRPS,NEW.DATRPS) <> 1 THEN
	    vLOG := vLOG||'Data de Emisso do RPS: de '||COALESCE(TO_CHAR(OLD.DATRPS,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATRPS,'DD/MM/YYYY'),cNulo)||CRLF;         
     END IF;
	 IF Equal(OLD.IM_RPS,NEW.IM_RPS) <> 1 THEN
	    vLOG := vLOG||'Inscrio Municipal do Prestador: de '||COALESCE(OLD.IM_RPS,cNulo)||' para '||COALESCE(NEW.IM_RPS,cNulo)||CRLF;        
     END IF;
	 IF Equal(OLD.DOCRPS,NEW.DOCRPS) <> 1 THEN
        vLOG := vLOG||'CPF ou CNPJ do Prestador: de '||COALESCE(OLD.DOCRPS,cNulo)||' para '||COALESCE(NEW.DOCRPS,cNulo)||CRLF;
     END IF;
	 IF Equal(OLD.TIPRPS,NEW.TIPRPS) <> 1 THEN
	    vLOG := vLOG||'Tipo de RPS: de '||COALESCE(OLD.TIPRPS,0)||' para '||COALESCE(NEW.TIPRPS,0)||CRLF;        
     END IF;
	 IF Equal(OLD.SITRPS,NEW.SITRPS) <> 1 THEN
        vLOG := vLOG||'Situao do RPS: de '||COALESCE(OLD.SITRPS,cNulo)||' para '||COALESCE(NEW.SITRPS,cNulo)||CRLF;
     END IF;
	 IF Equal(OLD.NUMNFS,NEW.NUMNFS) <> 1 THEN
        vLOG := vLOG||'Nmero da NFE-s: de '||COALESCE(OLD.NUMNFS,0)||' para '||COALESCE(NEW.NUMNFS,0)||CRLF;
     END IF;
	 IF Equal(OLD.DATNFS,NEW.DATNFS) <> 1 THEN
	    vLOG := vLOG||'Data e Hora da Emisso da NFE-s: de '||COALESCE(TO_CHAR(OLD.DATNFS,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATNFS,'DD/MM/YYYY'),cNulo)||CRLF;         
     END IF;
	 IF Equal(OLD.CODNFS,NEW.CODNFS) <> 1 THEN
	    vLOG := vLOG||'Cdigo de Verificao da NFE-s: de '||COALESCE(OLD.CODNFS,cNulo)||' para '||COALESCE(NEW.CODNFS,cNulo)||CRLF;        
     END IF;
	 IF Equal(OLD.SITNFS,NEW.SITNFS) <> 1 THEN
	    vLOG := vLOG||'Situao da NFE-s: de '||COALESCE(OLD.SITNFS,cNulo)||' para '||COALESCE(NEW.SITNFS,cNulo)||CRLF;                
     END IF;	 
	 
     IF ISNOTNULL(trim(vLOG)) = 'T' THEN
        -- cadastra o LOG.
        INSERT INTO TL_RPS (FILRPS,SEQRPS,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                 VALUES (NEW.CODFIL,NEW.SEQUEN,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);
     END IF;   
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5080 --*/
CREATE TRIGGER TGRPS2
AFTER INSERT OR UPDATE OR DELETE ON TT_RPS 
FOR EACH ROW EXECUTE PROCEDURE TGRPS2(); 


/*-- SEQ 5081 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRSUG() CASCADE;

/*-- SEQ 5082 --*/
CREATE OR REPLACE FUNCTION TGRSUG() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 2) Atualiza DATINC
-- 3) Atualiza ATU_EM

-- Principal
BEGIN

  IF (TG_OP = 'INSERT') THEN
   NEW.DATINC := AGORA();
  END IF;

  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     NEW.ATU_EM := AGORA();  
  END IF; 
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5083 --*/
CREATE TRIGGER TGRSUG
BEFORE INSERT OR UPDATE ON TR_SUG 
FOR EACH ROW EXECUTE PROCEDURE TGRSUG();


/*-- SEQ 5084 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRTB() CASCADE;

/*-- SEQ 5085 --*/
CREATE OR REPLACE FUNCTION TGRTB() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- Tratar o retorno de cobranca bancaria
-- LF
--    Trigger alterada para comportar carteiras sem registro no banco

   WK_ERRO                       Numeric(15);
   WK_FLGEST                     CHAR(1);
   WK_REC_FLGEST                 CHAR(1);
   WK_NOVAFLGEST                 CHAR(1);
   WK_FILREC                     TT_TIT.FILREC%TYPE;
   WK_SEQREC                     TT_TIT.SEQREC%TYPE;
   WK_PARREC                     TT_TIT.PARREC%TYPE;
   WK_SUBREC                     TT_TIT.SUBREC%TYPE;
   WK_DEDTAX                     TT_CCB.DEDTAX%TYPE;
   vComplemento                  Constant VARCHAR(100) := Constante( 'Complemento' );

   WK_ZERADO                     CHAR(1);
   nValorBanco                   TT_RTB.VLRCRE%TYPE;

   Logon                         TRetQuemLogou%ROWTYPE;

  /* Dominio dos erros
     1  Nao encontrado titulo para conciliar.
     2  Nosso numero nao encontrado.
     3  A identificaao do arquivo nao existe na base de dados.
     4  Identificacao do cliente nao confere com a do banco.
     5  Valores cadastrados e do banco estao diferentes. [Removido]
     6  Datas de vencimento cadastrados e do banco estao diferentes. [Removido]
  */

BEGIN
   WK_ERRO := 0;
   NEW.FLGEST :=  'E' ;
   NEW.CODERR := 0;
   WK_ZERADO   :=  'F' ;

   -- RFMP 88274
   -- Tratamento de IDEEMPs
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN

      --54339 - problemas com titulos q ja estavam no BB e esto sem registro no sistema
      IF RPAD(TRIM(NEW.IDEEMP),25, '0' ) = RPAD( '0' ,25, '0' ) THEN
         NEW.NOMCLI:=  'Ttulo inexistente! Venda: ' ||TRIM(NEW.NUMDOC);
         WK_ZERADO :=  'T' ;
      END IF;

      -- Trata IDEEMP invlidos
      IF NEW.IDEEMP IS NOT NULL THEN
         -- Anula se no tiver 14 caracteres
         -- Exemplo "001/         1"
         IF LENGTH(TRIM(NEW.IDEEMP)) <= 4 THEN
            NEW.IDEEMP := NULL;
         -- Anula se no tiver a barra no quarto caracter
         ELSIF SUBSTR(TRIM(NEW.IDEEMP),4,1) <>  '/'  THEN
            NEW.IDEEMP := NULL;
         END IF;
      END IF;

      -- Tratamento para data de Delphi vazia
      IF NEW.DATCRE = TO_DATE('30/12/1899','DD/MM/YYYY') THEN
         NEW.DATCRE := NULL;
      END IF;
   END IF;

   WK_FILREC := NULL;
   WK_SEQREC := NULL;

   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      IF (IntervaloDias(NEW.DATOCO, NEW.DATVEN) >= 120) AND (NEW.CBANCO =  '399' ) AND (NEW.CODMOV = 9) THEN
         SELECT FILREC, SEQREC, PARREC, SUBREC , FLGEST
           INTO WK_FILREC, WK_SEQREC, WK_PARREC, WK_SUBREC , WK_FLGEST
           FROM TT_TIT
          WHERE RPAD(NOSNUM,20, ' ' ) = RPAD(NEW.NOSNUM,20, ' ' )
            AND (Equal(TO_NUMBER(CODBCO), COALESCE(NEW.CBANCO,TO_NUMBER(CODBCO))) = 1) -- RFMP 67815
            AND (Equal(TO_NUMBER(NUMAGE), COALESCE(NEW.CODAGE,TO_NUMBER(NUMAGE))) = 1)
            AND (Equal(TO_NUMBER(CTACRR), COALESCE(NEW.COD_CC,TO_NUMBER(CTACRR))) = 1);
         IF WK_FLGEST =  'A'  THEN   -- 36562
            UPDATE TT_TIT SET FLGEST =  'C' ,
                        DUMMY  = Constante( 'VEM_DE_TGRTB' )
            WHERE RPAD(NOSNUM,20, ' ' ) = RPAD(NEW.NOSNUM,20, ' ' )
               AND (Equal(TO_NUMBER(CODBCO), COALESCE(NEW.CBANCO,TO_NUMBER(CODBCO))) = 1) -- RFMP 67815
               AND (Equal(TO_NUMBER(NUMAGE), COALESCE(NEW.CODAGE,TO_NUMBER(NUMAGE))) = 1)
               AND (Equal(TO_NUMBER(CTACRR), COALESCE(NEW.COD_CC,TO_NUMBER(CTACRR))) = 1)
               AND FLGEST =  'A' ;
            UPDATE TT_REC SET PORTAD = 0
             WHERE CODFIL = WK_FILREC
               AND SEQUEN = WK_SEQREC
               AND NUMPAR = WK_PARREC
               AND SUBPAR = WK_SUBREC
               AND FLGEST NOT IN ( 'C' , 'P' , 'X' );
         END IF;
      ELSE
         SELECT CASE COUNT(*) WHEN 0 THEN 1 ELSE 0 END INTO WK_ERRO FROM TT_RET RET
          WHERE RET.CODBCO = LPAD(TO_CHAR(NEW.CBANCO),3, '0' )
            AND RET.RETBCO = NEW.CODMOV;
         IF WK_ERRO = 1 then
            RAISE EXCEPTION 'PG-20028 Cdigo de retorno "%" no est cadastrado no banco de dados. %' , NEW.CODMOV,vComplemento;
         END IF;

         -- RFMP 88274
         -- Tratamento da WK_ZERADO foi retirado daqui

         -- Nao encontrado titulo para conciliar.
         IF (NEW.IDEEMP IS NOT NULL) AND (WK_ZERADO =  'F' ) THEN -- Condicao acrescentada para titulos sem registro a
                                                                   -- conciliacao sera feita pelo NOSNUM
            SELECT CASE COUNT(*) WHEN 0 THEN 1 ELSE 0 END INTO WK_ERRO FROM TT_TIT TIT
             WHERE TRIM(NEW.IDEEMP) = TRIM(TIT.CODFIL|| '/' ||TRIM(TIT.SEQUEN));
         END IF;
         IF wk_ERRO = 0 AND NEW.DOCCLI <> 0 AND NEW.CBANCO <> 1 THEN
            --43626 NEW.CBANCO = 1 -> BBRASIL  envia dados do cliente
            -- 4  Identificacao do cliente nao confere com a do banco.
            IF NEW.IDEEMP IS NOT NULL THEN -- Condico acrescentada para ttulos sem registro a
                                            -- conciliao ser feita pelo NOSNUM
               SELECT CASE COUNT(*) WHEN 0 THEN 4 ELSE 0 END INTO wk_ERRO
                 FROM TT_TIT TIT INNER JOIN TT_VEN VEN ON VEN.CODFIL = TIT.FILREC
                                                      AND VEN.SEQUEN = TIT.SEQREC
                                 INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI
                                                      AND CLI.CODCLI = VEN.CODCLI
                                 LEFT JOIN TT_END ENDE ON ENDE.FILCLI = VEN.FILCLI
                                                      AND ENDE.CODCLI = VEN.CODCLI
                                                      AND ENDE.CODFIL = VEN.FILCOB
                                                      AND ENDE.NUMEND = VEN.ENDCOB
                WHERE TRIM(NEW.IDEEMP) = TRIM(TIT.CODFIL|| '/' ||TRIM(TIT.SEQUEN))
                  AND ( (RPAD(TIT.NOSNUM,20, ' ' ) = RPAD(NEW.NOSNUM,20, ' ' )) OR
                       -- MN - 2023089617 - Na leitura do retorno vem sem dgito, ento retiramos o dgito da TT_TIT para encontrar o ttulo
                        (RPAD(substr(TIT.NOSNUM, 1, length(TIT.NOSNUM) - 1),20, ' ' ) = RPAD(NEW.NOSNUM,20, ' ' ))
                      )
                  AND (Equal(TO_NUMBER(TIT.CODBCO), COALESCE(NEW.CBANCO,TO_NUMBER(TIT.CODBCO))) = 1) -- RFMP 67815
                  AND (Equal(TO_NUMBER(TIT.NUMAGE), COALESCE(NEW.CODAGE,TO_NUMBER(TIT.NUMAGE))) = 1)
                  AND (Equal(TO_NUMBER(TIT.CTACRR), COALESCE(NEW.COD_CC,TO_NUMBER(TIT.CTACRR))) = 1)
                  AND (
                       (LPAD(TRIM(TO_CHAR(NEW.DOCCLI)),15, '0' ) = LPAD(TRIM(CLI.NUMDOC),15, '0' ))
                       OR
                       (LPAD(TRIM(TO_CHAR(NEW.DOCCLI)),15, '0' ) = LPAD(TRIM(ENDE.NUMDOC),15, '0' ))
                      );
            ELSE
               SELECT CASE COALESCE(COUNT(*),0) WHEN 0 THEN 4
                                                  ELSE 0
                      END INTO wk_ERRO
                 FROM TT_TIT TIT INNER JOIN TT_VEN VEN ON VEN.CODFIL = TIT.FILREC
                                                      AND VEN.SEQUEN = TIT.SEQREC
                                 INNER JOIN TT_CLI CLI ON CLI.FILCLI = VEN.FILCLI
                                                      AND CLI.CODCLI = VEN.CODCLI
                                 LEFT JOIN TT_END ENDE ON ENDE.FILCLI = VEN.FILCLI
                                                      AND ENDE.CODCLI = VEN.CODCLI
                                                      AND ENDE.CODFIL = VEN.FILCOB
                                                      AND ENDE.NUMEND = VEN.ENDCOB
                WHERE RPAD(TIT.NOSNUM,20, ' ' ) = RPAD(NEW.NOSNUM,20, ' ' )
                  AND (Equal(TO_NUMBER(TIT.CODBCO), COALESCE(NEW.CBANCO,TO_NUMBER(TIT.CODBCO))) = 1) -- RFMP 67815
                  AND (Equal(TO_NUMBER(TIT.NUMAGE), COALESCE(NEW.CODAGE,TO_NUMBER(TIT.NUMAGE))) = 1)
                  AND (Equal(TO_NUMBER(TIT.CTACRR), COALESCE(NEW.COD_CC,TO_NUMBER(TIT.CTACRR))) = 1)
                  AND (
                       (LPAD(TRIM(TO_CHAR(NEW.DOCCLI)),15, '0' ) = LPAD(TRIM(CLI.NUMDOC),15, '0' ))
                       OR
                       (LPAD(TRIM(TO_CHAR(NEW.DOCCLI)),15, '0' ) = LPAD(TRIM(ENDE.NUMDOC),15, '0' ))
                      );
            END IF;
         END IF;
         NEW.CODERR := Wk_ERRO;
         IF wk_ERRO = 0 THEN
            -- pegando flag atual
            IF NEW.IDEEMP IS NOT NULL THEN -- Condico acrescentada para ttulos sem registro a
                                            -- conciliao ser feita pelo NOSNUM
               SELECT TIT.FILREC, TIT.SEQREC, TIT.PARREC, TIT.SUBREC, TIT.FLGEST, CCB.DEDTAX
                 INTO WK_FILREC, WK_SEQREC, WK_PARREC, WK_SUBREC , WK_FLGEST, WK_DEDTAX
                 FROM TT_TIT TIT
                 JOIN TT_CCB CCB ON TIT.CODBCO = CCB.CODBCO AND TIT.CODCCB = CCB.CODCCB
                WHERE TRIM(NEW.IDEEMP) = TRIM(TIT.CODFIL|| '/' ||TRIM(TIT.SEQUEN));
            ELSE
                                 SELECT TIT.FILREC, TIT.SEQREC, TIT.PARREC, TIT.SUBREC, TIT.FLGEST, CCB.DEDTAX
                    INTO WK_FILREC, WK_SEQREC, WK_PARREC, WK_SUBREC , WK_FLGEST, WK_DEDTAX
                    FROM TT_TIT TIT
                    JOIN TT_CCB CCB ON TIT.CODBCO = CCB.CODBCO AND TIT.CODCCB = CCB.CODCCB
                   WHERE RPAD(TIT.NOSNUM,20, ' ' ) = RPAD(NEW.NOSNUM,20, ' ' )
                     AND (Equal(TO_NUMBER(TIT.CODBCO), COALESCE(NEW.CBANCO,TO_NUMBER(TIT.CODBCO))) = 1) -- RFMP 67815
                     AND (Equal(TO_NUMBER(TIT.NUMAGE), COALESCE(NEW.CODAGE,TO_NUMBER(TIT.NUMAGE))) = 1)
                     AND (Equal(TO_NUMBER(TIT.CTACRR), COALESCE(NEW.COD_CC,TO_NUMBER(TIT.CTACRR))) = 1);
                           END IF;
            IF (WK_FLGEST IS NOT NULL) THEN
               SELECT FLGEST
                 INTO WK_REC_FLGEST
                 FROM TT_REC
                WHERE CODFIL = WK_FILREC
                  AND SEQUEN = WK_SEQREC
                  AND NUMPAR = WK_PARREC
                  AND SUBPAR = WK_SUBREC;
            END IF;

            NEW.FLGEST :=  'P' ;
            IF (WK_FLGEST IS NOT NULL) AND (WK_FLGEST not in ( 'C' , 'P' ) ) THEN
               -- Atualiza Titulo
               IF NEW.IDEEMP IS NOT NULL THEN -- Condico acrescentada para ttulos sem registro a
                                                -- conciliao ser feita pelo NOSNUM
                  UPDATE TT_TIT SET VLRIOF = NEW.VLRIOF,
                                    AGECOB = CASE NEW.AGECOB WHEN 0 THEN AGECOB ELSE NEW.AGECOB END,
                                    DIGCOB = CASE NEW.DIGACC WHEN 0 THEN DIGCOB ELSE CAST(NEW.DIGACC AS CHAR) END,
                                    DUMMY  = Constante( 'VEM_DE_TGRTB' )
                   WHERE TRIM(NEW.IDEEMP) = TRIM(CODFIL|| '/' ||TRIM(SEQUEN));
               ELSE
                  UPDATE TT_TIT SET VLRIOF = NEW.VLRIOF,
                                    AGECOB = CASE NEW.AGECOB WHEN 0 THEN AGECOB
                                                              ELSE NEW.AGECOB
                                             END,
                                    DIGCOB = CASE NEW.DIGACC WHEN 0 THEN DIGCOB
                                                                     ELSE CAST(NEW.DIGACC AS CHAR)
                                             END,
                                    DUMMY  = Constante( 'VEM_DE_TGRTB' )
                   WHERE RPAD(NOSNUM,20, ' ' ) = RPAD(NEW.NOSNUM,20, ' ' )
                     AND (Equal(TO_NUMBER(CODBCO), COALESCE(NEW.CBANCO,TO_NUMBER(CODBCO))) = 1) -- RFMP 67815
                     AND (Equal(TO_NUMBER(NUMAGE), COALESCE(NEW.CODAGE,TO_NUMBER(NUMAGE))) = 1)
                     AND (Equal(TO_NUMBER(CTACRR), COALESCE(NEW.COD_CC,TO_NUMBER(CTACRR))) = 1);
               END IF;
            END IF;
            IF (WK_FLGEST IS NOT NULL) AND (WK_FLGEST not in ( 'C' , 'P' )) OR (WK_REC_FLGEST =  'A' ) THEN
                              
                  WK_NOVAFLGEST :=  ' ' ;
                  SELECT MIN(FLGNEW) INTO WK_NOVAFLGEST
                    FROM TD_RET
                   WHERE (CODTAB) IN (SELECT CODRET FROM TT_RET
                                       WHERE CODBCO = LPAD(TO_CHAR(NEW.CBANCO),3, '0' )
                                         AND RETBCO = NEW.CODMOV);
               
               -- Atualiza REC, esta atualizaao nao ira atualizar o Titulo novamente.
               IF WK_NOVAFLGEST IS NOT NULL THEN
                  --if ( (NEW.VLRCRE <> 0) AND (WK_NOVAFLGEST <>  'I' ) )
                  --OR ( (WK_NOVAFLGEST =  'P' ) AND (NEW.VLRPAG <> 0) AND (NEW.DATCRE IS NOT NULL) )THEN
                  IF COALESCE(WK_NOVAFLGEST, ' ' ) =  'P'
                  --AND (NEW.DATCRE IS NOT NULL)
                  --AND (NEW.VLRCRE <> 0)
                  --AND (NEW.VLRPAG <> 0)
                  THEN
                     nValorBanco := 0;
                     IF COALESCE(NVLZ(NEW.VLRCRE,NEW.VLRPAG),0) > 0 THEN
                        nValorBanco := COALESCE(NVLZ(NEW.VLRCRE,NEW.VLRPAG),0);
                        IF WK_DEDTAX =  'T' THEN
                           nValorBanco := nValorBanco - COALESCE(NEW.VLRTAR,0);
                        END IF;
                     END IF;

                     select * into Logon from DadosLogon();
                     IF NOT Logon.Encontrou THEN
                        RAISE EXCEPTION 'PG-20040 Voce nao e um usuario cadastrado no sistema [TT_RTB]. %' , vComplemento;
                     END IF;

                     -- Pagamento da Parcela
                     IF NEW.IDEEMP IS NOT NULL THEN
                        UPDATE TT_REC
                           SET --PAGAME = NEW.DATCRE,
                               PAGAME = NEW.DATOCO,
                               DATFIS = COALESCE(NEW.DATCRE,NEW.DATOCO),  --56483
                               VLRPGT = NVLZ(nValorBanco, VLRPAR - COALESCE(NEW.VLRTAR,0)),
                               VLRTAX = NEW.VLRTAR,
                               VLRDES = CASE WHEN nValorBanco = 0 THEN 0 ELSE nValorBanco + COALESCE(NEW.VLRTAR,0) - VLRPAR END,
                               FLGEST = 'P',
                               DUMMY = Constante( 'VEM_DE_TGRTB' ),
                               FILREC = NEW.CODFIL,
                               NUMECF = '000',
                               FILUSU = Logon.FILUSU,
                               CODUSU = Logon.CODUSU
                         WHERE (CODFIL,SEQUEN,NUMPAR,SUBPAR) IN (
                           SELECT FILREC,SEQREC,PARREC,SUBREC FROM TT_TIT TIT
                           WHERE TRIM(NEW.IDEEMP) = TRIM(TIT.CODFIL|| '/' ||TRIM(TIT.SEQUEN)) )
                           AND FLGEST =  'A' ;
                     ELSE
                        UPDATE TT_REC
                           SET --PAGAME = NEW.DATCRE,
                               PAGAME = NEW.DATOCO,
                               DATFIS = COALESCE(NEW.DATCRE,NEW.DATOCO),  --56483
                               VLRPGT = NVLZ(nValorBanco, VLRPAR - COALESCE(NEW.VLRTAR,0)),
                               VLRTAX = NEW.VLRTAR,
                               VLRDES = CASE WHEN nValorBanco = 0 THEN 0 ELSE nValorBanco + COALESCE(NEW.VLRTAR,0) - VLRPAR END,
                               FLGEST =  'P',
                               DUMMY = Constante( 'VEM_DE_TGRTB' ),
                               FILREC = NEW.CODFIL,
                               NUMECF =  '000',
                               FILUSU = Logon.FILUSU,
                               CODUSU = Logon.CODUSU
                         WHERE (CODFIL,SEQUEN,NUMPAR,SUBPAR) IN (
                                SELECT FILREC,SEQREC,PARREC,SUBREC FROM TT_TIT TIT
                                 WHERE RPAD(TIT.NOSNUM,20, ' ' ) = RPAD(NEW.NOSNUM,20, ' ' )
                                   AND (Equal(TO_NUMBER(TIT.CODBCO), COALESCE(NEW.CBANCO,TO_NUMBER(TIT.CODBCO))) = 1) -- RFMP 67815
                                   AND (Equal(TO_NUMBER(TIT.NUMAGE), COALESCE(NEW.CODAGE,TO_NUMBER(TIT.NUMAGE))) = 1)
                                   AND (Equal(TO_NUMBER(TIT.CTACRR), COALESCE(NEW.COD_CC,TO_NUMBER(TIT.CTACRR))) = 1)
                                 )
                           AND FLGEST =  'A' ;
                     END IF;
                     -- Pagamento do Ttulo
                     IF NEW.IDEEMP IS NOT NULL THEN
                        UPDATE TT_TIT
                           SET FLGEST =  'P' ,
                               DUMMY = Constante( 'VEM_DE_TGRTB' )
                         WHERE TRIM(NEW.IDEEMP) = TRIM(CODFIL|| '/' ||TRIM(SEQUEN))
                           AND FLGEST NOT IN ( 'P' , 'C' );
                     ELSE
                        UPDATE TT_TIT
                           SET FLGEST =  'P' ,
                               DUMMY = Constante( 'VEM_DE_TGRTB' )
                         WHERE RPAD(NOSNUM,20, ' ' ) = RPAD(NEW.NOSNUM,20, ' ' )
                           AND (Equal(TO_NUMBER(CODBCO), COALESCE(NEW.CBANCO,TO_NUMBER(CODBCO))) = 1) -- RFMP 67815
                           AND (Equal(TO_NUMBER(NUMAGE), COALESCE(NEW.CODAGE,TO_NUMBER(NUMAGE))) = 1)
                           AND (Equal(TO_NUMBER(CTACRR), COALESCE(NEW.COD_CC,TO_NUMBER(CTACRR))) = 1)
                           AND FLGEST NOT IN ( 'P' , 'C' );
                     END IF;
                  ELSE -- Atualiza situao do ttulo (situaes diferentes de Pago)
                     IF NEW.IDEEMP IS NOT NULL THEN
                        UPDATE TT_TIT
                           SET FLGEST = WK_NOVAFLGEST,
                               DUMMY = Constante( 'VEM_DE_TGRTB' )
                         WHERE TRIM(NEW.IDEEMP) = TRIM(CODFIL|| '/' ||TRIM(SEQUEN))
                           AND FLGEST NOT IN ( 'C' , 'P' );
                     ELSE
                        UPDATE TT_TIT
                           SET FLGEST = WK_NOVAFLGEST,
                               DUMMY = Constante( 'VEM_DE_TGRTB' )
                         WHERE RPAD(NOSNUM,20, ' ' ) = RPAD(NEW.NOSNUM,20, ' ' )
                           AND (Equal(TO_NUMBER(CODBCO), COALESCE(NEW.CBANCO,TO_NUMBER(CODBCO))) = 1) -- RFMP 67815
                           AND (Equal(TO_NUMBER(NUMAGE), COALESCE(NEW.CODAGE,TO_NUMBER(NUMAGE))) = 1)
                           AND (Equal(TO_NUMBER(CTACRR), COALESCE(NEW.COD_CC,TO_NUMBER(CTACRR))) = 1)
                           AND FLGEST NOT IN ( 'C' , 'P' );
                     END IF;
                  END IF; -- Nova situao  "P"
               END IF; -- Novo FLGEST is not null
            END IF; -- IF (WK_FLGEST IS NOT NULL) AND (WK_FLGEST not in ( 'C' , 'P' ) ) THEN
         END IF; -- IF wk_ERRO = 0 THEN
      END IF;

      -- Update para atualizar situao da venda aps o processamento do retorno
      IF ISNULL(WK_FILREC) = 'F' THEN
         UPDATE TT_VEN
            SET FLGEST = 'Y',
                DUMMY = CONSTANTE('VEM_DE_TGRTB')
          WHERE CODFIL = WK_FILREC
            AND SEQUEN = WK_SEQREC;
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5086 --*/
CREATE TRIGGER TGRTB
BEFORE INSERT OR UPDATE OR DELETE ON TT_RTB 
FOR EACH ROW EXECUTE PROCEDURE TGRTB();


/*-- SEQ 5087 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRTT() CASCADE;

/*-- SEQ 5088 --*/
CREATE OR REPLACE FUNCTION TGRTT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
BEGIN
   -- Trata dados padroes na inclusao
   IF (TG_OP = 'INSERT') THEN
      IF ISNULL(NEW.SEQUEN)='T' THEN
         NEW.SEQUEN:=ProximoCodigo('TT_RTT',NEW.CODFIL);
      END IF;
      NEW.DATINC := agora();
   END IF;

   -- Popula a coluna ATU_EM
   IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
      NEW.ATU_EM := agora();
   END IF;

   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser excluido';
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5089 --*/
CREATE TRIGGER TGRTT
BEFORE INSERT OR UPDATE ON TT_RTT 
FOR EACH ROW EXECUTE PROCEDURE TGRTT();

/*-- SEQ 5090 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRTT2() CASCADE;

/*-- SEQ 5091 --*/
CREATE OR REPLACE FUNCTION TGRTT2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 2) Registrar mudanca dos dados num "log"
   vLOG                          VARCHAR(4000)     := '';
   vFILUSU                       VARCHAR(3);
   vCODUSU                       VARCHAR(3);
   cNulo                         CONSTANT CHAR(1)   := '0';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
      WK_CODUID                     TT_UID.CODUID%TYPE;
   cDUMMY                        VARCHAR(20);
BEGIN

   IF (TG_OP = 'INSERT') THEN
      cDUMMY:=INSERE_LFIN_LAN('RTT',NEW.CODFIL,NEW.SEQUEN,'--','--');
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF (Equal(OLD.DATOPE,NEW.DATOPE) <> 1) OR
         (Equal(OLD.VLRPGT,NEW.VLRPGT) <> 1) OR
         (Equal(OLD.DATEST,NEW.DATEST) <> 1) OR
         (Equal(OLD.TIPRTT,NEW.TIPRTT) <> 1) THEN
         cDUMMY:=INSERE_LFIN_LAN('RTT',NEW.CODFIL,NEW.SEQUEN,'--','--');
      END IF;
   END IF;

   WK_CODUID := GetCoduidAtual();

  select * into QuemLogou from DadosLogon();
  vFILUSU := QuemLogou.FILUSU;
  vCODUSU := QuemLogou.CODUSU;

  -- Tratamento de log
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
         vLOG := vLOG||'Cdigo da Filial: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
         vLOG := vLOG||'Sequenciador: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODAVU,NEW.CODAVU) <> 1 THEN
         vLOG := vLOG||'Cdigo Avulso "Nmero do Documento": de '||COALESCE(OLD.CODAVU,cNulo)||' para '||COALESCE(NEW.CODAVU,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TIPRTT,NEW.TIPRTT) <> 1 THEN
         vLOG := vLOG||'Convnios de Recebimentos de Ttulos de Terceiros: de '||COALESCE(TO_CHAR(OLD.TIPRTT,'Nulo'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.TIPRTT,'Nulo'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CONTRA,NEW.CONTRA) <> 1 THEN
         vLOG := vLOG||'Nmero do Contrato: de '||COALESCE(OLD.CONTRA,cNulo)||' para '||COALESCE(NEW.CONTRA,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NUMPAR,NEW.NUMPAR) <> 1 THEN
         vLOG := vLOG||'Nmero da Parcela: de '||COALESCE(OLD.NUMPAR,cNulo)||' para '||COALESCE(NEW.NUMPAR,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DATVEN,NEW.DATVEN) <> 1 THEN
         vLOG := vLOG||'Data do Vencimento: de '||COALESCE(to_char(OLD.DATVEN,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.DATVEN,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DATPGT,NEW.DATPGT) <> 1 THEN
         vLOG := vLOG||'Data do Pagamento: de '||COALESCE(to_char(OLD.DATPGT,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.DATPGT,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DATOPE,NEW.DATOPE) <> 1 THEN
         vLOG := vLOG||'Data e Hora da Transao: de '||COALESCE(to_char(OLD.DATOPE,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(to_char(NEW.DATOPE,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRPAR,NEW.VLRPAR) <> 1 THEN
         vLOG := vLOG||'Valor da Parcela: de '||COALESCE(OLD.VLRPAR,0)||' para '||COALESCE(NEW.VLRPAR,0)||CRLF;
      END IF;
      IF Equal(OLD.VLRPGT,NEW.VLRPGT) <> 1 THEN
         vLOG := vLOG||'Valor do Pagamento: de '||COALESCE(OLD.VLRPGT,0)||' para '||COALESCE(NEW.VLRPGT,0)||CRLF;
      END IF;
      IF Equal(OLD.CUPFIS,NEW.CUPFIS) <> 1 THEN
         vLOG := vLOG||'Nmero do Cupom Fiscal: de '||COALESCE(OLD.CUPFIS,cNulo)||' para '||COALESCE(NEW.CUPFIS,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NUMECF,NEW.NUMECF) <> 1 THEN
         vLOG := vLOG||'Nmero do ECF: de '||COALESCE(OLD.NUMECF,cNulo)||' para '||COALESCE(NEW.NUMECF,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILUSU,NEW.FILUSU) <> 1 THEN
         vLOG := vLOG||'Filial do Usurio que Recebeu: de '||COALESCE(OLD.FILUSU,cNulo)||' para '||COALESCE(NEW.FILUSU,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODUSU,NEW.CODUSU) <> 1 THEN
         vLOG := vLOG||'Cdigo do Usurio que Recebeu: de '||COALESCE(OLD.CODUSU,cNulo)||' para '||COALESCE(NEW.CODUSU,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.AUTORI,NEW.AUTORI) <> 1 THEN
         vLOG := vLOG||'Nmero de Autorizao: de '||COALESCE(OLD.AUTORI,cNulo)||' para '||COALESCE(NEW.AUTORI,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
         vLOG := vLOG||'Estado do Recebimento: de '||COALESCE(OLD.FLGEST,cNulo)||' para '||COALESCE(NEW.FLGEST,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODBAR,NEW.CODBAR) <> 1 THEN
         vLOG := vLOG||'Cdigo de Barras: de '||COALESCE(OLD.CODBAR,cNulo)||' para '||COALESCE(NEW.CODBAR,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRDES,NEW.VLRDES) <> 1 THEN
         vLOG := vLOG||'Valor de Desconto: de '||COALESCE(OLD.VLRDES,0)||' para '||COALESCE(NEW.VLRDES,0)||CRLF;
      END IF;
      IF Equal(OLD.VLRACR,NEW.VLRACR) <> 1 THEN
         vLOG := vLOG||'Valor de Acrscimo: de '||COALESCE(OLD.VLRACR,0)||' para '||COALESCE(NEW.VLRACR,0)||CRLF;
      END IF;
      IF Equal(OLD.NUMDOC,NEW.NUMDOC) <> 1 THEN
         vLOG := vLOG||'Nmero do Documento: de '||COALESCE(OLD.NUMDOC,cNulo)||' para '||COALESCE(NEW.NUMDOC,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODBCO,NEW.CODBCO) <> 1 THEN
         vLOG := vLOG||'Cdigo do Banco: de '||COALESCE(OLD.CODBCO,cNulo)||' para '||COALESCE(NEW.CODBCO,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TRN_ID,NEW.TRN_ID) <> 1 THEN
         vLOG := vLOG||'ID Transao: de '||COALESCE(OLD.TRN_ID,iNulo)||' para '||COALESCE(NEW.TRN_ID,iNulo)||CRLF;
      END IF;

      -- Rhuan - 101157 - Log para observao gravado em registro exclusivo para evitar estouro do tamanho da coluna.
      IF (COALESCE(OLD.OBSERV,'XXX') <> COALESCE(NEW.OBSERV,'XXX')) AND (ISNULL(OLD.OBSERV) = 'F') THEN
        INSERT INTO TL_RTT (FILRTT,SEQRTT,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                    VALUES (NEW.CODFIL,NEW.SEQUEN,agora(),vFILUSU,vCODUSU,OLD.OBSERV,WK_CODUID);
      END IF;

      IF ISNOTNULL(trim(vLOG)) = 'T' THEN
         -- cadastra o LOG.
         INSERT INTO TL_RTT (FILRTT,SEQRTT,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                     VALUES (NEW.CODFIL,NEW.SEQUEN,agora(),vFILUSU,vCODUSU,vLOG,WK_CODUID);
      END IF;
   END IF;

   -- Paulo K. - 88173
   IF (TG_OP = 'INSERT') THEN
      -- Vincula a TT_RTT com a TT_SAV e coloca a TT_SAV como "Faturado".
      IF ISNULL(NEW.CODBAR)='F' THEN
         UPDATE TT_SAV
            SET FILRTT = NEW.CODFIL,
                SEQRTT = NEW.SEQUEN
               /* RFMP atualizado pelo Checkout
               ,FLGEST = 'F'
               */
         WHERE TRIM(CODAVU) = TRIM(NEW.CODAVU);
      END IF;
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      -- Em caso de estorno da RTT, volta o servio para "Aberto" e remove o vinculo TT_SAV > TT_RTT.
      IF NEW.FLGEST = 'E' THEN
         UPDATE TT_SAV
            SET FILRTT = NULL,
                SEQRTT = NULL,
                FLGEST = 'A'
         WHERE FILRTT = NEW.CODFIL
         AND SEQRTT = NEW.SEQUEN;
      END IF;
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5092 --*/
CREATE TRIGGER TGRTT2
AFTER INSERT OR UPDATE OR DELETE ON TT_RTT 
FOR EACH ROW EXECUTE PROCEDURE TGRTT2();


/*-- SEQ 5093 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGREQXWOR() CASCADE;

/*-- SEQ 5094 --*/
CREATE OR REPLACE FUNCTION TGREQXWOR() RETURNS TRIGGER AS $$
DECLARE
-- Tabela Vinculo entre Requisitos
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Atualiza DATINC
-- 3) Atualiza ATU_EM
-- 4) Impedir exclusao
  
  vComplemento  VARCHAR(254) := constante('complemento'); 
  QuemLogou TRetQuemLogou%ROWTYPE;

-- Principal
BEGIN
  IF (TG_OP = 'DELETE') THEN
     RAISE EXCEPTION 'PG-20001 Nao e permitida a exclusao. %' , vComplemento;     
  END IF;

  IF (TG_OP = 'INSERT') THEN
     IF NEW.SEQUEN IS NULL THEN
        NEW.SEQUEN := ProximoCodigo('TT_REQXWOR', NEW.CODFIL);
     END IF;
--     select * into QuemLogou from DadosLogon();
--     NEW.FILUSU := QuemLogou.FILUSU;
--     NEW.CODUSU := QuemLogou.CODUSU;
     NEW.DATINC := AGORA();
  END IF;

  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     NEW.ATU_EM := AGORA();
  END IF;  

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5095 --*/
CREATE TRIGGER TGREQXWOR
BEFORE INSERT OR DELETE OR UPDATE ON TT_REQXWOR 
FOR EACH ROW EXECUTE PROCEDURE TGREQXWOR();


/*-- SEQ 5096 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGRZR() CASCADE;

/*-- SEQ 5097 --*/
CREATE OR REPLACE FUNCTION TGRZR() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
BEGIN
  IF (TG_OP = 'INSERT') THEN
    -- Gera codigo sequencial
    IF (NEW.SEQUEN IS NULL) THEN
      NEW.SEQUEN:=ProximoCodigo('TT_RZR',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5098 --*/
CREATE TRIGGER TGRZR
BEFORE INSERT ON TT_RZR 
FOR EACH ROW EXECUTE PROCEDURE TGRZR();


/*-- SEQ 5099 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGSAD() CASCADE;

/*-- SEQ 5100 --*/
CREATE OR REPLACE FUNCTION TGSAD() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
BEGIN
   -- Trata dados padroes na inclusao
   IF (TG_OP = 'INSERT') THEN
      IF ISNULL(NEW.SEQUEN)='T' THEN
         NEW.SEQUEN:=ProximoCodigo('TT_SAD', NEW.CODFIL);
      END IF;
      NEW.DATINC := agora();
   END IF;

   -- Popula a coluna ATU_EM
   IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
      NEW.ATU_EM := agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5101 --*/
CREATE TRIGGER TGSAD
BEFORE INSERT OR UPDATE ON TT_SAD 
FOR EACH ROW EXECUTE PROCEDURE TGSAD();

/*-- SEQ 5102 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGSAD2() CASCADE;

/*-- SEQ 5103 --*/
CREATE OR REPLACE FUNCTION TGSAD2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo
-- 1) Registrar mudanca dos dados num "log" na TL_GRA

-- Declarao de variveis e cursores
   cLOG                          VARCHAR(4000)     := '';
   cLogChave                     VARCHAR(135)      := '';
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   cFILUSU                       VARCHAR(3);
   cCODUSU                       VARCHAR(3);
   cDESSAD                       TD_SAD.DESSAD%TYPE;
      
   QuemLogou                     TRetQuemLogou%ROWTYPE;
      WK_CODUID                     TT_UID.CODUID%TYPE;
   cRetorno                      VARCHAR(2);
   cWhere                        TM_ATU.FILTRO%TYPE;

-- Principal
BEGIN
   WK_CODUID := GetCoduidAtual();

   select * into QuemLogou from DadosLogon();
   cFILUSU := QuemLogou.FILUSU;
   cCODUSU := QuemLogou.CODUSU;

   -- Em caso de excluso
   IF (TG_OP = 'DELETE') THEN
      SELECT DSAD.DESSAD INTO cDESSAD FROM TD_SAD DSAD WHERE DSAD.CODTAB = OLD.CODSAD;
      cLogChave := 'Servio Adicional ' || cDESSAD || ' [' || OLD.CODFIL || '-' || OLD.SEQUEN || ']';
      cLOG := 'Excluso de ' || cLogChave;
      -- Inclui uma linha em TL_GRA
      INSERT INTO TL_GRA (FILMAT,CODMAT,CODCOR,CODTAM,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                  VALUES (OLD.FILMAT,OLD.CODMAT,OLD.CODCOR,OLD.CODTAM,agora(),cFILUSU,cCODUSU,cLOG,WK_CODUID);
   END IF;

   --Tratamento para Atualizar Tabela Pai
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      cWhere := 'FILMAT = ' || CHR(39) || NEW.FILMAT  || CHR(39) || ' AND CODMAT = ' || CHR(39) || NEW.CODMAT || CHR(39) ||
                ' AND CODCOR = ' || TO_CHAR(NEW.CODCOR) || ' AND CODTAM = ' || TO_CHAR(NEW.CODTAM);
   ELSIF (TG_OP = 'DELETE') THEN
      cWhere := 'FILMAT = ' || CHR(39) || OLD.FILMAT  || CHR(39) || ' AND CODMAT = ' || CHR(39) || OLD.CODMAT || CHR(39) ||
                ' AND CODCOR = ' || TO_CHAR(OLD.CODCOR) || ' AND CODTAM = ' || TO_CHAR(OLD.CODTAM);
   END IF;
   cRetorno := INSERE_MATU('TT_SAD', 'TT_GRA', cWhere);

   -- Tratamento de log
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN
      SELECT DSAD.DESSAD INTO cDESSAD FROM TD_SAD DSAD WHERE DSAD.CODTAB = NEW.CODSAD;
      cLogChave := 'Servio Adicional ' || cDESSAD || ' [' || NEW.CODFIL || '-' || NEW.SEQUEN || ']';
   END IF;
   IF (TG_OP = 'INSERT') THEN
      cLOG := 'Incluso de ' || cLogChave;
   ELSIF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
         cLOG := cLOG||'Filial: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
         cLOG := cLOG||'Sequnciador: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DATINC,NEW.DATINC) <> 1 THEN
         cLOG := cLOG||'Data Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ATU_EM,NEW.ATU_EM) <> 1 THEN
         cLOG := cLOG||'Data da Atualizao: de '||COALESCE(TO_CHAR(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODSAD,NEW.CODSAD) <> 1 THEN
         cLOG := cLOG||'Tipo de Servio Adicional: de '||COALESCE(OLD.CODSAD,iNulo)||' para '||COALESCE(NEW.CODSAD,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILMAT,NEW.FILMAT) <> 1 or Equal(OLD.CODMAT,NEW.CODMAT) <> 1 or
         Equal(OLD.CODCOR,NEW.CODCOR) <> 1 or Equal(OLD.CODTAM,NEW.CODTAM) <> 1 THEN
         cLOG := cLOG||'Produto: de '||COALESCE(OLD.FILMAT,cNulo)||COALESCE(OLD.CODMAT,cNulo)||'-'||COALESCE(to_char(OLD.CODCOR),cNulo)||'-'||COALESCE(to_char(OLD.CODTAM),cNulo)||' para '||
                                       COALESCE(NEW.FILMAT,cNulo)||COALESCE(NEW.CODMAT,cNulo)||'-'||COALESCE(to_char(NEW.CODCOR),cNulo)||'-'||COALESCE(to_char(NEW.CODTAM),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VALSAD,NEW.VALSAD) <> 1 THEN
         cLOG := cLOG||'Valor do Servio (em R$): de '||COALESCE(TO_CHAR(OLD.VALSAD,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VALSAD,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERSAD,NEW.PERSAD) <> 1 THEN
         cLOG := cLOG||'% sobre Preo do Produto: de '||COALESCE(TO_CHAR(OLD.PERSAD,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERSAD,'fm9G999G999G990D00'),cNulo)||CRLF;
      END IF;
      IF (OLD.SIGNAT<0 AND NEW.SIGNAT>=0) THEN
         cLOG := cLOG||'Situao: Ativado'||CRLF;
      END IF;
      IF (OLD.SIGNAT>=0 AND NEW.SIGNAT<0) THEN
         cLOG := cLOG||'Situao: Desativado'||CRLF;
      END IF;
      IF Equal(OLD.CODSEG,NEW.CODSEG) <> 1 THEN
         cLOG := cLOG||'Cdigo na Seguradora: de '||COALESCE(OLD.CODSEG,cNulo)||' para '||COALESCE(NEW.CODSEG,cNulo)||CRLF;
      END IF;

      IF ISNOTNULL(cLOG) = 'T' THEN
         cLOG := cLogChave || ' >> ' || cLOG;
      END IF;
   END IF;
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN
      IF ISNOTNULL(cLOG) = 'T' THEN
         INSERT INTO TL_GRA (FILMAT,CODMAT,CODCOR,CODTAM,DATOPE,FILUSU,CODUSU,MSGLOG,CODUID)
                     VALUES (NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,agora(),cFILUSU,cCODUSU,cLOG,WK_CODUID);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5104 --*/
CREATE TRIGGER TGSAD2
AFTER INSERT OR UPDATE OR DELETE ON TT_SAD 
FOR EACH ROW EXECUTE PROCEDURE TGSAD2();


/*-- SEQ 5105 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGSAL() CASCADE;

/*-- SEQ 5106 --*/
CREATE OR REPLACE FUNCTION TGSAL() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Recalcular saldos automaticamente
-- 3) Impedir exclusao se houver saldo ou reserva para o produto
--
   proximo                       CHAR(10);
   calcula_reserva               BOOLEAN;
   calcula_saldo                 BOOLEAN;

   total_ico                     Numeric;
   total_ive_saldo               Numeric;
   total_ive_reserva             Numeric;
   total_ior_reserva             Numeric;
   total_ior_reserva_kit         Numeric;
   total_lan                     Numeric;

   wk_CODFIL                     TT_SAL.CODFIL%TYPE;
   wk_FILMAT                     TT_SAL.FILMAT%TYPE;
   wk_CODMAT                     TT_SAL.CODMAT%TYPE;
   wk_CODCOR                     TT_SAL.CODCOR%TYPE;
   wk_CODTAM                     TT_SAL.CODTAM%TYPE;
   wk_CODMUL                     TT_SAL.CODMUL%TYPE;

   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');
   cLOG                          VARCHAR(4000)     := '';
   cNulo                         CONSTANT CHAR(4)   := 'Nulo'; 
   iNulo                         CONSTANT Numeric(1) := 0;  
   CRLF                          CONSTANT CHAR(1)   := CHR(10);
   cNOMFIL                       TD_FIL.NOMFIL%TYPE;
   cDESMUL                       TD_MUL.DESMUL%TYPE;
  
   --LEO 84337
   vSESSIONID                    TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');
  
  -- RFMP 85136
   WK_UID                        TPC_UID_Retorno%ROWTYPE;
  

-- Principal
BEGIN
  
   IF ((TG_OP = 'UPDATE')) or ((TG_OP = 'INSERT')) THEN  
      NEW.CAL_CM := TRUNC(NEW.CAL_CM);
   END IF;

   IF ((TG_OP = 'UPDATE')) OR ((TG_OP = 'INSERT')) THEN  
      NEW.ATU_EM := agora();
   END IF;

   ---- RFMP 70324 atualizar o custo medio caso alguma dessas colunas for alterada
   IF (TG_OP = 'UPDATE') THEN 
      IF (Equal(NEW.INI_CM,OLD.INI_CM) <> 1) 
      OR (Equal(NEW.QTD_CM,OLD.QTD_CM) <> 1) 
      OR (Equal(NEW.VLR_CM,OLD.VLR_CM) <> 1) 
      OR (Equal(NEW.VLRCMG,OLD.VLRCMG) <> 1) THEN
         NEW.CAL_CM := NULL;
         NEW.ATU_CM := 'F';
      END IF;
   END IF;

   IF (TG_OP = 'UPDATE') THEN 
      IF NEW.CODMUL=0 THEN 
         IF OLD.ATU_CM='F' AND NEW.ATU_CM='T' THEN
            IF (COALESCE(NEW.CAL_CM,TO_DATE('01/01/1900','DD/MM/YYYY'))<>TRUNC(add_day(agora(),1))) or
               (COALESCE(NEW.DUMMY,'XX')<>constante('vem_de_calcusmed')) THEN
               RAISE EXCEPTION 'PG-20018 Nao e permitido colocar como calculado manualmente. %' , VComplemento;
            END IF;
         ELSIF (OLD.ATU_CM='T') AND (NEW.ATU_CM='T') THEN
            IF Equal(NEW.CAL_CM,OLD.CAL_CM) <> 1 THEN
               RAISE EXCEPTION 'PG-20019 Ao alterar a data de calculo deve-se colocar como nao calculado. %' , VComplemento;
            END IF;
         ELSIF (COALESCE(NEW.CAL_CM,TO_DATE('01/01/1900','DD/MM/YYYY'))) >
               (COALESCE(OLD.CAL_CM,TO_DATE('01/01/1900','DD/MM/YYYY'))) THEN
            RAISE EXCEPTION 'PG-20020 Data somente pode ser adiantada se custo estiver como calculado. %' , VComplemento;
         END IF;
      END IF;
   END IF;  

   -- Impede a alteracao de determinadas colunas
   IF ((TG_OP = 'UPDATE')) THEN
      IF (OLD.SEQUEN <> NEW.SEQUEN) OR
         (OLD.FILMAT <> NEW.FILMAT) OR
         (OLD.CODMAT <> NEW.CODMAT) OR
         (OLD.CODCOR <> NEW.CODCOR) OR
         (OLD.CODTAM <> NEW.CODTAM) OR
         (OLD.CODMUL <> NEW.CODMUL) THEN
         RAISE EXCEPTION 'PG-20017 Tentativa de mudar dados que sao apenas de leitura. %' , VComplemento;
      END IF;
   END IF;

   IF (TG_OP = 'INSERT') THEN
      wk_CODFIL := NEW.CODFIL;
      wk_FILMAT := NEW.FILMAT;
      wk_CODMAT := NEW.CODMAT;
      wk_CODCOR := NEW.CODCOR;
      wk_CODTAM := NEW.CODTAM;
      wk_CODMUL := NEW.CODMUL;
   ELSIF (TG_OP = 'UPDATE') THEN
      wk_CODFIL := OLD.CODFIL;
      wk_FILMAT := OLD.FILMAT;
      wk_CODMAT := OLD.CODMAT;
      wk_CODCOR := OLD.CODCOR;
      wk_CODTAM := OLD.CODTAM;
      wk_CODMUL := OLD.CODMUL;
   END IF;

   -- Verifica as condicoes para o calculo/recalculo dos saldos
   Calcula_reserva := False;
   Calcula_saldo   := False;

   IF ((TG_OP = 'UPDATE')) THEN
      IF (NEW.DUMMY IS NULL) THEN
         IF (OLD.QTDEST <> NEW.QTDEST) THEN
            calcula_saldo   := True;
         END IF;
         IF Equal(OLD.RESERV,NEW.RESERV) <> 1 THEN
            calcula_reserva := True;
         END IF;
      END IF;
   END IF;
   
   -- Tratamento de log
   IF ((TG_OP = 'UPDATE')) THEN
      IF Equal(OLD.LOCAL1,NEW.LOCAL1) <> 1 THEN
         cLOG := cLOG||'Localizao 1: de '||COALESCE(OLD.LOCAL1,cNulo)||' para '||COALESCE(NEW.LOCAL1,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.LOCAL2,NEW.LOCAL2) <> 1 THEN
         cLOG := cLOG||'Localizao 2: de '||COALESCE(OLD.LOCAL2,cNulo)||' para '||COALESCE(NEW.LOCAL2,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.LOCAL3,NEW.LOCAL3) <> 1 THEN
         cLOG := cLOG||'Localizao 3: de '||COALESCE(OLD.LOCAL3,cNulo)||' para '||COALESCE(NEW.LOCAL3,cNulo)||CRLF;   
      END IF; 
      IF Equal(OLD.INI_CM,NEW.INI_CM) <> 1 THEN
         cLOG := cLOG||'Data Ini.Custo Mdio: de '||COALESCE(TO_CHAR(OLD.INI_CM,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.INI_CM,'DD/MM/YYYY'),cNulo)||CRLF;   
      END IF; 
      IF Equal(OLD.QTD_CM,NEW.QTD_CM) <> 1 THEN
         cLOG := cLOG||'Qtde Ini. Custo Mdio: de '||COALESCE(OLD.QTD_CM,iNulo)||' para '||COALESCE(NEW.QTD_CM,iNulo)||CRLF;   
      END IF; 
      IF Equal(OLD.VLR_CM,NEW.VLR_CM) <> 1 THEN
         cLOG := cLOG||'Valor Ini. Cust. Med. Fis: de '||COALESCE(OLD.VLR_CM,iNulo)||' para '||COALESCE(NEW.VLR_CM,iNulo)||CRLF;   
      END IF; 
      IF Equal(OLD.VLRCMG,NEW.VLRCMG) <> 1 THEN
         cLOG := cLOG||'Valor Ini. Cust. Md. Ger: de '||COALESCE(OLD.VLRCMG,iNulo)||' para '||COALESCE(NEW.VLRCMG,iNulo)||CRLF;   
      END IF; 
      IF Equal(OLD.QTDMAX,NEW.QTDMAX) <> 1 THEN
         cLOG := cLOG||'Quantidade maxima: de '||COALESCE(OLD.QTDMAX,iNulo)||' para '||COALESCE(NEW.QTDMAX,iNulo)||CRLF;   
      END IF; 
      IF Equal(OLD.MOT_CM,NEW.MOT_CM) <> 1 THEN
         cLOG := cLOG||'Motivo para custo mdio inicial: de '||COALESCE(OLD.MOT_CM,cNulo)||' para '||COALESCE(NEW.MOT_CM,cNulo)||CRLF;   
      END IF; 
      IF Equal(OLD.MOVEST,NEW.MOVEST) <> 1 THEN
         cLOG := cLOG||'Movimentar estoque: de '||COALESCE(OLD.MOVEST,cNulo)||' para '||COALESCE(NEW.MOVEST,cNulo)||CRLF;   
      END IF; 
      IF Equal(OLD.FLGATI,NEW.FLGATI) <> 1 THEN
         cLOG := cLOG||'Ativo na Filial?: de '||COALESCE(OLD.FLGATI,cNulo)||' para '||COALESCE(NEW.FLGATI,cNulo)||CRLF;   
      END IF; 
      IF Equal(OLD.DISMINZER,NEW.DISMINZER) <> 1 THEN
         cLOG := cLOG||' Distribuio quando quantidade mnima Zero?: de '||COALESCE(OLD.DISMINZER,cNulo)||' para '||COALESCE(NEW.DISMINZER,cNulo)||CRLF;   
      END IF; 
      
           
      IF ISNOTNULL(TRIM(cLOG)) = 'T' THEN 
         SELECT DFIL.NOMFIL INTO cNOMFIL FROM TD_FIL DFIL WHERE DFIL.CODFIL = NEW.CODFIL;
         SELECT DMUL.DESMUL INTO cDESMUL FROM TD_MUL DMUL WHERE DMUL.CODTAB = NEW.CODMUL;
         cLOG := 'Filial: ' || cNOMFIL || ', Estoque: ' || cDESMUL || ' >> ' || cLOG;         
         INSERT INTO TL_GRA (FILMAT,CODMAT,CODCOR,CODTAM,DATOPE,MSGLOG)
                     VALUES (NEW.FILMAT,NEW.CODMAT,NEW.CODCOR,NEW.CODTAM,agora(),cLOG);
      END IF;
   END IF;

   -- Gera um codigo automaticamente
   IF (TG_OP = 'INSERT') THEN
      NEW.SEQUEN := ProximoCodigo('TT_SAL',NEW.CODFIL);
      NEW.QTDEST := COALESCE(NEW.QTDEST,0);
      NEW.RESERV := COALESCE(NEW.RESERV,0);
   -- Nao deixa o sequenciador permanecer negativo
   ELSIF (TG_OP = 'DELETE') THEN
      IF (COALESCE(OLD.QTDEST,0) <> 0) OR (COALESCE(OLD.RESERV,0) <> 0) THEN
         RAISE EXCEPTION 'PG-20016 Ainda ha saldo ou reserva para este produto. %' , vComplemento;
      END IF;
   END IF;
  
   IF (TG_OP = 'UPDATE') THEN
      IF (OLD.MOVEST != NEW.MOVEST) THEN
         IF ((OLD.MOVEST = 'T') AND
            (NEW.MOVEST = 'F')) THEN
            NEW.QTDEST     := 0;
            Calcula_reserva := False;
            Calcula_saldo   := False;
         END IF;
      END IF;
   END IF;

   -- Manda realizar o calculo/recalculo
   -- **********************************
   -- ******* Calculo de SALDO *********
   -- **********************************

   IF calcula_RESERVA THEN

      -- Reserva (IVE)
      -- RFMP 65536 PCIA Verifica se deve reservar venda
      IF ReservaVenda() = 'T' THEN
         -- RFMP 80324
         -- RFMP 78593                 
         -- Ao efetivar a venda de Entrega Futura o sistema deve reservar a mercadoria.
         -- Sistema no deve reservar em caso de Venda sob Encomenda.    
         SELECT COALESCE(SUM(COALESCE(IVE.QTDPEN,0)-
                                CASE WHEN CFG.RESERVA_ENT_FUT = 'T'
                                      AND IVE.FLGFUT <> 'E'
                                     THEN 0
                                     ELSE COALESCE(IVE.QTDFUT,0) 
                                END),0) 
           INTO total_ive_reserva
           FROM TT_CFG CFG,
                TT_IVE IVE INNER JOIN TT_PRO PRO ON IVE.FILMAT = PRO.FILMAT
                                                AND IVE.CODMAT = PRO.CODMAT
          WHERE COALESCE(IVE.FILRES, IVE.CODFIL) = wk_CODFIL
            AND IVE.FILMAT = wk_FILMAT
            AND IVE.CODMAT = wk_CODMAT
            AND IVE.CODCOR = wk_CODCOR
            AND IVE.CODTAM = wk_CODTAM
            AND IVE.CODMUL = wk_CODMUL
            AND IVE.VEN_DATHOR > COALESCE( CFG.IGNORA_RESERVA, TO_DATE('01/01/1980','DD/MM/YYYY') )
            AND IVE.SITMOV <> 'C'
            AND IVE.LANEST = ('R')
            AND IVE.FILORI IS NULL
            AND PRO.TIPPRO NOT IN ('1','2');
      END IF;

      -- Reserva (IOR)
      SELECT COALESCE(SUM(QTDITE),0)
        INTO total_ior_reserva
        FROM TT_CFG CFG,
         TT_IOR IOR INNER JOIN TT_ORC ORC ON ORC.CODFIL = IOR.CODFIL
                                         AND ORC.TIPPED = IOR.TIPPED
                                         AND ORC.NUMPED = IOR.NUMPED
                    INNER JOIN TT_PRO PRO ON IOR.FILMAT = PRO.FILMAT
                                         AND IOR.CODMAT = PRO.CODMAT
       WHERE COALESCE(IOR.FILRES, IOR.CODFIL) = wk_CODFIL
         AND IOR.FILMAT = wk_FILMAT
         AND IOR.CODMAT = wk_CODMAT
         AND IOR.CODCOR = wk_CODCOR
         AND IOR.CODTAM = wk_CODTAM
         AND IOR.CODMUL = wk_CODMUL
         AND IOR.FLGEST = 'R'
         AND ORC.PED_EM > COALESCE( CFG.IGNORA_RESERVA, TO_DATE('01/01/1980','DD/MM/YYYY') )
         AND PRO.TIPPRO NOT IN ('1','3')
         AND NOT EXISTS (SELECT SEQUEN 
                           FROM TT_KIT 
                          WHERE FILMAT=wk_FILMAT
                            AND CODMAT=wk_CODMAT
                            AND CODCOR=wk_CODCOR
                            AND CODTAM=wk_CODTAM);      

      -- Reserva (IOR) para kits
      SELECT COALESCE(SUM(IOR.QTDITE*KIT.QTDITE),0)
        INTO total_ior_reserva_kit    
        FROM TT_CFG CFG,
        TT_IOR IOR INNER JOIN TT_ORC ORC ON ORC.CODFIL = IOR.CODFIL
                                        AND ORC.TIPPED = IOR.TIPPED
                                        AND ORC.NUMPED = IOR.NUMPED
                    LEFT JOIN TT_KIT KIT ON IOR.FILMAT = KIT.FILMAT 
                                        AND IOR.CODMAT = KIT.CODMAT
                                        AND IOR.CODCOR = KIT.CODCOR
                                        AND IOR.CODTAM = KIT.CODTAM
                   INNER JOIN TT_PRO PRO ON IOR.FILMAT = PRO.FILMAT 
                                        AND IOR.CODMAT = PRO.CODMAT
       WHERE COALESCE(IOR.FILRES, IOR.CODFIL) = wk_CODFIL 
         AND KIT.FILITE = wk_FILMAT 
         AND KIT.CODITE = wk_CODMAT 
         AND KIT.CORITE = wk_CODCOR 
         AND KIT.TAMITE = wk_CODTAM 
         AND IOR.CODMUL = wk_CODMUL 
         AND IOR.FLGEST = 'R'
         AND ORC.PED_EM > COALESCE( CFG.IGNORA_RESERVA, TO_DATE('01/01/1980','DD/MM/YYYY') )
         AND PRO.TIPPRO NOT IN ('1','2');

      -- Grava
      NEW.RESERV := total_ive_reserva + total_ior_reserva+total_ior_reserva_kit;

   END IF;

   IF calcula_SALDO THEN

      -- Saldo de compras
      SELECT COALESCE(SUM(QTDMOV),0)
        INTO total_ico
        FROM TT_ICO
       WHERE CODFIL = wk_CODFIL
         AND FILMAT = wk_FILMAT
         AND CODMAT = wk_CODMAT
         AND CODCOR = wk_CODCOR
         AND CODTAM = wk_CODTAM
         AND CODMUL = wk_CODMUL
         AND LANEST = 'S'
         AND SITMOV <> 'C';

      -- Saldo de vendas
      SELECT COALESCE(SUM(QTDMOV),0)
        INTO total_ive_saldo
        FROM TT_IVE
       WHERE CODFIL = wk_CODFIL
         AND FILMAT = wk_FILMAT
         AND CODMAT = wk_CODMAT
         AND CODCOR = wk_CODCOR
         AND CODTAM = wk_CODTAM
         AND CODMUL = wk_CODMUL
         AND SITMOV <> 'C'
         AND LANEST IN ('C','S')
         AND SITKIT <> '1';

      -- Saldo de lancamentos
      SELECT COALESCE(SUM(QTDMOV),0)
        INTO total_lan
        FROM TT_LAN
       WHERE CODFIL = wk_CODFIL
         AND FILMAT = wk_FILMAT
         AND CODMAT = wk_CODMAT
         AND CODCOR = wk_CODCOR
         AND CODTAM = wk_CODTAM
         AND CODMUL = wk_CODMUL
         AND SITMOV <> 'C';

      -- Grava
      NEW.QTDEST := total_ico + total_lan - total_ive_saldo;

   END IF;

   -- "Default"
   IF (NOT (TG_OP = 'DELETE')) THEN
      NEW.DUMMY  := NULL;
   END IF; 

   -- Inicializa dados para assinatura

   -- RFMP 85136
   WK_UID := GetUidAtual();

   IF (TG_OP = 'DELETE') THEN
      IF WK_UID.BLQ_SEM_UID = 'T' AND WK_UID.CODUID IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;
   END IF;
  
   IF (TG_OP = 'INSERT') THEN
      IF WK_UID.BLQ_SEM_UID = 'T' AND WK_UID.CODUID IS NULL THEN
         RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;
  
      -- Douglas - 83441 
      NEW.CODUID := WK_UID.CODUID;
      NEW.ASSINA := COALESCE(AssinaTabela('TT_SAL',
                                             ConcatenaSAL(NEW.CODFIL,
                                                          NEW.SEQUEN,
                                                          NEW.QTDEST),
                                                   null, null, null),NEW.ASSINA);
   END IF;
   IF (TG_OP = 'UPDATE') THEN
      IF ConcatenaSAL(NEW.CODFIL,NEW.SEQUEN,NEW.QTDEST) <>
         ConcatenaSAL(OLD.CODFIL,OLD.SEQUEN,OLD.QTDEST) 
      THEN
         IF WK_UID.BLQ_SEM_UID = 'T' AND WK_UID.CODUID IS NULL THEN
            RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
         END IF;

         -- Douglas - 83441 
         NEW.CODUID := WK_UID.CODUID;
         NEW.ASSINA := COALESCE(AssinaTabela('TT_SAL', 
                                                ConcatenaSAL(NEW.CODFIL,
                                                             NEW.SEQUEN,
                                                             NEW.QTDEST),
                                                OLD.CODUID, 
                                                ConcatenaSAL(OLD.CODFIL,
                                                             OLD.SEQUEN,
                                                             OLD.QTDEST),
                                           OLD.ASSINA),NEW.ASSINA);
      END IF;
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5107 --*/
CREATE TRIGGER TGSAL
BEFORE INSERT OR DELETE OR UPDATE ON TT_SAL 
FOR EACH ROW EXECUTE PROCEDURE TGSAL();

/*-- SEQ 5108 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGSAL_ASS() CASCADE;

/*-- SEQ 5109 --*/
CREATE OR REPLACE FUNCTION TGSAL_ASS() RETURNS TRIGGER AS $$
-- 83073
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
DECLARE

  WK_DUMMY                        VARCHAR(2);

  -- RFMP 85136
   WK_UID                         TPC_UID_Retorno%ROWTYPE;

BEGIN

   IF ExisteFilialNaUF('SC') THEN
      IF (TG_OP = 'INSERT') THEN
        -- RFMP 85136 Tratamento para no dar lock na TT_ASS
        WK_UID := GetUidAtual(); 
       
        IF WK_UID.ASSINS = 'T' THEN    
          UPDATE TT_ASS
             SET QTDREG = QTDREG + 1
           WHERE NOMTAB = 'TT_SAL';
        ELSE
          WK_DUMMY := Insere_MASS('TT_SAL');
        END IF;     
      END IF;  
      
      IF (TG_OP = 'DELETE') THEN
        UPDATE TT_ASS
           SET QTDREG = QTDREG - 1
         WHERE NOMTAB = 'TT_SAL';
      END IF;   
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5110 --*/
CREATE TRIGGER TGSAL_ASS
AFTER INSERT OR DELETE ON TT_SAL 
FOR EACH ROW EXECUTE PROCEDURE TGSAL_ASS();


/*-- SEQ 5111 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGSAV() CASCADE;

/*-- SEQ 5112 --*/
CREATE OR REPLACE FUNCTION TGSAV() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria.
-- 2) Gerar um codigo sequencial exclusivo para o cdigo avulso (CODAVU).
-- 3) Impedir que depois de gravado os vinculos sejam alterados.
DECLARE
  -- Declarao de variveis de cursores
  vComplemento                   constant VARCHAR(100) := constante('complemento');
BEGIN
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    IF ISNULL(NEW.SEQUEN)='T' THEN
      NEW.SEQUEN:=ProximoCodigo('TT_SAV',NEW.CODFIL);
    END IF;
   NEW.DATINC := agora();
  END IF;

  -- Popula a coluna ATU_EM
  IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
     NEW.ATU_EM := agora();
  END IF;

  -- Impede alteraces nos vinculos
  IF (TG_OP = 'UPDATE') THEN
     IF (OLD.FILPED <> NEW.FILPED) OR
        (OLD.TIPPED <> NEW.TIPPED) OR
        (OLD.NUMPED <> NEW.NUMPED) OR
        (OLD.NUMITE <> NEW.NUMITE) OR
        (OLD.FILVEN <> NEW.FILVEN) OR
        (OLD.SEQVEN <> NEW.SEQVEN) OR
        (OLD.NUMIVE <> NEW.NUMIVE) OR
        (OLD.FILRTT <> NEW.FILRTT) OR
        (OLD.SEQRTT <> NEW.SEQRTT) THEN
       RAISE EXCEPTION 'PG-20012 Um vnculo no pode ser modificado. %' , vComplemento;
    END IF;
  END IF;

  -- Calcula se soma no total
  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     IF ISNULL(NEW.SOMTOT) = 'T' THEN
        NEW.SOMTOT := 'T';
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5113 --*/
CREATE TRIGGER TGSAV
BEFORE INSERT OR UPDATE ON TT_SAV 
FOR EACH ROW EXECUTE PROCEDURE TGSAV();

/*-- SEQ 5114 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGSAV2() CASCADE;

/*-- SEQ 5115 --*/
CREATE OR REPLACE FUNCTION TGSAV2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo
-- 1) Registrar mudanca dos dados num "log" na TL_SAV

  vLOG                           VARCHAR(4000) := '';
  cNulo                          CONSTANT CHAR(1) := '0';
  iNulo                          CONSTANT Numeric(1) := 0;
  sNulo                          CONSTANT CHAR(4) := 'Nulo';
  CRLF                           CONSTANT CHAR(1) := CHR(10);
  vFILUSU                        VARCHAR(3);
  vCODUSU                        VARCHAR(3);
  QuemLogou                      TRetQuemLogou%ROWTYPE;
  WK_CODUID                      TT_UID.CODUID%TYPE;
BEGIN
  WK_CODUID := GetCoduidAtual();

  select * into QuemLogou from DadosLogon();
  vFILUSU := QuemLogou.FILUSU;
  vCODUSU := QuemLogou.CODUSU;

  -- Em caso de Incluso
  IF (TG_OP = 'INSERT') THEN
    vLOG := 'Incluso de Servios Adicionais Vendidos';
    -- Inclui uma linha em TL_SAV
    INSERT INTO TL_SAV (FILSAV, SEQSAV, DATOPE, FILUSU, CODUSU, MSGLOG, CODUID)
    VALUES(NEW.CODFIL,NEW.SEQUEN, Agora(), vFILUSU, vCODUSU, vLOG, WK_CODUID);
  ELSIF (TG_OP = 'UPDATE') THEN

     IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 THEN
        vLOG := vLOG||'Filial: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
     END IF;

     IF Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 THEN
        vLOG := vLOG||'Sequenciador: de '||COALESCE(OLD.SEQUEN,cNulo)||' para '||COALESCE(NEW.SEQUEN,cNulo)||CRLF;
     END IF;

     --IF Equal(OLD.DATINC,NEW.DATINC) <> 1 THEN
     --   vLOG := vLOG||'Data Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     --END IF;

     --IF Equal(OLD.ATU_EM,NEW.ATU_EM) <> 1 THEN
     --   vLOG := vLOG||'Data da Atualizao: de '||COALESCE(TO_CHAR(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     --END IF;

     IF Equal(OLD.CODAVU,NEW.CODAVU) <> 1 THEN
        vLOG := vLOG||'Cdigo avulso: de '||COALESCE(OLD.CODAVU,cNulo)||' para '||COALESCE(NEW.CODAVU,cNulo)||CRLF;
     END IF;

     IF Equal(OLD.TIPVAL,NEW.TIPVAL) <> 1 THEN
        vLOG := vLOG||'Tipo do Tempo de Validade do Servio: de '||COALESCE(OLD.TIPVAL,iNulo)||' para '||COALESCE(NEW.TIPVAL,iNulo)||CRLF;
     END IF;

     IF Equal(OLD.VALIDA,NEW.VALIDA) <> 1 THEN
        vLOG := vLOG||'Garantia/Validade: de '||COALESCE(OLD.VALIDA,iNulo)||' para '||COALESCE(NEW.VALIDA,iNulo)||CRLF;
     END IF;

     IF Equal(OLD.VALSAD,NEW.VALSAD) <> 1 THEN
        vLOG := vLOG||'Valor do Seguro (em R$): de '||COALESCE(TO_CHAR(OLD.VALSAD,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VALSAD,'fm9G999G999G990D00'),cNulo)||CRLF;
     END IF;

     IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
        vLOG := vLOG||'Situao do Servio Adquirido: de '||COALESCE(DescricaoDominio('SAV','FLGEST',OLD.FLGEST),cNulo)||' para '||COALESCE(DescricaoDominio('SAV','FLGEST',NEW.FLGEST),cNulo)||CRLF;
     END IF;

     IF Equal(OLD.NUMSER,NEW.NUMSER) <> 1 THEN
        vLOG := vLOG||'Nmero de Srie do Produto Vinculado: de '||COALESCE(OLD.NUMSER,cNulo)||' para '||COALESCE(NEW.NUMSER,cNulo)||CRLF;
     END IF;

     IF Equal(OLD.NUMSEQ,NEW.NUMSEQ) <> 1 THEN
        vLOG := vLOG||'Nmero Sequencial do Contrato: de '||COALESCE(TO_CHAR(OLD.NUMSEQ,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.NUMSEQ,'fm9G999G999G990D00'),cNulo)||CRLF;
     END IF;

     IF Equal(OLD.OBSERV,NEW.OBSERV) <> 1 THEN
        vLOG := vLOG||'Observao: de '||COALESCE(OLD.OBSERV,cNulo)||' para '||COALESCE(NEW.OBSERV,cNulo)||CRLF;
     END IF;

     IF Equal(OLD.DATINI,NEW.DATINI) <> 1 THEN
        vLOG := vLOG||'Data de Incio da Cobertura do Servio: de '||COALESCE(TO_CHAR(OLD.DATINI,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINI,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;

     IF Equal(OLD.DATFIM,NEW.DATFIM) <> 1 THEN
        vLOG := vLOG||'Data de Fim da Cobertura do Servio: de '||COALESCE(TO_CHAR(OLD.DATFIM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATFIM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;

     IF Equal(OLD.CODSAD,NEW.CODSAD) <> 1 THEN
        vLOG := vLOG||'Tipo de Servio: de '||COALESCE(OLD.CODSAD,cNulo)||' para '||COALESCE(NEW.CODSAD,cNulo)||CRLF;
     END IF;

     IF Equal(OLD.VALSADORI,NEW.VALSADORI) <> 1 THEN
        vLOG := vLOG||'Valor do Servio Original (em R$): de '||COALESCE(TO_CHAR(OLD.VALSADORI,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VALSADORI,'fm9G999G999G990D00'),cNulo)||CRLF;
     END IF;

     IF Equal(OLD.PERSADORI,NEW.PERSADORI) <> 1 THEN
        vLOG := vLOG||'% Original sobre Preo Total: de '||COALESCE(TO_CHAR(OLD.PERSADORI,'fm990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PERSADORI,'fm990D00'),cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.FILCLI,NEW.FILCLI) = 0 OR
         Equal(OLD.CODCLI,NEW.CODCLI) = 0) THEN
        vLOG := vLOG||'Cliente: de '||COALESCE(OLD.FILCLI,sNulo)||'/'||TRIM(COALESCE(OLD.CODCLI,sNulo))
                                               ||' para '
                                               ||COALESCE(NEW.FILCLI,sNulo)||'/'||TRIM(COALESCE(NEW.CODCLI,sNulo))||CRLF;
     END IF;

     IF Equal(OLD.PERIOF,NEW.PERIOF) <> 1 THEN
        vLOG := vLOG||'% de IOF: de '||COALESCE(TO_CHAR(OLD.PERIOF,'fm990D00'),sNulo)||' para '||COALESCE(TO_CHAR(NEW.PERIOF,'fm990D00'),sNulo)||CRLF;
     END IF;

     IF Equal(OLD.VLRIOF,NEW.VLRIOF) <> 1 THEN
        vLOG := vLOG||'Valor do IOF: de '||COALESCE(TO_CHAR(OLD.VLRIOF,'fm9G999G999G990D00'),sNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRIOF,'fm9G999G999G990D00'),sNulo)||CRLF;
     END IF;
     -- 95664 Almir Borges
     IF Equal(OLD.FILSAD,NEW.FILSAD) <> 1 THEN
        vLOG := vLOG||'Filial Servio Adicional: de '||COALESCE(OLD.FILSAD,cNulo)||' para '||COALESCE(NEW.FILSAD,cNulo)||CRLF;
     END IF;
     -- 95664 Almir Borges
     IF Equal(OLD.SEQSAD,NEW.SEQSAD) <> 1 THEN
        vLOG := vLOG||'Seq Servio Adicional: de '||COALESCE(OLD.SEQSAD,cNulo)||' para '||COALESCE(NEW.SEQSAD,cNulo)||CRLF;
     END IF;
     IF Equal(OLD.VLRCOM,NEW.VLRCOM) <> 1 THEN
       vLOG := vLOG||'Valor de Comisso: de '||COALESCE(OLD.VLRCOM,iNulo)||' para '||COALESCE(NEW.VLRCOM,iNulo)||CRLF;
     END IF;
     IF Equal(OLD.DATCAN,NEW.DATCAN) <> 1 THEN
        vLOG := vLOG||'Data do cancelamento do servio: de '||COALESCE(TO_CHAR(OLD.DATCAN,'DD/MM/YYYY HH24:MI:SS'),sNulo)||' para '||COALESCE(TO_CHAR(NEW.DATCAN,'DD/MM/YYYY HH24:MI:SS'),sNulo)||CRLF;
     END IF;
     IF Equal(OLD.VLRCAN,NEW.VLRCAN) <> 1 THEN
        vLOG := vLOG||'Valor do cancelamento do servio: de '||COALESCE(TO_CHAR(OLD.VLRCAN,'fm9G999G999G990D00'),sNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRCAN,'fm9G999G999G990D00'),sNulo)||CRLF;
     END IF;
     IF Equal(OLD.CDIMEI,NEW.CDIMEI) <> 1 THEN
        vLOG := vLOG||'Cdigo IMEI do Produto Vinculado: de '||COALESCE(OLD.CDIMEI,sNulo)||' para '||COALESCE(NEW.CDIMEI,sNulo)||CRLF;
     END IF;

    IF ISNOTNULL(vLOG)='T'  THEN
      -- Inclui uma linha em TL_SAV
      INSERT INTO TL_SAV (FILSAV, SEQSAV, DATOPE, FILUSU, CODUSU, MSGLOG, CODUID)
      VALUES(NEW.CODFIL,NEW.SEQUEN, Agora(), vFILUSU, vCODUSU, vLOG, WK_CODUID);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5116 --*/
CREATE TRIGGER TGSAV2
AFTER INSERT OR UPDATE ON TT_SAV 
FOR EACH ROW EXECUTE PROCEDURE TGSAV2();

/*-- SEQ 5117 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGSAV3() CASCADE;

/*-- SEQ 5118 --*/
CREATE OR REPLACE FUNCTION TGSAV3() RETURNS TRIGGER AS $$
-- 91707
-- Valida TT_SAV.NUNSEQ quando impresso da TD_SAD.IMPDOC ="T"
DECLARE

 WK_IMPDOC TD_SAD.IMPDOC%TYPE;

BEGIN

  SELECT DSAD.IMPDOC INTO WK_IMPDOC FROM TD_SAD DSAD WHERE DSAD.CODTAB = NEW.CODSAD;

  IF WK_IMPDOC = 'T' THEN
    IF ((NEW.NUMSEQ IS NULL) AND (NEW.FLGEST = 'F')) THEN
      RAISE EXCEPTION 'PG-20018 No  permitido faturamento/impresso de servio adicional com sequencial de impresso nulo!';
    END IF;
  END IF;


 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5119 --*/
CREATE TRIGGER TGSAV3
BEFORE INSERT OR UPDATE ON TT_SAV 
FOR EACH ROW EXECUTE PROCEDURE TGSAV3();


/*-- SEQ 5120 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGSIM() CASCADE;

/*-- SEQ 5121 --*/
CREATE OR REPLACE FUNCTION TGSIM() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
      NEW.SEQUEN := ProximoCodigo('TT_SIM',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5122 --*/
CREATE TRIGGER TGSIM
BEFORE INSERT ON TT_SIM 
FOR EACH ROW EXECUTE PROCEDURE TGSIM();


/*-- SEQ 5123 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGSLI() CASCADE;

/*-- SEQ 5124 --*/
CREATE OR REPLACE FUNCTION TGSLI() RETURNS TRIGGER AS $$
DECLARE
  vComplemento       CONSTANT VARCHAR(254) := Constante('complemento');
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Atualiza DATINC
-- 3) Atualiza ATU_EM

-- Principal
BEGIN
  IF (TG_OP = 'UPDATE') THEN
    IF ABS(OLD.SIGNAT) <> ABS(NEW.SIGNAT) THEN
       RAISE EXCEPTION 'PG-20003 Registro foi alterado por outro usuário, refaça a consulta e tente gravar novamente. %' , vComplemento;
    END IF;
    IF (NEW.SIGNAT >= 0) THEN
        NEW.SIGNAT := MOD(NEW.SIGNAT + 1,100000);
    ELSE
        NEW.SIGNAT := MOD(NEW.SIGNAT - 1,100000);
    END IF;
  END IF;
  
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN:=ProximoCodigo('TT_SLI',NEW.CODFIL);
    END IF;
  END IF;

  -- Trata dados padroes na inclusao  
  IF (TG_OP = 'INSERT') THEN
   NEW.DATINC := AGORA();
  END IF;

  -- Popula a coluna ATU_EM
  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     NEW.ATU_EM := AGORA();  
  END IF; 

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5125 --*/
CREATE TRIGGER TGSLI
BEFORE INSERT OR UPDATE ON TT_SLI 
FOR EACH ROW EXECUTE PROCEDURE TGSLI();


/*-- SEQ 5126 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGSLT() CASCADE;

/*-- SEQ 5127 --*/
CREATE OR REPLACE FUNCTION TGSLT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

  vComplemento  VARCHAR(254) := constante('complemento');
-- Principal
BEGIN

   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN := ProximoCodigo('TT_SLT',NEW.CODFIL);
      END IF;

      IF NEW.RESERV IS NULL THEN
         NEW.RESERV := 0;
      END IF;

      -- RFMP 96855 - Tratamento retirado
      --IF (NEW.QTDEST <> 0) THEN
      --    UPDATE TT_LOT
      --       SET QTDEST = NEW.QTDEST
      --     WHERE CODFIL = NEW.FILLOT
      --       AND SEQUEN = NEW.SEQLOT;
      --END IF;
   END IF;
   
   IF (TG_OP = 'UPDATE') THEN
      IF (NEW.QTDEST > 99999999) THEN
         RAISE EXCEPTION 'PG-20056 Valor máximo de quantidade em estoque passou do limite (R$99.999.99). %' , vComplemento;
      END IF;

      -- RFMP 96855 - Tratamento retirado
      --IF (Equal(OLD.QTDEST,NEW.QTDEST) <> 1) THEN
      --   UPDATE TT_LOT
      --      SET QTDEST = NEW.QTDEST
      --    WHERE CODFIL = NEW.FILLOT
      --      AND SEQUEN = NEW.SEQLOT;
      --END IF;
   END IF;

   IF ((TG_OP = 'UPDATE')) OR ((TG_OP = 'INSERT')) THEN
      NEW.ATU_EM := agora();
      
      IF (NEW.QTDEST <> 0) THEN
         NEW.MOVSLT := 'T';
      END IF;
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5128 --*/
CREATE TRIGGER TGSLT
BEFORE INSERT OR UPDATE ON TT_SLT 
FOR EACH ROW EXECUTE PROCEDURE TGSLT();


/*-- SEQ 5129 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGSPC1() CASCADE;

/*-- SEQ 5130 --*/
CREATE OR REPLACE FUNCTION TGSPC1() RETURNS TRIGGER AS $$
DECLARE
  pg_dummy VARCHAR(5)
;
BEGIN
   IF PC_TRIGGERS_ENABLED('PC_CONJUGE') THEN
      pg_dummy := PC_CLEAR_LIST('PC_CONJUGE')
;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5131 --*/
CREATE TRIGGER TGSPC1
BEFORE INSERT OR UPDATE ON TT_SPC 
FOR STATEMENT EXECUTE PROCEDURE TGSPC1();

/*-- SEQ 5132 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGSPC2() CASCADE;

/*-- SEQ 5133 --*/
CREATE OR REPLACE FUNCTION TGSPC2() RETURNS TRIGGER AS $$
DECLARE
      cFILCON                       TT_CLI.FILCON%TYPE;
   cCODCON                       TT_CLI.CODCON%TYPE;
   pg_dummy VARCHAR(5)
;
BEGIN
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN      
      IF ((instr(NEW.E_MAIL, CHR(13)) > 0) OR   
	      (instr(NEW.E_MAIL, CHR(10)) > 0))THEN
         NEW.E_MAIL := TRIM(REPLACE(REPLACE(NEW.E_MAIL,CHR(13), ''),CHR(10), ''));
      END IF;
   END IF;

   IF NOT (TG_OP = 'DELETE') THEN   
 
      IF PC_TRIGGERS_ENABLED('PC_CONJUGE') THEN
                     SELECT FILCON,CODCON INTO cFILCON,cCODCON
              FROM TT_CLI
             WHERE FILCLI = NEW.FILCLI
               AND CODCLI = NEW.CODCLI
               AND FILCON IS NOT NULL
               AND CODCON IS NOT NULL
               AND FLGTIP = 0;
                  IF (cFILCON IS NOT NULL) AND (cCODCON IS NOT NULL) THEN
            pg_dummy := PC_NEXT_GROUP('PC_CONJUGE');
pg_dummy := PC_ADD_LIST('PC_CONJUGE','FILCLI',true,NEW.FILCLI);
pg_dummy := PC_ADD_LIST('PC_CONJUGE','CODCLI',true,NEW.CODCLI);
pg_dummy := PC_ADD_LIST('PC_CONJUGE','FILCON',false,cFILCON);
pg_dummy := PC_ADD_LIST('PC_CONJUGE','CODCON',false,cCODCON);
pg_dummy := PC_FIND_LIST('PC_CONJUGE')
;
         END IF;
      END IF;
   END IF; 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5134 --*/
CREATE TRIGGER TGSPC2
BEFORE INSERT OR UPDATE ON TT_SPC 
FOR EACH ROW EXECUTE PROCEDURE TGSPC2();

/*-- SEQ 5135 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGSPC3() CASCADE;

/*-- SEQ 5136 --*/
CREATE OR REPLACE FUNCTION TGSPC3() RETURNS TRIGGER AS $$
-- Objetivo:
-- 2) Registrar mudana dos dados num "log"
-- 3) "Delete cascade" na tabela de "log"
DECLARE
   cLOG                          VARCHAR(4000) := '';
   CRLF                          CONSTANT CHAR(1) := CHR(10);
   cNulo                         CONSTANT CHAR(4) := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   iACHOU                        INTEGER;
   cRetorno                      VARCHAR(2);
   cWhere                        TM_ATU.FILTRO%TYPE;
BEGIN
   --Tratamento para Atualizar Tabela Pai
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN      
      cWhere := 'FILCLI = ' || CHR(39) || NEW.FILCLI  || CHR(39) || ' AND CODCLI = ' || CHR(39) || NEW.CODCLI || CHR(39);
   ELSIF (TG_OP = 'DELETE') THEN      
      cWhere := 'FILCLI = ' || CHR(39) || OLD.FILCLI  || CHR(39) || ' AND CODCLI = ' || CHR(39) || OLD.CODCLI || CHR(39);
   END IF;
   cRetorno := INSERE_MATU('TT_SPC', 'TT_CLI', cWhere);
   
   -- Tratamento de Log
   IF (TG_OP = 'INSERT') THEN
      cLOG := 'Inclusao';
      cLOG := '<< DADOS DE SPC >>'||CRLF||cLOG;
      INSERT INTO TL_CLI (FILCLI,CODCLI,DATOPE,MSGLOG)
          VALUES (NEW.FILCLI,NEW.CODCLI,agora(),cLOG);
   ELSIF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.ALUFIN,NEW.ALUFIN) <> 1 THEN
         cLOG := cLOG||'Aluguel/financiamento: de '||TO_CHAR(COALESCE(OLD.ALUFIN,iNulo),'fm9G999G990D00')||' para '||TO_CHAR(COALESCE(NEW.ALUFIN,iNulo),'fm9G999G990D00')||CRLF;
      END IF;
      IF Equal(OLD.ANTMES,NEW.ANTMES) <> 1 THEN
         cLOG := cLOG||'Tempo de servico do ultimo emprego do parceiro: de '||COALESCE(OLD.ANTMES,iNulo)||' mes(es) para '||COALESCE(NEW.ANTMES,iNulo)||' mes(es)'||CRLF;
      END IF;
      IF Equal(OLD.ATUMES,NEW.ATUMES) <> 1 THEN
         cLOG := cLOG||'Tempo de servico do emprego atual do parceiro: de '||COALESCE(OLD.ATUMES,iNulo)||' mes(es) para '||COALESCE(NEW.ATUMES,iNulo)||' mes(es)'||CRLF;
      END IF;
      IF Equal(OLD.CASMES,NEW.CASMES) <> 1 THEN
         cLOG := cLOG||'Tempo de casado: de '||COALESCE(OLD.CASMES,iNulo)||' mes(es) para '||COALESCE(NEW.CASMES,iNulo)||' mes(es)'||CRLF;
      END IF;
      IF Equal(OLD.CANMES,NEW.CANMES) <> 1 THEN
         cLOG := cLOG||'Tempo de servico do ultimo emprego do conjuge: de '||COALESCE(OLD.CANMES,iNulo)||' mes(es) para '||COALESCE(NEW.CANMES,iNulo)||' mes(es)'||CRLF;
      END IF;
      IF Equal(OLD.CARPRC,NEW.CARPRC) <> 1 THEN
         cLOG := cLOG||'CTPS conjuge: de '||COALESCE(OLD.CARPRC,cNulo)||' para '||COALESCE(NEW.CARPRC,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CARPRO,NEW.CARPRO) <> 1 THEN
         cLOG := cLOG||'CTPS: de '||COALESCE(OLD.CARPRO,cNulo)||' para '||COALESCE(NEW.CARPRO,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CIDNAS,NEW.CIDNAS) <> 1 THEN
         cLOG := cLOG||'Cidade natal: de '||COALESCE(OLD.CIDNAS,cNulo)||' para '||COALESCE(NEW.CIDNAS,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CON_LR,NEW.CON_LR) <> 1 THEN
         cLOG := cLOG||'Residencia: de '||COALESCE(OLD.CON_LR,cNulo)||' para '||COALESCE(NEW.CON_LR,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CON_LT,NEW.CON_LT) <> 1 THEN
         cLOG := cLOG||'Local de trabalho: de '||COALESCE(OLD.CON_LT,cNulo)||' para '||COALESCE(NEW.CON_LT,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CONSPC,NEW.CONSPC) <> 1 THEN
         cLOG := cLOG||'Consulta SPC: de '||COALESCE(OLD.CONSPC,cNulo)||' para '||COALESCE(NEW.CONSPC,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CON_TC,NEW.CON_TC) <> 1 THEN
         cLOG := cLOG||'Talao cheques: de '||COALESCE(OLD.CON_TC,cNulo)||' para '||COALESCE(NEW.CON_TC,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.E_MAIL,NEW.E_MAIL) <> 1 THEN
         cLOG := cLOG||'e-Mail: de '||COALESCE(OLD.E_MAIL,cNulo)||' para '||COALESCE(NEW.E_MAIL,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ENDCO1,NEW.ENDCO1) <> 1 THEN
         cLOG := cLOG||'Endereco comercial conjuge: de '||COALESCE(OLD.ENDCO1,cNulo)||' para '||COALESCE(NEW.ENDCO1,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ENDCO2,NEW.ENDCO2) <> 1 THEN
         cLOG := cLOG||'Complemento endereco comercial conjuge: de '||COALESCE(OLD.ENDCO2,cNulo)||' para '||COALESCE(NEW.ENDCO2,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ENDERE,NEW.ENDERE) <> 1 THEN
         cLOG := cLOG||'Endereco firma: de '||COALESCE(OLD.ENDERE,cNulo)||' para '||COALESCE(NEW.ENDERE,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ENDLO1,NEW.ENDLO1) <> 1 THEN
         cLOG := cLOG||'Endereco referencia comercial 1: de '||COALESCE(OLD.ENDLO1,cNulo)||' para '||COALESCE(NEW.ENDLO1,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.ENDLO2,NEW.ENDLO2) <> 1 THEN
         cLOG := cLOG||'Endereco referencia comercial (loja) 2: de '||COALESCE(OLD.ENDLO2,cNulo)||' para '||COALESCE(NEW.ENDLO2,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FIRANT,NEW.FIRANT) <> 1 THEN
         cLOG := cLOG||'Firma anterior: de '||COALESCE(OLD.FIRANT,cNulo)||' para '||COALESCE(NEW.FIRANT,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FIRATU,NEW.FIRATU) <> 1 THEN
         cLOG := cLOG||'Firma atual: de '||COALESCE(OLD.FIRATU,cNulo)||' para '||COALESCE(NEW.FIRATU,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FIRCON,NEW.FIRCON) <> 1 THEN
         cLOG := cLOG||'Firma do conjuge: de '||COALESCE(OLD.FIRCON,cNulo)||' para '||COALESCE(NEW.FIRCON,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.MORMES,NEW.MORMES) <> 1 THEN
         cLOG := cLOG||'Tempo de moradia (meses): de '||COALESCE(OLD.MORMES,iNulo)||' para '||COALESCE(NEW.MORMES,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.NACION,NEW.NACION) <> 1 THEN
         cLOG := cLOG||'Nacionalidade: de '||COALESCE(OLD.NACION,cNulo)||' para '||COALESCE(NEW.NACION,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NOMLO1,NEW.NOMLO1) <> 1 THEN
         cLOG := cLOG||'Referencia comercial (loja) 1: de '||COALESCE(OLD.NOMLO1,cNulo)||' para '||COALESCE(NEW.NOMLO1,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NOMLO2,NEW.NOMLO2) <> 1 THEN
         cLOG := cLOG||'Referencia comercial (loja) 2: de '||COALESCE(OLD.NOMLO2,cNulo)||' para '||COALESCE(NEW.NOMLO2,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NOMSUP,NEW.NOMSUP) <> 1 THEN
         cLOG := cLOG||'Superior imediato: de '||COALESCE(OLD.NOMSUP,cNulo)||' para '||COALESCE(NEW.NOMSUP,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NUMCEL,NEW.NUMCEL) <> 1 THEN
         cLOG := cLOG||'Celular: de '||COALESCE(OLD.NUMCEL,cNulo)||' para '||COALESCE(NEW.NUMCEL,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NUMCOC,NEW.NUMCOC) <> 1 THEN
         cLOG := cLOG||'DDD conjuge: de '||COALESCE(OLD.NUMCOC,cNulo)||' para '||COALESCE(NEW.NUMCOC,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NUMCOD,NEW.NUMCOD) <> 1 THEN
         cLOG := cLOG||'DDD firma: de '||COALESCE(OLD.NUMCOD,cNulo)||' para '||COALESCE(NEW.NUMCOD,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NUMTEL,NEW.NUMTEL) <> 1 THEN
         cLOG := cLOG||'Telefone firma: de '||COALESCE(OLD.NUMTEL,cNulo)||' para '||COALESCE(NEW.NUMTEL,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.RGCONJ,NEW.RGCONJ) <> 1 THEN
         cLOG := cLOG||'RG conjuge: de '||COALESCE(OLD.RGCONJ,cNulo)||' para '||COALESCE(NEW.RGCONJ,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SALBAC,NEW.SALBAC) <> 1 THEN
         cLOG := cLOG||'Salario base conjuge: de'||TO_CHAR(COALESCE(OLD.SALBAC,iNulo),'fm9G999G990D00')||' para '||TO_CHAR(COALESCE(NEW.SALBAC,iNulo),'fm9G999G990D00')||CRLF;
      END IF;
      IF Equal(OLD.SALBAS,NEW.SALBAS) <> 1 THEN
         cLOG := cLOG||'Salario base: de '||TO_CHAR(COALESCE(OLD.SALBAS,iNulo),'fm9G999G990D00')||' para '||TO_CHAR(COALESCE(NEW.SALBAS,iNulo),'fm9G999G990D00')||CRLF;
      END IF;
      IF Equal(OLD.SERCAC,NEW.SERCAC) <> 1 THEN
         cLOG := cLOG||'Serie CTPS conjuge: de '||COALESCE(OLD.SERCAC,cNulo)||' para '||COALESCE(NEW.SERCAC,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SERCAR,NEW.SERCAR) <> 1 THEN
         cLOG := cLOG||'Serie CTPS: de '||COALESCE(OLD.SERCAR,cNulo)||' para '||COALESCE(NEW.SERCAR,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TELCON,NEW.TELCON) <> 1 THEN
         cLOG := cLOG||'Telefone conjuge: de '||COALESCE(OLD.TELCON,cNulo)||' para '||COALESCE(NEW.TELCON,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TIPRES,NEW.TIPRES) <> 1 THEN
         cLOG := cLOG||'Tipo residencia: de '||COALESCE(DescricaoDominio('SPC','TIPRES',TO_CHAR(OLD.TIPRES)),cNULO)||' para '||COALESCE(DescricaoDominio('SPC','TIPRES',TO_CHAR(NEW.TIPRES)),cNULO)||CRLF;
      END IF;
      IF Equal(OLD.COMPLE,NEW.COMPLE) <> 1 THEN
         cLOG := cLOG||'Compl. End. Trabalho: de '||COALESCE(OLD.COMPLE,cNulo)||' para '||COALESCE(NEW.COMPLE,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRRED,NEW.VLRRED) <> 1 THEN
         cLOG := cLOG||'Valor da Renda: de '||COALESCE(OLD.VLRRED,iNulo)||' para '||COALESCE(NEW.VLRRED,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.ORIRED,NEW.ORIRED) <> 1 THEN
         cLOG := cLOG||'Origem da Renda: de '||COALESCE(OLD.ORIRED,cNulo)||' para '||COALESCE(NEW.ORIRED,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NUMDEP,NEW.NUMDEP) <> 1 THEN
         cLOG := cLOG||'Numero de Dependente: de '||COALESCE(OLD.NUMDEP,iNulo)||' para '||COALESCE(NEW.NUMDEP,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.TEM_TC,NEW.TEM_TC) <> 1 THEN
         cLOG := cLOG||'Tem Talao de Cheques?: de '||COALESCE(OLD.TEM_TC,cNulo)||' para '||COALESCE(NEW.TEM_TC,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TEM_CC,NEW.TEM_CC) <> 1 THEN
         cLOG := cLOG||'Tem Cartao Credito?: de '||COALESCE(OLD.TEM_CC,cNulo)||' para '||COALESCE(NEW.TEM_CC,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CARLOJ,NEW.CARLOJ) <> 1 THEN
         cLOG := cLOG||'Tem Cartao Loja?: de '||COALESCE(OLD.CARLOJ,cNulo)||' para '||COALESCE(NEW.CARLOJ,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TEMAUT,NEW.TEMAUT) <> 1 THEN
         cLOG := cLOG||'Tem automvel?: de '||COALESCE(OLD.TEMAUT,cNulo)||' para '||COALESCE(NEW.TEMAUT,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.DDDCEL,NEW.DDDCEL) <> 1 THEN
         cLOG := cLOG||'DDD Celular: de '||COALESCE(OLD.DDDCEL,cNulo)||' para '||COALESCE(NEW.DDDCEL,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODOCU,NEW.CODOCU) <> 1 THEN
         cLOG := cLOG||'Ocupacao: de '||COALESCE(OLD.CODOCU,iNulo)||' para '||COALESCE(NEW.CODOCU,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.CONOCU,NEW.CONOCU) <> 1 THEN
         cLOG := cLOG||'Emprego do Conjuge : de '||COALESCE(OLD.CONOCU,iNulo)||' para '||COALESCE(NEW.CONOCU,iNulo)||CRLF;
      END IF;
      IF ISNOTNULL(cLOG)='T' THEN   -- Paulo : 67106
         cLOG := '<< DADOS DE SPC >>'||CRLF||cLOG;
         INSERT INTO TL_CLI (FILCLI,CODCLI,DATOPE,MSGLOG)
         VALUES (NEW.FILCLI,NEW.CODCLI,agora(),cLOG);
      END IF;
   ELSIF (TG_OP = 'DELETE') THEN
      iACHOU := TGR_Cliente_Existe(OLD.filcli, OLD.CODCli); /* retornos possiveis 0 e 1 E -1 */
      IF (iACHOU = 0) THEN
         DELETE FROM TL_CLI WHERE FILCLI = OLD.FILCLI AND CODCLI = OLD.CODCLI;
      END IF;     
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5137 --*/
CREATE TRIGGER TGSPC3
AFTER INSERT OR UPDATE OR DELETE ON TT_SPC 
FOR EACH ROW EXECUTE PROCEDURE TGSPC3();

/*-- SEQ 5138 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGSPC4() CASCADE;

/*-- SEQ 5139 --*/
CREATE OR REPLACE FUNCTION TGSPC4() RETURNS TRIGGER AS $$
DECLARE
   pg_dummy VARCHAR(5)
;
BEGIN
   IF PC_TRIGGERS_ENABLED('PC_CONJUGE') THEN
      pg_dummy := PC_INIT('PC_CONJUGE',FALSE);
pg_dummy := PC_EXECUTE('PC_CONJUGE','ATUALIZACONJUGE');
pg_dummy := PC_INIT('PC_CONJUGE')
;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5140 --*/
CREATE TRIGGER TGSPC4
AFTER INSERT OR UPDATE ON TT_SPC 
FOR STATEMENT EXECUTE PROCEDURE TGSPC4();

/*-- SEQ 5141 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGSPC_DW() CASCADE;

/*-- SEQ 5142 --*/
CREATE OR REPLACE FUNCTION TGSPC_DW() RETURNS TRIGGER AS $$
DECLARE
   bProcessa                     BOOLEAN DEFAULT False;
      
   regDW                         RECORD;
      cDUMMY                        VARCHAR(2);
   vFILCLI                       TT_SPC.FILCLI%TYPE;
   vCODCLI                       TT_SPC.CODCLI%TYPE;
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');

-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Vendas_Cliente

BEGIN
  IF UsaVMDecisor() = 'T' THEN
     IF (TG_OP = 'INSERT') THEN
        bProcessa := True;
        vFILCLI   := NEW.FILCLI; 
        vCODCLI   := NEW.CODCLI;
     ELSIF (TG_OP = 'UPDATE') THEN
        IF Equal(OLD.FILCLI,NEW.FILCLI) <> 1 
        OR Equal(OLD.CODCLI,NEW.CODCLI) <> 1 THEN --PK
           RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
        END IF;
        IF Equal(OLD.CODOCU,NEW.CODOCU) <> 1 THEN
           bProcessa := True;
           vFILCLI   := NEW.FILCLI; 
           vCODCLI   := NEW.CODCLI;
        END IF;
     ELSIF (TG_OP = 'DELETE') THEN
        bProcessa := True;
        vFILCLI   := OLD.FILCLI; 
        vCODCLI   := OLD.CODCLI;
     END IF;
        
     IF bProcessa THEN
        FOR regDW IN (SELECT DW.Filial,
                           DW.Filial_Cliente,
                           DW.Codigo_Cliente,
                           DW.Ano_Mes
                      FROM DW_Vendas_Cliente DW
                     WHERE DW.Filial_Cliente = vFILCLI
                       AND DW.Codigo_Cliente = vCODCLI)
        LOOP
           cDUMMY := Insere_DW_Log_Vendas_Cliente(regDW.FILIAL, regDW.Filial_Cliente, regDW.Codigo_Cliente, regDW.ANO_MES);
        END LOOP;
     END IF;
  END IF;   
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5143 --*/
CREATE TRIGGER TGSPC_DW
AFTER INSERT OR DELETE OR UPDATE ON TT_SPC 
FOR EACH ROW EXECUTE PROCEDURE TGSPC_DW();


/*-- SEQ 5144 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGSQL() CASCADE;

/*-- SEQ 5145 --*/
CREATE OR REPLACE FUNCTION TGSQL() RETURNS TRIGGER AS $$
BEGIN
  -- Gera um codigo automaticamente   
  IF (TG_OP = 'INSERT') THEN
    NEW.NUMSEQ:=ProximoCodigo('TT_SQL',NULL);
  END IF;
  
  -- Paulo :  67831
  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
    NEW.RELORI := TRIM(NEW.RELORI);
    NEW.RELDES := TRIM(NEW.RELDES);
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5146 --*/
CREATE TRIGGER TGSQL
BEFORE INSERT OR UPDATE ON TT_SQL 
FOR EACH ROW EXECUTE PROCEDURE TGSQL();





/*-- SEQ 5147 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGSUB2() CASCADE;

/*-- SEQ 5148 --*/
CREATE OR REPLACE FUNCTION TGSUB2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo
-- 2) Impedir a mudanca de um item de subdivisao se ele ja estiver sendo utilizado
-- 3) Impedir alteracoes no fator de conversao se houver vinculos a ele
--
DECLARE
   achou                         INTEGER;
   linha                         INTEGER;
   DevePassar                    BOOLEAN;
   vComplemento                  VARCHAR(100) := Constante('Complemento');
   cRet                          VARCHAR(2);
-- Principal
begin
   IF ((TG_OP = 'INSERT')) THEN
      IF NEW.CODITE IS NULL THEN
         NEW.CODITE := ProximoCodigo('TT_SUB','');
      END IF;
   END IF;
 
   IF (TG_OP = 'UPDATE') THEN
      DevePassar := (Equal (NEW.CODSUB, OLD.CODSUB) <> 1) 
                 OR (Equal (NEW.FATCON, OLD.FATCON) <> 1)
                 OR (Equal (NEW.NOMEXT, OLD.NOMEXT) <> 1);
   END IF;

   IF DEVEPASSAR then
      -- Confirma se o codigo foi efetivamente mudado
      -- Verifica se ja nao existe um item de grade utilizando este item de subdivisao
      SELECT COUNT(*) INTO linha FROM TT_GRA WHERE CODTAM = OLD.CODITE;

      IF (OLD.CODSUB <> NEW.CODSUB) AND Linha > 0 THEN
         RAISE EXCEPTION 'PG-20005 Ha itens de grade vinculados ao item de subdivisao. %' , vComplemento;
      END IF;

      -- Verifica se o FATCON pode ser modificado
      IF (NEW.FATCON <> 1) AND (NEW.FATCON <> OLD.FATCON) THEN
         SELECT COUNT(*) INTO ACHOU
           FROM TD_SUB
          WHERE CODSAL = NEW.CODITE;

         IF ACHOU > 0 THEN
            RAISE EXCEPTION 'PG-20006 Fator de conversao nao e 1 para 1. %' , vComplemento;
         END IF;
      END IF;
   END IF;
  
   IF NOT (TG_OP = 'DELETE') THEN
      -- Default
      IF NEW.NOMEXT IS NULL THEN
         NEW.NOMEXT := NEW.NOMITE;
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5149 --*/
CREATE TRIGGER TGSUB2
BEFORE INSERT OR UPDATE OR DELETE ON TT_SUB 
FOR EACH ROW EXECUTE PROCEDURE TGSUB2();

/*-- SEQ 5150 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGSUB3() CASCADE;

/*-- SEQ 5151 --*/
CREATE OR REPLACE FUNCTION TGSUB3() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualizar tabela TT_PROxNOM
-- 2) Atualiza ATU_EM da TT_GRA
--
DECLARE
      cRetorno                      VARCHAR(2);
   cWhere                        TM_ATU.FILTRO%TYPE;
   nCODTAM                       TT_GRA.CODTAM%TYPE;
   
-- Principal
BEGIN
   --Atualiza TT_PROxNOM
   --davi - 21/11/06 - 41296
   IF ((TG_OP = 'UPDATE')) THEN
      IF (Equal(OLD.NOMITE,NEW.NOMITE) = 0) THEN
         
         cRetorno := PC_PROxNOM_Atualiza('IPR.CODTAM = '||NEW.CODITE, null, null, null, null );
                        END IF;
   END IF;
   
   --Tratamento para Atualizar Tabela Pai 
   IF (TG_OP = 'INSERT') THEN
      nCODTAM := NEW.CODITE;
   ELSIF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.NOMITE,NEW.NOMITE) <> 1
      OR Equal(OLD.NOMEXT,NEW.NOMEXT) <> 1
      OR Equal(OLD.CODSUB,NEW.CODSUB) <> 1
      OR Equal(OLD.FATCON,NEW.FATCON) <> 1
      OR Equal(OLD.ORDSUB,NEW.ORDSUB) <> 1
      OR Equal(OLD.TAMPHO,NEW.TAMPHO) <> 1 
      OR Equal(OLD.QTDPHO,NEW.QTDPHO) <> 1 
      OR Equal(OLD.CODEXT,NEW.CODEXT) <> 1 THEN
         nCODTAM := NEW.CODITE;
      ELSE
         nCODTAM := NULL;
      END IF;
   ELSIF (TG_OP = 'DELETE') THEN
      nCODTAM := OLD.CODITE;
   END IF;
   IF ISNOTNULL(TO_CHAR(nCODTAM))='T' THEN
      cWhere := 'CODTAM = ' || TO_CHAR( nCODTAM );
      cRetorno := INSERE_MATU('TT_SUB', 'TT_GRA', cWhere);
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5152 --*/
CREATE TRIGGER TGSUB3
AFTER INSERT OR UPDATE OR DELETE ON TT_SUB 
FOR EACH ROW EXECUTE PROCEDURE TGSUB3();



/*-- SEQ 5153 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGSUB_DW() CASCADE;

/*-- SEQ 5154 --*/
CREATE OR REPLACE FUNCTION TGSUB_DW() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Produto
DECLARE
      
   regDW                         RECORD;
      cDUMMY                        VARCHAR(2);
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');
BEGIN
  IF UsaVMDecisor() = 'T' THEN
     -- (TG_OP = 'INSERT'): No faz nada porque ainda no est relacionado a nenhum produto
     -- (TG_OP = 'DELETE'): Garantido pela FK
     IF (TG_OP = 'UPDATE') THEN
        IF Equal(OLD.CODITE,NEW.CODITE) <> 1 THEN -- PK
           RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
        END IF;
        IF Equal(OLD.NOMITE,NEW.NOMITE) <> 1 THEN
           FOR regDW IN (SELECT DISTINCT DW.FILMAT, DW.CODMAT, DW.CODCOR, DW.CODTAM
                           FROM DW_Produto DW
                          WHERE DW.CODTAM = OLD.CODITE)
           LOOP
              cDUMMY := Insere_DW_Log_Produto(regDW.FILMAT,regDW.CODMAT,regDW.CODCOR,regDW.CODTAM);
           END LOOP;
        END IF;
     END IF;
  END IF; 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5155 --*/
CREATE TRIGGER TGSUB_DW
AFTER UPDATE ON TT_SUB 
FOR EACH ROW EXECUTE PROCEDURE TGSUB_DW();


/*-- SEQ 5156 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGSUP() CASCADE;

/*-- SEQ 5157 --*/
CREATE OR REPLACE FUNCTION TGSUP() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Registrar mudanca dos dados num "log"

   vLOG                          VARCHAR(4000)     := '';                      -- LOG GERAL
   cOld                          VARCHAR(400)      := '';                      -- VALOR ANTIGO
   cNew                          VARCHAR(400)      := '';                      -- VALOR NOVO
   HorasOld                      VARCHAR(7)        := '';                      -- HORAS ANTIGAS, USADO PARA CONVERTER MINUTOS EM HORAS
   HorasNew                      VARCHAR(7)        := '';                      -- HORAS NOVAR,  USADO PARA CONVERTER MINUTOS EM HORAS
   cData                         CHAR(21)           := 'DD/MM/YYYY HH24:MI:SS'; -- FORMATO DE DATA USADA NAS CONVERSOES
   WK_PERMIS                     CHAR(1)            := 'N';
   WK_TIPHOR                     CHAR(1)            := '';
   WK_CARENC                     Numeric(12,2);
   WK_SACFUN                     CHAR(1)            := '';
   WK_SACMOD                     CHAR(1)            := '';
   WK_SACCWS                     CHAR(1)            := '';
      
      QuemLogou                  TRetQuemLogou%ROWTYPE;
      vcomplemento                  CONSTANT VARCHAR(254):= constante('complemento');
   vUSER                         VARCHAR(50);

-- Principal
BEGIN

  -- Pega o Usuario Logado
  SELECT GetApeUsuAtual() INTO vUSER
    FROM DUAL;

  -- Evitar lancamentos fora do perodo de validade e atualizar ATU_EM
  IF not (TG_OP = 'DELETE') THEN
    IF not (Livre(NEW.CODFIL,'TT_SUP',NEW.DATREG) = 1) THEN
      RAISE EXCEPTION 'PG-20039 Lancamento fora do periodo de validade de uso do sistema.%' , vComplemento;
    END IF;


    IF (TG_OP = 'INSERT') THEN
       IF NEW.ATU_EM IS NULL THEN
          NEW.ATU_EM := agora();
       END IF;
    ELSIF (TG_OP = 'UPDATE') THEN
       IF NEW.ATU_EM = OLD.ATU_EM THEN
          NEW.ATU_EM := agora();
       END IF;
    END IF;

    NEW.VERSAO:=trim(NEW.VERSAO);
  END IF;

  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    -- Joga o prximo codigo no sequen
    IF (NEW.SEQUEN IS NULL) THEN
      NEW.SEQUEN:=ProximoCodigo('TT_SUP',NEW.CODFIL);
    END IF;

    NEW.DATREG := agora();

    IF (NEW.SITUAC = 'A') THEN
      NEW.DATABE := ProximaHoraUtil(NEW.CODFIL,NEW.DATREG);
    END IF;

    IF (NEW.SITUAC = 'R') OR (NEW.SITUAC = 'C') THEN
      NEW.DATABE := ProximaHoraUtil(NEW.CODFIL,NEW.DATREG);
      NEW.DATFEC := agora();
    END IF;

  END IF;

  IF (TG_OP = 'UPDATE') THEN
    NEW.DATREG := OLD.DatReg;

    IF Equal(NEW.SITUAC, OLD.SITUAC) <> 1 AND
       (NEW.SITUAC = 'R' OR NEW.SITUAC = 'C')
    THEN
       NEW.FLGACT := null;
       NEW.OMISSO := null;
    END IF;

    -- RFMP 85278 Apagar aceite ao reabrir chamado
    IF Equal(NEW.SITUAC, OLD.SITUAC) <> 1 AND
       (OLD.SITUAC = 'R' AND NEW.SITUAC = 'A')
    THEN
       NEW.FLGACT := null;
       NEW.DATACT := null;
       NEW.TIPACT := null;
       NEW.FILACT := null;
       NEW.CODACT := null;
       NEW.NUMACT := null;
    END IF;

    IF OLD.FILCOB IS NULL AND NEW.FILCOB IS NOT NULL THEN
       NEW.DATCOB := AGORA();
    END IF;

    IF Equal(NEW.FLGACT, OLD.FLGACT) <> 1 AND
       NEW.FLGACT='F' THEN
       NEW.SITUAC:='N';
    END IF;

    IF (Equal(NEW.DATPRO, OLD.DATPRO) <> 1) THEN
       NEW.QTDPRO := COALESCE(OLD.QTDPRO,0)+1;
    ELSE
       NEW.QTDPRO := OLD.QTDPRO;
    END IF;

    -- JR 37281
    IF ((NEW.SITUAC = 'R') OR (NEW.SITUAC = 'C')) AND (Equal(NEW.SITUAC, OLD.SITUAC) <> 1) THEN
       SELECT SAC_EXIGE_CODFUN INTO WK_SACFUN FROM TT_CFG;
       IF (WK_SACFUN = 'T') AND (COALESCE(NEW.CODFUN,0) = 0) AND (NEW.PERFIL <> 'C') THEN
          RAISE EXCEPTION 'PG-20039 Obrigatrio o preenchimento da funcionalidade no fechamento de um chamado. %' , vComplemento;
       END IF;
    END IF;

    IF ((NEW.SITUAC = 'R') OR (NEW.SITUAC = 'C')) AND (Equal(NEW.SITUAC, OLD.SITUAC) <> 1) THEN
       SELECT SAC_EXIGE_MODULO INTO WK_SACMOD FROM TT_CFG;
       IF (WK_SACMOD = 'T') AND (COALESCE(NEW.MODULO,0) = 0) AND (NEW.PERFIL <> 'C') THEN
          RAISE EXCEPTION 'PG-20039 Obrigatrio o preenchimento do mdulo no fechamento de um chamado. %' , vComplemento;
       END IF;
    END IF;

    IF ((NEW.SITUAC = 'R') OR (NEW.SITUAC = 'C')) AND (Equal(NEW.SITUAC, OLD.SITUAC) <> 1) THEN
       SELECT SAC_EXIGE_CODCWS INTO WK_SACCWS FROM TT_CFG;
       IF (WK_SACCWS = 'T') AND (COALESCE(NEW.TIPSUP,0) = 0) AND (NEW.PERFIL <> 'C') THEN
          RAISE EXCEPTION 'PG-20039 Obrigatrio o preenchimento da classificao no fechamento de um chamado. %' , vComplemento;
       END IF;
    END IF;

    select * into QuemLogou from DadosLogon();
    IF not (QuemLogou.Encontrou) THEN
       RAISE EXCEPTION 'PG-20039 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
    END IF;

    IF (OLD.TIPREG='I') and (NEW.TIPREG<>'I') THEN
       RAISE EXCEPTION 'PG-20039 Nao e possivel alterar Registro Via Sistema para estado. %' , vComplemento;
    END IF;

    IF (OLD.TIPREG<>'I') and (NEW.TIPREG='I') THEN
       RAISE EXCEPTION 'PG-20039 Nao e possivel alterar para Registro Via Sistema. %' , vComplemento;
    END IF;

    IF (Equal(NEW.DATABE, OLD.DATABE) <> 1)
    OR (Equal(NEW.DATFEC, OLD.DATFEC) <> 1) THEN
       IF PERMISSAO(vUSER,144) = 0 THEN
         RAISE EXCEPTION 'PG-20040 Voce nao tem permissao para mudar as datas de Abertura e Fechamento. %' , vComplemento;
       END IF;
    end if;

    -- No permitir usurios normais alterarem a prioridade
    IF (Equal(NEW.CODPRI, OLD.CODPRI) <> 1) THEN
       IF (NEW.CODPRI  = 0) THEN
          RAISE EXCEPTION 'PG-20038 Nao e permitido alterar a severidade para "Nao Classificado". %' , vComplemento;
       end if;

       SELECT SUBSTR(PERMISSOESUSUARIO(FILUSU,CODUSU),128,1) INTO WK_PERMIS FROM TT_USU
       WHERE FILUSU = Quemlogou.Filusu
         AND CODUSU = Quemlogou.Codusu;
       SELECT TIPHOR INTO WK_TIPHOR
         FROM TD_PRI
        WHERE CODTAB = OLD.CODPRI;
       SELECT CARENC INTO WK_CARENC
         FROM TD_PRI
        WHERE CODTAB = NEW.CODPRI;
       IF NOT (OLD.CODPRI = 0 OR WK_PERMIS = 'S' OR (WK_TIPHOR = 'U' AND WK_CARENC > 0)) THEN
          RAISE EXCEPTION 'PG-20041 Voc no pode alterar a Severidade. %' , vComplemento;
       END IF;
    end if;


    IF Equal(NEW.SITUAC, OLD.SITUAC) <> 1 THEN
      IF NEW.SITUAC <> 'N' THEN
        IF NEW.DATABE IS NULL THEN
          NEW.DATABE := ProximaHoraUtil(NEW.CODFIL,NEW.DATREG);
        END IF;
      END IF;

      IF (NEW.SITUAC = 'R') OR (NEW.SITUAC = 'C') THEN
        IF NEW.DATABE IS NULL THEN
          NEW.DATABE := ProximaHoraUtil(NEW.CODFIL,NEW.DATREG);
        END IF;

        NEW.DATFEC := agora();
      END IF;

      IF (OLD.SITUAC = 'R') OR (OLD.SITUAC = 'C') THEN
        NEW.DATFEC := null;
      END IF;
    END IF;

    -- Caso o OLD <> NEW entao gera o LOG!!
    IF (OLD.MODULO <> NEW.MODULO) THEN
      IF (OLD.MODULO IS NULL) THEN
        cOld := 'Nulo';
      ELSE
        select MODULO into cOld from TD_MOD where CODTAB = OLD.MODULO ;
      END IF;
      IF (NEW.MODULO IS NULL) THEN
        cNew := 'Nulo';
      ELSE
        select MODULO into cNew from TD_MOD where CODTAB = NEW.MODULO ;
      END IF;
      vLOG := vLOG||'Modulo: de '||cOld||' para '||cNew||chr(13)||chr(10);
    END IF;

    IF (COALESCE(OLD.VERSAO,'Nulo') <> COALESCE(NEW.VERSAO,'Nulo')) THEN
      vLOG := vLOG||'Verso: de '||COALESCE(OLD.VERSAO,'Nulo')||' para '||COALESCE(NEW.VERSAO,'Nulo')||chr(13)||chr(10);
    END IF;

    IF (COALESCE(OLD.RELEASE,'Nulo') <> COALESCE(NEW.RELEASE,'Nulo')) THEN
      vLOG := vLOG||'Release: de '||COALESCE(OLD.RELEASE,'Nulo')||' para '||COALESCE(NEW.RELEASE,'Nulo')||chr(13)||chr(10);
    END IF;

    IF (COALESCE(OLD.FLGCOB ,'Nulo') <> COALESCE(NEW.FLGCOB,'Nulo')) THEN
      select CASE OLD.FLGCOB WHEN 'A' THEN 'A Faturar'
                              WHEN 'C' THEN 'Contrato'
                              WHEN 'S' THEN 'Cortesia'
                              WHEN 'F' THEN 'Faturado'
                              WHEN 'D' THEN 'A Definir'
                              ELSE 'Nulo'
             END into cOld from dual;
      select CASE NEW.FLGCOB WHEN 'A' THEN 'A Faturar'
                              WHEN 'C' THEN 'Contrato'
                              WHEN 'S' THEN 'Cortesia'
                              WHEN 'F' THEN 'Faturado'
                              WHEN 'D' THEN 'A Definir'
                              ELSE 'Nulo'
              END into cNew from dual;
      vLOG := vLOG||'Cobrana: de '||cOld||' para '||cNew||chr(13)||chr(10);
    END IF;

    IF ((COALESCE(OLD.FILRES,'Nulo') <> COALESCE(NEW.FILRES,'Nulo')) OR (COALESCE(OLD.CODRES,'Nulo') <> COALESCE(NEW.CODRES,'Nulo'))) THEN
      IF (OLD.FILRES IS NULL) THEN
        cOld := 'Nulo';
      ELSE
        select APEUSU into cOld from TT_USU where FILUSU = OLD.FILRES AND CODUSU = OLD.CODRES;
      END IF;
      IF (NEW.FILRES IS NULL) THEN
        cNew := 'Nulo';
      ELSE
        select APEUSU into cNew from TT_USU where FILUSU = NEW.FILRES AND CODUSU = NEW.CODRES;
      END IF;
      vLOG := vLOG||'Responsavel: de '||cOld||' para '||cNew||chr(13)||chr(10);
    END IF;

    IF (COALESCE(OLD.DESSUP,'Nulo') <> COALESCE(NEW.DESSUP,'Nulo')) THEN
      vLOG := vLOG||'Ttulo da Tarefa: de '||COALESCE(OLD.DESSUP,'Nulo')||' para '||COALESCE(NEW.DESSUP,'Nulo')||chr(13)||chr(10);
    END IF;

    IF (COALESCE(OLD.E_MAIL,'Nulo') <> COALESCE(NEW.E_MAIL,'Nulo')) THEN
      vLOG := vLOG||'E-mail: de '||COALESCE(OLD.E_MAIL,'Nulo')||' para '||COALESCE(NEW.E_MAIL,'Nulo')||chr(13)||chr(10);
    END IF;

    IF (COALESCE(TO_CHAR(OLD.DATPRO,cData),'Nulo') <> COALESCE(TO_CHAR(NEW.DATPRO,cData),'Nulo')) THEN
      vLOG := vLOG||'Data Prometida: de '||COALESCE(TO_CHAR(OLD.DATPRO,cData),'Nulo')||' para '||COALESCE(TO_CHAR(NEW.DATPRO,cData),'Nulo')||chr(13)||chr(10);
    END IF;

    IF (COALESCE(TO_CHAR(OLD.DATREG,cData),'Nulo') <> COALESCE(TO_CHAR(NEW.DATREG,cData),'Nulo')) THEN
      vLOG := vLOG||'Data do Registro: de '||COALESCE(TO_CHAR(OLD.DATREG,cData),'Nulo')||' para '||COALESCE(TO_CHAR(NEW.DATREG,cData),'Nulo')||chr(13)||chr(10);
    END IF;

    IF (COALESCE(TO_CHAR(OLD.DATCOB,cData),'Nulo') <> COALESCE(TO_CHAR(NEW.DATCOB,cData),'Nulo')) THEN
      vLOG := vLOG||'Data de Cobrana: de '||COALESCE(TO_CHAR(OLD.DATCOB,cData),'Nulo')||' para '||COALESCE(TO_CHAR(NEW.DATCOB,cData),'Nulo')||chr(13)||chr(10);
    END IF;

    IF (COALESCE(OLD.PRICLI,'Nulo') <> COALESCE(NEW.PRICLI,'Nulo')) THEN
      vLOG := vLOG||'Prioridade do Cliente: de '||COALESCE(OLD.PRICLI,'Nulo')||' para '||COALESCE(NEW.PRICLI,'Nulo')||chr(13)||chr(10);
    END IF;

    IF (COALESCE(TO_CHAR(OLD.QTDFAT),'Nulo') <> COALESCE(TO_CHAR(NEW.QTDFAT),'Nulo')) THEN
      HorasOld := TRUNC(OLD.QTDFAT / 60,'000')||':'||LTRIM(RTRIM(TO_CHAR(mod(OLD.QTDFAT,60),'00')));
      HorasNew := TRUNC(NEW.QTDFAT / 60,'000')||':'||LTRIM(RTRIM(TO_CHAR(mod(NEW.QTDFAT,60),'00')));
      vLOG := vLOG||'Horas Cobradas: de '||COALESCE(HorasOld,'Nulo')||' para '||COALESCE(HorasNew,'Nulo')||chr(13)||chr(10);
    END IF;

    IF (COALESCE(OLD.SITUAC,'Nulo') <> COALESCE(NEW.SITUAC,'Nulo')) THEN
      select CASE OLD.SITUAC WHEN 'A' THEN 'Aberto'
                              WHEN 'C' THEN 'Cancelado'
                              WHEN 'E' THEN 'Em Espera'
                              WHEN 'R' THEN 'Resolvido'
                              WHEN 'N' THEN 'No Lido'
                              ELSE 'Nulo'
             END into cOld from dual;
      select CASE NEW.SITUAC WHEN 'A' THEN 'Aberto'
                              WHEN 'C' THEN 'Cancelado'
                              WHEN 'E' THEN 'Em Espera'
                              WHEN 'R' THEN 'Resolvido'
                              WHEN 'N' THEN 'No Lido'
                              ELSE 'Nulo'
             END into cNew from dual;
      vLOG := vLOG||'Situacao: de '||cOld||' para '||cNew||chr(13)||chr(10);
    END IF;

    IF ((COALESCE(OLD.FILCLI,'Nulo') <> COALESCE(NEW.FILCLI,'Nulo')) OR (COALESCE(OLD.CODCLI,'Nulo') <> COALESCE(NEW.CODCLI,'Nulo'))) THEN
      vLOG := vLOG||'Cliente: de '||COALESCE(OLD.FILCLI,'Nulo')||'-'||COALESCE(OLD.CODCLI,'Nulo')||
             ' para '||COALESCE(NEW.FILCLI,'Nulo')||'-'||COALESCE(NEW.CODCLI,'Nulo')||chr(13)||chr(10);
    END IF;

    IF ((COALESCE(OLD.FILEND,'Nulo') <> COALESCE(NEW.FILEND,'Nulo'))
     OR (COALESCE(OLD.NUMEND,-99999) <> COALESCE(NEW.NUMEND,-99999))) THEN
      IF (OLD.FILEND IS NULL) THEN
        cOld := 'Nulo';
      ELSE
        select COALESCE(DEND.DESEND,'INDEFINIDO') into cOld from TT_END ENDE left join TD_END DEND ON DEND.CODTAB = ENDE.TIPEND
        where ENDE.CODFIL = OLD.FILEND AND ENDE.NUMEND = OLD.NUMEND
          and ENDE.FILCLI = OLD.FILCLI AND ENDE.CODCLI = OLD.CODCLI;
      END IF;

      IF (NEW.FILEND IS NULL) THEN
        cNew := 'Nulo';
      ELSE
        select COALESCE(DEND.DESEND,'INDEFINIDO') into cNew from TT_END ENDE left join TD_END DEND ON DEND.CODTAB = ENDE.TIPEND
        where ENDE.CODFIL = NEW.FILEND AND ENDE.NUMEND = NEW.NUMEND
          and ENDE.FILCLI = NEW.FILCLI AND ENDE.CODCLI = NEW.CODCLI;
      END IF;

      vLOG := vLOG||'Endereo do Cliente: de '||cOld||' para '||cNew||chr(13)||chr(10);
    END IF;

    IF Equal(OLD.JUSTIF,NEW.JUSTIF)<>1 THEN
      IF (OLD.JUSTIF IS NULL) THEN
        cOld := 'Nulo';
      ELSE
        select DESJUS into cOld from TD_JUS where CODTAB = OLD.JUSTIF;
      END IF;
      IF (NEW.JUSTIF IS NULL) THEN
        cNew := 'Nulo';
      ELSE
        select DESJUS into cNew from TD_JUS where CODTAB = NEW.JUSTIF;
      END IF;
      vLOG := vLOG||'Justificativa da Situao: de '||COALESCE(cOld,'Nulo')||' para '||COALESCE(cNew,'Nulo')||chr(13)||chr(10);
    END IF;

    IF ((COALESCE(OLD.FILACT,'Nulo') <> COALESCE(NEW.FILACT,'Nulo')) OR
        (COALESCE(OLD.CODACT,'Nulo') <> COALESCE(NEW.CODACT,'Nulo')) OR
        (COALESCE(TO_CHAR(OLD.NUMACT),'Nulo') <> COALESCE(TO_CHAR(NEW.NUMACT),'Nulo'))) THEN

       select COALESCE(
        (select coalesce(NOMTRA,CONTAT)
           from tt_con
          where FILCLI = OLD.FILACT
            AND CODCLI = OLD.CODACT
            AND NUMCON = OLD.NUMACT
         ),'Nulo') into cOld
       from dual;

       select COALESCE(
        (select coalesce(NOMTRA,CONTAT)
           from tt_con
          where FILCLI = OLD.FILACT
            AND CODCLI = OLD.CODACT
            AND NUMCON = OLD.NUMACT
         ),'Nulo') into cOld
       from dual;

      vLOG := vLOG||'Aceito por: de '||cOld||' para '||cNew||chr(13)||chr(10);
    END IF;

    IF (COALESCE(TO_CHAR(OLD.DATACT,cData),'Nulo') <> COALESCE(TO_CHAR(NEW.DATACT,cData),'Nulo')) THEN
      vLOG := vLOG||'Data Aceite: de '||COALESCE(TO_CHAR(OLD.DATACT,cData),'Nulo')||' para '||COALESCE(TO_CHAR(NEW.DATACT,cData),'Nulo')||Chr(13)||chr(10);
    END IF;

    IF (COALESCE(OLD.TIPACT,'Nulo') <> COALESCE(NEW.TIPACT,'Nulo')) THEN
      select CASE OLD.TIPACT WHEN 'V' THEN 'Verbal'
                              WHEN 'T' THEN 'Telefnico'
                              WHEN 'F' THEN 'Fax'
                              WHEN 'E' THEN 'E-mail'
                              WHEN 'C' THEN 'Carta'
                              WHEN 'S' THEN 'Site'
                              WHEN 'M' THEN 'Mensagem Instantnea'
                              ELSE 'Nulo'
             END into cOld from dual;
      select CASE NEW.TIPACT WHEN 'V' THEN 'Verbal'
                              WHEN 'T' THEN 'Telefnico'
                              WHEN 'F' THEN 'Fax'
                              WHEN 'E' THEN 'E-mail'
                              WHEN 'C' THEN 'Carta'
                              WHEN 'S' THEN 'Site'
                              WHEN 'M' THEN 'Mensagem Instantnea'
                              ELSE 'Nulo'
             END into cNew from dual;
      vLOG := vLOG||'Tipo de Aceite: de '||cOld||' para '||cNew||chr(13)||chr(10);
    END IF;

    IF (NEW.FLGACT <> OLD.FLGACT) THEN
      select CASE OLD.FLGACT WHEN 'T' THEN 'Aprovado'
                              WHEN 'F' THEN 'Reprovado'
                              ELSE 'Nulo'
             END into cOld from dual;
      select CASE NEW.FLGACT WHEN 'T' THEN 'Aprovado'
                              WHEN 'F' THEN 'Reprovado'
                              ELSE 'Nulo'
             END into cNew from dual;
      vLOG := vLOG||'Aceito pelo Cliente: de '||COALESCE(cOld,'Nulo')||' para '||COALESCE(cNew,'Nulo')||chr(13)||chr(10);
    END IF;


    IF (NEW.CODPRI <> OLD.CODPRI) THEN
      select DESPRI into cOld from TD_PRI WHERE CODTAB = OLD.CODPRI;
      select DESPRI into cNew from TD_PRI WHERE CODTAB = NEW.CODPRI;
      vLOG := vLOG||'Severidade: de '||COALESCE(cOld,'Nulo')||' para '||COALESCE(cNew,'Nulo')||chr(13)||chr(10);
    END IF;

    IF (NEW.CODFUN <> OLD.CODFUN) THEN
      select DESFUN into cOld from TD_FUN WHERE CODTAB = OLD.CODFUN;
      select DESFUN into cNew from TD_FUN WHERE CODTAB = NEW.CODFUN;
      vLOG := vLOG||'Funcionalidade: de '||COALESCE(cOld,'Nulo')||' para '||COALESCE(cNew,'Nulo')||chr(13)||chr(10);
    END IF;

    IF (NEW.TIPSUP <> OLD.TIPSUP) THEN
      select DESCWS into cOld from TD_CWS WHERE CODTAB = OLD.TIPSUP;
      select DESCWS into cNew from TD_CWS WHERE CODTAB = NEW.TIPSUP;
      vLOG := vLOG||'Classificao do Chamado: de '||COALESCE(cOld,'Nulo')||' para '||COALESCE(cNew,'Nulo')||chr(13)||chr(10);
    END IF;

    IF (COALESCE(OLD.TIPREG,'Nulo') <> COALESCE(NEW.TIPREG,'Nulo')) THEN
      select CASE OLD.TIPACT WHEN 'V' THEN 'Verbal'
                              WHEN 'T' THEN 'Telefnico'
                              WHEN 'F' THEN 'Fax'
                              WHEN 'E' THEN 'E-mail'
                              WHEN 'C' THEN 'Carta'
                              WHEN 'S' THEN 'Site'
                              WHEN 'M' THEN 'Mensagem Instantnea'
                              ELSE 'Nulo'
             END into cOld from dual;
      select CASE NEW.TIPACT WHEN 'V' THEN 'Verbal'
                              WHEN 'T' THEN 'Telefnico'
                              WHEN 'F' THEN 'Fax'
                              WHEN 'E' THEN 'E-mail'
                              WHEN 'C' THEN 'Carta'
                              WHEN 'S' THEN 'Site'
                              WHEN 'M' THEN 'Mensagem Instantnea'
                              ELSE 'Nulo'
             END into cNew from dual;
      vLOG := vLOG||'Tipo de Registro: de '||cOld||' para '||cNew||chr(13)||chr(10);
    END IF;

    IF (COALESCE(OLD.COMJUS,'Nulo') <> COALESCE(NEW.COMJUS,'Nulo')) THEN
      vLOG := vLOG||'Complemento de Justificativa: de '||COALESCE(OLD.COMJUS,'Nulo')||' para '||COALESCE(NEW.COMJUS,'Nulo')||chr(13)||chr(10);
    END IF;

    IF (COALESCE(OLD.QTDPRO,0) <> COALESCE(NEW.QTDPRO,0)) THEN
      vLOG := vLOG||'Nmero de alteraes em Data Promessa: de '||COALESCE(OLD.QTDPRO,0)||' para '||COALESCE(NEW.QTDPRO,0)||chr(13)||chr(10);
    END IF;


    IF ( ISNOTNULL(vLOG)='T') THEN
      INSERT into TL_SUP (CODFIL,SEQUEN,MSGLOG,FLGMUD)
      VALUES (NEW.CODFIL,NEW.SEQUEN,vLOG,'O');
    END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5158 --*/
CREATE TRIGGER TGSUP
BEFORE INSERT OR UPDATE OR DELETE ON TT_SUP 
FOR EACH ROW EXECUTE PROCEDURE TGSUP();


/*-- SEQ 5159 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGTAR() CASCADE;

/*-- SEQ 5160 --*/
CREATE OR REPLACE FUNCTION TGTAR() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

  proximo CHAR(10);
  Filial TT_IDF.CODLOJ%TYPE;

-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
     IF NEW.CODFIL IS NULL THEN
       SELECT CODLOJ INTO Filial FROM TT_IDF;
       NEW.CODFIL := Filial;
     END IF;

    NEW.SEQUEN := ProximoCodigo('TT_TAR',NEW.CODFIL);
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5161 --*/
CREATE TRIGGER TGTAR
BEFORE INSERT ON TT_TAR 
FOR EACH ROW EXECUTE PROCEDURE TGTAR();


/*-- SEQ 5162 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGTCP() CASCADE;

/*-- SEQ 5163 --*/
CREATE OR REPLACE FUNCTION TGTCP() RETURNS TRIGGER AS $$
DECLARE
   cRet                          VARCHAR(2);
BEGIN
   IF (TG_OP = 'DELETE') THEN
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_TCP', TO_CHAR(OLD.CARTAO), TO_CHAR(OLD.numpar));
   END IF;

   IF (TG_OP = 'INSERT') THEN
      --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_TCP', TO_CHAR(NEW.CARTAO), TO_CHAR(NEW.numpar));

      NEW.SEQUEN := ProximoCodigo('TT_TCP',NEW.CODFIL);
   END IF;

   IF NOT (TG_OP = 'DELETE') THEN
      NEW.ATU_EM := AGORA();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5164 --*/
CREATE TRIGGER TGTCP
BEFORE UPDATE OR INSERT OR DELETE ON TT_TCP 
FOR EACH ROW EXECUTE PROCEDURE TGTCP();

/*-- SEQ 5165 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGTCP2() CASCADE;

/*-- SEQ 5166 --*/
CREATE OR REPLACE FUNCTION TGTCP2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5167 --*/
CREATE TRIGGER TGTCP2
AFTER INSERT OR UPDATE OR DELETE ON TT_TCP 
FOR EACH ROW EXECUTE PROCEDURE TGTCP2();


/*-- SEQ 5168 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGTEC() CASCADE;

/*-- SEQ 5169 --*/
CREATE OR REPLACE FUNCTION TGTEC() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
BEGIN
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
      NEW.SEQUEN:=ProximoCodigo('TT_TEC',NEW.CODFIL);
    END IF;
  END IF; 
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5170 --*/
CREATE TRIGGER TGTEC
BEFORE INSERT OR UPDATE ON TT_TEC 
FOR EACH ROW EXECUTE PROCEDURE TGTEC();




/*-- SEQ 5171 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGTEF2() CASCADE;

/*-- SEQ 5172 --*/
CREATE OR REPLACE FUNCTION TGTEF2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
  vComplemento       VARCHAR(100) := constante('complemento');
  nDIAS INTEGER;
  cDUMMY VARCHAR(10);
  inRec  TT_TEF%ROWTYPE;
-- Principal
BEGIN
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
      NEW.SEQUEN:=ProximoCodigo('TT_TEF',NEW.CODFIL);
    END IF;
    
    NEW.DATINC := agora();
    NEW.NSUTRN := TRIM(NEW.NSUTRN);
  END IF; 
  
  IF (TG_OP = 'DELETE') THEN
     RAISE EXCEPTION 'PG-20003 No  permitida a excluso. %' , vComplemento;
  END IF;
  
  
  IF (TG_OP = 'UPDATE') THEN
     
     NEW.ATU_EM:=AGORA();

      
         IF (Equal(OLD.PORORI,NEW.PORORI) <> 1) OR 
            (Equal(OLD.FILUSU,NEW.FILUSU) <> 1) OR 
            (Equal(OLD.CODUSU,NEW.CODUSU) <> 1) OR 
            (Equal(OLD.FILCLI,NEW.FILCLI) <> 1) OR 
            (Equal(OLD.CODCLI,NEW.CODCLI) <> 1) OR 
            (Equal(OLD.CARTAO,NEW.CARTAO) <> 1) OR 
            (Equal(OLD.DATFIS,NEW.DATFIS) <> 1) OR 
            (Equal(OLD.TIPCOB,NEW.TIPCOB) <> 1) OR
            (Equal(OLD.CODBAN,NEW.CODBAN) <> 1) THEN 
                              
                 cDummy := PC_TEF_Atualize(NEW.CODFIL, NEW.SEQUEN);
                       END IF;
          
  END IF;
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5173 --*/
CREATE TRIGGER TGTEF2
BEFORE INSERT OR UPDATE OR DELETE ON TT_TEF 
FOR EACH ROW EXECUTE PROCEDURE TGTEF2();


/*-- SEQ 5174 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGTEF3() CASCADE;

/*-- SEQ 5175 --*/
CREATE OR REPLACE FUNCTION TGTEF3() RETURNS TRIGGER AS $$
DECLARE
  vComplemento       VARCHAR(100) := constante('complemento');

  cDUMMY             CHAR(1);
  vLOG    VARCHAR(4000)     := '';
  cNulo   CONSTANT CHAR(4)   := 'Nulo';
  iNulo   CONSTANT Numeric(1) := 0;
  CRLF    CONSTANT CHAR(1)   := CHR(10);
  cOld VARCHAR(250);
  cNew VARCHAR(250); 
  QuemLogou TRetQuemLogou%ROWTYPE;

BEGIN

  IF (TG_OP = 'UPDATE') THEN 
     IF (Equal(OLD.NUMECF,NEW.NUMECF) = 0) THEN
        vLOG := vLOG||'Nmero do ECF: de '||COALESCE(OLD.NUMECF,cNulo)||' para '||COALESCE(NEW.NUMECF,cNulo)||CRLF;
     END IF;
     
     IF (Equal(OLD.TRN_ID,NEW.TRN_ID) = 0) THEN
        vLOG := vLOG||'Nmero do ID de Transacao: de '||COALESCE(OLD.TRN_ID,iNulo)||' para '||COALESCE(NEW.TRN_ID,iNulo)||CRLF;
     END IF;
     
     IF (Equal(OLD.VLDCAR,NEW.VLDCAR) = 0) THEN
        vLOG := vLOG||'Validacao : de '||COALESCE(OLD.VLDCAR,cNulo)||' para '||COALESCE(NEW.VLDCAR,cNulo)||CRLF;
     END IF;
     
     IF (Equal(OLD.NUMAUT,NEW.NUMAUT) = 0) THEN
        vLOG := vLOG||'Autorizacao : de '||COALESCE(OLD.NUMAUT,cNulo)||' para '||COALESCE(NEW.NUMAUT,cNulo)||CRLF;
     END IF;  
     
     IF (Equal(OLD.NUMCAR,NEW.NUMCAR) = 0) THEN
        vLOG := vLOG||'Numero Cartao : de '||COALESCE(OLD.NUMCAR,cNulo)||' para '||COALESCE(NEW.NUMCAR,cNulo)||CRLF;
     END IF;
     
     IF (Equal(OLD.NSUTRN,NEW.NSUTRN) = 0) THEN
        vLOG := vLOG||'Nr. Transacao : de '||COALESCE(OLD.NSUTRN,cNulo)||' para '||COALESCE(NEW.NSUTRN,cNulo)||CRLF;
     END IF;
     
     IF Equal(OLD.TIPOPE,NEW.TIPOPE) <> 1 THEN
        vLOG := vLOG||'Tipo Operacao: de '||COALESCE(DescricaoDominio('TEF','TIPOPE',OLD.TIPOPE),cNulo)||' para '||COALESCE(DescricaoDominio('TEF','TIPOPE',NEW.TIPOPE),cNulo)||CRLF;
     END IF;
     
     IF Equal(OLD.DATTRN,NEW.DATTRN) <> 1 THEN
        vLOG := vLOG||'Data Transao: de '||COALESCE(TO_CHAR(OLD.DATTRN,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATTRN,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
     
     IF (Equal(OLD.MANUAL,NEW.MANUAL) = 0) THEN
        vLOG := vLOG||'Manual? : de '||COALESCE(OLD.MANUAL,cNulo)||' para '||COALESCE(NEW.MANUAL,cNulo)||CRLF;
     END IF;
     
     IF (Equal(OLD.VLROPE,NEW.VLROPE) = 0) THEN
        vLOG := vLOG||'Valor operacao: de '||COALESCE(OLD.VLROPE,iNulo)||' para '||COALESCE(NEW.VLROPE,iNulo)||CRLF;
     END IF;
     
     IF (Equal(OLD.PORORI,NEW.PORORI) = 0) THEN
        vLOG := vLOG||'Portador original: de '||COALESCE(OLD.PORORI,iNulo)||' para '||COALESCE(NEW.PORORI,iNulo)||CRLF;
     END IF;
     
     IF Equal(OLD.TIPCOB,NEW.TIPCOB) <> 1 THEN
        vLOG := vLOG||'Tipo portador: de '||COALESCE(DescricaoDominio('DCOB','TIPCOB',OLD.TIPCOB),cNulo)||' para '||COALESCE(DescricaoDominio('DCOB','TIPCOB',NEW.TIPCOB),cNulo)||CRLF;
     END IF;
     
     IF (Equal(OLD.CARTAO,NEW.CARTAO) = 0) THEN
        SELECT COALESCE(DESOUT,cNulo) INTO cOld FROM TD_CAR WHERE CODTAB = OLD.CARTAO;
        SELECT COALESCE(DESOUT,cNulo) INTO cNew FROM TD_CAR WHERE CODTAB = NEW.CARTAO;
        vLOG := vLOG||'Cartao: de '||cOld||' para '||cNew||CRLF;
     END IF; 
     
     IF (Equal(OLD.CODBAN,NEW.CODBAN) = 0) THEN
        vLOG := vLOG||'Cd. Bandeira Padro: de '||COALESCE(OLD.CODBAN,cNulo)||' para '||COALESCE(NEW.CODBAN,cNulo)||CRLF;        
     END IF;

     IF (Equal(OLD.FILCLI,NEW.FILCLI) = 0 OR
        Equal(OLD.CODCLI,NEW.CODCLI) = 0) THEN
        vLOG := vLOG||'Cliente: de '||COALESCE(OLD.FILCLI||'/'||TRIM(OLD.CODCLI),cNulo)||' para '||COALESCE(NEW.FILCLI||'/'||TRIM(NEW.CODCLI),cNulo)||CRLF;
     END IF;

     IF (Equal(OLD.DATINC,NEW.DATINC) <> 1) THEN
        vLOG := vLOG||'Data Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
     END IF;

     IF ISNOTNULL(vLOG) = 'T' THEN
       select * into QuemLogou from DadosLogon();  
       INSERT INTO TL_TEF (CODFIL,SEQTEF,FILUSU,CODUSU,DATOPE,MSGLOG)
                     VALUES (NEW.CODFIL,NEW.SEQUEN,QuemLogou.FILUSU,QuemLogou.CODUSU,agora(),vLog);
     END IF;

  END IF;
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5176 --*/
CREATE TRIGGER TGTEF3
AFTER INSERT OR UPDATE ON TT_TEF 
FOR EACH ROW EXECUTE PROCEDURE TGTEF3();




/*-- SEQ 5177 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGTEQ() CASCADE;

/*-- SEQ 5178 --*/
CREATE OR REPLACE FUNCTION TGTEQ() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN := ProximoCodigo('TT_TEQ',NEW.CODFIL);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5179 --*/
CREATE TRIGGER TGTEQ
BEFORE INSERT OR DELETE OR UPDATE ON TT_TEQ 
FOR EACH ROW EXECUTE PROCEDURE TGTEQ();


/*-- SEQ 5180 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGTIN() CASCADE;

/*-- SEQ 5181 --*/
CREATE OR REPLACE FUNCTION TGTIN() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Atualiza DATINC
-- 3) Atualiza ATU_EM
 
-- Principal
BEGIN  
   IF (TG_OP = 'INSERT') THEN
      NEW.SEQUEN := ProximoCodigo('TT_TIN',NEW.CODFIL);
      NEW.DATINC := AGORA();
   END IF;
  
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := AGORA();
   END IF;  
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5182 --*/
CREATE TRIGGER TGTIN
BEFORE INSERT OR UPDATE OR DELETE ON TT_TIN 
FOR EACH ROW EXECUTE PROCEDURE TGTIN();




/*-- SEQ 5183 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGTIT2() CASCADE;

/*-- SEQ 5184 --*/
CREATE OR REPLACE FUNCTION TGTIT2() RETURNS TRIGGER AS $$

-- Objetivo:
-- 1) Impedir exclusoes
-- 2) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 3) Consistir Titulos
-- 4) Gerar Instrucoes dependendo da alteracao.

DECLARE
   wk_Remessas        TT_CFG%ROWTYPE;
   wk_ARealizar       VARCHAR(20);
   WK_CONTA           Numeric(10);
   WK_REC_FLGEST      TT_REC.FLGEST%TYPE;
   WK_ENVREM          CHAR(1);

   WK_REC	      TT_REC%ROWTYPE;

   cData  CHAR(21)    := 'DD/MM/YYYY HH24:MI:SS'; -- FORMATO DE DATA USADA NAS CONVERSOES

   c_cancelar       CONSTANT CHAR(1) := 'C';
   c_pago           CONSTANT CHAR(1) := 'P';
   c_aberto         CONSTANT CHAR(1) := 'A';
   c_inconsistente  CONSTANT CHAR(1) := 'I';
   c_Estornado      CONSTANT CHAR(1) := 'X';
   c_Protestado     CONSTANT CHAR(1) := 'T';
   c_Nulo           CONSTANT CHAR(1) := NULL ;
   vComplemento     CONSTANT VARCHAR(100) := constante('complemento');
   vVEM_DE_TGRTB    CONSTANT VARCHAR(100) := constante('vem_de_tgrtb');
   bContinue        Boolean;
   cDUMMY           CHAR(2);
   WK_FLGREC        TT_REC.FLGEST%TYPE;
   WK_PORTAD        TT_REC.PORTAD%TYPE;

 --PTULIO 33666
   vTOLERANCIA         TT_REC.VLRPAR%TYPE;
   vVALOR_COM_DESCONTO TT_REC.VLRPAR%TYPE;
   vVLRPAGAR           TT_REC.VLRPAR%TYPE;
   WK_DIAPRO TT_CTB.DIAPRO%TYPE;
   WK_PERPRO TT_CTB.PERPRO%TYPE;
   WK_NUMPRO TT_CTB.NUMPRO%TYPE;
   vACHOU     Boolean;
   WK_DATPRO Timestamp;
   WK_JURPRO TT_CTB.PERPRO%TYPE;
   vAux VARCHAR(10);
 --PTULIO 33666

-- Principal
BEGIN

  SELECT INT_CAN_TIT, INT_ALT_DAT, INT_ALT_VLR,
         INT_PAG_CAR, INT_INC_TIT, INT_CON_DES,
         INT_CAN_DES, INT_PRT_TIT, INT_S_B_PRT,
         INT_S_C_PRT
    INTO wk_Remessas.INT_CAN_TIT, wk_Remessas.INT_ALT_DAT, wk_Remessas.INT_ALT_VLR,
         wk_Remessas.INT_PAG_CAR, wk_Remessas.INT_INC_TIT, wk_Remessas.INT_CON_DES,
         wk_Remessas.INT_CAN_DES, wk_Remessas.INT_PRT_TIT, wk_Remessas.INT_S_B_PRT,
         wk_Remessas.INT_S_C_PRT
    FROM TT_CFG;

  IF (TG_OP = 'UPDATE') THEN
     IF (TG_OP = 'DELETE') THEN
        RAISE EXCEPTION 'PG-20001 Um titulo nao pode ser excluido. %' , vComplemento;
     END IF;

     IF  (OLD.FLGEST in (c_Cancelar,c_Pago))
     AND (NEW.FLGEST = c_Protestado) THEN
        RAISE EXCEPTION 'PG-20003 Um titulo cancelado ou pago nao pode ser protestado. %' , vComplemento;
     END IF;

     IF OLD.FLGEST in (c_Cancelar) THEN
        RAISE EXCEPTION 'PG-20002 Um titulo cancelado ou pago nao pode ser modificado. %' , vComplemento;
     END IF;

     IF  ( OLD.FLGEST <> NEW.FLGEST )
     AND ( OLD.FLGEST = C_Pago       )
     AND ( NEW.FLGEST <> C_Cancelar  ) then
        RAISE EXCEPTION 'PG-20002 Um titulo cancelado ou pago nao pode ser modificado. %' , vComplemento;
     END IF;
  END IF;

  IF (TG_OP = 'INSERT') THEN
     IF NEW.SEQUEN IS NULL THEN
        NEW.SEQUEN := ProximoCodigo('TT_TIT',NEW.CODFIL);
     END IF;
  END IF;

  IF (TG_OP = 'UPDATE') THEN
     NEW.VLRORI := OLD.VLRORI; -- Nao altera
  END IF;

  -- Tratamento de Erro
  IF  (NEW.CODMOR = 0)
  OR  (NEW.CODMOR IS NULL) THEN
     NEW.JURMOR := Null;
     NEW.CODMOR := 0;
     NEW.DATMOR := Null;
  END IF;

  IF  (NEW.CODMOR = 3) THEN
     NEW.JURMOR := Null;
     NEW.DATMOR := Null;
  END IF;

  IF (NEW.CODDES = 0)
  OR (NEW.CODDES IS NULL) THEN
     NEW.JURDES := Null;
     NEW.CODDES := 0;
     NEW.DATDES := Null;
  END IF;

  IF  (NEW.CODPRT = 0)
  OR  (NEW.CODPRT IS NULL) THEN
     NEW.CODPRT := 0;
     NEW.PRZPRT := Null;
  END IF;

  IF  (NEW.CODBAI =0 )
  OR  (NEW.CODBAI IS NULL) THEN
     NEW.CODBAI := 0;
     NEW.PRZBAI := Null;
  END IF;

  -- Tentar consistir o titulo
  cDUMMY := TGR_ConsistirTitulos(NEW.CODFIL, NEW.SEQUEN, NEW.FILREC, NEW.SEQREC, NEW.PARREC, NEW.SUBREC,
                                 NEW.CODBCO, NEW.NUMAGE, NEW.CTACRR, NEW.CODECB, NEW.CODCCB, NEW.NOSNUM,
                                 NEW.CODREM);

  NEW.CODERR := NULL;
  IF substr(cDUMMY,1,1) <> 'T' THEN
     NEW.CODERR := substr(cDUMMY,1,1);
     IF NEW.CODERR = 'U' THEN
        NEW.CODERR := NULL;
     END IF;
  END IF;
  WK_ENVREM   := substr(cDUMMY,2,1);

  -- Se os novos dados do titulo estao pra nao enviar, verificar se os dados antigos tambem estavam
  -- rfmp 64513
  IF (TG_OP = 'UPDATE') THEN
    IF WK_ENVREM <> 'T' THEN
      WK_ENVREM := SUBSTR(TGR_ConsistirTitulos(OLD.CODFIL, OLD.SEQUEN, OLD.FILREC, OLD.SEQREC, OLD.PARREC, OLD.SUBREC,
                                            OLD.CODBCO, OLD.NUMAGE, OLD.CTACRR, OLD.CODECB, OLD.CODCCB, OLD.NOSNUM,
                                            OLD.CODREM),2,1);
    END IF;
  END IF;

  IF NEW.CODERR <> 'U' THEN
     NEW.FLGEST := c_Inconsistente;
  ELSIF (TG_OP = 'UPDATE') THEN
     IF (OLD.FLGEST = c_Inconsistente) AND (NEW.FLGEST <> c_cancelar) THEN
        -- HABILITA O TiTULO CONFORME A REC
        SELECT FLGEST
          INTO WK_REC_FLGEST
          FROM TT_REC
         WHERE NEW.FILREC = CODFIL
           AND NEW.SEQREC = SEQUEN
           AND NEW.PARREC = NUMPAR
           AND NEW.SUBREC = SUBPAR;
        IF wk_REC_FLGEST <> c_Estornado THEN
           NEW.FLGEST := wk_REC_FLGEST;
        ELSE
           NEW.FLGEST := c_Cancelar;
        END IF;
     END IF;
  END IF;

  IF  (NEW.FLGEST = c_cancelar)
  AND (NEW.SEQCAN IS NULL) THEN
     NEW.SEQCAN := ProximoCodigo('TT_TIT',NEW.CODFIL);
  END IF;

 
  IF (TG_OP = 'UPDATE') THEN
     -- Se FLGEST foi alterado, alterar a REC
     IF (NEW.FLGEST <> OLD.FLGEST) AND
        (COALESCE(TRIM(NEW.DUMMY),'#') = vVEM_DE_TGRTB) AND
        (NOT (NEW.FLGEST = 'P')) THEN
        -- Atualizacao da TG_RTB
	  IF NEW.FLGEST = 'C' THEN

	      SELECT CODFIL,SEQUEN,NUMPAR,FLGEST,ATU_EM,DATVEN,VLRPAR,CODMOE,PORTAD,SIGNAT,SEQCHE,CODUSU,
	             FILREC,FILUSU,NUMECF,CUPFIS,PAGAME,VLRDES,VLRPGT,CARTAO,DUMMY,TIPCCC,SUBPAR
	        INTO WK_REC.CODFIL,WK_REC.SEQUEN,WK_REC.NUMPAR,WK_REC.FLGEST,WK_REC.ATU_EM,WK_REC.DATVEN,
		     WK_REC.VLRPAR,WK_REC.CODMOE,WK_REC.PORTAD,WK_REC.SIGNAT,WK_REC.SEQCHE,WK_REC.CODUSU,
	             WK_REC.FILREC,WK_REC.FILUSU,WK_REC.NUMECF,WK_REC.CUPFIS,WK_REC.PAGAME,WK_REC.VLRDES,
		     WK_REC.VLRPGT,WK_REC.CARTAO,WK_REC.DUMMY,WK_REC.TIPCCC,WK_REC.SUBPAR
	        FROM TT_REC
               WHERE NEW.FILREC =  CODFIL
       	         AND NEW.SEQREC =  SEQUEN
		 AND NEW.PARREC =  NUMPAR
		 AND NEW.SUBREC =  SUBPAR;


	      UPDATE TT_REC SET FLGEST = 'C',
	                        dummy = vVEM_DE_TGRTB
	              WHERE NEW.FILREC =  CODFIL
		        AND NEW.SEQREC =  SEQUEN
		        AND NEW.PARREC =  NUMPAR
		        AND NEW.SUBREC =  SUBPAR;

	      INSERT INTO TT_REC (CODFIL,SEQUEN,NUMPAR,FLGEST,ATU_EM,DATVEN,VLRPAR,CODMOE,PORTAD,SIGNAT,SEQCHE,CODUSU,FILREC,
	                          FILUSU,NUMECF,CUPFIS,PAGAME,VLRDES,VLRPGT,CARTAO,DUMMY,TIPCCC,SUBPAR,SUBORI)
			   VALUES(WK_REC.CODFIL,WK_REC.SEQUEN,WK_REC.NUMPAR,'A',agora(),WK_REC.DATVEN,WK_REC.VLRPAR,
			          WK_REC.CODMOE,WK_REC.PORTAD,WK_REC.SIGNAT,WK_REC.SEQCHE,WK_REC.CODUSU,WK_REC.FILREC,
				  WK_REC.FILUSU,WK_REC.NUMECF,WK_REC.CUPFIS,WK_REC.PAGAME,WK_REC.VLRDES,WK_REC.VLRPGT,
				  WK_REC.CARTAO,vVEM_DE_TGRTB,WK_REC.TIPCCC,LPAD(TO_CHAR(to_number(WK_REC.SUBPAR)+1),2),WK_REC.SUBPAR);

	   ELSE
    	   UPDATE TT_REC
                 SET FLGEST = CASE NEW.FLGEST WHEN 'I' THEN 'A'
                                               WHEN 'T' THEN 'A'
                                               ELSE NEW.FLGEST
                              END,
                     DUMMY = vVEM_DE_TGRTB
         WHERE NEW.FILREC =  CODFIL
           AND NEW.SEQREC =  SEQUEN
                 AND NEW.PARREC =  NUMPAR
                 AND NEW.SUBREC =  SUBPAR
                 AND (CASE NEW.FLGEST WHEN 'I' THEN 'A'
                                       WHEN 'T' THEN 'A'
                                       ELSE NEW.FLGEST
                      END) <> FLGEST;
        END IF;

     END IF;


     bContinue := True;
     IF (NEW.FLGEST = 'P') AND
        (COALESCE(TRIM(NEW.DUMMY),'#') = vVEM_DE_TGRTB) THEN
        bContinue := False;
     END IF;

     -- Inicio dos testes de FLGEST
     IF (NEW.FLGEST = c_Inconsistente) then
        -- Tambem passa por aqui quando inclui um titulo inconsistente
        bContinue := False;
     END IF;

     
     IF (NEW.FLGEST = c_aberto) then
        -- Tambem passa por aqui quando inclui um titulo inconsistente
        bContinue := True;
     END IF;
     
     -- Se de aberto passou para pago
     IF (NEW.FLGEST = c_Pago) AND (OLD.FLGEST = c_aberto) then
        vAux:=CriaSubparTitulo (NEW.FILREC,NEW.SEQREC,NEW.PARREC,NEW.SUBREC,
                                NEW.CODBCO,NEW.NUMAGE,NEW.CTACRR,NEW.JURDES,
                                NEW.CODDES,NEW.DATDES,NEW.VLRORI);
     END IF;
----------- --PTulio 33666

     -- Se de inconsistente passou para pago ou cancelado
     IF (NEW.FLGEST IN (c_Pago,c_Cancelar)) AND (OLD.FLGEST = c_Inconsistente) then
        SELECT COUNT(*) INTO WK_CONTA FROM TT_IXT IXT
         WHERE IXT.CODFIL = NEW.CODFIL
           AND IXT.SEQTIT = NEW.SEQUEN;
        IF (WK_CONTA > 0) AND (WK_ENVREM = 'T') THEN
           cDUMMY := TGR_CadastrarIXT(NEW.CODFIL, NEW.SEQUEN, NEW.FILREC, NEW.SEQREC, NEW.PARREC, NEW.SUBREC, NEW.CODBCO, NEW.CODECB, NEW.CODCCB,NEW.DUMMY,wk_Remessas.INT_CAN_TIT);
        END IF;
        bContinue := False;
     END IF;

     -- se de inconsistente passou para aberto
     IF bContinue AND ((NEW.FLGEST = c_Aberto) AND (OLD.FLGEST = c_Inconsistente)) then
        SELECT COUNT(*) INTO WK_CONTA
          FROM TT_IXT IXT
         WHERE IXT.CODFIL = NEW.CODFIL
           AND IXT.SEQTIT = NEW.SEQUEN;

        IF (WK_CONTA = 0) AND (WK_ENVREM = 'T') AND (WK_ENVREM = 'T') THEN
           cDUMMY := TGR_CadastrarIXT(NEW.CODFIL, NEW.SEQUEN, NEW.FILREC, NEW.SEQREC, NEW.PARREC, NEW.SUBREC, NEW.CODBCO, NEW.CODECB, NEW.CODCCB, NEW.DUMMY, wk_Remessas.INT_INC_TIT);
        END IF;

        bContinue := False;
     END IF;

     -- Qualquer modificacao na Remessa gera automaricamente uma nova IXT
     IF bContinue AND (COALESCE(NEW.CODREM,-9) <> COALESCE(OLD.CODREM,-9)) AND (WK_ENVREM = 'T') THEN
        cDUMMY := TGR_CadastrarIXT(NEW.CODFIL, NEW.SEQUEN, NEW.FILREC, NEW.SEQREC, NEW.PARREC, NEW.SUBREC, NEW.CODBCO, NEW.CODECB, NEW.CODCCB,NEW.DUMMY,NEW.CODREM);
        bContinue := False;
     END IF;

     IF bContinue THEN
        -- Alteracao de outros valores
        IF ((COALESCE(NEW.CODCCB, -99)                        <> COALESCE(OLD.CODCCB, -99))
        OR  (COALESCE(NEW.CODECB, -99)                        <> COALESCE(OLD.CODECB, -99))
        OR  (COALESCE(NEW.CODMOR, -9 )                        <> COALESCE(OLD.CODMOR, -9) )
        OR  (COALESCE(NEW.JURMOR, -99)                        <> COALESCE(OLD.JURMOR, -99))
        OR  (COALESCE(TO_CHAR(NEW.DATMOR,cData),'##/##/####') <> COALESCE(TO_CHAR(OLD.DATMOR,cData),'##/##/####'))
        OR  (COALESCE(NEW.CODPRT, -9)                         <> COALESCE(OLD.CODPRT, -9) )
        OR  (COALESCE(NEW.PRZPRT, -99)                        <> COALESCE(OLD.PRZPRT, -99))
        OR  (COALESCE(NEW.CODBAI, -9)                         <> COALESCE(OLD.CODBAI, -9) )
        OR  (COALESCE(NEW.PRZBAI, -99)                        <> COALESCE(OLD.PRZBAI, -99))
        OR  (COALESCE(NEW.ACEITE, '#')                        <> COALESCE(OLD.ACEITE, '#'))) THEN
          IF (WK_ENVREM = 'T') THEN
            cDUMMY := TGR_CadastrarIXT(NEW.CODFIL, NEW.SEQUEN, NEW.FILREC, NEW.SEQREC, NEW.PARREC, NEW.SUBREC, NEW.CODBCO, NEW.CODECB, NEW.CODCCB,NEW.DUMMY,wk_Remessas.INT_ALT_VLR);
          END IF;
        END IF;

        -- Valor Origem nao pode ser alterado
        IF COALESCE(NEW.VLRABT,-99999) <> COALESCE(OLD.VLRABT,-99999) THEN
           NEW.VLRABT := OLD.VLRABT;
        END IF;

        -- Conceder desconto
        IF ((COALESCE(OLD.coddes,0) = 0) AND (COALESCE(NEW.coddes,0) <> 0 )) AND (WK_ENVREM = 'T') THEN
           cDUMMY := TGR_CadastrarIXT(NEW.CODFIL, NEW.SEQUEN, NEW.FILREC, NEW.SEQREC, NEW.PARREC, NEW.SUBREC, NEW.CODBCO, NEW.CODECB, NEW.CODCCB, NEW.DUMMY, wk_Remessas.INT_CON_DES);
        END IF;

        -- Cancelar Desconto
        IF ((COALESCE(OLD.coddes,0) <> 0) AND (COALESCE(NEW.coddes,0) = 0 )) AND (WK_ENVREM = 'T') THEN
           cDUMMY := TGR_CadastrarIXT(NEW.CODFIL, NEW.SEQUEN, NEW.FILREC, NEW.SEQREC, NEW.PARREC, NEW.SUBREC, NEW.CODBCO, NEW.CODECB, NEW.CODCCB, NEW.DUMMY, wk_Remessas.INT_CAN_DES);
        END IF;

        -- Alteracao de Desconto
        IF  (COALESCE(OLD.coddes,0) <> 0)
        AND (COALESCE(NEW.coddes,0) <> 0)
        AND ((COALESCE(NEW.CODDES, -9)                         <> COALESCE(OLD.CODDES, -9)  )
        OR   (COALESCE(NEW.JURDES, -99)                        <> COALESCE(OLD.JURDES, -99) )
        OR   (COALESCE(TO_CHAR(NEW.DATDES,cData),'##/##/####') <> COALESCE(TO_CHAR(OLD.DATDES,cData),'##/##/####'))) then
          IF (WK_ENVREM = 'T') THEN
            IF wk_Remessas.INT_CAN_DES <> wk_Remessas.INT_CON_DES THEN
               cDUMMY := TGR_CadastrarIXT(NEW.CODFIL, NEW.SEQUEN, NEW.FILREC, NEW.SEQREC, NEW.PARREC, NEW.SUBREC, NEW.CODBCO, NEW.CODECB, NEW.CODCCB,NEW.DUMMY, wk_Remessas.INT_CAN_DES);
               cDUMMY := TGR_CadastrarIXT(NEW.CODFIL, NEW.SEQUEN, NEW.FILREC, NEW.SEQREC, NEW.PARREC, NEW.SUBREC, NEW.CODBCO, NEW.CODECB, NEW.CODCCB,NEW.DUMMY, wk_Remessas.INT_CON_DES);
            ELSE
               cDUMMY := TGR_CadastrarIXT(NEW.CODFIL, NEW.SEQUEN, NEW.FILREC, NEW.SEQREC, NEW.PARREC, NEW.SUBREC, NEW.CODBCO, NEW.CODECB, NEW.CODCCB,NEW.DUMMY, wk_Remessas.INT_CON_DES);
            END IF;
          END IF;
        END IF;

        -- Protestar Titulo
        IF (COALESCE(OLD.FLGEST,'#') <> c_Protestado) and (NEW.FLGEST = c_Protestado) AND (WK_ENVREM = 'T') THEN
           cDUMMY := TGR_CadastrarIXT(NEW.CODFIL, NEW.SEQUEN, NEW.FILREC, NEW.SEQREC, NEW.PARREC, NEW.SUBREC, NEW.CODBCO, NEW.CODECB, NEW.CODCCB,NEW.DUMMY, wk_Remessas.INT_PRT_TIT);
        END IF;

        -- Sustar protesto, com baixa de titulo
        IF (COALESCE(OLD.FLGEST,'#') = c_Protestado) and (NEW.FLGEST IN (c_Cancelar,c_pago)) AND (WK_ENVREM = 'T') THEN
           cDUMMY := TGR_CadastrarIXT(NEW.CODFIL, NEW.SEQUEN, NEW.FILREC, NEW.SEQREC, NEW.PARREC, NEW.SUBREC, NEW.CODBCO, NEW.CODECB, NEW.CODCCB,NEW.DUMMY, wk_Remessas.INT_S_B_PRT);
        END IF;

        -- Sustar protesto, com manutencao do titulo
        IF (COALESCE(OLD.FLGEST,'#') = c_Protestado) and (NEW.FLGEST NOT IN (c_Cancelar,c_pago)) AND (WK_ENVREM = 'T') THEN
           cDUMMY := TGR_CadastrarIXT(NEW.CODFIL, NEW.SEQUEN, NEW.FILREC, NEW.SEQREC, NEW.PARREC, NEW.SUBREC, NEW.CODBCO, NEW.CODECB, NEW.CODCCB,NEW.DUMMY, wk_Remessas.INT_S_C_PRT);
        END IF;

        -- Pagar em carteira
        IF (COALESCE(OLD.FLGEST,'#') NOT IN (c_Pago,c_Protestado)) and (NEW.FLGEST = c_Pago) AND (WK_ENVREM = 'T') THEN
           cDUMMY := TGR_CadastrarIXT(NEW.CODFIL, NEW.SEQUEN, NEW.FILREC, NEW.SEQREC, NEW.PARREC, NEW.SUBREC, NEW.CODBCO, NEW.CODECB, NEW.CODCCB,NEW.DUMMY, wk_Remessas.INT_PAG_CAR);
        END IF;

        -- Cancelar Titulo
        IF (COALESCE(OLD.FLGEST,'#') NOT IN (c_PAGO,C_Cancelar,c_Protestado)) and (NEW.FLGEST = c_Cancelar) AND (WK_ENVREM = 'T') THEN
           cDUMMY := TGR_CadastrarIXT(NEW.CODFIL, NEW.SEQUEN, NEW.FILREC, NEW.SEQREC, NEW.PARREC, NEW.SUBREC, NEW.CODBCO, NEW.CODECB, NEW.CODCCB,NEW.DUMMY, wk_Remessas.INT_CAN_TIT);
        END IF;

     END IF;
  END IF;

  NEW.CODREM := NULL;
  NEW.DUMMY  := NULL;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5185 --*/
CREATE TRIGGER TGTIT2
BEFORE INSERT OR DELETE OR UPDATE ON TT_TIT 
FOR EACH ROW EXECUTE PROCEDURE TGTIT2();


/*-- SEQ 5186 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGTIT3() CASCADE;

/*-- SEQ 5187 --*/
CREATE OR REPLACE FUNCTION TGTIT3() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Impedir exclusoes
-- 2) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 3) Consistir Titulos
-- 4) Gerar Instrucoes dependendo da alteracao.
-- 5) Gerar log

DECLARE
   wk_Remessas        TT_CFG%ROWTYPE;
   wk_ARealizar       VARCHAR(20);
   WK_CONTA           Numeric(10);
   WK_REC_FLGEST      TT_REC.FLGEST%TYPE;
   WK_ENVREM          CHAR(1);

   WK_REC	      TT_REC%ROWTYPE;

   cData  CHAR(21)    := 'DD/MM/YYYY HH24:MI:SS'; -- FORMATO DE DATA USADA NAS CONVERSOES

   c_cancelar       CONSTANT CHAR(1) := 'C';
   c_pago           CONSTANT CHAR(1) := 'P';
   c_aberto         CONSTANT CHAR(1) := 'A';
   c_inconsistente  CONSTANT CHAR(1) := 'I';
   c_Estornado      CONSTANT CHAR(1) := 'X';
   c_Protestado     CONSTANT CHAR(1) := 'T';
   vComplemento     CONSTANT VARCHAR(100) := constante('complemento');
   vVEM_DE_TGRTB    CONSTANT VARCHAR(100) := constante('vem_de_tgrtb');
   bContinue        Boolean;
   cDUMMY           CHAR(2);
   WK_FLGREC        TT_REC.FLGEST%TYPE;
   WK_PORTAD        TT_REC.PORTAD%TYPE;

  /* variveis de log - incio */
    
  QuemLogou TRetQuemLogou%ROWTYPE;
    vLOG      VARCHAR(4000)     := '';
  cNulo     CONSTANT CHAR(4)   := 'Nulo';
  iNulo     CONSTANT Numeric(1) := 0;
  CRLF      CONSTANT CHAR(1)   := CHR(10);
  vTIT      CHAR(20)           := '';
  wk_coduid tt_uid.coduid%type;
  /* variveis de log - fim */

-- Principal
BEGIN
  SELECT INT_CAN_TIT, INT_ALT_DAT, INT_ALT_VLR,
         INT_PAG_CAR, INT_INC_TIT, INT_CON_DES,
         INT_CAN_DES, INT_PRT_TIT, INT_S_B_PRT,
         INT_S_C_PRT
    INTO wk_Remessas.INT_CAN_TIT, wk_Remessas.INT_ALT_DAT, wk_Remessas.INT_ALT_VLR,
         wk_Remessas.INT_PAG_CAR, wk_Remessas.INT_INC_TIT, wk_Remessas.INT_CON_DES,
         wk_Remessas.INT_CAN_DES, wk_Remessas.INT_PRT_TIT, wk_Remessas.INT_S_B_PRT,
         wk_Remessas.INT_S_C_PRT
    FROM TT_CFG;

  -- Tentar consistir o titulo
  cDUMMY := TGR_ConsistirTitulos(NEW.CODFIL, NEW.SEQUEN, NEW.FILREC, NEW.SEQREC, NEW.PARREC, NEW.SUBREC,
                                 NEW.CODBCO, NEW.NUMAGE, NEW.CTACRR, NEW.CODECB, NEW.CODCCB, NEW.NOSNUM,
                                 NEW.CODREM);

  NEW.CODERR := NULL;
  IF substr(cDUMMY,1,1) <> 'T' THEN
     NEW.CODERR := substr(cDUMMY,1,1);
     IF NEW.CODERR = 'U' THEN
        NEW.CODERR := NULL;
     END IF;
  END IF;
  WK_ENVREM   := substr(cDUMMY,2,1);

  IF (TG_OP = 'INSERT') THEN
    IF (NEW.FLGEST = c_Aberto) AND
       (WK_ENVREM = 'T') then
       cDUMMY := TGR_CadastrarIXT(NEW.CODFIL, NEW.SEQUEN, NEW.FILREC, NEW.SEQREC, NEW.PARREC, NEW.SUBREC, NEW.CODBCO, NEW.CODECB, NEW.CODCCB,NEW.DUMMY, wk_Remessas.INT_INC_TIT);
    END IF;
  END IF;

  -- rfmp 67319
  IF (TG_OP = 'UPDATE') THEN
     IF (Equal(OLD.ACEITE,NEW.ACEITE) = 0) THEN
        vLOG := vLOG||'Aceitar?: de '||COALESCE(OLD.ACEITE,cNulo)||' para '||COALESCE(NEW.ACEITE,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.AGECOB,NEW.AGECOB) = 0) THEN
        vLOG := vLOG||'Agncia Cobrana: de '||COALESCE(OLD.AGECOB,iNulo)||' para '||COALESCE(NEW.AGECOB,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.CODBAI,NEW.CODBAI) = 0) THEN
        vLOG := vLOG||'Tipo de Baixa: de '||COALESCE(OLD.CODBAI,iNulo)||' para '||COALESCE(NEW.CODBAI,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.CODBCO,NEW.CODBCO) = 0) THEN
        vLOG := vLOG||'Banco: de '||COALESCE(OLD.CODBCO,cNulo)||' para '||COALESCE(NEW.CODBCO,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.CODCCB,NEW.CODCCB) = 0) THEN
        vLOG := vLOG||'Carteira: de '||COALESCE(TO_CHAR(OLD.CODCCB),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODCCB),cNulo)||CRLF;
        IF EnviaRemessa(OLD.CODCCB) <> EnviaRemessa(NEW.CODCCB) THEN
           vLOG := vLOG||'Envia Remessa?: de '||EnviaRemessa(OLD.CODCCB)||' para '||EnviaRemessa(NEW.CODCCB)||CRLF;
        END IF;
     END IF;
     IF (Equal(OLD.CODDES,NEW.CODDES) = 0) THEN
        vLOG := vLOG||'Tipo Desconto: de '||COALESCE(OLD.CODDES,iNulo)||' para '||COALESCE(NEW.CODDES,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.CODECB,NEW.CODECB) = 0) THEN
        vLOG := vLOG||'Espcie: de '||COALESCE(TO_CHAR(OLD.CODECB),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODECB),cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.CODERR,NEW.CODERR) = 0) THEN
        vLOG := vLOG||'Erro: de '||COALESCE(OLD.CODERR,cNulo)||' para '||COALESCE(NEW.CODERR,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.CODFIL,NEW.CODFIL) = 0) THEN
        vLOG := vLOG||'Filial: de '||COALESCE(OLD.CODFIL,cNulo)||' para '||COALESCE(NEW.CODFIL,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.CODMOR,NEW.CODMOR) = 0) THEN
        vLOG := vLOG||'Juros de Mora: de '||COALESCE(OLD.CODMOR,iNulo)||' para '||COALESCE(NEW.CODMOR,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.CODPRT,NEW.CODPRT) = 0) THEN
        vLOG := vLOG||'Protesto: de '||COALESCE(OLD.CODPRT,iNulo)||' para '||COALESCE(NEW.CODPRT,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.CODREM,NEW.CODREM) = 0) THEN
        vLOG := vLOG||'Remessa: de '||COALESCE(OLD.CODREM,iNulo)||' para '||COALESCE(NEW.CODREM,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.CTACRR,NEW.CTACRR) = 0) THEN
        vLOG := vLOG||'Conta Corrente N.: de '||COALESCE(OLD.CTACRR,cNulo)||' para '||COALESCE(NEW.CTACRR,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.DATDES,NEW.DATDES) = 0) THEN
        vLOG := vLOG||'Data Desconto: de '||COALESCE(TO_CHAR(OLD.DATDES,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATDES,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.DATMOR,NEW.DATMOR) = 0) THEN
        vLOG := vLOG||'Data Juros: de '||COALESCE(TO_CHAR(OLD.DATMOR,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATMOR,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
	 -- Paulo K. - 89699
	 IF (Equal(OLD.DATVEN,NEW.DATVEN) = 0) THEN
        vLOG := vLOG||'Data Vencimento: de '||COALESCE(TO_CHAR(OLD.DATVEN,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATVEN,'DD/MM/YYYY'),cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.DIGCOB,NEW.DIGCOB) = 0) THEN
        vLOG := vLOG||'Dgito da Agncia : de '||COALESCE(OLD.DIGCOB,cNulo)||' para '||COALESCE(NEW.DIGCOB,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.FILREC||OLD.SEQREC||OLD.PARREC||OLD.SUBREC,NEW.FILREC||NEW.SEQREC||NEW.PARREC||NEW.SUBREC) = 0) THEN
        vLOG := vLOG||'Parcela: de '||COALESCE(OLD.FILREC||OLD.SEQREC||OLD.PARREC||OLD.SUBREC,cNulo)||' para '||COALESCE(NEW.FILREC||NEW.SEQREC||NEW.PARREC||NEW.SUBREC,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.FLGEST,NEW.FLGEST) = 0) THEN
        vLOG := vLOG||'Situao: de '||COALESCE(OLD.FLGEST,cNulo)||' para '||COALESCE(NEW.FLGEST,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.JURDES,NEW.JURDES) = 0) THEN
        vLOG := vLOG||'Desconto Cedido: de '||COALESCE(OLD.JURDES,iNulo)||' para '||COALESCE(NEW.JURDES,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.JURMOR,NEW.JURMOR) = 0) THEN
        vLOG := vLOG||'Juros de Mora: de '||COALESCE(OLD.JURMOR,iNulo)||' para '||COALESCE(NEW.JURMOR,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.NOSNUM,NEW.NOSNUM) = 0) THEN
        vLOG := vLOG||'Nosso Nmero: de '||COALESCE(OLD.NOSNUM,cNulo)||' para '||COALESCE(NEW.NOSNUM,cNulo)||CRLF;
     END IF;
	 -- Paulo K. - 89699
	 IF (Equal(OLD.NOSNUM2,NEW.NOSNUM2) = 0) THEN
        vLOG := vLOG||'Nosso Nmero 2: de '||COALESCE(OLD.NOSNUM2,cNulo)||' para '||COALESCE(NEW.NOSNUM2,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.NUMAGE,NEW.NUMAGE) = 0) THEN
        vLOG := vLOG||'Nmero da Agncia: de '||COALESCE(OLD.NUMAGE,cNulo)||' para '||COALESCE(NEW.NUMAGE,cNulo)||CRLF;
     END IF;
     IF (Equal(OLD.PRZBAI,NEW.PRZBAI) = 0) THEN
        vLOG := vLOG||'Prazo para Baixa: de '||COALESCE(OLD.PRZBAI,iNulo)||' para '||COALESCE(NEW.PRZBAI,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.PRZPRT,NEW.PRZPRT) = 0) THEN
        vLOG := vLOG||'Prazo para Protesto: de '||COALESCE(OLD.PRZPRT,iNulo)||' para '||COALESCE(NEW.PRZPRT,iNulo)||CRLF;
     END IF;
	 -- Paulo K. - 89699
	 IF (Equal(OLD.PORTAD,NEW.PORTAD) = 0) THEN
        vLOG := vLOG||'Portador: de '||COALESCE(OLD.PORTAD,iNulo)||' para '||COALESCE(NEW.PORTAD,iNulo)||CRLF;
     END IF;
	 -- Paulo K. - 89699
     IF (Equal(OLD.SEQCAN,NEW.SEQCAN) = 0) THEN
        vLOG := vLOG||'Seq. Cancelamento: de '||COALESCE(OLD.SEQCAN,cNulo)||' para '||COALESCE(NEW.SEQCAN,cNulo)||CRLF;
     END IF;
	 -- Paulo K. - 89699
	 IF (Equal(OLD.DUMMY,NEW.DUMMY) = 0) THEN
        vLOG := vLOG||'Dummy: de '||COALESCE(OLD.DUMMY,cNulo)||' para '||COALESCE(NEW.DUMMY,cNulo)||CRLF;
     END IF;
	 IF (Equal(OLD.VLRABT,NEW.VLRABT) = 0) THEN
        vLOG := vLOG||'Valor do Abatimento: de '||COALESCE(OLD.VLRABT,iNulo)||' para '||COALESCE(NEW.VLRABT,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.VLRIOF,NEW.VLRIOF) = 0) THEN
        vLOG := vLOG||'Valor IOF: de '||COALESCE(OLD.VLRIOF,iNulo)||' para '||COALESCE(NEW.VLRIOF,iNulo)||CRLF;
     END IF;
     IF (Equal(OLD.VLRORI,NEW.VLRORI) = 0) THEN
        vLOG := vLOG||'Valor Origem: de '||COALESCE(OLD.VLRORI,iNulo)||' para '||COALESCE(NEW.VLRORI,iNulo)||CRLF;
     END IF;
     -- Paulo K. - 89699
     IF (Equal(OLD.VLRPAR,NEW.VLRPAR) = 0) THEN
        vLOG := vLOG||'Valor da parcela: de '||COALESCE(OLD.VLRPAR,iNulo)||' para '||COALESCE(NEW.VLRPAR,iNulo)||CRLF;
     END IF;
  END IF;
  IF (TG_OP = 'INSERT') THEN
     vLOG := 'Includa';
  END IF;
  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     IF ISNOTNULL(vLOG) = 'T' THEN
        WK_CODUID := GetCoduidAtual();
        vTIT := NEW.CODFIL||'-'||NEW.SEQUEN;
        vLOG := 'TIT ['||TRIM(vTIT)||']: '||CRLF||vLOG;
        select * into QuemLogou from DadosLogon();
        INSERT INTO TL_VEN (FILVEN, SEQVEN, FILUSU, CODUSU, DATOPE, MSGLOG, CODUID)
                    VALUES (NEW.FILREC, NEW.SEQREC, QuemLogou.FILUSU, QuemLogou.CODUSU, agora(), vLog, WK_CODUID);
     END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5188 --*/
CREATE TRIGGER TGTIT3
AFTER INSERT OR DELETE OR UPDATE ON TT_TIT 
FOR EACH ROW EXECUTE PROCEDURE TGTIT3();



/*-- SEQ 5189 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGTPF() CASCADE;

/*-- SEQ 5190 --*/
CREATE OR REPLACE FUNCTION TGTPF() RETURNS TRIGGER AS $$
DECLARE
-- MN - 02/12/2019 - PJ7477 - Tabela Preos por Fornecedor
-- Objetivo:
-- 1) Atualiza DATINC
-- 2) Atualiza ATU_EM
-- 3) Impedir exclusao
  
  -- Declarao de variveis e cursores  
  cComplemento  VARCHAR(254) := constante('complemento'); 

-- Principal
BEGIN
-- Impede excluso.
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20000 Registro no pode ser excludo. %' , cCOMPLEMENTO;
   END IF;

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.ID_TPF IS NULL THEN
         SELECT NEXTVAL('sqTPF') INTO NEW.ID_TPF FROM DUAL;
      END IF;
      
      NEW.DATINC := Agora();
   END IF;

   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;  

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5191 --*/
CREATE TRIGGER TGTPF
BEFORE INSERT OR DELETE OR UPDATE ON TT_TPF 
FOR EACH ROW EXECUTE PROCEDURE TGTPF();


/*-- SEQ 5192 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGTPR() CASCADE;

/*-- SEQ 5193 --*/
CREATE OR REPLACE FUNCTION TGTPR() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Truncar hora das datas
DECLARE
-- Principal
BEGIN
   -- Retira hora
   NEW.DATMIN := TRUNC(NEW.DATMIN);
   NEW.DATMAX := TRUNC(NEW.DATMAX);

   IF (TG_OP = 'UPDATE') THEN
      -- Quando houve alterao marca data de atualizao da TT_PRE relativa aos registros da tabela
      IF Equal(NEW.DESPRE,OLD.DESPRE) = 0 OR
         Equal(NEW.VAREJO,OLD.VAREJO) = 0 OR
         Equal(NEW.ESTADO,OLD.ESTADO) = 0 OR
         Equal(NEW.FILDES,OLD.FILDES) = 0 OR
         Equal(NEW.DATMAX,OLD.DATMAX) = 0 OR
         Equal(NEW.DATMIN,OLD.DATMIN) = 0 OR
         Equal(NEW.CATEG1,OLD.CATEG1) = 0 OR
         Equal(NEW.CATEG2,OLD.CATEG2) = 0 OR
         Equal(NEW.CATEG3,OLD.CATEG3) = 0 OR
         Equal(NEW.MULTIP,OLD.MULTIP) = 0 OR
         Equal(NEW.FILPGT,OLD.FILPGT) = 0 OR
         Equal(NEW.CODPGT,OLD.CODPGT) = 0 OR
         Equal(NEW.TOTQTD,OLD.TOTQTD) = 0 OR
         Equal(NEW.CODCTR,OLD.CODCTR) = 0 OR
         Equal(NEW.PERLUC,OLD.PERLUC) = 0 OR
         Equal(NEW.FIL_CK,OLD.FIL_CK) = 0 THEN
         UPDATE TT_PRE SET ATU_EM = AGORA() 
          WHERE FILPRE = NEW.CODFIL AND CODPRE = NEW.CODPRE;
      END IF;
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5194 --*/
CREATE TRIGGER TGTPR
BEFORE INSERT OR UPDATE ON TT_TPR 
FOR EACH ROW EXECUTE PROCEDURE TGTPR();

/*-- SEQ 5195 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGTPR2() CASCADE;

/*-- SEQ 5196 --*/
CREATE OR REPLACE FUNCTION TGTPR2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
DECLARE
   cRetorno                      VARCHAR(2);
BEGIN
   cRetorno := AtualizaData('CONFIGURACAO',Agora());
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5197 --*/
CREATE TRIGGER TGTPR2
AFTER INSERT OR UPDATE OR DELETE ON TT_TPR 
FOR EACH ROW EXECUTE PROCEDURE TGTPR2();


/*-- SEQ 5198 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGTPRXFIL() CASCADE;

/*-- SEQ 5199 --*/
CREATE OR REPLACE FUNCTION TGTPRXFIL() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Gerar um cdigo sequencial exclusivo para compor a chave primria.
-- 2. Atualiza controles de data.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN := ProximoCodigo('TT_TPRXFIL',NEW.CODFIL);
      END IF;
      NEW.DATINC := Agora();
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5200 --*/
CREATE TRIGGER TGTPRXFIL
BEFORE INSERT OR UPDATE OR DELETE ON TT_TPRXFIL 
FOR EACH ROW EXECUTE PROCEDURE TGTPRXFIL();




/*-- SEQ 5201 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGTRA2() CASCADE;

/*-- SEQ 5202 --*/
CREATE OR REPLACE FUNCTION TGTRA2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Garantir que a mercadoria que entrou corresponde a mesma que saiu (nota de transferencia)
-- 2) Fazer com que o custo mmedio seja recalculado ao vincular a compra

   vComplemento                  CONSTANT VARCHAR(254):= constante('complemento');
   vErroSaida                    CONSTANT Numeric(1) := -1;
   vErroEntrada                  CONSTANT Numeric(1) := -2;
   vErroQuantidade               CONSTANT Numeric(1) := -3;
   vErroEntradaComplementar      CONSTANT Numeric(1) := -4;
   vOk                           CONSTANT Numeric(1) := 0;  
   wk_Achou                      INTEGER;
   wk_VEN_DATHOR                 TT_IVE.VEN_DATHOR%TYPE;
   cTipNat                       TD_NAT.TIPNAT%TYPE;
   cDummy                        VARCHAR(1);
    
   inRec                         TT_TRA%ROWTYPE;
BEGIN
   IF (NEW.FILICO IS NOT NULL) AND
      (NEW.SEQICO IS NOT NULL) AND
      (NEW.NUMICO IS NOT NULL) THEN 
      SELECT CASE WHEN IVE.QTDMOV IS NULL THEN vErroSaida
                  ELSE
                        CASE WHEN ICO.QTDMOV IS NULL THEN vErroEntrada
                             ELSE
                             CASE WHEN COALESCE(COM.FINNFE,'0') = '2' THEN vErroEntradaComplementar
                                  ELSE
                                  CASE WHEN IVE.QTDMOV = ICO.QTDMOV THEN vOk
                                       ELSE vErroQuantidade
                                  END
                             END
                        END
             END AS ACHOU,
            IVE.VEN_DATHOR INTO wk_Achou, wk_VEN_DATHOR
       FROM (SELECT NEW.FILIVE AS FILIVE,NEW.SEQIVE AS SEQIVE,NEW.NUMIVE AS NUMIVE,
                    NEW.FILICO AS FILICO,NEW.SEQICO AS SEQICO,NEW.NUMICO AS NUMICO,
                    NEW.FILMAT AS FILMAT,NEW.CODMAT AS CODMAT,NEW.CODCOR AS CODCOR,NEW.CODTAM AS CODTAM FROM DUAL) TRA
      LEFT OUTER JOIN TT_IVE IVE ON IVE.CODFIL = TRA.FILIVE AND
                                    IVE.SEQUEN = TRA.SEQIVE AND
                                    IVE.NUMITE = TRA.NUMIVE AND
                                    IVE.FILMAT = TRA.FILMAT AND
                                    IVE.CODMAT = TRA.CODMAT AND
                                    IVE.CODCOR = TRA.CODCOR AND
                                    IVE.CODTAM = TRA.CODTAM
      LEFT OUTER JOIN TT_ICO ICO ON ICO.CODFIL = TRA.FILICO AND
                                    ICO.SEQUEN = TRA.SEQICO AND
                                    ICO.NUMITE = TRA.NUMICO AND
                                    ICO.FILMAT = TRA.FILMAT AND
                                    ICO.CODMAT = TRA.CODMAT AND
                                    ICO.CODCOR = TRA.CODCOR AND
                                    ICO.CODTAM = TRA.CODTAM
      LEFT OUTER JOIN TT_COM COM ON COM.CODFIL = ICO.CODFIL AND
                                    COM.SEQUEN = ICO.SEQUEN;

      IF wk_Achou = vErroSaida THEN
         RAISE EXCEPTION 'PG-20001 Nao foi possivel confirmar a saida desse produto.%' , vComplemento;
      ELSIF wk_Achou = vErroEntrada THEN
         RAISE EXCEPTION 'PG-20002 Nao foi possivel confirmar a entrada desse produto.%' , vComplemento;
      ELSIF wk_Achou = vErroQuantidade THEN
         RAISE EXCEPTION 'PG-20003 Quantidade de entrada e saida desse produto nao confere.%' , vComplemento;
      ELSIF wk_Achou = vErroEntradaComplementar THEN
         RAISE EXCEPTION 'PG-20002 Nota complementar de entrada no pode ser utilizada em transferncias.%' , vComplemento;
      END IF;
    
      IF (TG_OP = 'UPDATE') THEN
         IF (OLD.FILICO IS NULL) THEN
            /* Atualiza a data do custo medio na TT_SAL */
            UPDATE TT_SAL
               SET CAL_CM = CASE WHEN CAL_CM IS NULL THEN NULL ELSE
                            CASE WHEN wk_VEN_DATHOR<CAL_CM THEN wk_VEN_DATHOR
                                                 ELSE CAL_CM
                            END
                            END,
                   ATU_CM = 'F',
                   DUMMY = Constante('vem_de_TGIVE')
               WHERE CODFIL = NEW.FILIVE
                 AND FILMAT = NEW.FILMAT
                 AND CODMAT = NEW.CODMAT
                 AND CODCOR = NEW.CODCOR
                 AND CODTAM = NEW.CODTAM
                 AND CODMUL = 0;
            
            IF (ISNOTNULL(NEW.FILICO)='T') THEN
               -- Nota Devoluo
                                 SELECT DNAT.TIPNAT 
                    INTO cTipNat
                    FROM TT_IVE DEV
                    JOIN TT_VEN VEN_DEV ON VEN_DEV.CODFIL = DEV.CODFIL AND VEN_DEV.SEQUEN = DEV.SEQUEN
                    JOIN TD_NAT DNAT ON DNAT.CODTAB = VEN_DEV.CODNAT                                  
                   WHERE DEV.CODFIL = NEW.FILIVE 
                     AND DEV.SEQUEN = NEW.SEQIVE
                     AND DEV.NUMITE = NEW.NUMIVE;
                           
               IF (cTipNat='R') THEN
                                       inRec.FILIVE := NEW.FILIVE;
                     inRec.SEQIVE := NEW.SEQIVE;
                     inRec.NUMIVE := NEW.NUMIVE;
                     inRec.FILICO := NEW.FILICO;
                     inRec.SEQICO := NEW.SEQICO;
                     inRec.NUMICO := NEW.NUMICO;
                  
                     
                     cDummy = PC_TRA_Update(inREC.FILIVE,
                                            inREC.SEQIVE,
                                            inREC.NUMIVE,
                                            inREC.FILICO,
                                            inREC.SEQICO,
                                            inREC.NUMICO);
                                                      END IF;
            END IF;
         END IF; 
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5203 --*/
CREATE TRIGGER TGTRA2
AFTER INSERT OR UPDATE ON TT_TRA 
FOR EACH ROW EXECUTE PROCEDURE TGTRA2();



/*-- SEQ 5204 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGTRC() CASCADE;

/*-- SEQ 5205 --*/
CREATE OR REPLACE FUNCTION TGTRC() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Impedir exclusao
-- 2) Impedir alteracao nas colunas que nao se referem ao status
-- 
  vComplemento Constant VARCHAR(100) := Constante('Complemento');
  cDUMMY VARCHAR(10);
BEGIN
  -- Impede exclusoes
  IF (TG_OP = 'DELETE') THEN
    RAISE EXCEPTION 'PG-20027 Exclusao so pode ser feita atraves da rotina manutencao. %' , vComplemento;
  END IF;

  -- Impede alteracoes
  IF (TG_OP = 'UPDATE') THEN
    -- IMPORTANTE: nao e feita referencia a coluna OBSERV porque ela
    --             e do tipo TEXT e uma trigger nao pode fazer referencia
    --             a uma coluna desse tipo.
    IF (OLD.SEQUEN <> NEW.SEQUEN) OR
       (OLD.CODFIL <> NEW.CODFIL) OR
       (OLD.CODSER <> NEW.CODSER) OR
       (OLD.NUMNOT <> NEW.NUMNOT) OR
       (OLD.DATOPE <> NEW.DATOPE) OR
       (OLD.VLRTOT <> NEW.VLRTOT) OR
       (OLD.OUTTAX <> NEW.OUTTAX) OR
       (OLD.DESCON <> NEW.DESCON) OR
       (OLD.VLRLIQ <> NEW.VLRLIQ) OR
       (OLD.FILUSU <> NEW.FILUSU) OR
       (OLD.CODUSU <> NEW.CODUSU) OR
       (OLD.CODMOE <> NEW.CODMOE) OR
       (OLD.VLTXJU <> NEW.VLTXJU) OR
       (OLD.INCOJU <> NEW.INCOJU) OR
       (OLD.INTPJU <> NEW.INTPJU) OR
       (OLD.VLTXMU <> NEW.VLTXMU) OR
       (OLD.INTPMU <> NEW.INTPMU) OR
       (OLD.MOEJUR <> NEW.MOEJUR) OR
       (OLD.TIPNOT <> NEW.TIPNOT) OR
       (OLD.SEQCAN <> NEW.SEQCAN) OR
       (LTRIM(RTRIM(OLD.SUBSER)) <> LTRIM(RTRIM(NEW.SUBSER))) THEN
       RAISE EXCEPTION 'PG-20024 Um titulo nao pode ser modificado. %' , vComplemento;
    END IF;

    IF (OLD.FLGEST = 'C') AND (NEW.FLGEST <> OLD.FLGEST) THEN
      RAISE EXCEPTION 'PG-20025 Um titulo devolvido nao pode ser modificado. %' , vComplemento;
    END IF;
  END IF;

  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
    NEW.SEQUEN := ProximoCodigo('TT_TRC',NEW.CODFIL);
  END IF;

  -- Evita "brancos" na subserie
  IF NOT (TG_OP = 'DELETE') THEN
    IF (NEW.SUBSER = ' ')
    OR (NEW.SUBSER = '  ')
    OR (NEW.SUBSER = '   ') THEN
      NEW.SUBSER := Null;
    END IF;

    -- Gera proximo sequenciador de cancelamento
    IF (NEW.FLGEST = 'C') THEN
      IF (TG_OP = 'UPDATE') THEN 
         IF (NEW.FLGEST <> OLD.FLGEST) THEN
           NEW.SEQCAN := ProximoCodigo('TT_TRC_CANCELAMENTO',NEW.CODFIL);
         end if;
      ELSIF (TG_OP = 'INSERT') THEN
        NEW.SEQCAN := ProximoCodigo('TT_TRC_CANCELAMENTO',NEW.CODFIL);
      END IF;   
 
      -- Improvavel mas...
      IF (NEW.SEQCAN IS NULL) THEN
        RAISE EXCEPTION 'PG-20026 Falha na geracao do sequenciador de cancelamento. %' , vComplemento;
      END IF;
  
      -- "update cascade"
      IF (TG_OP = 'UPDATE') THEN
        -- Cancela recebimentos
        UPDATE TT_PTR SET FLGEST = 'C',DUMMY = Constante('vem_de_TGTRC')
        WHERE SEQUEN = NEW.SEQUEN
          AND CODFIL = NEW.CODFIL
          AND FLGEST NOT IN ('C','P','X');
  
        -- Estorna recebimentos
        UPDATE TT_PTR SET FLGEST = 'X',DUMMY = Constante('vem_de_TGTRC')
        WHERE SEQUEN = NEW.SEQUEN
          AND CODFIL = NEW.CODFIL
          AND FLGEST NOT IN ('X','C');
      END IF;
    END IF;
  END IF; 

  -- DN 45679 - Tabelas Financeiras
  IF (TG_OP = 'INSERT') THEN    
     cDUMMY:=INSERE_LFIN_CLI('PTR',NEW.CODFIL,NEW.SEQUEN,NEW.FILPAR,NEW.CODPAR);
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     cDUMMY:=INSERE_LFIN_CLI('PTR',NEW.CODFIL,NEW.SEQUEN,NEW.FILPAR,NEW.CODPAR);
  END IF;
  -- DN 45679 - Fim Tabelas Financeiras

  -- "Default"
  NEW.ATU_EM := agora();

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5206 --*/
CREATE TRIGGER TGTRC
BEFORE INSERT OR DELETE OR UPDATE ON TT_TRC 
FOR EACH ROW EXECUTE PROCEDURE TGTRC();


/*-- SEQ 5207 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGTRN() CASCADE;

/*-- SEQ 5208 --*/
CREATE OR REPLACE FUNCTION TGTRN() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Atualiza DATINC
-- 3) Atualiza ATU_EM

-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN:=ProximoCodigo('TT_TRN',NEW.CODFIL);
    END IF;
  END IF;

  -- Trata dados padroes na inclusao  
  IF (TG_OP = 'INSERT') THEN
   NEW.DATINC := AGORA();
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5209 --*/
CREATE TRIGGER TGTRN
BEFORE INSERT OR UPDATE ON TT_TRN 
FOR EACH ROW EXECUTE PROCEDURE TGTRN();


/*-- SEQ 5210 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGTSF() CASCADE;

/*-- SEQ 5211 --*/
CREATE OR REPLACE FUNCTION TGTSF() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Gerar um cdigo sequencial exclusivo para compor a chave primria.
-- 2. Atualiza controles de data.
-- 3. Log incluso/excluso.

-- Declarao de variveis e cursores
   cComplemento                  CONSTANT VARCHAR(254) := Constante('complemento');
   cRet                          VARCHAR(2);
-- Principal
BEGIN

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN := ProximoCodigo('TT_TSF',NEW.CODFIL);
      END IF;
      NEW.DATINC := Agora();
      -- Log excluso.
      cRet := LogExclusao(FALSE,'TT_TSF', NEW.CODFIL, NEW.SEQUEN);
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;
   
   -- Log excluso.
   IF (TG_OP = 'DELETE') THEN
      cRet := LogExclusao(TRUE,'TT_TSF', OLD.CODFIL, OLD.SEQUEN);
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5212 --*/
CREATE TRIGGER TGTSF
BEFORE INSERT OR UPDATE OR DELETE ON TT_TSF 
FOR EACH ROW EXECUTE PROCEDURE TGTSF();


/*-- SEQ 5213 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGUID() CASCADE;

/*-- SEQ 5214 --*/
CREATE OR REPLACE FUNCTION TGUID() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

--  vComplemento constant VARCHAR(100) := constante('complemento');

BEGIN
  IF (TG_OP = 'INSERT') THEN
    -- Gera codigo sequencial
    IF (NEW.CODUID IS NULL) THEN
      NEW.CODUID:=TO_NUMBER(TRIM(ProximoCodigo('TT_UID',NULL)));
    END IF;

    -- Para restringir acesso de um executavel bloqueando a TT_UID:
    -- 1. Descomente o codigo abaixo modificando a versao atual e as releases e 
    --    modulos que serao bloqueados.
    -- 2. Modifique a release no TOTALL.COP para possamos executar o modulo compilado 
    --    aqui na Totall sem fazer modificacoes.
    -- 
    -- Restringir uso da 5.1b r0.
    -- IF  UPPER(NEW.NOMSIS) = 'TOTALLCOMMERCEBACKOFFICE'
    -- AND UPPER(NEW.VERSIS) = '5.1C-R0' THEN
    --    RAISE EXCEPTION 'PG-20010 Versao 5.1c-r0 nao esta liberada para uso. Atualize o executavel. % ' , vComplemento;
    -- END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5215 --*/
CREATE TRIGGER TGUID
BEFORE INSERT ON TT_UID 
FOR EACH ROW EXECUTE PROCEDURE TGUID();



/*-- SEQ 5216 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGUSU2() CASCADE;

/*-- SEQ 5217 --*/
CREATE OR REPLACE FUNCTION TGUSU2() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Fazer parte do papel de uma "foreign key" para filial
DECLARE
   codigo                        CONSTANT CHAR(6) := '     0';
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');
   vUSUARIO                      TT_USU.APEUSU%TYPE;
   inRec                         TT_USU%ROWTYPE;
      cDUMMY                        VARCHAR(1);  
   cRet                          VARCHAR(2);
   cPathBase                     TT_CFG.PATH_BASE%TYPE;
   cDiasExpiraSenha              Numeric(3);
   cDataVencimentoSenha          TT_USU.VALSEN%TYPE;
BEGIN
   IF (TG_OP = 'UPDATE') THEN
      SELECT GetApeUsuAtual() INTO vUSUARIO FROM DUAL;
      IF (vUSUARIO<>NEW.APEUSU) AND 
         (vUSUARIO<>Qualdono()) AND 
         ((NEW.SENHA1<>OLD.SENHA1) OR (NEW.SENHA2<>OLD.SENHA2)) THEN
         RAISE EXCEPTION 'PG-20030 Somente o proprio usuario ou o usuario TOTALL. %' , vComplemento;
      END IF;  
      IF (vUSUARIO<>Qualdono()) AND
         ((Equal(OLD.FILUSU,NEW.FILUSU) <> 1) 
      OR (Equal(OLD.CODUSU,NEW.CODUSU) <> 1) 
      OR (Equal(OLD.ATU_EM,NEW.ATU_EM) <> 1) 
      OR (Equal(OLD.FILCLI,NEW.FILCLI) <> 1) 
      OR (Equal(OLD.CODCLI,NEW.CODCLI) <> 1) 
      OR (Equal(OLD.NOMUSU,NEW.NOMUSU) <> 1) 
      OR (Equal(OLD.APEUSU,NEW.APEUSU) <> 1) 
      OR (Equal(OLD.NIVUSU,NEW.NIVUSU) <> 1) 
      OR (Equal(OLD.PERCOM,NEW.PERCOM) <> 1) 
      OR (Equal(OLD.MAIDAT,NEW.MAIDAT) <> 1) 
      OR (Equal(OLD.MENDAT,NEW.MENDAT) <> 1) 
      OR (Equal(OLD.FILSUP,NEW.FILSUP) <> 1) 
      OR (Equal(OLD.CODSUP,NEW.CODSUP) <> 1) 
      OR (Equal(OLD.PERMIS,NEW.PERMIS) <> 1) 
      OR (Equal(OLD.SIGNAT,NEW.SIGNAT) <> 1) 
      OR (Equal(OLD.FILATV,NEW.FILATV) <> 1) 
      OR (Equal(OLD.CODEXT,NEW.CODEXT) <> 1) 
      OR (Equal(OLD.GRUPOS,NEW.GRUPOS) <> 1) 
      OR (Equal(OLD.TABATU,NEW.TABATU) <> 1) 
      OR (Equal(OLD.LIMCOM,NEW.LIMCOM) <> 1) 
      OR (Equal(OLD.CODCTR,NEW.CODCTR) <> 1) 
      OR (Equal(OLD.MINDAT,NEW.MINDAT) <> 1) 
      OR (Equal(OLD.MAXDAT,NEW.MAXDAT) <> 1) 
      OR (Equal(OLD.VISSE1,NEW.VISSE1) <> 1) 
      OR (Equal(OLD.VISSE2,NEW.VISSE2) <> 1) 
      OR (Equal(OLD.VISPER,NEW.VISPER) <> 1) 
      OR (Equal(OLD.USANDB,NEW.USANDB) <> 1) 
      OR (Equal(OLD.EDINDB,NEW.EDINDB) <> 1) 
      OR (Equal(OLD.PATNDB,NEW.PATNDB) <> 1) 
      OR (Equal(OLD.AGENDB,NEW.AGENDB) <> 1) 
      OR (Equal(OLD.USANDC,NEW.USANDC) <> 1) 
      OR (Equal(OLD.HORDOM,NEW.HORDOM) <> 1) 
      OR (Equal(OLD.HORSEG,NEW.HORSEG) <> 1) 
      OR (Equal(OLD.HORTER,NEW.HORTER) <> 1) 
      OR (Equal(OLD.HORQUA,NEW.HORQUA) <> 1) 
      OR (Equal(OLD.HORQUI,NEW.HORQUI) <> 1) 
      OR (Equal(OLD.HORSEX,NEW.HORSEX) <> 1) 
      OR (Equal(OLD.HORSAB,NEW.HORSAB) <> 1) 
      OR (Equal(OLD.E_MAIL,NEW.E_MAIL) <> 1) 
      OR (Equal(OLD.INDPRO,NEW.INDPRO) <> 1) 
      OR (Equal(OLD.CODSET,NEW.CODSET) <> 1) 
      OR (Equal(OLD.FAZENQ,NEW.FAZENQ) <> 1) 
      OR (Equal(OLD.FUNCAO,NEW.FUNCAO) <> 1) 
      OR (Equal(OLD.FAZMON,NEW.FAZMON) <> 1)) THEN
         IF vUSUARIO=NEW.APEUSU THEN
            IF (COALESCE(SUBSTR(OLD.PERMIS,4,1),'N')='N' AND
               COALESCE(SUBSTR(OLD.PERMIS,74,1),'N')='N') OR OLD.NIVUSU<>0 THEN
               RAISE EXCEPTION 'PG-20030 Usuario sem permissao para realizar alteracao. ';
            END IF;
         ELSE 
                        -- Verifica se usurio tem permissao de update
               inRec.APEUSU := vUSUARIO;
                        
            cDUMMY := PC_USU_UPDATE(inRec.APEUSU);
             
         END IF;     
      END IF; 
   END IF;
  
   IF NOT (TG_OP = 'DELETE') THEN
      -- Se o codigo do parceiro for zero e da mesma filial dispensa verificacao
      IF (NEW.FILCLI = NEW.FILUSU) AND (NEW.CODCLI <> CODIGO) THEN
         IF NOT TGR_Existe_Filial(NEW.FILUSU) THEN
            RAISE EXCEPTION 'PG-20029 Filial % nao existe. %' , NEW.FILCLI,vComplemento;
         END IF;
      END IF;

      -- Impede alguns caracteres em APEUSU
      IF ((LTRIM(RTRIM(NEW.APEUSU)) LIKE '% %') OR
         (LTRIM(RTRIM(NEW.APEUSU)) LIKE '%.%') OR
         (LTRIM(RTRIM(NEW.APEUSU)) LIKE '%,%') ) THEN
         RAISE EXCEPTION 'PG-20027 Nao pode haver espacos, pontos ou virgulas no apelido do usuario. %' , vComplemento;
      END IF;

      -- Exigencia para bom funcionamento do CheckOut
      IF (SUBSTR(LTRIM(RTRIM(NEW.APEUSU)),1,1) in ('0','1','2','3','4', '5','6','7','8','9')) THEN
         RAISE EXCEPTION 'PG-20028 Apelido de usuario nao pode comecar com numeros. %' , vComplemento;
      END IF;
      NEW.ATU_EM := AGORA();
      NEW.APEUSU := UPPER(NEW.APEUSU);
      NEW.USANDB := COALESCE(NEW.USANDB,'T');
      NEW.EDINDB := COALESCE(NEW.EDINDB,'F');
      NEW.USANDC := COALESCE(NEW.USANDC,'F');
      NEW.AGENDB := COALESCE(NEW.AGENDB,'F');
    
   END IF;

   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      -- RFMP 72339
      SELECT PATH_BASE into cPathBase from TT_CFG;
      IF ISNOTNULL(cPathBase) = 'T' THEN 
         IF ISNULL(TRIM(NEW.PATNDB)) = 'T' THEN
            NEW.PATNDB := cPathBase || PATH_DEFAULT('TT_USU','PATNDB');
         END IF;
      END IF;    
   END IF;

   IF (TG_OP = 'DELETE') THEN
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_USU', OLD.FILUSU, OLD.CODUSU);
   END IF;
   IF (TG_OP = 'INSERT') THEN
      --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_USU', NEW.FILUSU, NEW.CODUSU);
   END IF;
    IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5218 --*/
CREATE TRIGGER TGUSU2
BEFORE INSERT OR UPDATE OR DELETE ON TT_USU 
FOR EACH ROW EXECUTE PROCEDURE TGUSU2();


/*-- SEQ 5219 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGUSU4() CASCADE;

/*-- SEQ 5220 --*/
CREATE OR REPLACE FUNCTION TGUSU4() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Atualiza ATU_EM da TT_ATU de configurao
-- 1. Registrar mudanas dos dados na TT_USU.
DECLARE
   cRetorno                      VARCHAR(2);
   cLog                          VARCHAR(4000) := '';
   cNulo                         CONSTANT CHAR(04) := 'Nulo';
   iNulo                         CONSTANT Numeric(01) := 0;
   CRLF                          CONSTANT CHAR(01) := CHR(10);
      cDUMMY                        VARCHAR(1);
   cDiasExpiraSenha              Numeric(3);
   cDataVencimentoSenha          TT_USU.VALSEN%TYPE;
BEGIN
   IF (TG_OP = 'UPDATE') THEN
      IF (Equal(OLD.FILUSU,NEW.FILUSU) <> 1) 
      OR (Equal(OLD.CODUSU,NEW.CODUSU) <> 1) 
      OR (Equal(OLD.CODSUP,NEW.CODSUP) <> 1) 
      OR (Equal(OLD.FILCLI,NEW.FILCLI) <> 1) 
      OR (Equal(OLD.FILSUP,NEW.FILSUP) <> 1) 
      OR (Equal(OLD.CODCLI,NEW.CODCLI) <> 1) 
      OR (Equal(OLD.CODEXT,NEW.CODEXT) <> 1) 
      OR (Equal(OLD.SENHA1,NEW.SENHA1) <> 1) 
      OR (Equal(OLD.SENHA2,NEW.SENHA2) <> 1) 
      OR (Equal(OLD.PERMIS,NEW.PERMIS) <> 1) 
      OR (Equal(OLD.PERCOM,NEW.PERCOM) <> 1) 
      OR (Equal(OLD.HORDOM,NEW.HORDOM) <> 1) 
      OR (Equal(OLD.HORQUA,NEW.HORQUA) <> 1) 
      OR (Equal(OLD.HORQUI,NEW.HORQUI) <> 1) 
      OR (Equal(OLD.HORSAB,NEW.HORSAB) <> 1) 
      OR (Equal(OLD.HORSEG,NEW.HORSEG) <> 1) 
      OR (Equal(OLD.HORSEX,NEW.HORSEX) <> 1) 
      OR (Equal(OLD.HORTER,NEW.HORTER) <> 1) 
      OR (Equal(OLD.CODCTR,NEW.CODCTR) <> 1) 
      OR (Equal(OLD.MAIDAT,NEW.MAIDAT) <> 1) 
      OR (Equal(OLD.MENDAT,NEW.MENDAT) <> 1) 
      OR (Equal(OLD.NIVUSU,NEW.NIVUSU) <> 1) 
      OR (Equal(OLD.SIGNAT,NEW.SIGNAT) <> 1) 
      OR (Equal(OLD.AGENDB,NEW.AGENDB) <> 1) 
      OR (Equal(OLD.EDINDB,NEW.EDINDB) <> 1) 
      OR (Equal(OLD.USANDB,NEW.USANDB) <> 1) 
      OR (Equal(OLD.USANDC,NEW.USANDC) <> 1) 
      OR (Equal(OLD.APEUSU,NEW.APEUSU) <> 1) 
      OR (Equal(OLD.NOMUSU,NEW.NOMUSU) <> 1) 
      OR (Equal(OLD.FILATV,NEW.FILATV) <> 1) 
      OR (Equal(OLD.TABATU,NEW.TABATU) <> 1) 
      OR (Equal(OLD.MAXDAT,NEW.MAXDAT) <> 1) 
      OR (Equal(OLD.MINDAT,NEW.MINDAT) <> 1) 
      OR (Equal(OLD.VISSE1,NEW.VISSE1) <> 1) 
      OR (Equal(OLD.VISSE2,NEW.VISSE2) <> 1) 
      OR (Equal(OLD.LIMCOM,NEW.LIMCOM) <> 1) 
      OR (Equal(OLD.E_MAIL,NEW.E_MAIL) <> 1) 
      OR (Equal(OLD.VISPER,NEW.VISPER) <> 1) 
      OR (Equal(OLD.PATNDB,NEW.PATNDB) <> 1) 
      OR (Equal(OLD.GRUPOS,NEW.GRUPOS) <> 1) 
      OR (Equal(OLD.INDPRO,NEW.INDPRO) <> 1) 
      OR (Equal(OLD.CODSET,NEW.CODSET) <> 1) 
      OR (Equal(OLD.FAZENQ,NEW.FAZENQ) <> 1) 
      OR (Equal(OLD.FUNCAO,NEW.FUNCAO) <> 1) 
      OR (Equal(OLD.FAZMON,NEW.FAZMON) <> 1) 
      OR (Equal(OLD.USUCOB,NEW.USUCOB) <> 1) 
      OR (Equal(OLD.NUMPAL,NEW.NUMPAL) <> 1) 
      OR (Equal(OLD.COMIMP,NEW.COMIMP) <> 1) 
      OR (Equal(OLD.VALSEN,NEW.VALSEN) <> 1) 
      OR (Equal(OLD.FILINI,NEW.FILINI) <> 1) 
      OR (Equal(OLD.CODINI,NEW.CODINI) <> 1) 
      OR (Equal(OLD.CFGINI,NEW.CFGINI) <> 1) 
      OR (Equal(OLD.VISWOR,NEW.VISWOR) <> 1) 
      OR (Equal(OLD.FILDIF,NEW.FILDIF) <> 1) 
      OR (Equal(OLD.SEQDIF,NEW.SEQDIF) <> 1) 
      OR (Equal(OLD.TIPDIF,NEW.TIPDIF) <> 1) 
      OR (Equal(OLD.FILECT,NEW.FILECT) <> 1) 
      OR (Equal(OLD.SEQECT,NEW.SEQECT) <> 1) 
      OR (Equal(OLD.CSENHA,NEW.CSENHA) <> 1) 
      OR (Equal(OLD.HORRATCOR,NEW.HORRATCOR) <> 1) 
      OR (Equal(OLD.PERRATCOB,NEW.PERRATCOB) <> 1) 
      OR (Equal(OLD.MINRATCOB,NEW.MINRATCOB) <> 1) 
      OR (Equal(OLD.FILGER,NEW.FILGER) <> 1) 
      OR (Equal(OLD.SEQGER,NEW.SEQGER) <> 1) 
      OR (Equal(OLD.TIPGER,NEW.TIPGER) <> 1) 
      OR (Equal(OLD.SNHPOP,NEW.SNHPOP) <> 1) 
      OR (Equal(OLD.LIMCRE,NEW.LIMCRE) <> 1) 
      OR (Equal(OLD.CHVMAT,NEW.CHVMAT) <> 1) 
      OR (Equal(OLD.ATU_EM,NEW.ATU_EM) <> 1)THEN
         cRetorno := AtualizaData('CONFIGURACAO',Agora());
      END IF;

      -- Log
      IF Equal(OLD.APEUSU,NEW.APEUSU) <> 1 THEN
         cLog := cLog||'Apelido do usurio: de '||COALESCE(OLD.APEUSU,cNulo)||' para '||COALESCE(NEW.APEUSU,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.FILCLI,NEW.FILCLI) <> 1)
      OR (Equal(OLD.CODCLI,NEW.CODCLI) <> 1) THEN
         IF ISNOTNULL(OLD.FILCLI)='T' THEN
                        
            cDUMMY := PC_USUxLOG_UPDATE(NEW.FILCLI, NEW.CODCLI, 'Parceiro desvinculado do usurio "' || NEW.APEUSU || '".');
                     END IF;

                  
         cDUMMY := PC_USUxLOG_UPDATE(NEW.FILCLI, NEW.CODCLI, 'Parceiro vinculado do usurio "' || NEW.APEUSU || '".');
               END IF;
      IF (Equal(OLD.FILSUP,NEW.FILSUP) <> 1)
      OR (Equal(OLD.CODSUP,NEW.CODSUP) <> 1) THEN
         cLog := cLog||'Usurio Supervisor: de '||COALESCE(OLD.FILSUP,cNulo)||'/'||COALESCE(OLD.CODSUP,cNulo)||' para '||COALESCE(NEW.FILSUP,cNulo)||'/'||COALESCE(NEW.CODSUP,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODEXT,NEW.CODEXT) <> 1 THEN
         cLog := cLog||'Cdigo externo: de '||COALESCE(OLD.CODEXT,cNulo)||' para '||COALESCE(NEW.CODEXT,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.SENHA1,NEW.SENHA1) <> 1)
      OR (Equal(OLD.SENHA2,NEW.SENHA2) <> 1)
      OR (Equal(OLD.CSENHA,NEW.CSENHA) <> 1) THEN
         cLog := cLog||'Senha do Usurio Alterada'||CRLF;
      END IF;
      IF (Equal(OLD.VISSE1,NEW.VISSE1) <> 1)
      OR (Equal(OLD.VISSE2,NEW.VISSE2) <> 1) THEN
         cLog := cLog||'Senha(Lite) do Usurio Alterada'||CRLF;
      END IF;
      IF Equal(OLD.HORDOM,NEW.HORDOM) <> 1 THEN
         cLog := cLog||'Horrio Domingo: de '||COALESCE(OLD.HORDOM,iNulo)||' para '||COALESCE(NEW.HORDOM,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.HORSEG,NEW.HORSEG) <> 1 THEN
         cLog := cLog||'Horrio Segunda: de '||COALESCE(OLD.HORSEG,iNulo)||' para '||COALESCE(NEW.HORSEG,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.HORTER,NEW.HORTER) <> 1 THEN
         cLog := cLog||'Horrio Tera: de '||COALESCE(OLD.HORTER,iNulo)||' para '||COALESCE(NEW.HORTER,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.HORQUA,NEW.HORQUA) <> 1 THEN
         cLog := cLog||'Horrio Quarta: de '||COALESCE(OLD.HORQUA,iNulo)||' para '||COALESCE(NEW.HORQUA,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.HORQUI,NEW.HORQUI) <> 1 THEN
         cLog := cLog||'Horrio Quinta: de '||COALESCE(OLD.HORQUI,iNulo)||' para '||COALESCE(NEW.HORQUI,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.HORSEX,NEW.HORSEX) <> 1 THEN
         cLog := cLog||'Horrio Sexta: de '||COALESCE(OLD.HORSEX,iNulo)||' para '||COALESCE(NEW.HORSEX,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.HORSAB,NEW.HORSAB) <> 1 THEN
         cLog := cLog||'Horrio Sbado: de '||COALESCE(OLD.HORSAB,iNulo)||' para '||COALESCE(NEW.HORSAB,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCTR,NEW.CODCTR) <> 1 THEN
         cLog := cLog||'Unidade de Negcios: de '||COALESCE(OLD.CODCTR,iNulo)||' para '||COALESCE(NEW.CODCTR,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.MAIDAT,NEW.MAIDAT) <> 1 THEN
         cLog := cLog||'Maior data possvel de uso em relao ao dia de hoje: de '||COALESCE(OLD.MAIDAT,iNulo)||' para '||COALESCE(NEW.MAIDAT,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.MENDAT,NEW.MENDAT) <> 1 THEN
         cLog := cLog||'Menor data possvel de uso em relao ao dia de hoje: de '||COALESCE(OLD.MENDAT,iNulo)||' para '||COALESCE(NEW.MENDAT,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.NIVUSU,NEW.NIVUSU) <> 1 THEN
         cLog := cLog||'Nvel do Usurio: de '||COALESCE(OLD.NIVUSU,iNulo)||' para '||COALESCE(NEW.NIVUSU,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERCOM,NEW.PERCOM) <> 1 THEN
         cLog := cLog||'Percentagem de comisso do usurio: de '||COALESCE(OLD.PERCOM,iNulo)||' para '||COALESCE(NEW.PERCOM,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.AGENDB,NEW.AGENDB) <> 1 THEN
         cLog := cLog||'Acesso ao Agendador?: de '||COALESCE(OLD.AGENDB,cNulo)||' para '||COALESCE(NEW.AGENDB,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.EDINDB,NEW.EDINDB) <> 1 THEN
         cLog := cLog||'Editar Formatos?: de '||COALESCE(OLD.EDINDB,cNulo)||' para '||COALESCE(NEW.EDINDB,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.USANDB,NEW.USANDB) <> 1 THEN
         cLog := cLog||'Usar TOTALI BI Browser?: de '||COALESCE(OLD.USANDB,cNulo)||' para '||COALESCE(NEW.USANDB,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.USANDC,NEW.USANDC) <> 1 THEN
         cLog := cLog||'Usar TOTALI BI Config?: de '||COALESCE(OLD.USANDC,cNulo)||' para '||COALESCE(NEW.USANDC,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NOMUSU,NEW.NOMUSU) <> 1 THEN
         cLog := cLog||'Nome do usurio: de '||COALESCE(OLD.NOMUSU,cNulo)||' para '||COALESCE(NEW.NOMUSU,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILATV,NEW.FILATV) <> 1 THEN
         cLog := cLog||'Filial onde est alocado: de '||COALESCE(OLD.FILATV,cNulo)||' para '||COALESCE(NEW.FILATV,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.TABATU,NEW.TABATU) <> 1 THEN
         cLog := cLog||'Tabela Atual: de '||COALESCE(OLD.TABATU,cNulo)||' para '||COALESCE(NEW.TABATU,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.MAXDAT,NEW.MAXDAT) <> 1 THEN
         cLog := cLog||'Mx. dias p/ aceitar baixa parcelas/lanamentos avulsos aps vencimento: de '||COALESCE(OLD.MAXDAT,iNulo)||' para '||COALESCE(NEW.MAXDAT,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.MINDAT,NEW.MINDAT) <> 1 THEN
         cLog := cLog||'Min. dias p/ aceitar baixa parcelas/lanamentos avulsos aps vencimento: de '||COALESCE(OLD.MINDAT,iNulo)||' para '||COALESCE(NEW.MINDAT,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.LIMCOM,NEW.LIMCOM) <> 1 THEN
         cLog := cLog||'Limite de Compras: de '||COALESCE(OLD.LIMCOM,iNulo)||' para '||COALESCE(NEW.LIMCOM,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.E_MAIL,NEW.E_MAIL) <> 1 THEN
         cLog := cLog||'E-mail: de '||COALESCE(OLD.E_MAIL,cNulo)||' para '||COALESCE(NEW.E_MAIL,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VISPER,NEW.VISPER) <> 1 THEN
         cLog := cLog||'Viso da Permisso: de '||COALESCE(OLD.VISPER,cNulo)||' para '||COALESCE(NEW.VISPER,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.PATNDB,NEW.PATNDB) <> 1 THEN
         cLog := cLog||'Path Consultas NetData: de '||COALESCE(OLD.PATNDB,cNulo)||' para '||COALESCE(NEW.PATNDB,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.GRUPOS,NEW.GRUPOS) <> 1 THEN
         cLog := cLog||'Grupos(Uso futuro): de '||COALESCE(OLD.GRUPOS,cNulo)||' para '||COALESCE(NEW.GRUPOS,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.INDPRO,NEW.INDPRO) <> 1 THEN
         cLog := cLog||'ndice Produtividade: de '||COALESCE(OLD.INDPRO,iNulo)||' para '||COALESCE(NEW.INDPRO,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODSET,NEW.CODSET) <> 1 THEN
         cLog := cLog||'Cdigo Setor: de '||COALESCE(OLD.CODSET,iNulo)||' para '||COALESCE(NEW.CODSET,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.FAZENQ,NEW.FAZENQ) <> 1 THEN
         cLog := cLog||'Faz Enquete?: de '||COALESCE(OLD.FAZENQ,cNulo)||' para '||COALESCE(NEW.FAZENQ,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FUNCAO,NEW.FUNCAO) <> 1 THEN
         cLog := cLog||'Funo: de '||COALESCE(OLD.FUNCAO,cNulo)||' para '||COALESCE(NEW.FUNCAO,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FAZMON,NEW.FAZMON) <> 1 THEN
         cLog := cLog||'Faz Montagem?: de '||COALESCE(OLD.FAZMON,cNulo)||' para '||COALESCE(NEW.FAZMON,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.USUCOB,NEW.USUCOB) <> 1 THEN
         cLog := cLog||'Usurio de Cobrana?: de '||COALESCE(OLD.USUCOB,cNulo)||' para '||COALESCE(NEW.USUCOB,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.COMIMP,NEW.COMIMP) <> 1 THEN
         cLog := cLog||'Comunicao com impressora : de '||COALESCE(OLD.COMIMP,cNulo)||' para '||COALESCE(NEW.COMIMP,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NUMPAL,NEW.NUMPAL) <> 1 THEN
         cLog := cLog||'Nmero do Palm: de '||COALESCE(OLD.NUMPAL,iNulo)||' para '||COALESCE(NEW.NUMPAL,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.VALSEN,NEW.VALSEN) <> 1 THEN
         cLog := cLog||'Validade Senha: de '||COALESCE(TO_CHAR(OLD.VALSEN,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VALSEN,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILINI,NEW.FILINI) <> 1
      OR Equal(OLD.CODINI,NEW.CODINI) <> 1 THEN
         cLog := cLog||'Usurio de que se assume a formatao de telas: de '||COALESCE(OLD.FILINI,cNulo)||'/'||COALESCE(OLD.CODINI,cNulo)||' para '||COALESCE(NEW.FILINI,cNulo)||'/'||COALESCE(NEW.CODINI,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CFGINI,NEW.CFGINI) <> 1 THEN
         cLog := cLog||'Se grava ou no as alteraes da formatao de telas: de '||COALESCE(OLD.CFGINI,cNulo)||' para '||COALESCE(NEW.CFGINI,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VISWOR,NEW.VISWOR) <> 1 THEN
         cLog := cLog||'ltima Visualizao: de '||COALESCE(OLD.VISWOR,cNulo)||' para '||COALESCE(NEW.VISWOR,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILDIF,NEW.FILDIF) <> 1
      OR Equal(OLD.SEQDIF,NEW.SEQDIF) <> 1
      OR Equal(OLD.TIPDIF,NEW.TIPDIF) <> 1 THEN
         cLog := cLog||'Ref. Tipo Conta: de '||COALESCE(OLD.FILDIF,cNulo)||'/'||COALESCE(OLD.SEQDIF,cNulo)||'-'||COALESCE(OLD.TIPDIF,cNulo)||' para '||COALESCE(NEW.FILDIF,cNulo)||'/'||COALESCE(NEW.SEQDIF,cNulo)||'-'||COALESCE(NEW.TIPDIF,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILECT,NEW.FILECT) <> 1
      OR Equal(OLD.SEQECT,NEW.SEQECT) <> 1 THEN
         cLog := cLog||'Contas Ttulos: de '||COALESCE(OLD.FILECT,cNulo)||'/'||COALESCE(OLD.SEQECT,cNulo)||' para '||COALESCE(NEW.FILECT,cNulo)||'/'||COALESCE(NEW.SEQECT,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.FILGER,NEW.FILGER) <> 1
      OR Equal(OLD.SEQGER,NEW.SEQGER) <> 1
      OR Equal(OLD.TIPGER,NEW.TIPGER) <> 1 THEN
         cLog := cLog||'Tipo Conta Gerencial: de '||COALESCE(OLD.FILGER,cNulo)||'/'||COALESCE(OLD.SEQGER,cNulo)||'-'||COALESCE(OLD.TIPGER,cNulo)||' para '||COALESCE(NEW.FILGER,cNulo)||'/'||COALESCE(NEW.SEQGER,cNulo)||'-'||COALESCE(NEW.TIPGER,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SNHPOP,NEW.SNHPOP) <> 1 THEN
         cLog := cLog||'Senha do Email: de '||COALESCE(OLD.SNHPOP,cNulo)||' para '||COALESCE(NEW.SNHPOP,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.HORRATCOR,NEW.HORRATCOR) <> 1 THEN
         cLog := cLog||'Valor pago por hora cortesia: de '||COALESCE(OLD.HORRATCOR,iNulo)||' para '||COALESCE(NEW.HORRATCOR,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.PERRATCOB,NEW.PERRATCOB) <> 1 THEN
         cLog := cLog||'Valor mnimo sobre hora cobrada: de '||COALESCE(OLD.PERRATCOB,iNulo)||' para '||COALESCE(NEW.PERRATCOB,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.MINRATCOB,NEW.MINRATCOB) <> 1 THEN
         cLog := cLog||'Percentual sobre hora cobrada: de '||COALESCE(OLD.MINRATCOB,iNulo)||' para '||COALESCE(NEW.MINRATCOB,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.LIMCRE,NEW.LIMCRE) <> 1 THEN
         cLog := cLog||'Limite de crdito para liberao: de '||COALESCE(OLD.LIMCRE,iNulo)||' para '||COALESCE(NEW.LIMCRE,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.SUPMAX,NEW.SUPMAX) <> 1 THEN
         cLog := cLog||'% Desconto Mximo Permitido para Supervisor: de '||COALESCE(OLD.SUPMAX,iNulo)||' para '||COALESCE(NEW.SUPMAX,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.PRZPAG_MIN,NEW.PRZPAG_MIN) <> 1 THEN
         cLog := cLog||'Prazo mdio mnimo a pagar: de '||COALESCE(OLD.PRZPAG_MIN,iNulo)||' para '||COALESCE(NEW.PRZPAG_MIN,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.PRZPAG_MAX,NEW.PRZPAG_MAX) <> 1 THEN
         cLog := cLog||'Prazo mdio mximo a pagar: de '||COALESCE(OLD.PRZPAG_MAX,iNulo)||' para '||COALESCE(NEW.PRZPAG_MAX,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.CHVMAT,NEW.CHVMAT) <> 1 THEN
         cLog := cLog||'Cdigo de Matrcula: de '||COALESCE(OLD.CHVMAT,cNulo)||' para '||COALESCE(NEW.CHVMAT,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODPOS_USU,NEW.CODPOS_USU) <> 1 THEN
         cLog := cLog||'Cdigo POS CONTROLE: de '||COALESCE(OLD.CODPOS_USU,cNulo)||' para '||COALESCE(NEW.CODPOS_USU,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.SIGNAT,NEW.SIGNAT) <> 1 THEN
         IF (OLD.SIGNAT < 0) AND (NEW.SIGNAT > 0) THEN
            cLog := cLog||'Situao: de Desativado para Ativado'||CRLF;
         ELSIF (OLD.SIGNAT > 0) AND (NEW.SIGNAT < 0) THEN
            cLog := cLog||'Situao: de Ativado para Desativado'||CRLF;
         END IF;
      END IF;

      IF ISNOTNULL(TRIM(cLog)) = 'T' THEN
         cLog := 'Alterao do Usurio '||NEW.FILUSU||'/'||NEW.CODUSU||CRLF||cLog;
                  
         cDUMMY := PC_USUxLOG_UPDATE(NEW.FILCLI, NEW.CODCLI, cLog);
               END IF;
      
      -- Controle do Vencimento da Senha    
      IF (Equal(OLD.SENHA1,NEW.SENHA1) <> 1)
      OR (Equal(OLD.SENHA2,NEW.SENHA2) <> 1)
      OR (Equal(OLD.CSENHA,NEW.CSENHA) <> 1) THEN
         cDataVencimentoSenha := NULL;

          
          SELECT DIAS_EXPIRA
            INTO cDiasExpiraSenha
            FROM (SELECT (SELECT DIAS_EXPIRA_SENHA 
                            FROM TT_PAP PAP
                           WHERE PAP.SEQUEN = PAPUSU.SEQPAP
                             AND PAP.DIAS_EXPIRA_SENHA > 0 ) AS DIAS_EXPIRA 
                     FROM TT_PAPXUSU PAPUSU
                    WHERE PAPUSU.FILUSU = NEW.FILUSU
                      AND PAPUSU.CODUSU = NEW.CODUSU
                                       ORDER BY DIAS_EXPIRA
                 
                    LIMIT 1
                                  )   AS  DIAS
           WHERE 1=1
           LIMIT 1;          
         IF (cDiasExpiraSenha > 0) THEN 
            
            SELECT Agora() + INTERVAL '1' DAY * cDiasExpiraSenha
              INTO cDataVencimentoSenha
              FROM DUAL;
                        
               
         END IF;         
            
         IF (cDataVencimentoSenha IS NOT NULL) THEN
            UPDATE TT_USU
               SET VALSEN = cDataVencimentoSenha
             WHERE 1=1
               AND FILUSU = NEW.FILUSU
               AND CODUSU = NEW.CODUSU
               AND (VALSEN > cDataVencimentoSenha
                OR VALSEN IS NULL);
            cLog := 'Alterao do Usurio '||NEW.FILUSU||'/'||NEW.CODUSU||
                    'Alterado data de vencimento da senha para:  '|| NEW.VALSEN;
         END IF;  
      END IF;

      -- Pemisses
      IF Equal(OLD.PERMIS,NEW.PERMIS) <> 1 THEN
         cLog := 'Alterao do Usurio '||NEW.FILUSU||'/'||NEW.CODUSU||CRLF||
                 'Permisses alteradas:  '|| PermissoesUsuarioAlteradas(OLD.PERMIS, NEW.PERMIS);
                  
         cDUMMY := PC_USUxLOG_UPDATE(NEW.FILCLI, NEW.CODCLI, SUBSTR(cLog,1,4000));
               END IF;
   ELSE
      cRetorno := AtualizaData('CONFIGURACAO',Agora());--Processo de Incluso/Excluso de Usurio
   END IF; 
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5221 --*/
CREATE TRIGGER TGUSU4
AFTER INSERT OR UPDATE OR DELETE ON TT_USU 
FOR EACH ROW EXECUTE PROCEDURE TGUSU4();


/*-- SEQ 5222 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGUSU_DW() CASCADE;

/*-- SEQ 5223 --*/
CREATE OR REPLACE FUNCTION TGUSU_DW() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar log para view/tabela materializadas DW_Vendas_Grupos
DECLARE
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');
BEGIN
   -- (TG_OP = 'INSERT'): No faz nada porque no est relacionado a nenhum registro pai
   -- (TG_OP = 'DELETE'): Garantido pela FK
   IF (TG_OP = 'UPDATE') THEN
      IF Equal(OLD.FILUSU,NEW.FILUSU) <> 1 
      OR Equal(OLD.CODUSU,NEW.CODUSU) <> 1 THEN -- PK      
         RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
      END IF;
      IF Equal(OLD.APEUSU,NEW.APEUSU) <> 1 THEN
         UPDATE DW_Vendas_Grupos
            SET Vendedor = InitCap(NEW.APEUSU) 
          WHERE Vendedor = InitCap(OLD.APEUSU); -- UQ
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5224 --*/
CREATE TRIGGER TGUSU_DW
AFTER UPDATE ON TT_USU 
FOR EACH ROW EXECUTE PROCEDURE TGUSU_DW();


/*-- SEQ 5225 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGVAT() CASCADE;

/*-- SEQ 5226 --*/
CREATE OR REPLACE FUNCTION TGVAT() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.CODTAB IS NULL THEN
       NEW.CODTAB:=ProximoCodigo('TT_VAT',null);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5227 --*/
CREATE TRIGGER TGVAT
BEFORE INSERT ON TT_VAT 
FOR EACH ROW EXECUTE PROCEDURE TGVAT();


/*-- SEQ 5228 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGVDD() CASCADE;

/*-- SEQ 5229 --*/
CREATE OR REPLACE FUNCTION TGVDD() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Atualiza DATINC
-- 3) Atualiza ATU_EM

-- Principal
  QuemLogou TRetQuemLogou%ROWTYPE;
  vLOG    VARCHAR(4000)     := '';
  cNulo   CONSTANT CHAR(4)   := 'Nulo';
  CRLF    CONSTANT CHAR(1)   := CHR(10);
  wk_coduid tt_uid.coduid%type;
  wk_filped tt_vdd.filped%type;
  wk_tipped tt_vdd.tipped%type;
  wk_numped tt_vdd.numped%type;
  wk_filven tt_vdd.filven%type;
  wk_seqven tt_vdd.seqven%type;
  wk_codfil tt_vdd.codfil%type;
BEGIN
  IF (TG_OP = 'INSERT') THEN
     IF NEW.SEQUEN IS NULL THEN
        NEW.SEQUEN := ProximoCodigo('TT_VDD', NEW.CODFIL);
     END IF;
     NEW.DATINC := agora();
  END IF;
  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
     NEW.ATU_EM := agora();
  END IF;
  IF (TG_OP = 'UPDATE') THEN
    IF Equal(OLD.FILPED,NEW.FILPED) <> 1 OR
       Equal(OLD.TIPPED,NEW.TIPPED) <> 1 OR
       Equal(OLD.NUMPED,NEW.NUMPED) <> 1 OR
       Equal(OLD.FILVEN,NEW.FILVEN) <> 1 OR
       Equal(OLD.SEQVEN,NEW.SEQVEN) <> 1 OR
       Equal(OLD.FILVDD,NEW.FILVDD) <> 1 OR
       Equal(OLD.CODVDD,NEW.CODVDD) <> 1 THEN
       vLOG := vLOG||'Alterou registro: '||COALESCE(TO_CHAR(OLD.CODFIL),cNulo)||'/'||COALESCE(TO_CHAR(OLD.SEQUEN),cNulo)||' na TT_VDD '||CRLF;
    END IF;
    IF Equal(OLD.VLRBAS,NEW.VLRBAS) <> 1 THEN
       vLOG := vLOG||'Valor Base da Comisso (tabela vendedor): de '||COALESCE(TO_CHAR(OLD.VLRBAS,'fm999G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRBAS,'fm999G999G999G990D00'),cNulo)||CRLF;
    END IF;
  END IF;
  IF (TG_OP = 'INSERT') THEN
       vLOG := vLOG||'Incluiu registro: '||COALESCE(TO_CHAR(NEW.CODFIL),cNulo)||'/'||COALESCE(TO_CHAR(NEW.SEQUEN),cNulo)||' na TT_VDD '||CRLF;
  END IF;
  IF (TG_OP = 'DELETE') THEN
       vLOG := vLOG||'Excluiu registro: '||COALESCE(TO_CHAR(OLD.CODFIL),cNulo)||'/'||COALESCE(TO_CHAR(OLD.SEQUEN),cNulo)||' na TT_VDD '||CRLF;
  END IF;

  WK_CODUID := GetCoduidAtual();

  IF ISNOTNULL(vLOG) = 'T' THEN
     select * into QuemLogou from DadosLogon();
    IF (TG_OP = 'UPDATE') OR (TG_OP = 'INSERT') THEN
      wk_filped := NEW.FILPED;
      wk_tipped := NEW.TIPPED;
      wk_numped := NEW.NUMPED;
      wk_filven := NEW.FILVEN;
      wk_seqven := NEW.SEQVEN;
      wk_codfil := NEW.CODFIL;
    END IF;
    IF (TG_OP = 'DELETE') THEN
      wk_filped := OLD.FILPED;
      wk_tipped := OLD.TIPPED;
      wk_numped := OLD.NUMPED;
      wk_filven := OLD.FILVEN;
      wk_seqven := OLD.SEQVEN;
      wk_codfil := OLD.CODFIL;
    END IF;
    IF (isnull(wk_filped)='F') THEN
      INSERT INTO TL_ORC (CODFIL,TIPPED,NUMPED,TIPLOG,DATOPE,MSGLOG)
                  VALUES (wk_filped,wk_tipped,wk_numped,'F',Agora(),vLOG);
    END IF;
    IF (isnull(wk_filven)='F') THEN
      INSERT INTO TL_VEN (FILVEN,SEQVEN,FILUSU,CODUSU,DATOPE,MSGLOG,CODUID)
                  VALUES (wk_filven,wk_seqven,QuemLogou.FILUSU,QuemLogou.CODUSU,Agora(),vLog,WK_CODUID);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5230 --*/
CREATE TRIGGER TGVDD
BEFORE INSERT OR DELETE OR UPDATE ON TT_VDD 
FOR EACH ROW EXECUTE PROCEDURE TGVDD();


/*-- SEQ 5231 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGVEI() CASCADE;

/*-- SEQ 5232 --*/
CREATE OR REPLACE FUNCTION TGVEI() RETURNS TRIGGER AS $$
-- Objetivo:
-- 2) Registrar mudanca dos dados num "log"
-- 3) "Delete cascade" na tabela de "log"
DECLARE
   cLOG                          VARCHAR(4000)     := '';
   cLogChave                     VARCHAR(15)       := '';
   cNulo                         CONSTANT CHAR(4)   := 'Nulo';
   iNulo                         CONSTANT Numeric(1) := 0;
   CRLF                          CONSTANT CHAR(1)   := CHR(10);

   cVC_FILCLI                    TT_CFG.VC_FILCLI%TYPE;
   cVC_CODCLI                    TT_CFG.VC_CODCLI%TYPE;
   vComplemento                  CONSTANT VARCHAR(100) := Constante('Complemento');
-- Principal
BEGIN
   IF (TG_OP = 'INSERT') THEN
      -- Nao permite veiculos para o cliente "venda ao consumidor"
      SELECT VC_FILCLI, VC_CODCLI INTO cVC_FILCLI, cVC_CODCLI FROM TT_CFG;
      IF  ((NEW.FILCLI = cVC_FILCLI)
      AND  (NEW.CODCLI = cVC_CODCLI)) THEN
         RAISE EXCEPTION 'PG-20039 Nao e permitido incluir veiculos para o parceiro "Venda ao Consumidor". %' , vComplemento;
      END IF;
   END IF;
   -- Tratamento de log
   IF (TG_OP = 'INSERT')
   OR (TG_OP = 'UPDATE') THEN
      cLogChave := 'Veculo ' || NEW.PLACAS;
   END IF;
   IF (TG_OP = 'INSERT') THEN
      cLOG := 'Incluso de ' || cLogChave;      
   ELSIF (TG_OP = 'UPDATE') THEN  
      IF Equal(OLD.PLACAS,NEW.PLACAS) <> 1 THEN
         cLOG := cLOG||'Placas: de '||COALESCE(OLD.PLACAS,cNulo)||' para '||COALESCE(NEW.PLACAS,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODTIP,NEW.CODTIP) <> 1 THEN
         cLOG := cLOG||'Tipo: de '||COALESCE(OLD.CODTIP,iNulo)||' para '||COALESCE(NEW.CODTIP,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.CODCOR,NEW.CODCOR) <> 1 THEN
         cLOG := cLOG||'Cor: de '||COALESCE(OLD.CODCOR,iNulo)||' para '||COALESCE(NEW.CODCOR,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.MODVEI,NEW.MODVEI) <> 1 THEN
         cLOG := cLOG||'Modelo: de '||COALESCE(OLD.MODVEI,'...')||' para '||COALESCE(NEW.MODVEI,'...')||CRLF;
      END IF;
      IF Equal(OLD.MARVEI,NEW.MARVEI) <> 1 THEN
         cLOG := cLOG||'Marca: de '||COALESCE(OLD.MARVEI,'...')||' para '||COALESCE(NEW.MARVEI,'...')||CRLF;
      END IF;
      IF Equal(OLD.ANOVEI,NEW.ANOVEI) <> 1 THEN
         cLOG := cLOG||'Ano: de '||COALESCE(OLD.ANOVEI,iNulo)||' para '||COALESCE(NEW.ANOVEI,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.TRAFEG,NEW.TRAFEG) <> 1 THEN
         cLOG := cLOG||'Controla trafego: de '||COALESCE(OLD.TRAFEG,cNulo)||' para '||COALESCE(NEW.TRAFEG,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.NACION,NEW.NACION) <> 1 THEN
         cLOG := cLOG||'Nacional/Importado?: de '||COALESCE(OLD.NACION,cNulo)||' para '||COALESCE(NEW.NACION,cNulo)||CRLF;
      END IF;
      IF (Equal(OLD.FILCCC,NEW.FILCCC) <> 1) or (Equal(OLD.SEQCCC,NEW.SEQCCC) <> 1) THEN
         cLOG := cLOG||'Conta Corrente: de '||COALESCE(OLD.FILCCC,cNulo)||'/'||COALESCE(OLD.SEQCCC,cNulo)||' para '||COALESCE(NEW.FILCCC,cNulo)||'/'||COALESCE(NEW.SEQCCC,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.VLRCCC,NEW.VLRCCC) <> 1 THEN
         cLOG := cLOG||'Valor conta corrente: de '||COALESCE(OLD.VLRCCC,iNulo)||' para '||COALESCE(NEW.VLRCCC,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.VEIATI,NEW.VEIATI) <> 1 THEN
         cLOG := cLOG||'Veculo Ativo?: de '||COALESCE(OLD.VEIATI,cNulo)||' para '||COALESCE(NEW.VEIATI,cNulo)||CRLF;
      END IF;
      IF Equal(OLD.CCCPRE,NEW.CCCPRE) <> 1 THEN
         cLOG := cLOG||'Conta Corrente Preferencial: de '||COALESCE(OLD.CCCPRE,iNulo)||' para '||COALESCE(NEW.CCCPRE,iNulo)||CRLF;
      END IF;
      IF Equal(OLD.SIGEST,NEW.SIGEST) <> 1 THEN
         cLOG := cLOG||'UF: de '||COALESCE(OLD.SIGEST,cNulo)||' para '||COALESCE(NEW.SIGEST,cNulo)||CRLF;
      END IF;
      
      IF ISNOTNULL(cLOG) = 'T' THEN
         cLOG := cLogChave || ' >> ' || cLOG;
      END IF;
   END IF;
   IF (TG_OP = 'INSERT') 
   OR (TG_OP = 'UPDATE') THEN
      IF ISNOTNULL(cLOG) = 'T' THEN
         INSERT INTO TL_CLI (FILCLI,CODCLI,DATOPE,MSGLOG)
                     VALUES (NEW.FILCLI,NEW.CODCLI,agora(),cLOG);
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5233 --*/
CREATE TRIGGER TGVEI
AFTER INSERT OR DELETE OR UPDATE ON TT_VEI 
FOR EACH ROW EXECUTE PROCEDURE TGVEI();

/*-- SEQ 5234 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGVEI1() CASCADE;

/*-- SEQ 5235 --*/
CREATE OR REPLACE FUNCTION TGVEI1() RETURNS TRIGGER AS $$
DECLARE
   cRet                          VARCHAR(2);
BEGIN
   IF (TG_OP = 'DELETE') THEN
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_VEI', COALESCE(OLD.FILCLI,'')||COALESCE(OLD.CODCLI ,''), OLD.PLACAS);
   END IF;
   
   IF (TG_OP = 'INSERT') THEN
      --esse (TG_OP = 'DELETE') eh proposital, gerando um false na funo
      cRet := LogExclusao((TG_OP = 'DELETE'), 'TT_VEI', COALESCE(NEW.FILCLI,'')||COALESCE(NEW.CODCLI ,''), NEW.PLACAS);
   END IF;
   IF NOT (TG_OP = 'DELETE') THEN
      NEW.ATU_EM := AGORA();
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5236 --*/
CREATE TRIGGER TGVEI1
BEFORE INSERT OR UPDATE OR DELETE ON TT_VEI 
FOR EACH ROW EXECUTE PROCEDURE TGVEI1();



/*-- SEQ 5237 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGVEN2() CASCADE;

/*-- SEQ 5238 --*/
CREATE OR REPLACE FUNCTION TGVEN2() RETURNS TRIGGER AS $$
DECLARE

  -- Objetivo:
  -- 1) Impedir exclusao
  -- 2) Impedir alteracao nas colunas que nao se referem ao status
  -- 3) Realizar "update cascade" no TT_VEN para unificacao dos status
  -- 4) Gerar um codigo sequencial exclusivo para compor a chave primaria
  -- 5) Verificar, a mando do Checkout, se ainda existe parcelas a receber
  -- 6) Impedir cancelamento de Nota Fiscal de Transferencia
  -- 7) Estornar parcelas ligadas a devoluo de mercadorias
  -- 8) Gera Bnus por Valor Acumulado de Vendas
  -- 9) Estornar vendas/itens que ultrapassaram o prazo de cancelamento
  --
  -- IMPORTANTE: se esta trigger passar a permitir alteracoes na chave primaria ou
  --             exclusoes, sera preciso fazer o "update/delete cascade" em TT_VEN
  --             ou impedir de faze-lo. Este cuidado e necessario porque TT_VEN
  --             nao possui "foreign key" (ela foi eliminada para evitar o erro de
  --             "mutating table")
  --

  linha                          INTEGER;
  qtd_rec                        INTEGER DEFAULT 0;
  vFILCTA                        TD_CTA.FILCTA%TYPE;
  vSEQCTA                        TD_CTA.SEQCTA%TYPE;
  vTIPCTA                        TD_CTA.TIPCTA%TYPE;
  vCODCFO                        TD_CFO.CODTAB%TYPE;
  vUFLOJA                        TT_END.SIGEST%TYPE;
  vSEQCOM                        TT_COM.SEQUEN%TYPE;
  vCMSIND                        TT_CLI.CMSIND%TYPE;
  regTT_Rec                      record;
  regTT_Cms                      record;
  regTV_VDD                      record;

  -- Criada para indicar o status de LANVEN e FINANC e passa-lo para TT_IVE
  wk_DiaFechado                  Numeric;
  wk_TipoCCC                     TT_CCC.TIPCCC%TYPE;
  vComplemento                   VARCHAR(100) := constante('complemento');
  vVEM_DE_TGVEN                  VARCHAR(1) := constante('VEM_DE_TGVEN');
  vFILCLI                        TT_CLI.FILCLI%TYPE;
  vCODCLI                        TT_CLI.CODCLI%TYPE;
  vSALDO                         TT_CCC.VLRLAN%TYPE;
  cDUMMY                         CHAR(10);
  vLog                           VARCHAR(4000);
  WK_CTR_CC                      TD_FIL.CTR_CC%TYPE;
  vPERCAN                        VARCHAR(250);
  cTIPNAT                        TD_NAT.TIPNAT%TYPE;
  cFINANC                        TD_NAT.FINANC%TYPE;

 
  QuemLogou                      TRetQuemLogou%ROWTYPE;

  vTOTPAR                        TT_CLI.TOTPAR%TYPE;
  vTOTATR                        TT_CLI.TOTATR%TYPE;
  estado                         VARCHAR(1);


  vVEM_DE_TGVEN_TT               VARCHAR(100) := constante('vem_de_tgven_tt');
  vVEM_DE_TGVEN_TF               VARCHAR(100) := constante('vem_de_tgven_tf');
  vVEM_DE_TGVEN_FT               VARCHAR(100) := constante('vem_de_tgven_ft');
  vVEM_DE_TGVEN_FF               VARCHAR(100) := constante('vem_de_tgven_ff');
  vVEM_DE_TGVEN_DV               VARCHAR(100) := constante('vem_de_tgven_dv');
  vVEM_DE_TGVEN_DV_CMS           VARCHAR(100) := constante('vem_de_tgven_dv_cms');
  WK_FILVEN                      TT_CLI.FILVEN%TYPE;
  WK_CODVEN                      TT_CLI.CODVEN%TYPE;

  vFILTEF                        TT_OPE.FILTEF%TYPE;
  vSEQTEF                        TT_OPE.SEQTEF%TYPE;

  -- CODCRT Tratamento para 0
  vCODCRT                        TT_VEN.CODCRT%TYPE;

  --LEO 84337
  vSESSIONID                     TT_UID.SESSION_ID%TYPE := USERENV('SESSIONID');

  WK_LIMCOF                      TD_FIL.LIMCOF%TYPE;
  WK_PERSOC                      TD_FIL.PERSOC%TYPE;
  WK_PERCOF                      TD_FIL.PERCOF%TYPE;
  WK_PERPIS                      TD_FIL.PERPIS%TYPE;

  --80327
  WK_FLGECO                      TT_ORC.FLGECO%TYPE;
  WK_TIPPED                      TT_ORC.TIPPED%TYPE;
  WK_NUMPED                      TT_ORC.NUMPED%TYPE;
  WK_CODFIL                      TT_ORC.CODFIL%TYPE;
  WK_MODNOT                      TD_SER.MODNOT%TYPE;
  wk_MultVendedores              TT_CFG.MULT_VENDEDORES%TYPE;
  cResult                        VARCHAR(5);
  cSituacao                      VARCHAR(3);
  cFLGESTNew                     TT_VEN.FLGEST%TYPE;
  nQtdVendedores                 Numeric;
  vFILCLIOld                     TT_CLI.FILCLI%TYPE;
  vCODCLIOld                     TT_CLI.CODCLI%TYPE;
  vESTORN                        TT_IVE.ESTORN%TYPE;
  bAltera_EXPORT                 BOOLEAN;
  nDifVlrlan                     TT_CCC.VLRLAN%TYPE;
  vVEM_DE_DESCANCELA_VENDA       VARCHAR(100) := constante('VEM_DE_DESCANCELA_VENDA');
  -- RFMP 85136
  WK_UID                         TPC_UID_Retorno%ROWTYPE;

  -- Cursor para estornar faturamentos de CC do cliente e seus dependentes
  FaturaCC CURSOR(pFILFAT TT_CCC.FILFAT%TYPE,
           pSEQFAT TT_CCC.SEQFAT%TYPE) IS
  select filcli,codcli,sum(vlrlan)
    from tt_ccc
   where filfat=pFILFAT
     and seqfat=pSEQFAT
     and status<>'F'
   group by filcli,codcli
  having sum(vlrlan)<>0;

  -- Cursor para estornar faturamentos de CC do cliente e seus dependentes
  CR_Rec CURSOR(pCODFIL TT_VEN.CODFIL%TYPE,
           pSEQUEN TT_VEN.SEQUEN%TYPE) IS
  SELECT *
    FROM TT_REC
   WHERE CODFIL = pCODFIL
     AND SEQUEN = pSEQUEN;

  -- Cursor para cancelar as parcelas de carto quando a venda  cancelada pelo Checkout e o carto s foi usado para pagar aquela venda
  CR_Itf CURSOR(pCODFIL TT_VEN.CODFIL%TYPE,
           pSEQUEN TT_VEN.SEQUEN%TYPE) IS
  SELECT TEF.CODFIL, TEF.SEQUEN
    FROM TT_OPE REC INNER JOIN TT_TEF TEF ON REC.CODFIL = TEF.CODFIL
                                         AND REC.NUMECF = TEF.NUMECF
                                         AND REC.TRN_ID = TEF.TRN_ID
                     LEFT JOIN TT_OPE OPE ON OPE.CODFIL = REC.CODFIL
                                         AND OPE.NUMECF = REC.NUMECF
                                         AND OPE.TRN_ID = REC.TRN_ID
                                         AND OPE.FILREC <> REC.FILREC
                                         AND OPE.SEQREC <> REC.SEQREC
   WHERE REC.FILREC = pCODFIL
     AND REC.SEQREC = pSEQUEN
     AND OPE.CODFIL IS NULL
   GROUP BY TEF.CODFIL, TEF.SEQUEN;

  -- Cursor para estornar comisses pagas a vendedores
  CR_Cms CURSOR(pCODFIL TT_VEN.CODFIL%TYPE,
           pSEQUEN TT_VEN.SEQUEN%TYPE) IS
  SELECT *
    FROM TT_CMS
   WHERE FILREC = pCODFIL
     AND SEQREC = pSEQUEN
     AND FLGEST = 'P';

  -- Cursor para acumulo de bnus por valor para multiplos vendedores
  -- Pedro E. Braga: 92163 / 92188 - Tratamento para Bnus por Valor Acumulado de Venda.
  CR_MultiplosVendedores CURSOR(pCODFIL TT_VEN.CODFIL%TYPE,
           pSEQUEN TT_VEN.SEQUEN%TYPE) IS
      SELECT *
        FROM TV_VDD
       WHERE CODFIL = pCODFIL
         AND SEQUEN = pSEQUEN;

BEGIN

  -- DN - Financeiro Estoque
  IF ((TG_OP = 'INSERT') OR (TG_OP = 'UPDATE')) THEN
     NEW.DATSTR:=TO_CHAR(NEW.DATHOR,'DD/MM/YYYY');
  END IF;

  -- CODAVU sempre em maisculas
  IF ((TG_OP = 'INSERT') OR (TG_OP = 'UPDATE')) AND (NEW.CODAVU <> UPPER(NEW.CODAVU)) THEN
     NEW.CODAVU := UPPER(NEW.CODAVU);
  END IF;

  -- Pedro E. Braga: 92163 / 92188 - Tratamento para Bnus por Valor Acumulado de Venda.
  IF ((TG_OP = 'INSERT') OR (TG_OP = 'UPDATE')) THEN
    cFLGESTNew := NEW.FLGEST;
  END IF;

  -- Tratamento para CODCRT = 0
  IF (TG_OP = 'INSERT') THEN
     IF NEW.CODCRT = 0 THEN

    -- Busca valor correto para CODCRT  na coluna TD_IDF.REGTRI quando CODFIL da venda inserida for igual a TD_FIL.CODFIL
        SELECT CASE REGTRI WHEN 'S'
                           THEN CASE WHEN COALESCE(TRISIM,'X') = 'O' THEN 2 ELSE 1 END
                           ELSE 3
               END AS NEW_CODCRT
          INTO vCODCRT
          FROM TD_FIL
         WHERE CODFIL = NEW.CODFIL;

       -- Substitui o 0 pelo o valor tratado da coluna TD_FIL.REGTRI
       NEW.CODCRT := vCODCRT;
     END IF;
  END IF;

  -- Controle para Concorrencia de Transao
  IF (TG_OP = 'UPDATE') THEN
    IF (COALESCE(OLD.SIGNAT,0) <> COALESCE(NEW.SIGNAT,0)) THEN
       RAISE EXCEPTION 'PG-20003 Registro foi alterado por outro usurio, refaa a consulta e tente gravar novamente. %' , vComplemento;
    END IF;
    NEW.SIGNAT := MOD(COALESCE(OLD.SIGNAT,0) + 1,100000);
  END IF;

  -- Impede exclusoes
  IF (TG_OP = 'DELETE') THEN
     RAISE EXCEPTION 'PG-20027 Exclusao so pode ser feita atraves da rotina manutencao. %' , vComplemento;
  END IF;

  -- MN - Impede alteraes indesejadas de documentos eletrnicos. Documento autorizado s pode ser cancelado. 
  --      documento denegado ou cancelado no pode ser alterado
  IF (TG_OP = 'UPDATE') THEN
    IF Equal(OLD.FLGNFE,NEW.FLGNFE) <> 1 THEN
      IF ((OLD.FLGNFE = '3') and (NEW.FLGNFE <> '4')) OR -- Quando registro est cancelado e ser marcado como Inutilizado
         ((OLD.FLGNFE = '3') and COALESCE(NEW.DUMMY,' ') <> constante('VEM_DE_DESCANCELA_VENDA')) -- Operao que est realizando o descancelamento da venda para autenticao ou outra mudana devido a falhas
         THEN 
         RAISE EXCEPTION 'PG-20033 No  possvel alterar o status de documento eletrnico quando o mesmo est Cancelado. %' , vComplemento;
      END IF;

      IF OLD.FLGNFE = '6' THEN 
         RAISE EXCEPTION 'PG-20033 No  possvel alterar o status de documento eletrnico quando o mesmo est Denegado. %' , vComplemento;
      END IF;

      IF (OLD.FLGNFE = '1') and (NEW.FLGNFE <> '3') THEN 
         RAISE EXCEPTION 'PG-20033 Somente  possvel alterar o status de documento eletrnico Autorizado para Cancelado. %' , vComplemento;
      END IF;
    END IF;
  END IF;
  
  IF (TG_OP = 'UPDATE') THEN
     IF (NEW.FLGEST = 'C') AND (NEW.FLGEST <> OLD.FLGEST) THEN

        NEW.ORICAN := '1';
        IF COALESCE(NEW.DUMMY,' ') = constante('VEM_DE_CANCELA_NF') THEN
           NEW.ORICAN := '2';
        END IF;
        
        -- MN - 2023067644 - Se estiver cancelando a venda, deve-se verificar se deve cancelar o vnculo com oramento faturado
        --      a TT_RDV s existe para ecommerce, ns no inserimos nessa tabela. Se tiver registro de RDV, deve-se alterar
        --      TT_ORC.FLGECO, de F (Faturado) para P (Pagamento aprovado)
        BEGIN
          WK_CODFIL := '';
          WK_TIPPED := '';
          WK_NUMPED := '';
        
          SELECT ORC.CODFIL, ORC.TIPPED, ORC.NUMPED,
                 CASE WHEN RDV.CODFIL IS NULL THEN 'R' ELSE 'P' END AS SITECO
            INTO WK_CODFIL, WK_TIPPED, WK_NUMPED, WK_FLGECO
            FROM TT_IVE IVE INNER JOIN TT_IOR IOR ON IOR.FILIVE = IVE.CODFIL
                                                 AND IOR.SEQIVE = IVE.SEQUEN
                                                 AND IOR.NUMIVE = IVE.NUMITE
                            INNER JOIN TT_ORC ORC ON ORC.CODFIL = IOR.CODFIL
                                                 AND ORC.TIPPED = IOR.TIPPED
                                                 AND ORC.NUMPED = IOR.NUMPED 
                             LEFT JOIN TT_RDV RDV ON ORC.CODFIL = RDV.CODFIL
                                                 AND ORC.TIPPED = RDV.TIPPED
                                                 AND ORC.NUMPED = RDV.NUMPED
          WHERE ORC.FLGECO = 'F'
            AND IVE.CODFIL = NEW.CODFIL
            AND IVE.SEQUEN = NEW.SEQUEN
          LIMIT 1;

                END;
        
        IF TRIM(WK_NUMPED) <> '' THEN 
          UPDATE TT_ORC 
             SET FLGECO = WK_FLGECO
           WHERE CODFIL = WK_CODFIL
             AND TIPPED = WK_TIPPED
             AND NUMPED = WK_NUMPED;
        END IF;
     END IF;
  END IF;

  IF (TG_OP = 'INSERT') THEN
     IF COALESCE(NEW.DUMMY,'N')<>'I' THEN
        RAISE EXCEPTION 'PG-20048 Checkout nao esta com a versao minima para esta base de dados. %' , vComplemento;
     END IF;
  END IF;

  IF (TG_OP = 'INSERT') THEN
     IF NEW.CODSER = 'CC' AND NEW.CODCTR = 0 THEN
        SELECT CTR_CC INTO WK_CTR_CC FROM TD_FIL WHERE CODFIL = NEW.CODFIL;
        IF WK_CTR_CC IS NOT NULL THEN
          NEW.CODCTR := WK_CTR_CC;
        ELSE
          RAISE EXCEPTION 'PG-20028 Falta definir na filial a unidade de negcio para faturamento. Verifique no Totali Config. %' , vComplemento;
        END IF;
     END IF;
  END IF;

  -- Impede cancelamento de Notas Fiscais de Transferncia
  IF (TG_OP = 'UPDATE') THEN
      IF (OLD.FLGEST <> NEW.FLGEST) AND
         (NEW.FLGEST = 'C') AND
         (NEW.CODCLI = '     0') AND
         (NEW.NUMNOT = ('###'||NEW.FILCLI)) THEN
         RAISE EXCEPTION 'PG-20045 Nao e permitido o cancelamento de nota fiscal de transferencia. %' , vComplemento;
      END IF;
  END IF;

  -- Restringe que a ven tenha natureza de venda quando for titulo avulso - rfmp - 64090
  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
    IF (NEW.TITAVU = 'T')
    AND(NEW.LANVEN = 'T') THEN
      RAISE EXCEPTION 'PG-20046 Nao e permitido lancamento de venda para titulo avulso. %' , vComplemento;
    END IF;
  END IF;

  --Caso o campo CMSIND esteja nulo o calculo  feito pelo campo CMSIND da tabela TT_CLI - 67467
  IF (TG_OP = 'INSERT') THEN
    SELECT FINANC into cFINANC
      FROM TD_NAT
     WHERE CODTAB = NEW.CODNAT;
     IF  (coalesce(NEW.CMSIND,0)=0)
     AND (NEW.FILGUI IS NOT NULL)
     AND (NEW.CODGUI IS NOT NULL)
     AND cFINANC='T' THEN
                SELECT CMSIND into vCMSIND
           FROM TT_CLI
          WHERE FILCLI = NEW.FILGUI
            AND CODCLI = NEW.CODGUI;
       
       -- 91081 - Retirado o valor de VLRFRE do clculo da comisso para indicador
       NEW.CMSIND := (NEW.VLRLIQ-COALESCE(NEW.VLRFRE,0)) * vCMSIND /100;

     END IF;
  END IF;

  -- "update cascade"
  IF (TG_OP = 'UPDATE') THEN
     IF (NEW.FLGEST = 'C') AND (NEW.FLGEST <> OLD.FLGEST) THEN
        IF    COALESCE(NEW.LANVEN,'F') IN ('T','P') AND COALESCE(NEW.FINANC,'F') = 'T' then estado := vVEM_DE_TGVEN_TT;
        ELSIF COALESCE(NEW.LANVEN,'F') IN ('T','P') AND COALESCE(NEW.FINANC,'F') = 'F' then estado := vVEM_DE_TGVEN_TF;
        ELSIF COALESCE(NEW.LANVEN,'F') = 'F' AND COALESCE(NEW.FINANC,'F') = 'T' then estado := vVEM_DE_TGVEN_FT;
        ELSIF COALESCE(NEW.LANVEN,'F') = 'F' AND COALESCE(NEW.FINANC,'F') = 'F' then estado := vVEM_DE_TGVEN_FF;
        -- Improvavel mas...
        ELSE RAISE EXCEPTION 'PG-20031 Valor invalido para LANVEN ou FINANC. %' , vComplemento;
        END IF;

       SELECT COUNT(*),SUM(TRUNC(PAGAME) - TRUNC(DATVEN)) INTO vTOTPAR, vTOTATR
         FROM TT_REC
        WHERE FLGEST NOT IN ('C','P','X')
          AND CODFIL = NEW.CODFIL
          AND SEQUEN = NEW.SEQUEN;

       -- Rhuan - 93022 - Tratamento para estorno de nota
       IF NEW.IMPEST = 'P' THEN
         vESTORN := 'T';
       ELSE
         vESTORN := 'F';
       END IF;

       
       
          cDUMMY := PC_VEN_UPDATE(NEW.CODFIL, NEW.SEQUEN, estado, vTOTPAR, vTOTATR, vESTORN);
          cDUMMY := PC_VEN_UPDATE(NEW.CODFIL, NEW.SEQUEN, NULL, NULL, NULL, NULL);
       
       -- para nota de crdito de ICMS
       UPDATE TR_ECF SET SEQCRE = NULL WHERE CODFIL = OLD.CODFIL AND SEQCRE = OLD.SEQUEN;

       -- Reabre carga ao cancelar nota de romaneio - PAVIN - rfmp - 58363 - 29/01/2008
       UPDATE TT_IRO
          SET FLGEST = 'C'
        WHERE FILVEN = NEW.CODFIL
          AND SEQVEN = NEW.SEQUEN;

       UPDATE TT_ROM
          SET FLGEST = 'F'
        WHERE (CODFIL, SEQUEN)
           IN (SELECT CODFIL, SEQUEN
                 FROM TT_IRO
                WHERE FILVEN = NEW.CODFIL
                  AND SEQVEN = NEW.SEQUEN);

       -- Ao cancelar impressao disvincula separacoes da nota - PROJETO PAVIN - rfmp - 58863 - 30/01/2008
       UPDATE TT_IVO
          SET FILIMP = null,
              SEQIMP = null,
              NUMIMP = null,
              FLGEST = 'D', -- RFMP 86017 Devolve separao
              FILROM = null,
              SEQROM = null,
              TEMROM = 'F'
        WHERE FILIMP = NEW.CODFIL
          AND SEQIMP = NEW.SEQUEN;
     END IF;
  END IF;

  -- RFMP 75423
  -- Tratamento de PIS, Cofins e Contribuio Social para manter compatibilidade com os Checkouts anteriores  4.7m
  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
    SELECT COALESCE(LIMCOF,0), COALESCE(PERSOC,0), COALESCE(PERCOF,0), COALESCE(PERPIS,0)
      INTO WK_LIMCOF, WK_PERSOC, WK_PERCOF, WK_PERPIS
      FROM TD_FIL
     WHERE CODFIL = NEW.CODFIL;
    IF  (WK_LIMCOF > 0)
    AND (COALESCE(NEW.VLRCOF,0) > 0)
    AND (COALESCE(NEW.VLRPIS,0) + COALESCE(NEW.VLRCSL,0) + COALESCE(NEW.VLRCFI,0)) = 0
    AND (COALESCE(WK_PERSOC,0) + COALESCE(WK_PERCOF,0) + COALESCE(WK_PERPIS,0)) > 0 THEN
      NEW.VLRPIS := TRUNC(COALESCE(NEW.VLRCOF,0) / (COALESCE(WK_PERSOC,0) + COALESCE(WK_PERCOF,0) + COALESCE(WK_PERPIS,0)) * WK_PERPIS,2);
      NEW.VLRCSL := TRUNC(COALESCE(NEW.VLRCOF,0) / (COALESCE(WK_PERSOC,0) + COALESCE(WK_PERCOF,0) + COALESCE(WK_PERPIS,0)) * WK_PERSOC,2);
      NEW.VLRCFI := NEW.VLRCOF - NEW.VLRPIS - NEW.VLRCSL;
    END IF;
  END IF;

  --rodrigo 63531
  IF (TG_OP = 'INSERT') THEN
      IF (NEW.VLRLIQ = NEW.VLRNOT + NEW.SUBSTT + NEW.VLRFRE + NEW.VLRSEG + COALESCE(NEW.VLRPIS,0) + COALESCE(NEW.VLRCSL,0) + COALESCE(NEW.VLRCFI,0) ) AND (NEW.DESCON <> 0) AND
         (NEW.VLRNOT<>0) THEN
         IF (NEW.DESCON = ((NEW.VLRLIQ/NEW.VLRNOT) -1) *100) AND (NEW.VLRFRE = NEW.VLRNOT * (NEW.DESCON/100)) THEN
          NEW.DESCON := 0;
         END IF;
      END IF;
  END IF;

  -- Se dia fechado, nao permite inclusao de vendas
  IF (TG_OP = 'INSERT') THEN
     IF NEW.CODSER IN ('CF','TK') THEN
         SELECT COUNT(*) INTO wk_DiaFechado FROM DUAL
           WHERE EXISTS (SELECT DIAFEC
                           FROM TR_ECF
                          WHERE CODFIL = NEW.CODFIL
                            AND NUMECF = NEW.NUMECF
                            AND DATOPE = NEW.DATFIS
                            AND CNT_RO = NEW.CNT_RO
                            AND DIAFEC = 'S');

         IF wk_DiaFechado > 0 THEN
            RAISE EXCEPTION 'PG-20043 Nao se pode inserir vendas para um movimento encerrado. %' , vComplemento;
         END IF;
     END IF;
  END IF;

  -- Impede alteracoes
  IF (TG_OP = 'UPDATE') THEN
    IF ((--Equal(OLD.CODFIL,NEW.CODFIL) = 0 OR
--       Equal(OLD.FILVEN,NEW.FILVEN) = 0 OR --rodrigo 58200
--       Equal(OLD.CODVEN,NEW.CODVEN) = 0 OR --rodrigo 58200
       Equal(OLD.FILPGT,NEW.FILPGT) = 0 OR
--       Equal(OLD.CODPGT,NEW.CODPGT) = 0 OR
       Equal(OLD.PERCOM,NEW.PERCOM) = 0 OR
       Equal(OLD.PERENT,NEW.PERENT) = 0 OR
       Equal(OLD.COMSOB,NEW.COMSOB) = 0 OR
       --Equal(OLD.CODNAT,NEW.CODNAT) = 0 OR
       Equal(OLD.PRAMED,NEW.PRAMED) = 0 OR
       Equal(OLD.ESPECI,NEW.ESPECI) = 0 OR
       Equal(OLD.AUTENT,NEW.AUTENT) = 0 OR
       --Equal(OLD.DESCON,NEW.DESCON) = 0 OR
-- Paulo - 75595 : Agora  possivel alterar o indicador da venda.
--       Equal(OLD.FILGUI,NEW.FILGUI) = 0 OR
--       Equal(OLD.CODGUI,NEW.CODGUI) = 0 OR
--       Equal(OLD.SIGNAT,NEW.SIGNAT) = 0 OR
       Equal(OLD.DATSAI,NEW.DATSAI) = 0 OR
       Equal(OLD.NUMVOL,NEW.NUMVOL) = 0 OR
       --Equal(OLD.MARCAS,NEW.MARCAS) = 0 OR -- Manoel - 101190
       --RFMP 84638 Comentado: Equal(OLD.VLRSEG,NEW.VLRSEG) = 0 OR
       --RFMP 84638 Comentado: Equal(OLD.VLRFRE,NEW.VLRFRE) = 0 OR
       Equal(OLD.PESBRU,NEW.PESBRU) = 0 OR
       Equal(OLD.PESLIQ,NEW.PESLIQ) = 0 OR
       Equal(OLD.NUMCON,NEW.NUMCON) = 0 OR
       Equal(OLD.CODPRE,NEW.CODPRE) = 0 OR
       Equal(OLD.SINAL ,NEW.SINAL ) = 0 OR
       Equal(OLD.FINANC,NEW.FINANC) = 0 OR
       Equal(OLD.TRIBUT,NEW.TRIBUT) = 0 OR
       Equal(OLD.FILPRE,NEW.FILPRE) = 0 OR
       Equal(OLD.EMIDES,NEW.EMIDES) = 0 OR
--       Equal(OLD.SEQUEN,NEW.SEQUEN) = 0 OR
       Equal(OLD.FILTRA,NEW.FILTRA) = 0 OR
       Equal(OLD.CODTRA,NEW.CODTRA) = 0 OR
       Equal(OLD.TIPNOT,NEW.TIPNOT) = 0 OR
       Equal(OLD.TIPTRA,NEW.TIPTRA) = 0 OR
       --PTulio - davi - 34593 - 14/05/05
       --Equal(OLD.FILFAT,NEW.FILFAT) = 0 OR
       --Equal(OLD.ENDFAT,NEW.ENDFAT) = 0 OR
       --Equal(OLD.FILENT,NEW.FILENT) = 0 OR
       --Equal(OLD.ENDENT,NEW.ENDENT) = 0 OR
       --Equal(OLD.FILCOB,NEW.FILCOB) = 0 OR
       --Equal(OLD.ENDCOB,NEW.ENDCOB) = 0 OR
       Equal(OLD.CODFIN,NEW.CODFIN) = 0 OR
       Equal(OLD.LANVEN,NEW.LANVEN) = 0 OR
       Equal(OLD.VINCUL,NEW.VINCUL) = 0) OR
       ((--Equal(OLD.VLRNOT,NEW.VLRNOT) = 0 OR
         --Equal(OLD.VLRLIQ,NEW.VLRLIQ) = 0 OR
         Equal(OLD.NUMNOT,NEW.NUMNOT) = 0 OR
         --Equal(OLD.CODSER,NEW.CODSER) = 0 OR
--         Equal(OLD.NUMECF,NEW.NUMECF) = 0 OR -- 001/ 33333
         Equal(OLD.DATHOR,NEW.DATHOR) = 0)
          AND (NEW.CODCLI<>'     0')
--          AND (OLD.NUMNOT<> ('###'||OLD.FILCLI))
          AND (OLD.DATHOR<>TRUNC(OLD.DATHOR)
          AND (COALESCE(OLD.NROIMP,0)<>0))))
          AND (NEW.TITAVU='F')
        THEN
       RAISE EXCEPTION 'PG-20028 Uma venda nao pode ser modificada. %' , vComplemento;
    END IF;

    -- DANIEL 33618 PTULIOF2
    IF (Equal(OLD.FILCLI,NEW.FILCLI) = 0 OR
        Equal(OLD.CODCLI,NEW.CODCLI) = 0) AND
        PERMISSAO(trim(GetApeUsuAtual()),195)=0 THEN
        RAISE EXCEPTION 'PG-20049 Usuario no tem permissao para alterar cliente de venda. %' , vComplemento;
    END IF;

    IF (Equal(OLD.FILCLI,NEW.FILCLI) = 0 OR
        Equal(OLD.CODCLI,NEW.CODCLI) = 0) THEN

       UPDATE TT_CHR
          SET FILCLI=NEW.FILCLI,
              CODCLI=NEW.CODCLI,
              DUMMY=CONSTANTE('VEM_DE_TGVEN')
        WHERE (CODFIL,SEQUEN) IN
        (SELECT CODFIL,SEQCHE
           FROM TT_REC
          WHERE CODFIL=NEW.CODFIL
            AND SEQUEN=NEW.SEQUEN
        );

       UPDATE TT_CCC
          SET FILCLI=NEW.FILCLI,
              CODCLI=NEW.CODCLI,
              DUMMY=CONSTANTE('VEM_DE_TGVEN')
        WHERE CODVEN=NEW.CODFIL
          AND SEQVEN=NEW.SEQUEN;

    END IF;
    -- FIM DANIEL 33618 PTULIOF2

    IF (OLD.SEQFAT is not null AND
        NEW.SEQFAT is not null AND
        OLD.SEQFAT <> NEW.SEQFAT) THEN
        RAISE EXCEPTION 'PG-20042 Nao e possivel mudar o vinculo de uma nota para outra. %' , vComplemento;
    END IF;

    IF NOT ((NEW.FLGEST = 'C') AND (OLD.FLGEST != 'C')) THEN
       IF Equal(OLD.FILUSU,NEW.FILUSU) = 0 OR
          Equal(OLD.CODUSU,NEW.CODUSU) = 0 THEN
          RAISE EXCEPTION 'PG-20050 Usuario de uma venda cancelada nao pode ser modificado. %' , vComplemento;
       END IF;
    ELSE
       IF TGR_Tem_Vinculo(NEW.codfil, NEW.sequen) THEN
          RAISE EXCEPTION 'PG-20040 Cancelamento so pode ser feito em notas que nao tenham vinculo. %' , vComplemento;
       END IF;

       IF NEW.SEQFAT IS NOT NULL THEN
          RAISE EXCEPTION 'PG-20041 Cancelamento nao pode ser feito em notas de faturamento. %' , vComplemento;
       END IF;
    END IF;

/*    IF (NEW.FLGEST <> OLD.FLGEST) THEN
       IF (OLD.FLGEST = 'C') THEN
          RAISE EXCEPTION 'PG-20029 Uma venda cancelada nao pode ser modificada. %' , vComplemento;
       --ELSIF (NEW.FLGEST = 'C') AND TGR_Tem_Cheque_Pendente(NEW.codfil, NEW.sequen) THEN
       --   RAISE EXCEPTION 'PG-20030 Ha cheques pendentes relacionados a esta venda. %' , vComplemento;
       END IF;
    END IF;
*/

    IF (NEW.SEQFAT IS NOT NULL) AND (COALESCE(NEW.NROIMP,0) < COALESCE(OLD.NROIMP,0)) THEN
       RAISE EXCEPTION 'PG-20032 Numero de impressao nao pode ser retroativo. %' , vComplemento;
    END IF;
  END IF;

  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN
     IF NEW.SEQUEN IS NULL THEN
        NEW.SEQUEN := ProximoCodigo('TT_VEN',NEW.CODFIL);
     END IF;

     IF (NEW.CODGUI = '      ') THEN
        NEW.CODGUI := null;
     ELSE
        NEW.CODGUI := lpad(TO_CHAR(to_number(NEW.CODGUI)+1-1),6,' ');
     END IF;
     
     NEW.DATINC  := agora();
  END IF;

  -- Evitar lancamentos fora do perodo de validade
  IF not (TG_OP = 'DELETE') THEN
     IF not (Livre(NEW.CODFIL,'TT_VEN',NEW.DATHOR) = 1) THEN
        RAISE EXCEPTION 'PG-20039 Lancamento fora do periodo de validade de uso do sistema. %' , vComplemento;
     END IF;
  END IF;

  -- "update cascade"
  IF (TG_OP = 'UPDATE') THEN
     IF (NEW.FLGEST = 'C') AND (NEW.FLGEST <> OLD.FLGEST) THEN

        SELECT COUNT(*) INTO wk_DiaFechado FROM DUAL
          WHERE EXISTS (SELECT DIAFEC
                          FROM TR_ECF
                         WHERE CODFIL = NEW.CODFIL
                           AND NUMECF = NEW.NUMECF
                           AND DATOPE = TRUNC(NEW.DATHOR)
                           AND CNT_RO = NEW.CNT_RO
                           AND DIAFEC in ('S','F'));

        IF wk_DiaFechado > 0 THEN
          select * into QuemLogou from DadosLogon();
           SELECT COUNT(*) INTO wk_DiaFechado
             FROM TT_USU
            WHERE SUBSTR(PERMISSOESUSUARIO(FILUSU,CODUSU),149,1)='S'
              AND FILUSU=QuemLogou.FILUSU
              and CODUSU=QuemLogou.CODUSU;
           IF wk_DiaFechado = 0 THEN
              RAISE EXCEPTION 'PG-20044 Usurio sem permisso para cancelar vendas de dias j fechados. %' , vComplemento;
           END IF;
        END IF;

        -- Estornar parcelas ligadas a devoluo de mercadorias
        
       
          cDUMMY := PC_VEN_DEVOLUCAO(NEW.CODFIL, NEW.SEQUEN);
       
        -- Cancela recebimentos
        UPDATE TT_REC
           SET FLGEST = 'C',DUMMY = vVEM_DE_TGVEN
         WHERE SEQUEN = NEW.SEQUEN
           AND CODFIL = NEW.CODFIL
           AND FLGEST NOT IN ('C','P','X');

        -- Estorna recebimentos
        UPDATE TT_REC SET FLGEST = 'X',DUMMY = vVEM_DE_TGVEN
         WHERE SEQUEN = NEW.SEQUEN
           AND CODFIL = NEW.CODFIL
           AND FLGEST NOT IN ('X','C');

        -- Diferena nos lanamentos de C/C
        SELECT SUM(VLRLAN)
          INTO nDifVlrlan
          FROM TT_CCC
         WHERE CODVEN = OLD.CODFIL
           AND SEQVEN = OLD.SEQUEN;

        -- RFMP 99064
        -- Ao cancelar a nota pelo Backoffice,  chamada a tela de rastreio de operaes.
        -- Nela o sistema chama a funo EstornaParcela que gera o estorno dos lanamentos de C/C.
        -- Ao cancelar a venda, sistema estava duplicando esses lanamentos de C/C.
        -- Com esse tratamento, sistema s estorna lanamentos aqui se houver alguma diferena nos valores.
        -- Teoricamente, s deve ter diferena quando o cancelamento for realizado pelo Checkout.
        IF nDifVlrlan <> 0 THEN
           -- Lanca estorno em conta corrente
           INSERT INTO TT_CCC (CODVEN, SEQVEN, CODFIL, FILCLI, CODCLI, DATOPE, NUMDOC, FILUSU, CODUSU, VLRLAN, COMPLE, TIPCCC, PLACAS, STATUS, PORORI, DATFIS,TIPLAN,
                               FILCCC, SEQCCC, TIPREL)
                      (SELECT  CODVEN, SEQVEN, CODFIL, FILCLI, CODCLI, agora(), NUMDOC, FILUSU, CODUSU, VLRLAN*-1,
                               TO_CHAR('ESTORNO REF. CANCELAMENTO VENDA'), TIPCCC, PLACAS,
                               CASE STATUS WHEN 'A' THEN 'P'
                                                    ELSE 'A'
                               END AS STATUS,
                               PORORI, DATFIS,TO_CHAR('N'),
                               FILCCC, SEQCCC, TIPREL
                         FROM TT_CCC
                        WHERE CODVEN = OLD.CODFIL
                          AND SEQVEN = OLD.SEQUEN);

           -- Altera os lanamentos abertos para pagos
           UPDATE TT_CCC
              SET STATUS='P'
            WHERE CODVEN = OLD.CODFIL
              AND SEQVEN = OLD.SEQUEN
              AND STATUS = 'A'
              AND (COMPLE IS NULL OR COMPLE<>'ESTORNO REF. CANCELAMENTO VENDA');
        END IF;

        -- Quebra o vinculo dos cheques que sao apropriados a outras vendas
        UPDATE TT_REC
           SET SEQCHE = NULL,DUMMY = vVEM_DE_TGVEN
         WHERE CODFIL = NEW.CODFIL
           AND SEQUEN = NEW.SEQUEN
           AND FLGEST NOT IN ('X','C')
           AND 0 NOT IN (SELECT COUNT(*)
                           FROM TT_REC OUT, TT_CHR CHR, TT_REC REC
                          WHERE REC.FILREC = CHR.CODFIL
                            AND REC.SEQCHE = CHR.SEQUEN
                            AND CHR.CODFIL = OUT.FILREC
                            AND CHR.SEQUEN = OUT.SEQCHE
                            AND REC.CODFIL = NEW.CODFIL
                            AND REC.SEQUEN = NEW.SEQUEN
                            AND (OUT.CODFIL != NEW.CODFIL OR
                                 OUT.SEQUEN != NEW.SEQUEN));


        -- Se o cancelamento da nota nao vier do form de cancelamento do backoffice
        IF COALESCE(NEW.DUMMY,' ') <> constante('VEM_DE_CANCELA_NF') THEN
          -- rfmp 67248
          OPEN CR_Itf(NEW.CODFIL, NEW.SEQUEN);
          LOOP FETCH CR_Itf INTO vFILTEF, vSEQTEF;
               EXIT WHEN NOT FOUND;
            -- Cancela parcela do cartao
            UPDATE TT_ITF
               SET FLGEST = 'C'
             WHERE CODFIL = vFILTEF
               AND SEQUEN = vSEQTEF
               AND FLGEST <> 'C';
          END LOOP;
          CLOSE CR_Itf;

          -- Cancela cheques
          UPDATE TT_CHR
             SET FLGEST = 'X',
                 DUMMY = vVEM_DE_TGVEN
           WHERE FLGEST IN ('A','S','V')
             AND (CODFIL,SEQUEN) IN (SELECT DISTINCT FILREC,SEQCHE
                                       FROM TT_REC REC
                                      WHERE REC.CODFIL = NEW.CODFIL
                                        AND REC.SEQUEN = NEW.SEQUEN
                                        AND REC.SEQCHE IS NOT NULL);
        END IF;

        -- Estornar faturamento de conta corrente
        wk_TipoCCC := TGR_Tem_Faturamento_CC(NEW.CODFIL, NEW.SEQUEN, NEW.CODSER);
        IF wk_TipoCCC is not null THEN
           OPEN FaturaCC(NEW.CODFIL, NEW.SEQUEN);
           LOOP
               FETCH FaturaCC INTO vFILCLI,vCODCLI,vSALDO;
               EXIT WHEN NOT FOUND;
               INSERT INTO TT_CCC (CODFIL, FILCLI, CODCLI,
                                   DATOPE, NUMDOC, FILUSU,
                                   CODUSU, VLRLAN, TIPCCC,
                                   STATUS,TIPLAN)
                           VALUES (NEW.CODFIL, vFILCLI, vCODCLI,
                                   agora(), NEW.CODSER||NEW.NUMNOT, NEW.FILUSU,
                                   NEW.CODUSU, vSALDO, wk_TipoCCC,
                                   'F','Q');

          END LOOP;
          CLOSE FaturaCC;
          UPDATE TT_CCC
             SET STATUS = 'A', FILFAT = NULL, SEQFAT = NULL
           WHERE FILFAT = NEW.CODFIL
             AND SEQFAT = NEW.SEQUEN;

        END IF;
        -- Estornar e cancelar compromisso de fundo rural - RFMP 62085 10/05/2008
        IF OLD.FUNRUR <> 0 THEN
          -- Nao permite cancelar nota com compromisso de fundo rural pago
          vPERCAN := SUBSTR(PermiteCancelamento(OLD.CODFIL, OLD.NUMECF, OLD.CODSER, OLD.NUMNOT), 1, 250);
          IF INSTR(UPPER(vPERCAN), 'FUNDO RURAL') > 0 THEN
            RAISE EXCEPTION 'PG-20044 % %' , vPERCAN,vComplemento;
          END IF;
          -- Cancela compromisso
          UPDATE TT_COM
             SET FLGEST = 'D'
           WHERE CODFIL = OLD.CODFIL
             AND CODSER = OLD.CODSER
             AND SUBSTR(NUMNOT,4,6) = OLD.NUMNOT
             AND FILFOR = OLD.FILCLI
             AND CODFOR = OLD.CODCLI;
        END IF;

        -- cancela comisses relacionadas a esta venda
        UPDATE TT_CMS
           SET FLGEST = 'C'
         WHERE FILREC = NEW.CODFIL
           AND SEQREC = NEW.SEQUEN
           AND FLGEST NOT IN ('C','P');

        -- RFMP 73534
        -- para cada comisso paga, criar uma com valor inverso (estorno)
        OPEN CR_Cms(NEW.CODFIL, NEW.SEQUEN);
        LOOP
          FETCH CR_Cms INTO regTT_Cms;
          EXIT WHEN NOT FOUND;
          INSERT INTO TT_CMS (CODFIL,FILREC,
                              SEQREC,NUMPAR,
                              SUBPAR,DATPGT,
                              FILCLI,CODCLI,
                              BASCMS,VLRCMS,
                              PERCMS,COMSOB,
                              FLGEST,NROCAN,
                              TIPCMS)
                      VALUES (regTT_Cms.CODFIL,regTT_Cms.FILREC,
                              regTT_Cms.SEQREC,regTT_Cms.NUMPAR,
                              regTT_Cms.SUBPAR,regTT_Cms.DATPGT,
                              regTT_Cms.FILCLI,regTT_Cms.CODCLI,
                              regTT_Cms.BASCMS,regTT_Cms.VLRCMS*-1,
                              regTT_Cms.PERCMS,regTT_Cms.COMSOB,
                              'A',regTT_Cms.NROCAN,
                              regTT_Cms.TIPCMS);
        END LOOP;
        CLOSE CR_Cms;

        -- Rhuan - 102007 - Estornar bnus vinculado  venda
        -- Faz um contra-lanamento para cada registro vinculado.
        INSERT INTO TT_BON (CODFIL, FILUSU, CODUSU, FILCLI, CODCLI,
                            DATOPE, VLRLAN, FILVEN, SEQVEN, TIPBON,
                            HISTOR)
                    (SELECT CODFIL, FILUSU, CODUSU, FILCLI, CODCLI,
                            DATOPE, VLRLAN*-1, FILVEN, SEQVEN, TIPBON,
                            HISTOR
                       FROM TT_BON
                      WHERE FILVEN = NEW.CODFIL
                        AND SEQVEN = NEW.SEQUEN);
     END IF;

     -- Usado pelo Checkout
     IF (NEW.FLGEST in ('?','Y')) AND (NEW.FLGEST <> OLD.FLGEST) THEN
                   SELECT SUM(CASE REC.FLGEST WHEN 'A' THEN 1 ELSE 0 END),
                  CASE WHEN SUM(CASE WHEN REC.FLGEST='A' AND REC.CARTAO IS NULL AND REC.SEQCHE IS NULL THEN 1 ELSE 0 END)>0 THEN 'F'
                       WHEN SUM(CASE WHEN REC.DATFIS<>NEW.datfis THEN 1 ELSE 0 END)>0 THEN 'F'
                       WHEN SUM(CASE WHEN CHR.DATFIS<>CHR.DATVEN THEN 1 ELSE 0 END)>0 THEN 'F' -- RFMP 66883
                  ELSE 'T'
                  END,
                  count(*) INTO linha, NEW.AVISTA, qtd_rec
             FROM TT_REC REC LEFT JOIN TT_CHR CHR ON CHR.CODFIL = REC.CODFIL
                                                 AND CHR.SEQUEN = REC.SEQCHE
            WHERE REC.CODFIL = NEW.CODFIL
              AND REC.SEQUEN = NEW.SEQUEN;
        
        IF OLD.FLGEST = 'C' THEN
           NEW.FLGEST := 'C';
        ELSIF (linha > 0) THEN
           NEW.FLGEST := 'A';
        ELSE
           NEW.FLGEST := 'Q';
        END IF;

        IF coalesce(NEW.DUMMY,'XX')<>CONSTANTE('VEM_DE_TGRTB') THEN      --56100
           cDUMMY:=PROCESSATITULOS(NEW.FILPGT, NEW.CODPGT);
        END IF;

        -- RFMP 59271 Gerar compromisso de fundo rural
        IF (qtd_rec > 0) AND (NEW.FUNRUR <> 0) AND (OLD.FLGEST <> 'C') THEN

          -- buscar conta
          SELECT FILCTA, SEQCTA, TIPCTA
            INTO vFILCTA, vSEQCTA, vTIPCTA
            FROM TD_CTA
           WHERE CFGCOL = 'TIPCTA_MER_REV';

          -- buscar codcfo
          SELECT CODTAB
            INTO vCODCFO
            FROM TD_CFO
           WHERE CODCFO = SUBSTR((SELECT CASE WHEN COALESCE(NEW.UFLOJA,'T') = 'T'
                                                        THEN NATDEN
                                                        ELSE NATFOR
                                                   END
                                              FROM TD_NAT
                                             WHERE CODTAB = COALESCE(NEW.CODNAT,0)),1,4);

          -- buscar uf
          SELECT SIGEST
            INTO vUFLOJA
            FROM TT_END
           WHERE FILCLI = NEW.FILCLI
             AND CODCLI = NEW.CODCLI
             AND CODFIL = NEW.FILFAT
             AND NUMEND = NEW.ENDFAT;

          -- novo sequen da tt_com
          vSEQCOM := ProximoCodigo('TT_COM', NEW.CODFIL);

          -- inserir na tt_com
          INSERT INTO TT_COM (
            CODFIL, SEQUEN, FILFOR, CODFOR, TIPPAR, CODSER,
            NUMNOT, DATOPE, FLGEST, DATCMP, QTDTOT,
            VLRTOT, NOTESP, OUTTAX, DESCON, VLRLIQ,
            FILUSU, CODUSU, CODMOE, INCOJU, INTPJU,
            INTPMU, CODCFO, MOEJUR, TIPNOT, CODSET,
            FILCTA, SEQCTA, TIPCTA, UFNOTA, RETIRR,
            RETCSS, SIGNAT
          )
          VALUES (
            NEW.CODFIL, vSEQCOM, NEW.FILCLI, NEW.CODCLI, NULL, NEW.CODSER,
            LPAD(NEW.NUMNOT, 9, ' '), TRUNC(AGORA()), 'A', TRUNC(AGORA()), qtd_rec,
            NEW.VLRNOT*-1, 'F', 0, NEW.DESCON*-1, NEW.VLRLIQ*-1,
            NEW.FILUSU, NEW.CODUSU, 0, 'D', 'S',
            '%', vCODCFO, 0, 'A', 0,
            vFILCTA, vSEQCTA, vTIPCTA, vUFLOJA, 'F',
            'F', 0
          );

          -- para cada rec criar uma pag
          OPEN CR_Rec(NEW.CODFIL, NEW.SEQUEN);
          LOOP
            FETCH CR_Rec INTO regTT_Rec;
            EXIT WHEN NOT FOUND;
            INSERT INTO TT_PAG (
              CODFIL, SEQUEN, NUMPAR,
              SUBPAR, FLGEST, DATVEN,
              VLRPAR, FILUSU, CODUSU
            )
            VALUES (
              regTT_Rec.CODFIL, vSEQCOM, regTT_Rec.NUMPAR,
              regTT_Rec.SUBPAR, 'A', regTT_Rec.DATVEN,
              regTT_Rec.VLRPAR*-1, regTT_Rec.FILUSU, regTT_Rec.CODUSU
            );
          END LOOP;
          CLOSE CR_Rec;

          -- cancelar recs
          UPDATE TT_REC
             SET FLGEST = 'C',
                 DUMMY  = vVEM_DE_TGVEN
           WHERE CODFIL = NEW.CODFIL
             AND SEQUEN = NEW.SEQUEN;

          -- quita venda
          NEW.FLGEST := 'Q';

        END IF;

     END IF;


     -- Ainda dentro do IF (TG_OP = 'UPDATE')
     -- RFMP 96851
     -- Chamado pela TGIVE2 atravs do UPDATE na coluna ATU_EM.
     IF COALESCE(NEW.DUMMY,' ') <> Constante('VEM_DE_TGIVE') THEN
        --74356
        SELECT TIPNAT into cTIPNAT
          FROM TD_NAT
         WHERE CODTAB = NEW.CODNAT;
        IF cTIPNAT = 'D' THEN
           IF NEW.VLRLIQ < 0 THEN
                           
                 cDUMMY := PC_VEN_DEVOLUCAO_CMS(NEW.CODFIL, NEW.SEQUEN);
                         END IF;
        END IF;
     END IF;
  END IF;

  IF (TG_OP = 'INSERT') THEN
     SELECT FILVEN, CODVEN
       INTO WK_FILVEN, WK_CODVEN
       FROM TT_CLI
      WHERE FILCLI = NEW.FILCLI
        AND CODCLI = NEW.CODCLI;
     IF (isnull(WK_FILVEN)='F') THEN
      NEW.FILVDP := WK_FILVEN;
      NEW.CODVDP := WK_CODVEN;
     END IF;
  END IF;
    -- "Default"
  IF NOT (TG_OP = 'DELETE') THEN
    IF (TG_OP = 'INSERT') THEN
       NEW.ATU_EM := agora();
       IF NEW.DATFIS IS NULL THEN
         NEW.DATFIS := TRUNC(NEW.DATHOR); -- PTulio - davi - 27/04/05 - 33733
       END IF;
    END IF;
    IF (TG_OP = 'UPDATE') THEN
      IF (COALESCE(NEW.DUMMY, 'X') <> '%') THEN
        IF (NEW.ATU_EM = OLD.ATU_EM) THEN
           NEW.ATU_EM := agora();
        END IF;
      END IF;
    END IF;
    IF coalesce(NEW.DUMMY,'XX')<>CONSTANTE('VEM_DE_PCREC') and
       coalesce(NEW.DUMMY,'XX')<>CONSTANTE('VEM_DE_PCRECCAS') THEN
                                
             cDUMMY := PC_REC_CASCADE_DATA(new.CODFIL,new.SEQUEN,NULL,NULL,new.ATU_EM,NULL);
                        END IF;

    -- Rhuan - 98019 - Controle se altera ou no o EXPORT ao alterar alguns campos
    bAltera_EXPORT := TemFun('VEN_EXPORT') = 'F';

    IF (TG_OP = 'INSERT') THEN
      NEW.EXPORT := 'F';
    ELSIF  (Equal(NEW.CODFIL,OLD.CODFIL) = 0 OR
            Equal(NEW.CODSER,OLD.CODSER) = 0 OR
            Equal(NEW.NUMNOT,OLD.NUMNOT) = 0 OR
            Equal(NEW.FILCLI,OLD.FILCLI) = 0 OR
            Equal(NEW.CODCLI,OLD.CODCLI) = 0 OR
            Equal(NEW.FLGEST,OLD.FLGEST) = 0 OR
            Equal(NEW.FILUSU,OLD.FILUSU) = 0 OR
            Equal(NEW.CODUSU,OLD.CODUSU) = 0 OR
            Equal(NEW.FILVEN,OLD.FILVEN) = 0 OR --rodrigo 58200
            Equal(NEW.CODVEN,OLD.CODVEN) = 0 OR --rodrigo 58200
            Equal(NEW.FILPGT,OLD.FILPGT) = 0 OR
            Equal(NEW.CODPGT,OLD.CODPGT) = 0 OR
            Equal(NEW.VLRNOT,OLD.VLRNOT) = 0 OR
            Equal(NEW.VLRLIQ,OLD.VLRLIQ) = 0 OR
            Equal(NEW.PERCOM,OLD.PERCOM) = 0 OR
            Equal(NEW.PERENT,OLD.PERENT) = 0 OR
            Equal(NEW.COMSOB,OLD.COMSOB) = 0 OR
            Equal(NEW.CODNAT,OLD.CODNAT) = 0 OR
            Equal(NEW.PRAMED,OLD.PRAMED) = 0 OR
            Equal(NEW.ESPECI,OLD.ESPECI) = 0 OR
--            Equal(NEW.OBSERV,OLD.OBSERV) = 0 OR
--            Equal(NEW.NROIMP,OLD.NROIMP) = 0 OR
            Equal(NEW.AUTENT,OLD.AUTENT) = 0 OR
            Equal(NEW.DESCON,OLD.DESCON) = 0 OR
            Equal(NEW.FILGUI,OLD.FILGUI) = 0 OR
            Equal(NEW.CODGUI,OLD.CODGUI) = 0 OR
            Equal(NEW.DATSAI,OLD.DATSAI) = 0 OR
            Equal(NEW.NUMVOL,OLD.NUMVOL) = 0 OR
            Equal(NEW.MARCAS,OLD.MARCAS) = 0 OR
            Equal(NEW.VLRSEG,OLD.VLRSEG) = 0 OR
            Equal(NEW.VLRFRE,OLD.VLRFRE) = 0 OR
            Equal(NEW.PESBRU,OLD.PESBRU) = 0 OR
            Equal(NEW.PESLIQ,OLD.PESLIQ) = 0 OR
            Equal(NEW.NUMCON,OLD.NUMCON) = 0 OR
            Equal(NEW.CODPRE,OLD.CODPRE) = 0 OR
            Equal(NEW.SINAL ,OLD.SINAL ) = 0 OR
            Equal(NEW.FINANC,OLD.FINANC) = 0 OR
            Equal(NEW.TRIBUT,OLD.TRIBUT) = 0 OR
            Equal(NEW.SEQFAT,OLD.SEQFAT) = 0 OR
            Equal(NEW.FILPRE,OLD.FILPRE) = 0 OR
            Equal(NEW.PROPGT,OLD.PROPGT) = 0 OR
            Equal(NEW.EMIDES,OLD.EMIDES) = 0 OR
            Equal(NEW.SEQUEN,OLD.SEQUEN) = 0 OR
            Equal(NEW.FILTRA,OLD.FILTRA) = 0 OR
            Equal(NEW.CODTRA,OLD.CODTRA) = 0 OR
            Equal(NEW.TIPNOT,OLD.TIPNOT) = 0 OR
            Equal(NEW.TIPTRA,OLD.TIPTRA) = 0 OR
            Equal(NEW.FILFAT,OLD.FILFAT) = 0 OR
            Equal(NEW.ENDFAT,OLD.ENDFAT) = 0 OR
            Equal(NEW.FILENT,OLD.FILENT) = 0 OR
            Equal(NEW.ENDENT,OLD.ENDENT) = 0 OR
            Equal(NEW.FILCOB,OLD.FILCOB) = 0 OR
            Equal(NEW.ENDCOB,OLD.ENDCOB) = 0 OR
            Equal(NEW.CODFIN,OLD.CODFIN) = 0 OR
            Equal(NEW.BASUBS,OLD.BASUBS) = 0 OR
            Equal(NEW.SUBSTT,OLD.SUBSTT) = 0 OR
            Equal(NEW.RETIDO,OLD.RETIDO) = 0 OR
            Equal(NEW.CONSFI,OLD.CONSFI) = 0 OR
            Equal(NEW.VINCUL,OLD.VINCUL) = 0 OR
            Equal(NEW.UFLOJA,OLD.UFLOJA) = 0 OR
            Equal(NEW.FLGTIP,OLD.FLGTIP) = 0 OR
            Equal(NEW.LANVEN,OLD.LANVEN) = 0 OR
            Equal(NEW.CODEXT,OLD.CODEXT) = 0 OR
            Equal(NEW.CODCTR,OLD.CODCTR) = 0 OR
            -- Dados do Documento Eletrnico
            Equal(NEW.FLGNFE,OLD.FLGNFE) = 0 OR
            Equal(NEW.CHAVEA,OLD.CHAVEA) = 0 OR
            Equal(NEW.PROAUT,OLD.PROAUT) = 0 OR
            Equal(NEW.DATAUT,OLD.DATAUT) = 0 OR
            Equal(NEW.PROCAN,OLD.PROCAN) = 0 OR
            Equal(NEW.DATCAN,OLD.DATCAN) = 0 OR
            Equal(NEW.NUMNFS,OLD.NUMNFS) = 0 OR
            Equal(NEW.CHVCAN,OLD.CHVCAN) = 0 OR
            Equal(NEW.SATCAN,OLD.SATCAN) = 0 OR
            Equal(NEW.SATCFE,OLD.SATCFE) = 0 OR
            Equal(NEW.SATSER,OLD.SATSER) = 0 OR
            Equal(NEW.MODNOT,OLD.MODNOT) = 0 OR
            Equal(NEW.MOTCAN,OLD.MOTCAN) = 0 OR
            Equal(NEW.FINNFE,OLD.FINNFE) = 0 OR
            Equal(NEW.VERNFE,OLD.VERNFE) = 0 OR
            Equal(NEW.SEREXT,OLD.SEREXT) = 0
            -- Dados do Documento Eletrnico
            ) AND bAltera_EXPORT THEN
      NEW.EXPORT := 'F';
    END IF;

    IF (TG_OP = 'UPDATE') THEN
      IF (NEW.FLGEST = 'C') and (OLD.FLGEST <> NEW.FLGEST) THEN
        NEW.EXPORT := 'F';
        NEW.EXPFIS := 'F';
      END IF;
    END IF;


  -- DN 45679 - Tabelas Financeiras
  IF (TG_OP = 'INSERT') THEN
     cDUMMY:=INSERE_LFIN_CLI('REC',NEW.CODFIL,NEW.SEQUEN,NEW.FILCLI,NEW.CODCLI);
  END IF;
  IF (TG_OP = 'UPDATE') THEN
     IF Equal(OLD.FILCLI,NEW.FILCLI) <> 1 OR
        Equal(OLD.CODCLI,NEW.CODCLI) <> 1 THEN
        cDUMMY:=INSERE_LFIN_CLI('REC',NEW.CODFIL,NEW.SEQUEN,NEW.FILCLI,NEW.CODCLI);
     END IF;
     -- RFMP 93469
     -- Tratamento para gerar os lanamentos financeiros ao cancelar a venda.
     IF (NEW.FLGEST = 'C') AND (NEW.FLGEST <> OLD.FLGEST) THEN
        cDUMMY:=INSERE_LFIN_LAN('REC',NEW.CODFIL,NEW.SEQUEN,
                                Constante('NUMPAR_FIN_VENDAS_CANCELADAS'),
                                Constante('SUBPAR_FIN_VENDAS_CANCELADAS'));
     END IF;
  END IF;
  -- DN 45679 - Fim Tabelas Financeiras

  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
    IF NEW.CHAVEA IS NULL OR LENGTH(NEW.CHAVEA) < 44 OR LENGTH(NEW.CHAVEA) IS NULL THEN
      NEW.CHAVEA := NULL;
    END IF;
  END IF;

  -- Pedro E. Braga - 97872 - Verifica se nota de transferncia e atualiza chave na nota de entrada.
  IF (TG_OP = 'UPDATE') THEN
    IF (Equal(OLD.CHAVEA,NEW.CHAVEA) <> 1) THEN
      UPDATE TT_COM COM SET CHAVEA = NEW.CHAVEA
       WHERE COM.FLGEST <> 'D'
         AND (COM.CODFIL, COM.SEQUEN) IN (SELECT DISTINCT TRA.FILICO, TRA.SEQICO
                                            FROM TT_TRA TRA
                                           WHERE TRA.FILIVE = NEW.CODFIL
                                             AND TRA.SEQIVE = NEW.SEQUEN);
    END IF;
  END IF;
  
  -- Rhuan - Ticket 2020065410 - Ao cancelar a sada da Transferncia cancela tambm a entrada, caso j tenha sido realizada.
  IF (TG_OP = 'UPDATE') THEN
      IF (OLD.FLGEST <> NEW.FLGEST) AND (NEW.FLGEST = 'C') AND (NEW.CODCLI = '     0') THEN
         UPDATE TT_COM COM 
            SET FLGEST = 'D'
          WHERE COM.FLGEST <> 'D'
            AND (COM.CODFIL, COM.SEQUEN) IN (SELECT DISTINCT TRA.FILICO, TRA.SEQICO
                                               FROM TT_TRA TRA
                                              WHERE TRA.FILIVE = NEW.CODFIL
                                                AND TRA.SEQIVE = NEW.SEQUEN);
         
         
         -- Exclui as transferencias pendentes
         -- Em Oracle esse DELETE  executado pela trigger da TT_IVE.
         delete from tt_tra
          where filive=NEW.codfil
            and seqive=NEW.sequen
            and seqico is null;
                  
      END IF;
  END IF;  

  -- Fernando - 73487 - Incio
  IF (TG_OP = 'UPDATE') THEN
     --74356
     SELECT TIPNAT into cTIPNAT
       FROM TD_NAT
      WHERE CODTAB = NEW.CODNAT;
     IF cTIPNAT <> 'D' THEN
        IF NEW.VLRLIQ > 0 THEN

           -- Insere na TT_VDD se for informado um vendedor principal
           IF (OLD.FILVDP IS NULL) AND (OLD.CODVDP IS NULL) AND (NEW.FILVDP IS NOT NULL) AND (NEW.CODVDP IS NOT NULL) THEN
              SELECT MULT_VENDEDORES
                INTO wk_MultVendedores
                FROM TT_CFG;

           IF wk_MultVendedores = 'T' THEN
                 -- S inserir o vendedor principal na TT_VDD se usa mltiplos vendedores
                 INSERT INTO TT_VDD (CODFIL, FILVEN, SEQVEN, FILVDD, CODVDD, TIPVDD)
                       VALUES (NEW.CODFIL, NEW.CODFIL, NEW.SEQUEN, NEW.FILVDP, NEW.CODVDP, 'P');
              END IF;
           END IF;
           -- Exclui da TT_VDD se foi removido a informao do vendedor principal
           IF (OLD.FILVDP IS NOT NULL) AND (OLD.CODVDP IS NOT NULL) AND (NEW.FILVDP IS NULL) AND (NEW.CODVDP IS NULL) THEN
              DELETE FROM TT_VDD WHERE FILVEN = NEW.CODFIL AND SEQVEN = NEW.SEQUEN AND TIPVDD = 'P';
           END IF;
           -- Atualiza informaes do Vendedor
           IF (OLD.FILVEN <> NEW.FILVEN) OR (OLD.CODVEN <> NEW.CODVEN) THEN
              UPDATE TT_VDD
                 SET FILVDD = NEW.FILVEN,
                     CODVDD = NEW.CODVEN
               WHERE FILVEN = NEW.CODFIL
                 AND SEQVEN = NEW.SEQUEN
                 AND TIPVDD = 'V';
           END IF;
           -- Atualiza informaes do vendedor principal
           IF (NEW.FILVDP IS NOT NULL) AND (NEW.CODVDP IS NOT NULL) AND ((OLD.FILVDP <> NEW.FILVDP) OR (OLD.CODVDP <> NEW.CODVDP)) THEN
              UPDATE TT_VDD
                 SET FILVDD = NEW.FILVDP,
                     CODVDD = NEW.CODVDP
               WHERE FILVEN = NEW.CODFIL
                 AND SEQVEN = NEW.SEQUEN
                 AND TIPVDD = 'P';
           END IF;
        END IF;
     END IF;
  END IF;
  -- Fernando - 73487 - Fim

    IF (TG_OP = 'INSERT') or (TG_OP = 'UPDATE') THEN
       NEW.DUMMY:=NULL;
    END IF;
  -- Paulo : 76217
  IF (TG_OP = 'INSERT') THEN
    SELECT MODNOT INTO WK_MODNOT
      FROM TD_SER
     WHERE CODSER = NEW.CODSER;
    IF (NEW.FLGNFE IS NULL) AND (COALESCE(WK_MODNOT, '0') IN ('55','65','59')) THEN
       NEW.FLGNFE := '0';
    END IF;
  END IF;

  END IF;

  -- Pedro E. Braga: 92163 / 92188 - Tratamento para Bnus por Valor Acumulado de Venda.
   -- Verifica se Trabalha com Multiplos Vendedores
   SELECT MULT_VENDEDORES
     INTO wk_MultVendedores
     FROM TT_CFG;

  IF (TG_OP = 'INSERT') THEN
    cSituacao := 'INS';
    -- Pedro E. Braga: 92163 / 92188 - Tratamento para Bnus por Valor Acumulado de Venda.
    --Bnus Acululado para Cliente/Parceiro
    cResult := TGR_VEN_Acumula_Bonus(cSituacao , NEW.FILCLI, NULL, NEW.CODCLI, NULL, 'X',
                                                   NEW.LANVEN, NULL, NEW.FINANC, NULL, NEW.FLGEST, NULL,
                                                   NEW.VLRNOT, NULL, NEW.DATFIS, NULL, NEW.CODFIL, NULL,
                                                   NEW.FILUSU, NULL, NEW.CODUSU, NULL );

    --Bnus Acululado para Vendedor
    IF (wk_MultVendedores = 'F') THEN
        --Captura Parceiro Vinculado ao Vendedor
        SELECT FILCLI, CODCLI
          INTO vFILCLI, vCODCLI
          FROM TT_USU
         WHERE FILUSU = NEW.FILVEN
           AND CODUSU = NEW.CODVEN;
        cResult := TGR_VEN_Acumula_Bonus(cSituacao , vFILCLI    , NULL, vCODCLI    , NULL, 'V',
                                                       NEW.LANVEN, NULL, NEW.FINANC, NULL, NEW.FLGEST, NULL,
                                                       NEW.VLRNOT, NULL, NEW.DATFIS, NULL, NEW.CODFIL, NULL,
                                                       NEW.FILUSU, NULL, NEW.CODUSU, NULL );
    END IF;

    --Bnus Acululado para Indicador
    IF ((NEW.FILGUI IS NOT NULL) AND (NEW.CODGUI IS NOT NULL)) THEN
        cResult := TGR_VEN_Acumula_Bonus(cSituacao  , NEW.FILGUI, NULL, NEW.CODGUI, NULL, 'I',
                                                       NEW.LANVEN, NULL, NEW.FINANC, NULL, NEW.FLGEST, NULL,
                                                       NEW.VLRNOT, NULL, NEW.DATFIS, NULL, NEW.CODFIL, NULL,
                                                       NEW.FILUSU, NULL, NEW.CODUSU, NULL );
    END IF;

  ELSE
    IF (TG_OP = 'UPDATE') THEN
        cSituacao := 'UPD';
        --Bnus Acululado para Cliente/Parceiro
        cResult := TGR_VEN_Acumula_Bonus(cSituacao , NEW.FILCLI, OLD.FILCLI, NEW.CODCLI, OLD.CODCLI, 'X',
                                                       NEW.LANVEN, OLD.LANVEN, NEW.FINANC, OLD.FINANC, NEW.FLGEST, OLD.FLGEST,
                                                       NEW.VLRNOT, OLD.VLRNOT, NEW.DATFIS, OLD.DATFIS, NEW.CODFIL, OLD.CODFIL,
                                                       NEW.FILUSU, OLD.FILUSU, NEW.CODUSU, OLD.CODUSU );

        --Bnus Acululado para Vendedor
        IF (wk_MultVendedores = 'F') THEN
            --Captura Parceiro Vinculado ao Vendedor
            SELECT FILCLI, CODCLI
              INTO vFILCLI, vCODCLI
              FROM TT_USU
             WHERE FILUSU = NEW.FILVEN
               AND CODUSU = NEW.CODVEN;
            SELECT FILCLI, CODCLI
              INTO vFILCLIOld, vCODCLIOld
              FROM TT_USU
             WHERE FILUSU = OLD.FILVEN
               AND CODUSU = OLD.CODVEN;
            cResult := TGR_VEN_Acumula_Bonus(cSituacao , vFILCLI    , vFILCLIOld , vCODCLI    , vCODCLIOld , 'V',
                                                           NEW.LANVEN, OLD.LANVEN, NEW.FINANC, OLD.FINANC, NEW.FLGEST, OLD.FLGEST,
                                                           NEW.VLRNOT, OLD.VLRNOT, NEW.DATFIS, OLD.DATFIS, NEW.CODFIL, OLD.CODFIL,
                                                           NEW.FILUSU, OLD.FILUSU, NEW.CODUSU, OLD.CODUSU );
        ELSE  IF ((cFLGESTNew IN ('?','Y')) AND (cFLGESTNew <> NEW.FLGEST)) OR
                 ((NEW.FLGEST <> OLD.FLGEST) AND NOT(cFLGESTNew IN ('?','Y'))) THEN -- Usado pelo Checkout
             -- Carregar Quantidade de Vendedores da Venda
             SELECT COALESCE(COUNT(*),0)
               INTO nQtdVendedores
               FROM TV_VDD
              WHERE CODFIL = NEW.CODFIL AND SEQUEN = NEW.SEQUEN;

             OPEN CR_MultiplosVendedores(NEW.CODFIL, NEW.SEQUEN);
              LOOP
                FETCH CR_MultiplosVendedores INTO regTV_VDD;
                EXIT WHEN NOT FOUND;
                --Captura Parceiro Vinculado ao Vendedor
                SELECT FILCLI, CODCLI
                  INTO vFILCLI, vCODCLI
                  FROM TT_USU
                 WHERE FILUSU = regTV_VDD.FILVEN
                   AND CODUSU = regTV_VDD.CODVEN;
                 cResult := TGR_VEN_Acumula_Bonus(cSituacao , vFILCLI     , NULL, vCODCLI    , NULL, 'V',
                                                               NEW.LANVEN, NULL, NEW.FINANC, NULL, NEW.FLGEST, NULL,
                                                               NEW.VLRNOT / nQtdVendedores, NULL, NEW.DATFIS, NULL, NEW.CODFIL, NULL,
                                                               NEW.FILUSU, NULL, NEW.CODUSU, NULL );
              END LOOP;
              CLOSE CR_MultiplosVendedores;
            END IF;
        END IF;

        --Bnus Acululado para Indicador
        IF ((NEW.FILGUI IS NOT NULL) AND (NEW.CODGUI IS NOT NULL)) OR
           ((OLD.FILGUI IS NOT NULL) AND (OLD.CODGUI IS NOT NULL)) THEN
            cResult := TGR_VEN_Acumula_Bonus(cSituacao , NEW.FILGUI, OLD.FILGUI, NEW.CODGUI, OLD.CODGUI, 'I',
                                                           NEW.LANVEN, OLD.LANVEN, NEW.FINANC, OLD.FINANC, NEW.FLGEST, OLD.FLGEST,
                                                           NEW.VLRNOT, OLD.VLRNOT, NEW.DATFIS, OLD.DATFIS, NEW.CODFIL, OLD.CODFIL,
                                                           NEW.FILUSU, OLD.FILUSU, NEW.CODUSU, OLD.CODUSU );
        END IF;

    ELSE
        IF (TG_OP = 'DELETE') THEN
            cSituacao := 'DEL';
            --Bnus Acululado para Cliente/Parceiro
            cResult := TGR_VEN_Acumula_Bonus(cSituacao , NULL, OLD.FILCLI, NULL, OLD.CODCLI, 'X',
                                                           NULL, OLD.LANVEN, NULL, OLD.FINANC, NULL, OLD.FLGEST,
                                                           NULL, OLD.VLRNOT, NULL, OLD.DATFIS, NULL, OLD.CODFIL,
                                                           NULL, OLD.FILUSU, NULL, OLD.CODUSU );

            --Bnus Acululado para Vendedor
            IF (wk_MultVendedores = 'F') THEN
                SELECT FILCLI, CODCLI
                  INTO vFILCLIOld, vCODCLIOld
                  FROM TT_USU
                 WHERE FILUSU = OLD.FILVEN
                   AND CODUSU = OLD.CODVEN;
                cResult := TGR_VEN_Acumula_Bonus(cSituacao , NULL, vFILCLIOld , NULL, vCODCLIOld , 'V',
                                                               NULL, OLD.LANVEN, NULL, OLD.FINANC, NULL, OLD.FLGEST,
                                                               NULL, OLD.VLRNOT, NULL, OLD.DATFIS, NULL, OLD.CODFIL,
                                                               NULL, OLD.FILUSU, NULL, OLD.CODUSU );
            END IF;

            --Bnus Acululado para Indicador
            IF ((OLD.FILGUI IS NOT NULL) AND (OLD.CODGUI IS NOT NULL)) THEN
                cResult := TGR_VEN_Acumula_Bonus(cSituacao , NULL, OLD.FILGUI, NULL, OLD.CODGUI, 'I',
                                                               NULL, OLD.LANVEN, NULL, OLD.FINANC, NULL, OLD.FLGEST,
                                                               NULL, OLD.VLRNOT, NULL, OLD.DATFIS, NULL, OLD.CODFIL,
                                                               NULL, OLD.FILUSU, NULL, OLD.CODUSU );
            END IF;

        END IF;
    END IF;
  END IF;
  -- Pedro E. Braga: 92163 / 92188

  -- Inicializa dados para assinatura

  -- RFMP 85136
  WK_UID := GetUidAtual();

  IF (TG_OP = 'DELETE') THEN
    IF WK_UID.BLQ_SEM_UID = 'T' AND WK_UID.CODUID IS NULL THEN
      RAISE EXCEPTION 'PG-20027 No  permitido deletar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
  END IF;
  IF (TG_OP = 'INSERT') THEN
    IF WK_UID.BLQ_SEM_UID = 'T' AND WK_UID.CODUID IS NULL THEN
      RAISE EXCEPTION 'PG-20027 No  permitido inserir um registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
    END IF;
    -- Douglas - 83441
    NEW.CODUID := WK_UID.CODUID;
    NEW.ASSINA := COALESCE(AssinaTabela('TT_VEN',
                                        ConcatenaVEN(NEW.CODFIL,
                                                     NEW.NUMECF,
                                                     NEW.CODSER,
                                                     NEW.NUMNOT,
                                                     NEW.CNT_RO,
                                                     NEW.VLRLIQ,
                                                     NEW.FLGEST,
                                                     NEW.SEREXT,
                                                     NEW.MODNOT,
                                                     NEW.CHAVEA,
                                                     NEW.FILUSU,
                                                     NEW.CODUSU,
                                                     NEW.VLRNOT,
                                                     NEW.DOCNFP,
                                                     NEW.DATHOR,
                                                     NEW.NOTMAN),
                                                   null, null, null),NEW.ASSINA);
  END IF;
  IF (TG_OP = 'UPDATE') THEN
    IF ConcatenaVEN(NEW.CODFIL,NEW.NUMECF,NEW.CODSER,NEW.NUMNOT,NEW.CNT_RO,NEW.VLRLIQ,NEW.FLGEST,NEW.SEREXT,NEW.MODNOT,NEW.CHAVEA,NEW.FILUSU,NEW.CODUSU,NEW.VLRNOT,NEW.DOCNFP,NEW.DATHOR,NEW.NOTMAN) <>
       ConcatenaVEN(OLD.CODFIL,OLD.NUMECF,OLD.CODSER,OLD.NUMNOT,OLD.CNT_RO,OLD.VLRLIQ,OLD.FLGEST,OLD.SEREXT,OLD.MODNOT,OLD.CHAVEA,OLD.FILUSU,OLD.CODUSU,OLD.VLRNOT,OLD.DOCNFP,OLD.DATHOR,OLD.NOTMAN)
    THEN
      IF WK_UID.BLQ_SEM_UID = 'T' AND WK_UID.CODUID IS NULL THEN
        RAISE EXCEPTION 'PG-20027 No  permitido modificar esse registro sem uma sesso de banco de dados vlida. Sesso: %' , vSessionID;
      END IF;

      -- Douglas - 83441
     NEW.CODUID := WK_UID.CODUID;
     NEW.ASSINA := COALESCE(AssinaTabela('TT_VEN',
                                          ConcatenaVEN(NEW.CODFIL,
                                                       NEW.NUMECF,
                                                       NEW.CODSER,
                                                       NEW.NUMNOT,
                                                       NEW.CNT_RO,
                                                       NEW.VLRLIQ,
                                                       NEW.FLGEST,
                                                       NEW.SEREXT,
                                                       NEW.MODNOT,
                                                       NEW.CHAVEA,
                                                       NEW.FILUSU,
                                                       NEW.CODUSU,
                                                       NEW.VLRNOT,
                                                       NEW.DOCNFP,
                                                       NEW.DATHOR,
                                                       NEW.NOTMAN),
                                          OLD.CODUID,
                                          ConcatenaVEN(OLD.CODFIL,
                                                       OLD.NUMECF,
                                                       OLD.CODSER,
                                                       OLD.NUMNOT,
                                                       OLD.CNT_RO,
                                                       OLD.VLRLIQ,
                                                       OLD.FLGEST,
                                                       OLD.SEREXT,
                                                       OLD.MODNOT,
                                                       OLD.CHAVEA,
                                                       OLD.FILUSU,
                                                       OLD.CODUSU,
                                                       OLD.VLRNOT,
                                                       OLD.DOCNFP,
                                                       OLD.DATHOR,
                                                       OLD.NOTMAN),
                                          OLD.ASSINA),
                             NEW.ASSINA);
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5239 --*/
CREATE TRIGGER TGVEN2
BEFORE INSERT OR DELETE OR UPDATE ON TT_VEN 
FOR EACH ROW EXECUTE PROCEDURE TGVEN2();

/*-- SEQ 5240 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGVEN3() CASCADE;

/*-- SEQ 5241 --*/
CREATE OR REPLACE FUNCTION TGVEN3() RETURNS TRIGGER AS $$
DECLARE
  -- Declarao de variveis e cursores
  inRecECF                       TR_ECF%ROWTYPE;

  vComplemento                   VARCHAR(100) := constante('complemento');

  cDUMMY                         CHAR(1);
  wk_TeveFechamento              Numeric;
  vLOG                           VARCHAR(4000)     := '';
  cNulo                          CONSTANT CHAR(4)   := 'Nulo';
  iNulo                          CONSTANT Numeric(1) := 0;
  CRLF                           CONSTANT CHAR(1)   := CHR(10);
  wk_coduid                      tt_uid.coduid%type;

  vNEW_APEUSU                    tt_usu.apeusu%type;
  vOLD_APEUSU                    tt_usu.apeusu%type;

  wk_TIPSUP                      TT_SUP.TIPSUP%TYPE;

  wk_MultVendedores              TT_CFG.MULT_VENDEDORES%TYPE;
  cTIPNAT                        TD_NAT.TIPNAT%TYPE;

  QuemLogou                      TRetQuemLogou%ROWTYPE;

  cOld                           VARCHAR(255);
  cNew                           VARCHAR(255);

BEGIN
  IF (TG_OP = 'INSERT') THEN
    SELECT COUNT(*) into wk_TeveFechamento
      FROM TR_ECF
     WHERE CODFIL = NEW.CODFIL
       AND NUMECF = NEW.NUMECF
       AND DATOPE = TRUNC(NEW.DATHOR)
       AND CNT_RO = NEW.CNT_RO;

    IF wk_TeveFechamento > 0 THEN
      
      
        cDUMMY := PC_RECF_PLUS_UPDATE(NEW.CODFIL,NEW.NUMECF,null,null,null,null,null,null,null,NEW.CODSER,NEW.CNT_RO);
          END IF;

    --74356
    SELECT TIPNAT into cTIPNAT
      FROM TD_NAT
     WHERE CODTAB = NEW.CODNAT;
    IF cTIPNAT <> 'D' THEN
       IF NEW.VLRLIQ > 0 THEN

          -- Fernando - 73487 - Incio
          -- Insere na TT_VDD o Vendedor
          INSERT INTO TT_VDD (CODFIL, FILVEN, SEQVEN, FILVDD, CODVDD, TIPVDD)
                VALUES (NEW.CODFIL, NEW.CODFIL, NEW.SEQUEN, NEW.FILVEN, NEW.CODVEN, 'V');

          IF (NEW.FILVDP IS NOT NULL) THEN
             SELECT MULT_VENDEDORES
               INTO wk_MultVendedores
            FROM TT_CFG;

             IF wk_MultVendedores = 'T' THEN
                -- S inserir o vendedor principal na TT_VDD se usa mltiplos vendedores
                INSERT INTO TT_VDD (CODFIL, FILVEN, SEQVEN, FILVDD, CODVDD, TIPVDD)
                   VALUES (NEW.CODFIL, NEW.CODFIL, NEW.SEQUEN, NEW.FILVDP, NEW.CODVDP, 'P');
             END IF;
          END IF;
          -- Fernando - 73487 - Fim
       END IF;
    END IF;
  END IF;

  IF (TG_OP = 'UPDATE') THEN
     IF (OLD.FLGEST <> 'I') THEN
         -- Cancelando SAC
         IF (NEW.FLGEST='C')  and (OLD.FLGEST <> NEW.FLGEST) THEN
           select min(codtab) INTO wk_TIPSUP
             from td_cws
            where tipcws = 'A'
              and codtab > 0;

           UPDATE TT_SUP
              SET SITUAC='C',
                  TIPSUP=CASE WHEN COALESCE(TIPSUP,0) = 0 AND WK_TIPSUP IS NOT NULL THEN wk_TIPSUP ELSE TIPSUP END,
                  TIPCWS=CASE WHEN COALESCE(TIPSUP,0) = 0 AND WK_TIPSUP IS NOT NULL THEN 'A' ELSE TIPCWS END
            WHERE SITUAC='A'
              AND PERFIL='V'
              AND FILVEN=NEW.CODFIL
              AND SEQVEN=NEW.SEQUEN;
         END IF;
         IF (Equal(OLD.FILCLI,NEW.FILCLI) = 0 OR
             Equal(OLD.CODCLI,NEW.CODCLI) = 0) THEN
            -- davi - ptulio - 36089 - 02/08/05
            vLOG := vLOG||'Cliente: de '||COALESCE(OLD.FILCLI||'/'||TRIM(OLD.CODCLI),cNulo)||' para '||COALESCE(NEW.FILCLI||'/'||TRIM(NEW.CODCLI),cNulo);
         END IF;
         IF Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
            vLOG := vLOG||'Estado: de '||COALESCE(DescricaoDominio('VEN','FLGEST',OLD.FLGEST),cNulo)||' para '||COALESCE(DescricaoDominio('VEN','FLGEST',NEW.FLGEST),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.NUMECF,NEW.NUMECF) <> 1 THEN
            vLOG := vLOG||'Numero ECF: de '||COALESCE(OLD.NUMECF,cNulo)||' para '||COALESCE(NEW.NUMECF,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.CODSER,NEW.CODSER) <> 1 THEN
            vLOG := vLOG||'Serie: de '||COALESCE(OLD.CODSER,cNulo)||' para '||COALESCE(NEW.CODSER,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.NUMNOT,NEW.NUMNOT) <> 1 THEN
            vLOG := vLOG||'Numero Nota: de '||COALESCE(OLD.NUMNOT,cNulo)||' para '||COALESCE(NEW.NUMNOT,cNulo)||CRLF;
         END IF;
         IF (Equal(OLD.DATINC,NEW.DATINC) <> 1) THEN
            vLOG := vLOG||'Data Incluso: de '||COALESCE(TO_CHAR(OLD.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATINC,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
         END IF;
         IF (Equal(OLD.ATU_EM,NEW.ATU_EM) <> 1) THEN
            vLOG := vLOG||'Data Atualizao: de '||COALESCE(TO_CHAR(OLD.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ATU_EM,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.DATHOR,NEW.DATHOR) <> 1 THEN
            vLOG := vLOG||'Data: de '||COALESCE(TO_CHAR(OLD.DATHOR,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATHOR,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.VLRNOT,NEW.VLRNOT) <> 1 THEN
            vLOG := vLOG||'Valor da Nota: de '||COALESCE(TO_CHAR(OLD.VLRNOT),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRNOT),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.VLRLIQ,NEW.VLRLIQ) <> 1 THEN
            vLOG := vLOG||'Valor Liquido: de '||COALESCE(TO_CHAR(OLD.VLRLIQ),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRLIQ),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.NROIMP,NEW.NROIMP) <> 1 THEN
            vLOG := vLOG||'Numero Impressao: de '||COALESCE(TO_CHAR(OLD.NROIMP),cNulo)||' para '||COALESCE(TO_CHAR(NEW.NROIMP),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.SEQFAT,NEW.SEQFAT) = 0 THEN
            vLOG := vLOG||'Fatura: de '||COALESCE(TRIM(OLD.SEQFAT),cNulo)||' para '||COALESCE(TRIM(NEW.SEQFAT),cNulo);
         END IF;
         IF Equal(OLD.PROPGT,NEW.PROPGT) <> 1 THEN
            vLOG := vLOG||'Prox. Venc: de '||COALESCE(TO_CHAR(OLD.PROPGT,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.PROPGT,'DD/MM/YYYY'),cNulo)||CRLF;
         END IF;
         IF (Equal(OLD.FILFAT,NEW.FILFAT) = 0 OR
             Equal(OLD.ENDFAT,NEW.ENDFAT) = 0) THEN
            vLOG := vLOG||'End. Fatura: de '||COALESCE(OLD.FILFAT||'/'||TRIM(TO_CHAR(OLD.ENDFAT)),cNulo)||' para '||COALESCE(NEW.FILFAT||'/'||TRIM(TO_CHAR(NEW.ENDFAT)),cNulo);
         END IF;
         IF (Equal(OLD.FILENT,NEW.FILENT) = 0 OR
             Equal(OLD.ENDENT,NEW.ENDENT) = 0) THEN
            vLOG := vLOG||'End. Entrega: de '||COALESCE(OLD.FILENT||'/'||TRIM(TO_CHAR(OLD.ENDENT)),cNulo)||' para '||COALESCE(NEW.FILENT||'/'||TRIM(TO_CHAR(NEW.ENDENT)),cNulo);
         END IF;
         IF (Equal(OLD.FILCOB,NEW.FILCOB) = 0 OR
             Equal(OLD.ENDCOB,NEW.ENDCOB) = 0) THEN
            vLOG := vLOG||'End. Cobranca: de '||COALESCE(OLD.FILCOB||'/'||TRIM(TO_CHAR(OLD.ENDCOB)),cNulo)||' para '||COALESCE(NEW.FILCOB||'/'||TRIM(TO_CHAR(NEW.ENDCOB)),cNulo);
         END IF;
         IF Equal(COALESCE(OLD.BASUBS,0),COALESCE(NEW.BASUBS,0)) <> 1 THEN
            vLOG := vLOG||'Base Sub. Tributaria: de '||COALESCE(TO_CHAR(OLD.BASUBS),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASUBS),cNulo)||CRLF;
         END IF;
         IF Equal(COALESCE(OLD.SUBSTT,0),COALESCE(NEW.SUBSTT,0)) <> 1 THEN
            vLOG := vLOG||'Sub. Tributaria: de '||COALESCE(TO_CHAR(OLD.SUBSTT),cNulo)||' para '||COALESCE(TO_CHAR(NEW.SUBSTT),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.RETIDO,NEW.RETIDO) <> 1 THEN
            vLOG := vLOG||'Imposto Retido: de '||COALESCE(TO_CHAR(OLD.RETIDO),cNulo)||' para '||COALESCE(TO_CHAR(NEW.RETIDO),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.CONSFI,NEW.CONSFI) <> 1 THEN
            vLOG := vLOG||'Consumidor Final: de '||COALESCE(OLD.CONSFI,cNulo)||' para '||COALESCE(NEW.CONSFI,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.UFLOJA,NEW.UFLOJA) <> 1 THEN
            vLOG := vLOG||'UF da Loja: de '||COALESCE(OLD.UFLOJA,cNulo)||' para '||COALESCE(NEW.UFLOJA,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.FLGTIP,NEW.FLGTIP) <> 1 THEN
            vLOG := vLOG||'Tipo de Pessoa: de '||COALESCE(DescricaoDominio('VEN','FLGTIP',to_char(OLD.FLGTIP)),cNulo)||' para '||COALESCE(DescricaoDominio('VEN','FLGTIP',to_char(NEW.FLGTIP)),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.CODEXT,NEW.CODEXT) <> 1 THEN
            vLOG := vLOG||'Cod. Externo: de '||COALESCE(TO_CHAR(OLD.CODEXT),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODEXT),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.CODCTR,NEW.CODCTR) <> 1 THEN
            vLOG := vLOG||'Unidade de Negocios: de '||COALESCE(TO_CHAR(OLD.CODCTR),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODCTR),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.TIPTRO,NEW.TIPTRO) <> 1 THEN
            vLOG := vLOG||'Tipo Venda: de '||COALESCE(DescricaoDominio('VEN','TIPTRO',OLD.TIPTRO),cNulo)||' para '||COALESCE(DescricaoDominio('VEN','TIPTRO',NEW.TIPTRO),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.CODDEV,NEW.CODDEV) <> 1 THEN
            vLOG := vLOG||'Codigo Devolucao: de '||COALESCE(TO_CHAR(OLD.CODDEV),cNulo)||' para '||COALESCE(TO_CHAR(NEW.CODDEV),cNulo)||CRLF;
         END IF;
         IF Equal(COALESCE(OLD.VLRCOF,0),COALESCE(NEW.VLRCOF,0)) <> 1 THEN
            vLOG := vLOG||'Valor Retido de PIS+COFINS+CSLL: de '||COALESCE(TO_CHAR(OLD.VLRCOF),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRCOF),cNulo)||CRLF;
         END IF;
         IF Equal(COALESCE(OLD.VLRCFI,0),COALESCE(NEW.VLRCFI,0)) <> 1 THEN
            vLOG := vLOG||'Valor Retido de COFINS: de '||COALESCE(TO_CHAR(OLD.VLRCFI),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRCFI),cNulo)||CRLF;
         END IF;
         IF Equal(COALESCE(OLD.VLRPIS,0),COALESCE(NEW.VLRPIS,0)) <> 1 THEN
            vLOG := vLOG||'Valor Retido de PIS: de '||COALESCE(TO_CHAR(OLD.VLRPIS),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRPIS),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.QTDREN,NEW.QTDREN) <> 1 THEN
            vLOG := vLOG||'Quantidade Renegociada: de '||COALESCE(TO_CHAR(OLD.QTDREN),cNulo)||' para '||COALESCE(TO_CHAR(NEW.QTDREN),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.DATFIS,NEW.DATFIS) <> 1 THEN
            vLOG := vLOG||'Data Fiscal: de '||COALESCE(TO_CHAR(OLD.DATFIS,'DD/MM/YYYY'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATFIS,'DD/MM/YYYY'),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.CHAVEA,NEW.CHAVEA) <> 1 THEN
            vLOG := vLOG||'Chave da NF-e: de '||COALESCE(OLD.CHAVEA,cNulo)||' para '||COALESCE(NEW.CHAVEA,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.FLGNFE,NEW.FLGNFE) <> 1 THEN
            vLOG := vLOG||'Status da NF-e: de '||COALESCE(DescricaoDominio('VEN','FLGNFE',OLD.FLGNFE),cNulo)||' para '||COALESCE(DescricaoDominio('VEN','FLGNFE',NEW.FLGNFE),cNulo)||CRLF;
         END IF;
         IF Equal(COALESCE(OLD.BASICM,0),COALESCE(NEW.BASICM,0)) <> 1 THEN
            vLOG := vLOG||'Base de ICMS: de '||COALESCE(TO_CHAR(OLD.BASICM),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASICM),cNulo)||CRLF;
         END IF;
         IF Equal(COALESCE(OLD.VLRICM,0),COALESCE(NEW.VLRICM,0)) <> 1 THEN
            vLOG := vLOG||'Valor de ICMS: de '||COALESCE(TO_CHAR(OLD.VLRICM),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRICM),cNulo)||CRLF;
         END IF;
         IF Equal(COALESCE(OLD.BASISS,0),COALESCE(NEW.BASISS,0)) <> 1 THEN
            vLOG := vLOG||'Base de ISSQN: de '||COALESCE(TO_CHAR(OLD.BASISS),cNulo)||' para '||COALESCE(TO_CHAR(NEW.BASISS),cNulo)||CRLF;
         END IF;
         IF Equal(COALESCE(OLD.VLRISS,0),COALESCE(NEW.VLRISS,0)) <> 1 THEN
            vLOG := vLOG||'Valor de ISSQN: de '||COALESCE(TO_CHAR(OLD.VLRISS),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRISS),cNulo)||CRLF;
         END IF;
         IF Equal(COALESCE(OLD.VLRFRE,0),COALESCE(NEW.VLRFRE,0)) <> 1 THEN
            vLOG := vLOG||'Valor do Frete: de '||COALESCE(TO_CHAR(OLD.VLRFRE),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRFRE),cNulo)||CRLF;
         END IF;
         IF Equal(COALESCE(OLD.VLRSEG,0),COALESCE(NEW.VLRSEG,0)) <> 1 THEN
            vLOG := vLOG||'Valor do Seguro: de '||COALESCE(TO_CHAR(OLD.VLRSEG),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRSEG),cNulo)||CRLF;
         END IF;
         IF Equal(COALESCE(OLD.DESRAT,0),COALESCE(NEW.DESRAT,0)) <> 1 THEN
            vLOG := vLOG||'Desconto Rateado: de '||COALESCE(TO_CHAR(OLD.DESRAT),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DESRAT),cNulo)||CRLF;
         END IF;
         IF Equal(COALESCE(OLD.OUTTAX,0),COALESCE(NEW.OUTTAX,0)) <> 1 THEN
            vLOG := vLOG||'Outras Taxas: de '||COALESCE(TO_CHAR(OLD.OUTTAX),cNulo)||' para '||COALESCE(TO_CHAR(NEW.OUTTAX),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.ORICAN,NEW.ORICAN) <> 1 THEN
            vLOG := vLOG||'Origem do Cancelamento: de '||COALESCE(TO_CHAR(OLD.ORICAN),cNulo)||' para '||COALESCE(TO_CHAR(NEW.ORICAN),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.MARCAS,NEW.MARCAS) <> 1 THEN
            vLOG := vLOG||'Marcas: de '||COALESCE(OLD.MARCAS,cNulo)||' para '||COALESCE(NEW.MARCAS,cNulo)||CRLF;
         END IF;

         --rodrigo 58200 flvio 59074
         vOLD_APEUSU := NULL;
         vNEW_APEUSU := NULL;
         IF Equal(OLD.CODVEN,NEW.CODVEN) <> 1 THEN
            IF (OLD.CODVEN IS NOT NULL) THEN
               Select apeusu into vOLD_APEUSU from tt_usu where filusu = OLD.FILVEN  and codusu = OLD.CODVEN;
            END IF;
            IF (NEW.CODVEN IS NOT NULL) THEN
               Select apeusu into vNEW_APEUSU from tt_usu where filusu = NEW.FILVEN and codusu = NEW.CODVEN;
            END IF;
            vLOG := vLOG||'Nome do Vendedor: de '||COALESCE(vOLD_APEUSU,cNulo)||' para '||COALESCE(vNEW_APEUSU,cNulo)||CRLF;
         END IF;
         --rodrigo 58200
         IF Equal(OLD.FILVEN,NEW.FILVEN) <> 1 THEN
            vLOG := vLOG||'Filial do Vendedor: de '||COALESCE(OLD.FILVEN,cNulo)||' para '||COALESCE(NEW.FILVEN,cNulo)||CRLF;
         END IF;
         -- rfmp 64090
         IF Equal(OLD.FILCTA,NEW.FILCTA) <> 1 THEN
            vLOG := vLOG||'Filial da Conta: de '||COALESCE(OLD.FILCTA,cNulo)||' para '||COALESCE(NEW.FILCTA,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.SEQCTA,NEW.SEQCTA) <> 1 THEN
            vLOG := vLOG||'Seq. da Conta: de '||COALESCE(OLD.SEQCTA,cNulo)||' para '||COALESCE(NEW.SEQCTA,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.TIPCTA,NEW.TIPCTA) <> 1 THEN
            vLOG := vLOG||'Tipo da Conta: de '||COALESCE(OLD.TIPCTA,cNulo)||' para '||COALESCE(NEW.TIPCTA,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.TITAVU,NEW.TITAVU) <> 1 THEN
            vLOG := vLOG||'Titulo Avulso?: de '||COALESCE(OLD.TITAVU,cNulo)||' para '||COALESCE(NEW.TITAVU,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.CODAVU,NEW.CODAVU) <> 1 THEN
            vLOG := vLOG||'Cod. Titulo Avulso : de '||COALESCE(OLD.CODAVU,cNulo)||' para '||COALESCE(NEW.CODAVU,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.FINNFE,NEW.FINNFE) <> 1 THEN
            vLOG := vLOG||'Finalidade da NFe: de '||COALESCE(TO_CHAR(OLD.FINNFE),cNulo)||' para '||COALESCE(TO_CHAR(NEW.FINNFE),cNulo)||CRLF;
         END IF;
         -- fl 59074
         vOLD_APEUSU := NULL;
         vNEW_APEUSU := NULL;
         IF Equal(OLD.CODVDP,NEW.CODVDP) <> 1 THEN
            IF (OLD.CODVDP IS NOT NULL) THEN
               Select apeusu into vOLD_APEUSU from tt_usu where filusu = OLD.FILVDP  and codusu = OLD.CODVDP;
            END IF;
            IF (NEW.CODVDP IS NOT NULL) THEN
                Select apeusu into vNEW_APEUSU from tt_usu where filusu = NEW.FILVDP and codusu = NEW.CODVDP;
            END IF;
            vLOG := vLOG||'Nome do Vendedor Principal: de '||COALESCE(vOLD_APEUSU,cNulo)||' para '||COALESCE(vNEW_APEUSU,cNulo)||CRLF;
         END IF;
         --rodrigo 58200
         IF Equal(OLD.FILVDP,NEW.FILVDP) <> 1 THEN
            vLOG := vLOG||'Filial do Vendedor Principal: de '||COALESCE(OLD.FILVDP,cNulo)||' para '||COALESCE(NEW.FILVDP,cNulo)||CRLF;
         END IF;
         -- RFMP 87521
         IF (Equal(OLD.FILGUI,NEW.FILGUI) = 0 OR
             Equal(OLD.CODGUI,NEW.CODGUI) = 0) THEN
            vLOG := vLOG||'Indicador: de '||COALESCE(OLD.FILGUI||'/'||TRIM(OLD.CODGUI),cNulo)||' para '||COALESCE(NEW.FILGUI||'/'||TRIM(NEW.CODGUI),cNulo);
         END IF;
         -- Paulo K. - 88161
         IF Equal(COALESCE(OLD.VLRSAD,0),COALESCE(NEW.VLRSAD,0)) <> 1 THEN
            vLOG := vLOG||'Valor Servios Adicionais Total: de '||COALESCE(TO_CHAR(OLD.VLRSAD),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRSAD),cNulo)||CRLF;
         END IF;
         -- Paulo K. - 89144
         IF Equal(COALESCE(OLD.VLRIBP,0),COALESCE(NEW.VLRIBP,0)) <> 1 THEN
            vLOG := vLOG||'Valor do Imposto: de '||COALESCE(TO_CHAR(OLD.VLRIBP),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRIBP),cNulo)||CRLF;
         END IF;
         -- RFMP 90316
         IF Equal(OLD.CODFRE,NEW.CODFRE) <> 1 THEN
           IF OLD.CODFRE IS NULL THEN
             cOld := cNulo;
           ELSE
             SELECT COALESCE(TRIM(DESFRE),cNulo) INTO cOld FROM TD_FRE WHERE CODTAB = OLD.CODFRE;
           END IF;
           IF NEW.CODFRE IS NULL THEN
             cNew := cNulo;
           ELSE
             SELECT COALESCE(TRIM(DESFRE),cNulo) INTO cNew FROM TD_FRE WHERE CODTAB = NEW.CODFRE;
           END IF;
           vLOG := vLOG||'Poltica de Frete: de '||cOld||' para '||cNew||CRLF;
         END IF;
         -- Pedro E. Braga - 90739
         IF Equal(OLD.FLGEXT,NEW.FLGEXT) <> 1 THEN
            vLOG := vLOG||'NF Externa?: de '||COALESCE(OLD.FLGEXT,cNulo)||' para '||COALESCE(NEW.FLGEXT,cNulo)||CRLF;
         END IF;
         -- Pedro E. Braga - 91510
         IF Equal(OLD.VLRFLX,NEW.VLRFLX) <> 1 THEN
            vLOG := vLOG||'Valor juros FLEX: de '||COALESCE(OLD.VLRFLX,iNulo)||' para '||COALESCE(NEW.VLRFLX,iNulo)||CRLF;
         END IF;
         -- Pedro E. Braga - 93428
         IF Equal(OLD.NOTMAN,NEW.NOTMAN) <> 1 THEN
            vLOG := vLOG||'Nmero Nota Manual: de '||COALESCE(OLD.NOTMAN,cNulo)||' para '||COALESCE(NEW.NOTMAN,cNulo)||CRLF;
         END IF;
         --Mateus - 93025
         IF Equal(OLD.FILEST,NEW.FILEST) <> 1 THEN
            vLOG := vLOG||'Filial nota estorno: de '||COALESCE(OLD.FILEST,cNulo)||' para '||COALESCE(NEW.FILEST,cNulo)||CRLF;
         END IF;
         --Mateus - 93025
         IF Equal(OLD.SEQEST,NEW.SEQEST) <> 1 THEN
            vLOG := vLOG||'Sequenciador nota estorno: de '||COALESCE(OLD.SEQEST,cNulo)||' para '||COALESCE(NEW.SEQEST,cNulo)||CRLF;
         END IF;
         --Mateus - 93025
         IF Equal(OLD.IMPEST,NEW.IMPEST) <> 1 THEN
            vLOG := vLOG||'Situao Impresso Estorno: de '||COALESCE(OLD.IMPEST,cNulo)||' para '||COALESCE(NEW.IMPEST,cNulo)||CRLF;
         END IF;
         --Mateus - 93025
         IF Equal(OLD.ECFEST,NEW.ECFEST) <> 1 THEN
            vLOG := vLOG||'ECF Impresso Estorno: de '||COALESCE(OLD.ECFEST,cNulo)||' para '||COALESCE(NEW.ECFEST,cNulo)||CRLF;
         END IF;
         --Almir R. Borges  - 94767
         IF Equal(OLD.TIPESP,NEW.TIPESP) <> 1 THEN
            vLOG := vLOG||'Tipo de NF especial: de '||COALESCE(OLD.TIPESP,cNulo)||' para '||COALESCE(NEW.TIPESP,cNulo)||CRLF;
         END IF;
         --Almir R. Borges  - 95107
         IF Equal(OLD.FILORI,NEW.FILORI) <> 1 THEN
            vLOG := vLOG||'Filial da nota de origem: de '||COALESCE(OLD.FILORI,cNulo)||' para '||COALESCE(NEW.FILORI,cNulo)||CRLF;
         END IF;
         --Almir R. Borges  - 95107
         IF Equal(OLD.SEQORI,NEW.SEQORI) <> 1 THEN
            vLOG := vLOG||'Sequenciador da nota de origem: de '||COALESCE(OLD.SEQORI,cNulo)||' para '||COALESCE(NEW.SEQORI,cNulo)||CRLF;
         END IF;
         -- Pedro E. Braga - 95968
         IF Equal(OLD.VLRIBPFED,NEW.VLRIBPFED) <> 1 THEN
            vLOG := vLOG||'Valor de Impostos Federais: de '||COALESCE(OLD.VLRIBPFED,iNulo)||' para '||COALESCE(NEW.VLRIBPFED,iNulo)||CRLF;
         END IF;
         IF Equal(OLD.VLRIBPEST,NEW.VLRIBPEST) <> 1 THEN
            vLOG := vLOG||'Valor de Impostos Estaduais: de '||COALESCE(OLD.VLRIBPEST,iNulo)||' para '||COALESCE(NEW.VLRIBPEST,iNulo)||CRLF;
         END IF;
         IF Equal(OLD.VLRIBPMUN,NEW.VLRIBPMUN) <> 1 THEN
            vLOG := vLOG||'Valor de Impostos Municipais: de '||COALESCE(OLD.VLRIBPMUN,iNulo)||' para '||COALESCE(NEW.VLRIBPMUN,iNulo)||CRLF;
         END IF;
         IF Equal(OLD.CHVIBP,NEW.CHVIBP) <> 1 THEN
            vLOG := vLOG||'Chave do IBPT: de '||COALESCE(OLD.CHVIBP,cNulo)||' para '||COALESCE(NEW.CHVIBP,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.FONIBP,NEW.FONIBP) <> 1 THEN
            vLOG := vLOG||'Fonte IBPT (Fonte Usada no Clculo do Imposto): de '||COALESCE(OLD.FONIBP,cNulo)||' para '||COALESCE(NEW.FONIBP,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.VLRSADCAN,NEW.VLRSADCAN) <> 1 THEN
            vLOG := vLOG||'Valor do servio adicional cancelado: de '||COALESCE(TO_CHAR(OLD.VLRSADCAN,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRSADCAN,'fm9G999G999G990D00'),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.MODNOT,NEW.MODNOT) <> 1 THEN
            vLOG := vLOG||'Modelo Fiscal: de '||COALESCE(OLD.MODNOT,cNulo)||' para '||COALESCE(NEW.MODNOT,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.SATSER,NEW.SATSER) <> 1 THEN
            vLOG := vLOG||'Nmero de Srie do SAT: de '||COALESCE(OLD.SATSER,iNulo)||' para '||COALESCE(NEW.SATSER,iNulo)||CRLF;
         END IF;
         IF Equal(OLD.SATCFE,NEW.SATCFE) <> 1 THEN
            vLOG := vLOG||'Nmero do CF-e: de '||COALESCE(OLD.SATCFE,iNulo)||' para '||COALESCE(NEW.SATCFE,iNulo)||CRLF;
         END IF;
         IF Equal(OLD.EMAILC,NEW.EMAILC) <> 1 THEN
            vLOG := vLOG||'E-mail do Cliente: de '||COALESCE(OLD.EMAILC,cNulo)||' para '||COALESCE(NEW.EMAILC,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.TRN_ID,NEW.TRN_ID) <> 1 THEN
            vLOG := vLOG||'ID Transao: de '||COALESCE(OLD.TRN_ID,iNulo)||' para '||COALESCE(NEW.TRN_ID,iNulo)||CRLF;
         END IF;
         IF Equal(OLD.VLRADU,NEW.VLRADU) <> 1 THEN
            vLOG := vLOG||'Valor das Despesas Aduaneiras: de '||COALESCE(TO_CHAR(OLD.VLRADU,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.VLRADU,'fm9G999G999G990D00'),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.DOCIMP,NEW.DOCIMP) <> 1 THEN
            vLOG := vLOG||'Nmero do Documento de Importao: de '||COALESCE(OLD.DOCIMP,cNulo)||' para '||COALESCE(NEW.DOCIMP,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.TIPIMP,NEW.TIPIMP) <> 1 THEN
            vLOG := vLOG||'Tipo de Documento de Importao: de '||COALESCE(DescricaoDominio('VEN','TIPIMP',OLD.TIPIMP),cNulo)||' para '||COALESCE(DescricaoDominio('VEN','TIPIMP',NEW.TIPIMP),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.RECIBO,NEW.RECIBO) <> 1 THEN
            vLOG := vLOG||'Recibo Provisrio?: de '||COALESCE(OLD.RECIBO,cNulo)||' para '||COALESCE(NEW.RECIBO,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.NFRECI,NEW.NFRECI) <> 1 THEN
            vLOG := vLOG||'NF sobre Recibo Provisrio?: de '||COALESCE(OLD.NFRECI,cNulo)||' para '||COALESCE(NEW.NFRECI,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.EMIDES,NEW.EMIDES) <> 1 THEN
            vLOG := vLOG||'Frete  por conta do Destinatrio ou de Terceiros?: de '||COALESCE(OLD.EMIDES,cNulo)||' para '||COALESCE(NEW.EMIDES,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.PROAUT,NEW.PROAUT) <> 1 THEN
            vLOG := vLOG||'Protocolo de Autorizao: de '||COALESCE(OLD.PROAUT,cNulo)||' para '||COALESCE(NEW.PROAUT,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.DATAUT,NEW.DATAUT) <> 1 THEN
            vLOG := vLOG||'Data e Hora de Autorizao: de '||COALESCE(TO_CHAR(OLD.DATAUT,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATAUT,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.PROCAN,NEW.PROCAN) <> 1 THEN
            vLOG := vLOG||'Protocolo de Cancelamento/Inutilizao: de '||COALESCE(OLD.PROCAN,cNulo)||' para '||COALESCE(NEW.PROCAN,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.DATCAN,NEW.DATCAN) <> 1 THEN
            vLOG := vLOG||'Data e Hora de Cancelamento/Inutilizao: de '||COALESCE(TO_CHAR(OLD.DATCAN,'DD/MM/YYYY HH24:MI:SS'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DATCAN,'DD/MM/YYYY HH24:MI:SS'),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.NUMNFS,NEW.NUMNFS) <> 1 THEN
            vLOG := vLOG||'Nmero NFSe: de '||COALESCE(OLD.NUMNFS,cNulo)||' para '||COALESCE(NEW.NUMNFS,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.CHVCAN,NEW.CHVCAN) <> 1 THEN
            vLOG := vLOG||'Chave Cancelamento: de '||COALESCE(OLD.CHVCAN,cNulo)||' para '||COALESCE(NEW.CHVCAN,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.SATCAN,NEW.SATCAN) <> 1 THEN
            vLOG := vLOG||'Nm Cancelamento SAT: de '||COALESCE(OLD.SATCAN,iNulo)||' para '||COALESCE(NEW.SATCAN,iNulo)||CRLF;
         END IF;
         IF Equal(OLD.SENAR, NEW.SENAR) <> 1 THEN
            vLOG := vLOG||'Valor Servio Nacional de Aprendizagem Rural: de '||COALESCE(OLD.SENAR,iNulo)||' para '||COALESCE(NEW.SENAR,iNulo)||CRLF;
         END IF;
         IF Equal(OLD.SEGRUR,NEW.SEGRUR) <> 1 THEN
            vLOG := vLOG||'Valor Seguro Rural: de '||COALESCE(TO_CHAR(OLD.SEGRUR,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.SEGRUR,'fm9G999G999G990D00'),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.FILCRE,NEW.FILCRE) <> 1 THEN
            vLOG := vLOG||'Filial da Nota de Transferncia de saldo credor de ICMS: de '||COALESCE(OLD.FILCRE,cNulo)||' para '||COALESCE(NEW.FILCRE,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.SEQCRE,NEW.SEQCRE) <> 1 THEN
            vLOG := vLOG||'Sequenciador da Nota de Transferncia de saldo credor de ICMS: de '||COALESCE(OLD.SEQCRE,cNulo)||' para '||COALESCE(NEW.SEQCRE,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.DESESP,NEW.DESESP) <> 1 THEN
            vLOG := vLOG||'Desconto Especial: de '||COALESCE(TO_CHAR(OLD.DESESP,'fm9G999G999G990D00'),cNulo)||' para '||COALESCE(TO_CHAR(NEW.DESESP,'fm9G999G999G990D00'),cNulo)||CRLF;
         END IF;
         IF Equal(OLD.EXPORT,NEW.EXPORT) <> 1 THEN
            SELECT CASE OLD.EXPORT WHEN 'T' THEN 'Sim'
                                    WHEN 'F' THEN 'No'
                                    ELSE cNulo
            END INTO cOld FROM DUAL;
            SELECT CASE NEW.EXPORT WHEN 'T' THEN 'Sim'
                                    WHEN 'F' THEN 'No'
                                    ELSE cNulo
            END INTO cNew FROM DUAL;
            vLOG := vLOG||'Exportado?: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.EXPFIS,NEW.EXPFIS) <> 1 THEN
            SELECT CASE OLD.EXPFIS WHEN 'T' THEN 'Sim'
                                    WHEN 'F' THEN 'No'
                                    ELSE cNulo
            END INTO cOld FROM DUAL;
            SELECT CASE NEW.EXPFIS WHEN 'T' THEN 'Sim'
                                    WHEN 'F' THEN 'No'
                                    ELSE cNulo
            END INTO cNew FROM DUAL;
            vLOG := vLOG||'Exportado Fiscal?: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.EXPEM4,NEW.EXPEM4) <> 1 THEN
            SELECT CASE OLD.EXPEM4 WHEN 'T' THEN 'Sim'
                                    WHEN 'F' THEN 'No'
                                    ELSE cNulo
            END INTO cOld FROM DUAL;
            SELECT CASE NEW.EXPEM4 WHEN 'T' THEN 'Sim'
                                    WHEN 'F' THEN 'No'
                                    ELSE cNulo
            END INTO cNew FROM DUAL;
            vLOG := vLOG||'Exportado EME4?: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.EXT_EC,NEW.EXT_EC) <> 1 THEN
            SELECT CASE OLD.EXT_EC WHEN 'T' THEN 'Sim'
                                    WHEN 'F' THEN 'No'
                                    ELSE cNulo
            END INTO cOld FROM DUAL;
            SELECT CASE NEW.EXT_EC WHEN 'T' THEN 'Sim'
                                    WHEN 'F' THEN 'No'
                                    ELSE cNulo
            END INTO cNew FROM DUAL;
            vLOG := vLOG||'Exportado E-Commerce?: de '||COALESCE(cOld,cNulo)||' para '||COALESCE(cNew,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.TIPINT,NEW.TIPINT) <> 1 THEN
            IF OLD.TIPINT IS NULL THEN
              cOld := cNulo;
            ELSE
              SELECT DESTIPxINT INTO cOld FROM TD_TIPxINT WHERE CODTAB = OLD.TIPINT;
            END IF;
            IF NEW.TIPINT IS NULL THEN
              cNew := cNulo;
            ELSE
              SELECT DESTIPxINT INTO cNew FROM TD_TIPxINT WHERE CODTAB = NEW.TIPINT;
            END IF;
            
            vLOG := vLOG||'Tipo da Intermediao: de '||cOld||' para '||cNew||CRLF;
         END IF;
         IF Equal(OLD.FILINT,NEW.FILINT) <> 1 THEN
            vLOG := vLOG||'Filial do Parceiro Intermediador: de '||COALESCE(OLD.FILINT,cNulo)||' para '||COALESCE(NEW.FILINT,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.CODINT,NEW.CODINT) <> 1 THEN
            vLOG := vLOG||'Cdigo do Parceiro Intermediador: de '||COALESCE(OLD.CODINT,cNulo)||' para '||COALESCE(NEW.CODINT,cNulo)||CRLF;
         END IF;
         IF Equal(OLD.ID_INT,NEW.ID_INT) <> 1 THEN
            vLOG := vLOG||'Identificao do Intermediador: de '||COALESCE(OLD.ID_INT,cNulo)||' para '||COALESCE(NEW.ID_INT,cNulo)||CRLF;
         END IF;

         WK_CODUID := GetCoduidAtual();

         IF ISNOTNULL(vLOG) = 'T' THEN
           select * into QuemLogou from DadosLogon();
           INSERT INTO TL_VEN (FILVEN,SEQVEN,FILUSU,CODUSU,DATOPE,MSGLOG,CODUID)
                       VALUES (NEW.CODFIL,NEW.SEQUEN,QuemLogou.FILUSU,QuemLogou.CODUSU,agora(),vLog,WK_CODUID);
         END IF;

         IF COALESCE(OLD.OBSERV,'XXX')<>COALESCE(NEW.OBSERV,'XXX') THEN
           select * into QuemLogou from DadosLogon();
           INSERT INTO TL_VEN (FILVEN,SEQVEN,FILUSU,CODUSU,DATOPE,MSGLOG,CODUID)
                       VALUES (NEW.CODFIL,NEW.SEQUEN,QuemLogou.FILUSU,QuemLogou.CODUSU,agora(),COALESCE(OLD.OBSERV,cNulo),WK_CODUID);
         END IF;
         -- Almir R. Borges / 94812
         IF COALESCE(OLD.MOTCAN,'XXX') <> COALESCE(NEW.MOTCAN,'XXX') THEN
            select * into QuemLogou from DadosLogon();
           INSERT INTO TL_VEN (FILVEN,SEQVEN,FILUSU,CODUSU,DATOPE,MSGLOG,CODUID)
                   VALUES (NEW.CODFIL,NEW.SEQUEN,QuemLogou.FILUSU,QuemLogou.CODUSU,agora(),COALESCE(OLD.MOTCAN,cNulo),WK_CODUID);
         END IF;
      END IF;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5242 --*/
CREATE TRIGGER TGVEN3
AFTER INSERT OR DELETE OR UPDATE ON TT_VEN 
FOR EACH ROW EXECUTE PROCEDURE TGVEN3();


/*-- SEQ 5243 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGVEN_DW() CASCADE;

/*-- SEQ 5244 --*/
CREATE OR REPLACE FUNCTION TGVEN_DW() RETURNS TRIGGER AS $$
DECLARE
  cDUMMY        VARCHAR(2);
  vComplemento  CONSTANT VARCHAR(100) := Constante('Complemento');

-- Objetivo:
-- 1) Gerar log para view/tabela materializada DW_Vendas_Meio
-- 2) Gerar log para view/tabela materializada DW_Vendas_Grupos
-- 3) Gerar log para view/tabela materializada DW_Vendas_Produto
-- 4) Gerar log para view/tabela materializada DW_Vendas_Cliente
-- 5) Gerar log para view/tabela materializada DW_Vendas
-- 6) Gerar log para view/tabela materializada DW_Vendas_Hora

BEGIN
  IF UsaVMDecisor() = 'T' THEN
     IF (TG_OP = 'INSERT') THEN
       cDUMMY := Insere_DW_Log_Vendas_Meio(NEW.CODFIL, NEW.CODCTR, ANO_MES(NEW.DATFIS));
       cDUMMY := Insere_DW_Log_Vendas_Grupos(NEW.CODFIL, ANO_MES(NEW.DATFIS));
       cDUMMY := Insere_DW_Log_Vendas_Produto(NEW.CODFIL, ANO_MES(NEW.DATFIS));
       cDUMMY := Insere_DW_Log_Vendas_Cliente(NEW.CODFIL, NEW.FILCLI, NEW.CODCLI, ANO_MES(NEW.DATFIS));
       cDUMMY := Insere_DW_Log_Vendas(NEW.CODFIL, NEW.CODCTR, NEW.DATFIS);
       cDUMMY := Insere_DW_Log_Vendas_Hora(NEW.CODFIL, TRUNC_DATA(NEW.DATHOR), HORA_DATA(NEW.DATHOR));
     ELSIF (TG_OP = 'UPDATE') THEN
       IF Equal(OLD.CODFIL,NEW.CODFIL) <> 1 -- PK
       OR Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1 -- PK
       OR Equal(OLD.DATFIS,NEW.DATFIS) <> 1 -- impedido por trigger
       OR Equal(OLD.LANVEN,NEW.LANVEN) <> 1 -- impedido por trigger
       THEN
         RAISE EXCEPTION 'PG-20005 DW-No  permitido alterar determinadas colunas nesta tabela. %' , vComplemento;
       END IF;
       -- DW_Vendas_Meio
       IF Equal(OLD.CODCTR,NEW.CODCTR) <> 1
       OR Equal(OLD.LANVEN,NEW.LANVEN) <> 1
       OR Equal(OLD.DATHOR,NEW.DATHOR) <> 1 THEN
         cDUMMY := Insere_DW_Log_Vendas_Meio(NEW.CODFIL, NEW.CODCTR, ANO_MES(NEW.DATFIS));
         IF Equal(OLD.CODCTR,NEW.CODCTR) <> 1 THEN
           cDUMMY := Insere_DW_Log_Vendas_Meio(OLD.CODFIL, OLD.CODCTR, ANO_MES(OLD.DATFIS));
         END IF;
       END IF;
       -- DW_Vendas_Grupos
       IF Equal(OLD.VLRLIQ,NEW.VLRLIQ) <> 1
       OR Equal(OLD.VLRNOT,NEW.VLRNOT) <> 1
       OR Equal(OLD.FILPGT,NEW.FILPGT) <> 1
       OR Equal(OLD.CODPGT,NEW.CODPGT) <> 1
       OR Equal(OLD.FILVEN,NEW.FILVEN) <> 1
       OR Equal(OLD.CODVEN,NEW.CODVEN) <> 1
       OR Equal(OLD.CODCTR,NEW.CODCTR) <> 1
       OR Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
         cDUMMY := Insere_DW_Log_Vendas_Grupos(NEW.CODFIL, ANO_MES(NEW.DATFIS));
       END IF;
       -- DW_Vendas_Produto
       IF Equal(OLD.VLRLIQ,NEW.VLRLIQ) <> 1
       OR Equal(OLD.VLRNOT,NEW.VLRNOT) <> 1
       OR Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
         cDUMMY := Insere_DW_Log_Vendas_Produto(NEW.CODFIL, ANO_MES(NEW.DATFIS));
       END IF;
       -- DW_Vendas_Cliente
       IF Equal(OLD.FILCLI,NEW.FILCLI) <> 1
       OR Equal(OLD.CODCLI,NEW.CODCLI) <> 1
       OR Equal(OLD.VLRLIQ,NEW.VLRLIQ) <> 1
       OR Equal(OLD.QTDITE,NEW.QTDITE) <> 1
       OR Equal(OLD.FLGEST,NEW.FLGEST) <> 1
       OR Equal(OLD.CODSER,NEW.CODSER) <> 1 THEN
         cDUMMY := Insere_DW_Log_Vendas_Cliente(NEW.CODFIL, NEW.FILCLI, NEW.CODCLI, ANO_MES(NEW.DATFIS));
         IF Equal(OLD.FILCLI,NEW.FILCLI) <> 1
         OR Equal(OLD.CODCLI,NEW.CODCLI) <> 1 THEN
           cDUMMY := Insere_DW_Log_Vendas_Cliente(OLD.CODFIL, OLD.FILCLI, OLD.CODCLI, ANO_MES(OLD.DATFIS));
         END IF;
       END IF;
       -- DW_Vendas
       IF Equal(OLD.CODCTR,NEW.CODCTR) <> 1
       OR Equal(OLD.QTDITE,NEW.QTDITE) <> 1
       OR Equal(OLD.VLRLIQ,NEW.VLRLIQ) <> 1
       OR Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
         cDUMMY := Insere_DW_Log_Vendas(NEW.CODFIL, NEW.CODCTR, NEW.DATFIS);
         -- Colunas que modificam diretamente a chave
         IF Equal(OLD.CODCTR,NEW.CODCTR) <> 1 THEN
           cDUMMY := Insere_DW_Log_Vendas(OLD.CODFIL, OLD.CODCTR, OLD.DATFIS);
         END IF;
       END IF;
       -- DW_Vendas_Hora
       IF Equal(OLD.DATHOR,NEW.DATHOR) <> 1
       OR Equal(OLD.VLRLIQ,NEW.VLRLIQ) <> 1
       OR Equal(OLD.FLGEST,NEW.FLGEST) <> 1 THEN
         cDUMMY := Insere_DW_Log_Vendas_Hora(NEW.CODFIL, TRUNC_DATA(NEW.DATHOR), HORA_DATA(NEW.DATHOR));
         -- Colunas que modificam diretamente a chave
         IF Equal(OLD.CODCTR,NEW.CODCTR) <> 1 THEN
           cDUMMY := Insere_DW_Log_Vendas_Hora(OLD.CODFIL, TRUNC_DATA(OLD.DATHOR), HORA_DATA(OLD.DATHOR));
         END IF;
       END IF;
     ELSIF (TG_OP = 'DELETE') THEN -- impedido por trigger
       cDUMMY := Insere_DW_Log_Vendas_Meio(OLD.CODFIL, OLD.CODCTR, ANO_MES(OLD.DATFIS));
       cDUMMY := Insere_DW_Log_Vendas_Grupos(OLD.CODFIL, ANO_MES(OLD.DATFIS));
       cDUMMY := Insere_DW_Log_Vendas_Produto(OLD.CODFIL, ANO_MES(OLD.DATFIS));
       cDUMMY := Insere_DW_Log_Vendas_Cliente(OLD.CODFIL, OLD.FILCLI, OLD.CODCLI, ANO_MES(OLD.DATFIS));
       cDUMMY := Insere_DW_Log_Vendas(OLD.CODFIL, OLD.CODCTR, OLD.DATFIS);
       cDUMMY := Insere_DW_Log_Vendas_Hora(OLD.CODFIL, TRUNC_DATA(OLD.DATHOR), HORA_DATA(OLD.DATHOR));
     END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5245 --*/
CREATE TRIGGER TGVEN_DW
AFTER INSERT OR DELETE OR UPDATE ON TT_VEN 
FOR EACH ROW EXECUTE PROCEDURE TGVEN_DW();

/*-- SEQ 5246 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGVEN_ASS() CASCADE;

/*-- SEQ 5247 --*/
CREATE OR REPLACE FUNCTION TGVEN_ASS() RETURNS TRIGGER AS $$
-- 83073
-- Atualiza a QTDREG.TT_ASS, Caso exista excluso ou incluso de registros.
DECLARE

 WK_DUMMY VARCHAR(2);

  -- RFMP 85136
  WK_UID TPC_UID_Retorno%ROWTYPE;

BEGIN

  IF ExisteFilialNaUF('SC') THEN
     IF (TG_OP = 'INSERT') THEN
       -- RFMP 85136 Tratamento para no dar lock na TT_ASS
       WK_UID := GetUidAtual();
     
       IF WK_UID.ASSINS = 'T' THEN
         UPDATE TT_ASS
            SET QTDREG = QTDREG + 1
          WHERE NOMTAB = 'TT_VEN';
       ELSE
         WK_DUMMY := Insere_MASS('TT_VEN');
       END IF;
     END IF;
     
     IF (TG_OP = 'DELETE') THEN
       UPDATE TT_ASS
          SET QTDREG = QTDREG - 1
        WHERE NOMTAB = 'TT_VEN';
     END IF;  
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5248 --*/
CREATE TRIGGER TGVEN_ASS
AFTER INSERT OR DELETE ON TT_VEN 
FOR EACH ROW EXECUTE PROCEDURE TGVEN_ASS();


/*-- SEQ 5249 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGVENXOBS() CASCADE;

/*-- SEQ 5250 --*/
CREATE OR REPLACE FUNCTION TGVENXOBS() RETURNS TRIGGER AS $$
-- Objetivo:
-- Impedir delete ou update
BEGIN  
  IF (TG_OP = 'UPDATE') THEN   
        RAISE EXCEPTION 'PG-20006 Registro de uso interno. Nao pode ser modificado';    
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5251 --*/
CREATE TRIGGER TGVENXOBS
BEFORE UPDATE ON TT_VENXOBS 
FOR EACH ROW EXECUTE PROCEDURE TGVENXOBS();


/*-- SEQ 5252 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGVOL() CASCADE;

/*-- SEQ 5253 --*/
CREATE OR REPLACE FUNCTION TGVOL() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Impedir a alteracao de algumas colunas
-- 2) Fazer parte do papel de uma "foreign key"
--
  achou      INTEGER;
  vComplemento Constant VARCHAR(100) := Constante('Complemento');
-- Principal
BEGIN

  -- Impede a alteracao da chave primaria
  IF (TG_OP = 'UPDATE') THEN
    IF (NEW.FILVOL <> OLD.FILVOL) OR
       (NEW.SEQUEN <> OLD.SEQUEN) OR
       (OLD.FILCAR IS NOT NULL AND NEW.FILCAR IS NOT NULL AND NEW.FILCAR <> OLD.FILCAR) OR
       (OLD.SEQCAR IS NOT NULL AND NEW.SEQCAR IS NOT NULL AND NEW.SEQCAR <> OLD.SEQCAR) THEN
       RAISE EXCEPTION 'PG-20036 Nao e permitido alterar este volume. %' , VComplemento;
    END IF;
  END IF;

  IF (TG_OP = 'DELETE') THEN
    ACHOU := TGR_Carga_Existe(OLD.FILCAR, OLD.SEQCAR); /* retornos possiveis 0 e 1 */
    IF (achou = 1) THEN
       RAISE EXCEPTION 'PG-20038 Nao e possivel excluir este volume. %' , vComplemento;
    END IF;
  END IF;

  -- Evitar lancamentos fora do periodo de validade
  IF not (TG_OP = 'DELETE') THEN
    IF not (Livre(NEW.FILVOL,'TT_VOL',NEW.DATVOL) = 1) THEN
       RAISE EXCEPTION 'PG-20039 Lancamento fora do periodo de validade de uso do sistema. %' , vComplemento;
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5254 --*/
CREATE TRIGGER TGVOL
BEFORE INSERT OR DELETE OR UPDATE ON TT_VOL 
FOR EACH ROW EXECUTE PROCEDURE TGVOL();


/*-- SEQ 5255 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGVOT() CASCADE;

/*-- SEQ 5256 --*/
CREATE OR REPLACE FUNCTION TGVOT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Gerar um cdigo sequencial exclusivo para compor a chave primria.

-- Declarao de variveis e cursores

-- Principal
BEGIN

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.SEQUEN IS NULL THEN
         NEW.SEQUEN := ProximoCodigo('TT_VOT',NEW.CODFIL);
      END IF;
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5257 --*/
CREATE TRIGGER TGVOT
BEFORE INSERT OR UPDATE OR DELETE ON TT_VOT 
FOR EACH ROW EXECUTE PROCEDURE TGVOT();


/*-- SEQ 5258 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGVPE() CASCADE;

/*-- SEQ 5259 --*/
CREATE OR REPLACE FUNCTION TGVPE() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

DECLARE

-- Principal
BEGIN
  -- Trata dados padroes na inclusao
  IF (TG_OP = 'INSERT') THEN
    NEW.SEQUEN := ProximoCodigo('TT_VPE',NEW.CODFIL);
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5260 --*/
CREATE TRIGGER TGVPE
BEFORE INSERT ON TT_VPE 
FOR EACH ROW EXECUTE PROCEDURE TGVPE();




/*-- SEQ 5261 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGVRT() CASCADE;

/*-- SEQ 5262 --*/
CREATE OR REPLACE FUNCTION TGVRT() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- Principal

  vFLGNFE            TT_VEN.FLGNFE%TYPE;

BEGIN
  -- Trata dados padroes na inclusao
  IF ISNULL(TRIM(NEW.SEQUEN))='T' THEN
    NEW.SEQUEN:=ProximoCodigo('TT_VRT',NEW.CODFIL);
  END IF;

  -- No insere chave de NFE invlida
  IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
    IF NEW.CHAVEA IS NULL OR LENGTH(NEW.CHAVEA) < 44 OR LENGTH(NEW.CHAVEA) IS NULL THEN
      NEW.CHAVEA := NULL;
    END IF;
  END IF;

  IF (TG_OP = 'INSERT') THEN
     
     -- RFMP 85922 - Trigger alterada para fazer o que o TotallNfeGX faz em se tratando de atualizar a TT_VEN
     -- RFMP 83050 - Status pode ter alguma situao que no existe no FLGNFE
     vFLGNFE := NULL;
     -- envio
     IF NEW.FLGTIP = 'E' THEN
        IF NEW.FLGENV IN ('1','2','6','8') THEN
           vFLGNFE := NEW.FLGENV;
        END IF;
     -- status
     ELSIF NEW.FLGTIP = 'S' THEN
        IF NEW.FLGSTA IN ('1','2','3','6','8') THEN
           vFLGNFE := NEW.FLGSTA;
        END IF;
     -- cancelamento   
     ELSIF NEW.FLGTIP = 'C' THEN
        IF NEW.FLGCAN IN ('2','3','8') THEN
           vFLGNFE := NEW.FLGCAN;
        END IF;
     -- inutilizao   
     ELSIF NEW.FLGTIP = 'I' THEN
        IF NEW.FLGINU IN ('2','4','8') THEN
           vFLGNFE := NEW.FLGINU;
        END IF;
     END IF;
     
     UPDATE TT_VEN VEN
        SET CHAVEA = COALESCE(NEW.CHAVEA,CHAVEA),
            FLGNFE = COALESCE(vFLGNFE,FLGNFE)
      WHERE VEN.CODFIL = NEW.FILVEN
        AND VEN.NUMECF = NEW.ECFVEN
        AND VEN.CODSER = NEW.SERVEN
        AND VEN.NUMNOT = NEW.NOTVEN
        AND VEN.CNT_RO = NEW.CROVEN
        AND VEN.FLGNFE IS NOT NULL;     
     
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5263 --*/
CREATE TRIGGER TGVRT
BEFORE INSERT ON TT_VRT 
FOR EACH ROW EXECUTE PROCEDURE TGVRT();



/*-- SEQ 5264 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGWCLI() CASCADE;

/*-- SEQ 5265 --*/
CREATE OR REPLACE FUNCTION TGWCLI() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Interface entre Totall Lite e Totall 2000. Ao receber novos registros,
--    procura em TT_CLI por (FILCLI+CODCLI, NUMDOC, FIL_CK+ECF_CK+COD_CK), se nao encontra entao insere,
--    caso contrario faz updade
-- 2) Atualiza tambem o TT_END pelo mesmo criterio
DECLARE
   FilialCli                     TT_CLI.FILCLI%TYPE;
   CodigoCli                     TT_CLI.CODCLI%TYPE;
   FilialEnd                     TT_CLI.FILCLI%TYPE;
   NumeroEnd                     TT_COD.ULTCOD%TYPE;
   DocumeEnd                     TT_END.NUMDOC%TYPE;
   FilialSpc                     TT_CLI.FILCLI%TYPE;
   CodigoSpc                     TT_CLI.CODCLI%TYPE;
   UltimoCli                     TT_COD.ULTCOD%TYPE;
   CodigoMunicipio               TT_MUN.CODIGO%TYPE;
   CodigoIBGEMunicipio           TT_MUN.CODIBG%TYPE;
   NomeMunicipio                 TT_MUN.NOMCID%TYPE;
   SiglaEstadoMunicipio          TT_MUN.SIGEST%TYPE;
   PriNumEnd                     TT_END.NUMEND%TYPE;
   FilialAux                     TT_CLI.FILCLI%TYPE;
   CodigoAux                     TT_CLI.CODCLI%TYPE;
   FilialEndAux                  TT_CLI.FILCLI%TYPE;
   NumeroEndAux                  TT_COD.ULTCOD%TYPE;
   DocumeEndAux                  TT_END.NUMDOC%TYPE;
   cISENTO                       TT_CLI.ISENTO%TYPE;
   WK_E_MCON                     TT_CLI.E_MCON%TYPE;
   cDummy                        VARCHAR(100);
   vComplemento                  CONSTANT VARCHAR(100) := Constante('complemento');

   MunicipioPorCEP CURSOR(pCEP TT_MUN.CODCEP%TYPE) IS
     SELECT MUN.CODIGO, MUN.CODIBG, MUN.NOMCID, MUN.SIGEST
       FROM TT_MUN MUN
      WHERE MUN.CEPINI <= pCEP AND MUN.CODCEP >= pCEP
      ;

   MunicipioPorIBGE CURSOR(pCODIBG TT_MUN.CODIBG%TYPE) IS
     SELECT MUN.CODIGO, MUN.CODIBG, MUN.NOMCID, MUN.SIGEST
       FROM TT_MUN MUN
      WHERE MUN.CODIBG = pCODIBG
      ;

   Cliente CURSOR(pDocumento TT_CLI.NUMDOC%TYPE) IS
     SELECT CLI.FILCLI, CLI.CODCLI
       FROM TT_CLI CLI
      WHERE (LTRIM(RTRIM(CLI.NUMDOC)) = LTRIM(RTRIM(pDocumento)))
        -- 104400 - Retirado a Busca pelo Radical devido a solicitao realizada na tarefa.
        --  LTRIM(RTRIM(CLI.NUMDOC)) LIKE SUBSTR( LTRIM(RTRIM(pDocumento)),1, CASE LENGTH(LTRIM(RTRIM(pDocumento))) WHEN 14 THEN 8 ELSE LENGTH(LTRIM(RTRIM(pDocumento))) END)||'%'
        AND CASE LENGTH(LTRIM(RTRIM(pDocumento))) WHEN 14 THEN
                 CASE CLI.FLGTIP WHEN 0 THEN 1
                                    ELSE 0
                 END
            ELSE CASE CLI.FLGTIP WHEN 0 THEN 0
                                    ELSE 1
                 END
            END = 0
        ORDER BY CASE WHEN CLI.NUMDOC=pDocumento THEN 0
                      WHEN pDocumento IN (SELECT ENDE.NUMDOC FROM TT_END ENDE WHERE ENDE.FILCLI=CLI.FILCLI AND ENDE.CODCLI=CLI.CODCLI) THEN 1
                 ELSE 2 END
      ;

   ClientePorCodigo CURSOR(pFilial TT_CLI.FILCLI%TYPE,
           pCodigo TT_CLI.CODCLI%TYPE) IS
     SELECT CLI.FILCLI, CLI.CODCLI
       FROM TT_CLI CLI
      WHERE CLI.FILCLI = pFilial
        AND CLI.CODCLI = pCodigo
      ;

   ClientePorCodigoCheckout CURSOR(pFil_CK TT_CLI.FIL_CK%TYPE,
           pECF_CK TT_CLI.ECF_CK%TYPE,
           pCod_CK TT_CLI.COD_CK%TYPE) IS
     SELECT CLI.FILCLI, CLI.CODCLI
       FROM TT_CLI CLI
      WHERE CLI.FIL_CK = pFil_CK
        AND CLI.ECF_CK = pECF_CK
        AND CLI.COD_CK = pCod_CK
      ;

   ClienteEndereco CURSOR(pDocumento TT_CLI.NUMDOC%TYPE) IS
     SELECT FILCLI, CODCLI
       FROM TT_END
      WHERE (LTRIM(RTRIM(NUMDOC)) = LTRIM(RTRIM(pDocumento)))
      ORDER BY CASE COALESCE(NUMDOC,'X') WHEN 'X' THEN 2
                                             ELSE 1
               END
      ;

   Codigo CURSOR(pFilial TT_COD.FILCOD%TYPE) IS
     SELECT ULTCOD
       FROM TT_COD
      WHERE CODTAB = 'CLI'
        AND FILCOD = pFilial
      ;

   Endereco CURSOR(pFilial TT_END.FILCLI%TYPE,
           pCodigo TT_END.CODCLI%TYPE,
           pDocume TT_END.NUMDOC%TYPE,
           pFilEnd TT_END.CODFIL%TYPE,
           pCodEnd TT_END.NUMEND%TYPE) IS
     SELECT CODFIL, NUMEND, NUMDOC
       FROM TT_END
      WHERE FILCLI  = pFilial
        AND CODCLI  = pCodigo
        AND (  ((LTRIM(RTRIM(NUMDOC)) = LTRIM(RTRIM(pDocume)) OR NUMDOC IS NULL) AND pFilEnd IS NULL)
            OR
               ((CODFIL = pFilEnd) AND (NUMEND = pCodEnd))
            )
      ORDER BY CASE COALESCE(NUMDOC,'X') WHEN 'X' THEN 2
                                             ELSE 1
               END
      ;

   EnderecoPorCodigo CURSOR(pFilial TT_END.FILCLI%TYPE,
           pCodigo TT_END.CODCLI%TYPE,
           pFilEnd TT_END.CODFIL%TYPE,
           pCodEnd TT_END.NUMEND%TYPE) IS
     SELECT CODFIL, NUMEND, NUMDOC
       FROM TT_END
      WHERE FILCLI = pFilial
        AND CODCLI = pCodigo
        AND CODFIL = pFilEnd
        AND NUMEND = pCodEnd
      ;

   EnderecoPorCodigoCheckout CURSOR(pFilial TT_END.FILCLI%TYPE,
           pCodigo TT_END.CODCLI%TYPE,
           pFil_CK TT_END.FIL_CK%TYPE,
           pECF_CK TT_END.ECF_CK%TYPE,
           pCod_CK TT_END.COD_CK%TYPE) IS
     SELECT CODFIL, NUMEND, NUMDOC
       FROM TT_END
      WHERE FILCLI = pFilial
        AND CODCLI = pCodigo
        AND FIL_CK = pFil_CK
        AND ECF_CK = pECF_CK
        AND COD_CK = pCod_CK
      ;

   -- Verifica se ja existe outro endereo com este documento
   DocumentoUsadoCliente CURSOR(pFilial TT_CLI.FILCLI%TYPE,
           pCodigo TT_CLI.CODCLI%TYPE,
           pDocume TT_CLI.NUMDOC%TYPE) IS
     SELECT FILCLI, CODCLI
       FROM TT_CLI
      WHERE (FILCLI  <> pFilial OR CODCLI <> pCodigo)
        AND (LTRIM(RTRIM(NUMDOC)) = LTRIM(RTRIM(pDocume)));
   DocumentoUsadoEndereco CURSOR(pFilial TT_END.FILCLI%TYPE,
           pCodigo TT_END.CODCLI%TYPE,
           pDocume TT_END.NUMDOC%TYPE) IS
     SELECT FILCLI, CODCLI
       FROM TT_END
      WHERE (FILCLI  <> pFilial OR CODCLI <> pCodigo)
        AND (LTRIM(RTRIM(NUMDOC)) = LTRIM(RTRIM(pDocume)));
BEGIN

   IF (TG_OP = 'INSERT') THEN
      NEW.NUMDOC := TRIM(NEW.NUMDOC);
      NEW.CODCEP := TRIM(NEW.CODCEP);

      -- Trata se vier espacos, transforma em null
      IF (NEW.SIGEST = '  ') OR (NEW.SIGEST = ' ') THEN
        NEW.SIGEST := NULL;
      END IF;

      -- RFMP 102234
      -- Busca o Municpio se o endereo for no Brasil
      -- E s trs o Cdigo do IBGE se no tiver sido informado pelo CheckOut.

      CodigoMunicipio      := NULL;
      CodigoIBGEMunicipio  := NULL;
      NomeMunicipio        := NULL;
      SiglaEstadoMunicipio := NULL;

      IF COALESCE(NEW.END_CODPAI, 1058) = 1058 THEN
         OPEN MunicipioPorCEP (NEW.CODCEP);
            FETCH MunicipioPorCEP INTO CodigoMunicipio, CodigoIBGEMunicipio, NomeMunicipio, SiglaEstadoMunicipio;
            IF NOT FOUND THEN
               CodigoMunicipio      := NULL;
               CodigoIBGEMunicipio  := NULL;
               NomeMunicipio        := NULL;
               SiglaEstadoMunicipio := NULL;
            END IF;
         CLOSE MunicipioPorCEP;
      END IF;

      /*
      -- RFMP 102234
      -- Essas validacoes causariam problema para cliente estrangeiro

      -- Busca o Municipio
      IF NEW.CODIBG IS NULL THEN
         OPEN MunicipioPorCEP (NEW.CODCEP);
            FETCH MunicipioPorCEP INTO CodigoMunicipio, CodigoIBGE, NomeMunicipio, SiglaEstadoMunicipio;
            IF NOT FOUND THEN
               CodigoMunicipio := NULL;
               CodigoIBGE := NULL;
               NomeMunicipio := NULL;
               SiglaEstadoMunicipio := NULL;
            END IF;
         CLOSE MunicipioPorCEP;
      ELSE
         OPEN MunicipioPorIBGE (NEW.CODIBG);
            FETCH MunicipioPorIBGE INTO CodigoMunicipio, CodigoIBGE, NomeMunicipio, SiglaEstadoMunicipio;
            IF NOT FOUND THEN
               CodigoMunicipio := NULL;
               CodigoIBGE := NULL;
               NomeMunicipio := NULL;
               SiglaEstadoMunicipio := NULL;
            END IF;
         CLOSE MunicipioPorIBGE;
      END IF;

      IF CodigoIBGE IS NULL THEN
        RAISE EXCEPTION 'PG-20007 Cdigo do IBGE no encontrado. %' , vComplemento;
      END IF;
      */

      -- Busca o cliente
      -- Rhuan 95867 - Se FILCLI e CODCLI vierem preenchidos, busca diretamente pelo codigo
      IF (ISNOTNULL(TRIM(NEW.FILCLI)) = 'T') AND (ISNOTNULL(TRIM(NEW.CODCLI)) = 'T') THEN
         OPEN ClientePorCodigo(NEW.FILCLI,NEW.CODCLI);
         FETCH ClientePorCodigo INTO FilialCli, CodigoCli;
         IF NOT FOUND THEN
            FilialCli := NULL;
            CodigoCli := NULL;
         END IF;
         CLOSE ClientePorCodigo;
      ELSIF (ISNOTNULL(TRIM(NEW.FIL_CK_CLI)) = 'T')
        AND (ISNOTNULL(TRIM(NEW.ECF_CK_CLI)) = 'T')
        AND (ISNOTNULL(TO_CHAR(NEW.COD_CK_CLI)) = 'T') THEN
         --Busca pela Chave do Checkout
         OPEN ClientePorCodigoCheckout (NEW.FIL_CK_CLI, NEW.ECF_CK_CLI, NEW.COD_CK_CLI);
         FETCH ClientePorCodigoCheckout INTO FilialCli, CodigoCli;
         IF NOT FOUND THEN
            FilialCli := NULL;
            CodigoCli := NULL;
         END IF;
         CLOSE ClientePorCodigoCheckout;
      ELSIF (ISNOTNULL(TRIM(NEW.NUMDOC)) = 'T')
        AND (COALESCE(NEW.CODPAI, 1058) = 1058) THEN
         --Pesquisa Cliente Pelo NUMDOC Base
         OPEN Cliente (NEW.NUMDOC);
         FETCH Cliente INTO FilialCli, CodigoCli;
         IF NOT FOUND THEN
            FilialCli := NULL;
            CodigoCli := NULL;
         END IF;
         CLOSE Cliente;

         --Pesquisa Cliente pelo NUMDOC do Endereo
         IF (ISNULL(FilialCli) = 'T') THEN
            OPEN ClienteEndereco (NEW.NUMDOC);
            FETCH ClienteEndereco INTO FilialCli, CodigoCli;
            IF NOT FOUND THEN
               FilialCli := null;
               CodigoCli := null;
            END IF;
            CLOSE ClienteEndereco;
         END IF;
      ELSE
         FilialCli := NULL;
         CodigoCli := NULL;
      END IF;

      -- Caso o cliente nao exista, inclui, senao altera
      NumeroEnd := -1;
      DocumeEnd := NULL;
      IF (ISNULL(FilialCli) = 'T') THEN
         IF (ISNULL(NEW.CODCLI) = 'T') THEN
            -- Acha o numero do ultimo cliente incluso na filial
            OPEN Codigo (NEW.FILCLI);
            FETCH Codigo INTO UltimoCli;
            IF NOT FOUND THEN
               UltimoCli := null;
            END IF;
            CLOSE Codigo;

            -- Se nao ha registro em TT_COD, insere
            IF (UltimoCli IS NULL) THEN
              SELECT COALESCE(CAST(MAX(CODCLI) AS INTEGER),0) + 1 INTO UltimoCli FROM TT_CLI WHERE FILCLI = NEW.FILCLI;
              INSERT INTO TT_COD (CODTAB, FILCOD, ULTCOD)
                          VALUES ('CLI', NEW.FILCLI, UltimoCli);
            ELSE
              -- Atualiza TT_COD
              UPDATE TT_COD
                 SET ULTCOD = UltimoCli + 1
               WHERE CODTAB = 'CLI'
                 AND FILCOD = NEW.FILCLI;
              UltimoCli := UltimoCli + 1;
            END IF;
         ELSE
            UltimoCli := NEW.CODCLI;
         END IF;

         FilialCli := NEW.FILCLI;
         CodigoCli := LPAD(TO_CHAR(UltimoCli),6,' ');

         IF (ISNULL(NEW.ISENTO) = 'T') THEN
            IF (NEW.FLGTIP = 0 AND (NEW.TIPDOC<> 'IE' OR UPPER(NEW.INSEST)= 'ISENTO' OR NEW.INSEST IS NULL )) OR
               (NEW.FLGTIP = 2) OR
               (NEW.FLGTIP > 0 and (UPPER(NEW.INSEST)= 'ISENTO' OR NEW.INSEST IS NULL)) THEN
               cISENTO := 'T';
            ELSE
               cISENTO := 'F';
            END IF;
         ELSE
            cISENTO := NEW.ISENTO;
         END IF;

         IF NEW.FLGTIP <> '0' THEN
           WK_E_MCON := NEW.E_MAIL;
         ELSE
           WK_E_MCON := NULL;
         END IF;

         -- Insere novo cliente
         INSERT INTO TT_CLI (FILCLI, CODCLI, DATNAS, DATOPE, ESTCIV,
                            NUMDOC, FLGTIP, ULTCOM, CODSEX, NASCON,
                            NOMCLI, ULTNOM, INSEST, CONJUG,
                            SIGNAT, SEXCON, CATEG1, CATEG2, OBSERV,OBSOUT,
                            TIPDOC, ID_DAT, ID_EST, ID_ORG, ESTRAN, CODPAI, ISENTO,
                            FILUSU, CODUSU, FIL_CK, ECF_CK, COD_CK, E_MCON, CONTRIBUINTE)
                    VALUES (FilialCli, CodigoCli, NEW.DATNAS, NEW.DATOPE, COALESCE(NEW.ESTCIV, 0),
                            NEW.NUMDOC, COALESCE(NEW.FLGTIP,0), NEW.ULTCOM, COALESCE(NEW.CODSEX,0), NEW.NASCON,
                            TRIM( COALESCE(NEW.NOMCLI,NEW.NUMDOC)), TRIM( NEW.ULTNOM),
                            TRIM( NEW.INSEST), TRIM( NEW.CONJUG),
                            0, COALESCE(NEW.SEXCON,0), NEW.CATEG1, NEW.CATEG2, NEW.OBSERV, NEW.OBSOUT,
                            NEW.TIPDOC, NEW.ID_DAT, NEW.ID_EST, NEW.ID_ORG, NEW.ESTRAN, COALESCE(NEW.CODPAI, 1058), cISENTO,
                            NEW.FILUSU, NEW.CODUSU, NEW.FIL_CK_CLI, NEW.ECF_CK_CLI, NEW.COD_CK_CLI, WK_E_MCON, NULL);

         INSERT INTO TL_CLI (CODUSU,FILCLI,FILUSU,CODCLI,DATOPE,MSGLOG)
                    VALUES (NEW.CODUSU,FilialCli,NEW.FILUSU,CodigoCli,Agora(),'Incluso de Parceiro via CheckOut');

         cDummy := TGR_PopulaTabelaPersonalizada(FilialCli,CodigoCli);

         if NEW.FLGTIP = '0' then
           cDummy := TGR_PopulaSPC(FilialCli,CodigoCli,NEW.E_MAIL, NEW.DDDCEL, NEW.NUMCEL);
         end if;

         NumeroEnd := UltimoCli;
         DocumeEnd := NEW.NUMDOC;
      ELSE
         -- Verifica se ja existe outro cliente com este documento quando cliente estrangeiro
         IF (ISNOTNULL(NEW.NUMDOC) = 'T')
         AND (COALESCE(NEW.CODPAI, 1058) <> 1058) THEN
            OPEN DocumentoUsadoCliente (FilialCli,CodigoCli,LTRIM(RTRIM(NEW.NUMDOC)));
               FETCH DocumentoUsadoCliente INTO FilialAux, CodigoAux;
               IF NOT (NOT FOUND) THEN
                  RAISE EXCEPTION 'PG-20007 Documento j utilizado por outro cliente. %' , vComplemento;
               END IF;
            CLOSE DocumentoUsadoCliente;
            IF (ISNULL(FilialAux) = 'T') THEN
               OPEN DocumentoUsadoEndereco (FilialCli,CodigoCli,LTRIM(RTRIM(NEW.NUMDOC)));
                  FETCH DocumentoUsadoEndereco INTO FilialAux, CodigoAux;
                  IF NOT (NOT FOUND) THEN
                     RAISE EXCEPTION 'PG-20007 Documento j utilizado por um endereo de outro cliente. %' , vComplemento;
                  END IF;
               CLOSE DocumentoUsadoEndereco;
            END IF;
         END IF;

        UPDATE TT_CLI
           SET DATNAS = COALESCE( NEW.DATNAS, DATNAS ),
               DATOPE = COALESCE( NEW.DATOPE, DATOPE ),
               ESTCIV = COALESCE( NEW.ESTCIV, ESTCIV ),
               FLGTIP = COALESCE( NEW.FLGTIP, FLGTIP ),
               ULTCOM = COALESCE( NEW.ULTCOM, ULTCOM ),
               CODSEX = COALESCE( NEW.CODSEX, CODSEX ),
               NASCON = COALESCE( NEW.NASCON, NASCON ),
               SEXCON = COALESCE( NEW.SEXCON, SEXCON ),
               CATEG1 = COALESCE( NEW.CATEG1, CATEG1 ),
               CATEG2 = COALESCE( NEW.CATEG2, CATEG2 ),
               OBSOUT = COALESCE( NEW.OBSOUT, OBSOUT ),
               NOMCLI = Trim( COALESCE(NEW.NOMCLI, NOMCLI) ),
               ULTNOM = Trim( COALESCE(NEW.ULTNOM, ULTNOM) ),
               INSEST = Trim( COALESCE(NEW.INSEST, INSEST) ),
               CONJUG = Trim( COALESCE(NEW.CONJUG, CONJUG) ),
               SIGNAT = CASE WHEN ABS(SIGNAT) = 999 THEN 0
                             WHEN SIGNAT < 0   THEN 0
                             ELSE (SIGNAT + 1) END,
               TIPDOC = COALESCE( NEW.TIPDOC, TIPDOC ),
               CODPAI = COALESCE( NEW.END_CODPAI, 1058 ),
               ID_DAT = COALESCE( NEW.ID_DAT, ID_DAT ),
               ID_EST = COALESCE( NEW.ID_EST, ID_EST ),
               ID_ORG = COALESCE( NEW.ID_ORG, ID_ORG ),
               ESTRAN = COALESCE( NEW.ESTRAN, ESTRAN ),
               FILUSU = COALESCE( NEW.FILUSU, FILUSU ),
               CODUSU = COALESCE( NEW.CODUSU, CODUSU ),
               ISENTO = COALESCE( NEW.ISENTO, ISENTO ),
               FIL_CK = COALESCE( NEW.FIL_CK_CLI, FIL_CK ),
               ECF_CK = COALESCE( NEW.ECF_CK_CLI, ECF_CK ),
               COD_CK = COALESCE( NEW.COD_CK_CLI, COD_CK ),
               -- Quando Cliente estrangeiro e NUMDOC informado na integrao = null mantem o NUMDOC informado.
               NUMDOC = CASE WHEN COALESCE(NEW.CODPAI, 1058) = 1058 THEN NUMDOC
                             WHEN COALESCE(NEW.CODPAI, 1058) <> 1058 THEN COALESCE(NEW.NUMDOC, NUMDOC)
                             ELSE NUMDOC END,
               DUMMY  = CONSTANTE('VEM_DE_TGWCLI')
         WHERE FILCLI = FilialCli
           AND CODCLI = CodigoCli;

         INSERT INTO TL_CLI (CODUSU,FILCLI,FILUSU,CODCLI,DATOPE,MSGLOG)
                    VALUES (NEW.CODUSU,FilialCli,NEW.FILUSU,CodigoCli,agora(),'Alterao de Parceiro via CheckOut');


         cDummy := TGR_PopulaTabelaPersonalizada(FilialCli,CodigoCli);
         cDummy := TGR_PopulaSPC(FilialCli,CodigoCli,NEW.E_MAIL, NEW.DDDCEL, NEW.NUMCEL);

         -- Verifica se ja existe o endereco
         -- Rhuan 95867 - Se FILCLI e CODCLI vierem preenchidos, busca diretamente pela chave
         IF (ISNOTNULL(TRIM(NEW.FILCLI)) = 'T') AND (ISNOTNULL(TRIM(NEW.CODCLI)) = 'T')
         AND (ISNOTNULL(TRIM(NEW.FILEND)) = 'T') AND (ISNOTNULL(TO_CHAR(NEW.NUMEND)) = 'T') THEN
            OPEN EnderecoPorCodigo(FilialCli, CodigoCli, NEW.FILEND, NEW.NUMEND);
            FETCH EnderecoPorCodigo INTO FilialEnd, NumeroEnd, DocumeEnd;
            IF NOT FOUND THEN
               FilialEnd := NULL;
            END IF;
            CLOSE EnderecoPorCodigo;
         ELSIF (ISNOTNULL(TRIM(NEW.FIL_CK_END)) = 'T')
           AND (ISNOTNULL(TRIM(NEW.ECF_CK_END)) = 'T')
           AND (ISNOTNULL(TO_CHAR(NEW.COD_CK_END)) = 'T') THEN
            --Busca Endereo pelo Cdigo do Checkout
            OPEN EnderecoPorCodigoCheckout(FilialCli, CodigoCli, NEW.FIL_CK_END, NEW.ECF_CK_END, NEW.COD_CK_END);
            FETCH EnderecoPorCodigoCheckout INTO FilialEnd, NumeroEnd, DocumeEnd;
            IF NOT FOUND THEN
               FilialEnd := NULL;
            END IF;
            CLOSE EnderecoPorCodigoCheckout;
         ELSE
            --Busca Endereo pelo NUMDOC
            OPEN Endereco (FilialCli, CodigoCli, NEW.NUMDOC, NEW.FILEND, NEW.NUMEND);
            FETCH Endereco INTO FilialEnd, NumeroEnd, DocumeEnd;
            IF NOT FOUND THEN
               FilialEnd := NULL;
            END IF;
            CLOSE Endereco;
         END IF;

         --84179
         IF (NEW.FLGTIP = '0') AND (NEW.TIPDOC <> 'IE') THEN
            NEW.INSEST := NULL;
         END IF;

         IF (ISNULL(FilialEnd) = 'T') THEN
            NumeroEnd := CodigoCli;
            DocumeEnd := NEW.NUMDOC;
         ELSE
           UPDATE TT_END SET CODCEP = COALESCE( NEW.CODCEP, CODCEP ),
                             CODLOG = COALESCE( NEW.CODLOG, CODLOG ),
                             FLGNAC = COALESCE( NEW.PROCED, FLGNAC ),
                             ESTRAN = COALESCE( NEW.INTERN, ESTRAN ),
                             CODCID = COALESCE( CodigoMunicipio, CODCID ),
                             NOMCID = COALESCE( NomeMunicipio, COALESCE(NEW.NOMCID, NOMCID) ),
                             SIGEST = COALESCE( SiglaEstadoMunicipio, COALESCE(NEW.SIGEST, SIGEST) ),
                             NUMERO = COALESCE( NEW.NUMERO, NUMERO ),
                             ENDERE = Trim( COALESCE( NEW.ENDERE, ENDERE ) ),
                             COMPLE = Trim( COALESCE( NEW.COMPLE, COMPLE ) ),
                             CODDDD = Trim( COALESCE( NEW.CODDDD, CODDDD ) ),
                             NUMFON = Trim( COALESCE( NEW.NUMFON, NUMFON ) ),
                             NUMFAX = Trim( COALESCE( NEW.NUMFAX, NUMFAX ) ),
                             LOCTRA = Trim( COALESCE( NEW.LOCTRA, LOCTRA ) ),
                             BAIRRO = Trim( COALESCE( NEW.BAIRRO, BAIRRO ) ),
                             INSEST = Trim( COALESCE( NEW.INSEST, INSEST ) ),
                             FILUSU = COALESCE( NEW.FILUSU, FILUSU ),
                             CODUSU = COALESCE( NEW.CODUSU, CODUSU ),
                             FIL_CK = COALESCE( NEW.FIL_CK_END, FIL_CK ),
                             ECF_CK = COALESCE( NEW.ECF_CK_END, ECF_CK ),
                             COD_CK = COALESCE( NEW.COD_CK_END, COD_CK ),
                             CODPAI = COALESCE( NEW.END_CODPAI, 1058),
                             CODIBG = COALESCE( NEW.CODIBG, COALESCE(CodigoIBGEMunicipio, CODIBG) ),
                             NOMREC = COALESCE( NEW.NOMREC, NOMREC ),
                             DUMMY  = CONSTANTE('VEM_DE_TGWCLI')
            WHERE FILCLI = FilialCli
              AND CODCLI = CodigoCli
              AND NUMEND = COALESCE(NEW.NUMEND, NumeroEnd)
              AND CODFIL = COALESCE(NEW.FILEND, FilialEnd);

           NumeroEnd := -1; -- Impede a incluso de um novo endereo
         END IF;
      END IF;

      IF (NumeroEnd > -1) THEN
                     SELECT MAX(NUMEND)+1 INTO PriNumEnd
              FROM TT_END
             WHERE FILCLI = FilialCli
               AND CODCLI = CodigoCli;
         
         -- Verifica se ja existe outro endereco com este documento
         IF (ISNOTNULL(DocumeEnd) = 'T') THEN
            -- Busca endereo com o mesmo documento em cliente diferente.
            OPEN DocumentoUsadoEndereco (FilialCli,CodigoCli,LTRIM(RTRIM(DocumeEnd)));
               FETCH DocumentoUsadoEndereco INTO FilialAux, CodigoAux;
               IF NOT (NOT FOUND) THEN
                  RAISE EXCEPTION 'PG-20007 Documento j utilizado por um endereo de outro cliente. %' , vComplemento;
               END IF;
            CLOSE DocumentoUsadoEndereco;

            IF (NEW.FLGTIP = '0') THEN
               DocumeEnd := NULL;
            ELSE
               --Busca endereo com mesmo documento no cliente atual
               OPEN Endereco (FilialCli, CodigoCli, LTRIM(RTRIM(DocumeEnd)), null, null);
                  FETCH Endereco INTO FilialEndAux, NumeroEndAux, DocumeEndAux;
                  IF NOT (NOT FOUND) THEN
                     -- Rhuan - Ticket 201999127382 - Ao invs de gerar exceo, insere o novo endereo sem o Documento
                     --RAISE EXCEPTION 'PG-20007 Documento j utilizado por um endereo do cliente. %' , vComplemento;
                     DocumeEnd := NULL;
                  END IF;
               CLOSE Endereco;
            END IF;
         END IF;

         INSERT INTO TT_END (FILCLI, CODCLI, CODFIL, NUMEND, CODCEP,
                             CODLOG, FLGNAC, ENDERE, COMPLE, CODDDD,
                             NUMFON, NUMFAX, LOCTRA, ESTRAN, CODCID,
                             ENDCOB, ENDCOR, BAIRRO, NUMDOC,
                             NOMCID, SIGEST, NUMERO, TIPEND, INSEST, CODPAI, CODIBG,
                             FIL_CK, ECF_CK, COD_CK, NOMREC)
                     VALUES (FilialCli, CodigoCli, FilialCli, COALESCE(PriNumEnd,1), NEW.CODCEP,
                             NEW.CODLOG, COALESCE(NEW.PROCED, 'F'), TRIM( NEW.ENDERE ),
                             TRIM( NEW.COMPLE ), TRIM( NEW.CODDDD ),
                             TRIM( NEW.NUMFON ), TRIM( NEW.NUMFAX ),
                             TRIM( NEW.LOCTRA ), TRIM( NEW.INTERN ),
                             CodigoMunicipio, 'T', 'T',
                             TRIM( NEW.BAIRRO ), DocumeEnd,
                             COALESCE(NomeMunicipio, NEW.NOMCID), COALESCE(SiglaEstadoMunicipio, NEW.SIGEST), NEW.NUMERO, 0, NEW.INSEST, COALESCE(NEW.END_CODPAI, 1058), COALESCE(NEW.CODIBG, CodigoIBGEMunicipio),
                             NEW.FIL_CK_END, NEW.ECF_CK_END, NEW.COD_CK_END, NEW.NOMREC);
      END IF;

      NEW.FILBCO := FilialCli;
      NEW.CODBCO := CodigoCli;
      NEW.ATU_EM := Agora();

   ELSIF (TG_OP = 'UPDATE') THEN
      RAISE EXCEPTION 'PG-20006 TW_CLI permite somente inclusoes e exclusoes. %' , vComplemento;
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5266 --*/
CREATE TRIGGER TGWCLI
BEFORE INSERT OR DELETE OR UPDATE ON TW_CLI 
FOR EACH ROW EXECUTE PROCEDURE TGWCLI();


/*-- SEQ 5267 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGWECF() CASCADE;

/*-- SEQ 5268 --*/
CREATE OR REPLACE FUNCTION TGWECF() RETURNS TRIGGER AS $$

-- Objetivo:
-- Fazer insert na TT_ECF caso ainda nao exista

DECLARE
   nCOUNT    INTEGER;
   nCOUNT_RZ INTEGER;
-- Principal
BEGIN

  nCOUNT    := 0;
  nCOUNT_RZ := 0;

  IF (TG_OP = 'INSERT') THEN 
       SELECT COUNT(*) INTO nCOUNT
         FROM TT_ECF
        WHERE CODFIL = NEW.CODFIL
          AND NUMECF = NEW.NUMECF
          AND CODSER = 'CF'
          AND TOTALI = NEW.TOTALI
          AND DATOPE = NEW.DATOPE
          AND CNT_RO = NEW.CNT_RO;
          
       SELECT COUNT(*) INTO nCOUNT_RZ
         FROM TT_ECF ECF
        WHERE ECF.CODFIL = NEW.CODFIL
          AND ECF.NUMECF IN (SELECT DECF.NUMECF
                               FROM TD_ECF DECF
                              WHERE DECF.CODORI = NEW.NUMECF)
          AND ECF.CNT_RZ = NEW.CNT_RZ
          AND ECF.TOTALI = NEW.TOTALI;
          
      IF nCOUNT=0 AND nCOUNT_RZ=0 AND COALESCE(NEW.VLR_GT,0)>0 THEN 
         INSERT INTO TT_ECF (CODFIL,NUMECF,DATOPE,TOTALI,NUMSER,CNTOPE,CNT_RZ,VLR_GT,VLRTOT,VLRBAS,ATU_EM,TIPTOT,CNT_RO)
         VALUES
         (NEW.CODFIL,NEW.NUMECF,NEW.DATOPE,NEW.TOTALI,NEW.NUMSER,NEW.CNTOPE,NEW.CNT_RZ,NEW.VLR_GT,NEW.VLRTOT,NEW.VLRBAS,NEW.ATU_EM,NEW.TIPTOT,NEW.CNT_RO);
      ELSE
         IF nCOUNT_RZ = 1 THEN
            -- RFMP 82330 Permitir reenvio dos totalizadores de ECFs
            UPDATE TT_ECF
               SET VLRTOT = NEW.VLRTOT,
                   VLRBAS = NEW.VLRBAS
             WHERE CODFIL = NEW.CODFIL
               AND NUMECF IN (SELECT DECF.NUMECF
                                FROM TD_ECF DECF
                               WHERE DECF.CODORI = NEW.NUMECF)
               AND CNT_RZ = NEW.CNT_RZ
               AND TOTALI = NEW.TOTALI;
               
            UPDATE TR_ECF
               SET DIAFEC = 'X'
             WHERE CODFIL = NEW.CODFIL
               AND NUMECF IN (SELECT DECF.NUMECF
                                FROM TD_ECF DECF
                               WHERE DECF.CODORI = NEW.NUMECF)
               AND CNT_RZ = NEW.CNT_RZ;
         END IF;   
      END IF;
  END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5269 --*/
CREATE TRIGGER TGWECF
BEFORE INSERT ON TW_ECF 
FOR EACH ROW EXECUTE PROCEDURE TGWECF();


/*-- SEQ 5270 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGWEXT() CASCADE;

/*-- SEQ 5271 --*/
CREATE OR REPLACE FUNCTION TGWEXT() RETURNS TRIGGER AS $$
DECLARE
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN:=ProximoCodigo('TW_EXT','');
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5272 --*/
CREATE TRIGGER TGWEXT
BEFORE INSERT ON TW_EXT 
FOR EACH ROW EXECUTE PROCEDURE TGWEXT();


/*-- SEQ 5273 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGEXD() CASCADE;

/*-- SEQ 5274 --*/
CREATE OR REPLACE FUNCTION TGEXD() RETURNS TRIGGER AS $$
DECLARE
-- Objetivos:
-- 1. Impede excluso.
-- 2. Gerar um cdigo sequencial exclusivo para compor a chave primria.
-- 3. Atualiza controles de data.

-- Declarao de variveis e cursores
   COMPLEMENTO                   CONSTANT VARCHAR(254) := Constante('COMPLEMENTO');

-- Principal
BEGIN

   -- Impede excluso.
   IF (TG_OP = 'DELETE') THEN
      RAISE EXCEPTION 'PG-20000 Registro no pode ser excludo. %' , COMPLEMENTO;
   END IF;

   -- Gerar um cdigo sequencial exclusivo para compor a chave primria.
   IF (TG_OP = 'INSERT') THEN
      IF NEW.ID_EXD IS NULL THEN
         SELECT NEXTVAL('SQEXTXDOC') INTO NEW.ID_EXD FROM DUAL;
      END IF;
      NEW.DATINC := Agora();
   END IF;

   -- Atualiza controles de data.
   IF (TG_OP = 'INSERT') OR (TG_OP = 'UPDATE') THEN
      NEW.ATU_EM := Agora();
   END IF;

 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5275 --*/
CREATE TRIGGER TGEXD
BEFORE INSERT OR UPDATE OR DELETE ON TW_EXTXDOC 
FOR EACH ROW EXECUTE PROCEDURE TGEXD();


/*-- SEQ 5276 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGWFLU() CASCADE;

/*-- SEQ 5277 --*/
CREATE OR REPLACE FUNCTION TGWFLU() RETURNS TRIGGER AS $$
DECLARE
-- Principal
BEGIN
  -- Gera um codigo automaticamente
  IF (TG_OP = 'INSERT') THEN 
    IF NEW.SEQUEN IS NULL THEN
       NEW.SEQUEN:=ProximoCodigo('TW_FLU','');
    END IF;
  END IF;
  IF (TG_OP = 'UPDATE') THEN
    IF Equal(OLD.DATPRE,NEW.DATPRE) <> 1 OR 
       Equal(OLD.VLRPRE,NEW.VLRPRE) <> 1 THEN
       NEW.GRAVAR:='T';
    END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5278 --*/
CREATE TRIGGER TGWFLU
BEFORE INSERT OR UPDATE ON TW_FLU 
FOR EACH ROW EXECUTE PROCEDURE TGWFLU();


/*-- SEQ 5279 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGWFUN1() CASCADE;

/*-- SEQ 5280 --*/
CREATE OR REPLACE FUNCTION TGWFUN1() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Criar projetos e tarefas a partir da insero em tw_fun
DECLARE

  Cliente CURSOR(vFILCLI TT_CLI.FILCLI%TYPE,
           vCODCLI TT_CLI.CODCLI%TYPE,
           vFILPAI TT_PRJ.CODFIL%TYPE,
           vSEQPAI TT_PRJ.SEQUEN%TYPE) IS
     SELECT CODFIL, SEQUEN
       FROM TT_PRJ 
      WHERE FILCLI = vFILCLI
        and CODCLI = vCODCLI
        AND FILPAI = vFILPAI
        and SEQPAI = vSEQPAI;

  Implantacao CURSOR(vTIPFUN TT_PRJ.TIPFUN%TYPE) IS
     SELECT CODFIL, SEQUEN
       FROM TT_PRJ
      WHERE CHVPAI IS NULL
        and TIPFUN = vTIPFUN;
        
  SubNivel CURSOR(vFILPAI TT_PRJ.FILPAI%TYPE,
           VSEQPAI TT_PRJ.SEQPAI%TYPE,
           vTIPFUN TT_PRJ.TIPFUN%TYPE) IS
     SELECT CODFIL, SEQUEN
       FROM TT_PRJ
      WHERE FILPAI=vFILPAI
        and SEQPAI=vSEQPAI
        and TIPFUN=vTIPFUN;        

  TarefaCur CURSOR(vFILPRJ TT_WOR.FILPRJ%TYPE,
           VSEQPRJ TT_WOR.SEQPRJ%TYPE,
           vCODFUN TT_WOR.CODFUN%TYPE,
           vTIPTAR TT_WOR.TIPTAR%TYPE) IS
     SELECT WOR.CODFIL, WOR.SEQUEN
       FROM TT_WOR WOR INNER JOIN TD_SIT DSIT ON WOR.FLGSIT = DSIT.CODTAB
      WHERE WOR.FILPRJ=vFILPRJ
        and WOR.SEQPRJ=vSEQPRJ
        and WOR.CODFUN=vCODFUN
        AND DSIT.TIPSIT<>'C'
        and WOR.TIPTAR=VTIPTAR;   

  vCODFIL TT_PRJ.CODFIL%TYPE;
  vSEQUEN TT_PRJ.SEQUEN%TYPE;
  vFILIMP TT_PRJ.CODFIL%TYPE;
  vSEQIMP TT_PRJ.SEQUEN%TYPE;  
  vFILN1  TT_PRJ.CODFIL%TYPE;  
  vSEQN1  TT_PRJ.SEQUEN%TYPE;
  vFILWOR TT_WOR.CODFIL%TYPE; 
  vSEQWOR TT_WOR.SEQUEN%TYPE; 
  vTOTHOR TT_WOR.TARPRE%TYPE;
  vTIPTAR TD_CWS.CODTAB%TYPE;
  vTIPCWS TD_CWS.TIPCWS%TYPE;
  vNOMPRJ TT_PRJ.NOMPRJ%TYPE; 
  vFILUSU TT_USU.FILUSU%TYPE;
  vCODUSU TT_USU.CODUSU%TYPE;
  vDCODFUN TD_FUN.CODTAB%TYPE;
  vCOUNT  Numeric;
  vACHOU  BOOLEAN;
  QuemLogou TRetQuemLogou%ROWTYPE;
  
  vComplemento CONSTANT VARCHAR(254):= constante('complemento');

BEGIN  
  select * into QuemLogou from DadosLogon();

  -- Pega CODFIL e SEQUEN do usuario logado
  IF not QuemLogou.Encontrou THEN
    RAISE EXCEPTION 'PG-20001 Voce nao e um usuario cadastrado no sistema %' , vComplemento;
  END IF;
  vFILUSU := QuemLogou.FILUSU;
  vCODUSU := QuemLogou.CODUSU;

  OPEN Implantacao('000');
  vACHOU:=true;
  FETCH Implantacao INTO vFILIMP, vSEQIMP;
  IF NOT FOUND THEN
     vACHOU:=false;
  END IF; 
  CLOSE Implantacao;

  -- No Implantacao
  IF coalesce(NEW.TIPLAN,'X')='I' THEN    
     -- Tratamento no Implantacao
     IF NOT vACHOU THEN 
        -- Se nao ja existe insere 
        SELECT CODLOJ,
                PROXIMOCODIGO('TT_PRJ',CODLOJ) INTO vFILIMP,vSEQIMP
          FROM TT_IDF;     
       INSERT INTO TT_PRJ (CODFIL,SEQUEN,NOMPRJ,DATREG,ATU_EM,FILREG,CODREG,FILATU,CODATU,TIPFUN) VALUES
       (vFILIMP,vSEQIMP,'Implantao',AGORA(),AGORA(),vFILUSU,vCODUSU,vFILUSU,vCODUSU,'000');        
     END IF;        
  ELSE 
     IF NOT vACHOU THEN
        RAISE EXCEPTION 'PG-20002 Nao foi possvel localizar o n principal de "Implantao". %' , vComplemento;
     END IF;
  END IF;

  NEW.CODFUN:=rpad(UPPER(NEW.CODFUN),3,' ');

  OPEN Cliente(NEW.filcli, NEW.codcli, vFILIMP, vSEQIMP);
  vACHOU:=true;
  FETCH Cliente INTO vCODFIL, vSEQUEN;
  IF NOT FOUND THEN
     vACHOU:=false;
  END IF;  
  CLOSE Cliente;

  -- No Principal
  IF coalesce(NEW.TIPLAN,'X')='I' THEN    
     IF NOT vACHOU THEN 
         -- Se nao ja existe insere o no principal do cliente
         SELECT CODLOJ,
               PROXIMOCODIGO('TT_PRJ',CODLOJ) INTO vCODFIL,vSEQUEN
           FROM TT_IDF;
        INSERT INTO TT_PRJ (CODFIL,SEQUEN,FILPAI,SEQPAI,FILCLI,CODCLI,NOMPRJ,DATREG,ATU_EM,FILREG,CODREG,FILATU,CODATU,MSGREQ) VALUES
        (vCODFIL,vSEQUEN,vFILIMP,vSEQIMP,NEW.FILCLI,NEW.CODCLI,NEW.DESFUN,AGORA(),AGORA(),vFILUSU,vCODUSU,vFILUSU,vCODUSU, NEW.MSGREQ);
     END IF;     
  ELSE 
     IF NOT vACHOU THEN
        RAISE EXCEPTION 'PG-20002 Nao foi possvel localizar arvore do cliente %' , vComplemento;
     END IF;
  END IF;

  -- Tratamento SubNiveis
  IF (NEW.TIPLAN is null) or (NEW.TIPLAN='P') THEN    
      OPEN SubNivel(vCODFIL,vSEQUEN,SUBSTR(NEW.CODFUN,1,1)||'  ');
      vACHOU:=true;
      FETCH SubNivel INTO vFILN1, vSEQN1;
      IF NOT FOUND THEN
         vACHOU:=false;
      END IF;
      CLOSE SubNivel;
     -- Tratamento para tiplan P
     IF coalesce(NEW.TIPLAN,'X')='P' THEN
        IF NOT vACHOU THEN            
            -- Se nao existe insere 
            SELECT CODLOJ,
                   PROXIMOCODIGO('TT_PRJ',CODLOJ) INTO vFILN1,vSEQN1
              FROM TT_IDF;     
           INSERT INTO TT_PRJ (CODFIL,SEQUEN,FILPAI,SEQPAI,NOMPRJ,DATREG,ATU_EM,FILREG,CODREG,FILATU,CODATU,MSGREQ,TIPFUN) VALUES
           (vFILN1,vSEQN1,vCODFIL,vSEQUEN,NEW.DESFUN,AGORA(),AGORA(),vFILUSU,vCODUSU,vFILUSU,vCODUSU,NEW.MSGREQ,SUBSTR(NEW.CODFUN,1,1)||'  ');
        END IF;     
     ELSE
        IF NOT vACHOU THEN 
           RAISE EXCEPTION 'PG-20003 Nao foi possvel localizar o No na arvore do cliente%' , vComplemento;
        END IF;
     END IF; 

     -- Tratamento para No folha do projeto
     IF NEW.TIPLAN is null THEN
        SELECT CODTAB,TIPCWS INTO vTIPTAR,vTIPCWS
        FROM TD_CWS CWS
        WHERE CWS.codtab=NEW.TIPCFG;
        SELECT COUNT(*) INTO vCOUNT
        FROM TD_FUN 
        WHERE CODFUN=NEW.CODFUN;
        IF vCOUNT=0 THEN 
           INSERT INTO TD_FUN 
           (CODTAB,FUNATI,DESFUN,CODFUN)
           (SELECT (SELECT MAX(CODTAB)+1 FROM TD_FUN) AS CODTAB,
                   TO_CHAR('T') AS FUNATI,
                   NEW.DESFUN,
                   NEW.CODFUN
              FROM TT_IDF
           );           
        END IF;       
        SELECT CODTAB INTO vDCODFUN
        FROM TD_FUN 
        WHERE CODFUN=NEW.CODFUN;     
        OPEN TarefaCur(vFILN1,vSEQN1,vDCODFUN,vTIPTAR);
        vACHOU:=true;
        FETCH TarefaCur INTO vFILWOR, vSEQWOR;
        IF NOT FOUND THEN
           vACHOU:=false;
        END IF;
        CLOSE TarefaCur;

        -- Tratamento da tarefa
        vTOTHOR := COALESCE(NEW.HORCFG,0)+COALESCE(NEW.HORTRE,0)+COALESCE(NEW.HORMON,0)+COALESCE(NEW.HORADE,0);
        IF vTOTHOR > 0 THEN
           IF vACHOU THEN 
              UPDATE TT_WOR 
                 SET TARPRE=vTOTHOR,
                     COBRAR=vTOTHOR
               WHERE FILPRJ=vFILN1
                 and SEQPRJ=vSEQN1
                 and CODFUN=vDCODFUN
                 AND FLGSIT NOT IN (SELECT CODTAB FROM TD_SIT WHERE TIPSIT = 'C')
                 and TIPTAR=VTIPTAR; 
           ELSE
              vNOMPRJ:=NEW.CODFUN||') '||NEW.DESFUN;     
              insert into tt_wor
                (codfil, sequen, destar, modulo, versao, tiptar, tipcws, flgsit, fatura,
                 tarpre, cobrar, filprj, seqprj, conclu, filres, codres, filtst, codtst, 
                 filcli, codcli, priori, reserv, pricli, codfun, tarefa)
                ( select IDF.CODLOJ AS CODFIL,
                         PROXIMOCODIGO('TT_WOR',IDF.CODLOJ) AS SEQUEN,
                         vNOMPRJ as DESTAR,
                         0 as MODULO,
                         NEW.VERSAO as VERSAO,
                         VTIPTAR AS TIPTAR,
                         vTIPCWS as TIPCWS,
                         (SELECT MIN(CODTAB) FROM TD_SIT WHERE TIPSIT = 'A') AS FLGSIT,
                         TO_CHAR('A') AS FATURA,
                         vTOTHOR AS TARPRE,
                         vTOTHOR AS COBRAR,
                         vFILN1 AS FILPRJ,
                         vSEQN1 AS SEQPRJ,
                         0 AS CONCLU,
                         NEW.FILRES AS FILRES,
                         NEW.CODRES AS CODRES,
                         NEW.FILTST AS FILTST,
                         NEW.CODTST AS CODTST,
                         NEW.FILCLI AS FILCLI,
                         NEW.CODCLI AS CODCLI,
                         2 AS PRIORI,
                         TO_CHAR('F') AS RESERV,
                         2 AS PRICLI,
                         vDCODFUN as CODFUN,
                         NEW.DOCUME AS TAREFA
                    FROM TT_IDF IDF
                );
           END IF;
        ELSE
           IF vACHOU THEN         
              BEGIN                 
                DELETE FROM TT_WOR 
                       WHERE FILPRJ=vFILN1
                         and SEQPRJ=vSEQN1
                         and CODFUN=vDCODFUN
                         and TIPTAR=vTIPTAR; 
              EXCEPTION
                 WHEN OTHERS THEN 
                     UPDATE TT_WOR SET FLGSIT=(SELECT MIN(CODTAB) FROM TD_SIT WHERE TIPSIT = 'C')
                      WHERE FILPRJ=vFILN1
                        and SEQPRJ=vSEQN1
                        and CODFUN=vDCODFUN
                        and FLGSIT NOT IN (SELECT CODTAB FROM TD_SIT WHERE TIPSIT = 'C')
                        and TIPTAR=vTIPTAR; 
              END;
           END IF;
        END IF; 
     END IF;    -- Fim tiplan nulo     
  END IF;       -- Fim tratamento subniveis
  
  
  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5281 --*/
CREATE TRIGGER TGWFUN1
BEFORE INSERT ON TW_FUN 
FOR EACH ROW EXECUTE PROCEDURE TGWFUN1();

/*-- SEQ 5282 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGWFUN2() CASCADE;

/*-- SEQ 5283 --*/
CREATE OR REPLACE FUNCTION TGWFUN2() RETURNS TRIGGER AS $$
BEGIN
  DELETE FROM TW_FUN;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5284 --*/
CREATE TRIGGER TGWFUN2
AFTER INSERT ON TW_FUN 
FOR STATEMENT EXECUTE PROCEDURE TGWFUN2();


/*-- SEQ 5285 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGWFXC() CASCADE;

/*-- SEQ 5286 --*/
CREATE OR REPLACE FUNCTION TGWFXC() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Interface entre Totall Lite e Totall 2000.
--    Ao receber insert atualiza TT_FXC
--
DECLARE
  wk_Linhas      INTEGER;
  vComplemento  VARCHAR(254):= constante('complemento');
BEGIN
  IF (TG_OP = 'UPDATE') THEN
   RAISE EXCEPTION 'PG-20001 Os dados nao podem ser alterados.%' , vComplemento;
  END IF;

  NEW.ULTFAT := COALESCE(NEW.ULTFAT,agora());
    SELECT COUNT(*) INTO wk_Linhas
      FROM TT_FXC
    WHERE FILCLI = NEW.FILCLI
      AND CODCLI = NEW.CODCLI
      AND CODCCC = NEW.CODCCC;

  IF wk_Linhas > 0 THEN
    UPDATE TT_FXC SET ULTFAT = NEW.ULTFAT
    WHERE FILCLI = NEW.FILCLI
      AND CODCLI = NEW.CODCLI
      AND CODCCC = NEW.CODCCC;
  ELSE
    INSERT INTO TT_FXC (FILCLI,CODCLI,CODCCC,ULTFAT)
                VALUES (NEW.FILCLI,NEW.CODCLI,NEW.CODCCC,NEW.ULTFAT);
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5287 --*/
CREATE TRIGGER TGWFXC
BEFORE INSERT OR UPDATE ON TW_FXC 
FOR EACH ROW EXECUTE PROCEDURE TGWFXC();



/*-- SEQ 5288 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGWIIN() CASCADE;

/*-- SEQ 5289 --*/
CREATE OR REPLACE FUNCTION TGWIIN() RETURNS TRIGGER AS $$
DECLARE
-- Select para ler as referencias a ordem de preferencia eh TGA, EAN, PRO
-- Foi utilizado varios OR para que nao precisasse usar funcao, perdendo indice.
cREF CURSOR(pREFPRO TW_IIN.REFPRO%TYPE) IS
	SELECT FILMAT, CODMAT, CODCOR, CODTAM  FROM TT_GRA WHERE REFPRO = pREFPRO UNION ALL
	SELECT FILMAT, CODMAT, CODCOR, CODTAM  FROM TT_GRA WHERE REFPRO = replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') UNION ALL
	SELECT FILMAT, CODMAT, CODCOR, CODTAM  FROM TT_GRA WHERE REFPRO = lpad('0',01,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFPRO = lpad('0',02,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFPRO = lpad('0',03,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFPRO = lpad('0',04,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFPRO = lpad('0',05,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFPRO = lpad('0',06,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFPRO = lpad('0',07,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFPRO = lpad('0',08,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFPRO = lpad('0',09,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFPRO = lpad('0',10,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFPRO = lpad('0',11,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFPRO = lpad('0',12,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFPRO = lpad('0',13,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFPRO = lpad('0',14,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFPRO = lpad('0',15,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFPRO = lpad('0',16,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFPRO = lpad('0',17,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFPRO = lpad('0',18,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFPRO = lpad('0',19,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') UNION ALL
	SELECT FILMAT, CODMAT, CODCOR, CODTAM  FROM TT_EAN WHERE CODEAN = pREFPRO UNION ALL
	SELECT FILMAT, CODMAT, CODCOR, CODTAM  FROM TT_EAN WHERE CODEAN = replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') UNION ALL
	SELECT FILMAT, CODMAT, CODCOR, CODTAM  FROM TT_EAN WHERE CODEAN = lpad('0',01,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 CODEAN = lpad('0',02,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 CODEAN = lpad('0',03,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 CODEAN = lpad('0',04,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 CODEAN = lpad('0',05,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 CODEAN = lpad('0',06,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 CODEAN = lpad('0',07,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 CODEAN = lpad('0',08,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 CODEAN = lpad('0',09,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 CODEAN = lpad('0',10,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 CODEAN = lpad('0',11,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 CODEAN = lpad('0',12,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 CODEAN = lpad('0',13,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 CODEAN = lpad('0',14,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 CODEAN = lpad('0',15,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 CODEAN = lpad('0',16,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 CODEAN = lpad('0',17,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 CODEAN = lpad('0',18,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 CODEAN = lpad('0',19,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') UNION ALL
	SELECT FILMAT, CODMAT, TO_NUMBER(NULL) AS CODCOR, TO_NUMBER(NULL) AS CODTAM  FROM TT_PRO WHERE REFBAS = pREFPRO UNION ALL
	SELECT FILMAT, CODMAT, TO_NUMBER(NULL) AS CODCOR, TO_NUMBER(NULL) AS CODTAM  FROM TT_PRO WHERE REFBAS = replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') UNION ALL
	SELECT FILMAT, CODMAT, TO_NUMBER(NULL) AS CODCOR, TO_NUMBER(NULL) AS CODTAM  FROM TT_PRO 
							   WHERE REFBAS = lpad('0',01,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFBAS = lpad('0',02,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFBAS = lpad('0',03,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFBAS = lpad('0',04,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFBAS = lpad('0',05,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFBAS = lpad('0',06,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFBAS = lpad('0',07,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFBAS = lpad('0',08,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFBAS = lpad('0',09,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFBAS = lpad('0',10,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFBAS = lpad('0',11,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFBAS = lpad('0',12,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFBAS = lpad('0',13,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0') OR
								 REFBAS = lpad('0',14,'0')||replace(ltrim(replace(pREFPRO,'0',' ')),' ','0');


cREF2 CURSOR(pREFPRO TW_IIN.REFPRO%TYPE) IS
	SELECT FILMAT, CODMAT, CODCOR, CODTAM  FROM TT_GRA WHERE REFPRO = pREFPRO UNION ALL
	SELECT FILMAT, CODMAT, CODCOR, CODTAM  FROM TT_EAN WHERE CODEAN = pREFPRO UNION ALL
	SELECT FILMAT, CODMAT, TO_NUMBER(NULL) AS CODCOR, TO_NUMBER(NULL) AS CODTAM  FROM TT_PRO WHERE REFBAS = pREFPRO ;

 vACHOU BOOLEAN;
 vFILMAT TT_GRA.FILMAT%TYPE;
 vCODMAT TT_GRA.CODMAT%TYPE;
 VCODCOR TT_GRA.CODCOR%TYPE;
 vCODTAM TT_GRA.CODTAM%TYPE; 
 vQTD INTEGER;

BEGIN

  IF COALESCE(NEW.ZERESQ,'T') = 'T' THEN

	  OPEN cREF(NEW.REFPRO);
	  vACHOU := TRUE;
	  FETCH cREF INTO vFILMAT, vCODMAT, vCODCOR, vCODTAM;
	  IF NOT FOUND THEN
	     vACHOU := false;
	  END IF;
	  CLOSE cREF;
  ELSE
	  OPEN cREF2(NEW.REFPRO);
	  vACHOU := TRUE;
	  FETCH cREF2 INTO vFILMAT, vCODMAT, vCODCOR, vCODTAM;
	  IF NOT FOUND THEN
	     vACHOU := false;
	  END IF;
	  CLOSE cREF2;

  END IF;



  IF vACHOU = TRUE THEN
     IF vCODCOR IS NOT NULL THEN
       SELECT REFPRO INTO NEW.REFGRA
         FROM TT_GRA 
        WHERE FILMAT = vFILMAT
          AND CODMAT = vCODMAT
          AND CODCOR = vCODCOR
          AND CODTAM = vCODTAM;
      ELSE
         SELECT MIN(REFPRO), COUNT(*) INTO NEW.REFGRA, vQTD
           FROM TT_GRA 
          WHERE FILMAT = vFILMAT
            AND CODMAT = vCODMAT
          GROUP BY FILMAT,CODMAT;
		  
		  IF vQTD > 1 THEN
			NEW.REFGRA := NULL;
		  END IF;
      END IF;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5290 --*/
CREATE TRIGGER TGWIIN
BEFORE INSERT ON TW_IIN 
FOR EACH ROW EXECUTE PROCEDURE TGWIIN();


/*-- SEQ 5291 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGWIVEXIOR() CASCADE;

/*-- SEQ 5292 --*/
CREATE OR REPLACE FUNCTION TGWIVEXIOR() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria

-- Principal
BEGIN
   -- Gera um codigo automaticamente
   IF (TG_OP = 'INSERT') THEN 
      IF NEW.CODTAB IS NULL THEN
       
         SELECT NEXTVAL('SQWIVEXIOR') 
           INTO NEW.CODTAB 
           FROM DUAL;
      END IF;
    
      NEW.DATINC := Agora();
   END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5293 --*/
CREATE TRIGGER TGWIVEXIOR
BEFORE INSERT ON TW_IVEXIOR 
FOR EACH ROW EXECUTE PROCEDURE TGWIVEXIOR();



/*-- SEQ 5294 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGWOR2() CASCADE;

/*-- SEQ 5295 --*/
CREATE OR REPLACE FUNCTION TGWOR2() RETURNS TRIGGER AS $$
DECLARE
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
-- 2) Registrar mudana dos dados num "log"
-- 3) Enviar e-mails TT_MAI

  c_LF              CHAR(2)            := chr(13)||chr(10);
  TEXTOEMAILPADRAO  VARCHAR(10000)    := '';
  TEXTOEMAIL        VARCHAR(10000)    := '';         -- EMAIL EXPLICATIVO...

  VLOG              VARCHAR(4000)     := '';         -- VLOG GERAL
  LOGAUX            VARCHAR(4000)     := '';         -- VLOG AUXILIAR, USADO NA TAREFA, DOCUME E REVISA
  MSGResp           VARCHAR(4000)     := '';         -- TEXTO DO E-MAIL
  MSGRev            VARCHAR(4000)     := '';         -- TEXTO DO E-MAIL
  MSGReg            VARCHAR(4000)     := '';         -- TEXTO DO E-MAIL
  cOld              VARCHAR(400)      := '';         -- VALOR ANTIGO
  cNew              VARCHAR(400)      := '';         -- VALOR NOVO
  Assunto           VARCHAR(300)      := '';         -- ASSUNTO DO E-MAIL
  PegaCopia         VARCHAR(4000)     := '';         -- AUXILIAR NAS CPIAS DO E-MAIL
  MailCopia         VARCHAR(4000)     := '';         -- GUARDA CPIAS DO E-MAIL
  ContaReg          Numeric(10)         := null;         -- Usado pro caso de retornar sem registo as select
  filial            TT_USU.FILUSU%TYPE;               -- Usado Para pegar o e-mail do usurio
  usuario           TT_USU.CODUSU%TYPE;               -- Usado Para pegar o e-mail do usurio
  E_MailLogon       VARCHAR(300)      := '';         -- Usado para pegar o Usurio logado
  
  cSITORI           TD_SIT.TIPSIT%TYPE; -- davi - 41196 - 22/05/06
  cSITDES           TD_SIT.TIPSIT%TYPE; -- davi - 41196 - 22/05/06
  cSITMAI           TD_SIT.SITMAI%TYPE;
  cFILGERMOD        TD_MOD.FILINT%TYPE; -- davi - 41190 - 23/05/06
  cCODGERMOD        TD_MOD.CODINT%TYPE; -- davi - 41190 - 23/05/06 
  cTIPAVA           TT_AVA.AVALIA%TYPE; 
  cFILADO           TT_USU.CODUSU%TYPE; -- davi - 41190 - 25/05/06 
  cCODADO           TT_USU.CODUSU%TYPE; -- davi - 41190 - 25/05/06 
  QuemLogou TRetQuemLogou;

  cData  CHAR(21)    := 'DD/MM/YYYY HH24:MI:SS'; -- FORMATO DE DATA USADA NAS CONVERSES

  vComplemento CONSTANT VARCHAR(254):= constante('complemento');
  
  vDummy VARCHAR(20);
  
  wk_Status TT_PRJ.STATUS%TYPE;  
  
  vValida BOOLEAN; 
  
  vGERENTE CHAR(1);

  vUSER VARCHAR(100);
    
-- Principal
BEGIN

  IF (NOT (TG_OP = 'DELETE')) THEN           
	 NEW.MINPRE:=nvlz(NEW.MINPRE,NEW.TARPRE);
	 NEW.MAXPRE:=nvlz(NEW.MAXPRE,NEW.TARPRE);
  END IF;

  -- Pega o Usuario Logado
  SELECT GetApeUsuAtual() INTO vUSER
    FROM DUAL;

  -- Pegando o E_mail do usurio Logado!!
  select * into QuemLogou from DadosLogon();
  IF QuemLogou.Encontrou THEN
     filial:=QuemLogou.filusu;
     usuario:=QuemLogou.codusu;
     E_mailLogon := PegaE_Mail(Filial,Usuario);
  ELSE
     RAISE EXCEPTION 'PG-20037 Voce nao e um usuario cadastrado no sistema. %' , VComplemento;
  END IF;
  
  IF (NOT (TG_OP = 'DELETE')) AND (NEW.DUMMY IS NULL ) THEN           
     
      IF (TG_OP = 'INSERT') THEN
        -- Se tem permissao para registrar tarefa
        IF ChecaPermissao(NEW.FILPRJ,NEW.SEQPRJ,filial,usuario,CONSTANTE('wf_registrar_tarefa')) = '1' THEN
           -- Se eh gerente de projeto
           IF ChecaPermissao(NEW.FILPRJ,NEW.SEQPRJ,filial,usuario,CONSTANTE('wf_gerenciar')) = '1' THEN 
              -- Nao permitir registrar tarefa para responavel que nao pode ler a mesma
              IF ChecaPermissao(NEW.FILPRJ,NEW.SEQPRJ,NEW.FILRES,NEW.CODRES,CONSTANTE('wf_ler_projeto')) = '0' THEN
                 RAISE EXCEPTION 'PG-20038 Usuario responsavel nao tem permissao para ler neste projeto. %' , VComplemento;
              END IF;
           -- Se nao eh gerente de projeto
           ELSE
              -- Se nao eh gerente de projeto somente pode registrar para ele mesmo
              IF ((NEW.FILRES<>filial) or (NEW.CODRES<>usuario)) and 
                 (vUser<>qualdono()) THEN
                 RAISE EXCEPTION 'PG-20039 Usuario nao pode registrar tarefa para outro responsavel. %' , VComplemento;
              END IF;                 
           END IF;           
        -- Se nao tem permissao para registrar tarefa
        ELSE    
          RAISE EXCEPTION 'PG-20040 Usuario nao pode registrar tarefa. %' , VComplemento;
        END IF;  
	-- davi - 41196 - 22/05/06
	IF NEW.FLGSIT IS NULL THEN
          SELECT CODTAB INTO NEW.FLGSIT FROM TD_SIT WHERE TIPSIT = 'R';
	END IF;
      END IF;
    
      -- Verificando se o usurio pode ser responsvel pela tarefa
      vValida:=false;
      IF (TG_OP = 'INSERT') THEN
         vValida:=true;
      END IF;
            
      IF (TG_OP = 'UPDATE') THEN 
        IF ((Equal(OLD.FILRES,NEW.FILRES) = 0 OR Equal(OLD.CODRES,NEW.CODRES) = 0)  OR
            (Equal(OLD.FILPRJ,NEW.FILPRJ) = 0 OR Equal(OLD.SEQPRJ,NEW.SEQPRJ) = 0)) THEN
            vValida:=true;
        END IF;
      END IF;
      
      IF vValida THEN
        IF ChecaPermissao(NEW.FILPRJ,NEW.SEQPRJ,NEW.FILRES,NEW.CODRES,CONSTANTE('wf_responsavel')) = '0' then
          RAISE EXCEPTION 'PG-20041 Usuario nao pode ser responsvel pela tarefa. %' , VComplemento;
        END IF;  
      END IF;   
      
      -- Verificando se o usurio pode ser responsvel pela tarefa
      vValida:=false;
      IF (TG_OP = 'INSERT') THEN
         vValida:=true;
      END IF;
            
      IF (TG_OP = 'UPDATE') THEN 
        IF (Equal(OLD.FILTST,NEW.FILTST) = 0 OR Equal(OLD.CODTST,NEW.CODTST) = 0) THEN
           vValida:=true;
        END IF;
      END IF;
      
      -- Verificando se o usurio pode revisar a tarefa
      IF vValida THEN
        IF ChecaPermissao(NEW.FILPRJ,NEW.SEQPRJ,NEW.FILTST,NEW.CODTST,CONSTANTE('wf_revisor')) = '0' then
          RAISE EXCEPTION 'PG-20042 Usuario nao pode revisar tarefa. %' , VComplemento;
        END IF;  
      END IF;
    
      -- Verificando se o projeto ainda aceita tarefas
      IF ((TG_OP = 'INSERT') OR (TG_OP = 'UPDATE')) THEN

	IF (TG_OP = 'INSERT') THEN 
          SELECT STATUS INTO wk_Status 
            FROM TT_PRJ 
           WHERE CODFIL = NEW.FILPRJ 
             AND SEQUEN = NEW.SEQPRJ;
      	
          IF wk_Status = 'F' THEN
             RAISE EXCEPTION 'PG-20043 O projeto nao aceita mais tarefas. %' , VComplemento;
          END IF;  
        END IF;

        -- Quando concluda a tarefa est executada e vice-versa!!!
        SELECT TIPSIT INTO cSITDES FROM TD_SIT WHERE CODTAB = NEW.FLGSIT; -- davi - 41196 - 22/05/06  
       
        -- davi - 41196 - 22/05/06 - NEW.flgest => cSITORI
        IF (cSITDES in ('X','I')) AND (NEW.CONCLU <> 100) THEN
           IF (TG_OP = 'UPDATE') THEN 
	      SELECT TIPSIT INTO cSITORI FROM TD_SIT WHERE CODTAB = OLD.FLGSIT;
              IF (cSITORI not in ('X','I')) THEN
                 NEW.CONCLU := 100;    
              END IF;
           ELSE
             NEW.CONCLU := 100;
           END IF;
        END IF;

        IF (NEW.CONCLU = 100) AND (cSITDES = 'A') THEN
          NEW.CONCLU := 0;
        END IF;        
      END IF;    
     
      -- davi - 41200 - 22/05/06
      IF (TG_OP = 'UPDATE') THEN
        IF Equal(OLD.FLGSIT,NEW.FLGSIT) <> 1 THEN
   	  --davi - 49570 - 31/10/06
          IF (cSITORI = 'A') AND 
	     (cSITDES = 'X') AND 
  	     (NEW.PERFIL = 'P') THEN 
	     NEW.REVISA := Questionario(NEW.FILCLI, NEW.CODCLI, NEW.DATREG, NEW.ATU_EM);
          END IF;
          IF ValidaFluxoWorkflow(OLD.FLGSIT,NEW.FLGSIT) = 'F' THEN
             RAISE EXCEPTION 'PG-20073 Status de destino invalido. %' , VComplemento;
	  ELSE
            -- davi - 41190 - 23/05/06
	    IF ISNULL(TRIM(TO_CHAR(NEW.NOTAVA))) = 'T' THEN
              NEW.NOTAVA := NULL;
	    END IF;
	    IF ISNULL(TO_CHAR(NEW.NOTAVA)) = 'F' THEN

              -- gerente (integrador) do modulo
                              SELECT FILINT, CODINT INTO cFILGERMOD, cCODGERMOD FROM TD_MOD WHERE CODTAB = NEW.MODULO;
              
              IF AvaliacaoTarefa(OLD.FLGSIT,
	                         OLD.FILREG,OLD.CODREG,OLD.FILRES,OLD.CODRES,OLD.FILTST,OLD.CODTST,
		                 cFILGERMOD,cCODGERMOD) = 'F' THEN
	
  	         RAISE EXCEPTION 'PG-20077 Usuario nao tem permissao para dar nota para o fluxo. %' , VComplemento;                 
	      ELSE
                SELECT TIPADO INTO cTIPAVA FROM TD_SIT WHERE CODTAB = OLD.FLGSIT;

                IF cTIPAVA = '1' THEN
   		   cFILADO := OLD.FILTST;
		   cCODADO := OLD.CODTST; 
                END IF;
		IF cTIPAVA = '2' THEN 
 		   cFILADO := OLD.FILREG;
		   cCODADO := OLD.CODREG; 
		END IF;
   		IF cTIPAVA = '3' THEN 
 		   cFILADO := OLD.FILRES;
		   cCODADO := OLD.CODRES; 
		END IF;
   		IF cTIPAVA = '4' THEN 
 		   cFILADO := cFILGERMOD;
		   cCODADO := cCODGERMOD;   
                END IF;

                -- insere na tt_ava     
		INSERT INTO TT_AVA (FILWOR,SEQWOR,FILAVA,CODAVA,FILADO,CODADO,AVALIA,NOTAVA)
                            VALUES (NEW.CODFIL,NEW.SEQUEN,filial,usuario,cFILADO,cCODADO,cTIPAVA,NEW.NOTAVA);                      

	      END IF;
            END IF;
  	  END IF;
	END IF;
      END IF;
            
      IF NOT (TG_OP = 'DELETE') THEN 	
	IF ISNULL(TRIM(TO_CHAR(NEW.NOTAVA))) = 'F' THEN
          NEW.NOTAVA := NULL;
	END IF;
      END IF;

      IF (TG_OP = 'UPDATE') THEN    
      
        -- Permite alteracao se o usuario eh gerente do projeto.
        IF (ChecaPermissao(NEW.FILPRJ,NEW.SEQPRJ,filial,usuario,CONSTANTE('wf_gerenciar')) = '0' ) then
            -- verificacao de responsavel
            IF Equal(OLD.FILRES,NEW.FILRES) <> 1 OR 
               Equal(OLD.CODRES,NEW.CODRES) <> 1 THEN           
                 RAISE EXCEPTION 'PG-20044 Usuario nao pode alterar o responsavel da tarefa.%' , VComplemento;
            END IF;
        END IF;
        -- Permite alteracao se o usuario eh gerente do projeto ou criou a tarefa e eh responsavel.
        IF (ChecaPermissao(NEW.FILPRJ,NEW.SEQPRJ,filial,usuario,CONSTANTE('wf_gerenciar')) = '0' ) and
           (NEW.FILRES<>filial or NEW.CODRES<>usuario or
            NEW.FILREG<>filial or NEW.CODREG<>usuario or
            ChecaPermissao(NEW.FILPRJ,NEW.SEQPRJ,filial,usuario,CONSTANTE('wf_registrar_tarefa')) = '0' ) then      
            -- verificacao horas previstas
            IF Equal(OLD.TARPRE,NEW.TARPRE) <> 1 THEN             
                RAISE EXCEPTION 'PG-20045 Usuario nao pode alterar as horas previstas para a tarefa. %' , VComplemento;
            END IF;
            
			-- verificacao horas mnimas previstas
			IF Equal(OLD.MINPRE,NEW.MINPRE) <> 1 THEN             
                RAISE EXCEPTION 'PG-20045 Usuario nao pode alterar as horas previstas para a tarefa. %' , VComplemento;
            END IF;
			
			-- verificacao horas mximas previstas
			IF Equal(OLD.MAXPRE,NEW.MAXPRE) <> 1 THEN             
                RAISE EXCEPTION 'PG-20045 Usuario nao pode alterar as horas previstas para a tarefa. %' , VComplemento;
            END IF;
			
            -- verificacao horas previstas para revisao
            IF Equal(OLD.TSTPRE,NEW.TSTPRE) <> 1 THEN
                RAISE EXCEPTION 'PG-20046 Usuario nao pode alterar as horas previstas para a revisao. %' , VComplemento;
            END IF;
            
            -- verificacao data fixa
            IF Equal(OLD.DATFIX,NEW.DATFIX) <> 1 THEN        
                RAISE EXCEPTION 'PG-20047 Usuario nao pode alterar a data fixa da tarefa. %' , VComplemento;
            END IF;    
            
            -- verificacao data prometida
            IF Equal(OLD.DATPRO,NEW.DATPRO) <> 1 THEN
                RAISE EXCEPTION 'PG-20048 Usuario nao pode alterar a data prometida da tarefa. %' , VComplemento;
            END IF;             
             
            -- verificacao prioridade
            IF Equal(OLD.PRIORI,NEW.PRIORI) <> 1 THEN
                RAISE EXCEPTION 'PG-20049 Usuario nao pode alterar a prioridade da tarefa. %' , VComplemento;
            END IF;                     
             
            -- verificacao mao de obra
            IF Equal(OLD.TIPMAO,NEW.TIPMAO) <> 1 THEN
                RAISE EXCEPTION 'PG-20050 Usuario nao pode alterar o tipo de mo de obra da tarefa. %' , VComplemento;
            END IF;
             
            -- verificacao de complexidade
            IF Equal(OLD.CODFPA,NEW.CODFPA) <> 1 THEN
                RAISE EXCEPTION 'PG-20051 Usuario nao pode alterar a complexidade da tarefa. %' , VComplemento;
            END IF;     
             
            -- verificacao de cobranca
            IF Equal(OLD.FATURA,NEW.FATURA) <> 1 THEN
                RAISE EXCEPTION 'PG-20052 Usuario nao pode alterar o tipo de cobranca da tarefa. %' , VComplemento;
            END IF;     
                     
            -- verificacao de reserva
            IF Equal(OLD.RESERV,NEW.RESERV) <> 1 THEN
                RAISE EXCEPTION 'PG-20053 Usuario nao pode alterar o status de reserva da tarefa. %' , VComplemento;
            END IF;    
                     
            -- verificacao de horas cobradas
            IF Equal(OLD.COBRAR,NEW.COBRAR) <> 1 THEN
                RAISE EXCEPTION 'PG-20054 Usuario nao pode alterar as horas cobradas da tarefa. %' , VComplemento;
            END IF;                  
             
            -- verificacao de cliente
            IF Equal(OLD.FILCLI,NEW.FILCLI) <> 1 OR
               Equal(OLD.CODCLI,NEW.CODCLI) <> 1 THEN
                 RAISE EXCEPTION 'PG-20055 Usuario nao pode alterar o cliente da tarefa. %' , VComplemento;
            END IF;        
            
            -- verificacao de modulo
            IF Equal(OLD.MODULO,NEW.MODULO) <> 1 THEN
                 RAISE EXCEPTION 'PG-20056 Usuario nao pode alterar o modulo da tarefa. %' , VComplemento;
            END IF;
            
            -- verificacao de versao
            IF Equal(OLD.VERSAO,NEW.VERSAO) <> 1 THEN
                 RAISE EXCEPTION 'PG-20057 Usuario nao pode alterar a versao da tarefa. %' , VComplemento;
            END IF;
            
            -- verificacao de tipo da tarefa
            IF Equal(OLD.TIPTAR,NEW.TIPTAR) <> 1 OR 
               Equal(OLD.TIPCWS,NEW.TIPCWS) <> 1 THEN
                 RAISE EXCEPTION 'PG-20058 Usuario nao pode alterar a tipo da tarefa. %' , VComplemento;
            END IF;
            
            -- verificacao de classificacao
            IF Equal(OLD.CLATAR,NEW.CLATAR) <> 1 THEN
                 RAISE EXCEPTION 'PG-20059 Usuario nao pode alterar a classificacao da tarefa. %' , VComplemento;
            END IF;
    
            -- verificacao de revisor
            IF Equal(OLD.FILTST,NEW.FILTST) <> 1 OR 
               Equal(OLD.CODTST,NEW.CODTST) <> 1 THEN           
                 RAISE EXCEPTION 'PG-20060 Usuario nao pode alterar o revisor da tarefa.%' , VComplemento;
            END IF;
            
            -- verificacao de prioridade do cliente
            IF Equal(OLD.PRICLI,NEW.PRICLI) <> 1 THEN           
                 RAISE EXCEPTION 'PG-20061 Usuario nao pode alterar a prioridade do cliente da tarefa.%' , VComplemento;
            END IF;
            
            -- verificacao de notificar
            IF Equal(OLD.AVISAR,NEW.AVISAR) <> 1 THEN           
                 RAISE EXCEPTION 'PG-20062 Usuario nao pode alterar a notificacao da tarefa.%' , VComplemento;
            END IF;
            
            -- verificacao de funcionalidade
            IF Equal(OLD.CODFUN,NEW.CODFUN) <> 1 THEN           
                 RAISE EXCEPTION 'PG-20063 Usuario nao pode alterar a funcionalidade da tarefa.%' , VComplemento;
            END IF;
        
        END IF; -- fim ChecaPermissao Gerenciar           
        
        -- verificacao de projeto
        IF Equal(OLD.FILPRJ,NEW.FILPRJ) <> 1 OR 
           Equal(OLD.SEQPRJ,NEW.SEQPRJ) <> 1 THEN
           -- Neste caso eh old no FILPR e SEQPRJ pois esta verificando se tinha permisso para alterar a tarefa no projeto anterior
           IF ChecaPermissao(OLD.FILPRJ,OLD.SEQPRJ,filial,usuario,CONSTANTE('wf_gerenciar')) = '0' then
             RAISE EXCEPTION 'PG-20064 Usuario nao pode alterar o projeto da tarefa.%' , VComplemento;
           END IF;   
        END IF;        
        
        -- verificacao de inicio e fim de projecao 
        IF Equal(OLD.INIPRT,NEW.INIPRT) <> 1 OR
           Equal(OLD.FIMPRT,NEW.FIMPRT) <> 1 THEN           
          
           IF (ChecaPermissao(NEW.FILPRJ,NEW.SEQPRJ,filial,usuario,CONSTANTE('wf_projetar')) = '0') then
             RAISE EXCEPTION 'PG-20065 Usuario nao pode alterar as datas de inicio e fim de projecao. %' , VComplemento;
           END IF;   
        END IF;  
        
        -- verificacao de inicio e fim de planejamento
        IF Equal(OLD.INIPLT,NEW.INIPLT) <> 1 OR
           Equal(OLD.FIMPLT,NEW.FIMPLT) <> 1 THEN           
          
           IF (ChecaPermissao(NEW.FILPRJ,NEW.SEQPRJ,filial,usuario,CONSTANTE('wf_planejar')) = '0') then
             RAISE EXCEPTION 'PG-20066 Usuario nao pode alterar as datas de inicio e fim de planejamento. %' , VComplemento;
           END IF;   
        END IF;  
        
      END IF;   
      
      IF ((TG_OP = 'INSERT') OR (TG_OP = 'UPDATE')) THEN

	SELECT TIPSIT INTO cSITDES FROM TD_SIT WHERE CODTAB = NEW.FLGSIT;  -- davi - 41196 - 22/05/06

        IF (TG_OP = 'UPDATE') THEN     
            -- Mantem a quantidade de horas da primeira reprovao
            -- davi - 41196 - 22/05/06 NEW.flgest => cSITORI
            IF (OLD.HORERR IS NULL) AND (cSITDES = '2') THEN 
              NEW.HORERR := OLD.TARREA;
            ELSE 
              IF (Equal(NEW.HORERR,OLD.HORERR) <> 1)  AND (vUser <> qualdono() AND Permissao(vUser,276) <> 1) THEN 
                NEW.HORERR := OLD.HORERR; 
              END IF;
            END IF;   
        END IF;


        vValida:=false;
        IF (TG_OP = 'INSERT') THEN
           vValida:=true;
        END IF;
              
        IF (TG_OP = 'UPDATE') THEN 
          SELECT TIPSIT INTO cSITORI FROM TD_SIT WHERE CODTAB = OLD.FLGSIT;  -- davi - 41196 - 22/05/06
          -- davi - 41196 - 22/05/06 - OLD.flgest => cSITORI
          IF (cSITORI <> '2') THEN
             vValida:=true;
          END IF;
        END IF;
        
        -- Incrementa a quantidade de vezes que a tarefa foi reprovada
        -- davi - 41196 - 22/05/06 - NEW.flgest => cSITDES
        IF vValida AND (cSITDES = '2') THEN
          NEW.QTDERR := COALESCE(OLD.QTDERR,0) + 1; 
        ELSE 
          IF ((TG_OP = 'UPDATE')) AND (vUser <> qualdono() AND Permissao(vUser,276) <> 1) THEN
              IF (Equal(NEW.QTDERR,OLD.QTDERR) <> 1) THEN
                NEW.QTDERR := OLD.QTDERR; 
              END IF;
          END IF;
        END IF; 
      END IF;     

      SELECT TIPSIT INTO cSITDES FROM TD_SIT WHERE CODTAB = NEW.FLGSIT; -- davi - 41196 - 22/05/06

      -- davi - 41196 - 22/05/06 - NEW.flgest => cSITDES
      TextoEmailPadrao := MontaEmail(NEW.CODFIL,NEW.SEQUEN,cSITDES,NEW.TARPRE,NEW.TSTPRE,NEW.FILREG,
                                     NEW.CODREG,NEW.FILTST,NEW.CODTST,NEW.FILRES,NEW.CODRES,NEW.MODULO,
                                     NEW.TIPTAR,NEW.FILCLI,NEW.CODCLI,NEW.FILPRJ,NEW.SEQPRJ,NEW.PRICLI,
                                     NEW.DESTAR,NEW.PRIORI,NEW.VERSAO,NEW.INIPRT,NEW.INIPRR,NEW.DATPRO,
                                     null,null);
    
      IF (TG_OP = 'UPDATE') THEN
        IF Equal(TO_CHAR(OLD.DATREG,cData),TO_CHAR(NEW.DATREG,cData)) = 0 THEN
        --IF (COALESCE(TO_CHAR(OLD.DATREG,cData),'Nulo') <> COALESCE(TO_CHAR(NEW.DATREG,cData),'Nulo')) THEN
          NEW.DATREG := OLD.DATREG;
        END IF;
    
      --  IF ((COALESCE(OLD.FILREG,'Nulo') <> COALESCE(NEW.FILREG,'Nulo')) OR (COALESCE(OLD.CODREG,'Nulo') <> COALESCE(NEW.CODREG,'Nulo'))) THEN
      --     NEW.FILREG := OLD.FILREG;
      --    NEW.CODREG := OLD.CODREG;
      --  END IF;
        IF Equal(OLD.VERSAO,NEW.VERSAO) = 0 THEN
        --IF (COALESCE(OLD.VERSAO,'Nulo') <> COALESCE(NEW.VERSAO,'Nulo')) THEN
          NEW.VERSAO := Upper(NEW.VERSAO);
        END IF;
        NEW.ATU_EM := agora();
      ELSIF (TG_OP = 'INSERT') THEN
        NEW.datreg := agora();
        NEW.ATU_EM := agora();
        NEW.FILREG := Filial;
        NEW.CODREG := Usuario;
        NEW.VERSAO := Upper(NEW.VERSAO);
        -- Joga o prximo cdigo no sequen
        IF isnull(trim(NEW.SEQUEN))='T' THEN
          NEW.SEQUEN:=ProximoCodigo('TT_WOR',NEW.CODFIL);
        END IF;
    
        -- Manda um e-mail para o responsvel com a nova tarefa!!
        IF ISNOTNULL(NEW.FILRES) = 'T' THEN
        --IF (NEW.FILRES IS NOT NULL) THEN
          select APEUSU into cNew from TT_USU where FILUSU = NEW.FILRES AND CODUSU = NEW.CODRES;
          SELECT REPLACE(TextoEmailPadrao,'***MSG***','') INTO TEXTOEMAIL FROM DUAL;
          vDummy:=Lanca_Mail(NEW.codfil,NEW.sequen,'T','',PegaE_Mail(NEW.FILRES,NEW.CODRES),'','',E_mailLogon,TEXTOEMAIL,'',NEW.avisar);
        END IF;
      END IF;
    
      -- Quando concluda a tarefa est executada e vice-versa!!!
      SELECT TIPSIT INTO cSITDES FROM TD_SIT WHERE CODTAB = NEW.FLGSIT; -- davi - 41196 - 22/05/06
     
      -- davi - 41196 - 22/05/06 - NEW.flgest => cSITDES
      IF (cSITDES in ('X','I')) AND (NEW.CONCLU <> 100) THEN
         IF (TG_OP = 'UPDATE') THEN 
	    SELECT TIPSIT INTO cSITORI FROM TD_SIT WHERE CODTAB = OLD.FLGSIT;
            IF (cSITORI not in ('X','I')) THEN
               NEW.CONCLU := 100;    
            END IF;
         ELSE
           NEW.CONCLU := 100;
         END IF;
      END IF;
      
      IF (NEW.CONCLU = 100) AND (cSITDES = 'A') THEN
        NEW.CONCLU := 0;
      END IF;
    
      IF (TG_OP = 'UPDATE') THEN
        MSGResp := '';
        MSGRev  := '';
        
	-- davi - 41196 - 22/05/06
	SELECT TIPSIT INTO cSITDES FROM TD_SIT WHERE CODTAB = NEW.FLGSIT;
        SELECT TIPSIT INTO cSITORI FROM TD_SIT WHERE CODTAB = OLD.FLGSIT;    

        -- Caso o OLD <> NEW ento gera o VLOG!!
        IF (OLD.MODULO <> NEW.MODULO) THEN
          select COALESCE(MIN(MODULO),'Nulo') into cOld from TD_MOD where CODTAB = OLD.MODULO ;
          select COALESCE(MIN(MODULO),'Nulo') into cNew from TD_MOD where CODTAB = NEW.MODULO ;
          VLOG := VLOG||'Modulo: de '||cOld||' para '||cNew||c_LF;
        END IF;
    
        IF Equal(OLD.VERSAO,NEW.VERSAO) = 0 THEN
        --IF (COALESCE(OLD.VERSAO,'Nulo') <> COALESCE(NEW.VERSAO,'Nulo')) THEN
          VLOG := VLOG||'Verso: de '||COALESCE(OLD.VERSAO,'Nulo')||' para '||COALESCE(NEW.VERSAO,'Nulo')||c_LF;
        END IF;
    
        IF Equal(OLD.TIPTAR,NEW.TIPTAR) = 0 THEN
        --IF (COALESCE(TO_CHAR(OLD.TIPTAR),'') <> COALESCE(TO_CHAR(NEW.TIPTAR),'')) THEN
          select COALESCE(MIN(DESCWS),'Nulo') into cOld from TD_CWS where CODTAB = OLD.TIPTAR;
          select COALESCE(MIN(DESCWS),'Nulo') into cNew from TD_CWS where CODTAB = NEW.TIPTAR;
          VLOG := VLOG||'Tipo de tarefa : de '||cOld||' para '||cNew||c_LF;
        END IF;
    
        IF Equal(OLD.FATURA,NEW.FATURA) = 0 THEN
        --IF (COALESCE(OLD.FATURA,'Nulo') <> COALESCE(NEW.FATURA,'Nulo')) THEN
          select CASE OLD.FATURA WHEN 'A' THEN 'A Faturar'
                                  WHEN 'C' THEN 'Contrato'
                                  WHEN 'S' THEN 'Cortesia'
                                  WHEN 'F' THEN 'Faturado'
                                  WHEN 'D' THEN 'A Definir'
                                                      ELSE 'Nulo'
                 END into cOld from dual;
          select CASE NEW.FATURA WHEN 'A' THEN 'A Faturar'
                                  WHEN 'C' THEN 'Contrato'
                                  WHEN 'S' THEN 'Cortesia'
                                  WHEN 'F' THEN 'Faturado'
                                  WHEN 'D' THEN 'A Definir'
                                                      ELSE 'Nulo'
                 END into cNew from dual;
          VLOG := VLOG||'Situacao de Cobrana: de '||cOld||' para '||cNew||c_LF;
        END IF;
    
        IF (Equal(OLD.FILRES,NEW.FILRES) = 0) OR (Equal(OLD.CODRES,NEW.CODRES) = 0) THEN
        --IF ((COALESCE(OLD.FILRES,'Nulo') <> COALESCE(NEW.FILRES,'Nulo')) OR (COALESCE(OLD.CODRES,'Nulo') <> COALESCE(NEW.CODRES,'Nulo'))) THEN
          select COALESCE(MIN(APEUSU),'Nulo') into cOld from TT_USU where FILUSU = OLD.FILRES AND CODUSU = OLD.CODRES;
          select COALESCE(MIN(APEUSU),'Nulo') into cNew from TT_USU where FILUSU = NEW.FILRES AND CODUSU = NEW.CODRES;
          VLOG := VLOG||'Responsavel: de '||cOld||' para '||cNew||c_LF;
          -- Enviando e-mail para o antigo responsavel;
          IF (ISNOTNULL(OLD.FILRES) = 'T') AND (cSITDES = 'A') THEN
           --IF (OLD.FILRES IS NOT NULL) AND (cSITDES = 'A') THEN
            SELECT REPLACE(TEXTOEMAILPADRAO,'***MSG***','Voc no  mais o responsvel por esta tarefa.') INTO TEXTOEMAIL FROM DUAL;
            vDummy:=Lanca_Mail(NEW.codfil,NEW.sequen,'T','',PegaE_Mail(OLD.FILRES,OLD.CODRES),'','',E_mailLogon,TEXTOEMAIL,VLOG,NEW.avisar);
          END IF;
           -- Enviando e-mail separado informando que a Tarefa foi modificada
          IF (ISNOTNULL(NEW.FILRES) = 'T') AND (cSITDES = 'A') THEN 
          --IF (NEW.FILRES IS NOT NULL) AND (cSITDES = 'A') THEN
            MSGResp := MSGResp || 'Alterao de Responsvel. Nova tarefa para voc.'||c_lf;
          END IF;
        END IF;
        
        -- Paulo  - 65034 - 16/10/2008
        IF (Equal(OLD.FILREG,NEW.FILREG) = 0) OR (Equal(OLD.CODREG,NEW.CODREG) = 0) THEN
        --IF ((COALESCE(OLD.FILREG,'Nulo') <> COALESCE(NEW.FILREG,'Nulo')) OR (COALESCE(OLD.CODREG,'Nulo') <> COALESCE(NEW.CODREG,'Nulo'))) THEN
          select COALESCE(MIN(APEUSU),'Nulo') into cOld from TT_USU where FILUSU = OLD.FILREG AND CODUSU = OLD.CODREG;
          select COALESCE(MIN(APEUSU),'Nulo') into cNew from TT_USU where FILUSU = NEW.FILREG AND CODUSU = NEW.CODREG;
          VLOG := VLOG||'Registrador: de '||cOld||' para '||cNew||c_LF;
          -- Enviando e-mail para o antigo Registrador;
          IF (ISNOTNULL(OLD.FILREG) = 'T') AND (cSITDES = 'A') THEN
          --IF (OLD.FILREG IS NOT NULL) AND (cSITDES = 'A') THEN
            SELECT REPLACE(TEXTOEMAILPADRAO,'***MSG***','Voc no  mais o usurio registrador desta tarefa.') INTO TEXTOEMAIL FROM DUAL;
            vDummy:=Lanca_Mail(NEW.codfil,NEW.sequen,'T','',PegaE_Mail(OLD.FILREG,OLD.CODREG),'','',E_mailLogon,TEXTOEMAIL,VLOG,NEW.avisar);
          END IF;
           -- Enviando e-mail separado informando que a Tarefa foi modificada
          IF (ISNOTNULL(NEW.FILREG) = 'T') AND (cSITDES = 'A') THEN
           --IF (NEW.FILREG IS NOT NULL) AND (cSITDES = 'A') THEN
            MSGResp := MSGResp || 'Alterao de Registrador.'||c_lf;
          END IF;
        END IF;
    
        IF (Equal(OLD.FILTST,NEW.FILTST) = 0) OR (Equal(OLD.CODTST,NEW.CODTST) = 0) THEN
        --IF ((COALESCE(OLD.FILTST,'Nulo') <> COALESCE(NEW.FILTST,'Nulo')) OR (COALESCE(OLD.CODTST,'Nulo') <> COALESCE(NEW.CODTST,'Nulo'))) THEN
          select COALESCE(MIN(APEUSU),'Nulo') into cOld from TT_USU where FILUSU = OLD.FILTST AND CODUSU = OLD.CODTST;
          select COALESCE(MIN(APEUSU),'Nulo') into cNew from TT_USU where FILUSU = NEW.FILTST AND CODUSU = NEW.CODTST;
          VLOG := VLOG||'Revisor: de '||cOld||' para '||cNew||c_LF;
          IF (ISNOTNULL(OLD.FILTST) = 'T') AND (cSITDES = 'X') THEN
           --IF (OLD.FILTST IS NOT NULL) AND (cSITDES = 'X') THEN
            SELECT REPLACE(TEXTOEMAILPADRAO,'***MSG***','Voc no  mais o revisor desta tarefa.') INTO TEXTOEMAIL FROM DUAL;
            vDummy:=Lanca_Mail(NEW.codfil,NEW.sequen,'T','',PegaE_Mail(OLD.FILTST,OLD.CODTST),'','',E_mailLogon,TEXTOEMAIL,VLOG,NEW.avisar);
          END IF;
          -- Enviando e-mail separado informando que a Tarefa foi modificada
          IF (ISNOTNULL(NEW.FILRES) = 'T') AND (cSITDES = 'X') THEN
           --IF (NEW.FILRES IS NOT NULL) AND (cSITDES = 'X') THEN
            MSGRev := MSGRev || 'Alterao de Revisor. Nova reviso para voc.'||c_lf;
          END IF;
        END IF;
    
        IF (Equal(OLD.DESTAR,NEW.DESTAR) = 0) THEN
        --IF (COALESCE(OLD.DESTAR,'Nulo') <> COALESCE(NEW.DESTAR,'Nulo')) THEN
          VLOG := VLOG||'Ttulo da Tarefa: de "'||COALESCE(OLD.DESTAR,'Nulo')||'" para "'||COALESCE(NEW.DESTAR,'Nulo')||'"'||c_LF;
        END IF;
    
        IF (Equal(OLD.TAREFA,NEW.TAREFA) = 0) THEN
        --IF (COALESCE(OLD.TAREFA,'Nulo') <> COALESCE(NEW.TAREFA,'Nulo')) THEN
           LOGAUX := COALESCE(OLD.TAREFA,'Nulo');
           INSERT into TL_WOR (CODFIL,SEQUEN,MSGLOG,FLGMUD) VALUES (NEW.CODFIL,NEW.SEQUEN,LOGAUX,'T');
           -- Enviando e-mail separado informando que a Tarefa foi modificada
           IF (ISNOTNULL(NEW.FILRES) = 'T') AND (cSITDES = 'A') THEN
            --IF (NEW.FILRES IS NOT NULL) AND (cSITDES = 'A') THEN
             MSGResp := MSGResp || 'A descrio da tarefa foi alterada, por favor verifique abaixo as mudanas'||c_lf;
           END IF;
        END IF;
        
        IF (Equal(OLD.REVISA,NEW.REVISA) = 0) THEN
        --IF (COALESCE(OLD.REVISA,'Nulo') <> COALESCE(NEW.REVISA,'Nulo')) THEN
           LOGAUX := COALESCE(OLD.REVISA,'Nulo');
           INSERT into TL_WOR (CODFIL,SEQUEN,MSGLOG,FLGMUD) VALUES (NEW.CODFIL,NEW.SEQUEN,LOGAUX,'R');
           -- Enviando e-mail separado informando que a Reviso foi modificada
           IF (ISNOTNULL(OLD.FILTST) = 'T') AND (cSITORI = 'X') THEN
            --IF (OLD.FILTST IS NOT NULL) AND (cSITORI = 'X') THEN
             MSGRev := MSGRev || 'A descrio da reviso da tarefa foi alterada, por favor verifique abaixo as mudanas'|| c_lf;
           END IF;
        END IF;
        
        IF (Equal(OLD.DOCUME,NEW.DOCUME) = 0) THEN
        --IF (COALESCE(OLD.DOCUME,'Nulo') <> COALESCE(NEW.DOCUME,'Nulo')) THEN
           LOGAUX := COALESCE(OLD.DOCUME,'Nulo');
           INSERT into TL_WOR (CODFIL,SEQUEN,MSGLOG,FLGMUD) VALUES (NEW.CODFIL,NEW.SEQUEN,LOGAUX,'D');
        END IF;
        
        IF Equal(OLD.DATPRO,NEW.DATPRO) = 0 THEN
        --IF (COALESCE(TO_CHAR(OLD.DATPRO,cData),'Nulo') <> COALESCE(TO_CHAR(NEW.DATPRO,cData),'Nulo')) THEN
          VLOG := VLOG||'Data Prometida: de '||COALESCE(TO_CHAR(OLD.DATPRO,cData),'Nulo')||' para '||COALESCE(TO_CHAR(NEW.DATPRO,cData),'Nulo')||c_LF;
          if (cSITDES = 'A') then
            MSGResp := MSGResp || 'A data prometida foi alterada, verifique se  h tempo para concluir esta tarefa.' || c_lf;
          else
            if (cSITDES = 'X') then
              MsgRev := MSGRev || 'A data prometida foi alterada, verifique se h tempo para revisar esta tarefa.' || c_lf;
            end if;
          end if;
        END IF;
    
        IF Equal(TO_CHAR(OLD.INITAR,cData),TO_CHAR(NEW.INITAR,cData)) = 0 THEN
        --IF (COALESCE(TO_CHAR(OLD.INITAR,cData),'Nulo') <> COALESCE(TO_CHAR(NEW.INITAR,cData),'Nulo')) THEN
          VLOG := VLOG||'Incio da Tarefa: de '||COALESCE(TO_CHAR(OLD.INITAR),'Nulo')||' para '||COALESCE(TO_CHAR(NEW.INITAR),'Nulo')||c_LF;
        END IF;
    
        IF Equal(TO_CHAR(OLD.FIMTAR,cData),TO_CHAR(NEW.FIMTAR,cData)) = 0 THEN
        --IF (COALESCE(TO_CHAR(OLD.FIMTAR,cData),'Nulo') <> COALESCE(TO_CHAR(NEW.FIMTAR,cData),'Nulo')) THEN
          VLOG := VLOG||'Fim da Tarefa: de '||COALESCE(TO_CHAR(OLD.FIMTAR),'Nulo')||' para '||COALESCE(TO_CHAR(NEW.FIMTAR),'Nulo')||c_LF;
        END IF;
    
        IF Equal(TO_CHAR(OLD.INITST,cData),TO_CHAR(NEW.INITST,cData)) = 0 THEN
        --IF (COALESCE(TO_CHAR(OLD.INITST,cData),'Nulo') <> COALESCE(TO_CHAR(NEW.INITST,cData),'Nulo')) THEN
          VLOG := VLOG||'Incio da Reviso: de '||COALESCE(TO_CHAR(OLD.INITST),'Nulo')||' para '||COALESCE(TO_CHAR(NEW.INITST),'Nulo')||c_LF;
        END IF;
    
        IF Equal(TO_CHAR(OLD.FIMTST,cData),TO_CHAR(NEW.FIMTST,cData)) = 0 THEN
        --IF (COALESCE(TO_CHAR(OLD.FIMTST,cData),'Nulo') <> COALESCE(TO_CHAR(NEW.FIMTST,cData),'Nulo')) THEN
          VLOG := VLOG||'Fim da Reviso: de '||COALESCE(TO_CHAR(OLD.FIMTST),'Nulo')||' para '||COALESCE(TO_CHAR(NEW.FIMTST),'Nulo')||c_LF;
        END IF;
    
        IF Equal(TO_CHAR(OLD.INIPLT,cData),TO_CHAR(NEW.INIPLT,cData)) = 0 THEN
        --IF (COALESCE(TO_CHAR(OLD.INIPLT,cData),'Nulo') <> COALESCE(TO_CHAR(NEW.INIPLT,cData),'Nulo')) THEN
          VLOG := VLOG||'Incio Planejado para a Tarefa: de '||COALESCE(TO_CHAR(OLD.INIPLT),'Nulo')||' para '||COALESCE(TO_CHAR(NEW.INIPLT),'Nulo')||c_LF;
        END IF;
    
        IF Equal(TO_CHAR(OLD.FIMPLT,cData),TO_CHAR(NEW.FIMPLT,cData)) = 0 THEN
        --IF (COALESCE(TO_CHAR(OLD.FIMPLT,cData),'Nulo') <> COALESCE(TO_CHAR(NEW.FIMPLT,cData),'Nulo')) THEN
          VLOG := VLOG||'Fim Planejado para a Tarefa: de '||COALESCE(TO_CHAR(OLD.FIMPLT),'Nulo')||' para '||COALESCE(TO_CHAR(NEW.FIMPLT),'Nulo')||c_LF;
        END IF;
    
        IF Equal(TO_CHAR(OLD.INIPLR,cData),TO_CHAR(NEW.INIPLR,cData)) = 0 THEN
        --IF (COALESCE(TO_CHAR(OLD.INIPLR,cData),'Nulo') <> COALESCE(TO_CHAR(NEW.INIPLR,cData),'Nulo')) THEN
          VLOG := VLOG||'Incio Planejado para a Reviso: de '||COALESCE(TO_CHAR(OLD.INIPLR),'Nulo')||' para '||COALESCE(TO_CHAR(NEW.INIPLR),'Nulo')||c_LF;
        END IF;
    
        IF Equal(TO_CHAR(OLD.FIMPLR,cData),TO_CHAR(NEW.FIMPLR,cData)) = 0 THEN
        --IF (COALESCE(TO_CHAR(OLD.FIMPLR,cData),'Nulo') <> COALESCE(TO_CHAR(NEW.FIMPLR,cData),'Nulo')) THEN
          VLOG := VLOG||'Fim Planejado para a Reviso: de '||COALESCE(TO_CHAR(OLD.FIMPLR),'Nulo')||' para '||COALESCE(TO_CHAR(NEW.FIMPLR),'Nulo')||c_LF;
        END IF;
    
        IF Equal(OLD.AVISAR,NEW.AVISAR) = 0 THEN
        --IF (COALESCE(OLD.AVISAR,'#') <> COALESCE(NEW.AVISAR,'#')) THEN
          Select CASE OLD.AVISAR WHEN 'T' THEN 'Sempre'
                                  WHEN 'F' THEN 'Nunca'
                                  WHEN '1' THEN 'Somente desta vez'
                                                      ELSE 'Nulo'
                 END INTO cOld from Dual;
          Select CASE NEW.AVISAR WHEN 'T' THEN 'Sempre'
                                  WHEN 'F' THEN 'Nunca'
                                  WHEN '1' THEN 'Somente desta vez'
                                                      ELSE 'Nulo'
                 END INTO cNew from Dual;
          VLOG := VLOG||'Notificar: de '||cOld||' para '||cNew||c_LF;
        END IF;
    
        -- Transformando os Minutos em Horas
        IF Equal(OLD.TARPRE,NEW.TARPRE) = 0 THEN 
        --IF (COALESCE(TO_CHAR(OLD.TARPRE),'') <> COALESCE(TO_CHAR(NEW.TARPRE),'')) THEN
          cOld := TRUNC(OLD.TARPRE / 60,'000')||':'||LTRIM(RTRIM(TO_CHAR(mod(OLD.TARPRE,60),'00')));
          cNew := TRUNC(NEW.TARPRE / 60,'000')||':'||LTRIM(RTRIM(TO_CHAR(mod(NEW.TARPRE,60),'00')));
          VLOG := VLOG||'Horas Previstas para Tarefa: de '||COALESCE(cOld,'Nulo')||' para '||COALESCE(cNew,'Nulo')||c_LF;
          if (cSITDES = 'A') then
            MSGResp := MSGResp ||  'A previso de horas para realizar a tarefa foi alterada, verifique se o tempo previsto est correto.' || c_lf;
          End if;
        END IF; 
		
		-- Transformando os Minutos em Horas
        IF Equal(OLD.MINPRE,NEW.MINPRE) = 0 THEN         
          cOld := TRUNC(OLD.MINPRE / 60,'000')||':'||LTRIM(RTRIM(TO_CHAR(mod(OLD.MINPRE,60),'00')));
          cNew := TRUNC(NEW.MINPRE / 60,'000')||':'||LTRIM(RTRIM(TO_CHAR(mod(NEW.MINPRE,60),'00')));
          VLOG := VLOG||'Horas Mnimas Previstas para Tarefa: de '||COALESCE(cOld,'Nulo')||' para '||COALESCE(cNew,'Nulo')||c_LF;
          if (cSITDES = 'A') then
            MSGResp := MSGResp ||  'A previso mnima de horas para realizar a tarefa foi alterada, verifique se o tempo previsto est correto.' || c_lf;
          End if;
        END IF; 
        
				-- Transformando os Minutos em Horas
        IF Equal(OLD.MAXPRE,NEW.MAXPRE) = 0 THEN         
          cOld := TRUNC(OLD.MAXPRE / 60,'000')||':'||LTRIM(RTRIM(TO_CHAR(mod(OLD.MAXPRE,60),'00')));
          cNew := TRUNC(NEW.MAXPRE / 60,'000')||':'||LTRIM(RTRIM(TO_CHAR(mod(NEW.MAXPRE,60),'00')));
          VLOG := VLOG||'Horas Mximas Previstas para Tarefa: de '||COALESCE(cOld,'Nulo')||' para '||COALESCE(cNew,'Nulo')||c_LF;
          if (cSITDES = 'A') then
            MSGResp := MSGResp ||  'A previso mxima de horas para realizar a tarefa foi alterada, verifique se o tempo previsto est correto.' || c_lf;
          End if;
        END IF; 
		
        IF Equal(OLD.TARREA,NEW.TARREA) = 0 THEN 
        --IF (COALESCE(TO_CHAR(OLD.TARREA),'') <> COALESCE(TO_CHAR(NEW.TARREA),'')) THEN
          cOld := TRUNC(OLD.TARREA / 60,'000')||':'||LTRIM(RTRIM(TO_CHAR(mod(OLD.TARREA,60),'00')));
          cNew := TRUNC(NEW.TARREA / 60,'000')||':'||LTRIM(RTRIM(TO_CHAR(mod(NEW.TARREA,60),'00')));
          VLOG := VLOG||'Horas Realizadas para Tarefa: de '||COALESCE(cOld,'Nulo')||' para '||COALESCE(cNew,'Nulo')||c_LF;
        END IF;
    
        IF Equal(OLD.TSTPRE,NEW.TSTPRE) = 0 THEN 
        --IF (COALESCE(TO_CHAR(OLD.TSTPRE),'') <> COALESCE(TO_CHAR(NEW.TSTPRE),'')) THEN
          cOld := TRUNC(OLD.TSTPRE / 60,'000')||':'||LTRIM(RTRIM(TO_CHAR(mod(OLD.TSTPRE,60),'00')));
          cNew := TRUNC(NEW.TSTPRE / 60,'000')||':'||LTRIM(RTRIM(TO_CHAR(mod(NEW.TSTPRE,60),'00')));
          VLOG := VLOG||'Horas Previstas para a Reviso: de '||COALESCE(cOld,'Nulo')||' para '||COALESCE(cNew,'Nulo')||c_LF;
          if (cSITORI = 'X') then
            MSGRev := MSGRev || 'A previso de horas para a reviso foi alterada, verifique se o tempo previsto est correto.' || c_lf;
          End if;
        END IF; 
        
        IF Equal(OLD.TSTREA,NEW.TSTREA) = 0 THEN 
        --IF (COALESCE(TO_CHAR(OLD.TSTREA),'') <> COALESCE(TO_CHAR(NEW.TSTREA),'')) THEN
          cOld := TRUNC(OLD.TSTREA / 60,'000')||':'||LTRIM(RTRIM(TO_CHAR(mod(OLD.TSTREA,60),'00')));
          cNew := TRUNC(NEW.TSTREA / 60,'000')||':'||LTRIM(RTRIM(TO_CHAR(mod(NEW.TSTREA,60),'00')));
          VLOG := VLOG||'Horas Realizadas para a Reviso: de '||COALESCE(cOld,'Nulo')||' para '||COALESCE(cNew,'Nulo')||c_LF;
        END IF;
    
        IF Equal(OLD.COBRAR,NEW.COBRAR) = 0 THEN 
        --IF (COALESCE(TO_CHAR(OLD.COBRAR),'') <> COALESCE(TO_CHAR(NEW.COBRAR),'')) THEN
          cOld := TRUNC(OLD.COBRAR / 60,'000')||':'||LTRIM(RTRIM(TO_CHAR(mod(OLD.COBRAR,60),'00')));
          cNew := TRUNC(NEW.COBRAR / 60,'000')||':'||LTRIM(RTRIM(TO_CHAR(mod(NEW.COBRAR,60),'00')));
          VLOG := VLOG||'Horas Cobradas: de '||COALESCE(cOld,'Nulo')||' para '||COALESCE(cNew,'Nulo')||c_LF;
        END IF;
    
        IF ((Equal(OLD.FILACT,NEW.FILACT) = 0) OR
            (Equal(OLD.CODACT,NEW.CODACT) = 0) OR
            (Equal(OLD.NUMACT,NEW.NUMACT) = 0)) THEN 
        --IF ((COALESCE(OLD.FILACT,'Nulo') <> COALESCE(NEW.FILACT,'Nulo')) OR
        --    (COALESCE(OLD.CODACT,'Nulo') <> COALESCE(NEW.CODACT,'Nulo')) OR              
          --(COALESCE(TO_CHAR(OLD.NUMACT),'') <> COALESCE(TO_CHAR(NEW.NUMACT),''))) THEN
          select COALESCE(min(NOMTRA),COALESCE(min(CONTAT),'Nulo')) into cOld from TT_CON where FILCLI = OLD.FILACT AND CODCLI = OLD.CODACT AND NUMCON = OLD.NUMACT;
          select COALESCE(min(NOMTRA),COALESCE(min(CONTAT),'Nulo')) into cNew from TT_CON where FILCLI = NEW.FILACT AND CODCLI = NEW.CODACT AND NUMCON = NEW.NUMACT;
          VLOG := VLOG||'Aceito por: de '||cOld||' para '||cNew||c_LF;
        END IF;
    
        IF Equal(TO_CHAR(OLD.DATACT,cData),TO_CHAR(NEW.DATACT,cData)) = 0 THEN 
        --IF (COALESCE(TO_CHAR(OLD.DATACT,cData),'Nulo') <> COALESCE(TO_CHAR(NEW.DATACT,cData),'Nulo')) THEN
          VLOG := VLOG||'Data Aceite: de '||COALESCE(TO_CHAR(OLD.DATACT,cData),'Nulo')||' para '||COALESCE(TO_CHAR(NEW.DATACT,cData),'Nulo')||c_LF;
        END IF;
    
        IF Equal(OLD.TIPACT,NEW.TIPACT) = 0 THEN 
        --IF (COALESCE(OLD.TIPACT,'Nulo') <> COALESCE(NEW.TIPACT,'Nulo')) THEN
          select CASE OLD.TIPACT WHEN 'V' THEN 'Verbal'
                                  WHEN 'T' THEN 'Telefnico'
                                  WHEN 'F' THEN 'Fax'
                                  WHEN 'E' THEN 'E-mail'
                                  WHEN 'C' THEN 'Carta'
                                                      ELSE 'Nulo'
                 END into cOld from dual;
          select CASE NEW.TIPACT WHEN 'V' THEN 'Verbal'
                                  WHEN 'T' THEN 'Telefnico'
                                  WHEN 'F' THEN 'Fax'
                                  WHEN 'E' THEN 'E-mail'
                                  WHEN 'C' THEN 'Carta'
                                                      ELSE 'Nulo'
                 END into cNew from dual;
          VLOG := VLOG||'Tipo de Aceite: de '||cOld||' para '||cNew||c_LF;
        END IF;
    
        IF Equal(OLD.PRIORI,NEW.PRIORI) = 0 THEN 
        --IF (COALESCE(TO_CHAR(OLD.PRIORI),'') <> COALESCE(TO_CHAR(NEW.PRIORI),'')) THEN
          VLOG := VLOG||'Prioridade: de '||COALESCE(TO_CHAR(OLD.PRIORI,'9'),'Nulo')||' para '||COALESCE(TO_CHAR(NEW.PRIORI,'9'),'Nulo')||c_LF;
          if (cSITDES = 'A') then
            MSGResp := MSGResp || 'A prioridade desta tarefa foi alterada, verifique como ficou a ordem de execuo de suas tarefas.' || c_lf;
          End if;
          if (cSITDES = 'X') then
            MSGRev := MSGRev || 'A prioridade desta tarefa foi alterada, verifique como ficou a ordem de reviso de suas tarefas.' || c_lf;
          End if;
        END IF;
    
        IF ((Equal(OLD.FILPRJ,NEW.FILPRJ) = 0) OR (Equal(OLD.SEQPRJ,NEW.SEQPRJ) = 0)) THEN 
        --IF ((COALESCE(OLD.FILPRJ,'Nulo') <> COALESCE(NEW.FILPRJ,'Nulo')) OR (COALESCE(OLD.SEQPRJ,'Nulo') <> COALESCE(NEW.SEQPRJ,'Nulo'))) THEN
          cOld := HierarquiaProjeto(OLD.filprj,OLD.seqprj);
          cNew := HierarquiaProjeto(NEW.filprj,NEW.seqprj);
          VLOG := VLOG||'Nome do Projeto: de '||cOld||' para '||cNew||c_LF;
        END IF;    
        
        IF Equal(OLD.CONCLU,NEW.CONCLU) = 0 THEN 
        --IF (COALESCE(TO_CHAR(OLD.CONCLU),'') <> COALESCE(TO_CHAR(NEW.CONCLU),'')) THEN
          -- S pode alterar a concluso o usurio responsvel
          VLOG := VLOG||'Concludo: de '||COALESCE(TO_CHAR(OLD.CONCLU),'Nulo')||'% para '||COALESCE(TO_CHAR(NEW.CONCLU),'Nulo')||'%'||c_LF;
        END IF;
    
        IF Equal(OLD.FLGSIT,NEW.FLGSIT) = 0 THEN 
        --IF (COALESCE(OLD.FLGSIT,'') <> COALESCE(NEW.FLGSIT,'')) THEN
          select dessit into cOld from td_sit where codtab = OLD.FLGSIT;
          select dessit into cNew from td_sit where codtab = NEW.FLGSIT;
          if (cOld = 'Aberto') or (cNew = 'Aberto') then
             MSGResp := MSGResp || 'A situao desta tarefa foi alterada para: "'||cNew||'". ' || c_lf;
          else
            if (cSITDES = 'Executado') or (cSITORI = 'Executado') then
              MSGRev := MSGRev || 'A situao desta tarefa foi alterada para: "'||cNew||'". ' || c_lf;
            end if;
          end if;
          VLOG := VLOG||'Situacao: de '||cOld||' para '||cNew||c_LF;
        END IF;
    
        IF Equal(OLD.CLATAR,NEW.CLATAR) = 0 THEN 
        --IF (COALESCE(TO_CHAR(OLD.CLATAR),'') <> COALESCE(TO_CHAR(NEW.CLATAR),'')) THEN
          select COALESCE(MIN(DESCLT),'Nulo') into cOld from TD_CLT where CODTAB = OLD.CLATAR;
          select COALESCE(MIN(DESCLT),'Nulo') into cNew from TD_CLT where CODTAB = NEW.CLATAR;
          VLOG := VLOG||'Classificao da Tarefa: de '||cOld||' para '||cNew||c_LF;
        END IF;
    
        IF ((Equal(OLD.FILCLI,NEW.FILCLI) = 0) OR
            (Equal(OLD.CODCLI,NEW.CODCLI) = 0)) THEN 
        --IF ((COALESCE(OLD.FILCLI,'Nulo') <> COALESCE(NEW.FILCLI,'Nulo')) OR (COALESCE(OLD.CODCLI,'Nulo') <> COALESCE(NEW.CODCLI,'Nulo'))) THEN
          VLOG := VLOG||'Cliente: de '||COALESCE(OLD.FILCLI,'Nulo')||'-'||COALESCE(OLD.CODCLI,'Nulo')||
          ' para '||COALESCE(NEW.FILCLI,'Nulo')||'-'||COALESCE(NEW.CODCLI,'Nulo')||c_LF;
        END IF;
    
        IF ((Equal(OLD.FILSOL,NEW.FILSOL) = 0) OR 
            (Equal(OLD.CODSOL,NEW.CODSOL) = 0) OR
            (Equal(TO_CHAR(OLD.NUMSOL),TO_CHAR(NEW.NUMSOL)) = 0)) THEN 
        --IF ((COALESCE(OLD.FILSOL,'Nulo') <> COALESCE(NEW.FILSOL,'Nulo')) OR (COALESCE(OLD.CODSOL,'Nulo') <> COALESCE(NEW.CODSOL,'Nulo')) OR (COALESCE(TO_CHAR(OLD.NUMSOL),'Nulo') <> COALESCE(TO_CHAR(NEW.NUMSOL),'Nulo'))) THEN
          select COALESCE(min(NOMTRA),COALESCE(min(CONTAT),'Nulo')) into cOld from TT_CON where FILCLI = OLD.FILSOL AND CODCLI = OLD.CODSOL AND NUMCON = OLD.NUMSOL;
          select COALESCE(min(NOMTRA),COALESCE(min(CONTAT),'Nulo')) into cNew from TT_CON where FILCLI = NEW.FILSOL AND CODCLI = NEW.CODSOL AND NUMCON = NEW.NUMSOL;
          VLOG := VLOG||'Solicitado por: de '||COALESCE(cOld,'Nulo')||' para '||COALESCE(cNew,'Nulo')||c_LF;
        END IF;
    
        IF Equal(TO_CHAR(OLD.DATSOL,cData),TO_CHAR(NEW.DATSOL,cData)) = 0 THEN            
        --IF (COALESCE(TO_CHAR(OLD.DATSOL,cData),'Nulo') <> COALESCE(TO_CHAR(NEW.DATSOL,cData),'Nulo')) THEN
          VLOG := VLOG||'Data de Solicitao: de '||COALESCE(TO_CHAR(OLD.DATSOL),'Nulo')||' para '||COALESCE(TO_CHAR(NEW.DATSOL),'Nulo')||c_LF;
        END IF;
    
        IF Equal(OLD.JUSATR,NEW.JUSATR) = 0 THEN 
        --IF (COALESCE(TO_CHAR(OLD.JUSATR),'') <> COALESCE(TO_CHAR(NEW.JUSATR),'')) THEN
          select COALESCE(MIN(DESJUS),'Nulo') into cOld from TD_JUS where CODTAB = OLD.JUSATR;
          select COALESCE(MIN(DESJUS),'Nulo') into cNew from TD_JUS where CODTAB = NEW.JUSATR;
          VLOG := VLOG||'Justificativa: de '||COALESCE(cOld,'Nulo')||' para '||COALESCE(cNew,'Nulo')||c_LF;
        END IF;
    
        IF (COALESCE(OLD.COMJUS,'Nulo') <> COALESCE(NEW.COMJUS,'Nulo')) THEN
          VLOG := VLOG||'Complemento da Justificativa: de "'||COALESCE(OLD.COMJUS,'Nulo')||'" para "'||COALESCE(NEW.COMJUS,'Nulo')||'"'||c_LF;
        END IF;
        
         IF Equal(OLD.RELEAS,NEW.RELEAS) = 0 THEN
          cOld := coalesce(To_char(OLD.RELEAS),'Nulo');
          cNew := coalesce(To_char(NEW.RELEAS),'Nulo');
          VLOG := VLOG||'Release : de '||cOld||' para '||cNew||c_LF;
        END IF;
    
        IF (NEW.AVISAR <> OLD.AVISAR) THEN
          select CASE OLD.AVISAR WHEN 'T' THEN 'Sim'
                                  WHEN 'F' THEN 'No'
                                  WHEN '1' THEN 'Somente desta vez'
                                                      ELSE 'Nulo'
                 END into cOld from dual;
          select CASE NEW.AVISAR WHEN 'T' THEN 'Sim'
                                  WHEN 'F' THEN 'No'
                                  WHEN '1' THEN 'Somente desta vez'
                                                      ELSE 'Nulo'
                 END into cNew from dual;
          VLOG := VLOG||'Notificar: de '||COALESCE(cOld,'Nulo')||' para '||COALESCE(cNew,'Nulo')||c_LF;
        END IF;
    
        IF (NEW.FLGACT <> OLD.FLGACT) THEN
          select CASE OLD.FLGACT WHEN 'T' THEN 'Aprovado'
                                  WHEN 'F' THEN 'Reprovado'
                                                      ELSE 'Nulo'
                 END into cOld from dual;
          select CASE NEW.FLGACT WHEN 'T' THEN 'Aprovado'
                                  WHEN 'F' THEN 'Reprovado'
                                                      ELSE 'Nulo'
                 END into cNew from dual;
          VLOG := VLOG||'Aceito pelo Cliente: de '||COALESCE(cOld,'Nulo')||' para '||COALESCE(cNew,'Nulo')||c_LF;
        END IF;
    
        IF (NEW.PRICLI <> OLD.PRICLI) THEN
          select CASE OLD.PRICLI WHEN 0 THEN 'Imediata'
                                  WHEN 1 THEN 'Alta'
                                  WHEN 2 THEN 'Mdia'
                                  WHEN 3 THEN 'Baixa'
                                                      ELSE 'Nulo'
                 END into cOld from dual;
          select CASE NEW.PRICLI WHEN 0 THEN 'Imediata'
                                  WHEN 1 THEN 'Alta'
                                  WHEN 2 THEN 'Mdia'
                                  WHEN 3 THEN 'Baixa'
                                                      ELSE 'Nulo'
                 END into cNew from dual;
          VLOG := VLOG||'Prioridade do Cliente: de '||COALESCE(cOld,'Nulo')||' para '||COALESCE(cNew,'Nulo')||c_LF;
        END IF;
    
        IF ISNOTNULL(trim(VLOG)) = 'T' THEN
        --IF (VLOG IS NOT NULL) THEN
          INSERT into TL_WOR (CODFIL,SEQUEN,MSGLOG,FLGMUD) VALUES (NEW.CODFIL,NEW.SEQUEN,VLOG,'A');
        END IF;
    
        -- Se concludo ento manda e-mail para o responsvel pelo teste!!
        IF (cSITORI <> 'X') AND (cSITDES = 'X') THEN
          IF ((ISNOTNULL(NEW.FILTST) = 'T') AND 
              (ISNOTNULL(NEW.CODTST) = 'T')) THEN
            --IF ((NEW.FILTST IS NOT NULL) AND (NEW.CODTST IS NOT NULL)) THEN
             MSGRev := MSGRev || 'Tarefa pronta para ser revisada por voc.' || c_lf;
          END IF;
        END IF;
        
        -- Se concludo ento manda e-mail para que registrou a tarefa
        IF (cSITORI <> 'E') AND (cSITDES = 'E') THEN
          MSGReg := MSGReg || 'Tarefa foi colocada em espera.' || c_lf;
        END IF;
    
        -- Enviando e-mail com as modificaes
        IF ISNOTNULL(MSGResp) = 'T' THEN    
         --if MSGResp IS NOT NULL then
          SELECT REPLACE(TEXTOEMAILPADRAO,'***MSG***',MSGResp) INTO TEXTOEMAIL FROM DUAL;
          vDummy:=Lanca_Mail(NEW.codfil,NEW.sequen,'T','',PegaE_Mail(NEW.FILRES,NEW.CODRES),'','',E_mailLogon,TEXTOEMAIL,VLOG,NEW.avisar);
        END IF;
        
        IF ISNOTNULL(MSGRev) = 'T' THEN    
        --if MSGRev IS NOT NULL then
          SELECT REPLACE(TEXTOEMAILPADRAO,'***MSG***',MSGRev) INTO TEXTOEMAIL FROM DUAL;
          vDummy:=Lanca_Mail(NEW.codfil,NEW.sequen,'T','',PegaE_Mail(NEW.FILTST,NEW.CODTST),'','',E_mailLogon,TEXTOEMAIL,VLOG,NEW.avisar);
        END IF;
        
        -- Enviando e-mail com as modificaes
        IF ISNOTNULL(MSGReg) = 'T' THEN
        --if MSGReg IS NOT NULL then
          SELECT REPLACE(TEXTOEMAILPADRAO,'***MSG***',MSGReg) INTO TEXTOEMAIL FROM DUAL;
          vDummy:=Lanca_Mail(NEW.codfil,NEW.sequen,'T','',PegaE_Mail(NEW.FILREG,NEW.CODREG),'','',E_mailLogon,TEXTOEMAIL,VLOG,NEW.avisar);
        END IF;
    
        -- Testado e com sucesso manda e-mail para o registrado, solicitante e cliente.
        IF (cSITORI <> '1') AND (cSITDES = '1') THEN
          MsgResp := 'A tarefa descrita como: "'||NEW.DESTAR||'" foi revisada e aprovada.' || C_lf
            ||'Entraremos em contato assim que ela estiver disponvel para atualizaes. ' || C_lf;
            IF (ISNOTNULL(NEW.FILCLI) = 'T') THEN
            --IF (NEW.FILCLI IS NOT NULL) THEN
            select count( *) into ContaReg from TT_SPC where FILCLI = NEW.FILCLI AND CODCLI = NEW.CODCLI;
            IF ContaReg <> 0 THEN
              select E_MAIL into PegaCopia from TT_SPC where FILCLI = NEW.FILCLI AND CODCLI = NEW.CODCLI;
              IF (PegaCopia <> 'Nulo') then
                MailCopia := MailCopia||PegaCopia||';';
              END IF;
            END IF;
          END IF;
          IF ((ISNOTNULL(NEW.FILSOL) = 'T') AND
              (ISNOTNULL(NEW.CODSOL) = 'T') AND 
              (COALESCE(NEW.NUMSOL,-1) >= 0)) THEN
            --IF ((NEW.FILSOL IS NOT NULL) AND (NEW.CODSOL IS NOT NULL) AND (NEW.NUMSOL IS NOT NULL)) THEN
            select count( *) into ContaReg from TT_CON where FILCLI = NEW.FILSOL AND CODCLI = NEW.CODSOL AND NUMCON = NEW.NUMSOL;
            IF ContaReg <> 0 THEN
              select E_MAIL into PegaCopia from TT_CON where FILCLI = NEW.FILSOL AND CODCLI = NEW.CODSOL AND NUMCON = NEW.NUMSOL;
              IF (PegaCopia <> 'Nulo') then
                MailCopia := MailCopia||PegaCopia||';';
              END IF;
            END IF;
          END IF;
          vDummy:=Lanca_Mail(NEW.codfil,NEW.sequen,'T','',PegaE_Mail(NEW.FILREG,NEW.CODREG),MailCopia,'',E_mailLogon,MsgResp,'',NEW.avisar);
        END IF;
      END IF;
    
      IF NEW.AVISAR = '1' THEN
        NEW.AVISAR := 'F';
      END IF;
  END IF; -- Fim not (TG_OP = 'DELETE')

  -- Totalizar tarefas e tempos no projeto
  IF (TG_OP = 'INSERT') THEN
    -- davi - 41196 - 22/05/06 - NEW.flgest => cSITDES
    SELECT TIPSIT INTO cSITDES FROM TD_SIT WHERE CODTAB = NEW.FLGSIT;
    vDummy:=TotalizaNoProjeto(NEW.FILPRJ,NEW.SEQPRJ,cSITDES,
                      NEW.FLGACT,
                      NEW.TARREA,NEW.TARPRE,NEW.CONCLU,false,true,true);
  END IF;

  -- Manda e-mail de alterao de situao de tarefa. - 71713
  IF (TG_OP = 'UPDATE') THEN
     IF (OLD.FLGSIT <> NEW.FLGSIT) THEN
        SELECT SITMAI INTO cSITMAI FROM TD_SIT WHERE CODTAB = NEW.FLGSIT;
        SELECT REPLACE(TEXTOEMAILPADRAO,'***MSG***','A situao desta tarefa foi alterada.') INTO TEXTOEMAIL FROM DUAL;
        vDummy:=Lanca_Mail_Sit(NEW.codfil,NEW.sequen,'T','',cSITMAI,'','',E_mailLogon,TEXTOEMAIL,VLOG,NEW.avisar,TO_CHAR(NEW.FLGSIT));
     END IF;
  END IF;

  IF (TG_OP = 'UPDATE') AND (NEW.DUMMY IS NULL ) THEN
    -- davi - 41196 - 22/05/06 - NEW.flgest => cSITDES
    SELECT TIPSIT INTO cSITDES FROM TD_SIT WHERE CODTAB = NEW.FLGSIT;
    SELECT TIPSIT INTO cSITORI FROM TD_SIT WHERE CODTAB = OLD.FLGSIT;
    -- Totalizar tarefas e tempos no projeto
    vDummy:=TotalizaNoProjeto(NEW.FILPRJ,NEW.SEQPRJ,cSITDES,
                      NEW.FLGACT,
                      NEW.TARREA,NEW.TARPRE,NEW.CONCLU,
                      FALSE,
                      ((Equal(cSITDES,cSITORI) <> 1) OR
                       (Equal(OLD.TARREA,NEW.TARREA) <> 1) OR
                       (Equal(OLD.SEQPRJ,NEW.SEQPRJ) <> 1) OR --davi - 31845 - 09/08/05 - trocou de prj
                       (Equal(OLD.CONCLU,NEW.CONCLU) <> 1)),
                      ((Equal(OLD.FLGACT,NEW.FLGACT) <> 1) OR
                       (Equal(OLD.TARREA,NEW.TARREA) <> 1) OR
                       (Equal(OLD.TARPRE,NEW.TARPRE) <> 1) OR
                       (Equal(OLD.CONCLU,NEW.CONCLU) <> 1)));

    -- Estornar quantidade de tarefas e tempos no projeto
    vDummy:=TotalizaNoProjeto(OLD.FILPRJ,OLD.SEQPRJ,cSITORI,
                      OLD.FLGACT,
                      OLD.TARREA,OLD.TARPRE,OLD.CONCLU,
                      TRUE,
                      ((Equal(cSITDES,cSITORI) <> 1) OR
                       (Equal(OLD.TARREA,NEW.TARREA) <> 1) OR
                       (Equal(OLD.SEQPRJ,NEW.SEQPRJ) <> 1) OR --davi - 31845 - 09/08/05 - trocou de prj
                       (Equal(OLD.CONCLU,NEW.CONCLU) <> 1)),
                      ((Equal(OLD.FLGACT,NEW.FLGACT) <> 1) OR
                       (Equal(OLD.TARREA,NEW.TARREA) <> 1) OR
                       (Equal(OLD.TARPRE,NEW.TARPRE) <> 1) OR
                       (Equal(OLD.CONCLU,NEW.CONCLU) <> 1)));
  END IF;

  IF (TG_OP = 'DELETE') THEN
 
    -- Estornar quantidade de tarefas e tempos no projeto
    IF OLD.DUMMY IS NULL THEN

      -- Impede a excluso de o usurio no possui permisso
      IF ChecaPermissao(OLD.FILPRJ,OLD.SEQPRJ,filial,usuario,CONSTANTE('wf_excluir_tarefa')) = '0' then
         RAISE EXCEPTION 'PG-20039 Usuario nao pode excluir tarefa. %' , VComplemento;
      END IF;
      -- davi - 41196 - 22/05/06 - OLD.flgest => cSITORI
      SELECT TIPSIT INTO cSITORI FROM TD_SIT WHERE CODTAB = OLD.FLGSIT;
      vDummy:=TotalizaNoProjeto(OLD.FILPRJ,OLD.SEQPRJ,cSITORI,
                        OLD.FLGACT,
                        OLD.TARREA,OLD.TARPRE,OLD.CONCLU,
                        TRUE,true,true);
    END IF;   

  END IF;



 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5296 --*/
CREATE TRIGGER TGWOR2
BEFORE INSERT OR DELETE OR UPDATE ON TT_WOR 
FOR EACH ROW EXECUTE PROCEDURE TGWOR2();

/*-- SEQ 5297 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGWOR3() CASCADE;

/*-- SEQ 5298 --*/
CREATE OR REPLACE FUNCTION TGWOR3() RETURNS TRIGGER AS $$
DECLARE
  inRec TT_WOR%ROWTYPE;
  Vdummy VARCHAR(20);
BEGIN
    vDummy:=PC_WOR_UPDATE(OLD.CODFIL,OLD.SEQUEN);
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5299 --*/
CREATE TRIGGER TGWOR3
AFTER DELETE ON TT_WOR 
FOR EACH ROW EXECUTE PROCEDURE TGWOR3();



/*-- SEQ 5300 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGWPRE1() CASCADE;

/*-- SEQ 5301 --*/
CREATE OR REPLACE FUNCTION TGWPRE1() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
DECLARE
  FILIAL CHAR(3);
  vComplemento Constant VARCHAR(100) := Constante('Complemento');
  wk_DECIMA     TT_PRO.DECIMA%TYPE;
BEGIN  
  IF (TG_OP = 'INSERT') THEN
    IF NEW.CODFIL IS NULL THEN
      SELECT CODLOJ INTO FILIAL FROM TT_IDF;
      NEW.CODFIL := FILIAL;
    END IF;

    NEW.SEQUEN := ProximoCodigo('TW_PRE',NEW.CODFIL);
  END IF;
  
  -- RFMP 83838 - Tratamento para amenizar problemas com quantidade no Checkout
  IF (TG_OP = 'INSERT') THEN
    SELECT PRO.DECIMA
      INTO wk_DECIMA
      FROM TT_PRO PRO
     WHERE PRO.FILMAT = NEW.FILMAT
       AND PRO.CODMAT = NEW.CODMAT;
    IF wk_DECIMA = 'F' THEN
      NEW.PRECOV := ROUND(NEW.PRECOV,2);
    END IF;
  END IF;  

  IF (TG_OP = 'UPDATE') THEN
    IF OLD.FLGAPL = 'T' THEN
      RAISE EXCEPTION 'PG-20001 Este preco ja foi aplicado. %' , vComplemento;
    END IF;

    -- Dados basicos nao podem ser modificados
    IF (Equal(OLD.FILPRE,NEW.FILPRE) <> 1)
    OR (Equal(OLD.CODPRE,NEW.CODPRE) <> 1)
    OR (Equal(OLD.FILMAT,NEW.FILMAT) <> 1)
    OR (Equal(OLD.CODMAT,NEW.CODMAT) <> 1)
    OR (Equal(OLD.CODCOR,NEW.CODCOR) <> 1)
    OR (Equal(OLD.CODTAM,NEW.CODTAM) <> 1)
    OR (Equal(OLD.CODFIL,NEW.CODFIL) <> 1)
    OR (Equal(OLD.SEQUEN,NEW.SEQUEN) <> 1) THEN
      RAISE EXCEPTION 'PG-20002 Dados basicos nao podem ser modificados. %' , vComplemento;
    END IF;

    -- ATUALIZA TT_PRE
    UPDATE TT_PRE SET PRECOV = NEW.PRECOV,
                      ULTREA = agora(),
                      CODMOE = COALESCE(NEW.CODMOE, 0),
                      --  materializacao dos custos que geraram o preco
                      --  (estes valores sao utilizados no acompanhamento da elasticidade do preco)
                      CUSREP = NEW.CUSREP,
                      CUSVEN = NEW.CUSVEN,
                      DESFIX = NEW.DESFIX,
                      LUCPRJ = NEW.LUCPRJ,
                      PEROPEFIX = NEW.PEROPEFIX,
                      PERLUCPRJ = NEW.PERLUCPRJ
     WHERE FILPRE = NEW.FILPRE
       AND CODPRE = NEW.CODPRE
       AND FILMAT = NEW.FILMAT
       AND CODMAT = NEW.CODMAT
       AND CODCOR = NEW.CODCOR
       AND CODTAM = NEW.CODTAM;
  END IF;  
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5302 --*/
CREATE TRIGGER TGWPRE1
BEFORE INSERT OR UPDATE ON TW_PRE 
FOR EACH ROW EXECUTE PROCEDURE TGWPRE1();

/*-- SEQ 5303 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGWPRE2() CASCADE;

/*-- SEQ 5304 --*/
CREATE OR REPLACE FUNCTION TGWPRE2() RETURNS TRIGGER AS $$
BEGIN
  DELETE FROM TW_PRE WHERE FLGAPL = 'T';
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5305 --*/
CREATE TRIGGER TGWPRE2
AFTER UPDATE ON TW_PRE 
FOR STATEMENT EXECUTE PROCEDURE TGWPRE2();


/*-- SEQ 5306 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGWSAC() CASCADE;

/*-- SEQ 5307 --*/
CREATE OR REPLACE FUNCTION TGWSAC() RETURNS TRIGGER AS $$
DECLARE
  -- Objetivo:
  -- 1) Gerar um codigo sequencial exclusivo para compor a chave primaria
  -- 2) cadastrar uma linha em TT_SUP E TT_MSG para cada linha gerada em TW_SAC

  WK_SEQUEN TT_SUP.SEQUEN%TYPE;
  WK_FILCLI TT_CLI.FILCLI%TYPE;
  WK_CODCLI TT_CLI.CODCLI%TYPE;
  WK_CONTA  Numeric(2);
  vCODFILIDF TT_IDF.CODLOJ%TYPE;
  vComplemento VARCHAR(100);
  Logon  TRetQuemLogou%ROWTYPE;
  -- Principal
begin

  vComplemento := Constante('Complemento');
  
  IF (TG_OP = 'INSERT') THEN
     IF NEW.CODFIL IS NULL THEN
        SELECT CODLOJ INTO vCODFILIDF FROM TT_IDF;
        NEW.CODFIL := vCODFILIDF;
     END IF;

     -- Gera codigo sequencial
     IF (NEW.SEQUEN IS NULL) THEN
       NEW.SEQUEN := ProximoCodigo('TW_SAC',NEW.CODFIL);
     END IF;
     
     -- Dados do usuario
     -- Pega CODFIL e SEQUEN do usuario logado
     select * into Logon from DadosLogon();
     IF not Logon.Encontrou THEN
       RAISE EXCEPTION 'PG-20037 Voce nao e um usuario cadastrado no sistema. %' , vComplemento;
     END IF;
     
     SELECT COALESCE(NEW.FILCLI,CFG.VC_FILCLI) into WK_FILCLI FROM TT_CFG CFG;
     SELECT COALESCE(NEW.CODCLI,CFG.VC_CODCLI) into WK_CODCLI FROM TT_CFG CFG;
     SELECT LPAD(TRIM(NEXTVAL('SQSUP')),10,' ') into WK_SEQUEN FROM DUAL;
     
     -- Inserindo em TT_SUP
     INSERT INTO TT_SUP
         (CODFIL,SEQUEN,FILCLI,CODCLI,FILEND,NUMEND,DATREG,
          MODULO,VERSAO,CODPRI,SITUAC,FILRES,CODRES,DESSUP,
          RELEASE,QTDFAT,E_MAIL,FLGCOB,ATU_EM,CODFUN, TIPSUP, TIPCWS)
         (SELECT NEW.CODFIL,WK_SEQUEN,WK_FILCLI,WK_CODCLI,
                 EDE.CODFIL,EDE.NUMEND,agora(),
                 DMOD.CODTAB, COALESCE(DMOD.VERATU,'0'), 0, 'N', COALESCE(DMOD.FILSAC,'001'), COALESCE(DMOD.CODSAC,'  1'), substr(NEW.TITULO,1,254),
                 0, 0, COALESCE(substr(CON.E_MAIL,1,100),'E-mail nao encontrado'), 'D', agora(), 0, 0, 'A'
            FROM TD_MOD DMOD, TT_END EDE LEFT OUTER JOIN TT_CON CON ON (CON.FILCLI = EDE.FILCLI
                                                                   AND  CON.CODCLI = EDE.CODCLI)
           WHERE DMOD.CODTAB = NEW.CODMOD
             AND EDE.FILCLI = WK_FILCLI
             AND EDE.CODCLI = WK_CODCLI
                          
             LIMIT 1
                      );
     
     -- Inserindo em TT_MSG
     SELECT COUNT(*) INTO WK_CONTA FROM TT_SUP
      WHERE CODFIL = NEW.CODFIL
        AND SEQUEN = WK_SEQUEN;
     
     IF WK_CONTA > 0 THEN
       INSERT INTO TT_MSG
          (CODFIL,SEQUEN,SEQMSG,FILUSU,CODUSU,DATMSG,DESMSG,MSGSUP,ANEXOS,RESPOS)
       VALUES
          (NEW.CODFIL,WK_SEQUEN,1,Logon.FilUsu,Logon.CODUSU,agora(),substr(NEW.TITULO,1,40),substr(NEW.DESMSG,1,4000),NULL,'A');
     END IF ;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5308 --*/
CREATE TRIGGER TGWSAC
BEFORE INSERT ON TW_SAC 
FOR EACH ROW EXECUTE PROCEDURE TGWSAC();


/*-- SEQ 5309 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGWTAB() CASCADE;

/*-- SEQ 5310 --*/
CREATE OR REPLACE FUNCTION TGWTAB() RETURNS TRIGGER AS $$
DECLARE
  nTIPCTB INTEGER;
BEGIN
    -- Trata TIPCTB (Portadores com titulos)
    NEW.DESCOB := RTRIM(LTRIM(NEW.DESCOB));

    IF (NEW.DESCOB IS NOT NULL) THEN

       SELECT count(*) INTO nTIPCTB
       FROM TT_CTB CTB
       WHERE CTB.FILCTA = NEW.FILCTA
         AND CTB.SEQCTA = NEW.SEQCTA
         AND CTB.TIPCTA = NEW.TIPCTA;

       IF (nTIPCTB = 0) THEN
          NEW.TIPCTB := NULL;
       ELSE
          NEW.TIPCTB := 'T';
       END IF;

    END IF;

    IF (NEW.COMCCC IS NULL) THEN 
        NEW.COMCCC := 'T';
    END IF;

    IF (NEW.CTRTIP IS NULL) THEN 
        NEW.CTRTIP := 'G';
    END IF;

    IF (NEW.TIPCOB IS NULL) THEN 
        NEW.TIPCOB := 'P';
    END IF;

    -- Trata dados de coletores
    IF (NEW.NOMCOL IS NOT NULL) THEN
       IF ISNULL(TRIM(NEW.SEPDEC)) = 'T' THEN
           NEW.SEPDEC := NULL;
       END IF;
       IF (NEW.DELIMI IS NULL) THEN 
           NEW.COLQTD := NULL;
           NEW.COLREF := NULL;
       ELSE
           NEW.INIREF := NULL;
           NEW.FIMREF := NULL;
           NEW.INIQTD := NULL;
           NEW.FIMQTD := NULL;
       END IF;
    END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5311 --*/
CREATE TRIGGER TGWTAB
BEFORE INSERT OR UPDATE ON TW_TAB 
FOR EACH ROW EXECUTE PROCEDURE TGWTAB();


/*-- SEQ 5312 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TGWUSU() CASCADE;

/*-- SEQ 5313 --*/
CREATE OR REPLACE FUNCTION TGWUSU() RETURNS TRIGGER AS $$
-- Objetivo:
-- 1) Interface entre Totall Lite e Totall 2000. Ao receber update
--    ou insert atualiza TT_USU
DECLARE

  UltimoCli TT_COD.ULTCOD%TYPE;
  CodigoUsu TT_USU.CODUSU%TYPE;
  Nivel     TT_USU.NIVUSU%TYPE;
  Achou     Integer;
  WK_NADA   VARCHAR(100);
-- Principal
BEGIN

  -- Identifica se o usuario vai se tornar um indicador de vendas
  Nivel := NEW.NIVUSU;

  IF (TG_OP = 'INSERT') THEN
     -- Acha o numero do ultimo cliente incluso na filial
     UltimoCli := TGR_WUSU_ProximoCodigo('CLI',NEW.FILUSU,null);

     -- Insere o Usuario como parceiro. Coloca apenas os dados basicos pois o Totall Lite
     -- nao tem esta relacao
     insert into TT_CLI (FILCLI, CODCLI, NOMCLI)
        values (NEW.FILUSU, lpad(UltimoCli,6,' '), NEW.NOMUSU);

     -- E um indicador?
     IF Nivel = 3 THEN
       insert into TT_REL (FILPAR, CODPAR, TIPPAR)
         values (NEW.FILUSU,  lpad(UltimoCli,6,' '), 'I');
       Nivel := 2; /* passa a ser considerado um vendedor */
     END IF;

     -- Ajusta TT_COD no caso do codigo do usuario nao estar disponivel
     CodigoUsu := LPad(TGR_WUSU_ProximoCodigo('USU',NEW.FILUSU,TO_NUMBER(NEW.CODUSU)),3,' ');

     -- Verifica se o usuario j existe
     SELECT COUNT(*) INTO Achou
     FROM TT_USU
     WHERE FILUSU = NEW.FILUSU
       AND CODUSU = CodigoUsu;

     IF (achou > 0) THEN
       update TT_USU set NOMUSU = NEW.NOMUSU,
                         APEUSU = NEW.APEUSU,
                         NIVUSU = Nivel,
                         ATU_EM = NEW.ATU_EM,
                         CODEXT = NEW.CODEXT,
                         FILCLI = NEW.FILUSU,
                         CODCLI = lpad(UltimoCli,6,' '),
                         PERCOM = NEW.PERCOM,
                         SENHA1 = '200',
                         SENHA2 = '200',
                         MAIDAT = 0,
                         MENDAT = 0,
                         SIGNAT = 2,
                         VISSE1 = NEW.VISSE1,
                         VISSE2 = NEW.VISSE2,
                         VISPER = NEW.VISPER
       where FILUSU = NEW.FILUSU
         and CODUSU = CodigoUsu;
     ELSE
       insert into TT_USU (FILUSU, CODUSU, NOMUSU, APEUSU, NIVUSU, ATU_EM, CODEXT,
                           FILCLI, CODCLI, PERCOM, SENHA1, SENHA2, MAIDAT, MENDAT,
                           PERMIS, SIGNAT, VISSE1, VISSE2, VISPER)
       values
       (NEW.FILUSU, CodigoUsu, NEW.NOMUSU, NEW.APEUSU,
        Nivel, NEW.ATU_EM, NEW.CODEXT, NEW.FILUSU,
        lpad(UltimoCli,6,' '), NEW.PERCOM, '200', '200', 0, 0,
        LPAD('N',100,'N'), 2, NEW.VISSE1, NEW.VISSE2, NEW.VISPER);
     END IF;

  ELSIF (TG_OP = 'UPDATE') THEN
     -- E um indicador?
     IF Nivel = 3 THEN
       WK_NADA := TGR_AcrescentaIndicador(NEW.FILUSU, NEW.CODUSU);
       Nivel := 2; /* passa a ser considerado um vendedor */
     END IF;

     update TT_USU set NOMUSU = NEW.NOMUSU,
                       NIVUSU = Nivel,
                       APEUSU = NEW.APEUSU,
                       ATU_EM = NEW.ATU_EM,
                       CODEXT = NEW.CODEXT,
                       PERCOM = NEW.PERCOM
     where FILUSU = NEW.FILUSU
       and CODUSU = NEW.CODUSU;
  END IF;
 IF (TG_OP = 'DELETE') THEN
    RETURN OLD;  
 ELSE
    RETURN NEW;  
 END IF;
END;
$$ language 'plpgsql';

/*-- SEQ 5314 --*/
CREATE TRIGGER TGWUSU
BEFORE INSERT OR DELETE OR UPDATE ON TW_USU 
FOR EACH ROW EXECUTE PROCEDURE TGWUSU();


/*-- SEQ 5315 --*/
UPDATE TT_IDF SET RELEASE=6;


/*-- SEQ 5316 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_amb() CASCADE;


/*-- SEQ 5317 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_amp() CASCADE;


/*-- SEQ 5318 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_apr() CASCADE;


/*-- SEQ 5319 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_arc() CASCADE;


/*-- SEQ 5320 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_bco() CASCADE;


/*-- SEQ 5321 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_bic() CASCADE;


/*-- SEQ 5322 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_bom() CASCADE;


/*-- SEQ 5323 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_cai() CASCADE;


/*-- SEQ 5324 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_car() CASCADE;


/*-- SEQ 5325 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ccb() CASCADE;


/*-- SEQ 5326 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ccc() CASCADE;


/*-- SEQ 5327 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_cds() CASCADE;


/*-- SEQ 5328 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_cfo() CASCADE;


/*-- SEQ 5329 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_cfp() CASCADE;


/*-- SEQ 5330 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_cl1() CASCADE;


/*-- SEQ 5331 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_cl2() CASCADE;


/*-- SEQ 5332 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_cl3() CASCADE;


/*-- SEQ 5333 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_cl4() CASCADE;


/*-- SEQ 5334 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_clt() CASCADE;


/*-- SEQ 5335 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_cnc() CASCADE;


/*-- SEQ 5336 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_cob() CASCADE;


/*-- SEQ 5337 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_col() CASCADE;


/*-- SEQ 5338 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_com() CASCADE;


/*-- SEQ 5339 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_con() CASCADE;


/*-- SEQ 5340 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_cor() CASCADE;


/*-- SEQ 5341 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_corvei() CASCADE;


/*-- SEQ 5342 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_cre() CASCADE;


/*-- SEQ 5343 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_crt() CASCADE;


/*-- SEQ 5344 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ct1() CASCADE;


/*-- SEQ 5345 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ct2() CASCADE;


/*-- SEQ 5346 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ct3() CASCADE;


/*-- SEQ 5347 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_cta() CASCADE;


/*-- SEQ 5348 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ctr() CASCADE;


/*-- SEQ 5349 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_cus() CASCADE;


/*-- SEQ 5350 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_cws() CASCADE;


/*-- SEQ 5351 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_dep() CASCADE;


/*-- SEQ 5352 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_des() CASCADE;


/*-- SEQ 5353 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_det() CASCADE;


/*-- SEQ 5354 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_dev() CASCADE;


/*-- SEQ 5355 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_dfc() CASCADE;


/*-- SEQ 5356 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_div() CASCADE;


/*-- SEQ 5357 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_doc() CASCADE;


/*-- SEQ 5358 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_dop() CASCADE;


/*-- SEQ 5359 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ean() CASCADE;


/*-- SEQ 5360 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ecb() CASCADE;


/*-- SEQ 5361 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ecf() CASCADE;


/*-- SEQ 5362 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_end() CASCADE;


/*-- SEQ 5363 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ent() CASCADE;


/*-- SEQ 5364 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_esp() CASCADE;


/*-- SEQ 5365 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_est() CASCADE;


/*-- SEQ 5366 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_eti() CASCADE;


/*-- SEQ 5367 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_exp() CASCADE;


/*-- SEQ 5368 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ext() CASCADE;


/*-- SEQ 5369 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_fcc() CASCADE;


/*-- SEQ 5370 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_fce() CASCADE;


/*-- SEQ 5371 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_fid() CASCADE;


/*-- SEQ 5372 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_fil() CASCADE;


/*-- SEQ 5373 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_fin() CASCADE;


/*-- SEQ 5374 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_fis() CASCADE;


/*-- SEQ 5375 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_fps() CASCADE;


/*-- SEQ 5376 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_fre() CASCADE;


/*-- SEQ 5377 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_fun() CASCADE;


/*-- SEQ 5378 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_gra() CASCADE;


/*-- SEQ 5379 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_gru() CASCADE;


/*-- SEQ 5380 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_hom() CASCADE;


/*-- SEQ 5381 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_icm() CASCADE;


/*-- SEQ 5382 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ies() CASCADE;


/*-- SEQ 5383 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ime() CASCADE;


/*-- SEQ 5384 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_img() CASCADE;


/*-- SEQ 5385 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ina() CASCADE;


/*-- SEQ 5386 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ins() CASCADE;


/*-- SEQ 5387 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ipi() CASCADE;


/*-- SEQ 5388 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ir1() CASCADE;


/*-- SEQ 5389 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ir2() CASCADE;


/*-- SEQ 5390 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ire() CASCADE;


/*-- SEQ 5391 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_irr() CASCADE;


/*-- SEQ 5392 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_iso() CASCADE;


/*-- SEQ 5393 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_iss() CASCADE;


/*-- SEQ 5394 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_jus() CASCADE;


/*-- SEQ 5395 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_lan() CASCADE;


/*-- SEQ 5396 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_lcr() CASCADE;


/*-- SEQ 5397 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_lib() CASCADE;


/*-- SEQ 5398 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_lpc() CASCADE;


/*-- SEQ 5399 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_maq() CASCADE;


/*-- SEQ 5400 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_mar() CASCADE;


/*-- SEQ 5401 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_mdv() CASCADE;


/*-- SEQ 5402 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_med() CASCADE;


/*-- SEQ 5403 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_mnf() CASCADE;


/*-- SEQ 5404 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_mod() CASCADE;


/*-- SEQ 5405 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_moe() CASCADE;


/*-- SEQ 5406 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_mon() CASCADE;


/*-- SEQ 5407 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_mot() CASCADE;


/*-- SEQ 5408 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_mpb() CASCADE;


/*-- SEQ 5409 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_mtd() CASCADE;


/*-- SEQ 5410 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_mul() CASCADE;


/*-- SEQ 5411 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_mvp() CASCADE;


/*-- SEQ 5412 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_nat() CASCADE;


/*-- SEQ 5413 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_niv() CASCADE;


/*-- SEQ 5414 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_obs() CASCADE;


/*-- SEQ 5415 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ocu() CASCADE;


/*-- SEQ 5416 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_omi() CASCADE;


/*-- SEQ 5417 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_out() CASCADE;


/*-- SEQ 5418 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_pai() CASCADE;


/*-- SEQ 5419 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_per() CASCADE;


/*-- SEQ 5420 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_pes() CASCADE;


/*-- SEQ 5421 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_pgf() CASCADE;


/*-- SEQ 5422 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_pho() CASCADE;


/*-- SEQ 5423 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_pre() CASCADE;


/*-- SEQ 5424 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_pri() CASCADE;


/*-- SEQ 5425 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_reg() CASCADE;


/*-- SEQ 5426 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_rej() CASCADE;


/*-- SEQ 5427 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_rel() CASCADE;


/*-- SEQ 5428 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_rem() CASCADE;


/*-- SEQ 5429 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_req() CASCADE;


/*-- SEQ 5430 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ret() CASCADE;


/*-- SEQ 5431 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_rgc() CASCADE;


/*-- SEQ 5432 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ros() CASCADE;


/*-- SEQ 5433 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_rtt() CASCADE;


/*-- SEQ 5434 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_sad() CASCADE;


/*-- SEQ 5435 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_sad_can() CASCADE;


/*-- SEQ 5436 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_sat() CASCADE;


/*-- SEQ 5437 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_saz() CASCADE;


/*-- SEQ 5438 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ser() CASCADE;


/*-- SEQ 5439 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_set() CASCADE;


/*-- SEQ 5440 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_sit() CASCADE;


/*-- SEQ 5441 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_std() CASCADE;


/*-- SEQ 5442 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_stf() CASCADE;


/*-- SEQ 5443 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_str() CASCADE;


/*-- SEQ 5444 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_sub() CASCADE;


/*-- SEQ 5445 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_tan() CASCADE;


/*-- SEQ 5446 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_tcc() CASCADE;


/*-- SEQ 5447 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_tcd() CASCADE;


/*-- SEQ 5448 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ted() CASCADE;


/*-- SEQ 5449 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_ter() CASCADE;


/*-- SEQ 5450 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_tip() CASCADE;


/*-- SEQ 5451 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_tipxint() CASCADE;


/*-- SEQ 5452 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_tri() CASCADE;


/*-- SEQ 5453 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_vcr() CASCADE;


/*-- SEQ 5454 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_vei() CASCADE;


/*-- SEQ 5455 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_vpe() CASCADE;


/*-- SEQ 5456 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_vtp() CASCADE;


/*-- SEQ 5457 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_td_zaz() CASCADE;


/*-- SEQ 5458 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_te_ccc() CASCADE;


/*-- SEQ 5459 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_te_chr() CASCADE;


/*-- SEQ 5460 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_te_cli() CASCADE;


/*-- SEQ 5461 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_te_ecf() CASCADE;


/*-- SEQ 5462 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_te_ecfxrecf() CASCADE;


/*-- SEQ 5463 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_te_for() CASCADE;


/*-- SEQ 5464 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_te_mov() CASCADE;


/*-- SEQ 5465 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_te_recf() CASCADE;


/*-- SEQ 5466 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_te_venxive() CASCADE;


/*-- SEQ 5467 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_cam() CASCADE;


/*-- SEQ 5468 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_ccc() CASCADE;


/*-- SEQ 5469 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_cfp() CASCADE;


/*-- SEQ 5470 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_chr() CASCADE;


/*-- SEQ 5471 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_cli() CASCADE;


/*-- SEQ 5472 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_com() CASCADE;


/*-- SEQ 5473 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_des() CASCADE;


/*-- SEQ 5474 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_dop() CASCADE;


/*-- SEQ 5475 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_ean() CASCADE;


/*-- SEQ 5476 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_ico() CASCADE;


/*-- SEQ 5477 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_iin() CASCADE;


/*-- SEQ 5478 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_imu() CASCADE;


/*-- SEQ 5479 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_inv() CASCADE;


/*-- SEQ 5480 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_itf() CASCADE;


/*-- SEQ 5481 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_itf_ro() CASCADE;


/*-- SEQ 5482 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_ive() CASCADE;


/*-- SEQ 5483 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_kit() CASCADE;


/*-- SEQ 5484 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_lan() CASCADE;


/*-- SEQ 5485 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_lim() CASCADE;


/*-- SEQ 5486 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_lot() CASCADE;


/*-- SEQ 5487 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_nat() CASCADE;


/*-- SEQ 5488 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_pag() CASCADE;


/*-- SEQ 5489 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_pla() CASCADE;


/*-- SEQ 5490 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_pre() CASCADE;


/*-- SEQ 5491 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_pro() CASCADE;


/*-- SEQ 5492 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_rec() CASCADE;


/*-- SEQ 5493 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_rom() CASCADE;


/*-- SEQ 5494 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_sal() CASCADE;


/*-- SEQ 5495 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_sep() CASCADE;


/*-- SEQ 5496 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_ser() CASCADE;


/*-- SEQ 5497 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_slt() CASCADE;


/*-- SEQ 5498 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_usu() CASCADE;


/*-- SEQ 5499 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_ti_ven() CASCADE;


/*-- SEQ 5500 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tr_cai() CASCADE;


/*-- SEQ 5501 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tr_cta() CASCADE;


/*-- SEQ 5502 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tr_cxg() CASCADE;


/*-- SEQ 5503 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tr_ecf() CASCADE;


/*-- SEQ 5504 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tr_fin() CASCADE;


/*-- SEQ 5505 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tr_mov() CASCADE;


/*-- SEQ 5506 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tr_sug() CASCADE;


/*-- SEQ 5507 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_aba() CASCADE;


/*-- SEQ 5508 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_abm() CASCADE;


/*-- SEQ 5509 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_acm() CASCADE;


/*-- SEQ 5510 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_acr() CASCADE;


/*-- SEQ 5511 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_adi() CASCADE;


/*-- SEQ 5512 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_afe() CASCADE;


/*-- SEQ 5513 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_agc() CASCADE;


/*-- SEQ 5514 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_age() CASCADE;


/*-- SEQ 5515 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_agexusu() CASCADE;


/*-- SEQ 5516 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_anp() CASCADE;


/*-- SEQ 5517 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_anx() CASCADE;


/*-- SEQ 5518 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_aqv() CASCADE;


/*-- SEQ 5519 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_arq() CASCADE;


/*-- SEQ 5520 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ass() CASCADE;


/*-- SEQ 5521 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_atu() CASCADE;


/*-- SEQ 5522 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_aus() CASCADE;


/*-- SEQ 5523 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_aut() CASCADE;


/*-- SEQ 5524 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ava() CASCADE;


/*-- SEQ 5525 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_avi() CASCADE;


/*-- SEQ 5526 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_bai() CASCADE;


/*-- SEQ 5527 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_bicxecf() CASCADE;


/*-- SEQ 5528 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_bon() CASCADE;


/*-- SEQ 5529 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_bonxcli() CASCADE;


/*-- SEQ 5530 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_bru() CASCADE;


/*-- SEQ 5531 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_bsc() CASCADE;


/*-- SEQ 5532 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cai() CASCADE;


/*-- SEQ 5533 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_car() CASCADE;


/*-- SEQ 5534 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cbp() CASCADE;


/*-- SEQ 5535 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cbs() CASCADE;


/*-- SEQ 5536 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ccb() CASCADE;


/*-- SEQ 5537 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ccc() CASCADE;


/*-- SEQ 5538 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cce() CASCADE;


/*-- SEQ 5539 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cct() CASCADE;


/*-- SEQ 5540 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ccx() CASCADE;


/*-- SEQ 5541 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cee() CASCADE;


/*-- SEQ 5542 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ces() CASCADE;


/*-- SEQ 5543 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cesxncm() CASCADE;


/*-- SEQ 5544 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cfc() CASCADE;


/*-- SEQ 5545 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cfg() CASCADE;


/*-- SEQ 5546 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cfg2() CASCADE;


/*-- SEQ 5547 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_chr() CASCADE;


/*-- SEQ 5548 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cid() CASCADE;


/*-- SEQ 5549 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cl12() CASCADE;


/*-- SEQ 5550 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cl2() CASCADE;


/*-- SEQ 5551 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cla() CASCADE;


/*-- SEQ 5552 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cli() CASCADE;


/*-- SEQ 5553 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_clixfil() CASCADE;


/*-- SEQ 5554 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_clixint() CASCADE;


/*-- SEQ 5555 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cms() CASCADE;


/*-- SEQ 5556 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cnc() CASCADE;


/*-- SEQ 5557 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cob() CASCADE;


/*-- SEQ 5558 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cod() CASCADE;


/*-- SEQ 5559 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_com() CASCADE;


/*-- SEQ 5560 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_comxcom() CASCADE;


/*-- SEQ 5561 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_comxcta() CASCADE;


/*-- SEQ 5562 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_con() CASCADE;


/*-- SEQ 5563 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cor() CASCADE;


/*-- SEQ 5564 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_corxcob() CASCADE;


/*-- SEQ 5565 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cos() CASCADE;


/*-- SEQ 5566 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cpe() CASCADE;


/*-- SEQ 5567 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cpf() CASCADE;


/*-- SEQ 5568 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cpfxfor() CASCADE;


/*-- SEQ 5569 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cpm() CASCADE;


/*-- SEQ 5570 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cpr() CASCADE;


/*-- SEQ 5571 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cprxdfil() CASCADE;


/*-- SEQ 5572 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cprxgat() CASCADE;


/*-- SEQ 5573 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cprxpla() CASCADE;


/*-- SEQ 5574 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cprxtpr() CASCADE;


/*-- SEQ 5575 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_crb() CASCADE;


/*-- SEQ 5576 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cre() CASCADE;


/*-- SEQ 5577 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_crtxcli() CASCADE;


/*-- SEQ 5578 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_crtxend() CASCADE;


/*-- SEQ 5579 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_crtxgra() CASCADE;


/*-- SEQ 5580 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_crtxpro() CASCADE;


/*-- SEQ 5581 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_csc() CASCADE;


/*-- SEQ 5582 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cta() CASCADE;


/*-- SEQ 5583 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ctaxdctr() CASCADE;


/*-- SEQ 5584 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ctaxdcus() CASCADE;


/*-- SEQ 5585 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ctaxfil() CASCADE;


/*-- SEQ 5586 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ctb() CASCADE;


/*-- SEQ 5587 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ctbxccb() CASCADE;


/*-- SEQ 5588 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ctf() CASCADE;


/*-- SEQ 5589 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ctm() CASCADE;


/*-- SEQ 5590 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ctr() CASCADE;


/*-- SEQ 5591 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ctt() CASCADE;


/*-- SEQ 5592 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cup() CASCADE;


/*-- SEQ 5593 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cupxuso() CASCADE;


/*-- SEQ 5594 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cus() CASCADE;


/*-- SEQ 5595 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_cxg() CASCADE;


/*-- SEQ 5596 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_dec() CASCADE;


/*-- SEQ 5597 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_del() CASCADE;


/*-- SEQ 5598 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_dep() CASCADE;


/*-- SEQ 5599 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_des() CASCADE;


/*-- SEQ 5600 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_desxcli() CASCADE;


/*-- SEQ 5601 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_desxdccc() CASCADE;


/*-- SEQ 5602 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_desxico() CASCADE;


/*-- SEQ 5603 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_dev() CASCADE;


/*-- SEQ 5604 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_devxrec() CASCADE;


/*-- SEQ 5605 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_dis() CASCADE;


/*-- SEQ 5606 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_div() CASCADE;


/*-- SEQ 5607 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_dmtdxdcorvei() CASCADE;


/*-- SEQ 5608 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_doe() CASCADE;


/*-- SEQ 5609 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_dom() CASCADE;


/*-- SEQ 5610 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_dop() CASCADE;


/*-- SEQ 5611 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_dou() CASCADE;


/*-- SEQ 5612 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_dow() CASCADE;


/*-- SEQ 5613 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_dro() CASCADE;


/*-- SEQ 5614 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_dru() CASCADE;


/*-- SEQ 5615 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_dsp() CASCADE;


/*-- SEQ 5616 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_dxc() CASCADE;


/*-- SEQ 5617 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_dxg() CASCADE;


/*-- SEQ 5618 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_dxi() CASCADE;


/*-- SEQ 5619 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ean() CASCADE;


/*-- SEQ 5620 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ecb() CASCADE;


/*-- SEQ 5621 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ecf() CASCADE;


/*-- SEQ 5622 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ect() CASCADE;


/*-- SEQ 5623 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_edi() CASCADE;


/*-- SEQ 5624 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_end() CASCADE;


/*-- SEQ 5625 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_enp() CASCADE;


/*-- SEQ 5626 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_enq() CASCADE;


/*-- SEQ 5627 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_env() CASCADE;


/*-- SEQ 5628 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_eqp() CASCADE;


/*-- SEQ 5629 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_err() CASCADE;


/*-- SEQ 5630 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_est() CASCADE;


/*-- SEQ 5631 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_eti() CASCADE;


/*-- SEQ 5632 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_exp() CASCADE;


/*-- SEQ 5633 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ext() CASCADE;


/*-- SEQ 5634 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_fcp() CASCADE;


/*-- SEQ 5635 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_fer() CASCADE;


/*-- SEQ 5636 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_fid() CASCADE;


/*-- SEQ 5637 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_filxpla() CASCADE;


/*-- SEQ 5638 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_fin() CASCADE;


/*-- SEQ 5639 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_fis() CASCADE;


/*-- SEQ 5640 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_flw() CASCADE;


/*-- SEQ 5641 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_frexcom() CASCADE;


/*-- SEQ 5642 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_frm() CASCADE;


/*-- SEQ 5643 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_fro() CASCADE;


/*-- SEQ 5644 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_frp() CASCADE;


/*-- SEQ 5645 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ftr() CASCADE;


/*-- SEQ 5646 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_fun() CASCADE;


/*-- SEQ 5647 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_fxc() CASCADE;


/*-- SEQ 5648 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_gab() CASCADE;


/*-- SEQ 5649 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_gatxapl() CASCADE;


/*-- SEQ 5650 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_gatxcli() CASCADE;


/*-- SEQ 5651 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_gatxpro() CASCADE;


/*-- SEQ 5652 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_gra() CASCADE;


/*-- SEQ 5653 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_graxdcar() CASCADE;


/*-- SEQ 5654 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_graxmdv() CASCADE;


/*-- SEQ 5655 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_graxsc() CASCADE;


/*-- SEQ 5656 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_gru() CASCADE;


/*-- SEQ 5657 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_guarda() CASCADE;


/*-- SEQ 5658 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_hnd() CASCADE;


/*-- SEQ 5659 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_hor() CASCADE;


/*-- SEQ 5660 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_hre() CASCADE;


/*-- SEQ 5661 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_htb() CASCADE;


/*-- SEQ 5662 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_iag() CASCADE;


/*-- SEQ 5663 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ibd() CASCADE;


/*-- SEQ 5664 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ibg() CASCADE;


/*-- SEQ 5665 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ibp() CASCADE;


/*-- SEQ 5666 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_icf() CASCADE;


/*-- SEQ 5667 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_icm() CASCADE;


/*-- SEQ 5668 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ico() CASCADE;


/*-- SEQ 5669 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_icoxirc() CASCADE;


/*-- SEQ 5670 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_icoxlot() CASCADE;


/*-- SEQ 5671 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_icp() CASCADE;


/*-- SEQ 5672 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_icpxfor() CASCADE;


/*-- SEQ 5673 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ict() CASCADE;


/*-- SEQ 5674 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_idf() CASCADE;


/*-- SEQ 5675 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_idi() CASCADE;


/*-- SEQ 5676 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ied() CASCADE;


/*-- SEQ 5677 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ien() CASCADE;


/*-- SEQ 5678 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_iex() CASCADE;


/*-- SEQ 5679 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ifc() CASCADE;


/*-- SEQ 5680 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ifo() CASCADE;


/*-- SEQ 5681 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_iin() CASCADE;


/*-- SEQ 5682 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ili() CASCADE;


/*-- SEQ 5683 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ilm() CASCADE;


/*-- SEQ 5684 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_imp() CASCADE;


/*-- SEQ 5685 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_imu() CASCADE;


/*-- SEQ 5686 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_inb() CASCADE;


/*-- SEQ 5687 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ind() CASCADE;


/*-- SEQ 5688 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_inf() CASCADE;


/*-- SEQ 5689 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ini() CASCADE;


/*-- SEQ 5690 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_int() CASCADE;


/*-- SEQ 5691 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_inu() CASCADE;


/*-- SEQ 5692 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_inv() CASCADE;


/*-- SEQ 5693 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ior() CASCADE;


/*-- SEQ 5694 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_iorxcpr() CASCADE;


/*-- SEQ 5695 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_iorxdet() CASCADE;


/*-- SEQ 5696 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ipc() CASCADE;


/*-- SEQ 5697 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ipe() CASCADE;


/*-- SEQ 5698 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ipf() CASCADE;


/*-- SEQ 5699 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_iprexdif() CASCADE;


/*-- SEQ 5700 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ipt() CASCADE;


/*-- SEQ 5701 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_iptxest() CASCADE;


/*-- SEQ 5702 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_iptxexc() CASCADE;


/*-- SEQ 5703 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_iptxncm() CASCADE;


/*-- SEQ 5704 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_iptxpro() CASCADE;


/*-- SEQ 5705 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_iqu() CASCADE;


/*-- SEQ 5706 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_irc() CASCADE;


/*-- SEQ 5707 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ircxipe() CASCADE;


/*-- SEQ 5708 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_iro() CASCADE;


/*-- SEQ 5709 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_isl() CASCADE;


/*-- SEQ 5710 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_itf() CASCADE;


/*-- SEQ 5711 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_itfxctf() CASCADE;


/*-- SEQ 5712 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_iti() CASCADE;


/*-- SEQ 5713 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_itp() CASCADE;


/*-- SEQ 5714 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_iuf() CASCADE;


/*-- SEQ 5715 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ive() CASCADE;


/*-- SEQ 5716 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ivexcpr() CASCADE;


/*-- SEQ 5717 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ivexcsg() CASCADE;


/*-- SEQ 5718 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ivexior() CASCADE;


/*-- SEQ 5719 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ivexipe() CASCADE;


/*-- SEQ 5720 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ivo() CASCADE;


/*-- SEQ 5721 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ixt() CASCADE;


/*-- SEQ 5722 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_job() CASCADE;


/*-- SEQ 5723 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_kit() CASCADE;


/*-- SEQ 5724 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_lac() CASCADE;


/*-- SEQ 5725 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_lan() CASCADE;


/*-- SEQ 5726 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_lay() CASCADE;


/*-- SEQ 5727 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_layxlgpd() CASCADE;


/*-- SEQ 5728 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_lcf() CASCADE;


/*-- SEQ 5729 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_lck() CASCADE;


/*-- SEQ 5730 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_lex() CASCADE;


/*-- SEQ 5731 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_lib() CASCADE;


/*-- SEQ 5732 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_lid() CASCADE;


/*-- SEQ 5733 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_lim() CASCADE;


/*-- SEQ 5734 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_limxfil() CASCADE;


/*-- SEQ 5735 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_lis() CASCADE;


/*-- SEQ 5736 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_lmc() CASCADE;


/*-- SEQ 5737 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_log() CASCADE;


/*-- SEQ 5738 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_loi() CASCADE;


/*-- SEQ 5739 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_lot() CASCADE;


/*-- SEQ 5740 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ltb() CASCADE;


/*-- SEQ 5741 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_mai() CASCADE;


/*-- SEQ 5742 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_mar() CASCADE;


/*-- SEQ 5743 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_mcf() CASCADE;


/*-- SEQ 5744 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_mdt() CASCADE;


/*-- SEQ 5745 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_mer() CASCADE;


/*-- SEQ 5746 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_mes() CASCADE;


/*-- SEQ 5747 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_met() CASCADE;


/*-- SEQ 5748 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_mic() CASCADE;


/*-- SEQ 5749 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_moe() CASCADE;


/*-- SEQ 5750 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_mon() CASCADE;


/*-- SEQ 5751 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_mpb() CASCADE;


/*-- SEQ 5752 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_mpd() CASCADE;


/*-- SEQ 5753 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_mpf() CASCADE;


/*-- SEQ 5754 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_mpr() CASCADE;


/*-- SEQ 5755 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_mrd() CASCADE;


/*-- SEQ 5756 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_msg() CASCADE;


/*-- SEQ 5757 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_mun() CASCADE;


/*-- SEQ 5758 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_mva() CASCADE;


/*-- SEQ 5759 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_nae() CASCADE;


/*-- SEQ 5760 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ncm() CASCADE;


/*-- SEQ 5761 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_nfe() CASCADE;


/*-- SEQ 5762 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_nut() CASCADE;


/*-- SEQ 5763 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_obs() CASCADE;


/*-- SEQ 5764 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_oip() CASCADE;


/*-- SEQ 5765 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_opc() CASCADE;


/*-- SEQ 5766 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ope() CASCADE;


/*-- SEQ 5767 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_orc() CASCADE;


/*-- SEQ 5768 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_orc_eco() CASCADE;


/*-- SEQ 5769 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_out() CASCADE;


/*-- SEQ 5770 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_out_bak() CASCADE;


/*-- SEQ 5771 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_pag() CASCADE;


/*-- SEQ 5772 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_pap() CASCADE;


/*-- SEQ 5773 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_papxusu() CASCADE;


/*-- SEQ 5774 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_pcs() CASCADE;


/*-- SEQ 5775 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ped() CASCADE;


/*-- SEQ 5776 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_pedxddes() CASCADE;


/*-- SEQ 5777 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_per() CASCADE;


/*-- SEQ 5778 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_pho() CASCADE;


/*-- SEQ 5779 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_piv() CASCADE;


/*-- SEQ 5780 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_pla() CASCADE;


/*-- SEQ 5781 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_plaxcar() CASCADE;


/*-- SEQ 5782 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_por() CASCADE;


/*-- SEQ 5783 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ppr() CASCADE;


/*-- SEQ 5784 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_pre() CASCADE;


/*-- SEQ 5785 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_prexdif() CASCADE;


/*-- SEQ 5786 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_prj() CASCADE;


/*-- SEQ 5787 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_prjxpap() CASCADE;


/*-- SEQ 5788 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_prjxprj() CASCADE;


/*-- SEQ 5789 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_prjxusu() CASCADE;


/*-- SEQ 5790 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_pro() CASCADE;


/*-- SEQ 5791 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_proxnom() CASCADE;


/*-- SEQ 5792 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_psu() CASCADE;


/*-- SEQ 5793 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ptc() CASCADE;


/*-- SEQ 5794 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ptr() CASCADE;


/*-- SEQ 5795 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_pxf() CASCADE;


/*-- SEQ 5796 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_pxr() CASCADE;


/*-- SEQ 5797 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_qry() CASCADE;


/*-- SEQ 5798 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_que() CASCADE;


/*-- SEQ 5799 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_rat() CASCADE;


/*-- SEQ 5800 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_rcp() CASCADE;


/*-- SEQ 5801 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_rct() CASCADE;


/*-- SEQ 5802 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_rdp() CASCADE;


/*-- SEQ 5803 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_rdv() CASCADE;


/*-- SEQ 5804 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_rec() CASCADE;


/*-- SEQ 5805 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_red() CASCADE;


/*-- SEQ 5806 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ref() CASCADE;


/*-- SEQ 5807 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_reg() CASCADE;


/*-- SEQ 5808 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_rel() CASCADE;


/*-- SEQ 5809 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_rem() CASCADE;


/*-- SEQ 5810 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ren() CASCADE;


/*-- SEQ 5811 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_req() CASCADE;


/*-- SEQ 5812 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_reqxreq() CASCADE;


/*-- SEQ 5813 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_reqxwor() CASCADE;


/*-- SEQ 5814 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_res() CASCADE;


/*-- SEQ 5815 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ret() CASCADE;


/*-- SEQ 5816 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_rfc() CASCADE;


/*-- SEQ 5817 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_rom() CASCADE;


/*-- SEQ 5818 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_rpp() CASCADE;


/*-- SEQ 5819 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_rps() CASCADE;


/*-- SEQ 5820 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_rtb() CASCADE;


/*-- SEQ 5821 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_rtt() CASCADE;


/*-- SEQ 5822 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_rxf() CASCADE;


/*-- SEQ 5823 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_rzr() CASCADE;


/*-- SEQ 5824 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_sad() CASCADE;


/*-- SEQ 5825 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_sal() CASCADE;


/*-- SEQ 5826 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_sav() CASCADE;


/*-- SEQ 5827 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_sim() CASCADE;


/*-- SEQ 5828 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_sli() CASCADE;


/*-- SEQ 5829 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_slt() CASCADE;


/*-- SEQ 5830 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_spc() CASCADE;


/*-- SEQ 5831 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_sql() CASCADE;


/*-- SEQ 5832 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_srv() CASCADE;


/*-- SEQ 5833 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_sto() CASCADE;


/*-- SEQ 5834 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_sub() CASCADE;


/*-- SEQ 5835 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_sup() CASCADE;


/*-- SEQ 5836 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_supxwor() CASCADE;


/*-- SEQ 5837 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_tar() CASCADE;


/*-- SEQ 5838 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_tcp() CASCADE;


/*-- SEQ 5839 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_tec() CASCADE;


/*-- SEQ 5840 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_tef() CASCADE;


/*-- SEQ 5841 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_teq() CASCADE;


/*-- SEQ 5842 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_tin() CASCADE;


/*-- SEQ 5843 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_tit() CASCADE;


/*-- SEQ 5844 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_tpf() CASCADE;


/*-- SEQ 5845 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_tpr() CASCADE;


/*-- SEQ 5846 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_tprxfil() CASCADE;


/*-- SEQ 5847 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_tra() CASCADE;


/*-- SEQ 5848 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_trc() CASCADE;


/*-- SEQ 5849 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_trn() CASCADE;


/*-- SEQ 5850 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_tsf() CASCADE;


/*-- SEQ 5851 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_uid() CASCADE;


/*-- SEQ 5852 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_usu() CASCADE;


/*-- SEQ 5853 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_utl() CASCADE;


/*-- SEQ 5854 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_vat() CASCADE;


/*-- SEQ 5855 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_vdd() CASCADE;


/*-- SEQ 5856 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_vei() CASCADE;


/*-- SEQ 5857 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ven() CASCADE;


/*-- SEQ 5858 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_venxobs() CASCADE;


/*-- SEQ 5859 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_ver() CASCADE;


/*-- SEQ 5860 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_vol() CASCADE;


/*-- SEQ 5861 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_vot() CASCADE;


/*-- SEQ 5862 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_vpe() CASCADE;


/*-- SEQ 5863 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_vrt() CASCADE;


/*-- SEQ 5864 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_vxp() CASCADE;


/*-- SEQ 5865 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_wor() CASCADE;


/*-- SEQ 5866 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tt_worxwor() CASCADE;


/*-- SEQ 5867 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_arq() CASCADE;


/*-- SEQ 5868 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_ccc() CASCADE;


/*-- SEQ 5869 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_cfg() CASCADE;


/*-- SEQ 5870 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_cli() CASCADE;


/*-- SEQ 5871 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_com_fis() CASCADE;


/*-- SEQ 5872 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_croxdat() CASCADE;


/*-- SEQ 5873 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_croxwor() CASCADE;


/*-- SEQ 5874 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_cta() CASCADE;


/*-- SEQ 5875 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_dom() CASCADE;


/*-- SEQ 5876 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_ecf() CASCADE;


/*-- SEQ 5877 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_ect() CASCADE;


/*-- SEQ 5878 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_ext() CASCADE;


/*-- SEQ 5879 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_extxdoc() CASCADE;


/*-- SEQ 5880 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_fin() CASCADE;


/*-- SEQ 5881 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_fis_75() CASCADE;


/*-- SEQ 5882 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_flu() CASCADE;


/*-- SEQ 5883 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_fpv() CASCADE;


/*-- SEQ 5884 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_fun() CASCADE;


/*-- SEQ 5885 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_fxc() CASCADE;


/*-- SEQ 5886 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_gru() CASCADE;


/*-- SEQ 5887 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_icm() CASCADE;


/*-- SEQ 5888 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_ico_fis() CASCADE;


/*-- SEQ 5889 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_iin() CASCADE;


/*-- SEQ 5890 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_inv_fis() CASCADE;


/*-- SEQ 5891 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_inv_fis_ico_sub() CASCADE;


/*-- SEQ 5892 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_inv_fis_pro_sub() CASCADE;


/*-- SEQ 5893 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_ive() CASCADE;


/*-- SEQ 5894 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_ive_fis() CASCADE;


/*-- SEQ 5895 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_ivexior() CASCADE;


/*-- SEQ 5896 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_key() CASCADE;


/*-- SEQ 5897 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_lay() CASCADE;


/*-- SEQ 5898 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_mov() CASCADE;


/*-- SEQ 5899 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_play() CASCADE;


/*-- SEQ 5900 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_pre() CASCADE;


/*-- SEQ 5901 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_prj() CASCADE;


/*-- SEQ 5902 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_rec() CASCADE;


/*-- SEQ 5903 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_rzr() CASCADE;


/*-- SEQ 5904 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_sac() CASCADE;


/*-- SEQ 5905 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_sal() CASCADE;


/*-- SEQ 5906 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_sql() CASCADE;


/*-- SEQ 5907 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_sup() CASCADE;


/*-- SEQ 5908 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_tab() CASCADE;


/*-- SEQ 5909 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_usu() CASCADE;


/*-- SEQ 5910 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_ven_fis() CASCADE;


/*-- SEQ 5911 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_vres() CASCADE;


/*-- SEQ 5912 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_wor() CASCADE;


/*-- SEQ 5913 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION TR_TESTENULL_tw_worxwor() CASCADE;



/*-- SEQ 5914 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_amb() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desamb)::VARCHAR = '''' THEN
   NEW.desamb := NULL;
END IF;
IF trim(NEW.ambati)::VARCHAR = '''' THEN
   NEW.ambati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_amb
BEFORE INSERT OR UPDATE ON td_amb
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_amb();



/*-- SEQ 5915 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_amp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.ampati)::VARCHAR = '''' THEN
   NEW.ampati := NULL;
END IF;
IF trim(NEW.phocom)::VARCHAR = '''' THEN
   NEW.phocom := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_amp
BEFORE INSERT OR UPDATE ON td_amp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_amp();



/*-- SEQ 5916 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_apr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.aprova)::VARCHAR = '''' THEN
   NEW.aprova := NULL;
END IF;
IF trim(NEW.aprati)::VARCHAR = '''' THEN
   NEW.aprati := NULL;
END IF;
IF trim(NEW.desapr)::VARCHAR = '''' THEN
   NEW.desapr := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_apr
BEFORE INSERT OR UPDATE ON td_apr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_apr();



/*-- SEQ 5917 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_arc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desarc)::VARCHAR = '''' THEN
   NEW.desarc := NULL;
END IF;
IF trim(NEW.arcatv)::VARCHAR = '''' THEN
   NEW.arcatv := NULL;
END IF;
IF trim(NEW.tiparc)::VARCHAR = '''' THEN
   NEW.tiparc := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_arc
BEFORE INSERT OR UPDATE ON td_arc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_arc();



/*-- SEQ 5918 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_bco() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.cbanco)::VARCHAR = '''' THEN
   NEW.cbanco := NULL;
END IF;
IF trim(NEW.bcoati)::VARCHAR = '''' THEN
   NEW.bcoati := NULL;
END IF;
IF trim(NEW.abanco)::VARCHAR = '''' THEN
   NEW.abanco := NULL;
END IF;
IF trim(NEW.nbanco)::VARCHAR = '''' THEN
   NEW.nbanco := NULL;
END IF;
IF trim(NEW.fbanco)::VARCHAR = '''' THEN
   NEW.fbanco := NULL;
END IF;
IF trim(NEW.filbco)::VARCHAR = '''' THEN
   NEW.filbco := NULL;
END IF;
IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_bco
BEFORE INSERT OR UPDATE ON td_bco
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_bco();



/*-- SEQ 5919 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_bic() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filbic)::VARCHAR = '''' THEN
   NEW.filbic := NULL;
END IF;
IF trim(NEW.nivpre)::VARCHAR = '''' THEN
   NEW.nivpre := NULL;
END IF;
IF trim(NEW.bicatv)::VARCHAR = '''' THEN
   NEW.bicatv := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;
IF trim(NEW.fillac)::VARCHAR = '''' THEN
   NEW.fillac := NULL;
END IF;
IF trim(NEW.seqlac)::VARCHAR = '''' THEN
   NEW.seqlac := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_bic
BEFORE INSERT OR UPDATE ON td_bic
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_bic();



/*-- SEQ 5920 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_bom() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.nserie)::VARCHAR = '''' THEN
   NEW.nserie := NULL;
END IF;
IF trim(NEW.nomfab)::VARCHAR = '''' THEN
   NEW.nomfab := NULL;
END IF;
IF trim(NEW.modelo)::VARCHAR = '''' THEN
   NEW.modelo := NULL;
END IF;
IF trim(NEW.tipmed)::VARCHAR = '''' THEN
   NEW.tipmed := NULL;
END IF;
IF trim(NEW.bomati)::VARCHAR = '''' THEN
   NEW.bomati := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_bom
BEFORE INSERT OR UPDATE ON td_bom
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_bom();



/*-- SEQ 5921 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_cai() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.cx_cod)::VARCHAR = '''' THEN
   NEW.cx_cod := NULL;
END IF;
IF trim(NEW.cx_ati)::VARCHAR = '''' THEN
   NEW.cx_ati := NULL;
END IF;
IF trim(NEW.cx_his)::VARCHAR = '''' THEN
   NEW.cx_his := NULL;
END IF;
IF trim(NEW.cx_des)::VARCHAR = '''' THEN
   NEW.cx_des := NULL;
END IF;
IF trim(NEW.ctacai)::VARCHAR = '''' THEN
   NEW.ctacai := NULL;
END IF;
IF trim(NEW.transf)::VARCHAR = '''' THEN
   NEW.transf := NULL;
END IF;
IF trim(NEW.filcai)::VARCHAR = '''' THEN
   NEW.filcai := NULL;
END IF;
IF trim(NEW.seqcai)::VARCHAR = '''' THEN
   NEW.seqcai := NULL;
END IF;
IF trim(NEW.tipcai)::VARCHAR = '''' THEN
   NEW.tipcai := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_cai
BEFORE INSERT OR UPDATE ON td_cai
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_cai();



/*-- SEQ 5922 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_car() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.cobcar)::VARCHAR = '''' THEN
   NEW.cobcar := NULL;
END IF;
IF trim(NEW.tipcar)::VARCHAR = '''' THEN
   NEW.tipcar := NULL;
END IF;
IF trim(NEW.filcar)::VARCHAR = '''' THEN
   NEW.filcar := NULL;
END IF;
IF trim(NEW.seqcar)::VARCHAR = '''' THEN
   NEW.seqcar := NULL;
END IF;
IF trim(NEW.carati)::VARCHAR = '''' THEN
   NEW.carati := NULL;
END IF;
IF trim(NEW.procar)::VARCHAR = '''' THEN
   NEW.procar := NULL;
END IF;
IF trim(NEW.tipadm)::VARCHAR = '''' THEN
   NEW.tipadm := NULL;
END IF;
IF trim(NEW.filadm)::VARCHAR = '''' THEN
   NEW.filadm := NULL;
END IF;
IF trim(NEW.codadm)::VARCHAR = '''' THEN
   NEW.codadm := NULL;
END IF;
IF trim(NEW.desout)::VARCHAR = '''' THEN
   NEW.desout := NULL;
END IF;
IF trim(NEW.ctacar)::VARCHAR = '''' THEN
   NEW.ctacar := NULL;
END IF;
IF trim(NEW.carlet)::VARCHAR = '''' THEN
   NEW.carlet := NULL;
END IF;
IF trim(NEW.carimg)::VARCHAR = '''' THEN
   NEW.carimg := NULL;
END IF;
IF trim(NEW.regcar)::VARCHAR = '''' THEN
   NEW.regcar := NULL;
END IF;
IF trim(NEW.codcre)::VARCHAR = '''' THEN
   NEW.codcre := NULL;
END IF;
IF trim(NEW.bandeb)::VARCHAR = '''' THEN
   NEW.bandeb := NULL;
END IF;
IF trim(NEW.bancre)::VARCHAR = '''' THEN
   NEW.bancre := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_car
BEFORE INSERT OR UPDATE ON td_car
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_car();



/*-- SEQ 5923 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ccb() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.tipccb)::VARCHAR = '''' THEN
   NEW.tipccb := NULL;
END IF;
IF trim(NEW.ccbati)::VARCHAR = '''' THEN
   NEW.ccbati := NULL;
END IF;
IF trim(NEW.apeccb)::VARCHAR = '''' THEN
   NEW.apeccb := NULL;
END IF;
IF trim(NEW.desccb)::VARCHAR = '''' THEN
   NEW.desccb := NULL;
END IF;
IF trim(NEW.envrem)::VARCHAR = '''' THEN
   NEW.envrem := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ccb
BEFORE INSERT OR UPDATE ON td_ccb
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ccb();



/*-- SEQ 5924 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ccc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.tipccc)::VARCHAR = '''' THEN
   NEW.tipccc := NULL;
END IF;
IF trim(NEW.filccc)::VARCHAR = '''' THEN
   NEW.filccc := NULL;
END IF;
IF trim(NEW.seqccc)::VARCHAR = '''' THEN
   NEW.seqccc := NULL;
END IF;
IF trim(NEW.cccati)::VARCHAR = '''' THEN
   NEW.cccati := NULL;
END IF;
IF trim(NEW.cliliv)::VARCHAR = '''' THEN
   NEW.cliliv := NULL;
END IF;
IF trim(NEW.comccc)::VARCHAR = '''' THEN
   NEW.comccc := NULL;
END IF;
IF trim(NEW.desccc)::VARCHAR = '''' THEN
   NEW.desccc := NULL;
END IF;
IF trim(NEW.assccc)::VARCHAR = '''' THEN
   NEW.assccc := NULL;
END IF;
IF trim(NEW.txtccc)::VARCHAR = '''' THEN
   NEW.txtccc := NULL;
END IF;
IF trim(NEW.regccc)::VARCHAR = '''' THEN
   NEW.regccc := NULL;
END IF;
IF trim(NEW.ctaccc)::VARCHAR = '''' THEN
   NEW.ctaccc := NULL;
END IF;
IF trim(NEW.sqlccc)::VARCHAR = '''' THEN
   NEW.sqlccc := NULL;
END IF;
IF trim(NEW.ccclet)::VARCHAR = '''' THEN
   NEW.ccclet := NULL;
END IF;
IF trim(NEW.cccimg)::VARCHAR = '''' THEN
   NEW.cccimg := NULL;
END IF;
IF trim(NEW.ccccai)::VARCHAR = '''' THEN
   NEW.ccccai := NULL;
END IF;
IF trim(NEW.codext_dccc)::VARCHAR = '''' THEN
   NEW.codext_dccc := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ccc
BEFORE INSERT OR UPDATE ON td_ccc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ccc();



/*-- SEQ 5925 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_cds() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.cdsati)::VARCHAR = '''' THEN
   NEW.cdsati := NULL;
END IF;
IF trim(NEW.codcds)::VARCHAR = '''' THEN
   NEW.codcds := NULL;
END IF;
IF trim(NEW.descds)::VARCHAR = '''' THEN
   NEW.descds := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_cds
BEFORE INSERT OR UPDATE ON td_cds
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_cds();



/*-- SEQ 5926 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_cfo() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.descfo)::VARCHAR = '''' THEN
   NEW.descfo := NULL;
END IF;
IF trim(NEW.cfoati)::VARCHAR = '''' THEN
   NEW.cfoati := NULL;
END IF;
IF trim(NEW.codcfo)::VARCHAR = '''' THEN
   NEW.codcfo := NULL;
END IF;
IF trim(NEW.extcfo)::VARCHAR = '''' THEN
   NEW.extcfo := NULL;
END IF;
IF trim(NEW.cfomod)::VARCHAR = '''' THEN
   NEW.cfomod := NULL;
END IF;
IF trim(NEW.cfocta_fil)::VARCHAR = '''' THEN
   NEW.cfocta_fil := NULL;
END IF;
IF trim(NEW.cfocta_seq)::VARCHAR = '''' THEN
   NEW.cfocta_seq := NULL;
END IF;
IF trim(NEW.cfocta_tip)::VARCHAR = '''' THEN
   NEW.cfocta_tip := NULL;
END IF;
IF trim(NEW.movest_dcfo)::VARCHAR = '''' THEN
   NEW.movest_dcfo := NULL;
END IF;
IF trim(NEW.cfofor)::VARCHAR = '''' THEN
   NEW.cfofor := NULL;
END IF;
IF trim(NEW.tipccm)::VARCHAR = '''' THEN
   NEW.tipccm := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_cfo
BEFORE INSERT OR UPDATE ON td_cfo
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_cfo();



/*-- SEQ 5927 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_cfp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.cfpati)::VARCHAR = '''' THEN
   NEW.cfpati := NULL;
END IF;
IF trim(NEW.descfp)::VARCHAR = '''' THEN
   NEW.descfp := NULL;
END IF;
IF trim(NEW.vencon)::VARCHAR = '''' THEN
   NEW.vencon := NULL;
END IF;
IF trim(NEW.venrev)::VARCHAR = '''' THEN
   NEW.venrev := NULL;
END IF;
IF trim(NEW.devcon)::VARCHAR = '''' THEN
   NEW.devcon := NULL;
END IF;
IF trim(NEW.devrev)::VARCHAR = '''' THEN
   NEW.devrev := NULL;
END IF;
IF trim(NEW.saicon)::VARCHAR = '''' THEN
   NEW.saicon := NULL;
END IF;
IF trim(NEW.sairev)::VARCHAR = '''' THEN
   NEW.sairev := NULL;
END IF;
IF trim(NEW.entcon)::VARCHAR = '''' THEN
   NEW.entcon := NULL;
END IF;
IF trim(NEW.entrev)::VARCHAR = '''' THEN
   NEW.entrev := NULL;
END IF;
IF trim(NEW.comcon)::VARCHAR = '''' THEN
   NEW.comcon := NULL;
END IF;
IF trim(NEW.comrev)::VARCHAR = '''' THEN
   NEW.comrev := NULL;
END IF;
IF trim(NEW.dvccon)::VARCHAR = '''' THEN
   NEW.dvccon := NULL;
END IF;
IF trim(NEW.dvcrev)::VARCHAR = '''' THEN
   NEW.dvcrev := NULL;
END IF;
IF trim(NEW.intcon)::VARCHAR = '''' THEN
   NEW.intcon := NULL;
END IF;
IF trim(NEW.intrev)::VARCHAR = '''' THEN
   NEW.intrev := NULL;
END IF;
IF trim(NEW.vencon_for)::VARCHAR = '''' THEN
   NEW.vencon_for := NULL;
END IF;
IF trim(NEW.venrev_for)::VARCHAR = '''' THEN
   NEW.venrev_for := NULL;
END IF;
IF trim(NEW.devcon_for)::VARCHAR = '''' THEN
   NEW.devcon_for := NULL;
END IF;
IF trim(NEW.devrev_for)::VARCHAR = '''' THEN
   NEW.devrev_for := NULL;
END IF;
IF trim(NEW.saicon_for)::VARCHAR = '''' THEN
   NEW.saicon_for := NULL;
END IF;
IF trim(NEW.sairev_for)::VARCHAR = '''' THEN
   NEW.sairev_for := NULL;
END IF;
IF trim(NEW.entcon_for)::VARCHAR = '''' THEN
   NEW.entcon_for := NULL;
END IF;
IF trim(NEW.entrev_for)::VARCHAR = '''' THEN
   NEW.entrev_for := NULL;
END IF;
IF trim(NEW.comcon_for)::VARCHAR = '''' THEN
   NEW.comcon_for := NULL;
END IF;
IF trim(NEW.comrev_for)::VARCHAR = '''' THEN
   NEW.comrev_for := NULL;
END IF;
IF trim(NEW.dvccon_for)::VARCHAR = '''' THEN
   NEW.dvccon_for := NULL;
END IF;
IF trim(NEW.dvcrev_for)::VARCHAR = '''' THEN
   NEW.dvcrev_for := NULL;
END IF;
IF trim(NEW.intcon_for)::VARCHAR = '''' THEN
   NEW.intcon_for := NULL;
END IF;
IF trim(NEW.intrev_for)::VARCHAR = '''' THEN
   NEW.intrev_for := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_cfp
BEFORE INSERT OR UPDATE ON td_cfp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_cfp();



/*-- SEQ 5928 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_cl1() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.cl1ati)::VARCHAR = '''' THEN
   NEW.cl1ati := NULL;
END IF;
IF trim(NEW.class1)::VARCHAR = '''' THEN
   NEW.class1 := NULL;
END IF;
IF trim(NEW.codex1)::VARCHAR = '''' THEN
   NEW.codex1 := NULL;
END IF;
IF trim(NEW.combus)::VARCHAR = '''' THEN
   NEW.combus := NULL;
END IF;
IF trim(NEW.cl1web)::VARCHAR = '''' THEN
   NEW.cl1web := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_cl1
BEFORE INSERT OR UPDATE ON td_cl1
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_cl1();



/*-- SEQ 5929 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_cl2() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.cl2ati)::VARCHAR = '''' THEN
   NEW.cl2ati := NULL;
END IF;
IF trim(NEW.class2)::VARCHAR = '''' THEN
   NEW.class2 := NULL;
END IF;
IF trim(NEW.codex2)::VARCHAR = '''' THEN
   NEW.codex2 := NULL;
END IF;
IF trim(NEW.cl2web)::VARCHAR = '''' THEN
   NEW.cl2web := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_cl2
BEFORE INSERT OR UPDATE ON td_cl2
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_cl2();



/*-- SEQ 5930 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_cl3() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.cl3ati)::VARCHAR = '''' THEN
   NEW.cl3ati := NULL;
END IF;
IF trim(NEW.class3)::VARCHAR = '''' THEN
   NEW.class3 := NULL;
END IF;
IF trim(NEW.codex3)::VARCHAR = '''' THEN
   NEW.codex3 := NULL;
END IF;
IF trim(NEW.cl3web)::VARCHAR = '''' THEN
   NEW.cl3web := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_cl3
BEFORE INSERT OR UPDATE ON td_cl3
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_cl3();



/*-- SEQ 5931 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_cl4() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.cl4ati)::VARCHAR = '''' THEN
   NEW.cl4ati := NULL;
END IF;
IF trim(NEW.class4)::VARCHAR = '''' THEN
   NEW.class4 := NULL;
END IF;
IF trim(NEW.codex4)::VARCHAR = '''' THEN
   NEW.codex4 := NULL;
END IF;
IF trim(NEW.cl4web)::VARCHAR = '''' THEN
   NEW.cl4web := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_cl4
BEFORE INSERT OR UPDATE ON td_cl4
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_cl4();



/*-- SEQ 5932 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_clt() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.cltatv)::VARCHAR = '''' THEN
   NEW.cltatv := NULL;
END IF;
IF trim(NEW.desclt)::VARCHAR = '''' THEN
   NEW.desclt := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_clt
BEFORE INSERT OR UPDATE ON td_clt
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_clt();



/*-- SEQ 5933 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_cnc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.cncati)::VARCHAR = '''' THEN
   NEW.cncati := NULL;
END IF;
IF trim(NEW.nomcnc)::VARCHAR = '''' THEN
   NEW.nomcnc := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_cnc
BEFORE INSERT OR UPDATE ON td_cnc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_cnc();



/*-- SEQ 5934 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_cob() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.tipcob)::VARCHAR = '''' THEN
   NEW.tipcob := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.gertit)::VARCHAR = '''' THEN
   NEW.gertit := NULL;
END IF;
IF trim(NEW.cobati)::VARCHAR = '''' THEN
   NEW.cobati := NULL;
END IF;
IF trim(NEW.tipctb)::VARCHAR = '''' THEN
   NEW.tipctb := NULL;
END IF;
IF trim(NEW.descob)::VARCHAR = '''' THEN
   NEW.descob := NULL;
END IF;
IF trim(NEW.saicar)::VARCHAR = '''' THEN
   NEW.saicar := NULL;
END IF;
IF trim(NEW.txtcob)::VARCHAR = '''' THEN
   NEW.txtcob := NULL;
END IF;
IF trim(NEW.coblet)::VARCHAR = '''' THEN
   NEW.coblet := NULL;
END IF;
IF trim(NEW.cobimg)::VARCHAR = '''' THEN
   NEW.cobimg := NULL;
END IF;
IF trim(NEW.codext_dcob)::VARCHAR = '''' THEN
   NEW.codext_dcob := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_cob
BEFORE INSERT OR UPDATE ON td_cob
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_cob();



/*-- SEQ 5935 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_col() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.colati)::VARCHAR = '''' THEN
   NEW.colati := NULL;
END IF;
IF trim(NEW.footer)::VARCHAR = '''' THEN
   NEW.footer := NULL;
END IF;
IF trim(NEW.header)::VARCHAR = '''' THEN
   NEW.header := NULL;
END IF;
IF trim(NEW.sepdec)::VARCHAR = '''' THEN
   NEW.sepdec := NULL;
END IF;
IF trim(NEW.nomcol)::VARCHAR = '''' THEN
   NEW.nomcol := NULL;
END IF;
IF trim(NEW.zeresq)::VARCHAR = '''' THEN
   NEW.zeresq := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_col
BEFORE INSERT OR UPDATE ON td_col
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_col();



/*-- SEQ 5936 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_com() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.comati)::VARCHAR = '''' THEN
   NEW.comati := NULL;
END IF;
IF trim(NEW.descom)::VARCHAR = '''' THEN
   NEW.descom := NULL;
END IF;
IF trim(NEW.cabcom)::VARCHAR = '''' THEN
   NEW.cabcom := NULL;
END IF;
IF trim(NEW.itecom)::VARCHAR = '''' THEN
   NEW.itecom := NULL;
END IF;
IF trim(NEW.rodcom)::VARCHAR = '''' THEN
   NEW.rodcom := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_com
BEFORE INSERT OR UPDATE ON td_com
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_com();



/*-- SEQ 5937 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_con() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.conati)::VARCHAR = '''' THEN
   NEW.conati := NULL;
END IF;
IF trim(NEW.tipcon)::VARCHAR = '''' THEN
   NEW.tipcon := NULL;
END IF;
IF trim(NEW.descon)::VARCHAR = '''' THEN
   NEW.descon := NULL;
END IF;
IF trim(NEW.clacon)::VARCHAR = '''' THEN
   NEW.clacon := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_con
BEFORE INSERT OR UPDATE ON td_con
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_con();



/*-- SEQ 5938 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_cor() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.rb_cor)::VARCHAR = '''' THEN
   NEW.rb_cor := NULL;
END IF;
IF trim(NEW.coratv)::VARCHAR = '''' THEN
   NEW.coratv := NULL;
END IF;
IF trim(NEW.titcor)::VARCHAR = '''' THEN
   NEW.titcor := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_cor
BEFORE INSERT OR UPDATE ON td_cor
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_cor();



/*-- SEQ 5939 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_corvei() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.descorvei)::VARCHAR = '''' THEN
   NEW.descorvei := NULL;
END IF;
IF trim(NEW.corveiati)::VARCHAR = '''' THEN
   NEW.corveiati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_corvei
BEFORE INSERT OR UPDATE ON td_corvei
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_corvei();



/*-- SEQ 5940 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_cre() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.coluna)::VARCHAR = '''' THEN
   NEW.coluna := NULL;
END IF;
IF trim(NEW.colpai)::VARCHAR = '''' THEN
   NEW.colpai := NULL;
END IF;
IF trim(NEW.descri)::VARCHAR = '''' THEN
   NEW.descri := NULL;
END IF;
IF trim(NEW.despon)::VARCHAR = '''' THEN
   NEW.despon := NULL;
END IF;
IF trim(NEW.tipdad)::VARCHAR = '''' THEN
   NEW.tipdad := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_cre
BEFORE INSERT OR UPDATE ON td_cre
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_cre();



/*-- SEQ 5941 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_crt() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.usodet)::VARCHAR = '''' THEN
   NEW.usodet := NULL;
END IF;
IF trim(NEW.tipcrt)::VARCHAR = '''' THEN
   NEW.tipcrt := NULL;
END IF;
IF trim(NEW.nn_crt)::VARCHAR = '''' THEN
   NEW.nn_crt := NULL;
END IF;
IF trim(NEW.descrt)::VARCHAR = '''' THEN
   NEW.descrt := NULL;
END IF;
IF trim(NEW.mincrt)::VARCHAR = '''' THEN
   NEW.mincrt := NULL;
END IF;
IF trim(NEW.maxcrt)::VARCHAR = '''' THEN
   NEW.maxcrt := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_crt
BEFORE INSERT OR UPDATE ON td_crt
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_crt();



/*-- SEQ 5942 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ct1() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.ct1ati)::VARCHAR = '''' THEN
   NEW.ct1ati := NULL;
END IF;
IF trim(NEW.nomct1)::VARCHAR = '''' THEN
   NEW.nomct1 := NULL;
END IF;
IF trim(NEW.codext_dct1)::VARCHAR = '''' THEN
   NEW.codext_dct1 := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ct1
BEFORE INSERT OR UPDATE ON td_ct1
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ct1();



/*-- SEQ 5943 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ct2() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.ct2ati)::VARCHAR = '''' THEN
   NEW.ct2ati := NULL;
END IF;
IF trim(NEW.nomct2)::VARCHAR = '''' THEN
   NEW.nomct2 := NULL;
END IF;
IF trim(NEW.codext_dct2)::VARCHAR = '''' THEN
   NEW.codext_dct2 := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ct2
BEFORE INSERT OR UPDATE ON td_ct2
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ct2();



/*-- SEQ 5944 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ct3() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.ct3ati)::VARCHAR = '''' THEN
   NEW.ct3ati := NULL;
END IF;
IF trim(NEW.nomct3)::VARCHAR = '''' THEN
   NEW.nomct3 := NULL;
END IF;
IF trim(NEW.codext_dct3)::VARCHAR = '''' THEN
   NEW.codext_dct3 := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ct3
BEFORE INSERT OR UPDATE ON td_ct3
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ct3();



/*-- SEQ 5945 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_cta() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.descta)::VARCHAR = '''' THEN
   NEW.descta := NULL;
END IF;
IF trim(NEW.cfgcol)::VARCHAR = '''' THEN
   NEW.cfgcol := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.usocta)::VARCHAR = '''' THEN
   NEW.usocta := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_cta
BEFORE INSERT OR UPDATE ON td_cta
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_cta();



/*-- SEQ 5946 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ctr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.ctrtip)::VARCHAR = '''' THEN
   NEW.ctrtip := NULL;
END IF;
IF trim(NEW.ctrfil)::VARCHAR = '''' THEN
   NEW.ctrfil := NULL;
END IF;
IF trim(NEW.ctrseq)::VARCHAR = '''' THEN
   NEW.ctrseq := NULL;
END IF;
IF trim(NEW.ctrati)::VARCHAR = '''' THEN
   NEW.ctrati := NULL;
END IF;
IF trim(NEW.desctr)::VARCHAR = '''' THEN
   NEW.desctr := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.ctruso)::VARCHAR = '''' THEN
   NEW.ctruso := NULL;
END IF;
IF trim(NEW.patped)::VARCHAR = '''' THEN
   NEW.patped := NULL;
END IF;
IF trim(NEW.filpra)::VARCHAR = '''' THEN
   NEW.filpra := NULL;
END IF;
IF trim(NEW.seqpra)::VARCHAR = '''' THEN
   NEW.seqpra := NULL;
END IF;
IF trim(NEW.tippra)::VARCHAR = '''' THEN
   NEW.tippra := NULL;
END IF;
IF trim(NEW.ctrest_fil)::VARCHAR = '''' THEN
   NEW.ctrest_fil := NULL;
END IF;
IF trim(NEW.ctrest_seq)::VARCHAR = '''' THEN
   NEW.ctrest_seq := NULL;
END IF;
IF trim(NEW.ctrest_tip)::VARCHAR = '''' THEN
   NEW.ctrest_tip := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ctr
BEFORE INSERT OR UPDATE ON td_ctr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ctr();



/*-- SEQ 5947 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_cus() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.cusati)::VARCHAR = '''' THEN
   NEW.cusati := NULL;
END IF;
IF trim(NEW.cencus)::VARCHAR = '''' THEN
   NEW.cencus := NULL;
END IF;
IF trim(NEW.extcus)::VARCHAR = '''' THEN
   NEW.extcus := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_cus
BEFORE INSERT OR UPDATE ON td_cus
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_cus();



/*-- SEQ 5948 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_cws() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.cwsati)::VARCHAR = '''' THEN
   NEW.cwsati := NULL;
END IF;
IF trim(NEW.descws)::VARCHAR = '''' THEN
   NEW.descws := NULL;
END IF;
IF trim(NEW.pedaut)::VARCHAR = '''' THEN
   NEW.pedaut := NULL;
END IF;
IF trim(NEW.tipcws)::VARCHAR = '''' THEN
   NEW.tipcws := NULL;
END IF;
IF trim(NEW.horcws)::VARCHAR = '''' THEN
   NEW.horcws := NULL;
END IF;
IF trim(NEW.tipwor)::VARCHAR = '''' THEN
   NEW.tipwor := NULL;
END IF;
IF trim(NEW.oricws)::VARCHAR = '''' THEN
   NEW.oricws := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_cws
BEFORE INSERT OR UPDATE ON td_cws
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_cws();



/*-- SEQ 5949 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_dep() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.depati)::VARCHAR = '''' THEN
   NEW.depati := NULL;
END IF;
IF trim(NEW.contab)::VARCHAR = '''' THEN
   NEW.contab := NULL;
END IF;
IF trim(NEW.desdep)::VARCHAR = '''' THEN
   NEW.desdep := NULL;
END IF;
IF trim(NEW.imgdep)::VARCHAR = '''' THEN
   NEW.imgdep := NULL;
END IF;
IF trim(NEW.depweb)::VARCHAR = '''' THEN
   NEW.depweb := NULL;
END IF;
IF trim(NEW.codpos_ddep)::VARCHAR = '''' THEN
   NEW.codpos_ddep := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_dep
BEFORE INSERT OR UPDATE ON td_dep
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_dep();



/*-- SEQ 5950 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_des() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.tipdes)::VARCHAR = '''' THEN
   NEW.tipdes := NULL;
END IF;
IF trim(NEW.desatv)::VARCHAR = '''' THEN
   NEW.desatv := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_des
BEFORE INSERT OR UPDATE ON td_des
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_des();



/*-- SEQ 5951 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_det() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.usodet)::VARCHAR = '''' THEN
   NEW.usodet := NULL;
END IF;
IF trim(NEW.desdet)::VARCHAR = '''' THEN
   NEW.desdet := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_det
BEFORE INSERT OR UPDATE ON td_det
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_det();



/*-- SEQ 5952 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_dev() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desdev)::VARCHAR = '''' THEN
   NEW.desdev := NULL;
END IF;
IF trim(NEW.devati)::VARCHAR = '''' THEN
   NEW.devati := NULL;
END IF;
IF trim(NEW.usodev)::VARCHAR = '''' THEN
   NEW.usodev := NULL;
END IF;
IF trim(NEW.vlrdev)::VARCHAR = '''' THEN
   NEW.vlrdev := NULL;
END IF;
IF trim(NEW.clidev)::VARCHAR = '''' THEN
   NEW.clidev := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_dev
BEFORE INSERT OR UPDATE ON td_dev
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_dev();



/*-- SEQ 5953 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_dfc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.coddfc)::VARCHAR = '''' THEN
   NEW.coddfc := NULL;
END IF;
IF trim(NEW.desdfc)::VARCHAR = '''' THEN
   NEW.desdfc := NULL;
END IF;
IF trim(NEW.dfcati)::VARCHAR = '''' THEN
   NEW.dfcati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_dfc
BEFORE INSERT OR UPDATE ON td_dfc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_dfc();



/*-- SEQ 5954 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_div() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.divati)::VARCHAR = '''' THEN
   NEW.divati := NULL;
END IF;
IF trim(NEW.nomdiv)::VARCHAR = '''' THEN
   NEW.nomdiv := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_div
BEFORE INSERT OR UPDATE ON td_div
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_div();



/*-- SEQ 5955 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_doc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.tipdoc)::VARCHAR = '''' THEN
   NEW.tipdoc := NULL;
END IF;
IF trim(NEW.docatv)::VARCHAR = '''' THEN
   NEW.docatv := NULL;
END IF;
IF trim(NEW.desdoc)::VARCHAR = '''' THEN
   NEW.desdoc := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_doc
BEFORE INSERT OR UPDATE ON td_doc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_doc();



/*-- SEQ 5956 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_dop() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.dopati)::VARCHAR = '''' THEN
   NEW.dopati := NULL;
END IF;
IF trim(NEW.desdop)::VARCHAR = '''' THEN
   NEW.desdop := NULL;
END IF;
IF trim(NEW.tiptit)::VARCHAR = '''' THEN
   NEW.tiptit := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_dop
BEFORE INSERT OR UPDATE ON td_dop
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_dop();



/*-- SEQ 5957 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ean() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.eanati)::VARCHAR = '''' THEN
   NEW.eanati := NULL;
END IF;
IF trim(NEW.desean)::VARCHAR = '''' THEN
   NEW.desean := NULL;
END IF;
IF trim(NEW.eanfil)::VARCHAR = '''' THEN
   NEW.eanfil := NULL;
END IF;
IF trim(NEW.eancod)::VARCHAR = '''' THEN
   NEW.eancod := NULL;
END IF;
IF trim(NEW.usaven)::VARCHAR = '''' THEN
   NEW.usaven := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ean
BEFORE INSERT OR UPDATE ON td_ean
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ean();



/*-- SEQ 5958 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ecb() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.ecbati)::VARCHAR = '''' THEN
   NEW.ecbati := NULL;
END IF;
IF trim(NEW.desecb)::VARCHAR = '''' THEN
   NEW.desecb := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ecb
BEFORE INSERT OR UPDATE ON td_ecb
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ecb();



/*-- SEQ 5959 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ecf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.cobecf)::VARCHAR = '''' THEN
   NEW.cobecf := NULL;
END IF;
IF trim(NEW.codori)::VARCHAR = '''' THEN
   NEW.codori := NULL;
END IF;
IF trim(NEW.filecf)::VARCHAR = '''' THEN
   NEW.filecf := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.ecfati)::VARCHAR = '''' THEN
   NEW.ecfati := NULL;
END IF;
IF trim(NEW.serecf)::VARCHAR = '''' THEN
   NEW.serecf := NULL;
END IF;
IF trim(NEW.ctadif)::VARCHAR = '''' THEN
   NEW.ctadif := NULL;
END IF;
IF trim(NEW.ctaabe)::VARCHAR = '''' THEN
   NEW.ctaabe := NULL;
END IF;
IF trim(NEW.ctafec)::VARCHAR = '''' THEN
   NEW.ctafec := NULL;
END IF;
IF trim(NEW.ctatro)::VARCHAR = '''' THEN
   NEW.ctatro := NULL;
END IF;
IF trim(NEW.saienv)::VARCHAR = '''' THEN
   NEW.saienv := NULL;
END IF;
IF trim(NEW.maqecf)::VARCHAR = '''' THEN
   NEW.maqecf := NULL;
END IF;
IF trim(NEW.marecf)::VARCHAR = '''' THEN
   NEW.marecf := NULL;
END IF;
IF trim(NEW.modecf)::VARCHAR = '''' THEN
   NEW.modecf := NULL;
END IF;
IF trim(NEW.vswecf)::VARCHAR = '''' THEN
   NEW.vswecf := NULL;
END IF;
IF trim(NEW.codfab)::VARCHAR = '''' THEN
   NEW.codfab := NULL;
END IF;
IF trim(NEW.codmod)::VARCHAR = '''' THEN
   NEW.codmod := NULL;
END IF;
IF trim(NEW.fitdet)::VARCHAR = '''' THEN
   NEW.fitdet := NULL;
END IF;
IF trim(NEW.ecfutl)::VARCHAR = '''' THEN
   NEW.ecfutl := NULL;
END IF;
IF trim(NEW.ecfmfa)::VARCHAR = '''' THEN
   NEW.ecfmfa := NULL;
END IF;
IF trim(NEW.ecftip)::VARCHAR = '''' THEN
   NEW.ecftip := NULL;
END IF;
IF trim(NEW.tnciee)::VARCHAR = '''' THEN
   NEW.tnciee := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;
IF trim(NEW.codext_decf)::VARCHAR = '''' THEN
   NEW.codext_decf := NULL;
END IF;
IF trim(NEW.arrtru)::VARCHAR = '''' THEN
   NEW.arrtru := NULL;
END IF;
IF trim(NEW.status_dados)::VARCHAR = '''' THEN
   NEW.status_dados := NULL;
END IF;
IF trim(NEW.ck4g_homol)::VARCHAR = '''' THEN
   NEW.ck4g_homol := NULL;
END IF;
IF trim(NEW.ck4g_detver)::VARCHAR = '''' THEN
   NEW.ck4g_detver := NULL;
END IF;
IF trim(NEW.ck4g_usafrete)::VARCHAR = '''' THEN
   NEW.ck4g_usafrete := NULL;
END IF;
IF trim(NEW.ck4g_zsomenteapos24h)::VARCHAR = '''' THEN
   NEW.ck4g_zsomenteapos24h := NULL;
END IF;
IF trim(NEW.ck4g_md5)::VARCHAR = '''' THEN
   NEW.ck4g_md5 := NULL;
END IF;
IF trim(NEW.ck4g_modfis_vc)::VARCHAR = '''' THEN
   NEW.ck4g_modfis_vc := NULL;
END IF;
IF trim(NEW.ck4g_modfis_vc_cont)::VARCHAR = '''' THEN
   NEW.ck4g_modfis_vc_cont := NULL;
END IF;
IF trim(NEW.ck4g_usa_cont_offline)::VARCHAR = '''' THEN
   NEW.ck4g_usa_cont_offline := NULL;
END IF;
IF trim(NEW.flgcfe)::VARCHAR = '''' THEN
   NEW.flgcfe := NULL;
END IF;
IF trim(NEW.decf_numext)::VARCHAR = '''' THEN
   NEW.decf_numext := NULL;
END IF;
IF trim(NEW.sercon_decf)::VARCHAR = '''' THEN
   NEW.sercon_decf := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ecf
BEFORE INSERT OR UPDATE ON td_ecf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ecf();



/*-- SEQ 5960 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_end() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desend)::VARCHAR = '''' THEN
   NEW.desend := NULL;
END IF;
IF trim(NEW.endatv)::VARCHAR = '''' THEN
   NEW.endatv := NULL;
END IF;
IF trim(NEW.dupend)::VARCHAR = '''' THEN
   NEW.dupend := NULL;
END IF;
IF trim(NEW.usoend)::VARCHAR = '''' THEN
   NEW.usoend := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_end
BEFORE INSERT OR UPDATE ON td_end
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_end();



/*-- SEQ 5961 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ent() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.tipent)::VARCHAR = '''' THEN
   NEW.tipent := NULL;
END IF;
IF trim(NEW.desent)::VARCHAR = '''' THEN
   NEW.desent := NULL;
END IF;
IF trim(NEW.entati)::VARCHAR = '''' THEN
   NEW.entati := NULL;
END IF;
IF trim(NEW.entfil)::VARCHAR = '''' THEN
   NEW.entfil := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ent
BEFORE INSERT OR UPDATE ON td_ent
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ent();



/*-- SEQ 5962 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_esp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.espati)::VARCHAR = '''' THEN
   NEW.espati := NULL;
END IF;
IF trim(NEW.especi)::VARCHAR = '''' THEN
   NEW.especi := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_esp
BEFORE INSERT OR UPDATE ON td_esp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_esp();



/*-- SEQ 5963 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_est() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.estado)::VARCHAR = '''' THEN
   NEW.estado := NULL;
END IF;
IF trim(NEW.aliint)::VARCHAR = '''' THEN
   NEW.aliint := NULL;
END IF;
IF trim(NEW.estati)::VARCHAR = '''' THEN
   NEW.estati := NULL;
END IF;
IF trim(NEW.icmcid)::VARCHAR = '''' THEN
   NEW.icmcid := NULL;
END IF;
IF trim(NEW.norint)::VARCHAR = '''' THEN
   NEW.norint := NULL;
END IF;
IF trim(NEW.sombas)::VARCHAR = '''' THEN
   NEW.sombas := NULL;
END IF;
IF trim(NEW.inscst)::VARCHAR = '''' THEN
   NEW.inscst := NULL;
END IF;
IF trim(NEW.nomest)::VARCHAR = '''' THEN
   NEW.nomest := NULL;
END IF;
IF trim(NEW.basmar)::VARCHAR = '''' THEN
   NEW.basmar := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_est
BEFORE INSERT OR UPDATE ON td_est
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_est();



/*-- SEQ 5964 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_eti() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.etiati)::VARCHAR = '''' THEN
   NEW.etiati := NULL;
END IF;
IF trim(NEW.deseti)::VARCHAR = '''' THEN
   NEW.deseti := NULL;
END IF;
IF trim(NEW.rbfile)::VARCHAR = '''' THEN
   NEW.rbfile := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_eti
BEFORE INSERT OR UPDATE ON td_eti
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_eti();



/*-- SEQ 5965 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_exp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.atiexp)::VARCHAR = '''' THEN
   NEW.atiexp := NULL;
END IF;
IF trim(NEW.desexp)::VARCHAR = '''' THEN
   NEW.desexp := NULL;
END IF;
IF trim(NEW.aliexp)::VARCHAR = '''' THEN
   NEW.aliexp := NULL;
END IF;
IF trim(NEW.usoexc)::VARCHAR = '''' THEN
   NEW.usoexc := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_exp
BEFORE INSERT OR UPDATE ON td_exp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_exp();



/*-- SEQ 5966 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ext() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desext)::VARCHAR = '''' THEN
   NEW.desext := NULL;
END IF;
IF trim(NEW.locrec)::VARCHAR = '''' THEN
   NEW.locrec := NULL;
END IF;
IF trim(NEW.locccc)::VARCHAR = '''' THEN
   NEW.locccc := NULL;
END IF;
IF trim(NEW.locchr)::VARCHAR = '''' THEN
   NEW.locchr := NULL;
END IF;
IF trim(NEW.locfin)::VARCHAR = '''' THEN
   NEW.locfin := NULL;
END IF;
IF trim(NEW.locdop)::VARCHAR = '''' THEN
   NEW.locdop := NULL;
END IF;
IF trim(NEW.loctit)::VARCHAR = '''' THEN
   NEW.loctit := NULL;
END IF;
IF trim(NEW.locdep)::VARCHAR = '''' THEN
   NEW.locdep := NULL;
END IF;
IF trim(NEW.gerfin)::VARCHAR = '''' THEN
   NEW.gerfin := NULL;
END IF;
IF trim(NEW.gerccc)::VARCHAR = '''' THEN
   NEW.gerccc := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ext
BEFORE INSERT OR UPDATE ON td_ext
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ext();



/*-- SEQ 5967 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_fcc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.fccati)::VARCHAR = '''' THEN
   NEW.fccati := NULL;
END IF;
IF trim(NEW.fccfil)::VARCHAR = '''' THEN
   NEW.fccfil := NULL;
END IF;
IF trim(NEW.fcc_filmat)::VARCHAR = '''' THEN
   NEW.fcc_filmat := NULL;
END IF;
IF trim(NEW.fcc_codmat)::VARCHAR = '''' THEN
   NEW.fcc_codmat := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_fcc
BEFORE INSERT OR UPDATE ON td_fcc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_fcc();



/*-- SEQ 5968 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_fce() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desfce)::VARCHAR = '''' THEN
   NEW.desfce := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_fce
BEFORE INSERT OR UPDATE ON td_fce
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_fce();



/*-- SEQ 5969 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_fid() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.atifid)::VARCHAR = '''' THEN
   NEW.atifid := NULL;
END IF;
IF trim(NEW.desfid)::VARCHAR = '''' THEN
   NEW.desfid := NULL;
END IF;
IF trim(NEW.imgfid)::VARCHAR = '''' THEN
   NEW.imgfid := NULL;
END IF;
IF trim(NEW.clafid)::VARCHAR = '''' THEN
   NEW.clafid := NULL;
END IF;
IF trim(NEW.imgfud)::VARCHAR = '''' THEN
   NEW.imgfud := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_fid
BEFORE INSERT OR UPDATE ON td_fid
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_fid();



/*-- SEQ 5970 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_fil() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.coddep)::VARCHAR = '''' THEN
   NEW.coddep := NULL;
END IF;
IF trim(NEW.codcid)::VARCHAR = '''' THEN
   NEW.codcid := NULL;
END IF;
IF trim(NEW.conver)::VARCHAR = '''' THEN
   NEW.conver := NULL;
END IF;
IF trim(NEW.filati)::VARCHAR = '''' THEN
   NEW.filati := NULL;
END IF;
IF trim(NEW.nomfil)::VARCHAR = '''' THEN
   NEW.nomfil := NULL;
END IF;
IF trim(NEW.razsoc)::VARCHAR = '''' THEN
   NEW.razsoc := NULL;
END IF;
IF trim(NEW.codcep)::VARCHAR = '''' THEN
   NEW.codcep := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.dddfil)::VARCHAR = '''' THEN
   NEW.dddfil := NULL;
END IF;
IF trim(NEW.numero)::VARCHAR = '''' THEN
   NEW.numero := NULL;
END IF;
IF trim(NEW.faxfil)::VARCHAR = '''' THEN
   NEW.faxfil := NULL;
END IF;
IF trim(NEW.fonfil)::VARCHAR = '''' THEN
   NEW.fonfil := NULL;
END IF;
IF trim(NEW.homol1)::VARCHAR = '''' THEN
   NEW.homol1 := NULL;
END IF;
IF trim(NEW.homol2)::VARCHAR = '''' THEN
   NEW.homol2 := NULL;
END IF;
IF trim(NEW.homver)::VARCHAR = '''' THEN
   NEW.homver := NULL;
END IF;
IF trim(NEW.hom_bo)::VARCHAR = '''' THEN
   NEW.hom_bo := NULL;
END IF;
IF trim(NEW.hom_ca)::VARCHAR = '''' THEN
   NEW.hom_ca := NULL;
END IF;
IF trim(NEW.hom_cf)::VARCHAR = '''' THEN
   NEW.hom_cf := NULL;
END IF;
IF trim(NEW.hom_cg)::VARCHAR = '''' THEN
   NEW.hom_cg := NULL;
END IF;
IF trim(NEW.hom_co)::VARCHAR = '''' THEN
   NEW.hom_co := NULL;
END IF;
IF trim(NEW.hom_cs)::VARCHAR = '''' THEN
   NEW.hom_cs := NULL;
END IF;
IF trim(NEW.hom_eb)::VARCHAR = '''' THEN
   NEW.hom_eb := NULL;
END IF;
IF trim(NEW.hom_ec)::VARCHAR = '''' THEN
   NEW.hom_ec := NULL;
END IF;
IF trim(NEW.hom_nb)::VARCHAR = '''' THEN
   NEW.hom_nb := NULL;
END IF;
IF trim(NEW.hom_nc)::VARCHAR = '''' THEN
   NEW.hom_nc := NULL;
END IF;
IF trim(NEW.hom_ns)::VARCHAR = '''' THEN
   NEW.hom_ns := NULL;
END IF;
IF trim(NEW.hom_or)::VARCHAR = '''' THEN
   NEW.hom_or := NULL;
END IF;
IF trim(NEW.hom_rb)::VARCHAR = '''' THEN
   NEW.hom_rb := NULL;
END IF;
IF trim(NEW.hom_sd)::VARCHAR = '''' THEN
   NEW.hom_sd := NULL;
END IF;
IF trim(NEW.hom_se)::VARCHAR = '''' THEN
   NEW.hom_se := NULL;
END IF;
IF trim(NEW.hom_sw)::VARCHAR = '''' THEN
   NEW.hom_sw := NULL;
END IF;
IF trim(NEW.hom_tm)::VARCHAR = '''' THEN
   NEW.hom_tm := NULL;
END IF;
IF trim(NEW.hom_to)::VARCHAR = '''' THEN
   NEW.hom_to := NULL;
END IF;
IF trim(NEW.numser)::VARCHAR = '''' THEN
   NEW.numser := NULL;
END IF;
IF trim(NEW.numfon)::VARCHAR = '''' THEN
   NEW.numfon := NULL;
END IF;
IF trim(NEW.bairro)::VARCHAR = '''' THEN
   NEW.bairro := NULL;
END IF;
IF trim(NEW.cgcfil)::VARCHAR = '''' THEN
   NEW.cgcfil := NULL;
END IF;
IF trim(NEW.contat)::VARCHAR = '''' THEN
   NEW.contat := NULL;
END IF;
IF trim(NEW.e_mail)::VARCHAR = '''' THEN
   NEW.e_mail := NULL;
END IF;
IF trim(NEW.hompge)::VARCHAR = '''' THEN
   NEW.hompge := NULL;
END IF;
IF trim(NEW.endere)::VARCHAR = '''' THEN
   NEW.endere := NULL;
END IF;
IF trim(NEW.respon)::VARCHAR = '''' THEN
   NEW.respon := NULL;
END IF;
IF trim(NEW.acefil)::VARCHAR = '''' THEN
   NEW.acefil := NULL;
END IF;
IF trim(NEW.imgfil)::VARCHAR = '''' THEN
   NEW.imgfil := NULL;
END IF;
IF trim(NEW.patcar)::VARCHAR = '''' THEN
   NEW.patcar := NULL;
END IF;
IF trim(NEW.patped)::VARCHAR = '''' THEN
   NEW.patped := NULL;
END IF;
IF trim(NEW.pat_aa)::VARCHAR = '''' THEN
   NEW.pat_aa := NULL;
END IF;
IF trim(NEW.ufloja)::VARCHAR = '''' THEN
   NEW.ufloja := NULL;
END IF;
IF trim(NEW.pattke)::VARCHAR = '''' THEN
   NEW.pattke := NULL;
END IF;
IF trim(NEW.filtes)::VARCHAR = '''' THEN
   NEW.filtes := NULL;
END IF;
IF trim(NEW.seqtes)::VARCHAR = '''' THEN
   NEW.seqtes := NULL;
END IF;
IF trim(NEW.filtrn)::VARCHAR = '''' THEN
   NEW.filtrn := NULL;
END IF;
IF trim(NEW.seqtrn)::VARCHAR = '''' THEN
   NEW.seqtrn := NULL;
END IF;
IF trim(NEW.tiptrn)::VARCHAR = '''' THEN
   NEW.tiptrn := NULL;
END IF;
IF trim(NEW.filger)::VARCHAR = '''' THEN
   NEW.filger := NULL;
END IF;
IF trim(NEW.codger)::VARCHAR = '''' THEN
   NEW.codger := NULL;
END IF;
IF trim(NEW.comple)::VARCHAR = '''' THEN
   NEW.comple := NULL;
END IF;
IF trim(NEW.ie_fil)::VARCHAR = '''' THEN
   NEW.ie_fil := NULL;
END IF;
IF trim(NEW.tcmipi)::VARCHAR = '''' THEN
   NEW.tcmipi := NULL;
END IF;
IF trim(NEW.tipbom)::VARCHAR = '''' THEN
   NEW.tipbom := NULL;
END IF;
IF trim(NEW.regtri)::VARCHAR = '''' THEN
   NEW.regtri := NULL;
END IF;
IF trim(NEW.red_cf)::VARCHAR = '''' THEN
   NEW.red_cf := NULL;
END IF;
IF trim(NEW.acr_cf)::VARCHAR = '''' THEN
   NEW.acr_cf := NULL;
END IF;
IF trim(NEW.re8020)::VARCHAR = '''' THEN
   NEW.re8020 := NULL;
END IF;
IF trim(NEW.fillan)::VARCHAR = '''' THEN
   NEW.fillan := NULL;
END IF;
IF trim(NEW.seqlan)::VARCHAR = '''' THEN
   NEW.seqlan := NULL;
END IF;
IF trim(NEW.tiplan)::VARCHAR = '''' THEN
   NEW.tiplan := NULL;
END IF;
IF trim(NEW.filtar)::VARCHAR = '''' THEN
   NEW.filtar := NULL;
END IF;
IF trim(NEW.seqtar)::VARCHAR = '''' THEN
   NEW.seqtar := NULL;
END IF;
IF trim(NEW.tiptar)::VARCHAR = '''' THEN
   NEW.tiptar := NULL;
END IF;
IF trim(NEW.filjur)::VARCHAR = '''' THEN
   NEW.filjur := NULL;
END IF;
IF trim(NEW.seqjur)::VARCHAR = '''' THEN
   NEW.seqjur := NULL;
END IF;
IF trim(NEW.tipjur)::VARCHAR = '''' THEN
   NEW.tipjur := NULL;
END IF;
IF trim(NEW.filcpm)::VARCHAR = '''' THEN
   NEW.filcpm := NULL;
END IF;
IF trim(NEW.seqcpm)::VARCHAR = '''' THEN
   NEW.seqcpm := NULL;
END IF;
IF trim(NEW.tipcpm)::VARCHAR = '''' THEN
   NEW.tipcpm := NULL;
END IF;
IF trim(NEW.poremp)::VARCHAR = '''' THEN
   NEW.poremp := NULL;
END IF;
IF trim(NEW.insmun)::VARCHAR = '''' THEN
   NEW.insmun := NULL;
END IF;
IF trim(NEW.patcon)::VARCHAR = '''' THEN
   NEW.patcon := NULL;
END IF;
IF trim(NEW.fil_ct)::VARCHAR = '''' THEN
   NEW.fil_ct := NULL;
END IF;
IF trim(NEW.seq_ct)::VARCHAR = '''' THEN
   NEW.seq_ct := NULL;
END IF;
IF trim(NEW.tip_ct)::VARCHAR = '''' THEN
   NEW.tip_ct := NULL;
END IF;
IF trim(NEW.nomfar)::VARCHAR = '''' THEN
   NEW.nomfar := NULL;
END IF;
IF trim(NEW.crffar)::VARCHAR = '''' THEN
   NEW.crffar := NULL;
END IF;
IF trim(NEW.licfar)::VARCHAR = '''' THEN
   NEW.licfar := NULL;
END IF;
IF trim(NEW.baifil)::VARCHAR = '''' THEN
   NEW.baifil := NULL;
END IF;
IF trim(NEW.baiout)::VARCHAR = '''' THEN
   NEW.baiout := NULL;
END IF;
IF trim(NEW.tesfil)::VARCHAR = '''' THEN
   NEW.tesfil := NULL;
END IF;
IF trim(NEW.tesseq)::VARCHAR = '''' THEN
   NEW.tesseq := NULL;
END IF;
IF trim(NEW.testip)::VARCHAR = '''' THEN
   NEW.testip := NULL;
END IF;
IF trim(NEW.serpad)::VARCHAR = '''' THEN
   NEW.serpad := NULL;
END IF;
IF trim(NEW.chehom)::VARCHAR = '''' THEN
   NEW.chehom := NULL;
END IF;
IF trim(NEW.filout)::VARCHAR = '''' THEN
   NEW.filout := NULL;
END IF;
IF trim(NEW.seqout)::VARCHAR = '''' THEN
   NEW.seqout := NULL;
END IF;
IF trim(NEW.tipout)::VARCHAR = '''' THEN
   NEW.tipout := NULL;
END IF;
IF trim(NEW.patnot)::VARCHAR = '''' THEN
   NEW.patnot := NULL;
END IF;
IF trim(NEW.baispc)::VARCHAR = '''' THEN
   NEW.baispc := NULL;
END IF;
IF trim(NEW.trisim)::VARCHAR = '''' THEN
   NEW.trisim := NULL;
END IF;
IF trim(NEW.digitacao_atacado)::VARCHAR = '''' THEN
   NEW.digitacao_atacado := NULL;
END IF;
IF trim(NEW.ratipi_frete)::VARCHAR = '''' THEN
   NEW.ratipi_frete := NULL;
END IF;
IF trim(NEW.filweb)::VARCHAR = '''' THEN
   NEW.filweb := NULL;
END IF;
IF trim(NEW.ckpanomina)::VARCHAR = '''' THEN
   NEW.ckpanomina := NULL;
END IF;
IF trim(NEW.ckpacidche)::VARCHAR = '''' THEN
   NEW.ckpacidche := NULL;
END IF;
IF trim(NEW.tipluc)::VARCHAR = '''' THEN
   NEW.tipluc := NULL;
END IF;
IF trim(NEW.pafecf)::VARCHAR = '''' THEN
   NEW.pafecf := NULL;
END IF;
IF trim(NEW.preven)::VARCHAR = '''' THEN
   NEW.preven := NULL;
END IF;
IF trim(NEW.davnfs)::VARCHAR = '''' THEN
   NEW.davnfs := NULL;
END IF;
IF trim(NEW.davfis)::VARCHAR = '''' THEN
   NEW.davfis := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;
IF trim(NEW.filcnt)::VARCHAR = '''' THEN
   NEW.filcnt := NULL;
END IF;
IF trim(NEW.codcnt)::VARCHAR = '''' THEN
   NEW.codcnt := NULL;
END IF;
IF trim(NEW.patnfe)::VARCHAR = '''' THEN
   NEW.patnfe := NULL;
END IF;
IF trim(NEW.filpag)::VARCHAR = '''' THEN
   NEW.filpag := NULL;
END IF;
IF trim(NEW.seqpag)::VARCHAR = '''' THEN
   NEW.seqpag := NULL;
END IF;
IF trim(NEW.tippag)::VARCHAR = '''' THEN
   NEW.tippag := NULL;
END IF;
IF trim(NEW.ctcpag)::VARCHAR = '''' THEN
   NEW.ctcpag := NULL;
END IF;
IF trim(NEW.percre)::VARCHAR = '''' THEN
   NEW.percre := NULL;
END IF;
IF trim(NEW.traori)::VARCHAR = '''' THEN
   NEW.traori := NULL;
END IF;
IF trim(NEW.servid)::VARCHAR = '''' THEN
   NEW.servid := NULL;
END IF;
IF trim(NEW.datbas)::VARCHAR = '''' THEN
   NEW.datbas := NULL;
END IF;
IF trim(NEW.ecfest)::VARCHAR = '''' THEN
   NEW.ecfest := NULL;
END IF;
IF trim(NEW.ck_ven_cmb_est_zer)::VARCHAR = '''' THEN
   NEW.ck_ven_cmb_est_zer := NULL;
END IF;
IF trim(NEW.ip_sfc)::VARCHAR = '''' THEN
   NEW.ip_sfc := NULL;
END IF;
IF trim(NEW.patimgchr)::VARCHAR = '''' THEN
   NEW.patimgchr := NULL;
END IF;
IF trim(NEW.basicm_maj)::VARCHAR = '''' THEN
   NEW.basicm_maj := NULL;
END IF;
IF trim(NEW.substituta)::VARCHAR = '''' THEN
   NEW.substituta := NULL;
END IF;
IF trim(NEW.filven)::VARCHAR = '''' THEN
   NEW.filven := NULL;
END IF;
IF trim(NEW.codven)::VARCHAR = '''' THEN
   NEW.codven := NULL;
END IF;
IF trim(NEW.creddf)::VARCHAR = '''' THEN
   NEW.creddf := NULL;
END IF;
IF trim(NEW.perfil)::VARCHAR = '''' THEN
   NEW.perfil := NULL;
END IF;
IF trim(NEW.obs_des_st)::VARCHAR = '''' THEN
   NEW.obs_des_st := NULL;
END IF;
IF trim(NEW.obs_st_dev)::VARCHAR = '''' THEN
   NEW.obs_st_dev := NULL;
END IF;
IF trim(NEW.obs_perdas)::VARCHAR = '''' THEN
   NEW.obs_perdas := NULL;
END IF;
IF trim(NEW.st_interestadual)::VARCHAR = '''' THEN
   NEW.st_interestadual := NULL;
END IF;
IF trim(NEW.ip_tef)::VARCHAR = '''' THEN
   NEW.ip_tef := NULL;
END IF;
IF trim(NEW.codtef)::VARCHAR = '''' THEN
   NEW.codtef := NULL;
END IF;
IF trim(NEW.tef_avista)::VARCHAR = '''' THEN
   NEW.tef_avista := NULL;
END IF;
IF trim(NEW.tef_aprazo)::VARCHAR = '''' THEN
   NEW.tef_aprazo := NULL;
END IF;
IF trim(NEW.tef_adcionais)::VARCHAR = '''' THEN
   NEW.tef_adcionais := NULL;
END IF;
IF trim(NEW.tef_parametros)::VARCHAR = '''' THEN
   NEW.tef_parametros := NULL;
END IF;
IF trim(NEW.filent_regesp)::VARCHAR = '''' THEN
   NEW.filent_regesp := NULL;
END IF;
IF trim(NEW.tipcom)::VARCHAR = '''' THEN
   NEW.tipcom := NULL;
END IF;
IF trim(NEW.desipi)::VARCHAR = '''' THEN
   NEW.desipi := NULL;
END IF;
IF trim(NEW.desipitra)::VARCHAR = '''' THEN
   NEW.desipitra := NULL;
END IF;
IF trim(NEW.serdev)::VARCHAR = '''' THEN
   NEW.serdev := NULL;
END IF;
IF trim(NEW.ck4g_modfis_vc)::VARCHAR = '''' THEN
   NEW.ck4g_modfis_vc := NULL;
END IF;
IF trim(NEW.ck4g_modfis_vc_cont)::VARCHAR = '''' THEN
   NEW.ck4g_modfis_vc_cont := NULL;
END IF;
IF trim(NEW.ck4g_usa_cont_offline)::VARCHAR = '''' THEN
   NEW.ck4g_usa_cont_offline := NULL;
END IF;
IF trim(NEW.replica_saldo)::VARCHAR = '''' THEN
   NEW.replica_saldo := NULL;
END IF;
IF trim(NEW.usaparicm)::VARCHAR = '''' THEN
   NEW.usaparicm := NULL;
END IF;
IF trim(NEW.ip_middle)::VARCHAR = '''' THEN
   NEW.ip_middle := NULL;
END IF;
IF trim(NEW.serimp)::VARCHAR = '''' THEN
   NEW.serimp := NULL;
END IF;
IF trim(NEW.tipcobret)::VARCHAR = '''' THEN
   NEW.tipcobret := NULL;
END IF;
IF trim(NEW.ip_orderlocal)::VARCHAR = '''' THEN
   NEW.ip_orderlocal := NULL;
END IF;
IF trim(NEW.sernfreci)::VARCHAR = '''' THEN
   NEW.sernfreci := NULL;
END IF;
IF trim(NEW.nf_con)::VARCHAR = '''' THEN
   NEW.nf_con := NULL;
END IF;
IF trim(NEW.serrps)::VARCHAR = '''' THEN
   NEW.serrps := NULL;
END IF;
IF trim(NEW.ck4g_itememunicalinha)::VARCHAR = '''' THEN
   NEW.ck4g_itememunicalinha := NULL;
END IF;
IF trim(NEW.sercfe)::VARCHAR = '''' THEN
   NEW.sercfe := NULL;
END IF;
IF trim(NEW.sersat)::VARCHAR = '''' THEN
   NEW.sersat := NULL;
END IF;
IF trim(NEW.filclidoa)::VARCHAR = '''' THEN
   NEW.filclidoa := NULL;
END IF;
IF trim(NEW.codclidoa)::VARCHAR = '''' THEN
   NEW.codclidoa := NULL;
END IF;
IF trim(NEW.sertra)::VARCHAR = '''' THEN
   NEW.sertra := NULL;
END IF;
IF trim(NEW.tef_codlojaut)::VARCHAR = '''' THEN
   NEW.tef_codlojaut := NULL;
END IF;
IF trim(NEW.tef_codestaut)::VARCHAR = '''' THEN
   NEW.tef_codestaut := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_fil
BEFORE INSERT OR UPDATE ON td_fil
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_fil();



/*-- SEQ 5971 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_fin() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.finati)::VARCHAR = '''' THEN
   NEW.finati := NULL;
END IF;
IF trim(NEW.desfin)::VARCHAR = '''' THEN
   NEW.desfin := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_fin
BEFORE INSERT OR UPDATE ON td_fin
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_fin();



/*-- SEQ 5972 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_fis() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.fisati)::VARCHAR = '''' THEN
   NEW.fisati := NULL;
END IF;
IF trim(NEW.codfis)::VARCHAR = '''' THEN
   NEW.codfis := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_fis
BEFORE INSERT OR UPDATE ON td_fis
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_fis();



/*-- SEQ 5973 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_fps() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfps)::VARCHAR = '''' THEN
   NEW.codfps := NULL;
END IF;
IF trim(NEW.desfps)::VARCHAR = '''' THEN
   NEW.desfps := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_fps
BEFORE INSERT OR UPDATE ON td_fps
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_fps();



/*-- SEQ 5974 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_fre() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desfre)::VARCHAR = '''' THEN
   NEW.desfre := NULL;
END IF;
IF trim(NEW.freati)::VARCHAR = '''' THEN
   NEW.freati := NULL;
END IF;
IF trim(NEW.dfre_tipcob)::VARCHAR = '''' THEN
   NEW.dfre_tipcob := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_fre
BEFORE INSERT OR UPDATE ON td_fre
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_fre();



/*-- SEQ 5975 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_fun() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.funati)::VARCHAR = '''' THEN
   NEW.funati := NULL;
END IF;
IF trim(NEW.desfun)::VARCHAR = '''' THEN
   NEW.desfun := NULL;
END IF;
IF trim(NEW.codfun)::VARCHAR = '''' THEN
   NEW.codfun := NULL;
END IF;
IF trim(NEW.funpai)::VARCHAR = '''' THEN
   NEW.funpai := NULL;
END IF;
IF trim(NEW.tipfun)::VARCHAR = '''' THEN
   NEW.tipfun := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_fun
BEFORE INSERT OR UPDATE ON td_fun
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_fun();



/*-- SEQ 5976 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_gra() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.graati)::VARCHAR = '''' THEN
   NEW.graati := NULL;
END IF;
IF trim(NEW.nomgra)::VARCHAR = '''' THEN
   NEW.nomgra := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_gra
BEFORE INSERT OR UPDATE ON td_gra
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_gra();



/*-- SEQ 5977 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_gru() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.gruati)::VARCHAR = '''' THEN
   NEW.gruati := NULL;
END IF;
IF trim(NEW.desgru)::VARCHAR = '''' THEN
   NEW.desgru := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_gru
BEFORE INSERT OR UPDATE ON td_gru
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_gru();



/*-- SEQ 5978 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_hom() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codhom)::VARCHAR = '''' THEN
   NEW.codhom := NULL;
END IF;
IF trim(NEW.atihom)::VARCHAR = '''' THEN
   NEW.atihom := NULL;
END IF;
IF trim(NEW.deshom)::VARCHAR = '''' THEN
   NEW.deshom := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_hom
BEFORE INSERT OR UPDATE ON td_hom
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_hom();



/*-- SEQ 5979 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_icm() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.icmati)::VARCHAR = '''' THEN
   NEW.icmati := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_icm
BEFORE INSERT OR UPDATE ON td_icm
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_icm();



/*-- SEQ 5980 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ies() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.es_ati)::VARCHAR = '''' THEN
   NEW.es_ati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ies
BEFORE INSERT OR UPDATE ON td_ies
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ies();



/*-- SEQ 5981 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ime() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.me_ati)::VARCHAR = '''' THEN
   NEW.me_ati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ime
BEFORE INSERT OR UPDATE ON td_ime
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ime();



/*-- SEQ 5982 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_img() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desimg)::VARCHAR = '''' THEN
   NEW.desimg := NULL;
END IF;
IF trim(NEW.letimg)::VARCHAR = '''' THEN
   NEW.letimg := NULL;
END IF;
IF trim(NEW.nomimg)::VARCHAR = '''' THEN
   NEW.nomimg := NULL;
END IF;
IF trim(NEW.imgati)::VARCHAR = '''' THEN
   NEW.imgati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_img
BEFORE INSERT OR UPDATE ON td_img
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_img();



/*-- SEQ 5983 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ina() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desina)::VARCHAR = '''' THEN
   NEW.desina := NULL;
END IF;
IF trim(NEW.inaati)::VARCHAR = '''' THEN
   NEW.inaati := NULL;
END IF;
IF trim(NEW.usoina)::VARCHAR = '''' THEN
   NEW.usoina := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ina
BEFORE INSERT OR UPDATE ON td_ina
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ina();



/*-- SEQ 5984 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ins() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.insati)::VARCHAR = '''' THEN
   NEW.insati := NULL;
END IF;
IF trim(NEW.desins)::VARCHAR = '''' THEN
   NEW.desins := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ins
BEFORE INSERT OR UPDATE ON td_ins
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ins();



/*-- SEQ 5985 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ipi() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.ipiati)::VARCHAR = '''' THEN
   NEW.ipiati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ipi
BEFORE INSERT OR UPDATE ON td_ipi
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ipi();



/*-- SEQ 5986 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ir1() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.r1_ati)::VARCHAR = '''' THEN
   NEW.r1_ati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ir1
BEFORE INSERT OR UPDATE ON td_ir1
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ir1();



/*-- SEQ 5987 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ir2() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.r2_ati)::VARCHAR = '''' THEN
   NEW.r2_ati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ir2
BEFORE INSERT OR UPDATE ON td_ir2
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ir2();



/*-- SEQ 5988 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ire() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.re_ati)::VARCHAR = '''' THEN
   NEW.re_ati := NULL;
END IF;
IF trim(NEW.aplcon)::VARCHAR = '''' THEN
   NEW.aplcon := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ire
BEFORE INSERT OR UPDATE ON td_ire
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ire();



/*-- SEQ 5989 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_irr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.irrati)::VARCHAR = '''' THEN
   NEW.irrati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_irr
BEFORE INSERT OR UPDATE ON td_irr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_irr();



/*-- SEQ 5990 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_iso() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.isoati)::VARCHAR = '''' THEN
   NEW.isoati := NULL;
END IF;
IF trim(NEW.phoiso)::VARCHAR = '''' THEN
   NEW.phoiso := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_iso
BEFORE INSERT OR UPDATE ON td_iso
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_iso();



/*-- SEQ 5991 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_iss() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.issati)::VARCHAR = '''' THEN
   NEW.issati := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_iss
BEFORE INSERT OR UPDATE ON td_iss
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_iss();



/*-- SEQ 5992 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_jus() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.jusati)::VARCHAR = '''' THEN
   NEW.jusati := NULL;
END IF;
IF trim(NEW.desjus)::VARCHAR = '''' THEN
   NEW.desjus := NULL;
END IF;
IF trim(NEW.comjus)::VARCHAR = '''' THEN
   NEW.comjus := NULL;
END IF;
IF trim(NEW.tipjus)::VARCHAR = '''' THEN
   NEW.tipjus := NULL;
END IF;
IF trim(NEW.avijus)::VARCHAR = '''' THEN
   NEW.avijus := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_jus
BEFORE INSERT OR UPDATE ON td_jus
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_jus();



/*-- SEQ 5993 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_lan() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.sinlan)::VARCHAR = '''' THEN
   NEW.sinlan := NULL;
END IF;
IF trim(NEW.lanati)::VARCHAR = '''' THEN
   NEW.lanati := NULL;
END IF;
IF trim(NEW.deslan)::VARCHAR = '''' THEN
   NEW.deslan := NULL;
END IF;
IF trim(NEW.lanvlr)::VARCHAR = '''' THEN
   NEW.lanvlr := NULL;
END IF;
IF trim(NEW.lanedi)::VARCHAR = '''' THEN
   NEW.lanedi := NULL;
END IF;
IF trim(NEW.movleg)::VARCHAR = '''' THEN
   NEW.movleg := NULL;
END IF;
IF trim(NEW.fillan)::VARCHAR = '''' THEN
   NEW.fillan := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_lan
BEFORE INSERT OR UPDATE ON td_lan
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_lan();



/*-- SEQ 5994 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_lcr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desles)::VARCHAR = '''' THEN
   NEW.desles := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_lcr
BEFORE INSERT OR UPDATE ON td_lcr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_lcr();



/*-- SEQ 5995 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_lib() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.libati)::VARCHAR = '''' THEN
   NEW.libati := NULL;
END IF;
IF trim(NEW.codlib)::VARCHAR = '''' THEN
   NEW.codlib := NULL;
END IF;
IF trim(NEW.deslib)::VARCHAR = '''' THEN
   NEW.deslib := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_lib
BEFORE INSERT OR UPDATE ON td_lib
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_lib();



/*-- SEQ 5996 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_lpc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.lpcati)::VARCHAR = '''' THEN
   NEW.lpcati := NULL;
END IF;
IF trim(NEW.deslpc)::VARCHAR = '''' THEN
   NEW.deslpc := NULL;
END IF;
IF trim(NEW.numext)::VARCHAR = '''' THEN
   NEW.numext := NULL;
END IF;
IF trim(NEW.tiprce)::VARCHAR = '''' THEN
   NEW.tiprce := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_lpc
BEFORE INSERT OR UPDATE ON td_lpc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_lpc();



/*-- SEQ 5997 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_maq() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.maqatv)::VARCHAR = '''' THEN
   NEW.maqatv := NULL;
END IF;
IF trim(NEW.nommaq)::VARCHAR = '''' THEN
   NEW.nommaq := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_maq
BEFORE INSERT OR UPDATE ON td_maq
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_maq();



/*-- SEQ 5998 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_mar() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.marati)::VARCHAR = '''' THEN
   NEW.marati := NULL;
END IF;
IF trim(NEW.phomar)::VARCHAR = '''' THEN
   NEW.phomar := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_mar
BEFORE INSERT OR UPDATE ON td_mar
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_mar();



/*-- SEQ 5999 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_mdv() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desmdv)::VARCHAR = '''' THEN
   NEW.desmdv := NULL;
END IF;
IF trim(NEW.disexi)::VARCHAR = '''' THEN
   NEW.disexi := NULL;
END IF;
IF trim(NEW.mdvati)::VARCHAR = '''' THEN
   NEW.mdvati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_mdv
BEFORE INSERT OR UPDATE ON td_mdv
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_mdv();



/*-- SEQ 6000 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_med() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.medati)::VARCHAR = '''' THEN
   NEW.medati := NULL;
END IF;
IF trim(NEW.unimed)::VARCHAR = '''' THEN
   NEW.unimed := NULL;
END IF;
IF trim(NEW.desmed)::VARCHAR = '''' THEN
   NEW.desmed := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;
IF trim(NEW.codpos_dmed)::VARCHAR = '''' THEN
   NEW.codpos_dmed := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_med
BEFORE INSERT OR UPDATE ON td_med
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_med();



/*-- SEQ 6001 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_mnf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codmnf)::VARCHAR = '''' THEN
   NEW.codmnf := NULL;
END IF;
IF trim(NEW.desmnf)::VARCHAR = '''' THEN
   NEW.desmnf := NULL;
END IF;
IF trim(NEW.impmnf)::VARCHAR = '''' THEN
   NEW.impmnf := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_mnf
BEFORE INSERT OR UPDATE ON td_mnf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_mnf();



/*-- SEQ 6002 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_mod() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.modati)::VARCHAR = '''' THEN
   NEW.modati := NULL;
END IF;
IF trim(NEW.modulo)::VARCHAR = '''' THEN
   NEW.modulo := NULL;
END IF;
IF trim(NEW.codsac)::VARCHAR = '''' THEN
   NEW.codsac := NULL;
END IF;
IF trim(NEW.codwor)::VARCHAR = '''' THEN
   NEW.codwor := NULL;
END IF;
IF trim(NEW.filsac)::VARCHAR = '''' THEN
   NEW.filsac := NULL;
END IF;
IF trim(NEW.filwor)::VARCHAR = '''' THEN
   NEW.filwor := NULL;
END IF;
IF trim(NEW.veratu)::VARCHAR = '''' THEN
   NEW.veratu := NULL;
END IF;
IF trim(NEW.filint)::VARCHAR = '''' THEN
   NEW.filint := NULL;
END IF;
IF trim(NEW.codint)::VARCHAR = '''' THEN
   NEW.codint := NULL;
END IF;
IF trim(NEW.filtst)::VARCHAR = '''' THEN
   NEW.filtst := NULL;
END IF;
IF trim(NEW.codtst)::VARCHAR = '''' THEN
   NEW.codtst := NULL;
END IF;
IF trim(NEW.grumod)::VARCHAR = '''' THEN
   NEW.grumod := NULL;
END IF;
IF trim(NEW.filcom)::VARCHAR = '''' THEN
   NEW.filcom := NULL;
END IF;
IF trim(NEW.codcom)::VARCHAR = '''' THEN
   NEW.codcom := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_mod
BEFORE INSERT OR UPDATE ON td_mod
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_mod();



/*-- SEQ 6003 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_moe() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.moeati)::VARCHAR = '''' THEN
   NEW.moeati := NULL;
END IF;
IF trim(NEW.desmoe)::VARCHAR = '''' THEN
   NEW.desmoe := NULL;
END IF;
IF trim(NEW.moelet)::VARCHAR = '''' THEN
   NEW.moelet := NULL;
END IF;
IF trim(NEW.moeimg)::VARCHAR = '''' THEN
   NEW.moeimg := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_moe
BEFORE INSERT OR UPDATE ON td_moe
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_moe();



/*-- SEQ 6004 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_mon() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desmon)::VARCHAR = '''' THEN
   NEW.desmon := NULL;
END IF;
IF trim(NEW.monati)::VARCHAR = '''' THEN
   NEW.monati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_mon
BEFORE INSERT OR UPDATE ON td_mon
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_mon();



/*-- SEQ 6005 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_mot() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.descmo)::VARCHAR = '''' THEN
   NEW.descmo := NULL;
END IF;
IF trim(NEW.tipcom)::VARCHAR = '''' THEN
   NEW.tipcom := NULL;
END IF;
IF trim(NEW.cilind)::VARCHAR = '''' THEN
   NEW.cilind := NULL;
END IF;
IF trim(NEW.potenc)::VARCHAR = '''' THEN
   NEW.potenc := NULL;
END IF;
IF trim(NEW.mtoati)::VARCHAR = '''' THEN
   NEW.mtoati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_mot
BEFORE INSERT OR UPDATE ON td_mot
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_mot();



/*-- SEQ 6006 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_mpb() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desmpb)::VARCHAR = '''' THEN
   NEW.desmpb := NULL;
END IF;
IF trim(NEW.mpbati)::VARCHAR = '''' THEN
   NEW.mpbati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_mpb
BEFORE INSERT OR UPDATE ON td_mpb
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_mpb();



/*-- SEQ 6007 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_mtd() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desmtd)::VARCHAR = '''' THEN
   NEW.desmtd := NULL;
END IF;
IF trim(NEW.mtdati)::VARCHAR = '''' THEN
   NEW.mtdati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_mtd
BEFORE INSERT OR UPDATE ON td_mtd
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_mtd();



/*-- SEQ 6008 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_mul() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.mulati)::VARCHAR = '''' THEN
   NEW.mulati := NULL;
END IF;
IF trim(NEW.desmul)::VARCHAR = '''' THEN
   NEW.desmul := NULL;
END IF;
IF trim(NEW.sugest)::VARCHAR = '''' THEN
   NEW.sugest := NULL;
END IF;
IF trim(NEW.mulweb)::VARCHAR = '''' THEN
   NEW.mulweb := NULL;
END IF;
IF trim(NEW.codext_dmul)::VARCHAR = '''' THEN
   NEW.codext_dmul := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_mul
BEFORE INSERT OR UPDATE ON td_mul
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_mul();



/*-- SEQ 6009 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_mvp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desmot)::VARCHAR = '''' THEN
   NEW.desmot := NULL;
END IF;
IF trim(NEW.usomot)::VARCHAR = '''' THEN
   NEW.usomot := NULL;
END IF;
IF trim(NEW.conmot)::VARCHAR = '''' THEN
   NEW.conmot := NULL;
END IF;
IF trim(NEW.tipmot)::VARCHAR = '''' THEN
   NEW.tipmot := NULL;
END IF;
IF trim(NEW.motati)::VARCHAR = '''' THEN
   NEW.motati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_mvp
BEFORE INSERT OR UPDATE ON td_mvp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_mvp();



/*-- SEQ 6010 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_nat() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.lanven)::VARCHAR = '''' THEN
   NEW.lanven := NULL;
END IF;
IF trim(NEW.tipnat)::VARCHAR = '''' THEN
   NEW.tipnat := NULL;
END IF;
IF trim(NEW.financ)::VARCHAR = '''' THEN
   NEW.financ := NULL;
END IF;
IF trim(NEW.movest)::VARCHAR = '''' THEN
   NEW.movest := NULL;
END IF;
IF trim(NEW.natati)::VARCHAR = '''' THEN
   NEW.natati := NULL;
END IF;
IF trim(NEW.tribut)::VARCHAR = '''' THEN
   NEW.tribut := NULL;
END IF;
IF trim(NEW.usacus)::VARCHAR = '''' THEN
   NEW.usacus := NULL;
END IF;
IF trim(NEW.servin)::VARCHAR = '''' THEN
   NEW.servin := NULL;
END IF;
IF trim(NEW.natden)::VARCHAR = '''' THEN
   NEW.natden := NULL;
END IF;
IF trim(NEW.natfor)::VARCHAR = '''' THEN
   NEW.natfor := NULL;
END IF;
IF trim(NEW.natfud)::VARCHAR = '''' THEN
   NEW.natfud := NULL;
END IF;
IF trim(NEW.natfuf)::VARCHAR = '''' THEN
   NEW.natfuf := NULL;
END IF;
IF trim(NEW.extdem)::VARCHAR = '''' THEN
   NEW.extdem := NULL;
END IF;
IF trim(NEW.extfor)::VARCHAR = '''' THEN
   NEW.extfor := NULL;
END IF;
IF trim(NEW.nature)::VARCHAR = '''' THEN
   NEW.nature := NULL;
END IF;
IF trim(NEW.coment)::VARCHAR = '''' THEN
   NEW.coment := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.natred)::VARCHAR = '''' THEN
   NEW.natred := NULL;
END IF;
IF trim(NEW.natref)::VARCHAR = '''' THEN
   NEW.natref := NULL;
END IF;
IF trim(NEW.natoln)::VARCHAR = '''' THEN
   NEW.natoln := NULL;
END IF;
IF trim(NEW.consfi)::VARCHAR = '''' THEN
   NEW.consfi := NULL;
END IF;
IF trim(NEW.seqexc)::VARCHAR = '''' THEN
   NEW.seqexc := NULL;
END IF;
IF trim(NEW.devvin)::VARCHAR = '''' THEN
   NEW.devvin := NULL;
END IF;
IF trim(NEW.natmod)::VARCHAR = '''' THEN
   NEW.natmod := NULL;
END IF;
IF trim(NEW.natutl)::VARCHAR = '''' THEN
   NEW.natutl := NULL;
END IF;
IF trim(NEW.natden_fil)::VARCHAR = '''' THEN
   NEW.natden_fil := NULL;
END IF;
IF trim(NEW.natden_seq)::VARCHAR = '''' THEN
   NEW.natden_seq := NULL;
END IF;
IF trim(NEW.natden_tip)::VARCHAR = '''' THEN
   NEW.natden_tip := NULL;
END IF;
IF trim(NEW.natfor_fil)::VARCHAR = '''' THEN
   NEW.natfor_fil := NULL;
END IF;
IF trim(NEW.natfor_seq)::VARCHAR = '''' THEN
   NEW.natfor_seq := NULL;
END IF;
IF trim(NEW.natfor_tip)::VARCHAR = '''' THEN
   NEW.natfor_tip := NULL;
END IF;
IF trim(NEW.natest_fil)::VARCHAR = '''' THEN
   NEW.natest_fil := NULL;
END IF;
IF trim(NEW.natest_seq)::VARCHAR = '''' THEN
   NEW.natest_seq := NULL;
END IF;
IF trim(NEW.natest_tip)::VARCHAR = '''' THEN
   NEW.natest_tip := NULL;
END IF;
IF trim(NEW.sitpis)::VARCHAR = '''' THEN
   NEW.sitpis := NULL;
END IF;
IF trim(NEW.sitcof)::VARCHAR = '''' THEN
   NEW.sitcof := NULL;
END IF;
IF trim(NEW.natbcc)::VARCHAR = '''' THEN
   NEW.natbcc := NULL;
END IF;
IF trim(NEW.natesd)::VARCHAR = '''' THEN
   NEW.natesd := NULL;
END IF;
IF trim(NEW.natesf)::VARCHAR = '''' THEN
   NEW.natesf := NULL;
END IF;
IF trim(NEW.natred_st)::VARCHAR = '''' THEN
   NEW.natred_st := NULL;
END IF;
IF trim(NEW.natref_st)::VARCHAR = '''' THEN
   NEW.natref_st := NULL;
END IF;
IF trim(NEW.cstnor)::VARCHAR = '''' THEN
   NEW.cstnor := NULL;
END IF;
IF trim(NEW.cst_st)::VARCHAR = '''' THEN
   NEW.cst_st := NULL;
END IF;
IF trim(NEW.conloc)::VARCHAR = '''' THEN
   NEW.conloc := NULL;
END IF;
IF trim(NEW.natpre)::VARCHAR = '''' THEN
   NEW.natpre := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_nat
BEFORE INSERT OR UPDATE ON td_nat
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_nat();



/*-- SEQ 6011 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_niv() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desniv)::VARCHAR = '''' THEN
   NEW.desniv := NULL;
END IF;
IF trim(NEW.nivati)::VARCHAR = '''' THEN
   NEW.nivati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_niv
BEFORE INSERT OR UPDATE ON td_niv
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_niv();



/*-- SEQ 6012 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_obs() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.obsati)::VARCHAR = '''' THEN
   NEW.obsati := NULL;
END IF;
IF trim(NEW.desobs)::VARCHAR = '''' THEN
   NEW.desobs := NULL;
END IF;
IF trim(NEW.txtobs)::VARCHAR = '''' THEN
   NEW.txtobs := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_obs
BEFORE INSERT OR UPDATE ON td_obs
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_obs();



/*-- SEQ 6013 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ocu() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desocu)::VARCHAR = '''' THEN
   NEW.desocu := NULL;
END IF;
IF trim(NEW.ocuati)::VARCHAR = '''' THEN
   NEW.ocuati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ocu
BEFORE INSERT OR UPDATE ON td_ocu
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ocu();



/*-- SEQ 6014 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_omi() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desomi)::VARCHAR = '''' THEN
   NEW.desomi := NULL;
END IF;
IF trim(NEW.omiati)::VARCHAR = '''' THEN
   NEW.omiati := NULL;
END IF;
IF trim(NEW.omilis)::VARCHAR = '''' THEN
   NEW.omilis := NULL;
END IF;
IF trim(NEW.omires)::VARCHAR = '''' THEN
   NEW.omires := NULL;
END IF;
IF trim(NEW.omicon)::VARCHAR = '''' THEN
   NEW.omicon := NULL;
END IF;
IF trim(NEW.omifil)::VARCHAR = '''' THEN
   NEW.omifil := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_omi
BEFORE INSERT OR UPDATE ON td_omi
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_omi();



/*-- SEQ 6015 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_out() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.dadrec)::VARCHAR = '''' THEN
   NEW.dadrec := NULL;
END IF;
IF trim(NEW.outati)::VARCHAR = '''' THEN
   NEW.outati := NULL;
END IF;
IF trim(NEW.descar)::VARCHAR = '''' THEN
   NEW.descar := NULL;
END IF;
IF trim(NEW.outlet)::VARCHAR = '''' THEN
   NEW.outlet := NULL;
END IF;
IF trim(NEW.outimg)::VARCHAR = '''' THEN
   NEW.outimg := NULL;
END IF;
IF trim(NEW.regout)::VARCHAR = '''' THEN
   NEW.regout := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_out
BEFORE INSERT OR UPDATE ON td_out
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_out();



/*-- SEQ 6016 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_pai() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.despai)::VARCHAR = '''' THEN
   NEW.despai := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_pai
BEFORE INSERT OR UPDATE ON td_pai
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_pai();



/*-- SEQ 6017 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_per() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desper)::VARCHAR = '''' THEN
   NEW.desper := NULL;
END IF;
IF trim(NEW.percod)::VARCHAR = '''' THEN
   NEW.percod := NULL;
END IF;
IF trim(NEW.perati)::VARCHAR = '''' THEN
   NEW.perati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_per
BEFORE INSERT OR UPDATE ON td_per
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_per();



/*-- SEQ 6018 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_pes() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.despes)::VARCHAR = '''' THEN
   NEW.despes := NULL;
END IF;
IF trim(NEW.pesati)::VARCHAR = '''' THEN
   NEW.pesati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_pes
BEFORE INSERT OR UPDATE ON td_pes
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_pes();



/*-- SEQ 6019 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_pgf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.msgret)::VARCHAR = '''' THEN
   NEW.msgret := NULL;
END IF;
IF trim(NEW.pgfati)::VARCHAR = '''' THEN
   NEW.pgfati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_pgf
BEFORE INSERT OR UPDATE ON td_pgf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_pgf();



/*-- SEQ 6020 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_pho() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.phoati)::VARCHAR = '''' THEN
   NEW.phoati := NULL;
END IF;
IF trim(NEW.phoout)::VARCHAR = '''' THEN
   NEW.phoout := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_pho
BEFORE INSERT OR UPDATE ON td_pho
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_pho();



/*-- SEQ 6021 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_pre() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.preati)::VARCHAR = '''' THEN
   NEW.preati := NULL;
END IF;
IF trim(NEW.despre)::VARCHAR = '''' THEN
   NEW.despre := NULL;
END IF;
IF trim(NEW.cabpre)::VARCHAR = '''' THEN
   NEW.cabpre := NULL;
END IF;
IF trim(NEW.itepre)::VARCHAR = '''' THEN
   NEW.itepre := NULL;
END IF;
IF trim(NEW.rodpre)::VARCHAR = '''' THEN
   NEW.rodpre := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_pre
BEFORE INSERT OR UPDATE ON td_pre
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_pre();



/*-- SEQ 6022 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_pri() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.priati)::VARCHAR = '''' THEN
   NEW.priati := NULL;
END IF;
IF trim(NEW.despri)::VARCHAR = '''' THEN
   NEW.despri := NULL;
END IF;
IF trim(NEW.obspri)::VARCHAR = '''' THEN
   NEW.obspri := NULL;
END IF;
IF trim(NEW.tiphor)::VARCHAR = '''' THEN
   NEW.tiphor := NULL;
END IF;
IF trim(NEW.apepri)::VARCHAR = '''' THEN
   NEW.apepri := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_pri
BEFORE INSERT OR UPDATE ON td_pri
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_pri();



/*-- SEQ 6023 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_reg() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.regati)::VARCHAR = '''' THEN
   NEW.regati := NULL;
END IF;
IF trim(NEW.regiao)::VARCHAR = '''' THEN
   NEW.regiao := NULL;
END IF;
IF trim(NEW.cepini)::VARCHAR = '''' THEN
   NEW.cepini := NULL;
END IF;
IF trim(NEW.cepfim)::VARCHAR = '''' THEN
   NEW.cepfim := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_reg
BEFORE INSERT OR UPDATE ON td_reg
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_reg();



/*-- SEQ 6024 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_rej() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.rejati)::VARCHAR = '''' THEN
   NEW.rejati := NULL;
END IF;
IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;
IF trim(NEW.desrej)::VARCHAR = '''' THEN
   NEW.desrej := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_rej
BEFORE INSERT OR UPDATE ON td_rej
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_rej();



/*-- SEQ 6025 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_rel() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.relati)::VARCHAR = '''' THEN
   NEW.relati := NULL;
END IF;
IF trim(NEW.desrel)::VARCHAR = '''' THEN
   NEW.desrel := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_rel
BEFORE INSERT OR UPDATE ON td_rel
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_rel();



/*-- SEQ 6026 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_rem() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.remati)::VARCHAR = '''' THEN
   NEW.remati := NULL;
END IF;
IF trim(NEW.desrem)::VARCHAR = '''' THEN
   NEW.desrem := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_rem
BEFORE INSERT OR UPDATE ON td_rem
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_rem();



/*-- SEQ 6027 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_req() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desreq)::VARCHAR = '''' THEN
   NEW.desreq := NULL;
END IF;
IF trim(NEW.reqati)::VARCHAR = '''' THEN
   NEW.reqati := NULL;
END IF;
IF trim(NEW.abrreq)::VARCHAR = '''' THEN
   NEW.abrreq := NULL;
END IF;
IF trim(NEW.clareq)::VARCHAR = '''' THEN
   NEW.clareq := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_req
BEFORE INSERT OR UPDATE ON td_req
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_req();



/*-- SEQ 6028 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ret() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.retati)::VARCHAR = '''' THEN
   NEW.retati := NULL;
END IF;
IF trim(NEW.desret)::VARCHAR = '''' THEN
   NEW.desret := NULL;
END IF;
IF trim(NEW.flgnew)::VARCHAR = '''' THEN
   NEW.flgnew := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ret
BEFORE INSERT OR UPDATE ON td_ret
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ret();



/*-- SEQ 6029 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_rgc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desrgc)::VARCHAR = '''' THEN
   NEW.desrgc := NULL;
END IF;
IF trim(NEW.rgcati)::VARCHAR = '''' THEN
   NEW.rgcati := NULL;
END IF;
IF trim(NEW.flgenc)::VARCHAR = '''' THEN
   NEW.flgenc := NULL;
END IF;
IF trim(NEW.flgdev)::VARCHAR = '''' THEN
   NEW.flgdev := NULL;
END IF;
IF trim(NEW.rgc_tipent)::VARCHAR = '''' THEN
   NEW.rgc_tipent := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_rgc
BEFORE INSERT OR UPDATE ON td_rgc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_rgc();



/*-- SEQ 6030 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ros() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.rosati)::VARCHAR = '''' THEN
   NEW.rosati := NULL;
END IF;
IF trim(NEW.result)::VARCHAR = '''' THEN
   NEW.result := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ros
BEFORE INSERT OR UPDATE ON td_ros
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ros();



/*-- SEQ 6031 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_rtt() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desrtt)::VARCHAR = '''' THEN
   NEW.desrtt := NULL;
END IF;
IF trim(NEW.rttati)::VARCHAR = '''' THEN
   NEW.rttati := NULL;
END IF;
IF trim(NEW.rttest)::VARCHAR = '''' THEN
   NEW.rttest := NULL;
END IF;
IF trim(NEW.filcta_drtt)::VARCHAR = '''' THEN
   NEW.filcta_drtt := NULL;
END IF;
IF trim(NEW.seqcta_drtt)::VARCHAR = '''' THEN
   NEW.seqcta_drtt := NULL;
END IF;
IF trim(NEW.tipcta_drtt)::VARCHAR = '''' THEN
   NEW.tipcta_drtt := NULL;
END IF;
IF trim(NEW.filcta_est_drtt)::VARCHAR = '''' THEN
   NEW.filcta_est_drtt := NULL;
END IF;
IF trim(NEW.seqcta_est_drtt)::VARCHAR = '''' THEN
   NEW.seqcta_est_drtt := NULL;
END IF;
IF trim(NEW.tipcta_est_drtt)::VARCHAR = '''' THEN
   NEW.tipcta_est_drtt := NULL;
END IF;
IF trim(NEW.rttdig)::VARCHAR = '''' THEN
   NEW.rttdig := NULL;
END IF;
IF trim(NEW.rtttef)::VARCHAR = '''' THEN
   NEW.rtttef := NULL;
END IF;
IF trim(NEW.rttbar)::VARCHAR = '''' THEN
   NEW.rttbar := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_rtt
BEFORE INSERT OR UPDATE ON td_rtt
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_rtt();



/*-- SEQ 6032 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_sad() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.dessad)::VARCHAR = '''' THEN
   NEW.dessad := NULL;
END IF;
IF trim(NEW.sadati)::VARCHAR = '''' THEN
   NEW.sadati := NULL;
END IF;
IF trim(NEW.sugorc)::VARCHAR = '''' THEN
   NEW.sugorc := NULL;
END IF;
IF trim(NEW.venavu)::VARCHAR = '''' THEN
   NEW.venavu := NULL;
END IF;
IF trim(NEW.impdoc)::VARCHAR = '''' THEN
   NEW.impdoc := NULL;
END IF;
IF trim(NEW.forimp)::VARCHAR = '''' THEN
   NEW.forimp := NULL;
END IF;
IF trim(NEW.somgar)::VARCHAR = '''' THEN
   NEW.somgar := NULL;
END IF;
IF trim(NEW.flgpes)::VARCHAR = '''' THEN
   NEW.flgpes := NULL;
END IF;
IF trim(NEW.repsad)::VARCHAR = '''' THEN
   NEW.repsad := NULL;
END IF;
IF trim(NEW.fornum_ck4g)::VARCHAR = '''' THEN
   NEW.fornum_ck4g := NULL;
END IF;
IF trim(NEW.forimp_ck4g)::VARCHAR = '''' THEN
   NEW.forimp_ck4g := NULL;
END IF;
IF trim(NEW.forcan_ck4g)::VARCHAR = '''' THEN
   NEW.forcan_ck4g := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_sad
BEFORE INSERT OR UPDATE ON td_sad
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_sad();



/*-- SEQ 6033 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_sad_can() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.forcan)::VARCHAR = '''' THEN
   NEW.forcan := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_sad_can
BEFORE INSERT OR UPDATE ON td_sad_can
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_sad_can();



/*-- SEQ 6034 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_sat() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.dessat)::VARCHAR = '''' THEN
   NEW.dessat := NULL;
END IF;
IF trim(NEW.satati)::VARCHAR = '''' THEN
   NEW.satati := NULL;
END IF;
IF trim(NEW.sat_codfil)::VARCHAR = '''' THEN
   NEW.sat_codfil := NULL;
END IF;
IF trim(NEW.sat_codser)::VARCHAR = '''' THEN
   NEW.sat_codser := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_sat
BEFORE INSERT OR UPDATE ON td_sat
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_sat();



/*-- SEQ 6035 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_saz() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.sazati)::VARCHAR = '''' THEN
   NEW.sazati := NULL;
END IF;
IF trim(NEW.dessaz)::VARCHAR = '''' THEN
   NEW.dessaz := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_saz
BEFORE INSERT OR UPDATE ON td_saz
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_saz();



/*-- SEQ 6036 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ser() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.divtro)::VARCHAR = '''' THEN
   NEW.divtro := NULL;
END IF;
IF trim(NEW.impnot)::VARCHAR = '''' THEN
   NEW.impnot := NULL;
END IF;
IF trim(NEW.restri)::VARCHAR = '''' THEN
   NEW.restri := NULL;
END IF;
IF trim(NEW.serati)::VARCHAR = '''' THEN
   NEW.serati := NULL;
END IF;
IF trim(NEW.serman)::VARCHAR = '''' THEN
   NEW.serman := NULL;
END IF;
IF trim(NEW.serfim)::VARCHAR = '''' THEN
   NEW.serfim := NULL;
END IF;
IF trim(NEW.serini)::VARCHAR = '''' THEN
   NEW.serini := NULL;
END IF;
IF trim(NEW.desser)::VARCHAR = '''' THEN
   NEW.desser := NULL;
END IF;
IF trim(NEW.dissai)::VARCHAR = '''' THEN
   NEW.dissai := NULL;
END IF;
IF trim(NEW.txtent)::VARCHAR = '''' THEN
   NEW.txtent := NULL;
END IF;
IF trim(NEW.txtfim)::VARCHAR = '''' THEN
   NEW.txtfim := NULL;
END IF;
IF trim(NEW.txtini)::VARCHAR = '''' THEN
   NEW.txtini := NULL;
END IF;
IF trim(NEW.txtite)::VARCHAR = '''' THEN
   NEW.txtite := NULL;
END IF;
IF trim(NEW.txtser)::VARCHAR = '''' THEN
   NEW.txtser := NULL;
END IF;
IF trim(NEW.titavu)::VARCHAR = '''' THEN
   NEW.titavu := NULL;
END IF;
IF trim(NEW.serutl)::VARCHAR = '''' THEN
   NEW.serutl := NULL;
END IF;
IF trim(NEW.serord)::VARCHAR = '''' THEN
   NEW.serord := NULL;
END IF;
IF trim(NEW.serdoc)::VARCHAR = '''' THEN
   NEW.serdoc := NULL;
END IF;
IF trim(NEW.serext)::VARCHAR = '''' THEN
   NEW.serext := NULL;
END IF;
IF trim(NEW.txtobs)::VARCHAR = '''' THEN
   NEW.txtobs := NULL;
END IF;
IF trim(NEW.serrem)::VARCHAR = '''' THEN
   NEW.serrem := NULL;
END IF;
IF trim(NEW.recibo)::VARCHAR = '''' THEN
   NEW.recibo := NULL;
END IF;
IF trim(NEW.envnfs)::VARCHAR = '''' THEN
   NEW.envnfs := NULL;
END IF;
IF trim(NEW.sercon)::VARCHAR = '''' THEN
   NEW.sercon := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ser
BEFORE INSERT OR UPDATE ON td_ser
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ser();



/*-- SEQ 6037 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_set() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.setati)::VARCHAR = '''' THEN
   NEW.setati := NULL;
END IF;
IF trim(NEW.desset)::VARCHAR = '''' THEN
   NEW.desset := NULL;
END IF;
IF trim(NEW.filset)::VARCHAR = '''' THEN
   NEW.filset := NULL;
END IF;
IF trim(NEW.prjset)::VARCHAR = '''' THEN
   NEW.prjset := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_set
BEFORE INSERT OR UPDATE ON td_set
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_set();



/*-- SEQ 6038 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_sit() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.sitati)::VARCHAR = '''' THEN
   NEW.sitati := NULL;
END IF;
IF trim(NEW.dessit)::VARCHAR = '''' THEN
   NEW.dessit := NULL;
END IF;
IF trim(NEW.flgres)::VARCHAR = '''' THEN
   NEW.flgres := NULL;
END IF;
IF trim(NEW.flgrev)::VARCHAR = '''' THEN
   NEW.flgrev := NULL;
END IF;
IF trim(NEW.flgreg)::VARCHAR = '''' THEN
   NEW.flgreg := NULL;
END IF;
IF trim(NEW.flgmod)::VARCHAR = '''' THEN
   NEW.flgmod := NULL;
END IF;
IF trim(NEW.tipsit)::VARCHAR = '''' THEN
   NEW.tipsit := NULL;
END IF;
IF trim(NEW.tipado)::VARCHAR = '''' THEN
   NEW.tipado := NULL;
END IF;
IF trim(NEW.ger_cc)::VARCHAR = '''' THEN
   NEW.ger_cc := NULL;
END IF;
IF trim(NEW.sitmai)::VARCHAR = '''' THEN
   NEW.sitmai := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_sit
BEFORE INSERT OR UPDATE ON td_sit
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_sit();



/*-- SEQ 6039 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_std() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.flgflx)::VARCHAR = '''' THEN
   NEW.flgflx := NULL;
END IF;
IF trim(NEW.usostd)::VARCHAR = '''' THEN
   NEW.usostd := NULL;
END IF;
IF trim(NEW.stdati)::VARCHAR = '''' THEN
   NEW.stdati := NULL;
END IF;
IF trim(NEW.desstd)::VARCHAR = '''' THEN
   NEW.desstd := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_std
BEFORE INSERT OR UPDATE ON td_std
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_std();



/*-- SEQ 6040 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_stf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desstf)::VARCHAR = '''' THEN
   NEW.desstf := NULL;
END IF;
IF trim(NEW.stfati)::VARCHAR = '''' THEN
   NEW.stfati := NULL;
END IF;
IF trim(NEW.stf_filfor)::VARCHAR = '''' THEN
   NEW.stf_filfor := NULL;
END IF;
IF trim(NEW.stf_codfor)::VARCHAR = '''' THEN
   NEW.stf_codfor := NULL;
END IF;
IF trim(NEW.stf_codser)::VARCHAR = '''' THEN
   NEW.stf_codser := NULL;
END IF;
IF trim(NEW.stf_subser)::VARCHAR = '''' THEN
   NEW.stf_subser := NULL;
END IF;
IF trim(NEW.stf_coddar)::VARCHAR = '''' THEN
   NEW.stf_coddar := NULL;
END IF;
IF trim(NEW.stf_filcta)::VARCHAR = '''' THEN
   NEW.stf_filcta := NULL;
END IF;
IF trim(NEW.stf_seqcta)::VARCHAR = '''' THEN
   NEW.stf_seqcta := NULL;
END IF;
IF trim(NEW.stf_tipcta)::VARCHAR = '''' THEN
   NEW.stf_tipcta := NULL;
END IF;
IF trim(NEW.stf_codfps)::VARCHAR = '''' THEN
   NEW.stf_codfps := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_stf
BEFORE INSERT OR UPDATE ON td_stf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_stf();



/*-- SEQ 6041 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_str() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desstr)::VARCHAR = '''' THEN
   NEW.desstr := NULL;
END IF;
IF trim(NEW.strati)::VARCHAR = '''' THEN
   NEW.strati := NULL;
END IF;
IF trim(NEW.flgstr)::VARCHAR = '''' THEN
   NEW.flgstr := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_str
BEFORE INSERT OR UPDATE ON td_str
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_str();



/*-- SEQ 6042 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_sub() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.subati)::VARCHAR = '''' THEN
   NEW.subati := NULL;
END IF;
IF trim(NEW.nomsub)::VARCHAR = '''' THEN
   NEW.nomsub := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_sub
BEFORE INSERT OR UPDATE ON td_sub
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_sub();



/*-- SEQ 6043 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_tan() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filtan)::VARCHAR = '''' THEN
   NEW.filtan := NULL;
END IF;
IF trim(NEW.grafil)::VARCHAR = '''' THEN
   NEW.grafil := NULL;
END IF;
IF trim(NEW.gracod)::VARCHAR = '''' THEN
   NEW.gracod := NULL;
END IF;
IF trim(NEW.tanatv)::VARCHAR = '''' THEN
   NEW.tanatv := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_tan
BEFORE INSERT OR UPDATE ON td_tan
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_tan();



/*-- SEQ 6044 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_tcc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.tccati)::VARCHAR = '''' THEN
   NEW.tccati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_tcc
BEFORE INSERT OR UPDATE ON td_tcc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_tcc();



/*-- SEQ 6045 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_tcd() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.tcdati)::VARCHAR = '''' THEN
   NEW.tcdati := NULL;
END IF;
IF trim(NEW.tefent)::VARCHAR = '''' THEN
   NEW.tefent := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_tcd
BEFORE INSERT OR UPDATE ON td_tcd
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_tcd();



/*-- SEQ 6046 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ted() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.dested)::VARCHAR = '''' THEN
   NEW.dested := NULL;
END IF;
IF trim(NEW.tedati)::VARCHAR = '''' THEN
   NEW.tedati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ted
BEFORE INSERT OR UPDATE ON td_ted
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ted();



/*-- SEQ 6047 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_ter() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.terati)::VARCHAR = '''' THEN
   NEW.terati := NULL;
END IF;
IF trim(NEW.ter_ip)::VARCHAR = '''' THEN
   NEW.ter_ip := NULL;
END IF;
IF trim(NEW.filter)::VARCHAR = '''' THEN
   NEW.filter := NULL;
END IF;
IF trim(NEW.terven)::VARCHAR = '''' THEN
   NEW.terven := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_ter
BEFORE INSERT OR UPDATE ON td_ter
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_ter();



/*-- SEQ 6048 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_tip() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.tipati)::VARCHAR = '''' THEN
   NEW.tipati := NULL;
END IF;
IF trim(NEW.photip)::VARCHAR = '''' THEN
   NEW.photip := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_tip
BEFORE INSERT OR UPDATE ON td_tip
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_tip();



/*-- SEQ 6049 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_tipxint() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.destipxint)::VARCHAR = '''' THEN
   NEW.destipxint := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_tipxint
BEFORE INSERT OR UPDATE ON td_tipxint
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_tipxint();



/*-- SEQ 6050 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_tri() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.triati)::VARCHAR = '''' THEN
   NEW.triati := NULL;
END IF;
IF trim(NEW.codtri)::VARCHAR = '''' THEN
   NEW.codtri := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_tri
BEFORE INSERT OR UPDATE ON td_tri
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_tri();



/*-- SEQ 6051 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_vcr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.corati)::VARCHAR = '''' THEN
   NEW.corati := NULL;
END IF;
IF trim(NEW.descor)::VARCHAR = '''' THEN
   NEW.descor := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_vcr
BEFORE INSERT OR UPDATE ON td_vcr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_vcr();



/*-- SEQ 6052 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_vei() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.placas)::VARCHAR = '''' THEN
   NEW.placas := NULL;
END IF;
IF trim(NEW.veiati)::VARCHAR = '''' THEN
   NEW.veiati := NULL;
END IF;
IF trim(NEW.desvei)::VARCHAR = '''' THEN
   NEW.desvei := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_vei
BEFORE INSERT OR UPDATE ON td_vei
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_vei();



/*-- SEQ 6053 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_vpe() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.vpeati)::VARCHAR = '''' THEN
   NEW.vpeati := NULL;
END IF;
IF trim(NEW.motvpe)::VARCHAR = '''' THEN
   NEW.motvpe := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_vpe
BEFORE INSERT OR UPDATE ON td_vpe
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_vpe();



/*-- SEQ 6054 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_vtp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.vtpati)::VARCHAR = '''' THEN
   NEW.vtpati := NULL;
END IF;
IF trim(NEW.desvtp)::VARCHAR = '''' THEN
   NEW.desvtp := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_vtp
BEFORE INSERT OR UPDATE ON td_vtp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_vtp();



/*-- SEQ 6055 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_td_zaz() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.sazati)::VARCHAR = '''' THEN
   NEW.sazati := NULL;
END IF;
IF trim(NEW.dessaz)::VARCHAR = '''' THEN
   NEW.dessaz := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_td_zaz
BEFORE INSERT OR UPDATE ON td_zaz
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_td_zaz();



/*-- SEQ 6056 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_te_ccc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.extcli)::VARCHAR = '''' THEN
   NEW.extcli := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.comple)::VARCHAR = '''' THEN
   NEW.comple := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.numpar)::VARCHAR = '''' THEN
   NEW.numpar := NULL;
END IF;
IF trim(NEW.subpar)::VARCHAR = '''' THEN
   NEW.subpar := NULL;
END IF;
IF trim(NEW.maxpar)::VARCHAR = '''' THEN
   NEW.maxpar := NULL;
END IF;
IF trim(NEW.filpgt)::VARCHAR = '''' THEN
   NEW.filpgt := NULL;
END IF;
IF trim(NEW.codpgt)::VARCHAR = '''' THEN
   NEW.codpgt := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_te_ccc
BEFORE INSERT OR UPDATE ON te_ccc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_te_ccc();



/*-- SEQ 6057 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_te_chr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.tipope)::VARCHAR = '''' THEN
   NEW.tipope := NULL;
END IF;
IF trim(NEW.autori)::VARCHAR = '''' THEN
   NEW.autori := NULL;
END IF;
IF trim(NEW.cdcmc7)::VARCHAR = '''' THEN
   NEW.cdcmc7 := NULL;
END IF;
IF trim(NEW.codage)::VARCHAR = '''' THEN
   NEW.codage := NULL;
END IF;
IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;
IF trim(NEW.doccli)::VARCHAR = '''' THEN
   NEW.doccli := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.numche)::VARCHAR = '''' THEN
   NEW.numche := NULL;
END IF;
IF trim(NEW.numcon)::VARCHAR = '''' THEN
   NEW.numcon := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.obslog)::VARCHAR = '''' THEN
   NEW.obslog := NULL;
END IF;
IF trim(NEW.serche)::VARCHAR = '''' THEN
   NEW.serche := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_te_chr
BEFORE INSERT OR UPDATE ON te_chr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_te_chr();



/*-- SEQ 6058 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_te_cli() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.nomcli)::VARCHAR = '''' THEN
   NEW.nomcli := NULL;
END IF;
IF trim(NEW.ultnom)::VARCHAR = '''' THEN
   NEW.ultnom := NULL;
END IF;
IF trim(NEW.flgtip)::VARCHAR = '''' THEN
   NEW.flgtip := NULL;
END IF;
IF trim(NEW.insest)::VARCHAR = '''' THEN
   NEW.insest := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.endere)::VARCHAR = '''' THEN
   NEW.endere := NULL;
END IF;
IF trim(NEW.comple)::VARCHAR = '''' THEN
   NEW.comple := NULL;
END IF;
IF trim(NEW.bairro)::VARCHAR = '''' THEN
   NEW.bairro := NULL;
END IF;
IF trim(NEW.codcep)::VARCHAR = '''' THEN
   NEW.codcep := NULL;
END IF;
IF trim(NEW.codlog)::VARCHAR = '''' THEN
   NEW.codlog := NULL;
END IF;
IF trim(NEW.nomcid)::VARCHAR = '''' THEN
   NEW.nomcid := NULL;
END IF;
IF trim(NEW.sigest)::VARCHAR = '''' THEN
   NEW.sigest := NULL;
END IF;
IF trim(NEW.numfon)::VARCHAR = '''' THEN
   NEW.numfon := NULL;
END IF;
IF trim(NEW.status)::VARCHAR = '''' THEN
   NEW.status := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_te_cli
BEFORE INSERT OR UPDATE ON te_cli
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_te_cli();



/*-- SEQ 6059 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_te_ecf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.numser)::VARCHAR = '''' THEN
   NEW.numser := NULL;
END IF;
IF trim(NEW.tiptot)::VARCHAR = '''' THEN
   NEW.tiptot := NULL;
END IF;
IF trim(NEW.totali)::VARCHAR = '''' THEN
   NEW.totali := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_te_ecf
BEFORE INSERT OR UPDATE ON te_ecf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_te_ecf();



/*-- SEQ 6060 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_te_ecfxrecf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.status)::VARCHAR = '''' THEN
   NEW.status := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_te_ecfxrecf
BEFORE INSERT OR UPDATE ON te_ecfxrecf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_te_ecfxrecf();



/*-- SEQ 6061 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_te_for() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filfor)::VARCHAR = '''' THEN
   NEW.filfor := NULL;
END IF;
IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;
IF trim(NEW.nomcli)::VARCHAR = '''' THEN
   NEW.nomcli := NULL;
END IF;
IF trim(NEW.ultnom)::VARCHAR = '''' THEN
   NEW.ultnom := NULL;
END IF;
IF trim(NEW.flgtip)::VARCHAR = '''' THEN
   NEW.flgtip := NULL;
END IF;
IF trim(NEW.insest)::VARCHAR = '''' THEN
   NEW.insest := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.endere)::VARCHAR = '''' THEN
   NEW.endere := NULL;
END IF;
IF trim(NEW.comple)::VARCHAR = '''' THEN
   NEW.comple := NULL;
END IF;
IF trim(NEW.bairro)::VARCHAR = '''' THEN
   NEW.bairro := NULL;
END IF;
IF trim(NEW.codcep)::VARCHAR = '''' THEN
   NEW.codcep := NULL;
END IF;
IF trim(NEW.codlog)::VARCHAR = '''' THEN
   NEW.codlog := NULL;
END IF;
IF trim(NEW.nomcid)::VARCHAR = '''' THEN
   NEW.nomcid := NULL;
END IF;
IF trim(NEW.sigest)::VARCHAR = '''' THEN
   NEW.sigest := NULL;
END IF;
IF trim(NEW.numfon)::VARCHAR = '''' THEN
   NEW.numfon := NULL;
END IF;
IF trim(NEW.status)::VARCHAR = '''' THEN
   NEW.status := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_te_for
BEFORE INSERT OR UPDATE ON te_for
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_te_for();



/*-- SEQ 6062 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_te_mov() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.extpro)::VARCHAR = '''' THEN
   NEW.extpro := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.docume)::VARCHAR = '''' THEN
   NEW.docume := NULL;
END IF;
IF trim(NEW.numext)::VARCHAR = '''' THEN
   NEW.numext := NULL;
END IF;
IF trim(NEW.tipmov)::VARCHAR = '''' THEN
   NEW.tipmov := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.tipreg)::VARCHAR = '''' THEN
   NEW.tipreg := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.sitmov)::VARCHAR = '''' THEN
   NEW.sitmov := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_te_mov
BEFORE INSERT OR UPDATE ON te_mov
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_te_mov();



/*-- SEQ 6063 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_te_recf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.diafec)::VARCHAR = '''' THEN
   NEW.diafec := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_te_recf
BEFORE INSERT OR UPDATE ON te_recf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_te_recf();



/*-- SEQ 6064 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_te_venxive() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.numnot)::VARCHAR = '''' THEN
   NEW.numnot := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.especi)::VARCHAR = '''' THEN
   NEW.especi := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.tipnot)::VARCHAR = '''' THEN
   NEW.tipnot := NULL;
END IF;
IF trim(NEW.ciffob)::VARCHAR = '''' THEN
   NEW.ciffob := NULL;
END IF;
IF trim(NEW.status)::VARCHAR = '''' THEN
   NEW.status := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_te_venxive
BEFORE INSERT OR UPDATE ON te_venxive
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_te_venxive();



/*-- SEQ 6065 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_cam() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desmoe)::VARCHAR = '''' THEN
   NEW.desmoe := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_cam
BEFORE INSERT OR UPDATE ON ti_cam
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_cam();



/*-- SEQ 6066 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_ccc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.comple)::VARCHAR = '''' THEN
   NEW.comple := NULL;
END IF;
IF trim(NEW.tiplan)::VARCHAR = '''' THEN
   NEW.tiplan := NULL;
END IF;
IF trim(NEW.atulim)::VARCHAR = '''' THEN
   NEW.atulim := NULL;
END IF;
IF trim(NEW.codccc)::VARCHAR = '''' THEN
   NEW.codccc := NULL;
END IF;
IF trim(NEW.desccc)::VARCHAR = '''' THEN
   NEW.desccc := NULL;
END IF;
IF trim(NEW.codcob)::VARCHAR = '''' THEN
   NEW.codcob := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_ccc
BEFORE INSERT OR UPDATE ON ti_ccc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_ccc();



/*-- SEQ 6067 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_cfp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.cfpati)::VARCHAR = '''' THEN
   NEW.cfpati := NULL;
END IF;
IF trim(NEW.descfp)::VARCHAR = '''' THEN
   NEW.descfp := NULL;
END IF;
IF trim(NEW.vencon)::VARCHAR = '''' THEN
   NEW.vencon := NULL;
END IF;
IF trim(NEW.venrev)::VARCHAR = '''' THEN
   NEW.venrev := NULL;
END IF;
IF trim(NEW.devcon)::VARCHAR = '''' THEN
   NEW.devcon := NULL;
END IF;
IF trim(NEW.devrev)::VARCHAR = '''' THEN
   NEW.devrev := NULL;
END IF;
IF trim(NEW.saicon)::VARCHAR = '''' THEN
   NEW.saicon := NULL;
END IF;
IF trim(NEW.sairev)::VARCHAR = '''' THEN
   NEW.sairev := NULL;
END IF;
IF trim(NEW.entcon)::VARCHAR = '''' THEN
   NEW.entcon := NULL;
END IF;
IF trim(NEW.entrev)::VARCHAR = '''' THEN
   NEW.entrev := NULL;
END IF;
IF trim(NEW.comcon)::VARCHAR = '''' THEN
   NEW.comcon := NULL;
END IF;
IF trim(NEW.comrev)::VARCHAR = '''' THEN
   NEW.comrev := NULL;
END IF;
IF trim(NEW.dvccon)::VARCHAR = '''' THEN
   NEW.dvccon := NULL;
END IF;
IF trim(NEW.dvcrev)::VARCHAR = '''' THEN
   NEW.dvcrev := NULL;
END IF;
IF trim(NEW.intcon)::VARCHAR = '''' THEN
   NEW.intcon := NULL;
END IF;
IF trim(NEW.intrev)::VARCHAR = '''' THEN
   NEW.intrev := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_cfp
BEFORE INSERT OR UPDATE ON ti_cfp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_cfp();



/*-- SEQ 6068 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_chr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.codage)::VARCHAR = '''' THEN
   NEW.codage := NULL;
END IF;
IF trim(NEW.numche)::VARCHAR = '''' THEN
   NEW.numche := NULL;
END IF;
IF trim(NEW.numcon)::VARCHAR = '''' THEN
   NEW.numcon := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.autori)::VARCHAR = '''' THEN
   NEW.autori := NULL;
END IF;
IF trim(NEW.tipcob)::VARCHAR = '''' THEN
   NEW.tipcob := NULL;
END IF;
IF trim(NEW.obslog)::VARCHAR = '''' THEN
   NEW.obslog := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.cdcmc7)::VARCHAR = '''' THEN
   NEW.cdcmc7 := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.placas)::VARCHAR = '''' THEN
   NEW.placas := NULL;
END IF;
IF trim(NEW.serche)::VARCHAR = '''' THEN
   NEW.serche := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_chr
BEFORE INSERT OR UPDATE ON ti_chr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_chr();



/*-- SEQ 6069 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_cli() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.nomcli)::VARCHAR = '''' THEN
   NEW.nomcli := NULL;
END IF;
IF trim(NEW.ultnom)::VARCHAR = '''' THEN
   NEW.ultnom := NULL;
END IF;
IF trim(NEW.ctipdoc)::VARCHAR = '''' THEN
   NEW.ctipdoc := NULL;
END IF;
IF trim(NEW.dtipdoc)::VARCHAR = '''' THEN
   NEW.dtipdoc := NULL;
END IF;
IF trim(NEW.insest)::VARCHAR = '''' THEN
   NEW.insest := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.categ1)::VARCHAR = '''' THEN
   NEW.categ1 := NULL;
END IF;
IF trim(NEW.categ2)::VARCHAR = '''' THEN
   NEW.categ2 := NULL;
END IF;
IF trim(NEW.categ3)::VARCHAR = '''' THEN
   NEW.categ3 := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.ativo)::VARCHAR = '''' THEN
   NEW.ativo := NULL;
END IF;
IF trim(NEW.desina)::VARCHAR = '''' THEN
   NEW.desina := NULL;
END IF;
IF trim(NEW.icm_cf)::VARCHAR = '''' THEN
   NEW.icm_cf := NULL;
END IF;
IF trim(NEW.call_c)::VARCHAR = '''' THEN
   NEW.call_c := NULL;
END IF;
IF trim(NEW.conjug)::VARCHAR = '''' THEN
   NEW.conjug := NULL;
END IF;
IF trim(NEW.doccon)::VARCHAR = '''' THEN
   NEW.doccon := NULL;
END IF;
IF trim(NEW.ddtcon)::VARCHAR = '''' THEN
   NEW.ddtcon := NULL;
END IF;
IF trim(NEW.telcon)::VARCHAR = '''' THEN
   NEW.telcon := NULL;
END IF;
IF trim(NEW.ddccon)::VARCHAR = '''' THEN
   NEW.ddccon := NULL;
END IF;
IF trim(NEW.celuco)::VARCHAR = '''' THEN
   NEW.celuco := NULL;
END IF;
IF trim(NEW.e_mcon)::VARCHAR = '''' THEN
   NEW.e_mcon := NULL;
END IF;
IF trim(NEW.nomtra)::VARCHAR = '''' THEN
   NEW.nomtra := NULL;
END IF;
IF trim(NEW.id_org)::VARCHAR = '''' THEN
   NEW.id_org := NULL;
END IF;
IF trim(NEW.id_est)::VARCHAR = '''' THEN
   NEW.id_est := NULL;
END IF;
IF trim(NEW.codpla)::VARCHAR = '''' THEN
   NEW.codpla := NULL;
END IF;
IF trim(NEW.apeven)::VARCHAR = '''' THEN
   NEW.apeven := NULL;
END IF;
IF trim(NEW.codcon)::VARCHAR = '''' THEN
   NEW.codcon := NULL;
END IF;
IF trim(NEW.naospc)::VARCHAR = '''' THEN
   NEW.naospc := NULL;
END IF;
IF trim(NEW.codvin)::VARCHAR = '''' THEN
   NEW.codvin := NULL;
END IF;
IF trim(NEW.obsout)::VARCHAR = '''' THEN
   NEW.obsout := NULL;
END IF;
IF trim(NEW.simple)::VARCHAR = '''' THEN
   NEW.simple := NULL;
END IF;
IF trim(NEW.hompge)::VARCHAR = '''' THEN
   NEW.hompge := NULL;
END IF;
IF trim(NEW.tipcli1)::VARCHAR = '''' THEN
   NEW.tipcli1 := NULL;
END IF;
IF trim(NEW.tipcli2)::VARCHAR = '''' THEN
   NEW.tipcli2 := NULL;
END IF;
IF trim(NEW.tipcli3)::VARCHAR = '''' THEN
   NEW.tipcli3 := NULL;
END IF;
IF trim(NEW.tipcli4)::VARCHAR = '''' THEN
   NEW.tipcli4 := NULL;
END IF;
IF trim(NEW.tipcli5)::VARCHAR = '''' THEN
   NEW.tipcli5 := NULL;
END IF;
IF trim(NEW.tipcli6)::VARCHAR = '''' THEN
   NEW.tipcli6 := NULL;
END IF;
IF trim(NEW.tipcli7)::VARCHAR = '''' THEN
   NEW.tipcli7 := NULL;
END IF;
IF trim(NEW.tipcli8)::VARCHAR = '''' THEN
   NEW.tipcli8 := NULL;
END IF;
IF trim(NEW.tipcli9)::VARCHAR = '''' THEN
   NEW.tipcli9 := NULL;
END IF;
IF trim(NEW.tipcli10)::VARCHAR = '''' THEN
   NEW.tipcli10 := NULL;
END IF;
IF trim(NEW.nconta)::VARCHAR = '''' THEN
   NEW.nconta := NULL;
END IF;
IF trim(NEW.fileco)::VARCHAR = '''' THEN
   NEW.fileco := NULL;
END IF;
IF trim(NEW.tracon)::VARCHAR = '''' THEN
   NEW.tracon := NULL;
END IF;
IF trim(NEW.tipcon)::VARCHAR = '''' THEN
   NEW.tipcon := NULL;
END IF;
IF trim(NEW.tippes)::VARCHAR = '''' THEN
   NEW.tippes := NULL;
END IF;
IF trim(NEW.dddcon)::VARCHAR = '''' THEN
   NEW.dddcon := NULL;
END IF;
IF trim(NEW.contel)::VARCHAR = '''' THEN
   NEW.contel := NULL;
END IF;
IF trim(NEW.dddcel)::VARCHAR = '''' THEN
   NEW.dddcel := NULL;
END IF;
IF trim(NEW.celcon)::VARCHAR = '''' THEN
   NEW.celcon := NULL;
END IF;
IF trim(NEW.dddfxc)::VARCHAR = '''' THEN
   NEW.dddfxc := NULL;
END IF;
IF trim(NEW.numfxc)::VARCHAR = '''' THEN
   NEW.numfxc := NULL;
END IF;
IF trim(NEW.e_mail)::VARCHAR = '''' THEN
   NEW.e_mail := NULL;
END IF;
IF trim(NEW.filend)::VARCHAR = '''' THEN
   NEW.filend := NULL;
END IF;
IF trim(NEW.endere)::VARCHAR = '''' THEN
   NEW.endere := NULL;
END IF;
IF trim(NEW.contat)::VARCHAR = '''' THEN
   NEW.contat := NULL;
END IF;
IF trim(NEW.numero)::VARCHAR = '''' THEN
   NEW.numero := NULL;
END IF;
IF trim(NEW.bairro)::VARCHAR = '''' THEN
   NEW.bairro := NULL;
END IF;
IF trim(NEW.sigest)::VARCHAR = '''' THEN
   NEW.sigest := NULL;
END IF;
IF trim(NEW.nomcid)::VARCHAR = '''' THEN
   NEW.nomcid := NULL;
END IF;
IF trim(NEW.codlog)::VARCHAR = '''' THEN
   NEW.codlog := NULL;
END IF;
IF trim(NEW.regiao)::VARCHAR = '''' THEN
   NEW.regiao := NULL;
END IF;
IF trim(NEW.flgnac)::VARCHAR = '''' THEN
   NEW.flgnac := NULL;
END IF;
IF trim(NEW.estran)::VARCHAR = '''' THEN
   NEW.estran := NULL;
END IF;
IF trim(NEW.usa_nf)::VARCHAR = '''' THEN
   NEW.usa_nf := NULL;
END IF;
IF trim(NEW.endcob)::VARCHAR = '''' THEN
   NEW.endcob := NULL;
END IF;
IF trim(NEW.endcor)::VARCHAR = '''' THEN
   NEW.endcor := NULL;
END IF;
IF trim(NEW.tipend)::VARCHAR = '''' THEN
   NEW.tipend := NULL;
END IF;
IF trim(NEW.comple)::VARCHAR = '''' THEN
   NEW.comple := NULL;
END IF;
IF trim(NEW.codcep)::VARCHAR = '''' THEN
   NEW.codcep := NULL;
END IF;
IF trim(NEW.loctra)::VARCHAR = '''' THEN
   NEW.loctra := NULL;
END IF;
IF trim(NEW.codddd)::VARCHAR = '''' THEN
   NEW.codddd := NULL;
END IF;
IF trim(NEW.numfon)::VARCHAR = '''' THEN
   NEW.numfon := NULL;
END IF;
IF trim(NEW.dddfax)::VARCHAR = '''' THEN
   NEW.dddfax := NULL;
END IF;
IF trim(NEW.numfax)::VARCHAR = '''' THEN
   NEW.numfax := NULL;
END IF;
IF trim(NEW.docend)::VARCHAR = '''' THEN
   NEW.docend := NULL;
END IF;
IF trim(NEW.ie_end)::VARCHAR = '''' THEN
   NEW.ie_end := NULL;
END IF;
IF trim(NEW.nacion)::VARCHAR = '''' THEN
   NEW.nacion := NULL;
END IF;
IF trim(NEW.cidnas)::VARCHAR = '''' THEN
   NEW.cidnas := NULL;
END IF;
IF trim(NEW.celddd)::VARCHAR = '''' THEN
   NEW.celddd := NULL;
END IF;
IF trim(NEW.celnum)::VARCHAR = '''' THEN
   NEW.celnum := NULL;
END IF;
IF trim(NEW.maispc)::VARCHAR = '''' THEN
   NEW.maispc := NULL;
END IF;
IF trim(NEW.firatu)::VARCHAR = '''' THEN
   NEW.firatu := NULL;
END IF;
IF trim(NEW.numcod)::VARCHAR = '''' THEN
   NEW.numcod := NULL;
END IF;
IF trim(NEW.numtel)::VARCHAR = '''' THEN
   NEW.numtel := NULL;
END IF;
IF trim(NEW.nomsup)::VARCHAR = '''' THEN
   NEW.nomsup := NULL;
END IF;
IF trim(NEW.endspc)::VARCHAR = '''' THEN
   NEW.endspc := NULL;
END IF;
IF trim(NEW.comspc)::VARCHAR = '''' THEN
   NEW.comspc := NULL;
END IF;
IF trim(NEW.desocu)::VARCHAR = '''' THEN
   NEW.desocu := NULL;
END IF;
IF trim(NEW.firant)::VARCHAR = '''' THEN
   NEW.firant := NULL;
END IF;
IF trim(NEW.carpro)::VARCHAR = '''' THEN
   NEW.carpro := NULL;
END IF;
IF trim(NEW.sercar)::VARCHAR = '''' THEN
   NEW.sercar := NULL;
END IF;
IF trim(NEW.nomlo1)::VARCHAR = '''' THEN
   NEW.nomlo1 := NULL;
END IF;
IF trim(NEW.endlo1)::VARCHAR = '''' THEN
   NEW.endlo1 := NULL;
END IF;
IF trim(NEW.nomlo2)::VARCHAR = '''' THEN
   NEW.nomlo2 := NULL;
END IF;
IF trim(NEW.endlo2)::VARCHAR = '''' THEN
   NEW.endlo2 := NULL;
END IF;
IF trim(NEW.con_tc)::VARCHAR = '''' THEN
   NEW.con_tc := NULL;
END IF;
IF trim(NEW.conspc)::VARCHAR = '''' THEN
   NEW.conspc := NULL;
END IF;
IF trim(NEW.con_lt)::VARCHAR = '''' THEN
   NEW.con_lt := NULL;
END IF;
IF trim(NEW.con_lr)::VARCHAR = '''' THEN
   NEW.con_lr := NULL;
END IF;
IF trim(NEW.carloj)::VARCHAR = '''' THEN
   NEW.carloj := NULL;
END IF;
IF trim(NEW.temaut)::VARCHAR = '''' THEN
   NEW.temaut := NULL;
END IF;
IF trim(NEW.tem_cc)::VARCHAR = '''' THEN
   NEW.tem_cc := NULL;
END IF;
IF trim(NEW.tem_tc)::VARCHAR = '''' THEN
   NEW.tem_tc := NULL;
END IF;
IF trim(NEW.orired)::VARCHAR = '''' THEN
   NEW.orired := NULL;
END IF;
IF trim(NEW.rgconj)::VARCHAR = '''' THEN
   NEW.rgconj := NULL;
END IF;
IF trim(NEW.fircon)::VARCHAR = '''' THEN
   NEW.fircon := NULL;
END IF;
IF trim(NEW.endco1)::VARCHAR = '''' THEN
   NEW.endco1 := NULL;
END IF;
IF trim(NEW.endco2)::VARCHAR = '''' THEN
   NEW.endco2 := NULL;
END IF;
IF trim(NEW.carprc)::VARCHAR = '''' THEN
   NEW.carprc := NULL;
END IF;
IF trim(NEW.sercac)::VARCHAR = '''' THEN
   NEW.sercac := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;
IF trim(NEW.global)::VARCHAR = '''' THEN
   NEW.global := NULL;
END IF;
IF trim(NEW.codddi)::VARCHAR = '''' THEN
   NEW.codddi := NULL;
END IF;
IF trim(NEW.ddicon)::VARCHAR = '''' THEN
   NEW.ddicon := NULL;
END IF;
IF trim(NEW.endati)::VARCHAR = '''' THEN
   NEW.endati := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.isento)::VARCHAR = '''' THEN
   NEW.isento := NULL;
END IF;
IF trim(NEW.con_doccon)::VARCHAR = '''' THEN
   NEW.con_doccon := NULL;
END IF;
IF trim(NEW.con_retpro)::VARCHAR = '''' THEN
   NEW.con_retpro := NULL;
END IF;
IF trim(NEW.nomrec)::VARCHAR = '''' THEN
   NEW.nomrec := NULL;
END IF;
IF trim(NEW.codct1)::VARCHAR = '''' THEN
   NEW.codct1 := NULL;
END IF;
IF trim(NEW.codct2)::VARCHAR = '''' THEN
   NEW.codct2 := NULL;
END IF;
IF trim(NEW.codct3)::VARCHAR = '''' THEN
   NEW.codct3 := NULL;
END IF;
IF trim(NEW.e_mfin)::VARCHAR = '''' THEN
   NEW.e_mfin := NULL;
END IF;
IF trim(NEW.end_codext)::VARCHAR = '''' THEN
   NEW.end_codext := NULL;
END IF;
IF trim(NEW.contribuinte)::VARCHAR = '''' THEN
   NEW.contribuinte := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_cli
BEFORE INSERT OR UPDATE ON ti_cli
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_cli();



/*-- SEQ 6070 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_com() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.incoju)::VARCHAR = '''' THEN
   NEW.incoju := NULL;
END IF;
IF trim(NEW.intpju)::VARCHAR = '''' THEN
   NEW.intpju := NULL;
END IF;
IF trim(NEW.intpmu)::VARCHAR = '''' THEN
   NEW.intpmu := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.tipnot)::VARCHAR = '''' THEN
   NEW.tipnot := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;
IF trim(NEW.numnot)::VARCHAR = '''' THEN
   NEW.numnot := NULL;
END IF;
IF trim(NEW.codmoe)::VARCHAR = '''' THEN
   NEW.codmoe := NULL;
END IF;
IF trim(NEW.moejur)::VARCHAR = '''' THEN
   NEW.moejur := NULL;
END IF;
IF trim(NEW.codset)::VARCHAR = '''' THEN
   NEW.codset := NULL;
END IF;
IF trim(NEW.notesp)::VARCHAR = '''' THEN
   NEW.notesp := NULL;
END IF;
IF trim(NEW.tippar)::VARCHAR = '''' THEN
   NEW.tippar := NULL;
END IF;
IF trim(NEW.tiptrp)::VARCHAR = '''' THEN
   NEW.tiptrp := NULL;
END IF;
IF trim(NEW.serfre)::VARCHAR = '''' THEN
   NEW.serfre := NULL;
END IF;
IF trim(NEW.forfre)::VARCHAR = '''' THEN
   NEW.forfre := NULL;
END IF;
IF trim(NEW.numfre)::VARCHAR = '''' THEN
   NEW.numfre := NULL;
END IF;
IF trim(NEW.serfat)::VARCHAR = '''' THEN
   NEW.serfat := NULL;
END IF;
IF trim(NEW.forfat)::VARCHAR = '''' THEN
   NEW.forfat := NULL;
END IF;
IF trim(NEW.numfat)::VARCHAR = '''' THEN
   NEW.numfat := NULL;
END IF;
IF trim(NEW.ufnota)::VARCHAR = '''' THEN
   NEW.ufnota := NULL;
END IF;
IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.subser)::VARCHAR = '''' THEN
   NEW.subser := NULL;
END IF;
IF trim(NEW.espdoc)::VARCHAR = '''' THEN
   NEW.espdoc := NULL;
END IF;
IF trim(NEW.conpgt)::VARCHAR = '''' THEN
   NEW.conpgt := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.filend)::VARCHAR = '''' THEN
   NEW.filend := NULL;
END IF;
IF trim(NEW.obsfat)::VARCHAR = '''' THEN
   NEW.obsfat := NULL;
END IF;
IF trim(NEW.codcfo)::VARCHAR = '''' THEN
   NEW.codcfo := NULL;
END IF;
IF trim(NEW.atucus)::VARCHAR = '''' THEN
   NEW.atucus := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;
IF trim(NEW.flgins)::VARCHAR = '''' THEN
   NEW.flgins := NULL;
END IF;
IF trim(NEW.flgcss)::VARCHAR = '''' THEN
   NEW.flgcss := NULL;
END IF;
IF trim(NEW.flgpis)::VARCHAR = '''' THEN
   NEW.flgpis := NULL;
END IF;
IF trim(NEW.flgcof)::VARCHAR = '''' THEN
   NEW.flgcof := NULL;
END IF;
IF trim(NEW.filfre)::VARCHAR = '''' THEN
   NEW.filfre := NULL;
END IF;
IF trim(NEW.filfat)::VARCHAR = '''' THEN
   NEW.filfat := NULL;
END IF;
IF trim(NEW.titcta)::VARCHAR = '''' THEN
   NEW.titcta := NULL;
END IF;
IF trim(NEW.usocta)::VARCHAR = '''' THEN
   NEW.usocta := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;
IF trim(NEW.cliente)::VARCHAR = '''' THEN
   NEW.cliente := NULL;
END IF;
IF trim(NEW.usuario)::VARCHAR = '''' THEN
   NEW.usuario := NULL;
END IF;
IF trim(NEW.descfo)::VARCHAR = '''' THEN
   NEW.descfo := NULL;
END IF;
IF trim(NEW.tipemp)::VARCHAR = '''' THEN
   NEW.tipemp := NULL;
END IF;
IF trim(NEW.poremp)::VARCHAR = '''' THEN
   NEW.poremp := NULL;
END IF;
IF trim(NEW.retirr)::VARCHAR = '''' THEN
   NEW.retirr := NULL;
END IF;
IF trim(NEW.retcss)::VARCHAR = '''' THEN
   NEW.retcss := NULL;
END IF;
IF trim(NEW.flgicm)::VARCHAR = '''' THEN
   NEW.flgicm := NULL;
END IF;
IF trim(NEW.flgiss)::VARCHAR = '''' THEN
   NEW.flgiss := NULL;
END IF;
IF trim(NEW.chavea)::VARCHAR = '''' THEN
   NEW.chavea := NULL;
END IF;
IF trim(NEW.codavu)::VARCHAR = '''' THEN
   NEW.codavu := NULL;
END IF;
IF trim(NEW.coddar)::VARCHAR = '''' THEN
   NEW.coddar := NULL;
END IF;
IF trim(NEW.codfps)::VARCHAR = '''' THEN
   NEW.codfps := NULL;
END IF;
IF trim(NEW.datstr)::VARCHAR = '''' THEN
   NEW.datstr := NULL;
END IF;
IF trim(NEW.filagc)::VARCHAR = '''' THEN
   NEW.filagc := NULL;
END IF;
IF trim(NEW.finnfe)::VARCHAR = '''' THEN
   NEW.finnfe := NULL;
END IF;
IF trim(NEW.natbcc)::VARCHAR = '''' THEN
   NEW.natbcc := NULL;
END IF;
IF trim(NEW.natfre)::VARCHAR = '''' THEN
   NEW.natfre := NULL;
END IF;
IF trim(NEW.rateio_frete)::VARCHAR = '''' THEN
   NEW.rateio_frete := NULL;
END IF;
IF trim(NEW.seqagc)::VARCHAR = '''' THEN
   NEW.seqagc := NULL;
END IF;
IF trim(NEW.sitcof)::VARCHAR = '''' THEN
   NEW.sitcof := NULL;
END IF;
IF trim(NEW.sitpis)::VARCHAR = '''' THEN
   NEW.sitpis := NULL;
END IF;
IF trim(NEW.tipfre)::VARCHAR = '''' THEN
   NEW.tipfre := NULL;
END IF;
IF trim(NEW.xmlnfe)::VARCHAR = '''' THEN
   NEW.xmlnfe := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_com
BEFORE INSERT OR UPDATE ON ti_com
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_com();



/*-- SEQ 6071 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_des() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.codpro)::VARCHAR = '''' THEN
   NEW.codpro := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_des
BEFORE INSERT OR UPDATE ON ti_des
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_des();



/*-- SEQ 6072 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_dop() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.fildes)::VARCHAR = '''' THEN
   NEW.fildes := NULL;
END IF;
IF trim(NEW.filrdp)::VARCHAR = '''' THEN
   NEW.filrdp := NULL;
END IF;
IF trim(NEW.seqrdp)::VARCHAR = '''' THEN
   NEW.seqrdp := NULL;
END IF;
IF trim(NEW.chetro)::VARCHAR = '''' THEN
   NEW.chetro := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.obsint)::VARCHAR = '''' THEN
   NEW.obsint := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;
IF trim(NEW.usocta)::VARCHAR = '''' THEN
   NEW.usocta := NULL;
END IF;
IF trim(NEW.titcta)::VARCHAR = '''' THEN
   NEW.titcta := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_dop
BEFORE INSERT OR UPDATE ON ti_dop
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_dop();



/*-- SEQ 6073 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_ean() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.codean)::VARCHAR = '''' THEN
   NEW.codean := NULL;
END IF;
IF trim(NEW.refati)::VARCHAR = '''' THEN
   NEW.refati := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_ean
BEFORE INSERT OR UPDATE ON ti_ean
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_ean();



/*-- SEQ 6074 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_ico() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.numnot)::VARCHAR = '''' THEN
   NEW.numnot := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;
IF trim(NEW.codcfo)::VARCHAR = '''' THEN
   NEW.codcfo := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.sitmov)::VARCHAR = '''' THEN
   NEW.sitmov := NULL;
END IF;
IF trim(NEW.unicom)::VARCHAR = '''' THEN
   NEW.unicom := NULL;
END IF;
IF trim(NEW.univen)::VARCHAR = '''' THEN
   NEW.univen := NULL;
END IF;
IF trim(NEW.lanest)::VARCHAR = '''' THEN
   NEW.lanest := NULL;
END IF;
IF trim(NEW.codbus)::VARCHAR = '''' THEN
   NEW.codbus := NULL;
END IF;
IF trim(NEW.codmul)::VARCHAR = '''' THEN
   NEW.codmul := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;
IF trim(NEW.icmtip)::VARCHAR = '''' THEN
   NEW.icmtip := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.tippro)::VARCHAR = '''' THEN
   NEW.tippro := NULL;
END IF;
IF trim(NEW.codmoe)::VARCHAR = '''' THEN
   NEW.codmoe := NULL;
END IF;
IF trim(NEW.descfo)::VARCHAR = '''' THEN
   NEW.descfo := NULL;
END IF;
IF trim(NEW.lot_codext)::VARCHAR = '''' THEN
   NEW.lot_codext := NULL;
END IF;
IF trim(NEW.codcst)::VARCHAR = '''' THEN
   NEW.codcst := NULL;
END IF;
IF trim(NEW.codben)::VARCHAR = '''' THEN
   NEW.codben := NULL;
END IF;
IF trim(NEW.codcstdif)::VARCHAR = '''' THEN
   NEW.codcstdif := NULL;
END IF;
IF trim(NEW.codfci)::VARCHAR = '''' THEN
   NEW.codfci := NULL;
END IF;
IF trim(NEW.cstxml)::VARCHAR = '''' THEN
   NEW.cstxml := NULL;
END IF;
IF trim(NEW.natbcc)::VARCHAR = '''' THEN
   NEW.natbcc := NULL;
END IF;
IF trim(NEW.retsub)::VARCHAR = '''' THEN
   NEW.retsub := NULL;
END IF;
IF trim(NEW.sitcof)::VARCHAR = '''' THEN
   NEW.sitcof := NULL;
END IF;
IF trim(NEW.sitipi)::VARCHAR = '''' THEN
   NEW.sitipi := NULL;
END IF;
IF trim(NEW.sitpis)::VARCHAR = '''' THEN
   NEW.sitpis := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_ico
BEFORE INSERT OR UPDATE ON ti_ico
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_ico();



/*-- SEQ 6075 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_iin() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.inv_codext)::VARCHAR = '''' THEN
   NEW.inv_codext := NULL;
END IF;
IF trim(NEW.gra_codext)::VARCHAR = '''' THEN
   NEW.gra_codext := NULL;
END IF;
IF trim(NEW.gra_refuni)::VARCHAR = '''' THEN
   NEW.gra_refuni := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_iin
BEFORE INSERT OR UPDATE ON ti_iin
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_iin();



/*-- SEQ 6076 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_imu() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.sittri)::VARCHAR = '''' THEN
   NEW.sittri := NULL;
END IF;
IF trim(NEW.desrps)::VARCHAR = '''' THEN
   NEW.desrps := NULL;
END IF;
IF trim(NEW.codsrv)::VARCHAR = '''' THEN
   NEW.codsrv := NULL;
END IF;
IF trim(NEW.dessrv)::VARCHAR = '''' THEN
   NEW.dessrv := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_imu
BEFORE INSERT OR UPDATE ON ti_imu
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_imu();



/*-- SEQ 6077 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_inv() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.apeusu)::VARCHAR = '''' THEN
   NEW.apeusu := NULL;
END IF;
IF trim(NEW.desinv)::VARCHAR = '''' THEN
   NEW.desinv := NULL;
END IF;
IF trim(NEW.desest)::VARCHAR = '''' THEN
   NEW.desest := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_inv
BEFORE INSERT OR UPDATE ON ti_inv
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_inv();



/*-- SEQ 6078 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_itf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.md5car)::VARCHAR = '''' THEN
   NEW.md5car := NULL;
END IF;
IF trim(NEW.nsutrn)::VARCHAR = '''' THEN
   NEW.nsutrn := NULL;
END IF;
IF trim(NEW.operad)::VARCHAR = '''' THEN
   NEW.operad := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;
IF trim(NEW.filtef)::VARCHAR = '''' THEN
   NEW.filtef := NULL;
END IF;
IF trim(NEW.seqtef)::VARCHAR = '''' THEN
   NEW.seqtef := NULL;
END IF;
IF trim(NEW.obssta)::VARCHAR = '''' THEN
   NEW.obssta := NULL;
END IF;
IF trim(NEW.numaut)::VARCHAR = '''' THEN
   NEW.numaut := NULL;
END IF;
IF trim(NEW.cnpj)::VARCHAR = '''' THEN
   NEW.cnpj := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.bandeira)::VARCHAR = '''' THEN
   NEW.bandeira := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_itf
BEFORE INSERT OR UPDATE ON ti_itf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_itf();



/*-- SEQ 6079 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_itf_ro() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;
IF trim(NEW.numage)::VARCHAR = '''' THEN
   NEW.numage := NULL;
END IF;
IF trim(NEW.ctacrr)::VARCHAR = '''' THEN
   NEW.ctacrr := NULL;
END IF;
IF trim(NEW.tippro)::VARCHAR = '''' THEN
   NEW.tippro := NULL;
END IF;
IF trim(NEW.opcext)::VARCHAR = '''' THEN
   NEW.opcext := NULL;
END IF;
IF trim(NEW.obssta)::VARCHAR = '''' THEN
   NEW.obssta := NULL;
END IF;
IF trim(NEW.operad)::VARCHAR = '''' THEN
   NEW.operad := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_itf_ro
BEFORE INSERT OR UPDATE ON ti_itf_ro
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_itf_ro();



/*-- SEQ 6080 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_ive() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.numnot)::VARCHAR = '''' THEN
   NEW.numnot := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.tip001)::VARCHAR = '''' THEN
   NEW.tip001 := NULL;
END IF;
IF trim(NEW.natfis)::VARCHAR = '''' THEN
   NEW.natfis := NULL;
END IF;
IF trim(NEW.tippro)::VARCHAR = '''' THEN
   NEW.tippro := NULL;
END IF;
IF trim(NEW.vincul)::VARCHAR = '''' THEN
   NEW.vincul := NULL;
END IF;
IF trim(NEW.sitkit)::VARCHAR = '''' THEN
   NEW.sitkit := NULL;
END IF;
IF trim(NEW.numext)::VARCHAR = '''' THEN
   NEW.numext := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;
IF trim(NEW.filbic)::VARCHAR = '''' THEN
   NEW.filbic := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;
IF trim(NEW.filori)::VARCHAR = '''' THEN
   NEW.filori := NULL;
END IF;
IF trim(NEW.notori)::VARCHAR = '''' THEN
   NEW.notori := NULL;
END IF;
IF trim(NEW.serori)::VARCHAR = '''' THEN
   NEW.serori := NULL;
END IF;
IF trim(NEW.ecfori)::VARCHAR = '''' THEN
   NEW.ecfori := NULL;
END IF;
IF trim(NEW.lanest)::VARCHAR = '''' THEN
   NEW.lanest := NULL;
END IF;
IF trim(NEW.icmtip)::VARCHAR = '''' THEN
   NEW.icmtip := NULL;
END IF;
IF trim(NEW.sitmov)::VARCHAR = '''' THEN
   NEW.sitmov := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.codvdd)::VARCHAR = '''' THEN
   NEW.codvdd := NULL;
END IF;
IF trim(NEW.calsub)::VARCHAR = '''' THEN
   NEW.calsub := NULL;
END IF;
IF trim(NEW.sittri)::VARCHAR = '''' THEN
   NEW.sittri := NULL;
END IF;
IF trim(NEW.devvin)::VARCHAR = '''' THEN
   NEW.devvin := NULL;
END IF;
IF trim(NEW.filrct)::VARCHAR = '''' THEN
   NEW.filrct := NULL;
END IF;
IF trim(NEW.fildou)::VARCHAR = '''' THEN
   NEW.fildou := NULL;
END IF;
IF trim(NEW.flgfut)::VARCHAR = '''' THEN
   NEW.flgfut := NULL;
END IF;
IF trim(NEW.nomdou)::VARCHAR = '''' THEN
   NEW.nomdou := NULL;
END IF;
IF trim(NEW.uf_crm)::VARCHAR = '''' THEN
   NEW.uf_crm := NULL;
END IF;
IF trim(NEW.numrct)::VARCHAR = '''' THEN
   NEW.numrct := NULL;
END IF;
IF trim(NEW.nompac)::VARCHAR = '''' THEN
   NEW.nompac := NULL;
END IF;
IF trim(NEW.rg_pac)::VARCHAR = '''' THEN
   NEW.rg_pac := NULL;
END IF;
IF trim(NEW.lot_codext)::VARCHAR = '''' THEN
   NEW.lot_codext := NULL;
END IF;
IF trim(NEW.codmul)::VARCHAR = '''' THEN
   NEW.codmul := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_ive
BEFORE INSERT OR UPDATE ON ti_ive
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_ive();



/*-- SEQ 6081 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_kit() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;
IF trim(NEW.tipope)::VARCHAR = '''' THEN
   NEW.tipope := NULL;
END IF;
IF trim(NEW.codpro)::VARCHAR = '''' THEN
   NEW.codpro := NULL;
END IF;
IF trim(NEW.codite)::VARCHAR = '''' THEN
   NEW.codite := NULL;
END IF;
IF trim(NEW.brinde)::VARCHAR = '''' THEN
   NEW.brinde := NULL;
END IF;
IF trim(NEW.flgimp)::VARCHAR = '''' THEN
   NEW.flgimp := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_kit
BEFORE INSERT OR UPDATE ON ti_kit
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_kit();



/*-- SEQ 6082 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_lan() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.desest)::VARCHAR = '''' THEN
   NEW.desest := NULL;
END IF;
IF trim(NEW.docume)::VARCHAR = '''' THEN
   NEW.docume := NULL;
END IF;
IF trim(NEW.tiplan)::VARCHAR = '''' THEN
   NEW.tiplan := NULL;
END IF;
IF trim(NEW.tipmov)::VARCHAR = '''' THEN
   NEW.tipmov := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;
IF trim(NEW.numext)::VARCHAR = '''' THEN
   NEW.numext := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.sitmov)::VARCHAR = '''' THEN
   NEW.sitmov := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;
IF trim(NEW.lot_codext)::VARCHAR = '''' THEN
   NEW.lot_codext := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_lan
BEFORE INSERT OR UPDATE ON ti_lan
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_lan();



/*-- SEQ 6083 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_lim() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.tipccc)::VARCHAR = '''' THEN
   NEW.tipccc := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;
IF trim(NEW.filpgt)::VARCHAR = '''' THEN
   NEW.filpgt := NULL;
END IF;
IF trim(NEW.despgt)::VARCHAR = '''' THEN
   NEW.despgt := NULL;
END IF;
IF trim(NEW.fatend)::VARCHAR = '''' THEN
   NEW.fatend := NULL;
END IF;
IF trim(NEW.codccc)::VARCHAR = '''' THEN
   NEW.codccc := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_lim
BEFORE INSERT OR UPDATE ON ti_lim
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_lim();



/*-- SEQ 6084 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_lot() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.gra_codext)::VARCHAR = '''' THEN
   NEW.gra_codext := NULL;
END IF;
IF trim(NEW.for_codext)::VARCHAR = '''' THEN
   NEW.for_codext := NULL;
END IF;
IF trim(NEW.numlot)::VARCHAR = '''' THEN
   NEW.numlot := NULL;
END IF;
IF trim(NEW.tonali)::VARCHAR = '''' THEN
   NEW.tonali := NULL;
END IF;
IF trim(NEW.tamanh)::VARCHAR = '''' THEN
   NEW.tamanh := NULL;
END IF;
IF trim(NEW.flgpon)::VARCHAR = '''' THEN
   NEW.flgpon := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;
IF trim(NEW.codalt)::VARCHAR = '''' THEN
   NEW.codalt := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_lot
BEFORE INSERT OR UPDATE ON ti_lot
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_lot();



/*-- SEQ 6085 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_nat() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.tipnat)::VARCHAR = '''' THEN
   NEW.tipnat := NULL;
END IF;
IF trim(NEW.financ)::VARCHAR = '''' THEN
   NEW.financ := NULL;
END IF;
IF trim(NEW.movest)::VARCHAR = '''' THEN
   NEW.movest := NULL;
END IF;
IF trim(NEW.natati)::VARCHAR = '''' THEN
   NEW.natati := NULL;
END IF;
IF trim(NEW.natoln)::VARCHAR = '''' THEN
   NEW.natoln := NULL;
END IF;
IF trim(NEW.tribut)::VARCHAR = '''' THEN
   NEW.tribut := NULL;
END IF;
IF trim(NEW.usacus)::VARCHAR = '''' THEN
   NEW.usacus := NULL;
END IF;
IF trim(NEW.natred)::VARCHAR = '''' THEN
   NEW.natred := NULL;
END IF;
IF trim(NEW.natref)::VARCHAR = '''' THEN
   NEW.natref := NULL;
END IF;
IF trim(NEW.lanven)::VARCHAR = '''' THEN
   NEW.lanven := NULL;
END IF;
IF trim(NEW.servin)::VARCHAR = '''' THEN
   NEW.servin := NULL;
END IF;
IF trim(NEW.natden)::VARCHAR = '''' THEN
   NEW.natden := NULL;
END IF;
IF trim(NEW.natfor)::VARCHAR = '''' THEN
   NEW.natfor := NULL;
END IF;
IF trim(NEW.natfud)::VARCHAR = '''' THEN
   NEW.natfud := NULL;
END IF;
IF trim(NEW.natfuf)::VARCHAR = '''' THEN
   NEW.natfuf := NULL;
END IF;
IF trim(NEW.nature)::VARCHAR = '''' THEN
   NEW.nature := NULL;
END IF;
IF trim(NEW.coment)::VARCHAR = '''' THEN
   NEW.coment := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.extdem)::VARCHAR = '''' THEN
   NEW.extdem := NULL;
END IF;
IF trim(NEW.extfor)::VARCHAR = '''' THEN
   NEW.extfor := NULL;
END IF;
IF trim(NEW.consfi)::VARCHAR = '''' THEN
   NEW.consfi := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;
IF trim(NEW.devvin)::VARCHAR = '''' THEN
   NEW.devvin := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_nat
BEFORE INSERT OR UPDATE ON ti_nat
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_nat();



/*-- SEQ 6086 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_pag() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.numnot)::VARCHAR = '''' THEN
   NEW.numnot := NULL;
END IF;
IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;
IF trim(NEW.numpar)::VARCHAR = '''' THEN
   NEW.numpar := NULL;
END IF;
IF trim(NEW.subpar)::VARCHAR = '''' THEN
   NEW.subpar := NULL;
END IF;
IF trim(NEW.fildop)::VARCHAR = '''' THEN
   NEW.fildop := NULL;
END IF;
IF trim(NEW.seqdop)::VARCHAR = '''' THEN
   NEW.seqdop := NULL;
END IF;
IF trim(NEW.conpgt)::VARCHAR = '''' THEN
   NEW.conpgt := NULL;
END IF;
IF trim(NEW.docpgt)::VARCHAR = '''' THEN
   NEW.docpgt := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.codaut)::VARCHAR = '''' THEN
   NEW.codaut := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.codpro)::VARCHAR = '''' THEN
   NEW.codpro := NULL;
END IF;
IF trim(NEW.flgflu)::VARCHAR = '''' THEN
   NEW.flgflu := NULL;
END IF;
IF trim(NEW.subori)::VARCHAR = '''' THEN
   NEW.subori := NULL;
END IF;
IF trim(NEW.dop_codext)::VARCHAR = '''' THEN
   NEW.dop_codext := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_pag
BEFORE INSERT OR UPDATE ON ti_pag
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_pag();



/*-- SEQ 6087 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_pla() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filpgt)::VARCHAR = '''' THEN
   NEW.filpgt := NULL;
END IF;
IF trim(NEW.preinf)::VARCHAR = '''' THEN
   NEW.preinf := NULL;
END IF;
IF trim(NEW.codmoe)::VARCHAR = '''' THEN
   NEW.codmoe := NULL;
END IF;
IF trim(NEW.moecor)::VARCHAR = '''' THEN
   NEW.moecor := NULL;
END IF;
IF trim(NEW.caronl)::VARCHAR = '''' THEN
   NEW.caronl := NULL;
END IF;
IF trim(NEW.entvlr)::VARCHAR = '''' THEN
   NEW.entvlr := NULL;
END IF;
IF trim(NEW.fatura)::VARCHAR = '''' THEN
   NEW.fatura := NULL;
END IF;
IF trim(NEW.flgesp)::VARCHAR = '''' THEN
   NEW.flgesp := NULL;
END IF;
IF trim(NEW.jurtot)::VARCHAR = '''' THEN
   NEW.jurtot := NULL;
END IF;
IF trim(NEW.apepgt)::VARCHAR = '''' THEN
   NEW.apepgt := NULL;
END IF;
IF trim(NEW.despgt)::VARCHAR = '''' THEN
   NEW.despgt := NULL;
END IF;
IF trim(NEW.class1)::VARCHAR = '''' THEN
   NEW.class1 := NULL;
END IF;
IF trim(NEW.class2)::VARCHAR = '''' THEN
   NEW.class2 := NULL;
END IF;
IF trim(NEW.class3)::VARCHAR = '''' THEN
   NEW.class3 := NULL;
END IF;
IF trim(NEW.class4)::VARCHAR = '''' THEN
   NEW.class4 := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.tipcob)::VARCHAR = '''' THEN
   NEW.tipcob := NULL;
END IF;
IF trim(NEW.usacam)::VARCHAR = '''' THEN
   NEW.usacam := NULL;
END IF;
IF trim(NEW.usacre)::VARCHAR = '''' THEN
   NEW.usacre := NULL;
END IF;
IF trim(NEW.usaout)::VARCHAR = '''' THEN
   NEW.usaout := NULL;
END IF;
IF trim(NEW.usache)::VARCHAR = '''' THEN
   NEW.usache := NULL;
END IF;
IF trim(NEW.usadin)::VARCHAR = '''' THEN
   NEW.usadin := NULL;
END IF;
IF trim(NEW.usatef)::VARCHAR = '''' THEN
   NEW.usatef := NULL;
END IF;
IF trim(NEW.usac_c)::VARCHAR = '''' THEN
   NEW.usac_c := NULL;
END IF;
IF trim(NEW.propor)::VARCHAR = '''' THEN
   NEW.propor := NULL;
END IF;
IF trim(NEW.desrec)::VARCHAR = '''' THEN
   NEW.desrec := NULL;
END IF;
IF trim(NEW.renego)::VARCHAR = '''' THEN
   NEW.renego := NULL;
END IF;
IF trim(NEW.rensob)::VARCHAR = '''' THEN
   NEW.rensob := NULL;
END IF;
IF trim(NEW.intpmu)::VARCHAR = '''' THEN
   NEW.intpmu := NULL;
END IF;
IF trim(NEW.usacpp)::VARCHAR = '''' THEN
   NEW.usacpp := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;
IF trim(NEW.natden)::VARCHAR = '''' THEN
   NEW.natden := NULL;
END IF;
IF trim(NEW.natfor)::VARCHAR = '''' THEN
   NEW.natfor := NULL;
END IF;
IF trim(NEW.categ1)::VARCHAR = '''' THEN
   NEW.categ1 := NULL;
END IF;
IF trim(NEW.categ2)::VARCHAR = '''' THEN
   NEW.categ2 := NULL;
END IF;
IF trim(NEW.categ3)::VARCHAR = '''' THEN
   NEW.categ3 := NULL;
END IF;
IF trim(NEW.tipccc)::VARCHAR = '''' THEN
   NEW.tipccc := NULL;
END IF;
IF trim(NEW.sobneg)::VARCHAR = '''' THEN
   NEW.sobneg := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_pla
BEFORE INSERT OR UPDATE ON ti_pla
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_pla();



/*-- SEQ 6088 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_pre() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.categ1)::VARCHAR = '''' THEN
   NEW.categ1 := NULL;
END IF;
IF trim(NEW.categ2)::VARCHAR = '''' THEN
   NEW.categ2 := NULL;
END IF;
IF trim(NEW.categ3)::VARCHAR = '''' THEN
   NEW.categ3 := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;
IF trim(NEW.codmoe)::VARCHAR = '''' THEN
   NEW.codmoe := NULL;
END IF;
IF trim(NEW.despre)::VARCHAR = '''' THEN
   NEW.despre := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.despre_codext)::VARCHAR = '''' THEN
   NEW.despre_codext := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_pre
BEFORE INSERT OR UPDATE ON ti_pre
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_pre();



/*-- SEQ 6089 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_pro() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.refbas)::VARCHAR = '''' THEN
   NEW.refbas := NULL;
END IF;
IF trim(NEW.desmat)::VARCHAR = '''' THEN
   NEW.desmat := NULL;
END IF;
IF trim(NEW.espmat)::VARCHAR = '''' THEN
   NEW.espmat := NULL;
END IF;
IF trim(NEW.contra)::VARCHAR = '''' THEN
   NEW.contra := NULL;
END IF;
IF trim(NEW.desecf)::VARCHAR = '''' THEN
   NEW.desecf := NULL;
END IF;
IF trim(NEW.desmar)::VARCHAR = '''' THEN
   NEW.desmar := NULL;
END IF;
IF trim(NEW.desina)::VARCHAR = '''' THEN
   NEW.desina := NULL;
END IF;
IF trim(NEW.class1)::VARCHAR = '''' THEN
   NEW.class1 := NULL;
END IF;
IF trim(NEW.class2)::VARCHAR = '''' THEN
   NEW.class2 := NULL;
END IF;
IF trim(NEW.class3)::VARCHAR = '''' THEN
   NEW.class3 := NULL;
END IF;
IF trim(NEW.class4)::VARCHAR = '''' THEN
   NEW.class4 := NULL;
END IF;
IF trim(NEW.depart)::VARCHAR = '''' THEN
   NEW.depart := NULL;
END IF;
IF trim(NEW.sazona)::VARCHAR = '''' THEN
   NEW.sazona := NULL;
END IF;
IF trim(NEW.etique)::VARCHAR = '''' THEN
   NEW.etique := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.desgra)::VARCHAR = '''' THEN
   NEW.desgra := NULL;
END IF;
IF trim(NEW.nomdiv)::VARCHAR = '''' THEN
   NEW.nomdiv := NULL;
END IF;
IF trim(NEW.nomsub)::VARCHAR = '''' THEN
   NEW.nomsub := NULL;
END IF;
IF trim(NEW.itediv)::VARCHAR = '''' THEN
   NEW.itediv := NULL;
END IF;
IF trim(NEW.itesub)::VARCHAR = '''' THEN
   NEW.itesub := NULL;
END IF;
IF trim(NEW.refpro)::VARCHAR = '''' THEN
   NEW.refpro := NULL;
END IF;
IF trim(NEW.locali)::VARCHAR = '''' THEN
   NEW.locali := NULL;
END IF;
IF trim(NEW.obsgra)::VARCHAR = '''' THEN
   NEW.obsgra := NULL;
END IF;
IF trim(NEW.estado)::VARCHAR = '''' THEN
   NEW.estado := NULL;
END IF;
IF trim(NEW.codfis)::VARCHAR = '''' THEN
   NEW.codfis := NULL;
END IF;
IF trim(NEW.insagr)::VARCHAR = '''' THEN
   NEW.insagr := NULL;
END IF;
IF trim(NEW.calsub)::VARCHAR = '''' THEN
   NEW.calsub := NULL;
END IF;
IF trim(NEW.codtri)::VARCHAR = '''' THEN
   NEW.codtri := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;
IF trim(NEW.nomimg)::VARCHAR = '''' THEN
   NEW.nomimg := NULL;
END IF;
IF trim(NEW.subfed)::VARCHAR = '''' THEN
   NEW.subfed := NULL;
END IF;
IF trim(NEW.ativo)::VARCHAR = '''' THEN
   NEW.ativo := NULL;
END IF;
IF trim(NEW.descfp)::VARCHAR = '''' THEN
   NEW.descfp := NULL;
END IF;
IF trim(NEW.codmon)::VARCHAR = '''' THEN
   NEW.codmon := NULL;
END IF;
IF trim(NEW.codlpc)::VARCHAR = '''' THEN
   NEW.codlpc := NULL;
END IF;
IF trim(NEW.tiprce)::VARCHAR = '''' THEN
   NEW.tiprce := NULL;
END IF;
IF trim(NEW.sugser)::VARCHAR = '''' THEN
   NEW.sugser := NULL;
END IF;
IF trim(NEW.balsim)::VARCHAR = '''' THEN
   NEW.balsim := NULL;
END IF;
IF trim(NEW.terass)::VARCHAR = '''' THEN
   NEW.terass := NULL;
END IF;
IF trim(NEW.flgser)::VARCHAR = '''' THEN
   NEW.flgser := NULL;
END IF;
IF trim(NEW.valest)::VARCHAR = '''' THEN
   NEW.valest := NULL;
END IF;
IF trim(NEW.contro)::VARCHAR = '''' THEN
   NEW.contro := NULL;
END IF;
IF trim(NEW.codfab)::VARCHAR = '''' THEN
   NEW.codfab := NULL;
END IF;
IF trim(NEW.entreg)::VARCHAR = '''' THEN
   NEW.entreg := NULL;
END IF;
IF trim(NEW.decima)::VARCHAR = '''' THEN
   NEW.decima := NULL;
END IF;
IF trim(NEW.numext)::VARCHAR = '''' THEN
   NEW.numext := NULL;
END IF;
IF trim(NEW.montar)::VARCHAR = '''' THEN
   NEW.montar := NULL;
END IF;
IF trim(NEW.retcof)::VARCHAR = '''' THEN
   NEW.retcof := NULL;
END IF;
IF trim(NEW.unidad)::VARCHAR = '''' THEN
   NEW.unidad := NULL;
END IF;
IF trim(NEW.unifor)::VARCHAR = '''' THEN
   NEW.unifor := NULL;
END IF;
IF trim(NEW.promoc)::VARCHAR = '''' THEN
   NEW.promoc := NULL;
END IF;
IF trim(NEW.voluni)::VARCHAR = '''' THEN
   NEW.voluni := NULL;
END IF;
IF trim(NEW.uniemb)::VARCHAR = '''' THEN
   NEW.uniemb := NULL;
END IF;
IF trim(NEW.uniapl)::VARCHAR = '''' THEN
   NEW.uniapl := NULL;
END IF;
IF trim(NEW.forlin)::VARCHAR = '''' THEN
   NEW.forlin := NULL;
END IF;
IF trim(NEW.prepsi)::VARCHAR = '''' THEN
   NEW.prepsi := NULL;
END IF;
IF trim(NEW.oricus)::VARCHAR = '''' THEN
   NEW.oricus := NULL;
END IF;
IF trim(NEW.graati)::VARCHAR = '''' THEN
   NEW.graati := NULL;
END IF;
IF trim(NEW.icmtip)::VARCHAR = '''' THEN
   NEW.icmtip := NULL;
END IF;
IF trim(NEW.sitcof)::VARCHAR = '''' THEN
   NEW.sitcof := NULL;
END IF;
IF trim(NEW.sitpis)::VARCHAR = '''' THEN
   NEW.sitpis := NULL;
END IF;
IF trim(NEW.codfps)::VARCHAR = '''' THEN
   NEW.codfps := NULL;
END IF;
IF trim(NEW.sitipi)::VARCHAR = '''' THEN
   NEW.sitipi := NULL;
END IF;
IF trim(NEW.codncm)::VARCHAR = '''' THEN
   NEW.codncm := NULL;
END IF;
IF trim(NEW.tipdoc)::VARCHAR = '''' THEN
   NEW.tipdoc := NULL;
END IF;
IF trim(NEW.isepis)::VARCHAR = '''' THEN
   NEW.isepis := NULL;
END IF;
IF trim(NEW.icmfed)::VARCHAR = '''' THEN
   NEW.icmfed := NULL;
END IF;
IF trim(NEW.arrtru)::VARCHAR = '''' THEN
   NEW.arrtru := NULL;
END IF;
IF trim(NEW.iiptpr)::VARCHAR = '''' THEN
   NEW.iiptpr := NULL;
END IF;
IF trim(NEW.impkit)::VARCHAR = '''' THEN
   NEW.impkit := NULL;
END IF;
IF trim(NEW.oripro)::VARCHAR = '''' THEN
   NEW.oripro := NULL;
END IF;
IF trim(NEW.natbcc)::VARCHAR = '''' THEN
   NEW.natbcc := NULL;
END IF;
IF trim(NEW.desdet)::VARCHAR = '''' THEN
   NEW.desdet := NULL;
END IF;
IF trim(NEW.icmise)::VARCHAR = '''' THEN
   NEW.icmise := NULL;
END IF;
IF trim(NEW.desweb)::VARCHAR = '''' THEN
   NEW.desweb := NULL;
END IF;
IF trim(NEW.nomdiv_codext)::VARCHAR = '''' THEN
   NEW.nomdiv_codext := NULL;
END IF;
IF trim(NEW.nomsub_codext)::VARCHAR = '''' THEN
   NEW.nomsub_codext := NULL;
END IF;
IF trim(NEW.nomgra_codext)::VARCHAR = '''' THEN
   NEW.nomgra_codext := NULL;
END IF;
IF trim(NEW.itediv_codext)::VARCHAR = '''' THEN
   NEW.itediv_codext := NULL;
END IF;
IF trim(NEW.itesub_codext)::VARCHAR = '''' THEN
   NEW.itesub_codext := NULL;
END IF;
IF trim(NEW.usalot)::VARCHAR = '''' THEN
   NEW.usalot := NULL;
END IF;
IF trim(NEW.lotonl)::VARCHAR = '''' THEN
   NEW.lotonl := NULL;
END IF;
IF trim(NEW.codces)::VARCHAR = '''' THEN
   NEW.codces := NULL;
END IF;
IF trim(NEW.tipmpb)::VARCHAR = '''' THEN
   NEW.tipmpb := NULL;
END IF;
IF trim(NEW.nomsub_codsal)::VARCHAR = '''' THEN
   NEW.nomsub_codsal := NULL;
END IF;
IF trim(NEW.gra_desgra)::VARCHAR = '''' THEN
   NEW.gra_desgra := NULL;
END IF;
IF trim(NEW.procon)::VARCHAR = '''' THEN
   NEW.procon := NULL;
END IF;
IF trim(NEW.regdif)::VARCHAR = '''' THEN
   NEW.regdif := NULL;
END IF;
IF trim(NEW.codben_00)::VARCHAR = '''' THEN
   NEW.codben_00 := NULL;
END IF;
IF trim(NEW.codben_10)::VARCHAR = '''' THEN
   NEW.codben_10 := NULL;
END IF;
IF trim(NEW.codben_20)::VARCHAR = '''' THEN
   NEW.codben_20 := NULL;
END IF;
IF trim(NEW.codben_30)::VARCHAR = '''' THEN
   NEW.codben_30 := NULL;
END IF;
IF trim(NEW.codben_40)::VARCHAR = '''' THEN
   NEW.codben_40 := NULL;
END IF;
IF trim(NEW.codben_41)::VARCHAR = '''' THEN
   NEW.codben_41 := NULL;
END IF;
IF trim(NEW.codben_50)::VARCHAR = '''' THEN
   NEW.codben_50 := NULL;
END IF;
IF trim(NEW.codben_51)::VARCHAR = '''' THEN
   NEW.codben_51 := NULL;
END IF;
IF trim(NEW.codben_60)::VARCHAR = '''' THEN
   NEW.codben_60 := NULL;
END IF;
IF trim(NEW.codben_70)::VARCHAR = '''' THEN
   NEW.codben_70 := NULL;
END IF;
IF trim(NEW.codben_90)::VARCHAR = '''' THEN
   NEW.codben_90 := NULL;
END IF;
IF trim(NEW.aplcon)::VARCHAR = '''' THEN
   NEW.aplcon := NULL;
END IF;
IF trim(NEW.desncm)::VARCHAR = '''' THEN
   NEW.desncm := NULL;
END IF;
IF trim(NEW.desces)::VARCHAR = '''' THEN
   NEW.desces := NULL;
END IF;
IF trim(NEW.imggru)::VARCHAR = '''' THEN
   NEW.imggru := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_pro
BEFORE INSERT OR UPDATE ON ti_pro
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_pro();



/*-- SEQ 6090 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_rec() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.numnot)::VARCHAR = '''' THEN
   NEW.numnot := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.numpar)::VARCHAR = '''' THEN
   NEW.numpar := NULL;
END IF;
IF trim(NEW.subpar)::VARCHAR = '''' THEN
   NEW.subpar := NULL;
END IF;
IF trim(NEW.filrec)::VARCHAR = '''' THEN
   NEW.filrec := NULL;
END IF;
IF trim(NEW.ecfrec)::VARCHAR = '''' THEN
   NEW.ecfrec := NULL;
END IF;
IF trim(NEW.cupfis)::VARCHAR = '''' THEN
   NEW.cupfis := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;
IF trim(NEW.codage)::VARCHAR = '''' THEN
   NEW.codage := NULL;
END IF;
IF trim(NEW.numche)::VARCHAR = '''' THEN
   NEW.numche := NULL;
END IF;
IF trim(NEW.numcon)::VARCHAR = '''' THEN
   NEW.numcon := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.codmoe)::VARCHAR = '''' THEN
   NEW.codmoe := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.flgflu)::VARCHAR = '''' THEN
   NEW.flgflu := NULL;
END IF;
IF trim(NEW.subori)::VARCHAR = '''' THEN
   NEW.subori := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_rec
BEFORE INSERT OR UPDATE ON ti_rec
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_rec();



/*-- SEQ 6091 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_rom() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.filmot)::VARCHAR = '''' THEN
   NEW.filmot := NULL;
END IF;
IF trim(NEW.codmot)::VARCHAR = '''' THEN
   NEW.codmot := NULL;
END IF;
IF trim(NEW.placa)::VARCHAR = '''' THEN
   NEW.placa := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_rom
BEFORE INSERT OR UPDATE ON ti_rom
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_rom();



/*-- SEQ 6092 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_sal() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.tiplan)::VARCHAR = '''' THEN
   NEW.tiplan := NULL;
END IF;
IF trim(NEW.desest)::VARCHAR = '''' THEN
   NEW.desest := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_sal
BEFORE INSERT OR UPDATE ON ti_sal
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_sal();



/*-- SEQ 6093 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_sep() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;
IF trim(NEW.rom_codext)::VARCHAR = '''' THEN
   NEW.rom_codext := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_sep
BEFORE INSERT OR UPDATE ON ti_sep
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_sep();



/*-- SEQ 6094 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_ser() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.divtro)::VARCHAR = '''' THEN
   NEW.divtro := NULL;
END IF;
IF trim(NEW.impnot)::VARCHAR = '''' THEN
   NEW.impnot := NULL;
END IF;
IF trim(NEW.restri)::VARCHAR = '''' THEN
   NEW.restri := NULL;
END IF;
IF trim(NEW.serati)::VARCHAR = '''' THEN
   NEW.serati := NULL;
END IF;
IF trim(NEW.serman)::VARCHAR = '''' THEN
   NEW.serman := NULL;
END IF;
IF trim(NEW.serfim)::VARCHAR = '''' THEN
   NEW.serfim := NULL;
END IF;
IF trim(NEW.serini)::VARCHAR = '''' THEN
   NEW.serini := NULL;
END IF;
IF trim(NEW.desser)::VARCHAR = '''' THEN
   NEW.desser := NULL;
END IF;
IF trim(NEW.dissai)::VARCHAR = '''' THEN
   NEW.dissai := NULL;
END IF;
IF trim(NEW.txtent)::VARCHAR = '''' THEN
   NEW.txtent := NULL;
END IF;
IF trim(NEW.txtfim)::VARCHAR = '''' THEN
   NEW.txtfim := NULL;
END IF;
IF trim(NEW.txtini)::VARCHAR = '''' THEN
   NEW.txtini := NULL;
END IF;
IF trim(NEW.txtite)::VARCHAR = '''' THEN
   NEW.txtite := NULL;
END IF;
IF trim(NEW.txtser)::VARCHAR = '''' THEN
   NEW.txtser := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_ser
BEFORE INSERT OR UPDATE ON ti_ser
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_ser();



/*-- SEQ 6095 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_slt() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.desest)::VARCHAR = '''' THEN
   NEW.desest := NULL;
END IF;
IF trim(NEW.lanent)::VARCHAR = '''' THEN
   NEW.lanent := NULL;
END IF;
IF trim(NEW.lansai)::VARCHAR = '''' THEN
   NEW.lansai := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_slt
BEFORE INSERT OR UPDATE ON ti_slt
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_slt();



/*-- SEQ 6096 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_usu() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.filsup)::VARCHAR = '''' THEN
   NEW.filsup := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.senha1)::VARCHAR = '''' THEN
   NEW.senha1 := NULL;
END IF;
IF trim(NEW.senha2)::VARCHAR = '''' THEN
   NEW.senha2 := NULL;
END IF;
IF trim(NEW.permis)::VARCHAR = '''' THEN
   NEW.permis := NULL;
END IF;
IF trim(NEW.codctr)::VARCHAR = '''' THEN
   NEW.codctr := NULL;
END IF;
IF trim(NEW.agendb)::VARCHAR = '''' THEN
   NEW.agendb := NULL;
END IF;
IF trim(NEW.edindb)::VARCHAR = '''' THEN
   NEW.edindb := NULL;
END IF;
IF trim(NEW.usandb)::VARCHAR = '''' THEN
   NEW.usandb := NULL;
END IF;
IF trim(NEW.usandc)::VARCHAR = '''' THEN
   NEW.usandc := NULL;
END IF;
IF trim(NEW.apeusu)::VARCHAR = '''' THEN
   NEW.apeusu := NULL;
END IF;
IF trim(NEW.nomusu)::VARCHAR = '''' THEN
   NEW.nomusu := NULL;
END IF;
IF trim(NEW.filatv)::VARCHAR = '''' THEN
   NEW.filatv := NULL;
END IF;
IF trim(NEW.tabatu)::VARCHAR = '''' THEN
   NEW.tabatu := NULL;
END IF;
IF trim(NEW.e_mail)::VARCHAR = '''' THEN
   NEW.e_mail := NULL;
END IF;
IF trim(NEW.visper)::VARCHAR = '''' THEN
   NEW.visper := NULL;
END IF;
IF trim(NEW.patndb)::VARCHAR = '''' THEN
   NEW.patndb := NULL;
END IF;
IF trim(NEW.grupos)::VARCHAR = '''' THEN
   NEW.grupos := NULL;
END IF;
IF trim(NEW.codset)::VARCHAR = '''' THEN
   NEW.codset := NULL;
END IF;
IF trim(NEW.fazenq)::VARCHAR = '''' THEN
   NEW.fazenq := NULL;
END IF;
IF trim(NEW.funcao)::VARCHAR = '''' THEN
   NEW.funcao := NULL;
END IF;
IF trim(NEW.fazmon)::VARCHAR = '''' THEN
   NEW.fazmon := NULL;
END IF;
IF trim(NEW.usucob)::VARCHAR = '''' THEN
   NEW.usucob := NULL;
END IF;
IF trim(NEW.comimp)::VARCHAR = '''' THEN
   NEW.comimp := NULL;
END IF;
IF trim(NEW.filini)::VARCHAR = '''' THEN
   NEW.filini := NULL;
END IF;
IF trim(NEW.codini)::VARCHAR = '''' THEN
   NEW.codini := NULL;
END IF;
IF trim(NEW.cfgini)::VARCHAR = '''' THEN
   NEW.cfgini := NULL;
END IF;
IF trim(NEW.viswor)::VARCHAR = '''' THEN
   NEW.viswor := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;
IF trim(NEW.csenha)::VARCHAR = '''' THEN
   NEW.csenha := NULL;
END IF;
IF trim(NEW.codsup)::VARCHAR = '''' THEN
   NEW.codsup := NULL;
END IF;
IF trim(NEW.tipope)::VARCHAR = '''' THEN
   NEW.tipope := NULL;
END IF;
IF trim(NEW.docpar)::VARCHAR = '''' THEN
   NEW.docpar := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_usu
BEFORE INSERT OR UPDATE ON ti_usu
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_usu();



/*-- SEQ 6097 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_ti_ven() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.numnot)::VARCHAR = '''' THEN
   NEW.numnot := NULL;
END IF;
IF trim(NEW.codctr)::VARCHAR = '''' THEN
   NEW.codctr := NULL;
END IF;
IF trim(NEW.autent)::VARCHAR = '''' THEN
   NEW.autent := NULL;
END IF;
IF trim(NEW.consfi)::VARCHAR = '''' THEN
   NEW.consfi := NULL;
END IF;
IF trim(NEW.emides)::VARCHAR = '''' THEN
   NEW.emides := NULL;
END IF;
IF trim(NEW.financ)::VARCHAR = '''' THEN
   NEW.financ := NULL;
END IF;
IF trim(NEW.tribut)::VARCHAR = '''' THEN
   NEW.tribut := NULL;
END IF;
IF trim(NEW.ufloja)::VARCHAR = '''' THEN
   NEW.ufloja := NULL;
END IF;
IF trim(NEW.codpre)::VARCHAR = '''' THEN
   NEW.codpre := NULL;
END IF;
IF trim(NEW.coddev)::VARCHAR = '''' THEN
   NEW.coddev := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.codpgt)::VARCHAR = '''' THEN
   NEW.codpgt := NULL;
END IF;
IF trim(NEW.filcob)::VARCHAR = '''' THEN
   NEW.filcob := NULL;
END IF;
IF trim(NEW.filent)::VARCHAR = '''' THEN
   NEW.filent := NULL;
END IF;
IF trim(NEW.filfat)::VARCHAR = '''' THEN
   NEW.filfat := NULL;
END IF;
IF trim(NEW.codtra)::VARCHAR = '''' THEN
   NEW.codtra := NULL;
END IF;
IF trim(NEW.numcon)::VARCHAR = '''' THEN
   NEW.numcon := NULL;
END IF;
IF trim(NEW.vincul)::VARCHAR = '''' THEN
   NEW.vincul := NULL;
END IF;
IF trim(NEW.marcas)::VARCHAR = '''' THEN
   NEW.marcas := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;
IF trim(NEW.tiptro)::VARCHAR = '''' THEN
   NEW.tiptro := NULL;
END IF;
IF trim(NEW.plafre)::VARCHAR = '''' THEN
   NEW.plafre := NULL;
END IF;
IF trim(NEW.uf_fre)::VARCHAR = '''' THEN
   NEW.uf_fre := NULL;
END IF;
IF trim(NEW.ecffat)::VARCHAR = '''' THEN
   NEW.ecffat := NULL;
END IF;
IF trim(NEW.serfat)::VARCHAR = '''' THEN
   NEW.serfat := NULL;
END IF;
IF trim(NEW.numfat)::VARCHAR = '''' THEN
   NEW.numfat := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;
IF trim(NEW.filpgt)::VARCHAR = '''' THEN
   NEW.filpgt := NULL;
END IF;
IF trim(NEW.natden)::VARCHAR = '''' THEN
   NEW.natden := NULL;
END IF;
IF trim(NEW.natfor)::VARCHAR = '''' THEN
   NEW.natfor := NULL;
END IF;
IF trim(NEW.filpre)::VARCHAR = '''' THEN
   NEW.filpre := NULL;
END IF;
IF trim(NEW.cliente)::VARCHAR = '''' THEN
   NEW.cliente := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.flgtip)::VARCHAR = '''' THEN
   NEW.flgtip := NULL;
END IF;
IF trim(NEW.tipnot)::VARCHAR = '''' THEN
   NEW.tipnot := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.codven)::VARCHAR = '''' THEN
   NEW.codven := NULL;
END IF;
IF trim(NEW.lanven)::VARCHAR = '''' THEN
   NEW.lanven := NULL;
END IF;
IF trim(NEW.codgui)::VARCHAR = '''' THEN
   NEW.codgui := NULL;
END IF;
IF trim(NEW.imprim)::VARCHAR = '''' THEN
   NEW.imprim := NULL;
END IF;
IF trim(NEW.autint)::VARCHAR = '''' THEN
   NEW.autint := NULL;
END IF;
IF trim(NEW.oriven)::VARCHAR = '''' THEN
   NEW.oriven := NULL;
END IF;
IF trim(NEW.avista)::VARCHAR = '''' THEN
   NEW.avista := NULL;
END IF;
IF trim(NEW.docnfp)::VARCHAR = '''' THEN
   NEW.docnfp := NULL;
END IF;
IF trim(NEW.flgnfe)::VARCHAR = '''' THEN
   NEW.flgnfe := NULL;
END IF;
IF trim(NEW.chavea)::VARCHAR = '''' THEN
   NEW.chavea := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_ti_ven
BEFORE INSERT OR UPDATE ON ti_ven
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_ti_ven();



/*-- SEQ 6098 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tr_cai() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.arqcai)::VARCHAR = '''' THEN
   NEW.arqcai := NULL;
END IF;
IF trim(NEW.arqxls)::VARCHAR = '''' THEN
   NEW.arqxls := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tr_cai
BEFORE INSERT OR UPDATE ON tr_cai
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tr_cai();



/*-- SEQ 6099 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tr_cta() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.flgflx)::VARCHAR = '''' THEN
   NEW.flgflx := NULL;
END IF;
IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.fillan)::VARCHAR = '''' THEN
   NEW.fillan := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tr_cta
BEFORE INSERT OR UPDATE ON tr_cta
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tr_cta();



/*-- SEQ 6100 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tr_cxg() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcxg)::VARCHAR = '''' THEN
   NEW.filcxg := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codcxg)::VARCHAR = '''' THEN
   NEW.codcxg := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tr_cxg
BEFORE INSERT OR UPDATE ON tr_cxg
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tr_cxg();



/*-- SEQ 6101 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tr_ecf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.diafec)::VARCHAR = '''' THEN
   NEW.diafec := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;
IF trim(NEW.seqcre)::VARCHAR = '''' THEN
   NEW.seqcre := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.manual)::VARCHAR = '''' THEN
   NEW.manual := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;
IF trim(NEW.pelafd)::VARCHAR = '''' THEN
   NEW.pelafd := NULL;
END IF;
IF trim(NEW.expfis)::VARCHAR = '''' THEN
   NEW.expfis := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.expem4)::VARCHAR = '''' THEN
   NEW.expem4 := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tr_ecf
BEFORE INSERT OR UPDATE ON tr_ecf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tr_ecf();



/*-- SEQ 6102 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tr_fin() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.origem)::VARCHAR = '''' THEN
   NEW.origem := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.numpar)::VARCHAR = '''' THEN
   NEW.numpar := NULL;
END IF;
IF trim(NEW.subpar)::VARCHAR = '''' THEN
   NEW.subpar := NULL;
END IF;
IF trim(NEW.tiplan)::VARCHAR = '''' THEN
   NEW.tiplan := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.flgflx)::VARCHAR = '''' THEN
   NEW.flgflx := NULL;
END IF;
IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.oricta)::VARCHAR = '''' THEN
   NEW.oricta := NULL;
END IF;
IF trim(NEW.filcrt)::VARCHAR = '''' THEN
   NEW.filcrt := NULL;
END IF;
IF trim(NEW.seqcrt)::VARCHAR = '''' THEN
   NEW.seqcrt := NULL;
END IF;
IF trim(NEW.tipcrt)::VARCHAR = '''' THEN
   NEW.tipcrt := NULL;
END IF;
IF trim(NEW.oricrt)::VARCHAR = '''' THEN
   NEW.oricrt := NULL;
END IF;
IF trim(NEW.filori)::VARCHAR = '''' THEN
   NEW.filori := NULL;
END IF;
IF trim(NEW.fildes)::VARCHAR = '''' THEN
   NEW.fildes := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tr_fin
BEFORE INSERT OR UPDATE ON tr_fin
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tr_fin();



/*-- SEQ 6103 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tr_mov() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.filico)::VARCHAR = '''' THEN
   NEW.filico := NULL;
END IF;
IF trim(NEW.seqico)::VARCHAR = '''' THEN
   NEW.seqico := NULL;
END IF;
IF trim(NEW.filfre)::VARCHAR = '''' THEN
   NEW.filfre := NULL;
END IF;
IF trim(NEW.seqfre)::VARCHAR = '''' THEN
   NEW.seqfre := NULL;
END IF;
IF trim(NEW.promoc)::VARCHAR = '''' THEN
   NEW.promoc := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tr_mov
BEFORE INSERT OR UPDATE ON tr_mov
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tr_mov();



/*-- SEQ 6104 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tr_sug() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.ano_mes)::VARCHAR = '''' THEN
   NEW.ano_mes := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.graabc)::VARCHAR = '''' THEN
   NEW.graabc := NULL;
END IF;
IF trim(NEW.graxyz)::VARCHAR = '''' THEN
   NEW.graxyz := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tr_sug
BEFORE INSERT OR UPDATE ON tr_sug
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tr_sug();



/*-- SEQ 6105 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_aba() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.encini)::VARCHAR = '''' THEN
   NEW.encini := NULL;
END IF;
IF trim(NEW.encfim)::VARCHAR = '''' THEN
   NEW.encfim := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;
IF trim(NEW.absaut)::VARCHAR = '''' THEN
   NEW.absaut := NULL;
END IF;
IF trim(NEW.absrem)::VARCHAR = '''' THEN
   NEW.absrem := NULL;
END IF;
IF trim(NEW.codaba)::VARCHAR = '''' THEN
   NEW.codaba := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.manut)::VARCHAR = '''' THEN
   NEW.manut := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_aba
BEFORE INSERT OR UPDATE ON tt_aba
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_aba();



/*-- SEQ 6106 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_abm() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.encerr)::VARCHAR = '''' THEN
   NEW.encerr := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_abm
BEFORE INSERT OR UPDATE ON tt_abm
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_abm();



/*-- SEQ 6107 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_acm() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.sitmov)::VARCHAR = '''' THEN
   NEW.sitmov := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.docume)::VARCHAR = '''' THEN
   NEW.docume := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_acm
BEFORE INSERT OR UPDATE ON tt_acm
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_acm();



/*-- SEQ 6108 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_acr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.placas)::VARCHAR = '''' THEN
   NEW.placas := NULL;
END IF;
IF trim(NEW.flgacr)::VARCHAR = '''' THEN
   NEW.flgacr := NULL;
END IF;
IF trim(NEW.flgser)::VARCHAR = '''' THEN
   NEW.flgser := NULL;
END IF;
IF trim(NEW.filaut)::VARCHAR = '''' THEN
   NEW.filaut := NULL;
END IF;
IF trim(NEW.codaut)::VARCHAR = '''' THEN
   NEW.codaut := NULL;
END IF;
IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;
IF trim(NEW.codage)::VARCHAR = '''' THEN
   NEW.codage := NULL;
END IF;
IF trim(NEW.numcon)::VARCHAR = '''' THEN
   NEW.numcon := NULL;
END IF;
IF trim(NEW.numche)::VARCHAR = '''' THEN
   NEW.numche := NULL;
END IF;
IF trim(NEW.serche)::VARCHAR = '''' THEN
   NEW.serche := NULL;
END IF;
IF trim(NEW.cdcmc7)::VARCHAR = '''' THEN
   NEW.cdcmc7 := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.motser)::VARCHAR = '''' THEN
   NEW.motser := NULL;
END IF;
IF trim(NEW.motlim)::VARCHAR = '''' THEN
   NEW.motlim := NULL;
END IF;
IF trim(NEW.oriacr)::VARCHAR = '''' THEN
   NEW.oriacr := NULL;
END IF;
IF trim(NEW.senacr)::VARCHAR = '''' THEN
   NEW.senacr := NULL;
END IF;
IF trim(NEW.obsche)::VARCHAR = '''' THEN
   NEW.obsche := NULL;
END IF;
IF trim(NEW.filmot)::VARCHAR = '''' THEN
   NEW.filmot := NULL;
END IF;
IF trim(NEW.codmot)::VARCHAR = '''' THEN
   NEW.codmot := NULL;
END IF;
IF trim(NEW.tipmot)::VARCHAR = '''' THEN
   NEW.tipmot := NULL;
END IF;
IF trim(NEW.filven)::VARCHAR = '''' THEN
   NEW.filven := NULL;
END IF;
IF trim(NEW.seqven)::VARCHAR = '''' THEN
   NEW.seqven := NULL;
END IF;
IF trim(NEW.imgchr)::VARCHAR = '''' THEN
   NEW.imgchr := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_acr
BEFORE INSERT OR UPDATE ON tt_acr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_acr();



/*-- SEQ 6109 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_adi() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.fabest)::VARCHAR = '''' THEN
   NEW.fabest := NULL;
END IF;
IF trim(NEW.codncm)::VARCHAR = '''' THEN
   NEW.codncm := NULL;
END IF;
IF trim(NEW.filfor)::VARCHAR = '''' THEN
   NEW.filfor := NULL;
END IF;
IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;
IF trim(NEW.desfor)::VARCHAR = '''' THEN
   NEW.desfor := NULL;
END IF;
IF trim(NEW.filfab)::VARCHAR = '''' THEN
   NEW.filfab := NULL;
END IF;
IF trim(NEW.codfab)::VARCHAR = '''' THEN
   NEW.codfab := NULL;
END IF;
IF trim(NEW.desfab)::VARCHAR = '''' THEN
   NEW.desfab := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_adi
BEFORE INSERT OR UPDATE ON tt_adi
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_adi();



/*-- SEQ 6110 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_afe() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filafe)::VARCHAR = '''' THEN
   NEW.filafe := NULL;
END IF;
IF trim(NEW.codafe)::VARCHAR = '''' THEN
   NEW.codafe := NULL;
END IF;
IF trim(NEW.filreg)::VARCHAR = '''' THEN
   NEW.filreg := NULL;
END IF;
IF trim(NEW.codreg)::VARCHAR = '''' THEN
   NEW.codreg := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_afe
BEFORE INSERT OR UPDATE ON tt_afe
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_afe();



/*-- SEQ 6111 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_agc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.repete)::VARCHAR = '''' THEN
   NEW.repete := NULL;
END IF;
IF trim(NEW.repdom)::VARCHAR = '''' THEN
   NEW.repdom := NULL;
END IF;
IF trim(NEW.repseg)::VARCHAR = '''' THEN
   NEW.repseg := NULL;
END IF;
IF trim(NEW.repter)::VARCHAR = '''' THEN
   NEW.repter := NULL;
END IF;
IF trim(NEW.repqua)::VARCHAR = '''' THEN
   NEW.repqua := NULL;
END IF;
IF trim(NEW.repqui)::VARCHAR = '''' THEN
   NEW.repqui := NULL;
END IF;
IF trim(NEW.repsex)::VARCHAR = '''' THEN
   NEW.repsex := NULL;
END IF;
IF trim(NEW.repsab)::VARCHAR = '''' THEN
   NEW.repsab := NULL;
END IF;
IF trim(NEW.repjan)::VARCHAR = '''' THEN
   NEW.repjan := NULL;
END IF;
IF trim(NEW.repfev)::VARCHAR = '''' THEN
   NEW.repfev := NULL;
END IF;
IF trim(NEW.repmar)::VARCHAR = '''' THEN
   NEW.repmar := NULL;
END IF;
IF trim(NEW.repabr)::VARCHAR = '''' THEN
   NEW.repabr := NULL;
END IF;
IF trim(NEW.repmai)::VARCHAR = '''' THEN
   NEW.repmai := NULL;
END IF;
IF trim(NEW.repjun)::VARCHAR = '''' THEN
   NEW.repjun := NULL;
END IF;
IF trim(NEW.repjul)::VARCHAR = '''' THEN
   NEW.repjul := NULL;
END IF;
IF trim(NEW.repago)::VARCHAR = '''' THEN
   NEW.repago := NULL;
END IF;
IF trim(NEW.repset)::VARCHAR = '''' THEN
   NEW.repset := NULL;
END IF;
IF trim(NEW.repout)::VARCHAR = '''' THEN
   NEW.repout := NULL;
END IF;
IF trim(NEW.repnov)::VARCHAR = '''' THEN
   NEW.repnov := NULL;
END IF;
IF trim(NEW.repdez)::VARCHAR = '''' THEN
   NEW.repdez := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_agc
BEFORE INSERT OR UPDATE ON tt_agc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_agc();



/*-- SEQ 6112 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_age() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.evento)::VARCHAR = '''' THEN
   NEW.evento := NULL;
END IF;
IF trim(NEW.coment)::VARCHAR = '''' THEN
   NEW.coment := NULL;
END IF;
IF trim(NEW.agepub)::VARCHAR = '''' THEN
   NEW.agepub := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_age
BEFORE INSERT OR UPDATE ON tt_age
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_age();



/*-- SEQ 6113 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_agexusu() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filage)::VARCHAR = '''' THEN
   NEW.filage := NULL;
END IF;
IF trim(NEW.seqage)::VARCHAR = '''' THEN
   NEW.seqage := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filpap)::VARCHAR = '''' THEN
   NEW.filpap := NULL;
END IF;
IF trim(NEW.seqpap)::VARCHAR = '''' THEN
   NEW.seqpap := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_agexusu
BEFORE INSERT OR UPDATE ON tt_agexusu
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_agexusu();



/*-- SEQ 6114 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_anp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.nomanp)::VARCHAR = '''' THEN
   NEW.nomanp := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_anp
BEFORE INSERT OR UPDATE ON tt_anp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_anp();



/*-- SEQ 6115 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_anx() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.nomanx)::VARCHAR = '''' THEN
   NEW.nomanx := NULL;
END IF;
IF trim(NEW.anexo)::VARCHAR = '''' THEN
   NEW.anexo := NULL;
END IF;
IF trim(NEW.seqmai)::VARCHAR = '''' THEN
   NEW.seqmai := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_anx
BEFORE INSERT OR UPDATE ON tt_anx
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_anx();



/*-- SEQ 6116 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_aqv() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.arqnom)::VARCHAR = '''' THEN
   NEW.arqnom := NULL;
END IF;
IF trim(NEW.arqtip)::VARCHAR = '''' THEN
   NEW.arqtip := NULL;
END IF;
IF trim(NEW.contyp)::VARCHAR = '''' THEN
   NEW.contyp := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_aqv
BEFORE INSERT OR UPDATE ON tt_aqv
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_aqv();



/*-- SEQ 6117 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_arq() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codtab)::VARCHAR = '''' THEN
   NEW.codtab := NULL;
END IF;
IF trim(NEW.codfis)::VARCHAR = '''' THEN
   NEW.codfis := NULL;
END IF;
IF trim(NEW.formul)::VARCHAR = '''' THEN
   NEW.formul := NULL;
END IF;
IF trim(NEW.nomtab)::VARCHAR = '''' THEN
   NEW.nomtab := NULL;
END IF;
IF trim(NEW.path)::VARCHAR = '''' THEN
   NEW.path := NULL;
END IF;
IF trim(NEW.paleta)::VARCHAR = '''' THEN
   NEW.paleta := NULL;
END IF;
IF trim(NEW.secun1)::VARCHAR = '''' THEN
   NEW.secun1 := NULL;
END IF;
IF trim(NEW.secun2)::VARCHAR = '''' THEN
   NEW.secun2 := NULL;
END IF;
IF trim(NEW.descri)::VARCHAR = '''' THEN
   NEW.descri := NULL;
END IF;
IF trim(NEW.primar)::VARCHAR = '''' THEN
   NEW.primar := NULL;
END IF;
IF trim(NEW.filbas)::VARCHAR = '''' THEN
   NEW.filbas := NULL;
END IF;
IF trim(NEW.id_uni)::VARCHAR = '''' THEN
   NEW.id_uni := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.parame)::VARCHAR = '''' THEN
   NEW.parame := NULL;
END IF;
IF trim(NEW.subsql)::VARCHAR = '''' THEN
   NEW.subsql := NULL;
END IF;
IF trim(NEW.person)::VARCHAR = '''' THEN
   NEW.person := NULL;
END IF;
IF trim(NEW.expnet)::VARCHAR = '''' THEN
   NEW.expnet := NULL;
END IF;
IF trim(NEW.geral)::VARCHAR = '''' THEN
   NEW.geral := NULL;
END IF;
IF trim(NEW.apelid)::VARCHAR = '''' THEN
   NEW.apelid := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_arq
BEFORE INSERT OR UPDATE ON tt_arq
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_arq();



/*-- SEQ 6118 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ass() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.nomtab)::VARCHAR = '''' THEN
   NEW.nomtab := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ass
BEFORE INSERT OR UPDATE ON tt_ass
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ass();



/*-- SEQ 6119 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_atu() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desatu)::VARCHAR = '''' THEN
   NEW.desatu := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_atu
BEFORE INSERT OR UPDATE ON tt_atu
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_atu();



/*-- SEQ 6120 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_aus() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.motivo)::VARCHAR = '''' THEN
   NEW.motivo := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filaus)::VARCHAR = '''' THEN
   NEW.filaus := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_aus
BEFORE INSERT OR UPDATE ON tt_aus
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_aus();



/*-- SEQ 6121 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_aut() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.modulo)::VARCHAR = '''' THEN
   NEW.modulo := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.comple)::VARCHAR = '''' THEN
   NEW.comple := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.seqven)::VARCHAR = '''' THEN
   NEW.seqven := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.tipped)::VARCHAR = '''' THEN
   NEW.tipped := NULL;
END IF;
IF trim(NEW.filcom)::VARCHAR = '''' THEN
   NEW.filcom := NULL;
END IF;
IF trim(NEW.seqcom)::VARCHAR = '''' THEN
   NEW.seqcom := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_aut
BEFORE INSERT OR UPDATE ON tt_aut
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_aut();



/*-- SEQ 6122 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ava() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filwor)::VARCHAR = '''' THEN
   NEW.filwor := NULL;
END IF;
IF trim(NEW.seqwor)::VARCHAR = '''' THEN
   NEW.seqwor := NULL;
END IF;
IF trim(NEW.filava)::VARCHAR = '''' THEN
   NEW.filava := NULL;
END IF;
IF trim(NEW.codava)::VARCHAR = '''' THEN
   NEW.codava := NULL;
END IF;
IF trim(NEW.filado)::VARCHAR = '''' THEN
   NEW.filado := NULL;
END IF;
IF trim(NEW.codado)::VARCHAR = '''' THEN
   NEW.codado := NULL;
END IF;
IF trim(NEW.avalia)::VARCHAR = '''' THEN
   NEW.avalia := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ava
BEFORE INSERT OR UPDATE ON tt_ava
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ava();



/*-- SEQ 6123 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_avi() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.filven)::VARCHAR = '''' THEN
   NEW.filven := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.placas)::VARCHAR = '''' THEN
   NEW.placas := NULL;
END IF;
IF trim(NEW.seqven)::VARCHAR = '''' THEN
   NEW.seqven := NULL;
END IF;
IF trim(NEW.mensag)::VARCHAR = '''' THEN
   NEW.mensag := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_avi
BEFORE INSERT OR UPDATE ON tt_avi
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_avi();



/*-- SEQ 6124 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_bai() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codmun)::VARCHAR = '''' THEN
   NEW.codmun := NULL;
END IF;
IF trim(NEW.nombai)::VARCHAR = '''' THEN
   NEW.nombai := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_bai
BEFORE INSERT OR UPDATE ON tt_bai
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_bai();



/*-- SEQ 6125 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_bicxecf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_bicxecf
BEFORE INSERT OR UPDATE ON tt_bicxecf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_bicxecf();



/*-- SEQ 6126 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_bon() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.filrec)::VARCHAR = '''' THEN
   NEW.filrec := NULL;
END IF;
IF trim(NEW.seqrec)::VARCHAR = '''' THEN
   NEW.seqrec := NULL;
END IF;
IF trim(NEW.numpar)::VARCHAR = '''' THEN
   NEW.numpar := NULL;
END IF;
IF trim(NEW.subpar)::VARCHAR = '''' THEN
   NEW.subpar := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.filccc)::VARCHAR = '''' THEN
   NEW.filccc := NULL;
END IF;
IF trim(NEW.seqccc)::VARCHAR = '''' THEN
   NEW.seqccc := NULL;
END IF;
IF trim(NEW.tipbon)::VARCHAR = '''' THEN
   NEW.tipbon := NULL;
END IF;
IF trim(NEW.histor)::VARCHAR = '''' THEN
   NEW.histor := NULL;
END IF;
IF trim(NEW.filven)::VARCHAR = '''' THEN
   NEW.filven := NULL;
END IF;
IF trim(NEW.seqven)::VARCHAR = '''' THEN
   NEW.seqven := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_bon
BEFORE INSERT OR UPDATE ON tt_bon
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_bon();



/*-- SEQ 6127 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_bonxcli() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filven)::VARCHAR = '''' THEN
   NEW.filven := NULL;
END IF;
IF trim(NEW.tippar)::VARCHAR = '''' THEN
   NEW.tippar := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_bonxcli
BEFORE INSERT OR UPDATE ON tt_bonxcli
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_bonxcli();



/*-- SEQ 6128 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_bru() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.aprova)::VARCHAR = '''' THEN
   NEW.aprova := NULL;
END IF;
IF trim(NEW.filaut)::VARCHAR = '''' THEN
   NEW.filaut := NULL;
END IF;
IF trim(NEW.codaut)::VARCHAR = '''' THEN
   NEW.codaut := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_bru
BEFORE INSERT OR UPDATE ON tt_bru
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_bru();



/*-- SEQ 6129 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_bsc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.filpre)::VARCHAR = '''' THEN
   NEW.filpre := NULL;
END IF;
IF trim(NEW.tip_formula)::VARCHAR = '''' THEN
   NEW.tip_formula := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.filped)::VARCHAR = '''' THEN
   NEW.filped := NULL;
END IF;
IF trim(NEW.tipped)::VARCHAR = '''' THEN
   NEW.tipped := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.flgori)::VARCHAR = '''' THEN
   NEW.flgori := NULL;
END IF;
IF trim(NEW.filtin)::VARCHAR = '''' THEN
   NEW.filtin := NULL;
END IF;
IF trim(NEW.seqtin)::VARCHAR = '''' THEN
   NEW.seqtin := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_bsc
BEFORE INSERT OR UPDATE ON tt_bsc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_bsc();



/*-- SEQ 6130 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cai() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.origem)::VARCHAR = '''' THEN
   NEW.origem := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.cheque)::VARCHAR = '''' THEN
   NEW.cheque := NULL;
END IF;
IF trim(NEW.tipcar)::VARCHAR = '''' THEN
   NEW.tipcar := NULL;
END IF;
IF trim(NEW.seqcai)::VARCHAR = '''' THEN
   NEW.seqcai := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cai
BEFORE INSERT OR UPDATE ON tt_cai
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cai();



/*-- SEQ 6131 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_car() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcar)::VARCHAR = '''' THEN
   NEW.filcar := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codmot)::VARCHAR = '''' THEN
   NEW.codmot := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filmot)::VARCHAR = '''' THEN
   NEW.filmot := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_car
BEFORE INSERT OR UPDATE ON tt_car
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_car();



/*-- SEQ 6132 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cbp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.filend)::VARCHAR = '''' THEN
   NEW.filend := NULL;
END IF;
IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;
IF trim(NEW.numage)::VARCHAR = '''' THEN
   NEW.numage := NULL;
END IF;
IF trim(NEW.ctacrr)::VARCHAR = '''' THEN
   NEW.ctacrr := NULL;
END IF;
IF trim(NEW.digage)::VARCHAR = '''' THEN
   NEW.digage := NULL;
END IF;
IF trim(NEW.diga_c)::VARCHAR = '''' THEN
   NEW.diga_c := NULL;
END IF;
IF trim(NEW.digcrr)::VARCHAR = '''' THEN
   NEW.digcrr := NULL;
END IF;
IF trim(NEW.tipcon)::VARCHAR = '''' THEN
   NEW.tipcon := NULL;
END IF;
IF trim(NEW.conjun)::VARCHAR = '''' THEN
   NEW.conjun := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cbp
BEFORE INSERT OR UPDATE ON tt_cbp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cbp();



/*-- SEQ 6133 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cbs() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filapl)::VARCHAR = '''' THEN
   NEW.filapl := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.troco_tef)::VARCHAR = '''' THEN
   NEW.troco_tef := NULL;
END IF;
IF trim(NEW.venda_cc_e_outros)::VARCHAR = '''' THEN
   NEW.venda_cc_e_outros := NULL;
END IF;
IF trim(NEW.usa_preatendimento)::VARCHAR = '''' THEN
   NEW.usa_preatendimento := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cbs
BEFORE INSERT OR UPDATE ON tt_cbs
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cbs();



/*-- SEQ 6134 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ccb() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;
IF trim(NEW.carccb)::VARCHAR = '''' THEN
   NEW.carccb := NULL;
END IF;
IF trim(NEW.dtrblq)::VARCHAR = '''' THEN
   NEW.dtrblq := NULL;
END IF;
IF trim(NEW.emiblq)::VARCHAR = '''' THEN
   NEW.emiblq := NULL;
END IF;
IF trim(NEW.frmcad)::VARCHAR = '''' THEN
   NEW.frmcad := NULL;
END IF;
IF trim(NEW.tipdoc)::VARCHAR = '''' THEN
   NEW.tipdoc := NULL;
END IF;
IF trim(NEW.desccb)::VARCHAR = '''' THEN
   NEW.desccb := NULL;
END IF;
IF trim(NEW.predes)::VARCHAR = '''' THEN
   NEW.predes := NULL;
END IF;
IF trim(NEW.envnos)::VARCHAR = '''' THEN
   NEW.envnos := NULL;
END IF;
IF trim(NEW.locpag)::VARCHAR = '''' THEN
   NEW.locpag := NULL;
END IF;
IF trim(NEW.gersgr)::VARCHAR = '''' THEN
   NEW.gersgr := NULL;
END IF;
IF trim(NEW.dedtax)::VARCHAR = '''' THEN
   NEW.dedtax := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ccb
BEFORE INSERT OR UPDATE ON tt_ccb
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ccb();



/*-- SEQ 6135 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ccc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.status)::VARCHAR = '''' THEN
   NEW.status := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.numpar)::VARCHAR = '''' THEN
   NEW.numpar := NULL;
END IF;
IF trim(NEW.subpar)::VARCHAR = '''' THEN
   NEW.subpar := NULL;
END IF;
IF trim(NEW.codven)::VARCHAR = '''' THEN
   NEW.codven := NULL;
END IF;
IF trim(NEW.filfat)::VARCHAR = '''' THEN
   NEW.filfat := NULL;
END IF;
IF trim(NEW.placas)::VARCHAR = '''' THEN
   NEW.placas := NULL;
END IF;
IF trim(NEW.seqfat)::VARCHAR = '''' THEN
   NEW.seqfat := NULL;
END IF;
IF trim(NEW.seqven)::VARCHAR = '''' THEN
   NEW.seqven := NULL;
END IF;
IF trim(NEW.comple)::VARCHAR = '''' THEN
   NEW.comple := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.oldstt)::VARCHAR = '''' THEN
   NEW.oldstt := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.filccc)::VARCHAR = '''' THEN
   NEW.filccc := NULL;
END IF;
IF trim(NEW.seqccc)::VARCHAR = '''' THEN
   NEW.seqccc := NULL;
END IF;
IF trim(NEW.tiprel)::VARCHAR = '''' THEN
   NEW.tiprel := NULL;
END IF;
IF trim(NEW.contra)::VARCHAR = '''' THEN
   NEW.contra := NULL;
END IF;
IF trim(NEW.filped)::VARCHAR = '''' THEN
   NEW.filped := NULL;
END IF;
IF trim(NEW.tipped)::VARCHAR = '''' THEN
   NEW.tipped := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.tiplan)::VARCHAR = '''' THEN
   NEW.tiplan := NULL;
END IF;
IF trim(NEW.fildop)::VARCHAR = '''' THEN
   NEW.fildop := NULL;
END IF;
IF trim(NEW.seqdop)::VARCHAR = '''' THEN
   NEW.seqdop := NULL;
END IF;
IF trim(NEW.filchr)::VARCHAR = '''' THEN
   NEW.filchr := NULL;
END IF;
IF trim(NEW.seqchr)::VARCHAR = '''' THEN
   NEW.seqchr := NULL;
END IF;
IF trim(NEW.filrat)::VARCHAR = '''' THEN
   NEW.filrat := NULL;
END IF;
IF trim(NEW.seqrat)::VARCHAR = '''' THEN
   NEW.seqrat := NULL;
END IF;
IF trim(NEW.chkfat)::VARCHAR = '''' THEN
   NEW.chkfat := NULL;
END IF;
IF trim(NEW.filwor)::VARCHAR = '''' THEN
   NEW.filwor := NULL;
END IF;
IF trim(NEW.seqwor)::VARCHAR = '''' THEN
   NEW.seqwor := NULL;
END IF;
IF trim(NEW.filcms)::VARCHAR = '''' THEN
   NEW.filcms := NULL;
END IF;
IF trim(NEW.seqcms)::VARCHAR = '''' THEN
   NEW.seqcms := NULL;
END IF;
IF trim(NEW.atulim)::VARCHAR = '''' THEN
   NEW.atulim := NULL;
END IF;
IF trim(NEW.expem4)::VARCHAR = '''' THEN
   NEW.expem4 := NULL;
END IF;
IF trim(NEW.indexp)::VARCHAR = '''' THEN
   NEW.indexp := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ccc
BEFORE INSERT OR UPDATE ON tt_ccc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ccc();



/*-- SEQ 6136 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cce() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.e_mail)::VARCHAR = '''' THEN
   NEW.e_mail := NULL;
END IF;
IF trim(NEW.hostid)::VARCHAR = '''' THEN
   NEW.hostid := NULL;
END IF;
IF trim(NEW.snhpop)::VARCHAR = '''' THEN
   NEW.snhpop := NULL;
END IF;
IF trim(NEW.userid)::VARCHAR = '''' THEN
   NEW.userid := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.nomcce)::VARCHAR = '''' THEN
   NEW.nomcce := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cce
BEFORE INSERT OR UPDATE ON tt_cce
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cce();



/*-- SEQ 6137 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cct() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filctt)::VARCHAR = '''' THEN
   NEW.filctt := NULL;
END IF;
IF trim(NEW.seqctt)::VARCHAR = '''' THEN
   NEW.seqctt := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cct
BEFORE INSERT OR UPDATE ON tt_cct
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cct();



/*-- SEQ 6138 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ccx() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ccx
BEFORE INSERT OR UPDATE ON tt_ccx
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ccx();



/*-- SEQ 6139 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cee() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.indemi)::VARCHAR = '''' THEN
   NEW.indemi := NULL;
END IF;
IF trim(NEW.textoc)::VARCHAR = '''' THEN
   NEW.textoc := NULL;
END IF;
IF trim(NEW.filven)::VARCHAR = '''' THEN
   NEW.filven := NULL;
END IF;
IF trim(NEW.seqven)::VARCHAR = '''' THEN
   NEW.seqven := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cee
BEFORE INSERT OR UPDATE ON tt_cee
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cee();



/*-- SEQ 6140 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ces() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codces)::VARCHAR = '''' THEN
   NEW.codces := NULL;
END IF;
IF trim(NEW.desces)::VARCHAR = '''' THEN
   NEW.desces := NULL;
END IF;
IF trim(NEW.cesati)::VARCHAR = '''' THEN
   NEW.cesati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ces
BEFORE INSERT OR UPDATE ON tt_ces
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ces();



/*-- SEQ 6141 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cesxncm() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codces)::VARCHAR = '''' THEN
   NEW.codces := NULL;
END IF;
IF trim(NEW.codncm)::VARCHAR = '''' THEN
   NEW.codncm := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cesxncm
BEFORE INSERT OR UPDATE ON tt_cesxncm
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cesxncm();



/*-- SEQ 6142 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cfc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.tipmei)::VARCHAR = '''' THEN
   NEW.tipmei := NULL;
END IF;
IF trim(NEW.desmei)::VARCHAR = '''' THEN
   NEW.desmei := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cfc
BEFORE INSERT OR UPDATE ON tt_cfc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cfc();



/*-- SEQ 6143 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cfg() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.tipcta_trn)::VARCHAR = '''' THEN
   NEW.tipcta_trn := NULL;
END IF;
IF trim(NEW.serie_fat_cc)::VARCHAR = '''' THEN
   NEW.serie_fat_cc := NULL;
END IF;
IF trim(NEW.vc_serie)::VARCHAR = '''' THEN
   NEW.vc_serie := NULL;
END IF;
IF trim(NEW.filcta_trn)::VARCHAR = '''' THEN
   NEW.filcta_trn := NULL;
END IF;
IF trim(NEW.filpre)::VARCHAR = '''' THEN
   NEW.filpre := NULL;
END IF;
IF trim(NEW.vc_codpgt)::VARCHAR = '''' THEN
   NEW.vc_codpgt := NULL;
END IF;
IF trim(NEW.vc_filcli)::VARCHAR = '''' THEN
   NEW.vc_filcli := NULL;
END IF;
IF trim(NEW.vc_filpgt)::VARCHAR = '''' THEN
   NEW.vc_filpgt := NULL;
END IF;
IF trim(NEW.vc_codcli)::VARCHAR = '''' THEN
   NEW.vc_codcli := NULL;
END IF;
IF trim(NEW.seqcta_trn)::VARCHAR = '''' THEN
   NEW.seqcta_trn := NULL;
END IF;
IF trim(NEW.chetro)::VARCHAR = '''' THEN
   NEW.chetro := NULL;
END IF;
IF trim(NEW.pcoonline)::VARCHAR = '''' THEN
   NEW.pcoonline := NULL;
END IF;
IF trim(NEW.tipfar)::VARCHAR = '''' THEN
   NEW.tipfar := NULL;
END IF;
IF trim(NEW.tippos)::VARCHAR = '''' THEN
   NEW.tippos := NULL;
END IF;
IF trim(NEW.tipsoft)::VARCHAR = '''' THEN
   NEW.tipsoft := NULL;
END IF;
IF trim(NEW.usadoc)::VARCHAR = '''' THEN
   NEW.usadoc := NULL;
END IF;
IF trim(NEW.vldcliext)::VARCHAR = '''' THEN
   NEW.vldcliext := NULL;
END IF;
IF trim(NEW.vldestext)::VARCHAR = '''' THEN
   NEW.vldestext := NULL;
END IF;
IF trim(NEW.pluraldec)::VARCHAR = '''' THEN
   NEW.pluraldec := NULL;
END IF;
IF trim(NEW.pluralint)::VARCHAR = '''' THEN
   NEW.pluralint := NULL;
END IF;
IF trim(NEW.singuldec)::VARCHAR = '''' THEN
   NEW.singuldec := NULL;
END IF;
IF trim(NEW.singulint)::VARCHAR = '''' THEN
   NEW.singulint := NULL;
END IF;
IF trim(NEW.nomcodsac)::VARCHAR = '''' THEN
   NEW.nomcodsac := NULL;
END IF;
IF trim(NEW.nomlstsac)::VARCHAR = '''' THEN
   NEW.nomlstsac := NULL;
END IF;
IF trim(NEW.nomnumreg)::VARCHAR = '''' THEN
   NEW.nomnumreg := NULL;
END IF;
IF trim(NEW.nomnumser)::VARCHAR = '''' THEN
   NEW.nomnumser := NULL;
END IF;
IF trim(NEW.nomemp)::VARCHAR = '''' THEN
   NEW.nomemp := NULL;
END IF;
IF trim(NEW.mai_fr)::VARCHAR = '''' THEN
   NEW.mai_fr := NULL;
END IF;
IF trim(NEW.mai_to)::VARCHAR = '''' THEN
   NEW.mai_to := NULL;
END IF;
IF trim(NEW.lanven_reimp_cf)::VARCHAR = '''' THEN
   NEW.lanven_reimp_cf := NULL;
END IF;
IF trim(NEW.usostd)::VARCHAR = '''' THEN
   NEW.usostd := NULL;
END IF;
IF trim(NEW.fil_papel_todos)::VARCHAR = '''' THEN
   NEW.fil_papel_todos := NULL;
END IF;
IF trim(NEW.seq_papel_todos)::VARCHAR = '''' THEN
   NEW.seq_papel_todos := NULL;
END IF;
IF trim(NEW.au_entrel)::VARCHAR = '''' THEN
   NEW.au_entrel := NULL;
END IF;
IF trim(NEW.au_entrelc)::VARCHAR = '''' THEN
   NEW.au_entrelc := NULL;
END IF;
IF trim(NEW.clicodext)::VARCHAR = '''' THEN
   NEW.clicodext := NULL;
END IF;
IF trim(NEW.financ_reimp_cf)::VARCHAR = '''' THEN
   NEW.financ_reimp_cf := NULL;
END IF;
IF trim(NEW.movest_reimp_cf)::VARCHAR = '''' THEN
   NEW.movest_reimp_cf := NULL;
END IF;
IF trim(NEW.srvuni)::VARCHAR = '''' THEN
   NEW.srvuni := NULL;
END IF;
IF trim(NEW.tribut_reimp_cf)::VARCHAR = '''' THEN
   NEW.tribut_reimp_cf := NULL;
END IF;
IF trim(NEW.valida_numdoc)::VARCHAR = '''' THEN
   NEW.valida_numdoc := NULL;
END IF;
IF trim(NEW.cdco)::VARCHAR = '''' THEN
   NEW.cdco := NULL;
END IF;
IF trim(NEW.au_impress)::VARCHAR = '''' THEN
   NEW.au_impress := NULL;
END IF;
IF trim(NEW.categ1)::VARCHAR = '''' THEN
   NEW.categ1 := NULL;
END IF;
IF trim(NEW.categ2)::VARCHAR = '''' THEN
   NEW.categ2 := NULL;
END IF;
IF trim(NEW.categ3)::VARCHAR = '''' THEN
   NEW.categ3 := NULL;
END IF;
IF trim(NEW.class1)::VARCHAR = '''' THEN
   NEW.class1 := NULL;
END IF;
IF trim(NEW.class2)::VARCHAR = '''' THEN
   NEW.class2 := NULL;
END IF;
IF trim(NEW.class3)::VARCHAR = '''' THEN
   NEW.class3 := NULL;
END IF;
IF trim(NEW.class4)::VARCHAR = '''' THEN
   NEW.class4 := NULL;
END IF;
IF trim(NEW.data1)::VARCHAR = '''' THEN
   NEW.data1 := NULL;
END IF;
IF trim(NEW.data2)::VARCHAR = '''' THEN
   NEW.data2 := NULL;
END IF;
IF trim(NEW.data3)::VARCHAR = '''' THEN
   NEW.data3 := NULL;
END IF;
IF trim(NEW.vc_plano)::VARCHAR = '''' THEN
   NEW.vc_plano := NULL;
END IF;
IF trim(NEW.au_autent)::VARCHAR = '''' THEN
   NEW.au_autent := NULL;
END IF;
IF trim(NEW.au_desaut)::VARCHAR = '''' THEN
   NEW.au_desaut := NULL;
END IF;
IF trim(NEW.au_deslin)::VARCHAR = '''' THEN
   NEW.au_deslin := NULL;
END IF;
IF trim(NEW.au_hablin)::VARCHAR = '''' THEN
   NEW.au_hablin := NULL;
END IF;
IF trim(NEW.au_lnfeed)::VARCHAR = '''' THEN
   NEW.au_lnfeed := NULL;
END IF;
IF trim(NEW.mask_locali)::VARCHAR = '''' THEN
   NEW.mask_locali := NULL;
END IF;
IF trim(NEW.subcodsac)::VARCHAR = '''' THEN
   NEW.subcodsac := NULL;
END IF;
IF trim(NEW.au_inic)::VARCHAR = '''' THEN
   NEW.au_inic := NULL;
END IF;
IF trim(NEW.desven)::VARCHAR = '''' THEN
   NEW.desven := NULL;
END IF;
IF trim(NEW.vc_cliente)::VARCHAR = '''' THEN
   NEW.vc_cliente := NULL;
END IF;
IF trim(NEW.au_imprim)::VARCHAR = '''' THEN
   NEW.au_imprim := NULL;
END IF;
IF trim(NEW.divpath)::VARCHAR = '''' THEN
   NEW.divpath := NULL;
END IF;
IF trim(NEW.path_anexos)::VARCHAR = '''' THEN
   NEW.path_anexos := NULL;
END IF;
IF trim(NEW.path_projetos)::VARCHAR = '''' THEN
   NEW.path_projetos := NULL;
END IF;
IF trim(NEW.rbpath)::VARCHAR = '''' THEN
   NEW.rbpath := NULL;
END IF;
IF trim(NEW.sac_e_mail)::VARCHAR = '''' THEN
   NEW.sac_e_mail := NULL;
END IF;
IF trim(NEW.sac_host)::VARCHAR = '''' THEN
   NEW.sac_host := NULL;
END IF;
IF trim(NEW.sac_nome)::VARCHAR = '''' THEN
   NEW.sac_nome := NULL;
END IF;
IF trim(NEW.sac_porta_smtp)::VARCHAR = '''' THEN
   NEW.sac_porta_smtp := NULL;
END IF;
IF trim(NEW.sac_resposta_erro)::VARCHAR = '''' THEN
   NEW.sac_resposta_erro := NULL;
END IF;
IF trim(NEW.sac_senha_pop3)::VARCHAR = '''' THEN
   NEW.sac_senha_pop3 := NULL;
END IF;
IF trim(NEW.sac_texto_libera)::VARCHAR = '''' THEN
   NEW.sac_texto_libera := NULL;
END IF;
IF trim(NEW.sac_userid)::VARCHAR = '''' THEN
   NEW.sac_userid := NULL;
END IF;
IF trim(NEW.cabpre)::VARCHAR = '''' THEN
   NEW.cabpre := NULL;
END IF;
IF trim(NEW.fatura)::VARCHAR = '''' THEN
   NEW.fatura := NULL;
END IF;
IF trim(NEW.fmtdoc)::VARCHAR = '''' THEN
   NEW.fmtdoc := NULL;
END IF;
IF trim(NEW.fmtreq)::VARCHAR = '''' THEN
   NEW.fmtreq := NULL;
END IF;
IF trim(NEW.rodpre)::VARCHAR = '''' THEN
   NEW.rodpre := NULL;
END IF;
IF trim(NEW.sac_home_page)::VARCHAR = '''' THEN
   NEW.sac_home_page := NULL;
END IF;
IF trim(NEW.vende_desativados)::VARCHAR = '''' THEN
   NEW.vende_desativados := NULL;
END IF;
IF trim(NEW.popula_tp_cli)::VARCHAR = '''' THEN
   NEW.popula_tp_cli := NULL;
END IF;
IF trim(NEW.ckbemvindo)::VARCHAR = '''' THEN
   NEW.ckbemvindo := NULL;
END IF;
IF trim(NEW.cknomatend)::VARCHAR = '''' THEN
   NEW.cknomatend := NULL;
END IF;
IF trim(NEW.ckvlrinfun)::VARCHAR = '''' THEN
   NEW.ckvlrinfun := NULL;
END IF;
IF trim(NEW.ckusabalan)::VARCHAR = '''' THEN
   NEW.ckusabalan := NULL;
END IF;
IF trim(NEW.cknumextdp)::VARCHAR = '''' THEN
   NEW.cknumextdp := NULL;
END IF;
IF trim(NEW.ckpanumext)::VARCHAR = '''' THEN
   NEW.ckpanumext := NULL;
END IF;
IF trim(NEW.ckpaobrven)::VARCHAR = '''' THEN
   NEW.ckpaobrven := NULL;
END IF;
IF trim(NEW.ckpaagrupa)::VARCHAR = '''' THEN
   NEW.ckpaagrupa := NULL;
END IF;
IF trim(NEW.ckpaconsfi)::VARCHAR = '''' THEN
   NEW.ckpaconsfi := NULL;
END IF;
IF trim(NEW.ckusadebap)::VARCHAR = '''' THEN
   NEW.ckusadebap := NULL;
END IF;
IF trim(NEW.ckpapagirr)::VARCHAR = '''' THEN
   NEW.ckpapagirr := NULL;
END IF;
IF trim(NEW.ckpasaiche)::VARCHAR = '''' THEN
   NEW.ckpasaiche := NULL;
END IF;
IF trim(NEW.ckpamfimpp)::VARCHAR = '''' THEN
   NEW.ckpamfimpp := NULL;
END IF;
IF trim(NEW.ckpadigche)::VARCHAR = '''' THEN
   NEW.ckpadigche := NULL;
END IF;
IF trim(NEW.ckpapredoc)::VARCHAR = '''' THEN
   NEW.ckpapredoc := NULL;
END IF;
IF trim(NEW.ckpavlrapr)::VARCHAR = '''' THEN
   NEW.ckpavlrapr := NULL;
END IF;
IF trim(NEW.ckpasaicai)::VARCHAR = '''' THEN
   NEW.ckpasaicai := NULL;
END IF;
IF trim(NEW.ckpaunicai)::VARCHAR = '''' THEN
   NEW.ckpaunicai := NULL;
END IF;
IF trim(NEW.ckpatxtpre)::VARCHAR = '''' THEN
   NEW.ckpatxtpre := NULL;
END IF;
IF trim(NEW.ckpavenite)::VARCHAR = '''' THEN
   NEW.ckpavenite := NULL;
END IF;
IF trim(NEW.ckpatotven)::VARCHAR = '''' THEN
   NEW.ckpatotven := NULL;
END IF;
IF trim(NEW.ckpadescit)::VARCHAR = '''' THEN
   NEW.ckpadescit := NULL;
END IF;
IF trim(NEW.ckpadescto)::VARCHAR = '''' THEN
   NEW.ckpadescto := NULL;
END IF;
IF trim(NEW.ckftxtsub1)::VARCHAR = '''' THEN
   NEW.ckftxtsub1 := NULL;
END IF;
IF trim(NEW.ckftxtsub2)::VARCHAR = '''' THEN
   NEW.ckftxtsub2 := NULL;
END IF;
IF trim(NEW.ckftxtsub3)::VARCHAR = '''' THEN
   NEW.ckftxtsub3 := NULL;
END IF;
IF trim(NEW.ckftxtsub4)::VARCHAR = '''' THEN
   NEW.ckftxtsub4 := NULL;
END IF;
IF trim(NEW.ckforcomit)::VARCHAR = '''' THEN
   NEW.ckforcomit := NULL;
END IF;
IF trim(NEW.ckforcomv1)::VARCHAR = '''' THEN
   NEW.ckforcomv1 := NULL;
END IF;
IF trim(NEW.ckforcomv2)::VARCHAR = '''' THEN
   NEW.ckforcomv2 := NULL;
END IF;
IF trim(NEW.ckforcoms1)::VARCHAR = '''' THEN
   NEW.ckforcoms1 := NULL;
END IF;
IF trim(NEW.ckforcoms2)::VARCHAR = '''' THEN
   NEW.ckforcoms2 := NULL;
END IF;
IF trim(NEW.ckforcoms3)::VARCHAR = '''' THEN
   NEW.ckforcoms3 := NULL;
END IF;
IF trim(NEW.ckforcoms4)::VARCHAR = '''' THEN
   NEW.ckforcoms4 := NULL;
END IF;
IF trim(NEW.ckpacoml1)::VARCHAR = '''' THEN
   NEW.ckpacoml1 := NULL;
END IF;
IF trim(NEW.ckpacoml2)::VARCHAR = '''' THEN
   NEW.ckpacoml2 := NULL;
END IF;
IF trim(NEW.ckpacoml3)::VARCHAR = '''' THEN
   NEW.ckpacoml3 := NULL;
END IF;
IF trim(NEW.ckpacoml4)::VARCHAR = '''' THEN
   NEW.ckpacoml4 := NULL;
END IF;
IF trim(NEW.e_mail_financ)::VARCHAR = '''' THEN
   NEW.e_mail_financ := NULL;
END IF;
IF trim(NEW.deposita_chetro)::VARCHAR = '''' THEN
   NEW.deposita_chetro := NULL;
END IF;
IF trim(NEW.ciclopre)::VARCHAR = '''' THEN
   NEW.ciclopre := NULL;
END IF;
IF trim(NEW.sac_mail_filusu)::VARCHAR = '''' THEN
   NEW.sac_mail_filusu := NULL;
END IF;
IF trim(NEW.sac_mail_codusu)::VARCHAR = '''' THEN
   NEW.sac_mail_codusu := NULL;
END IF;
IF trim(NEW.patipodesconto)::VARCHAR = '''' THEN
   NEW.patipodesconto := NULL;
END IF;
IF trim(NEW.cli_codsex)::VARCHAR = '''' THEN
   NEW.cli_codsex := NULL;
END IF;
IF trim(NEW.cli_estciv)::VARCHAR = '''' THEN
   NEW.cli_estciv := NULL;
END IF;
IF trim(NEW.cli_categ1)::VARCHAR = '''' THEN
   NEW.cli_categ1 := NULL;
END IF;
IF trim(NEW.cli_categ2)::VARCHAR = '''' THEN
   NEW.cli_categ2 := NULL;
END IF;
IF trim(NEW.cli_categ3)::VARCHAR = '''' THEN
   NEW.cli_categ3 := NULL;
END IF;
IF trim(NEW.cli_datnas)::VARCHAR = '''' THEN
   NEW.cli_datnas := NULL;
END IF;
IF trim(NEW.cli_doccon)::VARCHAR = '''' THEN
   NEW.cli_doccon := NULL;
END IF;
IF trim(NEW.cli_nascon)::VARCHAR = '''' THEN
   NEW.cli_nascon := NULL;
END IF;
IF trim(NEW.cli_conjug)::VARCHAR = '''' THEN
   NEW.cli_conjug := NULL;
END IF;
IF trim(NEW.cli_insest)::VARCHAR = '''' THEN
   NEW.cli_insest := NULL;
END IF;
IF trim(NEW.cli_numfon)::VARCHAR = '''' THEN
   NEW.cli_numfon := NULL;
END IF;
IF trim(NEW.cli_endere)::VARCHAR = '''' THEN
   NEW.cli_endere := NULL;
END IF;
IF trim(NEW.cli_codcep)::VARCHAR = '''' THEN
   NEW.cli_codcep := NULL;
END IF;
IF trim(NEW.deduztaxatitulo)::VARCHAR = '''' THEN
   NEW.deduztaxatitulo := NULL;
END IF;
IF trim(NEW.path_arquivos)::VARCHAR = '''' THEN
   NEW.path_arquivos := NULL;
END IF;
IF trim(NEW.pre_psi_utiliza)::VARCHAR = '''' THEN
   NEW.pre_psi_utiliza := NULL;
END IF;
IF trim(NEW.nf_apos_cf)::VARCHAR = '''' THEN
   NEW.nf_apos_cf := NULL;
END IF;
IF trim(NEW.credit_score)::VARCHAR = '''' THEN
   NEW.credit_score := NULL;
END IF;
IF trim(NEW.ultsac_filusu)::VARCHAR = '''' THEN
   NEW.ultsac_filusu := NULL;
END IF;
IF trim(NEW.ultsac_codusu)::VARCHAR = '''' THEN
   NEW.ultsac_codusu := NULL;
END IF;
IF trim(NEW.fatura_cc_por_filial)::VARCHAR = '''' THEN
   NEW.fatura_cc_por_filial := NULL;
END IF;
IF trim(NEW.paphoto)::VARCHAR = '''' THEN
   NEW.paphoto := NULL;
END IF;
IF trim(NEW.paphoetiqueta)::VARCHAR = '''' THEN
   NEW.paphoetiqueta := NULL;
END IF;
IF trim(NEW.paphofor1)::VARCHAR = '''' THEN
   NEW.paphofor1 := NULL;
END IF;
IF trim(NEW.paphofors)::VARCHAR = '''' THEN
   NEW.paphofors := NULL;
END IF;
IF trim(NEW.paphovar1)::VARCHAR = '''' THEN
   NEW.paphovar1 := NULL;
END IF;
IF trim(NEW.paphovar2)::VARCHAR = '''' THEN
   NEW.paphovar2 := NULL;
END IF;
IF trim(NEW.paphovar3)::VARCHAR = '''' THEN
   NEW.paphovar3 := NULL;
END IF;
IF trim(NEW.paphofilrevela)::VARCHAR = '''' THEN
   NEW.paphofilrevela := NULL;
END IF;
IF trim(NEW.paphocodrevela)::VARCHAR = '''' THEN
   NEW.paphocodrevela := NULL;
END IF;
IF trim(NEW.paphofilamplia)::VARCHAR = '''' THEN
   NEW.paphofilamplia := NULL;
END IF;
IF trim(NEW.paphocodamplia)::VARCHAR = '''' THEN
   NEW.paphocodamplia := NULL;
END IF;
IF trim(NEW.paphofilrevamp)::VARCHAR = '''' THEN
   NEW.paphofilrevamp := NULL;
END IF;
IF trim(NEW.paphocodrevamp)::VARCHAR = '''' THEN
   NEW.paphocodrevamp := NULL;
END IF;
IF trim(NEW.palistadebitos)::VARCHAR = '''' THEN
   NEW.palistadebitos := NULL;
END IF;
IF trim(NEW.papredatarconsumidor)::VARCHAR = '''' THEN
   NEW.papredatarconsumidor := NULL;
END IF;
IF trim(NEW.acao_devolucao)::VARCHAR = '''' THEN
   NEW.acao_devolucao := NULL;
END IF;
IF trim(NEW.sac_pos_venda)::VARCHAR = '''' THEN
   NEW.sac_pos_venda := NULL;
END IF;
IF trim(NEW.filprj)::VARCHAR = '''' THEN
   NEW.filprj := NULL;
END IF;
IF trim(NEW.seqprj)::VARCHAR = '''' THEN
   NEW.seqprj := NULL;
END IF;
IF trim(NEW.restricao_vinculo)::VARCHAR = '''' THEN
   NEW.restricao_vinculo := NULL;
END IF;
IF trim(NEW.une_nome_sobrenome)::VARCHAR = '''' THEN
   NEW.une_nome_sobrenome := NULL;
END IF;
IF trim(NEW.checkout_vermin)::VARCHAR = '''' THEN
   NEW.checkout_vermin := NULL;
END IF;
IF trim(NEW.recpar_devolucao)::VARCHAR = '''' THEN
   NEW.recpar_devolucao := NULL;
END IF;
IF trim(NEW.cliente_por_doc)::VARCHAR = '''' THEN
   NEW.cliente_por_doc := NULL;
END IF;
IF trim(NEW.e_mail_estoque)::VARCHAR = '''' THEN
   NEW.e_mail_estoque := NULL;
END IF;
IF trim(NEW.ckdescecf)::VARCHAR = '''' THEN
   NEW.ckdescecf := NULL;
END IF;
IF trim(NEW.cob_usa_sac)::VARCHAR = '''' THEN
   NEW.cob_usa_sac := NULL;
END IF;
IF trim(NEW.cob_forma_registro)::VARCHAR = '''' THEN
   NEW.cob_forma_registro := NULL;
END IF;
IF trim(NEW.cob_e_mail_sac)::VARCHAR = '''' THEN
   NEW.cob_e_mail_sac := NULL;
END IF;
IF trim(NEW.cob_e_mail_cartas)::VARCHAR = '''' THEN
   NEW.cob_e_mail_cartas := NULL;
END IF;
IF trim(NEW.cob_e_mail_spc)::VARCHAR = '''' THEN
   NEW.cob_e_mail_spc := NULL;
END IF;
IF trim(NEW.cob_fil_gerente)::VARCHAR = '''' THEN
   NEW.cob_fil_gerente := NULL;
END IF;
IF trim(NEW.cob_cod_gerente)::VARCHAR = '''' THEN
   NEW.cob_cod_gerente := NULL;
END IF;
IF trim(NEW.e_mail_erro)::VARCHAR = '''' THEN
   NEW.e_mail_erro := NULL;
END IF;
IF trim(NEW.tamanho_observacao)::VARCHAR = '''' THEN
   NEW.tamanho_observacao := NULL;
END IF;
IF trim(NEW.cancela_reserva)::VARCHAR = '''' THEN
   NEW.cancela_reserva := NULL;
END IF;
IF trim(NEW.usa_renegociacao_sac)::VARCHAR = '''' THEN
   NEW.usa_renegociacao_sac := NULL;
END IF;
IF trim(NEW.cli_call_c)::VARCHAR = '''' THEN
   NEW.cli_call_c := NULL;
END IF;
IF trim(NEW.compensacao_automatica)::VARCHAR = '''' THEN
   NEW.compensacao_automatica := NULL;
END IF;
IF trim(NEW.valortransferencia)::VARCHAR = '''' THEN
   NEW.valortransferencia := NULL;
END IF;
IF trim(NEW.ckpamfl1)::VARCHAR = '''' THEN
   NEW.ckpamfl1 := NULL;
END IF;
IF trim(NEW.ckpamfl2)::VARCHAR = '''' THEN
   NEW.ckpamfl2 := NULL;
END IF;
IF trim(NEW.ckpamfl3)::VARCHAR = '''' THEN
   NEW.ckpamfl3 := NULL;
END IF;
IF trim(NEW.ckpamfl4)::VARCHAR = '''' THEN
   NEW.ckpamfl4 := NULL;
END IF;
IF trim(NEW.exporta_todos_clientes)::VARCHAR = '''' THEN
   NEW.exporta_todos_clientes := NULL;
END IF;
IF trim(NEW.pda_path_importacao)::VARCHAR = '''' THEN
   NEW.pda_path_importacao := NULL;
END IF;
IF trim(NEW.pda_path_exportacao)::VARCHAR = '''' THEN
   NEW.pda_path_exportacao := NULL;
END IF;
IF trim(NEW.pda_integracao)::VARCHAR = '''' THEN
   NEW.pda_integracao := NULL;
END IF;
IF trim(NEW.pda_filpre)::VARCHAR = '''' THEN
   NEW.pda_filpre := NULL;
END IF;
IF trim(NEW.usa_placa_orcamento)::VARCHAR = '''' THEN
   NEW.usa_placa_orcamento := NULL;
END IF;
IF trim(NEW.vinculo_placa_orcamento)::VARCHAR = '''' THEN
   NEW.vinculo_placa_orcamento := NULL;
END IF;
IF trim(NEW.transfer_ser)::VARCHAR = '''' THEN
   NEW.transfer_ser := NULL;
END IF;
IF trim(NEW.base_markup)::VARCHAR = '''' THEN
   NEW.base_markup := NULL;
END IF;
IF trim(NEW.pda_grupo)::VARCHAR = '''' THEN
   NEW.pda_grupo := NULL;
END IF;
IF trim(NEW.pda_subgrupo)::VARCHAR = '''' THEN
   NEW.pda_subgrupo := NULL;
END IF;
IF trim(NEW.abater_desconto_nf)::VARCHAR = '''' THEN
   NEW.abater_desconto_nf := NULL;
END IF;
IF trim(NEW.cli_nomcid)::VARCHAR = '''' THEN
   NEW.cli_nomcid := NULL;
END IF;
IF trim(NEW.cli_bairro)::VARCHAR = '''' THEN
   NEW.cli_bairro := NULL;
END IF;
IF trim(NEW.cli_regiao)::VARCHAR = '''' THEN
   NEW.cli_regiao := NULL;
END IF;
IF trim(NEW.sac_exige_codfun)::VARCHAR = '''' THEN
   NEW.sac_exige_codfun := NULL;
END IF;
IF trim(NEW.sac_exige_codcws)::VARCHAR = '''' THEN
   NEW.sac_exige_codcws := NULL;
END IF;
IF trim(NEW.filsrv)::VARCHAR = '''' THEN
   NEW.filsrv := NULL;
END IF;
IF trim(NEW.codsrv)::VARCHAR = '''' THEN
   NEW.codsrv := NULL;
END IF;
IF trim(NEW.usa_perc_horfal)::VARCHAR = '''' THEN
   NEW.usa_perc_horfal := NULL;
END IF;
IF trim(NEW.solicita_end_cf)::VARCHAR = '''' THEN
   NEW.solicita_end_cf := NULL;
END IF;
IF trim(NEW.pda_ultexp_parcial)::VARCHAR = '''' THEN
   NEW.pda_ultexp_parcial := NULL;
END IF;
IF trim(NEW.tipo_ctr_venda)::VARCHAR = '''' THEN
   NEW.tipo_ctr_venda := NULL;
END IF;
IF trim(NEW.sugere_servicos)::VARCHAR = '''' THEN
   NEW.sugere_servicos := NULL;
END IF;
IF trim(NEW.dados_path_exporta)::VARCHAR = '''' THEN
   NEW.dados_path_exporta := NULL;
END IF;
IF trim(NEW.dados_path_importa)::VARCHAR = '''' THEN
   NEW.dados_path_importa := NULL;
END IF;
IF trim(NEW.gera_codext_integracao)::VARCHAR = '''' THEN
   NEW.gera_codext_integracao := NULL;
END IF;
IF trim(NEW.cktxtpromissoria)::VARCHAR = '''' THEN
   NEW.cktxtpromissoria := NULL;
END IF;
IF trim(NEW.parc_cartao)::VARCHAR = '''' THEN
   NEW.parc_cartao := NULL;
END IF;
IF trim(NEW.parc_cliente_transp)::VARCHAR = '''' THEN
   NEW.parc_cliente_transp := NULL;
END IF;
IF trim(NEW.parc_fornecedor)::VARCHAR = '''' THEN
   NEW.parc_fornecedor := NULL;
END IF;
IF trim(NEW.parc_indica_venda)::VARCHAR = '''' THEN
   NEW.parc_indica_venda := NULL;
END IF;
IF trim(NEW.parc_marca)::VARCHAR = '''' THEN
   NEW.parc_marca := NULL;
END IF;
IF trim(NEW.parc_motorista)::VARCHAR = '''' THEN
   NEW.parc_motorista := NULL;
END IF;
IF trim(NEW.parc_representante)::VARCHAR = '''' THEN
   NEW.parc_representante := NULL;
END IF;
IF trim(NEW.parc_tec_interno)::VARCHAR = '''' THEN
   NEW.parc_tec_interno := NULL;
END IF;
IF trim(NEW.parc_transportador)::VARCHAR = '''' THEN
   NEW.parc_transportador := NULL;
END IF;
IF trim(NEW.parc_tecnico_externo)::VARCHAR = '''' THEN
   NEW.parc_tecnico_externo := NULL;
END IF;
IF trim(NEW.parc_usuario)::VARCHAR = '''' THEN
   NEW.parc_usuario := NULL;
END IF;
IF trim(NEW.exp_rec_data_venda)::VARCHAR = '''' THEN
   NEW.exp_rec_data_venda := NULL;
END IF;
IF trim(NEW.limcredito_somalim)::VARCHAR = '''' THEN
   NEW.limcredito_somalim := NULL;
END IF;
IF trim(NEW.enviadatfaturamento)::VARCHAR = '''' THEN
   NEW.enviadatfaturamento := NULL;
END IF;
IF trim(NEW.ckfordes)::VARCHAR = '''' THEN
   NEW.ckfordes := NULL;
END IF;
IF trim(NEW.placaabertura)::VARCHAR = '''' THEN
   NEW.placaabertura := NULL;
END IF;
IF trim(NEW.imp_cf_nf)::VARCHAR = '''' THEN
   NEW.imp_cf_nf := NULL;
END IF;
IF trim(NEW.filprj_pxd)::VARCHAR = '''' THEN
   NEW.filprj_pxd := NULL;
END IF;
IF trim(NEW.seqprj_pxd)::VARCHAR = '''' THEN
   NEW.seqprj_pxd := NULL;
END IF;
IF trim(NEW.custo_por_filial)::VARCHAR = '''' THEN
   NEW.custo_por_filial := NULL;
END IF;
IF trim(NEW.impede_orc_maior_limite)::VARCHAR = '''' THEN
   NEW.impede_orc_maior_limite := NULL;
END IF;
IF trim(NEW.sac_exige_modulo)::VARCHAR = '''' THEN
   NEW.sac_exige_modulo := NULL;
END IF;
IF trim(NEW.ckpapesqident)::VARCHAR = '''' THEN
   NEW.ckpapesqident := NULL;
END IF;
IF trim(NEW.ckparecfilial)::VARCHAR = '''' THEN
   NEW.ckparecfilial := NULL;
END IF;
IF trim(NEW.agrupa_lctos_te_ccc)::VARCHAR = '''' THEN
   NEW.agrupa_lctos_te_ccc := NULL;
END IF;
IF trim(NEW.sup_aprova_restricao)::VARCHAR = '''' THEN
   NEW.sup_aprova_restricao := NULL;
END IF;
IF trim(NEW.cksangrianegativa)::VARCHAR = '''' THEN
   NEW.cksangrianegativa := NULL;
END IF;
IF trim(NEW.tipcta_ecf)::VARCHAR = '''' THEN
   NEW.tipcta_ecf := NULL;
END IF;
IF trim(NEW.cktrocachradepositar)::VARCHAR = '''' THEN
   NEW.cktrocachradepositar := NULL;
END IF;
IF trim(NEW.obrig_icms_ped)::VARCHAR = '''' THEN
   NEW.obrig_icms_ped := NULL;
END IF;
IF trim(NEW.spc_parcela)::VARCHAR = '''' THEN
   NEW.spc_parcela := NULL;
END IF;
IF trim(NEW.chrdev_cria_subpar)::VARCHAR = '''' THEN
   NEW.chrdev_cria_subpar := NULL;
END IF;
IF trim(NEW.cli_contat)::VARCHAR = '''' THEN
   NEW.cli_contat := NULL;
END IF;
IF trim(NEW.avisa_estoque_neg)::VARCHAR = '''' THEN
   NEW.avisa_estoque_neg := NULL;
END IF;
IF trim(NEW.sac_tipreg)::VARCHAR = '''' THEN
   NEW.sac_tipreg := NULL;
END IF;
IF trim(NEW.impede_alteracao_pedido)::VARCHAR = '''' THEN
   NEW.impede_alteracao_pedido := NULL;
END IF;
IF trim(NEW.fil_genesio)::VARCHAR = '''' THEN
   NEW.fil_genesio := NULL;
END IF;
IF trim(NEW.cod_genesio)::VARCHAR = '''' THEN
   NEW.cod_genesio := NULL;
END IF;
IF trim(NEW.fil_profarma)::VARCHAR = '''' THEN
   NEW.fil_profarma := NULL;
END IF;
IF trim(NEW.cod_profarma)::VARCHAR = '''' THEN
   NEW.cod_profarma := NULL;
END IF;
IF trim(NEW.fil_especial)::VARCHAR = '''' THEN
   NEW.fil_especial := NULL;
END IF;
IF trim(NEW.cod_especial)::VARCHAR = '''' THEN
   NEW.cod_especial := NULL;
END IF;
IF trim(NEW.pro_codlpc)::VARCHAR = '''' THEN
   NEW.pro_codlpc := NULL;
END IF;
IF trim(NEW.pro_contro)::VARCHAR = '''' THEN
   NEW.pro_contro := NULL;
END IF;
IF trim(NEW.fil_panarello)::VARCHAR = '''' THEN
   NEW.fil_panarello := NULL;
END IF;
IF trim(NEW.cod_panarello)::VARCHAR = '''' THEN
   NEW.cod_panarello := NULL;
END IF;
IF trim(NEW.fil_dimed)::VARCHAR = '''' THEN
   NEW.fil_dimed := NULL;
END IF;
IF trim(NEW.cod_dimed)::VARCHAR = '''' THEN
   NEW.cod_dimed := NULL;
END IF;
IF trim(NEW.nome_classificacao)::VARCHAR = '''' THEN
   NEW.nome_classificacao := NULL;
END IF;
IF trim(NEW.fil_dimper)::VARCHAR = '''' THEN
   NEW.fil_dimper := NULL;
END IF;
IF trim(NEW.cod_dimper)::VARCHAR = '''' THEN
   NEW.cod_dimper := NULL;
END IF;
IF trim(NEW.fil_santacruz)::VARCHAR = '''' THEN
   NEW.fil_santacruz := NULL;
END IF;
IF trim(NEW.cod_santacruz)::VARCHAR = '''' THEN
   NEW.cod_santacruz := NULL;
END IF;
IF trim(NEW.ck_fecha_valor_contado)::VARCHAR = '''' THEN
   NEW.ck_fecha_valor_contado := NULL;
END IF;
IF trim(NEW.penaut)::VARCHAR = '''' THEN
   NEW.penaut := NULL;
END IF;
IF trim(NEW.filcmp)::VARCHAR = '''' THEN
   NEW.filcmp := NULL;
END IF;
IF trim(NEW.atuped)::VARCHAR = '''' THEN
   NEW.atuped := NULL;
END IF;
IF trim(NEW.bonus_online)::VARCHAR = '''' THEN
   NEW.bonus_online := NULL;
END IF;
IF trim(NEW.valida_estoque_order)::VARCHAR = '''' THEN
   NEW.valida_estoque_order := NULL;
END IF;
IF trim(NEW.mostra_repasse)::VARCHAR = '''' THEN
   NEW.mostra_repasse := NULL;
END IF;
IF trim(NEW.logoboleto)::VARCHAR = '''' THEN
   NEW.logoboleto := NULL;
END IF;
IF trim(NEW.areceber_passa_ecf)::VARCHAR = '''' THEN
   NEW.areceber_passa_ecf := NULL;
END IF;
IF trim(NEW.reutiliza_referencia)::VARCHAR = '''' THEN
   NEW.reutiliza_referencia := NULL;
END IF;
IF trim(NEW.enviar_entrega)::VARCHAR = '''' THEN
   NEW.enviar_entrega := NULL;
END IF;
IF trim(NEW.cfop_com_ecf)::VARCHAR = '''' THEN
   NEW.cfop_com_ecf := NULL;
END IF;
IF trim(NEW.sql_cusrep)::VARCHAR = '''' THEN
   NEW.sql_cusrep := NULL;
END IF;
IF trim(NEW.custo_lucro_markup)::VARCHAR = '''' THEN
   NEW.custo_lucro_markup := NULL;
END IF;
IF trim(NEW.obriga_codean)::VARCHAR = '''' THEN
   NEW.obriga_codean := NULL;
END IF;
IF trim(NEW.troco_tef)::VARCHAR = '''' THEN
   NEW.troco_tef := NULL;
END IF;
IF trim(NEW.venda_cc_e_outros)::VARCHAR = '''' THEN
   NEW.venda_cc_e_outros := NULL;
END IF;
IF trim(NEW.loja_fechada)::VARCHAR = '''' THEN
   NEW.loja_fechada := NULL;
END IF;
IF trim(NEW.usa_preatendimento)::VARCHAR = '''' THEN
   NEW.usa_preatendimento := NULL;
END IF;
IF trim(NEW.altera_preco_orc_separado)::VARCHAR = '''' THEN
   NEW.altera_preco_orc_separado := NULL;
END IF;
IF trim(NEW.reserva_venda)::VARCHAR = '''' THEN
   NEW.reserva_venda := NULL;
END IF;
IF trim(NEW.filpgt_wor_prop)::VARCHAR = '''' THEN
   NEW.filpgt_wor_prop := NULL;
END IF;
IF trim(NEW.codpgt_wor_prop)::VARCHAR = '''' THEN
   NEW.codpgt_wor_prop := NULL;
END IF;
IF trim(NEW.filpap_diretoria)::VARCHAR = '''' THEN
   NEW.filpap_diretoria := NULL;
END IF;
IF trim(NEW.seqpap_diretoria)::VARCHAR = '''' THEN
   NEW.seqpap_diretoria := NULL;
END IF;
IF trim(NEW.plano_pgt_wor_prop)::VARCHAR = '''' THEN
   NEW.plano_pgt_wor_prop := NULL;
END IF;
IF trim(NEW.despap_diretoria)::VARCHAR = '''' THEN
   NEW.despap_diretoria := NULL;
END IF;
IF trim(NEW.mult_vendedores)::VARCHAR = '''' THEN
   NEW.mult_vendedores := NULL;
END IF;
IF trim(NEW.ckbloqrefbas)::VARCHAR = '''' THEN
   NEW.ckbloqrefbas := NULL;
END IF;
IF trim(NEW.pafecf_nrolau)::VARCHAR = '''' THEN
   NEW.pafecf_nrolau := NULL;
END IF;
IF trim(NEW.pafecf_nomcom)::VARCHAR = '''' THEN
   NEW.pafecf_nomcom := NULL;
END IF;
IF trim(NEW.pafecf_priarq)::VARCHAR = '''' THEN
   NEW.pafecf_priarq := NULL;
END IF;
IF trim(NEW.pafecf_priarq_md5)::VARCHAR = '''' THEN
   NEW.pafecf_priarq_md5 := NULL;
END IF;
IF trim(NEW.pafecf_outarq)::VARCHAR = '''' THEN
   NEW.pafecf_outarq := NULL;
END IF;
IF trim(NEW.pafecf_assina)::VARCHAR = '''' THEN
   NEW.pafecf_assina := NULL;
END IF;
IF trim(NEW.rateio_frete)::VARCHAR = '''' THEN
   NEW.rateio_frete := NULL;
END IF;
IF trim(NEW.path_base)::VARCHAR = '''' THEN
   NEW.path_base := NULL;
END IF;
IF trim(NEW.usa_vm_decisor)::VARCHAR = '''' THEN
   NEW.usa_vm_decisor := NULL;
END IF;
IF trim(NEW.romaneio_filial)::VARCHAR = '''' THEN
   NEW.romaneio_filial := NULL;
END IF;
IF trim(NEW.reserva_ent_fut)::VARCHAR = '''' THEN
   NEW.reserva_ent_fut := NULL;
END IF;
IF trim(NEW.valida_parc_ck)::VARCHAR = '''' THEN
   NEW.valida_parc_ck := NULL;
END IF;
IF trim(NEW.gx_simpan_fil)::VARCHAR = '''' THEN
   NEW.gx_simpan_fil := NULL;
END IF;
IF trim(NEW.path_ttsegur)::VARCHAR = '''' THEN
   NEW.path_ttsegur := NULL;
END IF;
IF trim(NEW.pafecf_cgctot)::VARCHAR = '''' THEN
   NEW.pafecf_cgctot := NULL;
END IF;
IF trim(NEW.pafecf_nompaf)::VARCHAR = '''' THEN
   NEW.pafecf_nompaf := NULL;
END IF;
IF trim(NEW.ckpanumext_nao_dav)::VARCHAR = '''' THEN
   NEW.ckpanumext_nao_dav := NULL;
END IF;
IF trim(NEW.ckpanumext_dep)::VARCHAR = '''' THEN
   NEW.ckpanumext_dep := NULL;
END IF;
IF trim(NEW.bru_aprovada)::VARCHAR = '''' THEN
   NEW.bru_aprovada := NULL;
END IF;
IF trim(NEW.entrega_cf)::VARCHAR = '''' THEN
   NEW.entrega_cf := NULL;
END IF;
IF trim(NEW.dest_st_dev)::VARCHAR = '''' THEN
   NEW.dest_st_dev := NULL;
END IF;
IF trim(NEW.dser_nfcompl)::VARCHAR = '''' THEN
   NEW.dser_nfcompl := NULL;
END IF;
IF trim(NEW.percom_fpv)::VARCHAR = '''' THEN
   NEW.percom_fpv := NULL;
END IF;
IF trim(NEW.blq_sem_uid)::VARCHAR = '''' THEN
   NEW.blq_sem_uid := NULL;
END IF;
IF trim(NEW.st_no_frete)::VARCHAR = '''' THEN
   NEW.st_no_frete := NULL;
END IF;
IF trim(NEW.totallecbase)::VARCHAR = '''' THEN
   NEW.totallecbase := NULL;
END IF;
IF trim(NEW.totallechost)::VARCHAR = '''' THEN
   NEW.totallechost := NULL;
END IF;
IF trim(NEW.totallecport)::VARCHAR = '''' THEN
   NEW.totallecport := NULL;
END IF;
IF trim(NEW.substt_consfi)::VARCHAR = '''' THEN
   NEW.substt_consfi := NULL;
END IF;
IF trim(NEW.boleto_email)::VARCHAR = '''' THEN
   NEW.boleto_email := NULL;
END IF;
IF trim(NEW.ckpacanhotonfe)::VARCHAR = '''' THEN
   NEW.ckpacanhotonfe := NULL;
END IF;
IF trim(NEW.filpre_atc)::VARCHAR = '''' THEN
   NEW.filpre_atc := NULL;
END IF;
IF trim(NEW.ckgradepesavel)::VARCHAR = '''' THEN
   NEW.ckgradepesavel := NULL;
END IF;
IF trim(NEW.dev_fatvin)::VARCHAR = '''' THEN
   NEW.dev_fatvin := NULL;
END IF;
IF trim(NEW.usa_cta_transito_transf_ident)::VARCHAR = '''' THEN
   NEW.usa_cta_transito_transf_ident := NULL;
END IF;
IF trim(NEW.venda_estrangeiro)::VARCHAR = '''' THEN
   NEW.venda_estrangeiro := NULL;
END IF;
IF trim(NEW.ckpavalabe)::VARCHAR = '''' THEN
   NEW.ckpavalabe := NULL;
END IF;
IF trim(NEW.baiped)::VARCHAR = '''' THEN
   NEW.baiped := NULL;
END IF;
IF trim(NEW.ckpafildav)::VARCHAR = '''' THEN
   NEW.ckpafildav := NULL;
END IF;
IF trim(NEW.separar_entrega)::VARCHAR = '''' THEN
   NEW.separar_entrega := NULL;
END IF;
IF trim(NEW.giro_estoque)::VARCHAR = '''' THEN
   NEW.giro_estoque := NULL;
END IF;
IF trim(NEW.filtra_fornec_pedido)::VARCHAR = '''' THEN
   NEW.filtra_fornec_pedido := NULL;
END IF;
IF trim(NEW.ckpaconfere_dav)::VARCHAR = '''' THEN
   NEW.ckpaconfere_dav := NULL;
END IF;
IF trim(NEW.ckpaaut_dev_frete)::VARCHAR = '''' THEN
   NEW.ckpaaut_dev_frete := NULL;
END IF;
IF trim(NEW.transpicm)::VARCHAR = '''' THEN
   NEW.transpicm := NULL;
END IF;
IF trim(NEW.arredondam)::VARCHAR = '''' THEN
   NEW.arredondam := NULL;
END IF;
IF trim(NEW.filpre_rev)::VARCHAR = '''' THEN
   NEW.filpre_rev := NULL;
END IF;
IF trim(NEW.filcob)::VARCHAR = '''' THEN
   NEW.filcob := NULL;
END IF;
IF trim(NEW.filent)::VARCHAR = '''' THEN
   NEW.filent := NULL;
END IF;
IF trim(NEW.fil_basf)::VARCHAR = '''' THEN
   NEW.fil_basf := NULL;
END IF;
IF trim(NEW.cod_basf)::VARCHAR = '''' THEN
   NEW.cod_basf := NULL;
END IF;
IF trim(NEW.cfcontripj)::VARCHAR = '''' THEN
   NEW.cfcontripj := NULL;
END IF;
IF trim(NEW.filmat_tin)::VARCHAR = '''' THEN
   NEW.filmat_tin := NULL;
END IF;
IF trim(NEW.codmat_tin)::VARCHAR = '''' THEN
   NEW.codmat_tin := NULL;
END IF;
IF trim(NEW.lim_tiptol)::VARCHAR = '''' THEN
   NEW.lim_tiptol := NULL;
END IF;
IF trim(NEW.vdd_ckpavenite)::VARCHAR = '''' THEN
   NEW.vdd_ckpavenite := NULL;
END IF;
IF trim(NEW.vdd_ckpatotven)::VARCHAR = '''' THEN
   NEW.vdd_ckpatotven := NULL;
END IF;
IF trim(NEW.ind_ckpavenite)::VARCHAR = '''' THEN
   NEW.ind_ckpavenite := NULL;
END IF;
IF trim(NEW.ind_ckpatotven)::VARCHAR = '''' THEN
   NEW.ind_ckpatotven := NULL;
END IF;
IF trim(NEW.usa_dcai_0)::VARCHAR = '''' THEN
   NEW.usa_dcai_0 := NULL;
END IF;
IF trim(NEW.valor_aquisicao)::VARCHAR = '''' THEN
   NEW.valor_aquisicao := NULL;
END IF;
IF trim(NEW.blq_cf_retira_deposito)::VARCHAR = '''' THEN
   NEW.blq_cf_retira_deposito := NULL;
END IF;
IF trim(NEW.fpv_preco_simulado)::VARCHAR = '''' THEN
   NEW.fpv_preco_simulado := NULL;
END IF;
IF trim(NEW.clirevsemie)::VARCHAR = '''' THEN
   NEW.clirevsemie := NULL;
END IF;
IF trim(NEW.tipdia_fluxo)::VARCHAR = '''' THEN
   NEW.tipdia_fluxo := NULL;
END IF;
IF trim(NEW.prazo_ent_pedido)::VARCHAR = '''' THEN
   NEW.prazo_ent_pedido := NULL;
END IF;
IF trim(NEW.parc_pedido)::VARCHAR = '''' THEN
   NEW.parc_pedido := NULL;
END IF;
IF trim(NEW.tipdia_elasticidade)::VARCHAR = '''' THEN
   NEW.tipdia_elasticidade := NULL;
END IF;
IF trim(NEW.devcompranfeimposto)::VARCHAR = '''' THEN
   NEW.devcompranfeimposto := NULL;
END IF;
IF trim(NEW.regra_media_vendas)::VARCHAR = '''' THEN
   NEW.regra_media_vendas := NULL;
END IF;
IF trim(NEW.tipdia_vdu_pp)::VARCHAR = '''' THEN
   NEW.tipdia_vdu_pp := NULL;
END IF;
IF trim(NEW.filmat_aux)::VARCHAR = '''' THEN
   NEW.filmat_aux := NULL;
END IF;
IF trim(NEW.codmat_aux)::VARCHAR = '''' THEN
   NEW.codmat_aux := NULL;
END IF;
IF trim(NEW.ck4g_detver_homol)::VARCHAR = '''' THEN
   NEW.ck4g_detver_homol := NULL;
END IF;
IF trim(NEW.ck4g_detver_produ)::VARCHAR = '''' THEN
   NEW.ck4g_detver_produ := NULL;
END IF;
IF trim(NEW.ck4g_regra_atualizacao)::VARCHAR = '''' THEN
   NEW.ck4g_regra_atualizacao := NULL;
END IF;
IF trim(NEW.sep_fat_retira_deposito)::VARCHAR = '''' THEN
   NEW.sep_fat_retira_deposito := NULL;
END IF;
IF trim(NEW.sepmaior)::VARCHAR = '''' THEN
   NEW.sepmaior := NULL;
END IF;
IF trim(NEW.filmat_rat)::VARCHAR = '''' THEN
   NEW.filmat_rat := NULL;
END IF;
IF trim(NEW.codmat_rat)::VARCHAR = '''' THEN
   NEW.codmat_rat := NULL;
END IF;
IF trim(NEW.prezer)::VARCHAR = '''' THEN
   NEW.prezer := NULL;
END IF;
IF trim(NEW.devfil)::VARCHAR = '''' THEN
   NEW.devfil := NULL;
END IF;
IF trim(NEW.impprevent)::VARCHAR = '''' THEN
   NEW.impprevent := NULL;
END IF;
IF trim(NEW.sersat)::VARCHAR = '''' THEN
   NEW.sersat := NULL;
END IF;
IF trim(NEW.st_pripar)::VARCHAR = '''' THEN
   NEW.st_pripar := NULL;
END IF;
IF trim(NEW.recebe_cc_individual)::VARCHAR = '''' THEN
   NEW.recebe_cc_individual := NULL;
END IF;
IF trim(NEW.dest_st_inffisco)::VARCHAR = '''' THEN
   NEW.dest_st_inffisco := NULL;
END IF;
IF trim(NEW.obrpeso)::VARCHAR = '''' THEN
   NEW.obrpeso := NULL;
END IF;
IF trim(NEW.obrvol)::VARCHAR = '''' THEN
   NEW.obrvol := NULL;
END IF;
IF trim(NEW.filteq)::VARCHAR = '''' THEN
   NEW.filteq := NULL;
END IF;
IF trim(NEW.seqteq)::VARCHAR = '''' THEN
   NEW.seqteq := NULL;
END IF;
IF trim(NEW.dispor)::VARCHAR = '''' THEN
   NEW.dispor := NULL;
END IF;
IF trim(NEW.varcus)::VARCHAR = '''' THEN
   NEW.varcus := NULL;
END IF;
IF trim(NEW.oricre)::VARCHAR = '''' THEN
   NEW.oricre := NULL;
END IF;
IF trim(NEW.descpmord)::VARCHAR = '''' THEN
   NEW.descpmord := NULL;
END IF;
IF trim(NEW.filmat_tra)::VARCHAR = '''' THEN
   NEW.filmat_tra := NULL;
END IF;
IF trim(NEW.codmat_tra)::VARCHAR = '''' THEN
   NEW.codmat_tra := NULL;
END IF;
IF trim(NEW.transfer_sercol)::VARCHAR = '''' THEN
   NEW.transfer_sercol := NULL;
END IF;
IF trim(NEW.ent_filcli)::VARCHAR = '''' THEN
   NEW.ent_filcli := NULL;
END IF;
IF trim(NEW.ent_codcli)::VARCHAR = '''' THEN
   NEW.ent_codcli := NULL;
END IF;
IF trim(NEW.agrupador_itens_distr_est)::VARCHAR = '''' THEN
   NEW.agrupador_itens_distr_est := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cfg
BEFORE INSERT OR UPDATE ON tt_cfg
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cfg();



/*-- SEQ 6144 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cfg2() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.sac_home_page)::VARCHAR = '''' THEN
   NEW.sac_home_page := NULL;
END IF;
IF trim(NEW.vende_desativados)::VARCHAR = '''' THEN
   NEW.vende_desativados := NULL;
END IF;
IF trim(NEW.popula_tp_cli)::VARCHAR = '''' THEN
   NEW.popula_tp_cli := NULL;
END IF;
IF trim(NEW.ckbemvindo)::VARCHAR = '''' THEN
   NEW.ckbemvindo := NULL;
END IF;
IF trim(NEW.cknomatend)::VARCHAR = '''' THEN
   NEW.cknomatend := NULL;
END IF;
IF trim(NEW.ckvlrinfun)::VARCHAR = '''' THEN
   NEW.ckvlrinfun := NULL;
END IF;
IF trim(NEW.ckusabalan)::VARCHAR = '''' THEN
   NEW.ckusabalan := NULL;
END IF;
IF trim(NEW.cknumextdp)::VARCHAR = '''' THEN
   NEW.cknumextdp := NULL;
END IF;
IF trim(NEW.ckpanumext)::VARCHAR = '''' THEN
   NEW.ckpanumext := NULL;
END IF;
IF trim(NEW.ckpaobrven)::VARCHAR = '''' THEN
   NEW.ckpaobrven := NULL;
END IF;
IF trim(NEW.ckpaagrupa)::VARCHAR = '''' THEN
   NEW.ckpaagrupa := NULL;
END IF;
IF trim(NEW.ckpaconsfi)::VARCHAR = '''' THEN
   NEW.ckpaconsfi := NULL;
END IF;
IF trim(NEW.ckusadebap)::VARCHAR = '''' THEN
   NEW.ckusadebap := NULL;
END IF;
IF trim(NEW.ckpapagirr)::VARCHAR = '''' THEN
   NEW.ckpapagirr := NULL;
END IF;
IF trim(NEW.ckpanomina)::VARCHAR = '''' THEN
   NEW.ckpanomina := NULL;
END IF;
IF trim(NEW.ckpacidche)::VARCHAR = '''' THEN
   NEW.ckpacidche := NULL;
END IF;
IF trim(NEW.ckpasaiche)::VARCHAR = '''' THEN
   NEW.ckpasaiche := NULL;
END IF;
IF trim(NEW.ckpamfimpp)::VARCHAR = '''' THEN
   NEW.ckpamfimpp := NULL;
END IF;
IF trim(NEW.ckpadigche)::VARCHAR = '''' THEN
   NEW.ckpadigche := NULL;
END IF;
IF trim(NEW.ckpapredoc)::VARCHAR = '''' THEN
   NEW.ckpapredoc := NULL;
END IF;
IF trim(NEW.ckpavlrapr)::VARCHAR = '''' THEN
   NEW.ckpavlrapr := NULL;
END IF;
IF trim(NEW.ckpaobrcar)::VARCHAR = '''' THEN
   NEW.ckpaobrcar := NULL;
END IF;
IF trim(NEW.ckpasaicai)::VARCHAR = '''' THEN
   NEW.ckpasaicai := NULL;
END IF;
IF trim(NEW.ckpaunicai)::VARCHAR = '''' THEN
   NEW.ckpaunicai := NULL;
END IF;
IF trim(NEW.ckpatxtpre)::VARCHAR = '''' THEN
   NEW.ckpatxtpre := NULL;
END IF;
IF trim(NEW.ckpavenite)::VARCHAR = '''' THEN
   NEW.ckpavenite := NULL;
END IF;
IF trim(NEW.ckpatotven)::VARCHAR = '''' THEN
   NEW.ckpatotven := NULL;
END IF;
IF trim(NEW.ckpadescit)::VARCHAR = '''' THEN
   NEW.ckpadescit := NULL;
END IF;
IF trim(NEW.ckpadescto)::VARCHAR = '''' THEN
   NEW.ckpadescto := NULL;
END IF;
IF trim(NEW.ckftxtsub1)::VARCHAR = '''' THEN
   NEW.ckftxtsub1 := NULL;
END IF;
IF trim(NEW.ckftxtsub2)::VARCHAR = '''' THEN
   NEW.ckftxtsub2 := NULL;
END IF;
IF trim(NEW.ckftxtsub3)::VARCHAR = '''' THEN
   NEW.ckftxtsub3 := NULL;
END IF;
IF trim(NEW.ckftxtsub4)::VARCHAR = '''' THEN
   NEW.ckftxtsub4 := NULL;
END IF;
IF trim(NEW.ckforcomit)::VARCHAR = '''' THEN
   NEW.ckforcomit := NULL;
END IF;
IF trim(NEW.ckforcomv1)::VARCHAR = '''' THEN
   NEW.ckforcomv1 := NULL;
END IF;
IF trim(NEW.ckforcomv2)::VARCHAR = '''' THEN
   NEW.ckforcomv2 := NULL;
END IF;
IF trim(NEW.ckforcoms1)::VARCHAR = '''' THEN
   NEW.ckforcoms1 := NULL;
END IF;
IF trim(NEW.ckforcoms2)::VARCHAR = '''' THEN
   NEW.ckforcoms2 := NULL;
END IF;
IF trim(NEW.ckforcoms3)::VARCHAR = '''' THEN
   NEW.ckforcoms3 := NULL;
END IF;
IF trim(NEW.ckforcoms4)::VARCHAR = '''' THEN
   NEW.ckforcoms4 := NULL;
END IF;
IF trim(NEW.ckpacoml1)::VARCHAR = '''' THEN
   NEW.ckpacoml1 := NULL;
END IF;
IF trim(NEW.ckpacoml2)::VARCHAR = '''' THEN
   NEW.ckpacoml2 := NULL;
END IF;
IF trim(NEW.ckpacoml3)::VARCHAR = '''' THEN
   NEW.ckpacoml3 := NULL;
END IF;
IF trim(NEW.ckpacoml4)::VARCHAR = '''' THEN
   NEW.ckpacoml4 := NULL;
END IF;
IF trim(NEW.e_mail_financ)::VARCHAR = '''' THEN
   NEW.e_mail_financ := NULL;
END IF;
IF trim(NEW.deposita_chetro)::VARCHAR = '''' THEN
   NEW.deposita_chetro := NULL;
END IF;
IF trim(NEW.ciclopre)::VARCHAR = '''' THEN
   NEW.ciclopre := NULL;
END IF;
IF trim(NEW.sac_mail_filusu)::VARCHAR = '''' THEN
   NEW.sac_mail_filusu := NULL;
END IF;
IF trim(NEW.sac_mail_codusu)::VARCHAR = '''' THEN
   NEW.sac_mail_codusu := NULL;
END IF;
IF trim(NEW.patipodesconto)::VARCHAR = '''' THEN
   NEW.patipodesconto := NULL;
END IF;
IF trim(NEW.cli_codsex)::VARCHAR = '''' THEN
   NEW.cli_codsex := NULL;
END IF;
IF trim(NEW.cli_estciv)::VARCHAR = '''' THEN
   NEW.cli_estciv := NULL;
END IF;
IF trim(NEW.cli_categ1)::VARCHAR = '''' THEN
   NEW.cli_categ1 := NULL;
END IF;
IF trim(NEW.cli_categ2)::VARCHAR = '''' THEN
   NEW.cli_categ2 := NULL;
END IF;
IF trim(NEW.cli_categ3)::VARCHAR = '''' THEN
   NEW.cli_categ3 := NULL;
END IF;
IF trim(NEW.cli_datnas)::VARCHAR = '''' THEN
   NEW.cli_datnas := NULL;
END IF;
IF trim(NEW.cli_doccon)::VARCHAR = '''' THEN
   NEW.cli_doccon := NULL;
END IF;
IF trim(NEW.cli_nascon)::VARCHAR = '''' THEN
   NEW.cli_nascon := NULL;
END IF;
IF trim(NEW.cli_conjug)::VARCHAR = '''' THEN
   NEW.cli_conjug := NULL;
END IF;
IF trim(NEW.cli_insest)::VARCHAR = '''' THEN
   NEW.cli_insest := NULL;
END IF;
IF trim(NEW.cli_numfon)::VARCHAR = '''' THEN
   NEW.cli_numfon := NULL;
END IF;
IF trim(NEW.cli_endere)::VARCHAR = '''' THEN
   NEW.cli_endere := NULL;
END IF;
IF trim(NEW.cli_codcep)::VARCHAR = '''' THEN
   NEW.cli_codcep := NULL;
END IF;
IF trim(NEW.deduztaxatitulo)::VARCHAR = '''' THEN
   NEW.deduztaxatitulo := NULL;
END IF;
IF trim(NEW.pre_psi_utiliza)::VARCHAR = '''' THEN
   NEW.pre_psi_utiliza := NULL;
END IF;
IF trim(NEW.nf_apos_cf)::VARCHAR = '''' THEN
   NEW.nf_apos_cf := NULL;
END IF;
IF trim(NEW.credit_score)::VARCHAR = '''' THEN
   NEW.credit_score := NULL;
END IF;
IF trim(NEW.ultsac_filusu)::VARCHAR = '''' THEN
   NEW.ultsac_filusu := NULL;
END IF;
IF trim(NEW.ultsac_codusu)::VARCHAR = '''' THEN
   NEW.ultsac_codusu := NULL;
END IF;
IF trim(NEW.fatura_cc_por_filial)::VARCHAR = '''' THEN
   NEW.fatura_cc_por_filial := NULL;
END IF;
IF trim(NEW.path_arquivos)::VARCHAR = '''' THEN
   NEW.path_arquivos := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cfg2
BEFORE INSERT OR UPDATE ON tt_cfg2
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cfg2();



/*-- SEQ 6145 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_chr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.tipcob)::VARCHAR = '''' THEN
   NEW.tipcob := NULL;
END IF;
IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codage)::VARCHAR = '''' THEN
   NEW.codage := NULL;
END IF;
IF trim(NEW.numche)::VARCHAR = '''' THEN
   NEW.numche := NULL;
END IF;
IF trim(NEW.numcon)::VARCHAR = '''' THEN
   NEW.numcon := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.autori)::VARCHAR = '''' THEN
   NEW.autori := NULL;
END IF;
IF trim(NEW.obslog)::VARCHAR = '''' THEN
   NEW.obslog := NULL;
END IF;
IF trim(NEW.cdcmc7)::VARCHAR = '''' THEN
   NEW.cdcmc7 := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.placas)::VARCHAR = '''' THEN
   NEW.placas := NULL;
END IF;
IF trim(NEW.seqcan)::VARCHAR = '''' THEN
   NEW.seqcan := NULL;
END IF;
IF trim(NEW.serche)::VARCHAR = '''' THEN
   NEW.serche := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;
IF trim(NEW.fildep)::VARCHAR = '''' THEN
   NEW.fildep := NULL;
END IF;
IF trim(NEW.seqdep)::VARCHAR = '''' THEN
   NEW.seqdep := NULL;
END IF;
IF trim(NEW.flgflu)::VARCHAR = '''' THEN
   NEW.flgflu := NULL;
END IF;
IF trim(NEW.fildif)::VARCHAR = '''' THEN
   NEW.fildif := NULL;
END IF;
IF trim(NEW.filfor)::VARCHAR = '''' THEN
   NEW.filfor := NULL;
END IF;
IF trim(NEW.seqfor)::VARCHAR = '''' THEN
   NEW.seqfor := NULL;
END IF;
IF trim(NEW.expem4)::VARCHAR = '''' THEN
   NEW.expem4 := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_chr
BEFORE INSERT OR UPDATE ON tt_chr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_chr();



/*-- SEQ 6146 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cid() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codcid)::VARCHAR = '''' THEN
   NEW.codcid := NULL;
END IF;
IF trim(NEW.descid)::VARCHAR = '''' THEN
   NEW.descid := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cid
BEFORE INSERT OR UPDATE ON tt_cid
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cid();



/*-- SEQ 6147 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cl12() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.cl2ati)::VARCHAR = '''' THEN
   NEW.cl2ati := NULL;
END IF;
IF trim(NEW.class2)::VARCHAR = '''' THEN
   NEW.class2 := NULL;
END IF;
IF trim(NEW.codex2)::VARCHAR = '''' THEN
   NEW.codex2 := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cl12
BEFORE INSERT OR UPDATE ON tt_cl12
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cl12();



/*-- SEQ 6148 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cl2() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.cl2ati)::VARCHAR = '''' THEN
   NEW.cl2ati := NULL;
END IF;
IF trim(NEW.class2)::VARCHAR = '''' THEN
   NEW.class2 := NULL;
END IF;
IF trim(NEW.codex2)::VARCHAR = '''' THEN
   NEW.codex2 := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cl2
BEFORE INSERT OR UPDATE ON tt_cl2
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cl2();



/*-- SEQ 6149 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cla() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.descla)::VARCHAR = '''' THEN
   NEW.descla := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cla
BEFORE INSERT OR UPDATE ON tt_cla
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cla();



/*-- SEQ 6150 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cli() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.call_c)::VARCHAR = '''' THEN
   NEW.call_c := NULL;
END IF;
IF trim(NEW.icm_cf)::VARCHAR = '''' THEN
   NEW.icm_cf := NULL;
END IF;
IF trim(NEW.nomcli)::VARCHAR = '''' THEN
   NEW.nomcli := NULL;
END IF;
IF trim(NEW.tipcob)::VARCHAR = '''' THEN
   NEW.tipcob := NULL;
END IF;
IF trim(NEW.tipdoc)::VARCHAR = '''' THEN
   NEW.tipdoc := NULL;
END IF;
IF trim(NEW.codpla)::VARCHAR = '''' THEN
   NEW.codpla := NULL;
END IF;
IF trim(NEW.codven)::VARCHAR = '''' THEN
   NEW.codven := NULL;
END IF;
IF trim(NEW.filpla)::VARCHAR = '''' THEN
   NEW.filpla := NULL;
END IF;
IF trim(NEW.filven)::VARCHAR = '''' THEN
   NEW.filven := NULL;
END IF;
IF trim(NEW.filvin)::VARCHAR = '''' THEN
   NEW.filvin := NULL;
END IF;
IF trim(NEW.codvin)::VARCHAR = '''' THEN
   NEW.codvin := NULL;
END IF;
IF trim(NEW.isenha)::VARCHAR = '''' THEN
   NEW.isenha := NULL;
END IF;
IF trim(NEW.doccon)::VARCHAR = '''' THEN
   NEW.doccon := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.insest)::VARCHAR = '''' THEN
   NEW.insest := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.ultnom)::VARCHAR = '''' THEN
   NEW.ultnom := NULL;
END IF;
IF trim(NEW.hompge)::VARCHAR = '''' THEN
   NEW.hompge := NULL;
END IF;
IF trim(NEW.conjug)::VARCHAR = '''' THEN
   NEW.conjug := NULL;
END IF;
IF trim(NEW.obsout)::VARCHAR = '''' THEN
   NEW.obsout := NULL;
END IF;
IF trim(NEW.nomimg)::VARCHAR = '''' THEN
   NEW.nomimg := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.telcon)::VARCHAR = '''' THEN
   NEW.telcon := NULL;
END IF;
IF trim(NEW.celcon)::VARCHAR = '''' THEN
   NEW.celcon := NULL;
END IF;
IF trim(NEW.e_mcon)::VARCHAR = '''' THEN
   NEW.e_mcon := NULL;
END IF;
IF trim(NEW.ddtcon)::VARCHAR = '''' THEN
   NEW.ddtcon := NULL;
END IF;
IF trim(NEW.ddccon)::VARCHAR = '''' THEN
   NEW.ddccon := NULL;
END IF;
IF trim(NEW.nomtra)::VARCHAR = '''' THEN
   NEW.nomtra := NULL;
END IF;
IF trim(NEW.id_org)::VARCHAR = '''' THEN
   NEW.id_org := NULL;
END IF;
IF trim(NEW.id_est)::VARCHAR = '''' THEN
   NEW.id_est := NULL;
END IF;
IF trim(NEW.edicre)::VARCHAR = '''' THEN
   NEW.edicre := NULL;
END IF;
IF trim(NEW.global)::VARCHAR = '''' THEN
   NEW.global := NULL;
END IF;
IF trim(NEW.pp_flg)::VARCHAR = '''' THEN
   NEW.pp_flg := NULL;
END IF;
IF trim(NEW.pp_fil)::VARCHAR = '''' THEN
   NEW.pp_fil := NULL;
END IF;
IF trim(NEW.pp_cod)::VARCHAR = '''' THEN
   NEW.pp_cod := NULL;
END IF;
IF trim(NEW.simple)::VARCHAR = '''' THEN
   NEW.simple := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.naospc)::VARCHAR = '''' THEN
   NEW.naospc := NULL;
END IF;
IF trim(NEW.atucus)::VARCHAR = '''' THEN
   NEW.atucus := NULL;
END IF;
IF trim(NEW.filcon)::VARCHAR = '''' THEN
   NEW.filcon := NULL;
END IF;
IF trim(NEW.codcon)::VARCHAR = '''' THEN
   NEW.codcon := NULL;
END IF;
IF trim(NEW.poremp)::VARCHAR = '''' THEN
   NEW.poremp := NULL;
END IF;
IF trim(NEW.tipemp)::VARCHAR = '''' THEN
   NEW.tipemp := NULL;
END IF;
IF trim(NEW.estran)::VARCHAR = '''' THEN
   NEW.estran := NULL;
END IF;
IF trim(NEW.usaref)::VARCHAR = '''' THEN
   NEW.usaref := NULL;
END IF;
IF trim(NEW.repase)::VARCHAR = '''' THEN
   NEW.repase := NULL;
END IF;
IF trim(NEW.pedele)::VARCHAR = '''' THEN
   NEW.pedele := NULL;
END IF;
IF trim(NEW.filgui)::VARCHAR = '''' THEN
   NEW.filgui := NULL;
END IF;
IF trim(NEW.codgui)::VARCHAR = '''' THEN
   NEW.codgui := NULL;
END IF;
IF trim(NEW.naodiv)::VARCHAR = '''' THEN
   NEW.naodiv := NULL;
END IF;
IF trim(NEW.isento)::VARCHAR = '''' THEN
   NEW.isento := NULL;
END IF;
IF trim(NEW.sufram)::VARCHAR = '''' THEN
   NEW.sufram := NULL;
END IF;
IF trim(NEW.codnae)::VARCHAR = '''' THEN
   NEW.codnae := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.codcrc)::VARCHAR = '''' THEN
   NEW.codcrc := NULL;
END IF;
IF trim(NEW.iseche)::VARCHAR = '''' THEN
   NEW.iseche := NULL;
END IF;
IF trim(NEW.dettip)::VARCHAR = '''' THEN
   NEW.dettip := NULL;
END IF;
IF trim(NEW.entise)::VARCHAR = '''' THEN
   NEW.entise := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;
IF trim(NEW.filend)::VARCHAR = '''' THEN
   NEW.filend := NULL;
END IF;
IF trim(NEW.e_mfin)::VARCHAR = '''' THEN
   NEW.e_mfin := NULL;
END IF;
IF trim(NEW.obsfor)::VARCHAR = '''' THEN
   NEW.obsfor := NULL;
END IF;
IF trim(NEW.filfia)::VARCHAR = '''' THEN
   NEW.filfia := NULL;
END IF;
IF trim(NEW.codfia)::VARCHAR = '''' THEN
   NEW.codfia := NULL;
END IF;
IF trim(NEW.cod_rntc)::VARCHAR = '''' THEN
   NEW.cod_rntc := NULL;
END IF;
IF trim(NEW.fil_ck)::VARCHAR = '''' THEN
   NEW.fil_ck := NULL;
END IF;
IF trim(NEW.ecf_ck)::VARCHAR = '''' THEN
   NEW.ecf_ck := NULL;
END IF;
IF trim(NEW.regesp)::VARCHAR = '''' THEN
   NEW.regesp := NULL;
END IF;
IF trim(NEW.indexp)::VARCHAR = '''' THEN
   NEW.indexp := NULL;
END IF;
IF trim(NEW.regmei)::VARCHAR = '''' THEN
   NEW.regmei := NULL;
END IF;
IF trim(NEW.contribuinte)::VARCHAR = '''' THEN
   NEW.contribuinte := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cli
BEFORE INSERT OR UPDATE ON tt_cli
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cli();



/*-- SEQ 6151 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_clixfil() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.meucod)::VARCHAR = '''' THEN
   NEW.meucod := NULL;
END IF;
IF trim(NEW.endftp)::VARCHAR = '''' THEN
   NEW.endftp := NULL;
END IF;
IF trim(NEW.usuftp)::VARCHAR = '''' THEN
   NEW.usuftp := NULL;
END IF;
IF trim(NEW.senftp)::VARCHAR = '''' THEN
   NEW.senftp := NULL;
END IF;
IF trim(NEW.masnot)::VARCHAR = '''' THEN
   NEW.masnot := NULL;
END IF;
IF trim(NEW.masped)::VARCHAR = '''' THEN
   NEW.masped := NULL;
END IF;
IF trim(NEW.masret)::VARCHAR = '''' THEN
   NEW.masret := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_clixfil
BEFORE INSERT OR UPDATE ON tt_clixfil
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_clixfil();



/*-- SEQ 6152 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_clixint() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.codint)::VARCHAR = '''' THEN
   NEW.codint := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_clixint
BEFORE INSERT OR UPDATE ON tt_clixint
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_clixint();



/*-- SEQ 6153 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cms() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filrec)::VARCHAR = '''' THEN
   NEW.filrec := NULL;
END IF;
IF trim(NEW.seqrec)::VARCHAR = '''' THEN
   NEW.seqrec := NULL;
END IF;
IF trim(NEW.numpar)::VARCHAR = '''' THEN
   NEW.numpar := NULL;
END IF;
IF trim(NEW.subpar)::VARCHAR = '''' THEN
   NEW.subpar := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.tipcms)::VARCHAR = '''' THEN
   NEW.tipcms := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cms
BEFORE INSERT OR UPDATE ON tt_cms
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cms();



/*-- SEQ 6154 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cnc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cnc
BEFORE INSERT OR UPDATE ON tt_cnc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cnc();



/*-- SEQ 6155 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cob() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.filrec)::VARCHAR = '''' THEN
   NEW.filrec := NULL;
END IF;
IF trim(NEW.seqrec)::VARCHAR = '''' THEN
   NEW.seqrec := NULL;
END IF;
IF trim(NEW.numpar)::VARCHAR = '''' THEN
   NEW.numpar := NULL;
END IF;
IF trim(NEW.subpar)::VARCHAR = '''' THEN
   NEW.subpar := NULL;
END IF;
IF trim(NEW.filchr)::VARCHAR = '''' THEN
   NEW.filchr := NULL;
END IF;
IF trim(NEW.seqchr)::VARCHAR = '''' THEN
   NEW.seqchr := NULL;
END IF;
IF trim(NEW.filsup)::VARCHAR = '''' THEN
   NEW.filsup := NULL;
END IF;
IF trim(NEW.seqsup)::VARCHAR = '''' THEN
   NEW.seqsup := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cob
BEFORE INSERT OR UPDATE ON tt_cob
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cob();



/*-- SEQ 6156 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cod() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codtab)::VARCHAR = '''' THEN
   NEW.codtab := NULL;
END IF;
IF trim(NEW.filcod)::VARCHAR = '''' THEN
   NEW.filcod := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cod
BEFORE INSERT OR UPDATE ON tt_cod
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cod();



/*-- SEQ 6157 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_com() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.incoju)::VARCHAR = '''' THEN
   NEW.incoju := NULL;
END IF;
IF trim(NEW.intpju)::VARCHAR = '''' THEN
   NEW.intpju := NULL;
END IF;
IF trim(NEW.intpmu)::VARCHAR = '''' THEN
   NEW.intpmu := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.tipnot)::VARCHAR = '''' THEN
   NEW.tipnot := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filfor)::VARCHAR = '''' THEN
   NEW.filfor := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;
IF trim(NEW.numnot)::VARCHAR = '''' THEN
   NEW.numnot := NULL;
END IF;
IF trim(NEW.notesp)::VARCHAR = '''' THEN
   NEW.notesp := NULL;
END IF;
IF trim(NEW.tippar)::VARCHAR = '''' THEN
   NEW.tippar := NULL;
END IF;
IF trim(NEW.ufnota)::VARCHAR = '''' THEN
   NEW.ufnota := NULL;
END IF;
IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.filend)::VARCHAR = '''' THEN
   NEW.filend := NULL;
END IF;
IF trim(NEW.subser)::VARCHAR = '''' THEN
   NEW.subser := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.seqfat)::VARCHAR = '''' THEN
   NEW.seqfat := NULL;
END IF;
IF trim(NEW.seqfre)::VARCHAR = '''' THEN
   NEW.seqfre := NULL;
END IF;
IF trim(NEW.espdoc)::VARCHAR = '''' THEN
   NEW.espdoc := NULL;
END IF;
IF trim(NEW.conpgt)::VARCHAR = '''' THEN
   NEW.conpgt := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.obsfat)::VARCHAR = '''' THEN
   NEW.obsfat := NULL;
END IF;
IF trim(NEW.seqcan)::VARCHAR = '''' THEN
   NEW.seqcan := NULL;
END IF;
IF trim(NEW.tiptrp)::VARCHAR = '''' THEN
   NEW.tiptrp := NULL;
END IF;
IF trim(NEW.atucus)::VARCHAR = '''' THEN
   NEW.atucus := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;
IF trim(NEW.flg_inss)::VARCHAR = '''' THEN
   NEW.flg_inss := NULL;
END IF;
IF trim(NEW.flg_cs)::VARCHAR = '''' THEN
   NEW.flg_cs := NULL;
END IF;
IF trim(NEW.flg_pis)::VARCHAR = '''' THEN
   NEW.flg_pis := NULL;
END IF;
IF trim(NEW.flgins)::VARCHAR = '''' THEN
   NEW.flgins := NULL;
END IF;
IF trim(NEW.flgcss)::VARCHAR = '''' THEN
   NEW.flgcss := NULL;
END IF;
IF trim(NEW.flgpis)::VARCHAR = '''' THEN
   NEW.flgpis := NULL;
END IF;
IF trim(NEW.flgcof)::VARCHAR = '''' THEN
   NEW.flgcof := NULL;
END IF;
IF trim(NEW.tipemp)::VARCHAR = '''' THEN
   NEW.tipemp := NULL;
END IF;
IF trim(NEW.poremp)::VARCHAR = '''' THEN
   NEW.poremp := NULL;
END IF;
IF trim(NEW.filfre)::VARCHAR = '''' THEN
   NEW.filfre := NULL;
END IF;
IF trim(NEW.motrej)::VARCHAR = '''' THEN
   NEW.motrej := NULL;
END IF;
IF trim(NEW.retirr)::VARCHAR = '''' THEN
   NEW.retirr := NULL;
END IF;
IF trim(NEW.retcss)::VARCHAR = '''' THEN
   NEW.retcss := NULL;
END IF;
IF trim(NEW.flgicm)::VARCHAR = '''' THEN
   NEW.flgicm := NULL;
END IF;
IF trim(NEW.flgiss)::VARCHAR = '''' THEN
   NEW.flgiss := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.filagc)::VARCHAR = '''' THEN
   NEW.filagc := NULL;
END IF;
IF trim(NEW.seqagc)::VARCHAR = '''' THEN
   NEW.seqagc := NULL;
END IF;
IF trim(NEW.codavu)::VARCHAR = '''' THEN
   NEW.codavu := NULL;
END IF;
IF trim(NEW.rateio_frete)::VARCHAR = '''' THEN
   NEW.rateio_frete := NULL;
END IF;
IF trim(NEW.tipfre)::VARCHAR = '''' THEN
   NEW.tipfre := NULL;
END IF;
IF trim(NEW.chavea)::VARCHAR = '''' THEN
   NEW.chavea := NULL;
END IF;
IF trim(NEW.sitpis)::VARCHAR = '''' THEN
   NEW.sitpis := NULL;
END IF;
IF trim(NEW.sitcof)::VARCHAR = '''' THEN
   NEW.sitcof := NULL;
END IF;
IF trim(NEW.codfps)::VARCHAR = '''' THEN
   NEW.codfps := NULL;
END IF;
IF trim(NEW.natfre)::VARCHAR = '''' THEN
   NEW.natfre := NULL;
END IF;
IF trim(NEW.natbcc)::VARCHAR = '''' THEN
   NEW.natbcc := NULL;
END IF;
IF trim(NEW.coddar)::VARCHAR = '''' THEN
   NEW.coddar := NULL;
END IF;
IF trim(NEW.datstr)::VARCHAR = '''' THEN
   NEW.datstr := NULL;
END IF;
IF trim(NEW.finnfe)::VARCHAR = '''' THEN
   NEW.finnfe := NULL;
END IF;
IF trim(NEW.expfis)::VARCHAR = '''' THEN
   NEW.expfis := NULL;
END IF;
IF trim(NEW.export_can)::VARCHAR = '''' THEN
   NEW.export_can := NULL;
END IF;
IF trim(NEW.xmlnfe)::VARCHAR = '''' THEN
   NEW.xmlnfe := NULL;
END IF;
IF trim(NEW.expem4)::VARCHAR = '''' THEN
   NEW.expem4 := NULL;
END IF;
IF trim(NEW.tipccm)::VARCHAR = '''' THEN
   NEW.tipccm := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_com
BEFORE INSERT OR UPDATE ON tt_com
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_com();



/*-- SEQ 6158 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_comxcom() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.fildoc)::VARCHAR = '''' THEN
   NEW.fildoc := NULL;
END IF;
IF trim(NEW.seqdoc)::VARCHAR = '''' THEN
   NEW.seqdoc := NULL;
END IF;
IF trim(NEW.filcom)::VARCHAR = '''' THEN
   NEW.filcom := NULL;
END IF;
IF trim(NEW.seqcom)::VARCHAR = '''' THEN
   NEW.seqcom := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_comxcom
BEFORE INSERT OR UPDATE ON tt_comxcom
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_comxcom();



/*-- SEQ 6159 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_comxcta() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.tipnot)::VARCHAR = '''' THEN
   NEW.tipnot := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_comxcta
BEFORE INSERT OR UPDATE ON tt_comxcta
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_comxcta();



/*-- SEQ 6160 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_con() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.celcon)::VARCHAR = '''' THEN
   NEW.celcon := NULL;
END IF;
IF trim(NEW.telcon)::VARCHAR = '''' THEN
   NEW.telcon := NULL;
END IF;
IF trim(NEW.e_mail)::VARCHAR = '''' THEN
   NEW.e_mail := NULL;
END IF;
IF trim(NEW.contat)::VARCHAR = '''' THEN
   NEW.contat := NULL;
END IF;
IF trim(NEW.filend)::VARCHAR = '''' THEN
   NEW.filend := NULL;
END IF;
IF trim(NEW.dddcon)::VARCHAR = '''' THEN
   NEW.dddcon := NULL;
END IF;
IF trim(NEW.dddcel)::VARCHAR = '''' THEN
   NEW.dddcel := NULL;
END IF;
IF trim(NEW.nomtra)::VARCHAR = '''' THEN
   NEW.nomtra := NULL;
END IF;
IF trim(NEW.dddfax)::VARCHAR = '''' THEN
   NEW.dddfax := NULL;
END IF;
IF trim(NEW.numfax)::VARCHAR = '''' THEN
   NEW.numfax := NULL;
END IF;
IF trim(NEW.codddi)::VARCHAR = '''' THEN
   NEW.codddi := NULL;
END IF;
IF trim(NEW.doccon)::VARCHAR = '''' THEN
   NEW.doccon := NULL;
END IF;
IF trim(NEW.retpro)::VARCHAR = '''' THEN
   NEW.retpro := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_con
BEFORE INSERT OR UPDATE ON tt_con
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_con();



/*-- SEQ 6161 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cor() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.tipcor)::VARCHAR = '''' THEN
   NEW.tipcor := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.filend)::VARCHAR = '''' THEN
   NEW.filend := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cor
BEFORE INSERT OR UPDATE ON tt_cor
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cor();



/*-- SEQ 6162 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_corxcob() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcor)::VARCHAR = '''' THEN
   NEW.filcor := NULL;
END IF;
IF trim(NEW.seqcor)::VARCHAR = '''' THEN
   NEW.seqcor := NULL;
END IF;
IF trim(NEW.filrec)::VARCHAR = '''' THEN
   NEW.filrec := NULL;
END IF;
IF trim(NEW.seqrec)::VARCHAR = '''' THEN
   NEW.seqrec := NULL;
END IF;
IF trim(NEW.numpar)::VARCHAR = '''' THEN
   NEW.numpar := NULL;
END IF;
IF trim(NEW.subpar)::VARCHAR = '''' THEN
   NEW.subpar := NULL;
END IF;
IF trim(NEW.filchr)::VARCHAR = '''' THEN
   NEW.filchr := NULL;
END IF;
IF trim(NEW.seqchr)::VARCHAR = '''' THEN
   NEW.seqchr := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_corxcob
BEFORE INSERT OR UPDATE ON tt_corxcob
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_corxcob();



/*-- SEQ 6163 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cos() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcos)::VARCHAR = '''' THEN
   NEW.filcos := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.tippar)::VARCHAR = '''' THEN
   NEW.tippar := NULL;
END IF;
IF trim(NEW.tipped)::VARCHAR = '''' THEN
   NEW.tipped := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.filpar)::VARCHAR = '''' THEN
   NEW.filpar := NULL;
END IF;
IF trim(NEW.codpar)::VARCHAR = '''' THEN
   NEW.codpar := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cos
BEFORE INSERT OR UPDATE ON tt_cos
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cos();



/*-- SEQ 6164 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cpe() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.numpar)::VARCHAR = '''' THEN
   NEW.numpar := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cpe
BEFORE INSERT OR UPDATE ON tt_cpe
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cpe();



/*-- SEQ 6165 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cpf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.descri)::VARCHAR = '''' THEN
   NEW.descri := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cpf
BEFORE INSERT OR UPDATE ON tt_cpf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cpf();



/*-- SEQ 6166 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cpfxfor() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filfor)::VARCHAR = '''' THEN
   NEW.filfor := NULL;
END IF;
IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;
IF trim(NEW.przpgt)::VARCHAR = '''' THEN
   NEW.przpgt := NULL;
END IF;
IF trim(NEW.perpgt)::VARCHAR = '''' THEN
   NEW.perpgt := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.tipexp)::VARCHAR = '''' THEN
   NEW.tipexp := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cpfxfor
BEFORE INSERT OR UPDATE ON tt_cpfxfor
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cpfxfor();



/*-- SEQ 6167 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cpm() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcpm)::VARCHAR = '''' THEN
   NEW.filcpm := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filpre)::VARCHAR = '''' THEN
   NEW.filpre := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.seqpre)::VARCHAR = '''' THEN
   NEW.seqpre := NULL;
END IF;
IF trim(NEW.codpgt)::VARCHAR = '''' THEN
   NEW.codpgt := NULL;
END IF;
IF trim(NEW.filpgt)::VARCHAR = '''' THEN
   NEW.filpgt := NULL;
END IF;
IF trim(NEW.filpro)::VARCHAR = '''' THEN
   NEW.filpro := NULL;
END IF;
IF trim(NEW.fillot)::VARCHAR = '''' THEN
   NEW.fillot := NULL;
END IF;
IF trim(NEW.seqlot)::VARCHAR = '''' THEN
   NEW.seqlot := NULL;
END IF;
IF trim(NEW.clilev)::VARCHAR = '''' THEN
   NEW.clilev := NULL;
END IF;
IF trim(NEW.temdes)::VARCHAR = '''' THEN
   NEW.temdes := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cpm
BEFORE INSERT OR UPDATE ON tt_cpm
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cpm();



/*-- SEQ 6168 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cpr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.descri)::VARCHAR = '''' THEN
   NEW.descri := NULL;
END IF;
IF trim(NEW.cprati)::VARCHAR = '''' THEN
   NEW.cprati := NULL;
END IF;
IF trim(NEW.tipapl)::VARCHAR = '''' THEN
   NEW.tipapl := NULL;
END IF;
IF trim(NEW.canapl)::VARCHAR = '''' THEN
   NEW.canapl := NULL;
END IF;
IF trim(NEW.filapl)::VARCHAR = '''' THEN
   NEW.filapl := NULL;
END IF;
IF trim(NEW.filpre)::VARCHAR = '''' THEN
   NEW.filpre := NULL;
END IF;
IF trim(NEW.usoout)::VARCHAR = '''' THEN
   NEW.usoout := NULL;
END IF;
IF trim(NEW.vencus)::VARCHAR = '''' THEN
   NEW.vencus := NULL;
END IF;
IF trim(NEW.igncmp)::VARCHAR = '''' THEN
   NEW.igncmp := NULL;
END IF;
IF trim(NEW.regaco)::VARCHAR = '''' THEN
   NEW.regaco := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cpr
BEFORE INSERT OR UPDATE ON tt_cpr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cpr();



/*-- SEQ 6169 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cprxdfil() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcpr)::VARCHAR = '''' THEN
   NEW.filcpr := NULL;
END IF;
IF trim(NEW.seqcpr)::VARCHAR = '''' THEN
   NEW.seqcpr := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cprxdfil
BEFORE INSERT OR UPDATE ON tt_cprxdfil
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cprxdfil();



/*-- SEQ 6170 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cprxgat() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcpr)::VARCHAR = '''' THEN
   NEW.filcpr := NULL;
END IF;
IF trim(NEW.seqcpr)::VARCHAR = '''' THEN
   NEW.seqcpr := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.tipgat)::VARCHAR = '''' THEN
   NEW.tipgat := NULL;
END IF;
IF trim(NEW.filcprfut)::VARCHAR = '''' THEN
   NEW.filcprfut := NULL;
END IF;
IF trim(NEW.seqcprfut)::VARCHAR = '''' THEN
   NEW.seqcprfut := NULL;
END IF;
IF trim(NEW.tipobg)::VARCHAR = '''' THEN
   NEW.tipobg := NULL;
END IF;
IF trim(NEW.gatati)::VARCHAR = '''' THEN
   NEW.gatati := NULL;
END IF;
IF trim(NEW.descri)::VARCHAR = '''' THEN
   NEW.descri := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cprxgat
BEFORE INSERT OR UPDATE ON tt_cprxgat
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cprxgat();



/*-- SEQ 6171 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cprxpla() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcpr)::VARCHAR = '''' THEN
   NEW.filcpr := NULL;
END IF;
IF trim(NEW.seqcpr)::VARCHAR = '''' THEN
   NEW.seqcpr := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filpgt)::VARCHAR = '''' THEN
   NEW.filpgt := NULL;
END IF;
IF trim(NEW.codpgt)::VARCHAR = '''' THEN
   NEW.codpgt := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cprxpla
BEFORE INSERT OR UPDATE ON tt_cprxpla
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cprxpla();



/*-- SEQ 6172 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cprxtpr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcpr)::VARCHAR = '''' THEN
   NEW.filcpr := NULL;
END IF;
IF trim(NEW.seqcpr)::VARCHAR = '''' THEN
   NEW.seqcpr := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filtpr)::VARCHAR = '''' THEN
   NEW.filtpr := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cprxtpr
BEFORE INSERT OR UPDATE ON tt_cprxtpr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cprxtpr();



/*-- SEQ 6173 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_crb() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;
IF trim(NEW.apecrb)::VARCHAR = '''' THEN
   NEW.apecrb := NULL;
END IF;
IF trim(NEW.descrb)::VARCHAR = '''' THEN
   NEW.descrb := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_crb
BEFORE INSERT OR UPDATE ON tt_crb
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_crb();



/*-- SEQ 6174 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cre() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.coluna)::VARCHAR = '''' THEN
   NEW.coluna := NULL;
END IF;
IF trim(NEW.descri)::VARCHAR = '''' THEN
   NEW.descri := NULL;
END IF;
IF trim(NEW.tipdad)::VARCHAR = '''' THEN
   NEW.tipdad := NULL;
END IF;
IF trim(NEW.codigo)::VARCHAR = '''' THEN
   NEW.codigo := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cre
BEFORE INSERT OR UPDATE ON tt_cre
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cre();



/*-- SEQ 6175 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_crtxcli() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.descrt)::VARCHAR = '''' THEN
   NEW.descrt := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.tipcrt)::VARCHAR = '''' THEN
   NEW.tipcrt := NULL;
END IF;
IF trim(NEW.usodet)::VARCHAR = '''' THEN
   NEW.usodet := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_crtxcli
BEFORE INSERT OR UPDATE ON tt_crtxcli
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_crtxcli();



/*-- SEQ 6176 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_crtxend() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.descrt)::VARCHAR = '''' THEN
   NEW.descrt := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.filend)::VARCHAR = '''' THEN
   NEW.filend := NULL;
END IF;
IF trim(NEW.tipcrt)::VARCHAR = '''' THEN
   NEW.tipcrt := NULL;
END IF;
IF trim(NEW.usodet)::VARCHAR = '''' THEN
   NEW.usodet := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_crtxend
BEFORE INSERT OR UPDATE ON tt_crtxend
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_crtxend();



/*-- SEQ 6177 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_crtxgra() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.descrt)::VARCHAR = '''' THEN
   NEW.descrt := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.tipcrt)::VARCHAR = '''' THEN
   NEW.tipcrt := NULL;
END IF;
IF trim(NEW.usodet)::VARCHAR = '''' THEN
   NEW.usodet := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_crtxgra
BEFORE INSERT OR UPDATE ON tt_crtxgra
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_crtxgra();



/*-- SEQ 6178 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_crtxpro() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.descrt)::VARCHAR = '''' THEN
   NEW.descrt := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.tipcrt)::VARCHAR = '''' THEN
   NEW.tipcrt := NULL;
END IF;
IF trim(NEW.usodet)::VARCHAR = '''' THEN
   NEW.usodet := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_crtxpro
BEFORE INSERT OR UPDATE ON tt_crtxpro
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_crtxpro();



/*-- SEQ 6179 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_csc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.filped)::VARCHAR = '''' THEN
   NEW.filped := NULL;
END IF;
IF trim(NEW.tipped)::VARCHAR = '''' THEN
   NEW.tipped := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_csc
BEFORE INSERT OR UPDATE ON tt_csc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_csc();



/*-- SEQ 6180 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cta() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.filect)::VARCHAR = '''' THEN
   NEW.filect := NULL;
END IF;
IF trim(NEW.seqect)::VARCHAR = '''' THEN
   NEW.seqect := NULL;
END IF;
IF trim(NEW.titcta)::VARCHAR = '''' THEN
   NEW.titcta := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.prefix)::VARCHAR = '''' THEN
   NEW.prefix := NULL;
END IF;
IF trim(NEW.usocta)::VARCHAR = '''' THEN
   NEW.usocta := NULL;
END IF;
IF trim(NEW.aplnum)::VARCHAR = '''' THEN
   NEW.aplnum := NULL;
END IF;
IF trim(NEW.aturea)::VARCHAR = '''' THEN
   NEW.aturea := NULL;
END IF;
IF trim(NEW.atuare)::VARCHAR = '''' THEN
   NEW.atuare := NULL;
END IF;
IF trim(NEW.filnum)::VARCHAR = '''' THEN
   NEW.filnum := NULL;
END IF;
IF trim(NEW.filvin)::VARCHAR = '''' THEN
   NEW.filvin := NULL;
END IF;
IF trim(NEW.seqvin)::VARCHAR = '''' THEN
   NEW.seqvin := NULL;
END IF;
IF trim(NEW.tipvin)::VARCHAR = '''' THEN
   NEW.tipvin := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cta
BEFORE INSERT OR UPDATE ON tt_cta
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cta();



/*-- SEQ 6181 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ctaxdctr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ctaxdctr
BEFORE INSERT OR UPDATE ON tt_ctaxdctr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ctaxdctr();



/*-- SEQ 6182 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ctaxdcus() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ctaxdcus
BEFORE INSERT OR UPDATE ON tt_ctaxdcus
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ctaxdcus();



/*-- SEQ 6183 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ctaxfil() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.period)::VARCHAR = '''' THEN
   NEW.period := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ctaxfil
BEFORE INSERT OR UPDATE ON tt_ctaxfil
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ctaxfil();



/*-- SEQ 6184 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ctb() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.chetro)::VARCHAR = '''' THEN
   NEW.chetro := NULL;
END IF;
IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;
IF trim(NEW.numage)::VARCHAR = '''' THEN
   NEW.numage := NULL;
END IF;
IF trim(NEW.ctacrr)::VARCHAR = '''' THEN
   NEW.ctacrr := NULL;
END IF;
IF trim(NEW.tipctb)::VARCHAR = '''' THEN
   NEW.tipctb := NULL;
END IF;
IF trim(NEW.nomage)::VARCHAR = '''' THEN
   NEW.nomage := NULL;
END IF;
IF trim(NEW.digage)::VARCHAR = '''' THEN
   NEW.digage := NULL;
END IF;
IF trim(NEW.diga_c)::VARCHAR = '''' THEN
   NEW.diga_c := NULL;
END IF;
IF trim(NEW.digcrr)::VARCHAR = '''' THEN
   NEW.digcrr := NULL;
END IF;
IF trim(NEW.ctactb)::VARCHAR = '''' THEN
   NEW.ctactb := NULL;
END IF;
IF trim(NEW.impcai)::VARCHAR = '''' THEN
   NEW.impcai := NULL;
END IF;
IF trim(NEW.numage_nosnum)::VARCHAR = '''' THEN
   NEW.numage_nosnum := NULL;
END IF;
IF trim(NEW.digage_nosnum)::VARCHAR = '''' THEN
   NEW.digage_nosnum := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ctb
BEFORE INSERT OR UPDATE ON tt_ctb
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ctb();



/*-- SEQ 6185 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ctbxccb() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;
IF trim(NEW.numage)::VARCHAR = '''' THEN
   NEW.numage := NULL;
END IF;
IF trim(NEW.ctacrr)::VARCHAR = '''' THEN
   NEW.ctacrr := NULL;
END IF;
IF trim(NEW.licenc)::VARCHAR = '''' THEN
   NEW.licenc := NULL;
END IF;
IF trim(NEW.codcnv)::VARCHAR = '''' THEN
   NEW.codcnv := NULL;
END IF;
IF trim(NEW.recsac)::VARCHAR = '''' THEN
   NEW.recsac := NULL;
END IF;
IF trim(NEW.codced)::VARCHAR = '''' THEN
   NEW.codced := NULL;
END IF;
IF trim(NEW.codtra)::VARCHAR = '''' THEN
   NEW.codtra := NULL;
END IF;
IF trim(NEW.codmod)::VARCHAR = '''' THEN
   NEW.codmod := NULL;
END IF;
IF trim(NEW.codger)::VARCHAR = '''' THEN
   NEW.codger := NULL;
END IF;
IF trim(NEW.laybol)::VARCHAR = '''' THEN
   NEW.laybol := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ctbxccb
BEFORE INSERT OR UPDATE ON tt_ctbxccb
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ctbxccb();



/*-- SEQ 6186 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ctf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.nomarq)::VARCHAR = '''' THEN
   NEW.nomarq := NULL;
END IF;
IF trim(NEW.arqtxt)::VARCHAR = '''' THEN
   NEW.arqtxt := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ctf
BEFORE INSERT OR UPDATE ON tt_ctf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ctf();



/*-- SEQ 6187 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ctm() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.numpar)::VARCHAR = '''' THEN
   NEW.numpar := NULL;
END IF;
IF trim(NEW.subpar)::VARCHAR = '''' THEN
   NEW.subpar := NULL;
END IF;
IF trim(NEW.vldcar)::VARCHAR = '''' THEN
   NEW.vldcar := NULL;
END IF;
IF trim(NEW.numcar)::VARCHAR = '''' THEN
   NEW.numcar := NULL;
END IF;
IF trim(NEW.nsutrn)::VARCHAR = '''' THEN
   NEW.nsutrn := NULL;
END IF;
IF trim(NEW.tipope)::VARCHAR = '''' THEN
   NEW.tipope := NULL;
END IF;
IF trim(NEW.manual)::VARCHAR = '''' THEN
   NEW.manual := NULL;
END IF;
IF trim(NEW.seqtef)::VARCHAR = '''' THEN
   NEW.seqtef := NULL;
END IF;
IF trim(NEW.invali)::VARCHAR = '''' THEN
   NEW.invali := NULL;
END IF;
IF trim(NEW.numaut)::VARCHAR = '''' THEN
   NEW.numaut := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ctm
BEFORE INSERT OR UPDATE ON tt_ctm
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ctm();



/*-- SEQ 6188 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ctr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.tipnot)::VARCHAR = '''' THEN
   NEW.tipnot := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ctr
BEFORE INSERT OR UPDATE ON tt_ctr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ctr();



/*-- SEQ 6189 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ctt() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.cttpro)::VARCHAR = '''' THEN
   NEW.cttpro := NULL;
END IF;
IF trim(NEW.tipctt)::VARCHAR = '''' THEN
   NEW.tipctt := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.contra)::VARCHAR = '''' THEN
   NEW.contra := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.filreg)::VARCHAR = '''' THEN
   NEW.filreg := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.seqreg)::VARCHAR = '''' THEN
   NEW.seqreg := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.filven)::VARCHAR = '''' THEN
   NEW.filven := NULL;
END IF;
IF trim(NEW.codven)::VARCHAR = '''' THEN
   NEW.codven := NULL;
END IF;
IF trim(NEW.filemp)::VARCHAR = '''' THEN
   NEW.filemp := NULL;
END IF;
IF trim(NEW.codemp)::VARCHAR = '''' THEN
   NEW.codemp := NULL;
END IF;
IF trim(NEW.codhom)::VARCHAR = '''' THEN
   NEW.codhom := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ctt
BEFORE INSERT OR UPDATE ON tt_ctt
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ctt();



/*-- SEQ 6190 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cup() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filcpr)::VARCHAR = '''' THEN
   NEW.filcpr := NULL;
END IF;
IF trim(NEW.seqcpr)::VARCHAR = '''' THEN
   NEW.seqcpr := NULL;
END IF;
IF trim(NEW.numero)::VARCHAR = '''' THEN
   NEW.numero := NULL;
END IF;
IF trim(NEW.tipcod)::VARCHAR = '''' THEN
   NEW.tipcod := NULL;
END IF;
IF trim(NEW.descri)::VARCHAR = '''' THEN
   NEW.descri := NULL;
END IF;
IF trim(NEW.cupati)::VARCHAR = '''' THEN
   NEW.cupati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cup
BEFORE INSERT OR UPDATE ON tt_cup
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cup();



/*-- SEQ 6191 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cupxuso() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcup)::VARCHAR = '''' THEN
   NEW.filcup := NULL;
END IF;
IF trim(NEW.seqcup)::VARCHAR = '''' THEN
   NEW.seqcup := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.filven)::VARCHAR = '''' THEN
   NEW.filven := NULL;
END IF;
IF trim(NEW.seqven)::VARCHAR = '''' THEN
   NEW.seqven := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cupxuso
BEFORE INSERT OR UPDATE ON tt_cupxuso
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cupxuso();



/*-- SEQ 6192 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cus() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.tipnot)::VARCHAR = '''' THEN
   NEW.tipnot := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cus
BEFORE INSERT OR UPDATE ON tt_cus
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cus();



/*-- SEQ 6193 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_cxg() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.tipmar)::VARCHAR = '''' THEN
   NEW.tipmar := NULL;
END IF;
IF trim(NEW.filcxg)::VARCHAR = '''' THEN
   NEW.filcxg := NULL;
END IF;
IF trim(NEW.filmar)::VARCHAR = '''' THEN
   NEW.filmar := NULL;
END IF;
IF trim(NEW.codcxg)::VARCHAR = '''' THEN
   NEW.codcxg := NULL;
END IF;
IF trim(NEW.codmar)::VARCHAR = '''' THEN
   NEW.codmar := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_cxg
BEFORE INSERT OR UPDATE ON tt_cxg
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_cxg();



/*-- SEQ 6194 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_dec() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.origem)::VARCHAR = '''' THEN
   NEW.origem := NULL;
END IF;
IF trim(NEW.titulo)::VARCHAR = '''' THEN
   NEW.titulo := NULL;
END IF;
IF trim(NEW.sqlstr)::VARCHAR = '''' THEN
   NEW.sqlstr := NULL;
END IF;
IF trim(NEW.sqlstr2)::VARCHAR = '''' THEN
   NEW.sqlstr2 := NULL;
END IF;
IF trim(NEW.sqlstr3)::VARCHAR = '''' THEN
   NEW.sqlstr3 := NULL;
END IF;
IF trim(NEW.sqlstr4)::VARCHAR = '''' THEN
   NEW.sqlstr4 := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_dec
BEFORE INSERT OR UPDATE ON tt_dec
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_dec();



/*-- SEQ 6195 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_del() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.tabela)::VARCHAR = '''' THEN
   NEW.tabela := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.re_inc)::VARCHAR = '''' THEN
   NEW.re_inc := NULL;
END IF;
IF trim(NEW.osuser)::VARCHAR = '''' THEN
   NEW.osuser := NULL;
END IF;
IF trim(NEW.comput)::VARCHAR = '''' THEN
   NEW.comput := NULL;
END IF;
IF trim(NEW.progra)::VARCHAR = '''' THEN
   NEW.progra := NULL;
END IF;
IF trim(NEW.chave1)::VARCHAR = '''' THEN
   NEW.chave1 := NULL;
END IF;
IF trim(NEW.chave2)::VARCHAR = '''' THEN
   NEW.chave2 := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_del
BEFORE INSERT OR UPDATE ON tt_del
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_del();



/*-- SEQ 6196 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_dep() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.nomarq)::VARCHAR = '''' THEN
   NEW.nomarq := NULL;
END IF;
IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;
IF trim(NEW.numage)::VARCHAR = '''' THEN
   NEW.numage := NULL;
END IF;
IF trim(NEW.ctacrr)::VARCHAR = '''' THEN
   NEW.ctacrr := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_dep
BEFORE INSERT OR UPDATE ON tt_dep
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_dep();



/*-- SEQ 6197 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_des() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filico)::VARCHAR = '''' THEN
   NEW.filico := NULL;
END IF;
IF trim(NEW.seqico)::VARCHAR = '''' THEN
   NEW.seqico := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_des
BEFORE INSERT OR UPDATE ON tt_des
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_des();



/*-- SEQ 6198 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_desxcli() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filven)::VARCHAR = '''' THEN
   NEW.filven := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.filpgt)::VARCHAR = '''' THEN
   NEW.filpgt := NULL;
END IF;
IF trim(NEW.codpgt)::VARCHAR = '''' THEN
   NEW.codpgt := NULL;
END IF;
IF trim(NEW.tipaco)::VARCHAR = '''' THEN
   NEW.tipaco := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_desxcli
BEFORE INSERT OR UPDATE ON tt_desxcli
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_desxcli();



/*-- SEQ 6199 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_desxdccc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_desxdccc
BEFORE INSERT OR UPDATE ON tt_desxdccc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_desxdccc();



/*-- SEQ 6200 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_desxico() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filico)::VARCHAR = '''' THEN
   NEW.filico := NULL;
END IF;
IF trim(NEW.seqico)::VARCHAR = '''' THEN
   NEW.seqico := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_desxico
BEFORE INSERT OR UPDATE ON tt_desxico
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_desxico();



/*-- SEQ 6201 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_dev() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.filrec)::VARCHAR = '''' THEN
   NEW.filrec := NULL;
END IF;
IF trim(NEW.seqrec)::VARCHAR = '''' THEN
   NEW.seqrec := NULL;
END IF;
IF trim(NEW.numpar)::VARCHAR = '''' THEN
   NEW.numpar := NULL;
END IF;
IF trim(NEW.subpar)::VARCHAR = '''' THEN
   NEW.subpar := NULL;
END IF;
IF trim(NEW.filchr)::VARCHAR = '''' THEN
   NEW.filchr := NULL;
END IF;
IF trim(NEW.seqchr)::VARCHAR = '''' THEN
   NEW.seqchr := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_dev
BEFORE INSERT OR UPDATE ON tt_dev
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_dev();



/*-- SEQ 6202 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_devxrec() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.fildev)::VARCHAR = '''' THEN
   NEW.fildev := NULL;
END IF;
IF trim(NEW.seqdev)::VARCHAR = '''' THEN
   NEW.seqdev := NULL;
END IF;
IF trim(NEW.filrec)::VARCHAR = '''' THEN
   NEW.filrec := NULL;
END IF;
IF trim(NEW.seqrec)::VARCHAR = '''' THEN
   NEW.seqrec := NULL;
END IF;
IF trim(NEW.parrec)::VARCHAR = '''' THEN
   NEW.parrec := NULL;
END IF;
IF trim(NEW.subrec)::VARCHAR = '''' THEN
   NEW.subrec := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_devxrec
BEFORE INSERT OR UPDATE ON tt_devxrec
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_devxrec();



/*-- SEQ 6203 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_dis() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filfor)::VARCHAR = '''' THEN
   NEW.filfor := NULL;
END IF;
IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;
IF trim(NEW.filend)::VARCHAR = '''' THEN
   NEW.filend := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_dis
BEFORE INSERT OR UPDATE ON tt_dis
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_dis();



/*-- SEQ 6204 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_div() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.nomite)::VARCHAR = '''' THEN
   NEW.nomite := NULL;
END IF;
IF trim(NEW.nomext)::VARCHAR = '''' THEN
   NEW.nomext := NULL;
END IF;
IF trim(NEW.numrgb)::VARCHAR = '''' THEN
   NEW.numrgb := NULL;
END IF;
IF trim(NEW.imagem)::VARCHAR = '''' THEN
   NEW.imagem := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_div
BEFORE INSERT OR UPDATE ON tt_div
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_div();



/*-- SEQ 6205 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_dmtdxdcorvei() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codigo)::VARCHAR = '''' THEN
   NEW.codigo := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_dmtdxdcorvei
BEFORE INSERT OR UPDATE ON tt_dmtdxdcorvei
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_dmtdxdcorvei();



/*-- SEQ 6206 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_doe() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.codcid)::VARCHAR = '''' THEN
   NEW.codcid := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_doe
BEFORE INSERT OR UPDATE ON tt_doe
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_doe();



/*-- SEQ 6207 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_dom() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codarq)::VARCHAR = '''' THEN
   NEW.codarq := NULL;
END IF;
IF trim(NEW.nomcpo)::VARCHAR = '''' THEN
   NEW.nomcpo := NULL;
END IF;
IF trim(NEW.desdom)::VARCHAR = '''' THEN
   NEW.desdom := NULL;
END IF;
IF trim(NEW.estrel)::VARCHAR = '''' THEN
   NEW.estrel := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_dom
BEFORE INSERT OR UPDATE ON tt_dom
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_dom();



/*-- SEQ 6208 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_dop() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.fildes)::VARCHAR = '''' THEN
   NEW.fildes := NULL;
END IF;
IF trim(NEW.filrdp)::VARCHAR = '''' THEN
   NEW.filrdp := NULL;
END IF;
IF trim(NEW.seqrdp)::VARCHAR = '''' THEN
   NEW.seqrdp := NULL;
END IF;
IF trim(NEW.chetro)::VARCHAR = '''' THEN
   NEW.chetro := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.obsint)::VARCHAR = '''' THEN
   NEW.obsint := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.seqexc)::VARCHAR = '''' THEN
   NEW.seqexc := NULL;
END IF;
IF trim(NEW.filven)::VARCHAR = '''' THEN
   NEW.filven := NULL;
END IF;
IF trim(NEW.seqven)::VARCHAR = '''' THEN
   NEW.seqven := NULL;
END IF;
IF trim(NEW.filcbp)::VARCHAR = '''' THEN
   NEW.filcbp := NULL;
END IF;
IF trim(NEW.seqcbp)::VARCHAR = '''' THEN
   NEW.seqcbp := NULL;
END IF;
IF trim(NEW.codbar)::VARCHAR = '''' THEN
   NEW.codbar := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.expem4)::VARCHAR = '''' THEN
   NEW.expem4 := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_dop
BEFORE INSERT OR UPDATE ON tt_dop
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_dop();



/*-- SEQ 6209 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_dou() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.nomdou)::VARCHAR = '''' THEN
   NEW.nomdou := NULL;
END IF;
IF trim(NEW.uf_crm)::VARCHAR = '''' THEN
   NEW.uf_crm := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_dou
BEFORE INSERT OR UPDATE ON tt_dou
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_dou();



/*-- SEQ 6210 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_dow() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.seqdow)::VARCHAR = '''' THEN
   NEW.seqdow := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.estdow)::VARCHAR = '''' THEN
   NEW.estdow := NULL;
END IF;
IF trim(NEW.sitdow)::VARCHAR = '''' THEN
   NEW.sitdow := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_dow
BEFORE INSERT OR UPDATE ON tt_dow
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_dow();



/*-- SEQ 6211 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_dro() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.coddro)::VARCHAR = '''' THEN
   NEW.coddro := NULL;
END IF;
IF trim(NEW.desdro)::VARCHAR = '''' THEN
   NEW.desdro := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_dro
BEFORE INSERT OR UPDATE ON tt_dro
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_dro();



/*-- SEQ 6212 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_dru() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.coddro)::VARCHAR = '''' THEN
   NEW.coddro := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_dru
BEFORE INSERT OR UPDATE ON tt_dru
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_dru();



/*-- SEQ 6213 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_dsp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filpre)::VARCHAR = '''' THEN
   NEW.filpre := NULL;
END IF;
IF trim(NEW.tabela)::VARCHAR = '''' THEN
   NEW.tabela := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_dsp
BEFORE INSERT OR UPDATE ON tt_dsp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_dsp();



/*-- SEQ 6214 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_dxc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_dxc
BEFORE INSERT OR UPDATE ON tt_dxc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_dxc();



/*-- SEQ 6215 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_dxg() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filfor)::VARCHAR = '''' THEN
   NEW.filfor := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_dxg
BEFORE INSERT OR UPDATE ON tt_dxg
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_dxg();



/*-- SEQ 6216 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_dxi() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.seqipe)::VARCHAR = '''' THEN
   NEW.seqipe := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_dxi
BEFORE INSERT OR UPDATE ON tt_dxi
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_dxi();



/*-- SEQ 6217 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ean() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codean)::VARCHAR = '''' THEN
   NEW.codean := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ean
BEFORE INSERT OR UPDATE ON tt_ean
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ean();



/*-- SEQ 6218 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ecb() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;
IF trim(NEW.sigecb)::VARCHAR = '''' THEN
   NEW.sigecb := NULL;
END IF;
IF trim(NEW.desecb)::VARCHAR = '''' THEN
   NEW.desecb := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ecb
BEFORE INSERT OR UPDATE ON tt_ecb
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ecb();



/*-- SEQ 6219 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ecf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.totali)::VARCHAR = '''' THEN
   NEW.totali := NULL;
END IF;
IF trim(NEW.numser)::VARCHAR = '''' THEN
   NEW.numser := NULL;
END IF;
IF trim(NEW.tiptot)::VARCHAR = '''' THEN
   NEW.tiptot := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.totpar)::VARCHAR = '''' THEN
   NEW.totpar := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;
IF trim(NEW.expfis)::VARCHAR = '''' THEN
   NEW.expfis := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ecf
BEFORE INSERT OR UPDATE ON tt_ecf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ecf();



/*-- SEQ 6220 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ect() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.titect)::VARCHAR = '''' THEN
   NEW.titect := NULL;
END IF;
IF trim(NEW.filect)::VARCHAR = '''' THEN
   NEW.filect := NULL;
END IF;
IF trim(NEW.seqect)::VARCHAR = '''' THEN
   NEW.seqect := NULL;
END IF;
IF trim(NEW.chvprj)::VARCHAR = '''' THEN
   NEW.chvprj := NULL;
END IF;
IF trim(NEW.chvpai)::VARCHAR = '''' THEN
   NEW.chvpai := NULL;
END IF;
IF trim(NEW.arvore)::VARCHAR = '''' THEN
   NEW.arvore := NULL;
END IF;
IF trim(NEW.usocta)::VARCHAR = '''' THEN
   NEW.usocta := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ect
BEFORE INSERT OR UPDATE ON tt_ect
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ect();



/*-- SEQ 6221 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_edi() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.filest)::VARCHAR = '''' THEN
   NEW.filest := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_edi
BEFORE INSERT OR UPDATE ON tt_edi
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_edi();



/*-- SEQ 6222 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_end() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.endcob)::VARCHAR = '''' THEN
   NEW.endcob := NULL;
END IF;
IF trim(NEW.endcor)::VARCHAR = '''' THEN
   NEW.endcor := NULL;
END IF;
IF trim(NEW.flgnac)::VARCHAR = '''' THEN
   NEW.flgnac := NULL;
END IF;
IF trim(NEW.sigest)::VARCHAR = '''' THEN
   NEW.sigest := NULL;
END IF;
IF trim(NEW.codlog)::VARCHAR = '''' THEN
   NEW.codlog := NULL;
END IF;
IF trim(NEW.codcid)::VARCHAR = '''' THEN
   NEW.codcid := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.insest)::VARCHAR = '''' THEN
   NEW.insest := NULL;
END IF;
IF trim(NEW.numero)::VARCHAR = '''' THEN
   NEW.numero := NULL;
END IF;
IF trim(NEW.nomcid)::VARCHAR = '''' THEN
   NEW.nomcid := NULL;
END IF;
IF trim(NEW.bairro)::VARCHAR = '''' THEN
   NEW.bairro := NULL;
END IF;
IF trim(NEW.comple)::VARCHAR = '''' THEN
   NEW.comple := NULL;
END IF;
IF trim(NEW.estran)::VARCHAR = '''' THEN
   NEW.estran := NULL;
END IF;
IF trim(NEW.contat)::VARCHAR = '''' THEN
   NEW.contat := NULL;
END IF;
IF trim(NEW.loctra)::VARCHAR = '''' THEN
   NEW.loctra := NULL;
END IF;
IF trim(NEW.endere)::VARCHAR = '''' THEN
   NEW.endere := NULL;
END IF;
IF trim(NEW.codddd)::VARCHAR = '''' THEN
   NEW.codddd := NULL;
END IF;
IF trim(NEW.dddfax)::VARCHAR = '''' THEN
   NEW.dddfax := NULL;
END IF;
IF trim(NEW.codcep)::VARCHAR = '''' THEN
   NEW.codcep := NULL;
END IF;
IF trim(NEW.numfax)::VARCHAR = '''' THEN
   NEW.numfax := NULL;
END IF;
IF trim(NEW.usa_nf)::VARCHAR = '''' THEN
   NEW.usa_nf := NULL;
END IF;
IF trim(NEW.numfon)::VARCHAR = '''' THEN
   NEW.numfon := NULL;
END IF;
IF trim(NEW.tiparc)::VARCHAR = '''' THEN
   NEW.tiparc := NULL;
END IF;
IF trim(NEW.insmun)::VARCHAR = '''' THEN
   NEW.insmun := NULL;
END IF;
IF trim(NEW.codddi)::VARCHAR = '''' THEN
   NEW.codddi := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.fil_ck)::VARCHAR = '''' THEN
   NEW.fil_ck := NULL;
END IF;
IF trim(NEW.ecf_ck)::VARCHAR = '''' THEN
   NEW.ecf_ck := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.nomrec)::VARCHAR = '''' THEN
   NEW.nomrec := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_end
BEFORE INSERT OR UPDATE ON tt_end
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_end();



/*-- SEQ 6223 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_enp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.filend)::VARCHAR = '''' THEN
   NEW.filend := NULL;
END IF;
IF trim(NEW.filpre)::VARCHAR = '''' THEN
   NEW.filpre := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_enp
BEFORE INSERT OR UPDATE ON tt_enp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_enp();



/*-- SEQ 6224 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_enq() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.grucst)::VARCHAR = '''' THEN
   NEW.grucst := NULL;
END IF;
IF trim(NEW.desenq)::VARCHAR = '''' THEN
   NEW.desenq := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_enq
BEFORE INSERT OR UPDATE ON tt_enq
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_enq();



/*-- SEQ 6225 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_env() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.nomarq)::VARCHAR = '''' THEN
   NEW.nomarq := NULL;
END IF;
IF trim(NEW.nommaq)::VARCHAR = '''' THEN
   NEW.nommaq := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_env
BEFORE INSERT OR UPDATE ON tt_env
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_env();



/*-- SEQ 6226 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_eqp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filteq)::VARCHAR = '''' THEN
   NEW.filteq := NULL;
END IF;
IF trim(NEW.seqteq)::VARCHAR = '''' THEN
   NEW.seqteq := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.filend)::VARCHAR = '''' THEN
   NEW.filend := NULL;
END IF;
IF trim(NEW.numser)::VARCHAR = '''' THEN
   NEW.numser := NULL;
END IF;
IF trim(NEW.deseqp)::VARCHAR = '''' THEN
   NEW.deseqp := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.filctt)::VARCHAR = '''' THEN
   NEW.filctt := NULL;
END IF;
IF trim(NEW.seqctt)::VARCHAR = '''' THEN
   NEW.seqctt := NULL;
END IF;
IF trim(NEW.fileqp)::VARCHAR = '''' THEN
   NEW.fileqp := NULL;
END IF;
IF trim(NEW.seqeqp)::VARCHAR = '''' THEN
   NEW.seqeqp := NULL;
END IF;
IF trim(NEW.filmar)::VARCHAR = '''' THEN
   NEW.filmar := NULL;
END IF;
IF trim(NEW.codmar)::VARCHAR = '''' THEN
   NEW.codmar := NULL;
END IF;
IF trim(NEW.locali)::VARCHAR = '''' THEN
   NEW.locali := NULL;
END IF;
IF trim(NEW.desmar)::VARCHAR = '''' THEN
   NEW.desmar := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_eqp
BEFORE INSERT OR UPDATE ON tt_eqp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_eqp();



/*-- SEQ 6227 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_err() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.seqlcf)::VARCHAR = '''' THEN
   NEW.seqlcf := NULL;
END IF;
IF trim(NEW.txterr)::VARCHAR = '''' THEN
   NEW.txterr := NULL;
END IF;
IF trim(NEW.xmltra)::VARCHAR = '''' THEN
   NEW.xmltra := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_err
BEFORE INSERT OR UPDATE ON tt_err
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_err();



/*-- SEQ 6228 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_est() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_est
BEFORE INSERT OR UPDATE ON tt_est
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_est();



/*-- SEQ 6229 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_eti() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_eti
BEFORE INSERT OR UPDATE ON tt_eti
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_eti();



/*-- SEQ 6230 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_exp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_exp
BEFORE INSERT OR UPDATE ON tt_exp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_exp();



/*-- SEQ 6231 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ext() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;
IF trim(NEW.numage)::VARCHAR = '''' THEN
   NEW.numage := NULL;
END IF;
IF trim(NEW.ctacrr)::VARCHAR = '''' THEN
   NEW.ctacrr := NULL;
END IF;
IF trim(NEW.seqarq)::VARCHAR = '''' THEN
   NEW.seqarq := NULL;
END IF;
IF trim(NEW.seqext)::VARCHAR = '''' THEN
   NEW.seqext := NULL;
END IF;
IF trim(NEW.gruarq)::VARCHAR = '''' THEN
   NEW.gruarq := NULL;
END IF;
IF trim(NEW.filimp)::VARCHAR = '''' THEN
   NEW.filimp := NULL;
END IF;
IF trim(NEW.codimp)::VARCHAR = '''' THEN
   NEW.codimp := NULL;
END IF;
IF trim(NEW.nomarq)::VARCHAR = '''' THEN
   NEW.nomarq := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ext
BEFORE INSERT OR UPDATE ON tt_ext
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ext();



/*-- SEQ 6232 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_fcp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filmed)::VARCHAR = '''' THEN
   NEW.filmed := NULL;
END IF;
IF trim(NEW.fillei)::VARCHAR = '''' THEN
   NEW.fillei := NULL;
END IF;
IF trim(NEW.codlei)::VARCHAR = '''' THEN
   NEW.codlei := NULL;
END IF;
IF trim(NEW.filreg)::VARCHAR = '''' THEN
   NEW.filreg := NULL;
END IF;
IF trim(NEW.codreg)::VARCHAR = '''' THEN
   NEW.codreg := NULL;
END IF;
IF trim(NEW.origem)::VARCHAR = '''' THEN
   NEW.origem := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_fcp
BEFORE INSERT OR UPDATE ON tt_fcp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_fcp();



/*-- SEQ 6233 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_fer() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.motivo)::VARCHAR = '''' THEN
   NEW.motivo := NULL;
END IF;
IF trim(NEW.filfer)::VARCHAR = '''' THEN
   NEW.filfer := NULL;
END IF;
IF trim(NEW.lojabr)::VARCHAR = '''' THEN
   NEW.lojabr := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_fer
BEFORE INSERT OR UPDATE ON tt_fer
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_fer();



/*-- SEQ 6234 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_fid() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.cgcfil)::VARCHAR = '''' THEN
   NEW.cgcfil := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;
IF trim(NEW.reserv)::VARCHAR = '''' THEN
   NEW.reserv := NULL;
END IF;
IF trim(NEW.rescon)::VARCHAR = '''' THEN
   NEW.rescon := NULL;
END IF;
IF trim(NEW.rescan)::VARCHAR = '''' THEN
   NEW.rescan := NULL;
END IF;
IF trim(NEW.vendev)::VARCHAR = '''' THEN
   NEW.vendev := NULL;
END IF;
IF trim(NEW.status)::VARCHAR = '''' THEN
   NEW.status := NULL;
END IF;
IF trim(NEW.oriped)::VARCHAR = '''' THEN
   NEW.oriped := NULL;
END IF;
IF trim(NEW.destat)::VARCHAR = '''' THEN
   NEW.destat := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_fid
BEFORE INSERT OR UPDATE ON tt_fid
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_fid();



/*-- SEQ 6235 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_filxpla() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filpgt)::VARCHAR = '''' THEN
   NEW.filpgt := NULL;
END IF;
IF trim(NEW.codpgt)::VARCHAR = '''' THEN
   NEW.codpgt := NULL;
END IF;
IF trim(NEW.filsel)::VARCHAR = '''' THEN
   NEW.filsel := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_filxpla
BEFORE INSERT OR UPDATE ON tt_filxpla
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_filxpla();



/*-- SEQ 6236 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_fin() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.tipger)::VARCHAR = '''' THEN
   NEW.tipger := NULL;
END IF;
IF trim(NEW.tipnum)::VARCHAR = '''' THEN
   NEW.tipnum := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filger)::VARCHAR = '''' THEN
   NEW.filger := NULL;
END IF;
IF trim(NEW.filnum)::VARCHAR = '''' THEN
   NEW.filnum := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.seqger)::VARCHAR = '''' THEN
   NEW.seqger := NULL;
END IF;
IF trim(NEW.seqnum)::VARCHAR = '''' THEN
   NEW.seqnum := NULL;
END IF;
IF trim(NEW.seqtrn)::VARCHAR = '''' THEN
   NEW.seqtrn := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.flgfin)::VARCHAR = '''' THEN
   NEW.flgfin := NULL;
END IF;
IF trim(NEW.chvtrn)::VARCHAR = '''' THEN
   NEW.chvtrn := NULL;
END IF;
IF trim(NEW.filchr)::VARCHAR = '''' THEN
   NEW.filchr := NULL;
END IF;
IF trim(NEW.seqchr)::VARCHAR = '''' THEN
   NEW.seqchr := NULL;
END IF;
IF trim(NEW.filccc)::VARCHAR = '''' THEN
   NEW.filccc := NULL;
END IF;
IF trim(NEW.seqccc)::VARCHAR = '''' THEN
   NEW.seqccc := NULL;
END IF;
IF trim(NEW.orilan)::VARCHAR = '''' THEN
   NEW.orilan := NULL;
END IF;
IF trim(NEW.filrec)::VARCHAR = '''' THEN
   NEW.filrec := NULL;
END IF;
IF trim(NEW.filest)::VARCHAR = '''' THEN
   NEW.filest := NULL;
END IF;
IF trim(NEW.seqest)::VARCHAR = '''' THEN
   NEW.seqest := NULL;
END IF;
IF trim(NEW.chvtrn2)::VARCHAR = '''' THEN
   NEW.chvtrn2 := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.doc_id)::VARCHAR = '''' THEN
   NEW.doc_id := NULL;
END IF;
IF trim(NEW.filusu_rec)::VARCHAR = '''' THEN
   NEW.filusu_rec := NULL;
END IF;
IF trim(NEW.codusu_rec)::VARCHAR = '''' THEN
   NEW.codusu_rec := NULL;
END IF;
IF trim(NEW.expem4)::VARCHAR = '''' THEN
   NEW.expem4 := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_fin
BEFORE INSERT OR UPDATE ON tt_fin
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_fin();



/*-- SEQ 6237 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_fis() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.origem)::VARCHAR = '''' THEN
   NEW.origem := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;
IF trim(NEW.modnot)::VARCHAR = '''' THEN
   NEW.modnot := NULL;
END IF;
IF trim(NEW.subexp)::VARCHAR = '''' THEN
   NEW.subexp := NULL;
END IF;
IF trim(NEW.serexp)::VARCHAR = '''' THEN
   NEW.serexp := NULL;
END IF;
IF trim(NEW.nomser)::VARCHAR = '''' THEN
   NEW.nomser := NULL;
END IF;
IF trim(NEW.serati)::VARCHAR = '''' THEN
   NEW.serati := NULL;
END IF;
IF trim(NEW.espdoc)::VARCHAR = '''' THEN
   NEW.espdoc := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_fis
BEFORE INSERT OR UPDATE ON tt_fis
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_fis();



/*-- SEQ 6238 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_flw() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_flw
BEFORE INSERT OR UPDATE ON tt_flw
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_flw();



/*-- SEQ 6239 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_frexcom() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filfre)::VARCHAR = '''' THEN
   NEW.filfre := NULL;
END IF;
IF trim(NEW.seqfre)::VARCHAR = '''' THEN
   NEW.seqfre := NULL;
END IF;
IF trim(NEW.filcom)::VARCHAR = '''' THEN
   NEW.filcom := NULL;
END IF;
IF trim(NEW.seqcom)::VARCHAR = '''' THEN
   NEW.seqcom := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_frexcom
BEFORE INSERT OR UPDATE ON tt_frexcom
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_frexcom();



/*-- SEQ 6240 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_frm() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.formul)::VARCHAR = '''' THEN
   NEW.formul := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_frm
BEFORE INSERT OR UPDATE ON tt_frm
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_frm();



/*-- SEQ 6241 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_fro() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desfro)::VARCHAR = '''' THEN
   NEW.desfro := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_fro
BEFORE INSERT OR UPDATE ON tt_fro
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_fro();



/*-- SEQ 6242 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_frp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_frp
BEFORE INSERT OR UPDATE ON tt_frp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_frp();



/*-- SEQ 6243 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ftr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filpla)::VARCHAR = '''' THEN
   NEW.filpla := NULL;
END IF;
IF trim(NEW.codpla)::VARCHAR = '''' THEN
   NEW.codpla := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ftr
BEFORE INSERT OR UPDATE ON tt_ftr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ftr();



/*-- SEQ 6244 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_fun() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.nomfun)::VARCHAR = '''' THEN
   NEW.nomfun := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_fun
BEFORE INSERT OR UPDATE ON tt_fun
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_fun();



/*-- SEQ 6245 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_fxc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_fxc
BEFORE INSERT OR UPDATE ON tt_fxc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_fxc();



/*-- SEQ 6246 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_gab() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.desgab)::VARCHAR = '''' THEN
   NEW.desgab := NULL;
END IF;
IF trim(NEW.estrur)::VARCHAR = '''' THEN
   NEW.estrur := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_gab
BEFORE INSERT OR UPDATE ON tt_gab
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_gab();



/*-- SEQ 6247 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_gatxapl() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcpr)::VARCHAR = '''' THEN
   NEW.filcpr := NULL;
END IF;
IF trim(NEW.seqcpr)::VARCHAR = '''' THEN
   NEW.seqcpr := NULL;
END IF;
IF trim(NEW.seqgat)::VARCHAR = '''' THEN
   NEW.seqgat := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.tipapl)::VARCHAR = '''' THEN
   NEW.tipapl := NULL;
END IF;
IF trim(NEW.mulapl)::VARCHAR = '''' THEN
   NEW.mulapl := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_gatxapl
BEFORE INSERT OR UPDATE ON tt_gatxapl
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_gatxapl();



/*-- SEQ 6248 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_gatxcli() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcpr)::VARCHAR = '''' THEN
   NEW.filcpr := NULL;
END IF;
IF trim(NEW.seqcpr)::VARCHAR = '''' THEN
   NEW.seqcpr := NULL;
END IF;
IF trim(NEW.seqgat)::VARCHAR = '''' THEN
   NEW.seqgat := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_gatxcli
BEFORE INSERT OR UPDATE ON tt_gatxcli
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_gatxcli();



/*-- SEQ 6249 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_gatxpro() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcpr)::VARCHAR = '''' THEN
   NEW.filcpr := NULL;
END IF;
IF trim(NEW.seqcpr)::VARCHAR = '''' THEN
   NEW.seqcpr := NULL;
END IF;
IF trim(NEW.seqgat)::VARCHAR = '''' THEN
   NEW.seqgat := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_gatxpro
BEFORE INSERT OR UPDATE ON tt_gatxpro
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_gatxpro();



/*-- SEQ 6250 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_gra() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.promoc)::VARCHAR = '''' THEN
   NEW.promoc := NULL;
END IF;
IF trim(NEW.voluni)::VARCHAR = '''' THEN
   NEW.voluni := NULL;
END IF;
IF trim(NEW.refpro)::VARCHAR = '''' THEN
   NEW.refpro := NULL;
END IF;
IF trim(NEW.filcom)::VARCHAR = '''' THEN
   NEW.filcom := NULL;
END IF;
IF trim(NEW.locali)::VARCHAR = '''' THEN
   NEW.locali := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.seqcom)::VARCHAR = '''' THEN
   NEW.seqcom := NULL;
END IF;
IF trim(NEW.forlin)::VARCHAR = '''' THEN
   NEW.forlin := NULL;
END IF;
IF trim(NEW.prepsi)::VARCHAR = '''' THEN
   NEW.prepsi := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.filped)::VARCHAR = '''' THEN
   NEW.filped := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.oricus)::VARCHAR = '''' THEN
   NEW.oricus := NULL;
END IF;
IF trim(NEW.graati)::VARCHAR = '''' THEN
   NEW.graati := NULL;
END IF;
IF trim(NEW.icmtip)::VARCHAR = '''' THEN
   NEW.icmtip := NULL;
END IF;
IF trim(NEW.forpre)::VARCHAR = '''' THEN
   NEW.forpre := NULL;
END IF;
IF trim(NEW.codncm)::VARCHAR = '''' THEN
   NEW.codncm := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;
IF trim(NEW.destaq)::VARCHAR = '''' THEN
   NEW.destaq := NULL;
END IF;
IF trim(NEW.codfis)::VARCHAR = '''' THEN
   NEW.codfis := NULL;
END IF;
IF trim(NEW.usabon)::VARCHAR = '''' THEN
   NEW.usabon := NULL;
END IF;
IF trim(NEW.filres)::VARCHAR = '''' THEN
   NEW.filres := NULL;
END IF;
IF trim(NEW.graabc)::VARCHAR = '''' THEN
   NEW.graabc := NULL;
END IF;
IF trim(NEW.graxyz)::VARCHAR = '''' THEN
   NEW.graxyz := NULL;
END IF;
IF trim(NEW.enveco)::VARCHAR = '''' THEN
   NEW.enveco := NULL;
END IF;
IF trim(NEW.imggru)::VARCHAR = '''' THEN
   NEW.imggru := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.desgra)::VARCHAR = '''' THEN
   NEW.desgra := NULL;
END IF;
IF trim(NEW.codpos_gra)::VARCHAR = '''' THEN
   NEW.codpos_gra := NULL;
END IF;
IF trim(NEW.skyhub)::VARCHAR = '''' THEN
   NEW.skyhub := NULL;
END IF;
IF trim(NEW.sughed)::VARCHAR = '''' THEN
   NEW.sughed := NULL;
END IF;
IF trim(NEW.gersug)::VARCHAR = '''' THEN
   NEW.gersug := NULL;
END IF;
IF trim(NEW.filcom_ant)::VARCHAR = '''' THEN
   NEW.filcom_ant := NULL;
END IF;
IF trim(NEW.seqcom_ant)::VARCHAR = '''' THEN
   NEW.seqcom_ant := NULL;
END IF;
IF trim(NEW.flgrep)::VARCHAR = '''' THEN
   NEW.flgrep := NULL;
END IF;
IF trim(NEW.tippin)::VARCHAR = '''' THEN
   NEW.tippin := NULL;
END IF;
IF trim(NEW.convin)::VARCHAR = '''' THEN
   NEW.convin := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_gra
BEFORE INSERT OR UPDATE ON tt_gra
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_gra();



/*-- SEQ 6251 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_graxdcar() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.tipcar)::VARCHAR = '''' THEN
   NEW.tipcar := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.protef)::VARCHAR = '''' THEN
   NEW.protef := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_graxdcar
BEFORE INSERT OR UPDATE ON tt_graxdcar
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_graxdcar();



/*-- SEQ 6252 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_graxmdv() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_graxmdv
BEFORE INSERT OR UPDATE ON tt_graxmdv
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_graxmdv();



/*-- SEQ 6253 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_graxsc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_graxsc
BEFORE INSERT OR UPDATE ON tt_graxsc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_graxsc();



/*-- SEQ 6254 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_gru() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codtab)::VARCHAR = '''' THEN
   NEW.codtab := NULL;
END IF;
IF trim(NEW.codgru)::VARCHAR = '''' THEN
   NEW.codgru := NULL;
END IF;
IF trim(NEW.desgru)::VARCHAR = '''' THEN
   NEW.desgru := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_gru
BEFORE INSERT OR UPDATE ON tt_gru
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_gru();



/*-- SEQ 6255 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_guarda() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.gua_codfil)::VARCHAR = '''' THEN
   NEW.gua_codfil := NULL;
END IF;
IF trim(NEW.gua_numecf)::VARCHAR = '''' THEN
   NEW.gua_numecf := NULL;
END IF;
IF trim(NEW.gua_numnot)::VARCHAR = '''' THEN
   NEW.gua_numnot := NULL;
END IF;
IF trim(NEW.gua_msg)::VARCHAR = '''' THEN
   NEW.gua_msg := NULL;
END IF;
IF trim(NEW.gua_situacao)::VARCHAR = '''' THEN
   NEW.gua_situacao := NULL;
END IF;
IF trim(NEW.gua_modfis)::VARCHAR = '''' THEN
   NEW.gua_modfis := NULL;
END IF;
IF trim(NEW.gua_chavea)::VARCHAR = '''' THEN
   NEW.gua_chavea := NULL;
END IF;
IF trim(NEW.gua_codser)::VARCHAR = '''' THEN
   NEW.gua_codser := NULL;
END IF;
IF trim(NEW.gua_protocolo)::VARCHAR = '''' THEN
   NEW.gua_protocolo := NULL;
END IF;
IF trim(NEW.gua_cnpj)::VARCHAR = '''' THEN
   NEW.gua_cnpj := NULL;
END IF;
IF trim(NEW.gua_protocolocanc)::VARCHAR = '''' THEN
   NEW.gua_protocolocanc := NULL;
END IF;
IF trim(NEW.gua_lote)::VARCHAR = '''' THEN
   NEW.gua_lote := NULL;
END IF;
IF trim(NEW.gua_nfsenumero)::VARCHAR = '''' THEN
   NEW.gua_nfsenumero := NULL;
END IF;
IF trim(NEW.gua_nfsecodigoverificacao)::VARCHAR = '''' THEN
   NEW.gua_nfsecodigoverificacao := NULL;
END IF;
IF trim(NEW.gua_nfsecodigocancelamento)::VARCHAR = '''' THEN
   NEW.gua_nfsecodigocancelamento := NULL;
END IF;
IF trim(NEW.gua_recibo)::VARCHAR = '''' THEN
   NEW.gua_recibo := NULL;
END IF;
IF trim(NEW.gua_xml_canc)::VARCHAR = '''' THEN
   NEW.gua_xml_canc := NULL;
END IF;
IF trim(NEW.gua_xml)::VARCHAR = '''' THEN
   NEW.gua_xml := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_guarda
BEFORE INSERT OR UPDATE ON tt_guarda
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_guarda();



/*-- SEQ 6256 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_hnd() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.server)::VARCHAR = '''' THEN
   NEW.server := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.nomcom)::VARCHAR = '''' THEN
   NEW.nomcom := NULL;
END IF;
IF trim(NEW.nomcon)::VARCHAR = '''' THEN
   NEW.nomcon := NULL;
END IF;
IF trim(NEW.sqltxt)::VARCHAR = '''' THEN
   NEW.sqltxt := NULL;
END IF;
IF trim(NEW.logcon)::VARCHAR = '''' THEN
   NEW.logcon := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_hnd
BEFORE INSERT OR UPDATE ON tt_hnd
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_hnd();



/*-- SEQ 6257 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_hor() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.tiptra)::VARCHAR = '''' THEN
   NEW.tiptra := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.filsup)::VARCHAR = '''' THEN
   NEW.filsup := NULL;
END IF;
IF trim(NEW.seqsup)::VARCHAR = '''' THEN
   NEW.seqsup := NULL;
END IF;
IF trim(NEW.seqwor)::VARCHAR = '''' THEN
   NEW.seqwor := NULL;
END IF;
IF trim(NEW.destra)::VARCHAR = '''' THEN
   NEW.destra := NULL;
END IF;
IF trim(NEW.filrat)::VARCHAR = '''' THEN
   NEW.filrat := NULL;
END IF;
IF trim(NEW.seqrat)::VARCHAR = '''' THEN
   NEW.seqrat := NULL;
END IF;
IF trim(NEW.fatura)::VARCHAR = '''' THEN
   NEW.fatura := NULL;
END IF;
IF trim(NEW.filrev)::VARCHAR = '''' THEN
   NEW.filrev := NULL;
END IF;
IF trim(NEW.codrev)::VARCHAR = '''' THEN
   NEW.codrev := NULL;
END IF;
IF trim(NEW.pagtec)::VARCHAR = '''' THEN
   NEW.pagtec := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_hor
BEFORE INSERT OR UPDATE ON tt_hor
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_hor();



/*-- SEQ 6258 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_hre() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.filend)::VARCHAR = '''' THEN
   NEW.filend := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_hre
BEFORE INSERT OR UPDATE ON tt_hre
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_hre();



/*-- SEQ 6259 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_htb() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.digage)::VARCHAR = '''' THEN
   NEW.digage := NULL;
END IF;
IF trim(NEW.diga_c)::VARCHAR = '''' THEN
   NEW.diga_c := NULL;
END IF;
IF trim(NEW.dig_cc)::VARCHAR = '''' THEN
   NEW.dig_cc := NULL;
END IF;
IF trim(NEW.tipser)::VARCHAR = '''' THEN
   NEW.tipser := NULL;
END IF;
IF trim(NEW.idevan)::VARCHAR = '''' THEN
   NEW.idevan := NULL;
END IF;
IF trim(NEW.ococsp)::VARCHAR = '''' THEN
   NEW.ococsp := NULL;
END IF;
IF trim(NEW.camemp)::VARCHAR = '''' THEN
   NEW.camemp := NULL;
END IF;
IF trim(NEW.conven)::VARCHAR = '''' THEN
   NEW.conven := NULL;
END IF;
IF trim(NEW.nombco)::VARCHAR = '''' THEN
   NEW.nombco := NULL;
END IF;
IF trim(NEW.nomemp)::VARCHAR = '''' THEN
   NEW.nomemp := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_htb
BEFORE INSERT OR UPDATE ON tt_htb
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_htb();



/*-- SEQ 6260 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_iag() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.coment)::VARCHAR = '''' THEN
   NEW.coment := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_iag
BEFORE INSERT OR UPDATE ON tt_iag
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_iag();



/*-- SEQ 6261 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ibd() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.nomibd)::VARCHAR = '''' THEN
   NEW.nomibd := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ibd
BEFORE INSERT OR UPDATE ON tt_ibd
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ibd();



/*-- SEQ 6262 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ibg() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.nommun)::VARCHAR = '''' THEN
   NEW.nommun := NULL;
END IF;
IF trim(NEW.sigest)::VARCHAR = '''' THEN
   NEW.sigest := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ibg
BEFORE INSERT OR UPDATE ON tt_ibg
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ibg();



/*-- SEQ 6263 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ibp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codigo)::VARCHAR = '''' THEN
   NEW.codigo := NULL;
END IF;
IF trim(NEW.chave)::VARCHAR = '''' THEN
   NEW.chave := NULL;
END IF;
IF trim(NEW.versao)::VARCHAR = '''' THEN
   NEW.versao := NULL;
END IF;
IF trim(NEW.fonte)::VARCHAR = '''' THEN
   NEW.fonte := NULL;
END IF;
IF trim(NEW.sigest)::VARCHAR = '''' THEN
   NEW.sigest := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ibp
BEFORE INSERT OR UPDATE ON tt_ibp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ibp();



/*-- SEQ 6264 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_icf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.codite)::VARCHAR = '''' THEN
   NEW.codite := NULL;
END IF;
IF trim(NEW.desmat)::VARCHAR = '''' THEN
   NEW.desmat := NULL;
END IF;
IF trim(NEW.unidad)::VARCHAR = '''' THEN
   NEW.unidad := NULL;
END IF;
IF trim(NEW.codtot)::VARCHAR = '''' THEN
   NEW.codtot := NULL;
END IF;
IF trim(NEW.flgcan)::VARCHAR = '''' THEN
   NEW.flgcan := NULL;
END IF;
IF trim(NEW.arrtru)::VARCHAR = '''' THEN
   NEW.arrtru := NULL;
END IF;
IF trim(NEW.decqtd)::VARCHAR = '''' THEN
   NEW.decqtd := NULL;
END IF;
IF trim(NEW.decuni)::VARCHAR = '''' THEN
   NEW.decuni := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.msglog)::VARCHAR = '''' THEN
   NEW.msglog := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_icf
BEFORE INSERT OR UPDATE ON tt_icf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_icf();



/*-- SEQ 6265 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_icm() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codcid)::VARCHAR = '''' THEN
   NEW.codcid := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_icm
BEFORE INSERT OR UPDATE ON tt_icm
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_icm();



/*-- SEQ 6266 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ico() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.lanest)::VARCHAR = '''' THEN
   NEW.lanest := NULL;
END IF;
IF trim(NEW.sitmov)::VARCHAR = '''' THEN
   NEW.sitmov := NULL;
END IF;
IF trim(NEW.tippro)::VARCHAR = '''' THEN
   NEW.tippro := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.codbus)::VARCHAR = '''' THEN
   NEW.codbus := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;
IF trim(NEW.com_atucus)::VARCHAR = '''' THEN
   NEW.com_atucus := NULL;
END IF;
IF trim(NEW.atufre)::VARCHAR = '''' THEN
   NEW.atufre := NULL;
END IF;
IF trim(NEW.icmtip)::VARCHAR = '''' THEN
   NEW.icmtip := NULL;
END IF;
IF trim(NEW.retsub)::VARCHAR = '''' THEN
   NEW.retsub := NULL;
END IF;
IF trim(NEW.sitipi)::VARCHAR = '''' THEN
   NEW.sitipi := NULL;
END IF;
IF trim(NEW.codcst)::VARCHAR = '''' THEN
   NEW.codcst := NULL;
END IF;
IF trim(NEW.sitpis)::VARCHAR = '''' THEN
   NEW.sitpis := NULL;
END IF;
IF trim(NEW.sitcof)::VARCHAR = '''' THEN
   NEW.sitcof := NULL;
END IF;
IF trim(NEW.codcstdif)::VARCHAR = '''' THEN
   NEW.codcstdif := NULL;
END IF;
IF trim(NEW.natbcc)::VARCHAR = '''' THEN
   NEW.natbcc := NULL;
END IF;
IF trim(NEW.fillot)::VARCHAR = '''' THEN
   NEW.fillot := NULL;
END IF;
IF trim(NEW.seqlot)::VARCHAR = '''' THEN
   NEW.seqlot := NULL;
END IF;
IF trim(NEW.expfis)::VARCHAR = '''' THEN
   NEW.expfis := NULL;
END IF;
IF trim(NEW.cstxml)::VARCHAR = '''' THEN
   NEW.cstxml := NULL;
END IF;
IF trim(NEW.codfci)::VARCHAR = '''' THEN
   NEW.codfci := NULL;
END IF;
IF trim(NEW.codben)::VARCHAR = '''' THEN
   NEW.codben := NULL;
END IF;
IF trim(NEW.com_tipccm)::VARCHAR = '''' THEN
   NEW.com_tipccm := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ico
BEFORE INSERT OR UPDATE ON tt_ico
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ico();



/*-- SEQ 6267 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_icoxirc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filico)::VARCHAR = '''' THEN
   NEW.filico := NULL;
END IF;
IF trim(NEW.seqico)::VARCHAR = '''' THEN
   NEW.seqico := NULL;
END IF;
IF trim(NEW.filirc)::VARCHAR = '''' THEN
   NEW.filirc := NULL;
END IF;
IF trim(NEW.seqirc)::VARCHAR = '''' THEN
   NEW.seqirc := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_icoxirc
BEFORE INSERT OR UPDATE ON tt_icoxirc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_icoxirc();



/*-- SEQ 6268 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_icoxlot() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filico)::VARCHAR = '''' THEN
   NEW.filico := NULL;
END IF;
IF trim(NEW.seqico)::VARCHAR = '''' THEN
   NEW.seqico := NULL;
END IF;
IF trim(NEW.fillot)::VARCHAR = '''' THEN
   NEW.fillot := NULL;
END IF;
IF trim(NEW.seqlot)::VARCHAR = '''' THEN
   NEW.seqlot := NULL;
END IF;
IF trim(NEW.fildev)::VARCHAR = '''' THEN
   NEW.fildev := NULL;
END IF;
IF trim(NEW.seqdev)::VARCHAR = '''' THEN
   NEW.seqdev := NULL;
END IF;
IF trim(NEW.sitmov)::VARCHAR = '''' THEN
   NEW.sitmov := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_icoxlot
BEFORE INSERT OR UPDATE ON tt_icoxlot
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_icoxlot();



/*-- SEQ 6269 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_icp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.filent)::VARCHAR = '''' THEN
   NEW.filent := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_icp
BEFORE INSERT OR UPDATE ON tt_icp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_icp();



/*-- SEQ 6270 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_icpxfor() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filfor)::VARCHAR = '''' THEN
   NEW.filfor := NULL;
END IF;
IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.flgven)::VARCHAR = '''' THEN
   NEW.flgven := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_icpxfor
BEFORE INSERT OR UPDATE ON tt_icpxfor
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_icpxfor();



/*-- SEQ 6271 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ict() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.cttpro)::VARCHAR = '''' THEN
   NEW.cttpro := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.fileqp)::VARCHAR = '''' THEN
   NEW.fileqp := NULL;
END IF;
IF trim(NEW.seqeqp)::VARCHAR = '''' THEN
   NEW.seqeqp := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ict
BEFORE INSERT OR UPDATE ON tt_ict
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ict();



/*-- SEQ 6272 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_idf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.manut)::VARCHAR = '''' THEN
   NEW.manut := NULL;
END IF;
IF trim(NEW.coddep)::VARCHAR = '''' THEN
   NEW.coddep := NULL;
END IF;
IF trim(NEW.codlog)::VARCHAR = '''' THEN
   NEW.codlog := NULL;
END IF;
IF trim(NEW.codloj)::VARCHAR = '''' THEN
   NEW.codloj := NULL;
END IF;
IF trim(NEW.codcep)::VARCHAR = '''' THEN
   NEW.codcep := NULL;
END IF;
IF trim(NEW.codcid)::VARCHAR = '''' THEN
   NEW.codcid := NULL;
END IF;
IF trim(NEW.basins)::VARCHAR = '''' THEN
   NEW.basins := NULL;
END IF;
IF trim(NEW.tiparq)::VARCHAR = '''' THEN
   NEW.tiparq := NULL;
END IF;
IF trim(NEW.usuadm)::VARCHAR = '''' THEN
   NEW.usuadm := NULL;
END IF;
IF trim(NEW.tbsdat)::VARCHAR = '''' THEN
   NEW.tbsdat := NULL;
END IF;
IF trim(NEW.tbsind)::VARCHAR = '''' THEN
   NEW.tbsind := NULL;
END IF;
IF trim(NEW.senint)::VARCHAR = '''' THEN
   NEW.senint := NULL;
END IF;
IF trim(NEW.lock_c)::VARCHAR = '''' THEN
   NEW.lock_c := NULL;
END IF;
IF trim(NEW.verdet)::VARCHAR = '''' THEN
   NEW.verdet := NULL;
END IF;
IF trim(NEW.verper)::VARCHAR = '''' THEN
   NEW.verper := NULL;
END IF;
IF trim(NEW.lock_f)::VARCHAR = '''' THEN
   NEW.lock_f := NULL;
END IF;
IF trim(NEW.nomper)::VARCHAR = '''' THEN
   NEW.nomper := NULL;
END IF;
IF trim(NEW.proteq)::VARCHAR = '''' THEN
   NEW.proteq := NULL;
END IF;
IF trim(NEW.xmlass)::VARCHAR = '''' THEN
   NEW.xmlass := NULL;
END IF;
IF trim(NEW.xmldoc)::VARCHAR = '''' THEN
   NEW.xmldoc := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_idf
BEFORE INSERT OR UPDATE ON tt_idf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_idf();



/*-- SEQ 6273 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_idi() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.filori)::VARCHAR = '''' THEN
   NEW.filori := NULL;
END IF;
IF trim(NEW.fildes)::VARCHAR = '''' THEN
   NEW.fildes := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filped)::VARCHAR = '''' THEN
   NEW.filped := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_idi
BEFORE INSERT OR UPDATE ON tt_idi
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_idi();



/*-- SEQ 6274 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ied() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.tabela)::VARCHAR = '''' THEN
   NEW.tabela := NULL;
END IF;
IF trim(NEW.import)::VARCHAR = '''' THEN
   NEW.import := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;
IF trim(NEW.inclui)::VARCHAR = '''' THEN
   NEW.inclui := NULL;
END IF;
IF trim(NEW.exclui)::VARCHAR = '''' THEN
   NEW.exclui := NULL;
END IF;
IF trim(NEW.altera)::VARCHAR = '''' THEN
   NEW.altera := NULL;
END IF;
IF trim(NEW.mantem)::VARCHAR = '''' THEN
   NEW.mantem := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ied
BEFORE INSERT OR UPDATE ON tt_ied
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ied();



/*-- SEQ 6275 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ien() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.seqenv)::VARCHAR = '''' THEN
   NEW.seqenv := NULL;
END IF;
IF trim(NEW.l1_240)::VARCHAR = '''' THEN
   NEW.l1_240 := NULL;
END IF;
IF trim(NEW.l1_200)::VARCHAR = '''' THEN
   NEW.l1_200 := NULL;
END IF;
IF trim(NEW.l2_200)::VARCHAR = '''' THEN
   NEW.l2_200 := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ien
BEFORE INSERT OR UPDATE ON tt_ien
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ien();



/*-- SEQ 6276 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_iex() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.tiplan)::VARCHAR = '''' THEN
   NEW.tiplan := NULL;
END IF;
IF trim(NEW.codhis)::VARCHAR = '''' THEN
   NEW.codhis := NULL;
END IF;
IF trim(NEW.histor)::VARCHAR = '''' THEN
   NEW.histor := NULL;
END IF;
IF trim(NEW.docume)::VARCHAR = '''' THEN
   NEW.docume := NULL;
END IF;
IF trim(NEW.nature)::VARCHAR = '''' THEN
   NEW.nature := NULL;
END IF;
IF trim(NEW.bcoori)::VARCHAR = '''' THEN
   NEW.bcoori := NULL;
END IF;
IF trim(NEW.ageori)::VARCHAR = '''' THEN
   NEW.ageori := NULL;
END IF;
IF trim(NEW.ctbori)::VARCHAR = '''' THEN
   NEW.ctbori := NULL;
END IF;
IF trim(NEW.cpmf)::VARCHAR = '''' THEN
   NEW.cpmf := NULL;
END IF;
IF trim(NEW.sitcon)::VARCHAR = '''' THEN
   NEW.sitcon := NULL;
END IF;
IF trim(NEW.filcon)::VARCHAR = '''' THEN
   NEW.filcon := NULL;
END IF;
IF trim(NEW.codcon)::VARCHAR = '''' THEN
   NEW.codcon := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_iex
BEFORE INSERT OR UPDATE ON tt_iex
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_iex();



/*-- SEQ 6277 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ifc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.filfor)::VARCHAR = '''' THEN
   NEW.filfor := NULL;
END IF;
IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;
IF trim(NEW.uf_ori)::VARCHAR = '''' THEN
   NEW.uf_ori := NULL;
END IF;
IF trim(NEW.filcmp)::VARCHAR = '''' THEN
   NEW.filcmp := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ifc
BEFORE INSERT OR UPDATE ON tt_ifc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ifc();



/*-- SEQ 6278 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ifo() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.filfor)::VARCHAR = '''' THEN
   NEW.filfor := NULL;
END IF;
IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;
IF trim(NEW.uf_ori)::VARCHAR = '''' THEN
   NEW.uf_ori := NULL;
END IF;
IF trim(NEW.flgsub)::VARCHAR = '''' THEN
   NEW.flgsub := NULL;
END IF;
IF trim(NEW.icmtip)::VARCHAR = '''' THEN
   NEW.icmtip := NULL;
END IF;
IF trim(NEW.flgred_icm_p_st)::VARCHAR = '''' THEN
   NEW.flgred_icm_p_st := NULL;
END IF;
IF trim(NEW.oripro)::VARCHAR = '''' THEN
   NEW.oripro := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ifo
BEFORE INSERT OR UPDATE ON tt_ifo
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ifo();



/*-- SEQ 6279 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_iin() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_iin
BEFORE INSERT OR UPDATE ON tt_iin
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_iin();



/*-- SEQ 6280 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ili() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.sitmov)::VARCHAR = '''' THEN
   NEW.sitmov := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ili
BEFORE INSERT OR UPDATE ON tt_ili
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ili();



/*-- SEQ 6281 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ilm() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filemi)::VARCHAR = '''' THEN
   NEW.filemi := NULL;
END IF;
IF trim(NEW.codemi)::VARCHAR = '''' THEN
   NEW.codemi := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ilm
BEFORE INSERT OR UPDATE ON tt_ilm
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ilm();



/*-- SEQ 6282 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_imp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.path)::VARCHAR = '''' THEN
   NEW.path := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_imp
BEFORE INSERT OR UPDATE ON tt_imp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_imp();



/*-- SEQ 6283 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_imu() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.codcid)::VARCHAR = '''' THEN
   NEW.codcid := NULL;
END IF;
IF trim(NEW.sittri)::VARCHAR = '''' THEN
   NEW.sittri := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;
IF trim(NEW.desrps)::VARCHAR = '''' THEN
   NEW.desrps := NULL;
END IF;
IF trim(NEW.codsrv)::VARCHAR = '''' THEN
   NEW.codsrv := NULL;
END IF;
IF trim(NEW.dessrv)::VARCHAR = '''' THEN
   NEW.dessrv := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_imu
BEFORE INSERT OR UPDATE ON tt_imu
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_imu();



/*-- SEQ 6284 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_inb() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filrpp)::VARCHAR = '''' THEN
   NEW.filrpp := NULL;
END IF;
IF trim(NEW.codrpp)::VARCHAR = '''' THEN
   NEW.codrpp := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_inb
BEFORE INSERT OR UPDATE ON tt_inb
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_inb();



/*-- SEQ 6285 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ind() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.nomind)::VARCHAR = '''' THEN
   NEW.nomind := NULL;
END IF;
IF trim(NEW.forind)::VARCHAR = '''' THEN
   NEW.forind := NULL;
END IF;
IF trim(NEW.forsql)::VARCHAR = '''' THEN
   NEW.forsql := NULL;
END IF;
IF trim(NEW.coment)::VARCHAR = '''' THEN
   NEW.coment := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ind
BEFORE INSERT OR UPDATE ON tt_ind
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ind();



/*-- SEQ 6286 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_inf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.inf_ds_cprod)::VARCHAR = '''' THEN
   NEW.inf_ds_cprod := NULL;
END IF;
IF trim(NEW.inf_nu_ncm)::VARCHAR = '''' THEN
   NEW.inf_nu_ncm := NULL;
END IF;
IF trim(NEW.inf_filmat)::VARCHAR = '''' THEN
   NEW.inf_filmat := NULL;
END IF;
IF trim(NEW.inf_codmat)::VARCHAR = '''' THEN
   NEW.inf_codmat := NULL;
END IF;
IF trim(NEW.ive_codfil)::VARCHAR = '''' THEN
   NEW.ive_codfil := NULL;
END IF;
IF trim(NEW.ive_sequen)::VARCHAR = '''' THEN
   NEW.ive_sequen := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_inf
BEFORE INSERT OR UPDATE ON tt_inf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_inf();



/*-- SEQ 6287 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ini() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.modulo)::VARCHAR = '''' THEN
   NEW.modulo := NULL;
END IF;
IF trim(NEW.regini)::VARCHAR = '''' THEN
   NEW.regini := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ini
BEFORE INSERT OR UPDATE ON tt_ini
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ini();



/*-- SEQ 6288 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_int() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.csenha)::VARCHAR = '''' THEN
   NEW.csenha := NULL;
END IF;
IF trim(NEW.filres)::VARCHAR = '''' THEN
   NEW.filres := NULL;
END IF;
IF trim(NEW.codres)::VARCHAR = '''' THEN
   NEW.codres := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.e_mail)::VARCHAR = '''' THEN
   NEW.e_mail := NULL;
END IF;
IF trim(NEW.intati)::VARCHAR = '''' THEN
   NEW.intati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_int
BEFORE INSERT OR UPDATE ON tt_int
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_int();



/*-- SEQ 6289 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_inu() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.justif)::VARCHAR = '''' THEN
   NEW.justif := NULL;
END IF;
IF trim(NEW.modnot)::VARCHAR = '''' THEN
   NEW.modnot := NULL;
END IF;
IF trim(NEW.proinu)::VARCHAR = '''' THEN
   NEW.proinu := NULL;
END IF;
IF trim(NEW.expem4)::VARCHAR = '''' THEN
   NEW.expem4 := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_inu
BEFORE INSERT OR UPDATE ON tt_inu
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_inu();



/*-- SEQ 6290 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_inv() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.codcri)::VARCHAR = '''' THEN
   NEW.codcri := NULL;
END IF;
IF trim(NEW.filcri)::VARCHAR = '''' THEN
   NEW.filcri := NULL;
END IF;
IF trim(NEW.titinv)::VARCHAR = '''' THEN
   NEW.titinv := NULL;
END IF;
IF trim(NEW.codenc)::VARCHAR = '''' THEN
   NEW.codenc := NULL;
END IF;
IF trim(NEW.filenc)::VARCHAR = '''' THEN
   NEW.filenc := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_inv
BEFORE INSERT OR UPDATE ON tt_inv
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_inv();



/*-- SEQ 6291 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ior() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.tipped)::VARCHAR = '''' THEN
   NEW.tipped := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.promoc)::VARCHAR = '''' THEN
   NEW.promoc := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.filres)::VARCHAR = '''' THEN
   NEW.filres := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.montar)::VARCHAR = '''' THEN
   NEW.montar := NULL;
END IF;
IF trim(NEW.period)::VARCHAR = '''' THEN
   NEW.period := NULL;
END IF;
IF trim(NEW.tippar)::VARCHAR = '''' THEN
   NEW.tippar := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filfor)::VARCHAR = '''' THEN
   NEW.filfor := NULL;
END IF;
IF trim(NEW.filive)::VARCHAR = '''' THEN
   NEW.filive := NULL;
END IF;
IF trim(NEW.filpar)::VARCHAR = '''' THEN
   NEW.filpar := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;
IF trim(NEW.codpar)::VARCHAR = '''' THEN
   NEW.codpar := NULL;
END IF;
IF trim(NEW.seqive)::VARCHAR = '''' THEN
   NEW.seqive := NULL;
END IF;
IF trim(NEW.numfor)::VARCHAR = '''' THEN
   NEW.numfor := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.filrct)::VARCHAR = '''' THEN
   NEW.filrct := NULL;
END IF;
IF trim(NEW.seqrct)::VARCHAR = '''' THEN
   NEW.seqrct := NULL;
END IF;
IF trim(NEW.fildou)::VARCHAR = '''' THEN
   NEW.fildou := NULL;
END IF;
IF trim(NEW.seqdou)::VARCHAR = '''' THEN
   NEW.seqdou := NULL;
END IF;
IF trim(NEW.fileqp)::VARCHAR = '''' THEN
   NEW.fileqp := NULL;
END IF;
IF trim(NEW.seqeqp)::VARCHAR = '''' THEN
   NEW.seqeqp := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.filori)::VARCHAR = '''' THEN
   NEW.filori := NULL;
END IF;
IF trim(NEW.tipori)::VARCHAR = '''' THEN
   NEW.tipori := NULL;
END IF;
IF trim(NEW.numori)::VARCHAR = '''' THEN
   NEW.numori := NULL;
END IF;
IF trim(NEW.tippgt)::VARCHAR = '''' THEN
   NEW.tippgt := NULL;
END IF;
IF trim(NEW.tipent)::VARCHAR = '''' THEN
   NEW.tipent := NULL;
END IF;
IF trim(NEW.flgivo)::VARCHAR = '''' THEN
   NEW.flgivo := NULL;
END IF;
IF trim(NEW.filend)::VARCHAR = '''' THEN
   NEW.filend := NULL;
END IF;
IF trim(NEW.cooven)::VARCHAR = '''' THEN
   NEW.cooven := NULL;
END IF;
IF trim(NEW.flgenc)::VARCHAR = '''' THEN
   NEW.flgenc := NULL;
END IF;
IF trim(NEW.conclu)::VARCHAR = '''' THEN
   NEW.conclu := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;
IF trim(NEW.ecfven)::VARCHAR = '''' THEN
   NEW.ecfven := NULL;
END IF;
IF trim(NEW.flgest_paf)::VARCHAR = '''' THEN
   NEW.flgest_paf := NULL;
END IF;
IF trim(NEW.fillot)::VARCHAR = '''' THEN
   NEW.fillot := NULL;
END IF;
IF trim(NEW.seqlot)::VARCHAR = '''' THEN
   NEW.seqlot := NULL;
END IF;
IF trim(NEW.icmtip)::VARCHAR = '''' THEN
   NEW.icmtip := NULL;
END IF;
IF trim(NEW.filili)::VARCHAR = '''' THEN
   NEW.filili := NULL;
END IF;
IF trim(NEW.seqili)::VARCHAR = '''' THEN
   NEW.seqili := NULL;
END IF;
IF trim(NEW.prosug)::VARCHAR = '''' THEN
   NEW.prosug := NULL;
END IF;
IF trim(NEW.tipdet)::VARCHAR = '''' THEN
   NEW.tipdet := NULL;
END IF;
IF trim(NEW.perent)::VARCHAR = '''' THEN
   NEW.perent := NULL;
END IF;
IF trim(NEW.garant)::VARCHAR = '''' THEN
   NEW.garant := NULL;
END IF;
IF trim(NEW.filcpm)::VARCHAR = '''' THEN
   NEW.filcpm := NULL;
END IF;
IF trim(NEW.seqcpm)::VARCHAR = '''' THEN
   NEW.seqcpm := NULL;
END IF;
IF trim(NEW.numcre)::VARCHAR = '''' THEN
   NEW.numcre := NULL;
END IF;
IF trim(NEW.oricre)::VARCHAR = '''' THEN
   NEW.oricre := NULL;
END IF;
IF trim(NEW.numpedcom)::VARCHAR = '''' THEN
   NEW.numpedcom := NULL;
END IF;
IF trim(NEW.clsabc)::VARCHAR = '''' THEN
   NEW.clsabc := NULL;
END IF;
IF trim(NEW.sitiss)::VARCHAR = '''' THEN
   NEW.sitiss := NULL;
END IF;
IF trim(NEW.premancam)::VARCHAR = '''' THEN
   NEW.premancam := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ior
BEFORE INSERT OR UPDATE ON tt_ior
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ior();



/*-- SEQ 6292 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_iorxcpr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filior)::VARCHAR = '''' THEN
   NEW.filior := NULL;
END IF;
IF trim(NEW.tipior)::VARCHAR = '''' THEN
   NEW.tipior := NULL;
END IF;
IF trim(NEW.numior)::VARCHAR = '''' THEN
   NEW.numior := NULL;
END IF;
IF trim(NEW.filcpr)::VARCHAR = '''' THEN
   NEW.filcpr := NULL;
END IF;
IF trim(NEW.seqcpr)::VARCHAR = '''' THEN
   NEW.seqcpr := NULL;
END IF;
IF trim(NEW.filcup)::VARCHAR = '''' THEN
   NEW.filcup := NULL;
END IF;
IF trim(NEW.seqcup)::VARCHAR = '''' THEN
   NEW.seqcup := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_iorxcpr
BEFORE INSERT OR UPDATE ON tt_iorxcpr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_iorxcpr();



/*-- SEQ 6293 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_iorxdet() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filped)::VARCHAR = '''' THEN
   NEW.filped := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.tipped)::VARCHAR = '''' THEN
   NEW.tipped := NULL;
END IF;
IF trim(NEW.filtin)::VARCHAR = '''' THEN
   NEW.filtin := NULL;
END IF;
IF trim(NEW.seqtin)::VARCHAR = '''' THEN
   NEW.seqtin := NULL;
END IF;
IF trim(NEW.filkit)::VARCHAR = '''' THEN
   NEW.filkit := NULL;
END IF;
IF trim(NEW.seqkit)::VARCHAR = '''' THEN
   NEW.seqkit := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.icmtip)::VARCHAR = '''' THEN
   NEW.icmtip := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_iorxdet
BEFORE INSERT OR UPDATE ON tt_iorxdet
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_iorxdet();



/*-- SEQ 6294 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ipc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.ipcati)::VARCHAR = '''' THEN
   NEW.ipcati := NULL;
END IF;
IF trim(NEW.vlrtxt)::VARCHAR = '''' THEN
   NEW.vlrtxt := NULL;
END IF;
IF trim(NEW.vlrboo)::VARCHAR = '''' THEN
   NEW.vlrboo := NULL;
END IF;
IF trim(NEW.filipc)::VARCHAR = '''' THEN
   NEW.filipc := NULL;
END IF;
IF trim(NEW.filecf)::VARCHAR = '''' THEN
   NEW.filecf := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ipc
BEFORE INSERT OR UPDATE ON tt_ipc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ipc();



/*-- SEQ 6295 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ipe() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.filent)::VARCHAR = '''' THEN
   NEW.filent := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filico)::VARCHAR = '''' THEN
   NEW.filico := NULL;
END IF;
IF trim(NEW.seqico)::VARCHAR = '''' THEN
   NEW.seqico := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.codbus)::VARCHAR = '''' THEN
   NEW.codbus := NULL;
END IF;
IF trim(NEW.filive)::VARCHAR = '''' THEN
   NEW.filive := NULL;
END IF;
IF trim(NEW.seqive)::VARCHAR = '''' THEN
   NEW.seqive := NULL;
END IF;
IF trim(NEW.filori)::VARCHAR = '''' THEN
   NEW.filori := NULL;
END IF;
IF trim(NEW.pedori)::VARCHAR = '''' THEN
   NEW.pedori := NULL;
END IF;
IF trim(NEW.fillot)::VARCHAR = '''' THEN
   NEW.fillot := NULL;
END IF;
IF trim(NEW.seqlot)::VARCHAR = '''' THEN
   NEW.seqlot := NULL;
END IF;
IF trim(NEW.flgenc)::VARCHAR = '''' THEN
   NEW.flgenc := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ipe
BEFORE INSERT OR UPDATE ON tt_ipe
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ipe();



/*-- SEQ 6296 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ipf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.ipiinc)::VARCHAR = '''' THEN
   NEW.ipiinc := NULL;
END IF;
IF trim(NEW.igndes)::VARCHAR = '''' THEN
   NEW.igndes := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ipf
BEFORE INSERT OR UPDATE ON tt_ipf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ipf();



/*-- SEQ 6297 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_iprexdif() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filapl)::VARCHAR = '''' THEN
   NEW.filapl := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_iprexdif
BEFORE INSERT OR UPDATE ON tt_iprexdif
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_iprexdif();



/*-- SEQ 6298 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ipt() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.desipt)::VARCHAR = '''' THEN
   NEW.desipt := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ipt
BEFORE INSERT OR UPDATE ON tt_ipt
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ipt();



/*-- SEQ 6299 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_iptxest() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.sigest)::VARCHAR = '''' THEN
   NEW.sigest := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_iptxest
BEFORE INSERT OR UPDATE ON tt_iptxest
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_iptxest();



/*-- SEQ 6300 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_iptxexc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.sigest)::VARCHAR = '''' THEN
   NEW.sigest := NULL;
END IF;
IF trim(NEW.codncm)::VARCHAR = '''' THEN
   NEW.codncm := NULL;
END IF;
IF trim(NEW.tipexc)::VARCHAR = '''' THEN
   NEW.tipexc := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_iptxexc
BEFORE INSERT OR UPDATE ON tt_iptxexc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_iptxexc();



/*-- SEQ 6301 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_iptxncm() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codncm)::VARCHAR = '''' THEN
   NEW.codncm := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_iptxncm
BEFORE INSERT OR UPDATE ON tt_iptxncm
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_iptxncm();



/*-- SEQ 6302 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_iptxpro() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_iptxpro
BEFORE INSERT OR UPDATE ON tt_iptxpro
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_iptxpro();



/*-- SEQ 6303 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_iqu() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filque)::VARCHAR = '''' THEN
   NEW.filque := NULL;
END IF;
IF trim(NEW.codque)::VARCHAR = '''' THEN
   NEW.codque := NULL;
END IF;
IF trim(NEW.filper)::VARCHAR = '''' THEN
   NEW.filper := NULL;
END IF;
IF trim(NEW.codper)::VARCHAR = '''' THEN
   NEW.codper := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_iqu
BEFORE INSERT OR UPDATE ON tt_iqu
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_iqu();



/*-- SEQ 6304 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_irc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.codbus)::VARCHAR = '''' THEN
   NEW.codbus := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_irc
BEFORE INSERT OR UPDATE ON tt_irc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_irc();



/*-- SEQ 6305 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ircxipe() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filirc)::VARCHAR = '''' THEN
   NEW.filirc := NULL;
END IF;
IF trim(NEW.seqirc)::VARCHAR = '''' THEN
   NEW.seqirc := NULL;
END IF;
IF trim(NEW.filipe)::VARCHAR = '''' THEN
   NEW.filipe := NULL;
END IF;
IF trim(NEW.seqipe)::VARCHAR = '''' THEN
   NEW.seqipe := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ircxipe
BEFORE INSERT OR UPDATE ON tt_ircxipe
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ircxipe();



/*-- SEQ 6306 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_iro() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filven)::VARCHAR = '''' THEN
   NEW.filven := NULL;
END IF;
IF trim(NEW.seqven)::VARCHAR = '''' THEN
   NEW.seqven := NULL;
END IF;
IF trim(NEW.seqcan)::VARCHAR = '''' THEN
   NEW.seqcan := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.entreg)::VARCHAR = '''' THEN
   NEW.entreg := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filalt)::VARCHAR = '''' THEN
   NEW.filalt := NULL;
END IF;
IF trim(NEW.codalt)::VARCHAR = '''' THEN
   NEW.codalt := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_iro
BEFORE INSERT OR UPDATE ON tt_iro
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_iro();



/*-- SEQ 6307 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_isl() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_isl
BEFORE INSERT OR UPDATE ON tt_isl
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_isl();



/*-- SEQ 6308 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_itf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_itf
BEFORE INSERT OR UPDATE ON tt_itf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_itf();



/*-- SEQ 6309 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_itfxctf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filitf)::VARCHAR = '''' THEN
   NEW.filitf := NULL;
END IF;
IF trim(NEW.seqitf)::VARCHAR = '''' THEN
   NEW.seqitf := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.flgest_ant)::VARCHAR = '''' THEN
   NEW.flgest_ant := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_itfxctf
BEFORE INSERT OR UPDATE ON tt_itfxctf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_itfxctf();



/*-- SEQ 6310 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_iti() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filcxs)::VARCHAR = '''' THEN
   NEW.filcxs := NULL;
END IF;
IF trim(NEW.tipiti)::VARCHAR = '''' THEN
   NEW.tipiti := NULL;
END IF;
IF trim(NEW.flgati)::VARCHAR = '''' THEN
   NEW.flgati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_iti
BEFORE INSERT OR UPDATE ON tt_iti
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_iti();



/*-- SEQ 6311 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_itp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.filins)::VARCHAR = '''' THEN
   NEW.filins := NULL;
END IF;
IF trim(NEW.codins)::VARCHAR = '''' THEN
   NEW.codins := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_itp
BEFORE INSERT OR UPDATE ON tt_itp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_itp();



/*-- SEQ 6312 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_iuf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.estado)::VARCHAR = '''' THEN
   NEW.estado := NULL;
END IF;
IF trim(NEW.subtri)::VARCHAR = '''' THEN
   NEW.subtri := NULL;
END IF;
IF trim(NEW.insagr)::VARCHAR = '''' THEN
   NEW.insagr := NULL;
END IF;
IF trim(NEW.calsub)::VARCHAR = '''' THEN
   NEW.calsub := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;
IF trim(NEW.icmise)::VARCHAR = '''' THEN
   NEW.icmise := NULL;
END IF;
IF trim(NEW.flgred)::VARCHAR = '''' THEN
   NEW.flgred := NULL;
END IF;
IF trim(NEW.regespimp)::VARCHAR = '''' THEN
   NEW.regespimp := NULL;
END IF;
IF trim(NEW.redicm)::VARCHAR = '''' THEN
   NEW.redicm := NULL;
END IF;
IF trim(NEW.codben_00)::VARCHAR = '''' THEN
   NEW.codben_00 := NULL;
END IF;
IF trim(NEW.codben_10)::VARCHAR = '''' THEN
   NEW.codben_10 := NULL;
END IF;
IF trim(NEW.codben_20)::VARCHAR = '''' THEN
   NEW.codben_20 := NULL;
END IF;
IF trim(NEW.codben_30)::VARCHAR = '''' THEN
   NEW.codben_30 := NULL;
END IF;
IF trim(NEW.codben_40)::VARCHAR = '''' THEN
   NEW.codben_40 := NULL;
END IF;
IF trim(NEW.codben_41)::VARCHAR = '''' THEN
   NEW.codben_41 := NULL;
END IF;
IF trim(NEW.codben_50)::VARCHAR = '''' THEN
   NEW.codben_50 := NULL;
END IF;
IF trim(NEW.codben_51)::VARCHAR = '''' THEN
   NEW.codben_51 := NULL;
END IF;
IF trim(NEW.codben_60)::VARCHAR = '''' THEN
   NEW.codben_60 := NULL;
END IF;
IF trim(NEW.codben_70)::VARCHAR = '''' THEN
   NEW.codben_70 := NULL;
END IF;
IF trim(NEW.codben_90)::VARCHAR = '''' THEN
   NEW.codben_90 := NULL;
END IF;
IF trim(NEW.regdif)::VARCHAR = '''' THEN
   NEW.regdif := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_iuf
BEFORE INSERT OR UPDATE ON tt_iuf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_iuf();



/*-- SEQ 6313 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ive() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.lanest)::VARCHAR = '''' THEN
   NEW.lanest := NULL;
END IF;
IF trim(NEW.tippro)::VARCHAR = '''' THEN
   NEW.tippro := NULL;
END IF;
IF trim(NEW.vincul)::VARCHAR = '''' THEN
   NEW.vincul := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;
IF trim(NEW.tip001)::VARCHAR = '''' THEN
   NEW.tip001 := NULL;
END IF;
IF trim(NEW.numori)::VARCHAR = '''' THEN
   NEW.numori := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.numext)::VARCHAR = '''' THEN
   NEW.numext := NULL;
END IF;
IF trim(NEW.icmtip)::VARCHAR = '''' THEN
   NEW.icmtip := NULL;
END IF;
IF trim(NEW.sitkit)::VARCHAR = '''' THEN
   NEW.sitkit := NULL;
END IF;
IF trim(NEW.sitmov)::VARCHAR = '''' THEN
   NEW.sitmov := NULL;
END IF;
IF trim(NEW.filvdd)::VARCHAR = '''' THEN
   NEW.filvdd := NULL;
END IF;
IF trim(NEW.codvdd)::VARCHAR = '''' THEN
   NEW.codvdd := NULL;
END IF;
IF trim(NEW.filbic)::VARCHAR = '''' THEN
   NEW.filbic := NULL;
END IF;
IF trim(NEW.natfis)::VARCHAR = '''' THEN
   NEW.natfis := NULL;
END IF;
IF trim(NEW.filori)::VARCHAR = '''' THEN
   NEW.filori := NULL;
END IF;
IF trim(NEW.calsub)::VARCHAR = '''' THEN
   NEW.calsub := NULL;
END IF;
IF trim(NEW.devvin)::VARCHAR = '''' THEN
   NEW.devvin := NULL;
END IF;
IF trim(NEW.filrct)::VARCHAR = '''' THEN
   NEW.filrct := NULL;
END IF;
IF trim(NEW.seqrct)::VARCHAR = '''' THEN
   NEW.seqrct := NULL;
END IF;
IF trim(NEW.fildou)::VARCHAR = '''' THEN
   NEW.fildou := NULL;
END IF;
IF trim(NEW.seqdou)::VARCHAR = '''' THEN
   NEW.seqdou := NULL;
END IF;
IF trim(NEW.flgfut)::VARCHAR = '''' THEN
   NEW.flgfut := NULL;
END IF;
IF trim(NEW.impkit)::VARCHAR = '''' THEN
   NEW.impkit := NULL;
END IF;
IF trim(NEW.promoc)::VARCHAR = '''' THEN
   NEW.promoc := NULL;
END IF;
IF trim(NEW.penatu)::VARCHAR = '''' THEN
   NEW.penatu := NULL;
END IF;
IF trim(NEW.sitipi)::VARCHAR = '''' THEN
   NEW.sitipi := NULL;
END IF;
IF trim(NEW.sitpis)::VARCHAR = '''' THEN
   NEW.sitpis := NULL;
END IF;
IF trim(NEW.sitcof)::VARCHAR = '''' THEN
   NEW.sitcof := NULL;
END IF;
IF trim(NEW.codcst)::VARCHAR = '''' THEN
   NEW.codcst := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;
IF trim(NEW.numext_dep)::VARCHAR = '''' THEN
   NEW.numext_dep := NULL;
END IF;
IF trim(NEW.indrep)::VARCHAR = '''' THEN
   NEW.indrep := NULL;
END IF;
IF trim(NEW.sitiss)::VARCHAR = '''' THEN
   NEW.sitiss := NULL;
END IF;
IF trim(NEW.codean)::VARCHAR = '''' THEN
   NEW.codean := NULL;
END IF;
IF trim(NEW.codaba)::VARCHAR = '''' THEN
   NEW.codaba := NULL;
END IF;
IF trim(NEW.natbcc)::VARCHAR = '''' THEN
   NEW.natbcc := NULL;
END IF;
IF trim(NEW.filicoori)::VARCHAR = '''' THEN
   NEW.filicoori := NULL;
END IF;
IF trim(NEW.seqicoori)::VARCHAR = '''' THEN
   NEW.seqicoori := NULL;
END IF;
IF trim(NEW.fillot)::VARCHAR = '''' THEN
   NEW.fillot := NULL;
END IF;
IF trim(NEW.seqlot)::VARCHAR = '''' THEN
   NEW.seqlot := NULL;
END IF;
IF trim(NEW.filbsc)::VARCHAR = '''' THEN
   NEW.filbsc := NULL;
END IF;
IF trim(NEW.estorn)::VARCHAR = '''' THEN
   NEW.estorn := NULL;
END IF;
IF trim(NEW.desite)::VARCHAR = '''' THEN
   NEW.desite := NULL;
END IF;
IF trim(NEW.filres)::VARCHAR = '''' THEN
   NEW.filres := NULL;
END IF;
IF trim(NEW.prosug)::VARCHAR = '''' THEN
   NEW.prosug := NULL;
END IF;
IF trim(NEW.expfis)::VARCHAR = '''' THEN
   NEW.expfis := NULL;
END IF;
IF trim(NEW.fildev)::VARCHAR = '''' THEN
   NEW.fildev := NULL;
END IF;
IF trim(NEW.frmpre)::VARCHAR = '''' THEN
   NEW.frmpre := NULL;
END IF;
IF trim(NEW.codces)::VARCHAR = '''' THEN
   NEW.codces := NULL;
END IF;
IF trim(NEW.traimp)::VARCHAR = '''' THEN
   NEW.traimp := NULL;
END IF;
IF trim(NEW.filoip)::VARCHAR = '''' THEN
   NEW.filoip := NULL;
END IF;
IF trim(NEW.seqoip)::VARCHAR = '''' THEN
   NEW.seqoip := NULL;
END IF;
IF trim(NEW.codfci)::VARCHAR = '''' THEN
   NEW.codfci := NULL;
END IF;
IF trim(NEW.temdes)::VARCHAR = '''' THEN
   NEW.temdes := NULL;
END IF;
IF trim(NEW.codben)::VARCHAR = '''' THEN
   NEW.codben := NULL;
END IF;
IF trim(NEW.numpedcom)::VARCHAR = '''' THEN
   NEW.numpedcom := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.filcpm)::VARCHAR = '''' THEN
   NEW.filcpm := NULL;
END IF;
IF trim(NEW.seqcpm)::VARCHAR = '''' THEN
   NEW.seqcpm := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ive
BEFORE INSERT OR UPDATE ON tt_ive
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ive();



/*-- SEQ 6314 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ivexcpr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filive)::VARCHAR = '''' THEN
   NEW.filive := NULL;
END IF;
IF trim(NEW.seqive)::VARCHAR = '''' THEN
   NEW.seqive := NULL;
END IF;
IF trim(NEW.filcpr)::VARCHAR = '''' THEN
   NEW.filcpr := NULL;
END IF;
IF trim(NEW.seqcpr)::VARCHAR = '''' THEN
   NEW.seqcpr := NULL;
END IF;
IF trim(NEW.filcup)::VARCHAR = '''' THEN
   NEW.filcup := NULL;
END IF;
IF trim(NEW.seqcup)::VARCHAR = '''' THEN
   NEW.seqcup := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ivexcpr
BEFORE INSERT OR UPDATE ON tt_ivexcpr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ivexcpr();



/*-- SEQ 6315 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ivexcsg() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filrem)::VARCHAR = '''' THEN
   NEW.filrem := NULL;
END IF;
IF trim(NEW.seqrem)::VARCHAR = '''' THEN
   NEW.seqrem := NULL;
END IF;
IF trim(NEW.filfat)::VARCHAR = '''' THEN
   NEW.filfat := NULL;
END IF;
IF trim(NEW.seqfat)::VARCHAR = '''' THEN
   NEW.seqfat := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.nf_dev)::VARCHAR = '''' THEN
   NEW.nf_dev := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ivexcsg
BEFORE INSERT OR UPDATE ON tt_ivexcsg
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ivexcsg();



/*-- SEQ 6316 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ivexior() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filive)::VARCHAR = '''' THEN
   NEW.filive := NULL;
END IF;
IF trim(NEW.seqive)::VARCHAR = '''' THEN
   NEW.seqive := NULL;
END IF;
IF trim(NEW.filped)::VARCHAR = '''' THEN
   NEW.filped := NULL;
END IF;
IF trim(NEW.tipped)::VARCHAR = '''' THEN
   NEW.tipped := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ivexior
BEFORE INSERT OR UPDATE ON tt_ivexior
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ivexior();



/*-- SEQ 6317 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ivexipe() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filive)::VARCHAR = '''' THEN
   NEW.filive := NULL;
END IF;
IF trim(NEW.seqive)::VARCHAR = '''' THEN
   NEW.seqive := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.filipe)::VARCHAR = '''' THEN
   NEW.filipe := NULL;
END IF;
IF trim(NEW.numipe)::VARCHAR = '''' THEN
   NEW.numipe := NULL;
END IF;
IF trim(NEW.filped)::VARCHAR = '''' THEN
   NEW.filped := NULL;
END IF;
IF trim(NEW.tipped)::VARCHAR = '''' THEN
   NEW.tipped := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.fillot)::VARCHAR = '''' THEN
   NEW.fillot := NULL;
END IF;
IF trim(NEW.seqlot)::VARCHAR = '''' THEN
   NEW.seqlot := NULL;
END IF;
IF trim(NEW.filico)::VARCHAR = '''' THEN
   NEW.filico := NULL;
END IF;
IF trim(NEW.seqico)::VARCHAR = '''' THEN
   NEW.seqico := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ivexipe
BEFORE INSERT OR UPDATE ON tt_ivexipe
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ivexipe();



/*-- SEQ 6318 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ivo() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filvol)::VARCHAR = '''' THEN
   NEW.filvol := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.tipped)::VARCHAR = '''' THEN
   NEW.tipped := NULL;
END IF;
IF trim(NEW.filive)::VARCHAR = '''' THEN
   NEW.filive := NULL;
END IF;
IF trim(NEW.filped)::VARCHAR = '''' THEN
   NEW.filped := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.seqive)::VARCHAR = '''' THEN
   NEW.seqive := NULL;
END IF;
IF trim(NEW.seqvol)::VARCHAR = '''' THEN
   NEW.seqvol := NULL;
END IF;
IF trim(NEW.filipe)::VARCHAR = '''' THEN
   NEW.filipe := NULL;
END IF;
IF trim(NEW.numipe)::VARCHAR = '''' THEN
   NEW.numipe := NULL;
END IF;
IF trim(NEW.filrom)::VARCHAR = '''' THEN
   NEW.filrom := NULL;
END IF;
IF trim(NEW.seqrom)::VARCHAR = '''' THEN
   NEW.seqrom := NULL;
END IF;
IF trim(NEW.filimp)::VARCHAR = '''' THEN
   NEW.filimp := NULL;
END IF;
IF trim(NEW.seqimp)::VARCHAR = '''' THEN
   NEW.seqimp := NULL;
END IF;
IF trim(NEW.origem)::VARCHAR = '''' THEN
   NEW.origem := NULL;
END IF;
IF trim(NEW.temrom)::VARCHAR = '''' THEN
   NEW.temrom := NULL;
END IF;
IF trim(NEW.imp_cf)::VARCHAR = '''' THEN
   NEW.imp_cf := NULL;
END IF;
IF trim(NEW.fillot)::VARCHAR = '''' THEN
   NEW.fillot := NULL;
END IF;
IF trim(NEW.seqlot)::VARCHAR = '''' THEN
   NEW.seqlot := NULL;
END IF;
IF trim(NEW.entregue)::VARCHAR = '''' THEN
   NEW.entregue := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ivo
BEFORE INSERT OR UPDATE ON tt_ivo
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ivo();



/*-- SEQ 6319 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ixt() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.seqtit)::VARCHAR = '''' THEN
   NEW.seqtit := NULL;
END IF;
IF trim(NEW.filenv)::VARCHAR = '''' THEN
   NEW.filenv := NULL;
END IF;
IF trim(NEW.seqenv)::VARCHAR = '''' THEN
   NEW.seqenv := NULL;
END IF;
IF trim(NEW.filfin)::VARCHAR = '''' THEN
   NEW.filfin := NULL;
END IF;
IF trim(NEW.seqfin)::VARCHAR = '''' THEN
   NEW.seqfin := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ixt
BEFORE INSERT OR UPDATE ON tt_ixt
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ixt();



/*-- SEQ 6320 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_job() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.nomjob)::VARCHAR = '''' THEN
   NEW.nomjob := NULL;
END IF;
IF trim(NEW.desjob)::VARCHAR = '''' THEN
   NEW.desjob := NULL;
END IF;
IF trim(NEW.ulterr)::VARCHAR = '''' THEN
   NEW.ulterr := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_job
BEFORE INSERT OR UPDATE ON tt_job
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_job();



/*-- SEQ 6321 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_kit() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filite)::VARCHAR = '''' THEN
   NEW.filite := NULL;
END IF;
IF trim(NEW.codite)::VARCHAR = '''' THEN
   NEW.codite := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.brinde)::VARCHAR = '''' THEN
   NEW.brinde := NULL;
END IF;
IF trim(NEW.flgimp)::VARCHAR = '''' THEN
   NEW.flgimp := NULL;
END IF;
IF trim(NEW.numext_tinta)::VARCHAR = '''' THEN
   NEW.numext_tinta := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_kit
BEFORE INSERT OR UPDATE ON tt_kit
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_kit();



/*-- SEQ 6322 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_lac() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.numlac)::VARCHAR = '''' THEN
   NEW.numlac := NULL;
END IF;
IF trim(NEW.lacati)::VARCHAR = '''' THEN
   NEW.lacati := NULL;
END IF;
IF trim(NEW.tipman)::VARCHAR = '''' THEN
   NEW.tipman := NULL;
END IF;
IF trim(NEW.numlau)::VARCHAR = '''' THEN
   NEW.numlau := NULL;
END IF;
IF trim(NEW.motapl)::VARCHAR = '''' THEN
   NEW.motapl := NULL;
END IF;
IF trim(NEW.cnpres)::VARCHAR = '''' THEN
   NEW.cnpres := NULL;
END IF;
IF trim(NEW.cpftec)::VARCHAR = '''' THEN
   NEW.cpftec := NULL;
END IF;
IF trim(NEW.fillac)::VARCHAR = '''' THEN
   NEW.fillac := NULL;
END IF;
IF trim(NEW.seqlac)::VARCHAR = '''' THEN
   NEW.seqlac := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_lac
BEFORE INSERT OR UPDATE ON tt_lac
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_lac();



/*-- SEQ 6323 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_lan() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.sitmov)::VARCHAR = '''' THEN
   NEW.sitmov := NULL;
END IF;
IF trim(NEW.tipmov)::VARCHAR = '''' THEN
   NEW.tipmov := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.docume)::VARCHAR = '''' THEN
   NEW.docume := NULL;
END IF;
IF trim(NEW.numext)::VARCHAR = '''' THEN
   NEW.numext := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.filive)::VARCHAR = '''' THEN
   NEW.filive := NULL;
END IF;
IF trim(NEW.seqive)::VARCHAR = '''' THEN
   NEW.seqive := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;
IF trim(NEW.filori)::VARCHAR = '''' THEN
   NEW.filori := NULL;
END IF;
IF trim(NEW.codori)::VARCHAR = '''' THEN
   NEW.codori := NULL;
END IF;
IF trim(NEW.fildes)::VARCHAR = '''' THEN
   NEW.fildes := NULL;
END IF;
IF trim(NEW.coddes)::VARCHAR = '''' THEN
   NEW.coddes := NULL;
END IF;
IF trim(NEW.filppr)::VARCHAR = '''' THEN
   NEW.filppr := NULL;
END IF;
IF trim(NEW.seqppr)::VARCHAR = '''' THEN
   NEW.seqppr := NULL;
END IF;
IF trim(NEW.datstr)::VARCHAR = '''' THEN
   NEW.datstr := NULL;
END IF;
IF trim(NEW.fillot)::VARCHAR = '''' THEN
   NEW.fillot := NULL;
END IF;
IF trim(NEW.seqlot)::VARCHAR = '''' THEN
   NEW.seqlot := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_lan
BEFORE INSERT OR UPDATE ON tt_lan
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_lan();



/*-- SEQ 6324 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_lay() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codtab)::VARCHAR = '''' THEN
   NEW.codtab := NULL;
END IF;
IF trim(NEW.codgru)::VARCHAR = '''' THEN
   NEW.codgru := NULL;
END IF;
IF trim(NEW.tipcpo)::VARCHAR = '''' THEN
   NEW.tipcpo := NULL;
END IF;
IF trim(NEW.nomcpo)::VARCHAR = '''' THEN
   NEW.nomcpo := NULL;
END IF;
IF trim(NEW.expres)::VARCHAR = '''' THEN
   NEW.expres := NULL;
END IF;
IF trim(NEW.arqlis)::VARCHAR = '''' THEN
   NEW.arqlis := NULL;
END IF;
IF trim(NEW.origem)::VARCHAR = '''' THEN
   NEW.origem := NULL;
END IF;
IF trim(NEW.netdat)::VARCHAR = '''' THEN
   NEW.netdat := NULL;
END IF;
IF trim(NEW.oujoin)::VARCHAR = '''' THEN
   NEW.oujoin := NULL;
END IF;
IF trim(NEW.tipdad)::VARCHAR = '''' THEN
   NEW.tipdad := NULL;
END IF;
IF trim(NEW.tipfil)::VARCHAR = '''' THEN
   NEW.tipfil := NULL;
END IF;
IF trim(NEW.totalizado)::VARCHAR = '''' THEN
   NEW.totalizado := NULL;
END IF;
IF trim(NEW.velho)::VARCHAR = '''' THEN
   NEW.velho := NULL;
END IF;
IF trim(NEW.nomusu)::VARCHAR = '''' THEN
   NEW.nomusu := NULL;
END IF;
IF trim(NEW.descpo)::VARCHAR = '''' THEN
   NEW.descpo := NULL;
END IF;
IF trim(NEW.clafil)::VARCHAR = '''' THEN
   NEW.clafil := NULL;
END IF;
IF trim(NEW.usocpo)::VARCHAR = '''' THEN
   NEW.usocpo := NULL;
END IF;
IF trim(NEW.codlis)::VARCHAR = '''' THEN
   NEW.codlis := NULL;
END IF;
IF trim(NEW.deslis)::VARCHAR = '''' THEN
   NEW.deslis := NULL;
END IF;
IF trim(NEW.tip_lgpd)::VARCHAR = '''' THEN
   NEW.tip_lgpd := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_lay
BEFORE INSERT OR UPDATE ON tt_lay
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_lay();



/*-- SEQ 6325 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_layxlgpd() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codtab)::VARCHAR = '''' THEN
   NEW.codtab := NULL;
END IF;
IF trim(NEW.nomcpo)::VARCHAR = '''' THEN
   NEW.nomcpo := NULL;
END IF;
IF trim(NEW.tip_lgpd)::VARCHAR = '''' THEN
   NEW.tip_lgpd := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_layxlgpd
BEFORE INSERT OR UPDATE ON tt_layxlgpd
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_layxlgpd();



/*-- SEQ 6326 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_lcf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.cupfis)::VARCHAR = '''' THEN
   NEW.cupfis := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.tipope)::VARCHAR = '''' THEN
   NEW.tipope := NULL;
END IF;
IF trim(NEW.msgerr)::VARCHAR = '''' THEN
   NEW.msgerr := NULL;
END IF;
IF trim(NEW.flghis)::VARCHAR = '''' THEN
   NEW.flghis := NULL;
END IF;
IF trim(NEW.flgcan)::VARCHAR = '''' THEN
   NEW.flgcan := NULL;
END IF;
IF trim(NEW.flgpro)::VARCHAR = '''' THEN
   NEW.flgpro := NULL;
END IF;
IF trim(NEW.flgexe)::VARCHAR = '''' THEN
   NEW.flgexe := NULL;
END IF;
IF trim(NEW.versao)::VARCHAR = '''' THEN
   NEW.versao := NULL;
END IF;
IF trim(NEW.tipdoc)::VARCHAR = '''' THEN
   NEW.tipdoc := NULL;
END IF;
IF trim(NEW.filped)::VARCHAR = '''' THEN
   NEW.filped := NULL;
END IF;
IF trim(NEW.tipped)::VARCHAR = '''' THEN
   NEW.tipped := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.sisori)::VARCHAR = '''' THEN
   NEW.sisori := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_lcf
BEFORE INSERT OR UPDATE ON tt_lcf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_lcf();



/*-- SEQ 6327 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_lck() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.lckdoc)::VARCHAR = '''' THEN
   NEW.lckdoc := NULL;
END IF;
IF trim(NEW.lckfil)::VARCHAR = '''' THEN
   NEW.lckfil := NULL;
END IF;
IF trim(NEW.lckecf)::VARCHAR = '''' THEN
   NEW.lckecf := NULL;
END IF;
IF trim(NEW.lckusu)::VARCHAR = '''' THEN
   NEW.lckusu := NULL;
END IF;
IF trim(NEW.lckobs)::VARCHAR = '''' THEN
   NEW.lckobs := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_lck
BEFORE INSERT OR UPDATE ON tt_lck
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_lck();



/*-- SEQ 6328 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_lex() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filiex)::VARCHAR = '''' THEN
   NEW.filiex := NULL;
END IF;
IF trim(NEW.seqiex)::VARCHAR = '''' THEN
   NEW.seqiex := NULL;
END IF;
IF trim(NEW.filrec)::VARCHAR = '''' THEN
   NEW.filrec := NULL;
END IF;
IF trim(NEW.seqrec)::VARCHAR = '''' THEN
   NEW.seqrec := NULL;
END IF;
IF trim(NEW.numpar)::VARCHAR = '''' THEN
   NEW.numpar := NULL;
END IF;
IF trim(NEW.subpar)::VARCHAR = '''' THEN
   NEW.subpar := NULL;
END IF;
IF trim(NEW.filccc)::VARCHAR = '''' THEN
   NEW.filccc := NULL;
END IF;
IF trim(NEW.seqccc)::VARCHAR = '''' THEN
   NEW.seqccc := NULL;
END IF;
IF trim(NEW.filchr)::VARCHAR = '''' THEN
   NEW.filchr := NULL;
END IF;
IF trim(NEW.seqchr)::VARCHAR = '''' THEN
   NEW.seqchr := NULL;
END IF;
IF trim(NEW.filfin)::VARCHAR = '''' THEN
   NEW.filfin := NULL;
END IF;
IF trim(NEW.seqfin)::VARCHAR = '''' THEN
   NEW.seqfin := NULL;
END IF;
IF trim(NEW.fildop)::VARCHAR = '''' THEN
   NEW.fildop := NULL;
END IF;
IF trim(NEW.seqdop)::VARCHAR = '''' THEN
   NEW.seqdop := NULL;
END IF;
IF trim(NEW.filtit)::VARCHAR = '''' THEN
   NEW.filtit := NULL;
END IF;
IF trim(NEW.seqtit)::VARCHAR = '''' THEN
   NEW.seqtit := NULL;
END IF;
IF trim(NEW.oldflg)::VARCHAR = '''' THEN
   NEW.oldflg := NULL;
END IF;
IF trim(NEW.fildep)::VARCHAR = '''' THEN
   NEW.fildep := NULL;
END IF;
IF trim(NEW.seqdep)::VARCHAR = '''' THEN
   NEW.seqdep := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_lex
BEFORE INSERT OR UPDATE ON tt_lex
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_lex();



/*-- SEQ 6329 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_lib() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.numlib)::VARCHAR = '''' THEN
   NEW.numlib := NULL;
END IF;
IF trim(NEW.hommod)::VARCHAR = '''' THEN
   NEW.hommod := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_lib
BEFORE INSERT OR UPDATE ON tt_lib
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_lib();



/*-- SEQ 6330 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_lid() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.cupfis)::VARCHAR = '''' THEN
   NEW.cupfis := NULL;
END IF;
IF trim(NEW.tipope)::VARCHAR = '''' THEN
   NEW.tipope := NULL;
END IF;
IF trim(NEW.filori)::VARCHAR = '''' THEN
   NEW.filori := NULL;
END IF;
IF trim(NEW.ecfori)::VARCHAR = '''' THEN
   NEW.ecfori := NULL;
END IF;
IF trim(NEW.lidpos)::VARCHAR = '''' THEN
   NEW.lidpos := NULL;
END IF;
IF trim(NEW.versao)::VARCHAR = '''' THEN
   NEW.versao := NULL;
END IF;
IF trim(NEW.tipdoc)::VARCHAR = '''' THEN
   NEW.tipdoc := NULL;
END IF;
IF trim(NEW.filped)::VARCHAR = '''' THEN
   NEW.filped := NULL;
END IF;
IF trim(NEW.tipped)::VARCHAR = '''' THEN
   NEW.tipped := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;
IF trim(NEW.expem4)::VARCHAR = '''' THEN
   NEW.expem4 := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_lid
BEFORE INSERT OR UPDATE ON tt_lid
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_lid();



/*-- SEQ 6331 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_lim() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.tipcob)::VARCHAR = '''' THEN
   NEW.tipcob := NULL;
END IF;
IF trim(NEW.codpgt)::VARCHAR = '''' THEN
   NEW.codpgt := NULL;
END IF;
IF trim(NEW.filcob)::VARCHAR = '''' THEN
   NEW.filcob := NULL;
END IF;
IF trim(NEW.filpgt)::VARCHAR = '''' THEN
   NEW.filpgt := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.fatend)::VARCHAR = '''' THEN
   NEW.fatend := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_lim
BEFORE INSERT OR UPDATE ON tt_lim
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_lim();



/*-- SEQ 6332 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_limxfil() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_limxfil
BEFORE INSERT OR UPDATE ON tt_limxfil
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_limxfil();



/*-- SEQ 6333 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_lis() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.deslis)::VARCHAR = '''' THEN
   NEW.deslis := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_lis
BEFORE INSERT OR UPDATE ON tt_lis
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_lis();



/*-- SEQ 6334 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_lmc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.filreg)::VARCHAR = '''' THEN
   NEW.filreg := NULL;
END IF;
IF trim(NEW.codreg)::VARCHAR = '''' THEN
   NEW.codreg := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_lmc
BEFORE INSERT OR UPDATE ON tt_lmc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_lmc();



/*-- SEQ 6335 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_log() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.nomlog)::VARCHAR = '''' THEN
   NEW.nomlog := NULL;
END IF;
IF trim(NEW.codcep)::VARCHAR = '''' THEN
   NEW.codcep := NULL;
END IF;
IF trim(NEW.comple)::VARCHAR = '''' THEN
   NEW.comple := NULL;
END IF;
IF trim(NEW.tiplog)::VARCHAR = '''' THEN
   NEW.tiplog := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_log
BEFORE INSERT OR UPDATE ON tt_log
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_log();



/*-- SEQ 6336 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_loi() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.xmldoc)::VARCHAR = '''' THEN
   NEW.xmldoc := NULL;
END IF;
IF trim(NEW.md5xml)::VARCHAR = '''' THEN
   NEW.md5xml := NULL;
END IF;
IF trim(NEW.arqxml)::VARCHAR = '''' THEN
   NEW.arqxml := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_loi
BEFORE INSERT OR UPDATE ON tt_loi
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_loi();



/*-- SEQ 6337 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_lot() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.filfor)::VARCHAR = '''' THEN
   NEW.filfor := NULL;
END IF;
IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;
IF trim(NEW.numlot)::VARCHAR = '''' THEN
   NEW.numlot := NULL;
END IF;
IF trim(NEW.tonali)::VARCHAR = '''' THEN
   NEW.tonali := NULL;
END IF;
IF trim(NEW.tamanh)::VARCHAR = '''' THEN
   NEW.tamanh := NULL;
END IF;
IF trim(NEW.flgpon)::VARCHAR = '''' THEN
   NEW.flgpon := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.lotati)::VARCHAR = '''' THEN
   NEW.lotati := NULL;
END IF;
IF trim(NEW.codalt)::VARCHAR = '''' THEN
   NEW.codalt := NULL;
END IF;
IF trim(NEW.tippin)::VARCHAR = '''' THEN
   NEW.tippin := NULL;
END IF;
IF trim(NEW.chassi)::VARCHAR = '''' THEN
   NEW.chassi := NULL;
END IF;
IF trim(NEW.convin)::VARCHAR = '''' THEN
   NEW.convin := NULL;
END IF;
IF trim(NEW.serial)::VARCHAR = '''' THEN
   NEW.serial := NULL;
END IF;
IF trim(NEW.nummot)::VARCHAR = '''' THEN
   NEW.nummot := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_lot
BEFORE INSERT OR UPDATE ON tt_lot
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_lot();



/*-- SEQ 6338 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ltb() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.seqarq)::VARCHAR = '''' THEN
   NEW.seqarq := NULL;
END IF;
IF trim(NEW.digage)::VARCHAR = '''' THEN
   NEW.digage := NULL;
END IF;
IF trim(NEW.diga_c)::VARCHAR = '''' THEN
   NEW.diga_c := NULL;
END IF;
IF trim(NEW.dig_cc)::VARCHAR = '''' THEN
   NEW.dig_cc := NULL;
END IF;
IF trim(NEW.conven)::VARCHAR = '''' THEN
   NEW.conven := NULL;
END IF;
IF trim(NEW.nomemp)::VARCHAR = '''' THEN
   NEW.nomemp := NULL;
END IF;
IF trim(NEW.infor1)::VARCHAR = '''' THEN
   NEW.infor1 := NULL;
END IF;
IF trim(NEW.infor2)::VARCHAR = '''' THEN
   NEW.infor2 := NULL;
END IF;
IF trim(NEW.numavi)::VARCHAR = '''' THEN
   NEW.numavi := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ltb
BEFORE INSERT OR UPDATE ON tt_ltb
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ltb();



/*-- SEQ 6339 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_mai() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.exclui)::VARCHAR = '''' THEN
   NEW.exclui := NULL;
END IF;
IF trim(NEW.assunt)::VARCHAR = '''' THEN
   NEW.assunt := NULL;
END IF;
IF trim(NEW.mai_fr)::VARCHAR = '''' THEN
   NEW.mai_fr := NULL;
END IF;
IF trim(NEW.mai_to)::VARCHAR = '''' THEN
   NEW.mai_to := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.anexos)::VARCHAR = '''' THEN
   NEW.anexos := NULL;
END IF;
IF trim(NEW.mai_cb)::VARCHAR = '''' THEN
   NEW.mai_cb := NULL;
END IF;
IF trim(NEW.mai_cc)::VARCHAR = '''' THEN
   NEW.mai_cc := NULL;
END IF;
IF trim(NEW.tipmsg)::VARCHAR = '''' THEN
   NEW.tipmsg := NULL;
END IF;
IF trim(NEW.textos)::VARCHAR = '''' THEN
   NEW.textos := NULL;
END IF;
IF trim(NEW.maienv)::VARCHAR = '''' THEN
   NEW.maienv := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_mai
BEFORE INSERT OR UPDATE ON tt_mai
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_mai();



/*-- SEQ 6340 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_mar() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filmar)::VARCHAR = '''' THEN
   NEW.filmar := NULL;
END IF;
IF trim(NEW.codmar)::VARCHAR = '''' THEN
   NEW.codmar := NULL;
END IF;
IF trim(NEW.tipmar)::VARCHAR = '''' THEN
   NEW.tipmar := NULL;
END IF;
IF trim(NEW.desmar)::VARCHAR = '''' THEN
   NEW.desmar := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_mar
BEFORE INSERT OR UPDATE ON tt_mar
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_mar();



/*-- SEQ 6341 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_mcf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.flgdes)::VARCHAR = '''' THEN
   NEW.flgdes := NULL;
END IF;
IF trim(NEW.flgacr)::VARCHAR = '''' THEN
   NEW.flgacr := NULL;
END IF;
IF trim(NEW.flgcan)::VARCHAR = '''' THEN
   NEW.flgcan := NULL;
END IF;
IF trim(NEW.orddesacr)::VARCHAR = '''' THEN
   NEW.orddesacr := NULL;
END IF;
IF trim(NEW.nomecli)::VARCHAR = '''' THEN
   NEW.nomecli := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.msglog)::VARCHAR = '''' THEN
   NEW.msglog := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_mcf
BEFORE INSERT OR UPDATE ON tt_mcf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_mcf();



/*-- SEQ 6342 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_mdt() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.fillei)::VARCHAR = '''' THEN
   NEW.fillei := NULL;
END IF;
IF trim(NEW.codlei)::VARCHAR = '''' THEN
   NEW.codlei := NULL;
END IF;
IF trim(NEW.filreg)::VARCHAR = '''' THEN
   NEW.filreg := NULL;
END IF;
IF trim(NEW.codreg)::VARCHAR = '''' THEN
   NEW.codreg := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_mdt
BEFORE INSERT OR UPDATE ON tt_mdt
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_mdt();



/*-- SEQ 6343 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_mer() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.desmer)::VARCHAR = '''' THEN
   NEW.desmer := NULL;
END IF;
IF trim(NEW.unidad)::VARCHAR = '''' THEN
   NEW.unidad := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_mer
BEFORE INSERT OR UPDATE ON tt_mer
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_mer();



/*-- SEQ 6344 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_mes() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.nommes)::VARCHAR = '''' THEN
   NEW.nommes := NULL;
END IF;
IF trim(NEW.sigest)::VARCHAR = '''' THEN
   NEW.sigest := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_mes
BEFORE INSERT OR UPDATE ON tt_mes
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_mes();



/*-- SEQ 6345 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_met() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_met
BEFORE INSERT OR UPDATE ON tt_met
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_met();



/*-- SEQ 6346 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_mic() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.nommic)::VARCHAR = '''' THEN
   NEW.nommic := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_mic
BEFORE INSERT OR UPDATE ON tt_mic
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_mic();



/*-- SEQ 6347 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_moe() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;
IF trim(NEW.desmoe)::VARCHAR = '''' THEN
   NEW.desmoe := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_moe
BEFORE INSERT OR UPDATE ON tt_moe
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_moe();



/*-- SEQ 6348 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_mon() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.locali)::VARCHAR = '''' THEN
   NEW.locali := NULL;
END IF;
IF trim(NEW.tipmon)::VARCHAR = '''' THEN
   NEW.tipmon := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filres)::VARCHAR = '''' THEN
   NEW.filres := NULL;
END IF;
IF trim(NEW.codres)::VARCHAR = '''' THEN
   NEW.codres := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.filive)::VARCHAR = '''' THEN
   NEW.filive := NULL;
END IF;
IF trim(NEW.seqive)::VARCHAR = '''' THEN
   NEW.seqive := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_mon
BEFORE INSERT OR UPDATE ON tt_mon
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_mon();



/*-- SEQ 6349 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_mpb() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filven)::VARCHAR = '''' THEN
   NEW.filven := NULL;
END IF;
IF trim(NEW.seqven)::VARCHAR = '''' THEN
   NEW.seqven := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_mpb
BEFORE INSERT OR UPDATE ON tt_mpb
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_mpb();



/*-- SEQ 6350 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_mpd() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_mpd
BEFORE INSERT OR UPDATE ON tt_mpd
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_mpd();



/*-- SEQ 6351 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_mpf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_mpf
BEFORE INSERT OR UPDATE ON tt_mpf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_mpf();



/*-- SEQ 6352 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_mpr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_mpr
BEFORE INSERT OR UPDATE ON tt_mpr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_mpr();



/*-- SEQ 6353 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_mrd() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_mrd
BEFORE INSERT OR UPDATE ON tt_mrd
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_mrd();



/*-- SEQ 6354 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_msg() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.respos)::VARCHAR = '''' THEN
   NEW.respos := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.desmsg)::VARCHAR = '''' THEN
   NEW.desmsg := NULL;
END IF;
IF trim(NEW.anexos)::VARCHAR = '''' THEN
   NEW.anexos := NULL;
END IF;
IF trim(NEW.msgsup)::VARCHAR = '''' THEN
   NEW.msgsup := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_msg
BEFORE INSERT OR UPDATE ON tt_msg
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_msg();



/*-- SEQ 6355 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_mun() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codigo)::VARCHAR = '''' THEN
   NEW.codigo := NULL;
END IF;
IF trim(NEW.sigest)::VARCHAR = '''' THEN
   NEW.sigest := NULL;
END IF;
IF trim(NEW.cepini)::VARCHAR = '''' THEN
   NEW.cepini := NULL;
END IF;
IF trim(NEW.codcep)::VARCHAR = '''' THEN
   NEW.codcep := NULL;
END IF;
IF trim(NEW.nomcid)::VARCHAR = '''' THEN
   NEW.nomcid := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_mun
BEFORE INSERT OR UPDATE ON tt_mun
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_mun();



/*-- SEQ 6356 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_mva() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.tipope)::VARCHAR = '''' THEN
   NEW.tipope := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_mva
BEFORE INSERT OR UPDATE ON tt_mva
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_mva();



/*-- SEQ 6357 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_nae() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codnae)::VARCHAR = '''' THEN
   NEW.codnae := NULL;
END IF;
IF trim(NEW.nomnae)::VARCHAR = '''' THEN
   NEW.nomnae := NULL;
END IF;
IF trim(NEW.secnae)::VARCHAR = '''' THEN
   NEW.secnae := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_nae
BEFORE INSERT OR UPDATE ON tt_nae
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_nae();



/*-- SEQ 6358 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ncm() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.nomncm)::VARCHAR = '''' THEN
   NEW.nomncm := NULL;
END IF;
IF trim(NEW.flgati)::VARCHAR = '''' THEN
   NEW.flgati := NULL;
END IF;
IF trim(NEW.codncm)::VARCHAR = '''' THEN
   NEW.codncm := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ncm
BEFORE INSERT OR UPDATE ON tt_ncm
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ncm();



/*-- SEQ 6359 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_nfe() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.nfe_id_chave)::VARCHAR = '''' THEN
   NEW.nfe_id_chave := NULL;
END IF;
IF trim(NEW.nfe_id_versao)::VARCHAR = '''' THEN
   NEW.nfe_id_versao := NULL;
END IF;
IF trim(NEW.nfe_ds_modelo)::VARCHAR = '''' THEN
   NEW.nfe_ds_modelo := NULL;
END IF;
IF trim(NEW.nfe_ds_cnpjemit)::VARCHAR = '''' THEN
   NEW.nfe_ds_cnpjemit := NULL;
END IF;
IF trim(NEW.nfe_id_ieemit)::VARCHAR = '''' THEN
   NEW.nfe_id_ieemit := NULL;
END IF;
IF trim(NEW.nfe_ds_cnpjdest)::VARCHAR = '''' THEN
   NEW.nfe_ds_cnpjdest := NULL;
END IF;
IF trim(NEW.nfe_ds_iedest)::VARCHAR = '''' THEN
   NEW.nfe_ds_iedest := NULL;
END IF;
IF trim(NEW.nfe_ds_ufdest)::VARCHAR = '''' THEN
   NEW.nfe_ds_ufdest := NULL;
END IF;
IF trim(NEW.nfe_id_refnfe)::VARCHAR = '''' THEN
   NEW.nfe_id_refnfe := NULL;
END IF;
IF trim(NEW.nfe_codfil)::VARCHAR = '''' THEN
   NEW.nfe_codfil := NULL;
END IF;
IF trim(NEW.ven_codfil)::VARCHAR = '''' THEN
   NEW.ven_codfil := NULL;
END IF;
IF trim(NEW.ven_sequen)::VARCHAR = '''' THEN
   NEW.ven_sequen := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_nfe
BEFORE INSERT OR UPDATE ON tt_nfe
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_nfe();



/*-- SEQ 6360 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_nut() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.receit)::VARCHAR = '''' THEN
   NEW.receit := NULL;
END IF;
IF trim(NEW.porcao)::VARCHAR = '''' THEN
   NEW.porcao := NULL;
END IF;
IF trim(NEW.figura)::VARCHAR = '''' THEN
   NEW.figura := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_nut
BEFORE INSERT OR UPDATE ON tt_nut
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_nut();



/*-- SEQ 6361 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_obs() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.desobs)::VARCHAR = '''' THEN
   NEW.desobs := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_obs
BEFORE INSERT OR UPDATE ON tt_obs
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_obs();



/*-- SEQ 6362 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_oip() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.docimp)::VARCHAR = '''' THEN
   NEW.docimp := NULL;
END IF;
IF trim(NEW.tipdoc)::VARCHAR = '''' THEN
   NEW.tipdoc := NULL;
END IF;
IF trim(NEW.locdes)::VARCHAR = '''' THEN
   NEW.locdes := NULL;
END IF;
IF trim(NEW.docadq)::VARCHAR = '''' THEN
   NEW.docadq := NULL;
END IF;
IF trim(NEW.uf_adq)::VARCHAR = '''' THEN
   NEW.uf_adq := NULL;
END IF;
IF trim(NEW.cliexp)::VARCHAR = '''' THEN
   NEW.cliexp := NULL;
END IF;
IF trim(NEW.filloi)::VARCHAR = '''' THEN
   NEW.filloi := NULL;
END IF;
IF trim(NEW.seqloi)::VARCHAR = '''' THEN
   NEW.seqloi := NULL;
END IF;
IF trim(NEW.uf_des)::VARCHAR = '''' THEN
   NEW.uf_des := NULL;
END IF;
IF trim(NEW.filtra)::VARCHAR = '''' THEN
   NEW.filtra := NULL;
END IF;
IF trim(NEW.codtra)::VARCHAR = '''' THEN
   NEW.codtra := NULL;
END IF;
IF trim(NEW.destra)::VARCHAR = '''' THEN
   NEW.destra := NULL;
END IF;
IF trim(NEW.flgcad)::VARCHAR = '''' THEN
   NEW.flgcad := NULL;
END IF;
IF trim(NEW.flgemi)::VARCHAR = '''' THEN
   NEW.flgemi := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_oip
BEFORE INSERT OR UPDATE ON tt_oip
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_oip();



/*-- SEQ 6363 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_opc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filper)::VARCHAR = '''' THEN
   NEW.filper := NULL;
END IF;
IF trim(NEW.codper)::VARCHAR = '''' THEN
   NEW.codper := NULL;
END IF;
IF trim(NEW.nomopc)::VARCHAR = '''' THEN
   NEW.nomopc := NULL;
END IF;
IF trim(NEW.filres)::VARCHAR = '''' THEN
   NEW.filres := NULL;
END IF;
IF trim(NEW.codres)::VARCHAR = '''' THEN
   NEW.codres := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_opc
BEFORE INSERT OR UPDATE ON tt_opc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_opc();



/*-- SEQ 6364 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ope() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.cupfis)::VARCHAR = '''' THEN
   NEW.cupfis := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filrec)::VARCHAR = '''' THEN
   NEW.filrec := NULL;
END IF;
IF trim(NEW.seqrec)::VARCHAR = '''' THEN
   NEW.seqrec := NULL;
END IF;
IF trim(NEW.numpar)::VARCHAR = '''' THEN
   NEW.numpar := NULL;
END IF;
IF trim(NEW.subpar)::VARCHAR = '''' THEN
   NEW.subpar := NULL;
END IF;
IF trim(NEW.filccc)::VARCHAR = '''' THEN
   NEW.filccc := NULL;
END IF;
IF trim(NEW.seqccc)::VARCHAR = '''' THEN
   NEW.seqccc := NULL;
END IF;
IF trim(NEW.filchr)::VARCHAR = '''' THEN
   NEW.filchr := NULL;
END IF;
IF trim(NEW.seqchr)::VARCHAR = '''' THEN
   NEW.seqchr := NULL;
END IF;
IF trim(NEW.filfin)::VARCHAR = '''' THEN
   NEW.filfin := NULL;
END IF;
IF trim(NEW.seqfin)::VARCHAR = '''' THEN
   NEW.seqfin := NULL;
END IF;
IF trim(NEW.tipcar)::VARCHAR = '''' THEN
   NEW.tipcar := NULL;
END IF;
IF trim(NEW.fildop)::VARCHAR = '''' THEN
   NEW.fildop := NULL;
END IF;
IF trim(NEW.seqdop)::VARCHAR = '''' THEN
   NEW.seqdop := NULL;
END IF;
IF trim(NEW.doctro)::VARCHAR = '''' THEN
   NEW.doctro := NULL;
END IF;
IF trim(NEW.filtef)::VARCHAR = '''' THEN
   NEW.filtef := NULL;
END IF;
IF trim(NEW.seqtef)::VARCHAR = '''' THEN
   NEW.seqtef := NULL;
END IF;
IF trim(NEW.meipgt)::VARCHAR = '''' THEN
   NEW.meipgt := NULL;
END IF;
IF trim(NEW.filrtt)::VARCHAR = '''' THEN
   NEW.filrtt := NULL;
END IF;
IF trim(NEW.seqrtt)::VARCHAR = '''' THEN
   NEW.seqrtt := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;
IF trim(NEW.filsav)::VARCHAR = '''' THEN
   NEW.filsav := NULL;
END IF;
IF trim(NEW.seqsav)::VARCHAR = '''' THEN
   NEW.seqsav := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ope
BEFORE INSERT OR UPDATE ON tt_ope
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ope();



/*-- SEQ 6365 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_orc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.tipped)::VARCHAR = '''' THEN
   NEW.tipped := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.nature)::VARCHAR = '''' THEN
   NEW.nature := NULL;
END IF;
IF trim(NEW.tipent)::VARCHAR = '''' THEN
   NEW.tipent := NULL;
END IF;
IF trim(NEW.codpgt)::VARCHAR = '''' THEN
   NEW.codpgt := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.codven)::VARCHAR = '''' THEN
   NEW.codven := NULL;
END IF;
IF trim(NEW.filalc)::VARCHAR = '''' THEN
   NEW.filalc := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.filpgt)::VARCHAR = '''' THEN
   NEW.filpgt := NULL;
END IF;
IF trim(NEW.filpre)::VARCHAR = '''' THEN
   NEW.filpre := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.filven)::VARCHAR = '''' THEN
   NEW.filven := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.descli)::VARCHAR = '''' THEN
   NEW.descli := NULL;
END IF;
IF trim(NEW.emides)::VARCHAR = '''' THEN
   NEW.emides := NULL;
END IF;
IF trim(NEW.reserv)::VARCHAR = '''' THEN
   NEW.reserv := NULL;
END IF;
IF trim(NEW.codapr)::VARCHAR = '''' THEN
   NEW.codapr := NULL;
END IF;
IF trim(NEW.filapr)::VARCHAR = '''' THEN
   NEW.filapr := NULL;
END IF;
IF trim(NEW.filcob)::VARCHAR = '''' THEN
   NEW.filcob := NULL;
END IF;
IF trim(NEW.filent)::VARCHAR = '''' THEN
   NEW.filent := NULL;
END IF;
IF trim(NEW.filfat)::VARCHAR = '''' THEN
   NEW.filfat := NULL;
END IF;
IF trim(NEW.filreg)::VARCHAR = '''' THEN
   NEW.filreg := NULL;
END IF;
IF trim(NEW.filtra)::VARCHAR = '''' THEN
   NEW.filtra := NULL;
END IF;
IF trim(NEW.labori)::VARCHAR = '''' THEN
   NEW.labori := NULL;
END IF;
IF trim(NEW.lojori)::VARCHAR = '''' THEN
   NEW.lojori := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.numori)::VARCHAR = '''' THEN
   NEW.numori := NULL;
END IF;
IF trim(NEW.codtra)::VARCHAR = '''' THEN
   NEW.codtra := NULL;
END IF;
IF trim(NEW.cupfis)::VARCHAR = '''' THEN
   NEW.cupfis := NULL;
END IF;
IF trim(NEW.numnot)::VARCHAR = '''' THEN
   NEW.numnot := NULL;
END IF;
IF trim(NEW.codreg)::VARCHAR = '''' THEN
   NEW.codreg := NULL;
END IF;
IF trim(NEW.marcas)::VARCHAR = '''' THEN
   NEW.marcas := NULL;
END IF;
IF trim(NEW.numblo)::VARCHAR = '''' THEN
   NEW.numblo := NULL;
END IF;
IF trim(NEW.numaut)::VARCHAR = '''' THEN
   NEW.numaut := NULL;
END IF;
IF trim(NEW.numres)::VARCHAR = '''' THEN
   NEW.numres := NULL;
END IF;
IF trim(NEW.numser)::VARCHAR = '''' THEN
   NEW.numser := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.obsorc)::VARCHAR = '''' THEN
   NEW.obsorc := NULL;
END IF;
IF trim(NEW.aprova)::VARCHAR = '''' THEN
   NEW.aprova := NULL;
END IF;
IF trim(NEW.aprcli)::VARCHAR = '''' THEN
   NEW.aprcli := NULL;
END IF;
IF trim(NEW.msgvpe)::VARCHAR = '''' THEN
   NEW.msgvpe := NULL;
END IF;
IF trim(NEW.placas)::VARCHAR = '''' THEN
   NEW.placas := NULL;
END IF;
IF trim(NEW.separa)::VARCHAR = '''' THEN
   NEW.separa := NULL;
END IF;
IF trim(NEW.comand)::VARCHAR = '''' THEN
   NEW.comand := NULL;
END IF;
IF trim(NEW.filgui)::VARCHAR = '''' THEN
   NEW.filgui := NULL;
END IF;
IF trim(NEW.codgui)::VARCHAR = '''' THEN
   NEW.codgui := NULL;
END IF;
IF trim(NEW.televe)::VARCHAR = '''' THEN
   NEW.televe := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.docnfp)::VARCHAR = '''' THEN
   NEW.docnfp := NULL;
END IF;
IF trim(NEW.canpre)::VARCHAR = '''' THEN
   NEW.canpre := NULL;
END IF;
IF trim(NEW.predav)::VARCHAR = '''' THEN
   NEW.predav := NULL;
END IF;
IF trim(NEW.filadi)::VARCHAR = '''' THEN
   NEW.filadi := NULL;
END IF;
IF trim(NEW.seqadi)::VARCHAR = '''' THEN
   NEW.seqadi := NULL;
END IF;
IF trim(NEW.nomcli)::VARCHAR = '''' THEN
   NEW.nomcli := NULL;
END IF;
IF trim(NEW.dddcli)::VARCHAR = '''' THEN
   NEW.dddcli := NULL;
END IF;
IF trim(NEW.telcli)::VARCHAR = '''' THEN
   NEW.telcli := NULL;
END IF;
IF trim(NEW.numped_paf)::VARCHAR = '''' THEN
   NEW.numped_paf := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;
IF trim(NEW.codras)::VARCHAR = '''' THEN
   NEW.codras := NULL;
END IF;
IF trim(NEW.enveco)::VARCHAR = '''' THEN
   NEW.enveco := NULL;
END IF;
IF trim(NEW.flgeco)::VARCHAR = '''' THEN
   NEW.flgeco := NULL;
END IF;
IF trim(NEW.orcimp)::VARCHAR = '''' THEN
   NEW.orcimp := NULL;
END IF;
IF trim(NEW.flgbon)::VARCHAR = '''' THEN
   NEW.flgbon := NULL;
END IF;
IF trim(NEW.desvol)::VARCHAR = '''' THEN
   NEW.desvol := NULL;
END IF;
IF trim(NEW.placat)::VARCHAR = '''' THEN
   NEW.placat := NULL;
END IF;
IF trim(NEW.emailc)::VARCHAR = '''' THEN
   NEW.emailc := NULL;
END IF;
IF trim(NEW.fileqp)::VARCHAR = '''' THEN
   NEW.fileqp := NULL;
END IF;
IF trim(NEW.seqeqp)::VARCHAR = '''' THEN
   NEW.seqeqp := NULL;
END IF;
IF trim(NEW.filwor)::VARCHAR = '''' THEN
   NEW.filwor := NULL;
END IF;
IF trim(NEW.seqwor)::VARCHAR = '''' THEN
   NEW.seqwor := NULL;
END IF;
IF trim(NEW.trnecf)::VARCHAR = '''' THEN
   NEW.trnecf := NULL;
END IF;
IF trim(NEW.numped_re)::VARCHAR = '''' THEN
   NEW.numped_re := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.metent)::VARCHAR = '''' THEN
   NEW.metent := NULL;
END IF;
IF trim(NEW.urlent)::VARCHAR = '''' THEN
   NEW.urlent := NULL;
END IF;
IF trim(NEW.tippag)::VARCHAR = '''' THEN
   NEW.tippag := NULL;
END IF;
IF trim(NEW.filcup)::VARCHAR = '''' THEN
   NEW.filcup := NULL;
END IF;
IF trim(NEW.seqcup)::VARCHAR = '''' THEN
   NEW.seqcup := NULL;
END IF;
IF trim(NEW.expem4)::VARCHAR = '''' THEN
   NEW.expem4 := NULL;
END IF;
IF trim(NEW.filret)::VARCHAR = '''' THEN
   NEW.filret := NULL;
END IF;
IF trim(NEW.numpedcom)::VARCHAR = '''' THEN
   NEW.numpedcom := NULL;
END IF;
IF trim(NEW.impsep)::VARCHAR = '''' THEN
   NEW.impsep := NULL;
END IF;
IF trim(NEW.e_json)::VARCHAR = '''' THEN
   NEW.e_json := NULL;
END IF;
IF trim(NEW.sisori)::VARCHAR = '''' THEN
   NEW.sisori := NULL;
END IF;
IF trim(NEW.codident)::VARCHAR = '''' THEN
   NEW.codident := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_orc
BEFORE INSERT OR UPDATE ON tt_orc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_orc();



/*-- SEQ 6366 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_orc_eco() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filorc)::VARCHAR = '''' THEN
   NEW.filorc := NULL;
END IF;
IF trim(NEW.tiporc)::VARCHAR = '''' THEN
   NEW.tiporc := NULL;
END IF;
IF trim(NEW.numorc)::VARCHAR = '''' THEN
   NEW.numorc := NULL;
END IF;
IF trim(NEW.flgeco)::VARCHAR = '''' THEN
   NEW.flgeco := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_orc_eco
BEFORE INSERT OR UPDATE ON tt_orc_eco
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_orc_eco();



/*-- SEQ 6367 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_out() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codtab)::VARCHAR = '''' THEN
   NEW.codtab := NULL;
END IF;
IF trim(NEW.sqlout)::VARCHAR = '''' THEN
   NEW.sqlout := NULL;
END IF;
IF trim(NEW.titout)::VARCHAR = '''' THEN
   NEW.titout := NULL;
END IF;
IF trim(NEW.sqlout2)::VARCHAR = '''' THEN
   NEW.sqlout2 := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_out
BEFORE INSERT OR UPDATE ON tt_out
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_out();



/*-- SEQ 6368 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_out_bak() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codtab)::VARCHAR = '''' THEN
   NEW.codtab := NULL;
END IF;
IF trim(NEW.sqlout)::VARCHAR = '''' THEN
   NEW.sqlout := NULL;
END IF;
IF trim(NEW.titout)::VARCHAR = '''' THEN
   NEW.titout := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_out_bak
BEFORE INSERT OR UPDATE ON tt_out_bak
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_out_bak();



/*-- SEQ 6369 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_pag() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.numpar)::VARCHAR = '''' THEN
   NEW.numpar := NULL;
END IF;
IF trim(NEW.subpar)::VARCHAR = '''' THEN
   NEW.subpar := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.codaut)::VARCHAR = '''' THEN
   NEW.codaut := NULL;
END IF;
IF trim(NEW.codpro)::VARCHAR = '''' THEN
   NEW.codpro := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filaut)::VARCHAR = '''' THEN
   NEW.filaut := NULL;
END IF;
IF trim(NEW.fildop)::VARCHAR = '''' THEN
   NEW.fildop := NULL;
END IF;
IF trim(NEW.filpro)::VARCHAR = '''' THEN
   NEW.filpro := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.seqdop)::VARCHAR = '''' THEN
   NEW.seqdop := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.conpgt)::VARCHAR = '''' THEN
   NEW.conpgt := NULL;
END IF;
IF trim(NEW.docpgt)::VARCHAR = '''' THEN
   NEW.docpgt := NULL;
END IF;
IF trim(NEW.flgflu)::VARCHAR = '''' THEN
   NEW.flgflu := NULL;
END IF;
IF trim(NEW.subori)::VARCHAR = '''' THEN
   NEW.subori := NULL;
END IF;
IF trim(NEW.autban)::VARCHAR = '''' THEN
   NEW.autban := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_pag
BEFORE INSERT OR UPDATE ON tt_pag
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_pag();



/*-- SEQ 6370 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_pap() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.despap)::VARCHAR = '''' THEN
   NEW.despap := NULL;
END IF;
IF trim(NEW.permis)::VARCHAR = '''' THEN
   NEW.permis := NULL;
END IF;
IF trim(NEW.peraut)::VARCHAR = '''' THEN
   NEW.peraut := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_pap
BEFORE INSERT OR UPDATE ON tt_pap
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_pap();



/*-- SEQ 6371 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_papxusu() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filpap)::VARCHAR = '''' THEN
   NEW.filpap := NULL;
END IF;
IF trim(NEW.seqpap)::VARCHAR = '''' THEN
   NEW.seqpap := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_papxusu
BEFORE INSERT OR UPDATE ON tt_papxusu
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_papxusu();



/*-- SEQ 6372 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_pcs() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.pcsati)::VARCHAR = '''' THEN
   NEW.pcsati := NULL;
END IF;
IF trim(NEW.nompcs)::VARCHAR = '''' THEN
   NEW.nompcs := NULL;
END IF;
IF trim(NEW.despcs)::VARCHAR = '''' THEN
   NEW.despcs := NULL;
END IF;
IF trim(NEW.tippcs)::VARCHAR = '''' THEN
   NEW.tippcs := NULL;
END IF;
IF trim(NEW.pcsger)::VARCHAR = '''' THEN
   NEW.pcsger := NULL;
END IF;
IF trim(NEW.pcsfil)::VARCHAR = '''' THEN
   NEW.pcsfil := NULL;
END IF;
IF trim(NEW.pcsecf)::VARCHAR = '''' THEN
   NEW.pcsecf := NULL;
END IF;
IF trim(NEW.pcsser)::VARCHAR = '''' THEN
   NEW.pcsser := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_pcs
BEFORE INSERT OR UPDATE ON tt_pcs
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_pcs();



/*-- SEQ 6373 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ped() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.tipfor)::VARCHAR = '''' THEN
   NEW.tipfor := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filfor)::VARCHAR = '''' THEN
   NEW.filfor := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;
IF trim(NEW.codapr)::VARCHAR = '''' THEN
   NEW.codapr := NULL;
END IF;
IF trim(NEW.filapr)::VARCHAR = '''' THEN
   NEW.filapr := NULL;
END IF;
IF trim(NEW.conpgt)::VARCHAR = '''' THEN
   NEW.conpgt := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;
IF trim(NEW.pedfor)::VARCHAR = '''' THEN
   NEW.pedfor := NULL;
END IF;
IF trim(NEW.venent)::VARCHAR = '''' THEN
   NEW.venent := NULL;
END IF;
IF trim(NEW.pedext)::VARCHAR = '''' THEN
   NEW.pedext := NULL;
END IF;
IF trim(NEW.conven)::VARCHAR = '''' THEN
   NEW.conven := NULL;
END IF;
IF trim(NEW.filend)::VARCHAR = '''' THEN
   NEW.filend := NULL;
END IF;
IF trim(NEW.promoc)::VARCHAR = '''' THEN
   NEW.promoc := NULL;
END IF;
IF trim(NEW.nomarq)::VARCHAR = '''' THEN
   NEW.nomarq := NULL;
END IF;
IF trim(NEW.codcon)::VARCHAR = '''' THEN
   NEW.codcon := NULL;
END IF;
IF trim(NEW.atuped)::VARCHAR = '''' THEN
   NEW.atuped := NULL;
END IF;
IF trim(NEW.freori)::VARCHAR = '''' THEN
   NEW.freori := NULL;
END IF;
IF trim(NEW.traaut)::VARCHAR = '''' THEN
   NEW.traaut := NULL;
END IF;
IF trim(NEW.impsep)::VARCHAR = '''' THEN
   NEW.impsep := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ped
BEFORE INSERT OR UPDATE ON tt_ped
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ped();



/*-- SEQ 6374 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_pedxddes() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_pedxddes
BEFORE INSERT OR UPDATE ON tt_pedxddes
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_pedxddes();



/*-- SEQ 6375 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_per() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filper)::VARCHAR = '''' THEN
   NEW.filper := NULL;
END IF;
IF trim(NEW.codper)::VARCHAR = '''' THEN
   NEW.codper := NULL;
END IF;
IF trim(NEW.titper)::VARCHAR = '''' THEN
   NEW.titper := NULL;
END IF;
IF trim(NEW.forrep)::VARCHAR = '''' THEN
   NEW.forrep := NULL;
END IF;
IF trim(NEW.mulesc)::VARCHAR = '''' THEN
   NEW.mulesc := NULL;
END IF;
IF trim(NEW.msgper)::VARCHAR = '''' THEN
   NEW.msgper := NULL;
END IF;
IF trim(NEW.obsper)::VARCHAR = '''' THEN
   NEW.obsper := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_per
BEFORE INSERT OR UPDATE ON tt_per
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_per();



/*-- SEQ 6376 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_pho() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codbar)::VARCHAR = '''' THEN
   NEW.codbar := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_pho
BEFORE INSERT OR UPDATE ON tt_pho
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_pho();



/*-- SEQ 6377 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_piv() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_piv
BEFORE INSERT OR UPDATE ON tt_piv
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_piv();



/*-- SEQ 6378 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_pla() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filpgt)::VARCHAR = '''' THEN
   NEW.filpgt := NULL;
END IF;
IF trim(NEW.codpgt)::VARCHAR = '''' THEN
   NEW.codpgt := NULL;
END IF;
IF trim(NEW.preinf)::VARCHAR = '''' THEN
   NEW.preinf := NULL;
END IF;
IF trim(NEW.tipcob)::VARCHAR = '''' THEN
   NEW.tipcob := NULL;
END IF;
IF trim(NEW.caronl)::VARCHAR = '''' THEN
   NEW.caronl := NULL;
END IF;
IF trim(NEW.entvlr)::VARCHAR = '''' THEN
   NEW.entvlr := NULL;
END IF;
IF trim(NEW.fatura)::VARCHAR = '''' THEN
   NEW.fatura := NULL;
END IF;
IF trim(NEW.flgesp)::VARCHAR = '''' THEN
   NEW.flgesp := NULL;
END IF;
IF trim(NEW.jurtot)::VARCHAR = '''' THEN
   NEW.jurtot := NULL;
END IF;
IF trim(NEW.apepgt)::VARCHAR = '''' THEN
   NEW.apepgt := NULL;
END IF;
IF trim(NEW.despgt)::VARCHAR = '''' THEN
   NEW.despgt := NULL;
END IF;
IF trim(NEW.propor)::VARCHAR = '''' THEN
   NEW.propor := NULL;
END IF;
IF trim(NEW.usacam)::VARCHAR = '''' THEN
   NEW.usacam := NULL;
END IF;
IF trim(NEW.usache)::VARCHAR = '''' THEN
   NEW.usache := NULL;
END IF;
IF trim(NEW.usacre)::VARCHAR = '''' THEN
   NEW.usacre := NULL;
END IF;
IF trim(NEW.usac_c)::VARCHAR = '''' THEN
   NEW.usac_c := NULL;
END IF;
IF trim(NEW.usadin)::VARCHAR = '''' THEN
   NEW.usadin := NULL;
END IF;
IF trim(NEW.usaout)::VARCHAR = '''' THEN
   NEW.usaout := NULL;
END IF;
IF trim(NEW.usatef)::VARCHAR = '''' THEN
   NEW.usatef := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.desrec)::VARCHAR = '''' THEN
   NEW.desrec := NULL;
END IF;
IF trim(NEW.renego)::VARCHAR = '''' THEN
   NEW.renego := NULL;
END IF;
IF trim(NEW.rensob)::VARCHAR = '''' THEN
   NEW.rensob := NULL;
END IF;
IF trim(NEW.intpmu)::VARCHAR = '''' THEN
   NEW.intpmu := NULL;
END IF;
IF trim(NEW.usacpp)::VARCHAR = '''' THEN
   NEW.usacpp := NULL;
END IF;
IF trim(NEW.usadeb)::VARCHAR = '''' THEN
   NEW.usadeb := NULL;
END IF;
IF trim(NEW.sobneg)::VARCHAR = '''' THEN
   NEW.sobneg := NULL;
END IF;
IF trim(NEW.permite_entrega_pgt)::VARCHAR = '''' THEN
   NEW.permite_entrega_pgt := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_pla
BEFORE INSERT OR UPDATE ON tt_pla
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_pla();



/*-- SEQ 6379 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_plaxcar() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filpgt)::VARCHAR = '''' THEN
   NEW.filpgt := NULL;
END IF;
IF trim(NEW.codpgt)::VARCHAR = '''' THEN
   NEW.codpgt := NULL;
END IF;
IF trim(NEW.flgcre)::VARCHAR = '''' THEN
   NEW.flgcre := NULL;
END IF;
IF trim(NEW.flgdeb)::VARCHAR = '''' THEN
   NEW.flgdeb := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_plaxcar
BEFORE INSERT OR UPDATE ON tt_plaxcar
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_plaxcar();



/*-- SEQ 6380 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_por() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.tipped)::VARCHAR = '''' THEN
   NEW.tipped := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.numpar)::VARCHAR = '''' THEN
   NEW.numpar := NULL;
END IF;
IF trim(NEW.tipmei)::VARCHAR = '''' THEN
   NEW.tipmei := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_por
BEFORE INSERT OR UPDATE ON tt_por
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_por();



/*-- SEQ 6381 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ppr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.expem4)::VARCHAR = '''' THEN
   NEW.expem4 := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ppr
BEFORE INSERT OR UPDATE ON tt_ppr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ppr();



/*-- SEQ 6382 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_pre() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filpre)::VARCHAR = '''' THEN
   NEW.filpre := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_pre
BEFORE INSERT OR UPDATE ON tt_pre
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_pre();



/*-- SEQ 6383 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_prexdif() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filreg)::VARCHAR = '''' THEN
   NEW.filreg := NULL;
END IF;
IF trim(NEW.codreg)::VARCHAR = '''' THEN
   NEW.codreg := NULL;
END IF;
IF trim(NEW.filatu)::VARCHAR = '''' THEN
   NEW.filatu := NULL;
END IF;
IF trim(NEW.codatu)::VARCHAR = '''' THEN
   NEW.codatu := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.filacp)::VARCHAR = '''' THEN
   NEW.filacp := NULL;
END IF;
IF trim(NEW.codacp)::VARCHAR = '''' THEN
   NEW.codacp := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_prexdif
BEFORE INSERT OR UPDATE ON tt_prexdif
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_prexdif();



/*-- SEQ 6384 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_prj() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.respon)::VARCHAR = '''' THEN
   NEW.respon := NULL;
END IF;
IF trim(NEW.codatu)::VARCHAR = '''' THEN
   NEW.codatu := NULL;
END IF;
IF trim(NEW.codreg)::VARCHAR = '''' THEN
   NEW.codreg := NULL;
END IF;
IF trim(NEW.filatu)::VARCHAR = '''' THEN
   NEW.filatu := NULL;
END IF;
IF trim(NEW.filreg)::VARCHAR = '''' THEN
   NEW.filreg := NULL;
END IF;
IF trim(NEW.reserv)::VARCHAR = '''' THEN
   NEW.reserv := NULL;
END IF;
IF trim(NEW.tipact)::VARCHAR = '''' THEN
   NEW.tipact := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filact)::VARCHAR = '''' THEN
   NEW.filact := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.filpai)::VARCHAR = '''' THEN
   NEW.filpai := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codact)::VARCHAR = '''' THEN
   NEW.codact := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.seqpai)::VARCHAR = '''' THEN
   NEW.seqpai := NULL;
END IF;
IF trim(NEW.flgact)::VARCHAR = '''' THEN
   NEW.flgact := NULL;
END IF;
IF trim(NEW.anexos)::VARCHAR = '''' THEN
   NEW.anexos := NULL;
END IF;
IF trim(NEW.aviext)::VARCHAR = '''' THEN
   NEW.aviext := NULL;
END IF;
IF trim(NEW.aviint)::VARCHAR = '''' THEN
   NEW.aviint := NULL;
END IF;
IF trim(NEW.docume)::VARCHAR = '''' THEN
   NEW.docume := NULL;
END IF;
IF trim(NEW.msgreq)::VARCHAR = '''' THEN
   NEW.msgreq := NULL;
END IF;
IF trim(NEW.revisa)::VARCHAR = '''' THEN
   NEW.revisa := NULL;
END IF;
IF trim(NEW.chvprj)::VARCHAR = '''' THEN
   NEW.chvprj := NULL;
END IF;
IF trim(NEW.chvpai)::VARCHAR = '''' THEN
   NEW.chvpai := NULL;
END IF;
IF trim(NEW.filres)::VARCHAR = '''' THEN
   NEW.filres := NULL;
END IF;
IF trim(NEW.codres)::VARCHAR = '''' THEN
   NEW.codres := NULL;
END IF;
IF trim(NEW.status)::VARCHAR = '''' THEN
   NEW.status := NULL;
END IF;
IF trim(NEW.nomprj)::VARCHAR = '''' THEN
   NEW.nomprj := NULL;
END IF;
IF trim(NEW.tipfun)::VARCHAR = '''' THEN
   NEW.tipfun := NULL;
END IF;
IF trim(NEW.patdoc)::VARCHAR = '''' THEN
   NEW.patdoc := NULL;
END IF;
IF trim(NEW.notifi)::VARCHAR = '''' THEN
   NEW.notifi := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_prj
BEFORE INSERT OR UPDATE ON tt_prj
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_prj();



/*-- SEQ 6385 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_prjxpap() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filprj)::VARCHAR = '''' THEN
   NEW.filprj := NULL;
END IF;
IF trim(NEW.seqprj)::VARCHAR = '''' THEN
   NEW.seqprj := NULL;
END IF;
IF trim(NEW.filpap)::VARCHAR = '''' THEN
   NEW.filpap := NULL;
END IF;
IF trim(NEW.seqpap)::VARCHAR = '''' THEN
   NEW.seqpap := NULL;
END IF;
IF trim(NEW.lerprj)::VARCHAR = '''' THEN
   NEW.lerprj := NULL;
END IF;
IF trim(NEW.regwor)::VARCHAR = '''' THEN
   NEW.regwor := NULL;
END IF;
IF trim(NEW.reswor)::VARCHAR = '''' THEN
   NEW.reswor := NULL;
END IF;
IF trim(NEW.tstwor)::VARCHAR = '''' THEN
   NEW.tstwor := NULL;
END IF;
IF trim(NEW.excwor)::VARCHAR = '''' THEN
   NEW.excwor := NULL;
END IF;
IF trim(NEW.prowor)::VARCHAR = '''' THEN
   NEW.prowor := NULL;
END IF;
IF trim(NEW.plawor)::VARCHAR = '''' THEN
   NEW.plawor := NULL;
END IF;
IF trim(NEW.gerwor)::VARCHAR = '''' THEN
   NEW.gerwor := NULL;
END IF;
IF trim(NEW.valrat)::VARCHAR = '''' THEN
   NEW.valrat := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_prjxpap
BEFORE INSERT OR UPDATE ON tt_prjxpap
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_prjxpap();



/*-- SEQ 6386 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_prjxprj() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filprj)::VARCHAR = '''' THEN
   NEW.filprj := NULL;
END IF;
IF trim(NEW.seqprj)::VARCHAR = '''' THEN
   NEW.seqprj := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_prjxprj
BEFORE INSERT OR UPDATE ON tt_prjxprj
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_prjxprj();



/*-- SEQ 6387 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_prjxusu() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filprj)::VARCHAR = '''' THEN
   NEW.filprj := NULL;
END IF;
IF trim(NEW.seqprj)::VARCHAR = '''' THEN
   NEW.seqprj := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_prjxusu
BEFORE INSERT OR UPDATE ON tt_prjxusu
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_prjxusu();



/*-- SEQ 6388 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_pro() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.contra)::VARCHAR = '''' THEN
   NEW.contra := NULL;
END IF;
IF trim(NEW.contro)::VARCHAR = '''' THEN
   NEW.contro := NULL;
END IF;
IF trim(NEW.decima)::VARCHAR = '''' THEN
   NEW.decima := NULL;
END IF;
IF trim(NEW.montar)::VARCHAR = '''' THEN
   NEW.montar := NULL;
END IF;
IF trim(NEW.numext)::VARCHAR = '''' THEN
   NEW.numext := NULL;
END IF;
IF trim(NEW.refbas)::VARCHAR = '''' THEN
   NEW.refbas := NULL;
END IF;
IF trim(NEW.desmat)::VARCHAR = '''' THEN
   NEW.desmat := NULL;
END IF;
IF trim(NEW.tipmar)::VARCHAR = '''' THEN
   NEW.tipmar := NULL;
END IF;
IF trim(NEW.filmar)::VARCHAR = '''' THEN
   NEW.filmar := NULL;
END IF;
IF trim(NEW.codmar)::VARCHAR = '''' THEN
   NEW.codmar := NULL;
END IF;
IF trim(NEW.desecf)::VARCHAR = '''' THEN
   NEW.desecf := NULL;
END IF;
IF trim(NEW.espmat)::VARCHAR = '''' THEN
   NEW.espmat := NULL;
END IF;
IF trim(NEW.nomimg)::VARCHAR = '''' THEN
   NEW.nomimg := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.entreg)::VARCHAR = '''' THEN
   NEW.entreg := NULL;
END IF;
IF trim(NEW.retcof)::VARCHAR = '''' THEN
   NEW.retcof := NULL;
END IF;
IF trim(NEW.subfed)::VARCHAR = '''' THEN
   NEW.subfed := NULL;
END IF;
IF trim(NEW.sugser)::VARCHAR = '''' THEN
   NEW.sugser := NULL;
END IF;
IF trim(NEW.balsim)::VARCHAR = '''' THEN
   NEW.balsim := NULL;
END IF;
IF trim(NEW.filcla)::VARCHAR = '''' THEN
   NEW.filcla := NULL;
END IF;
IF trim(NEW.seqcla)::VARCHAR = '''' THEN
   NEW.seqcla := NULL;
END IF;
IF trim(NEW.terass)::VARCHAR = '''' THEN
   NEW.terass := NULL;
END IF;
IF trim(NEW.flgser)::VARCHAR = '''' THEN
   NEW.flgser := NULL;
END IF;
IF trim(NEW.valest)::VARCHAR = '''' THEN
   NEW.valest := NULL;
END IF;
IF trim(NEW.tipdoc)::VARCHAR = '''' THEN
   NEW.tipdoc := NULL;
END IF;
IF trim(NEW.isepis)::VARCHAR = '''' THEN
   NEW.isepis := NULL;
END IF;
IF trim(NEW.icmfed)::VARCHAR = '''' THEN
   NEW.icmfed := NULL;
END IF;
IF trim(NEW.arrtru)::VARCHAR = '''' THEN
   NEW.arrtru := NULL;
END IF;
IF trim(NEW.iiptpr)::VARCHAR = '''' THEN
   NEW.iiptpr := NULL;
END IF;
IF trim(NEW.sitcof)::VARCHAR = '''' THEN
   NEW.sitcof := NULL;
END IF;
IF trim(NEW.sitpis)::VARCHAR = '''' THEN
   NEW.sitpis := NULL;
END IF;
IF trim(NEW.impkit)::VARCHAR = '''' THEN
   NEW.impkit := NULL;
END IF;
IF trim(NEW.codfps)::VARCHAR = '''' THEN
   NEW.codfps := NULL;
END IF;
IF trim(NEW.sitipi)::VARCHAR = '''' THEN
   NEW.sitipi := NULL;
END IF;
IF trim(NEW.oripro)::VARCHAR = '''' THEN
   NEW.oripro := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;
IF trim(NEW.desdet)::VARCHAR = '''' THEN
   NEW.desdet := NULL;
END IF;
IF trim(NEW.natbcc)::VARCHAR = '''' THEN
   NEW.natbcc := NULL;
END IF;
IF trim(NEW.tipmpb)::VARCHAR = '''' THEN
   NEW.tipmpb := NULL;
END IF;
IF trim(NEW.desweb)::VARCHAR = '''' THEN
   NEW.desweb := NULL;
END IF;
IF trim(NEW.filcta_venest)::VARCHAR = '''' THEN
   NEW.filcta_venest := NULL;
END IF;
IF trim(NEW.seqcta_venest)::VARCHAR = '''' THEN
   NEW.seqcta_venest := NULL;
END IF;
IF trim(NEW.tipcta_venest)::VARCHAR = '''' THEN
   NEW.tipcta_venest := NULL;
END IF;
IF trim(NEW.filcta_comest)::VARCHAR = '''' THEN
   NEW.filcta_comest := NULL;
END IF;
IF trim(NEW.seqcta_comest)::VARCHAR = '''' THEN
   NEW.seqcta_comest := NULL;
END IF;
IF trim(NEW.tipcta_comest)::VARCHAR = '''' THEN
   NEW.tipcta_comest := NULL;
END IF;
IF trim(NEW.obsmpb)::VARCHAR = '''' THEN
   NEW.obsmpb := NULL;
END IF;
IF trim(NEW.usalot)::VARCHAR = '''' THEN
   NEW.usalot := NULL;
END IF;
IF trim(NEW.sitpiscom)::VARCHAR = '''' THEN
   NEW.sitpiscom := NULL;
END IF;
IF trim(NEW.sitcofcom)::VARCHAR = '''' THEN
   NEW.sitcofcom := NULL;
END IF;
IF trim(NEW.codncm)::VARCHAR = '''' THEN
   NEW.codncm := NULL;
END IF;
IF trim(NEW.filifo)::VARCHAR = '''' THEN
   NEW.filifo := NULL;
END IF;
IF trim(NEW.seqifo)::VARCHAR = '''' THEN
   NEW.seqifo := NULL;
END IF;
IF trim(NEW.lotonl)::VARCHAR = '''' THEN
   NEW.lotonl := NULL;
END IF;
IF trim(NEW.obimei)::VARCHAR = '''' THEN
   NEW.obimei := NULL;
END IF;
IF trim(NEW.confer)::VARCHAR = '''' THEN
   NEW.confer := NULL;
END IF;
IF trim(NEW.codces)::VARCHAR = '''' THEN
   NEW.codces := NULL;
END IF;
IF trim(NEW.for060)::VARCHAR = '''' THEN
   NEW.for060 := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.procon)::VARCHAR = '''' THEN
   NEW.procon := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_pro
BEFORE INSERT OR UPDATE ON tt_pro
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_pro();



/*-- SEQ 6389 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_proxnom() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codsom)::VARCHAR = '''' THEN
   NEW.codsom := NULL;
END IF;
IF trim(NEW.desnom)::VARCHAR = '''' THEN
   NEW.desnom := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_proxnom
BEFORE INSERT OR UPDATE ON tt_proxnom
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_proxnom();



/*-- SEQ 6390 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_psu() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_psu
BEFORE INSERT OR UPDATE ON tt_psu
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_psu();



/*-- SEQ 6391 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ptc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.tipptc)::VARCHAR = '''' THEN
   NEW.tipptc := NULL;
END IF;
IF trim(NEW.desptc)::VARCHAR = '''' THEN
   NEW.desptc := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ptc
BEFORE INSERT OR UPDATE ON tt_ptc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ptc();



/*-- SEQ 6392 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ptr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.numpar)::VARCHAR = '''' THEN
   NEW.numpar := NULL;
END IF;
IF trim(NEW.subpar)::VARCHAR = '''' THEN
   NEW.subpar := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.flgflu)::VARCHAR = '''' THEN
   NEW.flgflu := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ptr
BEFORE INSERT OR UPDATE ON tt_ptr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ptr();



/*-- SEQ 6393 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_pxf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.filfor)::VARCHAR = '''' THEN
   NEW.filfor := NULL;
END IF;
IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;
IF trim(NEW.tipfor)::VARCHAR = '''' THEN
   NEW.tipfor := NULL;
END IF;
IF trim(NEW.repase)::VARCHAR = '''' THEN
   NEW.repase := NULL;
END IF;
IF trim(NEW.oricus)::VARCHAR = '''' THEN
   NEW.oricus := NULL;
END IF;
IF trim(NEW.icmtip)::VARCHAR = '''' THEN
   NEW.icmtip := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_pxf
BEFORE INSERT OR UPDATE ON tt_pxf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_pxf();



/*-- SEQ 6394 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_pxr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.diasem)::VARCHAR = '''' THEN
   NEW.diasem := NULL;
END IF;
IF trim(NEW.diames)::VARCHAR = '''' THEN
   NEW.diames := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_pxr
BEFORE INSERT OR UPDATE ON tt_pxr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_pxr();



/*-- SEQ 6395 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_qry() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.qrychv)::VARCHAR = '''' THEN
   NEW.qrychv := NULL;
END IF;
IF trim(NEW.qrydes)::VARCHAR = '''' THEN
   NEW.qrydes := NULL;
END IF;
IF trim(NEW.qryati)::VARCHAR = '''' THEN
   NEW.qryati := NULL;
END IF;
IF trim(NEW.qryexp)::VARCHAR = '''' THEN
   NEW.qryexp := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_qry
BEFORE INSERT OR UPDATE ON tt_qry
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_qry();



/*-- SEQ 6396 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_que() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filque)::VARCHAR = '''' THEN
   NEW.filque := NULL;
END IF;
IF trim(NEW.codque)::VARCHAR = '''' THEN
   NEW.codque := NULL;
END IF;
IF trim(NEW.titque)::VARCHAR = '''' THEN
   NEW.titque := NULL;
END IF;
IF trim(NEW.avista)::VARCHAR = '''' THEN
   NEW.avista := NULL;
END IF;
IF trim(NEW.priper)::VARCHAR = '''' THEN
   NEW.priper := NULL;
END IF;
IF trim(NEW.regpre)::VARCHAR = '''' THEN
   NEW.regpre := NULL;
END IF;
IF trim(NEW.regven)::VARCHAR = '''' THEN
   NEW.regven := NULL;
END IF;
IF trim(NEW.regcli)::VARCHAR = '''' THEN
   NEW.regcli := NULL;
END IF;
IF trim(NEW.regsac)::VARCHAR = '''' THEN
   NEW.regsac := NULL;
END IF;
IF trim(NEW.posven)::VARCHAR = '''' THEN
   NEW.posven := NULL;
END IF;
IF trim(NEW.posrem)::VARCHAR = '''' THEN
   NEW.posrem := NULL;
END IF;
IF trim(NEW.posent)::VARCHAR = '''' THEN
   NEW.posent := NULL;
END IF;
IF trim(NEW.posmon)::VARCHAR = '''' THEN
   NEW.posmon := NULL;
END IF;
IF trim(NEW.regmkt)::VARCHAR = '''' THEN
   NEW.regmkt := NULL;
END IF;
IF trim(NEW.regwor)::VARCHAR = '''' THEN
   NEW.regwor := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_que
BEFORE INSERT OR UPDATE ON tt_que
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_que();



/*-- SEQ 6397 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_rat() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filres)::VARCHAR = '''' THEN
   NEW.filres := NULL;
END IF;
IF trim(NEW.codres)::VARCHAR = '''' THEN
   NEW.codres := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.status)::VARCHAR = '''' THEN
   NEW.status := NULL;
END IF;
IF trim(NEW.filrev)::VARCHAR = '''' THEN
   NEW.filrev := NULL;
END IF;
IF trim(NEW.codrev)::VARCHAR = '''' THEN
   NEW.codrev := NULL;
END IF;
IF trim(NEW.sitfat)::VARCHAR = '''' THEN
   NEW.sitfat := NULL;
END IF;
IF trim(NEW.sitpag)::VARCHAR = '''' THEN
   NEW.sitpag := NULL;
END IF;
IF trim(NEW.filapr)::VARCHAR = '''' THEN
   NEW.filapr := NULL;
END IF;
IF trim(NEW.codapr)::VARCHAR = '''' THEN
   NEW.codapr := NULL;
END IF;
IF trim(NEW.coment)::VARCHAR = '''' THEN
   NEW.coment := NULL;
END IF;
IF trim(NEW.filprj)::VARCHAR = '''' THEN
   NEW.filprj := NULL;
END IF;
IF trim(NEW.seqprj)::VARCHAR = '''' THEN
   NEW.seqprj := NULL;
END IF;
IF trim(NEW.filpar)::VARCHAR = '''' THEN
   NEW.filpar := NULL;
END IF;
IF trim(NEW.codpar)::VARCHAR = '''' THEN
   NEW.codpar := NULL;
END IF;
IF trim(NEW.tippar)::VARCHAR = '''' THEN
   NEW.tippar := NULL;
END IF;
IF trim(NEW.filcri)::VARCHAR = '''' THEN
   NEW.filcri := NULL;
END IF;
IF trim(NEW.codcri)::VARCHAR = '''' THEN
   NEW.codcri := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_rat
BEFORE INSERT OR UPDATE ON tt_rat
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_rat();



/*-- SEQ 6398 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_rcp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.tipfor)::VARCHAR = '''' THEN
   NEW.tipfor := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filfor)::VARCHAR = '''' THEN
   NEW.filfor := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;
IF trim(NEW.numnot)::VARCHAR = '''' THEN
   NEW.numnot := NULL;
END IF;
IF trim(NEW.codsup)::VARCHAR = '''' THEN
   NEW.codsup := NULL;
END IF;
IF trim(NEW.filsup)::VARCHAR = '''' THEN
   NEW.filsup := NULL;
END IF;
IF trim(NEW.subser)::VARCHAR = '''' THEN
   NEW.subser := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_rcp
BEFORE INSERT OR UPDATE ON tt_rcp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_rcp();



/*-- SEQ 6399 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_rct() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.numrct)::VARCHAR = '''' THEN
   NEW.numrct := NULL;
END IF;
IF trim(NEW.nompac)::VARCHAR = '''' THEN
   NEW.nompac := NULL;
END IF;
IF trim(NEW.rg_pac)::VARCHAR = '''' THEN
   NEW.rg_pac := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_rct
BEFORE INSERT OR UPDATE ON tt_rct
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_rct();



/*-- SEQ 6400 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_rdp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.fildes)::VARCHAR = '''' THEN
   NEW.fildes := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.codrec)::VARCHAR = '''' THEN
   NEW.codrec := NULL;
END IF;
IF trim(NEW.filrec)::VARCHAR = '''' THEN
   NEW.filrec := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_rdp
BEFORE INSERT OR UPDATE ON tt_rdp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_rdp();



/*-- SEQ 6401 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_rdv() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.tipped)::VARCHAR = '''' THEN
   NEW.tipped := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.tiprdv)::VARCHAR = '''' THEN
   NEW.tiprdv := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.numcar)::VARCHAR = '''' THEN
   NEW.numcar := NULL;
END IF;
IF trim(NEW.codnac)::VARCHAR = '''' THEN
   NEW.codnac := NULL;
END IF;
IF trim(NEW.cidtit)::VARCHAR = '''' THEN
   NEW.cidtit := NULL;
END IF;
IF trim(NEW.endtit)::VARCHAR = '''' THEN
   NEW.endtit := NULL;
END IF;
IF trim(NEW.ceptit)::VARCHAR = '''' THEN
   NEW.ceptit := NULL;
END IF;
IF trim(NEW.esttit)::VARCHAR = '''' THEN
   NEW.esttit := NULL;
END IF;
IF trim(NEW.numtrn)::VARCHAR = '''' THEN
   NEW.numtrn := NULL;
END IF;
IF trim(NEW.id_trn)::VARCHAR = '''' THEN
   NEW.id_trn := NULL;
END IF;
IF trim(NEW.numaut)::VARCHAR = '''' THEN
   NEW.numaut := NULL;
END IF;
IF trim(NEW.extcar)::VARCHAR = '''' THEN
   NEW.extcar := NULL;
END IF;
IF trim(NEW.nosnum)::VARCHAR = '''' THEN
   NEW.nosnum := NULL;
END IF;
IF trim(NEW.vldcar)::VARCHAR = '''' THEN
   NEW.vldcar := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_rdv
BEFORE INSERT OR UPDATE ON tt_rdv
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_rdv();



/*-- SEQ 6402 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_rec() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.numpar)::VARCHAR = '''' THEN
   NEW.numpar := NULL;
END IF;
IF trim(NEW.subpar)::VARCHAR = '''' THEN
   NEW.subpar := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filrec)::VARCHAR = '''' THEN
   NEW.filrec := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.cupfis)::VARCHAR = '''' THEN
   NEW.cupfis := NULL;
END IF;
IF trim(NEW.seqche)::VARCHAR = '''' THEN
   NEW.seqche := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.flgflu)::VARCHAR = '''' THEN
   NEW.flgflu := NULL;
END IF;
IF trim(NEW.subori)::VARCHAR = '''' THEN
   NEW.subori := NULL;
END IF;
IF trim(NEW.orirec)::VARCHAR = '''' THEN
   NEW.orirec := NULL;
END IF;
IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.filren)::VARCHAR = '''' THEN
   NEW.filren := NULL;
END IF;
IF trim(NEW.seqren)::VARCHAR = '''' THEN
   NEW.seqren := NULL;
END IF;
IF trim(NEW.filitf)::VARCHAR = '''' THEN
   NEW.filitf := NULL;
END IF;
IF trim(NEW.seqitf)::VARCHAR = '''' THEN
   NEW.seqitf := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.avista)::VARCHAR = '''' THEN
   NEW.avista := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;
IF trim(NEW.filpgt)::VARCHAR = '''' THEN
   NEW.filpgt := NULL;
END IF;
IF trim(NEW.codpgt)::VARCHAR = '''' THEN
   NEW.codpgt := NULL;
END IF;
IF trim(NEW.nosnum)::VARCHAR = '''' THEN
   NEW.nosnum := NULL;
END IF;
IF trim(NEW.indexp)::VARCHAR = '''' THEN
   NEW.indexp := NULL;
END IF;
IF trim(NEW.filccc)::VARCHAR = '''' THEN
   NEW.filccc := NULL;
END IF;
IF trim(NEW.seqccc)::VARCHAR = '''' THEN
   NEW.seqccc := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_rec
BEFORE INSERT OR UPDATE ON tt_rec
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_rec();



/*-- SEQ 6403 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_red() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.mesano)::VARCHAR = '''' THEN
   NEW.mesano := NULL;
END IF;
IF trim(NEW.przmed)::VARCHAR = '''' THEN
   NEW.przmed := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_red
BEFORE INSERT OR UPDATE ON tt_red
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_red();



/*-- SEQ 6404 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ref() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.tipfor)::VARCHAR = '''' THEN
   NEW.tipfor := NULL;
END IF;
IF trim(NEW.filfor)::VARCHAR = '''' THEN
   NEW.filfor := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;
IF trim(NEW.reffor)::VARCHAR = '''' THEN
   NEW.reffor := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ref
BEFORE INSERT OR UPDATE ON tt_ref
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ref();



/*-- SEQ 6405 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_reg() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codhom)::VARCHAR = '''' THEN
   NEW.codhom := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.filend)::VARCHAR = '''' THEN
   NEW.filend := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.numreg)::VARCHAR = '''' THEN
   NEW.numreg := NULL;
END IF;
IF trim(NEW.regatv)::VARCHAR = '''' THEN
   NEW.regatv := NULL;
END IF;
IF trim(NEW.numser)::VARCHAR = '''' THEN
   NEW.numser := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_reg
BEFORE INSERT OR UPDATE ON tt_reg
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_reg();



/*-- SEQ 6406 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_rel() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filpar)::VARCHAR = '''' THEN
   NEW.filpar := NULL;
END IF;
IF trim(NEW.codpar)::VARCHAR = '''' THEN
   NEW.codpar := NULL;
END IF;
IF trim(NEW.tippar)::VARCHAR = '''' THEN
   NEW.tippar := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_rel
BEFORE INSERT OR UPDATE ON tt_rel
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_rel();



/*-- SEQ 6407 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_rem() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;
IF trim(NEW.desrem)::VARCHAR = '''' THEN
   NEW.desrem := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_rem
BEFORE INSERT OR UPDATE ON tt_rem
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_rem();



/*-- SEQ 6408 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ren() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filpgt)::VARCHAR = '''' THEN
   NEW.filpgt := NULL;
END IF;
IF trim(NEW.codpgt)::VARCHAR = '''' THEN
   NEW.codpgt := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ren
BEFORE INSERT OR UPDATE ON tt_ren
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ren();



/*-- SEQ 6409 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_req() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.titreq)::VARCHAR = '''' THEN
   NEW.titreq := NULL;
END IF;
IF trim(NEW.comple)::VARCHAR = '''' THEN
   NEW.comple := NULL;
END IF;
IF trim(NEW.priori)::VARCHAR = '''' THEN
   NEW.priori := NULL;
END IF;
IF trim(NEW.risreq)::VARCHAR = '''' THEN
   NEW.risreq := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.clareq)::VARCHAR = '''' THEN
   NEW.clareq := NULL;
END IF;
IF trim(NEW.descri)::VARCHAR = '''' THEN
   NEW.descri := NULL;
END IF;
IF trim(NEW.filprj)::VARCHAR = '''' THEN
   NEW.filprj := NULL;
END IF;
IF trim(NEW.seqprj)::VARCHAR = '''' THEN
   NEW.seqprj := NULL;
END IF;
IF trim(NEW.filwor)::VARCHAR = '''' THEN
   NEW.filwor := NULL;
END IF;
IF trim(NEW.seqwor)::VARCHAR = '''' THEN
   NEW.seqwor := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.motalt)::VARCHAR = '''' THEN
   NEW.motalt := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_req
BEFORE INSERT OR UPDATE ON tt_req
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_req();



/*-- SEQ 6410 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_reqxreq() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filreq)::VARCHAR = '''' THEN
   NEW.filreq := NULL;
END IF;
IF trim(NEW.seqreq)::VARCHAR = '''' THEN
   NEW.seqreq := NULL;
END IF;
IF trim(NEW.clareq)::VARCHAR = '''' THEN
   NEW.clareq := NULL;
END IF;
IF trim(NEW.filvin)::VARCHAR = '''' THEN
   NEW.filvin := NULL;
END IF;
IF trim(NEW.seqvin)::VARCHAR = '''' THEN
   NEW.seqvin := NULL;
END IF;
IF trim(NEW.clavin)::VARCHAR = '''' THEN
   NEW.clavin := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_reqxreq
BEFORE INSERT OR UPDATE ON tt_reqxreq
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_reqxreq();



/*-- SEQ 6411 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_reqxwor() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filreq)::VARCHAR = '''' THEN
   NEW.filreq := NULL;
END IF;
IF trim(NEW.seqreq)::VARCHAR = '''' THEN
   NEW.seqreq := NULL;
END IF;
IF trim(NEW.clareq)::VARCHAR = '''' THEN
   NEW.clareq := NULL;
END IF;
IF trim(NEW.filwor)::VARCHAR = '''' THEN
   NEW.filwor := NULL;
END IF;
IF trim(NEW.seqwor)::VARCHAR = '''' THEN
   NEW.seqwor := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_reqxwor
BEFORE INSERT OR UPDATE ON tt_reqxwor
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_reqxwor();



/*-- SEQ 6412 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_res() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.filper)::VARCHAR = '''' THEN
   NEW.filper := NULL;
END IF;
IF trim(NEW.filque)::VARCHAR = '''' THEN
   NEW.filque := NULL;
END IF;
IF trim(NEW.codper)::VARCHAR = '''' THEN
   NEW.codper := NULL;
END IF;
IF trim(NEW.codque)::VARCHAR = '''' THEN
   NEW.codque := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.coment)::VARCHAR = '''' THEN
   NEW.coment := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_res
BEFORE INSERT OR UPDATE ON tt_res
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_res();



/*-- SEQ 6413 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ret() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;
IF trim(NEW.desret)::VARCHAR = '''' THEN
   NEW.desret := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ret
BEFORE INSERT OR UPDATE ON tt_ret
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ret();



/*-- SEQ 6414 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_rfc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.nomrfc)::VARCHAR = '''' THEN
   NEW.nomrfc := NULL;
END IF;
IF trim(NEW.endere)::VARCHAR = '''' THEN
   NEW.endere := NULL;
END IF;
IF trim(NEW.dddfon)::VARCHAR = '''' THEN
   NEW.dddfon := NULL;
END IF;
IF trim(NEW.numfon)::VARCHAR = '''' THEN
   NEW.numfon := NULL;
END IF;
IF trim(NEW.e_mail)::VARCHAR = '''' THEN
   NEW.e_mail := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_rfc
BEFORE INSERT OR UPDATE ON tt_rfc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_rfc();



/*-- SEQ 6415 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_rom() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filmot)::VARCHAR = '''' THEN
   NEW.filmot := NULL;
END IF;
IF trim(NEW.codmot)::VARCHAR = '''' THEN
   NEW.codmot := NULL;
END IF;
IF trim(NEW.tipmot)::VARCHAR = '''' THEN
   NEW.tipmot := NULL;
END IF;
IF trim(NEW.filtra)::VARCHAR = '''' THEN
   NEW.filtra := NULL;
END IF;
IF trim(NEW.codtra)::VARCHAR = '''' THEN
   NEW.codtra := NULL;
END IF;
IF trim(NEW.tiptra)::VARCHAR = '''' THEN
   NEW.tiptra := NULL;
END IF;
IF trim(NEW.placas)::VARCHAR = '''' THEN
   NEW.placas := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_rom
BEFORE INSERT OR UPDATE ON tt_rom
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_rom();



/*-- SEQ 6416 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_rpp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.codrpp)::VARCHAR = '''' THEN
   NEW.codrpp := NULL;
END IF;
IF trim(NEW.desrpp)::VARCHAR = '''' THEN
   NEW.desrpp := NULL;
END IF;
IF trim(NEW.proaut)::VARCHAR = '''' THEN
   NEW.proaut := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filped)::VARCHAR = '''' THEN
   NEW.filped := NULL;
END IF;
IF trim(NEW.tipped)::VARCHAR = '''' THEN
   NEW.tipped := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.filive)::VARCHAR = '''' THEN
   NEW.filive := NULL;
END IF;
IF trim(NEW.seqive)::VARCHAR = '''' THEN
   NEW.seqive := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_rpp
BEFORE INSERT OR UPDATE ON tt_rpp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_rpp();



/*-- SEQ 6417 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_rps() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.serrps)::VARCHAR = '''' THEN
   NEW.serrps := NULL;
END IF;
IF trim(NEW.numrps)::VARCHAR = '''' THEN
   NEW.numrps := NULL;
END IF;
IF trim(NEW.im_rps)::VARCHAR = '''' THEN
   NEW.im_rps := NULL;
END IF;
IF trim(NEW.docrps)::VARCHAR = '''' THEN
   NEW.docrps := NULL;
END IF;
IF trim(NEW.sitrps)::VARCHAR = '''' THEN
   NEW.sitrps := NULL;
END IF;
IF trim(NEW.codnfs)::VARCHAR = '''' THEN
   NEW.codnfs := NULL;
END IF;
IF trim(NEW.sitnfs)::VARCHAR = '''' THEN
   NEW.sitnfs := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_rps
BEFORE INSERT OR UPDATE ON tt_rps
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_rps();



/*-- SEQ 6418 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_rtb() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.seqarq)::VARCHAR = '''' THEN
   NEW.seqarq := NULL;
END IF;
IF trim(NEW.cartei)::VARCHAR = '''' THEN
   NEW.cartei := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.codo_s)::VARCHAR = '''' THEN
   NEW.codo_s := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.dato_s)::VARCHAR = '''' THEN
   NEW.dato_s := NULL;
END IF;
IF trim(NEW.motoco)::VARCHAR = '''' THEN
   NEW.motoco := NULL;
END IF;
IF trim(NEW.nosnum)::VARCHAR = '''' THEN
   NEW.nosnum := NULL;
END IF;
IF trim(NEW.ideemp)::VARCHAR = '''' THEN
   NEW.ideemp := NULL;
END IF;
IF trim(NEW.como_s)::VARCHAR = '''' THEN
   NEW.como_s := NULL;
END IF;
IF trim(NEW.nomcli)::VARCHAR = '''' THEN
   NEW.nomcli := NULL;
END IF;
IF trim(NEW.flgnew)::VARCHAR = '''' THEN
   NEW.flgnew := NULL;
END IF;
IF trim(NEW.desret)::VARCHAR = '''' THEN
   NEW.desret := NULL;
END IF;
IF trim(NEW.digage)::VARCHAR = '''' THEN
   NEW.digage := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_rtb
BEFORE INSERT OR UPDATE ON tt_rtb
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_rtb();



/*-- SEQ 6419 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_rtt() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codavu)::VARCHAR = '''' THEN
   NEW.codavu := NULL;
END IF;
IF trim(NEW.contra)::VARCHAR = '''' THEN
   NEW.contra := NULL;
END IF;
IF trim(NEW.numpar)::VARCHAR = '''' THEN
   NEW.numpar := NULL;
END IF;
IF trim(NEW.cupfis)::VARCHAR = '''' THEN
   NEW.cupfis := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.autori)::VARCHAR = '''' THEN
   NEW.autori := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.codbar)::VARCHAR = '''' THEN
   NEW.codbar := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;
IF trim(NEW.ecfest)::VARCHAR = '''' THEN
   NEW.ecfest := NULL;
END IF;
IF trim(NEW.filusu_est)::VARCHAR = '''' THEN
   NEW.filusu_est := NULL;
END IF;
IF trim(NEW.codusu_est)::VARCHAR = '''' THEN
   NEW.codusu_est := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_rtt
BEFORE INSERT OR UPDATE ON tt_rtt
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_rtt();



/*-- SEQ 6420 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_rxf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.reserv)::VARCHAR = '''' THEN
   NEW.reserv := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_rxf
BEFORE INSERT OR UPDATE ON tt_rxf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_rxf();



/*-- SEQ 6421 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_rzr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.numnot)::VARCHAR = '''' THEN
   NEW.numnot := NULL;
END IF;
IF trim(NEW.filrec)::VARCHAR = '''' THEN
   NEW.filrec := NULL;
END IF;
IF trim(NEW.seqrec)::VARCHAR = '''' THEN
   NEW.seqrec := NULL;
END IF;
IF trim(NEW.numrec)::VARCHAR = '''' THEN
   NEW.numrec := NULL;
END IF;
IF trim(NEW.subrec)::VARCHAR = '''' THEN
   NEW.subrec := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_rzr
BEFORE INSERT OR UPDATE ON tt_rzr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_rzr();



/*-- SEQ 6422 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_sad() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.codseg)::VARCHAR = '''' THEN
   NEW.codseg := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_sad
BEFORE INSERT OR UPDATE ON tt_sad
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_sad();



/*-- SEQ 6423 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_sal() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.atu_cm)::VARCHAR = '''' THEN
   NEW.atu_cm := NULL;
END IF;
IF trim(NEW.local1)::VARCHAR = '''' THEN
   NEW.local1 := NULL;
END IF;
IF trim(NEW.local2)::VARCHAR = '''' THEN
   NEW.local2 := NULL;
END IF;
IF trim(NEW.local3)::VARCHAR = '''' THEN
   NEW.local3 := NULL;
END IF;
IF trim(NEW.seqcmp)::VARCHAR = '''' THEN
   NEW.seqcmp := NULL;
END IF;
IF trim(NEW.movest)::VARCHAR = '''' THEN
   NEW.movest := NULL;
END IF;
IF trim(NEW.fazcmp)::VARCHAR = '''' THEN
   NEW.fazcmp := NULL;
END IF;
IF trim(NEW.mot_cm)::VARCHAR = '''' THEN
   NEW.mot_cm := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;
IF trim(NEW.flgati)::VARCHAR = '''' THEN
   NEW.flgati := NULL;
END IF;
IF trim(NEW.disminzer)::VARCHAR = '''' THEN
   NEW.disminzer := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_sal
BEFORE INSERT OR UPDATE ON tt_sal
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_sal();



/*-- SEQ 6424 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_sav() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filped)::VARCHAR = '''' THEN
   NEW.filped := NULL;
END IF;
IF trim(NEW.tipped)::VARCHAR = '''' THEN
   NEW.tipped := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.filven)::VARCHAR = '''' THEN
   NEW.filven := NULL;
END IF;
IF trim(NEW.seqven)::VARCHAR = '''' THEN
   NEW.seqven := NULL;
END IF;
IF trim(NEW.codavu)::VARCHAR = '''' THEN
   NEW.codavu := NULL;
END IF;
IF trim(NEW.filrtt)::VARCHAR = '''' THEN
   NEW.filrtt := NULL;
END IF;
IF trim(NEW.seqrtt)::VARCHAR = '''' THEN
   NEW.seqrtt := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.numser)::VARCHAR = '''' THEN
   NEW.numser := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.somtot)::VARCHAR = '''' THEN
   NEW.somtot := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;
IF trim(NEW.expcan)::VARCHAR = '''' THEN
   NEW.expcan := NULL;
END IF;
IF trim(NEW.filsad)::VARCHAR = '''' THEN
   NEW.filsad := NULL;
END IF;
IF trim(NEW.seqsad)::VARCHAR = '''' THEN
   NEW.seqsad := NULL;
END IF;
IF trim(NEW.cdimei)::VARCHAR = '''' THEN
   NEW.cdimei := NULL;
END IF;
IF trim(NEW.codseg)::VARCHAR = '''' THEN
   NEW.codseg := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_sav
BEFORE INSERT OR UPDATE ON tt_sav
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_sav();



/*-- SEQ 6425 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_sim() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.filsim)::VARCHAR = '''' THEN
   NEW.filsim := NULL;
END IF;
IF trim(NEW.codsim)::VARCHAR = '''' THEN
   NEW.codsim := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_sim
BEFORE INSERT OR UPDATE ON tt_sim
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_sim();



/*-- SEQ 6426 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_sli() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.deslpr)::VARCHAR = '''' THEN
   NEW.deslpr := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_sli
BEFORE INSERT OR UPDATE ON tt_sli
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_sli();



/*-- SEQ 6427 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_slt() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.fillot)::VARCHAR = '''' THEN
   NEW.fillot := NULL;
END IF;
IF trim(NEW.seqlot)::VARCHAR = '''' THEN
   NEW.seqlot := NULL;
END IF;
IF trim(NEW.movslt)::VARCHAR = '''' THEN
   NEW.movslt := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_slt
BEFORE INSERT OR UPDATE ON tt_slt
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_slt();



/*-- SEQ 6428 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_spc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.conspc)::VARCHAR = '''' THEN
   NEW.conspc := NULL;
END IF;
IF trim(NEW.con_lr)::VARCHAR = '''' THEN
   NEW.con_lr := NULL;
END IF;
IF trim(NEW.con_lt)::VARCHAR = '''' THEN
   NEW.con_lt := NULL;
END IF;
IF trim(NEW.con_tc)::VARCHAR = '''' THEN
   NEW.con_tc := NULL;
END IF;
IF trim(NEW.carprc)::VARCHAR = '''' THEN
   NEW.carprc := NULL;
END IF;
IF trim(NEW.carpro)::VARCHAR = '''' THEN
   NEW.carpro := NULL;
END IF;
IF trim(NEW.sercac)::VARCHAR = '''' THEN
   NEW.sercac := NULL;
END IF;
IF trim(NEW.sercar)::VARCHAR = '''' THEN
   NEW.sercar := NULL;
END IF;
IF trim(NEW.numcel)::VARCHAR = '''' THEN
   NEW.numcel := NULL;
END IF;
IF trim(NEW.numtel)::VARCHAR = '''' THEN
   NEW.numtel := NULL;
END IF;
IF trim(NEW.telcon)::VARCHAR = '''' THEN
   NEW.telcon := NULL;
END IF;
IF trim(NEW.rgconj)::VARCHAR = '''' THEN
   NEW.rgconj := NULL;
END IF;
IF trim(NEW.nacion)::VARCHAR = '''' THEN
   NEW.nacion := NULL;
END IF;
IF trim(NEW.endco2)::VARCHAR = '''' THEN
   NEW.endco2 := NULL;
END IF;
IF trim(NEW.endlo1)::VARCHAR = '''' THEN
   NEW.endlo1 := NULL;
END IF;
IF trim(NEW.endlo2)::VARCHAR = '''' THEN
   NEW.endlo2 := NULL;
END IF;
IF trim(NEW.cidnas)::VARCHAR = '''' THEN
   NEW.cidnas := NULL;
END IF;
IF trim(NEW.e_mail)::VARCHAR = '''' THEN
   NEW.e_mail := NULL;
END IF;
IF trim(NEW.endere)::VARCHAR = '''' THEN
   NEW.endere := NULL;
END IF;
IF trim(NEW.numcoc)::VARCHAR = '''' THEN
   NEW.numcoc := NULL;
END IF;
IF trim(NEW.numcod)::VARCHAR = '''' THEN
   NEW.numcod := NULL;
END IF;
IF trim(NEW.comple)::VARCHAR = '''' THEN
   NEW.comple := NULL;
END IF;
IF trim(NEW.orired)::VARCHAR = '''' THEN
   NEW.orired := NULL;
END IF;
IF trim(NEW.tem_tc)::VARCHAR = '''' THEN
   NEW.tem_tc := NULL;
END IF;
IF trim(NEW.tem_cc)::VARCHAR = '''' THEN
   NEW.tem_cc := NULL;
END IF;
IF trim(NEW.carloj)::VARCHAR = '''' THEN
   NEW.carloj := NULL;
END IF;
IF trim(NEW.temaut)::VARCHAR = '''' THEN
   NEW.temaut := NULL;
END IF;
IF trim(NEW.dddcel)::VARCHAR = '''' THEN
   NEW.dddcel := NULL;
END IF;
IF trim(NEW.nomsup)::VARCHAR = '''' THEN
   NEW.nomsup := NULL;
END IF;
IF trim(NEW.firatu)::VARCHAR = '''' THEN
   NEW.firatu := NULL;
END IF;
IF trim(NEW.firant)::VARCHAR = '''' THEN
   NEW.firant := NULL;
END IF;
IF trim(NEW.nomlo1)::VARCHAR = '''' THEN
   NEW.nomlo1 := NULL;
END IF;
IF trim(NEW.nomlo2)::VARCHAR = '''' THEN
   NEW.nomlo2 := NULL;
END IF;
IF trim(NEW.fircon)::VARCHAR = '''' THEN
   NEW.fircon := NULL;
END IF;
IF trim(NEW.endco1)::VARCHAR = '''' THEN
   NEW.endco1 := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_spc
BEFORE INSERT OR UPDATE ON tt_spc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_spc();



/*-- SEQ 6429 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_sql() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.reldes)::VARCHAR = '''' THEN
   NEW.reldes := NULL;
END IF;
IF trim(NEW.relori)::VARCHAR = '''' THEN
   NEW.relori := NULL;
END IF;
IF trim(NEW.coddes)::VARCHAR = '''' THEN
   NEW.coddes := NULL;
END IF;
IF trim(NEW.codori)::VARCHAR = '''' THEN
   NEW.codori := NULL;
END IF;
IF trim(NEW.rel_on)::VARCHAR = '''' THEN
   NEW.rel_on := NULL;
END IF;
IF trim(NEW.relnxn)::VARCHAR = '''' THEN
   NEW.relnxn := NULL;
END IF;
IF trim(NEW.filtro)::VARCHAR = '''' THEN
   NEW.filtro := NULL;
END IF;
IF trim(NEW.propor)::VARCHAR = '''' THEN
   NEW.propor := NULL;
END IF;
IF trim(NEW.relon_des)::VARCHAR = '''' THEN
   NEW.relon_des := NULL;
END IF;
IF trim(NEW.sqlout2)::VARCHAR = '''' THEN
   NEW.sqlout2 := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_sql
BEFORE INSERT OR UPDATE ON tt_sql
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_sql();



/*-- SEQ 6430 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_srv() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.dessrv)::VARCHAR = '''' THEN
   NEW.dessrv := NULL;
END IF;
IF trim(NEW.srvati)::VARCHAR = '''' THEN
   NEW.srvati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_srv
BEFORE INSERT OR UPDATE ON tt_srv
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_srv();



/*-- SEQ 6431 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_sto() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.nomobj)::VARCHAR = '''' THEN
   NEW.nomobj := NULL;
END IF;
IF trim(NEW.cache)::VARCHAR = '''' THEN
   NEW.cache := NULL;
END IF;
IF trim(NEW.objpai)::VARCHAR = '''' THEN
   NEW.objpai := NULL;
END IF;
IF trim(NEW.objsec)::VARCHAR = '''' THEN
   NEW.objsec := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_sto
BEFORE INSERT OR UPDATE ON tt_sto
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_sto();



/*-- SEQ 6432 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_sub() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.nomite)::VARCHAR = '''' THEN
   NEW.nomite := NULL;
END IF;
IF trim(NEW.nomext)::VARCHAR = '''' THEN
   NEW.nomext := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_sub
BEFORE INSERT OR UPDATE ON tt_sub
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_sub();



/*-- SEQ 6433 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_sup() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.flgcob)::VARCHAR = '''' THEN
   NEW.flgcob := NULL;
END IF;
IF trim(NEW.situac)::VARCHAR = '''' THEN
   NEW.situac := NULL;
END IF;
IF trim(NEW.codres)::VARCHAR = '''' THEN
   NEW.codres := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.filend)::VARCHAR = '''' THEN
   NEW.filend := NULL;
END IF;
IF trim(NEW.filres)::VARCHAR = '''' THEN
   NEW.filres := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.flgact)::VARCHAR = '''' THEN
   NEW.flgact := NULL;
END IF;
IF trim(NEW.tipact)::VARCHAR = '''' THEN
   NEW.tipact := NULL;
END IF;
IF trim(NEW.filact)::VARCHAR = '''' THEN
   NEW.filact := NULL;
END IF;
IF trim(NEW.release)::VARCHAR = '''' THEN
   NEW.release := NULL;
END IF;
IF trim(NEW.codact)::VARCHAR = '''' THEN
   NEW.codact := NULL;
END IF;
IF trim(NEW.dessup)::VARCHAR = '''' THEN
   NEW.dessup := NULL;
END IF;
IF trim(NEW.e_mail)::VARCHAR = '''' THEN
   NEW.e_mail := NULL;
END IF;
IF trim(NEW.tipcws)::VARCHAR = '''' THEN
   NEW.tipcws := NULL;
END IF;
IF trim(NEW.tipreg)::VARCHAR = '''' THEN
   NEW.tipreg := NULL;
END IF;
IF trim(NEW.comjus)::VARCHAR = '''' THEN
   NEW.comjus := NULL;
END IF;
IF trim(NEW.perfil)::VARCHAR = '''' THEN
   NEW.perfil := NULL;
END IF;
IF trim(NEW.filven)::VARCHAR = '''' THEN
   NEW.filven := NULL;
END IF;
IF trim(NEW.seqven)::VARCHAR = '''' THEN
   NEW.seqven := NULL;
END IF;
IF trim(NEW.filcob)::VARCHAR = '''' THEN
   NEW.filcob := NULL;
END IF;
IF trim(NEW.codcob)::VARCHAR = '''' THEN
   NEW.codcob := NULL;
END IF;
IF trim(NEW.versao)::VARCHAR = '''' THEN
   NEW.versao := NULL;
END IF;
IF trim(NEW.omisso)::VARCHAR = '''' THEN
   NEW.omisso := NULL;
END IF;
IF trim(NEW.filorc)::VARCHAR = '''' THEN
   NEW.filorc := NULL;
END IF;
IF trim(NEW.tiporc)::VARCHAR = '''' THEN
   NEW.tiporc := NULL;
END IF;
IF trim(NEW.numorc)::VARCHAR = '''' THEN
   NEW.numorc := NULL;
END IF;
IF trim(NEW.pricli)::VARCHAR = '''' THEN
   NEW.pricli := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_sup
BEFORE INSERT OR UPDATE ON tt_sup
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_sup();



/*-- SEQ 6434 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_supxwor() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filsup)::VARCHAR = '''' THEN
   NEW.filsup := NULL;
END IF;
IF trim(NEW.seqsup)::VARCHAR = '''' THEN
   NEW.seqsup := NULL;
END IF;
IF trim(NEW.filwor)::VARCHAR = '''' THEN
   NEW.filwor := NULL;
END IF;
IF trim(NEW.seqwor)::VARCHAR = '''' THEN
   NEW.seqwor := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_supxwor
BEFORE INSERT OR UPDATE ON tt_supxwor
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_supxwor();



/*-- SEQ 6435 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_tar() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.consul)::VARCHAR = '''' THEN
   NEW.consul := NULL;
END IF;
IF trim(NEW.deciso)::VARCHAR = '''' THEN
   NEW.deciso := NULL;
END IF;
IF trim(NEW.domfei)::VARCHAR = '''' THEN
   NEW.domfei := NULL;
END IF;
IF trim(NEW.mesabr)::VARCHAR = '''' THEN
   NEW.mesabr := NULL;
END IF;
IF trim(NEW.mesago)::VARCHAR = '''' THEN
   NEW.mesago := NULL;
END IF;
IF trim(NEW.mesdez)::VARCHAR = '''' THEN
   NEW.mesdez := NULL;
END IF;
IF trim(NEW.mesfev)::VARCHAR = '''' THEN
   NEW.mesfev := NULL;
END IF;
IF trim(NEW.mesjan)::VARCHAR = '''' THEN
   NEW.mesjan := NULL;
END IF;
IF trim(NEW.mesjul)::VARCHAR = '''' THEN
   NEW.mesjul := NULL;
END IF;
IF trim(NEW.mesjun)::VARCHAR = '''' THEN
   NEW.mesjun := NULL;
END IF;
IF trim(NEW.mesmai)::VARCHAR = '''' THEN
   NEW.mesmai := NULL;
END IF;
IF trim(NEW.mesmar)::VARCHAR = '''' THEN
   NEW.mesmar := NULL;
END IF;
IF trim(NEW.mesnov)::VARCHAR = '''' THEN
   NEW.mesnov := NULL;
END IF;
IF trim(NEW.mesout)::VARCHAR = '''' THEN
   NEW.mesout := NULL;
END IF;
IF trim(NEW.messet)::VARCHAR = '''' THEN
   NEW.messet := NULL;
END IF;
IF trim(NEW.quafei)::VARCHAR = '''' THEN
   NEW.quafei := NULL;
END IF;
IF trim(NEW.quifei)::VARCHAR = '''' THEN
   NEW.quifei := NULL;
END IF;
IF trim(NEW.sabfei)::VARCHAR = '''' THEN
   NEW.sabfei := NULL;
END IF;
IF trim(NEW.segfei)::VARCHAR = '''' THEN
   NEW.segfei := NULL;
END IF;
IF trim(NEW.sexfei)::VARCHAR = '''' THEN
   NEW.sexfei := NULL;
END IF;
IF trim(NEW.terfei)::VARCHAR = '''' THEN
   NEW.terfei := NULL;
END IF;
IF trim(NEW.nomcon)::VARCHAR = '''' THEN
   NEW.nomcon := NULL;
END IF;
IF trim(NEW.tittar)::VARCHAR = '''' THEN
   NEW.tittar := NULL;
END IF;
IF trim(NEW.formai)::VARCHAR = '''' THEN
   NEW.formai := NULL;
END IF;
IF trim(NEW.forsal)::VARCHAR = '''' THEN
   NEW.forsal := NULL;
END IF;
IF trim(NEW.emaerr)::VARCHAR = '''' THEN
   NEW.emaerr := NULL;
END IF;
IF trim(NEW.imprim)::VARCHAR = '''' THEN
   NEW.imprim := NULL;
END IF;
IF trim(NEW.salvar)::VARCHAR = '''' THEN
   NEW.salvar := NULL;
END IF;
IF trim(NEW.e_mail)::VARCHAR = '''' THEN
   NEW.e_mail := NULL;
END IF;
IF trim(NEW.expsac)::VARCHAR = '''' THEN
   NEW.expsac := NULL;
END IF;
IF trim(NEW.txtmai)::VARCHAR = '''' THEN
   NEW.txtmai := NULL;
END IF;
IF trim(NEW.lnkanx)::VARCHAR = '''' THEN
   NEW.lnkanx := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_tar
BEFORE INSERT OR UPDATE ON tt_tar
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_tar();



/*-- SEQ 6436 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_tcp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.sobtod)::VARCHAR = '''' THEN
   NEW.sobtod := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_tcp
BEFORE INSERT OR UPDATE ON tt_tcp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_tcp();



/*-- SEQ 6437 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_tec() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filtec)::VARCHAR = '''' THEN
   NEW.filtec := NULL;
END IF;
IF trim(NEW.caract)::VARCHAR = '''' THEN
   NEW.caract := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_tec
BEFORE INSERT OR UPDATE ON tt_tec
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_tec();



/*-- SEQ 6438 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_tef() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.vldcar)::VARCHAR = '''' THEN
   NEW.vldcar := NULL;
END IF;
IF trim(NEW.numcar)::VARCHAR = '''' THEN
   NEW.numcar := NULL;
END IF;
IF trim(NEW.nsutrn)::VARCHAR = '''' THEN
   NEW.nsutrn := NULL;
END IF;
IF trim(NEW.tipope)::VARCHAR = '''' THEN
   NEW.tipope := NULL;
END IF;
IF trim(NEW.manual)::VARCHAR = '''' THEN
   NEW.manual := NULL;
END IF;
IF trim(NEW.tipcob)::VARCHAR = '''' THEN
   NEW.tipcob := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.numaut)::VARCHAR = '''' THEN
   NEW.numaut := NULL;
END IF;
IF trim(NEW.codban)::VARCHAR = '''' THEN
   NEW.codban := NULL;
END IF;
IF trim(NEW.expem4)::VARCHAR = '''' THEN
   NEW.expem4 := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_tef
BEFORE INSERT OR UPDATE ON tt_tef
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_tef();



/*-- SEQ 6439 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_teq() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filteq)::VARCHAR = '''' THEN
   NEW.filteq := NULL;
END IF;
IF trim(NEW.seqteq)::VARCHAR = '''' THEN
   NEW.seqteq := NULL;
END IF;
IF trim(NEW.tipati)::VARCHAR = '''' THEN
   NEW.tipati := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.destip)::VARCHAR = '''' THEN
   NEW.destip := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_teq
BEFORE INSERT OR UPDATE ON tt_teq
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_teq();



/*-- SEQ 6440 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_tin() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.descri)::VARCHAR = '''' THEN
   NEW.descri := NULL;
END IF;
IF trim(NEW.desgru)::VARCHAR = '''' THEN
   NEW.desgru := NULL;
END IF;
IF trim(NEW.nomcor)::VARCHAR = '''' THEN
   NEW.nomcor := NULL;
END IF;
IF trim(NEW.descor)::VARCHAR = '''' THEN
   NEW.descor := NULL;
END IF;
IF trim(NEW.desbas)::VARCHAR = '''' THEN
   NEW.desbas := NULL;
END IF;
IF trim(NEW.desemb)::VARCHAR = '''' THEN
   NEW.desemb := NULL;
END IF;
IF trim(NEW.desmat)::VARCHAR = '''' THEN
   NEW.desmat := NULL;
END IF;
IF trim(NEW.espmat)::VARCHAR = '''' THEN
   NEW.espmat := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_tin
BEFORE INSERT OR UPDATE ON tt_tin
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_tin();



/*-- SEQ 6441 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_tit() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.parrec)::VARCHAR = '''' THEN
   NEW.parrec := NULL;
END IF;
IF trim(NEW.subrec)::VARCHAR = '''' THEN
   NEW.subrec := NULL;
END IF;
IF trim(NEW.filrec)::VARCHAR = '''' THEN
   NEW.filrec := NULL;
END IF;
IF trim(NEW.seqrec)::VARCHAR = '''' THEN
   NEW.seqrec := NULL;
END IF;
IF trim(NEW.aceite)::VARCHAR = '''' THEN
   NEW.aceite := NULL;
END IF;
IF trim(NEW.coderr)::VARCHAR = '''' THEN
   NEW.coderr := NULL;
END IF;
IF trim(NEW.digcob)::VARCHAR = '''' THEN
   NEW.digcob := NULL;
END IF;
IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;
IF trim(NEW.numage)::VARCHAR = '''' THEN
   NEW.numage := NULL;
END IF;
IF trim(NEW.ctacrr)::VARCHAR = '''' THEN
   NEW.ctacrr := NULL;
END IF;
IF trim(NEW.seqcan)::VARCHAR = '''' THEN
   NEW.seqcan := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.nosnum)::VARCHAR = '''' THEN
   NEW.nosnum := NULL;
END IF;
IF trim(NEW.nosnum2)::VARCHAR = '''' THEN
   NEW.nosnum2 := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_tit
BEFORE INSERT OR UPDATE ON tt_tit
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_tit();



/*-- SEQ 6442 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_tpf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filfor)::VARCHAR = '''' THEN
   NEW.filfor := NULL;
END IF;
IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;
IF trim(NEW.tipfre)::VARCHAR = '''' THEN
   NEW.tipfre := NULL;
END IF;
IF trim(NEW.tpfati)::VARCHAR = '''' THEN
   NEW.tpfati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_tpf
BEFORE INSERT OR UPDATE ON tt_tpf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_tpf();



/*-- SEQ 6443 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_tpr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.estado)::VARCHAR = '''' THEN
   NEW.estado := NULL;
END IF;
IF trim(NEW.fildes)::VARCHAR = '''' THEN
   NEW.fildes := NULL;
END IF;
IF trim(NEW.despre)::VARCHAR = '''' THEN
   NEW.despre := NULL;
END IF;
IF trim(NEW.filpgt)::VARCHAR = '''' THEN
   NEW.filpgt := NULL;
END IF;
IF trim(NEW.codpgt)::VARCHAR = '''' THEN
   NEW.codpgt := NULL;
END IF;
IF trim(NEW.totqtd)::VARCHAR = '''' THEN
   NEW.totqtd := NULL;
END IF;
IF trim(NEW.fil_ck)::VARCHAR = '''' THEN
   NEW.fil_ck := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.usaicmesp)::VARCHAR = '''' THEN
   NEW.usaicmesp := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_tpr
BEFORE INSERT OR UPDATE ON tt_tpr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_tpr();



/*-- SEQ 6444 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_tprxfil() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filpre)::VARCHAR = '''' THEN
   NEW.filpre := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_tprxfil
BEFORE INSERT OR UPDATE ON tt_tprxfil
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_tprxfil();



/*-- SEQ 6445 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_tra() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filive)::VARCHAR = '''' THEN
   NEW.filive := NULL;
END IF;
IF trim(NEW.seqive)::VARCHAR = '''' THEN
   NEW.seqive := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.filico)::VARCHAR = '''' THEN
   NEW.filico := NULL;
END IF;
IF trim(NEW.seqico)::VARCHAR = '''' THEN
   NEW.seqico := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_tra
BEFORE INSERT OR UPDATE ON tt_tra
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_tra();



/*-- SEQ 6446 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_trc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.incoju)::VARCHAR = '''' THEN
   NEW.incoju := NULL;
END IF;
IF trim(NEW.intpju)::VARCHAR = '''' THEN
   NEW.intpju := NULL;
END IF;
IF trim(NEW.intpmu)::VARCHAR = '''' THEN
   NEW.intpmu := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.tipnot)::VARCHAR = '''' THEN
   NEW.tipnot := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.filpar)::VARCHAR = '''' THEN
   NEW.filpar := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codpar)::VARCHAR = '''' THEN
   NEW.codpar := NULL;
END IF;
IF trim(NEW.numnot)::VARCHAR = '''' THEN
   NEW.numnot := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.subser)::VARCHAR = '''' THEN
   NEW.subser := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.seqcan)::VARCHAR = '''' THEN
   NEW.seqcan := NULL;
END IF;
IF trim(NEW.filpag)::VARCHAR = '''' THEN
   NEW.filpag := NULL;
END IF;
IF trim(NEW.seqpag)::VARCHAR = '''' THEN
   NEW.seqpag := NULL;
END IF;
IF trim(NEW.tippag)::VARCHAR = '''' THEN
   NEW.tippag := NULL;
END IF;
IF trim(NEW.seqven)::VARCHAR = '''' THEN
   NEW.seqven := NULL;
END IF;
IF trim(NEW.expem4)::VARCHAR = '''' THEN
   NEW.expem4 := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_trc
BEFORE INSERT OR UPDATE ON tt_trc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_trc();



/*-- SEQ 6447 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_trn() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.cupfis)::VARCHAR = '''' THEN
   NEW.cupfis := NULL;
END IF;
IF trim(NEW.txttrn)::VARCHAR = '''' THEN
   NEW.txttrn := NULL;
END IF;
IF trim(NEW.msgerr)::VARCHAR = '''' THEN
   NEW.msgerr := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_trn
BEFORE INSERT OR UPDATE ON tt_trn
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_trn();



/*-- SEQ 6448 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_tsf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.tabela)::VARCHAR = '''' THEN
   NEW.tabela := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_tsf
BEFORE INSERT OR UPDATE ON tt_tsf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_tsf();



/*-- SEQ 6449 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_uid() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.useros)::VARCHAR = '''' THEN
   NEW.useros := NULL;
END IF;
IF trim(NEW.nommaq)::VARCHAR = '''' THEN
   NEW.nommaq := NULL;
END IF;
IF trim(NEW.versis)::VARCHAR = '''' THEN
   NEW.versis := NULL;
END IF;
IF trim(NEW.nomsis)::VARCHAR = '''' THEN
   NEW.nomsis := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;
IF trim(NEW.termin)::VARCHAR = '''' THEN
   NEW.termin := NULL;
END IF;
IF trim(NEW.assins)::VARCHAR = '''' THEN
   NEW.assins := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_uid
BEFORE INSERT OR UPDATE ON tt_uid
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_uid();



/*-- SEQ 6450 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_usu() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.codsup)::VARCHAR = '''' THEN
   NEW.codsup := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.filsup)::VARCHAR = '''' THEN
   NEW.filsup := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.senha1)::VARCHAR = '''' THEN
   NEW.senha1 := NULL;
END IF;
IF trim(NEW.senha2)::VARCHAR = '''' THEN
   NEW.senha2 := NULL;
END IF;
IF trim(NEW.agendb)::VARCHAR = '''' THEN
   NEW.agendb := NULL;
END IF;
IF trim(NEW.edindb)::VARCHAR = '''' THEN
   NEW.edindb := NULL;
END IF;
IF trim(NEW.usandb)::VARCHAR = '''' THEN
   NEW.usandb := NULL;
END IF;
IF trim(NEW.usandc)::VARCHAR = '''' THEN
   NEW.usandc := NULL;
END IF;
IF trim(NEW.apeusu)::VARCHAR = '''' THEN
   NEW.apeusu := NULL;
END IF;
IF trim(NEW.nomusu)::VARCHAR = '''' THEN
   NEW.nomusu := NULL;
END IF;
IF trim(NEW.filatv)::VARCHAR = '''' THEN
   NEW.filatv := NULL;
END IF;
IF trim(NEW.tabatu)::VARCHAR = '''' THEN
   NEW.tabatu := NULL;
END IF;
IF trim(NEW.e_mail)::VARCHAR = '''' THEN
   NEW.e_mail := NULL;
END IF;
IF trim(NEW.visper)::VARCHAR = '''' THEN
   NEW.visper := NULL;
END IF;
IF trim(NEW.patndb)::VARCHAR = '''' THEN
   NEW.patndb := NULL;
END IF;
IF trim(NEW.grupos)::VARCHAR = '''' THEN
   NEW.grupos := NULL;
END IF;
IF trim(NEW.fazenq)::VARCHAR = '''' THEN
   NEW.fazenq := NULL;
END IF;
IF trim(NEW.funcao)::VARCHAR = '''' THEN
   NEW.funcao := NULL;
END IF;
IF trim(NEW.fazmon)::VARCHAR = '''' THEN
   NEW.fazmon := NULL;
END IF;
IF trim(NEW.permis)::VARCHAR = '''' THEN
   NEW.permis := NULL;
END IF;
IF trim(NEW.usucob)::VARCHAR = '''' THEN
   NEW.usucob := NULL;
END IF;
IF trim(NEW.comimp)::VARCHAR = '''' THEN
   NEW.comimp := NULL;
END IF;
IF trim(NEW.filini)::VARCHAR = '''' THEN
   NEW.filini := NULL;
END IF;
IF trim(NEW.codini)::VARCHAR = '''' THEN
   NEW.codini := NULL;
END IF;
IF trim(NEW.cfgini)::VARCHAR = '''' THEN
   NEW.cfgini := NULL;
END IF;
IF trim(NEW.viswor)::VARCHAR = '''' THEN
   NEW.viswor := NULL;
END IF;
IF trim(NEW.fildif)::VARCHAR = '''' THEN
   NEW.fildif := NULL;
END IF;
IF trim(NEW.seqdif)::VARCHAR = '''' THEN
   NEW.seqdif := NULL;
END IF;
IF trim(NEW.tipdif)::VARCHAR = '''' THEN
   NEW.tipdif := NULL;
END IF;
IF trim(NEW.filect)::VARCHAR = '''' THEN
   NEW.filect := NULL;
END IF;
IF trim(NEW.seqect)::VARCHAR = '''' THEN
   NEW.seqect := NULL;
END IF;
IF trim(NEW.csenha)::VARCHAR = '''' THEN
   NEW.csenha := NULL;
END IF;
IF trim(NEW.filger)::VARCHAR = '''' THEN
   NEW.filger := NULL;
END IF;
IF trim(NEW.seqger)::VARCHAR = '''' THEN
   NEW.seqger := NULL;
END IF;
IF trim(NEW.tipger)::VARCHAR = '''' THEN
   NEW.tipger := NULL;
END IF;
IF trim(NEW.snhpop)::VARCHAR = '''' THEN
   NEW.snhpop := NULL;
END IF;
IF trim(NEW.chvmat)::VARCHAR = '''' THEN
   NEW.chvmat := NULL;
END IF;
IF trim(NEW.codpos_usu)::VARCHAR = '''' THEN
   NEW.codpos_usu := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_usu
BEFORE INSERT OR UPDATE ON tt_usu
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_usu();



/*-- SEQ 6451 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_utl() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.ferabe)::VARCHAR = '''' THEN
   NEW.ferabe := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_utl
BEFORE INSERT OR UPDATE ON tt_utl
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_utl();



/*-- SEQ 6452 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_vat() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.detver)::VARCHAR = '''' THEN
   NEW.detver := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_vat
BEFORE INSERT OR UPDATE ON tt_vat
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_vat();



/*-- SEQ 6453 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_vdd() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filped)::VARCHAR = '''' THEN
   NEW.filped := NULL;
END IF;
IF trim(NEW.tipped)::VARCHAR = '''' THEN
   NEW.tipped := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.filven)::VARCHAR = '''' THEN
   NEW.filven := NULL;
END IF;
IF trim(NEW.seqven)::VARCHAR = '''' THEN
   NEW.seqven := NULL;
END IF;
IF trim(NEW.filvdd)::VARCHAR = '''' THEN
   NEW.filvdd := NULL;
END IF;
IF trim(NEW.codvdd)::VARCHAR = '''' THEN
   NEW.codvdd := NULL;
END IF;
IF trim(NEW.tipvdd)::VARCHAR = '''' THEN
   NEW.tipvdd := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_vdd
BEFORE INSERT OR UPDATE ON tt_vdd
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_vdd();



/*-- SEQ 6454 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_vei() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.placas)::VARCHAR = '''' THEN
   NEW.placas := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.trafeg)::VARCHAR = '''' THEN
   NEW.trafeg := NULL;
END IF;
IF trim(NEW.filccc)::VARCHAR = '''' THEN
   NEW.filccc := NULL;
END IF;
IF trim(NEW.seqccc)::VARCHAR = '''' THEN
   NEW.seqccc := NULL;
END IF;
IF trim(NEW.nacion)::VARCHAR = '''' THEN
   NEW.nacion := NULL;
END IF;
IF trim(NEW.marvei)::VARCHAR = '''' THEN
   NEW.marvei := NULL;
END IF;
IF trim(NEW.modvei)::VARCHAR = '''' THEN
   NEW.modvei := NULL;
END IF;
IF trim(NEW.veiati)::VARCHAR = '''' THEN
   NEW.veiati := NULL;
END IF;
IF trim(NEW.sigest)::VARCHAR = '''' THEN
   NEW.sigest := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_vei
BEFORE INSERT OR UPDATE ON tt_vei
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_vei();



/*-- SEQ 6455 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ven() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.flgtip)::VARCHAR = '''' THEN
   NEW.flgtip := NULL;
END IF;
IF trim(NEW.tipnot)::VARCHAR = '''' THEN
   NEW.tipnot := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.codpgt)::VARCHAR = '''' THEN
   NEW.codpgt := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.codven)::VARCHAR = '''' THEN
   NEW.codven := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.filpgt)::VARCHAR = '''' THEN
   NEW.filpgt := NULL;
END IF;
IF trim(NEW.filpre)::VARCHAR = '''' THEN
   NEW.filpre := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.filven)::VARCHAR = '''' THEN
   NEW.filven := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.numnot)::VARCHAR = '''' THEN
   NEW.numnot := NULL;
END IF;
IF trim(NEW.autent)::VARCHAR = '''' THEN
   NEW.autent := NULL;
END IF;
IF trim(NEW.consfi)::VARCHAR = '''' THEN
   NEW.consfi := NULL;
END IF;
IF trim(NEW.emides)::VARCHAR = '''' THEN
   NEW.emides := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;
IF trim(NEW.financ)::VARCHAR = '''' THEN
   NEW.financ := NULL;
END IF;
IF trim(NEW.tribut)::VARCHAR = '''' THEN
   NEW.tribut := NULL;
END IF;
IF trim(NEW.lanven)::VARCHAR = '''' THEN
   NEW.lanven := NULL;
END IF;
IF trim(NEW.tiptra)::VARCHAR = '''' THEN
   NEW.tiptra := NULL;
END IF;
IF trim(NEW.filcob)::VARCHAR = '''' THEN
   NEW.filcob := NULL;
END IF;
IF trim(NEW.filent)::VARCHAR = '''' THEN
   NEW.filent := NULL;
END IF;
IF trim(NEW.filfat)::VARCHAR = '''' THEN
   NEW.filfat := NULL;
END IF;
IF trim(NEW.filgui)::VARCHAR = '''' THEN
   NEW.filgui := NULL;
END IF;
IF trim(NEW.filtra)::VARCHAR = '''' THEN
   NEW.filtra := NULL;
END IF;
IF trim(NEW.codgui)::VARCHAR = '''' THEN
   NEW.codgui := NULL;
END IF;
IF trim(NEW.codtra)::VARCHAR = '''' THEN
   NEW.codtra := NULL;
END IF;
IF trim(NEW.numcon)::VARCHAR = '''' THEN
   NEW.numcon := NULL;
END IF;
IF trim(NEW.seqfat)::VARCHAR = '''' THEN
   NEW.seqfat := NULL;
END IF;
IF trim(NEW.vincul)::VARCHAR = '''' THEN
   NEW.vincul := NULL;
END IF;
IF trim(NEW.marcas)::VARCHAR = '''' THEN
   NEW.marcas := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.tiptro)::VARCHAR = '''' THEN
   NEW.tiptro := NULL;
END IF;
IF trim(NEW.ufloja)::VARCHAR = '''' THEN
   NEW.ufloja := NULL;
END IF;
IF trim(NEW.plafre)::VARCHAR = '''' THEN
   NEW.plafre := NULL;
END IF;
IF trim(NEW.uf_fre)::VARCHAR = '''' THEN
   NEW.uf_fre := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.imprim)::VARCHAR = '''' THEN
   NEW.imprim := NULL;
END IF;
IF trim(NEW.autint)::VARCHAR = '''' THEN
   NEW.autint := NULL;
END IF;
IF trim(NEW.oriven)::VARCHAR = '''' THEN
   NEW.oriven := NULL;
END IF;
IF trim(NEW.avista)::VARCHAR = '''' THEN
   NEW.avista := NULL;
END IF;
IF trim(NEW.docnfp)::VARCHAR = '''' THEN
   NEW.docnfp := NULL;
END IF;
IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.titavu)::VARCHAR = '''' THEN
   NEW.titavu := NULL;
END IF;
IF trim(NEW.codavu)::VARCHAR = '''' THEN
   NEW.codavu := NULL;
END IF;
IF trim(NEW.filagc)::VARCHAR = '''' THEN
   NEW.filagc := NULL;
END IF;
IF trim(NEW.seqagc)::VARCHAR = '''' THEN
   NEW.seqagc := NULL;
END IF;
IF trim(NEW.filvdp)::VARCHAR = '''' THEN
   NEW.filvdp := NULL;
END IF;
IF trim(NEW.codvdp)::VARCHAR = '''' THEN
   NEW.codvdp := NULL;
END IF;
IF trim(NEW.flgnfe)::VARCHAR = '''' THEN
   NEW.flgnfe := NULL;
END IF;
IF trim(NEW.serext)::VARCHAR = '''' THEN
   NEW.serext := NULL;
END IF;
IF trim(NEW.obsfis)::VARCHAR = '''' THEN
   NEW.obsfis := NULL;
END IF;
IF trim(NEW.assina)::VARCHAR = '''' THEN
   NEW.assina := NULL;
END IF;
IF trim(NEW.vernfe)::VARCHAR = '''' THEN
   NEW.vernfe := NULL;
END IF;
IF trim(NEW.dettip)::VARCHAR = '''' THEN
   NEW.dettip := NULL;
END IF;
IF trim(NEW.chavea)::VARCHAR = '''' THEN
   NEW.chavea := NULL;
END IF;
IF trim(NEW.orican)::VARCHAR = '''' THEN
   NEW.orican := NULL;
END IF;
IF trim(NEW.datstr)::VARCHAR = '''' THEN
   NEW.datstr := NULL;
END IF;
IF trim(NEW.flgext)::VARCHAR = '''' THEN
   NEW.flgext := NULL;
END IF;
IF trim(NEW.notman)::VARCHAR = '''' THEN
   NEW.notman := NULL;
END IF;
IF trim(NEW.filest)::VARCHAR = '''' THEN
   NEW.filest := NULL;
END IF;
IF trim(NEW.seqest)::VARCHAR = '''' THEN
   NEW.seqest := NULL;
END IF;
IF trim(NEW.impest)::VARCHAR = '''' THEN
   NEW.impest := NULL;
END IF;
IF trim(NEW.ecfest)::VARCHAR = '''' THEN
   NEW.ecfest := NULL;
END IF;
IF trim(NEW.tipesp)::VARCHAR = '''' THEN
   NEW.tipesp := NULL;
END IF;
IF trim(NEW.motcan)::VARCHAR = '''' THEN
   NEW.motcan := NULL;
END IF;
IF trim(NEW.filori)::VARCHAR = '''' THEN
   NEW.filori := NULL;
END IF;
IF trim(NEW.seqori)::VARCHAR = '''' THEN
   NEW.seqori := NULL;
END IF;
IF trim(NEW.chvibp)::VARCHAR = '''' THEN
   NEW.chvibp := NULL;
END IF;
IF trim(NEW.fonibp)::VARCHAR = '''' THEN
   NEW.fonibp := NULL;
END IF;
IF trim(NEW.expfis)::VARCHAR = '''' THEN
   NEW.expfis := NULL;
END IF;
IF trim(NEW.modnot)::VARCHAR = '''' THEN
   NEW.modnot := NULL;
END IF;
IF trim(NEW.emailc)::VARCHAR = '''' THEN
   NEW.emailc := NULL;
END IF;
IF trim(NEW.docimp)::VARCHAR = '''' THEN
   NEW.docimp := NULL;
END IF;
IF trim(NEW.tipimp)::VARCHAR = '''' THEN
   NEW.tipimp := NULL;
END IF;
IF trim(NEW.recibo)::VARCHAR = '''' THEN
   NEW.recibo := NULL;
END IF;
IF trim(NEW.nfreci)::VARCHAR = '''' THEN
   NEW.nfreci := NULL;
END IF;
IF trim(NEW.proaut)::VARCHAR = '''' THEN
   NEW.proaut := NULL;
END IF;
IF trim(NEW.procan)::VARCHAR = '''' THEN
   NEW.procan := NULL;
END IF;
IF trim(NEW.numnfs)::VARCHAR = '''' THEN
   NEW.numnfs := NULL;
END IF;
IF trim(NEW.chvcan)::VARCHAR = '''' THEN
   NEW.chvcan := NULL;
END IF;
IF trim(NEW.filcre)::VARCHAR = '''' THEN
   NEW.filcre := NULL;
END IF;
IF trim(NEW.seqcre)::VARCHAR = '''' THEN
   NEW.seqcre := NULL;
END IF;
IF trim(NEW.expem4)::VARCHAR = '''' THEN
   NEW.expem4 := NULL;
END IF;
IF trim(NEW.ext_ec)::VARCHAR = '''' THEN
   NEW.ext_ec := NULL;
END IF;
IF trim(NEW.impsep)::VARCHAR = '''' THEN
   NEW.impsep := NULL;
END IF;
IF trim(NEW.filint)::VARCHAR = '''' THEN
   NEW.filint := NULL;
END IF;
IF trim(NEW.codint)::VARCHAR = '''' THEN
   NEW.codint := NULL;
END IF;
IF trim(NEW.id_int)::VARCHAR = '''' THEN
   NEW.id_int := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ven
BEFORE INSERT OR UPDATE ON tt_ven
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ven();



/*-- SEQ 6456 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_venxobs() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filven)::VARCHAR = '''' THEN
   NEW.filven := NULL;
END IF;
IF trim(NEW.seqven)::VARCHAR = '''' THEN
   NEW.seqven := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_venxobs
BEFORE INSERT OR UPDATE ON tt_venxobs
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_venxobs();



/*-- SEQ 6457 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_ver() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_ver
BEFORE INSERT OR UPDATE ON tt_ver
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_ver();



/*-- SEQ 6458 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_vol() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filvol)::VARCHAR = '''' THEN
   NEW.filvol := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.filcar)::VARCHAR = '''' THEN
   NEW.filcar := NULL;
END IF;
IF trim(NEW.seqcar)::VARCHAR = '''' THEN
   NEW.seqcar := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_vol
BEFORE INSERT OR UPDATE ON tt_vol
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_vol();



/*-- SEQ 6459 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_vot() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filoip)::VARCHAR = '''' THEN
   NEW.filoip := NULL;
END IF;
IF trim(NEW.seqoip)::VARCHAR = '''' THEN
   NEW.seqoip := NULL;
END IF;
IF trim(NEW.especi)::VARCHAR = '''' THEN
   NEW.especi := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_vot
BEFORE INSERT OR UPDATE ON tt_vot
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_vot();



/*-- SEQ 6460 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_vpe() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codvdd)::VARCHAR = '''' THEN
   NEW.codvdd := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.filvdd)::VARCHAR = '''' THEN
   NEW.filvdd := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.comple)::VARCHAR = '''' THEN
   NEW.comple := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.filped)::VARCHAR = '''' THEN
   NEW.filped := NULL;
END IF;
IF trim(NEW.tipped)::VARCHAR = '''' THEN
   NEW.tipped := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.status)::VARCHAR = '''' THEN
   NEW.status := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_vpe
BEFORE INSERT OR UPDATE ON tt_vpe
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_vpe();



/*-- SEQ 6461 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_vrt() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.flgtip)::VARCHAR = '''' THEN
   NEW.flgtip := NULL;
END IF;
IF trim(NEW.flgenv)::VARCHAR = '''' THEN
   NEW.flgenv := NULL;
END IF;
IF trim(NEW.flgcan)::VARCHAR = '''' THEN
   NEW.flgcan := NULL;
END IF;
IF trim(NEW.flginu)::VARCHAR = '''' THEN
   NEW.flginu := NULL;
END IF;
IF trim(NEW.flgimp)::VARCHAR = '''' THEN
   NEW.flgimp := NULL;
END IF;
IF trim(NEW.chavea)::VARCHAR = '''' THEN
   NEW.chavea := NULL;
END IF;
IF trim(NEW.motret)::VARCHAR = '''' THEN
   NEW.motret := NULL;
END IF;
IF trim(NEW.filven)::VARCHAR = '''' THEN
   NEW.filven := NULL;
END IF;
IF trim(NEW.ecfven)::VARCHAR = '''' THEN
   NEW.ecfven := NULL;
END IF;
IF trim(NEW.serven)::VARCHAR = '''' THEN
   NEW.serven := NULL;
END IF;
IF trim(NEW.notven)::VARCHAR = '''' THEN
   NEW.notven := NULL;
END IF;
IF trim(NEW.flgsta)::VARCHAR = '''' THEN
   NEW.flgsta := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_vrt
BEFORE INSERT OR UPDATE ON tt_vrt
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_vrt();



/*-- SEQ 6462 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_vxp() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.placas)::VARCHAR = '''' THEN
   NEW.placas := NULL;
END IF;
IF trim(NEW.tipmot)::VARCHAR = '''' THEN
   NEW.tipmot := NULL;
END IF;
IF trim(NEW.tiptra)::VARCHAR = '''' THEN
   NEW.tiptra := NULL;
END IF;
IF trim(NEW.filmot)::VARCHAR = '''' THEN
   NEW.filmot := NULL;
END IF;
IF trim(NEW.filtra)::VARCHAR = '''' THEN
   NEW.filtra := NULL;
END IF;
IF trim(NEW.codmot)::VARCHAR = '''' THEN
   NEW.codmot := NULL;
END IF;
IF trim(NEW.codtra)::VARCHAR = '''' THEN
   NEW.codtra := NULL;
END IF;
IF trim(NEW.destin)::VARCHAR = '''' THEN
   NEW.destin := NULL;
END IF;
IF trim(NEW.origem)::VARCHAR = '''' THEN
   NEW.origem := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_vxp
BEFORE INSERT OR UPDATE ON tt_vxp
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_vxp();



/*-- SEQ 6463 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_wor() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.fatura)::VARCHAR = '''' THEN
   NEW.fatura := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.codreg)::VARCHAR = '''' THEN
   NEW.codreg := NULL;
END IF;
IF trim(NEW.filprj)::VARCHAR = '''' THEN
   NEW.filprj := NULL;
END IF;
IF trim(NEW.filreg)::VARCHAR = '''' THEN
   NEW.filreg := NULL;
END IF;
IF trim(NEW.seqprj)::VARCHAR = '''' THEN
   NEW.seqprj := NULL;
END IF;
IF trim(NEW.avisar)::VARCHAR = '''' THEN
   NEW.avisar := NULL;
END IF;
IF trim(NEW.reserv)::VARCHAR = '''' THEN
   NEW.reserv := NULL;
END IF;
IF trim(NEW.destar)::VARCHAR = '''' THEN
   NEW.destar := NULL;
END IF;
IF trim(NEW.tipact)::VARCHAR = '''' THEN
   NEW.tipact := NULL;
END IF;
IF trim(NEW.codres)::VARCHAR = '''' THEN
   NEW.codres := NULL;
END IF;
IF trim(NEW.codtst)::VARCHAR = '''' THEN
   NEW.codtst := NULL;
END IF;
IF trim(NEW.filact)::VARCHAR = '''' THEN
   NEW.filact := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.filres)::VARCHAR = '''' THEN
   NEW.filres := NULL;
END IF;
IF trim(NEW.filsol)::VARCHAR = '''' THEN
   NEW.filsol := NULL;
END IF;
IF trim(NEW.filtst)::VARCHAR = '''' THEN
   NEW.filtst := NULL;
END IF;
IF trim(NEW.codact)::VARCHAR = '''' THEN
   NEW.codact := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.codsol)::VARCHAR = '''' THEN
   NEW.codsol := NULL;
END IF;
IF trim(NEW.flgact)::VARCHAR = '''' THEN
   NEW.flgact := NULL;
END IF;
IF trim(NEW.docume)::VARCHAR = '''' THEN
   NEW.docume := NULL;
END IF;
IF trim(NEW.revisa)::VARCHAR = '''' THEN
   NEW.revisa := NULL;
END IF;
IF trim(NEW.tarefa)::VARCHAR = '''' THEN
   NEW.tarefa := NULL;
END IF;
IF trim(NEW.codfpa)::VARCHAR = '''' THEN
   NEW.codfpa := NULL;
END IF;
IF trim(NEW.tipmao)::VARCHAR = '''' THEN
   NEW.tipmao := NULL;
END IF;
IF trim(NEW.datfix)::VARCHAR = '''' THEN
   NEW.datfix := NULL;
END IF;
IF trim(NEW.filrev)::VARCHAR = '''' THEN
   NEW.filrev := NULL;
END IF;
IF trim(NEW.codrev)::VARCHAR = '''' THEN
   NEW.codrev := NULL;
END IF;
IF trim(NEW.tipcws)::VARCHAR = '''' THEN
   NEW.tipcws := NULL;
END IF;
IF trim(NEW.comjus)::VARCHAR = '''' THEN
   NEW.comjus := NULL;
END IF;
IF trim(NEW.splitw)::VARCHAR = '''' THEN
   NEW.splitw := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.versao)::VARCHAR = '''' THEN
   NEW.versao := NULL;
END IF;
IF trim(NEW.perfil)::VARCHAR = '''' THEN
   NEW.perfil := NULL;
END IF;
IF trim(NEW.filped)::VARCHAR = '''' THEN
   NEW.filped := NULL;
END IF;
IF trim(NEW.tipped)::VARCHAR = '''' THEN
   NEW.tipped := NULL;
END IF;
IF trim(NEW.numped)::VARCHAR = '''' THEN
   NEW.numped := NULL;
END IF;
IF trim(NEW.modelo)::VARCHAR = '''' THEN
   NEW.modelo := NULL;
END IF;
IF trim(NEW.filmod)::VARCHAR = '''' THEN
   NEW.filmod := NULL;
END IF;
IF trim(NEW.seqmod)::VARCHAR = '''' THEN
   NEW.seqmod := NULL;
END IF;
IF trim(NEW.filpos)::VARCHAR = '''' THEN
   NEW.filpos := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_wor
BEFORE INSERT OR UPDATE ON tt_wor
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_wor();



/*-- SEQ 6464 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tt_worxwor() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filwor)::VARCHAR = '''' THEN
   NEW.filwor := NULL;
END IF;
IF trim(NEW.seqwor)::VARCHAR = '''' THEN
   NEW.seqwor := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tt_worxwor
BEFORE INSERT OR UPDATE ON tt_worxwor
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tt_worxwor();



/*-- SEQ 6465 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_arq() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codtab)::VARCHAR = '''' THEN
   NEW.codtab := NULL;
END IF;
IF trim(NEW.codfis)::VARCHAR = '''' THEN
   NEW.codfis := NULL;
END IF;
IF trim(NEW.descri)::VARCHAR = '''' THEN
   NEW.descri := NULL;
END IF;
IF trim(NEW.filbas)::VARCHAR = '''' THEN
   NEW.filbas := NULL;
END IF;
IF trim(NEW.formul)::VARCHAR = '''' THEN
   NEW.formul := NULL;
END IF;
IF trim(NEW.id_uni)::VARCHAR = '''' THEN
   NEW.id_uni := NULL;
END IF;
IF trim(NEW.nomtab)::VARCHAR = '''' THEN
   NEW.nomtab := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.paleta)::VARCHAR = '''' THEN
   NEW.paleta := NULL;
END IF;
IF trim(NEW.parame)::VARCHAR = '''' THEN
   NEW.parame := NULL;
END IF;
IF trim(NEW.path)::VARCHAR = '''' THEN
   NEW.path := NULL;
END IF;
IF trim(NEW.person)::VARCHAR = '''' THEN
   NEW.person := NULL;
END IF;
IF trim(NEW.primar)::VARCHAR = '''' THEN
   NEW.primar := NULL;
END IF;
IF trim(NEW.secun1)::VARCHAR = '''' THEN
   NEW.secun1 := NULL;
END IF;
IF trim(NEW.secun2)::VARCHAR = '''' THEN
   NEW.secun2 := NULL;
END IF;
IF trim(NEW.subsql)::VARCHAR = '''' THEN
   NEW.subsql := NULL;
END IF;
IF trim(NEW.apelid)::VARCHAR = '''' THEN
   NEW.apelid := NULL;
END IF;
IF trim(NEW.geral)::VARCHAR = '''' THEN
   NEW.geral := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_arq
BEFORE INSERT OR UPDATE ON tw_arq
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_arq();



/*-- SEQ 6466 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_ccc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.cccati)::VARCHAR = '''' THEN
   NEW.cccati := NULL;
END IF;
IF trim(NEW.comccc)::VARCHAR = '''' THEN
   NEW.comccc := NULL;
END IF;
IF trim(NEW.desccc)::VARCHAR = '''' THEN
   NEW.desccc := NULL;
END IF;
IF trim(NEW.regccc)::VARCHAR = '''' THEN
   NEW.regccc := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_ccc
BEFORE INSERT OR UPDATE ON tw_ccc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_ccc();



/*-- SEQ 6467 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_cfg() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.lanven_reimp_cf)::VARCHAR = '''' THEN
   NEW.lanven_reimp_cf := NULL;
END IF;
IF trim(NEW.tipcta_trn)::VARCHAR = '''' THEN
   NEW.tipcta_trn := NULL;
END IF;
IF trim(NEW.usostd)::VARCHAR = '''' THEN
   NEW.usostd := NULL;
END IF;
IF trim(NEW.serie_fat_cc)::VARCHAR = '''' THEN
   NEW.serie_fat_cc := NULL;
END IF;
IF trim(NEW.filcta_trn)::VARCHAR = '''' THEN
   NEW.filcta_trn := NULL;
END IF;
IF trim(NEW.filpre)::VARCHAR = '''' THEN
   NEW.filpre := NULL;
END IF;
IF trim(NEW.seqcta_trn)::VARCHAR = '''' THEN
   NEW.seqcta_trn := NULL;
END IF;
IF trim(NEW.au_entrel)::VARCHAR = '''' THEN
   NEW.au_entrel := NULL;
END IF;
IF trim(NEW.au_entrelc)::VARCHAR = '''' THEN
   NEW.au_entrelc := NULL;
END IF;
IF trim(NEW.chetro)::VARCHAR = '''' THEN
   NEW.chetro := NULL;
END IF;
IF trim(NEW.clicodext)::VARCHAR = '''' THEN
   NEW.clicodext := NULL;
END IF;
IF trim(NEW.financ_reimp_cf)::VARCHAR = '''' THEN
   NEW.financ_reimp_cf := NULL;
END IF;
IF trim(NEW.movest_reimp_cf)::VARCHAR = '''' THEN
   NEW.movest_reimp_cf := NULL;
END IF;
IF trim(NEW.pcoonline)::VARCHAR = '''' THEN
   NEW.pcoonline := NULL;
END IF;
IF trim(NEW.tipfar)::VARCHAR = '''' THEN
   NEW.tipfar := NULL;
END IF;
IF trim(NEW.tippos)::VARCHAR = '''' THEN
   NEW.tippos := NULL;
END IF;
IF trim(NEW.tipsoft)::VARCHAR = '''' THEN
   NEW.tipsoft := NULL;
END IF;
IF trim(NEW.tribut_reimp_cf)::VARCHAR = '''' THEN
   NEW.tribut_reimp_cf := NULL;
END IF;
IF trim(NEW.usadoc)::VARCHAR = '''' THEN
   NEW.usadoc := NULL;
END IF;
IF trim(NEW.valida_numdoc)::VARCHAR = '''' THEN
   NEW.valida_numdoc := NULL;
END IF;
IF trim(NEW.vldcliext)::VARCHAR = '''' THEN
   NEW.vldcliext := NULL;
END IF;
IF trim(NEW.vldestext)::VARCHAR = '''' THEN
   NEW.vldestext := NULL;
END IF;
IF trim(NEW.cdco)::VARCHAR = '''' THEN
   NEW.cdco := NULL;
END IF;
IF trim(NEW.au_impress)::VARCHAR = '''' THEN
   NEW.au_impress := NULL;
END IF;
IF trim(NEW.categ1)::VARCHAR = '''' THEN
   NEW.categ1 := NULL;
END IF;
IF trim(NEW.categ2)::VARCHAR = '''' THEN
   NEW.categ2 := NULL;
END IF;
IF trim(NEW.categ3)::VARCHAR = '''' THEN
   NEW.categ3 := NULL;
END IF;
IF trim(NEW.class1)::VARCHAR = '''' THEN
   NEW.class1 := NULL;
END IF;
IF trim(NEW.class2)::VARCHAR = '''' THEN
   NEW.class2 := NULL;
END IF;
IF trim(NEW.class3)::VARCHAR = '''' THEN
   NEW.class3 := NULL;
END IF;
IF trim(NEW.class4)::VARCHAR = '''' THEN
   NEW.class4 := NULL;
END IF;
IF trim(NEW.data1)::VARCHAR = '''' THEN
   NEW.data1 := NULL;
END IF;
IF trim(NEW.data2)::VARCHAR = '''' THEN
   NEW.data2 := NULL;
END IF;
IF trim(NEW.data3)::VARCHAR = '''' THEN
   NEW.data3 := NULL;
END IF;
IF trim(NEW.pluraldec)::VARCHAR = '''' THEN
   NEW.pluraldec := NULL;
END IF;
IF trim(NEW.pluralint)::VARCHAR = '''' THEN
   NEW.pluralint := NULL;
END IF;
IF trim(NEW.singuldec)::VARCHAR = '''' THEN
   NEW.singuldec := NULL;
END IF;
IF trim(NEW.singulint)::VARCHAR = '''' THEN
   NEW.singulint := NULL;
END IF;
IF trim(NEW.vc_plano)::VARCHAR = '''' THEN
   NEW.vc_plano := NULL;
END IF;
IF trim(NEW.au_autent)::VARCHAR = '''' THEN
   NEW.au_autent := NULL;
END IF;
IF trim(NEW.au_desaut)::VARCHAR = '''' THEN
   NEW.au_desaut := NULL;
END IF;
IF trim(NEW.au_deslin)::VARCHAR = '''' THEN
   NEW.au_deslin := NULL;
END IF;
IF trim(NEW.au_hablin)::VARCHAR = '''' THEN
   NEW.au_hablin := NULL;
END IF;
IF trim(NEW.au_lnfeed)::VARCHAR = '''' THEN
   NEW.au_lnfeed := NULL;
END IF;
IF trim(NEW.mask_locali)::VARCHAR = '''' THEN
   NEW.mask_locali := NULL;
END IF;
IF trim(NEW.nomcodsac)::VARCHAR = '''' THEN
   NEW.nomcodsac := NULL;
END IF;
IF trim(NEW.nomlstsac)::VARCHAR = '''' THEN
   NEW.nomlstsac := NULL;
END IF;
IF trim(NEW.nomnumreg)::VARCHAR = '''' THEN
   NEW.nomnumreg := NULL;
END IF;
IF trim(NEW.nomnumser)::VARCHAR = '''' THEN
   NEW.nomnumser := NULL;
END IF;
IF trim(NEW.subcodsac)::VARCHAR = '''' THEN
   NEW.subcodsac := NULL;
END IF;
IF trim(NEW.au_inic)::VARCHAR = '''' THEN
   NEW.au_inic := NULL;
END IF;
IF trim(NEW.cod_ecb_tit_desecb)::VARCHAR = '''' THEN
   NEW.cod_ecb_tit_desecb := NULL;
END IF;
IF trim(NEW.desccc)::VARCHAR = '''' THEN
   NEW.desccc := NULL;
END IF;
IF trim(NEW.desven)::VARCHAR = '''' THEN
   NEW.desven := NULL;
END IF;
IF trim(NEW.int_alt_dat_desrem)::VARCHAR = '''' THEN
   NEW.int_alt_dat_desrem := NULL;
END IF;
IF trim(NEW.int_alt_vlr_desrem)::VARCHAR = '''' THEN
   NEW.int_alt_vlr_desrem := NULL;
END IF;
IF trim(NEW.int_can_des_desrem)::VARCHAR = '''' THEN
   NEW.int_can_des_desrem := NULL;
END IF;
IF trim(NEW.int_can_tit_desrem)::VARCHAR = '''' THEN
   NEW.int_can_tit_desrem := NULL;
END IF;
IF trim(NEW.int_con_des_desrem)::VARCHAR = '''' THEN
   NEW.int_con_des_desrem := NULL;
END IF;
IF trim(NEW.int_inc_tit_desrem)::VARCHAR = '''' THEN
   NEW.int_inc_tit_desrem := NULL;
END IF;
IF trim(NEW.int_pag_car_desrem)::VARCHAR = '''' THEN
   NEW.int_pag_car_desrem := NULL;
END IF;
IF trim(NEW.int_prt_tit_desrem)::VARCHAR = '''' THEN
   NEW.int_prt_tit_desrem := NULL;
END IF;
IF trim(NEW.int_s_b_prt_desrem)::VARCHAR = '''' THEN
   NEW.int_s_b_prt_desrem := NULL;
END IF;
IF trim(NEW.int_s_c_prt_desrem)::VARCHAR = '''' THEN
   NEW.int_s_c_prt_desrem := NULL;
END IF;
IF trim(NEW.nomemp)::VARCHAR = '''' THEN
   NEW.nomemp := NULL;
END IF;
IF trim(NEW.campox)::VARCHAR = '''' THEN
   NEW.campox := NULL;
END IF;
IF trim(NEW.vc_cliente)::VARCHAR = '''' THEN
   NEW.vc_cliente := NULL;
END IF;
IF trim(NEW.au_imprim)::VARCHAR = '''' THEN
   NEW.au_imprim := NULL;
END IF;
IF trim(NEW.desdop_std)::VARCHAR = '''' THEN
   NEW.desdop_std := NULL;
END IF;
IF trim(NEW.mai_fr)::VARCHAR = '''' THEN
   NEW.mai_fr := NULL;
END IF;
IF trim(NEW.mai_to)::VARCHAR = '''' THEN
   NEW.mai_to := NULL;
END IF;
IF trim(NEW.path_anexos)::VARCHAR = '''' THEN
   NEW.path_anexos := NULL;
END IF;
IF trim(NEW.path_projetos)::VARCHAR = '''' THEN
   NEW.path_projetos := NULL;
END IF;
IF trim(NEW.rbpath)::VARCHAR = '''' THEN
   NEW.rbpath := NULL;
END IF;
IF trim(NEW.alttab)::VARCHAR = '''' THEN
   NEW.alttab := NULL;
END IF;
IF trim(NEW.fmtdoc)::VARCHAR = '''' THEN
   NEW.fmtdoc := NULL;
END IF;
IF trim(NEW.fmtreq)::VARCHAR = '''' THEN
   NEW.fmtreq := NULL;
END IF;
IF trim(NEW.vende_desativados)::VARCHAR = '''' THEN
   NEW.vende_desativados := NULL;
END IF;
IF trim(NEW.popula_tp_cli)::VARCHAR = '''' THEN
   NEW.popula_tp_cli := NULL;
END IF;
IF trim(NEW.ckbemvindo)::VARCHAR = '''' THEN
   NEW.ckbemvindo := NULL;
END IF;
IF trim(NEW.cknomatend)::VARCHAR = '''' THEN
   NEW.cknomatend := NULL;
END IF;
IF trim(NEW.ckvlrinfun)::VARCHAR = '''' THEN
   NEW.ckvlrinfun := NULL;
END IF;
IF trim(NEW.ckusabalan)::VARCHAR = '''' THEN
   NEW.ckusabalan := NULL;
END IF;
IF trim(NEW.cknumextdp)::VARCHAR = '''' THEN
   NEW.cknumextdp := NULL;
END IF;
IF trim(NEW.ckpanumext)::VARCHAR = '''' THEN
   NEW.ckpanumext := NULL;
END IF;
IF trim(NEW.ckpaobrven)::VARCHAR = '''' THEN
   NEW.ckpaobrven := NULL;
END IF;
IF trim(NEW.ckpaagrupa)::VARCHAR = '''' THEN
   NEW.ckpaagrupa := NULL;
END IF;
IF trim(NEW.ckpaconsfi)::VARCHAR = '''' THEN
   NEW.ckpaconsfi := NULL;
END IF;
IF trim(NEW.ckusadebap)::VARCHAR = '''' THEN
   NEW.ckusadebap := NULL;
END IF;
IF trim(NEW.ckpapagirr)::VARCHAR = '''' THEN
   NEW.ckpapagirr := NULL;
END IF;
IF trim(NEW.ckpasaiche)::VARCHAR = '''' THEN
   NEW.ckpasaiche := NULL;
END IF;
IF trim(NEW.ckpamfimpp)::VARCHAR = '''' THEN
   NEW.ckpamfimpp := NULL;
END IF;
IF trim(NEW.ckpadigche)::VARCHAR = '''' THEN
   NEW.ckpadigche := NULL;
END IF;
IF trim(NEW.ckpapredoc)::VARCHAR = '''' THEN
   NEW.ckpapredoc := NULL;
END IF;
IF trim(NEW.ckpavlrapr)::VARCHAR = '''' THEN
   NEW.ckpavlrapr := NULL;
END IF;
IF trim(NEW.ckpasaicai)::VARCHAR = '''' THEN
   NEW.ckpasaicai := NULL;
END IF;
IF trim(NEW.ckpaunicai)::VARCHAR = '''' THEN
   NEW.ckpaunicai := NULL;
END IF;
IF trim(NEW.ckpatxtpre)::VARCHAR = '''' THEN
   NEW.ckpatxtpre := NULL;
END IF;
IF trim(NEW.ckpavenite)::VARCHAR = '''' THEN
   NEW.ckpavenite := NULL;
END IF;
IF trim(NEW.ckpatotven)::VARCHAR = '''' THEN
   NEW.ckpatotven := NULL;
END IF;
IF trim(NEW.ckpadescit)::VARCHAR = '''' THEN
   NEW.ckpadescit := NULL;
END IF;
IF trim(NEW.ckpadescto)::VARCHAR = '''' THEN
   NEW.ckpadescto := NULL;
END IF;
IF trim(NEW.ckftxtsub1)::VARCHAR = '''' THEN
   NEW.ckftxtsub1 := NULL;
END IF;
IF trim(NEW.ckftxtsub2)::VARCHAR = '''' THEN
   NEW.ckftxtsub2 := NULL;
END IF;
IF trim(NEW.ckftxtsub3)::VARCHAR = '''' THEN
   NEW.ckftxtsub3 := NULL;
END IF;
IF trim(NEW.ckftxtsub4)::VARCHAR = '''' THEN
   NEW.ckftxtsub4 := NULL;
END IF;
IF trim(NEW.ckforcomit)::VARCHAR = '''' THEN
   NEW.ckforcomit := NULL;
END IF;
IF trim(NEW.ckforcomv1)::VARCHAR = '''' THEN
   NEW.ckforcomv1 := NULL;
END IF;
IF trim(NEW.ckforcomv2)::VARCHAR = '''' THEN
   NEW.ckforcomv2 := NULL;
END IF;
IF trim(NEW.ckforcoms1)::VARCHAR = '''' THEN
   NEW.ckforcoms1 := NULL;
END IF;
IF trim(NEW.ckforcoms2)::VARCHAR = '''' THEN
   NEW.ckforcoms2 := NULL;
END IF;
IF trim(NEW.ckforcoms3)::VARCHAR = '''' THEN
   NEW.ckforcoms3 := NULL;
END IF;
IF trim(NEW.ckforcoms4)::VARCHAR = '''' THEN
   NEW.ckforcoms4 := NULL;
END IF;
IF trim(NEW.ckpacoml1)::VARCHAR = '''' THEN
   NEW.ckpacoml1 := NULL;
END IF;
IF trim(NEW.ckpacoml2)::VARCHAR = '''' THEN
   NEW.ckpacoml2 := NULL;
END IF;
IF trim(NEW.ckpacoml3)::VARCHAR = '''' THEN
   NEW.ckpacoml3 := NULL;
END IF;
IF trim(NEW.ckpacoml4)::VARCHAR = '''' THEN
   NEW.ckpacoml4 := NULL;
END IF;
IF trim(NEW.e_mail_financ)::VARCHAR = '''' THEN
   NEW.e_mail_financ := NULL;
END IF;
IF trim(NEW.deposita_chetro)::VARCHAR = '''' THEN
   NEW.deposita_chetro := NULL;
END IF;
IF trim(NEW.ciclopre)::VARCHAR = '''' THEN
   NEW.ciclopre := NULL;
END IF;
IF trim(NEW.sac_mail_filusu)::VARCHAR = '''' THEN
   NEW.sac_mail_filusu := NULL;
END IF;
IF trim(NEW.sac_mail_codusu)::VARCHAR = '''' THEN
   NEW.sac_mail_codusu := NULL;
END IF;
IF trim(NEW.sac_mail_apeusu)::VARCHAR = '''' THEN
   NEW.sac_mail_apeusu := NULL;
END IF;
IF trim(NEW.patipodesconto)::VARCHAR = '''' THEN
   NEW.patipodesconto := NULL;
END IF;
IF trim(NEW.cli_codsex)::VARCHAR = '''' THEN
   NEW.cli_codsex := NULL;
END IF;
IF trim(NEW.cli_estciv)::VARCHAR = '''' THEN
   NEW.cli_estciv := NULL;
END IF;
IF trim(NEW.cli_categ2)::VARCHAR = '''' THEN
   NEW.cli_categ2 := NULL;
END IF;
IF trim(NEW.cli_categ3)::VARCHAR = '''' THEN
   NEW.cli_categ3 := NULL;
END IF;
IF trim(NEW.cli_datnas)::VARCHAR = '''' THEN
   NEW.cli_datnas := NULL;
END IF;
IF trim(NEW.cli_doccon)::VARCHAR = '''' THEN
   NEW.cli_doccon := NULL;
END IF;
IF trim(NEW.cli_nascon)::VARCHAR = '''' THEN
   NEW.cli_nascon := NULL;
END IF;
IF trim(NEW.cli_conjug)::VARCHAR = '''' THEN
   NEW.cli_conjug := NULL;
END IF;
IF trim(NEW.cli_insest)::VARCHAR = '''' THEN
   NEW.cli_insest := NULL;
END IF;
IF trim(NEW.cli_numfon)::VARCHAR = '''' THEN
   NEW.cli_numfon := NULL;
END IF;
IF trim(NEW.cli_endere)::VARCHAR = '''' THEN
   NEW.cli_endere := NULL;
END IF;
IF trim(NEW.cli_codcep)::VARCHAR = '''' THEN
   NEW.cli_codcep := NULL;
END IF;
IF trim(NEW.cc_workflow_desc)::VARCHAR = '''' THEN
   NEW.cc_workflow_desc := NULL;
END IF;
IF trim(NEW.vc_codcli)::VARCHAR = '''' THEN
   NEW.vc_codcli := NULL;
END IF;
IF trim(NEW.vc_filcli)::VARCHAR = '''' THEN
   NEW.vc_filcli := NULL;
END IF;
IF trim(NEW.vc_codpgt)::VARCHAR = '''' THEN
   NEW.vc_codpgt := NULL;
END IF;
IF trim(NEW.vc_filpgt)::VARCHAR = '''' THEN
   NEW.vc_filpgt := NULL;
END IF;
IF trim(NEW.vc_serie)::VARCHAR = '''' THEN
   NEW.vc_serie := NULL;
END IF;
IF trim(NEW.cli_categ1)::VARCHAR = '''' THEN
   NEW.cli_categ1 := NULL;
END IF;
IF trim(NEW.deduztaxatitulo)::VARCHAR = '''' THEN
   NEW.deduztaxatitulo := NULL;
END IF;
IF trim(NEW.path_arquivos)::VARCHAR = '''' THEN
   NEW.path_arquivos := NULL;
END IF;
IF trim(NEW.pre_psi_utiliza)::VARCHAR = '''' THEN
   NEW.pre_psi_utiliza := NULL;
END IF;
IF trim(NEW.nf_apos_cf)::VARCHAR = '''' THEN
   NEW.nf_apos_cf := NULL;
END IF;
IF trim(NEW.credit_score)::VARCHAR = '''' THEN
   NEW.credit_score := NULL;
END IF;
IF trim(NEW.ultsac_filusu)::VARCHAR = '''' THEN
   NEW.ultsac_filusu := NULL;
END IF;
IF trim(NEW.ultsac_codusu)::VARCHAR = '''' THEN
   NEW.ultsac_codusu := NULL;
END IF;
IF trim(NEW.fatura_cc_por_filial)::VARCHAR = '''' THEN
   NEW.fatura_cc_por_filial := NULL;
END IF;
IF trim(NEW.paphoto)::VARCHAR = '''' THEN
   NEW.paphoto := NULL;
END IF;
IF trim(NEW.paphoetiqueta)::VARCHAR = '''' THEN
   NEW.paphoetiqueta := NULL;
END IF;
IF trim(NEW.paphofor1)::VARCHAR = '''' THEN
   NEW.paphofor1 := NULL;
END IF;
IF trim(NEW.paphofors)::VARCHAR = '''' THEN
   NEW.paphofors := NULL;
END IF;
IF trim(NEW.paphovar1)::VARCHAR = '''' THEN
   NEW.paphovar1 := NULL;
END IF;
IF trim(NEW.paphovar2)::VARCHAR = '''' THEN
   NEW.paphovar2 := NULL;
END IF;
IF trim(NEW.paphovar3)::VARCHAR = '''' THEN
   NEW.paphovar3 := NULL;
END IF;
IF trim(NEW.paphofilrevela)::VARCHAR = '''' THEN
   NEW.paphofilrevela := NULL;
END IF;
IF trim(NEW.paphocodrevela)::VARCHAR = '''' THEN
   NEW.paphocodrevela := NULL;
END IF;
IF trim(NEW.paphofilamplia)::VARCHAR = '''' THEN
   NEW.paphofilamplia := NULL;
END IF;
IF trim(NEW.paphocodamplia)::VARCHAR = '''' THEN
   NEW.paphocodamplia := NULL;
END IF;
IF trim(NEW.paphofilrevamp)::VARCHAR = '''' THEN
   NEW.paphofilrevamp := NULL;
END IF;
IF trim(NEW.paphocodrevamp)::VARCHAR = '''' THEN
   NEW.paphocodrevamp := NULL;
END IF;
IF trim(NEW.produto_rev)::VARCHAR = '''' THEN
   NEW.produto_rev := NULL;
END IF;
IF trim(NEW.produto_amp)::VARCHAR = '''' THEN
   NEW.produto_amp := NULL;
END IF;
IF trim(NEW.produto_rev_amp)::VARCHAR = '''' THEN
   NEW.produto_rev_amp := NULL;
END IF;
IF trim(NEW.pose_padrao)::VARCHAR = '''' THEN
   NEW.pose_padrao := NULL;
END IF;
IF trim(NEW.obs_padrao)::VARCHAR = '''' THEN
   NEW.obs_padrao := NULL;
END IF;
IF trim(NEW.palistadebitos)::VARCHAR = '''' THEN
   NEW.palistadebitos := NULL;
END IF;
IF trim(NEW.papredatarconsumidor)::VARCHAR = '''' THEN
   NEW.papredatarconsumidor := NULL;
END IF;
IF trim(NEW.acao_devolucao)::VARCHAR = '''' THEN
   NEW.acao_devolucao := NULL;
END IF;
IF trim(NEW.sac_pos_venda)::VARCHAR = '''' THEN
   NEW.sac_pos_venda := NULL;
END IF;
IF trim(NEW.filprj)::VARCHAR = '''' THEN
   NEW.filprj := NULL;
END IF;
IF trim(NEW.seqprj)::VARCHAR = '''' THEN
   NEW.seqprj := NULL;
END IF;
IF trim(NEW.restricao_vinculo)::VARCHAR = '''' THEN
   NEW.restricao_vinculo := NULL;
END IF;
IF trim(NEW.une_nome_sobrenome)::VARCHAR = '''' THEN
   NEW.une_nome_sobrenome := NULL;
END IF;
IF trim(NEW.recpar_devolucao)::VARCHAR = '''' THEN
   NEW.recpar_devolucao := NULL;
END IF;
IF trim(NEW.cliente_por_doc)::VARCHAR = '''' THEN
   NEW.cliente_por_doc := NULL;
END IF;
IF trim(NEW.e_mail_estoque)::VARCHAR = '''' THEN
   NEW.e_mail_estoque := NULL;
END IF;
IF trim(NEW.ckdescecf)::VARCHAR = '''' THEN
   NEW.ckdescecf := NULL;
END IF;
IF trim(NEW.cob_usa_sac)::VARCHAR = '''' THEN
   NEW.cob_usa_sac := NULL;
END IF;
IF trim(NEW.cob_forma_registro)::VARCHAR = '''' THEN
   NEW.cob_forma_registro := NULL;
END IF;
IF trim(NEW.cob_e_mail_sac)::VARCHAR = '''' THEN
   NEW.cob_e_mail_sac := NULL;
END IF;
IF trim(NEW.cob_e_mail_cartas)::VARCHAR = '''' THEN
   NEW.cob_e_mail_cartas := NULL;
END IF;
IF trim(NEW.cob_e_mail_spc)::VARCHAR = '''' THEN
   NEW.cob_e_mail_spc := NULL;
END IF;
IF trim(NEW.cob_fil_gerente)::VARCHAR = '''' THEN
   NEW.cob_fil_gerente := NULL;
END IF;
IF trim(NEW.cob_cod_gerente)::VARCHAR = '''' THEN
   NEW.cob_cod_gerente := NULL;
END IF;
IF trim(NEW.e_mail_erro)::VARCHAR = '''' THEN
   NEW.e_mail_erro := NULL;
END IF;
IF trim(NEW.tamanho_observacao)::VARCHAR = '''' THEN
   NEW.tamanho_observacao := NULL;
END IF;
IF trim(NEW.cancela_reserva)::VARCHAR = '''' THEN
   NEW.cancela_reserva := NULL;
END IF;
IF trim(NEW.usa_renegociacao_sac)::VARCHAR = '''' THEN
   NEW.usa_renegociacao_sac := NULL;
END IF;
IF trim(NEW.cli_call_c)::VARCHAR = '''' THEN
   NEW.cli_call_c := NULL;
END IF;
IF trim(NEW.compensacao_automatica)::VARCHAR = '''' THEN
   NEW.compensacao_automatica := NULL;
END IF;
IF trim(NEW.valortransferencia)::VARCHAR = '''' THEN
   NEW.valortransferencia := NULL;
END IF;
IF trim(NEW.ckpamfl1)::VARCHAR = '''' THEN
   NEW.ckpamfl1 := NULL;
END IF;
IF trim(NEW.ckpamfl2)::VARCHAR = '''' THEN
   NEW.ckpamfl2 := NULL;
END IF;
IF trim(NEW.ckpamfl3)::VARCHAR = '''' THEN
   NEW.ckpamfl3 := NULL;
END IF;
IF trim(NEW.ckpamfl4)::VARCHAR = '''' THEN
   NEW.ckpamfl4 := NULL;
END IF;
IF trim(NEW.exporta_todos_clientes)::VARCHAR = '''' THEN
   NEW.exporta_todos_clientes := NULL;
END IF;
IF trim(NEW.pda_path_importacao)::VARCHAR = '''' THEN
   NEW.pda_path_importacao := NULL;
END IF;
IF trim(NEW.pda_path_exportacao)::VARCHAR = '''' THEN
   NEW.pda_path_exportacao := NULL;
END IF;
IF trim(NEW.pda_integracao)::VARCHAR = '''' THEN
   NEW.pda_integracao := NULL;
END IF;
IF trim(NEW.pda_filpre)::VARCHAR = '''' THEN
   NEW.pda_filpre := NULL;
END IF;
IF trim(NEW.usa_placa_orcamento)::VARCHAR = '''' THEN
   NEW.usa_placa_orcamento := NULL;
END IF;
IF trim(NEW.vinculo_placa_orcamento)::VARCHAR = '''' THEN
   NEW.vinculo_placa_orcamento := NULL;
END IF;
IF trim(NEW.transfer_ser)::VARCHAR = '''' THEN
   NEW.transfer_ser := NULL;
END IF;
IF trim(NEW.base_markup)::VARCHAR = '''' THEN
   NEW.base_markup := NULL;
END IF;
IF trim(NEW.pda_grupo)::VARCHAR = '''' THEN
   NEW.pda_grupo := NULL;
END IF;
IF trim(NEW.pda_subgrupo)::VARCHAR = '''' THEN
   NEW.pda_subgrupo := NULL;
END IF;
IF trim(NEW.abater_desconto_nf)::VARCHAR = '''' THEN
   NEW.abater_desconto_nf := NULL;
END IF;
IF trim(NEW.cli_nomcid)::VARCHAR = '''' THEN
   NEW.cli_nomcid := NULL;
END IF;
IF trim(NEW.cli_bairro)::VARCHAR = '''' THEN
   NEW.cli_bairro := NULL;
END IF;
IF trim(NEW.cli_regiao)::VARCHAR = '''' THEN
   NEW.cli_regiao := NULL;
END IF;
IF trim(NEW.sac_exige_codfun)::VARCHAR = '''' THEN
   NEW.sac_exige_codfun := NULL;
END IF;
IF trim(NEW.sac_exige_codcws)::VARCHAR = '''' THEN
   NEW.sac_exige_codcws := NULL;
END IF;
IF trim(NEW.filsrv)::VARCHAR = '''' THEN
   NEW.filsrv := NULL;
END IF;
IF trim(NEW.codsrv)::VARCHAR = '''' THEN
   NEW.codsrv := NULL;
END IF;
IF trim(NEW.usa_perc_horfal)::VARCHAR = '''' THEN
   NEW.usa_perc_horfal := NULL;
END IF;
IF trim(NEW.solicita_end_cf)::VARCHAR = '''' THEN
   NEW.solicita_end_cf := NULL;
END IF;
IF trim(NEW.pda_ultexp_parcial)::VARCHAR = '''' THEN
   NEW.pda_ultexp_parcial := NULL;
END IF;
IF trim(NEW.sugere_servicos)::VARCHAR = '''' THEN
   NEW.sugere_servicos := NULL;
END IF;
IF trim(NEW.dados_path_exporta)::VARCHAR = '''' THEN
   NEW.dados_path_exporta := NULL;
END IF;
IF trim(NEW.dados_path_importa)::VARCHAR = '''' THEN
   NEW.dados_path_importa := NULL;
END IF;
IF trim(NEW.gera_codext_integracao)::VARCHAR = '''' THEN
   NEW.gera_codext_integracao := NULL;
END IF;
IF trim(NEW.cktxtpromissoria)::VARCHAR = '''' THEN
   NEW.cktxtpromissoria := NULL;
END IF;
IF trim(NEW.parc_cartao)::VARCHAR = '''' THEN
   NEW.parc_cartao := NULL;
END IF;
IF trim(NEW.parc_cliente_transp)::VARCHAR = '''' THEN
   NEW.parc_cliente_transp := NULL;
END IF;
IF trim(NEW.parc_fornecedor)::VARCHAR = '''' THEN
   NEW.parc_fornecedor := NULL;
END IF;
IF trim(NEW.parc_indica_venda)::VARCHAR = '''' THEN
   NEW.parc_indica_venda := NULL;
END IF;
IF trim(NEW.parc_marca)::VARCHAR = '''' THEN
   NEW.parc_marca := NULL;
END IF;
IF trim(NEW.parc_motorista)::VARCHAR = '''' THEN
   NEW.parc_motorista := NULL;
END IF;
IF trim(NEW.parc_representante)::VARCHAR = '''' THEN
   NEW.parc_representante := NULL;
END IF;
IF trim(NEW.parc_tec_interno)::VARCHAR = '''' THEN
   NEW.parc_tec_interno := NULL;
END IF;
IF trim(NEW.parc_transportador)::VARCHAR = '''' THEN
   NEW.parc_transportador := NULL;
END IF;
IF trim(NEW.parc_tecnico_externo)::VARCHAR = '''' THEN
   NEW.parc_tecnico_externo := NULL;
END IF;
IF trim(NEW.parc_usuario)::VARCHAR = '''' THEN
   NEW.parc_usuario := NULL;
END IF;
IF trim(NEW.limcredito_somalim)::VARCHAR = '''' THEN
   NEW.limcredito_somalim := NULL;
END IF;
IF trim(NEW.enviadatfaturamento)::VARCHAR = '''' THEN
   NEW.enviadatfaturamento := NULL;
END IF;
IF trim(NEW.ckfordes)::VARCHAR = '''' THEN
   NEW.ckfordes := NULL;
END IF;
IF trim(NEW.placaabertura)::VARCHAR = '''' THEN
   NEW.placaabertura := NULL;
END IF;
IF trim(NEW.imp_cf_nf)::VARCHAR = '''' THEN
   NEW.imp_cf_nf := NULL;
END IF;
IF trim(NEW.filprj_pxd)::VARCHAR = '''' THEN
   NEW.filprj_pxd := NULL;
END IF;
IF trim(NEW.seqprj_pxd)::VARCHAR = '''' THEN
   NEW.seqprj_pxd := NULL;
END IF;
IF trim(NEW.custo_por_filial)::VARCHAR = '''' THEN
   NEW.custo_por_filial := NULL;
END IF;
IF trim(NEW.impede_orc_maior_limite)::VARCHAR = '''' THEN
   NEW.impede_orc_maior_limite := NULL;
END IF;
IF trim(NEW.sac_exige_modulo)::VARCHAR = '''' THEN
   NEW.sac_exige_modulo := NULL;
END IF;
IF trim(NEW.ckpapesqident)::VARCHAR = '''' THEN
   NEW.ckpapesqident := NULL;
END IF;
IF trim(NEW.ckparecfilial)::VARCHAR = '''' THEN
   NEW.ckparecfilial := NULL;
END IF;
IF trim(NEW.agrupa_lctos_te_ccc)::VARCHAR = '''' THEN
   NEW.agrupa_lctos_te_ccc := NULL;
END IF;
IF trim(NEW.cksangrianegativa)::VARCHAR = '''' THEN
   NEW.cksangrianegativa := NULL;
END IF;
IF trim(NEW.tipcta_ecf)::VARCHAR = '''' THEN
   NEW.tipcta_ecf := NULL;
END IF;
IF trim(NEW.cktrocachradepositar)::VARCHAR = '''' THEN
   NEW.cktrocachradepositar := NULL;
END IF;
IF trim(NEW.sup_aprova_restricao)::VARCHAR = '''' THEN
   NEW.sup_aprova_restricao := NULL;
END IF;
IF trim(NEW.obrig_icms_ped)::VARCHAR = '''' THEN
   NEW.obrig_icms_ped := NULL;
END IF;
IF trim(NEW.spc_parcela)::VARCHAR = '''' THEN
   NEW.spc_parcela := NULL;
END IF;
IF trim(NEW.cli_contat)::VARCHAR = '''' THEN
   NEW.cli_contat := NULL;
END IF;
IF trim(NEW.avisa_estoque_neg)::VARCHAR = '''' THEN
   NEW.avisa_estoque_neg := NULL;
END IF;
IF trim(NEW.sac_tipreg)::VARCHAR = '''' THEN
   NEW.sac_tipreg := NULL;
END IF;
IF trim(NEW.impede_alteracao_pedido)::VARCHAR = '''' THEN
   NEW.impede_alteracao_pedido := NULL;
END IF;
IF trim(NEW.fil_dimed)::VARCHAR = '''' THEN
   NEW.fil_dimed := NULL;
END IF;
IF trim(NEW.cod_dimed)::VARCHAR = '''' THEN
   NEW.cod_dimed := NULL;
END IF;
IF trim(NEW.fil_dimper)::VARCHAR = '''' THEN
   NEW.fil_dimper := NULL;
END IF;
IF trim(NEW.cod_dimper)::VARCHAR = '''' THEN
   NEW.cod_dimper := NULL;
END IF;
IF trim(NEW.fil_panarello)::VARCHAR = '''' THEN
   NEW.fil_panarello := NULL;
END IF;
IF trim(NEW.cod_panarello)::VARCHAR = '''' THEN
   NEW.cod_panarello := NULL;
END IF;
IF trim(NEW.fil_santacruz)::VARCHAR = '''' THEN
   NEW.fil_santacruz := NULL;
END IF;
IF trim(NEW.cod_santacruz)::VARCHAR = '''' THEN
   NEW.cod_santacruz := NULL;
END IF;
IF trim(NEW.fil_genesio)::VARCHAR = '''' THEN
   NEW.fil_genesio := NULL;
END IF;
IF trim(NEW.cod_genesio)::VARCHAR = '''' THEN
   NEW.cod_genesio := NULL;
END IF;
IF trim(NEW.fil_profarma)::VARCHAR = '''' THEN
   NEW.fil_profarma := NULL;
END IF;
IF trim(NEW.cod_profarma)::VARCHAR = '''' THEN
   NEW.cod_profarma := NULL;
END IF;
IF trim(NEW.fil_especial)::VARCHAR = '''' THEN
   NEW.fil_especial := NULL;
END IF;
IF trim(NEW.cod_especial)::VARCHAR = '''' THEN
   NEW.cod_especial := NULL;
END IF;
IF trim(NEW.pro_codlpc)::VARCHAR = '''' THEN
   NEW.pro_codlpc := NULL;
END IF;
IF trim(NEW.pro_contro)::VARCHAR = '''' THEN
   NEW.pro_contro := NULL;
END IF;
IF trim(NEW.nome_classificacao)::VARCHAR = '''' THEN
   NEW.nome_classificacao := NULL;
END IF;
IF trim(NEW.ck_fecha_valor_contado)::VARCHAR = '''' THEN
   NEW.ck_fecha_valor_contado := NULL;
END IF;
IF trim(NEW.penaut)::VARCHAR = '''' THEN
   NEW.penaut := NULL;
END IF;
IF trim(NEW.filcmp)::VARCHAR = '''' THEN
   NEW.filcmp := NULL;
END IF;
IF trim(NEW.atuped)::VARCHAR = '''' THEN
   NEW.atuped := NULL;
END IF;
IF trim(NEW.bonus_online)::VARCHAR = '''' THEN
   NEW.bonus_online := NULL;
END IF;
IF trim(NEW.valida_estoque_order)::VARCHAR = '''' THEN
   NEW.valida_estoque_order := NULL;
END IF;
IF trim(NEW.mostra_repasse)::VARCHAR = '''' THEN
   NEW.mostra_repasse := NULL;
END IF;
IF trim(NEW.areceber_passa_ecf)::VARCHAR = '''' THEN
   NEW.areceber_passa_ecf := NULL;
END IF;
IF trim(NEW.logoboleto)::VARCHAR = '''' THEN
   NEW.logoboleto := NULL;
END IF;
IF trim(NEW.enviar_entrega)::VARCHAR = '''' THEN
   NEW.enviar_entrega := NULL;
END IF;
IF trim(NEW.cfop_com_ecf)::VARCHAR = '''' THEN
   NEW.cfop_com_ecf := NULL;
END IF;
IF trim(NEW.obriga_codean)::VARCHAR = '''' THEN
   NEW.obriga_codean := NULL;
END IF;
IF trim(NEW.reutiliza_referencia)::VARCHAR = '''' THEN
   NEW.reutiliza_referencia := NULL;
END IF;
IF trim(NEW.troco_tef)::VARCHAR = '''' THEN
   NEW.troco_tef := NULL;
END IF;
IF trim(NEW.venda_cc_e_outros)::VARCHAR = '''' THEN
   NEW.venda_cc_e_outros := NULL;
END IF;
IF trim(NEW.loja_fechada)::VARCHAR = '''' THEN
   NEW.loja_fechada := NULL;
END IF;
IF trim(NEW.usa_preatendimento)::VARCHAR = '''' THEN
   NEW.usa_preatendimento := NULL;
END IF;
IF trim(NEW.custo_lucro_markup)::VARCHAR = '''' THEN
   NEW.custo_lucro_markup := NULL;
END IF;
IF trim(NEW.altera_preco_orc_separado)::VARCHAR = '''' THEN
   NEW.altera_preco_orc_separado := NULL;
END IF;
IF trim(NEW.filpgt_wor_prop)::VARCHAR = '''' THEN
   NEW.filpgt_wor_prop := NULL;
END IF;
IF trim(NEW.codpgt_wor_prop)::VARCHAR = '''' THEN
   NEW.codpgt_wor_prop := NULL;
END IF;
IF trim(NEW.filpap_diretoria)::VARCHAR = '''' THEN
   NEW.filpap_diretoria := NULL;
END IF;
IF trim(NEW.seqpap_diretoria)::VARCHAR = '''' THEN
   NEW.seqpap_diretoria := NULL;
END IF;
IF trim(NEW.plano_pgt_wor_prop)::VARCHAR = '''' THEN
   NEW.plano_pgt_wor_prop := NULL;
END IF;
IF trim(NEW.despap_diretoria)::VARCHAR = '''' THEN
   NEW.despap_diretoria := NULL;
END IF;
IF trim(NEW.mult_vendedores)::VARCHAR = '''' THEN
   NEW.mult_vendedores := NULL;
END IF;
IF trim(NEW.ckbloqrefbas)::VARCHAR = '''' THEN
   NEW.ckbloqrefbas := NULL;
END IF;
IF trim(NEW.rateio_frete)::VARCHAR = '''' THEN
   NEW.rateio_frete := NULL;
END IF;
IF trim(NEW.path_base)::VARCHAR = '''' THEN
   NEW.path_base := NULL;
END IF;
IF trim(NEW.usa_vm_decisor)::VARCHAR = '''' THEN
   NEW.usa_vm_decisor := NULL;
END IF;
IF trim(NEW.romaneio_filial)::VARCHAR = '''' THEN
   NEW.romaneio_filial := NULL;
END IF;
IF trim(NEW.reserva_ent_fut)::VARCHAR = '''' THEN
   NEW.reserva_ent_fut := NULL;
END IF;
IF trim(NEW.path_ttsegur)::VARCHAR = '''' THEN
   NEW.path_ttsegur := NULL;
END IF;
IF trim(NEW.ckpanumext_nao_dav)::VARCHAR = '''' THEN
   NEW.ckpanumext_nao_dav := NULL;
END IF;
IF trim(NEW.ckpanumext_dep)::VARCHAR = '''' THEN
   NEW.ckpanumext_dep := NULL;
END IF;
IF trim(NEW.bru_aprovada)::VARCHAR = '''' THEN
   NEW.bru_aprovada := NULL;
END IF;
IF trim(NEW.entrega_cf)::VARCHAR = '''' THEN
   NEW.entrega_cf := NULL;
END IF;
IF trim(NEW.dest_st_dev)::VARCHAR = '''' THEN
   NEW.dest_st_dev := NULL;
END IF;
IF trim(NEW.dser_nfcompl)::VARCHAR = '''' THEN
   NEW.dser_nfcompl := NULL;
END IF;
IF trim(NEW.percom_fpv)::VARCHAR = '''' THEN
   NEW.percom_fpv := NULL;
END IF;
IF trim(NEW.blq_sem_uid)::VARCHAR = '''' THEN
   NEW.blq_sem_uid := NULL;
END IF;
IF trim(NEW.st_no_frete)::VARCHAR = '''' THEN
   NEW.st_no_frete := NULL;
END IF;
IF trim(NEW.totallecbase)::VARCHAR = '''' THEN
   NEW.totallecbase := NULL;
END IF;
IF trim(NEW.totallechost)::VARCHAR = '''' THEN
   NEW.totallechost := NULL;
END IF;
IF trim(NEW.totallecport)::VARCHAR = '''' THEN
   NEW.totallecport := NULL;
END IF;
IF trim(NEW.substt_consfi)::VARCHAR = '''' THEN
   NEW.substt_consfi := NULL;
END IF;
IF trim(NEW.ckgradepesavel)::VARCHAR = '''' THEN
   NEW.ckgradepesavel := NULL;
END IF;
IF trim(NEW.dev_fatvin)::VARCHAR = '''' THEN
   NEW.dev_fatvin := NULL;
END IF;
IF trim(NEW.usa_cta_transito_transf_ident)::VARCHAR = '''' THEN
   NEW.usa_cta_transito_transf_ident := NULL;
END IF;
IF trim(NEW.venda_estrangeiro)::VARCHAR = '''' THEN
   NEW.venda_estrangeiro := NULL;
END IF;
IF trim(NEW.ckpavalabe)::VARCHAR = '''' THEN
   NEW.ckpavalabe := NULL;
END IF;
IF trim(NEW.baiped)::VARCHAR = '''' THEN
   NEW.baiped := NULL;
END IF;
IF trim(NEW.separar_entrega)::VARCHAR = '''' THEN
   NEW.separar_entrega := NULL;
END IF;
IF trim(NEW.giro_estoque)::VARCHAR = '''' THEN
   NEW.giro_estoque := NULL;
END IF;
IF trim(NEW.ckpafildav)::VARCHAR = '''' THEN
   NEW.ckpafildav := NULL;
END IF;
IF trim(NEW.filtra_fornec_pedido)::VARCHAR = '''' THEN
   NEW.filtra_fornec_pedido := NULL;
END IF;
IF trim(NEW.ckpaconfere_dav)::VARCHAR = '''' THEN
   NEW.ckpaconfere_dav := NULL;
END IF;
IF trim(NEW.ckpaaut_dev_frete)::VARCHAR = '''' THEN
   NEW.ckpaaut_dev_frete := NULL;
END IF;
IF trim(NEW.transpicm)::VARCHAR = '''' THEN
   NEW.transpicm := NULL;
END IF;
IF trim(NEW.arredondam)::VARCHAR = '''' THEN
   NEW.arredondam := NULL;
END IF;
IF trim(NEW.filcob)::VARCHAR = '''' THEN
   NEW.filcob := NULL;
END IF;
IF trim(NEW.filent)::VARCHAR = '''' THEN
   NEW.filent := NULL;
END IF;
IF trim(NEW.fil_basf)::VARCHAR = '''' THEN
   NEW.fil_basf := NULL;
END IF;
IF trim(NEW.cod_basf)::VARCHAR = '''' THEN
   NEW.cod_basf := NULL;
END IF;
IF trim(NEW.lim_tiptol)::VARCHAR = '''' THEN
   NEW.lim_tiptol := NULL;
END IF;
IF trim(NEW.vdd_ckpavenite)::VARCHAR = '''' THEN
   NEW.vdd_ckpavenite := NULL;
END IF;
IF trim(NEW.vdd_ckpatotven)::VARCHAR = '''' THEN
   NEW.vdd_ckpatotven := NULL;
END IF;
IF trim(NEW.ind_ckpavenite)::VARCHAR = '''' THEN
   NEW.ind_ckpavenite := NULL;
END IF;
IF trim(NEW.ind_ckpatotven)::VARCHAR = '''' THEN
   NEW.ind_ckpatotven := NULL;
END IF;
IF trim(NEW.usa_dcai_0)::VARCHAR = '''' THEN
   NEW.usa_dcai_0 := NULL;
END IF;
IF trim(NEW.valor_aquisicao)::VARCHAR = '''' THEN
   NEW.valor_aquisicao := NULL;
END IF;
IF trim(NEW.blq_cf_retira_deposito)::VARCHAR = '''' THEN
   NEW.blq_cf_retira_deposito := NULL;
END IF;
IF trim(NEW.fpv_preco_simulado)::VARCHAR = '''' THEN
   NEW.fpv_preco_simulado := NULL;
END IF;
IF trim(NEW.clirevsemie)::VARCHAR = '''' THEN
   NEW.clirevsemie := NULL;
END IF;
IF trim(NEW.filmat_tin)::VARCHAR = '''' THEN
   NEW.filmat_tin := NULL;
END IF;
IF trim(NEW.codmat_tin)::VARCHAR = '''' THEN
   NEW.codmat_tin := NULL;
END IF;
IF trim(NEW.tipdia_fluxo)::VARCHAR = '''' THEN
   NEW.tipdia_fluxo := NULL;
END IF;
IF trim(NEW.prazo_ent_pedido)::VARCHAR = '''' THEN
   NEW.prazo_ent_pedido := NULL;
END IF;
IF trim(NEW.parc_pedido)::VARCHAR = '''' THEN
   NEW.parc_pedido := NULL;
END IF;
IF trim(NEW.tipdia_elasticidade)::VARCHAR = '''' THEN
   NEW.tipdia_elasticidade := NULL;
END IF;
IF trim(NEW.devcompranfeimposto)::VARCHAR = '''' THEN
   NEW.devcompranfeimposto := NULL;
END IF;
IF trim(NEW.regra_media_vendas)::VARCHAR = '''' THEN
   NEW.regra_media_vendas := NULL;
END IF;
IF trim(NEW.tipdia_vdu_pp)::VARCHAR = '''' THEN
   NEW.tipdia_vdu_pp := NULL;
END IF;
IF trim(NEW.filmat_aux)::VARCHAR = '''' THEN
   NEW.filmat_aux := NULL;
END IF;
IF trim(NEW.codmat_aux)::VARCHAR = '''' THEN
   NEW.codmat_aux := NULL;
END IF;
IF trim(NEW.ck4g_detver_homol)::VARCHAR = '''' THEN
   NEW.ck4g_detver_homol := NULL;
END IF;
IF trim(NEW.ck4g_detver_produ)::VARCHAR = '''' THEN
   NEW.ck4g_detver_produ := NULL;
END IF;
IF trim(NEW.ck4g_regra_atualizacao)::VARCHAR = '''' THEN
   NEW.ck4g_regra_atualizacao := NULL;
END IF;
IF trim(NEW.sep_fat_retira_deposito)::VARCHAR = '''' THEN
   NEW.sep_fat_retira_deposito := NULL;
END IF;
IF trim(NEW.filmat_rat)::VARCHAR = '''' THEN
   NEW.filmat_rat := NULL;
END IF;
IF trim(NEW.codmat_rat)::VARCHAR = '''' THEN
   NEW.codmat_rat := NULL;
END IF;
IF trim(NEW.prezer)::VARCHAR = '''' THEN
   NEW.prezer := NULL;
END IF;
IF trim(NEW.devfil)::VARCHAR = '''' THEN
   NEW.devfil := NULL;
END IF;
IF trim(NEW.impprevent)::VARCHAR = '''' THEN
   NEW.impprevent := NULL;
END IF;
IF trim(NEW.sersat)::VARCHAR = '''' THEN
   NEW.sersat := NULL;
END IF;
IF trim(NEW.st_pripar)::VARCHAR = '''' THEN
   NEW.st_pripar := NULL;
END IF;
IF trim(NEW.recebe_cc_individual)::VARCHAR = '''' THEN
   NEW.recebe_cc_individual := NULL;
END IF;
IF trim(NEW.dest_st_inffisco)::VARCHAR = '''' THEN
   NEW.dest_st_inffisco := NULL;
END IF;
IF trim(NEW.obrpeso)::VARCHAR = '''' THEN
   NEW.obrpeso := NULL;
END IF;
IF trim(NEW.obrvol)::VARCHAR = '''' THEN
   NEW.obrvol := NULL;
END IF;
IF trim(NEW.dispor)::VARCHAR = '''' THEN
   NEW.dispor := NULL;
END IF;
IF trim(NEW.varcus)::VARCHAR = '''' THEN
   NEW.varcus := NULL;
END IF;
IF trim(NEW.oricre)::VARCHAR = '''' THEN
   NEW.oricre := NULL;
END IF;
IF trim(NEW.descpmord)::VARCHAR = '''' THEN
   NEW.descpmord := NULL;
END IF;
IF trim(NEW.filmat_tra)::VARCHAR = '''' THEN
   NEW.filmat_tra := NULL;
END IF;
IF trim(NEW.codmat_tra)::VARCHAR = '''' THEN
   NEW.codmat_tra := NULL;
END IF;
IF trim(NEW.transfer_sercol)::VARCHAR = '''' THEN
   NEW.transfer_sercol := NULL;
END IF;
IF trim(NEW.ent_filcli)::VARCHAR = '''' THEN
   NEW.ent_filcli := NULL;
END IF;
IF trim(NEW.ent_codcli)::VARCHAR = '''' THEN
   NEW.ent_codcli := NULL;
END IF;
IF trim(NEW.agrupador_itens_distr_est)::VARCHAR = '''' THEN
   NEW.agrupador_itens_distr_est := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_cfg
BEFORE INSERT OR UPDATE ON tw_cfg
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_cfg();



/*-- SEQ 6468 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_cli() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filbco)::VARCHAR = '''' THEN
   NEW.filbco := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.proced)::VARCHAR = '''' THEN
   NEW.proced := NULL;
END IF;
IF trim(NEW.codlog)::VARCHAR = '''' THEN
   NEW.codlog := NULL;
END IF;
IF trim(NEW.codcep)::VARCHAR = '''' THEN
   NEW.codcep := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.insest)::VARCHAR = '''' THEN
   NEW.insest := NULL;
END IF;
IF trim(NEW.ultnom)::VARCHAR = '''' THEN
   NEW.ultnom := NULL;
END IF;
IF trim(NEW.bairro)::VARCHAR = '''' THEN
   NEW.bairro := NULL;
END IF;
IF trim(NEW.intern)::VARCHAR = '''' THEN
   NEW.intern := NULL;
END IF;
IF trim(NEW.loctra)::VARCHAR = '''' THEN
   NEW.loctra := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.e_mail)::VARCHAR = '''' THEN
   NEW.e_mail := NULL;
END IF;
IF trim(NEW.codddd)::VARCHAR = '''' THEN
   NEW.codddd := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.nomcid)::VARCHAR = '''' THEN
   NEW.nomcid := NULL;
END IF;
IF trim(NEW.sigest)::VARCHAR = '''' THEN
   NEW.sigest := NULL;
END IF;
IF trim(NEW.nomcli)::VARCHAR = '''' THEN
   NEW.nomcli := NULL;
END IF;
IF trim(NEW.comple)::VARCHAR = '''' THEN
   NEW.comple := NULL;
END IF;
IF trim(NEW.endere)::VARCHAR = '''' THEN
   NEW.endere := NULL;
END IF;
IF trim(NEW.conjug)::VARCHAR = '''' THEN
   NEW.conjug := NULL;
END IF;
IF trim(NEW.numero)::VARCHAR = '''' THEN
   NEW.numero := NULL;
END IF;
IF trim(NEW.obsout)::VARCHAR = '''' THEN
   NEW.obsout := NULL;
END IF;
IF trim(NEW.numfon)::VARCHAR = '''' THEN
   NEW.numfon := NULL;
END IF;
IF trim(NEW.numfax)::VARCHAR = '''' THEN
   NEW.numfax := NULL;
END IF;
IF trim(NEW.tipdoc)::VARCHAR = '''' THEN
   NEW.tipdoc := NULL;
END IF;
IF trim(NEW.id_org)::VARCHAR = '''' THEN
   NEW.id_org := NULL;
END IF;
IF trim(NEW.id_est)::VARCHAR = '''' THEN
   NEW.id_est := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.estran)::VARCHAR = '''' THEN
   NEW.estran := NULL;
END IF;
IF trim(NEW.isento)::VARCHAR = '''' THEN
   NEW.isento := NULL;
END IF;
IF trim(NEW.dddcel)::VARCHAR = '''' THEN
   NEW.dddcel := NULL;
END IF;
IF trim(NEW.numcel)::VARCHAR = '''' THEN
   NEW.numcel := NULL;
END IF;
IF trim(NEW.filend)::VARCHAR = '''' THEN
   NEW.filend := NULL;
END IF;
IF trim(NEW.fil_ck_cli)::VARCHAR = '''' THEN
   NEW.fil_ck_cli := NULL;
END IF;
IF trim(NEW.ecf_ck_cli)::VARCHAR = '''' THEN
   NEW.ecf_ck_cli := NULL;
END IF;
IF trim(NEW.fil_ck_end)::VARCHAR = '''' THEN
   NEW.fil_ck_end := NULL;
END IF;
IF trim(NEW.ecf_ck_end)::VARCHAR = '''' THEN
   NEW.ecf_ck_end := NULL;
END IF;
IF trim(NEW.nomrec)::VARCHAR = '''' THEN
   NEW.nomrec := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_cli
BEFORE INSERT OR UPDATE ON tw_cli
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_cli();



/*-- SEQ 6469 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_com_fis() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.tippar)::VARCHAR = '''' THEN
   NEW.tippar := NULL;
END IF;
IF trim(NEW.tipnot)::VARCHAR = '''' THEN
   NEW.tipnot := NULL;
END IF;
IF trim(NEW.intpmu)::VARCHAR = '''' THEN
   NEW.intpmu := NULL;
END IF;
IF trim(NEW.intpju)::VARCHAR = '''' THEN
   NEW.intpju := NULL;
END IF;
IF trim(NEW.incoju)::VARCHAR = '''' THEN
   NEW.incoju := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.filfor)::VARCHAR = '''' THEN
   NEW.filfor := NULL;
END IF;
IF trim(NEW.numnot)::VARCHAR = '''' THEN
   NEW.numnot := NULL;
END IF;
IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.notesp)::VARCHAR = '''' THEN
   NEW.notesp := NULL;
END IF;
IF trim(NEW.seqcan)::VARCHAR = '''' THEN
   NEW.seqcan := NULL;
END IF;
IF trim(NEW.seqfre)::VARCHAR = '''' THEN
   NEW.seqfre := NULL;
END IF;
IF trim(NEW.subser)::VARCHAR = '''' THEN
   NEW.subser := NULL;
END IF;
IF trim(NEW.seqfat)::VARCHAR = '''' THEN
   NEW.seqfat := NULL;
END IF;
IF trim(NEW.conpgt)::VARCHAR = '''' THEN
   NEW.conpgt := NULL;
END IF;
IF trim(NEW.nature)::VARCHAR = '''' THEN
   NEW.nature := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.espdoc)::VARCHAR = '''' THEN
   NEW.espdoc := NULL;
END IF;
IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.ufnota)::VARCHAR = '''' THEN
   NEW.ufnota := NULL;
END IF;
IF trim(NEW.filend)::VARCHAR = '''' THEN
   NEW.filend := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.insest)::VARCHAR = '''' THEN
   NEW.insest := NULL;
END IF;
IF trim(NEW.tipemp)::VARCHAR = '''' THEN
   NEW.tipemp := NULL;
END IF;
IF trim(NEW.poremp)::VARCHAR = '''' THEN
   NEW.poremp := NULL;
END IF;
IF trim(NEW.modnot)::VARCHAR = '''' THEN
   NEW.modnot := NULL;
END IF;
IF trim(NEW.filfre)::VARCHAR = '''' THEN
   NEW.filfre := NULL;
END IF;
IF trim(NEW.chavea)::VARCHAR = '''' THEN
   NEW.chavea := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_com_fis
BEFORE INSERT OR UPDATE ON tw_com_fis
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_com_fis();



/*-- SEQ 6470 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_croxdat() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_croxdat
BEFORE INSERT OR UPDATE ON tw_croxdat
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_croxdat();



/*-- SEQ 6471 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_croxwor() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.proces)::VARCHAR = '''' THEN
   NEW.proces := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_croxwor
BEFORE INSERT OR UPDATE ON tw_croxwor
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_croxwor();



/*-- SEQ 6472 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_cta() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.chv_id)::VARCHAR = '''' THEN
   NEW.chv_id := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.titcta)::VARCHAR = '''' THEN
   NEW.titcta := NULL;
END IF;
IF trim(NEW.arvore)::VARCHAR = '''' THEN
   NEW.arvore := NULL;
END IF;
IF trim(NEW.chvpai)::VARCHAR = '''' THEN
   NEW.chvpai := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_cta
BEFORE INSERT OR UPDATE ON tw_cta
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_cta();



/*-- SEQ 6473 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_dom() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codarq)::VARCHAR = '''' THEN
   NEW.codarq := NULL;
END IF;
IF trim(NEW.nomcpo)::VARCHAR = '''' THEN
   NEW.nomcpo := NULL;
END IF;
IF trim(NEW.desdom)::VARCHAR = '''' THEN
   NEW.desdom := NULL;
END IF;
IF trim(NEW.estrel)::VARCHAR = '''' THEN
   NEW.estrel := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_dom
BEFORE INSERT OR UPDATE ON tw_dom
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_dom();



/*-- SEQ 6474 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_ecf() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.totali)::VARCHAR = '''' THEN
   NEW.totali := NULL;
END IF;
IF trim(NEW.numser)::VARCHAR = '''' THEN
   NEW.numser := NULL;
END IF;
IF trim(NEW.tiptot)::VARCHAR = '''' THEN
   NEW.tiptot := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_ecf
BEFORE INSERT OR UPDATE ON tw_ecf
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_ecf();



/*-- SEQ 6475 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_ect() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.chv_id)::VARCHAR = '''' THEN
   NEW.chv_id := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.titcta)::VARCHAR = '''' THEN
   NEW.titcta := NULL;
END IF;
IF trim(NEW.chvpai)::VARCHAR = '''' THEN
   NEW.chvpai := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_ect
BEFORE INSERT OR UPDATE ON tw_ect
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_ect();



/*-- SEQ 6476 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_ext() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.apeusu)::VARCHAR = '''' THEN
   NEW.apeusu := NULL;
END IF;
IF trim(NEW.filrec)::VARCHAR = '''' THEN
   NEW.filrec := NULL;
END IF;
IF trim(NEW.docume)::VARCHAR = '''' THEN
   NEW.docume := NULL;
END IF;
IF trim(NEW.histor)::VARCHAR = '''' THEN
   NEW.histor := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.nomcli)::VARCHAR = '''' THEN
   NEW.nomcli := NULL;
END IF;
IF trim(NEW.ultnom)::VARCHAR = '''' THEN
   NEW.ultnom := NULL;
END IF;
IF trim(NEW.tabori)::VARCHAR = '''' THEN
   NEW.tabori := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.obsint)::VARCHAR = '''' THEN
   NEW.obsint := NULL;
END IF;
IF trim(NEW.fillan)::VARCHAR = '''' THEN
   NEW.fillan := NULL;
END IF;
IF trim(NEW.seqlan)::VARCHAR = '''' THEN
   NEW.seqlan := NULL;
END IF;
IF trim(NEW.parlan)::VARCHAR = '''' THEN
   NEW.parlan := NULL;
END IF;
IF trim(NEW.sublan)::VARCHAR = '''' THEN
   NEW.sublan := NULL;
END IF;
IF trim(NEW.titcrt)::VARCHAR = '''' THEN
   NEW.titcrt := NULL;
END IF;
IF trim(NEW.nomori)::VARCHAR = '''' THEN
   NEW.nomori := NULL;
END IF;
IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.titcta)::VARCHAR = '''' THEN
   NEW.titcta := NULL;
END IF;
IF trim(NEW.estorn)::VARCHAR = '''' THEN
   NEW.estorn := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_ext
BEFORE INSERT OR UPDATE ON tw_ext
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_ext();



/*-- SEQ 6477 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_extxdoc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.origem)::VARCHAR = '''' THEN
   NEW.origem := NULL;
END IF;
IF trim(NEW.filori)::VARCHAR = '''' THEN
   NEW.filori := NULL;
END IF;
IF trim(NEW.seqori)::VARCHAR = '''' THEN
   NEW.seqori := NULL;
END IF;
IF trim(NEW.status)::VARCHAR = '''' THEN
   NEW.status := NULL;
END IF;
IF trim(NEW.parori)::VARCHAR = '''' THEN
   NEW.parori := NULL;
END IF;
IF trim(NEW.subori)::VARCHAR = '''' THEN
   NEW.subori := NULL;
END IF;
IF trim(NEW.destino)::VARCHAR = '''' THEN
   NEW.destino := NULL;
END IF;
IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.filref)::VARCHAR = '''' THEN
   NEW.filref := NULL;
END IF;
IF trim(NEW.seqref)::VARCHAR = '''' THEN
   NEW.seqref := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_extxdoc
BEFORE INSERT OR UPDATE ON tw_extxdoc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_extxdoc();



/*-- SEQ 6478 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_fin() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.flgflx)::VARCHAR = '''' THEN
   NEW.flgflx := NULL;
END IF;
IF trim(NEW.fillan)::VARCHAR = '''' THEN
   NEW.fillan := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_fin
BEFORE INSERT OR UPDATE ON tw_fin
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_fin();



/*-- SEQ 6479 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_fis_75() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.codigo)::VARCHAR = '''' THEN
   NEW.codigo := NULL;
END IF;
IF trim(NEW.unidad)::VARCHAR = '''' THEN
   NEW.unidad := NULL;
END IF;
IF trim(NEW.sittri)::VARCHAR = '''' THEN
   NEW.sittri := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_fis_75
BEFORE INSERT OR UPDATE ON tw_fis_75
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_fis_75();



/*-- SEQ 6480 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_flu() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.numpar)::VARCHAR = '''' THEN
   NEW.numpar := NULL;
END IF;
IF trim(NEW.subpar)::VARCHAR = '''' THEN
   NEW.subpar := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.tabori)::VARCHAR = '''' THEN
   NEW.tabori := NULL;
END IF;
IF trim(NEW.docume)::VARCHAR = '''' THEN
   NEW.docume := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.status)::VARCHAR = '''' THEN
   NEW.status := NULL;
END IF;
IF trim(NEW.tiplan)::VARCHAR = '''' THEN
   NEW.tiplan := NULL;
END IF;
IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.seqori)::VARCHAR = '''' THEN
   NEW.seqori := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.gravar)::VARCHAR = '''' THEN
   NEW.gravar := NULL;
END IF;
IF trim(NEW.filpgt)::VARCHAR = '''' THEN
   NEW.filpgt := NULL;
END IF;
IF trim(NEW.codpgt)::VARCHAR = '''' THEN
   NEW.codpgt := NULL;
END IF;
IF trim(NEW.filmar)::VARCHAR = '''' THEN
   NEW.filmar := NULL;
END IF;
IF trim(NEW.codmar)::VARCHAR = '''' THEN
   NEW.codmar := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_flu
BEFORE INSERT OR UPDATE ON tw_flu
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_flu();



/*-- SEQ 6481 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_fpv() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.subser)::VARCHAR = '''' THEN
   NEW.subser := NULL;
END IF;
IF trim(NEW.numnot)::VARCHAR = '''' THEN
   NEW.numnot := NULL;
END IF;
IF trim(NEW.filfor)::VARCHAR = '''' THEN
   NEW.filfor := NULL;
END IF;
IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;
IF trim(NEW.alterado)::VARCHAR = '''' THEN
   NEW.alterado := NULL;
END IF;
IF trim(NEW.nomcli)::VARCHAR = '''' THEN
   NEW.nomcli := NULL;
END IF;
IF trim(NEW.ultnom)::VARCHAR = '''' THEN
   NEW.ultnom := NULL;
END IF;
IF trim(NEW.refpro)::VARCHAR = '''' THEN
   NEW.refpro := NULL;
END IF;
IF trim(NEW.docume)::VARCHAR = '''' THEN
   NEW.docume := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.desmat)::VARCHAR = '''' THEN
   NEW.desmat := NULL;
END IF;
IF trim(NEW.espmat)::VARCHAR = '''' THEN
   NEW.espmat := NULL;
END IF;
IF trim(NEW.itediv)::VARCHAR = '''' THEN
   NEW.itediv := NULL;
END IF;
IF trim(NEW.itesub)::VARCHAR = '''' THEN
   NEW.itesub := NULL;
END IF;
IF trim(NEW.acasug)::VARCHAR = '''' THEN
   NEW.acasug := NULL;
END IF;
IF trim(NEW.prepsi)::VARCHAR = '''' THEN
   NEW.prepsi := NULL;
END IF;
IF trim(NEW.subfed)::VARCHAR = '''' THEN
   NEW.subfed := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_fpv
BEFORE INSERT OR UPDATE ON tw_fpv
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_fpv();



/*-- SEQ 6482 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_fun() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.tiplan)::VARCHAR = '''' THEN
   NEW.tiplan := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.codfun)::VARCHAR = '''' THEN
   NEW.codfun := NULL;
END IF;
IF trim(NEW.desfun)::VARCHAR = '''' THEN
   NEW.desfun := NULL;
END IF;
IF trim(NEW.msgreq)::VARCHAR = '''' THEN
   NEW.msgreq := NULL;
END IF;
IF trim(NEW.docume)::VARCHAR = '''' THEN
   NEW.docume := NULL;
END IF;
IF trim(NEW.versao)::VARCHAR = '''' THEN
   NEW.versao := NULL;
END IF;
IF trim(NEW.filres)::VARCHAR = '''' THEN
   NEW.filres := NULL;
END IF;
IF trim(NEW.codres)::VARCHAR = '''' THEN
   NEW.codres := NULL;
END IF;
IF trim(NEW.filtst)::VARCHAR = '''' THEN
   NEW.filtst := NULL;
END IF;
IF trim(NEW.codtst)::VARCHAR = '''' THEN
   NEW.codtst := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_fun
BEFORE INSERT OR UPDATE ON tw_fun
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_fun();



/*-- SEQ 6483 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_fxc() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_fxc
BEFORE INSERT OR UPDATE ON tw_fxc
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_fxc();



/*-- SEQ 6484 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_gru() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codtab)::VARCHAR = '''' THEN
   NEW.codtab := NULL;
END IF;
IF trim(NEW.codgru)::VARCHAR = '''' THEN
   NEW.codgru := NULL;
END IF;
IF trim(NEW.desgru)::VARCHAR = '''' THEN
   NEW.desgru := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_gru
BEFORE INSERT OR UPDATE ON tw_gru
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_gru();



/*-- SEQ 6485 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_icm() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.sigest)::VARCHAR = '''' THEN
   NEW.sigest := NULL;
END IF;
IF trim(NEW.codcid)::VARCHAR = '''' THEN
   NEW.codcid := NULL;
END IF;
IF trim(NEW.nomcid)::VARCHAR = '''' THEN
   NEW.nomcid := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_icm
BEFORE INSERT OR UPDATE ON tw_icm
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_icm();



/*-- SEQ 6486 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_ico_fis() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.tippro)::VARCHAR = '''' THEN
   NEW.tippro := NULL;
END IF;
IF trim(NEW.sitmov)::VARCHAR = '''' THEN
   NEW.sitmov := NULL;
END IF;
IF trim(NEW.lanest)::VARCHAR = '''' THEN
   NEW.lanest := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.codbus)::VARCHAR = '''' THEN
   NEW.codbus := NULL;
END IF;
IF trim(NEW.nature)::VARCHAR = '''' THEN
   NEW.nature := NULL;
END IF;
IF trim(NEW.icmtip)::VARCHAR = '''' THEN
   NEW.icmtip := NULL;
END IF;
IF trim(NEW.modnot)::VARCHAR = '''' THEN
   NEW.modnot := NULL;
END IF;
IF trim(NEW.retsub)::VARCHAR = '''' THEN
   NEW.retsub := NULL;
END IF;
IF trim(NEW.codcst)::VARCHAR = '''' THEN
   NEW.codcst := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_ico_fis
BEFORE INSERT OR UPDATE ON tw_ico_fis
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_ico_fis();



/*-- SEQ 6487 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_iin() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.refpro)::VARCHAR = '''' THEN
   NEW.refpro := NULL;
END IF;
IF trim(NEW.refgra)::VARCHAR = '''' THEN
   NEW.refgra := NULL;
END IF;
IF trim(NEW.zeresq)::VARCHAR = '''' THEN
   NEW.zeresq := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_iin
BEFORE INSERT OR UPDATE ON tw_iin
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_iin();



/*-- SEQ 6488 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_inv_fis() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.tem_precom)::VARCHAR = '''' THEN
   NEW.tem_precom := NULL;
END IF;
IF trim(NEW.tem_cusrep)::VARCHAR = '''' THEN
   NEW.tem_cusrep := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_inv_fis
BEFORE INSERT OR UPDATE ON tw_inv_fis
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_inv_fis();



/*-- SEQ 6489 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_inv_fis_ico_sub() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filfor)::VARCHAR = '''' THEN
   NEW.filfor := NULL;
END IF;
IF trim(NEW.codfor)::VARCHAR = '''' THEN
   NEW.codfor := NULL;
END IF;
IF trim(NEW.filend)::VARCHAR = '''' THEN
   NEW.filend := NULL;
END IF;
IF trim(NEW.modnot)::VARCHAR = '''' THEN
   NEW.modnot := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.subser)::VARCHAR = '''' THEN
   NEW.subser := NULL;
END IF;
IF trim(NEW.numnot)::VARCHAR = '''' THEN
   NEW.numnot := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.tippro)::VARCHAR = '''' THEN
   NEW.tippro := NULL;
END IF;
IF trim(NEW.icmtip)::VARCHAR = '''' THEN
   NEW.icmtip := NULL;
END IF;
IF trim(NEW.retsub)::VARCHAR = '''' THEN
   NEW.retsub := NULL;
END IF;
IF trim(NEW.nature)::VARCHAR = '''' THEN
   NEW.nature := NULL;
END IF;
IF trim(NEW.codcst)::VARCHAR = '''' THEN
   NEW.codcst := NULL;
END IF;
IF trim(NEW.chavea)::VARCHAR = '''' THEN
   NEW.chavea := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_inv_fis_ico_sub
BEFORE INSERT OR UPDATE ON tw_inv_fis_ico_sub
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_inv_fis_ico_sub();



/*-- SEQ 6490 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_inv_fis_pro_sub() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_inv_fis_pro_sub
BEFORE INSERT OR UPDATE ON tw_inv_fis_pro_sub
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_inv_fis_pro_sub();



/*-- SEQ 6491 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_ive() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.lanest)::VARCHAR = '''' THEN
   NEW.lanest := NULL;
END IF;
IF trim(NEW.tipori)::VARCHAR = '''' THEN
   NEW.tipori := NULL;
END IF;
IF trim(NEW.tippro)::VARCHAR = '''' THEN
   NEW.tippro := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.numori)::VARCHAR = '''' THEN
   NEW.numori := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.numext)::VARCHAR = '''' THEN
   NEW.numext := NULL;
END IF;
IF trim(NEW.icmtip)::VARCHAR = '''' THEN
   NEW.icmtip := NULL;
END IF;
IF trim(NEW.sitkit)::VARCHAR = '''' THEN
   NEW.sitkit := NULL;
END IF;
IF trim(NEW.sitmov)::VARCHAR = '''' THEN
   NEW.sitmov := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_ive
BEFORE INSERT OR UPDATE ON tw_ive
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_ive();



/*-- SEQ 6492 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_ive_fis() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.tippro)::VARCHAR = '''' THEN
   NEW.tippro := NULL;
END IF;
IF trim(NEW.lanest)::VARCHAR = '''' THEN
   NEW.lanest := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.sitkit)::VARCHAR = '''' THEN
   NEW.sitkit := NULL;
END IF;
IF trim(NEW.sitmov)::VARCHAR = '''' THEN
   NEW.sitmov := NULL;
END IF;
IF trim(NEW.numori)::VARCHAR = '''' THEN
   NEW.numori := NULL;
END IF;
IF trim(NEW.dummy)::VARCHAR = '''' THEN
   NEW.dummy := NULL;
END IF;
IF trim(NEW.icmtip)::VARCHAR = '''' THEN
   NEW.icmtip := NULL;
END IF;
IF trim(NEW.numext)::VARCHAR = '''' THEN
   NEW.numext := NULL;
END IF;
IF trim(NEW.tip001)::VARCHAR = '''' THEN
   NEW.tip001 := NULL;
END IF;
IF trim(NEW.vincul)::VARCHAR = '''' THEN
   NEW.vincul := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;
IF trim(NEW.natfis)::VARCHAR = '''' THEN
   NEW.natfis := NULL;
END IF;
IF trim(NEW.calsub)::VARCHAR = '''' THEN
   NEW.calsub := NULL;
END IF;
IF trim(NEW.codcst)::VARCHAR = '''' THEN
   NEW.codcst := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_ive_fis
BEFORE INSERT OR UPDATE ON tw_ive_fis
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_ive_fis();



/*-- SEQ 6493 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_ivexior() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filive)::VARCHAR = '''' THEN
   NEW.filive := NULL;
END IF;
IF trim(NEW.seqive)::VARCHAR = '''' THEN
   NEW.seqive := NULL;
END IF;
IF trim(NEW.vencoo)::VARCHAR = '''' THEN
   NEW.vencoo := NULL;
END IF;
IF trim(NEW.venecf)::VARCHAR = '''' THEN
   NEW.venecf := NULL;
END IF;
IF trim(NEW.filori)::VARCHAR = '''' THEN
   NEW.filori := NULL;
END IF;
IF trim(NEW.tipori)::VARCHAR = '''' THEN
   NEW.tipori := NULL;
END IF;
IF trim(NEW.numori)::VARCHAR = '''' THEN
   NEW.numori := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_ivexior
BEFORE INSERT OR UPDATE ON tw_ivexior
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_ivexior();



/*-- SEQ 6494 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_key() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.seqkey)::VARCHAR = '''' THEN
   NEW.seqkey := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_key
BEFORE INSERT OR UPDATE ON tw_key
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_key();



/*-- SEQ 6495 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_lay() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codtab)::VARCHAR = '''' THEN
   NEW.codtab := NULL;
END IF;
IF trim(NEW.codgru)::VARCHAR = '''' THEN
   NEW.codgru := NULL;
END IF;
IF trim(NEW.arqlis)::VARCHAR = '''' THEN
   NEW.arqlis := NULL;
END IF;
IF trim(NEW.clafil)::VARCHAR = '''' THEN
   NEW.clafil := NULL;
END IF;
IF trim(NEW.codlis)::VARCHAR = '''' THEN
   NEW.codlis := NULL;
END IF;
IF trim(NEW.descpo)::VARCHAR = '''' THEN
   NEW.descpo := NULL;
END IF;
IF trim(NEW.deslis)::VARCHAR = '''' THEN
   NEW.deslis := NULL;
END IF;
IF trim(NEW.expres)::VARCHAR = '''' THEN
   NEW.expres := NULL;
END IF;
IF trim(NEW.netdat)::VARCHAR = '''' THEN
   NEW.netdat := NULL;
END IF;
IF trim(NEW.nomcpo)::VARCHAR = '''' THEN
   NEW.nomcpo := NULL;
END IF;
IF trim(NEW.nomusu)::VARCHAR = '''' THEN
   NEW.nomusu := NULL;
END IF;
IF trim(NEW.origem)::VARCHAR = '''' THEN
   NEW.origem := NULL;
END IF;
IF trim(NEW.oujoin)::VARCHAR = '''' THEN
   NEW.oujoin := NULL;
END IF;
IF trim(NEW.tipcpo)::VARCHAR = '''' THEN
   NEW.tipcpo := NULL;
END IF;
IF trim(NEW.tipdad)::VARCHAR = '''' THEN
   NEW.tipdad := NULL;
END IF;
IF trim(NEW.tipfil)::VARCHAR = '''' THEN
   NEW.tipfil := NULL;
END IF;
IF trim(NEW.totalizado)::VARCHAR = '''' THEN
   NEW.totalizado := NULL;
END IF;
IF trim(NEW.usocpo)::VARCHAR = '''' THEN
   NEW.usocpo := NULL;
END IF;
IF trim(NEW.velho)::VARCHAR = '''' THEN
   NEW.velho := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_lay
BEFORE INSERT OR UPDATE ON tw_lay
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_lay();



/*-- SEQ 6496 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_mov() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.sitmov)::VARCHAR = '''' THEN
   NEW.sitmov := NULL;
END IF;
IF trim(NEW.tipmov)::VARCHAR = '''' THEN
   NEW.tipmov := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.docume)::VARCHAR = '''' THEN
   NEW.docume := NULL;
END IF;
IF trim(NEW.numext)::VARCHAR = '''' THEN
   NEW.numext := NULL;
END IF;
IF trim(NEW.nature)::VARCHAR = '''' THEN
   NEW.nature := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_mov
BEFORE INSERT OR UPDATE ON tw_mov
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_mov();



/*-- SEQ 6497 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_play() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codtab)::VARCHAR = '''' THEN
   NEW.codtab := NULL;
END IF;
IF trim(NEW.codgru)::VARCHAR = '''' THEN
   NEW.codgru := NULL;
END IF;
IF trim(NEW.descpo)::VARCHAR = '''' THEN
   NEW.descpo := NULL;
END IF;
IF trim(NEW.nomcpo)::VARCHAR = '''' THEN
   NEW.nomcpo := NULL;
END IF;
IF trim(NEW.nomusu)::VARCHAR = '''' THEN
   NEW.nomusu := NULL;
END IF;
IF trim(NEW.podnul)::VARCHAR = '''' THEN
   NEW.podnul := NULL;
END IF;
IF trim(NEW.tipcpo)::VARCHAR = '''' THEN
   NEW.tipcpo := NULL;
END IF;
IF trim(NEW.tipdad)::VARCHAR = '''' THEN
   NEW.tipdad := NULL;
END IF;
IF trim(NEW.tipfil)::VARCHAR = '''' THEN
   NEW.tipfil := NULL;
END IF;
IF trim(NEW.totali)::VARCHAR = '''' THEN
   NEW.totali := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_play
BEFORE INSERT OR UPDATE ON tw_play
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_play();



/*-- SEQ 6498 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_pre() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.filpre)::VARCHAR = '''' THEN
   NEW.filpre := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.flgapl)::VARCHAR = '''' THEN
   NEW.flgapl := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_pre
BEFORE INSERT OR UPDATE ON tw_pre
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_pre();



/*-- SEQ 6499 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_prj() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_prj
BEFORE INSERT OR UPDATE ON tw_prj
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_prj();



/*-- SEQ 6500 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_rec() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.numpar)::VARCHAR = '''' THEN
   NEW.numpar := NULL;
END IF;
IF trim(NEW.subpar)::VARCHAR = '''' THEN
   NEW.subpar := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filrec)::VARCHAR = '''' THEN
   NEW.filrec := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.cupfis)::VARCHAR = '''' THEN
   NEW.cupfis := NULL;
END IF;
IF trim(NEW.seqche)::VARCHAR = '''' THEN
   NEW.seqche := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.chvven)::VARCHAR = '''' THEN
   NEW.chvven := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_rec
BEFORE INSERT OR UPDATE ON tw_rec
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_rec();



/*-- SEQ 6501 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_rzr() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.seqant)::VARCHAR = '''' THEN
   NEW.seqant := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_rzr
BEFORE INSERT OR UPDATE ON tw_rzr
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_rzr();



/*-- SEQ 6502 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_sac() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.titulo)::VARCHAR = '''' THEN
   NEW.titulo := NULL;
END IF;
IF trim(NEW.desmsg)::VARCHAR = '''' THEN
   NEW.desmsg := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_sac
BEFORE INSERT OR UPDATE ON tw_sac
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_sac();



/*-- SEQ 6503 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_sal() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_sal
BEFORE INSERT OR UPDATE ON tw_sal
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_sal();



/*-- SEQ 6504 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_sql() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.coddes)::VARCHAR = '''' THEN
   NEW.coddes := NULL;
END IF;
IF trim(NEW.codori)::VARCHAR = '''' THEN
   NEW.codori := NULL;
END IF;
IF trim(NEW.filtro)::VARCHAR = '''' THEN
   NEW.filtro := NULL;
END IF;
IF trim(NEW.propor)::VARCHAR = '''' THEN
   NEW.propor := NULL;
END IF;
IF trim(NEW.reldes)::VARCHAR = '''' THEN
   NEW.reldes := NULL;
END IF;
IF trim(NEW.relnxn)::VARCHAR = '''' THEN
   NEW.relnxn := NULL;
END IF;
IF trim(NEW.relori)::VARCHAR = '''' THEN
   NEW.relori := NULL;
END IF;
IF trim(NEW.rel_on)::VARCHAR = '''' THEN
   NEW.rel_on := NULL;
END IF;
IF trim(NEW.relon_des)::VARCHAR = '''' THEN
   NEW.relon_des := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_sql
BEFORE INSERT OR UPDATE ON tw_sql
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_sql();



/*-- SEQ 6505 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_sup() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_sup
BEFORE INSERT OR UPDATE ON tw_sup
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_sup();



/*-- SEQ 6506 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_tab() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.cobcar)::VARCHAR = '''' THEN
   NEW.cobcar := NULL;
END IF;
IF trim(NEW.cobecf)::VARCHAR = '''' THEN
   NEW.cobecf := NULL;
END IF;
IF trim(NEW.ctrtip)::VARCHAR = '''' THEN
   NEW.ctrtip := NULL;
END IF;
IF trim(NEW.flgflx)::VARCHAR = '''' THEN
   NEW.flgflx := NULL;
END IF;
IF trim(NEW.lanven)::VARCHAR = '''' THEN
   NEW.lanven := NULL;
END IF;
IF trim(NEW.sepdec)::VARCHAR = '''' THEN
   NEW.sepdec := NULL;
END IF;
IF trim(NEW.sinlan)::VARCHAR = '''' THEN
   NEW.sinlan := NULL;
END IF;
IF trim(NEW.tipadm)::VARCHAR = '''' THEN
   NEW.tipadm := NULL;
END IF;
IF trim(NEW.tipcar)::VARCHAR = '''' THEN
   NEW.tipcar := NULL;
END IF;
IF trim(NEW.tipccb)::VARCHAR = '''' THEN
   NEW.tipccb := NULL;
END IF;
IF trim(NEW.tipcob)::VARCHAR = '''' THEN
   NEW.tipcob := NULL;
END IF;
IF trim(NEW.tipcta)::VARCHAR = '''' THEN
   NEW.tipcta := NULL;
END IF;
IF trim(NEW.tipnat)::VARCHAR = '''' THEN
   NEW.tipnat := NULL;
END IF;
IF trim(NEW.usostd)::VARCHAR = '''' THEN
   NEW.usostd := NULL;
END IF;
IF trim(NEW.codhom)::VARCHAR = '''' THEN
   NEW.codhom := NULL;
END IF;
IF trim(NEW.codlib)::VARCHAR = '''' THEN
   NEW.codlib := NULL;
END IF;
IF trim(NEW.codori)::VARCHAR = '''' THEN
   NEW.codori := NULL;
END IF;
IF trim(NEW.codsac)::VARCHAR = '''' THEN
   NEW.codsac := NULL;
END IF;
IF trim(NEW.codwor)::VARCHAR = '''' THEN
   NEW.codwor := NULL;
END IF;
IF trim(NEW.ctrfil)::VARCHAR = '''' THEN
   NEW.ctrfil := NULL;
END IF;
IF trim(NEW.eanfil)::VARCHAR = '''' THEN
   NEW.eanfil := NULL;
END IF;
IF trim(NEW.filadm)::VARCHAR = '''' THEN
   NEW.filadm := NULL;
END IF;
IF trim(NEW.filcar)::VARCHAR = '''' THEN
   NEW.filcar := NULL;
END IF;
IF trim(NEW.filccc)::VARCHAR = '''' THEN
   NEW.filccc := NULL;
END IF;
IF trim(NEW.filcta)::VARCHAR = '''' THEN
   NEW.filcta := NULL;
END IF;
IF trim(NEW.filecf)::VARCHAR = '''' THEN
   NEW.filecf := NULL;
END IF;
IF trim(NEW.filmat)::VARCHAR = '''' THEN
   NEW.filmat := NULL;
END IF;
IF trim(NEW.filsac)::VARCHAR = '''' THEN
   NEW.filsac := NULL;
END IF;
IF trim(NEW.filwor)::VARCHAR = '''' THEN
   NEW.filwor := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.codmat)::VARCHAR = '''' THEN
   NEW.codmat := NULL;
END IF;
IF trim(NEW.codadm)::VARCHAR = '''' THEN
   NEW.codadm := NULL;
END IF;
IF trim(NEW.eancod)::VARCHAR = '''' THEN
   NEW.eancod := NULL;
END IF;
IF trim(NEW.serfim)::VARCHAR = '''' THEN
   NEW.serfim := NULL;
END IF;
IF trim(NEW.serini)::VARCHAR = '''' THEN
   NEW.serini := NULL;
END IF;
IF trim(NEW.placas)::VARCHAR = '''' THEN
   NEW.placas := NULL;
END IF;
IF trim(NEW.ctrseq)::VARCHAR = '''' THEN
   NEW.ctrseq := NULL;
END IF;
IF trim(NEW.seqcar)::VARCHAR = '''' THEN
   NEW.seqcar := NULL;
END IF;
IF trim(NEW.seqcta)::VARCHAR = '''' THEN
   NEW.seqcta := NULL;
END IF;
IF trim(NEW.aliint)::VARCHAR = '''' THEN
   NEW.aliint := NULL;
END IF;
IF trim(NEW.ampati)::VARCHAR = '''' THEN
   NEW.ampati := NULL;
END IF;
IF trim(NEW.atihom)::VARCHAR = '''' THEN
   NEW.atihom := NULL;
END IF;
IF trim(NEW.bcoati)::VARCHAR = '''' THEN
   NEW.bcoati := NULL;
END IF;
IF trim(NEW.carati)::VARCHAR = '''' THEN
   NEW.carati := NULL;
END IF;
IF trim(NEW.ccbati)::VARCHAR = '''' THEN
   NEW.ccbati := NULL;
END IF;
IF trim(NEW.cccati)::VARCHAR = '''' THEN
   NEW.cccati := NULL;
END IF;
IF trim(NEW.cl1ati)::VARCHAR = '''' THEN
   NEW.cl1ati := NULL;
END IF;
IF trim(NEW.cl2ati)::VARCHAR = '''' THEN
   NEW.cl2ati := NULL;
END IF;
IF trim(NEW.cl3ati)::VARCHAR = '''' THEN
   NEW.cl3ati := NULL;
END IF;
IF trim(NEW.cl4ati)::VARCHAR = '''' THEN
   NEW.cl4ati := NULL;
END IF;
IF trim(NEW.cliliv)::VARCHAR = '''' THEN
   NEW.cliliv := NULL;
END IF;
IF trim(NEW.cltatv)::VARCHAR = '''' THEN
   NEW.cltatv := NULL;
END IF;
IF trim(NEW.cncati)::VARCHAR = '''' THEN
   NEW.cncati := NULL;
END IF;
IF trim(NEW.cobati)::VARCHAR = '''' THEN
   NEW.cobati := NULL;
END IF;
IF trim(NEW.colati)::VARCHAR = '''' THEN
   NEW.colati := NULL;
END IF;
IF trim(NEW.comati)::VARCHAR = '''' THEN
   NEW.comati := NULL;
END IF;
IF trim(NEW.comccc)::VARCHAR = '''' THEN
   NEW.comccc := NULL;
END IF;
IF trim(NEW.corati)::VARCHAR = '''' THEN
   NEW.corati := NULL;
END IF;
IF trim(NEW.ct1ati)::VARCHAR = '''' THEN
   NEW.ct1ati := NULL;
END IF;
IF trim(NEW.ct2ati)::VARCHAR = '''' THEN
   NEW.ct2ati := NULL;
END IF;
IF trim(NEW.ct3ati)::VARCHAR = '''' THEN
   NEW.ct3ati := NULL;
END IF;
IF trim(NEW.ctrati)::VARCHAR = '''' THEN
   NEW.ctrati := NULL;
END IF;
IF trim(NEW.cusati)::VARCHAR = '''' THEN
   NEW.cusati := NULL;
END IF;
IF trim(NEW.cx_ati)::VARCHAR = '''' THEN
   NEW.cx_ati := NULL;
END IF;
IF trim(NEW.cx_his)::VARCHAR = '''' THEN
   NEW.cx_his := NULL;
END IF;
IF trim(NEW.dadrec)::VARCHAR = '''' THEN
   NEW.dadrec := NULL;
END IF;
IF trim(NEW.depati)::VARCHAR = '''' THEN
   NEW.depati := NULL;
END IF;
IF trim(NEW.desatv)::VARCHAR = '''' THEN
   NEW.desatv := NULL;
END IF;
IF trim(NEW.divati)::VARCHAR = '''' THEN
   NEW.divati := NULL;
END IF;
IF trim(NEW.divtro)::VARCHAR = '''' THEN
   NEW.divtro := NULL;
END IF;
IF trim(NEW.docatv)::VARCHAR = '''' THEN
   NEW.docatv := NULL;
END IF;
IF trim(NEW.dopati)::VARCHAR = '''' THEN
   NEW.dopati := NULL;
END IF;
IF trim(NEW.eanati)::VARCHAR = '''' THEN
   NEW.eanati := NULL;
END IF;
IF trim(NEW.ecbati)::VARCHAR = '''' THEN
   NEW.ecbati := NULL;
END IF;
IF trim(NEW.ecfati)::VARCHAR = '''' THEN
   NEW.ecfati := NULL;
END IF;
IF trim(NEW.espati)::VARCHAR = '''' THEN
   NEW.espati := NULL;
END IF;
IF trim(NEW.estati)::VARCHAR = '''' THEN
   NEW.estati := NULL;
END IF;
IF trim(NEW.es_ati)::VARCHAR = '''' THEN
   NEW.es_ati := NULL;
END IF;
IF trim(NEW.etiati)::VARCHAR = '''' THEN
   NEW.etiati := NULL;
END IF;
IF trim(NEW.financ)::VARCHAR = '''' THEN
   NEW.financ := NULL;
END IF;
IF trim(NEW.finati)::VARCHAR = '''' THEN
   NEW.finati := NULL;
END IF;
IF trim(NEW.fisati)::VARCHAR = '''' THEN
   NEW.fisati := NULL;
END IF;
IF trim(NEW.footer)::VARCHAR = '''' THEN
   NEW.footer := NULL;
END IF;
IF trim(NEW.gertit)::VARCHAR = '''' THEN
   NEW.gertit := NULL;
END IF;
IF trim(NEW.graati)::VARCHAR = '''' THEN
   NEW.graati := NULL;
END IF;
IF trim(NEW.gruati)::VARCHAR = '''' THEN
   NEW.gruati := NULL;
END IF;
IF trim(NEW.header)::VARCHAR = '''' THEN
   NEW.header := NULL;
END IF;
IF trim(NEW.icmati)::VARCHAR = '''' THEN
   NEW.icmati := NULL;
END IF;
IF trim(NEW.icmcid)::VARCHAR = '''' THEN
   NEW.icmcid := NULL;
END IF;
IF trim(NEW.impnot)::VARCHAR = '''' THEN
   NEW.impnot := NULL;
END IF;
IF trim(NEW.insati)::VARCHAR = '''' THEN
   NEW.insati := NULL;
END IF;
IF trim(NEW.ipiati)::VARCHAR = '''' THEN
   NEW.ipiati := NULL;
END IF;
IF trim(NEW.irrati)::VARCHAR = '''' THEN
   NEW.irrati := NULL;
END IF;
IF trim(NEW.isoati)::VARCHAR = '''' THEN
   NEW.isoati := NULL;
END IF;
IF trim(NEW.issati)::VARCHAR = '''' THEN
   NEW.issati := NULL;
END IF;
IF trim(NEW.jusati)::VARCHAR = '''' THEN
   NEW.jusati := NULL;
END IF;
IF trim(NEW.lanati)::VARCHAR = '''' THEN
   NEW.lanati := NULL;
END IF;
IF trim(NEW.libati)::VARCHAR = '''' THEN
   NEW.libati := NULL;
END IF;
IF trim(NEW.marati)::VARCHAR = '''' THEN
   NEW.marati := NULL;
END IF;
IF trim(NEW.medati)::VARCHAR = '''' THEN
   NEW.medati := NULL;
END IF;
IF trim(NEW.me_ati)::VARCHAR = '''' THEN
   NEW.me_ati := NULL;
END IF;
IF trim(NEW.modati)::VARCHAR = '''' THEN
   NEW.modati := NULL;
END IF;
IF trim(NEW.moeati)::VARCHAR = '''' THEN
   NEW.moeati := NULL;
END IF;
IF trim(NEW.movest)::VARCHAR = '''' THEN
   NEW.movest := NULL;
END IF;
IF trim(NEW.natati)::VARCHAR = '''' THEN
   NEW.natati := NULL;
END IF;
IF trim(NEW.natoln)::VARCHAR = '''' THEN
   NEW.natoln := NULL;
END IF;
IF trim(NEW.norint)::VARCHAR = '''' THEN
   NEW.norint := NULL;
END IF;
IF trim(NEW.obsati)::VARCHAR = '''' THEN
   NEW.obsati := NULL;
END IF;
IF trim(NEW.outati)::VARCHAR = '''' THEN
   NEW.outati := NULL;
END IF;
IF trim(NEW.phoati)::VARCHAR = '''' THEN
   NEW.phoati := NULL;
END IF;
IF trim(NEW.preati)::VARCHAR = '''' THEN
   NEW.preati := NULL;
END IF;
IF trim(NEW.procar)::VARCHAR = '''' THEN
   NEW.procar := NULL;
END IF;
IF trim(NEW.r1_ati)::VARCHAR = '''' THEN
   NEW.r1_ati := NULL;
END IF;
IF trim(NEW.r2_ati)::VARCHAR = '''' THEN
   NEW.r2_ati := NULL;
END IF;
IF trim(NEW.regati)::VARCHAR = '''' THEN
   NEW.regati := NULL;
END IF;
IF trim(NEW.remati)::VARCHAR = '''' THEN
   NEW.remati := NULL;
END IF;
IF trim(NEW.restri)::VARCHAR = '''' THEN
   NEW.restri := NULL;
END IF;
IF trim(NEW.retati)::VARCHAR = '''' THEN
   NEW.retati := NULL;
END IF;
IF trim(NEW.re_ati)::VARCHAR = '''' THEN
   NEW.re_ati := NULL;
END IF;
IF trim(NEW.rosati)::VARCHAR = '''' THEN
   NEW.rosati := NULL;
END IF;
IF trim(NEW.sazati)::VARCHAR = '''' THEN
   NEW.sazati := NULL;
END IF;
IF trim(NEW.serati)::VARCHAR = '''' THEN
   NEW.serati := NULL;
END IF;
IF trim(NEW.serman)::VARCHAR = '''' THEN
   NEW.serman := NULL;
END IF;
IF trim(NEW.setati)::VARCHAR = '''' THEN
   NEW.setati := NULL;
END IF;
IF trim(NEW.sombas)::VARCHAR = '''' THEN
   NEW.sombas := NULL;
END IF;
IF trim(NEW.stdati)::VARCHAR = '''' THEN
   NEW.stdati := NULL;
END IF;
IF trim(NEW.subati)::VARCHAR = '''' THEN
   NEW.subati := NULL;
END IF;
IF trim(NEW.tccati)::VARCHAR = '''' THEN
   NEW.tccati := NULL;
END IF;
IF trim(NEW.tcdati)::VARCHAR = '''' THEN
   NEW.tcdati := NULL;
END IF;
IF trim(NEW.tefent)::VARCHAR = '''' THEN
   NEW.tefent := NULL;
END IF;
IF trim(NEW.tipati)::VARCHAR = '''' THEN
   NEW.tipati := NULL;
END IF;
IF trim(NEW.tipctb)::VARCHAR = '''' THEN
   NEW.tipctb := NULL;
END IF;
IF trim(NEW.triati)::VARCHAR = '''' THEN
   NEW.triati := NULL;
END IF;
IF trim(NEW.tribut)::VARCHAR = '''' THEN
   NEW.tribut := NULL;
END IF;
IF trim(NEW.usacus)::VARCHAR = '''' THEN
   NEW.usacus := NULL;
END IF;
IF trim(NEW.usaven)::VARCHAR = '''' THEN
   NEW.usaven := NULL;
END IF;
IF trim(NEW.veiati)::VARCHAR = '''' THEN
   NEW.veiati := NULL;
END IF;
IF trim(NEW.vpeati)::VARCHAR = '''' THEN
   NEW.vpeati := NULL;
END IF;
IF trim(NEW.vtpati)::VARCHAR = '''' THEN
   NEW.vtpati := NULL;
END IF;
IF trim(NEW.unimed)::VARCHAR = '''' THEN
   NEW.unimed := NULL;
END IF;
IF trim(NEW.veratu)::VARCHAR = '''' THEN
   NEW.veratu := NULL;
END IF;
IF trim(NEW.desmoe)::VARCHAR = '''' THEN
   NEW.desmoe := NULL;
END IF;
IF trim(NEW.natden)::VARCHAR = '''' THEN
   NEW.natden := NULL;
END IF;
IF trim(NEW.natfor)::VARCHAR = '''' THEN
   NEW.natfor := NULL;
END IF;
IF trim(NEW.natfud)::VARCHAR = '''' THEN
   NEW.natfud := NULL;
END IF;
IF trim(NEW.natfuf)::VARCHAR = '''' THEN
   NEW.natfuf := NULL;
END IF;
IF trim(NEW.abanco)::VARCHAR = '''' THEN
   NEW.abanco := NULL;
END IF;
IF trim(NEW.apeccb)::VARCHAR = '''' THEN
   NEW.apeccb := NULL;
END IF;
IF trim(NEW.desean)::VARCHAR = '''' THEN
   NEW.desean := NULL;
END IF;
IF trim(NEW.extdem)::VARCHAR = '''' THEN
   NEW.extdem := NULL;
END IF;
IF trim(NEW.extfor)::VARCHAR = '''' THEN
   NEW.extfor := NULL;
END IF;
IF trim(NEW.cencus)::VARCHAR = '''' THEN
   NEW.cencus := NULL;
END IF;
IF trim(NEW.class1)::VARCHAR = '''' THEN
   NEW.class1 := NULL;
END IF;
IF trim(NEW.class2)::VARCHAR = '''' THEN
   NEW.class2 := NULL;
END IF;
IF trim(NEW.class3)::VARCHAR = '''' THEN
   NEW.class3 := NULL;
END IF;
IF trim(NEW.class4)::VARCHAR = '''' THEN
   NEW.class4 := NULL;
END IF;
IF trim(NEW.contab)::VARCHAR = '''' THEN
   NEW.contab := NULL;
END IF;
IF trim(NEW.descon)::VARCHAR = '''' THEN
   NEW.descon := NULL;
END IF;
IF trim(NEW.desset)::VARCHAR = '''' THEN
   NEW.desset := NULL;
END IF;
IF trim(NEW.inscst)::VARCHAR = '''' THEN
   NEW.inscst := NULL;
END IF;
IF trim(NEW.phocom)::VARCHAR = '''' THEN
   NEW.phocom := NULL;
END IF;
IF trim(NEW.phoiso)::VARCHAR = '''' THEN
   NEW.phoiso := NULL;
END IF;
IF trim(NEW.phomar)::VARCHAR = '''' THEN
   NEW.phomar := NULL;
END IF;
IF trim(NEW.phoout)::VARCHAR = '''' THEN
   NEW.phoout := NULL;
END IF;
IF trim(NEW.photip)::VARCHAR = '''' THEN
   NEW.photip := NULL;
END IF;
IF trim(NEW.regiao)::VARCHAR = '''' THEN
   NEW.regiao := NULL;
END IF;
IF trim(NEW.result)::VARCHAR = '''' THEN
   NEW.result := NULL;
END IF;
IF trim(NEW.codtri)::VARCHAR = '''' THEN
   NEW.codtri := NULL;
END IF;
IF trim(NEW.descar)::VARCHAR = '''' THEN
   NEW.descar := NULL;
END IF;
IF trim(NEW.deseti)::VARCHAR = '''' THEN
   NEW.deseti := NULL;
END IF;
IF trim(NEW.deshom)::VARCHAR = '''' THEN
   NEW.deshom := NULL;
END IF;
IF trim(NEW.desout)::VARCHAR = '''' THEN
   NEW.desout := NULL;
END IF;
IF trim(NEW.dessaz)::VARCHAR = '''' THEN
   NEW.dessaz := NULL;
END IF;
IF trim(NEW.especi)::VARCHAR = '''' THEN
   NEW.especi := NULL;
END IF;
IF trim(NEW.nomct1)::VARCHAR = '''' THEN
   NEW.nomct1 := NULL;
END IF;
IF trim(NEW.nomct2)::VARCHAR = '''' THEN
   NEW.nomct2 := NULL;
END IF;
IF trim(NEW.nomct3)::VARCHAR = '''' THEN
   NEW.nomct3 := NULL;
END IF;
IF trim(NEW.nomdiv)::VARCHAR = '''' THEN
   NEW.nomdiv := NULL;
END IF;
IF trim(NEW.nomgra)::VARCHAR = '''' THEN
   NEW.nomgra := NULL;
END IF;
IF trim(NEW.nomsub)::VARCHAR = '''' THEN
   NEW.nomsub := NULL;
END IF;
IF trim(NEW.tipdes)::VARCHAR = '''' THEN
   NEW.tipdes := NULL;
END IF;
IF trim(NEW.desclt)::VARCHAR = '''' THEN
   NEW.desclt := NULL;
END IF;
IF trim(NEW.desser)::VARCHAR = '''' THEN
   NEW.desser := NULL;
END IF;
IF trim(NEW.serecf)::VARCHAR = '''' THEN
   NEW.serecf := NULL;
END IF;
IF trim(NEW.nomest)::VARCHAR = '''' THEN
   NEW.nomest := NULL;
END IF;
IF trim(NEW.cx_des)::VARCHAR = '''' THEN
   NEW.cx_des := NULL;
END IF;
IF trim(NEW.desccb)::VARCHAR = '''' THEN
   NEW.desccb := NULL;
END IF;
IF trim(NEW.desccc)::VARCHAR = '''' THEN
   NEW.desccc := NULL;
END IF;
IF trim(NEW.descob)::VARCHAR = '''' THEN
   NEW.descob := NULL;
END IF;
IF trim(NEW.descom)::VARCHAR = '''' THEN
   NEW.descom := NULL;
END IF;
IF trim(NEW.descor)::VARCHAR = '''' THEN
   NEW.descor := NULL;
END IF;
IF trim(NEW.desctr)::VARCHAR = '''' THEN
   NEW.desctr := NULL;
END IF;
IF trim(NEW.desdoc)::VARCHAR = '''' THEN
   NEW.desdoc := NULL;
END IF;
IF trim(NEW.desdop)::VARCHAR = '''' THEN
   NEW.desdop := NULL;
END IF;
IF trim(NEW.desdop_std)::VARCHAR = '''' THEN
   NEW.desdop_std := NULL;
END IF;
IF trim(NEW.desecb)::VARCHAR = '''' THEN
   NEW.desecb := NULL;
END IF;
IF trim(NEW.desfin)::VARCHAR = '''' THEN
   NEW.desfin := NULL;
END IF;
IF trim(NEW.desgru)::VARCHAR = '''' THEN
   NEW.desgru := NULL;
END IF;
IF trim(NEW.desins)::VARCHAR = '''' THEN
   NEW.desins := NULL;
END IF;
IF trim(NEW.desjus)::VARCHAR = '''' THEN
   NEW.desjus := NULL;
END IF;
IF trim(NEW.deslan)::VARCHAR = '''' THEN
   NEW.deslan := NULL;
END IF;
IF trim(NEW.deslib)::VARCHAR = '''' THEN
   NEW.deslib := NULL;
END IF;
IF trim(NEW.desobs)::VARCHAR = '''' THEN
   NEW.desobs := NULL;
END IF;
IF trim(NEW.despre)::VARCHAR = '''' THEN
   NEW.despre := NULL;
END IF;
IF trim(NEW.desrem)::VARCHAR = '''' THEN
   NEW.desrem := NULL;
END IF;
IF trim(NEW.desret)::VARCHAR = '''' THEN
   NEW.desret := NULL;
END IF;
IF trim(NEW.desstd)::VARCHAR = '''' THEN
   NEW.desstd := NULL;
END IF;
IF trim(NEW.desvei)::VARCHAR = '''' THEN
   NEW.desvei := NULL;
END IF;
IF trim(NEW.desvtp)::VARCHAR = '''' THEN
   NEW.desvtp := NULL;
END IF;
IF trim(NEW.livre)::VARCHAR = '''' THEN
   NEW.livre := NULL;
END IF;
IF trim(NEW.nbanco)::VARCHAR = '''' THEN
   NEW.nbanco := NULL;
END IF;
IF trim(NEW.nomcnc)::VARCHAR = '''' THEN
   NEW.nomcnc := NULL;
END IF;
IF trim(NEW.nomcol)::VARCHAR = '''' THEN
   NEW.nomcol := NULL;
END IF;
IF trim(NEW.desdep)::VARCHAR = '''' THEN
   NEW.desdep := NULL;
END IF;
IF trim(NEW.cliadm)::VARCHAR = '''' THEN
   NEW.cliadm := NULL;
END IF;
IF trim(NEW.coment)::VARCHAR = '''' THEN
   NEW.coment := NULL;
END IF;
IF trim(NEW.dissai)::VARCHAR = '''' THEN
   NEW.dissai := NULL;
END IF;
IF trim(NEW.saicar)::VARCHAR = '''' THEN
   NEW.saicar := NULL;
END IF;
IF trim(NEW.titctr)::VARCHAR = '''' THEN
   NEW.titctr := NULL;
END IF;
IF trim(NEW.assccc)::VARCHAR = '''' THEN
   NEW.assccc := NULL;
END IF;
IF trim(NEW.imgdep)::VARCHAR = '''' THEN
   NEW.imgdep := NULL;
END IF;
IF trim(NEW.rbfile)::VARCHAR = '''' THEN
   NEW.rbfile := NULL;
END IF;
IF trim(NEW.titcar)::VARCHAR = '''' THEN
   NEW.titcar := NULL;
END IF;
IF trim(NEW.fbanco)::VARCHAR = '''' THEN
   NEW.fbanco := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.txtccc)::VARCHAR = '''' THEN
   NEW.txtccc := NULL;
END IF;
IF trim(NEW.txtobs)::VARCHAR = '''' THEN
   NEW.txtobs := NULL;
END IF;
IF trim(NEW.desmul)::VARCHAR = '''' THEN
   NEW.desmul := NULL;
END IF;
IF trim(NEW.mulati)::VARCHAR = '''' THEN
   NEW.mulati := NULL;
END IF;
IF trim(NEW.regccc)::VARCHAR = '''' THEN
   NEW.regccc := NULL;
END IF;
IF trim(NEW.filint)::VARCHAR = '''' THEN
   NEW.filint := NULL;
END IF;
IF trim(NEW.codint)::VARCHAR = '''' THEN
   NEW.codint := NULL;
END IF;
IF trim(NEW.filtst)::VARCHAR = '''' THEN
   NEW.filtst := NULL;
END IF;
IF trim(NEW.codtst)::VARCHAR = '''' THEN
   NEW.codtst := NULL;
END IF;
IF trim(NEW.sacusu)::VARCHAR = '''' THEN
   NEW.sacusu := NULL;
END IF;
IF trim(NEW.worusu)::VARCHAR = '''' THEN
   NEW.worusu := NULL;
END IF;
IF trim(NEW.intusu)::VARCHAR = '''' THEN
   NEW.intusu := NULL;
END IF;
IF trim(NEW.tstusu)::VARCHAR = '''' THEN
   NEW.tstusu := NULL;
END IF;
IF trim(NEW.titcta)::VARCHAR = '''' THEN
   NEW.titcta := NULL;
END IF;
IF trim(NEW.ctacai)::VARCHAR = '''' THEN
   NEW.ctacai := NULL;
END IF;
IF trim(NEW.ctaccc)::VARCHAR = '''' THEN
   NEW.ctaccc := NULL;
END IF;
IF trim(NEW.ctacar)::VARCHAR = '''' THEN
   NEW.ctacar := NULL;
END IF;
IF trim(NEW.transf)::VARCHAR = '''' THEN
   NEW.transf := NULL;
END IF;
IF trim(NEW.desmat)::VARCHAR = '''' THEN
   NEW.desmat := NULL;
END IF;
IF trim(NEW.natref)::VARCHAR = '''' THEN
   NEW.natref := NULL;
END IF;
IF trim(NEW.natred)::VARCHAR = '''' THEN
   NEW.natred := NULL;
END IF;
IF trim(NEW.codex1)::VARCHAR = '''' THEN
   NEW.codex1 := NULL;
END IF;
IF trim(NEW.codex2)::VARCHAR = '''' THEN
   NEW.codex2 := NULL;
END IF;
IF trim(NEW.codex3)::VARCHAR = '''' THEN
   NEW.codex3 := NULL;
END IF;
IF trim(NEW.codex4)::VARCHAR = '''' THEN
   NEW.codex4 := NULL;
END IF;
IF trim(NEW.priati)::VARCHAR = '''' THEN
   NEW.priati := NULL;
END IF;
IF trim(NEW.despri)::VARCHAR = '''' THEN
   NEW.despri := NULL;
END IF;
IF trim(NEW.tiphor)::VARCHAR = '''' THEN
   NEW.tiphor := NULL;
END IF;
IF trim(NEW.obspri)::VARCHAR = '''' THEN
   NEW.obspri := NULL;
END IF;
IF trim(NEW.cwsati)::VARCHAR = '''' THEN
   NEW.cwsati := NULL;
END IF;
IF trim(NEW.descws)::VARCHAR = '''' THEN
   NEW.descws := NULL;
END IF;
IF trim(NEW.pedaut)::VARCHAR = '''' THEN
   NEW.pedaut := NULL;
END IF;
IF trim(NEW.tipcws)::VARCHAR = '''' THEN
   NEW.tipcws := NULL;
END IF;
IF trim(NEW.funati)::VARCHAR = '''' THEN
   NEW.funati := NULL;
END IF;
IF trim(NEW.desfun)::VARCHAR = '''' THEN
   NEW.desfun := NULL;
END IF;
IF trim(NEW.comjus)::VARCHAR = '''' THEN
   NEW.comjus := NULL;
END IF;
IF trim(NEW.tipjus)::VARCHAR = '''' THEN
   NEW.tipjus := NULL;
END IF;
IF trim(NEW.filset)::VARCHAR = '''' THEN
   NEW.filset := NULL;
END IF;
IF trim(NEW.prjset)::VARCHAR = '''' THEN
   NEW.prjset := NULL;
END IF;
IF trim(NEW.horcws)::VARCHAR = '''' THEN
   NEW.horcws := NULL;
END IF;
IF trim(NEW.envrem)::VARCHAR = '''' THEN
   NEW.envrem := NULL;
END IF;
IF trim(NEW.ccbtit)::VARCHAR = '''' THEN
   NEW.ccbtit := NULL;
END IF;
IF trim(NEW.flgnew)::VARCHAR = '''' THEN
   NEW.flgnew := NULL;
END IF;
IF trim(NEW.ctruso)::VARCHAR = '''' THEN
   NEW.ctruso := NULL;
END IF;
IF trim(NEW.cbanco)::VARCHAR = '''' THEN
   NEW.cbanco := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.conati)::VARCHAR = '''' THEN
   NEW.conati := NULL;
END IF;
IF trim(NEW.cx_cod)::VARCHAR = '''' THEN
   NEW.cx_cod := NULL;
END IF;
IF trim(NEW.estado)::VARCHAR = '''' THEN
   NEW.estado := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.tipcon)::VARCHAR = '''' THEN
   NEW.tipcon := NULL;
END IF;
IF trim(NEW.tipdoc)::VARCHAR = '''' THEN
   NEW.tipdoc := NULL;
END IF;
IF trim(NEW.codfis)::VARCHAR = '''' THEN
   NEW.codfis := NULL;
END IF;
IF trim(NEW.modulo)::VARCHAR = '''' THEN
   NEW.modulo := NULL;
END IF;
IF trim(NEW.nature)::VARCHAR = '''' THEN
   NEW.nature := NULL;
END IF;
IF trim(NEW.servin)::VARCHAR = '''' THEN
   NEW.servin := NULL;
END IF;
IF trim(NEW.apepri)::VARCHAR = '''' THEN
   NEW.apepri := NULL;
END IF;
IF trim(NEW.lanvlr)::VARCHAR = '''' THEN
   NEW.lanvlr := NULL;
END IF;
IF trim(NEW.lanedi)::VARCHAR = '''' THEN
   NEW.lanedi := NULL;
END IF;
IF trim(NEW.clacon)::VARCHAR = '''' THEN
   NEW.clacon := NULL;
END IF;
IF trim(NEW.desdev)::VARCHAR = '''' THEN
   NEW.desdev := NULL;
END IF;
IF trim(NEW.devati)::VARCHAR = '''' THEN
   NEW.devati := NULL;
END IF;
IF trim(NEW.desmuldev)::VARCHAR = '''' THEN
   NEW.desmuldev := NULL;
END IF;
IF trim(NEW.usodev)::VARCHAR = '''' THEN
   NEW.usodev := NULL;
END IF;
IF trim(NEW.vlrdev)::VARCHAR = '''' THEN
   NEW.vlrdev := NULL;
END IF;
IF trim(NEW.saienv)::VARCHAR = '''' THEN
   NEW.saienv := NULL;
END IF;
IF trim(NEW.desocu)::VARCHAR = '''' THEN
   NEW.desocu := NULL;
END IF;
IF trim(NEW.grumod)::VARCHAR = '''' THEN
   NEW.grumod := NULL;
END IF;
IF trim(NEW.desmon)::VARCHAR = '''' THEN
   NEW.desmon := NULL;
END IF;
IF trim(NEW.monati)::VARCHAR = '''' THEN
   NEW.monati := NULL;
END IF;
IF trim(NEW.avijus)::VARCHAR = '''' THEN
   NEW.avijus := NULL;
END IF;
IF trim(NEW.desina)::VARCHAR = '''' THEN
   NEW.desina := NULL;
END IF;
IF trim(NEW.inaati)::VARCHAR = '''' THEN
   NEW.inaati := NULL;
END IF;
IF trim(NEW.usoina)::VARCHAR = '''' THEN
   NEW.usoina := NULL;
END IF;
IF trim(NEW.desarc)::VARCHAR = '''' THEN
   NEW.desarc := NULL;
END IF;
IF trim(NEW.arcatv)::VARCHAR = '''' THEN
   NEW.arcatv := NULL;
END IF;
IF trim(NEW.tiparc)::VARCHAR = '''' THEN
   NEW.tiparc := NULL;
END IF;
IF trim(NEW.rb_cor)::VARCHAR = '''' THEN
   NEW.rb_cor := NULL;
END IF;
IF trim(NEW.coratv)::VARCHAR = '''' THEN
   NEW.coratv := NULL;
END IF;
IF trim(NEW.titcor)::VARCHAR = '''' THEN
   NEW.titcor := NULL;
END IF;
IF trim(NEW.coddfc)::VARCHAR = '''' THEN
   NEW.coddfc := NULL;
END IF;
IF trim(NEW.desdfc)::VARCHAR = '''' THEN
   NEW.desdfc := NULL;
END IF;
IF trim(NEW.dfcati)::VARCHAR = '''' THEN
   NEW.dfcati := NULL;
END IF;
IF trim(NEW.descfo)::VARCHAR = '''' THEN
   NEW.descfo := NULL;
END IF;
IF trim(NEW.cfoati)::VARCHAR = '''' THEN
   NEW.cfoati := NULL;
END IF;
IF trim(NEW.codcfo)::VARCHAR = '''' THEN
   NEW.codcfo := NULL;
END IF;
IF trim(NEW.extcfo)::VARCHAR = '''' THEN
   NEW.extcfo := NULL;
END IF;
IF trim(NEW.clidev)::VARCHAR = '''' THEN
   NEW.clidev := NULL;
END IF;
IF trim(NEW.desend)::VARCHAR = '''' THEN
   NEW.desend := NULL;
END IF;
IF trim(NEW.endatv)::VARCHAR = '''' THEN
   NEW.endatv := NULL;
END IF;
IF trim(NEW.dupend)::VARCHAR = '''' THEN
   NEW.dupend := NULL;
END IF;
IF trim(NEW.aprova)::VARCHAR = '''' THEN
   NEW.aprova := NULL;
END IF;
IF trim(NEW.aprati)::VARCHAR = '''' THEN
   NEW.aprati := NULL;
END IF;
IF trim(NEW.maqecf)::VARCHAR = '''' THEN
   NEW.maqecf := NULL;
END IF;
IF trim(NEW.codfun)::VARCHAR = '''' THEN
   NEW.codfun := NULL;
END IF;
IF trim(NEW.motvpe)::VARCHAR = '''' THEN
   NEW.motvpe := NULL;
END IF;
IF trim(NEW.filtan)::VARCHAR = '''' THEN
   NEW.filtan := NULL;
END IF;
IF trim(NEW.grafil)::VARCHAR = '''' THEN
   NEW.grafil := NULL;
END IF;
IF trim(NEW.gracod)::VARCHAR = '''' THEN
   NEW.gracod := NULL;
END IF;
IF trim(NEW.tanatv)::VARCHAR = '''' THEN
   NEW.tanatv := NULL;
END IF;
IF trim(NEW.filbic)::VARCHAR = '''' THEN
   NEW.filbic := NULL;
END IF;
IF trim(NEW.nivpre)::VARCHAR = '''' THEN
   NEW.nivpre := NULL;
END IF;
IF trim(NEW.bicatv)::VARCHAR = '''' THEN
   NEW.bicatv := NULL;
END IF;
IF trim(NEW.consfi)::VARCHAR = '''' THEN
   NEW.consfi := NULL;
END IF;
IF trim(NEW.desapr)::VARCHAR = '''' THEN
   NEW.desapr := NULL;
END IF;
IF trim(NEW.desamb)::VARCHAR = '''' THEN
   NEW.desamb := NULL;
END IF;
IF trim(NEW.ambati)::VARCHAR = '''' THEN
   NEW.ambati := NULL;
END IF;
IF trim(NEW.usoend)::VARCHAR = '''' THEN
   NEW.usoend := NULL;
END IF;
IF trim(NEW.cepini)::VARCHAR = '''' THEN
   NEW.cepini := NULL;
END IF;
IF trim(NEW.cepfim)::VARCHAR = '''' THEN
   NEW.cepfim := NULL;
END IF;
IF trim(NEW.seqexc)::VARCHAR = '''' THEN
   NEW.seqexc := NULL;
END IF;
IF trim(NEW.sitati)::VARCHAR = '''' THEN
   NEW.sitati := NULL;
END IF;
IF trim(NEW.dessit)::VARCHAR = '''' THEN
   NEW.dessit := NULL;
END IF;
IF trim(NEW.flgres)::VARCHAR = '''' THEN
   NEW.flgres := NULL;
END IF;
IF trim(NEW.flgrev)::VARCHAR = '''' THEN
   NEW.flgrev := NULL;
END IF;
IF trim(NEW.flgreg)::VARCHAR = '''' THEN
   NEW.flgreg := NULL;
END IF;
IF trim(NEW.flgmod)::VARCHAR = '''' THEN
   NEW.flgmod := NULL;
END IF;
IF trim(NEW.tipsit)::VARCHAR = '''' THEN
   NEW.tipsit := NULL;
END IF;
IF trim(NEW.relati)::VARCHAR = '''' THEN
   NEW.relati := NULL;
END IF;
IF trim(NEW.desrel)::VARCHAR = '''' THEN
   NEW.desrel := NULL;
END IF;
IF trim(NEW.cfpati)::VARCHAR = '''' THEN
   NEW.cfpati := NULL;
END IF;
IF trim(NEW.descfp)::VARCHAR = '''' THEN
   NEW.descfp := NULL;
END IF;
IF trim(NEW.vencon)::VARCHAR = '''' THEN
   NEW.vencon := NULL;
END IF;
IF trim(NEW.venrev)::VARCHAR = '''' THEN
   NEW.venrev := NULL;
END IF;
IF trim(NEW.devcon)::VARCHAR = '''' THEN
   NEW.devcon := NULL;
END IF;
IF trim(NEW.devrev)::VARCHAR = '''' THEN
   NEW.devrev := NULL;
END IF;
IF trim(NEW.saicon)::VARCHAR = '''' THEN
   NEW.saicon := NULL;
END IF;
IF trim(NEW.sairev)::VARCHAR = '''' THEN
   NEW.sairev := NULL;
END IF;
IF trim(NEW.entcon)::VARCHAR = '''' THEN
   NEW.entcon := NULL;
END IF;
IF trim(NEW.entrev)::VARCHAR = '''' THEN
   NEW.entrev := NULL;
END IF;
IF trim(NEW.comcon)::VARCHAR = '''' THEN
   NEW.comcon := NULL;
END IF;
IF trim(NEW.comrev)::VARCHAR = '''' THEN
   NEW.comrev := NULL;
END IF;
IF trim(NEW.dvccon)::VARCHAR = '''' THEN
   NEW.dvccon := NULL;
END IF;
IF trim(NEW.dvcrev)::VARCHAR = '''' THEN
   NEW.dvcrev := NULL;
END IF;
IF trim(NEW.intcon)::VARCHAR = '''' THEN
   NEW.intcon := NULL;
END IF;
IF trim(NEW.intrev)::VARCHAR = '''' THEN
   NEW.intrev := NULL;
END IF;
IF trim(NEW.tipfun)::VARCHAR = '''' THEN
   NEW.tipfun := NULL;
END IF;
IF trim(NEW.devvin)::VARCHAR = '''' THEN
   NEW.devvin := NULL;
END IF;
IF trim(NEW.tipado)::VARCHAR = '''' THEN
   NEW.tipado := NULL;
END IF;
IF trim(NEW.terati)::VARCHAR = '''' THEN
   NEW.terati := NULL;
END IF;
IF trim(NEW.ter_ip)::VARCHAR = '''' THEN
   NEW.ter_ip := NULL;
END IF;
IF trim(NEW.filter)::VARCHAR = '''' THEN
   NEW.filter := NULL;
END IF;
IF trim(NEW.terven)::VARCHAR = '''' THEN
   NEW.terven := NULL;
END IF;
IF trim(NEW.tiprce)::VARCHAR = '''' THEN
   NEW.tiprce := NULL;
END IF;
IF trim(NEW.lpcati)::VARCHAR = '''' THEN
   NEW.lpcati := NULL;
END IF;
IF trim(NEW.deslpc)::VARCHAR = '''' THEN
   NEW.deslpc := NULL;
END IF;
IF trim(NEW.numext)::VARCHAR = '''' THEN
   NEW.numext := NULL;
END IF;
IF trim(NEW.sugest)::VARCHAR = '''' THEN
   NEW.sugest := NULL;
END IF;
IF trim(NEW.tipwor)::VARCHAR = '''' THEN
   NEW.tipwor := NULL;
END IF;
IF trim(NEW.oricws)::VARCHAR = '''' THEN
   NEW.oricws := NULL;
END IF;
IF trim(NEW.aplcon)::VARCHAR = '''' THEN
   NEW.aplcon := NULL;
END IF;
IF trim(NEW.zeresq)::VARCHAR = '''' THEN
   NEW.zeresq := NULL;
END IF;
IF trim(NEW.filcai)::VARCHAR = '''' THEN
   NEW.filcai := NULL;
END IF;
IF trim(NEW.seqcai)::VARCHAR = '''' THEN
   NEW.seqcai := NULL;
END IF;
IF trim(NEW.tipcai)::VARCHAR = '''' THEN
   NEW.tipcai := NULL;
END IF;
IF trim(NEW.titcai)::VARCHAR = '''' THEN
   NEW.titcai := NULL;
END IF;
IF trim(NEW.extcus)::VARCHAR = '''' THEN
   NEW.extcus := NULL;
END IF;
IF trim(NEW.filpra)::VARCHAR = '''' THEN
   NEW.filpra := NULL;
END IF;
IF trim(NEW.seqpra)::VARCHAR = '''' THEN
   NEW.seqpra := NULL;
END IF;
IF trim(NEW.tippra)::VARCHAR = '''' THEN
   NEW.tippra := NULL;
END IF;
IF trim(NEW.titctrpra)::VARCHAR = '''' THEN
   NEW.titctrpra := NULL;
END IF;
IF trim(NEW.marecf)::VARCHAR = '''' THEN
   NEW.marecf := NULL;
END IF;
IF trim(NEW.modecf)::VARCHAR = '''' THEN
   NEW.modecf := NULL;
END IF;
IF trim(NEW.vswecf)::VARCHAR = '''' THEN
   NEW.vswecf := NULL;
END IF;
IF trim(NEW.codfab)::VARCHAR = '''' THEN
   NEW.codfab := NULL;
END IF;
IF trim(NEW.codmod)::VARCHAR = '''' THEN
   NEW.codmod := NULL;
END IF;
IF trim(NEW.fitdet)::VARCHAR = '''' THEN
   NEW.fitdet := NULL;
END IF;
IF trim(NEW.movleg)::VARCHAR = '''' THEN
   NEW.movleg := NULL;
END IF;
IF trim(NEW.fillan)::VARCHAR = '''' THEN
   NEW.fillan := NULL;
END IF;
IF trim(NEW.fccati)::VARCHAR = '''' THEN
   NEW.fccati := NULL;
END IF;
IF trim(NEW.titavu)::VARCHAR = '''' THEN
   NEW.titavu := NULL;
END IF;
IF trim(NEW.desmed)::VARCHAR = '''' THEN
   NEW.desmed := NULL;
END IF;
IF trim(NEW.cl1web)::VARCHAR = '''' THEN
   NEW.cl1web := NULL;
END IF;
IF trim(NEW.cl2web)::VARCHAR = '''' THEN
   NEW.cl2web := NULL;
END IF;
IF trim(NEW.cl3web)::VARCHAR = '''' THEN
   NEW.cl3web := NULL;
END IF;
IF trim(NEW.cl4web)::VARCHAR = '''' THEN
   NEW.cl4web := NULL;
END IF;
IF trim(NEW.depweb)::VARCHAR = '''' THEN
   NEW.depweb := NULL;
END IF;
IF trim(NEW.cfomod)::VARCHAR = '''' THEN
   NEW.cfomod := NULL;
END IF;
IF trim(NEW.natmod)::VARCHAR = '''' THEN
   NEW.natmod := NULL;
END IF;
IF trim(NEW.cfocta_fil)::VARCHAR = '''' THEN
   NEW.cfocta_fil := NULL;
END IF;
IF trim(NEW.cfocta_seq)::VARCHAR = '''' THEN
   NEW.cfocta_seq := NULL;
END IF;
IF trim(NEW.cfocta_tip)::VARCHAR = '''' THEN
   NEW.cfocta_tip := NULL;
END IF;
IF trim(NEW.natutl)::VARCHAR = '''' THEN
   NEW.natutl := NULL;
END IF;
IF trim(NEW.serutl)::VARCHAR = '''' THEN
   NEW.serutl := NULL;
END IF;
IF trim(NEW.natden_fil)::VARCHAR = '''' THEN
   NEW.natden_fil := NULL;
END IF;
IF trim(NEW.natden_seq)::VARCHAR = '''' THEN
   NEW.natden_seq := NULL;
END IF;
IF trim(NEW.natden_tip)::VARCHAR = '''' THEN
   NEW.natden_tip := NULL;
END IF;
IF trim(NEW.natfor_fil)::VARCHAR = '''' THEN
   NEW.natfor_fil := NULL;
END IF;
IF trim(NEW.natfor_seq)::VARCHAR = '''' THEN
   NEW.natfor_seq := NULL;
END IF;
IF trim(NEW.natfor_tip)::VARCHAR = '''' THEN
   NEW.natfor_tip := NULL;
END IF;
IF trim(NEW.ecfutl)::VARCHAR = '''' THEN
   NEW.ecfutl := NULL;
END IF;
IF trim(NEW.titctaden)::VARCHAR = '''' THEN
   NEW.titctaden := NULL;
END IF;
IF trim(NEW.titctafor)::VARCHAR = '''' THEN
   NEW.titctafor := NULL;
END IF;
IF trim(NEW.cfocta_tit)::VARCHAR = '''' THEN
   NEW.cfocta_tit := NULL;
END IF;
IF trim(NEW.desstr)::VARCHAR = '''' THEN
   NEW.desstr := NULL;
END IF;
IF trim(NEW.flgstr)::VARCHAR = '''' THEN
   NEW.flgstr := NULL;
END IF;
IF trim(NEW.strati)::VARCHAR = '''' THEN
   NEW.strati := NULL;
END IF;
IF trim(NEW.desreq)::VARCHAR = '''' THEN
   NEW.desreq := NULL;
END IF;
IF trim(NEW.reqati)::VARCHAR = '''' THEN
   NEW.reqati := NULL;
END IF;
IF trim(NEW.abrreq)::VARCHAR = '''' THEN
   NEW.abrreq := NULL;
END IF;
IF trim(NEW.clareq)::VARCHAR = '''' THEN
   NEW.clareq := NULL;
END IF;
IF trim(NEW.ger_cc)::VARCHAR = '''' THEN
   NEW.ger_cc := NULL;
END IF;
IF trim(NEW.filcom)::VARCHAR = '''' THEN
   NEW.filcom := NULL;
END IF;
IF trim(NEW.codcom)::VARCHAR = '''' THEN
   NEW.codcom := NULL;
END IF;
IF trim(NEW.comusu)::VARCHAR = '''' THEN
   NEW.comusu := NULL;
END IF;
IF trim(NEW.serord)::VARCHAR = '''' THEN
   NEW.serord := NULL;
END IF;
IF trim(NEW.patped)::VARCHAR = '''' THEN
   NEW.patped := NULL;
END IF;
IF trim(NEW.serdoc)::VARCHAR = '''' THEN
   NEW.serdoc := NULL;
END IF;
IF trim(NEW.mulweb)::VARCHAR = '''' THEN
   NEW.mulweb := NULL;
END IF;
IF trim(NEW.vencon_for)::VARCHAR = '''' THEN
   NEW.vencon_for := NULL;
END IF;
IF trim(NEW.venrev_for)::VARCHAR = '''' THEN
   NEW.venrev_for := NULL;
END IF;
IF trim(NEW.devcon_for)::VARCHAR = '''' THEN
   NEW.devcon_for := NULL;
END IF;
IF trim(NEW.devrev_for)::VARCHAR = '''' THEN
   NEW.devrev_for := NULL;
END IF;
IF trim(NEW.saicon_for)::VARCHAR = '''' THEN
   NEW.saicon_for := NULL;
END IF;
IF trim(NEW.sairev_for)::VARCHAR = '''' THEN
   NEW.sairev_for := NULL;
END IF;
IF trim(NEW.entcon_for)::VARCHAR = '''' THEN
   NEW.entcon_for := NULL;
END IF;
IF trim(NEW.entrev_for)::VARCHAR = '''' THEN
   NEW.entrev_for := NULL;
END IF;
IF trim(NEW.comcon_for)::VARCHAR = '''' THEN
   NEW.comcon_for := NULL;
END IF;
IF trim(NEW.comrev_for)::VARCHAR = '''' THEN
   NEW.comrev_for := NULL;
END IF;
IF trim(NEW.dvccon_for)::VARCHAR = '''' THEN
   NEW.dvccon_for := NULL;
END IF;
IF trim(NEW.dvcrev_for)::VARCHAR = '''' THEN
   NEW.dvcrev_for := NULL;
END IF;
IF trim(NEW.intcon_for)::VARCHAR = '''' THEN
   NEW.intcon_for := NULL;
END IF;
IF trim(NEW.intrev_for)::VARCHAR = '''' THEN
   NEW.intrev_for := NULL;
END IF;
IF trim(NEW.ecfmfa)::VARCHAR = '''' THEN
   NEW.ecfmfa := NULL;
END IF;
IF trim(NEW.ecftip)::VARCHAR = '''' THEN
   NEW.ecftip := NULL;
END IF;
IF trim(NEW.tnciee)::VARCHAR = '''' THEN
   NEW.tnciee := NULL;
END IF;
IF trim(NEW.sitmai)::VARCHAR = '''' THEN
   NEW.sitmai := NULL;
END IF;
IF trim(NEW.ocuati)::VARCHAR = '''' THEN
   NEW.ocuati := NULL;
END IF;
IF trim(NEW.serext)::VARCHAR = '''' THEN
   NEW.serext := NULL;
END IF;
IF trim(NEW.nserie)::VARCHAR = '''' THEN
   NEW.nserie := NULL;
END IF;
IF trim(NEW.nomfab)::VARCHAR = '''' THEN
   NEW.nomfab := NULL;
END IF;
IF trim(NEW.modelo)::VARCHAR = '''' THEN
   NEW.modelo := NULL;
END IF;
IF trim(NEW.tipmed)::VARCHAR = '''' THEN
   NEW.tipmed := NULL;
END IF;
IF trim(NEW.bomati)::VARCHAR = '''' THEN
   NEW.bomati := NULL;
END IF;
IF trim(NEW.tiptit)::VARCHAR = '''' THEN
   NEW.tiptit := NULL;
END IF;
IF trim(NEW.natest_fil)::VARCHAR = '''' THEN
   NEW.natest_fil := NULL;
END IF;
IF trim(NEW.natest_seq)::VARCHAR = '''' THEN
   NEW.natest_seq := NULL;
END IF;
IF trim(NEW.natest_tip)::VARCHAR = '''' THEN
   NEW.natest_tip := NULL;
END IF;
IF trim(NEW.ctrest_fil)::VARCHAR = '''' THEN
   NEW.ctrest_fil := NULL;
END IF;
IF trim(NEW.ctrest_seq)::VARCHAR = '''' THEN
   NEW.ctrest_seq := NULL;
END IF;
IF trim(NEW.ctrest_tip)::VARCHAR = '''' THEN
   NEW.ctrest_tip := NULL;
END IF;
IF trim(NEW.desrtt)::VARCHAR = '''' THEN
   NEW.desrtt := NULL;
END IF;
IF trim(NEW.rttati)::VARCHAR = '''' THEN
   NEW.rttati := NULL;
END IF;
IF trim(NEW.rttest)::VARCHAR = '''' THEN
   NEW.rttest := NULL;
END IF;
IF trim(NEW.filcta_drtt)::VARCHAR = '''' THEN
   NEW.filcta_drtt := NULL;
END IF;
IF trim(NEW.seqcta_drtt)::VARCHAR = '''' THEN
   NEW.seqcta_drtt := NULL;
END IF;
IF trim(NEW.tipcta_drtt)::VARCHAR = '''' THEN
   NEW.tipcta_drtt := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.filcta_est_drtt)::VARCHAR = '''' THEN
   NEW.filcta_est_drtt := NULL;
END IF;
IF trim(NEW.seqcta_est_drtt)::VARCHAR = '''' THEN
   NEW.seqcta_est_drtt := NULL;
END IF;
IF trim(NEW.tipcta_est_drtt)::VARCHAR = '''' THEN
   NEW.tipcta_est_drtt := NULL;
END IF;
IF trim(NEW.codext_decf)::VARCHAR = '''' THEN
   NEW.codext_decf := NULL;
END IF;
IF trim(NEW.sitpis)::VARCHAR = '''' THEN
   NEW.sitpis := NULL;
END IF;
IF trim(NEW.sitcof)::VARCHAR = '''' THEN
   NEW.sitcof := NULL;
END IF;
IF trim(NEW.fccfil)::VARCHAR = '''' THEN
   NEW.fccfil := NULL;
END IF;
IF trim(NEW.fcc_filmat)::VARCHAR = '''' THEN
   NEW.fcc_filmat := NULL;
END IF;
IF trim(NEW.fcc_codmat)::VARCHAR = '''' THEN
   NEW.fcc_codmat := NULL;
END IF;
IF trim(NEW.fillac)::VARCHAR = '''' THEN
   NEW.fillac := NULL;
END IF;
IF trim(NEW.seqlac)::VARCHAR = '''' THEN
   NEW.seqlac := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.desmpb)::VARCHAR = '''' THEN
   NEW.desmpb := NULL;
END IF;
IF trim(NEW.mpbati)::VARCHAR = '''' THEN
   NEW.mpbati := NULL;
END IF;
IF trim(NEW.natbcc)::VARCHAR = '''' THEN
   NEW.natbcc := NULL;
END IF;
IF trim(NEW.serrem)::VARCHAR = '''' THEN
   NEW.serrem := NULL;
END IF;
IF trim(NEW.dessad)::VARCHAR = '''' THEN
   NEW.dessad := NULL;
END IF;
IF trim(NEW.sadati)::VARCHAR = '''' THEN
   NEW.sadati := NULL;
END IF;
IF trim(NEW.sugorc)::VARCHAR = '''' THEN
   NEW.sugorc := NULL;
END IF;
IF trim(NEW.venavu)::VARCHAR = '''' THEN
   NEW.venavu := NULL;
END IF;
IF trim(NEW.impdoc)::VARCHAR = '''' THEN
   NEW.impdoc := NULL;
END IF;
IF trim(NEW.forimp)::VARCHAR = '''' THEN
   NEW.forimp := NULL;
END IF;
IF trim(NEW.somgar)::VARCHAR = '''' THEN
   NEW.somgar := NULL;
END IF;
IF trim(NEW.movest_dcfo)::VARCHAR = '''' THEN
   NEW.movest_dcfo := NULL;
END IF;
IF trim(NEW.desrgc)::VARCHAR = '''' THEN
   NEW.desrgc := NULL;
END IF;
IF trim(NEW.rgcati)::VARCHAR = '''' THEN
   NEW.rgcati := NULL;
END IF;
IF trim(NEW.flgenc)::VARCHAR = '''' THEN
   NEW.flgenc := NULL;
END IF;
IF trim(NEW.flgdev)::VARCHAR = '''' THEN
   NEW.flgdev := NULL;
END IF;
IF trim(NEW.desstf)::VARCHAR = '''' THEN
   NEW.desstf := NULL;
END IF;
IF trim(NEW.stfati)::VARCHAR = '''' THEN
   NEW.stfati := NULL;
END IF;
IF trim(NEW.stf_filfor)::VARCHAR = '''' THEN
   NEW.stf_filfor := NULL;
END IF;
IF trim(NEW.stf_codfor)::VARCHAR = '''' THEN
   NEW.stf_codfor := NULL;
END IF;
IF trim(NEW.stf_codser)::VARCHAR = '''' THEN
   NEW.stf_codser := NULL;
END IF;
IF trim(NEW.stf_subser)::VARCHAR = '''' THEN
   NEW.stf_subser := NULL;
END IF;
IF trim(NEW.stf_coddar)::VARCHAR = '''' THEN
   NEW.stf_coddar := NULL;
END IF;
IF trim(NEW.stf_filcta)::VARCHAR = '''' THEN
   NEW.stf_filcta := NULL;
END IF;
IF trim(NEW.stf_seqcta)::VARCHAR = '''' THEN
   NEW.stf_seqcta := NULL;
END IF;
IF trim(NEW.stf_tipcta)::VARCHAR = '''' THEN
   NEW.stf_tipcta := NULL;
END IF;
IF trim(NEW.stf_codfps)::VARCHAR = '''' THEN
   NEW.stf_codfps := NULL;
END IF;
IF trim(NEW.despes)::VARCHAR = '''' THEN
   NEW.despes := NULL;
END IF;
IF trim(NEW.pesati)::VARCHAR = '''' THEN
   NEW.pesati := NULL;
END IF;
IF trim(NEW.desfre)::VARCHAR = '''' THEN
   NEW.desfre := NULL;
END IF;
IF trim(NEW.freati)::VARCHAR = '''' THEN
   NEW.freati := NULL;
END IF;
IF trim(NEW.dfre_tipcob)::VARCHAR = '''' THEN
   NEW.dfre_tipcob := NULL;
END IF;
IF trim(NEW.desniv)::VARCHAR = '''' THEN
   NEW.desniv := NULL;
END IF;
IF trim(NEW.nivati)::VARCHAR = '''' THEN
   NEW.nivati := NULL;
END IF;
IF trim(NEW.natesd)::VARCHAR = '''' THEN
   NEW.natesd := NULL;
END IF;
IF trim(NEW.natesf)::VARCHAR = '''' THEN
   NEW.natesf := NULL;
END IF;
IF trim(NEW.ck4g_homol)::VARCHAR = '''' THEN
   NEW.ck4g_homol := NULL;
END IF;
IF trim(NEW.ck4g_detver)::VARCHAR = '''' THEN
   NEW.ck4g_detver := NULL;
END IF;
IF trim(NEW.status_dados)::VARCHAR = '''' THEN
   NEW.status_dados := NULL;
END IF;
IF trim(NEW.sqlccc)::VARCHAR = '''' THEN
   NEW.sqlccc := NULL;
END IF;
IF trim(NEW.carlet)::VARCHAR = '''' THEN
   NEW.carlet := NULL;
END IF;
IF trim(NEW.carimg)::VARCHAR = '''' THEN
   NEW.carimg := NULL;
END IF;
IF trim(NEW.moelet)::VARCHAR = '''' THEN
   NEW.moelet := NULL;
END IF;
IF trim(NEW.moeimg)::VARCHAR = '''' THEN
   NEW.moeimg := NULL;
END IF;
IF trim(NEW.outlet)::VARCHAR = '''' THEN
   NEW.outlet := NULL;
END IF;
IF trim(NEW.outimg)::VARCHAR = '''' THEN
   NEW.outimg := NULL;
END IF;
IF trim(NEW.ccclet)::VARCHAR = '''' THEN
   NEW.ccclet := NULL;
END IF;
IF trim(NEW.cccimg)::VARCHAR = '''' THEN
   NEW.cccimg := NULL;
END IF;
IF trim(NEW.rttdig)::VARCHAR = '''' THEN
   NEW.rttdig := NULL;
END IF;
IF trim(NEW.rtttef)::VARCHAR = '''' THEN
   NEW.rtttef := NULL;
END IF;
IF trim(NEW.rttbar)::VARCHAR = '''' THEN
   NEW.rttbar := NULL;
END IF;
IF trim(NEW.regcar)::VARCHAR = '''' THEN
   NEW.regcar := NULL;
END IF;
IF trim(NEW.regout)::VARCHAR = '''' THEN
   NEW.regout := NULL;
END IF;
IF trim(NEW.ccccai)::VARCHAR = '''' THEN
   NEW.ccccai := NULL;
END IF;
IF trim(NEW.desimg)::VARCHAR = '''' THEN
   NEW.desimg := NULL;
END IF;
IF trim(NEW.letimg)::VARCHAR = '''' THEN
   NEW.letimg := NULL;
END IF;
IF trim(NEW.nomimg)::VARCHAR = '''' THEN
   NEW.nomimg := NULL;
END IF;
IF trim(NEW.imgati)::VARCHAR = '''' THEN
   NEW.imgati := NULL;
END IF;
IF trim(NEW.desmot)::VARCHAR = '''' THEN
   NEW.desmot := NULL;
END IF;
IF trim(NEW.usomot)::VARCHAR = '''' THEN
   NEW.usomot := NULL;
END IF;
IF trim(NEW.conmot)::VARCHAR = '''' THEN
   NEW.conmot := NULL;
END IF;
IF trim(NEW.tipmot)::VARCHAR = '''' THEN
   NEW.tipmot := NULL;
END IF;
IF trim(NEW.motati)::VARCHAR = '''' THEN
   NEW.motati := NULL;
END IF;
IF trim(NEW.coblet)::VARCHAR = '''' THEN
   NEW.coblet := NULL;
END IF;
IF trim(NEW.cobimg)::VARCHAR = '''' THEN
   NEW.cobimg := NULL;
END IF;
IF trim(NEW.flgpes)::VARCHAR = '''' THEN
   NEW.flgpes := NULL;
END IF;
IF trim(NEW.repsad)::VARCHAR = '''' THEN
   NEW.repsad := NULL;
END IF;
IF trim(NEW.ck4g_usafrete)::VARCHAR = '''' THEN
   NEW.ck4g_usafrete := NULL;
END IF;
IF trim(NEW.ck4g_zsomenteapos24h)::VARCHAR = '''' THEN
   NEW.ck4g_zsomenteapos24h := NULL;
END IF;
IF trim(NEW.ck4g_md5)::VARCHAR = '''' THEN
   NEW.ck4g_md5 := NULL;
END IF;
IF trim(NEW.natred_st)::VARCHAR = '''' THEN
   NEW.natred_st := NULL;
END IF;
IF trim(NEW.natref_st)::VARCHAR = '''' THEN
   NEW.natref_st := NULL;
END IF;
IF trim(NEW.cstnor)::VARCHAR = '''' THEN
   NEW.cstnor := NULL;
END IF;
IF trim(NEW.cst_st)::VARCHAR = '''' THEN
   NEW.cst_st := NULL;
END IF;
IF trim(NEW.dessat)::VARCHAR = '''' THEN
   NEW.dessat := NULL;
END IF;
IF trim(NEW.satati)::VARCHAR = '''' THEN
   NEW.satati := NULL;
END IF;
IF trim(NEW.sat_codfil)::VARCHAR = '''' THEN
   NEW.sat_codfil := NULL;
END IF;
IF trim(NEW.sat_codser)::VARCHAR = '''' THEN
   NEW.sat_codser := NULL;
END IF;
IF trim(NEW.ck4g_modfis_vc)::VARCHAR = '''' THEN
   NEW.ck4g_modfis_vc := NULL;
END IF;
IF trim(NEW.ck4g_modfis_vc_cont)::VARCHAR = '''' THEN
   NEW.ck4g_modfis_vc_cont := NULL;
END IF;
IF trim(NEW.ck4g_usa_cont_offline)::VARCHAR = '''' THEN
   NEW.ck4g_usa_cont_offline := NULL;
END IF;
IF trim(NEW.flgcfe)::VARCHAR = '''' THEN
   NEW.flgcfe := NULL;
END IF;
IF trim(NEW.decf_numext)::VARCHAR = '''' THEN
   NEW.decf_numext := NULL;
END IF;
IF trim(NEW.recibo)::VARCHAR = '''' THEN
   NEW.recibo := NULL;
END IF;
IF trim(NEW.codcre)::VARCHAR = '''' THEN
   NEW.codcre := NULL;
END IF;
IF trim(NEW.conloc)::VARCHAR = '''' THEN
   NEW.conloc := NULL;
END IF;
IF trim(NEW.envnfs)::VARCHAR = '''' THEN
   NEW.envnfs := NULL;
END IF;
IF trim(NEW.desomi)::VARCHAR = '''' THEN
   NEW.desomi := NULL;
END IF;
IF trim(NEW.omiati)::VARCHAR = '''' THEN
   NEW.omiati := NULL;
END IF;
IF trim(NEW.omilis)::VARCHAR = '''' THEN
   NEW.omilis := NULL;
END IF;
IF trim(NEW.omires)::VARCHAR = '''' THEN
   NEW.omires := NULL;
END IF;
IF trim(NEW.omicon)::VARCHAR = '''' THEN
   NEW.omicon := NULL;
END IF;
IF trim(NEW.omifil)::VARCHAR = '''' THEN
   NEW.omifil := NULL;
END IF;
IF trim(NEW.basmar)::VARCHAR = '''' THEN
   NEW.basmar := NULL;
END IF;
IF trim(NEW.natpre)::VARCHAR = '''' THEN
   NEW.natpre := NULL;
END IF;
IF trim(NEW.rgc_tipent)::VARCHAR = '''' THEN
   NEW.rgc_tipent := NULL;
END IF;
IF trim(NEW.desper)::VARCHAR = '''' THEN
   NEW.desper := NULL;
END IF;
IF trim(NEW.percod)::VARCHAR = '''' THEN
   NEW.percod := NULL;
END IF;
IF trim(NEW.perati)::VARCHAR = '''' THEN
   NEW.perati := NULL;
END IF;
IF trim(NEW.sercon)::VARCHAR = '''' THEN
   NEW.sercon := NULL;
END IF;
IF trim(NEW.cfofor)::VARCHAR = '''' THEN
   NEW.cfofor := NULL;
END IF;
IF trim(NEW.codext_dccc)::VARCHAR = '''' THEN
   NEW.codext_dccc := NULL;
END IF;
IF trim(NEW.codext_dcob)::VARCHAR = '''' THEN
   NEW.codext_dcob := NULL;
END IF;
IF trim(NEW.codpos_dmed)::VARCHAR = '''' THEN
   NEW.codpos_dmed := NULL;
END IF;
IF trim(NEW.codpos_ddep)::VARCHAR = '''' THEN
   NEW.codpos_ddep := NULL;
END IF;
IF trim(NEW.bandeb)::VARCHAR = '''' THEN
   NEW.bandeb := NULL;
END IF;
IF trim(NEW.bancre)::VARCHAR = '''' THEN
   NEW.bancre := NULL;
END IF;
IF trim(NEW.codext_dmul)::VARCHAR = '''' THEN
   NEW.codext_dmul := NULL;
END IF;
IF trim(NEW.codext_dct1)::VARCHAR = '''' THEN
   NEW.codext_dct1 := NULL;
END IF;
IF trim(NEW.codext_dct2)::VARCHAR = '''' THEN
   NEW.codext_dct2 := NULL;
END IF;
IF trim(NEW.codext_dct3)::VARCHAR = '''' THEN
   NEW.codext_dct3 := NULL;
END IF;
IF trim(NEW.destipxint)::VARCHAR = '''' THEN
   NEW.destipxint := NULL;
END IF;
IF trim(NEW.tipccm)::VARCHAR = '''' THEN
   NEW.tipccm := NULL;
END IF;
IF trim(NEW.filbco)::VARCHAR = '''' THEN
   NEW.filbco := NULL;
END IF;
IF trim(NEW.codbco)::VARCHAR = '''' THEN
   NEW.codbco := NULL;
END IF;
IF trim(NEW.desmtd)::VARCHAR = '''' THEN
   NEW.desmtd := NULL;
END IF;
IF trim(NEW.descmo)::VARCHAR = '''' THEN
   NEW.descmo := NULL;
END IF;
IF trim(NEW.tipcom)::VARCHAR = '''' THEN
   NEW.tipcom := NULL;
END IF;
IF trim(NEW.cilind)::VARCHAR = '''' THEN
   NEW.cilind := NULL;
END IF;
IF trim(NEW.potenc)::VARCHAR = '''' THEN
   NEW.potenc := NULL;
END IF;
IF trim(NEW.desmdv)::VARCHAR = '''' THEN
   NEW.desmdv := NULL;
END IF;
IF trim(NEW.disexi)::VARCHAR = '''' THEN
   NEW.disexi := NULL;
END IF;
IF trim(NEW.descorvei)::VARCHAR = '''' THEN
   NEW.descorvei := NULL;
END IF;
IF trim(NEW.mtdati)::VARCHAR = '''' THEN
   NEW.mtdati := NULL;
END IF;
IF trim(NEW.mtoati)::VARCHAR = '''' THEN
   NEW.mtoati := NULL;
END IF;
IF trim(NEW.mdvati)::VARCHAR = '''' THEN
   NEW.mdvati := NULL;
END IF;
IF trim(NEW.corveiati)::VARCHAR = '''' THEN
   NEW.corveiati := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_tab
BEFORE INSERT OR UPDATE ON tw_tab
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_tab();



/*-- SEQ 6507 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_usu() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.codext)::VARCHAR = '''' THEN
   NEW.codext := NULL;
END IF;
IF trim(NEW.apeusu)::VARCHAR = '''' THEN
   NEW.apeusu := NULL;
END IF;
IF trim(NEW.nomusu)::VARCHAR = '''' THEN
   NEW.nomusu := NULL;
END IF;
IF trim(NEW.visper)::VARCHAR = '''' THEN
   NEW.visper := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_usu
BEFORE INSERT OR UPDATE ON tw_usu
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_usu();



/*-- SEQ 6508 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_ven_fis() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.tiptro)::VARCHAR = '''' THEN
   NEW.tiptro := NULL;
END IF;
IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.codven)::VARCHAR = '''' THEN
   NEW.codven := NULL;
END IF;
IF trim(NEW.tipnot)::VARCHAR = '''' THEN
   NEW.tipnot := NULL;
END IF;
IF trim(NEW.filven)::VARCHAR = '''' THEN
   NEW.filven := NULL;
END IF;
IF trim(NEW.filusu)::VARCHAR = '''' THEN
   NEW.filusu := NULL;
END IF;
IF trim(NEW.filpgt)::VARCHAR = '''' THEN
   NEW.filpgt := NULL;
END IF;
IF trim(NEW.filcli)::VARCHAR = '''' THEN
   NEW.filcli := NULL;
END IF;
IF trim(NEW.numecf)::VARCHAR = '''' THEN
   NEW.numecf := NULL;
END IF;
IF trim(NEW.flgtip)::VARCHAR = '''' THEN
   NEW.flgtip := NULL;
END IF;
IF trim(NEW.flgest)::VARCHAR = '''' THEN
   NEW.flgest := NULL;
END IF;
IF trim(NEW.codser)::VARCHAR = '''' THEN
   NEW.codser := NULL;
END IF;
IF trim(NEW.codusu)::VARCHAR = '''' THEN
   NEW.codusu := NULL;
END IF;
IF trim(NEW.codpgt)::VARCHAR = '''' THEN
   NEW.codpgt := NULL;
END IF;
IF trim(NEW.codcli)::VARCHAR = '''' THEN
   NEW.codcli := NULL;
END IF;
IF trim(NEW.autent)::VARCHAR = '''' THEN
   NEW.autent := NULL;
END IF;
IF trim(NEW.ufloja)::VARCHAR = '''' THEN
   NEW.ufloja := NULL;
END IF;
IF trim(NEW.tribut)::VARCHAR = '''' THEN
   NEW.tribut := NULL;
END IF;
IF trim(NEW.financ)::VARCHAR = '''' THEN
   NEW.financ := NULL;
END IF;
IF trim(NEW.emides)::VARCHAR = '''' THEN
   NEW.emides := NULL;
END IF;
IF trim(NEW.consfi)::VARCHAR = '''' THEN
   NEW.consfi := NULL;
END IF;
IF trim(NEW.filpre)::VARCHAR = '''' THEN
   NEW.filpre := NULL;
END IF;
IF trim(NEW.filent)::VARCHAR = '''' THEN
   NEW.filent := NULL;
END IF;
IF trim(NEW.filgui)::VARCHAR = '''' THEN
   NEW.filgui := NULL;
END IF;
IF trim(NEW.tiptra)::VARCHAR = '''' THEN
   NEW.tiptra := NULL;
END IF;
IF trim(NEW.seqfat)::VARCHAR = '''' THEN
   NEW.seqfat := NULL;
END IF;
IF trim(NEW.numcon)::VARCHAR = '''' THEN
   NEW.numcon := NULL;
END IF;
IF trim(NEW.filtra)::VARCHAR = '''' THEN
   NEW.filtra := NULL;
END IF;
IF trim(NEW.filfat)::VARCHAR = '''' THEN
   NEW.filfat := NULL;
END IF;
IF trim(NEW.filcob)::VARCHAR = '''' THEN
   NEW.filcob := NULL;
END IF;
IF trim(NEW.codtra)::VARCHAR = '''' THEN
   NEW.codtra := NULL;
END IF;
IF trim(NEW.codgui)::VARCHAR = '''' THEN
   NEW.codgui := NULL;
END IF;
IF trim(NEW.lanven)::VARCHAR = '''' THEN
   NEW.lanven := NULL;
END IF;
IF trim(NEW.marcas)::VARCHAR = '''' THEN
   NEW.marcas := NULL;
END IF;
IF trim(NEW.vincul)::VARCHAR = '''' THEN
   NEW.vincul := NULL;
END IF;
IF trim(NEW.export)::VARCHAR = '''' THEN
   NEW.export := NULL;
END IF;
IF trim(NEW.observ)::VARCHAR = '''' THEN
   NEW.observ := NULL;
END IF;
IF trim(NEW.modnot)::VARCHAR = '''' THEN
   NEW.modnot := NULL;
END IF;
IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.insest)::VARCHAR = '''' THEN
   NEW.insest := NULL;
END IF;
IF trim(NEW.ufnota)::VARCHAR = '''' THEN
   NEW.ufnota := NULL;
END IF;
IF trim(NEW.avista)::VARCHAR = '''' THEN
   NEW.avista := NULL;
END IF;
IF trim(NEW.docnfp)::VARCHAR = '''' THEN
   NEW.docnfp := NULL;
END IF;
IF trim(NEW.chavea)::VARCHAR = '''' THEN
   NEW.chavea := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_ven_fis
BEFORE INSERT OR UPDATE ON tw_ven_fis
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_ven_fis();



/*-- SEQ 6509 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_vres() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.numdoc)::VARCHAR = '''' THEN
   NEW.numdoc := NULL;
END IF;
IF trim(NEW.tipreg)::VARCHAR = '''' THEN
   NEW.tipreg := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_vres
BEFORE INSERT OR UPDATE ON tw_vres
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_vres();



/*-- SEQ 6510 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_wor() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_wor
BEFORE INSERT OR UPDATE ON tw_wor
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_wor();



/*-- SEQ 6511 --*/
CREATE OR REPLACE FUNCTION TR_TESTENULL_tw_worxwor() RETURNS TRIGGER AS '
BEGIN

IF trim(NEW.codfil)::VARCHAR = '''' THEN
   NEW.codfil := NULL;
END IF;
IF trim(NEW.sequen)::VARCHAR = '''' THEN
   NEW.sequen := NULL;
END IF;
IF trim(NEW.filwor)::VARCHAR = '''' THEN
   NEW.filwor := NULL;
END IF;
IF trim(NEW.seqwor)::VARCHAR = '''' THEN
   NEW.seqwor := NULL;
END IF;

RETURN NEW;

END;
' language 'plpgsql';

CREATE TRIGGER _TESTENULL_tw_worxwor
BEFORE INSERT OR UPDATE ON tw_worxwor
FOR EACH ROW EXECUTE PROCEDURE TR_TESTENULL_tw_worxwor();



/*-- SEQ 6512 --*/ 
SELECT DISABLETRIGGERS(LOWER('TT_OUT'));

/*-- SEQ 6513 --*/
DELETE FROM TT_OUT;

/*-- SEQ 6514 --*/
-- Atualizando CODTAB = CAM
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('CAM',0,AGORA(),'select CODMOE, VLRREF, CAST(TO_CHAR(DATREF,"DD/MM/YYYY") AS VARCHAR(10)) AS DATREF
from TT_CAM');

/*-- SEQ 6515 --*/
-- Atualizando CODTAB = GRAC 
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('GRAC',0,AGORA(),'SELECT CAST(rpad( COALESCE(FILMAT ,"")|| COALESCE(CODMAT ,"")|| "-" || COALESCE(TO_CHAR(CODCOR),"")|| "-" || COALESCE(TO_CHAR(CODTAM),""), 21," " ) AS VARCHAR(21)) as CHAVEPRO,
TIPCAR, PROTEF, CODFIL, SEQUEN
from TT_GRAXDCAR');

/*-- SEQ 6516 --*/
-- Atualizando CODTAB = CFG
-- Registro de carga completa 
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('CFG',0,AGORA(),'SELECT CAST(TO_CHAR( AGORA(), "DD/MM/YYYY") AS VARCHAR(10)) AS DATOPE,
       CAST(CFG.VC_FILCLI || CFG.VC_CODCLI AS VARCHAR(9)) AS CHAVECLI,
       CAST(CFG.VC_FILPGT || CFG.VC_CODPGT AS VARCHAR(6)) AS CHAVEPGT,
       CAST(CASE CFG.VC_SERIE WHEN "CF" THEN "  "
                                   ELSE CFG.VC_SERIE
       END AS VARCHAR(2)) AS CHAVESERIE,
       CFG.REDICMFRE, CFG.ARREDONDAC,CFG.SINGULINT, CFG.PLURALINT, CFG.SINGULDEC,
       CFG.PLURALDEC, CFG.NOMEMP, CFG.FILPRE,
       CFG.CODPRE,
       CAST("N" AS CHAR(1)) as subser, CAST(TRIM(TO_CHAR(IDF.VERBAS,"999")) AS CHAR(3)) AS VERBAS,
       CFG.CHEQUEMINIMO as LIMCHQ,CFG.USADOC,CFG.CC_CHECKOUT AS PaCC_CheckOut,
       CFG.CC_WORKFLOW,
       CFG.PATIPODESCONTO,
       LIM_SAQUE_CC AS PaLimSaqueCC,
       TIPPOS AS Posto,
       TIPFAR AS Farmacia,
       VldCliExt AS ValidaClienteExterno,
       CAST(CFG.FILCTA_TRN || CFG.SEQCTA_TRN || CFG.TIPCTA_TRN AS VARCHAR(14)) as PaCtaTranf,
       CFG.CODNAT_REIMP_CF,
       -1 as PaValeTroca,
       -2 as PaBonus,
       TPR.NPR_DATMIN,TPR.NPR_DATMAX,TPR.NPR_FILPRE,TPR.NPR_CODPRE,
       CFG.VENDE_DESATIVADOS,
       CFG.CKBEMVINDO,CFG.CKNOMATEND,CFG.CKVlrInfUN,CFG.CKUsaBalAN,CFG.CKNumExtDp,
       CFG.CKPANumExt,CFG.CKPaObrVen,CFG.CKPaQtdDec,CFG.CKPaPreDec,CFG.CKPaDiasAt,
       CFG.CKPaAgrupa,CFG.CKPaConsFi,CFG.CKUsaDebAp,CFG.CKPaPagIrr,CFG.CKPaVlrIrr,
       CFG.CKPrecoSub,CFG.CKPaSaiChe,CFG.CKPaMfImpP,
       CFG.CKPaDigChe,CFG.CKPaPreDoc,CFG.CKPaVlrApr,CAST("O" AS CHAR(1)) as CKPaObrCar,CFG.CKPaSaiCai,
       CFG.CKPaUniCai,CFG.CKPaQtdAut,CFG.CKPATxtPre,CAST(CFG.CKPAVenIte AS VARCHAR(4000)) as BONITECLI,
       CAST(CFG.CKPaTotVen AS VARCHAR(4000)) as BONVENCLI,
       CFG.CKPaDescIt,CFG.CKPaDescTo,CFG.CKFTxtSub1,CFG.CKFTxtSub2,CFG.CKFTxtSub3,
       CFG.CKFTxtSub4,CFG.CKFORComIt,CFG.CKFORComV1,CFG.CKFORComV2,CFG.CKFORComS1,
       CFG.CKFORComS2,CFG.CKFORComS3,CFG.CKFORComS4,CFG.CKPaComL1,CFG.CKPaComL2,
       CFG.CKPaComL3,CFG.CKPaComL4,
       CFG.E_MAIL_FINANC,CFG.DEPOSITA_CHETRO,
       CFG.CICLOPRE,CFG.SERIE_FAT_CC,
       CFG.PaPhoto,
       CFG.PaPhoDuplo,
       CFG.PaPhoAmplia as PaPhoPosAmp,
       CFG.PaPhoTempo,
       CFG.PaPhoEtiqueta,
       CFG.PaPhoFor1,
       CFG.PaPhoForS,
       CFG.PaPhoVar1,
       CFG.PaPhoVar2,
       CFG.PaPhoVar3,
       CFG.PaPhoObsPadrao,
       CFG.PAPHOTIPLAN,
       PaListaDebitos,
       CFG.CC_DEVOLUCAO,CFG.MEIO_TAXASERVICO,CFG.ACAO_DEVOLUCAO,
       CFG.PaPreDatarConsumidor,
       CAST(CASE WHEN MEIO_TAXASERVICO IS NULL THEN "F" ELSE "T" END AS CHAR(1)) AS USA_TAXASERVICO,
       CFG.NF_APOS_CF AS NFAPOSCF,
       CFG.RESTRICAO_VINCULO,
       CFG.CheckOut_VerMin,
       CFG.CheckOut_RelMin,
       CFG.RECPAR_DEVOLUCAO, CFG.E_MAIL_ERRO, CFG.CKDESCECF, CFG.CKTXTPROMISSORIA,
       CAST((SELECT MER.FILCTA || MER.SEQCTA || MER.TIPCTA FROM TD_CTA MER WHERE MER.CFGCOL = "TIPCTA_MER_REV") AS VARCHAR(14)) as PaCtaCompra,
       CFG.CkPaMFL1, CFG.CkPaMFL2, CFG.CkPaMFL3, CFG.CkPaMFL4,CC_CredFornecedor,
       CFG.NAT_CREICM,CFG.FILSRV,CFG.CODSRV,CFG.TIPSRV,CFG.VLDORC, CFG.MEIO_ABATIMENTO,
       CFG.CKNEGATIVO,CFG.ARREDONPAR,
       CFG.CKFORDES,CFG.SOLICITA_END_CF,CFG.PLACAABERTURA,IDF.VERSEG, CFG.NAT_CONSIGNACAO,
              cast("P" as char(1)) as BANCO_ANSI  FROM TT_CFG CFG, TT_IDF IDF,
      (SELECT 0 AS DUMMY FROM DUAL) DUAL LEFT OUTER JOIN
      (SELECT 0 AS DUMMY,
             MIN(DATMIN) AS NPR_DATMIN,
             MIN(DATMAX) AS NPR_DATMAX,
             CODFIL AS NPR_FILPRE,
             CODPRE AS NPR_CODPRE
        FROM TT_TPR
       WHERE ( (ESTADO IS NOT NULL) OR (FILDES IS NOT NULL) )
         AND (CODFIL,CODPRE) NOT IN (SELECT FILPRE,CODPRE FROM TT_CFG)
         AND DATMIN > TRUNC(AGORA())
             GROUP BY CODFIL,CODPRE) TPR ON DUAL.DUMMY = TPR.DUMMY LIMIT 1 ');

/*-- SEQ 6517 --*/
-- Atualizando CODTAB = CFG2
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('CFG2',0,AGORA(),
'SELECT CFG.MIN_ABASTEC_CHEQUE, CFG.CKPAPESQIDENT, CFG.MAXDIAREC, CFG.CFOPPERDAS, CFG.IMPEDE_ALTERACAO_PEDIDO, CFG.CkPaRecFilial, CFG.CKSANGRIANEGATIVA, CKTrocaChrADepositar,
        CAST(CFG.TRANSFER_CODCFO AS VARCHAR(5)) AS TRANSFER_CODCFO, CFG.CK_FECHA_VALOR_CONTADO,
        CAST((SELECT FILCTA||SEQCTA||TIPCTA FROM TD_CTA WHERE CFGCOL = "GETNET") AS VARCHAR(14)) AS CTA_GETNET,
        CFG.ENVIAR_ENTREGA, CFG.NATFAT, CFG.NATVEN, CFG.CC_CARTAFRETE, CFG.USA_PREATENDIMENTO,
        CFG.PER_CPMF,CFG.TAXA_TEF_NO_PRECO,CFG.CUSTO_LIGACAO,CFG.TROCO_TEF,CFG.VENDA_CC_E_OUTROS,
        CFG.CUSTOFINMENSAL,CFG.DIAS_TEF_NO_PRECO,CFG.TAXCRE_PREATEND,CFG.DIACRE_PREATEND,CFG.TAXDEB_PREATEND,
        CFG.DIADEB_PREATEND, CFG.CKBLOQREFBAS,CAST(CFG.CC_VALE_PRESENTE AS VARCHAR(5)) AS CC_VALE_PRESENTE,CFG.PER_TROCA_CHEQUE,
        CAST((SELECT FILCTA||SEQCTA||TIPCTA FROM TD_CTA WHERE CFGCOL = "TAXA_TRO_CHEQUE") AS VARCHAR(14)) AS CTA_TAXTRO,
        CFG.PAFECF_NROLAU, CFG.PAFECF_NOMCOM, CFG.PAFECF_PRIARQ, CFG.PAFECF_PRIARQ_MD5 AS PAFECF_MD5, CFG.PAFECF_OUTARQ, CFG.PAFECF_ASSINA, CFG.VALIDA_NUMDOC, CFG.TIPSOFT,
        CAST(CFG.DEVTRA_NAT AS VARCHAR(5)) AS DEVTRA_NAT, CAST(CFG.DEVTRA_CFO AS VARCHAR(5)) AS DEVTRA_CFO, CFG.HOR_SERASA, CFG.DIAS_ULTCOM, CFG.VALIDA_PARC_CK,
        CAST(CFG.TIPRTT_AGENC AS VARCHAR(5)) as TIPRTT_AGENC, CAST(CFG.MEIO_ESTAC AS VARCHAR(5)) as MEIO_ESTAC, CAST(CFG.CKPANUMEXT_NAO_DAV AS VARCHAR(1)) as NUMEXTNDAV,
        CAST(CFG.CKPANUMEXT_DEP AS VARCHAR(1)) as NUMEXT_DEP, CAST(CFG.ENTREGA_CF AS VARCHAR(1)) as ENTREGA_CF, CAST(CFG.TIPRTT_ESTAC AS VARCHAR(5)) as TIPRTT_ESTAC,
        CAST(CFG.DEST_ST_DEV AS VARCHAR(1)) as DEST_ST_DEV, CAST(CFG.BOLETO_EMAIL AS VARCHAR(1)) as BOLETO_EMAIL, CAST(CFG.CKPACANHOTONFE AS VARCHAR(4000)) as CKPACANHOTONFE,
        CAST(CFG.PATH_ARQUIVOS AS VARCHAR(200)) AS PATH_ARQUIVOS, CAST(CFG.VENDA_ESTRANGEIRO AS VARCHAR(1)) as VENDA_ESTRANGEIRO, CFG.DEV_FATVIN,
        CFG.CKPAVALABE, CAST(CFG.CKPAFILDAV AS VARCHAR(1)) AS CKPAFILDAV, CAST(CFG.SEPARAR_ENTREGA AS VARCHAR(1)) AS SEPARAR_ENTREGA,
        CFG.CKPACONFERE_DAV AS CONFEREDAV, CFG.CKPAAUT_DEV_FRETE AS AUTDEVFRET, CFG.TRANSPICM, CFG.NATBON, CFG.NATDECTRA, CFG.LIM_TIPTOL, CFG.LIM_PERTOL, CFG.LIM_VALTOL,
        CAST(CFG.VDD_CKPAVENITE AS VARCHAR(4000)) AS BONITEVDD, CAST(CFG.VDD_CKPATOTVEN AS VARCHAR(4000)) AS BONVENVDD, CAST(CFG.IND_CKPAVENITE AS VARCHAR(4000)) AS BONITEIND,
        CAST(CFG.IND_CKPATOTVEN AS VARCHAR(4000)) AS BONVENIND, CAST(CFG.CFCONTRIPJ AS VARCHAR(1)) AS CFCONTRIPJ, CFG.TIPRTT_RCEL AS TIPRTT_RCE, CAST(CFG.USA_DCAI_0 AS VARCHAR(1)) AS USA_DCAI_0,
        CFG.BLQ_CF_RETIRA_DEPOSITO AS BLQCFRETDP, CFG.CLIREVSEMIE AS REVSEMIE, CFG.DEVCOMPRANFEIMPOSTO AS NFEIMPOSTO, CFG.NATRESSARCIMENTOST AS NATRESSAST, CFG.NATADJUDICACAOICMS AS NATAJUICMS,
        CAST(RPAD(COALESCE(CFG.FILMAT_AUX, "")||COALESCE(CFG.CODMAT_AUX, "")||"-"||COALESCE(TO_CHAR(CFG.CODCOR_AUX),"")||"-"||COALESCE(TO_CHAR(CFG.CODTAM_AUX),""), 21, " ") AS VARCHAR(21)) AS PRODUTOAUX,
        CFG.NATDEVCOMP, CFG.SEMESTLOTE, CFG.TAMCODLOTE, CAST(TO_CHAR(CFG.TRANSFER_NAT) AS VARCHAR(5)) AS NATTRANSF, CFG.PERIPITRA, CFG.PERIPIATA, CFG.SEPMAIOR,
        CFG.PREZER, CAST((SELECT MIN(CODSER) FROM TD_SER WHERE SERATI = "T" AND MODNOT = 65) AS CHAR(2)) AS SERIECFE, CFG.IMPPREVENT, CFG.SERSAT, CFG.PERPARICM,
        CFG.ST_PRIPAR, CAST((SELECT MIN(CODSER) FROM TD_SER WHERE SERATI = "T" AND MODNOT = 59) AS CHAR(2)) AS SERIESAT, CFG.SISDFE, CFG.RECEBE_CC_INDIVIDUAL AS RECCCINDIV, CFG.OBRPESO, CFG.OBRVOL,
        CFG.DEST_ST_INFFISCO AS DESTSTINF, CAST(CFG.CC_RESTSAV AS VARCHAR(5)) AS CC_RESTSAV
   FROM TT_CFG CFG');

/*-- SEQ 6518 --*/
-- Atualizando CODTAB = CLI
-- RFMP 76140 Coluna DIVIDA foi mantida apenas por compatibilidade na carga. No Checkout o valor vem da TV_RES.
-- Rhuan - 97314 - Criada view TV_CLI_OUT para carga de clientes
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('CLI',0,AGORA(),
'SELECT CHAVECLI,CHAVEVIN,CHAVEPLA,CODEXT,NUMDOC,TRANSP,PARNUM,OBSERV,DATNAS,DATOPE,
        ULTCOM,ATIVO,DIVIDA,CODFID,PERFID,NOMCLI,ULTNOM,ESTCIV,FLGTIP,SUFRAM,
        INSEST,CODSEX,CONJUG,VALOR1,TOTATR,TOTPAR,MAIATR,IMPRIM,CATEG1,ATU_EM,SIMPLE,REGMEI,
        E_MAIL,CATEG3,CODNAE,CCCPRE,TIPDOC,ID_DAT,ID_ORG,ID_EST,GLOBAL,ESTRAN,ISENTO,
        PRAZOCARFRE,LIMCHE,ISECHE,NAODIV,DETTIP,DATCRE,ENTISE,FILEND,NUMEND,CODGUI,
        DDDCEL,NUMCEL,E_MFIN,CODPAI,MAXBON,COD_RNTC,FIL_CK,ECF_CK,COD_CK,
        EXPTOD,EXPORTA,FILCLI,CODCLI,CHV_FILCLI,CHV_CODCLI,CONTRIBUINTE
  FROM TV_CLI_OUT CLI
--FILTRO - Ignorado deste ponto para baixo na carga simplificada
 WHERE (CLI.EXPTOD = "T" OR
        CLI.FLGTIP = 5 OR
        (CLI.CHAVECLI = (SELECT VC_FILCLI||VC_CODCLI FROM TT_CFG)) OR
        TipoParceiro(SUBSTR(CLI.CHAVECLI,1,3),SUBSTR(CLI.CHAVECLI,4,6), "F") = "T" OR
        CLI.ATIVO="T")
   AND COALESCE(CLI.EXPORTA,1)>0 ');

/*-- SEQ 6519 --*/
-- Atualizando CODTAB = CPM
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('CPM',0,AGORA(),'SELECT CAST(rpad( COALESCE(PRE.FILMAT ,"")|| COALESCE(PRE.CODMAT ,"")|| "-" || COALESCE(TO_CHAR(PRE.CODCOR),"")|| "-" || COALESCE(TO_CHAR(PRE.CODTAM),""), 21," " ) AS VARCHAR(21)) as CHAVEPRO,
       CAST(COALESCE(CPM.FILPGT ,"")|| COALESCE(CPM.CODPGT ,"") AS VARCHAR(6)) AS CHAVEPGT, CPM.FILPRO AS FILDES, TPR.ESTADO,
       CPM.PRECOP, CAST(TO_CHAR(CPM.DATVAL,"DD/MM/YYYY") AS VARCHAR(10)) AS DATVAL, CPM.FILLOT, CPM.SEQLOT,
       PRE.FILPRE, PRE.CODPRE, CPM.QTDMIN, CPM.CLILEV, CPM.TEMDES, CPM.DATINI, CAST(CPM.FILCPM || CPM.SEQUEN AS VARCHAR(13)) AS CHAVECPM
  FROM TT_PRE PRE INNER JOIN TT_CPM CPM ON PRE.FILPRE = CPM.FILPRE AND PRE.SEQUEN = CPM.SEQPRE
                  INNER JOIN TT_TPR TPR ON TPR.CODFIL = PRE.FILPRE AND TPR.CODPRE = PRE.CODPRE
 WHERE TRUNC(AGORA()) BETWEEN COALESCE(CPM.DATINI,TO_DATE("01/01/1900","DD/MM/YYYY")) AND CPM.DATVAL AND COALESCE(QTDCPM,0) <= 0');

/*-- SEQ 6520 --*/
-- Atualizando CODTAB = DES
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('DES',0,AGORA(),'SELECT * FROM TT_DESxDCCC');

/*-- SEQ 6521 --*/
-- Atualizando CODTAB = DOP
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('DOP',0,AGORA(),'SELECT CTB.CODBCO,
       CTB.NUMAGE,
       CTB.CTACRR,
       DOP.NUMDOC,
       DOP.VLRDOC
  FROM TT_DOP DOP INNER JOIN TT_CTB CTB ON DOP.FILCTA = CTB.FILCTA AND DOP.SEQCTA = CTB.SEQCTA AND DOP.TIPCTA = CTB.TIPCTA
 WHERE DOP.FLGEST = "C"');

/*-- SEQ 6522 --*/
-- Atualizando CODTAB = EAN
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('EAN',0,AGORA(),'select CAST(rpad( COALESCE(ean.FILMAT ,"")|| COALESCE(ean.CODMAT ,"")|| "-" ||
                COALESCE(TO_CHAR(ean.CODCOR),"")|| "-" || COALESCE(TO_CHAR(ean.CODTAM),""), 21, " " ) AS VARCHAR(21)) as CHAVEPRO,
       ean.CODEAN, dean.usaven, ean.usoean
  from tt_ean ean INNER JOIN td_ean dean ON ean.usoean = dean.codtab');

/*-- SEQ 6523 --*/
-- Atualizando CODTAB = ECF
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('ECF',0,AGORA(),'SELECT
       FIL.CODFIL, FIL.RAZSOC, FIL.CGCFIL,
       FIL.ENDERE, FIL.NUMERO, FIL.COMPLE, FIL.BAIRRO,
       FIL.DDDFIL, FIL.FONFIL, FIL.FAXFIL,
       FIL.CODCID, FIL.CODIBG, FIL.CODCEP, COALESCE(IBG.NOMMUN,MUN.NOMCID) AS CIDADE, COALESCE(IBG.SIGEST,MUN.SIGEST) AS ESTADO,
       CAST(CASE WHEN (SELECT PAPHOTO FROM TT_CFG) = "T" THEN NULL
                 ELSE SUBSTR(COALESCE(CTR.PATPED,FIL.PATPED),1,254) END AS VARCHAR(254)) AS PATPED,
       CAST(SUBSTR(FIL.PAT_AA,1,254) AS VARCHAR(254)) AS PAT_AA,
	   CAST(SUBSTR(FIL.PATCAR,1,254) AS VARCHAR(254)) AS PATCAR,
	   CAST(SUBSTR(FIL.PATTKE,1,254) AS VARCHAR(254)) AS CKPATHTKE,
       FIL.FILTRN, FIL.SEQTRN, FIL.TIPTRN,
       ECF.NUMECF,
       CAST(CASE INSTR(UPPER(ECF.SERECF),"INDEFINIDO") WHEN 0 THEN ECF.SERECF
                                                                     ELSE NULL
       END AS VARCHAR(25)) AS NUMSER,
       CTA.CODFIL AS FILCTA, CTA.SEQUEN AS SEQCTA, CTA.TIPCTA,
       FIL.TESFIL AS FILABE, FIL.TESSEQ AS SEQABE, FIL.TESTIP AS TIPABE,
       FIL.TESFIL AS FILFEC, FIL.TESSEQ AS SEQFEC, FIL.TESTIP AS TIPFEC,
       FIL.TESFIL AS FILTRO, FIL.TESSEQ AS SEQTRO, FIL.TESTIP AS TIPTRO,
       FIL.TESFIL AS FILDIF, FIL.TESSEQ AS SEQDIF, FIL.TESTIP AS TIPDIF,
       ECF.PORECF, COB.TIPCOB, COB.COBPAD,
       ECF.CODMUL, ECF.ECFMFA, ECF.ECFTIP, ECF.ECFCOL,
       ECF.SAIENV,
       CAST(TO_CHAR(ECF.CODCTR) AS VARCHAR(5)) AS CODCTR,
       FIL.PATCON,ECF.MAQECF, ECF.ECFUTL, ECF.TNCIEE, ECF.MAXCAI, ECF.FLGCFE, ECF.DECF_NUMEXT AS DECFNUMEXT,
       FIL.PORRET, FIL.TIPCOBRET
  FROM TD_ECF ECF INNER JOIN TD_COB COB ON ECF.PORECF = COB.CODTAB AND ECF.COBECF = COB.TIPCOB
                  INNER JOIN TT_CTA CTA ON COB.FILCTA = CTA.CODFIL AND COB.SEQCTA = CTA.SEQUEN
                  INNER JOIN TD_FIL FIL ON ECF.FILECF = FIL.CODFIL
                  INNER JOIN TT_MUN MUN ON FIL.CODCID = MUN.CODIGO
                  LEFT OUTER JOIN TT_IBG IBG ON IBG.CODIBG = FIL.CODIBG
		  LEFT  JOIN TD_CTR CTR ON ECF.CODCTR = CTR.CODTAB');

/*-- SEQ 6524 --*/
-- Atualizando CODTAB = END
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('END',0,AGORA(),'
SELECT /*+INDEX(CLI,PK_CLI)*/
       CAST(ENDE.FILCLI||ENDE.CODCLI AS VARCHAR(9)) AS CHAVECLI,
       ENDE.CODFIL,ENDE.NUMEND,
       DEND.DESEND AS APEEND,
       ENDE.ENDCOB,ENDE.ENDCOR,ENDE.NUMDOC,ENDE.INSEST,
       CAST(LTRIM(RTRIM(COALESCE(ENDE.ENDERE,""))) AS VARCHAR(60)) AS ENDERE,
       ENDE.COMPLE,
       ENDE.CODCEP,ENDE.CODDDD,ENDE.NUMFON,ENDE.NUMFAX,ENDE.LOCTRA,ENDE.REGIAO,
       ENDE.FLGNAC,ENDE.ESTRAN,ENDE.CODLOG,ENDE.NUMERO,ENDE.BAIRRO,ENDE.NOMCID,ENDE.SIGEST,ENDE.USA_NF,
       ENDE.SIGNAT, ENDE.NOMREC,
       (SELECT CAST(MIN(TIPLOG) AS VARCHAR(15))
          FROM TT_LOG
         WHERE CODCEP = CAST(TRIM(ENDE.CODCEP||ENDE.CODLOG) AS CHAR(8))) AS TIPLOG, ENDE.CODPAI,
       ENDE.FIL_CK, ENDE.ECF_CK, ENDE.COD_CK, COALESCE(ENDE.CODIBG, MUN.CODIBG) AS CODIBG
FROM TT_END ENDE INNER JOIN TT_CLI CLI  ON ENDE.FILCLI = CLI.FILCLI AND ENDE.CODCLI = CLI.CODCLI
                 LEFT JOIN TD_END DEND ON DEND.CODTAB = ENDE.TIPEND
                 LEFT JOIN TT_MUN MUN  ON MUN.CODIGO = ENDE.CODCID
                 CROSS JOIN TT_CFG CFG
--FILTRO - Ignorado deste ponto para baixo na carga simplificada
WHERE (CFG.EXPORTA_TODOS_CLIENTES = "T"
OR CLI.FLGTIP = 5
OR (ENDE.FILCLI||ENDE.CODCLI = (SELECT VC_FILCLI||VC_CODCLI FROM TT_CFG))
OR TipoParceiro(SUBSTR(ENDE.FILCLI||ENDE.CODCLI,1,3),SUBSTR(ENDE.FILCLI||ENDE.CODCLI,4,6), "F") = "T"
OR TipoParceiro(SUBSTR(ENDE.FILCLI||ENDE.CODCLI,1,3),SUBSTR(ENDE.FILCLI||ENDE.CODCLI,4,6), "T") = "T"
OR COALESCE(CLI.SIGNAT,0)>=0)');

/*-- SEQ 6525 --*/
-- Atualizando CODTAB = FIL
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('FIL',0,AGORA(),
'SELECT FIL.CODFIL, FIL.UFLOJA, FIL.NOMFIL, FIL.RAZSOC, FIL.REGTRI, FIL.RED_CF, FIL.ACR_CF,
        CAST(FIL.ENDERE||", "||FIL.NUMERO AS VARCHAR(52)) AS ENDERE, FIL.COMPLE, CAST(SUBSTR(FIL.CODCEP,1,5) AS VARCHAR(5)) AS CODCEP, CAST(SUBSTR(FIL.CODCEP,6,3)AS VARCHAR(3)) AS CODLOG,
        FIL.FONFIL AS NUMFON, FIL.DDDFIL AS CODDDD, MUN.NOMCID,
        FIL.IE_FIL AS INSEST, FIL.CGCFIL AS NUMDOC,
        FIL.PERPIS, FIL.PERCOF, FIL.VENPIS, FIL.VENCOF, FIL.PERSOC, FIL.LIMCOF, FIL.TIPBOM,
        CAST(TO_CHAR(FIL.DATCRE,"DD/MM/YYYY") AS VARCHAR(10)) AS DATCRE, FIL.REGESP, FIL.RE8020, FIL.BAIFIL, FIL.BAIOUT, FIL.SERPAD,
        FIL.PER_FIS_RURAL, FIL.PER_JUR_RURAL, FIL.BASICM_MAJ, FIL.SUBSTITUTA,FIL.PATIMGCHR,
        FIL.FILOUT, FIL.SEQOUT, FIL.TIPOUT, FIL.PATNOT, FIL.TRISIM, FIL.CKPANOMINA, FIL.CKPACIDCHE,
        FIL.PAFECF, FIL.PREVEN, FIL.DAVNFS, FIL.DAVFIS, FIL.ASSINA, FIL.BAIRRO, FIL.ENDERE AS LOGRADOURO, FIL.NUMERO,
        CLI.CODNAE, FIL.INSMUN, FIL.PATNFE, DataEntradaSimples(SUBSTR(FIL.CGCFIL, 1, 8)) AS DATSIM, FIL.PERCRE, COALESCE(FIL.ALISIM_ICMS, 0) AS ALISIM_ICMS,
        FIL.CK_VEN_CMB_EST_ZER, FIL.FILVEN, FIL.CODVEN, FIL.QTDABAST, FIL.PEROPEFIX, COALESCE(FIL.CODDEP,FIL.CODFIL) AS CODDEP, FIL.CREDDF,
        FIL.FILENT_REGESP, FIL.PERCOMSUG, FIL.TIPCOM, FIL.DESIPI, FIL.DESIPITRA, FIL.SERDEV, FIL.SERTRA, FIL.USAPARICM, CNT.NUMDOC as CNT_NUMDOC, COALESCE(FIL.CODIBG,MUN.CODIBG) as CODIBG,
        FIL.SERIMP, FIL.PORRET, FIL.TIPCOBRET, FIL.SERNFRECI, FIL.TROCOTEF, FIL.SEGMENTO, FIL.IP_MIDDLE, FIL.PORTA_MIDDLE,
        FIL.NF_CON, FIL.RETSOC, FIL.PER_FIS_SENAR AS SENAR_PF, FIL.PER_JUR_SENAR AS SENAR_PJ,
        CAST(FIL.SISDFE AS VARCHAR(1)) AS SISDFE, FIL.PER_SEGRUR, FIL.SERCFE AS SERIECFE, FIL.SERSAT AS SERIESAT
   FROM TD_FIL FIL LEFT OUTER JOIN TT_MUN MUN ON MUN.CODIGO = FIL.CODCID
                   LEFT JOIN TT_CLI CLI ON CLI.FILCLI = FIL.CODFIL
                                       AND CLI.CODCLI = "     0"
                   LEFT JOIN TT_CLI CNT ON CNT.FILCLI = FIL.FILCNT AND CNT.CODCLI = FIL.CODCNT ');

/*-- SEQ 6526 --*/
-- Atualizando CODTAB = FOR
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('FOR',0,AGORA(),
'SELECT CAST(MIN(CLI.NOMCLI) AS VARCHAR(64)) AS NOMCLI,
        CAST(MIN(CLI.ULTNOM) AS VARCHAR(30)) AS ULTNOM,
        CAST(MIN(CLI.NUMDOC) AS CHAR(15)) AS NUMDOC,
        CAST(MIN(CLI.INSEST) AS VARCHAR(15)) AS INSEST,
        CAST(MIN(CLI.FILCLI || CLI.CODCLI) AS VARCHAR(9)) as CHAVEFOR,
        CAST(MAX(REL.TIPPAR) AS CHAR(1)) AS TRANSP,
        MIN(FRM.FORMUL) AS FORMUL,
        CAST(TO_CHAR(MAX(ATU_EM),"DD/MM/YYYY HH24:MI:SS") as VARCHAR(21)) AS ATU_EM
   FROM TT_REL REL INNER JOIN TT_CLI CLI ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI = REL.CODPAR
                    LEFT JOIN TT_FRM FRM ON FRM.FILCLI = REL.FILPAR AND FRM.CODCLI = REL.CODPAR
  WHERE REL.TIPPAR IN ("F","T","M")
  GROUP BY REL.FILPAR, REL.CODPAR');

/*-- SEQ 6527 --*/
-- Atualizando CODTAB = GUI
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('GUI',0,AGORA(),'SELECT CAST(COALESCE(REL.FILPAR,"")||LPAD(LTRIM(COALESCE(REL.CODPAR,"")),6," ") AS VARCHAR(9)) AS CODGUI,
       CLI.NOMCLI as NOMGUI,CLI.ULTNOM,CLI.NUMDOC
FROM TT_CLI CLI INNER JOIN TT_REL REL ON CLI.FILCLI = REL.FILPAR AND CLI.CODCLI = REL.CODPAR
 WHERE REL.TIPPAR = "I"');

/*-- SEQ 6528 --*/
-- Atualizando CODTAB = IMG
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('IMG',0,AGORA(),'SELECT DISTINCT COALESCE(NOMIMG,IMGDEP) AS IMAGEM
 FROM TT_PRO PRO LEFT OUTER JOIN TD_DEP DEP ON PRO.DEPART = DEP.CODTAB
WHERE COALESCE(NOMIMG,IMGDEP) IS NOT NULL
  AND PRO.SIGNAT >= 0');

/*-- SEQ 6529 --*/
-- Atualizando CODTAB = IMU
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('IMU',0,AGORA(),'SELECT CAST(COALESCE(A.FILMAT,"")||COALESCE(A.CODMAT ,"") AS VARCHAR(8)) as CHAVEPRO,
       A.CODCID,
       B.RESISS AS PERISS,
	    A.SITTRI,
       A.CODIBG
  FROM TD_ISS B INNER JOIN TT_IMU A ON A.RESISS = B.CODTAB');

/*-- SEQ 6530 --*/
-- Atualizando CODTAB = IUF
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('IUF',0,AGORA(),'SELECT CAST(COALESCE(IUF.FILMAT,"")||COALESCE(IUF.CODMAT ,"") AS VARCHAR(8)) as CHAVEPRO,
       IUF.ESTADO,
       FIS.CODFIS,IUF.CALSUB,
       ICM.RESICM AS PERICM,
       IES.ICMSES AS REDESP,
       IME.ICMSME AS REDUME,
       IRE.ICMSRE AS REDBAS,
       IRE.REDCON,
       IRE.REDTRA,
       IRE.APLCON AS APLCON,
       IR1.ICMSR1 AS REDGR1,
       IR2.ICMSR2 AS REDGR2,
       IUF.LUCSUB AS MARGST,
       IUF.SUBTRI AS TIPICM,
       IUF.INSAGR,
       TRI.CODTRI, 
       IUF.REGESP,
       IUF.MVAVEN,
       IUF.MVAC07,
       IUF.MVAC12,
       IUF.PERSRV, CAST(RPAD(coalesce(TO_CHAR(IUF.CODCFP)," "),5," ") AS VARCHAR(5)) AS CODCFP,
       IUF.ICMISE,
       IUF.REDSIM,
       IUF.FLGRED, 
       IUF.REGESPIMP,
       IUF.REDICM,
       IUF.REDINT,
       IUF.PERFCP, 
       IUF.CODBEN_00, IUF.CODBEN_10, IUF.CODBEN_20, IUF.CODBEN_30, IUF.CODBEN_40, IUF.CODBEN_41, 
       IUF.CODBEN_50, IUF.CODBEN_51, IUF.CODBEN_60, IUF.CODBEN_70, IUF.CODBEN_90, IUF.PERDIF,
	   IUF.REGDIF, DIF.RESICM AS ALIDIF 
  FROM TT_IUF IUF LEFT OUTER JOIN TD_IME IME ON IME.CODTAB = IUF.REDUME
                  LEFT OUTER JOIN TD_FIS FIS ON FIS.CODTAB = IUF.CODFIS
                  LEFT OUTER JOIN TD_IR2 IR2 ON IR2.CODTAB = IUF.REDUC2
                  LEFT OUTER JOIN TD_IR1 IR1 ON IR1.CODTAB = IUF.REDUC1
                  LEFT OUTER JOIN TD_IRE IRE ON IRE.CODTAB = IUF.REDALI
                  LEFT OUTER JOIN TD_IES IES ON IES.CODTAB = IUF.REDESP
                  LEFT OUTER JOIN TD_ICM ICM ON ICM.CODTAB = IUF.RESICM
                  LEFT OUTER JOIN TD_TRI TRI ON TRI.CODTAB = IUF.CODTRI
				  LEFT OUTER JOIN TD_ICM DIF ON DIF.CODTAB = IUF.ALIDIF');

/*-- SEQ 6531 --*/
-- Atualizando CODTAB = KIT
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('KIT',0,AGORA(),'SELECT CAST(RPAD(SUBSTR( COALESCE(FILMAT,"") || COALESCE(CODMAT,"") || "-" || COALESCE(CODCOR,0) || "-" || COALESCE(CODTAM,0), 1, 21),21) AS VARCHAR(21)) AS CHAVEMAT,
       CAST(RPAD(COALESCE(FILITE,"") || COALESCE(CODITE,"") || "-" || COALESCE(TO_CHAR(CORITE),"") || "-" ||COALESCE(TO_CHAR(TAMITE),""), 21, " ") AS VARCHAR(21)) AS CHAVEITE,
       QTDITE, NUMEXT_TINTA,
       TO_NUMBER(TRIM(CODITE)) AS ORDEM
  FROM TT_KIT
');

/*-- SEQ 6532 --*/
-- Atualizando CODTAB = LIM
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('LIM',0,AGORA(),'SELECT CAST(COALESCE(FILCLI,"")||COALESCE(CODCLI,"") AS VARCHAR(9)) AS CHAVECLI,
       TIPCCC,LIMCCC
  FROM TT_LIM');

/*-- SEQ 6533 --*/
-- Atualizando CODTAB = MUN
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('MUN',0,AGORA(),
'SELECT MUN.CODIGO, MUN.SIGEST, MUN.CEPINI, MUN.CODCEP, MUN.NOMCID, MUN.SIGNAT,
       MUN.CODIBG, CAST(TO_CHAR(MUN.ATU_EM,"DD/MM/YYYY HH24:MI:SS") as VARCHAR(21)) AS ATU_EM
  FROM TT_MUN MUN');

/*-- SEQ 6534 --*/
-- Atualizando CODTAB = NPR
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('NPR',0,AGORA(),'SELECT CAST(rpad( COALESCE(PRE.FILMAT ,"")|| COALESCE(PRE.CODMAT ,"")|| "-" || COALESCE(TO_CHAR(PRE.CODCOR),"")|| "-" || COALESCE(TO_CHAR(PRE.CODTAM),""), 21, " " ) AS VARCHAR(21)) AS CHAVEPRO,
       PRE.FILPRE,PRE.CODPRE,PRE.SEQUEN,
       PRE.PRECOV,
       PRE.CODMOE,PRE.FLGEST,PRE.ULTREA,
       PRE.DESMAX,PRE.MULTIP,TPR.ESTADO,
       TPR.FILDES,
       TPR.VAREJO,
       PRE.DESIDE
  FROM TT_PRE PRE
    INNER JOIN
      (SELECT MIN(DATMIN),CODFIL,CODPRE,FILDES,ESTADO, VAREJO
                     FROM TT_TPR
                    WHERE ( (ESTADO IS NOT NULL) OR (FILDES IS NOT NULL) )
                      AND (CODFIL,CODPRE) NOT IN (SELECT FILPRE,CODPRE FROM TT_CFG)
                      AND DATMIN > TRUNC(AGORA())
                    GROUP BY CODFIL,CODPRE,FILDES,ESTADO, VAREJO) TPR
     ON TPR.CODFIL = PRE.FILPRE AND TPR.CODPRE = PRE.CODPRE');


/*-- SEQ 6535 --*/
-- Atualizando CODTAB = PCLI
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('PCLI',0,AGORA(),'SELECT * FROM TP_CLI');

/*-- SEQ 6536 --*/
-- Atualizando CODTAB = PLA
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('PLA',0,AGORA(),'SELECT DESPGT, APEPGT, CODMOE, PRAMIN, PRAMAX, PRIMIN, PRIMAX, DE1MIN, DE1MAX,
       PARMIN, PARMAX, PERCOM, PERENT, COMSOB, FORMUL, PERIOD, PRAIDE, PRIIDE,
       DE1IDE, PARIDE, VLRMIN, VLRMAX, PZOMIN, PZOMAX, PZOIDE,NIVUSU, JURTOT,
       CARONL, ATRMAX, FLGESP, CODNAT, FATURA, PROPOR,
       CAST(TO_CHAR( DATMIN, "DD/MM/YYYY" ) AS VARCHAR(10)) AS DATMIN,
       CAST(TO_CHAR( DATMAX, "DD/MM/YYYY" ) AS VARCHAR(10)) AS DATMAX,
       CAST(COALESCE(FILPGT ,"")|| COALESCE(CODPGT ,"") AS VARCHAR(6)) AS CHAVEPGT,
       CODCOB, CARMAX, ACRDIA, FLGJUR,
       PORENT, PORDEM, usacam, usacre, usaout, usache, usadin, usatef, usac_c,
       CAST(CASE ABS(COALESCE(SIGNAT,0)) WHEN COALESCE(SIGNAT,0) THEN "T"
                                                            ELSE "F"
       END AS CHAR(1)) AS ATIVO,
       CODEXT,DIAANT,DESANT,CHRREC,DESREC,VLTXMU,INTPMU,USACPP,APLICA,BONPGT,
       ABAMIN,ABAMAX,
       CAST(TIPCCC AS VARCHAR(5)) AS TIPCCC,
       CATEG1, CATEG2, CATEG3, JURFLX, CAST(TO_CHAR(ATU_EM,"DD/MM/YYYY HH24:MI:SS") as VARCHAR(21)) AS ATU_EM,
       DIAFLX, ACRBOL, MINPAR, INDDES
  FROM TT_PLA
 where APLICA in (0,1,3,5)');

/*-- SEQ 6537 --*/
-- Atualizando CODTAB = PRE
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('PRE',0,AGORA(),'SELECT /*+ INDEX(PRE,PK_PRE)*/cast(rpad(COALESCE(PRE.FILMAT ,"") || COALESCE(PRE.CODMAT ,"") || "-" || COALESCE(TO_CHAR(PRE.CODCOR),"") || "-" || COALESCE(TO_CHAR(PRE.CODTAM),"") , 21, " " ) as VARCHAR(21)) AS CHAVEPRO,
       PRE.FILPRE,PRE.CODPRE,PRE.SEQUEN,
       PRE.PRECOV,
       PRE.CODMOE,PRE.FLGEST,CAST(TO_CHAR(PRE.ULTREA,"DD/MM/YYYY HH24:MI:SS") as VARCHAR(21)) AS ULTREA,
       PRE.DESMAX,PRE.MULTIP,TPR.ESTADO,
       TPR.CATEG1, TPR.CATEG2, TPR.CATEG3,
       TPR.FILDES,
       CAST(TO_CHAR(TPR.CODCTR) AS VARCHAR(5)) AS CODCTR,
       TPR.VAREJO,
       PRE.DESIDE
 FROM TT_TPR TPR INNER JOIN TT_PRE PRE ON PRE.FILPRE = TPR.CODFIL AND PRE.CODPRE = TPR.CODPRE
                 INNER JOIN TT_GRA GRA ON GRA.FILMAT = PRE.FILMAT
                                      AND GRA.CODMAT = PRE.CODMAT
                                      AND GRA.CODCOR = PRE.CODCOR
                                      AND GRA.CODTAM = PRE.CODTAM
                 INNER JOIN TT_PRO PRO ON PRO.FILMAT = GRA.FILMAT
                                      AND PRO.CODMAT = GRA.CODMAT
      ,TT_CFG CFG
WHERE (  ((SELECT PAPHOTO FROM TT_CFG)="F")
   OR (( PRE.FILMAT || PRE.CODMAT <> COALESCE((SELECT CFG.PAPHOFILREVELA || CFG.PAPHOCODREVELA FROM TT_CFG CFG)," "))
   AND ( PRE.FILMAT || PRE.CODMAT <> COALESCE((SELECT CFG.PAPHOFILREVAMP || CFG.PAPHOCODREVAMP FROM TT_CFG CFG)," "))
   AND ( PRE.FILMAT || PRE.CODMAT <> COALESCE((SELECT CFG.PAPHOFILAMPLIA || CFG.PAPHOCODAMPLIA FROM TT_CFG CFG)," "))) )
   AND ((CFG.VENDE_DESATIVADOS = "T") OR (GRA.GRAATI="T"))
   AND ((CFG.VENDE_DESATIVADOS = "T") OR (PRO.SIGNAT >= 0))
   AND TPR.SIGNAT >=0');

/*-- SEQ 6538 --*/
-- Atualizando CODTAB = PRO
-- Registro de carga completa
-- Pedro E. Braga - 103856 - Criada view TV_PRO_OUT para carga de produtos
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('PRO',0,AGORA(),'SELECT IPR.CHAVEPRO,IPR.PTOQTD,IPR.UNIDAD,IPR.UNIVEN,IPR.UNICOM,IPR.PERCOM,IPR.DESMAT,IPR.REFBAS,IPR.ESPMAT,IPR.MINQTD,
      IPR.DECIMA,IPR.VALCON,IPR.QTDMUL,IPR.CUSREP,IPR.PRECOM,IPR.DESMAX,IPR.OBSERV,IPR.PERLUC,IPR.NUMEXT,IPR.BRINDE,
      IPR.REFPRO,IPR.ITEDIV,IPR.ITESUB,IPR.DESECF,IPR.CODTRI,IPR.PRECOV,IPR.CODMOE,IPR.CLASS1,IPR.CLASS2,IPR.CLASS3,
      IPR.CLASS4,IPR.PERIPI,IPR.PERIRR,IPR.SERMAT,IPR.SEQUEN,IPR.FLGEST,IPR.IMAGEM,IPR.RETCOF,IPR.CHAVEMAR,IPR.DESMAR,
      IPR.CODGRA,IPR.ORDDIV,IPR.ORDSUB,IPR.BALSIM,IPR.CONTRO,IPR.TIPDOC,IPR.ICMFED,IPR.ARRTRU,IPR.IIPTPR,IPR.CODLPC,
      IPR.ATU_EM,IPR.IMPKIT,IPR.CODANP,IPR.CODNCM,IPR.SITCOF,IPR.SITPIS,IPR.COD_EX,IPR.SITIPI,IPR.CODSRV,IPR.CODFPS,
      IPR.CODSAL,IPR.FATCON,IPR.ORIPRO,IPR.PREFIS,IPR.TIPMPB,IPR.PESBRU,IPR.PESLIQ,IPR.BASSUB,IPR.VLR_ST,IPR.BASIPI,
      IPR.VLRIPI,IPR.VLRFRE,IPR.CODFCI,IPR.VLRPIS,IPR.VLRCOF,IPR.VENPIS,IPR.VENCOF,IPR.OBSMPB,IPR.FLGDEV,IPR.DESFRE,
      IPR.SUBFRE,IPR.USALOT,IPR.PERIND,IPR.CODFIS,IPR.CONFER,IPR.CODCES,IPR.CODENQ,IPR.FOR060,IPR.LOTONL,IPR.BASFCP,
      IPR.PERFCP,IPR.VLRFCP,IPR.PRE_DESIDE,IPR.VLRICM,IPR.DESGRA,IPR.QTDLIM_PJ,IPR.QTDLIM_PF,IPR.PROCON
 FROM TV_PRO_OUT IPR
CROSS JOIN TT_CFG CFG
WHERE 1 = 1
  AND ((CFG.VENDE_DESATIVADOS = "T") OR (IPR.SIGNAT >= 0))
  AND ((CFG.PAPHOTO="F")
   OR ((IPR.FILMAT || IPR.CODMAT <> COALESCE(CFG.PAPHOFILREVELA || CFG.PAPHOCODREVELA," "))
  AND (IPR.FILMAT || IPR.CODMAT <> COALESCE(CFG.PAPHOFILREVAMP || CFG.PAPHOCODREVAMP," "))
  AND (IPR.FILMAT || IPR.CODMAT <> COALESCE(CFG.PAPHOFILAMPLIA || CFG.PAPHOCODAMPLIA," "))))');

/*-- SEQ 6539 --*/
-- Atualizando CODTAB = REC
-- Registro de carga completa em PostgreSQL
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('REC',0,AGORA(),'
SELECT REC.NUMPAR, REC.SUBPAR, REC.VLRPAR, REC.CODMOE,
       CAST(TO_CHAR(REC.DATVEN,"DD/MM/YYYY") AS VARCHAR(10)) AS DATVEN,
       CAST(COALESCE(REC.CODFIL ,"")|| COALESCE(REC.SEQUEN ,"") AS VARCHAR(13)) AS CHAVEVEN,
       CAST(COALESCE(RPAD(VEN.CODSER,2) ,"")|| COALESCE(VEN.NUMECF ,"")|| COALESCE(VEN.NUMNOT ,"") AS VARCHAR(11)) AS CHAVEORI,
       COALESCE(REC.CODEXT,TIT.NOSNUM) AS NOSSON,
       CAST(CASE WHEN TIT.FILREC IS NULL THEN "F"
                                    ELSE "T"
       END AS CHAR(1)) AS TEMTIT,
       CAST(CASE COALESCE(REC.RENORI,-1) WHEN -1 THEN "F"
                                            ELSE "T"
       END AS CHAR(1)) AS RENEGO,
       VEN.CNT_RO
  FROM TT_REC REC INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
             LEFT OUTER JOIN TT_TIT TIT ON REC.CODFIL = TIT.FILREC AND REC.SEQUEN = TIT.SEQREC
                                       AND REC.NUMPAR = TIT.PARREC AND REC.SUBPAR = TIT.SUBREC
 WHERE VEN.FLGEST = "A"
   AND REC.FLGEST = "A"
   AND REC.SEQCHE IS NULL
   AND REC.CARTAO IS NULL');

/*-- SEQ 6540 --*/
-- Atualizando CODTAB = RED
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('RED',0,AGORA(),'SELECT * FROM TT_RED');

/*-- SEQ 6541 --*/
-- Atualizando CODTAB = TAB
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('TAB',0,AGORA(),'SELECT * FROM TV_TAB_OUT ORDER BY CODTAB');

/*-- SEQ 6542 --*/
-- Atualizando CODTAB = ULT
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('ULT',0,AGORA(),'SELECT CODFIL, NUMECF, CODSER,
       CAST(LPAD(TO_CHAR(max(COALESCE(TO_NUMBER(LTRIM(RTRIM(NUMNOT))),0))+1),6," ") AS VARCHAR(6)) as ULTNOT
  FROM TT_VEN VEN
 WHERE NUMNOT NOT LIKE "###%"
 GROUP BY CODFIL, NUMECF, CODSER');

/*-- SEQ 6543 --*/
-- Atualizando CODTAB = USU
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('USU',0,AGORA(),'SELECT NOMUSU,
       CODEXT AS NUMEXT,CODCTR,
       APEUSU,NIVUSU,
       CAST(COALESCE(FILUSU,"") || COALESCE(CODUSU,"") AS VARCHAR(6)) as CHAVEUSU,
       PERMISSOESUSUARIO(FILUSU,CODUSU) AS PERMIS,PERCOM,CSENHA,
              CAST(NULL AS Numeric) AS SENHA1, CAST(NULL AS Numeric) AS SENHA2,       VISSE1,VISSE2,VISPER,
       CAST(CASE ABS(COALESCE(SIGNAT,0)) WHEN COALESCE(SIGNAT,0) THEN "T" ELSE "F" END AS CHAR(1)) AS ATIVO,
       FILDIF, SEQDIF, TIPDIF, FILATV, LIMCRE,
       CAST(COALESCE(FILCLI,"") || COALESCE(CODCLI,"") AS VARCHAR(9)) as CHAVECLI
  FROM TT_USU
  WHERE SIGNAT>=0');

/*-- SEQ 6544 --*/
-- Atualizando CODTAB = VEI
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('VEI',0,AGORA(),'SELECT CAST(COALESCE(A.FILCLI,"")||COALESCE(A.CODCLI ,"") AS VARCHAR(9)) AS CHAVECLI,
       A.PLACAS,A.CODTIP,
       B.DESVTP AS DESTIP,
       A.CODCOR,C.DESCOR,
       A.MARVEI,A.MODVEI,A.ANOVEI,A.TRAFEG,A.VEIATI,
       CAST(TO_CHAR(A.CCCPRE) AS VARCHAR(4000)) AS CCCPRE
  FROM TT_VEI A INNER JOIN TD_VTP B ON A.CODTIP = B.CODTAB
                INNER JOIN TD_VCR C ON A.CODCOR = C.CODTAB
');

/*-- SEQ 6545 --*/
-- Atualizando CODTAB = VEN
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('VEN',0,AGORA(),'SELECT /*+RULE*/
       CAST(COALESCE(VEN.CODFIL,"") || COALESCE(VEN.SEQUEN,"") AS VARCHAR(13)) AS CHAVEVEN,
       CAST(COALESCE(VEN.FILCLI,"") || COALESCE(VEN.CODCLI,"") AS VARCHAR(9)) AS CHAVECLI,
       CAST(COALESCE(VEN.FILVEN,"") || COALESCE(VEN.CODVEN,"") AS VARCHAR(6)) AS CHAVEVDD,
       CAST(COALESCE(VEN.FILPGT,"") || COALESCE(VEN.CODPGT,"") AS VARCHAR(6)) AS CHAVEPGT,
       CAST(TO_CHAR(VEN.DATHOR,"DD/MM/YYYY") AS VARCHAR(10)) AS DATOPE,
       CAST(TO_CHAR(VEN.PROPGT,"DD/MM/YYYY") AS VARCHAR(10))  AS PROPGT,
       VEN.DESCON AS DESCON,
       VEN.VLRNOT AS VLRNOT,
       VEN.VLRLIQ AS VLRLIQ,
       CAST(COALESCE(RPAD(VEN.CODSER,2),"") || COALESCE(VEN.NUMECF,"") || COALESCE(VEN.NUMNOT,"") AS VARCHAR(11)) AS CHAVEORI,
       VEN.CNT_RO
  FROM TT_VEN VEN
 WHERE VEN.FLGEST = "A"
     AND exists( select "ok"
        FROM TT_REC REC
        WHERE REC.CARTAO IS NULL
          AND REC.SEQCHE IS NULL
          AND REC.FLGEST = "A"
          AND REC.CODFIL=VEN.CODFIL
          AND REC.SEQUEN=VEN.SEQUEN
          LIMIT 1
         )');

/*-- SEQ 6546 --*/
-- Atualizando CODTAB = CTB
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT)
VALUES ('CTB',0,AGORA(),
'select CTB.FILCTA,CTB.SEQCTA,CTB.TIPCTA,CTB.CODBCO,
        CAST(substr(CTB.NUMAGE,2,4)||CTB.digage AS VARCHAR(5)) as NUMAGE,
        CAST(substr(CTB.CTACRR,2,9)||CTB.digcrr AS VARCHAR(11)) AS CTACRR,
        CTB.NOMAGE,CTB.CHETRO,CTB.TIPCTB,CTB.DIGAGE,CTB.DIGCRR,
        CTB.DIGA_C,CTB.PRXTIT,CTB.VLRCHE,CTB.CTACTB,CTB.MAXCHE,
        CTB.MAXDIA,CTB.MINDIA,CTB.VLRLIM,CTB.IMPCAI, BCO.VLRCHE AS VLRFL_CHE
   from tt_ctb CTB LEFT JOIN TD_BCO BCO ON BCO.CBANCO = CTB.CODBCO');

/*-- SEQ 6547 --*/
-- Atualizando CODTAB = PHO
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT)
VALUES ('PHO',0,AGORA(),
'SELECT PHO.*, EXP.TAMPHO, EXP.QTDPHO
FROM TT_PHO PHO, (SELECT SUB.TAMPHO, SUB.QTDPHO, SUB.CODITE
FROM TT_GRA GRA, TT_SUB SUB
WHERE SUB.CODITE = GRA.CODTAM
AND (GRA.FILMAT, GRA.CODMAT) = (SELECT PAPHOFILREVELA, PAPHOCODREVELA FROM TT_CFG)) EXP
WHERE EXP.CODITE = PHO.CODEXP
AND PHO.CODBAR IS NOT NULL
');

/*-- SEQ 6548 --*/
-- Atualizando CODTAB = AMP
-- Registro de carga completa
INSERT INTO TT_OUT
(CODTAB,CODEXP,ATU_EM,SQLOUT)
VALUES
('AMP',0,AGORA(),
'SELECT CAST(rpad( COALESCE(IPR.FILMAT,"") ||
       COALESCE(IPR.CODMAT,"") || "-" ||
       COALESCE(TO_CHAR(IPR.CODCOR),"")|| "-" ||
       COALESCE(TO_CHAR(IPR.CODTAM),""), 21," " ) AS VARCHAR(21)) as CHAVEPRO,
    CAST(CASE IPR.FILMAT || IPR.CODMAT WHEN (SELECT CFG.PAPHOFILREVELA || CFG.PAPHOCODREVELA FROM TT_CFG CFG) THEN "R"
                                  WHEN (SELECT CFG.PAPHOFILREVAMP || CFG.PAPHOCODREVAMP FROM TT_CFG CFG) THEN "2"
                                                                                                         ELSE "A"
    END AS CHAR(1)) AS TIPPHO,
    AMP.CORAMP AS CORPHO,
    SUB.TAMPHO,
    IPR.PTOQTD,
    CAST(IPR.MEDUNI AS VARCHAR(2)) AS UNIDAD,
    CAST(IPR.UNIDAD AS VARCHAR(2)) AS UNIVEN,
    CAST(IPR.UNIFOR AS VARCHAR(2)) AS UNICOM,
    IPR.PERCOM,
    IPR.DESMAT,
    IPR.REFBAS,
    IPR.ESPMAT,
    IPR.MINQTD,
    IPR.DECIMA,
    IPR.VALCON,
    IPR.CUSREP,
    IPR.PRECOM,
    CASE COALESCE(PRE.DESMAX,0) WHEN 0 THEN IPR.DESMAX
                     ELSE PRE.DESMAX
    END as DESMAX,
    PRE.DESIDE AS PRE_DESIDE,
    CAST(IPR.OBSERV AS VARCHAR(255)) AS OBSERV,
    IPR.PERLUC,
    IPR.NUMEXT,
    IPR.BRINDE,
    IPR.REFPRO,
    IPR.ITEDIV,
    IPR.ITESUB,
    IPR.DESECF,
    TRI.CODTRI,
    COALESCE(PRE.PRECOV,0) AS PRECOV,
    PRE.CODMOE,
    IPR.CLASS1,
    IPR.CLASS2,
    IPR.CLASS3,
    IPR.CLASS4,
    IPI.RESIPI AS PERIPI,
    IRR.RESIRR AS PERIRR,
    IPR.TIPPRO AS SERMAT,
    IPR.SEQUEN AS SEQUEN,
    PRE.FLGEST,
    COALESCE(IPR.NOMIMG,DEP.IMGDEP) AS IMAGEM
from TV_IPR IPR LEFT OUTER JOIN TD_DEP DEP ON DEP.CODTAB = IPR.DEPART
        LEFT OUTER JOIN TD_TRI TRI ON TRI.CODTAB = IPR.CODTRI
        LEFT OUTER JOIN TD_IPI IPI ON IPI.CODTAB = IPR.RESIPI
        LEFT OUTER JOIN TD_IRR IRR ON IRR.CODTAB = IPR.RESIRR
        LEFT OUTER JOIN TV_VAR PRE ON PRE.FILMAT = IPR.FILMAT and PRE.CODMAT = IPR.CODMAT
                     and PRE.CODCOR = IPR.CODCOR and PRE.CODTAM = IPR.CODTAM
        LEFT OUTER JOIN TD_AMP AMP ON AMP.DIVAMP = IPR.CODCOR
        LEFT OUTER JOIN TT_SUB SUB ON SUB.CODITE = IPR.CODTAM
where ((IPR.FILMAT, IPR.CODMAT) IN  (SELECT PAPHOFILREVELA, PAPHOCODREVELA FROM TT_CFG )
    or (IPR.FILMAT, IPR.CODMAT) IN  (SELECT PAPHOFILREVAMP, PAPHOCODREVAMP FROM TT_CFG )
    or (IPR.FILMAT, IPR.CODMAT) IN  (SELECT PAPHOFILAMPLIA, PAPHOCODAMPLIA FROM TT_CFG ))');

/*-- SEQ 6549 --*/
-- Atualizando CODTAB = RECP
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT)
VALUES ('RECP',0,AGORA(),
'SELECT /*+INDEX(VEN,PK_VEN)*/
  REC.NUMPAR, REC.SUBPAR, REC.VLRPAR,
  CAST(COALESCE(REC.CODFIL,"")|| COALESCE(REC.SEQUEN,"") AS VARCHAR(13)) AS CHAVEVEN,
  CAST(COALESCE(RPAD(VEN.CODSER,2),"")|| COALESCE(VEN.NUMECF,"")|| COALESCE(VEN.NUMNOT,"") AS VARCHAR(11)) AS CHAVEORI,
  VEN.CNT_RO
 FROM TT_REC REC INNER JOIN TT_VEN VEN ON VEN.CODFIL = REC.CODFIL AND VEN.SEQUEN = REC.SEQUEN
 WHERE REC.FLGEST = "A"
 AND REC.SEQCHE IS NULL
 AND REC.CARTAO IS NULL
 AND REC.ATU_EM >= TRUNC(AGORA())-8
 AND REC.PAGAME >= TRUNC(AGORA())-8
');

/*-- SEQ 6550 --*/
-- Atualizando CODTAB = SAL
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('SAL',0,AGORA(),'select CAST(rpad( COALESCE(SAL.FILMAT,"")|| COALESCE(SAL.CODMAT,"")|| "-" || COALESCE(TO_CHAR(SAL.CODCOR),"")|| "-" || COALESCE(TO_CHAR(SAL.CODTAM),""), 21," " ) AS VARCHAR(21)) as CHAVEPRO,
SAL.CODFIL, SAL.QTDEST
from tt_sal sal, tt_cfg cfg
where SAL.QTDEST > 0
AND CFG.PaEstoqueVenda IS NOT NULL
AND SAL.CODMUL = CFG.PaEstoqueVenda
');

/*-- SEQ 6551 --*/
-- Atualizando CODTAB = BIC
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('BIC',0,AGORA(),
'SELECT BIC.FILBIC AS CODFIL,BIC.CODTAN,
       BIC.SEQFIL,BOM.NUMBOM,BIC.SEQBOM,
       BIC.QTDENC,BIC.NIVPRE,BIC.MAXCHE,
       BIC.BICATV,TAN.TANQUE,TAN.GRAFIL,
       TAN.GRACOD,TAN.GRACOR,TAN.GRATAM,
       CAST(RPAD( COALESCE(TAN.GRAFIL,"")|| COALESCE(TAN.GRACOD,"")|| "-" || COALESCE(TO_CHAR(TAN.GRACOR),"")|| "-" || COALESCE(TO_CHAR(TAN.GRATAM),""), 21," ") AS VARCHAR(21)) as CHAVEPRO,
       TAN.TANATV, BIC.CODTAB, TAN.PRECAL, BIC.FILLAC, BIC.SEQLAC, LAC.NUMLAC,
       BIC.CODBOM
FROM TD_BIC BIC INNER JOIN TD_TAN TAN ON TAN.CODTAB = BIC.CODTAN
                                     AND TAN.FILTAN = BIC.FILBIC
                INNER JOIN TD_BOM BOM ON BIC.CODBOM=BOM.CODTAB
				 LEFT JOIN TT_LAC LAC ON BIC.FILLAC=LAC.CODFIL
				                     AND BIC.SEQLAC=LAC.SEQUEN');

/*-- SEQ 6552 --*/
-- Atualizando CODTAB = TCP
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('TCP',0,AGORA(),
'SELECT * FROM TT_TCP');

/*-- SEQ 6553 --*/
-- Atualizando CODTAB = CUS
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('CUS',0,AGORA(),
'SELECT *
FROM (SELECT CHAVEPRO,CODFIL,FILMAT,CODMAT,CODCOR,CODTAM,
             CASE WHEN ValorTransferencia = "R" THEN REPCMP ELSE TRUNC(ValoresProduto(ValorTransferencia, FILMAT, CODMAT, CODCOR, CODTAM, CODFIL, REPCMP),4) END AS VLRCUS,
             BASSUB, VLR_ST, BASIPI, VLRIPI, VLRFRE
        FROM (SELECT /*+ INDEX(PRO,PK_PRO)*/
                      CAST(RPAD( COALESCE(SAL.FILMAT ,"")|| COALESCE(SAL.CODMAT ,"")|| "-" || COALESCE(TO_CHAR(SAL.CODCOR),"")|| "-" || COALESCE(TO_CHAR(SAL.CODTAM),""), 21," " ) AS VARCHAR(21)) AS CHAVEPRO,
                      SAL.*, 
                      CASE WHEN PCS.ValorTransferencia IN ("C","G","M","R","V") THEN PCS.ValorTransferencia
                           ELSE CFG.ValorTransferencia
                      END AS ValorTransferencia,
                      COALESCE(round(ICO.BASSUBDIF/NVLZ(ICO.QTDMOV,1),4), 0) AS BASSUB,
                      COALESCE(round(ICO.VLR_STDIF/NVLZ(ICO.QTDMOV,1),4), 0) AS VLR_ST,
                      COALESCE(round(ICO.BASIPI/NVLZ(ICO.QTDMOV,1),4), 0) AS BASIPI,
                      COALESCE(round(ICO.VLRIPI/NVLZ(ICO.QTDMOV,1),4), 0) AS VLRIPI,
                      COALESCE(round((ICO.ICO_VLRFRE + ICO.IPIFRE)/NVLZ(ICO.QTDMOV,1),4), 0) AS VLRFRE
        FROM TT_SAL SAL INNER JOIN TT_PRO PRO ON PRO.FILMAT = SAL.FILMAT
                                             AND PRO.CODMAT = SAL.CODMAT
                        INNER JOIN TT_GRA GRA ON SAL.FILMAT = GRA.FILMAT
                                             AND SAL.CODMAT = GRA.CODMAT
                                             AND SAL.CODCOR = GRA.CODCOR
                                             AND SAL.CODTAM = GRA.CODTAM
                        LEFT JOIN TT_ICO ICO ON GRA.FILCOM = ICO.CODFIL AND
                                                GRA.SEQCOM = ICO.SEQUEN AND
                                                GRA.ITECOM = ICO.NUMITE
                                INNER JOIN TD_FIL FIL ON FIL.CODFIL = SAL.CODFIL
                                CROSS JOIN (SELECT LeParametroTxt("VALOR_TRANSF_CARGA", NULL, NULL, NULL, NULL) AS ValorTransferencia FROM DUAL) PCS
                                CROSS JOIN TT_CFG CFG
                WHERE PRO.SIGNAT >= 0
                  AND FIL.FILATI = "T"
                  AND SAL.CODMUL = 0
              ) INT
      )INT
WHERE VLRCUS>0');

/*-- SEQ 6554 --*/
-- Atualizando CODTAB = CLID
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('CLID',0,AGORA(),
'select  CAST(FILCLI||CODCLI AS VARCHAR(9)) AS CHAVECLI , CAST(FILPGT||CODPGT AS VARCHAR(9)) AS CHAVEPGT, FILVEN, CAST(TO_CHAR(CLASS1) AS VARCHAR(5)) AS CLASS1, CAST(TO_CHAR(CLASS2) AS VARCHAR(5)) AS CLASS2, CAST(TO_CHAR(CLASS3) AS VARCHAR(5)) AS CLASS3, CAST(TO_CHAR(CLASS4) AS VARCHAR(5)) AS CLASS4, VLRVEN,
 CASE WHEN TIPACO = "V" THEN ACORDO END AS PERDES,
 CAST(CASE WHEN FILMAT IS NOT NULL THEN
           rpad( COALESCE(FILMAT,"")|| COALESCE(CODMAT,"")|| "-" || COALESCE(TO_CHAR(CODCOR),"")|| "-" || COALESCE(TO_CHAR(CODTAM),""), 21," " )
      ELSE NULL
 END AS VARCHAR(21)) as CHAVEPRO, CASE WHEN TIPACO = "P" THEN ACORDO END AS VLRDES, ACORDO, TIPACO, CAST(TO_CHAR(DATVAL,"DD/MM/YYYY") AS VARCHAR(10)) AS DATVAL
 from tt_desxcli');


/*-- SEQ 6555 --*/
-- Atualizando CODTAB = CLIB
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('CLIB',0,AGORA(),
'SELECT CAST(FILCLI||CODCLI AS VARCHAR(9)) AS CHAVECLI, FILVEN, CAST(TO_CHAR(CLASS1) AS VARCHAR(5)) AS CLASS1, CAST(TO_CHAR(CLASS2) AS VARCHAR(5)) AS CLASS2,
CAST(TO_CHAR(CLASS3) AS VARCHAR(5)) AS CLASS3, CAST(TO_CHAR(CLASS4) AS VARCHAR(5)) AS CLASS4, QTDVEN, QTDBON, CAST(TIPPAR AS VARCHAR(1)) AS TIPPAR  FROM  TT_BONXCLI');

/*-- SEQ 6556 --*/
-- Atualizando CODTAB = FUN
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('FUN',0,AGORA(),
'SELECT NOMFUN, CAST(TO_CHAR(DATFUN,"DD/MM/YYYY") AS VARCHAR(10)) AS DATFUN FROM TT_FUN');

/*-- SEQ 6557 --*/
-- Atualizando CODTAB = OUT
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('OUT',0,AGORA(),
'SELECT CODTAB, REPLACE(SQLOUT,CHR(34),CHR(39)) AS SQLOUT
   FROM TT_OUT
  WHERE CODEXP = 0');

/*-- SEQ 6558 --*/
-- Atualizando CODTAB = PLAF
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('PLAF',0,AGORA(),
'SELECT CODFIL, SEQUEN, FILPGT, CODPGT, CODCTR, FILSEL, ATU_EM
   FROM TT_FILXPLA ');

/*-- SEQ 6559 --*/
-- Atualizando CODTAB = FCC
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('FCC',0,AGORA(),
'SELECT VLRTAX, PERATE, FCCATI, FCCFIL,
        CAST(CASE WHEN FCC_FILMAT IS NOT NULL
                  THEN rpad( COALESCE(FCC_FILMAT,"")|| COALESCE(FCC_CODMAT,"")|| "-" || COALESCE(TO_CHAR(FCC_CODCOR),"")|| "-" || COALESCE(TO_CHAR(FCC_CODTAM),""), 21," " )
                  ELSE NULL
              END AS VARCHAR(21)) as CHAVEPRO
   FROM TD_FCC ');

/*-- SEQ 6560 --*/
-- Atualizando CODTAB = BICE
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('BICE',0,AGORA(),
'SELECT BIC.CODFIL, BIC.CODBIC, DECF.NUMECF
   FROM TT_BICXECF BIC INNER JOIN TD_ECF DECF ON DECF.CODTAB = BIC.CODECF');

/*-- SEQ 6561 --*/
-- Atualizando CODTAB = DOU
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('DOU',0,AGORA(),
'SELECT CODFIL, SEQUEN, NOMDOU, CODCRM, UF_CRM
  FROM TT_DOU');

/*-- SEQ 6562 --*/
-- Atualizando CODTAB = PLAC
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('PLAC',0,AGORA(),
'SELECT CODFIL, SEQUEN, DATINC, ATU_EM, CARTAO, FILPGT, CODPGT, FLGCRE, FLGDEB
  FROM TT_PLAXCAR');

/*-- SEQ 6563 --*/
-- Atualizando CODTAB = TAB2
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('TAB2',0,AGORA(),'SELECT * FROM TV_TAB_OUT2 ORDER BY CODTAB');

/*-- SEQ 6564 --*/
-- Atualizando CODTAB = CBS
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('CBS',0,AGORA(),'SELECT * FROM TT_CBS');

/*-- SEQ 6565 --*/
-- Atualizando CODTAB = BOM
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('DBOM',0,AGORA(),'SELECT * FROM TD_BOM');

/*-- SEQ 6566 --*/
-- Atualizando CODTAB = DPAI
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('DPAI',0,AGORA(),
'SELECT DPAI.CODPAI, DPAI.DESPAI, CAST(TO_CHAR(DPAI.ATU_EM,"DD/MM/YYYY HH24:MI:SS") as VARCHAR(21)) AS ATU_EM
   FROM TD_PAI DPAI');

/*-- SEQ 6567 --*/
-- Atualizando CODTAB = DFPS
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('DFPS',0,AGORA(),'SELECT * FROM TD_FPS');

/*-- SEQ 6568 --*/
-- Atualizando CODTAB = OBS
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('OBS',0,AGORA(),'SELECT * FROM TT_OBS');

/*-- SEQ 6569 --*/
-- Atualizando CODTAB = FRO
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('FRO',0,AGORA(),'SELECT * FROM TT_FRO');

/*-- SEQ 6570 --*/
-- Atualizando CODTAB = PTC
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('PTC',0,AGORA(),'SELECT * FROM TT_PTC');

/*-- SEQ 6571 --*/
-- Atualizando CODTAB = IPT
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('IPT',0,AGORA(),'SELECT * FROM TT_IPT');

/*-- SEQ 6572 --*/
-- Atualizando CODTAB = PCXP
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('PCXP',0,AGORA(),'SELECT * FROM TT_IPTXPRO');

/*-- SEQ 6573 --*/
-- Atualizando CODTAB = PCXN
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('PCXN',0,AGORA(),'SELECT * FROM TT_IPTXNCM');

/*-- SEQ 6574 --*/
-- Atualizando CODTAB = PXEN
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('PXEN',0,AGORA(),'SELECT * FROM TT_IPTXEXC');

/*-- SEQ 6575 --*/
-- Atualizando CODTAB = MVA
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('MVA',0,AGORA(),'SELECT * FROM TT_MVA');

/*-- SEQ 6576 --*/
-- Atualizando CODTAB = PCXE
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('PCXE',0,AGORA(),'SELECT * FROM TT_IPTXEST');

/*-- SEQ 6577 --*/
-- Atualizando CODTAB = PTC
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('LPTC',0,AGORA(),'SELECT * FROM TL_PTC');

/*-- SEQ 6578 --*/
-- Atualizando CODTAB = DRTT
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('DRTT',0,AGORA(),'SELECT * FROM TD_RTT');

/*-- SEQ 6579 --*/
-- Atualizando CODTAB = BRU
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('BRU',0,AGORA(),'SELECT * FROM TT_BRU WHERE ANOREF >= TO_NUMBER(TO_CHAR(AGORA(),''YYYY''))-CASE WHEN TO_NUMBER(TO_CHAR(AGORA(),''MM'')) = 1 THEN 2 ELSE 1 END');

/*-- SEQ 6580 --*/
-- Atualizando CODTAB = SIM
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('SIM',0,AGORA(),'SELECT * FROM TD_SIM');

/*-- SEQ 6581 --*/
--A tualizando CODTAB = LOC
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('LOC',0,AGORA(),'select CAST(rpad( COALESCE(SAL.FILMAT,"")|| COALESCE(SAL.CODMAT,"")|| "-" || COALESCE(TO_CHAR(SAL.CODCOR),"")|| "-" || COALESCE(TO_CHAR(SAL.CODTAM),""), 21," " ) AS VARCHAR(21)) as CHAVEPRO,
SAL.CODFIL,
cast(RPAD(FormataLocalizacao(SAL.LOCAL1, SAL.LOCAL2, SAL.LOCAL3, GRA.LOCALI),40," ") as VARCHAR(40)) AS LOCALI
from tt_sal sal inner join tt_gra gra on sal.filmat=gra.filmat and sal.codmat=gra.codmat and sal.codcor=gra.codcor and sal.codtam=gra.codtam
                cross join tt_cfg cfg
where SAL.LOCAL1 IS NOT NULL OR SAL.LOCAL2 IS NOT NULL OR SAL.LOCAL3 IS NOT NULL OR GRA.LOCALI IS NOT NULL
and sal.codmul = coalesce(CFG.PaEstoqueVenda,0)');

/*-- SEQ 6582 --*/
-- Atualizando CODTAB = FER
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('FER',0,AGORA(),
'SELECT CODFIL, SEQUEN, FILFER, DIAFER, MESFER, ANOFER, MOTIVO, LOJABR
   FROM TT_FER
');

/*-- SEQ 6583 --*/
-- Atualizando CODTAB = DSAD
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('DSAD',0,AGORA(),
'SELECT DSAD.CODTAB, DSAD.DESSAD, DSAD.SADATI, DSAD.SUGORC, DSAD.VENAVU,
        DSAD.CODRTT, DSAD.IMPDOC, DSAD.FORIMP, DSAD.TIPVAL, DSAD.VALIDA,
        DSAD.SOMGAR, DSAD.NUMINI, DSAD.DESMIN, DSAD.ACRMAX, DSAD.VALSAD,
        DSAD.PERSAD, DSAD.PERIOF, DSAD.FLGPES, DSAD.REPSAD, DSAD.PERCOM_DSAD,
        DSAD.DIARES, DSAD_CAN.FORCAN
   FROM TD_SAD DSAD LEFT JOIN TD_SAD_CAN DSAD_CAN ON DSAD_CAN.CODTAB = DSAD.CODTAB');

/*-- SEQ 6584 --*/
-- Atualizando CODTAB = IBP
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('IBP',0,AGORA(),'
SELECT CODFIL, SEQUEN,
       CAST(TO_CHAR(DATINC,"DD/MM/YYYY HH24:MI:SS") AS VARCHAR(21)) AS DATINC,
       CAST(TO_CHAR(ATU_EM,"DD/MM/YYYY HH24:MI:SS") AS VARCHAR(21)) AS ATU_EM,
       CODIGO, COD_EX, TABELA, ALINAC, ALIIMP,
       ALIFEDNAC, ALIFEDIMP, ALIEST, ALIMUN,
       CAST(TO_CHAR(DATINI,"DD/MM/YYYY HH24:MI:SS") AS VARCHAR(21))as DATINI,
       CAST(TO_CHAR(DATFIM,"DD/MM/YYYY HH24:MI:SS") AS VARCHAR(21))as DATFIM,
       CHAVE, VERSAO, FONTE, SIGEST
   FROM TT_IBP
  WHERE DATINI > AGORA() -- vigencia futura
    AND TABELA = 0
UNION
SELECT CODFIL, SEQUEN,
       CAST(TO_CHAR(DATINC,"DD/MM/YYYY HH24:MI:SS") AS VARCHAR(21)) AS DATINC,
       CAST(TO_CHAR(ATU_EM,"DD/MM/YYYY HH24:MI:SS") AS VARCHAR(21)) AS ATU_EM,
       CODIGO, COD_EX, TABELA, ALINAC, ALIIMP,
       ALIFEDNAC, ALIFEDIMP, ALIEST, ALIMUN,
       CAST(TO_CHAR(DATINI,"DD/MM/YYYY HH24:MI:SS") AS VARCHAR(21))as DATINI,
       CAST(TO_CHAR(DATFIM,"DD/MM/YYYY HH24:MI:SS") AS VARCHAR(21))as DATFIM,
       CHAVE, VERSAO, FONTE, SIGEST
   FROM TT_IBP
  WHERE DATINI <= AGORA()
    AND DATFIM >= AGORA()
    AND TABELA = 0'); -- vigencia atual

/*-- SEQ 6585 --*/
-- Atualizando CODTAB = LOT
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('LOT',0,AGORA(),
'SELECT CAST(RPAD( COALESCE(TAB.FILMAT ,"")|| COALESCE(TAB.CODMAT ,"")|| "-" || COALESCE(TO_CHAR(TAB.CODCOR),"")|| "-" || COALESCE(TO_CHAR(TAB.CODTAM),""), 21," " ) AS VARCHAR(21)) AS CHAVEPRO,
       CAST(TAB.FILFOR || TAB.CODFOR AS VARCHAR(9)) as CHAVEFOR,
       TAB.CODFIL, TAB.SEQUEN, TAB.NUMLOT,
       CAST(TO_CHAR(TAB.DATINC,"DD/MM/YYYY HH24:MI:SS") as VARCHAR(21)) AS DATINC,
       CAST(TO_CHAR(TAB.ATU_EM,"DD/MM/YYYY HH24:MI:SS") as VARCHAR(21)) AS ATU_EM,
       CAST(TO_CHAR(TAB.DATVAL,"DD/MM/YYYY") AS VARCHAR(10)) AS DATVAL,
       TAB.TONALI, TAB.TAMANH, TAB.QTDINI, TAB.QTDCOM, TAB.FLGPON,
       TAB.PERABA, TAB.LOTATI, TAB.CODMUL, TAB.QTDEST, TAB.RESERV,
       TAB.FILSLT, TAB.MOVSLT
  FROM (
 SELECT LOT.FILMAT, LOT.CODMAT, LOT.CODCOR, LOT.CODTAM,
        LOT.FILFOR, LOT.CODFOR,
        LOT.CODFIL, LOT.SEQUEN, LOT.NUMLOT,
        LOT.DATINC, LOT.ATU_EM,
        LOT.TONALI, LOT.TAMANH, LOT.DATVAL,
        LOT.QTDINI, LOT.QTDCOM, LOT.FLGPON,
        COALESCE(LOT.PERABA,0) AS PERABA,
        LOT.LOTATI, PRO.LOTONL, SLT.CODFIL AS FILSLT,
        SLT.CODMUL, SLT.QTDEST, SLT.RESERV, SLT.MOVSLT
   FROM TV_SLT SLT
  INNER JOIN TT_LOT LOT ON LOT.CODFIL = SLT.FILLOT
                       AND LOT.SEQUEN = SLT.SEQLOT
  INNER JOIN TT_PRO PRO ON LOT.FILMAT = PRO.FILMAT
                       AND LOT.CODMAT = PRO.CODMAT
                       AND PRO.LOTONL = "T"
UNION ALL
 SELECT LOT.FILMAT, LOT.CODMAT, LOT.CODCOR, LOT.CODTAM,
        LOT.FILFOR, LOT.CODFOR,
        LOT.CODFIL, LOT.SEQUEN, LOT.NUMLOT,
        LOT.DATINC, LOT.ATU_EM,
        LOT.TONALI, LOT.TAMANH, LOT.DATVAL,
        LOT.QTDINI, LOT.QTDCOM, LOT.FLGPON,
        COALESCE(LOT.PERABA,0) AS PERABA,
        LOT.LOTATI,
        MIN(PRO.LOTONL) AS LOTONL,
        CAST(NULL AS CHAR(3)) AS FILSLT,
        0 AS CODMUL,
        SUM(SLT.QTDEST) AS QTDEST,
        SUM(SLT.RESERV) AS RESERV,
        MAX(SLT.MOVSLT) AS MOVSLT
   FROM TV_SLT SLT
  INNER JOIN TT_LOT LOT ON LOT.CODFIL = SLT.FILLOT
                       AND LOT.SEQUEN = SLT.SEQLOT
  INNER JOIN TT_PRO PRO ON LOT.FILMAT = PRO.FILMAT
                       AND LOT.CODMAT = PRO.CODMAT
                       AND PRO.LOTONL = "F"
  GROUP BY LOT.FILMAT, LOT.CODMAT, LOT.CODCOR, LOT.CODTAM, LOT.FILFOR, LOT.CODFOR,
           LOT.CODFIL, LOT.SEQUEN, LOT.NUMLOT, LOT.DATINC, LOT.ATU_EM, LOT.TONALI,
           LOT.TAMANH, LOT.DATVAL, LOT.QTDINI, LOT.QTDCOM, LOT.FLGPON, LOT.PERABA,
           LOT.LOTATI
 ) TAB
--FILTRO - Ignorado deste ponto para baixo na carga simplificada
  WHERE TAB.LOTATI = "T"
    AND TAB.QTDEST > 0');

/*-- SEQ 6586 --*/
-- Atualizando CODTAB = SLT
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('SLT',0,AGORA(),
'SELECT SLT.CODFIL,SLT.SEQUEN,SLT.CODMUL,SLT.FILLOT,SLT.SEQLOT,SLT.QTDEST,SLT.RESERV,SLT.QTDINI,SLT.LOTATI,
        CAST(TO_CHAR(SLT.ATU_EM,"DD/MM/YYYY HH24:MI:SS") as VARCHAR(21)) AS ATU_EM,
        CAST(RPAD( COALESCE(LOT.FILMAT ,"")|| COALESCE(LOT.CODMAT ,"")|| "-" || COALESCE(TO_CHAR(LOT.CODCOR),"")|| "-" || COALESCE(TO_CHAR(LOT.CODTAM),""), 21," " ) AS VARCHAR(21)) AS CHAVEPRO,
        CAST(LOT.FILFOR || LOT.CODFOR AS VARCHAR(9)) as CHAVEFOR, SLT.MOVSLT
   FROM TV_SLT SLT INNER JOIN TT_LOT LOT ON LOT.CODFIL = SLT.FILLOT
                                        AND LOT.SEQUEN = SLT.SEQLOT
--FILTRO - Ignorado deste ponto para baixo na carga simplificada
  WHERE LOT.QTDEST > 0
    AND LOT.LOTATI = "T"
    AND "F" = (
        SELECT PRO.LOTONL
          FROM TT_PRO PRO
         WHERE PRO.FILMAT = LOT.FILMAT
           AND PRO.CODMAT = LOT.CODMAT
        )');

/*-- SEQ 6587 --*/
-- Atualizando CODTAB = DRGC
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('DRGC',0,AGORA(),'SELECT * FROM TD_RGC');

/*-- SEQ 6588 --*/
-- Atualizando CODTAB = FRP
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('FRP',0,AGORA(),'SELECT * FROM TT_FRP');

/*-- SEQ 6589 --*/
-- Atualizando CODTAB = MFEC
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('MFEC',0,AGORA(),'SELECT CODFIL, NUMECF, CAST(TO_CHAR(DATOPE,"DD/MM/YYYY HH24:MI:SS") as VARCHAR(21)) AS DATOPE, FLGEST FROM TM_FEC WHERE FLGEST = "A"');

/*-- SEQ 6590 --*/
-- Atualizando CODTAB = CON
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,SQLOUT) VALUES ('CON',0,AGORA(),'SELECT CAST(CON.FILCLI || CON.CODCLI AS VARCHAR(9)) as CHAVECLI,
   CON.NUMCON,
   CON.CONTAT,
   CON.DOCCON,
   CON.RETPRO
  FROM TT_CLI CLI INNER JOIN TT_CON CON ON CON.FILCLI = CLI.FILCLI
                                       AND CON.CODCLI = CLI.CODCLI
 WHERE CLI.FLGTIP = 1
   AND CLI.SIGNAT >= 0
   AND CON.DOCCON IS NOT NULL
   AND CON.RETPRO = "T"');

/*-- SEQ 6591 --*/
-- Atualizando CODTAB = LOG
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('LOG',0,AGORA(),'Exportao de Logradouros',
'SELECT CODTAB, CODCEP, NOMLOG, COMPLE, CODBAI FROM TT_LOG');

/*-- SEQ 6592 --*/
-- Atualizando CODTAB = BAI
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('BAI',0,AGORA(),'Exportao de Bairros',
'SELECT CODBAI, CODMUN, NOMBAI FROM TT_BAI');

-- Atualizando CODTAB = IBG
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('IBG', 0, AGORA(), 'Exportao de Municpios.',
'SELECT CODIBG, NOMMUN, CODMES, CODMIC, SIGEST, CAST(TO_CHAR(ATU_EM,"DD/MM/YYYY HH24:MI:SS") as VARCHAR(21)) AS ATU_EM
   FROM TT_IBG');

/*-- SEQ 6593 --*/
-- Atualizando CODTAB = PCS
-- Registro de carga completa
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('PCS',0,AGORA(), 'Exportao de Param Cfg Sist',
'SELECT CAST(PCS.ID_PCS AS Numeric(10,0)) AS ID_PCS,
        CAST(TO_CHAR(PCS.DATINC,"DD/MM/YYYY HH24:MI:SS") AS VARCHAR(21)) AS PCS_DATINC,
        CAST(TO_CHAR(PCS.ATU_EM,"DD/MM/YYYY HH24:MI:SS") AS VARCHAR(21)) AS PCS_ATU_EM,
        PCS.PCSATI,
        PCS.NOMPCS,
        PCS.DESPCS,
        PCS.TIPPCS,
        PCS.PCSGER,
        PCS.PCSFIL,
        PCS.PCSECF,
        PCS.PCSSER,
        CAST(IPC.ID_IPC AS Numeric(10,0)) AS ID_IPC,
        CAST(TO_CHAR(IPC.DATINC,"DD/MM/YYYY HH24:MI:SS") AS VARCHAR(21)) AS IPC_DATINC,
        CAST(TO_CHAR(IPC.ATU_EM,"DD/MM/YYYY HH24:MI:SS") AS VARCHAR(21)) AS IPC_ATU_EM,
        IPC.IPCATI,
        IPC.VLRNUM,
        IPC.VLRINT,
        IPC.VLRTXT,
        IPC.VLRBOO,
        IPC.VLRDAT,
        IPC.FILIPC,
        IPC.FILECF,
        IPC.NUMECF,
        IPC.CODSER
   FROM TT_IPC IPC INNER JOIN TT_PCS PCS ON PCS.ID_PCS = IPC.ID_PCS
  WHERE PCS.PCSATI = "T"
    AND IPC.IPCATI = "T"');

/*-- SEQ 6594 --*/
-- Atualizando CODTAB = ECOM
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('ECOM',1,AGORA(),'Exportao de Compras',
'SELECT * FROM TV_ECOM');

/*-- SEQ 6595 --*/
-- Atualizando CODTAB = EICO
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('EICO',1,AGORA(),'Exportao de Itens de Compras',
'SELECT * FROM TV_EICO');

/*-- SEQ 6596 --*/
-- Atualizando CODTAB = EPAG
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('EPAG',1,AGORA(),'Exportao de Parcelas a Pagar',
'SELECT * FROM TV_EPAG');

/*-- SEQ 6597 --*/
-- Atualizando CODTAB = EDOP
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('EDOP',1,AGORA(),'Exportao de Docs. de Pgto',
'SELECT * FROM TV_EDOP');

/*-- SEQ 6598 --*/
-- Atualizando CODTAB = EVEN
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('EVEN',1,AGORA(),'Exportao de Vendas',
'SELECT * FROM TV_EVEN_EXP');

/*-- SEQ 6599 --*/
-- Atualizando CODTAB = EIVE
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('EIVE',1,AGORA(),'Exportao de Itens de Vendas',
'SELECT * FROM TV_EIVE_EXP');

/*-- SEQ 6600 --*/
-- Atualizando CODTAB = EREC
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('EREC',1,AGORA(),'Exportao de Parc. a Receber',
'SELECT * FROM TV_EREC');

/*-- SEQ 6601 --*/
-- Atualizando CODTAB = ENAT
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('ENAT',1,AGORA(),'Exportao de Naturezas',
'SELECT * FROM TV_ENAT');

/*-- SEQ 6602 --*/
-- Atualizando CODTAB = ESER
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('ESER',1,AGORA(),'Exportao de Sries',
'SELECT * FROM TV_ESER');

/*-- SEQ 6603 --*/
-- Atualizando CODTAB = EUSU
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('EUSU',1,AGORA(),'Exportao de Usurios',
'SELECT * FROM TV_EUSU');

/*-- SEQ 6604 --*/
-- Atualizando CODTAB = ECLI
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('ECLI',1,AGORA(),'Exportao de Parceiros',
'SELECT * FROM TV_ECLI');

/*-- SEQ 6605 --*/
-- Atualizando CODTAB = EPRO
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('EPRO',1,AGORA(),'Exportao de Produtos',
'SELECT * FROM TV_EPRO');

/*-- SEQ 6606 --*/
-- Atualizando CODTAB = ECMS
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('ECMS',1,AGORA(),'Exportao de Comisses',
'SELECT * FROM TV_ECMS');

/*-- SEQ 6607 --*/
-- Atualizando CODTAB = ESAL
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('ESAL',1,AGORA(),'Exportao de Saldos',
'SELECT * FROM TV_ESAL');

/*-- SEQ 6608 --*/
-- Atualizando CODTAB = EPRE
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('EPRE',1,AGORA(),'Exportao de Preos',
'SELECT * FROM TV_EPRE');

/*-- SEQ 6609 --*/
-- Atualizando CODTAB = ELIM
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('ELIM',1,AGORA(),'Exportao de Limites de CC',
'SELECT * FROM TV_ELIM');

/*-- SEQ 6610 --*/
-- Atualizando CODTAB = ELAN
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('ELAN',1,AGORA(),'Exportao de Lan. Avulsos',
'SELECT * FROM TV_ELAN');

/*-- SEQ 6611 --*/
-- Atualizando CODTAB = ECHR
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('ECHR',1,AGORA(),'Exportao de Cheques',
'SELECT * FROM TV_ECHR');

/*-- SEQ 6612 --*/
-- Atualizando CODTAB = EPLA
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('EPLA',1,AGORA(),'Exportao de Planos',
'SELECT * FROM TV_EPLA');

/*-- SEQ 6613 --*/
-- Atualizando CODTAB = ECAM
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('ECAM',1,AGORA(),'Exportao de Cmbio',
'SELECT * FROM TV_ECAM');

/*-- SEQ 6614 --*/
-- Atualizando CODTAB = EKIT
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('EKIT',1,AGORA(),'Exportao de Kit',
'SELECT * FROM TV_EKIT');

/*-- SEQ 6615 --*/
-- Atualizando CODTAB = ECFP
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('ECFP',1,AGORA(),'Exportao de CFOP',
'SELECT * FROM TV_ECFP');

/*-- SEQ 6616 --*/
-- Atualizando CODTAB = ECON
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('ECON',1,AGORA(),'Exportao Contabil',
'SELECT * FROM TV_ECON');

/*-- SEQ 6617 --*/
-- Atualizando CODTAB = ELOT
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('ELOT',1,AGORA(),'Exportao Lotes',
'SELECT * FROM TV_ELOT');

/*-- SEQ 6618 --*/
-- Atualizando CODTAB = ESLT
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('ESLT',1,AGORA(),'Exportao Saldo de Lotes',
'SELECT * FROM TV_ESLT');

/*-- SEQ 6619 --*/
-- Atualizando CODTAB = ESEP
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('ESEP',1,AGORA(),'Exportao Separaes Penden.',
'SELECT * FROM TV_ESEP');

/*-- SEQ 6620 --*/
-- Atualizando CODTAB = EINV
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('EINV',1,AGORA(),'Exportao Inventrios',
'SELECT * FROM TV_EINV');

/*-- SEQ 6621 --*/
-- Atualizando CODTAB = EIIN
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('EIIN',1,AGORA(),'Exportao de Itens de Invent.',
'SELECT * FROM TV_EIIN');

/*-- SEQ 6622 --*/
-- Atualizando CODTAB = EROM
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('EROM',1,AGORA(),'Exportao Romaneios',
'SELECT * FROM TV_EROM');

/*-- SEQ 6623 --*/
-- Atualizando CODTAB = GAB
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('GAB',1,AGORA(),'Exportao de Gabaritos de CB',
'SELECT * FROM TT_GAB');

/*-- SEQ 6624 --*/
-- Atualizando CODTAB = EEAN
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('EEAN',1,AGORA(),'Exportao EAN',
'SELECT * FROM TV_EEAN');

/*-- SEQ 6625 --*/
-- Atualizando CODTAB = ECCC
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('ECCC',1,AGORA(),'Conta Corrente',
'SELECT * FROM TV_ECCC');

/*-- SEQ 6626 --*/
-- Atualizando CODTAB = EIMU
-- Registro de exportao
INSERT INTO TT_OUT (CODTAB,CODEXP,ATU_EM,TITOUT,SQLOUT) VALUES ('EIMU',1,AGORA(),'Exportao Impostos Municipais',
'SELECT * FROM TV_EIMU');

/*-- SEQ 6627 --*/
SELECT ENABLETRIGGERS(LOWER('TT_OUT'));


/*-- SEQ 6628 --*/
DELETE FROM TT_DEC;

/*-- SEQ 6629 --*/
-- Filiais
INSERT INTO TT_DEC
(ORIGEM, CODTAB, TITULO, SQLSTR)
VALUES
('T', 1, 'Filiais',
 'SELECT FILIAL AS CODFIL, NOME_FILIAL AS NOMFIL, REGIONAL, ATIVIDADE'||CHR(13)||CHR(10)||
 '  FROM DW_Filiais order by codfil');

/*-- SEQ 6630 --*/
-- Busca o nome das Classes e Categotias do banco
INSERT INTO TT_DEC
(ORIGEM, CODTAB, TITULO, SQLSTR)
VALUES 
('T', 2, 'Configuraes',
 'SELECT CLASS1, CLASS2, CLASS3, CLASS4, CATEG1, CATEG2, CATEG3'||CHR(13)||CHR(10)||
 '  FROM DW_Configuracoes');

/*-- SEQ 6631 --*/
-- Filiais
INSERT INTO TT_DEC
(ORIGEM, CODTAB, TITULO, SQLSTR)
VALUES
('T', 3, 'Unidades',
 'SELECT CODIGO AS COD_UNIDADE, DESCRICAO AS UNIDADE'||CHR(13)||CHR(10)||
 '  FROM DW_UnidadeNegocio');

/*-- SEQ 6632 --*/
-- Grupos de Filiais
INSERT INTO TT_DEC
(ORIGEM, CODTAB, TITULO, SQLSTR)
VALUES
('T', 4, 'Grupos de Filiais',
  'select :tbl_coluna as grupo '||CHR(13)||CHR(10)||
  '  from DW_FILIAIS'||CHR(13)||CHR(10)||
  ' group by :tbl_coluna');

/*-- SEQ 6633 --*/
-- Grupos de Filiais
INSERT INTO TT_DEC
(ORIGEM, CODTAB, TITULO, SQLSTR)
VALUES
('T', 5, 'Filiais por Grupo', 
  'select filial as codfil,   '||CHR(13)||CHR(10)||
  '       nome_filial as nomfil, '||CHR(13)||CHR(10)||
  '       regional,              '||CHR(13)||CHR(10)||
  '       atividade              '||CHR(13)||CHR(10)||
  '  from DW_FILIAIS             '||CHR(13)||CHR(10)||
  ' where :tbl_campo in ( :set_valores ) '||CHR(13)||CHR(10)||
  ' order by codfil');

/*-- SEQ 6634 --*/
-- Evoluo Mensal de Vendas
INSERT INTO TT_DEC
(ORIGEM, CODTAB, TITULO, SQLSTR)
VALUES 
('T', 101, 'Evoluo Mensal de Vendas',
 'SELECT MES.MES, INT.ANO_2, INT.ANO_1, INT.ANO,'                                     ||CHR(13)||CHR(10)||
 '       CASE WHEN TO_NUMBER(MES.MES) + CASE WHEN MES.MES < TO_CHAR(AGORA(), ''MM'')' ||CHR(13)||CHR(10)||
 '                                           THEN 12'                                 ||CHR(13)||CHR(10)||
 '                                           ELSE 0'                                  ||CHR(13)||CHR(10)||
 '                                      END - TO_NUMBER(TO_CHAR(AGORA(), ''MM'')) < 6'||CHR(13)||CHR(10)||
 '            THEN TRUNC(VAR.VARIACAO*INT.ANO_1, 2)'                                  ||CHR(13)||CHR(10)||
 '            ELSE 0'                                                                 ||CHR(13)||CHR(10)||
 '       END AS PREVISAO,'                                                            ||CHR(13)||CHR(10)||
 '       (SELECT SUM(COALESCE(MPF.META,FIL.VALOR1))'                                     ||CHR(13)||CHR(10)||
 '          FROM DW_FILIAIS FIL LEFT JOIN DW_Metas_Filiais MPF ON FIL.FILIAL=MPF.FILIAL'||CHR(13)||CHR(10)||
 '         WHERE MPF.ANO IS NULL OR '                                                 ||CHR(13)||CHR(10)||
 '               (MPF.ANO = TO_NUMBER(TO_CHAR(AGORA(), ''YYYY'')) AND'                ||CHR(13)||CHR(10)||
 '                MPF.MES = TO_NUMBER(INT.MES))'                                      ||CHR(13)||CHR(10)|| 
 '           /*<opcional>*/'                                                          ||CHR(13)||CHR(10)||
 '           AND FIL.FILIAL IN (:set_filial)'                                         ||CHR(13)||CHR(10)||
 '           /*</opcional>*/'                                                         ||CHR(13)||CHR(10)||
 '           ) AS META'                                                               ||CHR(13)||CHR(10)||
 '  FROM (SELECT * FROM DW_variacao_Vendas) VAR,'                                     ||CHR(13)||CHR(10)||
 '       (SELECT TO_CHAR(DAT.DATOPE,''DD'') AS MES'                                   ||CHR(13)||CHR(10)||
 '          FROM TT_DAT DAT'                                                          ||CHR(13)||CHR(10)||
 '         WHERE DAT.DATOPE >= LAST_DAY(AGORA())'                                     ||CHR(13)||CHR(10)||
 '           AND DAT.DATOPE <= ADD_DAY(LAST_DAY(AGORA()), 12)) MES LEFT JOIN'         ||CHR(13)||CHR(10)||
 '       (SELECT TO_CHAR(VEN.DATA,''MM'') AS MES,'                                    ||CHR(13)||CHR(10)||
 '               SUM(CASE WHEN TO_NUMBER(TO_CHAR(VEN.DATA,''YYYY'')) = TO_NUMBER(TO_CHAR(AGORA(),''YYYY''))-2 THEN VEN.VALOR ELSE 0 END) AS ANO_2,'||CHR(13)||CHR(10)||
 '               SUM(CASE WHEN TO_NUMBER(TO_CHAR(VEN.DATA,''YYYY'')) = TO_NUMBER(TO_CHAR(AGORA(),''YYYY''))-1 THEN VEN.VALOR ELSE 0 END) AS ANO_1,'||CHR(13)||CHR(10)||
 '               SUM(CASE WHEN TO_NUMBER(TO_CHAR(VEN.DATA,''YYYY'')) = TO_NUMBER(TO_CHAR(AGORA(),''YYYY''))-0 THEN VEN.VALOR ELSE 0 END) AS ANO'||CHR(13)||CHR(10)||
 '          FROM DW_Vendas VEN'                                                       ||CHR(13)||CHR(10)||
 '         WHERE VEN.DATA >= TO_DATE(''01/01/'' || TRIM(TO_CHAR(TO_NUMBER(TO_CHAR(AGORA(), ''YYYY'')) - 2, ''0009'')) ,''DD/MM/YYYY'')'||CHR(13)||CHR(10)||
 '           AND VEN.DATA < AGORA()'                                                  ||CHR(13)||CHR(10)||
 '           /*<opcional>*/'                                                          ||CHR(13)||CHR(10)||
 '           AND VEN.FILIAL IN (:set_filial)'                                         ||CHR(13)||CHR(10)||
 '           /*</opcional>*/'                                                         ||CHR(13)||CHR(10)||
 '         GROUP BY TO_CHAR(VEN.DATA,''MM'')) INT ON MES.MES = INT.MES'               ||CHR(13)||CHR(10)||
 ' ORDER BY MES.MES');

/*-- SEQ 6635 --*/
-- Venda Diria
INSERT INTO TT_DEC
(ORIGEM, CODTAB, TITULO, SQLSTR)
VALUES 
('T', 102, 'Venda Diria',
 'SELECT INT.DIA, INT.VENDIA AS VALOR,'                           ||CHR(13)||CHR(10)||
 '       TRUNC(CASE MET WHEN 2 THEN VENMES / DIAS_DO_MES'         ||CHR(13)||CHR(10)||
 '                      WHEN 1 THEN VENDIA'                       ||CHR(13)||CHR(10)||
 '                      WHEN 0 THEN (METMES-VENMES) / DIAS_DO_MES'||CHR(13)||CHR(10)||
 '             END) AS META'                                      ||CHR(13)||CHR(10)||
 '  FROM (SELECT TO_CHAR(DAT.DATOPE,''DD'') AS DIA, DIAS_DO_MES,' ||CHR(13)||CHR(10)||
 '               (-- Vendas do dia'                               ||CHR(13)||CHR(10)||
 '               SELECT SUM(V.VALOR) AS VENMES'                   ||CHR(13)||CHR(10)||
 '                 FROM DW_Vendas V'                              ||CHR(13)||CHR(10)||
 '                WHERE V.DATA = DAT.DATOPE'                      ||CHR(13)||CHR(10)||
 '                /*<opcional>*/'                                 ||CHR(13)||CHR(10)||
 '                  AND V.FILIAL IN (:set_filial)'                ||CHR(13)||CHR(10)||
 '                /*</opcional>*/'                                ||CHR(13)||CHR(10)||
 '                ) AS VENDIA,'                                   ||CHR(13)||CHR(10)||
 '                MET.METMES, VEN.VENMES,'                        ||CHR(13)||CHR(10)||
 '                -- Para o ms atual, projeta meta dos dias faltantes'||CHR(13)||CHR(10)||
 '                CASE WHEN TO_CHAR(CAST(:date_dataini AS DATE), ''MM/YYYY'') = TO_CHAR(AGORA(), ''MM/YYYY'')'||CHR(13)||CHR(10)||
 '                     THEN CASE WHEN TO_CHAR(DAT.DATOPE,''DD'') <= TO_CHAR(AGORA(), ''DD'')'||CHR(13)||CHR(10)||
 '                               THEN 1'                          ||CHR(13)||CHR(10)||
 '                               ELSE 0'                          ||CHR(13)||CHR(10)||
 '                          END'                                  ||CHR(13)||CHR(10)||
 '                     ELSE 2'                                    ||CHR(13)||CHR(10)||
 '                END AS MET'                                     ||CHR(13)||CHR(10)||
 '          FROM ( -- Numero de dias do ms'                      ||CHR(13)||CHR(10)||
 '                SELECT TO_NUMBER(TO_CHAR(LAST_DAY(:date_dataini), ''DD'')) AS DIAS_DO_MES'||CHR(13)||CHR(10)||
 '                  FROM DUAL'                                    ||CHR(13)||CHR(10)||
 '                ) MES,'                                         ||CHR(13)||CHR(10)||
 '               ( -- Meta do ms'                                ||CHR(13)||CHR(10)||
 '                SELECT SUM(COALESCE(M.META,F.VALOR1)) AS METMES'                   ||CHR(13)||CHR(10)||
 '                  FROM DW_FILIAIS F LEFT JOIN DW_Metas_Filiais M ON F.FILIAL=M.FILIAL' ||CHR(13)||CHR(10)||
 '                 WHERE M.ANO = TO_NUMBER(TO_CHAR(CAST(:date_dataini AS DATE), ''YYYY''))'||CHR(13)||CHR(10)||
 '                   AND M.MES = TO_NUMBER(TO_CHAR(CAST(:date_dataini AS DATE), ''MM''))'  ||CHR(13)||CHR(10)||
 '                 /*<opcional>*/'                                ||CHR(13)||CHR(10)||
 '                   AND M.FILIAL IN (:set_filial)'               ||CHR(13)||CHR(10)||
 '                 /*</opcional>*/'                               ||CHR(13)||CHR(10)||
 '                ) met,'                                         ||CHR(13)||CHR(10)||
 '               ( -- Vendas total do ms'                        ||CHR(13)||CHR(10)||
 '                SELECT SUM(V.VALOR) AS VENMES'                  ||CHR(13)||CHR(10)||
 '                  FROM DW_Vendas V'                             ||CHR(13)||CHR(10)||
 '                 WHERE V.DATA BETWEEN :date_dataini AND LAST_DAY(:date_dataini)'||CHR(13)||CHR(10)||
 '                 /*<opcional>*/'                                ||CHR(13)||CHR(10)||
 '                   AND V.FILIAL IN (:set_filial)'               ||CHR(13)||CHR(10)||
 '                 /*</opcional>*/'                               ||CHR(13)||CHR(10)||
 '                ) VEN,'                                         ||CHR(13)||CHR(10)||
 '                TT_DAT DAT'                                     ||CHR(13)||CHR(10)||
 '         WHERE DAT.DATOPE >= :date_dataini'                     ||CHR(13)||CHR(10)||
 '           AND DAT.DATOPE < ADD_DAY(LAST_DAY(:date_dataini), 1)'||CHR(13)||CHR(10)||
 '        ) INT');


/*-- SEQ 6636 --*/
-- Venda por Hora
INSERT INTO TT_DEC
(ORIGEM, CODTAB, TITULO, SQLSTR)
VALUES 
('T', 103, 'Venda por Hora',
 'SELECT DAT.HORA||''-''||LTRIM(TO_CHAR(TO_NUMBER(DAT.HORA)+1,''09'')) AS HORA,'||CHR(13)||CHR(10)||
 '       INT.DOM, INT.SEG, INT.TER, INT.QUA, INT.QUI, INT.SEX, INT.SAB'                  ||CHR(13)||CHR(10)||
 '  FROM -- Gera 24 linhas (horas) para poder trazer linhas em branco para horrios de intervalo de vendas'||CHR(13)||CHR(10)||
 '       (SELECT CAST(REPLACE(TO_CHAR(TO_NUMBER(TO_CHAR(DIA.DATOPE, ''DD''))-1,''09''),'' '','''')  AS CHAR(2)) AS HORA'||CHR(13)||CHR(10)||
 '          FROM TT_DAT DIA'                                                    ||CHR(13)||CHR(10)||
 '         WHERE DIA.DATOPE > LAST_DAY(AGORA())'                                ||CHR(13)||CHR(10)||
 '           AND DIA.DATOPE < ADD_DAY(LAST_DAY(AGORA()),24)'                     ||CHR(13)||CHR(10)||
 '        ) DAT LEFT JOIN (SELECT HORA, -- Busca a venda por hora e dia da semana'||CHR(13)||CHR(10)||
 '                                SUM(CASE WHEN TO_CHAR(VEN.DATA,''D'') = ''1'' THEN QTDVEN ELSE 0 END) AS DOM,'||CHR(13)||CHR(10)||
 '                                SUM(CASE WHEN TO_CHAR(VEN.DATA,''D'') = ''2'' THEN QTDVEN ELSE 0 END) AS SEG,'||CHR(13)||CHR(10)||
 '                                SUM(CASE WHEN TO_CHAR(VEN.DATA,''D'') = ''3'' THEN QTDVEN ELSE 0 END) AS TER,'||CHR(13)||CHR(10)||
 '                                SUM(CASE WHEN TO_CHAR(VEN.DATA,''D'') = ''4'' THEN QTDVEN ELSE 0 END) AS QUA,'||CHR(13)||CHR(10)||
 '                                SUM(CASE WHEN TO_CHAR(VEN.DATA,''D'') = ''5'' THEN QTDVEN ELSE 0 END) AS QUI,'||CHR(13)||CHR(10)||
 '                                SUM(CASE WHEN TO_CHAR(VEN.DATA,''D'') = ''6'' THEN QTDVEN ELSE 0 END) AS SEX,'||CHR(13)||CHR(10)||
 '                                SUM(CASE WHEN TO_CHAR(VEN.DATA,''D'') = ''7'' THEN QTDVEN ELSE 0 END) AS SAB '||CHR(13)||CHR(10)||
 '                           FROM DW_Vendas_Hora VEN'                           ||CHR(13)||CHR(10)||
 '                          WHERE VEN.DATA BETWEEN :date_dataini AND LAST_DAY(:date_dataini)'||CHR(13)||CHR(10)||
 '                          /*<opcional>*/'                                     ||CHR(13)||CHR(10)||
 '                            AND VEN.FILIAL IN (:set_filial)'                  ||CHR(13)||CHR(10)|| 
 '                          /*</opcional>*/'                                    ||CHR(13)||CHR(10)||
 '                          GROUP BY VEN.HORA'                                  ||CHR(13)||CHR(10)||
 '                          ORDER BY VEN.HORA'                                  ||CHR(13)||CHR(10)||
 '                         ) INT ON INT.HORA = DAT.HORA'                        ||CHR(13)||CHR(10)||
 '             INNER JOIN (SELECT -- VERIFICA PRIMEIRO E LTIMO HORRIO DE VENDA, PARA TRAZER SOMENTE NESTE INTERVALO'||CHR(13)||CHR(10)||
 '                                MIN(VEN.HORA) AS MINIMO,'                     ||CHR(13)||CHR(10)||
 '                                MAX(VEN.HORA) AS MAXIMO'                      ||CHR(13)||CHR(10)||
 '                           FROM DW_Vendas_Hora VEN'                           ||CHR(13)||CHR(10)||
 '                          WHERE VEN.DATA BETWEEN :date_dataini AND LAST_DAY(:date_dataini)'||CHR(13)||CHR(10)||
 '                          /*<opcional>*/'                                     ||CHR(13)||CHR(10)||
 '                            AND VEN.FILIAL IN (:set_filial)'                  ||CHR(13)||CHR(10)||
 '                          /*</opcional>*/'                                    ||CHR(13)||CHR(10)||
 '                         ) LIM ON DAT.HORA BETWEEN LIM.MINIMO AND LIM.MAXIMO' ||CHR(13)||CHR(10)||
 ' ORDER BY DAT.HORA');


/*-- SEQ 6637 --*/
-- Venda por Plano, Vendedor, Departamento, Unidades de Negcio e Classes
INSERT INTO TT_DEC
(ORIGEM, CODTAB, TITULO, SQLSTR)
VALUES 
('T', 104, 'Venda por Plano, Vendedor, Departamento, Unidades de Negcio e Classes',
 'SELECT :tbl_coluna AS GRUPO,'    ||CHR(13)||CHR(10)||
 '       SUM(VALOR) AS VALOR'      ||CHR(13)||CHR(10)||
 '  FROM DW_Vendas_Grupos'         ||CHR(13)||CHR(10)||
 ' WHERE ANO_MES = TO_CHAR(CAST(:date_dataini AS DATE),''YYYY'')||''-''||TO_CHAR(CAST(:date_dataini AS DATE),''MM'')'||CHR(13)||CHR(10)||
 ' /*<opcional>*/'                 ||CHR(13)||CHR(10)||
 '   AND FILIAL IN (:set_filial)'  ||CHR(13)||CHR(10)||
 ' /*</opcional>*/'                ||CHR(13)||CHR(10)||
 ' GROUP BY :tbl_coluna'           ||CHR(13)||CHR(10)||
 ' ORDER BY 2 DESC ');

/*-- SEQ 6638 --*/
-- Venda por Sexo, Estado Civil, Tipo de Pessoa, Profissao e Categorias
INSERT INTO TT_DEC
(ORIGEM, CODTAB, TITULO, SQLSTR)
VALUES 
('T', 105, 'Venda por Sexo, Estado Civil, Tipo de Pessoa e Categorias',
 'SELECT :tbl_coluna AS GRUPO,'    ||CHR(13)||CHR(10)||
 '       SUM(VALOR) AS VALOR'      ||CHR(13)||CHR(10)||
 '  FROM DW_Vendas_Cliente'        ||CHR(13)||CHR(10)||
 ' WHERE ANO_MES = TO_CHAR(CAST(:date_dataini AS DATE),''YYYY'')||''-''||TO_CHAR(CAST(:date_dataini AS DATE),''MM'')'||CHR(13)||CHR(10)||
 ' /*<opcional>*/'                 ||CHR(13)||CHR(10)||
 '   AND FILIAL IN (:set_filial)'  ||CHR(13)||CHR(10)||
 ' /*</opcional>*/'                ||CHR(13)||CHR(10)||
 ' GROUP BY :tbl_coluna'           ||CHR(13)||CHR(10)||
 ' ORDER BY 2 DESC ');


/*-- SEQ 6639 --*/
-- Indicadores de Venda
INSERT INTO TT_DEC
(ORIGEM, CODTAB, TITULO, SQLSTR)
VALUES 
('T', 106, 'Indicadores de Venda',
 'SELECT RES.*,'  													            	||CHR(13)||CHR(10)||
 '	     CASE WHEN META + ESCALA > VENDA THEN META + ESCALA'  	                    ||CHR(13)||CHR(10)||
'	          WHEN ESCALA = 0            THEN 0'              	                    ||CHR(13)||CHR(10)||
 '	          ELSE ESCALA * (1 + ROUND(VENDA / ESCALA))'     						||CHR(13)||CHR(10)||
 '	     END AS MAXIMO'  													        ||CHR(13)||CHR(10)||
 '  FROM (SELECT CODIGO_FILIAL, NOME_FILIAL, ANO, MES, UNIDADE, TOTAL_VENDAS, INDICADOR,'||CHR(13)||CHR(10)||
 '		         QTD, MINIMO, META, '						||CHR(13)||CHR(10)||
 '		         META - MINIMO AS ESCALA,'						||CHR(13)||CHR(10)||
 '		         ROUND(TOTAL_VENDAS / CASE WHEN QTD = 0 THEN 1 ELSE QTD END) AS VENDA'||CHR(13)||CHR(10)||
 '	        FROM (SELECT FIL.FILIAL AS CODIGO_FILIAL,'  							                        ||CHR(13)||CHR(10)||
 '	             		 FIL.NOME_FILIAL AS NOME_FILIAL,'  							                        ||CHR(13)||CHR(10)||
 '						 CTR.DESCRICAO AS UNIDADE,'  								                        ||CHR(13)||CHR(10)||
 '						 CASE UPPER(PAD.INDICADOR) WHEN ''MEDIA ITENS'' THEN INT.QTDITE '                   ||CHR(13)||CHR(10)|| 
 '							 						 ELSE INT.VLRLIQ'                                      ||CHR(13)||CHR(10)|| 
 '						 END AS TOTAL_VENDAS,'                                      ||CHR(13)||CHR(10)|| 
 '						 CASE UPPER(PAD.INDICADOR) WHEN ''MEDIA ITENS'' THEN INT.MEDITE ELSE INT.QTDITE END AS QTDITE,'||CHR(13)||CHR(10)|| 
 '						 INT.ANO, INT.MES, PAD.INDICADOR,'  			||CHR(13)||CHR(10)|| 
 '						 CASE WHEN UPPER(PAD.INDICADOR) = ''VENDA DIARIA'''				||CHR(13)||CHR(10)|| 
 '						 		THEN ROUND(COALESCE(MPF.MINIMO,MPF.META*.8,FIL.NIVCRI) /'		||CHR(13)||CHR(10)|| 
 '						 			CASE WHEN COALESCE(MPF.DIASUTEIS,0) = 0 THEN 30 ELSE MPF.DIASUTEIS END)'||CHR(13)||CHR(10)|| 
 '						 	ELSE COALESCE(MPI.MINIMO, PAD.MINIMO)'                ||CHR(13)||CHR(10)|| 
 '						 END AS MINIMO,'  											||CHR(13)||CHR(10)|| 
 '						 CASE WHEN UPPER(PAD.INDICADOR) = ''VENDA DIARIA'''				||CHR(13)||CHR(10)|| 
 '						 		THEN ROUND(COALESCE(MPF.META,FIL.VALOR1) / CASE WHEN COALESCE(MPF.DIASUTEIS,0) = 0 THEN 30 ELSE MPF.DIASUTEIS END)'||CHR(13)||CHR(10)|| 
 '						 		ELSE COALESCE(MPI.META, PAD.META)'					||CHR(13)||CHR(10)|| 
 '						 END AS META,'  											||CHR(13)||CHR(10)|| 
 '						 CASE UPPER(PAD.INDICADOR) WHEN ''M2''           THEN COALESCE(MPF.QTD_M2, FIL.QTD_M2, 0)'||CHR(13)||CHR(10)|| 
 '						 					WHEN ''FUNCIONARIOS'' THEN COALESCE(MPF.QTD_FUNCIONARIOS, FIL.QTDFUN, 0)'||CHR(13)||CHR(10)|| 
 '						 					WHEN ''VENDA DIARIA'' THEN COALESCE(INT.NUMDIA, 0)' ||CHR(13)||CHR(10)|| 
 '						 					WHEN ''ECFS''         THEN COALESCE(MPF.QTD_ECF, FIL.QTDECF)'||CHR(13)||CHR(10)|| 
 '						 					ELSE INT.QTDVEN'  						||CHR(13)||CHR(10)||
 '						 END AS QTD'      											||CHR(13)||CHR(10)||
 '					FROM (SELECT VEN.FILIAL, VEN.COD_UNIDADE,'						||CHR(13)||CHR(10)||
 '						 		TO_NUMBER(TO_CHAR(VEN.DATA,''MM'')) AS MES,'		||CHR(13)||CHR(10)||
 '						 		TO_NUMBER(TO_CHAR(VEN.DATA,''YYYY'')) AS ANO,'		||CHR(13)||CHR(10)||
 '						 		COUNT(DISTINCT VEN.DATA) AS NUMDIA,'				||CHR(13)||CHR(10)||
 '						 		SUM(COALESCE(VEN.VALOR, 0)) AS VLRLIQ,'	    	||CHR(13)||CHR(10)||
 '						 		SUM(COALESCE(VEN.QTD_VENDAS, 0)) AS QTDVEN,'		||CHR(13)||CHR(10)||
 '						 		SUM(COALESCE(VEN.QTD_ITENS, 0)) AS QTDITE, '		||CHR(13)||CHR(10)||
 '						 		AVG(COALESCE(VEN.QTD_ITENS, 0)) AS MEDITE '		||CHR(13)||CHR(10)||
 '						 	FROM DW_VENDAS VEN'										||CHR(13)||CHR(10)||
 '						 WHERE VEN.DATA >= :date_dataini'				    		||CHR(13)||CHR(10)||
 '						 	AND VEN.DATA < ADD_DAY(LAST_DAY(:date_dataini), 1)'    ||CHR(13)||CHR(10)||
 '            /*<opcional>*/ AND VEN.FILIAL IN (:set_filial) /*</opcional>*/'		||CHR(13)||CHR(10)||
 '            /*<opcional>*/ AND VEN.COD_UNIDADE IN (:STR_CODUNIDADE) /*</opcional>*/'||CHR(13)||CHR(10)||
 '						 	GROUP BY VEN.FILIAL, VEN.COD_UNIDADE,'					||CHR(13)||CHR(10)||
 '						 		TO_CHAR(VEN.DATA,''MM''),'							||CHR(13)||CHR(10)||
 '						 		TO_CHAR(VEN.DATA,''YYYY'')'						||CHR(13)||CHR(10)||
 '						 ) INT INNER JOIN DW_Filiais FIL ON FIL.FILIAL = INT.FILIAL'||CHR(13)||CHR(10)||
 '						 		LEFT JOIN DW_UnidadeNegocio CTR ON CTR.CODIGO = INT.COD_UNIDADE'||CHR(13)||CHR(10)|| 
 '						 		LEFT JOIN DW_Metas_Filiais MPF ON MPF.FILIAL = INT.FILIAL' 	 ||CHR(13)||CHR(10)|| 
 '						 								 		AND MPF.ANO = INT.ANO'  			 ||CHR(13)||CHR(10)|| 
 '						 								 		AND MPF.MES = INT.MES'  			 ||CHR(13)||CHR(10)|| 
 '						 								 		AND MPF.COD_UNIDADE = INT.COD_UNIDADE'||CHR(13)||CHR(10)|| 
 '			                     LEFT JOIN DW_Metas_Indicadores PAD ON PAD.ANO = 0'				 ||CHR(13)||CHR(10)|| 
 '						   	                                       AND PAD.MES = 0'  			 ||CHR(13)||CHR(10)|| 
 '                                                  /*<opcional>*/ AND TRIM(PAD.INDICADOR) = :str_indicador /*</opcional>*/'||CHR(13)||CHR(10)|| 
 '			                     LEFT JOIN DW_Metas_Indicadores MPI ON MPI.ANO = INT.ANO'	 	 ||CHR(13)||CHR(10)|| 
 '							                                       AND MPI.MES = INT.MES'  		 ||CHR(13)||CHR(10)|| 
 '							                                       AND MPI.INDICADOR = PAD.INDICADOR'||CHR(13)||CHR(10)|| 
 '     ) TAB ) RES');

/*-- SEQ 6640 --*/
-- Venda por Meio de Pagamento
INSERT INTO TT_DEC
(ORIGEM, CODTAB, TITULO, SQLSTR)
VALUES 
('T', 107, 'Venda por Meio de Pagamento',
 'SELECT MEIO AS GRUPO,'         ||CHR(13)||CHR(10)||
 '       SUM(VALOR) AS VALOR'    ||CHR(13)||CHR(10)||
 '  FROM DW_Vendas_Meio'         ||CHR(13)||CHR(10)||
 ' WHERE ANO_MES = TO_CHAR(CAST(:date_dataini AS DATE),''YYYY'')||''-''||TO_CHAR(CAST(:date_dataini AS DATE),''MM'')'||CHR(13)||CHR(10)||
 ' /*<opcional>*/'               ||CHR(13)||CHR(10)||
 '   AND FILIAL IN (:set_filial)'||CHR(13)||CHR(10)||
 '/*</opcional>*/'               ||CHR(13)||CHR(10)||
 ' GROUP BY MEIO'                ||CHR(13)||CHR(10)||
 ' ORDER BY 2 DESC');

/*-- SEQ 6641 --*/
-- Top Clientes
INSERT INTO TT_DEC
(ORIGEM, CODTAB, TITULO, SQLSTR)
VALUES
('T', 201, 'Top Clientes',
 'SELECT ATU.POS_ATUAL, ANT.POS_ANTERIOR,'                                           ||CHR(13)||CHR(10)||
 '       ATU.CLIENTE,'               ||CHR(13)||CHR(10)||
 '       ANT.VALOR AS ANT_VALOR,'                                                    ||CHR(13)||CHR(10)||
 '       ATU.VALOR AS ATU_VALOR,'                                                    ||CHR(13)||CHR(10)||
 '       ANT.QUANTIDADE AS ANT_QUANTIDADE,'                                          ||CHR(13)||CHR(10)||
 '       ATU.QUANTIDADE AS ATU_QUANTIDADE,'                                          ||CHR(13)||CHR(10)||
 '       ANT.MAIOR AS ANT_MAIOR,'                                                    ||CHR(13)||CHR(10)||
 '       ATU.MAIOR AS ATU_MAIOR,'                                                    ||CHR(13)||CHR(10)||
 '       CAST(ANT.MEDIA AS NUMERIC(14,2)) AS ANT_MEDIA,'                             ||CHR(13)||CHR(10)||
 '       CAST(ATU.MEDIA AS NUMERIC(14,2)) AS ATU_MEDIA,'                             ||CHR(13)||CHR(10)||
 '       (CAST(CASE WHEN COALESCE(ANT.VALOR   ,0) = 0 THEN 100.00 ELSE ATU.VALOR * 100 / ANT.VALOR    END AS NUMERIC(12))/100) AS VARIACAO,'     ||CHR(13)||CHR(10)||
 '        CAST(CASE WHEN COALESCE(TOTATU.VALOR,0) = 0 THEN 0      ELSE ATU.VALOR * 100 / TOTATU.VALOR END AS NUMERIC(14,2)) AS ATU_PARTICIPACAO,'||CHR(13)||CHR(10)||
 '        CAST(CASE WHEN COALESCE(TOTANT.VALOR,0) = 0 THEN 0      ELSE ANT.VALOR * 100 / TOTANT.VALOR END AS NUMERIC(14,2)) AS ANT_PARTICIPACAO,'||CHR(13)||CHR(10)||
 '       TOTATU.VALOR AS TOTAL_GERAL,'                                               ||CHR(13)||CHR(10)||
 '       ATU.FILIAL_CLIENTE AS FILIAL,'                                              ||CHR(13)||CHR(10)||
 '       ATU.CODIGO_CLIENTE AS CODIGO'                                               ||CHR(13)||CHR(10)||
 '  FROM (SELECT 1 AS IND, 1 AS POS_ATUAL, I1.*'                                     ||CHR(13)||CHR(10)||
 '          FROM (SELECT FILIAL_CLIENTE,'                                            ||CHR(13)||CHR(10)||
 '                       CODIGO_CLIENTE,'                                            ||CHR(13)||CHR(10)||
'                        NOME_COMPLETO AS CLIENTE,'                                                   ||CHR(13)||CHR(10)||
 '                       SUM(VEN.VALOR) AS VALOR,'                                   ||CHR(13)||CHR(10)||
 '                       COUNT(VEN.VALOR) AS QUANTIDADE,'                            ||CHR(13)||CHR(10)||
 '                       MAX(VEN.VALOR) AS MAIOR,'                                   ||CHR(13)||CHR(10)||
 '                       AVG(VEN.VALOR) AS MEDIA'                                    ||CHR(13)||CHR(10)||
 '                  FROM dw_vendas_cliente VEN'                                      ||CHR(13)||CHR(10)||
 '                 WHERE VEN.ANO_MES BETWEEN :str_anomesiniatu AND :str_anomesfimatu'||CHR(13)||CHR(10)||
 '                   AND VEN.CONSUMIDOR = ''F'' '                                    ||CHR(13)||CHR(10)||
 '    /*<opcional>*/ AND FILIAL IN (:set_filial) /*</opcional>*/'                    ||CHR(13)||CHR(10)||
 '                 GROUP BY FILIAL_CLIENTE, CODIGO_CLIENTE, NOME_COMPLETO'           ||CHR(13)||CHR(10)||
 '                 ORDER BY SUM(VEN.VALOR) DESC) I1'                                 ||CHR(13)||CHR(10)||
 '       WHERE ROWNUM<=  :INT_TOP) ATU'                                                        ||CHR(13)||CHR(10)||
 '       LEFT JOIN'                                                                  ||CHR(13)||CHR(10)||
 '       (SELECT 1 AS POS_ANTERIOR, INT.*'                                           ||CHR(13)||CHR(10)||
 '          FROM (SELECT FILIAL_CLIENTE,'                                            ||CHR(13)||CHR(10)||
 '                       CODIGO_CLIENTE,'                                            ||CHR(13)||CHR(10)||
 '                       SUM(VEN.VALOR) AS VALOR,'                                   ||CHR(13)||CHR(10)||
 '                       COUNT(VEN.VALOR) AS QUANTIDADE,'                            ||CHR(13)||CHR(10)||
 '                       MAX(VEN.VALOR) AS MAIOR,'                                   ||CHR(13)||CHR(10)||
 '                       AVG(VEN.VALOR) AS MEDIA'                                    ||CHR(13)||CHR(10)||
 '                  FROM dw_vendas_cliente VEN'                                      ||CHR(13)||CHR(10)||
 '                 WHERE VEN.ANO_MES BETWEEN :STR_ANOMESINIANT AND :STR_ANOMESFIMANT'||CHR(13)||CHR(10)||
 '                   AND VEN.CONSUMIDOR = ''F'''                                     ||CHR(13)||CHR(10)||
 '    /*<opcional>*/ AND FILIAL IN (:set_filial) /*</opcional>*/'                    ||CHR(13)||CHR(10)||
 '                 GROUP BY FILIAL_CLIENTE, CODIGO_CLIENTE'                          ||CHR(13)||CHR(10)||
 '                 ORDER BY SUM(VEN.VALOR) DESC'                                     ||CHR(13)||CHR(10)||
 '                ) INT ) ANT ON ATU.FILIAL_CLIENTE = ANT.FILIAL_CLIENTE'            ||CHR(13)||CHR(10)|| 
 '                           AND ATU.CODIGO_CLIENTE = ANT.CODIGO_CLIENTE'            ||CHR(13)||CHR(10)||
 '       LEFT JOIN'                                                                  ||CHR(13)||CHR(10)||
 '       (SELECT 1 AS IND, SUM(VEN.VALOR) AS VALOR'                                  ||CHR(13)||CHR(10)||
 '          FROM dw_vendas_cliente VEN'                                              ||CHR(13)||CHR(10)||
 '         WHERE VEN.ANO_MES BETWEEN :str_anomesiniatu AND :str_anomesfimatu'        ||CHR(13)||CHR(10)||
 '           AND VEN.CONSUMIDOR = ''F'''                                             ||CHR(13)||CHR(10)||
 '         /*<opcional>*/ AND FILIAL IN (:set_filial) /*</opcional>*/'               ||CHR(13)||CHR(10)||
 '        ) TOTATU ON TOTATU.IND = ATU.IND'                                          ||CHR(13)||CHR(10)||
 '       LEFT JOIN'                                                                  ||CHR(13)||CHR(10)||
 '       (SELECT 1 AS IND, SUM(VEN.VALOR) AS VALOR'                                  ||CHR(13)||CHR(10)||
 '          FROM dw_vendas_cliente VEN'                                              ||CHR(13)||CHR(10)||
 '         WHERE VEN.ANO_MES BETWEEN :STR_ANOMESINIANT AND :STR_ANOMESFIMANT'        ||CHR(13)||CHR(10)||
 '           AND VEN.CONSUMIDOR = ''F'''                                             ||CHR(13)||CHR(10)||
 '         /*<opcional>*/ AND FILIAL IN (:set_filial) /*</opcional>*/'               ||CHR(13)||CHR(10)||
 '        ) TOTANT ON TOTANT.IND = ATU.IND'                                      ||CHR(13)||CHR(10)||
 ' ORDER BY ATU.POS_ATUAL');

/*-- SEQ 6642 --*/
-- Venda de Cliente por Plano, vendedor, Unidade de Negcio, Departamento e Classes
INSERT INTO TT_DEC
(ORIGEM, CODTAB, TITULO, SQLSTR)
VALUES 
('T', 202, 'Venda de Cliente por Plano, vendedor, Unidade de Negcio, Departamento e Classes',
 'SELECT :tbl_coluna AS GRUPO,'                             ||CHR(13)||CHR(10)||
 '       SUM(VALOR) AS VALOR,'                              ||CHR(13)||CHR(10)||
 '       SUM(QUANTIDADE) AS QUANTIDADE,'                    ||CHR(13)||CHR(10)||
 '       COUNT(*) AS ITENS'                                 ||CHR(13)||CHR(10)||
 '  FROM DW_Vendas_Cliente_Produto'                         ||CHR(13)||CHR(10)||
 ' WHERE FILIAL_CLIENTE = :str_filialcliente'               ||CHR(13)||CHR(10)||
 '   AND CODIGO_CLIENTE = :str_codigocliente'               ||CHR(13)||CHR(10)||
 '   AND DATA BETWEEN :date_dataini AND :date_datafim'      ||CHR(13)||CHR(10)||
 ' /*<opcional>*/ FILIAL IN (:set_filial) /*</opcional>*/'  ||CHR(13)||CHR(10)||
 ' GROUP BY :tbl_coluna');


/*-- SEQ 6643 --*/
-- Vendas de 1 cliente (2 anos)
INSERT INTO TT_DEC
(ORIGEM, CODTAB, TITULO, SQLSTR)
VALUES
('T', 203, 'Vendas de 1 cliente (2 anos)',
 'SELECT MES.MES,'                                                                  ||CHR(13)||CHR(10)||
 '       MES.ANO,'                                                                  ||CHR(13)||CHR(10)||
 '       ATU.VALOR AS ATU_VALOR,'                                                   ||CHR(13)||CHR(10)||
 '       ANT.VALOR AS ANT_VALOR,'                                                   ||CHR(13)||CHR(10)||
 '       ATU.QTD_ITENS  AS ATU_QTD_ITENS,'                                          ||CHR(13)||CHR(10)||
 '       ANT.QTD_ITENS  AS ANT_QTD_ITENS,'                                          ||CHR(13)||CHR(10)||
 '       ATU.QTD_VENDAS AS ATU_QTD_VENDAS,'                                         ||CHR(13)||CHR(10)||
 '       ANT.QTD_VENDAS AS ANT_QTD_VENDAS'                                          ||CHR(13)||CHR(10)||
 '  FROM (SELECT TO_CHAR(DATOPE, ''MM'') AS MES, TO_CHAR(DATOPE, ''YYYY'') AS ANO, TO_CHAR(DATOPE, ''YYYY-MM'') AS ANO_MES'||CHR(13)||CHR(10)||
 '          FROM TT_DAT'                                                            ||CHR(13)||CHR(10)||
 '         WHERE DATOPE BETWEEN TO_DATE(''01/''||:str_mesini||''/''||:str_anoini,''dd/mm/yyyy'')'||CHR(13)||CHR(10)||
 '           AND TO_DATE(''01/''||:str_mesfim||''/''||:str_anofim,''dd/mm/yyyy'')'  ||CHR(13)||CHR(10)||
 '         GROUP BY TO_CHAR(DATOPE, ''MM''), TO_CHAR(DATOPE, ''YYYY''), TO_CHAR(DATOPE, ''YYYY-MM'')'||CHR(13)||CHR(10)||
 '        ) MES LEFT JOIN (SELECT SUBSTR(ANO_MES,6,2) AS MES,'                      ||CHR(13)||CHR(10)||
 '                                ANO_MES,'                                         ||CHR(13)||CHR(10)||
 '                                SUM(VALOR) AS VALOR,'                             ||CHR(13)||CHR(10)||
 '                                SUM(QTD_ITENS) AS QTD_ITENS,'                     ||CHR(13)||CHR(10)||
 '                                SUM(QTD_VENDAS) AS QTD_VENDAS'                    ||CHR(13)||CHR(10)||
 '                           FROM DW_Vendas_Cliente'                                ||CHR(13)||CHR(10)||
 '                          WHERE ANO_MES BETWEEN :str_anoini||''-''||:str_mesini'  ||CHR(13)||CHR(10)||
 '                            AND :str_anofim||''-''||:str_mesfim'                  ||CHR(13)||CHR(10)||
 '                            AND FILIAL_CLIENTE = :str_filialcliente'              ||CHR(13)||CHR(10)||
 '                            AND CODIGO_CLIENTE = :str_codigocliente'              ||CHR(13)||CHR(10)||
 '             /*<opcional>*/ AND FILIAL IN (:set_filial) /*</opcional>*/'          ||CHR(13)||CHR(10)||
 '                          GROUP BY ANO_MES'                                       ||CHR(13)||CHR(10)||
 '                         ) ATU ON ATU.MES = MES.MES LEFT JOIN (SELECT SUBSTR(ANO_MES,6,2) AS MES,'  ||CHR(13)||CHR(10)||
 '                                                                      ANO_MES,'                     ||CHR(13)||CHR(10)||
 '                                                                      SUM(VALOR) AS VALOR,'         ||CHR(13)||CHR(10)||
 '                                                                      SUM(QTD_ITENS) AS QTD_ITENS,' ||CHR(13)||CHR(10)||
 '                                                                      SUM(QTD_VENDAS) AS QTD_VENDAS'||CHR(13)||CHR(10)||
 '                                                                 FROM DW_Vendas_Cliente'            ||CHR(13)||CHR(10)||
 '                                                                WHERE ANO_MES BETWEEN REPLACE(TO_CHAR(TO_NUMBER(:str_anoini)-1, ''9999''),'' '', '''')||''-''||:str_mesini'||CHR(13)||CHR(10)||
 '                                                                  AND REPLACE(TO_CHAR(TO_NUMBER(:str_anofim)-1, ''9999''),'' '', '''')||''-''||:str_mesfim'||CHR(13)||CHR(10)||
 '                                                                  AND FILIAL_CLIENTE = :str_filialcliente'    ||CHR(13)||CHR(10)||
 '                                                                  AND CODIGO_CLIENTE = :str_codigocliente'    ||CHR(13)||CHR(10)||
 '                                                   /*<opcional>*/ AND FILIAL IN (:set_filial) /*</opcional>*/'||CHR(13)||CHR(10)||
 '                                                                GROUP BY ANO_MES'                             ||CHR(13)||CHR(10)||
 '                                                               ) ANT ON ANT.MES = MES.MES'                    ||CHR(13)||CHR(10)||
 ' ORDER BY MES.ANO_MES');


/*-- SEQ 6644 --*/
-- Lista de Departamentos e Classes
INSERT INTO TT_DEC
(ORIGEM, CODTAB, TITULO, SQLSTR)
VALUES
('T', 301, 'Lista de departamento e classes',
 'SELECT DISTINCT :tbl_campo AS CODTAB, :tbl_campo2 AS DESCRICAO'||CHR(13)||CHR(10)||
 '  FROM Dw_produto '                                            ||CHR(13)||CHR(10)||
 '/*<opcional>*/'                                                ||CHR(13)||CHR(10)||
 ' WHERE :tbl_grupo = :int_grupo'                                ||CHR(13)||CHR(10)||
 '/*</opcional>*/'                                               ||CHR(13)||CHR(10)||
 ' ORDER BY :tbl_campo2');


/*-- SEQ 6645 --*/
-- Lista de Produtos
INSERT INTO TT_DEC
(ORIGEM, CODTAB, TITULO, SQLSTR)
VALUES
('T', 302, 'Lista dos produtos',
 'SELECT ITE.*, TRUNC(ITE.VALOR * 100 / PAR.VALOR, 3) AS PARTICIPACAO' ||CHR(13)||CHR(10)||
 '  FROM (SELECT ''FALSE'' AS SELPRO, PRO.COD_PRODUTO, PRO.PRODUTO,'   ||CHR(13)||CHR(10)||
 '               SUM(VEN.QUANTIDADE) AS QUANTIDADE,'                   ||CHR(13)||CHR(10)||
 '               TRUNC(SUM(VEN.VALOR),2) AS VALOR'                     ||CHR(13)||CHR(10)||
 '          FROM DW_PRODUTO PRO INNER JOIN DW_VENDAS_PRODUTO VEN ON VEN.COD_PRODUTO = PRO.COD_PRODUTO' ||CHR(13)||CHR(10)||
 '             WHERE VEN.ANO_MES BETWEEN TO_CHAR(CAST(:date_dataini AS DATE),''YYYY-MM'') AND TO_CHAR(CAST(:date_datafim AS DATE),''YYYY-MM'')'||CHR(13)||CHR(10)||
 '/*<opcional>*/ AND PRO.COD_DEPARTAMENTO = COALESCE(:int_depart, PRO.COD_DEPARTAMENTO)'                ||CHR(13)||CHR(10)||
 '/*<opcional>*/ AND PRO.COD_CLASSE1 = COALESCE(:int_class1, PRO.COD_CLASSE1) /*</opcional>*/' ||CHR(13)||CHR(10)||
 '/*<opcional>*/ AND PRO.COD_CLASSE2 = COALESCE(:int_class2, PRO.COD_CLASSE2) /*</opcional>*/' ||CHR(13)||CHR(10)||
 '/*<opcional>*/ AND PRO.COD_CLASSE3 = COALESCE(:int_class3, PRO.COD_CLASSE3) /*</opcional>*/' ||CHR(13)||CHR(10)||
 '/*<opcional>*/ AND PRO.COD_CLASSE4 = COALESCE(:int_class4, PRO.COD_CLASSE4) /*</opcional>*/' ||CHR(13)||CHR(10)||
 '/*<opcional>*/ AND VEN.FILIAL IN (:set_filial) /*</opcional>*/'          ||CHR(13)||CHR(10)||
 '         GROUP BY PRO.COD_PRODUTO, PRO.PRODUTO'                          ||CHR(13)||CHR(10)||
 '        ) ITE,'                                                          ||CHR(13)||CHR(10)||
 '       (SELECT SUM(TOT.VALOR) AS VALOR'                                  ||CHR(13)||CHR(10)||
 '          FROM Dw_Vendas tot'                                            ||CHR(13)||CHR(10)||
 '         WHERE TOT.DATA BETWEEN :date_dataini AND :date_datafim'         ||CHR(13)||CHR(10)||
 '         /*<opcional>*/ AND TOT.FILIAL IN (:set_filial) /*</opcional>*/' ||CHR(13)||CHR(10)||
 '        ) PAR'                                                           ||CHR(13)||CHR(10)||
 ' ORDER BY ITE.VALOR DESC');

/*-- SEQ 6646 --*/
-- Movimento dos Produtos
INSERT INTO TT_DEC
(ORIGEM, CODTAB, TITULO, SQLSTR)
VALUES
('T', 303, 'Movimento dos produtos',
'SELECT pro.COD_PRODUTO AS PRODUTO, cast(to_char(dat.datope,''YYYY-MM'') as varchar(7)) as ANO_MES,        ' ||CHR(13)||CHR(10)||
'       coalesce(SUM(VEN.QUANTIDADE),0) AS QUANTIDADE,                                                     ' ||CHR(13)||CHR(10)||
'       coalesce(SUM(VEN.VALOR),0) AS VALOR                                                                ' ||CHR(13)||CHR(10)||
'  FROM tt_dat dat cross join dw_produto pro                                                               ' ||CHR(13)||CHR(10)||
'                  left join DW_VENDAS_PRODUTO VEN on VEN.ANO_MES = to_char(dat.datope,''YYYY-MM'')        ' ||CHR(13)||CHR(10)||
'                                                 AND VEN.COD_PRODUTO = PRO.COD_PRODUTO                    ' ||CHR(13)||CHR(10)||
'         /*<OPCIONAL>*/ AND VEN.FILIAL IN ( :set_filial ) /*</OPCIONAL>*/                                 ' ||CHR(13)||CHR(10)||
' WHERE to_char(dat.datope,''DD'')=''01''                                                                  ' ||CHR(13)||CHR(10)||
' and dat.datope BETWEEN to_date(''01/''||to_char(CAST(:date_dataini AS DATE),''mm/yyyy''),''dd/mm/yyyy'') ' ||CHR(13)||CHR(10)||
'                    AND last_day(CAST(:date_datafim AS DATE))                                             ' ||CHR(13)||CHR(10)|| 
' and pro.COD_PRODUTO IN ( :set_produtos )                                                                 ' ||CHR(13)||CHR(10)||
' GROUP BY pro.COD_PRODUTO, to_char(dat.datope,''YYYY-MM'')                                                ' ||CHR(13)||CHR(10)||
' ORDER BY pro.COD_PRODUTO, to_char(dat.datope,''YYYY-MM'')                                                ' );


/*-- SEQ 6647 --*/
/*-- IGNORE ERRO --*/
alter table tt_arq drop constraint fk_arq_arq;

/*-- SEQ 6648 --*/
/*-- IGNORE ERRO --*/
alter table tt_lay drop constraint fk_lay_arq_origem;

/*-- SEQ 6649 --*/
/*-- IGNORE ERRO --*/
alter table tt_lay drop constraint fk_lay_arq_arqlis;

/*-- SEQ 6650 --*/
/*-- IGNORE ERRO --*/
alter table tt_sql drop constraint fk_sql_arq_codori;

/*-- SEQ 6651 --*/
/*-- IGNORE ERRO --*/
alter table tt_sql drop constraint fk_sql_arq_coddes;

/*-- SEQ 6652 --*/
/*-- IGNORE ERRO --*/
alter table tp_lay drop constraint fk_play_arq;

/*-- SEQ 6653 --*/
delete from tt_dom;

/*-- SEQ 6654 --*/
delete from tt_lay;

/*-- SEQ 6655 --*/
delete from tt_gru;

/*-- SEQ 6656 --*/
delete from tt_sql;

/*-- SEQ 6657 --*/
delete from tt_arq;
/*-- SEQ 6658 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT '50CI',
       TO_NUMBER(null),
       '50CI',
       'Fis.50c Interno',
       'TV_FIS_50CINTERNO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '50CI.CODFIL,50CI.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6659 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT '50CI','--','' FROM DUAL
UNION ALL
SELECT '50CI','01','Identificao' FROM DUAL
UNION ALL
SELECT '50CI','02','Datas' FROM DUAL
UNION ALL
SELECT '50CI','03','Valores' FROM DUAL
UNION ALL
SELECT '50CI','99','Outros' FROM DUAL
);

/*-- SEQ 6660 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT '50CI',
       '03',
       10,
       12,
       'BASICM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Base de ICMS',
       'Base de ICMS',
       '',
       'BASICM',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '03',
       20,
       12,
       'BASINT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Base Int.',
       'Base Int.',
       '',
       'BASINT',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial Compra',
       'Filial da compra',
       'DFIL.CODFIL = 50CI.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '01',
       40,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Fornecedor',
       'Cdigo do Fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '01',
       50,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Srie',
       'Cdigo Srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '02',
       60,
       7,
       'DATAOK',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data OK',
       'Data OK',
       '',
       'DATAOK',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '03',
       70,
       8,
       'DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Desconto',
       'Desconto da compra',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '01',
       80,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial origem do fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '99',
       90,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT '50CI',
       '03',
       100,
       8,
       'ICMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% de ICMS',
       'ICMS por Item',
       '',
       'ICMITE',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '01',
       110,
       2,
       'MODNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mod.~Nota',
       'Mod.~Nota',
       '',
       'MODNOT',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '01',
       120,
       12,
       'NATURE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       '9',
       'F',
       'Natureza da Operao',
       'Natureza da Operao',
       '',
       'NATURE',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '01',
       270,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '01',
       280,
       12,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nmero de Endereos',
       'Nmero de Endereos',
       '',
       'NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '01',
       130,
       8,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nro Nota',
       'Nro da nota da compra',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '99',
       140,
       12,
       'OUTRAS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Outras',
       'Outras',
       '',
       'OUTRAS',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '99',
       150,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '01',
       160,
       3,
       'SEREXP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie~como',
       'Srie~como',
       '',
       'SEREXP',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '01',
       170,
       2,
       'SUBEXP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'SubSrie~como',
       'SubSrie~como',
       '',
       'SUBEXP',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '01',
       180,
       3,
       'SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Sub-Srie',
       'Sub-Srie de compra',
       '',
       'SUBSER',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '01',
       190,
       1,
       'TIPNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Nota',
       'Tipo de Nota',
       '',
       'TIPNOT',
       'T' FROM DUAL
UNION ALL
SELECT '50CI',
       '01',
       200,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo do Parceiro',
       'Tipo de Parceiro',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT '50CI',
       '01',
       210,
       2,
       'UFNOTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF da Nota',
       'UF da Nota',
       '',
       'UFNOTA',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '03',
       220,
       8,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'ICMS do Item',
       'Valor do ICMS do item da compra',
       '',
       'VLRICM',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '03',
       230,
       8,
       'VLRIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'IPI do Item',
       'Valor do IPI do item da compra',
       '',
       'VLRIPI',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '03',
       240,
       8,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Lquido',
       'Valor Lquido da compra',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '03',
       250,
       8,
       'VLRSUB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Subt. Tribut. Compra',
       'Valor total da substituio tributria da compra',
       '',
       'VLRSUB',
       'F' FROM DUAL
UNION ALL
SELECT '50CI',
       '03',
       260,
       8,
       'VLRTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Total',
       'Valor total da compra',
       '',
       'VLRTOT',
       'F' FROM DUAL
);

/*-- SEQ 6661 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT '50CI',
       'FLGEST',
       0,
       'A',
       'Em Aberta',
       102,
       ' ' FROM DUAL
UNION ALL
SELECT '50CI',
       'FLGEST',
       0,
       'C',
       'Cancelada',
       100,
       ' ' FROM DUAL
UNION ALL
SELECT '50CI',
       'FLGEST',
       0,
       'Q',
       'Quitada',
       101,
       ' ' FROM DUAL
UNION ALL
SELECT '50CI',
       'TIPNOT',
       0,
       'A',
       'N.F.F.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT '50CI',
       'TIPNOT',
       0,
       'F',
       'Fatura',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT '50CI',
       'TIPNOT',
       0,
       'N',
       'Nota fiscal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT '50CI',
       'TIPPAR',
       0,
       'F',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT '50CI',
       'TIPPAR',
       0,
       'T',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6662 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT '50VI',
       TO_NUMBER(null),
       '50VI',
       'Fis. x 50 int.',
       'TV_FIS_50VINTERNO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '50VI.CODFIL,50VI.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6663 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT '50VI','--','' FROM DUAL
UNION ALL
SELECT '50VI','01','Identificao' FROM DUAL
UNION ALL
SELECT '50VI','02','Datas' FROM DUAL
UNION ALL
SELECT '50VI','03','Valores' FROM DUAL
UNION ALL
SELECT '50VI','99','Outros' FROM DUAL
);

/*-- SEQ 6664 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT '50VI',
       '03',
       10,
       12,
       'BASICM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Base de ICMS',
       'Base de ICMS',
       '',
       'BASICM',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '03',
       20,
       12,
       'BASINT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Base Int.',
       'Base Int.',
       '',
       'BASINT',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '01',
       30,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '01',
       40,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial Compra',
       'Filial da compra',
       'DFIL.CODFIL = 50VI.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '01',
       50,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Srie',
       'Cdigo Srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '02',
       60,
       7,
       'DATAOK',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data OK',
       'Data OK',
       '',
       'DATAOK',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '03',
       70,
       12,
       'ENDFAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Endereo Fatura',
       'Endereo Fatura',
       '',
       'ENDFAT',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '01',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '01',
       90,
       3,
       'FILFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Fatura',
       '',
       'FILFAT',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '99',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT '50VI',
       '01',
       110,
       2,
       'MODNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mod.~Nota',
       'Mod.~Nota',
       '',
       'MODNOT',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '01',
       120,
       12,
       'NATURE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       '9',
       'F',
       'Natureza da Operao',
       'Natureza da Operao',
       '',
       'NATURE',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '01',
       130,
       3,
       'NUMECF',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       'F',
       'Nmero do ECF',
       'Nmero do ECF',
       'DECF.FILECF = 50VI.CODFIL AND DECF.NUMECF = 50VI.NUMECF',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '01',
       140,
       8,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nro Nota',
       'Nro da nota da compra',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '03',
       150,
       12,
       'OUTRAS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Outras',
       'Outras',
       '',
       'OUTRAS',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '03',
       160,
       12,
       'PERICM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '% de ICMS',
       '% de ICMS',
       '',
       'PERICM',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '03',
       170,
       12,
       'REDTOT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Total Reduo',
       'Total Reduo ',
       '',
       'REDTOT',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '01',
       180,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '01',
       190,
       3,
       'SEREXP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie~como',
       'Srie~como',
       '',
       'SEREXP',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '01',
       200,
       2,
       'SUBEXP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'SubSrie~como',
       'SubSrie~como',
       '',
       'SUBEXP',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '03',
       210,
       12,
       'SUBSTT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Subst. Tributria',
       'Subst. Tributria',
       '',
       'SUBSTT',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '99',
       220,
       1,
       'UFLOJA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tem UF?',
       'Tem UF?',
       '',
       'UFLOJA',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '03',
       230,
       8,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'ICMS do Item',
       'Valor do ICMS do item da compra',
       '',
       'VLRICM',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '03',
       240,
       8,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Lquido',
       'Valor Lquido da compra',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT '50VI',
       '03',
       250,
       12,
       'VLRNOT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor da Nota',
       'Valor da Nota',
       '',
       'VLRNOT',
       'F' FROM DUAL
);

/*-- SEQ 6665 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT '50VI',
       'FLGEST',
       0,
       'A',
       'Em Aberta',
       102,
       ' ' FROM DUAL
UNION ALL
SELECT '50VI',
       'FLGEST',
       0,
       'C',
       'Cancelada',
       100,
       ' ' FROM DUAL
UNION ALL
SELECT '50VI',
       'FLGEST',
       0,
       'Q',
       'Quitada',
       101,
       ' ' FROM DUAL
);

/*-- SEQ 6666 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT '51CI',
       TO_NUMBER(null),
       '51CI',
       'Fis.51c Interno',
       'TV_FIS_51CINTERNO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '51CI.CODFIL,51CI.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6667 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT '51CI','--','' FROM DUAL
UNION ALL
SELECT '51CI','01','Identificao' FROM DUAL
UNION ALL
SELECT '51CI','99','Outros' FROM DUAL
);

/*-- SEQ 6668 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT '51CI',
       '01',
       10,
       12,
       'BASINT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Base Int.',
       'Base Int.',
       '',
       'BASINT',
       'F' FROM DUAL
UNION ALL
SELECT '51CI',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial Compra',
       'Filial da compra',
       'DFIL.CODFIL = 51CI.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT '51CI',
       '01',
       30,
       7,
       'DATAOK',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data OK',
       'Data OK',
       '',
       'DATAOK',
       'F' FROM DUAL
UNION ALL
SELECT '51CI',
       '01',
       40,
       12,
       'NATURE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       '9',
       'F',
       'Natureza da Operao',
       'Natureza da Operao',
       '',
       'NATURE',
       'F' FROM DUAL
UNION ALL
SELECT '51CI',
       '01',
       50,
       12,
       'OUTRAS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Outras',
       'Outras',
       '',
       'OUTRAS',
       'F' FROM DUAL
UNION ALL
SELECT '51CI',
       '01',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT '51CI',
       '01',
       70,
       8,
       'VLRIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'IPI do Item',
       'Valor do IPI do item da compra',
       '',
       'VLRIPI',
       'F' FROM DUAL
);

/*-- SEQ 6669 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT '51VI',
       TO_NUMBER(null),
       '51VI',
       'Fis.x 51Interno',
       'TV_FIS_51VINTERNO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '51VI.CODFIL,51VI.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6670 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT '51VI','--','' FROM DUAL
UNION ALL
SELECT '51VI','01','Identificao' FROM DUAL
UNION ALL
SELECT '51VI','99','Outros' FROM DUAL
);

/*-- SEQ 6671 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT '51VI',
       '01',
       10,
       12,
       'BASINT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Base Int.',
       'Base Int.',
       '',
       'BASINT',
       'F' FROM DUAL
UNION ALL
SELECT '51VI',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial Compra',
       'Filial da compra',
       'DFIL.CODFIL = 50VI.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT '51VI',
       '01',
       30,
       7,
       'DATAOK',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data OK',
       'Data OK',
       '',
       'DATAOK',
       'F' FROM DUAL
UNION ALL
SELECT '51VI',
       '01',
       40,
       12,
       'OUTRAS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Outras',
       'Outras',
       '',
       'OUTRAS',
       'F' FROM DUAL
UNION ALL
SELECT '51VI',
       '01',
       50,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT '51VI',
       '01',
       60,
       12,
       'VLRIPI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor IPI',
       'Valor IPI',
       '',
       'VLRIPI',
       'F' FROM DUAL
);

/*-- SEQ 6672 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT '70CI',
       TO_NUMBER(null),
       '70CI',
       'Fis.70c Interno',
       'TV_FIS_70CINTERNO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '70CI.CODFIL,70CI.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6673 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT '70CI','--','' FROM DUAL
UNION ALL
SELECT '70CI','01','Identificao' FROM DUAL
UNION ALL
SELECT '70CI','02','Datas' FROM DUAL
UNION ALL
SELECT '70CI','03','Valores' FROM DUAL
UNION ALL
SELECT '70CI','99','Outros' FROM DUAL
);

/*-- SEQ 6674 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT '70CI',
       '03',
       10,
       12,
       'BASICM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Base de ICMS',
       'Base de ICMS',
       '',
       'BASICM',
       'F' FROM DUAL
UNION ALL
SELECT '70CI',
       '03',
       20,
       12,
       'BASINT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Base Int.',
       'Base Int.',
       '',
       'BASINT',
       'F' FROM DUAL
UNION ALL
SELECT '70CI',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial Compra',
       'Filial da compra',
       'DFIL.CODFIL = 70CI.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT '70CI',
       '01',
       40,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Fornecedor',
       'Cdigo do Fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT '70CI',
       '01',
       50,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Srie',
       'Cdigo Srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT '70CI',
       '02',
       60,
       7,
       'DATAOK',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data OK',
       'Data OK',
       '',
       'DATAOK',
       'F' FROM DUAL
UNION ALL
SELECT '70CI',
       '03',
       70,
       8,
       'DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Desconto',
       'Desconto da compra',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT '70CI',
       '01',
       80,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial origem do fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT '70CI',
       '99',
       90,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT '70CI',
       '03',
       100,
       8,
       'ICMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% de ICMS',
       'ICMS por Item',
       '',
       'ICMITE',
       'F' FROM DUAL
UNION ALL
SELECT '70CI',
       '01',
       110,
       12,
       'NATURE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       '9',
       'F',
       'Natureza da Operao',
       'Natureza da Operao',
       '',
       'NATURE',
       'F' FROM DUAL
UNION ALL
SELECT '70CI',
       '01',
       120,
       8,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nro Nota',
       'Nro da nota da compra',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT '70CI',
       '03',
       130,
       12,
       'OUTRAS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Outras',
       'Outras',
       '',
       'OUTRAS',
       'F' FROM DUAL
UNION ALL
SELECT '70CI',
       '01',
       140,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT '70CI',
       '01',
       150,
       3,
       'SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Sub-Srie',
       'Sub-Srie de compra',
       '',
       'SUBSER',
       'F' FROM DUAL
UNION ALL
SELECT '70CI',
       '01',
       160,
       1,
       'TIPNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Nota',
       'Tipo de Nota',
       '',
       'TIPNOT',
       'T' FROM DUAL
UNION ALL
SELECT '70CI',
       '01',
       170,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo do Parceiro',
       'Tipo de Parceiro',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT '70CI',
       '01',
       180,
       2,
       'UFNOTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF da Nota',
       'UF da Nota',
       '',
       'UFNOTA',
       'F' FROM DUAL
UNION ALL
SELECT '70CI',
       '03',
       190,
       8,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'ICMS do Item',
       'Valor do ICMS do item da compra',
       '',
       'VLRICM',
       'F' FROM DUAL
UNION ALL
SELECT '70CI',
       '03',
       200,
       8,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Lquido',
       'Valor Lquido da compra',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT '70CI',
       '03',
       210,
       8,
       'VLRTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Total',
       'Valor total da compra',
       '',
       'VLRTOT',
       'F' FROM DUAL
);

/*-- SEQ 6675 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT '70CI',
       'FLGEST',
       0,
       'A',
       'Em Aberta',
       102,
       ' ' FROM DUAL
UNION ALL
SELECT '70CI',
       'FLGEST',
       0,
       'C',
       'Cancelada',
       100,
       ' ' FROM DUAL
UNION ALL
SELECT '70CI',
       'FLGEST',
       0,
       'Q',
       'Quitada',
       101,
       ' ' FROM DUAL
UNION ALL
SELECT '70CI',
       'TIPNOT',
       0,
       'A',
       'N.F.F.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT '70CI',
       'TIPNOT',
       0,
       'F',
       'Fatura',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT '70CI',
       'TIPNOT',
       0,
       'N',
       'Nota fiscal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT '70CI',
       'TIPPAR',
       0,
       'F',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT '70CI',
       'TIPPAR',
       0,
       'T',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6676 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ABA ',
       TO_NUMBER(null),
       'ABA ',
       'Abastecimentos',
       'TT_ABA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CODFIL, SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6677 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ABA ','--','' FROM DUAL
UNION ALL
SELECT 'ABA ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ABA ','99','Outros' FROM DUAL
);

/*-- SEQ 6678 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22114,
       'IVE ',
       'ABA ',
       '0N',
       '01',
       '',
       '',
       'ABA.FILIVE = IVE.CODFIL(+) AND
ABA.SEQIVE = IVE.SEQUEN(+) AND
ABA.NUMIVE = IVE.NUMITE(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22115,
       'USU ',
       'ABA ',
       '01',
       '0N',
       '',
       '',
       'ABA.FILUSU = USU.FILUSU(+) AND
ABA.CODUSU = USU.CODUSU(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 6679 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ABA ',
       '--',
       150,
       1,
       'ABSAUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Abast. Automtico?',
       'Abastecimento Automtico?',
       '',
       'ABSAUT',
       'F' FROM DUAL
UNION ALL
SELECT 'ABA ',
       '--',
       160,
       1,
       'ABSREM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Abast. V. Remanesc?',
       'Abastecimento de Valor Remanescente?',
       '',
       'ABSREM',
       'F' FROM DUAL
UNION ALL
SELECT 'ABA ',
       '--',
       170,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ASSINA',
       'F' FROM DUAL
UNION ALL
SELECT 'ABA ',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'ABA ',
       '--',
       220,
       10,
       'CODABA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       '',
       'Cdigo Abastecimento',
       'Cdigo Abastecimento',
       '',
       'CODABA',
       '' FROM DUAL
UNION ALL
SELECT 'ABA ',
       '--',
       20,
       11,
       'CODBIC',
       'A',
       'DBIC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DBIC.FILBIC||'' - ''||DBIC.SEQFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Bico',
       'Bico',
       'DBIC.CODTAB = ABA.CODBIC',
       'CODBIC',
       'F' FROM DUAL
UNION ALL
SELECT 'ABA ',
       '--',
       30,
       5,
       'CODBOM',
       'S',
       'DBOM',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TO_CHAR(DBOM.NUMBOM)',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Bomba',
       'Cdigo Bomba',
       'DBOM.CODTAB = ABA.CODBOM',
       'CODBOM',
       'F' FROM DUAL
UNION ALL
SELECT 'ABA ',
       '--',
       40,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ABA ',
       '--',
       50,
       5,
       'CODTAN',
       'S',
       'DTAN',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TO_CHAR(DTAN.TANQUE)',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Tanque',
       'Cdigo Tanque',
       'DTAN.CODTAB =  ABA.CODTAN',
       'CODTAN',
       'F' FROM DUAL
UNION ALL
SELECT 'ABA ',
       '--',
       180,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'ABA ',
       '--',
       260,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       '9',
       '',
       'Nome Usurio',
       'Nome do usurio',
       'ABA.FILUSU = USU2.FILUSU(+) AND ABA.CODUSU = USU2.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'ABA ',
       '--',
       60,
       7,
       'DATABE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Abastecimento',
       'Data Abastecimento',
       '',
       'DATABE',
       'F' FROM DUAL
UNION ALL
SELECT 'ABA ',
       '--',
       70,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'ABA ',
       '--',
       80,
       20,
       'ENCFIM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Encerrante Final',
       'Encerrante Final',
       '',
       'ENCFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'ABA ',
       '--',
       90,
       20,
       'ENCINI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Encerrante Inicial',
       'Encerrante Inicial',
       '',
       'ENCINI',
       'F' FROM DUAL
UNION ALL
SELECT 'ABA ',
       '--',
       250,
       3,
       'FILUSU',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial Usurio',
       'Filial do usurio',
       'DFIL.CODFIL(+) = ABA.FILUSU',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'ABA ',
       '--',
       110,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Status do Abastecime',
       'Status do Abastecimento',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'ABA ',
       '--',
       270,
       1,
       'MANUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Manuteno~Bomba',
       'Manuteno de Bomba',
       '',
       'MANUT',
       '' FROM DUAL
UNION ALL
SELECT 'ABA ',
       '--',
       230,
       12,
       'VLRTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor total',
       'Valor total',
       '',
       'VLRTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'ABA ',
       '--',
       240,
       12,
       'VLRUNI',
       'F',
       '',
       3,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor unitrio',
       'Valor unitrio',
       '',
       'VLRUNI',
       'F' FROM DUAL
UNION ALL
SELECT 'ABA ',
       '--',
       210,
       15,
       'VOLABS',
       'F',
       '',
       3,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Volume Abastecido',
       'Volume Abastecido',
       '',
       'VOLABS',
       'F' FROM DUAL
);

/*-- SEQ 6680 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ABA ',
       'FLGEST',
       0,
       'A',
       'Aferio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ABA ',
       'FLGEST',
       0,
       'B',
       'Bloqueado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ABA ',
       'FLGEST',
       0,
       'C',
       'Emitido CF',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ABA ',
       'FLGEST',
       0,
       'N',
       'Emitida NF',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ABA ',
       'FLGEST',
       0,
       'P',
       'Pendente',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6681 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ABM ',
       TO_NUMBER(null),
       'ABM ',
       'Abas. Baixado Manual',
       'TT_ABM',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'ABM.FILUSU, ABM.CODUSU',
       '' FROM DUAL
);

/*-- SEQ 6682 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ABM ','--','' FROM DUAL
UNION ALL
SELECT 'ABM ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ABM ','99','Outros' FROM DUAL
);

/*-- SEQ 6683 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ABM ',
       '01',
       30,
       11,
       'CODBIC',
       'A',
       'DBIC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DBIC.FILBIC||'' - ''||DBIC.SEQFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Bico',
       'Bico',
       'DBIC.CODTAB = ABM.CODBIC',
       'CODBIC',
       'F' FROM DUAL
UNION ALL
SELECT 'ABM ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'FIL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'FIL2.CODFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial',
       'Filial',
       'FIL2.CODFIL = ABM.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ABM ',
       '01',
       90,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'N',
       '',
       'Usurio',
       'Cdigo do Usurio',
       'USU.FILUSU = ABM.FILUSU AND USU.CODUSU = ABM.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'ABM ',
       '01',
       70,
       1,
       'ENCERR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'N Encerrante em LT',
       'N Encerrante em LT',
       '',
       'ENCERR',
       '' FROM DUAL
UNION ALL
SELECT 'ABM ',
       '01',
       80,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       '' FROM DUAL
UNION ALL
SELECT 'ABM ',
       '01',
       50,
       12,
       'PRECOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Unitrio',
       'Valor Unitrio',
       '',
       'PRECOV',
       '' FROM DUAL
UNION ALL
SELECT 'ABM ',
       '01',
       40,
       12,
       'QTDMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Qtd. Movimentada',
       'Qtd. Movimentada',
       '',
       'QTDMOV',
       '' FROM DUAL
UNION ALL
SELECT 'ABM ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'ABM ',
       '01',
       60,
       14,
       'VLRMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Total',
       'Valor Total',
       '',
       'VLRMOV',
       '' FROM DUAL
);

/*-- SEQ 6684 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ACM ',
       TO_NUMBER(null),
       'ACM ',
       'Ajustes Custo Mdio',
       'TT_ACM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'ACM.CODFIL, ACM.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6685 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ACM ','--','' FROM DUAL
UNION ALL
SELECT 'ACM ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ACM ','02','Datas' FROM DUAL
UNION ALL
SELECT 'ACM ','03','Valores' FROM DUAL
UNION ALL
SELECT 'ACM ','99','Outros' FROM DUAL
);

/*-- SEQ 6686 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 30402,
       'USU ',
       'ACM ',
       '1',
       'N',
       '',
       '',
       'USU.FILUSU = ACM.FILUSU AND
USU.CODUSU = ACM.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30403,
       'GRA ',
       'ACM ',
       '1',
       'N',
       '',
       '',
       'GRA.FILMAT = ACM.FILMAT and
GRA.CODMAT = ACM.CODMAT and
GRA.CODCOR = ACM.CODCOR and
GRA.CODTAM = ACM.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 6687 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ACM ',
       '02',
       80,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data da Atualizao',
       'Data da ltima Atualizao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'ACM ',
       '01',
       50,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       '',
       'N',
       '',
       'Cdigo da Diviso',
       'Cdigo da Diviso',
       'DIV.CODITE = ACM.CODCOR',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'ACM ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = ACM.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ACM ',
       '01',
       40,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo do Produto',
       'Cdigo do Produto',
       '',
       'CODMAT',
       '' FROM DUAL
UNION ALL
SELECT 'ACM ',
       '01',
       60,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       '',
       'N',
       '',
       'Cdigo do Subdiviso',
       'Cdigo da Subdiviso',
       'SUB.CODITE = ACM.CODTAM',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'ACM ',
       '01',
       180,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo do Usurio',
       'Cdigo do Usurio',
       '',
       'CODUSU',
       '' FROM DUAL
UNION ALL
SELECT 'ACM ',
       '02',
       90,
       8,
       'DATAJU',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data do Ajuste',
       'Data do Ajuste',
       '',
       'DATAJU',
       '' FROM DUAL
UNION ALL
SELECT 'ACM ',
       '02',
       70,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data da Incluso',
       'Data da Incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'ACM ',
       '01',
       110,
       17,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       '' FROM DUAL
UNION ALL
SELECT 'ACM ',
       '01',
       30,
       3,
       'FILMAT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial do Produto',
       'Cdigo da Filial do Produto',
       'DFIL.CODFIL = ACM.FILMAT',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ACM ',
       '01',
       170,
       3,
       'FILUSU',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial do Usurio',
       'Filial do Usurio',
       'DFIL.CODFIL = ACM.FILUSU',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'ACM ',
       '99',
       160,
       10,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(ACM.OBSERV)',
       '' FROM DUAL
UNION ALL
SELECT 'ACM ',
       '99',
       120,
       10,
       'ORD_CM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Ordem Custo Mdio',
       'Ordem Custo Mdio',
       '',
       'ORD_CM',
       '' FROM DUAL
UNION ALL
SELECT 'ACM ',
       '99',
       150,
       16,
       'SAL_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Saldo CM',
       'Saldo CM no momento do lanamento',
       '',
       'SAL_CM',
       '' FROM DUAL
UNION ALL
SELECT 'ACM ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'ACM ',
       '01',
       190,
       1,
       'SITMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Situao',
       'Situao',
       '',
       'SITMOV',
       'T' FROM DUAL
UNION ALL
SELECT 'ACM ',
       '99',
       140,
       16,
       'TOTCMG',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Total CM ger.',
       'Valor total CM gerencial no momento do lanamento',
       '',
       'TOTCMG',
       '' FROM DUAL
UNION ALL
SELECT 'ACM ',
       '99',
       130,
       16,
       'TOT_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       '',
       'Valor Total CM',
       'Valor total CM no momento do lanamento',
       '',
       'TOT_CM',
       '' FROM DUAL
UNION ALL
SELECT 'ACM ',
       '03',
       100,
       16,
       'VLRAJU',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor do Ajuste',
       'Valor do Ajuste',
       '',
       'VLRAJU',
       '' FROM DUAL
);

/*-- SEQ 6688 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ACM ',
       'SITMOV',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ACM ',
       'SITMOV',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6689 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ACR ',
       TO_NUMBER(null),
       'ACR ',
       'Anlise de Crdito',
       'TT_ACR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CODFIL, SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6690 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ACR ','--','' FROM DUAL
UNION ALL
SELECT 'ACR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ACR ','99','Outros' FROM DUAL
);

/*-- SEQ 6691 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20243,
       'USU ',
       'ACR ',
       '1',
       'N',
       '',
       '',
       'ACR.FILAUT = USU.FILUSU AND 
ACR.CODAUT = USU.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20244,
       'CLI ',
       'ACR ',
       '1',
       '0N',
       '',
       '',
       'ACR.FILCLI = CLI.FILCLI AND 
ACR.CODCLI = CLI.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21178,
       'VEN ',
       'ACR ',
       '1',
       'N',
       '',
       '',
       'ACR.FILVEN = VEN.CODFIL AND
ACR.SEQVEN = VEN.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21179,
       'REL ',
       'ACR ',
       '1',
       'N',
       '',
       '',
       'ACR.FILMOT = REL.FILPAR AND
ACR.CODMOT = REL.CODPAR AND 
ACR.TIPMOT = REL.TIPPAR',
       '',
       '' FROM DUAL
);

/*-- SEQ 6692 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ACR ',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       20,
       30,
       'CDCMC7',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo CMC7  Cheque',
       'Cdigo CMC7 do Cheque',
       '',
       'CDCMC7',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       30,
       5,
       'CODAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Agncia Cheq.',
       'Cdigo da Agncia do Cheque',
       '',
       'CODAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       40,
       3,
       'CODAUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Usurio Auto.',
       'Cdigo do Usurio que Autorizou',
       '',
       'CODAUT',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       50,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Banco Cheque',
       'Cdigo do Banco do Cheque',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       60,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       70,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = ACR.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       330,
       6,
       'CODMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cod. Motorista',
       'Codigo do Motorista',
       '',
       'CODMOT',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       80,
       7,
       'DATAUT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data e hora da Auto.',
       'Data e hora da Autorizao',
       '',
       'DATAUT',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       250,
       7,
       'DATCHR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Emisso Cheque',
       'Data Emisso Cheque',
       '',
       'DATCHR',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       260,
       7,
       'DATCON',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incio da Conta',
       'Data Incio da Conta',
       '',
       'DATCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       90,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       100,
       7,
       'DATSER',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data e hora  Serasa',
       'Data e hora da consulta ao Serasa',
       '',
       'DATSER',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       270,
       7,
       'DATVEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Vencimento Cheq',
       'Data Vencimento Cheque
Data Vencimento Cheque
Data Vencimento Cheque
',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       110,
       3,
       'FILAUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Usurio Auto.',
       'Filial do Usurio que Autorizou',
       '',
       'FILAUT',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       120,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do Cliente',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       340,
       3,
       'FILMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Fil. Motorista',
       'Filial do Motorista',
       '',
       'FILMOT',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       350,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Fil. Venda',
       'Filial da Venda',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       130,
       1,
       'FLGACR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao da Anlise ',
       'Situao da Anlise de Crdito',
       '',
       'FLGACR',
       'T' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       140,
       1,
       'FLGSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao da Consulta',
       'Situao da Consulta ao Serasa',
       '',
       'FLGSER',
       'T' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       390,
       40,
       'IMGCHR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Imagem do Cheque',
       'Nome do Arquivo da Imagem do Cheque no Servidor',
       '',
       'IMGCHR',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       280,
       14,
       'LIMACR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Limite De Crdito',
       'Limite De Crdito',
       '',
       'LIMACR',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       150,
       4000,
       'MOTLIM',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo da Restrio ',
       'Motivo da Restrio no Limite de Crdito',
       '',
       'MOTLIM',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       160,
       4000,
       'MOTSER',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo Negativao',
       'Motivo de Negativao no Serasa',
       '',
       'MOTSER',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       290,
       14,
       'NOVLIM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Novo Limite',
       'Novo Limite (Caso sofra alteraes)',
       '',
       'NOVLIM',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       170,
       6,
       'NUMCHE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Cheque',
       'Nmero do Cheque',
       '',
       'NUMCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       180,
       10,
       'NUMCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero C/C do Cheque',
       'Nmero da C/C do Cheque',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       190,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento do Cheque',
       'Documento do Cheque',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       320,
       4000,
       'OBSCHE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Obs. Checkout',
       'Observao do Checkout',
       '',
       'OBSCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       200,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao An. Cred',
       'Observao da Anlise de Crdito/Motivo da Reijeio',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       300,
       1,
       'ORIACR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem com Domnio',
       'Origem com Domnio',
       '',
       'ORIACR',
       'T' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       210,
       7,
       'PLACAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Placa do Veculo Aba',
       'Placa do Veculo Abastecido',
       '',
       'PLACAS',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       310,
       20,
       'SENACR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Senha de Liberao',
       'Senha de Liberao',
       '',
       'SENACR',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       220,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       360,
       10,
       'SEQVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Seq. Venda',
       'Sequenciador da Venda',
       '',
       'SEQVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       230,
       3,
       'SERCHE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Srie do Cheque',
       'Srie do Cheque',
       '',
       'SERCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       370,
       1,
       'TIPMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tip. Motorista',
       'Tipo do Motorista',
       '',
       'TIPMOT',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       240,
       9,
       'VLRCHE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor do Cheque',
       'Valor do Cheque',
       '',
       'VLRCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'ACR ',
       '--',
       380,
       14,
       'VLRPRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       ' Valor Previsto',
       'Valor Previsto para Compra',
       '',
       'VLRPRE',
       'F' FROM DUAL
);

/*-- SEQ 6693 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ACR ',
       'FLGACR',
       0,
       '1',
       'Aprovado Dentro do Limite',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ACR ',
       'FLGACR',
       0,
       '2',
       'Aprovado somente p/ esta venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ACR ',
       'FLGACR',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ACR ',
       'FLGACR',
       0,
       'R',
       'Reprovado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ACR ',
       'FLGSER',
       0,
       'N',
       'No Consultado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ACR ',
       'FLGSER',
       0,
       'P',
       'Aprovado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ACR ',
       'FLGSER',
       0,
       'R',
       'Reprovado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ACR ',
       'ORIACR',
       0,
       'A',
       'Anlise de Crdito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ACR ',
       'ORIACR',
       0,
       'C',
       'Commerce',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6694 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ADI ',
       TO_NUMBER(null),
       'ADI ',
       'Adies da DI',
       'TT_ADI',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'ADI.CODFIL, ADI.SEQUEN, ADI.NUMITE',
       '' FROM DUAL
);

/*-- SEQ 6695 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ADI ','--','' FROM DUAL
UNION ALL
SELECT 'ADI ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ADI ','99','Outros' FROM DUAL
);

/*-- SEQ 6696 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 24501,
       'CLI ',
       'ADI ',
       '01',
       '0N',
       '',
       '',
       '(CLI.FILCLI = ADI.FILFOR(+) AND
 CLI.CODCLI = ADI.CODFOR(+))
OR
(CLI.FILCLI = ADI.FILFAB(+) AND
 CLI.CODCLI = ADI.CODFAB(+))',
       '',
       '' FROM DUAL
UNION ALL
SELECT 24494,
       'OIP ',
       'ADI ',
       '1',
       '0N',
       '',
       '',
       'OIP.CODFIL = ADI.CODFIL(+) AND
OIP.SEQUEN = ADI.SEQUEN(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 6697 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ADI ',
       '99',
       130,
       6,
       'CODFAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Fabricante',
       'Cdigo do Fabricante estrangeiro',
       '',
       'CODFAB',
       'F' FROM DUAL
UNION ALL
SELECT 'ADI ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = ADI.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ADI ',
       '99',
       100,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Fornecedor',
       'Cdigo do Fornecedor estrangeiro',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'ADI ',
       '99',
       80,
       8,
       'CODNCM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo NCM',
       'Cdigo NCM',
       '',
       'CODNCM',
       '' FROM DUAL
UNION ALL
SELECT 'ADI ',
       '99',
       140,
       100,
       'DESFAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Fabricante',
       'Descrio do Fabricante na DI',
       '',
       'DESFAB',
       'F' FROM DUAL
UNION ALL
SELECT 'ADI ',
       '99',
       110,
       100,
       'DESFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Fornecedor',
       'Descrio do Fornecedor na DI',
       '',
       'DESFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'ADI ',
       '99',
       50,
       60,
       'FABEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Fab. Estrangeiro',
       'Cdigo do fabricante estrangeiro (descontinuado)',
       '',
       'FABEST',
       'F' FROM DUAL
UNION ALL
SELECT 'ADI ',
       '99',
       120,
       3,
       'FILFAB',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Fabricante',
       'Filial do Fabricante estrangeiro',
       'DFIL.CODFIL = ADI.FILFAB(+)',
       'FILFAB',
       'T' FROM DUAL
UNION ALL
SELECT 'ADI ',
       '99',
       90,
       3,
       'FILFOR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Fornecedor',
       'Filial do Fornecedor estrangeiro',
       'DFIL.CODFIL = ADI.FILFOR(+)',
       'FILFOR',
       'T' FROM DUAL
UNION ALL
SELECT 'ADI ',
       '99',
       70,
       11,
       'NUMDRA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nm. Drawback',
       'Nmero do ato concessrio de Drawback',
       '',
       'NUMDRA',
       'F' FROM DUAL
UNION ALL
SELECT 'ADI ',
       '01',
       30,
       3,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Numero da Adio',
       'Numero da Adio',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'ADI ',
       '99',
       40,
       3,
       'SEQITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero Seq',
       'Nmero sequencial do item dentro da Adio',
       '',
       'SEQITE',
       'F' FROM DUAL
UNION ALL
SELECT 'ADI ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'ADI ',
       '99',
       60,
       13,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '#Valor Desconto',
       'Valor do desconto do item da DI - Adio (descontinuado)',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'ADI ',
       '99',
       150,
       12,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor do Frete USD',
       'Valor do Frete em Dlares',
       '',
       'VLRFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'ADI ',
       '99',
       160,
       12,
       'VLRSEG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor do Seguro USD',
       'Valor do Seguro em Dlares',
       '',
       'VLRSEG',
       'F' FROM DUAL
);

/*-- SEQ 6698 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'AFE ',
       TO_NUMBER(null),
       'AFE ',
       'Aferies',
       'TT_AFE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'AFE.CODFIL,AFE.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6699 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'AFE ','--','' FROM DUAL
UNION ALL
SELECT 'AFE ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'AFE ','05','Aferio' FROM DUAL
UNION ALL
SELECT 'AFE ','10','Registro e Autorizao' FROM DUAL
UNION ALL
SELECT 'AFE ','50','Encerrante' FROM DUAL
UNION ALL
SELECT 'AFE ','60','Interveno' FROM DUAL
UNION ALL
SELECT 'AFE ','99','Outros' FROM DUAL
);

/*-- SEQ 6700 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20244,
       'USU ',
       'AFE ',
       '1',
       '0N',
       '',
       '',
       'USU.FILUSU(+) = AFE.FILUSU AND USU.CODUSU(+) = AFE.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20245,
       'DBIC',
       'AFE ',
       '1',
       '1',
       '',
       '',
       'DBIC.CODTAB = AFE.CODBIC',
       '',
       '' FROM DUAL
);

/*-- SEQ 6701 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'AFE ',
       '--',
       110,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da atualizao',
       'Data da atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'AFE ',
       '--',
       40,
       3,
       'CODAFE',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       '9',
       'F',
       'Usurio aferidor',
       'Cdigo do usurio',
       'AFE.FILAFE = USU2.FILUSU(+) AND USU2.CODUSU(+) = AFE.CODAFE',
       'CODAFE',
       'T' FROM DUAL
UNION ALL
SELECT 'AFE ',
       '--',
       120,
       11,
       'CODBIC',
       'A',
       'DBIC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DBIC.FILBIC||'' - ''||DBIC.SEQFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Bico',
       'Bico',
       'DBIC.CODTAB = AFE.CODBIC',
       'CODBIC',
       'F' FROM DUAL
UNION ALL
SELECT 'AFE ',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = AFE.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'AFE ',
       '--',
       70,
       3,
       'CODREG',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       '9',
       'F',
       'Usurio responsvel',
       'Cdigo do usurio',
       'AFE.FILREG = USU2.FILUSU(+) AND USU2.CODUSU(+) = AFE.CODREG',
       'CODREG',
       'T' FROM DUAL
UNION ALL
SELECT 'AFE ',
       '--',
       50,
       7,
       'DATAFE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data aferio',
       'Data',
       '',
       'DATAFE',
       'F' FROM DUAL
UNION ALL
SELECT 'AFE ',
       '--',
       80,
       7,
       'DATREG',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data registro',
       'Data',
       '',
       'DATREG',
       'F' FROM DUAL
UNION ALL
SELECT 'AFE ',
       '--',
       100,
       10,
       'ENCFIM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Encerrante final',
       'Encerrante final',
       '',
       'ENCFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'AFE ',
       '--',
       90,
       10,
       'ENCINI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Encerrante inicial',
       'Encerrante inicial',
       '',
       'ENCINI',
       'F' FROM DUAL
UNION ALL
SELECT 'AFE ',
       '--',
       30,
       3,
       'FILAFE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILAFE',
       'F' FROM DUAL
UNION ALL
SELECT 'AFE ',
       '--',
       60,
       3,
       'FILREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILREG',
       'F' FROM DUAL
UNION ALL
SELECT 'AFE ',
       '--',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequncia',
       'Sequncia',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 6702 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'AGC ',
       TO_NUMBER(null),
       'AGC ',
       'Agen. Compro. Repet.',
       'TT_AGC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 6703 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'AGC ','--','' FROM DUAL
UNION ALL
SELECT 'AGC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'AGC ','99','Outros' FROM DUAL
);

/*-- SEQ 6704 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'AGC ',
       '01',
       60,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data da atualizao',
       'Data da atualizao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'AGC.CODFIL = DFIL.CODFIL',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '01',
       50,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       '0',
       '',
       'Cdigo do Usurio',
       'Cdigo do Usurio',
       'AGC.FILUSU = USU.FILUSU(+) AND AGC.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       '' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '01',
       190,
       7,
       'DATEXP',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Expirao',
       'Data Expirao',
       '',
       'DATEXP',
       '' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '01',
       70,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       '',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '01',
       80,
       7,
       'DATINI ',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Inicial',
       'Data Inicial',
       '',
       'DATINI ',
       '' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '01',
       40,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       '',
       'Filial do Usurio',
       'Filial do Usurio',
       '',
       'FILUSU',
       '' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '01',
       30,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       '' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '--',
       210,
       1,
       'MESTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Tipo Repeti Mensal',
       'Tipo de Repetio Mensal',
       '',
       'MESTIP',
       'F' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '01',
       100,
       2,
       'NROREP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Repete a cada tempo',
       'Repete a cada tempo',
       '',
       'NROREP',
       '' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '--',
       220,
       1,
       'REPABR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Abril',
       'Abril',
       '',
       'REPABR',
       'F' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '--',
       230,
       1,
       'REPAGO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Agosto',
       'Agosto',
       '',
       'REPAGO',
       'F' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '--',
       240,
       1,
       'REPDEZ',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Dezembro',
       'Dezembro',
       '',
       'REPDEZ',
       'F' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '01',
       110,
       1,
       'REPDOM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Domingo',
       'Domingo',
       '',
       'REPDOM',
       '' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '--',
       250,
       1,
       'REPETE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Repete',
       'Repete Semanal/Mensal',
       '',
       'REPETE',
       'T' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '01',
       90,
       1,
       'REPETE ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Repetio',
       'Repetio',
       '',
       'REPETE ',
       '' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '--',
       260,
       1,
       'REPFEV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Fevereiro',
       'Fevereiro',
       '',
       'REPFEV',
       'F' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '--',
       270,
       1,
       'REPJAN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Janeiro',
       'Janeiro',
       '',
       'REPJAN',
       'F' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '--',
       280,
       1,
       'REPJUL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Julho',
       'Julho',
       '',
       'REPJUL',
       'F' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '--',
       290,
       1,
       'REPJUN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Junho',
       'Junho',
       '',
       'REPJUN',
       'F' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '--',
       300,
       1,
       'REPMAI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Maio',
       'Maio',
       '',
       'REPMAI',
       'F' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '--',
       310,
       1,
       'REPMAR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'F',
       'Maro',
       'Maro',
       '',
       'REPMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '01',
       180,
       1,
       'REPMES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'A',
       '',
       'F',
       'N',
       '',
       'Dia p/ repet. mensal',
       'Dia p/ repet. mensal',
       '',
       'REPMES',
       '' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '--',
       320,
       1,
       'REPNOV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Novembro',
       'Novembro',
       '',
       'REPNOV',
       'F' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '--',
       330,
       1,
       'REPOUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Outubro',
       'Outubro',
       '',
       'REPOUT',
       'F' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '01',
       140,
       1,
       'REPQUA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Quarta',
       'Quarta',
       '',
       'REPQUA',
       '' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '01',
       150,
       1,
       'REPQUI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Quinta',
       'Quinta',
       '',
       'REPQUI',
       '' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '01',
       170,
       1,
       'REPSAB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Sabado',
       'Sabado',
       '',
       'REPSAB',
       '' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '01',
       120,
       1,
       'REPSEG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Segunda',
       'Segunda',
       '',
       'REPSEG',
       '' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '--',
       340,
       1,
       'REPSET',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Setembro',
       'Setembro',
       '',
       'REPSET',
       'F' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '01',
       160,
       1,
       'REPSEX',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Sexta',
       'Sexta',
       '',
       'REPSEX',
       '' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '01',
       130,
       1,
       'REPTER',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Tera',
       'Tera',
       '',
       'REPTER',
       '' FROM DUAL
UNION ALL
SELECT 'AGC ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6705 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'AGC ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AGC ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AGC ',
       'FLGEST',
       0,
       'F',
       'Finalizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AGC ',
       'REPETE',
       0,
       'M',
       'Mensal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AGC ',
       'REPETE',
       0,
       'S',
       'Semanal',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6706 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'AGE ',
       TO_NUMBER(null),
       'AGE ',
       'Agenda',
       'TT_AGE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'AGE.CODFIL,AGE.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6707 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'AGE ','--','' FROM DUAL
UNION ALL
SELECT 'AGE ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'AGE ','02','Coluna Virtuais' FROM DUAL
UNION ALL
SELECT 'AGE ','99','Outros' FROM DUAL
);

/*-- SEQ 6708 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 5366,
       'IAG ',
       'AGE ',
       'N',
       '1',
       '',
       '',
       'iag.codfil = age.codfil and
iag.sequen = age.sequen',
       '',
       '' FROM DUAL
);

/*-- SEQ 6709 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'AGE ',
       '01',
       10,
       1,
       'AGEPUB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Publica?',
       'Agenda Pblica',
       '',
       'AGEPUB',
       'F' FROM DUAL
UNION ALL
SELECT 'AGE ',
       '01',
       20,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizao feita em',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'AGE ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Cdigo da Filial',
       'DFIL.CODFIL = AGE.CODFIL',
       'AGE.CODFIL||AGE.SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'AGE ',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Usuario',
       'Cdigo Usurio',
       'USU2.FILUSU(+) = AGE.FILUSU AND USU2.CODUSU(+) = AGE.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'AGE ',
       '01',
       50,
       4000,
       'COMENT',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Comentario',
       'Comentrios',
       '',
       'COMENT',
       'F' FROM DUAL
UNION ALL
SELECT 'AGE ',
       '01',
       60,
       7,
       'DATFIM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Termino',
       'Data Final',
       '',
       'DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'AGE ',
       '01',
       70,
       7,
       'DATINI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Inicio',
       'Data Inicial',
       '',
       'DATINI',
       'F' FROM DUAL
UNION ALL
SELECT 'AGE ',
       '01',
       80,
       254,
       'EVENTO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Evento',
       'Evento',
       '',
       'EVENTO',
       'F' FROM DUAL
UNION ALL
SELECT 'AGE ',
       '01',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'AGE ',
       '01',
       100,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 6710 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ANP ',
       TO_NUMBER(null),
       'ANP ',
       'Prod. Regulados ANP',
       'TT_ANP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'ANP.CODANP,
ANP.NOMANP',
       '' FROM DUAL
);

/*-- SEQ 6711 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ANP ','--','' FROM DUAL
UNION ALL
SELECT 'ANP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ANP ','99','Outros' FROM DUAL
);

/*-- SEQ 6712 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ANP ',
       '--',
       10,
       9,
       'CODANP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       '',
       'Cdigo ANP',
       'Cdigo ANP',
       '',
       'CODANP',
       '' FROM DUAL
UNION ALL
SELECT 'ANP ',
       '--',
       20,
       70,
       'NOMANP',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Produto',
       'Nome do produto ANP',
       '',
       'NOMANP',
       '' FROM DUAL
);

/*-- SEQ 6713 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ANX ',
       TO_NUMBER(null),
       'ANX ',
       'Anexos',
       'TT_ANX',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'ANX.CODFIL,ANX.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6714 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ANX ','--','' FROM DUAL
UNION ALL
SELECT 'ANX ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ANX ','99','Outros' FROM DUAL
);

/*-- SEQ 6715 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 5367,
       'MAI ',
       'ANX ',
       '1',
       '1',
       '',
       '',
       'MAI.CODFIL = ANX.CODFIL AND
MAI.SEQUEN = ANX.SEQMAI',
       '',
       '' FROM DUAL
);

/*-- SEQ 6716 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ANX ',
       '99',
       10,
       0,
       'ANEXO',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Texto anexo',
       'Texto Anexo',
       '',
       'RTF2TXT(ANEXO)',
       'F' FROM DUAL
UNION ALL
SELECT 'ANX ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial do Cliente',
       'Filial do Cliente',
       'DFIL.CODFIL = ANX.CODFIL',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'ANX ',
       '01',
       30,
       255,
       'NOMANX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Arquivo anexo',
       'Nome do arquivo anexo',
       '',
       'NOMANX',
       'F' FROM DUAL
UNION ALL
SELECT 'ANX ',
       '99',
       50,
       10,
       'SEQMAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador E-mail',
       '',
       'SEQMAI',
       'F' FROM DUAL
UNION ALL
SELECT 'ANX ',
       '01',
       40,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 6717 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'AQV ',
       TO_NUMBER(null),
       'AQV ',
       'Arquivos do Sistema',
       'TT_AQV',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'AQV.ID_AQV',
       '' FROM DUAL
);

/*-- SEQ 6718 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'AQV ','--','' FROM DUAL
UNION ALL
SELECT 'AQV ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'AQV ','02','Datas' FROM DUAL
UNION ALL
SELECT 'AQV ','99','Outros' FROM DUAL
);

/*-- SEQ 6719 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'AQV ',
       '01',
       40,
       100,
       'ARQNOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome do Arquivo',
       'Nome do Arquivo',
       '',
       'ARQNOM',
       '' FROM DUAL
UNION ALL
SELECT 'AQV ',
       '01',
       50,
       1,
       'ARQTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo do Arquivo',
       'Tipo do Arquivo',
       '',
       'ARQTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'AQV ',
       '02',
       30,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'AQV ',
       '01',
       60,
       50,
       'CONTYP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Content-Type',
       'Content-Type',
       '',
       'CONTYP',
       '' FROM DUAL
UNION ALL
SELECT 'AQV ',
       '02',
       20,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'AQV ',
       '01',
       10,
       14,
       'ID_AQV',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Chave ID',
       'Chave ID',
       '',
       'ID_AQV',
       '' FROM DUAL
);

/*-- SEQ 6720 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'AQV ',
       'ARQTIP',
       0,
       'N',
       'No definido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AQV ',
       'ARQTIP',
       0,
       'R',
       'Remessa CNAB',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6721 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ARQ ',
       0,
       'ARQ ',
       'BI_Arquivos',
       'TT_ARQ',
       'T',
       '',
       'TOTALL',
       'TOTALLW = 7.2 / LITE = 3.2 / T2000 = 0.02',
       '{ARQ}',
       '',
       '',
       '',
       'F',
       '',
       'ARQ.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 6722 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ARQ ','--','' FROM DUAL
);

/*-- SEQ 6723 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 5368,
       'DOM ',
       'ARQ ',
       'N',
       '1',
       '',
       '',
       'DOM.CODARQ(+) = ARQ.CODTAB',
       '',
       '' FROM DUAL
);

/*-- SEQ 6724 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ARQ ',
       '--',
       60,
       15,
       'APELID',
       'A',
       '',
       0,
       0,
       'ARQ ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'ARQ',
       'F',
       'A',
       'F',
       'Alias do DB',
       'Contm o Alias da Base de Dados onde se encontra a tabela em questo',
       '',
       'APELID',
       'F' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       '--',
       20,
       4,
       'CODFIS',
       'A',
       '',
       0,
       0,
       'ARQ ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'ARQ',
       'F',
       'A',
       'F',
       'Codigo',
       'Cdigo Fsico',
       '',
       'CODFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       '--',
       10,
       4,
       'CODTAB',
       'S',
       '',
       0,
       0,
       'ARQ ',
       10,
       TO_NUMBER(null),
       '
',
       '',
       'I',
       'ARQ',
       'F',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       '--',
       70,
       72,
       'DESCRI',
       'A',
       '',
       0,
       0,
       'ARQ ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'ARQ',
       'F',
       'A',
       'F',
       'Contedo Arquivo',
       'Descrio do contedo do arquivo',
       '',
       'DESCRI',
       'F' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       '--',
       180,
       1,
       'EXPNET',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exporta p/Metadados?',
       'Exporta p/Metadados?',
       '',
       'EXPNET',
       'F' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       '--',
       50,
       40,
       'FILBAS',
       'A',
       '',
       0,
       0,
       'ARQ ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'ARQ',
       'F',
       'A',
       'F',
       'Filtro Basico',
       'Filtro Bsico',
       '',
       'FILBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       '--',
       120,
       1,
       'FORMUL',
       'L',
       '',
       0,
       0,
       'ARQ ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'ARQ',
       'F',
       '',
       'F',
       'Usa Paleta Formulas?',
       'Indica se uma tabela  mostrada na paleta de frmulas ou no',
       '',
       'FORMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       '--',
       40,
       1,
       'GERAL',
       'L',
       '',
       0,
       0,
       'ARQ ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'ARQ',
       'F',
       '',
       'F',
       'Global?',
       'Global (Para as tabelas principais)',
       '',
       'GERAL',
       'F' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       '--',
       16,
       254,
       'ID_UNI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificador',
       'Identificador',
       '',
       'ID_UNI',
       'F' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       '--',
       25,
       4,
       'LISCODFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Lista de Cdigos',
       'Use esta coluna para escolher lista de arquivos',
       '',
       'CODFIS',
       'T' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       '--',
       140,
       20,
       'NOMTAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'ARQ ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Descrio da Tabela',
       'Descrio da tabela',
       '',
       'NOMTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       '--',
       130,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'ARQ ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'ARQ',
       'F',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(ARQ.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       '--',
       110,
       15,
       'PALETA',
       'A',
       '',
       0,
       0,
       'ARQ ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'ARQ',
       'F',
       'A',
       'F',
       'Paleta Formulas',
       'Contm a descrio reduzida da tabela a ser mstrada na paleta de formula',
       '',
       'PALETA',
       'F' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       '--',
       17,
       4000,
       'PARAME',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Parmetro',
       'Parmetro',
       '',
       'RTF2TXT(PARAME)',
       'F' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       '--',
       30,
       40,
       'PATH',
       'A',
       '',
       0,
       0,
       'ARQ ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'ARQ',
       'F',
       'A',
       'F',
       'Nome Fisico',
       'Nome fsico da tabela',
       '',
       'PATH',
       'F' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       '--',
       160,
       1,
       'PERSON',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Personalizado?',
       'Personalizado',
       '',
       'PERSON',
       'F' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       '--',
       80,
       80,
       'PRIMAR',
       'A',
       '',
       0,
       0,
       'ARQ ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'ARQ',
       'F',
       'A',
       'F',
       'Chave Primaria',
       'Campos que compem a Chave Primria do Arquivo',
       '',
       'PRIMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       '--',
       90,
       20,
       'SECUN1',
       'A',
       '',
       0,
       0,
       'ARQ ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'ARQ',
       'F',
       'A',
       'F',
       'Chave Secundaria 1',
       'Campos que compem a Chave Secundria 1',
       '',
       'SECUN1',
       'F' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       '--',
       100,
       20,
       'SECUN2',
       'A',
       '',
       0,
       0,
       'ARQ ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'ARQ',
       'F',
       'A',
       'F',
       'Chave Secundaria 2',
       'Campos que compem a Chave Secundria 2',
       '',
       'SECUN2',
       'F' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       '--',
       170,
       4000,
       'SUBSQL',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub Select',
       'Sub Select',
       '',
       'SUBSQL',
       'F' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       '--',
       150,
       8,
       'UNICO',
       'N',
       '',
       0,
       TO_NUMBER(null),
       'ARQ ',
       150,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Uso Interno',
       'Uso interno',
       '',
       'UNICO',
       'F' FROM DUAL
);

/*-- SEQ 6725 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ARQ ',
       'LISCODFIS',
       0,
       ' ',
       'Cliente',
       TO_NUMBER(null),
       'CLI' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       'LISCODFIS',
       0,
       ' ',
       'Endereo Cliente',
       TO_NUMBER(null),
       'END' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       'LISCODFIS',
       0,
       ' ',
       'Grade do Produto',
       TO_NUMBER(null),
       'GRA' FROM DUAL
UNION ALL
SELECT 'ARQ ',
       'LISCODFIS',
       0,
       ' ',
       'Produto',
       TO_NUMBER(null),
       'PRO' FROM DUAL
);

/*-- SEQ 6726 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ASS ',
       TO_NUMBER(null),
       'ASS ',
       'Assinaturas PAF',
       'TT_ASS',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'NOMTAB',
       '' FROM DUAL
);

/*-- SEQ 6727 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ASS ','--','' FROM DUAL
UNION ALL
SELECT 'ASS ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ASS ','99','Outros' FROM DUAL
);

/*-- SEQ 6728 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ASS ',
       '--',
       10,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Assinatura',
       'Assinatura',
       '',
       'ASSINA',
       'F' FROM DUAL
UNION ALL
SELECT 'ASS ',
       '--',
       20,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'ASS ',
       '--',
       30,
       40,
       'NOMTAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Tabela',
       'Nome Tabela',
       '',
       'NOMTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'ASS ',
       '--',
       40,
       12,
       'QTDREG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Qtd. de registros',
       'Quantidade de registros',
       '',
       'QTDREG',
       'F' FROM DUAL
);

/*-- SEQ 6729 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ATU ',
       TO_NUMBER(null),
       'ATU ',
       'Controle Atualizao',
       'TT_ATU',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'ID_ATU',
       '' FROM DUAL
);

/*-- SEQ 6730 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ATU ','--','' FROM DUAL
UNION ALL
SELECT 'ATU ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ATU ','99','Outros' FROM DUAL
);

/*-- SEQ 6731 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ATU ',
       '01',
       30,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data atualizao',
       'Data da ltima atualizao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'ATU ',
       '99',
       40,
       7,
       'DATFIM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data final',
       'Data final da ltima exportao',
       '',
       'DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'ATU ',
       '99',
       50,
       7,
       'DATINI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de incio',
       'Data de incio da ltima exportao',
       '',
       'DATINI',
       'F' FROM DUAL
UNION ALL
SELECT 'ATU ',
       '01',
       20,
       20,
       'DESATU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio',
       'Descrio',
       '',
       'DESATU',
       '' FROM DUAL
UNION ALL
SELECT 'ATU ',
       '01',
       10,
       14,
       'ID_ATU',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'ID',
       'ID',
       '',
       'ID_ATU',
       '' FROM DUAL
);

/*-- SEQ 6732 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'AUS ',
       TO_NUMBER(null),
       'AUS ',
       'Ausncias',
       'TT_AUS',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'AUS.CODFIL,AUS.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6733 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'AUS ','--','' FROM DUAL
UNION ALL
SELECT 'AUS ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'AUS ','99','Outros' FROM DUAL
);

/*-- SEQ 6734 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 5369,
       'USU ',
       'AUS ',
       'N',
       '1',
       '',
       '',
       'USU.FILUSU(+) = AUS.FILUSU AND
USU.CODUSU(+) = AUS.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 6735 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'AUS ',
       '01',
       60,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Filial',
       'AUS.CODFIL = DFIL.CODFIL(+) ',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'AUS ',
       '01',
       10,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Usurio',
       'Cdigo Usurio',
       'USU2.FILUSU(+) = AUS.FILUSU AND USU2.CODUSU(+) = AUS.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'AUS ',
       '01',
       20,
       7,
       'DATAUS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data',
       'Data ausncia',
       '',
       'DATAUS',
       'F' FROM DUAL
UNION ALL
SELECT 'AUS ',
       '01',
       30,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'AUS ',
       '01',
       40,
       150,
       'MOTIVO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo',
       'Motivo Ausncia',
       '',
       'MOTIVO',
       'F' FROM DUAL
UNION ALL
SELECT 'AUS ',
       '01',
       50,
       7,
       'QTDHOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Horas(Minutos)',
       'Quantidade de Horas(Minutos)',
       '',
       'QTDHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'AUS ',
       '01',
       70,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 6736 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'AUT ',
       TO_NUMBER(null),
       'AUT ',
       'Autorizaes',
       'TT_AUT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'AUT.CODFIL,AUT.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6737 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'AUT ','--','' FROM DUAL
UNION ALL
SELECT 'AUT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'AUT ','99','Outros' FROM DUAL
);

/*-- SEQ 6738 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23341,
       'CLI ',
       'AUT ',
       'N',
       '1',
       '',
       '',
       'CLI.FILCLI(+) = AUT.FILCLI AND
CLI.CODCLI(+) = AUT.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23342,
       'GRA ',
       'AUT ',
       'N',
       '1',
       '',
       '',
       'GRA.FILMAT(+) = AUT.FILMAT AND
GRA.CODMAT(+) = AUT.CODMAT AND
GRA.CODCOR(+) = AUT.CODCOR AND
GRA.CODTAM(+) = AUT.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23343,
       'ORC ',
       'AUT ',
       'N',
       '1',
       '',
       '',
       'ORC.CODFIL(+) = AUT.CODFIL AND
ORC.TIPPED(+) = AUT.TIPPED AND
ORC.NUMPED(+) = AUT.NUMPED',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23344,
       'USU ',
       'AUT ',
       'N',
       '1',
       '',
       '',
       'USU.FILUSU(+) = AUT.FILUSU AND
USU.CODUSU(+) = AUT.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23345,
       'VEN ',
       'AUT ',
       'N',
       '1',
       '',
       '',
       'VEN.CODFIL(+) = AUT.CODFIL AND
VEN.SEQUEN(+) = AUT.SEQVEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 6739 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'AUT ',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       20,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Diviso',
       'Diviso do produto',
       'AUT.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = AUT.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       40,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       50,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'AUT.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       60,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Usurio',
       'Cdigo Usurio',
       'USU2.FILUSU(+) = AUT.FILUSU AND USU2.CODUSU(+) = AUT.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       70,
       254,
       'COMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Complemento',
       'Complemento',
       '',
       'COMPLE',
       'F' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       80,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       90,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       190,
       3,
       'FILCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Compra',
       'Filial Compra',
       '',
       'FILCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       100,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       110,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       210,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       230,
       10,
       'ID_POS',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'ID Autorizao PoS',
       'ID da Autorizao no Totali PoS',
       '',
       'ID_POS',
       '' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       240,
       5,
       'INSTAL',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nm. Instalao PoS',
       'Nmero da Instalao do Totali PoS',
       '',
       'INSTAL',
       '' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       120,
       2,
       'MODULO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Mdulo',
       'Mdulo',
       '',
       'MODULO',
       'T' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       130,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       'ECF',
       'Nmero do ECF que recebeu a parcela',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       140,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nmero do Pedido',
       'Nmero do pedido',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       200,
       10,
       'SEQCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Compra',
       '',
       'SEQCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       150,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       160,
       10,
       'SEQVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador de Vendas',
       '',
       'SEQVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '99',
       220,
       8,
       'TAXDES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Desconto/Acrscimo',
       '% Desconto/Acrscimo',
       '',
       'TAXDES',
       '' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       170,
       5,
       'TIPAUT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Tipo de Autorizaes',
       'Tipo de Autorizaes',
       '',
       'TIPAUT',
       'T' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       250,
       10,
       'TIPAUT_POS',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Tipo Autorizao PoS',
       'Tipo da Autorizao do Totali PoS',
       '',
       'TIPAUT_POS',
       '' FROM DUAL
UNION ALL
SELECT 'AUT ',
       '01',
       180,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo do Pedido',
       'Tipo do Pedido',
       '',
       'TIPPED',
       'T' FROM DUAL
);

/*-- SEQ 6740 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'AUT ',
       'FLGEST',
       0,
       'A',
       'Autorizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'FLGEST',
       0,
       'P',
       'Pendente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'MODULO',
       0,
       ' ',
       'Commerce Web',
       TO_NUMBER(null),
       'CW' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'MODULO',
       0,
       ' ',
       'BackOffice',
       TO_NUMBER(null),
       'BO' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'MODULO',
       0,
       ' ',
       'Cash',
       TO_NUMBER(null),
       'CA' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'MODULO',
       0,
       ' ',
       'CRM e Fidelizao',
       TO_NUMBER(null),
       'CF' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'MODULO',
       0,
       ' ',
       'Config',
       TO_NUMBER(null),
       'CG' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'MODULO',
       0,
       ' ',
       'CheckOut',
       TO_NUMBER(null),
       'CK' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'MODULO',
       0,
       ' ',
       'CheckOut Server',
       TO_NUMBER(null),
       'CS' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'MODULO',
       0,
       ' ',
       'e-Business',
       TO_NUMBER(null),
       'EB' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'MODULO',
       0,
       ' ',
       'e-Commerce',
       TO_NUMBER(null),
       'EC' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'MODULO',
       0,
       ' ',
       'NEtData Browser',
       TO_NUMBER(null),
       'NB' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'MODULO',
       0,
       ' ',
       'NetData Config',
       TO_NUMBER(null),
       'NC' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'MODULO',
       0,
       ' ',
       'NetData Server',
       TO_NUMBER(null),
       'NS' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'MODULO',
       0,
       ' ',
       'Order',
       TO_NUMBER(null),
       'OR' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'MODULO',
       0,
       ' ',
       'Report Builder',
       TO_NUMBER(null),
       'RB' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'MODULO',
       0,
       ' ',
       'Stoq e Delivery',
       TO_NUMBER(null),
       'SD' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'MODULO',
       0,
       ' ',
       'Service',
       TO_NUMBER(null),
       'SE' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'MODULO',
       0,
       ' ',
       'SAC e WorkFlow',
       TO_NUMBER(null),
       'SW' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'MODULO',
       0,
       ' ',
       'Telemarketing',
       TO_NUMBER(null),
       'TM' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'MODULO',
       0,
       ' ',
       'Tools',
       TO_NUMBER(null),
       'TO' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       107,
       ' ',
       'Pedido Abaixo do Valor Mnimo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       106,
       ' ',
       'Dev. em filial dif. da origem',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       78,
       ' ',
       'Desconto acima do permitido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       104,
       ' ',
       'Sem permisso venda parte lote',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       103,
       ' ',
       's/ perm. produto somente enc ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       71,
       ' ',
       'Vend. s/ perm. venda encomend',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       72,
       ' ',
       'Srie  permitida p/ o produto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       73,
       ' ',
       'Prazo Mdio fora lim. plano ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       17,
       ' ',
       'Supervisor  tem autor. de ADM',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       18,
       ' ',
       'Superv.  tem aut. de OPERADOR',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       70,
       ' ',
       'Prazo valid.venc. s. reclculo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       24,
       ' ',
       'Cancelamento de notas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       52,
       ' ',
       'Digitao de O.S.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       53,
       ' ',
       'Reimpresso de notas fiscais',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       54,
       ' ',
       'V Valores do Caixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       55,
       ' ',
       'Contm inform.da lista negra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       56,
       ' ',
       'Alterao de O.S.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       57,
       ' ',
       'Interveno Fiscal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       58,
       ' ',
       'Incluso de Alquota',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       59,
       ' ',
       'Restore',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       60,
       ' ',
       'Ven.c/consulta off-line crdi.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       61,
       ' ',
       'Ven.vincul.c/script parado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       62,
       ' ',
       'Pr-datarcheq.p/ven.consumidor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       63,
       ' ',
       'Devol./troca s/vnculoanterior',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       64,
       ' ',
       'Faz sangria/reforo  identif.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       65,
       ' ',
       'Faz transf.(sangria/reforo)id',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       66,
       ' ',
       'Retirada em c/c',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       100,
       ' ',
       'Cancel.venda dias j fechados',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       7,
       ' ',
       'Val.Desc/Acrsc fora lim.plano',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       8,
       ' ',
       'Falta(m) Y kg para o produto X',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       9,
       ' ',
       'Val.Oramen/O.S.fora lim.plano',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       69,
       ' ',
       'Tab.Preos c/prazo Vign.Venc.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       68,
       ' ',
       'Sem Atu.Custos p/Fornec. Atu.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       67,
       ' ',
       'EndCob/EndEnt/EndFat com ARC',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       10,
       ' ',
       'A data do plano expirou',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       25,
       ' ',
       'Configurar sistema',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       26,
       ' ',
       'Recebimento parcial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       27,
       ' ',
       'Diferena de valores',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       28,
       ' ',
       'Venda sem consulta de crdito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       29,
       ' ',
       'Venda fora do plano',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       30,
       ' ',
       'Cliente com restrio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       31,
       ' ',
       'Autoriza restries',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       32,
       ' ',
       'Reforo do caixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       33,
       ' ',
       'Sangria do caixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       34,
       ' ',
       'Cliente com dbito de Bonus',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       35,
       ' ',
       'Cheque Pr',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       36,
       ' ',
       'Trocar o cliente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       37,
       ' ',
       'Troco de cheque',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       38,
       ' ',
       'Receber sem ver situao Banco',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       39,
       ' ',
       'Cancelamento de Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       40,
       ' ',
       'Finalizar trabalho',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       41,
       ' ',
       'Fechamento da estao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       42,
       ' ',
       'Fechar caixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       43,
       ' ',
       'Sada de valores',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       44,
       ' ',
       'Fechamento total',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       45,
       ' ',
       'Aceitar todos os cheques',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       46,
       ' ',
       'Aceitar o cheque',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       47,
       ' ',
       'Aceitar cheques',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       48,
       ' ',
       'Conta Corrente negativa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       49,
       ' ',
       'Limite de saque',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       50,
       ' ',
       'Cancelamento de item',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       51,
       ' ',
       'Edio/cancel.de nota/cupom',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       16,
       ' ',
       'Tab.Preos <> do pedido atual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       14,
       ' ',
       'Cli.possui prod. X para+Y dias',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       15,
       ' ',
       'Totais Inconsistentes',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       21,
       ' ',
       'Lanamento de TEF',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       22,
       ' ',
       'Recebimento de parcela',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       23,
       ' ',
       'Cancelar operao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       1,
       ' ',
       'Data 1 parc.deve ser >=a hoje',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       2,
       ' ',
       'Val.Desc/Acrsc fora lim.plano',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       3,
       ' ',
       'Val.1 parc.fora lim. do plano',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       4,
       ' ',
       'Nm.parc. fora limite do plano',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       5,
       ' ',
       'Val.esperado<>do val.informado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       6,
       ' ',
       'Aplicado desc.prod.em promoo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       11,
       ' ',
       'Data 1 parc. fora lim. plano',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       12,
       ' ',
       'Restries de crdito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       13,
       ' ',
       'No possvel testar restries',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       102,
       ' ',
       'Permitir modif frete calculado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       93,
       ' ',
       'Falta(m) Y UM para o lote X',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       0,
       ' ',
       'No se aplica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       105,
       '',
       'Cancelamento fora do prazo',
       TO_NUMBER(null),
       '' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT',
       101,
       '',
       'Aviso de entrega fora do prazo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       1001,
       ' ',
       'Incluir o cliente no programa ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       2001,
       ' ',
       'Retirar o cliente no programa ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       3001,
       ' ',
       'Mudar a fidelizao do cliente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       2,
       ' ',
       'O Plano "%A" exige autorizao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       9,
       ' ',
       'Receber os valores',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       10,
       ' ',
       'Efetuar a venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       11,
       ' ',
       'Configurar sistema',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       1011,
       ' ',
       'Alterar o acesso ao banco de d',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       12,
       ' ',
       'Receber parcialmente o documen',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       1012,
       ' ',
       'Receber a dvida do documento ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       2012,
       ' ',
       'Receber a dvida do documento ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       3012,
       ' ',
       'Receber o documento "%A", com ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       13,
       ' ',
       'Autorizar operao de TEF',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       15,
       ' ',
       'Ver extrato do cliente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       24,
       ' ',
       'Estornar recebimento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       1030,
       ' ',
       'Cancelamento da operao atual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       2030,
       ' ',
       'Emitir reduo Z. Se a reduo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       3030,
       ' ',
       'Cancelamento da transao %B d',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       4030,
       ' ',
       'Falta de comunicao com o ser',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       5030,
       ' ',
       'Transao ainda no processada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       6030,
       ' ',
       'Cancelar o ltimo cupom de ven',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       7030,
       ' ',
       'Aceitar Vale-Compra vencido em',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       8030,
       ' ',
       'Incluir a alquota de %A% do t',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       9030,
       ' ',
       'Vender %A Kg do produto sem pe',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       10030,
       ' ',
       'Por falta de comunicao com o',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       11030,
       ' ',
       'O Vale Compra ainda no foi pr',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       12030,
       ' ',
       'Devolver produtos no valor de ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       13030,
       ' ',
       'Ressarcimento de vale em dinhe',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       14030,
       ' ',
       'Registro de cancelamento manua',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       15030,
       ' ',
       'Registro de REABERTURA do canc',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       16030,
       ' ',
       'Cancelar transao de TEF pelo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       17030,
       ' ',
       'Emitir Vale Compra como troco.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       18030,
       ' ',
       'Sincronizar manualmente dados ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       31,
       ' ',
       'Liberar operao alm do limit',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       1031,
       ' ',
       'A. Encontrado %B ocorrncias.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       2031,
       ' ',
       'No foi possvel validar a sit',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       3031,
       ' ',
       'No foi possvel validar a sit',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       4031,
       ' ',
       'Limite Expirado. </RED>  Limit',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       5031,
       ' ',
       'Limite Excedido. ;Limite %A. L',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       6031,
       ' ',
       'Cliente com Parcelas Abertas. ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       7031,
       ' ',
       'No foi possvel consultar as ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       33,
       ' ',
       'Operar o caixa.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       1033,
       ' ',
       'Abrir a gaveta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       34,
       ' ',
       'Supervisor de caixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       1034,
       ' ',
       'Reforo no caixa de %A %B',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       2034,
       ' ',
       'Sangria no caixa de %A %C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       3034,
       ' ',
       'Por falta de comunicao com o',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       4034,
       ' ',
       'Retirada de cheques.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       43,
       ' ',
       'Retirada de %A de %B',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       44,
       ' ',
       'Pagamento com %B alm do LIMIT',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       1044,
       ' ',
       'Pagamento com %B alm do SALDO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       45,
       ' ',
       'Autorizar estouro de limite.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       99,
       ' ',
       'Fechamento de caixa sem contag',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       100,
       ' ',
       'Cancelamento do item %A.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       123,
       ' ',
       'Autorizar venda sem consultar ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       143,
       ' ',
       'Devoluo sem vnculo.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       158,
       ' ',
       'Visualisar dados financeiros e',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       169,
       ' ',
       'Estoque insuficiente. Disponv',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       1169,
       ' ',
       'Produto com estoque negativo d',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       2169,
       ' ',
       'No foi possvel consultar o e',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       3169,
       ' ',
       'No foi possvel consultar o e',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       4169,
       ' ',
       'O lote %A est com a data de v',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       5169,
       ' ',
       'Falha de comunicao com o ser',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       6169,
       ' ',
       'Venda com quantidade inferior ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       7169,
       ' ',
       'Estoque insuficiente no lote i',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       8169,
       ' ',
       'Produto desativado ou bloquead',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       178,
       ' ',
       'Abertura de caixa.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       1178,
       ' ',
       'A impressora no est ativa, p',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       2178,
       ' ',
       'J foi emitida a Reduo Z de ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       3178,
       ' ',
       'Abrir o caixa antes de conclui',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       179,
       ' ',
       'Fechamento de caixa.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       1179,
       ' ',
       'H pendncias no resolvidas d',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       2179,
       ' ',
       'H transaes pendentes, ou se',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       3179,
       ' ',
       'A impressora no est ativa. O',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       4179,
       ' ',
       'Por conta da impressora que n',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       5179,
       ' ',
       'Ver lanamentos do caixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       180,
       ' ',
       'Usar a tabela de preos "%A"',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       1213,
       ' ',
       'Plano "%C" permite no mximo %',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       2213,
       ' ',
       'Plano "%C" permite que o PRAZO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       3213,
       ' ',
       'Plano "%C" permite %A dias no ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       4213,
       ' ',
       'Plano "%C" permite operaes d',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       5213,
       ' ',
       'Plano "%C" permite que as oper',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       6213,
       ' ',
       'Plano "%C" permite no mximo %',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       7213,
       ' ',
       'Plano "%C" permite que o mnim',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       8213,
       ' ',
       'Plano "%C" permite %A dias no ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       9213,
       ' ',
       'Plano "%C" exige um valor de e',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       10213,
       ' ',
       'Plano "%C" permite no mximo %',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       11213,
       ' ',
       'Plano "%C" permite que o mnim',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       12213,
       ' ',
       'Plano "%C" permite %A PARCELAS',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       13213,
       ' ',
       'Plano "%C" permite no mximo %',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       14213,
       ' ',
       'Plano "%C" exige no mnimo %A ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       15213,
       ' ',
       'Plano "%C" permite %A de DESCO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       16213,
       ' ',
       'Plano "%C" permite no mximo %',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       17213,
       ' ',
       'Plano "%C" exige no mnimo %A ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       18213,
       ' ',
       'Plano "%C" permite %A de ACRS',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       19213,
       ' ',
       'Plano "%C" no permite DESCONT',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       20213,
       ' ',
       'Plano "%C" no aceita ACRSCIM',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       21213,
       ' ',
       'Plano "%C" permite no mximo %',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       22213,
       ' ',
       'Plano "%C" exige no mnimo %A ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       23213,
       ' ',
       'Plano "%C" permite %A no 1 RE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       24213,
       ' ',
       'A" com pendncia de pagamento.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       25213,
       ' ',
       'Plano "%A" para uso em negocia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       26213,
       ' ',
       'Itens no permitidos para %A P',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       27213,
       ' ',
       'Plano "%C" permite parcelas m',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       227,
       ' ',
       'Trocar bobina.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       1227,
       ' ',
       'Reimpresso do documento de "%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       2227,
       ' ',
       'Reimpresso do documento de "%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       3227,
       ' ',
       'Enviar e-Mail do documento de ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       1237,
       ' ',
       'Permitido um desconto mximo d',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       1,
       ' ',
       'Cadastrar cliente e editar end',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       2237,
       ' ',
       'Ofertado desconto de %B em um ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       3237,
       ' ',
       'Ofertado desconto de %B no pro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       4237,
       ' ',
       'Ofertado desconto no item pelo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       5237,
       ' ',
       'Ofertado desconto na venda pel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       262,
       ' ',
       'Acessar Pr-Venda de Outros Ve',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       339,
       ' ',
       'Mesclar DAV.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       1339,
       ' ',
       'Transferir %A desta operao d',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       378,
       ' ',
       'Alterar limite de crdito ;De ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       1378,
       ' ',
       'Alterar situao do CNPJ ;De "',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       391,
       ' ',
       'O nmero de srie informado ne',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       415,
       ' ',
       'Devoluo de nota de outra fil',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       423,
       ' ',
       'Uso de palavra imprpria no ca',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       429,
       ' ',
       'Acessar tela de saldo por fili',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       430,
       ' ',
       'Acessar tela de saldo por grad',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       1435,
       ' ',
       'Plano "%C", por padro, no ac',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       2435,
       ' ',
       'Plano "%C", por padro, no ac',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       3435,
       ' ',
       'Plano "%C" possui um DESCONTO ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       4435,
       ' ',
       'Plano "%C" possui um ACRSCIMO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       5435,
       ' ',
       'Ofertado desconto no item pelo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPAUT_POS',
       6435,
       ' ',
       'Ofertado desconto na venda pel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPPED',
       0,
       'O',
       'Oramento',
       71,
       ' ' FROM DUAL
UNION ALL
SELECT 'AUT ',
       'TIPPED',
       0,
       'S',
       'O.S.',
       72,
       ' ' FROM DUAL
);

/*-- SEQ 6741 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'AVA ',
       TO_NUMBER(null),
       'AVA ',
       'Tabela de Avaliaes',
       'TT_AVA',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'AVA.CODFIL, AVA.SEQUEN, AVA.FILADO,AVA.CODADO,AVA.FILAVA,ADO.CODAVA,ADO.AVALIA',
       '' FROM DUAL
);

/*-- SEQ 6742 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'AVA ','--','' FROM DUAL
UNION ALL
SELECT 'AVA ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'AVA ','99','Outros' FROM DUAL
);

/*-- SEQ 6743 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'AVA ',
       '01',
       70,
       1,
       'AVALIA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Quem  avaliado',
       'Quem  avaliado',
       '',
       'AVALIA',
       '' FROM DUAL
UNION ALL
SELECT 'AVA ',
       '01',
       60,
       3,
       'CODADO',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'A',
       '',
       'Cdigo do Avaliado',
       'Cdigo do Avaliado',
       'AVA.FILADO = USU.FILUSU  AND USU.CODUSU = AVA.CODADO',
       'CODADO',
       'F' FROM DUAL
UNION ALL
SELECT 'AVA ',
       '01',
       40,
       3,
       'CODAVA',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'A',
       '',
       'Cdigo do Avaliador',
       'Cdigo do Avaliador',
       'AVA.FILAVA = USU.FILUSU  AND USU.CODUSU = AVA.CODAVA',
       'CODAVA',
       'F' FROM DUAL
UNION ALL
SELECT 'AVA ',
       '01',
       50,
       3,
       'FILADO',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       '',
       'Filial do Avaliado',
       'DFIL.CODFIL = AVA.FILADO',
       'FILADO',
       '' FROM DUAL
UNION ALL
SELECT 'AVA ',
       '01',
       30,
       3,
       'FILAVA',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       '',
       'Filial do Avaliador',
       'DFIL.CODFIL = AVA.FILAVA',
       'FILAVA',
       'T' FROM DUAL
UNION ALL
SELECT 'AVA ',
       '01',
       10,
       3,
       'FILWOR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial da Tarefa',
       'Filial da Tarefa',
       'DFIL.CODFIL = AVA.FILWOR',
       'FILWOR',
       'F' FROM DUAL
UNION ALL
SELECT 'AVA ',
       '01',
       80,
       2,
       'NOTAVA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Nota da Avaliao',
       'Nota da avaliao',
       '',
       'NOTAVA',
       '' FROM DUAL
UNION ALL
SELECT 'AVA ',
       '01',
       20,
       10,
       'SEQWOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       '',
       'Nmero da Tarefa',
       'Nmero da Tarefa',
       '',
       'SEQWOR',
       '' FROM DUAL
);

/*-- SEQ 6744 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'AVA ',
       'AVALIA',
       0,
       '1',
       'Revisor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AVA ',
       'AVALIA',
       0,
       '2',
       'Registrador',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AVA ',
       'AVALIA',
       0,
       '3',
       'Responsvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AVA ',
       'AVALIA',
       0,
       '4',
       'Gerente de Mdulo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AVA ',
       'AVALIA',
       0,
       '5',
       'Gerente de Projeto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'AVA ',
       'NOTAVA',
       0,
       ' ',
       '0',
       TO_NUMBER(null),
       '0' FROM DUAL
UNION ALL
SELECT 'AVA ',
       'NOTAVA',
       0,
       ' ',
       '1',
       TO_NUMBER(null),
       '1' FROM DUAL
UNION ALL
SELECT 'AVA ',
       'NOTAVA',
       0,
       ' ',
       '2',
       TO_NUMBER(null),
       '2' FROM DUAL
UNION ALL
SELECT 'AVA ',
       'NOTAVA',
       0,
       ' ',
       '3',
       TO_NUMBER(null),
       '3' FROM DUAL
UNION ALL
SELECT 'AVA ',
       'NOTAVA',
       0,
       ' ',
       '4',
       TO_NUMBER(null),
       '4' FROM DUAL
UNION ALL
SELECT 'AVA ',
       'NOTAVA',
       0,
       ' ',
       '5',
       TO_NUMBER(null),
       '5' FROM DUAL
UNION ALL
SELECT 'AVA ',
       'NOTAVA',
       0,
       ' ',
       '6',
       TO_NUMBER(null),
       '6' FROM DUAL
UNION ALL
SELECT 'AVA ',
       'NOTAVA',
       0,
       ' ',
       '7',
       TO_NUMBER(null),
       '7' FROM DUAL
UNION ALL
SELECT 'AVA ',
       'NOTAVA',
       0,
       ' ',
       '8',
       TO_NUMBER(null),
       '8' FROM DUAL
UNION ALL
SELECT 'AVA ',
       'NOTAVA',
       0,
       ' ',
       '9',
       TO_NUMBER(null),
       '9' FROM DUAL
UNION ALL
SELECT 'AVA ',
       'NOTAVA',
       0,
       ' ',
       '10',
       TO_NUMBER(null),
       '10' FROM DUAL
);

/*-- SEQ 6745 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'AVI ',
       TO_NUMBER(null),
       'AVI ',
       'Registro de avisos',
       'TT_AVI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'AVI.CODFIL,AVI.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6746 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'AVI ','--','' FROM DUAL
UNION ALL
SELECT 'AVI ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'AVI ','99','Outros' FROM DUAL
);

/*-- SEQ 6747 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 5381,
       'VEN ',
       'AVI ',
       '01',
       '1',
       '',
       '',
       'VEN.CODFIL(+) = AVI.FILVEN AND
VEN.SEQUEN(+) = AVI.SEQVEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 5382,
       'CLI ',
       'AVI ',
       'N',
       '1',
       '',
       '',
       'cli.filcli = avi.filcli and
cli.codcli = avi.codcli',
       '',
       '' FROM DUAL
UNION ALL
SELECT 5383,
       'VEI ',
       'AVI ',
       'N',
       '1',
       '',
       '',
       'VEI.PLACAS(+) = AVI.PLACAS',
       '',
       '' FROM DUAL
);

/*-- SEQ 6748 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'AVI ',
       '01',
       90,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'AVI ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Codigo da filial',
       'DFIL.CODFIL = AVI.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'AVI ',
       '01',
       20,
       7,
       'DATENT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Entrega da Mensagem',
       'Data entrega da mensagem',
       '',
       'DATENT',
       'F' FROM DUAL
UNION ALL
SELECT 'AVI ',
       '01',
       100,
       7,
       'DATEXP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Expira em:',
       'Data de Expirao',
       '',
       'DATEXP',
       'F' FROM DUAL
UNION ALL
SELECT 'AVI ',
       '01',
       30,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Incluso Msg',
       'Data incluso da mensagem',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'AVI ',
       '01',
       110,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'V',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'AVI ',
       '01',
       40,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da venda',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'AVI ',
       '01',
       50,
       4000,
       'MENSAG',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem',
       '',
       'RTF2TXT(MENSAG)',
       'F' FROM DUAL
UNION ALL
SELECT 'AVI ',
       '01',
       60,
       7,
       'PLACAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Placa Veiculo',
       'Placa do veiculo',
       '',
       'PLACAS',
       'F' FROM DUAL
UNION ALL
SELECT 'AVI ',
       '01',
       70,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       '(AVI.CODFIL||AVI.SEQUEN)',
       'F' FROM DUAL
UNION ALL
SELECT 'AVI ',
       '01',
       80,
       10,
       'SEQVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Codigo da venda',
       '',
       'SEQVEN',
       'F' FROM DUAL
);

/*-- SEQ 6749 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'BAI ',
       TO_NUMBER(null),
       'BAI ',
       'Bairros',
       'TT_BAI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 6750 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'BAI ','--','' FROM DUAL
UNION ALL
SELECT 'BAI ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'BAI ','99','Outros' FROM DUAL
);

/*-- SEQ 6751 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 26583,
       'MUN ',
       'BAI ',
       'N',
       '1',
       '',
       '',
       'MUN.CODIGO = BAI.CODMUN',
       '',
       '' FROM DUAL
);

/*-- SEQ 6752 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'BAI ',
       '01',
       10,
       5,
       'CODBAI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Bairro',
       'Cdigo Bairro',
       '',
       'CODBAI',
       'F' FROM DUAL
UNION ALL
SELECT 'BAI ',
       '01',
       40,
       10,
       'CODIBG',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cd. IBGE Municpio',
       'Cdigo IBGE do Municpio',
       '',
       'CODIBG',
       'F' FROM DUAL
UNION ALL
SELECT 'BAI ',
       '01',
       20,
       5,
       'CODMUN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Municpio',
       'Cdigo Municpio',
       '',
       'CODMUN',
       'F' FROM DUAL
UNION ALL
SELECT 'BAI ',
       '01',
       30,
       30,
       'NOMBAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Bairro',
       'Bairro',
       '',
       'NOMBAI',
       'F' FROM DUAL
);

/*-- SEQ 6753 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'BON ',
       TO_NUMBER(null),
       'BON ',
       'Bonificaes',
       'TT_BON',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'BON.CODFIL,BON.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6754 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'BON ','--','' FROM DUAL
UNION ALL
SELECT 'BON ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'BON ','02','Datas' FROM DUAL
UNION ALL
SELECT 'BON ','99','Outros' FROM DUAL
);

/*-- SEQ 6755 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23194,
       'CLI ',
       'BON ',
       '01',
       'N',
       '',
       '',
       'CLI.FILCLI(+) = BON.FILCLI AND
CLI.CODCLI(+) = BON.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23195,
       'REC ',
       'BON ',
       '01',
       'N',
       '',
       '',
       'REC.CODFIL(+) = BON.FILREC AND
REC.SEQUEN(+) = BON.SEQREC AND
REC.NUMPAR(+) = BON.NUMPAR AND
REC.SUBPAR(+) = BON.SUBPAR
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23196,
       'USU ',
       'BON ',
       '01',
       'N',
       '',
       '',
       'USU.FILUSU(+) = BON.FILUSU AND
USU.CODUSU(+) = BON.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23197,
       'CCC ',
       'BON ',
       '01',
       'N',
       '',
       '',
       'CCC.CODFIL(+) = BON.FILCCC AND
CCC.SEQUEN(+) = BON.SEQCCC',
       '',
       '' FROM DUAL
UNION ALL
SELECT 86824,
       'VEN ',
       'BON ',
       '01',
       'N',
       '',
       '',
       'VEN.CODFIL(+) = BON.FILVEN AND
VEN.SEQUEN(+) = BON.SEQVEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45911,
       'RECP',
       'BON ',
       '01',
       'N',
       '',
       '',
       'RECP.ORI_CODFIL(+) = BON.FILREC AND
RECP.ORI_SEQUEN(+) = BON.SEQREC AND
RECP.ORI_NUMPAR(+) = BON.NUMPAR AND
RECP.ORI_SUBPAR(+) = BON.SUBPAR',
       '',
       '' FROM DUAL
);

/*-- SEQ 6756 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'BON ',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'BON ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       'BON.CODFIL = DFIL.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'BON ',
       '01',
       30,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       '9',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'USU.FILUSU(+) = BON.FILUSU AND USU.CODUSU(+) = BON.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'BON ',
       '02',
       190,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data de Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'BON ',
       '02',
       40,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'BON ',
       '02',
       130,
       7,
       'DATRES',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data do resgate',
       'Data do resgate do bnus',
       '',
       'DATRES',
       'F' FROM DUAL
UNION ALL
SELECT 'BON ',
       '--',
       140,
       1,
       'DUMMY',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DUMMY',
       'F' FROM DUAL
UNION ALL
SELECT 'BON ',
       '01',
       150,
       3,
       'FILCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Fil. Conta Corrente',
       'Filial da Conta Corrente',
       '',
       'FILCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'BON ',
       '01',
       50,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial do cliente',
       'Filial do cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'BON ',
       '01',
       90,
       3,
       'FILREC',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Recebimento',
       'Filial Recebimento',
       'BON.FILREC = DFIL.CODFIL(+)',
       'FILREC',
       'T' FROM DUAL
UNION ALL
SELECT 'BON ',
       '01',
       60,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial do usuario',
       'Filial do usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'BON ',
       '01',
       200,
       3,
       'FILVEN',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial da Venda',
       'Filial da Venda',
       'BON.FILVEN = DFIL.CODFIL(+)',
       'FILVEN',
       'T' FROM DUAL
UNION ALL
SELECT 'BON ',
       '99',
       180,
       40,
       'HISTOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Histrico',
       'Histrico',
       '',
       'HISTOR',
       '' FROM DUAL
UNION ALL
SELECT 'BON ',
       '01',
       100,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero Parcelas',
       'Nmero Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'BON ',
       '01',
       160,
       10,
       'SEQCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq Conta Corrente',
       'Sequenciador da Conta Corrente',
       '',
       'SEQCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'BON ',
       '01',
       110,
       10,
       'SEQREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Recebimentos',
       'Sequenciador Recebimentos',
       '',
       'SEQREC',
       'F' FROM DUAL
UNION ALL
SELECT 'BON ',
       '99',
       70,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'BON ',
       '01',
       210,
       10,
       'SEQVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq. da Venda',
       'Sequenciador da Venda',
       '',
       'SEQVEN',
       '' FROM DUAL
UNION ALL
SELECT 'BON ',
       '01',
       120,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'BON ',
       '99',
       170,
       1,
       'TIPBON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo do bnus',
       'Tipo do bnus',
       '',
       'TIPBON',
       'T' FROM DUAL
UNION ALL
SELECT 'BON ',
       '99',
       80,
       12,
       'VLRLAN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Lanamento',
       'valor do lancamento',
       '',
       'VLRLAN',
       'F' FROM DUAL
);

/*-- SEQ 6757 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'BON ',
       'TIPBON',
       0,
       'C',
       'Bnus concedido como cliente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BON ',
       'TIPBON',
       0,
       'I',
       'Bnus concedido como indicador',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BON ',
       'TIPBON',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BON ',
       'TIPBON',
       0,
       'V',
       'Bnus concedido como vendedor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BON ',
       'TIPBON',
       0,
       'X',
       'Bnus referente  vendas',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6758 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'BRU ',
       TO_NUMBER(null),
       'BRU ',
       'Receita Bruta Ms',
       'TT_BRU',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'BRU.CODFIL, BRU.ANOREF, BRU.MESREF',
       '' FROM DUAL
);

/*-- SEQ 6759 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'BRU ','--','' FROM DUAL
UNION ALL
SELECT 'BRU ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'BRU ','99','Outros' FROM DUAL
);

/*-- SEQ 6760 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20285,
       'USU ',
       'BRU ',
       '1',
       '0N',
       '',
       '',
       'BRU.FILAUT = USU.FILUSU AND 
BRU.CODAUT = USU.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 6761 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'BRU ',
       '--',
       20,
       4,
       'ANOREF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano',
       'Ano',
       '',
       'ANOREF',
       'F' FROM DUAL
UNION ALL
SELECT 'BRU ',
       '--',
       30,
       1,
       'APROVA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Aprovado?',
       'Aprovado?',
       '',
       'APROVA',
       'F' FROM DUAL
UNION ALL
SELECT 'BRU ',
       '--',
       40,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'BRU ',
       '--',
       50,
       3,
       'CODAUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Usurio que Aprovou',
       'Cdigo do Usurio que Aprovou',
       '',
       'CODAUT',
       'F' FROM DUAL
UNION ALL
SELECT 'BRU ',
       '--',
       60,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'BRU ',
       '--',
       70,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'BRU ',
       '--',
       80,
       3,
       'FILAUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Usurio que Aprovou',
       'Filial do Usurio que Aprovou',
       '',
       'FILAUT',
       'F' FROM DUAL
UNION ALL
SELECT 'BRU ',
       '--',
       90,
       2,
       'MESREF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms',
       'Ms',
       '',
       'MESREF',
       'F' FROM DUAL
UNION ALL
SELECT 'BRU ',
       '--',
       130,
       8,
       'NUMDOC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Radical do CNPJ',
       'Radical do CNPJ',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'BRU ',
       '--',
       100,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'BRU ',
       '--',
       110,
       12,
       'VLRBRU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Vlr Bruto Apurado',
       'Valor Bruto Apurado pelo Sistema',
       '',
       'VLRBRU',
       'F' FROM DUAL
UNION ALL
SELECT 'BRU ',
       '--',
       120,
       12,
       'VLRINF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Vlr Bruto Inf Manual',
       'Valor Bruto Informado Manualmente',
       '',
       'VLRINF',
       'F' FROM DUAL
);

/*-- SEQ 6762 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'BSC ',
       TO_NUMBER(null),
       'BSC ',
       'Base SelfColor',
       'TT_BSC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'BSC.FILUSU, BSC.CODUSU,
BSC.FILMAT, BSC.CODMAT, BSC.CODCOR, BSC.CODTAM,
BSC.FILPED, BSC.TIPPED, BSC.NUMPED, BSC.ITEPED,
BSC.FILPRE, BSC.CODPRE',
       '' FROM DUAL
);

/*-- SEQ 6763 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'BSC ','--','' FROM DUAL
UNION ALL
SELECT 'BSC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'BSC ','02','Datas' FROM DUAL
UNION ALL
SELECT 'BSC ','99','Outros' FROM DUAL
);

/*-- SEQ 6764 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21203,
       'USU ',
       'BSC ',
       '0N',
       '1',
       '',
       '',
       'BSC.FILUSU = USU.FILUSU AND
BSC.CODUSU = USU.CODUSU
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21204,
       'GRA ',
       'BSC ',
       '0N',
       '1',
       '',
       '',
       'BSC.FILMAT = GRA.FILMAT AND
BSC.CODMAT = GRA.CODMAT AND
BSC.CODCOR = GRA.CODCOR AND
BSC.CODTAM = GRA.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21205,
       'IOR ',
       'BSC ',
       '0N',
       '01',
       '',
       '',
       'BSC.FILPED = IOR.CODFIL AND
BSC.TIPPED = IOR.TIPPED AND
BSC.NUMPED = IOR.NUMPED AND
BSC.ITEPED = IOR.NUMITE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21206,
       'TPR ',
       'BSC ',
       '0N',
       '1',
       '',
       '',
       'BSC.FILPRE = TPR.CODFIL AND
BSC.CODPRE = TPR.CODPRE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22183,
       'TIN ',
       'BSC ',
       '0N',
       '1',
       '',
       '',
       'BSC.FILTIN = TIN.CODFIL AND
BSC.SEQTIN = TIN.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 6765 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'BSC ',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data da Atualizao',
       'Data e hora da modificao do registro',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       20,
       5,
       'CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Diviso do item de grade da base no Commerce',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Fil. reg. Fabricao',
       'Filial em que foi registrada a fabricao',
       'BSC.CODFIL=DFIL.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       40,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Cdigo do item de grade da base no Commerce',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       50,
       5,
       'CODPRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Cdigo da tabela de preo utilizada',
       '',
       'CODPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       60,
       5,
       'CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Subdiviso do item de grade da base no Commerce',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       70,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Cdigo do usurio que fez o registro',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       80,
       10,
       'COD_BASE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cd. base da mistura',
       'Cdigo da base da mistura no SelfColor ',
       '',
       'COD_BASE',
       'F' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       90,
       10,
       'COD_EMBALAGEM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cd. embalagem',
       'Cdigo da embalagem utilizada na produo no SelfColor',
       '',
       'COD_EMBALAGEM',
       'F' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       100,
       10,
       'COD_FORMULA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Tipo da frmula',
       'Tipo da frmula',
       '',
       'COD_FORMULA',
       'T' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       110,
       10,
       'COD_GRUPO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo do grupo',
       'Cdigo do grupo no SelfColor',
       '',
       'COD_GRUPO',
       'F' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       120,
       10,
       'COD_PRODUTO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo do produto',
       'Cdigo do produto utilizado na base da mistura no SelfColor',
       '',
       'COD_PRODUTO',
       'F' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       130,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data da incluso',
       'Data e hora da incluso do registro',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       140,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial da grade',
       'Filial do item de grade da base no Commerce',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       150,
       3,
       'FILPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial item de Ora.',
       'Filial do item de oramento em que foi vendida a base',
       '',
       'FILPED',
       'F' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       160,
       3,
       'FILPRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial tabela preo',
       'Filial da tabela de preo utilizada',
       '',
       'FILPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       280,
       3,
       'FILTIN',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial Tinta',
       'Filial Tinta',
       'DFIL.CODFIL = BSC.FILTIN',
       'FILTIN',
       '' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       170,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do usurio',
       'Filial do usurio que fez o registro',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       180,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao da produo',
       'Situao da produo',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       270,
       1,
       'FLGORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem do Registro',
       'Indica Origem do Registro',
       '',
       'FLGORI',
       'T' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       190,
       10,
       'ID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Identificador nico com SQ no banco.',
       '',
       'ID',
       'F' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       200,
       5,
       'ITEPED',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'N do item de Ora.',
       'Nmero do item de oramento em que foi vendida a base',
       '',
       'ITEPED',
       'F' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       210,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Pedido do item Ora.',
       'Pedido do item de oramento em que foi vendida a base',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       220,
       14,
       'PRECOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Preo unitrio de venda da base',
       '',
       'PRECOV',
       'F' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       230,
       12,
       'QTDMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Quantidade produzida',
       'Quantidade produzida',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       290,
       10,
       'SEQTIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Sequenciador Tinta',
       'Sequenciador Tinta',
       '',
       'SEQTIN',
       '' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       240,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo do item Ora.',
       'Tipo do item de oramento em que foi vendida a base',
       '',
       'TIPPED',
       'T' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       250,
       1,
       'TIP_FORMULA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo da frmula',
       'Tipo da frmula',
       '',
       'TIP_FORMULA',
       'T' FROM DUAL
UNION ALL
SELECT 'BSC ',
       '--',
       260,
       12,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor total',
       'Valor total (Base + Colorantes)',
       '',
       'VLRMOV',
       'F' FROM DUAL
);

/*-- SEQ 6766 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'BSC ',
       'FLGEST',
       0,
       'A',
       'Aberta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BSC ',
       'FLGEST',
       0,
       'C',
       'Cancelada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BSC ',
       'FLGEST',
       0,
       'F',
       'Fila de Dispensa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BSC ',
       'FLGEST',
       0,
       'P',
       'Produzida',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BSC ',
       'FLGORI',
       0,
       'O',
       'Order',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BSC ',
       'FLGORI',
       0,
       'S',
       'SelfColor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BSC ',
       'TIPPED',
       0,
       'O',
       'DAV',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BSC ',
       'TIPPED',
       0,
       'P',
       'Pr-Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BSC ',
       'TIPPED',
       0,
       'S',
       'DAV-OS',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BSC ',
       'TIP_FORMULA',
       0,
       'P',
       'Personalizada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BSC ',
       'TIP_FORMULA',
       0,
       'S',
       'Suvinil',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6767 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'BXC ',
       TO_NUMBER(null),
       'BXC ',
       'Conta B. X Carteira',
       'TT_CTBXCCB',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 6768 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'BXC ','--','' FROM DUAL
UNION ALL
SELECT 'BXC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'BXC ','99','Outros' FROM DUAL
);

/*-- SEQ 6769 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 26921,
       'CCB ',
       'BXC ',
       '1',
       '0N',
       '',
       '',
       'BXC.CODBCO = CCB.CODBCO AND
BXC.CODCCB = CCB.CODCCB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26922,
       'CTB ',
       'BXC ',
       '1',
       '0N',
       '',
       '',
       'BXC.CODBCO = CTB.CODBCO AND
BXC.NUMAGE = CTB.NUMAGE AND
BXC.CTACRR = CTB.CTACRR',
       '',
       '' FROM DUAL
);

/*-- SEQ 6770 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'BXC ',
       '01',
       100,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       '',
       'Data da atualizao',
       'Data da atualizao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'BXC ',
       '01',
       30,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Banco',
       'Banco',
       '',
       'CODBCO',
       '' FROM DUAL
UNION ALL
SELECT 'BXC ',
       '01',
       60,
       5,
       'CODCCB',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Carteira',
       'Carteira',
       '',
       'CODCCB',
       '' FROM DUAL
UNION ALL
SELECT 'BXC ',
       '01',
       140,
       20,
       'CODCED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Cedente',
       'Cdigo do Cedente',
       '',
       'CODCED',
       'F' FROM DUAL
UNION ALL
SELECT 'BXC ',
       '01',
       80,
       20,
       'CODCNV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Convnio',
       'Convnio',
       '',
       'CODCNV',
       '' FROM DUAL
UNION ALL
SELECT 'BXC ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'BXC ',
       '99',
       150,
       1,
       'CODGER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Gerao',
       'Cdigo de Gerao',
       '',
       'CODGER',
       'F' FROM DUAL
UNION ALL
SELECT 'BXC ',
       '99',
       160,
       10,
       'CODMOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Modalidade',
       'Cdigo da Modalidade',
       '',
       'CODMOD',
       'F' FROM DUAL
UNION ALL
SELECT 'BXC ',
       '01',
       170,
       20,
       'CODTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Transmisso',
       'Cdigo de Transmisso para Remessa',
       '',
       'CODTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'BXC ',
       '01',
       50,
       10,
       'CTACRR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Conta',
       'Conta',
       '',
       'CTACRR',
       '' FROM DUAL
UNION ALL
SELECT 'BXC ',
       '01',
       90,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'BXC ',
       '01',
       111,
       1,
       'LAYBOL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Layout Boleto Middle',
       'Layout do Boleto no Middleware',
       '',
       'LAYBOL',
       'T' FROM DUAL
UNION ALL
SELECT 'BXC ',
       '01',
       110,
       5,
       'LAYPAD',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Layout Boleto CB',
       'Layout do Boleto no CobreBem',
       '',
       'LAYPAD',
       'T' FROM DUAL
UNION ALL
SELECT 'BXC ',
       '99',
       180,
       3,
       'LAYREM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Layout Remessa',
       'Layout do Arquivo de Remessa/Retorno do CNAB',
       '',
       'LAYREM',
       'T' FROM DUAL
UNION ALL
SELECT 'BXC ',
       '01',
       70,
       100,
       'LICENC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Licena Cobre bem',
       'Licena Cobre bem',
       '',
       'LICENC',
       '' FROM DUAL
UNION ALL
SELECT 'BXC ',
       '01',
       40,
       5,
       'NUMAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Agencia',
       'Agencia',
       '',
       'NUMAGE',
       '' FROM DUAL
UNION ALL
SELECT 'BXC ',
       '01',
       120,
       4000,
       'RECSAC',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Recibo do Sacado',
       'Recibo do Sacado',
       '',
       'RTF2TXT(RECSAC)',
       '' FROM DUAL
UNION ALL
SELECT 'BXC ',
       '01',
       130,
       10,
       'SEQREM',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Sequenciador Remessa',
       'Sequenciador da Remessa',
       '',
       'SEQREM',
       '' FROM DUAL
UNION ALL
SELECT 'BXC ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6771 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'BXC ',
       'LAYBOL',
       0,
       'C',
       'Carn',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYBOL',
       0,
       'E',
       'Entrega',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYBOL',
       0,
       'F',
       'Fatura',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYBOL',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYBOL',
       0,
       'P',
       'Padro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYPAD',
       0,
       ' ',
       'Padro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYPAD',
       1,
       ' ',
       'PadroHTML',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYPAD',
       2,
       ' ',
       'PadroReciboPersonalizadoHTML',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYPAD',
       3,
       ' ',
       'Invertido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYPAD',
       4,
       ' ',
       'CarnetReciboLateralDireita',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYPAD',
       5,
       ' ',
       'CarnetReciboLateralEsquerda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYPAD',
       6,
       ' ',
       'PadroReciboPersonalizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYPAD',
       7,
       ' ',
       'InvertidoReciboPersonalizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYPAD',
       8,
       ' ',
       'CarnetReciboLateralDireitaPers',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYPAD',
       9,
       ' ',
       'CarnetReciboLateralEsquerdPers',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYPAD',
       10,
       ' ',
       'PadroEndereadoVerso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYPAD',
       11,
       ' ',
       'InvertidoEndereadoVerso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYPAD',
       12,
       ' ',
       'PadroEndereadoVersoRecibPers',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYPAD',
       13,
       ' ',
       'InvertidoEndereadoVersoRecPer',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYPAD',
       14,
       ' ',
       'PadroVersoPersonalizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYPAD',
       15,
       ' ',
       'InvertidoVersoPersonalizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYPAD',
       16,
       ' ',
       'PadroVersoPersonalizadoRecPer',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYPAD',
       17,
       ' ',
       'InvertidoVersoPersReciboPers',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYPAD',
       18,
       ' ',
       'CarnetReciboTopo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYPAD',
       19,
       ' ',
       'CarnetReciboTopoPersonalizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYREM',
       240,
       ' ',
       'CNAB 240',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'BXC ',
       'LAYREM',
       400,
       ' ',
       'CNAB 400',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6772 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'BXE ',
       TO_NUMBER(null),
       'BXE ',
       'BicosXEcf',
       'TT_BICXECF',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'BXE.CODFIL,BXE.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6773 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'BXE ','--','' FROM DUAL
UNION ALL
SELECT 'BXE ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'BXE ','99','Outros' FROM DUAL
);

/*-- SEQ 6774 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'BXE ',
       '01',
       30,
       11,
       'CODBIC',
       'A',
       'DBIC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DBIC.FILBIC||'' - ''||DBIC.SEQFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Bico',
       'Bico',
       'DBIC.CODTAB = BXE.CODBIC',
       'CODBIC',
       'F' FROM DUAL
UNION ALL
SELECT 'BXE ',
       '01',
       40,
       5,
       'CODECF',
       'G',
       'DECW',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DECW.FILECF||'' - ''||DECW.NUMECF',
       'V',
       '',
       '',
       'N',
       '',
       'ECF',
       'Cdigo do Ecf',
       'DECW.FILECF = BXE.CODFIL AND DECW.CODTAB = BXE.CODECF',
       'CODECF',
       'F' FROM DUAL
UNION ALL
SELECT 'BXE ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'FIL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'FIL2.CODFIL',
       'V',
       '',
       '',
       '9',
       '',
       'Filial',
       'Filial',
       'FIL2.CODFIL = BXE.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'BXE ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6775 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CAI ',
       TO_NUMBER(null),
       'CAI ',
       'Caixa',
       'TT_CAI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CAI.CODFIL,CAI.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6776 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CAI ','--','' FROM DUAL
UNION ALL
SELECT 'CAI ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CAI ','99','Outros' FROM DUAL
);

/*-- SEQ 6777 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 43309,
       'RCAI',
       'CAI ',
       'N',
       '1',
       '',
       '',
       'RCAI.CODFIL = CAI.CODFIL AND
RCAI.SEQUEN = CAI.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 6778 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CAI ',
       '01',
       10,
       5,
       'CAMBIO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cmbio',
       'Cmbio',
       '',
       'CAMBIO',
       'F' FROM DUAL
UNION ALL
SELECT 'CAI ',
       '01',
       20,
       5,
       'CARTAO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Carto',
       'Carto',
       '',
       'CARTAO',
       'F' FROM DUAL
UNION ALL
SELECT 'CAI ',
       '01',
       30,
       1,
       'CHEQUE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Cheque',
       'Cheque',
       '',
       'CHEQUE',
       'T' FROM DUAL
UNION ALL
SELECT 'CAI ',
       '01',
       40,
       5,
       'CODCAI',
       'S',
       'DCAI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCAI.CX_DES',
       'V',
       '',
       '',
       'N',
       'F',
       'Descrio do Caixa',
       'Descrio do caixa',
       'CAI.CODCAI = DCAI.CODTAB(+)',
       'CODCAI',
       'T' FROM DUAL
UNION ALL
SELECT 'CAI ',
       '01',
       50,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = CAI.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CAI ',
       '01',
       60,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo da Srie',
       'Cdigo da Srie',
       'CAI.CODSER=DSER.CODSER (+)',
       'CODSER',
       'T' FROM DUAL
UNION ALL
SELECT 'CAI ',
       '01',
       70,
       1,
       'ORIGEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem',
       'Origem',
       '',
       'ORIGEM',
       'T' FROM DUAL
UNION ALL
SELECT 'CAI ',
       '01',
       80,
       5,
       'OUTROS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Outros',
       'Outros',
       '',
       'OUTROS',
       'F' FROM DUAL
UNION ALL
SELECT 'CAI ',
       '01',
       90,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CAI ',
       '01',
       100,
       1,
       'TIPCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Carto',
       'Tipo Carto',
       '',
       'TIPCAR',
       'T' FROM DUAL
UNION ALL
SELECT 'CAI ',
       '01',
       110,
       5,
       'TIPCCC',
       'S',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       'A',
       'F',
       'Tipo C/C',
       'Tipo Conta Corrente',
       'DCCC.CODTAB = CAI.TIPCCC',
       'TIPCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'CAI ',
       '01',
       120,
       12,
       'VLRLAN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Lanamento',
       'Valor Lanamento',
       '',
       'VLRLAN',
       'F' FROM DUAL
);

/*-- SEQ 6779 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CAI ',
       'CHEQUE',
       0,
       'P',
       'Pr-Datado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CAI ',
       'CHEQUE',
       0,
       'T',
       'Cheque Troco',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CAI ',
       'CHEQUE',
       0,
       'V',
       ' Vista',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CAI ',
       'ORIGEM',
       0,
       '1',
       'Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CAI ',
       'ORIGEM',
       0,
       '2',
       'Recebimento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CAI ',
       'ORIGEM',
       0,
       '3',
       'Sangria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CAI ',
       'ORIGEM',
       0,
       '4',
       'Reforo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CAI ',
       'ORIGEM',
       0,
       '5',
       'Depsito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CAI ',
       'ORIGEM',
       0,
       '6',
       'Retirada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CAI ',
       'ORIGEM',
       0,
       '7',
       'Recebimento de devoluo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CAI ',
       'ORIGEM',
       0,
       '8',
       'Devoluo de Vendas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CAI ',
       'ORIGEM',
       0,
       '9',
       'Diferena',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CAI ',
       'ORIGEM',
       0,
       'T',
       'Recebimento de terceiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CAI ',
       'TIPCAR',
       0,
       'C',
       'Crdito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CAI ',
       'TIPCAR',
       0,
       'D',
       'Dbito',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6780 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CAM ',
       0,
       'CAM ',
       'Cmbio',
       'TT_CAM',
       'T',
       '',
       'TOTALL',
       'Cmbio',
       '{CODMOE;DATREF}',
       '',
       '',
       'Cmbio',
       'T',
       '',
       'CAM.CODMOE,CAM.DATREF',
       '' FROM DUAL
);

/*-- SEQ 6781 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CAM ','--','' FROM DUAL
);

/*-- SEQ 6782 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CAM ',
       '--',
       25,
       4,
       'ANO_DATREF',
       'A',
       '',
       0,
       0,
       'CAM ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CAM',
       '',
       'N',
       'T',
       'Ano de Data',
       'Ano de Data de referncia',
       '',
       'TO_CHAR(CAM.DATREF,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CAM ',
       '--',
       10,
       2,
       'CODMOE',
       'S',
       'DMOE',
       0,
       0,
       'CAM ',
       10,
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       'CAM',
       'F',
       'A',
       'T',
       'Moeda',
       'Cdigo da moeda',
       'CAM.CODMOE = DMOE.CODTAB (+)',
       'CODMOE',
       'T' FROM DUAL
UNION ALL
SELECT 'CAM ',
       '--',
       20,
       8,
       'DATREF',
       'D',
       '',
       0,
       0,
       'CAM ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CAM',
       'F',
       'D',
       'T',
       'Data Referncia',
       'Data de referncia',
       '',
       'DATREF',
       'F' FROM DUAL
UNION ALL
SELECT 'CAM ',
       '--',
       23,
       2,
       'MES_DATREF',
       'A',
       '',
       0,
       0,
       'CAM ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CAM',
       '',
       'N',
       'T',
       'Ms de Data',
       'Ms de Data de referncia',
       '',
       'TO_CHAR(CAM.DATREF,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CAM ',
       '--',
       30,
       14,
       'VLRREF',
       'F',
       '',
       4,
       0,
       'CAM ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CAM',
       'T',
       'N',
       'T',
       'Valor Referncia',
       'Valor de referncia',
       '',
       'VLRREF',
       'F' FROM DUAL
);

/*-- SEQ 6783 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CAR ',
       TO_NUMBER(null),
       'CAR ',
       'Cartes',
       'TT_CAR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'CAR.FILCAR,CAR.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6784 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CAR ','--','' FROM DUAL
);

/*-- SEQ 6785 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 5390,
       'USU ',
       'CAR ',
       'N',
       '1',
       '',
       '',
       'USU.FILUSU(+) = CAR.FILMOT AND
USU.CODUSU(+) = CAR.CODMOT AND
USU.FILUSU(+) = CAR.FILUSU AND
USU.CODUSU(+) = CAR.CODUSU
',
       '',
       '' FROM DUAL
);

/*-- SEQ 6786 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CAR ',
       '--',
       7,
       3,
       'CODMOT',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Motorista',
       'Cdigo Motorista',
       'CAR.FILMOT= USU2.FILUSU(+) AND CAR.CODMOT = USU2.CODUSU(+)',
       'CODMOT',
       'T' FROM DUAL
UNION ALL
SELECT 'CAR ',
       '--',
       5,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Usurio',
       'Cdigo do Usurio',
       'CAR.FILUSU = USU2.FILUSU(+) AND CAR.CODUSU = USU2.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'CAR ',
       '--',
       3,
       7,
       'DATCAR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Carto',
       'Data Carto',
       '',
       'DATCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'CAR ',
       '--',
       1,
       3,
       'FILCAR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial do Carto',
       'Filial do Carto',
       'DFIL.CODFIL = CAR.FILCAR',
       'FILCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'CAR ',
       '--',
       6,
       3,
       'FILMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Motivo',
       '',
       'FILMOT',
       'F' FROM DUAL
UNION ALL
SELECT 'CAR ',
       '--',
       4,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'CAR ',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 6787 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CBP ',
       TO_NUMBER(null),
       'CBP ',
       'Ct. Bancria Cliente',
       'TT_CBP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 6788 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CBP ','--','' FROM DUAL
UNION ALL
SELECT 'CBP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CBP ','99','Outros' FROM DUAL
);

/*-- SEQ 6789 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 63343,
       'CLI ',
       'CBP ',
       '1',
       'N',
       '',
       '',
       'CLI.FILCLI = CBP.FILCLI AND
CLI.CODCLI = CBP.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 63344,
       'EDE ',
       'CBP ',
       '1',
       'N',
       '',
       '',
       'CLI.FILCLI = EDE.FILCLI AND
CLI.CODCLI = EDE.CODCLI AND
CLI.FILEND = EDE.CODFIL AND
CLI.NUMEND = EDE.NUMEND',
       '',
       '' FROM DUAL
);

/*-- SEQ 6790 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'CBP ',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Atualizado Em',
       'Atualizado Em',
       '',
       'ATU_EM',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CBP ',
       '--',
       20,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Banco',
       'Cdigo do Banco',
       '',
       'CODBCO',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CBP ',
       '--',
       30,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CBP ',
       '--',
       40,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = CBP.CODFIL',
       'CODFIL',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'CBP ',
       '--',
       150,
       1,
       'CONJUN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Conta Conjunta?',
       'Conta Conjunta?',
       '',
       'CONJUN',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CBP ',
       '--',
       50,
       10,
       'CTACRR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Conta',
       'Conta',
       '',
       'CTACRR',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CBP ',
       '--',
       60,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data de Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CBP ',
       '--',
       70,
       2,
       'DIGAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Dgito Agncia',
       'Dgito Agncia',
       '',
       'DIGAGE',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CBP ',
       '--',
       80,
       1,
       'DIGA_C',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Digito Agencia/Conta',
       'Digito Agencia/Conta',
       '',
       'DIGA_C',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CBP ',
       '--',
       90,
       2,
       'DIGCRR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Digito Conta',
       'Digito Conta',
       '',
       'DIGCRR',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CBP ',
       '--',
       100,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial do Cliente',
       'Filial do Cliente',
       'DFIL.CODFIL = CBP.FILCLI',
       'FILCLI',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CBP ',
       '--',
       110,
       3,
       'FILEND',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial Endereo',
       'Filial Endereo',
       'DFIL.CODFIL = CBP.FILEND',
       'FILEND',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CBP ',
       '--',
       120,
       5,
       'NUMAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Agncia',
       'Agncia',
       '',
       'NUMAGE',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CBP ',
       '--',
       130,
       4,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Endereo',
       'Nmero Endereo',
       '',
       'NUMEND',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CBP ',
       '--',
       140,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CBP ',
       '--',
       160,
       1,
       'TIPCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCON',
       'T',
       'P' FROM DUAL
);

/*-- SEQ 6791 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CBP ',
       'ATU_EM',
       0,
       'P',
       'Poupana',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CBP ',
       'TIPCON',
       0,
       'C',
       'Conta Corrente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CBP ',
       'TIPCON',
       0,
       'J',
       'Judicial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CBP ',
       'TIPCON',
       0,
       'P',
       'Poupana',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6792 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CBS ',
       TO_NUMBER(null),
       'CBS ',
       'Config Combustvel',
       'TT_CBS',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CBS.CODFIL, CBS.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6793 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CBS ','--','' FROM DUAL
UNION ALL
SELECT 'CBS ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CBS ','99','Outros' FROM DUAL
);

/*-- SEQ 6794 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20352,
       'PRO ',
       'CBS ',
       '01',
       '0N',
       '',
       '',
       'CBS.FILMAT(+) = PRO.FILMAT AND CBS.CODMAT(+) = PRO.CODMAT',
       '',
       '' FROM DUAL
);

/*-- SEQ 6795 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CBS ',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = CBS.CODFIL',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'CBS ',
       '--',
       20,
       6,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo do Produto',
       'Cdigo do Produto na qual se aplica a configurao',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'CBS ',
       '--',
       30,
       8,
       'CUSTOFINMENSAL',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Custo finan. mensal',
       'Custo financeiro mensal',
       '',
       'CUSTOFINMENSAL',
       'F' FROM DUAL
UNION ALL
SELECT 'CBS ',
       '--',
       40,
       12,
       'CUSTO_LIGACAO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Custo lig. Tel. -TEF',
       'Custo para ligaes telefnicas (TEF)',
       '',
       'CUSTO_LIGACAO',
       'F' FROM DUAL
UNION ALL
SELECT 'CBS ',
       '--',
       50,
       3,
       'DIACRE_PREATEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Dias para crdito',
       'Dias para crdito no pr-atendimento',
       '',
       'DIACRE_PREATEND',
       'F' FROM DUAL
UNION ALL
SELECT 'CBS ',
       '--',
       60,
       3,
       'DIADEB_PREATEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Dias para dbito',
       'Dias para dbito no pr-atendimento',
       '',
       'DIADEB_PREATEND',
       'F' FROM DUAL
UNION ALL
SELECT 'CBS ',
       '--',
       70,
       5,
       'DIAS_TEF_NO_PRECO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Base de preo em dia',
       'Base de preo em dias',
       '',
       'DIAS_TEF_NO_PRECO',
       'F' FROM DUAL
UNION ALL
SELECT 'CBS ',
       '--',
       80,
       3,
       'FILAPL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial aplica config',
       'Filial na qual se aplica a configurao',
       '',
       'FILAPL',
       'F' FROM DUAL
UNION ALL
SELECT 'CBS ',
       '--',
       90,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial PRO ap config',
       'Filial do Produto na qual se aplica a configurao',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'CBS ',
       '--',
       100,
       4,
       'PER_CPMF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '% CPMF',
       '% CPMF',
       '',
       'PER_CPMF',
       'F' FROM DUAL
UNION ALL
SELECT 'CBS ',
       '--',
       110,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CBS ',
       '--',
       120,
       7,
       'TAXA_TEF_NO_PRECO',
       'F',
       '',
       3,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Taxa de TEF',
       'Taxa de TEF embutida no preo',
       '',
       'TAXA_TEF_NO_PRECO',
       'F' FROM DUAL
UNION ALL
SELECT 'CBS ',
       '--',
       130,
       12,
       'TAXCRE_PREATEND',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Taxa para crdito',
       'Taxa para crdito no pr-atendimento',
       '',
       'TAXCRE_PREATEND',
       'F' FROM DUAL
UNION ALL
SELECT 'CBS ',
       '--',
       140,
       12,
       'TAXDEB_PREATEND',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Taxa para dbito',
       'Taxa para dbito no pr-atendimento',
       '',
       'TAXDEB_PREATEND',
       'F' FROM DUAL
UNION ALL
SELECT 'CBS ',
       '--',
       150,
       1,
       'TROCO_TEF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Aceita troco (TEF)?',
       'Aceita troco sobre operaes de TEF',
       '',
       'TROCO_TEF',
       'F' FROM DUAL
UNION ALL
SELECT 'CBS ',
       '--',
       160,
       1,
       'USA_PREATENDIMENTO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Pr-atend. Calc?',
       'Usa Pr-atendimento para clculo de combustvel',
       '',
       'USA_PREATENDIMENTO',
       'F' FROM DUAL
UNION ALL
SELECT 'CBS ',
       '--',
       170,
       1,
       'VENDA_CC_E_OUTROS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Aceita out meio Pag?',
       'Em vendas com C/C aceita outros meios de pagamento misturadas',
       '',
       'VENDA_CC_E_OUTROS',
       'F' FROM DUAL
);

/*-- SEQ 6796 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CCB ',
       TO_NUMBER(null),
       'CCB ',
       'Carteira Bancria',
       'TT_CCB',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CCB.CODBCO,CCB.CODCCB',
       '' FROM DUAL
);

/*-- SEQ 6797 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CCB ','--','' FROM DUAL
UNION ALL
SELECT 'CCB ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CCB ','99','Outros' FROM DUAL
);

/*-- SEQ 6798 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CCB ',
       '01',
       10,
       3,
       'CARBCO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Carteira do Banco',
       'Carteira no Banco',
       '',
       'CARBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'CCB ',
       '01',
       50,
       1,
       'CARCCB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Caracters. Carteira',
       'Caracterstica da Carteira',
       '',
       'CARCCB',
       'F' FROM DUAL
UNION ALL
SELECT 'CCB ',
       '01',
       20,
       3,
       'CODBCO',
       'A',
       'DBCO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DBCO.NBANCO',
       'V',
       '',
       '',
       'A',
       'F',
       'Cod Banco',
       'Codigo do Banco',
       'DBCO.CBANCO(+) = CCB.CODBCO',
       'CODBCO',
       'T' FROM DUAL
UNION ALL
SELECT 'CCB ',
       '01',
       30,
       5,
       'CODCCB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cod Carteira',
       'Codigo Carteira',
       '',
       'CODCCB',
       'F' FROM DUAL
UNION ALL
SELECT 'CCB ',
       '99',
       140,
       5,
       'CODCRB',
       'S',
       'CRB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'CRB.DESCRB',
       'V',
       '',
       '',
       'N',
       '',
       'Carteira de Banco',
       'Cdigo na Lista de Carteiras de Banco',
       'CRB.CODBCO (+) = CCB.CODBCO',
       'CODCRB',
       'T' FROM DUAL
UNION ALL
SELECT 'CCB ',
       '01',
       150,
       1,
       'DEDTAX',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Deduz Taxa do Ttulo',
       'Deduz Taxa do Ttulo?',
       '',
       'DEDTAX',
       '' FROM DUAL
UNION ALL
SELECT 'CCB ',
       '01',
       40,
       30,
       'DESCCB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Carteira',
       'Descricao da Carteira',
       '',
       'DESCCB',
       'F' FROM DUAL
UNION ALL
SELECT 'CCB ',
       '01',
       60,
       1,
       'DTRBLQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DistribuioBloqueto',
       'Distribuio do Bloqueto',
       '',
       'DTRBLQ',
       'F' FROM DUAL
UNION ALL
SELECT 'CCB ',
       '01',
       70,
       1,
       'EMIBLQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Emisso Bloqueto',
       'Emisso Bloqueto',
       '',
       'EMIBLQ',
       'F' FROM DUAL
UNION ALL
SELECT 'CCB ',
       '01',
       110,
       1,
       'ENVNOS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Envia Nosso-Nmero',
       'Indica se o sistema deve enviar o Nosso-Nmero para o banco',
       '',
       'ENVNOS',
       'F' FROM DUAL
UNION ALL
SELECT 'CCB ',
       '01',
       80,
       1,
       'FRMCAD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Forma Cadastramento',
       'Forma de Cadastramento',
       '',
       'FRMCAD',
       'F' FROM DUAL
UNION ALL
SELECT 'CCB ',
       '99',
       120,
       1,
       'GERSGR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Gera Segmento R?',
       'Gera Segmento R no CNAB 240?',
       '',
       'GERSGR',
       'F' FROM DUAL
UNION ALL
SELECT 'CCB ',
       '99',
       130,
       200,
       'LOCPAG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Local de Pagamento',
       'Local de Pagamento',
       '',
       'LOCPAG',
       'F' FROM DUAL
UNION ALL
SELECT 'CCB ',
       '01',
       100,
       1,
       'PREDES',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'F',
       'Pr Desconto?',
       'Pr Desconto?',
       '',
       'PREDES',
       'F' FROM DUAL
UNION ALL
SELECT 'CCB ',
       '01',
       90,
       1,
       'TIPDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Tipo Documento',
       'Tipo Documento',
       '',
       'TIPDOC',
       'F' FROM DUAL
);

/*-- SEQ 6799 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CCC ',
       TO_NUMBER(null),
       'CCC ',
       'Conta Corrente',
       'TT_CCC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'CCC.CODFIL,CCC.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6800 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CCC ','--','' FROM DUAL
UNION ALL
SELECT 'CCC ','08','Operaes de Caixa' FROM DUAL
UNION ALL
SELECT 'CCC ','1 ','Identificao' FROM DUAL
UNION ALL
SELECT 'CCC ','99','Outros' FROM DUAL
);

/*-- SEQ 6801 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 30511,
       'WOR ',
       'CCC ',
       '1',
       'N',
       '',
       '',
       'WOR.CODFIL = CCC.FILWOR AND
WOR.SEQUEN = CCC.SEQWOR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30512,
       'USU ',
       'CCC ',
       '0N',
       '1',
       '',
       '',
       'USU.FILUSU(+) = CCC.FILUSU AND
USU.CODUSU(+) = CCC.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30513,
       'GRA ',
       'CCC ',
       '1',
       'N',
       '',
       '',
       'GRA.FILMAT(+) = CCC.FILMAT AND
GRA.CODMAT(+) = CCC.CODMAT AND
GRA.CODCOR(+) = CCC.CODCOR AND
GRA.CODTAM(+) = CCC.CODTAM
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30514,
       'LIM ',
       'CCC ',
       '1',
       'N',
       '',
       '',
       'CCC.FILCLI(+) = LIM.FILCLI AND
CCC.CODCLI(+) = LIM.CODCLI AND
CCC.TIPCCC(+) = LIM.TIPCCC',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30515,
       'CHR ',
       'CCC ',
       '0N',
       '1',
       '',
       '',
       'CHR.FILCHR(+) = CCC.CODFIL AND CHR.SEQCHR(+) = CCC.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30516,
       'REC ',
       'CCC ',
       '1',
       'N',
       '',
       '',
       'REC.CODFIL(+) = CCC.CODVEN AND
REC.SEQUEN(+) = CCC.SEQVEN AND
REC.NUMPAR(+) = CCC.NUMPAR AND
REC.SUBPAR(+) = CCC.SUBPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30517,
       'VEI ',
       'CCC ',
       '1',
       'N',
       '',
       '',
       'VEI.PLACAS(+) = CCC.PLACAS',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30518,
       'VEN ',
       'CCC ',
       '1',
       '0N',
       '',
       '',
       'CCC.FILFAT(+) = VEN.CODFIL AND
CCC.SEQFAT(+) = VEN.SEQUEN ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30519,
       'RAT ',
       'CCC ',
       '1',
       '0N',
       '',
       '',
       'CCC.FILRAT(+) = RAT.CODFIL AND
CCC.SEQRAT(+) = RAT.SEQUEN ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30520,
       'DOP ',
       'CCC ',
       '0N',
       '1',
       '',
       '',
       'DOP.CODFIL(+) = CCC.FILDOP AND
DOP.SEQUEN(+) = CCC.SEQDOP',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30521,
       'RECP',
       'CCC ',
       '1',
       'N',
       '',
       '',
       'RECP.CODFIL(+) = CCC.CODVEN AND
RECP.SEQUEN(+) = CCC.SEQVEN AND
RECP.NUMPAR(+) = CCC.NUMPAR AND
RECP.SUBPAR(+) = CCC.SUBPAR',
       '',
       '' FROM DUAL
);

/*-- SEQ 6802 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'CCC ',
       '99',
       620,
       1,
       'ATULIM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Atualiza limite',
       'Atualiza limite de saldo',
       '',
       'ATULIM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       130,
       12,
       'CCCVENCOMBUSTIVEL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Combustvel~Venda',
       'Combustvel Venda',
       '',
       '(COMBUSTIVEIS(CCC.CODVEN, CCC.SEQVEN))',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '--',
       590,
       1,
       'CHKFAT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Faturar?',
       'Faturar?',
       '',
       'CHKFAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       640,
       44,
       'CODBAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo de barras',
       'Cdigo de barras do vale gerado',
       '',
       'CODBAR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '1 ',
       4,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo~Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       140,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Diviso',
       'Diviso do produto',
       'DIV.CODITE (+) = CCC.CODCOR',
       'CODCOR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '1 ',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Filial',
       'CCC.CODFIL = DFIL.CODFIL',
       'CODFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       650,
       44,
       'CODMAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd. barras manual',
       'Cdigo de barras manual indicado pelo cliente',
       '',
       'CODMAN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       150,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo~Produto',
       'Cdigo interno do produto',
       '',
       'CODMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       160,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'SUB.CODITE (+) = CCC.CODTAM',
       'CODTAM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '1 ',
       8,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Usurio',
       'Codigo usuario',
       'CCC.FILUSU = USU2.FILUSU(+) AND CCC.CODUSU = USU2.CODUSU(+)',
       'CODUSU',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '1 ',
       19,
       3,
       'CODVEN',
       'A',
       'VDD ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'VDD.APEUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial~Venda',
       'Filial da Venda',
       'CCC.FILVEN = VDD.FILUSU (+)  AND CCC.CODVEN = VDD.CODUSU (+)',
       'CODVEN',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       29,
       100,
       'COMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Complemento',
       'Complemento',
       '',
       'COMPLE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '--',
       490,
       15,
       'CONTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Contrato',
       'Nmero do Contrato',
       '',
       'CONTRA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       572,
       12,
       'CRECCC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Credito',
       'Lanamento de Credito ',
       '',
       '(CASE WHEN CCC.VLRLAN<0 THEN 0 ELSE CCC.VLRLAN END)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '1 ',
       200,
       7,
       'DATFIS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Fiscal',
       'Data Fiscal',
       '',
       'DATFIS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '--',
       630,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       5,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Operao',
       'Data operacao',
       '',
       'DATOPE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       573,
       12,
       'DEBCCC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Debito',
       'Lanamento de Debito',
       '',
       '(CASE WHEN CCC.VLRLAN>0 THEN 0 ELSE CCC.VLRLAN END)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '--',
       390,
       1,
       'DUMMY',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DUMMY',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '--',
       400,
       1,
       'EXPORT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exportar?',
       'Exportar?',
       '',
       'EXPORT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '--',
       410,
       3,
       'FILCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILCCC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '--',
       420,
       3,
       'FILCHR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial do Cheque',
       'Filial do Cheque',
       '',
       'FILCHR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '1 ',
       3,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial~Cliente',
       'Filial Cliente',
       '',
       'FILCLI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       310,
       3,
       'FILDOP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Documento',
       'Filial Documento Pagamento',
       '',
       'FILDOP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '1 ',
       39,
       3,
       'FILFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial~Fatura',
       'Filial Faturamento',
       '',
       'FILFAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       170,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial~Produto',
       'Filial onde foi cadastrado o material',
       '',
       'FILMAT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '--',
       500,
       3,
       'FILPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILPED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       570,
       3,
       'FILRAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial da RAT',
       'Filial da RAT',
       '',
       'FILRAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '1 ',
       7,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial~Usurio',
       'Filial Usuario',
       '',
       'FILUSU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '1 ',
       610,
       3,
       'FILWOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Filial WorkFlow',
       'Filial WorkFlow',
       '',
       'FILWOR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '--',
       510,
       5,
       'ITEPED',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ITEPED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '1 ',
       6,
       8,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Numero Documento',
       '',
       'NUMDOC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       129,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero ECF',
       'Nmero ECF',
       '',
       'NUMECF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       49,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero Parcela',
       'Nmero da Parcela',
       '',
       'NUMPAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '--',
       520,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NUMPED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       621,
       20,
       'NUMVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nmero Nota Origem',
       'Retorna Nmero Venda Origem',
       '',
       'RETORNA_NUMNOT_CCC(CCC.CODVEN,CCC.SEQVEN)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '1 ',
       250,
       1,
       'OLDSTT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status~antes Fatura',
       'Salva Status Antes de Faturar',
       '',
       'OLDSTT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '1 ',
       220,
       4000,
       'OPERACAOCAIXA',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Operao Caixa',
       'Operao Caixa',
       '',
       'RTF2TXT(RTRIM(SUBSTR(OPERACAOCAIXA(''CCC'',CCC.CODFIL,CCC.SEQUEN,NULL,NULL),1,50)))',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       59,
       7,
       'PLACAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Placas',
       'Placas',
       '',
       'PLACAS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '--',
       530,
       5,
       'PORORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Portador origem',
       'Portador origem',
       '',
       'PORORI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       180,
       12,
       'QTDLAN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde~Lanamento',
       'Quantidade Lanmento',
       '',
       'QTDLAN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       571,
       12,
       'SALCCC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Saldo',
       'Saldo Conta Corrente',
       '',
       'SaldoContaCorrente(CCC.DATOPE, CCC.FILCLI, CCC.CODCLI, CCC.TIPCCC)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '--',
       470,
       10,
       'SEQCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQCCC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '--',
       480,
       10,
       'SEQCHR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Cheque',
       'Cdigo Cheque',
       '',
       'SEQCHR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       370,
       10,
       'SEQDOP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Documento',
       'Cdigo Documento de Pagamento',
       '',
       'SEQDOP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       69,
       10,
       'SEQFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq.~Fatura',
       'Sequenciador Faturamento',
       '',
       'SEQFAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       580,
       10,
       'SEQRAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador da RAT',
       'Sequenciador da RAT',
       '',
       'SEQRAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '1 ',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       190,
       10,
       'SEQVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq.~Venda',
       'Seq. Venda',
       '',
       'SEQVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '1 ',
       600,
       10,
       'SEQWOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Sequen. WorkFlow',
       'Sequen. WorkFlow',
       '',
       'SEQWOR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '1 ',
       89,
       1,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'STATUS',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '1 ',
       99,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '1 ',
       109,
       5,
       'TIPCCC',
       'S',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       'A',
       'F',
       'Tipo C/C',
       'Tipo C/C',
       'DCCC.CODTAB = CCC.TIPCCC',
       'TIPCCC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '1 ',
       260,
       1,
       'TIPLAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de lanamento',
       'Tipo de lanamento',
       '',
       'TIPLAN',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '--',
       540,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPPED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '--',
       550,
       1,
       'TIPREL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Rel.',
       'Tipo Rel.',
       '',
       'TIPREL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '99',
       9,
       12,
       'VLRLAN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor de~Lanamento',
       'Valor lancamento',
       '',
       'VLRLAN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CCC ',
       '--',
       560,
       12,
       'VLRORI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor origem',
       'Valor origem',
       '',
       'VLRORI',
       'F',
       'D' FROM DUAL
);

/*-- SEQ 6803 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CCC ',
       'STATUS',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'STATUS',
       0,
       'F',
       'Faturamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'STATUS',
       0,
       'P',
       'Pagamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'STATUS',
       0,
       'S',
       'Suspensos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       '0',
       'Integrao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       '1',
       'Crdito Bonificao Futura',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       '2',
       'Dbito Bonificao Futura',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       '3',
       'Estorno Bonificao Futura',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'A',
       'Contrato',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'B',
       'Troco no recebimento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'C',
       'Recebimento de C/C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'D',
       'Depsito na C/C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'E',
       'Estorno de C/C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'F',
       'Dbito para o fornecedor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'G',
       'Fatura cliente global',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'H',
       'Recebimento de Cheque',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'I',
       'Retirada de C/C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'J',
       'Credita comisso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'K',
       'Vale compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'L',
       'Devoluo de venda em C/C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'M',
       'Receb. de C/C com o meio C/C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'N',
       'Estorno de C/C no cancelamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'O',
       'Faturamento referente a OS',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'P',
       'Gera C/C carto prprio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'Q',
       'Estorno de faturamento de C/C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'R',
       'Recebimento de REC',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'S',
       'Desconto no recebimento de C/C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'T',
       'Troco na venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'U',
       'Estorno parc. contra lanc. C/C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'V',
       'Venda com C/C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'W',
       'Conciliao banc./Gerar cred.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'X',
       'Exporta CCC',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCC ',
       'TIPLAN',
       0,
       'Z',
       'Lanamento extrato',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6804 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CCE ',
       TO_NUMBER(null),
       'CCE ',
       'Cx Correio Eletronic',
       'TT_CCE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CCE.E_MAIL',
       '' FROM DUAL
);

/*-- SEQ 6805 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CCE ','--','' FROM DUAL
UNION ALL
SELECT 'CCE ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CCE ','99','Outros' FROM DUAL
);

/*-- SEQ 6806 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5398,
       'CLI ',
       'CCE ',
       '01',
       '0N',
       '',
       '',
       'CLI.FILCLI(+) = CCE.FILCLI AND
CLI.CODCLI(+) = CCE.CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 5399,
       'USU ',
       'CCE ',
       '1 ',
       '0N',
       '',
       '',
       'usu.filusu = cce.filusu and
usu.codusu = cce.codusu',
       '' FROM DUAL
);

/*-- SEQ 6807 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CCE ',
       '--',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Codigo do Cliente',
       'Codigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'CCE ',
       '--',
       90,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Usuario',
       'Codigo do Usuario',
       'USU.FILUSU(+) = CCE.FILUSU AND USU.CODUSU(+) = CCE.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'CCE ',
       '--',
       20,
       255,
       'E_MAIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Email',
       'Email',
       '',
       'E_MAIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CCE ',
       '--',
       30,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Cliente Associado',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'CCE ',
       '--',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'CCE ',
       '--',
       40,
       255,
       'HOSTID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'S',
       '',
       '',
       'A',
       'F',
       'Servidor POP',
       'Servidor POP',
       '',
       'HOSTID',
       'F' FROM DUAL
UNION ALL
SELECT 'CCE ',
       '--',
       50,
       255,
       'NOMCCE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome da Conta',
       'Nome da Conta',
       '',
       'NOMCCE',
       'F' FROM DUAL
UNION ALL
SELECT 'CCE ',
       '--',
       60,
       5,
       'PRTPOP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Porta',
       'Porta POP',
       '',
       'PRTPOP',
       'F' FROM DUAL
UNION ALL
SELECT 'CCE ',
       '--',
       70,
       255,
       'SNHPOP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Senha',
       'Senha POP',
       '',
       'SNHPOP',
       'F' FROM DUAL
UNION ALL
SELECT 'CCE ',
       '--',
       80,
       255,
       'USERID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'User ID',
       'Usuario',
       '',
       'USERID',
       'F' FROM DUAL
);

/*-- SEQ 6808 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CCRE',
       TO_NUMBER(null),
       'CCRE',
       'Conta Crdito',
       'TT_CTA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'CCRE.CODFIL,CCRE.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6809 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CCRE','--','' FROM DUAL
);

/*-- SEQ 6810 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 66628,
       'VEN ',
       'CCRE',
       '1 ',
       '0N',
       '',
       '',
       'VEN.FILCTA = CCRE.CODFIL AND VEN.SEQCTA = CCRE.SEQUEN AND VEN.TIPCTA = CCRE.TIPCTA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 66629,
       'REC ',
       'CCRE',
       '1 ',
       '0N',
       '',
       '',
       'REC.FILCTA = CCRE.CODFIL AND REC.SEQCTA = CCRE.SEQUEN AND REC.TIPCTA = CCRE.TIPCTA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 65835,
       'COM ',
       'CCRE',
       '1 ',
       '0N',
       '',
       '',
       'COM.FILCTA = CCRE.CODFIL AND
COM.SEQCTA = CCRE.SEQUEN AND
COM.TIPCTA = CCRE.TIPCTA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 65836,
       'CTB ',
       'CCRE',
       '1 ',
       '0N',
       '',
       '',
       'CTB.FILCTA = CCRE.CODFIL AND
CTB.SEQCTA = CCRE.SEQUEN AND
CTB.TIPCTA = CCRE.TIPCTA AND
CTB.CTACTB = CCRE.USOCTA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 65837,
       'CXC ',
       'CCRE',
       '1 ',
       '0N',
       '',
       '',
       'CXC.FILCTA = CCRE.CODFIL AND
CXC.SEQCTA = CCRE.SEQUEN
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 65838,
       'DOP ',
       'CCRE',
       '1 ',
       '0N',
       '',
       '',
       'DOP.FILCTA = CCRE.CODFIL AND
DOP.SEQCTA = CCRE.SEQUEN AND
DOP.TIPCTA = CCRE.TIPCTA
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 65839,
       'ECT ',
       'CCRE',
       '1 ',
       '0N',
       '',
       '',
       'ECT.CODFIL = CCRE.FILECT(+) AND
ECT.SEQUEN = CCRE.SEQECT(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 65842,
       'VER ',
       'CCRE',
       '1 ',
       '0N',
       '',
       '',
       'VER.FILCTA = CCRE.CODFIL AND
VER.SEQCTA = CCRE.SEQUEN
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45913,
       'RECP',
       'CCRE',
       '1',
       '0N',
       '',
       '',
       'RECP.FILCTA = CCRE.CODFIL AND RECP.SEQCTA = CCRE.SEQUEN AND RECP.TIPCTA = CCRE.TIPCTA',
       '',
       '' FROM DUAL
);

/*-- SEQ 6811 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CCRE',
       '--',
       38,
       1,
       'APLNUM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Aplicabilidade Conta',
       'Aplicabilidade da conta ',
       '',
       'APLNUM',
       'F' FROM DUAL
UNION ALL
SELECT 'CCRE',
       '--',
       18,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Codigo Externo',
       'Codigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'CCRE',
       '--',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = CCRE.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CCRE',
       '--',
       6,
       3,
       'FILECT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Estrutura de Contas',
       '',
       'FILECT',
       'F' FROM DUAL
UNION ALL
SELECT 'CCRE',
       '--',
       58,
       1,
       'NIVCRI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Nvel de Criticidade',
       'Nvel de Criticidade',
       '',
       'NIVCRI',
       'F' FROM DUAL
UNION ALL
SELECT 'CCRE',
       '--',
       4,
       250,
       'PREFIX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Prefixo',
       'Prefixo',
       '',
       'PREFIX',
       'F' FROM DUAL
UNION ALL
SELECT 'CCRE',
       '--',
       7,
       10,
       'SEQECT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Chave Estrutura de Contas',
       '',
       'SEQECT',
       'F' FROM DUAL
UNION ALL
SELECT 'CCRE',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CCRE',
       '--',
       8,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'CCRE',
       '--',
       3,
       250,
       'TITCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Conta',
       'Conta',
       '',
       'TITCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'CCRE',
       '--',
       5,
       10,
       'ULTDOC',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'ltimo Documento',
       'ltimo Documento',
       '',
       'ULTDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'CCRE',
       '--',
       28,
       1,
       'USOCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Uso da Conta',
       'Uso da Conta',
       '',
       'USOCTA',
       'F' FROM DUAL
);

/*-- SEQ 6812 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CCRE',
       'APLNUM',
       0,
       'A',
       'Aplicaes',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCRE',
       'APLNUM',
       0,
       'B',
       'Banco',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCRE',
       'APLNUM',
       0,
       'C',
       'Caixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCRE',
       'APLNUM',
       0,
       'D',
       'Diferena',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCRE',
       'APLNUM',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCRE',
       'APLNUM',
       0,
       'N',
       'No Definido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCRE',
       'NIVCRI',
       0,
       ' ',
       'Baixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCRE',
       'NIVCRI',
       1,
       ' ',
       'Mdia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCRE',
       'NIVCRI',
       2,
       ' ',
       'Alta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCRE',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCRE',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCRE',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCRE',
       'USOCTA',
       0,
       'B',
       'Bancos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCRE',
       'USOCTA',
       0,
       'C',
       'Cartes de Crdito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCRE',
       'USOCTA',
       0,
       'E',
       'ECFs',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCRE',
       'USOCTA',
       0,
       'L',
       'Limites C/C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCRE',
       'USOCTA',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCRE',
       'USOCTA',
       0,
       'P',
       'Portadores',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6813 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CCT ',
       TO_NUMBER(null),
       'CCT ',
       'Cobertura Contrato',
       'TT_CCT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 6814 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CCT ','--','' FROM DUAL
UNION ALL
SELECT 'CCT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CCT ','99','Outros' FROM DUAL
);

/*-- SEQ 6815 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 36527,
       'GRA ',
       'CCT ',
       '1 ',
       'N ',
       '',
       '',
       'GRA.FILMAT(+) = CCT.FILMAT AND
GRA.CODMAT(+) = CCT.CODMAT AND
GRA.CODCOR(+) = CCT.CODCOR AND
GRA.CODTAM(+) = CCT.CODTAM',
       '' FROM DUAL
);

/*-- SEQ 6816 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CCT ',
       '--',
       50,
       5,
       'CODCOR',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Diviso',
       'Diviso',
       '',
       'CODCOR',
       '' FROM DUAL
UNION ALL
SELECT 'CCT ',
       '--',
       40,
       5,
       'CODMAT',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Cdigo do Material',
       'Cdigo do Material',
       '',
       'CODMAT',
       '' FROM DUAL
UNION ALL
SELECT 'CCT ',
       '--',
       60,
       5,
       'CODTAM',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Sub-Diviso',
       'Sub-Diviso',
       '',
       'CODTAM',
       '' FROM DUAL
UNION ALL
SELECT 'CCT ',
       '--',
       10,
       3,
       'FILCTT',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial da Cobertura',
       'Filial da Cobertura',
       'DFIL.CODFIL = CCT.FILCTT',
       'FILCTT',
       '' FROM DUAL
UNION ALL
SELECT 'CCT ',
       '--',
       30,
       3,
       'FILMAT',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial do Material',
       'Filial do Material',
       'DFIL.CODFIL = CCT.FILMAT',
       'FILMAT',
       '' FROM DUAL
UNION ALL
SELECT 'CCT ',
       '--',
       20,
       10,
       'SEQCTT',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Seq. da Cobertura',
       'Seq. da Cobertura',
       '',
       'SEQCTT',
       '' FROM DUAL
);

/*-- SEQ 6817 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CCX ',
       TO_NUMBER(null),
       'CCX ',
       'Controle Fechame ECF',
       'TT_CCX',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CCX.CODFIL, CCX.SEQUEN,
CCX.CODFIL, CCX.NUMECF, CCX.DATABE',
       '' FROM DUAL
);

/*-- SEQ 6818 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CCX ','--','' FROM DUAL
UNION ALL
SELECT 'CCX ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CCX ','99','Outros' FROM DUAL
);

/*-- SEQ 6819 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20259,
       'DECF',
       'CCX ',
       '1',
       '0N',
       '',
       '',
       'CCX.CODFIL = DECF.FILECF AND 
CCX.NUMECF = DECF.NUMECF',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20260,
       'USU ',
       'CCX ',
       '1',
       '0N',
       '',
       '',
       'CCX.FILUSU = USU.FILUSU AND 
CCX.CODUSU = USU.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 6820 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CCX ',
       '--',
       10,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'CCX ',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'CCX.CODFIL = DFIL.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CCX ',
       '--',
       30,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cod ltimo Usu Envol',
       'Cdigo ltimo Usurio Envolvido',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'CCX ',
       '--',
       40,
       8,
       'DATABE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Abertura Caixa ',
       'Data de Abertura do Caixa',
       '',
       'DATABE',
       'F' FROM DUAL
UNION ALL
SELECT 'CCX ',
       '--',
       50,
       8,
       'DATFEC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fechamen. Caixa',
       'Data de Fechamento do Caixa',
       '',
       'DATFEC',
       'F' FROM DUAL
UNION ALL
SELECT 'CCX ',
       '--',
       60,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'CCX ',
       '--',
       70,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Fil ltimo Usu Envol',
       'Filial ltimo Usurio Envolvido',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'CCX ',
       '--',
       80,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'CCX ',
       '--',
       90,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do ECF',
       'Nmero do ECF',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'CCX ',
       '--',
       100,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 6821 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CCX ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CCX ',
       'FLGEST',
       0,
       'F',
       'Fechado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6822 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CDEB',
       TO_NUMBER(null),
       'CDEB',
       'Conta Dbito',
       'TT_CTA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'CDEB.CODFIL,CDEB.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6823 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CDEB','--','' FROM DUAL
);

/*-- SEQ 6824 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 38074,
       'ECT ',
       'CDEB',
       '1 ',
       '0N',
       '',
       '',
       'ECT.CODFIL = CDEB.FILECT(+) AND
ECT.SEQUEN = CDEB.SEQECT(+)',
       '' FROM DUAL
);

/*-- SEQ 6825 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CDEB',
       '--',
       38,
       1,
       'APLNUM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Aplicabilidade Conta',
       'Aplicabilidade da conta ',
       '',
       'APLNUM',
       'F' FROM DUAL
UNION ALL
SELECT 'CDEB',
       '--',
       18,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Codigo Externo',
       'Codigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'CDEB',
       '--',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = CDEB.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CDEB',
       '--',
       6,
       3,
       'FILECT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Estrutura de Contas',
       '',
       'FILECT',
       'F' FROM DUAL
UNION ALL
SELECT 'CDEB',
       '--',
       58,
       1,
       'NIVCRI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Nvel de Criticidade',
       'Nvel de Criticidade',
       '',
       'NIVCRI',
       'F' FROM DUAL
UNION ALL
SELECT 'CDEB',
       '--',
       4,
       10,
       'PREFIX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Prefixo',
       'Prefixo',
       '',
       'PREFIX',
       'F' FROM DUAL
UNION ALL
SELECT 'CDEB',
       '--',
       7,
       10,
       'SEQECT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Chave Estrutura de Contas',
       '',
       'SEQECT',
       'F' FROM DUAL
UNION ALL
SELECT 'CDEB',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CDEB',
       '--',
       8,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'CDEB',
       '--',
       3,
       250,
       'TITCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Conta',
       'Ttulo da Conta',
       '',
       'TITCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'CDEB',
       '--',
       5,
       10,
       'ULTDOC',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'ltimo Documento',
       'ltimo Documento',
       '',
       'ULTDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'CDEB',
       '--',
       28,
       1,
       'USOCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Uso da Conta',
       'Uso da Conta',
       '',
       'USOCTA',
       'F' FROM DUAL
);

/*-- SEQ 6826 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CDEB',
       'APLNUM',
       0,
       'A',
       'Aplicaes',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CDEB',
       'APLNUM',
       0,
       'B',
       'Banco',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CDEB',
       'APLNUM',
       0,
       'C',
       'Caixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CDEB',
       'APLNUM',
       0,
       'D',
       'Diferena',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CDEB',
       'APLNUM',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CDEB',
       'APLNUM',
       0,
       'N',
       'No Definido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CDEB',
       'NIVCRI',
       0,
       ' ',
       'Baixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CDEB',
       'NIVCRI',
       1,
       ' ',
       'Mdia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CDEB',
       'NIVCRI',
       2,
       ' ',
       'Alta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CDEB',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CDEB',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CDEB',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CDEB',
       'USOCTA',
       0,
       'B',
       'Bancos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CDEB',
       'USOCTA',
       0,
       'C',
       'Cartes de Crdito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CDEB',
       'USOCTA',
       0,
       'E',
       'ECFs',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CDEB',
       'USOCTA',
       0,
       'L',
       'Limites C/C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CDEB',
       'USOCTA',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CDEB',
       'USOCTA',
       0,
       'P',
       'Portadores',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6827 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CEE ',
       TO_NUMBER(null),
       'CEE ',
       'C. Eletrnica NFE',
       'TT_CEE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CEE.CODFIL, CEE.SEQUEN
VEN.ID, CEE.SEQUEN
',
       '' FROM DUAL
);

/*-- SEQ 6828 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CEE ','--','' FROM DUAL
UNION ALL
SELECT 'CEE ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CEE ','99','Outros' FROM DUAL
);

/*-- SEQ 6829 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 42496,
       'VEN ',
       'CEE ',
       '1',
       'N',
       '',
       '',
       'VEN.CODFIL = CEE.FILVEN AND
VEN.SEQUEN = CEE.SEQVEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 6830 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CEE ',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Cdigo filial',
       'Cdigo da filial',
       'DFIL.CODFIL(+) = CEE.CODFIL',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'CEE ',
       '--',
       20,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data incluso',
       'Data de incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'CEE ',
       '--',
       30,
       7,
       'DATREG',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data registro',
       'Data de registro',
       '',
       'DATREG',
       'F' FROM DUAL
UNION ALL
SELECT 'CEE ',
       '--',
       40,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Filial da venda',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CEE ',
       '--',
       50,
       1,
       'INDEMI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Ind. destinatrio',
       'Identificador de Destinatrio',
       '',
       'INDEMI',
       'T' FROM DUAL
UNION ALL
SELECT 'CEE ',
       '--',
       60,
       15,
       'PROTOC',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Num Protocolo SEFAZ',
       'Nmero do protocolo emitido pela SEFAZ',
       '',
       'PROTOC',
       'F' FROM DUAL
UNION ALL
SELECT 'CEE ',
       '--',
       70,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CEE ',
       '--',
       80,
       10,
       'SEQVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Sequenciador de Venda',
       '',
       'SEQVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CEE ',
       '--',
       90,
       1000,
       'TEXTOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Texto Ocorrencia',
       'Texto Ocorrncia',
       '',
       'TEXTOC',
       'F' FROM DUAL
);

/*-- SEQ 6831 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CEE ',
       'INDEMI',
       0,
       'R',
       'Receita Federal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CEE ',
       'INDEMI',
       0,
       'S',
       'SEFAZ',
       TO_NUMBER(null),
       ' ' FROM DUAL
);
/*-- SEQ 6832 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CEIC',
       TO_NUMBER(null),
       'CEIC',
       'Crdito/Estorno ICMS',
       'TV_CRE_EST_ICMS',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 6833 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CEIC','--','' FROM DUAL
UNION ALL
SELECT 'CEIC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CEIC','02','Venda' FROM DUAL
UNION ALL
SELECT 'CEIC','03','ltima Transferncia' FROM DUAL
UNION ALL
SELECT 'CEIC','04','ltima Compra' FROM DUAL
UNION ALL
SELECT 'CEIC','99','Outros' FROM DUAL
);

/*-- SEQ 6834 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 25857,
       'IPRF',
       'CEIC',
       '1',
       '1',
       '',
       '',
       'IPRF.FILMAT = CEIC.IVE_FILMAT and
IPRF.CODMAT = CEIC.IVE_CODMAT and
IPRF.CODCOR = CEIC.IVE_CODCOR and
IPRF.CODTAM = CEIC.IVE_CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 25856,
       'GRA ',
       'CEIC',
       '1',
       '0N',
       '',
       '',
       'GRA.FILMAT = CEIC.IVE_FILMAT(+) and
GRA.CODMAT = CEIC.IVE_CODMAT(+) and
GRA.CODCOR = CEIC.IVE_CODCOR(+) and
GRA.CODTAM = CEIC.IVE_CODTAM(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 6835 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CEIC',
       '03',
       10,
       30,
       'CHAVETRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Chave da ltima Entrada de Transferncia',
       '',
       'CHAVETRA',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       20,
       5,
       'IVE_CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       '',
       'N',
       'F',
       'Cor~Produto',
       'Codigo da cor (diviso)',
       'DIV.CODITE (+) = CEIC.IVE_CODCOR',
       'IVE_CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       540,
       3,
       'IVE_CODCST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'CST ICMS Venda',
       'CST ICMS',
       '',
       'IVE_CODCST',
       '' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       470,
       3,
       'IVE_CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       '',
       'Cdigo da filial do Item da Venda',
       'DFIL.CODFIL (+) = CEIC.IVE_CODFIL',
       'IVE_CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       30,
       5,
       'IVE_CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Cdigo~Produto',
       'Codigo do produto',
       '',
       'IVE_CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       40,
       5,
       'IVE_CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       '',
       'N',
       'F',
       'Tamanho~Produto',
       'Cdigo do tamanho (sub-diviso)',
       'SUB.CODITE (+) = CEIC.IVE_CODTAM',
       'IVE_CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       50,
       8,
       'IVE_DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data/Hora Venda',
       'Data/Hora Venda',
       '',
       'IVE_DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       60,
       3,
       'IVE_FILMAT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial~Produto',
       'Filial de incluso do produto',
       'DFIL.CODFIL (+) = CEIC.IVE_FILMAT',
       'IVE_FILMAT',
       'T' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       550,
       5,
       'IVE_ICMRED',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% ICMS Com Reduo',
       'Taxa de ICMS do Item da Venda com Reduo da base de ICMS',
       '',
       'IVE_ICMRED',
       '' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       70,
       1,
       'IVE_ICMTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Trib. Venda',
       'Tipo de tributao do produto da Venda',
       '',
       'IVE_ICMTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       80,
       12,
       'IVE_QTDMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtde Vendida',
       'Quantidade vendida',
       '',
       'IVE_QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       530,
       7,
       'IVE_REDITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Reduo ICMS Venda',
       'Taxa de Reduo da Base de ICMS do item da Venda',
       '',
       'IVE_REDITE',
       '' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       480,
       10,
       'IVE_SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador do Item da Venda',
       '',
       'IVE_SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       90,
       7,
       'IVE_TAX001',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '%ICMS ou %ISS Venda',
       'ICMS(Qdo Mat.)a TAXA002=IPI e ISS(Qdo Serv.) a TAXA002=IRRF e/ou COFINS',
       '',
       'IVE_TAX001',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       460,
       7,
       'IVE_TAX002',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '%IPI ou %IRRF Venda',
       'Aliquota ISS(A TAXA002 pode mudar conforme descrio da TAXA001',
       '',
       'IVE_TAX002',
       '' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       100,
       7,
       'IVE_TAXICM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Taxa de ICMS Venda',
       'Taxa de ICMS da Venda',
       '',
       'IVE_TAXICM',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       110,
       14,
       'IVE_VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Item Venda',
       'Valor total do item da Venda',
       '',
       'IVE_VLRMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '04',
       120,
       7,
       'PERICM_ULT_COM_ANT_TRA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'ICMS lt Com Transf.',
       'Taxa de ICMS da ltima Compra antes da Tranferncia',
       '',
       'PERICM_ULT_COM_ANT_TRA',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       130,
       14,
       'TRAIVE_BAS_ST_COM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vlr BC ICMS Ret Tra',
       'Valor da BC do ICMS Retido Anteriormente da Transferncia',
       '',
       'TRAIVE_BAS_ST_COM',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       140,
       12,
       'TRAIVE_QTDMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtde Transf.',
       'Quantida da Transferncia',
       '',
       'TRAIVE_QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       150,
       12,
       'TRAIVE_VLRICM_COM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'ICMS Prp Subst.Tra',
       'Valor do ICMS Prprio do Substituto cobrado em operao anterior Transf',
       '',
       'TRAIVE_VLRICM_COM',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       160,
       14,
       'TRAIVE_VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Item Transf.',
       'Valor total do item na Transferncia',
       '',
       'TRAIVE_VLRMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       170,
       14,
       'TRAIVE_VLR_ST_COM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vlr ICMS Ret Ant Tra',
       'Valor do ICMS Retido Anteriormente da Transferncia',
       '',
       'TRAIVE_VLR_ST_COM',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       180,
       44,
       'TRA_CHAVEA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave NF-e Transf.',
       'Chave de Acesso NF-e da Transferncia',
       '',
       'TRA_CHAVEA',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       190,
       6,
       'TRA_CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       '',
       'Cdigo do cliente da Transferncia',
       '',
       'TRA_CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       200,
       3,
       'TRA_CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Transf.',
       'Cdigo da filial da Transferncia',
       'DFIL.CODFIL (+) = CEIC.TRA_CODFIL',
       'TRA_CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       210,
       2,
       'TRA_CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie Transf.',
       'Cdigo da srie da Transferncia',
       '',
       'TRA_CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       220,
       7,
       'TRA_DATFIS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Fiscal Transf.',
       'Data Fiscal da Transferncia',
       '',
       'TRA_DATFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       230,
       7,
       'TRA_DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso Transf',
       'Data e hora da operao da Transferncia',
       '',
       'TRA_DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       240,
       3,
       'TRA_FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       '',
       'Filial onde foi cadastrado o cliente da Transferncia',
       'DFIL.CODFIL (+) = CEIC.TRA_FILCLI',
       'TRA_FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       250,
       2,
       'TRA_MODNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Modelo Fiscal Transf',
       'Modelo Fiscal da Transferncia',
       '',
       'TRA_MODNOT',
       'T' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       260,
       3,
       'TRA_NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'ECF Transf.',
       'Nmero do ECF da Transferncia',
       '',
       'TRA_NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       270,
       6,
       'TRA_NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero Transf.',
       'Nmero da nota da Transferncia',
       '',
       'TRA_NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       280,
       10,
       'TRA_SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Transferncia',
       '',
       'TRA_SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       290,
       12,
       'TRA_VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Lquido Transf',
       'Valor lquido da nota da Transferncia',
       '',
       'TRA_VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       300,
       12,
       'TRA_VLRNOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Itens Transf.',
       'Valor da nota da Transferncia',
       '',
       'TRA_VLRNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '01',
       490,
       4000,
       'ULTTRANF',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Chave + % ICMS Compra ltima Transferncia',
       '',
       'ULTTRANF',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       500,
       3,
       'ULTTRA_CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       '',
       'Cdigo da filial da Transferncia',
       'DFIL.CODFIL (+) = CEIC.ULTTRA_CODFIL',
       'ULTTRA_CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       510,
       5,
       'ULTTRA_NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Nmero do Item da Transferncia',
       '',
       'ULTTRA_NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       520,
       10,
       'ULTTRA_SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Transferncia',
       '',
       'ULTTRA_SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       310,
       44,
       'VEN_CHAVEA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave NF-e Venda',
       'Chave de Acesso NF-e da Venda',
       '',
       'VEN_CHAVEA',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       320,
       6,
       'VEN_CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Cliente Venda',
       'Cdigo do cliente da Venda',
       '',
       'VEN_CODCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       330,
       3,
       'VEN_CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Venda',
       'Cdigo da filial da Venda',
       'DFIL.CODFIL (+) = CEIC.VEN_CODFIL',
       'VEN_CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       340,
       2,
       'VEN_CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie Venda',
       'Cdigo da srie da Venda',
       '',
       'VEN_CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       350,
       7,
       'VEN_DATFIS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Fiscal Venda',
       'Data Fiscal da Venda',
       '',
       'VEN_DATFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       360,
       7,
       'VEN_DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso Venda',
       'Data e hora da operao da Venda',
       '',
       'VEN_DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       370,
       3,
       'VEN_FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Cliente Venda',
       'Filial onde foi cadastrado o cliente da Venda',
       'DFIL.CODFIL (+) = CEIC.VEN_FILCLI',
       'VEN_FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       380,
       2,
       'VEN_MODNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Modelo Fiscal Venda',
       'Modelo Fiscal da Venda',
       '',
       'VEN_MODNOT',
       'T' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       390,
       3,
       'VEN_NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'ECF Venda',
       'Nmero do ECF da Venda',
       '',
       'VEN_NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       400,
       6,
       'VEN_NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero Venda',
       'Nmero da nota da Venda',
       '',
       'VEN_NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       410,
       10,
       'VEN_SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Venda',
       '',
       'VEN_SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       420,
       12,
       'VEN_VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Lquido Venda',
       'Valor lquido da nota da Venda',
       '',
       'VEN_VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '02',
       430,
       12,
       'VEN_VLRNOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Itens Venda',
       'Valor da nota da Venda',
       '',
       'VEN_VLRNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       440,
       12,
       'VLRICM_CRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Crdito ICMS Transf.',
       'Valor do crdito de ICMS na nota de transferncia',
       '',
       'VLRICM_CRE',
       'F' FROM DUAL
UNION ALL
SELECT 'CEIC',
       '03',
       450,
       12,
       'VLRICM_EST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Estorno ICMS Transf.',
       'Estorno do crdito de ICMS na nota de transferncia',
       '',
       'VLRICM_EST',
       'F' FROM DUAL
);

/*-- SEQ 6836 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CEIC',
       'IVE_ICMTIP',
       0,
       '0',
       'Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CEIC',
       'IVE_ICMTIP',
       0,
       '1',
       'No tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CEIC',
       'IVE_ICMTIP',
       0,
       '2',
       'Isento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CEIC',
       'IVE_ICMTIP',
       0,
       '3',
       'Substitudo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CEIC',
       'IVE_ICMTIP',
       0,
       '4',
       'Isento no estado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6837 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CES ',
       TO_NUMBER(null),
       'CES ',
       'CEST',
       'TT_CES',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CES.CODCES',
       '' FROM DUAL
);

/*-- SEQ 6838 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CES ','--','' FROM DUAL
UNION ALL
SELECT 'CES ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CES ','99','Outros' FROM DUAL
);

/*-- SEQ 6839 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CES ',
       '01',
       30,
       1,
       'CESATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Ativo?',
       '',
       'CESATI',
       '' FROM DUAL
UNION ALL
SELECT 'CES ',
       '01',
       10,
       7,
       'CODCES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'CEST',
       'CEST',
       '',
       'CODCES',
       '' FROM DUAL
UNION ALL
SELECT 'CES ',
       '01',
       40,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data de Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'CES ',
       '01',
       20,
       4000,
       'DESCES',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio do CEST',
       'Descrio do CEST',
       '',
       'RTF2TXT(DESCES)',
       '' FROM DUAL
);

/*-- SEQ 6840 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CFC ',
       TO_NUMBER(null),
       'CFC ',
       'Contagem Fecha Caixa',
       'TT_CFC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CFC.CODFIl,CFC.SEQUEN,CFC.NUMITE',
       '' FROM DUAL
);

/*-- SEQ 6841 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CFC ','--','' FROM DUAL
UNION ALL
SELECT 'CFC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CFC ','02','Valores' FROM DUAL
UNION ALL
SELECT 'CFC ','99','Outros' FROM DUAL
);

/*-- SEQ 6842 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 48333,
       'RCAI',
       'CFC ',
       '1',
       'N',
       '',
       '',
       'CFC.CODFIL = RCAI.CODFIL AND
CFC.SEQUEN = RCAI.SEQUEN
',
       '',
       '' FROM DUAL
);

/*-- SEQ 6843 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CFC ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Fechamento Cx',
       'Filial do Fechamento de Caixa',
       'DFIL.CODFIL = CFC.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CFC ',
       '01',
       50,
       40,
       'DESMEI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio do Meio',
       'Descrio do Meio',
       '',
       'DESMEI',
       '' FROM DUAL
UNION ALL
SELECT 'CFC ',
       '01',
       30,
       5,
       'NUMITE',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Item da Contagem',
       'Item da Contagem',
       '',
       'NUMITE',
       '' FROM DUAL
UNION ALL
SELECT 'CFC ',
       '02',
       90,
       10,
       'QTDLAN',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Qtde Lanamentos',
       'Quantidade de Lanamentos',
       '',
       'QTDLAN',
       '' FROM DUAL
UNION ALL
SELECT 'CFC ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq. Fechamento Cx',
       'Sequenciador do Fechamento de Caixa',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'CFC ',
       '01',
       40,
       1,
       'TIPMEI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo do Meio',
       'Tipo do Meio',
       '',
       'TIPMEI',
       'T' FROM DUAL
UNION ALL
SELECT 'CFC ',
       '02',
       60,
       12,
       'VLRAPU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Apurado',
       'Valor Apurado',
       '',
       'VLRAPU',
       '' FROM DUAL
UNION ALL
SELECT 'CFC ',
       '02',
       70,
       12,
       'VLRCAN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Cancelado',
       'Valor Cancelado',
       '',
       'VLRCAN',
       '' FROM DUAL
UNION ALL
SELECT 'CFC ',
       '02',
       80,
       12,
       'VLRCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Contado',
       'Valor Contado',
       '',
       'VLRCON',
       '' FROM DUAL
);

/*-- SEQ 6844 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CFC ',
       'TIPMEI',
       0,
       '1',
       'Dbito via POS',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFC ',
       'TIPMEI',
       0,
       '2',
       'Crdito via POS',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFC ',
       'TIPMEI',
       0,
       '9',
       'Pendncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFC ',
       'TIPMEI',
       0,
       'B',
       'Boleto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFC ',
       'TIPMEI',
       0,
       'C',
       'Carto Crdito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFC ',
       'TIPMEI',
       0,
       'D',
       'Carto Dbito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFC ',
       'TIPMEI',
       0,
       'E',
       'Moeda Estrangeira',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFC ',
       'TIPMEI',
       0,
       'F',
       'Conta Corrente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFC ',
       'TIPMEI',
       0,
       'H',
       'Cheque',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFC ',
       'TIPMEI',
       0,
       'I',
       'Fidelidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFC ',
       'TIPMEI',
       0,
       'N',
       'Carteira/Carn',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFC ',
       'TIPMEI',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFC ',
       'TIPMEI',
       0,
       'P',
       'Vale Presente via TEF',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFC ',
       'TIPMEI',
       0,
       'Q',
       'Qualquer',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFC ',
       'TIPMEI',
       0,
       'R',
       'Moeda Corrente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFC ',
       'TIPMEI',
       0,
       'S',
       'Vale Presente Nativo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFC ',
       'TIPMEI',
       0,
       'T',
       'TEFs',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFC ',
       'TIPMEI',
       0,
       'V',
       'Vale Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6845 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CFG ',
       0,
       'CFG ',
       'Configurao Config',
       'TT_CFG',
       'T',
       '',
       'TOTALL',
       'Configurao do Ambiente',
       '',
       '',
       '',
       'Configura#o',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 6846 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CFG ','--','' FROM DUAL
UNION ALL
SELECT 'CFG ','01','Dados da Empresa' FROM DUAL
UNION ALL
SELECT 'CFG ','02','Vendas ao Consumidor' FROM DUAL
UNION ALL
SELECT 'CFG ','03','Compra' FROM DUAL
UNION ALL
SELECT 'CFG ','04','Datas Livres do Cliente' FROM DUAL
UNION ALL
SELECT 'CFG ','05','Nome da Moeda' FROM DUAL
UNION ALL
SELECT 'CFG ','06','Geral' FROM DUAL
UNION ALL
SELECT 'CFG ','10','Configurao de Autenticao (Uso Futuro)' FROM DUAL
UNION ALL
SELECT 'CFG ','11','Fatura' FROM DUAL
UNION ALL
SELECT 'CFG ','12','Classe ABC' FROM DUAL
UNION ALL
SELECT 'CFG ','13','Categorias' FROM DUAL
UNION ALL
SELECT 'CFG ','14','Classes' FROM DUAL
UNION ALL
SELECT 'CFG ','15','Vendas' FROM DUAL
UNION ALL
SELECT 'CFG ','16','Valores' FROM DUAL
UNION ALL
SELECT 'CFG ','17','Mensagem Promocional CF' FROM DUAL
UNION ALL
SELECT 'CFG ','18','Tipos de Parceiros' FROM DUAL
UNION ALL
SELECT 'CFG ','99','Outros' FROM DUAL
);

/*-- SEQ 6847 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20861,
       'USU ',
       'CFG ',
       'N',
       '1',
       '',
       '',
       'CFG.SAC_MAIL_FILUSU = USU.FILUSU AND
CFG.SAC_MAIL_CODUSU = USU.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20862,
       'CTA ',
       'CFG ',
       'N',
       '1',
       '',
       '',
       'CTA.CODFIL = CFG.FILCTA_TRN  AND
CTA.SEQUEN = CFG.SEQCTA_TRN  AND
CTA.TIPCTA = CFG.TIPCTA_TRN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20863,
       'DOUT',
       'CFG ',
       'N',
       '1',
       '',
       '',
       'DOUT.CODTAB = CFG.MEIO_ESTAC',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20864,
       'DVEI',
       'CFG ',
       'N',
       '1',
       '',
       '',
       'DVEI.CODTAB = CFG.VEI_ORC',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20865,
       'GRA ',
       'CFG ',
       'N',
       '1',
       '',
       '',
       'CFG.FILMAT_AUX = GRA.FILMAT AND
CFG.CODMAT_AUX = GRA.CODMAT AND
CFG.CODCOR_AUX = GRA.CODCOR AND
CFG.CODTAM_AUX = GRA.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20866,
       'DNAT',
       'CFG ',
       'N',
       '1',
       '',
       '',
       'DNAT.CODTAB = CFG.NAT_CONSIGNACAO ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20867,
       'TPR ',
       'CFG ',
       'N',
       '1',
       '',
       '',
       'TPR.CODFIL = CFG.FILPRE AND
TPR.CODPRE = CFG.CODPRE
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20868,
       'PAP ',
       'CFG ',
       'N',
       '1',
       '',
       '',
       'PAP.CODFIL = CFG.FIL_PAPEL_TODOS AND
PAP.SEQUEN = CFG.SEQ_PAPEL_TODOS
',
       '',
       '' FROM DUAL
);

/*-- SEQ 6848 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'CFG ',
       '01',
       2544,
       1,
       'ABATER_DESCONTO_NF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Abater Desconto NF?',
       'Abater Desconto NF?',
       '',
       'ABATER_DESCONTO_NF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '12',
       10,
       2,
       'ABCQA',
       'S',
       '',
       0,
       0,
       'CFG ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CFG',
       'F',
       '',
       'F',
       'Quantidade A',
       'Quantidade A',
       '',
       'ABCQA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '12',
       30,
       2,
       'ABCQB',
       'S',
       '',
       0,
       0,
       'CFG ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CFG',
       'F',
       '',
       'F',
       'Quantidade B',
       'Quantidade B',
       '',
       'ABCQB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '12',
       50,
       2,
       'ABCQC',
       'S',
       '',
       0,
       0,
       'CFG ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CFG',
       'F',
       '',
       'F',
       'Quantidade C',
       'Quantidade C',
       '',
       'ABCQC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '12',
       20,
       2,
       'ABCVA',
       'S',
       '',
       0,
       0,
       'CFG ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CFG',
       'F',
       '',
       'F',
       'Valor A',
       'Valor A',
       '',
       'ABCVA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '12',
       40,
       2,
       'ABCVB',
       'S',
       '',
       0,
       0,
       'CFG ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CFG',
       'F',
       '',
       'F',
       'Valor B',
       'Valor B',
       '',
       'ABCVB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '12',
       60,
       2,
       'ABCVC',
       'S',
       '',
       0,
       0,
       'CFG ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CFG',
       'F',
       '',
       'F',
       'Valor C',
       'Valor C',
       '',
       'ABCVC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       1854,
       1,
       'ACAO_DEVOLUCAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Ao da Devoluo',
       'Ao ao receber devoluo de mercadoria',
       '',
       'ACAO_DEVOLUCAO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3310,
       1,
       'AGRUPA_LCTOS_TE_CCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Agurpa Lctos CCC',
       'Agurpa Lctos CCC',
       '',
       'AGRUPA_LCTOS_TE_CCC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4070,
       1,
       'ALTERA_PRECO_ORC_SEPARADO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'F',
       'Per. Alt. Preo Ven.',
       'Permitir alterar preo de venda em oramento separado',
       '',
       'ALTERA_PRECO_ORC_SEPARADO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3790,
       1,
       'ARECEBER_PASSA_ECF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       '',
       'Vendas pelo ECF Fin.',
       'Vendas a prazo passam pelo ECF na viso financeira',
       '',
       'ARECEBER_PASSA_ECF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '03',
       20,
       2,
       'ARREDONDAC',
       'S',
       '',
       0,
       0,
       'CFG ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CFG',
       'F',
       '',
       'F',
       'Arredonda Parcelas',
       'Arredondamento das parcelas',
       '',
       'ARREDONDAC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5750,
       1,
       'ARREDONDAM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Arredonda mltiplo?',
       'Arredonda mltiplo?',
       '',
       'ARREDONDAM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2884,
       2,
       'ARREDONPAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Casas decimais Venda',
       'Casas Decimais para arredondamento no parcelamento de vendas',
       '',
       'ARREDONPAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3800,
       1,
       'ATUPED',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Atualizar custo ped.',
       'Atualizar custos pelo pedido',
       '',
       'ATUPED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '06',
       10,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'CFG ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CFG',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       110,
       20,
       'AU_AUTENT',
       'A',
       '',
       0,
       0,
       'CFG ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Ativa Autenticao',
       'Ativa autenticao',
       '',
       'AU_AUTENT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       120,
       20,
       'AU_DESAUT',
       'A',
       '',
       0,
       0,
       'CFG ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'DesativaAutenticao',
       'Desativa autenticao',
       '',
       'AU_DESAUT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       100,
       20,
       'AU_DESLIN',
       'A',
       '',
       0,
       0,
       'CFG ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Desativa linha Autom',
       'Desativa linha automtica',
       '',
       'AU_DESLIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       40,
       1,
       'AU_ENTREL',
       'A',
       '',
       0,
       0,
       'CFG ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Entrelao Impr.Comum',
       'Entrelao da Impr. Comum',
       '',
       'AU_ENTREL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       50,
       1,
       'AU_ENTRELC',
       'A',
       '',
       0,
       0,
       'CFG ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Nm. Autenticao',
       'Nmero de autenticao',
       '',
       'AU_ENTRELC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       90,
       20,
       'AU_HABLIN',
       'A',
       '',
       0,
       0,
       'CFG ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'T',
       'A',
       'F',
       'Ativa Linha Autom.',
       'Ativa linha automtica',
       '',
       'AU_HABLIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       10,
       8,
       'AU_IMPRESS',
       'A',
       '',
       0,
       0,
       'CFG ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Sada Padro Imp.Aut',
       'Sada padro da Impr. de Autenticao',
       '',
       'AU_IMPRESS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       60,
       50,
       'AU_IMPRIM',
       'A',
       '',
       0,
       0,
       'CFG ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Tam.Val.Autenticao',
       'Tamanho do Valor na autenticao',
       '',
       'AU_IMPRIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       30,
       30,
       'AU_INIC',
       'A',
       '',
       0,
       0,
       'CFG ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'EntrelaoImpr.Auten,',
       'Entrelao da Impr. de Autenticao',
       '',
       'AU_INIC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       130,
       20,
       'AU_LNFEED',
       'A',
       '',
       0,
       0,
       'CFG ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Seq. Caracteres',
       'Seqncia de caracteres para LINE FEED na impressora',
       '',
       'AU_LNFEED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       80,
       2,
       'AU_TAMVLR',
       'S',
       '',
       0,
       0,
       'CFG ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CFG',
       'F',
       '',
       'F',
       'Seq. Caract. Linha',
       'Seqncia de caracteres para a mundana de linha',
       '',
       'AU_TAMVLR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       70,
       2,
       'AU_VEZES',
       'S',
       '',
       0,
       0,
       'CFG ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CFG',
       'F',
       '',
       'F',
       'ContedoAutenticao',
       'Contedo da autenticao',
       '',
       'AU_VEZES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3420,
       1,
       'AVISA_ESTOQUE_NEG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Avisa Est Negativo',
       'Avisar Estoque Negativo?',
       '',
       'AVISA_ESTOQUE_NEG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5640,
       1,
       'BAIPED',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Baixa Automtica Ped',
       'Baixa Automtica em Pedidos de Compra',
       '',
       'BAIPED',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2584,
       1,
       'BASE_MARKUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Base Markup',
       'Base Markup',
       '',
       'BASE_MARKUP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       6070,
       1,
       'BLQ_CF_RETIRA_DEPOSITO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Blq CF Ret Depsito',
       'Bloqueia CF para Retira no Depsito',
       '',
       'BLQ_CF_RETIRA_DEPOSITO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5460,
       1,
       'BLQ_SEM_UID',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       '',
       'Bloqueia Alteraes sem Registro de Acesso na Trigger',
       '',
       'BLQ_SEM_UID',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '06',
       5470,
       1,
       'BOLETO_EMAIL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Env. Boleto E-mail?',
       'Enviar Boleto por E-mail?',
       '',
       'BOLETO_EMAIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3810,
       1,
       'BONUS_ONLINE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Bnus on-line',
       'Bnus on-line',
       '',
       'BONUS_ONLINE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5110,
       1,
       'BRU_APROVADA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Rec Bruta Pr-Aprov?',
       'Receita Bruta Pr-Aprovada?',
       '',
       'BRU_APROVADA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       54,
       4000,
       'CABPRE',
       '4',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cabealho Fatura',
       'Cabealho de fatura',
       '',
       'RTF2TXT(CABPRE)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '02',
       2314,
       1,
       'CANCELA_RESERVA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Cancela Reserva?',
       'Cancelamento Automtico de Reserva?',
       '',
       'CANCELA_RESERVA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '16',
       131,
       3,
       'CARENCIA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Carncia',
       'Carncia',
       '',
       'CARENCIA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '16',
       132,
       2,
       'CARENCIAMEDICAMENTO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Carncia Medicamento',
       'Carncia Medicamento',
       '',
       'CARENCIAMEDICAMENTO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '16',
       3940,
       3,
       'CARENCIA_RESTRI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Carncia rest. Receb',
       'Carncia para restrio de recebimentos',
       '',
       'CARENCIA_RESTRI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '13',
       10,
       15,
       'CATEG1',
       'A',
       '',
       0,
       0,
       'CFG ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Ttulo 1a. Categoria',
       'Nome da Categoria 1',
       '',
       'CATEG1',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '13',
       20,
       15,
       'CATEG2',
       'A',
       '',
       0,
       0,
       'CFG ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Ttulo 2a. Categoria',
       'Nome da Categoria 2',
       '',
       'CATEG2',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '13',
       30,
       15,
       'CATEG3',
       'A',
       '',
       0,
       0,
       'CFG ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Ttulo 3a. Categoria',
       'Nome da Categoria 3',
       '',
       'CATEG3',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4010,
       5,
       'CC_CARTAFRETE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Conta Corr. C. Frete',
       'Conta Corrente para Carta Frete',
       '',
       'CC_CARTAFRETE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       133,
       5,
       'CC_CHECKOUT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Conta Corr. Checkout',
       'Conta Corrente CheckOut',
       '',
       'CC_CHECKOUT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2504,
       5,
       'CC_CREDFORNECEDOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'C.C. Cred.Fornecedor',
       'C.C. Cred. Fornecedor',
       '',
       'CC_CREDFORNECEDOR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1864,
       5,
       'CC_DEVOLUCAO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'CC p/ Devoluo Mer.',
       'Conta corrente utilizada para devoluo de mercadoria',
       '',
       'CC_DEVOLUCAO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7860,
       5,
       'CC_DOACAOTROCO',
       'G',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       'N',
       '',
       'C/C para Doao',
       'C/C para Doao de Troco',
       'DCCC.CODTAB(+) = CFG.CC_DOACAOTROCO',
       'CC_DOACAOTROCO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7640,
       5,
       'CC_PENDENCIA',
       'G',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       'N',
       '',
       'C/C para pendncias',
       'Conta Corrente para pendncias',
       'DCCC.CODTAB(+) = CFG.CC_PENDENCIA',
       'CC_PENDENCIA',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7730,
       5,
       'CC_RESTSAV',
       'G',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       'N',
       '',
       'C/C Rest. Serv. Adic',
       'C/C Restituio de Servios Adicionais',
       'DCCC.CODTAB(+) = CFG.CC_RESTSAV',
       'CC_RESTSAV',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4280,
       5,
       'CC_VALE_PRESENTE',
       'S',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       '',
       'F',
       'C/C p/ Vale presente',
       'Conta Corrente para Vale Presentes',
       'DCCC.CODTAB(+) = CFG.CC_VALE_PRESENTE',
       'CC_VALE_PRESENTE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7880,
       5,
       'CC_VENDACONJUNTA',
       'G',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       'N',
       '',
       'C/C para V. Conjunta',
       'C/C para vendas conjuntas',
       'DCCC.CODTAB(+) = CFG.CC_VENDACONJUNTA',
       'CC_VENDACONJUNTA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1304,
       5,
       'CC_WORKFLOW',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'C.C. WorkFlow',
       'Conta Corrente Workflow',
       '',
       'CC_WORKFLOW',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4130,
       5,
       'CC_WOR_PROP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '',
       'F',
       'Conta Corrente para ',
       'Conta Corrente para propostas',
       '',
       'CC_WOR_PROP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '03',
       40,
       5,
       'CDCO',
       'A',
       '',
       0,
       0,
       'CFG ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CFG',
       'F',
       '9',
       'F',
       'Conta Padro Dbitos',
       'Conta padro de dbitos no Fluxo de Caixa',
       '',
       'CDCO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       6000,
       1,
       'CFCONTRIPJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'CF p/ Contribuite PJ',
       'Permitir venda em cupom fiscal para Contribuite Pessoa Jurdica',
       '',
       'CFCONTRIPJ',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       7370,
       14,
       'CFG_LIMITESANGRIACHEQUE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Limite valor cheque',
       'Limite de valores de cheque no caixa',
       '',
       'CFG_LIMITESANGRIACHEQUE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       7550,
       2,
       'CFG_PARCEIRO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Integ. Retaguarda',
       'Integrao com Retaguarda',
       '',
       'CFG_PARCEIRO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       7390,
       5,
       'CFG_REFORCOABERTURA',
       'F',
       'DCAI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCAI.CX_DES',
       'V',
       '',
       '',
       'N',
       '',
       'Reforo abertura',
       'Reforo abertura',
       'DCAI.CODTAB = CFG.CFG_REFORCOABERTURA',
       'CFG_REFORCOABERTURA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       7380,
       5,
       'CFG_SANGRIAFECHAMENTO',
       'F',
       'DCAI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCAI.CX_DES',
       'V',
       '',
       '',
       'N',
       '',
       'Sangria fechamento',
       'Sangria de fechamento',
       'DCAI.CODTAB = CFG.CFG_SANGRIAFECHAMENTO',
       'CFG_SANGRIAFECHAMENTO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7370,
       2,
       'CFG_TAMANHOMATRICULA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Tamanho matrcula',
       'Tamanho do cdigo de matrcula de funcionrios (somente os nmeros)',
       '',
       'CFG_TAMANHOMATRICULA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3510,
       5,
       'CFOPPERDAS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'CFOP perdas',
       'CFOP para nota de perdas',
       '',
       'CFOPPERDAS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3890,
       1,
       'CFOP_COM_ECF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exporta ECF no CFOP',
       'Exporta ECF no CFOP no MT Fiscal',
       '',
       'CFOP_COM_ECF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       1934,
       3,
       'CHECKOUT_RELMIN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Release Mnima',
       'Release Mnima',
       '',
       'CHECKOUT_RELMIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       1944,
       5,
       'CHECKOUT_VERMIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Verso Mnima',
       'Verso Mnima',
       '',
       'CHECKOUT_VERMIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       134,
       5,
       'CHEQUE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cheque',
       'Cheque',
       '',
       'CHEQUE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       78,
       10,
       'CHEQUEMINIMO',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cheque Mnimo',
       'Cheque Mnimo',
       '',
       'CHEQUEMINIMO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       135,
       5,
       'CHESTD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cheque Sit. Tipo Doc',
       'Cheque Situao Tipo de Documento',
       '',
       'CHESTD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       136,
       1,
       'CHETRO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Cheque Troco?',
       'Cheque Troco',
       '',
       'CHETRO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3430,
       1,
       'CHRDEV_CRIA_SUBPAR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Cria sub parcela?',
       'Cria sub parcela?',
       '',
       'CHRDEV_CRIA_SUBPAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       174,
       1,
       'CICLOPRE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Preo Cclica?',
       'Usa tabela de preos cclica',
       '',
       'CICLOPRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7310,
       1,
       'CK4G_DETVER_HOMOL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Det Verso Homol CK4',
       'Detalhe da Verso para Homologao do Checkout 4G',
       '',
       'CK4G_DETVER_HOMOL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7340,
       1,
       'CK4G_DETVER_PRODU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Det Verso Prod CK4G',
       'Detalhe da Verso para Produo do Checkout 4G',
       '',
       'CK4G_DETVER_PRODU',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7360,
       1,
       'CK4G_REGRA_ATUALIZACAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Reg Atualiza CK4G',
       'Regra para Atualizao de Release do Checkout 4G',
       '',
       'CK4G_REGRA_ATUALIZACAO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7320,
       2,
       'CK4G_RELEAS_HOMOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Release Homol CK4G',
       'Release para Homologao do Checkout 4G',
       '',
       'CK4G_RELEAS_HOMOL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7350,
       2,
       'CK4G_RELEAS_PRODU',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Release Prod CK4G',
       'Release para Produo do Checkout 4G',
       '',
       'CK4G_RELEAS_PRODU',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7300,
       4,
       'CK4G_VERSAO_HOMOL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Verso Homol CK4G',
       'Verso para Homologao do Checkout 4G',
       '',
       'CK4G_VERSAO_HOMOL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7330,
       4,
       'CK4G_VERSAO_PRODU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Verso Prod CK4G',
       'Verso para Produo do Checkout 4G',
       '',
       'CK4G_VERSAO_PRODU',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       184,
       255,
       'CKBEMVINDO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem Boas Vindas',
       'Mensagem de Boas Vindas',
       '',
       'CKBEMVINDO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4270,
       1,
       'CKBLOQREFBAS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Bloquear ref. basica',
       'Bloquear referncia bsica',
       '',
       'CKBLOQREFBAS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2284,
       4000,
       'CKDESCECF',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio ECF',
       'Descrio ECF',
       '',
       'CKDESCECF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       194,
       4000,
       'CKFORCOMIT',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Frmula de Comisso ',
       'Frmula de Comisso de cada Item',
       '',
       'CKFORCOMIT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       204,
       4000,
       'CKFORCOMS1',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub-Frmula Comiss1',
       'Sub - Frmula Comisso 1',
       '',
       'CKFORCOMS1',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       214,
       4000,
       'CKFORCOMS2',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub-Frmula Comiss2',
       'Sub - Frmula Comisso 2',
       '',
       'CKFORCOMS2',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       224,
       4000,
       'CKFORCOMS3',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub-Frmula Comiss3',
       'Sub - Frmula Comisso 3',
       '',
       'CKFORCOMS3',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       234,
       4000,
       'CKFORCOMS4',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub-Frmula Comiss4',
       'Sub - Frmula Comisso 4',
       '',
       'CKFORCOMS4',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       244,
       4000,
       'CKFORCOMV1',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Frm. Itens Entrada',
       'Frmula aps os itens (ENTRADA) %',
       '',
       'CKFORCOMV1',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       254,
       4000,
       'CKFORCOMV2',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Frm. Itens Saldo F.',
       'Frmula aps os itens (SALDO FINANCIADO) %',
       '',
       'CKFORCOMV2',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2734,
       4000,
       'CKFORDES',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Fm. Desconto',
       'Fm. Desconto',
       '',
       'CKFORDES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       264,
       4000,
       'CKFTXTSUB1',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub - Frmula 1',
       'Sub - Frmula 1',
       '',
       'CKFTXTSUB1',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       274,
       4000,
       'CKFTXTSUB2',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub - Frmula 2',
       'Sub - Frmula 2',
       '',
       'CKFTXTSUB2',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       284,
       4000,
       'CKFTXTSUB3',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub - Frmula 3',
       'Sub - Frmula 3',
       '',
       'CKFTXTSUB3',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       294,
       4000,
       'CKFTXTSUB4',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub - Frmula 4',
       'Sub - Frmula 4',
       '',
       'CKFTXTSUB4',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5490,
       1,
       'CKGRADEPESAVEL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Grade Pesvel',
       'Permite Produto com Grade ser Pesvel',
       '',
       'CKGRADEPESAVEL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2744,
       1,
       'CKNEGATIVO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Validao de Estoque',
       'Regras para Validao de Estoque',
       '',
       'CKNEGATIVO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       304,
       255,
       'CKNOMATEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mens. Tela Descano',
       'Mensagem na Tela de Descano',
       '',
       'CKNOMATEND',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       314,
       1,
       'CKNUMEXTDP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'AceitaNm.Exter.Dup ',
       'Aceita Nmero Externo Duplicado',
       '',
       'CKNUMEXTDP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       324,
       1,
       'CKPAAGRUPA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Agrupa Produtos?',
       'Agrupa Produto com Grade na Impresso de Nota Fiscal',
       '',
       'CKPAAGRUPA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5740,
       1,
       'CKPAAUT_DEV_FRETE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Autor. Devol. Frete?',
       'Solicita Aut. para Devolver Frete Aps Ter Sido Impressa a Remessa?',
       '',
       'CKPAAUT_DEV_FRETE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '06',
       5490,
       4000,
       'CKPACANHOTONFE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Frm. Canhoto NF-e',
       'Frmula de Canhoto para NF-e',
       '',
       'CKPACANHOTONFE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       344,
       1,
       'CKPACOML1',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Executa Sub-Frm. 1?',
       'Executa Sub - Frmula  1 a cada Item',
       '',
       'CKPACOML1',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       354,
       1,
       'CKPACOML2',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Executa Sub-Frm. 2?',
       'Executa Sub - Frmula  2 a cada Item',
       '',
       'CKPACOML2',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       364,
       1,
       'CKPACOML3',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Executa Sub-Frm. 3?',
       'Executa Sub - Frmula  3 a cada Item',
       '',
       'CKPACOML3',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       374,
       1,
       'CKPACOML4',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Executa Sub-Frm. 4?',
       'Executa Sub - Frmula  4 a cada Item',
       '',
       'CKPACOML4',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5730,
       1,
       'CKPACONFERE_DAV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Conf. DAV/Pr-Venda?',
       'Usa conferncia de DAV/Pr-Venda?',
       '',
       'CKPACONFERE_DAV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       384,
       1,
       'CKPACONSFI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Trata Consumidor F.?',
       'Trata todas as Vendas como Consumidor Final',
       '',
       'CKPACONSFI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       394,
       4000,
       'CKPADESCIT',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Frm. Desconto Item',
       'Frmula de Desconto de Item',
       '',
       'CKPADESCIT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       404,
       4000,
       'CKPADESCTO',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Frm. Desconto Total',
       'Frmula Desconto Total',
       '',
       'CKPADESCTO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       414,
       2,
       'CKPADIASAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias Atraso Cliente',
       'Dias de Atraso do Cliente',
       '',
       'CKPADIASAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       424,
       1,
       'CKPADIGCHE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Analisa Dgit Cheque',
       'Analisa Dgito do Cheque',
       '',
       'CKPADIGCHE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5670,
       1,
       'CKPAFILDAV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Resg DAV Filiais?',
       'Permite resgatar DAVs de outras filiais?',
       '',
       'CKPAFILDAV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       434,
       1,
       'CKPAMFIMPP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Imp.Promi.Cheque Pr',
       'Imprime Promissria para Cheque Pr - Datado',
       '',
       'CKPAMFIMPP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2394,
       4000,
       'CKPAMFL1',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha1  Mens.Prom.CF',
       'Linha 1 da mensagem promocional do cupom fiscal',
       '',
       'CKPAMFL1',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2404,
       4000,
       'CKPAMFL2',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha2  Mens.Prom.CF',
       'Linha 2 da mensagem promocional do cupom fiscal',
       '',
       'CKPAMFL2',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2414,
       4000,
       'CKPAMFL3',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha3  Mens.Prom.CF',
       'Linha 3 da mensagem promocional do cupom fiscal',
       '',
       'CKPAMFL3',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2424,
       4000,
       'CKPAMFL4',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha4  Mens.Prom.CF',
       'Linha 4 da mensagem promocional do cupom fiscal',
       '',
       'CKPAMFL4',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       454,
       1,
       'CKPANUMEXT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Aceita Lote',
       'Aceita Lote',
       '',
       'CKPANUMEXT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5080,
       1,
       'CKPANUMEXT_DEP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Acc. Dep Comp. Lote',
       'Aceita Informar Depsito como Complemento do Lote',
       '',
       'CKPANUMEXT_DEP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5090,
       1,
       'CKPANUMEXT_NAO_DAV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Res Lt P/ Ven s/ Dav',
       'Restringe Lote Para Vendas sem DAV',
       '',
       'CKPANUMEXT_NAO_DAV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       464,
       1,
       'CKPAOBRCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Obriga Informar Car.',
       'Obriga Informar Carto',
       '',
       'CKPAOBRCAR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       474,
       1,
       'CKPAOBRVEN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Obriga Informar Ven.',
       'Obriga Informar Vendedor',
       '',
       'CKPAOBRVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       484,
       1,
       'CKPAPAGIRR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Cliente Pagador IRRF',
       'Cliente  Fonte Pagadora de IRRF',
       '',
       'CKPAPAGIRR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3320,
       1,
       'CKPAPESQIDENT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CKPAPESQIDENT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       494,
       1,
       'CKPAPREDEC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Casas Dec. Preo Uni',
       'Casas Decimais do Preo Unitrio',
       '',
       'CKPAPREDEC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       504,
       1,
       'CKPAPREDOC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Preenche CPF/CNPJ ?',
       'Preenche CPF/CNPJ do Cliente',
       '',
       'CKPAPREDOC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       514,
       1,
       'CKPAQTDAUT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Qtde x Autenticao',
       'Quantidade de vezes que pede Autenticao',
       '',
       'CKPAQTDAUT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       524,
       1,
       'CKPAQTDDEC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Casas Dec. Qtde',
       'Casas Decimais da Quantidade',
       '',
       'CKPAQTDDEC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3330,
       1,
       'CKPARECFILIAL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CKPARECFILIAL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       534,
       255,
       'CKPASAICAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sada Fechame. Caixa',
       'Sada do Fechamento de Caixa',
       '',
       'CKPASAICAI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       544,
       255,
       'CKPASAICHE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sada do Cheque',
       'Sada do Cheque',
       '',
       'CKPASAICHE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       554,
       4000,
       'CKPATOTVEN',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Frm.Pontuao Venda',
       'Frmula de Pontuao Total de Venda',
       '',
       'CKPATOTVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       564,
       4000,
       'CKPATXTPRE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Frmula de Preo(Ao ',
       'Frmula de Preo(Ao vender)',
       '',
       'CKPATXTPRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       574,
       1,
       'CKPAUNICAI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'nico Caixa Aberto?',
       'nico Caixa Aberto',
       '',
       'CKPAUNICAI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5620,
       1,
       'CKPAVALABE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Valores Abre Caixa',
       'Informar Valores na Abertura do Caixa',
       '',
       'CKPAVALABE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       584,
       4000,
       'CKPAVENITE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Frm. Pontuao Ven.',
       'Frmula de Pontuao de venda para Itens',
       '',
       'CKPAVENITE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       594,
       1,
       'CKPAVLRAPR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Alt. Val.Apro.Cheque',
       'Altera o Valor a Apropriar do Cheque',
       '',
       'CKPAVLRAPR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       604,
       8,
       'CKPAVLRIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Cobrana IRRF',
       'Valor de Cobrana de IRRF',
       '',
       'CKPAVLRIRR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       614,
       1,
       'CKPRECOSUB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'PreoBase Subs.Tri. ',
       'Preo Base de Subs. Tributria',
       '',
       'CKPRECOSUB',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3340,
       1,
       'CKSANGRIANEGATIVA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sangria negativa',
       'Sangria negativa',
       '',
       'CKSANGRIANEGATIVA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3350,
       1,
       'CKTROCACHRADEPOSITAR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Troca Cach deposita?',
       'Troca Cach deposita?',
       '',
       'CKTROCACHRADEPOSITAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2894,
       4000,
       'CKTXTPROMISSORIA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Promissria',
       'Promissria',
       '',
       'CKTXTPROMISSORIA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       624,
       1,
       'CKUSABALAN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Balana?',
       'Usa Balana',
       '',
       'CKUSABALAN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       634,
       1,
       'CKUSADEBAP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Aprop. Recebim.?',
       'Usa Apropriao no Recebimento de Dbitos',
       '',
       'CKUSADEBAP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       644,
       1,
       'CKVLRINFUN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Valor Informado Uni.',
       'Informa se o Valor Informado  Unitrio',
       '',
       'CKVLRINFUN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3750,
       1,
       'CK_FECHA_VALOR_CONTADO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Fecha caixa vlr for',
       'Fecha caixa com valor contado',
       '',
       'CK_FECHA_VALOR_CONTADO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3740,
       5,
       'CL4WEB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Classe view de WEB',
       'Classe para view de integrao WEB',
       '',
       'CL4WEB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '14',
       10,
       15,
       'CLASS1',
       'A',
       '',
       0,
       0,
       'CFG ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Ttulo 1a. Classe',
       'Nome da Classe 1',
       '',
       'CLASS1',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '14',
       20,
       15,
       'CLASS2',
       'A',
       '',
       0,
       0,
       'CFG ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Ttulo 2a. Classe',
       'Nome da Classe 2',
       '',
       'CLASS2',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '14',
       30,
       15,
       'CLASS3',
       'A',
       '',
       0,
       0,
       'CFG ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Ttulo 3a. Classe',
       'Nome da Classe 3',
       '',
       'CLASS3',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '14',
       40,
       15,
       'CLASS4',
       'A',
       '',
       0,
       0,
       'CFG ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Ttulo 4a. Classe',
       'Nome da Classe 4',
       '',
       'CLASS4',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       59,
       1,
       'CLICODEXT',
       'L',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       70,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Obriga CdigoExterno',
       'Obriga cdigo externo para cliente (T/F)',
       '',
       'CLICODEXT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       1994,
       1,
       'CLIENTE_POR_DOC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Cliente por DOC?',
       'Cliente por DOC?',
       '',
       'CLIENTE_POR_DOC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       7170,
       1,
       'CLIREVSEMIE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Revenda sem Insc Est',
       'Permite cadastrar revenda sem Inscrio Estadual',
       '',
       'CLIREVSEMIE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2554,
       1,
       'CLI_BAIRRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Cliente Bairro?',
       'Cliente Bairro?',
       '',
       'CLI_BAIRRO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '02',
       2334,
       1,
       'CLI_CALL_C',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Aceita Rec. Contato?',
       'Aceita receber contato telefnico?',
       '',
       'CLI_CALL_C',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1314,
       1,
       'CLI_CATEG1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Categoria1 Cliente',
       'Categoria1 do Cliente',
       '',
       'CLI_CATEG1',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1324,
       15,
       'CLI_CATEG2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Categoria2 Cliente',
       'Categoria2 do Cliente',
       '',
       'CLI_CATEG2',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1334,
       1,
       'CLI_CATEG3',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Categoria3 Cliente',
       'Categoria3 do Cliente',
       '',
       'CLI_CATEG3',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1344,
       1,
       'CLI_CODCEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Cd. Cep Cliente',
       'Cdigo do Cep do Cliente',
       '',
       'CLI_CODCEP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1354,
       1,
       'CLI_CODSEX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Cd. Sexo Cliente',
       'Cdigo Sexo do Cliente',
       '',
       'CLI_CODSEX',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1364,
       1,
       'CLI_CONJUG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Nome do Cnjuge',
       'Nome do Cnjuge',
       '',
       'CLI_CONJUG',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3440,
       1,
       'CLI_CONTAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Contatos',
       'Contatos',
       '',
       'CLI_CONTAT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1374,
       1,
       'CLI_DATNAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Data Nas. Cnjuge',
       'Data de Nascimento do Cnjuge',
       '',
       'CLI_DATNAS',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1384,
       1,
       'CLI_DOCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Documento do Cnjuge',
       'Documento do Cnjuge',
       '',
       'CLI_DOCCON',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1394,
       1,
       'CLI_ENDERE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Endereo Cliente',
       'Endereo do Cliente',
       '',
       'CLI_ENDERE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1404,
       1,
       'CLI_ESTCIV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Estado Civil Cliente',
       'Estado Civil do Cliente',
       '',
       'CLI_ESTCIV',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1414,
       1,
       'CLI_INSEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Segundo Documento',
       'Segundo Documento',
       '',
       'CLI_INSEST',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1424,
       1,
       'CLI_NASCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Nascimento Cnjuge',
       'Nascimento do Cnjuge',
       '',
       'CLI_NASCON',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2564,
       1,
       'CLI_NOMCID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Cliente Nom. Cidade',
       'Cliente Nom. Cidade',
       '',
       'CLI_NOMCID',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1434,
       1,
       'CLI_NUMFON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Telefone',
       'Telefone',
       '',
       'CLI_NUMFON',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5930,
       12,
       'CLI_QTDBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Qtd. bnus cli.',
       'Quantidade de bnus por valor acumulado de venda do cliente',
       '',
       'CLI_QTDBON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2574,
       1,
       'CLI_REGIAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Cliente Regio',
       'Cliente Regio',
       '',
       'CLI_REGIAO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5940,
       12,
       'CLI_VLRVEN_BON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Vl. venda bnus cli.',
       'Valor acumulado de venda para clculo de bnus do cliente',
       '',
       'CLI_VLRVEN_BON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2194,
       6,
       'COB_COD_GERENTE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Gerente',
       'Cdigo Gerente',
       '',
       'COB_COD_GERENTE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2024,
       3,
       'COB_DIAS_CARTA1_CHR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias Carta1 Cheque',
       'Dias Carta1 Cheque ',
       '',
       'COB_DIAS_CARTA1_CHR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2034,
       3,
       'COB_DIAS_CARTA1_REC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias Carta1 Cheque R',
       'Dias Carta1 Cheque Receber ',
       '',
       'COB_DIAS_CARTA1_REC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2044,
       3,
       'COB_DIAS_CARTA2_CHR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias Carta2 Cheque ',
       'Dias Carta2 Cheque ',
       '',
       'COB_DIAS_CARTA2_CHR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2054,
       3,
       'COB_DIAS_CARTA2_REC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias Carta2 Cheque R',
       'Dias Carta2 Cheque Receber',
       '',
       'COB_DIAS_CARTA2_REC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2064,
       3,
       'COB_DIAS_DEVOLUCAO1',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias de Devoluo 1',
       'Dias de Devoluo 1',
       '',
       'COB_DIAS_DEVOLUCAO1',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2074,
       3,
       'COB_DIAS_DEVOLUCAO2',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias de Devoluo 2',
       'Dias de Devoluo 2',
       '',
       'COB_DIAS_DEVOLUCAO2',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2084,
       3,
       'COB_DIAS_SPC_CHR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias Cheque no SPC',
       'Dias Cheque no SPC',
       '',
       'COB_DIAS_SPC_CHR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2094,
       3,
       'COB_DIAS_SPC_REC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias SPC Rec.',
       'Dias SPC Rec.',
       '',
       'COB_DIAS_SPC_REC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2104,
       3,
       'COB_DIAS_VENCTO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias de Vencimentos',
       'Dias de Vencimentos',
       '',
       'COB_DIAS_VENCTO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2114,
       4000,
       'COB_E_MAIL_CARTAS',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail/Cartas',
       'E-mail/Cartas',
       '',
       'COB_E_MAIL_CARTAS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2124,
       4000,
       'COB_E_MAIL_SAC',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail/SAC',
       'E-mail/SAC',
       '',
       'COB_E_MAIL_SAC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2134,
       4000,
       'COB_E_MAIL_SPC',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail/SPC',
       'E-mail/SPC',
       '',
       'COB_E_MAIL_SPC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2204,
       3,
       'COB_FIL_GERENTE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cd. Filial Gerente',
       'Cd. Filial Gerente',
       '',
       'COB_FIL_GERENTE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2144,
       1,
       'COB_FORMA_REGISTRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Forma Registro',
       'Forma Registro',
       '',
       'COB_FORMA_REGISTRO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2154,
       5,
       'COB_MOD_CODCOR1',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Mod. Cdm Corresp. 1',
       'mod. Cdigo Correspondncia 1',
       '',
       'COB_MOD_CODCOR1',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2164,
       5,
       'COB_MOD_CODCOR2',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Mod. Cdm Corresp. 2',
       'mod. Cdigo Correspondncia 2',
       '',
       'COB_MOD_CODCOR2',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2174,
       3,
       'COB_OUTROS_PAGTOS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Outros Pagamentos',
       'Outros Pagamentos',
       '',
       'COB_OUTROS_PAGTOS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2184,
       1,
       'COB_USA_SAC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa SAC?',
       'Usa SAC?',
       '',
       'COB_USA_SAC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7270,
       5,
       'CODCOR_AUX',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Diviso Prod. Aux.',
       'Diviso do produto auxiliar para uso interno do sistema',
       '',
       'CODCOR_AUX',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7490,
       5,
       'CODCOR_RAT',
       'G',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       '',
       'N',
       '',
       'Diviso Produto RAT',
       'Diviso do Produto para faturamento de RAT',
       'DIV.CODITE = CFG.CODCOR_RAT(+)',
       'CODCOR_RAT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7000,
       5,
       'CODCOR_TIN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Cor Tinta',
       'Cor Tinta',
       '',
       'CODCOR_TIN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7780,
       5,
       'CODCOR_TRA',
       'G',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       '',
       'N',
       '',
       'Diviso prod. transf',
       'Diviso do produto para transferncia de saldo credor de ICMS',
       'DIV.CODITE(+) = CFG.CODCOR_TRA',
       'CODCOR_TRA',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2754,
       5,
       'CODEXP_COLETOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cd. Exp. Coletor',
       'Cdigo de exportao para Coletor',
       '',
       'CODEXP_COLETOR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7260,
       5,
       'CODMAT_AUX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Cdigo Prod. Aux.',
       'Cdigo do produto auxiliar para uso interno do sistema',
       '',
       'CODMAT_AUX',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7480,
       5,
       'CODMAT_RAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo Produto RAT',
       'Cdigo do Produto para faturamento de RAT',
       '',
       'CODMAT_RAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       6090,
       5,
       'CODMAT_TIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo Produto Tinta',
       'Cdigo Produto Tinta',
       '',
       'CODMAT_TIN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7770,
       5,
       'CODMAT_TRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo prod. transf',
       'Cdigo do produto para transferncia de saldo credor de ICMS',
       '',
       'CODMAT_TRA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       654,
       5,
       'CODNAT_REIMP_CF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Naturezap/Reimp. CF',
       'Natureza para reimpresso de CF',
       '',
       'CODNAT_REIMP_CF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4150,
       3,
       'CODPGT_WOR_PROP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Plano para propostas',
       'Plano para propostas acima do valor mnimo',
       '',
       'CODPGT_WOR_PROP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       57,
       5,
       'CODPRE',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo Tab. Preos',
       'Cdigo da tabela de preos para venda ao varejo',
       '',
       'CODPRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5840,
       5,
       'CODPRE_ATC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'N',
       'F',
       'Cd. Preo Atacado',
       'Cd. Preo Atacado',
       '',
       'CODPRE_ATC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5850,
       5,
       'CODPRE_REV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'N',
       'F',
       'Cd. Preo Revenda',
       'Cd. Preo Revenda',
       '',
       'CODPRE_REV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2704,
       5,
       'CODSRV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Servio',
       'Cdigo Servio',
       '',
       'CODSRV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4420,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODTAB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7280,
       5,
       'CODTAM_AUX',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Subdiviso Prod.Aux.',
       'Subdiviso do produto auxiliar para uso interno do sistema',
       '',
       'CODTAM_AUX',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7500,
       5,
       'CODTAM_RAT',
       'G',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       '',
       'N',
       '',
       'Subdiviso Prod RAT',
       'Subdiviso do Produto para faturamento de RAT',
       'SUB.CODITE = CFG.CODTAM_RAT(+)',
       'CODTAM_RAT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7010,
       5,
       'CODTAM_TIN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Tamanho Tinta',
       'Tamanho Tinta',
       '',
       'CODTAM_TIN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7790,
       5,
       'CODTAM_TRA',
       'G',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       '',
       'N',
       '',
       'Subdiv. prod. trans',
       'Subidiviso do produto para transferncia de saldo credor de ICMS',
       'SUB.CODITE(+) = CFG.CODTAM_TRA',
       'CODTAM_TRA',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4910,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Identificao de Acesso',
       '',
       'CODUID',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5820,
       6,
       'COD_BASF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo BASF',
       'Cdigo de Cadastro do Fornecedor BASF',
       '',
       'COD_BASF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3520,
       6,
       'COD_DIMED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo DIMED',
       'Cdigo de Cadastro do Fornecedor DIMED',
       '',
       'COD_DIMED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3530,
       6,
       'COD_DIMPER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo DIMPER',
       'Cdigo de Cadastro do Fornecedor DIMPER',
       '',
       'COD_DIMPER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       664,
       5,
       'COD_ECB_TIT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Espcie Padro',
       'Espcie Padro',
       '',
       'COD_ECB_TIT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3540,
       6,
       'COD_ESPECIAL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Especial',
       'Cdigo especial',
       '',
       'COD_ESPECIAL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3550,
       6,
       'COD_GENESIO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Gensio',
       'Cdigo de Cadastro do Fornecedor Genesio A. Mendes',
       '',
       'COD_GENESIO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3560,
       6,
       'COD_PANARELLO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Panarello',
       'Cdigo de Cadastro do Fornecedor Panarello',
       '',
       'COD_PANARELLO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3570,
       6,
       'COD_PROFARMA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo PROFARMA',
       'Cdigo de Cadastro do Fornecedor PROFARMA',
       '',
       'COD_PROFARMA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3580,
       6,
       'COD_SANTACRUZ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Santa Cruz',
       'Cdigo de Cadastro do Fornecedor Santa Cruz',
       '',
       'COD_SANTACRUZ',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '02',
       2344,
       1,
       'COMPENSACAO_AUTOMATICA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Compensao Aut.?',
       'Compensao Automtica?',
       '',
       'COMPENSACAO_AUTOMATICA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       137,
       5,
       'CONTATO_FINANCEIRO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Contato Financeiro',
       'Contato Financeiro',
       '',
       'CONTATO_FINANCEIRO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1444,
       1,
       'CREDIT_SCORE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Credt Score?',
       'Credit Score',
       '',
       'CREDIT_SCORE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4050,
       8,
       'CUSTOFINMENSAL',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Custo Financeiro Men',
       'Custo Financeiro Mensal',
       '',
       'CUSTOFINMENSAL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3960,
       12,
       'CUSTO_LIGACAO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Custo Ligaes Telef',
       'Custo para Ligaes Telefnicas (TEF)',
       '',
       'CUSTO_LIGACAO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4040,
       1,
       'CUSTO_LUCRO_MARKUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Custo',
       'Tipo de Custo para Lucro e Markup',
       '',
       'CUSTO_LUCRO_MARKUP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2904,
       1,
       'CUSTO_POR_FILIAL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Custo por filial?',
       'Custo por filial?',
       '',
       'CUSTO_POR_FILIAL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       2814,
       255,
       'DADOS_PATH_EXPORTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Caminho Destino Exp.',
       'Caminho destino de arquivos TXT com a base do Totali Commerce',
       '',
       'DADOS_PATH_EXPORTA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       2824,
       255,
       'DADOS_PATH_IMPORTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Caminho Origem Imp.',
       'Caminho origem de arquivos TXT com a base do Totali Commerce',
       '',
       'DADOS_PATH_IMPORTA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '04',
       10,
       15,
       'DATA1',
       'A',
       '',
       0,
       0,
       'CFG ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Descrio 1 Data',
       'Descrio da 1 data',
       '',
       'DATA1',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '04',
       20,
       15,
       'DATA2',
       'A',
       '',
       0,
       0,
       'CFG ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Descrio 2 Data',
       'Descrio da 2 data',
       '',
       'DATA2',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '04',
       30,
       15,
       'DATA3',
       'A',
       '',
       0,
       0,
       'CFG ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Descrio 3 Data',
       'Descrio da 3 data',
       '',
       'DATA3',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5890,
       7,
       'DATA_BONUS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'D',
       'F',
       'Data inicial bnus',
       'Data inicial do bnus',
       '',
       'DATA_BONUS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5330,
       7,
       'DATPAF',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATPAF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1454,
       2,
       'DAT_CHRDEP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cheques Dep.  Comp.',
       'Cheques Depositados e no compensados',
       '',
       'DAT_CHRDEP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1464,
       2,
       'DAT_CHRDES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cheque Pr  Descon.',
       'Cheques Pr-descontados e no compensados',
       '',
       'DAT_CHRDES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1474,
       2,
       'DAT_CHRDEV1',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cheques Dev. 1',
       'Cheques Devolvidos 1 vez e no compensados',
       '',
       'DAT_CHRDEV1',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1484,
       2,
       'DAT_CHRDEV2',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cheques Dev. 2',
       'Cheques Devolvidos 2 vezes e no cobrados',
       '',
       'DAT_CHRDEV2',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1494,
       2,
       'DAT_CHRPRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Chuques Pr a Depos.',
       'Chques Pr a Depositar',
       '',
       'DAT_CHRPRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1504,
       2,
       'DAT_RESERV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'OramentoAber.Reser.',
       'Considerar problema os oramentos em aberto e com reserva',
       '',
       'DAT_RESERV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1514,
       1,
       'DEDUZTAXATITULO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       '#Deduz Taxa de Ttul',
       'Deduz Taxa de Ttulo? (descontinuado)',
       '',
       'DEDUZTAXATITULO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       674,
       1,
       'DEPOSITA_CHETRO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Deposita ChequeTroco',
       'Deposita Cheque Troco',
       '',
       'DEPOSITA_CHETRO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7750,
       1,
       'DESCPMORD',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Desc. Promoo Order',
       'Permite Desconto em Promoo no Order',
       '',
       'DESCPMORD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4390,
       30,
       'DESPAP_DIRETORIA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESPAP_DIRETORIA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5200,
       1,
       'DEST_ST_DEV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Destacar ST em Dev.',
       'Destacar ST em Devoluo',
       '',
       'DEST_ST_DEV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7660,
       1,
       'DEST_ST_INFFISCO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Dest. ST Inf. Fisco',
       'Destacar ST nas Informaes Adicionais para o Fisco',
       '',
       'DEST_ST_INFFISCO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '05',
       20,
       30,
       'DESVEN',
       'A',
       '',
       0,
       0,
       'CFG ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Descrio da Venda',
       'Descrio da venda',
       '',
       'DESVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7190,
       1,
       'DEVCOMPRANFEIMPOSTO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Dev Comp Nfe Imposto',
       'Devoluo de Compra Imprimir Nfe de Imposto',
       '',
       'DEVCOMPRANFEIMPOSTO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7510,
       1,
       'DEVFIL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Dev. mesma filial?',
       'Devolve nota fiscal apenas na mesma filial?',
       '',
       'DEVFIL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4450,
       5,
       'DEVTRA_CFO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'CFOP  transferncia',
       'Cdigo CFOP para devoluo de transferncia (Entrada)',
       '',
       'DEVTRA_CFO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4440,
       5,
       'DEVTRA_NAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Nat.de transferncia',
       'Natureza para devoluo de transferncia (Sada)',
       '',
       'DEVTRA_NAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5550,
       1,
       'DEV_FATVIN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Devoluo Total Vinc',
       'Devoluo Total Vinculada',
       '',
       'DEV_FATVIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4080,
       3,
       'DIACRE_PREATEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '0',
       'F',
       'Dias Ct. Cr. Pr At.',
       'Dias do carto do crdito do pr-atendimento',
       '',
       'DIACRE_PREATEND',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4090,
       3,
       'DIADEB_PREATEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '0',
       'F',
       'Dias Ct. Db. Pr At',
       'Dias do carto de dbito do pr-atendimento',
       '',
       'DIADEB_PREATEND',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       7020,
       3,
       'DIAS_ABC_XYZ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Dias ABC/XYZ',
       'Nmero de Dias que Sero Considerados nas Classificaes ABC e XYZ',
       '',
       'DIAS_ABC_XYZ',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2594,
       3,
       'DIAS_ACEITE_AUTOMATICO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias Aceite Autom.',
       'Dias Aceite Automtico',
       '',
       'DIAS_ACEITE_AUTOMATICO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5900,
       3,
       'DIAS_BONUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '9',
       'F',
       'Dias expirao bnus',
       'Dias para expirao do bnus',
       '',
       'DIAS_BONUS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2674,
       2,
       'DIAS_COMPENSACAO_AUTOMATICA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias Comp. Autom.',
       'Dias Compensao Automtica',
       '',
       'DIAS_COMPENSACAO_AUTOMATICA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       4220,
       3,
       'DIAS_EXPIRAR_PEDIDO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Expirao de Pedidos',
       'Dias para Expirao de Pedidos Parciais',
       '',
       'DIAS_EXPIRAR_PEDIDO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       7040,
       3,
       'DIAS_NUMVEN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '#Dias Nm. Vendas',
       'Nmero de Dias Considerados para Nmero de Vendas (descontinuado)',
       '',
       'DIAS_NUMVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7230,
       3,
       'DIAS_REC_PEDIDOS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Dias Rec Pedidos',
       'Dias para Recebimento dos Pedidos',
       '',
       'DIAS_REC_PEDIDOS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4060,
       5,
       'DIAS_TEF_NO_PRECO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Base de Preo em Dia',
       'Base de Preo em Dias',
       '',
       'DIAS_TEF_NO_PRECO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4460,
       2,
       'DIAS_ULTCOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Dias Desde a ltima ',
       'Mximo de Dias Desde a ltima Compra',
       '',
       'DIAS_ULTCOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7180,
       2,
       'DIAS_VARPRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Dias Var Preo',
       ' Dias para Variao do Preo',
       '',
       'DIAS_VARPRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5610,
       2,
       'DIAVEN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Dia Venda',
       'Dia Venda',
       '',
       'DIAVEN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7710,
       1,
       'DISPOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Dist. Proporcional',
       'Distribuio de Estoque Proporcional  Necessidade',
       '',
       'DISPOR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       73,
       255,
       'DIVPATH',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path da Diviso',
       'Path da Diviso',
       '',
       'DIVPATH',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3910,
       5,
       'DOPCCC',
       'S',
       'DDOP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDOP.DESDOP',
       'V',
       '',
       '',
       'N',
       'F',
       'Tipo Documento C/C',
       'Tipo de Doc para pagamento com CC',
       'DDOP.CODTAB(+) = CFG.DOPCCC',
       'DOPCCC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5340,
       2,
       'DSER_NFCOMPL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie para NF Comple',
       'Srie para NF Complementar',
       '',
       'DSER_NFCOMPL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5140,
       5,
       'ECOM_AMEX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Amex para E-Commerce',
       'Domnio de Carto da Bandeira Amex para Recebimento Via E-Commerce',
       '',
       'ECOM_AMEX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5150,
       5,
       'ECOM_MASTER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Mastercard p/ E-Comm',
       'Domnio de Carto da Bandeira Mastercard para Recebimento Via E-Commerce',
       '',
       'ECOM_MASTER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5160,
       5,
       'ECOM_VISA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Visa para E-Commerce',
       'Domnio de Carto da Bandeira Visa para Recebimento Via E-Commerce',
       '',
       'ECOM_VISA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5180,
       1,
       'ENTREGA_CF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Permite Ent Cup Fis ',
       'Permite Entrega com Cupom Fiscal?',
       '',
       'ENTREGA_CF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7840,
       6,
       'ENT_CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cod. Cons. Entrega',
       'Cdigo Consumidor de entrega',
       '',
       'ENT_CODCLI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7830,
       3,
       'ENT_FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Filial Cons. Entrega',
       'Filial Consumidor de entrega',
       '',
       'ENT_FILCLI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2764,
       1,
       'ENVIADATFATURAMENTO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Envia Data Fatura.?',
       'Envia Data de Faturamento?',
       '',
       'ENVIADATFATURAMENTO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3850,
       1,
       'ENVIAR_ENTREGA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Meio Entreg Checkout',
       'Enviar meio de entrega para Checkout',
       '',
       'ENVIAR_ENTREGA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2914,
       3,
       'EXPIRAR_SENHA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'N dias troca senha',
       'Nmero de dias para troca das senhas dos usurios',
       '',
       'EXPIRAR_SENHA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '02',
       2364,
       7,
       'EXPORTA_ESCRITA',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Exportao',
       'Data Exportao',
       '',
       'EXPORTA_ESCRITA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2434,
       1,
       'EXPORTA_TODOS_CLIENTES',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Esporta Todos Cli.',
       'Esporta Todos Cli.',
       '',
       'EXPORTA_TODOS_CLIENTES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3360,
       1,
       'EXP_REC_DATA_VENDA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Rec data venda',
       'Rec data venda',
       '',
       'EXP_REC_DATA_VENDA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '06',
       30,
       2,
       'EXTENSMALA',
       'S',
       '',
       0,
       0,
       'CFG ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CFG',
       'F',
       '',
       'F',
       'Tam. Ext.Mala Direta',
       'Tamanho da linha de extenso na mala-direta',
       '',
       'EXTENSMALA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2294,
       255,
       'E_MAIL_ERRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail Erro',
       'E-mail Erro',
       '',
       'E_MAIL_ERRO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2004,
       255,
       'E_MAIL_ESTOQUE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail Estoque',
       'E-mail Estoque',
       '',
       'E_MAIL_ESTOQUE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       684,
       255,
       'E_MAIL_FINANC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail Financeiro',
       'E-mail Financeiro',
       '',
       'E_MAIL_FINANC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       53,
       4000,
       'FATURA',
       '4',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Formato Impresso ',
       'Formato de impresso de faturas',
       '',
       'RTF2TXT(FATURA)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1524,
       1,
       'FATURA_CC_POR_FILIAL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Fat. CC por Filial?',
       'Fatura Conta Corrente por Filial?',
       '',
       'FATURA_CC_POR_FILIAL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3880,
       3,
       'FILCMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial de compra',
       'Filial de compra que ser utilizada pela formao de preo de venda',
       '',
       'FILCMP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5780,
       3,
       'FILCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial cobrana',
       'Filial padro para cobrana',
       '',
       'FILCOB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2924,
       3,
       'FILCTA_CARTOES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Conta Cartes',
       'Fillial Conta Cartes',
       '',
       'FILCTA_CARTOES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2934,
       3,
       'FILCTA_CHEQUES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Conta Cheques',
       'Filial Conta Cheques',
       '',
       'FILCTA_CHEQUES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2944,
       3,
       'FILCTA_CONTAS_A_REC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Conta a receb',
       'Filial Conta a receber',
       '',
       'FILCTA_CONTAS_A_REC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       694,
       3,
       'FILCTA_DES_CON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fil.Conta Desc.Conc.',
       'Filial Conta Descontos Concebidos',
       '',
       'FILCTA_DES_CON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       704,
       3,
       'FILCTA_DES_OBT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fil.Conta Desc.Obti.',
       'Filial Conta Descontos Obtidos',
       '',
       'FILCTA_DES_OBT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       714,
       3,
       'FILCTA_FOR_PAG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fil.Conta Forn.Pagos',
       'Filial Conta Forcedores Pagos',
       '',
       'FILCTA_FOR_PAG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       724,
       3,
       'FILCTA_FRE_MER',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fil.Conta Frete Mer.',
       'Filial Conta Frete de Mercadorias',
       '',
       'FILCTA_FRE_MER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       734,
       3,
       'FILCTA_FRE_PAG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fil.Conta Frete Pago',
       'Filial Conta Frete Pagos',
       '',
       'FILCTA_FRE_PAG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       138,
       3,
       'FILCTA_GER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Conta Geren.',
       'Filial Conta Gerencial',
       '',
       'FILCTA_GER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       744,
       3,
       'FILCTA_JUR_PAG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fil.Conta Juros Pago',
       'Filial Conta Juros Pagos',
       '',
       'FILCTA_JUR_PAG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       754,
       3,
       'FILCTA_JUR_REC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fil.Conta Juros Rec.',
       'Filial Juros Recebidos',
       '',
       'FILCTA_JUR_REC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       764,
       3,
       'FILCTA_MER_REV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fil. Conta Mer. Rev.',
       'Filial Conta Mercadorias Revenda',
       '',
       'FILCTA_MER_REV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2954,
       3,
       'FILCTA_RENEGOCIACOES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Conta Renegoc',
       'Filial Conta Renegociaes',
       '',
       'FILCTA_RENEGOCIACOES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2964,
       3,
       'FILCTA_RENEGOCIADAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fil Conta Renegociad',
       'Filial Conta Renegociadas',
       '',
       'FILCTA_RENEGOCIADAS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       774,
       3,
       'FILCTA_TAX_PRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fil.ContaTax.PrDesc',
       'Filial Conta de Taxas de Pr-Descpnto',
       '',
       'FILCTA_TAX_PRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       784,
       3,
       'FILCTA_TIT_PAG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fil. Ttulos a Pagar',
       'Filial Conta Ttulos a Pagar',
       '',
       'FILCTA_TIT_PAG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       794,
       3,
       'FILCTA_TIT_REC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fil. Ttulos Receber',
       'Filial Ttulos a Receber',
       '',
       'FILCTA_TIT_REC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       75,
       3,
       'FILCTA_TRN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Conta',
       'Filial Conta',
       '',
       'FILCTA_TRN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5790,
       3,
       'FILENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial entrega',
       'Filial padro para entrega',
       '',
       'FILENT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '01',
       3890,
       1,
       'FILIAL_CONTRATO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       '9',
       '',
       'Filial do Contrato',
       'Filial que a Empresa possui Contrato',
       '',
       'FILIAL_CONTRATO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7250,
       3,
       'FILMAT_AUX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       '',
       'Filial Prod. Aux.',
       'Filial do produto auxiliar para uso interno do sistema',
       '',
       'FILMAT_AUX',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7470,
       3,
       'FILMAT_RAT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Produto RAT',
       'Filial do Produto para faturamento de RAT',
       'DFIL.CODFIL = CFG.FILMAT_RAT(+)',
       'FILMAT_RAT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       6080,
       3,
       'FILMAT_TIN',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial Produto Tinta',
       'Filial Produto Tinta',
       'DFIL.CODFIL = CFG.FILMAT_TIN',
       'FILMAT_TIN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7760,
       3,
       'FILMAT_TRA',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial prod. transf',
       'Filial do produto para transferncia de saldo credor de ICMS',
       'DFIL.CODFIL(+) = CFG.FILMAT_TRA',
       'FILMAT_TRA',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4170,
       3,
       'FILPAP_DIRETORIA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Papel da diretoria',
       'Papel da diretoria',
       '',
       'FILPAP_DIRETORIA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4180,
       3,
       'FILPGT_WOR_PROP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Plano para propostas',
       'Plano para propostas acima do valor mnimo',
       '',
       'FILPGT_WOR_PROP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       56,
       3,
       'FILPRE',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial Tabela Preos',
       'Filial da tabela de preos para venda ao varejo',
       '',
       'FILPRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5860,
       3,
       'FILPRE_ATC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '0',
       'F',
       'Filial Preo Atacado',
       'Filial Preo Atacado',
       '',
       'FILPRE_ATC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5870,
       3,
       'FILPRE_REV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '0',
       'F',
       'Filial Preo Revenda',
       'Filial Preo Revenda',
       '',
       'FILPRE_REV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       1954,
       3,
       'FILPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Projeto',
       '',
       'FILPRJ',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2974,
       3,
       'FILPRJ_PXD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILPRJ_PXD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2714,
       3,
       'FILSRV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Servios',
       'Filial Servios',
       '',
       'FILSRV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7690,
       3,
       'FILTEQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Filial Tipo Equipam.',
       'Filial do Tipo de Equipamento Padro para DAV-OS',
       '',
       'FILTEQ',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5680,
       1,
       'FILTRA_FORNEC_PEDIDO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Filtra For. Pedido',
       'Filtra Fornecedor no Pedido',
       '',
       'FILTRA_FORNEC_PEDIDO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5830,
       3,
       'FIL_BASF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial BASF',
       'Filial de Cadastro do Fornecedor BASF',
       '',
       'FIL_BASF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3590,
       3,
       'FIL_DIMED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial DIMED',
       'Filial de Cadastro do Fornecedor DIMED',
       '',
       'FIL_DIMED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3600,
       3,
       'FIL_DIMPER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial DIMPER',
       'Filial de Cadastro do Fornecedor DIMPER',
       '',
       'FIL_DIMPER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3610,
       3,
       'FIL_ESPECIAL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial Especial',
       'Filial Especial',
       '',
       'FIL_ESPECIAL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3620,
       3,
       'FIL_GENESIO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial Genesio',
       'Filial de Cadastro do Fornecedor Genesio A. Mendes',
       '',
       'FIL_GENESIO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3630,
       3,
       'FIL_PANARELLO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial Panarello',
       'Filial de Cadastro do Fornecedor Panarello',
       '',
       'FIL_PANARELLO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       804,
       3,
       'FIL_PAPEL_TODOS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fil. Papel p/ todos',
       'Filial Papel para todos ',
       '',
       'FIL_PAPEL_TODOS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3640,
       3,
       'FIL_PROFARMA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial PROFARMA',
       'Filial de Cadastro do Fornecedor PROFARMA',
       '',
       'FIL_PROFARMA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3650,
       3,
       'FIL_SANTACRUZ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial Santa Cruz',
       'Filial de Cadastro do Fornecedor Santa Cruz',
       '',
       'FIL_SANTACRUZ',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       814,
       1,
       'FINANC_REIMP_CF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Financ. Reimprime CF',
       'Financeiro Reimprime Cupom Fiscal?',
       '',
       'FINANC_REIMP_CF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3660,
       5,
       'FLGSIT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FLGSIT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       824,
       4000,
       'FMTDOC',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Estrutura padro Doc',
       'Estrutura padro para documentao de projeto',
       '',
       'FMTDOC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       834,
       4000,
       'FMTREQ',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Estrutura Padro Req',
       'Estrutura padro para carncia de projeto',
       '',
       'FMTREQ',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7020,
       1,
       'FPV_PRECO_SIMULADO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'FPV Preo Simulado',
       'Habilitar Formao por Preo Simulado',
       '',
       'FPV_PRECO_SIMULADO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2984,
       1,
       'GERA_CODEXT_INTEGRACAO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Gerar cod ext integr',
       'Gerar cdigo externo para integrao?',
       '',
       'GERA_CODEXT_INTEGRACAO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5660,
       1,
       'GIRO_ESTOQUE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Regra Giro Estoque',
       'Regra de Giro de Estoque',
       '',
       'GIRO_ESTOQUE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5500,
       1,
       'GRAVALOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Gravar Log',
       'Gravar Log',
       '',
       'GRAVALOG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4610,
       5,
       'GX_SIMPAN_ENT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Lan.Produto Acabado',
       'Lan. Produto Acabado',
       '',
       'GX_SIMPAN_ENT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4620,
       7,
       'GX_SIMPAN_ENV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Enviado em',
       'Enviado em',
       '',
       'GX_SIMPAN_ENV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4630,
       3,
       'GX_SIMPAN_FIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       '',
       'GX_SIMPAN_FIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4640,
       5,
       'GX_SIMPAN_PER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Lan. Perda',
       'Lan. Perda',
       '',
       'GX_SIMPAN_PER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4650,
       5,
       'GX_SIMPAN_SAI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Lan. Produo',
       'Lan. Produo',
       '',
       'GX_SIMPAN_SAI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3670,
       2,
       'HORAS_CANC_COMANDA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Horas canc. comanda',
       'Horas canc. comanda',
       '',
       'HORAS_CANC_COMANDA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2534,
       4,
       'HOR_SEPARA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Hora Separao',
       'Hora Separao',
       '',
       'HOR_SEPARA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4470,
       3,
       'HOR_SERASA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Horas Consulta Seras',
       'Validade para consulta do Serasa (em horas)',
       '',
       'HOR_SERASA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       3760,
       7,
       'IGNORA_RESERVA',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Ignorar reservas',
       'Ignorar reservas',
       '',
       'IGNORA_RESERVA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       3770,
       7,
       'IGNORA_VINCULO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Ignorar vnculos',
       'Ignora vnculo',
       '',
       'IGNORA_VINCULO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3274,
       1,
       'IMPEDE_ALTERACAO_PEDIDO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Impede Alter. Pedido',
       'Bloquear alterao de Pedidos no Checkout
Bloquear alterao de Pedidos',
       '',
       'IMPEDE_ALTERACAO_PEDIDO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       2825,
       1,
       'IMPEDE_ORC_MAIOR_LIMITE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Limite Crdito Orc.',
       'Travar oramentos superiores ao limite do cliente.',
       '',
       'IMPEDE_ORC_MAIOR_LIMITE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7530,
       1,
       'IMPPREVENT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Imprime prev. ent.',
       'Imprime previso e perodo de entrega na NF',
       '',
       'IMPPREVENT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2784,
       1,
       'IMP_CF_NF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Reimprimir~CF em NF?',
       'Padro para Reimprimir CF em NF?',
       '',
       'IMP_CF_NF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5990,
       4000,
       'IND_CKPATOTVEN',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Frm. Pont Ven. Ind',
       'Frmula de pontuao por venda (indicador)',
       '',
       'RTF2TXT(IND_CKPATOTVEN)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5980,
       4000,
       'IND_CKPAVENITE',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Frm. Pont Item Ind',
       'Frmula de pontuao por item de venda (indicador)',
       '',
       'RTF2TXT(IND_CKPAVENITE)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '16',
       6030,
       12,
       'IND_QTDBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Qtd. bnus indicador',
       'Qtd de bnus por valor acumulado de venda do indicador',
       '',
       'IND_QTDBON',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '16',
       6020,
       12,
       'IND_VLRVEN_BON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Vl. venda bnus ind',
       'Valor acumulado de venda para clculo de bnus do indicador',
       '',
       'IND_VLRVEN_BON',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       844,
       5,
       'INT_ALT_DAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Alterao de Data',
       'Alterao de Data',
       '',
       'INT_ALT_DAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       854,
       5,
       'INT_ALT_VLR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Alterao de Outros ',
       'Alterao de Outros Valores',
       '',
       'INT_ALT_VLR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       864,
       5,
       'INT_CAN_DES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cancela Desconto',
       'Cancelamento de Desconto',
       '',
       'INT_CAN_DES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       874,
       5,
       'INT_CAN_TIT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cancela Ttulo',
       'Cancelamento de Ttulo',
       '',
       'INT_CAN_TIT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       935,
       5,
       'INT_CON_ABA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Concesso Abatimento',
       'Cdigo da Instruo de Concesso de Abatimento',
       '',
       'INT_CON_ABA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       884,
       5,
       'INT_CON_DES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Concesso Desconto',
       'Concesso de Desconto',
       '',
       'INT_CON_DES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       894,
       5,
       'INT_INC_TIT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Incluso de Ttulo',
       'Incluso de Ttulo',
       '',
       'INT_INC_TIT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       904,
       5,
       'INT_PAG_CAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Pagamento Carteira',
       'Pagamento de Carteira',
       '',
       'INT_PAG_CAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       914,
       5,
       'INT_PRT_TIT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Protesto de Ttulo',
       'Protesto de Ttulo',
       '',
       'INT_PRT_TIT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       924,
       5,
       'INT_S_B_PRT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Protesto BaixaTtulo',
       'Sustao de Protesto com Baixa de Ttulo',
       '',
       'INT_S_B_PRT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       934,
       5,
       'INT_S_C_PRT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Protesto Canc.Ttulo',
       'Sustao de Protesto com Cancelamento de Ttulo',
       '',
       'INT_S_C_PRT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       944,
       1,
       'LANVEN_REIMP_CF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Lanamento Venda/CF',
       'Lanamento Venda Reimpresso Cupom Fiscal',
       '',
       'LANVEN_REIMP_CF',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7850,
       3,
       'LIBERASESSAOMIN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Timeout Inatividade',
       'Timeout para Inatividade',
       '',
       'LIBERASESSAOMIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2794,
       1,
       'LIMCREDITO_SOMALIM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Soma Limites CC?',
       'Soma dos limites de crdito de conta corrente ?',
       '',
       'LIMCREDITO_SOMALIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5320,
       3,
       'LIMDIA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Dias lim. cre valido',
       'Quantidade em dias que o limite de crdito ter validade',
       '',
       'LIMDIA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '16',
       6040,
       5,
       'LIM_PERTOL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Tolerncia limite ',
       '% Tolerncia para limite de crdito',
       '',
       'LIM_PERTOL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       139,
       14,
       'LIM_SAQUE_CC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Limite Saque CC',
       'Limite Saque Conta Corrente',
       '',
       'LIM_SAQUE_CC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5950,
       1,
       'LIM_TIPTOL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Tipo tol. limite cr',
       'Tipo de tolerncia para limite de crdito',
       '',
       'LIM_TIPTOL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '16',
       6050,
       12,
       'LIM_VALTOL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor tolerncia lim',
       'Valor da tolerncia para limite de crdito',
       '',
       'LIM_VALTOL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3900,
       100,
       'LOGOBOLETO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Img boleto CobreBem',
       'Caminho para imagens dos boletos para CobreBem',
       '',
       'LOGOBOLETO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4020,
       1,
       'LOJA_FECHADA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Verifica loja fechad',
       'Verifica se loja est fechada ao gerar C/C carto prprio',
       '',
       'LOJA_FECHADA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       140,
       255,
       'MAI_FR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail de:',
       'E-mail de:',
       '',
       'MAI_FR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       141,
       255,
       'MAI_TO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail pra:',
       'E-mail para:',
       '',
       'MAI_TO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       70,
       20,
       'MASK_LOCALI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'T',
       'A',
       'F',
       'Mscara Localizao',
       'Mscara Localizao',
       '',
       'MASK_LOCALI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3680,
       2,
       'MAXDIAREC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Max Dias Receita',
       'Mximo de dias para receitas',
       '',
       'MAXDIAREC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       142,
       3,
       'MAXPER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Mximo Permisses',
       'Mximo Permisses',
       '',
       'MAXPER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3690,
       2,
       'MAX_DIAS_AGUARDA_FRETE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Max dia aguarda Fret',
       'Mximo de dias que aguarda frete',
       '',
       'MAX_DIAS_AGUARDA_FRETE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2804,
       5,
       'MEIO_ABATIMENTO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Meio~Abatimento',
       'Meio~Abatimento',
       '',
       'MEIO_ABATIMENTO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5100,
       5,
       'MEIO_ESTAC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Pag. Vale-Estacio.',
       'Meio de Pagamento do Vale-Estacionamento',
       '',
       'MEIO_ESTAC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1874,
       5,
       'MEIO_TAXASERVICO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Taxa Servio Devolu.',
       'Taxa de servio de devoluo ',
       '',
       'MEIO_TAXASERVICO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '02',
       2374,
       2,
       'MESES_CARTEIRA_MAX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Mx.Meses Carteira',
       'Mx.Meses Carteira',
       '',
       'MESES_CARTEIRA_MAX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '02',
       2384,
       2,
       'MESES_CARTEIRA_MIN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Min.Meses Carteira',
       'Min.Meses Carteira',
       '',
       'MESES_CARTEIRA_MIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5600,
       5,
       'METCLI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Meta Cliente',
       'Meta Cliente',
       '',
       'METCLI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4260,
       6,
       'MIN_ABASTEC_CHEQUE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       '% Mn p/ Abast. Cheq',
       '% Mnimo para Abast. Cheque',
       '',
       'MIN_ABASTEC_CHEQUE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '03',
       3840,
       1,
       'MOSTRA_REPASSE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Mostrar Repasse',
       'Mostrar repasse no registro de compras',
       '',
       'MOSTRA_REPASSE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       954,
       1,
       'MOVEST_REIMP_CF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Moviemntao Estoque',
       'Movimentao do Estoque e Reimpresso Cupom fiscal',
       '',
       'MOVEST_REIMP_CF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5350,
       8,
       'MPF_CODCFG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MPF_CODCFG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5360,
       8,
       'MPI_ECFCRI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MPI_ECFCRI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5370,
       8,
       'MPI_ECFMET',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MPI_ECFMET',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5380,
       8,
       'MPI_FUNCRI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MPI_FUNCRI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5390,
       8,
       'MPI_FUNMET',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MPI_FUNMET',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5400,
       8,
       'MPI_ITECRI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MPI_ITECRI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5410,
       8,
       'MPI_ITEMET',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MPI_ITEMET',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5420,
       8,
       'MPI_M2_CRI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MPI_M2_CRI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5430,
       8,
       'MPI_M2_MET',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MPI_M2_MET',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5440,
       8,
       'MPI_MEDCRI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MPI_MEDCRI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5450,
       8,
       'MPI_MEDMET',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MPI_MEDMET',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       4210,
       1,
       'MULT_VENDEDORES',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Utl Mlt. Vendedores',
       'Utiliza Mltiplos Vendedores?',
       '',
       'MULT_VENDEDORES',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7210,
       5,
       'NATADJUDICACAOICMS',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nat Adjudicao ICMS',
       'Natureza padro para Adjudicao de Crdito de ICMS',
       '',
       'NATADJUDICACAOICMS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5910,
       5,
       'NATBON',
       'S',
       'DNAT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DNAT.NATURE',
       'V',
       '',
       '',
       'N',
       'F',
       'Natureza bonificao',
       'Natureza padro para bonificao',
       'DNAT.CODTAB(+) = CFG.NATBON',
       'NATBON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7870,
       5,
       'NATDECTRA',
       'S',
       'DNAT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DNAT.NATURE',
       'V',
       '',
       '',
       'N',
       '',
       'Natureza Dec. Trans.',
       'Natureza para Declarao de Transporte',
       'DNAT.CODTAB(+) = CFG.NATDECTRA',
       'NATDECTRA',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7290,
       5,
       'NATDEVCOMP',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Natureza Dev. Compra',
       'Natureza padro para Devoluo de Compra',
       '',
       'NATDEVCOMP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3860,
       5,
       'NATFAT',
       'S',
       'DNAT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DNAT.NATURE',
       'V',
       '',
       '',
       'N',
       'F',
       'Natureza Faturamento',
       'Natureza padro para simples faturamento',
       'DNAT.CODTAB(+) = CFG.NATFAT',
       'NATFAT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7580,
       5,
       'NATIMP',
       'G',
       'DNAT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DNAT.NATURE',
       'V',
       '',
       '',
       'N',
       '',
       'Natureza Importao',
       'Natureza para Importao',
       'DNAT.CODTAB(+) = CFG.NATIMP',
       'NATIMP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7630,
       5,
       'NATNFRECI',
       'G',
       'DNAT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DNAT.NATURE',
       'V',
       '',
       '',
       'N',
       '',
       'Natureza p NF Recibo',
       'Natureza para NF Sobre Recibo Provisrio',
       'DNAT.CODTAB(+) = CFG.NATNFRECI',
       'NATNFRECI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7620,
       5,
       'NATRECIBO',
       'G',
       'DNAT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DNAT.NATURE',
       'V',
       '',
       '',
       'N',
       '',
       'Natureza Recibo P',
       'Natureza para Recibo Provisrio',
       'DNAT.CODTAB(+) = CFG.NATRECIBO',
       'NATRECIBO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7200,
       5,
       'NATRESSARCIMENTOST',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nat Ressarcimento ST',
       'Natureza padro para Ressarcimento de ST',
       '',
       'NATRESSARCIMENTOST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3870,
       5,
       'NATVEN',
       'S',
       'DNAT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DNAT.NATURE',
       'V',
       '',
       '',
       'N',
       'F',
       'Natureza Venda',
       'Natureza padro para venda',
       'DNAT.CODTAB(+) = CFG.NATVEN',
       'NATVEN',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       4230,
       5,
       'NAT_CONSIGNACAO',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Natureza para Consig',
       'Natureza para Consignao',
       '',
       'NAT_CONSIGNACAO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2604,
       5,
       'NAT_CREICM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nat.Crdito ICMS',
       'Natureza nota de crdito de ICMS',
       '',
       'NAT_CREICM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       143,
       5,
       'NAT_FAT_CC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nat. Fatura C. C.',
       'Natureza Fatura Conta Corrente',
       '',
       'NAT_FAT_CC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1534,
       1,
       'NF_APOS_CF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'NF aps CF?',
       'Nota Fiscal aps Cupom Fiscal?',
       '',
       'NF_APOS_CF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       101,
       25,
       'NOMCODSAC',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       100,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cdigo Livre do SAC',
       'Cdigo livre do SAC',
       '',
       'NOMCODSAC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '01',
       10,
       30,
       'NOMEMP',
       'A',
       '',
       0,
       0,
       'CFG ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Nome da Empresa',
       'Nome da Empresa',
       '',
       'NOMEMP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3700,
       20,
       'NOME_CLASSIFICACAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Classificao',
       'Nome da Classificao',
       '',
       'NOME_CLASSIFICACAO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       63,
       25,
       'NOMLSTSAC',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       110,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Nome Lista Fixa SAC',
       'Nome para lista fixa do SAC',
       '',
       'NOMLSTSAC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       91,
       25,
       'NOMNUMREG',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Descrio nRegistro',
       'Descrio para o campo nro de registro',
       '',
       'NOMNUMREG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       60,
       25,
       'NOMNUMSER',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Descrio Nm. Srie',
       'Descrio para o campo nro de srie',
       '',
       'NOMNUMSER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '05',
       30,
       2,
       'NUMVEN',
       'S',
       '',
       0,
       0,
       'CFG ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CFG',
       'F',
       '',
       'F',
       'Nmero da Venda',
       'Nmero da venda',
       '',
       'NUMVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3920,
       1,
       'OBRIGA_CODEAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Cdigo de Venda',
       'Cdigo de Venda',
       '',
       'OBRIGA_CODEAN',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3370,
       1,
       'OBRIG_ICMS_PED',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Preen %ICMS Compra?',
       'Preenchimento do %ICMS na Compra',
       '',
       'OBRIG_ICMS_PED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7670,
       1,
       'OBRPESO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Obrigar Peso?',
       'Obrigar Peso em NFe?',
       '',
       'OBRPESO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7680,
       1,
       'OBRVOL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Obrigar Volume?',
       'Obrigar Volume em NFe?',
       '',
       'OBRVOL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7740,
       1,
       'ORICRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Origem RE',
       'Origem da Requisio Externa',
       '',
       'ORICRE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1904,
       5,
       'PADIVAMPLIACAO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Diviso da Ampliao',
       'Diviso da Ampliao',
       '',
       'PADIVAMPLIACAO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2994,
       1,
       'PADRAO_COMISSAO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Padro comisso',
       'Padro comisso',
       '',
       'PADRAO_COMISSAO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2494,
       5,
       'PAESTOQUEVENDA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'PA.Estoque Venda',
       'PA.Estoque Venda',
       '',
       'PAESTOQUEVENDA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4310,
       128,
       'PAFECF_ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ass. dados PAF-ECF',
       'Assinatura dados PAF-ECF',
       '',
       'PAFECF_ASSINA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4920,
       14,
       'PAFECF_CGCTOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'CNPJ Empre. Desemv.',
       'CNPJ da Empresa Desenvolvedora',
       '',
       'PAFECF_CGCTOT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4320,
       40,
       'PAFECF_NOMCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Comercial',
       'Nome Comercial',
       '',
       'PAFECF_NOMCOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4930,
       254,
       'PAFECF_NOMPAF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome comer. PAF',
       'Nome comercial do PAF',
       '',
       'PAFECF_NOMPAF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4330,
       20,
       'PAFECF_NROLAU',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Laudo',
       'Nmero do Laudo',
       '',
       'PAFECF_NROLAU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4340,
       4000,
       'PAFECF_OUTARQ',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Out arq exec MD5',
       'Outros arquivo executvel e MD5',
       '',
       'PAFECF_OUTARQ',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4350,
       40,
       'PAFECF_PRIARQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Princ arq executvel',
       'Principal arquivo executvel',
       '',
       'PAFECF_PRIARQ',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4360,
       40,
       'PAFECF_PRIARQ_MD5',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'MD5 Princ arq. exec.',
       'MD5 Principal arquivo executvel',
       '',
       'PAFECF_PRIARQ_MD5',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1544,
       1,
       'PALISTADEBITOS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Imp. Lista Dbitos?',
       'Imprime Dbitos do cliente ao pagar as parcelas',
       '',
       'PALISTADEBITOS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1554,
       5,
       'PAPHOAMPLIA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ampliao da Foto',
       'Ampliao da Foto',
       '',
       'PAPHOAMPLIA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1564,
       5,
       'PAPHOCODAMPLIA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'N',
       'F',
       'Cdigo Ampliao',
       'Cdigo Ampliao',
       '',
       'PAPHOCODAMPLIA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1574,
       5,
       'PAPHOCODREVAMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Rev. e Amplia',
       'Cdigo Revelao e Ampliao',
       '',
       'PAPHOCODREVAMP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1584,
       5,
       'PAPHOCODREVELA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'CdigoRevelao Foto',
       'Cdigo Revelao Foto',
       '',
       'PAPHOCODREVELA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1594,
       2,
       'PAPHODUPLO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nm. Mx.Cd. Barras',
       'Nmero mximo de cdigos de barras ',
       '',
       'PAPHODUPLO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1604,
       4000,
       'PAPHOETIQUETA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Pad.Etiquetas p/Env.',
       'Padro de Etiqueta para Envelopes:',
       '',
       'PAPHOETIQUETA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1614,
       3,
       'PAPHOFILAMPLIA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'FilialFoto Ampliao',
       'Filial Foto Ampliao',
       '',
       'PAPHOFILAMPLIA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1624,
       3,
       'PAPHOFILREVAMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Revel./Ampli.',
       'Filial Revelao e Ampliao',
       '',
       'PAPHOFILREVAMP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1634,
       3,
       'PAPHOFILREVELA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial FotoRevelao',
       'Filial Foto Revelao',
       '',
       'PAPHOFILREVELA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1644,
       4000,
       'PAPHOFOR1',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Fr.Preo Venda Foto',
       'Frmula de preo de venda de foto',
       '',
       'PAPHOFOR1',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1654,
       4000,
       'PAPHOFORS',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'FrmulaPadro Sinal',
       'Frmula padro para sinal',
       '',
       'PAPHOFORS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1664,
       5,
       'PAPHOOBSPADRAO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'ObservaoPadro O.S',
       'Observao padro de O.S.',
       '',
       'PAPHOOBSPADRAO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1674,
       3,
       'PAPHOTEMPO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tempo Rev. Minutos',
       'Tempo padro para Revelao em "minutos"',
       '',
       'PAPHOTEMPO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2014,
       5,
       'PAPHOTIPLAN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tipo Lanamento',
       'Tipo Lanamento',
       '',
       'PAPHOTIPLAN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1684,
       1,
       'PAPHOTO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Empresa Fotografia?',
       'Empresa de Fotografia',
       '',
       'PAPHOTO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1694,
       254,
       'PAPHOVAR1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Varivel  X',
       'Varivel  X',
       '',
       'PAPHOVAR1',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1704,
       254,
       'PAPHOVAR2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Varivel  Z',
       'Varivel  Z',
       '',
       'PAPHOVAR2',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1714,
       254,
       'PAPHOVAR3',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Varivel  Y',
       'Varivel  Y',
       '',
       'PAPHOVAR3',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1884,
       1,
       'PAPREDATARCONSUMIDOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Pr_Datar Cheques?',
       'Permite pr-datar cheques para vendas ao consumidor',
       '',
       'PAPREDATARCONSUMIDOR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '18',
       1,
       1,
       'PARC_CARTAO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Carto',
       'Tipo de Parceiro Carto',
       '',
       'PARC_CARTAO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '18',
       2,
       1,
       'PARC_CLIENTE_TRANSP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Cliente Transp.',
       'Tipo de Parceiro Cliente Transportadora',
       '',
       'PARC_CLIENTE_TRANSP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '18',
       3,
       1,
       'PARC_FORNECEDOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Fornecedor',
       'Tipo de Parceiro Fornecedor',
       '',
       'PARC_FORNECEDOR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '18',
       4,
       1,
       'PARC_INDICA_VENDA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Indica Venda',
       'Tipo de Parceiro Indica Venda',
       '',
       'PARC_INDICA_VENDA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '18',
       5,
       1,
       'PARC_MARCA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Marca',
       'Tipo de Parceiro Marca',
       '',
       'PARC_MARCA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '18',
       6,
       1,
       'PARC_MOTORISTA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Motorista',
       'Tipo de Parceiro Motorista',
       '',
       'PARC_MOTORISTA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7150,
       1,
       'PARC_PEDIDO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Parcelamen Pedido',
       'Obriga Parcelamento no Pedido',
       '',
       'PARC_PEDIDO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '18',
       7,
       1,
       'PARC_REPRESENTANTE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Representante',
       'Tipo de Parceiro Representante',
       '',
       'PARC_REPRESENTANTE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '18',
       8,
       1,
       'PARC_TECNICO_EXTERNO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tcnico Externo',
       'Tipo de Parceiro Tcnico Externo',
       '',
       'PARC_TECNICO_EXTERNO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '18',
       9,
       1,
       'PARC_TEC_INTERNO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tcnico Interno',
       'Tipo de Parceiro Tcnico Interno',
       '',
       'PARC_TEC_INTERNO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '18',
       10,
       1,
       'PARC_TRANSPORTADOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Transportador',
       'Tipo de Parceiro Transportador',
       '',
       'PARC_TRANSPORTADOR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '18',
       11,
       1,
       'PARC_USUARIO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usurio',
       'Tipo de Parceiro Usurio',
       '',
       'PARC_USUARIO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       144,
       255,
       'PATH_ANEXOS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path(Caminho) Anexos',
       'Path(Caminho) Anexos',
       '',
       'PATH_ANEXOS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1724,
       200,
       'PATH_ARQUIVOS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path de Arquivos',
       'Path de Arquivos',
       '',
       'PATH_ARQUIVOS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4400,
       100,
       'PATH_BASE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Caminho p/ Servidor',
       'Caminho para Servidor de Arquivos',
       '',
       'PATH_BASE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       964,
       255,
       'PATH_PROJETOS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path dos Projetos',
       'Path dos Projetos',
       '',
       'PATH_PROJETOS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4890,
       255,
       'PATH_TTSEGUR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path TTSEGUR',
       'Path para Biblioteca TTSEGUR no Servidor de Banco de Dados',
       '',
       'PATH_TTSEGUR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1734,
       1,
       'PATIPODESCONTO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Desconto',
       'Tipo de Desconto',
       '',
       'PATIPODESCONTO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '05',
       10,
       2,
       'PATIPOREF',
       'S',
       '',
       0,
       0,
       'CFG ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CFG',
       'F',
       '',
       'F',
       'Tipo de Referncia',
       'Tipo de Referncia',
       '',
       'PATIPOREF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '03',
       30,
       1,
       'PCOONLINE',
       'L',
       '',
       0,
       0,
       'CFG ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'CFG',
       'F',
       '',
       'F',
       'Atu. Preo On-line?',
       'Atualizao de preos On-Line',
       '',
       'PCOONLINE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '17',
       2444,
       2,
       'PDA_CODPRE',
       'S',
       'TPR ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TPR.DESPRE',
       'V',
       '',
       'F',
       'A',
       'F',
       'Tabela de Preos',
       'Tabela de preos usada pela fora de vendas',
       'TPR.CODFIL = CFG.PDA_FILPRE and TPR.CODPRE = CFG.PDA_CODPRE',
       'PDA_CODPRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '17',
       2454,
       3,
       'PDA_FILPRE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial Origem Preo',
       'Tabela de preos usada pela fora de vendas',
       'DFIL.CODFIL = CFG.PDA_FILPRE',
       'PDA_FILPRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2614,
       1,
       'PDA_GRUPO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Grupo Exportado?',
       'Grupo Exportado?',
       '',
       'PDA_GRUPO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '17',
       2464,
       1,
       'PDA_INTEGRACAO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Integrao PDAs?',
       'Usa integrao com PDAs?',
       '',
       'PDA_INTEGRACAO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '17',
       2474,
       255,
       'PDA_PATH_EXPORTACAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Caminho Destino PDAs',
       'Caminho de destino dos arquivos gerados pelo TC',
       '',
       'PDA_PATH_EXPORTACAO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '17',
       2484,
       255,
       'PDA_PATH_IMPORTACAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Caminho Origem PDAs',
       'Caminho de origem dos arquivos gerados pelo servidor ',
       '',
       'PDA_PATH_IMPORTACAO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2624,
       1,
       'PDA_SUBGRUPO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Sub-Grupo Exportado?',
       'Sub-Grupo Exportado?',
       '',
       'PDA_SUBGRUPO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2814,
       7,
       'PDA_ULTEXP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data ltima Exp.',
       'Data da ltima exportao',
       '',
       'PDA_ULTEXP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2824,
       1,
       'PDA_ULTEXP_PARCIAL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Data Exp. Parcial?',
       'ltima exportao foi parcial ou no',
       '',
       'PDA_ULTEXP_PARCIAL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2834,
       7,
       'PDA_ULTIMP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data ltima Imp.',
       'Data da ltima importao ',
       '',
       'PDA_ULTIMP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '03',
       60,
       2,
       'PEDCOMPATE',
       'S',
       '',
       0,
       0,
       'CFG ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CFG',
       'F',
       '',
       'F',
       'Dif.Ped./Compra Fim',
       'Diferena entre pedido e compra (final do perodo)',
       '',
       'PEDCOMPATE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '03',
       50,
       2,
       'PEDCOMPDE',
       'S',
       '',
       0,
       0,
       'CFG ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CFG',
       'F',
       '',
       'F',
       'Dif.Ped./Compra In.',
       'Diferena entre pedido e compra (incio do perodo)',
       '',
       'PEDCOMPDE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       3780,
       1,
       'PENAUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Pend. s Autorizados',
       'Considerar como pendente somente os pedidos autorizados',
       '',
       'PENAUT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       68,
       6,
       'PERCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Comisso',
       'Percentual de comisso',
       '',
       'PERCOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       69,
       1,
       'PERCOM_FPV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       '% Comisso na FPV?',
       '% Comisso Incide na FPV?',
       '',
       'PERCOM_FPV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7450,
       5,
       'PERIPIATA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% IPI Transf Atac',
       '% de IPI para Transferncias entre Filiais Atacadistas',
       '',
       'PERIPIATA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7440,
       5,
       'PERIPITRA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% IPI Transf',
       '% de IPI para Transferncias',
       '',
       'PERIPITRA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       71,
       6,
       'PERIR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Imposto de Renda',
       'Percentual Imposto de Renda',
       '',
       'PERIR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7540,
       5,
       'PERPARICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Partilha ICMS',
       '% da Partilha de ICMS para o Destino',
       '',
       'PERPARICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4190,
       7,
       'PERURG_PROP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Acrs. Prop. Ugentes',
       'Percentual de acrscimo em propostas urgentes',
       '',
       'PERURG_PROP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       7050,
       4,
       'PER_A',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '% A no ABC',
       'Participao de A na Classificao ABC',
       '',
       'PER_A',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       7060,
       4,
       'PER_B',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% B no ABC',
       'Participao de B na Classificao ABC',
       '',
       'PER_B',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       7070,
       4,
       'PER_C',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% C no ABC',
       'Participao de C na Classificao ABC',
       '',
       'PER_C',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3970,
       4,
       'PER_CPMF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% CPMF',
       '% CPMF',
       '',
       'PER_CPMF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4240,
       6,
       'PER_TROCA_CHEQUE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% p/Troca de cheques',
       'Percentual para Troca de Cheques',
       '',
       'PER_TROCA_CHEQUE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       7080,
       4,
       'PER_X',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% X no XYZ',
       'Participao de X na Classificao XYZ',
       '',
       'PER_X',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       7090,
       4,
       'PER_Y',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% Y no XYZ',
       'Participao de Y na Classificao XYZ',
       '',
       'PER_Y',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       7100,
       4,
       'PER_Z',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% Z no XYZ',
       'Participao de Z na Classificao XYZ',
       '',
       'PER_Z',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2844,
       1,
       'PLACAABERTURA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Placa Abertura?',
       'Placa Abertura?',
       '',
       'PLACAABERTURA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4410,
       15,
       'PLANO_PGT_WOR_PROP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PLANO_PGT_WOR_PROP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '05',
       70,
       15,
       'PLURALDEC',
       'A',
       '',
       0,
       0,
       'CFG ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Decimal Plural',
       'Decimal Plural',
       '',
       'PLURALDEC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '05',
       50,
       15,
       'PLURALINT',
       'A',
       '',
       0,
       0,
       'CFG ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Inteiro Plural',
       'Inteiro Plural',
       '',
       'PLURALINT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       974,
       1,
       'POPULA_TP_CLI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Popula Tabela TP_CLI',
       'Popula Tabela TP_CLI?',
       '',
       'POPULA_TP_CLI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5050,
       5,
       'PORMTV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Portador MTVendor ',
       'Portador para Integrao com MTVendors',
       '',
       'PORMTV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       984,
       5,
       'PORTKE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Portador para TKE',
       'Portador para TKE',
       '',
       'PORTKE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       145,
       3,
       'PRAFIN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Prazo em Dias',
       'Prazo em Dias',
       '',
       'PRAFIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7140,
       1,
       'PRAZO_ENT_PEDIDO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Prazo Entrega Pedido',
       'Obriga Prazo de Entrega no Pedido',
       '',
       'PRAZO_ENT_PEDIDO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7520,
       1,
       'PREZER',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exibir prod s/ preo',
       'Exibe produtos sem preo ou com preo zerado',
       '',
       'PREZER',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2214,
       12,
       'PRE_ARR_100_REAIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Arredonda 100 Reais',
       'Arredonda 100 Reais',
       '',
       'PRE_ARR_100_REAIS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2224,
       12,
       'PRE_ARR_10_CENTAVOS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Arredonda 10 cetavos',
       'Arredonda 10 cetavos',
       '',
       'PRE_ARR_10_CENTAVOS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2234,
       12,
       'PRE_ARR_10_REAIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Arredonda 10 Reais',
       'Arredonda 10 Reais',
       '',
       'PRE_ARR_10_REAIS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2244,
       12,
       'PRE_ARR_1_CENTAVO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Arredonda 1 centavo',
       'Arredonda 1 centavo',
       '',
       'PRE_ARR_1_CENTAVO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2254,
       12,
       'PRE_ARR_1_REAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Arredonda 1 Real',
       'Arredonda 1 Real',
       '',
       'PRE_ARR_1_REAL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2264,
       12,
       'PRE_PSI_100_REAIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Centena de Reais',
       'Centena de Reais para Preo Psicolgico',
       '',
       'PRE_PSI_100_REAIS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1754,
       12,
       'PRE_PSI_10_CENTAVOS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Dezenas de Centavos',
       'Dezenas de Centavos para Preo Psicolgico',
       '',
       'PRE_PSI_10_CENTAVOS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2274,
       12,
       'PRE_PSI_10_REAIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dezena de Real',
       'Dezena de Real para Preo Psicolgico',
       '',
       'PRE_PSI_10_REAIS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1774,
       12,
       'PRE_PSI_1_CENTAVO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Unidade Centavos',
       'Unidade Centavos para preo Psicolgico',
       '',
       'PRE_PSI_1_CENTAVO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1784,
       12,
       'PRE_PSI_1_REAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Unidade Real',
       'Unidade Real para preo Psicolgico',
       '',
       'PRE_PSI_1_REAL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1794,
       1,
       'PRE_PSI_DIGITO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dgito Preo Psico.',
       'Dgito Preo Psicolgico',
       '',
       'PRE_PSI_DIGITO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '16',
       1804,
       12,
       'PRE_PSI_MINIMO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Preo Psico. Mnimo',
       'Preo Psicolgico Mnimo',
       '',
       'PRE_PSI_MINIMO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '16',
       1814,
       2,
       'PRE_PSI_PERCENTUAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '% Preo Psicolgico',
       'Percentual Preo Psicolgico',
       '',
       'PRE_PSI_PERCENTUAL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       1824,
       1,
       'PRE_PSI_UTILIZA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Utiliza Preo Psico?',
       'Utiliza Preo Psicolgico',
       '',
       'PRE_PSI_UTILIZA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3710,
       1,
       'PRO_CODLPC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Princpio Ativo',
       'Princpio Ativo',
       '',
       'PRO_CODLPC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3720,
       1,
       'PRO_CONTRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Lista Pro Controlado',
       'Lista de Produto Controlado ',
       '',
       'PRO_CONTRO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4370,
       1,
       'RATEIO_FRETE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Frete rateado por',
       'Frete rateado por',
       '',
       'RATEIO_FRETE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       72,
       255,
       'RBPATH',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path dos Arquivos',
       'Localizao, "path", dos arquivos com os formatos de impresso (RTM)',
       '',
       'RBPATH',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7650,
       1,
       'RECEBE_CC_INDIVIDUAL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Rec. C/C Individual',
       'Receber C/C de forma Individual',
       '',
       'RECEBE_CC_INDIVIDUAL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       1984,
       1,
       'RECPAR_DEVOLUCAO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Rec. Par. Devoluo?',
       'Rec. Par. Devoluo',
       '',
       'RECPAR_DEVOLUCAO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '03',
       10,
       8,
       'REDICMFRE',
       'F',
       '',
       2,
       0,
       'CFG ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CFG',
       'T',
       '',
       'F',
       'Reduo ICMS/Frete',
       'Reduo de ICMS sobre frete (%)',
       '',
       'REDICMFRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       7110,
       1,
       'REGRA_CLSABC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Regra ABC',
       'Regra para Classificao ABC',
       '',
       'REGRA_CLSABC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       7120,
       1,
       'REGRA_CLSXYZ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Regra XYZ',
       'Regra para Classificao XYZ',
       '',
       'REGRA_CLSXYZ',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       6060,
       1,
       'REGRA_CODFIS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Regra Cdigo Fiscal',
       'Regra para Cdigo Fiscal (Regra Cdigo Fiscal)',
       '',
       'REGRA_CODFIS',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7220,
       1,
       'REGRA_MEDIA_VENDAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Regra Mdia Ven',
       'Regra para Calcular a Mdia de Vendas no Ponto de Pedido',
       '',
       'REGRA_MEDIA_VENDAS',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4600,
       1,
       'RESERVA_ENT_FUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Ora. Entrega Futura',
       'Reservar Oramento de Entrega Futura',
       '',
       'RESERVA_ENT_FUT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '02',
       4120,
       1,
       'RESERVA_VENDA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Reserva estoque?',
       'Venda reserva estoque?',
       '',
       'RESERVA_VENDA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       1924,
       1,
       'RESTRICAO_VINCULO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Restrio Vnculo?',
       'Restrio Vnculo?',
       '',
       'RESTRICAO_VINCULO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3950,
       1,
       'REUTILIZA_REFERENCIA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Reut ref pro import?',
       'Reutiliza Referncia do Produto na Importao?',
       '',
       'REUTILIZA_REFERENCIA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       55,
       4000,
       'RODPRE',
       '4',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Rodap Fatura',
       'Rodap da fatura',
       '',
       'RTF2TXT(RODPRE)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4590,
       1,
       'ROMANEIO_FILIAL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Romaneio por Filial',
       'Romaneio por Filial',
       '',
       'ROMANEIO_FILIAL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3450,
       5,
       'SAC_CODFUN',
       'S',
       'DFUN',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFUN.DESFUN',
       'V',
       '',
       '',
       '9',
       'F',
       'Funcionalidade',
       'Funcionalidade',
       'DFUN.CODTAB = CFG.SAC_CODFUN',
       'SAC_CODFUN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3460,
       5,
       'SAC_CODPRI',
       'S',
       'DPRI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DPRI.DESPRI',
       'V',
       '',
       '',
       '9',
       'F',
       'Severidade',
       'Severidade',
       'DPRI.CODTAB = CFG.SAC_CODPRI',
       'SAC_CODPRI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2634,
       1,
       'SAC_EXIGE_CODCWS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Classifica Chamado?',
       'Exige Classificao ao fechar um chamado
',
       '',
       'SAC_EXIGE_CODCWS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2644,
       1,
       'SAC_EXIGE_CODFUN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Preenche Funcional.?',
       'Exige preenchimento de Funcionalidade ao fechar um chamado
',
       '',
       'SAC_EXIGE_CODFUN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2845,
       1,
       'SAC_EXIGE_MODULO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Classifica Chamado?',
       'Exige Modulo ao fechar um chamado
',
       '',
       'SAC_EXIGE_MODULO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       146,
       255,
       'SAC_E_MAIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'SAC E-mail',
       'SAC E-mail',
       '',
       'SAC_E_MAIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3500,
       5,
       'SAC_FLGSIT',
       'S',
       'DSIT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSIT.DESSIT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Situao',
       'Situao',
       'DSIT.CODTAB = CFG.SAC_FLGSIT',
       'SAC_FLGSIT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       994,
       255,
       'SAC_HOME_PAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'SAC Home-Page',
       'SAC Home-Page',
       '',
       'SAC_HOME_PAGE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       147,
       255,
       'SAC_HOST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'SAC HOST',
       'SAC HOST',
       '',
       'SAC_HOST',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1004,
       3,
       'SAC_MAIL_CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Usuario Responsavel',
       'Usuario Responsavel',
       'CFG.SAC_MAIL_FILUSU = USU.FILUSU AND CFG.SAC_MAIL_CODUSU = USU.CODUSU',
       'SAC_MAIL_CODUSU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1014,
       3,
       'SAC_MAIL_FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fil Usu Responsavel',
       'Fil Usu Responsavel',
       '',
       'SAC_MAIL_FILUSU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       148,
       255,
       'SAC_NOME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'SAC Nome',
       'SAC Nome',
       '',
       'SAC_NOME',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       149,
       5,
       'SAC_PORTA_POP3',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'SAC Porta POP3',
       'SAC Porta POP3',
       '',
       'SAC_PORTA_POP3',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       150,
       255,
       'SAC_PORTA_SMTP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'SAC Porta SMTP',
       'SAC Porta SMTP',
       '',
       'SAC_PORTA_SMTP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       1914,
       1,
       'SAC_POS_VENDA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'SAC Aps Venda?',
       'SAC Aps Venda?',
       '',
       'SAC_POS_VENDA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       151,
       255,
       'SAC_RESPOSTA_ERRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'SAC Resposta Erro',
       'SAC Resposta Erro',
       '',
       'SAC_RESPOSTA_ERRO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       152,
       255,
       'SAC_SENHA_POP3',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'SAC Senha POP3',
       'SAC Senha POP3',
       '',
       'SAC_SENHA_POP3',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       153,
       255,
       'SAC_TEXTO_LIBERA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'SAC Texto Liberao',
       'SAC Texto Liberao',
       '',
       'SAC_TEXTO_LIBERA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3470,
       1,
       'SAC_TIPREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Registro',
       'Tipo de Registro',
       '',
       'SAC_TIPREG',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3480,
       5,
       'SAC_TIPSUP',
       'S',
       'DCWS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCWS.DESCWS',
       'V',
       '',
       '',
       '9',
       'F',
       'Classificao',
       'Classificao',
       'CFG.TIPSUP = DCWS.CODTAB',
       'SAC_TIPSUP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       154,
       255,
       'SAC_USERID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'SAC ID do usurio',
       'SAC ID do usurio',
       '',
       'SAC_USERID',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7400,
       1,
       'SEMESTLOTE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Sem Estoque do Lote',
       'Venda Sem Estoque do Lote',
       '',
       'SEMESTLOTE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5650,
       1,
       'SEPARAR_ENTREGA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Utiliza separao?',
       'Utiliza separao para entrega?',
       '',
       'SEPARAR_ENTREGA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7460,
       1,
       'SEPMAIOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Separao Qtd. Maior',
       'Permite Separao no Checkout com Quantidade Maior',
       '',
       'SEPMAIOR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7430,
       1,
       'SEP_FAT_RETIRA_DEPOSITO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Sep Fat Ret Depsito',
       'Cria separao para Fatura Retira no Depsito',
       '',
       'SEP_FAT_RETIRA_DEPOSITO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       3114,
       10,
       'SEQCTA_CARTOES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Seq Conta Cartes',
       'Sequenciador Conta Cartes',
       '',
       'SEQCTA_CARTOES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       3124,
       10,
       'SEQCTA_CHEQUES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Seq Conta Cheques',
       'Sequenciador Conta Cheques',
       '',
       'SEQCTA_CHEQUES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       3134,
       10,
       'SEQCTA_CONTAS_A_REC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Seq Conta a receber',
       'Sequenciador Conta a receber',
       '',
       'SEQCTA_CONTAS_A_REC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1024,
       10,
       'SEQCTA_DES_CON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq Conta Desc Conc.',
       'Sequenciador Conta Descontos Concebidos',
       '',
       'SEQCTA_DES_CON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1034,
       10,
       'SEQCTA_DES_OBT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq Conta Desc Obtid',
       'Sequenciador Conta Descontos Obtidos',
       '',
       'SEQCTA_DES_OBT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1044,
       10,
       'SEQCTA_FOR_PAG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq Conta Forn. pago',
       'Sequenciador Conta Fornecedores PAgos',
       '',
       'SEQCTA_FOR_PAG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1054,
       10,
       'SEQCTA_FRE_MER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq Conta Frete Merc',
       'Sequenciador Conta Frete de Mercadorias',
       '',
       'SEQCTA_FRE_MER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1064,
       10,
       'SEQCTA_FRE_PAG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq Conta Frete pago',
       'Sequenciador Conta Frete Pagos',
       '',
       'SEQCTA_FRE_PAG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       155,
       10,
       'SEQCTA_GER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. Conta Gerencial',
       'Sequenciador Conta Gerencial',
       '',
       'SEQCTA_GER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1074,
       10,
       'SEQCTA_JUR_PAG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq Conta Juros pago',
       'Sequenciador Conta Juros Pagos',
       '',
       'SEQCTA_JUR_PAG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1084,
       10,
       'SEQCTA_JUR_REC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq Conta Juros rece',
       'Sequenciador Conta Juros Recebidos',
       '',
       'SEQCTA_JUR_REC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1094,
       10,
       'SEQCTA_MER_REV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq Conta Merc Reven',
       'Sequenciador Conta Mercadorias de Revenda',
       '',
       'SEQCTA_MER_REV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       3144,
       10,
       'SEQCTA_RENEGOCIACOES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Seq Conta Renegocia',
       'Sequenciador Conta Renegociaes',
       '',
       'SEQCTA_RENEGOCIACOES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       3154,
       10,
       'SEQCTA_RENEGOCIADAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Seq Conta Renegociad',
       'Sequenciador Conta Renegociadas',
       '',
       'SEQCTA_RENEGOCIADAS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1104,
       10,
       'SEQCTA_TAX_PRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq Con Taxa Pr-des',
       'Sequenciador Conta Taxas de Pr-Desconto',
       '',
       'SEQCTA_TAX_PRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1114,
       10,
       'SEQCTA_TIT_PAG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq Conta Tit apagar',
       'Sequenciador Conta Ttulos a Pagar',
       '',
       'SEQCTA_TIT_PAG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1124,
       10,
       'SEQCTA_TIT_REC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq Conta Tit recebe',
       'Sequenciador Conta Ttulos a Receber',
       '',
       'SEQCTA_TIT_REC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       76,
       10,
       'SEQCTA_TRN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador Conta',
       'Sequenciador Conta',
       '',
       'SEQCTA_TRN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4140,
       10,
       'SEQPAP_DIRETORIA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Papel da diretoria',
       'Papel da diretoria',
       '',
       'SEQPAP_DIRETORIA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       1964,
       10,
       'SEQPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Projeto',
       '',
       'SEQPRJ',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       3164,
       10,
       'SEQPRJ_PXD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQPRJ_PXD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7700,
       10,
       'SEQTEQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Seq Tipo Equipam.',
       'Seq do Tipo de Equipamento Padro para DAV-OS',
       '',
       'SEQTEQ',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1134,
       10,
       'SEQ_PAPEL_TODOS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq Papel p/ todos',
       'Sequenciador Papel para Todos',
       '',
       'SEQ_PAPEL_TODOS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       156,
       2,
       'SERIE_FAT_CC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie Fatura C.C.',
       'Srie Fatura Conta Corrente',
       '',
       'SERIE_FAT_CC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       7560,
       2,
       'SERSAT',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       'F',
       'Srie do SAT',
       'Srie do SAT',
       'DSER.CODSER(+) = CFG.SERSAT',
       'SERSAT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '05',
       60,
       15,
       'SINGULDEC',
       'A',
       '',
       0,
       0,
       'CFG ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Decimal Singular',
       'Decimal Singular',
       '',
       'SINGULDEC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '05',
       40,
       15,
       'SINGULINT',
       'A',
       '',
       0,
       0,
       'CFG ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Inteiro Singular',
       'Inteiro Singular',
       '',
       'SINGULINT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7610,
       1,
       'SISDFE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Mensageria DFE',
       'Mensageria para Documento Fiscal Eletrnico',
       '',
       'SISDFE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2864,
       1,
       'SOLICITA_END_CF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Solicita~End. CF?',
       'Gravar parmetro para definir se solicita endereo na emisso de CF?',
       '',
       'SOLICITA_END_CF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       3380,
       1,
       'SPC_PARCELA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'SPC por pacela',
       'Baixar de SPC por parcela',
       '',
       'SPC_PARCELA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3930,
       4000,
       'SQL_CUSREP',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Frmula Custo Repos.',
       'Frmula para clculo do custo de reposio',
       '',
       'RTF2TXT(SQL_CUSREP)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       58,
       1,
       'SRVUNI',
       'L',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       60,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Servidor nico(T/F)?',
       'Servidor nico (T/F)',
       '',
       'SRVUNI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5880,
       1,
       'ST_NO_FRETE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Fat.Fret ST Compras',
       'Considera Fatura de Conhecimento de Frete na ST das Compras Vinculadas',
       '',
       'ST_NO_FRETE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       7570,
       1,
       'ST_PRIPAR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Cobrar ST 1a Parc.',
       'Cobrar ST na 1a Parcela',
       '',
       'ST_PRIPAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       64,
       25,
       'SUBCODSAC',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       120,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Nome Sub-Cdigo SAC',
       'Nome para sub-cdigo livre do SAC',
       '',
       'SUBCODSAC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5480,
       1,
       'SUBSTT_CONSFI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'ST consfi contr fora',
       'ST consfi contr fora',
       '',
       'SUBSTT_CONSFI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       3174,
       1,
       'SUGERE_SERVICOS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Sug serv pr-venda?',
       'Sugere servios na pr-venda',
       '',
       'SUGERE_SERVICOS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3390,
       1,
       'SUP_APROVA_RESTRICAO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Pedir superv p/ Orc.',
       'Pedir supervisor para oramentos com restrio mesmo em aprovao?',
       '',
       'SUP_APROVA_RESTRICAO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '02',
       2304,
       2,
       'TAMANHO_OBSERVACAO',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'N',
       'F',
       'Tam. Obs. Oramento',
       'Tamamnho Observao Oramento',
       'DSER.CODSER = CFG.TAMANHO_OBSERVACAO',
       'TAMANHO_OBSERVACAO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7410,
       2,
       'TAMCODLOTE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Tamanho Cdigo Lote',
       'Tamanho do Cdigo de Barras do Lote',
       '',
       'TAMCODLOTE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3980,
       7,
       'TAXA_TEF_NO_PRECO',
       'F',
       '',
       3,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Tx TEF Embutid Preo',
       'Taxa de TEF Embutida no Preo',
       '',
       'TAXA_TEF_NO_PRECO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4100,
       12,
       'TAXCRE_PREATEND',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       'N',
       'F',
       'Tx Ct Crd. Pr At.',
       'Taxa do carto de crdito do pr-atendimento',
       '',
       'TAXCRE_PREATEND',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4110,
       12,
       'TAXDEB_PREATEND',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       'N',
       'F',
       'Tx Ct Db. Pr At.',
       'Taxa do carto de dbito do pr-atendimento',
       '',
       'TAXDEB_PREATEND',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       157,
       7,
       'TAXFIN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Taxa Financeira',
       'Taxa Financeira',
       '',
       'TAXFIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '06',
       20,
       8,
       'TAXMES',
       'F',
       '',
       2,
       0,
       'CFG ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CFG',
       'T',
       '',
       'F',
       'Taxa Ms Corr.Monet.',
       'Taxa mensal de correo monetria',
       '',
       'TAXMES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3730,
       5,
       'TIPCCC_PMI',
       'G',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       'N',
       'F',
       'Tipo Conta PM',
       'Tipo de Conta do Cliente Policia Militar',
       'DCCC.CODTAB = CFG.TIPCCC_PMI',
       'TIPCCC_PMI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       3790,
       5,
       'TIPCCC_RAT',
       'N',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       'N',
       '',
       'Conta para Fat. RAT',
       'Conta para Faturamento de RAT',
       'DCCC.CODTAB(+) = CFG.TIPCCC_RAT',
       'TIPCCC_RAT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       3184,
       1,
       'TIPCTA_CARTOES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Conta Cartes',
       'Tipo Conta Cartes',
       '',
       'TIPCTA_CARTOES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       3194,
       1,
       'TIPCTA_CHEQUES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Conta Cheques',
       'Tipo Conta Cheques',
       '',
       'TIPCTA_CHEQUES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       3204,
       1,
       'TIPCTA_CONTAS_A_REC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Conta a receber',
       'Tipo Conta a receber',
       '',
       'TIPCTA_CONTAS_A_REC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1144,
       1,
       'TIPCTA_DES_CON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta Desc.Con.',
       'Tipo Conta Descontos Concebidos',
       '',
       'TIPCTA_DES_CON',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1154,
       1,
       'TIPCTA_DES_OBT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta Desc.Obt.',
       'Tipo Conta Descontos Obtidos',
       '',
       'TIPCTA_DES_OBT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3400,
       1,
       'TIPCTA_ECF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tip con cad aut ECF?',
       'Tipo de conta no cadastro automtico de ECF',
       '',
       'TIPCTA_ECF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1164,
       1,
       'TIPCTA_FOR_PAG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta For.Pagos',
       'Tipo Conta Fornecedores Pagos',
       '',
       'TIPCTA_FOR_PAG',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1174,
       1,
       'TIPCTA_FRE_MER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta Fre. Mer.',
       'Tipo Conta Frete Mercadorias',
       '',
       'TIPCTA_FRE_MER',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1184,
       1,
       'TIPCTA_FRE_PAG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta Fre. Pago',
       'Tipo Conta Frete Pagos',
       '',
       'TIPCTA_FRE_PAG',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       158,
       1,
       'TIPCTA_GER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Conta Gerencial',
       'Tipo Conta Gerencial',
       '',
       'TIPCTA_GER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1194,
       1,
       'TIPCTA_JUR_PAG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta Jur. Pago',
       'Tipo Conta Juros Pagos',
       '',
       'TIPCTA_JUR_PAG',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1204,
       1,
       'TIPCTA_JUR_REC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta Jur. Rec.',
       'Tipo Conta Juros Recebidos',
       '',
       'TIPCTA_JUR_REC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1214,
       1,
       'TIPCTA_MER_REV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta Mer. Rev.',
       'Tipo Conta Mercadorias Revenda',
       '',
       'TIPCTA_MER_REV',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       3214,
       1,
       'TIPCTA_RENEGOCIACOES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Conta Renegocia',
       'Tipo Conta Renegociaes',
       '',
       'TIPCTA_RENEGOCIACOES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       3224,
       1,
       'TIPCTA_RENEGOCIADAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tip Conta Renegociad',
       'Tipo Conta Renegociadas',
       '',
       'TIPCTA_RENEGOCIADAS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1224,
       1,
       'TIPCTA_TAX_PRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta Tax. Pr',
       'Tipo Conta Taxa Pr-Desconto',
       '',
       'TIPCTA_TAX_PRE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1234,
       1,
       'TIPCTA_TIT_PAG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta Tt. Pago',
       'Tipo Conta Ttulos a pagar',
       '',
       'TIPCTA_TIT_PAG',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1244,
       1,
       'TIPCTA_TIT_REC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta Tt. Rec.',
       'Tipo Conta Ttulos a Receber',
       '',
       'TIPCTA_TIT_REC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       77,
       1,
       'TIPCTA_TRN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Conta Trnsito',
       'Tipo Conta Trnsito',
       '',
       'TIPCTA_TRN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7170,
       1,
       'TIPDIA_ELASTICIDADE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo Dia Elastic',
       'Dias que Sero Considerados no Clculo da Elasticidade do Preo',
       '',
       'TIPDIA_ELASTICIDADE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7130,
       1,
       'TIPDIA_FLUXO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo Dia Fluxo',
       'Dias que Sero Considerados na Projeo do Fluxo Financeiro',
       '',
       'TIPDIA_FLUXO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7240,
       1,
       'TIPDIA_VDU_PP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo Dia VDU PP',
       'Dias que Sero Considerados para Mdia Vendas no Clc. Ponto de Pedido',
       '',
       'TIPDIA_VDU_PP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       159,
       1,
       'TIPFAR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Famcias e Drogarias',
       'Farmcias e Drogarias',
       '',
       'TIPFAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4720,
       5,
       'TIPLAN_INS',
       'S',
       'DLAN',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DLAN.DESLAN',
       'V',
       '',
       '',
       'N',
       'F',
       'Tipo Lan. Insumo',
       'Tipo de Lanamento para Insumo',
       'DLAN.CODTAB = CFG.TIPLAN_INS',
       'TIPLAN_INS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4730,
       5,
       'TIPLAN_PPR',
       'S',
       'DLAN',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DLAN.DESLAN',
       'V',
       '',
       '',
       'N',
       'F',
       'Tipo Lan. Produo ',
       'Tipo de Lanamento para Produo Prpria',
       'DLAN.CODTAB = CFG.TIPLAN_PPR',
       'TIPLAN_PPR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       3234,
       1,
       'TIPO_CTR_VENDA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo CTR venda',
       'Tipo CTR venda',
       '',
       'TIPO_CTR_VENDA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       160,
       1,
       'TIPPOS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Postos Combustveis?',
       'Postos de Combustveis',
       '',
       'TIPPOS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5060,
       5,
       'TIPRTT_AGENC',
       'S',
       'DRTT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DRTT.DESRTT',
       'V',
       '',
       '',
       '9',
       'F',
       'Tip Rec Agenciamento',
       'Tipo de Recebimento para Boleto de Agenciamento de Cargas',
       'DRTT.CODTAB(+) = CFG.TIPRTT_AGENC',
       'TIPRTT_AGENC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5070,
       5,
       'TIPRTT_ESTAC',
       'S',
       'DRTT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DRTT.DESRTT',
       'V',
       '',
       '',
       '9',
       'F',
       'Tip Rec Estacionamto',
       'Tipo de Recebimento para Boleto de Estacionamento',
       'DRTT.CODTAB(+) = CFG.TIPRTT_ESTAC',
       'TIPRTT_ESTAC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7160,
       5,
       'TIPRTT_RCEL',
       'F',
       'DRTT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DRTT.DESRTT',
       'V',
       '',
       '',
       'N',
       '',
       'Rec. Recarga Celular',
       'Tipo de Recebimento para Recarga Celular',
       'DRTT.CODTAB(+) = CFG.TIPRTT_RCEL',
       'TIPRTT_RCEL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7590,
       5,
       'TIPRTT_VGAS',
       'G',
       'DRTT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DRTT.DESRTT',
       'V',
       '',
       '',
       'N',
       '',
       'Rec. Vale Gs',
       'Tipo de Recebimento para Vale Gs',
       'DRTT.CODTAB(+) = CFG.TIPRTT_VGAS',
       'TIPRTT_VGAS',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7600,
       5,
       'TIPRTT_VPRE',
       'G',
       'DRTT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DRTT.DESRTT',
       'V',
       '',
       '',
       'N',
       '',
       'Rec. Vale Presente',
       'Tipo de Recebimento para Vale Presente',
       'DRTT.CODTAB(+) = CFG.TIPRTT_VPRE',
       'TIPRTT_VPRE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1254,
       1,
       'TIPSOFT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tipo Software?',
       'Tipo Software',
       '',
       'TIPSOFT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2724,
       5,
       'TIPSRV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tpo Servio',
       'Tipo Servio',
       '',
       'TIPSRV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7420,
       1,
       'TIPSUGPRO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Tipo sug. produtos',
       'Tipo de sugesto de produtos',
       '',
       'TIPSUGPRO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5510,
       40,
       'TOTALLECBASE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Base URL',
       'Base URL',
       '',
       'TOTALLECBASE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5520,
       40,
       'TOTALLECHOST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Host',
       'Host',
       '',
       'TOTALLECHOST',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5530,
       40,
       'TOTALLECPORT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Porta',
       'Porta',
       '',
       'TOTALLECPORT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       3410,
       5,
       'TRANSFER_CODCFO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'CFOP via transf.',
       'Cdigo CFOP da entrada via transferncia',
       '',
       'TRANSFER_CODCFO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7800,
       5,
       'TRANSFER_ICM_NAT',
       'G',
       'DNAT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DNAT.NATURE',
       'V',
       '',
       '',
       'N',
       '',
       'Nat. Transf. ICMS',
       'Natureza Padro para Transferncia de Saldo Credor de ICMS',
       'DNAT.CODTAB(+) = CFG.TRANSFER_ICM_NAT',
       'TRANSFER_ICM_NAT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2654,
       5,
       'TRANSFER_NAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Transfer. Natureza',
       'Transfer. Natureza',
       '',
       'TRANSFER_NAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7810,
       5,
       'TRANSFER_NATCOL',
       'G',
       'DNAT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DNAT.NATURE',
       'V',
       '',
       '',
       'N',
       '',
       'Nat.Transf. Coligada',
       'Natureza para tranferncia entre filiais coligadas',
       'DNAT.CODTAB(+) = CFG.TRANSFER_NATCOL',
       'TRANSFER_NATCOL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2664,
       2,
       'TRANSFER_SER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Transfer. Srie',
       'Transfer. Srie',
       '',
       'TRANSFER_SER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7820,
       2,
       'TRANSFER_SERCOL',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       '',
       'Ser.Transf. Coligada',
       'Srie para transferncia entre filiais coligadas',
       'DSER.CODSER(+) = CFG.TRANSFER_SERCOL',
       'TRANSFER_SERCOL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5760,
       1,
       'TRANSPICM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Transp ICMS?',
       'Considerar transporte de mercadorias para clculo de ICMS?',
       '',
       'TRANSPICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1264,
       1,
       'TRIBUT_REIMP_CF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Reimp. Cupom Fiscal?',
       'Tributa Reimpresso Cupom Fiscal',
       '',
       'TRIBUT_REIMP_CF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3990,
       1,
       'TROCO_TEF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Aceita Troco Oper.',
       'Aceita Troco Sobre Pperaes de TEF',
       '',
       'TROCO_TEF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       1834,
       3,
       'ULTSAC_CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'ltimo Cd. Usurio',
       'ltimo Cdigo Usuriio SAC',
       '',
       'ULTSAC_CODUSU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       1844,
       3,
       'ULTSAC_FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'ltima FilialUsurio',
       'ltima Filial do Usurio do SAC',
       '',
       'ULTSAC_FILUSU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       1974,
       1,
       'UNE_NOME_SOBRENOME',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Unio Nome+Sobrenome',
       'Unio Nome+Sobrenome?',
       '',
       'UNE_NOME_SOBRENOME',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       74,
       1,
       'UNICO',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'nico',
       'nico',
       '',
       'UNICO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       161,
       1,
       'USADOC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Documento?',
       'Usa Documento?',
       '',
       'USADOC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5580,
       1,
       'USA_CTA_TRANSITO_TRANSF_IDENT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa conta trnsito t',
       'Utiliza conta em trnsito na transferncia identificada',
       '',
       'USA_CTA_TRANSITO_TRANSF_IDENT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       6010,
       1,
       'USA_DCAI_0',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Usa sang/ref padro',
       'Usa sangria/reforo padro no caixa',
       '',
       'USA_DCAI_0',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       2874,
       1,
       'USA_PERC_HORFAL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Perc horas falt tar?',
       'Usa percentual de horas faltantes para tarefas?',
       '',
       'USA_PERC_HORFAL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2514,
       1,
       'USA_PLACA_ORCAMENTO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Placa Oramento',
       'Usa Placa Oramento',
       '',
       'USA_PLACA_ORCAMENTO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4030,
       1,
       'USA_PREATENDIMENTO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Pr-atendimento ',
       'Usa Pr-atendimento para clculo de combustvel',
       '',
       'USA_PREATENDIMENTO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '02',
       2324,
       1,
       'USA_RENEGOCIACAO_SAC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Renegociao SAC',
       'Usa Renegociao no SAC?',
       '',
       'USA_RENEGOCIACAO_SAC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '06',
       2694,
       1,
       'USA_SIMULACAO_SAC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Simulao SAC?',
       'Usa Simulao SAC?',
       '',
       'USA_SIMULACAO_SAC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4430,
       1,
       'USA_VM_DECISOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Usa VM para Decisor?',
       'Materializar views para o Totali Decisor?',
       '',
       'USA_VM_DECISOR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       162,
       1,
       'USOSTD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao Documentos',
       'Usa situao de Documentos',
       '',
       'USOSTD',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1894,
       1,
       'VALIDA_ESTOQUE_EXT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Valida Estoque?',
       'Valida Estoque?',
       '',
       'VALIDA_ESTOQUE_EXT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       3830,
       1,
       'VALIDA_ESTOQUE_ORDER',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Validar estoque neg.',
       'Validar estoque negativo no Totali Order',
       '',
       'VALIDA_ESTOQUE_ORDER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1274,
       1,
       'VALIDA_NUMDOC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Valida Nm.Documento',
       'Valida Nmero do Docuemnto',
       '',
       'VALIDA_NUMDOC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4770,
       1,
       'VALIDA_PARC_CK',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Validar Parceiro',
       'Validar Parceiro no Checkout',
       '',
       'VALIDA_PARC_CK',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '10',
       3244,
       10,
       'VALORTOLERANCIA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tolern baixa Titulo',
       'Tolerncia para baixa de ttulos abaixo do valor previsto',
       '',
       'VALORTOLERANCIA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '02',
       2354,
       1,
       'VALORTRANSFERENCIA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Valor Transferncia',
       'Valor Transferncia',
       '',
       'VALORTRANSFERENCIA',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       6020,
       1,
       'VALOR_AQUISICAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Valor Aquisio',
       'Valor Utilizado para Aquisio de Produtos',
       '',
       'VALOR_AQUISICAO
',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5920,
       12,
       'VALOR_BON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '9',
       'F',
       'Valor por bnus',
       'Valor por bnus',
       '',
       'VALOR_BON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       7720,
       1,
       'VARCUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Variao de Custo',
       'Tipo de validao da Variao de Custo',
       '',
       'VARCUS',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5630,
       5,
       'VARIACAO_CUSTO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Variao Custo',
       'Variao de Custo para Compra (em %)',
       '',
       'VARIACAO_CUSTO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '02',
       30,
       44,
       'VC_CLIENTE',
       'A',
       '',
       0,
       0,
       'CFG ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Descrio Cliente',
       'Cliente',
       '',
       'VC_CLIENTE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '02',
       20,
       6,
       'VC_CODCLI',
       'A',
       '',
       0,
       0,
       'CFG ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CFG',
       'F',
       'N',
       'F',
       'Cdigo Cliente',
       'Cdigo do Cliente',
       '',
       'VC_CODCLI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '02',
       50,
       3,
       'VC_CODPGT',
       'A',
       '',
       0,
       0,
       'CFG ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CFG',
       'F',
       'N',
       'F',
       'Cdigo do Plano',
       'Cdigo do Plano',
       '',
       'VC_CODPGT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '02',
       10,
       3,
       'VC_FILCLI',
       'A',
       '',
       0,
       0,
       'CFG ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CFG',
       'F',
       'N',
       'F',
       'Filial do Cliente',
       'Filial do cliente',
       '',
       'VC_FILCLI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '02',
       40,
       3,
       'VC_FILPGT',
       'A',
       '',
       0,
       0,
       'CFG ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CFG',
       'F',
       'N',
       'F',
       'Filial PGTO',
       'Filial do cdigo Pagamento',
       '',
       'VC_FILPGT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '02',
       60,
       15,
       'VC_PLANO',
       'A',
       '',
       0,
       0,
       'CFG ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CFG',
       'F',
       'A',
       'F',
       'Plano',
       'Plano',
       '',
       'VC_PLANO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '02',
       70,
       2,
       'VC_SERIE',
       'A',
       'DSER',
       0,
       0,
       'CFG ',
       70,
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       'CFG',
       'F',
       'A',
       'F',
       'Srie',
       'Srie',
       'CFG.VC_SERIE = DSER.CODSER (+)',
       'VC_SERIE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5970,
       4000,
       'VDD_CKPATOTVEN',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Frm. Pont Ven. Vdd',
       'Frmula de pontuao por venda (vendedor)',
       '',
       'RTF2TXT(VDD_CKPATOTVEN)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5960,
       4000,
       'VDD_CKPAVENITE',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Frm. Pont Item Vdd',
       'Frmula de pontuao por item de venda (vendedor)',
       '',
       'RTF2TXT(VDD_CKPAVENITE)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '16',
       6010,
       12,
       'VDD_QTDBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Qtd. bnus vend',
       'Qtd de bnus por valor acumulado de venda do vendedor',
       '',
       'VDD_QTDBON',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '16',
       6000,
       12,
       'VDD_VLRVEN_BON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Vl. venda bnus vdd',
       'Valor acumulado de venda para clculo de bnus do vendedor',
       '',
       'VDD_VLRVEN_BON',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '99',
       5720,
       5,
       'VEI_ORC',
       'S',
       'DVEI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DVEI.DESVEI',
       'V',
       '',
       '',
       'A',
       'F',
       'Veculo Oramento',
       'Veculo Referncia para Oramento',
       'CFG.VEI_ORC = DVEI.CODTAB(+)',
       'VEI_ORC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4000,
       1,
       'VENDA_CC_E_OUTROS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'C/C + outros meios',
       'Em Vendas com C/C Aceita Outros Meios de Pagamento Misturadas',
       '',
       'VENDA_CC_E_OUTROS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       5590,
       1,
       'VENDA_ESTRANGEIRO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Venda para Clientes ',
       'Venda para Clientes no Estrangeiro',
       '',
       'VENDA_ESTRANGEIRO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1284,
       1,
       'VENDE_DESATIVADOS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Vende Desativados?',
       'Vende Desativados(Vendas Ckeckout)',
       '',
       'VENDE_DESATIVADOS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       2524,
       1,
       'VINCULO_PLACA_ORCAMENTO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Vnculo Placa Oram.',
       'Vnculo Placa Oram.',
       '',
       'VINCULO_PLACA_ORCAMENTO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       163,
       1,
       'VLDCLIEXT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Valida Cliente Exter',
       'Valida Cliente Externo',
       '',
       'VLDCLIEXT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       1294,
       1,
       'VLDESTEXT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Estoque Externo?',
       'Usa estoque externo mantido por outro sistema',
       '',
       'VLDESTEXT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       164,
       3,
       'VLDORC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Valida Oramento',
       'Valida Oramento',
       '',
       'VLDORC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       '--',
       4200,
       12,
       'VLRMIN_WOR_PROP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Mnimo Prop.',
       'Valor mnimo para propostas a prazo',
       '',
       'VLRMIN_WOR_PROP',
       'F',
       'D' FROM DUAL
);

/*-- SEQ 6849 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CFG ',
       'ACAO_DEVOLUCAO',
       0,
       '0',
       'Aceita qualquer meio de PGTO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'ACAO_DEVOLUCAO',
       0,
       '1',
       'Obrigar uso de c/c',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'ACAO_DEVOLUCAO',
       0,
       '2',
       'Sugerir uso de c/c',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'BASE_MARKUP',
       0,
       '1',
       'Custo Mdio + Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'BASE_MARKUP',
       0,
       '2',
       'Custo de Reposio + Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'BASE_MARKUP',
       0,
       '3',
       'Preo de Compra + Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'BASE_MARKUP',
       0,
       '4',
       'Preo de Compra + IPI + Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'BASE_MARKUP',
       0,
       'B',
       'Preo de Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'BASE_MARKUP',
       0,
       'C',
       'Preo de Compra + IPI',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'BASE_MARKUP',
       0,
       'I',
       'Custo de Reposio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'BASE_MARKUP',
       0,
       'R',
       'Custo Mdio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CFG_PARCEIRO',
       1,
       ' ',
       'Totali',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CFG_PARCEIRO',
       2,
       ' ',
       'Unisys',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CFG_PARCEIRO',
       3,
       ' ',
       'Vikam',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CFG_PARCEIRO',
       4,
       ' ',
       'Consistem',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CFG_PARCEIRO',
       5,
       ' ',
       'Intersys',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CFG_PARCEIRO',
       6,
       ' ',
       'Consistem + Intersys',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CFG_PARCEIRO',
       7,
       ' ',
       'Senior',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CK4G_REGRA_ATUALIZACAO',
       0,
       'C',
       'Somente Crticas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CK4G_REGRA_ATUALIZACAO',
       0,
       'N',
       'Nunca',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CK4G_REGRA_ATUALIZACAO',
       0,
       'S',
       'Sempre',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CKNEGATIVO',
       1,
       ' ',
       'No Valida',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CKNEGATIVO',
       2,
       ' ',
       'Solicitar Permisso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CKNEGATIVO',
       3,
       ' ',
       'Bloqueia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CKPAOBRCAR',
       0,
       'N',
       'No Obriga',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CKPAOBRCAR',
       0,
       'O',
       'Obriga',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CKPAOBRCAR',
       0,
       'P',
       'Opcional',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CKPRECOSUB',
       1,
       ' ',
       'Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CKPRECOSUB',
       2,
       ' ',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_BAIRRO',
       0,
       '0',
       'No consiste',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_BAIRRO',
       0,
       '1',
       'Aceita somente se cadastrado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_BAIRRO',
       0,
       '2',
       'Alerta caso no cadastrado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_CATEG1',
       0,
       'D',
       'Desejvel  (sistema alerta)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_CATEG1',
       0,
       'F',
       'Opcional(sistema no verifica)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_CATEG1',
       0,
       'T',
       'Obrigatrio (sistema exige)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_CATEG2',
       0,
       ' ',
       'Opcional(sistema no verifica)',
       TO_NUMBER(null),
       'F' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_CATEG2',
       0,
       ' ',
       'Obrigatrio (sistema exige)',
       TO_NUMBER(null),
       'T' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_CATEG2',
       0,
       ' ',
       'Desejvel  (sistema alerta)',
       TO_NUMBER(null),
       'D' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_CATEG3',
       0,
       'D',
       'Desejvel  (sistema alerta)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_CATEG3',
       0,
       'F',
       'Opcional(sistema no verifica)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_CATEG3',
       0,
       'T',
       'Obrigatrio (sistema exige)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_CODCEP',
       0,
       'D',
       'Desejvel  (sistema alerta)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_CODCEP',
       0,
       'F',
       'Opcional(sistema no verifica)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_CODCEP',
       0,
       'T',
       'Obrigatrio (sistema exige)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_CODSEX',
       0,
       'D',
       'Desejvel  (sistema alerta)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_CODSEX',
       0,
       'F',
       'Opcional(sistema no verifica)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_CODSEX',
       0,
       'T',
       'Obrigatrio (sistema exige)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_CONJUG',
       0,
       'D',
       'Desejvel  (sistema alerta)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_CONJUG',
       0,
       'F',
       'Opcional(sistema no verifica)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_CONJUG',
       0,
       'T',
       'Obrigatrio (sistema exige)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_CONTAT',
       0,
       'D',
       'Desejvel (sistema alerta)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_CONTAT',
       0,
       'F',
       'Opcional(sistema no verifica)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_CONTAT',
       0,
       'T',
       'Obrigatrio (sistema exige)
',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_DATNAS',
       0,
       'D',
       'Desejvel  (sistema alerta)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_DATNAS',
       0,
       'F',
       'Opcional(sistema no verifica)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_DATNAS',
       0,
       'T',
       'Obrigatrio (sistema exige)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_DOCCON',
       0,
       'D',
       'Desejvel  (sistema alerta)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_DOCCON',
       0,
       'F',
       'Opcional(sistema no verifica)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_DOCCON',
       0,
       'T',
       'Obrigatrio (sistema exige)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_ENDERE',
       0,
       'D',
       'Desejvel  (sistema alerta)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_ENDERE',
       0,
       'F',
       'Opcional(sistema no verifica)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_ENDERE',
       0,
       'T',
       'Obrigatrio (sistema exige)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_ESTCIV',
       0,
       'D',
       'Desejvel  (sistema alerta)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_ESTCIV',
       0,
       'F',
       'Opcional(sistema no verifica)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_ESTCIV',
       0,
       'T',
       'Obrigatrio (sistema exige)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_INSEST',
       0,
       'D',
       'Desejvel  (sistema alerta)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_INSEST',
       0,
       'F',
       'Opcional(sistema no verifica)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_INSEST',
       0,
       'T',
       'Obrigatrio (sistema exige)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_NASCON',
       0,
       'D',
       'Desejvel  (sistema alerta)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_NASCON',
       0,
       'F',
       'Opcional(sistema no verifica)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_NASCON',
       0,
       'T',
       'Obrigatrio (sistema exige)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_NOMCID',
       0,
       '0',
       'No consiste',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_NOMCID',
       0,
       '1',
       'Aceita somente se cadastrado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_NOMCID',
       0,
       '2',
       'Alerta caso no cadastrado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_NUMFON',
       0,
       'D',
       'Desejvel  (sistema alerta)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_NUMFON',
       0,
       'F',
       'Opcional(sistema no verifica)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_NUMFON',
       0,
       'T',
       'Obrigatrio (sistema exige)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_REGIAO',
       0,
       '0',
       'No pr-define pelo CEP',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_REGIAO',
       0,
       '1',
       'Pr-define CEP e aceita editar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CLI_REGIAO',
       0,
       '2',
       'Pr-define CEP  aceita editar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'COB_FORMA_REGISTRO',
       0,
       '0',
       'No gera',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'COB_FORMA_REGISTRO',
       0,
       '1',
       '1 Unico cheque ou parcela',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'COB_FORMA_REGISTRO',
       0,
       'T',
       'Todos os cheques e parcela',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CUSTO_LUCRO_MARKUP',
       0,
       '0',
       'Custo de Reposio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CUSTO_LUCRO_MARKUP',
       0,
       '1',
       'Custo de Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CUSTO_LUCRO_MARKUP',
       0,
       '2',
       'Custo Mdio Fiscal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CUSTO_LUCRO_MARKUP',
       0,
       '3',
       'Custo Mdio Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'CUSTO_LUCRO_MARKUP',
       0,
       '4',
       'Custo na Formao do Preo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'FILIAL_CONTRATO',
       0,
       ' ',
       'Oficina Software LTDA',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'FILIAL_CONTRATO',
       1,
       ' ',
       'Totali',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'GIRO_ESTOQUE',
       0,
       'A',
       'Dias loja aberta(com estoque)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'GIRO_ESTOQUE',
       0,
       'C',
       'Dias corridos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'LANVEN_REIMP_CF',
       0,
       'F',
       'No',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'LANVEN_REIMP_CF',
       0,
       'P',
       'Sim, mas em nota complementar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'LANVEN_REIMP_CF',
       0,
       'T',
       'Sim',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'OBRIGA_CODEAN',
       0,
       'D',
       'Desejvel (sistema alerta)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'OBRIGA_CODEAN',
       0,
       'F',
       'Opcional(sistema no verifica)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'OBRIGA_CODEAN',
       0,
       'T',
       'Obrigatrio (sistema exige)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'ORICRE',
       0,
       'I',
       'Internet',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'ORICRE',
       0,
       'M',
       'Mobile',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'ORICRE',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'PATIPODESCONTO',
       0,
       'F',
       'Val.calc.p/frmula s/permisso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'PATIPODESCONTO',
       0,
       'P',
       'Pelos val. "mnimo" e "mximo"',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'RATEIO_FRETE',
       0,
       'P',
       'Peso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'RATEIO_FRETE',
       0,
       'V',
       'Valor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'REGRA_CLSABC',
       0,
       ' ',
       'No Usa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'REGRA_CLSABC',
       1,
       ' ',
       'Custo x Quantidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'REGRA_CLSABC',
       2,
       ' ',
       'Nmero de Vendas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'REGRA_CLSXYZ',
       0,
       ' ',
       'No Usa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'REGRA_CLSXYZ',
       1,
       ' ',
       'Custo x Quantidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'REGRA_CLSXYZ',
       2,
       ' ',
       'Nmero de Vendas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'REGRA_CODFIS',
       1,
       ' ',
       'Chave interna da grade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'REGRA_CODFIS',
       2,
       ' ',
       'Referncia bsica do produto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'REGRA_CODFIS',
       3,
       ' ',
       'Referncia de Grade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'REGRA_CODFIS',
       4,
       ' ',
       'Cdigo externo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'REGRA_MEDIA_VENDAS',
       0,
       '1',
       'Perodo Anterior',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'REGRA_MEDIA_VENDAS',
       0,
       '2',
       'Mesmo Perodo no Ano Anterior ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'SAC_TIPREG',
       0,
       'C',
       'Carta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'SAC_TIPREG',
       0,
       'E',
       'E-mail',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'SAC_TIPREG',
       0,
       'F',
       'Fax',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'SAC_TIPREG',
       0,
       'I',
       'Sistema',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'SAC_TIPREG',
       0,
       'M',
       'Mensagem Instantnea',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'SAC_TIPREG',
       0,
       'S',
       'Site',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'SAC_TIPREG',
       0,
       'T',
       'Telefone',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'SAC_TIPREG',
       0,
       'V',
       'Verbal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'SEMESTLOTE',
       3,
       ' ',
       'Bloqueia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'SEMESTLOTE',
       1,
       ' ',
       'No Valida',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'SEMESTLOTE',
       2,
       ' ',
       'Solicitar Permisso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'SISDFE',
       0,
       ' ',
       'Totali Middleware',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_DES_CON',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_DES_CON',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_DES_CON',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_DES_OBT',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_DES_OBT',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_DES_OBT',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_FOR_PAG',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_FOR_PAG',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_FOR_PAG',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_FRE_MER',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_FRE_MER',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_FRE_MER',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_FRE_PAG',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_FRE_PAG',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_FRE_PAG',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_JUR_PAG',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_JUR_PAG',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_JUR_PAG',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_JUR_REC',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_JUR_REC',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_JUR_REC',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_MER_REV',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_MER_REV',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_MER_REV',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_TAX_PRE',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_TAX_PRE',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_TAX_PRE',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_TIT_PAG',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_TIT_PAG',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_TIT_PAG',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_TIT_REC',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_TIT_REC',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPCTA_TIT_REC',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPDIA_ELASTICIDADE',
       0,
       'A',
       'Dias com Loja Aberta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPDIA_ELASTICIDADE',
       0,
       'C',
       'Dias Corridos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPDIA_FLUXO',
       0,
       'A',
       'Dias com Loja Aberta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPDIA_FLUXO',
       0,
       'C',
       'Dias Corridos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPDIA_VDU_PP',
       0,
       'A',
       'Dias com Loja Aberta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPDIA_VDU_PP',
       0,
       'C',
       'Dias Corridos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPSUGPRO',
       0,
       ' ',
       'Sugesto Manual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPSUGPRO',
       1,
       ' ',
       'Sugesto aps cada item',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'TIPSUGPRO',
       2,
       ' ',
       'Sugesto aps fechamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'USOSTD',
       0,
       'A',
       'Ativo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'USOSTD',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'VALORTRANSFERENCIA',
       0,
       'C',
       'Preo Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'VALORTRANSFERENCIA',
       0,
       'G',
       'Custo Mdio Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'VALORTRANSFERENCIA',
       0,
       'M',
       'Custo Mdio Fiscal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'VALORTRANSFERENCIA',
       0,
       'R',
       'Reposio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'VALORTRANSFERENCIA',
       0,
       'V',
       'Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'VALOR_AQUISICAO',
       0,
       'C',
       'Preo Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'VALOR_AQUISICAO',
       0,
       'S',
       'Preo Simulado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'VARCUS',
       0,
       'C',
       'ltima Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CFG ',
       'VARCUS',
       0,
       'G',
       'Grade',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6850 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CFIL',
       TO_NUMBER(null),
       'CFIL',
       'Dados FTP Fornecedor',
       'TT_CLIXFIL',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 6851 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CFIL','--','' FROM DUAL
UNION ALL
SELECT 'CFIL','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CFIL','99','Outros' FROM DUAL
);

/*-- SEQ 6852 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'CFIL',
       '--',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Fornecedor',
       'Cdigo Fornecedor',
       '',
       'CODCLI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFIL',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Filial Fornecedor',
       'Filial Fornecedor',
       '',
       'CODFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFIL',
       '--',
       30,
       50,
       'ENDFTP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Endereo FTP',
       'Endereo FTP',
       '',
       'ENDFTP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFIL',
       '--',
       40,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Minha Filial',
       'Minha Filial',
       '',
       'FILCLI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFIL',
       '--',
       80,
       50,
       'MASNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mscara Nota Fiscal',
       'Mscara Nota Fiscal',
       '',
       'MASNOT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFIL',
       '--',
       90,
       50,
       'MASPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mscara Pedido',
       'Mscara Pedido',
       '',
       'MASPED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFIL',
       '--',
       100,
       50,
       'MASRET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mscara Retorno',
       'Mscara Retorno',
       '',
       'MASRET',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFIL',
       '--',
       50,
       20,
       'MEUCOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Meu cdigo',
       'Meu Cdigo no Fornecedor',
       '',
       'MEUCOD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFIL',
       '--',
       60,
       50,
       'SENFTP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Senha FTP',
       'Senha FTP',
       '',
       'SENFTP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CFIL',
       '--',
       70,
       50,
       'USUFTP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Usurio FTP',
       'Usurio FTP',
       '',
       'USUFTP',
       'F',
       'D' FROM DUAL
);

/*-- SEQ 6853 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CFIL',
       'CODFIL',
       0,
       ' ',
       'Filial',
       TO_NUMBER(null),
       'DFIL' FROM DUAL
UNION ALL
SELECT 'CFIL',
       'FILCLI',
       0,
       ' ',
       'Filial',
       TO_NUMBER(null),
       'DFIL' FROM DUAL
);

/*-- SEQ 6854 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CFOP',
       TO_NUMBER(null),
       'CFOP',
       'Dom. CFOPs Compras',
       'TD_CFO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CFOP.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 6855 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CFOP','--','' FROM DUAL
UNION ALL
SELECT 'CFOP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CFOP','99','Outros' FROM DUAL
);

/*-- SEQ 6856 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CFOP',
       '01',
       10,
       1,
       'CFOATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'CFOP Ativo?',
       'CFOP Ativo?',
       '',
       'CFOATI',
       'F' FROM DUAL
UNION ALL
SELECT 'CFOP',
       '01',
       80,
       3,
       'CFOCTA_FIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       'Filial',
       '',
       'CFOCTA_FIL',
       '' FROM DUAL
UNION ALL
SELECT 'CFOP',
       '01',
       90,
       10,
       'CFOCTA_SEQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       '',
       'Sequenciador Conta',
       '',
       'CFOCTA_SEQ',
       '' FROM DUAL
UNION ALL
SELECT 'CFOP',
       '01',
       100,
       1,
       'CFOCTA_TIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo da Conta',
       'Tipo da Conta',
       '',
       'CFOCTA_TIP',
       '' FROM DUAL
UNION ALL
SELECT 'CFOP',
       '01',
       120,
       6,
       'CFOFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'CFOP Sada',
       'CFOP de Sada na Nota do Fornecedor',
       '',
       'CFOFOR',
       '' FROM DUAL
UNION ALL
SELECT 'CFOP',
       '01',
       70,
       2,
       'CFOMOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Modelo da nota',
       'Modelo da nota',
       '',
       'CFOMOD',
       '' FROM DUAL
UNION ALL
SELECT 'CFOP',
       '01',
       20,
       6,
       'CODCFO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo CFOP',
       'Cdigo CFOP',
       '',
       'CODCFO',
       'F' FROM DUAL
UNION ALL
SELECT 'CFOP',
       '01',
       30,
       10,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'CFOP',
       '01',
       40,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'CFOP',
       '01',
       50,
       40,
       'DESCFO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio CFOP',
       'Descrio CFOP de Compra',
       '',
       'DESCFO',
       'F' FROM DUAL
UNION ALL
SELECT 'CFOP',
       '01',
       60,
       10,
       'EXTCFO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ext. CFOP',
       'Ext. CFOP',
       '',
       'EXTCFO',
       'F' FROM DUAL
UNION ALL
SELECT 'CFOP',
       '01',
       110,
       1,
       'MOVEST_DCFO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Movimenta Estoque?',
       'Movimenta Estoque?',
       '',
       'MOVEST_DCFO',
       '' FROM DUAL
);

/*-- SEQ 6857 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CHR ',
       TO_NUMBER(null),
       'CHR ',
       'Cheques Recebidos',
       'TT_CHR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CHR.CODFIL,CHR.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6858 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CHR ','--','' FROM DUAL
UNION ALL
SELECT 'CHR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CHR ','02','Datas' FROM DUAL
UNION ALL
SELECT 'CHR ','03','Valores' FROM DUAL
UNION ALL
SELECT 'CHR ','08','Operaes de Caixa' FROM DUAL
UNION ALL
SELECT 'CHR ','99','Outros' FROM DUAL
);

/*-- SEQ 6859 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 29373,
       'LID ',
       'CHR ',
       '01',
       '0N',
       '',
       '',
       'CHR.CODFIL (+) = LID.CODFIL AND
CHR.NUMECF (+) = LID.NUMECF AND
CHR.TRN_ID (+) = LID.TRN_ID',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29374,
       'VFOR',
       'CHR ',
       '0N',
       '01',
       '',
       '',
       'VFOR.FILCLI(+) = CHR.FILFOR AND VFOR.CODCLI(+) = CHR.SEQFOR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29375,
       'CTB ',
       'CHR ',
       '1',
       '1',
       '',
       '',
       'ctb.codbco(+) = chr.codbco and
ctb.numage(+) = chr.codage and
ctb.ctacrr(+) = chr.numcon',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29376,
       'LCHR',
       'CHR ',
       'N',
       '1',
       '',
       '',
       'CHR.CODFIL = LCHR.CODFIL AND
CHR.SEQUEN = LCHR.SEQCHE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29377,
       'CLI ',
       'CHR ',
       '1',
       '1',
       '',
       '',
       'CLI.FILCLI = CHR.FILCLI AND
CLI.CODCLI = CHR.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29378,
       'USU ',
       'CHR ',
       '1',
       'N',
       '',
       '',
       'USU.FILUSU = CHR.FILUSU AND
USU.CODUSU = CHR.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 6860 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CHR ',
       '03',
       10,
       2,
       'ALINEA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Alnea',
       'Alnea',
       '',
       'ALINEA',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '02',
       215,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'CHR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CHR',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em...',
       '',
       'TO_CHAR(CHR.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '02',
       190,
       4,
       'ANO_DATVEN',
       'A',
       '',
       0,
       0,
       'CHR ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CHR',
       '',
       'N',
       'T',
       'Ano de Data Vencto',
       'Ano de Data de vencimento do cheque (Bom
para...)',
       '',
       'TO_CHAR(CHR.DATVEN,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '02',
       160,
       4,
       'ANO_PAGAME',
       'A',
       '',
       0,
       0,
       'CHR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CHR',
       '',
       'N',
       'T',
       'Ano de Data pagto',
       'Ano de Data  e hora em que o cheque foi
pago',
       '',
       'TO_CHAR(CHR.PAGAME,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '02',
       20,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '99',
       30,
       40,
       'AUTORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Autorizao',
       'Autorizao',
       '',
       'AUTORI',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '01',
       40,
       30,
       'CDCMC7',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo CMC7 cheque',
       'Cdigo CMC7 do cheque',
       '',
       'CDCMC7',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '01',
       50,
       5,
       'CODAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Agncia',
       'Cdigo da agncia',
       '',
       'CODAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '01',
       60,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Banco',
       'Cdigo do banco',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '01',
       70,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '01',
       80,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Filial de Origem',
       'CHR.CODFIL=DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '01',
       90,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'CHR.FILUSU = USU.FILUSU(+) AND  CHR.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '02',
       330,
       7,
       'DATFIS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fiscal',
       'Data Fiscal',
       '',
       'DATFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '02',
       470,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '02',
       100,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de operao',
       'Data de operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '--',
       350,
       7,
       'DATPRE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '@',
       'F',
       'Data prevista',
       'Data prevista',
       '',
       'DATPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '02',
       340,
       7,
       'DATREA',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Realizao',
       'Data de Realizao de cheques',
       '',
       'DATREA',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '02',
       110,
       8,
       'DATVEN',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Vencto',
       'Data de vencimento do cheque (Bom para...)',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '99',
       120,
       1,
       'DUMMY',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       '',
       'Uso interno das triggers',
       '',
       'DUMMY',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '--',
       360,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exportar?',
       'Exportar?',
       '',
       'EXPORT',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '01',
       130,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '--',
       370,
       3,
       'FILDEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '--',
       380,
       1,
       'FILDIF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '--',
       390,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial do Fornecedor',
       'Filial do Fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '01',
       140,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '99',
       150,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Situao do cheque',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '--',
       400,
       1,
       'FLGFLU',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Proce p fluxo finan?',
       'Processado pelo fluxo financeiro?',
       '',
       'FLGFLU',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '02',
       210,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'CHR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CHR',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em...',
       '',
       'TO_CHAR(CHR.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '02',
       180,
       2,
       'MES_DATVEN',
       'A',
       '',
       0,
       0,
       'CHR ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CHR',
       '',
       'N',
       'T',
       'Ms de Data Vencto',
       'Ms de Data de vencimento do cheque (Bom
para...)',
       '',
       'TO_CHAR(CHR.DATVEN,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '02',
       150,
       2,
       'MES_PAGAME',
       'A',
       '',
       0,
       0,
       'CHR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CHR',
       '',
       'N',
       'T',
       'Ms data Pagto',
       'Ms de Data  e hora em que o cheque foi pago',
       '',
       'TO_CHAR(CHR.PAGAME,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '01',
       160,
       6,
       'NUMCHE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nmero',
       'Nmero do cheque',
       '',
       'NUMCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '01',
       170,
       10,
       'NUMCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Conta',
       'Nmero da conta',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '03',
       180,
       1,
       'NUMDEP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'NDepsito',
       'Nmero do Depsito',
       '',
       'NUMDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '01',
       190,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '01',
       200,
       3,
       'NUMECF',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       'F',
       'Nmero do ECF',
       'Nmero do ECF',
       'DECF.FILECF = CHR.CODFIL AND DECF.NUMECF = CHR.NUMECF',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '99',
       210,
       254,
       'OBSLOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observaes Log.',
       'Observaes Log.',
       '',
       'OBSLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '08',
       320,
       4000,
       'OPERACAOCAIXA',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Operao Caixa',
       'Operao Caixa',
       '',
       'RTF2TXT(RTRIM(SUBSTR(OPERACAOCAIXA(''CHR'',CHR.CODFIL,CHR.SEQUEN,NULL,NULL),1,50)))',
       '' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '02',
       220,
       8,
       'PAGAME',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data pagto',
       'Data  e hora em que o cheque foi pago',
       '',
       'PAGAME',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '02',
       365,
       8,
       'PAGAME_PERDAS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Pagam. Perdas',
       'Data Pagamento para perda contabil (se aberto considera hoje)',
       '',
       'COALESCE(CHR.PAGAME,AGORA())',
       '' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '99',
       230,
       7,
       'PLACAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Placa',
       'Placa do veiculo',
       '',
       'PLACAS',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '--',
       410,
       5,
       'PORORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Portador origem',
       'Portador origem',
       '',
       'PORORI',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '01',
       240,
       5,
       'PORTAD',
       'G',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       'F',
       '9',
       'F',
       'Portador',
       'Cdigo do portador',
       'DCOB.CODTAB(+) = CHR.PORTAD',
       'PORTAD',
       'T' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '99',
       250,
       10,
       'SEQCAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador de Cancelamento',
       '',
       'SEQCAN',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '--',
       420,
       10,
       'SEQDEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '--',
       430,
       6,
       'SEQFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Fornecedor',
       'Cdigo do Fornecedor',
       '',
       'SEQFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '99',
       260,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '01',
       310,
       3,
       'SERCHE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie do Cheque',
       'Srie do Cheque',
       '',
       'SERCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '01',
       270,
       1,
       'TIPCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Cobrana',
       'Tipo Cobrana',
       '',
       'TIPCOB',
       'T' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '01',
       460,
       12,
       'TRN_ID',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'ID Transao',
       'ID Transao',
       '',
       'TRN_ID',
       '' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '03',
       280,
       8,
       'VLRCHE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Cheque',
       'Valor do cheque',
       '',
       'VLRCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '03',
       290,
       12,
       'VLRDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor diferena',
       'Diferena entre valores',
       '',
       'VLRDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '03',
       300,
       12,
       'VLRORI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Origem',
       'Valor Origem',
       '',
       'VLRORI',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '03',
       310,
       12,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Valor Parcela',
       'Valor Parcela',
       '',
       '(SELECT SUM(REC.VLRPAR) FROM TT_REC REC WHERE REC.FILREC = CHR.CODFIL AND REC.SEQCHE = CHR.SEQUEN)',
       '' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '--',
       440,
       12,
       'VLRPRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor previsto',
       'Valor previsto',
       '',
       'VLRPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'CHR ',
       '03',
       450,
       12,
       'VLRTRO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Taxa Troca de Cheque',
       'Taxa Troca de Cheque',
       '',
       'VLRTRO',
       '' FROM DUAL
);

/*-- SEQ 6861 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CHR ',
       'FLGEST',
       0,
       'A',
       'A Depositar',
       280,
       ' ' FROM DUAL
UNION ALL
SELECT 'CHR ',
       'FLGEST',
       0,
       'B',
       'Cobrado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CHR ',
       'FLGEST',
       0,
       'C',
       'Compensado',
       281,
       ' ' FROM DUAL
UNION ALL
SELECT 'CHR ',
       'FLGEST',
       0,
       'D',
       'Depositado',
       282,
       ' ' FROM DUAL
UNION ALL
SELECT 'CHR ',
       'FLGEST',
       0,
       'G',
       'Depositar/Custodiar(Arquivo)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CHR ',
       'FLGEST',
       0,
       'I',
       'Incobrvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CHR ',
       'FLGEST',
       0,
       'P',
       'Pr-Descontado',
       283,
       ' ' FROM DUAL
UNION ALL
SELECT 'CHR ',
       'FLGEST',
       0,
       'R',
       'Reservado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CHR ',
       'FLGEST',
       0,
       'S',
       'Substitudo',
       285,
       ' ' FROM DUAL
UNION ALL
SELECT 'CHR ',
       'FLGEST',
       0,
       'U',
       'Custodiado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CHR ',
       'FLGEST',
       0,
       'V',
       'Devolvido',
       286,
       ' ' FROM DUAL
UNION ALL
SELECT 'CHR ',
       'FLGEST',
       0,
       'X',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CHR ',
       'TIPCOB',
       0,
       'B',
       'Bancria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CHR ',
       'TIPCOB',
       0,
       'P',
       'Padro',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6862 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CIN ',
       TO_NUMBER(null),
       'CIN ',
       'Conta Intermediria',
       'TT_CTA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'CIN.CODFIL,CIN.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6863 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CIN ','--','' FROM DUAL
);

/*-- SEQ 6864 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 11297,
       'CTB ',
       'CIN ',
       'N',
       '1',
       '',
       '',
       'CTB.FILCTA = CIN.CODFIL AND
CTB.SEQCTA = CIN.SEQUEN AND
CTB.TIPCTA = CIN.TIPCTA AND
CTB.CTACTB = CIN.USOCTA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 11298,
       'ECT ',
       'CIN ',
       '1',
       '0N',
       '',
       '',
       'ECT.CODFIL = CIN.FILECT(+) AND
ECT.SEQUEN = CIN.SEQECT(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 11299,
       'FIN ',
       'CIN ',
       'N',
       '1',
       '',
       '',
       'FIN.FILGER = CIN.CODFIL AND
FIN.SEQGER = CIN.SEQUEN AND
FIN.TIPGER = CIN.TIPCTA',
       '',
       '' FROM DUAL
);

/*-- SEQ 6865 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CIN ',
       '--',
       80,
       1,
       'APLNUM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Aplicabilidade Conta',
       'Aplicabilidade da conta ',
       '',
       'APLNUM',
       'F' FROM DUAL
UNION ALL
SELECT 'CIN ',
       '--',
       182,
       1,
       'ATUARE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Atualizao do rec?',
       'Atualizao do a receber?',
       '',
       'ATUARE',
       'F' FROM DUAL
UNION ALL
SELECT 'CIN ',
       '--',
       195,
       1,
       'ATUREA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'A receb. atualizado?',
       'A receber atualizado?',
       '',
       'ATUREA',
       'F' FROM DUAL
UNION ALL
SELECT 'CIN ',
       '--',
       18,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'CIN ',
       '--',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = CIN.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CIN ',
       '--',
       175,
       7,
       'DATARE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Data atu a receber',
       'Data atualizao do a receber',
       '',
       'DATARE',
       'F' FROM DUAL
UNION ALL
SELECT 'CIN ',
       '--',
       185,
       7,
       'DATREA',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'A receber data',
       'A receber data',
       '',
       'DATREA',
       'F' FROM DUAL
UNION ALL
SELECT 'CIN ',
       '--',
       70,
       4000,
       'ESTRUTURADECONTAS',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Estrutura~Conta',
       'Estrutura da Conta',
       '',
       'RTF2TXT(ESTRUTURADECONTAS(CIN.CODFIL,CIN.SEQUEN))',
       '' FROM DUAL
UNION ALL
SELECT 'CIN ',
       '--',
       6,
       3,
       'FILECT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       '',
       'Filial Estrutura de Contas',
       '',
       'FILECT',
       'F' FROM DUAL
UNION ALL
SELECT 'CIN ',
       '--',
       150,
       3,
       'FILNUM',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial Numerria',
       'Filial ~Numerria',
       'DFIL.CODFIL(+) = CIN.FILNUM',
       'FILNUM',
       'T' FROM DUAL
UNION ALL
SELECT 'CIN ',
       '--',
       100,
       1,
       'NIVCRI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Nvel de Criticidade',
       'Nvel de Criticidade',
       '',
       'NIVCRI',
       'F' FROM DUAL
UNION ALL
SELECT 'CIN ',
       '--',
       170,
       5,
       'ORDCTA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Ordem',
       'Ordem',
       '',
       'ORDCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'CIN ',
       '--',
       4,
       250,
       'PREFIX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Prefixo',
       'Prefixo',
       '',
       'PREFIX',
       'F' FROM DUAL
UNION ALL
SELECT 'CIN ',
       '--',
       180,
       14,
       'SALARE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Saldo a receber',
       'Saldo a receber',
       '',
       'SALARE',
       'F' FROM DUAL
UNION ALL
SELECT 'CIN ',
       '--',
       190,
       14,
       'SALREA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'A receber saldo',
       'A receber saldo',
       '',
       'SALREA',
       'F' FROM DUAL
UNION ALL
SELECT 'CIN ',
       '--',
       7,
       10,
       'SEQECT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Chave Estrutura de Contas',
       '',
       'SEQECT',
       'F' FROM DUAL
UNION ALL
SELECT 'CIN ',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CIN ',
       '--',
       8,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'CIN ',
       '--',
       3,
       250,
       'TITCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Conta',
       'Conta',
       '',
       'TITCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'CIN ',
       '--',
       5,
       10,
       'ULTDOC',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'ltimo Documento',
       'ltimo Documento',
       '',
       'ULTDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'CIN ',
       '--',
       28,
       1,
       'USOCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Uso da Conta',
       'Uso da Conta',
       '',
       'USOCTA',
       'F' FROM DUAL
);

/*-- SEQ 6866 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CIN ',
       'APLNUM',
       0,
       'A',
       'Aplicaes',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CIN ',
       'APLNUM',
       0,
       'B',
       'Banco',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CIN ',
       'APLNUM',
       0,
       'C',
       'Caixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CIN ',
       'APLNUM',
       0,
       'D',
       'Diferena',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CIN ',
       'APLNUM',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CIN ',
       'APLNUM',
       0,
       'N',
       'No Definido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CIN ',
       'NIVCRI',
       0,
       ' ',
       'Baixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CIN ',
       'NIVCRI',
       1,
       ' ',
       'Mdia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CIN ',
       'NIVCRI',
       2,
       ' ',
       'Alta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CIN ',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CIN ',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CIN ',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CIN ',
       'USOCTA',
       0,
       'B',
       'Bancos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CIN ',
       'USOCTA',
       0,
       'C',
       'Cartes de Crdito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CIN ',
       'USOCTA',
       0,
       'E',
       'ECFs',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CIN ',
       'USOCTA',
       0,
       'L',
       'Limites C/C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CIN ',
       'USOCTA',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CIN ',
       'USOCTA',
       0,
       'P',
       'Portadores',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6867 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CIXF',
       TO_NUMBER(null),
       'CIXF',
       'ItemXFornec. Cotao',
       'TT_ICPXFOR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 6868 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CIXF','--','' FROM DUAL
UNION ALL
SELECT 'CIXF','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CIXF','02','Valores' FROM DUAL
UNION ALL
SELECT 'CIXF','99','Outros' FROM DUAL
);

/*-- SEQ 6869 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CIXF',
       '99',
       70,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Atualizao',
       'Data Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '02',
       310,
       12,
       'BASCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base COFINS',
       'Base COFINS',
       '',
       'BASCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '02',
       180,
       12,
       'BASICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base de ICMS',
       'Base de ICMS',
       '',
       'BASICM',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '02',
       150,
       12,
       'BASIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base de IPI',
       'Base de IPI',
       '',
       'BASIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '02',
       280,
       12,
       'BASPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base PIS',
       'Base PIS',
       '',
       'BASPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '02',
       230,
       12,
       'BASSTT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base ST',
       'Base ST',
       '',
       'BASSTT',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = CIXF.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '01',
       50,
       3,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Fornecedor',
       'Cdigo Fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '99',
       60,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '01',
       40,
       3,
       'FILFOR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Fornecedor',
       'Filial Fornecedor',
       'DFIL.CODFIL = CIXF.FILFOR',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '99',
       80,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '02',
       220,
       12,
       'ISEICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor ICMS Isento',
       'Valor ICMS Isento',
       '',
       'ISEICM',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '01',
       30,
       5,
       'NUMICP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero do Item',
       'Nmero do Item do Produto',
       '',
       'NUMICP',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '99',
       90,
       100,
       'PERPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '% Prazo de Pagamento',
       'Percentual de pagamento sobre o Prazo de Pagamento',
       '',
       'PERPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '99',
       100,
       5,
       'PRZENT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Prazo de Entrega',
       'Nmero de dias do Prazo de Entrega',
       '',
       'PRZENT',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '99',
       110,
       100,
       'PRZPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Prazo de Pagamento',
       'Nmero de dias do Prazo de Pagamento',
       '',
       'PRZPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '02',
       120,
       12,
       'QTDITE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Quantidade',
       'Quantidade',
       '',
       'QTDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '02',
       240,
       7,
       'REDSTT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% Reduo Base ST',
       '% Reduo Base ST',
       '',
       'REDSTT',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequnciador',
       'Sequnciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '02',
       320,
       7,
       'TAXCOF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% COFINS',
       '% COFINS',
       '',
       'TAXCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '02',
       200,
       7,
       'TAXICM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% ICMS',
       '% ICMS',
       '',
       'TAXICM',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '02',
       160,
       7,
       'TAXIPI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% IPI',
       '% IPI',
       '',
       'TAXIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '02',
       250,
       7,
       'TAXMVA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% MVA',
       '% MVA',
       '',
       'TAXMVA',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '02',
       290,
       7,
       'TAXPIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% PIS',
       '% PIS',
       '',
       'TAXPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '02',
       190,
       7,
       'TAXRED',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% Reduo Base ICMS',
       '% Reduo Base ICMS',
       '',
       'TAXRED',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '02',
       260,
       7,
       'TAXSTT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% ICMS ST',
       '% ICMS ST',
       '',
       'TAXSTT',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '02',
       330,
       12,
       'VLRCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor COFINS',
       'Valor COFINS',
       '',
       'VLRCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '02',
       210,
       12,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor ICMS',
       'Valor ICMS',
       '',
       'VLRICM',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '02',
       170,
       12,
       'VLRIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor IPI',
       'Valor IPI',
       '',
       'VLRIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '02',
       140,
       12,
       'VLRITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Total',
       'Valor Total',
       '',
       'VLRITE',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '02',
       300,
       12,
       'VLRPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor PIS',
       'Valor PIS',
       '',
       'VLRPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '02',
       270,
       12,
       'VLRSTT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor ST',
       'Valor ST',
       '',
       'VLRSTT',
       'F' FROM DUAL
UNION ALL
SELECT 'CIXF',
       '02',
       130,
       12,
       'VLRUNI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Unitrio',
       'Valor Unitrio',
       '',
       'VLRUNI',
       'F' FROM DUAL
);

/*-- SEQ 6870 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CIXF',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CIXF',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CIXF',
       'FLGEST',
       0,
       'R',
       'Recebido',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6871 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CLA ',
       TO_NUMBER(null),
       'CLA ',
       'Classificao',
       'TT_CLA',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CLA.CODFIL,CLA.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6872 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CLA ','--','' FROM DUAL
UNION ALL
SELECT 'CLA ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CLA ','99','Outros' FROM DUAL
);

/*-- SEQ 6873 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21249,
       'PRO ',
       'CLA ',
       'N',
       '1',
       '',
       '',
       'PRO.FILCLA = CLA.CODFIL AND PRO.SEQCLA = CLA.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 6874 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CLA ',
       '01',
       51,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN CLA.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'CLA ',
       '01',
       40,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       '' FROM DUAL
UNION ALL
SELECT 'CLA ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL = CLA.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CLA ',
       '01',
       30,
       40,
       'DESCLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Desc. Classificao',
       'Desc. Classificao',
       '',
       'DESCLA',
       '' FROM DUAL
UNION ALL
SELECT 'CLA ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'CLA ',
       '01',
       50,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN CLA.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
);

/*-- SEQ 6875 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CLI ',
       0,
       'CLI ',
       'Clientes',
       'TT_CLI',
       'T',
       '',
       'TOTALL',
       'Clientes',
       '{FILCLI;CODCLI};ATU_EM;NOMCLI;ULTNOM;DOCUME;DOCCON',
       'NUMDOC',
       'NOMCLI',
       'Cliente',
       'T',
       '',
       'CLI.FILCLI,CLI.CODCLI
CLI.NOMCLI,CLI.ULTNOM
CLI.NUMDOC',
       '' FROM DUAL
);

/*-- SEQ 6876 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CLI ','--','' FROM DUAL
UNION ALL
SELECT 'CLI ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CLI ','02','Endereo' FROM DUAL
UNION ALL
SELECT 'CLI ','03','Documentao' FROM DUAL
UNION ALL
SELECT 'CLI ','04','Juros x Descontos' FROM DUAL
UNION ALL
SELECT 'CLI ','05','Parametros para Postos de Combustivel (1)' FROM DUAL
UNION ALL
SELECT 'CLI ','06','Parametros para Postos de Combustivel (2)' FROM DUAL
UNION ALL
SELECT 'CLI ','07','Parametros para Postos de Combustivel (3)' FROM DUAL
UNION ALL
SELECT 'CLI ','08','Parametros para Postos de Combustivel (4)' FROM DUAL
UNION ALL
SELECT 'CLI ','09','Parametros para Postos de Combustivel (5)' FROM DUAL
UNION ALL
SELECT 'CLI ','10','Parametros para Postos de Combustivel (6)' FROM DUAL
UNION ALL
SELECT 'CLI ','11','Parametros para Postos de Combustivel (7)' FROM DUAL
UNION ALL
SELECT 'CLI ','13','Parametros Valor Venda Cliente' FROM DUAL
UNION ALL
SELECT 'CLI ','14','Compras' FROM DUAL
UNION ALL
SELECT 'CLI ','99','Outros' FROM DUAL
);

/*-- SEQ 6877 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 31764,
       'DCT2',
       'CLI ',
       '01',
       'N',
       '',
       '',
       'CLI.CATEG2 = DCT2.CODTAB (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31765,
       'DDES',
       'CLI ',
       '01',
       '0N',
       '',
       '',
       'CLI.TIPDES = DDES.CODTAB (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31766,
       'DDEP',
       'CLI ',
       '01',
       '0N',
       '',
       '',
       'CLI.DEPART = DDEP.CODTAB (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31767,
       'DCL1',
       'CLI ',
       '01',
       '0N',
       '',
       '',
       'CLI.CLASS1 = DCL1.CODTAB (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31768,
       'DCL2',
       'CLI ',
       '01',
       '0N',
       '',
       '',
       'CLI.CLASS2 = DCL2.CODTAB (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31769,
       'DCL3',
       'CLI ',
       '01',
       '0N',
       '',
       '',
       'CLI.CLASS3 = DCL3.CODTAB (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31770,
       'DCL4',
       'CLI ',
       '01',
       '0N',
       '',
       '',
       'CLI.CLASS4 = DCL4.CODTAB (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31771,
       'DCT1',
       'CLI ',
       '01',
       'N',
       '',
       '',
       'CLI.CATEG1 = DCT1.CODTAB (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31772,
       'DCT3',
       'CLI ',
       '01',
       'N',
       '',
       '',
       'CLI.CATEG3 = DCT3.CODTAB (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31773,
       'IND ',
       'CLI ',
       '01',
       'N',
       '',
       '',
       'CLI.FILGUI = IND.FILCLI(+) AND
CLI.CODGUI = IND.CODCLI(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31774,
       'SPC ',
       'CLI ',
       '01',
       '1',
       '',
       '',
       'SPC.FILCLI(+) = CLI.FILCLI and
SPC.CODCLI(+) = CLI.CODCLI ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31775,
       'CON ',
       'CLI ',
       '0N',
       '01',
       '',
       '',
       'CON.FILCLI(+) = CLI.FILCLI AND
CON.CODCLI(+) = CLI.CODCLI ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31776,
       'VINC',
       'CLI ',
       '01',
       '1',
       '',
       '',
       'vinc.FILVIN(+) = CLI.FILCLI AND
vinc.CODVIN(+) = CLI.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31777,
       'FAT ',
       'CLI ',
       'N',
       '1',
       '',
       '',
       'FAT.FILCLI = CLI.FILCLI AND
FAT.CODCLI = CLI.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31778,
       'CFG ',
       'CLI ',
       '1',
       '1',
       '',
       '',
       'CFG.VC_FILCLI = CLI.FILCLI AND
CFG.VC_CODCLI = CLI.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31779,
       'COM ',
       'CLI ',
       'N',
       '1',
       '',
       '',
       'COM.FILFOR = CLI.FILCLI AND
COM.CODFOR = CLI.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31780,
       'REG ',
       'CLI ',
       'N',
       '1',
       '',
       '',
       'CLI.FILCLI = REG.FILCLI AND
CLI.CODCLI = REG.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31781,
       'FCM ',
       'CLI ',
       'N',
       '1',
       '',
       '',
       'CLI.FILCLI = FCM.FILFOR AND CLI.CODCLI = FCM.CODFOR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31782,
       'USU ',
       'CLI ',
       '01',
       '1',
       '',
       '',
       'USU.FILCLI = CLI.FILCLI(+) AND
USU.CODCLI = CLI.CODCLI(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31783,
       'EDE ',
       'CLI ',
       'N',
       '1',
       '',
       '',
       'EDE.FILCLI = CLI.FILCLI AND
EDE.CODCLI = CLI.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31784,
       'VRES',
       'CLI ',
       '01',
       'N',
       '',
       '',
       'VRES.NUMDOC = CLI.NUMDOC',
       '',
       '' FROM DUAL
);

/*-- SEQ 6878 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'CLI ',
       '05',
       630,
       8,
       ':CLI.CB1_DATINI,CLI.CB1_DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data (1)',
       'Data (1)',
       '',
       ':CLI.CB1_DATINI,CLI.CB1_DATFIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '06',
       650,
       8,
       ':CLI.CB2_DATINI,CLI.CB2_DATFIM',
       'D',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data (2)',
       'Data (2)',
       '',
       ':CLI.CB2_DATINI,CLI.CB2_DATFIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '07',
       730,
       15,
       ':CLI.CB3_CODFIL',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Fil Combustivel (1)',
       'Fil Combustivel (1)',
       'CLI.:CLI.CB3_CODFIL = DFIL.CODFIL',
       ':CLI.CB3_CODFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '07',
       720,
       8,
       ':CLI.CB3_DATINI,CLI.CB3_DATFIM',
       'D',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Filial 1',
       'Data Filial 1',
       '',
       ':CLI.CB3_DATINI,CLI.CB3_DATFIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '08',
       760,
       15,
       ':CLI.CB4_CODFIL',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Fil Combustivel (2)',
       'Fil Combustivel (2)',
       'CLI.:CLI.CB4_CODFIL = DFIL.CODFIL',
       ':CLI.CB4_CODFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '08',
       750,
       8,
       ':CLI.CB4_DATINI,CLI.CB4_DATFIM',
       'D',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Filial 2',
       'Data Filial 2',
       '',
       ':CLI.CB4_DATINI,CLI.CB4_DATFIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '09',
       790,
       15,
       ':CLI.CB5_CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Fil Combustivel (3)',
       'Fil Combustivel (3)',
       'CLI.:CLI.CB5_CODFIL = DFIL.CODFIL',
       ':CLI.COMB5_CODFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '09',
       780,
       8,
       ':CLI.CB5_DATINI,CLI.CB5_DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Filial 3',
       'Data Filial 3',
       '',
       ':CLI.CB5_DATINI,CLI.CB5_DATFIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '10',
       820,
       15,
       ':CLI.CB6_CODFIL',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Fil Combustivel (4)',
       'Fil Combustivel (4)',
       'CLI.:CLI.CB6_CODFIL = DFIL.CODFIL',
       ':CLI.CB6_CODFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '10',
       810,
       8,
       ':CLI.CB6_DATINI,CLI.CB6_DATFIM',
       'D',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Filial 4',
       'Data Filial 4',
       '',
       ':CLI.CB6_DATINI,CLI.CB6_DATFIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '11',
       850,
       15,
       ':CLI.CB7_CODFIL',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Fil Combustivel (5)',
       'Fil Combustivel (5)',
       'CLI.:CLI.CB7_CODFIL = DFIL.CODFIL',
       ':CLI.CB7_CODFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '11',
       840,
       8,
       ':CLI.CB7_DATINI,CLI.CB7_DATFIM',
       'D',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Filial 5',
       'Data Filial 5',
       '',
       ':CLI.CB7_DATINI,CLI.CB7_DATFIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '13',
       1163,
       8,
       ':CLI.DFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Final',
       'Data Final',
       '',
       ':CLI.DFIM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '13',
       1162,
       8,
       ':CLI.DINI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Inicial',
       'Data Inicial',
       '',
       ':CLI.DINI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       300,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'CLI ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(CLI.ATU_EM,''YYYY'')',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       920,
       4,
       'ANO_DATA01',
       'A',
       '',
       0,
       0,
       'CLI ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 1',
       '',
       'TO_CHAR(CLI.DATA01,''YYYY'')',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       950,
       4,
       'ANO_DATA02',
       'A',
       '',
       0,
       0,
       'CLI ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 2',
       '',
       'TO_CHAR(CLI.DATA02,''YYYY'')',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1000,
       4,
       'ANO_DATA03',
       'A',
       '',
       0,
       0,
       'CLI ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 3',
       '',
       'TO_CHAR(CLI.DATA03,''YYYY'')',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       330,
       4,
       'ANO_DATNAS',
       'A',
       '',
       0,
       0,
       'CLI ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ano Nascto/Fundao',
       'Ano de Data de nascimento',
       '',
       'TO_CHAR(CLI.DATNAS,''YYYY'')',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       360,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       0,
       'CLI ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ano de Data Incluso',
       'Ano de Data de operao (cadastramento)',
       '',
       'TO_CHAR(CLI.DATOPE,''YYYY'')',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       410,
       4,
       'ANO_NASCON',
       'A',
       '',
       0,
       0,
       'CLI ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ano de Nascto Cnj./',
       'Ano de Data de nascimento do cnjuge ou contato principal',
       '',
       'TO_CHAR(CLI.NASCON,''YYYY'')',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '04',
       590,
       4,
       'ANO_ULTCOM',
       'A',
       '',
       0,
       0,
       'CLI ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ano de ltima Compra',
       'Ano de Data da ltima compra',
       '',
       'TO_CHAR(CLI.ULTCOM,''YYYY'')',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '--',
       1700,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Assinatura dos dados para PAF_ECF',
       '',
       'ASSINA',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '04',
       1510,
       8,
       'ATRASOEMABERTO',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Atraso em Aberto',
       'Atraso em Aberto',
       '',
       'ATRASOEMABERTO(CLI.FILCLI,CLI.CODCLI)',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '02',
       1150,
       1,
       'ATUCUS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Atualiza Custos?',
       'Atualiza  Custos?',
       '',
       'ATUCUS',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       280,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'CLI ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       90,
       1,
       'CALL_C',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Aceita Contato?',
       'Aceita Contato Telefnico',
       '',
       'CALL_C',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       870,
       2,
       'CATEG1',
       'S',
       'DCT1',
       0,
       20,
       'CLI ',
       10,
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'V',
       'CLI',
       'F',
       'A',
       'T',
       'Profisso/Ramo',
       'Categoria - 1',
       'CLI.CATEG1=DCT1.CODTAB (+)',
       'CATEG1',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       880,
       2,
       'CATEG2',
       'S',
       'DCT2',
       0,
       21,
       'CLI ',
       20,
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'V',
       'CLI',
       'F',
       'A',
       'T',
       'Salrio/Faturam',
       'Categoria - 2',
       'CLI.CATEG2=DCT2.CODTAB (+)',
       'CATEG2',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       890,
       2,
       'CATEG3',
       'S',
       'DCT3',
       0,
       22,
       'CLI ',
       30,
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'V',
       'CLI',
       'F',
       'A',
       'T',
       '3',
       'Categoria - 3',
       'CLI.CATEG3=DCT3.CODTAB (+)',
       'CATEG3',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1200,
       2,
       'CCCPRE',
       'S',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       'A',
       '',
       'Conta Cliente',
       'Conta corrente Cliente',
       'DCCC.CODTAB = CLI.CCCPRE (+)',
       'CCCPRE',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       170,
       8,
       'CELCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Celular Cnjuge',
       'Celular Cnjuge',
       '',
       'CELCON',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '--',
       1520,
       5,
       'CENCUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CENCUS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       250,
       9,
       'CHAVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'T',
       'Filial+Cdigo',
       'Filial+Cdigo do cliente',
       '',
       '(CLI.FILCLI||CLI.CODCLI)',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1870,
       5,
       'CLASS1',
       'S',
       'DCL1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL1.CLASS1',
       'V',
       '',
       '',
       'N',
       '',
       'Classe1 que Atua',
       'Classe1 em que Atua',
       'CLI.CLASS1 = DCL1.CODTAB (+)',
       'CLASS1',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1880,
       5,
       'CLASS2',
       'S',
       'DCL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL2.CLASS2',
       'V',
       '',
       '',
       'N',
       '',
       'Classe2 que Atua',
       'Classe2 em que Atua',
       'CLI.CLASS2 = DCL2.CODTAB (+)',
       'CLASS2',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1890,
       5,
       'CLASS3',
       'S',
       'DCL3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL3.CLASS3',
       'V',
       '',
       '',
       'N',
       '',
       'Classe3 que Atua',
       'Classe3 em que Atua',
       'CLI.CLASS3 = DCL3.CODTAB (+)',
       'CLASS3',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1900,
       5,
       'CLASS4',
       'S',
       'DCL4',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL4.CLASS4',
       'V',
       '',
       '',
       'N',
       '',
       'Classe4 que Atua',
       'Classe4 em que Atua',
       'CLI.CLASS4 = DCL4.CODTAB (+)',
       'CLASS4',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       1200,
       10,
       'CLIENTEPROJETO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cliente~do Projeto',
       'Projeto do Cliente',
       '',
       'PROJETOCLIENTE(CLI.FILCLI,CLI.CODCLI)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '--',
       1620,
       7,
       'CMSIND',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% Comisso p/ Indic.',
       '% de comisso para indicador',
       '',
       'CMSIND',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       0,
       'CLI ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '02',
       1160,
       6,
       'CODCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Codigo Reg.Cnjuge',
       'Codigo do registro do conjuge',
       '',
       'CODCON',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '--',
       2000,
       15,
       'CODCRC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODCRC',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       1660,
       15,
       'CODCRC ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Insc. Contabilista',
       'Nmero de inscrio do contabilista',
       '',
       'CODCRC ',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '--',
       1570,
       5,
       'CODCUS',
       'S',
       'DCUS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCUS.CENCUS',
       'V',
       '',
       '',
       'N',
       'F',
       'Centro de Custos',
       'Centro de Custos',
       'DCUS.CODTAB = CLI.CODCUS',
       'CODCUS',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       20,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Alternativo nico',
       '',
       'CODEXT',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1990,
       6,
       'CODFIA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo Fiador',
       'Cdigo do Fiador',
       '',
       'CODFIA',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       100,
       5,
       'CODFID',
       'S',
       'DFID',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFID.DESFID',
       'V',
       '',
       '',
       'A',
       'F',
       'Fidelizao',
       'Fidelizao',
       'CLI.CODFID = DFID.CODTAB(+)',
       'CODFID',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       2050,
       5,
       'CODFRE',
       'S',
       'DFRE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFRE.DESFRE',
       'V',
       '',
       '',
       'N',
       '',
       'Pol. Frete Padro',
       'Poltica de Frete Padro',
       'DFRE.CODTAB = CLI.CODFRE',
       'CODFRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       2060,
       5,
       'CODFRE_ENC',
       'S',
       'DFRE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFRE.DESFRE',
       'V',
       '',
       '',
       'N',
       '',
       'Pol. Frete Encom',
       'Poltica de Frete para Produtos Comercializados Somente como Encomendas',
       'DFRE.CODTAB = CLI.CODFRE_ENC',
       'CODFRE_ENC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '--',
       1580,
       6,
       'CODGUI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODGUI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       1110,
       5,
       'CODINA',
       'S',
       'DINA',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DINA.DESINA',
       'V',
       '',
       '',
       'N',
       'F',
       'Motivo Inatividade',
       'Cdigo da Inatividade',
       'DINA.CODTAB = CLI.CODINA(+)',
       'CODINA',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1640,
       7,
       'CODNAE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo CNAE',
       'Cdigo CNAE',
       '',
       'CODNAE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       1680,
       5,
       'CODPAI',
       'S',
       'DPAI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DPAI.DESPAI',
       'V',
       '',
       '',
       'N',
       'F',
       'Pas',
       'Pas de Origem',
       'DPAI.CODPAI = CLI.CODPAI',
       'CODPAI',
       'F',
       'S' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '04',
       550,
       3,
       'CODPLA',
       'A',
       'PLA ',
       0,
       24,
       'CLI ',
       60,
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       'CLI',
       'F',
       'A',
       'T',
       'Plano Pagamento',
       'Cdigo do plano padro',
       'CLI.FILPLA=PLA.FILPGT(+)  AND CLI.CODPLA=PLA.CODPGT(+)',
       'CODPLA',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       370,
       2,
       'CODSEX',
       'S',
       '',
       0,
       19,
       'CLI ',
       90,
       30,
       '',
       '',
       'D',
       'CLI',
       'F',
       'A',
       'T',
       'Sexo',
       'Cdigo de Sexo do Cliente',
       '',
       'CODSEX',
       'T',
       'S' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '--',
       1720,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       'N',
       'F',
       '',
       '',
       '',
       'CODUID',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '--',
       2010,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODUSU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '04',
       610,
       3,
       'CODVEN',
       'A',
       'USU ',
       0,
       0,
       'CLI ',
       120,
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       'CLI',
       'F',
       'A',
       'T',
       'Vendedor Padro',
       'Vendedor Padro',
       'CLI.FILVEN=USU.FILUSU(+) AND CLI.CODVEN=USU.CODUSU(+)',
       'CODVEN',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       40,
       6,
       'CODVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo Vnculo',
       'Cdigo do Vnculo',
       '',
       'CODVIN',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       2100,
       10,
       'COD_CK',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo Checkout',
       'Cdigo para cliente cadastrado no Checkout',
       '',
       'COD_CK',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       2070,
       20,
       'COD_RNTC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo RNTC',
       'Cdigo do Registro Nacional de Transportador de Carga (ANTT)',
       '',
       'COD_RNTC',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '05',
       620,
       10,
       'COMBU1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Combustivel (1)',
       'Combustivel (1)',
       '',
       'COMBUSTIVEIS_CLIENTE(CLI.FILCLI,CLI.CODCLI, :CLI.CB1_DATINI, :CLI.CB1_DATFIM,NULL)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '06',
       640,
       10,
       'COMBU2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Combustivel (2)',
       'Combustivel (2)',
       '',
       'COMBUSTIVEIS_CLIENTE(CLI.FILCLI,CLI.CODCLI, :CLI.CB2_DATINI, :CLI.CB2_DATFIM,NULL)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '07',
       710,
       8,
       'COMBUSFIL1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Combustivel Filial 1',
       'Combustivel Filial 1',
       '',
       'COMBUSTIVEIS_CLIENTE(CLI.FILCLI,CLI.CODCLI, :CLI.CB3_DATINI, :CLI.CB3_DATFIM,:CLI.CB3_CODFIL)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '08',
       740,
       8,
       'COMBUSFIL2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Combustivel Filial 2',
       'Combustivel Filial 2',
       '',
       'COMBUSTIVEIS_CLIENTE(CLI.FILCLI,CLI.CODCLI, :CLI.CB4_DATINI, :CLI.CB4_DATFIM,:CLI.CB4_CODFIL)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '09',
       770,
       8,
       'COMBUSFIL3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Combustivel Filial 3',
       'Combustivel Filial 3',
       '',
       'COMBUSTIVEIS_CLIENTE(CLI.FILCLI,CLI.CODCLI, :CLI.CB5_DATINI, :CLI.CB5_DATFIM,:CLI.CB5_CODFIL)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '10',
       800,
       8,
       'COMBUSFIL4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Combustivel Filial 4',
       'Combustivel Filial 4',
       '',
       'COMBUSTIVEIS_CLIENTE(CLI.FILCLI,CLI.CODCLI, :CLI.CB6_DATINI, :CLI.CB6_DATFIM,:CLI.CB6_CODFIL)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '11',
       830,
       8,
       'COMBUSFIL5',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Combustivel Filial 5',
       'Combustivel Filial 5',
       '',
       'COMBUSTIVEIS_CLIENTE(CLI.FILCLI,CLI.CODCLI, :CLI.CB7_DATINI, :CLI.CB7_DATFIM,:CLI.CB7_CODFIL)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '03',
       110,
       5,
       'CONBOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Boleto',
       'Boleto',
       '',
       'CONBOL',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       380,
       44,
       'CONJUG',
       'A',
       '',
       0,
       0,
       'CLI ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CLI',
       'F',
       'A',
       'T',
       'Cnjuge ou Contato',
       'Nome do Cnjuge ou do  Contato principal',
       '',
       'CONJUG',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       2190,
       1,
       'CONTRIBUINTE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Contribuinte de ICMS',
       'Contribuinte de ICMS',
       '',
       'CONTRIBUINTE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       900,
       8,
       'DATA01',
       'D',
       '',
       0,
       0,
       'CLI ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'D',
       'T',
       '',
       'Data livre - 1',
       '',
       'DATA01',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       930,
       8,
       'DATA02',
       'D',
       '',
       0,
       0,
       'CLI ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'D',
       'T',
       '',
       'Data livre - 2',
       '',
       'DATA02',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       960,
       8,
       'DATA03',
       'D',
       '',
       0,
       0,
       'CLI ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'D',
       'T',
       '',
       'Data livre - 3',
       '',
       'DATA03',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1165,
       8,
       'DATA_SUP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data ltimo Chamado',
       'Data do ltimo Registro de Chamado',
       '',
       '(select trunc(max(supcli.datreg)) from tt_sup supcli where supcli.filcli=cli.filcli and supcli.codcli=cli.codcli)',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '--',
       1740,
       8,
       'DATCRE',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Dat ult. anlize Cre',
       'Data da ltima anlise de crdito',
       '',
       'DATCRE',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       310,
       8,
       'DATNAS',
       'D',
       '',
       0,
       0,
       'CLI ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'D',
       'T',
       'Nascto/Fundao',
       'Data de nascimento',
       '',
       'DATNAS',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       340,
       8,
       'DATOPE',
       'D',
       '',
       0,
       0,
       'CLI ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'D',
       'T',
       'Data Incluso',
       'Data de operao (cadastramento)',
       '',
       'DATOPE',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       180,
       4,
       'DDCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DDD Celular Cnjuge',
       'DDD Celular Cnjuge',
       '',
       'DDCCON',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       210,
       4,
       'DDTCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'DDD Telefone Cnjuge',
       'DDD Telefone Cnjuge',
       '',
       'DDTCON',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       2140,
       1,
       'DENEGA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Cliente Denegado?',
       'Cliente Denegado?',
       '',
       'DENEGA',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1860,
       5,
       'DEPART',
       'S',
       'DDEP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDEP.DESDEP',
       'V',
       '',
       '',
       'N',
       '',
       'Dep. que Atua',
       'Departamento em que Atua',
       'CLI.DEPART = DDEP.CODTAB (+)',
       'DEPART',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '14',
       1950,
       5,
       'DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       '% Desconto/Acrsc',
       '% Desconto/Acrscimo',
       '',
       'DESCON',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1730,
       1,
       'DETTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Det.Tipo de Parceiro',
       'Detalhe do Tipo de Parceiro',
       '',
       'DETTIP',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       335,
       2,
       'DIA_DATNAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Dia Data Nascimento',
       'Dia Data de Nascimento',
       '',
       'TO_CHAR(CLI.DATNAS,''DD'')',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '04',
       1200,
       12,
       'DIVIDA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo~Dvida',
       'Saldo Dvida',
       '',
       'DIVIDA(CLI.FILCLI,CLI.CODCLI)',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '03',
       490,
       15,
       'DOCCON',
       'A',
       '',
       0,
       0,
       'CLI ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CLI',
       'F',
       'A',
       'T',
       'Doc. Cnjuge/Contato',
       'Doc. Cnjuge/Contato',
       '',
       'DOCCON',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       860,
       4000,
       'DOENCA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Doenas',
       'Doenas',
       '',
       'TRAZDOENCAS(CLI.FILCLI,CLI.CODCLI)',
       'F',
       'S' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1140,
       1,
       'DUMMY',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       '',
       'Dummy',
       '',
       'DUMMY',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       2090,
       3,
       'ECF_CK',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       '',
       'ECF Checkout',
       'ECF para cliente cadastrado no Checkout',
       'DECF.FILECF (+) = CLI.FIL_CK AND DECF.NUMECF (+) = CLI.ECF_CK',
       'ECF_CK',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       1040,
       1,
       'EDICRE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Credito manualmente?',
       'Credito definido manualmente(pode editar o limite de credito pode editar',
       '',
       'EDICRE',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1750,
       1,
       'ENTISE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Entidade ise imposto',
       'Entidade isenta de impostos',
       '',
       'ENTISE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '03',
       460,
       2,
       'ESTCIV',
       'S',
       '',
       0,
       18,
       'CLI ',
       20,
       30,
       '',
       '',
       'D',
       'CLI',
       'F',
       'A',
       'T',
       'Estado Civil',
       'Estado Civil',
       '',
       'ESTCIV',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '--',
       1530,
       1,
       'ESTRAN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Estrangeiro?',
       'Estrangeiro?',
       '',
       'ESTRAN',
       'F',
       'S' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       220,
       40,
       'E_MCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail',
       'E-mail',
       '',
       'E_MCON',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1850,
       254,
       'E_MFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail do Financeiro',
       'E-mail do Financeiro',
       '',
       'E_MFIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       240,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       0,
       'CLI ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'CLI',
       'F',
       'N',
       'T',
       'Filial Cliente',
       'Filial onde foi cadastrado o cliente',
       'CLI.FILCLI = DFIL.CODFIL (+)',
       'FILCLI',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '02',
       1170,
       3,
       'FILCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Reg.Cnjuge',
       'Filial do registro do conjuge',
       '',
       'FILCON',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '02',
       1800,
       3,
       'FILEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Fil Endere Principal',
       'Filial do Endereo Principal',
       '',
       'FILEND',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1980,
       3,
       'FILFIA',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial Fiador',
       'Filial do Fiador',
       'CLI.FILFIA = DFIL.CODFIL(+)',
       'FILFIA',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '--',
       1590,
       3,
       'FILGUI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILGUI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '04',
       540,
       3,
       'FILPLA',
       'A',
       '',
       0,
       0,
       'CLI ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'N',
       'F',
       'Filial Plano Padro',
       'Filial Plano Padro',
       '',
       'FILPLA',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       1650,
       3,
       'FILUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'A',
       '',
       'Usu. lt. alterao',
       'Usurio da ltima alterao',
       'CLI.FILUSU = USU2.FILUSU  AND CLI.CODUSU = USU2.CODUSU',
       'FILUSU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '04',
       600,
       3,
       'FILVEN',
       'A',
       '',
       0,
       0,
       'CLI ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'N',
       'F',
       '',
       'Filial do Vendedor',
       '',
       'FILVEN',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       30,
       3,
       'FILVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       30,
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Vnculo',
       '',
       'FILVIN',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       2080,
       3,
       'FIL_CK',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Checkout',
       'Filial para cliente cadastrado no Checkout',
       'DFIL.CODFIL (+) = CLI.FIL_CK',
       'FIL_CK',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '03',
       470,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       0,
       'CLI ',
       30,
       30,
       '',
       '',
       'D',
       'CLI',
       'F',
       'A',
       'T',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '02',
       440,
       20,
       'FONE_ENDERE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       'SELECT FILCLI, CODCLI, NOMCLI,
       SUBSTR((SELECT MIN(LPAD(CODFIL,3)||LPAD(TO_CHAR(NUMEND),4)||DECODE(CODDDD,NULL,NULL,''''''''''''''''''''''''''''''''(''''''''''''''''''''''''''''''''||CODDDD||'''''''''''''''''''''''''''''''')'''''''''''''''''''''''''''''''')||NUMFON)
                 FROM TT_END
                WHERE FILCLI = CLI.FILCLI
                  AND CODCLI = CLI.CODCLI
                  AND NUMFON IS NOT NULL), 8)
  FROM TT_CLI CLI
',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Telefone',
       'Telefone',
       '',
       'SUBSTR((SELECT MIN(LPAD(CODFIL,3)||LPAD(TO_CHAR(NUMEND),4)||(CASE WHEN CODDDD = NULL THEN NULL ELSE''(''||CODDDD||'')'' END)||NUMFON) FROM TT_END WHERE FILCLI = CLI.FILCLI AND CODCLI = CLI.CODCLI AND NUMFON IS NOT NULL), 8)',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1050,
       1,
       'GLOBAL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Faturamento Global',
       'Faturamento Global',
       '',
       'GLOBAL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '02',
       430,
       40,
       'HOMPGE',
       'A',
       '',
       0,
       0,
       'CLI ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CLI',
       'F',
       'A',
       'T',
       'Home Page',
       'Home Page do Cliente',
       '',
       'HOMPGE',
       'F',
       'S' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       120,
       1,
       'ICM_CF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'ICM_CF  Nota Fiscal?',
       'ICM_CF  Nota Fiscal',
       '',
       'ICM_CF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       660,
       7,
       'ID_DAT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data RG',
       'Data RG',
       '',
       'ID_DAT',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       670,
       2,
       'ID_EST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF do RG',
       'UF do RG',
       '',
       'ID_EST',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       680,
       6,
       'ID_ORG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'rgo Expeditor',
       'rgo Expeditor',
       '',
       'ID_ORG',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1010,
       2,
       'IMPRIM',
       'S',
       '',
       0,
       0,
       'CLI ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'N',
       'F',
       'Class. Interna',
       'Livre para customizao',
       '',
       'IMPRIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       2160,
       1,
       'INDEXP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Indicador Exportao',
       'Indicador de Exportao',
       '',
       'INDEXP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '03',
       480,
       15,
       'INSEST',
       'A',
       '',
       0,
       4,
       'CLI ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'CLI',
       'F',
       'A',
       'T',
       '2 Documento',
       'Inscrio Estadual ou Identidade',
       '',
       'INSEST',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1700,
       1,
       'ISECHE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Ise Tax Troca Cheque',
       'Isenta Taxa de Troca de Cheque',
       '',
       'ISECHE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       70,
       6,
       'ISENHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Senha',
       'Senha',
       '',
       'ISENHA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1600,
       1,
       'ISENTO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Revenda/Consumidor',
       'Revenda/Consumidor Final',
       '',
       'ISENTO',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '--',
       2020,
       12,
       'LIMCHE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'LIMCHE',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1690,
       12,
       'LIMCHE ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Limite do Cheque',
       'Limite Cheque s/ Consulta no Serasa p/ Cliente no Sujeito  Restries',
       '',
       'LIMCHE ',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       690,
       3,
       'LIMPAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Limpar',
       'Limpar',
       '',
       'LIMPAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '04',
       530,
       2,
       'MAIATR',
       'S',
       '',
       0,
       0,
       'CLI ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       '9',
       'T',
       'Maior atraso',
       'Maior atraso registrado',
       '',
       'MAIATR',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       2030,
       12,
       'MAXBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Qtd. mxima bnus',
       'Quantidade mxima de bnus',
       '',
       'MAXBON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '14',
       2110,
       8,
       'MEDATRPON',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Mdia Atraso Pond.',
       'Mdia de atraso no perodo ponderado',
       '',
       'MediaDiasAtrasoPonderado(CLI.FILCLI, CLI.CODCLI,:MESATR)',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '04',
       1500,
       12,
       'MEDIAATRASO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Mdia Atraso',
       'Mdia Atraso',
       '',
       '(CASE WHEN CLI.TOTPAR = 0.00 THEN 0 ELSE TRUNC(CLI.TOTATR/CLI.TOTPAR,2) END)',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '14',
       2120,
       2,
       'MESATR',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Meses venda Md atr',
       'Meses a considerar para Mdia de atraso',
       '',
       ':MESATR',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       290,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'CLI ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(CLI.ATU_EM,''MM'')',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       910,
       2,
       'MES_DATA01',
       'A',
       '',
       0,
       0,
       'CLI ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 1',
       '',
       'TO_CHAR(CLI.DATA01,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       940,
       2,
       'MES_DATA02',
       'A',
       '',
       0,
       0,
       'CLI ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 2',
       '',
       'TO_CHAR(CLI.DATA02,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       970,
       2,
       'MES_DATA03',
       'A',
       '',
       0,
       0,
       'CLI ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 3',
       '',
       'TO_CHAR(CLI.DATA03,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       320,
       2,
       'MES_DATNAS',
       'A',
       '',
       0,
       0,
       'CLI ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ms Nascto/Fundao',
       'Ms de Data de nascimento',
       '',
       'TO_CHAR(CLI.DATNAS,''MM'')',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       350,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       0,
       'CLI ',
       80,
       30,
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ms de Data Incluso',
       'Ms de Data de operao (cadastramento)',
       '',
       'TO_CHAR(CLI.DATOPE,''MM'')',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       400,
       2,
       'MES_NASCON',
       'A',
       '',
       0,
       0,
       'CLI ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ms de Nascto Cnj./',
       'Ms de Data de nascimento do cnjuge ou contato principal',
       '',
       'TO_CHAR(CLI.NASCON,''MM'')',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '04',
       580,
       2,
       'MES_ULTCOM',
       'A',
       '',
       0,
       0,
       'CLI ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ms de ltima Compra',
       'Ms de Data da ltima compra',
       '',
       'TO_CHAR(CLI.ULTCOM,''MM'')',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '--',
       1610,
       1,
       'NAODIV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'No suj.  restrio',
       'No sujeito  restrio',
       '',
       'NAODIV',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       1130,
       1,
       'NAOSPC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'No no SPC?',
       'No no SPC?',
       '',
       'NAOSPC',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       390,
       8,
       'NASCON',
       'D',
       '',
       0,
       0,
       'CLI ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'D',
       'T',
       'Nascto Cnj./Contato',
       'Data de nascimento do cnjuge ou contato principal',
       '',
       'NASCON',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       260,
       44,
       'NOMCLI',
       'A',
       '',
       0,
       0,
       'CLI ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CLI',
       'F',
       'A',
       'T',
       'Nome/Razo Social',
       'Nome do Cliente',
       '',
       'NOMCLI',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       275,
       65,
       'NOME_COMPLETO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome Completo',
       'Nome Completo',
       '',
       '(CASE WHEN CLI.FLGTIP = 0 THEN (CLI.NOMCLI || '' '' || COALESCE(CLI.ULTNOM,'''')) ELSE CLI.NOMCLI END)',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       60,
       255,
       'NOMIMG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Imagem',
       'Nome Imagem',
       '',
       'NOMIMG',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       700,
       20,
       'NOMTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Apelido',
       'Apelido',
       '',
       'NOMTRA',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '03',
       450,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       3,
       'CLI ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CLI',
       'F',
       'A',
       'T',
       'Documento (CPF/CNPJ)',
       'Nmero do Documento: CNPJ ou CPF',
       '',
       'NUMDOC',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '02',
       1820,
       4,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd Endere Principal',
       'Cdigo do Endereo Principal',
       '',
       'NUMEND',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1020,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'CLI ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CLI',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(CLI.OBSERV)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1970,
       4000,
       'OBSFOR',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       'Observao do Fornecedor',
       '',
       'RTF2TXT(OBSFOR)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       130,
       254,
       'OBSOUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'OBS. CheckOut',
       'Obervao para CheckOut',
       '',
       'OBSOUT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '14',
       1910,
       2,
       'PARPED',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Parcelas Pedido',
       'Nmero de Parcelas para Pedido',
       '',
       'PARPED',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '--',
       1540,
       1,
       'PEDELE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Pedido Eletrnico?',
       'Pedido Eletrnico?',
       '',
       'PEDELE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '14',
       1940,
       3,
       'PERIOD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Intervalo Parcelas',
       'Intervalo em Dias Entre as Parcelas',
       '',
       'PERIOD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1620,
       7,
       'PERVDD',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       '% com. p/ ven. princ',
       'Percentual de comisso para vendedor principal',
       '',
       'PERVDD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1180,
       1,
       'POREMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Porte da Empresa',
       'Porte da Empresa',
       '',
       'POREMP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '04',
       560,
       2,
       'PORPAD',
       'S',
       'DCOB',
       0,
       16,
       'CLI ',
       70,
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       'CLI',
       'F',
       'A',
       'T',
       'Portador Padro',
       'Portador padro',
       'CLI.PORPAD=DCOB.CODTAB (+)',
       'PORPAD',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       1060,
       3,
       'PP_COD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cd.Usu. Prospeco',
       'Cdigo do usurio que est prospectando
Cdigo do usurio que est pros',
       '',
       'PP_COD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       1070,
       3,
       'PP_FIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial de Prospeco',
       'Filial do usurio que est prospectando
Filial do usurio que est pros',
       '',
       'PP_FIL',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       1080,
       7,
       'PP_FIM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fim prospeco',
       'Data Final de prospeco',
       '',
       'PP_FIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       1090,
       1,
       'PP_FLG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag de Prospeco?',
       'Flag de Prospeco ',
       '',
       'PP_FLG',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       1100,
       7,
       'PP_INI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data ini. prospeco',
       'Data de inicio de prospeso',
       '',
       'PP_INI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '14',
       1920,
       2,
       'PREENT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Previso Entrega',
       'Dias para Entrega a partir do Pedido',
       '',
       'PREENT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '14',
       1930,
       3,
       'PRIPAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Primeira Parcela',
       'Dias para Primeira Parcela',
       '',
       'PRIPAR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       2130,
       1,
       'REGESP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Regime Especial?',
       'Fornecedor possui Regime Especial?',
       '',
       'REGESP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       2180,
       1,
       'REGMEI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Optante pelo MEI',
       'Optante pelo MEI?',
       '',
       'REGMEI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '--',
       1550,
       1,
       'REPASE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Repasse',
       'Repasse ser antes ou depois do valor do item',
       '',
       'REPASE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '04',
       140,
       12,
       'SALBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Bnus',
       'Bnus',
       '',
       'SALBON',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '04',
       1602,
       12,
       'SALDOCC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo C/C',
       'Saldo C/C',
       '',
       '(SELECT SUM(INT.VSALDO) FROM TT_LIM INT WHERE INT.FILCLI=CLI.FILCLI AND INT.CODCLI=CLI.CODCLI)',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       420,
       2,
       'SEXCON',
       'S',
       '',
       0,
       0,
       'CLI ',
       120,
       30,
       '',
       '',
       'D',
       'CLI',
       'F',
       'A',
       'T',
       'Sexo do Cnjuge',
       'Sexo do cnjuge',
       '',
       'SEXCON',
       'T',
       'S' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1030,
       1,
       'SIGNAT',
       'L',
       '',
       0,
       0,
       'CLI ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'CLI',
       'F',
       'A',
       'F',
       'Ativo?',
       'Ativo(T) se SIGNAT >=0 e Desativo(F) se SIGNAT < 0',
       '',
       '(CASE WHEN CLI.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       1120,
       1,
       'SIMPLE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Optante pelo Simples',
       'Optante pelo Simples?',
       '',
       'SIMPLE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1630,
       9,
       'SUFRAM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'SUFRAMA',
       'Superintendncia da Zona Franca de Manaus',
       '',
       'SUFRAM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '02',
       230,
       8,
       'TELCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Telefone do Cnjuge',
       'Telefone do Cnjuge',
       '',
       'TELCON',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '04',
       150,
       1,
       'TIPCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Cobrana',
       'Tipo Cobrana',
       '',
       'TIPCOB',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '14',
       1960,
       5,
       'TIPDES',
       'S',
       'DDES',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDES.TIPDES',
       'V',
       '',
       '',
       'N',
       '',
       'Tipo Desconto',
       'Tipo Desconto',
       'CLI.TIPDES = DDES.CODTAB (+)',
       'TIPDES',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '03',
       50,
       2,
       'TIPDOC',
       'A',
       'DDOC',
       0,
       TO_NUMBER(null),
       '',
       40,
       TO_NUMBER(null),
       '',
       'DDOC.DESDOC',
       'V',
       '',
       'F',
       'A',
       'F',
       'Tipo Documento',
       'Tipo de Documento',
       'DDOC.TIPDOC(+) = CLI.TIPDOC',
       'TIPDOC',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1190,
       1,
       'TIPEMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo da Empresa',
       'Tipo da Empresa',
       '',
       'TIPEMP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '04',
       510,
       4,
       'TOTATR',
       'G',
       '',
       0,
       0,
       'CLI ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       '9',
       'F',
       'Total de Atrasos',
       'Total de atrasos na vida do cliente',
       '',
       'TOTATR',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '04',
       520,
       4,
       'TOTPAR',
       'G',
       '',
       0,
       0,
       'CLI ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       '9',
       'F',
       'Total Geral Parcelas',
       'Total de parcelas na vida do cliente',
       '',
       'TOTPAR',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       80,
       250,
       'TRACO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Espao para Anotao',
       'Espao para Anotao',
       '',
       'LPAD(''_'',50,''_'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '04',
       570,
       8,
       'ULTCOM',
       'D',
       '',
       0,
       0,
       'CLI ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'D',
       'T',
       'ltima Compra',
       'Data da ltima compra',
       '',
       'ULTCOM',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '01',
       270,
       20,
       'ULTNOM',
       'A',
       '',
       0,
       0,
       'CLI ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CLI',
       'F',
       'A',
       'T',
       'Sobrenome/Fantasia',
       'Sobrenome ou fantasia',
       '',
       'ULTNOM',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '--',
       1560,
       1,
       'USAREF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa referncia?',
       'Usa referncia?',
       '',
       'USAREF',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       2150,
       7,
       'VALLIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Validade do Limite',
       'Validade do Limite',
       '',
       'VALLIM',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '04',
       500,
       8,
       'VALOR1',
       'F',
       '',
       2,
       0,
       'CLI ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'T',
       '9',
       'T',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'VALOR1',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       2040,
       12,
       'VENBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Vendas para bnus',
       'Vendas acumuladas para clculo de bnus',
       '',
       'VENBON',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       1160,
       1,
       'VERIFICANULL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Possui Campos Nulos',
       'Verifica existncia de campos nulos no cadastro de clientes',
       '',
       'VERIFICANULL(FILCLI, CODCLI)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '99',
       2170,
       14,
       'VLRMIN_PEDCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Vlr Mn. Pedido',
       'Valor Mnimo para Pedido de Compra',
       '',
       'VLRMIN_PEDCOM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CLI ',
       '13',
       1161,
       12,
       'VLRVENCLI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Valor Vendas',
       'Valor Vendas',
       '',
       '(SELECT SUM(VEN.VLRNOT) FROM TT_VEN VEN WHERE (VEN.FLGEST<>''C'') AND (VEN.DATHOR BETWEEN :CLI.DINI AND :CLI.DFIM) AND CLI.FILCLI=VEN.FILCLI AND CLI.CODCLI=VEN.CODCLI GROUP BY CLI.FILCLI, CLI.CODCLI)',
       '',
       'P' FROM DUAL
);

/*-- SEQ 6879 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CLI ',
       'CODSEX',
       0,
       '-',
       'Nao conhecido',
       144,
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'CODSEX',
       2,
       '-',
       'Feminino',
       146,
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'CODSEX',
       1,
       '-',
       'Masculino',
       145,
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'DENEGA',
       1,
       ' ',
       'No',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'DENEGA',
       2,
       ' ',
       'Sim',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'DENEGA',
       3,
       ' ',
       'Sim. Permitir Vendas.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'DETTIP',
       0,
       'E',
       'Governo Estadual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'DETTIP',
       0,
       'F',
       'Governo Federal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'DETTIP',
       0,
       'M',
       'Governo Municipal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'DETTIP',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'ESTCIV',
       6,
       ' ',
       'Separado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'ESTCIV',
       5,
       ' ',
       'Unio Estvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'ESTCIV',
       0,
       ' ',
       'Indefinido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'ESTCIV',
       4,
       ' ',
       'Divorciado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'ESTCIV',
       1,
       ' ',
       'Solteiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'ESTCIV',
       2,
       ' ',
       'Casado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'ESTCIV',
       3,
       ' ',
       'Viuvo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'FLGTIP',
       0,
       ' ',
       'Fisica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'FLGTIP',
       1,
       ' ',
       'Juridica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'FLGTIP',
       2,
       ' ',
       'Entidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'FLGTIP',
       3,
       ' ',
       'Especial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'FLGTIP',
       4,
       ' ',
       'M.E.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'FLGTIP',
       5,
       ' ',
       'Filial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'GLOBAL',
       0,
       'G',
       'Faturamento Global',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'GLOBAL',
       0,
       'I',
       'No faz Faturamento Global',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'INDEXP',
       0,
       'E',
       'Enviar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'INDEXP',
       0,
       'I',
       'Importao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'INDEXP',
       0,
       'N',
       'No Enviar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'ISENTO',
       0,
       'F',
       'Revenda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'ISENTO',
       0,
       'T',
       'Consumidor Final',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'POREMP',
       0,
       'M',
       'Micro-empresa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'POREMP',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'POREMP',
       0,
       'P',
       'Pequeno Porte',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'REPASE',
       0,
       '0',
       'Sem Repasse',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'REPASE',
       0,
       '1',
       'Antes',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'REPASE',
       0,
       '2',
       'Depois',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'SEXCON',
       0,
       ' ',
       'Nao Conhecido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'SEXCON',
       1,
       ' ',
       'Masculino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'SEXCON',
       2,
       ' ',
       'Feminino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'TIPCOB',
       0,
       'B',
       'Bancria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'TIPCOB',
       0,
       'P',
       'Padro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'TIPEMP',
       0,
       'L',
       'Limitada (LTDA)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'TIPEMP',
       0,
       'R',
       'Registro de Empresrio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CLI ',
       'TIPEMP',
       0,
       'S',
       'Sociedade Annima (S.A.)',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6880 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CLI2',
       TO_NUMBER(null),
       'CLI2',
       'Parceiros Simplificado',
       'TT_CLI',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CLI.FILCLI,CLI.CODCLI',
       '' FROM DUAL
);

/*-- SEQ 6881 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CLI2','--','' FROM DUAL
UNION ALL
SELECT 'CLI2','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CLI2','99','Outros' FROM DUAL
);

/*-- SEQ 6882 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CLI2',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo Parceiro',
       'Cdigo do parceiro',
       '',
       'CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 'CLI2',
       '01',
       10,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Parceiro',
       'Filial onde foi cadastrado o parceiro',
       'CLI2.FILCLI = DFIL.CODFIL',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'CLI2',
       '01',
       30,
       64,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome/Razo Social',
       'Nome/Razo Social do parceiro',
       '',
       'NOMCLI',
       '' FROM DUAL
UNION ALL
SELECT 'CLI2',
       '01',
       50,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Documento (CPF/CNPJ)',
       'Nmero do Documento: CNPJ ou CPF',
       '',
       'NUMDOC',
       '' FROM DUAL
UNION ALL
SELECT 'CLI2',
       '01',
       40,
       30,
       'ULTNOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Sobrenome/Fantasia',
       'Sobrenome/Nome Fantasia do parceiro',
       '',
       'ULTNOM',
       '' FROM DUAL
);

/*-- SEQ 6883 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CLXI',
       TO_NUMBER(null),
       'CLXI',
       'Ident. Intermediador',
       'TT_CLIXINT',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CLXI.ID_CLIXINT
CLXI.TIPINT',
       '' FROM DUAL
);

/*-- SEQ 6884 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CLXI','--','' FROM DUAL
UNION ALL
SELECT 'CLXI','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CLXI','02','Datas' FROM DUAL
UNION ALL
SELECT 'CLXI','99','Outros' FROM DUAL
);

/*-- SEQ 6885 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 36249,
       'CLI ',
       'CLXI',
       '1',
       '0N',
       '',
       '',
       'CLXI.FILCLI(+) = CLI.FILCLI AND
CLXI.CODCLI(+) = CLI.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36250,
       'DTXI',
       'CLXI',
       '1',
       '1',
       '',
       '',
       'CLXI.TIPINT = DTXI.CODTAB',
       '',
       '' FROM DUAL
);

/*-- SEQ 6886 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CLXI',
       '02',
       30,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Atualizao',
       'Data Atualizao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'CLXI',
       '01',
       50,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '.',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo Parceiro',
       'Cdigo do Parceiro',
       '. = CLXI.CODCLI',
       'CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 'CLXI',
       '01',
       70,
       100,
       'CODINT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo ID Intermed',
       'Cdigo de Identificao do Intermediador',
       '',
       'CODINT',
       '' FROM DUAL
UNION ALL
SELECT 'CLXI',
       '02',
       20,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'CLXI',
       '01',
       40,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Parceiro',
       'Filial do Parceiro',
       'DFIL.CODFIL = CLXI.FILCLI',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'CLXI',
       '01',
       10,
       10,
       'ID_CLIXINT',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'ID',
       'ID de Identificao',
       '',
       'ID_CLIXINT',
       '' FROM DUAL
UNION ALL
SELECT 'CLXI',
       '01',
       60,
       10,
       'TIPINT',
       'N',
       'DTXI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DTXI.DESTIPXINT',
       'V',
       '',
       '',
       'N',
       '',
       'Tipo Intermediao',
       'Tipo da Intermediao',
       'DTXI.CODTAB = CLXI.TIPINT',
       'TIPINT',
       'F' FROM DUAL
);

/*-- SEQ 6887 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CMP ',
       TO_NUMBER(null),
       'CMP ',
       'Componentes',
       'TT_EQP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CMP.CODFIL, CMP.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6888 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CMP ','--','' FROM DUAL
UNION ALL
SELECT 'CMP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CMP ','02','Recursividade' FROM DUAL
UNION ALL
SELECT 'CMP ','99','Outros' FROM DUAL
);

/*-- SEQ 6889 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21266,
       'CCT ',
       'CMP ',
       '1',
       'N',
       '',
       '',
       'CMP.FILCTT = CCT.FILCTT AND
CMP.CODCTT = CCT.CODCTT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21267,
       'EENT',
       'CMP ',
       '1',
       'N',
       '',
       '',
       'CMP.FILCLI = EENT.FILCLI AND
CMP.CODCLI = EENT.CODCLI AND
CMP.FILEND = EENT.CODFIL AND
CMP.NUMEND = EENT.NUMEND',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21268,
       'TEQ ',
       'CMP ',
       '1',
       'N',
       '',
       '',
       'CMP.FILTEQ = TEQ.CODFIL AND
CMP.CODTEQ = TEQ.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21265,
       'CLI ',
       'CMP ',
       '1',
       'N',
       '',
       '',
       'CMP.FILCLI = CLI.FILCLI AND
CMP.CODCLI = CLI.CODCLI',
       '',
       '' FROM DUAL
);

/*-- SEQ 6890 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CMP ',
       '99',
       70,
       6,
       'CODCLI',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'CMP ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Equipamento',
       'Filial do Equipamento',
       'DFIL.CODFIL = CMP.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CMP ',
       '99',
       140,
       8,
       'DATAQU',
       'D',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data da Aquisio',
       'Data da Aquisio',
       '',
       'DATAQU',
       'F' FROM DUAL
UNION ALL
SELECT 'CMP ',
       '99',
       110,
       8,
       'DATLIM',
       'D',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Limite',
       'Data Limite',
       '',
       'DATLIM',
       'F' FROM DUAL
UNION ALL
SELECT 'CMP ',
       '99',
       120,
       20,
       'DESEQP',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Desc. do Equipamento',
       'Descrio do Equipamento',
       '',
       'DESEQP',
       'F' FROM DUAL
UNION ALL
SELECT 'CMP ',
       '99',
       60,
       3,
       'FILCLI',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'I',
       '',
       '',
       '0',
       '',
       'Filial do Cliente',
       'Filial do Cliente',
       'DFIL.CODFIL = CMP.FILCLI',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'CMP ',
       '99',
       150,
       3,
       'FILCTT',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'I',
       '',
       '',
       '0',
       '',
       'Filial do Contrato',
       'Filial do Contrato',
       'DFIL.CODFIL = CMP.FILCTT',
       'FILCTT',
       'F' FROM DUAL
UNION ALL
SELECT 'CMP ',
       '99',
       80,
       3,
       'FILEND',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'I',
       '',
       '',
       '0',
       '',
       'Filial do Endereo',
       'Filial do Endereo',
       'DFIL.CODFIL = CMP.FILEND',
       'FILEND',
       'F' FROM DUAL
UNION ALL
SELECT 'CMP ',
       '02',
       170,
       3,
       'FILEQP',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'I',
       '',
       '',
       '0',
       '',
       'Filial Equipamento',
       'Filial do Equipamento',
       'DFIL.CODFIL = CMP.FILEQP',
       'FILEQP',
       'F' FROM DUAL
UNION ALL
SELECT 'CMP ',
       '99',
       30,
       3,
       'FILTEQ',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'I',
       '',
       '',
       '0',
       '',
       'Filial Tipo de Equip',
       'Filial do Tipo de Equipamento',
       'DFIL.CODFIL = CMP.FILTEQ',
       'FILTEQ',
       'F' FROM DUAL
UNION ALL
SELECT 'CMP ',
       '99',
       90,
       4,
       'NUMEND',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nmero do Endereo',
       'Nmero do Endereo',
       '',
       'NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT 'CMP ',
       '99',
       100,
       20,
       'NUMSER',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nmero de Srie',
       'Nmero de Srie',
       '',
       'NUMSER',
       'F' FROM DUAL
UNION ALL
SELECT 'CMP ',
       '99',
       130,
       4000,
       'OBSERV',
       '4',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(CMP.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'CMP ',
       '99',
       160,
       10,
       'SEQCTT',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo do Contrato',
       'Cdigo do Contrato',
       '',
       'SEQCTT',
       'F' FROM DUAL
UNION ALL
SELECT 'CMP ',
       '02',
       180,
       10,
       'SEQEQP',
       'A',
       'EQP ',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'EQP.',
       'I',
       '',
       '',
       '9',
       '',
       'Seq. do Equipamento',
       'Sequncia do Equipamento',
       'CMP. = CMP.SEQEQP',
       'SEQEQP',
       'F' FROM DUAL
UNION ALL
SELECT 'CMP ',
       '99',
       40,
       10,
       'SEQTEQ',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq. do Tipo Equip',
       'Sequncia do Tipo de Equipamento',
       '',
       'SEQTEQ',
       'F' FROM DUAL
UNION ALL
SELECT 'CMP ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       '',
       'Seq. do Equipamento',
       'Sequncia do Equipamento',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CMP ',
       '99',
       51,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN CMP.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'CMP ',
       '99',
       50,
       1,
       'SIGNAT',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN CMP.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL       
);

/*-- SEQ 6891 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CMS ',
       TO_NUMBER(null),
       'CMS ',
       'Comisses',
       'TV_CMS',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'CMS.FILVEN,CMS.CODVEN',
       '' FROM DUAL
);

/*-- SEQ 6892 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CMS ','01','Dados' FROM DUAL
UNION ALL
SELECT 'CMS ','10','Mltiplos Vendedores' FROM DUAL
);

/*-- SEQ 6893 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20272,
       'CLI ',
       'CMS ',
       '1',
       'N',
       '',
       '',
       'CMS.FILCLI = CLI.FILCLI and
CMS.CODCLI = CLI.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 19455,
       'REC ',
       'CMS ',
       '1',
       '1',
       '',
       '',
       'REC.CODFIL=CMS.CODFIL AND 
REC.SEQUEN=CMS.SEQUEN AND 
REC.NUMPAR=CMS.NUMPAR AND
REC.SUBPAR=CMS.SUBPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 19456,
       'PLA ',
       'CMS ',
       '1',
       'N',
       '',
       '',
       'CMS.FILPGT = PLA.FILPGT and
CMS.CODPGT = PLA.CODPGT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 19457,
       'VDD ',
       'CMS ',
       '1',
       'N',
       '',
       '',
       'CMS.FILVEN = VDD.FILUSU and
CMS.CODVEN = VDD.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45914,
       'RECP',
       'CMS ',
       '1',
       '1',
       '',
       '',
       'RECP.ORI_CODFIL=CMS.CODFIL AND
RECP.ORI_SEQUEN=CMS.SEQUEN AND
RECP.ORI_NUMPAR=CMS.NUMPAR AND
RECP.ORI_SUBPAR=CMS.SUBPAR',
       '',
       '' FROM DUAL
);

/*-- SEQ 6894 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CMS ',
       '01',
       10,
       2,
       'ANO_DATA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'T',
       'Ano de Data',
       'Ano de Data',
       '',
       'TO_CHAR(CMS.DATA,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       430,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       260,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       110,
       3,
       'CODPGT',
       'A',
       'PLA ',
       0,
       TO_NUMBER(null),
       '',
       110,
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       '',
       'F',
       'A',
       'T',
       'Plano',
       'Plano',
       'PLA.FILPGT = CMS.FILPGT and PLA.CODPGT = CMS.CODPGT',
       'CODPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       90,
       2,
       'CODSER',
       'A',
       'SER2',
       0,
       TO_NUMBER(null),
       '',
       90,
       TO_NUMBER(null),
       '',
       'SER2.CODSER',
       'V',
       '',
       'F',
       'A',
       'T',
       'Srie',
       'Srie',
       'SER2.CODSER = CMS.CODSER',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       40,
       3,
       'CODVEN',
       'A',
       'VDD ',
       0,
       TO_NUMBER(null),
       '',
       40,
       TO_NUMBER(null),
       '',
       'VDD.APEUSU',
       'V',
       '',
       'F',
       'A',
       'T',
       'Vendedor',
       'Vendedor',
       'VDD.FILUSU = CMS.FILVEN and VDD.CODUSU = CMS.CODVEN',
       'CODVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       70,
       8,
       'COMISSAO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'T',
       'Comisso',
       'Comisso',
       '',
       'COMISSAO',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       240,
       5,
       'COMSOB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Comisso',
       'Tipo de Comisso',
       '',
       'COMSOB',
       'T' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       4,
       8,
       'DATA',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'T',
       'Data',
       'Data',
       '',
       'DATA',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       310,
       8,
       'DATOPE',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Apenas Data',
       'Apenas Data',
       '',
       'TRUNC(CMS.DATA)',
       '' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       80,
       13,
       'DOCUMENTO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Documento',
       'Documento',
       '',
       'DOCUMENTO',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       420,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do Cliente',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       1,
       3,
       'FILIAL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'T',
       'Filial',
       'Filial',
       'DFIL.CODFIL = CMS.FILIAL',
       'FILIAL',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       100,
       3,
       'FILPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial do plano',
       '',
       'FILPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       30,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial do vendedor',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       26,
       1,
       'FLGPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Operao',
       'Operao
Operao',
       '',
       'FLGPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       5,
       2,
       'MES_DATA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'T',
       'Ms de Data',
       'Ms de Data',
       '',
       'TO_CHAR(CMS.DATA,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '10',
       320,
       12,
       'MV_BAS_CMS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Base de Clculo',
       'Base de Clculo - Rateada pelos Vendedores',
       '',
       'MV_BAS_CMS',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '10',
       330,
       12,
       'MV_BAS_CMS_VDP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'BC Vd. Principal',
       'Base de Clculo do Vendedor Principal (Valor Doc - Comisso Indicador)',
       '',
       'MV_BAS_CMS_VDP',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '10',
       340,
       1,
       'MV_FLG_VDP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Vendedor Principal?',
       'Vendedor Principal?',
       '',
       'MV_FLG_VDP',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '10',
       350,
       12,
       'MV_PER_CMS_IND',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% para Indicador',
       '% de Comisso para Indicador',
       '',
       'MV_PER_CMS_IND',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '10',
       360,
       12,
       'MV_PER_CMS_VDD',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% para Vendedor',
       '% de Comisso para Vendedor',
       '',
       'MV_PER_CMS_VDD',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '10',
       370,
       12,
       'MV_PER_CMS_VDP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% para Vd. Principal',
       '% de Comisso para Vendedor Principal',
       '',
       'MV_PER_CMS_VDP',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '10',
       380,
       12,
       'MV_QTD_VDD',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtd. de Vendedores',
       'Quantidade de Vendedores',
       '',
       'MV_QTD_VDD',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '10',
       390,
       12,
       'MV_VLR_CMS_IND',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor para Indicador',
       'Valor de Comisso para Indicador',
       '',
       'MV_VLR_CMS_IND',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '10',
       400,
       12,
       'MV_VLR_CMS_VDD',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor para Vendedor',
       'Valor de Comisso para Vendedor',
       '',
       'MV_VLR_CMS_VDD',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '10',
       410,
       12,
       'MV_VLR_CMS_VDP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Vd. Principal',
       'Valor de Comisso para Vendedor Principal',
       '',
       'MV_VLR_CMS_VDP',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       3,
       3,
       'NUMCODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'FILIAL',
       '' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       270,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       190,
       5,
       'PARCELA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Parcela',
       'Parcela',
       '',
       'PARCELA',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       60,
       8,
       'PERCENTUAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       '%',
       '%',
       '',
       'PERCENTUAL',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       280,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       290,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       50,
       8,
       'VALORDOC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'T',
       'Base de Clculo',
       'Base de Clculo - Valor do Documento',
       '',
       'VALORDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       300,
       12,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor da Parcela',
       'Valor da Parcela',
       '',
       'VLRPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'CMS ',
       '01',
       440,
       12,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Recebido',
       'Valor Recebido',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 6895 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CMS ',
       'COMSOB',
       8,
       ' ',
       'Markup no momento da Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CMS ',
       'COMSOB',
       6,
       ' ',
       'A receber na compensao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CMS ',
       'COMSOB',
       7,
       ' ',
       'Comisso por Markup',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CMS ',
       'COMSOB',
       5,
       ' ',
       'Recebimento na compensao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CMS ',
       'COMSOB',
       0,
       '-',
       'Lquido ao Vender',
       241,
       ' ' FROM DUAL
UNION ALL
SELECT 'CMS ',
       'COMSOB',
       1,
       '-',
       'Bruto ao Vender',
       242,
       ' ' FROM DUAL
UNION ALL
SELECT 'CMS ',
       'COMSOB',
       2,
       '-',
       'A receber no Vencimento',
       243,
       ' ' FROM DUAL
UNION ALL
SELECT 'CMS ',
       'COMSOB',
       3,
       '-',
       'Recebido no Recebimento',
       244,
       ' ' FROM DUAL
UNION ALL
SELECT 'CMS ',
       'COMSOB',
       4,
       '-',
       'A receber no Recebimento',
       245,
       ' ' FROM DUAL
UNION ALL
SELECT 'CMS ',
       'FLGPAR',
       0,
       'D',
       'Devolues',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CMS ',
       'FLGPAR',
       0,
       'E',
       'Entrada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CMS ',
       'FLGPAR',
       0,
       'P',
       'Parcela',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CMS ',
       'FLGPAR',
       0,
       'V',
       ' Vista',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6896 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CMSI',
       TO_NUMBER(null),
       'CMSI',
       'Comisso Indicadores',
       'TV_CMS_IND',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CMSI.CODFIL, CMSI.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6897 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CMSI','--','' FROM DUAL
UNION ALL
SELECT 'CMSI','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CMSI','99','Outros' FROM DUAL
);

/*-- SEQ 6898 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 18706,
       'CLI ',
       'CMSI',
       '1 ',
       'N ',
       '',
       '',
       'CLI.FILCLI = CMSI.FILGUI AND
CLI.CODCLI = CMSI.CODGUI',
       '',
       '' FROM DUAL
);

/*-- SEQ 6899 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CMSI',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial da Venda',
       'Filial da Venda',
       'DFIL.CODFIL = CMSI.CODFIL',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'CMSI',
       '99',
       20,
       6,
       'CODGUI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Cdigo do Indicador',
       'Cdigo do Indicador',
       '',
       'CODGUI',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSI',
       '99',
       30,
       12,
       'COMISSAO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor da Comisso',
       'Valor da Comisso',
       '',
       'COMISSAO',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSI',
       '99',
       40,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data e Hora da Venda',
       'Data e Hora da Venda',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSI',
       '99',
       50,
       13,
       'DOCUMENTO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento da Venda',
       'Documento da Venda',
       '',
       'DOCUMENTO',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSI',
       '99',
       18,
       3,
       'FILGUI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial do Indicador',
       'Filial do Indicador',
       'DFIL.CODFIL = CMSI.FILGUI',
       'FILGUI',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSI',
       '99',
       70,
       12,
       'PERCENTUAL',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '% de Comisso',
       '% de Comisso',
       '',
       'PERCENTUAL',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSI',
       '01',
       15,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Seq. da Venda',
       'Seq. da Venda',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSI',
       '99',
       90,
       12,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Lquido Venda',
       'Valor Lquido Venda',
       '',
       'VLRLIQ',
       'F' FROM DUAL
);

/*-- SEQ 6900 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CMSR',
       TO_NUMBER(null),
       'CMSR',
       'Comisses',
       'TT_CMS',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CMSR.CODFIL,CMSR.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6901 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CMSR','--','' FROM DUAL
UNION ALL
SELECT 'CMSR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CMSR','99','Outros' FROM DUAL
);

/*-- SEQ 6902 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 40684,
       'CLI ',
       'CMSR',
       '1',
       '1',
       '',
       '',
       'CMSR.FILCLI = CLI.FILCLI
AND CMSR.CODCLI = CLI.CODCLI
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 40685,
       'REC ',
       'CMSR',
       '01',
       'N',
       '',
       '',
       'CMSR.FILREC  = REC.CODFIL(+) AND 
CMSR.SEQREC  = REC.SEQUEN(+) AND 
CMSR.NUMPAR  = REC.NUMPAR(+) AND
CMSR.SUBPAR  = REC.SUBPAR(+)
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 95839,
       'VVND',
       'CMSR',
       '1',
       'N',
       '',
       '',
       'VVND.FILCLI = CMSR.FILCLI AND
VVND.CODCLI = CMSR.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45915,
       'RECP',
       'CMSR',
       '01',
       'N',
       '',
       '',
       'CMSR.FILREC = RECP.ORI_CODFIL(+) AND
CMSR.SEQREC = RECP.ORI_SEQUEN(+) AND
CMSR.NUMPAR = RECP.ORI_NUMPAR(+) AND
CMSR.SUBPAR = RECP.ORI_SUBPAR(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 6903 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CMSR',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSR',
       '--',
       20,
       14,
       'BASCMS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base de Cculo',
       'Base de Cculo',
       '',
       'BASCMS',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSR',
       '--',
       30,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Favorecido',
       'Favorecido (relao no metadados com TT_CLI)',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSR',
       '--',
       40,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSR',
       '--',
       50,
       5,
       'COMSOB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Comisso Sobre ',
       'Comisso Sobre ',
       '',
       'COMSOB',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSR',
       '--',
       60,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSR',
       '--',
       70,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Dt. Pgt Comisso',
       'Data de Pagamento da Comisso',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSR',
       '--',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Cliente',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSR',
       '--',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Ttulo Rec.',
       'Filial Ttulo Rec.',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSR',
       '--',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSR',
       '--',
       110,
       10,
       'NROCAN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Sequencia de Cancela',
       'Sequencia de Cancelamento',
       '',
       'NROCAN',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSR',
       '--',
       120,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Parcela p/ TT_REC',
       'Parcela Relao no metadados com TT_REC',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSR',
       '--',
       130,
       8,
       'PERCMS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Percentual de Comiss',
       'Percentual de Comisso',
       '',
       'PERCMS',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSR',
       '--',
       140,
       10,
       'SEQREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Seq. Rec.',
       'Seq. Rec.',
       '',
       'SEQREC',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSR',
       '--',
       150,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSR',
       '--',
       160,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub Parc. p/ TT_REC',
       'Sub Parcela Relao no metadados com TT_REC',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'CMSR',
       '--',
       190,
       1,
       'TIPCMS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo de comisso',
       'Tipo de comisso',
       '',
       'TIPCMS',
       'T' FROM DUAL
UNION ALL
SELECT 'CMSR',
       '--',
       170,
       12,
       'VLRCMS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor da Parcela',
       'Valor da Parcela',
       '',
       'VLRCMS',
       'F' FROM DUAL
);

/*-- SEQ 6904 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CMSR',
       'FLGEST',
       0,
       '2',
       'Autorizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CMSR',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CMSR',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CMSR',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CMSR',
       'TIPCMS',
       0,
       'I',
       'Indicador',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CMSR',
       'TIPCMS',
       0,
       'V',
       'Vendedor',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6905 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CNAB',
       TO_NUMBER(null),
       'CNAB',
       'Remessas e Retornos',
       'TV_IXT_RTB',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 6906 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CNAB','--','' FROM DUAL
UNION ALL
SELECT 'CNAB','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CNAB','99','Outros' FROM DUAL
);

/*-- SEQ 6907 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 29302,
       'TIT ',
       'CNAB',
       '1',
       '0N',
       '',
       '',
       'TIT.CODFIL = CNAB.FILTIT(+) AND
TIT.SEQUEN = CNAB.SEQTIT(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 6908 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CNAB',
       '--',
       120,
       0,
       'CODMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'CODMOV',
       '' FROM DUAL
UNION ALL
SELECT 'CNAB',
       '--',
       90,
       0,
       'CODREM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'CODREM',
       '' FROM DUAL
UNION ALL
SELECT 'CNAB',
       '--',
       100,
       8,
       'DATCRE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Crdito',
       'Data do Crdito',
       '',
       'DATCRE',
       '' FROM DUAL
UNION ALL
SELECT 'CNAB',
       '--',
       80,
       8,
       'DATMOV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Movimento',
       'Data do Movimento',
       '',
       'DATMOV',
       '' FROM DUAL
UNION ALL
SELECT 'CNAB',
       '--',
       130,
       100,
       'DESMSG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio Mensagem',
       'Descrio Mensagem',
       '',
       'DESMSG',
       '' FROM DUAL
UNION ALL
SELECT 'CNAB',
       '--',
       10,
       3,
       'FILREC',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial Parcela',
       'Filial da Parcela',
       'DFIL.CODFIL = CNAB.FILREC',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'CNAB',
       '--',
       50,
       3,
       'FILTIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       'A',
       '',
       'Filial Ttulo',
       'Filial do Ttulo',
       '',
       'FILTIT',
       '' FROM DUAL
UNION ALL
SELECT 'CNAB',
       '--',
       30,
       2,
       'PARREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '9',
       '',
       'Nmero Parcela',
       'Nmero da Parcela',
       '',
       'PARREC',
       '' FROM DUAL
UNION ALL
SELECT 'CNAB',
       '--',
       20,
       10,
       'SEQREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Sequenciador Parcela',
       'Sequenciador da Parcela',
       '',
       'SEQREC',
       '' FROM DUAL
UNION ALL
SELECT 'CNAB',
       '--',
       60,
       10,
       'SEQTIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       'A',
       '',
       'Sequenciador Ttulo',
       'Sequenciador do Ttulo',
       '',
       'SEQTIT',
       '' FROM DUAL
UNION ALL
SELECT 'CNAB',
       '--',
       40,
       2,
       'SUBREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '9',
       '',
       'Sub-Parcela',
       'Sub-Parcela',
       '',
       'SUBREC',
       '' FROM DUAL
UNION ALL
SELECT 'CNAB',
       '--',
       70,
       1,
       'TIPCNB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo Movimento',
       'Tipo do Movimento',
       '',
       'TIPCNB',
       'T' FROM DUAL
UNION ALL
SELECT 'CNAB',
       '--',
       110,
       0,
       'VLRCRE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Crdito',
       'Valor do Crdito',
       '',
       'VLRCRE',
       '' FROM DUAL
);

/*-- SEQ 6909 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CNAB',
       'TIPCNB',
       0,
       'M',
       'Remessa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CNAB',
       'TIPCNB',
       0,
       'R',
       'Retorno',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6910 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CNC ',
       TO_NUMBER(null),
       'CNC ',
       'Preos Concorrncia',
       'TT_CNC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'CNC.CODFIL,CNC.SEQUEN,CNC.CODCNC',
       '' FROM DUAL
);

/*-- SEQ 6911 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CNC ','--','' FROM DUAL
);

/*-- SEQ 6912 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 32998,
       'PRE ',
       'CNC ',
       '1 ',
       'N ',
       '',
       '',
       'CNC.CODFIL = PRE.FILPRE and
CNC.SEQUEN = PRE.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6913 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CNC ',
       '--',
       10,
       4,
       'ANO_DATANT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data Anterior',
       'Ano de Data Anterior',
       '',
       'TO_CHAR(CNC.DATANT,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CNC ',
       '--',
       50,
       4,
       'ANO_DATATU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data Atual',
       'Ano de Data Atual',
       '',
       'TO_CHAR(CNC.DATATU,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CNC ',
       '--',
       3,
       5,
       'CODCNC',
       'S',
       'DCNC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCNC.NOMCNC',
       'V',
       '',
       'F',
       '9',
       'F',
       'Concorrncia',
       'Concorrncia',
       'CNC.CODCNC = DCNC.CODTAB',
       'CODCNC',
       'F' FROM DUAL
UNION ALL
SELECT 'CNC ',
       '--',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial',
       'Cdigo da filial origem da tabela de preo',
       'DFIL.CODFIL = CNC.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CNC ',
       '--',
       4,
       8,
       'DATANT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Anterior',
       'Data Anterior',
       '',
       'DATANT',
       'F' FROM DUAL
UNION ALL
SELECT 'CNC ',
       '--',
       30,
       8,
       'DATATU',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Atual',
       'Data Atual',
       '',
       'DATATU',
       'F' FROM DUAL
UNION ALL
SELECT 'CNC ',
       '--',
       9,
       2,
       'MES_DATANT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data Anterior',
       'Ms de Data Anterior',
       '',
       'TO_CHAR(CNC.DATANT,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CNC ',
       '--',
       40,
       2,
       'MES_DATATU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data Atual',
       'Ms de Data Atual',
       '',
       'TO_CHAR(CNC.DATATU,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CNC ',
       '--',
       60,
       12,
       'PREANT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Preo Anterior',
       'Preo Anterior',
       '',
       'PREANT',
       'F' FROM DUAL
UNION ALL
SELECT 'CNC ',
       '--',
       70,
       12,
       'PREATU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Preo Atual',
       'Preo Atual',
       '',
       'PREATU',
       'F' FROM DUAL
UNION ALL
SELECT 'CNC ',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 6914 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'COB ',
       TO_NUMBER(null),
       'COB ',
       'Cobranas',
       'TT_COB',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'COB.CODFIL,COB.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6915 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'COB ','--','' FROM DUAL
UNION ALL
SELECT 'COB ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'COB ','99','Outros' FROM DUAL
);

/*-- SEQ 6916 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 7579,
       'REC ',
       'COB ',
       'N',
       '1',
       '',
       '',
       'REC.SEQUEN = COB.SEQREC AND
REC.CODFIL = COB.FILREC AND
REC.NUMPAR = COB.NUMPAR AND
REC.SUBPAR = COB.SUBPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 7580,
       'SPT ',
       'COB ',
       'N',
       '1',
       '',
       '',
       'SPT.CODFIL = COB.FILSUP AND
SPT.SEQUEN = COB.SEQSUP',
       '',
       '' FROM DUAL
UNION ALL
SELECT 7581,
       'CHR ',
       'COB ',
       'N',
       '1',
       '',
       '',
       'CHR.CODFIL = COB.FILCHR AND
CHR.SEQUEN = COB.SEQCHR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 7582,
       'CLI ',
       'COB ',
       'N',
       '1',
       '',
       '',
       'CLI.FILCLI = COB.FILCLI AND
CLI.CODCLI = COB.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45916,
       'RECP',
       'COB ',
       'N',
       '1',
       '',
       '',
       'RECP.ORI_SEQUEN = COB.SEQREC AND
RECP.ORI_CODFIL = COB.FILREC AND
RECP.ORI_NUMPAR = COB.NUMPAR AND
RECP.ORI_SUBPAR = COB.SUBPAR',
       '',
       '' FROM DUAL
);

/*-- SEQ 6917 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'COB ',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'COB ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'COB ',
       '01',
       30,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Operao',
       'Data da Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'COB ',
       '01',
       170,
       7,
       'DATPRO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Protesto',
       'Data de Protesto',
       '',
       'DATPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'COB ',
       '01',
       40,
       7,
       'DATVEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Venda',
       'Data da Venda',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'COB ',
       '01',
       50,
       3,
       'FILCHR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Cheques Receb',
       'Filial Cheques Recebidos',
       '',
       'FILCHR',
       'F' FROM DUAL
UNION ALL
SELECT 'COB ',
       '01',
       60,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'COB ',
       '01',
       70,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'COB ',
       '01',
       80,
       3,
       'FILSUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Superior',
       '',
       'FILSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'COB ',
       '01',
       90,
       7,
       'NAOSPC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       ' Inc. SPC at Data:',
       'No incluir do SPC at a Data',
       '',
       'NAOSPC',
       'F' FROM DUAL
UNION ALL
SELECT 'COB ',
       '01',
       100,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'COB ',
       '01',
       110,
       4,
       'QTDNAO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nm. Alteraes SPC',
       'Nmero de Alteraes no SPC',
       '',
       'QTDNAO',
       'F' FROM DUAL
UNION ALL
SELECT 'COB ',
       '01',
       120,
       10,
       'SEQCHR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Seq. Cheques a Receber',
       '',
       'SEQCHR',
       'F' FROM DUAL
UNION ALL
SELECT 'COB ',
       '01',
       130,
       10,
       'SEQREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Seq. Recebimento',
       '',
       'SEQREC',
       'F' FROM DUAL
UNION ALL
SELECT 'COB ',
       '01',
       140,
       10,
       'SEQSUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Superior',
       '',
       'SEQSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'COB ',
       '01',
       150,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'COB ',
       '01',
       160,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       'Sub-Parc.',
       'Nmero da sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
);

/*-- SEQ 6918 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'COD ',
       0,
       'COD ',
       'Gerador de Cdigos',
       'TT_COD',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 6919 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'COD ','--','' FROM DUAL
);

/*-- SEQ 6920 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'COD ',
       '--',
       60,
       5,
       'CODCHV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Chave composta cod',
       'Chave composta do cdigo',
       '',
       'CODCHV',
       '' FROM DUAL
UNION ALL
SELECT 'COD ',
       '--',
       40,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       'F',
       'Cdigo da Srie',
       'Cdigo da Srie',
       'DSER.CODSER(+) = COD.CODSER',
       'CODSER',
       'T' FROM DUAL
UNION ALL
SELECT 'COD ',
       '--',
       10,
       3,
       'CODTAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'COD ',
       '--',
       30,
       3,
       'FILCOD',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial Ger. Cd.',
       'Filial',
       'DFIL.CODFIL = COD.FILCOD',
       'FILCOD',
       'F' FROM DUAL
UNION ALL
SELECT 'COD ',
       '--',
       50,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequncia',
       'Sequncia',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'COD ',
       '--',
       20,
       10,
       'ULTCOD',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'ltimo Cdigo',
       'ltimo Cdigo',
       '',
       'ULTCOD',
       'F' FROM DUAL
);

/*-- SEQ 6921 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'COM ',
       0,
       'COM ',
       'Compras, Fretes, Tt',
       'TV_CMP',
       'T',
       '',
       'TOTALL',
       'Compras',
       '{CODFIL;FILFOR;CODFOR;CODSER;NUMNOT};DATOPE;FLGEST;NUMFAT;ATU_EM',
       '',
       '',
       'Compra',
       'T',
       '',
       'COM.CODFIL,COM.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6922 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'COM ','--','' FROM DUAL
UNION ALL
SELECT 'COM ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'COM ','02','Datas' FROM DUAL
UNION ALL
SELECT 'COM ','03','Valores' FROM DUAL
UNION ALL
SELECT 'COM ','04','Datas' FROM DUAL
UNION ALL
SELECT 'COM ','05','Juros e Multas' FROM DUAL
UNION ALL
SELECT 'COM ','06','Transporte' FROM DUAL
UNION ALL
SELECT 'COM ','99','Outros' FROM DUAL
);

/*-- SEQ 6923 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 121488,
       'FRE ',
       'COM ',
       '01',
       '01',
       '',
       '',
       'FRE.CODFIL = COM.FILFRE (+) and
FRE.SEQUEN = COM.SEQFRE (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 121489,
       'CLI ',
       'COM ',
       '1',
       'N',
       '',
       '',
       'CLI.FILCLI = COM.FILFOR AND
CLI.CODCLI = COM.CODFOR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 121490,
       'CTA ',
       'COM ',
       '01',
       'N',
       '',
       '',
       'CTA.CODFIL(+) = COM.FILCTA AND
CTA.SEQUEN(+) = COM.SEQCTA AND
CTA.TIPCTA(+) = COM.TIPCTA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 121491,
       'ICO ',
       'COM ',
       '0N',
       '01',
       '',
       '',
       'ICO.CODFIL = COM.CODFIL(+) and
ICO.SEQUEN = COM.SEQUEN(+)',
       '(CASE WHEN COM.VLRTOT = 0 THEN 0 ELSE COALESCE(((ICO.VLRMOV*(1+coalesce(ICO.IPIITE,0)/100)) / COM.VLRTOT),1) END)',
       '' FROM DUAL
UNION ALL
SELECT 121492,
       'EDE ',
       'COM ',
       '1',
       'N',
       '',
       '',
       'EDE.CODFIL = COM.FILEND AND
EDE.NUMEND = COM.NUMEND',
       '',
       '' FROM DUAL
UNION ALL
SELECT 121493,
       'FCM ',
       'COM ',
       '1',
       'N',
       '',
       '',
       'FCM.CODFIL = COM.CODFIL and
FCM.SEQUEN = COM.SEQFAT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 121494,
       'PVD ',
       'COM ',
       '1',
       'N',
       '',
       '',
       'PVD.FILPAR = COM.FILFOR and
PVD.CODPAR = COM.CODFOR and
PVD.TIPPAR = COM.TIPPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 121495,
       'REL ',
       'COM ',
       '1',
       'N',
       '',
       '',
       'REL.FILPAR = COM.FILFOR AND
REL.CODPAR = COM.CODFOR AND
REL.TIPPAR = COM.TIPPAR
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 121496,
       'USU ',
       'COM ',
       '1',
       'N',
       '',
       '',
       'USU.FILUSU = COM.FILUSU and
USU.CODUSU = COM.CODUSU
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 121497,
       'AGC ',
       'COM ',
       '1',
       'N',
       '',
       '',
       'COM.FILAGC = AGC.CODFIL AND
COM.SEQAGC = AGC.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 121498,
       'CLI2',
       'COM ',
       '1',
       'N',
       '',
       '',
       'CLI2.FILCLI = COM.FILFOR AND
CLI2.CODCLI = COM.CODFOR',
       '',
       '' FROM DUAL
);

/*-- SEQ 6924 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'COM ',
       '02',
       270,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'COM ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(COM.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '02',
       220,
       4,
       'ANO_DATCMP',
       'A',
       '',
       0,
       0,
       'COM ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       '',
       'N',
       'T',
       'Ano de Data Compra',
       'Ano de Data da compra',
       '',
       'TO_CHAR(COM.DATCMP,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '02',
       185,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       0,
       'COM ',
       80,
       30,
       '',
       '',
       'I',
       'COM',
       '',
       'B',
       'T',
       'Ano de Data Lanto',
       'Ano de Data da operao',
       '',
       'TO_CHAR(COM.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       371,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN COM.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       530,
       1,
       'ATUCUS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Atualiza Custo Rep?',
       'Atualiza Custo Reposio?',
       '',
       'ATUCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '02',
       10,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       550,
       12,
       'BASFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base de ICM do frete',
       'Base de ICM do frete',
       '',
       'BASFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       1350,
       12,
       'BASICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'BASICM',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       1080,
       12,
       'BASRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Base Ret. ST Fonte',
       'Base da Reteno de Substituio Tributria na Fonte',
       '',
       'BASRET',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       880,
       12,
       'BASSUB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Base de Substituio',
       'Base de Substituio',
       '',
       'BASSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       1360,
       14,
       'BSTFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'BSTFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       1130,
       14,
       'BSTFRE ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base de Substituio',
       'Base de Substituio',
       '',
       'BSTFRE ',
       '' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       1110,
       44,
       'CHAVEA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Chave acesso da NF-e',
       'Chave de acesso da NF-e',
       '',
       'CHAVEA',
       '' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       1040,
       20,
       'CODAVU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Avulso',
       'Cdigo Avulso',
       '',
       'CODAVU',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       520,
       5,
       'CODCFO',
       'S',
       'DCFO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCFO.DESCFO',
       'V',
       '',
       '',
       'A',
       'F',
       'Descrio CFOP',
       'Descrio CFOP de compra',
       'DCFO.CODTAB(+) = COM.CODCFO',
       'CODCFO',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       523,
       5,
       'CODCFOP',
       'S',
       'CFOP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'CFOP.CODCFO',
       'V',
       '',
       '',
       'A',
       '',
       'CFOP de Compra',
       'Cdigo CFOP de compra',
       'CFOP.CODTAB(+) = COM.CODCFO',
       'COALESCE(CODCFO,''1152'')',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       1290,
       1,
       'CODDAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Cod mod doc arrecada',
       'Cdigo do modelo do documento de arrecadao',
       '',
       'CODDAR',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       1030,
       5,
       'CODDOP',
       'S',
       'DDOP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDOP.DESDOP',
       'V',
       '',
       '',
       'N',
       'F',
       'Tipo documento',
       'Tipo documento',
       'DDOP.CODTAB = COM.CODDOP(+)',
       'CODDOP',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       870,
       2,
       'CODFCE',
       'A',
       'DFCE',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFCE.DESFCE',
       'V',
       '',
       '',
       'A',
       '',
       'Consumo Energia Elet',
       'Classe de Consumo de Energia Eltrica',
       'COM.CODFCE(+)=DFCE.CODFCE',
       'CODFCE',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       20,
       3,
       'CODFIL',
       'F',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da Filial de Origem',
       'DFIL.CODFIL = COM.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       30,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo~Fornecedor',
       'Cdigo do fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       1190,
       2,
       'CODFPS',
       'A',
       'DFPS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFPS.DESFPS',
       'V',
       '',
       '',
       'A',
       'F',
       'Finalidade Com/ Fret',
       'Finalidade do Compromisso/Frete',
       'DFPS.CODFPS = COM.CODFPS(+)',
       'CODFPS',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       1440,
       10,
       'CODIBG',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo IBGE Origem',
       'Cdigo IBGE da Cidade de Origem',
       '',
       'CODIBG',
       '' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       40,
       2,
       'CODMOE',
       'S',
       'DMOE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       '',
       'F',
       'A',
       'F',
       'Moeda',
       'Cdigo da moeda',
       'DMOE.CODTAB = COM.CODMOE(+)',
       'CODMOE',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       1460,
       5,
       'CODMUL',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Sub-Estoque',
       'Nome do Sub-Estoque',
       'DMUL.CODTAB = COM.CODMUL(+)',
       'CODMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       50,
       2,
       'CODSER',
       'A',
       'VFIS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'VFIS.CODSER',
       'V',
       '',
       'F',
       'A',
       'F',
       'Srie',
       'Cdigo da srie',
       'VFIS.CODSER = COM.CODSER AND VFIS.SUBSER_FIS=COM.SUBSER_FIS',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       60,
       5,
       'CODSET',
       'N',
       'DSET',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSET.DESSET',
       'V',
       '',
       'F',
       'N',
       'F',
       'Setor',
       'Setor',
       'DSET.CODTAB(+) = COM.CODSET',
       'CODSET',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       1410,
       4,
       'CODSRV',
       'S',
       'SRV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SRV.DESSRV',
       'V',
       '',
       '',
       'N',
       '',
       'Descrio do Servio',
       'Descrio do Servio',
       'SRV.CODSRV = COM.CODSRV(+)',
       'CODSRV',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       1120,
       5,
       'CODTRI',
       'S',
       'DTRI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DTRI.CODTRI',
       'V',
       '',
       '',
       'N',
       'F',
       'CST',
       'Cdigo da Situao Tributria',
       'DTRI.CODTAB = COM.CODTRI(+)',
       'CODTRI',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       70,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'COM.FILUSU = USU.FILUSU(+)  AND COM.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       80,
       10,
       'CONPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cond. Pagto.',
       'Condio de Pagamento',
       '',
       'CONPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '02',
       90,
       8,
       'DATCMP',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Compra',
       'Data da compra',
       '',
       'DATCMP',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '02',
       1420,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '02',
       100,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data Lanto',
       'Data da operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       810,
       10,
       'DENFORUF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Dentro/~Fora UF',
       'Dentro do Estado ou  Fora do Estado',
       '',
       '(SUBSTR(ESTADOCOMPRA(COM.CODFIL,COM.SEQUEN),0,10))',
       '' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       110,
       8,
       'DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Desconto',
       'Desconto',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       990,
       12,
       'DESPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Despesas na parcela',
       'Despesas Inclusas na parcela',
       '',
       'DESPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       540,
       13,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       '',
       'Documento',
       'Documento (Srie + Sub-Srie + Nmero )',
       '',
       '(TRIM(COM.CODSER) ||''/''|| CASE WHEN COM.SUBSER IS NULL THEN '''' ELSE TRIM(COM.SUBSER)||''-'' END || TRIM(COM.NUMNOT))',
       '' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       120,
       3,
       'ESPDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Espcie Docto',
       'Espcie de Documento',
       '',
       'ESPDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       1380,
       1,
       'EXPFIS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exportado Fiscal?',
       'Exportado Fiscal?',
       '',
       'EXPFIS',
       '' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       540,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exporta?',
       'Exporta?',
       '',
       'EXPORT',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       1390,
       1,
       'EXPORT_CAN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exportado Cancelado?',
       'Exportado Cancelado?',
       '',
       'EXPORT_CAN',
       '' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       1050,
       3,
       'FILAGC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILAGC',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       130,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Conta',
       'Filial Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       890,
       3,
       'FILCTA_COMFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial da Conta',
       'Filial da Fatura da Conta',
       '',
       '(SELECT INT.FILCTA
         FROM TT_COM INT
        WHERE COM.CODFIL=INT.CODFIL
          AND COM.SEQUEN=INT.SEQFAT
        GROUP BY INT.FILCTA,INT.SEQCTA,INT.TIPCTA
       HAVING COUNT(*) = 1)',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       140,
       3,
       'FILEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial endereo',
       'Filial endereo',
       '',
       'FILEND',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       150,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial do fornecedor',
       'Filial do fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       840,
       3,
       'FILFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       160,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial do fornecedor',
       'Filial do fornecedor',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       1370,
       1,
       'FINNFE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       '',
       'Finalidade da NF-e',
       'Finalidade da NF-e',
       '',
       'FINNFE',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       590,
       1,
       'FLGCOF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Incide COFINS?',
       'H incidncia de COFINS?',
       '',
       'FLGCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       600,
       1,
       'FLGCSS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Incide Contr.Social?',
       'H incidncia de contribuio social?',
       '',
       'FLGCSS',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       170,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Situao (Devolvida/Quitada/Em aberto)',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       1000,
       1,
       'FLGICM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FLGICM',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       610,
       1,
       'FLGINS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Incide INSS?',
       'H incidncia de INSS?',
       '',
       'FLGINS',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       1010,
       1,
       'FLGISS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FLGISS',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       620,
       1,
       'FLGPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Incide PIS?',
       'H incidncia de PIS?',
       '',
       'FLGPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       180,
       12,
       'ICMFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'ICMS Frete',
       'ICMS Frete',
       '',
       'ICMFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       190,
       1,
       'INCOJU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Correo',
       'Indicador do tipo de correo de juros',
       '',
       'INCOJU',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       200,
       1,
       'INTPJU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Juros',
       'Indicador do tipo de juros',
       '',
       'INTPJU',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       210,
       1,
       'INTPMU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Multa',
       'Indicador do tipo de multa',
       '',
       'INTPMU',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       850,
       12,
       'ISEICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Isento ICMS',
       'Isento ICMS',
       '',
       'ISEICM',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '02',
       260,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'COM ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(COM.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '02',
       211,
       2,
       'MES_DATCMP',
       'A',
       '',
       0,
       0,
       'COM ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       '',
       'N',
       'T',
       'Ms de Data Compra',
       'Ms de Data da compra',
       '',
       'TO_CHAR(COM.DATCMP,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '02',
       180,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       0,
       'COM ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       '',
       'N',
       'T',
       'Ms de Data Lanto',
       'Ms de Data da operao',
       '',
       'TO_CHAR(COM.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       220,
       2,
       'MOEJUR',
       'S',
       'DMOE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       '',
       'F',
       'A',
       'F',
       'Moeda Correo',
       'Moeda da Correo',
       'DMOE.CODTAB = COM.MOEJUR(+)',
       'MOEJUR',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       1060,
       4000,
       'MOTREJ',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       1280,
       2,
       'NATBCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Nat. Crd. PIS/Cofin',
       'Cdigo da Base de Clculo de Crdito de PIS/Cofins',
       '',
       'NATBCC',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       1220,
       1,
       'NATFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Natureza do Frete',
       'Natureza do Frete Contratado',
       '',
       'NATFRE',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       580,
       30,
       'NATURE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Natureza~Compra',
       'Natureza~Compra',
       '',
       '(CASE WHEN COM.NATURE IS NULL THEN ''TRANSFERENCIA'' ELSE COM.NATURE END)',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       240,
       0,
       'NOTESP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Nota Especial?',
       'Nota Especial',
       '',
       'NOTESP',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       25,
       3,
       'NUMCODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       250,
       4,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero de Endereos',
       'Nmero de Endereos',
       '',
       'NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       260,
       9,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nmero',
       'Nmero da nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       270,
       5,
       'NUMVOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero de Volumes',
       'Nmero de Volumes',
       '',
       'NUMVOL',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       280,
       4000,
       'OBSERV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Observaes',
       'Observaes',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       290,
       255,
       'OBSFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao Fatura',
       'Observao Fatura',
       '',
       'OBSFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       1020,
       12,
       'OUTDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Despesas avulso',
       'Despesas de Pagamento avulso',
       '',
       'OUTDES',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       860,
       12,
       'OUTICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Outros ICMS Compras',
       'Outros ICMS Compras',
       '',
       'OUTICM',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       300,
       8,
       'OUTTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Outras Taxas',
       'Outras taxas',
       '',
       'OUTTAX',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       630,
       12,
       'PERCSS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '%Contribuio~Social',
       '%Contribuio Social',
       '',
       'PERCSS',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       560,
       5,
       'PERFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% do ICM do frete',
       '% do ICM do frete',
       '',
       'PERFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       640,
       12,
       'PERICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% ICMS',
       '% ICMS',
       '',
       'PERICM',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       650,
       12,
       'PERINS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% INSS',
       '% INSS',
       '',
       'PERINS',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       660,
       12,
       'PERIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% IRRF',
       '% IRRF',
       '',
       'PERIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       670,
       12,
       'PERISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% ISS',
       '% ISS',
       '',
       'PERISS',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       820,
       1,
       'POREMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Porte da Empresa',
       'Porte da Empresa',
       '',
       'POREMP',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       310,
       8,
       'QTDTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtd. Total',
       'Quantidade total',
       '',
       'QTDTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       1090,
       1,
       'RATEIO_FRETE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'RATEIO_FRETE',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       510,
       12,
       'RETCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Reteno de COFINS',
       'Reteno de COFINS',
       '',
       'RETCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       940,
       1,
       'RETCSS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Retm Cont. Social',
       'Retm Contribuio Social',
       '',
       'RETCSS',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       950,
       1,
       'RETIRR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Retm Imp. de Renda',
       'Retm Imposto de Renda',
       '',
       'RETIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       524,
       6,
       'RETORNA_CFOP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'CFOP~Retorno',
       'CFOP Retorno',
       '',
       'RETORNA_CFOP(COM.CODFIL,COM.SEQUEN)',
       '' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       526,
       40,
       'RETORNA_DEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Departamento~Retorno',
       'Departamento~Retorno',
       '',
       'RETORNA_DEP(COM.CODFIL,COM.SEQUEN)',
       '' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       1070,
       10,
       'SEQAGC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQAGC',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       320,
       10,
       'SEQCAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Sequenciador de canc',
       'Sequenciador de cancelamentos',
       '',
       'SEQCAN',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       330,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador Contato',
       'Sequenciador Contato',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       900,
       10,
       'SEQCTA_COMFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. da Conta',
       'Sequncia da Fatura da Conta',
       '',
       '(SELECT INT.SEQCTA
         FROM TT_COM INT
        WHERE COM.CODFIL=INT.CODFIL
          AND COM.SEQUEN=INT.SEQFAT
        GROUP BY INT.FILCTA,INT.SEQCTA,INT.TIPCTA
       HAVING COUNT(*) = 1)',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       340,
       10,
       'SEQFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Sequncia NF Fatura',
       'Sequncia NF Fatura',
       '',
       'SEQFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       350,
       10,
       'SEQFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Sequncia Frete',
       'Sequncia Frete',
       '',
       'SEQFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       360,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       370,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN COM.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       1160,
       2,
       'SITCOF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'CST Cofins',
       'CST Cofins',
       '',
       'SITCOF',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       1150,
       2,
       'SITPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'CST PIS',
       'CST PIS',
       '',
       'SITPIS',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       1140,
       14,
       'ST_FRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr. de Substituio',
       'Valor de Substituio',
       '',
       'ST_FRE',
       '' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       380,
       3,
       'SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Sub-Srie',
       'Sub-Srie de compra',
       '',
       'SUBSER',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       910,
       3,
       'SUBSER_FIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SUBSER_FIS',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       390,
       12,
       'SUBSTT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Substit. Tributria',
       'Substit. Tributria',
       '',
       'SUBSTT',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       1450,
       1,
       'TIPCCM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo Custo Mdio',
       'Tipo Custo Mdio',
       '',
       'TIPCCM',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       400,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       920,
       1,
       'TIPCTA_COMFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       'D',
       '',
       '',
       'F',
       'Tipo da Conta',
       'Tipo da Fatura da Conta',
       '',
       '(SELECT INT.TIPCTA
         FROM TT_COM INT
        WHERE COM.CODFIL=INT.CODFIL
          AND COM.SEQUEN=INT.SEQFAT
        GROUP BY INT.FILCTA,INT.SEQCTA,INT.TIPCTA
       HAVING COUNT(*) = 1)',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       830,
       1,
       'TIPEMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo da Empresa',
       'Tipo da Empresa',
       '',
       'TIPEMP',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       1100,
       1,
       'TIPFRE',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo de Frete',
       'Tipo de Frete',
       '',
       'TIPFRE',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       410,
       1,
       'TIPNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Documento',
       'Tipo de Documento',
       '',
       'TIPNOT',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       420,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Parceiro',
       'Tipo de Parceiro',
       '',
       'COALESCE(COM.TIPPAR,''X'')',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       430,
       1,
       'TIPTRP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Transp. Frete',
       'Tipo de Transporte no Registro de Frete',
       '',
       'TIPTRP',
       'T' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       1340,
       250,
       'TITCTA',
       'A',
       'DCTA',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTA.DESCTA',
       'V',
       '',
       '',
       'A',
       '',
       'Conta Contbil',
       'Conta Contbil',
       'COM.FILCTA = DCTA.FILCTA AND COM.SEQCTA = DCTA.SEQCTA AND COM.TIPCTA = DCTA.TIPCTA',
       'TITCTA',
       '' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       1341,
       250,
       'TITCTA_CTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Conta Financeira',
       'Conta Financeira',
       '',
       '(SELECT CTA.TITCTA FROM TT_CTA CTA WHERE CTA.CODFIL= COM.FILCTA  AND CTA.SEQUEN=COM.SEQCTA  AND CTA.TIPCTA=COM.TIPCTA)',
       '' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       1030,
       12,
       'TOTPAR',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Total das Parcelas',
       'Total das Parcelas',
       '',
       'TOTPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '01',
       440,
       2,
       'UFNOTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF da Nota',
       'UF da Nota',
       '',
       'UFNOTA',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       870,
       12,
       'VE_PAGTO_FUN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VE_PAGTO_FUN',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       450,
       14,
       'VLRBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Bonificao',
       'Valor Bonificao',
       '',
       'VLRBON',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       1430,
       12,
       'VLRBONFUT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Vlr Bonificao Fut.',
       'Valor Bonificao Futura',
       '',
       'VLRBONFUT',
       '' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       970,
       12,
       'VLRCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VLRCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       690,
       12,
       'VLRCSS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Contr.Social',
       'Valor Contribuio Social',
       '',
       'VLRCSS',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       570,
       12,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor do frete',
       'Valor do frete',
       '',
       'VLRFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       700,
       12,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor ICMS',
       'Valor ICMS',
       '',
       'VLRICM',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       710,
       12,
       'VLRINS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor INSS',
       'Valor INSS',
       '',
       'VLRINS',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       960,
       12,
       'VLRIPI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor do IPI',
       'Valor do IPI',
       '',
       'VLRIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       720,
       12,
       'VLRIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor IRRF',
       'Valor IRRF',
       '',
       'VLRIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       730,
       12,
       'VLRISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor ISS',
       'Valor ISS',
       '',
       'VLRISS',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       460,
       8,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Lquido',
       'Valor lquido',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       930,
       12,
       'VLRNOT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Total da Nota',
       'Valor Total da Nota',
       '',
       'VLRNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '--',
       980,
       12,
       'VLRPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VLRPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       470,
       12,
       'VLRRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Reteno',
       'Valor Reteno',
       '',
       'VLRRET',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       1250,
       12,
       'VLRSRV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor do Servio',
       'Valor do Servio',
       '',
       'VLRSRV',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       480,
       8,
       'VLRTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Total',
       'Valor total',
       '',
       'VLRTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       490,
       8,
       'VLTXJU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Juros',
       'Valor ou taxa de juros',
       '',
       'VLTXJU',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '03',
       500,
       8,
       'VLTXMU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Multa',
       'Valor ou taxa de multa',
       '',
       'VLTXMU',
       'F' FROM DUAL
UNION ALL
SELECT 'COM ',
       '99',
       1400,
       4000,
       'XMLNFE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'XML da NFE',
       'XML da NFE',
       '',
       'XMLNFE',
       '' FROM DUAL
);

/*-- SEQ 6925 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'COM ',
       'CODDAR',
       0,
       '0',
       'documento estadual arrecadao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'CODDAR',
       0,
       '1',
       'GNRE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'FINNFE',
       0,
       '1',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'FINNFE',
       0,
       '2',
       'Complementar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'FINNFE',
       0,
       '3',
       'Ajuste',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'FINNFE',
       0,
       '4',
       'Devoluo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'FLGEST',
       0,
       'A',
       'Em aberto',
       12,
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'FLGEST',
       0,
       'D',
       'Devolvida',
       10,
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'FLGEST',
       0,
       'Q',
       'Quitada',
       11,
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'INCOJU',
       0,
       '$',
       'Moeda',
       16,
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'INCOJU',
       0,
       '0',
       'Nao h',
       18,
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'INCOJU',
       0,
       'A',
       'Anual',
       15,
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'INCOJU',
       0,
       'D',
       'Diria',
       13,
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'INCOJU',
       0,
       'M',
       'Mensal',
       14,
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'INTPJU',
       0,
       'C',
       'Composto',
       20,
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'INTPJU',
       0,
       'F',
       'Fixo',
       21,
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'INTPJU',
       0,
       'S',
       'Simples',
       19,
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'INTPMU',
       0,
       '#',
       'Percentual Corrigido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'INTPMU',
       0,
       '$',
       'Valor',
       23,
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'INTPMU',
       0,
       '%',
       'Percentual',
       22,
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'INTPMU',
       0,
       '@',
       'Valor Corrigido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'NATBCC',
       0,
       ' ',
       'Aquisio de bens para revenda',
       TO_NUMBER(null),
       '01' FROM DUAL
UNION ALL
SELECT 'COM ',
       'NATBCC',
       0,
       ' ',
       'Aquisio bens util. c/ insumo',
       TO_NUMBER(null),
       '02' FROM DUAL
UNION ALL
SELECT 'COM ',
       'NATBCC',
       0,
       ' ',
       'Aquisio serv. util. insumo',
       TO_NUMBER(null),
       '03' FROM DUAL
UNION ALL
SELECT 'COM ',
       'NATBCC',
       0,
       ' ',
       'Energia eltrica e trmica',
       TO_NUMBER(null),
       '04' FROM DUAL
UNION ALL
SELECT 'COM ',
       'NATBCC',
       0,
       ' ',
       'Aluguis de prdios',
       TO_NUMBER(null),
       '05' FROM DUAL
UNION ALL
SELECT 'COM ',
       'NATBCC',
       0,
       ' ',
       'Aluguis de mquinas e equip.',
       TO_NUMBER(null),
       '06' FROM DUAL
UNION ALL
SELECT 'COM ',
       'NATBCC',
       0,
       ' ',
       'Armazenagem mercadoria e frete',
       TO_NUMBER(null),
       '07' FROM DUAL
UNION ALL
SELECT 'COM ',
       'NATBCC',
       0,
       ' ',
       'Contraprestaes mercatil',
       TO_NUMBER(null),
       '08' FROM DUAL
UNION ALL
SELECT 'COM ',
       'NATBCC',
       0,
       ' ',
       'Crd. s/ encargos depreciao',
       TO_NUMBER(null),
       '09' FROM DUAL
UNION ALL
SELECT 'COM ',
       'NATBCC',
       0,
       ' ',
       'Crd. c/ base valor aquisio',
       TO_NUMBER(null),
       '10' FROM DUAL
UNION ALL
SELECT 'COM ',
       'NATBCC',
       0,
       ' ',
       'Amort. deprec. edific. imveis',
       TO_NUMBER(null),
       '11' FROM DUAL
UNION ALL
SELECT 'COM ',
       'NATBCC',
       0,
       ' ',
       'Dev. de vendas suj. Incidncia',
       TO_NUMBER(null),
       '12' FROM DUAL
UNION ALL
SELECT 'COM ',
       'NATBCC',
       0,
       ' ',
       'Outras Operaes direito crd.',
       TO_NUMBER(null),
       '13' FROM DUAL
UNION ALL
SELECT 'COM ',
       'NATBCC',
       0,
       ' ',
       'Atividade Transporte de Cargas',
       TO_NUMBER(null),
       '14' FROM DUAL
UNION ALL
SELECT 'COM ',
       'NATBCC',
       0,
       ' ',
       'Custo de Unidade Imobiliria',
       TO_NUMBER(null),
       '15' FROM DUAL
UNION ALL
SELECT 'COM ',
       'NATBCC',
       0,
       ' ',
       'Custo unidade no concluda',
       TO_NUMBER(null),
       '16' FROM DUAL
UNION ALL
SELECT 'COM ',
       'NATBCC',
       0,
       ' ',
       'Atividade de Prestao de Serv',
       TO_NUMBER(null),
       '17' FROM DUAL
UNION ALL
SELECT 'COM ',
       'NATBCC',
       0,
       ' ',
       'Estoque de abertura de bens',
       TO_NUMBER(null),
       '18' FROM DUAL
UNION ALL
SELECT 'COM ',
       'NATFRE',
       0,
       '2',
       'Compra (Gera Crdito)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'NATFRE',
       0,
       '3',
       'Compra (No Gera Crdito)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'NATFRE',
       0,
       '9',
       'Outras',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'POREMP',
       0,
       'M',
       'Micro-empresa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'POREMP',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'POREMP',
       0,
       'P',
       'Pequeno Porte',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Crdito-Tributada',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Crdito-No Tributada',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Crdito-Exportao',
       TO_NUMBER(null),
       '52' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Crdito-Vinc Trib Export',
       TO_NUMBER(null),
       '54' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Crdito-Vinc NTrib Export',
       TO_NUMBER(null),
       '55' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib Exp',
       TO_NUMBER(null),
       '56' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Exc Trib',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Exc NTrib',
       TO_NUMBER(null),
       '61' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Exc Export',
       TO_NUMBER(null),
       '62' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Trib NTrib',
       TO_NUMBER(null),
       '63' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Trib Export',
       TO_NUMBER(null),
       '64' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis NTrib Export',
       TO_NUMBER(null),
       '65' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Trib NTrib Exp
',
       TO_NUMBER(null),
       '66' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Presum-Outras Operaes
',
       TO_NUMBER(null),
       '67' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Aquisio sem Dir Crdito',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Aquisio com Iseno',
       TO_NUMBER(null),
       '71' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Aquisio com Suspenso',
       TO_NUMBER(null),
       '72' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Aquisio a Alquota Zero',
       TO_NUMBER(null),
       '73' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Aquisio sem Inc Contrib',
       TO_NUMBER(null),
       '74' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Aquisio por ST
',
       TO_NUMBER(null),
       '75' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Outras Operaes de Entrada',
       TO_NUMBER(null),
       '98' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITCOF',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Crdito-Tributada',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Crdito-No Tributada',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Crdito-Exportao',
       TO_NUMBER(null),
       '52' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib
',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Crdito-Vinc Trib Export',
       TO_NUMBER(null),
       '54' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Crdito-Vinc NTrib Export',
       TO_NUMBER(null),
       '55' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib Exp',
       TO_NUMBER(null),
       '56' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Exc Trib
',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Exc NTrib
',
       TO_NUMBER(null),
       '61' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Exc Export',
       TO_NUMBER(null),
       '62' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Trib NTrib',
       TO_NUMBER(null),
       '63' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Trib Export',
       TO_NUMBER(null),
       '64' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis NTrib Export',
       TO_NUMBER(null),
       '65' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Trib NTrib Exp',
       TO_NUMBER(null),
       '66' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Presum-Outras Operaes',
       TO_NUMBER(null),
       '67' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Aquisio sem Dir Crdito',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Aquisio com Iseno',
       TO_NUMBER(null),
       '71' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Aquisio com Suspenso',
       TO_NUMBER(null),
       '72' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Aquisio a Alquota Zero',
       TO_NUMBER(null),
       '73' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Aquisio sem Inc Contrib',
       TO_NUMBER(null),
       '74' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Aquisio por ST
',
       TO_NUMBER(null),
       '75' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Outras Operaes de Entrada',
       TO_NUMBER(null),
       '98' FROM DUAL
UNION ALL
SELECT 'COM ',
       'SITPIS',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPCCM',
       0,
       'C',
       'Calculado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPCCM',
       0,
       'M',
       'Manter Custo Atual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPCCM',
       0,
       'Z',
       'Custo Zero',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPEMP',
       0,
       'L',
       'Limitada (LTDA)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPEMP',
       0,
       'R',
       'Registro de Empresrio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPEMP',
       0,
       'S',
       'Sociedade Annima (S.A.)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPFRE',
       0,
       '0',
       'Por conta de terceiros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPFRE',
       0,
       '1',
       'Por conta do emitente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPFRE',
       0,
       '2',
       'Por conta do destinatrio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPFRE',
       0,
       '9',
       'Sem cobrana de frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPNOT',
       0,
       'A',
       'N.F.F.',
       276,
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPNOT',
       0,
       'F',
       'Fatura',
       274,
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPNOT',
       0,
       'N',
       'Nota Fiscal',
       275,
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPPAR',
       0,
       'F',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPPAR',
       0,
       'T',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPPAR',
       0,
       'X',
       'Compromisso',
       TO_NUMBER(null),
       '''' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPTRP',
       0,
       '0',
       'Rodovirio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPTRP',
       0,
       '1',
       'Aquavirio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPTRP',
       0,
       '2',
       'Areo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COM ',
       'TIPTRP',
       0,
       '3',
       'Ferrovirio',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6926 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CON ',
       0,
       'CON ',
       'Contatos',
       'TT_CON',
       'T',
       '',
       'TOTALL',
       'Contatos de clientes',
       '{FILCLI;CODCLI;NUMCON}',
       '',
       'CONTAT',
       'ClienteContato',
       'T',
       '',
       'CON.FILCLI,CON.CODCLI,CON.NUMCON',
       '' FROM DUAL
);

/*-- SEQ 6927 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CON ','--','' FROM DUAL
UNION ALL
SELECT 'CON ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CON ','02','Datas' FROM DUAL
UNION ALL
SELECT 'CON ','99','Outros' FROM DUAL
);

/*-- SEQ 6928 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22433,
       'DCON',
       'CON ',
       'N',
       '1',
       '',
       '',
       'DCON.CODTAB = CON.CODREL',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22434,
       'EDE ',
       'CON ',
       'N',
       '01',
       '',
       '',
       'EDE.FILCLI = CON.FILCLI(+) AND
EDE.CODCLI = CON.CODCLI(+) AND
EDE.CODFIL = CON.FILEND(+) AND
EDE.NUMEND = CON.NUMEND(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22435,
       'SUP ',
       'CON ',
       'N',
       '01',
       '',
       '',
       'SUP.FILACT = CON.FILCLI AND
SUP.CODACT = CON.CODCLI AND
SUP.NUMACT = CON.NUMCON',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22436,
       'WOR ',
       'CON ',
       'N',
       '01',
       '',
       '',
       'WOR.FILACT = CON.FILCLI AND
WOR.CODACT = CON.CODCLI AND
WOR.NUMACT = CON.NUMCON',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22437,
       'INT ',
       'CON ',
       'N',
       '01',
       '',
       '',
       'INT.FILCLI = CON.FILCLI AND
INT.CODCLI = CON.CODCLI AND
INT.NUMCON = CON.NUMCON',
       '',
       '' FROM DUAL
);

/*-- SEQ 6929 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'CON ',
       '02',
       100,
       4,
       'ANO_DATNAS',
       'A',
       '',
       0,
       0,
       'CON ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CON',
       '',
       'N',
       'T',
       'Ano de Nascimento',
       'Ano de Data de nascimento',
       '',
       'TO_CHAR(CON.DATNAS,''YYYY'')',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CON ',
       '99',
       150,
       8,
       'CELCON',
       'A',
       '',
       0,
       0,
       'CON ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CON',
       'F',
       'N',
       'T',
       'Celular do~Contato',
       'Celular',
       '',
       'CELCON',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CON ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       0,
       'CON ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CON',
       'F',
       '9',
       'F',
       'Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CON ',
       '99',
       200,
       3,
       'CODDDI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DDI Telefone',
       'DDI Telefone',
       '',
       'CODDDI',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CON ',
       '99',
       120,
       2,
       'CODREL',
       'S',
       'DCON',
       0,
       0,
       'CON ',
       70,
       TO_NUMBER(null),
       '',
       'DCON.DESCON',
       'V',
       'CON',
       'F',
       'A',
       'T',
       'Tipo Contato',
       'Cargo ou Grau de parentesco',
       'DCON.CODTAB = CON.CODREL',
       'CODREL',
       'F',
       'S' FROM DUAL
UNION ALL
SELECT 'CON ',
       '01',
       40,
       44,
       'CONTAT',
       'A',
       '',
       0,
       0,
       'CON ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CON',
       'F',
       'A',
       'T',
       'Nome do Contato',
       'Nome do contato/Parente',
       '',
       'CONTAT',
       'F',
       'S' FROM DUAL
UNION ALL
SELECT 'CON ',
       '02',
       80,
       8,
       'DATNAS',
       'D',
       '',
       0,
       0,
       'CON ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CON',
       'F',
       'N',
       'T',
       'Nascimento',
       'Data de nascimento',
       '',
       'DATNAS',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CON ',
       '99',
       170,
       2,
       'DDDCEL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DDD Celular',
       'DDD Celular',
       '',
       'DDDCEL',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CON ',
       '99',
       130,
       4,
       'DDDCON',
       'A',
       '',
       0,
       0,
       'CON ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CON',
       'F',
       '9',
       'T',
       'DDD do~Contato',
       'DDD do Contato',
       '',
       'DDDCON',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CON ',
       '99',
       180,
       2,
       'DDDFAX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DDD Fax',
       'DDD Fax',
       '',
       'DDDFAX',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CON ',
       '99',
       210,
       15,
       'DOCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Documento do Contato',
       'Documento do Contato',
       '',
       'DOCCON',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'CON ',
       '99',
       160,
       254,
       'E_MAIL',
       'A',
       '',
       0,
       0,
       'CON ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CON',
       'F',
       'A',
       'T',
       'E-mail',
       'E-mail',
       '',
       'E_MAIL',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CON ',
       '01',
       10,
       3,
       'FILCLI',
       'A',
       '',
       0,
       0,
       'CON ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CON',
       'F',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CON ',
       '01',
       50,
       3,
       'FILEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Endereo',
       '',
       'FILEND',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CON ',
       '02',
       90,
       2,
       'MES_DATNAS',
       'A',
       '',
       0,
       0,
       'CON ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CON',
       '',
       'N',
       'T',
       'Ms de Nascimento',
       'Ms de Data de nascimento',
       '',
       'TO_CHAR(CON.DATNAS,''MM'')',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CON ',
       '01',
       60,
       15,
       'NOMTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome de Tratamento',
       'Nome de Tratamento',
       '',
       'NOMTRA',
       'F',
       'S' FROM DUAL
UNION ALL
SELECT 'CON ',
       '01',
       30,
       2,
       'NUMCON',
       'S',
       '',
       0,
       0,
       'CON ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CON',
       'F',
       '',
       'F',
       'Nmero do Contato',
       'Nmero do contato (apenas para ordenao)',
       '',
       'NUMCON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CON ',
       '01',
       70,
       4,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero de Endereos',
       'Nmero de Endereos',
       '',
       'NUMEND',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CON ',
       '99',
       190,
       8,
       'NUMFAX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Fax',
       'Fax',
       '',
       'NUMFAX',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'CON ',
       '99',
       220,
       1,
       'RETPRO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Retira Produto?',
       'Retira Produto?',
       '',
       'RETPRO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CON ',
       '99',
       110,
       2,
       'SEXCON',
       'S',
       '',
       0,
       0,
       'CON ',
       60,
       30,
       '',
       '',
       'D',
       'CON',
       'F',
       'A',
       'T',
       'Sexo do Contato',
       'Sexo',
       '',
       'SEXCON',
       'T',
       'S' FROM DUAL
UNION ALL
SELECT 'CON ',
       '99',
       140,
       8,
       'TELCON',
       'A',
       '',
       0,
       0,
       'CON ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CON',
       'F',
       'N',
       'T',
       'Telefone do~Contato',
       'Telefone',
       '',
       'TELCON',
       'F',
       'P' FROM DUAL
);

/*-- SEQ 6930 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CON ',
       'SEXCON',
       0,
       '-',
       'Masculino',
       131,
       ' ' FROM DUAL
UNION ALL
SELECT 'CON ',
       'SEXCON',
       1,
       '-',
       'Feminino',
       132,
       ' ' FROM DUAL
);

/*-- SEQ 6931 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'COR ',
       TO_NUMBER(null),
       'COR ',
       'Correspondncias',
       'TT_COR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'COR.CODFIL,COR.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6932 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'COR ','--','' FROM DUAL
UNION ALL
SELECT 'COR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'COR ','99','Outros' FROM DUAL
);

/*-- SEQ 6933 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5459,
       'EDE ',
       'COR ',
       'N ',
       '1 ',
       '',
       '',
       'EDE.FILCLI = COR.FILCLI AND
EDE.CODCLI = COR.CODCLI AND
EDE.CODFIL = COR.FILEND AND
EDE.NUMEND = COR.NUMEND',
       '' FROM DUAL
);

/*-- SEQ 6934 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'COR ',
       '01',
       10,
       5,
       'CODARC',
       'S',
       'DARC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DARC.DESARC',
       'V',
       '',
       '',
       'N',
       'F',
       'Aviso Rec. Correspon',
       'Cdigo Aviso Recebimento de Correspondncia',
       'DARC.CODTAB = COR.CODARC',
       'CODARC',
       'F' FROM DUAL
UNION ALL
SELECT 'COR ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'COR ',
       '01',
       30,
       5,
       'CODCOR',
       'S',
       'DCOR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOR.TITCOR',
       'V',
       '',
       '',
       'N',
       'F',
       'Correspondncia',
       'Correspondncia',
       'DCOR.CODTAB = COR.CODCOR',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'COR ',
       '01',
       40,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = COR.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'COR ',
       '01',
       50,
       7,
       'DATARC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Aviso Rec. Cor.',
       'Data Aviso Recebimento de Correspondncia',
       '',
       'DATARC',
       'F' FROM DUAL
UNION ALL
SELECT 'COR ',
       '01',
       60,
       7,
       'DATIMP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Impresso',
       'Data Impresso',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'COR ',
       '01',
       70,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'COR ',
       '01',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Flial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'COR ',
       '01',
       90,
       3,
       'FILEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filail Endereo',
       '',
       'FILEND',
       'F' FROM DUAL
UNION ALL
SELECT 'COR ',
       '01',
       100,
       4,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero Endereo',
       'Nmero Endereo',
       '',
       'NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT 'COR ',
       '01',
       110,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'COR ',
       '01',
       120,
       1,
       'TIPCOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Tipo Correspondncia',
       'Tipo Correspondncia',
       '',
       'TIPCOR',
       'F' FROM DUAL
);

/*-- SEQ 6935 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'COR ',
       'TIPCOR',
       0,
       '1',
       '1 Cobrana',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COR ',
       'TIPCOR',
       0,
       '2',
       '2 Cobrana',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COR ',
       'TIPCOR',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6936 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'COS ',
       TO_NUMBER(null),
       'COS ',
       'Concluso Ordem Serv',
       'TT_COS',
       'T',
       '',
       'TOTALL',
       'Concluso da Ordem de Servio',
       '',
       '',
       '',
       '',
       'F',
       '',
       'COS.FILCOS,COS.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6937 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'COS ','--','' FROM DUAL
);

/*-- SEQ 6938 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 5460,
       'VTEC',
       'COS ',
       '1',
       '1',
       '',
       '',
       'VTEC.FILCLI = COS.FILPAR and
VTEC.CODCLI = COS.CODPAR
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 5461,
       'IOR ',
       'COS ',
       '1',
       '1',
       '',
       '',
       'IOR.CODFIL = COS.CODFIL and
IOR.TIPPED = COS.TIPPED and
IOR.NUMPED = COS.NUMPED and
IOR.NUMITE = COS.NUMITE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 5462,
       'REL ',
       'COS ',
       '1',
       'N',
       '',
       '',
       'REL.FILPAR = COS.FILPAR AND
REL.CODPAR = COS.CODPAR AND
REL.TIPPAR = COS.TIPPAR',
       '',
       '' FROM DUAL
);

/*-- SEQ 6939 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'COS ',
       '--',
       105,
       4,
       'ANO_DATFIM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'T',
       'Ano de Data Final',
       'Ano de Data do Fim da Execuo da Ordem de Servio',
       '',
       'TO_CHAR(COS.DATFIM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'COS ',
       '--',
       90,
       4,
       'ANO_DATINI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'T',
       'Ano de Data Inicial',
       'Ano de Data do Incio Execuo da Ordem de Servio',
       '',
       'TO_CHAR(COS.DATINI,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'COS ',
       '--',
       3,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filila Servio',
       'Cdigo da Filial de Origem da OS',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'COS ',
       '--',
       8,
       6,
       'CODPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Tcnico',
       'Cdigo do Tcnico',
       '',
       'CODPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'COS ',
       '--',
       110,
       5,
       'CODROS',
       'F',
       'DROS',
       0,
       TO_NUMBER(null),
       '',
       110,
       TO_NUMBER(null),
       '',
       'DROS.RESULT',
       'V',
       '',
       'F',
       '9',
       'T',
       'Resultado',
       'Resultado da Concluso',
       'DROS.CODTAB(+) = COS.CODROS',
       'CODROS',
       'T' FROM DUAL
UNION ALL
SELECT 'COS ',
       '--',
       100,
       8,
       'DATFIM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'T',
       'Data Final',
       'Data do Fim da Execuo da Ordem de Servio',
       '',
       'DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'COS ',
       '--',
       92,
       8,
       'DATINI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'T',
       'Data Inicial',
       'Data do Incio Execuo da Ordem de Servio',
       '',
       'DATINI',
       'F' FROM DUAL
UNION ALL
SELECT 'COS ',
       '--',
       1,
       3,
       'FILCOS',
       'A',
       'FIL2',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       'FIL2.CODFIL',
       'V',
       '',
       'F',
       'N',
       'T',
       'Filial',
       'Cdigo da Filial de Origem da Concluso',
       'COS.FILCOS=FIL2.CODFIL (+)',
       'FILCOS',
       'T' FROM DUAL
UNION ALL
SELECT 'COS ',
       '--',
       7,
       3,
       'FILPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da Filial de Origem do Tcnico',
       '',
       'FILPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'COS ',
       '--',
       103,
       2,
       'MES_DATFIM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'T',
       'Ms de Data Final',
       'Ms de Data do Fim da Execuo da Ordem de Servio',
       '',
       'TO_CHAR(COS.DATFIM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'COS ',
       '--',
       93,
       2,
       'MES_DATINI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'T',
       'Ms de Data Inicial',
       'Ms de Data do Incio Execuo da Ordem de Servio',
       '',
       'TO_CHAR(COS.DATINI,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'COS ',
       '--',
       6,
       5,
       'NUMITE',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nm.Item Ordem Serv.',
       'Nmero do Item da Ordem de Servio',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'COS ',
       '--',
       5,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nm. Ordem Servio',
       'Nmero da Ordem de Servio',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'COS ',
       '--',
       120,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       120,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(COS.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'COS ',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'COS ',
       '--',
       130,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       130,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo do Parceiro',
       'Tipo de Parceiro',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'COS ',
       '--',
       4,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       40,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Ordem Servio',
       'Tipo de Ordem de Servio',
       '',
       'TIPPED',
       'T' FROM DUAL
);

/*-- SEQ 6940 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'COS ',
       'TIPPAR',
       0,
       'F',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COS ',
       'TIPPAR',
       0,
       'T',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'COS ',
       'TIPPED',
       0,
       'O',
       'Oramento',
       71,
       ' ' FROM DUAL
UNION ALL
SELECT 'COS ',
       'TIPPED',
       0,
       'S',
       'O.S.',
       72,
       ' ' FROM DUAL
);

/*-- SEQ 6941 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CPE ',
       0,
       'CPE ',
       'Condies de PGTO',
       'TT_CPE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'PED.ID,CPE.NUMPAR,CPE.NUMPED,CPE.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 6942 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CPE ','--','Dados' FROM DUAL
);

/*-- SEQ 6943 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 5464,
       'PED ',
       'CPE ',
       '1 ',
       'N ',
       '',
       '',
       'PED.CODFIL = CPE.CODFIL AND
PED.NUMPED = CPE.NUMPED',
       '(case when ped.VLRLIQ = 0 then 0 else cpe.VLRPAR / ped.VLRLIQ end)',
       '' FROM DUAL
);

/*-- SEQ 6944 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CPE ',
       '--',
       55,
       4,
       'ANO_DATVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'T',
       'Ano de Vencimento',
       'Ano de Data de Vencimento',
       '',
       'TO_CHAR(CPE.DATVEN,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CPE ',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial do Pedido',
       'Cdigo da filial do pedido',
       'DFIL.CODFIL = CPE.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CPE ',
       '--',
       50,
       8,
       'DATVEN',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'T',
       'Vencimento',
       'Data de Vencimento',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CPE ',
       '--',
       53,
       2,
       'MES_DATVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'T',
       'Ms de Vencimento',
       'Ms de Data de Vencimento',
       '',
       'TO_CHAR(CPE.DATVEN,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CPE ',
       '--',
       30,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'T',
       'Parcela',
       'Nmero da parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'CPE ',
       '--',
       20,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nmero do Pedido',
       'Nmero do pedido',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'CPE ',
       '--',
       40,
       8,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'T',
       'Valor',
       'Valor da Parcela',
       '',
       'VLRPAR',
       'F' FROM DUAL
);

/*-- SEQ 6945 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CPF ',
       TO_NUMBER(null),
       'CPF ',
       'Cotao Preo Forn.',
       'TT_CPF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 6946 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CPF ','--','' FROM DUAL
UNION ALL
SELECT 'CPF ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CPF ','99','Outros' FROM DUAL
);

/*-- SEQ 6947 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CPF ',
       '99',
       40,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Atualizao',
       'Data Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'CPF ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = CPF.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CPF ',
       '99',
       30,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'CPF ',
       '99',
       50,
       254,
       'DESCRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'DESCRI',
       'F' FROM DUAL
UNION ALL
SELECT 'CPF ',
       '99',
       60,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'CPF ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequnciador',
       'Sequnciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 6948 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CPF ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CPF ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CPF ',
       'FLGEST',
       0,
       'E',
       'Enviado ao Fornecedor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CPF ',
       'FLGEST',
       0,
       'F',
       'Finalizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6949 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CPM ',
       TO_NUMBER(null),
       'CPM ',
       'Preos Promocionais',
       'TT_CPM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'CPM.FILCPM,CPM.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6950 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CPM ','--','' FROM DUAL
);

/*-- SEQ 6951 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22447,
       'PLA ',
       'CPM ',
       'N',
       '1',
       '',
       '',
       'PLA.CODPGT = CPM.CODPGT AND
PLA.FILPGT = CPM.FILPGT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22448,
       'PRE ',
       'CPM ',
       'N',
       '1',
       '',
       '',
       'PRE.FILPRE = CPM.FILPRE AND
PRE.SEQUEN = CPM.SEQPRE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22449,
       'USU ',
       'CPM ',
       'N',
       '1',
       '',
       '',
       'USU.FILUSU = CPM.FILUSU AND
USU.FILUSU = CPM.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 6952 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CPM ',
       '--',
       20,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Ultima Atualizao',
       'ltima atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'CPM ',
       '--',
       100,
       1,
       'CLILEV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Promoo Cliente Lev',
       'Promoo somente quando o cliente leva',
       '',
       'CLILEV',
       'F' FROM DUAL
UNION ALL
SELECT 'CPM ',
       '--',
       6,
       3,
       'CODPGT',
       'A',
       'PLA2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'PLA2.DESPGT',
       'V',
       '',
       'F',
       '9',
       'F',
       'Pagamento',
       'Cdigo do Pagamento',
       'PLA2.CODPGT = CPM.CODPGT AND PLA2.FILPGT = CPM.FILPGT',
       'CODPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'CPM ',
       '--',
       10,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do Usurio',
       'CPM.FILUSU = USU2.FILUSU(+) AND USU2.CODUSU(+) = CPM.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'CPM ',
       '--',
       70,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data da incluso',
       'Data da incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'CPM ',
       '--',
       30,
       7,
       'DATINI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Incio da promoo',
       'Incio da promoo',
       '',
       'DATINI',
       'F' FROM DUAL
UNION ALL
SELECT 'CPM ',
       '--',
       8,
       7,
       'DATVAL',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Validade',
       'Data de Validade',
       '',
       'DATVAL',
       'F' FROM DUAL
UNION ALL
SELECT 'CPM ',
       '--',
       1,
       3,
       'FILCPM',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial Preos Prom.',
       'Filial Preos Promocionais',
       'DFIL.CODFIL = CPM.FILCPM',
       'FILCPM',
       'F' FROM DUAL
UNION ALL
SELECT 'CPM ',
       '--',
       50,
       3,
       'FILLOT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial Lote',
       'Filial do Lote',
       'DFIL.CODFIL = CPM.FILLOT',
       'FILLOT',
       'T' FROM DUAL
UNION ALL
SELECT 'CPM ',
       '--',
       5,
       3,
       'FILPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Plano de Pagamento',
       '',
       'FILPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'CPM ',
       '--',
       3,
       3,
       'FILPRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial dos Preos',
       '',
       'FILPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'CPM ',
       '--',
       40,
       3,
       'FILPRO',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial da promoo',
       'Filial da promoo',
       'DFIL.CODFIL(+) = CPM.FILPRO',
       'FILPRO',
       'T' FROM DUAL
UNION ALL
SELECT 'CPM ',
       '--',
       9,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'CPM ',
       '--',
       7,
       10,
       'PRECOP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Preo Promocional',
       'Preo Promocional',
       '',
       'PRECOP',
       'F' FROM DUAL
UNION ALL
SELECT 'CPM ',
       '--',
       80,
       12,
       'QTDCPM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Quantidade Disp.',
       'Quantidade disponvel para promoo',
       '',
       'QTDCPM',
       'F' FROM DUAL
UNION ALL
SELECT 'CPM ',
       '--',
       90,
       12,
       'QTDMIN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Quantidade Mnima',
       'Quantidade Mnima',
       '',
       'QTDMIN',
       '' FROM DUAL
UNION ALL
SELECT 'CPM ',
       '--',
       60,
       10,
       'SEQLOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Seq Lote',
       'Sequenciador do Lote
',
       '',
       'SEQLOT',
       'F' FROM DUAL
UNION ALL
SELECT 'CPM ',
       '--',
       4,
       10,
       'SEQPRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador de Preos',
       '',
       'SEQPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'CPM ',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CPM ',
       '--',
       110,
       1,
       'TEMDES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Aceita Desconto?',
       'Aceita Desconto',
       '',
       'TEMDES',
       'T' FROM DUAL
);

/*-- SEQ 6953 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CPM ',
       'TEMDES',
       0,
       'F',
       'No Aceita Desconto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CPM ',
       'TEMDES',
       0,
       'T',
       'Aceita Desconto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CPM ',
       'TEMDES',
       0,
       'X',
       'Conforme Configurao',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6954 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CPR ',
       TO_NUMBER(null),
       'CPR ',
       'Campanha Promoo',
       'TT_CPR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 6955 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CPR ','--','' FROM DUAL
UNION ALL
SELECT 'CPR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CPR ','99','Outros' FROM DUAL
);

/*-- SEQ 6956 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 117782,
       'DFIL',
       'CPR ',
       '01',
       '0N',
       '',
       '',
       'CPR.CODFIL = DFIL.CODFIL(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 117783,
       'TPR ',
       'CPR ',
       '01',
       '0N',
       '',
       '',
       'CPR.FILPRE = TPR.CODFIL(+) AND
CPR.CODPRE = TPR.CODPRE(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 6957 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'CPR ',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Atualizao',
       'Data atualizao',
       '',
       'ATU_EM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CPR ',
       '--',
       20,
       1,
       'CANAPL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Canal Aplicao',
       'Canal de aplicao da campanha',
       '',
       'CANAPL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CPR ',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = CPR.CODFIL(+)',
       'CODFIL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CPR ',
       '--',
       140,
       5,
       'CODPRE',
       'S',
       'TPR ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TPR.DESPRE',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Tabela Preo',
       'Cdigo da tabela de preo',
       'CPR.FILPRE=TPR.CODFIL (+) AND CPR.CODPRE=TPR.CODPRE (+)',
       'CODPRE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CPR ',
       '--',
       40,
       1,
       'CPRATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Ativo',
       'Ativo',
       '',
       'CPRATI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CPR ',
       '--',
       50,
       7,
       'DATFIM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Final',
       'Data final',
       '',
       'DATFIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CPR ',
       '--',
       60,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data incluso',
       '',
       'DATINC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CPR ',
       '--',
       70,
       7,
       'DATINI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incio',
       'Data inicial',
       '',
       'DATINI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CPR ',
       '--',
       80,
       254,
       'DESCRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'DESCRI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CPR ',
       '--',
       150,
       3,
       'FILAPL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Aplic. Camp.',
       'Filial de aplicao da campanha',
       'DFIL.CODFIL = CPR.FILAPL(+)',
       'FILAPL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CPR ',
       '--',
       160,
       3,
       'FILPRE',
       'A',
       'TPR ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TPR.DESPRE',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Tabela Preo',
       'Filial da tabela de preo',
       'CPR.FILPRE=TPR.CODFIL (+) AND CPR.CODPRE=TPR.CODPRE (+)',
       'FILPRE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CPR ',
       '--',
       170,
       1,
       'IGNCMP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ignora Val. Campanha',
       'Valida valor mnimo aps aplicao do desconto da campanha?',
       '',
       'IGNCMP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'CPR ',
       '--',
       90,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CPR ',
       '--',
       100,
       1,
       'TIPAPL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Aplicao',
       'Tipo de aplicao',
       '',
       'TIPAPL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'CPR ',
       '--',
       110,
       1,
       'USOOUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Permitir Prod. Desc',
       'Permitir uso com produtos com outro desconto',
       '',
       'USOOUT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CPR ',
       '--',
       120,
       1,
       'VENCUS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Solic. Perm. V. Cust',
       'Solicitar permisso quando valor de venda abaixo do custo de reposio',
       '',
       'VENCUS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'CPR ',
       '--',
       130,
       12,
       'VLRMIN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Valor Mnimo Comp.',
       'Valor mnimo da compra',
       '',
       'VLRMIN',
       'F',
       'D' FROM DUAL
);

/*-- SEQ 6958 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CPR ',
       'CANAPL',
       0,
       'L',
       'Loja',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CPR ',
       'CANAPL',
       0,
       'O',
       'Omnichannel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CPR ',
       'CANAPL',
       0,
       'T',
       'Todos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CPR ',
       'TIPAPL',
       0,
       'L',
       'Lives',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CPR ',
       'TIPAPL',
       0,
       'P',
       'Por cupom',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6959 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CPXF',
       TO_NUMBER(null),
       'CPXF',
       'Fornecedores Cotao',
       'TT_CPFXFOR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 6960 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CPXF','--','' FROM DUAL
UNION ALL
SELECT 'CPXF','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CPXF','99','Outros' FROM DUAL
);

/*-- SEQ 6961 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 32873,
       'CLI ',
       'CPXF',
       '1',
       '0N',
       '',
       '',
       'CLI.FILCLI = CPXF.FILFOR AND
CLI.CODCLI = CPXF.CODFOR',
       '',
       '' FROM DUAL
);

/*-- SEQ 6962 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CPXF',
       '99',
       60,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Atualizao',
       'Data Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'CPXF',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = CPXF.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CPXF',
       '01',
       40,
       3,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Fornecedor',
       'Cdigo Fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'CPXF',
       '99',
       50,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'CPXF',
       '01',
       30,
       3,
       'FILFOR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Fornecedor',
       'Filial Fornecedor',
       'DFIL.CODFIL = CPXF.FILFOR',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'CPXF',
       '99',
       70,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'CPXF',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequnciador',
       'Sequnciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CPXF',
       '99',
       80,
       1,
       'TIPEXP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Exportao',
       'Tipo de Exportao',
       '',
       'TIPEXP',
       'T' FROM DUAL
);

/*-- SEQ 6963 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CPXF',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CPXF',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CPXF',
       'FLGEST',
       0,
       'E',
       'Enviado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CPXF',
       'FLGEST',
       0,
       'R',
       'Recebido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CPXF',
       'TIPEXP',
       0,
       'E',
       'Excel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CPXF',
       'TIPEXP',
       0,
       'J',
       'JSON',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6964 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CPXG',
       TO_NUMBER(null),
       'CPXG',
       'Gatilhos Campanha',
       'TT_CPRXGAT',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 6965 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CPXG','--','' FROM DUAL
UNION ALL
SELECT 'CPXG','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CPXG','99','Outros' FROM DUAL
);

/*-- SEQ 6966 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 117785,
       'CPR ',
       'CPXG',
       '1',
       '0N',
       '',
       '',
       'CPXG.FILCPR = CPR.CODFIL(+) AND
CPXG.SEQCPR = CPR.SEQUEN(+)
',
       '',
       '' FROM DUAL
);

/*-- SEQ 6967 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CPXG',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Atualizao',
       'Data atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'CPXG',
       '--',
       20,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'CPXG',
       '--',
       100,
       254,
       'DESCRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'DESCRI',
       'F' FROM DUAL
UNION ALL
SELECT 'CPXG',
       '--',
       30,
       3,
       'FILCPR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Campanha',
       'Filial campanha',
       'DFIL.CODFIL = CPXG.FILCPR(+)',
       'FILCPR',
       'T' FROM DUAL
UNION ALL
SELECT 'CPXG',
       '--',
       40,
       3,
       'FILCPRFUT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Camp. Futura',
       'Filial campanha futura',
       'DFIL.CODFIL = CPXG.FILCPRFUT(+)',
       'FILCPRFUT',
       'T' FROM DUAL
UNION ALL
SELECT 'CPXG',
       '--',
       50,
       10,
       'SEQCPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. Campanha',
       'Sequenciador da campanha',
       '',
       'SEQCPR',
       'T' FROM DUAL
UNION ALL
SELECT 'CPXG',
       '--',
       60,
       10,
       'SEQCPRFUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. Camp. Futura',
       'Sequenciador da campanha futura',
       '',
       'SEQCPRFUT',
       'T' FROM DUAL
UNION ALL
SELECT 'CPXG',
       '--',
       70,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CPXG',
       '--',
       80,
       1,
       'TIPGAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Gatilho',
       'Tipo gatilho',
       '',
       'TIPGAT',
       'T' FROM DUAL
UNION ALL
SELECT 'CPXG',
       '--',
       90,
       1,
       'TIPOBG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Obrigatoriedade',
       'Tipo obrigatoriedade',
       '',
       'TIPOBG',
       'T' FROM DUAL
);

/*-- SEQ 6968 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CPXG',
       'TIPGAT',
       0,
       'F',
       'Cupom uso futuro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CPXG',
       'TIPGAT',
       0,
       'O',
       'Operao atual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CPXG',
       'TIPOBG',
       0,
       'T',
       'Todas as regras sobre produto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CPXG',
       'TIPOBG',
       0,
       'U',
       'Apenas uma regra sobre produto',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6969 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CRB ',
       TO_NUMBER(null),
       'CRB ',
       'Carteiras de Bancos',
       'TT_CRB',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 6970 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CRB ','--','' FROM DUAL
UNION ALL
SELECT 'CRB ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CRB ','99','Outros' FROM DUAL
);

/*-- SEQ 6971 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CRB ',
       '01',
       30,
       20,
       'APECRB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Apelido da Carteira',
       'Apelido da Carteira',
       '',
       'APECRB',
       '' FROM DUAL
UNION ALL
SELECT 'CRB ',
       '01',
       20,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Cdigo do Banco',
       'Cdigo do Banco',
       '',
       'CODBCO',
       '' FROM DUAL
UNION ALL
SELECT 'CRB ',
       '01',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo',
       'Cdigo',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'CRB ',
       '99',
       40,
       80,
       'DESCRB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio Carteira',
       'Descrio da Carteira',
       '',
       'DESCRB',
       '' FROM DUAL
);

/*-- SEQ 6972 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CRE ',
       TO_NUMBER(null),
       'CRE ',
       'Credit Score',
       'TT_CRE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'cre.codfil,cre.sequen',
       '' FROM DUAL
);

/*-- SEQ 6973 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CRE ','--','' FROM DUAL
UNION ALL
SELECT 'CRE ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CRE ','99','Outros' FROM DUAL
);

/*-- SEQ 6974 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CRE ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = CRE.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CRE ',
       '01',
       20,
       1,
       'CODIGO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo',
       'Cdigo',
       '',
       'CODIGO',
       'F' FROM DUAL
UNION ALL
SELECT 'CRE ',
       '01',
       30,
       6,
       'COLUNA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Coluna',
       'Coluna',
       '',
       'COLUNA',
       'F' FROM DUAL
UNION ALL
SELECT 'CRE ',
       '01',
       40,
       40,
       'DESCRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'DESCRI',
       'F' FROM DUAL
UNION ALL
SELECT 'CRE ',
       '01',
       50,
       5,
       'FAIFIM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Faixa Final(At)',
       'Faixa Final(At)',
       '',
       'FAIFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'CRE ',
       '01',
       60,
       5,
       'FAIINI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Faixa Inicial(De)',
       'Faixa Inicial(De)',
       '',
       'FAIINI',
       'F' FROM DUAL
UNION ALL
SELECT 'CRE ',
       '01',
       70,
       8,
       'PONTOS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Pontos',
       'Pontos',
       '',
       'PONTOS',
       'F' FROM DUAL
UNION ALL
SELECT 'CRE ',
       '01',
       80,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CRE ',
       '01',
       90,
       1,
       'TIPDAD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo do Dado',
       'Tipo de Dado',
       '',
       'TIPDAD',
       'T' FROM DUAL
);

/*-- SEQ 6975 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CRE ',
       'TIPDAD',
       0,
       'D',
       'invCODIGO,COLUNA,FAIINI,FAIFIM',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRE ',
       'TIPDAD',
       0,
       'F',
       'Visvel FAIINI,FAIFIM,PONTOS',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRE ',
       'TIPDAD',
       0,
       'V',
       'Deixar visvel coluna Pontos',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6976 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CRTC',
       TO_NUMBER(null),
       'CRTC',
       'Caracterizao x Cli',
       'TT_CRTXCLI',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 6977 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CRTC','--','' FROM DUAL
UNION ALL
SELECT 'CRTC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CRTC','99','Outros' FROM DUAL
);

/*-- SEQ 6978 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 26103,
       'CLI ',
       'CRTC',
       '01',
       'N',
       '',
       '',
       'CLI.FILCLI = CRTC.FILCLI AND
CLI.CODCLI = CRTC.CODCLI',
       '',
       '' FROM DUAL
);

/*-- SEQ 6979 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CRTC',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'CRTC',
       '01',
       20,
       5,
       'CODCRT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cd. Caracterizao',
       'Cdigo da Caracterizao',
       '',
       'CODCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'CRTC',
       '01',
       30,
       254,
       'DESCRT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Desc. Caracterizao',
       'Descrio Caracterizao',
       '',
       'DESCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'CRTC',
       '01',
       40,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Cliente',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'CRTC',
       '01',
       50,
       1,
       'TIPCRT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Caracterizao',
       'Tipo Caracterizao',
       '',
       'TIPCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'CRTC',
       '01',
       60,
       1,
       'USODET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Uso',
       'Uso',
       '',
       'USODET',
       'F' FROM DUAL
);

/*-- SEQ 6980 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CRTC',
       'TIPCRT',
       0,
       'C',
       'Combo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTC',
       'TIPCRT',
       0,
       'D',
       'Data',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTC',
       'TIPCRT',
       0,
       'L',
       'Lgico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTC',
       'TIPCRT',
       0,
       'N',
       'Nmero',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTC',
       'TIPCRT',
       0,
       'S',
       'String',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTC',
       'USODET',
       0,
       'C',
       'CLIENTE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTC',
       'USODET',
       0,
       'E',
       'ENDEREO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTC',
       'USODET',
       0,
       'G',
       'GRADE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTC',
       'USODET',
       0,
       'N',
       'CONCORRENTE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTC',
       'USODET',
       0,
       'O',
       'PRODUTO DO CONCORRENTE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTC',
       'USODET',
       0,
       'P',
       'PRODUTO',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6981 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CRTE',
       TO_NUMBER(null),
       'CRTE',
       'Caracterizao End.',
       'TT_CRTXEND',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 6982 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CRTE','--','' FROM DUAL
UNION ALL
SELECT 'CRTE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CRTE','99','Outros' FROM DUAL
);

/*-- SEQ 6983 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CRTE',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'CRTE',
       '01',
       20,
       5,
       'CODCRT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cd. Caracterizao',
       'Cdigo da Caracterizao',
       '',
       'CODCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'CRTE',
       '01',
       30,
       254,
       'DESCRT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Desc. Caracterizao',
       'Descrio Caracterizao',
       '',
       'DESCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'CRTE',
       '01',
       40,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Cliente',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'CRTE',
       '01',
       50,
       3,
       'FILEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Endereo',
       'Filial Endereo',
       '',
       'FILEND',
       'F' FROM DUAL
UNION ALL
SELECT 'CRTE',
       '01',
       60,
       4,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero Endereo',
       'Nmero Endereo',
       '',
       'NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT 'CRTE',
       '01',
       70,
       1,
       'TIPCRT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Caracterizao',
       'Tipo Caracterizao',
       '',
       'TIPCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'CRTE',
       '01',
       80,
       1,
       'USODET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Uso',
       'Uso',
       '',
       'USODET',
       'F' FROM DUAL
);

/*-- SEQ 6984 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CRTE',
       'TIPCRT',
       0,
       'C',
       'Combo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTE',
       'TIPCRT',
       0,
       'D',
       'Data',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTE',
       'TIPCRT',
       0,
       'L',
       'Lgico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTE',
       'TIPCRT',
       0,
       'N',
       'Nmero',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTE',
       'TIPCRT',
       0,
       'S',
       'String',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTE',
       'USODET',
       0,
       'C',
       'CLIENTE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTE',
       'USODET',
       0,
       'E',
       'ENDEREO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTE',
       'USODET',
       0,
       'G',
       'GRADE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTE',
       'USODET',
       0,
       'N',
       'CONCORRENTE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTE',
       'USODET',
       0,
       'O',
       'PRODUTO DO CONCORRENTE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTE',
       'USODET',
       0,
       'P',
       'PRODUTO',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6985 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CRTG',
       TO_NUMBER(null),
       'CRTG',
       'Caracterizao Grade',
       'TT_CRTXGRA',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 6986 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CRTG','--','' FROM DUAL
UNION ALL
SELECT 'CRTG','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CRTG','99','Outros' FROM DUAL
);

/*-- SEQ 6987 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CRTG',
       '01',
       10,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Diviso do produto',
       'DIV.CODITE (+) = CRTG.CODCOR',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'CRTG',
       '01',
       20,
       5,
       'CODCRT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cd. Caracterizao',
       'Cdigo da Caracterizao',
       '',
       'CODCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'CRTG',
       '01',
       30,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Material',
       'Cdigo Material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'CRTG',
       '01',
       40,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'SUB.CODITE (+) = CRTG.CODTAM',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'CRTG',
       '01',
       50,
       254,
       'DESCRT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Desc. Caracterizao',
       'Descrio Caracterizao',
       '',
       'DESCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'CRTG',
       '01',
       60,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Material',
       'Filial Material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'CRTG',
       '01',
       70,
       1,
       'TIPCRT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Caracterizao',
       'Tipo Caracterizao',
       '',
       'TIPCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'CRTG',
       '01',
       80,
       1,
       'USODET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Uso',
       'Uso',
       '',
       'USODET',
       'F' FROM DUAL
);

/*-- SEQ 6988 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CRTG',
       'TIPCRT',
       0,
       'C',
       'Combo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTG',
       'TIPCRT',
       0,
       'D',
       'Data',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTG',
       'TIPCRT',
       0,
       'L',
       'Lgico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTG',
       'TIPCRT',
       0,
       'N',
       'Nmero',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTG',
       'TIPCRT',
       0,
       'S',
       'String',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTG',
       'USODET',
       0,
       'C',
       'CLIENTE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTG',
       'USODET',
       0,
       'E',
       'ENDEREO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTG',
       'USODET',
       0,
       'G',
       'GRADE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTG',
       'USODET',
       0,
       'N',
       'CONCORRENTE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTG',
       'USODET',
       0,
       'O',
       'PRODUTO DO CONCORRENTE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTG',
       'USODET',
       0,
       'P',
       'PRODUTO',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6989 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CRTP',
       TO_NUMBER(null),
       'CRTP',
       'Caracterizao Prod.',
       'TT_CRTXPRO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 6990 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CRTP','--','' FROM DUAL
UNION ALL
SELECT 'CRTP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CRTP','99','Outros' FROM DUAL
);

/*-- SEQ 6991 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CRTP',
       '01',
       10,
       5,
       'CODCRT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cd. Caracterizao',
       'Cdigo da Caracterizao',
       '',
       'CODCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'CRTP',
       '01',
       20,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Material',
       'Cdigo Material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'CRTP',
       '01',
       30,
       254,
       'DESCRT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Desc. Caracterizao',
       'Descrio Caracterizao',
       '',
       'DESCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'CRTP',
       '01',
       40,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Material',
       'Filial Material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'CRTP',
       '01',
       50,
       1,
       'TIPCRT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Caracterizao',
       'Tipo Caracterizao',
       '',
       'TIPCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'CRTP',
       '01',
       60,
       1,
       'USODET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Uso',
       'Uso',
       '',
       'USODET',
       'F' FROM DUAL
);

/*-- SEQ 6992 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CRTP',
       'TIPCRT',
       0,
       'C',
       'Combo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTP',
       'TIPCRT',
       0,
       'D',
       'Data',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTP',
       'TIPCRT',
       0,
       'L',
       'Lgico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTP',
       'TIPCRT',
       0,
       'N',
       'Nmero',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTP',
       'TIPCRT',
       0,
       'S',
       'String',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTP',
       'USODET',
       0,
       'C',
       'CLIENTE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTP',
       'USODET',
       0,
       'E',
       'ENDEREO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTP',
       'USODET',
       0,
       'G',
       'GRADE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTP',
       'USODET',
       0,
       'N',
       'CONCORRENTE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTP',
       'USODET',
       0,
       'O',
       'PRODUTO DO CONCORRENTE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CRTP',
       'USODET',
       0,
       'P',
       'PRODUTO',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6993 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CSC ',
       TO_NUMBER(null),
       'CSC ',
       'Coloraes SelfColor',
       'TT_CSC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CSC.CODFIL,CSC.ID,
CSC.FILMAT,CSC.CODMAT,CSC.CODCOR,CSC.CODTAM,
CSC.FILPED,CSC.TIPPED,CSC.NUMPED,CSC.ITEPED
',
       '' FROM DUAL
);

/*-- SEQ 6994 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CSC ','--','' FROM DUAL
UNION ALL
SELECT 'CSC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CSC ','99','Outros' FROM DUAL
);

/*-- SEQ 6995 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22109,
       'GRA ',
       'CSC ',
       '0N',
       '1',
       '',
       '',
       'CSC.FILMAT = GRA.FILMAT AND
CSC.CODMAT = GRA.CODMAT AND
CSC.CODCOR = GRA.CODCOR AND
CSC.CODTAM = GRA.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22110,
       'IOR ',
       'CSC ',
       '0N',
       '01',
       '',
       '',
       'CSC.FILPED = IOR.CODFIL AND
CSC.TIPPED = IOR.TIPPED AND
CSC.NUMPED = IOR.NUMPED AND
CSC.ITEPED = IOR.NUMITE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22111,
       'BSC ',
       'CSC ',
       'N',
       '1',
       '',
       '',
       'CSC.CODFIL = BSC.CODFIL AND
CSC.ID = BSC.ID',
       '',
       '' FROM DUAL
);

/*-- SEQ 6996 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CSC ',
       '--',
       10,
       5,
       'CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Diviso do item de grade da colorao no Commerce',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'CSC ',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial da fabricao',
       'Filial da fabricao',
       'DFIL.CODFIL = CSC.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'CSC ',
       '--',
       30,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Cdigo do item de grade da colorao no Commerce',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'CSC ',
       '--',
       40,
       5,
       'CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Subdiviso do item de grade da colorao no Commerce',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'CSC ',
       '--',
       50,
       10,
       'COD_COLOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da colorao',
       'Cdigo da colorao no SelfColor',
       '',
       'COD_COLOR',
       'F' FROM DUAL
UNION ALL
SELECT 'CSC ',
       '--',
       60,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do item',
       'Filial do item de grade da colorao no Commerce',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'CSC ',
       '--',
       70,
       3,
       'FILPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do item Ora.',
       'Filial do item de oramento em que foi vendida a base',
       '',
       'FILPED',
       'F' FROM DUAL
UNION ALL
SELECT 'CSC ',
       '--',
       80,
       10,
       'ID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'ID da fabricao',
       '',
       'ID',
       'F' FROM DUAL
UNION ALL
SELECT 'CSC ',
       '--',
       90,
       5,
       'ITEPED',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'N do item Ora.',
       'Nmero do item de oramento em que foi vendida a base',
       '',
       'ITEPED',
       'F' FROM DUAL
UNION ALL
SELECT 'CSC ',
       '--',
       100,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Item sequencial',
       'Item sequencial da colorao',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'CSC ',
       '--',
       110,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Pedido do item Ora.',
       'Pedido do item de oramento em que foi vendida a base',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'CSC ',
       '--',
       120,
       14,
       'PRECOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Preo de venda uni.',
       'Preo de venda unitrio da colorao',
       '',
       'PRECOV',
       'F' FROM DUAL
UNION ALL
SELECT 'CSC ',
       '--',
       130,
       12,
       'QTDITE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Quantidade utilizada',
       'Quantidade utilizada na mistura',
       '',
       'QTDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'CSC ',
       '--',
       140,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo do item Ora.',
       'Tipo do item de oramento em que foi vendida a base',
       '',
       'TIPPED',
       'T' FROM DUAL
);

/*-- SEQ 6997 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CSC ',
       'TIPPED',
       0,
       'O',
       'DAV',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CSC ',
       'TIPPED',
       0,
       'P',
       'Pr-Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CSC ',
       'TIPPED',
       0,
       'S',
       'DAV-OS',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 6998 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CTA ',
       TO_NUMBER(null),
       'CTA ',
       'Plano de Contas',
       'TT_CTA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'CTA.CODFIL,CTA.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 6999 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CTA ','--','' FROM DUAL
);

/*-- SEQ 7000 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20381,
       'CTB ',
       'CTA ',
       'N',
       '1',
       '',
       '',
       'CTB.FILCTA = CTA.CODFIL AND
CTB.SEQCTA = CTA.SEQUEN AND
CTB.TIPCTA = CTA.TIPCTA AND
CTB.CTACTB = CTA.USOCTA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20382,
       'CIN ',
       'CTA ',
       'N',
       '1',
       '',
       '',
       'CIN.CODFIL = CTA.FILVIN AND
CIN.SEQUEN = CTA.SEQVIN AND
CIN.TIPCTA = CTA.TIPVIN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20383,
       'ECT ',
       'CTA ',
       '1',
       '0N',
       '',
       '',
       'ECT.CODFIL = CTA.FILECT(+) AND
ECT.SEQUEN = CTA.SEQECT(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20384,
       'FIN ',
       'CTA ',
       'N',
       '1',
       '',
       '',
       'FIN.FILGER = CTA.CODFIL AND
FIN.SEQGER = CTA.SEQUEN AND
FIN.TIPGER = CTA.TIPCTA',
       '',
       '' FROM DUAL
);

/*-- SEQ 7001 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CTA ',
       '--',
       80,
       1,
       'APLNUM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Aplicabilidade Conta',
       'Aplicabilidade da conta ',
       '',
       'APLNUM',
       'T' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       182,
       1,
       'ATUARE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Atualizao do rec?',
       'Atualizao do a receber?',
       '',
       'ATUARE',
       'F' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       195,
       1,
       'ATUREA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'A receb. atualizado?',
       'A receber atualizado?',
       '',
       'ATUREA',
       'F' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       210,
       8,
       'ATU_EM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data da atualizao',
       'Data da atualizao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       18,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = CTA.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       175,
       7,
       'DATARE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Data atu a receber',
       'Data atualizao do a receber',
       '',
       'DATARE',
       'F' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       185,
       7,
       'DATREA',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'A receber data',
       'A receber data',
       '',
       'DATREA',
       'F' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       70,
       4000,
       'ESTRUTURANOME',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Estrutura~Conta',
       'Estrutura da Conta',
       '',
       'RTF2TXT(ESTRUTURADECONTAS(CTA.CODFIL,CTA.SEQUEN))',
       '' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       71,
       250,
       'NIVEL4',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nivel 4',
       'Nivel 4',
       '',
       'RTF2TXT(EstruturaDeContasNivel(CTA.CODFIL,CTA.SEQUEN, 1))',
       '' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       72,
       250,
       'NIVEL3',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nivel 3',
       'Nivel 3',
       '',
       'RTF2TXT(EstruturaDeContasNivel(CTA.CODFIL,CTA.SEQUEN, 2))',
       '' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       73,
       250,
       'NIVEL2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nivel 2',
       'Nivel 2',
       '',
       'RTF2TXT(EstruturaDeContasNivel(CTA.CODFIL,CTA.SEQUEN, 3))',
       '' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       74,
       250,
       'NIVEL1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nivel 1',
       'Nivel 1',
       '',
       'RTF2TXT(EstruturaDeContasNivel(CTA.CODFIL,CTA.SEQUEN, 4))',
       '' FROM DUAL	          
UNION ALL
SELECT 'CTA ',
       '--',
       6,
       3,
       'FILECT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       '',
       'Filial Estrutura de Contas',
       '',
       'FILECT',
       'F' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       150,
       3,
       'FILNUM',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial Numerria',
       'Filial ~Numerria',
       'DFIL.CODFIL(+) = CTA.FILNUM',
       'FILNUM',
       'T' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       200,
       3,
       'FILVIN',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial Conta Interm.',
       'Filial da Conta Intermediria',
       'DFIL.CODFIL(+) = CTA.FILVIN',
       'FILVIN',
       'T' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       100,
       1,
       'NIVCRI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Nvel de Criticidade',
       'Nvel de Criticidade',
       '',
       'NIVCRI',
       'T' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       170,
       5,
       'ORDCTA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ordem',
       'Ordem',
       '',
       'ORDCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       4,
       250,
       'PREFIX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Prefixo',
       'Prefixo',
       '',
       'PREFIX',
       'F' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       180,
       14,
       'SALARE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Saldo a receber',
       'Saldo a receber',
       '',
       'SALARE',
       'F' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       190,
       14,
       'SALREA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'A receber saldo',
       'A receber saldo',
       '',
       'SALREA',
       'F' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       7,
       10,
       'SEQECT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Chave Estrutura de Contas',
       '',
       'SEQECT',
       'F' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       201,
       10,
       'SEQVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq Conta Interm.',
       'Sequncia da Conta Intermediria',
       '',
       'SEQVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       8,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       202,
       1,
       'TIPVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Conta Interm.',
       'Tipo da Conta Intermediria',
       '',
       'TIPVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       3,
       250,
       'TITCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Conta',
       'Conta',
       '',
       'TITCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       5,
       10,
       'ULTDOC',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'ltimo Documento',
       'ltimo Documento',
       '',
       'ULTDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'CTA ',
       '--',
       28,
       1,
       'USOCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Uso da Conta',
       'Uso da Conta',
       '',
       'USOCTA',
       'T' FROM DUAL
);

/*-- SEQ 7002 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CTA ',
       'APLNUM',
       0,
       'A',
       'Aplicaes',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'APLNUM',
       0,
       'B',
       'Banco',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'APLNUM',
       0,
       'C',
       'Caixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'APLNUM',
       0,
       'D',
       'Diferena',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'APLNUM',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'APLNUM',
       0,
       'N',
       'No Definido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'APLNUM',
       0,
       'S',
       'Estoque',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'NIVCRI',
       0,
       ' ',
       'Baixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'NIVCRI',
       1,
       ' ',
       'Mdia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'NIVCRI',
       2,
       ' ',
       'Alta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'USOCTA',
       0,
       '+',
       'Entradas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'USOCTA',
       0,
       '-',
       'Sadas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'USOCTA',
       0,
       'B',
       'Bancos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'USOCTA',
       0,
       'C',
       'Cartes de Crdito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'USOCTA',
       0,
       'E',
       'ECFs',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'USOCTA',
       0,
       'I',
       'Impostos Retidos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'USOCTA',
       0,
       'L',
       'Limites C/C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'USOCTA',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'USOCTA',
       0,
       'P',
       'Portadores',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'USOCTA',
       0,
       'S',
       'Custo referente a Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTA ',
       'USOCTA',
       0,
       'T',
       'Custo referente a Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7003 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CTAD',
       TO_NUMBER(null),
       'CTAD',
       'Contas Despesas',
       'TV_CTA_DES',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CTAD.CODFIL,CTAD.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7004 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CTAD','--','' FROM DUAL
UNION ALL
SELECT 'CTAD','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CTAD','99','Outros' FROM DUAL
);

/*-- SEQ 7005 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 60528,
       'CTA ',
       'CTAD',
       '1 ',
       '01',
       '',
       '',
       'CTA.FILECT=CTAD.CODFIL AND CTA.SEQECT=CTAD.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 7006 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CTAD',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CTAD',
       '--',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 7007 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CTB ',
       TO_NUMBER(null),
       'CTB ',
       'Contas Bancrias',
       'TT_CTB',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CTB.FILCTA,CTB.SEQCTA,CTB.TIPCTA,CTB.CHETRO',
       '' FROM DUAL
);

/*-- SEQ 7008 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CTB ','--','' FROM DUAL
UNION ALL
SELECT 'CTB ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CTB ','99','Outros' FROM DUAL
);

/*-- SEQ 7009 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CTB ',
       '99',
       220,
       2,
       'APRAZO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Carncia Tt. Prazo',
       'Carncia para ttulos  prazo',
       '',
       'APRAZO',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '--',
       270,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '@',
       'F',
       'Ultima atualizao',
       'Ultima atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '99',
       230,
       2,
       'AVISTA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Carncia Tt. Vista',
       'Carncia para ttulos  vista',
       '',
       'AVISTA',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '99',
       10,
       1,
       'CHETRO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Cheque Troco?',
       ' cheque troco?',
       '',
       'CHETRO',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '01',
       20,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Banco',
       'Cdigo do Banco',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '01',
       40,
       10,
       'CTACRR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm. Conta Corrente',
       'Nmero da Conta Corrente',
       '',
       'CTACRR',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '99',
       160,
       1,
       'CTACTB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Conta Contbil',
       'Conta Contbil',
       '',
       'CTACTB',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '99',
       240,
       2,
       'DIAPRO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias PGTO Progressiv',
       'Nmero de dias para pagamento progressivo',
       '',
       'DIAPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '01',
       50,
       2,
       'DIGAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Dgito Agncia',
       'Dgito da Agncia',
       '',
       'DIGAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '01',
       330,
       2,
       'DIGAGE_NOSNUM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Dg. Ag p/ Nosso',
       'Dgito da Agncia para Clculo do Nosso Nmero',
       '',
       'DIGAGE_NOSNUM',
       '' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '01',
       60,
       1,
       'DIGA_C',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Digito Agencia/Conta',
       'Dgito da Agncia/Conta',
       '',
       'DIGA_C',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '01',
       70,
       2,
       'DIGCRR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Digito Conta',
       'Dgito da Conta',
       '',
       'DIGCRR',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       '',
       'Filial
Conta',
       'CTB.CODFIL = DFIL.CODFIL',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '--',
       280,
       1,
       'IMPCAI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Imprimir no Caixa',
       'Imprimir no Caixa',
       '',
       'IMPCAI',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '99',
       170,
       4,
       'MAXCHE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero Mximo Cheque',
       'Nmero mximo de cheques por lote',
       '',
       'MAXCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '99',
       180,
       3,
       'MAXDIA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias Cheques Maiores',
       'Nmero de dias para a compensao de cheques maiores',
       '',
       'MAXDIA',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '99',
       190,
       3,
       'MINDIA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias Cheques Menores',
       'Nmero de dias para a compensao de cheques menores',
       '',
       'MINDIA',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '01',
       90,
       30,
       'NOMAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Agencia',
       'Nome da Agncia',
       '',
       'NOMAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '01',
       100,
       5,
       'NUMAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Numero Agencia',
       'Numero da Agncia',
       '',
       'NUMAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '01',
       320,
       5,
       'NUMAGE_NOSNUM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Agncia p/ Nosso',
       'Agncia para Clculo do Nosso Nmero',
       '',
       'NUMAGE_NOSNUM',
       '' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '99',
       300,
       12,
       'NUMFIM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nosso Nmero Final',
       'Nosso Nmero Final',
       '',
       'NUMFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '99',
       310,
       12,
       'NUMINI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nosso Nmero Inicial',
       'Nosso Nmero Inicial',
       '',
       'NUMINI',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '99',
       250,
       1,
       'NUMPRO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nm. Desc. Progressi',
       'Nmero de descontos progressivos',
       '',
       'NUMPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '99',
       260,
       9,
       'PERPRO',
       'F',
       '',
       3,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% PGTO Progressivo',
       'Percentual para pagamento progressivo',
       '',
       'PERPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '99',
       110,
       12,
       'PRXTIT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Prximo Ttulo',
       'Prximo Ttulo',
       '',
       'PRXTIT',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '99',
       120,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '99',
       130,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo da Conta',
       'Tipo da Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '99',
       140,
       1,
       'TIPCTB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       ' Conta Corrente?',
       ' Conta Corrente?',
       '',
       'TIPCTB',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '99',
       200,
       8,
       'VLRCHE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Mx. Cheques',
       'Valor mximo de cheques para depsitos automatizados',
       '',
       'VLRCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'CTB ',
       '99',
       210,
       8,
       'VLRLIM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valores Limites',
       'Valor limite entre cheques menores e maiores',
       '',
       'VLRLIM',
       'F' FROM DUAL
);

/*-- SEQ 7010 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CTB ',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTB ',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTB ',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7011 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CTF ',
       TO_NUMBER(null),
       'CTF ',
       'Conciliao TEF',
       'TT_CTF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7012 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CTF ','--','' FROM DUAL
UNION ALL
SELECT 'CTF ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CTF ','99','Outros' FROM DUAL
);

/*-- SEQ 7013 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CTF ',
       '99',
       50,
       0,
       'ARQTXT',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Contedo do Arquivo',
       'Contedo do Arquivo',
       '',
       'ARQTXT',
       'F' FROM DUAL
UNION ALL
SELECT 'CTF ',
       '99',
       30,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'CTF ',
       '99',
       20,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'CTF ',
       '01',
       10,
       14,
       'ID_CTF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Chave ID',
       'Chave ID',
       '',
       'ID_CTF',
       'F' FROM DUAL
UNION ALL
SELECT 'CTF ',
       '99',
       40,
       254,
       'NOMARQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Arquivo',
       'Nome do Arquivo',
       '',
       'NOMARQ',
       'F' FROM DUAL
);

/*-- SEQ 7014 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CTM ',
       TO_NUMBER(null),
       'CTM ',
       'Carto Manual',
       'TT_CTM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'CTM.CODFIL,CTM.SEQUEN,CTM.NUMPAR,CTM.SUBPAR',
       '' FROM DUAL
);

/*-- SEQ 7015 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CTM ','--','' FROM DUAL
);

/*-- SEQ 7016 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CTM ',
       '--',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = CTM.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CTM ',
       '--',
       17,
       7,
       'DATTRN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Transao',
       'Data Transao',
       '',
       'DATTRN',
       'F' FROM DUAL
UNION ALL
SELECT 'CTM ',
       '--',
       27,
       1,
       'MANUAL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Manual?',
       'Manual',
       '',
       'MANUAL',
       'F' FROM DUAL
UNION ALL
SELECT 'CTM ',
       '--',
       37,
       18,
       'NSUTRN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nr. Transao',
       'Nr. Transao',
       '',
       'NSUTRN',
       'F' FROM DUAL
UNION ALL
SELECT 'CTM ',
       '--',
       7,
       20,
       'NUMAUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Autorizao',
       'Autorizaco',
       '',
       'NUMAUT',
       'F' FROM DUAL
UNION ALL
SELECT 'CTM ',
       '--',
       5,
       16,
       'NUMCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Carto',
       'Carto',
       '',
       'NUMCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'CTM ',
       '--',
       3,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Parcela',
       'Parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'CTM ',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CTM ',
       '--',
       4,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub-Parcela',
       'Sub-Parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'CTM ',
       '--',
       47,
       1,
       'TIPOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Operao',
       'Tipo Operao',
       '',
       'TIPOPE',
       'T' FROM DUAL
UNION ALL
SELECT 'CTM ',
       '--',
       6,
       4,
       'VLDCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Validade',
       'Validade',
       '',
       'VLDCAR',
       'F' FROM DUAL
);

/*-- SEQ 7017 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CTM ',
       'TIPOPE',
       0,
       'C',
       'Crdito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTM ',
       'TIPOPE',
       0,
       'D',
       'Dbito',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7018 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CTR ',
       TO_NUMBER(null),
       'CTR ',
       'CompraXUnid.Negcios',
       'TT_CTR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CTR.CODFIL,CTR.SEQUEN,CTR.CODCTR',
       '' FROM DUAL
);

/*-- SEQ 7019 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CTR ','--','' FROM DUAL
UNION ALL
SELECT 'CTR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CTR ','99','Outros' FROM DUAL
);

/*-- SEQ 7020 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5479,
       'COM ',
       'CTR ',
       'N ',
       '01',
       '',
       '',
       'COM.SEQUEN = CTR.SEQUEN AND
COM.CODFIL = CTR.CODFIL AND
COM.TIPNOT = CTR.TIPNOT',
       '' FROM DUAL
);

/*-- SEQ 7021 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CTR ',
       '01',
       10,
       5,
       'CODCTR',
       'S',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       '',
       'N',
       'F',
       'Unidade de Negcios',
       'Unidade de Negcios',
       'DCTR.CODTAB = CTR.CODCTR(+)',
       'CODCTR',
       'T' FROM DUAL
UNION ALL
SELECT 'CTR ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = CTR.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CTR ',
       '01',
       30,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CTR ',
       '01',
       40,
       1,
       'TIPNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Nota',
       'Tipo de Nota',
       '',
       'TIPNOT',
       'T' FROM DUAL
UNION ALL
SELECT 'CTR ',
       '01',
       50,
       12,
       'VLRRAT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Rateio',
       'Valor Rateio',
       '',
       'VLRRAT',
       'F' FROM DUAL
);

/*-- SEQ 7022 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CTR ',
       'TIPNOT',
       0,
       'A',
       'N.F.F.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTR ',
       'TIPNOT',
       0,
       'F',
       'Fatura',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTR ',
       'TIPNOT',
       0,
       'N',
       'Nota fiscal',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7023 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CTT ',
       TO_NUMBER(null),
       'CTT ',
       'Contratos Clientes',
       'TT_CTT',
       'T',
       '',
       'TOTALL',
       'Contrato de Manuteno e Alocao',
       '',
       '',
       '',
       '',
       'F',
       '',
       'CTT.CODFIL,CTT.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7024 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CTT ','--','' FROM DUAL
UNION ALL
SELECT 'CTT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CTT ','02','Valores' FROM DUAL
UNION ALL
SELECT 'CTT ','03','Datas' FROM DUAL
UNION ALL
SELECT 'CTT ','99','Outros' FROM DUAL
);

/*-- SEQ 7025 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 5480,
       'CLI ',
       'CTT ',
       '1',
       'N',
       '',
       '',
       'CLI.FILCLI = CTT.FILCLI AND
CLI.CODCLI = CTT.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 5481,
       'GRA ',
       'CTT ',
       '1',
       'N',
       '',
       '',
       'GRA.FILMAT = CTT.FILMAT AND
GRA.CODMAT = CTT.CODMAT AND
GRA.CODCOR = CTT.CODCOR AND
GRA.CODTAM = CTT.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 5482,
       'REG ',
       'CTT ',
       '1',
       'N',
       '',
       '',
       'REG.CODFIL = CTT.FILREG and
REG.SEQUEN = CTT.SEQREG',
       '',
       '' FROM DUAL
UNION ALL
SELECT 5483,
       'USU ',
       'CTT ',
       '1',
       'N',
       '',
       '',
       'USU.FILUSU = CTT.FILUSU AND
USU.CODUSU = CTT.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 5484,
       'VDD ',
       'CTT ',
       '1',
       'N',
       '',
       '',
       'VDD.FILUSU = CTT.FILVEN AND
VDD.CODUSU = CTT.CODVEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 7026 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CTT ',
       '03',
       80,
       4,
       'ANO_DATCAD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano~Data Cadastro',
       'Ano de Data da Incluso',
       '',
       'TO_CHAR(CTT.DATCAD,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '03',
       170,
       4,
       'ANO_DATFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de ltimo Fatura',
       'Ano de ltimo Faturamento',
       '',
       'TO_CHAR(CTT.DATFAT,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '03',
       140,
       4,
       'ANO_DATFIM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Fim da Vignc',
       'Ano de Fim da Vigncia',
       '',
       'TO_CHAR(CTT.DATFIM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '03',
       110,
       4,
       'ANO_DATINI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Incio Vignc',
       'Ano de Data do Incio da Vigncia',
       '',
       'TO_CHAR(CTT.DATINI,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '03',
       390,
       4,
       'ANO_PRIVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Primeiro Venc',
       'Ano de Primeiro Vencimento',
       '',
       'TO_CHAR(CTT.PRIVEN,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '99',
       360,
       3,
       'CARENC',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Carncia',
       'Quantidade de dias antes de comear a usufruir os benefcios do contrato',
       '',
       'CARENC',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '01',
       180,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Cliente',
       'Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '01',
       190,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       '9',
       'F',
       'Cdigo da Cor',
       'Codigo da cor (diviso)',
       'DIV.CODITE (+) = CTT.CODCOR',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       '0',
       'F',
       'Filial',
       'Cdigo da Filial de Origem',
       'CTT.CODFIL = DFIL.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '01',
       50,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Cdigo do Produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '01',
       200,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Tamanho',
       'Cdigo do tamanho (sub-diviso)',
       'SUB.CODITE (+) = CTT.CODTAM',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '01',
       280,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Cdigo do Usurio',
       'Cdigo do Usurio que Cadastrou o Contrato',
       'CTT.FILUSU = USU.FILUSU(+)  and CTT.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '01',
       420,
       3,
       'CODVEN',
       'A',
       'VDD ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'VDD.APEUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Vendedor',
       'Vendedor',
       'CTT.FILUSU = VDD.FILUSU(+)  AND CTT.CODUSU = VDD.CODUSU(+)',
       'CODVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '02',
       210,
       10,
       'COMISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Comisso',
       'Comisso',
       '',
       'COMISS',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '01',
       30,
       15,
       'CONTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       'Nmero do Contrato',
       'Nmero do Contrato',
       '',
       'CONTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '99',
       340,
       1,
       'CTTPRO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       80,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Prod. Tipo Contrato?',
       'Produto  do Tipo Contrato?',
       '',
       'CTTPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '03',
       60,
       8,
       'DATCAD',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Incluso',
       'Data da Incluso',
       '',
       'DATCAD',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '03',
       150,
       8,
       'DATFAT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'ltimo Faturamento',
       'ltimo Faturamento',
       '',
       'DATFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '03',
       120,
       8,
       'DATFIM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Fim da Vigncia',
       'Fim da Vigncia',
       '',
       'DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '03',
       90,
       8,
       'DATINI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Incio Vigncia',
       'Data do Incio da Vigncia',
       '',
       'DATINI',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '01',
       220,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '01',
       40,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Produto',
       '',
       'FILMAT',
       'T' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '99',
       310,
       3,
       'FILREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial do Registro',
       'Filial do Registro',
       '',
       'FILREG',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '01',
       270,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Usurio que Cadastrou o Contrato',
       '',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '01',
       430,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Vendedor',
       'Filial Vendedor',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '99',
       400,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       120,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '03',
       70,
       2,
       'MES_DATCAD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms~Incluso',
       'Ms de Data da Incluso',
       '',
       'TO_CHAR(CTT.DATCAD,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '03',
       160,
       2,
       'MES_DATFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de ltimo Fatura',
       'Ms de ltimo Faturamento',
       '',
       'TO_CHAR(CTT.DATFAT,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '03',
       130,
       2,
       'MES_DATFIM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Fim da Vignc',
       'Ms de Fim da Vigncia',
       '',
       'TO_CHAR(CTT.DATFIM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '03',
       100,
       2,
       'MES_DATINI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Incio Vignc',
       'Ms de Data do Incio da Vigncia',
       '',
       'TO_CHAR(CTT.DATINI,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '03',
       380,
       2,
       'MES_PRIVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Primeiro Venc',
       'Ms de Primeiro Vencimento',
       '',
       'TO_CHAR(CTT.PRIVEN,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '99',
       330,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       70,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(CTT.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '02',
       230,
       3,
       'PARFAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Parcelas Faturamento',
       'Parcelas Faturamento',
       '',
       'PARFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '02',
       240,
       3,
       'PARTOT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Parcelas Totais',
       'Parcelas Totais',
       '',
       'PARTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '99',
       300,
       2,
       'PERIOD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       40,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'N',
       'F',
       'Perodo Cobrana',
       'Periodicidade da Cobrana',
       '',
       'PERIOD',
       'T' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '03',
       370,
       8,
       'PRIVEN',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Primeiro Vencimento',
       'Primeiro Vencimento',
       '',
       'PRIVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '02',
       250,
       5,
       'QTDFAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade Faturamen',
       'Quantidade Faturamento',
       '',
       'QTDFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '02',
       260,
       5,
       'QTDLAN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade de Lanam',
       'Qauntidade de Lanamentos',
       '',
       'QTDLAN',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '99',
       320,
       10,
       'SEQREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Nmero do Registro',
       '',
       'SEQREG',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '01',
       10,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '02',
       440,
       5,
       'TIPCCC',
       'S',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       'A',
       'F',
       'Tipo CC',
       'Tipo CC',
       'DCCC. = CTT.TIPCCC(+)',
       'TIPCCC',
       'T' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '99',
       350,
       1,
       'TIPCTT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       90,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Contrato',
       'Tipo de Contrato',
       '',
       'TIPCTT',
       'T' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '03',
       410,
       7,
       'ULTREA',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'ltimo~Reajuste',
       'Data ltimo Reajuste de Preos',
       '',
       'ULTREA',
       'F' FROM DUAL
UNION ALL
SELECT 'CTT ',
       '02',
       290,
       10,
       'VLRMES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Mensal',
       'Valor Mensal',
       '',
       'VLRMES',
       'F' FROM DUAL
);

/*-- SEQ 7027 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CTT ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTT ',
       'FLGEST',
       0,
       'R',
       'Ativo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTT ',
       'PERIOD',
       2,
       ' ',
       'Bimestral',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTT ',
       'PERIOD',
       3,
       ' ',
       'Trimestral',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTT ',
       'PERIOD',
       4,
       ' ',
       'Quadrimestral',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTT ',
       'PERIOD',
       12,
       ' ',
       'Anual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTT ',
       'PERIOD',
       6,
       ' ',
       'Semestral',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTT ',
       'PERIOD',
       1,
       ' ',
       'Mensal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTT ',
       'TIPCTT',
       0,
       'L',
       'Locaao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CTT ',
       'TIPCTT',
       0,
       'M',
       'Manutenao',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7028 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CUP ',
       TO_NUMBER(null),
       'CUP ',
       'Cupom de Desconto',
       'TT_CUP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7029 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CUP ','--','' FROM DUAL
UNION ALL
SELECT 'CUP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CUP ','99','Outros' FROM DUAL
);

/*-- SEQ 7030 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 117801,
       'DFIL',
       'CUP ',
       '1',
       '0N',
       '',
       '',
       'CUP.CODFIL = DFIL.CODFIL(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 117802,
       'CPR ',
       'CUP ',
       '1',
       '0N',
       '',
       '',
       'CUP.FILCPR = CPR.CODFIL(+) AND
CUP.SEQCPR = CPR.SEQUEN(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 7031 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CUP ',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Atualizao',
       'Data atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'CUP ',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = CUP.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'CUP ',
       '--',
       30,
       1,
       'CUPATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Ativo',
       'Cupom ativo',
       '',
       'CUPATI',
       'F' FROM DUAL
UNION ALL
SELECT 'CUP ',
       '--',
       40,
       7,
       'DATFIM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Final',
       'Data final',
       '',
       'DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'CUP ',
       '--',
       50,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'CUP ',
       '--',
       60,
       7,
       'DATINI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Inicio',
       'Data incio',
       '',
       'DATINI',
       'F' FROM DUAL
UNION ALL
SELECT 'CUP ',
       '--',
       70,
       254,
       'DESCRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'DESCRI',
       'F' FROM DUAL
UNION ALL
SELECT 'CUP ',
       '--',
       80,
       3,
       'FILCPR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Campanha',
       'Filial campanha',
       'DFIL.CODFIL = CUP.FILCPR',
       'FILCPR',
       'F' FROM DUAL
UNION ALL
SELECT 'CUP ',
       '--',
       90,
       20,
       'NUMERO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Cupom',
       'Nmero do cupom',
       '',
       'NUMERO',
       'F' FROM DUAL
UNION ALL
SELECT 'CUP ',
       '--',
       100,
       10,
       'SEQCPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. Campanha',
       'Sequenciador da campanha',
       '',
       'SEQCPR',
       'T' FROM DUAL
UNION ALL
SELECT 'CUP ',
       '--',
       110,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CUP ',
       '--',
       120,
       1,
       'TIPCOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Cdigo Impresso',
       'Tipo do cdigo impresso (Barras ou QR Code)',
       '',
       'TIPCOD',
       'T' FROM DUAL
UNION ALL
SELECT 'CUP ',
       '--',
       130,
       5,
       'USOCLI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nro. Mx. Uso por Cli',
       'Nmero mximo de uso por cliente',
       '',
       'USOCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'CUP ',
       '--',
       140,
       5,
       'USOMAX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nro. Max de Uso',
       'Nmero mximo de uso',
       '',
       'USOMAX',
       'F' FROM DUAL
);

/*-- SEQ 7032 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CUP ',
       'TIPCOD',
       0,
       'B',
       'Barras',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CUP ',
       'TIPCOD',
       0,
       'Q',
       'QR-Code',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7033 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CUS ',
       TO_NUMBER(null),
       'CUS ',
       'Rateios p/Centr.Cust',
       'TT_CUS',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'CUS.CODCUS,CUS.CODFIL,CUS.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7034 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CUS ','--','' FROM DUAL
UNION ALL
SELECT 'CUS ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CUS ','02','Valores' FROM DUAL
UNION ALL
SELECT 'CUS ','99','Outros' FROM DUAL
);

/*-- SEQ 7035 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5485,
       'COM ',
       'CUS ',
       '1 ',
       '1 ',
       '',
       '',
       'COM.CODFIL = CUS.CODFIL AND
COM.SEQUEN = CUS.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7036 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CUS ',
       '01',
       10,
       5,
       'CODCUS',
       'A',
       'DCUS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCUS.CENCUS',
       'V',
       '',
       'F',
       'A',
       'F',
       'Centro de Custo',
       'Centro de Custo',
       'DCUS.CODTAB = CUS.CODCUS',
       'CODCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'CUS ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = CUS.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CUS ',
       '01',
       30,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CUS ',
       '99',
       50,
       6,
       'TIPNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo da Nota',
       'Tipo da Nota',
       '',
       'TIPNOT',
       'T' FROM DUAL
UNION ALL
SELECT 'CUS ',
       '02',
       40,
       12,
       'VLRRAT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Rateio',
       'Valor Rateio',
       '',
       'VLRRAT',
       'F' FROM DUAL
);

/*-- SEQ 7037 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CUS ',
       'TIPNOT',
       0,
       ' ',
       'N.F.F.',
       TO_NUMBER(null),
       'A' FROM DUAL
UNION ALL
SELECT 'CUS ',
       'TIPNOT',
       0,
       ' ',
       'Fatura',
       TO_NUMBER(null),
       'F' FROM DUAL
UNION ALL
SELECT 'CUS ',
       'TIPNOT',
       0,
       ' ',
       'Notas Fiscais',
       TO_NUMBER(null),
       'N' FROM DUAL
);

/*-- SEQ 7038 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CUXU',
       TO_NUMBER(null),
       'CUXU',
       'Uso Cupom Desconto',
       'TT_CUPXUSO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7039 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CUXU','--','' FROM DUAL
UNION ALL
SELECT 'CUXU','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CUXU','02','Venda' FROM DUAL
UNION ALL
SELECT 'CUXU','99','Outros' FROM DUAL
);

/*-- SEQ 7040 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 117804,
       'CUP ',
       'CUXU',
       '1',
       '0N',
       '',
       '',
       'CUXU.FILCUP = CUP.CODFIL(+) AND
CUXU.SEQCUP = CUP.SEQUEN(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 117805,
       'CLI ',
       'CUXU',
       '01',
       '0N',
       '',
       '',
       'CUXU.FILCLI = CLI.FILCLI(+) AND
CUXU.CODCLI = CLI.CODCLI(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 117806,
       'VEN ',
       'CUXU',
       '01',
       '0N',
       '',
       '',
       'CUXU.FILVEN = VEN.CODFIL(+) AND
CUXU.SEQVEN = VEN.SEQUEN(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 7041 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CUXU',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Atualizao',
       'Data atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'CUXU',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'CUXU',
       '--',
       30,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'CUXU',
       '--',
       40,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Cliente',
       'Filial Cliente',
       'DFIL.CODFIL = CUXU.FILCLI(+)',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'CUXU',
       '--',
       50,
       3,
       'FILCUP',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Cupom',
       'Filial Cupom',
       'DFIL.CODFIL = CUXU.FILCUP(+)',
       'FILCUP',
       'T' FROM DUAL
UNION ALL
SELECT 'CUXU',
       '02',
       60,
       3,
       'FILVEN',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial da Venda',
       'Filial da venda',
       'DFIL.CODFIL = CUXU.FILVEN',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CUXU',
       '--',
       80,
       10,
       'SEQCUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. Cupom',
       'Sequenciador do cupom',
       '',
       'SEQCUP',
       'T' FROM DUAL
UNION ALL
SELECT 'CUXU',
       '--',
       100,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CUXU',
       '02',
       70,
       10,
       'SEQVEN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Sequenciador Venda',
       'Sequenciador da venda',
       '',
       'SEQVEN',
       'F' FROM DUAL
);

/*-- SEQ 7042 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CXC ',
       TO_NUMBER(null),
       'CXC ',
       'Contas x Custos',
       'TT_CTAXDCUS',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CXC.FILCTA,CXC.SEQCTA,CXC.CODCUS',
       '' FROM DUAL
);

/*-- SEQ 7043 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CXC ','--','' FROM DUAL
UNION ALL
SELECT 'CXC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CXC ','99','Outros' FROM DUAL
);

/*-- SEQ 7044 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5486,
       'CTA ',
       'CXC ',
       '0N',
       '1 ',
       '',
       '',
       'CTA.CODFIL = CXC.FILCTA(+) AND
CTA.SEQUEN = CXC.SEQCTA(+)',
       '' FROM DUAL
);

/*-- SEQ 7045 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CXC ',
       '01',
       10,
       5,
       'CODCUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo do Custo',
       'Cdigo do Custo',
       '',
       'CODCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'CXC ',
       '01',
       20,
       3,
       'FILCTA',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Conta',
       'DFIL.CODFIL = CXC.FILCTA',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'CXC ',
       '01',
       30,
       6,
       'RATEIO',
       'F',
       '',
       3,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Rateio',
       'Rateio',
       '',
       'RATEIO',
       'F' FROM DUAL
UNION ALL
SELECT 'CXC ',
       '01',
       40,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'CXC ',
       '01',
       50,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
);

/*-- SEQ 7046 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CXC ',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CXC ',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'CXC ',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7047 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CXCO',
       TO_NUMBER(null),
       'CXCO',
       'Doc Ref Compromissos',
       'TT_COMXCOM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CXCO.CODFIL, CXCO.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7048 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CXCO','--','' FROM DUAL
UNION ALL
SELECT 'CXCO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CXCO','99','Outros' FROM DUAL
);

/*-- SEQ 7049 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21321,
       'VCMP',
       'CXCO',
       '1',
       '01',
       '',
       '',
       'CXCO.FILCOM = VCMP.CODFIL AND
CXCO.SEQCOM = VCMP.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21322,
       'COM ',
       'CXCO',
       '1',
       '0N',
       '',
       '',
       'CXCO.FILDOC = COM.CODFIL AND
CXCO.SEQDOC = COM.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 7050 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CXCO',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       '',
       'Filial',
       'Filial',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'CXCO',
       '99',
       50,
       3,
       'FILCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       '',
       'Filial Documento',
       'Filial Documento',
       '',
       'FILCOM',
       '' FROM DUAL
UNION ALL
SELECT 'CXCO',
       '99',
       30,
       3,
       'FILDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       '',
       'Filial (Compromisso)',
       'Filial (Compromisso)',
       '',
       'FILDOC',
       '' FROM DUAL
UNION ALL
SELECT 'CXCO',
       '99',
       60,
       10,
       'SEQCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq. Documento',
       'Sequenciador Documento',
       '',
       'SEQCOM',
       '' FROM DUAL
UNION ALL
SELECT 'CXCO',
       '99',
       40,
       10,
       'SEQDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq. (Compromisso)',
       'Sequenciador (Compromisso)',
       '',
       'SEQDOC',
       '' FROM DUAL
UNION ALL
SELECT 'CXCO',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7051 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CXCT',
       TO_NUMBER(null),
       'CXCT',
       'Rat. Contas em Compr',
       'TT_COMXCTA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CXCT.CODFIL, CXCT.SEQUEN, CXCT.FILCTA, CXCT.SEQCTA, CXCT.TIPCTA',
       '' FROM DUAL
);

/*-- SEQ 7052 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CXCT','--','' FROM DUAL
UNION ALL
SELECT 'CXCT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CXCT','99','Outros' FROM DUAL
);

/*-- SEQ 7053 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22207,
       'COM ',
       'CXCT',
       '1',
       '0N',
       '',
       '',
       'COM.CODFIL = CXCT.CODFIL(+) AND
COM.SEQUEN = CXCT.SEQUEN(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22208,
       'CTA ',
       'CXCT',
       '1',
       '0N',
       '',
       '',
       'CTA.CODFIL = CXCT.FILCTA(+) AND
CTA.SEQUEN = CXCT.SEQCTA(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 7054 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CXCT',
       '01',
       10,
       3,
       'CODFIL ',
       'S',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Compra',
       'Filial Compra',
       'DFIL.CODFIL = CXCT.CODFIL ',
       'CODFIL ',
       'F' FROM DUAL
UNION ALL
SELECT 'CXCT',
       '01',
       30,
       3,
       'FILCTA',
       'S',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Conta',
       'Filial Conta',
       'DFIL.CODFIL = CXCT.FILCTA',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'CXCT',
       '01',
       40,
       10,
       'SEQCTA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq. Conta',
       'Seq. Conta',
       '',
       'SEQCTA',
       '' FROM DUAL
UNION ALL
SELECT 'CXCT',
       '01',
       20,
       10,
       'SEQUEN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq. Compra',
       'Seq. Compra',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'CXCT',
       '01',
       50,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       '' FROM DUAL
UNION ALL
SELECT 'CXCT',
       '01',
       60,
       1,
       'TIPNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Tipo Compra',
       'Tipo Compra',
       '',
       'TIPNOT',
       '' FROM DUAL
UNION ALL
SELECT 'CXCT',
       '99',
       70,
       12,
       'VLRRAT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Rateado',
       'Valor Rateado',
       '',
       'VLRRAT',
       '' FROM DUAL
);

/*-- SEQ 7055 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CXG ',
       TO_NUMBER(null),
       'CXG ',
       'Regra Sugeir Vender',
       'TT_CXG',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CXG.CODFIL,CXG.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7056 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CXG ','--','' FROM DUAL
UNION ALL
SELECT 'CXG ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CXG ','99','Outros' FROM DUAL
);

/*-- SEQ 7057 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5487,
       'GRA ',
       'CXG ',
       '0N',
       '1 ',
       '',
       '',
       'GRA.FILMAT = CXG.FILMAT AND
GRA.CODMAT = CXG.CODMAT AND
GRA.CODCOR = CXG.CODCOR AND
GRA.CODTAM = CXG.CODTAM
',
       '' FROM DUAL
UNION ALL
SELECT 5488,
       'PRO ',
       'CXG ',
       '0N',
       '1 ',
       '',
       '',
       'PRO.FILMAT = CXG.FILMAT AND
PRO.CODMAT = CXG.CODMAT',
       '' FROM DUAL
UNION ALL
SELECT 5489,
       'REL ',
       'CXG ',
       '0N',
       '1 ',
       '',
       '',
       'REL.FILPAR = CXG.FILMAR AND
REL.CODPAR = CXG.CODMAR AND
REL.TIPPAR = CXG.TIPMAR',
       '' FROM DUAL
);

/*-- SEQ 7058 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CXG ',
       '01',
       10,
       5,
       'CLASS1',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '',
       'Departamento',
       '',
       'CLASS1',
       'F' FROM DUAL
UNION ALL
SELECT 'CXG ',
       '01',
       20,
       5,
       'CLASS2',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '',
       'Tipo2',
       '',
       'CLASS2',
       'F' FROM DUAL
UNION ALL
SELECT 'CXG ',
       '01',
       30,
       5,
       'CLASS3',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '',
       'Linha',
       '',
       'CLASS3',
       'F' FROM DUAL
UNION ALL
SELECT 'CXG ',
       '01',
       40,
       5,
       'CLASS4',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '',
       'Modelo',
       '',
       'CLASS4',
       'F' FROM DUAL
UNION ALL
SELECT 'CXG ',
       '01',
       50,
       5,
       'CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Diviso do Produto',
       'Divisao Produto',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'CXG ',
       '01',
       60,
       5,
       'CODCXG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cd.Produto Sugesto',
       'Produto para Sugesto',
       '',
       'CODCXG',
       'F' FROM DUAL
UNION ALL
SELECT 'CXG ',
       '01',
       70,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Codigo da Filial',
       'DFIL.CODFIL = CXG.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'CXG ',
       '01',
       80,
       6,
       'CODMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo da Marca',
       'Marca Para Sugesto',
       '',
       'CODMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'CXG ',
       '01',
       90,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Codigo material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'CXG ',
       '01',
       100,
       5,
       'CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cd.Subdiviso Prod.',
       'Sub-Divisao Produto',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'CXG ',
       '01',
       110,
       5,
       'CORCXG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cd. Diviso Produto',
       'Diviso Produto Para Sugesto',
       '',
       'CORCXG',
       'F' FROM DUAL
UNION ALL
SELECT 'CXG ',
       '01',
       120,
       5,
       'DEPART',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cd. Departamento',
       'Departamento para Sugesto',
       '',
       'DEPART',
       'F' FROM DUAL
UNION ALL
SELECT 'CXG ',
       '01',
       130,
       3,
       'FILCXG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fil.Produto Sugesto',
       'Filial Produto Para Sugesto',
       '',
       'FILCXG',
       'F' FROM DUAL
UNION ALL
SELECT 'CXG ',
       '01',
       140,
       3,
       'FILMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Marca Para Sugesto',
       '',
       'FILMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'CXG ',
       '01',
       150,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'CXG ',
       '01',
       160,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'CXG ',
       '01',
       170,
       5,
       'TAMCXG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tam. Prod. Sugesto',
       'Tamanho Produto para Sugesto',
       '',
       'TAMCXG',
       'F' FROM DUAL
UNION ALL
SELECT 'CXG ',
       '01',
       180,
       1,
       'TIPMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Marca Sugesto',
       'Tipo Marca Para Sugesto',
       '',
       'TIPMAR',
       'T' FROM DUAL
);

/*-- SEQ 7059 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'CXG ',
       'TIPMAR',
       0,
       'M',
       'Marca',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7060 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CXN ',
       TO_NUMBER(null),
       'CXN ',
       'Filtros para CEST',
       'TT_CESXNCM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CXN.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7061 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CXN ','--','' FROM DUAL
UNION ALL
SELECT 'CXN ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CXN ','99','Outros' FROM DUAL
);

/*-- SEQ 7062 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 27639,
       'CES ',
       'CXN ',
       'N',
       '1',
       '',
       '',
       'CXN.CODCES = CES.CODCES',
       '',
       '' FROM DUAL
);

/*-- SEQ 7063 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CXN ',
       '01',
       20,
       7,
       'CODCES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'CEST',
       'CEST',
       '',
       'CODCES',
       '' FROM DUAL
UNION ALL
SELECT 'CXN ',
       '01',
       30,
       8,
       'CODNCM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'NCM',
       'NCM',
       '',
       'CODNCM',
       '' FROM DUAL
UNION ALL
SELECT 'CXN ',
       '01',
       10,
       10,
       'CODTAB',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo',
       'Cdigo',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'CXN ',
       '01',
       40,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data de Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       '' FROM DUAL
);

/*-- SEQ 7064 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'CXR ',
       TO_NUMBER(null),
       'CXR ',
       'Recepo Compras',
       'TT_ICOXIRC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CXR.FILICO, CXR.SEQICO, CXR.ITEICO, CXR.FILIRC, CXR.SEQIRC, CXR.ITEIRC',
       '' FROM DUAL
);

/*-- SEQ 7065 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'CXR ','--','' FROM DUAL
UNION ALL
SELECT 'CXR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'CXR ','99','Outros' FROM DUAL
);

/*-- SEQ 7066 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21326,
       'ICO ',
       'CXR ',
       '0N',
       '1',
       '',
       '',
       'CXR.FILICO = ICO.CODFIL(+) AND
CXR.SEQICO = ICO.SEQUEN(+) AND
CXR.ITEICO = ICO.NUMITE(+) ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21327,
       'IRC ',
       'CXR ',
       '1',
       '01',
       '',
       '',
       'CXR.FILIRC = IRC.CODFIL AND
CXR.SEQIRC = IRC.SEQUEN AND
CXR.ITEIRC = IRC.NUMITE ',
       '',
       '' FROM DUAL
);

/*-- SEQ 7067 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'CXR ',
       '--',
       120,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data alterao',
       'Data alterao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'CXR ',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Cdigo filial',
       'Cdigo filial',
       'DFIL.CODFIL = CXR.CODFIL',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'CXR ',
       '--',
       110,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data incluso',
       'Data incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'CXR ',
       '--',
       30,
       3,
       'FILICO',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial compra',
       'Filial compra',
       'DFIL.CODFIL = CXR.FILICO',
       'FILICO',
       '' FROM DUAL
UNION ALL
SELECT 'CXR ',
       '--',
       60,
       3,
       'FILIRC',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial recepo',
       'Filial recepo',
       'DFIL.CODFIL = CXR.FILIRC',
       'FILIRC',
       '' FROM DUAL
UNION ALL
SELECT 'CXR ',
       '--',
       90,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       '' FROM DUAL
UNION ALL
SELECT 'CXR ',
       '--',
       50,
       5,
       'ITEICO',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       '',
       '',
       'ITEICO',
       '' FROM DUAL
UNION ALL
SELECT 'CXR ',
       '--',
       80,
       5,
       'ITEIRC',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       '',
       '',
       'ITEIRC',
       '' FROM DUAL
UNION ALL
SELECT 'CXR ',
       '--',
       100,
       14,
       'QTDENT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Quantidade recebida',
       'Quantidade recebida',
       '',
       'QTDENT',
       '' FROM DUAL
UNION ALL
SELECT 'CXR ',
       '--',
       40,
       10,
       'SEQICO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       '',
       '',
       '',
       'SEQICO',
       '' FROM DUAL
UNION ALL
SELECT 'CXR ',
       '--',
       70,
       10,
       'SEQIRC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       '',
       '',
       '',
       'SEQIRC',
       '' FROM DUAL
UNION ALL
SELECT 'CXR ',
       '--',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       '',
       '',
       '',
       'SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7068 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DAMB',
       TO_NUMBER(null),
       'DAMB',
       'Dom. Ambiente',
       'TD_AMB',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7069 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DAMB','--','' FROM DUAL
UNION ALL
SELECT 'DAMB','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DAMB','99','Outros' FROM DUAL
);

/*-- SEQ 7070 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DAMB',
       '--',
       10,
       1,
       'AMBATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ambiente Ativo?',
       'Ambiente Ativo?',
       '',
       'AMBATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DAMB',
       '--',
       20,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DAMB',
       '--',
       30,
       254,
       'DESAMB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Ambiente',
       'Descrio Ambiente',
       '',
       'DESAMB',
       'F' FROM DUAL
);

/*-- SEQ 7071 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DAMP',
       0,
       'DAMP',
       'Dom. Ampliaes',
       'TD_AMP',
       'F',
       '',
       'TOTALL',
       'PHOTO - Ampliaes',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DAMP.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7072 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DAMP','--','' FROM DUAL
UNION ALL
SELECT 'DAMP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DAMP','02','Datas' FROM DUAL
UNION ALL
SELECT 'DAMP','03','Valores' FROM DUAL
UNION ALL
SELECT 'DAMP','99','Outros' FROM DUAL
);

/*-- SEQ 7073 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5490,
       'CFG ',
       'DAMP',
       'N ',
       '1 ',
       '',
       '',
       'CFG.PAPHOAMPLIA = DAMP.CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 5491,
       'DIV ',
       'DAMP',
       '1 ',
       'N ',
       '',
       '',
       'DIV.CODITE = DAMP.DIVAMP',
       '' FROM DUAL
);

/*-- SEQ 7074 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DAMP',
       '99',
       10,
       1,
       'AMPATI',
       'L',
       '',
       0,
       0,
       'DAMP',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'AMPATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DAMP',
       '01',
       50,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DAMP',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DAMP',
       '01',
       80,
       3,
       'CORAMP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cor da Ampliao',
       'Cor da Ampliao',
       '',
       'CORAMP',
       'F' FROM DUAL
UNION ALL
SELECT 'DAMP',
       '01',
       60,
       5,
       'DIVAMP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Diviso da Ampliao',
       'Diviso da Ampliao',
       '',
       'DIVAMP',
       'F' FROM DUAL
UNION ALL
SELECT 'DAMP',
       '01',
       70,
       5,
       'DIVTMP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Diviso do Tempo',
       'Diviso do Tempo',
       '',
       'DIVTMP',
       'F' FROM DUAL
UNION ALL
SELECT 'DAMP',
       '03',
       30,
       8,
       'PHOALT',
       'F',
       '',
       2,
       0,
       'DAMP',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Altura',
       'Altura da foto',
       '',
       'PHOALT',
       'F' FROM DUAL
UNION ALL
SELECT 'DAMP',
       '99',
       40,
       15,
       'PHOCOM',
       'A',
       '',
       0,
       0,
       'DAMP',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Complemento',
       'Complemento da ampliao',
       '',
       'PHOCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'DAMP',
       '03',
       20,
       8,
       'PHOLAR',
       'F',
       '',
       2,
       0,
       'DAMP',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Largura',
       'Largura da foto',
       '',
       'PHOLAR',
       'F' FROM DUAL
);

/*-- SEQ 7075 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DAPR',
       TO_NUMBER(null),
       'DAPR',
       'Dom. Aprov.Oramento',
       'TD_APR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7076 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DAPR','--','' FROM DUAL
UNION ALL
SELECT 'DAPR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DAPR','99','Outros' FROM DUAL
);

/*-- SEQ 7077 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DAPR',
       '01',
       10,
       1,
       'APRATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Aprovao Ativa?',
       'Aprovao Ativa?',
       '',
       'APRATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DAPR',
       '01',
       20,
       1,
       'APROVA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Aprovao',
       'Tipo Aprovao',
       '',
       'APROVA',
       'F' FROM DUAL
UNION ALL
SELECT 'DAPR',
       '01',
       30,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DAPR',
       '01',
       40,
       20,
       'DESAPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Aprovao',
       'Descrio Aprovao',
       '',
       'DESAPR',
       'F' FROM DUAL
);

/*-- SEQ 7078 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DAPR',
       'APROVA',
       0,
       'A',
       'Aprovado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DAPR',
       'APROVA',
       0,
       'E',
       'Em Aprovao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DAPR',
       'APROVA',
       0,
       'R',
       'Reprovado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7079 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DARC',
       TO_NUMBER(null),
       'DARC',
       'Dom. Aviso Corresp.',
       'TD_ARC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DARC.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7080 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DARC','--','' FROM DUAL
UNION ALL
SELECT 'DARC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DARC','99','Outros' FROM DUAL
);

/*-- SEQ 7081 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DARC',
       '01',
       10,
       1,
       'ARCATV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       ' A.R.C. Ativo?',
       ' Aviso Recebimento Correspondncia Ativo?',
       '',
       'ARCATV',
       'F' FROM DUAL
UNION ALL
SELECT 'DARC',
       '01',
       20,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DARC',
       '01',
       30,
       30,
       'DESARC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Dsc Aviso Correspon.',
       'Descrio Aviso de Recebimento de Correspondncia',
       '',
       'DESARC',
       'F' FROM DUAL
UNION ALL
SELECT 'DARC',
       '01',
       40,
       1,
       'TIPARC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       ' do Tipo ARC?',
       'Tipo Aviso de Recebimento de Correspondncia',
       '',
       'TIPARC',
       'F' FROM DUAL
);

/*-- SEQ 7082 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DAT ',
       TO_NUMBER(null),
       'DAT ',
       'Datas de Operaes',
       'TT_DAT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7083 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DAT ','--','' FROM DUAL
UNION ALL
SELECT 'DAT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DAT ','99','Outros' FROM DUAL
);

/*-- SEQ 7084 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DAT ',
       '01',
       10,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
);

/*-- SEQ 7085 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DBCO',
       TO_NUMBER(null),
       'DBCO',
       'Dom. Bancos',
       'TD_BCO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DBCO.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7086 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DBCO','--','' FROM DUAL
UNION ALL
SELECT 'DBCO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DBCO','99','Outros' FROM DUAL
);

/*-- SEQ 7087 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 63442,
       'CTB ',
       'DBCO',
       'N',
       '1',
       '',
       '',
       'CTB.CODBCO = DBCO.CBANCO',
       '',
       '' FROM DUAL
UNION ALL
SELECT 63443,
       'ECB ',
       'DBCO',
       'N',
       '1',
       '',
       '',
       'ECB.CODBCO = DBCO.CBANCO',
       '',
       '' FROM DUAL
UNION ALL
SELECT 63444,
       'REM ',
       'DBCO',
       'N',
       '1',
       '',
       '',
       'REM.CODBCO = DBCO.CBANCO',
       '',
       '' FROM DUAL
UNION ALL
SELECT 63445,
       'RET ',
       'DBCO',
       'N',
       '1',
       '',
       '',
       'RET.CODBCO = DBCO.CBANCO',
       '',
       '' FROM DUAL
UNION ALL
SELECT 63446,
       'CCB ',
       'DBCO',
       'N',
       '1',
       '',
       '',
       'CCB.CODBCO = DBCO.CBANCO',
       '',
       '' FROM DUAL
);

/*-- SEQ 7088 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DBCO',
       '01',
       60,
       10,
       'ABANCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Agncia',
       'Cdigo Agncia',
       '',
       'ABANCO',
       'F' FROM DUAL
UNION ALL
SELECT 'DBCO',
       '01',
       10,
       1,
       'BCOATI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'DBCO',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'T',
       'Ativo',
       'Ativo',
       '',
       'BCOATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DBCO',
       '01',
       20,
       1,
       'CBANCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'DBCO',
       20,
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'F',
       '',
       'T',
       'Cdigo do Banco',
       'Cdigo do Banco',
       '',
       'CBANCO',
       'F' FROM DUAL
UNION ALL
SELECT 'DBCO',
       '01',
       30,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DBCO',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DBCO',
       '01',
       50,
       4000,
       'FBANCO',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Uso Interno',
       'Uso interno (Compatibilidade com verses anteriores)',
       '',
       'RTF2TXT(FBANCO)',
       'F' FROM DUAL
UNION ALL
SELECT 'DBCO',
       '01',
       40,
       30,
       'NBANCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'DBCO',
       40,
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'F',
       '',
       'T',
       'Nome do Banco',
       'Nome do Banco',
       '',
       'NBANCO',
       'F' FROM DUAL
UNION ALL
SELECT 'DBCO',
       '01',
       70,
       12,
       'PRXREM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Prxima Remessa ',
       'Prxima Remessa Bancria',
       '',
       'PRXREM',
       'F' FROM DUAL
UNION ALL
SELECT 'DBCO',
       '01',
       80,
       12,
       'VLRCHE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Vlr p Folha Chq Troc',
       'Valor p/ Folha de Cheque Troco',
       '',
       'VLRCHE',
       'F' FROM DUAL
);

/*-- SEQ 7089 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DBIC',
       TO_NUMBER(null),
       'DBIC',
       'Bicos Combustveis',
       'TD_BIC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DBIC.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7090 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DBIC','--','' FROM DUAL
UNION ALL
SELECT 'DBIC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DBIC','99','Outros' FROM DUAL
);

/*-- SEQ 7091 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20378,
       'DTAN',
       'DBIC',
       '1',
       '1',
       '',
       '',
       'DBIC.FILBIC = DTAN.FILTAN AND DBIC.CODTAN = DTAN.CODTAB',
       '',
       '' FROM DUAL
);

/*-- SEQ 7092 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DBIC',
       '01',
       10,
       1,
       'BICATV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo Sim/No?',
       '',
       'BICATV',
       'F' FROM DUAL
UNION ALL
SELECT 'DBIC',
       '01',
       110,
       5,
       'CODBOM',
       'G',
       'DBOM',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TO_CHAR(DBOM.NUMBOM)',
       'V',
       '',
       '',
       '',
       '',
       'Bomba de Combustvel',
       'Bomba de Combustvel',
       'DBOM.CODTAB = DBIC.CODBOM',
       'CODBOM',
       'F' FROM DUAL
UNION ALL
SELECT 'DBIC',
       '01',
       20,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DBIC',
       '01',
       30,
       5,
       'CODTAN',
       'S',
       'DTAN',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TO_CHAR(DTAN.TANQUE)',
       'V',
       '',
       '',
       '',
       'F',
       'Cdigo do Tanque',
       'Cdigo do tanque',
       'DTAN.CODTAB = DBIC.CODTAN',
       'CODTAN',
       'F' FROM DUAL
UNION ALL
SELECT 'DBIC',
       '01',
       40,
       3,
       'FILBIC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Filial',
       '',
       'FILBIC',
       'F' FROM DUAL
UNION ALL
SELECT 'DBIC',
       '--',
       150,
       3,
       'FILLAC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do Lacre',
       'Filial do Lacre',
       '',
       'FILLAC',
       'F' FROM DUAL
UNION ALL
SELECT 'DBIC',
       '01',
       50,
       3,
       'MAXCHE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Prazo Mx.Cheque',
       'Prazo mximo para venda com cheque.',
       '',
       'MAXCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'DBIC',
       '01',
       60,
       1,
       'NIVPRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Nvel Preo',
       'Nvel de preo',
       '',
       'NIVPRE',
       'T' FROM DUAL
UNION ALL
SELECT 'DBIC',
       '01',
       70,
       2,
       'NUMBOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Nmero da Bomba',
       'Nmero da Bomba',
       '',
       '(SELECT IDBOM.NUMBOM FROM TD_BOM IDBOM WHERE IDBOM.CODTAB = DBIC.CODBOM)',
       '' FROM DUAL
UNION ALL
SELECT 'DBIC',
       '01',
       80,
       2,
       'QTDENC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Qtde Dgitos',
       'Quantidade de dgitos do encerrante',
       '',
       'QTDENC',
       'F' FROM DUAL
UNION ALL
SELECT 'DBIC',
       '01',
       90,
       2,
       'SEQBOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero Bico',
       'Seq. Bomba',
       '',
       'SEQBOM',
       'F' FROM DUAL
UNION ALL
SELECT 'DBIC',
       '01',
       100,
       2,
       'SEQFIL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero Lgico',
       'Nmero sequencial do bico na filial',
       '',
       'SEQFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'DBIC',
       '--',
       160,
       10,
       'SEQLAC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequncia do Lacre',
       'Sequncia do Lacre',
       '',
       'SEQLAC',
       'F' FROM DUAL
);

/*-- SEQ 7093 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DBIC',
       'NIVPRE',
       0,
       '1',
       ' Vista sem Carto de Crdito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DBIC',
       'NIVPRE',
       0,
       '2',
       ' Vista com carto de crdito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DBIC',
       'NIVPRE',
       0,
       '3',
       'A prazo',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7094 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DBOM',
       TO_NUMBER(null),
       'DBOM',
       'Bombas  Combustvel',
       'TD_BOM',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DBOM.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7095 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DBOM','--','' FROM DUAL
UNION ALL
SELECT 'DBOM','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DBOM','99','Outros' FROM DUAL
);

/*-- SEQ 7096 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DBOM',
       '--',
       70,
       1,
       'BOMATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       '',
       'Ativo?',
       'Ativo?',
       '',
       'BOMATI',
       '' FROM DUAL
UNION ALL
SELECT 'DBOM',
       '--',
       80,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Filial da Bomba',
       'Cdigo de Filial da Bomba',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'DBOM',
       '--',
       10,
       5,
       'CODTAB',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo da Bomba',
       'Cdigo da Bomba',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'DBOM',
       '--',
       50,
       60,
       'MODELO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Modelo da Bomba',
       'Modelo da Bomba',
       '',
       'MODELO',
       '' FROM DUAL
UNION ALL
SELECT 'DBOM',
       '--',
       40,
       60,
       'NOMFAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome Fabri. da Bomba',
       'Nome do Fabricante da Bomba',
       '',
       'NOMFAB',
       '' FROM DUAL
UNION ALL
SELECT 'DBOM',
       '--',
       30,
       60,
       'NSERIE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'N. de Srie da Bomba',
       'Numero de Srie da Bomba',
       '',
       'NSERIE',
       '' FROM DUAL
UNION ALL
SELECT 'DBOM',
       '--',
       20,
       2,
       'NUMBOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nmero da Bomba',
       'Nmero da Bomba',
       '',
       'NUMBOM',
       '' FROM DUAL
UNION ALL
SELECT 'DBOM',
       '--',
       60,
       1,
       'TIPMED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Ident. de medio',
       'Identificador de medio',
       '',
       'TIPMED',
       'T' FROM DUAL
);

/*-- SEQ 7097 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DBOM',
       'TIPMED',
       0,
       '0',
       'Analgico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DBOM',
       'TIPMED',
       0,
       '1',
       'Digital',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7098 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCAI',
       0,
       'DCAI',
       'Dom. Sangria/Reforo',
       'TD_CAI',
       'F',
       '',
       'TOTALL',
       'Sangria/Reforo',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DCAI.CX_COD',
       '' FROM DUAL
);

/*-- SEQ 7099 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCAI','--','' FROM DUAL
);

/*-- SEQ 7100 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 5356,
       'CTA ',
       'DCAI',
       'N',
       '1',
       '',
       '',
       'dcai.filcai = cta.codfil and
dcai.seqcai = cta.sequen and
dcai.tipcai = cta.tipcta and
dcai.ctacai = cta.usocta',
       '',
       '' FROM DUAL
);

/*-- SEQ 7101 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCAI',
       '--',
       200,
       2,
       'CAIMEN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo de Menu POS',
       'Cdigo de Menu no Totall POS',
       '',
       'CAIMEN',
       '' FROM DUAL
UNION ALL
SELECT 'DCAI',
       '--',
       150,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo~Tabela',
       'Cdigo Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAI',
       '--',
       130,
       1,
       'CTACAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Conta Caixa',
       'Conta Caixa',
       '',
       'CTACAI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAI',
       '--',
       10,
       1,
       'CX_ATI',
       'L',
       '',
       0,
       0,
       'DCAI',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'CX_ATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAI',
       '--',
       20,
       3,
       'CX_COD',
       'A',
       '',
       0,
       0,
       'DCAI',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Cdigo',
       'Cdigo de lanamento caixa',
       '',
       'CX_COD',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAI',
       '--',
       160,
       30,
       'CX_DES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio de lanamento caixa',
       '',
       'CX_DES',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAI',
       '--',
       50,
       1,
       'CX_HIS',
       'L',
       '',
       0,
       0,
       'DCAI',
       50,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Pede Histrico?',
       'Lanamento pede histrico?',
       '',
       'CX_HIS',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAI',
       '--',
       190,
       12,
       'CX_MAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Vlr mx lanam. CK4G',
       'Valor mximo por lanamento (Checkout 4G)',
       '',
       'CX_MAX',
       '' FROM DUAL
UNION ALL
SELECT 'DCAI',
       '--',
       40,
       10,
       'CX_USU',
       'N',
       '',
       0,
       0,
       'DCAI',
       40,
       30,
       '',
       '',
       'D',
       'TAB',
       'F',
       'N',
       'T',
       'Uso do Caixa',
       'Uso do lanamento caixa',
       '',
       'CX_USU',
       'T' FROM DUAL
UNION ALL
SELECT 'DCAI',
       '--',
       70,
       3,
       'FILCAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Filial da conta',
       'Filial conta',
       '',
       'FILCAI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAI',
       '--',
       180,
       10,
       'SEQCAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Chave da conta',
       'Chave conta',
       '',
       'SEQCAI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAI',
       '--',
       90,
       10,
       'TIPCAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo da conta',
       'Tipo da conta',
       '',
       'TIPCAI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAI',
       '--',
       140,
       1,
       'TRANSF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Transferencia?',
       'Transferencia',
       '',
       'TRANSF',
       'F' FROM DUAL
);

/*-- SEQ 7102 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DCAI',
       'CX_USU',
       0,
       ' ',
       'Sangria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCAI',
       'CX_USU',
       1,
       ' ',
       'Reforo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCAI',
       'CX_USU',
       2,
       ' ',
       'Ressarcimento de Vale Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7103 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCAR',
       0,
       'DCAR',
       'Dom. de Cartes',
       'TD_CAR',
       'T',
       '',
       'TOTALL',
       'Descrio de Carto',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DCAR.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7104 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCAR','--','' FROM DUAL
);

/*-- SEQ 7105 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 28860,
       'DCOB',
       'DCAR',
       'N',
       '1',
       '',
       '',
       'DCAR.PORCAR = DCOB.CODTAB AND
DCAR.COBCAR = DCOB.TIPCOB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 28861,
       'CTA ',
       'DCAR',
       '1',
       'N',
       '',
       '',
       'cta.codfil = dcar.filcar and
cta.sequen = dcar.seqcar and
cta.tipcta = dcar.tipcar and
cta.usocta = dcar.ctacar',
       '',
       '' FROM DUAL
UNION ALL
SELECT 28862,
       'REL ',
       'DCAR',
       'N',
       '1',
       '',
       '',
       'rel.filpar = dcar.filadm and
rel.codpar = dcar.codadm and
rel.tippar = dcar.tipadm',
       '',
       '' FROM DUAL
UNION ALL
SELECT 28863,
       'CAI ',
       'DCAR',
       'N',
       '1',
       '',
       '',
       'CAI.CARTAO = DCAR.CODTAB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 28864,
       'REC ',
       'DCAR',
       'N',
       '1',
       '',
       '',
       'REC.CARTAO = DCAR.CODTAB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45917,
       'RECP',
       'DCAR',
       'N',
       '1',
       '',
       '',
       'RECP.CARTAO = DCAR.CODTAB',
       '',
       '' FROM DUAL
);

/*-- SEQ 7106 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCAR',
       '--',
       270,
       5,
       'BANCRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Bandeira Crdito',
       'Cdigo da Bandeira do Carto de Crdito',
       '',
       'BANCRE',
       '' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       260,
       5,
       'BANDEB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Bandeira Dbito',
       'Cdigo da Bandeira do Carto de Dbito',
       '',
       'BANDEB',
       '' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       10,
       0,
       'CARATI',
       'L',
       '',
       0,
       0,
       'DCAR',
       30,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo?',
       '',
       'CARATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       180,
       255,
       'CARIMG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome do cone C4G',
       'Nome do cone para Checkout4G',
       '',
       'CARIMG',
       '' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       170,
       1,
       'CARLET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Letra de atalho C4G',
       'Letra de atalho para Checkout4G',
       '',
       'CARLET',
       '' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       190,
       14,
       'CARLIM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Limite de valores',
       'Limite de valores no caixa',
       '',
       'CARLIM',
       '' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       200,
       1,
       'CARNIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Nvel de Tela',
       'Nvel de Tela',
       '',
       'CARNIV',
       'T' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       40,
       1,
       'COBCAR',
       'A',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       '',
       'A',
       'F',
       'Cobranca Cartao',
       'Cobranca Cartao',
       'DCAR.PORCAR = DCOB.CODTAB AND DCAR.COBCAR = DCOB.TIPCOB',
       'COBCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       50,
       6,
       'CODADM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave Administradora',
       'Chave Administradora',
       '',
       'CODADM',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       250,
       3,
       'CODCRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo Credenciadora',
       'Cdigo da Credenciadora de carto de dbito ou crdito',
       '',
       'CODCRE',
       '' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       150,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo~Tabela',
       'Cdigo~Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       60,
       1,
       'CTACAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Conta do Cartao',
       'Conta do Cartao',
       '',
       'CTACAR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       160,
       20,
       'DESOUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio do Carto',
       '',
       'DESOUT',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       4,
       3,
       'DIACAR',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Vencimento',
       'Vencimento',
       '',
       'DIACAR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       70,
       3,
       'DIADEB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias para Debito',
       'Dias para Debito',
       '',
       'DIADEB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       230,
       10,
       'EXTCRE',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nmero Ext. Crdito',
       'Nmero Externo para Crdito',
       '',
       'EXTCRE',
       '' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       240,
       10,
       'EXTDEB',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nmero Ext. Dbito',
       'Nmero Externo para Dbito',
       '',
       'EXTDEB',
       '' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       80,
       3,
       'FILADM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fil Administradora',
       'Filial Administradora',
       '',
       'FILADM',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       90,
       3,
       'FILCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial do Cartao',
       'Filial do Cartao',
       '',
       'FILCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       220,
       2,
       'MINAUT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Tamanho autorizao',
       'Tamanho mnimo da autorizao',
       '',
       'MINAUT',
       '' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       100,
       5,
       'PORCAR',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       '',
       'A',
       'F',
       'Portador do Cartao',
       'Portador do Cartao',
       'DCOB.CODTAB = DCAR.PORCAR',
       'PORCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       6,
       1,
       'PROCAR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Carto Prprio?',
       'Carto Prprio?',
       '',
       'PROCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       210,
       15,
       'REGCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Registrador no ECF',
       'Registrador no ECF',
       '',
       'REGCAR',
       '' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       110,
       10,
       'SEQCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Chave Cartao',
       '',
       'SEQCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       5,
       12,
       'TAXCAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Taxa',
       'Taxa',
       '',
       'TAXCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       120,
       12,
       'TAXDEB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Taxa Debito',
       'Taxa Debito',
       '',
       'TAXDEB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       130,
       1,
       'TIPADM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Administradora',
       'Tipo Administradora',
       '',
       'TIPADM',
       'F' FROM DUAL
UNION ALL
SELECT 'DCAR',
       '--',
       140,
       1,
       'TIPCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Cartao',
       'Tipo Cartao',
       '',
       'TIPCAR',
       'F' FROM DUAL
);

/*-- SEQ 7107 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DCAR',
       'CARNIV',
       1,
       ' ',
       'Primeiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCAR',
       'CARNIV',
       2,
       ' ',
       'Segundo',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7108 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCCB',
       TO_NUMBER(null),
       'DCCB',
       'Dom.Conta C.Bancria',
       'TD_CCB',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DCCB.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7109 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCCB','--','' FROM DUAL
UNION ALL
SELECT 'DCCB','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DCCB','99','Outros' FROM DUAL
);

/*-- SEQ 7110 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5362,
       'CCB ',
       'DCCB',
       '1 ',
       'N ',
       '',
       '',
       'CCB.CODCCB = DCCB.CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 5363,
       'REM ',
       'DCCB',
       '1 ',
       'N ',
       '',
       '',
       'REM.CODCCB = DCCB.CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 5364,
       'TIT ',
       'DCCB',
       '1 ',
       'N ',
       '',
       '',
       'TIT.CODCCB = DCCB.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7111 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCCB',
       '--',
       10,
       10,
       'APECCB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Apelido Carteira',
       'Apelido Carteira',
       '',
       'APECCB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCCB',
       '--',
       20,
       1,
       'CCBATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativa?',
       'Carteira Ativa?',
       '',
       'CCBATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCCB',
       '--',
       30,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCCB',
       '--',
       40,
       30,
       'DESCCB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao Carteira',
       'Descricao da Carteira',
       '',
       'DESCCB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCCB',
       '--',
       60,
       1,
       'ENVREM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Envia Remessa?',
       'Envia Remessa',
       '',
       'ENVREM',
       'F' FROM DUAL
UNION ALL
SELECT 'DCCB',
       '--',
       50,
       1,
       'TIPCCB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Carteira',
       'Tipo da Carteira',
       '',
       'TIPCCB',
       'T' FROM DUAL
);

/*-- SEQ 7112 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DCCB',
       'TIPCCB',
       0,
       'P',
       'Proprio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCCB',
       'TIPCCB',
       0,
       'T',
       'Terceirizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7113 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCCC',
       TO_NUMBER(null),
       'DCCC',
       'Dom. C/C Cliente',
       'TD_CCC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DCC.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7114 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCCC','--','' FROM DUAL
UNION ALL
SELECT 'DCCC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DCCC','99','Outros' FROM DUAL
);

/*-- SEQ 7115 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22497,
       'CTA ',
       'DCCC',
       'N',
       '1',
       '',
       '',
       'CTA.CODFIL = DCCC.FILCCC AND
CTA.SEQUEN = DCCC.SEQCCC AND
CTA.TIPCTA = DCCC.TIPCCC AND
CTA.USOCTA = DCCC.CTACCC',
       '',
       '' FROM DUAL
);

/*-- SEQ 7116 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCCC',
       '--',
       100,
       254,
       'ASSCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Assunto e-mail
',
       'Assunto e-mail',
       '',
       'ASSCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'DCCC',
       '--',
       10,
       1,
       'CCCATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'CCCATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCCC',
       '--',
       190,
       1,
       'CCCCAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Aceita dep/ret?',
       'Aceita depsito/retirada?',
       '',
       'CCCCAI',
       '' FROM DUAL
UNION ALL
SELECT 'DCCC',
       '--',
       160,
       255,
       'CCCIMG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome do cone C4G',
       'Nome do cone para Checkout4G',
       '',
       'CCCIMG',
       '' FROM DUAL
UNION ALL
SELECT 'DCCC',
       '--',
       150,
       1,
       'CCCLET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Letra de atalho C4G',
       'Letra de atalho para Checkout4G',
       '',
       'CCCLET',
       '' FROM DUAL
UNION ALL
SELECT 'DCCC',
       '--',
       170,
       14,
       'CCCLIM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Limite de valores',
       'Limite de valores no caixa',
       '',
       'CCCLIM',
       '' FROM DUAL
UNION ALL
SELECT 'DCCC',
       '--',
       180,
       1,
       'CCCNIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Nvel de Tela',
       'Nvel de Tela',
       '',
       'CCCNIV',
       'T' FROM DUAL
UNION ALL
SELECT 'DCCC',
       '--',
       20,
       1,
       'CLILIV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Cliente difere Venda',
       'Cliente diferente da venda?',
       '',
       'CLILIV',
       'F' FROM DUAL
UNION ALL
SELECT 'DCCC',
       '--',
       210,
       20,
       'CODEXT_DCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd. Externo',
       'Cdigo Externo',
       '',
       'CODEXT_DCCC',
       '' FROM DUAL
UNION ALL
SELECT 'DCCC',
       '--',
       30,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCCC',
       '--',
       40,
       1,
       'COMCCC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Exige~Complemento?',
       'Exige Complemento?',
       '',
       'COMCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'DCCC',
       '--',
       110,
       1,
       'CTACCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Codigo Conta',
       'Codigo Conta',
       '',
       'CTACCC',
       'F' FROM DUAL
UNION ALL
SELECT 'DCCC',
       '--',
       50,
       30,
       'DESCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao C/C',
       'Descricao C/C Cliente',
       '',
       'DESCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'DCCC',
       '--',
       60,
       2,
       'DIARET',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Dias para Retorno',
       'Dias para retorno',
       '',
       'DIARET',
       'F' FROM DUAL
UNION ALL
SELECT 'DCCC',
       '--',
       70,
       3,
       'FILCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial C/C Cliente',
       'Filial C/C Cliente',
       '',
       'FILCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'DCCC',
       '--',
       120,
       15,
       'REGCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Registrador para ECF',
       'Registrador para ECF',
       '',
       'REGCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'DCCC',
       '--',
       80,
       10,
       'SEQCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Seq. C/C Cliente',
       '',
       'SEQCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'DCCC',
       '--',
       140,
       10,
       'SQLCCC',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Formato imp. C/C',
       'Formato de impresso de C/C no padro SQL',
       '',
       'RTF2TXT(SQLCCC)',
       '' FROM DUAL
UNION ALL
SELECT 'DCCC',
       '--',
       90,
       1,
       'TIPCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo C/C',
       'Tipo C/C Cliente',
       '',
       'TIPCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'DCCC',
       '--',
       130,
       4000,
       'TXTCCC',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Corpo do e-mail',
       'Corpo do e-mail',
       '',
       'TXTCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'DCCC',
       '--',
       200,
       10,
       'VLRBON',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr Converso Bnus',
       'Valor Conversvel de Bnus Resgatveis no CheckOut 4G',
       '',
       'VLRBON',
       '' FROM DUAL
);

/*-- SEQ 7117 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DCCC',
       'CCCNIV',
       1,
       ' ',
       'Primeiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCCC',
       'CCCNIV',
       2,
       ' ',
       'Segundo',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7118 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCFO',
       TO_NUMBER(null),
       'DCFO',
       'Dom. CFOPs Compras',
       'TD_CFO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DCFO.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7119 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCFO','--','' FROM DUAL
UNION ALL
SELECT 'DCFO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DCFO','99','Outros' FROM DUAL
);

/*-- SEQ 7120 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCFO',
       '99',
       60,
       1,
       'CFOATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'CFOATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFO',
       '99',
       70,
       3,
       'CFOCTA_FIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Conta',
       'Filial Conta Gerencial para Compras',
       '',
       'CFOCTA_FIL',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFO',
       '99',
       80,
       10,
       'CFOCTA_SEQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Seq. Conta',
       'Sequnciador Conta Gerencial para Compras',
       '',
       'CFOCTA_SEQ',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFO',
       '99',
       90,
       1,
       'CFOCTA_TIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta Gerencial para Compras',
       '',
       'CFOCTA_TIP',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFO',
       '99',
       100,
       6,
       'CFOFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'CFOP Fornecedor',
       'CFOP de Sada na Nota do Fornecedor',
       '',
       'CFOFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFO',
       '99',
       110,
       2,
       'CFOMOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mod. Fiscal',
       'Modelo Fiscal',
       '',
       'CFOMOD',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFO',
       '01',
       120,
       6,
       'CODCFO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'CFOP',
       'Cdigo CFOP',
       '',
       'CODCFO',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFO',
       '01',
       40,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFO',
       '01',
       50,
       40,
       'DESCFO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio CFOP',
       'Descrio CFOP de Compra',
       '',
       'DESCFO',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFO',
       '01',
       130,
       10,
       'EXTCFO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'EXTCFO',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFO',
       '99',
       140,
       1,
       'MOVEST_DCFO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Mov. Estoque?',
       'Movimenta Estoque?',
       '',
       'MOVEST_DCFO',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFO',
       '99',
       150,
       1,
       'TIPCCM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo Custo Mdio',
       'Tipo Custo Mdio',
       '',
       'TIPCCM',
       'T' FROM DUAL
);

/*-- SEQ 7121 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DCFO',
       'TIPCCM',
       0,
       'C',
       'Calculado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCFO',
       'TIPCCM',
       0,
       'M',
       'Manter Custo Atual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCFO',
       'TIPCCM',
       0,
       'Z',
       'Custo Zero',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7122 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCFP',
       TO_NUMBER(null),
       'DCFP',
       'CFOP por Produto',
       'TD_CFP',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DCFP.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7123 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCFP','--','' FROM DUAL
UNION ALL
SELECT 'DCFP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DCFP','99','Outros' FROM DUAL
);

/*-- SEQ 7124 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCFP',
       '--',
       10,
       1,
       'CFPATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Ativo ?',
       'Ativo ?',
       '',
       'CFPATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       20,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo',
       'Cdigo',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       30,
       3,
       'COMCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Com Cons Final D',
       'Sufixo da natureza de compra para "consumidor final" Dentro do Estado',
       '',
       'COMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       180,
       3,
       'COMCON_FOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Com Cons Final F',
       'Sufixo da natureza de compra para "consumidor final" Fora do Estado',
       '',
       'COMCON_FOR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       40,
       3,
       'COMREV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Com Revenda D',
       'Sufixo da natureza de compra para "Revenda" Dentro do Estado',
       '',
       'COMREV',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       190,
       3,
       'COMREV_FOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Com Revenda F',
       'Sufixo da natureza de compra para "Revenda" Fora do Estado',
       '',
       'COMREV_FOR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       50,
       20,
       'DESCFP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio do grupo de CFOP''s.',
       '',
       'DESCFP',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       60,
       3,
       'DEVCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Dev Ve Con Fim D',
       'Sufixo da nat. de devol. de venda para "consum. final" Dentro do Estado',
       '',
       'DEVCON',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       200,
       3,
       'DEVCON_FOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Dev Ve Con Fim F',
       'Sufixo da nat. de devoluo de venda para "consum. final" Fora do Estado',
       '',
       'DEVCON_FOR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       70,
       3,
       'DEVREV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Dev Ven Reven D',
       'Sufixo da natureza de devoluo de venda para "Revenda" Dentro do Estado',
       '',
       'DEVREV',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       210,
       3,
       'DEVREV_FOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Dev Ven Reven F',
       'Sufixo da natureza de devoluo de venda para "Revenda" Fora do Estado',
       '',
       'DEVREV_FOR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       80,
       3,
       'DVCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Dev Co Con Fim D',
       'Sufixo da nat. de devol. de compra para "consum. final" Dentro do Estado',
       '',
       'DVCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       220,
       3,
       'DVCCON_FOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Dev Co Con Fim F',
       'Sufixo da nat. de devoluo de comp. para "consum. final" Fora do Estado',
       '',
       'DVCCON_FOR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       90,
       3,
       'DVCREV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Dev Com Reven D',
       'Sufixo da natureza de devoluo de comp. para "Revenda" Dentro do Estado',
       '',
       'DVCREV',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       230,
       3,
       'DVCREV_FOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Dev Com Reven F',
       'Sufixo da natureza de devoluo de compra para "Revenda" Fora do Estado',
       '',
       'DVCREV_FOR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       100,
       3,
       'ENTCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Ent Cons Final D',
       'Sufixo da nat. de ent. via transf. para "consum. final" Dentro do Estado',
       '',
       'ENTCON',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       240,
       3,
       'ENTCON_FOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Nat Ent Cons Final F',
       'Sufixo da nat. de ent. via transf. para "consum. final" Fora do Estado',
       '',
       'ENTCON_FOR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       110,
       3,
       'ENTREV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Ent Revenda D',
       'Sufixo da natureza de ent. via transf. para "Revenda" Dentro do Estado',
       '',
       'ENTREV',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       250,
       3,
       'ENTREV_FOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Ent Revenda F',
       'Sufixo da nat. de entrada via transf. para "Revenda" Fora do Estado',
       '',
       'ENTREV_FOR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       120,
       3,
       'INTCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Cons Cons Fin D',
       'Sufixo da nat. de cons. interno para "consumidor final" Dentro do Estado',
       '',
       'INTCON',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       260,
       3,
       'INTCON_FOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Cons Cons Fin F',
       'Sufixo da nat. de consum. interno para "consumidor final" Fora do Estado',
       '',
       'INTCON_FOR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       130,
       3,
       'INTREV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Cons Revenda D',
       'Sufixo da natureza de consumo interno para "Revenda" Dentro do Estado',
       '',
       'INTREV',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       270,
       3,
       'INTREV_FOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Cons Revenda F',
       'Sufixo da natureza de consumo interno para "Revenda" Fora do Estado',
       '',
       'INTREV_FOR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       140,
       3,
       'SAICON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Saida Cons Fin D',
       'Sufixo da nat. de sada via transf. para "consum final" Dentro do Estado',
       '',
       'SAICON',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       280,
       3,
       'SAICON_FOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Saida Cons Fin F',
       'Sufixo da nat. de sada via transf. para "consum. final" Fora do Estado',
       '',
       'SAICON_FOR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       150,
       3,
       'SAIREV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Saida Revenda D',
       'Sufixo da natureza de sada via transf. para "Revenda" Dentro do Estado',
       '',
       'SAIREV',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       290,
       3,
       'SAIREV_FOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Saida Revenda F',
       'Sufixo da nat. de sada via transferncia para "Revenda" Fora do Estado',
       '',
       'SAIREV_FOR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       160,
       3,
       'VENCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Ven Cons Final D',
       'Sufixo da natureza de venda para "consumidor final" Dentro do Estado',
       '',
       'VENCON',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       300,
       3,
       'VENCON_FOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Ven Cons Final F',
       'Sufixo da natureza de venda para "consumidor final" Fora do Estado',
       '',
       'VENCON_FOR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       170,
       3,
       'VENREV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Ven Revenda D',
       'Sufixo da natureza de venda para "Revenda" Dentro do Estado',
       '',
       'VENREV',
       'F' FROM DUAL
UNION ALL
SELECT 'DCFP',
       '--',
       310,
       3,
       'VENREV_FOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Ven Revenda F',
       'Sufixo da natureza de venda para "Revenda" Fora do Estado',
       '',
       'VENREV_FOR',
       'F' FROM DUAL
);

/*-- SEQ 7125 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCL1',
       0,
       'DCL1',
       'Dom. Classe 1',
       'TD_CL1',
       'F',
       '',
       'TOTALL',
       'Nome da Classe 1',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DCL1.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7126 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCL1','--','' FROM DUAL
);

/*-- SEQ 7127 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCL1',
       '--',
       10,
       1,
       'CL1ATI',
       'L',
       '',
       0,
       0,
       'DCL1',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'CL1ATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCL1',
       '--',
       70,
       1,
       'CL1WEB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Mostrar na web?',
       'Mostrar na web?',
       '',
       'CL1WEB',
       '' FROM DUAL
UNION ALL
SELECT 'DCL1',
       '--',
       20,
       40,
       'CLASS1',
       'A',
       '',
       0,
       0,
       'DCL1',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       '',
       'Nome da classe 1',
       '',
       'CLASS1',
       'F' FROM DUAL
UNION ALL
SELECT 'DCL1',
       '--',
       40,
       20,
       'CODEX1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Codigo Externo',
       'Codigo Externo',
       '',
       'CODEX1',
       'F' FROM DUAL
UNION ALL
SELECT 'DCL1',
       '--',
       30,
       2,
       'CODTAB',
       'N',
       '',
       0,
       TO_NUMBER(null),
       'DCL1',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCL1',
       '--',
       50,
       1,
       'COMBUS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Classe Combustveis?',
       'Classe corresponde a combustveis?',
       '',
       'COMBUS',
       'F' FROM DUAL
UNION ALL
SELECT 'DCL1',
       '--',
       60,
       5,
       'NATCL1',
       'S',
       'DNAT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DNAT.NATURE',
       'V',
       '',
       '',
       'A',
       'F',
       'Natureza Especial',
       'Natureza Especial',
       'DNAT.CODTAB = DCL1.NATCL1(+)',
       'NATCL1',
       'T' FROM DUAL
);

/*-- SEQ 7128 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCL2',
       0,
       'DCL2',
       'Dom. Classe 2',
       'TD_CL2',
       'F',
       '',
       'TOTALL',
       'Nome da Classe 2',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DCL2.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7129 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCL2','--','' FROM DUAL
);

/*-- SEQ 7130 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCL2',
       '--',
       40,
       1,
       'CL2ATI',
       'L',
       '',
       0,
       0,
       'DCL2',
       20,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'CL2ATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCL2',
       '--',
       70,
       1,
       'CL2WEB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Mostrar na web?',
       'Mostrar na web?',
       '',
       'CL2WEB',
       '' FROM DUAL
UNION ALL
SELECT 'DCL2',
       '--',
       30,
       40,
       'CLASS2',
       'A',
       '',
       0,
       0,
       'DCL2',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       '',
       'Nome da classe 2',
       '',
       'CLASS2',
       'F' FROM DUAL
UNION ALL
SELECT 'DCL2',
       '--',
       60,
       20,
       'CODEX2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Codigo Externo',
       'Codigo Externo',
       '',
       'CODEX2',
       'F' FROM DUAL
UNION ALL
SELECT 'DCL2',
       '--',
       50,
       2,
       'CODTAB',
       'N',
       '',
       0,
       TO_NUMBER(null),
       'DCL2',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
);

/*-- SEQ 7131 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCL3',
       0,
       'DCL3',
       'Dom. Classe 3',
       'TD_CL3',
       'F',
       '',
       'TOTALL',
       'Nome da Classe 3',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DCL3.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7132 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCL3','--','' FROM DUAL
);

/*-- SEQ 7133 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCL3',
       '--',
       50,
       1,
       'CL3ATI',
       'L',
       '',
       0,
       0,
       'DCL3',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'CL3ATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCL3',
       '--',
       90,
       1,
       'CL3WEB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Mostrar na web?',
       'Mostrar na web?',
       '',
       'CL3WEB',
       '' FROM DUAL
UNION ALL
SELECT 'DCL3',
       '--',
       60,
       40,
       'CLASS3',
       'A',
       '',
       0,
       0,
       'DCL3',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       '',
       'Nome da classe 3',
       '',
       'CLASS3',
       'F' FROM DUAL
UNION ALL
SELECT 'DCL3',
       '--',
       80,
       20,
       'CODEX3',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Codigo Externo',
       'Codigo Externo',
       '',
       'CODEX3',
       'F' FROM DUAL
UNION ALL
SELECT 'DCL3',
       '--',
       70,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DCL3',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
);

/*-- SEQ 7134 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCL4',
       0,
       'DCL4',
       'Dom. Classe 4',
       'TD_CL4',
       'F',
       '',
       'TOTALL',
       'Nome da Classe 4',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DCL4.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7135 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCL4','--','' FROM DUAL
);

/*-- SEQ 7136 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCL4',
       '--',
       70,
       1,
       'CL4ATI',
       'L',
       '',
       0,
       0,
       'DCL4',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'CL4ATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCL4',
       '--',
       110,
       1,
       'CL4WEB',
       'L',
       '',
       1,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Mostrar na web?',
       'Mostrar na web?',
       '',
       'CL4WEB',
       '' FROM DUAL
UNION ALL
SELECT 'DCL4',
       '--',
       80,
       40,
       'CLASS4',
       'A',
       '',
       0,
       0,
       'DCL4',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       '',
       'Nome da classe 4',
       '',
       'CLASS4',
       'F' FROM DUAL
UNION ALL
SELECT 'DCL4',
       '--',
       100,
       20,
       'CODEX4',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Codigo Externo',
       'Codigo Externo',
       '',
       'CODEX4',
       'F' FROM DUAL
UNION ALL
SELECT 'DCL4',
       '--',
       90,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DCL4',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
);

/*-- SEQ 7137 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCLT',
       TO_NUMBER(null),
       'DCLT',
       'Dom. C.L.T.',
       'TD_CLT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DCLT.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7138 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCLT','--','' FROM DUAL
);

/*-- SEQ 7139 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCLT',
       '--',
       3,
       1,
       'CLTATV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'CLT Ativa?',
       'Carteira L. de Trabalho ativa?',
       '',
       'CLTATV',
       'F' FROM DUAL
UNION ALL
SELECT 'DCLT',
       '--',
       1,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCLT',
       '--',
       2,
       25,
       'DESCLT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Desc. CLT',
       'Descrio da Carteira L. de Trabalho',
       '',
       'DESCLT',
       'F' FROM DUAL
);

/*-- SEQ 7140 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCNC',
       TO_NUMBER(null),
       'DCNC',
       'Dom. Concorrncia',
       'TD_CNC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DCNC.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7141 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCNC','--','' FROM DUAL
);

/*-- SEQ 7142 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCNC',
       '--',
       300,
       1,
       'CNCATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Ativo?',
       'Ativo',
       '',
       'CNCATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCNC',
       '--',
       100,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCNC',
       '--',
       200,
       30,
       'NOMCNC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Nome da Concorrncia',
       'Nome da Concorrncia',
       '',
       'NOMCNC',
       'F' FROM DUAL
);

/*-- SEQ 7143 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCOB',
       0,
       'DCOB',
       'Dom. Cobranas',
       'TD_COB',
       'T',
       '',
       'TOTALL',
       'Cobranas',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DCOB.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7144 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCOB','--','' FROM DUAL
UNION ALL
SELECT 'DCOB','01','Identificao' FROM DUAL
);

/*-- SEQ 7145 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22498,
       'CLI ',
       'DCOB',
       '0N',
       '01',
       '',
       '',
       'CLI.PORPAD = DCOB.CODTAB AND
CLI.TIPCOB = DCOB.TIPCOB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22499,
       'CTA ',
       'DCOB',
       '01',
       '0N',
       '',
       '',
       'CTA.CODFIL = DCOB.FILCTA AND
CTA.SEQUEN = DCOB.SEQCTA AND
CTA.TIPCTA = DCOB.TIPCTA AND
CTA.USOCTA = DCOB.TIPCOB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22500,
       'CTB ',
       'DCOB',
       '01',
       '0N',
       '',
       '',
       'CTB.FILCTA = DCOB.FILCTA AND
CTB.SEQCTA = DCOB.SEQCTA AND
CTB.TIPCTA = DCOB.TIPCTA AND
CTB.TIPCTB = DCOB.TIPCTB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22501,
       'LIM ',
       'DCOB',
       '0N',
       '01',
       '',
       '',
       'LIM.CODCOB = DCOB.CODTAB AND
LIM.TIPCOB = DCOB.TIPCOB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22502,
       'PLA ',
       'DCOB',
       '0N',
       '01',
       '',
       '',
       'PLA.CODCOB = DCOB.CODTAB AND
PLA.TIPCOB = DCOB.TIPCOB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22503,
       'REC ',
       'DCOB',
       '0N',
       '01',
       '',
       '',
       'REC.PORTAD = DCOB.CODTAB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45918,
       'RECP',
       'DCOB',
       '0N',
       '01',
       '',
       '',
       'RECP.PORTAD = DCOB.CODTAB',
       '',
       '' FROM DUAL
);

/*-- SEQ 7146 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCOB',
       '--',
       110,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '@',
       'F',
       'Ultima atualizao',
       'Ultima atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOB',
       '01',
       50,
       1,
       'COBATI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'DCOB',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Ativo',
       'Ativo',
       '',
       'COBATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOB',
       '--',
       160,
       255,
       'COBIMG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome do cone C4G',
       'Nome do cone para Checkout4G',
       '',
       'COBIMG',
       '' FROM DUAL
UNION ALL
SELECT 'DCOB',
       '--',
       150,
       1,
       'COBLET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Letra de atalho C4G',
       'Letra de atalho para Checkout4G',
       '',
       'COBLET',
       '' FROM DUAL
UNION ALL
SELECT 'DCOB',
       '--',
       170,
       1,
       'COBNIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Nvel de Tela',
       'Nvel de Tela',
       '',
       'COBNIV',
       'T' FROM DUAL
UNION ALL
SELECT 'DCOB',
       '--',
       120,
       5,
       'COBPAD',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       '',
       'A',
       'F',
       'Port. Pad. Pgt. Parc',
       'Portador Padro para Pagamento Parcial',
       'DCOB.CODTAB(+) = DCOB.COBPAD',
       'COBPAD',
       'T' FROM DUAL
UNION ALL
SELECT 'DCOB',
       '01',
       100,
       5,
       'CODCCB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Codigo C/C',
       'Cdigo C/C',
       '',
       'CODCCB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOB',
       '--',
       180,
       20,
       'CODEXT_DCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd. Externo',
       'Cdigo Externo',
       '',
       'CODEXT_DCOB',
       '' FROM DUAL
UNION ALL
SELECT 'DCOB',
       '01',
       60,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DCOB',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOB',
       '01',
       30,
       30,
       'DESCOB',
       'A',
       '',
       0,
       0,
       'DCOB',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Descrio',
       'Descrio da cobrana',
       '',
       'DESCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOB',
       '01',
       7,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOB',
       '01',
       70,
       1,
       'GERTIT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Gera Titulos?',
       'Gera Ttulos',
       '',
       'GERTIT',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOB',
       '01',
       40,
       2,
       'LARUNI',
       'S',
       '',
       0,
       0,
       'DCOB',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       'N',
       'T',
       'Extenso',
       'Extenso',
       '',
       'LARUNI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOB',
       '01',
       6,
       200,
       'SAICAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Dispositivo de Sada',
       'Dispositivo de Sada',
       '',
       'SAICAR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOB',
       '01',
       8,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Chave da Conta',
       '',
       '(DCOB.FILCTA||DCOB.SEQCTA)',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOB',
       '01',
       80,
       1,
       'TIPCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Cobrana',
       'Tipo de Cobrana',
       '',
       'TIPCOB',
       'T' FROM DUAL
UNION ALL
SELECT 'DCOB',
       '01',
       9,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo da Conta',
       'Tipo da Conta',
       '',
       'TIPCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOB',
       '01',
       90,
       1,
       'TIPCTB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Tipo C/C?',
       'Tipo C/C?',
       '',
       'TIPCTB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOB',
       '01',
       5,
       4000,
       'TXTCOB',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Formato da Cobrana',
       'Formato da Cobrana',
       '',
       'RTF2TXT(TXTCOB)',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOB',
       '01',
       130,
       14,
       'VLRABL',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Val. Acre. Boleto',
       'Valor Mnimo do Boleto',
       '',
       'VLRABL',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOB',
       '01',
       140,
       14,
       'VLRMBL',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Val. Min. Boleto',
       'Valor Mnimo do Boleto',
       '',
       'VLRMBL',
       'F' FROM DUAL
);

/*-- SEQ 7147 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DCOB',
       'COBNIV',
       1,
       ' ',
       'Primeiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCOB',
       'COBNIV',
       2,
       ' ',
       'Segundo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCOB',
       'TIPCOB',
       0,
       'B',
       'Bancos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCOB',
       'TIPCOB',
       0,
       'C',
       'Cartes de Crdito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCOB',
       'TIPCOB',
       0,
       'E',
       'ECFs',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCOB',
       'TIPCOB',
       0,
       'L',
       'Limites C/C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCOB',
       'TIPCOB',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCOB',
       'TIPCOB',
       0,
       'P',
       'Portadores',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7148 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCOL',
       TO_NUMBER(null),
       'DCOL',
       'Dom. Coletores',
       'TD_COL',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DCOL.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7149 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCOL','--','' FROM DUAL
UNION ALL
SELECT 'DCOL','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DCOL','02','Datas' FROM DUAL
UNION ALL
SELECT 'DCOL','03','Valores' FROM DUAL
UNION ALL
SELECT 'DCOL','99','Outros' FROM DUAL
);

/*-- SEQ 7150 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCOL',
       '01',
       1,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOL',
       '99',
       3,
       1,
       'COLATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Coletor Ativo?',
       'Coletor Ativo?',
       '',
       'COLATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOL',
       '03',
       9,
       2,
       'COLQTD',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Qtde Coletores',
       'Quantidade de Coletores',
       '',
       'COLQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOL',
       '03',
       8,
       2,
       'COLREF',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Referncia do Coleto',
       'Referncia do Coletor',
       '',
       'COLREF',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOL',
       '03',
       10,
       3,
       'DELIMI',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Delimitador',
       'Delimitador',
       '',
       'DELIMI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOL',
       '03',
       7,
       3,
       'FIMQTD',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade Final',
       'Quantidade Final',
       '',
       'FIMQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOL',
       '03',
       5,
       3,
       'FIMREF',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Referncia Final',
       'Referncia Final',
       '',
       'FIMREF',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOL',
       '99',
       12,
       1,
       'FOOTER',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tem Rodap?',
       'Tem Rodap?',
       '',
       'FOOTER',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOL',
       '99',
       11,
       1,
       'HEADER',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tem Cabealho?',
       'Tem Cabealho?',
       '',
       'HEADER',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOL',
       '03',
       6,
       3,
       'INIQTD',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade Inicial',
       'Quantidade Inicial',
       '',
       'INIQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOL',
       '03',
       4,
       3,
       'INIREF',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Referncia Inicial',
       'Referncia Inicial',
       '',
       'INIREF',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOL',
       '01',
       2,
       30,
       'NOMCOL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Coletor',
       'Nome Coletor',
       '',
       'NOMCOL',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOL',
       '03',
       14,
       1,
       'QTDDEC',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Qtde Decimais',
       'Quantidade de Decimais',
       '',
       'QTDDEC',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOL',
       '99',
       13,
       1,
       'SEPDEC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Separator Decimal',
       'Separador Decimal',
       '',
       'SEPDEC',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOL',
       '--',
       24,
       1,
       'ZERESQ',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Preenche zero',
       'Coletor preenche referncia com zero a esquerda',
       '',
       'ZERESQ',
       'F' FROM DUAL
);

/*-- SEQ 7151 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCOM',
       0,
       'DCOM',
       'Dom. Compras',
       'TD_COM',
       'F',
       '',
       'TOTALL',
       'Pedido de Compra',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DCOM.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7152 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCOM','--','' FROM DUAL
);

/*-- SEQ 7153 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCOM',
       '--',
       500,
       4000,
       'CABCOM',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Uso interno',
       'Compatibilidade com verses anteriores',
       '',
       'RTF2TXT(CABCOM)',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOM',
       '--',
       40,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DCOM',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOM',
       '--',
       20,
       1,
       'COMATI',
       'L',
       '',
       0,
       0,
       'DCOM',
       20,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'COMATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOM',
       '--',
       10,
       30,
       'DESCOM',
       'A',
       '',
       0,
       0,
       'DCOM',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Descrio Ped.Compra',
       'Descrio do Pedido de Compra',
       '',
       'DESCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOM',
       '--',
       600,
       4000,
       'ITECOM',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       60,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Itens de Compras',
       'Item de Compras',
       '',
       'RTF2TXT(ITECOM)',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOM',
       '--',
       30,
       2,
       'NUMCOM',
       'S',
       '',
       0,
       0,
       'DCOM',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       '',
       'T',
       'N de itens',
       'Nmero de itens do Pedido de Compra',
       '',
       'NUMCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOM',
       '--',
       700,
       4000,
       'RODCOM',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       70,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Uso interno',
       'Compatibilidade com verses anteriores',
       '',
       'RTF2TXT(RODCOM)',
       'F' FROM DUAL
);

/*-- SEQ 7154 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCON',
       TO_NUMBER(null),
       'DCON',
       'Dom. Tipos Contatos',
       'TD_CON',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DCON.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7155 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCON','--','' FROM DUAL
UNION ALL
SELECT 'DCON','01','Identificao' FROM DUAL
);

/*-- SEQ 7156 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCON',
       '01',
       50,
       1,
       'CLACON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Referncia',
       'Referncia',
       '',
       'CLACON',
       'T' FROM DUAL
UNION ALL
SELECT 'DCON',
       '01',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCON',
       '01',
       20,
       1,
       'CONATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'CONATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCON',
       '01',
       30,
       15,
       'DESCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Descrio',
       'Descrio',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'DCON',
       '01',
       40,
       1,
       'TIPCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       40,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'T',
       'Uso',
       'Uso',
       '',
       'TIPCON',
       'T' FROM DUAL
);

/*-- SEQ 7157 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DCON',
       'CLACON',
       0,
       'D',
       'Dependentes',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCON',
       'CLACON',
       0,
       'F',
       'Referncia Familiar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCON',
       'CLACON',
       0,
       'O',
       'Outras',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCON',
       'CLACON',
       0,
       'P',
       'Referncia Pessoal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCON',
       'TIPCON',
       0,
       'F',
       'Fsica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCON',
       'TIPCON',
       0,
       'J',
       'Jurdica',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7158 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCOR',
       TO_NUMBER(null),
       'DCOR',
       'Dom. Correspondncia',
       'TD_COR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DCOR.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7159 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCOR','--','' FROM DUAL
UNION ALL
SELECT 'DCOR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DCOR','99','Outros' FROM DUAL
);

/*-- SEQ 7160 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCOR',
       '--',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOR',
       '--',
       20,
       1,
       'CORATV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Correspondn. Ativa?',
       'Correspondncia Ativa?',
       '',
       'CORATV',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOR',
       '--',
       30,
       254,
       'RB_COR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'RB. Correspondncia',
       'RB. Correspondncia',
       '',
       'RB_COR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCOR',
       '--',
       40,
       30,
       'TITCOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo Correspondn.',
       '',
       '',
       'TITCOR',
       'F' FROM DUAL
);

/*-- SEQ 7161 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCRE',
       TO_NUMBER(null),
       'DCRE',
       'Dom.Controle Crdito',
       'TD_CRE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DCRE.COLUNA',
       '' FROM DUAL
);

/*-- SEQ 7162 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCRE','--','' FROM DUAL
UNION ALL
SELECT 'DCRE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DCRE','99','Outros' FROM DUAL
);

/*-- SEQ 7163 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5388,
       'CRE ',
       'DCRE',
       'N ',
       '1 ',
       '',
       '',
       'CRE.COLUNA = DCRE.COLUNA AND
CRE.TIPDAD = DCRE.TIPDAD',
       '' FROM DUAL
);

/*-- SEQ 7164 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCRE',
       '01',
       10,
       6,
       'COLPAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Coluna Pai',
       'Coluna Pai',
       '',
       'COLPAI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCRE',
       '01',
       20,
       6,
       'COLUNA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome da Coluna',
       'Nome da Coluna',
       '',
       'COLUNA',
       'F' FROM DUAL
UNION ALL
SELECT 'DCRE',
       '01',
       30,
       40,
       'DESCRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'DESCRI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCRE',
       '01',
       40,
       40,
       'DESPON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Descrio de Pontos',
       'Descrio de Pontos',
       '',
       'DESPON',
       'F' FROM DUAL
UNION ALL
SELECT 'DCRE',
       '01',
       50,
       1,
       'TIPDAD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Dados',
       'Tipo de Dados',
       '',
       'TIPDAD',
       'T' FROM DUAL
);

/*-- SEQ 7165 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DCRE',
       'TIPDAD',
       0,
       '0',
       'Num. Zeros a Esquerda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCRE',
       'TIPDAD',
       0,
       '9',
       'Num. Espacos a Esquerda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCRE',
       'TIPDAD',
       0,
       '@',
       'Data + Hora',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCRE',
       'TIPDAD',
       0,
       'A',
       'Alfanumerico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCRE',
       'TIPDAD',
       0,
       'B',
       'BMP (path ou direto)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCRE',
       'TIPDAD',
       0,
       'D',
       'Datas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCRE',
       'TIPDAD',
       0,
       'F',
       'Real',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCRE',
       'TIPDAD',
       0,
       'N',
       'Numerico a esquerda',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7166 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCRT',
       TO_NUMBER(null),
       'DCRT',
       'Caracterizao',
       'TD_CRT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7167 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCRT','--','' FROM DUAL
UNION ALL
SELECT 'DCRT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DCRT','99','Outros' FROM DUAL
);

/*-- SEQ 7168 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCRT',
       '01',
       10,
       5,
       'CODDET',
       'S',
       'DDET',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDET.DESDET',
       'V',
       '',
       '',
       '',
       'F',
       'Detalhamento',
       'Cdigo Detalhamento',
       'DDET.CODTAB = DCRT.CODDET',
       'CODDET',
       'F' FROM DUAL
UNION ALL
SELECT 'DCRT',
       '01',
       20,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCRT',
       '01',
       30,
       1,
       'DECCRT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Decimais',
       'Decimais quando numrico',
       '',
       'DECCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'DCRT',
       '01',
       40,
       254,
       'DESCRT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descr. Especificao',
       'Descrio da Especificao',
       '',
       'DESCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'DCRT',
       '01',
       50,
       254,
       'MAXCRT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Valor Mximo',
       'Valor Mximo',
       '',
       'MAXCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'DCRT',
       '01',
       60,
       254,
       'MINCRT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Valor Mnimo',
       'Valor Mnimo',
       '',
       'MINCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'DCRT',
       '01',
       70,
       1,
       'NN_CRT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Aceita Nulo?',
       'Aceita Nulo?',
       '',
       'NN_CRT',
       'F' FROM DUAL
UNION ALL
SELECT 'DCRT',
       '01',
       100,
       5,
       'ORDCRT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ordem Caracterizao',
       'Ordem Caracterizao',
       '',
       'ORDCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'DCRT',
       '01',
       80,
       1,
       'TIPCRT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Caracterizao',
       'Tipo Caracterizao',
       '',
       'TIPCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'DCRT',
       '01',
       90,
       1,
       'USODET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Uso',
       'Uso',
       '',
       'USODET',
       'F' FROM DUAL
);

/*-- SEQ 7169 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DCRT',
       'TIPCRT',
       0,
       'C',
       'Combo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCRT',
       'TIPCRT',
       0,
       'D',
       'Data',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCRT',
       'TIPCRT',
       0,
       'L',
       'Lgico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCRT',
       'TIPCRT',
       0,
       'N',
       'Nmero',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCRT',
       'TIPCRT',
       0,
       'S',
       'String',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCRT',
       'USODET',
       0,
       'C',
       'CLIENTE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCRT',
       'USODET',
       0,
       'E',
       'ENDEREO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCRT',
       'USODET',
       0,
       'G',
       'GRADE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCRT',
       'USODET',
       0,
       'N',
       'CONCORRENTE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCRT',
       'USODET',
       0,
       'O',
       'PRODUTO DO CONCORRENTE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCRT',
       'USODET',
       0,
       'P',
       'PRODUTO',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7170 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCT1',
       0,
       'DCT1',
       'Dom. Categoria 1',
       'TD_CT1',
       'F',
       '',
       'TOTALL',
       'Categorias de Cliente 1',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DCT1.COTAB',
       '' FROM DUAL
);

/*-- SEQ 7171 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCT1','--','' FROM DUAL
);

/*-- SEQ 7172 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCT1',
       '--',
       40,
       20,
       'CODEXT_DCT1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT_DCT1',
       'F' FROM DUAL
UNION ALL
SELECT 'DCT1',
       '--',
       30,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DCT1',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCT1',
       '--',
       10,
       1,
       'CT1ATI',
       'L',
       '',
       0,
       0,
       'DCT1',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       'A',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'CT1ATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCT1',
       '--',
       20,
       20,
       'NOMCT1',
       'A',
       '',
       0,
       0,
       'DCT1',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Ttulo da 1 Categ.',
       'Nome da categoria 1',
       '',
       'NOMCT1',
       'F' FROM DUAL
);

/*-- SEQ 7173 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCT2',
       0,
       'DCT2',
       'Dom. Categoria 2',
       'TD_CT2',
       'F',
       '',
       'TOTALL',
       'Categorias de Cliente 2',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DCT2.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7174 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCT2','--','' FROM DUAL
);

/*-- SEQ 7175 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCT2',
       '--',
       40,
       20,
       'CODEXT_DCT2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT_DCT2',
       'F' FROM DUAL
UNION ALL
SELECT 'DCT2',
       '--',
       10,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DCT2',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCT2',
       '--',
       30,
       1,
       'CT2ATI',
       'L',
       '',
       0,
       0,
       'DCT2',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       'A',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'CT2ATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCT2',
       '--',
       20,
       20,
       'NOMCT2',
       'A',
       '',
       0,
       0,
       'DCT2',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Ttulo da 2 Categ.',
       'Nome da categoria 2',
       '',
       'NOMCT2',
       'F' FROM DUAL
);

/*-- SEQ 7176 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCT3',
       0,
       'DCT3',
       'Dom. Categoria 3',
       'TD_CT3',
       'F',
       '',
       'TOTALL',
       'Categorias de Cliente 3',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DCT3.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7177 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCT3','--','' FROM DUAL
);

/*-- SEQ 7178 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCT3',
       '--',
       40,
       20,
       'CODEXT_DCT3',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT_DCT3',
       'F' FROM DUAL
UNION ALL
SELECT 'DCT3',
       '--',
       10,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DCT3',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCT3',
       '--',
       30,
       1,
       'CT3ATI',
       'L',
       '',
       0,
       0,
       'DCT3',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       'A',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'CT3ATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCT3',
       '--',
       20,
       20,
       'NOMCT3',
       'A',
       '',
       0,
       0,
       'DCT3',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Ttulo da 3 Categ.',
       'Nome da categoria 3',
       '',
       'NOMCT3',
       'F' FROM DUAL
);

/*-- SEQ 7179 --*/
INSERT INTO TT_ARQ(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,
       DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
       VALUES('DCTA',
              null,
              'DCTA',
              'Contas Financeciras',
              'TD_CTA',
              'F',
              '',
              'TOTALL',
              '',
              '',
              '',
              '',
              '',
              'T',
              '',
              '',
              '');
/*-- SEQ 7180 --*/
INSERT INTO TT_GRU ( CODTAB, CODGRU, DESGRU)
       VALUES ('DCTA','--','');
/*-- SEQ 7181 --*/
INSERT INTO TT_GRU ( CODTAB, CODGRU, DESGRU)
       VALUES ('DCTA','01','Identificao');
/*-- SEQ 7182 --*/
INSERT INTO TT_GRU ( CODTAB, CODGRU, DESGRU)
       VALUES ('DCTA','99','Outros');
/*-- SEQ 7183 --*/
INSERT INTO TT_SQL (NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)                                                                                             
       VALUES (25737,'CTA ','DCTA',                                   
               'N ','1 ','','',
               'CTA.CODFIL = DCTA.FILCTA AND CTA.SEQUEN = DCTA.SEQCTA AND CTA.TIPCTA = DCTA.TIPCTA','');
/*-- SEQ 7184 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DCTA',
              '--',
              10,
              20,
              'CFGCOL',
              'A',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'A',
              '',
              '',
              'A',
              'F',
              'Nome para busca',
              'Nome para busca',
              '',
              'CFGCOL',
              'F');
/*-- SEQ 7185 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DCTA',
              '--',
              20,
              3,
              'CODTAB',
              'S',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'U',
              '',
              '',
              'N',
              'F',
              'Codigo',
              'Codigo',
              '',
              'CODTAB',
              'F');
/*-- SEQ 7186 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DCTA',
              '--',
              40,
              40,
              'DESCTA',
              'A',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'A',
              '',
              '',
              'A',
              'F',
              'Descrio',
              'Descrio',
              '',
              'DESCTA',
              'F');
/*-- SEQ 7187 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DCTA',
              '--',
              50,
              1,
              'DUMMY',
              'L',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'A',
              '',
              '',
              'A',
              'F',
              '',
              '',
              '',
              'DUMMY',
              'F');
/*-- SEQ 7188 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DCTA',
              '--',
              60,
              3,
              'FILCTA',
              'A',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'I',
              '',
              '',
              'A',
              'F',
              'Filial',
              'Filial da conta',
              '',
              'FILCTA',
              'F');
/*-- SEQ 7189 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DCTA',
              '--',
              70,
              10,
              'SEQCTA',
              'A',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'A',
              '',
              '',
              'A',
              'F',
              'Sequencial',
              'Sequencial da conta',
              '',
              'SEQCTA',
              'F');
/*-- SEQ 7190 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DCTA',
              '--',
              80,
              1,
              'TIPCTA',
              'A',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'A',
              '',
              '',
              'A',
              'F',
              'Tipo',
              'Tipo da conta',
              '',
              'TIPCTA',
              'F');
/*-- SEQ 7191 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DCTA',
              '--',
              90,
              1,
              'USOCTA',
              'A',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'A',
              '',
              '',
              'A',
              'F',
              'Uso da conta',
              'Uso da conta',
              '',
              'USOCTA',
              'F');

/*-- SEQ 7192 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCTR',
       TO_NUMBER(null),
       'DCTR',
       'Dom.Unidade Negcios',
       'TD_CTR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DCTR.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7193 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCTR','--','' FROM DUAL
UNION ALL
SELECT 'DCTR','1 ','Identificao' FROM DUAL
);

/*-- SEQ 7194 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20256,
       'ECTA',
       'DCTR',
       '01',
       'N',
       '',
       '',
       'DCTR.CTREST_FIL = ECTA.CODFIL AND
DCTR.CTREST_SEQ = ECTA.SEQUEN AND
DCTR.CTREST_TIP = ECTA.TIPCTA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 19531,
       'CTA ',
       'DCTR',
       '1',
       '1',
       '',
       '',
       'CTA.CODFIL = DCTR.CTRFIL AND
CTA.SEQUEN = DCTR.CTRSEQ AND
CTA.TIPCTA = DCTR.CTRTIP AND
CTA.USOCTA = DCTR.CTRUSO',
       '',
       '' FROM DUAL
UNION ALL
SELECT 11394,
       'VIN ',
       'DCTR',
       'N',
       '1',
       '',
       '',
       'VIN.CODCTR = DCTR.CODTAB',
       '',
       '' FROM DUAL
);

/*-- SEQ 7195 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCTR',
       '1 ',
       40,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Codigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'DCTR',
       '1 ',
       10,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCTR',
       '1 ',
       20,
       1,
       'CTRATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Ativo?',
       'Ativo',
       '',
       'CTRATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCTR',
       '--',
       130,
       3,
       'CTREST_FIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'CTREST_FIL',
       'F' FROM DUAL
UNION ALL
SELECT 'DCTR',
       '--',
       140,
       10,
       'CTREST_SEQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       '',
       '',
       'CTREST_SEQ',
       'F' FROM DUAL
UNION ALL
SELECT 'DCTR',
       '--',
       150,
       1,
       'CTREST_TIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'CTREST_TIP',
       'F' FROM DUAL
UNION ALL
SELECT 'DCTR',
       '1 ',
       50,
       3,
       'CTRFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Fil Plano de Contas',
       'Filial Plano de Contas',
       'DFIL.CODFIL = DCTR.CTRFIL',
       'CTRFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'DCTR',
       '1 ',
       60,
       10,
       'CTRSEQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave Plano Contas',
       'Chave Plano de Contas',
       '',
       'CTRSEQ',
       'F' FROM DUAL
UNION ALL
SELECT 'DCTR',
       '1 ',
       70,
       1,
       'CTRTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Plano de Contas',
       'Tipo Plano de contas',
       '',
       'CTRTIP',
       'F' FROM DUAL
UNION ALL
SELECT 'DCTR',
       '1 ',
       80,
       1,
       'CTRUSO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Contrato de Uso',
       'Contrato de Uso',
       '',
       'CTRUSO',
       'T' FROM DUAL
UNION ALL
SELECT 'DCTR',
       '1 ',
       30,
       30,
       'DESCTR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'DESCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'DCTR',
       '1 ',
       4,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'DCTR',
       '--',
       90,
       3,
       'FILPRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial venda a prazo',
       'Filial conta para venda a prazo',
       '',
       'FILPRA',
       'F' FROM DUAL
UNION ALL
SELECT 'DCTR',
       '--',
       100,
       255,
       'PATPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Diretrio',
       'Diretrio Path Pedido',
       '',
       'PATPED',
       'F' FROM DUAL
UNION ALL
SELECT 'DCTR',
       '1 ',
       5,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Chave Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'DCTR',
       '--',
       110,
       10,
       'SEQPRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave conta a prazo',
       'Chave conta para venda a prazo',
       '',
       'SEQPRA',
       'F' FROM DUAL
UNION ALL
SELECT 'DCTR',
       '1 ',
       6,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'DCTR',
       '--',
       120,
       1,
       'TIPPRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo conta para venda a prazo',
       '',
       'TIPPRA',
       'F' FROM DUAL
);

/*-- SEQ 7196 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DCTR',
       'CTRUSO',
       0,
       '0',
       'No Classificado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7197 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCUS',
       0,
       'DCUS',
       'Dom. Centro Custos',
       'TD_CUS',
       'T',
       '',
       'TOTALL',
       'Centro de Custos',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DCUS.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7198 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCUS','--','' FROM DUAL
);

/*-- SEQ 7199 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCUS',
       '--',
       300,
       15,
       'CENCUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Unidade de Negcios',
       'Unidade de Negcios',
       '',
       'CENCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'DCUS',
       '--',
       100,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCUS',
       '--',
       200,
       1,
       'CUSATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Ativo?',
       'Ativo',
       '',
       'CUSATI',
       'F' FROM DUAL
);

/*-- SEQ 7200 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCVE',
       TO_NUMBER(null),
       'DCVE',
       'Dom. Cor Veculo',
       'TD_CORVEI',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7201 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCVE','--','' FROM DUAL
UNION ALL
SELECT 'DCVE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DCVE','99','Outros' FROM DUAL
);

/*-- SEQ 7202 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'DCVE',
       '01',
       50,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DCVE',
       '01',
       60,
       2,
       'CODCORDEN',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Cd. Cor Denatran',
       'Cdigo da Cor no Denatran',
       '',
       'CODCORDEN',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DCVE',
       '01',
       10,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DCVE',
       '01',
       20,
       1,
       'CORVEIATI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Cor do Veculo Ativo',
       'Cor do Veculo Ativo?',
       '',
       'CORVEIATI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DCVE',
       '01',
       40,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DCVE',
       '01',
       30,
       100,
       'DESCORVEI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Desc. Cor Veculo',
       'Descrio da Cor do Veculo',
       '',
       'DESCORVEI',
       '',
       'D' FROM DUAL
);

/*-- SEQ 7203 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DCVE',
       'CODCORDEN',
       1,
       ' ',
       'Amarelo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCVE',
       'CODCORDEN',
       2,
       ' ',
       'Azul',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCVE',
       'CODCORDEN',
       3,
       ' ',
       'Bege',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCVE',
       'CODCORDEN',
       4,
       ' ',
       'Branca',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCVE',
       'CODCORDEN',
       5,
       ' ',
       'Cinza',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCVE',
       'CODCORDEN',
       6,
       ' ',
       'Dourada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCVE',
       'CODCORDEN',
       7,
       ' ',
       'Gren',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCVE',
       'CODCORDEN',
       8,
       ' ',
       'Laranja',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCVE',
       'CODCORDEN',
       9,
       ' ',
       'Marrom',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCVE',
       'CODCORDEN',
       10,
       ' ',
       'Prata',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCVE',
       'CODCORDEN',
       11,
       ' ',
       'Preta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCVE',
       'CODCORDEN',
       12,
       ' ',
       'Rosa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCVE',
       'CODCORDEN',
       13,
       ' ',
       'Roxa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCVE',
       'CODCORDEN',
       14,
       ' ',
       'Verde',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCVE',
       'CODCORDEN',
       15,
       ' ',
       'Vermelha',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCVE',
       'CODCORDEN',
       16,
       ' ',
       'Fantasia',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7204 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DCWS',
       TO_NUMBER(null),
       'DCWS',
       'Dom.Workflow Suporte',
       'TD_CWS',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DCWS.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7205 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DCWS','--','' FROM DUAL
UNION ALL
SELECT 'DCWS','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DCWS','99','Outros' FROM DUAL
);

/*-- SEQ 7206 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5400,
       'SPT ',
       'DCWS',
       'N ',
       '1 ',
       '',
       '',
       'spt.tipsup = dcws.codtab and
spt.tipcws = dcws.tipcws',
       '' FROM DUAL
UNION ALL
SELECT 5401,
       'WOR ',
       'DCWS',
       'N ',
       '1 ',
       '',
       '',
       'wor.tiptar = dcws.codtab and
wor.tipcws = dcws.tipcws',
       '' FROM DUAL
);

/*-- SEQ 7207 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DCWS',
       '--',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DCWS',
       '--',
       20,
       1,
       'CWSATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'CWSATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DCWS',
       '--',
       30,
       100,
       'DESCWS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'DESCWS',
       'F' FROM DUAL
UNION ALL
SELECT 'DCWS',
       '--',
       40,
       15,
       'HORCWS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Hora Padro',
       'Hora Padro',
       '',
       'HORCWS',
       'F' FROM DUAL
UNION ALL
SELECT 'DCWS',
       '--',
       80,
       1,
       'ORICWS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem',
       'Origem',
       '',
       'ORICWS',
       'F' FROM DUAL
UNION ALL
SELECT 'DCWS',
       '--',
       50,
       1,
       'PEDAUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Autorizao(Sim/No)',
       'Autorizao(Sim/No)',
       '',
       'PEDAUT',
       'F' FROM DUAL
UNION ALL
SELECT 'DCWS',
       '--',
       60,
       1,
       'TIPCWS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo',
       '',
       'TIPCWS',
       'T' FROM DUAL
UNION ALL
SELECT 'DCWS',
       '--',
       70,
       1,
       'TIPWOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Natureza',
       'Natureza',
       '',
       'TIPWOR',
       'F' FROM DUAL
);

/*-- SEQ 7208 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DCWS',
       'ORICWS',
       0,
       'C',
       'Cliente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCWS',
       'ORICWS',
       0,
       'E',
       'Empresa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCWS',
       'ORICWS',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCWS',
       'TIPCWS',
       0,
       'A',
       'Ambos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCWS',
       'TIPCWS',
       0,
       'S',
       'Suporte',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCWS',
       'TIPCWS',
       0,
       'W',
       'WorkFlow',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCWS',
       'TIPWOR',
       0,
       'C',
       'Consultoria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCWS',
       'TIPWOR',
       0,
       'D',
       'Desenvolvimento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DCWS',
       'TIPWOR',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7209 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DDEP',
       0,
       'DDEP',
       'Dom. Departamentos',
       'TD_DEP',
       'F',
       '',
       'TOTALL',
       'Departamentos',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DDEP.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7210 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DDEP','--','' FROM DUAL
);

/*-- SEQ 7211 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DDEP',
       '--',
       70,
       40,
       'CODPOS_DDEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo POS CONTROLE',
       'Cdigo POS CONTROLE',
       '',
       'CODPOS_DDEP',
       '' FROM DUAL
UNION ALL
SELECT 'DDEP',
       '--',
       50,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DDEP',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DDEP',
       '--',
       40,
       15,
       'CONTAB',
       'A',
       '',
       0,
       0,
       'DDEP',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Cdigo da cta contab',
       'Cdigo da Conta Contbil',
       '',
       'CONTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DDEP',
       '--',
       10,
       1,
       'DEPATI',
       'L',
       '',
       0,
       0,
       'DDEP',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       'A',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'DEPATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DDEP',
       '--',
       60,
       1,
       'DEPWEB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Mostrar na web?',
       'Mostrar na web?',
       '',
       'DEPWEB',
       '' FROM DUAL
UNION ALL
SELECT 'DDEP',
       '--',
       20,
       40,
       'DESDEP',
       'A',
       '',
       0,
       0,
       'DDEP',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Nome do Departamento',
       'Descrio do Departamento',
       '',
       'DESDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'DDEP',
       '--',
       30,
       40,
       'IMGDEP',
       'A',
       '',
       0,
       0,
       'DDEP',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Imagem do depto',
       'Nome do arquivo imagem',
       '',
       'IMGDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'DDEP',
       '--',
       110,
       7,
       'PESPREFOR',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Peso Preo Forn.',
       'Peso aplicado sobre o Preo do Fornecedor',
       '',
       'PESPREFOR',
       '' FROM DUAL
UNION ALL
SELECT 'DDEP',
       '--',
       80,
       7,
       'PESPREVEN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Peso Valor Presente',
       'Peso aplicado sobre o Valor Presente',
       '',
       'PESPREVEN',
       '' FROM DUAL
UNION ALL
SELECT 'DDEP',
       '--',
       90,
       7,
       'PESPRZENT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Peso Prazo Entrega',
       'Peso aplicado sobre o Prazo de Entrega',
       '',
       'PESPRZENT',
       '' FROM DUAL
UNION ALL
SELECT 'DDEP',
       '--',
       100,
       7,
       'TAXJURMES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Taxa de Juros ao Ms',
       'Taxa de Juros ao Ms para Valor Presente',
       '',
       'TAXJURMES',
       '' FROM DUAL
);

/*-- SEQ 7212 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DDES',
       TO_NUMBER(null),
       'DDES',
       'Dom. Tipo Desconto',
       'TD_DES',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DDES.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7213 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DDES','--','' FROM DUAL
UNION ALL
SELECT 'DDES','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DDES','99','Outros' FROM DUAL
);

/*-- SEQ 7214 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DDES',
       '--',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DDES',
       '--',
       20,
       1,
       'DESATV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'DESATV',
       'F' FROM DUAL
UNION ALL
SELECT 'DDES',
       '--',
       30,
       20,
       'TIPDES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo do Desconto',
       'Descricao do Tipo do Desconto',
       '',
       'TIPDES',
       'F' FROM DUAL
);

/*-- SEQ 7215 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DDET',
       TO_NUMBER(null),
       'DDET',
       'Detalhamento',
       'TD_DET',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7216 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DDET','--','' FROM DUAL
UNION ALL
SELECT 'DDET','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DDET','99','Outros' FROM DUAL
);

/*-- SEQ 7217 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DDET',
       '01',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DDET',
       '01',
       20,
       254,
       'DESDET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio do Detalhamento',
       '',
       'DESDET',
       'F' FROM DUAL
UNION ALL
SELECT 'DDET',
       '01',
       50,
       5,
       'ORDDET',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ordem Detalhamento',
       'Ordem Detalhamento',
       '',
       'ORDDET',
       'F' FROM DUAL
UNION ALL
SELECT 'DDET',
       '01',
       30,
       5,
       'PAIDET',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Chave Registro Pai',
       'Chave Registro Pai',
       '',
       'PAIDET',
       'F' FROM DUAL
UNION ALL
SELECT 'DDET',
       '01',
       40,
       1,
       'USODET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Uso',
       'Uso',
       '',
       'USODET',
       'F' FROM DUAL
);

/*-- SEQ 7218 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DDET',
       'USODET',
       0,
       'C',
       'CLIENTE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DDET',
       'USODET',
       0,
       'E',
       'ENDEREO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DDET',
       'USODET',
       0,
       'G',
       'GRADE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DDET',
       'USODET',
       0,
       'N',
       'CONCORRENTE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DDET',
       'USODET',
       0,
       'O',
       'PRODUTO DO CONCORRENTE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DDET',
       'USODET',
       0,
       'P',
       'PRODUTO',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7219 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DDEV',
       TO_NUMBER(null),
       'DDEV',
       'Dom. Devolues',
       'TD_DEV',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DDEV.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7220 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DDEV','--','' FROM DUAL
UNION ALL
SELECT 'DDEV','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DDEV','99','Outros' FROM DUAL
);

/*-- SEQ 7221 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DDEV',
       '01',
       110,
       1,
       'CLIDEV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Cli.  mesmo da Dev.',
       'Cliente  o mesmo da devoluo?',
       '',
       'CLIDEV',
       'F' FROM DUAL
UNION ALL
SELECT 'DDEV',
       '01',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DDEV',
       '01',
       20,
       30,
       'DESDEV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Devoluo',
       'Descrio da Devoluo',
       '',
       'DESDEV',
       'F' FROM DUAL
UNION ALL
SELECT 'DDEV',
       '01',
       30,
       4,
       'DEVATE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Devolve At',
       'Devolve At',
       '',
       'DEVATE',
       'F' FROM DUAL
UNION ALL
SELECT 'DDEV',
       '01',
       40,
       1,
       'DEVATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Devoluo Ativa?',
       'Devoluo Ativa?',
       '',
       'DEVATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DDEV',
       '01',
       50,
       4,
       'DEVCOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Devoluo Comisso',
       'Devoluo Comisso',
       '',
       'DEVCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'DDEV',
       '01',
       60,
       4,
       'DEVICM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Credita ICMS',
       'Credita ICMS at anterior a X dias da venda',
       '',
       'DEVICM',
       'F' FROM DUAL
UNION ALL
SELECT 'DDEV',
       '01',
       70,
       4,
       'DEVMON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dev.MontagemComisso',
       'Devoluo Montagem Comisso',
       '',
       'DEVMON',
       'F' FROM DUAL
UNION ALL
SELECT 'DDEV',
       '01',
       80,
       5,
       'MULDEV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Subestoque Devoluo',
       'Subestoque na Devoluo',
       '',
       'MULDEV',
       'F' FROM DUAL
UNION ALL
SELECT 'DDEV',
       '01',
       90,
       1,
       'USODEV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Uso da Devoluo',
       'Uso da Devoluo',
       '',
       'USODEV',
       'T' FROM DUAL
UNION ALL
SELECT 'DDEV',
       '01',
       100,
       1,
       'VLRDEV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'T',
       'A',
       'F',
       'Val. Itens Devoluo',
       'Valor dos Itens de Devoluo',
       '',
       'VLRDEV',
       'T' FROM DUAL
);

/*-- SEQ 7222 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DDEV',
       'USODEV',
       0,
       'A',
       'Ambos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DDEV',
       'USODEV',
       0,
       'D',
       'Devoluo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DDEV',
       'USODEV',
       0,
       'T',
       'Troca',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DDEV',
       'VLRDEV',
       0,
       'B',
       ' Devolver pelo valor bruto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DDEV',
       'VLRDEV',
       0,
       'L',
       'Tratar pelo valor lq.(rateio)',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7223 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DDFC',
       TO_NUMBER(null),
       'DDFC',
       'Dom.Docs Fis.Compras',
       'TD_DFC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7224 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DDFC','--','' FROM DUAL
UNION ALL
SELECT 'DDFC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DDFC','99','Outros' FROM DUAL
);

/*-- SEQ 7225 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DDFC',
       '01',
       10,
       2,
       'CODDFC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd. Docs Fiscais',
       'Cdigo Documentos Fiscais de Compras ',
       '',
       'CODDFC',
       'F' FROM DUAL
UNION ALL
SELECT 'DDFC',
       '01',
       20,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DDFC',
       '01',
       30,
       30,
       'DESDFC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Docs F.C.',
       'Descrio Documentos Fiscais de Compras ',
       '',
       'DESDFC',
       'F' FROM DUAL
UNION ALL
SELECT 'DDFC',
       '01',
       40,
       1,
       'DFCATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Doc.Fiscal C. Ativo?',
       'Documento Fiscal de Compra Ativo?',
       '',
       'DFCATI',
       'F' FROM DUAL
);

/*-- SEQ 7226 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DDIV',
       0,
       'DDIV',
       'Dom. Divises',
       'TD_DIV',
       'F',
       '',
       'TOTALL',
       'Grade - Divises',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DDIV.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7227 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DDIV','--','' FROM DUAL
);

/*-- SEQ 7228 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DDIV',
       '--',
       30,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DDIV',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DDIV',
       '--',
       10,
       1,
       'DIVATI',
       'L',
       '',
       0,
       0,
       'DDIV',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'DIVATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DDIV',
       '--',
       20,
       20,
       'NOMDIV',
       'A',
       '',
       0,
       0,
       'DDIV',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Nome da diviso',
       'Descrio da grade',
       '',
       'NOMDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'DDIV',
       '--',
       40,
       2,
       'ORDDIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DDIV',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Ordem',
       'Ordem',
       '',
       'ORDDIV',
       'F' FROM DUAL
);

/*-- SEQ 7229 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DDOC',
       TO_NUMBER(null),
       'DDOC',
       'Dom. Documentos',
       'TD_DOC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DDOC.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7230 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DDOC','--','' FROM DUAL
);

/*-- SEQ 7231 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DDOC',
       '--',
       1,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DDOC',
       '--',
       4,
       30,
       'DESDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DESDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'DDOC',
       '--',
       2,
       1,
       'DOCATV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Registro Ativo?',
       'Registro Ativo',
       '',
       'DOCATV',
       'F' FROM DUAL
UNION ALL
SELECT 'DDOC',
       '--',
       3,
       2,
       'TIPDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Tipo de Documento',
       'Tipo de Documento',
       '',
       'TIPDOC',
       'F' FROM DUAL
);

/*-- SEQ 7232 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DDOP',
       TO_NUMBER(null),
       'DDOP',
       'Dom. Tipo Documento',
       'TD_DOP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DDOP.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7233 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DDOP','--','' FROM DUAL
);

/*-- SEQ 7234 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22589,
       'DOP ',
       'DDOP',
       'N',
       '1',
       '',
       '',
       'DDOP.CODTAB = DOP.DOMDOP',
       '',
       '' FROM DUAL
);

/*-- SEQ 7235 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DDOP',
       '--',
       1,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DDOP',
       '--',
       3,
       30,
       'DESDOP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Documento',
       'Descrio Documento',
       '',
       'DESDOP',
       'F' FROM DUAL
UNION ALL
SELECT 'DDOP',
       '--',
       2,
       1,
       'DOPATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Documento Ativo?',
       'Documento Ativo?',
       '',
       'DOPATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DDOP',
       '--',
       13,
       2,
       'MODPGT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       '0',
       'F',
       'Mod. de Pagamento.',
       'Modalidade de Pagamento',
       '',
       'MODPGT',
       'F' FROM DUAL
);

/*-- SEQ 7236 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DDOP',
       'MODPGT',
       1,
       ' ',
       'TED',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DDOP',
       'MODPGT',
       2,
       ' ',
       'Crdito em conta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DDOP',
       'MODPGT',
       3,
       ' ',
       'Cheque OP',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DDOP',
       'MODPGT',
       4,
       ' ',
       'Crdito em conta Real Time',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DDOP',
       'MODPGT',
       5,
       ' ',
       'DOC COMPE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DDOP',
       'MODPGT',
       6,
       ' ',
       'Ttulo Prprio Banco',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DDOP',
       'MODPGT',
       7,
       ' ',
       'Ttulo Terceiros
',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DDOP',
       'MODPGT',
       0,
       ' ',
       'No Usa',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7237 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DDUP',
       TO_NUMBER(null),
       'DDUP',
       'Dom. Duplicatas',
       'TD_DUP',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DDUP.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7238 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DDUP','--','' FROM DUAL
UNION ALL
SELECT 'DDUP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DDUP','99','Outros' FROM DUAL
);

/*-- SEQ 7239 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DDUP',
       '01',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
);

/*-- SEQ 7240 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DEAN',
       TO_NUMBER(null),
       'DEAN',
       'Dom. Tipo EAN',
       'TD_EAN',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DEAN.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7241 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DEAN','--','' FROM DUAL
);

/*-- SEQ 7242 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5439,
       'CLI ',
       'DEAN',
       '0N',
       '1 ',
       '',
       '',
       'cli.filcli(+) = dean.eanfil and
cli.codcli(+) = dean.eancod',
       '' FROM DUAL
);

/*-- SEQ 7243 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DEAN',
       '--',
       1,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DEAN',
       '--',
       2,
       10,
       'DESEAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao',
       'Descricao',
       '',
       'DESEAN',
       'F' FROM DUAL
UNION ALL
SELECT 'DEAN',
       '--',
       3,
       1,
       'EANATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'EANATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DEAN',
       '--',
       13,
       6,
       'EANCOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Codigo EAN',
       'Codigo EAN',
       '',
       'EANCOD',
       'F' FROM DUAL
UNION ALL
SELECT 'DEAN',
       '--',
       23,
       3,
       'EANFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial EAN',
       'Filial EAN',
       'DFIL.CODFIL(+) = DEAN.EANFIL',
       'EANFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'DEAN',
       '--',
       33,
       1,
       'USAVEN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa na Venda?',
       'Usa na Venda?',
       '',
       'USAVEN',
       'F' FROM DUAL
);

/*-- SEQ 7244 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DECB',
       TO_NUMBER(null),
       'DECB',
       'Dom. Espcie Doc.',
       'TD_ECB',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DECB.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7245 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DECB','--','' FROM DUAL
UNION ALL
SELECT 'DECB','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DECB','99','Outros' FROM DUAL
);

/*-- SEQ 7246 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DECB',
       '--',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DECB',
       '--',
       20,
       30,
       'DESECB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao Especie',
       'Descricao da especie',
       '',
       'DESECB',
       'F' FROM DUAL
UNION ALL
SELECT 'DECB',
       '--',
       30,
       1,
       'ECBATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'ECBATI',
       'F' FROM DUAL
);

/*-- SEQ 7247 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DECF',
       TO_NUMBER(null),
       'DECF',
       'Dom.Emissor Cup.Fis.',
       'TD_ECF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DECF.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7248 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DECF','--','' FROM DUAL
UNION ALL
SELECT 'DECF','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DECF','02','Checkout 4G' FROM DUAL
UNION ALL
SELECT 'DECF','99','Outros' FROM DUAL
);

/*-- SEQ 7249 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22477,
       'CCC ',
       'DECF',
       '1',
       'N',
       '',
       '',
       'CCC.CODFIL = DECF.FILECF AND
CCC.NUMECF = DECF.NUMECF',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22478,
       'ECF ',
       'DECF',
       '1',
       'N',
       '',
       '',
       'ECF.CODFIL = DECF.FILECF AND
ECF.NUMECF = DECF.NUMECF',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22479,
       'RCAI',
       'DECF',
       '1',
       'N',
       '',
       '',
       'RCAI.CODFIL = DECF.FILECF AND
RCAI.NUMECF = DECF.NUMECF',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22480,
       'REC ',
       'DECF',
       '1',
       'N',
       '',
       '',
       'REC.FILREC = DECF.FILECF AND
REC.NUMECF = DECF.NUMECF',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22481,
       'RECF',
       'DECF',
       '1',
       'N',
       '',
       '',
       'RECF.CODFIL = DECF.FILECF AND
RECF.NUMECF = DECF.NUMECF',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22482,
       'VEN ',
       'DECF',
       '1',
       'N',
       '',
       '',
       'VEN.CODFIL = DECF.FILECF AND
VEN.NUMECF = DECF.NUMECF',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22483,
       'AUT ',
       'DECF',
       '1',
       'N',
       '',
       '',
       'AUT.CODFIL = DECF.FILECF AND
AUT.NUMECF = DECF.NUMECF',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45919,
       'RECP',
       'DECF',
       '1',
       'N',
       '',
       '',
       'RECP.FILREC = DECF.FILECF AND
RECP.NUMECF = DECF.NUMECF',
       '',
       '' FROM DUAL
);

/*-- SEQ 7250 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DECF',
       '99',
       380,
       1,
       'ARRTRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Arredonda ou trunca?',
       'ECF arredonda ou trunca?',
       '',
       'ARRTRU',
       'T' FROM DUAL
UNION ALL
SELECT 'DECF',
       '--',
       350,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Assinatura para PAF-ECF',
       '',
       'ASSINA',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '--',
       280,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '@',
       'F',
       'Ultima atualizao',
       'Ultima atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '02',
       540,
       1,
       'CK4G_ACAOPADRAO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Ao aps NFC-e',
       'Ao aps gerao da NFC-e',
       '',
       'CK4G_ACAOPADRAO',
       'T' FROM DUAL
UNION ALL
SELECT 'DECF',
       '02',
       500,
       3,
       'CK4G_BARRASALTURA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Altura cd. barras',
       'Altura do cdigo de barras',
       '',
       'CK4G_BARRASALTURA',
       '' FROM DUAL
UNION ALL
SELECT 'DECF',
       '02',
       510,
       1,
       'CK4G_BARRASLARGURA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Largura cd. barras',
       'Largura do cdigo de barras',
       '',
       'CK4G_BARRASLARGURA',
       '' FROM DUAL
UNION ALL
SELECT 'DECF',
       '02',
       520,
       1,
       'CK4G_BARRASPADRAO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Padro cd. barras',
       'Padro do cdigo de barras',
       '',
       'CK4G_BARRASPADRAO',
       'T' FROM DUAL
UNION ALL
SELECT 'DECF',
       '02',
       460,
       1,
       'CK4G_DETVER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       'Detalhe da Verso Atual do Checkout 4G (No Utilizada)',
       '',
       'CK4G_DETVER',
       '' FROM DUAL
UNION ALL
SELECT 'DECF',
       '02',
       440,
       1,
       'CK4G_HOMOL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Homologao?',
       'Atualizar Checkout 4G para Verso de Homologao?',
       '',
       'CK4G_HOMOL',
       '' FROM DUAL
UNION ALL
SELECT 'DECF',
       '02',
       530,
       10,
       'CK4G_INTERVALOCARGADESALDOS',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Intervalo carga lote',
       'Intervalo entre cargas dos saldos de lotes',
       '',
       'CK4G_INTERVALOCARGADESALDOS',
       '' FROM DUAL
UNION ALL
SELECT 'DECF',
       '02',
       420,
       5,
       'CK4G_MANLOG_DET',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Man Log Det N Dias',
       'Mantm Log Detalhado Por N Dias',
       '',
       'CK4G_MANLOG_DET',
       '' FROM DUAL
UNION ALL
SELECT 'DECF',
       '02',
       430,
       5,
       'CK4G_MANLOG_GER',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Man Log Ger N Dias',
       'Mantm Log Geral Por N Dias',
       '',
       'CK4G_MANLOG_GER',
       '' FROM DUAL
UNION ALL
SELECT 'DECF',
       '02',
       410,
       5,
       'CK4G_MANMOV',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Man Mov N Dias',
       'Mantm Movimentao Por N Dias',
       '',
       'CK4G_MANMOV',
       '' FROM DUAL
UNION ALL
SELECT 'DECF',
       '02',
       580,
       32,
       'CK4G_MD5',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'MD5 licena ECF',
       'MD5 da licena do ECF',
       '',
       'CK4G_MD5',
       '' FROM DUAL
UNION ALL
SELECT 'DECF',
       '02',
       590,
       2,
       'CK4G_MODFIS_VC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mod. Fiscal VC',
       'Modelo Fiscal para Venda ao Consumidor',
       '',
       'CK4G_MODFIS_VC',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '02',
       600,
       2,
       'CK4G_MODFIS_VC_CONT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mod Fiscal (Cont)',
       'Modelo Fiscal (1 Contingncia)',
       '',
       'CK4G_MODFIS_VC_CONT',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '02',
       470,
       2,
       'CK4G_RELEAS_HOMOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       'Release Atual do Checkout 4G (No Utilizada)',
       '',
       'CK4G_RELEAS_HOMOL',
       '' FROM DUAL
UNION ALL
SELECT 'DECF',
       '02',
       550,
       1,
       'CK4G_USAFRETE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Usa frete onde?',
       'Usa frete onde?',
       '',
       'CK4G_USAFRETE',
       'T' FROM DUAL
UNION ALL
SELECT 'DECF',
       '02',
       610,
       1,
       'CK4G_USA_CONT_OFFLINE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Cont NFC-e Off-line',
       'Usa Contingncia de 65-NFC-e Offline?',
       '',
       'CK4G_USA_CONT_OFFLINE',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '02',
       570,
       7,
       'CK4G_VALIDADE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Validade licena ECF',
       'Validade da licena do ECF',
       '',
       'CK4G_VALIDADE',
       '' FROM DUAL
UNION ALL
SELECT 'DECF',
       '02',
       450,
       4,
       'CK4G_VERSAO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       'Verso Atual do Checkout 4G (No Utilizada)',
       '',
       'CK4G_VERSAO',
       '' FROM DUAL
UNION ALL
SELECT 'DECF',
       '02',
       560,
       1,
       'CK4G_ZSOMENTEAPOS24H',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Reduo Z aps 24h',
       'Reduo Z somente aps 24h',
       '',
       'CK4G_ZSOMENTEAPOS24H',
       '' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       1,
       1,
       'COBECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Cobrana ECF',
       'Cobrana ECF',
       '',
       'COBECF',
       'T' FROM DUAL
UNION ALL
SELECT 'DECF',
       '--',
       200,
       5,
       'CODCTR',
       'S',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       '',
       'N',
       'F',
       'Unidades de Negcios',
       'Cdigo da Unidades de Negcios',
       'DCTR.CODTAB = DECF.CODCTR(+)',
       'CODCTR',
       'T' FROM DUAL
UNION ALL
SELECT 'DECF',
       '--',
       351,
       20,
       'CODEXT_DECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT_DECF',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       220,
       3,
       'CODFAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Fabricante',
       'Cdigo do Fabricante conforme tabela na base de conhecimento',
       '',
       'CODFAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       230,
       2,
       'CODMOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Modelo',
       'Cdigo do Modelo conforme tabela na base de conhecimento',
       '',
       'CODMOD',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       20,
       5,
       'CODMUL',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       'F',
       'Sub-Estoque',
       'Nome do Sub-Estoque',
       'DMUL.CODTAB = DECF.CODMUL',
       'CODMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       30,
       3,
       'CODORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Origem',
       'Cdigo Origem',
       '',
       'CODORI',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       2,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '--',
       360,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Identificao de Acesso',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '--',
       390,
       4,
       'CRZINI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CRZINI',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       40,
       1,
       'CTAABE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Conta Abertura',
       'Conta Abertura',
       '',
       'CTAABE',
       'T' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       50,
       1,
       'CTADIF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Conta Diferena ECF',
       'Conta Diferena ECF',
       '',
       'CTADIF',
       'T' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       60,
       1,
       'CTAFEC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Conta Fechamento',
       'Conta Fechamento',
       '',
       'CTAFEC',
       'T' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       70,
       1,
       'CTATRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Conta Cheque Troco',
       'Conta Cheque Troco',
       '',
       'CTATRO',
       'T' FROM DUAL
UNION ALL
SELECT 'DECF',
       '99',
       630,
       1,
       'DECF_NUMEXT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Cd. Externo Obrig.',
       'Cdigo Externo Obrigatrio',
       '',
       'DECF_NUMEXT',
       '' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       240,
       7,
       'DSWECF',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Grav. do SB',
       'Data e hora da Gravao do Software Bsico',
       '',
       'DSWECF',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       3,
       1,
       'ECFATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'ECF Ativo?',
       'ECF Ativo?',
       '',
       'ECFATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '--',
       330,
       3,
       'ECFCOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero de colunas',
       'Nmero de colunas',
       '',
       'ECFCOL',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       310,
       1,
       'ECFMFA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'MF adicional',
       'Letra indicativa de MF adicional',
       '',
       'ECFMFA',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       320,
       7,
       'ECFTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo de ECF',
       'Tipo de ECF',
       '',
       'ECFTIP',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '--',
       300,
       1,
       'ECFUTL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Utilizao do ECF',
       'Utilizao do ECF',
       '',
       'ECFUTL',
       'T' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       5,
       3,
       'FILECF',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial ',
       'Filial Emissor Cupom Fiscal',
       'DECF.FILECF = DFIL.CODFIL(+)',
       'FILECF',
       'T' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       290,
       1,
       'FITDET',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Possui MFD',
       'Possu Memria Fita-Detalhe',
       '',
       'FITDET',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '99',
       620,
       4,
       'FLGCFE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Forma Emisso CF-e',
       'Forma de Emisso para CF-e',
       '',
       'FLGCFE',
       'T' FROM DUAL
UNION ALL
SELECT 'DECF',
       '--',
       400,
       4,
       'INTERV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'INTERV',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       180,
       200,
       'MAQECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Mquina na Rede',
       'Nome da Mquina na Rede',
       '',
       'MAQECF',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       250,
       20,
       'MARECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Marca do ECF',
       'Marca do ECF',
       '',
       'MARECF',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '99',
       370,
       12,
       'MAXCAI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Vlr Max Din Caixa',
       'Valor Mximo em Caixa (dinheiro e cheque)',
       '',
       'MAXCAI',
       '' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       260,
       20,
       'MODECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Modelo do ECF',
       'Marca do ECF',
       '',
       'MODECF',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '99',
       490,
       1,
       'NIVLOG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Nvel de Log',
       'Nvel de Log',
       '',
       'NIVLOG',
       'T' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       6,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nr ECF',
       'Nmero Emissor Cupom Fiscal',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       190,
       3,
       'NUMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero~Origem',
       'Nmero~Origem',
       '',
       'NUMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       7,
       5,
       'PORECF',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'ECF do portador',
       'ECF do portador',
       '',
       'PORECF',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '99',
       170,
       254,
       'SAIENV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sada de Envio',
       'Sada de Envio',
       '',
       'SAIENV',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '99',
       640,
       3,
       'SERCON_DECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Srie Fiscal Cont.',
       'Srie Fiscal para Contingncia de NFCe',
       '',
       'SERCON_DECF',
       '' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       9,
       15,
       'SERECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nr Srie',
       'Nmero de Srie ECF',
       '',
       'SERECF',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       340,
       6,
       'TNCIEE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd Nacional do ECF',
       'Cdigo Nacional de Identificao de ECF',
       '',
       'TNCIEE',
       'F' FROM DUAL
UNION ALL
SELECT 'DECF',
       '01',
       270,
       10,
       'VSWECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Verso do SB',
       'Verso do Software Bsico do ECF',
       '',
       'VSWECF',
       'F' FROM DUAL
);

/*-- SEQ 7251 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DECF',
       'ARRTRU',
       0,
       'A',
       'Arredonda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'ARRTRU',
       0,
       'T',
       'Trunca',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'CK4G_ACAOPADRAO',
       1,
       ' ',
       'Impresso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'CK4G_ACAOPADRAO',
       2,
       ' ',
       'E-mail',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'CK4G_ACAOPADRAO',
       9,
       ' ',
       'Ambos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'CK4G_BARRASPADRAO',
       0,
       ' ',
       'Nenhum',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'CK4G_BARRASPADRAO',
       1,
       ' ',
       'CodABar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'CK4G_BARRASPADRAO',
       2,
       ' ',
       'Code128',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'CK4G_USAFRETE',
       0,
       'A',
       'Na nota e no cupom fiscal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'CK4G_USAFRETE',
       0,
       'C',
       'No cupom fiscal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'CK4G_USAFRETE',
       0,
       'N',
       'Na nota fiscal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'CK4G_USAFRETE',
       0,
       'X',
       'No usa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'COBECF',
       0,
       'E',
       'E',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'CTAABE',
       0,
       'E',
       'E',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'CTADIF',
       0,
       'E',
       'E',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'CTAFEC',
       0,
       'E',
       'E',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'CTATRO',
       0,
       'E',
       'E',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'ECFUTL',
       0,
       'A',
       'Administrao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'ECFUTL',
       0,
       'L',
       'Loja',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'ECFUTL',
       0,
       'U',
       'ECF de Loja Autorizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'FLGCFE',
       0,
       ' ',
       'Padro da UF',
       TO_NUMBER(null),
       '00.0' FROM DUAL
UNION ALL
SELECT 'DECF',
       'FLGCFE',
       0,
       ' ',
       'CF-e-SAT',
       TO_NUMBER(null),
       '59.0' FROM DUAL
UNION ALL
SELECT 'DECF',
       'FLGCFE',
       0,
       ' ',
       'NFC-e',
       TO_NUMBER(null),
       '65.0' FROM DUAL
UNION ALL
SELECT 'DECF',
       'FLGCFE',
       0,
       ' ',
       'NFC-e sem Contingncia Offline',
       TO_NUMBER(null),
       '65.1' FROM DUAL
UNION ALL
SELECT 'DECF',
       'NIVLOG',
       0,
       ' ',
       'Nenhum',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'NIVLOG',
       1,
       ' ',
       'Erros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'NIVLOG',
       2,
       ' ',
       'Alerta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'NIVLOG',
       3,
       ' ',
       'Detalhado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECF',
       'NIVLOG',
       9,
       ' ',
       'Completo',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7252 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DECW',
       TO_NUMBER(null),
       'DECW',
       'Dom.Emissor Cup.Fis.',
       'TD_ECF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DECW.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7253 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DECW','--','' FROM DUAL
UNION ALL
SELECT 'DECW','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DECW','99','Outros' FROM DUAL
);

/*-- SEQ 7254 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22484,
       'RCAI',
       'DECW',
       '1',
       'N',
       '',
       '',
       'RCAI.CODFIL = DECW.FILECF AND
RCAI.NUMECF = DECW.NUMECF',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22485,
       'RECF',
       'DECW',
       '1',
       'N',
       '',
       '',
       'RECF.CODFIL = DECW.FILECF AND
RECF.NUMECF = DECW.NUMECF',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22486,
       'AUT ',
       'DECW',
       '1',
       'N',
       '',
       '',
       'AUT.CODFIL = DECW.FILECF AND
AUT.NUMECF = DECW.NUMECF',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22487,
       'CCC ',
       'DECW',
       '1',
       'N',
       '',
       '',
       'CCC.CODFIL = DECW.FILECF AND
CCC.NUMECF = DECW.NUMECF',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22488,
       'ECF ',
       'DECW',
       '1',
       'N',
       '',
       '',
       'ECF.CODFIL = DECW.FILECF AND
ECF.NUMECF = DECW.NUMECF',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22489,
       'REC ',
       'DECW',
       '1',
       'N',
       '',
       '',
       'REC.FILREC = DECW.FILECF AND
REC.NUMECF = DECW.NUMECF',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22490,
       'VEN ',
       'DECW',
       '1',
       'N',
       '',
       '',
       'VEN.CODFIL = DECW.FILECF AND
VEN.NUMECF = DECW.NUMECF',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45920,
       'RECP',
       'DECW',
       '1',
       'N',
       '',
       '',
       'RECP.FILREC = DECW.FILECF AND
RECP.NUMECF = DECW.NUMECF',
       '',
       '' FROM DUAL
);

/*-- SEQ 7255 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DECW',
       '99',
       190,
       1,
       'ARRTRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Arredonda ou trunca?',
       'ECF arredonda ou trunca?',
       '',
       'ARRTRU',
       'T' FROM DUAL
UNION ALL
SELECT 'DECW',
       '--',
       200,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ASSINA',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '--',
       210,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       1,
       1,
       'COBECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Cobrana ECF',
       'Cobrana ECF',
       '',
       'COBECF',
       'T' FROM DUAL
UNION ALL
SELECT 'DECW',
       '--',
       220,
       5,
       'CODCTR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '--',
       230,
       20,
       'CODEXT_DECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODEXT_DECF',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '--',
       240,
       3,
       'CODFAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODFAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '--',
       250,
       2,
       'CODMOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODMOD',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       20,
       5,
       'CODMUL',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       'F',
       'Sub-Estoque',
       'Nome do Sub-Estoque',
       'DMUL.CODTAB = DECW.CODMUL',
       'CODMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       30,
       3,
       'CODORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Origem',
       'Cdigo Origem',
       '',
       'CODORI',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       2,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '--',
       260,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '--',
       270,
       4,
       'CRZINI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CRZINI',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       40,
       1,
       'CTAABE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Conta Abertura',
       'Conta Abertura',
       '',
       'CTAABE',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       50,
       1,
       'CTADIF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Conta Diferena ECF',
       'Conta Diferena ECF',
       '',
       'CTADIF',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       60,
       1,
       'CTAFEC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Conta Fechamento',
       'Conta Fechamento',
       '',
       'CTAFEC',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       70,
       1,
       'CTATRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Conta Cheque Troco',
       'Conta Cheque Troco',
       '',
       'CTATRO',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '99',
       400,
       1,
       'DECF_NUMEXT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Cd. Externo Obrig.',
       'Cdigo Externo Obrigatrio',
       '',
       'DECF_NUMEXT',
       '' FROM DUAL
UNION ALL
SELECT 'DECW',
       '--',
       280,
       7,
       'DSWECF',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DSWECF',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       3,
       1,
       'ECFATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'ECF Ativo?',
       'ECF Ativo?',
       '',
       'ECFATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '--',
       290,
       3,
       'ECFCOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ECFCOL',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '--',
       300,
       1,
       'ECFMFA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ECFMFA',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '--',
       310,
       7,
       'ECFTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ECFTIP',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '--',
       320,
       1,
       'ECFUTL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ECFUTL',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       80,
       3,
       'FILABE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Abertura',
       'Filial Abertura',
       '',
       'FILABE',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       4,
       3,
       'FILDIF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial de dif de cx.',
       'Filial Diferencial de Caixa',
       '',
       'FILDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       5,
       3,
       'FILECF',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial ',
       'Filial Emissor Cupom Fiscal',
       'DECW.FILECF = DFIL.CODFIL(+)',
       'FILECF',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       90,
       3,
       'FILFEC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Fechamento',
       'Filial Fechamento',
       '',
       'FILFEC',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       100,
       3,
       'FILTRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Conta Cheque Troco',
       '',
       'FILTRO',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '--',
       330,
       1,
       'FITDET',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FITDET',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '--',
       340,
       4,
       'INTERV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'INTERV',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       180,
       200,
       'MAQECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Mquina na Rede',
       'Nome da Mquina na Rede',
       '',
       'MAQECF',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '--',
       350,
       20,
       'MARECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARECF',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '--',
       360,
       12,
       'MAXCAI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       '',
       '',
       'MAXCAI',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '--',
       370,
       20,
       'MODECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MODECF',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       6,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nr ECF',
       'Nmero Emissor Cupom Fiscal',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       7,
       5,
       'PORECF',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'ECF do portador',
       'ECF do portador',
       '',
       'PORECF',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '99',
       170,
       254,
       'SAIENV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sada de Envio',
       'Sada de Envio',
       '',
       'SAIENV',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       110,
       10,
       'SEQABE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador de Abertura',
       '',
       'SEQABE',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       8,
       10,
       'SEQDIF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Diferena do ECF',
       '',
       'SEQDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       120,
       10,
       'SEQFEC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Fechamento',
       '',
       'SEQFEC',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       130,
       10,
       'SEQTRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Conta Cheque Troco',
       '',
       'SEQTRO',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '99',
       410,
       3,
       'SERCON_DECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Srie Fiscal Cont.',
       'Srie Fiscal para Contingncia de NFCe',
       '',
       'SERCON_DECF',
       '' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       9,
       15,
       'SERECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nr Srie',
       'Nmero de Srie ECF',
       '',
       'SERECF',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       140,
       1,
       'TIPABE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Abertura',
       'Tipo de Abertura',
       '',
       'TIPABE',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       10,
       1,
       'TIPDIF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Diferena ECF',
       'Tipo Diferena do ECF',
       '',
       'TIPDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       150,
       1,
       'TIPFEC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Fechamento',
       'Tipo Fecjamento',
       '',
       'TIPFEC',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '01',
       160,
       1,
       'TIPTRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Cheque Troco',
       'Tipo Conta Cheque Troco',
       '',
       'TIPTRO',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '--',
       380,
       6,
       'TNCIEE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TNCIEE',
       'F' FROM DUAL
UNION ALL
SELECT 'DECW',
       '--',
       390,
       10,
       'VSWECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VSWECF',
       'F' FROM DUAL
);

/*-- SEQ 7256 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DECW',
       'ARRTRU',
       0,
       'A',
       'Arredonda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECW',
       'ARRTRU',
       0,
       'T',
       'Trunca',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECW',
       'COBECF',
       0,
       'E',
       'E',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECW',
       'CTAABE',
       0,
       'E',
       'E',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECW',
       'CTADIF',
       0,
       'E',
       'E',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECW',
       'CTAFEC',
       0,
       'E',
       'E',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECW',
       'CTATRO',
       0,
       'E',
       'E',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECW',
       'TIPABE',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECW',
       'TIPABE',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECW',
       'TIPABE',
       0,
       'N',
       'Numrica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECW',
       'TIPDIF',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECW',
       'TIPDIF',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECW',
       'TIPDIF',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECW',
       'TIPFEC',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECW',
       'TIPFEC',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECW',
       'TIPFEC',
       0,
       'N',
       'Numrica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECW',
       'TIPTRO',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DECW',
       'TIPTRO',
       0,
       'N',
       'Numrica',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7257 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DEND',
       TO_NUMBER(null),
       'DEND',
       'Dom. Endereos',
       'TD_END',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DEND.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7258 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DEND','--','' FROM DUAL
UNION ALL
SELECT 'DEND','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DEND','99','Outros' FROM DUAL
);

/*-- SEQ 7259 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DEND',
       '01',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DEND',
       '01',
       20,
       20,
       'DESEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Endereo',
       'Descrio Endereo',
       '',
       'DESEND',
       'F' FROM DUAL
UNION ALL
SELECT 'DEND',
       '01',
       30,
       1,
       'DUPEND',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Aceita Duplicidade?',
       'Aceita duplicidade por cliente?',
       '',
       'DUPEND',
       'F' FROM DUAL
UNION ALL
SELECT 'DEND',
       '01',
       40,
       1,
       'ENDATV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Endereo Ativo?',
       'Endereo Ativo?',
       '',
       'ENDATV',
       'F' FROM DUAL
UNION ALL
SELECT 'DEND',
       '01',
       50,
       1,
       'USOEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Uso Endereo',
       'Uso Endereo',
       '',
       'USOEND',
       'F' FROM DUAL
);

/*-- SEQ 7260 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DEND',
       'USOEND',
       0,
       'A',
       'Ambos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DEND',
       'USOEND',
       0,
       'F',
       'Pessoa Fsica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DEND',
       'USOEND',
       0,
       'J',
       'Pessoa Jurdica',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7261 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DENT',
       TO_NUMBER(null),
       'DENT',
       'Dom. Tipos de Entreg',
       'TD_ENT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7262 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DENT','--','' FROM DUAL
UNION ALL
SELECT 'DENT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DENT','99','Outros' FROM DUAL
);

/*-- SEQ 7263 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DENT',
       '--',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       'A',
       'F',
       '',
       'Cdigo da Tab. Tipo de Entrega',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DENT',
       '01',
       20,
       20,
       'DESENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio do Tipo de Entrega',
       '',
       'DESENT',
       'F' FROM DUAL
UNION ALL
SELECT 'DENT',
       '01',
       50,
       1,
       'ENTATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo no Order?',
       'Ativo no Order?',
       '',
       'ENTATI',
       '' FROM DUAL
UNION ALL
SELECT 'DENT',
       '01',
       60,
       1,
       'ENTFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Filial de Entrega',
       'Filial de Entrega',
       '',
       'ENTFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'DENT',
       '01',
       30,
       2,
       'PRZENT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Prazo de Entrega',
       'Prazo de Entrega',
       '',
       'PRZENT',
       'F' FROM DUAL
UNION ALL
SELECT 'DENT',
       '01',
       40,
       1,
       'TIPENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Entrega',
       'Tipo de Entrega',
       '',
       'TIPENT',
       'T' FROM DUAL
);

/*-- SEQ 7264 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DENT',
       'ENTFIL',
       0,
       '0',
       'Livre',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DENT',
       'ENTFIL',
       0,
       '1',
       'Filial do DAV',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DENT',
       'ENTFIL',
       0,
       '2',
       'Filial Depsito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DENT',
       'TIPENT',
       0,
       '0',
       'Cliente Leva',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DENT',
       'TIPENT',
       0,
       '1',
       'Depsito Entrega',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DENT',
       'TIPENT',
       0,
       '2',
       'Loja Entrega',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DENT',
       'TIPENT',
       0,
       '3',
       'Retira no Depsito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DENT',
       'TIPENT',
       0,
       '4',
       'Em Outra Loja',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DENT',
       'TIPENT',
       0,
       '5',
       'Entrega Futura',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DENT',
       'TIPENT',
       0,
       '6',
       'Apenas Oramento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DENT',
       'TIPENT',
       0,
       '7',
       'Venda sob Encomenda',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7265 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DES ',
       TO_NUMBER(null),
       'DES ',
       'Descarga Combustvel',
       'TT_DES',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7266 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DES ','--','' FROM DUAL
UNION ALL
SELECT 'DES ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DES ','99','Outros' FROM DUAL
);

/*-- SEQ 7267 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5463,
       'ICO ',
       'DES ',
       '1 ',
       'N ',
       '',
       '',
       'ICO.CODFIL = DES.FILICO(+) AND
ICO.SEQUEN = DES.SEQICO(+) AND
ICO.NUMITE = DES.NUMICO(+)',
       '' FROM DUAL
);

/*-- SEQ 7268 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DES ',
       '01',
       60,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Atualizao',
       'Data Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'DES ',
       '01',
       10,
       5,
       'CODTAN',
       'S',
       'DTAN',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DTAN.',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo~do Tanque',
       'Cdigo do Tanque',
       'DTAN.CODTAN = DES.CODTAN(+)',
       'CODTAN',
       'T' FROM DUAL
UNION ALL
SELECT 'DES ',
       '01',
       70,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Usurio',
       'DES.FILUSU = USU.FILUSU(+)  AND DES.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'DES ',
       '01',
       20,
       3,
       'FILICO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial~Item Compra',
       'Filial Item de Compra',
       '',
       'FILICO',
       'F' FROM DUAL
UNION ALL
SELECT 'DES ',
       '01',
       80,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Usurio',
       'Filial Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'DES ',
       '01',
       30,
       5,
       'NUMICO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero~Item Compra',
       'Nmero Item de Compra',
       '',
       'NUMICO',
       'F' FROM DUAL
UNION ALL
SELECT 'DES ',
       '01',
       40,
       9,
       'QTDLTS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade~de Litros',
       'Quantidade de Litros',
       '',
       'QTDLTS',
       'F' FROM DUAL
UNION ALL
SELECT 'DES ',
       '01',
       50,
       10,
       'SEQICO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQICO',
       'F' FROM DUAL
);

/*-- SEQ 7269 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DESP',
       0,
       'DESP',
       'Dom. Espcies',
       'TD_ESP',
       'F',
       '',
       'TOTALL',
       'Espcies de Volume',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DESP.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7270 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DESP','--','' FROM DUAL
);

/*-- SEQ 7271 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DESP',
       '--',
       30,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DESP',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DESP',
       '--',
       10,
       1,
       'ESPATI',
       'L',
       '',
       0,
       0,
       'DESP',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'ESPATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DESP',
       '--',
       20,
       20,
       'ESPECI',
       'A',
       '',
       0,
       0,
       'DESP',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Descrio',
       'Espcie de volume',
       '',
       'ESPECI',
       'F' FROM DUAL
);

/*-- SEQ 7272 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DEST',
       0,
       'DEST',
       'Dom. U.F.',
       'TD_EST',
       'F',
       '',
       'TOTALL',
       'UF',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DEST.ESTADO',
       '' FROM DUAL
);

/*-- SEQ 7273 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DEST','--','' FROM DUAL
);

/*-- SEQ 7274 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DEST',
       '--',
       80,
       0,
       'ALIINT',
       'L',
       '',
       0,
       0,
       'DEST',
       80,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Aliquota Interna?',
       'Alquota Interna',
       '',
       'ALIINT',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       2160,
       8,
       'ATU_EM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data da atualizao',
       'Data da atualizao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       2180,
       1,
       'BASMAR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Majorar Base ICMS?',
       'Majorar Base de ICMS de Destino da Partilha?',
       '',
       'BASMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       191,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DEST',
       190,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       20,
       2,
       'ESTADO',
       'A',
       '',
       0,
       0,
       'DEST',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Estado',
       'Sigla do Estado',
       '',
       'ESTADO',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       10,
       1,
       'ESTATI',
       'L',
       '',
       0,
       0,
       'DEST',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'ESTATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       200,
       2,
       'ESTIBG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Cod. IBGE p/ Estado',
       'Cdigo IBGE para Estado',
       '',
       'ESTIBG',
       '' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       50,
       1,
       'ICMCID',
       'L',
       '',
       0,
       0,
       'DEST',
       50,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'ICMS dif. por cidade',
       'ICMS por cidade (S/N)',
       '',
       'ICMCID',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       2150,
       12,
       'ICMIMP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Alquota ICMS Prod. ',
       'Alquota de ICMS de produtos importados',
       '',
       'ICMIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       2120,
       8,
       'ICMINT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'ICMS Interno',
       'ICMS Interno',
       '',
       'ICMINT',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       60,
       15,
       'INSCST',
       'A',
       '',
       0,
       0,
       'DEST',
       60,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Inscr. Estadual',
       'Incrio Estadual - Substituio Tributria',
       '',
       'INSCST',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       90,
       8,
       'MARG00',
       'F',
       '',
       2,
       0,
       'DEST',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Margem 1',
       'Margem 00',
       '',
       'MARG00',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       100,
       8,
       'MARG01',
       'F',
       '',
       2,
       0,
       'DEST',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Margem 2',
       'Margem 01',
       '',
       'MARG01',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       110,
       8,
       'MARG02',
       'F',
       '',
       2,
       0,
       'DEST',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Margem 3',
       'Margem 02',
       '',
       'MARG02',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       120,
       8,
       'MARG03',
       'F',
       '',
       2,
       0,
       'DEST',
       120,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Margem 4',
       'Margem 03',
       '',
       'MARG03',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       130,
       8,
       'MARG04',
       'F',
       '',
       2,
       0,
       'DEST',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Margem 5',
       'Margem 04',
       '',
       'MARG04',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       140,
       8,
       'MARG05',
       'F',
       '',
       2,
       0,
       'DEST',
       140,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Margem 6',
       'Margem 05',
       '',
       'MARG05',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       151,
       8,
       'MARG06',
       'F',
       '',
       2,
       0,
       'DEST',
       150,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Margem 7',
       'Margem 06',
       '',
       'MARG06',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       160,
       8,
       'MARG07',
       'F',
       '',
       2,
       0,
       'DEST',
       160,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Margem 8',
       'Margem 07',
       '',
       'MARG07',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       171,
       8,
       'MARG08',
       'F',
       '',
       2,
       0,
       'DEST',
       170,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Margem 9',
       'Margem 08',
       '',
       'MARG08',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       180,
       8,
       'MARG09',
       'F',
       '',
       2,
       0,
       'DEST',
       180,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Margem 10',
       'Margem 09',
       '',
       'MARG09',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       2130,
       12,
       'MAX_CF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor maximo CF',
       'Valor mximo permitido para CF',
       '',
       'MAX_CF',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       40,
       28,
       'NOMEST',
       'A',
       '',
       0,
       0,
       'DEST',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Nome do Estado',
       'Nome do Estado',
       '',
       'NOMEST',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       70,
       0,
       'NORINT',
       'L',
       '',
       0,
       0,
       'DEST',
       70,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Normal se interno?',
       'Normal se Interno',
       '',
       'NORINT',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       2000,
       1,
       'ONDCAL',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       200,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Onde Calcula Subst.',
       'Onde calcula a substituio tributria',
       '',
       'ONDCAL',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       2170,
       5,
       'PERFCP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Fundo Comb Pobreza',
       '% do Fundo de Combate  Pobreza na UF',
       '',
       'PERFCP',
       '' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       30,
       8,
       'PERICM',
       'F',
       '',
       2,
       0,
       'DEST',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       '% ICMS',
       'Percentual de ICMS do Estado',
       '',
       'PERICM',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       2110,
       12,
       'PERREP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '% Repasse ICMS',
       'Percentual para repasse',
       '',
       'PERREP',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       2100,
       1,
       'SOMBAS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       210,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Soma base (T/F)?',
       'Soma base (T/F)',
       '',
       'SOMBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'DEST',
       '--',
       2140,
       12,
       'SUBLIM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Sublimite da Receita',
       'Sublimite da Receita Bruta',
       '',
       'SUBLIM',
       'F' FROM DUAL
);

/*-- SEQ 7275 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DETI',
       0,
       'DETI',
       'Dom. Etiquetas',
       'TD_ETI',
       'F',
       '',
       'TOTALL',
       'Etiquetas',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DETI.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7276 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DETI','--','' FROM DUAL
);

/*-- SEQ 7277 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DETI',
       '--',
       80,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DETI',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DETI',
       '--',
       20,
       20,
       'DESETI',
       'A',
       '',
       0,
       0,
       'DETI',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Descrio',
       'Descrio da etiqueta',
       '',
       'DESETI',
       'F' FROM DUAL
UNION ALL
SELECT 'DETI',
       '--',
       10,
       1,
       'ETIATI',
       'L',
       '',
       0,
       0,
       'DETI',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'ETIATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DETI',
       '--',
       40,
       50,
       'INIETI',
       'A',
       '',
       0,
       0,
       'DETI',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Inicializao',
       'Caracteres de inicializao da impressora',
       '',
       'INIETI',
       'F' FROM DUAL
UNION ALL
SELECT 'DETI',
       '--',
       70,
       2,
       'LARETI',
       'S',
       '',
       0,
       0,
       'DETI',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       '',
       'T',
       'N de repeties Lat',
       'Largura da Etiqueta',
       '',
       'LARETI',
       'F' FROM DUAL
UNION ALL
SELECT 'DETI',
       '--',
       60,
       2,
       'LARNOM',
       'S',
       '',
       0,
       0,
       'DETI',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       '',
       'T',
       'Largura',
       'Largura do Extenso',
       '',
       'LARNOM',
       'F' FROM DUAL
UNION ALL
SELECT 'DETI',
       '--',
       9,
       255,
       'RBFILE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path do Arquivo',
       'Path do Arquivo',
       '',
       'RBFILE',
       'F' FROM DUAL
UNION ALL
SELECT 'DETI',
       '--',
       50,
       50,
       'SAIETI',
       'A',
       '',
       0,
       0,
       'DETI',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Saida em',
       'Caracteres de finalizao da impressora',
       '',
       'SAIETI',
       'F' FROM DUAL
UNION ALL
SELECT 'DETI',
       '--',
       800,
       4000,
       'TXTETI',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Uso interno',
       'Compatibilidade com verses anteriores',
       '',
       'RTF2TXT(TXTETI)',
       'F' FROM DUAL
);

/*-- SEQ 7278 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DEV ',
       TO_NUMBER(null),
       'DEV ',
       'Devedores (Reg. SPC)',
       'TT_DEV',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DEV.CODFIL,DEV.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7279 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DEV ','--','' FROM DUAL
UNION ALL
SELECT 'DEV ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DEV ','99','Outros' FROM DUAL
);

/*-- SEQ 7280 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 44958,
       'CHR ',
       'DEV ',
       'N',
       '1',
       '',
       '',
       'CHR.CODFIL = DEV.FILCHR AND
CHR.SEQUEN = DEV.SEQCHR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 44959,
       'PAR ',
       'DEV ',
       'N',
       '1',
       '',
       '',
       'PAR.FILCLI = DEV.FILCLI AND
PAR.CODCLI = DEV.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 44960,
       'REC ',
       'DEV ',
       'N',
       '1',
       '',
       '',
       'REC.SEQUEN = DEV.SEQREC AND
REC.CODFIL = DEV.FILREC AND
REC.NUMPAR = DEV.NUMPAR AND
REC.SUBPAR = DEV.SUBPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 44961,
       'CLI ',
       'DEV ',
       '1',
       '1',
       '',
       '',
       'CLI.FILCLI = DEV.FILCLI AND
CLI.CODCLI = DEV.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45921,
       'RECP',
       'DEV ',
       'N',
       '1',
       '',
       '',
       'RECP.ORI_SEQUEN = DEV.SEQREC AND
RECP.ORI_CODFIL = DEV.FILREC AND
RECP.ORI_NUMPAR = DEV.NUMPAR AND
RECP.ORI_SUBPAR = DEV.SUBPAR',
       '',
       '' FROM DUAL
);

/*-- SEQ 7281 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DEV ',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'DEV ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'DEV ',
       '01',
       30,
       3,
       'FILCHR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Cheques Receb',
       'Filial Cheques Recebidos',
       '',
       'FILCHR',
       'F' FROM DUAL
UNION ALL
SELECT 'DEV ',
       '01',
       40,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'DEV ',
       '01',
       50,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'DEV ',
       '01',
       60,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'DEV ',
       '01',
       70,
       7,
       'REGEXC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Reg. Excluso',
       'Data Registro Excluso',
       '',
       'REGEXC',
       'F' FROM DUAL
UNION ALL
SELECT 'DEV ',
       '01',
       80,
       7,
       'REGINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Reg. Incluso',
       'Data Reg. Incluso',
       '',
       'REGINC',
       'F' FROM DUAL
UNION ALL
SELECT 'DEV ',
       '01',
       90,
       10,
       'SEQCHR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Seq. Cheques a Receber',
       '',
       'SEQCHR',
       'F' FROM DUAL
UNION ALL
SELECT 'DEV ',
       '01',
       100,
       10,
       'SEQREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Seq. Recebimento',
       '',
       'SEQREC',
       'F' FROM DUAL
UNION ALL
SELECT 'DEV ',
       '01',
       110,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'DEV ',
       '01',
       120,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       'Sub-Parc.',
       'Nmero da sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'DEV ',
       '01',
       130,
       7,
       'TRNEXC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Transm. Exclu.',
       'Data Transmisso Excluso',
       '',
       'TRNEXC',
       'F' FROM DUAL
UNION ALL
SELECT 'DEV ',
       '01',
       140,
       7,
       'TRNINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Transm. Inclu.',
       'Data Transmisso Incluso',
       '',
       'TRNINC',
       'F' FROM DUAL
);

/*-- SEQ 7282 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DEVF',
       TO_NUMBER(null),
       'DEVF',
       'Situao de Eventos',
       'TV_EVE_FLG',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DEVF.CODARQ',
       '' FROM DUAL
);

/*-- SEQ 7283 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DEVF','--','' FROM DUAL
);

/*-- SEQ 7284 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DEVF',
       '--',
       10,
       4,
       'CODARQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Arquivo',
       'Cdigo do Arquivo',
       '',
       'CODARQ',
       'F' FROM DUAL
UNION ALL
SELECT 'DEVF',
       '--',
       20,
       1,
       'CODCHR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cdigo Alfa',
       'Cdigo Alfa',
       '',
       'CODCHR',
       'F' FROM DUAL
UNION ALL
SELECT 'DEVF',
       '--',
       30,
       60,
       'DESDOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Descrio do Domnio',
       'Descrio do Domnio',
       '',
       'DESDOM',
       'F' FROM DUAL
);

/*-- SEQ 7285 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DEVT',
       TO_NUMBER(null),
       'DEVT',
       'Tipos de Eventos',
       'TV_EVE_TIP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DEVT.TIPEVE',
       '' FROM DUAL
);

/*-- SEQ 7286 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DEVT','--','' FROM DUAL
);

/*-- SEQ 7287 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DEVT',
       '--',
       2,
       16,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Descrio de Evento',
       'Descrio de Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'DEVT',
       '--',
       1,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Tipo de Evento',
       'Tipo de Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
);

/*-- SEQ 7288 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DEXP',
       TO_NUMBER(null),
       'DEXP',
       'Dom.Padres Exporta.',
       'TD_EXP',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DEXP.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7289 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DEXP','--','' FROM DUAL
UNION ALL
SELECT 'DEXP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DEXP','99','Outros' FROM DUAL
);

/*-- SEQ 7290 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DEXP',
       '--',
       10,
       30,
       'ALIEXP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Alias  de Exportao',
       'Alias de Exportao',
       '',
       'ALIEXP',
       'F' FROM DUAL
UNION ALL
SELECT 'DEXP',
       '--',
       20,
       1,
       'ATIEXP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'ATIEXP',
       'F' FROM DUAL
UNION ALL
SELECT 'DEXP',
       '--',
       30,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DEXP',
       '--',
       50,
       7,
       'DATFIM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Final',
       'Data Final',
       '',
       'DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'DEXP',
       '--',
       60,
       7,
       'DATINI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Inicial',
       'Data Inicial',
       '',
       'DATINI',
       'F' FROM DUAL
UNION ALL
SELECT 'DEXP',
       '--',
       40,
       20,
       'DESEXP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Padro',
       'Descrio Padro',
       '',
       'DESEXP',
       'F' FROM DUAL
UNION ALL
SELECT 'DEXP',
       '--',
       70,
       1,
       'USOEXC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Uso ExclusivoTotali?',
       'Uso Exclusivo da Totali',
       '',
       'USOEXC',
       'F' FROM DUAL
);

/*-- SEQ 7291 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DEXT',
       TO_NUMBER(null),
       'DEXT',
       'Dom. Extrato',
       'TD_EXT',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7292 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DEXT','--','' FROM DUAL
UNION ALL
SELECT 'DEXT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DEXT','99','Outros' FROM DUAL
);

/*-- SEQ 7293 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DEXT',
       '--',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cd. Tabela',
       '',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DEXT',
       '--',
       20,
       50,
       'DESEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Extrato',
       'Descrio Extrato',
       '',
       'DESEXT',
       'F' FROM DUAL
);

/*-- SEQ 7294 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DFCC',
       TO_NUMBER(null),
       'DFCC',
       'Faixa Clculo Combus',
       'TD_FCC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DFCC.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7295 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DFCC','--','' FROM DUAL
UNION ALL
SELECT 'DFCC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DFCC','99','Outros' FROM DUAL
);

/*-- SEQ 7296 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22093,
       'GRA ',
       'DFCC',
       '1',
       'N',
       '',
       '',
       'DFCC.FCC_FILMAT = GRA.FILMAT AND
DFCC.FCC_CODMAT = GRA.CODMAT AND
DFCC.FCC_CODCOR = GRA.CODCOR AND
DFCC.FCC_CODTAM = GRA.CODTAM ',
       '',
       '' FROM DUAL
);

/*-- SEQ 7297 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DFCC',
       '01',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Atualizado em',
       'Atualizado em',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'DFCC',
       '01',
       20,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DFCC',
       '--',
       30,
       1,
       'FCCATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'FCCATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DFCC',
       '--',
       60,
       3,
       'FCCFIL',
       'A',
       'FIL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'FIL2.CODFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Codigo Filial',
       'Codigo Filial',
       'FIL2.CODFIL = DFCC.FCCFIL',
       'FCCFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'DFCC',
       '--',
       70,
       5,
       'FCC_CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       '',
       'N',
       'F',
       'Diviso',
       'Diviso',
       'GRA.CODCOR=DIV.CODITE (+)',
       'FCC_CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'DFCC',
       '--',
       80,
       5,
       'FCC_CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do material',
       'Cdigo do material',
       '',
       'FCC_CODMAT',
       'T' FROM DUAL
UNION ALL
SELECT 'DFCC',
       '--',
       90,
       5,
       'FCC_CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       '',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso',
       'GRA.CODTAM=SUB.CODITE (+)',
       'FCC_CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'DFCC',
       '--',
       100,
       3,
       'FCC_FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filia do Material',
       'Filia do Material',
       '',
       'FCC_FILMAT',
       'T' FROM DUAL
UNION ALL
SELECT 'DFCC',
       '--',
       40,
       7,
       'PERATE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Percetual maximo',
       'Percetual maximo',
       '',
       'PERATE',
       'F' FROM DUAL
UNION ALL
SELECT 'DFCC',
       '--',
       50,
       7,
       'VLRTAX',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Taxa',
       'Valor Taxa',
       '',
       'VLRTAX',
       'F' FROM DUAL
);

/*-- SEQ 7298 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DFCE',
       TO_NUMBER(null),
       'DFCE',
       'Faixa Cons Eletrica',
       'TD_FCE',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       ':DFCE.CODFCE',
       '' FROM DUAL
);

/*-- SEQ 7299 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DFCE','--','' FROM DUAL
UNION ALL
SELECT 'DFCE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DFCE','99','Outros' FROM DUAL
);

/*-- SEQ 7300 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DFCE',
       '01',
       10,
       2,
       'CODFCE',
       'S',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Cdigo Faixa Cons.',
       'Cdigo da Faixa de Consumo',
       '',
       'CODFCE',
       '' FROM DUAL
UNION ALL
SELECT 'DFCE',
       '01',
       20,
       254,
       'DESFCE',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Desc. Faixa Cons.',
       'Descrio da Faixa de Consumo',
       '',
       'DESFCE',
       '' FROM DUAL
);

/*-- SEQ 7301 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DFID',
       TO_NUMBER(null),
       'DFID',
       'Dom. Fidelizao',
       'TD_FID',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DFID.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7302 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DFID','--','' FROM DUAL
UNION ALL
SELECT 'DFID','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DFID','99','Outros' FROM DUAL
);

/*-- SEQ 7303 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DFID',
       '--',
       10,
       1,
       'ATIFID',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'ATIFID',
       'F' FROM DUAL
UNION ALL
SELECT 'DFID',
       '--',
       60,
       25,
       'CLAFID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Classe CSS identif.',
       'Classe CSS para identificar atendimento de clientes com esta fidelizao',
       '',
       'CLAFID',
       '' FROM DUAL
UNION ALL
SELECT 'DFID',
       '--',
       20,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DFID',
       '--',
       30,
       20,
       'DESFID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Desc. Fidelizao',
       'Descrio Fidelizao
',
       '',
       'DESFID',
       'F' FROM DUAL
UNION ALL
SELECT 'DFID',
       '--',
       40,
       0,
       'IMGFID',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Imagem Fidelizao',
       'Imagem Fidelizao',
       '',
       'IMGFID',
       'F' FROM DUAL
UNION ALL
SELECT 'DFID',
       '--',
       70,
       254,
       'IMGFUD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Path Img Fidelizao',
       'Path Imagem de Fidelizao',
       '',
       'IMGFUD',
       '' FROM DUAL
UNION ALL
SELECT 'DFID',
       '--',
       50,
       5,
       'PERFID',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Fidelizao',
       '% Fidelizao',
       '',
       'PERFID',
       'F' FROM DUAL
);

/*-- SEQ 7304 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DFIL',
       0,
       'DFIL',
       'Dom. Filiais',
       'TD_FIL',
       'T',
       '',
       'TOTALL',
       'Filiais',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DFIL.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 7305 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DFIL','--','' FROM DUAL
UNION ALL
SELECT 'DFIL','02','Valores' FROM DUAL
UNION ALL
SELECT 'DFIL','03','Datas' FROM DUAL
);

/*-- SEQ 7306 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21041,
       'DGRU',
       'DFIL',
       '1',
       'N',
       '',
       '',
       'DGRU.CODTAB = DFIL.CODGRU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21042,
       'USU ',
       'DFIL',
       '0N',
       '01',
       '',
       '',
       'USU.FILUSU = DFIL.FILGER(+) AND
USU.CODUSU = DFIL.CODGER(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21043,
       'ECT ',
       'DFIL',
       'N',
       '1',
       '',
       '',
       'ECT.CODFIL = DFIL.FILTES AND
ECT.SEQUEN = DFIL.SEQTES',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21044,
       'CTB ',
       'DFIL',
       'N',
       '1',
       '',
       '',
       'CTB.FILCTA = DFIL.FILPAG AND
CTB.SEQCTA = DFIL.SEQPAG AND
CTB.TIPCTA = DFIL.TIPPAG AND
CTB.CHETRO = DFIL.CTCPAG
',
       '',
       '' FROM DUAL
);

/*-- SEQ 7307 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'DFIL',
       '--',
       200,
       50,
       'ACEFIL',
       'A',
       '',
       0,
       0,
       'DFIL',
       190,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'F',
       'Acessrios da Filial',
       'Acessrios da filial',
       '',
       'ACEFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1100,
       1,
       'ACR_CF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Acrscimo Financeiro',
       'Acrescimo financeiro integra a base de ICMS para consumidor final. ',
       '',
       'ACR_CF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2250,
       5,
       'ALISIM_ICMS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Alquota de ICMS para Simples Nacional',
       '',
       'ALISIM_ICMS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '03',
       166,
       4,
       'ANO_FIMFIL',
       'A',
       '',
       0,
       0,
       'DFIL',
       160,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       '',
       'N',
       'T',
       'Ano de Data mxima',
       'Ano de Data mxima da utilizao',
       '',
       'TO_CHAR(DFIL.FIMFIL,''YYYY'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '03',
       165,
       4,
       'ANO_INIFIL',
       'A',
       '',
       0,
       0,
       'DFIL',
       150,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       '',
       'N',
       'T',
       'Ano de Data mnima',
       'Ano de Data mnima da utilizao',
       '',
       'TO_CHAR(DFIL.INIFIL,''YYYY'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '03',
       183,
       4,
       'ANO_INSTAL',
       'A',
       '',
       0,
       0,
       'DFIL',
       170,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       '',
       'N',
       'T',
       'Ano de Data e hora d',
       'Ano de Data e Hora da instalao',
       '',
       'TO_CHAR(DFIL.INSTAL,''YYYY'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1760,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Assinatura para PAF-ECF',
       '',
       'ASSINA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1520,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Ultima atualizao',
       'Ultima atualizao',
       '',
       'ATU_EM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1530,
       1,
       'BAIFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Baixa outra filial',
       'Permitir Baixas de pagamentos/recebimentos em outras filiais',
       '',
       'BAIFIL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1540,
       1,
       'BAIOUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Baixa outra empresa',
       'Permitir Baixas de pagamentos/recebimentos em outras empresas',
       '',
       'BAIOUT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       830,
       15,
       'BAIRRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Bairro',
       'Bairro',
       '',
       'BAIRRO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1670,
       1,
       'BAISPC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Registro e Baixa SPC',
       'Registro e Baixa no SPC',
       '',
       'BAISPC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2340,
       1,
       'BASICM_MAJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'B.ICMS Maj. Frete, I',
       'Base de ICMS Majorada com frete, IPI e ST da ltima compra',
       '',
       'BASICM_MAJ',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       130,
       15,
       'CGCFIL',
       'A',
       '',
       0,
       0,
       'DFIL',
       130,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'CNPJ',
       'CNPJ da filial',
       '',
       'CGCFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1620,
       10,
       'CHEHOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Verso Hom. Checkout',
       'Verso Homologada do Checkout',
       '',
       'CHEHOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2910,
       1,
       'CK4G_ITEMEMUNICALINHA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Item em 1 Linha',
       'Imprimir Item em 1 Linha',
       '',
       'CK4G_ITEMEMUNICALINHA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2550,
       5,
       'CK4G_MANLOG_DET',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Man Log Det N Dias',
       'Mantm Log Detalhado Por N Dias',
       '',
       'CK4G_MANLOG_DET',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2560,
       5,
       'CK4G_MANLOG_GER',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Man Log Ger N Dias',
       'Mantm Log Geral Por N Dias',
       '',
       'CK4G_MANLOG_GER',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2540,
       5,
       'CK4G_MANMOV',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Man Mov N Dias',
       'Mantm Movimentao Por N Dias',
       '',
       'CK4G_MANMOV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2741,
       2,
       'CK4G_MODFIS_VC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mod. Fiscal VC',
       'Modelo Fiscal para Venda ao Consumidor',
       '',
       'CK4G_MODFIS_VC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2750,
       2,
       'CK4G_MODFIS_VC_CONT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mod. Fiscal (Cont)',
       'Modelo Fiscal (1 Contingncia)',
       '',
       'CK4G_MODFIS_VC_CONT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2760,
       1,
       'CK4G_USA_CONT_OFFLINE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Cont NFC-e Off-line?',
       'Usa Contingncia de 65-NFC-e Offline?',
       '',
       'CK4G_USA_CONT_OFFLINE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1720,
       255,
       'CKPACIDCHE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cidade Pgto Cheque',
       'Cidade Pagamento Cheque',
       '',
       'CKPACIDCHE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1730,
       255,
       'CKPANOMINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cheque Nominal p/',
       'Cheque Nominal a Quem',
       '',
       'CKPANOMINA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2280,
       1,
       'CK_VEN_CMB_EST_ZER',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ven Combust Est Zero',
       'Venda Combustvel com Estoque Zerado?',
       '',
       'CK_VEN_CMB_EST_ZER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       840,
       8,
       'CODCEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Cep',
       'Cdigo Cep',
       '',
       'CODCEP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       850,
       5,
       'CODCID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo da Cidade',
       'Cdigo da Cidade',
       '',
       'CODCID',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       3030,
       6,
       'CODCLIDOA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Cod. da Entidade',
       'Cod. da Entidade Beneficada pela Doao de Troco',
       '',
       'CODCLIDOA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1930,
       6,
       'CODCNT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo do Contador',
       'Cdigo do Contador',
       '',
       'CODCNT ',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2000,
       8,
       'CODCOM_PAGFOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cod  Comunic Pag-For',
       'Cdigo de Comunicao no Pag-For',
       '',
       'CODCOM_PAGFOR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       241,
       3,
       'CODDEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       240,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial depsito',
       'Cdigo da filial para depsito',
       '',
       'CODDEP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       251,
       10,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       250,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo externo',
       'Cdigo externo',
       '',
       'CODEXT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       '',
       0,
       0,
       'DFIL',
       20,
       TO_NUMBER(null),
       '',
       '.',
       'I',
       'TAB',
       'F',
       'N',
       'T',
       'Filial',
       'Cdigo da filial',
       '. = DFIL.CODFIL',
       'CODFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1010,
       3,
       'CODGER',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Gerente',
       'Cdigo do Gerente',
       'USU2.FILUSU(+) = DFIL.FILGER  AND USU2.CODUSU(+) = DFIL.CODGER',
       'CODGER',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       26,
       5,
       'CODGRU',
       'F',
       'DGRU',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DGRU.DESGRU',
       'V',
       '',
       'T',
       '0',
       'F',
       'Grupo',
       'Cdigo do Grupo da Filial',
       'DGRU.CODTAB = DFIL.CODGRU',
       'CODGRU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2780,
       10,
       'CODIBG',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cd. IBGE Municpio',
       'Cdigo IBGE do Municpio',
       '',
       'CODIBG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2380,
       5,
       'CODSTF',
       'S',
       'DSTF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSTF.DESSTF',
       'V',
       '',
       '',
       'N',
       '',
       'Compromisso ST Frete',
       'Gera compromisso de ST de conhecimento de frete automaticamente',
       'DFIL.CODSTF = DSTF.CODTAB(+)',
       'CODSTF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       221,
       2,
       'CODTAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'DFIL',
       220,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2640,
       8,
       'CODTEF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo para o TEF',
       'Cdigo da filial para o TEF',
       '',
       'CODTEF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2170,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       'Identificao de Acesso',
       '',
       'CODUID',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2350,
       3,
       'CODVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Vendedor Padro',
       'Vendedor Padro',
       '',
       'CODVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       1180,
       6,
       'COMCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% COFINS para Compra',
       'Aliquota de COFINS para compra',
       '',
       'COMCOF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1240,
       5,
       'COMGLO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Comisso~Global',
       'Comisso~Global',
       '',
       'COMGLO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2060,
       12,
       'COMIS1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'COMIS1',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2070,
       12,
       'COMIS2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'COMIS2',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2080,
       12,
       'COMIS3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'COMIS3',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2090,
       12,
       'COMIS4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'COMIS4',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       1190,
       6,
       'COMPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% PIS para Compra',
       'Alquota de PIS para compra',
       '',
       'COMPIS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       80,
       45,
       'COMPLE',
       'A',
       '',
       0,
       0,
       'DFIL',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Complemento',
       'Complemento do endereo',
       '',
       'COMPLE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       860,
       28,
       'CONTAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Contato',
       'Contato',
       '',
       'CONTAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       50,
       1,
       'CONVER',
       'L',
       '',
       0,
       0,
       'DFIL',
       50,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'F',
       'Filial Convertida?',
       'Indica se a filial foi convertida ou no',
       '',
       'CONVER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2420,
       1,
       'CREDDF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Programa Crdito DF',
       'Includa no programa de concesso de crditos - Lei n 4.159/08 do DF',
       '',
       'CREDDF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1410,
       20,
       'CRFFAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'CRF do Farmaceutico ',
       'CRF do Farmaceutico responsvel',
       '',
       'CRFFAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2210,
       1,
       'CTCPAG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'N',
       '',
       'Cheque Troco da Cont',
       'Cheque Troco da Conta de Dbito do Pag-For',
       '',
       'CTCPAG',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1420,
       5,
       'CTR_CC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CTR_CC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2290,
       20,
       'DATBAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATBAS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '03',
       1130,
       7,
       'DATCRE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Crdito',
       'Data Crdito',
       '',
       'DATCRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2050,
       7,
       'DATEST',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Atu. Estoque',
       'Data da mais Recente Atualizao do Estoque',
       '',
       'DATEST',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2430,
       7,
       'DATFINEST',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATFINEST',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '03',
       2240,
       7,
       'DATSIM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Dt. Simples Nacional',
       'Data de Entrada no Simples Nacional',
       '',
       'DATSIM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1770,
       1,
       'DAVFIS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Permite DAV fiscal?',
       'Permite DAV fiscal?',
       '',
       'DAVFIS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1780,
       1,
       'DAVNFS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Perm. DAV no fiscal',
       'Permite DAV no fiscal?',
       '',
       'DAVNFS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       100,
       4,
       'DDDFIL',
       'A',
       '',
       0,
       0,
       'DFIL',
       100,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'DDD da filial',
       'DDD da filial',
       '',
       'DDDFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2720,
       1,
       'DESIPI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Destaca IPI?',
       'Destaca IPI?',
       '',
       'DESIPI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2730,
       1,
       'DESIPITRA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Destaca IPI Transf?',
       'Destaca IPI em transferncias? (Somente para Tipo de Comrcio Atacado)',
       '',
       'DESIPITRA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1680,
       1,
       'DIGITACAO_ATACADO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Digitao p/ Atacado',
       'Digitao para Atacado',
       '',
       'DIGITACAO_ATACADO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2255,
       3,
       'ECFEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'ECF Atu. Estoque',
       'ECF que Atualizou Data do Estoque',
       '',
       'ECFEST',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       70,
       45,
       'ENDERE',
       'A',
       '',
       0,
       0,
       'DFIL',
       70,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Endereo',
       'Endereo da filial',
       '',
       'ENDERE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '03',
       670,
       7,
       'EXP_BO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Exp. BackOffice',
       'Data Exportao Backoffice',
       '',
       'EXP_BO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '03',
       490,
       7,
       'EXP_CA',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Exportao Cash',
       'Data de Exportao Cash',
       '',
       'EXP_CA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '03',
       460,
       7,
       'EXP_CF',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Dt Exp.CRMFID',
       'Data Exportao CRMFID',
       '',
       'EXP_CF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       700,
       7,
       'EXP_CG',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Md Config valid.',
       'Mdulo Config - Validade',
       '',
       'EXP_CG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       520,
       7,
       'EXP_CO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Md Checkout valid.',
       'Mdulo Checkout - Validade',
       '',
       'EXP_CO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '03',
       550,
       7,
       'EXP_CS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Exp.C. Server',
       'Data Exportao Checkout Server',
       '',
       'EXP_CS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       760,
       7,
       'EXP_EB',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Md e-Business valid',
       'Mdulo e-Business- Validade',
       '',
       'EXP_EB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       790,
       7,
       'EXP_EC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Md e-Commerce valid',
       'Mdulo e-Commerce - Validade',
       '',
       'EXP_EC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '03',
       400,
       7,
       'EXP_NB',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'DtExpTotaliBIBrowser',
       'Data Exportao Totali BI Browser',
       '',
       'EXP_NB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '03',
       340,
       7,
       'EXP_NC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'DtExp.TotaliBIConfig',
       'Data Exportao Totali BI Config',
       '',
       'EXP_NC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '03',
       370,
       7,
       'EXP_NS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'DtExp.TotaliBIServer',
       'Data Exportao Totali BI Server',
       '',
       'EXP_NS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '03',
       580,
       7,
       'EXP_OR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Export. Order',
       'Data Exportao Order',
       '',
       'EXP_OR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '03',
       280,
       7,
       'EXP_RB',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Dt Exp. Rep. Builder',
       'Data Exportao Report Builder',
       '',
       'EXP_RB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '03',
       310,
       7,
       'EXP_SD',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Dt Exp.Stoq',
       'Exporta Stoq ',
       '',
       'EXP_SD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       610,
       7,
       'EXP_SE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Md Service valid.',
       'Mdulo Service - Validade',
       '',
       'EXP_SE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '03',
       430,
       7,
       'EXP_SW',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'DtExp SAC e Workflow',
       'Data Exportao SAC e Workflow',
       '',
       'EXP_SW',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       640,
       7,
       'EXP_TM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Md Telemarket valid',
       'Mdulo Telemarketing - Validade',
       '',
       'EXP_TM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       730,
       7,
       'EXP_TO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Md Tools valid.',
       'Mdulo Tools - Validade',
       '',
       'EXP_TO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       231,
       254,
       'E_MAIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'DFIL',
       230,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'E-mail',
       'E-mail',
       '',
       'E_MAIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       120,
       8,
       'FAXFIL',
       'A',
       '',
       0,
       0,
       'DFIL',
       120,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Fax da filial',
       'Fax da filial',
       '',
       'FAXFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       10,
       1,
       'FILATI',
       'L',
       '',
       0,
       0,
       'DFIL',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo?',
       '',
       'FILATI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       3020,
       3,
       'FILCLIDOA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Filial da Entidade',
       'Filial da Entidade Beneficiada pela Doao de Troco',
       '',
       'FILCLIDOA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1920,
       3,
       'FILCNT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Filial do Contador',
       'Filial do Contador',
       '',
       'FILCNT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1260,
       3,
       'FILCPM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILCPM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2690,
       3,
       'FILENT_REGESP',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Fil. Ent. Reg. Esp.',
       'Filial para Entrega em Regime Especial',
       'DFIL.CODFIL = DFIL.FILENT_REGESP',
       'FILENT_REGESP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1020,
       3,
       'FILGER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Gerente',
       '',
       'FILGER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1270,
       3,
       'FILJUR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILJUR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1280,
       3,
       'FILLAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILLAN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1630,
       3,
       'FILOUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Rec. Outros',
       'Filial Recebimentos com Outros',
       '',
       'FILOUT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2180,
       3,
       'FILPAG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Dbito PagFor',
       'Filial da Conta de Dbito do Pag-For',
       '',
       'FILPAG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1290,
       3,
       'FILTAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILTAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       870,
       3,
       'FILTES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Conta Tesouraria',
       '',
       'FILTES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       880,
       3,
       'FILTRN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Transferncia',
       '',
       'FILTRN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2360,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1740,
       1,
       'FILWEB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILWEB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1430,
       3,
       'FIL_CT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FIL_CT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '03',
       161,
       8,
       'FIMFIL',
       'D',
       '',
       0,
       0,
       'DFIL',
       160,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       'D',
       'T',
       'Data mxima',
       'Data mxima da utilizao',
       '',
       'FIMFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1440,
       7,
       'FINMAX',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'D',
       'F',
       'Data mxima',
       'Data mxima',
       '',
       'FINMAX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1450,
       7,
       'FINMIN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'D',
       'F',
       'Data mnima',
       'Data mnima',
       '',
       'FINMIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       110,
       8,
       'FONFIL',
       'A',
       '',
       0,
       0,
       'DFIL',
       110,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Fone da filial',
       'Telefone da filial',
       '',
       'FONFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1300,
       5,
       'FRCONT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '%ICMS Fora Cont.',
       'Aliquota de ICMS para Frete fora do Estado (Contribuinte)',
       '',
       'FRCONT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1310,
       5,
       'FRDENT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '%ICMS Dentro Estado',
       'Aliquota de ICMS dentro do Estado',
       '',
       'FRDENT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1320,
       5,
       'FRNAOC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '%ICMS Fora No Cont.',
       'Aliquota de ICMS para Frete Fora do Estado (No-Contribuinte)',
       '',
       'FRNAOC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       201,
       10,
       'HOMOL1',
       'A',
       '',
       0,
       0,
       'DFIL',
       200,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Senha de homologao',
       'Senha de homologao',
       '',
       'HOMOL1',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       220,
       10,
       'HOMOL2',
       'A',
       '',
       0,
       0,
       'DFIL',
       210,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Contra-Senha de hom.',
       'Contra senha de homologao',
       '',
       'HOMOL2',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       150,
       40,
       'HOMPGE',
       'A',
       '',
       0,
       0,
       'DFIL',
       140,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Homepage',
       'Home Page da filial',
       '',
       'HOMPGE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       820,
       10,
       'HOMVER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Homologa Verso',
       'Homologa Verso',
       '',
       'HOMVER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       680,
       10,
       'HOM_BO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Homologa Backoffice',
       'Homologa Backoffice',
       '',
       'HOM_BO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       500,
       10,
       'HOM_CA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Homologa Cash',
       'Homologa Cash',
       '',
       'HOM_CA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       470,
       10,
       'HOM_CF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Hom.CRM',
       'Homologa CRM',
       '',
       'HOM_CF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       710,
       10,
       'HOM_CG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Md Config Autor.',
       'Mdulo Config - Autoriza',
       '',
       'HOM_CG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       530,
       10,
       'HOM_CO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Md Checkout Autor.',
       'Mdulo Checkout - Autoriza',
       '',
       'HOM_CO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       560,
       10,
       'HOM_CS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Homologa C. Server',
       'Homologa Checkout Server',
       '',
       'HOM_CS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       770,
       10,
       'HOM_EB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Md e-Business Autor',
       'Mdulo e-Business- Autoriza',
       '',
       'HOM_EB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       800,
       10,
       'HOM_EC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Md e-Commerce Autor',
       'Mdulo e-Commerce - Autoriza',
       '',
       'HOM_EC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       410,
       10,
       'HOM_NB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Hom.TotaliBI Browser',
       'Homologa Totali BI Browser',
       '',
       'HOM_NB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       350,
       10,
       'HOM_NC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Hom. TotaliBI Config',
       'Homologa Totali BI Config',
       '',
       'HOM_NC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       380,
       10,
       'HOM_NS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Hom. TotaliBI Server',
       'Homologa Totali BI Server',
       '',
       'HOM_NS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       590,
       10,
       'HOM_OR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Homologa Order',
       'Homologa Order',
       '',
       'HOM_OR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       290,
       10,
       'HOM_RB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Hom. Report Builder',
       'Homologa Report Builder',
       '',
       'HOM_RB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       320,
       10,
       'HOM_SD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Hom. Stoq ',
       'Homologa Stoq ',
       '',
       'HOM_SD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       620,
       10,
       'HOM_SE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Md Service Autor.',
       'Mdulo Service - Autoriza',
       '',
       'HOM_SE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       440,
       10,
       'HOM_SW',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Hom SAC e Workflow',
       'Homologa SAC e Workflow ',
       '',
       'HOM_SW',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       650,
       10,
       'HOM_TM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Md Telemarket Autor',
       'Mdulo Telemarketing - Autoriza',
       '',
       'HOM_TM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       740,
       10,
       'HOM_TO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Md Tools Autor.',
       'Mdulo Tools - Autoriza',
       '',
       'HOM_TO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1060,
       15,
       'IE_FIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Inscrio Estadual ',
       'Inscrio Estadual da Filial',
       '',
       'IE_FIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       890,
       255,
       'IMGFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Imagem Filial',
       'Imagem Filial',
       '',
       'IMGFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '03',
       160,
       8,
       'INIFIL',
       'D',
       '',
       0,
       0,
       'DFIL',
       150,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       'D',
       'T',
       'Data mnima',
       'Data mnima da utilizao',
       '',
       'INIFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1460,
       15,
       'INSMUN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Inscr. Municipal',
       'Inscrio Municipal',
       '',
       'INSMUN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '03',
       180,
       8,
       'INSTAL',
       '@',
       '',
       0,
       0,
       'DFIL',
       170,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       '@',
       'T',
       'Data e hora da insta',
       'Data e Hora da instalao',
       '',
       'INSTAL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2570,
       5,
       'INTSIN',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Intervalo sincronia',
       'Intervalo em minutos para sincronia de dados no Checkout4G',
       '',
       'INTSIN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2790,
       40,
       'IP_MIDDLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'IP Middleware C4KG',
       'IP do Middleware (Checkout 4G)',
       '',
       'IP_MIDDLE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2860,
       20,
       'IP_ORDERLOCAL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'IP do Order Local',
       'IP do Servidor do Order Local',
       '',
       'IP_ORDERLOCAL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2300,
       255,
       'IP_SFC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'End. rede SelfColor',
       'Endereo de rede do sistema SelfColor',
       '',
       'IP_SFC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2630,
       15,
       'IP_TEF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Servidor de TEF',
       'Servidor de TEF',
       '',
       'IP_TEF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1470,
       20,
       'LICFAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Licena da Farmacia',
       'Licena da Farmacia',
       '',
       'LICFAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       1070,
       12,
       'LIMCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Limite de Cofins',
       'Limite de Cofins',
       '',
       'LIMCOF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       1910,
       14,
       'LIMCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Limite de Compra',
       'Limite de Compra',
       '',
       'LIMCOM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '03',
       164,
       2,
       'MES_FIMFIL',
       'A',
       '',
       0,
       0,
       'DFIL',
       160,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       '',
       'N',
       'T',
       'Ms de Data mxima',
       'Ms de Data mxima da utilizao',
       '',
       'TO_CHAR(DFIL.FIMFIL,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '03',
       163,
       2,
       'MES_INIFIL',
       'A',
       '',
       0,
       0,
       'DFIL',
       150,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       '',
       'N',
       'T',
       'Ms de Data mnima',
       'Ms de Data mnima da utilizao',
       '',
       'TO_CHAR(DFIL.INIFIL,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '03',
       185,
       2,
       'MES_INSTAL',
       'A',
       '',
       0,
       0,
       'DFIL',
       170,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       '',
       'N',
       'T',
       'Ms de Data e hora d',
       'Ms de Data e Hora da instalao',
       '',
       'TO_CHAR(DFIL.INSTAL,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       660,
       5,
       'MOD_BO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Mdulo Backoffice',
       'Mdulo Backoffice',
       '',
       'MOD_BO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       480,
       5,
       'MOD_CA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Mdulo Cash',
       'Mdulo Cash',
       '',
       'MOD_CA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       450,
       5,
       'MOD_CF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Md. CRM',
       'Mdulo CRM ',
       '',
       'MOD_CF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       690,
       5,
       'MOD_CG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Md Config Cpia',
       'Mdulo Config - Cpia',
       '',
       'MOD_CG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       510,
       5,
       'MOD_CO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Md Checkout Cpia',
       'Mdulo Checkout - Cpia',
       '',
       'MOD_CO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       540,
       5,
       'MOD_CS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Md. Checkout Server',
       'Mdulo Checkout Server',
       '',
       'MOD_CS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       750,
       5,
       'MOD_EB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Md e-Business Cpia',
       'Mdulo e-Business- Cpia',
       '',
       'MOD_EB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       780,
       5,
       'MOD_EC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Md e-Commerce Cpia',
       'Mdulo e-Commerce - Cpia',
       '',
       'MOD_EC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       390,
       5,
       'MOD_NB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Md. TotaliB Browser',
       'Mdulo Totali BI Browser',
       '',
       'MOD_NB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       330,
       5,
       'MOD_NC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Md. TotaliBI Config',
       'Mdulo Totali BI Config',
       '',
       'MOD_NC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       360,
       5,
       'MOD_NS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Md. TotaliBI Server',
       'Mdulo Totali BI Server',
       '',
       'MOD_NS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       570,
       5,
       'MOD_OR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Mdulo Order',
       'Mdulo Order',
       '',
       'MOD_OR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       270,
       5,
       'MOD_RB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Md. Report Builder',
       'Mdulo Report Builder',
       '',
       'MOD_RB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       300,
       5,
       'MOD_SD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Md. Stoq ',
       'Mdulo Stoq ',
       '',
       'MOD_SD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       600,
       5,
       'MOD_SE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Md Service Cpia',
       'Mdulo Service - Cpia',
       '',
       'MOD_SE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       420,
       5,
       'MOD_SW',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Md. SAC e Workflow',
       'Mdulo Web SAC e Workflow',
       '',
       'MOD_SW',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       630,
       5,
       'MOD_TM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Md Telemarket Cpia',
       'Mdulo Telemarketing - Cpia',
       '',
       'MOD_TM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       720,
       5,
       'MOD_TO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Md Tools Cpia',
       'Mdulo Tools - Cpia',
       '',
       'MOD_TO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2260,
       6,
       'MPRINI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MPRINI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1840,
       5,
       'MUL_TIPENT0',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cliente Leva',
       'Cliente Leva',
       '',
       'MUL_TIPENT0',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1850,
       5,
       'MUL_TIPENT1',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Depsito Entrega',
       'Depsito Entrega',
       '',
       'MUL_TIPENT1',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1860,
       5,
       'MUL_TIPENT2',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Loja Entrega',
       'Loja Entrega',
       '',
       'MUL_TIPENT2',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1870,
       5,
       'MUL_TIPENT3',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Retira no Depsito',
       'Retira no Depsito',
       '',
       'MUL_TIPENT3',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1880,
       5,
       'MUL_TIPENT4',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Em Outra Loja',
       'Em Outra Loja',
       '',
       'MUL_TIPENT4',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1890,
       5,
       'MUL_TIPENT5',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Entrega Futura',
       'Entrega Futura',
       '',
       'MUL_TIPENT5',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1900,
       5,
       'MUL_TIPENT7',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Venda sob Encomenda',
       'Venda sob Encomenda',
       '',
       'MUL_TIPENT7',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2870,
       1,
       'NF_CON',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'NF Conj. NFCe/SAT?',
       'Nota Fiscal de Servio Conjugada na NFCe/SAT?',
       '',
       'NF_CON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2100,
       12,
       'NIVCRI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NIVCRI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1480,
       40,
       'NOMFAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Farmaceutico respons',
       'Nome Farmaceutico responsvel',
       '',
       'NOMFAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       30,
       15,
       'NOMFIL',
       'A',
       '',
       0,
       0,
       'DFIL',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Nome da Filial',
       'Nome da filial',
       '',
       'NOMFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       900,
       5,
       'NUMERO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero',
       'Nmero',
       '',
       'NUMERO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       910,
       12,
       'NUMFON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Telefone',
       'Nmero Telefone',
       '',
       'NUMFON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       920,
       6,
       'NUMMRD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nm. Mapa Resumo Dia',
       'Nmero Mapa Resumo Dirio',
       '',
       'NUMMRD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       40,
       10,
       'NUMSER',
       'A',
       '',
       0,
       0,
       'DFIL',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       '9',
       'T',
       'Nmero de srie',
       'Nmero de srie',
       '',
       'NUMSER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2580,
       254,
       'OBS_DES_ST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Obs. destaque ST',
       'Obs. no destaque de ST (convnio/protocolo)',
       '',
       'OBS_DES_ST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2600,
       254,
       'OBS_PERDAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Obs.perdas desastres',
       'Obs. por perda em desastres naturais',
       '',
       'OBS_PERDAS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2590,
       254,
       'OBS_ST_DEV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Obs. devoluo ST',
       'Obs. para devoluo de compra com ST',
       '',
       'OBS_ST_DEV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1790,
       1,
       'PAFECF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa PAF-ECF?',
       'Usa PAF-ECF?',
       '',
       'PAFECF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       930,
       255,
       'PATCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path do Carto',
       'Path do Carto',
       '',
       'PATCAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1490,
       200,
       'PATCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path Con.',
       'Path Con.',
       '',
       'PATCON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2320,
       255,
       'PATIMGCHR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path Imagens Cheque',
       'Path das Imagens de Cheque para Anlise de Crdito',
       '',
       'PATIMGCHR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1990,
       255,
       'PATNFE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path de NF-e',
       'Path de NF-e',
       '',
       'PATNFE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1660,
       255,
       'PATNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path Numer. Notas ',
       'Path para Numerao das Notas',
       '',
       'PATNOT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       940,
       255,
       'PATPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path do Pedido',
       'Path do Pedido',
       '',
       'PATPED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       950,
       255,
       'PATTKE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path do TKE',
       'Path do TKE',
       '',
       'PATTKE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       960,
       255,
       'PAT_AA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path Requisies',
       'Path Requisies',
       '',
       'PAT_AA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       1220,
       6,
       'PERCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% COFINS p/Servios',
       'Aliquota de COFINS para Servios',
       '',
       'PERCOF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       2700,
       6,
       'PERCOMSUG',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Perc. Comisso Sug.',
       'Percentual de Comisso para Produtos Sugeridos',
       '',
       'PERCOMSUG',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2230,
       1,
       'PERCRE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Com Permisso de Cr',
       'Com Permisso de Crdito?',
       '',
       'PERCRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2440,
       1,
       'PERFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Perfil SPED',
       'Perfil SPED',
       '',
       'PERFIL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       1140,
       6,
       'PEROPE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       '% Desp. Operacionais',
       '% de Despesas Operacionais Variveis',
       '',
       'PEROPE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       2390,
       6,
       'PEROPEFIX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       '% Desp. Oper. Fix',
       '% de Despesas Operacionais Fixas',
       '',
       'PEROPEFIX',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       1230,
       6,
       'PERPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% PIS p/Servios',
       'Aliquota de PIS para Servios',
       '',
       'PERPIS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       1050,
       6,
       'PERSOC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '%Contribuio Social',
       '%Contribuio Social',
       '',
       'PERSOC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       1600,
       6,
       'PER_FIS_RURAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '%INSS Rural Fsica',
       'Inss Rural Pessoa Fsica',
       '',
       'PER_FIS_RURAL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       2250,
       6,
       'PER_FIS_SENAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Perc. SENAR Fsica',
       'Percentual SENAR Pessoa Fsica',
       '',
       'PER_FIS_SENAR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       1610,
       6,
       'PER_JUR_RURAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '%INSS Rural Jurdica',
       'Inss Rural Pessoa Jurdica',
       '',
       'PER_JUR_RURAL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       2260,
       6,
       'PER_JUR_SENAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Perc. SENAR Jurdica',
       'Percentual SENAR Pessoa Juridica',
       '',
       'PER_JUR_SENAR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       2920,
       6,
       'PER_SEGRUR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Perc. Seguro Rural',
       'Percentual Seguro Rural',
       '',
       'PER_SEGRUR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       2960,
       7,
       'PESPREFOR',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Peso Preo Forn.',
       'Peso aplicado sobre o Valor do Fornecedor',
       '',
       'PESPREFOR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       2950,
       7,
       'PESPREVEN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Peso Valor Presente',
       'Peso aplicado sobre o Valor Presente',
       '',
       'PESPREVEN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       2940,
       7,
       'PESPRZENT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Peso Prazo Entrega',
       'Peso aplicado sobre o Prazo de Entrega',
       '',
       'PESPRZENT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1250,
       1,
       'POREMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Porte da Empresa',
       'Porte da Empresa',
       '',
       'POREMP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2820,
       5,
       'PORRET',
       'G',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       '',
       'N',
       '',
       'Portador ret. cheque',
       'Portador do cheque quando for retirado do caixa',
       'DCOB.CODTAB(+) = DFIL.PORRET',
       'PORRET',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2295,
       10,
       'PORTA_DB',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'PORTA_DB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2800,
       10,
       'PORTA_MIDDLE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Porta Middle. CK4G',
       'Porta do Middleware (Checkout 4G)',
       '',
       'PORTA_MIDDLE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2450,
       3,
       'PRAZO_COMPRA_XA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Prazo Compra XA',
       'Prazo de Compra para Combinao X e A',
       '',
       'PRAZO_COMPRA_XA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2460,
       3,
       'PRAZO_COMPRA_XB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Prazo Compra XB',
       'Prazo de Compra para Combinao X e B',
       '',
       'PRAZO_COMPRA_XB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2470,
       3,
       'PRAZO_COMPRA_XC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Prazo Compra XC',
       'Prazo de Compra para Combinao X e C',
       '',
       'PRAZO_COMPRA_XC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2480,
       3,
       'PRAZO_COMPRA_YA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Prazo Compra YA',
       'Prazo de Compra para Combinao Y e A',
       '',
       'PRAZO_COMPRA_YA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2490,
       3,
       'PRAZO_COMPRA_YB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Prazo Compra YB',
       'Prazo de Compra para Combinao Y e B',
       '',
       'PRAZO_COMPRA_YB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2500,
       3,
       'PRAZO_COMPRA_YC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Prazo Compra YC',
       'Prazo de Compra para Combinao Y e C',
       '',
       'PRAZO_COMPRA_YC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2510,
       3,
       'PRAZO_COMPRA_ZA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Prazo Compra ZA',
       'Prazo de Compra para Combinao Z e A',
       '',
       'PRAZO_COMPRA_ZA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2520,
       3,
       'PRAZO_COMPRA_ZB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Prazo Compra ZB',
       'Prazo de Compra para Combinao Z e B',
       '',
       'PRAZO_COMPRA_ZB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2530,
       3,
       'PRAZO_COMPRA_ZC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Prazo Compra ZC',
       'Prazo de Compra para Combinao Z e C',
       '',
       'PRAZO_COMPRA_ZC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1800,
       1,
       'PREVEN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Permite Pr-venda?',
       'Permite Pr-venda?',
       '',
       'PREVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       2370,
       2,
       'QTDABAST',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'lt. X Abastec.',
       'Quantidade de Abastecimentos Pendentes Apresentada na Venda',
       '',
       'QTDABAST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2110,
       6,
       'QTDFUN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'QTDFUN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2120,
       6,
       'QTD_M2',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'QTD_M2',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1690,
       1,
       'RATIPI_FRETE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Rat. IPI Frete',
       'Rateio do IPI sobre Frete',
       '',
       'RATIPI_FRETE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       60,
       45,
       'RAZSOC',
       'A',
       '',
       0,
       0,
       'DFIL',
       60,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Razo Social',
       'Razo Social',
       '',
       'RAZSOC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1150,
       1,
       'RE8020',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Regime Esp. 80/20?',
       'Regime Esp. 80/20?',
       '',
       'RE8020',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1110,
       1,
       'RED_CF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Red.Consumidor Final',
       'Reduz base de clculo para consumidor final.',
       '',
       'RED_CF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1140,
       1,
       'REGESP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Regime Especial?',
       'Regime Especial "80/20".',
       '',
       'REGESP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1120,
       1,
       'REGTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Regime Tributrio',
       'Regime Tributrio',
       '',
       'REGTRI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2770,
       1,
       'REPLICA_SALDO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Replica Saldo CK4G',
       'Replica Saldo de Estoque no Checkout 4G',
       '',
       'REPLICA_SALDO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2990,
       5,
       'RESIRR',
       'G',
       'DIRR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TO_CHAR(DIRR.RESIRR)',
       'V',
       '',
       '',
       'N',
       '',
       '% IR',
       'Percentual de Imposto de Renda',
       'DIRR.CODTAB = DFIL.RESIRR(+)',
       'RESIRR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       90,
       45,
       'RESPON',
       'A',
       '',
       0,
       0,
       'DFIL',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Responsvel',
       'Responsvel',
       '',
       'RESPON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2890,
       4,
       'RETSOC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% de CSLL Reteno',
       'Alquota de CSLL para Reteno em Servios',
       '',
       'RETSOC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2620,
       2,
       'SEGMENTO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Segmento ',
       'Segmento de negcio',
       '',
       'SEGMENTO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1330,
       10,
       'SEQCPM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQCPM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1340,
       10,
       'SEQJUR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQJUR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1350,
       10,
       'SEQLAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQLAN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1640,
       10,
       'SEQOUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Seq. Rec Outros',
       'Seq. Recebimento com Outros',
       '',
       'SEQOUT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2190,
       10,
       'SEQPAG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. Dbito PagFor',
       'Sequncia da Conta de Dbito do Pag-For',
       '',
       'SEQPAG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1360,
       10,
       'SEQTAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Sequncia da Conta de Dbito do Pag-For',
       '',
       'SEQTAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       970,
       10,
       'SEQTES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQTES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       980,
       10,
       'SEQTRN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQTRN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1500,
       10,
       'SEQ_CT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQ_CT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2970,
       2,
       'SERCFE',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       '',
       'Srie NFCe',
       'Srie Padro para Nota Fiscal do Consumidor Eletrnica',
       'DSER.CODSER(+) = DFIL.SERCFE',
       'SERCFE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2740,
       2,
       'SERDEV',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       '',
       'Srie padro dev.',
       'Srie padro para devoluo',
       'DSER.CODSER(+)=DFIL.SERDEV',
       'SERDEV',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2810,
       2,
       'SERIMP',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       '',
       'Srie Importao',
       'Srie para Notas de Importao',
       'DSER.CODSER(+) = DFIL.SERIMP',
       'SERIMP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2840,
       2,
       'SERNFRECI',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       '',
       'Srie p NF Recibo',
       'Srie Padro para NF Sobre Recibo Provisrio',
       'DSER.CODSER(+) = DFIL.SERNFRECI',
       'SERNFRECI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1590,
       2,
       'SERPAD',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       'F',
       'Srie Padro',
       'Srie Padro',
       'DSER.CODSER(+) = DFIL.SERPAD',
       'SERPAD',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2880,
       2,
       'SERRPS',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       'F',
       'Srie para RPS',
       'Srie para Recibo Provisrio de Servio',
       'DSER.CODSER(+) = DFIL.SERRPS',
       'SERRPS',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2980,
       2,
       'SERSAT',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       '',
       'Srie CF-e(SAT/MFe)',
       'Srie Padro para CF-e(SAT/MFe)',
       'DSER.CODSER(+) = DFIL.SERSAT',
       'SERSAT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       3040,
       2,
       'SERTRA',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       '',
       'Srie Decl. Transpo.',
       'Srie Padro para Declarao de Transporte',
       'DSER.CODSER(+) = DFIL.SERTRA',
       'SERTRA',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2330,
       20,
       'SERVID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SERVID',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2900,
       1,
       'SISDFE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Mensageria DFE',
       'Mensageria para Documento Fiscal Eletrnico',
       '',
       'SISDFE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2610,
       1,
       'ST_INTERESTADUAL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Calc. ST interestadu',
       'Calcula ST para Consumidor Final interestadual',
       '',
       'ST_INTERESTADUAL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2310,
       1,
       'SUBSTITUTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Substituta no regime',
       'Substituta no regime de ICMS?',
       '',
       'SUBSTITUTA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       2930,
       7,
       'TAXJURMES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Taxa de Juros ao Ms',
       'Taxa de Juros ao Ms para Valor Presente',
       '',
       'TAXJURMES',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1080,
       1,
       'TCMIPI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'CM c/IPI inc.PIS/COF',
       'Custo Mdio com IPI incluso na base de PIS/Cofins.',
       '',
       'TCMIPI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2670,
       254,
       'TEF_ADCIONAIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Comandos Adcionais',
       'Comandos adcionais a serem enviados nas operaes de TEF',
       '',
       'TEF_ADCIONAIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2660,
       254,
       'TEF_APRAZO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Comandos TEF a Prazo',
       'Comandos a serem enviados nas operaes de TEF a Prazo',
       '',
       'TEF_APRAZO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2650,
       254,
       'TEF_AVISTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Comandos TEF a Vista',
       'Comandos a serem enviados nas operaes de TEF a Vista',
       '',
       'TEF_AVISTA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2680,
       254,
       'TEF_PARAMETROS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Parametros de TEF',
       'Parametros serem enviados nas conexes de TEF',
       '',
       'TEF_PARAMETROS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1560,
       3,
       'TESFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TESFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1570,
       10,
       'TESSEQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TESSEQ',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1580,
       1,
       'TESTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TESTIP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1090,
       1,
       'TIPBOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Bomba',
       'Tipo Bomba',
       '',
       'TIPBOM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2830,
       1,
       'TIPCOBRET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tp portad ret cheque',
       'Tipo do portador do cheque quando for retirado do caixa',
       '',
       'TIPCOBRET',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2710,
       1,
       'TIPCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo de Comrcio',
       'Tipo de Comrcio',
       '',
       'TIPCOM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1370,
       1,
       'TIPCPM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. Tipo de Conta',
       'Ref. Tipo de Conta',
       '',
       'TIPCPM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1550,
       5,
       'TIPEND',
       'S',
       'DEND',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEND.DESEND',
       'V',
       '',
       '',
       'N',
       'F',
       'Tipo de Endereo',
       'Tipo de Endereo',
       'DEND.CODTAB = DFIL.TIPEND(+)',
       'TIPEND',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1380,
       1,
       'TIPJUR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo de Juros',
       'Tipo de Juros',
       '',
       'TIPJUR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1390,
       1,
       'TIPLAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo de Lanamento',
       'Tipo de Lanamento',
       '',
       'TIPLAN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1750,
       1,
       'TIPLUC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Lucro',
       'Lucro',
       '',
       'TIPLUC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1650,
       1,
       'TIPOUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Con. Outros',
       'Tipo de Conta para Recebimento Outros',
       '',
       'TIPOUT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2200,
       1,
       'TIPPAG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tip Con DbitoPagFor',
       'Tipo da Conta de Dbito do Pag-For',
       '',
       'TIPPAG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1400,
       1,
       'TIPTAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo de Tarefa',
       'Tipo de Tarefa',
       '',
       'TIPTAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       990,
       1,
       'TIPTES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. 1 Tipo Conta',
       'Ref. 1 Tipo Conta',
       '',
       'TIPTES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1000,
       1,
       'TIPTRN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. 2 Tipo Conta',
       'Ref. 2 Tipo Conta',
       '',
       'TIPTRN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1510,
       1,
       'TIP_CT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo CT',
       'Tipo CT',
       '',
       'TIP_CT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2270,
       1,
       'TRAORI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Transf. data origem',
       'Transferencia pela data de origem',
       '',
       'TRAORI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       1700,
       1,
       'TRISIM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Trib. Simpl.',
       'Tipo de Tributao para Simples',
       '',
       'TRISIM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       2850,
       12,
       'TROCOTEF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Troco Mximo TEF',
       'Troco Mximo para Operaes com Carto',
       '',
       'TROCOTEF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       181,
       2,
       'UFLOJA',
       'A',
       '',
       0,
       0,
       'DFIL',
       180,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'U.F.',
       'Unidade federativa da loja',
       '',
       'UFLOJA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2410,
       7,
       'ULTNUMVEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       '#ltimo Nm. Vendas',
       'Data da ltima Contagem do Nmero de Vendas (descontinuado)',
       '',
       'ULTNUMVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2400,
       1,
       'USAPARICM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Usa Partilha ICMS?',
       'Usa Partilha de ICMS?',
       '',
       'USAPARICM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2130,
       12,
       'VALOR1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VALOR1',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2140,
       12,
       'VALOR2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VALOR2',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2150,
       12,
       'VALOR3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VALOR3',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       2160,
       12,
       'VALOR4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VALOR4',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       1200,
       6,
       'VENCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% COFINS para Venda',
       'Aliquota de COFINS para venda',
       '',
       'VENCOF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '02',
       1210,
       6,
       'VENPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% PIS para Venda',
       'Alquota de PIS para venda',
       '',
       'VENPIS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       810,
       3,
       'VERSAO',
       'F',
       '',
       1,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Verso',
       'Verso',
       '',
       'VERSAO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       3050,
       4,
       'TEF_CODLOJAUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'TEF_CODLOJAUT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       3060,
       5,
       'TEF_CODESTAUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'TEF_CODESTAUT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DFIL',
       '--',
       3070,
       3,
       'TEF_GPPADRAO',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TEF_GPPADRAO',
       'F',
       'D' FROM DUAL
);

/*-- SEQ 7308 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DFIL',
       'BAIFIL',
       0,
       '0',
       'No criticar baixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'BAIFIL',
       0,
       '1',
       'Alerta quando baixar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'BAIFIL',
       0,
       '2',
       'No permitir baixar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'BAIOUT',
       0,
       '0',
       'No criticar baixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'BAIOUT',
       0,
       '1',
       'Alerta quando baixar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'BAIOUT',
       0,
       '2',
       'No permitir baixar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'BAISPC',
       0,
       'E',
       'Empresa (Mesmo CNPJ)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'BAISPC',
       0,
       'G',
       'Geral',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'BAISPC',
       0,
       'I',
       'Individual (Filial)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'PERFIL',
       0,
       'A',
       'Perfil A',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'PERFIL',
       0,
       'B',
       'Perfil B',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'POREMP',
       0,
       'M',
       'Micro-Empresa (ME)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'POREMP',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'POREMP',
       0,
       'P',
       'Pequeno Porte (EPP)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'RATIPI_FRETE',
       0,
       'P',
       'Preo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'RATIPI_FRETE',
       0,
       'V',
       'Valor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'REGTRI',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'REGTRI',
       0,
       'S',
       'Simples',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'SISDFE',
       0,
       ' ',
       'Totali Middleware',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'TIPBOM',
       0,
       '0',
       'No Usa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'TIPBOM',
       0,
       '1',
       'TKE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'TIPBOM',
       0,
       '2',
       'Logitron',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'TIPBOM',
       0,
       '3',
       'Company',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'TIPBOM',
       0,
       '9',
       'Manual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'TIPCOBRET',
       0,
       'B',
       'Bancos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'TIPCOBRET',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'TIPCOBRET',
       0,
       'P',
       'Portadores',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'TIPCOM',
       0,
       'A',
       'Atacado/Equiparado a Indstria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'TIPCOM',
       0,
       'V',
       'Varejo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'TIPLUC',
       0,
       'P',
       'Presumido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'TIPLUC',
       0,
       'R',
       'Real',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'TRISIM',
       0,
       'N',
       'No tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'TRISIM',
       0,
       'O',
       'Tributao original',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFIL',
       'TRISIM',
       0,
       'S',
       'No trib. exceto substitudos',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7309 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DFIN',
       0,
       'DFIN',
       'Dom. Financeiro',
       'TD_FIN',
       'F',
       '',
       'TOTALL',
       'Financeiras',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DFIN.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7310 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DFIN','--','' FROM DUAL
);

/*-- SEQ 7311 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DFIN',
       '--',
       40,
       5,
       'CARTAO',
       'G',
       'DCAR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCAR.DESOUT',
       'V',
       '',
       '',
       'N',
       '',
       'Carto',
       'Carto',
       'DCAR.CODTAB(+) = DFIN.CARTAO',
       'CARTAO',
       'T' FROM DUAL
UNION ALL
SELECT 'DFIN',
       '--',
       10,
       5,
       'CODTAB',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DFIN',
       '--',
       30,
       15,
       'DESFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Descrio Financeiro',
       'Descrio Financeiro',
       '',
       'DESFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'DFIN',
       '--',
       20,
       1,
       'FINATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo?',
       '',
       'FINATI',
       'F' FROM DUAL
);

/*-- SEQ 7312 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DFIS',
       0,
       'DFIS',
       'Dom. Cdigo Fiscal',
       'TD_FIS',
       'F',
       '',
       'TOTALL',
       'Cdigo Fiscal',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DFIS.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7313 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DFIS','--','' FROM DUAL
);

/*-- SEQ 7314 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DFIS',
       '--',
       200,
       20,
       'CODFIS',
       'A',
       '',
       0,
       0,
       'DFIS',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Cdigo Fiscal',
       'Cdigo Fiscal',
       '',
       'CODFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'DFIS',
       '--',
       210,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DFIS',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DFIS',
       '--',
       190,
       1,
       'FISATI',
       'L',
       '',
       0,
       0,
       'DFIS',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'FISATI',
       'F' FROM DUAL
);

/*-- SEQ 7315 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DFPS',
       TO_NUMBER(null),
       'DFPS',
       'Finalidade Prod/Serv',
       'TD_FPS',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DFPS.CODFPS
 Finalidade do Produto/Servio',
       '' FROM DUAL
);

/*-- SEQ 7316 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DFPS','--','' FROM DUAL
UNION ALL
SELECT 'DFPS','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DFPS','99','Outros' FROM DUAL
);

/*-- SEQ 7317 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DFPS',
       '--',
       10,
       2,
       'CODFPS',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo Finalidade',
       'Cdigo da Finalidad',
       '',
       'CODFPS',
       '' FROM DUAL
UNION ALL
SELECT 'DFPS',
       '--',
       20,
       40,
       'DESFPS',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio Finalidade',
       'Descrio da Finalidade',
       '',
       'DESFPS',
       '' FROM DUAL
);

/*-- SEQ 7318 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DFRE',
       TO_NUMBER(null),
       'DFRE',
       'Dom. Poltica Frete',
       'TD_FRE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DFRE.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7319 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DFRE','--','' FROM DUAL
UNION ALL
SELECT 'DFRE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DFRE','99','Outros' FROM DUAL
);

/*-- SEQ 7320 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DFRE',
       '01',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Cdigo',
       'Cdigo',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'DFRE',
       '01',
       20,
       100,
       'DESFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio',
       'Descrio',
       '',
       'DESFRE',
       '' FROM DUAL
UNION ALL
SELECT 'DFRE',
       '--',
       80,
       12,
       'DFRE_FREMIN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor mnimo frete',
       'Valor mnimo de frete',
       '',
       'DFRE_FREMIN',
       '' FROM DUAL
UNION ALL
SELECT 'DFRE',
       '--',
       90,
       12,
       'DFRE_MINDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor mn. desconto',
       'Valor mnimo para desconto',
       '',
       'DFRE_MINDES',
       '' FROM DUAL
UNION ALL
SELECT 'DFRE',
       '--',
       10,
       5,
       'DFRE_PERDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Desconto no frete',
       '% Desconto no frete',
       '',
       'DFRE_PERDES',
       '' FROM DUAL
UNION ALL
SELECT 'DFRE',
       '--',
       50,
       5,
       'DFRE_PERVEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Sobre o valor',
       '% Sobre o valor',
       '',
       'DFRE_PERVEN',
       '' FROM DUAL
UNION ALL
SELECT 'DFRE',
       '01',
       40,
       1,
       'DFRE_TIPCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo Cobrana',
       'Tipo de Cobrana',
       '',
       'DFRE_TIPCOB',
       'T' FROM DUAL
UNION ALL
SELECT 'DFRE',
       '--',
       60,
       12,
       'DFRE_VALENT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor por entrega',
       'Valor por entrega',
       '',
       'DFRE_VALENT',
       '' FROM DUAL
UNION ALL
SELECT 'DFRE',
       '--',
       70,
       12,
       'DFRE_VALQTD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor por quantidade',
       'Valor por quantidade',
       '',
       'DFRE_VALQTD',
       '' FROM DUAL
UNION ALL
SELECT 'DFRE',
       '01',
       30,
       1,
       'FREATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Ativo?',
       '',
       'FREATI',
       '' FROM DUAL
);

/*-- SEQ 7321 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DFRE',
       'DFRE_TIPCOB',
       0,
       'E',
       'Valor por entrega',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFRE',
       'DFRE_TIPCOB',
       0,
       'P',
       'Valor por peso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFRE',
       'DFRE_TIPCOB',
       0,
       'Q',
       'Valor por quantidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFRE',
       'DFRE_TIPCOB',
       0,
       'R',
       'Valor por Regio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFRE',
       'DFRE_TIPCOB',
       0,
       'V',
       'Percentual sobre venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7322 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DFUN',
       TO_NUMBER(null),
       'DFUN',
       'Dom. Funcionalidades',
       'TD_FUN',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DFUN.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7323 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DFUN','--','' FROM DUAL
UNION ALL
SELECT 'DFUN','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DFUN','99','Outros' FROM DUAL
);

/*-- SEQ 7324 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DFUN',
       '01',
       40,
       3,
       'CODFUN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cd. Funcionalidade',
       'Cd. Funcionalidade',
       '',
       'CODFUN',
       'F' FROM DUAL
UNION ALL
SELECT 'DFUN',
       '01',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DFUN',
       '01',
       20,
       100,
       'DESFUN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao',
       'Descricao',
       '',
       'DESFUN',
       'F' FROM DUAL
UNION ALL
SELECT 'DFUN',
       '01',
       30,
       1,
       'FUNATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'FUNATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DFUN',
       '01',
       50,
       3,
       'FUNPAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cd. Funcionali. Pai',
       'Cd. Funcionalidade Pai',
       '',
       'FUNPAI',
       'F' FROM DUAL
UNION ALL
SELECT 'DFUN',
       '--',
       60,
       1,
       'TIPFUN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Funcionalidade',
       'Tipo de Funcionalidade',
       '',
       'TIPFUN',
       'F' FROM DUAL
);

/*-- SEQ 7325 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DFUN',
       'TIPFUN',
       0,
       'A',
       'Ambos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFUN',
       'TIPFUN',
       0,
       'S',
       'SAC',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DFUN',
       'TIPFUN',
       0,
       'W',
       'WorkFlow',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7326 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DGRA',
       0,
       'DGRA',
       'Dom. Grades',
       'TD_GRA',
       'F',
       '',
       'TOTALL',
       'Grades',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DGRA.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7327 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DGRA','--','' FROM DUAL
);

/*-- SEQ 7328 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DGRA',
       '--',
       30,
       2,
       'CODDIV',
       'S',
       '',
       0,
       0,
       'DGRA',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       '',
       'T',
       'Diviso',
       'Diviso',
       '',
       'CODDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'DGRA',
       '--',
       40,
       2,
       'CODSUB',
       'S',
       '',
       0,
       0,
       'DGRA',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       '',
       'T',
       'Sub Diviso',
       'Sub Diviso',
       '',
       'CODSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'DGRA',
       '--',
       50,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DGRA',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DGRA',
       '--',
       10,
       1,
       'GRAATI',
       'L',
       '',
       0,
       0,
       'DGRA',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Grade Ativa?',
       'Grade Ativa?',
       '',
       'GRAATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DGRA',
       '--',
       20,
       20,
       'NOMGRA',
       'A',
       '',
       0,
       0,
       'DGRA',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Descrio',
       'Descrio',
       '',
       'NOMGRA',
       'F' FROM DUAL
);

/*-- SEQ 7329 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DGRU',
       0,
       'DGRU',
       'Dom.Grupo de Filiais',
       'TD_GRU',
       'F',
       '',
       'TOTALL',
       'Grupo de Filiais',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DGRU.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7330 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DGRU','--','' FROM DUAL
);

/*-- SEQ 7331 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DGRU',
       '--',
       1,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DGRU',
       '--',
       3,
       30,
       'DESGRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Grupo',
       'Grupo',
       '',
       'DESGRU',
       'F' FROM DUAL
UNION ALL
SELECT 'DGRU',
       '--',
       2,
       1,
       'GRUATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Grupo Ativo?',
       'Grupo Ativo?',
       '',
       'GRUATI',
       'F' FROM DUAL
);

/*-- SEQ 7332 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DHOM',
       TO_NUMBER(null),
       'DHOM',
       'Dom. Homologao',
       'TD_HOM',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DHOM.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7333 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DHOM','--','' FROM DUAL
UNION ALL
SELECT 'DHOM','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DHOM','99','Outros' FROM DUAL
);

/*-- SEQ 7334 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DHOM',
       '--',
       10,
       1,
       'ATIHOM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Homologao Ativa?',
       'Homologao Ativa?',
       '',
       'ATIHOM',
       'F' FROM DUAL
UNION ALL
SELECT 'DHOM',
       '--',
       20,
       2,
       'CODHOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Homologao',
       'Cdigo Homologao',
       '',
       'CODHOM',
       'F' FROM DUAL
UNION ALL
SELECT 'DHOM',
       '--',
       30,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DHOM',
       '--',
       40,
       20,
       'DESHOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Hom.',
       'Descrio Homologao',
       '',
       'DESHOM',
       'F' FROM DUAL
);

/*-- SEQ 7335 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DICM',
       0,
       'DICM',
       'Dom. ICMS',
       'TD_ICM',
       'F',
       '',
       'TOTALL',
       'Aliquotas ICMS',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DICM.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7336 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DICM','--','' FROM DUAL
);

/*-- SEQ 7337 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DICM',
       '--',
       40,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Assinatura para PAF-ECF',
       '',
       'ASSINA',
       'F' FROM DUAL
UNION ALL
SELECT 'DICM',
       '--',
       30,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DICM',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DICM',
       '--',
       50,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Identificao de Acesso',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'DICM',
       '--',
       10,
       1,
       'ICMATI',
       'L',
       '',
       0,
       0,
       'DICM',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'ICMATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DICM',
       '--',
       70,
       5,
       'PERESPESTCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'ICMS Esp. Est Compra',
       '% ICMS Especfico Interestadual na Compra',
       '',
       'PERESPESTCOM',
       '' FROM DUAL
UNION ALL
SELECT 'DICM',
       '--',
       90,
       5,
       'PERESPESTVEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'ICMS Esp. Est. Venda',
       '% ICMS Especfico Interestadual na Venda',
       '',
       'PERESPESTVEN',
       '' FROM DUAL
UNION ALL
SELECT 'DICM',
       '--',
       60,
       5,
       'PERESPINTCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       '',
       'ICMS Esp. Int Compra',
       '% ICMS Especfico Interno na Compra',
       '',
       'PERESPINTCOM',
       '' FROM DUAL
UNION ALL
SELECT 'DICM',
       '--',
       80,
       5,
       'PERESPINTVEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'ICMS Esp. Int. Venda',
       '% ICMS Especfico Interno na Venda',
       '',
       'PERESPINTVEN',
       '' FROM DUAL
UNION ALL
SELECT 'DICM',
       '--',
       20,
       8,
       'RESICM',
       'F',
       '',
       2,
       0,
       'DICM',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Alquota',
       'Impostos',
       '',
       'RESICM',
       'F' FROM DUAL
);

/*-- SEQ 7338 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DIES',
       0,
       'DIES',
       'Dom. ICMS Cli. Esp.',
       'TD_IES',
       'F',
       '',
       'TOTALL',
       'Tabela de ICMS para Clientes Especiais',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DIES.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7339 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DIES','--','' FROM DUAL
);

/*-- SEQ 7340 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DIES',
       '--',
       110,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DIES',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DIES',
       '--',
       120,
       1,
       'ES_ATI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'DIES',
       30,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'T',
       'Ativo',
       'Ativo',
       '',
       'ES_ATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DIES',
       '--',
       100,
       8,
       'ICMSES',
       'F',
       '',
       2,
       0,
       'DIES',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Alquota',
       'Tabela de ICMS para Clientes Especiais',
       '',
       'ICMSES',
       'F' FROM DUAL
);

/*-- SEQ 7341 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DIME',
       0,
       'DIME',
       'Dom. ICMS Micro Emp.',
       'TD_IME',
       'F',
       '',
       'TOTALL',
       'Tabela de ICMS para Micro Empresas',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DIME.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7342 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DIME','--','' FROM DUAL
);

/*-- SEQ 7343 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DIME',
       '--',
       130,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DIME',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DIME',
       '--',
       120,
       8,
       'ICMSME',
       'F',
       '',
       2,
       0,
       'DIME',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Alquota',
       'Tabela de ICMS para Micro Empresas',
       '',
       'ICMSME',
       'F' FROM DUAL
UNION ALL
SELECT 'DIME',
       '--',
       110,
       1,
       'ME_ATI',
       'L',
       '',
       0,
       0,
       'DIME',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'ME_ATI',
       'F' FROM DUAL
);

/*-- SEQ 7344 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DIMG',
       TO_NUMBER(null),
       'DIMG',
       'Dom. Grupo Imagens',
       'TD_IMG',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DIMG.CODIMG',
       '' FROM DUAL
);

/*-- SEQ 7345 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DIMG','--','' FROM DUAL
UNION ALL
SELECT 'DIMG','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DIMG','99','Outros' FROM DUAL
);

/*-- SEQ 7346 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DIMG',
       '--',
       10,
       5,
       'CODTAB',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo',
       'Cdigo',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'DIMG',
       '--',
       20,
       15,
       'DESIMG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Descrio',
       'Descrio',
       '',
       'DESIMG',
       '' FROM DUAL
UNION ALL
SELECT 'DIMG',
       '--',
       50,
       1,
       'IMGATI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Ativo?',
       '',
       'IMGATI',
       '' FROM DUAL
UNION ALL
SELECT 'DIMG',
       '--',
       30,
       1,
       'LETIMG ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Letra',
       'Letra',
       '',
       'LETIMG ',
       '' FROM DUAL
UNION ALL
SELECT 'DIMG',
       '--',
       40,
       255,
       'NOMIMG ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome',
       'Nome',
       '',
       'NOMIMG ',
       '' FROM DUAL
);

/*-- SEQ 7347 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DINA',
       TO_NUMBER(null),
       'DINA',
       'Dom. Motivos Inativ.',
       'TD_INA',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7348 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DINA','--','' FROM DUAL
UNION ALL
SELECT 'DINA','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DINA','99','Outros' FROM DUAL
);

/*-- SEQ 7349 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DINA',
       '01',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DINA',
       '01',
       20,
       20,
       'DESINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Desc. Inatividade',
       'Descrio Inatividade',
       '',
       'DESINA',
       'F' FROM DUAL
UNION ALL
SELECT 'DINA',
       '01',
       30,
       1,
       'INAATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Inatividade Ativa?',
       'Inatividade Ativa?',
       '',
       'INAATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DINA',
       '01',
       40,
       1,
       'USOINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Uso Inatividade',
       'Uso Inatividade',
       '',
       'USOINA',
       'F' FROM DUAL
);

/*-- SEQ 7350 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DINA',
       'USOINA',
       0,
       'C',
       'Cliente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DINA',
       'USOINA',
       0,
       'P',
       'Produto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DINA',
       'USOINA',
       0,
       'Q',
       'Qualquer',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7351 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DIND',
       0,
       'DIND',
       'Dom. Indexador',
       'TD_IND',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DIND.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7352 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DIND','--','' FROM DUAL
);

/*-- SEQ 7353 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DIND',
       '--',
       110,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data de Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'DIND',
       '--',
       100,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
);

/*-- SEQ 7354 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DINS',
       TO_NUMBER(null),
       'DINS',
       'Dom. Instrues',
       'TD_INS',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DINS.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7355 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DINS','--','' FROM DUAL
UNION ALL
SELECT 'DINS','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DINS','99','Outros' FROM DUAL
);

/*-- SEQ 7356 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DINS',
       '01',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DINS',
       '01',
       20,
       30,
       'DESINS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Instruo',
       'Descrio Instruo',
       '',
       'DESINS',
       'F' FROM DUAL
UNION ALL
SELECT 'DINS',
       '01',
       30,
       1,
       'INSATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'INSATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DINS',
       '01',
       40,
       2,
       'QTDDIA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias',
       'Quantidade Dias',
       '',
       'QTDDIA',
       'F' FROM DUAL
);

/*-- SEQ 7357 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DIPI',
       0,
       'DIPI',
       'Dom. IPI',
       'TD_IPI',
       'F',
       '',
       'TOTALL',
       'Aliquotas do IPI',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DIPI.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7358 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DIPI','--','' FROM DUAL
);

/*-- SEQ 7359 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DIPI',
       '--',
       50,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DIPI',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DIPI',
       '--',
       30,
       1,
       'IPIATI',
       'L',
       '',
       0,
       0,
       'DIPI',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'IPIATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DIPI',
       '--',
       40,
       8,
       'RESIPI',
       'F',
       '',
       2,
       0,
       'DIPI',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Alquota',
       'Alquota do IPI',
       '',
       'RESIPI',
       'F' FROM DUAL
);

/*-- SEQ 7360 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DIR1',
       0,
       'DIR1',
       'Dom. ICMS 7%',
       'TD_IR1',
       'F',
       '',
       'TOTALL',
       'Tabela de ICMS para estados com 7%',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DIR1.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7361 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DIR1','--','' FROM DUAL
);

/*-- SEQ 7362 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DIR1',
       '--',
       170,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DIR1',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DIR1',
       '--',
       160,
       8,
       'ICMSR1',
       'F',
       '',
       2,
       0,
       'DIR1',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Alquota',
       'Tabela de ICMS para Estados com 12 %',
       '',
       'ICMSR1',
       'F' FROM DUAL
UNION ALL
SELECT 'DIR1',
       '--',
       150,
       1,
       'R1_ATI',
       'L',
       '',
       0,
       0,
       'DIR1',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'R1_ATI',
       'F' FROM DUAL
);


/*-- SEQ 7363 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DIR2',
       0,
       'DIR2',
       'Dom. ICMS 12%',
       'TD_IR2',
       'F',
       '',
       'TOTALL',
       'Tabela de ICMS para estados com 12%',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DIR2.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7364 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DIR2','--','' FROM DUAL
);

/*-- SEQ 7365 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DIR2',
       '--',
       190,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DIR2',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DIR2',
       '--',
       180,
       8,
       'ICMSR2',
       'F',
       '',
       2,
       0,
       'DIR2',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Alquota',
       'Tabela de ICMS para Estados com 7 %',
       '',
       'ICMSR2',
       'F' FROM DUAL
UNION ALL
SELECT 'DIR2',
       '--',
       170,
       1,
       'R2_ATI',
       'L',
       '',
       0,
       0,
       'DIR2',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'R2_ATI',
       'F' FROM DUAL
);


/*-- SEQ 7366 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DIRE',
       0,
       'DIRE',
       'Dom. ICMS Base Red.',
       'TD_IRE',
       'F',
       '',
       'TOTALL',
       'Tabela de ICMS para Base Reduzida',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DIRE.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7367 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DIRE','--','' FROM DUAL
);

/*-- SEQ 7368 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DIRE',
       '--',
       160,
       1,
       'APLCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Apl. cons. final',
       'Aplica a consumidor final',
       '',
       'APLCON',
       'T' FROM DUAL
UNION ALL
SELECT 'DIRE',
       '--',
       150,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DIRE',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DIRE',
       '--',
       140,
       8,
       'ICMSRE',
       'F',
       '',
       2,
       0,
       'DIRE',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Alquota',
       'Tabela de ICMS para Base Reduzida',
       '',
       'ICMSRE',
       'F' FROM DUAL
UNION ALL
SELECT 'DIRE',
       '--',
       180,
       6,
       'REDCON',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'ICMS Consum. Final',
       'Reduo ICMS para consumidor final',
       '',
       'REDCON',
       'F' FROM DUAL
UNION ALL
SELECT 'DIRE',
       '--',
       170,
       6,
       'REDTRA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Reduo de Entrada ',
       'Reduo de Entrada Transferncia',
       '',
       'REDTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'DIRE',
       '--',
       130,
       1,
       'RE_ATI',
       'L',
       '',
       0,
       0,
       'DIRE',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'RE_ATI',
       'F' FROM DUAL
);

/*-- SEQ 7369 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DIRE',
       'APLCON',
       0,
       'D',
       'Somente Dentro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DIRE',
       'APLCON',
       0,
       'F',
       'No Se Aplica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DIRE',
       'APLCON',
       0,
       'O',
       'Somente Fora',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DIRE',
       'APLCON',
       0,
       'T',
       'Todos',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7370 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DIRR',
       0,
       'DIRR',
       'Dom. IRRF',
       'TD_IRR',
       'F',
       '',
       'TOTALL',
       'Aliquotas do IRRF',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DIRR.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7371 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DIRR','--','' FROM DUAL
);

/*-- SEQ 7372 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DIRR',
       '--',
       90,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DIRR',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DIRR',
       '--',
       70,
       1,
       'IRRATI',
       'L',
       '',
       0,
       0,
       'DIRR',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'IRRATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DIRR',
       '--',
       80,
       8,
       'RESIRR',
       'F',
       '',
       2,
       0,
       'DIRR',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Alquota',
       'Alquota do IRRF',
       '',
       'RESIRR',
       'F' FROM DUAL
);

/*-- SEQ 7373 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DISO',
       0,
       'DISO',
       'Dom. ISO do Filme',
       'TD_ISO',
       'F',
       '',
       'TOTALL',
       'ISO do filme',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DISO.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7374 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DISO','--','' FROM DUAL
);

/*-- SEQ 7375 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DISO',
       '--',
       70,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DISO',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DISO',
       '--',
       50,
       1,
       'ISOATI',
       'L',
       '',
       0,
       0,
       'DISO',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'ISOATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DISO',
       '--',
       60,
       15,
       'PHOISO',
       'A',
       '',
       0,
       0,
       'DISO',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'ISO do Filme',
       'ISO do filme',
       '',
       'PHOISO',
       'F' FROM DUAL
);

/*-- SEQ 7376 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DISS',
       0,
       'DISS',
       'Dom. ISS',
       'TD_ISS',
       'F',
       '',
       'TOTALL',
       'Aliquotas do ISS',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DISS.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7377 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DISS','--','' FROM DUAL
);

/*-- SEQ 7378 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DISS',
       '--',
       90,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'Assinatura para PAF-ECF',
       '',
       'ASSINA',
       '' FROM DUAL
UNION ALL
SELECT 'DISS',
       '--',
       70,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DISS',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DISS',
       '--',
       80,
       0,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       '',
       'Cdigo da Tabela de Acesso',
       '',
       'CODUID',
       '' FROM DUAL
UNION ALL
SELECT 'DISS',
       '--',
       50,
       1,
       'ISSATI',
       'L',
       '',
       0,
       0,
       'DISS',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'ISSATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DISS',
       '--',
       60,
       8,
       'RESISS',
       'F',
       '',
       2,
       0,
       'DISS',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Alquota',
       'Alquota do ISS',
       '',
       'RESISS',
       'F' FROM DUAL
);

/*-- SEQ 7379 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DIV ',
       0,
       'DIV ',
       'Divises',
       'TT_DIV',
       'T',
       '',
       'TOTALL',
       'Divises',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DIV.CODITE',
       '' FROM DUAL
);

/*-- SEQ 7380 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DIV ','--','Dados' FROM DUAL
);

/*-- SEQ 7381 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DIV ',
       '--',
       10,
       2,
       'CODDIV',
       'S',
       'DDIV',
       0,
       0,
       'DIV ',
       20,
       TO_NUMBER(null),
       '',
       'DDIV.NOMDIV',
       'V',
       'DIV',
       'F',
       'A',
       'T',
       'Diviso',
       'Cdigo da Diviso',
       'DIV.CODDIV = DDIV.CODTAB (+)',
       'CODDIV',
       'T' FROM DUAL
UNION ALL
SELECT 'DIV ',
       '--',
       5,
       2,
       'CODITE',
       'S',
       '',
       0,
       0,
       'DIV ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'DIV',
       'F',
       '',
       'T',
       'Cdigo',
       'Cdigo deste item da divisao',
       '',
       'CODITE',
       'F' FROM DUAL
UNION ALL
SELECT 'DIV ',
       '--',
       70,
       255,
       'IMAGEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Imagem',
       'Nome Imagem',
       '',
       'IMAGEM',
       'F' FROM DUAL
UNION ALL
SELECT 'DIV ',
       '--',
       50,
       20,
       'NOMEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Externo',
       'Nome Externo',
       '',
       'NOMEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'DIV ',
       '--',
       30,
       10,
       'NOMITE',
       'A',
       '',
       0,
       0,
       'DIV ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'DIV',
       'F',
       'A',
       'T',
       'Descrio',
       'Nome do item',
       '',
       'NOMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'DIV ',
       '--',
       60,
       6,
       'NUMRGB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero RGB',
       'Nmero RGB',
       '',
       'NUMRGB',
       'F' FROM DUAL
UNION ALL
SELECT 'DIV ',
       '--',
       20,
       2,
       'ORDDIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DIV ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Ordem',
       'Ordem',
       '',
       'ORDDIV',
       'F' FROM DUAL
);

/*-- SEQ 7382 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DJUS',
       TO_NUMBER(null),
       'DJUS',
       'Dom. Justificativas',
       'TD_JUS',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DJUS.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7383 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DJUS','--','' FROM DUAL
);

/*-- SEQ 7384 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DJUS',
       '--',
       33,
       1,
       'AVIJUS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Emite Aviso?',
       'Emite Aviso?',
       '',
       'AVIJUS',
       'F' FROM DUAL
UNION ALL
SELECT 'DJUS',
       '--',
       1,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DJUS',
       '--',
       13,
       25,
       'COMJUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Comentrio',
       'Comentrio',
       '',
       'COMJUS',
       'F' FROM DUAL
UNION ALL
SELECT 'DJUS',
       '--',
       3,
       30,
       'DESJUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'DESJUS',
       'F' FROM DUAL
UNION ALL
SELECT 'DJUS',
       '--',
       2,
       1,
       'JUSATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Justificativa Ativa?',
       'Justificativa Ativa?',
       '',
       'JUSATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DJUS',
       '--',
       23,
       1,
       'TIPJUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo',
       '',
       'TIPJUS',
       'T' FROM DUAL
);

/*-- SEQ 7385 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DJUS',
       'TIPJUS',
       0,
       'A',
       'Aceita',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DJUS',
       'TIPJUS',
       0,
       'E',
       'Existe',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DJUS',
       'TIPJUS',
       0,
       'N',
       'Nao aceita',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7386 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DLAN',
       TO_NUMBER(null),
       'DLAN',
       'Dom. Tipo Lanamento',
       'TD_LAN',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DLAN.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7387 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DLAN','--','' FROM DUAL
UNION ALL
SELECT 'DLAN','1 ','Identificao' FROM DUAL
);

/*-- SEQ 7388 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DLAN',
       '1 ',
       20,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DLAN',
       '1 ',
       40,
       30,
       'DESLAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'DESLAN',
       'F' FROM DUAL
UNION ALL
SELECT 'DLAN',
       '--',
       80,
       3,
       'FILLAN',
       'A',
       'FIL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'FIL2.CODFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial lanamento',
       'Filial que permite lanamento',
       'FIL2.CODFIL = DLAN.FILLAN',
       'FILLAN',
       'F' FROM DUAL
UNION ALL
SELECT 'DLAN',
       '1 ',
       10,
       1,
       'LANATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       40,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Ativo?',
       'Ativo',
       '',
       'LANATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DLAN',
       '1 ',
       50,
       1,
       'LANEDI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Valor Editvel?',
       'Valor Editvel',
       '',
       'LANEDI',
       'F' FROM DUAL
UNION ALL
SELECT 'DLAN',
       '1 ',
       60,
       5,
       'LANNAT',
       'S',
       'DNAT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DNAT.NATURE',
       'V',
       '',
       '',
       'N',
       'F',
       'Natureza Nota Fiscal',
       'Natureza Nota Fiscal',
       'DNAT.CODTAB = DLAN.CODTAB',
       'LANNAT',
       'F' FROM DUAL
UNION ALL
SELECT 'DLAN',
       '1 ',
       70,
       1,
       'LANVLR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Valor Lanamento',
       'Valor Padro de Lanamento',
       '',
       'LANVLR',
       'T' FROM DUAL
UNION ALL
SELECT 'DLAN',
       '--',
       90,
       1,
       'MOVLEG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Movimenta Est. Legal',
       'Movimenta Estoque Legal ?',
       '',
       'MOVLEG',
       'F' FROM DUAL
UNION ALL
SELECT 'DLAN',
       '1 ',
       30,
       1,
       'SINLAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Sinal do lanamento',
       'Sinal do lanamento',
       '',
       'SINLAN',
       'T' FROM DUAL
);

/*-- SEQ 7389 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DLAN',
       'LANVLR',
       0,
       'C',
       'Preo de Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DLAN',
       'LANVLR',
       0,
       'M',
       'Custo Mdio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DLAN',
       'LANVLR',
       0,
       'R',
       'Custo de Reposio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DLAN',
       'LANVLR',
       0,
       'V',
       'Preo de Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DLAN',
       'SINLAN',
       0,
       '*',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DLAN',
       'SINLAN',
       0,
       '+',
       'Entrada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DLAN',
       'SINLAN',
       0,
       '-',
       'Sada',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7390 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DLCR',
       TO_NUMBER(null),
       'DLCR',
       'Lista Caracterizao',
       'TD_LCR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7391 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DLCR','--','' FROM DUAL
UNION ALL
SELECT 'DLCR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DLCR','99','Outros' FROM DUAL
);

/*-- SEQ 7392 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DLCR',
       '01',
       10,
       5,
       'CODCRT',
       'S',
       'DCRT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCRT.DESCRT',
       'V',
       '',
       '',
       '',
       'F',
       'Caracterizao',
       'Cdigo da Caracterizao',
       'DCRT.CODTAB = DLCR.CODCRT',
       'CODCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'DLCR',
       '01',
       20,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DLCR',
       '01',
       30,
       254,
       'DESLES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Lista',
       'Descrio da Lista',
       '',
       'DESLES',
       'F' FROM DUAL
UNION ALL
SELECT 'DLCR',
       '01',
       40,
       3,
       'ORDLIS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ordenao da Lista',
       'Ordenao da Lista',
       '',
       'ORDLIS',
       'F' FROM DUAL
);

/*-- SEQ 7393 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DLIB',
       TO_NUMBER(null),
       'DLIB',
       'Dom. Liberaes',
       'TD_LIB',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DLIB.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7394 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DLIB','--','' FROM DUAL
);

/*-- SEQ 7395 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5521,
       'GRA ',
       'DLIB',
       'N ',
       '1 ',
       '',
       '',
       'gra.filmat = dlib.filmat and
gra.codmat = dlib.codmat and
gra.codcor = dlib.codcor and
gra.codtam = dlib.codtam',
       '' FROM DUAL
);

/*-- SEQ 7396 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DLIB',
       '--',
       10,
       5,
       'CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cor Material',
       'Cor Material',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'DLIB',
       '--',
       20,
       2,
       'CODLIB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Liberao',
       'Cdigo Liberao',
       '',
       'CODLIB',
       'F' FROM DUAL
UNION ALL
SELECT 'DLIB',
       '--',
       30,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Cdigo Material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'DLIB',
       '--',
       40,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DLIB',
       '--',
       50,
       5,
       'CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tamanho Material',
       'Tamanho Material',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'DLIB',
       '--',
       60,
       30,
       'DESLIB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Liberao',
       'Descrio Liberao',
       '',
       'DESLIB',
       'F' FROM DUAL
UNION ALL
SELECT 'DLIB',
       '--',
       70,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       '',
       'Filial Material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'DLIB',
       '--',
       80,
       1,
       'LIBATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'LIBATI',
       'F' FROM DUAL
);

/*-- SEQ 7397 --*/
INSERT INTO TT_ARQ(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,
       DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
       VALUES('DLPC',
              null,
              'DLPC',
              'Produtos Controlados',
              'TD_LPC',
              'F',
              '',
              'TOTALL',
              '',
              '',
              '',
              '',
              '',
              'T',
              '',
              'DLPC.CODTAB',
              '');
/*-- SEQ 7398 --*/
INSERT INTO TT_GRU ( CODTAB, CODGRU, DESGRU)
       VALUES ('DLPC','--','');
/*-- SEQ 7399 --*/
INSERT INTO TT_GRU ( CODTAB, CODGRU, DESGRU)
       VALUES ('DLPC','01','Identificao');
/*-- SEQ 7400 --*/
INSERT INTO TT_GRU ( CODTAB, CODGRU, DESGRU)
       VALUES ('DLPC','99','Outros');
/*-- SEQ 7401 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DLPC',
              '--',
              10,
              5,
              'CODTAB',
              'S',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'I',
              '',
              '',
              '',
              'F',
              'Cdigo',
              'Cdigo',
              '',
              'CODTAB',
              'F');
/*-- SEQ 7402 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DLPC',
              '--',
              20,
              20,
              'DESLPC',
              'A',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'A',
              '',
              '',
              'A',
              'F',
              'Descrio ',
              'Descrio de produto controlado',
              '',
              'DESLPC',
              'F');
/*-- SEQ 7403 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DLPC',
              '--',
              30,
              1,
              'LPCATI',
              'L',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'Y',
              '',
              '',
              '',
              'F',
              'Ativo ?',
              'Ativo ?',
              '',
              'LPCATI',
              'F');
/*-- SEQ 7404 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DLPC',
              '--',
              40,
              20,
              'NUMEXT',
              'A',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'A',
              '',
              '',
              'A',
              'F',
              'Nmero Externo',
              'Nmero Externo',
              '',
              'NUMEXT',
              'F');
/*-- SEQ 7405 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DLPC',
              '--',
              50,
              1,
              'TIPRCE',
              'L',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'Y',
              '',
              '',
              '',
              'F',
              'Tipo RCE ?',
              'Lista do tipo RCE ?',
              '',
              'TIPRCE',
              'F');

/*-- SEQ 7406 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DMAQ',
       TO_NUMBER(null),
       'DMAQ',
       'Dom. Equipamentos',
       'TD_MAQ',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DMAQ.CODTAB
',
       '' FROM DUAL
);

/*-- SEQ 7407 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DMAQ','--','' FROM DUAL
UNION ALL
SELECT 'DMAQ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DMAQ','99','Outros' FROM DUAL
);

/*-- SEQ 7408 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DMAQ',
       '--',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DMAQ',
       '--',
       20,
       1,
       'MAQATV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'MAQATV',
       'F' FROM DUAL
UNION ALL
SELECT 'DMAQ',
       '--',
       30,
       20,
       'NOMMAQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome',
       '',
       '',
       'NOMMAQ',
       'F' FROM DUAL
);

/*-- SEQ 7409 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DMAR',
       0,
       'DMAR',
       'Dom. Filme (Marca)',
       'TD_MAR',
       'F',
       '',
       'TOTALL',
       'Marca do Filme',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DMAR.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7410 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DMAR','--','' FROM DUAL
);

/*-- SEQ 7411 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DMAR',
       '--',
       30,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DMAR',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DMAR',
       '--',
       10,
       1,
       'MARATI',
       'L',
       '',
       0,
       0,
       'DMAR',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'MARATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DMAR',
       '--',
       20,
       15,
       'PHOMAR',
       'A',
       '',
       0,
       0,
       'DMAR',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Marca do filme',
       'Marca do filme',
       '',
       'PHOMAR',
       'F' FROM DUAL
);

/*-- SEQ 7412 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DMDV',
       TO_NUMBER(null),
       'DMDV',
       'Dom. Mod. de Veculo',
       'TD_MDV',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7413 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DMDV','--','' FROM DUAL
UNION ALL
SELECT 'DMDV','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DMDV','99','Outros' FROM DUAL
);

/*-- SEQ 7414 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22039,
       'DVEI',
       'DMDV',
       '1',
       '1',
       '',
       '',
       'DVEI.CODTAB = DMDV.CODVEI(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 7415 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'DMDV',
       '01',
       100,
       8,
       'ANOFIMPROD',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Ano Fim. Produo',
       'Data de Fim da Produo do Veculo',
       '',
       'ANOFIMPROD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DMDV',
       '01',
       90,
       8,
       'ANOINIPROD',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Ano Ini. Produo',
       'Data de Incio da Produo do Veculo',
       '',
       'ANOINIPROD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DMDV',
       '01',
       80,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DMDV',
       '01',
       60,
       6,
       'CODMAR',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo Marca',
       'Cdigo da Marca Modelo',
       '',
       'CODMAR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DMDV',
       '01',
       10,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DMDV',
       '01',
       30,
       5,
       'CODVEI',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo do Veculo',
       'Cdigo do Veculo',
       '',
       'CODVEI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DMDV',
       '01',
       70,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DMDV',
       '01',
       40,
       100,
       'DESMDV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Desc. Modelo',
       'Descrio do Modelo',
       '',
       'DESMDV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DMDV',
       '01',
       50,
       4,
       'DISEXI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Distncia Eixos',
       'Distncia entre Eixos',
       '',
       'DISEXI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DMDV',
       '01',
       20,
       1,
       'MDVATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Modelo Ativo?',
       'Modelo Ativo?',
       '',
       'MDVATI',
       '',
       'D' FROM DUAL
);

/*-- SEQ 7416 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DMED',
       0,
       'DMED',
       'Dom. Medidas',
       'TD_MED',
       'T',
       '',
       'TOTALL',
       'Unidade de medida',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DMED.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7417 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DMED','--','' FROM DUAL
);

/*-- SEQ 7418 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22538,
       'GRA ',
       'DMED',
       '1',
       'N',
       '',
       '',
       'GRA.UNIDAD = DMED.CODTAB AND
GRA.UNIFOR = DMED.CODTAB AND
GRA.UNIAPL = DMED.CODTAB AND
GRA.UNIEMB = DMED.CODTAB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22539,
       'ICO ',
       'DMED',
       '1',
       'N',
       '',
       '',
       'ICO.UNICOM = DMED.CODTAB AND
ICO.UNIVEN = DMED.CODTAB ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22540,
       'IPE ',
       'DMED',
       '1',
       'N',
       '',
       '',
       'IPE.UNICOM = DMED.CODTAB AND
IPE.UNIVEN = DMED.CODTAB ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22541,
       'PRO ',
       'DMED',
       '1',
       'N',
       '',
       '',
       'PRO.UNIDAD = DMED.CODTAB AND
PRO.UNIFOR = DMED.CODTAB',
       '',
       '' FROM DUAL
);

/*-- SEQ 7419 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DMED',
       '--',
       50,
       40,
       'CODPOS_DMED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo POS CONTROLE',
       'Cdigo POS CONTROLE',
       '',
       'CODPOS_DMED',
       '' FROM DUAL
UNION ALL
SELECT 'DMED',
       '--',
       30,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DMED',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DMED',
       '--',
       40,
       20,
       'DESMED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Desc. Unidade Medida',
       'Desc. Unidade Medida',
       '',
       'DESMED',
       '' FROM DUAL
UNION ALL
SELECT 'DMED',
       '--',
       10,
       1,
       'MEDATI',
       'L',
       '',
       0,
       0,
       'DMED',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       'A',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'MEDATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DMED',
       '--',
       20,
       2,
       'UNIMED',
       'A',
       '',
       0,
       0,
       'DMED',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Unidade de medida',
       'Unidade de Medida',
       '',
       'UNIMED',
       'F' FROM DUAL
);

/*-- SEQ 7420 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DMNF',
       TO_NUMBER(null),
       'DMNF',
       'Mod.Documento Fiscal',
       'TD_MNF',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DMNF.CODMNF',
       '' FROM DUAL
);

/*-- SEQ 7421 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DMNF','--','' FROM DUAL
UNION ALL
SELECT 'DMNF','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DMNF','99','Outros' FROM DUAL
);

/*-- SEQ 7422 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DMNF',
       '--',
       10,
       2,
       'CODMNF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Modelo',
       'Cdigo do Modelo',
       '',
       'CODMNF',
       'F' FROM DUAL
UNION ALL
SELECT 'DMNF',
       '--',
       20,
       60,
       'DESMNF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio do Modelo',
       'Descrio do Modelo',
       '',
       'DESMNF',
       'F' FROM DUAL
UNION ALL
SELECT 'DMNF',
       '--',
       30,
       4,
       'IMPMNF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Modelo do Impresso',
       'Modelo do Impresso',
       '',
       'IMPMNF',
       'F' FROM DUAL
);

/*-- SEQ 7423 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DMOD',
       TO_NUMBER(null),
       'DMOD',
       'Dom. Mdulos',
       'TD_MOD',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DMOD.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7424 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DMOD','--','' FROM DUAL
UNION ALL
SELECT 'DMOD','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DMOD','10','Integrador' FROM DUAL
UNION ALL
SELECT 'DMOD','11','Atendente' FROM DUAL
UNION ALL
SELECT 'DMOD','12','Revisor' FROM DUAL
UNION ALL
SELECT 'DMOD','13','Desenvolvedor' FROM DUAL
UNION ALL
SELECT 'DMOD','14','Usurio Comercial' FROM DUAL
);

/*-- SEQ 7425 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20157,
       'USU ',
       'DMOD',
       '1',
       'N',
       '',
       '',
       'DMOD.FILCOM = USU.FILUSU AND
DMOD.CODCOM = USU.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 7426 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DMOD',
       '14',
       420,
       3,
       'CODCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       'Cdigo do usurio comercial',
       '',
       'CODCOM',
       '' FROM DUAL
UNION ALL
SELECT 'DMOD',
       '10',
       310,
       3,
       'CODINT',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Codigo Integrador',
       'Cdigo Integrador',
       'USU2.FILUSU(+) = DMOD.FILINT AND USU2.CODUSU(+) = DMOD.CODINT',
       'CODINT',
       'T' FROM DUAL
UNION ALL
SELECT 'DMOD',
       '11',
       320,
       3,
       'CODSAC',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Codigo Atendente',
       'Cdigo Atendente',
       'USU2.FILUSU(+) = DMOD.FILSAC AND AND USU2.CODUSU(+) = DMOD.CODSAC',
       'CODSAC',
       'T' FROM DUAL
UNION ALL
SELECT 'DMOD',
       '01',
       100,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DMOD',
       '12',
       330,
       3,
       'CODTST',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Revisor',
       'Cdigo Revisor',
       'USU2.FILUSU(+) = DMOD.FILTST AND USU2.CODUSU(+) = DMOD.CODTST',
       'CODTST',
       'T' FROM DUAL
UNION ALL
SELECT 'DMOD',
       '13',
       340,
       3,
       'CODWOR',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Desenvolvedor',
       'Cdigo Desenvolvedor',
       'USU2.FILUSU(+) = DMOD.FILWOR AND USU2.CODUSU(+) = DMOD.CODWOR',
       'CODWOR',
       'T' FROM DUAL
UNION ALL
SELECT 'DMOD',
       '14',
       410,
       3,
       'FILCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       'Filial do usurio comercial',
       '',
       'FILCOM',
       '' FROM DUAL
UNION ALL
SELECT 'DMOD',
       '10',
       350,
       3,
       'FILINT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Integrador',
       'Filial Integrador',
       '',
       'FILINT',
       'F' FROM DUAL
UNION ALL
SELECT 'DMOD',
       '11',
       360,
       3,
       'FILSAC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Atendente',
       '',
       'FILSAC',
       'F' FROM DUAL
UNION ALL
SELECT 'DMOD',
       '12',
       370,
       3,
       'FILTST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Revisor',
       '',
       'FILTST',
       'F' FROM DUAL
UNION ALL
SELECT 'DMOD',
       '13',
       380,
       3,
       'FILWOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Desenvolvedor',
       '',
       'FILWOR',
       'F' FROM DUAL
UNION ALL
SELECT 'DMOD',
       '01',
       400,
       20,
       'GRUMOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Grupo de Mdulo',
       'Grupo de Mdulo',
       '',
       'GRUMOD',
       'F' FROM DUAL
UNION ALL
SELECT 'DMOD',
       '01',
       300,
       1,
       'MODATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Ativo?',
       'Ativo',
       '',
       'MODATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DMOD',
       '01',
       200,
       20,
       'MODULO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Mdulo',
       'Descritivo do mdulo',
       '',
       'MODULO',
       'F' FROM DUAL
UNION ALL
SELECT 'DMOD',
       '01',
       205,
       20,
       'TIPOMODULO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Tipo de Mdulo',
       'Tipo de Mdulo',
       '',
       '(CASE WHEN UPPER(DMOD.GRUMOD) = ''FOX'' THEN DMOD.MODULO ELSE DMOD.GRUMOD END)',
       '' FROM DUAL
UNION ALL
SELECT 'DMOD',
       '01',
       390,
       4,
       'VERATU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Versao Atual',
       'Verso Atual',
       '',
       'VERATU',
       'F' FROM DUAL
);

/*-- SEQ 7427 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DMOE',
       0,
       'DMOE',
       'Dom. Moedas',
       'TD_MOE',
       'T',
       '',
       'TOTALL',
       'Moedas',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DMOE.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7428 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DMOE','--','' FROM DUAL
);

/*-- SEQ 7429 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 24547,
       'COM ',
       'DMOE',
       '1',
       'N',
       '',
       '',
       'COM.CODMOE = DMOE.CODTAB AND
COM.MOEJUR = DMOE.CODTAB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 24548,
       'PLA ',
       'DMOE',
       '1',
       'N',
       '',
       '',
       'PLA.CODMOE = DMOE.CODTAB AND
PLA.MOECOR = DMOE.CODTAB',
       '',
       '' FROM DUAL
);

/*-- SEQ 7430 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DMOE',
       '--',
       30,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DMOE',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DMOE',
       '--',
       20,
       5,
       'DESMOE',
       'A',
       '',
       0,
       0,
       'DMOE',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Descrio da Moeda',
       'Descrio da moeda',
       '',
       'DESMOE',
       'F' FROM DUAL
UNION ALL
SELECT 'DMOE',
       '--',
       10,
       1,
       'MOEATI',
       'L',
       '',
       0,
       0,
       'DMOE',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Moeda Ativa?',
       'Moeda Ativa?',
       '',
       'MOEATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DMOE',
       '--',
       50,
       255,
       'MOEIMG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome do cone C4G',
       'Nome do cone para Checkout4G',
       '',
       'MOEIMG',
       '' FROM DUAL
UNION ALL
SELECT 'DMOE',
       '--',
       40,
       1,
       'MOELET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Letra de atalho C4G',
       'Letra de atalho para Checkout4G',
       '',
       'MOELET',
       '' FROM DUAL
UNION ALL
SELECT 'DMOE',
       '--',
       60,
       14,
       'MOELIM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Limite de valores',
       'Limite de valores no caixa',
       '',
       'MOELIM',
       '' FROM DUAL
UNION ALL
SELECT 'DMOE',
       '--',
       70,
       1,
       'MOENIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Nvel de Tela',
       'Nvel de Tela',
       '',
       'MOENIV',
       'T' FROM DUAL
);

/*-- SEQ 7431 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DMOE',
       'MOENIV',
       1,
       ' ',
       'Primeiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DMOE',
       'MOENIV',
       2,
       ' ',
       'Segundo',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7432 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DMON',
       TO_NUMBER(null),
       'DMON',
       'Dom. Tipos Montagens',
       'TD_MON',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DMON.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7433 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DMON','--','' FROM DUAL
UNION ALL
SELECT 'DMON','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DMON','99','Outros' FROM DUAL
);

/*-- SEQ 7434 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DMON',
       '01',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DMON',
       '01',
       20,
       30,
       'DESMON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Montagem',
       'Descrio da Montagem de Volumes',
       '',
       'DESMON',
       'F' FROM DUAL
UNION ALL
SELECT 'DMON',
       '01',
       30,
       1,
       'MONATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Montagem Ativa?',
       'Montagem Ativa?',
       '',
       'MONATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DMON',
       '01',
       40,
       12,
       'MONCOR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Montagem Corretiva ',
       'Montagem Corretiva (assistncia)',
       '',
       'MONCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'DMON',
       '01',
       50,
       12,
       'MONDEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Mon. Dentro Empresa',
       'Montagem Dentro da empresa',
       '',
       'MONDEN',
       'F' FROM DUAL
UNION ALL
SELECT 'DMON',
       '01',
       60,
       12,
       'MONINT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Montagem Interurbana',
       'Montagem Interurbana',
       '',
       'MONINT',
       'F' FROM DUAL
UNION ALL
SELECT 'DMON',
       '01',
       70,
       12,
       'MONURB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Montagem Urbana',
       'Montagem Urbana',
       '',
       'MONURB',
       'F' FROM DUAL
);

/*-- SEQ 7435 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DMOT',
       TO_NUMBER(null),
       'DMOT',
       'Dom. Motor Veculo',
       'TD_MOT',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7436 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DMOT','--','' FROM DUAL
UNION ALL
SELECT 'DMOT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DMOT','99','Outros' FROM DUAL
);

/*-- SEQ 7437 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'DMOT',
       '01',
       80,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DMOT',
       '01',
       50,
       4,
       'CILIND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cilindrada do Motor',
       'Cilindrada do Motor',
       '',
       'CILIND',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DMOT',
       '01',
       10,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DMOT',
       '01',
       70,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DMOT',
       '01',
       30,
       100,
       'DESCMO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio do Motor',
       'Descrio do Motor',
       '',
       'DESCMO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DMOT',
       '01',
       20,
       1,
       'MTOATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Motor Ativo?',
       'Motor Ativo?',
       '',
       'MTOATI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DMOT',
       '01',
       60,
       4,
       'POTENC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Potencia do Motor',
       'Potncia do Motor',
       '',
       'POTENC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DMOT',
       '01',
       40,
       2,
       'TIPCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo do Combustvel',
       'Tipo do Combustvel',
       '',
       'TIPCOM',
       'T',
       'D' FROM DUAL
);

/*-- SEQ 7438 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DMOT',
       'TIPCOM',
       0,
       ' ',
       'Gasolina/Gs Natural Combustv',
       TO_NUMBER(null),
       '08' FROM DUAL
UNION ALL
SELECT 'DMOT',
       'TIPCOM',
       0,
       ' ',
       'lcool/Gs Natural Combustvel',
       TO_NUMBER(null),
       '09' FROM DUAL
UNION ALL
SELECT 'DMOT',
       'TIPCOM',
       0,
       ' ',
       'Diesel/Gs Natural Combustvel',
       TO_NUMBER(null),
       '10' FROM DUAL
UNION ALL
SELECT 'DMOT',
       'TIPCOM',
       0,
       ' ',
       'Vide/Campo/Observao',
       TO_NUMBER(null),
       '11' FROM DUAL
UNION ALL
SELECT 'DMOT',
       'TIPCOM',
       0,
       ' ',
       'lcool/Gs Natural Vecular',
       TO_NUMBER(null),
       '12' FROM DUAL
UNION ALL
SELECT 'DMOT',
       'TIPCOM',
       0,
       ' ',
       'Gasolina/Gs Natural Vecular',
       TO_NUMBER(null),
       '13' FROM DUAL
UNION ALL
SELECT 'DMOT',
       'TIPCOM',
       0,
       ' ',
       'Diesel/Gs Natural Vecular',
       TO_NUMBER(null),
       '14' FROM DUAL
UNION ALL
SELECT 'DMOT',
       'TIPCOM',
       0,
       ' ',
       'Gs Natural Vecular',
       TO_NUMBER(null),
       '15' FROM DUAL
UNION ALL
SELECT 'DMOT',
       'TIPCOM',
       0,
       ' ',
       'lcool/Gasolina',
       TO_NUMBER(null),
       '16' FROM DUAL
UNION ALL
SELECT 'DMOT',
       'TIPCOM',
       0,
       ' ',
       'Gasolina/lcool/Gs Natural Ve',
       TO_NUMBER(null),
       '17' FROM DUAL
UNION ALL
SELECT 'DMOT',
       'TIPCOM',
       0,
       ' ',
       'Gasolina/Eltrico',
       TO_NUMBER(null),
       '18' FROM DUAL
UNION ALL
SELECT 'DMOT',
       'TIPCOM',
       0,
       ' ',
       'lcool',
       TO_NUMBER(null),
       '01' FROM DUAL
UNION ALL
SELECT 'DMOT',
       'TIPCOM',
       0,
       ' ',
       'Gasolina',
       TO_NUMBER(null),
       '02' FROM DUAL
UNION ALL
SELECT 'DMOT',
       'TIPCOM',
       0,
       ' ',
       'Diesel',
       TO_NUMBER(null),
       '03' FROM DUAL
UNION ALL
SELECT 'DMOT',
       'TIPCOM',
       0,
       ' ',
       'Gasognio',
       TO_NUMBER(null),
       '04' FROM DUAL
UNION ALL
SELECT 'DMOT',
       'TIPCOM',
       0,
       ' ',
       'Gs Metano',
       TO_NUMBER(null),
       '05' FROM DUAL
UNION ALL
SELECT 'DMOT',
       'TIPCOM',
       0,
       ' ',
       'Eltrico/Fonte Interna',
       TO_NUMBER(null),
       '06' FROM DUAL
UNION ALL
SELECT 'DMOT',
       'TIPCOM',
       0,
       ' ',
       'Eltrico/Fonte Externa',
       TO_NUMBER(null),
       '07' FROM DUAL
);

/*-- SEQ 7439 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DMPB',
       TO_NUMBER(null),
       'DMPB',
       'Dom. Incisos MPB',
       'TD_MPB',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DMPB.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7440 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DMPB','--','' FROM DUAL
UNION ALL
SELECT 'DMPB','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DMPB','99','Outros' FROM DUAL
);

/*-- SEQ 7441 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DMPB',
       '--',
       1,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'DMPB',
       '--',
       2,
       100,
       'DESMPB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio Inciso',
       'Descrio do Inciso',
       '',
       'DESMPB',
       '' FROM DUAL
UNION ALL
SELECT 'DMPB',
       '--',
       4,
       1,
       'MPBATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Registro Ativo?',
       'Registro Ativo?',
       '',
       'MPBATI',
       '' FROM DUAL
UNION ALL
SELECT 'DMPB',
       '--',
       3,
       12,
       'VLRMAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Mximo',
       'Valor Mximo Venda',
       '',
       'VLRMAX',
       '' FROM DUAL
);

/*-- SEQ 7442 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DMTD',
       TO_NUMBER(null),
       'DMTD',
       'Dom. Montadora Veic.',
       'TD_MTD',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7443 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DMTD','--','' FROM DUAL
UNION ALL
SELECT 'DMTD','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DMTD','99','Outros' FROM DUAL
);

/*-- SEQ 7444 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'DMTD',
       '01',
       50,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DMTD',
       '01',
       10,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DMTD',
       '01',
       40,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DMTD',
       '01',
       30,
       100,
       'DESMTD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Desc. da Montadora',
       'Descrio da Montadora',
       '',
       'DESMTD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DMTD',
       '01',
       20,
       1,
       'MTDATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Montadora Ativa?',
       'Montadora Ativa?',
       '',
       'MTDATI',
       '',
       'D' FROM DUAL
);

/*-- SEQ 7445 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DMUL',
       TO_NUMBER(null),
       'DMUL',
       'Dom.Mltiplos Estoq.',
       'TD_MUL',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DMUL.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7446 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DMUL','--','' FROM DUAL
UNION ALL
SELECT 'DMUL','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DMUL','99','Outros' FROM DUAL
);

/*-- SEQ 7447 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DMUL',
       '01',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DMUL',
       '01',
       20,
       30,
       'DESMUL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'DESMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'DMUL',
       '01',
       30,
       1,
       'MULATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'MULATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DMUL',
       '--',
       40,
       1,
       'SUGEST',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Aval. sugesto comp.',
       'Avaliado na sugesto de compra',
       '',
       'SUGEST',
       'F' FROM DUAL
);

/*-- SEQ 7448 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DMVP',
       TO_NUMBER(null),
       'DMVP',
       'Mot. Variao Preos',
       'TD_MVP',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DMVP.CODMOT',
       '' FROM DUAL
);

/*-- SEQ 7449 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DMVP','--','' FROM DUAL
UNION ALL
SELECT 'DMVP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DMVP','99','Outros' FROM DUAL
);

/*-- SEQ 7450 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DMVP',
       '--',
       70,
       5,
       'ACRMAXMOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Acrsc.mx.do motivo',
       'Acrscimo mximo do motivo',
       '',
       'ACRMAXMOT',
       '' FROM DUAL
UNION ALL
SELECT 'DMVP',
       '--',
       10,
       5,
       'CODTAB',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo',
       'Cdigo',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'DMVP',
       '--',
       40,
       1,
       'CONMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Sol.qual concorrnte',
       'Solicita qual o concorrnte',
       '',
       'CONMOT',
       '' FROM DUAL
UNION ALL
SELECT 'DMVP',
       '--',
       60,
       5,
       'DESMAXMOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Desc.mx. do motivo',
       'Desconto mximo do motivo',
       '',
       'DESMAXMOT',
       '' FROM DUAL
UNION ALL
SELECT 'DMVP',
       '--',
       20,
       30,
       'DESMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio',
       'Descrio',
       '',
       'DESMOT',
       '' FROM DUAL
UNION ALL
SELECT 'DMVP',
       '--',
       90,
       1,
       'MOTATI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Ativo?',
       '',
       'MOTATI',
       '' FROM DUAL
UNION ALL
SELECT 'DMVP',
       '--',
       50,
       4,
       'PERMOT',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nr permisso Usu.Sol',
       'Nmero da permisso de usurio solicitada',
       '',
       'PERMOT',
       '' FROM DUAL
UNION ALL
SELECT 'DMVP',
       '--',
       80,
       1,
       'TIPMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo do motivo',
       'Tipo do motivo',
       '',
       'TIPMOT',
       'T' FROM DUAL
UNION ALL
SELECT 'DMVP',
       '--',
       30,
       1,
       'USOMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Uso',
       'Uso',
       '',
       'USOMOT',
       'T' FROM DUAL
);

/*-- SEQ 7451 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DMVP',
       'TIPMOT',
       0,
       'A',
       'Ambos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DMVP',
       'TIPMOT',
       0,
       'F',
       'Fechamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DMVP',
       'TIPMOT',
       0,
       'I',
       'Itens',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DMVP',
       'USOMOT',
       0,
       '+',
       'Acrscimo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DMVP',
       'USOMOT',
       0,
       '-',
       'Desconto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DMVP',
       'USOMOT',
       0,
       '2',
       'Desconto ou Acrscimo',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7452 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DNAT',
       0,
       'DNAT',
       'Dom. Naturezas',
       'TD_NAT',
       'F',
       '',
       'TOTALL',
       'Naturezas',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DNAT.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7453 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DNAT','--','' FROM DUAL
UNION ALL
SELECT 'DNAT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DNAT','02','Datas' FROM DUAL
UNION ALL
SELECT 'DNAT','03','Valores' FROM DUAL
UNION ALL
SELECT 'DNAT','99','Outros' FROM DUAL
);

/*-- SEQ 7454 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 28272,
       'CTA ',
       'DNAT',
       '01',
       'N',
       '',
       '',
       'DNAT.NATEST_FIL = CTA.CODFIL AND
DNAT.NATEST_SEQ = CTA.SEQUEN AND
DNAT.NATEST_TIP = CTA.TIPCTA',
       '',
       '' FROM DUAL
);

/*-- SEQ 7455 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DNAT',
       '01',
       170,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DNAT',
       160,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '99',
       100,
       80,
       'COMENT',
       'A',
       '',
       0,
       0,
       'DNAT',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Comentrio',
       'Comentrios da natureza',
       '',
       'COMENT',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '99',
       2320,
       1,
       'CONLOC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Consumo Local',
       'Consumo Local',
       '',
       'CONLOC',
       '' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '01',
       2032,
       1,
       'CONSFI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Consumidor Final',
       'Consumidor Final',
       '',
       'CONSFI',
       'T' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '99',
       2302,
       3,
       'CSTNOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'CST Produtos Normais',
       'Cdigo CST para Produtos Normais',
       '',
       'CSTNOR',
       'T' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '99',
       2312,
       3,
       'CST_ST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       '',
       'CST Produtos ST',
       'Cdigo CST para Produtos Substitudos',
       '',
       'CST_ST',
       'T' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '--',
       2042,
       1,
       'DEVVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Devolve vnculo',
       'Devolve vnculo',
       '',
       'DEVVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '01',
       2001,
       10,
       'EXTDEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nat. dentro do Est.',
       'Cdigo Externo para Naturezas dentro do Estado',
       '',
       'EXTDEM',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '01',
       2002,
       10,
       'EXTFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nat. fora do Est.',
       'Cdigo Externo para Naturezas fora do Estado',
       '',
       'EXTFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '99',
       160,
       1,
       'FINANC',
       'L',
       '',
       0,
       0,
       'DNAT',
       150,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Gera dados financ.?',
       'Indica se gera dados financeiros',
       '',
       'FINANC',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '99',
       2000,
       1,
       'LANVEN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       200,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Lanamento "Venda"?',
       'Lana registro como sendo do tipo "venda"',
       '',
       'LANVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '03',
       80,
       2,
       'LIMITE',
       'S',
       '',
       0,
       0,
       'DNAT',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Limite de retorno',
       'Nmero de dias para devoluo da nota fiscal',
       '',
       'LIMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '99',
       60,
       1,
       'MOVEST',
       'L',
       '',
       0,
       0,
       'DNAT',
       60,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Sada de mercadoria?',
       'Indica se movimenta estoque',
       '',
       'MOVEST',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '99',
       10,
       1,
       'NATATI',
       'L',
       '',
       0,
       0,
       'DNAT',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'NATATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '--',
       2242,
       2,
       'NATBCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Nat. Crd. PIS/Cofin',
       'Cdigo da Base de Clculo de Crdito de PIS/Cofins',
       '',
       'NATBCC',
       'T' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '01',
       110,
       6,
       'NATDEN',
       'A',
       '',
       0,
       0,
       'DNAT',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       'N',
       'T',
       'Cdigo no estado',
       'Natureza quando dentro do estado',
       '',
       'NATDEN',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '--',
       2252,
       6,
       'NATESD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nat Estorno Dentro E',
       'Natureza de Estorno Dentro do Estado',
       '',
       'NATESD',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '--',
       2262,
       6,
       'NATESF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nat Estorno Fora E',
       'Natureza de Estorno Fora do Estado',
       '',
       'NATESF',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '--',
       2132,
       3,
       'NATEST_FIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'NATEST_FIL',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '--',
       2142,
       10,
       'NATEST_SEQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       '',
       '',
       'NATEST_SEQ',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '--',
       2152,
       1,
       'NATEST_TIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       '',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'NATEST_TIP',
       'T' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '01',
       120,
       6,
       'NATFOR',
       'A',
       '',
       0,
       0,
       'DNAT',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       'N',
       'T',
       'Cdigo fora do est.',
       'Natureza quando fora do estado',
       '',
       'NATFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '01',
       130,
       6,
       'NATFUD',
       'A',
       '',
       0,
       0,
       'DNAT',
       120,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       'N',
       'T',
       'Natureza no estado',
       'Natureza futura quando dentro do estado',
       '',
       'NATFUD',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '01',
       140,
       6,
       'NATFUF',
       'A',
       '',
       0,
       0,
       'DNAT',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       'N',
       'T',
       'Natureza fora do est',
       'Natureza futura quando fora do estado',
       '',
       'NATFUF',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '99',
       2272,
       2,
       'NATMEN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo de Menu C4G',
       'Cdigo de Menu no Checkout 4G',
       '',
       'NATMEN',
       '' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '01',
       2042,
       2,
       'NATMOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Modelo da nota',
       'Modelo da nota',
       '',
       'NATMOD',
       '' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '01',
       2022,
       5,
       'NATMUL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nat.Mltiplo Estoque',
       'Natureza Mltiplo Estoque',
       '',
       'NATMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '99',
       1800,
       1,
       'NATOLN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       180,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Impresso on-line?',
       'Define se haver impresso on-line de NF',
       '',
       'NATOLN',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '99',
       2330,
       1,
       'NATPRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Origem do preo',
       'Origem do preo usado pela Natureza (Totali PoS)',
       '',
       'NATPRE',
       'T' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '01',
       21,
       6,
       'NATRED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Natureza Reduo',
       'Natureza Reduo',
       '',
       'NATRED',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '01',
       2282,
       6,
       'NATRED_ST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nat. Reversa ST Den.',
       'Natureza Reversa para Produtos ST Dentro Estado',
       '',
       'NATRED_ST',
       '' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '01',
       22,
       6,
       'NATREF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Natureza Referncia',
       'Natureza Referncia',
       '',
       'NATREF',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '01',
       2292,
       6,
       'NATREF_ST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nat. Reversa ST For.',
       'Natureza Reversa para Produtos ST Fora Estado',
       '',
       'NATREF_ST',
       '' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '01',
       20,
       40,
       'NATURE',
       'A',
       '',
       0,
       0,
       'DNAT',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Natureza',
       'Natureza da operao',
       '',
       'NATURE',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '01',
       2062,
       1,
       'NATUTL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Natureza disp. p/',
       'Natureza disponvel p/',
       '',
       'NATUTL',
       'T' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '99',
       1700,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       170,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(DNAT.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '--',
       2052,
       10,
       'SEQEXC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQEXC',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '01',
       150,
       2,
       'SERVIN',
       'A',
       '',
       0,
       0,
       'DNAT',
       140,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Srie padro V. fut',
       'Srie para vinculao, caso a natureza tenha vinculao',
       '',
       'SERVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '99',
       2222,
       2,
       'SITCOF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'CST Cofins',
       'Cdigo de Situao Tributria do COFINS',
       '',
       'SITCOF',
       'T' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '99',
       2232,
       2,
       'SITPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'CST PIS',
       'Cdigo de Situao Tributria do PIS',
       '',
       'SITPIS',
       'T' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '01',
       2012,
       1,
       'TIPNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo da natureza',
       'Tipo da natureza de operao',
       '',
       'TIPNAT',
       'T' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '99',
       1900,
       1,
       'TRIBUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       190,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Gera tributos?',
       'Define se a NF gera tributos',
       '',
       'TRIBUT',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '99',
       70,
       1,
       'USACUS',
       'L',
       '',
       0,
       0,
       'DNAT',
       70,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Preo custo/venda?',
       'Indica se usa preo de custo como sendo preo de venda',
       '',
       'USACUS',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '03',
       40,
       2,
       'USAICM',
       'S',
       '',
       0,
       0,
       'DNAT',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       '',
       'T',
       'ICMS',
       'Tipo de ICMS',
       '',
       'USAICM',
       'F' FROM DUAL
UNION ALL
SELECT 'DNAT',
       '03',
       50,
       2,
       'USAIPI',
       'S',
       '',
       0,
       0,
       'DNAT',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       '',
       'T',
       'IPI',
       'Tipo de IPI',
       '',
       'USAIPI',
       'F' FROM DUAL
);

/*-- SEQ 7456 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DNAT',
       'CONSFI',
       0,
       'F',
       'Para revenda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'CONSFI',
       0,
       'T',
       'Natureza para consumo final',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'CSTNOR',
       0,
       ' ',
       'Outras',
       TO_NUMBER(null),
       '90' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'CSTNOR',
       0,
       ' ',
       'Isenta',
       TO_NUMBER(null),
       '40' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'CSTNOR',
       0,
       ' ',
       'No tributada',
       TO_NUMBER(null),
       '41' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'CSTNOR',
       0,
       ' ',
       'Suspenso',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'CSTNOR',
       0,
       ' ',
       'Diferimento',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'CST_ST',
       0,
       ' ',
       'Isenta',
       TO_NUMBER(null),
       '40' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'CST_ST',
       0,
       ' ',
       'No tributada',
       TO_NUMBER(null),
       '41' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'CST_ST',
       0,
       ' ',
       'Suspenso',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'CST_ST',
       0,
       ' ',
       'Diferimento',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'CST_ST',
       0,
       ' ',
       'Outras',
       TO_NUMBER(null),
       '90' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATBCC',
       0,
       ' ',
       'Aquisio de bens para revenda',
       TO_NUMBER(null),
       '01' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATBCC',
       0,
       ' ',
       'Aquisio bens util. c/ insumo',
       TO_NUMBER(null),
       '02' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATBCC',
       0,
       ' ',
       'Aquisio serv. util. insumo',
       TO_NUMBER(null),
       '03' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATBCC',
       0,
       ' ',
       'Energia eltrica e trmica',
       TO_NUMBER(null),
       '04' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATBCC',
       0,
       ' ',
       'Aluguis de prdios',
       TO_NUMBER(null),
       '05' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATBCC',
       0,
       ' ',
       'Aluguis de mquinas e equip.',
       TO_NUMBER(null),
       '06' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATBCC',
       0,
       ' ',
       'Armazenagem mercadoria e frete',
       TO_NUMBER(null),
       '07' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATBCC',
       0,
       ' ',
       'Contraprestaes mercatil',
       TO_NUMBER(null),
       '08' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATBCC',
       0,
       ' ',
       'Crd. s/ encargos depreciao',
       TO_NUMBER(null),
       '09' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATBCC',
       0,
       ' ',
       'Crd. c/ base valor aquisio',
       TO_NUMBER(null),
       '10' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATBCC',
       0,
       ' ',
       'Amort. deprec. edific. imveis',
       TO_NUMBER(null),
       '11' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATBCC',
       0,
       ' ',
       'Dev. de vendas suj. Incidncia',
       TO_NUMBER(null),
       '12' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATBCC',
       0,
       ' ',
       'Outras Operaes direito crd.',
       TO_NUMBER(null),
       '13' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATBCC',
       0,
       ' ',
       'Atividade Transporte de Cargas',
       TO_NUMBER(null),
       '14' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATBCC',
       0,
       ' ',
       'Custo de Unidade Imobiliria',
       TO_NUMBER(null),
       '15' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATBCC',
       0,
       ' ',
       'Custo unidade no concluda',
       TO_NUMBER(null),
       '16' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATBCC',
       0,
       ' ',
       'Atividade de Prestao de Serv',
       TO_NUMBER(null),
       '17' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATBCC',
       0,
       ' ',
       'Estoque de abertura de bens',
       TO_NUMBER(null),
       '18' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATPRE',
       0,
       'C',
       'Custo de Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATPRE',
       0,
       'R',
       'Custo de Reposio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATPRE',
       0,
       'T',
       'Tabela de Preos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATUTL',
       0,
       'A',
       'ECF de Administrao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATUTL',
       0,
       'L',
       'ECF de Loja',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATUTL',
       0,
       'Q',
       'Qualquer',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'NATUTL',
       0,
       'U',
       'ECF de Loja Autorizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Tributvel (base de clculo)',
       TO_NUMBER(null),
       '01' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Ope. Trib. Alq. Diferenciada',
       TO_NUMBER(null),
       '02' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Ope. Trib. Alq Und Med.Pro',
       TO_NUMBER(null),
       '03' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Ope. Trib. Monofsica Rev.Alq',
       TO_NUMBER(null),
       '04' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Ope. Trib. Substituio Trib.',
       TO_NUMBER(null),
       '05' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Tributvel (alquota zero) ',
       TO_NUMBER(null),
       '06' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Isenta da Contribuio',
       TO_NUMBER(null),
       '07' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Sem Incidncia da Contribuio',
       TO_NUMBER(null),
       '08' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Outras Operaes de Sada',
       TO_NUMBER(null),
       '49' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Com Suspenso da Contribuio ',
       TO_NUMBER(null),
       '09' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Crdito-Tributada',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Crdito-No Tributada',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Crdito-Exportao',
       TO_NUMBER(null),
       '52' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Crdito-Vinc Trib Export',
       TO_NUMBER(null),
       '54' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Crdito-Vinc NTrib Export',
       TO_NUMBER(null),
       '55' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib Exp',
       TO_NUMBER(null),
       '56' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Exc Trib',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Exc NTrib',
       TO_NUMBER(null),
       '61' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Exc Export',
       TO_NUMBER(null),
       '62' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Trib NTrib',
       TO_NUMBER(null),
       '63' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Trib Export',
       TO_NUMBER(null),
       '64' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis NTrib Export',
       TO_NUMBER(null),
       '65' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Trib NTrib Exp
',
       TO_NUMBER(null),
       '66' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Presum-Outras Operaes
',
       TO_NUMBER(null),
       '67' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Aquisio sem Dir Crdito',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Aquisio com Iseno',
       TO_NUMBER(null),
       '71' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Aquisio com Suspenso',
       TO_NUMBER(null),
       '72' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Aquisio a Alquota Zero',
       TO_NUMBER(null),
       '73' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Aquisio sem Inc Contrib',
       TO_NUMBER(null),
       '74' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Aquisio por ST
',
       TO_NUMBER(null),
       '75' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Outras Operaes de Entrada',
       TO_NUMBER(null),
       '98' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITCOF',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Crdito-No Tributada',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Crdito-Exportao',
       TO_NUMBER(null),
       '52' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib
',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Crdito-Vinc Trib Export',
       TO_NUMBER(null),
       '54' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Crdito-Vinc NTrib Export',
       TO_NUMBER(null),
       '55' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib Exp',
       TO_NUMBER(null),
       '56' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Exc Trib
',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Exc NTrib
',
       TO_NUMBER(null),
       '61' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Exc Export',
       TO_NUMBER(null),
       '62' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Trib NTrib',
       TO_NUMBER(null),
       '63' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Trib Export',
       TO_NUMBER(null),
       '64' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis NTrib Export',
       TO_NUMBER(null),
       '65' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Trib NTrib Exp',
       TO_NUMBER(null),
       '66' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Presum-Outras Operaes',
       TO_NUMBER(null),
       '67' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Aquisio sem Dir Crdito',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Aquisio com Iseno',
       TO_NUMBER(null),
       '71' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Aquisio com Suspenso',
       TO_NUMBER(null),
       '72' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Aquisio a Alquota Zero',
       TO_NUMBER(null),
       '73' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Aquisio sem Inc Contrib',
       TO_NUMBER(null),
       '74' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Aquisio por ST
',
       TO_NUMBER(null),
       '75' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Outras Operaes de Entrada',
       TO_NUMBER(null),
       '98' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Tributvel (base de clculo)',
       TO_NUMBER(null),
       '01' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Ope. Trib. Alq. Diferenciada',
       TO_NUMBER(null),
       '02' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Ope. Trib. Alq Und Med.Pro
',
       TO_NUMBER(null),
       '03' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Ope. Trib. Monofsica Rev.Alq',
       TO_NUMBER(null),
       '04' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Ope. Trib. Substituio Trib.',
       TO_NUMBER(null),
       '05' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Tributvel (alquota zero)',
       TO_NUMBER(null),
       '06' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Isenta da Contribuio ',
       TO_NUMBER(null),
       '07' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Sem Incidncia da Contribuio',
       TO_NUMBER(null),
       '08' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Com Suspenso da Contribuio ',
       TO_NUMBER(null),
       '09' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Outras Operaes de Sada',
       TO_NUMBER(null),
       '49' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'SITPIS',
       0,
       ' ',
       'Crdito-Tributada',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'TIPNAT',
       0,
       'A',
       'Nota com vnculo anterior',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'TIPNAT',
       0,
       'B',
       'Estorno',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'TIPNAT',
       0,
       'C',
       'Consumo interno',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'TIPNAT',
       0,
       'D',
       'Devoluo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'TIPNAT',
       0,
       'E',
       'Entrada via Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'TIPNAT',
       0,
       'F',
       'Nota com vnculo futuro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'TIPNAT',
       0,
       'I',
       'Importao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'TIPNAT',
       0,
       'J',
       'Complementar/Ajuste',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'TIPNAT',
       0,
       'M',
       'Devoluo de Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'TIPNAT',
       0,
       'N',
       'No Classificado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'TIPNAT',
       0,
       'O',
       'Sobra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'TIPNAT',
       0,
       'P',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'TIPNAT',
       0,
       'R',
       'Devolucao de Transferencia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'TIPNAT',
       0,
       'S',
       'Sada via Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'TIPNAT',
       0,
       'V',
       'Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'TIPNAT',
       0,
       'Y',
       'NF Sobre Recibo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DNAT',
       'TIPNAT',
       0,
       'Z',
       'Recibo Provisrio',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7457 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DNIV',
       TO_NUMBER(null),
       'DNIV',
       'Dom. Nvel de Servi',
       'TD_NIV',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7458 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DNIV','--','' FROM DUAL
UNION ALL
SELECT 'DNIV','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DNIV','99','Outros' FROM DUAL
);

/*-- SEQ 7459 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DNIV',
       '01',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo',
       'Cdigo do Nvel de Servio',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'DNIV',
       '01',
       20,
       100,
       'DESNIV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio',
       'Descrio do Nvel de Servio',
       '',
       'DESNIV',
       '' FROM DUAL
UNION ALL
SELECT 'DNIV',
       '99',
       50,
       5,
       'FATNIV',
       'F',
       '',
       3,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Fator de Servio',
       'Fator de Servio',
       '',
       'FATNIV',
       '' FROM DUAL
UNION ALL
SELECT 'DNIV',
       '99',
       30,
       1,
       'NIVATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Nvel de Servio Ativo',
       '',
       'NIVATI',
       '' FROM DUAL
UNION ALL
SELECT 'DNIV',
       '99',
       40,
       4,
       'PERNIV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Nvel de Servio',
       'Percentual do Nvel de Servio',
       '',
       'PERNIV',
       '' FROM DUAL
);

/*-- SEQ 7460 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DOBS',
       0,
       'DOBS',
       'Dom. Observaes',
       'TD_OBS',
       'F',
       '',
       'TOTALL',
       'Observaes padres',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DOBS.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7461 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DOBS','--','' FROM DUAL
);

/*-- SEQ 7462 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DOBS',
       '--',
       40,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DOBS',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DOBS',
       '--',
       30,
       30,
       'DESOBS',
       'A',
       '',
       0,
       0,
       'DOBS',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Descrio',
       'Descrio da observao',
       '',
       'DESOBS',
       'F' FROM DUAL
UNION ALL
SELECT 'DOBS',
       '--',
       10,
       1,
       'OBSATI',
       'L',
       '',
       0,
       0,
       'DOBS',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'OBSATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DOBS',
       '--',
       51,
       4000,
       'TXTOBS',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Observao padro',
       'Texto da observao padro',
       '',
       'RTF2TXT(TXTOBS)',
       'F' FROM DUAL
UNION ALL
SELECT 'DOBS',
       '--',
       20,
       1,
       'USUOBS',
       'A',
       '',
       0,
       0,
       'DOBS',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Uso da observao',
       'Uso da observao',
       '',
       'USUOBS',
       'F' FROM DUAL
);

/*-- SEQ 7463 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DOCU',
       TO_NUMBER(null),
       'DOCU',
       'Dom. Ocupaes',
       'TD_OCU',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DOCU.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7464 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DOCU','--','' FROM DUAL
UNION ALL
SELECT 'DOCU','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DOCU','99','Outros' FROM DUAL
);

/*-- SEQ 7465 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DOCU',
       '01',
       10,
       12,
       'BASOCU',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Salrio Base',
       'Salrio Base (aceita >= 0)
Salrio Base (aceita >= 0)
Salrio Base',
       '',
       'BASOCU',
       'F' FROM DUAL
UNION ALL
SELECT 'DOCU',
       '01',
       20,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DOCU',
       '01',
       30,
       30,
       'DESOCU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Ocupao',
       'Descrio da Ocupao(Profisso)',
       '',
       'DESOCU',
       'F' FROM DUAL
);

/*-- SEQ 7466 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DOE ',
       TO_NUMBER(null),
       'DOE ',
       'Doenas Crnicas',
       'TT_DOE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DOE.CODFIL,DOE.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7467 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DOE ','--','' FROM DUAL
UNION ALL
SELECT 'DOE ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DOE ','99','Outros' FROM DUAL
);

/*-- SEQ 7468 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5550,
       'CLI ',
       'DOE ',
       '1 ',
       'N ',
       '',
       '',
       'CLI.CODCLI = DOE.CODCLI AND
CLI.FILCLI = DOE.FILCLI',
       '' FROM DUAL
UNION ALL
SELECT 5551,
       'TCID',
       'DOE ',
       '1 ',
       'N ',
       '',
       '',
       'TCID.CODCID = DOE.CODCID(+)',
       '' FROM DUAL
UNION ALL
SELECT 5552,
       'USU ',
       'DOE ',
       '1 ',
       'N ',
       '',
       '',
       'USU.FILUSU = DOE.FILUSU AND
USU.CODUSU = DOE.CODUSU',
       '' FROM DUAL
);

/*-- SEQ 7469 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DOE ',
       '01',
       1,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Data da ltima atualizao.',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'DOE ',
       '01',
       2,
       8,
       'CODCID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cd. Int. Doeas',
       'Cadastro internacional de Doenas.',
       '',
       'CODCID',
       'F' FROM DUAL
UNION ALL
SELECT 'DOE ',
       '01',
       3,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente.',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'DOE ',
       '01',
       4,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '9',
       'F',
       'Cdigo da Filial',
       'Filial do usurio logado.',
       'DOE.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'DOE ',
       '01',
       5,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Usurio',
       'Usurio que alterou o registro.',
       'DOE.FILUSU = USU.FILUSU(+)  AND DOE.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'DOE ',
       '01',
       6,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Cliente.',
       '',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'DOE ',
       '01',
       7,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Usurio que alterou o registro.',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'DOE ',
       '01',
       8,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 7470 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DOM ',
       TO_NUMBER(null),
       'DOM ',
       'BI_Domnios',
       'TT_DOM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DOM.CODARQ,DOM.NOMCPO,DOM.CODINT,DOM.COCHR,DOM.CODSTR',
       '' FROM DUAL
);

/*-- SEQ 7471 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DOM ','--','' FROM DUAL
);

/*-- SEQ 7472 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5555,
       'LAY ',
       'DOM ',
       '1 ',
       '0N',
       '',
       '',
       'LAY.CODTAB = DOM.CODARQ(+) AND
LAY.NOMCPO = DOM.NOMCPO(+)',
       '' FROM DUAL
);

/*-- SEQ 7473 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DOM ',
       '--',
       1,
       4,
       'CODARQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Arquivo',
       'Cdigo Arquivo',
       '',
       'CODARQ',
       'F' FROM DUAL
UNION ALL
SELECT 'DOM ',
       '--',
       4,
       1,
       'CODCHR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo~Alfa',
       'Cdigo Alfa',
       '',
       'CODCHR',
       'F' FROM DUAL
UNION ALL
SELECT 'DOM ',
       '--',
       7,
       1,
       'CODIGO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo',
       'Cdigo',
       '',
       'CASE WHEN LTRIM(RTRIM(DOM.CODCHR)) IS NULL THEN TO_CHAR(DOM.CODINT), ''-'' ELSE TO_CHAR(DOM.CODINT), DOM.CODCHR) END',
       'F' FROM DUAL
UNION ALL
SELECT 'DOM ',
       '--',
       3,
       10,
       'CODINT',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo~Numrico',
       'Cdigo Numrico',
       '',
       'CODINT',
       'F' FROM DUAL
UNION ALL
SELECT 'DOM ',
       '--',
       17,
       30,
       'CODSTR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo String',
       'Cdigo String',
       '',
       'CODSTR',
       'F' FROM DUAL
UNION ALL
SELECT 'DOM ',
       '--',
       5,
       30,
       'DESDOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Desc. Dominio',
       'Descrio Domnio',
       '',
       'DESDOM',
       'F' FROM DUAL
UNION ALL
SELECT 'DOM ',
       '--',
       2,
       30,
       'NOMCPO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Campo',
       'Nome do Campo',
       '',
       'NOMCPO',
       'F' FROM DUAL
UNION ALL
SELECT 'DOM ',
       '--',
       6,
       10,
       'SEQUEN',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 7474 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DOMI',
       TO_NUMBER(null),
       'DOMI',
       'Dom. Omnichannel',
       'TD_OMI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DOMI.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7475 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DOMI','--','' FROM DUAL
UNION ALL
SELECT 'DOMI','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DOMI','99','Outros' FROM DUAL
);

/*-- SEQ 7476 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 25958,
       'DFIL',
       'DOMI',
       '1',
       '0N',
       '',
       '',
       'DOMI.CODFIL = DFIL.CODFIL(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 7477 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DOMI',
       '--',
       10,
       5,
       'CODTAB',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo',
       'Cdigo',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'DOMI',
       '--',
       20,
       100,
       'DESOMI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Canal Omnichannel',
       'Descrio do Canal Omnichannel',
       '',
       'DESOMI',
       '' FROM DUAL
UNION ALL
SELECT 'DOMI',
       '--',
       30,
       1,
       'OMIATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       '',
       'Ativo? ',
       'Ativo? ',
       '',
       'OMIATI',
       '' FROM DUAL
UNION ALL
SELECT 'DOMI',
       '--',
       60,
       200,
       'OMICON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Confirm. Resgate DAV',
       'Servio de Confirmao de Resgate de DAV ',
       '',
       'OMICON',
       '' FROM DUAL
UNION ALL
SELECT 'DOMI',
       '--',
       70,
       3,
       'OMIFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL(+) = DOMI.OMIFIL',
       'OMIFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'DOMI',
       '--',
       40,
       200,
       'OMILIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Lista de DAVs',
       'Servio de Lista de DAVs ',
       '',
       'OMILIS',
       '' FROM DUAL
UNION ALL
SELECT 'DOMI',
       '--',
       50,
       200,
       'OMIRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Resgate de DAV',
       'Servio de Resgate de DAV ',
       '',
       'OMIRES',
       '' FROM DUAL
);

/*-- SEQ 7478 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DOP ',
       TO_NUMBER(null),
       'DOP ',
       'Docs. Pagto. (Todos)',
       'TV_DPG',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DOP.CODFIL,DOP.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7479 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DOP ','--','' FROM DUAL
UNION ALL
SELECT 'DOP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DOP ','02','Datas' FROM DUAL
UNION ALL
SELECT 'DOP ','03','Valores' FROM DUAL
UNION ALL
SELECT 'DOP ','04','Pagamento Eletrnico' FROM DUAL
UNION ALL
SELECT 'DOP ','08','Operao Caixa' FROM DUAL
UNION ALL
SELECT 'DOP ','99','Outros' FROM DUAL
);

/*-- SEQ 7480 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 26688,
       'VPGT',
       'DOP ',
       'N',
       '1',
       '',
       '',
       'VPGT.FILDOP = DOP.CODFIL AND
VPGT.SEQDOP = DOP.SEQUEN',
       '(case when DOP.VLRDOC = 0 then 0 else VPGT.VLRPGT / DOP.VLRDOC end)',
       '' FROM DUAL
UNION ALL
SELECT 26689,
       'CTB ',
       'DOP ',
       '1',
       '1',
       '',
       '',
       'dop.filcta = ctb.filcta and
dop.seqcta = ctb.seqcta and
dop.tipcta = ctb.tipcta and
dop.chetro = ctb.chetro',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26690,
       'CLI ',
       'DOP ',
       '01',
       '01',
       '',
       '',
       'CLI.FILCLI(+) = DOP.FILCLI AND
CLI.CODCLI(+) = DOP.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26691,
       'VFD ',
       'DOP ',
       '1',
       '1',
       '',
       '',
       'dop.codfil = vfd.codfil and
dop.sequen = vfd.sequen',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26692,
       'LDOP',
       'DOP ',
       '0N',
       '1',
       '',
       '',
       'DOP.CODFIL = LDOP.FILDOP(+) AND
DOP.SEQUEN = LDOP.SEQDOP(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26693,
       'VEN ',
       'DOP ',
       '1',
       '1',
       '',
       '',
       'DOP.FILVEN = VEN.CODFIL AND
DOP.SEQVEN = VEN.SEQUEN
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26694,
       'VIN ',
       'DOP ',
       '1',
       '1',
       '',
       '',
       'DOP.FILVEN = VIN.CODFIL AND
DOP.SEQVEN = VIN.SEQUEN
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26695,
       'RDP ',
       'DOP ',
       '1',
       'N',
       '',
       '',
       'RDP.CODFIL = DOP.FILRDP AND
RDP.SEQUEN = DOP.SEQRDP',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26696,
       'USU ',
       'DOP ',
       '1',
       'N',
       '',
       '',
       'USU.FILUSU = DOP.FILUSU AND
USU.CODUSU = DOP.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26697,
       'CFG ',
       'DOP ',
       '1',
       '0N',
       '',
       '',
       'CFG.CHETRO = DOP.CHETRO AND
CFG.CHEQUE = DOP.DOMDOP',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26698,
       'CTA ',
       'DOP ',
       '1',
       'N',
       '',
       '',
       'CTA.CODFIL = DOP.FILCTA AND
CTA.SEQUEN = DOP.SEQCTA AND
CTA.TIPCTA = DOP.TIPCTA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26699,
       'CBP ',
       'DOP ',
       '1',
       '0N',
       '',
       '',
       'DOP.FILCPB = CBP.CODFIL AND
DOP.SEQCPB = CBP.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 7481 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DOP ',
       '02',
       35,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(DOP.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '02',
       145,
       4,
       'ANO_DATPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Pagamento',
       'Ano de Pagamento',
       '',
       'TO_CHAR(DOP.DATPGT,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '02',
       30,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '01',
       205,
       20,
       'CHEQUECOMQUEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cheque est c/Quem?',
       'Cheque est c/Quem?',
       '',
       '(CASE WHEN DOP.FILDES IS NULL THEN ''CHEQUE C/ CLIENTE'' ELSE ''CHEQUE C/ LOJA'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '99',
       170,
       1,
       'CHETRO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Cheque Troco?',
       ' cheque troco?',
       '',
       'CHETRO',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '04',
       360,
       48,
       'CODBAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd Barras/Linha Dig',
       'Cdigo de Barras ou Linha Digitvel',
       '',
       'CODBAR',
       '' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '01',
       180,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '99',
       350,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       '' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo origem da filial.',
       'DOP.CODFIL = DFIL.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '01',
       90,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Usurio',
       'Cdigo do Usurio',
       'DOP.FILUSU = USU2.FILUSU(+) AND DOP.CODUSU = USU2.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '--',
       260,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '02',
       140,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data de Pagamento',
       'Data de Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '--',
       270,
       7,
       'DATRET',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Retorno',
       'Data Retorno',
       '',
       'DATRET',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '--',
       280,
       7,
       'DATTRA',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Transmisso',
       'Data Transmisso',
       '',
       'DATTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '01',
       50,
       5,
       'DOMDOP',
       'A',
       'DDOP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDOP.DESDOP',
       'V',
       '',
       'F',
       'A',
       'F',
       'Tipo de Documento',
       'Tipo de Documento',
       'DDOP.CODTAB(+) = DOP.DOMDOP',
       'DOMDOP',
       'T' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '--',
       290,
       1,
       'DUMMY',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DUMMY',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '--',
       300,
       3,
       'FILCBP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Fil Cta Ban Cliente',
       'Filial Conta Bancria do Cliente',
       '',
       'FILCBP',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '01',
       190,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '01',
       100,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial
Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '01',
       200,
       3,
       'FILDES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Entregue na Filial',
       'Filial Destino',
       '',
       'FILDES',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '01',
       210,
       3,
       'FILRDP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial RDP',
       '',
       'FILRDP',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '01',
       80,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '--',
       310,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '99',
       40,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '02',
       33,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(DOP.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '02',
       143,
       2,
       'MES_DATPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Pagamento',
       'Ms de Pagamento',
       '',
       'TO_CHAR(DOP.DATPGT,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '01',
       150,
       25,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'N Documento',
       'N Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '03',
       160,
       1,
       'NUMIMP',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nm. Impresses',
       'Nmero de Impresses',
       '',
       'NUMIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '04',
       370,
       10,
       'NUMREM',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Nmero Remessa',
       'Nmero Remessa',
       '',
       'NUMREM',
       '' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '99',
       130,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(DOP.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '99',
       220,
       4000,
       'OBSINT',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observaes Internas',
       'Observaes Internas',
       '',
       'OBSINT',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '08',
       250,
       4000,
       'OPERACAOCAIXA',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Operao Caixa',
       'Operao Caixa',
       '',
       'RTF2TXT(RTRIM(SUBSTR(OPERACAOCAIXA(''DOP'',DOP.CODFIL,DOP.SEQUEN,NULL,NULL),1,50)))',
       '' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '01',
       350,
       5,
       'PORORI',
       'F',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Portador de origem',
       'Portador de origem',
       '',
       'PORORI',
       '' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '01',
       240,
       50,
       'QUALCHEQUE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Pago com qual Conta?',
       'Com qual Conta Cheque foi pago',
       '',
       '(SELECT CTA.TITCTA FROM TT_CTA CTA WHERE DOP.FILCTA = CTA.CODFIL AND DOP.SEQCTA = CTA.SEQUEN AND CTA.TIPCTA = DOP.TIPCTA)',
       '' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '--',
       320,
       10,
       'SEQCBP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Cd Cta Ban Cliente',
       'Cdifo Conta Bancria Parceiro',
       '',
       'SEQCBP',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '01',
       110,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '--',
       330,
       10,
       'SEQEXC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQEXC',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '01',
       230,
       10,
       'SEQRDP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador RDP',
       '',
       'SEQRDP',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '--',
       340,
       10,
       'SEQVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '03',
       60,
       5,
       'STDDOP',
       'F',
       'DSTD',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSTD.DESSTD',
       'V',
       '',
       'F',
       'A',
       'F',
       'Situao Documento',
       'Situao Documento',
       'DSTD.CODTAB = DOP.STDDOP',
       'STDDOP',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '01',
       120,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo da Conta',
       'Tipo da Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '04',
       380,
       5,
       'TIPTED',
       'S',
       'DTED',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DTED.DESTED',
       'V',
       '',
       '',
       'A',
       '',
       'Finalidade DOC/TED',
       'Finalidade DOC/TED',
       'DTED.CODTAB = DOP.TIPTED',
       'TIPTED',
       'F' FROM DUAL
UNION ALL
SELECT 'DOP ',
       '03',
       70,
       12,
       'VLRDOC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor do Documento',
       'Valor do Documento',
       '',
       'VLRDOC',
       'F' FROM DUAL
);

/*-- SEQ 7482 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DOP ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DOP ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DOP ',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DOP ',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DOP ',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7483 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DOU ',
       TO_NUMBER(null),
       'DOU ',
       'Mdicos(Tab Totali)',
       'TT_DOU',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DOU.CODCRM',
       '' FROM DUAL
);

/*-- SEQ 7484 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DOU ','--','' FROM DUAL
UNION ALL
SELECT 'DOU ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DOU ','99','Outros' FROM DUAL
);

/*-- SEQ 7485 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DOU ',
       '--',
       42,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Atualizado em',
       'Atualizado em',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'DOU ',
       '--',
       1,
       6,
       'CODCRM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'CRM',
       'CRM',
       '',
       'CODCRM',
       'F' FROM DUAL
UNION ALL
SELECT 'DOU ',
       '--',
       12,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'DOU ',
       '--',
       2,
       45,
       'NOMDOU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Medico',
       'Medico',
       '',
       'NOMDOU',
       'F' FROM DUAL
UNION ALL
SELECT 'DOU ',
       '--',
       22,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'DOU ',
       '--',
       32,
       2,
       'UF_CRM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF CRM',
       'Estado CRM',
       '',
       'UF_CRM',
       'F' FROM DUAL
);

/*-- SEQ 7486 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DOUT',
       0,
       'DOUT',
       'Dom. Outros',
       'TD_OUT',
       'F',
       '',
       'TOTALL',
       'Descrio de Outros',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DOUT.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7487 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DOUT','--','' FROM DUAL
);

/*-- SEQ 7488 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DOUT',
       '--',
       50,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da~Tabela',
       'Cdigo da~Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DOUT',
       '--',
       60,
       1,
       'DADREC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Dados Complem.?',
       'dados complementares',
       '',
       'DADREC',
       'F' FROM DUAL
UNION ALL
SELECT 'DOUT',
       '--',
       70,
       20,
       'DESCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'DESCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'DOUT',
       '--',
       30,
       1,
       'OUTATI',
       'L',
       '',
       0,
       0,
       'DOUT',
       30,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'OUTATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DOUT',
       '--',
       90,
       255,
       'OUTIMG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome do cone C4G',
       'Nome do cone para Checkout4G',
       '',
       'OUTIMG',
       '' FROM DUAL
UNION ALL
SELECT 'DOUT',
       '--',
       80,
       1,
       'OUTLET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Letra de atalho C4G',
       'Letra de atalho para Checkout4G',
       '',
       'OUTLET',
       '' FROM DUAL
UNION ALL
SELECT 'DOUT',
       '--',
       100,
       14,
       'OUTLIM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Limite de valores',
       'Limite de valores no caixa',
       '',
       'OUTLIM',
       '' FROM DUAL
UNION ALL
SELECT 'DOUT',
       '--',
       110,
       1,
       'OUTNIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Nvel de Tela',
       'Nvel de Tela',
       '',
       'OUTNIV',
       'T' FROM DUAL
UNION ALL
SELECT 'DOUT',
       '--',
       120,
       15,
       'REGOUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Registrador no ECF',
       'Registrador no ECF',
       '',
       'REGOUT',
       '' FROM DUAL
);

/*-- SEQ 7489 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DOUT',
       'OUTNIV',
       1,
       ' ',
       'Primeiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DOUT',
       'OUTNIV',
       2,
       ' ',
       'Segundo',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7490 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DOW ',
       TO_NUMBER(null),
       'DOW ',
       'Controle Downloads',
       'TT_DOW',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DOW.SEQDOW',
       '' FROM DUAL
);

/*-- SEQ 7491 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DOW ','--','' FROM DUAL
UNION ALL
SELECT 'DOW ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DOW ','99','Outros' FROM DUAL
);

/*-- SEQ 7492 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DOW ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'DOW ',
       '01',
       20,
       3,
       'CODMAQ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Mquina',
       'Cdigo Mquina',
       '',
       'CODMAQ',
       'F' FROM DUAL
UNION ALL
SELECT 'DOW ',
       '01',
       30,
       1,
       'ESTDOW',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Situao Download',
       'Situao do Download(Ativo ou Desativo)',
       '',
       'ESTDOW',
       'F' FROM DUAL
UNION ALL
SELECT 'DOW ',
       '01',
       40,
       1,
       'FREDOW',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Frequncia Download',
       'Frequncia de Download',
       '',
       'FREDOW',
       'F' FROM DUAL
UNION ALL
SELECT 'DOW ',
       '01',
       50,
       7,
       'HORDOW',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Horrio Download',
       'Horrio Download',
       '',
       'HORDOW',
       'F' FROM DUAL
UNION ALL
SELECT 'DOW ',
       '01',
       60,
       5,
       'MODULO',
       'N',
       'DMOD',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOD.MODULO',
       'V',
       '',
       'F',
       'N',
       'F',
       'Mdulo',
       'Listagem de mdulos ',
       'DMOD.CODTAB = DOW.MODULO',
       'MODULO',
       'F' FROM DUAL
UNION ALL
SELECT 'DOW ',
       '01',
       70,
       5,
       'SEQDOW',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Sequenciador Download',
       '',
       'SEQDOW',
       'F' FROM DUAL
UNION ALL
SELECT 'DOW ',
       '01',
       80,
       1,
       'SITDOW',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao Download',
       'Situao Download',
       '',
       'SITDOW',
       'T' FROM DUAL
UNION ALL
SELECT 'DOW ',
       '01',
       90,
       7,
       'ULTDOW',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data ltimo Dowload',
       'Data ltimo Download',
       '',
       'ULTDOW',
       'F' FROM DUAL
UNION ALL
SELECT 'DOW ',
       '01',
       100,
       3,
       'ULTREL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'ltima release',
       'ltima release baixada ',
       '',
       'ULTREL',
       'F' FROM DUAL
UNION ALL
SELECT 'DOW ',
       '01',
       110,
       3,
       'ULTVER',
       'F',
       '',
       1,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'ltima Verso',
       'ltima Verso',
       '',
       'ULTVER',
       'F' FROM DUAL
);

/*-- SEQ 7493 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DOW ',
       'SITDOW',
       0,
       'A',
       'Em andamento: baixando ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DOW ',
       'SITDOW',
       0,
       'D',
       'Disponvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DOW ',
       'SITDOW',
       0,
       'E',
       'Erro',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7494 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DPAG',
       TO_NUMBER(null),
       'DPAG',
       'Pagamento Retroativo',
       'TV_DPAG',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7495 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DPAG','--','' FROM DUAL
UNION ALL
SELECT 'DPAG','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DPAG','02','Datas' FROM DUAL
UNION ALL
SELECT 'DPAG','03','Valores' FROM DUAL
UNION ALL
SELECT 'DPAG','99','Outros' FROM DUAL
);

/*-- SEQ 7496 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 29756,
       'CLI ',
       'DPAG',
       '1',
       'N',
       '',
       '',
       'CLI.FILCLI = DPAG.FILFOR AND
CLI.CODCLI = DPAG.CODFOR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29757,
       'COM ',
       'DPAG',
       '1',
       '0N',
       '',
       '',
       'DPAG.CODFIL = COM.CODFIL AND
DPAG.SEQUEN = COM.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 7497 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DPAG',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL = DPAG.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'DPAG',
       '01',
       20,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Srie',
       'Srie Nota Fiscal de Compra',
       '',
       'CODSER',
       'T' FROM DUAL
UNION ALL
SELECT 'DPAG',
       '02',
       70,
       10,
       'DATCMP',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Compra',
       'Data da Compra',
       '',
       'DATCMP',
       '' FROM DUAL
UNION ALL
SELECT 'DPAG',
       '02',
       110,
       10,
       'DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Referncia Final',
       'Data de Referncia Final',
       '',
       'DATFIM',
       '' FROM DUAL
UNION ALL
SELECT 'DPAG',
       '02',
       100,
       10,
       'DATINI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Referncia Inicial',
       'Data de Referncia Inicial',
       '',
       'DATINI',
       '' FROM DUAL
UNION ALL
SELECT 'DPAG',
       '02',
       80,
       10,
       'DATOPE',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Entrada',
       'Data da Entrada',
       '',
       'DATOPE',
       '' FROM DUAL
UNION ALL
SELECT 'DPAG',
       '02',
       90,
       10,
       'DATVEN',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Vencimento',
       'Data de Vencimento da Parcela',
       '',
       'DATVEN',
       '' FROM DUAL
UNION ALL
SELECT 'DPAG',
       '99',
       120,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'DPAG',
       '99',
       150,
       1,
       'FLGORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Situao Original',
       'Situao Original do Ttulo',
       '',
       'FLGORI',
       'T' FROM DUAL
UNION ALL
SELECT 'DPAG',
       '01',
       40,
       9,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Nota',
       'Nmero da Nota',
       '',
       'NUMNOT',
       '' FROM DUAL
UNION ALL
SELECT 'DPAG',
       '01',
       50,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Nmero Parcela',
       'Nmero da Parcela',
       '',
       'NUMPAR',
       '' FROM DUAL
UNION ALL
SELECT 'DPAG',
       '01',
       60,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Nmero Sub-Parcela',
       'Nmero da Sub-Parcela',
       '',
       'SUBPAR',
       '' FROM DUAL
UNION ALL
SELECT 'DPAG',
       '01',
       30,
       3,
       'SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Sub-Srie',
       'Sub-Srie Nota Fiscal de Compra',
       '',
       'SUBSER',
       '' FROM DUAL
UNION ALL
SELECT 'DPAG',
       '03',
       140,
       12,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Parcela',
       'Valor Parcela',
       '',
       'VLRPAR',
       '' FROM DUAL
UNION ALL
SELECT 'DPAG',
       '03',
       160,
       12,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Pago',
       'Valor Pago',
       '',
       'VLRPGT',
       '' FROM DUAL
);

/*-- SEQ 7498 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DPAG',
       'FLGEST',
       0,
       '1',
       'Programado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DPAG',
       'FLGEST',
       0,
       '2',
       'Autorizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DPAG',
       'FLGEST',
       0,
       'A',
       'A Pagar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DPAG',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DPAG',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DPAG',
       'FLGEST',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DPAG',
       'FLGORI',
       0,
       '1',
       'Programado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DPAG',
       'FLGORI',
       0,
       '2',
       'Autorizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DPAG',
       'FLGORI',
       0,
       'A',
       'A Pagar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DPAG',
       'FLGORI',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DPAG',
       'FLGORI',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DPAG',
       'FLGORI',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7499 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DPAI',
       TO_NUMBER(null),
       'DPAI',
       'Pases do IBGE',
       'TD_PAI',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CODPAI',
       '' FROM DUAL
);

/*-- SEQ 7500 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DPAI','--','' FROM DUAL
UNION ALL
SELECT 'DPAI','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DPAI','99','Outros' FROM DUAL
);

/*-- SEQ 7501 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DPAI',
       '--',
       30,
       8,
       'ATU_EM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data da atualizao',
       'Data da atualizao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'DPAI',
       '--',
       10,
       5,
       'CODPAI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cod. Pas',
       'Cdigo do Pas',
       '',
       'CODPAI',
       'F' FROM DUAL
UNION ALL
SELECT 'DPAI',
       '--',
       20,
       60,
       'DESPAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Pas',
       'Nome do Pas',
       '',
       'DESPAI',
       'F' FROM DUAL
);

/*-- SEQ 7502 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DPER',
       TO_NUMBER(null),
       'DPER',
       'Dom. Perodo Entrega',
       'TD_PER',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7503 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DPER','--','' FROM DUAL
UNION ALL
SELECT 'DPER','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DPER','99','Outros' FROM DUAL
);

/*-- SEQ 7504 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DPER',
       '01',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo',
       'Cdigo',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DPER',
       '01',
       20,
       100,
       'DESPER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Desc. Perdo Entrega',
       'Descrio Perdo Entrega',
       '',
       'DESPER',
       'F' FROM DUAL
UNION ALL
SELECT 'DPER',
       '99',
       30,
       1,
       'PERATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'PERATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DPER',
       '01',
       40,
       2,
       'PERCOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo apresentao',
       'Cdigo para apresentao',
       '',
       'PERCOD',
       'F' FROM DUAL
UNION ALL
SELECT 'DPER',
       '99',
       50,
       4,
       'PERORD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ordem',
       'Ordem',
       '',
       'PERORD',
       'F' FROM DUAL
);

/*-- SEQ 7505 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DPES',
       TO_NUMBER(null),
       'DPES',
       'Dom. Faixas de Peso',
       'TD_PES',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DPES.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7506 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DPES','--','' FROM DUAL
UNION ALL
SELECT 'DPES','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DPES','99','Outros' FROM DUAL
);

/*-- SEQ 7507 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DPES',
       '01',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Cdigo',
       'Cdigo',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'DPES',
       '01',
       20,
       100,
       'DESPES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio',
       'Descrio',
       '',
       'DESPES',
       '' FROM DUAL
UNION ALL
SELECT 'DPES',
       '01',
       30,
       1,
       'PESATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Ativo?',
       '',
       'PESATI',
       '' FROM DUAL
UNION ALL
SELECT 'DPES',
       '--',
       50,
       12,
       'PESFIM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Peso final',
       'Peso final',
       '',
       'PESFIM',
       '' FROM DUAL
UNION ALL
SELECT 'DPES',
       '--',
       40,
       12,
       'PESINI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Peso inicial',
       'Peso inicial',
       '',
       'PESINI',
       '' FROM DUAL
);

/*-- SEQ 7508 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DPGF',
       TO_NUMBER(null),
       'DPGF',
       'Retorno PagFor',
       'TD_PGF',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7509 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DPGF','--','' FROM DUAL
UNION ALL
SELECT 'DPGF','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DPGF','99','Outros' FROM DUAL
);

/*-- SEQ 7510 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 64973,
       'DBCO',
       'DPGF',
       '1 ',
       '0N',
       '',
       '',
       'DBCO.CODTAB = DPGF.CODBCO',
       '',
       '' FROM DUAL
);

/*-- SEQ 7511 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DPGF',
       '--',
       10,
       5,
       'CODBCO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Banco',
       'Banco',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'DPGF',
       '--',
       20,
       10,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo no Banco',
       'Cdigo no Banco',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'DPGF',
       '--',
       30,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo',
       'Cdigo',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DPGF',
       '--',
       40,
       255,
       'MSGRET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem de Retorno',
       'Mensagem de Retorno',
       '',
       'MSGRET',
       'F' FROM DUAL
UNION ALL
SELECT 'DPGF',
       '--',
       70,
       1,
       'PGFATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Retorno Ativo',
       'Retorno Ativo',
       '',
       'PGFATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DPGF',
       '--',
       50,
       1,
       'TIPREG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Tipo do Retorno',
       'Tipo do Retorno',
       '',
       'TIPREG',
       'F' FROM DUAL
UNION ALL
SELECT 'DPGF',
       '--',
       60,
       1,
       'TIPRET',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Registro',
       'Registro',
       '',
       'TIPRET',
       'F' FROM DUAL
);

/*-- SEQ 7512 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DPGF',
       'TIPREG',
       0,
       ' ',
       'HEADER',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DPGF',
       'TIPREG',
       2,
       ' ',
       'INCONSISTNCIA INVALIDA O REG.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DPGF',
       'TIPREG',
       3,
       ' ',
       'CONSISTNCIA TAREFA EXECUTADA',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DPGF',
       'TIPRET',
       1,
       ' ',
       'INCONSISTNCIA NO ARQUIVO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DPGF',
       'TIPRET',
       2,
       ' ',
       'INCONSISTNCIA EM REGISTRO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DPGF',
       'TIPRET',
       3,
       ' ',
       'CONSISTNCIA TAREFA EXECUTADA',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7513 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DPHO',
       0,
       'DPHO',
       'Dom. Fotos',
       'TD_PHO',
       'T',
       '',
       'TOTALL',
       'Outra classificao do filme',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DPHO.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7514 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DPHO','--','' FROM DUAL
UNION ALL
SELECT 'DPHO','01','Identificao' FROM DUAL
);

/*-- SEQ 7515 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5576,
       'IOR ',
       'DPHO',
       'N ',
       '1 ',
       '',
       '',
       'IOR.PHOOUT = DPHO.CODTAB
',
       '' FROM DUAL
UNION ALL
SELECT 5577,
       'PHO ',
       'DPHO',
       'N ',
       '1 ',
       '',
       '',
       'PHO.CODPHO = DPHO.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7516 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DPHO',
       '01',
       10,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DPHO',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DPHO',
       '01',
       70,
       1,
       'PHOATI',
       'L',
       '',
       0,
       0,
       'DPHO',
       20,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'PHOATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DPHO',
       '01',
       80,
       15,
       'PHOOUT',
       'A',
       '',
       0,
       0,
       'DPHO',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Outra classificao',
       'Outra classificao do filme',
       '',
       'PHOOUT',
       'F' FROM DUAL
);

/*-- SEQ 7517 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DPRE',
       0,
       'DPRE',
       'Dom. Pr-Venda',
       'TD_PRE',
       'F',
       '',
       'TOTALL',
       'Pr-Venda',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DPRE.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7518 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DPRE','--','' FROM DUAL
);

/*-- SEQ 7519 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DPRE',
       '--',
       61,
       4000,
       'CABPRE',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       60,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Compat c/ ver ante 1',
       'Compatibilidade com verses anteriores',
       '',
       'RTF2TXT(CABPRE)',
       'F' FROM DUAL
UNION ALL
SELECT 'DPRE',
       '--',
       80,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DPRE',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DPRE',
       '--',
       50,
       30,
       'DESPRE',
       'A',
       '',
       0,
       0,
       'DPRE',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Descrio',
       'Descrio da Pr-Venda',
       '',
       'DESPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'DPRE',
       '--',
       71,
       4000,
       'ITEPRE',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       70,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Compat c/ ver ante 2',
       'Compatibilidade com verses anteriores',
       '',
       'RTF2TXT(ITEPRE)',
       'F' FROM DUAL
UNION ALL
SELECT 'DPRE',
       '--',
       60,
       2,
       'NUMPRE',
       'S',
       '',
       0,
       0,
       'DPRE',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       '',
       'T',
       'Nmero de itens',
       'Nmero de itens da Pr-Venda',
       '',
       'NUMPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'DPRE',
       '--',
       10,
       1,
       'PREATI',
       'L',
       '',
       0,
       0,
       'DPRE',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'PREATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DPRE',
       '--',
       81,
       4000,
       'RODPRE',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Compat c/ ver ante 3',
       'Compatibilidade com verses anteriores',
       '',
       'RTF2TXT(RODPRE)',
       'F' FROM DUAL
UNION ALL
SELECT 'DPRE',
       '--',
       70,
       2,
       'USOPRE',
       'S',
       '',
       0,
       0,
       'DPRE',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       '',
       'T',
       'Uso',
       'Indica se  um Oramento ou um Pedido de Venda',
       '',
       'USOPRE',
       'F' FROM DUAL
);

/*-- SEQ 7520 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DPRI',
       TO_NUMBER(null),
       'DPRI',
       'Dom. Severidades',
       'TD_PRI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DPRI.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7521 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DPRI','--','' FROM DUAL
UNION ALL
SELECT 'DPRI','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DPRI','99','Outros' FROM DUAL
);

/*-- SEQ 7522 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5582,
       'SPT ',
       'DPRI',
       'N ',
       '1 ',
       '',
       '',
       'dpri.codtab = spt.codpri',
       '' FROM DUAL
);

/*-- SEQ 7523 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DPRI',
       '99',
       90,
       10,
       'APEPRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Apelido',
       'Apelido',
       '',
       'APEPRI',
       'F' FROM DUAL
UNION ALL
SELECT 'DPRI',
       '99',
       130,
       12,
       'CARENC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Carncia',
       'Carncia',
       '',
       'CARENC',
       '' FROM DUAL
UNION ALL
SELECT 'DPRI',
       '01',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DPRI',
       '01',
       20,
       100,
       'DESPRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'DESPRI',
       'F' FROM DUAL
UNION ALL
SELECT 'DPRI',
       '99',
       30,
       7,
       'HORPAD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Hora Padro',
       'Hora Padro(Minutos)',
       '',
       'HORPAD',
       'F' FROM DUAL
UNION ALL
SELECT 'DPRI',
       '99',
       40,
       7,
       'HORTRN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Horas Transferncia',
       'Horas Transferncia(Minutos)',
       '',
       'HORTRN',
       'F' FROM DUAL
UNION ALL
SELECT 'DPRI',
       '99',
       50,
       4000,
       'OBSPRI',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSPRI',
       'F' FROM DUAL
UNION ALL
SELECT 'DPRI',
       '99',
       60,
       5,
       'PESPRI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Peso',
       'Peso',
       '',
       'PESPRI',
       'F' FROM DUAL
UNION ALL
SELECT 'DPRI',
       '99',
       70,
       1,
       'PRIATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'PRIATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DPRI',
       '99',
       80,
       1,
       'TIPHOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Hora',
       'Tipo de Hora',
       '',
       'TIPHOR',
       'T' FROM DUAL
UNION ALL
SELECT 'DPRI',
       '99',
       100,
       1,
       'WORPRI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Prioridade~Mnima WF',
       'Prioridade mnima para a tarefa no Workflow',
       '',
       'WORPRI',
       'F' FROM DUAL
);

/*-- SEQ 7524 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DPRI',
       'TIPHOR',
       0,
       'C',
       'Corrida',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DPRI',
       'TIPHOR',
       0,
       'U',
       'Util',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7525 --*/ 
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DREC',
       TO_NUMBER(null),
       'DREC',
       'Receb Retroativo',
       'TV_DREC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7526 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DREC','--','' FROM DUAL
UNION ALL
SELECT 'DREC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DREC','99','Outros' FROM DUAL
);

/*-- SEQ 7527 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 45815,
       'CLI',
       'DREC',
       '1',
       'N',
       '',
       '',
       'DREC.FILCLI = CLI.FILCLI AND
DREC.CODCLI = CLI.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45814,
       'VEN',
       'DREC',
       '1',
       'N',
       '',
       '',
       'DREC.CODFIL = VEN.CODFIL AND
DREC.SEQEUN = VEN.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 7528 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DREC',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '9',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL = DREC.CODFIL',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'DREC',
       '--',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Sequencia',
       '',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'DREC',
       '--',
       30,
       8,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Incluso',
       'Data Incluso',
       '',
       'DATHOR',
       '' FROM DUAL
UNION ALL
SELECT 'DREC',
       '--',
       40,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Serie',
       'Serie',
       '',
       'CODSER',
       '' FROM DUAL
UNION ALL
SELECT 'DREC',
       '--',
       50,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Ecf',
       'Ecf',
       '',
       'NUMECF',
       '' FROM DUAL
UNION ALL
SELECT 'DREC',
       '--',
       60,
       6,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Numero',
       'Numero',
       '',
       'NUMNOT',
       '' FROM DUAL
UNION ALL
SELECT 'DREC',
       '--',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       '',
       'Filial Cliente',
       '',
       '',
       'FILCLI',
       '' FROM DUAL
UNION ALL
SELECT 'DREC',
       '--',
       80,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Cliente',
       '',
       '',
       'CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 'DREC',
       '--',
       90,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Parcela',
       'Parcela',
       '',
       'NUMPAR',
       '' FROM DUAL
UNION ALL
SELECT 'DREC',
       '--',
       100,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sub-Parcela',
       'Sub-Parcela',
       '',
       'SUBPAR',
       '' FROM DUAL
UNION ALL
SELECT 'DREC',
       '--',
       110,
       8,
       'DATVEN',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data~Vencimento',
       'Data Vencimento',
       '',
       'DATVEN',
       '' FROM DUAL
UNION ALL
SELECT 'DREC',
       '--',
       120,
       12,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor~Parcela',
       'Valor Parcela',
       '',
       'VLRPAR',
       '' FROM DUAL
UNION ALL
SELECT 'DREC',
       '--',
       130,
       12,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor~Pago',
       'Valor Pago',
       '',
       'VLRPGT',
       '' FROM DUAL
UNION ALL
SELECT 'DREC',
       '--',
       140,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'DREC',
       '--',
       150,
       1,
       'FLGORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Situao~Atual',
       'Situao Original',
       '',
       'FLGORI',
       'T' FROM DUAL
UNION ALL
SELECT 'DREC',
       '--',
       160,
       8,
       'DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Referencia~Final',
       'Referencia Final',
       '',
       'DATFIM',
       '' FROM DUAL
UNION ALL
SELECT 'DREC',
       '--',
       170,
       8,
       'PAGAME',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data~Pagamento',
       'Data Pagamento',
       '',
       'PAGAME',
       '' 
  FROM DUAL
);

/*-- SEQ 7529 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DREC',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DREC',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DREC',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DREC',
       'FLGEST',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DREC',
       'FLGORI',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DREC',
       'FLGORI',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DREC',
       'FLGORI',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DREC',
       'FLGORI',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7530 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DREG',
       0,
       'DREG',
       'Dom. Regies',
       'TD_REG',
       'T',
       '',
       'TOTALL',
       'Regio',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DREG.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7531 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DREG','--','' FROM DUAL
);

/*-- SEQ 7532 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5585,
       'EDE ',
       'DREG',
       'N ',
       '1 ',
       '',
       '',
       'EDE.REGIAO = DREG.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7533 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DREG',
       '--',
       40,
       5,
       'CEPFIM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cep Final',
       'Cep Final',
       '',
       'CEPFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'DREG',
       '--',
       50,
       5,
       'CEPINI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cep Inicial',
       'Cep Inicial',
       '',
       'CEPINI',
       'F' FROM DUAL
UNION ALL
SELECT 'DREG',
       '--',
       30,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DREG',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DREG',
       '--',
       10,
       1,
       'REGATI',
       'L',
       '',
       0,
       0,
       'DREG',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'REGATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DREG',
       '--',
       20,
       30,
       'REGIAO',
       'A',
       '',
       0,
       0,
       'DREG',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Descrio',
       'Descrio',
       '',
       'REGIAO',
       'F' FROM DUAL
);

/*-- SEQ 7534 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DREL',
       TO_NUMBER(null),
       'DREL',
       'Dom. Releases',
       'TD_REL',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DREL.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7535 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DREL','--','' FROM DUAL
UNION ALL
SELECT 'DREL','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DREL','99','Outros' FROM DUAL
);

/*-- SEQ 7536 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5588,
       'WOR ',
       'DREL',
       'N ',
       '1 ',
       '',
       '',
       'DPRI.CODTAB = WOR.RELWOR',
       '' FROM DUAL
);

/*-- SEQ 7537 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DREL',
       '01',
       10,
       5,
       'CODTAB',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'N',
       '',
       'Cdigo',
       'Cdigo',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'DREL',
       '01',
       30,
       40,
       'DESREL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Release',
       'Release',
       '',
       'DESREL',
       '' FROM DUAL
UNION ALL
SELECT 'DREL',
       '01',
       50,
       5,
       'PRIMAX',
       'G',
       'DPRI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DPRI.DESPRI',
       'V',
       '',
       '',
       'N',
       '',
       'Pri. Mxima',
       'Pri. Mxima',
       'DPRI.CODTAB = DREL.PRIMAX',
       'PRIMAX',
       'T' FROM DUAL
UNION ALL
SELECT 'DREL',
       '01',
       40,
       5,
       'PRIMIN',
       'G',
       'DPRI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DPRI.DESPRI',
       'V',
       '',
       '',
       'N',
       '',
       'Pri. Mnima',
       'Pri. Mnima',
       'DPRI.CODTAB = DREL.PRIMIN',
       'PRIMIN',
       'T' FROM DUAL
UNION ALL
SELECT 'DREL',
       '01',
       20,
       1,
       'RELATI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Ativo?',
       '',
       'RELATI',
       '' FROM DUAL
);

/*-- SEQ 7538 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DREM',
       TO_NUMBER(null),
       'DREM',
       'Dom. Remessas',
       'TD_REM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DREM.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7539 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DREM','--','' FROM DUAL
UNION ALL
SELECT 'DREM','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DREM','99','Outros' FROM DUAL
);

/*-- SEQ 7540 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5589,
       'REM ',
       'DREM',
       'N ',
       '1 ',
       '',
       '',
       'REM.CODREM = DREM.CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 5590,
       'TIT ',
       'DREM',
       'N ',
       '1 ',
       '',
       '',
       'TIT.CODREM = DREM.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7541 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DREM',
       '--',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DREM',
       '--',
       20,
       30,
       'DESREM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Remessa',
       'Descrio da remessa',
       '',
       'DESREM',
       'F' FROM DUAL
UNION ALL
SELECT 'DREM',
       '--',
       30,
       1,
       'REMATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativa?',
       'Ativa?',
       '',
       'REMATI',
       'F' FROM DUAL
);

/*-- SEQ 7542 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DREQ',
       TO_NUMBER(null),
       'DREQ',
       'Tipo de Requisito',
       'TD_REQ',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DREQ.CODTAB
',
       '' FROM DUAL
);

/*-- SEQ 7543 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DREQ','--','' FROM DUAL
UNION ALL
SELECT 'DREQ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DREQ','99','Outros' FROM DUAL
);

/*-- SEQ 7544 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DREQ',
       '--',
       10,
       5,
       'ABRREQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Abreviao',
       'Abreviao',
       '',
       'ABRREQ',
       'F' FROM DUAL
UNION ALL
SELECT 'DREQ',
       '--',
       20,
       1,
       'CLAREQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Classificao',
       'Classificao',
       '',
       'CLAREQ',
       'F' FROM DUAL
UNION ALL
SELECT 'DREQ',
       '01',
       30,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DREQ',
       '--',
       40,
       100,
       'DESREQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'DESREQ',
       'F' FROM DUAL
UNION ALL
SELECT 'DREQ',
       '--',
       50,
       1,
       'REQATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'REQATI',
       'F' FROM DUAL
);

/*-- SEQ 7545 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DREQ',
       'CLAREQ',
       0,
       'C',
       'Cliente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DREQ',
       'CLAREQ',
       0,
       'F',
       'Funcional',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DREQ',
       'CLAREQ',
       0,
       'I',
       'Implantao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DREQ',
       'CLAREQ',
       0,
       'N',
       'No Funcional',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DREQ',
       'CLAREQ',
       0,
       'S',
       'Atendido pelo sistema',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7546 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DRET',
       TO_NUMBER(null),
       'DRET',
       'Dom. Retor.Cob.Banco',
       'TD_RET',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DRET.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7547 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DRET','--','' FROM DUAL
UNION ALL
SELECT 'DRET','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DRET','99','Outros' FROM DUAL
);

/*-- SEQ 7548 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5592,
       'RET ',
       'DRET',
       'N ',
       '1 ',
       '',
       '',
       'RET.CODRET = DRET.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7549 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DRET',
       '--',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DRET',
       '--',
       20,
       30,
       'DESRET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Retorno',
       'Descricao do Retorno',
       '',
       'DESRET',
       'F' FROM DUAL
UNION ALL
SELECT 'DRET',
       '--',
       40,
       1,
       'FLGNEW',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sit Apos Receber',
       'situao aps receber',
       '',
       'FLGNEW',
       'F' FROM DUAL
UNION ALL
SELECT 'DRET',
       '--',
       30,
       1,
       'RETATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'RETATI',
       'F' FROM DUAL
);

/*-- SEQ 7550 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DRGC',
       TO_NUMBER(null),
       'DRGC',
       'Dom. Regras p/ Com.',
       'TD_RGC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DRGC.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7551 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DRGC','--','' FROM DUAL
UNION ALL
SELECT 'DRGC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DRGC','99','Outros' FROM DUAL
);

/*-- SEQ 7552 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DRGC',
       '01',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Cdigo~Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'DRGC',
       '01',
       20,
       100,
       'DESRGC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio Regra',
       'Descrio da regra para comercializao',
       '',
       'DESRGC',
       '' FROM DUAL
UNION ALL
SELECT 'DRGC',
       '99',
       50,
       1,
       'FLGDEV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Permite~Devoluo?',
       'Permite Devoluo?',
       '',
       'FLGDEV',
       '' FROM DUAL
UNION ALL
SELECT 'DRGC',
       '99',
       40,
       1,
       'FLGENC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Somente~Encomenda?',
       'Somente Encomenda?',
       '',
       'FLGENC',
       '' FROM DUAL
UNION ALL
SELECT 'DRGC',
       '99',
       30,
       1,
       'RGCATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Ativo?',
       '',
       'RGCATI',
       '' FROM DUAL
UNION ALL
SELECT 'DRGC',
       '99',
       60,
       1,
       'RGC_TIPENT',
       'A',
       'DENT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       'DENT.DESENT',
       'V',
       '',
       '',
       'A',
       '',
       'Tipo de Entrega',
       'Tipo de Entrega',
       'DENT.TIPENT = DRGC.RGC_TIPENT(+)',
       'RGC_TIPENT',
       'T' FROM DUAL
);

/*-- SEQ 7553 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DRGC',
       'RGC_TIPENT',
       0,
       '0',
       'Cliente Leva',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DRGC',
       'RGC_TIPENT',
       0,
       '1',
       'Depsito Entrega',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DRGC',
       'RGC_TIPENT',
       0,
       '2',
       'Loja Entrega',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DRGC',
       'RGC_TIPENT',
       0,
       '3',
       'Retira no Depsito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DRGC',
       'RGC_TIPENT',
       0,
       '4',
       'Em Outra Loja',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DRGC',
       'RGC_TIPENT',
       0,
       '5',
       'Entrega Futura',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DRGC',
       'RGC_TIPENT',
       0,
       '6',
       'Apenas Oramento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DRGC',
       'RGC_TIPENT',
       0,
       '7',
       'Venda sob Encomenda',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7554 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DRO ',
       TO_NUMBER(null),
       'DRO ',
       'Medicamentos',
       'TT_DRO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DRO.CODDRO',
       '' FROM DUAL
);

/*-- SEQ 7555 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DRO ','--','' FROM DUAL
UNION ALL
SELECT 'DRO ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DRO ','99','Outros' FROM DUAL
);

/*-- SEQ 7556 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DRO ',
       '--',
       1,
       8,
       'CODDRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo',
       'Cdigo da Tabela',
       '',
       'CODDRO',
       'F' FROM DUAL
UNION ALL
SELECT 'DRO ',
       '--',
       2,
       300,
       'DESDRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio da Tabela',
       '',
       'DESDRO',
       'F' FROM DUAL
);

/*-- SEQ 7557 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DROS',
       0,
       'DROS',
       'Dom. Resultados O.S.',
       'TD_ROS',
       'T',
       '',
       'TOTALL',
       'Resultados de O.S.',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DROS.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7558 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DROS','--','' FROM DUAL
);

/*-- SEQ 7559 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5599,
       'COS ',
       'DROS',
       'N ',
       '1 ',
       '',
       '',
       'TT_COS.CODROS = TD_ROS.CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 5600,
       'IOR ',
       'DROS',
       'N ',
       '1 ',
       '',
       '',
       'IOR.RESULT = DROS.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7560 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DROS',
       '--',
       30,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DROS',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DROS',
       '--',
       20,
       15,
       'RESULT',
       'A',
       '',
       0,
       0,
       'DROS',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Resultado de OS',
       'Resultado de O.S.',
       '',
       'RESULT',
       'F' FROM DUAL
UNION ALL
SELECT 'DROS',
       '--',
       10,
       1,
       'ROSATI',
       'L',
       '',
       0,
       0,
       'DROS',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'ROSATI',
       'F' FROM DUAL
);

/*-- SEQ 7561 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DRTT',
       TO_NUMBER(null),
       'DRTT',
       'Dom. Tt. Terceiros',
       'TD_RTT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DRTT.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7562 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DRTT','--','' FROM DUAL
UNION ALL
SELECT 'DRTT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DRTT','99','Outros' FROM DUAL
);

/*-- SEQ 7563 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 24577,
       'CTA ',
       'DRTT',
       '1',
       '0N',
       '',
       '',
       'DRTT.FILCTA_DRTT = CTA.CODFIL AND
DRTT.SEQCTA_DRTT = CTA.SEQUEN AND
DRTT.TIPCTA_DRTT = CTA.TIPCTA',
       '',
       '' FROM DUAL
);

/*-- SEQ 7564 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DRTT',
       '--',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Tabela',
       'Cdigo Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DRTT',
       '--',
       20,
       100,
       'DESRTT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome P/ Rece Tit Ter',
       'Nome do Convnio p/ Recebimento Ttulos Terceiros',
       '',
       'DESRTT',
       'F' FROM DUAL
UNION ALL
SELECT 'DRTT',
       '--',
       40,
       3,
       'FILCTA_DRTT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Conta Gerenci',
       'Filial da Conta Gerencial',
       '',
       'FILCTA_DRTT',
       'F' FROM DUAL
UNION ALL
SELECT 'DRTT',
       '--',
       80,
       3,
       'FILCTA_EST_DRTT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Conta Estorno',
       ' Filial da Conta Gerencial do Estorno',
       '',
       'FILCTA_EST_DRTT',
       'F' FROM DUAL
UNION ALL
SELECT 'DRTT',
       '--',
       50,
       1,
       'RTTATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'RTTATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DRTT',
       '--',
       130,
       200,
       'RTTBAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Expresso cd. barra',
       'Expresso regular do formato do cdigo de barras',
       '',
       'RTTBAR',
       '' FROM DUAL
UNION ALL
SELECT 'DRTT',
       '--',
       110,
       200,
       'RTTDIG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Expresso barra dig.',
       'Expresso regular do formato da barra digitvel',
       '',
       'RTTDIG',
       '' FROM DUAL
UNION ALL
SELECT 'DRTT',
       '--',
       30,
       1,
       'RTTEST',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Estornvel?',
       'Estornvel?',
       '',
       'RTTEST',
       'F' FROM DUAL
UNION ALL
SELECT 'DRTT',
       '--',
       120,
       1,
       'RTTTEF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Operao por TEF',
       'Operao on-Line via TEF',
       '',
       'RTTTEF',
       '' FROM DUAL
UNION ALL
SELECT 'DRTT',
       '--',
       140,
       1,
       'RTTTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Tp. corresp. banco',
       'Tipo do correspondente bancrio',
       '',
       'RTTTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'DRTT',
       '--',
       60,
       10,
       'SEQCTA_DRTT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Seq. Conta Gerencial',
       'Sequenciador da Conta Gerencial',
       '',
       'SEQCTA_DRTT',
       'F' FROM DUAL
UNION ALL
SELECT 'DRTT',
       '--',
       90,
       10,
       'SEQCTA_EST_DRTT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Seq. Conta Estorno',
       'Sequenciador da Conta Gerencial do Estorno',
       '',
       'SEQCTA_EST_DRTT',
       'F' FROM DUAL
UNION ALL
SELECT 'DRTT',
       '--',
       70,
       1,
       'TIPCTA_DRTT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo da Conta Gerenc',
       'Tipo da Conta Gerencial',
       '',
       'TIPCTA_DRTT',
       'F' FROM DUAL
UNION ALL
SELECT 'DRTT',
       '--',
       100,
       1,
       'TIPCTA_EST_DRTT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Conta Estorno',
       'Tipo da Conta Gerencial do Estorno',
       '',
       'TIPCTA_EST_DRTT',
       'F' FROM DUAL
);

/*-- SEQ 7565 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DRTT',
       'RTTTIP',
       0,
       ' ',
       'No Identificado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DRTT',
       'RTTTIP',
       1,
       ' ',
       'Ttulo ou Boleto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DRTT',
       'RTTTIP',
       2,
       ' ',
       'gua, Luz ou Telefone',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DRTT',
       'RTTTIP',
       3,
       ' ',
       'Estacionamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DRTT',
       'RTTTIP',
       4,
       ' ',
       'Agncia de Carga',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7566 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DRU ',
       TO_NUMBER(null),
       'DRU ',
       'Drogas em Uso',
       'TT_DRU',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DRU.CODFIL,DRU.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7567 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DRU ','--','' FROM DUAL
UNION ALL
SELECT 'DRU ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DRU ','99','Outros' FROM DUAL
);

/*-- SEQ 7568 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5602,
       'DRO ',
       'DRU ',
       'N ',
       '1 ',
       '',
       '',
       'DRU.CODDRO = DRO.CODDRO',
       '' FROM DUAL
UNION ALL
SELECT 5603,
       'CLI ',
       'DRU ',
       'N ',
       '1 ',
       '',
       '',
       'CLI.FILCLI = DRU.FILCLI AND
CLI.CODCLI = DRU.CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 5604,
       'USU ',
       'DRU ',
       'N ',
       '1 ',
       '',
       '',
       'USU.FILUSU = DRU.FILUSU AND
USU.CODUSU = DRU.CODUSU',
       '' FROM DUAL
);

/*-- SEQ 7569 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DRU ',
       '--',
       1,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'ltima atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'DRU ',
       '--',
       2,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'DRU ',
       '--',
       3,
       8,
       'CODDRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo',
       'Cdigo da Droga',
       '',
       'CODDRO',
       'F' FROM DUAL
UNION ALL
SELECT 'DRU ',
       '--',
       4,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Usurio logado',
       'DOE.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'DRU ',
       '--',
       5,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo do Usurio',
       'Cdigo do Usurio',
       'DOE.FILUSU = USU.FILUSU(+)  AND DOE.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'DRU ',
       '--',
       6,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'DRU ',
       '--',
       7,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Usurio que alterou o registro.',
       '',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'DRU ',
       '--',
       8,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 7570 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DSAD',
       TO_NUMBER(null),
       'DSAD',
       'Dom Serv. Adicionais',
       'TD_SAD',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DSAD.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7571 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DSAD','--','' FROM DUAL
UNION ALL
SELECT 'DSAD','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DSAD','99','Outros' FROM DUAL
);

/*-- SEQ 7572 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 47843,
       'SADC',
       'DSAD',
       '01',
       '1',
       '',
       '',
       'DSAD.CODTAB = SADC.CODTAB(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 47036,
       'DRTT',
       'DSAD',
       '01',
       '0N',
       '',
       '',
       'DSAD.CODRTT = DRTT.CODTAB(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 7573 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DSAD',
       '99',
       140,
       8,
       'ACRMAX',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Acrscimo mximo',
       'Acrscimo mximo',
       '',
       'ACRMAX',
       '' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '99',
       60,
       5,
       'CODRTT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Convnio recebimento',
       'Convnio para recebimento',
       '',
       'CODRTT',
       '' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '01',
       10,
       5,
       'CODTAB',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo',
       'Cdigo',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '99',
       130,
       8,
       'DESMIN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Desconto mximo',
       'Desconto mximo',
       '',
       'DESMIN',
       '' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '01',
       20,
       100,
       'DESSAD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio',
       'Descrio',
       '',
       'DESSAD',
       '' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '99',
       210,
       5,
       'DIARES',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Dias p/ restituio',
       'Dias limite para restituio integral',
       '',
       'DIARES',
       '' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '99',
       180,
       1,
       'FLGPES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Pessoa',
       'Tipo de Pessoa ao qual se Aplica o Servio',
       '',
       'FLGPES',
       'T' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '99',
       240,
       4000,
       'FORCAN_CK4G',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Formato Imp Canc',
       'Formato de Impresso de Cancelamento (para CheckOut 4G)',
       '',
       'FORCAN_CK4G',
       '' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '99',
       80,
       4000,
       'FORIMP',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Frmula p impresso',
       'Frmula para impresso',
       '',
       'RTF2TXT(FORIMP)',
       '' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '99',
       230,
       4000,
       'FORIMP_CK4G',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Formato de Impresso',
       'Formato de Impresso (para CheckOut 4G)',
       '',
       'FORIMP_CK4G',
       '' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '99',
       220,
       4000,
       'FORNUM_CK4G',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Frmula do Numerador',
       'Frmula do Numerador (para CheckOut 4G)',
       '',
       'RTF2TXT(FORNUM_CK4G)',
       '' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '99',
       70,
       1,
       'IMPDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Imprime documento?',
       'Imprime documento?',
       '',
       'IMPDOC',
       '' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '99',
       120,
       10,
       'NUMINI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Num ini control serv',
       'Nmero inicial do controle do servio',
       '',
       'NUMINI',
       '' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '99',
       200,
       6,
       'PERCOM_DSAD',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Percentual Comisso',
       'Percentual de Comisso',
       '',
       'PERCOM_DSAD',
       '' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '99',
       170,
       5,
       'PERIOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% de IOF',
       '% de IOF',
       '',
       'PERIOF',
       '' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '99',
       160,
       5,
       'PERSAD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '% sobre Preo Total',
       '% sobre Preo Total para Venda Avulsa',
       '',
       'PERSAD',
       '' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '99',
       190,
       254,
       'REPSAD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Arquivo de relatrio',
       'Nome do arquivo de relatrio',
       '',
       'REPSAD',
       '' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '99',
       30,
       1,
       'SADATI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Ativo?',
       '',
       'SADATI',
       '' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '99',
       110,
       1,
       'SOMGAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Soma garantia?',
       'Soma garantia na cobertura?',
       '',
       'SOMGAR',
       '' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '99',
       40,
       1,
       'SUGORC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Sugere ao orar?',
       'Sugere ao orar?',
       '',
       'SUGORC',
       '' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '99',
       90,
       1,
       'TIPVAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo Tempo Val Serv',
       'Tipo do Tempo de Validade do Servio',
       '',
       'TIPVAL',
       'T' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '99',
       100,
       5,
       'VALIDA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Garantia/Validade',
       'Garantia/Validade',
       '',
       'VALIDA',
       '' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '99',
       150,
       12,
       'VALSAD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Valor do Servio R$',
       'Valor do Servio (em R$) para Venda Avulsa',
       '',
       'VALSAD',
       '' FROM DUAL
UNION ALL
SELECT 'DSAD',
       '99',
       50,
       1,
       'VENAVU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Para venda avulsa?',
       'Para venda avulsa (sem vnculo com mercadoria)',
       '',
       'VENAVU',
       '' FROM DUAL
);

/*-- SEQ 7574 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DSAD',
       'FLGPES',
       0,
       'A',
       'Ambos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSAD',
       'FLGPES',
       0,
       'F',
       'Pessoa Fsica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSAD',
       'FLGPES',
       0,
       'J',
       'Pessoa Jurdica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSAD',
       'TIPVAL',
       1,
       ' ',
       'Dias',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSAD',
       'TIPVAL',
       2,
       ' ',
       'Meses',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSAD',
       'TIPVAL',
       0,
       ' ',
       'No Controla',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSAD',
       'TIPVAL',
       3,
       ' ',
       'Anos',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7575 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DSAT',
       TO_NUMBER(null),
       'DSAT',
       'Dom. Aparelhos SAT',
       'TD_SAT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7576 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DSAT','--','' FROM DUAL
UNION ALL
SELECT 'DSAT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DSAT','99','Outros' FROM DUAL
);

/*-- SEQ 7577 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DSAT',
       '--',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'N',
       'F',
       'Cdigo',
       'Cdigo',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DSAT',
       '--',
       20,
       40,
       'DESSAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'DESSAT',
       'F' FROM DUAL
UNION ALL
SELECT 'DSAT',
       '--',
       30,
       1,
       'SATATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'SATATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DSAT',
       '--',
       40,
       5,
       'SAT_CNT_RO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'CRO',
       'Contador de Reincio de Operao',
       '',
       'SAT_CNT_RO',
       'F' FROM DUAL
UNION ALL
SELECT 'DSAT',
       '--',
       50,
       3,
       'SAT_CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = DSAT.SAT_CODFIL',
       'SAT_CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'DSAT',
       '--',
       60,
       2,
       'SAT_CODSER',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Srie',
       'DSER.CODSER = DSAT.SAT_CODSER',
       'SAT_CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'DSAT',
       '--',
       70,
       9,
       'SAT_NUMSER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero de Srie',
       'Nmero de Srie (sem dgito)',
       '',
       'SAT_NUMSER',
       'F' FROM DUAL
);

/*-- SEQ 7578 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DSAZ',
       0,
       'DSAZ',
       'Dom. Sazonalidades',
       'TD_SAZ',
       'T',
       '',
       'TOTALL',
       'Sazonalidades',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DSAZ.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7579 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DSAZ','--','' FROM DUAL
);

/*-- SEQ 7580 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5605,
       'PRO ',
       'DSAZ',
       'N ',
       '1 ',
       '',
       '',
       'PRO.CODSAZ = DSAZ.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7581 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DSAZ',
       '--',
       150,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DSAZ',
       150,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DSAZ',
       '--',
       20,
       20,
       'DESSAZ',
       'A',
       '',
       0,
       0,
       'DSAZ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Descrio',
       'Descrio da Sazonalidade',
       '',
       'DESSAZ',
       'F' FROM DUAL
UNION ALL
SELECT 'DSAZ',
       '--',
       30,
       8,
       'SAZ001',
       'F',
       '',
       2,
       0,
       'DSAZ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Saz. Janeiro',
       'Tabela de sazonalidade ms de Janeiro',
       '',
       'SAZ001',
       'F' FROM DUAL
UNION ALL
SELECT 'DSAZ',
       '--',
       40,
       8,
       'SAZ002',
       'F',
       '',
       2,
       0,
       'DSAZ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Saz. Fevereiro',
       'Tabela de sazonalidade ms de Fevereiro',
       '',
       'SAZ002',
       'F' FROM DUAL
UNION ALL
SELECT 'DSAZ',
       '--',
       50,
       8,
       'SAZ003',
       'F',
       '',
       2,
       0,
       'DSAZ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Saz. Maro',
       'Tabela de sazonalidade ms de Maro',
       '',
       'SAZ003',
       'F' FROM DUAL
UNION ALL
SELECT 'DSAZ',
       '--',
       60,
       8,
       'SAZ004',
       'F',
       '',
       2,
       0,
       'DSAZ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Saz. Abril',
       'Tabela de sazonalidade ms de Abril',
       '',
       'SAZ004',
       'F' FROM DUAL
UNION ALL
SELECT 'DSAZ',
       '--',
       70,
       8,
       'SAZ005',
       'F',
       '',
       2,
       0,
       'DSAZ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Saz. Maio',
       'Tabela de sazonalidade ms de Maio',
       '',
       'SAZ005',
       'F' FROM DUAL
UNION ALL
SELECT 'DSAZ',
       '--',
       80,
       8,
       'SAZ006',
       'F',
       '',
       2,
       0,
       'DSAZ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Saz. Junho',
       'Tabela de sazonalidade ms de Junho',
       '',
       'SAZ006',
       'F' FROM DUAL
UNION ALL
SELECT 'DSAZ',
       '--',
       90,
       8,
       'SAZ007',
       'F',
       '',
       2,
       0,
       'DSAZ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Saz. Julho',
       'Tabela de sazonalidade ms de Julho',
       '',
       'SAZ007',
       'F' FROM DUAL
UNION ALL
SELECT 'DSAZ',
       '--',
       100,
       8,
       'SAZ008',
       'F',
       '',
       2,
       0,
       'DSAZ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Saz. Agosto',
       'Tabela de sazonalidade ms de Agosto',
       '',
       'SAZ008',
       'F' FROM DUAL
UNION ALL
SELECT 'DSAZ',
       '--',
       110,
       8,
       'SAZ009',
       'F',
       '',
       2,
       0,
       'DSAZ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Saz. Setembro',
       'Tabela de sazonalidade ms de Setembro',
       '',
       'SAZ009',
       'F' FROM DUAL
UNION ALL
SELECT 'DSAZ',
       '--',
       120,
       8,
       'SAZ010',
       'F',
       '',
       2,
       0,
       'DSAZ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Saz. Outubro',
       'Tabela de sazonalidade ms de Outubro',
       '',
       'SAZ010',
       'F' FROM DUAL
UNION ALL
SELECT 'DSAZ',
       '--',
       130,
       8,
       'SAZ011',
       'F',
       '',
       2,
       0,
       'DSAZ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Saz. Novembro',
       'Tabela de sazonalidade ms de Novembro',
       '',
       'SAZ011',
       'F' FROM DUAL
UNION ALL
SELECT 'DSAZ',
       '--',
       140,
       8,
       'SAZ012',
       'F',
       '',
       2,
       0,
       'DSAZ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Saz. Dezembro',
       'Tabela de sazonalidade ms de Dezembro',
       '',
       'SAZ012',
       'F' FROM DUAL
UNION ALL
SELECT 'DSAZ',
       '--',
       10,
       1,
       'SAZATI',
       'L',
       '',
       0,
       0,
       'DSAZ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'SAZATI',
       'F' FROM DUAL
);

/*-- SEQ 7582 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DSC ',
       TO_NUMBER(null),
       'DSC ',
       'Desconto por Cliente',
       'TT_DESXCLI',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7583 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DSC ','--','' FROM DUAL
UNION ALL
SELECT 'DSC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DSC ','99','Outros' FROM DUAL
);

/*-- SEQ 7584 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 128998,
       'DCL1',
       'DSC ',
       '01',
       '0N',
       '',
       '',
       'DSC.CLASS1 = DCL1.CODTAB (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 128999,
       'DCL2',
       'DSC ',
       '01',
       '0N',
       '',
       '',
       'DSC.CLASS2 = DCL2.CODTAB (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 129000,
       'DCL3',
       'DSC ',
       '01',
       '0N',
       '',
       '',
       'DSC.CLASS3 = DCL3.CODTAB (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 129001,
       'DCL4',
       'DSC ',
       '01',
       '0N',
       '',
       '',
       'DSC.CLASS4 = DCL4.CODTAB (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 128048,
       'CLI ',
       'DSC ',
       '0N',
       '1',
       '',
       '',
       'DSC.FILCLI = CLI.FILCLI AND
DSC.CODCLI = CLI.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 11460,
       'VIPR',
       'DSC ',
       '01',
       '0N',
       '',
       '',
       'DSC.FILMAT = VIPR.FILMAT(+) AND
DSC.CODMAT = VIPR.CODMAT(+) AND
DSC.CODCOR = VIPR.CODCOR(+) AND
DSC.CODTAM = VIPR.CODTAM(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 7585 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'DSC ',
       '99',
       180,
       14,
       'ACORDO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Valor Acordado',
       'Valor Acordado',
       '',
       'ACORDO',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'DSC ',
       '--',
       150,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Ultima atualizao',
       'Ultima atualizao',
       '',
       'ATU_EM',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'DSC ',
       '99',
       10,
       5,
       'CLASS1',
       'S',
       'DCL1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL1.CLASS1',
       'V',
       '',
       '',
       'N',
       'F',
       'Categoria',
       'Categoria',
       'DCL1.CODTAB = DSC.CLASS1',
       'CLASS1',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'DSC ',
       '99',
       20,
       5,
       'CLASS2',
       'S',
       'DCL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL2.CLASS2',
       'V',
       '',
       '',
       'N',
       'F',
       'SubCategoria',
       'Sub-Categoria',
       'DCL2.CODTAB = DSC.CLASS2',
       'CLASS2',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'DSC ',
       '99',
       30,
       5,
       'CLASS3',
       'S',
       'DCL3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL3.CLASS3',
       'V',
       '',
       '',
       'N',
       'F',
       'Familia',
       'Famlia',
       'DCL3.CODTAB = DSC.CLASS3',
       'CLASS3',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DSC ',
       '99',
       40,
       5,
       'CLASS4',
       'S',
       'DCL4',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL4.CLASS4',
       'V',
       '',
       '',
       'N',
       'F',
       'SubFamilia',
       'Sub-Famlia',
       'DCL4.CODTAB = DSC.CLASS4',
       'CLASS4',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'DSC ',
       '01',
       50,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'DSC ',
       '99',
       60,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       '',
       'N',
       'F',
       'Diviso',
       'Diviso',
       'DIV.CODITE = DSC.CODCOR',
       'CODCOR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DSC ',
       '99',
       70,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Material',
       'Cdigo do Material',
       '',
       'CODMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DSC ',
       '99',
       160,
       3,
       'CODPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Cdigo do Plano',
       'Cdigo do Plano',
       '',
       'CODPGT',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'DSC ',
       '99',
       80,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       '',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso',
       'SUB.CODITE = DSC.CODTAM',
       'CODTAM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DSC ',
       '99',
       200,
       8,
       'DATVAL',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data de Validade',
       'Data de Validade',
       '',
       'DATVAL',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'DSC ',
       '01',
       90,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial do Cliente',
       'Filial do Cliente',
       'DFIL.CODFIL = DSC.FILCLI',
       'FILCLI',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'DSC ',
       '99',
       100,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial do Material',
       'Filial do Material',
       '',
       'FILMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DSC ',
       '99',
       170,
       3,
       'FILPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial do Plano',
       'Filial do Plano',
       '',
       'FILPGT',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'DSC ',
       '99',
       110,
       3,
       'FILVEN',
       'A',
       'FIL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'FIL2.CODFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial da Venda',
       'Filial da Venda',
       'FIL2.CODFIL(+) = DSC.FILVEN',
       'FILVEN',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'DSC ',
       '99',
       120,
       6,
       'PERDES',
       'F',
       '',
       3,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% de desconto',
       'Percentual de desconto',
       '',
       'PERDES',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'DSC ',
       '01',
       130,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DSC ',
       '99',
       190,
       1,
       'TIPACO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo de Acordo',
       'Tipo de Acordo',
       '',
       'TIPACO',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'DSC ',
       '99',
       121,
       12,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor de desconto',
       'Valor de desconto',
       '',
       'VLRDES',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'DSC ',
       '99',
       140,
       12,
       'VLRVEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Vendas de no Mnimo',
       'Vendas de no Mnimo',
       '',
       'VLRVEN',
       'F',
       'P' FROM DUAL
);

/*-- SEQ 7586 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DSC ',
       'TIPACO',
       0,
       'F',
       'Valor Fixo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSC ',
       'TIPACO',
       0,
       'P',
       '% Desconto/Acrescimo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSC ',
       'TIPACO',
       0,
       'V',
       'Valor de Desconto/Acrescimo',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7587 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DSER',
       0,
       'DSER',
       'Dom. Sries',
       'TD_SER',
       'F',
       '',
       'TOTALL',
       'Sries',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DSER.CODSER',
       '' FROM DUAL
);

/*-- SEQ 7588 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DSER','--','' FROM DUAL
);

/*-- SEQ 7589 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DSER',
       '--',
       20,
       2,
       'CODSER',
       'A',
       '',
       0,
       0,
       'DSER',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Srie',
       'Cdigo da srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       150,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DSER',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       30,
       25,
       'DESSER',
       'A',
       '',
       0,
       0,
       'DSER',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Descrio',
       'Descrio da srie',
       '',
       'DESSER',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       50,
       10,
       'DISSAI',
       'A',
       '',
       0,
       0,
       'DSER',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Sada em',
       'Dispositivo de sada',
       '',
       'DISSAI',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       171,
       1,
       'DIVTRO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       170,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Dividir em 2 NFs?',
       'Define se a troca ser dividida em 2 NFs',
       '',
       'DIVTRO',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       310,
       1,
       'ENVNFS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Enviar NFSe?',
       'Enviar NFSe?',
       '',
       'ENVNFS',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       40,
       2,
       'EXTNOT',
       'S',
       '',
       0,
       0,
       'DSER',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       '',
       'T',
       'Largura do extenso',
       'Tamanho do extenso da N.F.',
       '',
       'EXTNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       60,
       1,
       'IMPNOT',
       'L',
       '',
       0,
       0,
       'DSER',
       60,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Impresso On-Line?',
       'Imprime nota On Line ? (S/N)',
       '',
       'IMPNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       221,
       2,
       'MODNOT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Modelo de Nota',
       'Modelo da Nota',
       '',
       'MODNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       211,
       3,
       'OBSCOL',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       210,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nro de Colunas',
       'Nmero de colunas no formulrio de NF para observao',
       '',
       'OBSCOL',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       201,
       3,
       'OBSLIN',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       200,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nro de linhas',
       'Nro de linhas no formulrio de NF para observao',
       '',
       'OBSLIN',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       120,
       2,
       'QTDITP',
       'S',
       '',
       0,
       0,
       'DSER',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       '',
       'T',
       'N de itens produto',
       'Quantidade de Itens de Produto',
       '',
       'QTDITP',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       130,
       2,
       'QTDITS',
       'S',
       '',
       0,
       0,
       'DSER',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       '',
       'T',
       'N de itens servio',
       'Quantidade de Itens de Servio',
       '',
       'QTDITS',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       300,
       1,
       'RECIBO',
       'L',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Recibo Provisrio?',
       'Recibo Provisrio?',
       '',
       'RECIBO',
       '' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       161,
       1,
       'RESTRI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       160,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Uso restrito?',
       'Define se a srie  de uso restrito de alguns usurios',
       '',
       'RESTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       10,
       1,
       'SERATI',
       'L',
       '',
       0,
       0,
       'DSER',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'SERATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       320,
       2,
       'SERCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Srie Cont. NFCe',
       'Srie de Contingncia de NFCe',
       '',
       'SERCON',
       '' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       261,
       1,
       'SERDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de documento',
       'Tipo de documento',
       '',
       'SERDOC',
       'T' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       271,
       3,
       'SEREXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Srie Fis. Exportada',
       'Srie Fiscal Exportada',
       '',
       'SEREXT',
       '' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       191,
       6,
       'SERFIM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       190,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Mximo de Notas',
       'Nmero mximo de notas (em caso de numereo manual)',
       '',
       'SERFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       181,
       6,
       'SERINI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       180,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Mnimo de Notas',
       'Nmero mnimo de nota (em caso de numerao manual)',
       '',
       'SERINI',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       140,
       1,
       'SERMAN',
       'L',
       '',
       0,
       0,
       'DSER',
       90,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Exige numerao man.',
       'Srie com numerao manual',
       '',
       'SERMAN',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       251,
       1,
       'SERORD',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Visualizar no Order?',
       'Visualizar no Order?',
       '',
       'SERORD',
       '' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       291,
       2,
       'SERREM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie de Remessa',
       'Srie de Remessa',
       '',
       'SERREM',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       241,
       1,
       'SERUTL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Serie disponivel p/',
       'Serie disponivel p/',
       '',
       'SERUTL',
       '' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       231,
       1,
       'TITAVU',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Ut. p/ Ttulo Avulso',
       'Utilizada para ttulo avulso?',
       '',
       'TITAVU',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       131,
       4000,
       'TXTENT',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       130,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Texto no meio da NF',
       'Texto para ser impresso entre os itens de servio e de produto na NF',
       '',
       'RTF2TXT(TXTENT)',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       151,
       4000,
       'TXTFIM',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       150,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Texto no final da NF',
       'Texto para ser impresso no final da NF',
       '',
       'RTF2TXT(TXTFIM)',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       111,
       4000,
       'TXTINI',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       110,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Texto no incio NF',
       'Texto para ser impresso no incio da NF',
       '',
       'RTF2TXT(TXTINI)',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       121,
       4000,
       'TXTITE',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       120,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Texto no Item da NF',
       'Texto para ser impresso no item de produto da NF',
       '',
       'RTF2TXT(TXTITE)',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       281,
       4000,
       'TXTOBS',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Texto da Observao',
       'Texto da Observao',
       '',
       'TXTOBS',
       'F' FROM DUAL
UNION ALL
SELECT 'DSER',
       '--',
       141,
       4000,
       'TXTSER',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       140,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Texto no servio NF',
       'Texto para ser impresso no item de servio da NF',
       '',
       'RTF2TXT(TXTSER)',
       'F' FROM DUAL
);

/*-- SEQ 7590 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DSER',
       'SERDOC',
       0,
       'A',
       'CF e NF',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSER',
       'SERDOC',
       0,
       'C',
       'CF',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSER',
       'SERDOC',
       0,
       'F',
       'NF',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSER',
       'SERDOC',
       0,
       'N',
       'No informado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSER',
       'SERUTL',
       0,
       'A',
       'ECF de Administrao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSER',
       'SERUTL',
       0,
       'L',
       'ECF de Loja',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSER',
       'SERUTL',
       0,
       'Q',
       'Qualquer',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7591 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DSET',
       0,
       'DSET',
       'Dom. Setor',
       'TD_SET',
       'T',
       '',
       'TOTALL',
       'Setor',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DSET.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7592 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DSET','--','' FROM DUAL
);

/*-- SEQ 7593 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5606,
       'PRJ ',
       'DSET',
       'N ',
       '1 ',
       '',
       '',
       'prj.codfil = dset.filset and
prj.sequen = dset.prjset',
       '' FROM DUAL
);

/*-- SEQ 7594 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DSET',
       '--',
       10,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DSET',
       '--',
       30,
       15,
       'DESSET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'DESSET',
       'F' FROM DUAL
UNION ALL
SELECT 'DSET',
       '--',
       40,
       3,
       'FILSET',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = DSET.FILSET',
       'FILSET',
       'F' FROM DUAL
UNION ALL
SELECT 'DSET',
       '--',
       50,
       10,
       'PRJSET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Projeto Setor',
       'Projeto Setor',
       '',
       'PRJSET',
       'F' FROM DUAL
UNION ALL
SELECT 'DSET',
       '--',
       20,
       1,
       'SETATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Ativo?',
       'Ativo',
       '',
       'SETATI',
       'F' FROM DUAL
);

/*-- SEQ 7595 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DSIM',
       TO_NUMBER(null),
       'DSIM',
       'Dom. Part. Sim Nacio',
       'TD_SIM',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7596 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DSIM','--','' FROM DUAL
UNION ALL
SELECT 'DSIM','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DSIM','99','Outros' FROM DUAL
);

/*-- SEQ 7597 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DSIM',
       '--',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DSIM',
       '--',
       20,
       5,
       'PERICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% ICMS',
       '% ICMS',
       '',
       'PERICM',
       'F' FROM DUAL
UNION ALL
SELECT 'DSIM',
       '--',
       30,
       12,
       'VLRFIM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Receita Bruta Final',
       'Receita Bruta Final',
       '',
       'VLRFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'DSIM',
       '--',
       40,
       12,
       'VLRINI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Receita Bruta Inicia',
       'Receita Bruta Inicial',
       '',
       'VLRINI',
       'F' FROM DUAL
);

/*-- SEQ 7598 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DSIT',
       TO_NUMBER(null),
       'DSIT',
       'Dom. Situaes',
       'TD_SIT',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DSIT.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7599 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DSIT','--','' FROM DUAL
UNION ALL
SELECT 'DSIT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DSIT','99','Outros' FROM DUAL
);

/*-- SEQ 7600 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 30370,
       'WOR ',
       'DSIT',
       'N ',
       '1 ',
       '',
       '',
       'DSIT.CODTAB = WOR.FLGSIT',
       '' FROM DUAL
);

/*-- SEQ 7601 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DSIT',
       '01',
       10,
       5,
       'CODTAB',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'N',
       '',
       'Cdigo',
       'Cdigo',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'DSIT',
       '01',
       30,
       40,
       'DESSIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Situao',
       'Descrio da situao',
       '',
       'DESSIT',
       '' FROM DUAL
UNION ALL
SELECT 'DSIT',
       '01',
       70,
       1,
       'FLGMOD',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Ap. p/ resp. mdulo?',
       'Aparecer para responsvel pelo mdulo?',
       '',
       'FLGMOD',
       '' FROM DUAL
UNION ALL
SELECT 'DSIT',
       '01',
       60,
       1,
       'FLGREG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Ap. p/ registrador?',
       'Aparecer para registrador?',
       '',
       'FLGREG',
       '' FROM DUAL
UNION ALL
SELECT 'DSIT',
       '01',
       40,
       1,
       'FLGRES',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Ap. p/ responsvel?',
       'Aparecer para responsvel?
',
       '',
       'FLGRES',
       '' FROM DUAL
UNION ALL
SELECT 'DSIT',
       '01',
       50,
       1,
       'FLGREV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Ap. p/ revisor?',
       'Aparecer para revisor?',
       '',
       'FLGREV',
       '' FROM DUAL
UNION ALL
SELECT 'DSIT',
       '01',
       100,
       1,
       'GER_CC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Ger. Conta Corrente',
       'Gerar conta corrente?',
       '',
       'GER_CC',
       '' FROM DUAL
UNION ALL
SELECT 'DSIT',
       '01',
       20,
       1,
       'SITATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Ativo?',
       'Ativo?',
       '',
       'SITATI',
       '' FROM DUAL
UNION ALL
SELECT 'DSIT',
       '01',
       110,
       4000,
       'SITMAI',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail p/ alt. sit.',
       'E-mail para notificar alterao de situao',
       '',
       'SITMAI',
       'F' FROM DUAL
UNION ALL
SELECT 'DSIT',
       '01',
       80,
       1,
       'TIPADO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Avaliado',
       'Avaliado',
       '',
       'TIPADO',
       'F' FROM DUAL
UNION ALL
SELECT 'DSIT',
       '01',
       90,
       1,
       'TIPSIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo da Situao',
       'Tipo da Situao',
       '',
       'TIPSIT',
       'F' FROM DUAL
);

/*-- SEQ 7602 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DSIT',
       'TIPSIT',
       0,
       '1',
       'Revisado e Aprovado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSIT',
       'TIPSIT',
       0,
       '2',
       'Revisado com Erros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSIT',
       'TIPSIT',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSIT',
       'TIPSIT',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSIT',
       'TIPSIT',
       0,
       'E',
       'Em Espera',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSIT',
       'TIPSIT',
       0,
       'I',
       'A Integrar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSIT',
       'TIPSIT',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSIT',
       'TIPSIT',
       0,
       'R',
       'A Classificar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSIT',
       'TIPSIT',
       0,
       'S',
       'Suspenso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSIT',
       'TIPSIT',
       0,
       'X',
       'Executado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7603 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DSP ',
       TO_NUMBER(null),
       'DSP ',
       'Desp. Operacionais',
       'TT_DSP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DSP.CODFIL,DSP.SEQUEN
DSP.FILPRE,DSP.CODPRE,DSP.TABELA,DSP.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7604 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DSP ','--','' FROM DUAL
UNION ALL
SELECT 'DSP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DSP ','02','Datas' FROM DUAL
UNION ALL
SELECT 'DSP ','03','Valores' FROM DUAL
UNION ALL
SELECT 'DSP ','99','Outros' FROM DUAL
);

/*-- SEQ 7605 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 40610,
       'TPR ',
       'DSP ',
       '0N',
       '01',
       '',
       '',
       'TPR.CODFIL = DSP.FILPRE(+) AND
TPR.CODPRE = DSP.CODPRE(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 7606 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DSP ',
       '02',
       40,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Atualizado em',
       'Atualizado em',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'DSP ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL = DSP.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'DSP ',
       '01',
       60,
       5,
       'CODPRE',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo da Tab. Preo',
       'Cdigo da Tabela de Preo',
       '',
       'CODPRE',
       '' FROM DUAL
UNION ALL
SELECT 'DSP ',
       '01',
       80,
       5,
       'CODTAB',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo',
       'Cdigo',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'DSP ',
       '02',
       30,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data de Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'DSP ',
       '01',
       110,
       40,
       'DESTAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio Tabela',
       'Descrio na Tabela (Cdigo do Departamento ou Classe)',
       '',
       'DescricaoDespesasOperacionais(DSP.TABELA, DSP.CODTAB)',
       '' FROM DUAL
UNION ALL
SELECT 'DSP ',
       '01',
       50,
       3,
       'FILPRE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial da Tab. Preo',
       'Filial da Tabela de Preo',
       'DFIL.CODFIL = DSP.FILPRE',
       'FILPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'DSP ',
       '03',
       90,
       5,
       'PERFIX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% de Despesa Fixa',
       '% de Despesa Fixa',
       '',
       'PERFIX',
       '' FROM DUAL
UNION ALL
SELECT 'DSP ',
       '03',
       100,
       5,
       'PERVAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% de Despesa Varive',
       '% de Despesa Varivel',
       '',
       'PERVAR',
       '' FROM DUAL
UNION ALL
SELECT 'DSP ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'DSP ',
       '01',
       70,
       12,
       'TABELA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tabela',
       'Tabela',
       '',
       'TABELA',
       'T' FROM DUAL
);

/*-- SEQ 7607 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DSP ',
       'TABELA',
       0,
       ' ',
       'Classe 4',
       TO_NUMBER(null),
       'TD_CL4' FROM DUAL
UNION ALL
SELECT 'DSP ',
       'TABELA',
       0,
       ' ',
       'Departamento',
       TO_NUMBER(null),
       'TD_DEP' FROM DUAL
UNION ALL
SELECT 'DSP ',
       'TABELA',
       0,
       ' ',
       'Classe 1',
       TO_NUMBER(null),
       'TD_CL1' FROM DUAL
UNION ALL
SELECT 'DSP ',
       'TABELA',
       0,
       ' ',
       'Classe 2',
       TO_NUMBER(null),
       'TD_CL2' FROM DUAL
UNION ALL
SELECT 'DSP ',
       'TABELA',
       0,
       ' ',
       'Classe 3',
       TO_NUMBER(null),
       'TD_CL3' FROM DUAL
);

/*-- SEQ 7608 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DSTD',
       TO_NUMBER(null),
       'DSTD',
       'Dom. Situao Docs',
       'TD_STD',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DSTD.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7609 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DSTD','--','' FROM DUAL
);

/*-- SEQ 7610 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5611,
       'DOP ',
       'DSTD',
       'N ',
       '1 ',
       '',
       '',
       'DOP.DOMDOP = DSTD.DOMDOP AND
DOP.STDDOP = DSTD.CODTAB AND
DOP.FLGEST = DSTD.USOSTD',
       '' FROM DUAL
);

/*-- SEQ 7611 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DSTD',
       '--',
       1,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DSTD',
       '--',
       4,
       30,
       'DESSTD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao',
       'Descrio Documento',
       '',
       'DESSTD',
       'F' FROM DUAL
UNION ALL
SELECT 'DSTD',
       '--',
       2,
       5,
       'DOMDOP',
       'F',
       'DDOP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDOP.DESDOP',
       'I',
       '',
       'T',
       '',
       'F',
       'Documento Pagamento',
       'Documento Pagamento',
       'DDOP. = DSTD.DOMDOP',
       'DOMDOP',
       'F' FROM DUAL
UNION ALL
SELECT 'DSTD',
       '--',
       15,
       1,
       'FLGFLX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Reflexo Fluxo Caixa',
       'Reflexo Fluxo de Caixa',
       '',
       'FLGFLX',
       'T' FROM DUAL
UNION ALL
SELECT 'DSTD',
       '--',
       3,
       1,
       'STDATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'STDATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DSTD',
       '--',
       5,
       1,
       'USOSTD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Estado',
       'Estado',
       '',
       'USOSTD',
       'T' FROM DUAL
);

/*-- SEQ 7612 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DSTD',
       'FLGFLX',
       0,
       'A',
       'A Realizar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSTD',
       'FLGFLX',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSTD',
       'FLGFLX',
       0,
       'R',
       'Realizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSTD',
       'USOSTD',
       0,
       'A',
       'Ativo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSTD',
       'USOSTD',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7613 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DSTF',
       TO_NUMBER(null),
       'DSTF',
       'Dom. ST Frete',
       'TD_STF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DSTF.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7614 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DSTF','--','' FROM DUAL
UNION ALL
SELECT 'DSTF','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DSTF','99','Outros' FROM DUAL
);

/*-- SEQ 7615 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 30266,
       'CLI ',
       'DSTF',
       '1',
       'N',
       '',
       '',
       'CLI.FILCLI = DSTF.STF_FILFOR AND
CLI.CODCLI = DSTF.STF_CODFOR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30267,
       'CTA ',
       'DSTF',
       '1',
       'N',
       '',
       '',
       'CTA.CODFIL = DSTF.FILCTA AND
CTA.SEQUEN = DSTF.SEQCTA AND
CTA.TIPCTA = DSTF.TIPCTA',
       '',
       '' FROM DUAL
);

/*-- SEQ 7616 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DSTF',
       '01',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Cdigo~Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'DSTF',
       '01',
       20,
       100,
       'DESSTF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio',
       'Descrio',
       '',
       'DESSTF',
       '' FROM DUAL
UNION ALL
SELECT 'DSTF',
       '01',
       30,
       1,
       'STFATI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Ativo?',
       'Ativo?',
       '',
       'STFATI',
       '' FROM DUAL
UNION ALL
SELECT 'DSTF',
       '--',
       170,
       5,
       'STF_CODCFO',
       'S',
       'DCFO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCFO.DESCFO',
       'V',
       '',
       '',
       'N',
       '',
       'Descrio~CFOP',
       'Descrio da CFOP',
       'DSTF.STF_CODCFO = DCFO.CODTAB(+)',
       'STF_CODCFO',
       'T' FROM DUAL
UNION ALL
SELECT 'DSTF',
       '--',
       150,
       5,
       'STF_CODCTR',
       'S',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       '',
       'N',
       '',
       'Unidade~Negcio',
       'Unidade de Negcio',
       'DSTF.STF_CODCTR = DCTR.CODTAB',
       'STF_CODCTR',
       'T' FROM DUAL
UNION ALL
SELECT 'DSTF',
       '--',
       160,
       5,
       'STF_CODCUS',
       'S',
       'DCUS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCUS.CENCUS',
       'V',
       '',
       '',
       'N',
       '',
       'Centro~Custo',
       'Centro de Custo',
       'DSTF.STF_CODCUS = DCUS.CODTAB',
       'STF_CODCUS',
       'T' FROM DUAL
UNION ALL
SELECT 'DSTF',
       '--',
       90,
       1,
       'STF_CODDAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Modelo DAR',
       'Modelo do Documento de Arrecadao Referenciado',
       '',
       'STF_CODDAR',
       'T' FROM DUAL
UNION ALL
SELECT 'DSTF',
       '--',
       50,
       6,
       'STF_CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo~Fornecedor',
       'Cdigo do Fornecedor',
       '',
       'STF_CODFOR',
       '' FROM DUAL
UNION ALL
SELECT 'DSTF',
       '--',
       140,
       2,
       'STF_CODFPS',
       'A',
       'DFPS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFPS.DESFPS',
       'V',
       '',
       '',
       'A',
       '',
       'Finalidade~Com/Fret',
       'Finalidade do Compromisso/Frete',
       'DSTF.STF_CODFPS = DFPS.CODFPS',
       'STF_CODFPS',
       'T' FROM DUAL
UNION ALL
SELECT 'DSTF',
       '--',
       60,
       2,
       'STF_CODSER',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       '',
       'Srie',
       'Srie',
       'DSTF.STF_CODSER = DSER.CODSER',
       'STF_CODSER',
       'T' FROM DUAL
UNION ALL
SELECT 'DSTF',
       '--',
       100,
       5,
       'STF_CODSET',
       'S',
       'DSET',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSET.DESSET',
       'V',
       '',
       '',
       'N',
       '',
       'Setor',
       'Setor',
       'DSTF.STF_CODSET = DSET.CODTAB',
       'STF_CODSET',
       'T' FROM DUAL
UNION ALL
SELECT 'DSTF',
       '--',
       80,
       2,
       'STF_DIAVEN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Dia~Vencimento',
       'Dia para Vencimento',
       '',
       'STF_DIAVEN',
       '' FROM DUAL
UNION ALL
SELECT 'DSTF',
       '--',
       110,
       3,
       'STF_FILCTA',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial~Conta',
       'Filial da Conta',
       'DSTF.STF_FILCTA = DFIL.CODFIL',
       'STF_FILCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'DSTF',
       '--',
       40,
       3,
       'STF_FILFOR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial~Fornecedor',
       'Filial do Fornecedor',
       'DSTF.STF_FILFOR = DFIL.CODFIL',
       'STF_FILFOR',
       'T' FROM DUAL
UNION ALL
SELECT 'DSTF',
       '--',
       120,
       10,
       'STF_SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq.~Conta',
       'Sequenciador da Conta',
       '',
       'STF_SEQCTA',
       '' FROM DUAL
UNION ALL
SELECT 'DSTF',
       '--',
       70,
       3,
       'STF_SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Sub-srie',
       'Sub-srie',
       '',
       'STF_SUBSER',
       '' FROM DUAL
UNION ALL
SELECT 'DSTF',
       '--',
       130,
       1,
       'STF_TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       '',
       'Tipo~Conta',
       'Tipo da Conta',
       '',
       'STF_TIPCTA',
       'T' FROM DUAL
);

/*-- SEQ 7617 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DSTF',
       'STF_CODDAR',
       0,
       '0',
       'Documento Estadual Arrecadao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSTF',
       'STF_CODDAR',
       0,
       '1',
       'GNRE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSTF',
       'STF_TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSTF',
       'STF_TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSTF',
       'STF_TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7618 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DSTR',
       TO_NUMBER(null),
       'DSTR',
       'Sit. do Requisito',
       'TD_STR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DSTR.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7619 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DSTR','--','' FROM DUAL
UNION ALL
SELECT 'DSTR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DSTR','99','Outros' FROM DUAL
);

/*-- SEQ 7620 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DSTR',
       '01',
       10,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DSTR',
       '--',
       20,
       100,
       'DESSTR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'DESSTR',
       'F' FROM DUAL
UNION ALL
SELECT 'DSTR',
       '--',
       30,
       1,
       'FLGSTR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGSTR',
       'F' FROM DUAL
UNION ALL
SELECT 'DSTR',
       '--',
       40,
       1,
       'STRATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       ' Ativo?',
       ' Ativo?',
       '',
       'STRATI',
       'F' FROM DUAL
);

/*-- SEQ 7621 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DSTR',
       'FLGSTR',
       0,
       '1',
       'Aprovado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSTR',
       'FLGSTR',
       0,
       '2',
       'Rejeitado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSTR',
       'FLGSTR',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSTR',
       'FLGSTR',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSTR',
       'FLGSTR',
       0,
       'E',
       'Enviado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DSTR',
       'FLGSTR',
       0,
       'S',
       'Suspenso',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7622 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DSUB',
       0,
       'DSUB',
       'Dom. Sub-Diviso',
       'TD_SUB',
       'T',
       '',
       'TOTALL',
       'Grade - Subdivises',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DSUB.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7623 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DSUB','--','' FROM DUAL
);

/*-- SEQ 7624 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5612,
       'SUB ',
       'DSUB',
       'N ',
       '1 ',
       '',
       '',
       'SUB.CODITE = DSUB.CODSAL AND
SUB.CODSUB = DSUB.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7625 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DSUB',
       '--',
       5,
       5,
       'CODSAL',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cd. Saldo Unificado',
       'Cdigo Saldo Unificado no Item',
       '',
       'CODSAL',
       'F' FROM DUAL
UNION ALL
SELECT 'DSUB',
       '--',
       30,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DSUB',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DSUB',
       '--',
       20,
       20,
       'NOMSUB',
       'A',
       '',
       0,
       0,
       'DSUB',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Nome',
       'Nome',
       '',
       'NOMSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'DSUB',
       '--',
       40,
       2,
       'ORDSUB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DSUB',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Ordem',
       'Ordem',
       '',
       'ORDSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'DSUB',
       '--',
       10,
       1,
       'SUBATI',
       'L',
       '',
       0,
       0,
       'DSUB',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'SUBATI',
       'F' FROM DUAL
);

/*-- SEQ 7626 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DTAN',
       TO_NUMBER(null),
       'DTAN',
       'Tanques',
       'TD_TAN',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DTAN.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7627 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DTAN','--','' FROM DUAL
UNION ALL
SELECT 'DTAN','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DTAN','99','Outros' FROM DUAL
);

/*-- SEQ 7628 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 64972,
       'GRA ',
       'DTAN',
       '1',
       '1',
       '',
       '',
       'DTAN.GRAFIL = GRA.FILMAT AND DTAN.GRACOD = GRA.CODMAT AND
DTAN.GRACOR = GRA.CODCOR AND DTAN.GRATAM = GRA.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 7629 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DTAN',
       '01',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DTAN',
       '01',
       20,
       3,
       'FILTAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Filial',
       '',
       'FILTAN',
       'F' FROM DUAL
UNION ALL
SELECT 'DTAN',
       '01',
       30,
       5,
       'GRACOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Grade',
       'Cdigo Grade',
       '',
       'GRACOD',
       'F' FROM DUAL
UNION ALL
SELECT 'DTAN',
       '01',
       40,
       5,
       'GRACOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Diviso',
       'Diviso',
       '',
       'GRACOR',
       'F' FROM DUAL
UNION ALL
SELECT 'DTAN',
       '01',
       50,
       3,
       'GRAFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Grade',
       'Filial Grade',
       '',
       'GRAFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'DTAN',
       '01',
       60,
       5,
       'GRATAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Sub-Diviso',
       '',
       '',
       'GRATAM',
       'F' FROM DUAL
UNION ALL
SELECT 'DTAN',
       '01',
       90,
       12,
       'PRECAL',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Pr-Calculo Combus.',
       'Valor para pr-clculo do combustvel',
       '',
       'PRECAL',
       'F' FROM DUAL
UNION ALL
SELECT 'DTAN',
       '01',
       100,
       12,
       'QTDLTS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Capacidade do Tanque',
       'Capacidade do Tanque (em Litros)',
       '',
       'QTDLTS',
       '' FROM DUAL
UNION ALL
SELECT 'DTAN',
       '01',
       70,
       1,
       'TANATV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'TANATV',
       'F' FROM DUAL
UNION ALL
SELECT 'DTAN',
       '01',
       80,
       2,
       'TANQUE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero do tanque',
       'Nmero do tanque',
       '',
       'TANQUE',
       'F' FROM DUAL
);

/*-- SEQ 7630 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DTCC',
       0,
       'DTCC',
       'Dom. TEF - Crdito',
       'TD_TCC',
       'F',
       '',
       'TOTALL',
       'TEF - Cartes de Crdito',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DTCC.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7631 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DTCC','--','' FROM DUAL
);

/*-- SEQ 7632 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DTCC',
       '--',
       40,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DTCC',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DTCC',
       '--',
       10,
       1,
       'TCCATI',
       'L',
       '',
       0,
       0,
       'DTCC',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'TCCATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DTCC',
       '--',
       30,
       8,
       'TEFJRC',
       'F',
       '',
       2,
       0,
       'DTCC',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Taxa de juros',
       'Taxa de juros',
       '',
       'TEFJRC',
       'F' FROM DUAL
UNION ALL
SELECT 'DTCC',
       '--',
       20,
       2,
       'TEFPRC',
       'S',
       '',
       0,
       0,
       'DTCC',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       '',
       'T',
       'N de parcelas',
       'Nmero de parcelas',
       '',
       'TEFPRC',
       'F' FROM DUAL
);

/*-- SEQ 7633 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DTCD',
       0,
       'DTCD',
       'Dom. TEF - Dbito',
       'TD_TCD',
       'F',
       '',
       'TOTALL',
       'TEF - Cartes de Dbito',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DTCD.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7634 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DTCD','--','' FROM DUAL
);

/*-- SEQ 7635 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DTCD',
       '--',
       50,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DTCD',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DTCD',
       '--',
       10,
       1,
       'TCDATI',
       'L',
       '',
       0,
       0,
       'DTCD',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'TCDATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DTCD',
       '--',
       40,
       1,
       'TEFENT',
       'L',
       '',
       0,
       0,
       'DTCD',
       40,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Entrada?',
       'Com entrada?',
       '',
       'TEFENT',
       'F' FROM DUAL
UNION ALL
SELECT 'DTCD',
       '--',
       30,
       8,
       'TEFJRD',
       'F',
       '',
       2,
       0,
       'DTCD',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'T',
       '',
       'T',
       'Taxa de juros',
       'Taxa de Juros',
       '',
       'TEFJRD',
       'F' FROM DUAL
UNION ALL
SELECT 'DTCD',
       '--',
       20,
       2,
       'TEFPRO',
       'S',
       '',
       0,
       0,
       'DTCD',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TAB',
       'F',
       '',
       'T',
       'N de parcelas',
       'Nmero de parcelas',
       '',
       'TEFPRO',
       'F' FROM DUAL
);

/*-- SEQ 7636 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DTED',
       TO_NUMBER(null),
       'DTED',
       'Finalidade DOC/TED',
       'TD_TED',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DTED.DESTED',
       '' FROM DUAL
);

/*-- SEQ 7637 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DTED','--','' FROM DUAL
UNION ALL
SELECT 'DTED','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DTED','99','Outros' FROM DUAL
);

/*-- SEQ 7638 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DTED',
       '01',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Cdigo',
       'Cdigo da tabela',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'DTED',
       '01',
       20,
       100,
       'DESTED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio da tabela',
       '',
       'DESTED',
       'F' FROM DUAL
UNION ALL
SELECT 'DTED',
       '01',
       30,
       1,
       'TEDATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'TEDATI',
       'F' FROM DUAL
);

/*-- SEQ 7639 --*/
INSERT INTO TT_ARQ(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,
       DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
       VALUES('DTER',
              null,
              'DTER',
              'Terminais',
              'TD_TER',
              'F',
              '',
              'TOTALL',
              '',
              '',
              '',
              '',
              '',
              'T',
              '',
              'DTER.CODTAB',
              '');
/*-- SEQ 7640 --*/
INSERT INTO TT_GRU ( CODTAB, CODGRU, DESGRU)
       VALUES ('DTER','--','');

/*-- SEQ 7641 --*/
INSERT INTO TT_GRU ( CODTAB, CODGRU, DESGRU)
       VALUES ('DTER','01','Identificao');

/*-- SEQ 7642 --*/
INSERT INTO TT_GRU ( CODTAB, CODGRU, DESGRU)
       VALUES ('DTER','99','Outros');
/*-- SEQ 7643 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DTER',
              '--',
              10,
              5,
              'CODTAB',
              'S',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              '',
              '',
              '',
              'N',
              'F',
              'Cdigo',
              'Cdigo',
              '',
              'CODTAB',
              'F');
/*-- SEQ 7644 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DTER',
              '--',
              20,
              3,
              'FILTER',
              'A',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'A',
              '',
              '',
              'A',
              'F',
              'Filial do Terminal',
              'Filial do Terminal',
              '',
              'FILTER',
              'F');
/*-- SEQ 7645 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DTER',
              '--',
              30,
              1,
              'TERATI',
              'L',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'Y',
              '',
              '',
              'A',
              'F',
              'Ativo ?',
              'Ativo ?',
              '',
              'TERATI',
              'F');
/*-- SEQ 7646 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DTER',
              '--',
              70,
              5,
              'TERCTR',
              'S',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'I',
              '',
              '',
              'N',
              'F',
              'Unidade de Negcio ',
              'Unidade de Negcio do Terminal',
              '',
              'TERCTR',
              'F');
/*-- SEQ 7647 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DTER',
              '--',
              60,
              1,
              'TERVEN',
              'L',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'Y',
              '',
              '',
              'A',
              'F',
              'Exige vendedor ?',
              'Terminal exige vendedor?',
              '',
              'TERVEN',
              'F');
/*-- SEQ 7648 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DTER',
              '--',
              50,
              15,
              'TER_IP',
              'A',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'A',
              '',
              '',
              'A',
              'F',
              'Ip do terminal',
              'Ip do terminal',
              '',
              'TER_IP',
              'F');

/*-- SEQ 7649 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DTIP',
       0,
       'DTIP',
       'Dom. Tipo do Filme',
       'TD_TIP',
       'F',
       '',
       'TOTALL',
       'Tipo do Filme',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DTIP.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7650 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DTIP','--','' FROM DUAL
);

/*-- SEQ 7651 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DTIP',
       '--',
       10,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DTIP',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DTIP',
       '--',
       40,
       15,
       'PHOTIP',
       'A',
       '',
       0,
       0,
       'DTIP',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Tipo de filme',
       'Tipo do filme',
       '',
       'PHOTIP',
       'F' FROM DUAL
UNION ALL
SELECT 'DTIP',
       '--',
       30,
       1,
       'TIPATI',
       'L',
       '',
       0,
       0,
       'DTIP',
       20,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'TAB',
       'F',
       '',
       'T',
       'Ativo?',
       'Ativo',
       '',
       'TIPATI',
       'F' FROM DUAL
);

/*-- SEQ 7652 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DTRI',
       TO_NUMBER(null),
       'DTRI',
       'Dom. Cod. Tributrio',
       'TD_TRI',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'DTRI.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7653 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DTRI','--','' FROM DUAL
);

/*-- SEQ 7654 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DTRI',
       '--',
       10,
       5,
       'CODTAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'DTRI',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DTRI',
       '--',
       20,
       20,
       'CODTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'DTRI',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Cdigo Tributrio',
       'Cdigo Tributrio',
       '',
       'CODTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'DTRI',
       '--',
       30,
       1,
       'TRIATI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'DTRI',
       30,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'T',
       'Ativo',
       'Ativo',
       '',
       'TRIATI',
       'F' FROM DUAL
);

/*-- SEQ 7655 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DTXI',
       TO_NUMBER(null),
       'DTXI',
       'Tipo Intermediador',
       'TD_TIPXINT',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DTXI.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7656 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DTXI','--','' FROM DUAL
UNION ALL
SELECT 'DTXI','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DTXI','02','Datas' FROM DUAL
UNION ALL
SELECT 'DTXI','99','Outros' FROM DUAL
);

/*-- SEQ 7657 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DTXI',
       '02',
       30,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Atualizao',
       'Data de atualizao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'DTXI',
       '01',
       10,
       10,
       'CODTAB',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo Tabela',
       'Cdigo da tabela',
       '',
       'CODTAB',
       'T' FROM DUAL
UNION ALL
SELECT 'DTXI',
       '02',
       20,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Incluso',
       'Data de incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'DTXI',
       '01',
       40,
       100,
       'DESTIPXINT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio',
       'Descrio',
       '',
       'DESTIPXINT',
       '' FROM DUAL
);

/*-- SEQ 7658 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DTXI',
       'CODTAB',
       0,
       '0',
       'No Definido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DTXI',
       'CODTAB',
       0,
       '1',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DTXI',
       'CODTAB',
       0,
       '2',
       'Totall Mobi',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DTXI',
       'CODTAB',
       0,
       '3',
       'SkyHub',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DTXI',
       'CODTAB',
       0,
       '4',
       'Mercos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DTXI',
       'CODTAB',
       0,
       '5',
       'E-Commerce',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7659 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DVCR',
       TO_NUMBER(null),
       'DVCR',
       'Dom. Cores Veculos',
       'TD_VCR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'dvcr.codtab',
       '' FROM DUAL
);

/*-- SEQ 7660 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DVCR','--','' FROM DUAL
UNION ALL
SELECT 'DVCR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DVCR','99','Outros' FROM DUAL
);

/*-- SEQ 7661 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DVCR',
       '--',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DVCR',
       '--',
       20,
       1,
       'CORATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Cor Ativa?',
       'Cor Ativa?',
       '',
       'CORATI',
       'F' FROM DUAL
UNION ALL
SELECT 'DVCR',
       '--',
       30,
       30,
       'DESCOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Cor',
       'Descricao da Cor',
       '',
       'DESCOR',
       'F' FROM DUAL
);

/*-- SEQ 7662 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DVEI',
       TO_NUMBER(null),
       'DVEI',
       'Dom. de Veculos',
       'TD_VEI',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'dvei.codtab',
       '' FROM DUAL
);

/*-- SEQ 7663 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DVEI','--','' FROM DUAL
);

/*-- SEQ 7664 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22040,
       'DMDV',
       'DVEI',
       '01',
       '1',
       '',
       '',
       'DMTD.CODTAB = DVEI.CODMTD(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 7665 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'DVEI',
       '--',
       15,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DVEI',
       '--',
       12,
       3,
       'CAPMAX',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Capacidade Mxima',
       'Capacidade Mxima',
       '',
       'CAPMAX',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DVEI',
       '--',
       7,
       5,
       'CODFRE',
       'S',
       'DFRE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFRE.DESFRE',
       'V',
       '',
       '',
       'N',
       '',
       'Pol. Frete Oramento',
       'Poltica de Frete para Oramento',
       'DVEI.CODFRE = DFRE.CODTAB(+)',
       'CODFRE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DVEI',
       '--',
       8,
       5,
       'CODMTD',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo da Montadora',
       'Cdigo da Montadora',
       '',
       'CODMTD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DVEI',
       '--',
       1,
       5,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DVEI',
       '--',
       11,
       1,
       'CONVEI',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Condio do Veculo',
       'Condio do Veculo',
       '',
       'CONVEI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DVEI',
       '--',
       14,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DVEI',
       '--',
       6,
       30,
       'DESVEI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio do Veculo',
       'Descrio do Veculo',
       '',
       'DESVEI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DVEI',
       '--',
       10,
       1,
       'ESPVEI',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Espcie do Veculo',
       'Espcie do Veculo',
       '',
       'ESPVEI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DVEI',
       '--',
       13,
       13,
       'MAXTRA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Mxima Trao',
       'Mxima Trao',
       '',
       'MAXTRA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'DVEI',
       '--',
       3,
       7,
       'PESMAX',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Peso Mximo',
       'Peso Mximo',
       '',
       'PESMAX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DVEI',
       '--',
       5,
       8,
       'PLACAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Placa',
       'Placa',
       '',
       'PLACAS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DVEI',
       '--',
       9,
       2,
       'TIPVEI',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Tipo de Veculo',
       'Tipo de Veculo',
       '',
       'TIPVEI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'DVEI',
       '--',
       2,
       1,
       'VEIATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Veculo Ativo?',
       'Veculo Ativo?',
       '',
       'VEIATI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'DVEI',
       '--',
       4,
       7,
       'VOLMAX',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Mximo de Volumes',
       'Mximo de Volumes',
       '',
       'VOLMAX',
       'F',
       'D' FROM DUAL
);

/*-- SEQ 7666 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DVEI',
       'CONVEI',
       1,
       ' ',
       'Acabado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'CONVEI',
       2,
       ' ',
       'Inacabado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'CONVEI',
       3,
       ' ',
       'Semiacabado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'ESPVEI',
       1,
       ' ',
       'Passageiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'ESPVEI',
       2,
       ' ',
       'Carga',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'ESPVEI',
       3,
       ' ',
       'Misto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'ESPVEI',
       4,
       ' ',
       'Corrida',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'ESPVEI',
       5,
       ' ',
       'Trao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'ESPVEI',
       6,
       ' ',
       'Especial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'TIPVEI',
       2,
       ' ',
       'Ciclomoto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'TIPVEI',
       3,
       ' ',
       'Motoneta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'TIPVEI',
       4,
       ' ',
       'Motociclo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'TIPVEI',
       5,
       ' ',
       'Triciclo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'TIPVEI',
       6,
       ' ',
       'Automvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'TIPVEI',
       7,
       ' ',
       'Micro-nibus',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'TIPVEI',
       8,
       ' ',
       'nibus',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'TIPVEI',
       10,
       ' ',
       'Reboque',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'TIPVEI',
       11,
       ' ',
       'Semirreboque',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'TIPVEI',
       13,
       ' ',
       'Camioneta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'TIPVEI',
       14,
       ' ',
       'Caminho',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'TIPVEI',
       17,
       ' ',
       'Caminho Trator',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'TIPVEI',
       18,
       ' ',
       'Trator Rodas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'TIPVEI',
       19,
       ' ',
       'Trator Esteiras',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'TIPVEI',
       20,
       ' ',
       'Trator Misto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'TIPVEI',
       21,
       ' ',
       'Quadriciclo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'TIPVEI',
       22,
       ' ',
       'Esp/nibus',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'TIPVEI',
       23,
       ' ',
       'Caminhonete',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'TIPVEI',
       24,
       ' ',
       'Carga/Cam',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'TIPVEI',
       25,
       ' ',
       'Utilitrio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DVEI',
       'TIPVEI',
       26,
       ' ',
       'Motor-Casa',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7667 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DVPE',
       TO_NUMBER(null),
       'DVPE',
       'Dom. Mot.Ven.Perdida',
       'TD_VPE',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7668 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DVPE','--','' FROM DUAL
UNION ALL
SELECT 'DVPE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DVPE','99','Outros' FROM DUAL
);

/*-- SEQ 7669 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DVPE',
       '--',
       13,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DVPE',
       '--',
       2,
       20,
       'MOTVPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo Venda Perdida',
       'Motivo Venda Perdida',
       '',
       'MOTVPE',
       'F' FROM DUAL
UNION ALL
SELECT 'DVPE',
       '--',
       3,
       1,
       'VPEATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Item Ativo?',
       'Se o item est ativo ou no',
       '',
       'VPEATI',
       'F' FROM DUAL
);

/*-- SEQ 7670 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DVTP',
       TO_NUMBER(null),
       'DVTP',
       'Dom. Tipos Veiculos',
       'TD_VTP',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DVTP.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 7671 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DVTP','--','' FROM DUAL
UNION ALL
SELECT 'DVTP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DVTP','99','Outros' FROM DUAL
);

/*-- SEQ 7672 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DVTP',
       '--',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'DVTP',
       '--',
       20,
       30,
       'DESVTP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Tipo V.',
       'Descricao do tipo do veiculo',
       '',
       'DESVTP',
       'F' FROM DUAL
UNION ALL
SELECT 'DVTP',
       '--',
       30,
       1,
       'VTPATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'VTPATI',
       'F' FROM DUAL
);

/*-- SEQ 7673 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DXC ',
       TO_NUMBER(null),
       'DXC ',
       'Dias Fat. x Clientes',
       'TT_DXC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DXC.CODFIL,DXC.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7674 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DXC ','--','' FROM DUAL
UNION ALL
SELECT 'DXC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DXC ','99','Outros' FROM DUAL
);

/*-- SEQ 7675 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21443,
       'CLI ',
       'DXC ',
       '0N',
       '1',
       '',
       '',
       'CLI.FILCLI = DXC.FILCLI AND
CLI.CODCLI = DXC.CODCLI',
       '',
       '' FROM DUAL
);

/*-- SEQ 7676 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DXC ',
       '01',
       10,
       5,
       'CODCCC',
       'S',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       '',
       'F',
       'Tipo C/C',
       'Tipo C/C',
       'DCCC.CODTAB(+) = DXC.CODCCC',
       'CODCCC',
       'T' FROM DUAL
UNION ALL
SELECT 'DXC ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Codigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'DXC ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Codigo Filial',
       'DFIL.CODFIL = DXC.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'DXC ',
       '01',
       90,
       2,
       'DIAFIX',
       'S',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Dia Fixo Vencimento',
       'Dia Fixo do Vencimento',
       '',
       'DIAFIX',
       '' FROM DUAL
UNION ALL
SELECT 'DXC ',
       '01',
       40,
       2,
       'DIAMES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dia do Mes',
       'Dia Mes',
       '',
       'DIAMES',
       'F' FROM DUAL
UNION ALL
SELECT 'DXC ',
       '01',
       50,
       1,
       'DIASEM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Dia da Semana',
       'Dia Semana',
       '',
       'DIASEM',
       'T' FROM DUAL
UNION ALL
SELECT 'DXC ',
       '01',
       60,
       3,
       'DIAVEN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias Ven.',
       'Dias Ven.(uso futuro)',
       '',
       'DIAVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'DXC ',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'DXC ',
       '01',
       80,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 7677 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'DXC ',
       'DIASEM',
       1,
       ' ',
       'Domingo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DXC ',
       'DIASEM',
       2,
       ' ',
       'Segunda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DXC ',
       'DIASEM',
       3,
       ' ',
       'Terca',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DXC ',
       'DIASEM',
       4,
       ' ',
       'Quarta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DXC ',
       'DIASEM',
       5,
       ' ',
       'Quinta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DXC ',
       'DIASEM',
       6,
       ' ',
       'Sexta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'DXC ',
       'DIASEM',
       7,
       ' ',
       'Sabado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7678 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DXDC',
       TO_NUMBER(null),
       'DXDC',
       'Descontos por c/c',
       'TT_DESXDCCC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DXDC.CODFIL,DXDC.PGTATE,DXDC.CODCCC',
       '' FROM DUAL
);

/*-- SEQ 7679 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DXDC','--','' FROM DUAL
UNION ALL
SELECT 'DXDC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DXDC','99','Outros' FROM DUAL
);

/*-- SEQ 7680 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DXDC',
       '01',
       10,
       5,
       'CODCCC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Conta C.',
       'Cdigo Conta Corrente',
       '',
       'CODCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'DXDC',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = DXDC.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'DXDC',
       '01',
       30,
       7,
       'PERDES',
       'F',
       '',
       3,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% de Desconto',
       'Percentual de Desconto',
       '',
       'PERDES',
       'F' FROM DUAL
UNION ALL
SELECT 'DXDC',
       '01',
       40,
       3,
       'PGTATE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Estado Pagamento',
       'Estado Pagamento',
       '',
       'PGTATE',
       'F' FROM DUAL
);

/*-- SEQ 7681 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DXG ',
       TO_NUMBER(null),
       'DXG ',
       'Descontos na Grade',
       'TT_DXG',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DXG.CODFIL,DXG.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7682 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DXG ','--','' FROM DUAL
UNION ALL
SELECT 'DXG ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DXG ','99','Outros' FROM DUAL
);

/*-- SEQ 7683 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5630,
       'GRA ',
       'DXG ',
       '0N',
       '1 ',
       '',
       '',
       'GRA.FILMAT(+) = DXG.FILMAT AND
GRA.CODMAT(+) = DXG.CODMAT AND
GRA.CODCOR(+) = DXG.CODCOR AND
GRA.CODTAM(+) = DXG.CODTAM',
       '' FROM DUAL
UNION ALL
SELECT 5631,
       'PXF ',
       'DXG ',
       'N ',
       '1 ',
       '',
       '',
       'PXF.FILFOR = DXG.FILFOR AND
PXF.CODFOR = DXG.CODFOR AND
PXF.FILMAT = DXG.FILMAT AND
PXF.CODMAT = DXG.CODMAT AND
PXF.CODCOR = DXG.CODCOR AND
PXF.CODTAM = DXG.CODTAM 
',
       '' FROM DUAL
);

/*-- SEQ 7684 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DXG ',
       '--',
       10,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Divisao do Produto',
       'DXG.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'DXG ',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Codigo Filial',
       'DFIL.CODFIL = DXG.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'DXG ',
       '--',
       30,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Fornecedor',
       'Codigo Fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'DXG ',
       '--',
       40,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Codigo Material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'DXG ',
       '--',
       50,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-divisao do Produto',
       'DXG.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'DXG ',
       '--',
       60,
       4,
       'DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Valor do Desconto',
       'Valor Desconto',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'DXG ',
       '--',
       70,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'DXG ',
       '--',
       80,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'DXG ',
       '--',
       90,
       2,
       'NUMDES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Numero Desconto',
       'Numero do Desconto',
       '',
       'NUMDES',
       'F' FROM DUAL
UNION ALL
SELECT 'DXG ',
       '--',
       100,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'DXG ',
       '--',
       110,
       5,
       'TIPDES',
       'S',
       'DDES',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDES.TIPDES',
       'V',
       '',
       '',
       'A',
       'F',
       'Tipo Desconto',
       'Tipo do Desconto (TD_DES)',
       'DDES.CODTAB = DXG.TIPDES',
       'TIPDES',
       'F' FROM DUAL
);

/*-- SEQ 7685 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DXI ',
       TO_NUMBER(null),
       'DXI ',
       'Descontos x Itens',
       'TT_DXI',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'DXI.CODFIL,DXI.NUMDES,DXI.SEQIPE',
       '' FROM DUAL
);

/*-- SEQ 7686 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DXI ','--','' FROM DUAL
UNION ALL
SELECT 'DXI ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DXI ','99','Outros' FROM DUAL
);

/*-- SEQ 7687 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5632,
       'IPE ',
       'DXI ',
       '01',
       '1 ',
       '',
       '',
       'IPE.CODFIL(+) = DXI.CODFIL AND
IPE.SEQUEN(+) = DXI.SEQIPE',
       '' FROM DUAL
);

/*-- SEQ 7688 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DXI ',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Codigo da Filial',
       'DFIL.CODFIL = DXI.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'DXI ',
       '--',
       20,
       4,
       'DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Desconto',
       '% de Desconto',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'DXI ',
       '--',
       30,
       2,
       'NUMDES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Numero~Desconto',
       'Numero do Desconto',
       '',
       'NUMDES',
       'F' FROM DUAL
UNION ALL
SELECT 'DXI ',
       '--',
       40,
       10,
       'SEQIPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequencial do Pedido (TT_IPE)',
       '',
       'SEQIPE',
       'F' FROM DUAL
UNION ALL
SELECT 'DXI ',
       '--',
       50,
       5,
       'TIPDES',
       'S',
       'DDES',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDES.TIPDES',
       'V',
       '',
       '',
       'A',
       'F',
       'Tipo Desconto',
       'Tipo do Desconto (TD_DES)',
       'DDES.CODTAB(+) = DXI.TIPDES',
       'TIPDES',
       'T' FROM DUAL
);

/*-- SEQ 7689 --*/
INSERT INTO TT_ARQ(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,
       DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
       VALUES('DXIC',
              null,
              'DXIC',
              'Descontos em Compra',
              'TT_DESXICO',
              'F',
              '',
              'TOTALL',
              '',
              '',
              '',
              '',
              '',
              'T',
              '',
              'DXIC.CODFIL,DXIC.SEQUEN',
              '');
/*-- SEQ 7690 --*/
INSERT INTO TT_GRU ( CODTAB, CODGRU, DESGRU)
       VALUES ('DXIC','--','');
/*-- SEQ 7691 --*/
INSERT INTO TT_GRU ( CODTAB, CODGRU, DESGRU)
       VALUES ('DXIC','01','Identificao');
/*-- SEQ 7692 --*/
INSERT INTO TT_GRU ( CODTAB, CODGRU, DESGRU)
       VALUES ('DXIC','99','Outros');
/*-- SEQ 7693 --*/
INSERT INTO TT_SQL (NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)                                                                                             
       VALUES (90295,'GRA ','DXIC',                                   
               '0N','1 ','','',
               'GRA.FILMAT = DXIC.FILMAT AND
GRA.CODMAT = DXIC.CODMAT AND
GRA.CODCOR = DXIC.CODCOR AND
GRA.CODTAM = DXIC.CODTAM','');
/*-- SEQ 7694 --*/
INSERT INTO TT_SQL (NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)                                                                                             
       VALUES (90296,'PXF ','DXIC',                                   
               'N ','1 ','','',
               'PXF.FILFOR = DXIC.FILFOR AND
PXF.CODFOR = DXIC.CODFOR AND
PXF.FILMAT = DXIC.FILMAT AND
PXF.CODMAT = DXIC.CODMAT','');
/*-- SEQ 7695 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DXIC',
              '--',
              10,
              5,
              'CODCOR',
              'S',
              'DIV ',
              0,
              null,
              '',
              null,
              null,
              '',
              'DIV.NOMEXT',
              'V',
              '',
              'F',
              'N',
              'F',
              'Diviso',
              'Divisao do Produto',
              'DXIC.CODCOR=DIV.CODITE',
              'CODCOR',
              'F');
/*-- SEQ 7696 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DXIC',
              '--',
              20,
              3,
              'CODFIL',
              'A',
              'DFIL',
              0,
              null,
              '',
              null,
              null,
              '',
              'DFIL.NOMFIL',
              'V',
              '',
              '',
              'N',
              'F',
              'Filial',
              'Codigo Filial',
              'DFIL.CODFIL = DXIC.CODFIL',
              'CODFIL',
              'F');
/*-- SEQ 7697 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DXIC',
              '--',
              30,
              6,
              'CODFOR',
              'A',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'I',
              '',
              '',
              '9',
              'F',
              'Cdigo Fornecedor',
              'Codigo Fornecedor',
              '',
              'CODFOR',
              'F');
/*-- SEQ 7698 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DXIC',
              '--',
              40,
              5,
              'CODMAT',
              'A',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'I',
              '',
              'F',
              '9',
              'F',
              '',
              'Codigo Material',
              '',
              'CODMAT',
              'F');
/*-- SEQ 7699 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DXIC',
              '--',
              50,
              5,
              'CODTAM',
              'S',
              'SUB ',
              0,
              null,
              '',
              null,
              null,
              '',
              'SUB.NOMEXT',
              'V',
              '',
              'F',
              'N',
              'F',
              'Sub-diviso',
              'Sub-diviso do Produto',
              'DXIC.CODTAM=SUB.CODITE',
              'CODTAM',
              'F');
/*-- SEQ 7700 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DXIC',
              '--',
              60,
              4,
              'DESCON',
              'F',
              '',
              2,
              null,
              '',
              null,
              null,
              '',
              '',
              'I',
              '',
              '',
              '',
              'F',
              'Valor do Desconto',
              'Valor Desconto',
              '',
              'DESCON',
              'F');
/*-- SEQ 7701 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DXIC',
              '--',
              70,
              3,
              'FILFOR',
              'A',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'I',
              '',
              '',
              'N',
              'F',
              '',
              'Filial Fornecedor',
              '',
              'FILFOR',
              'F');
/*-- SEQ 7702 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DXIC',
              '--',
              80,
              3,
              'FILMAT',
              'A',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'I',
              '',
              'F',
              'N',
              'F',
              '',
              'Filial do Material',
              '',
              'FILMAT',
              'F');
/*-- SEQ 7703 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DXIC',
              '--',
              90,
              2,
              'NUMDES',
              'S',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'I',
              '',
              '',
              '',
              'F',
              'Nmero Desconto',
              'Nmero Desconto',
              '',
              'NUMDES',
              'F');
/*-- SEQ 7704 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DXIC',
              '--',
              100,
              10,
              'SEQUEN',
              'A',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'I',
              '',
              '',
              '9',
              'F',
              '',
              'Sequenciador',
              '',
              'SEQUEN',
              'F');
/*-- SEQ 7705 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('DXIC',
              '--',
              110,
              5,
              'TIPDES',
              'S',
              'DDES',
              0,
              null,
              '',
              null,
              null,
              '',
              'DDES.TIPDES',
              'V',
              '',
              '',
              'A',
              'F',
              'Tipo Desconto',
              'Tipo do Desconto',
              'DDES.CODTAB = DXIC.TIPDES',
              'TIPDES',
              'F');

/*-- SEQ 7706 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'DXR ',
       TO_NUMBER(null),
       'DXR ',
       'Devedor por Parcela',
       'TT_DEVXREC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7707 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'DXR ','--','' FROM DUAL
UNION ALL
SELECT 'DXR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'DXR ','99','Outros' FROM DUAL
);

/*-- SEQ 7708 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 45031,
       'REC ',
       'DXR ',
       '1',
       'N',
       '',
       '',
       'REC.SEQUEN = DXC.SEQREC AND
REC.CODFIL = DXC.FILREC AND
REC.NUMPAR = DXC.PARREC AND
REC.SUBPAR = DXC.SUBREC',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45032,
       'VEN ',
       'DXR ',
       '1',
       'N',
       '',
       '',
       'VEN.CODFIL = DXR.FILDEV AND
VEN.SEQUEN = DXR.SEQDEV',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45922,
       'RECP',
       'DXR ',
       '1',
       'N',
       '',
       '',
       'RECP.ORI_SEQUEN = DXC.SEQREC AND
RECP.ORI_CODFIL = DXC.FILREC AND
RECP.ORI_NUMPAR = DXC.PARREC AND
RECP.ORI_SUBPAR = DXC.SUBREC',
       '',
       '' FROM DUAL
);

/*-- SEQ 7709 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'DXR ',
       '--',
       10,
       3,
       'FILDEV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILDEV',
       'F' FROM DUAL
UNION ALL
SELECT 'DXR ',
       '--',
       20,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'DXR ',
       '01',
       30,
       2,
       'PARREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Numero da Parcela',
       'Numero da parcela',
       '',
       'PARREC',
       'F' FROM DUAL
UNION ALL
SELECT 'DXR ',
       '--',
       40,
       10,
       'SEQDEV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQDEV',
       'F' FROM DUAL
UNION ALL
SELECT 'DXR ',
       '--',
       50,
       10,
       'SEQREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQREC',
       'F' FROM DUAL
UNION ALL
SELECT 'DXR ',
       '--',
       60,
       2,
       'SUBREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Numero Sub Parcela',
       'Numero Sub Parcela',
       '',
       'SUBREC',
       'F' FROM DUAL
);

/*-- SEQ 7710 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EAN ',
       TO_NUMBER(null),
       'EAN ',
       'Referncia de Vendas',
       'TT_EAN',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'EAN.CODEAN',
       '' FROM DUAL
);

/*-- SEQ 7711 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EAN ','--','' FROM DUAL
);

/*-- SEQ 7712 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 16269,
       'GRA ',
       'EAN ',
       '1 ',
       '0N',
       '',
       '',
       'GRA.FILMAT = EAN.FILMAT(+) AND
GRA.CODMAT = EAN.CODMAT(+) AND
GRA.CODCOR = EAN.CODCOR(+) AND
GRA.CODTAM = EAN.CODTAM(+)',
       '' FROM DUAL
);

/*-- SEQ 7713 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EAN ',
       '--',
       4,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Diviso do produto',
       'EAN.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'EAN ',
       '--',
       1,
       20,
       'CODEAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Referncia Venda',
       'Referncia Venda',
       '',
       'CODEAN',
       'F' FROM DUAL
UNION ALL
SELECT 'EAN ',
       '--',
       26,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Filial',
       'Cdigo Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EAN ',
       '--',
       3,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EAN ',
       '--',
       5,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'EAN.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'EAN ',
       '--',
       36,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'EAN ',
       '--',
       2,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EAN ',
       '--',
       46,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'EAN ',
       '--',
       6,
       5,
       'USOEAN',
       'F',
       'DEAN',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEAN.DESEAN',
       'V',
       '',
       'F',
       'A',
       'F',
       'Classificador',
       'Classificador',
       'EAN.USOEAN=DEAN.CODTAB(+)',
       'USOEAN',
       'T' FROM DUAL
);

/*-- SEQ 7714 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ECAM',
       TO_NUMBER(null),
       'ECAM',
       'Exportao de Cmbio',
       'TV_ECAM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7715 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ECAM','--','' FROM DUAL
UNION ALL
SELECT 'ECAM','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ECAM','99','Outros' FROM DUAL
);

/*-- SEQ 7716 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ECAM',
       '--',
       10,
       1,
       'DATIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Data Imp.',
       'Data Imp.',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'ECAM',
       '--',
       20,
       7,
       'DATREF',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Data Referncia',
       'Data Referncia',
       '',
       'DATREF',
       'F' FROM DUAL
UNION ALL
SELECT 'ECAM',
       '--',
       30,
       5,
       'DESMOE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Moeda',
       'Descrio da Moeda',
       '',
       'DESMOE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECAM',
       '--',
       40,
       1,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'ECAM',
       '--',
       50,
       12,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Status',
       'Status',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'ECAM',
       '--',
       60,
       12,
       'VLRREF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Referncia',
       'Valor Referncia',
       '',
       'VLRREF',
       'F' FROM DUAL
);

/*-- SEQ 7717 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ECB ',
       TO_NUMBER(null),
       'ECB ',
       'Espcie Bancria',
       'TT_ECB',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'ECB.CODBCO,ECB.CODECB',
       '' FROM DUAL
);

/*-- SEQ 7718 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ECB ','--','' FROM DUAL
UNION ALL
SELECT 'ECB ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ECB ','99','Outros' FROM DUAL
);

/*-- SEQ 7719 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ECB ',
       '01',
       10,
       3,
       'CODBCO',
       'A',
       'DBCO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DBCO.NBANCO',
       'V',
       '',
       '',
       'N',
       'F',
       'Banco',
       'Cdigo do Banco',
       'DBCO.CBANCO(+) = ECB.CODBCO',
       'CODBCO',
       'T' FROM DUAL
UNION ALL
SELECT 'ECB ',
       '01',
       20,
       5,
       'CODECB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cod. Espcie',
       'Cdigo da Espcie',
       '',
       'CODECB',
       'F' FROM DUAL
UNION ALL
SELECT 'ECB ',
       '01',
       30,
       30,
       'DESECB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Espcie',
       'Descrio Espcie',
       '',
       'DESECB',
       'F' FROM DUAL
UNION ALL
SELECT 'ECB ',
       '01',
       40,
       2,
       'ECBBCO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cod Espcie no Banco',
       'Cdigo da Espcie para o Banco',
       '',
       'ECBBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'ECB ',
       '01',
       50,
       4,
       'SIGECB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sigla da Espcie',
       'Sigla da Espcie',
       '',
       'SIGECB',
       'F' FROM DUAL
);

/*-- SEQ 7720 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ECCC',
       TO_NUMBER(null),
       'ECCC',
       'Exportao Lan. CCC',
       'TE_CCC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7721 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ECCC','--','' FROM DUAL
UNION ALL
SELECT 'ECCC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ECCC','99','Outros' FROM DUAL
);

/*-- SEQ 7722 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ECCC',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial onde ocorreu o lanamento',
       'DFIL.CODFIL = ECCC.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ECCC',
       '--',
       20,
       100,
       'COMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Complemento',
       'Complemento',
       '',
       'COMPLE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECCC',
       '--',
       30,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Operao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECCC',
       '--',
       40,
       20,
       'EXTCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd.Cliente~Origem',
       'Cdigo do cliente no sistema de origem',
       '',
       'EXTCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'ECCC',
       '--',
       50,
       13,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECCC',
       '--',
       60,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero ECF',
       'Nmero ECF',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'ECCC',
       '--',
       70,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Parcela',
       'Nmero Parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'ECCC',
       '--',
       80,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub-Parcela',
       'Preenchido somente no caso de pagamento de parcelas - tambm para venda ',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'ECCC',
       '--',
       90,
       5,
       'TIPCCC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tipo C/C',
       'Cdigo do tipo de conta corrente',
       '',
       'TIPCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECCC',
       '--',
       100,
       12,
       'VLRLAN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor do lanamento',
       'Valor do lanamento',
       '',
       'VLRLAN',
       'F' FROM DUAL
);

/*-- SEQ 7723 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ECF ',
       TO_NUMBER(null),
       'ECF ',
       'Totalizadores Z',
       'TT_ECF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'ECF.CODFIL,ECF.NUMECF,ECF.DATOPE,ECF.TOTALI,ECF.TIPTOT',
       '' FROM DUAL
);

/*-- SEQ 7724 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ECF ','--','' FROM DUAL
);

/*-- SEQ 7725 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ECF ',
       '--',
       152,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Assinatura para PAF-ECF',
       '',
       'ASSINA',
       'F' FROM DUAL
UNION ALL
SELECT 'ECF ',
       '--',
       12,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'ECF ',
       '--',
       22,
       6,
       'CNTOPE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nm. Operao Final',
       'Nmero Operao Final',
       '',
       'CNTOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECF ',
       '--',
       122,
       5,
       'CNT_RO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cont. Reinicio Oper.',
       'Contador de Reinicio de Operao',
       '',
       'CNT_RO',
       'F' FROM DUAL
UNION ALL
SELECT 'ECF ',
       '--',
       32,
       4,
       'CNT_RZ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nm. Oper. Reduo Z',
       'Nmero Operao Reduo Z',
       '',
       'CNT_RZ',
       'F' FROM DUAL
UNION ALL
SELECT 'ECF ',
       '--',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = ECF.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ECF ',
       '--',
       112,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'ECF ',
       '--',
       162,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Identificao de Acesso',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'ECF ',
       '--',
       42,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Operao',
       'Data de Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECF ',
       '--',
       172,
       1,
       'EXPFIS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exportado Fiscal?',
       'Exportado Fiscal?',
       '',
       'EXPFIS',
       '' FROM DUAL
UNION ALL
SELECT 'ECF ',
       '--',
       2,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nr ECF',
       'Nmero Emissor Cupom Fiscal',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'ECF ',
       '--',
       52,
       25,
       'NUMSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Srie',
       'Nmero Srie',
       '',
       'NUMSER',
       'F' FROM DUAL
UNION ALL
SELECT 'ECF ',
       '--',
       132,
       3,
       'ORDALI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ordem das Alquotas',
       'Ordem dos Totalizadores de Alquotas Gravado no ECF',
       '',
       'ORDALI',
       'F' FROM DUAL
UNION ALL
SELECT 'ECF ',
       '--',
       62,
       1,
       'TIPTOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Tot.',
       'Tipo Tot.',
       '',
       'TIPTOT',
       'T' FROM DUAL
UNION ALL
SELECT 'ECF ',
       '--',
       72,
       4,
       'TOTALI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Dsc. Total Alquota',
       'Descrio Total Alquota',
       '',
       'TOTALI',
       'F' FROM DUAL
UNION ALL
SELECT 'ECF ',
       '--',
       142,
       7,
       'TOTPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Totalizador Parcial',
       'Totalizador Parcial',
       '',
       'TOTPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'ECF ',
       '--',
       82,
       16,
       'VLRBAS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Base',
       'Valor Base',
       '',
       'VLRBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'ECF ',
       '--',
       92,
       16,
       'VLRTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Total',
       'Valor Total',
       '',
       'VLRTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECF ',
       '--',
       102,
       16,
       'VLR_GT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Val. PGTO/Vencimento',
       'Valor Pagamento at o Venciomento',
       '',
       'VLR_GT',
       'F' FROM DUAL
);

/*-- SEQ 7726 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ECF ',
       'TIPTOT',
       0,
       'M',
       'Mercadoria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECF ',
       'TIPTOT',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECF ',
       'TIPTOT',
       0,
       'S',
       'Servio',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7727 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ECFP',
       TO_NUMBER(null),
       'ECFP',
       'Exportao de CFOP',
       'TV_ECFP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7728 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ECFP','--','' FROM DUAL
UNION ALL
SELECT 'ECFP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ECFP','99','Outros' FROM DUAL
);

/*-- SEQ 7729 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ECFP',
       '--',
       10,
       1,
       'CFPATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo ?',
       'Ativo ?',
       '',
       'CFPATI',
       'F' FROM DUAL
UNION ALL
SELECT 'ECFP',
       '--',
       20,
       3,
       'COMCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Com Cons Final D',
       'Sufixo da natureza de compra para "consumidor final" Dentro do Estado',
       '',
       'COMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECFP',
       '--',
       30,
       3,
       'COMREV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Com Revenda D',
       'Sufixo da natureza de compra para "Revenda" Dentro do Estado',
       '',
       'COMREV',
       'F' FROM DUAL
UNION ALL
SELECT 'ECFP',
       '--',
       40,
       1,
       'DATIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Data Imp.',
       'Data Imp.',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'ECFP',
       '--',
       50,
       20,
       'DESCFP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'DESCFP',
       'F' FROM DUAL
UNION ALL
SELECT 'ECFP',
       '--',
       60,
       3,
       'DEVCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Dev Ve Con Fim D',
       'Sufixo da nat. de devol. de venda para "consum. final" Dentro do Estado',
       '',
       'DEVCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECFP',
       '--',
       70,
       3,
       'DEVREV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Dev Ven Reven D',
       'Sufixo da natureza de devoluo de venda para "Revenda" Dentro do Estado',
       '',
       'DEVREV',
       'F' FROM DUAL
UNION ALL
SELECT 'ECFP',
       '--',
       80,
       3,
       'DVCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Dev Co Con Fim D',
       'Sufixo da nat. de devol. de compra para "consum. final" Dentro do Estado',
       '',
       'DVCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECFP',
       '--',
       90,
       3,
       'DVCREV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Dev Com Reven D',
       'Sufixo da natureza de devoluo de comp. para "Revenda" Dentro do Estado',
       '',
       'DVCREV',
       'F' FROM DUAL
UNION ALL
SELECT 'ECFP',
       '--',
       100,
       3,
       'ENTCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Nat Ent Cons Final D',
       'Sufixo da nat. de ent. via transf. para "consum. final" Dentro do Estado',
       '',
       'ENTCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECFP',
       '--',
       110,
       3,
       'ENTREV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Ent Revenda D',
       'Sufixo da natureza de ent. via transf. para "Revenda" Dentro do Estado',
       '',
       'ENTREV',
       'F' FROM DUAL
UNION ALL
SELECT 'ECFP',
       '--',
       120,
       3,
       'INTCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Cons Cons Fin D',
       'Sufixo da nat. de cons. interno para "consumidor final" Dentro do Estado',
       '',
       'INTCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECFP',
       '--',
       130,
       3,
       'INTREV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Cons Revenda D',
       'Sufixo da natureza de consumo interno para "Revenda" Dentro do Estado',
       '',
       'INTREV',
       'F' FROM DUAL
UNION ALL
SELECT 'ECFP',
       '--',
       140,
       1,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'ECFP',
       '--',
       150,
       3,
       'SAICON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Saida Cons Fin D',
       'Sufixo da nat. de sada via transf. para "consum final" Dentro do Estado',
       '',
       'SAICON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECFP',
       '--',
       160,
       3,
       'SAIREV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Saida Revenda D',
       'Sufixo da natureza de sada via transf. para "Revenda" Dentro do Estado',
       '',
       'SAIREV',
       'F' FROM DUAL
UNION ALL
SELECT 'ECFP',
       '--',
       170,
       12,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Status',
       'Status',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'ECFP',
       '--',
       180,
       3,
       'VENCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Ven Cons Final D',
       'Sufixo da natureza de venda para "consumidor final" Dentro do Estado',
       '',
       'VENCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECFP',
       '--',
       190,
       3,
       'VENREV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat Ven Revenda D',
       'Estado',
       '',
       'VENREV',
       'F' FROM DUAL
);

/*-- SEQ 7730 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ECHR',
       TO_NUMBER(null),
       'ECHR',
       'Exporta Cheques Rec.',
       'TE_CHR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7731 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ECHR','--','' FROM DUAL
UNION ALL
SELECT 'ECHR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ECHR','99','Outros' FROM DUAL
);

/*-- SEQ 7732 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ECHR',
       '--',
       10,
       2,
       'ALINEA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Alnea',
       'Alnea',
       '',
       'ALINEA',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       20,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Data Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       30,
       40,
       'AUTORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Autorizao',
       'Autorizao eletrnica, caso houve consulta',
       '',
       'AUTORI',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       40,
       30,
       'CDCMC7',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo~CMC7 cheque',
       'Cdigo CMC7 cheque',
       '',
       'CDCMC7',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       50,
       5,
       'CODAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Agncia',
       'Agncia',
       '',
       'CODAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       60,
       3,
       'CODBCO',
       'A',
       'DBCO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DBCO.NBANCO',
       'V',
       '',
       '',
       'A',
       'F',
       'Banco',
       'Banco',
       'DBCO.CODTAB = ECHR.CODBCO',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       70,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = ECHR.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       80,
       10,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd.Externo~Usurio',
       'Cdigo Externo do Usurio',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       90,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de~operao',
       'Data de operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       100,
       7,
       'DATVEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Vencto',
       'Data Vencto',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       110,
       15,
       'DOCCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento~do Cliente',
       'CPF / CNPJ do cliente que portava o cheque',
       '',
       'DOCCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       120,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       130,
       6,
       'NUMCHE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero',
       'Nmero Cheque',
       '',
       'NUMCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       140,
       10,
       'NUMCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Conta',
       'Conta',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       150,
       1,
       'NUMDEP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'N de~Depsitos',
       'N de Depsitos',
       '',
       'NUMDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       160,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do~Documento',
       'CPF / CNPJ do cheque',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       170,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Numero~ECF',
       'Numero ECF',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       180,
       254,
       'OBSLOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observaes',
       'Observaes',
       '',
       'OBSLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       190,
       7,
       'PAGAME',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data pagto',
       'Data pagto',
       '',
       'PAGAME',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       200,
       5,
       'PORTAD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Portador',
       'Cdigo do portador',
       '',
       'PORTAD',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       210,
       3,
       'SERCHE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie do~Cheque',
       'Srie do Cheque',
       '',
       'SERCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       220,
       1,
       'TIPOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de~Operao',
       'Tipo de Operao',
       '',
       'TIPOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       230,
       9,
       'VLRCHE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor~Cheque',
       'Valor Cheque',
       '',
       'VLRCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       240,
       9,
       'VLRDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor~diferena',
       'Valor diferena',
       '',
       'VLRDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'ECHR',
       '--',
       250,
       9,
       'VLRORI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor~Original',
       'Valor Original',
       '',
       'VLRORI',
       'F' FROM DUAL
);

/*-- SEQ 7733 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ECHR',
       'FLGEST',
       0,
       'A',
       'A Depositar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECHR',
       'FLGEST',
       0,
       'B',
       'Cobrado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECHR',
       'FLGEST',
       0,
       'C',
       'Compensado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECHR',
       'FLGEST',
       0,
       'D',
       'Depositado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECHR',
       'FLGEST',
       0,
       'G',
       'Depositar/Custodiar(Arquivo)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECHR',
       'FLGEST',
       0,
       'I',
       'Incobrvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECHR',
       'FLGEST',
       0,
       'P',
       'Pr-Descontado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECHR',
       'FLGEST',
       0,
       'R',
       'Reservado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECHR',
       'FLGEST',
       0,
       'S',
       'Substitudo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECHR',
       'FLGEST',
       0,
       'U',
       'Custodiado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECHR',
       'FLGEST',
       0,
       'V',
       'Devolvido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECHR',
       'FLGEST',
       0,
       'X',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECHR',
       'TIPOPE',
       0,
       'A',
       'Alterao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECHR',
       'TIPOPE',
       0,
       'I',
       'Incluso',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7734 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ECLI',
       TO_NUMBER(null),
       'ECLI',
       'Exp. de Parceiros',
       'TV_ECLI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'ECLI_APEVEN',
       '' FROM DUAL
);

/*-- SEQ 7735 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ECLI','--','' FROM DUAL
UNION ALL
SELECT 'ECLI','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ECLI','99','Outros' FROM DUAL
);

/*-- SEQ 7736 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 95846,
       'MUN ',
       'ECLI',
       '01',
       '0N',
       '',
       '',
       'MUN.CODIGO(+) = ECLI.CODCID',
       '',
       '' FROM DUAL
);

/*-- SEQ 7737 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ECLI',
       '--',
       10,
       8,
       'ALUFIN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr. Aluguel/Financ.',
       'Valor do aluguel / financiamento',
       '',
       'ALUFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       20,
       8,
       'ANTMES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Tempo de Servio',
       'Tempo de servio do parceiro  no emprego anterior',
       '',
       'ANTMES',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       30,
       10,
       'APEVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'L',
       '',
       '',
       'A',
       'F',
       'Apelido Usurio',
       'Apelido do Usurio',
       '',
       'APEVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       40,
       2,
       'ATIVO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Ativo?',
       'Ativo(T) se SIGNAT >=0 e Desativo(F) se SIGNAT < 0',
       '',
       'ATIVO',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       50,
       2,
       'ATUMES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Meses de Trabalho',
       'Tempo de servio do parceiro no emprego atual (meses)',
       '',
       'ATUMES',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       60,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       70,
       40,
       'BAIRRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Bairro',
       'Bairro',
       '',
       'BAIRRO',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       80,
       1,
       'CALL_C',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Aceita Contato?',
       'Aceita Contato Telefnico',
       '',
       'CALL_C',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       90,
       2,
       'CANMES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Meses Serv. Cnjuge',
       'Tempo de servio do cnjuge (meses)',
       '',
       'CANMES',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       100,
       1,
       'CARLOJ',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Tem Carto Loja?',
       'Tem carto da Loja? ',
       '',
       'CARLOJ',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       110,
       6,
       'CARPRC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'CTPS do Cnjuge',
       'Nmero da Carteira de trabalho (CTPS) do cnjuge',
       '',
       'CARPRC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       120,
       6,
       'CARPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'CTPS',
       'Nmero da carteira de trabalho (CTPS) do cliente',
       '',
       'CARPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       130,
       5,
       'CASMES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tempo Casamento',
       'Tempo de Casamento',
       '',
       'CASMES',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       140,
       20,
       'CATEG1',
       'A',
       'DCT1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo da 1 Categ.',
       'Nome da categoria 1',
       'ECLI.CATEG1=DCT1.CODTAB (+)',
       'CATEG1',
       'T' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       150,
       20,
       'CATEG2',
       'A',
       'DCT2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo da 2 Categ.',
       'Nome da categoria 2',
       'ECLI.CATEG2=DCT2.CODTAB (+)',
       'CATEG2',
       'T' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       160,
       20,
       'CATEG3',
       'A',
       'DCT3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo da 3 Categ.',
       'Nome da categoria 3',
       'ECLI.CATEG3=DCT3.CODTAB (+)',
       'CATEG3',
       'T' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       170,
       8,
       'CELCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Celular Cnjuge',
       'Celular Cnjuge',
       '',
       'CELCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       180,
       2,
       'CELDDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DDD Celular',
       'DDD Celular',
       '',
       'CELDDD',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       190,
       8,
       'CELNUM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Celular',
       'Celular',
       '',
       'CELNUM',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       200,
       10,
       'CELUCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Celular do~Contato ',
       'Celular',
       '',
       'CELUCO',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       210,
       5,
       'CIDNAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Cidade Nasc.',
       'Cidade de nascimento do cliente',
       '',
       'CIDNAS',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       220,
       5,
       'CODCEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'CEP',
       'CEP do endereo',
       '',
       'CODCEP',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       230,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       240,
       20,
       'CODCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo Ext.Cnjugue',
       'Cdigo Externo do Cnjugue',
       '',
       'CODCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '01',
       1540,
       15,
       'CODCRC ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Insc. Contabilista',
       'Nmero de inscrio do contabilista',
       '',
       'CODCRC ',
       '' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       250,
       4,
       'CODDDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DDD Telefone',
       'DDD Telefone',
       '',
       'CODDDD',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       260,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo Ext. Cliente',
       'Cdigo Externo do Cliente',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       270,
       3,
       'CODLOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Logradouro',
       'Logradouro do endereo',
       '',
       'CODLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1580,
       7,
       'CODNAE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo CNAE',
       'Cdigo CNAE',
       '',
       'CODNAE',
       '' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '01',
       1550,
       5,
       'CODPAI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Pas',
       'Pas de Origem',
       '',
       'CODPAI',
       '' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       280,
       10,
       'CODPLA',
       'A',
       'PLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'I',
       '',
       '',
       '9',
       'F',
       'Codigo Externo',
       'Cdigo Externo',
       'ECLI.CODPLA=PLA.FILPGT(+)  AND ECLI.CODPLA=PLA.CODPGT(+)',
       'CODPLA',
       'T' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       290,
       2,
       'CODSEX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Sexo',
       'Cdigo de Sexo do Cliente',
       '',
       'CODSEX',
       'T' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       300,
       15,
       'CODVIN',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       310,
       40,
       'COMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Complemento',
       'Complemento do endereo ',
       '',
       'COMPLE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       320,
       40,
       'COMSPC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Compl. End. Trabalho',
       'Complemento Endereo Trabalho',
       '',
       'COMSPC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       330,
       5,
       'CONBOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Boleto',
       'Boleto',
       '',
       'CONBOL',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       340,
       44,
       'CONJUG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cnjuge ou Contato',
       'Nome do Cnjuge ou do  Contato principal',
       '',
       'CONJUG',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       350,
       5,
       'CONOCU',
       'S',
       'DOCU',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DOCU.DESOCU',
       'V',
       '',
       '',
       'A',
       'F',
       'Cargo Cnjuge',
       'Cargo do Cnjuge',
       'DOCU.CODTAB(+) = ECLI.CONOCU',
       'CONOCU',
       'T' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       360,
       1,
       'CONSPC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'SPC OK?',
       'Confirmao consulta SPC',
       '',
       'CONSPC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       370,
       44,
       'CONTAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Contato',
       'Nome do contato/Parente',
       '',
       'CONTAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       380,
       40,
       'CONTEL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero do Contato',
       'Nmero do contato (apenas para ordenao)',
       '',
       'CONTEL',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       390,
       1,
       'CON_LR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Local Residncia OK?',
       'Confirmao local de resid.',
       '',
       'CON_LR',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       400,
       1,
       'CON_LT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Local Trabalho OK?',
       'Confirmao local de trab.',
       '',
       'CON_LT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       410,
       1,
       'CON_TC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Talo Cheques OK?',
       'Confirmao talo cheques',
       '',
       'CON_TC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       420,
       2,
       'CTIPDOC',
       'A',
       'DDOC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDOC.DESDOC',
       'V',
       '',
       '',
       'A',
       'F',
       'Tipo Documento',
       'Tipo de Documento',
       'DDOC.TIPDOC(+) = ECLI.CTIPDOC',
       'CTIPDOC',
       'T' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       430,
       8,
       'DATA01',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       '',
       'Data livre - 1',
       '',
       'DATA01',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       440,
       8,
       'DATA02',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       '',
       'Data livre - 2',
       '',
       'DATA02',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       450,
       8,
       'DATA03',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       '',
       'Data livre - 3',
       '',
       'DATA03',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       460,
       1,
       'DATIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       470,
       8,
       'DATNAS',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Nascto/Fundao',
       'Data de nascimento',
       '',
       'DATNAS',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       480,
       8,
       'DATOPE',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Incluso',
       'Data de operao (cadastramento)',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       490,
       4,
       'DDCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DDD Celular Cnjuge',
       'DDD Celular Cnjuge',
       '',
       'DDCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       500,
       2,
       'DDDCEL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DDD Celular',
       'DDD Celular',
       '',
       'DDDCEL',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       510,
       4,
       'DDDCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'DDD do~Contato',
       'DDD do Contato',
       '',
       'DDDCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       520,
       2,
       'DDDFAX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DDD Fax',
       'DDD Fax',
       '',
       'DDDFAX',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       530,
       2,
       'DDDFXC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DDD Fax',
       'DDD Fax',
       '',
       'DDDFXC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       540,
       4,
       'DDTCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'DDD Telefone Cnjuge',
       'DDD Telefone Cnjuge',
       '',
       'DDTCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1570,
       1,
       'DENEGA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Cliente Denegado?',
       'Cliente Denegado?',
       '',
       'DENEGA',
       'T' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       550,
       20,
       'DESINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Desc. Inatividade',
       'Descrio Inatividade',
       '',
       'DESINA',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       560,
       30,
       'DESOCU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Ocupao',
       'Descrio da Ocupao(Profisso)',
       '',
       'DESOCU',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       570,
       15,
       'DOCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Doc. Cnjuge/Contato',
       'Doc. Cnjuge/Contato',
       '',
       'DOCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       580,
       15,
       'DOCEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'N Documento',
       'Nmero do documento',
       '',
       'DOCEND',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       590,
       30,
       'DTIPDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DTIPDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       600,
       20,
       'ENDCO1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'End. Trab. Cnjuge ',
       'Endereo Trabalho do Cnjuge',
       '',
       'ENDCO1',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       610,
       20,
       'ENDCO2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'End.Compl.do Cnjuge',
       'Complemento endereo do cnjuge',
       '',
       'ENDCO2',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       620,
       1,
       'ENDCOB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Cobrana?',
       'Cobrana',
       '',
       'ENDCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       630,
       1,
       'ENDCOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Correspondncia?',
       'Correspondncia',
       '',
       'ENDCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       640,
       40,
       'ENDERE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Endereo',
       'Endereo',
       '',
       'ENDERE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       650,
       34,
       'ENDLO1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'End. Ref. Coml. 1',
       'Endereo da referncia comercial 1',
       '',
       'ENDLO1',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       660,
       34,
       'ENDLO2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'End. Ref. Coml. 2',
       'Endereo da referncia comercial (loja) 2',
       '',
       'ENDLO2',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       670,
       42,
       'ENDSPC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Endereo Trabalho',
       'Endereo de Trabalho',
       '',
       'ENDSPC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       680,
       2,
       'ESTCIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Estado Civil',
       'Estado Civil',
       '',
       'ESTCIV',
       'T' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       690,
       40,
       'ESTRAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Endereo Estrangeiro',
       'Endereo estrangeiro',
       '',
       'ESTRAN',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       700,
       40,
       'E_MAIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail',
       'E-mail',
       '',
       'E_MAIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       710,
       40,
       'E_MCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail',
       'E-mail',
       '',
       'E_MCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       720,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial Cliente',
       'Filial onde foi cadastrado o cliente',
       'ECLI.FILCLI = DFIL.CODFIL (+)',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       730,
       1,
       'FILECO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILECO',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       740,
       3,
       'FILEND',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = ECLI.FILEND',
       'FILEND',
       'T' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       750,
       20,
       'FIRANT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Empresa Anterior',
       'Nome da firma anterior do cliente',
       '',
       'FIRANT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       760,
       20,
       'FIRATU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Local de Trabalho',
       'Firma atual do cliente',
       '',
       'FIRATU',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       770,
       20,
       'FIRCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Trabalho do Cnjuge',
       'Nome da firma do cnjuge ',
       '',
       'FIRCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       780,
       1,
       'FLGNAC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Nacional?',
       'Nacional?',
       '',
       'FLGNAC',
       'T' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       790,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       800,
       40,
       'HOMPGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Home Page',
       'Home Page do Cliente',
       '',
       'HOMPGE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       810,
       1,
       'ICM_CF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'ICM_CF  Nota Fiscal?',
       'ICM_CF  Nota Fiscal',
       '',
       'ICM_CF',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       820,
       7,
       'ID_DAT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data RG',
       'Data RG',
       '',
       'ID_DAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       830,
       2,
       'ID_EST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF do RG',
       'UF do RG',
       '',
       'ID_EST',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       840,
       6,
       'ID_ORG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'rgo Expeditor',
       'rgo Expeditor',
       '',
       'ID_ORG',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       850,
       15,
       'IE_END',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '2 Documento',
       '2 nmero do documento',
       '',
       'IE_END',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       860,
       15,
       'INSEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'L',
       '',
       '',
       'A',
       'F',
       '2 Documento',
       'Inscrio Estadual ou Identidade',
       '',
       'INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1560,
       12,
       'LIMCHE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Limite do Cheque',
       'Limite do Cheque sem Consulta no Serasa para Cliente no Sujeito  Restr',
       '',
       'LIMCHE',
       '' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       870,
       8,
       'LIMCRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'LIMCRE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       880,
       47,
       'LOCTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Proximidade',
       'Local prximo ao endereo',
       '',
       'LOCTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       890,
       40,
       'MAISPC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail',
       'e-mail',
       '',
       'MAISPC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       900,
       2,
       'MORMES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Meses de Moradia',
       'Tempo de moradia (meses)',
       '',
       'MORMES',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       910,
       1,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       920,
       17,
       'NACION',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nacionalidade',
       'Nacionalidade do cliente',
       '',
       'NACION',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       930,
       1,
       'NAOSPC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'No no SPC?',
       'No no SPC?',
       '',
       'NAOSPC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       940,
       8,
       'NASCNT',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nascimento',
       'Data de nascimento',
       '',
       'NASCNT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       950,
       8,
       'NASCON',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Nascto Cnj./Contato',
       'Data de nascimento do cnjuge ou contato principal',
       '',
       'NASCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       960,
       44,
       'NCONTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Contato',
       'Nome do contato/Parente',
       '',
       'NCONTA',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       980,
       44,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome/Razo Social',
       'Nome do Cliente',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       990,
       15,
       'NOMLO1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. Comercial 1',
       'Nome da referncia comercial (loja) 1',
       '',
       'NOMLO1',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1000,
       15,
       'NOMLO2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. Comercial 2',
       'Nome da referncia comercial (loja) 2',
       '',
       'NOMLO2',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1010,
       30,
       'NOMSUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Superior',
       'Nome do superior imediato do cliente',
       '',
       'NOMSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1020,
       20,
       'NOMTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Apelido',
       'Apelido',
       '',
       'NOMTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1030,
       4,
       'NUMCOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DDD Cnjuge (coml)',
       'DDD telefone do cnjuge',
       '',
       'NUMCOC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1040,
       4,
       'NUMCOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DDD (coml)',
       'Nmero do DDD da firma',
       '',
       'NUMCOD',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1050,
       2,
       'NUMCON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero do Contato',
       'Nmero do contato (apenas para ordenao)',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1060,
       3,
       'NUMDEP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero de Dependente',
       'Nmero de Dependentes',
       '',
       'NUMDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1070,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento (CPF/CNPJ)',
       'Nmero do Documento: CNPJ ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1080,
       1,
       'NUMECO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NUMECO',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1090,
       2,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero de Endereos',
       'Nmero de Endereos',
       '',
       'NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1100,
       15,
       'NUMERO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero',
       'Nmero',
       '',
       'NUMERO',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1110,
       8,
       'NUMFAX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'FAX ',
       'Nmero do fax',
       '',
       'NUMFAX',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1120,
       20,
       'NUMFON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Telefone',
       'Nmero do telefone',
       '',
       'NUMFON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1130,
       8,
       'NUMFXC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Fax',
       'Fax',
       '',
       'NUMFXC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1140,
       8,
       'NUMTEL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fone (coml)',
       'Nmero do telefone da firma',
       '',
       'NUMTEL',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1150,
       10,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(ECLI.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1160,
       254,
       'OBSOUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'OBS. CheckOut',
       'Obervao para CheckOut',
       '',
       'OBSOUT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1170,
       30,
       'ORIRED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Origem da Renda',
       'Origem da Renda',
       '',
       'ORIRED',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1180,
       2,
       'PORPAD',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       '',
       'A',
       'F',
       'Portador Padro',
       'Portador padro',
       'ECLI.PORPAD=DCOB.CODTAB (+)',
       'PORPAD',
       'T' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1190,
       15,
       'REGIAO',
       'A',
       'DREG',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DREG.REGIAO',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       'DREG.CODTAB(+)=ECLI.REGIAO',
       'REGIAO',
       'T' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1200,
       15,
       'RGCONJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identidade Cnjuge',
       'Nmero da Identidade do cnjuge',
       '',
       'RGCONJ',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1210,
       8,
       'SALBAC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Salrio do Cnjuge',
       'Salrio base do cnjuge',
       '',
       'SALBAC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1220,
       8,
       'SALBAS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Salrio',
       'Salrio base do cliente',
       '',
       'SALBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1230,
       6,
       'SERCAC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Srie da CTPS (Cnj)',
       'Srie da carteira de trabalho do cnjuge ',
       '',
       'SERCAC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1240,
       6,
       'SERCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Srie da CTPS',
       'Nmero da srie da carteira de trabalho',
       '',
       'SERCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1250,
       2,
       'SEXCON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Sexo do Cnjuge',
       'Sexo do cnjuge ',
       '',
       'SEXCON',
       'T' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1260,
       2,
       'SEXOCO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Sexo do Contato',
       'Sexo',
       '',
       'SEXOCO',
       'T' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1270,
       2,
       'SIGEST',
       'A',
       'DEST',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEST.ESTADO',
       'V',
       '',
       '',
       'A',
       'F',
       'UF',
       'UF ',
       'DEST.ESTADO = ECLI.SIGEST',
       'SIGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1280,
       1,
       'SIMPLE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Opt. pelo Simples?',
       'Optante pelo Simples',
       '',
       'SIMPLE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1290,
       12,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       '',
       '',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1300,
       8,
       'TELCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Telefone do Cnjuge',
       'Telefone do Cnjuge',
       '',
       'TELCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1310,
       8,
       'TELSPC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fone Cnjuge (coml)',
       'Nmero telefone do cnjuge',
       '',
       'TELSPC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1320,
       1,
       'TEMAUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tem automvel?',
       'Tem Automvel',
       '',
       'TEMAUT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1330,
       1,
       'TEM_CC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tem Carto Crdito?',
       'Tem Carto Crdito',
       '',
       'TEM_CC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1340,
       1,
       'TEM_TC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tem Talo Cheques?',
       'Tem Talo de Cheque',
       '',
       'TEM_TC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1350,
       1,
       'TIPCLI1',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Cliente Transportado',
       'Cliente Transportadora',
       '',
       'TIPCLI1',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1360,
       1,
       'TIPCLI10',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Cartes? ',
       'Cartes',
       '',
       'TIPCLI10',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1370,
       1,
       'TIPCLI2',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Fornecedor?',
       'Fornecedor',
       '',
       'TIPCLI2',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1380,
       1,
       'TIPCLI3',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Indicador Venda?',
       'Indicador Venda',
       '',
       'TIPCLI3',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1390,
       1,
       'TIPCLI4',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Marca?',
       'Marca',
       '',
       'TIPCLI4',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1400,
       1,
       'TIPCLI5',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tec. Interno?',
       'Tec. Interno',
       '',
       'TIPCLI5',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1410,
       1,
       'TIPCLI6',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Motorista?',
       'Motorista',
       '',
       'TIPCLI6',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1420,
       1,
       'TIPCLI7',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Representante?',
       'Representante',
       '',
       'TIPCLI7',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1430,
       1,
       'TIPCLI8',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Transportador?',
       'Transportador',
       '',
       'TIPCLI8',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1440,
       1,
       'TIPCLI9',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tcnico Externo?',
       'Tcnico Externo',
       '',
       'TIPCLI9',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1450,
       1,
       'TIPCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1460,
       5,
       'TIPEND',
       'S',
       'DEND',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEND.DESEND',
       'V',
       '',
       '',
       'N',
       'F',
       'Tipo do Endereo',
       'Tipo do Endereo',
       'DEND.CODTAB = ECLI.TIPEND(+)',
       'TIPEND',
       'T' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1470,
       1,
       'TIPPES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPPES',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1480,
       1,
       'TIPRES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Residncia',
       'Tipo de residncia',
       '',
       'TIPRES',
       'T' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1490,
       15,
       'TRACON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome de Tratamento',
       'Nome de Tratamento',
       '',
       'TRACON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1500,
       7,
       'ULTEXP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data/Hora~Exportao',
       'Data/Hora~Exportao',
       '',
       'ULTEXP',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1510,
       20,
       'ULTNOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sobrenome/Fantasia',
       'Sobrenome ou fantasia',
       '',
       'ULTNOM',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1520,
       1,
       'USA_NF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Nota Fiscal?',
       'Usa Nota Fiscal?',
       '',
       'USA_NF',
       'F' FROM DUAL
UNION ALL
SELECT 'ECLI',
       '--',
       1530,
       12,
       'VLRRED',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor da Renda',
       'Valor da Renda',
       '',
       'VLRRED',
       'F' FROM DUAL
);

/*-- SEQ 7738 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ECLI',
       'DENEGA',
       1,
       ' ',
       'No',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'DENEGA',
       2,
       ' ',
       'Sim',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'DENEGA',
       3,
       ' ',
       'Sim. Permitir Vendas.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'CODSEX',
       0,
       ' ',
       'Nao conhecido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'CODSEX',
       2,
       ' ',
       'Feminino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'CODSEX',
       1,
       ' ',
       'Masculino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'ESTCIV',
       6,
       ' ',
       'Separado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'ESTCIV',
       5,
       ' ',
       'Unio Estvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'ESTCIV',
       0,
       ' ',
       'Indefinido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'ESTCIV',
       4,
       ' ',
       'Divorciado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'ESTCIV',
       1,
       ' ',
       'Solteiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'ESTCIV',
       2,
       ' ',
       'Casado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'ESTCIV',
       3,
       ' ',
       'Viuvo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'FLGNAC',
       0,
       'F',
       'Brasileiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'FLGNAC',
       0,
       'T',
       'Estrangeiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'FLGTIP',
       0,
       ' ',
       'Fisica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'FLGTIP',
       1,
       ' ',
       'Juridica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'FLGTIP',
       2,
       ' ',
       'Entidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'FLGTIP',
       3,
       ' ',
       'Especial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'FLGTIP',
       4,
       ' ',
       'M.E.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'FLGTIP',
       5,
       ' ',
       'Filial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'SEXCON',
       0,
       ' ',
       'Nao Conhecido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'SEXCON',
       1,
       ' ',
       'Masculino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'SEXCON',
       2,
       ' ',
       'Feminino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'SEXOCO',
       0,
       ' ',
       'Masculino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'SEXOCO',
       1,
       ' ',
       'Feminino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'TIPRES',
       3,
       ' ',
       'Mora com os Parentes',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'TIPRES',
       4,
       ' ',
       'Mora no Trabalho',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'TIPRES',
       5,
       ' ',
       'No Informada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'TIPRES',
       0,
       ' ',
       'Alugada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'TIPRES',
       1,
       ' ',
       'Financiada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECLI',
       'TIPRES',
       2,
       ' ',
       'Prpria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7739 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ECMS',
       TO_NUMBER(null),
       'ECMS',
       'Exp. de Comisses',
       'TV_ECMS',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7740 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ECMS','--','' FROM DUAL
UNION ALL
SELECT 'ECMS','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ECMS','99','Outros' FROM DUAL
);

/*-- SEQ 7741 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ECMS',
       '--',
       10,
       3,
       'CODPGT',
       'A',
       'PLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       '',
       '',
       'A',
       'F',
       'Plano',
       'Plano',
       'PLA.FILPGT = CMS.FILPGT AND PLA.CODPGT = CMS.CODPGT',
       'CODPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECMS',
       '--',
       20,
       2,
       'CODSER',
       'A',
       'SER2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SER2.CODSER',
       'V',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Srie',
       'SER2.CODSER = CMS.CODSER',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'ECMS',
       '--',
       30,
       3,
       'CODVEN',
       'A',
       'VDD ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'VDD.APEUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Vendedor',
       'Vendedor',
       'VDD.FILUSU = CMS.FILVEN AND VDD.CODUSU = CMS.CODVEN',
       'CODVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'ECMS',
       '--',
       40,
       8,
       'COMISSAO',
       'F',
       '',
       3,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Comisso',
       'Comisso',
       '',
       'COMISSAO',
       'F' FROM DUAL
UNION ALL
SELECT 'ECMS',
       '--',
       50,
       5,
       'COMSOB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Comisso',
       'Tipo de Comisso',
       '',
       'COMSOB',
       'T' FROM DUAL
UNION ALL
SELECT 'ECMS',
       '--',
       60,
       8,
       'DATA',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data',
       'Data',
       '',
       'DATA',
       'F' FROM DUAL
UNION ALL
SELECT 'ECMS',
       '--',
       70,
       1,
       'DATIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Data Imp.',
       'Data Imp.',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'ECMS',
       '--',
       80,
       13,
       'DOCUMENTO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DOCUMENTO',
       'F' FROM DUAL
UNION ALL
SELECT 'ECMS',
       '--',
       90,
       3,
       'FILIAL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = CMS.FILIAL',
       'FILIAL',
       'F' FROM DUAL
UNION ALL
SELECT 'ECMS',
       '--',
       100,
       3,
       'FILPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Cdigo da filial do plano',
       '',
       'FILPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECMS',
       '--',
       110,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Cdigo da filial do vendedor',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'ECMS',
       '--',
       120,
       1,
       'FLGPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Operao',
       'Operao
Operao',
       '',
       'FLGPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'ECMS',
       '--',
       130,
       1,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo da Rejeio',
       'Motivo da Rejeio',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'ECMS',
       '--',
       140,
       5,
       'PARCELA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Parcela',
       'Parcela',
       '',
       'PARCELA',
       'F' FROM DUAL
UNION ALL
SELECT 'ECMS',
       '--',
       150,
       8,
       'PERCENTUAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '%',
       '%',
       '',
       'PERCENTUAL',
       'F' FROM DUAL
UNION ALL
SELECT 'ECMS',
       '--',
       160,
       12,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Status',
       'Status',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'ECMS',
       '--',
       170,
       8,
       'VALORDOC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base de Clculo',
       'Base de Clculo - Valor do Documento',
       '',
       'VALORDOC',
       'F' FROM DUAL
);

/*-- SEQ 7742 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ECMS',
       'COMSOB',
       8,
       ' ',
       'Markup no momento da Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECMS',
       'COMSOB',
       6,
       ' ',
       'A receber na compensao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECMS',
       'COMSOB',
       7,
       ' ',
       'Comisso por Markup',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECMS',
       'COMSOB',
       5,
       ' ',
       'Recebimento na compensao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECMS',
       'COMSOB',
       0,
       ' ',
       'Lquido ao Vender',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECMS',
       'COMSOB',
       1,
       ' ',
       'Bruto ao Vender',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECMS',
       'COMSOB',
       2,
       ' ',
       'A receber no Vencimento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECMS',
       'COMSOB',
       3,
       ' ',
       'Recebido no Recebimento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECMS',
       'COMSOB',
       4,
       ' ',
       'A receber no Recebimento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECMS',
       'FLGPAR',
       0,
       'D',
       'Devolues',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECMS',
       'FLGPAR',
       0,
       'E',
       'Entrada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECMS',
       'FLGPAR',
       0,
       'P',
       'Parcela',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECMS',
       'FLGPAR',
       0,
       'V',
       ' Vista',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7743 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ECOB',
       TO_NUMBER(null),
       'ECOB',
       'Endereo Cobrana',
       'TT_END',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'ECOB.FILCLI,ECOB.CODCLI,ECOB.CODFIL,ECOB.NUMEND
CLI.ID,ECOB.APEEND',
       '' FROM DUAL
);

/*-- SEQ 7744 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ECOB','--','' FROM DUAL
UNION ALL
SELECT 'ECOB','01','Localizao' FROM DUAL
UNION ALL
SELECT 'ECOB','02','Outros Dados' FROM DUAL
);

/*-- SEQ 7745 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 26735,
       'COM ',
       'ECOB',
       'N',
       '1',
       '',
       '',
       'COM.FILFOR = ECOB.FILCLI AND
COM.CODFOR = ECOB.CODCLI AND
COM.FILEND = ECOB.CODFIL AND
COM.NUMEND = ECOB.NUMEND',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26736,
       'CON ',
       'ECOB',
       'N',
       '1',
       '',
       '',
       'CON.FILCLI = ECOB.FILCLI AND
CON.CODCLI = ECOB.CODCLI AND
CON.FILEND = ECOB.CODFIL AND
CON.NUMEND = ECOB.NUMEND',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26737,
       'LIM ',
       'ECOB',
       'N',
       '1',
       '',
       '',
       'LIM.FILCLI = ECOB.FILCLI AND
LIM.CODCLI = ECOB.CODCLI AND
LIM.FILCOB = ECOB.CODFIL AND
LIM.ENDCOB = ECOB.NUMEND',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26738,
       'MUN ',
       'ECOB',
       '01',
       '0N',
       '',
       '',
       'MUN.CODIGO(+) = ECOB.CODCID',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26739,
       'PEND',
       'ECOB',
       '01',
       '1',
       '',
       '',
       'PEDE.FILCLI = ECOB.FILCLI AND
PEDE.CODCLI = ECOB.CODCLI AND
PEDE.FILEND = ECOB.CODFIL AND
PEDE.NUMEND = ECOB.NUMEND',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26740,
       'SUP ',
       'ECOB',
       'N',
       '1',
       '',
       '',
       'SUP.FILFOR = ECOB.FILCLI AND
SUP.CODFOR = ECOB.CODCLI AND
SUP.FILEND = ECOB.CODFIL AND
SUP.NUMEND = ECOB.NUMEND',
       '',
       '' FROM DUAL
);

/*-- SEQ 7746 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ECOB',
       '01',
       80,
       40,
       'BAIRRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Bairro',
       'Bairro',
       '',
       'BAIRRO',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       16,
       9,
       'CEP_LOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'CEP+Log',
       'CEP+Log',
       '',
       'CODCEP||''-''||ECOB.CODLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '02',
       380,
       10,
       'CLI_CK',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cd Cliente Checkout',
       'Cdigo para cliente cadastrado no Checkout',
       '',
       'CLI_CK',
       '' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       290,
       5,
       'CODARC',
       'S',
       'DARC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DARC.DESARC',
       'V',
       '',
       '',
       'N',
       'F',
       'AvisoCorrespondncia',
       'Cdigo de Aviso de Recebimento de Correspondncia',
       'DARC.CODTAB = ECOB.CODARC(+)',
       'CODARC',
       'T' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       150,
       5,
       'CODCEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'CEP',
       'Cep do endereo',
       '',
       'CODCEP',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       10,
       5,
       'CODCID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo da Cidade',
       'Cdigo da Cidade',
       '',
       'CODCID',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Cliente',
       'Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       180,
       4,
       'CODDDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'DDD Telefone',
       'DDD Telefone',
       '',
       'CODDDD',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '--',
       390,
       10,
       'CODECO',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo no E-commerce',
       'Cdigo no E-commerce',
       '',
       'CODECO',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = ECOB.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       160,
       3,
       'CODLOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'Logradouro',
       'Logradouro do endereo',
       '',
       'CODLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '02',
       340,
       5,
       'CODPAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Pas',
       'Pas',
       '',
       'CODPAI',
       '' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '02',
       370,
       10,
       'COD_CK',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo Checkout',
       'Cdigo para endereo cadastrado no Checkout',
       '',
       'COD_CK',
       '' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       140,
       40,
       'COMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Complemento',
       'Complemento do endereo',
       '',
       'COMPLE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       60,
       44,
       'CONTAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Contato',
       'Contato',
       '',
       'CONTAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       90,
       2,
       'DDDFAX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DDD Fax',
       'DDD Fax',
       '',
       'DDDFAX',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '02',
       360,
       3,
       'ECF_CK',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       '',
       'ECF Checkout',
       'ECF para endereo cadastrado no Checkout',
       'DECF.FILECF (+) = ECOB.FIL_CK AND DECF.NUMECF (+) = ECOB.ECF_CK',
       'ECF_CK',
       'T' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '02',
       240,
       1,
       'ENDCOB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'T',
       'Cobrana?',
       'Cobrana',
       '',
       'ENDCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '02',
       250,
       1,
       'ENDCOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'T',
       'Correspondncia?',
       'Correspondncia',
       '',
       'ENDCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       5,
       40,
       'ENDERE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Endereo',
       'Endereo',
       '',
       'ENDERE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       230,
       40,
       'ESTRAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       130,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Endereo Estrangeiro',
       'Endereo estrangeiro',
       '',
       'ESTRAN',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       40,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       'DFIL.CODFIL = ECOB.FILCLI',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '--',
       330,
       3,
       'FILUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'A',
       '',
       'Usu. lt. alterao',
       'Usurio da ltima alterao',
       'ECOB.FILUSU = USU2.FILUSU  AND ECOB.CODUSU = USU2.CODUSU',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '02',
       350,
       3,
       'FIL_CK',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Checkout',
       'Filial para endereo cadastrado no Checkout',
       'DFIL.CODFIL (+) = ECOB.FIL_CK',
       'FIL_CK',
       'T' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       220,
       1,
       'FLGNAC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       120,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'T',
       'Nacional?',
       'Nacionalidade',
       '',
       'FLGNAC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '02',
       270,
       15,
       'INSEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       '2. Documento',
       '2 nmero do documento',
       '',
       'INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       170,
       47,
       'LOCTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       70,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Proximidade',
       'Local prximo ao endereo',
       '',
       'LOCTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '02',
       260,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'Documento',
       'Nmero do documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       50,
       4,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero de Enderecos',
       'Nmero de Endereos',
       '',
       'NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       250,
       15,
       'NUMERO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero',
       'Nmero',
       '',
       'NUMERO',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       200,
       8,
       'NUMFAX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'FAX',
       'Nmero do fax',
       '',
       'NUMFAX',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       190,
       10,
       'NUMFON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'Telefone',
       'Nmero do telefone',
       '',
       'NUMFON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       300,
       5,
       'OLDCID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Cidade Ant.',
       'Cdigo Cidade Antiga',
       '',
       'OLDCID',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       210,
       2,
       'REGIAO',
       'S',
       'DREG',
       0,
       TO_NUMBER(null),
       '',
       110,
       TO_NUMBER(null),
       '',
       'DREG.REGIAO',
       'V',
       '',
       'F',
       'A',
       'T',
       'Regio',
       'Regio do endereo',
       'DREG.CODTAB = ECOB.REGIAO',
       'REGIAO',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       260,
       2,
       'SIGEST',
       'A',
       'DEST',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEST.ESTADO',
       'V',
       '',
       '',
       'A',
       'F',
       'UF',
       'UF',
       'DEST.ESTADO = ECOB.SIGEST',
       'SIGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       310,
       1,
       'TIPARC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo A.R.C.',
       'Tipo Aviso Recebimento Correspondncia',
       '',
       'TIPARC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       320,
       5,
       'TIPEND',
       'S',
       'DEND',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEND.DESEND',
       'V',
       '',
       '',
       'N',
       'F',
       'Tipo do Endereo',
       'Tipo do Endereo',
       'DEND.CODTAB = ECOB.TIPEND(+)',
       'TIPEND',
       'T' FROM DUAL
UNION ALL
SELECT 'ECOB',
       '01',
       280,
       1,
       'USA_NF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Nota Fiscal?',
       'Usa Nota Fiscal?',
       '',
       'USA_NF',
       'F' FROM DUAL
);

/*-- SEQ 7747 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ECOB',
       'TIPARC',
       0,
       ' ',
       'Nenhum',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOB',
       'TIPARC',
       0,
       'F',
       'Recebeu ARC',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7748 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ECOM',
       TO_NUMBER(null),
       'ECOM',
       'Exportao de Compra',
       'TV_ECOM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7749 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ECOM','--','' FROM DUAL
UNION ALL
SELECT 'ECOM','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ECOM','99','Outros' FROM DUAL
);

/*-- SEQ 7750 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ECOM',
       '--',
       10,
       8,
       'ACRESC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Desconto',
       'Desconto',
       '',
       'ACRESC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       581,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN ECOM.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       20,
       1,
       'ATUCUS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Atualiza Custos?',
       'Atualiza Custos?',
       '',
       'ATUCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       30,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       40,
       12,
       'BASFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base de ICM do frete',
       'Base de ICM do frete',
       '',
       'BASFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       860,
       14,
       'BSTFRE ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base de Substituio',
       'Base de Substituio',
       '',
       'BSTFRE ',
       '' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '01',
       840,
       44,
       'CHAVEA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Chave acesso da NF-e',
       'Chave de acesso da NF-e',
       '',
       'CHAVEA',
       '' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       50,
       9,
       'CLIENTE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CLIENTE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       60,
       6,
       'CODCFO',
       'A',
       'CFOP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'CFOP.DESCFO',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo CFOP',
       'Cdigo CFOP',
       'CFOP.CODTAB(+) = ECOM.CODCFO',
       'CODCFO',
       'T' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '99',
       820,
       2,
       'CODFCE',
       'A',
       'DFCE',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFCE.DESFCE',
       'V',
       '',
       '',
       'A',
       '',
       'Consumo Energia Elet',
       'Classe de Consumo de Energia Eltrica',
       'ECOM.CODFCE=DFCE.CODFCE',
       'CODFCE',
       '' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       70,
       3,
       'CODFIL',
       'F',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Cdigo da Filial de Origem',
       'DFIL.CODFIL = ECOM.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       80,
       20,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo do fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       90,
       5,
       'CODMOE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Moeda',
       'Descrio da moeda',
       '',
       'CODMOE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       100,
       2,
       'CODSER',
       'A',
       'VFIS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'VFIS.CODSER',
       'V',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Cdigo da srie',
       'VFIS.CODSER = ECOM.CODSER AND VFIS.SUBSER_FIS=ECOM.SUBSER_FIS',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       110,
       15,
       'CODSET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'CODSET',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '01',
       850,
       5,
       'CODTRI',
       'S',
       'DTRI',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DTRI.CODTRI',
       'V',
       '',
       '',
       'N',
       '',
       'CST',
       'Cdigo da Situao Tributria',
       'DTRI.CODTAB = COM.CODTRI',
       'CODTRI',
       '' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       120,
       10,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo externo',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       130,
       10,
       'CONPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cond. Pagto.',
       'Condio de Pagamento',
       '',
       'CONPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       140,
       8,
       'DATCMP',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Compra',
       'Data da compra',
       '',
       'DATCMP',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       150,
       7,
       'DATIMP',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       160,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Lanto',
       'Data da operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       170,
       8,
       'DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Desconto',
       'Desconto',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       180,
       12,
       'DESPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Despesas na parcela',
       'Despesas Inclusas na parcela',
       '',
       'DESPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       190,
       3,
       'ESPDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Espcie Docto',
       'Espcie de Documento',
       '',
       'ESPDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       940,
       1,
       'EXPFIS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exportado Fiscal?',
       'Exportado Fiscal?',
       '',
       'EXPFIS',
       '' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       200,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exporta?',
       'Exporta?',
       '',
       'EXPORT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       950,
       1,
       'EXPORT_CAN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exportado Cancelado?',
       'Exportado Cancelado?',
       '',
       'EXPORT_CAN',
       '' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       210,
       3,
       'FILCTA',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = ECOM.CODFIL',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       220,
       3,
       'FILEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial endereo',
       'Filial endereo',
       '',
       'FILEND',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       230,
       3,
       'FILFAT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'FAT.CODFIL = ECOM.CODFIL (+)',
       'FILFAT',
       'T' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       240,
       3,
       'FILFRE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Cdigo da Filial de Origem',
       'FRE.CODFIL = ECOM.CODFIL (+)',
       'FILFRE',
       'T' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       250,
       1,
       'FLGCOF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Inside COFINS?',
       'H insidncia de COFINS?',
       '',
       'FLGCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       260,
       1,
       'FLGCSS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Inside Contr.Social?',
       'H insidncia de contribuio social?',
       '',
       'FLGCSS',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       270,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao (Devolvida/Quitada/Em aberto)',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       280,
       1,
       'FLGINS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Inside INSS?',
       'H insidncia de INSS?',
       '',
       'FLGINS',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       290,
       1,
       'FLGPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Inside PIS?',
       'H insidncia de PIS?',
       '',
       'FLGPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       300,
       20,
       'FORFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Alternativo nico',
       '',
       'FORFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       310,
       20,
       'FORFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Alternativo nico',
       '',
       'FORFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       930,
       1,
       'FXC_FLGCOF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Retm COFINS FxC',
       'Retm COFINS para Frete/Compromissos',
       '',
       'FXC_FLGCOF',
       '' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       920,
       1,
       'FXC_FLGPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Retm PIS FxC',
       'Retm PIS para Frete/Compromissos',
       '',
       'FXC_FLGPIS',
       '' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       890,
       2,
       'FXC_SITCOF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'CST COFINS FxC',
       'CST COFINS para Frete/Compromissos',
       '',
       'FXC_SITCOF',
       'T' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       880,
       2,
       'FXC_SITPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'CST PIS FxC',
       'CST PIS para Frete/Compromissos',
       '',
       'FXC_SITPIS',
       'T' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       910,
       12,
       'FXC_VLRCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor COFINS FxC',
       'Valor COFINS para Frete/Compromissos',
       '',
       'FXC_VLRCOF',
       '' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       900,
       12,
       'FXC_VLRPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor PIS FxC',
       'Valor PIS para Frete/Compromissos',
       '',
       'FXC_VLRPIS',
       '' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       320,
       12,
       'ICMFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'ICMS Frete',
       'ICMS Frete',
       '',
       'ICMFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       330,
       1,
       'INCOJU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Correo',
       'Indicador do tipo de correo de juros',
       '',
       'INCOJU',
       'T' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       340,
       1,
       'INTPJU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Juros',
       'Indicador do tipo de juros',
       '',
       'INTPJU',
       'T' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       350,
       1,
       'INTPMU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Multa',
       'Indicador do tipo de multa',
       '',
       'INTPMU',
       'T' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       360,
       5,
       'MOEJUR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Moeda',
       'Descrio da moeda',
       '',
       'MOEJUR',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       370,
       1,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       380,
       0,
       'NOTESP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Nota Especial?',
       'Nota Especial',
       '',
       'NOTESP',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       390,
       4,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero de Endereos',
       'Nmero de Endereos',
       '',
       'NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       400,
       6,
       'NUMFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero',
       'Nmero da fatura',
       '',
       'NUMFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       410,
       8,
       'NUMFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero',
       'Nmero do conhecimento',
       '',
       'NUMFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       420,
       8,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero',
       'Nmero da nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       430,
       5,
       'NUMVOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero de Volumes',
       'Nmero de Volumes',
       '',
       'NUMVOL',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       440,
       4000,
       'OBSERV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observaes',
       'Observaes',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       450,
       255,
       'OBSFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao Fatura',
       'Observao Fatura',
       '',
       'OBSFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       460,
       12,
       'OUTDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Despesas avulso',
       'Despesas de Pagamento avulso',
       '',
       'OUTDES',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       470,
       8,
       'OUTTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Outras Taxas',
       'Outras taxas',
       '',
       'OUTTAX',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       480,
       12,
       'PERCSS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '%Contribuio~Social',
       '%Contribuio Social',
       '',
       'PERCSS',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       490,
       5,
       'PERFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% do ICM do frete',
       '% do ICM do frete',
       '',
       'PERFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       500,
       12,
       'PERICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% ICMS',
       '% ICMS',
       '',
       'PERICM',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       510,
       12,
       'PERINS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% INSS',
       '% INSS',
       '',
       'PERINS',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       520,
       12,
       'PERIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% IRRF',
       '% IRRF',
       '',
       'PERIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       530,
       12,
       'PERISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% ISS',
       '% ISS',
       '',
       'PERISS',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       540,
       8,
       'QTDTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtd. Total',
       'Quantidade total',
       '',
       'QTDTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       550,
       12,
       'RETCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Reteno de COFINS',
       'Reteno de COFINS',
       '',
       'RETCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       560,
       2,
       'SERFAT',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Cdigo da srie',
       'FAT.CODSER=ECOM.CODSER (+)',
       'SERFAT',
       'T' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       570,
       2,
       'SERFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Cdigo da srie',
       '',
       'SERFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       580,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN ECOM.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       590,
       12,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       870,
       14,
       'ST_FRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr. de Substituio',
       'Valor de Substituio',
       '',
       'ST_FRE',
       '' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       600,
       3,
       'SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub-Srie',
       'Sub-Srie de compra',
       '',
       'SUBSER',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       610,
       12,
       'SUBSTT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Substit. Tributria',
       'Substit. Tributria',
       '',
       'SUBSTT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       620,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '01',
       830,
       1,
       'TIPFRE',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo de Frete',
       'Tipo de Frete',
       '',
       'TIPFRE',
       'T' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       630,
       1,
       'TIPNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Documento',
       'Tipo de Documento',
       '',
       'TIPNOT',
       'T' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       640,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Parceiro',
       'Tipo de Parceiro',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       650,
       1,
       'TIPTRP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Transp. Frete',
       'Tipo de Transporte no Registro de Frete',
       '',
       'TIPTRP',
       'T' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       660,
       250,
       'TITCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Conta',
       'Conta',
       '',
       'TITCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       670,
       2,
       'UFNOTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF da Nota',
       'UF da Nota',
       '',
       'UFNOTA',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       680,
       1,
       'USOCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Uso da Conta',
       'Uso da Conta',
       '',
       'USOCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       690,
       3,
       'USUARIO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo Usurio',
       'Cdigo do Usurio',
       '',
       'USUARIO',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       700,
       14,
       'VLRBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Bonificao',
       'Valor Bonificao',
       '',
       'VLRBON',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       710,
       12,
       'VLRCSS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Contr.Social',
       'Valor Contribuio Social',
       '',
       'VLRCSS',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       720,
       12,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor do frete',
       'Valor do frete',
       '',
       'VLRFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       730,
       12,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor ICMS',
       'Valor ICMS',
       '',
       'VLRICM',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       740,
       12,
       'VLRINS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor INSS',
       'Valor INSS',
       '',
       'VLRINS',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       750,
       12,
       'VLRIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor IRRF',
       'Valor IRRF',
       '',
       'VLRIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       760,
       12,
       'VLRISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor ISS',
       'Valor ISS',
       '',
       'VLRISS',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       770,
       8,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Lquido',
       'Valor lquido',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       780,
       12,
       'VLRRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Reteno',
       'Valor Reteno',
       '',
       'VLRRET',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       790,
       8,
       'VLRTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Total',
       'Valor total',
       '',
       'VLRTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       800,
       8,
       'VLTXJU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Juros',
       'Valor ou taxa de juros',
       '',
       'VLTXJU',
       'F' FROM DUAL
UNION ALL
SELECT 'ECOM',
       '--',
       810,
       8,
       'VLTXMU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Multa',
       'Valor ou taxa de multa',
       '',
       'VLTXMU',
       'F' FROM DUAL
);

/*-- SEQ 7751 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ECOM',
       'FLGEST',
       0,
       'A',
       'Em aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FLGEST',
       0,
       'D',
       'Devolvida',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FLGEST',
       0,
       'Q',
       'Quitada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Presum-Aquis NTrib Export',
       TO_NUMBER(null),
       '65' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Presum-Aquis Trib NTrib Exp
',
       TO_NUMBER(null),
       '66' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Presum-Outras Operaes
',
       TO_NUMBER(null),
       '67' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Aquisio sem Dir Crdito',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Aquisio com Iseno',
       TO_NUMBER(null),
       '71' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Aquisio com Suspenso',
       TO_NUMBER(null),
       '72' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Aquisio a Alquota Zero',
       TO_NUMBER(null),
       '73' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Aquisio sem Inc Contrib',
       TO_NUMBER(null),
       '74' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Aquisio por ST
',
       TO_NUMBER(null),
       '75' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Outras Operaes de Entrada',
       TO_NUMBER(null),
       '98' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Crdito-Tributada',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Crdito-No Tributada',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Crdito-Exportao',
       TO_NUMBER(null),
       '52' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Crdito-Vinc Trib Export',
       TO_NUMBER(null),
       '54' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Crdito-Vinc NTrib Export',
       TO_NUMBER(null),
       '55' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib Exp',
       TO_NUMBER(null),
       '56' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Presum-Aquis Exc Trib',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Presum-Aquis Exc NTrib',
       TO_NUMBER(null),
       '61' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Presum-Aquis Exc Export',
       TO_NUMBER(null),
       '62' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Presum-Aquis Trib NTrib',
       TO_NUMBER(null),
       '63' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITCOF',
       0,
       ' ',
       'Presum-Aquis Trib Export',
       TO_NUMBER(null),
       '64' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Aquisio por ST
',
       TO_NUMBER(null),
       '75' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Outras Operaes de Entrada',
       TO_NUMBER(null),
       '98' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Crdito-Tributada',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Crdito-No Tributada',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Crdito-Exportao',
       TO_NUMBER(null),
       '52' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib
',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Crdito-Vinc Trib Export',
       TO_NUMBER(null),
       '54' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Crdito-Vinc NTrib Export',
       TO_NUMBER(null),
       '55' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib Exp',
       TO_NUMBER(null),
       '56' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Presum-Aquis Exc Trib
',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Presum-Aquis Exc NTrib
',
       TO_NUMBER(null),
       '61' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Presum-Aquis Exc Export',
       TO_NUMBER(null),
       '62' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Presum-Aquis Trib NTrib',
       TO_NUMBER(null),
       '63' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Presum-Aquis Trib Export',
       TO_NUMBER(null),
       '64' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Presum-Aquis NTrib Export',
       TO_NUMBER(null),
       '65' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Presum-Aquis Trib NTrib Exp',
       TO_NUMBER(null),
       '66' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Presum-Outras Operaes',
       TO_NUMBER(null),
       '67' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Aquisio sem Dir Crdito',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Aquisio com Iseno',
       TO_NUMBER(null),
       '71' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Aquisio com Suspenso',
       TO_NUMBER(null),
       '72' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Aquisio a Alquota Zero',
       TO_NUMBER(null),
       '73' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'FXC_SITPIS',
       0,
       ' ',
       'Aquisio sem Inc Contrib',
       TO_NUMBER(null),
       '74' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'INCOJU',
       0,
       '$',
       'Moeda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'INCOJU',
       0,
       '0',
       'Nao h',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'INCOJU',
       0,
       'A',
       'Anual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'INTPJU',
       0,
       'C',
       'Composto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'INTPJU',
       0,
       'F',
       'Fixo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'INTPJU',
       0,
       'S',
       'Simples',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'INTPMU',
       0,
       '#',
       'Percentual Corrigido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'INTPMU',
       0,
       '$',
       'Valor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'INTPMU',
       0,
       '%',
       'Percentual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'TIPFRE',
       0,
       '0',
       'Por conta de terceiros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'TIPFRE',
       0,
       '1',
       'Por conta do emitente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'TIPFRE',
       0,
       '2',
       'Por conta do destinatrio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'TIPFRE',
       0,
       '9',
       'Sem cobrana de frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'TIPNOT',
       0,
       'A',
       'N.F.F.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'TIPNOT',
       0,
       'F',
       'Fatura',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'TIPNOT',
       0,
       'N',
       'Nota Fiscal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'TIPPAR',
       0,
       'F',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'TIPPAR',
       0,
       'T',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'TIPPAR',
       0,
       'X',
       'Compromisso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'TIPTRP',
       0,
       '0',
       'Rodovirio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'TIPTRP',
       0,
       '1',
       'Aquavirio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'TIPTRP',
       0,
       '2',
       'Areo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'USOCTA',
       0,
       '+',
       'Entradas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'USOCTA',
       0,
       '-',
       'Sadas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECOM',
       'USOCTA',
       0,
       'B',
       'Bancos',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7752 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ECON',
       TO_NUMBER(null),
       'ECON',
       'Exportao Contabil',
       'TV_ECON',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7753 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ECON','--','' FROM DUAL
UNION ALL
SELECT 'ECON','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ECON','99','Outros' FROM DUAL
);

/*-- SEQ 7754 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ECON',
       '--',
       10,
       1,
       'AGRUPA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Agrupa',
       'Agrupa',
       '',
       'AGRUPA',
       'F' FROM DUAL
UNION ALL
SELECT 'ECON',
       '--',
       20,
       5,
       'CODCRT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Conta  contra-lanam',
       'Conta de contra-lanamento',
       '',
       'CODCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECON',
       '--',
       30,
       20,
       'CODCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Conta do lanamento',
       'Conta do lanamento',
       '',
       'CODCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'ECON',
       '--',
       40,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd. externo  Conta',
       'Cdigo externo de conta',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECON',
       '--',
       50,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial ',
       'Cdigo da Filial ',
       'DFIL.CODFIL = ECON.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ECON',
       '--',
       60,
       8,
       'DATLAN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Data de Lanamento',
       'Data de Lanamento',
       '',
       'DATLAN',
       'F' FROM DUAL
UNION ALL
SELECT 'ECON',
       '--',
       70,
       1,
       'EXC_MULREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'EXC_MULREC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECON',
       '--',
       80,
       4000,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'ECON',
       '--',
       90,
       3,
       'ORIGEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Origem ',
       'Origem ',
       '',
       'ORIGEM',
       'F' FROM DUAL
UNION ALL
SELECT 'ECON',
       '--',
       100,
       12,
       'VLRLAN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor do Lanamento',
       'Valor do Lanamento',
       '',
       'VLRLAN',
       'F' FROM DUAL
);

/*-- SEQ 7755 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ECR ',
       TO_NUMBER(null),
       'ECR ',
       'Evol. Contas Receber',
       'TV_ECR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7756 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ECR ','--','' FROM DUAL
UNION ALL
SELECT 'ECR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ECR ','02','Datas' FROM DUAL
UNION ALL
SELECT 'ECR ','03','Valores' FROM DUAL
UNION ALL
SELECT 'ECR ','99','Outros' FROM DUAL
);

/*-- SEQ 7757 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ECR ',
       '--',
       180,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'ECR ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = ECR.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ECR ',
       '02',
       20,
       7,
       'DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data~de Fim',
       'Data de Fim',
       '',
       'DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'ECR ',
       '02',
       15,
       7,
       'DATINI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data~de Incio',
       'Data de Incio',
       '',
       'DATINI',
       'F' FROM DUAL
UNION ALL
SELECT 'ECR ',
       '02',
       40,
       7,
       'DATREF',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data de~Referncia',
       'Data de Referncia',
       '',
       'DATREF',
       'F' FROM DUAL
UNION ALL
SELECT 'ECR ',
       '--',
       190,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial do Cliente',
       'Filial do Cliente',
       'ECR.FILCLI = DFIL.CODFIL (+)',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'ECR ',
       '03',
       50,
       12,
       'NEWREN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Aps Renegociao',
       'Valor Aps Renegociao',
       '',
       'NEWREN',
       'F' FROM DUAL
UNION ALL
SELECT 'ECR ',
       '--',
       200,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero da parcela',
       'Nmero da parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'ECR ',
       '01',
       60,
       49,
       'PERIODO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Perodo',
       'Perodo
Perodo
Perodo',
       '',
       'PERIODO',
       'F' FROM DUAL
UNION ALL
SELECT 'ECR ',
       '--',
       210,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador parcela',
       'Sequenciador parcela',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'ECR ',
       '--',
       220,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-parcela',
       'Nmero da sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'ECR ',
       '01',
       70,
       1,
       'SUBTOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Sub-Total',
       'Sub-Total',
       '',
       'SUBTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECR ',
       '01',
       80,
       1,
       'TIPLAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo~Lanamento',
       'Tipo Lanamento',
       '',
       'TIPLAN',
       'F' FROM DUAL
UNION ALL
SELECT 'ECR ',
       '03',
       90,
       12,
       'VLRACR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Juros~Recebimentos',
       'Acrscimos Sob Recebimentos',
       '',
       'VLRACR',
       'F' FROM DUAL
UNION ALL
SELECT 'ECR ',
       '03',
       100,
       12,
       'VLRANT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'A Receber~Anterior',
       'Valor a Receber Anterior',
       '',
       'VLRANT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECR ',
       '03',
       110,
       12,
       'VLRARE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor a Receber',
       'Valor a Receber',
       '',
       'VLRARE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECR ',
       '03',
       120,
       12,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Descon.~Recebimentos',
       'Descontos Sob Recebimentos',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'ECR ',
       '03',
       170,
       12,
       'VLRDEV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Pago c/~Devoluo',
       'Pago c/Devoluo',
       '',
       'VLRDEV',
       'F' FROM DUAL
UNION ALL
SELECT 'ECR ',
       '03',
       130,
       12,
       'VLREST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Estornos',
       'Estornos',
       '',
       'VLREST',
       'F' FROM DUAL
UNION ALL
SELECT 'ECR ',
       '03',
       140,
       12,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor~Receber',
       'Valor Receber',
       '',
       'VLRPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECR ',
       '03',
       150,
       12,
       'VLRREN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Renegociado',
       'Valor Renegociado
',
       '',
       'VLRREN',
       'F' FROM DUAL
UNION ALL
SELECT 'ECR ',
       '03',
       160,
       12,
       'VLRVEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Venda',
       'Valor Venda',
       '',
       'VLRVEN',
       'F' FROM DUAL
);

/*-- SEQ 7758 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ECR ',
       'SUBTOT',
       0,
       'A',
       'At o Perodo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECR ',
       'SUBTOT',
       0,
       'P',
       'Posterior ao Perodo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECR ',
       'TIPLAN',
       0,
       'D',
       'Devoluo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECR ',
       'TIPLAN',
       0,
       'E',
       'Entrada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECR ',
       'TIPLAN',
       0,
       'V',
       ' Vista',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7759 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ECT ',
       TO_NUMBER(null),
       'ECT ',
       'Contas Ttulos',
       'TT_ECT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'ECT.CODFIL,ECT.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7760 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ECT ','--','' FROM DUAL
UNION ALL
SELECT 'ECT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ECT ','05','Estrutura da Conta' FROM DUAL
UNION ALL
SELECT 'ECT ','99','Outros' FROM DUAL
);

/*-- SEQ 7761 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ECT ',
       '99',
       15,
       13,
       'CHVPAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Chave Pai',
       'Chave Pai',
       '',
       'CHVPAI',
       'F' FROM DUAL
UNION ALL
SELECT 'ECT ',
       '99',
       25,
       13,
       'CHVPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave do Projeto',
       'Chave do Projeto',
       '',
       'CHVPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'ECT ',
       '01',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Cdigo Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = ECT.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ECT ',
       '05',
       30,
       254,
       'EstruturaDeContas',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Estrutura da Conta',
       'Estrutura da Conta',
       '',
       'SUBSTR(EstruturaDeContas(ECT.CODFIL,ECT.SEQUEN),1,100)',
       '' FROM DUAL
UNION ALL
SELECT 'ECT ',
       '01',
       4,
       3,
       'FILECT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Estrutura Conta',
       '',
       'FILECT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECT ',
       '--',
       40,
       5,
       'ORDECT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'nr. ordem',
       'nr. ordem',
       '',
       'ORDECT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECT ',
       '01',
       5,
       10,
       'SEQECT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador de Estrutura de Contas',
       '',
       'SEQECT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECT ',
       '01',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'ECT ',
       '01',
       3,
       250,
       'TITECT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Ttulo',
       'Ttulo Estrutura de Contas',
       '',
       'TITECT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECT ',
       '--',
       50,
       1,
       'USOCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo conta',
       'Tipo conta para indicadores financeiros',
       '',
       'USOCTA',
       'F' FROM DUAL
);

/*-- SEQ 7762 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ECTA',
       TO_NUMBER(null),
       'ECTA',
       'Conta.Fina . Estoque',
       'TT_CTA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'ECTA.CODFIL,ECTA.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7763 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ECTA','--','' FROM DUAL
);

/*-- SEQ 7764 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20251,
       'CTB ',
       'ECTA',
       'N',
       '1',
       '',
       '',
       'CTB.FILCTA = ECTA.CODFIL AND
CTB.SEQCTA = ECTA.SEQUEN AND
CTB.TIPCTA = ECTA.TIPCTA AND
CTB.CTACTB = ECTA.USOCTA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20252,
       'CIN ',
       'ECTA',
       'N',
       '1',
       '',
       '',
       'CIN.CODFIL = ECTA.FILVIN AND
CIN.SEQUEN = ECTA.SEQVIN AND
CIN.TIPCTA = ECTA.TIPVIN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20253,
       'ECT ',
       'ECTA',
       '1',
       '0N',
       '',
       '',
       'ECT.CODFIL = ECTA.FILECT(+) AND
ECT.SEQUEN = ECTA.SEQECT(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20254,
       'FIN ',
       'ECTA',
       'N',
       '1',
       '',
       '',
       'FIN.FILGER = ECTA.CODFIL AND
FIN.SEQGER = ECTA.SEQUEN AND
FIN.TIPGER = ECTA.TIPCTA',
       '',
       '' FROM DUAL
);

/*-- SEQ 7765 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ECTA',
       '--',
       80,
       1,
       'APLNUM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Aplicabilidade Conta',
       'Aplicabilidade da conta ',
       '',
       'APLNUM',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       182,
       1,
       'ATUARE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Atualizao do rec?',
       'Atualizao do a receber?',
       '',
       'ATUARE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       195,
       1,
       'ATUREA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'A receb. atualizado?',
       'A receber atualizado?',
       '',
       'ATUREA',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       18,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = ECTA.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       175,
       7,
       'DATARE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Data atu a receber',
       'Data atualizao do a receber',
       '',
       'DATARE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       185,
       7,
       'DATREA',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'A receber data',
       'A receber data',
       '',
       'DATREA',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       70,
       4000,
       'ESTRUTURANOME',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Estrutura~Conta',
       'Estrutura da Conta',
       '',
       'RTF2TXT(ESTRUTURADECONTAS(ECTA.CODFIL,ECTA.SEQUEN))',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       6,
       3,
       'FILECT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       '',
       'Filial Estrutura de Contas',
       '',
       'FILECT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       150,
       3,
       'FILNUM',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial Numerria',
       'Filial ~Numerria',
       'DFIL.CODFIL(+) = ECTA.FILNUM',
       'FILNUM',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       200,
       3,
       'FILVIN',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial Conta Interm.',
       'Filial da Conta Intermediria',
       'DFIL.CODFIL(+) = ECTA.FILVIN',
       'FILVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       100,
       1,
       'NIVCRI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Nvel de Criticidade',
       'Nvel de Criticidade',
       '',
       'NIVCRI',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       170,
       5,
       'ORDCTA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ordem',
       'Ordem',
       '',
       'ORDCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       4,
       250,
       'PREFIX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Prefixo',
       'Prefixo',
       '',
       'PREFIX',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       180,
       14,
       'SALARE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Saldo a receber',
       'Saldo a receber',
       '',
       'SALARE',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       190,
       14,
       'SALREA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'A receber saldo',
       'A receber saldo',
       '',
       'SALREA',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       7,
       10,
       'SEQECT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Chave Estrutura de Contas',
       '',
       'SEQECT',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       201,
       10,
       'SEQVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq Conta Interm.',
       'Sequncia da Conta Intermediria',
       '',
       'SEQVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       8,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       202,
       1,
       'TIPVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Conta Interm.',
       'Tipo da Conta Intermediria',
       '',
       'TIPVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       3,
       250,
       'TITCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Conta',
       'Conta',
       '',
       'TITCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       5,
       10,
       'ULTDOC',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'ltimo Documento',
       'ltimo Documento',
       '',
       'ULTDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTA',
       '--',
       28,
       1,
       'USOCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Uso da Conta',
       'Uso da Conta',
       '',
       'USOCTA',
       'F' FROM DUAL
);

/*-- SEQ 7766 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ECTA',
       'APLNUM',
       0,
       'A',
       'Aplicaes',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'APLNUM',
       0,
       'B',
       'Banco',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'APLNUM',
       0,
       'C',
       'Caixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'APLNUM',
       0,
       'D',
       'Diferena',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'APLNUM',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'APLNUM',
       0,
       'N',
       'No Definido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'APLNUM',
       0,
       'S',
       'Estoque',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'NIVCRI',
       0,
       ' ',
       'Baixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'NIVCRI',
       1,
       ' ',
       'Mdia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'NIVCRI',
       2,
       ' ',
       'Alta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'USOCTA',
       0,
       '+',
       'Entradas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'USOCTA',
       0,
       '-',
       'Sadas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'USOCTA',
       0,
       'B',
       'Bancos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'USOCTA',
       0,
       'C',
       'Cartes de Crdito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'USOCTA',
       0,
       'E',
       'ECFs',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'USOCTA',
       0,
       'I',
       'Impostos Retidos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'USOCTA',
       0,
       'L',
       'Limites C/C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'USOCTA',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'USOCTA',
       0,
       'P',
       'Portadores',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'USOCTA',
       0,
       'S',
       'Custo Referente a Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ECTA',
       'USOCTA',
       0,
       'T',
       'Custo Referente a Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7767 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ECTR',
       TO_NUMBER(null),
       'ECTR',
       'Contas de Receita',
       'TV_ECT_REC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'ECTR.CODFIL,ECTR.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7768 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ECTR','--','' FROM DUAL
UNION ALL
SELECT 'ECTR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ECTR','99','Outros' FROM DUAL
);

/*-- SEQ 7769 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 66630,
       'CTA ',
       'ECTR',
       'N ',
       '1 ',
       '',
       '',
       'CTA.FILECT=ECTR.CODFIL AND CTA.SEQECT=ECTR.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 7770 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ECTR',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ECTR',
       '--',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 7771 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ECUS',
       TO_NUMBER(null),
       'ECUS',
       'Export. Custo Mdio',
       'TV_ECUSTOMEDIO',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7772 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ECUS','--','' FROM DUAL
UNION ALL
SELECT 'ECUS','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ECUS','99','Outros' FROM DUAL
);

/*-- SEQ 7773 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ECUS',
       '01',
       40,
       60,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       '' FROM DUAL
UNION ALL
SELECT 'ECUS',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL(+) = ECUS.CODFIL',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'ECUS',
       '01',
       30,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Nmero do Item',
       'Nmero do Item',
       '',
       'NUMITE',
       '' FROM DUAL
UNION ALL
SELECT 'ECUS',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'ECUS',
       '01',
       50,
       16,
       'VLR_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor do Custo Mdio',
       'Valor do Custo Mdio',
       '',
       'VLR_CM',
       '' FROM DUAL
);

/*-- SEQ 7774 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EDE ',
       TO_NUMBER(null),
       'EDE ',
       'Endereos',
       'TT_END',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'EDE.FILCLI,EDE.CODCLI,EDE.CODFIL,EDE.NUMEND',
       '' FROM DUAL
);

/*-- SEQ 7775 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EDE ','--','' FROM DUAL
UNION ALL
SELECT 'EDE ','01','Localizao' FROM DUAL
UNION ALL
SELECT 'EDE ','02','Outros Dados' FROM DUAL
);

/*-- SEQ 7776 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 26861,
       'VEN ',
       'EDE ',
       'N',
       '1',
       '',
       '',
       'VEN.FILCLI = EDE.FILCLI AND
VEN.CODCLI = EDE.CODCLI AND
VEN.FILCOB = EDE.CODFIL AND
VEN.ENDCOB = EDE.NUMEND
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26862,
       'COM ',
       'EDE ',
       'N',
       '1',
       '',
       '',
       'COM.FILFOR = EDE.FILCLI AND
COM.CODFOR = EDE.CODCLI AND
COM.FILEND = EDE.CODFIL AND
COM.NUMEND = EDE.NUMEND',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26863,
       'ORC ',
       'EDE ',
       'N',
       '1',
       '',
       '',
       'ORC.FILCLI = EDE.FILCLI AND
ORC.CODCLI = EDE.CODCLI AND
ORC.FILCOB = EDE.CODFIL AND
ORC.NUMCOB = EDE.NUMEND',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26864,
       'MUN ',
       'EDE ',
       '01',
       '0N',
       '',
       '',
       'MUN.CODIGO(+) = EDE.CODCID',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26865,
       'SUP ',
       'EDE ',
       'N',
       '1',
       '',
       '',
       'SUP.FILFOR = EDE.FILCLI AND
SUP.CODFOR = EDE.CODCLI AND
SUP.FILEND = EDE.CODFIL AND
SUP.NUMEND = EDE.NUMEND',
       '',
       '' FROM DUAL
);

/*-- SEQ 7777 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'EDE ',
       '02',
       371,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN EDE.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       80,
       40,
       'BAIRRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Bairro',
       'Bairro',
       '',
       'BAIRRO',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '02',
       420,
       10,
       'CLI_CK',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cd Cliente Checkout',
       'Cdigo para cliente cadastrado no Checkout',
       '',
       'CLI_CK',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '02',
       290,
       5,
       'CODARC',
       'S',
       'DARC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DARC.DESARC',
       'V',
       '',
       '',
       'N',
       'F',
       'AvisoCorrespondncia',
       'Cdigo de Aviso de Recebimento de Correspondncia',
       'DARC.CODTAB = EDE.CODARC(+)',
       'CODARC',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       150,
       5,
       'CODCEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'EDE ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'CEP',
       'CEP do endereo',
       '',
       'CODCEP',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       10,
       5,
       'CODCID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'EDE ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo da Cidade',
       'Cdigo da Cidade',
       '',
       'CODCID',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'EDE ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cliente',
       'Cliente',
       '',
       'CODCLI',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       180,
       4,
       'CODDDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'EDE ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'DDD Telefone',
       'DDD Telefone',
       '',
       'CODDDD',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '02',
       340,
       3,
       'CODDDI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DDI Telefone',
       'DDI Telefone',
       '',
       'CODDDI',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '--',
       430,
       10,
       'CODECO',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo no E-commerce',
       'Cdigo no E-commerce',
       '',
       'CODECO',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '02',
       480,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       'EDE ',
       30,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EDE.CODFIL',
       'CODFIL',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       440,
       10,
       'CODIBG',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cd. IBGE Municpio',
       'Cdigo do IBGE do Municpio',
       '',
       'CODIBG',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       160,
       3,
       'CODLOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'EDE ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'Logradouro',
       'Logradouro do endereo',
       '',
       'CODLOG',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '--',
       450,
       5,
       'CODPAI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODPAI',
       'F',
       'S' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '02',
       380,
       5,
       'CODPAI ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Pas',
       'Pas',
       '',
       'CODPAI ',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '--',
       460,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODUSU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '02',
       410,
       10,
       'COD_CK',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo Checkout',
       'Cdigo para endereo cadastrado no Checkout',
       '',
       'COD_CK',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       140,
       40,
       'COMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'EDE ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Complemento',
       'Complemento do endereo',
       '',
       'COMPLE',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       60,
       44,
       'CONTAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Contato',
       'Contato',
       '',
       'CONTAT',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       90,
       2,
       'DDDFAX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DDD Fax',
       'DDD Fax',
       '',
       'DDDFAX',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '--',
       470,
       1,
       'DUMMY',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DUMMY',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '02',
       400,
       3,
       'ECF_CK',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       '',
       'ECF Checkout',
       'ECF para endereo cadastrado no Checkout',
       'DECF.FILECF (+) = EDE.FIL_CK AND DECF.NUMECF (+) = EDE.ECF_CK',
       'ECF_CK',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '02',
       240,
       1,
       'ENDCOB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       'EDE ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'T',
       'Cobrana?',
       'Cobrana',
       '',
       'ENDCOB',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '02',
       250,
       1,
       'ENDCOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       'EDE ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'T',
       'Correspondncia?',
       'Correspondncia',
       '',
       'ENDCOR',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       130,
       40,
       'ENDERE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'EDE ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Endereo',
       'Endereo',
       '',
       'ENDERE',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       230,
       40,
       'ESTRAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'EDE ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Endereo Estrangeiro',
       'Endereo estrangeiro',
       '',
       'ESTRAN',
       'F',
       'S' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       40,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       'EDE ',
       40,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Cliente',
       'DFIL.CODFIL = EDE.FILCLI',
       'FILCLI',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '--',
       360,
       3,
       'FILUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'A',
       '',
       'Usu. lt. alterao',
       'Usurio da ltima alterao',
       'EDE.FILUSU = USU2.FILUSU  AND EDE.CODUSU = USU2.CODUSU',
       'FILUSU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '02',
       390,
       3,
       'FIL_CK',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Checkout',
       'Filial para endereo cadastrado no Checkout',
       'DFIL.CODFIL (+) = EDE.FIL_CK',
       'FIL_CK',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       220,
       1,
       'FLGNAC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'EDE ',
       110,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'T',
       'Nacional?',
       'Nacional?',
       '',
       'FLGNAC',
       'T',
       'S' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '02',
       270,
       15,
       'INSEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'EDE ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       '2  Documento',
       '2 nmero do documento',
       '',
       'INSEST',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '--',
       350,
       15,
       'INSMUN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Inscr. Municipal',
       'Inscrio Municipal',
       '',
       'INSMUN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       170,
       47,
       'LOCTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'EDE ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Proximidade',
       'Local prximo ao endereo',
       '',
       'LOCTRA',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '02',
       490,
       60,
       'NOMREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome do Recebedor',
       'Razo Social ou Nome do Recebedor',
       '',
       'NOMREC',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '02',
       260,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'EDE ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'N Documento',
       'Nmero do documento',
       '',
       'NUMDOC',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       50,
       2,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'EDE ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Nmero de Endereos',
       'Nmero de Endereos',
       '',
       'NUMEND',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       70,
       15,
       'NUMERO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero',
       'Nmero',
       '',
       'NUMERO',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       200,
       8,
       'NUMFAX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'EDE ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'FAX',
       'Nmero do fax',
       '',
       'NUMFAX',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       190,
       20,
       'NUMFON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'EDE ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'T',
       'Telefone',
       'Nmero do telefone',
       '',
       'NUMFON',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '02',
       320,
       5,
       'OLDCID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Cidade Ant.',
       'Cdigo Cidade Antiga',
       '',
       'OLDCID',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       210,
       2,
       'REGIAO',
       'S',
       'DREG',
       0,
       TO_NUMBER(null),
       'EDE ',
       100,
       TO_NUMBER(null),
       '',
       'DREG.REGIAO',
       'V',
       '',
       'F',
       'A',
       'T',
       'Regio',
       'Regio do endereo',
       'DREG.CODTAB(+)=EDE.REGIAO',
       'REGIAO',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       110,
       2,
       'SIGEST',
       'A',
       'DEST',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEST.ESTADO',
       'V',
       '',
       '',
       'A',
       'F',
       'UF',
       'UF',
       'DEST.ESTADO = EDE.SIGEST',
       'SIGEST',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       330,
       2,
       'SIGEST_',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Estado (Sigla)',
       'Sigla do Estado',
       '',
       'SIGEST',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '02',
       370,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN EDE.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '02',
       300,
       1,
       'TIPARC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo A.R.C.',
       'Tipo Aviso Recebimento Correspondncia',
       '',
       'TIPARC',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '02',
       310,
       5,
       'TIPEND',
       'S',
       'DEND',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEND.DESEND',
       'V',
       '',
       '',
       'N',
       'F',
       'Tipo do Endereo',
       'Tipo do Endereo',
       'DEND.CODTAB = EDE.TIPEND(+)',
       'TIPEND',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'EDE ',
       '01',
       280,
       1,
       'USA_NF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Nota Fiscal?',
       'Usa Nota Fiscal?',
       '',
       'USA_NF',
       'F',
       'P' FROM DUAL
);

/*-- SEQ 7778 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'EDE ',
       'FLGNAC',
       0,
       'F',
       'Brasileiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EDE ',
       'FLGNAC',
       0,
       'T',
       'Estrangeiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EDE ',
       'TIPARC',
       0,
       ' ',
       'Nenhum',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EDE ',
       'TIPARC',
       0,
       'F',
       'Recebeu ARC',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7779 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EDOP',
       TO_NUMBER(null),
       'EDOP',
       'Exp.Docs. de Pgto ',
       'TV_EDOP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7780 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EDOP','--','' FROM DUAL
UNION ALL
SELECT 'EDOP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EDOP','99','Outros' FROM DUAL
);

/*-- SEQ 7781 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EDOP',
       '--',
       10,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       20,
       1,
       'CHETRO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Cheque Troco?',
       ' cheque troco?',
       '',
       'CHETRO',
       'F' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       30,
       20,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Alternativo nico',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       40,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Cdigo origem da filial.',
       'EDOP.CODFIL = DFIL.CODFIL',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       50,
       10,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.NOMUSU',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo externo',
       'EDOP.FILUSU = USU.FILUSU(+) AND EDOP.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       60,
       1,
       'DATIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       70,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Pagamento',
       'Data de Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       80,
       5,
       'DOMDOP',
       'A',
       'DDOP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDOP.DESDOP',
       'V',
       '',
       '',
       'A',
       'F',
       'Tipo de Documento',
       'Tipo de Documento',
       'DDOP.CODTAB(+) = EDOP.DOMDOP',
       'DOMDOP',
       'T' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       90,
       3,
       'FILCTA',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EDOP.FILCTA',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       100,
       3,
       'FILDES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Entregue na Filial',
       'Filial Destino',
       '',
       'FILDES',
       'F' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       110,
       3,
       'FILRDP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial RDP',
       '',
       'FILRDP',
       'F' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       120,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       130,
       1,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       140,
       25,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'N Documento',
       'N Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       150,
       1,
       'NUMIMP',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nm. Impresses',
       'Nmero de Impresses',
       '',
       'NUMIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       160,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(EDOP.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       170,
       4000,
       'OBSINT',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observaes Internas',
       'Observaes Internas',
       '',
       'OBSINT',
       'F' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       180,
       10,
       'SEQRDP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador RDP',
       '',
       'SEQRDP',
       'F' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       190,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       200,
       12,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       210,
       5,
       'STDDOP',
       'F',
       'DSTD',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSTD.DESSTD',
       'V',
       '',
       '',
       'A',
       'F',
       'Situao Documento',
       'Situao Documento',
       'DSTD.CODTAB = EDOP.STDDOP',
       'STDDOP',
       'T' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       220,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo da Conta',
       'Tipo da Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       230,
       250,
       'TITCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Conta',
       'Conta',
       '',
       'TITCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       240,
       1,
       'USOCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Uso da Conta',
       'Uso da Conta',
       '',
       'USOCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'EDOP',
       '--',
       250,
       12,
       'VLRDOC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor do Documento',
       'Valor do Documento',
       '',
       'VLRDOC',
       'F' FROM DUAL
);

/*-- SEQ 7782 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'EDOP',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EDOP',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EDOP',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EDOP',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EDOP',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EDOP',
       'USOCTA',
       0,
       '+',
       'Entradas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EDOP',
       'USOCTA',
       0,
       '-',
       'Sadas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EDOP',
       'USOCTA',
       0,
       'B',
       'Bancos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EDOP',
       'USOCTA',
       0,
       'C',
       'Cartes de Crdito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EDOP',
       'USOCTA',
       0,
       'E',
       'ECFs',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EDOP',
       'USOCTA',
       0,
       'I',
       'Impostos Retidos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EDOP',
       'USOCTA',
       0,
       'L',
       'Limites C/C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EDOP',
       'USOCTA',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EDOP',
       'USOCTA',
       0,
       'P',
       'Portadores',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7783 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EECF',
       TO_NUMBER(null),
       'EECF',
       'Exportao Leitura Z',
       'TE_ECF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7784 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EECF','--','' FROM DUAL
UNION ALL
SELECT 'EECF','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EECF','99','Outros' FROM DUAL
);

/*-- SEQ 7785 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EECF',
       '--',
       10,
       6,
       'CNTOPE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nm. Operao Final',
       'Nm. Operao Final',
       '',
       'CNTOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EECF',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EECF.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EECF',
       '--',
       30,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da~Reduo Z',
       'Data da Reduo Z',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EECF',
       '--',
       40,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Numero ECF',
       'Numero ECF',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'EECF',
       '--',
       50,
       25,
       'NUMSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Srie~do ECF',
       'Nmero Srie do ECF',
       '',
       'NUMSER',
       'F' FROM DUAL
UNION ALL
SELECT 'EECF',
       '--',
       60,
       1,
       'TIPTOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo~Totalizador',
       'Tipo Totalizador',
       '',
       'TIPTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'EECF',
       '--',
       70,
       4,
       'TOTALI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Desc.Totalizador',
       'Desc. Totalizador (Alquota)',
       '',
       'TOTALI',
       'F' FROM DUAL
UNION ALL
SELECT 'EECF',
       '--',
       80,
       16,
       'VLRBAS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr. Base',
       'Valor Base',
       '',
       'VLRBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'EECF',
       '--',
       90,
       16,
       'VLRTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr. Total',
       'Valor Total',
       '',
       'VLRTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'EECF',
       '--',
       100,
       16,
       'VLR_GT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor do Grande Tota',
       'Valor do Grande Total',
       '',
       'VLR_GT',
       'F' FROM DUAL
);

/*-- SEQ 7786 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'EECF',
       'TIPTOT',
       0,
       'M',
       'Aliquita de Mercadoria (ICMS)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EECF',
       'TIPTOT',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EECF',
       'TIPTOT',
       0,
       'S',
       'Aliquota de Servio (ISS)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EECF',
       'TOTALI',
       0,
       ' ',
       'Total de cancelamentos',
       TO_NUMBER(null),
       'CANC' FROM DUAL
UNION ALL
SELECT 'EECF',
       'TOTALI',
       0,
       ' ',
       'Total de descontos',
       TO_NUMBER(null),
       'DESC' FROM DUAL
UNION ALL
SELECT 'EECF',
       'TOTALI',
       0,
       ' ',
       'Total de Isentos',
       TO_NUMBER(null),
       'ISEN' FROM DUAL
UNION ALL
SELECT 'EECF',
       'TOTALI',
       0,
       ' ',
       'Total de isentos no tributado',
       TO_NUMBER(null),
       'I_NT' FROM DUAL
UNION ALL
SELECT 'EECF',
       'TOTALI',
       0,
       ' ',
       'Total de no tributados',
       TO_NUMBER(null),
       'NAOT' FROM DUAL
UNION ALL
SELECT 'EECF',
       'TOTALI',
       0,
       ' ',
       'Total substituio Tributria',
       TO_NUMBER(null),
       'SUBS' FROM DUAL
);

/*-- SEQ 7787 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EENT',
       TO_NUMBER(null),
       'EENT',
       'Endereo Entrega',
       'TT_END',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'EENT.FILCLI,EENT.CODCLI,EENT.CODFIL,EENT.NUMEND
CLI.ID,EENT.APEEND',
       '' FROM DUAL
);

/*-- SEQ 7788 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EENT','--','' FROM DUAL
UNION ALL
SELECT 'EENT','01','Localizao' FROM DUAL
UNION ALL
SELECT 'EENT','02','Outros Dados' FROM DUAL
);

/*-- SEQ 7789 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 26751,
       'COM ',
       'EENT',
       'N',
       '1',
       '',
       '',
       'COM.FILFOR = EENT.FILCLI AND
COM.CODFOR = EENT.CODCLI AND
COM.FILEND = EENT.CODFIL AND
COM.NUMEND = EENT.NUMEND',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26752,
       'CON ',
       'EENT',
       'N',
       '1',
       '',
       '',
       'CON.FILCLI = EENT.FILCLI AND
CON.CODCLI = EENT.CODCLI AND
CON.FILEND = EENT.CODFIL AND
CON.NUMEND = EENT.NUMEND',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26753,
       'LIM ',
       'EENT',
       'N',
       '1',
       '',
       '',
       'LIM.FILCLI = EENT.FILCLI AND
LIM.CODCLI = EENT.CODCLI AND
LIM.FILCOB = EENT.CODFIL AND
LIM.ENDCOB = EENT.NUMEND',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26754,
       'MUN ',
       'EENT',
       '01',
       '0N',
       '',
       '',
       'MUN.CODIGO(+) = EENT.CODCID',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26755,
       'PEND',
       'EENT',
       '01',
       '1',
       '',
       '',
       'PEDE.FILCLI = EENT.FILCLI AND
PEDE.CODCLI = EENT.CODCLI AND
PEDE.FILEND = EENT.CODFIL AND
PEDE.NUMEND = EENT.NUMEND',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26756,
       'REG ',
       'EENT',
       'N',
       '1',
       '',
       '',
       'REG.FILFOR = EENT.FILCLI AND
REG.CODFOR = EENT.CODCLI AND
REG.FILEND = EENT.CODFIL AND
REG.NUMEND = EENT.NUMEND',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26757,
       'SUP ',
       'EENT',
       'N',
       '1',
       '',
       '',
       'SUP.FILFOR = EENT.FILCLI AND
SUP.CODFOR = EENT.CODCLI AND
SUP.FILEND = EENT.CODFIL AND
SUP.NUMEND = EENT.NUMEND',
       '',
       '' FROM DUAL
);

/*-- SEQ 7790 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EENT',
       '01',
       80,
       40,
       'BAIRRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Bairro',
       'Bairro',
       '',
       'BAIRRO',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       16,
       9,
       'CEP_LOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       70,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'CEP+Log',
       'CEP+Log',
       '',
       'CODCEP||''-''||EENT.CODLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       1,
       3,
       'CHAVE_CLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'F',
       '',
       'T',
       'Cliente End. Entrega',
       'Cliente End. Entrega',
       '',
       'FILCLI||EENT.CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '02',
       380,
       10,
       'CLI_CK',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cd Cliente Checkout',
       'Cdigo para cliente cadastrado no Checkout',
       '',
       'CLI_CK',
       '' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       290,
       5,
       'CODARC',
       'S',
       'DARC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DARC.DESARC',
       'V',
       '',
       '',
       'N',
       'F',
       'AvisoCorrespondncia',
       'Cdigo de Aviso de Recebimento de Correspondncia',
       'DARC.CODTAB = EENT.CODARC(+)',
       'CODARC',
       'T' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       150,
       5,
       'CODCEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'CEP',
       'Cep do endereo',
       '',
       'CODCEP',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       10,
       5,
       'CODCID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo da Cidade',
       'Cdigo da Cidade',
       '',
       'CODCID',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       180,
       4,
       'CODDDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'DDD Telefone',
       'DDD',
       '',
       'CODDDD',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '--',
       390,
       10,
       'CODECO',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo no E-commerce',
       'Cdigo no E-commerce',
       '',
       'CODECO',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EENT.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       160,
       3,
       'CODLOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'Logradouro',
       'Logradouro do endereo',
       '',
       'CODLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '02',
       340,
       5,
       'CODPAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Pas',
       'Pas',
       '',
       'CODPAI',
       '' FROM DUAL
UNION ALL
SELECT 'EENT',
       '02',
       370,
       10,
       'COD_CK',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo Checkout',
       'Cdigo para endereo cadastrado no Checkout',
       '',
       'COD_CK',
       '' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       140,
       40,
       'COMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Complemento',
       'Complemento do endereo',
       '',
       'COMPLE',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       60,
       44,
       'CONTAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Contato',
       'Contato',
       '',
       'CONTAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       90,
       2,
       'DDDFAX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DDD Fax',
       'DDD Fax',
       '',
       'DDDFAX',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '02',
       360,
       3,
       'ECF_CK',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       '',
       'ECF Checkout',
       'ECF para endereo cadastrado no Checkout',
       'DECF.FILECF (+) = EENT.FIL_CK AND DECF.NUMECF (+) = EENT.ECF_CK',
       'ECF_CK',
       'T' FROM DUAL
UNION ALL
SELECT 'EENT',
       '02',
       240,
       1,
       'ENDCOB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'N',
       'T',
       'Cobrana?',
       'Cobrana',
       '',
       'ENDCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '02',
       250,
       1,
       'ENDCOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'T',
       'Correspondncia?',
       'Correspondncia',
       '',
       'ENDCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       5,
       40,
       'ENDERE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Endereo',
       'Endereo',
       '',
       'ENDERE',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       230,
       40,
       'ESTRAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       150,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Endereo Estrangeiro',
       'Endereo estrangeiro',
       '',
       'ESTRAN',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       40,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       'DFIL.CODFIL = EENT.FILCLI',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '--',
       330,
       3,
       'FILUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'A',
       '',
       'Usu. lt. alterao',
       'Usurio da ltima alterao',
       'EENT.FILUSU = USU2.FILUSU  AND EENT.CODUSU = USU2.CODUSU',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '02',
       350,
       3,
       'FIL_CK',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Checkout',
       'Filial para endereo cadastrado no Checkout',
       'DFIL.CODFIL (+) = EENT.FIL_CK',
       'FIL_CK',
       'T' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       3,
       3,
       'FIL_END',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'Num.End.',
       'Num.End.',
       '',
       'CODFIL||EENT.NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       220,
       1,
       'FLGNAC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       140,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'T',
       'Nacional?',
       'Nacionalidade',
       '',
       'FLGNAC',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '02',
       270,
       15,
       'INSEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       '2 Documento',
       '2 nmero do documento',
       '',
       'INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       170,
       47,
       'LOCTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Proximidade',
       'Local prximo ao endereo',
       '',
       'LOCTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '02',
       260,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'Documento',
       'Nmero do documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       50,
       4,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero de Enderecos',
       'Nmero de Endereos',
       '',
       'NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       70,
       15,
       'NUMERO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero',
       'Nmero',
       '',
       'NUMERO',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       200,
       8,
       'NUMFAX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       120,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'FAX',
       'Nmero do fax',
       '',
       'NUMFAX',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       190,
       10,
       'NUMFON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'Telefone',
       'Nmero do telefone',
       '',
       'NUMFON',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       300,
       5,
       'OLDCID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Cidade Ant.',
       'Cdigo Cidade Antiga',
       '',
       'OLDCID',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       210,
       2,
       'REGIAO',
       'S',
       'DREG',
       0,
       TO_NUMBER(null),
       '',
       130,
       TO_NUMBER(null),
       '',
       'DREG.REGIAO',
       'V',
       '',
       'F',
       'N',
       'T',
       'Regio',
       'Regio do endereo',
       'DREG.CODTAB = EENT.REGIAO',
       'REGIAO',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       110,
       2,
       'SIGEST',
       'A',
       'DEST',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEST.ESTADO',
       'V',
       '',
       '',
       'A',
       'F',
       'UF',
       'UF',
       'DEST.ESTADO = EENT.SIGEST',
       'SIGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       310,
       1,
       'TIPARC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo A.R.C.',
       'Tipo Aviso Recebimento Correspondncia',
       '',
       'TIPARC',
       'F' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       320,
       5,
       'TIPEND',
       'S',
       'DEND',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEND.DESEND',
       'V',
       '',
       '',
       'N',
       'F',
       'Tipo do Endereo',
       'Tipo do Endereo',
       'DEND.CODTAB = EENT.TIPEND(+)',
       'TIPEND',
       'T' FROM DUAL
UNION ALL
SELECT 'EENT',
       '01',
       280,
       1,
       'USA_NF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Nota Fiscal?',
       'Usa Nota Fiscal?',
       '',
       'USA_NF',
       'F' FROM DUAL
);

/*-- SEQ 7791 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'EENT',
       'TIPARC',
       0,
       ' ',
       'Nenhum',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EENT',
       'TIPARC',
       0,
       'F',
       'Recebeu ARC',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7792 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EFAT',
       TO_NUMBER(null),
       'EFAT',
       'Endereo de Fatura',
       'TT_END',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'EFAT.FILCLI,EFAT.CODCLI,EFAT.CODFIL,EFAT.NUMEND
CLI.ID,EFAT.APEEND',
       '' FROM DUAL
);

/*-- SEQ 7793 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EFAT','--','' FROM DUAL
UNION ALL
SELECT 'EFAT','01','Localizao' FROM DUAL
UNION ALL
SELECT 'EFAT','02','Outros Dados' FROM DUAL
);

/*-- SEQ 7794 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 26758,
       'COM ',
       'EFAT',
       'N',
       '1',
       '',
       '',
       'COM.FILFOR = EFAT.FILCLI AND
COM.CODFOR = EFAT.CODCLI AND
COM.FILEND = EFAT.CODFIL AND
COM.NUMEND = EFAT.NUMEND',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26759,
       'CON ',
       'EFAT',
       'N',
       '1',
       '',
       '',
       'CON.FILCLI = EFAT.FILCLI AND
CON.CODCLI = EFAT.CODCLI AND
CON.FILEND = EFAT.CODFIL AND
CON.NUMEND = EFAT.NUMEND',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26760,
       'LIM ',
       'EFAT',
       'N',
       '1',
       '',
       '',
       'LIM.FILCLI = LIM.FILCLI AND
LIM.CODCLI = LIM.CODCLI AND
LIM.FILCOB = LIM.CODFIL AND
LIM.ENDCOB = LIM.NUMEND',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26761,
       'MUN ',
       'EFAT',
       '01',
       '0N',
       '',
       '',
       'EFAT.CODCID = MUN.CODIGO(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26762,
       'PEND',
       'EFAT',
       '01',
       '1',
       '',
       '',
       'PEDE.FILCLI = EFAT.FILCLI AND
PEDE.CODCLI = EFAT.CODCLI AND
PEDE.FILEND = EFAT.CODFIL AND
PEDE.NUMEND = EFAT.NUMEND',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26763,
       'REG ',
       'EFAT',
       'N',
       '1',
       '',
       '',
       'REG.FILFOR = EFAT.FILCLI AND
REG.CODFOR = EFAT.CODCLI AND
REG.FILEND = EFAT.CODFIL AND
REG.NUMEND = EFAT.NUMEND',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26764,
       'SUP ',
       'EFAT',
       'N',
       '1',
       '',
       '',
       'SUP.FILFOR = EFAT.FILCLI AND
SUP.CODFOR = EFAT.CODCLI AND
SUP.FILEND = EFAT.CODFIL AND
SUP.NUMEND = EFAT.NUMEND',
       '',
       '' FROM DUAL
);

/*-- SEQ 7795 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EFAT',
       '01',
       80,
       40,
       'BAIRRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Bairro',
       'Bairro',
       '',
       'BAIRRO',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       16,
       9,
       'CEP_LOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'F',
       '',
       'T',
       'CEP+Log',
       'CEP+Log',
       '',
       'CODCEP||''-''||EFAT.CODLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '02',
       380,
       10,
       'CLI_CK',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cd Cliente Checkout',
       'Cdigo para cliente cadastrado no Checkout',
       '',
       'CLI_CK',
       '' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       290,
       5,
       'CODARC',
       'S',
       'DARC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DARC.DESARC',
       'V',
       '',
       '',
       'N',
       'F',
       'AvisoCorrespondncia',
       'Cdigo de Aviso de Recebimento de Correspondncia',
       'DARC.CODTAB = EFAT.CODARC(+)',
       'CODARC',
       'T' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       150,
       5,
       'CODCEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'CEP',
       'Cep do endereo',
       '',
       'CODCEP',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       10,
       5,
       'CODCID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cidade',
       'Cdigo da Cidade',
       '',
       'CODCID',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       180,
       4,
       'CODDDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       80,
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       'F',
       'N',
       'T',
       'DDD Telefone',
       'DDD Telefone',
       '',
       'CODDDD',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '--',
       390,
       10,
       'CODECO',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo no E-commerce',
       'Cdigo no E-commerce',
       '',
       'CODECO',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EFAT.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       160,
       3,
       'CODLOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'Logradouro',
       'Logradouro do endereo',
       '',
       'CODLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       340,
       5,
       'CODPAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Pas',
       'Pas',
       '',
       'CODPAI',
       '' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '02',
       370,
       10,
       'COD_CK',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo Checkout',
       'Cdigo para endereo cadastrado no Checkout',
       '',
       'COD_CK',
       '' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       140,
       40,
       'COMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Complemento',
       'Complemento do endereo',
       '',
       'COMPLE',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       60,
       44,
       'CONTAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Contato',
       'Contato',
       '',
       'CONTAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       90,
       2,
       'DDDFAX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DDD Fax',
       'DDD Fax',
       '',
       'DDDFAX',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '02',
       360,
       3,
       'ECF_CK',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       '',
       'ECF Checkout',
       'ECF para endereo cadastrado no Checkout',
       'DECF.FILECF (+) = EFAT.FIL_CK AND DECF.NUMECF (+) = EFAT.ECF_CK',
       'ECF_CK',
       'T' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '02',
       240,
       1,
       'ENDCOB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'T',
       'Cobrana?',
       'Cobrana',
       '',
       'ENDCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '02',
       250,
       1,
       'ENDCOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'T',
       'Correspondncia?',
       'Correspondncia',
       '',
       'ENDCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       5,
       40,
       'ENDERE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Endereo',
       'Endereo',
       '',
       'ENDERE',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       230,
       40,
       'ESTRAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       130,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Endereo Estrangeiro',
       'Endereo estrangeiro',
       '',
       'ESTRAN',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       40,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       'DFIL.CODFIL = EFAT.FILCLI',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '--',
       330,
       3,
       'FILUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'A',
       '',
       'Usu. lt. alterao',
       'Usurio da ltima alterao',
       'EFAT.FILUSU = USU2.FILUSU  AND EFAT.CODUSU = USU2.CODUSU',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '02',
       350,
       3,
       'FIL_CK',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Checkout',
       'Filial para endereo cadastrado no Checkout',
       'DFIL.CODFIL (+) = EFAT.FIL_CK',
       'FIL_CK',
       'T' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       220,
       1,
       'FLGNAC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       120,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'T',
       'Nacional?',
       'Nacionalidade',
       '',
       'FLGNAC',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '02',
       270,
       15,
       'INSEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       '2 Documento',
       '2 nmero do documento',
       '',
       'INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       170,
       47,
       'LOCTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       70,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Proximidade',
       'Local prximo ao endereo',
       '',
       'LOCTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '02',
       260,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'Documento',
       'Nmero do documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       50,
       4,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero de Enderecos',
       'Nmero de Endereos',
       '',
       'NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       70,
       15,
       'NUMERO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero',
       'Nmero',
       '',
       'NUMERO',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       200,
       8,
       'NUMFAX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'FAX',
       'Nmero do fax',
       '',
       'NUMFAX',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       190,
       10,
       'NUMFON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'Telefone',
       'Nmero do telefone',
       '',
       'NUMFON',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       300,
       5,
       'OLDCID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Cidade Ant.',
       'Cdigo Cidade Antiga',
       '',
       'OLDCID',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       210,
       2,
       'REGIAO',
       'S',
       'DREG',
       0,
       TO_NUMBER(null),
       '',
       110,
       TO_NUMBER(null),
       '',
       'DREG.REGIAO',
       'V',
       '',
       'F',
       'A',
       'T',
       'Regio',
       'Regio do endereo',
       'DREG.CODTAB = EFAT.REGIAO',
       'REGIAO',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       110,
       2,
       'SIGEST',
       'A',
       'DEST',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEST.ESTADO',
       'V',
       '',
       '',
       'A',
       'F',
       'UF',
       'UF',
       'DEST.ESTADO = EFAT.SIGEST',
       'SIGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       310,
       1,
       'TIPARC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo A.R.C.',
       'Tipo Aviso Recebimento Correspondncia',
       '',
       'TIPARC',
       'F' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       320,
       5,
       'TIPEND',
       'S',
       'DEND',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEND.DESEND',
       'V',
       '',
       '',
       'N',
       'F',
       'Tipo do Endereo',
       'Tipo do Endereo',
       'DEND.CODTAB = EFAT.TIPEND(+)',
       'TIPEND',
       'T' FROM DUAL
UNION ALL
SELECT 'EFAT',
       '01',
       280,
       1,
       'USA_NF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Nota Fiscal?',
       'Usa Nota Fiscal?',
       '',
       'USA_NF',
       'F' FROM DUAL
);

/*-- SEQ 7796 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'EFAT',
       'TIPARC',
       0,
       ' ',
       'Nenhum',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EFAT',
       'TIPARC',
       0,
       'F',
       'Recebeu ARC',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7797 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EICO',
       TO_NUMBER(null),
       'EICO',
       'Exp. Itens de Compra',
       'TV_EICO',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7798 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EICO','--','' FROM DUAL
UNION ALL
SELECT 'EICO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EICO','99','Outros' FROM DUAL
);

/*-- SEQ 7799 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EICO',
       '--',
       471,
       12,
       'BASCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Base COFINS',
       'Base COFINS',
       '',
       'BASCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       711,
       14,
       'BASFCP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base FCP',
       'Valor da Base de Clculo do FCP',
       '',
       'BASFCP',
       '' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       771,
       14,
       'BASFCP_RET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base do FCP ST Ret',
       'Valor da Base de Clculo do FCP retido anteriormente por ST',
       '',
       'BASFCP_RET',
       '' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       741,
       14,
       'BASFCP_ST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base do FCP ST',
       'Valor da Base de Clculo do FCP retido por Substituio Tributria',
       '',
       'BASFCP_ST',
       '' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       11,
       12,
       'BASICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Base Clculo ICMS',
       'Base Clculo ICMS',
       '',
       'BASICM',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       441,
       12,
       'BASIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Base de Clculo  IPI',
       'Base de Clculo do IPI',
       '',
       'BASIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       481,
       12,
       'BASPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Base PIS',
       'Base PIS',
       '',
       'BASPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       491,
       14,
       'BASSUB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Base de Substituio',
       'Base de Substituio',
       '',
       'BASSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       21,
       20,
       'CODBUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo de Busca',
       'Cdigo de Busca',
       '',
       'CODBUS',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       31,
       6,
       'CODCFO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'CFOP',
       'CFOP',
       '',
       'CODCFO',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       41,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       51,
       20,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Fornecedor',
       'Cdigo Fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       61,
       20,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Material',
       'Cdigo Material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       71,
       5,
       'CODMOE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Moeda',
       'Descrio da Moeda',
       '',
       'CODMOE',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       81,
       30,
       'CODMUL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Desc. Mlt. Estoque',
       'Desc. Mlt. Estoque',
       '',
       'CODMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       91,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       101,
       7,
       'COM_DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Data da Operao',
       'Data da Operao',
       '',
       'COM_DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       701,
       3,
       'CSTXML',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'CST ICMS XML',
       'CST ICMS XML',
       '',
       'CSTXML',
       'T' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       111,
       12,
       'CUSANT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Custo Anterior',
       'Custo Anterior',
       '',
       'CUSANT',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       121,
       12,
       'CUSFRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Custo do Frete',
       'Custo do Frete',
       '',
       'CUSFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       131,
       12,
       'CUSREP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Custo Atual',
       'Custo Atual',
       '',
       'CUSREP',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       141,
       7,
       'DATANT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Data do ltimo Custo',
       'Data do ltimo Custo',
       '',
       'DATANT',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       151,
       1,
       'DATIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Data Imp.',
       'Data Imp.',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       161,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Data Inc.',
       'Data Inc.',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       171,
       5,
       'EMBORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Embalagem Original',
       'Embalagem Original',
       '',
       'EMBORI',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       181,
       12,
       'EMBQTD',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtde Orig. Embagem',
       'Qtde Orig. Embagem',
       '',
       'EMBQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       691,
       1,
       'EXPFIS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exportado Fiscal?',
       'Exportado Fiscal?',
       '',
       'EXPFIS',
       '' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       191,
       12,
       'FREFIS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Vlr.Frete Fiscal.',
       'Vlr.Frete Fiscal.',
       '',
       'FREFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       201,
       12,
       'ICMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% ICMS',
       '% ICMS',
       '',
       'ICMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       211,
       12,
       'IPIITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% de IPI',
       '% de IPI',
       '',
       'IPIITE',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       221,
       12,
       'ISEICM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Iseno ICMS',
       'Iseno ICMS',
       '',
       'ISEICM',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       231,
       1,
       'LANEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao no Estoque',
       'Situao no Estoque',
       '',
       'LANEST',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       241,
       1,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       251,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Item',
       'Item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       261,
       8,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero',
       'Nmero',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       271,
       10,
       'ORD_CM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ordem Custo Mdio',
       'Ordem Custo Mdio',
       '',
       'ORD_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       281,
       12,
       'OUTICM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Outros ICMS',
       'Outros ICMS',
       '',
       'OUTICM',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       541,
       6,
       'PERCOF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '%COFINS',
       '% COFINS',
       '',
       'PERCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       721,
       6,
       'PERFCP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% FCP',
       '% do ICMS relativo ao Fundo de Combate  Pobreza (FCP)',
       '',
       'PERFCP',
       '' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       781,
       6,
       'PERFCP_RET',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Perc. FCP ST Ret',
       'Percentual do FCP retido anteriormente por Substituio Tributria',
       '',
       'PERFCP_RET',
       '' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       751,
       6,
       'PERFCP_ST',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       '',
       'Percentual FCP ST',
       'Percentual do FCP retido por Substituio Tributria',
       '',
       'PERFCP_ST',
       '' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       291,
       12,
       'PERLUC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Percentual de Lucro',
       'Percentual de Lucro',
       '',
       'PERLUC',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       551,
       6,
       'PERPIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '%PIS',
       '% PIS',
       '',
       'PERPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       301,
       12,
       'PREANT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Preo Anterior',
       'Preo Anterior',
       '',
       'PREANT',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       311,
       12,
       'PREATU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Preo Atual de Venda',
       'Preo Atual de Venda',
       '',
       'PREATU',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       321,
       12,
       'QTDCOM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade Compra',
       'Quantidade Compra',
       '',
       'QTDCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       331,
       12,
       'QTDMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade',
       'Quantidade',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       341,
       12,
       'QTD_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade Conv.Mov.',
       'Quantidade Conv.Mov.',
       '',
       'QTD_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       561,
       7,
       'RED_ST',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '%Red. Subst. Trib.',
       '% Reduo da Base de Calculo da Substituio Tributria',
       '',
       'RED_ST',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       571,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       591,
       2,
       'SITCOF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Sit. Trib. COFINS',
       'Situao Tributria do COFINS',
       '',
       'SITCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       451,
       2,
       'SITIPI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Sit. Tributria IPI ',
       'Situao Tributria do IPI',
       '',
       'SITIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       351,
       1,
       'SITMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'SITMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       601,
       2,
       'SITPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Sit. Tributria PIS',
       'Situao Tributria do PIS',
       '',
       'SITPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       361,
       12,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Status',
       'Status',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       611,
       14,
       'TAXICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% ICMS',
       '% ICMS',
       '',
       'TAXICM',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       371,
       1,
       'TIPPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Produto',
       'Tipo Produto',
       '',
       'TIPPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       381,
       5,
       'UNICOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Unidade de Compras',
       'Unidade de Compras',
       '',
       'UNICOM',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       391,
       5,
       'UNIVEN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Unidade de Vendas',
       'Unidade de Vendas',
       '',
       'UNIVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       401,
       12,
       'VALCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Converso Unidades',
       'Converso Unidades',
       '',
       'VALCON',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       411,
       12,
       'VLRCAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Diferena',
       'Valor Diferena',
       '',
       'VLRCAL',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       631,
       12,
       'VLRCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor COFINS',
       'Valor COFINS',
       '',
       'VLRCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       731,
       14,
       'VLRFCP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor FCP',
       'Valor do ICMS relativo ao Fundo de Combate  Pobreza (FCP)',
       '',
       'VLRFCP',
       '' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       791,
       14,
       'VLRFCP_RET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor FCP ST Ret.',
       'Valor do FCP retido anteriormente por Substituio Tributria',
       '',
       'VLRFCP_RET',
       '' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       761,
       14,
       'VLRFCP_ST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor FCP ST',
       'Valor do FCP retido por Substituio Tributria',
       '',
       'VLRFCP_ST',
       '' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       421,
       12,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor ICMS',
       'Valor ICMS',
       '',
       'VLRICM',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       641,
       14,
       'VLRIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor IPI',
       'Valor IPI',
       '',
       'VLRIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       651,
       12,
       'VLRITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Total do Item',
       'Valor Total do Item',
       '',
       'VLRITE',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       431,
       12,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Item',
       'Valor Item',
       '',
       'VLRMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       661,
       12,
       'VLRPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor PIS',
       'Valor PIS',
       '',
       'VLRPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       671,
       12,
       'VLRUNI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Unitrio',
       'Valor Unitrio',
       '',
       'VLRUNI',
       'F' FROM DUAL
UNION ALL
SELECT 'EICO',
       '--',
       681,
       14,
       'VLR_ST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Substituio',
       'Valor de Substituio',
       '',
       'VLR_ST',
       'F' FROM DUAL
);

/*-- SEQ 7800 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'EICO',
       'CSTXML',
       0,
       ' ',
       'Tri.Simpl.s/Crd.c/Cobr.ICMSST',
       TO_NUMBER(null),
       '202' FROM DUAL
UNION ALL
SELECT 'EICO',
       'CSTXML',
       0,
       ' ',
       'Isen.Simpl.RecBrtc/Cobr.ICMSST',
       TO_NUMBER(null),
       '203' FROM DUAL
UNION ALL
SELECT 'EICO',
       'CSTXML',
       0,
       ' ',
       'Imune',
       TO_NUMBER(null),
       '300' FROM DUAL
UNION ALL
SELECT 'EICO',
       'CSTXML',
       0,
       ' ',
       'No tributada pelo Simples',
       TO_NUMBER(null),
       '400' FROM DUAL
UNION ALL
SELECT 'EICO',
       'CSTXML',
       0,
       ' ',
       'ICMScobr.ant. p/ST ou p/Antec.',
       TO_NUMBER(null),
       '500' FROM DUAL
UNION ALL
SELECT 'EICO',
       'CSTXML',
       0,
       ' ',
       'Outros',
       TO_NUMBER(null),
       '900' FROM DUAL
UNION ALL
SELECT 'EICO',
       'CSTXML',
       0,
       ' ',
       'Tributada integralmente',
       TO_NUMBER(null),
       '00' FROM DUAL
UNION ALL
SELECT 'EICO',
       'CSTXML',
       0,
       ' ',
       'Tributada com substituio',
       TO_NUMBER(null),
       '10' FROM DUAL
UNION ALL
SELECT 'EICO',
       'CSTXML',
       0,
       ' ',
       'Com reduo de base de clculo',
       TO_NUMBER(null),
       '20' FROM DUAL
UNION ALL
SELECT 'EICO',
       'CSTXML',
       0,
       ' ',
       'Isenta/no trib. com subst.',
       TO_NUMBER(null),
       '30' FROM DUAL
UNION ALL
SELECT 'EICO',
       'CSTXML',
       0,
       ' ',
       'Isenta',
       TO_NUMBER(null),
       '40' FROM DUAL
UNION ALL
SELECT 'EICO',
       'CSTXML',
       0,
       ' ',
       'No tributada',
       TO_NUMBER(null),
       '41' FROM DUAL
UNION ALL
SELECT 'EICO',
       'CSTXML',
       0,
       ' ',
       'Suspenso',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'EICO',
       'CSTXML',
       0,
       ' ',
       'Diferimento',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'EICO',
       'CSTXML',
       0,
       ' ',
       'ICMS cobrado ant. por subst.',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'EICO',
       'CSTXML',
       0,
       ' ',
       'Reduo de base por subst.',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'EICO',
       'CSTXML',
       0,
       ' ',
       'Outros',
       TO_NUMBER(null),
       '90' FROM DUAL
UNION ALL
SELECT 'EICO',
       'CSTXML',
       0,
       ' ',
       'Trib. Simples c/permi. Crdito',
       TO_NUMBER(null),
       '101' FROM DUAL
UNION ALL
SELECT 'EICO',
       'CSTXML',
       0,
       ' ',
       'Trib. Simples s/permi. Crdito',
       TO_NUMBER(null),
       '102' FROM DUAL
UNION ALL
SELECT 'EICO',
       'CSTXML',
       0,
       ' ',
       'Isen.ICMS Simples ReceitaBruta',
       TO_NUMBER(null),
       '103' FROM DUAL
UNION ALL
SELECT 'EICO',
       'CSTXML',
       0,
       ' ',
       'Tri.Simpl.c/Crd.c/Cobr.ICMSST',
       TO_NUMBER(null),
       '201' FROM DUAL
);

/*-- SEQ 7801 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EIOR',
       TO_NUMBER(null),
       'EIOR',
       'Exp. Itens Oramento',
       'TV_EIOR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7802 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EIOR','--','' FROM DUAL
UNION ALL
SELECT 'EIOR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EIOR','99','Outros' FROM DUAL
);

/*-- SEQ 7803 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EIOR',
       '--',
       390,
       10,
       'APLICA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtd. a aplicar',
       'Quantidade a aplicar (ex.10 gotas)',
       '',
       'APLICA',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       130,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       440,
       5,
       'CODAMB',
       'S',
       'DAMB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DAMB.DESAMB',
       'V',
       '',
       '',
       'N',
       'F',
       'Ambiente',
       'Ambiente',
       'DAMB.CODTAB = EIOR.CODAMB(+)',
       'CODAMB',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       100,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       '',
       'N',
       'F',
       'Diviso',
       'Diviso do Produto',
       'EIOR.CODCOR = DIV.CODITE(+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da filial',
       'EIOR.CODFIL = DFIL.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       300,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Fornecedor',
       'Cdigo do Fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       90,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Produto',
       'Cdigo do Produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       430,
       5,
       'CODMUL',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'N',
       'F',
       'Sub-Estoque',
       'Sub-Estoque',
       'DMUL.CODTAB = EIOR.CODMUL(+)',
       'CODMUL',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       270,
       6,
       'CODPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Tcnico',
       'Cdigo do Tcnico',
       '',
       'CODPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       110,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       '',
       'N',
       'F',
       'Sub-Diviso ',
       'Sub-Diviso do produto',
       'EIOR.CODTAM = SUB.CODITE(+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       510,
       5,
       'CODTER',
       'S',
       'DTER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DTER.TER_IP',
       'I',
       '',
       '',
       '',
       'F',
       'Terminal',
       'Terminal',
       'DTER.CODTAB(+) = EIOR.CODTER',
       'CODTER',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       220,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       '9',
       'F',
       'Usurio',
       'Cdigo do Usurio',
       'EIOR.FILUSU = USU.FILUSU(+) AND EIOR.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       690,
       1,
       'CONCLU',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Servio Concludo?',
       'Servio Concludo?',
       '',
       'CONCLU',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       660,
       6,
       'COOVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       'F',
       'Cdigo COO da venda',
       'Cdigo COO da venda',
       '',
       'COOVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       600,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Data de incluso',
       'Data de incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       420,
       3,
       'DIADUR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Durao',
       'Durao',
       '',
       'DIADUR',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       320,
       8,
       'ENTREG',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Entrega',
       'Data e hora da entrega',
       '',
       'ENTREG',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       490,
       3,
       'FILDOU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Mdico',
       'Filial Mdico',
       '',
       'FILDOU',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       640,
       3,
       'FILEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial do endereo',
       'Filial do endereo',
       '',
       'FILEND',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       520,
       3,
       'FILEQP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Equipamento',
       'Filial Equipamento',
       '',
       'FILEQP',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       290,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial do fornecedor',
       'Filial do fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       230,
       3,
       'FILIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Item de Venda',
       '',
       '',
       'FILIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       80,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial do Produto',
       'Filial do Produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       550,
       3,
       'FILORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial da Origem',
       '',
       '',
       'FILORI',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       260,
       3,
       'FILPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial do Tecnico',
       '',
       '',
       'FILPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       460,
       3,
       'FILRCT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial da Receita',
       'Filial da Receita',
       '',
       'FILRCT',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       120,
       3,
       'FILRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial da Reserva',
       'Filial da Reserva',
       '',
       'FILRES',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       210,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial do Usurio',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       670,
       1,
       'FLGENC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Encomendado?',
       'Indica se o item pode ser encomendado sem ser faturado',
       '',
       'FLGENC',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       60,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       630,
       1,
       'FLGIVO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Processada Separao',
       'Processada Separao?',
       '',
       'FLGIVO',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       580,
       5,
       'ITEORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Item da origem',
       'Item da origem',
       '',
       'ITEORI',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       200,
       1,
       'MONTAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Montargem',
       'Montargem',
       '',
       'MONTAR',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       650,
       4,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero do endereo',
       'Nmero do endereo',
       '',
       'NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       310,
       20,
       'NUMFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero Externo',
       'Nmero Externo',
       '',
       'NUMFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       40,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Item',
       'Nmero do item do pedido',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       250,
       5,
       'NUMIVE',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Item de Venda',
       'Item de Venda',
       '',
       'NUMIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       570,
       8,
       'NUMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Nmero da Origem',
       'Nmero da Origem',
       '',
       'NUMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       30,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Nmero Pedido/OS',
       'Nmero Pedido/OS',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       540,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       50,
       3,
       'ORDITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ordem de Itens',
       'Ordem de Itens
Ordem de Itens',
       '',
       'ORDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       700,
       1,
       'PERENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Perodo da Entrega',
       'Perodo da Entrega',
       '',
       'PERENT',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       410,
       1,
       'PERIOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Perodo da aplicao',
       'Perodo da aplicao',
       '',
       'PERIOD',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       610,
       5,
       'PERIPI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% IPI ltima Compra ',
       '% IPI ltima Compra ',
       '',
       'PERIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       340,
       5,
       'PHOISO',
       'S',
       'DISO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DISO.PHOISO',
       'V',
       '',
       '',
       'N',
       'F',
       'ISO',
       'ISO do filme',
       'EIOR.PHOISO=DISO.CODTAB (+)',
       'PHOISO',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       350,
       5,
       'PHOMAR',
       'S',
       'DMAR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMAR.PHOMAR',
       'V',
       '',
       '',
       'N',
       'F',
       'Marca do Filme',
       'Marca do Filme',
       'EIOR.PHOMAR=DMAR.CODTAB (+)',
       'PHOMAR',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       360,
       5,
       'PHOOUT',
       'S',
       'DPHO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DPHO.PHOOUT',
       'V',
       '',
       '',
       'N',
       'F',
       'Outros',
       'Outra classificao do filme',
       'EIOR.PHOOUT=DPHO.CODTAB (+)',
       'PHOOUT',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       370,
       5,
       'PHOTIP',
       'S',
       'DTIP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DTIP.PHOTIP',
       'V',
       '',
       '',
       'N',
       'F',
       'Tipo de Filme',
       'Tipo de Filme',
       'EIOR.PHOTIP=DTIP.CODTAB (+)',
       'PHOTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       330,
       12,
       'PREUNI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Preo Unitrio',
       'Preo Unitrio',
       '',
       'PREUNI',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       70,
       1,
       'PROMOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Promoo',
       'Promoo',
       '',
       'PROMOC',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       140,
       12,
       'QTDENT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtd. Entregue',
       'Quantidade entregue',
       '',
       'QTDENT',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       150,
       12,
       'QTDITE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtd. Pedida/OS',
       'Quantidade de determinado item',
       '',
       'QTDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       680,
       12,
       'QTDORI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade Original',
       'Quantidade Original',
       '',
       'QTDORI',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       480,
       14,
       'QTDPRE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Quantidade Prescrita',
       'Quantidade Prescrita',
       '',
       'QTDPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       400,
       2,
       'REPETE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'N vezes a aplicar',
       'Nmero de vezes a aplicar (ex. 2 vezes ao dia)',
       '',
       'REPETE',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       380,
       5,
       'RESULT',
       'S',
       'DROS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DROS.RESULT',
       'V',
       '',
       '',
       'N',
       'F',
       'Resultado',
       'Resultado',
       'EIOR.RESULT=DROS.CODTAB (+)',
       'RESULT',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       500,
       10,
       'SEQDOU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. do Mdico',
       'Sequenciador Mdico',
       '',
       'SEQDOU',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       530,
       10,
       'SEQEQP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. do Equipamento',
       'Sequenciador Equipamento',
       '',
       'SEQEQP',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       240,
       10,
       'SEQIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '9',
       'F',
       'Numero Item de Venda',
       'Numero Item de Venda',
       '',
       'SEQIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       470,
       10,
       'SEQRCT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador Receita',
       'Sequenciador Receita',
       '',
       'SEQRCT',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       450,
       5,
       'SERITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Rel. Serv./Produtos',
       'Permite auto relacionamento entre os servios e os produtos',
       '',
       'SERITE',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       620,
       1,
       'TIPENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de entrega',
       'Tipo de entrega',
       '',
       'TIPENT',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       560,
       1,
       'TIPORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo da Origem',
       'Tipo da Origem',
       '',
       'TIPORI',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       280,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Tcnico',
       'Tipo de Tcnico',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       20,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Pedido/OS',
       'Tipo Pedido/OS',
       '',
       'TIPPED',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       590,
       1,
       'TIPPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Pagamento',
       'Tipo de Pagamento',
       '',
       'TIPPGT',
       'T' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       160,
       12,
       'VLRCUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Total',
       'Valor Total',
       '',
       'VLRCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       170,
       14,
       'VLRENT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vlr. Entregue',
       'Valor entregue',
       '',
       'VLRENT',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       180,
       14,
       'VLRITE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vlr. Pedido/OS',
       'Valor deste item',
       '',
       'VLRITE',
       'F' FROM DUAL
UNION ALL
SELECT 'EIOR',
       '--',
       190,
       12,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Total Sem Desc',
       'Valor pago ao fornecedor Valor Total Sem Desconto',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 7804 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'EIOR',
       'FLGEST',
       0,
       'A',
       'Em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'FLGEST',
       0,
       'E',
       'Faturado/Vendido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'FLGIVO',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'FLGIVO',
       0,
       'P',
       'Processado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'MONTAR',
       0,
       'F',
       'Sem Montagem',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'MONTAR',
       0,
       'I',
       'Montagem Interna',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'MONTAR',
       0,
       'T',
       'Montagem na Entrega',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'PERENT',
       0,
       'M',
       'Manh',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'PERENT',
       0,
       'N',
       'Noite',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'PERENT',
       0,
       'T',
       'Tarde',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'PERIOD',
       0,
       'D',
       'Dirio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'PERIOD',
       0,
       'M',
       'Mensal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'PERIOD',
       0,
       'S',
       'Semanal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'PROMOC',
       0,
       'E',
       'Promocional no Plano',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'PROMOC',
       0,
       'N',
       'No Promocional no Plano',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'PROMOC',
       0,
       'Q',
       'Qualquer Plano',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'TIPENT',
       0,
       '0',
       'Cliente Leva',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'TIPENT',
       0,
       '1',
       'Depsito Entrega',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'TIPENT',
       0,
       '2',
       'Loja Entrega',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'TIPENT',
       0,
       '3',
       'Retira no Depsito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'TIPENT',
       0,
       '4',
       'Em Outra Loja',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'TIPENT',
       0,
       '5',
       'Entrega Futura',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'TIPENT',
       0,
       '6',
       'No Entrega (Apenas Oramento)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'TIPENT',
       0,
       '7',
       'Venda sob Encomenda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'TIPORI',
       0,
       'O',
       'DAV',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'TIPORI',
       0,
       'P',
       'Pr-Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'TIPORI',
       0,
       'S',
       'DAV-OS',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'TIPPAR',
       0,
       'F',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'TIPPAR',
       0,
       'T',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'TIPPED',
       0,
       'O',
       'DAV',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'TIPPED',
       0,
       'P',
       'Pr-Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'TIPPED',
       0,
       'S',
       'DAV-OS',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'TIPPGT',
       0,
       'C',
       'Contrato',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIOR',
       'TIPPGT',
       0,
       'F',
       'Faturamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7805 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EIVE',
       TO_NUMBER(null),
       'EIVE',
       'Exp. Itens Vendas ',
       'TV_EIVE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7806 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EIVE','--','' FROM DUAL
UNION ALL
SELECT 'EIVE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EIVE','99','Outros' FROM DUAL
);

/*-- SEQ 7807 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EIVE',
       '--',
       2130,
       12,
       'ACRRAT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Acrsc Rateado Item',
       'Acrscimo Rateado do Item',
       '',
       'ACRRAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2140,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       610,
       12,
       'BASCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base COFINS',
       'Base COFINS',
       '',
       'BASCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2560,
       12,
       'BASCOFRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base PIS/COF/CSL ret',
       'Base de PIS/COFINS/CSLL retido',
       '',
       'BASCOFRET',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2720,
       12,
       'BASEFE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base Efetiva',
       'Valor da base de clculo efetiva',
       '',
       'BASEFE',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2610,
       14,
       'BASFCP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base do FCP',
       'Valor da Base de Clculo do FCP',
       '',
       'BASFCP',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2680,
       14,
       'BASFCP_RET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base do FCP ST Ret',
       'Valor da Base de Clculo do FCP retido anteriormente por ST',
       '',
       'BASFCP_RET',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2650,
       14,
       'BASFCP_ST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base do FCP ST',
       'Valor da Base de Clculo do FCP retido por Substituio Tributria',
       '',
       'BASFCP_ST',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       780,
       12,
       'BASICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base ICMS',
       'Base ICMS',
       '',
       'BASICM',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2080,
       12,
       'BASICMDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Base ICMS Destino',
       'Base de ICMS na UF de Destino (Valor Integral)',
       '',
       'BASICMDES',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       620,
       12,
       'BASIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base IPI',
       'Base IPI',
       '',
       'BASIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       630,
       12,
       'BASISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base ISS',
       'Base ISS',
       '',
       'BASISS',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       640,
       12,
       'BASPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base PIS',
       'Base PIS',
       '',
       'BASPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       790,
       12,
       'BASUBS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base Sub. Tributria',
       'Base da Substituio Tributria',
       '',
       'BASUBS',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       1040,
       9,
       'CLIENTE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Filial/Cd. Cliente',
       'Filial/Cdigo do cliente',
       '',
       'CLIENTE',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       1060,
       20,
       'CLI_CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Cd. Externo Cliente',
       'Cdigo Externo Cliente',
       '',
       'CLI_CODEXT',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       10,
       5,
       'CNT_RO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cont. Reinicio Oper.',
       'Contador de Reinicio de Operao',
       '',
       'CNT_RO',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2030,
       7,
       'CODCES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'CEST',
       'CEST',
       '',
       'CODCES',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       800,
       3,
       'CODCST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'CST ICMS',
       'CST ICMS',
       '',
       'CODCST',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2150,
       3,
       'CODENQ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Enq IPI',
       'Cdigo de Enquadramento Legal do IPI',
       '',
       'CODENQ',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = VEN.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2160,
       60,
       'CODFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Fiscal',
       'Cdigo Fiscal',
       '',
       'CODFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       30,
       20,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Cdigo Externo',
       'Cdigo Externo (descontinuado)',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       40,
       30,
       'CODMUL',
       'A',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       'DMUL.CODTAB = IVE.CODMUL',
       'CODMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       810,
       1,
       'CODORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem da Mercadoria',
       'Origem da Mercadoria',
       '',
       'CODORI',
       'T' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2170,
       5,
       'CODPRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Tabela Preo',
       'Cdigo da tabela de preo',
       '',
       'CODPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       50,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Cdigo da srie',
       'VEN.CODSER=DSER.CODSER (+)',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       60,
       10,
       'CODVDD',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd externo vendedor',
       'Cdigo externo do vendedor',
       'IVE.FILVDD = USU.FILUSU(+)  AND IVE.CODVDD = USU.CODUSU(+)',
       'CODVDD',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       70,
       9,
       'COMISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Comisso',
       'Comisso',
       '',
       'COMISS',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2180,
       3,
       'CROORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'CRO Doc Vinculado',
       'Contador de Reinicio de Operao do Documento Vinculado',
       '',
       'CROORI',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2190,
       14,
       'CUSMED_FIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Custo mdio',
       'Custo mdio',
       '',
       'CUSMED_FIS',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2200,
       14,
       'CUSREP_FREFIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Custo da ltima Entr',
       'Custo da ltima Entrada',
       '',
       'CUSREP_FREFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2210,
       14,
       'CUSSIM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Custo Reposio Simu',
       'Custo de reposio: Custo simulado',
       '',
       'CUSSIM',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2010,
       18,
       'DATHORORI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Doc. de Origem',
       'Data e Hora da Emisso do Documento de Origem',
       '',
       'DATHORORI',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       80,
       1,
       'DATIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       90,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2220,
       30,
       'DESMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio do Produto',
       'Descrio do Produto',
       '',
       'DESMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2230,
       12,
       'DESRAT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Desc Rateado Item',
       'Desconto Rateado do Item',
       '',
       'DESRAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       100,
       3,
       'ECFORI',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       'F',
       'ECF Origem',
       'Nmero do ECF de Origem',
       'DECF.FILECF = EIVE.FILORI(+) AND DECF.NUMECF = EIVE.ECFORI(+)',
       'ECFORI',
       'T' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       110,
       5,
       'EMBORI',
       'G',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       '',
       '9',
       'F',
       'Embalagem Original',
       'Embalagem Original',
       'IVE.EMBORI=SUB.CODITE(+)',
       'EMBORI',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       120,
       12,
       'EMBQTD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade Original',
       'Quantidade Original',
       '',
       'EMBQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       1070,
       1,
       'ENTSAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo Documento',
       'Tipo de Documento',
       '',
       'ENTSAI',
       'T' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2020,
       1,
       'EXPFIS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exportado Fiscal?',
       'Exportado Fiscal?',
       '',
       'EXPFIS',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       130,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exportada?',
       'Exportada?',
       '',
       'EXPORT',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       140,
       3,
       'FILBIC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Bico Comb.',
       'Filial Bico Comb.',
       '',
       'FILBIC',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2240,
       3,
       'FILLOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do lote',
       'Filial do lote',
       '',
       'FILLOT',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       150,
       3,
       'FILORI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = VEN.CODFIL',
       'FILORI',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2250,
       3,
       'FILPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do DAV Origin',
       'Filial do DAV Original',
       '',
       'FILPED',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2260,
       3,
       'FILPRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Tabela Preo',
       'Filial da tabela de preo',
       '',
       'FILPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       1080,
       1,
       'FLGDEV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Devoluo?',
       'Devoluo?',
       '',
       'FLGDEV',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2280,
       5,
       'GRA_CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Diviso do Produto',
       'Diviso do Produto
',
       '',
       'GRA_CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2000,
       20,
       'GRA_CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo externo grade',
       'Cdigo externo da grade',
       '',
       'GRA_CODEXT',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2290,
       5,
       'GRA_CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Produto',
       'Cdigo do Produto',
       '',
       'GRA_CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2300,
       5,
       'GRA_CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Sub-Diviso do Produ',
       'Sub-Diviso do Produto',
       '',
       'GRA_CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2310,
       3,
       'GRA_FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do Produto',
       'Filial do Produto',
       '',
       'GRA_FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2320,
       12,
       'ICMDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Val ICMS Diferenciad',
       'Valor de ICMS diferenciado (quando CST x51)',
       '',
       'ICMDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2090,
       6,
       'ICMINTDES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Alquota Interna Des',
       'Alquota nas Operaes Internas na UF do Destinatrio para Partilha ICMS',
       '',
       'ICMINTDES',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       160,
       1,
       'ICMTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       '9',
       'F',
       'Tipo Tributao',
       'Tipo de tributao do produto',
       '',
       'ICMTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2330,
       5,
       'IOR_NUMITE',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero do Item DAV',
       'Nmero do Item da DAV',
       '',
       'IOR_NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       890,
       12,
       'ISEICM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Base ICMS Isento',
       'Base ICMS Isento',
       '',
       'ISEICM',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2040,
       5,
       'ITEFIS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nmero item Fiscal',
       'Nmero do item Fiscal',
       '',
       'ITEFIS',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       170,
       2,
       'ITEORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Item',
       'Nmero do item',
       '',
       'ITEORI',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2340,
       5,
       'ITEPED',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Item do DAV Original',
       'Item do DAV Original',
       '',
       'ITEPED',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       180,
       1,
       'LANEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Estoque',
       'Estoque',
       '',
       'LANEST',
       'T' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       1090,
       2,
       'MODORI',
       'A',
       'DMNF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMNF.DESMNF',
       'V',
       '',
       '',
       'A',
       '',
       'Modelo Doc de Origem',
       'Cdigo do Modelo do Documento Fiscal de Origem',
       'DMNF.CODMNF(+) = EIVE.MODORI',
       'MODORI',
       'T' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       190,
       1,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       200,
       3,
       'NATFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Natureza Fiscal',
       'Natureza fiscal',
       '',
       'NATFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2350,
       20,
       'NCM_CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'NCM_CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       210,
       6,
       'NOTORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero ',
       'Nmero da nota ',
       '',
       'NOTORI',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       740,
       8,
       'NUMBLO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero do Bloco',
       'Nmero do Bloco do Oramento',
       '',
       'NUMBLO',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       220,
       3,
       'NUMECF',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       'F',
       'Nmero do ECF',
       'Nmero do ECF',
       'DECF.FILECF = EIVE.CODFIL AND DECF.NUMECF = EIVE.NUMECF',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       230,
       20,
       'NUMEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nm. Externo',
       'Nmero externo',
       '',
       'NUMEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2360,
       20,
       'NUMEXT_DEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm Externo Depsito',
       'Nmero Externo para Depsito',
       '',
       'NUMEXT_DEP',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       240,
       2,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Item',
       'Nmero do item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       250,
       6,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero',
       'Nmero da nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2380,
       10,
       'NUMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Seq Int Doc Vinculad',
       'Sequenciador Interno do Documento Vinculado',
       '',
       'NUMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       750,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Nmero do Oramento',
       'Nmero do Oramento',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       260,
       10,
       'ORD_CM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Orden. Custo Mdio',
       'Ordenao Custo Mdio',
       '',
       'ORD_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       930,
       12,
       'OUTICM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Base ICMS Outros',
       'Base ICMS Outros',
       '',
       'OUTICM',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2390,
       12,
       'OUTTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Outras Taxas e Despe',
       'Outras Taxas e Despesas Acessrias',
       '',
       'OUTTAX',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       650,
       6,
       'PERCOF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '%COFINS',
       '% COFINS',
       '',
       'PERCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2640,
       6,
       'PERCON_ST',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Alquota Cons. Final',
       'Alquota suportada pelo Consumidor Final',
       '',
       'PERCON_ST',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2730,
       6,
       'PEREFE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Alquota Efetiva',
       'Alquota do ICMS efetiva',
       '',
       'PEREFE',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2620,
       6,
       'PERFCP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% FCP',
       '% do ICMS relativo ao Fundo de Combate  Pobreza (FCP)',
       '',
       'PERFCP',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2060,
       5,
       'PERFCPDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Fundo Pob. UF Dest',
       '% do Fundo de Pobreza na UF de Destino',
       '',
       'PERFCPDES',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2690,
       6,
       'PERFCP_RET',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% FCP ST Ret',
       '% do FCP retido anteriormente por Substituio Tributria',
       '',
       'PERFCP_RET',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2660,
       6,
       'PERFCP_ST',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% FCP ST',
       '% do FCP retido por Substituio Tributria',
       '',
       'PERFCP_ST',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       270,
       4,
       'PERICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '%ICMS ou %ISS',
       'ICMS(Qdo Mat.)a TAXA002=IPI e ISS(Qdo Serv.) a TAXA002=IRRF e/ou COFINS',
       '',
       'PERICM',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       280,
       4,
       'PERIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '%IPI ou %IRRF',
       '% ISS(A TAXA002 pode mudar conforme descrio da TAXA001',
       '',
       'PERIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2110,
       5,
       'PERPARICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% da Partilha ICMS',
       '% da Partilha de ICMS para UF de Destino',
       '',
       'PERPARICM',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       660,
       6,
       'PERPIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '%PIS',
       '% PIS',
       '',
       'PERPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       290,
       8,
       'QTDMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtde',
       'Quantidade vendida',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       300,
       12,
       'QTD_CM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtde Custo Medio',
       'Quantidade Custo Mdio',
       '',
       'QTD_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2710,
       7,
       'REDEFE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Reduo Base Efetiva',
       'Percentual de reduo da base de clculo efetiva',
       '',
       'REDEFE',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       310,
       7,
       'REDITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base reduzida ICMS',
       'Base reduzida de ICMS do item',
       '',
       'REDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2420,
       15,
       'REFBAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Referncia Bsica do',
       'Referncia Bsica do Produto',
       '',
       'REFBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2430,
       20,
       'REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Referncia do Produt',
       'Referncia do Produto',
       '',
       'REFPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2440,
       16,
       'SAL_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Saldo C.M. Fiscal',
       'Saldo C.M. Fiscal',
       '',
       'SAL_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       320,
       2,
       'SEQFIL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '',
       'Nmero sequencial do bico na filial',
       '',
       'SEQFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2450,
       10,
       'SEQLOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador de Lote',
       'Sequenciador de Lote',
       '',
       'SEQLOT',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       950,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       330,
       2,
       'SERORI',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       'F',
       'Srie ',
       'Cdigo da srie',
       'VEN.CODSER=DSER.CODSER (+)',
       'SERORI',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2460,
       1,
       'SIMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Regime Tributrio Fi',
       'Regime Tributrio da Filial',
       '',
       'SIMPLE',
       'T' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       670,
       2,
       'SITCOF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'CST COFINS',
       'CST COFINS',
       '',
       'SITCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       680,
       2,
       'SITIPI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'CST IPI',
       'CST IPI',
       '',
       'SITIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2600,
       1,
       'SITISS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Cd Tributao ISSQN',
       'Cdigo de Tributao de ISSQN',
       '',
       'SITISS',
       'T' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       340,
       1,
       'SITKIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Kit',
       'Situao de Kit',
       '',
       'SITKIT',
       'T' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       350,
       1,
       'SITMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Normal ou Cancelado',
       '',
       'SITMOV',
       'T' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       690,
       2,
       'SITPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'CST PIS',
       'CST PIS',
       '',
       'SITPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       360,
       12,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'F',
       '',
       'F',
       '',
       '',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       970,
       12,
       'SUBSTT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Vlr ICMS ST UF Dest.',
       'Valor do ICMS ST da UF destino',
       '',
       'SUBSTT',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2580,
       4,
       'TAXCOFRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% de COFINS retido',
       'Alquota de COFINS retido',
       '',
       'TAXCOFRET',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       700,
       6,
       'TAXICM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '%ICMS',
       '% ICMS',
       '',
       'TAXICM',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2100,
       6,
       'TAXICMDES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Alq. Interestadual',
       'Alquota Interestadual da Partilha de ICMS',
       '',
       'TAXICMDES',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       710,
       6,
       'TAXIPI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '%IPI',
       '% IPI',
       '',
       'TAXIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       370,
       4,
       'TAXIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '%IRRF',
       '% IRRF',
       '',
       'TAXIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       380,
       4,
       'TAXISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '%ISS',
       '% ISS',
       '',
       'TAXISS',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2570,
       4,
       'TAXPISRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% de PIS retido',
       'Alquota de PIS retido',
       '',
       'TAXPISRET',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2590,
       4,
       'TAXSOCRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% de CSLL retido',
       'Alquota de CSLL retido',
       '',
       'TAXSOCRET',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       390,
       1,
       'TIP001',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tributado',
       'Tributado',
       '',
       'TIP001',
       'T' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2470,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo do DAV Original',
       'Tipo do DAV Original',
       '',
       'TIPPED',
       'T' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       400,
       1,
       'TIPPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Produto',
       'Tipo Produto',
       '',
       'TIPPRO',
       'T' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2480,
       7,
       'TOTPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TOTPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2490,
       16,
       'TOT_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Total C.M. Fis',
       'Valor Total C.M. Fiscal',
       '',
       'TOT_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2500,
       2,
       'UNIMED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Unidade de Medida',
       'Unidade de Medida',
       '',
       'UNIMED',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       410,
       8,
       'VEN_DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data e hora da operao',
       '',
       'VEN_DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       1050,
       1,
       'VEN_FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Situao Venda',
       'Estado (Cancelado/Quitado/Em aberto)',
       '',
       'VEN_FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       420,
       1,
       'VINCUL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Vnculo',
       'Vinculada',
       '',
       'VINCUL',
       'T' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       720,
       12,
       'VLRCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor COFINS',
       'Valor COFINS',
       '',
       'VLRCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2530,
       12,
       'VLRCOFRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor de COF Retido',
       'Valor de COFINS Retido',
       '',
       'VLRCOFRET',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2510,
       12,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2740,
       12,
       'VLREFE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'ICMS Efetivo',
       'Valor do ICMS efetivo',
       '',
       'VLREFE',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2630,
       14,
       'VLRFCP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor FCP',
       'Valor do ICMS relativo ao Fundo de Combate  Pobreza (FCP)',
       '',
       'VLRFCP',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2700,
       14,
       'VLRFCP_RET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor FCP ST Ret.',
       'Valor do FCP retido anteriormente por Substituio Tributria',
       '',
       'VLRFCP_RET',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2670,
       14,
       'VLRFCP_ST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor FCP ST',
       'Valor do FCP retido por Substituio Tributria',
       '',
       'VLRFCP_ST',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       1000,
       12,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Frete',
       'Valor Frete',
       '',
       'VLRFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       430,
       9,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor ICMS / ISS',
       'Valor 001',
       '',
       'VLRICM',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2070,
       12,
       'VLRICMDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor ICMS UF Dest',
       'Valor de ICMS para UF de Destino',
       '',
       'VLRICMDES',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2120,
       12,
       'VLRICMFCP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Vl ICMS Fun Pob Dest',
       'Valor de ICMS para Fundo de Pobreza na UF de Destino',
       '',
       'VLRICMFCP',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2050,
       12,
       'VLRICMORI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor ICMS UF Orig',
       'Valor de ICMS para UF de Origem',
       '',
       'VLRICMORI',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2750,
       12,
       'VLRICM_COM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'ICMS Prprio Subst.',
       'Valor do ICMS Prprio do Substituto cobrado em operao anterior',
       '',
       'VLRICM_COM',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       440,
       9,
       'VLRIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor IPI / IRRF',
       'Valor 002',
       '',
       'VLRIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       450,
       9,
       'VLRIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor IRRF',
       'Valor IRRF',
       '',
       'VLRIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       460,
       9,
       'VLRISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor ISS',
       'Valor ISS',
       '',
       'VLRISS',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       1010,
       12,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Lquido',
       'Valor Lquido do Item',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       470,
       8,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Item',
       'Valor total do item',
       '',
       'VLRMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       600,
       12,
       'VLRORI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Original',
       'Valor Original',
       '',
       'VLRORI',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       730,
       12,
       'VLRPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor PIS',
       'Valor PIS',
       '',
       'VLRPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2520,
       12,
       'VLRPISRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor de PIS Retido',
       'Valor de PIS Retido',
       '',
       'VLRPISRET',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       1020,
       12,
       'VLRSEG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Seguro',
       'Valor Seguro',
       '',
       'VLRSEG',
       'F' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2550,
       12,
       'VLRSOC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor de CSLL',
       'Valor de CSLL',
       '',
       'VLRSOC',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       2540,
       12,
       'VLRSOCRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor de CSLL Retido',
       'Valor de CSLL Retido',
       '',
       'VLRSOCRET',
       '' FROM DUAL
UNION ALL
SELECT 'EIVE',
       '--',
       1030,
       12,
       'VLRUNI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vlr Unitrio Lquido',
       'Valor unitrio lquido',
       '',
       'VLRUNI',
       'F' FROM DUAL
);

/*-- SEQ 7808 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'EIVE',
       'CODORI',
       0,
       '0',
       'Nacional, exceto cd.3,4,5,8',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'CODORI',
       0,
       '1',
       'Estrang., Import.Dir., Exc.6',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'CODORI',
       0,
       '2',
       'Estrang., Adq.Int., Exc.7',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'CODORI',
       0,
       '3',
       'Nacional, Cont.Import.>40%<70%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'CODORI',
       0,
       '4',
       'Nacional, Conf.Proc.Prod.Bs.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'CODORI',
       0,
       '5',
       'Nacional, Cont.Import <= 40%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'CODORI',
       0,
       '6',
       'Estrang., Import.Dir.CAMEX-GNL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'CODORI',
       0,
       '7',
       'Estrang., Adq.Int. CAMEX-GNL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'CODORI',
       0,
       '8',
       'Nacional, Import. > a 70%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'ENTSAI',
       0,
       'E',
       'Entrada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'ENTSAI',
       0,
       'S',
       'Sada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'ICMTIP',
       0,
       '0',
       'Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'ICMTIP',
       0,
       '1',
       'No tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'ICMTIP',
       0,
       '2',
       'Isento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'ICMTIP',
       0,
       '3',
       'Substitudo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'ICMTIP',
       0,
       '4',
       'Isento no estado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'LANEST',
       0,
       'C',
       'Confirma Reserva',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'LANEST',
       0,
       'N',
       'Nao (s Histrico)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'LANEST',
       0,
       'R',
       'Reserva',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'LANEST',
       0,
       'S',
       'Baixa Estoque',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'SIMPLE',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'SIMPLE',
       0,
       'S',
       'Simples',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'SITISS',
       0,
       'I',
       'ISENTA',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'SITISS',
       0,
       'N',
       'NORMAL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'SITISS',
       0,
       'R',
       'RETIDA',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'SITISS',
       0,
       'S',
       'SUBSTITUTA',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'SITKIT',
       0,
       '1',
       'Header',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'SITKIT',
       0,
       '2',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'SITKIT',
       0,
       '3',
       'Item Kit',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'SITMOV',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'SITMOV',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'TIP001',
       0,
       'M',
       'Material',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'TIP001',
       0,
       'S',
       'Servios',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'TIPPED',
       0,
       'O',
       'DAV',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'TIPPED',
       0,
       'P',
       'Pr-Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'TIPPED',
       0,
       'S',
       'DAV-OS',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'TIPPRO',
       0,
       '0',
       'Material',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'TIPPRO',
       0,
       '1',
       'Servio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'VEN_FLGEST',
       0,
       'A',
       'Em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'VEN_FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'VEN_FLGEST',
       0,
       'I',
       'Incompleta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'VEN_FLGEST',
       0,
       'Q',
       'Quitado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'VINCUL',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'VINCUL',
       0,
       'C',
       'Completo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EIVE',
       'VINCUL',
       0,
       'N',
       'No  vnculo',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7809 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EKIT',
       TO_NUMBER(null),
       'EKIT',
       'Exportao de Kit',
       'TV_EKIT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7810 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EKIT','--','' FROM DUAL
UNION ALL
SELECT 'EKIT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EKIT','99','Outros' FROM DUAL
);

/*-- SEQ 7811 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EKIT',
       '--',
       10,
       1,
       'BRINDE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Brinde?',
       'Indica  ou no brinde',
       '',
       'BRINDE',
       'F' FROM DUAL
UNION ALL
SELECT 'EKIT',
       '--',
       20,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'EKIT',
       '--',
       30,
       20,
       'CODKIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODKIT',
       'F' FROM DUAL
UNION ALL
SELECT 'EKIT',
       '--',
       40,
       1,
       'DATIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'EKIT',
       '--',
       50,
       1,
       'FLGIMP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Imprime na N.F.?',
       'Imprime ou no na nota fiscal',
       '',
       'FLGIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'EKIT',
       '--',
       60,
       1,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'EKIT',
       '--',
       70,
       8,
       'NUMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtde no KIT',
       'Quantidade do item no KIT',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'EKIT',
       '--',
       80,
       12,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'STATUS',
       'F' FROM DUAL
);

/*-- SEQ 7812 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ELAN',
       TO_NUMBER(null),
       'ELAN',
       'Exp. de Lan. Avulsos',
       'TV_ELAN',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7813 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ELAN','--','' FROM DUAL
UNION ALL
SELECT 'ELAN','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ELAN','99','Outros' FROM DUAL
);

/*-- SEQ 7814 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ELAN',
       '--',
       10,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'ELAN',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'ELAN.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'ELAN',
       '--',
       30,
       1,
       'DATIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'ELAN',
       '--',
       40,
       8,
       'DATMOV',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Movto',
       'Data Movto',
       '',
       'DATMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'ELAN',
       '--',
       50,
       30,
       'DESEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'DESEST',
       'F' FROM DUAL
UNION ALL
SELECT 'ELAN',
       '--',
       60,
       17,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'ELAN',
       '--',
       70,
       1,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'ELAN',
       '--',
       80,
       20,
       'NUMEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Num. Externo',
       'Num. Externo',
       '',
       'NUMEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'ELAN',
       '--',
       90,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(ELAN.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'ELAN',
       '--',
       100,
       8,
       'QTDMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtde',
       'Qtde',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'ELAN',
       '--',
       110,
       12,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'ELAN',
       '--',
       120,
       5,
       'TIPLAN',
       'G',
       'DLAN',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DLAN.DESLAN',
       'V',
       '',
       '',
       '9',
       'F',
       'Motivo Lanamento',
       'Motivo do Lanamento',
       'ELAN.TIPLAN = DLAN.CODTAB',
       'TIPLAN',
       'F' FROM DUAL
UNION ALL
SELECT 'ELAN',
       '--',
       130,
       1,
       'TIPMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo',
       '',
       'TIPMOV',
       'T' FROM DUAL
UNION ALL
SELECT 'ELAN',
       '--',
       140,
       8,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor',
       'Valor',
       '',
       'VLRMOV',
       'F' FROM DUAL
);

/*-- SEQ 7815 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ELAN',
       'TIPMOV',
       0,
       'A',
       'Ajuste',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ELAN',
       'TIPMOV',
       0,
       'I',
       'Inicial',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7816 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ELIM',
       TO_NUMBER(null),
       'ELIM',
       'Exp. Limite de CC',
       'TV_ELIM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7817 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ELIM','--','' FROM DUAL
UNION ALL
SELECT 'ELIM','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ELIM','99','Outros' FROM DUAL
);

/*-- SEQ 7818 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ELIM',
       '--',
       10,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Alternativo nico',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'ELIM',
       '--',
       20,
       1,
       'DATIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'ELIM',
       '--',
       30,
       12,
       'LIMCCC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Limite C/C',
       'Limite Conta Corrente',
       '',
       'LIMCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'ELIM',
       '--',
       40,
       1,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'ELIM',
       '--',
       50,
       256,
       'OBSERV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'ELIM',
       '--',
       60,
       12,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       '',
       '',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'ELIM',
       '--',
       70,
       30,
       'TIPCCC',
       'A',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao C/C',
       'Descricao C/C Cliente',
       'DCCC.CODTAB = ELIM.TIPCCC',
       'TIPCCC',
       'F' FROM DUAL
);

/*-- SEQ 7819 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EMOV',
       TO_NUMBER(null),
       'EMOV',
       'Exporta Mov. Estoque',
       'TE_MOV',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7820 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EMOV','--','' FROM DUAL
UNION ALL
SELECT 'EMOV','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EMOV','99','Outros' FROM DUAL
);

/*-- SEQ 7821 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EMOV',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EMOV.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EMOV',
       '--',
       20,
       5,
       'CODMUL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Estoque~Mltiplo',
       'Estoque Mltiplo',
       '',
       'CODMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'EMOV',
       '--',
       30,
       7,
       'DATMOV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Movto',
       'Data Movto',
       '',
       'DATMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'EMOV',
       '--',
       40,
       25,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'EMOV',
       '--',
       50,
       20,
       'EXTPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd. Produto~Origem',
       'Cdigo do produto no sistema de origem',
       '',
       'EXTPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'EMOV',
       '--',
       60,
       40,
       'NUMEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Num. Externo',
       'Num. Externo',
       '',
       'NUMEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'EMOV',
       '--',
       70,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'EMOV',
       '--',
       80,
       14,
       'QTDMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde',
       'Qtde',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'EMOV',
       '--',
       90,
       5,
       'TIPLAN',
       'S',
       'DLAN',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DLAN.DESLAN',
       'V',
       '',
       '',
       '9',
       'F',
       'Motivo~Lanamento',
       'Motivo Lanamento',
       'DLAN.CODTAB = EMOV.TIPLAN',
       'TIPLAN',
       'F' FROM DUAL
UNION ALL
SELECT 'EMOV',
       '--',
       100,
       1,
       'TIPMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo',
       '',
       'TIPMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'EMOV',
       '--',
       110,
       14,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor',
       '',
       'VLRMOV',
       'F' FROM DUAL
);

/*-- SEQ 7822 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'EMOV',
       'TIPMOV',
       0,
       'A',
       'Ajuste',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EMOV',
       'TIPMOV',
       0,
       'C',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EMOV',
       'TIPMOV',
       0,
       'I',
       'Inicial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EMOV',
       'TIPMOV',
       0,
       'V',
       'Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7823 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ENAT',
       TO_NUMBER(null),
       'ENAT',
       'Export de Natureza',
       'TV_ENAT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7824 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ENAT','--','' FROM DUAL
UNION ALL
SELECT 'ENAT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ENAT','99','Outros' FROM DUAL
);

/*-- SEQ 7825 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ENAT',
       '--',
       10,
       80,
       'COMENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Comentrios',
       'Comentrios da natureza',
       '',
       'COMENT',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       20,
       1,
       'CONSFI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Consumidor Final',
       'Consumidor Final',
       '',
       'CONSFI',
       'T' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       30,
       1,
       'DATIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       40,
       10,
       'EXTDEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nat. dentro do Est.',
       'Cdigo Externo para Naturezas dentro do Estado',
       '',
       'EXTDEM',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       50,
       10,
       'EXTFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nat. fora do Est.',
       'Cdigo Externo para Naturezas fora do Estado',
       '',
       'EXTFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       60,
       1,
       'FINANC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Gera dados financ.? ',
       'Indica se gera dados financeiros',
       '',
       'FINANC',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       70,
       1,
       'LANVEN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Lanamento "Venda"? ',
       'Lana registro como sendo do tipo "venda"',
       '',
       'LANVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       80,
       2,
       'LIMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Limite de retorno',
       'Nmero de dias para devoluo da nota fiscal',
       '',
       'LIMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       90,
       1,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       100,
       1,
       'MOVEST',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Sada de mercadoria?',
       'Indica se movimenta estoque',
       '',
       'MOVEST',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       110,
       1,
       'NATATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo',
       '',
       'NATATI',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       120,
       3,
       'NATDEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo no estado ',
       'Natureza quando dentro do estado',
       '',
       'NATDEN',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       130,
       3,
       'NATFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo fora do est.',
       'Natureza quando fora do estado',
       '',
       'NATFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       140,
       3,
       'NATFUD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Natureza no estado',
       'Natureza futura quando dentro do estado',
       '',
       'NATFUD',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       150,
       3,
       'NATFUF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Natureza fora do est',
       'Natureza futura quando fora do estado',
       '',
       'NATFUF',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       160,
       5,
       'NATMUL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nat.Mltiplo Estoque',
       'Natureza Mltiplo Estoque',
       '',
       'NATMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       170,
       1,
       'NATOLN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Impresso on-line?',
       'Define se haver impresso on-line de NF',
       '',
       'NATOLN',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       180,
       6,
       'NATRED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Natureza Reduo',
       'Natureza Reduo',
       '',
       'NATRED',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       190,
       6,
       'NATREF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Natureza Referncia',
       'Natureza Referncia',
       '',
       'NATREF',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       200,
       40,
       'NATURE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Natureza',
       'Natureza da operao',
       '',
       'NATURE',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       210,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(ENAT.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       220,
       2,
       'SERVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie padro V. fut',
       'Srie para vinculao, caso a natureza tenha vinculao',
       '',
       'SERVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       230,
       12,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       240,
       1,
       'TIPNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo da natureza',
       'Tipo da natureza de operao',
       '',
       'TIPNAT',
       'T' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       250,
       1,
       'TRIBUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Gera tributos?',
       'Define se a NF gera tributos',
       '',
       'TRIBUT',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       260,
       1,
       'USACUS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Preo custo/venda?',
       'Indica se usa preo de custo como sendo preo de venda',
       '',
       'USACUS',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       270,
       2,
       'USAICM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'ICMS',
       'Tipo de ICMS',
       '',
       'USAICM',
       'F' FROM DUAL
UNION ALL
SELECT 'ENAT',
       '--',
       280,
       2,
       'USAIPI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'IPI',
       'Tipo de IPI',
       '',
       'USAIPI',
       'F' FROM DUAL
);

/*-- SEQ 7826 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ENAT',
       'CONSFI',
       0,
       'F',
       'Para revenda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ENAT',
       'CONSFI',
       0,
       'T',
       'Natureza para consumo final',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ENAT',
       'TIPNAT',
       0,
       'A',
       'Nota com vnculo anterior',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ENAT',
       'TIPNAT',
       0,
       'C',
       'Consumo interno',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ENAT',
       'TIPNAT',
       0,
       'D',
       'Devoluo',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7827 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ENQ ',
       TO_NUMBER(null),
       'ENQ ',
       'Enquadramento IPI',
       'TT_ENQ',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7828 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ENQ ','--','' FROM DUAL
UNION ALL
SELECT 'ENQ ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ENQ ','99','Outros' FROM DUAL
);

/*-- SEQ 7829 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ENQ ',
       '01',
       10,
       3,
       'CODENQ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Cdigo',
       'Cdigo',
       '',
       'CODENQ',
       'F' FROM DUAL
UNION ALL
SELECT 'ENQ ',
       '01',
       20,
       4000,
       'DESENQ',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio do Enquadr',
       'Descrio do Enquadramento Legal do IPI (Descrio)',
       '',
       'DESENQ',
       'F' FROM DUAL
UNION ALL
SELECT 'ENQ ',
       '01',
       30,
       1,
       'GRUCST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Grupo CST',
       'Grupo CST',
       '',
       'GRUCST',
       'T' FROM DUAL
);

/*-- SEQ 7830 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ENQ ',
       'GRUCST',
       0,
       'I',
       'Iseno',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ENQ ',
       'GRUCST',
       0,
       'M',
       'Imunidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ENQ ',
       'GRUCST',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ENQ ',
       'GRUCST',
       0,
       'R',
       'Reduo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ENQ ',
       'GRUCST',
       0,
       'S',
       'Suspenso',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7831 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ENT ',
       TO_NUMBER(null),
       'ENT ',
       'Vendas e itens',
       'TV_ENT',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'ENT.CODFIL,ENT.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7832 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ENT ','--','' FROM DUAL
);

/*-- SEQ 7833 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ENT ',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Filial',
       'ENT.CODFIL = DFIL.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ENT ',
       '--',
       40,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo da Srie',
       'Cdigo da Srie',
       'ENT.CODSER = DSER.CODSER(+)',
       'CODSER',
       'T' FROM DUAL
UNION ALL
SELECT 'ENT ',
       '--',
       15,
       3,
       'NUMCODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'ENT ',
       '--',
       30,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       'Nmero do ECF',
       'Nmero do ECF',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'ENT ',
       '--',
       60,
       2,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nmero do Item',
       'Nmero do Item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'ENT ',
       '--',
       50,
       6,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nmero da Nota',
       'Nmero da Nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'ENT ',
       '--',
       70,
       8,
       'QTDENT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Quantidade Vendida',
       'Quantidade Vendida',
       '',
       'QTDENT',
       'F' FROM DUAL
UNION ALL
SELECT 'ENT ',
       '--',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 7834 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ENV ',
       TO_NUMBER(null),
       'ENV ',
       'Envio de Informaes',
       'TT_ENV',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'ENV.CODFIL,END.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7835 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ENV ','--','' FROM DUAL
UNION ALL
SELECT 'ENV ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ENV ','99','Outros' FROM DUAL
);

/*-- SEQ 7836 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 5519,
       'USU ',
       'ENV ',
       'N',
       '01',
       '',
       '',
       'USU.FILUSU = ENV.FILUSU AND
USU.CODUSU = ENV.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 7837 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ENV ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = ENV.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ENV ',
       '01',
       20,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Usurio',
       'Cdigo Usurio',
       'USU2.FILUSU(+) = ENV.FILUSU AND USU2.CODUSU(+) = ENV.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'ENV ',
       '01',
       30,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'ENV ',
       '01',
       40,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'ENV ',
       '01',
       50,
       254,
       'NOMARQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Arquivo',
       'Nome Arquivo',
       '',
       'NOMARQ',
       'F' FROM DUAL
UNION ALL
SELECT 'ENV ',
       '01',
       60,
       254,
       'NOMMAQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Mquina',
       'Nome Mquina',
       '',
       'NOMMAQ',
       'F' FROM DUAL
UNION ALL
SELECT 'ENV ',
       '01',
       70,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 7838 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EPAG',
       TO_NUMBER(null),
       'EPAG',
       'Exp. Parc. a Pagar',
       'TV_EPAG',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7839 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EPAG','--','' FROM DUAL
UNION ALL
SELECT 'EPAG','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EPAG','99','Outros' FROM DUAL
);

/*-- SEQ 7840 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EPAG',
       '--',
       10,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       20,
       10,
       'CODAUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo externo',
       '',
       'CODAUT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       30,
       3,
       'CODBCO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Banco',
       'Cdigo do Banco',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       40,
       3,
       'CODFIL',
       'F',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Cdigo da Filial de Origem',
       'DFIL.CODFIL = COM.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       50,
       20,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Alternativo nico',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       60,
       10,
       'CODPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo externo',
       '',
       'CODPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       70,
       2,
       'CODSER',
       'A',
       'VFIS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'VFIS.CODSER',
       'V',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Cdigo da srie',
       'VFIS.CODSER = COM.CODSER AND VFIS.SUBSER_FIS=COM.SUBSER_FIS',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       80,
       10,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo externo',
       'PAG.FILUSU = USU.FILUSU(+)  AND PAG.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       90,
       5,
       'CONPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Conta Pagto.',
       'Conta para lanamento no OF-CASH',
       '',
       'CONPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       100,
       1,
       'DATIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       110,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       120,
       8,
       'DATPGT',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Pagamento',
       'Data de pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       130,
       7,
       'DATPRX',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Prximo Vencto',
       'Data do Prximo Vencimento',
       '',
       'DATPRX',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       140,
       8,
       'DATVEN',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data de Vencimento',
       'Data de Vencimento',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       150,
       8,
       'DOCPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento Pagamento',
       'Documento Pagamento',
       '',
       'DOCPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       160,
       3,
       'FILDOP',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Cdigo origem da filial.',
       'DOP.CODFIL = DFIL.CODFIL',
       'FILDOP',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       170,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Estado',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       180,
       1,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       190,
       8,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero',
       'Nmero da nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       200,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Parcela',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       210,
       2,
       'RENEGO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Num. renegociao',
       'Nmero da renegociao',
       '',
       'RENEGO',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       220,
       2,
       'RENORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Reneg. Original',
       'Renegociao Original',
       '',
       'RENORI',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       230,
       10,
       'SEQDOP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Documento Pagamento',
       '',
       'SEQDOP',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       240,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN EPAG.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL       
SELECT 'EPAG',
       '--',
       241,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN EPAG.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       250,
       12,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       260,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Sub-Parcela',
       'Sub Parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       270,
       12,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Desconto',
       'Valor Desconto',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       280,
       12,
       'VLRDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Saldo',
       'Saldo',
       '',
       'VLRDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       290,
       12,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Parcela',
       'Valor Parcela',
       '',
       'VLRPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'EPAG',
       '--',
       300,
       12,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Pagamento',
       'Valor Pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 7841 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'EPAG',
       'FLGEST',
       0,
       '1',
       'Programado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPAG',
       'FLGEST',
       0,
       '2',
       'Autorizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPAG',
       'FLGEST',
       0,
       'A',
       'A Pagar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPAG',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPAG',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPAG',
       'FLGEST',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7842 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EPLA',
       TO_NUMBER(null),
       'EPLA',
       'Exportao de Planos',
       'TV_EPLA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'PLA.APEPGT
PLA.DESPGT',
       '' FROM DUAL
);

/*-- SEQ 7843 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EPLA','--','' FROM DUAL
UNION ALL
SELECT 'EPLA','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EPLA','99','Outros' FROM DUAL
);

/*-- SEQ 7844 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EPLA',
       '--',
       10,
       8,
       'ABAMAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Arredondamento (max)',
       'Arredondamento (mximo)',
       '',
       'ABAMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       20,
       8,
       'ABAMIN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Arredondamento (min)',
       'Arredondamento (mnimo)',
       '',
       'ABAMIN',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       30,
       8,
       'ACRDIA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Acrscimo ao Dia',
       'Acrscimo ao Dia',
       '',
       'ACRDIA',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       40,
       10,
       'APEPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'L',
       '',
       '',
       'A',
       'F',
       'Apelido',
       'Apelido do plano de pagamento',
       '',
       'APEPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       50,
       1,
       'APLICA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Aplica Plano Vlido',
       'Indica para quais mdulos o plano  vlido',
       '',
       'APLICA',
       'T' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       751,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN EPLA.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       60,
       2,
       'ATRMAX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Tolera atraso at',
       'Maior atraso tolerado',
       '',
       'ATRMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       70,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       80,
       6,
       'BONPGT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Bnus Pgt. Antec.',
       'Bnus Pgt. Antec.',
       '',
       'BONPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       90,
       2,
       'CARMAX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Carncia Mxima',
       'Nmero de dias de carncia',
       '',
       'CARMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       100,
       1,
       'CARONL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Impr. Carn OnLine?',
       'Impr. Carn OnLine',
       '',
       'CARONL',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       110,
       3,
       'CHRREC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'N Mx. Dias Cheque/',
       'N Mx. Dias Cheque/Parcela',
       '',
       'CHRREC',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       120,
       40,
       'CLASS1',
       'A',
       'DCL1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL1.CLASS1',
       'A',
       '',
       '',
       'A',
       'F',
       'Catergoria',
       'Nome da classe 1',
       'EPLA.CLASS1 = DCL1.CODTAB (+) ',
       'CLASS1',
       'T' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       130,
       40,
       'CLASS2',
       'A',
       'DCL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL2.CLASS2',
       'A',
       '',
       '',
       'A',
       'F',
       'SubCategoria',
       'Nome da classe 2',
       'EPLA.CLASS2=DCL2.CODTAB (+)',
       'CLASS2',
       'T' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       140,
       40,
       'CLASS3',
       'A',
       'DCL3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL3.CLASS3',
       'A',
       '',
       '',
       'A',
       'F',
       'Familia',
       'Nome da classe 3',
       'EPLA.CLASS3=DCL3.CODTAB (+)',
       'CLASS3',
       'T' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       150,
       40,
       'CLASS4',
       'A',
       'DCL4',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL4.CLASS4',
       'A',
       '',
       '',
       'A',
       'F',
       'SubFamilia',
       'Nome da classe 4',
       'EPLA.CLASS4=DCL4.CODTAB (+)',
       'CLASS4',
       'T' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       160,
       1,
       'CODBAI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Instruo de Baixa',
       'Instruo de Baixa',
       '',
       'CODBAI',
       'T' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       170,
       2,
       'CODCOB',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       '',
       'A',
       'F',
       'Cobrana',
       'Cdigo da Cobrana',
       'EPLA.CODCOB=DCOB.CODTAB (+)',
       'CODCOB',
       'T' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       180,
       10,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Codigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       190,
       5,
       'CODMOE',
       'A',
       'DMOE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Moeda',
       'Descrio da moeda',
       'EPLA.CODMOE=DMOE.CODTAB (+)',
       'CODMOE',
       'T' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       200,
       1,
       'CODPRT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Instruo Protesto',
       'Instruo de Protesto',
       '',
       'CODPRT',
       'T' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       210,
       2,
       'COMSOB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Comisso Sobre',
       'Comisso sobre ... (ver tela do plano)',
       '',
       'COMSOB',
       'T' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       220,
       1,
       'DATIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       230,
       8,
       'DATMAX',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Validade (final)',
       'Data de validade (final)',
       '',
       'DATMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       240,
       8,
       'DATMIN',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Validade (inicial)',
       'Data de validade (inicial)',
       '',
       'DATMIN',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       250,
       8,
       'DATPRE',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Pre-Datamento',
       'Data de pre-datamento TEF',
       '',
       'DATPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       260,
       8,
       'DE1IDE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% Desc./Acres. (ide)',
       'Porcentagem Desconto/Acrscimo (ideal)',
       '',
       'DE1IDE',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       270,
       8,
       'DE1MAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% Desc./Acres. (max)',
       'Porcentagem Desconto/Acrscimo (mximo)',
       '',
       'DE1MAX',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       280,
       8,
       'DE1MIN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '% Desc./Acres. (min)',
       'Porcentagem Desconto/Acrscimo (mnimo)',
       '',
       'DE1MIN',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       290,
       8,
       'DESANT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Desc. Antecipado ',
       'Percentual de desconto antecipado',
       '',
       'DESANT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       300,
       6,
       'DESJUR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Desc. sobre Juros ',
       '% Desconto sobre os juros',
       '',
       'DESJUR',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       310,
       35,
       'DESPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'L',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio do plano de pagamento',
       '',
       'DESPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       320,
       1,
       'DESREC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Desconto Antecipado?',
       'Desconto Antecipado Automtico',
       '',
       'DESREC',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       330,
       2,
       'DIAANT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Dias p/ Desc. Antec.',
       'Nmero de dias para desconto antecipado',
       '',
       'DIAANT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       340,
       5,
       'DIATIT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias para Ttulos',
       'Dias para Ttulos',
       '',
       'DIATIT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       350,
       1,
       'ENTVLR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Valor Fixo na Entr.?',
       'Indica se a entrada  percentual ou valor',
       '',
       'ENTVLR',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       360,
       1,
       'FATURA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Formato Imp. Fatura?',
       'Formato de impresso de faturas',
       '',
       'FATURA',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       370,
       3,
       'FILPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial de Origem',
       'Filial onde foi cadastrado o Plano',
       '',
       'FILPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       380,
       1,
       'FLGESP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Parcelas Livres?',
       'Flag para parcelas livres (S/N)',
       '',
       'FLGESP',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       390,
       2,
       'FLGJUR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Juros',
       'Tipo de Juros',
       '',
       'FLGJUR',
       'T' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       400,
       2,
       'FORMUL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Frmula Comisso',
       'Frmula para clculo da comisso',
       '',
       'FORMUL',
       'T' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       930,
       7,
       'INDDES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'ndice Desconto (%)',
       'ndice do Desconto (%)',
       '',
       'INDDES',
       '' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       410,
       1,
       'INTPMU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Multa',
       'Indicador do tipo de multa',
       '',
       'INTPMU',
       'T' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       420,
       6,
       'JURREN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Juros Renegociao',
       'Juros de Renegociao',
       '',
       'JURREN',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       430,
       1,
       'JURTOT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Juros Sobre?',
       'Juros sobre o total da nota (S/N)',
       '',
       'JURTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       440,
       2,
       'MEDMAX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Maior Mdia Atraso',
       'Maior mdia de atrasos tolerada',
       '',
       'MEDMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       920,
       12,
       'MINPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor mnimo parcela',
       'Valor mnimo de parcela',
       '',
       'MINPAR',
       '' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       450,
       5,
       'MOECOR',
       'A',
       'DMOE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Moeda',
       'Descrio da moeda',
       'EPLA.MOECOR = DMOE.CODTAB (+)',
       'MOECOR',
       'T' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       460,
       1,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       470,
       3,
       'NATDEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo no estado',
       'Natureza quando dentro do estado',
       '',
       'NATDEN',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       480,
       3,
       'NATFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo fora do est.',
       'Natureza quando fora do estado',
       '',
       'NATFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       490,
       2,
       'NIVUSU',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Nvel Autorizado',
       'Nvel do usurio autorizado a operar este plano',
       '',
       'NIVUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       500,
       2,
       'NROMES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero de Meses',
       'Nmero de meses para refaturamento (quando Contrado)',
       '',
       'NROMES',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       510,
       2,
       'PARIDE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nm Parcelas (ide)',
       'Nmero de parcelas (ideal)',
       '',
       'PARIDE',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       520,
       2,
       'PARMAX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nm. Parcelas (max)',
       'Nmero de parcelas (mximo)',
       '',
       'PARMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       530,
       2,
       'PARMIN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nm. Parcelas (min)',
       'Nmero de parcelas (mnimo)',
       '',
       'PARMIN',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       540,
       2,
       'PARVEN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero de Parcelas',
       'Nmero de parcelas recebidas na venda (Caixa)',
       '',
       'PARVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       550,
       8,
       'PERCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Comisso Parcelas',
       'Percentual de comisso no geral',
       '',
       'PERCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       560,
       8,
       'PERENT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Comisso Entrada',
       'Percentual de comisso na entrada',
       '',
       'PERENT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       570,
       2,
       'PERIOD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Intervalo Parcelas',
       'Intervalo',
       '',
       'PERIOD',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       580,
       2,
       'PORDEM',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       '',
       'A',
       'F',
       'Portador das Parcela',
       'Portador das demais parcelas',
       'EPLA.PORDEM=DCOB.CODTAB (+)',
       'PORDEM',
       'T' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       590,
       2,
       'PORENT',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       '',
       'A',
       'F',
       'Portador da Entrada',
       'Portador da entrada',
       'EPLA.PORENT=DCOB.CODTAB (+)',
       'PORENT',
       'T' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       600,
       2,
       'PRAIDE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '1 Recebimento (ide)',
       'Dias de prazo para o 1 recebimento (ideal)',
       '',
       'PRAIDE',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       610,
       2,
       'PRAMAX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '1 Recebimento (max)',
       'Dias de prazo para o 1 recebimento (mximo)',
       '',
       'PRAMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       620,
       2,
       'PRAMIN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '1 Recebimento (min)',
       'Dias de prazo para o 1 recebimento (mnimo)',
       '',
       'PRAMIN',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       630,
       1,
       'PREINF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Preo Informado?',
       'Permite preo informado',
       '',
       'PREINF',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       640,
       2,
       'PRIIDE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% 1 Recto. (ideal)',
       'Porcentagem no 1 recebimento (ideal)',
       '',
       'PRIIDE',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       650,
       2,
       'PRIMAX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% 1 Recto. (max)',
       'Porcentagem no 1 recebimento (mximo)',
       '',
       'PRIMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       660,
       2,
       'PRIMIN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% 1 Recto (min)',
       'Porcentagem no 1 recebimento (mnimo)',
       '',
       'PRIMIN',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       670,
       1,
       'PROPOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Proporo?',
       'Proporo',
       '',
       'PROPOR',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       680,
       2,
       'PRZBAI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Prazo dias de Baixa',
       'Prazo dias de Baixa',
       '',
       'PRZBAI',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       690,
       2,
       'PRZPRT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Prazo de Protesto',
       'Prazo dias de Protesto',
       '',
       'PRZPRT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       700,
       2,
       'PZOIDE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Prazo Mdio (ide)',
       'Prazo mdio (ideal)',
       '',
       'PZOIDE',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       710,
       2,
       'PZOMAX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Prazo Mdio (max)',
       'Prazo mdio (mximo)',
       '',
       'PZOMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       720,
       2,
       'PZOMIN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Prazo Mdio (min)',
       'Prazo Mdio (min)',
       '',
       'PZOMIN',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       730,
       1,
       'RENEGO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Renegociao?',
       'Renegociao',
       '',
       'RENEGO',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       740,
       1,
       'RENSOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Calculado Sobre',
       'Renogociao Calculada Sobre',
       '',
       'RENSOB',
       'T' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       750,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN EPLA.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       910,
       1,
       'SOBNEG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Sob negociao',
       'Plano visvel somente sob negociao',
       '',
       'SOBNEG',
       '' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       760,
       12,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       '',
       '',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       770,
       1,
       'TIPCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Cobrana',
       'Tipo Cobrana',
       '',
       'TIPCOB',
       'T' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       780,
       2,
       'TIPPLA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Plano',
       'Tipo de plano (Venda/Contrado)',
       '',
       'TIPPLA',
       'T' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       790,
       2,
       'TOTLIM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Total Limitao',
       'Total de itens da limitao de planos a produtos',
       '',
       'TOTLIM',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       800,
       1,
       'USACAM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Cmbio?',
       'Usa Cmbio(Moeda Estrangeira)?',
       '',
       'USACAM',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       810,
       1,
       'USACHE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Cheque?',
       'Usa Cheque?',
       '',
       'USACHE',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       820,
       1,
       'USACPP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Carto Prprio Parc?',
       'Carto Prprio Parcelado?',
       '',
       'USACPP',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       830,
       1,
       'USACRE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Carto Crdito?',
       'Usa Carto de Crdito?',
       '',
       'USACRE',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       840,
       1,
       'USAC_C',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Conta Corrente?',
       'Usa Conta Corrente?',
       '',
       'USAC_C',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       850,
       1,
       'USADIN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Dinheiro?',
       'Usa Dinheiro(Moeda Nacional)?',
       '',
       'USADIN',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       860,
       1,
       'USAOUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Outros?',
       'Usa Outros?',
       '',
       'USAOUT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       870,
       1,
       'USATEF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa T.E.F.?',
       'Usa T.E.F.?',
       '',
       'USATEF',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       880,
       8,
       'VLRMAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Compra (max)',
       'Valor da compra (mximo)',
       '',
       'VLRMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       890,
       8,
       'VLRMIN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Compra (min)',
       'Valor da compra (mnimo)',
       '',
       'VLRMIN',
       'F' FROM DUAL
UNION ALL
SELECT 'EPLA',
       '--',
       900,
       12,
       'VLTXMU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Total x Multa',
       'Valor Total x Multa',
       '',
       'VLTXMU',
       'F' FROM DUAL
);

/*-- SEQ 7845 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'EPLA',
       'APLICA',
       0,
       ' ',
       'Qualquer',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'APLICA',
       1,
       ' ',
       'Vendas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'APLICA',
       2,
       ' ',
       'Ordens de Servio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'APLICA',
       3,
       ' ',
       'Ttulo Avulso a Receber',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'APLICA',
       4,
       ' ',
       'Faturamento Parcelado ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'CODBAI',
       0,
       ' ',
       'Sem Instruo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'CODBAI',
       1,
       ' ',
       'Baixar (Dias a Partir do Venc)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'CODBAI',
       2,
       ' ',
       'No Baixar / No Devolver',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'CODPRT',
       0,
       ' ',
       'Sem Instrues',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'CODPRT',
       1,
       ' ',
       'Protestar (Dias Corridos)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'CODPRT',
       2,
       ' ',
       'Protestar (Dias teis)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'CODPRT',
       3,
       ' ',
       'No Protestar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'COMSOB',
       7,
       ' ',
       'Comisso sobre markup',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'COMSOB',
       4,
       ' ',
       'A receber no Recebimento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'COMSOB',
       0,
       ' ',
       'Lquido ao Vender',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'COMSOB',
       1,
       ' ',
       'Bruto ao Vender',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'COMSOB',
       2,
       ' ',
       'A receber no Vencimento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'COMSOB',
       3,
       ' ',
       'Recebido no Recebimento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'COMSOB',
       5,
       ' ',
       'Recebido na compensao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'COMSOB',
       6,
       ' ',
       'A receber na compensao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'FLGJUR',
       1,
       ' ',
       'Composto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'FLGJUR',
       0,
       ' ',
       'Simples',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'FORMUL',
       3,
       ' ',
       '%Vend.+%Plano',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'FORMUL',
       6,
       ' ',
       '%Vend.+%Plano+%Prod.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'FORMUL',
       4,
       ' ',
       '%Vend.+%Prod.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'FORMUL',
       5,
       ' ',
       '%Plano+%Prod.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'FORMUL',
       0,
       ' ',
       '%Vendedor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'FORMUL',
       1,
       ' ',
       '%Plano',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'FORMUL',
       2,
       ' ',
       '%Produto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'INTPMU',
       0,
       '#',
       'Percentual Corrigido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'INTPMU',
       0,
       '$',
       'Valor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'INTPMU',
       0,
       '%',
       'Percentual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'INTPMU',
       0,
       '@',
       'Valor Corrigido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'NIVUSU',
       0,
       ' ',
       'Administrador',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'NIVUSU',
       1,
       ' ',
       'Operador',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'NIVUSU',
       2,
       ' ',
       'Vendedor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'NIVUSU',
       3,
       ' ',
       'Guia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'RENSOB',
       0,
       'J',
       'Valor com Juros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'RENSOB',
       0,
       'O',
       'Valor Original',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'TIPCOB',
       0,
       'B',
       'Bancria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'TIPCOB',
       0,
       'P',
       'Padro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'TIPPLA',
       0,
       ' ',
       'Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPLA',
       'TIPPLA',
       1,
       ' ',
       'Contrato',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7846 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EPRE',
       TO_NUMBER(null),
       'EPRE',
       'Exportao de Preos',
       'TV_EPRE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7847 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EPRE','--','' FROM DUAL
UNION ALL
SELECT 'EPRE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EPRE','99','Outros' FROM DUAL
);

/*-- SEQ 7848 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EPRE',
       '--',
       10,
       20,
       'CATEG1',
       'A',
       'DCT1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo da 1 Categ.',
       'Nome da categoria 1',
       'EPRE.CATEG1 = DCT1.CODTAB (+)',
       'CATEG1',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRE',
       '--',
       20,
       20,
       'CATEG2',
       'A',
       'DCT2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo da 2 Categ.',
       'Nome da categoria 2',
       'EPRE.CATEG2 = DCT2.CODTAB (+)',
       'CATEG2',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRE',
       '--',
       30,
       20,
       'CATEG3',
       'A',
       'DCT3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo da 3 Categ.',
       'Nome da categoria 3',
       'EPRE.CATEG3 = DCT3.CODTAB (+)',
       'CATEG3',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRE',
       '--',
       40,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRE',
       '--',
       50,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Filial de Origem da Tabela',
       'DFIL.CODFIL = EPRE.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRE',
       '--',
       60,
       1,
       'DATIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       '',
       '',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRE',
       '--',
       100,
       6,
       'DESIDE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Desconto Ideal',
       '% Desconto Ideal',
       '',
       'DESIDE',
       '' FROM DUAL
UNION ALL
SELECT 'EPRE',
       '--',
       110,
       30,
       'DESPRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio Tabela de Preo',
       '',
       'DESPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRE',
       '--',
       70,
       1,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRE',
       '--',
       80,
       8,
       'PRECOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Preo de Venda',
       'Preo de Venda',
       '',
       'PRECOV',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRE',
       '--',
       120,
       20,
       'PRE_CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd.Ext Tabela Preo',
       'Cdigo Externo da Tabela de Preo',
       '',
       'PRE_CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRE',
       '--',
       90,
       12,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       '',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRE',
       '--',
       130,
       7,
       'ULTREA',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'ltimo Reajuste',
       'Data do ltimo reajuste',
       '',
       'ULTREA',
       'F' FROM DUAL
);

/*-- SEQ 7849 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EPRO',
       TO_NUMBER(null),
       'EPRO',
       'Exportao Produto',
       'TV_EPRO',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7850 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EPRO','--','' FROM DUAL
UNION ALL
SELECT 'EPRO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EPRO','99','Outros' FROM DUAL
);

/*-- SEQ 7851 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EPRO',
       '--',
       10,
       1,
       'ARRTRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Arrentonda ou Trunca',
       'Arrentonda ou Trunca?',
       '',
       'ARRTRU',
       'T' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       20,
       5,
       'ATIVO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ativo? ',
       'Ativo(T) se SIGNAT >=0 e Desativo(F) se SIGNAT < 0',
       '',
       'ATIVO',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       30,
       2,
       'BRINDE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Brinde',
       'Brinde',
       '',
       'BRINDE',
       'T' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       40,
       2,
       'CALSUB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Produto Substituio',
       'Produto com Substituio',
       '',
       'CALSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       50,
       1,
       'CAL_CM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Data Clculo Custo M',
       'Data Cculo Custo Mdio',
       '',
       'CAL_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       60,
       40,
       'CLASS1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Catergoria',
       'Nome da classe 1',
       '',
       'CLASS1',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       70,
       40,
       'CLASS2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'SubCategoria',
       'Nome da classe 2',
       '',
       'CLASS2',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       80,
       40,
       'CLASS3',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Familia',
       'Nome da classe 3',
       '',
       'CLASS3',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       90,
       40,
       'CLASS4',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'SubFamilia',
       'Nome da classe 4',
       '',
       'CLASS4',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       100,
       2,
       'CLSXYZ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'XYZ',
       'Classe XYZ',
       '',
       'CLSXYZ',
       'T' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       1110,
       7,
       'CODCES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'CEST',
       'CEST',
       '',
       'CODCES',
       '' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       110,
       5,
       'CODCTR',
       'F',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'I',
       '',
       '',
       'N',
       'F',
       'Unidade de Negcios',
       'Cdigo da Tabela',
       'DCTR.CODTAB = EPRO.CODCTR',
       'CODCTR',
       'T' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       120,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       130,
       20,
       'CODFAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Alternativo nico',
       '',
       'CODFAB',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       140,
       20,
       'CODFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Fiscal',
       'Cdigo Fiscal',
       '',
       'CODFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       150,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cd.Interno',
       'Cdigo interno do produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       1100,
       8,
       'CODNCM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo NCM',
       'Cdigo NCM',
       '',
       'CODNCM',
       '' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       160,
       20,
       'CODTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Tributrio',
       'Cdigo Tributrio',
       '',
       'CODTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       170,
       10,
       'CONAPL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Unidade Embalagem',
       'Converso para unidade de Embalagem',
       '',
       'CONAPL',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       180,
       1,
       'CONTRA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Produto  contrato?',
       'Determina se produto  do tipo contrato',
       '',
       'CONTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       190,
       1,
       'CONTRO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Controla Produtos?',
       'Produtos Controlados',
       '',
       'CONTRO',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       200,
       12,
       'CUSFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Custo Frete',
       'Custo Frete',
       '',
       'CUSFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       210,
       8,
       'CUSREP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Custo de Reposio',
       'Custo de reposio deste produto no estoque',
       '',
       'CUSREP',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       220,
       8,
       'DATCAD',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Incluso em',
       'Data do Cadastro',
       '',
       'DATCAD',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       230,
       8,
       'DATCOM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Ultima Compra',
       'Data da compra',
       '',
       'DATCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       240,
       1,
       'DATIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       250,
       1,
       'DECIMA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Aceita Decimais?',
       'Aceita casas decimais nas transaes (S/N)',
       '',
       'DECIMA',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       260,
       40,
       'DEPART',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Departamento',
       'Departamento do Produto',
       '',
       'DEPART',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       270,
       20,
       'DESCFP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio do grupo de CFOPs.',
       '',
       'DESCFP',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       280,
       12,
       'DESCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Desconto',
       'Desconto',
       '',
       'DESCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       290,
       30,
       'DESECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Desc. p/ ECF',
       'Descrio resumida para ECF',
       '',
       'DESECF',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       300,
       20,
       'DESGRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'DESGRA',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       310,
       8,
       'DESIDE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Desconto Sugerido',
       'Desconto Sugerido',
       '',
       'DESIDE',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       320,
       20,
       'DESINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Desc. Inatividade',
       'Descrio Inatividade',
       '',
       'DESINA',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       330,
       30,
       'DESMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Marca',
       'Descrio da Marca',
       '',
       'DESMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       340,
       30,
       'DESMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio do material',
       '',
       'DESMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       350,
       8,
       'DESMAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Desconto Mximo',
       'Desconto Mximo',
       '',
       'DESMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       1140,
       1,
       'EMBALAGEM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Embalagem?',
       'Embalagem?',
       '',
       'EMBALAGEM',
       '' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       360,
       1,
       'ENTREG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Entrega?',
       'Entrega?',
       '',
       'ENTREG',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       370,
       30,
       'ESPMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Especificao',
       'Especificao do material',
       '',
       'ESPMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       380,
       2,
       'ESTADO',
       'A',
       'DEST',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEST.ESTADO',
       'V',
       '',
       '',
       'A',
       'F',
       'UF',
       'Unidade Federativa',
       'DEST.ESTADO = EPRO.ESTADO',
       'ESTADO',
       'T' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       390,
       20,
       'ETIQUE',
       'A',
       'DETI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DETI.DESETI',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio da etiqueta',
       'EPRO.ETIQUE=DETI.CODTAB (+)',
       'ETIQUE',
       'T' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       400,
       3,
       'FILMAT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Filial onde foi cadastrado o material',
       'EPRO.FILMAT = DFIL.CODFIL (+)',
       'FILMAT',
       'T' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       410,
       1,
       'FORLIN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Fora de Linha?',
       'Fora de Linha',
       '',
       'FORLIN',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       1150,
       120,
       'GRA_DESGRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio da Grade',
       'Descrio da Grade',
       '',
       'GRA_DESGRA',
       '' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       420,
       12,
       'ICMCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'ICMS Compra',
       'ICMS Compra',
       '',
       'ICMCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       430,
       1,
       'ICMFED',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'ICMS Subst. no Pas?',
       'ICMS Substitudo em todo o pas?',
       '',
       'ICMFED',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       440,
       12,
       'ICMFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% ICMS Frete',
       '% ICMS Frete',
       '',
       'ICMFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       450,
       1,
       'IIPTPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Produo Prp ou Ter',
       'Produo Prpria ou de Terceiro?',
       '',
       'IIPTPR',
       'T' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       460,
       1,
       'INSAGR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Insumo~Agropecurio?',
       'Tem insumo agropecurio Deduzido?',
       '',
       'INSAGR',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       470,
       12,
       'IPICOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'IPI Compra',
       'IPI Compra',
       '',
       'IPICOM',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       480,
       10,
       'ITEDIV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Nome do item',
       '',
       'ITEDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       490,
       10,
       'ITESUB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Item',
       'Nome do item',
       '',
       'ITESUB',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       500,
       10,
       'LOCALI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Localizao ',
       'Localizao',
       '',
       'LOCALI',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       510,
       5,
       'LUCSUB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Lucro~Substitudo',
       'Lucro Substituido',
       '',
       'LUCSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       520,
       12,
       'MARKUP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Markup',
       'Markup',
       '',
       'MARKUP',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       1130,
       3,
       'MAXPAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Mximo de parcelas',
       'Nmero mximo de parcelas na venda',
       '',
       'MAXPAR',
       '' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       530,
       8,
       'MINQTD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Estoque Mnimo',
       'Estoque mnimo',
       '',
       'MINQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       540,
       1,
       'MONTAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo~Montagem',
       'Tipo Montagem',
       '',
       'MONTAR',
       'T' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       550,
       1,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       1120,
       14,
       'MVAC04',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% MVA para Comp. 4%',
       '% MVA para Compra 4% (Margem de Valor Agregado ou Lucro Substitudo)',
       '',
       'MVAC04',
       '' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       560,
       14,
       'MVAC07',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '% MVA para Compra 7%',
       '% MVA para Compra 7% (Margem de Valor Agregado ou Lucro Substitudo)',
       '',
       'MVAC07',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       570,
       14,
       'MVAC12',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '% MVA para Comp. 12%',
       '% MVA para Compra 12% (Margem de Valor Agregado ou Lucro Substitudo)',
       '',
       'MVAC12',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       580,
       14,
       'MVAVEN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '% MVA para Venda',
       '% MVA para Venda (Margem de Valor Agregado ou Lucro Substitudo)',
       '',
       'MVAVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       590,
       20,
       'NOMDIV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome da diviso',
       'Descrio da grade',
       '',
       'NOMDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       600,
       255,
       'NOMIMG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Imagem',
       'Imagem do produto',
       '',
       'NOMIMG',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       610,
       20,
       'NOMSUB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome',
       'Nome',
       '',
       'NOMSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       620,
       1,
       'NUMEXT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Nm. Externo?',
       'Nmero externo na Ordem de Servio',
       '',
       'NUMEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       630,
       2,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nm. Itens Kits',
       'Nmero de itens de um kit',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       640,
       10,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(EPRO.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       650,
       4000,
       'OBSGRA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSGRA',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       660,
       8,
       'PERCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Comissao',
       'Percentual de Comisso',
       '',
       'PERCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       670,
       8,
       'PERLUC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% de Lucro',
       '% de Lucro',
       '',
       'PERLUC',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       680,
       5,
       'PERSRV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Servio R.E. 80/20',
       '% Servio Regime Especial 80/20',
       '',
       'PERSRV',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       690,
       14,
       'PESBRU',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Peso Bruto',
       'Peso bruto',
       '',
       'PESBRU',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       700,
       14,
       'PESLIQ',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Peso Lquido',
       'Peso lquido',
       '',
       'PESLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       710,
       8,
       'PRECOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Preo de Compra',
       'Preo de compra',
       '',
       'PRECOM',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       720,
       12,
       'PRECOV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRECOV',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       730,
       1,
       'PREPSI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Preo Psicolgico?',
       'Preo Psicolgico',
       '',
       'PREPSI',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       740,
       1,
       'PROMOC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Promocional?',
       'Indica se produto  promocional',
       '',
       'PROMOC',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       750,
       8,
       'PTOQTD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Ponto de Pedido',
       'Ponto de pedido',
       '',
       'PTOQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       760,
       12,
       'QTDCOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade Compra',
       'Quantidade Compra',
       '',
       'QTDCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       770,
       10,
       'QTDEMB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Contedo Embalagem',
       'Contedo da Embalagem',
       '',
       'QTDEMB',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       780,
       8,
       'QTDREP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Ideal de Reposio',
       'Quantidade ideal de reposiao',
       '',
       'QTDREP',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       790,
       8,
       'REDALI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Alquota',
       'Tabela de ICMS para Base Reduzida',
       '',
       'REDALI',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       800,
       6,
       'REDCON',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'ICMS Consum. Final',
       'Reduo ICMS para consumidor final',
       '',
       'REDCON',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       810,
       8,
       'REDESP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Alquota',
       'Tabela de ICMS para Clientes Especiais',
       '',
       'REDESP',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       820,
       6,
       'REDTRA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Reduo de Entrada ',
       'Reduo de Entrada Transferncia',
       '',
       'REDTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       830,
       8,
       'REDUC1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Alquota',
       'Tabela de ICMS para Estados com 12 %',
       '',
       'REDUC1',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       840,
       8,
       'REDUC2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Alquota',
       'Tabela de ICMS para Estados com 7 %',
       '',
       'REDUC2',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       850,
       8,
       'REDUME',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Alquota',
       'Tabela de ICMS para Micro Empresas',
       '',
       'REDUME',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       860,
       15,
       'REFBAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. Bsica',
       'Referncia Bsica do Produto',
       '',
       'REFBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       870,
       20,
       'REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Referncia',
       'Referncia do produto',
       '',
       'REFPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       880,
       1,
       'REGESP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Regime Tributrio',
       'Regime Tributrio',
       '',
       'REGESP',
       'T' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       890,
       8,
       'RESICM',
       'F',
       'DICM',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TO_CHAR(DICM.RESICM)',
       'I',
       '',
       'T',
       '',
       'F',
       'Alquota',
       'Impostos',
       'DICM.CODTAB(+) = EPRO.RESICM',
       'RESICM',
       'T' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       900,
       8,
       'RESIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Alquota',
       'Alquota do IPI',
       '',
       'RESIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       910,
       8,
       'RESIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Alquota',
       'Alquota do IRRF',
       '',
       'RESIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       920,
       1,
       'RETCOF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Reteno de COFINS?',
       'Permite Reteno de COFINS?',
       '',
       'RETCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       930,
       20,
       'SAZONA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio da Sazonalidade',
       '',
       'SAZONA',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       940,
       12,
       'SEGFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Seguro Frete',
       'Seguro Frete',
       '',
       'SEGFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       950,
       12,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       960,
       12,
       'SUBCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Sub Diviso Compra',
       'Subdiviso Compra',
       '',
       'SUBCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       970,
       1,
       'SUBFED',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Substitudo Federal',
       'Substitudo Federal',
       '',
       'SUBFED',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       980,
       1,
       'SUBTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Subst~Tributria',
       'Substituio Tributria',
       '',
       'SUBTRI',
       'T' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       990,
       12,
       'TAXCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Taxa Compra',
       'Taxa Compra',
       '',
       'TAXCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       1000,
       2,
       'TEMREP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Tempo de Reposio',
       'Tempo de Reposio',
       '',
       'TEMREP',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       1010,
       2,
       'TIPPRO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Produto',
       'Tipo de Produto',
       '',
       'TIPPRO',
       'T' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       1020,
       1,
       'TIPVAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       '',
       'F',
       'Expressa em',
       'Expressa em',
       '',
       'TIPVAL',
       'T' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       1030,
       2,
       'UNIAPL',
       'A',
       'DMED',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMED.UNIMED',
       'A',
       '',
       '',
       'A',
       'F',
       'Unidade de medida',
       'Unidade de Medida',
       'DMED.CODTAB(+) = EPRO.UNIAPL',
       'UNIAPL',
       'T' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       1040,
       2,
       'UNIDAD',
       'A',
       'DMED',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMED.',
       'A',
       '',
       '',
       'A',
       'F',
       'Unidade de medida',
       'Unidade de Medida',
       'DMED. = EPRO.UNIDAD',
       'UNIDAD',
       'T' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       1050,
       2,
       'UNIEMB',
       'A',
       'DMED',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMED.',
       'A',
       '',
       '',
       'A',
       'F',
       'Unidade de medida',
       'Unidade de Medida',
       'DMED. = EPRO.UNIEMB',
       'UNIEMB',
       'T' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       1060,
       2,
       'UNIFOR',
       'A',
       'DMED',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMED.',
       'A',
       '',
       '',
       'A',
       'F',
       'Unidade de medida',
       'Unidade de Medida',
       'DMED. = EPRO.UNIFOR',
       'UNIFOR',
       'T' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       1070,
       12,
       'VALCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Fator Converso',
       'Fator Converso',
       '',
       'VALCON',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       1080,
       5,
       'VALIDA',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Garantia/Validade',
       'Garantia/Validade',
       '',
       'VALIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'EPRO',
       '--',
       1090,
       1,
       'VOLUNI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'N',
       'F',
       'Volume nico?',
       'Volume nico?',
       '',
       'VOLUNI',
       'F' FROM DUAL
);

/*-- SEQ 7852 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'EPRO',
       'ARRTRU',
       0,
       'A',
       'Arredondamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'ARRTRU',
       0,
       'T',
       'Truncamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'BRINDE',
       1,
       ' ',
       'Pode ser Brinde',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'BRINDE',
       0,
       ' ',
       'Nao  Brinde',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'BRINDE',
       2,
       ' ',
       ' Brinde',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'CLSXYZ',
       2,
       ' ',
       'Z',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'CLSXYZ',
       1,
       ' ',
       'Y',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'CLSXYZ',
       0,
       ' ',
       'X',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'IIPTPR',
       0,
       'P',
       'p/ merc manufat pelo prop cont',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'IIPTPR',
       0,
       'T',
       'p/ merc manufat de terceiros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'MONTAR',
       0,
       'F',
       'Sem Montagem',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'MONTAR',
       0,
       'I',
       'Montagem Interna',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'MONTAR',
       0,
       'T',
       'Montagem na Entrega',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'REGESP',
       0,
       ' ',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'REGESP',
       1,
       ' ',
       'Especial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'SUBTRI',
       0,
       '0',
       'Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'SUBTRI',
       0,
       '1',
       'Nao Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'SUBTRI',
       0,
       '2',
       'Isento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'TIPPRO',
       2,
       ' ',
       'Terceirizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'TIPPRO',
       0,
       ' ',
       'Material',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'TIPPRO',
       1,
       ' ',
       'Servio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'TIPVAL',
       0,
       ' ',
       'No Controla',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'TIPVAL',
       1,
       ' ',
       'Dias',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EPRO',
       'TIPVAL',
       2,
       ' ',
       'Meses',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7853 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EQP ',
       TO_NUMBER(null),
       'EQP ',
       'Equipamentos',
       'TT_EQP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'EQP.CODFIL, EQP.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7854 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EQP ','--','' FROM DUAL
UNION ALL
SELECT 'EQP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EQP ','02','Recursividade' FROM DUAL
UNION ALL
SELECT 'EQP ','99','Outros' FROM DUAL
);

/*-- SEQ 7855 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21468,
       'CLI ',
       'EQP ',
       '1',
       'N',
       '',
       '',
       'EQP.FILCLI = CLI.FILCLI AND
EQP.CODCLI = CLI.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21469,
       'CCT ',
       'EQP ',
       '1',
       'N',
       '',
       '',
       'EQP.FILCTT = CCT.FILCTT AND
EQP.CODCTT = CCT.CODCTT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21470,
       'EENT',
       'EQP ',
       '1',
       'N',
       '',
       '',
       'EQP.FILCLI = EENT.FILCLI AND
EQP.CODCLI = EENT.CODCLI AND
EQP.FILEND = EENT.CODFIL AND
EQP.NUMEND = EENT.NUMEND',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21471,
       'CMP ',
       'EQP ',
       '1',
       'N',
       '',
       '',
       'EQP.FILEQP = CMP.CODFIL AND
EQP.SEQEQP = CMP.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21472,
       'TEQ ',
       'EQP ',
       '1',
       'N',
       '',
       '',
       'EQP.FILTEQ = TEQ.CODFIL AND
EQP.CODTEQ = TEQ.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 7856 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EQP ',
       '99',
       70,
       6,
       'CODCLI',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 'EQP ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Equipamento',
       'Filial do Equipamento',
       'DFIL.CODFIL = EQP.CODFIL',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'EQP ',
       '99',
       140,
       8,
       'DATAQU',
       'D',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data da Aquisio',
       'Data da Aquisio',
       '',
       'DATAQU',
       '' FROM DUAL
UNION ALL
SELECT 'EQP ',
       '99',
       110,
       8,
       'DATLIM',
       'D',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Limite',
       'Data Limite',
       '',
       'DATLIM',
       '' FROM DUAL
UNION ALL
SELECT 'EQP ',
       '99',
       120,
       20,
       'DESEQP',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Desc. do Equipamento',
       'Descrio do Equipamento/Modelo',
       '',
       'DESEQP',
       '' FROM DUAL
UNION ALL
SELECT 'EQP ',
       '99',
       170,
       20,
       'DESMAR',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio da Marca',
       'Descrio da Marca (Livre)',
       '',
       'DESMAR',
       '' FROM DUAL
UNION ALL
SELECT 'EQP ',
       '99',
       60,
       3,
       'FILCLI',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'I',
       '',
       '',
       '0',
       '',
       'Filial do Cliente',
       'Filial do Cliente',
       'DFIL.CODFIL = EQP.FILCLI',
       'FILCLI',
       '' FROM DUAL
UNION ALL
SELECT 'EQP ',
       '99',
       150,
       3,
       'FILCTT',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'I',
       '',
       '',
       '0',
       '',
       'Filial do Contrato',
       'Filial do Contrato',
       'DFIL.CODFIL = EQP.FILCTT',
       'FILCTT',
       '' FROM DUAL
UNION ALL
SELECT 'EQP ',
       '99',
       80,
       3,
       'FILEND',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'I',
       '',
       '',
       '0',
       '',
       'Filial do Endereo',
       'Filial do Endereo',
       'DFIL.CODFIL = EQP.FILEND',
       'FILEND',
       '' FROM DUAL
UNION ALL
SELECT 'EQP ',
       '02',
       170,
       3,
       'FILEQP',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'I',
       '',
       '',
       '0',
       '',
       'Filial Equipamento',
       'Filial do Equipamento',
       'DFIL.CODFIL = EQP.FILEQP',
       'FILEQP',
       '' FROM DUAL
UNION ALL
SELECT 'EQP ',
       '99',
       30,
       3,
       'FILTEQ',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'I',
       '',
       '',
       '0',
       '',
       'Filial Tipo de Equip',
       'Filial do Tipo de Equipamento',
       'DFIL.CODFIL = EQP.FILTEQ',
       'FILTEQ',
       '' FROM DUAL
UNION ALL
SELECT 'EQP ',
       '99',
       90,
       4,
       'NUMEND',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nmero do Endereo',
       'Nmero do Endereo',
       '',
       'NUMEND',
       '' FROM DUAL
UNION ALL
SELECT 'EQP ',
       '99',
       100,
       30,
       'NUMSER',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nmero de Srie',
       'Nmero de Srie',
       '',
       'NUMSER',
       '' FROM DUAL
UNION ALL
SELECT 'EQP ',
       '99',
       130,
       4000,
       'OBSERV',
       '4',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(EQP.OBSERV)',
       '' FROM DUAL
UNION ALL
SELECT 'EQP ',
       '99',
       160,
       10,
       'SEQCTT',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo do Contrato',
       'Cdigo do Contrato',
       '',
       'SEQCTT',
       '' FROM DUAL
UNION ALL
SELECT 'EQP ',
       '02',
       180,
       10,
       'SEQEQP',
       'A',
       'EQP ',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'EQP.',
       'I',
       '',
       '',
       '9',
       '',
       'Seq. do Equipamento',
       'Sequncia do Equipamento',
       'EQP. = EQP.SEQEQP',
       'SEQEQP',
       '' FROM DUAL
UNION ALL
SELECT 'EQP ',
       '99',
       40,
       10,
       'SEQTEQ',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq. do Tipo Equip',
       'Sequncia do Tipo de Equipamento',
       '',
       'SEQTEQ',
       '' FROM DUAL
UNION ALL
SELECT 'EQP ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       '',
       'Seq. do Equipamento',
       'Sequncia do Equipamento',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'EQP ',
       '99',
       51,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN EQP.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'EQP ',
       '99',
       50,
       1,
       'SIGNAT',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN EQP.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
);

/*-- SEQ 7857 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ERCF',
       TO_NUMBER(null),
       'ERCF',
       'Exporta Leitura Z',
       'TE_RECF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7858 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ERCF','--','' FROM DUAL
UNION ALL
SELECT 'ERCF','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ERCF','99','Outros' FROM DUAL
);

/*-- SEQ 7859 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ERCF',
       '--',
       10,
       4,
       'CNT_RZ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Contador~Reduo Z',
       'Contador Reduo Z',
       '',
       'CNT_RZ',
       'F' FROM DUAL
UNION ALL
SELECT 'ERCF',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = ERCF.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ERCF',
       '--',
       30,
       6,
       'CUPFIM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'CF Final',
       'CF Final',
       '',
       'CUPFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'ERCF',
       '--',
       40,
       6,
       'CUPINI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'CF Inicial',
       'CF Inicial',
       '',
       'CUPINI',
       'F' FROM DUAL
UNION ALL
SELECT 'ERCF',
       '--',
       50,
       7,
       'DATFEC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Fechamento',
       'Data Fechamento',
       '',
       'DATFEC',
       'F' FROM DUAL
UNION ALL
SELECT 'ERCF',
       '--',
       60,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da~Reduo Z',
       'Data da Reduo Z',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'ERCF',
       '--',
       70,
       1,
       'DIAFEC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Dia~Fechado?',
       'Dia Fechado',
       '',
       'DIAFEC',
       'F' FROM DUAL
UNION ALL
SELECT 'ERCF',
       '--',
       80,
       16,
       'GT_FIM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Grande~Total Final',
       'Grande~Total Final',
       '',
       'GT_FIM',
       'F' FROM DUAL
UNION ALL
SELECT 'ERCF',
       '--',
       90,
       16,
       'GT_INI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Grande~Total Inicial',
       'Grande Total Inicial',
       '',
       'GT_INI',
       'F' FROM DUAL
UNION ALL
SELECT 'ERCF',
       '--',
       100,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero~ECF',
       'Nmero ECF',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'ERCF',
       '--',
       110,
       6,
       'QTD_NF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde NF~Emitidas',
       'Qtde NF Emitidas',
       '',
       'QTD_NF',
       'F' FROM DUAL
);

/*-- SEQ 7860 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ERCF',
       'DIAFEC',
       0,
       'F',
       'Fechado Forado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ERCF',
       'DIAFEC',
       0,
       'S',
       'Sim',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7861 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EREC',
       TO_NUMBER(null),
       'EREC',
       'Exp Parc. a Receber ',
       'TV_EREC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7862 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EREC','--','' FROM DUAL
UNION ALL
SELECT 'EREC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EREC','99','Outros' FROM DUAL
);

/*-- SEQ 7863 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EREC',
       '--',
       10,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       20,
       5,
       'CARTAO',
       'S',
       'DCAR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCAR.DESOUT',
       'V',
       '',
       '',
       'A',
       'F',
       'Carto',
       'Carto de Crdito',
       'DCAR.CODTAB(+) = REC.CARTAO',
       'CARTAO',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       30,
       5,
       'CNT_RO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cont. Reinicio Oper.',
       'Contador de Reinicio de Operao',
       '',
       'CNT_RO',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       40,
       5,
       'CODAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Agncia',
       'Cdigo da agncia',
       '',
       'CODAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       50,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Banco',
       'Cdigo do banco',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       60,
       15,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Alternativo',
       'Cdigo Alternativo nico',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       70,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'REC.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       80,
       5,
       'CODMOE',
       'A',
       'DMOE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Moeda',
       'Descrio da moeda',
       'REC.CODMOE=DMOE.CODTAB (+)',
       'CODMOE',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       90,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Cdigo da srie',
       'VEN.CODSER=DSER.CODSER (+)',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       100,
       10,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       'REC.FILUSU = USU.FILUSU(+)  AND REC.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       110,
       8,
       'CUPFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cupom Fiscal',
       'Cupom fiscal',
       '',
       'CUPFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       120,
       8,
       'DATFIS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data e hora da operao',
       '',
       'DATFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       130,
       1,
       'DATIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       140,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       150,
       8,
       'DATVEN',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Vencimento',
       'Data de vencimento',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       160,
       3,
       'ECFREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'ECF',
       'Nmero do ECF que recebeu a parcela',
       '',
       'ECFREC',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       570,
       7,
       'ESTCAN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Cancela/Estorno',
       'Data de Cancelamento/Estorno',
       '',
       'ESTCAN',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       170,
       3,
       'FILREC',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Cdigo da filial do recebimento',
       'DFIL.CODFIL(+) = REC.FILREC',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       180,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       590,
       50,
       'MEIPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Meio de Pagamento',
       'Meios de Pagamento',
       '',
       'MEIPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       190,
       1,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       440,
       25,
       'NOSNUM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nosso Nmero',
       'Boleto Nosso Nmero',
       '',
       'NOSNUM',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       200,
       6,
       'NUMCHE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero',
       'Nmero do cheque',
       '',
       'NUMCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       210,
       10,
       'NUMCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Conta',
       'Nmero da conta',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       220,
       3,
       'NUMECF',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       'F',
       'Nmero do ECF',
       'Nmero do ECF',
       'DECF.FILECF = EREC.FILREC(+) AND DECF.NUMECF = EREC.NUMECF(+)',
       'NUMECF',
       'T' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       230,
       6,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero',
       'Nmero da nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       240,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero~Parcela',
       'Nmero da Parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       250,
       8,
       'PAGAME',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Pagamento',
       'Data e hora de Pagamento',
       '',
       'PAGAME',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       260,
       2,
       'PORTAD',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       '',
       'A',
       'F',
       'Portador',
       'Cdigo do portador',
       'REC.PORTAD=DCOB.CODTAB (+)',
       'PORTAD',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       270,
       2,
       'RENEGO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Renegociao',
       'Renegociao',
       '',
       'RENEGO',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       280,
       2,
       'RENORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Origem Renegociao',
       'Origem Renegociao',
       '',
       'RENORI',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       490,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       290,
       12,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       300,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Nmero da sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       310,
       5,
       'TIPCCC',
       'S',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       'A',
       'F',
       'Tipo Conta Corrente',
       'Tipo Conta Corrente',
       'DCCC.CODTAB(+) = REC.TIPCCC',
       'TIPCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       320,
       8,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr. Desconto',
       'Valor do Desconto',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       330,
       8,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vlr. Parcela',
       'Valor da parcela',
       '',
       'VLRPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       340,
       8,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vlr. Pago',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'EREC',
       '--',
       500,
       14,
       'VLRTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Vlr. Taxa',
       'Valor da Taxa',
       '',
       'VLRTAX',
       'F' FROM DUAL
);

/*-- SEQ 7864 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'EREC',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EREC',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EREC',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EREC',
       'FLGEST',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7865 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ERR ',
       TO_NUMBER(null),
       'ERR ',
       'Erros Proc. Transac.',
       'TT_ERR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'ERR.CODFIL,ERR.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7866 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ERR ','--','' FROM DUAL
UNION ALL
SELECT 'ERR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ERR ','99','Outros' FROM DUAL
);

/*-- SEQ 7867 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21498,
       'LCF ',
       'ERR ',
       '1',
       '0N',
       '',
       '',
       'LCF.CODFIL = ERR.CODFIL(+) AND
LCF.SEQUEN = ERR.SEQLCF(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 7868 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ERR ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL = ERR.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ERR ',
       '01',
       50,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data da incluso',
       'Data da incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'ERR ',
       '01',
       30,
       10,
       'SEQLCF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Sequenciador da LCF',
       'Sequenciador da LCF',
       '',
       'SEQLCF',
       '' FROM DUAL
UNION ALL
SELECT 'ERR ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'ERR ',
       '01',
       40,
       4000,
       'TXTERR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Texto do Erro',
       'Texto do Erro',
       '',
       'TXTERR',
       '' FROM DUAL
UNION ALL
SELECT 'ERR ',
       '99',
       60,
       4000,
       'XMLTRA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'XML da Transao',
       'XML da Transao',
       '',
       'XMLTRA',
       '' FROM DUAL
);

/*-- SEQ 7869 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ESAL',
       TO_NUMBER(null),
       'ESAL',
       'Exportao de Saldos',
       'TV_ESAL',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7870 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ESAL','--','' FROM DUAL
UNION ALL
SELECT 'ESAL','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ESAL','99','Outros' FROM DUAL
);

/*-- SEQ 7871 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ESAL',
       '--',
       10,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'ESAL',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'ESAL.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'ESAL',
       '--',
       30,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ESAL',
       '--',
       40,
       1,
       'DATIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'ESAL',
       '--',
       50,
       30,
       'DESEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'DESEST    ',
       'F' FROM DUAL
UNION ALL
SELECT 'ESAL',
       '--',
       60,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filia do Material',
       'Filial do material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ESAL',
       '--',
       70,
       7,
       'INI_CM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ini.Custo Mdio',
       'Data Ini.Custo Mdio',
       '',
       'INI_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'ESAL',
       '--',
       80,
       1,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'ESAL',
       '--',
       90,
       13,
       'PTOPED',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Ponto de pedido',
       'Ponto de pedido',
       '',
       'PTOPED',
       'F' FROM DUAL
UNION ALL
SELECT 'ESAL',
       '--',
       100,
       12,
       'QTDEST',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtd.Estoque',
       'Quantidade em estoque',
       '',
       'QTDEST',
       'F' FROM DUAL
UNION ALL
SELECT 'ESAL',
       '--',
       110,
       13,
       'QTDMIN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade mnima',
       'Quantidade mnima',
       '',
       'QTDMIN',
       'F' FROM DUAL
UNION ALL
SELECT 'ESAL',
       '--',
       120,
       12,
       'QTDREP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Ideal de Reposio',
       'Quantidade ideal de reposiao',
       '',
       'QTDREP',
       'F' FROM DUAL
UNION ALL
SELECT 'ESAL',
       '--',
       130,
       14,
       'QTD_CM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtde Ini. Custo M.',
       'Quantidade Inicial do Custo Mdio',
       '',
       'QTD_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'ESAL',
       '--',
       160,
       12,
       'RESERV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Qtd. Reserva',
       'Quantidade Reservada',
       '',
       'RESERV',
       '' FROM DUAL
UNION ALL
SELECT 'ESAL',
       '--',
       140,
       12,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       '',
       '',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'ESAL',
       '--',
       150,
       16,
       'VLR_CM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr Ini Cust Med Fis',
       'Valor Inicial do Custo Mdio Fiscal',
       '',
       'VLR_CM',
       'F' FROM DUAL
);

/*-- SEQ 7872 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ESER',
       TO_NUMBER(null),
       'ESER',
       'Exportao de Sries',
       'TV_ESER',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7873 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ESER','--','' FROM DUAL
UNION ALL
SELECT 'ESER','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ESER','99','Outros' FROM DUAL
);

/*-- SEQ 7874 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ESER',
       '--',
       10,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Cdigo da srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       20,
       1,
       'DATIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       30,
       25,
       'DESSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio da srie',
       '',
       'DESSER',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       40,
       10,
       'DISSAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sada em',
       'Dispositivo de sada',
       '',
       'DISSAI',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       50,
       1,
       'DIVTRO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Dividir em 2 NFs?',
       'Define se a troca ser dividida em 2 NFs',
       '',
       'DIVTRO',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       60,
       2,
       'EXTNOT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Largura do extenso',
       'Tamanho do extenso da N.F.',
       '',
       'EXTNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       70,
       1,
       'IMPNOT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Impresso On-Line?',
       'Imprime nota On Line ? (S/N)',
       '',
       'IMPNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       80,
       2,
       'MODNOT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Modelo de Nota',
       'Modelo da Nota',
       '',
       'MODNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       90,
       1,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       100,
       3,
       'OBSCOL',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nro de Colunas',
       'Nmero de colunas no formulrio de NF para observao',
       '',
       'OBSCOL',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       110,
       3,
       'OBSLIN',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nro de linhas',
       'Nro de linhas no formulrio de NF para observao',
       '',
       'OBSLIN',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       120,
       2,
       'QTDITP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'N de itens produto',
       'Quantidade de Itens de Produto',
       '',
       'QTDITP',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       130,
       2,
       'QTDITS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'N de itens servio',
       'Quantidade de Itens de Servio',
       '',
       'QTDITS',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       140,
       1,
       'RESTRI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Uso restrito?',
       'Define se a srie  de uso restrito de alguns usurios',
       '',
       'RESTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       150,
       1,
       'SERATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ativo?',
       'Ativo',
       '',
       'SERATI',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       160,
       6,
       'SERFIM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mximo de Notas',
       'Nmero mximo de notas (em caso de numereo manual)',
       '',
       'SERFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       170,
       6,
       'SERINI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mnimo de Notas',
       'Nmero mnimo de nota (em caso de numerao manual)',
       '',
       'SERINI',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       180,
       1,
       'SERMAN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exige numerao man.',
       'Srie com numerao manual',
       '',
       'SERMAN',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       190,
       12,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       200,
       4000,
       'TXTENT',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Texto no meio da NF',
       'Texto para ser impresso entre os itens de servio e de produto na NF',
       '',
       'RTF2TXT(TXTENT)',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       210,
       4000,
       'TXTFIM',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Texto no final da NF',
       'Texto para ser impresso no final da NF',
       '',
       'RTF2TXT(TXTFIM)',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       220,
       4000,
       'TXTINI',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Texto no incio NF',
       'Texto para ser impresso no incio da NF',
       '',
       'RTF2TXT(TXTINI)',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       230,
       4000,
       'TXTITE',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Texto no Item da NF',
       'Texto para ser impresso no item de produto da NF',
       '',
       'RTF2TXT(TXTITE)',
       'F' FROM DUAL
UNION ALL
SELECT 'ESER',
       '--',
       240,
       4000,
       'TXTSER',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Texto no servio NF',
       'Texto para ser impresso no item de servio da NF',
       '',
       'RTF2TXT(TXTSER)',
       'F' FROM DUAL
);

/*-- SEQ 7875 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EST ',
       TO_NUMBER(null),
       'EST ',
       'Estoque na Abertura ',
       'TT_EST',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7876 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EST ','--','' FROM DUAL
UNION ALL
SELECT 'EST ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EST ','99','Outros' FROM DUAL
);

/*-- SEQ 7877 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22387,
       'GRA ',
       'EST ',
       '1',
       '0N',
       '',
       '',
       'EST.FILMAT = GRA.FILMAT AND
EST.CODMAT = GRA.CODMAT AND
EST.CODCOR = GRA.CODCOR AND
EST.CODTAM = GRA.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 7878 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EST ',
       '--',
       90,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Assinatura do PAF-ECF',
       '',
       'ASSINA',
       'F' FROM DUAL
UNION ALL
SELECT 'EST ',
       '--',
       50,
       5,
       'CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Diviso da Grade',
       'Diviso da Grade',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'EST ',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'FIL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'FIL2.CODFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'FIL2.CODFIL = EST.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EST ',
       '--',
       40,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo da Grade',
       'Cdigo da Grade',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EST ',
       '--',
       60,
       5,
       'CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Subdiviso da Grade',
       'Subdiviso da Grade',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'EST ',
       '--',
       80,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Cdigo da Tabela de Acesso',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'EST ',
       '--',
       30,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial da Grade',
       'Filial da Grade',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EST ',
       '--',
       70,
       12,
       'QTDEST',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtd Estoque Fsico',
       'Quantidade Estoque Fsico',
       '',
       'QTDEST',
       'F' FROM DUAL
UNION ALL
SELECT 'EST ',
       '--',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 7879 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ESTO',
       TO_NUMBER(null),
       'ESTO',
       'Estorno ICMS Compra',
       'TV_PCIA_EST_ICMS_COMPRA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7880 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ESTO','--','' FROM DUAL
UNION ALL
SELECT 'ESTO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ESTO','99','Outros' FROM DUAL
);

/*-- SEQ 7881 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ESTO',
       '01',
       10,
       9,
       'COMNUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'NF Compra',
       'NF Compra',
       '',
       'COMNUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'ESTO',
       '--',
       20,
       12,
       'ICMEST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'ICMS Estornado',
       'ICMS Estornado',
       '',
       'ICMEST',
       'F' FROM DUAL
UNION ALL
SELECT 'ESTO',
       '--',
       30,
       12,
       'ICOATQMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade Compra',
       'Quantidade Compra',
       '',
       'ICOATQMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'ESTO',
       '--',
       40,
       14,
       'ICOBASICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base ICMS Compra',
       'Base ICMS Compra',
       '',
       'ICOBASICM',
       'F' FROM DUAL
UNION ALL
SELECT 'ESTO',
       '--',
       50,
       14,
       'ICOBASICMDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base Dif ICMS Compra',
       'Base Dif ICMS Compra',
       '',
       'ICOBASICMDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'ESTO',
       '--',
       60,
       12,
       'ICOICMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       '% ICMS Compra',
       '% ICMS Compra',
       '',
       'ICOICMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'ESTO',
       '--',
       70,
       14,
       'ICOICMITEDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       '% Dif ICMS Compra',
       '% Dif ICMS Compra',
       '',
       'ICOICMITEDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'ESTO',
       '--',
       80,
       14,
       'ICOVLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vlr ICMS Compra',
       'Vlr ICMS Compra',
       '',
       'ICOVLRICM',
       'F' FROM DUAL
UNION ALL
SELECT 'ESTO',
       '--',
       90,
       14,
       'ICOVLRICMDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vlr Dif ICMS Compra',
       'Vlr Dif ICMS Compra',
       '',
       'ICOVLRICMDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'ESTO',
       '--',
       100,
       12,
       'IVEBASICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base ICMS Dev',
       'Base ICMS Dev',
       '',
       'IVEBASICM',
       'F' FROM DUAL
UNION ALL
SELECT 'ESTO',
       '--',
       110,
       12,
       'IVEQTDMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade Dev',
       'Quantidade Dev',
       '',
       'IVEQTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'ESTO',
       '--',
       120,
       12,
       'IVEVLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'ICMS Dev',
       'ICMS Dev',
       '',
       'IVEVLRICM',
       'F' FROM DUAL
UNION ALL
SELECT 'ESTO',
       '--',
       130,
       7,
       'VENDATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Dev',
       'Data Dev',
       '',
       'VENDATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'ESTO',
       '01',
       140,
       6,
       'VENNUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'NF Dev',
       'NF Dev',
       '',
       'VENNUMNOT',
       'F' FROM DUAL
);

/*-- SEQ 7882 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ETI ',
       0,
       'ETI ',
       'Etiquetas',
       'TT_ETI',
       'T',
       '',
       'TOTALL',
       'Etiquetas',
       '{FILMAT;CODMAT;CODCOR;CODTAM};CODFIL',
       '',
       '',
       '',
       'F',
       '',
       'ETI.CODFIL,ETI.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7883 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ETI ','--','' FROM DUAL
);

/*-- SEQ 7884 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21474,
       'GRA ',
       'ETI ',
       '1',
       'N',
       '',
       '',
       'GRA.FILMAT = ETI.FILMAT and
GRA.CODMAT = ETI.CODMAT and
GRA.CODCOR = ETI.CODCOR and
GRA.CODTAM = ETI.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 7885 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ETI ',
       '--',
       30,
       2,
       'CODCOR',
       'S',
       'DIV ',
       0,
       0,
       'ETI ',
       30,
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       'ETI',
       'F',
       'A',
       'T',
       'Diviso',
       'Diviso do produto',
       'ETI.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'ETI ',
       '--',
       50,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       0,
       'ETI ',
       50,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'ETI',
       'F',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'ETI.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'ETI ',
       '--',
       20,
       5,
       'CODMAT',
       'A',
       '',
       0,
       0,
       'ETI ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ETI',
       'F',
       'N',
       'F',
       '',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ETI ',
       '--',
       40,
       2,
       'CODTAM',
       'S',
       'SUB ',
       0,
       0,
       'ETI ',
       40,
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       'ETI',
       'F',
       'A',
       'T',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'ETI.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'ETI ',
       '--',
       10,
       3,
       'FILMAT',
       'A',
       '',
       0,
       0,
       'ETI ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ETI',
       'F',
       'N',
       'F',
       '',
       'Cdigo da Filial do material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ETI ',
       '--',
       60,
       4,
       'QTDEMI',
       'G',
       '',
       0,
       0,
       'ETI ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ETI',
       'T',
       '9',
       'T',
       'Qtde p/Emisso',
       'Quantidade para emisso',
       '',
       'QTDEMI',
       'F' FROM DUAL
UNION ALL
SELECT 'ETI ',
       '--',
       80,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'ETI ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'ETI ',
       '--',
       71,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN ETI.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'ETI ',
       '--',
       70,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'ETI ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'ETI',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN ETI.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
);

/*-- SEQ 7886 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EUSU',
       TO_NUMBER(null),
       'EUSU',
       'Exportao de Usuri',
       'TV_EUSU',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7887 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EUSU','--','' FROM DUAL
UNION ALL
SELECT 'EUSU','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EUSU','99','Outros' FROM DUAL
);

/*-- SEQ 7888 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EUSU',
       '--',
       10,
       1,
       'AGENDB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Acesso ao Agendador?',
       'Acesso ao Agendador?',
       '',
       'AGENDB',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       20,
       10,
       'APEUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Apelido Usurio',
       'Apelido do usurio',
       '',
       'APEUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       30,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       40,
       1,
       'CFGINI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Grava Config. Tela?',
       'Se grava ou no as alteraes da formatao de telas',
       '',
       'CFGINI',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       50,
       20,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Alternativo nico',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       60,
       30,
       'CODCTR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'CODCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       70,
       10,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       80,
       3,
       'CODINI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Format.Telas',
       'Cdigo do usurio de que se assume a formatao de telas',
       '',
       'CODINI',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       90,
       5,
       'CODSET',
       'S',
       'DSET',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSET.DESSET',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Setor',
       'Cdigo Setor',
       'DSET.CODTAB = EUSU.CODSET',
       'CODSET',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       100,
       10,
       'CODSUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo externo',
       '',
       'CODSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       110,
       1,
       'COMIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Comunica. Impressora',
       'Comunicao com impressora ',
       '',
       'COMIMP',
       'T' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       120,
       32,
       'CSENHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Senha',
       'Senha',
       '',
       'CSENHA',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       130,
       1,
       'DATIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       140,
       1,
       'EDINDB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Editar Formatos?',
       'Editar Formatos?',
       '',
       'EDINDB',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       150,
       40,
       'E_MAIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail',
       'E-mail',
       '',
       'E_MAIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       160,
       1,
       'FAZENQ',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Faz Enquete?',
       'Faz Enquete?',
       '',
       'FAZENQ',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       170,
       1,
       'FAZMON',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Faz Montagem?',
       'Faz Montagem?',
       '',
       'FAZMON',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       180,
       3,
       'FILATV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Locado',
       'Filial onde est alocado',
       '',
       'FILATV',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       190,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial Cliente',
       'Filial onde foi cadastrado o cliente',
       'EUSU.FILCLI = DFIL.CODFIL (+)',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       200,
       3,
       'FILINI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Fillial Format.Telas',
       'Filial do usurio de que se assume a formatao de telas',
       '',
       'FILINI',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       210,
       3,
       'FILSUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Superior',
       '',
       'FILSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       220,
       3,
       'FILUSU',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial de Origem',
       'Filial do Usurio',
       'EUSU.FILUSU = DFIL.CODFIL (+)',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       230,
       30,
       'FUNCAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Funo',
       'Funo',
       '',
       'FUNCAO',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       240,
       4000,
       'GRUPOS',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Grupos(Uso futuro)',
       'Grupos(Uso futuro)',
       '',
       'RTF2TXT(GRUPOS)',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       250,
       4,
       'HORDOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horrio Domingo',
       'Horrio Domingo',
       '',
       'HORDOM',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       260,
       4,
       'HORQUA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horrio Quarta',
       'Horrio Quarta',
       '',
       'HORQUA',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       270,
       4,
       'HORQUI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horrio Quinta',
       'Horrio Quinta',
       '',
       'HORQUI',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       280,
       12,
       'HORRATCOR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Hora Cortesia',
       'Valor pago por hora cortesia',
       '',
       'HORRATCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       290,
       4,
       'HORSAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horrio Sbado',
       'Horrio Sbado',
       '',
       'HORSAB',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       300,
       4,
       'HORSEG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horrio Segunda',
       'Horrio Segunda',
       '',
       'HORSEG',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       310,
       4,
       'HORSEX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horrio Sexta',
       'Horrio Sexta',
       '',
       'HORSEX',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       320,
       4,
       'HORTER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horrio Tera',
       'Horrio Tera',
       '',
       'HORTER',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       330,
       6,
       'INDPRO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'ndice Produtividade',
       'ndice Produtividade',
       '',
       'INDPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       340,
       14,
       'LIMCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Limite de Compras',
       'Limite de Compras',
       '',
       'LIMCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       350,
       2,
       'MAIDAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Maior Dia/Data',
       'Maior data possvel de uso em relao ao dia de hoje',
       '',
       'MAIDAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       360,
       5,
       'MAXDAT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Mx.dias aps venc.',
       'Mx. dias p/ aceitar baixa parcelas/lanamentos avulsos aps vencimento',
       '',
       'MAXDAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       370,
       2,
       'MENDAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Menor Dia/Data',
       'Menor data possvel de uso em relao ao dia de hoje',
       '',
       'MENDAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       380,
       5,
       'MINDAT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Min.dias antes venc.',
       'Min. dias p/ aceitar baixa parcelas/lanamentos avulsos aps vencimento',
       '',
       'MINDAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       390,
       12,
       'MINRATCOB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% Hora Cobrada',
       'Percentual sobre hora cobrada',
       '',
       'MINRATCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       400,
       1,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       410,
       2,
       'NIVUSU',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Nvel',
       'Nvel do Usurio',
       '',
       'NIVUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       420,
       30,
       'NOMUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Usurio',
       'Nome do usurio',
       '',
       'NOMUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       430,
       3,
       'NUMPAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero do Palm',
       'Nmero do Palm',
       '',
       'NUMPAL',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       440,
       255,
       'PATNDB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path Consultas',
       'Path Consultas NetData',
       '',
       'PATNDB',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       450,
       8,
       'PERCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% Comisso',
       'Percentagem de comisso do usurio',
       '',
       'PERCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       460,
       1000,
       'PERMIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Lista de Permisses',
       'Lista das permisses',
       '',
       'PERMIS',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       470,
       5,
       'PERRATCOB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Mnimo Hora Cobrada',
       'Valor mnimo sobre hora cobrada',
       '',
       'PERRATCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       620,
       6,
       'PRZPAG_MAX',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Prazo mdio mx. pag',
       'Prazo mdio mximo a pagar',
       '',
       'PRZPAG_MAX',
       '' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       610,
       6,
       'PRZPAG_MIN',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Prazo mdio mn. pag',
       'Prazo mdio mnimo a pagar',
       '',
       'PRZPAG_MIN',
       '' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       480,
       20,
       'SENHA1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Senha usu cripto. 1',
       'Senha do usurio - criptografia 1',
       '',
       'SENHA1',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       490,
       20,
       'SENHA2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Senha usu cripto. 2',
       'Senha do usurio - criptografia 2',
       '',
       'SENHA2',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       500,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN EUSU.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       501,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN EUSU.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       510,
       12,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       520,
       15,
       'TABATU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tabela Atual',
       'Tabela Atual',
       '',
       'TABATU',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       530,
       1,
       'USANDB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'UsarTOTALIBI Browser',
       'Usar TOTALI BI Browser?',
       '',
       'USANDB',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       540,
       1,
       'USANDC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'UsarTOTALIBI Config?',
       'Usar TOTALI BI Config?',
       '',
       'USANDC',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       550,
       1,
       'USUCOB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usurio de Cobrana?',
       'Usurio de Cobrana?',
       '',
       'USUCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       560,
       7,
       'VALSEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Validade Senha',
       'Validade Senha',
       '',
       'VALSEN',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       570,
       100,
       'VISPER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Viso da Permisso',
       'Viso da Permisso',
       '',
       'VISPER',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       580,
       9,
       'VISSE1',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Senha1(Lite)',
       'Senha1(Lite)',
       '',
       'VISSE1',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       590,
       9,
       'VISSE2',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Senha2(Lite)',
       'Senha2(Lite)',
       '',
       'VISSE2',
       'F' FROM DUAL
UNION ALL
SELECT 'EUSU',
       '--',
       600,
       1,
       'VISWOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'ltima~Visualizao',
       'ltima~Visualizao',
       '',
       'VISWOR',
       'T' FROM DUAL
);

/*-- SEQ 7889 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'EUSU',
       'COMIMP',
       0,
       '0',
       'No Tem',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EUSU',
       'COMIMP',
       0,
       '1',
       'Infra Vermelho',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EUSU',
       'COMIMP',
       0,
       '2',
       'Serial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EUSU',
       'NIVUSU',
       0,
       ' ',
       'Administrador',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EUSU',
       'NIVUSU',
       1,
       ' ',
       'Operador',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EUSU',
       'NIVUSU',
       2,
       ' ',
       'Vendedor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EUSU',
       'VISWOR',
       0,
       'D',
       'Desenvolvimento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EUSU',
       'VISWOR',
       0,
       'I',
       'Implantao',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7890 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EVBO',
       TO_NUMBER(null),
       'EVBO',
       'Eventos Bnus',
       'TV_EVE_BON',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'EVBO.FILCLI,EVBO.CODCLI',
       '' FROM DUAL
);

/*-- SEQ 7891 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EVBO','--','' FROM DUAL
UNION ALL
SELECT 'EVBO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EVBO','99','Outros' FROM DUAL
);

/*-- SEQ 7892 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5522,
       'USU ',
       'EVBO',
       '0N',
       '01',
       '',
       '',
       'usu.filcli = evbo.filusu and
usu.codcli = evbo.codusu',
       '' FROM DUAL
UNION ALL
SELECT 5523,
       'CLI ',
       'EVBO',
       '0N',
       '01',
       '',
       '',
       'cli.filcli = evbo.filcli and
cli.codcli = evbo.codcli',
       '' FROM DUAL
);

/*-- SEQ 7893 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EVBO',
       '--',
       10,
       1,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVBO',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Codigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVBO',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EVBO.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVBO',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Usurio',
       'Codigo usuario',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVBO',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVBO',
       '--',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data Operacao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVBO',
       '--',
       60,
       5,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrico',
       'Descricao Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVBO',
       '--',
       70,
       10,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificao',
       'ID Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'EVBO',
       '--',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVBO',
       '--',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVBO',
       '--',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'EVBO',
       '--',
       110,
       1,
       'MSGEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVBO',
       '--',
       120,
       1,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao do Evento',
       'Situacao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVBO',
       '--',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVBO',
       '--',
       140,
       12,
       'VLREVE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 7894 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EVCC',
       TO_NUMBER(null),
       'EVCC',
       'Eventos C/C',
       'TV_EVE_CCC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7895 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EVCC','--','' FROM DUAL
UNION ALL
SELECT 'EVCC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EVCC','99','Outros' FROM DUAL
);

/*-- SEQ 7896 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5524,
       'CLI ',
       'EVCC',
       '0N',
       '01',
       '',
       '',
       'cli.filcli = evcc.filcli and
cli.codcli = evcc.codcli',
       '' FROM DUAL
UNION ALL
SELECT 5525,
       'USU ',
       'EVCC',
       '0N',
       '01',
       '',
       '',
       'cli.codfil = evcc.filusu and
cli.codcli = evcc.codusu',
       '' FROM DUAL
);

/*-- SEQ 7897 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EVCC',
       '--',
       10,
       1,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCC',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Codigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCC',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EVCC.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCC',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Usurio',
       'Codigo Usuario',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCC',
       '01',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCC',
       '--',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operacao',
       'Data de Operacao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCC',
       '--',
       60,
       34,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao',
       'Descricao Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCC',
       '--',
       70,
       10,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificao',
       'ID Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCC',
       '--',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCC',
       '--',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCC',
       '--',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'EVCC',
       '--',
       110,
       100,
       'MSGEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCC',
       '--',
       120,
       27,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situacao',
       'Situacao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCC',
       '--',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCC',
       '--',
       140,
       12,
       'VLREVE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 7898 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'EVCC',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVCC',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7899 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EVCH',
       TO_NUMBER(null),
       'EVCH',
       'Eventos de Cheques',
       'TV_EVE_CHR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7900 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EVCH','--','' FROM DUAL
UNION ALL
SELECT 'EVCH','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EVCH','99','Outros' FROM DUAL
);

/*-- SEQ 7901 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5526,
       'CLI ',
       'EVCH',
       '0N',
       '01',
       '',
       '',
       'cli.filcli = evch.filcli and
cli.codcli = evch.codcli',
       '' FROM DUAL
UNION ALL
SELECT 5527,
       'USU ',
       'EVCH',
       '0N',
       '01',
       '',
       '',
       'usu.filcli = evch.filusu and
usu.codcli = evch.codusu',
       '' FROM DUAL
);

/*-- SEQ 7902 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EVCH',
       '--',
       10,
       1,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCH',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Codigo cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCH',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Codigo Filial',
       'DFIL.CODFIL = EVCH.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCH',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Usurio',
       'Codigo Usuario',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCH',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCH',
       '--',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operacao',
       'Data Operacao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCH',
       '--',
       60,
       14,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao',
       'Descricao evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCH',
       '--',
       70,
       10,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificao',
       'ID Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCH',
       '--',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCH',
       '--',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCH',
       '--',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status Evento',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'EVCH',
       '--',
       110,
       0,
       'MSGEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCH',
       '--',
       120,
       30,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situacao',
       'Situacao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCH',
       '--',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCH',
       '--',
       140,
       12,
       'VLREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor Movimentado',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 7903 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'EVCH',
       'FLGEST',
       0,
       'A',
       'A Depositar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVCH',
       'FLGEST',
       0,
       'C',
       'Compensado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVCH',
       'FLGEST',
       0,
       'D',
       'Depositado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVCH',
       'FLGEST',
       0,
       'V',
       'Devolvido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVCH',
       'FLGEST',
       0,
       'X',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7904 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EVCO',
       TO_NUMBER(null),
       'EVCO',
       'Eventos Compra',
       'TV_EVE_COM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7905 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EVCO','--','' FROM DUAL
UNION ALL
SELECT 'EVCO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EVCO','99','Outros' FROM DUAL
);

/*-- SEQ 7906 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5532,
       'USU ',
       'EVCO',
       '0N',
       '01',
       '',
       '',
       'usu.filcli = evco.filusu and
usu.codcli = evco.codusu',
       '' FROM DUAL
UNION ALL
SELECT 5533,
       'CLI ',
       'EVCO',
       '0N',
       '01',
       '',
       '',
       'cli.filcli = evco.filcli and
cli.codcli = evco.filcli',
       '' FROM DUAL
);

/*-- SEQ 7907 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EVCO',
       '--',
       10,
       1,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCO',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Codigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCO',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EVCO.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCO',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Usurio',
       'Codigo Usuario',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCO',
       '99',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCO',
       '--',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data Operacao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCO',
       '--',
       60,
       8,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao',
       'Descricao Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCO',
       '--',
       70,
       10,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificao',
       'ID Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCO',
       '--',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCO',
       '--',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCO',
       '--',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCO',
       '--',
       110,
       4000,
       'MSGEVE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCO',
       '--',
       120,
       1,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situacao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCO',
       '--',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCO',
       '--',
       140,
       12,
       'VLREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 7908 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EVCS',
       TO_NUMBER(null),
       'EVCS',
       'Eventos EVE. COS.',
       'TV_EVE_COS',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7909 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EVCS','--','' FROM DUAL
UNION ALL
SELECT 'EVCS','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EVCS','99','Outros' FROM DUAL
);

/*-- SEQ 7910 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5534,
       'CLI ',
       'EVCS',
       '0N',
       '01',
       '',
       '',
       'cli.filcli = evcs.filcli and
cli.codcli = evcs.filcli',
       '' FROM DUAL
UNION ALL
SELECT 5535,
       'USU ',
       'EVCS',
       '0N',
       '01',
       '',
       '',
       'usu.filcli = evcs.filusu and
usu.codcli = evcs.codusu',
       '' FROM DUAL
);

/*-- SEQ 7911 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EVCS',
       '--',
       10,
       1,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCS',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Codigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCS',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EVCS.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCS',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Usurio',
       'Codigo Usuario',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCS',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCS',
       '--',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operacao',
       'Data Operacao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCS',
       '--',
       60,
       8,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao',
       'Descricao Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCS',
       '--',
       70,
       10,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificacao',
       'ID Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCS',
       '--',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCS',
       '--',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCS',
       '--',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCS',
       '--',
       110,
       4000,
       'MSGEVE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCS',
       '--',
       120,
       1,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situacao',
       'Situacao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCS',
       '--',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVCS',
       '--',
       140,
       12,
       'VLREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 7912 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EVE ',
       TO_NUMBER(null),
       'EVE ',
       'Eventos',
       'TV_EVE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7913 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EVE ','--','' FROM DUAL
UNION ALL
SELECT 'EVE ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EVE ','02','Datas' FROM DUAL
UNION ALL
SELECT 'EVE ','03','Valores' FROM DUAL
UNION ALL
SELECT 'EVE ','99','Outros' FROM DUAL
);

/*-- SEQ 7914 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 5539,
       'PAR ',
       'EVE ',
       '1',
       'N',
       '',
       '',
       'PAR.FILCLI = EVE.FILCLI and
PAR.CODCLI = EVE.CODCLI',
       '',
       '' FROM DUAL
);

/*-- SEQ 7915 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EVE ',
       '02',
       55,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data',
       'Ano de Data',
       '',
       'TO_CHAR(EVE.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'EVE ',
       '01',
       110,
       14,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Identificador nico',
       'Identificador nico',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVE ',
       '01',
       100,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVE ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Filial',
       'EVE.CODFIL = DFIL.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'EVE ',
       '01',
       80,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Usurio',
       'Usurio',
       'EVE.FILUSU = USU.FILUSU(+)  and EVE.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'EVE ',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVE ',
       '02',
       50,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data',
       'Data',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVE ',
       '01',
       20,
       40,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Descrio do Evento',
       'Descrio do Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVE ',
       '01',
       40,
       27,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'EVE ',
       '01',
       90,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVE ',
       '01',
       70,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVE ',
       '99',
       130,
       1,
       'FLGEST',
       'A',
       'DEVF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEVF.DESDOM',
       'V',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Situao do Evento',
       'EVE.TIPEVE = DEVF.CODARQ(+) and EVE.FLGEST = DEVF.CODCHR(+)',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'EVE ',
       '02',
       53,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data',
       'Ms de Data',
       '',
       'TO_CHAR(EVE.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'EVE ',
       '99',
       140,
       4000,
       'MSGEVE',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Observao',
       'Observao do Evento',
       '',
       'RTF2TXT(MSGEVE)',
       'F' FROM DUAL
UNION ALL
SELECT 'EVE ',
       '01',
       60,
       30,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Situao do Evento',
       'Situao do Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVE ',
       '01',
       10,
       3,
       'TIPEVE',
       'A',
       'DEVT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEVT.DESEVE',
       'V',
       '',
       'F',
       'A',
       'F',
       'Tipo de Evento',
       'Tipo de Evento',
       'EVE.TIPEVE = DEVT.TIPEVE',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVE ',
       '03',
       120,
       8,
       'VLREVE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor',
       'Valor',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 7916 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EVEN',
       TO_NUMBER(null),
       'EVEN',
       'Exportao de Vendas',
       'TV_EVEN',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'EVEN_CODPRE',
       '' FROM DUAL
);

/*-- SEQ 7917 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EVEN','--','' FROM DUAL
UNION ALL
SELECT 'EVEN','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EVEN','99','Outros' FROM DUAL
);

/*-- SEQ 7918 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EVEN',
       '--',
       10,
       8,
       'ACRESC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Desc/Acrscimo (%)',
       'Desconto / Acrscimo',
       '',
       'ACRESC',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       651,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN EVEN.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       20,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       30,
       1,
       'AUTENT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Autenticada?',
       'Indica se a nota j foi autenticada',
       '',
       'AUTENT',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       910,
       1,
       'AVISTA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       ' Vista?',
       'Venda realizada  vista?',
       '',
       'AVISTA',
       '' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       920,
       12,
       'BASICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base ICMS',
       'Base de ICMS',
       '',
       'BASICM',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       930,
       12,
       'BASIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base IPI',
       'Base de IPI',
       '',
       'BASIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       940,
       12,
       'BASIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base IRRF',
       'Base de IRRF',
       '',
       'BASIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       950,
       12,
       'BASISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base ISS',
       'Base de ISS',
       '',
       'BASISS',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       40,
       12,
       'BASUBS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base Sub. Tributria',
       'Base da Substituio Tributria',
       '',
       'BASUBS',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       960,
       44,
       'CHAVEA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Chave NFe',
       'Chave da Nota Fiscal Eletrnica',
       '',
       'CHAVEA',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1201,
       44,
       'CHVCAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Chave Cancelamento',
       'Chave de Autorizao do Cancelamento',
       '',
       'CHVCAN',
       '' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       50,
       6,
       'CLIENTE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CLIENTE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       60,
       5,
       'CNT_RO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cont. Reinicio Oper.',
       'Contador de Reinicio de Operao',
       '',
       'CNT_RO',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       70,
       20,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Alternativo nico',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       80,
       30,
       'CODCTR',
       'A',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       'DCTR.CODTAB = VEN.CODCTR(+)',
       'CODCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       90,
       30,
       'CODDEV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo da devoluo',
       'Motivo da devoluo',
       '',
       'CODDEV',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       100,
       15,
       'CODEXT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       110,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = VEN.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       120,
       5,
       'CODFIN',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cod. da Financeira',
       'Cod. da Financeira',
       '',
       'CODFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       130,
       3,
       'CODGUI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo do Guia',
       'Cdigo do Guia',
       '',
       'CODGUI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       140,
       10,
       'CODPGT',
       'A',
       'PLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'I',
       '',
       '',
       '9',
       'F',
       'Codigo Externo',
       'Cdigo Externo',
       'VEN.FILPGT = PLA.FILPGT(+) AND VEN.CODPGT = PLA.CODPGT(+)',
       'CODPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       150,
       30,
       'CODPRE',
       'A',
       'TPR ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TPR.DESPRE',
       'L',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio da tabela de preos',
       'VEN.FILPRE=TPR.CODFIL (+) AND VEN.CODPRE=TPR.CODPRE (+)',
       'CODPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       160,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Cdigo da srie',
       'VEN.CODSER=DSER.CODSER (+)',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       170,
       20,
       'CODTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Alternativo nico',
       '',
       'CODTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       180,
       10,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo externo',
       'VEN.FILUSU = USU.FILUSU(+)  AND VEN.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       190,
       10,
       'CODVEN',
       'A',
       'VDD ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'VDD.APEUSU',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo externo',
       'VEN.FILVEN = VDD.FILUSU (+)  AND VEN.CODVEN = VDD.CODUSU (+)',
       'CODVEN',
       'T' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       200,
       2,
       'COMSOB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Comisso Sobre',
       'Comisso sobre (ver tela plano)',
       '',
       'COMSOB',
       'T' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       210,
       1,
       'CONSFI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Consumidor Final?',
       'Consumidor Final?',
       '',
       'CONSFI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       220,
       8,
       'DATFIS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Incluso',
       'Data e hora da operao',
       '',
       'DATFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       230,
       8,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data e hora da operao',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1120,
       1,
       'DATIMP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'DATIMP',
       '' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       250,
       8,
       'DATSAI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Sada',
       'Data Sada',
       '',
       'DATSAI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       260,
       8,
       'DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Desc/Acrscimo (%)',
       'Desconto / Acrscimo',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1250,
       12,
       'DESESP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Desconto Especial',
       'Desconto Especial',
       '',
       'DESESP',
       '' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1180,
       15,
       'DOCNFP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Documento p/ NFP',
       'Nmero do CPF/CNPJ para Nota Fiscal Paulista, Nota Paran e similar',
       '',
       'DOCNFP',
       '' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       270,
       3,
       'ECFFAT',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       'F',
       'Nm. ECF da Fatura',
       'Nm. ECF da Fatura',
       'DECF.FILECF = EVEN.FILFAT(+) AND DECF.NUMECF = EVEN.ECFFAT(+)',
       'ECFFAT',
       'T' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       280,
       1,
       'EMIDES',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Frete Dest./Terc.?',
       'Frete  por conta do Destinatrio ou de Terceiros?',
       '',
       'EMIDES',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       290,
       2,
       'ENDCOB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero End. Cobrana',
       'Nmero do endereo de cobrana',
       '',
       'ENDCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       300,
       2,
       'ENDENT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero End. Entrega',
       'Nmero do endereo de entrega',
       '',
       'ENDENT',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       310,
       2,
       'ENDFAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero End. Fatura',
       'Nmero de endereo de fatura',
       '',
       'ENDFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       320,
       2,
       'ESPECI',
       'S',
       'DESP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DESP.ESPECI',
       'V',
       '',
       '',
       'A',
       'F',
       'Espcie de Volume',
       'Espcie do volume',
       'VEN.ESPECI = DESP.CODTAB (+)',
       'ESPECI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1170,
       1,
       'EXPFIS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exportado Fiscal?',
       'Exportado Fiscal?',
       '',
       'EXPFIS',
       '' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       330,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Exportar?',
       'Exportar?',
       '',
       'EXPORT',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       340,
       3,
       'FILCOB',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial Cobrana',
       'Filial do endereo de cobrana',
       'DFIL.CODFIL  = EVEN.FILCOB',
       'FILCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       350,
       3,
       'FILENT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial Entrega',
       'Filial do endereo de entrega',
       'DFIL.CODFIL  = EVEN.FILENT',
       'FILENT',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       360,
       3,
       'FILFAT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = VEN.CODFIL',
       'FILFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1100,
       3,
       'FILGUI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Filial do guia',
       'Filial do guia',
       '',
       'FILGUI',
       '' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       380,
       3,
       'FILPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial de Origem',
       'Filial onde foi cadastrado o Plano',
       '',
       'FILPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       390,
       3,
       'FILPRE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial de Origem da Tabela',
       'TPR.CODFIL = DFIL.CODFIL (+)',
       'FILPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       400,
       1,
       'FINANC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Gera Dados Financ.?',
       'Gera dados financeiros',
       '',
       'FINANC',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       410,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Estado (Cancelado/Quitado/Em aberto)',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1150,
       1,
       'FLGNFE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'NF-e',
       'NF-e',
       '',
       'FLGNFE',
       'T' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       420,
       1,
       'FLGTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Pessoa ',
       'Tipo de Pessoa ',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       430,
       1,
       'LANVEN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Implementao Futura',
       'Implementao futura',
       '',
       'LANVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       440,
       5,
       'MARCAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Marcas',
       'Marcas',
       '',
       'MARCAS',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1130,
       1,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'MOTREJ',
       '' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       460,
       3,
       'NATDEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo no estado',
       'Natureza quando dentro do estado',
       '',
       'NATDEN',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       470,
       3,
       'NATFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo fora do est.',
       'Natureza quando fora do estado',
       '',
       'NATFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       480,
       2,
       'NROIMP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nm. Impresses',
       'Nmero de vezes que a nota foi impressa',
       '',
       'NROIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       490,
       8,
       'NUMCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Conhecimento',
       'Conhecimento de frete',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1140,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Documento (CPF/CNPJ)',
       'Nmero do Documento: CNPJ ou CPF',
       '',
       'NUMDOC',
       '' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       500,
       3,
       'NUMECF',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       'F',
       'Nmero do ECF',
       'Nmero do ECF',
       'DECF.FILECF = EVEN.CODFIL AND DECF.NUMECF = EVEN.NUMECF',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       510,
       6,
       'NUMFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero',
       'Nmero da nota',
       '',
       'NUMFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1210,
       20,
       'NUMNFS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nmero da NFS-e',
       'Nmero da NFS-e',
       '',
       'NUMNFS',
       '' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       520,
       6,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero',
       'Nmero da nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       530,
       4,
       'NUMVOL',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Num.Volumes',
       'Nmero de Volumes',
       '',
       'NUMVOL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       540,
       10,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(EVEN.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       900,
       1,
       'ORICAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem Cancelamento',
       'Origem do Cancelamento',
       '',
       'ORICAN',
       'T' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1160,
       12,
       'OUTTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Outras Taxas',
       'Outras Taxas',
       '',
       'OUTTAX',
       '' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       550,
       8,
       'PERCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Comis. s/ Parcelas',
       'Valor da comisso sobre as parcelas (exceto entrada)',
       '',
       'PERCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       560,
       8,
       'PERENT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Comis. s/ Entrada',
       'Comisso (entrada)',
       '',
       'PERENT',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1010,
       12,
       'PERISS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '%ISS',
       '%ISS',
       '',
       'PERISS',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       570,
       14,
       'PESBRU',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Peso Bruto',
       'Peso lquido',
       '',
       'PESBRU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       580,
       14,
       'PESLIQ',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Peso Lquido',
       'Peso bruto',
       '',
       'PESLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       590,
       7,
       'PLAFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Placa Frete',
       'Placa Frete',
       '',
       'PLAFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       600,
       4,
       'PRAMED',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Prazo Mdio',
       'Prazo mdio',
       '',
       'PRAMED',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1240,
       20,
       'PRE_CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd.Ext Tabela Preo',
       'Cdigo Externo da Tabela de Preo',
       '',
       'PRE_CODEXT',
       '' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       610,
       8,
       'PROPGT',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Prox. Vencimento',
       'Data prximo vencimento',
       '',
       'PROPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1020,
       12,
       'QTDITE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtde Comprada',
       'Qtde Comprada',
       '',
       'QTDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       620,
       2,
       'QTDREN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Qtde Renegociada ',
       'Qtde Renegociada ',
       '',
       'QTDREN',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       630,
       12,
       'RETIDO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Imposto retido',
       'Valor do Imposto Retido',
       '',
       'RETIDO',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1202,
       6,
       'SATCAN',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nm Cancelamento SAT',
       'Nmero do CF-e de Cancelamento no SAT',
       '',
       'SATCAN',
       '' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1200,
       9,
       'SATCFE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Nmero do CF-e',
       'Nmero do CF-e',
       '',
       'SATCFE',
       '' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1190,
       6,
       'SATSER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Nmero de Srie do S',
       'Nmero de Srie do SAT (Srie SAT)',
       '',
       'SATSER',
       '' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1220,
       12,
       'SEGRUR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Seguro Rural',
       'Valor Seguro Rural',
       '',
       'SEGRUR',
       '' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1230,
       12,
       'SENAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor SENAR',
       'Valor Servio Nacional de Aprendizagem Rural',
       '',
       'SENAR',
       '' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1030,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       640,
       2,
       'SERFAT',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Cdigo da srie',
       'VEN.CODSER=DSER.CODSER (+)',
       'SERFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       650,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN EVEN.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       660,
       8,
       'SINAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Sinal Relacionado',
       'Valor de sinal relacionado',
       '',
       'SINAL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1110,
       1,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'STATUS',
       '' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       680,
       12,
       'SUBSTT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Subst. Tributria',
       'Subst. Tributria',
       '',
       'SUBSTT',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       690,
       1,
       'TIPNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Nota',
       'Tipo de Nota',
       '',
       'TIPNOT',
       'T' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       700,
       1,
       'TIPTRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Venda',
       'Tipo Venda',
       '',
       'TIPTRO',
       'T' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       710,
       1,
       'TRIBUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Tributada?',
       'Define se a venda  tributada',
       '',
       'TRIBUT',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       720,
       1,
       'UFLOJA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Dentro do Estado?',
       'Venda Dentro do Estado?',
       '',
       'UFLOJA',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       730,
       2,
       'UF_FRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF Frete',
       'UF Frete',
       '',
       'UF_FRE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       740,
       1,
       'VINCUL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Vinculada?',
       ' Vinculada?',
       '',
       'VINCUL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1040,
       12,
       'VLRCFI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Retido COFINS',
       'Valor Retido de COFINS',
       '',
       'VLRCFI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       750,
       12,
       'VLRCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vl Ret PIS+COF+CSLL',
       'Valor Retido de PIS+COFINS+CSLL',
       '',
       'VLRCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1050,
       12,
       'VLRCSL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valoe CSL',
       'Valor CLS',
       '',
       'VLRCSL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       760,
       8,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Frete',
       'Valor do Frete',
       '',
       'VLRFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1060,
       12,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor ICMS',
       'Valor ICMS',
       '',
       'VLRICM',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1070,
       12,
       'VLRIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor IRRF',
       'Valor IRRF',
       '',
       'VLRIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1080,
       12,
       'VLRISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor ISS',
       'Valor ISS',
       '',
       'VLRISS',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       770,
       8,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Lquido',
       'Valor lquido da nota',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       780,
       8,
       'VLRNOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor dos Itens',
       'Valor da nota',
       '',
       'VLRNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       1090,
       12,
       'VLRPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Retido PIS',
       'Valor Retido de PIS',
       '',
       'VLRPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'EVEN',
       '--',
       790,
       8,
       'VLRSEG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Seguro',
       'Valor do seguro do frete',
       '',
       'VLRSEG',
       'F' FROM DUAL
);

/*-- SEQ 7919 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'EVEN',
       'COMSOB',
       7,
       ' ',
       'Comisso sobre Markup',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'COMSOB',
       0,
       ' ',
       'Lquido ao Vender',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'COMSOB',
       1,
       ' ',
       'Bruto ao Vender',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'COMSOB',
       2,
       ' ',
       'A receber no Vencimento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'COMSOB',
       3,
       ' ',
       'Recebido no Recebimento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'COMSOB',
       4,
       ' ',
       'A receber no Recebimento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'COMSOB',
       5,
       ' ',
       'Recebido na compensao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'COMSOB',
       6,
       ' ',
       'A receber na compensao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'FLGEST',
       0,
       'A',
       'Em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'FLGEST',
       0,
       'I',
       'Incompleta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'FLGEST',
       0,
       'Q',
       'Quitado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'FLGNFE',
       0,
       '0',
       'No enviado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'FLGNFE',
       0,
       '1',
       'Autorizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'FLGNFE',
       0,
       '2',
       'Rejeitado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'FLGNFE',
       0,
       '3',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'FLGNFE',
       0,
       '4',
       'Inutilizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'FLGNFE',
       0,
       '5',
       'Enviando ao Sefaz',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'FLGNFE',
       0,
       '6',
       'Denegada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'FLGNFE',
       0,
       '8',
       'Erro de Importao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'FLGTIP',
       0,
       '0',
       'Fsica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'FLGTIP',
       0,
       '1',
       'Jurdica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'FLGTIP',
       0,
       '2',
       'Entidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'FLGTIP',
       0,
       '3',
       'Especial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'FLGTIP',
       0,
       '4',
       'M.E.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'FLGTIP',
       0,
       '5',
       'Filial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'ORICAN',
       0,
       '1',
       'Checkout',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'ORICAN',
       0,
       '2',
       'Backoffice',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'TIPNOT',
       0,
       'A',
       'N.F.F.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'TIPNOT',
       0,
       'F',
       'Fatura ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'TIPNOT',
       0,
       'N',
       'Nota fiscal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'TIPTRO',
       0,
       '+',
       'Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'TIPTRO',
       0,
       '-',
       'Devoluo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'TIPTRO',
       0,
       '2',
       'Sntegra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'TIPTRO',
       0,
       '@',
       'Vazio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVEN',
       'TIPTRO',
       0,
       'A',
       'Ambos',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7920 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EVFI',
       TO_NUMBER(null),
       'EVFI',
       'Eventos Financeiros',
       'TV_EVE_FIN',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7921 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EVFI','--','' FROM DUAL
UNION ALL
SELECT 'EVFI','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EVFI','99','Outros' FROM DUAL
);

/*-- SEQ 7922 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5540,
       'CLI ',
       'EVFI',
       '0N',
       '01',
       '',
       '',
       'cli.filcli = evfi.filcli and
cli.codcli = evfi.codcli',
       '' FROM DUAL
UNION ALL
SELECT 5541,
       'USU ',
       'EVFI',
       '0N',
       '01',
       '',
       '',
       'usu.filcli = evfi.filusu and
usu.codcli = evfi.codusu',
       '' FROM DUAL
);

/*-- SEQ 7923 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EVFI',
       '--',
       10,
       14,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVFI',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Codigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVFI',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EVFI.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVFI',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Usurio',
       'Codigo Usuario',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVFI',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVFI',
       '--',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operacao',
       'Data Operacao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVFI',
       '--',
       60,
       40,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao',
       'Descricao Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVFI',
       '--',
       70,
       27,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificacao',
       'ID Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'EVFI',
       '--',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVFI',
       '--',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVFI',
       '--',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'EVFI',
       '--',
       110,
       100,
       'MSGEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVFI',
       '--',
       120,
       30,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situacao',
       'Situacao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVFI',
       '--',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVFI',
       '--',
       140,
       12,
       'VLREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 7924 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'EVFI',
       'FLGEST',
       0,
       'A',
       'Em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVFI',
       'FLGEST',
       0,
       'B',
       'Cobrado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVFI',
       'FLGEST',
       0,
       'C',
       'Compensado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVFI',
       'FLGEST',
       0,
       'D',
       'Depositado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVFI',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVFI',
       'FLGEST',
       0,
       'Q',
       'Quitado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVFI',
       'FLGEST',
       0,
       'V',
       'Devolvido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVFI',
       'FLGEST',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7925 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EVLO',
       TO_NUMBER(null),
       'EVLO',
       'Eventos Log',
       'TV_EVE_LOG',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7926 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EVLO','--','' FROM DUAL
UNION ALL
SELECT 'EVLO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EVLO','99','Outros' FROM DUAL
);

/*-- SEQ 7927 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5542,
       'USU ',
       'EVLO',
       '0N',
       '01',
       '',
       '',
       'usu.filcli = evlo.filusu and
usu.codcli = evlo.codusu',
       '' FROM DUAL
UNION ALL
SELECT 5543,
       'CLI ',
       'EVLO',
       '0N',
       '01',
       '',
       '',
       'cli.filcli = evlo.filcli and
cli.codcli = evlo.filcli',
       '' FROM DUAL
);

/*-- SEQ 7928 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EVLO',
       '--',
       10,
       1,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLO',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Codigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLO',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EVLO.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLO',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Usurio',
       'Codigo Usuario',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLO',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLO',
       '--',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data Operacao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLO',
       '--',
       60,
       8,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrico',
       'Descricao Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLO',
       '--',
       70,
       10,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificao',
       'ID Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLO',
       '--',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLO',
       '--',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLO',
       '--',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLO',
       '--',
       110,
       4000,
       'MSGEVE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLO',
       '--',
       120,
       1,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situacao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLO',
       '--',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLO',
       '--',
       140,
       12,
       'VLREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 7929 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EVLR',
       TO_NUMBER(null),
       'EVLR',
       'Eventos LRCP',
       'TV_EVE_LRCP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7930 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EVLR','--','' FROM DUAL
UNION ALL
SELECT 'EVLR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EVLR','99','Outros' FROM DUAL
);

/*-- SEQ 7931 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5544,
       'USU ',
       'EVLR',
       '0N',
       '01',
       '',
       '',
       'usu.filcli = evlr.filusu and
usu.codcli = evlr.codusu',
       '' FROM DUAL
UNION ALL
SELECT 5545,
       'CLI ',
       'EVLR',
       '0N',
       '01',
       '',
       '',
       'cli.filcli = evlr.filcli and
cli.codcli = evlr.filcli',
       '' FROM DUAL
);

/*-- SEQ 7932 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EVLR',
       '--',
       10,
       1,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLR',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Codigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLR',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EVLR.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLR',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Usurio',
       'Codigo Usuario',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLR',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLR',
       '--',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operacao',
       'Data Operacao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLR',
       '--',
       60,
       8,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao',
       'Descricao Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLR',
       '--',
       70,
       10,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificacao',
       'ID Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLR',
       '--',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLR',
       '--',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLR',
       '--',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLR',
       '--',
       110,
       4000,
       'MSGEVE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLR',
       '--',
       120,
       1,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situacao',
       'Situacao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLR',
       '--',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVLR',
       '--',
       140,
       12,
       'VLREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 7933 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EVOR',
       TO_NUMBER(null),
       'EVOR',
       'Eventos Oramento',
       'TV_EVE_ORC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7934 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EVOR','--','' FROM DUAL
UNION ALL
SELECT 'EVOR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EVOR','99','Outros' FROM DUAL
);

/*-- SEQ 7935 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 24922,
       'USU ',
       'EVOR',
       '0N',
       '01',
       '',
       '',
       'usu.filcli = evor.filusu and
usu.codcli = evor.codusu',
       '',
       '' FROM DUAL
UNION ALL
SELECT 24923,
       'CLI ',
       'EVOR',
       '0N',
       '01',
       '',
       '',
       'cli.filcli = evor.filcli and
cli.codcli = evor.filcli',
       '',
       '' FROM DUAL
);

/*-- SEQ 7936 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EVOR',
       '--',
       10,
       10,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOR',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Codigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOR',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EVOR.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOR',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Usurio',
       'Codigo Usuario',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOR',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOR',
       '--',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operacao',
       'Data Operacao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOR',
       '--',
       60,
       40,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao',
       'Descricao Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOR',
       '--',
       160,
       35,
       'DESPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Plano de Pagamento',
       'Plano de Pagamento',
       '',
       'DESPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOR',
       '--',
       70,
       13,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificacao',
       'ID Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOR',
       '--',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOR',
       '--',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOR',
       '--',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOR',
       '--',
       110,
       4000,
       'MSGEVE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOR',
       '--',
       120,
       30,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situacao',
       'Situacao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOR',
       '--',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOR',
       '--',
       140,
       12,
       'VLREVE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 7937 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EVOS',
       TO_NUMBER(null),
       'EVOS',
       'Eventos Ord.Servios',
       'TV_EVE_OS',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7938 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EVOS','--','' FROM DUAL
UNION ALL
SELECT 'EVOS','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EVOS','99','Outros' FROM DUAL
);

/*-- SEQ 7939 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5548,
       'CLI ',
       'EVOS',
       '0N',
       '01',
       '',
       '',
       'cli.filcli = evos.filcli and
cli.codcli = evos.filcli',
       '' FROM DUAL
UNION ALL
SELECT 5549,
       'USU ',
       'EVOS',
       '0N',
       '01',
       '',
       '',
       'usu.filcli = evos.filusu and
usu.codcli = evos.codusu',
       '' FROM DUAL
);

/*-- SEQ 7940 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EVOS',
       '--',
       10,
       1,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOS',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Codigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOS',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EVOS.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOS',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Usurio',
       'Codigo Usuario',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOS',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOS',
       '--',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operacao',
       'Data Operacao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOS',
       '--',
       60,
       8,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao',
       'Descricao Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOS',
       '--',
       70,
       10,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificacao',
       'ID Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOS',
       '--',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOS',
       '--',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOS',
       '--',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOS',
       '--',
       110,
       4000,
       'MSGEVE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOS',
       '--',
       120,
       1,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situacao',
       'Situacao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOS',
       '--',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVOS',
       '--',
       140,
       12,
       'VLREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 7941 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EVPA',
       TO_NUMBER(null),
       'EVPA',
       'Eventos Pagamento',
       'TV_EVE_PAG',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7942 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EVPA','--','' FROM DUAL
UNION ALL
SELECT 'EVPA','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EVPA','99','Outros' FROM DUAL
);

/*-- SEQ 7943 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5553,
       'CLI ',
       'EVPA',
       '0N',
       '01',
       '',
       '',
       'cli.filcli = evpa.filcli and
cli.codcli = evpa.filcli',
       '' FROM DUAL
UNION ALL
SELECT 5554,
       'USU ',
       'EVPA',
       '0N',
       '01',
       '',
       '',
       'usu.filcli = evpa.filusu and
usu.codcli = evpa.codusu',
       '' FROM DUAL
);

/*-- SEQ 7944 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EVPA',
       '--',
       10,
       1,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPA',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Codigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPA',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EVPA.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPA',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Usurio',
       'Codigo Usuario',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPA',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPA',
       '--',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operacao',
       'Data Operacao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPA',
       '--',
       60,
       8,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao',
       'Descricao Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPA',
       '--',
       70,
       10,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificacao',
       'ID Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPA',
       '--',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPA',
       '--',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPA',
       '--',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPA',
       '--',
       110,
       4000,
       'MSGEVE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPA',
       '--',
       120,
       1,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situacao',
       'Situacao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPA',
       '--',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPA',
       '--',
       140,
       12,
       'VLREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 7945 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EVPE',
       TO_NUMBER(null),
       'EVPE',
       'Eventos dos Pedidos',
       'TV_EVE_PED',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7946 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EVPE','--','' FROM DUAL
UNION ALL
SELECT 'EVPE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EVPE','99','Outros' FROM DUAL
);

/*-- SEQ 7947 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5556,
       'CLI ',
       'EVPE',
       '0N',
       '01',
       '',
       '',
       'cli.filcli = evpe.filcli and
cli.codcli = evpe.codcli',
       '' FROM DUAL
UNION ALL
SELECT 5557,
       'USU ',
       'EVPE',
       '0N',
       '01',
       '',
       '',
       'usu.filcli = evpe.filusu and
usu.codcli = evpe.codusu',
       '' FROM DUAL
);

/*-- SEQ 7948 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EVPE',
       '--',
       10,
       8,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPE',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Codigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPE',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EVPE.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPE',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Usurio',
       'Codigo Usuario',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPE',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPE',
       '--',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operacao',
       'Data Operacao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPE',
       '--',
       60,
       16,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao',
       'Descricao Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPE',
       '--',
       70,
       8,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificacao',
       'ID evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPE',
       '--',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPE',
       '--',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPE',
       '--',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'EVPE',
       '--',
       110,
       0,
       'MSGEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPE',
       '--',
       120,
       30,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situacao',
       'Situacao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPE',
       '--',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPE',
       '--',
       140,
       12,
       'VLREVE',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 7949 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'EVPE',
       'FLGEST',
       0,
       'E',
       'Entregue',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7950 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EVPT',
       TO_NUMBER(null),
       'EVPT',
       'Eventos PTR',
       'TV_EVE_PTR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7951 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EVPT','--','' FROM DUAL
UNION ALL
SELECT 'EVPT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EVPT','99','Outros' FROM DUAL
);

/*-- SEQ 7952 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5568,
       'USU ',
       'EVPT',
       '0N',
       '01',
       '',
       '',
       'usu.filcli = evpt.filusu and
usu.codcli = evpt.codusu',
       '' FROM DUAL
UNION ALL
SELECT 5569,
       'CLI ',
       'EVPT',
       '0N',
       '01',
       '',
       '',
       'cli.filcli = evpt.filcli and
cli.codcli = evpt.filcli',
       '' FROM DUAL
);

/*-- SEQ 7953 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EVPT',
       '--',
       10,
       1,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPT',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Codigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPT',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EVPT.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPT',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Usurio',
       'Codigo Usuario',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPT',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPT',
       '--',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operacao',
       'Data Operacao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPT',
       '--',
       60,
       8,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao',
       'Descricao Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPT',
       '--',
       70,
       10,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificacao',
       'ID Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPT',
       '--',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPT',
       '--',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPT',
       '--',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPT',
       '--',
       110,
       4000,
       'MSGEVE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPT',
       '--',
       120,
       1,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situacao',
       'Situacao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPT',
       '--',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVPT',
       '--',
       140,
       12,
       'VLREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 7954 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EVRE',
       TO_NUMBER(null),
       'EVRE',
       'Eventos Recebimento',
       'TV_EVE_REC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7955 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EVRE','--','' FROM DUAL
UNION ALL
SELECT 'EVRE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EVRE','99','Outros' FROM DUAL
);

/*-- SEQ 7956 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5570,
       'CLI ',
       'EVRE',
       '0N',
       '01',
       '',
       '',
       'cli.filcli = evre.filcli and
cli.codcli = evre.codcli',
       '' FROM DUAL
UNION ALL
SELECT 5571,
       'USU ',
       'EVRE',
       '0N',
       '01',
       '',
       '',
       'usu.filcli = evre.filusu and
usu.codcli = evre.codusu',
       '' FROM DUAL
);

/*-- SEQ 7957 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EVRE',
       '--',
       10,
       14,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRE',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Codigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRE',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFLI = EVRE.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRE',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Usurio',
       'Codigo usuario',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRE',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRE',
       '--',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operacao',
       'Data Operacao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRE',
       '--',
       60,
       11,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao',
       'Descricao Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRE',
       '--',
       70,
       19,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificacao',
       'ID evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRE',
       '--',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRE',
       '--',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRE',
       '--',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'EVRE',
       '--',
       110,
       0,
       'MSGEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRE',
       '--',
       120,
       30,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situacao',
       'Situacao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRE',
       '--',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRE',
       '--',
       140,
       12,
       'VLREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 7958 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'EVRE',
       'FLGEST',
       0,
       'A',
       'Em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVRE',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVRE',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVRE',
       'FLGEST',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7959 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EVRG',
       TO_NUMBER(null),
       'EVRG',
       'Eventos de Registros',
       'TV_EVE_REG',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7960 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EVRG','--','' FROM DUAL
UNION ALL
SELECT 'EVRG','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EVRG','99','Outros' FROM DUAL
);

/*-- SEQ 7961 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5572,
       'CLI ',
       'EVRG',
       '0N',
       '01',
       '',
       '',
       'cli.filcli = evlo.filcli and
cli.codcli = evlo.filcli',
       '' FROM DUAL
UNION ALL
SELECT 5573,
       'USU ',
       'EVRG',
       '0N',
       '01',
       '',
       '',
       'usu.filcli = evlo.filusu and
usu.codcli = evlo.codusu',
       '' FROM DUAL
);

/*-- SEQ 7962 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EVRG',
       '--',
       10,
       1,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRG',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Codigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRG',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EVRG.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRG',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Usurio',
       'Codigo Usuario',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRG',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRG',
       '--',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operacao',
       'Data Operacao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRG',
       '--',
       60,
       8,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao',
       'Descricao Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRG',
       '--',
       70,
       10,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificacao',
       'ID Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRG',
       '--',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRG',
       '--',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRG',
       '--',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRG',
       '--',
       110,
       4000,
       'MSGEVE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRG',
       '--',
       120,
       1,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situacao',
       'Situacao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRG',
       '--',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRG',
       '--',
       140,
       12,
       'VLREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 7963 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EVRS',
       TO_NUMBER(null),
       'EVRS',
       'Eventos Questionrio',
       'TV_EVE_RES',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7964 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EVRS','--','' FROM DUAL
UNION ALL
SELECT 'EVRS','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EVRS','99','Outros' FROM DUAL
);

/*-- SEQ 7965 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5574,
       'CLI ',
       'EVRS',
       '0N',
       '01',
       '',
       '',
       'cli.filcli = evrs.filcli and
cli.codcli = evrs.filcli',
       '' FROM DUAL
UNION ALL
SELECT 5575,
       'USU ',
       'EVRS',
       '0N',
       '01',
       '',
       '',
       'usu.filcli = evrs.filusu and
usu.codcli = evrs.codusu',
       '' FROM DUAL
);

/*-- SEQ 7966 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EVRS',
       '--',
       10,
       1,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRS',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Codigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRS',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EVRS.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRS',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Usurio',
       'Codigo Usuario',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRS',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRS',
       '--',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operacao',
       'Data Operacao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRS',
       '--',
       60,
       8,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao',
       'Descricao Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRS',
       '--',
       70,
       10,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificacao',
       'ID Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRS',
       '--',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRS',
       '--',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRS',
       '--',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRS',
       '--',
       110,
       4000,
       'MSGEVE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRS',
       '--',
       120,
       1,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situacao',
       'Situacao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRS',
       '--',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVRS',
       '--',
       140,
       12,
       'VLREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 7967 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EVSU',
       TO_NUMBER(null),
       'EVSU',
       'Eventos Suporte',
       'TV_EVE_SUP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7968 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EVSU','--','' FROM DUAL
UNION ALL
SELECT 'EVSU','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EVSU','99','Outros' FROM DUAL
);

/*-- SEQ 7969 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5578,
       'CLI ',
       'EVSU',
       '0N',
       '01',
       '',
       '',
       'cli.filcli = evsu.filcli and
cli.codcli = evsu.codcli',
       '' FROM DUAL
UNION ALL
SELECT 5579,
       'USU ',
       'EVSU',
       '0N',
       '01',
       '',
       '',
       'usu.filusu = evsu.filusu and
usu.codusu = evsu.codusu',
       '' FROM DUAL
);

/*-- SEQ 7970 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EVSU',
       '01',
       10,
       1,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVSU',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Cliente',
       'Codigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVSU',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EVSU.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVSU',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Usurio',
       'Codigo Usuario',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVSU',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVSU',
       '01',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operacao',
       'Data Operacao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVSU',
       '01',
       60,
       8,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao',
       'Descricao Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVSU',
       '01',
       70,
       10,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificacao',
       'ID Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'EVSU',
       '01',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVSU',
       '01',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVSU',
       '01',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'EVSU',
       '01',
       110,
       4000,
       'MSGEVE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVSU',
       '01',
       120,
       1,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situacao',
       'Situacao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVSU',
       '01',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVSU',
       '01',
       140,
       12,
       'VLREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 7971 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EVTR',
       TO_NUMBER(null),
       'EVTR',
       'Eventos TRC',
       'TV_EVE_TRC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7972 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EVTR','--','' FROM DUAL
UNION ALL
SELECT 'EVTR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EVTR','99','Outros' FROM DUAL
);

/*-- SEQ 7973 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5580,
       'CLI ',
       'EVTR',
       '0N',
       '01',
       '',
       '',
       'cli.filcli = evtr.filcli and
cli.codcli = evtr.filcli',
       '' FROM DUAL
UNION ALL
SELECT 5581,
       'USU ',
       'EVTR',
       '0N',
       '01',
       '',
       '',
       'usu.filcli = evtr.filusu and
usu.codcli = evtr.codusu',
       '' FROM DUAL
);

/*-- SEQ 7974 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EVTR',
       '--',
       10,
       1,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVTR',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Codigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVTR',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EVTR.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVTR',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Usurio',
       'Codigo Usuario',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVTR',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVTR',
       '--',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operacao',
       'Data Operacao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVTR',
       '--',
       60,
       8,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao',
       'Descricao Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVTR',
       '--',
       70,
       10,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificacao',
       'ID Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'EVTR',
       '--',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVTR',
       '--',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVTR',
       '--',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'EVTR',
       '--',
       110,
       4000,
       'MSGEVE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVTR',
       '--',
       120,
       1,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situacao',
       'Situacao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVTR',
       '--',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Tipo',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVTR',
       '--',
       140,
       12,
       'VLREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 7975 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EVVE',
       TO_NUMBER(null),
       'EVVE',
       'Eventos Venda',
       'TV_EVE_VEN',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7976 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EVVE','--','' FROM DUAL
UNION ALL
SELECT 'EVVE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EVVE','99','Outros' FROM DUAL
);

/*-- SEQ 7977 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 24942,
       'CLI ',
       'EVVE',
       '1',
       'N',
       '',
       '',
       'cli.filcli = evve.filcli and
cli.codcli = evve.codcli',
       '',
       '' FROM DUAL
UNION ALL
SELECT 24943,
       'USU ',
       'EVVE',
       '0N',
       '01',
       '',
       '',
       'usu.filcli = evve.filusu and
usu.codlci = evve.codusu',
       '',
       '' FROM DUAL
);

/*-- SEQ 7978 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EVVE',
       '--',
       10,
       10,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'chave',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVVE',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Codigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVVE',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EVVE.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVVE',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Usurio',
       'Codigo Usuario',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVVE',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVVE',
       '--',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operacao',
       'Data Operacao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVVE',
       '--',
       60,
       40,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao',
       'Descricao Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVVE',
       '--',
       160,
       35,
       'DESPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Plano de Pagamento',
       'Plano de Pagamento',
       '',
       'DESPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'EVVE',
       '--',
       70,
       13,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificacao',
       'ID Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'EVVE',
       '--',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVVE',
       '--',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVVE',
       '--',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'EVVE',
       '--',
       110,
       4000,
       'MSGEVE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVVE',
       '--',
       120,
       30,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situacao',
       'Situacao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVVE',
       '--',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVVE',
       '--',
       140,
       12,
       'VLREVE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor',
       'Valor',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 7979 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'EVVE',
       'FLGEST',
       0,
       'A',
       'Em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVVE',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EVVE',
       'FLGEST',
       0,
       'Q',
       'Quitada',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7980 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EVWF',
       TO_NUMBER(null),
       'EVWF',
       'Eventos WorkFlow',
       'TV_EVE_WOR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7981 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EVWF','--','' FROM DUAL
UNION ALL
SELECT 'EVWF','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EVWF','99','Outros' FROM DUAL
);

/*-- SEQ 7982 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5586,
       'CLI ',
       'EVWF',
       '0N',
       '01',
       '',
       '',
       'cli.filcli = evwf.filcli and
cli.codcli = evwf.codcli',
       '' FROM DUAL
UNION ALL
SELECT 5587,
       'USU ',
       'EVWF',
       '0N',
       '01',
       '',
       '',
       'usu.filcli = evwf.filusu and
usu.codcli = evwf.codusu',
       '' FROM DUAL
);

/*-- SEQ 7983 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EVWF',
       '01',
       10,
       1,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVWF',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Cliente',
       'Codigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVWF',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EVWF.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EVWF',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Usurio',
       'Codigo Usuario',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVWF',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVWF',
       '01',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data Operacao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVWF',
       '01',
       60,
       8,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descricao Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVWF',
       '01',
       70,
       10,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificao',
       'ID Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'EVWF',
       '01',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'EVWF',
       '01',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'EVWF',
       '01',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'EVWF',
       '01',
       110,
       4000,
       'MSGEVE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVWF',
       '01',
       120,
       1,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situacao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVWF',
       '01',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'EVWF',
       '01',
       140,
       12,
       'VLREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 7984 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EXD ',
       TO_NUMBER(null),
       'EXD ',
       'Doc. Exportao',
       'TW_EXTXDOC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7985 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EXD ','--','' FROM DUAL
UNION ALL
SELECT 'EXD ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EXD ','99','Outros' FROM DUAL
);

/*-- SEQ 7986 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EXD ',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'EXD ',
       '--',
       20,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'EXD ',
       '--',
       80,
       20,
       'DESTINO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Destino Exportao',
       'Destino da Exportao',
       '',
       'DESTINO',
       'F' FROM DUAL
UNION ALL
SELECT 'EXD ',
       '--',
       30,
       3,
       'FILORI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial de Origem',
       'Filial de Origem',
       'DFIL.CODFIL = EXD.FILORI(+)',
       'FILORI',
       'T' FROM DUAL
UNION ALL
SELECT 'EXD ',
       '--',
       40,
       14,
       'ID_EXD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Chave ID',
       'Chave ID',
       '',
       'ID_EXD',
       'F' FROM DUAL
UNION ALL
SELECT 'EXD ',
       '--',
       90,
       5,
       'ITEORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Item de Origem',
       'Nmeto Item de Origem',
       '',
       'ITEORI',
       'F' FROM DUAL
UNION ALL
SELECT 'EXD ',
       '--',
       50,
       3,
       'ORIGEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Origem da Exportao',
       'Origem da Exportao',
       '',
       'ORIGEM',
       'F' FROM DUAL
UNION ALL
SELECT 'EXD ',
       '--',
       100,
       2,
       'PARORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Parcela de Origem',
       'Nmeto da Parcela de Origem',
       '',
       'PARORI',
       'F' FROM DUAL
UNION ALL
SELECT 'EXD ',
       '--',
       60,
       10,
       'SEQORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Sequncia de Origem',
       'Sequncia de Origem',
       '',
       'SEQORI',
       'F' FROM DUAL
UNION ALL
SELECT 'EXD ',
       '--',
       70,
       1,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao ',
       'Situao ',
       '',
       'STATUS',
       'T' FROM DUAL
UNION ALL
SELECT 'EXD ',
       '--',
       110,
       2,
       'SUBORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parc de Origem',
       'Nmeto da Sub-Parcela de Origem',
       '',
       'SUBORI',
       'F' FROM DUAL
);

/*-- SEQ 7987 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'EXD ',
       'STATUS',
       0,
       'A',
       'Aguardando Processamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EXD ',
       'STATUS',
       0,
       'E',
       'Exportado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'EXD ',
       'STATUS',
       0,
       'P',
       'Em Processamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 7988 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EXP ',
       TO_NUMBER(null),
       'EXP ',
       'Horas de Expediente',
       'TT_EXP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'EXP.CODFIL,EXP.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 7989 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EXP ','--','' FROM DUAL
UNION ALL
SELECT 'EXP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EXP ','99','Outros' FROM DUAL
);

/*-- SEQ 7990 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EXP ',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = EXP.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'EXP ',
       '--',
       20,
       1,
       'DIASEM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dia da Semana',
       'Dia da Semana',
       '',
       'DIASEM',
       'F' FROM DUAL
UNION ALL
SELECT 'EXP ',
       '--',
       30,
       4,
       'HORFIM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Hora Fim',
       'Hora Fim',
       '',
       'HORFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'EXP ',
       '--',
       40,
       4,
       'HORINI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Hora Inicio',
       'Hora Inicio',
       '',
       'HORINI',
       'F' FROM DUAL
UNION ALL
SELECT 'EXP ',
       '--',
       50,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 7991 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'EXT ',
       TO_NUMBER(null),
       'EXT ',
       'Extratos',
       'TT_EXT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 7992 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'EXT ','--','' FROM DUAL
UNION ALL
SELECT 'EXT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'EXT ','99','Outros' FROM DUAL
);

/*-- SEQ 7993 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5591,
       'CTB ',
       'EXT ',
       '1 ',
       '0N',
       '',
       '',
       'CTB.FILCTA = EXT.CODFIL(+) AND
CTB.SEQCTA = EXT.SEQUEN(+) AND
CTB.TIPCTA = EXT.TIPCTA(+) AND
CTB.CTACTB = EXT.USOCTA(+)',
       '' FROM DUAL
);

/*-- SEQ 7994 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'EXT ',
       '--',
       10,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Banco',
       'Cdigo do Banco',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'EXT ',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = EXT.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'EXT ',
       '--',
       40,
       10,
       'CTACRR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm. Conta Corrente',
       'Nmero da Conta Corrente',
       '',
       'CTACRR',
       'F' FROM DUAL
UNION ALL
SELECT 'EXT ',
       '--',
       50,
       7,
       'DATEXT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Extrato',
       'Data Extrato',
       '',
       'DATEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'EXT ',
       '--',
       60,
       7,
       'DATINI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incio',
       'Data Incio',
       '',
       'DATINI',
       'F' FROM DUAL
UNION ALL
SELECT 'EXT ',
       '--',
       80,
       10,
       'GRUARQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Grupo Arquivo',
       'Grupo Arquivo',
       '',
       'GRUARQ',
       'F' FROM DUAL
UNION ALL
SELECT 'EXT ',
       '--',
       90,
       255,
       'NOMARQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Arquivo',
       'Nome Arquivo',
       '',
       'NOMARQ',
       'F' FROM DUAL
UNION ALL
SELECT 'EXT ',
       '--',
       100,
       5,
       'NUMAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Numero Agencia',
       'Numero da Agncia',
       '',
       'NUMAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'EXT ',
       '--',
       140,
       16,
       'VLRINI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Inicial',
       'Valor Inicial',
       '',
       'VLRINI',
       'F' FROM DUAL
);

/*-- SEQ 7995 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'FAT ',
       0,
       'FAT ',
       'Faturas',
       'TV_FAT',
       'T',
       '',
       'TOTALL',
       'Fatura de Venda',
       '',
       '',
       '',
       '',
       'F',
       '',
       'CLI.ID,FAT.CODFIL,FAT.NUMECF',
       '' FROM DUAL
);

/*-- SEQ 7996 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'FAT ','--','' FROM DUAL
UNION ALL
SELECT 'FAT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'FAT ','02','Valores' FROM DUAL
UNION ALL
SELECT 'FAT ','99','Outros' FROM DUAL
);

/*-- SEQ 7997 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21517,
       'ECOB',
       'FAT ',
       '1',
       'N',
       '',
       '',
       'ECOB.FILCLI = FAT.FILCLI AND
ECOB.CODCLI = FAT.CODCLI AND
ECOB.CODFIL = FAT.FILCOB AND
ECOB.NUMEND = FAT.ENDCOB
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21518,
       'EFAT',
       'FAT ',
       '1',
       'N',
       '',
       '',
       'EFAT.FILCLI = FAT.FILCLI AND
EFAT.CODCLI = FAT.CODCLI AND
EFAT.CODFIL = FAT.FILFAT AND
EFAT.NUMEND = FAT.ENDFAT
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21519,
       'REC ',
       'FAT ',
       'N',
       '1',
       '',
       '',
       'REC.CODFIL = FAT.CODFIL and
REC.SEQUEN = FAT.SEQUEN',
       'REC.VLRPAR / FAT.VLRNOT',
       '' FROM DUAL
UNION ALL
SELECT 21520,
       'PLA ',
       'FAT ',
       '1',
       'N',
       '',
       '',
       'fat.filpgt = pla.filpgt and
fat.codpgt = pla.codpgt',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45923,
       'RECP',
       'FAT ',
       'N',
       '1',
       '',
       '',
       'RECP.ORI_CODFIL = FAT.CODFIL and
RECP.ORI_SEQUEN = FAT.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 7998 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'FAT ',
       '99',
       610,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'FAT ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FAT',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(FAT.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       380,
       4,
       'ANO_DATHOR',
       'A',
       '',
       0,
       0,
       'FAT ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FAT',
       '',
       'N',
       'T',
       'Ano~Incluso',
       'Ano de Data e hora da operao de incluso',
       '',
       'TO_CHAR(FAT.DATHOR,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       640,
       4,
       'ANO_PROPGT',
       'A',
       '',
       0,
       0,
       'FAT ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FAT',
       '',
       'N',
       'T',
       'Ano de Prox. Pagamen',
       'Ano de Data prximo pagamento ou data do cancelamento',
       '',
       'TO_CHAR(FAT.PROPGT,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       590,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'FAT ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FAT',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       580,
       1,
       'AUTENT',
       'L',
       '',
       0,
       0,
       'FAT ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'FAT',
       'F',
       '',
       'T',
       'Autenticada?',
       'Indica se a fatura j foi autenticada',
       '',
       'AUTENT',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       350,
       6,
       'CODCLI',
       'A',
       '',
       0,
       0,
       'FAT ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FAT',
       'F',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       290,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       0,
       'FAT ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'FAT',
       'F',
       'A',
       'T',
       'Filial',
       'Cdigo da filial',
       'FAT.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       70,
       6,
       'CODGUI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Guia',
       'Cdigo do Guia',
       '',
       'CODGUI',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '02',
       40,
       2,
       'CODNAT',
       'S',
       'DNAT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DNAT.NATURE',
       'V',
       '',
       'F',
       'A',
       'F',
       'Natureza',
       'Natureza de operao',
       'FAT.CODNAT = DNAT.CODTAB (+)',
       'CODNAT',
       'T' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       530,
       3,
       'CODPGT',
       'A',
       'PLA ',
       0,
       0,
       'FAT ',
       40,
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       'FAT',
       'F',
       'A',
       'T',
       'Plano',
       'Cdigo do plano de pagamento',
       'FAT.FILPGT = PLA.FILPGT and FAT.CODPGT = PLA.CODPGT',
       'CODPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       570,
       2,
       'CODPRE',
       'S',
       'TPR ',
       0,
       0,
       'FAT ',
       100,
       TO_NUMBER(null),
       '',
       'TPR.DESPRE',
       'V',
       'FAT',
       'F',
       'A',
       'T',
       'Tabela de Preos',
       'Cdigo da tabela de preos',
       'FAT.FILPRE=TPR.CODFIL (+) and FAT.CODPRE=TPR.CODPRE (+)',
       'CODPRE',
       'T' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       310,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       0,
       'FAT ',
       30,
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       'FAT',
       'F',
       'A',
       'T',
       'Srie',
       'Cdigo da srie',
       'FAT.CODSER=DSER.CODSER (+)',
       'CODSER',
       'T' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       210,
       6,
       'CODTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo da Transporta',
       'Cdigo da Transportadora',
       '',
       'CODTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       510,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       0,
       'FAT ',
       20,
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       'FAT',
       'F',
       'A',
       'T',
       'Usurio',
       'Cdigo do usurio',
       'FAT.FILUSU = USU.FILUSU(+)  and FAT.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       550,
       3,
       'CODVEN',
       'A',
       'VDD ',
       0,
       TO_NUMBER(null),
       '',
       60,
       TO_NUMBER(null),
       '',
       'VDD.APEUSU',
       'V',
       '',
       'F',
       'A',
       'T',
       'Vendedor',
       'Vendedor',
       'FAT.FILVEN = VDD.FILUSU (+)  and FAT.CODVEN = VDD.CODUSU (+)',
       'CODVEN',
       'T' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '02',
       30,
       5,
       'COMSOB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Comisso Sobre',
       'Comisso sobre ... (ver tela do plano)',
       '',
       'COMSOB',
       'T' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       360,
       8,
       'DATHOR',
       '@',
       '',
       0,
       0,
       'FAT ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FAT',
       'F',
       '@',
       'T',
       'Data~Incluso',
       'Data e hora da operao de incluso',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       80,
       7,
       'DATSAI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Sada',
       'Data Sada',
       '',
       'DATSAI',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       621,
       8,
       'DAT_QUITACAO',
       'D',
       '',
       0,
       0,
       'FAT ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'T',
       'Data~Quitao',
       'Data da quitao da venda/fatura',
       '',
       '(SELECT MAX(REC.PAGAME) FROM TT_REC REC WHERE REC.CODFIL = FAT.CODFIL AND REC.SEQUEN = FAT.SEQUEN)',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '02',
       460,
       8,
       'DESCON',
       'F',
       '',
       2,
       0,
       'FAT ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FAT',
       'T',
       '9',
       'T',
       'Desc/Acrscimo',
       'Valor do desconto / acrscimo',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       330,
       13,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Documento',
       'Documento (Srie + Sub-Srie + Nmero )',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       410,
       1,
       'EMIDES',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Frete Dest./Terc.?',
       'Frete  por conta do Destinatrio ou de Terceiros?',
       '',
       'EMIDES',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       400,
       4,
       'ENDCOB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Endereo de Cobrana',
       'Endereo de Cobrana',
       '',
       'ENDCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       270,
       4,
       'ENDENT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Endereo de Entrega',
       'Endereo de Entrega',
       '',
       'ENDENT',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       250,
       4,
       'ENDFAT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Endereo de Fatura',
       'Endereo de Fatura',
       '',
       'ENDFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '02',
       50,
       5,
       'ESPECI',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Especificao',
       'Especificao',
       '',
       'ESPECI',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       340,
       3,
       'FILCLI',
       'A',
       '',
       0,
       0,
       'FAT ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FAT',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       280,
       3,
       'FILCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial de Cobrana',
       '',
       'FILCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       260,
       3,
       'FILENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial de Entrega',
       '',
       'FILENT',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       240,
       3,
       'FILFAT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Fatura',
       'DFIL.CODFIL = FAT.FILFAT',
       'FILFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       60,
       3,
       'FILGUI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Guia',
       '',
       'FILGUI',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       520,
       3,
       'FILPGT',
       'A',
       '',
       0,
       0,
       'FAT ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FAT',
       'F',
       'N',
       'F',
       '',
       'Filial do plano de pagamento',
       '',
       'FILPGT',
       'T' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       480,
       3,
       'FILPRE',
       'A',
       '',
       0,
       0,
       'FAT ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FAT',
       'F',
       'N',
       'F',
       '',
       'Filial onde a tabela de preos foi criada',
       '',
       'FILPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       200,
       3,
       'FILTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Transportadora',
       '',
       'FILTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       500,
       3,
       'FILUSU',
       'A',
       '',
       0,
       0,
       'FAT ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FAT',
       'F',
       'N',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       540,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do vendedor',
       '',
       'FILVEN',
       'T' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       150,
       1,
       'FINANC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Financiado?',
       'Financiado?',
       '',
       'FINANC',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       390,
       1,
       'FLGEST',
       'A',
       '',
       0,
       0,
       'FAT ',
       90,
       30,
       '',
       '',
       'D',
       'FAT',
       'F',
       'A',
       'T',
       'Situao',
       'Estado (Cancelada, Quitada Em aberto)',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       100,
       5,
       'MARCAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Marcas',
       'Marcas',
       '',
       'MARCAS',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       600,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'FAT ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FAT',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(FAT.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       370,
       2,
       'MES_DATHOR',
       'A',
       '',
       0,
       0,
       'FAT ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FAT',
       '',
       'N',
       'T',
       'Ms~Incluso',
       'Ms de Data e hora da operao de incluso',
       '',
       'TO_CHAR(FAT.DATHOR,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       630,
       2,
       'MES_PROPGT',
       'A',
       '',
       0,
       0,
       'FAT ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FAT',
       '',
       'N',
       'T',
       'Ms de Prox. Pagamen',
       'Ms de Data prximo pagamento ou data do cancelamento',
       '',
       'TO_CHAR(FAT.PROPGT,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       470,
       2,
       'NROIMP',
       'S',
       '',
       0,
       0,
       'FAT ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FAT',
       'F',
       '9',
       'T',
       'Nm. Impresses',
       'Nmero de vezes que a fatura foi impressa',
       '',
       'NROIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       650,
       10,
       'NUMCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Conhecimento',
       'Conhecimento de frete',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       300,
       3,
       'NUMECF',
       'A',
       '',
       0,
       0,
       'FAT ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FAT',
       'F',
       '0',
       'T',
       'ECF',
       'Nmero do ECF',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       320,
       6,
       'NUMNOT',
       'A',
       '',
       0,
       0,
       'FAT ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FAT',
       'F',
       '9',
       'T',
       'Nmero',
       'Nmero da fatura',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '02',
       90,
       12,
       'NUMVOL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Num.Volume',
       'Numero de Volumes',
       '',
       'NUMVOL',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       490,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'FAT ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'FAT',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(FAT.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '02',
       10,
       12,
       'PERCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Comisso Parcelas',
       'Percentual de comisso no geral',
       '',
       'PERCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '02',
       20,
       12,
       'PERENT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Comisso Entrada',
       'Percentual de comisso na entrada',
       '',
       'PERENT',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '02',
       130,
       14,
       'PESBRU',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Peso Bruto',
       'Peso Bruto',
       '',
       'PESBRU',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '02',
       140,
       14,
       'PESLIQ',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Peso Lquido',
       'Peso Lquido',
       '',
       'PESLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '02',
       450,
       2,
       'PRAMED',
       'S',
       '',
       0,
       0,
       'FAT ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FAT',
       'F',
       '9',
       'T',
       'Prazo Mdio',
       'Prazo mdio',
       '',
       'PRAMED',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       620,
       8,
       'PROPGT',
       'D',
       '',
       0,
       0,
       'FAT ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FAT',
       'F',
       'D',
       'T',
       'Prox. Pagamento',
       'Data prximo pagamento ou data do cancelamento',
       '',
       'PROPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       170,
       10,
       'SEQFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador de Fatura',
       '',
       'SEQFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       180,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       560,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'FAT ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'FAT',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN FAT.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       561,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN FAT.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '02',
       420,
       8,
       'SINAL',
       'F',
       '',
       2,
       0,
       'FAT ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FAT',
       'T',
       '9',
       'T',
       'Sinal',
       'Valor de sinal relacionado',
       '',
       'SINAL',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       660,
       15,
       'SITUACAO_FATURA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Situao Fatura',
       'Situao Fatura',
       '',
       '(CASE WHEN REC.DATVEN < AGORA THEN ''VENCIDAS'' ELSE ''A VENCER''
END)',
       '' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       220,
       1,
       'TIPNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Nota',
       'Tipo de Nota',
       '',
       'TIPNOT',
       'T' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '01',
       230,
       1,
       'TIPTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Transportadora',
       'Tipo Transportadora',
       '',
       'TIPTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '99',
       160,
       1,
       'TRIBUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tributado?',
       'Tributado?',
       '',
       'TRIBUT',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '02',
       120,
       12,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor do Frete',
       'Valor do Frete',
       '',
       'VLRFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '02',
       440,
       8,
       'VLRLIQ',
       'F',
       '',
       2,
       0,
       'FAT ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FAT',
       'T',
       '9',
       'T',
       'Valor Lquido',
       'Valor lquido da fatura',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '02',
       430,
       8,
       'VLRNOT',
       'F',
       '',
       2,
       0,
       'FAT ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FAT',
       'T',
       '9',
       'T',
       'Valor Bruto',
       'Valor da fatura',
       '',
       'VLRNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'FAT ',
       '02',
       110,
       12,
       'VLRSEG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor do Seguro',
       'Valor do Seguro',
       '',
       'VLRSEG',
       'F' FROM DUAL
);

/*-- SEQ 7999 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'FAT ',
       'FLGEST',
       0,
       'A',
       'Em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FAT ',
       'FLGEST',
       0,
       'C',
       'Cancelada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FAT ',
       'FLGEST',
       0,
       'I',
       'Inconsistente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FAT ',
       'FLGEST',
       0,
       'Q',
       'Quitada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FAT ',
       'FLGEST',
       0,
       'T',
       'Protestado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FAT ',
       'TIPNOT',
       0,
       'A',
       'Ambas (NFF)',
       279,
       ' ' FROM DUAL
UNION ALL
SELECT 'FAT ',
       'TIPNOT',
       0,
       'F',
       'Fatura',
       277,
       ' ' FROM DUAL
UNION ALL
SELECT 'FAT ',
       'TIPNOT',
       0,
       'N',
       'Nota Fiscal',
       278,
       ' ' FROM DUAL
);

/*-- SEQ 8000 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'FCM ',
       0,
       'FCM ',
       'Fatura de Compras',
       'TV_FCM',
       'T',
       '',
       'TOTALL',
       'Fatura de Compra',
       '',
       '',
       '',
       '',
       'F',
       '',
       'PDV.ID,FCM.CODFIL,FCM.CODSER,FCM.NUMNOT',
       '' FROM DUAL
);

/*-- SEQ 8001 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'FCM ','--','' FROM DUAL
UNION ALL
SELECT 'FCM ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'FCM ','03','Valores' FROM DUAL
UNION ALL
SELECT 'FCM ','05','Juros e Multas' FROM DUAL
UNION ALL
SELECT 'FCM ','99','Outros' FROM DUAL
);

/*-- SEQ 8002 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21521,
       'VFOR',
       'FCM ',
       '1',
       'N',
       '',
       '',
       'FCM.FILFOR = VFOR.FILCLI AND
FCM.CODFOR = VFOR.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21522,
       'PVD ',
       'FCM ',
       '1',
       'N',
       '',
       '',
       'PVD.FILPAR = FCM.FILFOR and
PVD.CODPAR = FCM.CODFOR and
PVD.TIPPAR = FCM.TIPPAR',
       '',
       '' FROM DUAL
);

/*-- SEQ 8003 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'FCM ',
       '01',
       85,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'FCM ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FCM',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(FCM.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '01',
       65,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       0,
       'FCM ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FCM',
       '',
       'N',
       'T',
       'Ano de Data Lanto',
       'Ano de Data da operao',
       '',
       'TO_CHAR(FCM.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '01',
       80,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'FCM ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FCM',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       0,
       'FCM ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'FCM',
       'F',
       'A',
       'T',
       'Filial',
       'Cdigo da Filial de Origem',
       'FCM.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '01',
       30,
       6,
       'CODFOR',
       'A',
       '',
       0,
       0,
       'FCM ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FCM',
       'F',
       '9',
       'F',
       'Cdigo do Fornecedor',
       'Cdigo do fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '03',
       50,
       2,
       'CODMOE',
       'S',
       'DMOE',
       0,
       0,
       'FCM ',
       50,
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       'FCM',
       'F',
       'A',
       'T',
       'Moeda',
       'Cdigo da moeda',
       'FCM.CODMOE=DMOE.CODTAB (+)',
       'CODMOE',
       'T' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '01',
       40,
       2,
       'CODSER',
       'A',
       '',
       0,
       0,
       'FCM ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'FCM',
       'F',
       'A',
       'T',
       'Srie',
       'Cdigo da srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '99',
       20,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       0,
       'FCM ',
       20,
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       'FCM',
       'F',
       'A',
       'T',
       'Usurio',
       'Cdigo do usurio',
       'FCM.FILUSU = USU.FILUSU(+)  and FCM.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '03',
       60,
       10,
       'CONPGT',
       'A',
       '',
       0,
       0,
       'FCM ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'FCM',
       'F',
       'A',
       'T',
       'Cond. Pagto.',
       'Condio de Pagamento',
       '',
       'CONPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '99',
       11,
       8,
       'DATCMP',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Compra',
       'Data da compra',
       '',
       'DATCMP',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '01',
       60,
       8,
       'DATOPE',
       '@',
       '',
       0,
       0,
       'FCM ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FCM',
       'F',
       '@',
       'T',
       'Data Lanto',
       'Data da operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '03',
       30,
       8,
       'DESCON',
       'F',
       '',
       2,
       0,
       'FCM ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FCM',
       'T',
       '9',
       'T',
       'Desconto',
       'Desconto',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '01',
       55,
       13,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       70,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Documento',
       'Documento (Srie + Sub-Srie + Nmero )',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '99',
       50,
       3,
       'ESPDOC',
       'A',
       '',
       0,
       0,
       'FCM ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'FCM',
       'F',
       'A',
       'T',
       'Espcie Docto',
       'Espcie de Documento',
       '',
       'ESPDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '01',
       20,
       3,
       'FILFOR',
       'A',
       '',
       0,
       0,
       'FCM ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FCM',
       'F',
       'N',
       'F',
       '',
       'Filial do fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '99',
       10,
       3,
       'FILUSU',
       'A',
       '',
       0,
       0,
       'FCM ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FCM',
       'F',
       'N',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '01',
       70,
       1,
       'FLGEST',
       'A',
       '',
       0,
       0,
       'FCM ',
       90,
       30,
       '',
       '',
       'D',
       'FCM',
       'F',
       'A',
       'T',
       'Situao',
       'Situao (Devolvida/Quitada/Em aberto)',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '05',
       20,
       1,
       'INCOJU',
       'A',
       '',
       0,
       0,
       'FCM ',
       20,
       30,
       '',
       '',
       'D',
       'FCM',
       'F',
       'A',
       'T',
       'Correo em',
       'Indicador do tipo de correo de juros',
       '',
       'INCOJU',
       'T' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '05',
       30,
       1,
       'INTPJU',
       'A',
       '',
       0,
       0,
       'FCM ',
       30,
       30,
       '',
       '',
       'D',
       'FCM',
       'F',
       'A',
       'T',
       'Tipo Juros',
       'Indicador do tipo de juros',
       '',
       'INTPJU',
       'T' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '05',
       50,
       1,
       'INTPMU',
       'A',
       '',
       0,
       0,
       'FCM ',
       50,
       30,
       '',
       '',
       'D',
       'FCM',
       'F',
       'A',
       'T',
       'Tipo Multa',
       'Indicador do tipo de multa',
       '',
       'INTPMU',
       'T' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '01',
       83,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'FCM ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FCM',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(FCM.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '01',
       63,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       0,
       'FCM ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FCM',
       '',
       'N',
       'T',
       'Ms de Data Lanto',
       'Ms de Data da operao',
       '',
       'TO_CHAR(FCM.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '01',
       31,
       2,
       'MOEJUR',
       'S',
       'DMOE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       '',
       'F',
       'A',
       'F',
       'Moeda Correo',
       'Moeda da Correo',
       'FCM.MOEJUR=DMOE.CODTAB (+)',
       'MOEJUR',
       'T' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '99',
       40,
       12,
       'NATURE',
       'A',
       '',
       0,
       0,
       'FCM ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'FCM',
       'F',
       '9',
       'T',
       'Natureza',
       'Natureza',
       '',
       'NATURE',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '99',
       14,
       0,
       'NOTESP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Nota Especial?',
       'Nota Especial',
       '',
       'NOTESP',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '01',
       50,
       8,
       'NUMNOT',
       'A',
       '',
       0,
       0,
       'FCM ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FCM',
       'F',
       '9',
       'T',
       'Nmero',
       'Nmero da fatura',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '99',
       30,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'FCM ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'FCM',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(FCM.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '03',
       20,
       8,
       'OUTTAX',
       'F',
       '',
       2,
       0,
       'FCM ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FCM',
       'T',
       '9',
       'T',
       'Outras Taxas',
       'Outras taxas',
       '',
       'OUTTAX',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '03',
       12,
       12,
       'QTDTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Quantidade Total',
       'Quantidade Total',
       '',
       'QTDTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '99',
       36,
       10,
       'SEQCAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Cancelamento',
       '',
       'SEQCAN',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '99',
       32,
       10,
       'SEQFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Fatura',
       '',
       'SEQFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '99',
       33,
       10,
       'SEQFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Frete',
       '',
       'SEQFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '99',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '99',
       60,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'FCM ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'FCM',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN FCM.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '99',
       61,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN FCM.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '01',
       45,
       3,
       'SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Sub-Srie',
       'Sub-Srie',
       '',
       'SUBSER',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '01',
       34,
       1,
       'TIPNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Nota',
       'Tipo de Nota',
       '',
       'TIPNOT',
       'T' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '01',
       35,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Parceiro',
       'Tipo de Parceiro',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '03',
       40,
       8,
       'VLRLIQ',
       'F',
       '',
       2,
       0,
       'FCM ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FCM',
       'T',
       '9',
       'T',
       'Valor Lquido',
       'Valor lquido',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '03',
       10,
       8,
       'VLRTOT',
       'F',
       '',
       2,
       0,
       'FCM ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FCM',
       'T',
       '9',
       'T',
       'Valor Total',
       'Valor total',
       '',
       'VLRTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '05',
       10,
       8,
       'VLTXJU',
       'F',
       '',
       2,
       0,
       'FCM ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FCM',
       'T',
       '9',
       'T',
       'Juros',
       'Valor ou taxa de juros',
       '',
       'VLTXJU',
       'F' FROM DUAL
UNION ALL
SELECT 'FCM ',
       '05',
       40,
       8,
       'VLTXMU',
       'F',
       '',
       2,
       0,
       'FCM ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FCM',
       'T',
       '9',
       'T',
       'Multa',
       'Valor ou taxa de multa',
       '',
       'VLTXMU',
       'F' FROM DUAL
);

/*-- SEQ 8004 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'FCM ',
       'FLGEST',
       0,
       'A',
       'Em Aberto',
       33,
       ' ' FROM DUAL
UNION ALL
SELECT 'FCM ',
       'FLGEST',
       0,
       'D',
       'Devolvida',
       31,
       ' ' FROM DUAL
UNION ALL
SELECT 'FCM ',
       'FLGEST',
       0,
       'Q',
       'Quitada',
       32,
       ' ' FROM DUAL
UNION ALL
SELECT 'FCM ',
       'INCOJU',
       0,
       '$',
       'Moeda',
       37,
       ' ' FROM DUAL
UNION ALL
SELECT 'FCM ',
       'INCOJU',
       0,
       '0',
       'Nao h',
       38,
       ' ' FROM DUAL
UNION ALL
SELECT 'FCM ',
       'INCOJU',
       0,
       'A',
       'Anual',
       36,
       ' ' FROM DUAL
UNION ALL
SELECT 'FCM ',
       'INCOJU',
       0,
       'D',
       'Diria',
       34,
       ' ' FROM DUAL
UNION ALL
SELECT 'FCM ',
       'INCOJU',
       0,
       'M',
       'Mensal',
       35,
       ' ' FROM DUAL
UNION ALL
SELECT 'FCM ',
       'INTPJU',
       0,
       'C',
       'Composto',
       40,
       ' ' FROM DUAL
UNION ALL
SELECT 'FCM ',
       'INTPJU',
       0,
       'F',
       'Fixo',
       41,
       ' ' FROM DUAL
UNION ALL
SELECT 'FCM ',
       'INTPJU',
       0,
       'S',
       'Simples',
       39,
       ' ' FROM DUAL
UNION ALL
SELECT 'FCM ',
       'INTPMU',
       0,
       '$',
       'Valor',
       43,
       ' ' FROM DUAL
UNION ALL
SELECT 'FCM ',
       'INTPMU',
       0,
       '%',
       'Percentual',
       42,
       ' ' FROM DUAL
UNION ALL
SELECT 'FCM ',
       'TIPNOT',
       0,
       'A',
       'Ambas (NFF)',
       279,
       ' ' FROM DUAL
UNION ALL
SELECT 'FCM ',
       'TIPNOT',
       0,
       'F',
       'Fatura',
       277,
       ' ' FROM DUAL
UNION ALL
SELECT 'FCM ',
       'TIPNOT',
       0,
       'N',
       'Nota Fiscal',
       278,
       ' ' FROM DUAL
UNION ALL
SELECT 'FCM ',
       'TIPPAR',
       0,
       'F',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FCM ',
       'TIPPAR',
       0,
       'T',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8005 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'FCP ',
       TO_NUMBER(null),
       'FCP ',
       'Fechamento de Pista',
       'TT_FCP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8006 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'FCP ','--','' FROM DUAL
UNION ALL
SELECT 'FCP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'FCP ','99','Outros' FROM DUAL
);

/*-- SEQ 8007 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 15539,
       'MDT ',
       'FCP ',
       '1 ',
       '0N',
       '',
       '',
       'MDT.CODFIL = FCP.FILMED(+) AND
MDT.NUMTAN = FCP.TANMED(+) AND
MDT.DATMED = FCP.DATMED(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8008 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'FCP ',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Atualizado Em',
       'Atualizado Em',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'FCP ',
       '--',
       20,
       5,
       'CODBIC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo do Bico',
       'Cdigo do Bico',
       '',
       'CODBIC',
       'F' FROM DUAL
UNION ALL
SELECT 'FCP ',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = FCP.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'FCP ',
       '--',
       40,
       3,
       'CODLEI',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Usurio Leitura',
       'Usurio Leitura',
       'FCP.FILLEI = USU.FILUSU(+)  AND FCP.CODLEI = USU.CODUSU(+)',
       'CODLEI',
       'T' FROM DUAL
UNION ALL
SELECT 'FCP ',
       '--',
       50,
       3,
       'CODREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd.Usurio Registro',
       'Cdigo Usurio Registro',
       '',
       'CODREG',
       'F' FROM DUAL
UNION ALL
SELECT 'FCP ',
       '--',
       60,
       7,
       'DATFEC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fechamento',
       'Data Fechamento',
       '',
       'DATFEC',
       'F' FROM DUAL
UNION ALL
SELECT 'FCP ',
       '--',
       70,
       7,
       'DATMED',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Medio',
       'Data Medio',
       '',
       'DATMED',
       'F' FROM DUAL
UNION ALL
SELECT 'FCP ',
       '--',
       80,
       7,
       'DATREG',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Registro',
       'Data Registro',
       '',
       'DATREG',
       'F' FROM DUAL
UNION ALL
SELECT 'FCP ',
       '--',
       150,
       10,
       'ENCMAN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Encerrante Manual',
       'Encerrante Manual',
       '',
       'ENCMAN',
       '' FROM DUAL
UNION ALL
SELECT 'FCP ',
       '--',
       90,
       3,
       'FILLEI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Usu. Leitura',
       'Filial Usurio Leitura',
       '',
       'FILLEI',
       'F' FROM DUAL
UNION ALL
SELECT 'FCP ',
       '--',
       100,
       3,
       'FILMED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Medio',
       'Filial Medio',
       '',
       'FILMED',
       'F' FROM DUAL
UNION ALL
SELECT 'FCP ',
       '--',
       110,
       3,
       'FILREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Usu. Registro',
       'Filial Usurio Registro',
       '',
       'FILREG',
       'F' FROM DUAL
UNION ALL
SELECT 'FCP ',
       '--',
       120,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'FCP ',
       '--',
       130,
       5,
       'TANMED',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tanque Medio',
       'Tanque Medio',
       '',
       'TANMED',
       'F' FROM DUAL
UNION ALL
SELECT 'FCP ',
       '--',
       140,
       10,
       'VLRENC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Encerrante',
       'Valor Encerrante',
       '',
       'VLRENC',
       'F' FROM DUAL
);

/*-- SEQ 8009 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'FDF ',
       TO_NUMBER(null),
       'FDF ',
       'Faixa Desc. Faturam.',
       'TT_FDF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8010 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'FDF ','--','' FROM DUAL
UNION ALL
SELECT 'FDF ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'FDF ','99','Outros' FROM DUAL
);

/*-- SEQ 8011 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'FDF ',
       '01',
       10,
       12,
       'ATEVLR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'At Valor',
       'At Valor maior ou igual a 0',
       '',
       'ATEVLR',
       'F' FROM DUAL
UNION ALL
SELECT 'FDF ',
       '01',
       20,
       5,
       'DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Faixa de Desconto',
       'Faixa de Desconto(0 at 100)',
       '',
       'DESCON',
       'F' FROM DUAL
);

/*-- SEQ 8012 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'FER ',
       TO_NUMBER(null),
       'FER ',
       'Feriados',
       'TT_FER',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'FER.CODFIL,FER.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8013 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'FER ','--','' FROM DUAL
UNION ALL
SELECT 'FER ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'FER ','99','Outros' FROM DUAL
);

/*-- SEQ 8014 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'FER ',
       '01',
       10,
       4,
       'ANOFER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ano Feriado',
       'Ano Feriado',
       '',
       'ANOFER',
       'F' FROM DUAL
UNION ALL
SELECT 'FER ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = FER.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'FER ',
       '01',
       30,
       2,
       'DIAFER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dia Feriado',
       'Dia Feriado',
       '',
       'DIAFER',
       'F' FROM DUAL
UNION ALL
SELECT 'FER ',
       '01',
       70,
       3,
       'FILFER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Feriado',
       'Filial Feriado',
       '',
       'FILFER',
       'F' FROM DUAL
UNION ALL
SELECT 'FER ',
       '01',
       80,
       1,
       'LOJABR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Loja Abre?',
       'Loja Abre?',
       '',
       'LOJABR',
       '' FROM DUAL
UNION ALL
SELECT 'FER ',
       '01',
       40,
       2,
       'MESFER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Mes Feriado',
       'Mes Feriado',
       '',
       'MESFER',
       'F' FROM DUAL
UNION ALL
SELECT 'FER ',
       '01',
       50,
       100,
       'MOTIVO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo',
       'Motivo',
       '',
       'MOTIVO',
       'F' FROM DUAL
UNION ALL
SELECT 'FER ',
       '01',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8015 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'FG74',
       TO_NUMBER(null),
       'FG74',
       'FiscaI Ger. 74',
       'TV_FIS_GER_74',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8016 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'FG74','--','' FROM DUAL
UNION ALL
SELECT 'FG74','01','Identificao' FROM DUAL
UNION ALL
SELECT 'FG74','99','Outros' FROM DUAL
);

/*-- SEQ 8017 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'FG74',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'FG74',
       '01',
       20,
       126,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
);

/*-- SEQ 8018 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'FID ',
       TO_NUMBER(null),
       'FID ',
       'Inf. Int. Fidelidade',
       'TT_FID',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8019 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'FID ','--','' FROM DUAL
UNION ALL
SELECT 'FID ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'FID ','99','Outros' FROM DUAL
);

/*-- SEQ 8020 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20784,
       'VEN ',
       'FID ',
       '01',
       '01',
       '',
       '',
       'VEN.CODFIL = FID.CODFIL(+) AND
VEN.NUMECF = FID.NUMECF(+) AND
VEN.TRN_ID = FID.TRN_ID(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20785,
       'LID ',
       'FID ',
       '01',
       '01',
       '',
       '',
       'LID.CODFIL = FID.CODFIL(+) AND
LID.NUMECF = FID.NUMECF(+) AND
LID.TRN_ID = FID.TRN_ID(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8021 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'FID ',
       '99',
       100,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data de Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'FID ',
       '01',
       20,
       14,
       'CGCFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'CNPJ Filial',
       'CNPJ da Filial',
       '',
       'CGCFIL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'FID ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Cod. da Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = FID.CODFIL(+)',
       'CODFIL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'FID ',
       '99',
       190,
       7,
       'DATCAN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data do Cancelamento',
       'Data do cancelamento da reserva',
       '',
       'DATCAN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'FID ',
       '99',
       180,
       7,
       'DATCON',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data da Confirmao',
       'Data da confirmao da reserva',
       '',
       'DATCON',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'FID ',
       '99',
       200,
       7,
       'DATDEV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data da Devoluo',
       'Data da devoluo da venda',
       '',
       'DATDEV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'FID ',
       '99',
       90,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data de Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'FID ',
       '99',
       170,
       7,
       'DATRES',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data da Reserva',
       'Data da realizao da reserva',
       '',
       'DATRES',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'FID ',
       '99',
       210,
       100,
       'DESTAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Desc. Status Reserv.',
       'Descrio do Status da Reserva',
       '',
       'DESTAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'FID ',
       '99',
       110,
       1,
       'EXPORT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Flag de Exportao',
       'Fidelidade Exportada?',
       '',
       'EXPORT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'FID ',
       '01',
       10,
       12,
       'ID_TAB',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Ident. da Tabela',
       'Identificador da Tabela',
       '',
       'ID_TAB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'FID ',
       '01',
       40,
       14,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Num. do Documento',
       'Nmero do documento do Participante',
       '',
       'NUMDOC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'FID ',
       '01',
       60,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nmero de ECF',
       'Nmero de ECF',
       '',
       'NUMECF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'FID ',
       '99',
       220,
       1,
       'ORIPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Origem do Pedido',
       'Origem do Pedido',
       '',
       'ORIPED',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'FID ',
       '99',
       80,
       9,
       'PONTOS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Pontos de Fidelidade',
       'Pontos utilizados pela API de Fidelidade',
       '',
       'PONTOS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'FID ',
       '99',
       150,
       1,
       'RESCAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Reserva Cancelada',
       'Reserva de Fidelidade Cancelada?',
       '',
       'RESCAN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'FID ',
       '99',
       140,
       1,
       'RESCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Reserva Confirmada',
       'Reserva de Fidelidade Confirmada?',
       '',
       'RESCON',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'FID ',
       '99',
       130,
       1,
       'RESERV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Fidelidade Reservada',
       'Fidelidade Reservada?',
       '',
       'RESERV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'FID ',
       '99',
       230,
       2,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Status da Reserva',
       'Status da Reserva',
       '',
       'STATUS',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'FID ',
       '01',
       50,
       12,
       'TRN_ID',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Ident. da Transao',
       'Identificador da Transao',
       '',
       'TRN_ID',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'FID ',
       '99',
       160,
       1,
       'VENDEV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Devoluo de Venda',
       'Realizado devoluo da venda?',
       '',
       'VENDEV',
       '',
       'D' FROM DUAL
);

/*-- SEQ 8022 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'FID ',
       'ORIPED',
       0,
       'G',
       'GIMBA',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FID ',
       'ORIPED',
       0,
       'I',
       'INTRANET',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FID ',
       'ORIPED',
       0,
       'P',
       'PDV',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FID ',
       'STATUS',
       0,
       ' ',
       'Cancelamento em Andamento',
       TO_NUMBER(null),
       'CA' FROM DUAL
UNION ALL
SELECT 'FID ',
       'STATUS',
       0,
       ' ',
       'Cancelamento Realizado',
       TO_NUMBER(null),
       'CR' FROM DUAL
UNION ALL
SELECT 'FID ',
       'STATUS',
       0,
       ' ',
       'Confirmacao em Andamento',
       TO_NUMBER(null),
       'AA' FROM DUAL
UNION ALL
SELECT 'FID ',
       'STATUS',
       0,
       ' ',
       'Confirmacao Realizada',
       TO_NUMBER(null),
       'AR' FROM DUAL
UNION ALL
SELECT 'FID ',
       'STATUS',
       0,
       ' ',
       'Devolucao em Andamento',
       TO_NUMBER(null),
       'DA' FROM DUAL
UNION ALL
SELECT 'FID ',
       'STATUS',
       0,
       ' ',
       'Devolucao Realizada',
       TO_NUMBER(null),
       'DR' FROM DUAL
UNION ALL
SELECT 'FID ',
       'STATUS',
       0,
       ' ',
       'Reserva em Andamento',
       TO_NUMBER(null),
       'RA' FROM DUAL
UNION ALL
SELECT 'FID ',
       'STATUS',
       0,
       ' ',
       'Reserva Realizada',
       TO_NUMBER(null),
       'RR' FROM DUAL
);

/*-- SEQ 8023 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'FIL2',
       0,
       'FIL2',
       'Dom. Filiais',
       'TD_FIL',
       'F',
       '',
       'TOTALL',
       'Filiais',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8024 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'FIL2','--','' FROM DUAL
UNION ALL
SELECT 'FIL2','01','Identificao' FROM DUAL
);

/*-- SEQ 8025 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'FIL2',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       '',
       0,
       0,
       'DFIL',
       20,
       TO_NUMBER(null),
       '',
       '.',
       'I',
       'TAB',
       'F',
       'N',
       'T',
       'Filial',
       'Cdigo da filial',
       '. = FIL2.CODFIL',
       'CODFIL',
       'F' FROM DUAL
);

/*-- SEQ 8026 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'FXP ',
       TO_NUMBER(null),
       'FXP ',
       'Filial x Plano',
       'TT_FILXPLA',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8027 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'FXP ','--','' FROM DUAL
UNION ALL
SELECT 'FXP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'FXP ','99','Outros' FROM DUAL
);

/*-- SEQ 8028 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'FXP ',
       '--',
       50,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Atualizado em:',
       'Atualizado em:',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'FXP ',
       '--',
       10,
       3,
       'CODCTR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Unidade de negcios',
       'Cdigo Unidade de negcios',
       '',
       'CODCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'FXP ',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial do cadastro',
       'Filial do cadastro',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'FXP ',
       '--',
       60,
       3,
       'CODPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo plano',
       'Cdigo plano',
       '',
       'CODPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'FXP ',
       '--',
       70,
       3,
       'FILPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial plano',
       'Filial plano',
       '',
       'FILPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'FXP ',
       '--',
       30,
       3,
       'FILSEL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial Selecionada',
       'Filial Selecionada',
       '',
       'FILSEL',
       'F' FROM DUAL
UNION ALL
SELECT 'FXP ',
       '--',
       40,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8029 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'FIN ',
       TO_NUMBER(null),
       'FIN ',
       'Lan. Finan. Avulsos',
       'TT_FIN',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'FIN.CODFIL,FIN.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8030 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'FIN ','--','' FROM DUAL
UNION ALL
SELECT 'FIN ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'FIN ','02','Valores' FROM DUAL
UNION ALL
SELECT 'FIN ','03','Datas' FROM DUAL
UNION ALL
SELECT 'FIN ','08','Operaes de Caixa' FROM DUAL
UNION ALL
SELECT 'FIN ','99','Outros' FROM DUAL
);

/*-- SEQ 8031 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 29689,
       'LID ',
       'FIN ',
       '01',
       '0N',
       '',
       '',
       'FIN.CODFIL (+) = LID.CODFIL AND
FIN.NUMECF (+) = LID.NUMECF AND
FIN.TRN_ID (+) = LID.TRN_ID',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29688,
       'USU ',
       'FIN ',
       '1',
       'N',
       '',
       '',
       'USU.FILUSU = FIN.FILUSU AND
USU.CODUSU = FIN.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29685,
       'DECF',
       'FIN ',
       '01',
       '0N',
       '',
       '',
       'DECF.FILECF (+) = FIN.CODFIL AND 
DECF.NUMECF (+) = FIN.NUMECF',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29686,
       'CCRE',
       'FIN ',
       '1',
       '0N',
       '',
       '',
       'CCRE.CODFIL = FIN.FILGER AND
CCRE.SEQUEN = FIN.SEQGER AND
CCRE.TIPCTA = FIN.TIPGER',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29687,
       'CDEB',
       'FIN ',
       '1',
       '0N',
       '',
       '',
       'CDEB.CODFIL = FIN.FILNUM AND
CDEB.SEQUEN = FIN.SEQNUM AND
CDEB.TIPCTA = FIN.TIPNUM',
       '',
       '' FROM DUAL
);

/*-- SEQ 8032 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'FIN ',
       '01',
       94,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN FIN.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '03',
       26,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '99',
       93,
       5,
       'CHVTRANSFERENCIA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Chave Transferncias',
       'Chave de Transferncias Identificadas',
       '',
       'COALESCE(FIN.CHVTRN2, FIN.CHVTRN)',
       '' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '99',
       36,
       5,
       'CHVTRN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Chave de Transferncias Identificadas (gerado pelo Banco)',
       '',
       'CHVTRN',
       'F' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '99',
       92,
       5,
       'CHVTRN2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       'Chave de Transferncias Identificadas (gerada pela DLL)',
       '',
       'CHVTRN2',
       '' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '02',
       15,
       5,
       'CODCTR',
       'F',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       'F',
       'A',
       'F',
       'Unidade de Negcios',
       'Unidade de Negcios',
       'DCTR.CODTAB = FIN.CODCTR(+)',
       'CODCTR',
       'T' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '02',
       14,
       5,
       'CODCUS',
       'F',
       'DCUS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCUS.CENCUS',
       'V',
       '',
       'F',
       'A',
       'F',
       'Centro Custo',
       'Centro Custo',
       'DCUS.CODTAB = FIN.CODCUS',
       'CODCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '01',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = FIN.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '01',
       4,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo Usurio',
       'FIN.FILUSU = USU.FILUSU(+) AND FIN.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '01',
       140,
       3,
       'CODUSU_REC',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'A',
       '',
       'Usurio Recebimento',
       'Usurio que efetuou o recebimento',
       'FIN.FILUSU_REC = USU.FILUSU(+) AND FIN.CODUSU_REC = USU.CODUSU(+)',
       'CODUSU_REC',
       'T' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '03',
       66,
       7,
       'DATFIS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Fiscal',
       'Data Fiscal',
       '',
       'DATFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '03',
       160,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '03',
       5,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '01',
       150,
       8,
       'DATREC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data do Recebimento',
       'Data do Recebimento',
       '',
       'DATREC',
       '' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '01',
       120,
       20,
       'DOC_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'ID Documento',
       'Identificador do Documento',
       '',
       'DOC_ID',
       '' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '01',
       6,
       3,
       'FILGER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Gerencial',
       '',
       'FILGER',
       'F' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '01',
       9,
       3,
       'FILNUM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Nm.Lanament',
       'Filial nmero de lanamento Avulsos',
       '',
       'FILNUM',
       'F' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '01',
       3,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '01',
       130,
       3,
       'FILUSU_REC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       '',
       'Filial do Usurio que efetuou o recebimento',
       '',
       'FILUSU_REC',
       '' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '99',
       46,
       1,
       'FLGFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Flag Finan. Avulsos',
       'Flag Finan. Avulsos',
       '',
       'FLGFIN',
       'T' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '01',
       13,
       20,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '01',
       100,
       3,
       'NUMECF',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       '',
       'Nmero ECF',
       'Nmero ECF',
       'DECF.FILECF (+) = FIN.CODFIL AND DECF.NUMECF (+) = FIN.NUMECF',
       'NUMECF',
       'T' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '99',
       56,
       255,
       'OBSERV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '08',
       70,
       4000,
       'OPERACAOCAIXA',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Operao Caixa',
       'Operao Caixa',
       '',
       'RTF2TXT(RTRIM(SUBSTR(OPERACAOCAIXA(''FIN'',FIN.CODFIL,FIN.SEQUEN,NULL,NULL),1,50)))',
       '' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '01',
       91,
       1,
       'ORILAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Origem',
       'Origem do Lanamento Financeiro',
       '',
       'ORILAN',
       '' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '01',
       7,
       10,
       'SEQGER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Sequenciador Gerencial',
       '',
       'SEQGER',
       'F' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '01',
       10,
       10,
       'SEQNUM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador de Nmero',
       '',
       'SEQNUM',
       'F' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '01',
       16,
       10,
       'SEQTRN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador de Tranferncias Identiificadas',
       '',
       'SEQTRN',
       'F' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '01',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '01',
       90,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN FIN.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '01',
       8,
       1,
       'TIPGER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Gerencial',
       'Tipo Gerencial',
       '',
       'TIPGER',
       'T' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '01',
       11,
       1,
       'TIPNUM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Nmero',
       'Tipo Nmero',
       '',
       'TIPNUM',
       'T' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '01',
       110,
       12,
       'TRN_ID',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'ID Transao',
       'ID Transao',
       '',
       'TRN_ID',
       '' FROM DUAL
UNION ALL
SELECT 'FIN ',
       '02',
       12,
       12,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Movimentao',
       'Valor da Movimentao',
       '',
       'VLRMOV',
       'F' FROM DUAL
);

/*-- SEQ 8033 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'FIN ',
       'FLGFIN',
       0,
       'A',
       'Reforo em Aberto(Positivo)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FIN ',
       'FLGFIN',
       0,
       'I',
       'Reforo Sangria(Negativo)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FIN ',
       'FLGFIN',
       0,
       'R',
       'Reforo Confirmado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FIN ',
       'FLGFIN',
       0,
       'S',
       'Simples(No Identificada)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FIN ',
       'ORILAN',
       0,
       'B',
       'Totali BackOffice',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FIN ',
       'ORILAN',
       0,
       'C',
       'Totali CheckOut',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FIN ',
       'ORILAN',
       0,
       'I',
       'Scrips Internos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FIN ',
       'TIPGER',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FIN ',
       'TIPGER',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FIN ',
       'TIPNUM',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FIN ',
       'TIPNUM',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8034 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'FIS ',
       TO_NUMBER(null),
       'FIS ',
       'Tabela Fiscal',
       'TT_FIS',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'FIS.ORIGEM,FIS.CODSER,FIS.SUBSER',
       '' FROM DUAL
);

/*-- SEQ 8035 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'FIS ','--','' FROM DUAL
UNION ALL
SELECT 'FIS ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'FIS ','99','Outros' FROM DUAL
);

/*-- SEQ 8036 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'FIS ',
       '99',
       100,
       5,
       'CNT_RO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Contador de Reincio',
       'Contador de Reincio',
       '',
       'CNT_RO',
       'F' FROM DUAL
UNION ALL
SELECT 'FIS ',
       '01',
       5,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'FIS ',
       '99',
       110,
       3,
       'ESPDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Espcie Documento',
       'Espcie Documento',
       '',
       'ESPDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'FIS ',
       '99',
       20,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exportar?',
       'Exportar?',
       '',
       'EXPORT',
       'F' FROM DUAL
UNION ALL
SELECT 'FIS ',
       '99',
       30,
       2,
       'MODNOT',
       'A',
       'DMNF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMNF.DESMNF',
       'V',
       '',
       '',
       'A',
       'F',
       'Modelo da Nota',
       'Modelo da Nota',
       'DMNF.CODMNF = FIS.MODNOT',
       'MODNOT',
       'T' FROM DUAL
UNION ALL
SELECT 'FIS ',
       '99',
       40,
       25,
       'NOMSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Srie',
       'Descrio Srie',
       '',
       'NOMSER',
       'F' FROM DUAL
UNION ALL
SELECT 'FIS ',
       '01',
       1,
       1,
       'ORIGEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem',
       'Origem',
       '',
       'ORIGEM',
       'T' FROM DUAL
UNION ALL
SELECT 'FIS ',
       '99',
       90,
       1,
       'SERATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Srie Ativa?',
       'Srie Ativa?',
       '',
       'SERATI',
       'F' FROM DUAL
UNION ALL
SELECT 'FIS ',
       '99',
       60,
       3,
       'SEREXP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie Exportada',
       'Srie Exportada',
       '',
       'SEREXP',
       'F' FROM DUAL
UNION ALL
SELECT 'FIS ',
       '99',
       70,
       2,
       'SUBEXP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub-Srie Exportada',
       'Sub-Srie Exportada',
       '',
       'SUBEXP',
       'F' FROM DUAL
UNION ALL
SELECT 'FIS ',
       '01',
       10,
       3,
       'SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Sub-Srie',
       'Sub-Srie',
       '',
       'SUBSER',
       'F' FROM DUAL
);

/*-- SEQ 8037 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'FIS ',
       'ORIGEM',
       0,
       'C',
       'Compra/Compromisso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FIS ',
       'ORIGEM',
       0,
       'F',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FIS ',
       'ORIGEM',
       0,
       'V',
       'Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8038 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'FLW ',
       TO_NUMBER(null),
       'FLW ',
       'Fluxo de Workflow',
       'TT_FLW',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'FLW.CODFIL,FLW.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8039 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'FLW ','--','' FROM DUAL
UNION ALL
SELECT 'FLW ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'FLW ','99','Outros' FROM DUAL
);

/*-- SEQ 8040 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'FLW ',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = FLW.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'FLW ',
       '--',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seqenciador',
       'Seqenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'FLW ',
       '--',
       30,
       5,
       'SITDES',
       'S',
       'DSIT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSIT.DESSIT',
       'V',
       '',
       '',
       'N',
       'F',
       'Situao no Destino',
       'Situao no Destino',
       'DSIT.CODTAB = FLW.SITDES',
       'SITDES',
       'F' FROM DUAL
UNION ALL
SELECT 'FLW ',
       '--',
       40,
       5,
       'SITORI',
       'S',
       'DSIT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSIT.DESSIT',
       'V',
       '',
       '',
       'N',
       'F',
       'Situao na Origem',
       'Situao na Origem',
       'DSIT.CODTAB = FLW.SITORI',
       'SITORI',
       'F' FROM DUAL
);

/*-- SEQ 8041 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'FPV ',
       TO_NUMBER(null),
       'FPV ',
       'Formao Preo Venda',
       'TV_FPV',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'FPV.CODFIL,FPV.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8042 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'FPV ','--','' FROM DUAL
UNION ALL
SELECT 'FPV ','01','% de participao em relao ao custo final' FROM DUAL
UNION ALL
SELECT 'FPV ','02','Identificao' FROM DUAL
UNION ALL
SELECT 'FPV ','03','Datas' FROM DUAL
UNION ALL
SELECT 'FPV ','04','Valores' FROM DUAL
UNION ALL
SELECT 'FPV ','99','Outros' FROM DUAL
);

/*-- SEQ 8043 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 118043,
       'GRA ',
       'FPV ',
       '1',
       'N',
       '',
       '',
       'FPV.FILMAT = GRA.FILMAT and
FPV.CODMAT = GRA.CODMAT and
FPV.CODCOR = GRA.CODCOR and
FPV.CODTAM = GRA.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118044,
       'PVD ',
       'FPV ',
       '1',
       'N',
       '',
       '',
       'PVD.FILCLI = FPV.FILFOR and
PVD.CODCLI = FPV.CODFOR and
PVD.TIPPAR = FPV.TIPPAR',
       '',
       '' FROM DUAL
);

/*-- SEQ 8044 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'FPV ',
       '03',
       105,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano~Atualizao',
       'Ano de Atualizado Em',
       '',
       'TO_CHAR(FPV.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '03',
       85,
       4,
       'ANO_DATCMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data da Compr',
       'Ano de Data da Compra',
       '',
       'TO_CHAR(FPV.DATCMP,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '03',
       75,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data da Opera',
       'Ano de Data da Operao',
       '',
       'TO_CHAR(FPV.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '03',
       100,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data~Atualizao',
       'Atualizado Em',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '99',
       960,
       1,
       'CLAABC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Classif. ABC',
       'Classificao ABC',
       '',
       'CLAABC',
       'T' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '99',
       970,
       1,
       'CLAXYZ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Classif. XYZ',
       'Classificao XYZ',
       '',
       'CLAXYZ',
       'T' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '01',
       220,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Diviso',
       'Cdigo da diviso',
       'FPV.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '02',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial Compra',
       'Filial da compra',
       'DFIL.CODFIL = FPV.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '02',
       60,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo do Fornecedor',
       'Cdigo do fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '01',
       210,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Cdigo do produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '02',
       650,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Srie',
       'Nmero da srie da compra',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '01',
       230,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Sub-Diviso',
       'Cdigo da sub-diviso',
       'FPV.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '--',
       100,
       6,
       'COMCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% COFINS para Compra',
       'Aliquota de COFINS para compra',
       '',
       'COMCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '--',
       110,
       6,
       'COMPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% PIS para Compra',
       'Alquota de PIS para compra',
       '',
       'COMPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       410,
       8,
       'CUSAQS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Custo Aquis.',
       'Custo unitrio da aquisio',
       '',
       'CUSAQS',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       570,
       8,
       'CUSFIN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Custo final s/ lucro',
       'Custo final sem o lucro aplicado',
       '',
       'CUSFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       900,
       14,
       'CUSREP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Custo Reposio',
       'Custo Reposio',
       '',
       'CUSREP',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '03',
       80,
       8,
       'DATCMP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data da Compra',
       'Data da Compra',
       '',
       'DATCMP',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '03',
       70,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data da Operao',
       'Data da Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       150,
       8,
       'DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Desconto',
       'Desconto da compra',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       450,
       8,
       'DESITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Des/Acr do Item',
       'Desconto/Acrscimo unitrio',
       '',
       'DESITE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '02',
       610,
       30,
       'DESMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'L',
       '',
       'F',
       'A',
       'F',
       'Descrio Produto',
       'Descrio Produto',
       '',
       'DESMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       880,
       8,
       'DIFPRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Dif. Preo Venda',
       'Diferencial Preo de Venda',
       '',
       'DIFPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '01',
       90,
       19,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Documento',
       'Documento (Srie + Sub-Srie + Nmero)',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '02',
       620,
       30,
       'ESPMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'L',
       '',
       'F',
       'A',
       'F',
       'Especificao',
       'Especificao do material',
       '',
       'ESPMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '02',
       40,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial origem do fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '01',
       200,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial origem do produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       430,
       8,
       'FREITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr Unitario Frete',
       'Valor unitrio proporcional do frete',
       '',
       'FREITE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       360,
       14,
       'ICMCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'ICMS da compra',
       'Total de ICMS da compra',
       '',
       'ICMCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       130,
       14,
       'ICMFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'ICMS do frete',
       'ICMS unitrio do frete',
       '',
       'ICMFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       280,
       8,
       'ICMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% de ICMS',
       'ICMS por Item',
       '',
       'ICMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       370,
       14,
       'IPICOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'IPI da compra',
       'Total de IPI da compra',
       '',
       'IPICOM',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       270,
       8,
       'IPIITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% de IPI',
       'IPI do Item',
       '',
       'IPIITE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '02',
       630,
       10,
       'ITEDIV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Diviso',
       'Diviso',
       '',
       'ITEDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '02',
       640,
       10,
       'ITESUB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Sub-Diviso',
       'Sub-Diviso',
       '',
       'ITESUB',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       890,
       8,
       'LUCATU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% Lucro Atual',
       'Lucro Atual',
       '',
       'LUCATU',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       910,
       12,
       'MARKUP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Markup',
       'Markup',
       '',
       'MARKUP',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '03',
       103,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms~Atualizao',
       'Ms de Atualizado Em',
       '',
       'TO_CHAR(FPV.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '03',
       83,
       2,
       'MES_DATCMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data da Compr',
       'Ms de Data da Compra',
       '',
       'TO_CHAR(FPV.DATCMP,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '03',
       73,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data da Opera',
       'Ms de Data da Operao',
       '',
       'TO_CHAR(FPV.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '99',
       940,
       100,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome/Razo Social',
       'Nome/Razo Social Fornecedor da Compra Atual',
       '',
       'NOMCLI',
       '' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '99',
       1000,
       100,
       'NOMCLI_ANT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome For ltima Cmp.',
       'Nome/Razo Social Fornecedor da ltima Compra',
       '',
       'NOMCLI_ANT',
       '' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       190,
       8,
       'NUMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nro Item',
       'Nro Item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '02',
       670,
       8,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nro Nota',
       'Nro da nota da compra',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '99',
       180,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(FPV.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       590,
       8,
       'ORDDIV',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Ordem Diviso',
       'Ordem Diviso - Controle interno',
       '',
       'ORDDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       600,
       8,
       'ORDSUB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Ordem Sub-Diviso',
       'Ordem Sub-Diviso Controle interno',
       '',
       'ORDSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       160,
       8,
       'OUTTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Outras Taxas',
       'Outras taxas da compra',
       '',
       'OUTTAX',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '01',
       870,
       8,
       'PARAQS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Aquisio',
       'Participao da Aquisio em Relao ao Custo Final',
       '',
       'PARAQS',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '01',
       810,
       8,
       'PARCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Cofins',
       'Participao do cofins em relao ao custo final',
       '',
       'PARCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '01',
       840,
       8,
       'PARCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Comisso',
       'Participao da comisso em relao ao custo final',
       '',
       'PARCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '01',
       820,
       8,
       'PARCTS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Contribuiao Social',
       'Participao da contribuio social em relao ao custo final',
       '',
       'PARCTS',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '01',
       740,
       8,
       'PARDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Des/Acr',
       'Des/Acr em relao ao custo final',
       '',
       'PARDES',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '01',
       780,
       8,
       'PARFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Frete',
       'Participao do frete em relao ao custo final',
       '',
       'PARFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '01',
       760,
       8,
       'PARICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'ICMS',
       'Participao do ICMS em relao ao custo final',
       '',
       'PARICM',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '01',
       750,
       8,
       'PARIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'IPI',
       'Participao do IPI em relao ao custo final',
       '',
       'PARIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       89,
       12,
       'PARIRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Part. Imposto Renda',
       'Part. Imposto de Renda',
       '',
       'PARIRE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '01',
       830,
       8,
       'PARIVE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'ICMS Venda',
       'Participao do ICMS de venda em relao ao custo final',
       '',
       'PARIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '01',
       850,
       8,
       'PAROPE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Desp. Operacional',
       'Participao da despesa operacional em relao ao custo final',
       '',
       'PAROPE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '01',
       800,
       8,
       'PARPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'PIS',
       'Participao do PIS em relao ao custo final',
       '',
       'PARPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '01',
       860,
       8,
       'PARSEG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Seguro',
       'Participao do seguro em relao ao custo final',
       '',
       'PARSEG',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '01',
       770,
       8,
       'PARSUB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Subst. Tributria',
       'Participao da substituio tributria em relao ao custo final',
       '',
       'PARSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '01',
       790,
       8,
       'PARTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Outras taxas',
       'Participao de outras taxas em relao ao custo final',
       '',
       'PARTAX',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '01',
       730,
       8,
       'PARVLR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr Unitrio',
       'Valor unitrio em relao ao custo final',
       '',
       'PARVLR',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '--',
       580,
       12,
       'PAR_COMCOF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% COFINS Compra',
       '% COFINS Compra',
       '',
       'PAR_COMCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '--',
       590,
       12,
       'PAR_COMPIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '%.PIS Compra',
       '% PIS Compra',
       '',
       'PAR_COMPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '--',
       610,
       12,
       'PAR_VENCOF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% COFINS Venda',
       '% COFINS Venda',
       '',
       'PAR_VENCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '--',
       620,
       12,
       'PAR_VENPIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% PIS Venda',
       '% PIS Venda',
       '',
       'PAR_VENPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       300,
       8,
       'PERCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% de Confins',
       '% de Confins',
       '',
       'PERCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       330,
       8,
       'PERCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% de Comisso',
       '% de Comisso',
       '',
       'PERCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       710,
       8,
       'PERDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% diferena',
       'Percentual da diferena entre o preo atual e calculado',
       '',
       'PERDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '01',
       37,
       12,
       'PERENC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Encargos',
       'Percentual de Encargos',
       '',
       'PERENC',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '01',
       35,
       12,
       'PERIRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Imposto de Renda',
       'Percentual Imposto de Renda',
       '',
       'PERIRE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       320,
       8,
       'PERIVE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% de ICMS Venda',
       '% de ICMS Venda',
       '',
       'PERIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       350,
       8,
       'PERLUC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% de Lucro',
       'Percentual de lucro cadastrado no produto',
       '',
       'PERLUC',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       340,
       8,
       'PEROPE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% Desp. Operacional',
       'Percentual de despesas operacionais',
       '',
       'PEROPE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       290,
       8,
       'PERPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% do PIS',
       '% do PIS',
       '',
       'PERPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       310,
       8,
       'PERSOC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% Contr. Social',
       '% Contr. Social',
       '',
       'PERSOC',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       420,
       8,
       'PERTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Percentual Total',
       'Percentual Total',
       '',
       'PERTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       870,
       8,
       'PREATU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Preo Venda atual',
       'Preo de Venda Atual',
       '',
       'PREATU',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       560,
       8,
       'PRECAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Pr.Venda Final',
       'Preo de venda calculado',
       '',
       'PRECAL',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       690,
       8,
       'PRECOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Preo de venda',
       'Preo de venda',
       '',
       'PRECOV',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       240,
       8,
       'QTDMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Quantidade Item',
       'Quantidade Item',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '99',
       990,
       18,
       'QTDMOV_ANT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Qtd. ltima Compra',
       'Quantidade ltima Compra',
       '',
       'QTDMOV_ANT',
       '' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       245,
       8,
       'QTDMOV_CON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '0',
       'F',
       'Qtd Item~Conv.',
       'Quantidade Item Convertida',
       '',
       'QTDCONVERTIDA(FPV.CODTAM,FPV.QTDMOV)',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '02',
       580,
       20,
       'REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Referncia',
       'Referncia do produto',
       '',
       'REFPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       440,
       8,
       'SEGITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr Unitario Seguro',
       'Valor unitrio proporcional do seguro ',
       '',
       'SEGITE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '02',
       30,
       10,
       'SEQFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador do frete',
       '',
       'SEQFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '02',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       390,
       8,
       'SUBITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Subt. Tribut. Item',
       'Valor da substituio tributria do item',
       '',
       'SUBITE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '02',
       660,
       3,
       'SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Sub-Srie',
       'Nmero da sub-srie da compra',
       '',
       'SUBSER',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       460,
       8,
       'TAXITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Outras taxas do Item',
       'Outras taxas unitrias',
       '',
       'TAXITE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '02',
       50,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo do Parceiro',
       'Tipo de Parceiro',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       700,
       8,
       'TOTCOMFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Val. Lq. Frete',
       'Valor do total lquido do frete',
       '',
       'TOTCOMFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '99',
       950,
       100,
       'ULTNOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Sobrenome/Fantasia',
       'Sobrenome/Fantasia Fornecedor da Compra Atual',
       '',
       'ULTNOM',
       '' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '99',
       1010,
       100,
       'ULTNOM_ANT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Sobre For ltima Cmp',
       'Sobrenome/Fantasia Fornecedor da ltima Compra',
       '',
       'ULTNOM_ANT',
       '' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       920,
       16,
       'VLRCMG',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr.C.MdioGerencial',
       'Vlr.C.MdioGerencial',
       '',
       'VLRCMG',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       500,
       8,
       'VLRCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Confins do Item',
       'Valor unitrio do confins em relao ao preo de venda',
       '',
       'VLRCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       540,
       8,
       'VLRCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Comisso do Item',
       'Valor unitrio da comisso em relao ao preo de vendas',
       '',
       'VLRCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       720,
       8,
       'VLRENC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Preo custo c/ encar',
       'Preo de custo mais encargos financeiros embutidos',
       '',
       'VLRENC',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       110,
       8,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor frete',
       'Valor total do frete',
       '',
       'VLRFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       470,
       8,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'ICMS do Item',
       'Valor do ICMS do item da compra',
       '',
       'VLRICM',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       480,
       8,
       'VLRIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'IPI do Item',
       'Valor do IPI do item da compra',
       '',
       'VLRIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       63,
       12,
       'VLRIRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Imposto Renda',
       'Valor Imposto de Renda',
       '',
       'VLRIRE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       520,
       8,
       'VLRIVE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'ICMS do Item',
       'Valor unitrio do ICMS em relao ao preo de venda',
       '',
       'VLRIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       170,
       8,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Lquido',
       'Valor Lquido da compra',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       550,
       8,
       'VLRLUC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Lucro do Item',
       'Valor unitrio do lucro em relao ao preos de vendas',
       '',
       'VLRLUC',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       250,
       8,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Item',
       'Valor Item',
       '',
       'VLRMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       930,
       12,
       'VLRMRK',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Markup',
       'Valor Markup',
       '',
       'VLRMRK',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       530,
       8,
       'VLROPE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Desp. Operc. Item',
       'Valor unitrio da despesa operacional relativo ao preo de venda',
       '',
       'VLROPE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       490,
       8,
       'VLRPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'PIS do Item',
       'Valor do PIS em relao ao preo de venda',
       '',
       'VLRPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       260,
       8,
       'VLRPRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Presente',
       'Valor unitrio presente',
       '',
       'VLRPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       120,
       8,
       'VLRSEG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor seguro',
       'Valor do seguro do frete',
       '',
       'VLRSEG',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       510,
       8,
       'VLRSOC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Contr. do Item',
       'Valor unitrio de contribuio em relao ao preo de venda',
       '',
       'VLRSOC',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       380,
       8,
       'VLRSUB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Subt. Tribut. Compra',
       'Valor total da substituio tributria da compra',
       '',
       'VLRSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       140,
       8,
       'VLRTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Total',
       'Valor total da compra',
       '',
       'VLRTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       400,
       8,
       'VLRUNI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Unit.',
       'Valor Unitrio',
       '',
       'VLRUNI',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '99',
       980,
       18,
       'VLRUNI_ANT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr.  ltima Compra',
       'Valor ltima Compra',
       '',
       'VLRUNI_ANT',
       '' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '--',
       1050,
       12,
       'VLR_COMCOF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr. COFINS Compra',
       'Vlr. COFINS Compra',
       '',
       'VLR_COMCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '--',
       1060,
       12,
       'VLR_COMPIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr. PIS Compra',
       'Vlr. PIS Compra',
       '',
       'VLR_COMPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '--',
       1070,
       12,
       'VLR_PISCOF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr. PIS/COFINS',
       'Vlr. PIS/COFINS',
       '',
       'VLR_PISCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '--',
       1080,
       12,
       'VLR_VENCOF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr. COFINS Venda',
       'Vlr. COFINS Venda',
       '',
       'VLR_VENCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '--',
       1090,
       12,
       'VLR_VENPIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr. PIS Venda',
       'Vlr. PIS Venda',
       '',
       'VLR_VENPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'FPV ',
       '04',
       680,
       8,
       'VMVIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Compra c/ IPI',
       'Valor de compra com IPI embutido',
       '',
       'VMVIPI',
       'F' FROM DUAL
);

/*-- SEQ 8045 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'FPV ',
       'CLAABC',
       0,
       'A',
       'A',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FPV ',
       'CLAABC',
       0,
       'B',
       'B',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FPV ',
       'CLAABC',
       0,
       'C',
       'C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FPV ',
       'CLAXYZ',
       0,
       'X',
       'X',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FPV ',
       'CLAXYZ',
       0,
       'Y',
       'Y',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FPV ',
       'CLAXYZ',
       0,
       'Z',
       'Z',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FPV ',
       'TIPPAR',
       0,
       'F',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FPV ',
       'TIPPAR',
       0,
       'T',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8046 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'FRE ',
       0,
       'FRE ',
       'Fretes',
       'TV_FRE',
       'T',
       '',
       'TOTALL',
       'Conhecimento de Frete',
       '',
       '',
       '',
       '',
       'F',
       '',
       'PDV.ID,FRE.CODFIL,FRE.CODSER,FRE.NUMNOT',
       '' FROM DUAL
);

/*-- SEQ 8047 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'FRE ','--','' FROM DUAL
UNION ALL
SELECT 'FRE ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'FRE ','03','Valores' FROM DUAL
UNION ALL
SELECT 'FRE ','05','Juros e Multas' FROM DUAL
UNION ALL
SELECT 'FRE ','99','Outros' FROM DUAL
);

/*-- SEQ 8048 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21529,
       'TRA ',
       'FRE ',
       '1',
       'N',
       '',
       '',
       'TRA.FILCLI = FRE.FILFOR AND
TRA.CODCLI = FRE.CODFOR',
       '',
       '' FROM DUAL
);

/*-- SEQ 8049 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'FRE ',
       '01',
       250,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'FRE ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FRE',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizao',
       '',
       'TO_CHAR(FRE.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '01',
       210,
       4,
       'ANO_DATCMP',
       'A',
       '',
       0,
       0,
       'FRE ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FRE',
       '',
       'N',
       'T',
       'Ano Data da Compra',
       'Ano de Data da compra',
       '',
       'TO_CHAR(FRE.DATCMP,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '01',
       180,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       0,
       'FRE ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FRE',
       '',
       'N',
       'T',
       'Ano de Lanamento',
       'Ano de Data da operao',
       '',
       'TO_CHAR(FRE.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '01',
       230,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'FRE ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FRE',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '01',
       110,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       0,
       'FRE ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'FRE',
       'F',
       'A',
       'T',
       'Filial',
       'Cdigo da Filial de Origem',
       'FRE.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '01',
       130,
       6,
       'CODFOR',
       'A',
       '',
       0,
       0,
       'FRE ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FRE',
       'F',
       '9',
       'F',
       'Cdigo Fornecedor',
       'Cdigo Fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '03',
       300,
       2,
       'CODMOE',
       'S',
       'DMOE',
       0,
       0,
       'FRE ',
       50,
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       'FRE',
       'F',
       'A',
       'T',
       'Moeda',
       'Cdigo da moeda',
       'FRE.CODMOE=DMOE.CODTAB (+)',
       'CODMOE',
       'T' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '01',
       140,
       2,
       'CODSER',
       'A',
       '',
       0,
       0,
       'FRE ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'FRE',
       'F',
       'A',
       'T',
       'Srie',
       'Cdigo da srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '99',
       380,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       0,
       'FRE ',
       20,
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       'FRE',
       'F',
       'A',
       'T',
       'Usurio',
       'Cdigo do usurio',
       'FRE.FILUSU = USU.FILUSU(+)  and FRE.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '03',
       310,
       10,
       'CONPGT',
       'A',
       '',
       0,
       0,
       'FRE ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'FRE',
       'F',
       'A',
       'T',
       'Condies Pagamento',
       'Condio de Pagamento',
       '',
       'CONPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '01',
       190,
       8,
       'DATCMP',
       'D',
       '',
       0,
       0,
       'FRE ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FRE',
       'F',
       'D',
       'T',
       'Data da Compra',
       'Data da compra',
       '',
       'DATCMP',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '01',
       160,
       8,
       'DATOPE',
       '@',
       '',
       0,
       0,
       'FRE ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FRE',
       'F',
       '@',
       'T',
       'Data de Lanamento',
       'Data da operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '03',
       280,
       8,
       'DESCON',
       'F',
       '',
       2,
       0,
       'FRE ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FRE',
       'T',
       '9',
       'T',
       'Desconto',
       'Desconto',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '01',
       430,
       15,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '99',
       410,
       3,
       'ESPDOC',
       'A',
       '',
       0,
       0,
       'FRE ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'FRE',
       'F',
       'A',
       'T',
       'Espcie Documento',
       'Espcie de Documento',
       '',
       'ESPDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '01',
       120,
       3,
       'FILFOR',
       'A',
       '',
       0,
       0,
       'FRE ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FRE',
       'F',
       'N',
       'F',
       '',
       'Filial do Fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '99',
       370,
       3,
       'FILUSU',
       'A',
       '',
       0,
       0,
       'FRE ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FRE',
       'F',
       'N',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '01',
       220,
       1,
       'FLGEST',
       'A',
       '',
       0,
       0,
       'FRE ',
       80,
       30,
       '',
       '',
       'D',
       'FRE',
       'F',
       'A',
       'T',
       'Situao',
       'Situao (Devolvido/Quitado/Em aberto)',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '05',
       330,
       1,
       'INCOJU',
       'A',
       '',
       0,
       0,
       'FRE ',
       20,
       30,
       '',
       '',
       'D',
       'FRE',
       'F',
       'A',
       'T',
       'Correo em',
       'Indicador do tipo de correo de juros',
       '',
       'INCOJU',
       'T' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '05',
       340,
       1,
       'INTPJU',
       'A',
       '',
       0,
       0,
       'FRE ',
       30,
       30,
       '',
       '',
       'D',
       'FRE',
       'F',
       'A',
       'T',
       'Tipo de Juros',
       'Indicador do tipo de juros',
       '',
       'INTPJU',
       'T' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '05',
       360,
       1,
       'INTPMU',
       'A',
       '',
       0,
       0,
       'FRE ',
       50,
       30,
       '',
       '',
       'D',
       'FRE',
       'F',
       'A',
       'T',
       'Tipo de Multa',
       'Indicador do tipo de multa',
       '',
       'INTPMU',
       'T' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '01',
       240,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'FRE ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FRE',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizao',
       '',
       'TO_CHAR(FRE.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '01',
       200,
       2,
       'MES_DATCMP',
       'A',
       '',
       0,
       0,
       'FRE ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FRE',
       '',
       'N',
       'T',
       'Ms Data da Compra',
       'Ms de Data da compra',
       '',
       'TO_CHAR(FRE.DATCMP,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '01',
       170,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       0,
       'FRE ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FRE',
       '',
       'N',
       'T',
       'Ms  de Lanamento',
       'Ms de Data da operao',
       '',
       'TO_CHAR(FRE.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '03',
       40,
       2,
       'MOEJUR',
       'S',
       'DMOE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       '',
       'F',
       'A',
       'F',
       'Moeda Correo',
       'Moeda da Correo',
       'FRE.MOEJUR=DMOE.CODTAB (+)',
       'MOEJUR',
       'T' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '99',
       400,
       12,
       'NATURE',
       'A',
       '',
       0,
       0,
       'FRE ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'FRE',
       'F',
       '9',
       'T',
       'Natureza',
       'Natureza',
       '',
       'NATURE',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '99',
       30,
       1,
       'NOTESP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Nota Especial?',
       'Nota Especial?',
       '',
       'NOTESP',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '01',
       150,
       8,
       'NUMNOT',
       'A',
       '',
       0,
       0,
       'FRE ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FRE',
       'F',
       '9',
       'T',
       'Nmero',
       'Nmero do conhecimento',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '99',
       390,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'FRE ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'FRE',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(FRE.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '03',
       270,
       8,
       'OUTTAX',
       'F',
       '',
       2,
       0,
       'FRE ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FRE',
       'T',
       '9',
       'T',
       'Outras Taxas',
       'Outras taxas',
       '',
       'OUTTAX',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '03',
       20,
       12,
       'QTDTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Quantidade Total',
       'Quantidade Total',
       '',
       'QTDTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '99',
       90,
       10,
       'SEQCAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador de Cancelamento',
       '',
       'SEQCAN',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '99',
       50,
       10,
       'SEQFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador de Fatura',
       '',
       'SEQFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '99',
       60,
       10,
       'SEQFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador de Frete',
       '',
       'SEQFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '99',
       10,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '99',
       420,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'FRE ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'FRE',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN FRE.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '99',
       421,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN FRE.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '01',
       100,
       3,
       'SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub-Srie',
       'Sub-Srie',
       '',
       'SUBSER',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '01',
       70,
       1,
       'TIPNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Documento',
       'Tipo de Documento',
       '',
       'TIPNOT',
       'T' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '01',
       80,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Parceiro',
       'Tipo de Parceiro',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '03',
       290,
       8,
       'VLRLIQ',
       'F',
       '',
       2,
       0,
       'FRE ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FRE',
       'T',
       '9',
       'T',
       'Valor Lquido',
       'Valor lquido',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '03',
       260,
       8,
       'VLRTOT',
       'F',
       '',
       2,
       0,
       'FRE ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FRE',
       'T',
       '9',
       'T',
       'Valor Total',
       'Valor total',
       '',
       'VLRTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '05',
       320,
       8,
       'VLTXJU',
       'F',
       '',
       2,
       0,
       'FRE ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FRE',
       'T',
       '9',
       'T',
       'Juros',
       'Valor ou taxa de juros',
       '',
       'VLTXJU',
       'F' FROM DUAL
UNION ALL
SELECT 'FRE ',
       '05',
       350,
       8,
       'VLTXMU',
       'F',
       '',
       2,
       0,
       'FRE ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'FRE',
       'T',
       '9',
       'T',
       'Multa',
       'Valor ou taxa de multa',
       '',
       'VLTXMU',
       'F' FROM DUAL
);

/*-- SEQ 8050 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'FRE ',
       'FLGEST',
       0,
       'A',
       'Em aberto',
       46,
       ' ' FROM DUAL
UNION ALL
SELECT 'FRE ',
       'FLGEST',
       0,
       'D',
       'Devolvido',
       44,
       ' ' FROM DUAL
UNION ALL
SELECT 'FRE ',
       'FLGEST',
       0,
       'Q',
       'Quitado',
       45,
       ' ' FROM DUAL
UNION ALL
SELECT 'FRE ',
       'INCOJU',
       0,
       '$',
       'Moeda',
       50,
       ' ' FROM DUAL
UNION ALL
SELECT 'FRE ',
       'INCOJU',
       0,
       '0',
       'Nao h',
       51,
       ' ' FROM DUAL
UNION ALL
SELECT 'FRE ',
       'INCOJU',
       0,
       'A',
       'Anual',
       49,
       ' ' FROM DUAL
UNION ALL
SELECT 'FRE ',
       'INCOJU',
       0,
       'D',
       'Diria',
       47,
       ' ' FROM DUAL
UNION ALL
SELECT 'FRE ',
       'INCOJU',
       0,
       'M',
       'Mensal',
       48,
       ' ' FROM DUAL
UNION ALL
SELECT 'FRE ',
       'INTPJU',
       0,
       'C',
       'Composto',
       53,
       ' ' FROM DUAL
UNION ALL
SELECT 'FRE ',
       'INTPJU',
       0,
       'F',
       'Fixo',
       54,
       ' ' FROM DUAL
UNION ALL
SELECT 'FRE ',
       'INTPJU',
       0,
       'S',
       'Simples',
       52,
       ' ' FROM DUAL
UNION ALL
SELECT 'FRE ',
       'INTPMU',
       0,
       '$',
       'Valor',
       56,
       ' ' FROM DUAL
UNION ALL
SELECT 'FRE ',
       'INTPMU',
       0,
       '%',
       'Percentual',
       55,
       ' ' FROM DUAL
UNION ALL
SELECT 'FRE ',
       'TIPNOT',
       0,
       'A',
       'N.F.F.',
       276,
       ' ' FROM DUAL
UNION ALL
SELECT 'FRE ',
       'TIPNOT',
       0,
       'F',
       'Fatura',
       274,
       ' ' FROM DUAL
UNION ALL
SELECT 'FRE ',
       'TIPNOT',
       0,
       'N',
       'Nota Fiscal',
       275,
       ' ' FROM DUAL
UNION ALL
SELECT 'FRE ',
       'TIPPAR',
       0,
       'F',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'FRE ',
       'TIPPAR',
       0,
       'T',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8051 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'FRM ',
       TO_NUMBER(null),
       'FRM ',
       'Frmula Crd.Fornec ',
       'TT_FRM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8052 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'FRM ','--','' FROM DUAL
UNION ALL
SELECT 'FRM ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'FRM ','99','Outros' FROM DUAL
);

/*-- SEQ 8053 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5616,
       'CLI ',
       'FRM ',
       '1 ',
       'N ',
       '',
       '',
       'CLI.FILCLI = FRM.FILCLI and
CLI.CODCLI = FRM.CODCLI',
       '' FROM DUAL
);

/*-- SEQ 8054 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'FRM ',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'FRM ',
       '01',
       20,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'FRM ',
       '01',
       30,
       4000,
       'FORMUL',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Frmula',
       'Frmulas de crdito do fornecedor',
       '',
       'FORMUL',
       'F' FROM DUAL
);

/*-- SEQ 8055 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'FRO ',
       TO_NUMBER(null),
       'FRO ',
       'Obs. Fiscais Venda ',
       'TT_FRO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'FRO.CODFRO',
       '' FROM DUAL
);

/*-- SEQ 8056 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'FRO ','--','' FROM DUAL
UNION ALL
SELECT 'FRO ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'FRO ','99','Outros' FROM DUAL
);

/*-- SEQ 8057 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'FRO ',
       '--',
       10,
       5,
       'CODFRO',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Cdigo da Observao',
       'Cdigo da Observao',
       '',
       'CODFRO',
       'F' FROM DUAL
UNION ALL
SELECT 'FRO ',
       '--',
       20,
       4000,
       'DESFRO',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Frmula',
       'Frmula',
       '',
       'RTF2TXT(DESFRO)',
       'F' FROM DUAL
);

/*-- SEQ 8058 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'FRP ',
       TO_NUMBER(null),
       'FRP ',
       'Frete x Regio/Peso',
       'TT_FRP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'FRP.CODFIL,FRP.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8059 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'FRP ','--','' FROM DUAL
UNION ALL
SELECT 'FRP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'FRP ','05','Datas' FROM DUAL
UNION ALL
SELECT 'FRP ','99','Outros' FROM DUAL
);

/*-- SEQ 8060 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 26829,
       'DFRE',
       'FRP ',
       '1',
       'N',
       '',
       '',
       'FRP.CODFRE = DFRE.CODTAB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26830,
       'DREG',
       'FRP ',
       '1',
       'N',
       '',
       '',
       'FRP.CODREG = DREG.CODTAB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26831,
       'DPES',
       'FRP ',
       '1',
       'N',
       '',
       '',
       'FRP.CODPES = DPES.CODTAB',
       '',
       '' FROM DUAL
);

/*-- SEQ 8061 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'FRP ',
       '05',
       40,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data atualizao',
       'Data da atualizao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'FRP ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = FRP.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'FRP ',
       '--',
       50,
       5,
       'CODFRE',
       'S',
       'DFRE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFRE.DESFRE',
       'V',
       '',
       '',
       'N',
       '',
       'Poltica de frete',
       'Poltica de frete',
       'DFRE.CODTAB = FRP.CODFRE',
       'CODFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'FRP ',
       '--',
       70,
       5,
       'CODPES',
       'S',
       'DPES',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DPES.DESPES',
       'V',
       '',
       '',
       'N',
       '',
       'Faixa de peso',
       'Faixa de peso',
       'DPES.CODTAB = FRP.CODPES',
       'CODPES',
       'F' FROM DUAL
UNION ALL
SELECT 'FRP ',
       '--',
       60,
       5,
       'CODREG',
       'S',
       'DREG',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DREG.REGIAO',
       'V',
       '',
       '',
       'N',
       '',
       'Regio',
       'Regio',
       'DREG.CODTAB = FRP.CODREG',
       'CODREG',
       'F' FROM DUAL
UNION ALL
SELECT 'FRP ',
       '05',
       30,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data incluso',
       'Data da incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'FRP ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'FRP ',
       '--',
       80,
       12,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor por quilo',
       'Valor por quilo',
       '',
       'VLRFRE',
       '' FROM DUAL
);

/*-- SEQ 8062 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'FTR ',
       TO_NUMBER(null),
       'FTR ',
       'Fatores clc. financ',
       'TT_FTR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8063 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'FTR ','--','' FROM DUAL
UNION ALL
SELECT 'FTR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'FTR ','02','Datas' FROM DUAL
UNION ALL
SELECT 'FTR ','99','Outros' FROM DUAL
);

/*-- SEQ 8064 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 62381,
       'PLA ',
       'FTR ',
       '1',
       'N',
       '',
       '',
       'PLA.FILPGT = FTR.FILPLA AND
PLA.CODPGT = FTR.CODPLA',
       '',
       '' FROM DUAL
);

/*-- SEQ 8065 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'FTR ',
       '02',
       30,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Alterao',
       'Data de Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'FTR ',
       '01',
       50,
       3,
       'CODPLA',
       'A',
       'PLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       '',
       '',
       '9',
       'F',
       'Cdigo do plano',
       'Cdigo do plano',
       'FTR.FILPLA = PLA.FILPGT AND FTR.CODPLA = PLA.CODPGT',
       'CODPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'FTR ',
       '02',
       20,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'FTR ',
       '01',
       70,
       3,
       'DIACAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Dias de carncia',
       'Dias de carncia',
       '',
       'DIACAR',
       'F' FROM DUAL
UNION ALL
SELECT 'FTR ',
       '01',
       40,
       3,
       'FILPLA',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial do plano',
       'Filial do plano',
       'DFIL.CODFIL = FTR.FILPLA',
       'FILPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'FTR ',
       '01',
       80,
       7,
       'FTRFIN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fator',
       'Fator',
       '',
       'FTRFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'FTR ',
       '01',
       10,
       14,
       'ID_FTR',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Chave ID',
       'Chave ID',
       '',
       'ID_FTR',
       'F' FROM DUAL
UNION ALL
SELECT 'FTR ',
       '01',
       60,
       2,
       'QTDPAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Quantidade parcelas',
       'Quantidade de parcelas',
       '',
       'QTDPAR',
       'F' FROM DUAL
);

/*-- SEQ 8066 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'FXC ',
       TO_NUMBER(null),
       'FXC ',
       'ltimo Fat. C/C',
       'TT_FXC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'FXC.FILCLI,FXC.CODCLI,FXC.CODCCC',
       '' FROM DUAL
);

/*-- SEQ 8067 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'FXC ','--','' FROM DUAL
UNION ALL
SELECT 'FXC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'FXC ','99','Outros' FROM DUAL
);

/*-- SEQ 8068 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'FXC ',
       '--',
       10,
       5,
       'CODCCC',
       'S',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       '9',
       'F',
       'Tipo C/C',
       'Tipo C/C',
       'DCCC.CODTAB(+) = FXC.CODCCC',
       'CODCCC',
       'T' FROM DUAL
UNION ALL
SELECT 'FXC ',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Codigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'FXC ',
       '--',
       30,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'FXC ',
       '--',
       40,
       7,
       'ULTFAT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Ultimo Faturamento',
       'Data Ultimo Faturamento',
       '',
       'ULTFAT',
       'F' FROM DUAL
);

/*-- SEQ 8069 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'GAB ',
       TO_NUMBER(null),
       'GAB ',
       'Gabaritos de CB.',
       'TT_GAB',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8070 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'GAB ','--','' FROM DUAL
UNION ALL
SELECT 'GAB ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'GAB ','99','Outros' FROM DUAL
);

/*-- SEQ 8071 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'GAB ',
       '99',
       120,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       '(CASE WHEN GAB.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'GAB ',
       '99',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'GAB ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = GAB.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'GAB ',
       '99',
       30,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'GAB ',
       '99',
       40,
       40,
       'DESGAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Gabarito',
       'Descrio do Gabarito',
       '',
       'DESGAB',
       'F' FROM DUAL
UNION ALL
SELECT 'GAB ',
       '99',
       50,
       120,
       'ESTRUR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Estrutura Gabarito',
       'Estrutura do Gabarito',
       '',
       'ESTRUR',
       'F' FROM DUAL
UNION ALL
SELECT 'GAB ',
       '01',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'GAB ',
       '99',
       70,
       5,
       'SIGNAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0',
       '',
       'SIGNAT',
       'F' FROM DUAL
UNION ALL
SELECT 'GAB ',
       '99',
       80,
       5,
       'TAMMAX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Tamanho Mximo Gab',
       'Tamanho Mximo do Gabarito',
       '',
       'TAMMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'GAB ',
       '99',
       90,
       5,
       'TAMMIN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Tamanho Minimo Gab',
       'Tamanho Minimo do Gabarito',
       '',
       'TAMMIN',
       'F' FROM DUAL
UNION ALL
SELECT 'GAB ',
       '99',
       100,
       5,
       'TAMPRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Tamanho do Prefixo',
       'Tamanho do Prefixo',
       '',
       'TAMPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'GAB ',
       '99',
       110,
       5,
       'TIPGAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Tipo de Gabarito',
       'Tipo de Gabarito',
       '',
       'TIPGAB',
       'T' FROM DUAL
);

/*-- SEQ 8072 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'GAB ',
       'TIPGAB',
       1,
       ' ',
       'Balana',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GAB ',
       'TIPGAB',
       2,
       ' ',
       'Lote',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8073 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'GAXA',
       TO_NUMBER(null),
       'GAXA',
       'Aplicao Gat. Prod.',
       'TT_GATXAPL',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8074 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'GAXA','--','' FROM DUAL
UNION ALL
SELECT 'GAXA','01','Identificao' FROM DUAL
UNION ALL
SELECT 'GAXA','02','Classificao do Produto' FROM DUAL
UNION ALL
SELECT 'GAXA','03','Produto' FROM DUAL
UNION ALL
SELECT 'GAXA','99','Outros' FROM DUAL
);

/*-- SEQ 8075 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 118051,
       'CPXG',
       'GAXA',
       '1',
       '0N',
       '',
       '',
       'GAXA.FILCPR = CPXG.FILCPR(+) AND
GAXA.SEQCPR = CPXG.SEQCPR(+) AND
GAXA.SEQGAT = CPXG.SEQUEN(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118052,
       'DDEP',
       'GAXA',
       '01',
       '0N',
       '',
       '',
       'GAXA.CODDEP = DDEP.CODTAB(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118053,
       'DCL1',
       'GAXA',
       '01',
       '0N',
       '',
       '',
       'GAXA.CODCL1 = DCL1.CODTAB(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118054,
       'DCL2',
       'GAXA',
       '01',
       '0N',
       '',
       '',
       'GAXA.CODCL2 = DCL2.CODTAB(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118055,
       'DCL3',
       'GAXA',
       '01',
       '0N',
       '',
       '',
       'GAXA.CODCL3 = DCL3.CODTAB(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118056,
       'DCL4',
       'GAXA',
       '01',
       '0N',
       '',
       '',
       'GAXA.CODCL4 = DCL4.CODTAB(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118057,
       'PRO ',
       'GAXA',
       '01',
       '0N',
       '',
       '',
       'GAXA.FILMAT = PRO.FILMAT(+) AND
GAXA.CODMAT = PRO.CODMAT(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118058,
       'GRA ',
       'GAXA',
       '01',
       '0N',
       '',
       '',
       'GAXA.FILMAT = GRA.FILMAT(+) AND
GAXA.CODMAT = GRA.CODMAT(+) AND
GAXA.CODCOD = GRA.CODCOR(+) AND
GAXA.CODTAM = GRA.CODTAM(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8076 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'GAXA',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Atualizao',
       'Data atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'GAXA',
       '02',
       20,
       5,
       'CODCL1',
       'S',
       'DCL1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL1.CLASS1',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Classe (1)',
       'Cdigo da classe (1)',
       'DCL1.CODTAB = GAXA.CODCL1(+)',
       'CODCL1',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXA',
       '02',
       30,
       5,
       'CODCL2',
       'S',
       'DCL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL2.CLASS2',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Classe (2)',
       'Cdigo da classe (2)',
       'DCL2.CODTAB = GAXA.CODCL2(+)',
       'CODCL2',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXA',
       '02',
       40,
       5,
       'CODCL3',
       'S',
       'DCL3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL3.CLASS3',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Classe (3)',
       'Cdigo da classe (3)',
       'DCL3.CODTAB = GAXA.CODCL3(+)',
       'CODCL3',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXA',
       '02',
       50,
       5,
       'CODCL4',
       'S',
       'DCL4',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL4.CLASS4',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Classe (4)',
       'Cdigo da classe (4)',
       'DCL4.CODTAB = GAXA.CODCL4(+)',
       'CODCL4',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXA',
       '03',
       60,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Diviso',
       'Cdigo da diviso',
       'DIV.CODITE = GAXA.CODCOR(+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXA',
       '02',
       70,
       5,
       'CODDEP',
       'S',
       'DDEP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDEP.DESDEP',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Departamento',
       'Cdigo do departamento',
       'DDEP.CODTAB = GAXA.CODDEP',
       'CODDEP',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXA',
       '03',
       80,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo Produto',
       'Cdigo do produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'GAXA',
       '03',
       90,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       '',
       '9',
       'F',
       'Cdigo Sub-Diviso',
       'Cdigo da sub-diviso',
       'SUB.CODITE = GAXA.CODTAM(+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXA',
       '--',
       100,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data inclusao',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'GAXA',
       '--',
       110,
       3,
       'FILCPR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial Campanha',
       'Filial da campanha',
       'DFIL.CODFIL = GAXA.FILCPR(+)',
       'FILCPR',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXA',
       '03',
       120,
       3,
       'FILMAT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial Produto',
       'Filial do produto',
       'DFIL.CODFIL = GAXA.FILMAT(+)',
       'FILMAT',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXA',
       '--',
       190,
       1,
       'MULAPL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Apl. em mltiplos?',
       'Aplicao realizada sobre mltiplos?',
       '',
       'MULAPL',
       'F' FROM DUAL
UNION ALL
SELECT 'GAXA',
       '--',
       130,
       12,
       'QTDAPL',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Qtd. Aplicar',
       'Aplicar somente sobre a quantidade de produtos indicada',
       '',
       'QTDAPL',
       'F' FROM DUAL
UNION ALL
SELECT 'GAXA',
       '--',
       140,
       10,
       'SEQCPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. Campanha',
       'Sequenciador da campanha',
       '',
       'SEQCPR',
       'F' FROM DUAL
UNION ALL
SELECT 'GAXA',
       '--',
       150,
       10,
       'SEQGAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. Gatilho',
       'Sequenciador do gatilho',
       '',
       'SEQGAT',
       'F' FROM DUAL
UNION ALL
SELECT 'GAXA',
       '--',
       160,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'GAXA',
       '--',
       170,
       1,
       'TIPAPL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Aplicao',
       'Tipo da aplicao',
       '',
       'TIPAPL',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXA',
       '--',
       180,
       12,
       'VLRAPL',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Apl. Desc.',
       'Valor aplicado para o desconto',
       '',
       'VLRAPL',
       'F' FROM DUAL
);

/*-- SEQ 8077 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'GAXA',
       'TIPAPL',
       0,
       'F',
       'Preo Fixo por Produto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GAXA',
       'TIPAPL',
       0,
       'P',
       'Percentual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GAXA',
       'TIPAPL',
       0,
       'V',
       'Valor',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8078 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'GAXC',
       TO_NUMBER(null),
       'GAXC',
       'Regras Aplic. Cli.',
       'TT_GATXCLI',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8079 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'GAXC','--','' FROM DUAL
UNION ALL
SELECT 'GAXC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'GAXC','02','Classificao do Cliente' FROM DUAL
UNION ALL
SELECT 'GAXC','03','Cliente' FROM DUAL
UNION ALL
SELECT 'GAXC','99','Outros' FROM DUAL
);

/*-- SEQ 8080 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 118059,
       'CPXG',
       'GAXC',
       '1',
       '0N',
       '',
       '',
       'GAXC.FILCPR = GAXP.FILCPR(+) AND
GAXC.SEQCPR = GAXP.SEQCPR(+) AND
GAXC.SEQGAT = GAXP.SEQUEN(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118060,
       'DCT1',
       'GAXC',
       '01',
       '0N',
       '',
       '',
       'GAXC.CODCT1 = DCT1.CODTAB(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118061,
       'DCT2',
       'GAXC',
       '01',
       '0N',
       '',
       '',
       'GAXC.CODCT2 = DCT2.CODTAB(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118062,
       'DCT3',
       'GAXC',
       '01',
       '0N',
       '',
       '',
       'GAXC.CODCT3 = DCT3.CODTAB(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118063,
       'CLI ',
       'GAXC',
       '01',
       '0N',
       '',
       '',
       'GAXC.FILCLI = CLI.FILCLI(+) AND
GAXC.CODCLI = CLI.CODCLI(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8081 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'GAXC',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Atualizao',
       'Data atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'GAXC',
       '03',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'GAXC',
       '02',
       30,
       5,
       'CODCT1',
       'S',
       'DCT1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Categ. (1)',
       'Cdigo da categoria (1)',
       'DCT1.CODTAB = GAXC.CODCT1(+)',
       'CODCT1',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXC',
       '02',
       40,
       5,
       'CODCT2',
       'S',
       'DCT2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Categ. (2)',
       'Cdigo da categoria (2)',
       'DCT2.CODTAB = GAXC.CODCT2(+)',
       'CODCT2',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXC',
       '02',
       50,
       5,
       'CODCT3',
       'S',
       'DCT3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Categ. (3)',
       'Cdigo da categoria (3)',
       'DCT3.CODTAB = GAXC.CODCT3(+)',
       'CODCT3',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXC',
       '--',
       60,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'GAXC',
       '03',
       70,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial Cliente',
       'Filial do cliente',
       'DFIL.CODFIL = GAXC.FILCLI(+)',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXC',
       '--',
       80,
       3,
       'FILCPR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial Campanha',
       'Filial da campanha',
       'DFIL.CODFIL = GAXC.FILCPR(+)',
       'FILCPR',
       'F' FROM DUAL
UNION ALL
SELECT 'GAXC',
       '--',
       100,
       10,
       'SEQCPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. Campanha',
       'Sequenciador da campanha',
       '',
       'SEQCPR',
       'F' FROM DUAL
UNION ALL
SELECT 'GAXC',
       '--',
       110,
       10,
       'SEQGAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '.',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. Gatilho',
       'Sequenciador do gatilho',
       '',
       'SEQGAT',
       'F' FROM DUAL
UNION ALL
SELECT 'GAXC',
       '--',
       120,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8082 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'GAXP',
       TO_NUMBER(null),
       'GAXP',
       'Regras Aplicao Pr.',
       'TT_GATXPRO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8083 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'GAXP','--','' FROM DUAL
UNION ALL
SELECT 'GAXP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'GAXP','02','Classificao Produto' FROM DUAL
UNION ALL
SELECT 'GAXP','03','Produto' FROM DUAL
UNION ALL
SELECT 'GAXP','99','Outros' FROM DUAL
);

/*-- SEQ 8084 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 118064,
       'PRO ',
       'GAXP',
       '01',
       '0N',
       '',
       '',
       'GAXP.FILMAT = PRO.FILMAT(+) AND
GAXP.CODMAT = PRO.CODMAT(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118065,
       'GRA ',
       'GAXP',
       '01',
       '0N',
       '',
       '',
       'GAXP.FILMAT = GRA.FILMAT(+) AND
GAXP.CODMAT = GRA.CODMAT(+) AND
GAXP.CODCOR = GRA.CODCOR(+) AND
GAXP.CODTAM = GRA.CODTAM(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118066,
       'CPXG',
       'GAXP',
       '1',
       '0N',
       '',
       '',
       'GAXP.FILCPR = CPXG.FILCPR(+) AND
GAXP.SEQCPR = CPXG.SEQCPR(+) AND
GAXP.SEQGAT = CPXG.SEQUEN(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118067,
       'DCL2',
       'GAXP',
       '01',
       '0N',
       '',
       '',
       'GAXP.CODCL2 = DCL2.CODTAB(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118068,
       'DCL3',
       'GAXP',
       '01',
       '0N',
       '',
       '',
       'GAXP.CODCL3 = DCL3.CODTAB(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118069,
       'DCL4',
       'GAXP',
       '01',
       '0N',
       '',
       '',
       'GAXP.CODCL4 = DCL4.CODTAB(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118070,
       'DDEP',
       'GAXP',
       '01',
       '0N',
       '',
       '',
       'GAXP.CODDEP = DDEP.CODTAB(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8085 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'GAXP',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Atualizao',
       'Data atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'GAXP',
       '02',
       20,
       5,
       'CODCL1',
       'S',
       'DCL1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL1.CLASS1',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Classe (1)',
       'Cdigo da classe 1',
       'DCL1.CODTAB(+) = GAXP.CODCL1(+)',
       'CODCL1',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXP',
       '02',
       30,
       5,
       'CODCL2',
       'S',
       'DCL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL2.CLASS2',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Classe (2)',
       'Cdigo da classe 2',
       'DCL2.CODTAB(+) = GAXP.CODCL2(+)',
       'CODCL2',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXP',
       '02',
       40,
       5,
       'CODCL3',
       'S',
       'DCL3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL3.CLASS3',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Classe (3)',
       'Cdigo da classe 3',
       'DCL3.CODTAB(+) = GAXP.CODCL3(+)',
       'CODCL3',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXP',
       '02',
       50,
       5,
       'CODCL4',
       'S',
       'DCL4',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL4.CLASS4',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Classe (4)',
       'Cdigo da classe 4',
       'DCL4.CODTAB(+) = GAXP.CODCL4(+)',
       'CODCL4',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXP',
       '03',
       90,
       2,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       '',
       'N',
       '',
       'Cdigo Diviso',
       'Cdigo da diviso',
       'DIV.CODITE(+) = GAXP.CODCOR',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXP',
       '02',
       70,
       5,
       'CODDEP',
       'S',
       'DDEP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDEP.DESDEP',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Departamento',
       'Cdigo do departamento',
       'DDEP.CODTAB(+) = GAXP.CODDEP(+)',
       'CODDEP',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXP',
       '03',
       80,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo Produto',
       'Cdigo Produto',
       '',
       'CODMAT',
       '' FROM DUAL
UNION ALL
SELECT 'GAXP',
       '03',
       120,
       2,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       '',
       'N',
       '',
       'Cdigo Sub Diviso',
       'Cdigo Sub Diviso',
       'SUB.CODITE(+) = GAXP.CODTAM',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXP',
       '--',
       100,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'GAXP',
       '--',
       110,
       3,
       'FILCPR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial Campanha',
       'Filial da campanha',
       'DFIL.CODFIL = GAXP.FILCPR(+)',
       'FILCPR',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXP',
       '03',
       60,
       3,
       'FILMAT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Produto',
       'Filial Produto',
       'DFIL.CODFIL = GAXP.FILMAT(+)',
       'FILMAT',
       'T' FROM DUAL
UNION ALL
SELECT 'GAXP',
       '--',
       130,
       12,
       'QTDMAX',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Quantidade Max.',
       'Quantidade mxima de compra',
       '',
       'QTDMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'GAXP',
       '--',
       140,
       12,
       'QTDMIN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Quantidade Min.',
       'Quantidade mnima de compra',
       '',
       'QTDMIN',
       'F' FROM DUAL
UNION ALL
SELECT 'GAXP',
       '--',
       170,
       10,
       'SEQCPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. Campanha',
       'Sequenciador da campanha ',
       '',
       'SEQCPR',
       'F' FROM DUAL
UNION ALL
SELECT 'GAXP',
       '--',
       180,
       10,
       'SEQGAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. Gatilho',
       'Sequenciador do gatilho',
       '',
       'SEQGAT',
       'F' FROM DUAL
UNION ALL
SELECT 'GAXP',
       '--',
       190,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8086 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'GPD ',
       TO_NUMBER(null),
       'GPD ',
       'Viso LGPD Cliente',
       'TT_LAYXLGPD',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'GPD.ID_LAYXLGPD',
       '' FROM DUAL
);

/*-- SEQ 8087 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'GPD ','--','' FROM DUAL
UNION ALL
SELECT 'GPD ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'GPD ','99','Outros' FROM DUAL
);

/*-- SEQ 8088 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'GPD ',
       '--',
       20,
       4,
       'CODTAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'GPD ',
       '--',
       10,
       10,
       'ID_LAYXLGPD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Sequenciador',
       'Sequenciador',
       '',
       'ID_LAYXLGPD',
       '' FROM DUAL
UNION ALL
SELECT 'GPD ',
       '--',
       30,
       30,
       'NOMCPO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome do Campo',
       'Nome do Campo',
       '',
       'NOMCPO',
       '' FROM DUAL
UNION ALL
SELECT 'GPD ',
       '--',
       40,
       1,
       'TIP_LGPD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo Dado LGPD',
       'Classificao do Dado para efeitos da LGPD',
       '',
       'TIP_LGPD',
       'T' FROM DUAL
);

/*-- SEQ 8089 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'GPD ',
       'TIP_LGPD',
       0,
       'D',
       'Sem Controle',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GPD ',
       'TIP_LGPD',
       0,
       'P',
       'Dado Pessoal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GPD ',
       'TIP_LGPD',
       0,
       'S',
       'Dado Sensvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8090 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'GRA ',
       0,
       'GRA ',
       'Sub-Produto(Grade)',
       'TT_GRA',
       'T',
       '',
       'TOTALL',
       'Grades',
       '{FILMAT;CODMAT;CODCOR;CODTAM}',
       '',
       'REFPRO',
       'Grade',
       'F',
       '',
       'GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM
PRO.ID,GRA.CODCOR,GRA.CODTAM
GRA.REFPRO',
       '' FROM DUAL
);

/*-- SEQ 8091 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'GRA ','--','' FROM DUAL
UNION ALL
SELECT 'GRA ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'GRA ','02','Sugesto de Compra' FROM DUAL
UNION ALL
SELECT 'GRA ','03','Saldo da Filial' FROM DUAL
UNION ALL
SELECT 'GRA ','04','Valor Total de Compra' FROM DUAL
UNION ALL
SELECT 'GRA ','05','Valor Total de Reposio' FROM DUAL
UNION ALL
SELECT 'GRA ','08','Pedido Pendente' FROM DUAL
UNION ALL
SELECT 'GRA ','09','Saldo no Periodo' FROM DUAL
UNION ALL
SELECT 'GRA ','10','Valor de Venda do Produto (por Filial)' FROM DUAL
UNION ALL
SELECT 'GRA ','11','Data Custo Reposio' FROM DUAL
UNION ALL
SELECT 'GRA ','12','Giro de Estoque' FROM DUAL
UNION ALL
SELECT 'GRA ','13','Dias Sem Estoque' FROM DUAL
UNION ALL
SELECT 'GRA ','14','Dias Com Estoque' FROM DUAL
UNION ALL
SELECT 'GRA ','15','Dias Estoque Negativo' FROM DUAL
UNION ALL
SELECT 'GRA ','16','Quantidade Comprada' FROM DUAL
UNION ALL
SELECT 'GRA ','17','Valor Comprado' FROM DUAL
UNION ALL
SELECT 'GRA ','18','Qtd. Comprada' FROM DUAL
UNION ALL
SELECT 'GRA ','19','Valor de Venda do Produto' FROM DUAL
UNION ALL
SELECT 'GRA ','20','Status KIT' FROM DUAL
UNION ALL
SELECT 'GRA ','99','Outros' FROM DUAL
);

/*-- SEQ 8092 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21240,
       'LGRA',
       'GRA ',
       'N',
       '1',
       '',
       '',
       'GRA.FILMAT = LGRA.FILMAT AND
GRA.CODMAT = LGRA.CODMAT AND
GRA.CODCOR = LGRA.CODCOR AND
GRA.CODTAM = LGRA.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21241,
       'PRO ',
       'GRA ',
       '01',
       '0N',
       '',
       '',
       'PRO.FILMAT(+) = GRA.FILMAT and
PRO.CODMAT(+) = GRA.CODMAT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21242,
       'PXF ',
       'GRA ',
       '0N',
       '1',
       '',
       '',
       'GRA.FILMAT(+) = PXF.FILMAT AND
GRA.CODMAT(+) = PXF.CODMAT AND
GRA.CODCOR(+) = PXF.CODCOR AND
GRA.CODTAM(+) = PXF.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21243,
       'PRE ',
       'GRA ',
       'N',
       '1',
       '',
       '',
       'PRE.FILMAT = GRA.FILMAT and
PRE.CODMAT = GRA.CODMAT and
PRE.CODCOR = GRA.CODCOR and
PRE.CODTAM = GRA.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21244,
       'RCXG',
       'GRA ',
       'N',
       '1',
       '',
       '',
       'RCXG.FILMAT = GRA.FILMAT and
RCXG.CODMAT = GRA.CODMAT and
RCXG.CODCOR = GRA.CODCOR and
RCXG.CODTAM = GRA.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21245,
       'SUB ',
       'GRA ',
       'N',
       '1',
       '',
       '',
       'SUB.CODITE = GRA.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21246,
       'TTRA',
       'GRA ',
       'N',
       '1',
       '',
       '',
       'TTRA.FILMAT = GRA.FILMAT and
TTRA.CODMAT = GRA.CODMAT and
TTRA.CODCOR = GRA.CODCOR and
TTRA.CODTAM = GRA.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21247,
       'NCM ',
       'GRA ',
       '1',
       'N',
       '',
       '',
       'GRA.CODNCM = NCM.CODNCM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21248,
       'DIV ',
       'GRA ',
       'N',
       '1',
       '',
       '',
       'DIV.CODITE = GRA.CODCOR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22044,
       'DMOT',
       'GRA ',
       '01',
       '1',
       '',
       '',
       'DMOT.CODTAB(+) = GRA.CODMOT',
       '',
       '' FROM DUAL
);

/*-- SEQ 8093 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'GRA ',
       '16',
       2422,
       3,
       ':GRA.CODFILCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'V',
       '',
       '',
       'A',
       '',
       'Filial Qtde Comprada',
       'Filial Quantidade Comprada',
       '',
       ':GRA.CODFILCOM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '11',
       820,
       3,
       ':GRA.CODFILCRD',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Cdigo da Filial  ',
       'Cdigo da Filial',
       'GRA.:GRA.CODFILCRD=DFIL.CODFIL',
       ':GRA.CODFILCRD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '03',
       2540,
       3,
       ':GRA.CODFILDEP',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial Depsito',
       'Filial do Depsito',
       'GRA.:GRA.CODFILDEP = DFIL.CODFIL(+)',
       ':GRA.CODFILDEP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '12',
       380,
       3,
       ':GRA.CODFILGIR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial Giro',
       'Filial Giro',
       ':GRA.CODFIL = DFIL.CODFIL(+)',
       ':GRA.CODFILGIR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '02',
       430,
       3,
       ':GRA.CODFILLOC',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial Locao',
       'Filial Locao',
       ':GRA.CODFILLOC = DFIL.CODFIL(+)',
       ':GRA.CODFILLOC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '08',
       600,
       3,
       ':GRA.CODFILPP',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial PP',
       'Filial PP',
       'GRA.:GRA.CODFILPP = DFIL.CODFIL',
       ':GRA.CODFILPP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '03',
       460,
       3,
       ':GRA.CODFILSDF',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial SDF',
       'Filial SDF',
       'GRA.:GRA.CODFILSDF = DFIL.CODFIL(+)',
       ':GRA.CODFILSDF',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '04',
       490,
       3,
       ':GRA.CODFILVTC',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial VTC',
       'Filial VTC',
       'GRA.:GRA.CODFILVTC = DFIL.CODFIL(+)',
       ':GRA.CODFILVTC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '05',
       520,
       3,
       ':GRA.CODFILVTR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial VTR',
       'Filial VTR',
       'GRA.:GRA.CODFILVTR = DFIL.CODFIL(+)',
       ':GRA.CODFILVTR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '11',
       830,
       5,
       ':GRA.CODMULCRD',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       '9',
       '',
       'Cd.Mltiplo Estoque',
       'Cdigo Mltiplo Estoque',
       'GRA.:GRA.CODMULCRD = DMUL.CODTAB',
       ':GRA.CODMULCRD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '14',
       950,
       8,
       ':GRA.COM_DATINI,GRA.COM_DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Datas com Estoque',
       'Datas com Estoque',
       '',
       ':GRA.COM_DATINI,GRA.COM_DATFIM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '02',
       410,
       8,
       ':GRA.DAT01,GRA.DAT02',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data',
       'Data',
       '',
       ':GRA.DAT01,GRA.DAT02',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '02',
       420,
       8,
       ':GRA.DATATE',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Manter At',
       'Manter At',
       '',
       ':GRA.DATATE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '12',
       370,
       8,
       ':GRA.DATINI,GRA.DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data',
       'Data',
       '',
       ':GRA.DATINI,GRA.DATFIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '16',
       2421,
       8,
       ':GRA.DATINICOM,:GRA.DATFIMCOM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Qtde Comprada',
       'Data Quantidade Comprada',
       '',
       ':GRA.DATINICOM,:GRA.DATFIMCOM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '11',
       810,
       8,
       ':GRA.DATREFCRD',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Referncia',
       'Data de Referncia',
       '',
       ':GRA.DATREFCRD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '03',
       450,
       8,
       ':GRA.DATREFSDF',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Referncia',
       'Data Referncia',
       '',
       ':GRA.DATREFSDF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '04',
       480,
       8,
       ':GRA.DATREFVTC',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Referncia',
       'Data Referncia',
       '',
       ':GRA.DATREFVTC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '05',
       510,
       8,
       ':GRA.DATREFVTR',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data VTR',
       'Data VTR',
       '',
       ':GRA.DATREFVTR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       2040,
       12,
       ':GRA.DESCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Vlr desconto compra',
       'Valor desconto da compra',
       '',
       ':GRA.DESCOM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '18',
       2401,
       3,
       ':GRA.FILIALQV',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial Qdade Compra',
       'Filial quantidade comprada',
       'GRA.:GRA.FILIALQV  = DFIL.CODFIL(+)',
       ':GRA.FILIALQV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '10',
       2580,
       3,
       ':GRA.FILIALVALORVENDIDO',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Valor Vendido',
       'Filial Valor Vendido',
       'GRA.:GRA.FILIALVALORVENDIDO  = DFIL.CODFIL(+)',
       ':GRA.FILIALVALORVENDIDO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '17',
       2381,
       3,
       ':GRA.FILIALVV',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial Valor Vendido',
       'Filial valor vendido',
       'GRA.:GRA.FILIALVV  = DFIL.CODFIL(+)',
       ':GRA.FILIALVV',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '14',
       970,
       3,
       ':GRA.FILIAL_COM_ESTOQUE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial com Estoque',
       'Filial com Estoque',
       ':GRA.FILIAL_COM_ESTOQUE = DFIL.CODFIL(+)',
       ':GRA.FILIAL_COM_ESTOQUE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '15',
       1010,
       3,
       ':GRA.FILIAL_NEG_ESTOQUE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial Estoque Neg.',
       'Filial Estoque Negativo',
       'GRA.:GRA.FILIAL_NEG_ESTOQUE = DFIL.CODFIL(+)',
       ':GRA.FILIAL_NEG_ESTOQUE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '13',
       930,
       3,
       ':GRA.FILIAL_SEM_ESTOQUE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial Sem Estoque',
       'Filial Sem Estoque',
       ':GRA.FILIAL_SEM_ESTOQUE = DFIL.CODFIL(+)',
       ':GRA.FILIAL_SEM_ESTOQUE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '15',
       990,
       8,
       ':GRA.NEG_DATINI,GRA.NEG_DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Datas Estoque Neg.',
       'Datas Estoque Neg.',
       '',
       ':GRA.NEG_DATINI,GRA.NEG_DATFIM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '18',
       2402,
       8,
       ':GRA.QTDCOMPINI,GRA.QTDCOMPFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Datas Qtd. Comprada',
       'Datas Qtd. Comprada',
       '',
       ':GRA.QTDCOMPINI,GRA.QTDCOMPFIM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '09',
       620,
       8,
       ':GRA.SALDOPERIODO_DATINI,GRA.S',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Perodo',
       'Periodo',
       '',
       ':GRA.SALDOPERIODO_DATINI,GRA.SALDOPERIODO.DATFIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '13',
       910,
       8,
       ':GRA.SEM_DATINI,GRA.SEM_DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Sem Estoque',
       'Data sem Estoque',
       '',
       ':GRA.SEM_DATINI,GRA.SEM_DATFIM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '02',
       400,
       1,
       ':GRA.TIPPRJ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Tipo de Projeo',
       'Tipo de Projeo',
       '',
       ':GRA.TIPPRJ',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '17',
       2382,
       8,
       ':GRA.VLRCOMPINI,GRA.VLRCOMPFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Datas Vlr Comprado',
       'Datas Vlr Comprado',
       '',
       ':GRA.VLRCOMPINI,GRA.VLRCOMPFIM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '10',
       640,
       8,
       ':GRA.VLRVENDATINI,GRA.VLRVENDA',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Perodo',
       'Periodo',
       '',
       ':GRA.VLRVENDATINI,GRA.VLRVENDATFIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '19',
       2600,
       8,
       ':GRA.VVDATINI,GRA.VVDATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Perodo',
       'Perodo',
       '',
       ':GRA.VVDATINI,GRA.VVDATFIM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2240,
       8,
       ':VEN_DATHOR',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Ultima Venda',
       'Ultima Venda',
       '',
       '(SELECT MAX(IIVE.VEN_DATHOR) FROM TT_IVE IIVE WHERE IIVE.FILMAT=GRA.FILMAT AND IIVE.CODMAT=GRA.CODMAT AND IIVE.CODCOR=GRA.CODCOR AND IIVE.CODTAM=GRA.CODTAM)
',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2050,
       5,
       'AFICUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '%Acrs Financeiro',
       '%Acrscimo Financeiro',
       '',
       'AFICUS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '--',
       2180,
       5,
       'ALIFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% ICMS do Frete',
       '% ICMS do Frete',
       '',
       'ALIFRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2320,
       10,
       'ALTURA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Altura (cm)',
       'Altura (cm)',
       '',
       'ALTURA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2630,
       4,
       'ANOFAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Ano Fabricacao Veic',
       'Ano de Fabricao do Veculo',
       '',
       'ANOFAB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2700,
       8,
       'ANOFIMPROD',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Ano Fim. Produo',
       'Ano de Fim da Produo',
       '',
       'ANOFIMPROD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2690,
       8,
       'ANOINIPROD',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Ano Ini. Produo',
       'Ano de Inco da Produo',
       '',
       'ANOINIPROD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2640,
       4,
       'ANOMOD',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Ano Modelo Veic.',
       'Ano do Modelo do Veculo',
       '',
       'ANOMOD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       180,
       4,
       'ANO_DATCOM',
       'A',
       '',
       0,
       0,
       'GRA ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'GRA',
       '',
       'N',
       'T',
       'Ano de Ultima Compra',
       'Ano de Data da compra',
       '',
       'TO_CHAR(GRA.DATCOM,''YYYY'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '--',
       2300,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Assinatura para PAF-ECF',
       '',
       'ASSINA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       2060,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data da Atualizao',
       'Data da Atualizao',
       '',
       'ATU_EM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '16',
       2420,
       12,
       'AUXCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Quantidade Comprada',
       'Quantidade Comprada',
       '',
       'AUX_Comprado(:GRA.DATINICOM,:GRA.DATFIMCOM,:GRA.FILMAT,:GRA.CODMAT,:GRA.CODCOR,:GRA.COTAM,:GRA.FILCOM)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2520,
       7,
       'BALTAR',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Tara para Balana',
       'Tara para Balana',
       '',
       'BALTAR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       800,
       7,
       'CAL_CM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Clculo Custo M',
       'Data Cculo Custo Mdio',
       '',
       'CAL_CM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       60,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       0,
       'GRA ',
       30,
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       'GRA',
       'F',
       'N',
       'T',
       'Diviso',
       'Diviso do produto',
       'GRA.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2680,
       5,
       'CODCORVEI',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cod. Cor do Veculo',
       'Cdigo da Cor do Veculo',
       '',
       'CODCORVEI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       1040,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2492,
       60,
       'CODFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Cdigo Fiscal',
       'Cdigo Fiscal',
       '',
       'CODFIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       20,
       5,
       'CODMAT',
       'A',
       '',
       0,
       0,
       'GRA ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'GRA',
       'F',
       '9',
       'F',
       '',
       'Cdigo do material',
       '',
       'CODMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2620,
       5,
       'CODMOT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cod. Motor Veic.',
       'Cdigo  do Motor do Veculo',
       '',
       'CODMOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2250,
       8,
       'CODNCM',
       'A',
       'PRO ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'PRO.CODNCM',
       'A',
       '',
       '',
       'A',
       'F',
       '#Cdigo NCM',
       'Cdigo NCM (descontinuado)',
       'PRO.FILMAT = GRA.FILMAT AND PRO.CODMAT = GRA.CODMAT',
       '(SELECT PRO.CODNCM FROM TT_PRO PRO WHERE GRA.FILMAT = PRO.FILMAT AND GRA.CODMAT = PRO.CODMAT)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2580,
       40,
       'CODPOS_GRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo POS CONTROLE',
       'Cdigo POS CONTROLE',
       '',
       'CODPOS_GRA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       70,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       0,
       'GRA ',
       40,
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       'GRA',
       'F',
       'N',
       'T',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'GRA.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '--',
       2310,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Identificao de Acesso',
       '',
       'CODUID',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       320,
       10,
       'CONAPL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Unidade Embalagem',
       'Converso para unidade de Embalagem',
       '',
       'CONAPL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2670,
       1,
       'CONVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Condio VIN Veic.',
       'Condio do Vin do Veculo',
       '',
       'CONVIN',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       300,
       16,
       'CUSFRE',
       'F',
       '',
       6,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Custo Frete',
       'Custo Frete',
       '',
       'CUSFRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       190,
       14,
       'CUSREP',
       'F',
       '',
       4,
       0,
       'GRA ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'GRA',
       'T',
       '',
       'T',
       'Custo de Reposio',
       'Custo de reposio deste produto no estoque',
       '',
       'CUSREP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '11',
       800,
       12,
       'CUSTOREPOSICAODATA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Custo Reposio/Data',
       'Gera Custo de Reposio a partir de Data Informada, Retorna Saldo.',
       '',
       'CUSTOREPOSICAODATA(:GRA.DATREFCRD,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,:GRA.CODFILCRD,:GRA.CODMULCRD)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2070,
       5,
       'DACCUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '% Desc/Acrscimo',
       '% Desconto/Acrscimo para clculo de Preo de Venda',
       '',
       'DACCUS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       160,
       8,
       'DATCOM',
       'D',
       '',
       0,
       0,
       'GRA ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'GRA',
       'F',
       'D',
       'T',
       'Ultima Compra',
       'Data da compra',
       '',
       'DATCOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '--',
       2260,
       7,
       'DATFPV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATFPV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       650,
       12,
       'DESCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Desconto',
       'Desconto',
       '',
       'DESCOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       81,
       120,
       'DESGRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio da Grade',
       'Descrio da Grade',
       '',
       'DESGRA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '--',
       1050,
       14,
       'DESICO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Desc. Ico.',
       'Desc. Ico.',
       '',
       'DESICO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       220,
       8,
       'DESIDE',
       'F',
       '',
       2,
       0,
       'GRA ',
       170,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'GRA',
       'T',
       '',
       'T',
       'Desconto Sugerido',
       'Desconto Sugerido',
       '',
       'DESIDE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       210,
       8,
       'DESMAX',
       'F',
       '',
       2,
       0,
       'GRA ',
       160,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'GRA',
       'T',
       '',
       'T',
       'Desconto Mximo',
       'Desconto Mximo',
       '',
       'DESMAX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2350,
       1,
       'DESTAQ',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Destaque?',
       'Destaque?',
       '',
       'DESTAQ',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '14',
       940,
       12,
       'DIASDEESTOQUE_COM_ESTOQUE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Dias com Estoque',
       'Dias com Estoque',
       '',
       'DIASDEESTOQUE(''C'', :GRA.COM_DATINI, :GRA.COM_DATFIM, GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, :GRA.FILIAL_COM_ESTOQUE, 0)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '15',
       980,
       12,
       'DIASDEESTOQUE_NEGATIVO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'DiasEstoque Negativo',
       'Dias Estoque Negativo',
       '',
       'DIASDEESTOQUE(''-'', :GRA.NEG_DATINI, :GRA.NEG_DATFIM, GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, :GRA.FILIAL_NEG_ESTOQUE, 0)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '13',
       900,
       12,
       'DIASDEESTOQUE_SEM_ESTOQUE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Dias Sem Estoque',
       'Dias Sem Estoque',
       '',
       'DIASDEESTOQUE(''S'', :GRA.SEM_DATINI, :GRA.SEM_DATFIM, GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, :GRA.FILIAL_SEM_ESTOQUE, 0)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '--',
       2560,
       1,
       'DUMMY',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       '',
       'Dummy',
       '',
       'DUMMY',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2502,
       1,
       'ENVECO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Envia p/ E-commerce?',
       'Envia para E-commerce?',
       '',
       'ENVECO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2503,
       1,
       'SKYHUB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Envia p/ Skyhub?',
       'Envia para Skyhub?',
       '',
       'SKYHUB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       660,
       3,
       'FILCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Compra',
       'Filial Compra',
       '',
       'FILCOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2590,
       3,
       'FILCOM_ANT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       '',
       'Filial Penltima Com',
       'Filial Penltima Compra',
       '',
       'FILCOM_ANT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       10,
       3,
       'FILMAT',
       'A',
       '',
       0,
       0,
       'GRA ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'GRA',
       'F',
       'N',
       'F',
       'Filia do Material',
       'Filial do material',
       '',
       'FILMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2080,
       3,
       'FILPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Filial do Pedido',
       'Filial do Pedido',
       '',
       'FILPED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2462,
       3,
       'FILRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial de reserva',
       'Filial de reserva padro para o produto',
       '',
       'FILRES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       670,
       1,
       'FORLIN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Fora de Linha?',
       'Fora de Linha',
       '',
       'FORLIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '--',
       2270,
       1,
       'FORPRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FORPRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '--',
       2502,
       1,
       'GRAABC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'ABC Calculado',
       'Clculo ABC na Grade',
       '',
       'GRAABC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       2090,
       1,
       'GRAATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Ativo',
       'Item de Grade Ativo',
       '',
       'GRAATI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '--',
       2512,
       1,
       'GRAXYZ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'XYC Calculado',
       'Clculo XYZ na Grade',
       '',
       'GRAXYZ',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '12',
       360,
       12,
       'GiroEstoque',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Giro de Estoque',
       'Giro de Estoque',
       '',
       'GiroEstoque(:GRA.DATINI,:GRA.DATFIM,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,:GRA.CODFILGIR)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       680,
       14,
       'ICMCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'ICMS Compra',
       'ICMS Compra',
       '',
       'ICMCOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2100,
       14,
       'ICMCUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '% ICMS Custo',
       '% de ICMS para Formao do Preo de Venda',
       '',
       'ICMCUS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       690,
       14,
       'ICMFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% ICMS Frete',
       '% ICMS Frete',
       '',
       'ICMFRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       2110,
       1,
       'ICMTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Tributao',
       'Tipo de Tributao para a Formao do Preo de Venda',
       '',
       'ICMTIP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2530,
       255,
       'IMGGRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome da imagem',
       'Nome da imagem',
       '',
       'IMGGRU',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       700,
       14,
       'IPICOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'IPI Compra',
       'IPI Compra',
       '',
       'IPICOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2120,
       12,
       'IPICUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '% IPI Custo',
       '% de IPI para Formao do Preo de Venda',
       '',
       'IPICUS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2200,
       12,
       'IPIFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor IPI do Frete',
       'Valor IPI do Frete',
       '',
       'IPIFRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       710,
       5,
       'ITECOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Itens de Compra',
       'Itens de Compra',
       '',
       'ITECOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2610,
       10,
       'ITECOM_ANT',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       '',
       'Item Penltima Com',
       'Item Penltima Compra',
       '',
       'ITECOM_ANT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2130,
       5,
       'ITEPED',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Itens do Pedido',
       'Itens do Pedido',
       '',
       'ITEPED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2330,
       10,
       'LARGUR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Largura (cm)',
       'Largura (cm)',
       '',
       'LARGUR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       250,
       10,
       'LOCALI',
       'A',
       '',
       0,
       0,
       'GRA ',
       200,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'GRA',
       'F',
       'A',
       'T',
       'Localizao',
       'Localizao',
       '',
       'LOCALI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       720,
       14,
       'MARKUP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Markup',
       'Markup',
       '',
       'MARKUP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2570,
       3,
       'MAXPAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Mximo de parcelas',
       'Nmero mximo de parcelas na venda',
       '',
       'MAXPAR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       170,
       2,
       'MES_DATCOM',
       'A',
       '',
       0,
       0,
       'GRA ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'GRA',
       '',
       'N',
       'T',
       'Ms de Ultima Compra',
       'Ms de Data da compra',
       '',
       'TO_CHAR(GRA.DATCOM,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       90,
       8,
       'MINQTD',
       'F',
       '',
       2,
       0,
       'GRA ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'GRA',
       'T',
       '',
       'T',
       'Estoque Mnimo',
       'Estoque mnimo',
       '',
       'MINQTD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '--',
       2280,
       14,
       'MVACOM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '% MVA',
       '% MVA',
       '',
       'MVACOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       2522,
       255,
       'NOMPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome Produto',
       'Descrio Completa do Material',
       '',
       'NomeProduto(PRO.DESECF, PRO.DESMAT, GRA.CODCOR, DIV.NOMITE, GRA.CODTAM, SUB.NOMITE, PRO.ESPMAT, GRA.DESGRA, DIV.NOMEXT, SUB.NOMEXT)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2140,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero do Pedido',
       'Nmero do Pedido que atualizou os custos',
       '',
       'NUMPED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       730,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2150,
       1,
       'ORICUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem dos Custos',
       'Origem dos Custos',
       '',
       'ORICUS',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2160,
       12,
       'OUTCUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Out. Custos p/ Preo',
       'Outros Custos para Formao do Preo de Venda',
       '',
       'OUTCUS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '08',
       590,
       12,
       'PEDIDOPENDENTE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Pedidos Pendentes',
       'Traz a quantidade pendente de pedidos nao recebidos',
       '',
       'PEDIDOPENDENTE(:GRA.CODFILPP,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       240,
       8,
       'PERCOM',
       'F',
       '',
       2,
       0,
       'GRA ',
       190,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'GRA',
       'T',
       '',
       'T',
       '% Comissao',
       'Percentual de Comisso',
       '',
       'PERCOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '--',
       2170,
       12,
       'PERFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '% Frete Custo',
       '% Frete Custo',
       '',
       'PERFRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2432,
       5,
       'PERIND',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '% Comisso Indicador',
       ' % Comisso para Indicador',
       '',
       'PERIND',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       230,
       8,
       'PERLUC',
       'F',
       '',
       2,
       0,
       'GRA ',
       180,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'GRA',
       'T',
       '',
       'T',
       '% de Lucro',
       '% de Lucro',
       '',
       'PERLUC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2472,
       5,
       'PERTOLREP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Tolerncia C.Rep',
       '% Margem de Tolerncia para Custo de Reposio',
       '',
       'PERTOLREP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       130,
       14,
       'PESBRU',
       'F',
       '',
       4,
       0,
       'GRA ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'GRA',
       'T',
       '',
       'T',
       'Peso Bruto',
       'Peso bruto',
       '',
       'PESBRU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       120,
       14,
       'PESLIQ',
       'F',
       '',
       4,
       0,
       'GRA ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'GRA',
       'T',
       '',
       'T',
       'Peso Lquido',
       'Peso lquido',
       '',
       'PESLIQ',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       150,
       14,
       'PRECOM',
       'F',
       '',
       4,
       0,
       'GRA ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'GRA',
       'T',
       '',
       'T',
       'Preo de Compra',
       'Preo de compra',
       '',
       'PRECOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       2290,
       14,
       'PREFIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Preo Fiscal',
       'Preo Fiscal (Mximo, Sugesto ou Pauta)',
       '',
       'PREFIS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       740,
       1,
       'PREPSI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Preo Psicolgico?',
       'Preo Psicolgico',
       '',
       'PREPSI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2340,
       10,
       'PROFUN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Profundidade (cm)',
       'Profundidade (cm)',
       '',
       'PROFUN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       140,
       1,
       'PROMOC',
       'L',
       '',
       0,
       0,
       'GRA ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'GRA',
       'F',
       '',
       'T',
       'Promocional?',
       'Indica se produto  promocional',
       '',
       'PROMOC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       100,
       8,
       'PTOQTD',
       'F',
       '',
       2,
       0,
       'GRA ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'GRA',
       'T',
       '',
       'T',
       'Ponto de Pedido',
       'Ponto de pedido',
       '',
       'PTOQTD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2442,
       12,
       'QTDBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade de bnus',
       'Quantidade de bnus para o produto',
       '',
       'QTDBON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       750,
       12,
       'QTDCOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade Compra',
       'Quantidade Compra',
       '',
       'QTDCOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       330,
       10,
       'QTDEMB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Contedo Embalagem',
       'Contedo da Embalagem',
       '',
       'QTDEMB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '--',
       2360,
       7,
       'QTDMUL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Quantidade Mltipla',
       'Define mltiplos de quantidade que podem ser vendidos',
       '',
       'QTDMUL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       110,
       8,
       'QTDREP',
       'F',
       '',
       2,
       0,
       'GRA ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'GRA',
       'T',
       '',
       'T',
       'Ideal de Reposio',
       'Quantidade ideal de reposiao',
       '',
       'QTDREP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '18',
       2400,
       5,
       'QTD_COMPRA_PRODUTO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Qtd. Comprada',
       'Qtd. Comprada',
       '',
       'QTDCOMPRAPRODUTO(:GRA.QTDCOMPINI, :GRA.QTDCOMPFIM,GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, :GRA.FILIALQV)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       80,
       20,
       'REFPRO',
       'A',
       '',
       0,
       0,
       'GRA ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'GRA',
       'F',
       'A',
       'T',
       'Referncia',
       'Referncia do produto',
       '',
       'REFPRO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       1025,
       12,
       'SALDOEMTRANSITO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo em Transito',
       'Saldo em Transito',
       '',
       'SALDOEMTRANSITO(GRA.FILMAT, GRA.CODMAT, GRA.CODCOR,GRA.CODTAM)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '09',
       610,
       12,
       'SALDOPERIODO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Saldo no Perodo',
       'Saldo no Periodo',
       '',
       'SALDOPERIODO(GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,:GRA.SALDOPERIODO_DATINI,:GRA.SALDOPERIODO.DATFIM)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '03',
       440,
       20,
       'SALDO_FILIAL_STRING',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Saldo Filial String',
       'Saldo da Filial String',
       '',
       'TO_CHAR(SALDODAFILIAL(:GRA.DATREFSDF,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,:GRA.CODFILSDF))',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '09',
       615,
       20,
       'SALDO_PERIODO_STRING',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Saldo Periodo String',
       'Saldo Perodo String',
       '',
       'TO_CHAR(SALDOPERIODO(GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,:GRA.SALDOPERIODO_DATINI,:GRA.SALDOPERIODO.DATFIM))',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       760,
       12,
       'SEGFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Seguro Frete',
       'Seguro Frete',
       '',
       'SEGFRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       770,
       10,
       'SEQCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '',
       'Sequenciador Compra',
       '',
       'SEQCOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2600,
       10,
       'SEQCOM_ANT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Seq Penltima Com',
       'Sequenciador Penltima Compra',
       '',
       'SEQCOM_ANT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       310,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       'ELA, JUNTO COM FILMAT, PASSA A SER UMA CHAVE ALTERNATIVA (ALTERNATE KEY) PARA A TABELA DE GRADES (SIDNEI)',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       780,
       12,
       'SUBCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Sub Diviso Compra',
       'Subdiviso Compra',
       '',
       'SUBCOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '03',
       445,
       8,
       'SaldoDaFilial',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Saldo da Filial',
       'Saldo da Filial',
       '',
       'SaldoDaFilial(:GRA.DATREFSDF,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,:GRA.CODFILSDF)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '03',
       2550,
       8,
       'SaldoDoDeposito',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo Depsito',
       'Saldo do Depsito',
       '',
       'SaldoDaFilial(:GRA.DATREFSDF,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,:GRA.CODFILDEP)
',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '02',
       390,
       12,
       'SugestaoCompra',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Sugesto Compra',
       'Sugesto de Compra',
       '',
       'SugestaoCompra(:GRA.TIPPRJ,:GRA.DAT01,:GRA.DAT02,:GRA.DATATE,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,:GRA.CODFILLOC)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       790,
       14,
       'TAXCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Taxa Compra',
       'Taxa Compra',
       '',
       'TAXCOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       200,
       2,
       'TEMREP',
       'S',
       '',
       0,
       0,
       'GRA ',
       150,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'GRA',
       'F',
       '9',
       'T',
       'Tempo de Reposio',
       'Tempo de Reposio',
       '',
       'TEMREP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2660,
       1,
       'TIPPIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo Pintura Veic.',
       'Tipo de Pintura do Veculo',
       '',
       'TIPPIN',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       30,
       1,
       'TIPVAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       '',
       'F',
       'Expressa em',
       'Expressa em',
       '',
       'TIPVAL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       2230,
       7,
       'ULTBAS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '% ltima Reduo',
       '% ltima Reduo',
       '',
       'ULTBAS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       44,
       3,
       'ULTCSTCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'ltimo CST Compra',
       'ltimo CST Compra',
       '',
       '(SELECT ICO.CODCST FROM TT_ICO ICO WHERE ICO.NUMITE = GRA.ITECOM AND ICO.SEQUEN = GRA.SEQCOM AND ICO.CODFIL = GRA.FILCOM)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       1020,
       12,
       'ULTIMO_ICMS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '% ICMS',
       '% ICMS',
       '',
       'RETORNAICMS(GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       1030,
       12,
       'ULTIMO_IPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '% IPI',
       '% IPI',
       '',
       '(SELECT MAX(ICO.IPIITE) FROM TT_ICO ICO WHERE ICO.FILMAT = GRA.FILMAT AND ICO.CODMAT = GRA.CODMAT AND ICO.CODCOR = GRA.CODCOR AND ICO.CODTAM = GRA.CODTAM AND  ICO.COM_DATOPE = (SELECT MAX(ICO.COM_DATOPE)   FROM TT_ICO)
)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       340,
       5,
       'UNIAPL',
       'S',
       'DMED',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMED.UNIMED',
       'V',
       '',
       '',
       '9',
       'F',
       'Unidade Aplicao',
       'Unidade de Aplicao',
       'DMED.CODTAB(+) = GRA.UNIAPL',
       'UNIAPL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       270,
       5,
       'UNIDAD',
       'S',
       'DMED',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMED.UNIMED',
       'V',
       '',
       'F',
       'N',
       'F',
       'Unidade de Venda',
       'Unidade de Venda',
       'DMED.CODTAB = GRA.UNIDAD',
       'UNIDAD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       350,
       5,
       'UNIEMB',
       'S',
       'DMED',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMED.UNIMED',
       'V',
       '',
       '',
       '0',
       'F',
       'Unidade Embalagem',
       'Unidade Embalagem',
       'DMED.CODTAB = GRA.UNIEMB',
       'UNIEMB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       280,
       5,
       'UNIFOR',
       'S',
       'DMED',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMED.UNIMED',
       'V',
       '',
       'F',
       'N',
       'F',
       'Unidade Compra',
       'Unidade Compra',
       'DMED.CODTAB = GRA.UNIFOR',
       'UNIFOR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2452,
       1,
       'USABON',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa bnus?',
       'Usa bnus?',
       '',
       'USABON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       260,
       1,
       'UsaCodSal',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Controla~Estoque',
       'Controla Estoque',
       '',
       'UsaCodSal(GRA.CODTAM)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       290,
       12,
       'VALCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Fator Converso',
       'Fator Converso',
       '',
       'VALCON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       40,
       5,
       'VALIDA',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Garantia/Validade',
       'Garantia/Validade',
       '',
       'VALIDA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '10',
       630,
       12,
       'VALORVENDIDO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Vendido Filial',
       'Valor Vendido por Filial',
       '',
       'VALORVENDAPRODUTO(:GRA.VLRVENDATINI,:GRA.VLRVENDATFIM,GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, :GRA.FILIALVALORVENDIDO)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '19',
       2590,
       12,
       'VALORVENDIDO_SEM_FILIAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Valor Vendido',
       'Valor Vendido',
       '',
       'VALORVENDAPRODUTO(:GRA.VVDATINI,:GRA.VVDATFIM,GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, NULL)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '20',
       2710,
       20,
       'STATUSKIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Status KIT',
       'Status KIT',
       '',
       'VERIFICASTATUSKIT(IPRF.FILMAT,IPRF.CODMAT,IPRF.CODCOR,IPRF.CODTAM)',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '20',
       2720,
       20,
       'REFKIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Referncia KIT',
       'Referncia Venda KIT',
       '',
       'REFERENCIAGRADEHEADERKIT(IPRF.FILMAT,IPRF.CODMAT,IPRF.CODCOR,IPRF.CODTAM)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '17',
       2380,
       12,
       'VALOR_COMPRA_PRODUTO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Valor Comprado',
       'Valor comprado',
       '',
       'VALORCOMPRAPRODUTO(:GRA.VLRCOMPINI, :GRA.VLRCOMPFIM,GRA.FILMAT, GRA.CODMAT, GRA.CODCOR, GRA.CODTAM, :GRA.FILIALVV)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '99',
       2482,
       12,
       'VLRTOLREP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'V Tolerncia C.Rep',
       'Valor de Margem de Tolerncia para Custo de Reposio',
       '',
       'VLRTOLREP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '04',
       470,
       8,
       'VLRTOTCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor total Compra',
       'Valor Total da Compra',
       '',
       'SaldoDaFilial(:GRA.DATREFVTC,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,:GRA.CODFILVTC)*PRECOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '05',
       500,
       8,
       'VLRTOTREP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr Total Reposio',
       'Valor Total Reposio',
       '',
       'SaldoDaFilial(:GRA.DATREFVTR,GRA.FILMAT,GRA.CODMAT,GRA.CODCOR,GRA.CODTAM,:GRA.CODFILVTR)*CUSREP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       2190,
       15,
       'VOLUME',
       'F',
       '',
       5,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Volume m3',
       'Volume m3',
       '',
       'VOLUME',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'GRA ',
       '01',
       50,
       1,
       'VOLUNI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'N',
       'F',
       'Volume nico?',
       'Volume nico?',
       '',
       'VOLUNI',
       'F',
       'D' FROM DUAL
);

/*-- SEQ 8094 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'GRA ',
       'CONVIN',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'CONVIN',
       0,
       'R',
       'Remarcado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'GRAABC',
       0,
       'A',
       'A',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'GRAABC',
       0,
       'B',
       'B',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'GRAABC',
       0,
       'C',
       'C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'GRAXYZ',
       0,
       'X',
       'X',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'GRAXYZ',
       0,
       'Y',
       'Y',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'GRAXYZ',
       0,
       'Z',
       'Z',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'ICMTIP',
       0,
       '0',
       'Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'ICMTIP',
       0,
       '1',
       'No-Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'ICMTIP',
       0,
       '2',
       'Isento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'ICMTIP',
       0,
       '3',
       'Substitudo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'ICMTIP',
       0,
       '4',
       'Isento no Estado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'ORICUS',
       0,
       'C',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'ORICUS',
       0,
       'M',
       'Manual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'ORICUS',
       0,
       'P',
       'Pedido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'TIPPIN',
       0,
       'C',
       'Candy',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'TIPPIN',
       0,
       'F',
       'Falke',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'TIPPIN',
       0,
       'M',
       'Metlico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'TIPPIN',
       0,
       'P',
       'Perolizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'TIPPIN',
       0,
       'S',
       'Slido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'TIPVAL',
       0,
       ' ',
       'No Controla',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'TIPVAL',
       1,
       ' ',
       'Dias',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'TIPVAL',
       2,
       ' ',
       'Meses',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'TIPVAL',
       3,
       ' ',
       'Anos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'STATUSKIT',
       0,
       '',
       'KIT',
       TO_NUMBER(null),
       '1' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'STATUSKIT',
       0,
       '',
       'Normal',
       TO_NUMBER(null),
       '2' FROM DUAL
UNION ALL
SELECT 'GRA ',
       'STATUSKIT',
       0,
       '',
       'Item de KIT',
       TO_NUMBER(null),
       '3' FROM DUAL
);

/*-- SEQ 8095 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'GRAC',
       TO_NUMBER(null),
       'GRAC',
       'Grade/Tipo Carto',
       'TT_GRAXDCAR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8096 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'GRAC','--','' FROM DUAL
UNION ALL
SELECT 'GRAC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'GRAC','99','Outros' FROM DUAL
);

/*-- SEQ 8097 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20616,
       'GRA ',
       'GRAC',
       '1',
       '0N',
       '',
       '',
       'GRAC.FILMAT = GRA.FILMAT AND
GRAC.CODMAT = GRA.CODMAT AND
GRAC.CODCOR = GRA.CODCOR AND
GRAC.CODTAM = GRA.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 8098 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'GRAC',
       '--',
       40,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'GRAC',
       '--',
       80,
       5,
       'CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Diviso',
       'Cdigo da Diviso',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'GRAC',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'GRAC',
       '--',
       70,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo da Grade',
       'Cdigo da Grade',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'GRAC',
       '--',
       90,
       5,
       'CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Subdiviso',
       'Cdigo da Subdiviso',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'GRAC',
       '--',
       30,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'GRAC',
       '--',
       60,
       1,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial da Grade',
       'Filial da Grade',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'GRAC',
       '--',
       100,
       6,
       'PROTEF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd Prod Cad no Tef',
       'Cdigo do Produto Cadastrado no TEF',
       '',
       'PROTEF',
       'F' FROM DUAL
UNION ALL
SELECT 'GRAC',
       '--',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'GRAC',
       '--',
       50,
       1,
       'TIPCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Carto',
       'Tipo Carto',
       '',
       'TIPCAR',
       'T' FROM DUAL
);

/*-- SEQ 8099 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'GRAC',
       'TIPCAR',
       0,
       'C',
       'Gcard',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRAC',
       'TIPCAR',
       0,
       'D',
       'StandByDup',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRAC',
       'TIPCAR',
       0,
       'F',
       'FortCard',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRAC',
       'TIPCAR',
       0,
       'G',
       'Gax',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRAC',
       'TIPCAR',
       0,
       'L',
       'ValeShop',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRAC',
       'TIPCAR',
       0,
       'M',
       'SmartN',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRAC',
       'TIPCAR',
       0,
       'E',
       'SenffNet',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRAC',
       'TIPCAR',
       0,
       'P',
       'PoliCard',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRAC',
       'TIPCAR',
       0,
       'R',
       'Repom',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRAC',
       'TIPCAR',
       0,
       'S',
       'StandBy',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRAC',
       'TIPCAR',
       0,
       'T',
       'Ticket Car',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GRAC',
       'TIPCAR',
       0,
       'V',
       'Vale Card',
       TO_NUMBER(null),
       ' ' FROM DUAL
);
/*-- SEQ 8100 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'GRU ',
       TO_NUMBER(null),
       'GRU ',
       'Agrupador de Colunas',
       'TT_GRU',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'GRU.CODTAB,GRU.CODGRU',
       '' FROM DUAL
);

/*-- SEQ 8101 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'GRU ','--','' FROM DUAL
);

/*-- SEQ 8102 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'GRU ',
       '--',
       2,
       2,
       'CODGRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo do Grupo',
       'Cdigo Grupo',
       '',
       'CODGRU',
       'F' FROM DUAL
UNION ALL
SELECT 'GRU ',
       '--',
       1,
       4,
       'CODTAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'GRU ',
       '--',
       3,
       72,
       'DESGRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio do Grupo',
       'Descrio do Grupo',
       '',
       'DESGRU',
       'F' FROM DUAL
);

/*-- SEQ 8103 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'GXMD',
       TO_NUMBER(null),
       'GXMD',
       'Grade X Modelo Veic.',
       'TT_GRAXMDV',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8104 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'GXMD','--','' FROM DUAL
UNION ALL
SELECT 'GXMD','01','Identificao' FROM DUAL
UNION ALL
SELECT 'GXMD','99','Outros' FROM DUAL
);

/*-- SEQ 8105 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22045,
       'DMDV',
       'GXMD',
       'N',
       '0N',
       '',
       '',
       'DMDV.CODTAB = GXMD.CODMDV(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22046,
       'DMOT',
       'GXMD',
       'N',
       '0N',
       '',
       '',
       'DMOT.CODTAB = GXMD.CODMOT(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8106 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'GXMD',
       '01',
       70,
       4,
       'ANOFIM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Ano Final',
       'Ano Final da Aplicao',
       '',
       'ANOFIM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GXMD',
       '01',
       130,
       8,
       'ANOFIMPROD',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Ano Fim. Produo',
       'Ano de Fim da Produo do Veculo',
       '',
       'ANOFIMPROD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GXMD',
       '01',
       60,
       4,
       'ANOINI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Ano Inicial',
       'Ano Inicial da Aplicao',
       '',
       'ANOINI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GXMD',
       '01',
       120,
       8,
       'ANOINIPROD',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Ano Ini. Produo',
       'Ano de Incio de Produo do Veculo',
       '',
       'ANOINIPROD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GXMD',
       '01',
       90,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GXMD',
       '01',
       150,
       8,
       'ATU_EMCAT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Atualizao Cat',
       'Data de Atualizao do Catlogo',
       '',
       'ATU_EMCAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GXMD',
       '01',
       100,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       '',
       'N',
       '',
       'Diviso',
       'Diviso do Produto',
       'GXMD.CODCOR = DIV.CODITE(+)',
       'CODCOR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GXMD',
       '01',
       10,
       10,
       'CODTAB',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo',
       'Cdigo do Registro',
       '',
       'CODTAB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GXMD',
       '01',
       30,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo do Produto',
       'Cdigo do Material',
       '',
       'CODMAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GXMD',
       '01',
       40,
       5,
       'CODMDV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo do Modelo',
       'Cdigo do Modelo do Veculo',
       '',
       'CODMDV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GXMD',
       '01',
       50,
       5,
       'CODMOT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo do Motor',
       'Cdigo do Motor do Veculo',
       '',
       'CODMOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GXMD',
       '01',
       110,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       '',
       'N',
       '',
       'Sub-Diviso',
       'Sub-Diviso do Produto',
       'GXMD.CODTAM = SUB.CODITE(+)',
       'CODTAM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'GXMD',
       '01',
       80,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GXMD',
       '01',
       140,
       8,
       'DATINCCAT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Incluso Cat.',
       'Data de Incluso do Catlogo',
       '',
       'DATINCCAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'GXMD',
       '01',
       20,
       3,
       'FILMAT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial do Produto',
       'Filial do Material',
       'GXMD.FILMAT = DFIL.CODFIL',
       'FILMAT',
       'T',
       'D' FROM DUAL
);

/*-- SEQ 8107 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'GXSC',
       TO_NUMBER(null),
       'GXSC',
       'Grade SelfColor',
       'TT_GRAXSC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'GXSC.FILMAT, GXSC.CODMAT, GXSC.CODCOR, GXSC.CODTAM',
       '' FROM DUAL
);

/*-- SEQ 8108 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'GXSC','--','' FROM DUAL
UNION ALL
SELECT 'GXSC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'GXSC','99','Outros' FROM DUAL
);

/*-- SEQ 8109 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22112,
       'GRA ',
       'GXSC',
       '0N',
       '1',
       '',
       '',
       'GXSC.FILMAT = GRA.FILMAT AND
GXSC.CODMAT = GRA.CODMAT AND
GXSC.CODCOR = GRA.CODCOR AND
GXSC.CODTAM = GRA.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 8110 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'GXSC',
       '01',
       50,
       5,
       'CODCOR',
       'G',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       '',
       'N',
       'F',
       'Diviso da grade',
       'Diviso do item da grade da base/colorao no Commerce',
       'DIV.CODITE = GXSC.CODCOR',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'GXSC',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial',
       'Filial do registro',
       'DFIL.CODFIL = GXSC.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'GXSC',
       '01',
       40,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo da grade',
       'Cdigo do item da grade da base/colorao no Commerce',
       '',
       'CODMAT',
       '' FROM DUAL
UNION ALL
SELECT 'GXSC',
       '01',
       60,
       5,
       'CODTAM',
       'G',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       '',
       'N',
       'F',
       'Subdiviso da grade',
       'Subdiviso do item da grade da base/colorao no Commerce',
       'SUB.CODITE = GXSC.CODTAM',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'GXSC',
       '01',
       90,
       10,
       'COD_BASE',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo da base',
       'Cdigo da base no Sistema Tintomtrico',
       '',
       'COD_BASE',
       '' FROM DUAL
UNION ALL
SELECT 'GXSC',
       '01',
       80,
       10,
       'COD_COLOR',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da colorao',
       'Cdigo da colorao no Sistema Tintomtrico',
       '',
       'COD_COLOR',
       'F' FROM DUAL
UNION ALL
SELECT 'GXSC',
       '01',
       100,
       10,
       'COD_EMBALAGEM',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo da embalagem',
       'Cdigo da embalagem no Sistema Tintomtrico',
       '',
       'COD_EMBALAGEM',
       '' FROM DUAL
UNION ALL
SELECT 'GXSC',
       '01',
       70,
       10,
       'COD_PRODUTO',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo do produto',
       'Cdigo do produto no Sistema Tintomtrico',
       '',
       'COD_PRODUTO',
       'F' FROM DUAL
UNION ALL
SELECT 'GXSC',
       '01',
       30,
       3,
       'FILMAT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial da grade',
       'Filial do item da grade da base/colorao no Commerce',
       'DFIL.CODFIL = GXSC.FILMAT',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'GXSC',
       '01',
       20,
       10,
       'ID',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Identificador',
       'Identificador do registro',
       '',
       'ID',
       '' FROM DUAL
UNION ALL
SELECT 'GXSC',
       '99',
       130,
       12,
       'PRECO_MIN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Preo mnimo',
       'Preo mnimo da Base + Colorantes',
       '',
       'PRECO_MIN',
       '' FROM DUAL
UNION ALL
SELECT 'GXSC',
       '01',
       120,
       1,
       'SISTIN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Sistema Tintomtrico',
       'Sistema Tintomtrico',
       '',
       'SISTIN',
       'T' FROM DUAL
UNION ALL
SELECT 'GXSC',
       '99',
       110,
       16,
       'VOLUME',
       'F',
       '',
       5,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Volume da embalagem',
       'Volume da embalagem no Sistema Tintomtrico',
       '',
       'VOLUME',
       '' FROM DUAL
);

/*-- SEQ 8111 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'GXSC',
       'SISTIN',
       0,
       ' ',
       'SelfColor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'GXSC',
       'SISTIN',
       1,
       ' ',
       'ShotColor',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8112 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'HND ',
       TO_NUMBER(null),
       'HND ',
       'BI_Histrico',
       'TT_HND',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'HND.CODFIL,HND.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8113 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'HND ','--','' FROM DUAL
UNION ALL
SELECT 'HND ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'HND ','99','Outros' FROM DUAL
);

/*-- SEQ 8114 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 5624,
       'USU ',
       'HND ',
       '01',
       '0N',
       '',
       '',
       'USU.FILUSU(+) = HND.FILUSU AND
USU.CODUSU(+) = HND.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 8115 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'HND ',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Codigo da Filial',
       'DFIL.CODFIL = HND.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'HND ',
       '--',
       20,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Usuario',
       'Codigo do Usuario',
       'USU.FILUSU(+) = HND.FILUSU AND USU.CODUSU(+) = HND.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'HND ',
       '--',
       30,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data e Hora Consulta',
       'Data e Hora da consulta',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'HND ',
       '--',
       40,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'HND ',
       '--',
       50,
       4000,
       'LOGCON',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Log',
       'Log',
       '',
       'RTF2TXT(LOGCON)',
       'F' FROM DUAL
UNION ALL
SELECT 'HND ',
       '--',
       60,
       30,
       'NOMCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Computador',
       'Nome do Computador',
       '',
       'NOMCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'HND ',
       '--',
       70,
       255,
       'NOMCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome da Consulta',
       'Nome da Consulta',
       '',
       'NOMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'HND ',
       '--',
       80,
       9,
       'QTDLIN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Linhas Geradas',
       'Quantidade de Linhas',
       '',
       'QTDLIN',
       'F' FROM DUAL
UNION ALL
SELECT 'HND ',
       '--',
       90,
       7,
       'QTDMIN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Acesso Banco(min)',
       'Consulta ao Banco em Minutos',
       '',
       'QTDMIN',
       'F' FROM DUAL
UNION ALL
SELECT 'HND ',
       '--',
       100,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'HND ',
       '--',
       110,
       1,
       'SERVER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Bi Server?',
       'Gerada pelo TotaliBI Server?',
       '',
       'SERVER',
       'F' FROM DUAL
UNION ALL
SELECT 'HND ',
       '--',
       120,
       4000,
       'SQLTXT',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'SQL',
       'SQL da consulta',
       '',
       'RTF2TXT(SQLTXT)',
       'F' FROM DUAL
UNION ALL
SELECT 'HND ',
       '--',
       130,
       1,
       'VERTOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Totaliza?',
       'Totaliza?',
       '',
       'VERTOT',
       'F' FROM DUAL
);

/*-- SEQ 8116 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'HOR ',
       TO_NUMBER(null),
       'HOR ',
       'Horas Trabalhadas',
       'TT_HOR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'HOR.CODFIL,HOR.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8117 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'HOR ','--','' FROM DUAL
UNION ALL
SELECT 'HOR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'HOR ','99','Outros' FROM DUAL
);

/*-- SEQ 8118 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 5625,
       'USU ',
       'HOR ',
       '0N',
       '1',
       '',
       '',
       'USU.FILUSU(+) = HOR.FILUSU AND
USU.CODUSU(+) = HOR.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 5626,
       'RAT ',
       'HOR ',
       '1',
       'N',
       '',
       '',
       'RAT.CODFIL = HOR.FILRAT AND
RAT.SEQUEN = HOR.SEQRAT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 5627,
       'SPT ',
       'HOR ',
       '1',
       '0N',
       '',
       '',
       'SPT.CODFIL = HOR.FILSUP AND
SPT.SEQUEN = HOR.SEQSUP',
       '',
       '' FROM DUAL
UNION ALL
SELECT 5628,
       'WOR ',
       'HOR ',
       '1',
       '0N',
       '',
       '',
       'WOR.CODFIL = HOR.CODFIL(+) AND
WOR.SEQUEN = HOR.SEQWOR(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8119 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'HOR ',
       '01',
       170,
       64,
       'CLIENTEDAHORA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cliente da Hora',
       'Cliente da Hora',
       '',
       'CLIENTEDAHORA(HOR.CODFIL,HOR.SEQUEN)',
       '' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Codigo da Filial',
       'DFIL.CODFIL = HOR.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       190,
       6,
       'CODREV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Revenda',
       'Cdigo da Revenda',
       '',
       'CODREV',
       'F' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       20,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Codigo do usuario',
       'HOR.FILUSU = USU.FILUSU(+)  AND HOR.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       100,
       7,
       'DATREG',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Registro',
       'Data Registro',
       '',
       'DATREG',
       'F' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       30,
       7,
       'DATTRA',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data',
       'Data do trabalho',
       '',
       'DATTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       40,
       4000,
       'DESTRA',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Tarefa',
       'Descricao da Tarefa(Trabalho)',
       '',
       'RTF2TXT(DESTRA)',
       'F' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       180,
       1,
       'FATURA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Cobrana',
       'Fatura',
       '',
       'FATURA',
       'T' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       130,
       3,
       'FILRAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       '',
       'Filial Rateio',
       '',
       'FILRAT',
       'F' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       200,
       3,
       'FILREV',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Revenda',
       'DFIL.CODFIL = HOR.FILREV',
       'FILREV',
       'F' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       110,
       3,
       'FILSUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Suporte',
       '',
       'FILSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       50,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do usuario',
       '',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       150,
       4,
       'HORA60',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Hora',
       'Hora',
       '',
       '(CASE WHEN HOR.HORTRA <> 0 THEN HOR.HORTRA/60 ELSE 0 END)',
       '' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       65,
       12,
       'HORASREAIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Horas Reais',
       'Horas Reais',
       '',
       '(TO_NUMBER(TO_CHAR(TRUNC(HOR.HORTRA/60),''00'')||SUBSTR(TO_CHAR(HOR.HORTRA-TRUNC(HOR.HORTRA/60)*60,''00''),2,2))/100)',
       '' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       60,
       7,
       'HORTRA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Minutos',
       'Minutos Trabalhados',
       '',
       'HORTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       67,
       5,
       'HORTRABFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Horas(Formato Horas)',
       'Horas Trabalhadas(Formato de Hora)',
       '',
       '(SUBSTR(INTTOHORAS(HOR.HORTRA),1,5))',
       '' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       210,
       4,
       'NUMREV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nmero da Revenda',
       'Nmero da Revenda',
       '',
       'NUMREV',
       'F' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       220,
       1,
       'PAGTEC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Pagamento tcnico?',
       'Pagamento tcnico?',
       '',
       'PAGTEC',
       'F' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       140,
       10,
       'SEQRAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Seq. Rateio',
       '',
       'SEQRAT',
       'F' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       120,
       10,
       'SEQSUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Suporte',
       '',
       'SEQSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       70,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       80,
       10,
       'SEQWOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador WorkFlow (TT_WOR)',
       '',
       'SEQWOR',
       'F' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       160,
       3,
       'TIPOHORA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Tipo~Hora',
       'Tipo da Hora',
       '',
       '(CASE WHEN ((HOR.FILSUP IS NOT NULL) AND (HOR.SEQSUP IS NOT NULL)) THEN ''SAC'' WHEN (HOR.SEQWOR IS NOT NULL) THEN ''WF''  END)',
       '' FROM DUAL
UNION ALL
SELECT 'HOR ',
       '01',
       90,
       1,
       'TIPTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo~Trabalho',
       'Tipo do Trabalho',
       '',
       'TIPTRA',
       'T' FROM DUAL
);

/*-- SEQ 8120 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'HOR ',
       'FATURA',
       0,
       'A',
       'A Faturar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'HOR ',
       'FATURA',
       0,
       'C',
       'Contrato',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'HOR ',
       'FATURA',
       0,
       'D',
       'A Definir',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'HOR ',
       'FATURA',
       0,
       'F',
       'Faturado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'HOR ',
       'FATURA',
       0,
       'R',
       'Revenda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'HOR ',
       'FATURA',
       0,
       'S',
       'Cortesia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'HOR ',
       'FATURA',
       0,
       'V',
       'Faturado contra a Revenda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'HOR ',
       'TIPTRA',
       0,
       'C',
       'Classificao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'HOR ',
       'TIPTRA',
       0,
       'I',
       'Integrao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'HOR ',
       'TIPTRA',
       0,
       'R',
       'Revisao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'HOR ',
       'TIPTRA',
       0,
       'S',
       'Atendimento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'HOR ',
       'TIPTRA',
       0,
       'T',
       'Tarefa',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8121 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'HRE ',
       TO_NUMBER(null),
       'HRE ',
       'Disponibilidade',
       'TT_HRE',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8122 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'HRE ','--','' FROM DUAL
UNION ALL
SELECT 'HRE ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'HRE ','99','Outros' FROM DUAL
);

/*-- SEQ 8123 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 61712,
       'EDE ',
       'HRE ',
       '1 ',
       'N ',
       '',
       '',
       'HRE.FILCLI = ENDE.FILCLI AND
HRE.CODCLI = ENDE.CODCLI AND
HRE.FILEND = ENDE.CODFIL AND
HRE.NUMEND = ENDE.NUMEND',
       '',
       '' FROM DUAL
);

/*-- SEQ 8124 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'HRE ',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Atualizao',
       'Data Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'HRE ',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'HRE ',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       'F',
       'Cdigo Filial',
       'Cdigo Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'HRE ',
       '--',
       40,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data de Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'HRE ',
       '--',
       50,
       1,
       'DIASEM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Dia da Semana',
       'Dia da Semana',
       '',
       'DIASEM',
       'F' FROM DUAL
UNION ALL
SELECT 'HRE ',
       '--',
       60,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       'F',
       'Filial do Cliente',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'HRE ',
       '--',
       70,
       3,
       'FILEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       'F',
       'Filial do Endereo',
       'Filial do Endereo',
       '',
       'FILEND',
       'F' FROM DUAL
UNION ALL
SELECT 'HRE ',
       '--',
       80,
       4,
       'HORFIM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Hora Final',
       'Hora Final',
       '',
       'HORFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'HRE ',
       '--',
       90,
       4,
       'HORINI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Hora Inicial',
       'Hora Inicial',
       '',
       'HORINI',
       'F' FROM DUAL
UNION ALL
SELECT 'HRE ',
       '--',
       100,
       4,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero Endereo',
       'Nmero Endereo',
       '',
       'NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT 'HRE ',
       '--',
       110,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8125 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'HRE ',
       'DIASEM',
       0,
       ' ',
       'Domingo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'HRE ',
       'DIASEM',
       1,
       ' ',
       'Segunda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'HRE ',
       'DIASEM',
       2,
       ' ',
       'Tera',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'HRE ',
       'DIASEM',
       3,
       ' ',
       'Quarta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'HRE ',
       'DIASEM',
       4,
       ' ',
       'Quinta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'HRE ',
       'DIASEM',
       5,
       ' ',
       'Sexta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'HRE ',
       'DIASEM',
       6,
       ' ',
       'Sbado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8126 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'HTB ',
       TO_NUMBER(null),
       'HTB ',
       'Headers,Trailers Arq',
       'TT_HTB',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'HTB.CODFIL,HTB.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8127 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'HTB ','--','' FROM DUAL
UNION ALL
SELECT 'HTB ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'HTB ','02','Datas' FROM DUAL
UNION ALL
SELECT 'HTB ','03','Valores' FROM DUAL
UNION ALL
SELECT 'HTB ','99','Outros' FROM DUAL
);

/*-- SEQ 8128 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'HTB ',
       '01',
       10,
       20,
       'CAMEMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Uso Reserv.p/Empresa',
       'Para Uso Reservado da Empresa',
       '',
       'CAMEMP',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '01',
       20,
       1,
       'CBANCO',
       'A',
       'DBCO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DBCO.NBANCO',
       'V',
       '',
       'F',
       'N',
       'F',
       'Cdigo do Banco',
       'Cdigo do Banco',
       'DBCO.CBANCO = HTB.CBANCO',
       'CBANCO',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '01',
       30,
       5,
       'CODAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Agncia',
       'Cdigo da agncia',
       '',
       'CODAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '01',
       40,
       6,
       'CODARQ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Arquivo',
       'Cdigo do Arquivo',
       '',
       'CODARQ',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '01',
       50,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = HTB.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '01',
       60,
       12,
       'COD_CC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Conta C.',
       'Cdigo Conta Corrente',
       '',
       'COD_CC',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '01',
       70,
       20,
       'CONVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd. Convnio Banco',
       'Cdigo do Convnio no Banco',
       '',
       'CONVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '02',
       80,
       7,
       'DATGER',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Gerao',
       'Data em que foi Gerada',
       '',
       'DATGER',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '03',
       90,
       5,
       'DENARQ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Den. Arquivo',
       'Den. Arquivo',
       '',
       'DENARQ',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '03',
       100,
       2,
       'DIGAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Dgito da Agncia',
       'Dgito da Agncia',
       '',
       'DIGAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '01',
       110,
       1,
       'DIGA_C',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dgito Agncia Conta',
       'Dgito Agncia Conta',
       '',
       'DIGA_C',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '01',
       120,
       1,
       'DIG_CC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dgito Conta C.',
       'Dgito Conta Corrente',
       '',
       'DIG_CC',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '01',
       130,
       15,
       'DOCEMP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nm. Inscrio Emp.',
       'Nmero Inscrio da Empresa',
       '',
       'DOCEMP',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '01',
       140,
       3,
       'IDEVAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ident.Cob. sem Papel',
       'Identificao da Cobrana sem Papel',
       '',
       'IDEVAN',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '03',
       150,
       3,
       'LAYARQ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Layout Arquivo',
       'Layout do Arquivo',
       '',
       'LAYARQ',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '01',
       160,
       30,
       'NOMBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Banco',
       'Nome do Banco',
       '',
       'NOMBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '01',
       170,
       30,
       'NOMEMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome da Empresa',
       'Nome da Empresa',
       '',
       'NOMEMP',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '01',
       180,
       10,
       'OCOCSP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Oco. CSP',
       'Oco. CSP',
       '',
       'OCOCSP',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '03',
       190,
       6,
       'QTDCPC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade CPC',
       'Quantidade CPC',
       '',
       'QTDCPC',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '03',
       200,
       6,
       'QTDLOT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade Lotes',
       'Quantidade Lotes',
       '',
       'QTDLOT',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '03',
       210,
       6,
       'QTDREG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade Registros',
       'Quantidade de Registros',
       '',
       'QTDREG',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '99',
       220,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '01',
       230,
       1,
       'TIPDOC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tipo Documento',
       'Tipo Documento',
       '',
       'TIPDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '01',
       240,
       1,
       'TIPENV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cd.Remessa/Retorno',
       'Cdigo Remessa / Retorno',
       '',
       'TIPENV',
       'F' FROM DUAL
UNION ALL
SELECT 'HTB ',
       '01',
       250,
       2,
       'TIPSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'TipoServ.Cob.s/Papel',
       'Tipo de Servio Cobrana sem Papel',
       '',
       'TIPSER',
       'F' FROM DUAL
);

/*-- SEQ 8129 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IAG ',
       TO_NUMBER(null),
       'IAG ',
       'Itens de Agendamento',
       'TT_IAG',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'IAG.CODFIL,IAG.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8130 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IAG ','--','' FROM DUAL
UNION ALL
SELECT 'IAG ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IAG ','99','Outros' FROM DUAL
);

/*-- SEQ 8131 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IAG ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL(+) = IAG.CODFIL',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'IAG ',
       '99',
       20,
       254,
       'COMENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Comentrios',
       'Comentrios',
       '',
       'COMENT',
       'F' FROM DUAL
UNION ALL
SELECT 'IAG ',
       '01',
       30,
       7,
       'DATFIM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Final ',
       'Data Final',
       '',
       'DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'IAG ',
       '01',
       40,
       7,
       'DATINI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incio',
       'Data Incio',
       '',
       'DATINI',
       'F' FROM DUAL
UNION ALL
SELECT 'IAG ',
       '01',
       50,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8132 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IBD ',
       TO_NUMBER(null),
       'IBD ',
       'Distrito IBGE',
       'TT_IBD',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8133 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IBD ','--','' FROM DUAL
UNION ALL
SELECT 'IBD ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IBD ','99','Outros' FROM DUAL
);

/*-- SEQ 8134 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 24515,
       'IBG ',
       'IBD ',
       '01',
       '01',
       '',
       '',
       'IBG.CODIBG = IBD.CODIBG',
       '',
       '' FROM DUAL
);

/*-- SEQ 8135 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IBD ',
       '01',
       10,
       10,
       'CODIBD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cd. Distrito IBGE',
       'Cd. Distrito IBGE',
       '',
       'CODIBD',
       '' FROM DUAL
UNION ALL
SELECT 'IBD ',
       '01',
       20,
       10,
       'CODIBG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cd. Municpio IBGE',
       'Cd. Municpio IBGE',
       '',
       'CODIBG',
       'F' FROM DUAL
UNION ALL
SELECT 'IBD ',
       '01',
       30,
       50,
       'NOMIBD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Distrito IBGE',
       'Nome Distrito IBGE',
       '',
       'NOMIBD',
       'F' FROM DUAL
);

/*-- SEQ 8136 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IBG ',
       TO_NUMBER(null),
       'IBG ',
       'Municpio IBGE',
       'TT_IBG',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8137 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IBG ','--','' FROM DUAL
UNION ALL
SELECT 'IBG ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IBG ','99','Outros' FROM DUAL
);

/*-- SEQ 8138 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20617,
       'MES ',
       'IBG ',
       '1',
       'N',
       '',
       '',
       'MES.CODMES = IBG.CODMES',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20618,
       'MIC ',
       'IBG ',
       '1',
       'N',
       '',
       '',
       'MIC.CODMIC = IBG.CODMIC',
       '',
       '' FROM DUAL
);

/*-- SEQ 8139 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IBG ',
       '01',
       60,
       8,
       'ATU_EM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data da atualizao',
       'Data da atualizao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'IBG ',
       '01',
       10,
       10,
       'CODIBG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cd. Municpio IBGE',
       'Cd. Municpio IBGE',
       '',
       'CODIBG',
       '' FROM DUAL
UNION ALL
SELECT 'IBG ',
       '01',
       20,
       10,
       'CODMES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cd. Mesorregio',
       'Cd. Mesorregio',
       '',
       'CODMES',
       'F' FROM DUAL
UNION ALL
SELECT 'IBG ',
       '01',
       30,
       10,
       'CODMIC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cd. Microregio',
       'Cd. Microregio',
       '',
       'CODMIC',
       'F' FROM DUAL
UNION ALL
SELECT 'IBG ',
       '01',
       40,
       50,
       'NOMMUN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Municpio',
       'Nome do Municpio',
       '',
       'NOMMUN',
       'F' FROM DUAL
UNION ALL
SELECT 'IBG ',
       '01',
       50,
       2,
       'SIGEST',
       'A',
       'DEST',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEST.ESTADO',
       'V',
       '',
       '',
       'A',
       'F',
       'Estado do Municpio',
       'Estado do Municpio',
       'DEST.ESTADO = IBG.SIGEST',
       'SIGEST',
       'F' FROM DUAL
);

/*-- SEQ 8140 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IBP ',
       TO_NUMBER(null),
       'IBP ',
       'Aliq. med. pelo IBPT',
       'TT_IBP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'IBP.CODFIL, IBP.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8141 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IBP ','--','' FROM DUAL
UNION ALL
SELECT 'IBP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IBP ','99','Outros' FROM DUAL
);

/*-- SEQ 8142 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IBP ',
       '01',
       110,
       4,
       'ALIEST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Aliq Estaduais',
       'Alquotas de Impostos Estaduais',
       '',
       'ALIEST',
       '' FROM DUAL
UNION ALL
SELECT 'IBP ',
       '01',
       100,
       4,
       'ALIFEDIMP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Aliq Federais Imp',
       'Alquota de Impostos Federais para Produtos Importados',
       '',
       'ALIFEDIMP',
       '' FROM DUAL
UNION ALL
SELECT 'IBP ',
       '01',
       90,
       4,
       'ALIFEDNAC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Aliq Federais Nac',
       'Alquota de Impostos Federais para Produtos Nacionais',
       '',
       'ALIFEDNAC',
       '' FROM DUAL
UNION ALL
SELECT 'IBP ',
       '--',
       10,
       6,
       'ALIIMP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       'F',
       'Alquota Importao',
       'Alquota Importao',
       '',
       'ALIIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'IBP ',
       '01',
       120,
       4,
       'ALIMUN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Aliq Municipais',
       'Alquotas de Impostos Municipais',
       '',
       'ALIMUN',
       '' FROM DUAL
UNION ALL
SELECT 'IBP ',
       '--',
       20,
       6,
       'ALINAC',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       'F',
       'Alquota Nacional',
       'Alquota Nacional',
       '',
       'ALINAC',
       'F' FROM DUAL
UNION ALL
SELECT 'IBP ',
       '--',
       30,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'IBP ',
       '01',
       150,
       6,
       'CHAVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Chave do IBPT',
       'Chave do IBPT',
       '',
       'CHAVE',
       '' FROM DUAL
UNION ALL
SELECT 'IBP ',
       '01',
       40,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '0',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'IBP ',
       '--',
       50,
       8,
       'CODIGO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo NCM ou NBS',
       'Cdigo NCM ou NBS',
       '',
       'CODIGO',
       'F' FROM DUAL
UNION ALL
SELECT 'IBP ',
       '--',
       60,
       3,
       'COD_EX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Exceo ',
       'Cdigo Exceo ',
       '',
       'COD_EX',
       'F' FROM DUAL
UNION ALL
SELECT 'IBP ',
       '01',
       140,
       8,
       'DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Final',
       'Data Final da Vigncia',
       '',
       'DATFIM',
       '' FROM DUAL
UNION ALL
SELECT 'IBP ',
       '--',
       70,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'IBP ',
       '01',
       130,
       8,
       'DATINI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Inicial',
       'Inicial da Vigncia',
       '',
       'DATINI',
       '' FROM DUAL
UNION ALL
SELECT 'IBP ',
       '01',
       170,
       34,
       'FONTE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Fonte da Tabela',
       'Fonte da Tabela',
       '',
       'FONTE',
       '' FROM DUAL
UNION ALL
SELECT 'IBP ',
       '01',
       80,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IBP ',
       '--',
       180,
       2,
       'SIGEST',
       'A',
       'DEST',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEST.ESTADO',
       'V',
       '',
       '',
       'A',
       '',
       'UF',
       'UF',
       'DEST.ESTADO = IBP.SIGEST',
       'SIGEST',
       '' FROM DUAL
UNION ALL
SELECT 'IBP ',
       '--',
       90,
       1,
       'TABELA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tabela',
       'Tabela',
       '',
       'TABELA',
       'T' FROM DUAL
UNION ALL
SELECT 'IBP ',
       '01',
       160,
       6,
       'VERSAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Verso da Tabela',
       'Verso da Tabela',
       '',
       'VERSAO',
       '' FROM DUAL
);

/*-- SEQ 8143 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IBP ',
       'TABELA',
       2,
       ' ',
       'LC 116',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IBP ',
       'TABELA',
       0,
       ' ',
       'NCM',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IBP ',
       'TABELA',
       1,
       ' ',
       'NBS',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8144 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ICAM',
       TO_NUMBER(null),
       'ICAM',
       'Importao Cmbio',
       'TI_CAM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8145 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ICAM','--','' FROM DUAL
UNION ALL
SELECT 'ICAM','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ICAM','02','Dados' FROM DUAL
UNION ALL
SELECT 'ICAM','03','Controle' FROM DUAL
UNION ALL
SELECT 'ICAM','99','Outros' FROM DUAL
);

/*-- SEQ 8146 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ICAM',
       '03',
       10,
       7,
       'DATIMP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da~ importao',
       'Data da importao',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'ICAM',
       '02',
       20,
       7,
       'DATREF',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de~referncia',
       'Data de referncia',
       '',
       'DATREF',
       'F' FROM DUAL
UNION ALL
SELECT 'ICAM',
       '02',
       30,
       5,
       'DESMOE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Moeda',
       'Descrio ou simbolo da moeda',
       '',
       'DESMOE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICAM',
       '03',
       40,
       255,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo da~Rejeio',
       'Motivo da Rejeio',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'ICAM',
       '03',
       50,
       1,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status da~importao',
       'Status da importao',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'ICAM',
       '02',
       60,
       12,
       'VLRREF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr. Referncia',
       'Valor de Referncia',
       '',
       'VLRREF',
       'F' FROM DUAL
);

/*-- SEQ 8147 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ICF ',
       TO_NUMBER(null),
       'ICF ',
       'MFD Detalhe CF E15 ',
       'TT_ICF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'ICF.CODFIL, ICF.NUMECF, ICF.NUMCOO, ICF.DATEMI, ICF.NUMITE',
       '' FROM DUAL
);

/*-- SEQ 8148 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ICF ','--','' FROM DUAL
UNION ALL
SELECT 'ICF ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ICF ','99','Outros' FROM DUAL
);

/*-- SEQ 8149 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 25795,
       'MCF ',
       'ICF ',
       '1',
       'N',
       '',
       '',
       'ICF.CODFIL = MCF.CODFIL AND ICF.NUMECF = MCF.NUMECF AND
ICF.NUMCOO = MCF.NUMCOO AND ICF.DATEMI = MCF.DATEMI',
       '',
       '' FROM DUAL
);

/*-- SEQ 8150 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ICF ',
       '--',
       10,
       1,
       'ARRTRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Arredon. ou Trunca. ',
       'Indicador de Arredondamento(A) ou Truncamento(T) relativo  regra de cl',
       '',
       'ARRTRU',
       'T' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = ICF.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       30,
       14,
       'CODITE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Produto',
       'Cdigo do produto ou servio registrado no documento',
       '',
       'CODITE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       40,
       7,
       'CODTOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Totalizador',
       'Cdigo do totalizador relativo ao produto ou servio conforme tabela aba',
       '',
       'CODTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       50,
       7,
       'DATEMI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Emisso',
       'Data de incio da emisso',
       '',
       'DATEMI',
       'F' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       60,
       1,
       'DECQTD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Casas Decimais Qtde',
       'Parmetro de nmero de casas decimais da quantidade',
       '',
       'DECQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       70,
       1,
       'DECUNI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Casas Decimais Vl Un',
       'Parmetro de nmero de casas decimais de valor unitrio',
       '',
       'DECUNI',
       'F' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       80,
       100,
       'DESMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Material',
       'Descrio do produto ou servio constante no Cupom Fiscal',
       '',
       'DESMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       90,
       1,
       'FLGCAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Sit. Cancelamento',
       'Informar "S" se estiver cancelado, caso contrrio "N". Parcial informe P',
       '',
       'FLGCAN',
       'T' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       230,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       240,
       4000,
       'MSGLOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Log. Operao',
       'Informaes detalhadas do fechamento do item',
       '',
       'MSGLOG',
       '' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       100,
       6,
       'NUMCCF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'CCF, CVC ou CBP',
       'CCF, CVC ou CBP, conforme o documento emitido',
       '',
       'NUMCCF',
       'F' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       110,
       6,
       'NUMCOO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'COO',
       'COO (Contador de Ordem de Operao)	',
       '',
       'NUMCOO',
       'F' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       120,
       3,
       'NUMECF',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       'F',
       'Nmero do ECF',
       'Nmero do ECF',
       'DECF.FILECF = ICF.CODFIL AND DECF.NUMECF = ICF.NUMECF',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       130,
       3,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero do Item',
       'Nmero do item registrado no documento',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       140,
       10,
       'QTDCAN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtde Cancelada',
       'Quantidade cancelada, no caso de cancelamento parcial de item',
       '',
       'QTDCAN',
       'F' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       150,
       10,
       'QTDITE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtde Comercializada',
       'Quantidade comercializada',
       '',
       'QTDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       160,
       3,
       'UNIDAD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Unidade',
       'Unidade de medida',
       '',
       'UNIDAD',
       'F' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       170,
       8,
       'VLRACRES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Acrsc',
       'Valor do acrscimo incidente sobre o valor do item',
       '',
       'VLRACRES',
       'F' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       180,
       12,
       'VLRCAN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Cancelado',
       'Valor cancelado, no caso de cancelamento parcial de item',
       '',
       'VLRCAN',
       'F' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       190,
       12,
       'VLRCANACR',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Canc do Acrsc',
       'Valor do cancelamento de acrscimo no item',
       '',
       'VLRCANACR',
       'F' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       200,
       8,
       'VLRDESC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Desconto',
       'Valor do desconto incidente sobre o valor do item',
       '',
       'VLRDESC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       210,
       14,
       'VLRTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Total',
       'Valor total lquido do item',
       '',
       'VLRTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICF ',
       '--',
       220,
       12,
       'VLRUNI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Unitrio',
       'Valor unitrio do produto ou servio',
       '',
       'VLRUNI',
       'F' FROM DUAL
);

/*-- SEQ 8151 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ICF ',
       'ARRTRU',
       0,
       'A',
       'Arredondamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICF ',
       'ARRTRU',
       0,
       'T',
       'Truncamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICF ',
       'FLGCAN',
       0,
       'N',
       'Ativo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICF ',
       'FLGCAN',
       0,
       'P',
       'Cancelado Parcialmente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICF ',
       'FLGCAN',
       0,
       'S',
       'Situao Cancelamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICF ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICF ',
       'FLGEST',
       0,
       'C',
       'Processado com Correes',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICF ',
       'FLGEST',
       0,
       'I',
       'Inconsistente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICF ',
       'FLGEST',
       0,
       'P',
       'Processado sem Correes',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8152 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ICLI',
       TO_NUMBER(null),
       'ICLI',
       'Clientes da loja',
       'TI_CLI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8153 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ICLI','--','' FROM DUAL
UNION ALL
SELECT 'ICLI','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ICLI','02','Dados Bsicos' FROM DUAL
UNION ALL
SELECT 'ICLI','03','Dados de Contato' FROM DUAL
UNION ALL
SELECT 'ICLI','04','Dados de Endereo' FROM DUAL
UNION ALL
SELECT 'ICLI','05','Dados Adicionais Pessoa Fsica' FROM DUAL
UNION ALL
SELECT 'ICLI','06','Controle' FROM DUAL
UNION ALL
SELECT 'ICLI','99','Outros' FROM DUAL
);

/*-- SEQ 8154 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ICLI',
       '05',
       10,
       12,
       'ALUFIN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr. Aluguel/Financ.',
       'Vlr. Aluguel/Financ.',
       '',
       'ALUFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       20,
       8,
       'ANTMES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Tempo de~Servio',
       'Em meses de servio na empresa anterior',
       '',
       'ANTMES',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       30,
       15,
       'APEVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Vendedor~Preferencia',
       'Vendedor Preferencial',
       '',
       'APEVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       40,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Parceiro~Ativo?',
       'Parceiro Ativo?',
       '',
       'ATIVO',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       50,
       5,
       'ATUMES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tempo de~Servio',
       'Tempo de Servio',
       '',
       'ATUMES',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       60,
       40,
       'BAIRRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Bairro',
       'Bairro',
       '',
       'BAIRRO',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       70,
       1,
       'CALL_C',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Aceita~Contato?',
       'Aceita Contato Telefnico',
       '',
       'CALL_C',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       80,
       5,
       'CANMES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tempo Serv.~Cnjuge',
       'Tempo servio Cnjuge',
       '',
       'CANMES',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       90,
       20,
       'CARCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cargo do~Cnjuge',
       'Cargo do cnjuge',
       '',
       'CARCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       100,
       20,
       'CARGOP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cargo',
       'Cargo',
       '',
       'CARGOP',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       110,
       1,
       'CARLOJ',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Tem Carto~Loja?',
       'Tem carto da Loja?',
       '',
       'CARLOJ',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       120,
       6,
       'CARPRC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       '9',
       'F',
       'CTPS do~Cnjuge',
       'Nmero da Carteira de trabalho (CTPS) do cnjuge',
       '',
       'CARPRC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       130,
       6,
       'CARPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'CTPS',
       'CTPS',
       '',
       'CARPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       140,
       5,
       'CASMES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tempo~Casamento',
       'Tempo Casamento',
       '',
       'CASMES',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       150,
       2,
       'CATEG1',
       'S',
       'DCT1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'V',
       '',
       'F',
       'A',
       'F',
       'Profisso/Ramo',
       'Categoria - 1',
       'ICLI.CATEG1=DCT1.CODTAB (+)',
       'CATEG1',
       'T' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       160,
       2,
       'CATEG2',
       'S',
       'DCT2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'V',
       '',
       'F',
       'A',
       'F',
       'Salrio/Faturam',
       'Categoria - 2',
       'ICLI.CATEG2=DCT2.CODTAB (+)',
       'CATEG2',
       'T' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       170,
       2,
       'CATEG3',
       'S',
       'DCT3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'V',
       '',
       'F',
       'A',
       'F',
       '3',
       'Categoria - 3',
       'ICLI.CATEG3=DCT3.CODTAB (+)',
       'CATEG3',
       'T' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       180,
       8,
       'CELCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Celular do~Contato',
       'Celular do Contato',
       '',
       'CELCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       190,
       2,
       'CELDDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'DDD~Celular',
       'DDD Celular',
       '',
       'CELDDD',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       200,
       8,
       'CELNUM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Celular',
       'Celular',
       '',
       'CELNUM',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       210,
       8,
       'CELUCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Celular~Cnjuge/Cont',
       'Celular Cnjuge/Contato',
       '',
       'CELUCO',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       220,
       35,
       'CIDNAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Naturalidade',
       'Naturalidade',
       '',
       'CIDNAS',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       230,
       5,
       'CODCEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'CEP',
       'CEP',
       '',
       'CODCEP',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       240,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd. Parceiro~Totali',
       'Se informado,assume este como cdigo, seno, assume um sequenciador',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       250,
       6,
       'CODCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Codigo Reg.Cnjuge',
       'Codigo do registro do conjuge',
       '',
       'CODCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       260,
       4,
       'CODDDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'DDD~Telefone',
       'DDD Telefone',
       '',
       'CODDDD',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       270,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd. Sistema~Origem',
       'Cdigo no sistema de Origem',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       1590,
       10,
       'CODIBG',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cd. IBGE Municpio',
       'Cdigo do IBGE do Municpio',
       '',
       'CODIBG',
       '' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       280,
       3,
       'CODLOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Logradouro',
       'Logradouro',
       '',
       'CODLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       290,
       3,
       'CODPLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do~Plano',
       'Cdigo do Plano',
       '',
       'CODPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       300,
       5,
       'CODSEX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Sexo',
       'Cdigo de Sexo do Cliente',
       '',
       'CODSEX',
       'T' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       310,
       6,
       'CODVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo~Vnculo',
       'Empresa onde trabalha, se a mesma for parceiro ou empresas coligadas.',
       '',
       'CODVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       320,
       40,
       'COMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Complemento',
       'Complemento',
       '',
       'COMPLE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       330,
       40,
       'COMSPC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Compl. End.~Trabalho',
       'Compl. End. Trabalho',
       '',
       'COMSPC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       340,
       5,
       'CONBOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Contato~envio boleto',
       'Contato envio boleto e-mail',
       '',
       'CONBOL',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       350,
       44,
       'CONJUG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cnjuge ou Contato',
       'Nome cnjuge p/cliente pessoa fsica ou contato principal p/Jurdica',
       '',
       'CONJUG',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       360,
       5,
       'CONOCU',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Emprego do Cnjuge',
       'Emprego do Cnjuge',
       '',
       'CONOCU',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       370,
       1,
       'CONSPC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'SPC OK?',
       'Confirmao consulta SPC',
       '',
       'CONSPC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       380,
       44,
       'CONTAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Contato',
       'Contato',
       '',
       'CONTAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       1550,
       8,
       'CONTEL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Telefone~Contato',
       'Telefone do Contato',
       '',
       'CONTEL',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       1600,
       15,
       'CON_DOCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Documento do Contato',
       'Documento do Contato',
       '',
       'CON_DOCCON',
       '' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       400,
       1,
       'CON_LR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Local Residncia OK?',
       'Confirmao local de resid.',
       '',
       'CON_LR',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       410,
       1,
       'CON_LT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Local Trabalho OK?',
       'Confirmao local de trab.',
       '',
       'CON_LT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       1610,
       1,
       'CON_RETPRO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Retira Produto?',
       'Contato Retira Produto?',
       '',
       'CON_RETPRO',
       '' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       420,
       1,
       'CON_TC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Talo Cheques OK?',
       'Confirmao talo cheques',
       '',
       'CON_TC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       430,
       2,
       'CTIPDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd.Tipo~Documento',
       'Exemplo: IE-Incrio Estadual; RG-Identidade',
       '',
       'CTIPDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       440,
       8,
       'DATA01',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       '',
       'Data livre - 1',
       '',
       'DATA01',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       450,
       8,
       'DATA02',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       '',
       'Data livre - 2',
       '',
       'DATA02',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       460,
       8,
       'DATA03',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       '',
       'Data livre - 3',
       '',
       'DATA03',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '06',
       470,
       7,
       'DATIMP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da~importao',
       'Data da importao',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       480,
       7,
       'DATNAS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Nascto/Fundao',
       'Nascto/Fundao',
       '',
       'DATNAS',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       490,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data do~cadastro',
       'Data do cadastro',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       500,
       2,
       'DDCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'DDD~Cel.Cnjuge/Cont',
       'DDD Cel Cnjuge/Contato',
       '',
       'DDCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       510,
       2,
       'DDDCEL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'DDD~Celular',
       'DDD Celular',
       '',
       'DDDCEL',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       520,
       2,
       'DDDCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'DDD do~Contato',
       'DDD do Contato',
       '',
       'DDDCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       530,
       2,
       'DDDFAX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'DDD~Fax',
       'DDD Fax',
       '',
       'DDDFAX',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       540,
       2,
       'DDDFXC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'DDD~Fax',
       'DDD Fax',
       '',
       'DDDFXC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       550,
       4,
       'DDTCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'DDD~Tel.Cnj/Contato',
       'DDD Telefone Cnjuge',
       '',
       'DDTCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       560,
       20,
       'DESINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo~Inatividade',
       'Motivo da Inatividade',
       '',
       'DESINA',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       570,
       30,
       'DESOCU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ocupao',
       'Ocupao',
       '',
       'DESOCU',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       580,
       15,
       'DOCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Doc. Cnjuge/Contato',
       'Doc. Cnjuge/Contato',
       '',
       'DOCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       590,
       15,
       'DOCEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'CNPJ/MF',
       'CNPJ/MF',
       '',
       'DOCEND',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       600,
       30,
       'DTIPDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Desc.Tipo~Documento',
       'Exemplo: Incrio Estadual; Identidade',
       '',
       'DTIPDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       610,
       50,
       'ENDCO1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'End. Trab. Cnjuge ',
       'Endereo Trabalho do Cnjuge',
       '',
       'ENDCO1',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       620,
       20,
       'ENDCO2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'End.Compl.do Cnjuge',
       'Complemento endereo do cnjuge',
       '',
       'ENDCO2',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       630,
       1,
       'ENDCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cobrana?',
       'Cobrana?',
       '',
       'ENDCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       640,
       1,
       'ENDCOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Correspondncia?',
       'Correspondncia?',
       '',
       'ENDCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       650,
       40,
       'ENDERE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Endereo',
       'Endereo',
       '',
       'ENDERE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       660,
       34,
       'ENDLO1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Endereo Ref.Coml.1 ',
       'Endereo Ref. Coml. 1',
       '',
       'ENDLO1',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       670,
       34,
       'ENDLO2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Endereo Ref.Coml.2 ',
       'Endereo Ref. Coml. 2',
       '',
       'ENDLO2',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       680,
       42,
       'ENDSPC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Endereo~Trabalho',
       'Endereo Trabalho',
       '',
       'ENDSPC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       1640,
       20,
       'END_CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd. End Sistema~Ori',
       'Cdigo do Endereo no Sistema de Origem',
       '',
       'END_CODEXT',
       '' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       690,
       5,
       'ESTCIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Estado Civil',
       'Estado Civil',
       '',
       'ESTCIV',
       'T' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       700,
       40,
       'ESTRAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Endereo~Estrangeiro',
       'Endereo Estrangeiro',
       '',
       'ESTRAN',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       710,
       254,
       'E_MAIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail',
       'E-mail',
       '',
       'E_MAIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       720,
       254,
       'E_MCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-Mail Cnj/Contato',
       'E-Mail Cnjuge/Contato',
       '',
       'E_MCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '01',
       1630,
       254,
       'E_MFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'E-mail do Financeiro',
       'E-mail do Financeiro',
       '',
       'E_MFIN',
       '' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       730,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cod. Filial~Cadastro',
       'Codigo da filial de cadastramento',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       740,
       3,
       'FILECO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Filial~Endereo',
       'Filial Endereo',
       '',
       'FILECO',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       750,
       3,
       'FILEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do~Endereo',
       'Filial do Endereo',
       '',
       'FILEND',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       760,
       3,
       'FILPLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do~Plano ',
       'Filial do Plano ',
       '',
       'FILPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       770,
       20,
       'FIRANT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Empresa~Anterior',
       'Empresa Anterior',
       '',
       'FIRANT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       780,
       20,
       'FIRATU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Empresa',
       'Empresa',
       '',
       'FIRATU',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       790,
       50,
       'FIRCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Trabalho do Cnjuge',
       'Nome da firma do cnjuge',
       '',
       'FIRCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       800,
       1,
       'FLGNAC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nacional?',
       'Nacional?',
       '',
       'FLGNAC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       810,
       5,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       820,
       40,
       'HOMPGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Home Page',
       'Home Page',
       '',
       'HOMPGE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       830,
       1,
       'ICM_CF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa crdito~ICMS?',
       'Usa crdito ICMS',
       '',
       'ICM_CF',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       840,
       7,
       'ID_DAT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Expedio RG',
       'Data RG',
       '',
       'ID_DAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       850,
       2,
       'ID_EST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF do RG',
       'UF do RG',
       '',
       'ID_EST',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       860,
       6,
       'ID_ORG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'rgo~Expeditor',
       'rgo Expeditor',
       '',
       'ID_ORG',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       870,
       15,
       'IE_END',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Inscr. Estadual',
       'Inscr. Estadual',
       '',
       'IE_END',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       880,
       15,
       'INSEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nro do~documento',
       'Nro do documento',
       '',
       'INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '06',
       1580,
       1,
       'ISENTO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Revenda/Consumidor',
       'Revenda/Consumidor Final',
       '',
       'ISENTO',
       'T' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       890,
       12,
       'LIMCRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Limite de~crdito',
       'Limite de crdito',
       '',
       'LIMCRE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       900,
       47,
       'LOCTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Proximidade',
       'Proximidade',
       '',
       'LOCTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       910,
       254,
       'MAISPC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail',
       'E-mail',
       '',
       'MAISPC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       920,
       5,
       'MORMES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Tempo de~Moradia',
       'Tempo de Moradia',
       '',
       'MORMES',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '06',
       930,
       255,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo da~Rejeio',
       'Motivo da Rejeio',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       940,
       17,
       'NACION',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nacionalidade',
       'Nacionalidade',
       '',
       'NACION',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       950,
       1,
       'NAOSPC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Imune ao SPC?',
       'Imune ao SPC?',
       '',
       'NAOSPC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       1560,
       7,
       'NASCNT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Nasc.~Contato',
       'Data Nascimento do Contato',
       '',
       'NASCNT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       970,
       8,
       'NASCON',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Nascto Cnj./Contato',
       'Data de nascimento do cnjuge ou contato principal',
       '',
       'NASCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       980,
       44,
       'NCONTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Contato',
       'Nome do Contato',
       '',
       'NCONTA',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       990,
       35,
       'NOMCID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome da~Cidade',
       'Nome da Cidade',
       '',
       'NOMCID',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       1000,
       64,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome/Razo Social',
       'Nome/Razo Social',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       1010,
       15,
       'NOMLO1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. Comercial 1',
       'Loja onde comprou 1',
       '',
       'NOMLO1',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       1020,
       15,
       'NOMLO2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. Comercial 2',
       'Loja onde comprou 2',
       '',
       'NOMLO2',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       1620,
       60,
       'NOMREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome do Recebedor',
       'Razo Social ou Nome do Recebedor',
       '',
       'NOMREC',
       '' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       1030,
       30,
       'NOMSUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do~Superior',
       'Nome do Superior',
       '',
       'NOMSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       1040,
       20,
       'NOMTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Apelido',
       'Nome Tratamento',
       '',
       'NOMTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       1050,
       4,
       'NUMCOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'DDD~Cnjuge (coml)',
       'DDD telefone do cnjuge',
       '',
       'NUMCOC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       1060,
       4,
       'NUMCOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'DDD~(comercial)',
       'DDD (comercial)',
       '',
       'NUMCOD',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       1070,
       2,
       'NUMCON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Sequncia~Contato',
       'Sequncia Contato',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       1080,
       3,
       'NUMDEP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero de~Dependente',
       'Nmero de Dependentes',
       '',
       'NUMDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       1090,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'CPF ou CNPJ',
       'CPF ou CNPJ',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       1100,
       4,
       'NUMECO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Sequncia~Endereo',
       'Sequncia Endereo',
       '',
       'NUMECO',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       1110,
       4,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Seqncia~Endereo',
       'Seqncia Endereo',
       '',
       'NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       1120,
       15,
       'NUMERO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero',
       'Nmero',
       '',
       'NUMERO',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       1130,
       10,
       'NUMFAX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Fax',
       'Fax',
       '',
       'NUMFAX',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       1140,
       8,
       'NUMFON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Telefone',
       'Telefone',
       '',
       'NUMFON',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       1150,
       8,
       'NUMFXC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Fax',
       'Fax',
       '',
       'NUMFXC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       1160,
       8,
       'NUMTEL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Fone~(comercial)',
       'Fone (comercial)',
       '',
       'NUMTEL',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       1170,
       10,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(ICLI.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       1180,
       254,
       'OBSOUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observ.~p/Cupom Fis.',
       'Observ. p/ Cupom Fiscal',
       '',
       'OBSOUT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       1190,
       30,
       'ORIRED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Origem da Renda',
       'Origem da Renda',
       '',
       'ORIRED',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       1200,
       2,
       'PORPAD',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       'F',
       'A',
       'F',
       'Portador Padro',
       'Portador padro',
       'ICLI.PORPAD=DCOB.CODTAB (+)',
       'PORPAD',
       'T' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       1210,
       15,
       'REGIAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Regio',
       'Regio',
       '',
       'REGIAO',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       1220,
       15,
       'RGCONJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Identidade Cnjuge',
       'Nmero da Identidade do cnjuge',
       '',
       'RGCONJ',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       1230,
       8,
       'SALBAC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Salrio do~Cnjuge',
       'Salrio base do cnjuge',
       '',
       'SALBAC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       1240,
       12,
       'SALBAS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Salrio~Base',
       'Salrio Base',
       '',
       'SALBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       1250,
       6,
       'SERCAC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       '9',
       'F',
       'Srie da~CTPS (Cnj)',
       'Srie da carteira de trabalho do cnjuge',
       '',
       'SERCAC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       1260,
       6,
       'SERCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie da~CTPS',
       'Srie da CTPS',
       '',
       'SERCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       1270,
       5,
       'SEXCON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Sexo~Cnjuge/Contato',
       'Sexo do cnjuge',
       '',
       'SEXCON',
       'T' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       1570,
       2,
       'SEXOCO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Sexo~Contato',
       'Sexo Contato',
       '',
       'SEXOCO',
       'T' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       1290,
       2,
       'SIGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF',
       'UF',
       '',
       'SIGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       1300,
       1,
       'SIMPLE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Imposto Simples?',
       'Imposto Simples?',
       '',
       'SIMPLE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '06',
       1310,
       1,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Status da~importao',
       'Status da importao',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       1320,
       8,
       'TELCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tel.Cnjuge~/Contato',
       'Telefone do Cnjuge',
       '',
       'TELCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       1330,
       8,
       'TELSPC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Fone~Cnjuge (coml)',
       'Fone Cnjuge (coml)',
       '',
       'TELSPC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       1340,
       1,
       'TEMAUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tem~automvel?',
       'Tem Automvel?',
       '',
       'TEMAUT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       1350,
       1,
       'TEM_CC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tem Carto~Crdito?',
       'Tem Carto de Crdito?',
       '',
       'TEM_CC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       1360,
       1,
       'TEM_TC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tem Talo~de Cheques',
       'Tem Talo de Cheques?',
       '',
       'TEM_TC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       1370,
       1,
       'TIPCLI1',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Produtor?',
       'Produtor?',
       '',
       'TIPCLI1',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       1380,
       1,
       'TIPCLI10',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Administ.de~Cartes?',
       'Administ. de Cartes',
       '',
       'TIPCLI10',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       1390,
       1,
       'TIPCLI2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Fornecedor?',
       'Fornecedor?',
       '',
       'TIPCLI2',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       1400,
       1,
       'TIPCLI3',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Transportador?',
       'Transportador?',
       '',
       'TIPCLI3',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       1410,
       1,
       'TIPCLI4',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Par.~Transportadora?',
       'parceiro Transportadora?',
       '',
       'TIPCLI4',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       1420,
       1,
       'TIPCLI5',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Representante?',
       'Representante?',
       '',
       'TIPCLI5',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       1430,
       1,
       'TIPCLI6',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Indicador?',
       'Indicador?',
       '',
       'TIPCLI6',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       1440,
       1,
       'TIPCLI7',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Motorista?',
       'Motorista?',
       '',
       'TIPCLI7',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       1450,
       1,
       'TIPCLI8',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tcnico~Interno?',
       'Tcnico Interno?',
       '',
       'TIPCLI8',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       1460,
       1,
       'TIPCLI9',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tcnico~Externo?',
       'Tcnico Externo?',
       '',
       'TIPCLI9',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       1470,
       15,
       'TIPCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo~Contato',
       'Exemplo: Pai, Me, Scio, Representante...',
       '',
       'TIPCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       1480,
       20,
       'TIPEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo~Endereo',
       'Tipo Endereo. Exemplo: Matriz, Filial, Residencial, Trabalho...',
       '',
       'TIPEND',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       1490,
       1,
       'TIPPES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo~Pessoa',
       'Tipo Pessoa',
       '',
       'TIPPES',
       'T' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       1500,
       1,
       'TIPRES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de~Residncia',
       'Tipo de residncia',
       '',
       'TIPRES',
       'T' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '03',
       1510,
       15,
       'TRACON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Trabalho~Contato',
       'Trabalho Contato',
       '',
       'TRACON',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '02',
       1520,
       30,
       'ULTNOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Fantasia',
       'SobreNome/Nome Fantasia',
       '',
       'ULTNOM',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '04',
       1530,
       1,
       'USA_NF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Usa Nota~Fiscal?',
       'Usa Nota Fiscal?',
       '',
       'USA_NF',
       'F' FROM DUAL
UNION ALL
SELECT 'ICLI',
       '05',
       1540,
       12,
       'VLRRED',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor da~Renda',
       'Valor da Renda',
       '',
       'VLRRED',
       'F' FROM DUAL
);

/*-- SEQ 8155 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ICLI',
       'CODSEX',
       0,
       '-',
       'Nao conhecido',
       144,
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'CODSEX',
       2,
       '-',
       'Feminino',
       146,
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'CODSEX',
       1,
       '-',
       'Masculino',
       145,
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'ESTCIV',
       6,
       '',
       'Separado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'ESTCIV',
       5,
       '',
       'Unio Estvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'ESTCIV',
       0,
       '',
       'Indefinido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'ESTCIV',
       4,
       '',
       'Divorciado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'ESTCIV',
       1,
       '',
       'Solteiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'ESTCIV',
       2,
       '',
       'Casado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'ESTCIV',
       3,
       '',
       'Viuvo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'FLGTIP',
       0,
       '',
       'Fisica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'FLGTIP',
       1,
       '',
       'Juridica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'FLGTIP',
       2,
       '',
       'Entidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'FLGTIP',
       3,
       '',
       'Especial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'FLGTIP',
       4,
       '',
       'M.E.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'FLGTIP',
       5,
       '',
       'Filial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'ISENTO',
       0,
       'F',
       'Revenda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'ISENTO',
       0,
       'T',
       'Consumidor Final',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'SEXCON',
       0,
       '',
       'Nao Conhecido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'SEXCON',
       1,
       '',
       'Masculino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'SEXCON',
       2,
       '',
       'Feminino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'SEXOCO',
       0,
       '',
       'No Conhecido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'SEXOCO',
       1,
       '',
       'Masculino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'SEXOCO',
       2,
       '',
       'Feminino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'TIPPES',
       0,
       'F',
       'Fsica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'TIPPES',
       0,
       'J',
       'Jurdica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'TIPRES',
       0,
       'A',
       'Alugada',
       105,
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'TIPRES',
       1,
       'F',
       'Financiada',
       106,
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'TIPRES',
       2,
       'P',
       'Prpria',
       104,
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'TIPRES',
       3,
       '',
       'Mora com os Parentes',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'TIPRES',
       4,
       '',
       'Mora no Trabalho',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICLI',
       'TIPRES',
       5,
       '',
       'No Informada',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8156 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ICM ',
       0,
       'ICM ',
       'ICMS por Cidade',
       'TT_ICM',
       'T',
       '',
       'TOTALL',
       'ICMS',
       '',
       '',
       '',
       '',
       'F',
       '',
       'ICM.CODCID',
       '' FROM DUAL
);

/*-- SEQ 8157 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ICM ','--','' FROM DUAL
);

/*-- SEQ 8158 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 26968,
       'MUN ',
       'ICM ',
       '1',
       '1',
       '',
       '',
       'MUN.CODIGO = ICM.CODCID',
       '',
       '' FROM DUAL
);

/*-- SEQ 8159 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ICM ',
       '--',
       10,
       5,
       'CODCID',
       'A',
       '',
       0,
       0,
       'ICM ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'ICM',
       'F',
       'A',
       'T',
       'Cidade',
       'Cdigo do CEP Final',
       '',
       'CODCID',
       'F' FROM DUAL
UNION ALL
SELECT 'ICM ',
       '--',
       30,
       10,
       'CODIBG',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cd. IBGE Municipo',
       'Cdigo IBGE do Municpio',
       '',
       'CODIBG',
       'F' FROM DUAL
UNION ALL
SELECT 'ICM ',
       '--',
       20,
       8,
       'PERICM',
       'F',
       '',
       2,
       0,
       'ICM ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ICM',
       'T',
       '',
       'T',
       'Percentual ICMS',
       'Percentual de ICMS da cidade',
       '',
       'PERICM',
       'F' FROM DUAL
);

/*-- SEQ 8160 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ICO ',
       0,
       'ICO ',
       'Itens de Compra',
       'TT_ICO',
       'F',
       '',
       'TOTALL',
       'Itens da Compra',
       '{CODFIL;FILFOR;CODFOR;CODSER;NUMNOT;NUMITE};ATU_EM',
       '',
       '',
       'CompraItem',
       'T',
       '',
       'ICO.CODFIL,ICO.SEQUEN,ICO.NUMITE
COM.ID,ICO.NUMITE
IPE.ID,ICO.NUMITE',
       '' FROM DUAL
);

/*-- SEQ 8161 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ICO ','--','' FROM DUAL
UNION ALL
SELECT 'ICO ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ICO ','02','Dados' FROM DUAL
UNION ALL
SELECT 'ICO ','03','Datas' FROM DUAL
UNION ALL
SELECT 'ICO ','04','Valores' FROM DUAL
UNION ALL
SELECT 'ICO ','05','Impostos Diferenciados' FROM DUAL
UNION ALL
SELECT 'ICO ','99','Outros' FROM DUAL
);

/*-- SEQ 8162 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 18779,
       'GRA ',
       'ICO ',
       '1',
       'N',
       '',
       '',
       'GRA.FILMAT = ICO.FILMAT and
GRA.CODMAT = ICO.CODMAT and
GRA.CODCOR = ICO.CODCOR and
GRA.CODTAM = ICO.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 18780,
       'VIPR',
       'ICO ',
       '1',
       '1',
       '',
       '',
       'ICO.FILMAT = VIPR.FILMAT AND
ICO.CODMAT = VIPR.CODMAT AND
ICO.CODCOR = VIPR.CODCOR AND
ICO.CODTAM = VIPR.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 18781,
       'IPE ',
       'ICO ',
       '0N',
       '01',
       '',
       '',
       'IPE.FILICO = ICO.CODFIL (+) and
IPE.SEQICO = ICO.SEQUEN (+) and
IPE.NUMICO = ICO.NUMITE (+) ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 18782,
       'SUB ',
       'ICO ',
       'N',
       '1',
       '',
       '',
       'SUB.CODITE = ICO.EMBORI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 18783,
       'TRA ',
       'ICO ',
       '1',
       'N',
       '',
       '',
       'TRA.FILICO = ICO.CODFIL AND
TRA.SEQICO = ICO.SEQUEN AND
TRA.NUMICO = ICO.NUMITE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 18784,
       'IPRF',
       'ICO ',
       '1',
       '1',
       '',
       '',
       'ICO.FILMAT = IPRF.FILMAT AND
ICO.CODMAT = IPRF.CODMAT AND
ICO.CODCOR = IPRF.CODCOR AND
ICO.CODTAM = IPRF.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 18785,
       'LOT ',
       'ICO ',
       '0N',
       '01',
       '',
       '',
       'LOT.CODFIL(+) = ICO.FILLOT and
LOT.SEQUEN(+) = ICO.SEQLOT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 18786,
       'CFOP',
       'ICO ',
       '1',
       'N',
       '',
       '',
       'CFOP.CODTAB = ICO.CODCFO',
       '',
       '' FROM DUAL
);

/*-- SEQ 8163 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'ICO ',
       '04',
       1330,
       6,
       'ALIICMAGR',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       '% ICMS Agregado',
       'Alquota de ICMS Agregado',
       '',
       'ALIICMAGR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '03',
       35,
       4,
       'ANO_DATANT',
       'A',
       '',
       0,
       0,
       'ICO ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ICO',
       '',
       'N',
       'T',
       'Ano ltimo Custo',
       'Ano de Data do custo antes da compra',
       '',
       'TO_CHAR(ICO.DATANT,''YYYY'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1570,
       16,
       'APRBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Apropriao de Bonif',
       'Apropriao de Bonificao',
       '',
       'APRBON',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       480,
       1,
       'ATUFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Atualiza Frete',
       'Atualiza Frete',
       '',
       'ATUFRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '03',
       1560,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Atualizao',
       'Data Atualizao',
       '',
       'ATU_EM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       970,
       12,
       'BASCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base Cofins',
       'Base Cofins',
       '',
       'BASCOF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1470,
       14,
       'BASFCP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base do FCP',
       'Valor da Base de Clculo do FCP',
       '',
       'BASFCP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1530,
       14,
       'BASFCP_RET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base do FCP ST Ret',
       'Valor da Base de Clculo do FCP retido anteriormente por ST',
       '',
       'BASFCP_RET',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1500,
       14,
       'BASFCP_ST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base do FCP ST',
       'Valor da Base de Clculo do FCP retido por Substituio Tributria',
       '',
       'BASFCP_ST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       400,
       14,
       'BASICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base Clculo ICMS',
       'Base Clculo ICMS',
       '',
       'BASICM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1320,
       14,
       'BASICMAGR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base ICMS Agregado',
       'Base de ICMS Agregado',
       '',
       'BASICMAGR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '05',
       1060,
       14,
       'BASICMDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base do ICMS Dif',
       'Base do ICMS Diferenciado',
       '',
       'BASICMDIF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       1810,
       16,
       'BASICM_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base ICMS CM',
       'Base ICMS para Recalculo de Custo Mdio',
       '',
       'BASICM_CM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       820,
       12,
       'BASIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base de Clculo  IPI',
       'Base de Clculo do IPI',
       '',
       'BASIPI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1360,
       12,
       'BASIPICAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base IPI Calculado',
       'Base do IPI Calculado',
       '',
       'BASIPICAL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1230,
       12,
       'BASISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base de ISS',
       'Base de ISS',
       '',
       'BASISS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       980,
       12,
       'BASPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base PIS',
       'Base PIS',
       '',
       'BASPIS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       880,
       14,
       'BASSUB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base de Substituio',
       'Base de Substituio',
       '',
       'BASSUB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '05',
       1070,
       14,
       'BASSUBDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'BaseSubstituio Dif',
       'Base Substituio Diferenciado',
       '',
       'BASSUBDIF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       1830,
       16,
       'BAS_ST_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base ST CM',
       'Base ST para Recalculo de Custo Mdio',
       '',
       'BAS_ST_CM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       860,
       14,
       'BSTFRE ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base Subs. frete',
       'Base de Substituio do Conhecimento de Frete',
       '',
       'BSTFRE ',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       1600,
       10,
       'CODBEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd Benefcio Fiscal',
       'Cdigo de Benefcio Fiscal',
       '',
       'CODBEN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       320,
       20,
       'CODBUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo de Busca',
       'Cdigo de Busca',
       '',
       'CODBUS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '01',
       390,
       60,
       'CODCFO',
       'A',
       'CFOP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'CFOP.DESCFO',
       'A',
       '',
       '',
       'A',
       'F',
       'CFOP',
       'Natureza do item de compra',
       'CFOP.CODTAB(+) = ICO.CODCFO',
       'NATUREZAITEMCOMPRA(ICO.CODFIL,ICO.SEQUEN,ICO.NUMITE)',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '02',
       150,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       0,
       'ICO ',
       140,
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       'ICO',
       'F',
       '9',
       'F',
       'Cdigo da Cor',
       'Cdigo da Diviso',
       'DIV.CODITE (+) = ICO.CODCOR',
       'CODCOR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '01',
       400,
       3,
       'CODCST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'CST ICMS',
       'CST ICMS',
       '',
       'CODCST',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1220,
       3,
       'CODCSTDIF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'CST ICMS Dif.',
       'CST ICMS Dif.',
       '',
       'CODCSTDIF',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       1460,
       36,
       'CODFCI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo FCI',
       'Cdigo FCI',
       '',
       'CODFCI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       0,
       'ICO ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'ICO',
       '',
       'A',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = ICO.CODFIL',
       'CODFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '02',
       1310,
       20,
       'CODIGO',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo Fiscal',
       'Cdigo Fiscal',
       '',
       'CAST(ICO.FILMAT || '' '' || ICO.CODMAT || ''-'' || ICO.CODCOR || ''-'' || ICO.CODTAM AS VARCHAR(20))',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '02',
       140,
       5,
       'CODMAT',
       'A',
       '',
       0,
       0,
       'ICO ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ICO',
       'F',
       '9',
       'F',
       'Cdigo do Produto',
       'Cdigo do produto',
       '',
       'CODMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       60,
       2,
       'CODMOE',
       'S',
       'DMOE',
       0,
       0,
       'ICO ',
       60,
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       'ICO',
       'F',
       'A',
       'T',
       'Moeda',
       'Moeda do preo de venda',
       'ICO.CODMOE=DMOE.CODTAB (+)',
       'CODMOE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       330,
       0,
       'CODMUL',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       'F',
       'Sub-Estoque',
       'Nome do Sub-Estoque',
       'DMUL.CODTAB = ICO.CODMUL',
       'CODMUL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '01',
       410,
       1,
       'CODORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Origem Item',
       'Origem Item',
       '',
       'CODORI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '02',
       160,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       0,
       'ICO ',
       150,
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       'ICO',
       'F',
       'A',
       'F',
       'Cdigo do Tamanho',
       'Cdigo da Sub-Diviso',
       'SUB.CODITE (+) = ICO.CODTAM',
       'CODTAM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       490,
       1,
       'COM_ATUCUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Atualiza Custo Rep?',
       'Atualiza Custo Reposio?',
       '',
       'COM_ATUCUS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '03',
       24,
       7,
       'COM_DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data Operao',
       'Data de Operao da Compra',
       '',
       'COM_DATOPE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       1630,
       1,
       'COM_TIPCCM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo Custo Mdio',
       'Tipo Custo Mdio',
       '',
       'COM_TIPCCM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '05',
       1430,
       3,
       'CSTXML',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'CST ICMS XML',
       'CST ICMS XML',
       '',
       'CSTXML',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       20,
       8,
       'CUSANT',
       'F',
       '',
       2,
       0,
       'ICO ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ICO',
       'T',
       '9',
       'T',
       'Custo Anterior',
       'Custo do produto antes da compra',
       '',
       'CUSANT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       350,
       12,
       'CUSFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Custo do Frete',
       'Custo do Frete',
       '',
       'CUSFRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       40,
       14,
       'CUSREP',
       'F',
       '',
       4,
       0,
       'ICO ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ICO',
       'T',
       '9',
       'T',
       'Custo Atual',
       'Custo de reposio atual',
       '',
       'CUSREP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '03',
       30,
       8,
       'DATANT',
       'D',
       '',
       0,
       0,
       'ICO ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ICO',
       'F',
       'D',
       'T',
       'Data do ltimo Custo',
       'Data do custo antes da compra',
       '',
       'DATANT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '03',
       460,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       1800,
       12,
       'DIFAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Difal',
       'Difal',
       '',
       '(CASE WHEN ICO.ICMITE = 4 THEN (((VLRMOV - (VLRMOV*(ICO.ICMITE/100)))/0.88)*0.12)-(VLRMOV*(ICO.ICMITE/100)) ELSE 0 END)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       23,
       1,
       'DUMMY',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       '',
       'Controle Interno',
       '',
       'DUMMY',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       270,
       5,
       'EMBORI',
       'G',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       '9',
       'F',
       'Embalagem Original',
       'Embalagem Original',
       'ICO.EMBORI = SUB.CODITE(+)',
       'EMBORI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       260,
       12,
       'EMBQTD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtde Orig. Embagem',
       'Quantidade Original Embalagem',
       '',
       'EMBQTD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       1420,
       1,
       'EXPFIS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exportado Fiscal?',
       'Exportado Fiscal?',
       '',
       'EXPFIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       500,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exportar?',
       'Exportar?',
       '',
       'EXPORT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '01',
       1290,
       3,
       'FILLOT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial Lote',
       'Filial do Lote',
       'DFIL.CODFIL(+) = ICO.FILLOT',
       'FILLOT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '02',
       130,
       3,
       'FILMAT',
       'A',
       '',
       0,
       0,
       'ICO ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ICO',
       'F',
       'N',
       'F',
       'Filial do Produto',
       'Cdigo da filial origem do produto',
       '',
       'FILMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       440,
       16,
       'FREFIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr.Frete Fiscal.',
       'Vlr.Frete Fiscal.',
       '',
       'FREFIS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       100,
       8,
       'ICMITE',
       'F',
       '',
       2,
       0,
       'ICO ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ICO',
       'T',
       '',
       'T',
       '% ICMS',
       'ICMS por Item',
       '',
       'ICMITE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '05',
       1080,
       14,
       'ICMITEDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% do ICMS Dif',
       '% do ICMS Diferenciado',
       '',
       'ICMITEDIF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       570,
       1,
       'ICMTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo de Tributao',
       'Tipo de Tributao do Produto',
       '',
       'ICMTIP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1000,
       6,
       'ICMVEN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'ICMS Interno para ST',
       'ICMS Interno para ST',
       '',
       'ICMVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '05',
       1090,
       6,
       'ICMVENDIF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% ICMS p/ Venda Dif',
       '% do ICMS para Venda Diferenciado',
       '',
       'ICMVENDIF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       780,
       12,
       'ICO_BASRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Rateio Base Ret. ST',
       'Rateio da Base da Reteno de Substituio Tributria na Fonte',
       '',
       'ICO_BASRET',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       790,
       12,
       'ICO_OUTTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Rateio Ret. ST',
       'Rateio da Reteno de Substituio Tributria na Fonte',
       '',
       'ICO_OUTTAX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       800,
       12,
       'ICO_VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Rateio do Frete',
       'Rateio do Frete no Item',
       '',
       'ICO_VLRFRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       810,
       12,
       'ICO_VLRRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Rateio Outras Taxas',
       'Rateio de Outras Taxas no Item',
       '',
       'ICO_VLRRET',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '03',
       750,
       12,
       'INCONS_TRIB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Incons. de Tributos',
       'Inconsistncia de tributos',
       '',
       'round(ico.vlrmov-(COALESCE(((ICO.VLRMOV*(1+coalesce(ICO.IPIITE,0)/100)) / COM.VLRTOT),1)*COM.DESCON)-(COALESCE(ico.basicm,0)+COALESCE(ico.outicm,0)+COALESCE(ico.iseicm,0))
,2)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       580,
       12,
       'IPIFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor IPI do Frete',
       'Valor IPI do Frete',
       '',
       'IPIFRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       10,
       8,
       'IPIITE',
       'F',
       '',
       2,
       0,
       'ICO ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ICO',
       'T',
       '',
       'T',
       '% de IPI',
       'IPI do item',
       '',
       'IPIITE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1390,
       5,
       'IPITRA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Frao IPI Transf',
       'Frao do IPI na Transferncia',
       '',
       'IPITRA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       430,
       14,
       'ISEICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Iseno ICMS',
       'Iseno ICMS',
       '',
       'ISEICM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '05',
       1180,
       14,
       'ISEICMDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Iseno ICMS Dif',
       'Iseno ICMS Diferenciado',
       '',
       'ISEICMDIF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '02',
       250,
       1,
       'LANEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       190,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'T',
       'Situao no Estoque',
       'Situao de estoque',
       '',
       'LANEST',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '03',
       33,
       2,
       'MES_DATANT',
       'A',
       '',
       0,
       0,
       'ICO ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ICO',
       '',
       'N',
       'T',
       'Ms ltimo Custo',
       'Ms de Data do custo antes da compra',
       '',
       'TO_CHAR(ICO.DATANT,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       1620,
       2,
       'MOTDESON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Mot desonerao ICMS',
       'Motivo da desonerao do ICMS',
       '',
       'MOTDESON',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       760,
       14,
       'MVACOM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       '% MVA para compra',
       '% MVA para compra',
       '',
       'MVACOM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '05',
       1100,
       14,
       'MVACOMDIF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '% de MVA Dif',
       '% de MVA Diferenciado',
       '',
       'MVACOMDIF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '--',
       1280,
       2,
       'NATBCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Nat. Crd. PIS/Cofin',
       'Cdigo da Base de Clculo de Crdito de PIS/Cofins',
       '',
       'NATBCC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '01',
       15,
       3,
       'NUMCODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '01',
       60,
       2,
       'NUMITE',
       'S',
       '',
       0,
       0,
       'ICO ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ICO',
       'F',
       '',
       'T',
       'Item',
       'Nmero do item',
       '',
       'NUMITE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '01',
       360,
       10,
       'ORD_CM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ordem Custo Mdio',
       'Ordem Custo Mdio',
       '',
       'ORD_CM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1630,
       12,
       'OUTDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr.Desp.Pgt.Avulso',
       'Valor da Despesas de Pagamento avulso',
       '',
       'OUTDES',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       410,
       14,
       'OUTICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Outros ICMS',
       'Outros ICMS',
       '',
       'OUTICM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '05',
       1190,
       14,
       'OUTICMDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Outros ICMS Dif',
       'Outros ICMS Diferenciado',
       '',
       'OUTICMDIF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '--',
       1200,
       14,
       'PAUTAF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Pauta Fiscal',
       'Pauta Fiscal',
       '',
       'PAUTAF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1010,
       6,
       'PERCOF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Percentual Cofin',
       'Percentual Cofin',
       '',
       'PERCOF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1400,
       7,
       'PERCRESN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Alq crdito Simples',
       'Alquota aplicvel para clculo do crdito de ICMS (Simples Nacional)',
       '',
       'PERCRESN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1440,
       7,
       'PERDIF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Diferimento',
       '% Diferimento de ICMS',
       '',
       'PERDIF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '05',
       1640,
       6,
       'PERDIFICM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       '% ICMS Dif CST51 F',
       '% ICMS Diferido quando CST51 Viso Fornecedor',
       '',
       'PERDIFICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '05',
       1660,
       6,
       'PERDIFICMDIF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       '% ICMS Dif CST51 E',
       '% ICMS Diferido quando CST51 Viso Empresa',
       '',
       'PERDIFICMDIF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1480,
       6,
       'PERFCP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% FCP',
       '% do ICMS relativo ao Fundo de Combate  Pobreza (FCP)',
       '',
       'PERFCP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1540,
       6,
       'PERFCP_RET',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       '',
       'Perc. FCP ST Ret',
       'Percentual do FCP retido anteriormente por Substituio Tributria',
       '',
       'PERFCP_RET',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1510,
       6,
       'PERFCP_ST',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       '',
       'Percentual FCP ST',
       'Percentual do FCP retido por Substituio Tributria',
       '',
       'PERFCP_ST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1150,
       5,
       'PERICMDEV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Coluna no utilizada',
       'Coluna no utilizada no sistema',
       '',
       'PERICMDEV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1250,
       5,
       'PERISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Percentual de ISS',
       'Percentual de ISS',
       '',
       'PERISS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       80,
       8,
       'PERLUC',
       'F',
       '',
       2,
       0,
       'ICO ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ICO',
       'T',
       '',
       'F',
       'Percentual de Lucro',
       'Percentual de lucro cadastrado no produto',
       '',
       'PERLUC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '01',
       1020,
       6,
       'PERPIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Percentual PIS',
       'Percentual PIS',
       '',
       'PERPIS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       50,
       8,
       'PREANT',
       'F',
       '',
       2,
       0,
       'ICO ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ICO',
       'T',
       '',
       'F',
       'Preo Anterior',
       'Preo de venda antes da compra',
       '',
       'PREANT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       70,
       8,
       'PREATU',
       'F',
       '',
       2,
       0,
       'ICO ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ICO',
       'T',
       '',
       'F',
       'Preo Atual de Venda',
       'Preo atual de venda',
       '',
       'PREATU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       280,
       12,
       'QTDCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Quantidade Compra',
       'Quantidade (lanamento de compra)',
       '',
       'QTDCOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       285,
       12,
       'QTDCOM_CON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Quantidade Conv.Com.',
       'Quantidade Convertida',
       '',
       'QTDCONVERTIDA(ICO.CODTAM,ICO.QTDCOM)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       180,
       8,
       'QTDMOV',
       'F',
       '',
       2,
       0,
       'ICO ',
       160,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ICO',
       'T',
       '9',
       'T',
       'Quantidade',
       'Quantidade do item',
       '',
       'QTDMOV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       185,
       8,
       'QTDMOV_CON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Quantidade Conv.Mov.',
       'Quantidade do item Convertida',
       '',
       'QTDCONVERTIDA(ICO.CODTAM,ICO.QTDMOV)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       370,
       12,
       'QTD_CM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde Custo Mdio',
       'Quantidade Custo Mdio',
       '',
       'QTD_CM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       590,
       5,
       'REDITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base reduzida ICMS',
       'Base reduzida ICMS',
       '',
       'REDITE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '05',
       1110,
       5,
       'REDITEDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base red. ICMS Dif',
       'Reduo de Base de ICMS Diferenciado',
       '',
       'REDITEDIF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1030,
       6,
       'RED_ST',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Reduo Base de ST',
       'Reduo de Base de ST',
       '',
       'RED_ST',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '05',
       1120,
       6,
       'RED_STDIF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Red. Base ST Dif',
       '% de Reduo de Base de ST Diferenciado',
       '',
       'RED_STDIF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       770,
       1,
       'RETSUB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Retm ICMS Fonte ST',
       'Retm ICMS na Fonte por Substituio Tributria',
       '',
       'RETSUB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       510,
       16,
       'SAL_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Saldo Custo Mdio',
       'Saldo Custo Mdio',
       '',
       'SAL_CM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       1890,
       16,
       'SAL_CMORI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Saldo CM Original',
       'Saldo Custo Mdio Original',
       '',
       'SAL_CMORI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '01',
       1300,
       10,
       'SEQLOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq Lote',
       'Sequenciador do Lote',
       '',
       'SEQLOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '01',
       240,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'ICO ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1040,
       2,
       'SITCOF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'CST Cofins
',
       'CST Cofins',
       '',
       'SITCOF',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       830,
       2,
       'SITIPI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Sit. Tributria IPI ',
       'Situao Tributria do IPI',
       '',
       'SITIPI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       120,
       1,
       'SITMOV',
       'A',
       '',
       0,
       0,
       'ICO ',
       110,
       30,
       '',
       '',
       'D',
       'ICO',
       'F',
       'A',
       'T',
       'Situao',
       'Situao do item',
       '',
       'SITMOV',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1050,
       2,
       'SITPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'CST PIS',
       'CST PIS
',
       '',
       'SITPIS',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       870,
       14,
       'ST_FRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Subs. frete',
       'Valor de Substituio do Conhecimento de Frete',
       '',
       'ST_FRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1350,
       6,
       'TAXIPICAL',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Taxa IPI Calculado',
       'Taxa de IPI Calculado',
       '',
       'TAXIPICAL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '02',
       240,
       1,
       'TIPPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       180,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'T',
       'Tipo Produto',
       'Tipo de produto',
       '',
       'TIPPRO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       520,
       16,
       'TOTCMG',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vlr.Total C.M.Gerenc',
       'Valor Total do Custo Mdio Gerencial',
       '',
       'TOTCMG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       1880,
       16,
       'TOTCMGORI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Tot CMG Original',
       'Total Custo Mdio Geral Original',
       '',
       'TOTCMGORI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       530,
       16,
       'TOT_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vlr.Total C.M.Fisc',
       'Valor Total do Custo Mdio Fiscal ',
       '',
       'TOT_CM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       1870,
       16,
       'TOT_CMORI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Tot CM Original',
       'Total Custo Mdio Original',
       '',
       'TOT_CMORI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       290,
       5,
       'UNICOM',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Unidade de Compras',
       'Unidade de Compras',
       '',
       'UNICOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       300,
       5,
       'UNIVEN',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Unidade de Vendas',
       'Unidade de Vendas',
       '',
       'UNIVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       310,
       14,
       'VALCON',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Converso Unidades',
       'Valor de converso entre as unidades de Venda/Compra',
       '',
       'VALCON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       12,
       12,
       'VALORIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Valor IPI',
       'Valor IPI',
       '',
       '((COALESCE(ICO.IPIITE,0) / 100) * ICO.VLRMOV)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       90,
       8,
       'VLRCAL',
       'F',
       '',
       2,
       0,
       'ICO ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ICO',
       'T',
       '',
       'F',
       'Valor Diferena',
       'Valor da diferena de preos',
       '',
       'VLRCAL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       450,
       16,
       'VLRCMG',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr.C.MdioGerencial',
       'Vlr.C.MdioGerencial',
       '',
       'VLRCMG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       1860,
       16,
       'VLRCMGORI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor CMG Original',
       'Valor Custo Mdio Geral Original',
       '',
       'VLRCMGORI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '01',
       430,
       12,
       'VLRCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor de COFINS',
       'Valor de COFINS',
       '',
       'VLRCOF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1410,
       14,
       'VLRCRESN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vl. crdito ICMS SN',
       'Valor do crdito de ICMS que pode ser aproveitado pelo destinatrio',
       '',
       'VLRCRESN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       540,
       12,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Desconto do Item',
       'Valor Desconto do Item',
       '',
       'VLRDES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       1610,
       15,
       'VLRDESON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr ICMS Desonerado',
       'Valor do ICMS desonerado',
       '',
       'VLRDESON',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1450,
       12,
       'VLRDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor ICMS Diferido',
       'Valor do ICMS Diferido',
       '',
       'VLRDIF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '05',
       1650,
       14,
       'VLRDIFICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Vlr ICMS Dif CST51 F',
       'Valor do ICMS Diferido quando CST51 Viso Fornecedor',
       '',
       'VLRDIFICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '05',
       1770,
       14,
       'VLRDIFICMDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Vlr ICMS Dif CST51 E',
       'Valor do ICMS Diferido quando CST51 Viso Empresa',
       '',
       'VLRDIFICMDIF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1490,
       14,
       'VLRFCP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor FCP',
       'Valor do ICMS relativo ao Fundo de Combate  Pobreza (FCP)',
       '',
       'VLRFCP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1550,
       14,
       'VLRFCP_RET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor FCP ST Ret',
       'Valor do FCP retido anteriormente por Substituio Tributria',
       '',
       'VLRFCP_RET',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1520,
       14,
       'VLRFCP_ST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor FCP ST',
       'Valor do FCP retido por Substituio Tributria',
       '',
       'VLRFCP_ST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1380,
       12,
       'VLRFILDES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Preo no Destino',
       'Preo na Filial de Destino (Usado na Base de IPI em Transferncias)',
       '',
       'VLRFILDES',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       420,
       14,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor ICMS',
       'Valor ICMS
Valor ICMS',
       '',
       'VLRICM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1340,
       12,
       'VLRICMAGR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr. ICMS Agregado',
       'Valor de ICMS Agregado',
       '',
       'VLRICMAGR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1160,
       14,
       'VLRICMDEV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Coluna no utilizada',
       'Coluna no utilizada no sistema',
       '',
       'VLRICMDEV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '05',
       1130,
       14,
       'VLRICMDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor do ICMS Dif',
       'Valor do ICMS Diferenciado',
       '',
       'VLRICMDIF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '05',
       1780,
       14,
       'VLRICMOP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Vlr ICMS Operao F',
       'Valor da Operao do ICMS quando CST51 Viso Fornecedor',
       '',
       'VLRICMOP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '05',
       1790,
       14,
       'VLRICMOPDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Vlr ICMS Operao E',
       'Valor da Operao do ICMS quando CST51 Viso Empresa',
       '',
       'VLRICMOPDIF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       1820,
       16,
       'VLRICM_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor de ICMS CM',
       'Valor de ICMS para Recalculo de Custo Mdio',
       '',
       'VLRICM_CM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1580,
       12,
       'VLRICM_CRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Crdito ICMS Transf.',
       'Valor do crdito de ICMS na nota de transferncia',
       '',
       'VLRICM_CRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1590,
       12,
       'VLRICM_EST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Estorno ICMS Transf.',
       'Estorno do crdito de ICMS na nota de transferncia',
       '',
       'VLRICM_EST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       470,
       12,
       'VLRIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Valor IPI',
       'Valor do IPI',
       '',
       'VLRIPI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1370,
       12,
       'VLRIPICAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor IPI Calculado',
       'Valor do IPI Calculado',
       '',
       'VLRIPICAL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       1260,
       12,
       'VLRISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor de ISS',
       'Valor de ISS',
       '',
       'VLRISS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       550,
       12,
       'VLRITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Total do Item',
       'Valor Total do Item',
       '',
       'VLRITE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       190,
       8,
       'VLRMOV',
       'F',
       '',
       2,
       0,
       'ICO ',
       170,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ICO',
       'T',
       '9',
       'T',
       'Valor Item',
       'Valor total do item ',
       '',
       'VLRMOV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '01',
       420,
       12,
       'VLRPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor de PIS',
       'Valor de PIS',
       '',
       'VLRPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       380,
       16,
       'VLR_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Custo Mdio',
       'Valor Custo Mdio',
       '',
       'VLR_CM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       1850,
       16,
       'VLR_CMORI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor CM Original',
       'Valor Custo Mdio Original',
       '',
       'VLR_CMORI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '04',
       890,
       14,
       'VLR_ST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Substituio',
       'Valor de Substituio',
       '',
       'VLR_ST',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '05',
       1140,
       14,
       'VLR_STDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vlr Substituio Dif',
       'Valor de Substituio Diferenciado',
       '',
       'VLR_STDIF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ICO ',
       '99',
       1840,
       16,
       'VLR_ST_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor ST CM',
       'Valor ST para Recalculo de Custo Mdio',
       '',
       'VLR_ST_CM',
       '',
       'D' FROM DUAL
UNION ALL       
SELECT 'ICO',
       '99',
       1892.00,
       16.00,
       'CUSTOREPODATA',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Custo~Reposicao~Data',
       'Custo~Reposicao~Data',
       '',
       'CUSTOREPOSICAODATA(ICO.COM_DATOPE,ICO.FILMAT,ICO.CODMAT,ICO.CODCOR,ICO.CODTAM,ICO.CODFIL,ICO.CODMUL)',
       '',
       'D' FROM DUAL       
);

/*-- SEQ 8164 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ICO ',
       'CODCST',
       0,
       ' ',
       'Trib monof. sobre combustveis',
       TO_NUMBER(null),
       '02' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       ' ',
       'Trib.monof.combus.c/resp/reten',
       TO_NUMBER(null),
       '15' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       ' ',
       'Trib.monof.combus.c/rec/diferi',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       ' ',
       'Trib.monof.combus.c/ST',
       TO_NUMBER(null),
       '61' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       '',
       'Tri.Simpl.s/Crd.c/Cobr.ICMSST',
       TO_NUMBER(null),
       '202' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       '',
       'Isen.Simpl.RecBrtc/Cobr.ICMSST',
       TO_NUMBER(null),
       '203' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       '',
       'Imune',
       TO_NUMBER(null),
       '300' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       '',
       'No tributada pelo Simples',
       TO_NUMBER(null),
       '400' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       '',
       'ICMScobr.ant. p/ST ou p/Antec.',
       TO_NUMBER(null),
       '500' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       '',
       'Outros',
       TO_NUMBER(null),
       '900' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       '',
       'Tributada integralmente',
       TO_NUMBER(null),
       '00' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       '',
       'Tributada com substituio',
       TO_NUMBER(null),
       '10' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       '',
       'Com reduo de base de clculo',
       TO_NUMBER(null),
       '20' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       '',
       'Isenta/no trib. com subst.',
       TO_NUMBER(null),
       '30' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       '',
       'Isenta',
       TO_NUMBER(null),
       '40' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       '',
       'No tributada',
       TO_NUMBER(null),
       '41' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       '',
       'Suspenso',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       '',
       'Diferimento',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       '',
       'ICMS cobrado ant. por subst.',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       '',
       'Reduo de base por subst.',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       '',
       'Outros',
       TO_NUMBER(null),
       '90' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       '',
       'Trib. Simples c/permi. Crdito',
       TO_NUMBER(null),
       '101' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       '',
       'Trib. Simples s/permi. Crdito',
       TO_NUMBER(null),
       '102' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       '',
       'Isen.ICMS Simples ReceitaBruta',
       TO_NUMBER(null),
       '103' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCST',
       0,
       '',
       'Tri.Simpl.c/Crd.c/Cobr.ICMSST',
       TO_NUMBER(null),
       '201' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCSTDIF',
       0,
       '',
       'Tri.Simpl.s/Crd.c/Cobr.ICMSST',
       TO_NUMBER(null),
       '202' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCSTDIF',
       0,
       '',
       'Isen.Simpl.RecBrtc/Cobr.ICMSST',
       TO_NUMBER(null),
       '203' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCSTDIF',
       0,
       '',
       'Imune',
       TO_NUMBER(null),
       '300' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCSTDIF',
       0,
       '',
       'No tributada pelo Simples',
       TO_NUMBER(null),
       '400' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCSTDIF',
       0,
       '',
       'ICMScobr.ant. p/ST ou p/Antec.',
       TO_NUMBER(null),
       '500' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCSTDIF',
       0,
       '',
       'Outros',
       TO_NUMBER(null),
       '900' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCSTDIF',
       0,
       '',
       'Tributada integralmente',
       TO_NUMBER(null),
       '00' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCSTDIF',
       0,
       '',
       'Tributada com substituio',
       TO_NUMBER(null),
       '10' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCSTDIF',
       0,
       '',
       'Com reduo de base de clculo',
       TO_NUMBER(null),
       '20' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCSTDIF',
       0,
       '',
       'Isenta/no trib. com subst.',
       TO_NUMBER(null),
       '30' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCSTDIF',
       0,
       '',
       'Isenta',
       TO_NUMBER(null),
       '40' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCSTDIF',
       0,
       '',
       'No tributada',
       TO_NUMBER(null),
       '41' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCSTDIF',
       0,
       '',
       'Suspenso',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCSTDIF',
       0,
       '',
       'Diferimento',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCSTDIF',
       0,
       '',
       'ICMS cobrado ant. por subst.',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCSTDIF',
       0,
       '',
       'Reduo de base por subst.',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCSTDIF',
       0,
       '',
       'Outros',
       TO_NUMBER(null),
       '90' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCSTDIF',
       0,
       '',
       'Trib. Simples c/permi. Crdito',
       TO_NUMBER(null),
       '101' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCSTDIF',
       0,
       '',
       'Trib. Simples c/permi. Crdito',
       TO_NUMBER(null),
       '102' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCSTDIF',
       0,
       '',
       'Isen.ICMS Simples ReceitaBruta',
       TO_NUMBER(null),
       '103' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODCSTDIF',
       0,
       '',
       'Tri.Simpl.c/Crd.c/Cobr.ICMSST',
       TO_NUMBER(null),
       '201' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODORI',
       8,
       '',
       'Nacional, Import. > a 70%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODORI',
       3,
       '',
       'Nacional, Cont.Import.>40%<70%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODORI',
       4,
       '',
       'Nacional, Conf.Proc.Prod.Bs.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODORI',
       5,
       '',
       'Nacional, Cont.Import <= 40%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODORI',
       6,
       '',
       'Estrang., Import.Dir.CAMEX-GNL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODORI',
       7,
       '',
       'Estrang., Adq.Int. CAMEX-GNL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODORI',
       0,
       '',
       'Nacional, exceto cd.3,4,5,8',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODORI',
       1,
       '',
       'Estrang., Import.Dir., Exc.6',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CODORI',
       2,
       '',
       'Estrang., Adq.Int., Exc.7',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'COM_TIPCCM',
       0,
       'C',
       'Calculado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'COM_TIPCCM',
       0,
       'M',
       'Manter Custo Atual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'COM_TIPCCM',
       0,
       'Z',
       'Custo Zero',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       ' ',
       'Trib monof. sobre combustveis',
       TO_NUMBER(null),
       '02' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       ' ',
       'Trib.monof.combus.c/resp/reten',
       TO_NUMBER(null),
       '15' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       ' ',
       'Trib.monof.combus.c/rec/diferi',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       ' ',
       'Trib.monof.combus.c/ST',
       TO_NUMBER(null),
       '61' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       '',
       'Outros',
       TO_NUMBER(null),
       '900' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       '',
       'Tributada integralmente',
       TO_NUMBER(null),
       '00' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       '',
       'Tributada com substituio',
       TO_NUMBER(null),
       '10' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       '',
       'Com reduo de base de clculo',
       TO_NUMBER(null),
       '20' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       '',
       'Isenta/no trib. com subst.',
       TO_NUMBER(null),
       '30' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       '',
       'Isenta',
       TO_NUMBER(null),
       '40' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       '',
       'No tributada',
       TO_NUMBER(null),
       '41' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       '',
       'Suspenso',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       '',
       'Diferimento',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       '',
       'ICMS cobrado ant. por subst.',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       '',
       'Reduo de base por subst.',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       '',
       'Outros',
       TO_NUMBER(null),
       '90' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       '',
       'Trib. Simples c/permi. Crdito',
       TO_NUMBER(null),
       '101' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       '',
       'Trib. Simples s/permi. Crdito',
       TO_NUMBER(null),
       '102' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       '',
       'Isen.ICMS Simples ReceitaBruta',
       TO_NUMBER(null),
       '103' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       '',
       'Tri.Simpl.c/Crd.c/Cobr.ICMSST',
       TO_NUMBER(null),
       '201' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       '',
       'Tri.Simpl.s/Crd.c/Cobr.ICMSST',
       TO_NUMBER(null),
       '202' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       '',
       'Isen.Simpl.RecBrtc/Cobr.ICMSST',
       TO_NUMBER(null),
       '203' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       '',
       'Imune',
       TO_NUMBER(null),
       '300' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       '',
       'No tributada pelo Simples',
       TO_NUMBER(null),
       '400' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'CSTXML',
       0,
       '',
       'ICMScobr.ant. p/ST ou p/Antec.',
       TO_NUMBER(null),
       '500' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'ICMTIP',
       0,
       '0',
       'Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'ICMTIP',
       0,
       '1',
       'No Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'ICMTIP',
       0,
       '2',
       'Isento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'ICMTIP',
       0,
       '3',
       'Substitudo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'ICMTIP',
       0,
       '4',
       'Isento no Estado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'LANEST',
       0,
       'N',
       'Nao (s Histrico)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'LANEST',
       0,
       'S',
       'Entrada Estoque',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'MOTDESON',
       1,
       '',
       'Txi',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'MOTDESON',
       2,
       '',
       'Deficiente Fsico (Descontinua',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'MOTDESON',
       3,
       '',
       'Produtor Agropecurio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'MOTDESON',
       4,
       '',
       'Frotista/Locadora',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'MOTDESON',
       5,
       '',
       'Diplomtico/Consular',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'MOTDESON',
       6,
       '',
       'Utilitrios/Motocicletas Amaz.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'MOTDESON',
       7,
       '',
       'SUFRAMA',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'MOTDESON',
       8,
       '',
       'Venda a rgo Pblico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'MOTDESON',
       9,
       '',
       'Outros. (NT 2011/004)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'MOTDESON',
       10,
       '',
       'Deficiente Condutor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'MOTDESON',
       11,
       '',
       'Deficiente No Condutor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'MOTDESON',
       12,
       '',
       'rgo de fomento e desenvolvim',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'NATBCC',
       0,
       '',
       'Aquisio de bens para revenda',
       TO_NUMBER(null),
       '01' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'NATBCC',
       0,
       '',
       'Aquisio bens util. c/ insumo',
       TO_NUMBER(null),
       '02' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'NATBCC',
       0,
       '',
       'Aquisio serv. util. insumo',
       TO_NUMBER(null),
       '03' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'NATBCC',
       0,
       '',
       'Energia eltrica e trmica',
       TO_NUMBER(null),
       '04' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'NATBCC',
       0,
       '',
       'Aluguis de prdios',
       TO_NUMBER(null),
       '05' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'NATBCC',
       0,
       '',
       'Aluguis de mquinas e equip.',
       TO_NUMBER(null),
       '06' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'NATBCC',
       0,
       '',
       'Armazenagem mercadoria e frete',
       TO_NUMBER(null),
       '07' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'NATBCC',
       0,
       '',
       'Contraprestaes mercatil',
       TO_NUMBER(null),
       '08' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'NATBCC',
       0,
       '',
       'Crd. s/ encargos depreciao',
       TO_NUMBER(null),
       '09' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'NATBCC',
       0,
       '',
       'Crd. c/ base valor aquisio',
       TO_NUMBER(null),
       '10' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'NATBCC',
       0,
       '',
       'Amort. deprec. edific. imveis',
       TO_NUMBER(null),
       '11' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'NATBCC',
       0,
       '',
       'Dev. de vendas suj. Incidncia',
       TO_NUMBER(null),
       '12' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'NATBCC',
       0,
       '',
       'Outras Operaes direito crd.',
       TO_NUMBER(null),
       '13' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'NATBCC',
       0,
       '',
       'Atividade Transporte de Cargas',
       TO_NUMBER(null),
       '14' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'NATBCC',
       0,
       '',
       'Custo de Unidade Imobiliria',
       TO_NUMBER(null),
       '15' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'NATBCC',
       0,
       '',
       'Custo unidade no concluda',
       TO_NUMBER(null),
       '16' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'NATBCC',
       0,
       '',
       'Atividade de Prestao de Serv',
       TO_NUMBER(null),
       '17' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'NATBCC',
       0,
       '',
       'Estoque de abertura de bens',
       TO_NUMBER(null),
       '18' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Presum-Aquis Trib Export',
       TO_NUMBER(null),
       '64' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Presum-Aquis NTrib Export',
       TO_NUMBER(null),
       '65' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Presum-Aquis Trib NTrib Exp
',
       TO_NUMBER(null),
       '66' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Presum-Outras Operaes
',
       TO_NUMBER(null),
       '67' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Aquisio sem Dir Crdito',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Aquisio com Iseno',
       TO_NUMBER(null),
       '71' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Aquisio com Suspenso',
       TO_NUMBER(null),
       '72' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Aquisio a Alquota Zero',
       TO_NUMBER(null),
       '73' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Aquisio sem Inc Contrib',
       TO_NUMBER(null),
       '74' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Aquisio por ST
',
       TO_NUMBER(null),
       '75' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Crdito-Tributada',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Crdito-No Tributada',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Crdito-Exportao',
       TO_NUMBER(null),
       '52' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Crdito-Vinc Trib NTrib',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Crdito-Vinc Trib Export',
       TO_NUMBER(null),
       '54' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Crdito-Vinc NTrib Export',
       TO_NUMBER(null),
       '55' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Crdito-Vinc Trib NTrib Exp',
       TO_NUMBER(null),
       '56' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Presum-Aquis Exc Trib',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Presum-Aquis Exc NTrib',
       TO_NUMBER(null),
       '61' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Presum-Aquis Exc Export',
       TO_NUMBER(null),
       '62' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Presum-Aquis Trib NTrib',
       TO_NUMBER(null),
       '63' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Outras Operaes de Entrada',
       TO_NUMBER(null),
       '98' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITCOF',
       0,
       '',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITMOV',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITMOV',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Presum-Aquis Trib Export',
       TO_NUMBER(null),
       '64' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Presum-Aquis NTrib Export',
       TO_NUMBER(null),
       '65' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Presum-Aquis Trib NTrib Exp',
       TO_NUMBER(null),
       '66' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Presum-Outras Operaes',
       TO_NUMBER(null),
       '67' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Aquisio sem Dir Crdito',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Aquisio com Iseno',
       TO_NUMBER(null),
       '71' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Aquisio com Suspenso',
       TO_NUMBER(null),
       '72' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Aquisio a Alquota Zero',
       TO_NUMBER(null),
       '73' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Aquisio sem Inc Contrib',
       TO_NUMBER(null),
       '74' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Aquisio por ST
',
       TO_NUMBER(null),
       '75' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Outras Operaes de Entrada',
       TO_NUMBER(null),
       '98' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Crdito-Tributada',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Crdito-No Tributada',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Crdito-Exportao',
       TO_NUMBER(null),
       '52' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Crdito-Vinc Trib NTrib
',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Crdito-Vinc Trib Export',
       TO_NUMBER(null),
       '54' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Crdito-Vinc NTrib Export',
       TO_NUMBER(null),
       '55' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Crdito-Vinc Trib NTrib Exp',
       TO_NUMBER(null),
       '56' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Presum-Aquis Exc Trib
',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Presum-Aquis Exc NTrib
',
       TO_NUMBER(null),
       '61' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Presum-Aquis Exc Export',
       TO_NUMBER(null),
       '62' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'SITPIS',
       0,
       '',
       'Presum-Aquis Trib NTrib',
       TO_NUMBER(null),
       '63' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'TIPPRO',
       0,
       '0',
       'Material',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'TIPPRO',
       1,
       '1',
       'Servio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICO ',
       'TIPPRO',
       2,
       '2',
       'Terceirizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8165 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ICOM',
       TO_NUMBER(null),
       'ICOM',
       'Importa Compras',
       'TI_COM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8166 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ICOM','--','' FROM DUAL
UNION ALL
SELECT 'ICOM','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ICOM','99','Outros' FROM DUAL
);

/*-- SEQ 8167 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ICOM',
       '--',
       10,
       3,
       'ACRESC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Acrscimo',
       'Acrscimo',
       '',
       'ACRESC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       20,
       1,
       'ATUCUS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Atualiza Custos?',
       'Atualiza Custos?',
       '',
       'ATUCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       30,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       40,
       12,
       'BASFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base de ICM do frete',
       'Base de ICM do frete',
       '',
       'BASFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       780,
       44,
       'CHAVEA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Chave acesso da NF-e',
       'Chave de acesso da NF-e',
       '',
       'CHAVEA',
       '' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       50,
       6,
       'CODCFO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio CFOP',
       'Descrio CFOP de compra',
       '',
       'CODCFO',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       60,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da Filial de Origem',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       70,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cdigo~Fornecedor',
       'Cdigo do fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       80,
       15,
       'CODMOE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Moeda',
       'Moeda',
       '',
       'CODMOE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       90,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Srie',
       'Cdigo da srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       100,
       15,
       'CODSET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Setor',
       'Setor',
       '',
       'CODSET',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       110,
       20,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Usurio',
       'Usurio',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       120,
       10,
       'CONPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cond. Pagto.',
       'Condio de Pagamento',
       '',
       'CONPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       130,
       7,
       'DATCMP',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Compra',
       'Data da compra',
       '',
       'DATCMP',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       140,
       7,
       'DATIMP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Importao',
       'Data da Importao',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       150,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data Lanto',
       'Data da operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       160,
       12,
       'DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Desconto',
       'Desconto',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       170,
       3,
       'ESPDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Espcie Docto',
       'Espcie de Documento',
       '',
       'ESPDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       180,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exporta?',
       'Exporta?',
       '',
       'EXPORT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       190,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Conta',
       'Filial Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       200,
       3,
       'FILEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Endereo',
       'Filial endereo',
       '',
       'FILEND',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       210,
       3,
       'FILFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Fatura',
       'Filial Fatura',
       '',
       'FILFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       220,
       3,
       'FILFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Frete',
       'Filial Frete',
       '',
       'FILFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       230,
       1,
       'FLGCOF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Flag Cofins',
       'Flag Cofins',
       '',
       'FLGCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       240,
       1,
       'FLGCSS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Flag CSS',
       'Flag CSS',
       '',
       'FLGCSS',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       250,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Situao (Devolvida/Quitada/Em aberto)',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       260,
       1,
       'FLGINS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Flag INSS',
       'Flag INSS',
       '',
       'FLGINS',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       270,
       1,
       'FLGPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Flag PIS',
       'Flag PIS',
       '',
       'FLGPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       280,
       20,
       'FORFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Fornecedor Fatura',
       'Fornecedor Fatura',
       '',
       'FORFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       290,
       20,
       'FORFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Fornecedor Frete',
       'Fornecedor Frete',
       '',
       'FORFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       300,
       12,
       'ICMFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor ICMS/Frete',
       'Valor ICMS/Frete',
       '',
       'ICMFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       310,
       1,
       'INCOJU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Correo',
       'Indicador do tipo de correo de juros',
       '',
       'INCOJU',
       'T' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       320,
       1,
       'INTPJU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Juros',
       'Indicador do tipo de juros',
       '',
       'INTPJU',
       'T' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       330,
       1,
       'INTPMU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Multa',
       'Indicador do tipo de multa',
       '',
       'INTPMU',
       'T' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       340,
       15,
       'MOEJUR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Moeda da Correo',
       'Moeda da Correo',
       '',
       'MOEJUR',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       350,
       255,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo da~Rejeio',
       'Motivo da Rejeio',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       360,
       0,
       'NOTESP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Nota Especial?',
       'Nota Especial',
       '',
       'NOTESP',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       370,
       4,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero de Endereos',
       'Nmero de Endereos',
       '',
       'NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       380,
       8,
       'NUMFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Fatura',
       'Nmero Fatura',
       '',
       'NUMFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       390,
       8,
       'NUMFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Frete',
       'Nmero Frete',
       '',
       'NUMFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       400,
       8,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Nota',
       'Nmero Nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       410,
       5,
       'NUMVOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero Volume',
       'Nmero Volume',
       '',
       'NUMVOL',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       420,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       430,
       255,
       'OBSFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao Fatura',
       'Observao Fatura',
       '',
       'OBSFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       440,
       12,
       'OUTTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Outras Taxas',
       'Outras Taxas',
       '',
       'OUTTAX',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       450,
       5,
       'PERCSS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       '% CSS',
       '% CSS',
       '',
       'PERCSS',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       460,
       5,
       'PERFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '% Frete',
       '% Frete',
       '',
       'PERFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       470,
       5,
       'PERICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '% ICMS',
       '% ICMS',
       '',
       'PERICM',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       480,
       5,
       'PERINS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '% INSS',
       '% INSS',
       '',
       'PERINS',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       490,
       5,
       'PERIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '% IRR',
       '% IRR',
       '',
       'PERIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       500,
       5,
       'PERISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '% ISS',
       '% ISS',
       '',
       'PERISS',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       510,
       12,
       'QTDTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde Total',
       'Qtde Total',
       '',
       'QTDTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       520,
       12,
       'RETCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Reteno COFINS',
       'Reteno COFINS',
       '',
       'RETCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       530,
       2,
       'SERFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie Fatura',
       'Srie Fatura',
       '',
       'SERFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       540,
       2,
       'SERFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie Frete',
       'Srie Frete',
       '',
       'SERFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       550,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN ICOM.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       551,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN ICOM.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       560,
       1,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status da~importao',
       'Status da importao',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       570,
       3,
       'SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Sub-Srie',
       'Sub-Srie de compra',
       '',
       'SUBSER',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       580,
       12,
       'SUBSTT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Substit. Tributria',
       'Substit. Tributria',
       '',
       'SUBSTT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       590,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       600,
       1,
       'TIPNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Documento',
       'Tipo de Documento',
       '',
       'TIPNOT',
       'T' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       610,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Parceiro',
       'Tipo de Parceiro',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       620,
       1,
       'TIPTRP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Transp. Frete',
       'Tipo de Transporte no Registro de Frete',
       '',
       'TIPTRP',
       'T' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       630,
       250,
       'TITCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo da Conta',
       'Ttulo da Conta',
       '',
       'TITCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       640,
       2,
       'UFNOTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF da Nota',
       'UF da Nota',
       '',
       'UFNOTA',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       650,
       1,
       'USOCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Uso da Conta',
       'Uso da Conta',
       '',
       'USOCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       660,
       14,
       'VLRBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Bonificao',
       'Valor Bonificao',
       '',
       'VLRBON',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       670,
       12,
       'VLRCSS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor CSS',
       'Valor CSS',
       '',
       'VLRCSS',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       680,
       12,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor do frete',
       'Valor do frete',
       '',
       'VLRFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       690,
       12,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor ICMS',
       'Valor ICMS',
       '',
       'VLRICM',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       700,
       12,
       'VLRINS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor INSS',
       'Valor INSS',
       '',
       'VLRINS',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       710,
       12,
       'VLRIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor IRR',
       'Valor IRR',
       '',
       'VLRIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       720,
       12,
       'VLRISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor ISS',
       'Valor ISS',
       '',
       'VLRISS',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       730,
       12,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Lquido',
       'Valor lquido',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       740,
       12,
       'VLRRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Reteno',
       'Valor Reteno',
       '',
       'VLRRET',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       750,
       12,
       'VLRTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Total',
       'Valor total',
       '',
       'VLRTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       760,
       12,
       'VLTXJU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Juros',
       'Valor ou taxa de juros',
       '',
       'VLTXJU',
       'F' FROM DUAL
UNION ALL
SELECT 'ICOM',
       '--',
       770,
       12,
       'VLTXMU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Multa',
       'Valor ou taxa de multa',
       '',
       'VLTXMU',
       'F' FROM DUAL
);

/*-- SEQ 8168 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ICOM',
       'FLGEST',
       0,
       'A',
       'Em aberto',
       12,
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'FLGEST',
       0,
       'D',
       'Devolvida',
       10,
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'FLGEST',
       0,
       'Q',
       'Quitada',
       11,
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'INCOJU',
       0,
       '$',
       'Moeda',
       16,
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'INCOJU',
       0,
       '0',
       'Nao h',
       18,
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'INCOJU',
       0,
       'A',
       'Anual',
       15,
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'INCOJU',
       0,
       'D',
       'Diria',
       13,
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'INCOJU',
       0,
       'M',
       'Mensal',
       14,
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'INTPJU',
       0,
       'C',
       'Composto',
       20,
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'INTPJU',
       0,
       'F',
       'Fixo',
       21,
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'INTPJU',
       0,
       'S',
       'Simples',
       19,
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'INTPMU',
       0,
       '#',
       'Percentual Corrigido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'INTPMU',
       0,
       '$',
       'Valor',
       23,
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'INTPMU',
       0,
       '%',
       'Percentual',
       22,
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'INTPMU',
       0,
       '@',
       'Valor Corrigido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'TIPNOT',
       0,
       'A',
       'N.F.F.',
       276,
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'TIPNOT',
       0,
       'F',
       'Fatura',
       274,
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'TIPNOT',
       0,
       'N',
       'Nota Fiscal',
       275,
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'TIPPAR',
       0,
       'F',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'TIPPAR',
       0,
       'T',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'TIPTRP',
       0,
       '0',
       'Rodovirio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'TIPTRP',
       0,
       '1',
       'Aquavirio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'TIPTRP',
       0,
       '2',
       'Areo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'TIPTRP',
       0,
       '3',
       'Ferrovirio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'USOCTA',
       0,
       'B',
       'Bancos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'USOCTA',
       0,
       'C',
       'Cartes de Crdito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'USOCTA',
       0,
       'E',
       'ECFs',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'USOCTA',
       0,
       'L',
       'Limites C/C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'USOCTA',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICOM',
       'USOCTA',
       0,
       'P',
       'Portadores',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8169 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ICP ',
       TO_NUMBER(null),
       'ICP ',
       'Itens da Cotao',
       'TT_ICP',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8170 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ICP ','--','' FROM DUAL
UNION ALL
SELECT 'ICP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ICP ','99','Outros' FROM DUAL
);

/*-- SEQ 8171 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 32872,
       'VIPR',
       'ICP ',
       '1',
       '0N',
       '',
       '',
       'VIPR.FILMAT = ICP.FILMAT AND
VIPR.CODMAT = ICP.CODMAT AND
VIPR.CODCOR = ICP.CODCOR AND
VIPR.CODTAM = ICP.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 8172 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ICP ',
       '99',
       50,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Atualizao',
       'Data Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'ICP ',
       '99',
       90,
       5,
       'CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Diviso',
       'Cdigo da Diviso',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'ICP ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = ICP.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ICP ',
       '99',
       80,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Produto',
       'Cdigo do Produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICP ',
       '99',
       100,
       5,
       'CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Sub-Divis',
       'Cdigo da Sub-Diviso',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'ICP ',
       '99',
       40,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'ICP ',
       '99',
       60,
       3,
       'FILENT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial de Entrega',
       'Filial de Entrega',
       'DFIL.CODFIL = ICP.FILENT',
       'FILENT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICP ',
       '99',
       70,
       3,
       'FILMAT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial do Produto',
       'Filial do Produto',
       'DFIL.CODFIL = ICP.FILMAT',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICP ',
       '99',
       110,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'ICP ',
       '01',
       30,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero do Item',
       'Nmero do Item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICP ',
       '99',
       120,
       12,
       'QTDITE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Quantidade',
       'Quantidade',
       '',
       'QTDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICP ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequnciador',
       'Sequnciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8173 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ICP ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICP ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICP ',
       'FLGEST',
       0,
       'F',
       'Finalizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8174 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ICT ',
       TO_NUMBER(null),
       'ICT ',
       'Itens de Contrato',
       'TT_ICT',
       'F',
       '',
       'TOTALL',
       'Iem de Contrato de Manuteno e Alocao',
       '',
       '',
       '',
       '',
       'F',
       '',
       'ICT.CODFIL,ICT.SEQUEN,ICT.NUMITE
CTT.ID,ICT.NUMITE',
       '' FROM DUAL
);

/*-- SEQ 8175 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ICT ','--','' FROM DUAL
);

/*-- SEQ 8176 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5643,
       'CTT ',
       'ICT ',
       '1 ',
       'N ',
       '',
       '',
       'CTT.CODFIL = ICT.CODFIL AND
CTT.SEQUEN = ICT.SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 5644,
       'GRA ',
       'ICT ',
       '1 ',
       'N ',
       '',
       '',
       'GRA.FILMAT = ICT.FILMAT and
GRA.CODMAT = ICT.CODMAT and
GRA.CODCOR = ICT.CODCOR and
GRA.CODTAM = ICT.CODTAM
',
       '' FROM DUAL
UNION ALL
SELECT 5645,
       'PRO ',
       'ICT ',
       '1 ',
       'N ',
       '',
       '',
       'PRO.FILMAT = ICT.FILMAT and
PRO.CODMAT = ICT.CODMAT and
PRO.CONTRA = ICT.CTTPRO',
       '' FROM DUAL
);

/*-- SEQ 8177 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ICT ',
       '--',
       6,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       60,
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Diviso do Produto',
       'ICT.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'ICT ',
       '--',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial no Contrato',
       'DFIL.CODFIL = ICT.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ICT ',
       '--',
       5,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Cdigo do Produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICT ',
       '--',
       7,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       70,
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do Produto',
       'ICT.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'ICT ',
       '--',
       8,
       1,
       'CTTPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       80,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Produto  Contrato?',
       'Produto  do Tipo Contrato',
       '',
       'CTTPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'ICT ',
       '--',
       4,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ICT ',
       '--',
       3,
       5,
       'NUMITE',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nmero do Item',
       'Nmero do Item de Contrato',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'ICT ',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'ICT ',
       '--',
       18,
       1,
       'TIPPRO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Produto',
       'Tipo de produto',
       '',
       'TIPPRO',
       'T' FROM DUAL
);

/*-- SEQ 8178 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ICT ',
       'TIPPRO',
       0,
       '0',
       'Material',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICT ',
       'TIPPRO',
       1,
       '1',
       'Servio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ICT ',
       'TIPPRO',
       2,
       '2',
       'Terceirizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8179 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IDF ',
       0,
       'IDF ',
       'Identificador Filial',
       'TT_IDF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8180 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IDF ','--','' FROM DUAL
UNION ALL
SELECT 'IDF ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IDF ','99','Outros' FROM DUAL
);

/*-- SEQ 8181 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 26979,
       'MUN ',
       'IDF ',
       '1',
       '1',
       '',
       '',
       'MUN.CODIGO = IDF.CODCID',
       '',
       '' FROM DUAL
);

/*-- SEQ 8182 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IDF ',
       '--',
       300,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       80,
       2,
       'BASINS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Insero da Base',
       'Insero da Base',
       '',
       'BASINS',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       40,
       5,
       'CODCEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IDF ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cep',
       'Cep',
       '',
       'CODCEP',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       30,
       5,
       'CODCID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IDF ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cidade',
       'Cdigo da Cidade',
       '',
       'CODCID',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       20,
       3,
       'CODDEP',
       'A',
       '',
       0,
       0,
       'IDF ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'IDF',
       'F',
       'A',
       'F',
       'Cdigo Depsito',
       'Cdigo do Depsito',
       '',
       'CODDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '--',
       400,
       10,
       'CODIBG',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cd. IBGE Municpio',
       'Cdigo IBGE do Municpio',
       '',
       'CODIBG',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       50,
       3,
       'CODLOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IDF ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Logradouro',
       'Logradouro',
       '',
       'CODLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       10,
       3,
       'CODLOJ',
       'A',
       '',
       0,
       0,
       'IDF ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'IDF',
       'F',
       'A',
       'F',
       'Cdigo da Loja',
       'Cdigo da loja',
       '',
       'CODLOJ',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '99',
       430,
       7,
       'DATABC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Grade ABC XYZ',
       'Data do ltimo Reclculo da Classificao ABC XYZ da Grade',
       '',
       'DATABC',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '--',
       390,
       20,
       'DATBAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Database/SID para Conexo sem BDE',
       '',
       'DATBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '--',
       310,
       7,
       'DATCAR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '--',
       410,
       7,
       'DATCUS_VEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATCUS_VEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       270,
       1,
       'LOCK_C',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Lock Processo Conc.?',
       'garante que no ocorra este processo de forma concorrente',
       '',
       'LOCK_C',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       280,
       1,
       'LOCK_F',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Lock Processo Fin.?',
       'garante que no ocorra este processo de forma concorrente',
       '',
       'LOCK_F',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       100,
       1,
       'MANUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Manuteno',
       'Manuteno',
       '',
       'MANUT',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '--',
       320,
       20,
       'NOMPER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NOMPER',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '--',
       330,
       40,
       'PROTEQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Caminho do PROTEQ na rede',
       '',
       'PROTEQ',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       110,
       2,
       'RELEASE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Release',
       'Release',
       '',
       'RELEASE',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       120,
       2,
       'REL_BO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Release Backoffice',
       'Release Backoffice',
       '',
       'REL_BO',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       130,
       2,
       'REL_CA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Release Cash',
       'Release Cash',
       '',
       'REL_CA',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       140,
       2,
       'REL_CG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Release Config',
       'Release Config',
       '',
       'REL_CG',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       150,
       2,
       'REL_CS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Rel.CheckOut Server',
       'Release CheckoutServer',
       '',
       'REL_CS',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       160,
       2,
       'REL_OR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Release Order',
       'Release Order',
       '',
       'REL_OR',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       170,
       2,
       'REL_SD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Release Delivery',
       'Release Delivery',
       '',
       'REL_SD',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       180,
       2,
       'REL_SW',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Release Sac/W.F.',
       'Release Sac Work Flow',
       '',
       'REL_SW',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       190,
       2,
       'REL_TO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Release Tools',
       'Release Tools',
       '',
       'REL_TO',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       200,
       200,
       'SENINT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Senha',
       'Senha',
       '',
       'SENINT',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '--',
       380,
       20,
       'SERVID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Servidor para Conexo sem BDE',
       '',
       'SERVID',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       210,
       30,
       'TBSDAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tabela de Dados',
       'Tabela de Dados',
       '',
       'TBSDAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       220,
       30,
       'TBSIND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tabela Dados ndice',
       'Tabela de Dados ndice',
       '',
       'TBSIND',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       230,
       10,
       'TIPARQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Arquivo',
       'Tipo Arquivo',
       '',
       'TIPARQ',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       240,
       4,
       'ULTCMD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'ltimo Comando',
       'ltimo Comando',
       '',
       'ULTCMD',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       250,
       7,
       'ULTVER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'ltima Verso',
       'ltima verso',
       '',
       'ULTVER',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       90,
       1,
       'UNICO',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'nico',
       'nico',
       '',
       'UNICO',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       260,
       10,
       'USUADM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Usurio Administrado',
       'Usurio Administrador',
       '',
       'USUADM',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       6,
       2,
       'VERBAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Verso da Base',
       'Verso da Base',
       '',
       'VERBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '--',
       340,
       10,
       'VERDET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VERDET',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '99',
       420,
       5,
       'VERJOB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Verso TTJob.exe',
       'Verso Mnima do TTJob.exe',
       '',
       'VERJOB',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       7,
       12,
       'VERMET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Verso do MetaDados',
       'Verso do MetaDados',
       '',
       'VERMET',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       290,
       2,
       'VERPER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Verso Personalizada',
       'Verso Personalizada',
       '',
       'VERPER',
       '' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '--',
       370,
       3,
       'VERSEG',
       'F',
       '',
       1,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Verso TTSEGUR.dll',
       'Verso Mnima da TTSEGUR.dll',
       '',
       'VERSEG',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       350,
       256,
       'XMLASS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Assinatura do XML',
       'Assinatura do XML de Licena',
       '',
       'XMLASS',
       'F' FROM DUAL
UNION ALL
SELECT 'IDF ',
       '01',
       360,
       0,
       'XMLDOC',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento XML',
       'Documento XML de Licena',
       '',
       'XMLDOC',
       'F' FROM DUAL
);

/*-- SEQ 8183 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IED ',
       TO_NUMBER(null),
       'IED ',
       'Importa e Exporta',
       'TT_IED',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8184 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IED ','--','' FROM DUAL
UNION ALL
SELECT 'IED ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IED ','99','Outros' FROM DUAL
);

/*-- SEQ 8185 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IED ',
       '--',
       10,
       1,
       'ALTERA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Altera via Front-End',
       'Permite alterar via front-end?',
       '',
       'ALTERA',
       'F' FROM DUAL
UNION ALL
SELECT 'IED ',
       '--',
       20,
       12,
       'CNTEXP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde Exportaes',
       'Contador de nmero de vezes exportados',
       '',
       'CNTEXP',
       'F' FROM DUAL
UNION ALL
SELECT 'IED ',
       '--',
       30,
       12,
       'CNTIMP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde Importaes',
       'Contador de nmero de vezes importados',
       '',
       'CNTIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'IED ',
       '--',
       40,
       1,
       'EXCLUI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exclui via~front-end',
       'Permite excluir via front-end?',
       '',
       'EXCLUI',
       'F' FROM DUAL
UNION ALL
SELECT 'IED ',
       '--',
       50,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exporta~dados?',
       'Exporta dados?',
       '',
       'EXPORT',
       'F' FROM DUAL
UNION ALL
SELECT 'IED ',
       '--',
       60,
       1,
       'IMPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Importa~dados?',
       'Importa dados?',
       '',
       'IMPORT',
       'F' FROM DUAL
UNION ALL
SELECT 'IED ',
       '--',
       70,
       1,
       'INCLUI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Inclui via~Front-End',
       'Permite Incluir via Front-End?',
       '',
       'INCLUI',
       'F' FROM DUAL
UNION ALL
SELECT 'IED ',
       '--',
       80,
       1,
       'MANTEM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Mantem dados Integra',
       'Mantem os dados na tabela integrao mesmo aps importados com sucesso?',
       '',
       'MANTEM',
       'F' FROM DUAL
UNION ALL
SELECT 'IED ',
       '--',
       90,
       12,
       'QTDEXP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde Ult.~Exportao',
       'Quantidade da ltima exportao',
       '',
       'QTDEXP',
       'F' FROM DUAL
UNION ALL
SELECT 'IED ',
       '--',
       100,
       12,
       'QTDIMP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde Ult.~Importao',
       'Quantidade da ltima importao',
       '',
       'QTDIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'IED ',
       '--',
       110,
       3,
       'TABELA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tabela',
       'Tabela',
       '',
       'TABELA',
       'F' FROM DUAL
UNION ALL
SELECT 'IED ',
       '--',
       120,
       12,
       'TOTEXP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Total de Exportaes',
       'Quantidade geral de todas as exportaes',
       '',
       'TOTEXP',
       'F' FROM DUAL
UNION ALL
SELECT 'IED ',
       '--',
       130,
       12,
       'TOTIMP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Total de Importaes',
       'Quantidade geral de todas as importaes',
       '',
       'TOTIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'IED ',
       '--',
       140,
       7,
       'ULTEXP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data/Hora~Exportao',
       'Data/Hora~Exportao',
       '',
       'ULTEXP',
       'F' FROM DUAL
UNION ALL
SELECT 'IED ',
       '--',
       150,
       7,
       'ULTIMP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data/Hora~Importao',
       'Data e Hora da ltima importao',
       '',
       'ULTIMP',
       'F' FROM DUAL
);

/*-- SEQ 8186 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IED ',
       'TABELA',
       0,
       ' ',
       'Conta Corrente de Cliente',
       TO_NUMBER(null),
       'CCC' FROM DUAL
UNION ALL
SELECT 'IED ',
       'TABELA',
       0,
       ' ',
       'Cheques Recebidos',
       TO_NUMBER(null),
       'CHR' FROM DUAL
UNION ALL
SELECT 'IED ',
       'TABELA',
       0,
       ' ',
       'Clientes/Parceiros',
       TO_NUMBER(null),
       'CLI' FROM DUAL
UNION ALL
SELECT 'IED ',
       'TABELA',
       0,
       ' ',
       'Compras de Mercadorias',
       TO_NUMBER(null),
       'COM' FROM DUAL
UNION ALL
SELECT 'IED ',
       'TABELA',
       0,
       ' ',
       'Dados de Leitura Z da ECF',
       TO_NUMBER(null),
       'ECF' FROM DUAL
UNION ALL
SELECT 'IED ',
       'TABELA',
       0,
       ' ',
       'Limite de Conta Corrente',
       TO_NUMBER(null),
       'LIM' FROM DUAL
UNION ALL
SELECT 'IED ',
       'TABELA',
       0,
       ' ',
       'Movimentao de Estoque',
       TO_NUMBER(null),
       'MOV' FROM DUAL
UNION ALL
SELECT 'IED ',
       'TABELA',
       0,
       ' ',
       'Notas Fiscais Emitidas',
       TO_NUMBER(null),
       'NFE' FROM DUAL
UNION ALL
SELECT 'IED ',
       'TABELA',
       0,
       ' ',
       'Produtos',
       TO_NUMBER(null),
       'PRO' FROM DUAL
UNION ALL
SELECT 'IED ',
       'TABELA',
       0,
       ' ',
       'Saldos de Estoques',
       TO_NUMBER(null),
       'SAL' FROM DUAL
);

/*-- SEQ 8187 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IEN ',
       TO_NUMBER(null),
       'IEN ',
       'Itens de Envio',
       'TT_IEN',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'IEN.CODFIL,IEN.SEQIEN',
       '' FROM DUAL
);

/*-- SEQ 8188 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IEN ','--','' FROM DUAL
UNION ALL
SELECT 'IEN ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IEN ','99','Outros' FROM DUAL
);

/*-- SEQ 8189 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5654,
       'ENV ',
       'IEN ',
       '1 ',
       'N ',
       '',
       '',
       'ENV.CODFIL = IEN.CODFIL AND
ENV.SEQUEN = IEN.SEQENV',
       '' FROM DUAL
);

/*-- SEQ 8190 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IEN ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = IEN.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'IEN ',
       '01',
       20,
       200,
       'L1_200',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha1-200 caractere',
       'Linha1 - 200 caracteres',
       '',
       'L1_200',
       'F' FROM DUAL
UNION ALL
SELECT 'IEN ',
       '01',
       30,
       240,
       'L1_240',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha1-240 caractere',
       'Linha1 - 240 caracteres',
       '',
       'L1_240',
       'F' FROM DUAL
UNION ALL
SELECT 'IEN ',
       '01',
       40,
       200,
       'L2_200',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha2-200 caractere',
       'Linha2 - 200 caracteres',
       '',
       'L2_200',
       'F' FROM DUAL
UNION ALL
SELECT 'IEN ',
       '01',
       50,
       10,
       'SEQENV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Seq. de Envio',
       '',
       'SEQENV',
       'F' FROM DUAL
UNION ALL
SELECT 'IEN ',
       '01',
       60,
       10,
       'SEQIEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Seq. Itens de Envio',
       '',
       'SEQIEN',
       'F' FROM DUAL
);

/*-- SEQ 8191 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IEX ',
       TO_NUMBER(null),
       'IEX ',
       'Itens Extrato',
       'TT_IEX',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8192 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IEX ','--','' FROM DUAL
UNION ALL
SELECT 'IEX ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IEX ','99','Outros' FROM DUAL
);

/*-- SEQ 8193 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IEX ',
       '--',
       10,
       5,
       'AGEORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Agncia Origem',
       'Agncia Origem',
       '',
       'AGEORI',
       'F' FROM DUAL
UNION ALL
SELECT 'IEX ',
       '--',
       20,
       2,
       'ALINEA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Alnea',
       'Alnea',
       '',
       'ALINEA',
       'F' FROM DUAL
UNION ALL
SELECT 'IEX ',
       '--',
       30,
       3,
       'BCOORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Banco Origem',
       'Banco Origem',
       '',
       'BCOORI',
       'F' FROM DUAL
UNION ALL
SELECT 'IEX ',
       '--',
       40,
       3,
       'CODCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo~Contato',
       'Cdigo Contato',
       '',
       'CODCON',
       'F' FROM DUAL
UNION ALL
SELECT 'IEX ',
       '--',
       50,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = IEX.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'IEX ',
       '--',
       60,
       8,
       'CODHIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo~Histrico',
       'Cdigo~Histrico',
       '',
       'CODHIS',
       'F' FROM DUAL
UNION ALL
SELECT 'IEX ',
       '--',
       70,
       1,
       'CPMF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'CPMF?',
       'CPMF?',
       '',
       'CPMF',
       'F' FROM DUAL
UNION ALL
SELECT 'IEX ',
       '--',
       80,
       10,
       'CTBORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Conta Bancria Ori.',
       'Conta Bancria Origem',
       '',
       'CTBORI',
       'F' FROM DUAL
UNION ALL
SELECT 'IEX ',
       '--',
       90,
       7,
       'DATCON',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data conciliao',
       'Data conciliao',
       '',
       'DATCON',
       'F' FROM DUAL
UNION ALL
SELECT 'IEX ',
       '--',
       100,
       7,
       'DATLAN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Lanamento',
       'Data Lanamento',
       '',
       'DATLAN',
       'F' FROM DUAL
UNION ALL
SELECT 'IEX ',
       '--',
       110,
       7,
       'DATORI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fiscal',
       'Data Fiscal',
       '',
       'DATORI',
       'F' FROM DUAL
UNION ALL
SELECT 'IEX ',
       '--',
       120,
       39,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'IEX ',
       '--',
       140,
       25,
       'HISTOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Histrico',
       'Histrico',
       '',
       'HISTOR',
       'F' FROM DUAL
UNION ALL
SELECT 'IEX ',
       '--',
       150,
       3,
       'NATURE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Natureza',
       'Natureza',
       '',
       'NATURE',
       'F' FROM DUAL
UNION ALL
SELECT 'IEX ',
       '--',
       160,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nm. Item',
       'Nm. Item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IEX ',
       '--',
       170,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IEX ',
       '--',
       200,
       5,
       'TIPLAN',
       'G',
       'DLAN',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DLAN.DESLAN',
       'V',
       '',
       'F',
       '9',
       'F',
       'Motivo Lanamento',
       'Motivo do Lanamento',
       'DLAN.CODTAB = IEX.TIPLAN(+) ',
       'TIPLAN',
       'T' FROM DUAL
UNION ALL
SELECT 'IEX ',
       '--',
       210,
       16,
       'VLRLAN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Lanamento',
       'Valor Lanamento',
       '',
       'VLRLAN',
       'F' FROM DUAL
);

/*-- SEQ 8194 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IFC ',
       TO_NUMBER(null),
       'IFC ',
       'Impostos de Forneced',
       'TT_IFC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8195 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IFC ','--','' FROM DUAL
UNION ALL
SELECT 'IFC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IFC ','99','Outros' FROM DUAL
);

/*-- SEQ 8196 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IFC ',
       '99',
       140,
       12,
       'BASICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Base ICMS',
       'Base ICMS (BaseICMS)',
       '',
       'BASICM',
       '' FROM DUAL
UNION ALL
SELECT 'IFC ',
       '99',
       110,
       12,
       'BASIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Base IPI',
       'Base IPI (BaseIPI)',
       '',
       'BASIPI',
       '' FROM DUAL
UNION ALL
SELECT 'IFC ',
       '99',
       160,
       12,
       'BAS_ST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Base ST',
       'Base ST (BaseST)',
       '',
       'BAS_ST',
       '' FROM DUAL
UNION ALL
SELECT 'IFC ',
       '01',
       30,
       5,
       'CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Divisao',
       'Divisao',
       '',
       'CODCOR',
       '' FROM DUAL
UNION ALL
SELECT 'IFC ',
       '01',
       60,
       6,
       'CODFOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Codigo Fornecedor',
       'Codigo Fornecedor',
       '',
       'CODFOR',
       '' FROM DUAL
UNION ALL
SELECT 'IFC ',
       '01',
       20,
       5,
       'CODMAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Codigo Produto',
       'Codigo Produto',
       '',
       'CODMAT',
       '' FROM DUAL
UNION ALL
SELECT 'IFC ',
       '01',
       40,
       5,
       'CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'SubDivisao',
       'SubDivisao',
       '',
       'CODTAM',
       '' FROM DUAL
UNION ALL
SELECT 'IFC ',
       '99',
       180,
       12,
       'DESRAT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Desc/Acr Nota Rat',
       'Desconto/Acrscimo Rateado',
       '',
       'DESRAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IFC ',
       '01',
       190,
       3,
       'FILCMP',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial da Compra',
       'Filial da Compra',
       'DFIL.CODFIL = IFC.FILCMP',
       'FILCMP',
       'F' FROM DUAL
UNION ALL
SELECT 'IFC ',
       '01',
       50,
       3,
       'FILFOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Filial Fornecedor',
       'Filial Fornecedor',
       '',
       'FILFOR',
       '' FROM DUAL
UNION ALL
SELECT 'IFC ',
       '01',
       10,
       3,
       'FILMAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Filial do Produto',
       'Filial do Produto',
       '',
       'FILMAT',
       '' FROM DUAL
UNION ALL
SELECT 'IFC ',
       '99',
       200,
       12,
       'LUCMVA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Lucro por MVA',
       'Lucro por MVA',
       '',
       'LUCMVA',
       'F' FROM DUAL
UNION ALL
SELECT 'IFC ',
       '99',
       80,
       12,
       'OUTTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Outras Taxas',
       'Outras Taxas (OutrasTaxasRateado)',
       '',
       'OUTTAX',
       '' FROM DUAL
UNION ALL
SELECT 'IFC ',
       '99',
       210,
       5,
       'PERICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Alquota de ICMS ',
       'Alquota de ICMS ',
       '',
       'PERICM',
       'F' FROM DUAL
UNION ALL
SELECT 'IFC ',
       '99',
       220,
       7,
       'REDICM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% Red Base ICMS',
       '% Reduo de Base ICMS',
       '',
       'REDICM',
       'F' FROM DUAL
UNION ALL
SELECT 'IFC ',
       '01',
       70,
       2,
       'UF_ORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'UF da Origem',
       'UF da Origem',
       '',
       'UF_ORI',
       '' FROM DUAL
UNION ALL
SELECT 'IFC ',
       '99',
       90,
       12,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor do Frete',
       'Valor Frete (ValorFreteRateado)',
       '',
       'VLRFRE',
       '' FROM DUAL
UNION ALL
SELECT 'IFC ',
       '99',
       150,
       12,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor ICMS',
       'Valor ICMS (ValorICMS)',
       '',
       'VLRICM',
       '' FROM DUAL
UNION ALL
SELECT 'IFC ',
       '99',
       120,
       12,
       'VLRIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor IPI',
       'Valor IPI (ValorIPI)',
       '',
       'VLRIPI',
       '' FROM DUAL
UNION ALL
SELECT 'IFC ',
       '99',
       130,
       12,
       'VLRIPIFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor IPI Frete',
       'Valor IPI Frete (ValorIPIFrete)',
       '',
       'VLRIPIFRE',
       '' FROM DUAL
UNION ALL
SELECT 'IFC ',
       '99',
       100,
       12,
       'VLRSEG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor do seguro',
       'Valor Seguro (ValorSeguroRateado)',
       '',
       'VLRSEG',
       '' FROM DUAL
UNION ALL
SELECT 'IFC ',
       '99',
       170,
       12,
       'VLR_ST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor ST',
       'Valor ST (ValorST)',
       '',
       'VLR_ST',
       '' FROM DUAL
);

/*-- SEQ 8197 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IFO ',
       TO_NUMBER(null),
       'IFO ',
       'Impostos de Forneced',
       'TT_IFO',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'IFO.CODFIL, IFO.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8198 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IFO ','--','' FROM DUAL
UNION ALL
SELECT 'IFO ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IFO ','99','Outros' FROM DUAL
);

/*-- SEQ 8199 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21588,
       'PRO ',
       'IFO ',
       '1',
       '0N',
       '',
       '',
       'IFO.FILMAT(+) = PRO.FILMAT AND
IFO.CODMAT(+) = PRO.CODMAT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21589,
       'CLI ',
       'IFO ',
       '1',
       '0N',
       '',
       '',
       'IFO.FILFOR(+) = CLI.FILCLI AND
IFO.CODFOR(+) = CLI.CODCLI',
       '',
       '' FROM DUAL
);

/*-- SEQ 8200 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IFO ',
       '01',
       10,
       3,
       'CODFIL',
       'S',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = IFO.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'IFO ',
       '01',
       60,
       6,
       'CODFOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo Fornecedor',
       'Cdigo do Fornecedor',
       '',
       'CODFOR',
       '' FROM DUAL
UNION ALL
SELECT 'IFO ',
       '01',
       40,
       5,
       'CODMAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo do Produto',
       'Cdigo do Produto',
       '',
       'CODMAT',
       '' FROM DUAL
UNION ALL
SELECT 'IFO ',
       '01',
       50,
       3,
       'FILFOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Filial do Fornecedor',
       'Filial do Fornecedor',
       '',
       'FILFOR',
       '' FROM DUAL
UNION ALL
SELECT 'IFO ',
       '01',
       30,
       3,
       'FILMAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Filial do Produto',
       'Filial do Produto',
       '',
       'FILMAT',
       '' FROM DUAL
UNION ALL
SELECT 'IFO ',
       '99',
       150,
       1,
       'FLGRED_ICM_P_ST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Red BC ICMS Prop ST',
       'Reduz Base no Clculo do ICMS prprio para ST',
       '',
       'FLGRED_ICM_P_ST',
       '' FROM DUAL
UNION ALL
SELECT 'IFO ',
       '99',
       80,
       1,
       'FLGSUB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Retm ICMS ST?',
       'Retm ICMS ST?',
       '',
       'FLGSUB',
       '' FROM DUAL
UNION ALL
SELECT 'IFO ',
       '99',
       90,
       1,
       'ICMTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Situao Tributria',
       'Situao Tributria',
       '',
       'ICMTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'IFO ',
       '99',
       170,
       1,
       'ORIPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem do Produto ',
       'Origem do Produto ',
       '',
       'ORIPRO',
       'T' FROM DUAL
UNION ALL
SELECT 'IFO ',
       '99',
       130,
       5,
       'PERICM_FOR_DEST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% ICMS Op. Int. Dest',
       '% ICMS para Operaes Interestaduais no Destino',
       '',
       'PERICM_FOR_DEST',
       '' FROM DUAL
UNION ALL
SELECT 'IFO ',
       '99',
       120,
       5,
       'PERICM_INT_DEST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% ICMS Inter. Desti',
       '% ICMS Interno no Destino',
       '',
       'PERICM_INT_DEST',
       '' FROM DUAL
UNION ALL
SELECT 'IFO ',
       '99',
       110,
       5,
       'PERICM_INT_ORIG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% ICMS Inter. origem',
       '% ICMS Interno na origem',
       '',
       'PERICM_INT_ORIG',
       '' FROM DUAL
UNION ALL
SELECT 'IFO ',
       '99',
       100,
       5,
       'PERIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% de IPI',
       '% de IPI',
       '',
       'PERIPI',
       '' FROM DUAL
UNION ALL
SELECT 'IFO ',
       '99',
       160,
       5,
       'PERMVA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% MVA',
       '% MVA ',
       '',
       'PERMVA',
       '' FROM DUAL
UNION ALL
SELECT 'IFO ',
       '99',
       140,
       5,
       'REDICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Red. ICMS',
       '% Red. ICMS',
       '',
       'REDICM',
       '' FROM DUAL
UNION ALL
SELECT 'IFO ',
       '01',
       20,
       10,
       'SEQUEN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq.',
       'Sequncia',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'IFO ',
       '99',
       70,
       2,
       'UF_ORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'UF da Origem',
       'UF da Origem',
       '',
       'UF_ORI',
       '' FROM DUAL
);

/*-- SEQ 8201 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IFO ',
       'ICMTIP',
       0,
       '0',
       'Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IFO ',
       'ICMTIP',
       0,
       '1',
       'No Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IFO ',
       'ICMTIP',
       0,
       '2',
       'Isento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IFO ',
       'ICMTIP',
       0,
       '3',
       'Substitudo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IFO ',
       'ICMTIP',
       0,
       '4',
       'Isento no estado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IFO ',
       'ORIPRO',
       0,
       '0',
       'Nacional, exceto cd.3,4,5,8',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IFO ',
       'ORIPRO',
       0,
       '1',
       'Estrang., Import.Dir., Exc.6',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IFO ',
       'ORIPRO',
       0,
       '2',
       'Estrang., Adq.Int., Exc.7',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IFO ',
       'ORIPRO',
       0,
       '3',
       'Nacional, Cont.Import.>40%<70%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IFO ',
       'ORIPRO',
       0,
       '4',
       'Nacional, Conf.Proc.Prod.Bs.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IFO ',
       'ORIPRO',
       0,
       '5',
       'Nacional, Cont.Import <= 40%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IFO ',
       'ORIPRO',
       0,
       '6',
       'Estrang., Import.Dir.CAMEX-GNL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IFO ',
       'ORIPRO',
       0,
       '7',
       'Estrang., Adq.Int. CAMEX-GNL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IFO ',
       'ORIPRO',
       0,
       '8',
       'Nacional, Import. > a 70%',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8202 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IICO',
       TO_NUMBER(null),
       'IICO',
       'Importa Itens Compra',
       'TI_ICO',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8203 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IICO','--','' FROM DUAL
UNION ALL
SELECT 'IICO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IICO','99','Outros' FROM DUAL
);

/*-- SEQ 8204 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IICO',
       '--',
       10,
       12,
       'BASICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base Clculo ICMS',
       'Base Clculo ICMS',
       '',
       'BASICM',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       510,
       12,
       'BASIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'BASIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       20,
       20,
       'CODBUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo de Busca',
       'Cdigo de Busca',
       '',
       'CODBUS',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       30,
       6,
       'CODCFO',
       'A',
       'CFOP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'CFOP.DESCFO',
       'A',
       '',
       '',
       'A',
       'F',
       'CFOP',
       'Natureza do item de compra',
       'CFOP.CODTAB(+) = ICO.CODCFO',
       'CODCFO',
       'T' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       520,
       3,
       'CODCST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'CST ICMS',
       'CST ICMS',
       '',
       'CODCST',
       'T' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       40,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       50,
       20,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Fornecedor',
       'Cdigo Fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       60,
       20,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cdigo Produto',
       'Cdigo do produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       70,
       15,
       'CODMOE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Moeda',
       'Cdigo Moeda',
       '',
       'CODMOE',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       80,
       30,
       'CODMUL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub-Estoque',
       'Nome do Sub-Estoque',
       '',
       'CODMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       530,
       1,
       'CODORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       '9',
       'F',
       'Origem do Item',
       'Origem do Item',
       '',
       'CODORI',
       'T' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       90,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       100,
       7,
       'COM_DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao Compra',
       'Data Operao Compra',
       '',
       'COM_DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       110,
       12,
       'CUSANT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Custo Anterior',
       'Custo do produto antes da compra',
       '',
       'CUSANT',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       120,
       12,
       'CUSFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Custo do Frete',
       'Custo do Frete',
       '',
       'CUSFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       130,
       12,
       'CUSREP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Custo Atual',
       'Custo de reposio atual',
       '',
       'CUSREP',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       140,
       7,
       'DATANT',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data do ltimo Custo',
       'Data do custo antes da compra',
       '',
       'DATANT',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       450,
       7,
       'DATCRI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de criao',
       'Data de criao',
       '',
       'DATCRI',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       150,
       7,
       'DATIMP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Importao',
       'Data da Importao',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       160,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       540,
       30,
       'DESCFO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESCFO',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       170,
       5,
       'EMBORI',
       'G',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       '9',
       'F',
       'Embalagem Original',
       'Embalagem Original',
       'ICO.EMBORI = SUB.CODITE(+)',
       'EMBORI',
       'T' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       180,
       12,
       'EMBQTD',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtde Orig. Embagem',
       'Quantidade Original Embalagem',
       '',
       'EMBQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       190,
       12,
       'FREFIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr.Frete Fiscal.',
       'Vlr.Frete Fiscal.',
       '',
       'FREFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       200,
       5,
       'ICMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% ICMS',
       'ICMS por Item',
       '',
       'ICMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       460,
       1,
       'ICMTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de tributao',
       'Tipo de tributao do produto',
       '',
       'ICMTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       210,
       5,
       'IPIITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% de IPI',
       'IPI do item',
       '',
       'IPIITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       220,
       12,
       'ISEICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Iseno ICMS',
       'Iseno ICMS',
       '',
       'ISEICM',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       470,
       5,
       'ITEPED',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Item do Pedido',
       'Cdigo do item de pedido no Totali Commerce (enviado no pedido)',
       '',
       'ITEPED',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       230,
       1,
       'LANEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao no Estoque',
       'Situao de estoque',
       '',
       'LANEST',
       'T' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       550,
       20,
       'LOT_CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'LOT_CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       240,
       255,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo da~Rejeio',
       'Motivo da Rejeio',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       250,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Item',
       'Nmero do item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       260,
       8,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Nota',
       'Nmero Nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       440,
       12,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Pedido',
       'Cdigo do pedido no Totali Commerce (enviado no pedido)',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       270,
       10,
       'ORD_CM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ordem Custo Mdio',
       'Ordem Custo Mdio',
       '',
       'ORD_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       280,
       12,
       'OUTICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Outros ICMS',
       'Outros ICMS',
       '',
       'OUTICM',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       290,
       12,
       'PERLUC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Percentual de Lucro',
       'Percentual de lucro cadastrado no produto',
       '',
       'PERLUC',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       300,
       12,
       'PREANT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Preo Anterior',
       'Preo de venda antes da compra',
       '',
       'PREANT',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       310,
       12,
       'PREATU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Preo Atual de Venda',
       'Preo atual de venda',
       '',
       'PREATU',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       320,
       12,
       'QTDCOM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Quantidade Compra',
       'Quantidade (lanamento de compra)',
       '',
       'QTDCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       330,
       12,
       'QTDMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Quantidade',
       'Quantidade do item',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       340,
       12,
       'QTD_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde Custo Mdio',
       'Quantidade Custo Mdio',
       '',
       'QTD_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       350,
       1,
       'SITMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Situao do item',
       '',
       'SITMOV',
       'T' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       360,
       1,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status da~importao',
       'Status da importao',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       370,
       1,
       'TIPPRO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Produto',
       'Tipo de produto',
       '',
       'TIPPRO',
       'T' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       380,
       2,
       'UNICOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Unidade de Compras',
       'Unidade de Compras',
       '',
       'UNICOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       390,
       2,
       'UNIVEN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Unidade de Vendas',
       'Unidade de Vendas',
       '',
       'UNIVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       400,
       5,
       'VALCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Converso Unidades',
       'Valor de converso entre as unidades de Venda/Compra',
       '',
       'VALCON',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       410,
       12,
       'VLRCAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Diferena',
       'Valor da diferena de preos',
       '',
       'VLRCAL',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       490,
       6,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Desconto do Item',
       'Desconto do Item',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       420,
       12,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor ICMS',
       'Valor ICMS
Valor ICMS',
       '',
       'VLRICM',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       560,
       12,
       'VLRIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VLRIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       500,
       12,
       'VLRITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Total Item',
       'Valor Total do Item',
       '',
       'VLRITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IICO',
       '--',
       430,
       12,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Item',
       'Valor total do item ',
       '',
       'VLRMOV',
       'F' FROM DUAL
);

/*-- SEQ 8205 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IICO',
       'CODCST',
       0,
       ' ',
       'Tri.Simpl.s/Crd.c/Cobr.ICMSST',
       TO_NUMBER(null),
       '202' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODCST',
       0,
       ' ',
       'Isen.Simpl.RecBrtc/Cobr.ICMSST',
       TO_NUMBER(null),
       '203' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODCST',
       0,
       ' ',
       'Imune',
       TO_NUMBER(null),
       '300' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODCST',
       0,
       ' ',
       'No tributada pelo Simples',
       TO_NUMBER(null),
       '400' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODCST',
       0,
       ' ',
       'ICMScobr.ant. p/ST ou p/Antec.',
       TO_NUMBER(null),
       '500' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODCST',
       0,
       ' ',
       'Outros',
       TO_NUMBER(null),
       '900' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODCST',
       0,
       ' ',
       'Tributada integralmente',
       TO_NUMBER(null),
       '00' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODCST',
       0,
       ' ',
       'Tributada com substituio',
       TO_NUMBER(null),
       '10' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODCST',
       0,
       ' ',
       'Com reduo de base de clculo',
       TO_NUMBER(null),
       '20' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODCST',
       0,
       ' ',
       'Isenta/no trib. com subst.',
       TO_NUMBER(null),
       '30' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODCST',
       0,
       ' ',
       'Isenta',
       TO_NUMBER(null),
       '40' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODCST',
       0,
       ' ',
       'No tributada',
       TO_NUMBER(null),
       '41' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODCST',
       0,
       ' ',
       'Suspenso',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODCST',
       0,
       ' ',
       'Diferimento',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODCST',
       0,
       ' ',
       'ICMS cobrado ant. por subst.',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODCST',
       0,
       ' ',
       'Reduo de base por subst.',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODCST',
       0,
       ' ',
       'Outros',
       TO_NUMBER(null),
       '90' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODCST',
       0,
       ' ',
       'Trib. Simples c/permi. Crdito',
       TO_NUMBER(null),
       '101' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODCST',
       0,
       ' ',
       'Trib. Simples s/permi. Crdito',
       TO_NUMBER(null),
       '102' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODCST',
       0,
       ' ',
       'Isen.ICMS Simples ReceitaBruta',
       TO_NUMBER(null),
       '103' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODCST',
       0,
       ' ',
       'Tri.Simpl.c/Crd.c/Cobr.ICMSST',
       TO_NUMBER(null),
       '201' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODORI',
       5,
       ' ',
       'Nacional, Cont.Import <= 40%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODORI',
       6,
       ' ',
       'Estrang., Import.Dir.CAMEX-GNL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODORI',
       7,
       ' ',
       'Estrang., Adq.Int. CAMEX-GNL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODORI',
       8,
       ' ',
       'Nacional, Import. > a 70%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODORI',
       0,
       ' ',
       'Nacional, exceto cd.3,4,5,8',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODORI',
       1,
       ' ',
       'Estrang., Import.Dir., Exc.6',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODORI',
       2,
       ' ',
       'Estrang., Adq.Int., Exc.7',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODORI',
       3,
       ' ',
       'Nacional, Cont.Import.>40%<70%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IICO',
       'CODORI',
       4,
       ' ',
       'Nacional, Conf.Proc.Prod.Bs.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IICO',
       'ICMTIP',
       0,
       '0',
       'Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IICO',
       'ICMTIP',
       0,
       '1',
       'No Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IICO',
       'ICMTIP',
       0,
       '2',
       'Isento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IICO',
       'ICMTIP',
       0,
       '3',
       'Substitudo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IICO',
       'ICMTIP',
       0,
       '4',
       'Isento no Estado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IICO',
       'LANEST',
       0,
       'N',
       'Nao (s Histrico)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IICO',
       'LANEST',
       0,
       'S',
       'Entrada Estoque',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IICO',
       'SITMOV',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IICO',
       'SITMOV',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IICO',
       'TIPPRO',
       0,
       '0',
       'Material',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IICO',
       'TIPPRO',
       1,
       '1',
       'Servio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IICO',
       'TIPPRO',
       2,
       '2',
       'Terceirizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8206 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IIN ',
       TO_NUMBER(null),
       'IIN ',
       'Itens de Inventrio',
       'TV_IIN',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'IIEN.CODFIL,IIN.SEQUEN,IIN.NUMITE',
       '' FROM DUAL
);

/*-- SEQ 8207 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IIN ','--','' FROM DUAL
UNION ALL
SELECT 'IIN ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IIN ','99','Outros' FROM DUAL
);

/*-- SEQ 8208 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 37965,
       'GRA ',
       'IIN ',
       '1',
       '1',
       '',
       '',
       'IIN.FILMAT = GRA.FILMAT AND
IIN.CODMAT = GRA.CODMAT AND
IIN.CODCOR = GRA.CODCOR AND
IIN.CODTAM = GRA.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 37966,
       'INV ',
       'IIN ',
       '1',
       'N',
       '',
       '',
       'INV.CODFIL = IIN.CODFIL AND
INV.SEQUEN = IIN.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 37967,
       'SAL ',
       'IIN ',
       'N',
       'N',
       '',
       '',
       'SAL.CODFIL = IIN.CODFIL AND
SAL.FILMAT = IIN.FILMAT AND
SAL.CODMAT = IIN.CODMAT AND
SAL.CODCOR = IIN.CODCOR AND
SAL.CODTAM = IIN.CODCOR',
       '',
       '' FROM DUAL
);

/*-- SEQ 8209 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IIN ',
       '01',
       6,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Diviso',
       'Diviso do produto',
       'DIV.CODITE (+) = IIN.CODCOR',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'IIN ',
       '01',
       70,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       '' FROM DUAL
UNION ALL
SELECT 'IIN ',
       '01',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = IIN.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'IIN ',
       '01',
       5,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Cdigo interno do produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IIN ',
       '01',
       7,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'SUB.CODITE (+) = IIN.CODTAM',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'IIN ',
       '01',
       9,
       12,
       'CONPRI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Primeira Contagem',
       'Primeira Contagem',
       '',
       'CONPRI',
       'F' FROM DUAL
UNION ALL
SELECT 'IIN ',
       '01',
       12,
       12,
       'CONQUA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Quarta Contagem',
       'Quarta Contagem',
       '',
       'CONQUA',
       'F' FROM DUAL
UNION ALL
SELECT 'IIN ',
       '01',
       10,
       12,
       'CONSEG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Segunda Contagem',
       'Segunda Contagem',
       '',
       'CONSEG',
       'F' FROM DUAL
UNION ALL
SELECT 'IIN ',
       '01',
       11,
       12,
       'CONTER',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Terceira Contagem',
       'Terceira Contagem',
       '',
       'CONTER',
       'F' FROM DUAL
UNION ALL
SELECT 'IIN ',
       '01',
       13,
       12,
       'CONULT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'ltima Contagem',
       'ltima Contagem',
       '',
       'CONULT',
       'F' FROM DUAL
UNION ALL
SELECT 'IIN ',
       '01',
       60,
       18,
       'CUSTO_UNI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'C.M. Unit.',
       'Custo Mdio Unitrio',
       '',
       'CUSTO_UNI',
       'F' FROM DUAL
UNION ALL
SELECT 'IIN ',
       '01',
       15,
       12,
       'DIFERE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Diferena',
       'Diferena',
       '',
       'IIN.ULTIMA - COALESCE(IIN.QTDEST,0)',
       '' FROM DUAL
UNION ALL
SELECT 'IIN ',
       '01',
       4,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IIN ',
       '01',
       3,
       5,
       'NUMITE',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nmero de Itens',
       'Nmero de Itens',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IIN ',
       '01',
       8,
       12,
       'QTDEST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde Estoque',
       'Quantidade de Estoque',
       '',
       'QTDEST',
       'F' FROM DUAL
UNION ALL
SELECT 'IIN ',
       '01',
       14,
       12,
       'QTDEST_CON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde Convertida',
       'Quantidade Convertida',
       '',
       'QTDCONVERTIDA(IIN.CODTAM,IIN.QTDEST)',
       'F' FROM DUAL
UNION ALL
SELECT 'IIN ',
       '01',
       61,
       18,
       'QTD_EM_NF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Qtd. em~N.F. e C.F.',
       'Quantidade em Notas Fiscais e Cupons Fiscais',
       '',
       'QTD_EM_NF',
       'F' FROM DUAL
UNION ALL
SELECT 'IIN ',
       '01',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'INVENTRIO',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IIN ',
       '01',
       16,
       12,
       'ULTIMA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'ltimo Valor Contado',
       'ltimo Valor Contado',
       '',
       'COALESCE(COALESCE(COALESCE(COALESCE(COALESCE(IIN.CONULT,IIN.CONQUA),IIN.CONTER),IIN.CONSEG),IIN.CONPRI),0)',
       '' FROM DUAL
);

/*-- SEQ 8210 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IITF',
       TO_NUMBER(null),
       'IITF',
       'Reg. Imp. de Cartes',
       'TI_ITF',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8211 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IITF','--','' FROM DUAL
UNION ALL
SELECT 'IITF','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IITF','99','Outros' FROM DUAL
);

/*-- SEQ 8212 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22311,
       'CTF ',
       'IITF',
       '0N',
       '1',
       '',
       '',
       'IITF.ID_CTF(+) = CTF.ID_CTF',
       '',
       '' FROM DUAL
);

/*-- SEQ 8213 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IITF',
       '--',
       10,
       7,
       'DATIMP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Importao',
       'Data da Importao',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'IITF',
       '--',
       20,
       7,
       'DATPRO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Processamento',
       'Data do Processamento',
       '',
       'DATPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'IITF',
       '--',
       30,
       7,
       'DATVEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data da Venda',
       'Data da Venda',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IITF',
       '--',
       40,
       3,
       'FILTEF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial da Parcela',
       'Filial da Parcela',
       '',
       'FILTEF',
       'F' FROM DUAL
UNION ALL
SELECT 'IITF',
       '--',
       190,
       14,
       'ID_CTF',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo Conciliao',
       'Cdigo da Conciliao',
       '',
       'ID_CTF',
       '' FROM DUAL
UNION ALL
SELECT 'IITF',
       '--',
       50,
       32,
       'MD5CAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Carto Criptografado',
       'Carto Criptografado',
       '',
       'MD5CAR',
       'F' FROM DUAL
UNION ALL
SELECT 'IITF',
       '--',
       60,
       30,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo da Rejeio',
       'Motivo da Rejeio',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'IITF',
       '--',
       70,
       2,
       'NROPAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero da Parcela',
       'Nmero da Parcela',
       '',
       'NROPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'IITF',
       '--',
       80,
       10,
       'NRO_RO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Ident. da Operao',
       'Identificador da Operao',
       '',
       'NRO_RO',
       'F' FROM DUAL
UNION ALL
SELECT 'IITF',
       '--',
       90,
       18,
       'NSUTRN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ident. do Movimento',
       'Identificador do Movimento',
       '',
       'NSUTRN',
       'F' FROM DUAL
UNION ALL
SELECT 'IITF',
       '--',
       180,
       20,
       'NUMAUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Autorizao',
       'Autorizao',
       '',
       'NUMAUT',
       '' FROM DUAL
UNION ALL
SELECT 'IITF',
       '--',
       100,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Item da Parcela',
       'Item da Parcela',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IITF',
       '--',
       110,
       255,
       'OBSSTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao do Status',
       'Observao do Status',
       '',
       'OBSSTA',
       'F' FROM DUAL
UNION ALL
SELECT 'IITF',
       '--',
       120,
       1,
       'OPERAD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Bandeira do Carto',
       'Bandeira do Carto',
       '',
       'OPERAD',
       'F' FROM DUAL
UNION ALL
SELECT 'IITF',
       '--',
       130,
       10,
       'SEQARQ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. do Arquivo',
       'Seq. do Arquivo',
       '',
       'SEQARQ',
       'F' FROM DUAL
UNION ALL
SELECT 'IITF',
       '--',
       140,
       10,
       'SEQTEF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. da Parcela',
       'Seq. da Parcela',
       '',
       'SEQTEF',
       'F' FROM DUAL
UNION ALL
SELECT 'IITF',
       '--',
       150,
       1,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Status Conciliao',
       'Status da Conciliao',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'IITF',
       '--',
       160,
       2,
       'TOTPAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Qtd. de Parcelas',
       'Quantidade de Parcelas',
       '',
       'TOTPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'IITF',
       '--',
       170,
       14,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor da Parcela',
       'Valor da Parcela',
       '',
       'VLRPAR',
       'F' FROM DUAL
);

/*-- SEQ 8214 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IITF',
       'OPERAD',
       0,
       'A',
       'AMEX',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IITF',
       'OPERAD',
       0,
       'C',
       'REDECARD - Crdito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IITF',
       'OPERAD',
       0,
       'D',
       'REDECARD - Dbito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IITF',
       'OPERAD',
       0,
       'V',
       'VISA',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8215 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IITR',
       TO_NUMBER(null),
       'IITR',
       'Res. Imp. de Cartes',
       'TI_ITF_RO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8216 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IITR','--','' FROM DUAL
UNION ALL
SELECT 'IITR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IITR','99','Outros' FROM DUAL
);

/*-- SEQ 8217 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IITR',
       '--',
       10,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Banco',
       'Banco',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'IITR',
       '--',
       20,
       14,
       'CTACRR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Conta-Corrente',
       'Conta-Corrente',
       '',
       'CTACRR',
       'F' FROM DUAL
UNION ALL
SELECT 'IITR',
       '--',
       30,
       7,
       'DATCAP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Captura Venda',
       'Data da Captura da Venda',
       '',
       'DATCAP',
       'F' FROM DUAL
UNION ALL
SELECT 'IITR',
       '--',
       40,
       7,
       'DATDEP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data do Depsito',
       'Data do Depsito',
       '',
       'DATDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'IITR',
       '--',
       50,
       7,
       'DATENV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data do Envio Arq.',
       'Data do Envio do Arquivo',
       '',
       'DATENV',
       'F' FROM DUAL
UNION ALL
SELECT 'IITR',
       '--',
       60,
       7,
       'DATPRE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Prevista Dep.',
       'Data Prevista para Depsito',
       '',
       'DATPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'IITR',
       '--',
       70,
       10,
       'NRO_RO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Ident. da Operao',
       'Identificador da Operao',
       '',
       'NRO_RO',
       'F' FROM DUAL
UNION ALL
SELECT 'IITR',
       '--',
       80,
       5,
       'NUMAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Agncia',
       'Agncia',
       '',
       'NUMAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'IITR',
       '--',
       90,
       1,
       'OPCEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Operao do Arquivo',
       'Operao do Arquivo',
       '',
       'OPCEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'IITR',
       '--',
       100,
       1,
       'TIPPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo do Processo',
       'Tipo do Processo',
       '',
       'TIPPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'IITR',
       '--',
       110,
       14,
       'VLRBRU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Bruto',
       'Valor Bruto',
       '',
       'VLRBRU',
       'F' FROM DUAL
UNION ALL
SELECT 'IITR',
       '--',
       120,
       14,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Lquido',
       'Valor Lquido',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'IITR',
       '--',
       130,
       14,
       'VLRREJ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Rejeitado',
       'Valor Rejeitado',
       '',
       'VLRREJ',
       'F' FROM DUAL
);

/*-- SEQ 8218 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IITR',
       'OPCEXT',
       0,
       ' ',
       'No Conciliar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IITR',
       'OPCEXT',
       0,
       'D',
       'Conciliar',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8219 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IIVE',
       TO_NUMBER(null),
       'IIVE',
       'TI_IVE',
       'TI_IVE',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8220 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IIVE','--','' FROM DUAL
UNION ALL
SELECT 'IIVE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IIVE','99','Outros' FROM DUAL
);

/*-- SEQ 8221 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IIVE',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Cdigo da Filial de emisso da nota fiscal',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       20,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo~Produto',
       'Cdigo do Produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       30,
       5,
       'CODMUL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub-Estoque',
       'Nome do Sub-Estoque',
       '',
       'CODMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       40,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Srie da Nota Fiscal',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       50,
       3,
       'CODVDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Vendedor',
       'Cdigo Vendedor',
       '',
       'CODVDD',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       60,
       9,
       'COMISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Comisso',
       'Comisso',
       '',
       'COMISS',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       70,
       7,
       'DATIMP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da~importao',
       'Data da importao',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       80,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Incluso',
       'Data~Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       90,
       5,
       'EMBORI',
       'G',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       '9',
       'F',
       'Embalagem Original',
       'Embalagem Original',
       'IVE.EMBORI=SUB.CODITE(+)',
       'EMBORI',
       'T' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       100,
       12,
       'EMBQTD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Quantidade Original',
       'Quantidade Original',
       '',
       'EMBQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       110,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exportar?',
       'Exportar',
       '',
       'EXPORT',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       120,
       3,
       'FILBIC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Bico Comb.',
       '',
       'FILBIC',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       130,
       3,
       'FILORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial de Origem',
       '',
       'FILORI',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       140,
       3,
       'FILVDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial~Vendedor',
       'Filial Vendedor',
       '',
       'FILVDD',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       150,
       1,
       'ICMTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       '9',
       'F',
       'Tipo Tributao',
       'Tipo de tributao do produto',
       '',
       'ICMTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       160,
       2,
       'ITEORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Item de Origem',
       'Item de Origem',
       '',
       'ITEORI',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       170,
       1,
       'LANEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Lanamento~Estoque',
       'Lanamento em Estoque',
       '',
       'LANEST',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       180,
       255,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo da~Rejeio',
       'Motivo da Rejeio',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       190,
       6,
       'NATFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Natureza Fiscal',
       'Natureza Fiscal',
       '',
       'NATFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       200,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'ECF',
       'Cdigo do ECF',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       210,
       40,
       'NUMEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Nm. Externo',
       'Nmero externo',
       '',
       'NUMEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       220,
       2,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Item',
       'Nmero do Item na Nota Fiscal',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       230,
       6,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero~Nota Fiscal',
       'Nmero da Nota Fiscal',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       240,
       10,
       'NUMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Nmero~Origem',
       'Nmero da Origem',
       '',
       'NUMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       250,
       10,
       'ORD_CM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Orden. Custo Mdio',
       'Ordenao Custo Mdio',
       '',
       'ORD_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       260,
       5,
       'PERICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% ICMS',
       '% ICMS',
       '',
       'PERICM',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       270,
       5,
       'PERIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% IPI',
       '% IPI',
       '',
       'PERIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       280,
       12,
       'QTDMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Quantidade',
       'Quantidade',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       290,
       12,
       'QTD_CM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde Custo Medio',
       'Quantidade Custo Mdio',
       '',
       'QTD_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       300,
       7,
       'REDITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base reduzida ICMS',
       'Base reduzida de ICMS do item',
       '',
       'REDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       310,
       2,
       'SEQFIL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '',
       'Nmero sequencial do bico na filial',
       '',
       'SEQFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       320,
       1,
       'SITKIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Kit',
       'Situao de Kit',
       '',
       'SITKIT',
       'T' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       330,
       1,
       'SITMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Normal ou Cancelado',
       '',
       'SITMOV',
       'T' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       460,
       5,
       'SITTRI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao Tributria',
       'Situao Tributria',
       '',
       'SITTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       340,
       1,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status da~importao',
       'Status da importao',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       350,
       5,
       'TAXIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Taxa IRR',
       'Taxa IRR',
       '',
       'TAXIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       360,
       5,
       'TAXISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Taxa ISS',
       'Taxa ISS',
       '',
       'TAXISS',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       370,
       1,
       'TIP001',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tributado',
       'Tributado',
       '',
       'TIP001',
       'T' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       380,
       1,
       'TIPPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Produto',
       'Tipo Produto',
       '',
       'TIPPRO',
       'T' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       390,
       7,
       'VEN_DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Emisso NF',
       'Data de emisso da Nota Fiscal',
       '',
       'VEN_DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       400,
       1,
       'VINCUL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Vnculo',
       'Vnculo',
       '',
       'VINCUL',
       'T' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       420,
       12,
       'VLRIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor IPI',
       'Valor IPI',
       '',
       'VLRIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       430,
       12,
       'VLRIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor IRR',
       'Valor IRR',
       '',
       'VLRIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       440,
       12,
       'VLRISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor ISS',
       'Valor ISS',
       '',
       'VLRISS',
       'F' FROM DUAL
UNION ALL
SELECT 'IIVE',
       '--',
       450,
       12,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor~dos Itens',
       'Valor Total dos Itens',
       '',
       'VLRMOV',
       'F' FROM DUAL
);

/*-- SEQ 8222 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IIVE',
       'ICMTIP',
       0,
       '0',
       'Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IIVE',
       'ICMTIP',
       0,
       '1',
       'No tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IIVE',
       'ICMTIP',
       0,
       '2',
       'Isento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IIVE',
       'ICMTIP',
       0,
       '3',
       'Substitudo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IIVE',
       'ICMTIP',
       0,
       '4',
       'Isento no estado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IIVE',
       'LANEST',
       0,
       'C',
       'Confirma reserva',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IIVE',
       'LANEST',
       0,
       'N',
       'No (s Histrico)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IIVE',
       'LANEST',
       0,
       'R',
       'Reserva',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IIVE',
       'LANEST',
       0,
       'S',
       'Baixa de Estoque',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IIVE',
       'SITKIT',
       0,
       '1',
       'Header',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IIVE',
       'SITKIT',
       0,
       '2',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IIVE',
       'SITKIT',
       0,
       '3',
       'Item Kit',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IIVE',
       'SITMOV',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IIVE',
       'SITMOV',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IIVE',
       'TIP001',
       0,
       'M',
       'Material',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IIVE',
       'TIP001',
       0,
       'S',
       'Servios',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IIVE',
       'TIPPRO',
       0,
       '0',
       'Material',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IIVE',
       'TIPPRO',
       1,
       '1',
       'Servio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IIVE',
       'VINCUL',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IIVE',
       'VINCUL',
       0,
       'C',
       'Completo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IIVE',
       'VINCUL',
       0,
       'N',
       'No  vnculo',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8223 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IKIT',
       TO_NUMBER(null),
       'IKIT',
       'Importao de Kits',
       'TI_KIT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8224 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IKIT','--','' FROM DUAL
UNION ALL
SELECT 'IKIT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IKIT','99','Outros' FROM DUAL
);

/*-- SEQ 8225 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IKIT',
       '01',
       90,
       1,
       'BRINDE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Brinde?',
       'Brinde?',
       '',
       'BRINDE',
       '' FROM DUAL
UNION ALL
SELECT 'IKIT',
       '01',
       70,
       20,
       'CODITE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Item do Kit',
       'Item do Kit',
       '',
       'CODITE',
       '' FROM DUAL
UNION ALL
SELECT 'IKIT',
       '01',
       60,
       20,
       'CODPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd. Sistema Origem',
       'Cdigo Sistema Origem',
       '',
       'CODPRO',
       '' FROM DUAL
UNION ALL
SELECT 'IKIT',
       '01',
       10,
       8,
       'DATCRI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data de Criao',
       'Data de Criao',
       '',
       'DATCRI',
       '' FROM DUAL
UNION ALL
SELECT 'IKIT',
       '01',
       20,
       8,
       'DATIMP',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data de Importao',
       'Data de Importao',
       '',
       'DATIMP',
       '' FROM DUAL
UNION ALL
SELECT 'IKIT',
       '01',
       100,
       1,
       'FLGIMP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Imprime Obs. NF',
       'Imprime Observao da Nota Fiscal?',
       '',
       'FLGIMP',
       '' FROM DUAL
UNION ALL
SELECT 'IKIT',
       '01',
       30,
       255,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Motivo de Rejeio',
       'Motivo de Rejeio',
       '',
       'MOTREJ',
       '' FROM DUAL
UNION ALL
SELECT 'IKIT',
       '01',
       80,
       12,
       'QTDITE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'T',
       'N',
       '',
       'Quantidade Item Kit',
       'Quantidade Item Kit',
       '',
       'QTDITE',
       '' FROM DUAL
UNION ALL
SELECT 'IKIT',
       '01',
       40,
       1,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Status da Importao',
       'Status da Importao',
       '',
       'STATUS',
       'T' FROM DUAL
UNION ALL
SELECT 'IKIT',
       '01',
       50,
       1,
       'TIPOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo de Operao',
       'Tipo de Operao',
       '',
       'TIPOPE',
       'T' FROM DUAL
);

/*-- SEQ 8226 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IKIT',
       'STATUS',
       0,
       ' ',
       'Aguardando',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IKIT',
       'STATUS',
       1,
       ' ',
       'Importado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IKIT',
       'STATUS',
       2,
       ' ',
       'Erro de Importao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IKIT',
       'TIPOPE',
       0,
       'A',
       'Alterao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IKIT',
       'TIPOPE',
       0,
       'E',
       'Excluso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IKIT',
       'TIPOPE',
       0,
       'I',
       'Incluso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IKIT',
       'TIPOPE',
       0,
       'T',
       'Alterao/Incluso',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8227 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ILAN',
       TO_NUMBER(null),
       'ILAN',
       'Importa Lanamentos',
       'TI_LAN',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8228 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ILAN','--','' FROM DUAL
UNION ALL
SELECT 'ILAN','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ILAN','99','Outros' FROM DUAL
);

/*-- SEQ 8229 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ILAN',
       '--',
       10,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Original',
       'Cdigo do produto no sistema original',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'ILAN',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ILAN',
       '--',
       30,
       7,
       'DATIMP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Importao',
       'Data da Importao',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'ILAN',
       '--',
       40,
       7,
       'DATMOV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Movto',
       'Data Movto',
       '',
       'DATMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'ILAN',
       '--',
       50,
       30,
       'DESEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Estoque',
       'Descrio de qual estoque refere-se o saldo',
       '',
       'DESEST',
       'F' FROM DUAL
UNION ALL
SELECT 'ILAN',
       '--',
       60,
       17,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'ILAN',
       '--',
       70,
       255,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo da~Rejeio',
       'Motivo da Rejeio',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'ILAN',
       '--',
       80,
       20,
       'NUMEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Num. Externo',
       'Num. Externo',
       '',
       'NUMEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'ILAN',
       '--',
       90,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'ILAN',
       '--',
       100,
       12,
       'QTDMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Qtde',
       'Quantidade Movimentao',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'ILAN',
       '--',
       110,
       1,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status da~importao',
       'Status da importao',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'ILAN',
       '--',
       120,
       5,
       'TIPLAN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Motivo Lanamento',
       'Motivo Lanamento',
       '',
       'TIPLAN',
       'F' FROM DUAL
UNION ALL
SELECT 'ILAN',
       '--',
       130,
       1,
       'TIPMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo',
       '',
       'TIPMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'ILAN',
       '--',
       140,
       14,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor',
       '',
       'VLRMOV',
       'F' FROM DUAL
);

/*-- SEQ 8230 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ILAN',
       'TIPMOV',
       0,
       'A',
       'Ajuste',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ILAN',
       'TIPMOV',
       0,
       'I',
       'Inicial',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8231 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ILI ',
       TO_NUMBER(null),
       'ILI ',
       'Itens List.Presentes',
       'TT_ILI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'ILI.CODFIL, ILI.SEQUEN, ILI.NUMITE',
       '' FROM DUAL
);

/*-- SEQ 8232 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ILI ','--','' FROM DUAL
UNION ALL
SELECT 'ILI ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ILI ','99','Outros' FROM DUAL
);

/*-- SEQ 8233 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 28948,
       'GRA ',
       'ILI ',
       '1',
       'N',
       '',
       '',
       'GRA.FILMAT = ILI.FILMAT and
GRA.CODMAT = ILI.CODMAT and
GRA.CODCOR = ILI.CODCOR and
GRA.CODTAM = ILI.CODTAM
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 28949,
       'LIS ',
       'ILI ',
       '1',
       'N',
       '',
       '',
       'LIS.CODFIL = ILI.CODFIL and
LIS.SEQUEN = ILI.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 8234 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ILI ',
       '01',
       10,
       5,
       'CODCOR',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Diviso',
       'Diviso',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'ILI ',
       '01',
       20,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'ILI ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL (+) = ILI.CODFIL',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'ILI ',
       '01',
       40,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Produto',
       'Cdigo Produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ILI ',
       '01',
       50,
       5,
       'CODTAM',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Subdiviso',
       'Subdiviso',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'ILI ',
       '01',
       60,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Filial Produto',
       'Filial Produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ILI ',
       '01',
       70,
       5,
       'NUMITE',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Item',
       'Item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'ILI ',
       '99',
       80,
       12,
       'QTDITE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Quantidade do Produt',
       'Quantidade do Produto',
       '',
       'QTDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'ILI ',
       '99',
       90,
       12,
       'QTDRES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Quantidade Reservada',
       'Quantidade Reservada pelo E-commerce',
       '',
       'QTDRES',
       'F' FROM DUAL
UNION ALL
SELECT 'ILI ',
       '01',
       100,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'ILI ',
       '99',
       110,
       1,
       'SITMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'SITMOV',
       'T' FROM DUAL
);

/*-- SEQ 8235 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ILI ',
       'SITMOV',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ILI ',
       'SITMOV',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8236 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ILIM',
       TO_NUMBER(null),
       'ILIM',
       'Importa Limites CC',
       'TI_LIM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8237 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ILIM','--','' FROM DUAL
UNION ALL
SELECT 'ILIM','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ILIM','02','Dados' FROM DUAL
UNION ALL
SELECT 'ILIM','03','Controle' FROM DUAL
UNION ALL
SELECT 'ILIM','99','Outros' FROM DUAL
);

/*-- SEQ 8238 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ILIM',
       '02',
       10,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd.Cliente~Original',
       'Cdigo do Cliente no sistema original',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'ILIM',
       '03',
       20,
       7,
       'DATIMP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da~importao',
       'Data da importao',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'ILIM',
       '02',
       30,
       12,
       'LIMCCC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Limite C/C',
       'Limite C/C',
       '',
       'LIMCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'ILIM',
       '03',
       40,
       255,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo da~Rejeio',
       'Motivo da Rejeio',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'ILIM',
       '02',
       50,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'ILIM',
       '03',
       60,
       1,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status da~importao',
       'Status da importao',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'ILIM',
       '02',
       70,
       30,
       'TIPCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo C/C',
       'Tipo C/C',
       '',
       'TIPCCC',
       'F' FROM DUAL
);

/*-- SEQ 8239 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ILMC',
       TO_NUMBER(null),
       'ILMC',
       'Livro Mov. Combust.',
       'TT_ILM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'ILMC.CODFIL,ILMC.SEQUEN,ILMC.DATEMI',
       '' FROM DUAL
);

/*-- SEQ 8240 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ILMC','--','' FROM DUAL
UNION ALL
SELECT 'ILMC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ILMC','99','Outros' FROM DUAL
);

/*-- SEQ 8241 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5672,
       'LMC ',
       'ILMC',
       '1 ',
       'N ',
       '',
       '',
       'LMC.CODFIL = ILMC.CODFIL AND
LMC.SEQUEN = ILMC.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8242 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ILMC',
       '--',
       10,
       3,
       'CODEMI',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio que emitiu',
       'Usurio que emitiu',
       'ILMC.FILEMI = USU.FILUSU(+)  AND ILMC.CODEMI = USU.CODUSU(+)',
       'CODEMI',
       'T' FROM DUAL
UNION ALL
SELECT 'ILMC',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = ILMC.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ILMC',
       '--',
       30,
       7,
       'DATEMI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Emisso',
       'Data Emisso',
       '',
       'DATEMI',
       'F' FROM DUAL
UNION ALL
SELECT 'ILMC',
       '--',
       40,
       3,
       'FILEMI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Usurio',
       'Filial Usurio',
       '',
       'FILEMI',
       'F' FROM DUAL
UNION ALL
SELECT 'ILMC',
       '--',
       50,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'ILMC',
       '--',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8243 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IMOV',
       TO_NUMBER(null),
       'IMOV',
       'Importa Mov.Estoques',
       'TI_MOV',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8244 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IMOV','--','' FROM DUAL
UNION ALL
SELECT 'IMOV','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IMOV','02','Dados' FROM DUAL
UNION ALL
SELECT 'IMOV','03','Controle' FROM DUAL
UNION ALL
SELECT 'IMOV','99','Outros' FROM DUAL
);

/*-- SEQ 8245 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IMOV',
       '02',
       10,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd.Produto~Original',
       'Cdigo do produto no sistema original',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'IMOV',
       '02',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = IMOV.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'IMOV',
       '03',
       30,
       7,
       'DATIMP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da~importao',
       'Data da importao',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'IMOV',
       '02',
       40,
       7,
       'DATMOV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Movimentao',
       'Data Movimentao',
       '',
       'DATMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'IMOV',
       '02',
       50,
       30,
       'DESEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Desc. Estoque~Saldo',
       'Descrio de qual estoque refere-se o saldo.',
       '',
       'DESEST',
       'F' FROM DUAL
UNION ALL
SELECT 'IMOV',
       '02',
       60,
       17,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'IMOV',
       '03',
       70,
       255,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo da~Rejeio',
       'Motivo da Rejeio',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'IMOV',
       '02',
       80,
       20,
       'NUMEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Num. Externo',
       'Num. Externo',
       '',
       'NUMEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'IMOV',
       '02',
       90,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'IMOV',
       '02',
       100,
       12,
       'QTDMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Quantidade',
       'Quantidade',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'IMOV',
       '03',
       110,
       1,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status da~importao',
       'Status da importao',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'IMOV',
       '02',
       120,
       5,
       'TIPLAN',
       'S',
       'DLAN',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DLAN.DESLAN',
       'V',
       '',
       '',
       '9',
       'F',
       'Motivo~Lanamento',
       'Motivo Lanamento',
       'DLAN.CODTAB = IMOV.TIPLAN',
       'TIPLAN',
       'F' FROM DUAL
UNION ALL
SELECT 'IMOV',
       '02',
       130,
       1,
       'TIPMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo',
       '',
       'TIPMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'IMOV',
       '02',
       140,
       14,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor',
       '',
       'VLRMOV',
       'F' FROM DUAL
);

/*-- SEQ 8246 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IMOV',
       'TIPMOV',
       0,
       'A',
       'Ajuste',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMOV',
       'TIPMOV',
       0,
       'I',
       'Inicial',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8247 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IMP ',
       TO_NUMBER(null),
       'IMP ',
       'BI_Impressoras',
       'TT_IMP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'IMP.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 8248 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IMP ','--','' FROM DUAL
UNION ALL
SELECT 'IMP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IMP ','99','Outros' FROM DUAL
);

/*-- SEQ 8249 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IMP ',
       '--',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'IMP ',
       '--',
       20,
       255,
       'PATH',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Caminho Impressora',
       'Caminho para Impressora',
       '',
       'PATH',
       'F' FROM DUAL
);

/*-- SEQ 8250 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IMU ',
       TO_NUMBER(null),
       'IMU ',
       'Impostos Municipais',
       'TT_IMU',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'IMU.FILMAT,IMU.CODMAT,IMU.CODCID',
       '' FROM DUAL
);

/*-- SEQ 8251 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IMU ','--','' FROM DUAL
UNION ALL
SELECT 'IMU ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IMU ','02','NFSe' FROM DUAL
UNION ALL
SELECT 'IMU ','99','Outros' FROM DUAL
);

/*-- SEQ 8252 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 25074,
       'PRO ',
       'IMU ',
       '0N',
       '1',
       '',
       '',
       'PRO.FILMAT(+) = IMU.FILMAT AND
PRO.CODMAT(+) = IMU.CODMAT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 25075,
       'MUN ',
       'IMU ',
       '1',
       'N',
       '',
       '',
       'MUN.CODIGO = IMU.CODCID',
       '',
       '' FROM DUAL
);

/*-- SEQ 8253 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IMU ',
       '--',
       70,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       'Assinatura para PAF-ECF',
       '',
       'ASSINA',
       '' FROM DUAL
UNION ALL
SELECT 'IMU ',
       '--',
       90,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       '',
       '',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'IMU ',
       '01',
       10,
       5,
       'CODCID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo da Cidade',
       'Codigo da Cidade',
       '',
       'CODCID',
       'F' FROM DUAL
UNION ALL
SELECT 'IMU ',
       '--',
       100,
       10,
       'CODIBG',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '#Cd. IBGE Municpio',
       'Cdigo IBGE do Municpio (descontinuado)',
       '',
       'CODIBG',
       'F' FROM DUAL
UNION ALL
SELECT 'IMU ',
       '01',
       20,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Codigo do Produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IMU ',
       '02',
       150,
       10,
       'CODSRV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo do Servio',
       'Cdigo do Servio no Municpio',
       '',
       'CODSRV',
       '' FROM DUAL
UNION ALL
SELECT 'IMU ',
       '--',
       80,
       0,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       'Cdigo da Tabela de Acesso',
       '',
       'CODUID',
       '' FROM DUAL
UNION ALL
SELECT 'IMU ',
       '02',
       110,
       1000,
       'DESRPS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Dados Compl. RPS',
       'Dados Complementares do RPS',
       '',
       'DESRPS',
       'F' FROM DUAL
UNION ALL
SELECT 'IMU ',
       '02',
       160,
       4000,
       'DESSRV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio do Servio',
       'Descrio do Servio no Municpio',
       '',
       'DESSRV',
       '' FROM DUAL
UNION ALL
SELECT 'IMU ',
       '02',
       120,
       1,
       'EXIISS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Exigib. de ISS NFSe',
       'Exigibilidade ISS para NFSe',
       '',
       'EXIISS',
       'T' FROM DUAL
UNION ALL
SELECT 'IMU ',
       '01',
       30,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IMU ',
       '02',
       130,
       3,
       'NATNFS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Natureza de NFSe',
       'Natureza ou Operao da NFSe',
       '',
       'NATNFS',
       'T' FROM DUAL
UNION ALL
SELECT 'IMU ',
       '01',
       40,
       5,
       'RESISS',
       'S',
       'DISS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TO_CHAR(DISS.RESISS)',
       'V',
       '',
       '',
       'N',
       'F',
       'ISS Produto',
       'Aliquota ISS',
       'DISS.CODTAB = IMU.RESISS',
       'RESISS',
       'F' FROM DUAL
UNION ALL
SELECT 'IMU ',
       '02',
       60,
       1,
       'SITTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Cd Tributao ISSQN',
       'Cdigo de Tributao do ISSQN',
       '',
       'SITTRI',
       'T' FROM DUAL
UNION ALL
SELECT 'IMU ',
       '02',
       140,
       2,
       'TRINFS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Tipo de Tributao',
       'Tipo de Tributao',
       '',
       'TRINFS',
       'T' FROM DUAL
);

/*-- SEQ 8254 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IMU ',
       'EXIISS',
       0,
       ' ',
       'Exigvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'EXIISS',
       1,
       ' ',
       'No Incidncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'EXIISS',
       2,
       ' ',
       'Iseno',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'EXIISS',
       3,
       ' ',
       'Exportao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'EXIISS',
       4,
       ' ',
       'Imunidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'EXIISS',
       5,
       ' ',
       'Suspensa por Deciso Judicial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'EXIISS',
       6,
       ' ',
       'Suspensa por Processo Administ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'EXIISS',
       7,
       ' ',
       'ISS Fixo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'NATNFS',
       0,
       ' ',
       'Sem Deduo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'NATNFS',
       1,
       ' ',
       'Com Deduo Materiais',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'NATNFS',
       2,
       ' ',
       'Imune/Isenta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'NATNFS',
       3,
       ' ',
       'Devoluo de Simples Remessa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'NATNFS',
       4,
       ' ',
       'Intermediao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'SITTRI',
       0,
       'I',
       'ISENTA',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'SITTRI',
       0,
       'N',
       'NORMAL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'SITTRI',
       0,
       'R',
       'RETIDA',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'SITTRI',
       0,
       'S',
       'SUBSTITUTA',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'TRINFS',
       0,
       ' ',
       'Isenta ISS',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'TRINFS',
       1,
       ' ',
       'No Incidncia no Municpio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'TRINFS',
       2,
       ' ',
       'Imune',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'TRINFS',
       3,
       ' ',
       'Exigibilidade Suspensa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'TRINFS',
       4,
       ' ',
       'No Tributvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'TRINFS',
       5,
       ' ',
       'Tributvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'TRINFS',
       6,
       ' ',
       'Tributvel Fixo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'TRINFS',
       7,
       ' ',
       'Tributvel SN',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IMU ',
       'TRINFS',
       8,
       ' ',
       'MEI',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8255 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'INB ',
       TO_NUMBER(null),
       'INB ',
       'Insumos Baixados',
       'TT_INB',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'INB.CODFIL, INB.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8256 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'INB ','--','' FROM DUAL
UNION ALL
SELECT 'INB ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'INB ','99','Outros' FROM DUAL
);

/*-- SEQ 8257 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22128,
       'RPP ',
       'INB ',
       '1',
       'N',
       '',
       '',
       'RPP.CODFIL = INB.FILRPP AND
RPP.CODRPP = INB.CODRPP',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22129,
       'GRA ',
       'INB ',
       '1',
       '0N',
       '',
       '',
       'GRA.FILMAT = INB.FILMAT AND
GRA.CODMAT = INB.CODMAT AND
GRA.CODCOR = INB.CODCOR AND
GRA.CODTAM = INB.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 8258 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'INB ',
       '99',
       10,
       5,
       'CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Div Produto Insumo',
       'Diviso Produto Insumo',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'INB ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = INB.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'INB ',
       '99',
       30,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '9',
       'F',
       'Cod Produto Insumo',
       'Cdigo Produto Insumo',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'INB ',
       '99',
       40,
       10,
       'CODRPP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '9',
       'F',
       'Cod Receita Produzid',
       'Cdigo Receita Produzida',
       '',
       'CODRPP',
       'F' FROM DUAL
UNION ALL
SELECT 'INB ',
       '99',
       50,
       5,
       'CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Subdiv Prod Insumo',
       'Subdiviso Produto Insumo',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'INB ',
       '99',
       60,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       'F',
       'Fil Produto Insumo',
       'Filial Produto Insumo',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'INB ',
       '99',
       70,
       3,
       'FILRPP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '0',
       'F',
       'Fil Receita Produzid',
       'Filial Receita Produzida',
       '',
       'FILRPP',
       'F' FROM DUAL
UNION ALL
SELECT 'INB ',
       '01',
       80,
       12,
       'QTDMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'T',
       'A',
       'F',
       'Quantidade Insumo',
       'Quantidade Insumo',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'INB ',
       '01',
       90,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8259 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IND ',
       0,
       'IND ',
       'Indicador',
       'TV_IND',
       'T',
       '',
       'TOTALL',
       'Provedores',
       '',
       '',
       '',
       '',
       'F',
       '',
       'IND.FILCLI,IND.CODCLI
IND.NOMCLI,IND.ULTNOM
IND.NUMDOC
',
       '' FROM DUAL
);

/*-- SEQ 8260 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IND ','--','' FROM DUAL
UNION ALL
SELECT 'IND ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IND ','02','Endereo' FROM DUAL
UNION ALL
SELECT 'IND ','03','Documentao' FROM DUAL
UNION ALL
SELECT 'IND ','04','Dados Financeiros' FROM DUAL
UNION ALL
SELECT 'IND ','99','Outros' FROM DUAL
);

/*-- SEQ 8261 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23703,
       'EDE ',
       'IND ',
       'N',
       '1',
       '',
       '',
       'EDE.FILCLI = IND.FILCLI AND
EDE.CODCLI = IND.CODCLI
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23704,
       'CON ',
       'IND ',
       '0N',
       '01',
       '',
       '',
       'CON.FILCLI = IND.FILCLI (+)  and
CON.CODCLI = IND.CODCLI (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23705,
       'SPC ',
       'IND ',
       '01',
       '01',
       '',
       '',
       'SPC.FILCLI = IND.FILCLI (+) and
SPC.CODCLI = IND.CODCLI (+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8262 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IND ',
       '01',
       230,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(IND.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '99',
       430,
       4,
       'ANO_DATA01',
       'A',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 1',
       '',
       'TO_CHAR(IND.DATA01,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '99',
       460,
       4,
       'ANO_DATA02',
       'A',
       '',
       0,
       0,
       'PVD ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 2',
       '',
       'TO_CHAR(IND.DATA02,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '99',
       490,
       4,
       'ANO_DATA03',
       'A',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 3',
       '',
       'TO_CHAR(IND.DATA03,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       260,
       4,
       'ANO_DATNAS',
       'A',
       '',
       0,
       0,
       'PVD ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ano de Nascto/Funda',
       'Ano de Data de nascimento',
       '',
       'TO_CHAR(IND.DATNAS,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       290,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       0,
       'PVD ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ano de Data Incluso',
       'Ano de Data de operao (cadastramento)',
       '',
       'TO_CHAR(IND.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       210,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '99',
       380,
       2,
       'CATEG1',
       'S',
       'DCT1',
       0,
       20,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'V',
       'PVD',
       'F',
       'A',
       'T',
       'Profisso/Ramo',
       'Categoria - 1',
       'IND.CATEG1=DCT1.CODTAB (+)',
       'CATEG1',
       'T' FROM DUAL
UNION ALL
SELECT 'IND ',
       '99',
       390,
       2,
       'CATEG2',
       'S',
       'DCT2',
       0,
       21,
       'PVD ',
       20,
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'V',
       'PVD',
       'F',
       'A',
       'T',
       'Salrio/Faturam',
       'Categoria - 2',
       'IND.CATEG2=DCT2.CODTAB (+)',
       'CATEG2',
       'T' FROM DUAL
UNION ALL
SELECT 'IND ',
       '99',
       400,
       2,
       'CATEG3',
       'S',
       'DCT3',
       0,
       22,
       'PVD ',
       30,
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'V',
       'PVD',
       'F',
       'A',
       'T',
       '3',
       'Categoria - 3',
       'IND.CATEG3=DCT3.CODTAB (+)',
       'CATEG3',
       'T' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       180,
       9,
       'CHAVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Indicador',
       'Cdigo do fornecedor',
       '',
       'FILCLI||IND.CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '99',
       560,
       2,
       'CLASS1',
       'S',
       'DCL1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL1.CLASS1',
       'V',
       '',
       '',
       'N',
       '',
       'Catergoria',
       'Domnio de Classe 1',
       'DCL1.CODTAB (+) = IND.CLASS1',
       'CLASS1',
       'T' FROM DUAL
UNION ALL
SELECT 'IND ',
       '99',
       570,
       2,
       'CLASS2',
       'S',
       'DCL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL2.CLASS2',
       'V',
       '',
       '',
       'N',
       '',
       'SubCategoria',
       'Domnio de Classe 2',
       'DCL2.CODTAB (+ )= IND.CLASS2',
       'CLASS2',
       'T' FROM DUAL
UNION ALL
SELECT 'IND ',
       '99',
       580,
       2,
       'CLASS3',
       'S',
       'DCL3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL3.CLASS3',
       'V',
       '',
       '',
       'N',
       '',
       'Familia',
       'Domnio de Classe 3',
       'DCL3.CODTAB (+) = IND.CLASS3',
       'CLASS3',
       'T' FROM DUAL
UNION ALL
SELECT 'IND ',
       '99',
       590,
       2,
       'CLASS4',
       'S',
       'DCL4',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL4.CLASS4',
       'V',
       '',
       '',
       'N',
       '',
       'SubFamilia',
       'Domnio de Classe 4',
       'DCL4.CODTAB (+) = IND.CLASS4',
       'CLASS4',
       'T' FROM DUAL
UNION ALL
SELECT 'IND ',
       '04',
       600,
       7,
       'CMSIND',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Comisso',
       'Percentual de Comisso',
       '',
       'CMSIND',
       '' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       170,
       6,
       'CODCLI',
       'A',
       '',
       0,
       0,
       'PVD ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '9',
       'T',
       'Cdigo',
       'Cdigo do fornecedor',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       20,
       6,
       'CODPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Parceiro',
       'Cdigo do Parceiro',
       '',
       'CODPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       80,
       3,
       'CODPLA',
       'A',
       'PLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Plano padro',
       'Cdigo do plano padro',
       'IND.FILPLA=PLA.FILPGT (+) AND IND.CODPLA=PLA.CODPGT (+)',
       'CODPLA',
       'T' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       60,
       2,
       'CODSEX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Sexo',
       'Cdigo de Sexo do parceiro',
       '',
       'CODSEX',
       'T' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       150,
       3,
       'CODVEN',
       'A',
       'VDD ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'VDD.APEUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Vendedor',
       'Cdigo do Vendedor',
       'IND.FILVEN = VDD.FILUSU (+)  AND IND.CODVEN = VDD.CODUSU (+)',
       'CODVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       110,
       44,
       'CONJUG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cnjuge ou Contato',
       'Nome do Cnjuge ou do Contato principal',
       '',
       'CONJUG',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '99',
       410,
       8,
       'DATA01',
       'D',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       '',
       'Data livre - 1',
       '',
       'DATA01',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '99',
       440,
       8,
       'DATA02',
       'D',
       '',
       0,
       0,
       'PVD ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       '',
       'Data livre - 2',
       '',
       'DATA02',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '99',
       470,
       8,
       'DATA03',
       'D',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       '',
       'Data livre - 3',
       '',
       'DATA03',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       240,
       8,
       'DATNAS',
       'D',
       '',
       0,
       0,
       'PVD ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       'Nascto/Fundao',
       'Data de nascimento',
       '',
       'DATNAS',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       270,
       8,
       'DATOPE',
       'D',
       '',
       0,
       0,
       'PVD ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       'Data Incluso',
       'Data de operao (cadastramento)',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '99',
       550,
       2,
       'DEPART',
       'S',
       'DDEP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDEP.DESDEP',
       'V',
       '',
       '',
       'N',
       '',
       'Departamento',
       'Departamento',
       'DDEP.CODTAB (+)= IND.DEPART',
       'DEPART',
       'T' FROM DUAL
UNION ALL
SELECT 'IND ',
       '04',
       530,
       15,
       'DOCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Doc. Cnjuge/Contato',
       'Doc. Cnjuge/Contato',
       '',
       'DOCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '04',
       540,
       2,
       'ESTCIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Estado Civil',
       'Estado Civil',
       '',
       'ESTCIV',
       'T' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       160,
       3,
       'FILCLI',
       'A',
       '',
       0,
       0,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'N',
       'T',
       '',
       'Filial onde foi cadastrado o fornecedor',
       '',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       10,
       3,
       'FILPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Parceiro',
       '',
       'FILPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       70,
       3,
       'FILPLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial do Plano',
       'Filial do Plano',
       '',
       'FILPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       140,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Vendedor',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '03',
       320,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       0,
       'PVD ',
       20,
       30,
       '',
       '',
       'I',
       'PVD',
       'F',
       '',
       'T',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '02',
       300,
       40,
       'HOMPGE',
       'A',
       '',
       0,
       0,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PVD',
       'F',
       'A',
       'T',
       'Home Page',
       'Home Page do Fornecedor',
       '',
       'HOMPGE',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '99',
       500,
       2,
       'IMPRIM',
       'S',
       '',
       0,
       0,
       'PVD ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '',
       'F',
       'Livre p/Customizao',
       'Livre para customizao',
       '',
       'IMPRIM',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '03',
       330,
       15,
       'INSEST',
       'A',
       '',
       0,
       4,
       'PVD ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PVD',
       'F',
       'A',
       'T',
       '2 Documento',
       'Inscrio Estadual ou Identidade',
       '',
       'INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '04',
       370,
       2,
       'MAIATR',
       'S',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '9',
       'T',
       'Atraso Max. ao Pagar',
       'Maior atraso registrado',
       '',
       'MAIATR',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       220,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(IND.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '99',
       420,
       2,
       'MES_DATA01',
       'A',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 1',
       '',
       'TO_CHAR(IND.DATA01,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '99',
       450,
       2,
       'MES_DATA02',
       'A',
       '',
       0,
       0,
       'PVD ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 2',
       '',
       'TO_CHAR(IND.DATA02,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '99',
       480,
       2,
       'MES_DATA03',
       'A',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 3',
       '',
       'TO_CHAR(IND.DATA03,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       250,
       2,
       'MES_DATNAS',
       'A',
       '',
       0,
       0,
       'PVD ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ms de Nascto/Funda',
       'Ms de Data de nascimento',
       '',
       'TO_CHAR(IND.DATNAS,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       280,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       0,
       'PVD ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ms de Data Incluso',
       'Ms de Data de operao (cadastramento)',
       '',
       'TO_CHAR(IND.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       120,
       8,
       'NASCON',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Nascto Cnj./Contato',
       'Data de nascimento do cnjuge ou contato principal',
       '',
       'NASCON',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       190,
       44,
       'NOMCLI',
       'A',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PVD',
       'F',
       'A',
       'T',
       'Nome/Razo Social',
       'Nome do fornecedor',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '03',
       310,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       3,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PVD',
       'F',
       'A',
       'T',
       'Documento (CPF/CGC)',
       'Nmero do Documento: CGC ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '99',
       510,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'PVD ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PVD',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(IND.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       90,
       5,
       'PORPAD',
       'F',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       'F',
       'A',
       'F',
       'Portador Padro',
       'Portador padro',
       'PAR.PORPAD=DCOB.CODTAB (+)',
       'PORPAD',
       'T' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       130,
       5,
       'SEXCON',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       13,
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Sexo do Cnjuge',
       'Sexo do Cnjuge',
       '',
       'SEXCON',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '99',
       520,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'PVD ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PVD',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN IND.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '99',
       521,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN IND.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       30,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Parceiro',
       'Tipo de Parceiro',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'IND ',
       '04',
       350,
       4,
       'TOTATR',
       'G',
       '',
       0,
       0,
       'PVD ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '',
       'F',
       'Tot.Atrasos ForXCli',
       'Total de atrasos na vida do Fornecedor como cliente',
       '',
       'TOTATR',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '04',
       360,
       4,
       'TOTPAR',
       'G',
       '',
       0,
       0,
       'PVD ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '',
       'F',
       'Tot.Parcelas ForXCli',
       'Total de parcelas na vida do Fornecedor como cliente',
       '',
       'TOTPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       100,
       8,
       'ULTCOM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'ltima Compra',
       'Data da ltima compra',
       '',
       'ULTCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '01',
       200,
       20,
       'ULTNOM',
       'A',
       '',
       0,
       0,
       'PVD ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PVD',
       'F',
       'A',
       'T',
       'Sobrenome/Fantasia',
       'Sobrenome ou fantasia',
       '',
       'ULTNOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IND ',
       '04',
       340,
       8,
       'VALOR1',
       'F',
       '',
       2,
       0,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'T',
       '',
       'T',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'VALOR1',
       'F' FROM DUAL
);

/*-- SEQ 8263 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IND ',
       'CODSEX',
       2,
       '-',
       'Feminino',
       146,
       ' ' FROM DUAL
UNION ALL
SELECT 'IND ',
       'CODSEX',
       0,
       '-',
       'Nao conhecido',
       144,
       ' ' FROM DUAL
UNION ALL
SELECT 'IND ',
       'CODSEX',
       1,
       '-',
       'Masculino',
       145,
       ' ' FROM DUAL
UNION ALL
SELECT 'IND ',
       'ESTCIV',
       6,
       ' ',
       'Separado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IND ',
       'ESTCIV',
       5,
       ' ',
       'Unio Estvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IND ',
       'ESTCIV',
       0,
       ' ',
       'Indefinido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IND ',
       'ESTCIV',
       4,
       ' ',
       'Divorciado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IND ',
       'ESTCIV',
       1,
       ' ',
       'Solteiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IND ',
       'ESTCIV',
       2,
       ' ',
       'Casado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IND ',
       'ESTCIV',
       3,
       ' ',
       'Viuvo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IND ',
       'SEXCON',
       1,
       '-',
       'Masculino',
       212,
       ' ' FROM DUAL
UNION ALL
SELECT 'IND ',
       'SEXCON',
       2,
       '-',
       'Feminino',
       213,
       ' ' FROM DUAL
UNION ALL
SELECT 'IND ',
       'SEXCON',
       0,
       '-',
       'Nao conhecido',
       211,
       ' ' FROM DUAL
UNION ALL
SELECT 'IND ',
       'TIPPAR',
       0,
       'F',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IND ',
       'TIPPAR',
       0,
       'T',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8264 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'INDV',
       0,
       'INDV',
       'Indicador de Vendas',
       'TV_IND',
       'T',
       '',
       'TOTALL',
       'Provedores',
       '',
       '',
       '',
       '',
       'F',
       '',
       'INDV.FILCLI,INDV.CODCLI
INDV.NOMCLI,INDV.ULTNOM
INDV.NUMDOC
',
       '' FROM DUAL
);

/*-- SEQ 8265 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'INDV','--','' FROM DUAL
UNION ALL
SELECT 'INDV','01','Identificao' FROM DUAL
UNION ALL
SELECT 'INDV','02','Endereo' FROM DUAL
UNION ALL
SELECT 'INDV','03','Documentao' FROM DUAL
UNION ALL
SELECT 'INDV','04','Dados Financeiros' FROM DUAL
UNION ALL
SELECT 'INDV','99','Outros' FROM DUAL
);

/*-- SEQ 8266 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 25684,
       'EDE ',
       'INDV',
       'N',
       '1',
       '',
       '',
       'EDE.FILCLI = INDV.FILCLI AND
EDE.CODCLI = INDV.CODCLI
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 25685,
       'CON ',
       'INDV',
       '0N',
       '01',
       '',
       '',
       'CON.FILCLI = INDV.FILCLI (+)  and
CON.CODCLI = INDV.CODCLI (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 25686,
       'SPC ',
       'INDV',
       '01',
       '01',
       '',
       '',
       'SPC.FILCLI = INDV.FILCLI (+) and
SPC.CODCLI = INDV.CODCLI (+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8267 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'INDV',
       '01',
       230,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(INDV.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '99',
       430,
       4,
       'ANO_DATA01',
       'A',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 1',
       '',
       'TO_CHAR(INDV.DATA01,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '99',
       460,
       4,
       'ANO_DATA02',
       'A',
       '',
       0,
       0,
       'PVD ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 2',
       '',
       'TO_CHAR(INDV.DATA02,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '99',
       490,
       4,
       'ANO_DATA03',
       'A',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 3',
       '',
       'TO_CHAR(INDV.DATA03,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       260,
       4,
       'ANO_DATNAS',
       'A',
       '',
       0,
       0,
       'PVD ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ano de Nascto/Funda',
       'Ano de Data de nascimento',
       '',
       'TO_CHAR(INDV.DATNAS,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       290,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       0,
       'PVD ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ano de Data Incluso',
       'Ano de Data de operao (cadastramento)',
       '',
       'TO_CHAR(INDV.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       210,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '99',
       380,
       2,
       'CATEG1',
       'S',
       'DCT1',
       0,
       20,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'V',
       'PVD',
       'F',
       'A',
       'T',
       'Profisso/Ramo',
       'Categoria - 1',
       'INDV.CATEG1=DCT1.CODTAB (+)',
       'CATEG1',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '99',
       390,
       2,
       'CATEG2',
       'S',
       'DCT2',
       0,
       21,
       'PVD ',
       20,
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'V',
       'PVD',
       'F',
       'A',
       'T',
       'Salrio/Faturam',
       'Categoria - 2',
       'INDV.CATEG2=DCT2.CODTAB (+)',
       'CATEG2',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '99',
       400,
       2,
       'CATEG3',
       'S',
       'DCT3',
       0,
       22,
       'PVD ',
       30,
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'V',
       'PVD',
       'F',
       'A',
       'T',
       '3',
       'Categoria - 3',
       'INDV.CATEG3=DCT3.CODTAB (+)',
       'CATEG3',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       180,
       9,
       'CHAVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Indicador',
       'Cdigo do fornecedor',
       '',
       'FILCLI||INDV.CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '04',
       590,
       7,
       'CMSIND',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% Comisso',
       'Percentual de Comisso',
       '',
       'CMSIND',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       170,
       6,
       'CODCLI',
       'A',
       '',
       0,
       0,
       'PVD ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '9',
       'T',
       'Cdigo',
       'Cdigo do fornecedor',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       20,
       6,
       'CODPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Parceiro',
       'Cdigo do Parceiro',
       '',
       'CODPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       80,
       3,
       'CODPLA',
       'A',
       'PLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Plano padro',
       'Cdigo do plano padro',
       'INDV.FILPLA=PLA.FILPGT (+) AND INDV.CODPLA=PLA.CODPGT (+)',
       'CODPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       60,
       2,
       'CODSEX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Sexo',
       'Cdigo de Sexo do parceiro',
       '',
       'CODSEX',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       150,
       3,
       'CODVEN',
       'A',
       'VDD ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'VDD.APEUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Vendedor',
       'Cdigo do Vendedor',
       'INDV.FILVEN = VDD.FILUSU (+)  AND INDV.CODVEN = VDD.CODUSU (+)',
       'CODVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       110,
       44,
       'CONJUG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cnjuge ou Contato',
       'Nome do Cnjuge ou do Contato principal',
       '',
       'CONJUG',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '99',
       410,
       8,
       'DATA01',
       'D',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       '',
       'Data livre - 1',
       '',
       'DATA01',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '99',
       440,
       8,
       'DATA02',
       'D',
       '',
       0,
       0,
       'PVD ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       '',
       'Data livre - 2',
       '',
       'DATA02',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '99',
       470,
       8,
       'DATA03',
       'D',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       '',
       'Data livre - 3',
       '',
       'DATA03',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       240,
       8,
       'DATNAS',
       'D',
       '',
       0,
       0,
       'PVD ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       'Nascto/Fundao',
       'Data de nascimento',
       '',
       'DATNAS',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       270,
       8,
       'DATOPE',
       'D',
       '',
       0,
       0,
       'PVD ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       'Data Incluso',
       'Data de operao (cadastramento)',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '04',
       530,
       15,
       'DOCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Doc. Cnjuge/Contato',
       'Doc. Cnjuge/Contato',
       '',
       'DOCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '04',
       540,
       2,
       'ESTCIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Estado Civil',
       'Estado Civil',
       '',
       'ESTCIV',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       160,
       3,
       'FILCLI',
       'A',
       '',
       0,
       0,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'N',
       'T',
       '',
       'Filial onde foi cadastrado o fornecedor',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       10,
       3,
       'FILPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Parceiro',
       '',
       'FILPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       70,
       3,
       'FILPLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial do Plano',
       'Filial do Plano',
       '',
       'FILPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       140,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Vendedor',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '03',
       320,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       0,
       'PVD ',
       20,
       30,
       '',
       '',
       'I',
       'PVD',
       'F',
       '',
       'T',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '02',
       300,
       40,
       'HOMPGE',
       'A',
       '',
       0,
       0,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PVD',
       'F',
       'A',
       'T',
       'Home Page',
       'Home Page do Fornecedor',
       '',
       'HOMPGE',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '99',
       500,
       2,
       'IMPRIM',
       'S',
       '',
       0,
       0,
       'PVD ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '',
       'F',
       'Livre p/Customizao',
       'Livre para customizao',
       '',
       'IMPRIM',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '03',
       330,
       15,
       'INSEST',
       'A',
       '',
       0,
       4,
       'PVD ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PVD',
       'F',
       'A',
       'T',
       '2 Documento',
       'Inscrio Estadual ou Identidade',
       '',
       'INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '04',
       370,
       2,
       'MAIATR',
       'S',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '9',
       'T',
       'Atraso Max. ao Pagar',
       'Maior atraso registrado',
       '',
       'MAIATR',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       220,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(INDV.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '99',
       420,
       2,
       'MES_DATA01',
       'A',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 1',
       '',
       'TO_CHAR(INDV.DATA01,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '99',
       450,
       2,
       'MES_DATA02',
       'A',
       '',
       0,
       0,
       'PVD ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 2',
       '',
       'TO_CHAR(INDV.DATA02,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '99',
       480,
       2,
       'MES_DATA03',
       'A',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 3',
       '',
       'TO_CHAR(INDV.DATA03,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       250,
       2,
       'MES_DATNAS',
       'A',
       '',
       0,
       0,
       'PVD ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ms de Nascto/Funda',
       'Ms de Data de nascimento',
       '',
       'TO_CHAR(INDV.DATNAS,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       280,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       0,
       'PVD ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ms de Data Incluso',
       'Ms de Data de operao (cadastramento)',
       '',
       'TO_CHAR(INDV.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       120,
       8,
       'NASCON',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Nascto Cnj./Contato',
       'Data de nascimento do cnjuge ou contato principal',
       '',
       'NASCON',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       190,
       44,
       'NOMCLI',
       'A',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PVD',
       'F',
       'A',
       'T',
       'Nome/Razo Social',
       'Nome do fornecedor',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '03',
       310,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       3,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PVD',
       'F',
       'A',
       'T',
       'Documento (CPF/CGC)',
       'Nmero do Documento: CGC ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '99',
       510,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'PVD ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PVD',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(INDV.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       90,
       5,
       'PORPAD',
       'F',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       'F',
       'A',
       'F',
       'Portador Padro',
       'Portador padro',
       'PAR.PORPAD=DCOB.CODTAB (+)',
       'PORPAD',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       130,
       5,
       'SEXCON',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       13,
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Sexo do Cnjuge',
       'Sexo do Cnjuge',
       '',
       'SEXCON',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '99',
       520,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'PVD ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PVD',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN INDV.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '99',
       521,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN INDV.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       30,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Parceiro',
       'Tipo de Parceiro',
       '',
       'TIPPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '04',
       350,
       4,
       'TOTATR',
       'G',
       '',
       0,
       0,
       'PVD ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '',
       'F',
       'Tot.Atrasos ForXCli',
       'Total de atrasos na vida do Fornecedor como cliente',
       '',
       'TOTATR',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '04',
       360,
       4,
       'TOTPAR',
       'G',
       '',
       0,
       0,
       'PVD ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '',
       'F',
       'Tot.Parcelas ForXCli',
       'Total de parcelas na vida do Fornecedor como cliente',
       '',
       'TOTPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       100,
       8,
       'ULTCOM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'ltima Compra',
       'Data da ltima compra',
       '',
       'ULTCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '01',
       200,
       20,
       'ULTNOM',
       'A',
       '',
       0,
       0,
       'PVD ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PVD',
       'F',
       'A',
       'T',
       'Sobrenome/Fantasia',
       'Sobrenome ou fantasia',
       '',
       'ULTNOM',
       'F' FROM DUAL
UNION ALL
SELECT 'INDV',
       '04',
       340,
       8,
       'VALOR1',
       'F',
       '',
       2,
       0,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'T',
       '',
       'T',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'VALOR1',
       'F' FROM DUAL
);

/*-- SEQ 8268 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'INDV',
       'CODSEX',
       2,
       '-',
       'Feminino',
       146,
       ' ' FROM DUAL
UNION ALL
SELECT 'INDV',
       'CODSEX',
       0,
       '-',
       'Nao conhecido',
       144,
       ' ' FROM DUAL
UNION ALL
SELECT 'INDV',
       'CODSEX',
       1,
       '-',
       'Masculino',
       145,
       ' ' FROM DUAL
UNION ALL
SELECT 'INDV',
       'ESTCIV',
       3,
       ' ',
       'Viuvo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'INDV',
       'ESTCIV',
       1,
       ' ',
       'Solteiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'INDV',
       'ESTCIV',
       2,
       ' ',
       'Casado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'INDV',
       'ESTCIV',
       6,
       ' ',
       'Separado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'INDV',
       'ESTCIV',
       5,
       ' ',
       'Unio Estvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'INDV',
       'ESTCIV',
       0,
       ' ',
       'Indefinido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'INDV',
       'ESTCIV',
       4,
       ' ',
       'Divorciado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'INDV',
       'SEXCON',
       1,
       '-',
       'Masculino',
       212,
       ' ' FROM DUAL
UNION ALL
SELECT 'INDV',
       'SEXCON',
       2,
       '-',
       'Feminino',
       213,
       ' ' FROM DUAL
UNION ALL
SELECT 'INDV',
       'SEXCON',
       0,
       '-',
       'Nao conhecido',
       211,
       ' ' FROM DUAL
UNION ALL
SELECT 'INDV',
       'TIPPAR',
       0,
       'F',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'INDV',
       'TIPPAR',
       0,
       'T',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8269 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'INI ',
       TO_NUMBER(null),
       'INI ',
       'Inicializao',
       'TT_INI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8270 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'INI ','--','' FROM DUAL
UNION ALL
SELECT 'INI ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'INI ','99','Outros' FROM DUAL
);

/*-- SEQ 8271 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'INI ',
       '01',
       10,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'INI.FILUSU = USU.FILUSU(+)  AND INI.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'INI ',
       '01',
       20,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial Usurio',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'INI ',
       '01',
       30,
       2,
       'MODULO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Mdulo',
       'Mdulo',
       '',
       'MODULO',
       'F' FROM DUAL
UNION ALL
SELECT 'INI ',
       '01',
       40,
       0,
       'REGINI',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Registro Ini.',
       'Registro Ini.',
       '',
       'REGINI',
       'F' FROM DUAL
);

/*-- SEQ 8272 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'INI ',
       'MODULO',
       0,
       ' ',
       'BackOffice',
       TO_NUMBER(null),
       'BO' FROM DUAL
UNION ALL
SELECT 'INI ',
       'MODULO',
       0,
       ' ',
       'Config',
       TO_NUMBER(null),
       'CG' FROM DUAL
UNION ALL
SELECT 'INI ',
       'MODULO',
       0,
       ' ',
       'Checkout Server',
       TO_NUMBER(null),
       'CS' FROM DUAL
UNION ALL
SELECT 'INI ',
       'MODULO',
       0,
       ' ',
       'Order',
       TO_NUMBER(null),
       'OR' FROM DUAL
UNION ALL
SELECT 'INI ',
       'MODULO',
       0,
       ' ',
       'Delivery',
       TO_NUMBER(null),
       'SD' FROM DUAL
UNION ALL
SELECT 'INI ',
       'MODULO',
       0,
       ' ',
       'Sac/WorkFlow',
       TO_NUMBER(null),
       'SW' FROM DUAL
UNION ALL
SELECT 'INI ',
       'MODULO',
       0,
       ' ',
       'Tools',
       TO_NUMBER(null),
       'TO' FROM DUAL
);

/*-- SEQ 8273 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'INT ',
       TO_NUMBER(null),
       'INT ',
       'Senhas Internet(Tab)',
       'TT_INT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'INT.FILCLI,INT.CODCLI,INT.NUMCON',
       '' FROM DUAL
);

/*-- SEQ 8274 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'INT ','--','' FROM DUAL
UNION ALL
SELECT 'INT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'INT ','99','Outros' FROM DUAL
);

/*-- SEQ 8275 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 11601,
       'USU ',
       'INT ',
       '01',
       '01',
       '',
       '',
       'USU.FILUSU = INT.FILRES AND
USU.CODUSU = INT.CODRES',
       '',
       '' FROM DUAL
);

/*-- SEQ 8276 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'INT ',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'INT ',
       '--',
       100,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Filial',
       'Cdigo Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'INT ',
       '01',
       20,
       3,
       'CODRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Responsvel',
       'Cdigo Responsvel',
       '',
       'CODRES',
       'F' FROM DUAL
UNION ALL
SELECT 'INT ',
       '01',
       30,
       32,
       'CSENHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Senha',
       'Senha',
       '',
       'CSENHA',
       'F' FROM DUAL
UNION ALL
SELECT 'INT ',
       '01',
       120,
       254,
       'E_MAIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'E-mail para Login',
       'E-mail para Login',
       '',
       'E_MAIL',
       '' FROM DUAL
UNION ALL
SELECT 'INT ',
       '01',
       40,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'INT ',
       '01',
       50,
       3,
       'FILRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Responsvel',
       '',
       'FILRES',
       'F' FROM DUAL
UNION ALL
SELECT 'INT ',
       '01',
       130,
       1,
       'INTATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Ativo?',
       '',
       'INTATI',
       '' FROM DUAL
UNION ALL
SELECT 'INT ',
       '01',
       60,
       4,
       'NUMCON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero Consulta',
       'Nmero Consulta',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'INT ',
       '01',
       70,
       12,
       'QTDACE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade Acessos',
       'Quantidade de Acessos',
       '',
       'QTDACE',
       'F' FROM DUAL
UNION ALL
SELECT 'INT ',
       '--',
       110,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'INT ',
       '01',
       80,
       7,
       'ULTACE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'ltimo Acesso',
       'ltimo Acesso',
       '',
       'ULTACE',
       'F' FROM DUAL
UNION ALL
SELECT 'INT ',
       '01',
       90,
       2,
       'ULTNIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'ltimo Nvel',
       'ltimo Nvel',
       '',
       'ULTNIV',
       'F' FROM DUAL
);

/*-- SEQ 8277 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'INU ',
       TO_NUMBER(null),
       'INU ',
       'Inutilizao',
       'TT_INU',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8278 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'INU ','--','' FROM DUAL
UNION ALL
SELECT 'INU ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'INU ','99','Outros' FROM DUAL
);

/*-- SEQ 8279 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'INU ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL(+) = INU.CODFIL',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'INU ',
       '01',
       110,
       3,
       'CODSER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Srie Fiscal',
       'Srie Fiscal',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'INU ',
       '99',
       80,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'INU ',
       '99',
       90,
       255,
       'JUSTIF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Justificativa',
       'Justificativa',
       '',
       'JUSTIF',
       'F' FROM DUAL
UNION ALL
SELECT 'INU ',
       '01',
       50,
       2,
       'MODNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Modelo',
       'Modelo',
       '',
       'MODNOT',
       'T' FROM DUAL
UNION ALL
SELECT 'INU ',
       '01',
       30,
       14,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       'F',
       'CNPJ',
       'CNPJ',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'INU ',
       '01',
       70,
       10,
       'NUMFIM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero Fim',
       'Nmero Fim',
       '',
       'NUMFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'INU ',
       '01',
       60,
       10,
       'NUMINI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero Incio',
       'Nmero Incio',
       '',
       'NUMINI',
       'F' FROM DUAL
UNION ALL
SELECT 'INU ',
       '99',
       100,
       20,
       'PROINU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Protocolo',
       'Protocolo',
       '',
       'PROINU',
       'F' FROM DUAL
UNION ALL
SELECT 'INU ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'INU ',
       '01',
       40,
       1,
       'TIPAMB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Ambiente',
       'Ambiente',
       '',
       'TIPAMB',
       'T' FROM DUAL
);

/*-- SEQ 8280 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'INU ',
       'MODNOT',
       0,
       ' ',
       'NF-e',
       TO_NUMBER(null),
       '55' FROM DUAL
UNION ALL
SELECT 'INU ',
       'MODNOT',
       0,
       ' ',
       'NFC-e',
       TO_NUMBER(null),
       '65' FROM DUAL
UNION ALL
SELECT 'INU ',
       'TIPAMB',
       1,
       ' ',
       'Produo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'INU ',
       'TIPAMB',
       2,
       ' ',
       'Homologao',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8281 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'INV ',
       TO_NUMBER(null),
       'INV ',
       'Inventrio',
       'TT_INV',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'INV.CODFIL,INV.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8282 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'INV ','--','' FROM DUAL
);

/*-- SEQ 8283 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 24300,
       'USU ',
       'INV ',
       '1',
       'N',
       '',
       '',
       'USU.FILUSU = INV.FILCRI and
USU.CODUSU = INV.CODCRI
',
       '',
       '' FROM DUAL
);

/*-- SEQ 8284 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'INV ',
       '--',
       40,
       8,
       'ATU_EM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Atualizao',
       'Data Atualizao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'INV ',
       '--',
       5,
       3,
       'CODCRI',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo Criao',
       'INV.FILCRI = USU.FILUSU(+) AND INV.CODCRI = USU.CODUSU(+)',
       'CODCRI',
       'T' FROM DUAL
UNION ALL
SELECT 'INV ',
       '--',
       8,
       3,
       'CODENC',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo Encomenda',
       'INV.FILENC = USU.FILUSU(+) AND USU.CODUSU(+) = INV.CODENC',
       'CODENC',
       'T' FROM DUAL
UNION ALL
SELECT 'INV ',
       '--',
       30,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       '' FROM DUAL
UNION ALL
SELECT 'INV ',
       '--',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = INV.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'INV ',
       '--',
       20,
       5,
       'CODMUL',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       'F',
       'Sub-Estoque',
       'Nome do Sub-Estoque',
       'DMUL.CODTAB = INV.CODMUL',
       'CODMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'INV ',
       '--',
       6,
       7,
       'DATCRI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Criao',
       'Data Criao',
       '',
       'DATCRI',
       'F' FROM DUAL
UNION ALL
SELECT 'INV ',
       '--',
       9,
       7,
       'DATENC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Encomenda',
       'Data Encomenda',
       '',
       'DATENC',
       'F' FROM DUAL
UNION ALL
SELECT 'INV ',
       '--',
       4,
       3,
       'FILCRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Criao',
       'Filial Criao',
       '',
       'FILCRI',
       'F' FROM DUAL
UNION ALL
SELECT 'INV ',
       '--',
       7,
       3,
       'FILENC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Encomenda',
       'Filial Encomenda',
       '',
       'FILENC',
       'F' FROM DUAL
UNION ALL
SELECT 'INV ',
       '--',
       10,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'INV ',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'INV ',
       '--',
       3,
       40,
       'TITINV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo Inventrio',
       'Ttulo Inventrio',
       '',
       'TITINV',
       'F' FROM DUAL
);

/*-- SEQ 8285 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'INV ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'INV ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'INV ',
       'FLGEST',
       0,
       'E',
       'Executado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8286 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IOR ',
       0,
       'IOR ',
       'Itens de Oramento',
       'TT_IOR',
       'T',
       '',
       'TOTALL',
       'Itens do Oramento/Pedido Venda',
       '{CODFIL;TIPPED;NUMPED;NUMITE};FILMAT;CODMAT;CODCOR;CODTAM;FLGEST;ATU_EM',
       '',
       '',
       'PedidoVendaItem',
       'T',
       '',
       'IOR.CODFIL,IOR.TIPPED,IOR.NUMPED,IOR.NUMITE
ORC.ID,IOR.NUMITE',
       '' FROM DUAL
);

/*-- SEQ 8287 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IOR ','--','' FROM DUAL
UNION ALL
SELECT 'IOR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IOR ','02','Qtdes e Valores' FROM DUAL
UNION ALL
SELECT 'IOR ','03','Outros' FROM DUAL
UNION ALL
SELECT 'IOR ','04','Photo' FROM DUAL
);

/*-- SEQ 8288 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 36351,
       'VIPR',
       'IOR ',
       '1',
       'N',
       '',
       '',
       'VIPR.FILMAT = IOR.FILMAT and
VIPR.CODMAT = IOR.CODMAT and
VIPR.CODCOR = IOR.CODCOR and
VIPR.CODTAM = IOR.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36352,
       'LOT ',
       'IOR ',
       '0N',
       '01',
       '',
       '',
       'LOT.CODFIL(+) = IOR.FILLOT and
LOT.SEQUEN(+) = IOR.SEQLOT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36353,
       'REL ',
       'IOR ',
       '1',
       'N',
       '',
       '',
       'REL.FILPAR = IOR.FILPAR AND
REL.CODPAR = IOR.CODPAR AND
REL.TIPPAR = IOR.TIPPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36354,
       'USU ',
       'IOR ',
       '1',
       'N',
       '',
       '',
       'USU.FILUSU = IOR.FILUSU AND
USU.CODUSU = IOR.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36355,
       'DOU ',
       'IOR ',
       '1',
       'N',
       '',
       '',
       'DOU.CODCRM = IOR.CODCRM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36356,
       'GRA ',
       'IOR ',
       '1',
       'N',
       '',
       '',
       'GRA.FILMAT = IOR.FILMAT and
GRA.CODMAT = IOR.CODMAT and
GRA.CODCOR = IOR.CODCOR and
GRA.CODTAM = IOR.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36357,
       'IVE ',
       'IOR ',
       '1',
       '01',
       '',
       '',
       'IVE.SEQUEN = IOR.SEQIVE AND
IVE.CODFIL = IOR.FILIVE AND
IVE.NUMITE = IOR.NUMIVE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36358,
       'IVI ',
       'IOR ',
       '1',
       '01',
       '',
       '',
       'IVI.SEQUEN = IOR.SEQIVE AND
IVI.CODFIL = IOR.FILIVE AND
IVI.NUMITE = IOR.NUMIVE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36359,
       'CPM ',
       'IOR ',
       '01',
       '0N',
       '',
       '',
       'IOR.FILCPM = CPM.FILCPM(+) AND
IOR.SEQCPM = CPM.SEQUEN(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8289 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'IOR ',
       '03',
       410,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'IOR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(IOR.ATU_EM,''YYYY'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       440,
       4,
       'ANO_ENTREG',
       'A',
       '',
       0,
       0,
       'IOR ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       '',
       'N',
       'T',
       'Ano~Entrega',
       'Ano de Data e hora da entrega',
       '',
       'TO_CHAR(IOR.ENTREG,''YYYY'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       110,
       10,
       'APLICA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtd. a aplicar',
       'Quantidade a aplicar (ex.10 gotas)',
       '',
       'APLICA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       870,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Assinatura para PAF-ECF',
       '',
       'ASSINA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       390,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'IOR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1250,
       12,
       'BASCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base COFINS',
       'Base COFINS',
       '',
       'BASCOF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       940,
       12,
       'BASICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Base ICMS',
       'Base ICMS',
       '',
       'BASICM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1530,
       12,
       'BASINSS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Base INSS',
       'Valor Base INSS',
       '',
       'BASINSS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1130,
       12,
       'BASIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base de IPI',
       'Base de IPI',
       '',
       'BASIPI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1490,
       12,
       'BASISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Base ISS',
       'Valor Base ISS',
       '',
       'BASISS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1240,
       12,
       'BASPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base PIS',
       'Base PIS',
       '',
       'BASPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       950,
       14,
       'BASSTC',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Base se ST da compra',
       'Base se ST da compra',
       '',
       'BASSTC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       960,
       12,
       'BASSUB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Base de Substituio',
       'Base de Substituio',
       '',
       'BASSUB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       530,
       5,
       'CODAMB',
       'S',
       'DAMB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DAMB.DESAMB',
       'V',
       '',
       '',
       'N',
       'F',
       'Ambiente',
       'Ambiente',
       'DAMB.CODTAB = IOR.CODAMB(+)',
       'CODAMB',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       240,
       2,
       'CODCOR',
       'S',
       'DIV ',
       0,
       0,
       'IOR ',
       70,
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       'IOR',
       'F',
       'N',
       'T',
       'Diviso',
       'Diviso do Produto',
       'IOR.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       180,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       0,
       'IOR ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'IOR',
       'F',
       'N',
       'F',
       'Filial',
       'Cdigo da filial',
       'IOR.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       270,
       6,
       'CODFOR',
       'A',
       '',
       0,
       0,
       'IOR ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'F',
       '9',
       'F',
       'Cdigo do Fornecedor',
       'Cdigo do Fornecedor',
       '',
       'CODFOR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       230,
       5,
       'CODMAT',
       'A',
       '',
       0,
       0,
       'IOR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'F',
       '9',
       'F',
       '',
       'Cdigo do Produto',
       '',
       'CODMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       170,
       5,
       'CODMUL',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'N',
       'F',
       'Sub-Estoque',
       'Nome do Sub-Estoque',
       'DMUL.CODTAB = IOR.CODMUL(+)',
       'CODMUL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       50,
       6,
       'CODPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo do Tcnico',
       'Cdigo do Tcnico',
       '',
       'CODPAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       250,
       2,
       'CODTAM',
       'S',
       'SUB ',
       0,
       0,
       'IOR ',
       80,
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       'IOR',
       'F',
       'N',
       'T',
       'Sub-Diviso ',
       'Sub-Diviso do produto',
       'IOR.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       465,
       5,
       'CODTER',
       'S',
       'DTER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DTER.TER_IP',
       'V',
       '',
       '',
       'N',
       'F',
       'Terminal',
       'Terminal',
       'DTER.CODTAB(+) = IOR.CODTER',
       'CODTER',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       880,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Identificao de Acesso',
       '',
       'CODUID',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       80,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Usurio',
       'Cdigo do Usurio',
       'IOR.FILUSU = USU.FILUSU(+)  and IOR.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       890,
       1,
       'CONCLU',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CONCLU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '04',
       860,
       1,
       'CONCLU ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Servio Concludo?',
       'Servio Concludo?',
       '',
       'CONCLU ',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       830,
       6,
       'COOVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Cdigo COO da venda',
       'Cdigo COO da venda',
       '',
       'COOVEN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1350,
       12,
       'CUSMAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Custo Markup',
       'Custo Markup',
       '',
       'CUSMAR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1230,
       14,
       'CUSPRO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       '',
       'Custo Produto',
       'Custo Produto',
       '',
       'CUSPRO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       620,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Data de incluso',
       'Data de incluso',
       '',
       'DATINC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       920,
       12,
       'DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Desconto/Acrscimo',
       'Desconto/Acrscimo',
       '',
       'DESCON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       910,
       12,
       'DESICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Vlr iseno de ICMS',
       'Valor de iseno de ICMS',
       '',
       'DESICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1110,
       12,
       'DESRAT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Desc/Acrsc',
       'Desc/Acrscimo Rateado',
       '',
       'DESRAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       130,
       3,
       'DIADUR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Durao',
       'Durao',
       '',
       'DIADUR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       560,
       1,
       'DUMMY',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DUMMY',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       930,
       3,
       'ECFVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Ecf Vendido',
       'Nmero Ecf Vendido',
       '',
       'ECFVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       420,
       8,
       'ENTREG',
       '@',
       '',
       0,
       0,
       'IOR ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'F',
       '@',
       'T',
       'Data~Entrega',
       'Data e hora da entrega',
       '',
       'ENTREG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       1480,
       3,
       'FILCPM',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Promoo',
       'Filial Promoo',
       'DFIL.CODFIL = IOR.FILCPM(+)',
       'FILCPM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       570,
       3,
       'FILDOU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILDOU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       810,
       3,
       'FILEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial do endereo',
       'Filial do endereo',
       '',
       'FILEND',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       710,
       3,
       'FILEQP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILEQP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       260,
       3,
       'FILFOR',
       'A',
       '',
       0,
       0,
       'IOR ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'F',
       'N',
       'F',
       '',
       'Filial do fornecedor',
       '',
       'FILFOR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       1180,
       3,
       'FILILI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Filial Presente',
       'Filial do Item da Lista de Presente',
       '',
       'FILILI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       90,
       3,
       'FILIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial Item de Venda',
       '',
       'FILIVE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       1050,
       3,
       'FILLOT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial Lote',
       'Filial do Lote',
       'DFIL.CODFIL(+) = IOR.FILLOT',
       'FILLOT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       220,
       3,
       'FILMAT',
       'A',
       '',
       0,
       0,
       'IOR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'F',
       'N',
       'F',
       '',
       'Filial do Produto',
       '',
       'FILMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       720,
       3,
       'FILORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILORI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       40,
       3,
       'FILPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Tecnico',
       '',
       'FILPAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       580,
       3,
       'FILRCT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial da Receita',
       'Filial da Receita',
       '',
       'FILRCT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       10,
       3,
       'FILRES',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       '0',
       'F',
       'Filial Reserva',
       'Filial da Reserva',
       'DFIL.CODFIL = IOR.FILRES(+)',
       'FILRES',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       70,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       840,
       1,
       'FLGENC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Encomendado?',
       'Indica se o item pode ser encomendado sem ser faturado',
       '',
       'FLGENC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       380,
       1,
       'FLGEST',
       'A',
       '',
       0,
       0,
       'IOR ',
       10,
       30,
       '',
       '',
       'D',
       'IOR',
       'F',
       'A',
       'T',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       940,
       1,
       'FLGEST_PAF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       'F',
       '',
       'Situao do Item para PAF-ECF',
       '',
       'FLGEST_PAF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       800,
       1,
       'FLGIVO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Processada Separao',
       'Processada Separao?',
       '',
       'FLGIVO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       1450,
       1,
       'GARANT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Na Garantia?',
       'Na Garantia?',
       '',
       'GARANT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1100,
       1,
       'ICMTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tributao',
       'Tributao',
       '',
       'ICMTIP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       1150,
       12,
       'ISEICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ISEICM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       730,
       5,
       'ITEORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ITEORI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       1510,
       10,
       'ITEPEDCOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'N Item Compra Cli.',
       'Item do Pedido de Compra do Cliente',
       '',
       'ITEPEDCOM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       400,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'IOR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(IOR.ATU_EM,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       430,
       2,
       'MES_ENTREG',
       'A',
       '',
       0,
       0,
       'IOR ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       '',
       'N',
       'T',
       'Ms de Entregue em',
       'Ms de Data e hora da entrega',
       '',
       'TO_CHAR(IOR.ENTREG,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       470,
       1,
       'MONTAR',
       'A',
       '',
       0,
       0,
       'IOR ',
       60,
       30,
       '',
       '',
       'D',
       'IOR',
       'F',
       'A',
       'T',
       'Montargem',
       'Montagem',
       '',
       'MONTAR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       970,
       14,
       'MVAVEN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'MVA da venda',
       'MVA da venda',
       '',
       'MVAVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       1460,
       9,
       'NUMCRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       '',
       'Contador RE',
       'Contador de Requisio Externa',
       '',
       'NUMCRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       820,
       4,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero do endereo',
       'Nmero do endereo',
       '',
       'NUMEND',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       460,
       20,
       'NUMFOR',
       'A',
       '',
       0,
       0,
       'IOR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'F',
       'A',
       'T',
       'Nmero Externo',
       'Nmero Externo',
       '',
       'NUMFOR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       1200,
       5,
       'NUMILI',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Item Presente',
       'Nmero do Item da Lista de Presente',
       '',
       'NUMILI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       210,
       2,
       'NUMITE',
       'S',
       '',
       0,
       0,
       'IOR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'F',
       'N',
       'T',
       'Item',
       'Nmero do item do pedido',
       '',
       'NUMITE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       930,
       5,
       'NUMITE_PAF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero de Item para ',
       'Nmero de Item para PAF-ECF',
       '',
       'NUMITE_PAF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       30,
       5,
       'NUMIVE',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Item de Venda',
       'Item de Venda',
       '',
       'NUMIVE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       740,
       8,
       'NUMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       '',
       '',
       '',
       'NUMORI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       200,
       8,
       'NUMPED',
       'A',
       '',
       0,
       0,
       'IOR ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'F',
       '9',
       'F',
       'Nmero Pedido/OS',
       'Nmero Pedido/OS',
       '',
       'NUMPED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       1500,
       20,
       'NUMPEDCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'N Ped Compra Cli.',
       'Nmero do Pedido de Compra do Cliente',
       '',
       'NUMPEDCOM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       750,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       140,
       3,
       'ORDITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ordem de Itens',
       'Ordem de Itens',
       '',
       'ORDITE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       1470,
       1,
       'ORICRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Origem RE',
       'Origem da Requisio Externa',
       '',
       'ORICRE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1570,
       5,
       'PERDEDISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Deduo Base ISS',
       '% Deduo Base ISS',
       '',
       'PERDEDISS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       1430,
       1,
       'PERENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Perodo da Entrega',
       'Perodo da Entrega',
       '',
       'PERENT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1540,
       5,
       'PERINSS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% INSS',
       '% INSS',
       '',
       'PERINSS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       150,
       1,
       'PERIOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Perodo da aplicao',
       'Perodo da aplicao',
       '',
       'PERIOD',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       760,
       5,
       'PERIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% IPI ltima Compra',
       '% IPI ltima Compra',
       '',
       'PERIPI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1500,
       5,
       'PERISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% ISS',
       '% ISS',
       '',
       'PERISS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1340,
       10,
       'PERLUC',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Percentual de Lucro',
       'Percentual de Lucro',
       '',
       'PERLUC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1410,
       7,
       'PERMCO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Contribuio Orc',
       '% Margem de Contribuio no Oramento',
       '',
       'PERMCO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1390,
       12,
       'PERMCP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Contribuio Pro',
       '% Margem de Contribuio do Produto',
       '',
       'PERMCP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1380,
       7,
       'PEROPEFIX',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Desp. Oper. Fix',
       '% Despesas Operacionais Fixas',
       '',
       'PEROPEFIX',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1480,
       5,
       'PERREDISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Reduo Base ISS',
       '% Reduo Base ISS',
       '',
       'PERREDISS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '04',
       500,
       2,
       'PHOISO',
       'S',
       'DISO',
       0,
       0,
       'IOR ',
       30,
       TO_NUMBER(null),
       '',
       'DISO.PHOISO',
       'V',
       'IOR',
       'F',
       'N',
       'T',
       'ISO',
       'ISO do filme',
       'IOR.PHOISO=DISO.CODTAB (+)',
       'PHOISO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '04',
       480,
       2,
       'PHOMAR',
       'S',
       'DMAR',
       0,
       0,
       'IOR ',
       10,
       TO_NUMBER(null),
       '',
       'DMAR.PHOMAR',
       'V',
       'IOR',
       'F',
       'N',
       'T',
       'Marca do Filme',
       'Marca do Filme',
       'IOR.PHOMAR=DMAR.CODTAB (+)',
       'PHOMAR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '04',
       510,
       2,
       'PHOOUT',
       'S',
       'DPHO',
       0,
       0,
       'IOR ',
       40,
       TO_NUMBER(null),
       '',
       'DPHO.PHOOUT',
       'V',
       'IOR',
       'F',
       'N',
       'T',
       'Outros',
       'Outra classificao do filme',
       'IOR.PHOOUT=DPHO.CODTAB (+)',
       'PHOOUT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '04',
       490,
       2,
       'PHOTIP',
       'S',
       'DTIP',
       0,
       0,
       'IOR ',
       20,
       TO_NUMBER(null),
       '',
       'DTIP.PHOTIP',
       'V',
       'IOR',
       'T',
       'N',
       'T',
       'Tipo de Filme',
       'Tipo de Filme',
       'IOR.PHOTIP=DTIP.CODTAB (+)',
       'PHOTIP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       1640,
       1,
       'PREMANCAM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Preo Camp. Manual',
       'Preo da Campanha alterado manualmente?',
       '',
       'PREMANCAM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       1630,
       14,
       'PREORICAM',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Preo Original Camp.',
       'Preo original da Campanha',
       '',
       'PREORICAM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       340,
       12,
       'PREUNI',
       'F',
       '',
       2,
       0,
       'IOR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'T',
       'N',
       'T',
       'Preo Unitrio',
       'Preo Unitrio',
       '',
       'PREUNI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       520,
       1,
       'PROMOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Promoo',
       'Promoo',
       '',
       'PROMOC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       1210,
       1,
       'PROSUG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Produto sugerido?',
       'Produto sugerido?',
       '',
       'PROSUG',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       320,
       12,
       'QTDENT',
       'F',
       '',
       4,
       0,
       'IOR ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'T',
       'N',
       'T',
       'Qtd. Entregue',
       'Quantidade entregue',
       '',
       'QTDENT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       330,
       12,
       'QTDENT_CON',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtd. Entregue~Conv',
       'Quantidade entregue Convertida',
       '',
       'QTDCONVERTIDA(IOR.CODTAM,IOR.QTDENT)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       290,
       12,
       'QTDITE',
       'F',
       '',
       4,
       0,
       'IOR ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'T',
       'N',
       'T',
       'Qtd. Pedida/OS',
       'Quantidade de determinado item',
       '',
       'QTDITE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       300,
       12,
       'QTDITE_CON',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtd. Pedida/OS~Conv',
       'Quantidade de determinado item Convertida',
       '',
       'QTDCONVERTIDA(IOR.CODTAM,IOR.QTDITE)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       900,
       12,
       'QTDORI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'QTDORI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       850,
       12,
       'QTDORI ',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Quantidade Original',
       'Quantidade Original',
       '',
       'QTDORI ',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       590,
       14,
       'QTDPRE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Quantidade Prescrita',
       'Quantidade Prescrita',
       '',
       'QTDPRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       980,
       7,
       'REDICM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Red. de Base de ICMS',
       'Red. de Base de ICMS',
       '',
       'REDICM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       990,
       7,
       'REDSUB',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Red. de Base de ST',
       'Red. de Base de ST',
       '',
       'REDSUB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       160,
       2,
       'REPETE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'N vezes a aplicar',
       'Nmero de vezes a aplicar (ex. 2 vezes ao dia)',
       '',
       'REPETE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       450,
       2,
       'RESULT',
       'S',
       'DROS',
       0,
       0,
       'IOR ',
       40,
       TO_NUMBER(null),
       '',
       'DROS.RESULT',
       'V',
       'IOR',
       'F',
       'N',
       'T',
       'Resultado',
       'Resultado',
       'IOR.RESULT=DROS.CODTAB (+)',
       'RESULT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       1490,
       10,
       'SEQCPM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sequncia Promoo',
       'Sequncia Promoo',
       '',
       'SEQCPM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       600,
       10,
       'SEQDOU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQDOU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       770,
       10,
       'SEQEQP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQEQP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       1190,
       10,
       'SEQILI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq Presente',
       'Seq do Item da Lista de Presente',
       '',
       'SEQILI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       20,
       10,
       'SEQIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       'F',
       '9',
       'F',
       '',
       'Numero Item de Venda',
       '',
       'SEQIVE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       1060,
       10,
       'SEQLOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq Lote',
       'Sequenciador do Lote',
       '',
       'SEQLOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       610,
       10,
       'SEQRCT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador Receita',
       'Sequenciador Receita',
       '',
       'SEQRCT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       550,
       5,
       'SERITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Rel. Serv./Produtos',
       'Permite auto relacionamento entre os servios e os produtos',
       '',
       'SERITE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       1440,
       1,
       'SIGNAT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Ativo?',
       '',
       '(CASE WHEN IOR.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1560,
       1,
       'SITISS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Sit. Tributria ISS',
       'Situao Tributria ISS',
       '',
       'SITISS',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       1380,
       1,
       'SITUAC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Situao da Venda',
       'Situao da Venda',
       '',
       'SITUACAOVENDA(IOR.CODFIL, IOR.TIPPED, IOR.NUMPED, IOR.NUMITE)',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1080,
       5,
       'SUBFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '% Subsdio Frete',
       '% Subsdio Frete',
       '',
       'SUBFRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1370,
       5,
       'SUBTSF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Tab Subsdio Frete',
       '% de Subsdio da Tabela de Subsdios de Frete',
       '',
       'SUBTSF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1000,
       6,
       'TAXICM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Alquota de ICMS',
       'Alquota de ICMS',
       '',
       'TAXICM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1010,
       6,
       'TAXSUB',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Alquota de ST',
       'Alquota de ST',
       '',
       'TAXSUB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '03',
       1360,
       1,
       'TIPDET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo Detalhe',
       'Tipo de Detalhe do Produto',
       '',
       'TIPDET',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       780,
       1,
       'TIPENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de entrega',
       'Tipo de entrega',
       '',
       'TIPENT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       790,
       1,
       'TIPORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPORI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       60,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Tcnico',
       'Tipo de Tcnico',
       '',
       'TIPPAR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       190,
       1,
       'TIPPED',
       'A',
       '',
       0,
       0,
       'IOR ',
       20,
       30,
       '',
       '',
       'D',
       'IOR',
       'F',
       'A',
       'F',
       'Tipo Pedido/OS',
       'Tipo Pedido/OS',
       '',
       'TIPPED',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       700,
       1,
       'TIPPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Pagamento',
       'Tipo de Pagamento',
       '',
       'TIPPGT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '01',
       280,
       8,
       'VENCIMENTO',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Medicamento Acabando',
       'Medicamento Acabando',
       '',
       '(SELECT ADD_DAY(DATENT,COALESCE(IOR.DIADUR,0)) FROM TT_ORC WHERE CODFIL = IOR.CODFIL AND TIPPED = IOR.TIPPED AND NUMPED = IOR.NUMPED)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1210,
       12,
       'VLRABA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr. Abatimento Lote',
       'Valor do Abatimento do Lote',
       '',
       'VLRABA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1270,
       12,
       'VLRCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor COFINS',
       'Valor COFINS',
       '',
       'VLRCOF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1300,
       12,
       'VLRCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Comisso',
       'Valor Comisso',
       '',
       'VLRCOM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       360,
       12,
       'VLRCUS',
       'F',
       '',
       2,
       0,
       'IOR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'T',
       'N',
       'T',
       'Valor Total',
       'Valor Total',
       '',
       'VLRCUS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1580,
       12,
       'VLRDEDISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Deduo ISS',
       'Valor Deduo ISS',
       '',
       'VLRDEDISS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       350,
       14,
       'VLRENT',
       'F',
       '',
       4,
       0,
       'IOR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'T',
       'N',
       'T',
       'Vlr. Entregue',
       'Valor entregue',
       '',
       'VLRENT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1090,
       12,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor do Frete',
       'Valor do Frete',
       '',
       'VLRFRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1160,
       12,
       'VLRFREORI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor do Frete Origi',
       'Valor do Frete Sem Subsdio',
       '',
       'VLRFREORI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1020,
       12,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor ICMS',
       'Valor ICMS',
       '',
       'VLRICM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1550,
       12,
       'VLRINSS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor INSS',
       'Valor INSS',
       '',
       'VLRINSS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1140,
       12,
       'VLRIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor de IPI',
       'Valor de IPI',
       '',
       'VLRIPI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '--',
       1170,
       12,
       'VLRIPIFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VLRIPIFRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1280,
       12,
       'VLRIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor IRRF',
       'Valor IRRF',
       '',
       'VLRIRR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1510,
       12,
       'VLRISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor ISS',
       'Valor ISS',
       '',
       'VLRISS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1520,
       12,
       'VLRISSRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Retido ISS',
       'Valor Retido ISS',
       '',
       'VLRISSRET',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       310,
       14,
       'VLRITE',
       'F',
       '',
       4,
       0,
       'IOR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'T',
       'N',
       'T',
       'Vlr. Pedido/OS',
       'Valor deste item',
       '',
       'VLRITE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1330,
       12,
       'VLRLUC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Lucro',
       'Valor Lucro',
       '',
       'VLRLUC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1420,
       14,
       'VLRMCO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vl Contribuio Orc',
       'Valor Margem de Contribuio no Oramento',
       '',
       'VLRMCO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1400,
       14,
       'VLRMCP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vl Contribuio Pro',
       'Valor Margem de Contribuio do Produto',
       '',
       'VLRMCP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1310,
       12,
       'VLROPE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Desp. Operac.',
       'Valor Despesas Operacionais',
       '',
       'VLROPE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1320,
       12,
       'VLROPEFIX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Desp. Op.Fixas',
       'Valor Despesas Operacionais Fixas',
       '',
       'VLROPEFIX',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       370,
       12,
       'VLRPGT',
       'F',
       '',
       2,
       0,
       'IOR ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'T',
       'N',
       'T',
       'Valor Total Sem Desc',
       'Valor pago ao fornecedor Valor Total Sem Desconto',
       '',
       'VLRPGT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1260,
       12,
       'VLRPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor PIS',
       'Valor PIS',
       '',
       'VLRPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1120,
       12,
       'VLRSEG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Seguro',
       'Seguro',
       '',
       'VLRSEG',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1290,
       12,
       'VLRSOC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Contr. Social',
       'Valor Contribuio Social',
       '',
       'VLRSOC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1030,
       14,
       'VLRSTC',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Vlr BC do ICMS Retid',
       'Vlr BC do ICMS Retid',
       '',
       'VLRSTC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1040,
       12,
       'VLRSUB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Substituio',
       'Valor de Substituio',
       '',
       'VLRSUB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1590,
       12,
       'BASIRRF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base IRRF para ISS',
       'Base IRRF para Servio',
       '',
       'BASIRRF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1600,
       5,
       'PERIRRF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% IRRF para ISS',
       '% IRRF para Servio',
       '',
       'PERIRRF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IOR ',
       '02',
       1610,
       12,
       'VLRIRRF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor IRRF para ISS',
       'Valor IRRF para Servio',
       '',
       'VLRIRRF',
       '',
       'D' FROM DUAL
);

/*-- SEQ 8290 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IOR ',
       'FLGEST',
       0,
       'A',
       'Em aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'FLGEST',
       0,
       'E',
       'Faturado/Vendido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'FLGEST',
       0,
       'O',
       'Concludo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'FLGEST',
       0,
       'R',
       'Reservado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'FLGEST',
       0,
       'T',
       'Em andamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'FLGIVO',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'FLGIVO',
       0,
       'P',
       'Processado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'ICMTIP',
       0,
       '0',
       'Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'ICMTIP',
       0,
       '1',
       'No Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'ICMTIP',
       0,
       '2',
       'Isento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'ICMTIP',
       0,
       '3',
       'Substitudo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'ICMTIP',
       0,
       '4',
       'Isento no Estado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'MONTAR',
       0,
       'F',
       'Sem Montagem',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'MONTAR',
       0,
       'I',
       'Montagem Interna ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'MONTAR',
       0,
       'T',
       'Montagem na entrega',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'ORICRE',
       0,
       'I',
       'Internet',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'ORICRE',
       0,
       'M',
       'Mobile',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'ORICRE',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'PERENT',
       0,
       'M',
       'Manh',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'PERENT',
       0,
       'N',
       'Noite',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'PERENT',
       0,
       'T',
       'Tarde',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'PERIOD',
       0,
       'D',
       'Dirio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'PERIOD',
       0,
       'M',
       'Mensal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'PERIOD',
       0,
       'S',
       'Semanal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'PROMOC',
       0,
       'E',
       'Promocional no Plano',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'PROMOC',
       0,
       'N',
       'No Promocional no Plano',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'PROMOC',
       0,
       'Q',
       'Qualquer Plano',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'SITISS',
       0,
       'I',
       'ISENTA',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'SITISS',
       0,
       'N',
       'NORMAL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'SITISS',
       0,
       'R',
       'RETIDA',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'SITISS',
       0,
       'S',
       'SUBSTITUTA',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'SITUAC',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'SITUAC',
       0,
       'P',
       'Vendido Parcial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'SITUAC',
       0,
       'Q',
       'Vendido Total',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'TIPDET',
       0,
       'K',
       'Kit',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'TIPDET',
       0,
       'T',
       'Tinta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'TIPENT',
       0,
       '0',
       'Cliente Leva',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'TIPENT',
       0,
       '1',
       'Depsito Entrega',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'TIPENT',
       0,
       '2',
       'Loja Entrega',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'TIPENT',
       0,
       '3',
       'Retira no Depsito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'TIPENT',
       0,
       '4',
       'Em Outra Loja',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'TIPENT',
       0,
       '5',
       'Entrega Futura',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'TIPENT',
       0,
       '6',
       'Apenas Oramento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'TIPENT',
       0,
       '7',
       'Venda sob Encomenda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'TIPPAR',
       0,
       'F',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'TIPPAR',
       0,
       'T',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'TIPPED',
       0,
       'O',
       'DAV',
       57,
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'TIPPED',
       0,
       'P',
       'Pr-Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'TIPPED',
       0,
       'S',
       'DAV-OS',
       58,
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'TIPPGT',
       0,
       'C',
       'Contrato',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IOR ',
       'TIPPGT',
       0,
       'F',
       'Faturamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8291 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IOXC',
       TO_NUMBER(null),
       'IOXC',
       'Itens Ora. X Camp.',
       'TT_IORXCPR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8292 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IOXC','--','' FROM DUAL
UNION ALL
SELECT 'IOXC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IOXC','99','Outros' FROM DUAL
);

/*-- SEQ 8293 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 112672,
       'CUP ',
       'IOXC',
       '1',
       'N',
       '',
       '',
       'IOXC.FILCUP = CUP.CODFIL AND
IOXC.SEQCUP = CUP.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 111943,
       'CPR ',
       'IOXC',
       '1',
       'N',
       '',
       '',
       'IOXC.FILCPR = CPR.CODFIL AND
IOXC.SEQCPR = CPR.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 111944,
       'IOR ',
       'IOXC',
       '01',
       'N',
       '',
       '',
       'IOXC.FILIOR = IOR.CODFIL AND
IOXC.TIPIOR = IOR.TIPPED AND
IOXC.NUMIOR = IOR.NUMPED AND
IOXC.ITEIOR = IOR.NUMITE',
       '',
       '' FROM DUAL
);

/*-- SEQ 8294 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IOXC',
       '01',
       10,
       3,
       'FILCPR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial Campanha',
       'Filial da campanha',
       'DFIL.CODFIL = IOXC.FILCPR(+)',
       'FILCPR',
       'T' FROM DUAL
UNION ALL
SELECT 'IOXC',
       '01',
       100,
       3,
       'FILCUP',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Cupom',
       'Filial do Cupom',
       'DFIL.CODFIL = IOXC.FILCUP',
       'FILCUP',
       'T' FROM DUAL
UNION ALL
SELECT 'IOXC',
       '01',
       20,
       3,
       'FILIOR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial Oramento',
       'Filial do oramento',
       'DFIL.CODFIL = IOXC.FILIOR(+)',
       'FILIOR',
       'T' FROM DUAL
UNION ALL
SELECT 'IOXC',
       '--',
       30,
       10,
       'ID_OXC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'ID_OXC',
       'F' FROM DUAL
UNION ALL
SELECT 'IOXC',
       '01',
       40,
       10,
       'ITEIOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nro. Item Oramento',
       'Nmero do item da venda',
       '',
       'ITEIOR',
       'F' FROM DUAL
UNION ALL
SELECT 'IOXC',
       '01',
       50,
       8,
       'NUMIOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nro. Oramento',
       'Nmero do oramento',
       '',
       'NUMIOR',
       'F' FROM DUAL
UNION ALL
SELECT 'IOXC',
       '--',
       60,
       18,
       'QTDMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Qtde. Atendida',
       'Quantidade atendida',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'IOXC',
       '01',
       70,
       10,
       'SEQCPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. Campanha',
       'Sequenciador da campanha',
       '',
       'SEQCPR',
       'T' FROM DUAL
UNION ALL
SELECT 'IOXC',
       '01',
       110,
       10,
       'SEQCUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq, Cupom',
       'Sequenciador do Cupom',
       '',
       'SEQCUP',
       '' FROM DUAL
UNION ALL
SELECT 'IOXC',
       '01',
       80,
       1,
       'TIPIOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Tipo Oramento',
       'Tipo oramento',
       '',
       'TIPIOR',
       'F' FROM DUAL
UNION ALL
SELECT 'IOXC',
       '--',
       90,
       18,
       'VLRMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor do Desconto',
       'Valor do Desconto',
       '',
       'VLRMOV',
       '' FROM DUAL
);

/*-- SEQ 8295 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IPAG',
       TO_NUMBER(null),
       'IPAG',
       'Importa a Pagar',
       'TI_PAG',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8296 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IPAG','--','' FROM DUAL
UNION ALL
SELECT 'IPAG','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IPAG','99','Outros' FROM DUAL
);

/*-- SEQ 8297 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IPAG',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       20,
       20,
       'CODAUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Autorizao',
       'Cdigo Autorizao',
       '',
       'CODAUT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       30,
       3,
       'CODBCO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Banco',
       'Cdigo do Banco',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       40,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       50,
       20,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Fornecedor',
       'Cdigo Fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       60,
       20,
       'CODPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Produto',
       'Cdigo do Produto',
       '',
       'CODPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       70,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       80,
       20,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Usurio',
       'Cdigo Usurio',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       90,
       5,
       'CONPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Conta Pagto.',
       'Conta para lanamento no OF-CASH',
       '',
       'CONPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       100,
       7,
       'DATIMP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Importao',
       'Data da Importao',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       110,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       120,
       7,
       'DATPGT',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Pagamento',
       'Data de pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       130,
       7,
       'DATPRX',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Prximo Vencto',
       'Data do Prximo Vencimento',
       '',
       'DATPRX',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       140,
       7,
       'DATVEN',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data de Vencimento',
       'Data de Vencimento',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       150,
       8,
       'DOCPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento Pagamento',
       'Documento Pagamento',
       '',
       'DOCPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       290,
       20,
       'DOP_CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo Externo DOP',
       'Cdigo Externo do Documento de Pagamento',
       '',
       'DOP_CODEXT',
       '' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       160,
       3,
       'FILDOP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Doc. PGTO',
       'Filial Documento Pagamento',
       '',
       'FILDOP',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       170,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Estado',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       180,
       255,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo da~Rejeio',
       'Motivo da Rejeio',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       190,
       8,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Nota',
       'Nmero Nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       200,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Parcela',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       210,
       10,
       'SEQDOP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador Documento Pagamento',
       '',
       'SEQDOP',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       220,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN IPAG.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       221,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN IPAG.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       230,
       1,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status da~importao',
       'Status da importao',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       240,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub-Parcela',
       'Sub Parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       250,
       12,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Desconto',
       'Valor Desconto',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       260,
       12,
       'VLRDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Saldo',
       'Saldo',
       '',
       'VLRDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       270,
       12,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Parcela',
       'Valor Parcela',
       '',
       'VLRPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPAG',
       '--',
       280,
       12,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Pagamento',
       'Valor Pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 8298 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IPAG',
       'FLGEST',
       0,
       '1',
       'Programado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPAG',
       'FLGEST',
       0,
       '2',
       'Autorizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPAG',
       'FLGEST',
       0,
       'A',
       ' Pagar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPAG',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPAG',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPAG',
       'FLGEST',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8299 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IPC ',
       TO_NUMBER(null),
       'IPC ',
       'Itens Param Config.',
       'TT_IPC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'IPC.ID_IPC,IPC.ID_PCS',
       '' FROM DUAL
);

/*-- SEQ 8300 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IPC ','--','' FROM DUAL
UNION ALL
SELECT 'IPC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IPC ','02','Datas' FROM DUAL
UNION ALL
SELECT 'IPC ','99','Outros' FROM DUAL
);

/*-- SEQ 8301 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 106064,
       'DFIL',
       'IPC ',
       '01',
       '0N',
       '',
       '',
       'IPC.FILIPC = DFIL.CODFIL(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 106065,
       'DECF',
       'IPC ',
       '01',
       '0N',
       '',
       '',
       'IPC.FILECF = DECF.FILECF(+) AND
IPC.NUMECF = DECF.NUMECF(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 106066,
       'DSER',
       'IPC ',
       '01',
       '0N',
       '',
       '',
       'IPC.CODSER = DSER.CODSER(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 106067,
       'PCS ',
       'IPC ',
       '1',
       'N',
       '',
       '',
       'IPC.ID_PCS = PCS.ID_PCS',
       '',
       '' FROM DUAL
);

/*-- SEQ 8302 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IPC ',
       '02',
       40,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'IPC ',
       '01',
       140,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       '',
       'Srie',
       'Srie',
       'DSER.CODSER(+) = IPC.CODSER',
       'CODSER',
       'T' FROM DUAL
UNION ALL
SELECT 'IPC ',
       '02',
       30,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'IPC ',
       '01',
       120,
       3,
       'FILECF',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial do ECF',
       'Filial do ECF',
       'DFIL.CODFIL(+) = IPC.FILECF',
       'FILECF',
       'T' FROM DUAL
UNION ALL
SELECT 'IPC ',
       '01',
       110,
       3,
       'FILIPC',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL(+) = IPC.FILIPC',
       'FILIPC',
       'T' FROM DUAL
UNION ALL
SELECT 'IPC ',
       '01',
       10,
       14,
       'ID_IPC',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Chave ID',
       'Chave ID',
       '',
       'ID_IPC',
       '' FROM DUAL
UNION ALL
SELECT 'IPC ',
       '01',
       20,
       14,
       'ID_PCS',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'ID Param Config Sist',
       'ID Parmetros Configurados de Sistema',
       '',
       'ID_PCS',
       '' FROM DUAL
UNION ALL
SELECT 'IPC ',
       '01',
       50,
       1,
       'IPCATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Ativo?',
       '',
       'IPCATI',
       '' FROM DUAL
UNION ALL
SELECT 'IPC ',
       '01',
       130,
       3,
       'NUMECF',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       '',
       'Nmero do ECF',
       'Nmero do ECF',
       'DECF.FILECF(+) = IPC.FILECF AND DECF.NUMECF(+) = IPC.NUMECF',
       'NUMECF',
       'T' FROM DUAL
UNION ALL
SELECT 'IPC ',
       '01',
       90,
       1,
       'VLRBOO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Valor Booleano',
       'Valor Booleano',
       '',
       'VLRBOO',
       '' FROM DUAL
UNION ALL
SELECT 'IPC ',
       '01',
       100,
       7,
       'VLRDAT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data',
       'Data',
       '',
       'VLRDAT',
       '' FROM DUAL
UNION ALL
SELECT 'IPC ',
       '01',
       70,
       10,
       'VLRINT',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Inteiro',
       'Valor Inteiro',
       '',
       'VLRINT',
       '' FROM DUAL
UNION ALL
SELECT 'IPC ',
       '01',
       60,
       16,
       'VLRNUM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Numrico',
       'Valor Numrico',
       '',
       'VLRNUM',
       '' FROM DUAL
UNION ALL
SELECT 'IPC ',
       '01',
       80,
       100,
       'VLRTXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Valor Texto',
       'Valor Texto',
       '',
       'VLRTXT',
       '' FROM DUAL
);

/*-- SEQ 8303 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IPE ',
       0,
       'IPE ',
       'Itens de Ped.Compras',
       'TT_IPE',
       'T',
       '',
       'TOTALL',
       'Itens do Pedido de Compra',
       '{FILFOR;CODFIL;CODFOR;NUMPED;NUMITE};CODMAT;FILMAT;CODCOR;CODTAM;FLGEST;ATU_EM',
       '',
       '',
       'PedidoCompraItem',
       'T',
       '',
       'IPE.CODFIL,IPE.NUMPED,IPE.NUMITE
PED.ID,IPE.NUMITE',
       '' FROM DUAL
);

/*-- SEQ 8304 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IPE ','--','' FROM DUAL
UNION ALL
SELECT 'IPE ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IPE ','02','Datas' FROM DUAL
UNION ALL
SELECT 'IPE ','03','Valores' FROM DUAL
UNION ALL
SELECT 'IPE ','99','Outros' FROM DUAL
);

/*-- SEQ 8305 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23870,
       'GRA ',
       'IPE ',
       '1',
       'N',
       '',
       '',
       'GRA.FILMAT = IPE.FILMAT and
GRA.CODMAT = IPE.CODMAT and
GRA.CODCOR = IPE.CODCOR and
GRA.CODTAM = IPE.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23871,
       'VIPR',
       'IPE ',
       '1',
       '1',
       '',
       '',
       'VIPR.FILMAT = IPE.FILMAT(+) AND
VIPR.CODMAT = IPE.CODMAT(+) AND
VIPR.CODCOR = IPE.CODCOR(+) AND
VIPR.CODTAM = IPE.CODTAM(+) ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23872,
       'IVE ',
       'IPE ',
       '1',
       'N',
       '',
       '',
       'IVE.CODFIL = IPE.FILIVE AND
IVE.SEQUEN = IPE.SEQIVE AND
IVE.NUMITE = IPE.NUMIVE',
       '',
       '' FROM DUAL
);

/*-- SEQ 8306 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IPE ',
       '02',
       175,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'IPE ',
       170,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IPE',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(IPE.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '02',
       95,
       4,
       'ANO_DATREB',
       'A',
       '',
       0,
       0,
       'IPE ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IPE',
       '',
       'N',
       'T',
       'Ano de Recebido em',
       'Ano de Data de recebimento',
       '',
       'TO_CHAR(IPE.DATREB,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '02',
       170,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'IPE ',
       170,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IPE',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       350,
       14,
       'BASICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base Clculo ICMS',
       '',
       '',
       'BASICM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '01',
       0,
       20,
       'CODBUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cdigo de Busca',
       'Cdigo de Busca',
       '',
       'CODBUS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '01',
       60,
       2,
       'CODCOR',
       'S',
       'DIV ',
       0,
       0,
       'IPE ',
       60,
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       'IPE',
       'F',
       'A',
       'T',
       'Diviso',
       'Diviso do Produto',
       'IPE.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       0,
       'IPE ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'IPE',
       'F',
       'N',
       'F',
       'Filial',
       'Cdigo da filial',
       'IPE.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '01',
       50,
       5,
       'CODMAT',
       'A',
       '',
       0,
       0,
       'IPE ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IPE',
       'F',
       '9',
       'F',
       '',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       160,
       2,
       'CODMOE',
       'S',
       'DMOE',
       0,
       0,
       'IPE ',
       160,
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       'IPE',
       'F',
       'A',
       'T',
       'Moeda',
       'Cdigo da moeda utilizada no preo do item',
       'IPE.CODMOE=DMOE.CODTAB (+)',
       'CODMOE',
       'T' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       240,
       5,
       'CODMUL',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       'F',
       'Sub-Estoque',
       'Nome do Sub-Estoque',
       'DMUL.CODTAB = IPE.CODMUL',
       'CODMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '01',
       70,
       2,
       'CODTAM',
       'S',
       'SUB ',
       0,
       0,
       'IPE ',
       70,
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       'IPE',
       'F',
       'A',
       'T',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'IPE.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '02',
       90,
       8,
       'DATREB',
       'D',
       '',
       0,
       0,
       'IPE ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IPE',
       'F',
       'D',
       'T',
       'Recebido em',
       'Data de recebimento',
       '',
       'DATREB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '99',
       4,
       1,
       'DUMMY',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'F',
       '',
       'Controle Interno',
       '',
       'DUMMY',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '01',
       250,
       3,
       'FILENT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial Entrega',
       'Filial Entrega',
       'DFIL.CODFIL = IPE.FILENT',
       'FILENT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '01',
       1,
       3,
       'FILICO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do item de compra',
       '',
       'FILICO',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '01',
       320,
       3,
       'FILIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Itens de Venda',
       '',
       'FILIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '01',
       420,
       3,
       'FILLOT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial Lote',
       'Filial do Lote',
       'DFIL.CODFIL(+) = IPE.FILLOT',
       'FILLOT',
       'T' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '01',
       40,
       3,
       'FILMAT',
       'A',
       '',
       0,
       0,
       'IPE ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IPE',
       'F',
       'N',
       'F',
       '',
       'Filial do material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '01',
       258,
       3,
       'FILORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial de Origem',
       'Filial de Origem',
       '',
       'FILORI',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '99',
       400,
       1,
       'FLGENC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Para Encomenda?',
       'Para Encomenda?',
       '',
       'FLGENC',
       '' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '01',
       80,
       1,
       'FLGEST',
       'A',
       '',
       0,
       0,
       'IPE ',
       80,
       30,
       '',
       '',
       'D',
       'IPE',
       'F',
       'A',
       'T',
       'Situao',
       'Situao (Em aberto/Entregue/Cancelado)',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       230,
       5,
       'ICMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'ICMS sobre Item',
       'ICMS sobre Item',
       '',
       'ICMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       140,
       8,
       'IPIITE',
       'F',
       '',
       2,
       0,
       'IPE ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IPE',
       'T',
       'N',
       'T',
       '% IPI',
       'Percentual do IPI do item',
       '',
       'IPIITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       380,
       14,
       'ISEICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Iseno  ICMS',
       'Iseno ICMS',
       '',
       'ISEICM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '01',
       260,
       5,
       'ITEORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Item de Origem',
       'Item de Origem',
       '',
       'ITEORI',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '02',
       173,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'IPE ',
       170,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IPE',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(IPE.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '02',
       93,
       2,
       'MES_DATREB',
       'A',
       '',
       0,
       0,
       'IPE ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IPE',
       '',
       'N',
       'T',
       'Ms~Recebimento',
       'Ms de Data de recebimento',
       '',
       'TO_CHAR(IPE.DATREB,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '01',
       3,
       5,
       'NUMICO',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Nm.Item Compra',
       'Nmero do item de compra',
       '',
       'NUMICO',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '01',
       30,
       2,
       'NUMITE',
       'S',
       '',
       0,
       0,
       'IPE ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IPE',
       'F',
       'N',
       'T',
       'Item',
       'Nmero do item de pedido',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '01',
       330,
       5,
       'NUMIVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero Itens Venda',
       'Nmero Itens de Venda',
       '',
       'NUMIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '01',
       20,
       8,
       'NUMPED',
       'A',
       '',
       0,
       0,
       'IPE ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IPE',
       'F',
       '9',
       'F',
       'Nmero do pedido',
       'Nmero do pedido',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '01',
       259,
       5,
       'ORDITE',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ordem do Item',
       'Ordem do Item no Pedido',
       '',
       'ORDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       360,
       14,
       'OUTICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Outros ICMS',
       'Outros ICMS',
       '',
       'OUTICM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '01',
       410,
       8,
       'PEDORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Pedido de Origem',
       'Pedido de Origem',
       '',
       'PEDORI',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       120,
       8,
       'QTDCAN',
       'F',
       '',
       2,
       0,
       'IPE ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IPE',
       'T',
       'N',
       'T',
       'Qtd. Cancelada',
       'Quantidade cancelada',
       '',
       'QTDCAN',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       125,
       8,
       'QTDCAN_CON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtd. Cancelada~Conv.',
       'Quantidade cancelada Convertida',
       '',
       'QTDCONVERTIDA(IPE.CODTAM,IPE.QTDCAN)',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       130,
       8,
       'QTDENT',
       'F',
       '',
       2,
       0,
       'IPE ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IPE',
       'T',
       'N',
       'T',
       'Qtd. Entregue',
       'Quantidade entregue',
       '',
       'QTDENT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       135,
       8,
       'QTDENT_CON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtd. Entregue~Conv.',
       'Quantidade entregue Convertida',
       '',
       'QTDCONVERTIDA(IPE.CODTAM,IPE.QTDENT)',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       100,
       8,
       'QTDITE',
       'F',
       '',
       2,
       0,
       'IPE ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IPE',
       'T',
       'N',
       'T',
       'Qtd. Movimentada',
       'Quantidade Movimentada do item',
       '',
       'QTDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       105,
       8,
       'QTDITE_CON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtd. Mov.~Convertida',
       'Quantidade Movimentada do item convertido',
       '',
       'QTDCONVERTIDA(IPE.CODTAM,IPE.QTDITE)',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       440,
       12,
       'QTDPED',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtd. Pedida',
       'Quantidade Pedida do item',
       '',
       'QTDPED',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       460,
       12,
       'QTDPED_CON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Qtd. Ped.~Convertida',
       'Quantidade Pedida do item convertido',
       '',
       'QTDCONVERTIDA(IPE.CODTAM,IPE.QTDPED)',
       '' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       293,
       12,
       'QTDPENDENTE',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       '',
       'Qtde Pendende',
       'Quantidade Pendente',
       '',
       '(CASE WHEN IPE.FLGEST=''A'' THEN (COALESCE(IPE.QTDITE,0)-COALESCE(IPE.QTDCAN,0)) ELSE 0 END)',
       '' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '99',
       2,
       10,
       'SEQICO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequencial do item de compra',
       '',
       'SEQICO',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '99',
       340,
       10,
       'SEQIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Itens de Venda',
       '',
       'SEQIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '01',
       430,
       10,
       'SEQLOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq Lote',
       'Sequenciador do Lote',
       '',
       'SEQLOT',
       '' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '99',
       270,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '01',
       280,
       5,
       'UNICOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Unidade Compra',
       'Unidade Compra',
       '',
       'UNICOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '01',
       290,
       5,
       'UNIVEN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Unidade Venda',
       'Unidade Venda',
       '',
       'UNIVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       300,
       12,
       'VALCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Converso',
       'Valor de converso entre as unidades de Venda/Compra',
       '',
       'VALCON',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       310,
       12,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Desconta',
       'Valor Desconta',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       490,
       12,
       'VLREMB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor da Embalagem',
       'Valor da Embalagem',
       '',
       'VLREMB',
       '' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       390,
       12,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Frete',
       'Valor Frete',
       '',
       'VLRFRE',
       '' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       370,
       14,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor ICMS',
       'Valor ICMS',
       '',
       'VLRICM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       480,
       12,
       'VLRIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor do IPI',
       'Valor do IPI',
       '',
       'VLRIPI',
       '' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       110,
       8,
       'VLRITE',
       'F',
       '',
       2,
       0,
       'IPE ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IPE',
       'T',
       'N',
       'T',
       'Vlr. Pedido',
       'Valor do item',
       '',
       'VLRITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       450,
       12,
       'VLRUNI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vlr. Unitrio',
       'Valor Unitrio do item',
       '',
       'VLRUNI',
       'F' FROM DUAL
UNION ALL
SELECT 'IPE ',
       '03',
       150,
       8,
       'VLRVEN',
       'F',
       '',
       2,
       0,
       'IPE ',
       150,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IPE',
       'T',
       'N',
       'T',
       'Vlr. de Venda',
       'Valor de venda do item',
       '',
       'VLRVEN',
       'F' FROM DUAL
);

/*-- SEQ 8307 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IPE ',
       'FLGEST',
       0,
       'A',
       'Em aberto',
       59,
       ' ' FROM DUAL
UNION ALL
SELECT 'IPE ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       61,
       ' ' FROM DUAL
UNION ALL
SELECT 'IPE ',
       'FLGEST',
       0,
       'E',
       'Entregue',
       60,
       ' ' FROM DUAL
);

/*-- SEQ 8308 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IPF ',
       TO_NUMBER(null),
       'IPF ',
       'Itens Preo Fornec.',
       'TT_IPF',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8309 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IPF ','--','' FROM DUAL
UNION ALL
SELECT 'IPF ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IPF ','02','Valores' FROM DUAL
UNION ALL
SELECT 'IPF ','03','Datas' FROM DUAL
UNION ALL
SELECT 'IPF ','99','Outros' FROM DUAL
);

/*-- SEQ 8310 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 29292,
       'TPF ',
       'IPF ',
       '1',
       'N',
       '',
       '',
       'IPF.ID_TPF = TPF.ID_TPF',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29294,
       'GRA ',
       'IPF ',
       '1',
       '1',
       '',
       '',
       'IPF.FILMAT = GRA.FILMAT AND
IPF.CODMAT = GRA.CODMAT AND
IPF.CODCOR = GRA.CODCOR AND
IPF.CODTAM = GRA.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 8311 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IPF ',
       '01',
       170,
       5,
       'CODCOR',
       'G',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       '',
       'N',
       '',
       'Diviso',
       'Diviso',
       'IPF.CODCOR = DIV.CODITE',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPF ',
       '01',
       160,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo do Material',
       'Cdigo do Material',
       '',
       'CODMAT',
       '' FROM DUAL
UNION ALL
SELECT 'IPF ',
       '01',
       180,
       5,
       'CODTAM',
       'G',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       '',
       'N',
       '',
       'Subdiviso',
       'Subdiviso',
       'IPF.CODTAM = SUB.CODITE',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPF ',
       '03',
       140,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data de Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'IPF ',
       '01',
       150,
       3,
       'FILMAT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial do Material',
       'Filial do Material',
       'DFIL.CODFIL = IPF.FILMAT',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPF ',
       '01',
       10,
       14,
       'ID_IPF',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Chave ID',
       'Chave ID',
       '',
       'ID_IPF',
       '' FROM DUAL
UNION ALL
SELECT 'IPF ',
       '01',
       20,
       14,
       'ID_TPF',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'ID Preos Fornecedor',
       'ID Preos Fornecedor',
       '',
       'ID_TPF',
       '' FROM DUAL
UNION ALL
SELECT 'IPF ',
       '99',
       230,
       1,
       'IGNDES',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ignora Desconto?',
       'Ignora Desconto da Tabela?',
       '',
       'IGNDES',
       '' FROM DUAL
UNION ALL
SELECT 'IPF ',
       '99',
       130,
       1,
       'IPIINC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'IPI Incluso?',
       'IPI Incluso?',
       '',
       'IPIINC',
       '' FROM DUAL
UNION ALL
SELECT 'IPF ',
       '02',
       100,
       6,
       'PEREMB',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% da Embalagem',
       '% da Embalagem',
       '',
       'PEREMB',
       '' FROM DUAL
UNION ALL
SELECT 'IPF ',
       '02',
       90,
       6,
       'PERFRE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% do Frete',
       '% do Frete',
       '',
       'PERFRE',
       '' FROM DUAL
UNION ALL
SELECT 'IPF ',
       '02',
       30,
       6,
       'VLRDES_01',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Desconto 1',
       'Valor Desconto 1',
       '',
       'VLRDES_01',
       '' FROM DUAL
UNION ALL
SELECT 'IPF ',
       '02',
       40,
       6,
       'VLRDES_02',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Desconto 2',
       'Valor Desconto 2',
       '',
       'VLRDES_02',
       '' FROM DUAL
UNION ALL
SELECT 'IPF ',
       '02',
       50,
       6,
       'VLRDES_03',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Desconto 3',
       'Valor Desconto 3',
       '',
       'VLRDES_03',
       '' FROM DUAL
UNION ALL
SELECT 'IPF ',
       '02',
       60,
       6,
       'VLRDES_04',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Desconto 4',
       'Valor Desconto 4',
       '',
       'VLRDES_04',
       '' FROM DUAL
UNION ALL
SELECT 'IPF ',
       '02',
       70,
       6,
       'VLRDES_05',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Desconto 5',
       'Valor Desconto 5',
       '',
       'VLRDES_05',
       '' FROM DUAL
UNION ALL
SELECT 'IPF ',
       '02',
       80,
       6,
       'VLRDES_06',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Desconto 6',
       'Valor Desconto 6',
       '',
       'VLRDES_06',
       '' FROM DUAL
UNION ALL
SELECT 'IPF ',
       '02',
       190,
       6,
       'VLRDES_CALC',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Vlr Desc. Calculado',
       'Valor Desconto Calculado',
       '',
       'VLRDES_CALC',
       '' FROM DUAL
UNION ALL
SELECT 'IPF ',
       '02',
       120,
       12,
       'VLREMB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor da Embalagem',
       'Valor da Embalagem',
       '',
       'VLREMB',
       '' FROM DUAL
UNION ALL
SELECT 'IPF ',
       '02',
       220,
       12,
       'VLRFIN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Final do Item',
       'Valor Final do Item (Com acrscimo)',
       '',
       'VLRFIN',
       '' FROM DUAL
UNION ALL
SELECT 'IPF ',
       '02',
       110,
       12,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor do Frete',
       'Valor do Frete',
       '',
       'VLRFRE',
       '' FROM DUAL
UNION ALL
SELECT 'IPF ',
       '02',
       200,
       12,
       'VLRITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor do Item',
       'Valor do Item',
       '',
       'VLRITE',
       '' FROM DUAL
UNION ALL
SELECT 'IPF ',
       '02',
       210,
       12,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Lquido Item',
       'Valor Lquido Item (Sem Acrscimo)',
       '',
       'VLRLIQ',
       '' FROM DUAL
);

/*-- SEQ 8312 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IPR2',
       TO_NUMBER(null),
       'IPR2',
       'Itens de Produtos (p/ Embalagens)',
       'TV_IPR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'IPR2.FILMAT,IPR2.CODMAT,IPR2.CODCOR,IPR2.CODTAM',
       '' FROM DUAL
);

/*-- SEQ 8313 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IPR2','--','' FROM DUAL
UNION ALL
SELECT 'IPR2','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IPR2','02','Valores' FROM DUAL
UNION ALL
SELECT 'IPR2','03','Datas' FROM DUAL
UNION ALL
SELECT 'IPR2','04','Sugesto de Compra' FROM DUAL
UNION ALL
SELECT 'IPR2','05','Saldo da Filial' FROM DUAL
UNION ALL
SELECT 'IPR2','06','Valor Total de Compra' FROM DUAL
UNION ALL
SELECT 'IPR2','07','Valor Total de Reposio' FROM DUAL
UNION ALL
SELECT 'IPR2','08','Pedido Pendente' FROM DUAL
UNION ALL
SELECT 'IPR2','09','Saldo no Periodo' FROM DUAL
UNION ALL
SELECT 'IPR2','10','Valor de Venda do Produto' FROM DUAL
UNION ALL
SELECT 'IPR2','11','Data Custo Reposio' FROM DUAL
UNION ALL
SELECT 'IPR2','12','Giro de Estoque' FROM DUAL
UNION ALL
SELECT 'IPR2','13','Dias Sem Estoque' FROM DUAL
UNION ALL
SELECT 'IPR2','14','Dias Com Estoque' FROM DUAL
UNION ALL
SELECT 'IPR2','15','Dias Estoque Negativo' FROM DUAL
UNION ALL
SELECT 'IPR2','16','Saldo 2 da Filial' FROM DUAL
UNION ALL
SELECT 'IPR2','17','Saldo 3 da Filial' FROM DUAL
UNION ALL
SELECT 'IPR2','18','Saldo 4 da Filial' FROM DUAL
UNION ALL
SELECT 'IPR2','99','Outros' FROM DUAL
);

/*-- SEQ 8314 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22775,
       'CES ',
       'IPR2',
       '01',
       '0N',
       '',
       '',
       'CES.CODCES(+) = IPR2.CODCES',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22776,
       'ANP ',
       'IPR2',
       '1',
       'N',
       '',
       '',
       'ANP.CODANP = IPR2.CODANP',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22777,
       'NCM ',
       'IPR2',
       '1',
       'N',
       '',
       '',
       'NCM.CODNCM = IPR2.CODNCM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22778,
       'CUS ',
       'IPR2',
       '01',
       '01',
       '',
       '',
       'CUS.CODFIL = IPR2.FILMAT AND
CUS.SEQUEN = IPR2.SEQUEN ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22779,
       'MAR ',
       'IPR2',
       '01',
       'N',
       '',
       '',
       'MAR.FILPAR(+) = IPR2.FILMAR and
MAR.CODPAR(+) = IPR2.CODMAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22780,
       'GRA ',
       'IPR2',
       '1',
       'N',
       '',
       '',
       'GRA.FILMAT = IPR2.FILMAT AND
GRA.CODMAT = IPR2.CODMAT AND
GRA.CODCOR = IPR2.CODCOR AND
GRA.CODTAM = IPR2.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22781,
       'TMAR',
       'IPR2',
       '01',
       'N',
       '',
       '',
       'TMAR.FILMAR(+) = IPR2.FILMAR and
TMAR.CODMAR(+) = IPR2.CODMAR and
TMAR.ITEMAR(+) = IPR2.ITEMAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22782,
       'PXF ',
       'IPR2',
       'N',
       '1',
       '',
       '',
       'PXF.FILMAT = IPR2.FILMAT and
PXF.CODMAT = IPR2.CODMAT and
PXF.CODCOR = IPR2.CODCOR and
PXF.CODTAM = IPR2.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22783,
       'PRE ',
       'IPR2',
       'N',
       'N',
       '',
       '',
       'PRE.FILMAT = IPR2.FILMAT and
PRE.CODMAT = IPR2.CODMAT and
PRE.CODCOR = IPR2.CODCOR and
PRE.CODTAM = IPR2.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23816,
       'VCRG',
       'IPR2',
       '1',
       '1',
       '',
       '',
       'VCRG.FILMAT = IPR2.FILMAT AND
VCRG.CODMAT = IPR2.CODMAT AND
VCRG.CODCOR = IPR2.CODCOR AND
VCRG.CODTAM = IPR2.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23817,
       'VMIV',
       'IPR2',
       '01',
       '1',
       '',
       '',
       'IPR2.FILMAT = VMIV.FILMAT AND
IPR2.CODMAT = VMIV.CODMAT AND
IPR2.CODCOR = VMIV.CODCOR AND
IPR2.CODTAM = VMIV.CODTAM
',
       '',
       '' FROM DUAL
);

/*-- SEQ 8315 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IPR2',
       '09',
       2220,
       8,
       ':GRA.SALDOPERIODO_DATINI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Perodo',
       'Perodo',
       '',
       ':IPR2.SALDOPERIODO_DATINI,IPR2.SALDOPERIODO.DATFIM',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '11',
       2270,
       3,
       ':IPR2.CODFILCRD',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'IPR2.:IPR2.CODFILCRD=DFIL.CODFIL',
       ':IPR2.CODFILCRD',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '12',
       2310,
       3,
       ':IPR2.CODFILGIR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial Giro',
       'Filial Giro',
       ':IPR2.CODFIL = DFIL.CODFIL(+)',
       ':IPR2.CODFILGIR',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '04',
       2070,
       3,
       ':IPR2.CODFILLOC',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial Locao',
       'Filial Locao',
       ':IPR2.CODFILLOC = DFIL.CODFIL(+)',
       ':IPR2.CODFILLOC',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '08',
       2190,
       3,
       ':IPR2.CODFILPP',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial PP',
       'Filial PP',
       'IPR2.:IPR2.CODFILPP = DFIL.CODFIL',
       ':IPR2.CODFILPP',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '05',
       2110,
       3,
       ':IPR2.CODFILSDF',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial SDF',
       'Filial SDF',
       'IPR2.:IPR2.CODFILSDF = DFIL.CODFIL(+)',
       ':IPR2.CODFILSDF',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '16',
       3222,
       3,
       ':IPR2.CODFILSDF2',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial SDF',
       'Filial SDF',
       'IPR2.:IPR2.CODFILSDF = DFIL.CODFIL(+)',
       ':IPR2.CODFILSDF',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '17',
       3232,
       3,
       ':IPR2.CODFILSDF3',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial SDF',
       'Filial SDF',
       'IPR2.:IPR2.CODFILSDF = DFIL.CODFIL(+)',
       ':IPR2.CODFILSDF',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '18',
       3242,
       3,
       ':IPR2.CODFILSDF4',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial SDF',
       'Filial SDF',
       'IPR2.:IPR2.CODFILSDF = DFIL.CODFIL(+)',
       ':IPR2.CODFILSDF',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '06',
       2140,
       3,
       ':IPR2.CODFILVTC',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial VTC',
       'Filial VTC',
       'IPR2.:IPR2.CODFILVTC = DFIL.CODFIL(+)',
       ':IPR2.CODFILVTC',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '07',
       2170,
       3,
       ':IPR2.CODFILVTR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial VTR',
       'Filial VTR',
       'IPR2.:IPR2.CODFILVTR = DFIL.CODFIL(+)',
       ':IPR2.CODFILVTR',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '16',
       3223,
       30,
       ':IPR2.CODMUL2',
       'A',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       '',
       'Mltiplo Estoque',
       'Mltiplo Estoque',
       'IPR2.:IPR2.CODMUL2 = DMUL.CODTAB(+)',
       ':IPR2.CODMUL2',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '17',
       3233,
       30,
       ':IPR2.CODMUL3',
       'A',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       '',
       'Mltiplo Estoque',
       'Mltiplo Estoque',
       'IPR2.:IPR2.CODMUL2 = DMUL.CODTAB(+)',
       ':IPR2.CODMUL3',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '18',
       3243,
       30,
       ':IPR2.CODMUL4',
       'A',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       '',
       'Mltiplo Estoque',
       'Mltiplo Estoque',
       'IPR2.:IPR2.CODMUL2 = DMUL.CODTAB(+)',
       ':IPR2.CODMUL4',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '11',
       2280,
       5,
       ':IPR2.CODMULCRD',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       '9',
       '',
       'Cd.Mltiplo Estoque',
       'Cdigo Mltiplo Estoque',
       'IPR2.:IPR2.CODMULCRD = DMUL.CODTAB',
       ':IPR2.CODMULCRD',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '14',
       2360,
       8,
       ':IPR2.COM_DATINI,IPR2.COM_DATF',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Datas com Estoque',
       'Datas com Estoque',
       '',
       ':IPR2.COM_DATINI,IPR2.COM_DATFIM',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '04',
       2050,
       8,
       ':IPR2.DAT01,IPR2.DAT02',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data',
       'Data',
       '',
       ':IPR2.DAT01,IPR2.DAT02',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '04',
       2060,
       8,
       ':IPR2.DATATE',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Manter At',
       'Manter At',
       '',
       ':IPR2.DATATE',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '12',
       2300,
       8,
       ':IPR2.DATINI,IPR2.DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data',
       'Data',
       '',
       ':IPR2.DATINI,IPR2.DATFIM',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '11',
       2260,
       8,
       ':IPR2.DATREFCRD',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Referncia',
       'Data Referncia',
       '',
       ':IPR2.DATREFCRD',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '05',
       2100,
       8,
       ':IPR2.DATREFSDF',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Referncia',
       'Data Referncia',
       '',
       ':IPR2.DATREFSDF',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '16',
       3221,
       8,
       ':IPR2.DATREFSDF2',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Referncia',
       'Data Referncia',
       '',
       ':IPR2.DATREFSDF',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '17',
       3231,
       8,
       ':IPR2.DATREFSDF3',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Referncia',
       'Data Referncia',
       '',
       ':IPR2.DATREFSDF',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '18',
       3241,
       8,
       ':IPR2.DATREFSDF4',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Referncia',
       'Data Referncia',
       '',
       ':IPR2.DATREFSDF',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '06',
       2130,
       8,
       ':IPR2.DATREFVTC',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Referncia',
       'Data Referncia',
       '',
       ':IPR2.DATREFVTC',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '07',
       2160,
       8,
       ':IPR2.DATREFVTR',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data VTR',
       'Data VTR',
       '',
       ':IPR2.DATREFVTR',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '14',
       2370,
       3,
       ':IPR2.FILIAL_COM_ESTOQUE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial com Estoque',
       'Filial com Estoque',
       ':IPR2.FILIAL_COM_ESTOQUE = DFIL.CODFIL(+)',
       ':IPR2.FILIAL_COM_ESTOQUE',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '15',
       3000,
       3,
       ':IPR2.FILIAL_NEG_ESTOQUE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial Estoque Neg.',
       'Filial Estoque Negativo',
       'IPR2.:IPR2.FILIAL_NEG_ESTOQUE = DFIL.CODFIL(+)',
       ':IPR2.FILIAL_NEG_ESTOQUE',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '13',
       2340,
       3,
       ':IPR2.FILIAL_SEM_ESTOQUE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial Sem Estoque',
       'Filial Sem Estoque',
       ':IPR2.FILIAL_SEM_ESTOQUE = DFIL.CODFIL(+)',
       ':IPR2.FILIAL_SEM_ESTOQUE',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '15',
       2390,
       8,
       ':IPR2.NEG_DATINI,IPR2.NEG_DATF',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Datas Estoque Neg.',
       'Datas Estoque Negativo',
       '',
       ':IPR2.NEG_DATINI,IPR2.NEG_DATFIM',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '13',
       2330,
       8,
       ':IPR2.SEM_DATINI,IPR2.SEM_DATF',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Sem Estoque',
       'Data Sem Estoque',
       '',
       ':IPR2.SEM_DATINI,IPR2.SEM_DATFIM',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '04',
       2040,
       1,
       ':IPR2.TIPPRJ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Tipo de Projeo',
       'Tipo de Projeo',
       '',
       ':IPR2.TIPPRJ',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '10',
       2240,
       8,
       ':IPR2.VLRVENDATINI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Perodo',
       'Perodo',
       '',
       ':IPR2.VLRVENDATINI,IPR2.VLRVENDATFIM',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       940,
       5,
       'AFICUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Acrscimo Financeiro',
       'Acrscimo Financeiro para Formao do Preo de venda',
       '',
       'AFICUS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       3010,
       1,
       'ARRTRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Arrentonda ou Trunca',
       'Arrentonda ou Trunca?',
       '',
       'ARRTRU',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       681,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN IPR2.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '03',
       950,
       7,
       'ATUGRA',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Atu. da Grade',
       'Data de Atualizao do Item de Grade',
       '',
       'ATUGRA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '03',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       870,
       1,
       'BALSIM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Utiliza Balana?',
       'Utiliza Balana?',
       '',
       'BALSIM',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       20,
       2,
       'BRINDE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Brinde',
       'Brinde',
       '',
       'BRINDE',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       30,
       2,
       'CLASS1',
       'S',
       'DCL1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL1.CLASS1',
       'V',
       '',
       'F',
       'A',
       'F',
       'Catergoria',
       'Classificao 1',
       'IPR2.CLASS1=DCL1.CODTAB (+)',
       'CLASS1',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       40,
       2,
       'CLASS2',
       'S',
       'DCL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL2.CLASS2',
       'V',
       '',
       'F',
       'A',
       'F',
       'SubCategoria',
       'Classificao 2',
       'IPR2.CLASS2=DCL2.CODTAB (+)',
       'CLASS2',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       50,
       2,
       'CLASS3',
       'S',
       'DCL3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL3.CLASS3',
       'V',
       '',
       'F',
       'A',
       'F',
       'Familia',
       'Classificao 3',
       'IPR2.CLASS3=DCL3.CODTAB (+)',
       'CLASS3',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       60,
       2,
       'CLASS4',
       'S',
       'DCL4',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL4.CLASS4',
       'V',
       '',
       'F',
       'A',
       'F',
       'SubFamilia',
       'Classificao 4',
       'IPR2.CLASS4=DCL4.CODTAB (+)',
       'CLASS4',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       71,
       5,
       'CLSABC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Classe ABC',
       'Classe ABC',
       '',
       'CLSABC',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       70,
       5,
       'CLSXYZ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Classe XYZ',
       'Classe XYZ',
       '',
       'CLSXYZ',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       3080,
       9,
       'CODANP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Cdigo na ANP',
       'Cdigo na ANP',
       '',
       'CODANP',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       4360,
       7,
       'CODCES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'CEST',
       'CEST',
       '',
       'CODCES',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       80,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Divisao Material',
       'IPR2.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       1060,
       5,
       'CODCTR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       '',
       '',
       '',
       'CODCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       90,
       5,
       'CODDIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Diviso',
       'Cdigo Diviso',
       '',
       'CODDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       4370,
       3,
       'CODENQ',
       'S',
       'ENQ ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'ENQ.DESENQ',
       'V',
       '',
       '',
       'N',
       '',
       'Cd Enquad IPI',
       'Cdigo de Enquadramento Legal do IPI',
       'ENQ.CODENQ(+) = IPR2.CODENQ',
       'CODENQ',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       880,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo do Produto',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       4260,
       60,
       'CODFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Codigo Fiscal',
       'Cdigo Fiscal',
       '',
       'CODFIS',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       3910,
       2,
       'CODFPS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODFPS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       3260,
       2,
       'CODFPS ',
       'A',
       'DFPS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFPS.DESFPS',
       'V',
       '',
       '',
       'A',
       '',
       'Finalidade',
       'Finalidade',
       'DFPS.CODFPS=IPR2.CODFPS(+) ',
       'CODFPS ',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       100,
       2,
       'CODGRA',
       'S',
       'DGRA',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DGRA.NOMGRA',
       'V',
       '',
       'F',
       'A',
       'F',
       'Tipo Grade',
       'Cdigo da grade',
       'IPR2.CODGRA=DGRA.CODTAB (+)',
       'CODGRA',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       4280,
       5,
       'CODIMG',
       'G',
       'DIMG',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIMG.DESIMG',
       'V',
       '',
       '',
       'N',
       '',
       'Cdigo imagem grupo',
       'Cdigo da imagem do grupo',
       'DIMG.CODTAB = IPR2.CODIMG',
       'CODIMG',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       890,
       5,
       'CODLPC',
       'S',
       'DLPC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DLPC.DESLPC',
       'V',
       '',
       '',
       'N',
       'F',
       'Lista de Controlados',
       'Lista de Produto Controlado a qual o produto pertence',
       'DLPC.CODTAB = PRO.CODLPC',
       'CODLPC',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       110,
       6,
       'CODMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo da marca',
       'Cdigo da Marca deste produto',
       '',
       'CODMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       120,
       5,
       'CODMAT',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo material',
       'IPR2.CODTAM=SUB.CODITE (+)',
       'CODMAT',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       3110,
       8,
       'CODNCM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo NCM',
       'Cdigo NCM',
       '',
       'CODNCM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       4450,
       40,
       'CODPOS_GRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo POS CONTROLE',
       'Cdigo POS CONTROLE',
       '',
       'CODPOS_GRA',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       3920,
       5,
       'CODRGC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODRGC',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       130,
       5,
       'CODSAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cd. Saldo Unificado',
       'Cdigo Saldo Unificado no item',
       '',
       'CODSAL',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       140,
       2,
       'CODSAZ',
       'S',
       'DSAZ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSAZ.DESSAZ',
       'V',
       '',
       'F',
       'A',
       'F',
       'Sazonalidade',
       'Cdigo da sazonalidade',
       'IPR2.CODSAZ=DSAZ.CODTAB (+)',
       'CODSAZ',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       3930,
       4,
       'CODSRV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODSRV',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       150,
       5,
       'CODSUB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Sub-Diviso',
       'Cdigo Sub-Diviso',
       '',
       'CODSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       160,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso Material',
       'IPR2.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       170,
       2,
       'CODTRI',
       'S',
       'DTRI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DTRI.CODTRI',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo~Tributao',
       'Cdigo de tributao',
       'IPR2.CODTRI=DTRI.CODTAB (+)',
       'CODTRI',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       3090,
       3,
       'COD_EX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cd. de Exceo IPI',
       'Cdigo de Exceo do IPI',
       '',
       'COD_EX',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       180,
       10,
       'CONAPL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Conv. Emb. Aplicao',
       'Converso Aplicao e Embalagem',
       '',
       'CONAPL',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       4330,
       1,
       'CONFER',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Conferir na venda?',
       'Conferir na venda?',
       '',
       'CONFER',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       190,
       1,
       'CONTRA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Produto Contratado?',
       'Determina se produto  do tipo contrato',
       '',
       'CONTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       200,
       1,
       'CONTRO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Produto Controlado?',
       'Produtos Controlados',
       '',
       'CONTRO',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       210,
       16,
       'CUSFRE',
       'F',
       '',
       6,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Custo Frete',
       'Custo Frete',
       '',
       'CUSFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       220,
       14,
       'CUSREP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Custo Reposio',
       'Custo Reposicao',
       '',
       'CUSREP',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '11',
       2250,
       12,
       'CUSTOREPOSICAODATA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Custo Reposio/Data',
       'Custo Reposio/Data',
       '',
       'CUSTOREPOSICAODATA(:IPR2.DATREFCRD,IPR2.FILMAT,IPR2.CODMAT,IPR2.CODCOR,IPR2.CODTAM,:IPR2.CODFILCRD,:IPR2.CODMULCRD)',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       960,
       5,
       'DACCUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Desc/Acrscimo',
       'Desconto/Acrscimo para a Formao do Preo de Venda',
       '',
       'DACCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '03',
       230,
       7,
       'DATCAD',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Cadastro',
       'Data Cadastro',
       '',
       'DATCAD',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '03',
       240,
       7,
       'DATCOM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Compra',
       'Data Compra',
       '',
       'DATCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       250,
       1,
       'DECIMA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Usa Decimais?',
       'Usa Decimais?',
       '',
       'DECIMA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       810,
       5,
       'DEPART',
       'S',
       'DDEP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDEP.DESDEP',
       'V',
       '',
       '',
       'A',
       'F',
       'Departamento',
       'Departamento',
       'DDEP.CODTAB(+) = IPR2.DEPART',
       'DEPART',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       4250,
       40,
       'DESCLA',
       'A',
       'CLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'CLA.DESCLA',
       'V',
       '',
       '',
       'A',
       '',
       'Classificao',
       'Descrio da classificao',
       'IPR2.FILCLA = CLA.CODFIL(+) AND IPR2.SEQCLA = CLA.SEQUEN(+)',
       'DESCLA',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       4470,
       4000,
       'DESDET',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Desc. Detalhe HTML',
       'Descrio Detalhe (em HTML)',
       '',
       'DESDET',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       270,
       15,
       'DESECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao ECF',
       'Descrio ECF',
       '',
       'DESECF',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       3940,
       5,
       'DESFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       311,
       120,
       'DESGRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio da Grade',
       'Descrio da Grade',
       '',
       'DESGRA',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       280,
       12,
       'DESIDE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Desconto~Sugerido',
       'Desconto Sugerido',
       '',
       'DESIDE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       290,
       30,
       'DESMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio~Material',
       'Descrio Material',
       '',
       'DESMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       300,
       12,
       'DESMAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Desconto~Mximo',
       'Desconto Maximo',
       '',
       'DESMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       1090,
       20,
       'DESMED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio da Medida',
       'Descrio da Medida',
       '',
       'DESMED',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       3950,
       20,
       'DESMEDAPL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESMEDAPL',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       3960,
       20,
       'DESMEDEMB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESMEDEMB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       3970,
       20,
       'DESMEDFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESMEDFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       3980,
       20,
       'DESMEDUNI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESMEDUNI',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       4460,
       254,
       'DESWEB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio e-Commerce',
       'Descrio para e-Commerce',
       '',
       'DESWEB',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '14',
       2350,
       12,
       'DIASDEESTOQUE_COM_ESTOQUE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Dias com Estoque',
       'Dias com Estoque',
       '',
       'DIASDEESTOQUE(''C'', :IPR2.COM_DATINI, :IPR2.COM_DATFIM, IPR2.FILMAT, IPR2.CODMAT, IPR2.CODCOR, IPR2.CODTAM, :IPR2.FILIAL_COM_ESTOQUE, 0)',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '15',
       2380,
       12,
       'DIASDEESTOQUE_NEGATIVO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'DiasEstoque Negativo',
       'Dias Estoque Negativo',
       '',
       'DIASDEESTOQUE(''-'', :IPR2.NEG_DATINI, :IPR2.NEG_DATFIM, IPR2.FILMAT, IPR2.CODMAT, IPR2.CODCOR, IPR2.CODTAM, :IPR2.FILIAL_NEG_ESTOQUE, 0)',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '13',
       2320,
       12,
       'DIASDEESTOQUE_SEM_ESTOQUE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Dias Sem Estoque',
       'Dias Sem Estoque',
       '',
       'DIASDEESTOQUE(''S'', :IPR2.SEM_DATINI, :IPR2.SEM_DATFIM, IPR2.FILMAT, IPR2.CODMAT, IPR2.CODCOR, IPR2.CODTAM, :IPR2.FILIAL_SEM_ESTOQUE, 0)',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       310,
       30,
       'ESPMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Especificao',
       'Especificao Material',
       '',
       'ESPMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       4350,
       1,
       'ESTCHE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Estoque no CK4G',
       'Controle de Estoque no Checkout 4G',
       '',
       'ESTCHE',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       3210,
       2,
       'ETIQUE',
       'S',
       'DETI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DETI.DESETI',
       'V',
       '',
       '',
       'A',
       '',
       'Etiqueta',
       'Tipo de etiqueta',
       'IPR2.ETIQUE=DETI.CODTAB (+)',
       'ETIQUE',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       330,
       14,
       'FATCON',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Fator Converso',
       'Fator de converso entre as divises',
       '',
       'FATCON',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       900,
       3,
       'FILCLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILCLA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       3990,
       3,
       'FILCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       340,
       3,
       'FILMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Marca do material',
       '',
       'FILMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       350,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       4000,
       3,
       'FILRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial de reserva',
       'Filial de reserva padro para o produto',
       '',
       'FILRES',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       970,
       1,
       'FLGSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FLGSER',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       4410,
       1,
       'FOR060',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'CST60 emp substituta',
       'Forar substitudo (60) mesmo para empresa substituta',
       '',
       'FOR060',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       770,
       1,
       'FORLIN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Fora de Linha?',
       'Fora de Linha',
       '',
       'FORLIN',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       4280,
       1,
       'GRAABC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'ABC Calculado',
       'ABC Calculado na Grade',
       '',
       'GRAABC',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       980,
       1,
       'GRAATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'F',
       'Ativo?',
       'Item de Grade Ativo?',
       '',
       'GRAATI',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       4290,
       1,
       'GRAXYZ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'XYZ Calculado',
       'XYZ Calculado na Grade',
       '',
       'GRAXYZ',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       4010,
       256,
       'GRA_ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'GRA_ASSINA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       4300,
       12,
       'GRA_CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'GRA_CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '12',
       2290,
       12,
       'GiroEstoque',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       '',
       'Giro de Estoque',
       'Giro de Estoque',
       '',
       'GiroEstoque(:IPR2.DATINI,:IPR2.DATFIM,IPR2.FILMAT,IPR2.CODMAT,IPR2.CODCOR,IPR2.CODTAM,:IPR2.CODFILGIR)',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       830,
       14,
       'ICMCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'ICMS Compra',
       'ICMS Compra',
       '',
       'ICMCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       990,
       14,
       'ICMCUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '% ICMS p/ Preo',
       '% de ICMS para Formao do Preo de Venda',
       '',
       'ICMCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       4030,
       1,
       'ICMFED',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ICMFED',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       1000,
       1,
       'ICMTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Tributao',
       'Tipo de Tributao para Formao do Preo de Venda',
       '',
       'ICMTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       3070,
       1,
       'IIPTPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Produo Prp ou Ter',
       'Produo Prpria ou de Terceiro?',
       '',
       'IIPTPR',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       4300,
       255,
       'IMGGRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome da imagem',
       'Nome da imagem',
       '',
       'IMGGRU',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       3250,
       1,
       'IMPKIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Imp. Itens Kit NF?',
       'Imprimir Itens de Kit na NF/CF?',
       '',
       'IMPKIT',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       840,
       14,
       'IPICOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'IPI Compra',
       'IPI Compra',
       '',
       'IPICOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       1010,
       14,
       'IPICUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '% IPI Compra',
       '% IPI da Compra',
       '',
       'IPICUS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       4040,
       1,
       'ISEPIS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ISEPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       850,
       5,
       'ITECOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Item Compra',
       '',
       '',
       'ITECOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       360,
       10,
       'ITEDIV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Item Diviso',
       'Item Diviso',
       '',
       'ITEDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       800,
       4,
       'ITEMAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Itens de Marca',
       'Itens de Marca',
       '',
       'ITEMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       370,
       10,
       'ITESUB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Item SubDiviso',
       'Item SubDiviso',
       '',
       'ITESUB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       380,
       10,
       'LOCALI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Localizao',
       'Localizacao',
       '',
       'LOCALI',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       3480,
       30,
       'MARCA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Marca',
       'Descrio da Marca',
       '',
       'MARCA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       4440,
       3,
       'MAXPAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Mximo de parcelas',
       'Nmero mximo de parcelas na venda',
       '',
       'MAXPAR',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       390,
       2,
       'MEDAPL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Medida Aplicao',
       'Medida Aplicao',
       '',
       'MEDAPL',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       400,
       2,
       'MEDEMB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Medida Embalagem',
       'Medida Embalagem',
       '',
       'MEDEMB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       410,
       2,
       'MEDFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Medida Fornecedor',
       'Medida Fornecedor',
       '',
       'MEDFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       420,
       2,
       'MEDUNI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Medida Unidade',
       'Medida Unidade',
       '',
       'MEDUNI',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       430,
       12,
       'MINQTD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Estoque ~Mnimo',
       'Estoque Minimo',
       '',
       'MINQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       440,
       1,
       'MONTAR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Montagem?',
       'Aceita montagem',
       '',
       'MONTAR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       4270,
       14,
       'MVACOM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% MVA',
       '% MVA',
       '',
       'MVACOM',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       4050,
       2,
       'NATBCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATBCC',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       450,
       20,
       'NOMDIV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Diviso',
       'Nome Diviso',
       '',
       'NOMDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       460,
       255,
       'NOMIMG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Arquivo Imagem',
       'Nome Arquivo de Imagem',
       '',
       'NOMIMG',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       3180,
       4000,
       'NOMNCM',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio NCM',
       'Descrio NCM',
       '',
       'RTF2TXT(NOMNCM)',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       470,
       83,
       'NOMPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Produto',
       'Nome Produto',
       '',
       'NOMPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       480,
       20,
       'NOMSUB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Subdiviso',
       'Nome Subdiviso',
       '',
       'NOMSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       490,
       1,
       'NUMEXT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Numero Externo?',
       'Nmero externo na Ordem de Servio',
       '',
       'NUMEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       500,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Num. Itens do Kit',
       'Nmero de itens de um kit',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       4320,
       1,
       'OBIMEI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Obriga IMEI?',
       'Obriga IMEI no Servio Adicional?',
       '',
       'OBIMEI',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       510,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(IPR2.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       4060,
       4000,
       'OBSGRA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'OBSGRA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       4070,
       254,
       'OBSMPB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'OBSMPB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       520,
       5,
       'ORDDIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ordem Diviso',
       'Ordem Diviso',
       '',
       'ORDDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       530,
       5,
       'ORDSUB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ordem Sub-Diviso',
       'Ordem Sub-Diviso',
       '',
       'ORDSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       1020,
       1,
       'ORICUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem dos Custos',
       'Origem da Atualizao dos Custos',
       '',
       'ORICUS',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       3350,
       1,
       'ORIPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem do Produto',
       'Origem do Produto',
       '',
       'ORIPRO',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       1030,
       12,
       'OUTCUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Outros Custos',
       'Outros Custos',
       '',
       'OUTCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '08',
       2180,
       12,
       'PEDIDOPENDENTE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Pedidos Pendentes',
       'Traz a quantidade pendente de pedidos nao recebidos',
       '',
       'PEDIDOPENDENTE(:IPR2.CODFILPP,IPR2.FILMAT,IPR2.CODMAT,IPR2.CODCOR,IPR2.CODTAM)',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       540,
       12,
       'PERCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Comisso',
       'Percentual Comisso',
       '',
       'PERCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       3900,
       5,
       'PERIND',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '% Comisso Indicador',
       '% Comisso para Indicador',
       '',
       'PERIND',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       4420,
       8,
       'PERIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% IPI',
       'Alquota do IPI',
       '',
       'PERIPI',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       4430,
       8,
       'PERIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% IRR',
       'Alquota do Imposto de Renda',
       '',
       'PERIRR',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       550,
       12,
       'PERLUC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% de Lucro',
       '% de Lucro',
       '',
       'PERLUC',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       910,
       5,
       'PERSER',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PERSER',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       4400,
       5,
       'PER_II',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Imposto Importao',
       '% de Imposto sobre Importao',
       '',
       'PER_II',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       560,
       14,
       'PESBRU',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Peso~Bruto',
       'Peso Bruto',
       '',
       'PESBRU',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       570,
       14,
       'PESLIQ',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Peso~Lquido',
       'Peso Liquido',
       '',
       'PESLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       580,
       14,
       'PRECOM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Preco~Compra',
       'Preo Compra',
       '',
       'PRECOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       780,
       8,
       'PRECOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Preo de venda',
       'Preo de venda',
       '',
       'PRECOV',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       3370,
       14,
       'PREFIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Preo Fiscal',
       'Preo Fiscal (Mximo, Sugesto ou Pauta)',
       '',
       'PREFIS',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       1040,
       1,
       'PREPSI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PREPSI',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       590,
       1,
       'PROMOC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Promoo?',
       'Indica se produto  promocional',
       '',
       'PROMOC',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       4080,
       256,
       'PRO_ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRO_ASSINA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       4310,
       12,
       'PRO_CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRO_CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       600,
       12,
       'PTOQTD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Pto. Pedido',
       'Ponto de pedido',
       '',
       'PTOQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       4100,
       12,
       'QTDBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'QTDBON',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       790,
       12,
       'QTDCOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Quantidade Compra',
       'Quantidade Compra',
       '',
       'QTDCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       610,
       10,
       'QTDEMB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Contedo Embalagem',
       'Contedo da Embalagem',
       '',
       'QTDEMB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       4110,
       7,
       'QTDMUL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'QTDMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       620,
       12,
       'QTDREP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde Reposico',
       'Quantidade ideal de reposiao',
       '',
       'QTDREP',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       630,
       15,
       'REFBAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. Bsica',
       'Referncia Bsica',
       '',
       'REFBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       640,
       20,
       'REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. Produto',
       'Referncia do Produto',
       '',
       'REFPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       1100,
       20,
       'REFVEN_EAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Referencia de Venda',
       'Referencia de Venda',
       '',
       '(SELECT min(IEAN.CODEAN) FROM TT_EAN IEAN WHERE IEAN.FILMAT=IPR2.FILMAT AND IEAN.CODMAT=IPR2.CODMAT AND IEAN.CODCOR=IPR2.CODCOR AND IEAN.CODTAM=IPR2.CODTAM)',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       650,
       5,
       'RESIPI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'IPI',
       'Cdigo do IPI',
       '',
       'RESIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       660,
       5,
       'RESIRR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'IRR',
       'Cdigo do Imposto de Renda',
       '',
       'RESIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       820,
       1,
       'RETCOF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Reteno de COFINS?',
       'Permite Reteno de COFINS?',
       '',
       'RETCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '16',
       3220,
       8,
       'SALDO2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo 2 da Filial',
       'Saldo 2 da Filial',
       '',
       'SaldoDaFilial(:IPR2.DATREFSDF,IPR2.FILMAT,IPR2.CODMAT,IPR2.CODCOR,IPR2.CODTAM,:IPR2.CODFILSDF,:IPR2.CODMUL2)',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '17',
       3230,
       8,
       'SALDO3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo 3 da Filial',
       'Saldo 3 da Filial',
       '',
       'SaldoDaFilial(:IPR2.DATREFSDF,IPR2.FILMAT,IPR2.CODMAT,IPR2.CODCOR,IPR2.CODTAM,:IPR2.CODFILSDF,:IPR2.CODMUL3)',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '18',
       3240,
       8,
       'SALDO4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo 4 da Filial',
       'Saldo 4 da Filial',
       '',
       'SaldoDaFilial(:IPR2.DATREFSDF,IPR2.FILMAT,IPR2.CODMAT,IPR2.CODCOR,IPR2.CODTAM,:IPR2.CODFILSDF,:IPR2.CODMUL4)',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       2020,
       12,
       'SALDOEMTRANSITO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo em Transito',
       'Saldo em Transito',
       '',
       'SALDOEMTRANSITO(IPR2.FILMAT, IPR2.CODMAT, IPR2.CODCOR,IPR2.CODTAM)',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '09',
       2200,
       12,
       'SALDOPERIODO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Saldo no Perodo',
       'Saldo no Perodo',
       '',
       'SALDOPERIODO(IPR2.FILMAT,IPR2.CODMAT,IPR2.CODCOR,IPR2.CODTAM,:IPR2.SALDOPERIODO_DATINI,:IPR2.SALDOPERIODO.DATFIM)',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '05',
       2080,
       20,
       'SALDO_FILIAL_STRING',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Saldo Filial String',
       'Saldo Filial String',
       '',
       'TO_CHAR(SALDODAFILIAL(:IPR2.DATREFSDF,IPR2.FILMAT,IPR2.CODMAT,IPR2.CODCOR,IPR2.CODTAM,:IPR2.CODFILSDF))',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '09',
       2210,
       20,
       'SALDO_PERIODO_STRING',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Saldo Periodo String',
       'Saldo Periodo String',
       '',
       'TO_CHAR(SALDOPERIODO(IPR2.FILMAT,IPR2.CODMAT,IPR2.CODCOR,IPR2.CODTAM,:IPR2.SALDOPERIODO_DATINI,:IPR2.SALDOPERIODO.DATFIM))',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       920,
       10,
       'SEQCLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQCLA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       860,
       10,
       'SEQCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       670,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       680,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN IPR2.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       3100,
       2,
       'SITCOF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Cd. Sit. Trib. COF',
       'Cdigo de Situao Tributria do COFINS',
       '',
       'SITCOF',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       4230,
       2,
       'SITCOFCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'CST COFINS Compra',
       'Cdigo de Situao Tributria do COFINS para Compra',
       '',
       'SITCOFCOM',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       3200,
       1,
       'SITIPI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Cd. Sit. Trib. IPI',
       'Cdigo de Situao Tributria do IPI',
       '',
       'SITIPI',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       3190,
       2,
       'SITPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Cd. Sit. Trib. PIS',
       'Cdigo de Situao Tributria do PIS',
       '',
       'SITPIS',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       4240,
       2,
       'SITPISCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'CST PIS para Compra',
       'Cdigo de Situao Tributria do PIS para Compra',
       '',
       'SITPISCOM',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       4340,
       1,
       'SUBFED',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Substitudo Federal',
       'Substitudo Federal',
       '',
       'SUBFED',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       4120,
       5,
       'SUBFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SUBFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       930,
       1,
       'SUGSER',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SUGSER',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '05',
       2090,
       8,
       'SaldoDaFilial',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo da Filial',
       'Saldo da Filial',
       '',
       'SaldoDaFilial(:IPR2.DATREFSDF,IPR2.FILMAT,IPR2.CODMAT,IPR2.CODCOR,IPR2.CODTAM,:IPR2.CODFILSDF)',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '04',
       2030,
       12,
       'SugestaoCompra',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Sugesto Compra',
       'Sugesto Compra',
       '',
       'SugestaoCompra(:IPR2.TIPPRJ,:IPR2.DAT01,:IPR2.DAT02,:IPR2.DATATE,IPR2.FILMAT,IPR2.CODMAT,IPR2.CODCOR,IPR2.CODTAM,:IPR2.CODFILLOC)',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       690,
       5,
       'TEMREP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tempo p/~Reposio',
       'Tempo de Reposio',
       '',
       'TEMREP',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       1050,
       254,
       'TERASS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TERASS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       4130,
       1,
       'TIPDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       700,
       1,
       'TIPMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Marca',
       'Tipo Marca',
       '',
       'TIPMAR',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       3500,
       1,
       'TIPMPB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo para MPB',
       'Tipo para Tratamento em MP do Bem',
       '',
       'TIPMPB',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       710,
       2,
       'TIPPRO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Produto',
       'Tipo de produto',
       '',
       'TIPPRO',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       4140,
       1,
       'TIPVAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPVAL',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       2010,
       12,
       'ULTIMO_ICMS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '% ICMS',
       '% ICMS',
       '',
       'RETORNAICMS(IPR2.FILMAT,IPR2.CODMAT,IPR2.CODCOR,IPR2.CODTAM)',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       720,
       5,
       'UNIAPL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Unidade Aplicao',
       'Unidade de Aplicao',
       '',
       'UNIAPL',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       730,
       5,
       'UNIDAD',
       'S',
       'DMED',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMED.UNIMED',
       'V',
       '',
       '',
       'A',
       'F',
       'Unidade Venda',
       'Unidade Venda (medida utilizada  - Kg, l, m, etc.)',
       'DMED.CODTAB = IPR2.UNIDAD',
       'UNIDAD',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       740,
       5,
       'UNIEMB',
       'S',
       'DMED',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMED.UNIMED',
       'V',
       '',
       '',
       'A',
       'F',
       'Uni.Medida Embalagem',
       'Unidade de medida utilizada na embalagem',
       'DMED.CODTAB = IPR2.UNIEMB (+)',
       'UNIEMB',
       'T' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       750,
       5,
       'UNIFOR',
       'S',
       'DMED',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMED.UNIMED',
       'V',
       '',
       '',
       'A',
       'F',
       'Unidade Compra',
       'Unidade Compra (medida utilizada pelo fornecedor)',
       'DMED.CODTAB = IPR2.UNIFOR',
       'UNIFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       4150,
       1,
       'USABON',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'USABON',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       3730,
       1,
       'USALOT',
       'L',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Usa lote',
       'Usa lote?',
       '',
       'USALOT',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       2000,
       1,
       'UsaCodSal',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Controla~Estoque',
       'Controla Estoque',
       '',
       'UsaCodSal(IPR2.CODTAM)',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       760,
       12,
       'VALCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Val Conv. Ven/Com',
       'Valor de converso entre as unidades de Venda/Compra',
       '',
       'VALCON',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '01',
       1080,
       1,
       'VALEST',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Valida Estoque?',
       'Valida Estoque?',
       '',
       'VALEST',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       4160,
       5,
       'VALIDA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VALIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '10',
       2230,
       12,
       'VALORVENDIDO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Valor Vendido',
       'Valor Vendido',
       '',
       'VALORVENDAPRODUTO(:IPR2.VLRVENDATINI,:IPR2.VLRVENDATFIM,IPR2.FILMAT, IPR2.CODMAT, IPR2.CODCOR, IPR2.CODTAM, :IPR2.FILIALVV)',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       4170,
       6,
       'VENCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VENCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       4390,
       6,
       'VENCOFIMP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% COFINS Importao',
       '% COFINS na Importao',
       '',
       'VENCOFIMP',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       4180,
       6,
       'VENPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VENPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '99',
       4380,
       6,
       'VENPISIMP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% PIS Importao',
       '% PIS na Importao',
       '',
       'VENPISIMP',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       4190,
       16,
       'VLRCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VLRCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '--',
       4200,
       16,
       'VLRPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VLRPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '06',
       2120,
       8,
       'VLRTOTCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Valor total Compra',
       'Valor Total da Compra',
       '',
       'SaldoDaFilial(:IPR2.DATREFVTC,IPR2.FILMAT,IPR2.CODMAT,IPR2.CODCOR,IPR2.CODTAM,:IPR2.CODFILVTC)*PRECOM',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '07',
       2150,
       8,
       'VLRTOTREP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Vlr Total Reposio',
       'Valor Total Reposio',
       '',
       'SaldoDaFilial(:IPR2.DATREFVTR,IPR2.FILMAT,IPR2.CODMAT,IPR2.CODCOR,IPR2.CODTAM,:IPR2.CODFILVTR)*CUSREP',
       '' FROM DUAL
UNION ALL
SELECT 'IPR2',
       '02',
       1070,
       15,
       'VOLUME',
       'F',
       '',
       5,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Volume m3',
       'Volume m3',
       '',
       'VOLUME',
       'F' FROM DUAL
);

/*-- SEQ 8316 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IPR2',
       'ARRTRU',
       0,
       'A',
       'Arredondamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'ARRTRU',
       0,
       'T',
       'Truncamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'BRINDE',
       2,
       '-',
       ' Brinde',
       194,
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'BRINDE',
       1,
       '-',
       'Pode ser Brinde',
       193,
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'BRINDE',
       0,
       '-',
       'Nao  Brinde',
       192,
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'CLSABC',
       1,
       ' ',
       'B',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'CLSABC',
       2,
       ' ',
       'C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'CLSABC',
       0,
       ' ',
       'A',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'CLSXYZ',
       2,
       '-',
       'Z',
       191,
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'CLSXYZ',
       1,
       '-',
       'Y',
       190,
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'CLSXYZ',
       0,
       '-',
       'X',
       189,
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'ESTCHE',
       0,
       ' ',
       'S on-line',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'ESTCHE',
       1,
       ' ',
       'Replicado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'ESTCHE',
       9,
       ' ',
       'No controla',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'GRAABC',
       0,
       'A',
       'A',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'GRAABC',
       0,
       'B',
       'B',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'GRAABC',
       0,
       'C',
       'C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'GRAXYZ',
       0,
       'X',
       'X',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'GRAXYZ',
       0,
       'Y',
       'Y',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'GRAXYZ',
       0,
       'Z',
       'Z',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'ICMTIP',
       0,
       '0',
       'Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'ICMTIP',
       0,
       '1',
       'No-Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'ICMTIP',
       0,
       '2',
       'Isento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'ICMTIP',
       0,
       '3',
       'Substitudo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'ICMTIP',
       0,
       '4',
       'Isento no Estado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'IIPTPR',
       0,
       'P',
       'p/ merc manufat pelo prop cont',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'IIPTPR',
       0,
       'T',
       'p/ merc manufat de terceiros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'ORICUS',
       0,
       'C',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'ORICUS',
       0,
       'M',
       'Manual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'ORICUS',
       0,
       'P',
       'Pedido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'ORIPRO',
       0,
       '0',
       'Nacional, exceto cd.3,4,5,8',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'ORIPRO',
       0,
       '1',
       'Estrang., Import.Dir., Exc.6',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'ORIPRO',
       0,
       '2',
       'Estrang., Adq.Int., Exc.7',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'ORIPRO',
       0,
       '3',
       'Nacional, Cont.Import.>40%<70%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'ORIPRO',
       0,
       '4',
       'Nacional, Conf.Proc.Prod.Bs.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'ORIPRO',
       0,
       '5',
       'Nacional, Cont.Import <= 40%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'ORIPRO',
       0,
       '6',
       'Estrang., Import.Dir.CAMEX-GNL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'ORIPRO',
       0,
       '7',
       'Estrang., Adq.Int. CAMEX-GNL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'ORIPRO',
       0,
       '8',
       'Nacional, Import. > a 70%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOF',
       0,
       ' ',
       'Tributvel (base de clculo)',
       TO_NUMBER(null),
       '01' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOF',
       0,
       ' ',
       'Ope. Trib. Alq. Diferenciada',
       TO_NUMBER(null),
       '02' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOF',
       0,
       ' ',
       'Ope. Trib. Alq Und Med.Pro',
       TO_NUMBER(null),
       '03' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOF',
       0,
       ' ',
       'Ope. Trib. Monofsica Rev.Alq',
       TO_NUMBER(null),
       '04' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOF',
       0,
       ' ',
       'Ope. Trib. Substituio Trib.',
       TO_NUMBER(null),
       '05' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOF',
       0,
       ' ',
       'Tributvel (alquota zero)',
       TO_NUMBER(null),
       '06' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOF',
       0,
       ' ',
       'Isenta da Contribuio',
       TO_NUMBER(null),
       '07' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOF',
       0,
       ' ',
       'Sem Incidncia da Contribuio',
       TO_NUMBER(null),
       '08' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOF',
       0,
       ' ',
       'Com Suspenso da Contribuio ',
       TO_NUMBER(null),
       '09' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOF',
       0,
       ' ',
       'Outras Operaes de Sada',
       TO_NUMBER(null),
       '49' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOF',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Trib Export',
       TO_NUMBER(null),
       '64' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis NTrib Export',
       TO_NUMBER(null),
       '65' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Trib NTrib Exp',
       TO_NUMBER(null),
       '66' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Outras Operaes',
       TO_NUMBER(null),
       '67' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio sem Dir Crdito',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio com Iseno',
       TO_NUMBER(null),
       '71' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio com Suspenso',
       TO_NUMBER(null),
       '72' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio a Alquota Zero',
       TO_NUMBER(null),
       '73' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio sem Inc Contrib',
       TO_NUMBER(null),
       '74' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio por ST',
       TO_NUMBER(null),
       '75' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Outras Operaes de Entrada',
       TO_NUMBER(null),
       '98' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Tributada',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-No Tributada',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Exportao',
       TO_NUMBER(null),
       '52' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Vinc Trib Export',
       TO_NUMBER(null),
       '54' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Vinc NTrib Export',
       TO_NUMBER(null),
       '55' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib Exp',
       TO_NUMBER(null),
       '56' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Exc Trib',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Exc NTrib',
       TO_NUMBER(null),
       '61' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Exc Export',
       TO_NUMBER(null),
       '62' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Trib NTrib',
       TO_NUMBER(null),
       '63' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITIPI',
       0,
       '0',
       'Tributada',
       TO_NUMBER(null),
       '0' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITIPI',
       0,
       '1',
       'Tributada com alquota zero',
       TO_NUMBER(null),
       '1' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITIPI',
       0,
       '2',
       'Isenta',
       TO_NUMBER(null),
       '2' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITIPI',
       0,
       '3',
       'No-tributada',
       TO_NUMBER(null),
       '3' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITIPI',
       0,
       '4',
       'Imune',
       TO_NUMBER(null),
       '4' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITIPI',
       0,
       '5',
       'Com suspenso',
       TO_NUMBER(null),
       '5' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITIPI',
       0,
       '9',
       'Outras',
       TO_NUMBER(null),
       '9' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPIS',
       0,
       ' ',
       'Ope. Trib. Alq Und Med.Pro',
       TO_NUMBER(null),
       '03' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPIS',
       0,
       ' ',
       'Ope. Trib. Monofsica Rev.Alq',
       TO_NUMBER(null),
       '04' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPIS',
       0,
       ' ',
       'Ope. Trib. Substituio Trib.',
       TO_NUMBER(null),
       '05' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPIS',
       0,
       ' ',
       'Tributvel (alquota zero) ',
       TO_NUMBER(null),
       '06' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPIS',
       0,
       ' ',
       'Isenta da Contribuio ',
       TO_NUMBER(null),
       '07' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPIS',
       0,
       ' ',
       'Sem Incidncia da Contribuio',
       TO_NUMBER(null),
       '08' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPIS',
       0,
       ' ',
       'Com Suspenso da Contribuio ',
       TO_NUMBER(null),
       '09' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPIS',
       0,
       ' ',
       'Outras Operaes de Sada',
       TO_NUMBER(null),
       '49' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPIS',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPIS',
       0,
       ' ',
       'Tributvel (base de clculo)',
       TO_NUMBER(null),
       '01' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPIS',
       0,
       ' ',
       'Ope. Trib. Alq. Diferenciada',
       TO_NUMBER(null),
       '02' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Trib Export',
       TO_NUMBER(null),
       '64' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis NTrib Export',
       TO_NUMBER(null),
       '65' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Trib NTrib Exp',
       TO_NUMBER(null),
       '66' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Outras Operaes',
       TO_NUMBER(null),
       '67' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio sem Dir Crdito',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio com Iseno',
       TO_NUMBER(null),
       '71' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio com Suspenso',
       TO_NUMBER(null),
       '72' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio a Alquota Zero',
       TO_NUMBER(null),
       '73' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio sem Inc Contrib',
       TO_NUMBER(null),
       '74' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio por ST',
       TO_NUMBER(null),
       '75' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Outras Operaes de Entrada',
       TO_NUMBER(null),
       '98' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Tributada',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-No Tributada',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Exportao',
       TO_NUMBER(null),
       '52' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Vinc Trib Export',
       TO_NUMBER(null),
       '54' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Vinc NTrib Export',
       TO_NUMBER(null),
       '55' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib Exp',
       TO_NUMBER(null),
       '56' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Exc Trib',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Exc NTrib',
       TO_NUMBER(null),
       '61' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Exc Export',
       TO_NUMBER(null),
       '62' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Trib NTrib',
       TO_NUMBER(null),
       '63' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'TIPMAR',
       0,
       'M',
       'Marca',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'TIPMPB',
       0,
       'C',
       'Conj. CPU, Monitor e Mouse',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'TIPMPB',
       0,
       'T',
       'Tablet',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'TIPPRO',
       2,
       ' ',
       'Terceirizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'TIPPRO',
       0,
       ' ',
       'Material',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPR2',
       'TIPPRO',
       1,
       ' ',
       'Servio',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8317 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IPRF',
       TO_NUMBER(null),
       'IPRF',
       'Itens de Produtos (Otimizada)',
       'TV_IPR_FAST',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'IPRF.FILMAT,IPRF.CODMAT,IPRF.CODCOR,IPRF.CODTAM',
       '' FROM DUAL
);

/*-- SEQ 8318 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IPRF','--','' FROM DUAL
UNION ALL
SELECT 'IPRF','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IPRF','02','Valores' FROM DUAL
UNION ALL
SELECT 'IPRF','03','Datas' FROM DUAL
UNION ALL
SELECT 'IPRF','04','Sugesto de Compra' FROM DUAL
UNION ALL
SELECT 'IPRF','05','Saldo da Filial' FROM DUAL
UNION ALL
SELECT 'IPRF','06','Valor Total de Compra' FROM DUAL
UNION ALL
SELECT 'IPRF','07','Valor Total de Reposio' FROM DUAL
UNION ALL
SELECT 'IPRF','08','Pedido Pendente' FROM DUAL
UNION ALL
SELECT 'IPRF','09','Saldo no Periodo' FROM DUAL
UNION ALL
SELECT 'IPRF','10','Valor de Venda do Produto' FROM DUAL
UNION ALL
SELECT 'IPRF','11','Data Custo Reposio' FROM DUAL
UNION ALL
SELECT 'IPRF','12','Giro de Estoque' FROM DUAL
UNION ALL
SELECT 'IPRF','13','Dias Sem Estoque' FROM DUAL
UNION ALL
SELECT 'IPRF','14','Dias Com Estoque' FROM DUAL
UNION ALL
SELECT 'IPRF','15','Dias Estoque Negativo' FROM DUAL
UNION ALL
SELECT 'IPRF','16','Saldo 2 da Filial' FROM DUAL
UNION ALL
SELECT 'IPRF','17','Saldo 3 da Filial' FROM DUAL
UNION ALL
SELECT 'IPRF','18','Saldo 4 da Filial' FROM DUAL
UNION ALL
SELECT 'IPRF','19','Status KIT' FROM DUAL
UNION ALL
SELECT 'IPRF','99','Outros' FROM DUAL
);

/*-- SEQ 8319 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22786,
       'CES ',
       'IPRF',
       '01',
       '0N',
       '',
       '',
       'CES.CODCES(+) = IPRF.CODCES',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22787,
       'ANP ',
       'IPRF',
       '1',
       'N',
       '',
       '',
       'ANP.CODANP = IPRF.CODANP',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22788,
       'NCM ',
       'IPRF',
       '1',
       'N',
       '',
       '',
       'NCM.CODNCM = IPRF.CODNCM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22789,
       'CUS ',
       'IPRF',
       '01',
       '01',
       '',
       '',
       'CUS.CODFIL = IPRF.FILMAT AND
CUS.SEQUEN = IPRF.SEQUEN ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22790,
       'MAR ',
       'IPRF',
       '01',
       'N',
       '',
       '',
       'MAR.FILPAR(+) = IPRF.FILMAR and
MAR.CODPAR(+) = IPRF.CODMAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22791,
       'GRA ',
       'IPRF',
       '1',
       'N',
       '',
       '',
       'GRA.FILMAT = IPRF.FILMAT AND
GRA.CODMAT = IPRF.CODMAT AND
GRA.CODCOR = IPRF.CODCOR AND
GRA.CODTAM = IPRF.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22792,
       'TMAR',
       'IPRF',
       '01',
       'N',
       '',
       '',
       'TMAR.FILMAR(+) = IPRF.FILMAR and
TMAR.CODMAR(+) = IPRF.CODMAR and
TMAR.ITEMAR(+) = IPRF.ITEMAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22793,
       'PXF ',
       'IPRF',
       'N',
       '1',
       '',
       '',
       'PXF.FILMAT = IPRF.FILMAT and
PXF.CODMAT = IPRF.CODMAT and
PXF.CODCOR = IPRF.CODCOR and
PXF.CODTAM = IPRF.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22794,
       'PRE ',
       'IPRF',
       'N',
       'N',
       '',
       '',
       'PRE.FILMAT = IPRF.FILMAT and
PRE.CODMAT = IPRF.CODMAT and
PRE.CODCOR = IPRF.CODCOR and
PRE.CODTAM = IPRF.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22744,
       'VCRG',
       'IPRF',
       '1',
       '1',
       '',
       '',
       'VCRG.FILMAT = IPRF.FILMAT AND
VCRG.CODMAT = IPRF.CODMAT AND
VCRG.CODCOR = IPRF.CODCOR AND
VCRG.CODTAM = IPRF.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22745,
       'VMIV',
       'IPRF',
       '01',
       '1',
       '',
       '',
       'IPRF.FILMAT = VMIV.FILMAT AND
IPRF.CODMAT = VMIV.CODMAT AND
IPRF.CODCOR = VMIV.CODCOR AND
IPRF.CODTAM = VMIV.CODTAM
',
       '',
       '' FROM DUAL
);

/*-- SEQ 8320 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IPRF',
       '09',
       2220,
       8,
       ':GRA.SALDOPERIODO_DATINI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Perodo',
       'Perodo',
       '',
       ':IPRF.SALDOPERIODO_DATINI,IPRF.SALDOPERIODO.DATFIM',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '11',
       2270,
       3,
       ':IPRF.CODFILCRD',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'IPRF.:IPRF.CODFILCRD=DFIL.CODFIL',
       ':IPRF.CODFILCRD',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '12',
       2310,
       3,
       ':IPRF.CODFILGIR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial Giro',
       'Filial Giro',
       ':IPRF.CODFIL = DFIL.CODFIL(+)',
       ':IPRF.CODFILGIR',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '04',
       2070,
       3,
       ':IPRF.CODFILLOC',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial Locao',
       'Filial Locao',
       ':IPRF.CODFILLOC = DFIL.CODFIL(+)',
       ':IPRF.CODFILLOC',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '08',
       2190,
       3,
       ':IPRF.CODFILPP',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial PP',
       'Filial PP',
       'IPRF.:IPRF.CODFILPP = DFIL.CODFIL',
       ':IPRF.CODFILPP',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '05',
       2110,
       3,
       ':IPRF.CODFILSDF',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial SDF',
       'Filial SDF',
       'IPRF.:IPRF.CODFILSDF = DFIL.CODFIL(+)',
       ':IPRF.CODFILSDF',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '16',
       3222,
       3,
       ':IPRF.CODFILSDF2',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial SDF',
       'Filial SDF',
       'IPRF.:IPRF.CODFILSDF = DFIL.CODFIL(+)',
       ':IPRF.CODFILSDF',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '17',
       3232,
       3,
       ':IPRF.CODFILSDF3',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial SDF',
       'Filial SDF',
       'IPRF.:IPRF.CODFILSDF = DFIL.CODFIL(+)',
       ':IPRF.CODFILSDF',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '18',
       3242,
       3,
       ':IPRF.CODFILSDF4',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial SDF',
       'Filial SDF',
       'IPRF.:IPRF.CODFILSDF = DFIL.CODFIL(+)',
       ':IPRF.CODFILSDF',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '19',
       4420,
       20,
       'STATUSKIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Status KIT',
       'Status KIT',
       '',
       'VERIFICASTATUSKIT(IPRF.FILMAT,IPRF.CODMAT,IPRF.CODCOR,IPRF.CODTAM)',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '19',
       4430,
       20,
       'REFKIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Referncia KIT',
       'Referncia Venda KIT',
       '',
       'REFERENCIAGRADEHEADERKIT(IPRF.FILMAT,IPRF.CODMAT,IPRF.CODCOR,IPRF.CODTAM)',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '06',
       2140,
       3,
       ':IPRF.CODFILVTC',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial VTC',
       'Filial VTC',
       'IPRF.:IPRF.CODFILVTC = DFIL.CODFIL(+)',
       ':IPRF.CODFILVTC',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '07',
       2170,
       3,
       ':IPRF.CODFILVTR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial VTR',
       'Filial VTR',
       'IPRF.:IPRF.CODFILVTR = DFIL.CODFIL(+)',
       ':IPRF.CODFILVTR',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '16',
       3223,
       30,
       ':IPRF.CODMUL2',
       'A',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       '',
       'Mltiplo Estoque',
       'Mltiplo Estoque',
       'IPRF.:IPRF.CODMUL2 = DMUL.CODTAB(+)',
       ':IPRF.CODMUL2',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '17',
       3233,
       30,
       ':IPRF.CODMUL3',
       'A',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       '',
       'Mltiplo Estoque',
       'Mltiplo Estoque',
       'IPRF.:IPRF.CODMUL2 = DMUL.CODTAB(+)',
       ':IPRF.CODMUL3',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '18',
       3243,
       30,
       ':IPRF.CODMUL4',
       'A',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       '',
       'Mltiplo Estoque',
       'Mltiplo Estoque',
       'IPRF.:IPRF.CODMUL2 = DMUL.CODTAB(+)',
       ':IPRF.CODMUL4',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '11',
       2280,
       5,
       ':IPRF.CODMULCRD',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       '9',
       '',
       'Cd.Mltiplo Estoque',
       'Cdigo Mltiplo Estoque',
       'IPRF.:IPRF.CODMULCRD = DMUL.CODTAB',
       ':IPRF.CODMULCRD',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '14',
       2360,
       8,
       ':IPRF.COM_DATINI,IPRF.COM_DATF',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Datas com Estoque',
       'Datas com Estoque',
       '',
       ':IPRF.COM_DATINI,IPRF.COM_DATFIM',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '04',
       2050,
       8,
       ':IPRF.DAT01,IPRF.DAT02',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data',
       'Data',
       '',
       ':IPRF.DAT01,IPRF.DAT02',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '04',
       2060,
       8,
       ':IPRF.DATATE',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Manter At',
       'Manter At',
       '',
       ':IPRF.DATATE',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '12',
       2300,
       8,
       ':IPRF.DATINI,IPRF.DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data',
       'Data',
       '',
       ':IPRF.DATINI,IPRF.DATFIM',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '11',
       2260,
       8,
       ':IPRF.DATREFCRD',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Referncia',
       'Data Referncia',
       '',
       ':IPRF.DATREFCRD',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '05',
       2100,
       8,
       ':IPRF.DATREFSDF',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Referncia',
       'Data Referncia',
       '',
       ':IPRF.DATREFSDF',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '16',
       3221,
       8,
       ':IPRF.DATREFSDF2',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Referncia',
       'Data Referncia',
       '',
       ':IPRF.DATREFSDF',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '17',
       3231,
       8,
       ':IPRF.DATREFSDF3',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Referncia',
       'Data Referncia',
       '',
       ':IPRF.DATREFSDF',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '18',
       3241,
       8,
       ':IPRF.DATREFSDF4',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Referncia',
       'Data Referncia',
       '',
       ':IPRF.DATREFSDF',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '06',
       2130,
       8,
       ':IPRF.DATREFVTC',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Referncia',
       'Data Referncia',
       '',
       ':IPRF.DATREFVTC',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '07',
       2160,
       8,
       ':IPRF.DATREFVTR',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data VTR',
       'Data VTR',
       '',
       ':IPRF.DATREFVTR',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '14',
       2370,
       3,
       ':IPRF.FILIAL_COM_ESTOQUE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial com Estoque',
       'Filial com Estoque',
       ':IPRF.FILIAL_COM_ESTOQUE = DFIL.CODFIL(+)',
       ':IPRF.FILIAL_COM_ESTOQUE',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '15',
       3000,
       3,
       ':IPRF.FILIAL_NEG_ESTOQUE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial Estoque Neg.',
       'Filial Estoque Negativo',
       'IPRF.:IPRF.FILIAL_NEG_ESTOQUE = DFIL.CODFIL(+)',
       ':IPRF.FILIAL_NEG_ESTOQUE',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '13',
       2340,
       3,
       ':IPRF.FILIAL_SEM_ESTOQUE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial Sem Estoque',
       'Filial Sem Estoque',
       ':IPRF.FILIAL_SEM_ESTOQUE = DFIL.CODFIL(+)',
       ':IPRF.FILIAL_SEM_ESTOQUE',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '15',
       2390,
       8,
       ':IPRF.NEG_DATINI,IPRF.NEG_DATF',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Datas Estoque Neg.',
       'Datas Estoque Negativo',
       '',
       ':IPRF.NEG_DATINI,IPRF.NEG_DATFIM',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '13',
       2330,
       8,
       ':IPRF.SEM_DATINI,IPRF.SEM_DATF',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Sem Estoque',
       'Data Sem Estoque',
       '',
       ':IPRF.SEM_DATINI,IPRF.SEM_DATFIM',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '04',
       2040,
       1,
       ':IPRF.TIPPRJ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Tipo de Projeo',
       'Tipo de Projeo',
       '',
       ':IPRF.TIPPRJ',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '10',
       2240,
       8,
       ':IPRF.VLRVENDATINI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Perodo',
       'Perodo',
       '',
       ':IPRF.VLRVENDATINI,IPRF.VLRVENDATFIM',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       940,
       5,
       'AFICUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Acrscimo Financeiro',
       'Acrscimo Financeiro para Formao do Preo de venda',
       '',
       'AFICUS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       3010,
       1,
       'ARRTRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Arrentonda ou Trunca',
       'Arrentonda ou Trunca?',
       '',
       'ARRTRU',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       681,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN IPRF.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '03',
       950,
       7,
       'ATUGRA',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Atu. da Grade',
       'Data de Atualizao do Item de Grade',
       '',
       'ATUGRA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '03',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       870,
       1,
       'BALSIM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Utiliza Balana?',
       'Utiliza Balana?',
       '',
       'BALSIM',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       20,
       2,
       'BRINDE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Brinde',
       'Brinde',
       '',
       'BRINDE',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       30,
       2,
       'CLASS1',
       'S',
       'DCL1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL1.CLASS1',
       'V',
       '',
       'F',
       'A',
       'F',
       'Catergoria',
       'Classificao 1',
       'IPRF.CLASS1=DCL1.CODTAB (+)',
       'CLASS1',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       40,
       2,
       'CLASS2',
       'S',
       'DCL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL2.CLASS2',
       'V',
       '',
       'F',
       'A',
       'F',
       'SubCategoria',
       'Classificao 2',
       'IPRF.CLASS2=DCL2.CODTAB (+)',
       'CLASS2',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       50,
       2,
       'CLASS3',
       'S',
       'DCL3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL3.CLASS3',
       'V',
       '',
       'F',
       'A',
       'F',
       'Familia',
       'Classificao 3',
       'IPRF.CLASS3=DCL3.CODTAB (+)',
       'CLASS3',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       60,
       2,
       'CLASS4',
       'S',
       'DCL4',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL4.CLASS4',
       'V',
       '',
       'F',
       'A',
       'F',
       'SubFamilia',
       'Classificao 4',
       'IPRF.CLASS4=DCL4.CODTAB (+)',
       'CLASS4',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       70,
       2,
       'CLSXYZ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Classe XYZ',
       'Classificacao XYZ',
       '',
       'CLSXYZ',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       3080,
       9,
       'CODANP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Cdigo na ANP',
       'Cdigo na ANP',
       '',
       'CODANP',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       4330,
       7,
       'CODCES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'CEST',
       'CEST',
       '',
       'CODCES',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       80,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Divisao Material',
       'IPRF.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       1060,
       5,
       'CODCTR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       90,
       5,
       'CODDIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Diviso',
       'Cdigo Diviso',
       '',
       'CODDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       4340,
       3,
       'CODENQ',
       'S',
       'ENQ ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'ENQ.DESENQ',
       'V',
       '',
       '',
       'N',
       '',
       'Cd Enquad IPI',
       'Cdigo de Enquadramento Legal do IPI',
       'ENQ.CODENQ(+) = IPRF.CODENQ',
       'CODENQ',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       880,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo do Produto',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       4260,
       60,
       'CODFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Cdigo Fiscal',
       'Cdigo Fiscal',
       '',
       'CODFIS',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       3910,
       2,
       'CODFPS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODFPS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       3260,
       2,
       'CODFPS ',
       'A',
       'DFPS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFPS.DESFPS',
       'V',
       '',
       '',
       'A',
       '',
       'Finalidade',
       'Finalidade',
       'DFPS.CODFPS=IPRF.CODFPS(+) ',
       'CODFPS ',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       100,
       2,
       'CODGRA',
       'S',
       'DGRA',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DGRA.NOMGRA',
       'V',
       '',
       'F',
       'A',
       'F',
       'Tipo Grade',
       'Cdigo da grade',
       'IPRF.CODGRA=DGRA.CODTAB (+)',
       'CODGRA',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       4270,
       5,
       'CODIMG',
       'G',
       'DIMG',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIMG.DESIMG',
       'V',
       '',
       '',
       'N',
       '',
       'Cdigo imagem grupo',
       'Cdigo da imagem do grupo',
       'DIMG.CODTAB = IPRF.CODIMG',
       'CODIMG',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       890,
       5,
       'CODLPC',
       'S',
       'DLPC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DLPC.DESLPC',
       'V',
       '',
       '',
       'N',
       'F',
       'Lista de Controlados',
       'Lista de Produto Controlado a qual o produto pertence',
       'DLPC.CODTAB = PRO.CODLPC',
       'CODLPC',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       110,
       6,
       'CODMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo da marca',
       'Cdigo da Marca deste produto',
       '',
       'CODMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       120,
       5,
       'CODMAT',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo material',
       'IPRF.CODTAM=SUB.CODITE (+)',
       'CODMAT',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       3110,
       8,
       'CODNCM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo NCM',
       'Cdigo NCM',
       '',
       'CODNCM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       4400,
       40,
       'CODPOS_GRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo POS CONTROLE',
       'Cdigo POS CONTROLE',
       '',
       'CODPOS_GRA',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       3920,
       5,
       'CODRGC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODRGC',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       130,
       5,
       'CODSAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cd. Saldo Unificado',
       'Cdigo Saldo Unificado no item',
       '',
       'CODSAL',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       140,
       2,
       'CODSAZ',
       'S',
       'DSAZ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSAZ.DESSAZ',
       'V',
       '',
       'F',
       'A',
       'F',
       'Sazonalidade',
       'Cdigo da sazonalidade',
       'IPRF.CODSAZ=DSAZ.CODTAB (+)',
       'CODSAZ',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       3930,
       4,
       'CODSRV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODSRV',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       150,
       5,
       'CODSUB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Sub-Diviso',
       'Cdigo Sub-Diviso',
       '',
       'CODSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       160,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso Material',
       'IPRF.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       170,
       2,
       'CODTRI',
       'S',
       'DTRI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DTRI.CODTRI',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo~Tributao',
       'Cdigo de tributao',
       'IPRF.CODTRI=DTRI.CODTAB (+)',
       'CODTRI',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       3090,
       3,
       'COD_EX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cd. de Exceo IPI',
       'Cdigo de Exceo do IPI',
       '',
       'COD_EX',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       180,
       10,
       'CONAPL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Conv. Emb. Aplicao',
       'Converso Aplicao e Embalagem',
       '',
       'CONAPL',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       4300,
       1,
       'CONFER',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Conferir na venda?',
       'Conferir na venda?',
       '',
       'CONFER',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       190,
       1,
       'CONTRA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Produto Contratado?',
       'Determina se produto  do tipo contrato',
       '',
       'CONTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       200,
       1,
       'CONTRO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Produto Controlado?',
       'Produtos Controlados',
       '',
       'CONTRO',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       210,
       16,
       'CUSFRE',
       'F',
       '',
       6,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Custo Frete',
       'Custo Frete',
       '',
       'CUSFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       220,
       14,
       'CUSREP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Custo Reposio',
       'Custo Reposicao',
       '',
       'CUSREP',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '11',
       2250,
       12,
       'CUSTOREPOSICAODATA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Custo Reposio/Data',
       'Custo Reposio/Data',
       '',
       'CUSTOREPOSICAODATA(:IPRF.DATREFCRD,IPRF.FILMAT,IPRF.CODMAT,IPRF.CODCOR,IPRF.CODTAM,:IPRF.CODFILCRD,:IPRF.CODMULCRD)',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       960,
       5,
       'DACCUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Desc/Acrscimo',
       'Desconto/Acrscimo para a Formao do Preo de Venda',
       '',
       'DACCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '03',
       230,
       7,
       'DATCAD',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Cadastro',
       'Data Cadastro',
       '',
       'DATCAD',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '03',
       240,
       7,
       'DATCOM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Compra',
       'Data Compra',
       '',
       'DATCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       250,
       1,
       'DECIMA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Usa Decimais?',
       'Usa Decimais?',
       '',
       'DECIMA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       810,
       5,
       'DEPART',
       'S',
       'DDEP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDEP.DESDEP',
       'V',
       '',
       '',
       'A',
       'F',
       'Departamento',
       'Departamento',
       'DDEP.CODTAB(+) = IPRF.DEPART',
       'DEPART',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       4250,
       40,
       'DESCLA',
       'A',
       'CLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'CLA.DESCLA',
       'V',
       '',
       '',
       'A',
       '',
       'Des. Classificao',
       'Descrio Classificao',
       'CLA.CODFIL(+) = IPRF.FILCLA AND CLA.SEQUEN(+) = IPRF.SEQCLA',
       'DESCLA',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       4410,
       4000,
       'DESDET',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Desc. Detalhe HTML',
       'Descrio Detalhe (em HTML)',
       '',
       'DESDET',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       270,
       15,
       'DESECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao ECF',
       'Descrio ECF',
       '',
       'DESECF',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       3940,
       5,
       'DESFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       311,
       120,
       'DESGRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio da Grade',
       'Descrio da Grade',
       '',
       'DESGRA',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       280,
       12,
       'DESIDE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Desconto~Sugerido',
       'Desconto Sugerido',
       '',
       'DESIDE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       290,
       30,
       'DESMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio~Material',
       'Descrio Material',
       '',
       'DESMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       300,
       12,
       'DESMAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Desconto~Mximo',
       'Desconto Maximo',
       '',
       'DESMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       1090,
       20,
       'DESMED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio da Medida',
       'Descrio da Medida',
       '',
       'DESMED',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '14',
       2350,
       12,
       'DIASDEESTOQUE_COM_ESTOQUE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Dias com Estoque',
       'Dias com Estoque',
       '',
       'DIASDEESTOQUE(''C'', :IPRF.COM_DATINI, :IPRF.COM_DATFIM, IPRF.FILMAT, IPRF.CODMAT, IPRF.CODCOR, IPRF.CODTAM, :IPRF.FILIAL_COM_ESTOQUE, 0)',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '15',
       2380,
       12,
       'DIASDEESTOQUE_NEGATIVO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'DiasEstoque Negativo',
       'Dias Estoque Negativo',
       '',
       'DIASDEESTOQUE(''-'', :IPRF.NEG_DATINI, :IPRF.NEG_DATFIM, IPRF.FILMAT, IPRF.CODMAT, IPRF.CODCOR, IPRF.CODTAM, :IPRF.FILIAL_NEG_ESTOQUE, 0)',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '13',
       2320,
       12,
       'DIASDEESTOQUE_SEM_ESTOQUE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Dias Sem Estoque',
       'Dias Sem Estoque',
       '',
       'DIASDEESTOQUE(''S'', :IPRF.SEM_DATINI, :IPRF.SEM_DATFIM, IPRF.FILMAT, IPRF.CODMAT, IPRF.CODCOR, IPRF.CODTAM, :IPRF.FILIAL_SEM_ESTOQUE, 0)',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       310,
       30,
       'ESPMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Especificao',
       'Especificao Material',
       '',
       'ESPMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       4320,
       1,
       'ESTCHE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Estoque no CK4G',
       'Controle de Estoque no Checkout 4G',
       '',
       'ESTCHE',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       3210,
       2,
       'ETIQUE',
       'S',
       'DETI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DETI.DESETI',
       'V',
       '',
       '',
       'A',
       '',
       'Etiqueta',
       'Tipo de etiqueta',
       'IPRF.ETIQUE=DETI.CODTAB (+)',
       'ETIQUE',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       330,
       14,
       'FATCON',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Fator Converso',
       'Fator de converso entre as divises',
       '',
       'FATCON',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       900,
       3,
       'FILCLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILCLA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       3990,
       3,
       'FILCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       4440,
       3,
       'FILFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Filial de Fat.',
       'Filial de faturamento do produto para vendas conjuntas',
       '',
       'FILFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       340,
       3,
       'FILMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Marca do material',
       '',
       'FILMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       350,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       4000,
       3,
       'FILRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial de reserva',
       'Filial de reserva padro para o produto',
       '',
       'FILRES',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       970,
       1,
       'FLGSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FLGSER',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       4380,
       1,
       'FOR060',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'CST60 emp substituta',
       'Forar substitudo (60) mesmo para empresa substituta',
       '',
       'FOR060',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       770,
       1,
       'FORLIN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Fora de Linha?',
       'Fora de Linha',
       '',
       'FORLIN',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       4010,
       256,
       'GRA_ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'GRA_ASSINA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '12',
       2290,
       12,
       'GiroEstoque',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       '',
       'Giro de Estoque',
       'Giro de Estoque',
       '',
       'GiroEstoque(:IPRF.DATINI,:IPRF.DATFIM,IPRF.FILMAT,IPRF.CODMAT,IPRF.CODCOR,IPRF.CODTAM,:IPRF.CODFILGIR)',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       830,
       14,
       'ICMCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'ICMS Compra',
       'ICMS Compra',
       '',
       'ICMCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       990,
       14,
       'ICMCUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '% ICMS p/ Preo',
       '% de ICMS para Formao do Preo de Venda',
       '',
       'ICMCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       4030,
       1,
       'ICMFED',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ICMFED',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       1000,
       1,
       'ICMTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Tributao',
       'Tipo de Tributao para Formao do Preo de Venda',
       '',
       'ICMTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       3070,
       1,
       'IIPTPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Produo Prp ou Ter',
       'Produo Prpria ou de Terceiro?',
       '',
       'IIPTPR',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       4280,
       255,
       'IMGGRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome da imagem',
       'Nome da imagem',
       '',
       'IMGGRU',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       3250,
       1,
       'IMPKIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Imp. Itens Kit NF?',
       'Imprimir Itens de Kit na NF/CF?',
       '',
       'IMPKIT',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       840,
       14,
       'IPICOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'IPI Compra',
       'IPI Compra',
       '',
       'IPICOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       1010,
       14,
       'IPICUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '% IPI Compra',
       '% IPI da Compra',
       '',
       'IPICUS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       4040,
       1,
       'ISEPIS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ISEPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       850,
       5,
       'ITECOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Item Compra',
       '',
       '',
       'ITECOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       360,
       10,
       'ITEDIV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Item Diviso',
       'Item Diviso',
       '',
       'ITEDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       800,
       4,
       'ITEMAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Itens de Marca',
       'Itens de Marca',
       '',
       'ITEMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       370,
       10,
       'ITESUB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Item SubDiviso',
       'Item SubDiviso',
       '',
       'ITESUB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       380,
       10,
       'LOCALI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Localizao',
       'Localizacao',
       '',
       'LOCALI',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       4390,
       3,
       'MAXPAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Mximo de parcelas',
       'Nmero mximo de parcelas na venda',
       '',
       'MAXPAR',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       420,
       2,
       'MEDUNI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Medida Unidade',
       'Medida Unidade',
       '',
       'MEDUNI',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       430,
       12,
       'MINQTD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Estoque ~Mnimo',
       'Estoque Minimo',
       '',
       'MINQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       440,
       1,
       'MONTAR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Montagem?',
       'Aceita montagem',
       '',
       'MONTAR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       4050,
       2,
       'NATBCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATBCC',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       450,
       20,
       'NOMDIV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Diviso',
       'Nome Diviso',
       '',
       'NOMDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       460,
       255,
       'NOMIMG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Arquivo Imagem',
       'Nome Arquivo de Imagem',
       '',
       'NOMIMG',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       470,
       83,
       'NOMPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Produto',
       'Nome Produto',
       '',
       'NOMPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       480,
       20,
       'NOMSUB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Subdiviso',
       'Nome Subdiviso',
       '',
       'NOMSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       490,
       1,
       'NUMEXT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Numero Externo?',
       'Nmero externo na Ordem de Servio',
       '',
       'NUMEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       500,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Num. Itens do Kit',
       'Nmero de itens de um kit',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       4290,
       1,
       'OBIMEI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Obriga IMEI?',
       'Obriga IMEI no Servio Adicional?',
       '',
       'OBIMEI',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       510,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(IPRF.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       4060,
       4000,
       'OBSGRA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'OBSGRA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       4070,
       254,
       'OBSMPB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'OBSMPB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       520,
       5,
       'ORDDIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ordem Diviso',
       'Ordem Diviso',
       '',
       'ORDDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       530,
       5,
       'ORDSUB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ordem Sub-Diviso',
       'Ordem Sub-Diviso',
       '',
       'ORDSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       1020,
       1,
       'ORICUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem dos Custos',
       'Origem da Atualizao dos Custos',
       '',
       'ORICUS',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       3350,
       1,
       'ORIPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem do Produto',
       'Origem do Produto',
       '',
       'ORIPRO',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       1030,
       12,
       'OUTCUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Outros Custos',
       'Outros Custos',
       '',
       'OUTCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '08',
       2180,
       12,
       'PEDIDOPENDENTE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Pedidos Pendentes',
       'Traz a quantidade pendente de pedidos nao recebidos',
       '',
       'PEDIDOPENDENTE(:IPRF.CODFILPP,IPRF.FILMAT,IPRF.CODMAT,IPRF.CODCOR,IPRF.CODTAM)',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       540,
       12,
       'PERCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Comisso',
       'Percentual Comisso',
       '',
       'PERCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       3900,
       5,
       'PERIND',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '% Comisso Indicador',
       '% Comisso para Indicador',
       '',
       'PERIND',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       550,
       12,
       'PERLUC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% de Lucro',
       '% de Lucro',
       '',
       'PERLUC',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       910,
       5,
       'PERSER',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PERSER',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       4350,
       5,
       'PER_II',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Imposto Importao',
       '% de Imposto sobre Importao',
       '',
       'PER_II',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       560,
       14,
       'PESBRU',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Peso~Bruto',
       'Peso Bruto',
       '',
       'PESBRU',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       570,
       14,
       'PESLIQ',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Peso~Lquido',
       'Peso Liquido',
       '',
       'PESLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       580,
       14,
       'PRECOM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Preco~Compra',
       'Preo Compra',
       '',
       'PRECOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       3370,
       14,
       'PREFIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Preo Fiscal',
       'Preo Fiscal (Mximo, Sugesto ou Pauta)',
       '',
       'PREFIS',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       1040,
       1,
       'PREPSI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PREPSI',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       590,
       1,
       'PROMOC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Promoo?',
       'Indica se produto  promocional',
       '',
       'PROMOC',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       4080,
       256,
       'PRO_ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRO_ASSINA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       600,
       12,
       'PTOQTD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Pto. Pedido',
       'Ponto de pedido',
       '',
       'PTOQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       4100,
       12,
       'QTDBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'QTDBON',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       790,
       12,
       'QTDCOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Quantidade Compra',
       'Quantidade Compra',
       '',
       'QTDCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       610,
       10,
       'QTDEMB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Contedo Embalagem',
       'Contedo da Embalagem',
       '',
       'QTDEMB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       4110,
       7,
       'QTDMUL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'QTDMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       620,
       12,
       'QTDREP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde Reposico',
       'Quantidade ideal de reposiao',
       '',
       'QTDREP',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       630,
       15,
       'REFBAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. Bsica',
       'Referncia Bsica',
       '',
       'REFBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       640,
       20,
       'REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. Produto',
       'Referncia do Produto',
       '',
       'REFPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       1100,
       20,
       'REFVEN_EAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Referencia de Venda',
       'Referencia de Venda',
       '',
       '(SELECT min(IEAN.CODEAN) FROM TT_EAN IEAN WHERE IEAN.FILMAT=IPRF.FILMAT AND IEAN.CODMAT=IPRF.CODMAT AND IEAN.CODCOR=IPRF.CODCOR AND IEAN.CODTAM=IPRF.CODTAM)',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       650,
       5,
       'RESIPI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '% IPI',
       'Alquota do IPI',
       '',
       'RESIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       660,
       5,
       'RESIRR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '% IRR',
       'Alquota do Imposto de Renda',
       '',
       'RESIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       820,
       1,
       'RETCOF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Reteno de COFINS?',
       'Permite Reteno de COFINS?',
       '',
       'RETCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '16',
       3220,
       8,
       'SALDO2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo 2 da Filial',
       'Saldo 2 da Filial',
       '',
       'SaldoDaFilial(:IPRF.DATREFSDF,IPRF.FILMAT,IPRF.CODMAT,IPRF.CODCOR,IPRF.CODTAM,:IPRF.CODFILSDF,:IPRF.CODMUL2)',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '17',
       3230,
       8,
       'SALDO3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo 3 da Filial',
       'Saldo 3 da Filial',
       '',
       'SaldoDaFilial(:IPRF.DATREFSDF,IPRF.FILMAT,IPRF.CODMAT,IPRF.CODCOR,IPRF.CODTAM,:IPRF.CODFILSDF,:IPRF.CODMUL3)',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '18',
       3240,
       8,
       'SALDO4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo 4 da Filial',
       'Saldo 4 da Filial',
       '',
       'SaldoDaFilial(:IPRF.DATREFSDF,IPRF.FILMAT,IPRF.CODMAT,IPRF.CODCOR,IPRF.CODTAM,:IPRF.CODFILSDF,:IPRF.CODMUL4)',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       2020,
       12,
       'SALDOEMTRANSITO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo em Transito',
       'Saldo em Transito',
       '',
       'SALDOEMTRANSITO(IPRF.FILMAT, IPRF.CODMAT, IPRF.CODCOR,IPRF.CODTAM)',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '09',
       2200,
       12,
       'SALDOPERIODO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Saldo no Perodo',
       'Saldo no Perodo',
       '',
       'SALDOPERIODO(IPRF.FILMAT,IPRF.CODMAT,IPRF.CODCOR,IPRF.CODTAM,:IPRF.SALDOPERIODO_DATINI,:IPRF.SALDOPERIODO.DATFIM)',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '05',
       2080,
       20,
       'SALDO_FILIAL_STRING',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Saldo Filial String',
       'Saldo Filial String',
       '',
       'TO_CHAR(SALDODAFILIAL(:IPRF.DATREFSDF,IPRF.FILMAT,IPRF.CODMAT,IPRF.CODCOR,IPRF.CODTAM,:IPRF.CODFILSDF))',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '09',
       2210,
       20,
       'SALDO_PERIODO_STRING',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Saldo Periodo String',
       'Saldo Periodo String',
       '',
       'TO_CHAR(SALDOPERIODO(IPRF.FILMAT,IPRF.CODMAT,IPRF.CODCOR,IPRF.CODTAM,:IPRF.SALDOPERIODO_DATINI,:IPRF.SALDOPERIODO.DATFIM))',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       920,
       10,
       'SEQCLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQCLA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       860,
       10,
       'SEQCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       670,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       680,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN IPRF.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       3100,
       2,
       'SITCOF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Cd. Sit. Trib. COF',
       'Cdigo de Situao Tributria do COFINS',
       '',
       'SITCOF',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       4230,
       2,
       'SITCOFCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'CST COFINS Compra',
       'Cdigo de Situao Tributria do COFINS para Compra',
       '',
       'SITCOFCOM',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       3200,
       1,
       'SITIPI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Cd. Sit. Trib. IPI',
       'Cdigo de Situao Tributria do IPI',
       '',
       'SITIPI',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       3190,
       2,
       'SITPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Cd. Sit. Trib. PIS',
       'Cdigo de Situao Tributria do PIS',
       '',
       'SITPIS',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       4240,
       2,
       'SITPISCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'CST PIS para Compra',
       'Cdigo de Situao Tributria do PIS para Compra',
       '',
       'SITPISCOM',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       4310,
       1,
       'SUBFED',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Substitudo Federal',
       'Substitudo Federal',
       '',
       'SUBFED',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       4120,
       5,
       'SUBFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SUBFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       930,
       1,
       'SUGSER',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SUGSER',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '05',
       2090,
       8,
       'SaldoDaFilial',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo da Filial',
       'Saldo da Filial',
       '',
       'SaldoDaFilial(:IPRF.DATREFSDF,IPRF.FILMAT,IPRF.CODMAT,IPRF.CODCOR,IPRF.CODTAM,:IPRF.CODFILSDF)',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '04',
       2030,
       12,
       'SugestaoCompra',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Sugesto Compra',
       'Sugesto Compra',
       '',
       'SugestaoCompra(:IPRF.TIPPRJ,:IPRF.DAT01,:IPRF.DAT02,:IPRF.DATATE,IPRF.FILMAT,IPRF.CODMAT,IPRF.CODCOR,IPRF.CODTAM,:IPRF.CODFILLOC)',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       690,
       5,
       'TEMREP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tempo p/~Reposio',
       'Tempo de Reposio',
       '',
       'TEMREP',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       1050,
       254,
       'TERASS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TERASS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       4130,
       1,
       'TIPDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       700,
       1,
       'TIPMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Marca',
       'Tipo Marca',
       '',
       'TIPMAR',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       3500,
       1,
       'TIPMPB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo para MPB',
       'Tipo para Tratamento em MP do Bem',
       '',
       'TIPMPB',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       710,
       2,
       'TIPPRO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Produto',
       'Tipo de produto',
       '',
       'TIPPRO',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       4140,
       1,
       'TIPVAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPVAL',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       2010,
       12,
       'ULTIMO_ICMS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '% ICMS',
       '% ICMS',
       '',
       'RETORNAICMS(IPRF.FILMAT,IPRF.CODMAT,IPRF.CODCOR,IPRF.CODTAM)',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       720,
       5,
       'UNIAPL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Unidade Aplicao',
       'Unidade de Aplicao',
       '',
       'UNIAPL',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       730,
       5,
       'UNIDAD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Unidade Venda',
       'Unidade Venda (medida utilizada  - Kg, l, m, etc.)',
       '',
       'UNIDAD',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       740,
       5,
       'UNIEMB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Uni.Medida Embalagem',
       'Unidade de medida utilizada na embalagem',
       '',
       'UNIEMB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       750,
       5,
       'UNIFOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Unidade Compra',
       'Unidade Compra (medida utilizada pelo fornecedor)',
       '',
       'UNIFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       4150,
       1,
       'USABON',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'USABON',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       3730,
       1,
       'USALOT',
       'L',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Usa lote',
       'Usa lote?',
       '',
       'USALOT',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       2000,
       1,
       'UsaCodSal',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Controla~Estoque',
       'Controla Estoque',
       '',
       'UsaCodSal(IPRF.CODTAM)',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       760,
       12,
       'VALCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Val Conv. Ven/Com',
       'Valor de converso entre as unidades de Venda/Compra',
       '',
       'VALCON',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '01',
       1080,
       1,
       'VALEST',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Valida Estoque?',
       'Valida Estoque?',
       '',
       'VALEST',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '10',
       2230,
       12,
       'VALORVENDIDO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Valor Vendido',
       'Valor Vendido',
       '',
       'VALORVENDAPRODUTO(:IPRF.VLRVENDATINI,:IPRF.VLRVENDATFIM,IPRF.FILMAT, IPRF.CODMAT, IPRF.CODCOR, IPRF.CODTAM, :IPRF.FILIALVV)',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       4170,
       6,
       'VENCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VENCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       4360,
       6,
       'VENCOFIMP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% COFINS Importao',
       '% COFINS na Importao',
       '',
       'VENCOFIMP',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       4180,
       6,
       'VENPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VENPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '99',
       4370,
       6,
       'VENPISIMP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% PIS Importao',
       '% PIS na Importao',
       '',
       'VENPISIMP',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       4190,
       16,
       'VLRCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VLRCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '--',
       4200,
       16,
       'VLRPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VLRPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '06',
       2120,
       8,
       'VLRTOTCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Valor total Compra',
       'Valor Total da Compra',
       '',
       'SaldoDaFilial(:IPRF.DATREFVTC,IPRF.FILMAT,IPRF.CODMAT,IPRF.CODCOR,IPRF.CODTAM,:IPRF.CODFILVTC)*PRECOM',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '07',
       2150,
       8,
       'VLRTOTREP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Vlr Total Reposio',
       'Valor Total Reposio',
       '',
       'SaldoDaFilial(:IPRF.DATREFVTR,IPRF.FILMAT,IPRF.CODMAT,IPRF.CODCOR,IPRF.CODTAM,:IPRF.CODFILVTR)*CUSREP',
       '' FROM DUAL
UNION ALL
SELECT 'IPRF',
       '02',
       1070,
       15,
       'VOLUME',
       'F',
       '',
       5,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Volume m3',
       'Volume m3',
       '',
       'VOLUME',
       'F' FROM DUAL
);

/*-- SEQ 8321 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IPRF',
       'ARRTRU',
       0,
       'A',
       'Arredondamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'ARRTRU',
       0,
       'T',
       'Truncamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'BRINDE',
       2,
       '-',
       ' Brinde',
       194,
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'BRINDE',
       1,
       '-',
       'Pode ser Brinde',
       193,
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'BRINDE',
       0,
       '-',
       'Nao  Brinde',
       192,
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'CLSXYZ',
       2,
       '-',
       'Z',
       191,
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'CLSXYZ',
       1,
       '-',
       'Y',
       190,
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'CLSXYZ',
       0,
       '-',
       'X',
       189,
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'ESTCHE',
       0,
       ' ',
       'S on-line',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'ESTCHE',
       1,
       ' ',
       'Replicado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'ESTCHE',
       9,
       ' ',
       'No controla',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'ICMTIP',
       0,
       '0',
       'Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'ICMTIP',
       0,
       '1',
       'No-Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'ICMTIP',
       0,
       '2',
       'Isento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'ICMTIP',
       0,
       '3',
       'Substitudo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'ICMTIP',
       0,
       '4',
       'Isento no Estado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'IIPTPR',
       0,
       'P',
       'p/ merc manufat pelo prop cont',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'IIPTPR',
       0,
       'T',
       'p/ merc manufat de terceiros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'ORICUS',
       0,
       'C',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'ORICUS',
       0,
       'M',
       'Manual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'ORICUS',
       0,
       'P',
       'Pedido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'ORIPRO',
       0,
       '0',
       'Nacional, exceto cd.3,4,5,8',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'ORIPRO',
       0,
       '1',
       'Estrang., Import.Dir., Exc.6',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'ORIPRO',
       0,
       '2',
       'Estrang., Adq.Int., Exc.7',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'ORIPRO',
       0,
       '3',
       'Nacional, Cont.Import.>40%<70%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'ORIPRO',
       0,
       '4',
       'Nacional, Conf.Proc.Prod.Bs.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'ORIPRO',
       0,
       '5',
       'Nacional, Cont.Import <= 40%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'ORIPRO',
       0,
       '6',
       'Estrang., Import.Dir.CAMEX-GNL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'ORIPRO',
       0,
       '7',
       'Estrang., Adq.Int. CAMEX-GNL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'ORIPRO',
       0,
       '8',
       'Nacional, Import. > a 70%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOF',
       0,
       ' ',
       'Tributvel (base de clculo)',
       TO_NUMBER(null),
       '01' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOF',
       0,
       ' ',
       'Ope. Trib. Alq. Diferenciada',
       TO_NUMBER(null),
       '02' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOF',
       0,
       ' ',
       'Ope. Trib. Alq Und Med.Pro',
       TO_NUMBER(null),
       '03' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOF',
       0,
       ' ',
       'Ope. Trib. Monofsica Rev.Alq',
       TO_NUMBER(null),
       '04' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOF',
       0,
       ' ',
       'Ope. Trib. Substituio Trib.',
       TO_NUMBER(null),
       '05' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOF',
       0,
       ' ',
       'Tributvel (alquota zero)',
       TO_NUMBER(null),
       '06' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOF',
       0,
       ' ',
       'Isenta da Contribuio',
       TO_NUMBER(null),
       '07' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOF',
       0,
       ' ',
       'Sem Incidncia da Contribuio',
       TO_NUMBER(null),
       '08' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOF',
       0,
       ' ',
       'Com Suspenso da Contribuio ',
       TO_NUMBER(null),
       '09' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOF',
       0,
       ' ',
       'Outras Operaes de Sada',
       TO_NUMBER(null),
       '49' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOF',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Trib Export',
       TO_NUMBER(null),
       '64' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis NTrib Export',
       TO_NUMBER(null),
       '65' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Trib NTrib Exp',
       TO_NUMBER(null),
       '66' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Outras Operaes',
       TO_NUMBER(null),
       '67' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio sem Dir Crdito',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio com Iseno',
       TO_NUMBER(null),
       '71' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio com Suspenso',
       TO_NUMBER(null),
       '72' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio a Alquota Zero',
       TO_NUMBER(null),
       '73' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio sem Inc Contrib',
       TO_NUMBER(null),
       '74' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio por ST',
       TO_NUMBER(null),
       '75' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Outras Operaes de Entrada',
       TO_NUMBER(null),
       '98' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Tributada',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-No Tributada',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Exportao',
       TO_NUMBER(null),
       '52' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Vinc Trib Export',
       TO_NUMBER(null),
       '54' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Vinc NTrib Export',
       TO_NUMBER(null),
       '55' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib Exp',
       TO_NUMBER(null),
       '56' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Exc Trib',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Exc NTrib',
       TO_NUMBER(null),
       '61' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Exc Export',
       TO_NUMBER(null),
       '62' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Trib NTrib',
       TO_NUMBER(null),
       '63' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITIPI',
       0,
       ' ',
       'Tributada',
       TO_NUMBER(null),
       '0' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITIPI',
       0,
       ' ',
       'Tributada com alquota zero',
       TO_NUMBER(null),
       '1' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITIPI',
       0,
       ' ',
       'Isenta',
       TO_NUMBER(null),
       '2' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITIPI',
       0,
       ' ',
       'No-tributada',
       TO_NUMBER(null),
       '3' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITIPI',
       0,
       ' ',
       'Imune',
       TO_NUMBER(null),
       '4' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITIPI',
       0,
       ' ',
       'Com suspenso',
       TO_NUMBER(null),
       '5' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITIPI',
       0,
       ' ',
       'Outras',
       TO_NUMBER(null),
       '9' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPIS',
       0,
       ' ',
       'Tributvel (base de clculo)',
       TO_NUMBER(null),
       '01' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPIS',
       0,
       ' ',
       'Ope. Trib. Alq. Diferenciada',
       TO_NUMBER(null),
       '02' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPIS',
       0,
       ' ',
       'Ope. Trib. Alq Und Med.Pro',
       TO_NUMBER(null),
       '03' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPIS',
       0,
       ' ',
       'Ope. Trib. Monofsica Rev.Alq',
       TO_NUMBER(null),
       '04' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPIS',
       0,
       ' ',
       'Ope. Trib. Substituio Trib.',
       TO_NUMBER(null),
       '05' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPIS',
       0,
       ' ',
       'Tributvel (alquota zero) ',
       TO_NUMBER(null),
       '06' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPIS',
       0,
       ' ',
       'Isenta da Contribuio ',
       TO_NUMBER(null),
       '07' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPIS',
       0,
       ' ',
       'Sem Incidncia da Contribuio',
       TO_NUMBER(null),
       '08' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPIS',
       0,
       ' ',
       'Com Suspenso da Contribuio ',
       TO_NUMBER(null),
       '09' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPIS',
       0,
       ' ',
       'Outras Operaes de Sada',
       TO_NUMBER(null),
       '49' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPIS',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Trib Export',
       TO_NUMBER(null),
       '64' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis NTrib Export',
       TO_NUMBER(null),
       '65' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Trib NTrib Exp',
       TO_NUMBER(null),
       '66' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Outras Operaes',
       TO_NUMBER(null),
       '67' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio sem Dir Crdito',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio com Iseno',
       TO_NUMBER(null),
       '71' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio com Suspenso',
       TO_NUMBER(null),
       '72' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio a Alquota Zero',
       TO_NUMBER(null),
       '73' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio sem Inc Contrib',
       TO_NUMBER(null),
       '74' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio por ST',
       TO_NUMBER(null),
       '75' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Outras Operaes de Entrada',
       TO_NUMBER(null),
       '98' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Tributada',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-No Tributada',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Exportao',
       TO_NUMBER(null),
       '52' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Vinc Trib Export',
       TO_NUMBER(null),
       '54' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Vinc NTrib Export',
       TO_NUMBER(null),
       '55' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib Exp',
       TO_NUMBER(null),
       '56' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Exc Trib',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Exc NTrib',
       TO_NUMBER(null),
       '61' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Exc Export',
       TO_NUMBER(null),
       '62' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Trib NTrib',
       TO_NUMBER(null),
       '63' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'TIPMAR',
       0,
       'M',
       'Marca',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'TIPMPB',
       0,
       'C',
       'Conj. CPU, Monitor e Mouse',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'TIPMPB',
       0,
       'T',
       'Tablet',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'TIPPRO',
       2,
       ' ',
       'Terceirizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'TIPPRO',
       0,
       ' ',
       'Material',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'TIPPRO',
       1,
       ' ',
       'Servio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'STATUSKIT',
       0,
       '',
       'KIT',
       TO_NUMBER(null),
       '1' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'STATUSKIT',
       0,
       '',
       'Normal',
       TO_NUMBER(null),
       '2' FROM DUAL
UNION ALL
SELECT 'IPRF',
       'STATUSKIT',
       0,
       '',
       'Item de KIT',
       TO_NUMBER(null),
       '3' FROM DUAL
);

/*-- SEQ 8322 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IPRO',
       TO_NUMBER(null),
       'IPRO',
       'Importa Produtos',
       'TI_PRO',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8323 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IPRO','--','' FROM DUAL
UNION ALL
SELECT 'IPRO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IPRO','02','Dados Bsicos' FROM DUAL
UNION ALL
SELECT 'IPRO','03','Dados dos Itens de Grade' FROM DUAL
UNION ALL
SELECT 'IPRO','04','Preo' FROM DUAL
UNION ALL
SELECT 'IPRO','05','Dados de Tributos' FROM DUAL
UNION ALL
SELECT 'IPRO','06','Controle' FROM DUAL
UNION ALL
SELECT 'IPRO','99','Outros' FROM DUAL
);

/*-- SEQ 8324 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IPRO',
       '02',
       10,
       1,
       'ATIVO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Produto~Ativo?',
       'Produto Ativo?',
       '',
       'ATIVO',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       20,
       2,
       'BRINDE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Brinde',
       'Brinde',
       '',
       'BRINDE',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       30,
       1,
       'CALSUB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Pro. c/Substituio',
       'Produto com Substituio',
       '',
       'CALSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       40,
       7,
       'CAL_CM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Clculo Custo M',
       'Data Cculo Custo Mdio',
       '',
       'CAL_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       50,
       6,
       'CFOCON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'CFOP~Consumidor Fin.',
       'Sufixo de CFOP para consumidor final',
       '',
       'CFOCON',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       60,
       6,
       'CFOREV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'CFOP~Revenda',
       'Sufixo de CFOP para revenda',
       '',
       'CFOREV',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       70,
       2,
       'CLASS1',
       'S',
       'DCL1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL1.CLASS1',
       'V',
       '',
       'F',
       'A',
       'F',
       '',
       'Cdigo da classe 1',
       'IPRO.CLASS1=DCL1.CODTAB (+)',
       'CLASS1',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       80,
       2,
       'CLASS2',
       'S',
       'DCL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL2.CLASS2',
       'V',
       '',
       'F',
       'A',
       'F',
       '',
       'Cdigo da classe 2',
       'IPRO.CLASS2=DCL2.CODTAB (+)',
       'CLASS2',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       90,
       2,
       'CLASS3',
       'S',
       'DCL3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL3.CLASS3',
       'V',
       '',
       'F',
       'A',
       'F',
       '',
       'Cdigo da classe 3',
       'IPRO.CLASS3=DCL3.CODTAB (+)',
       'CLASS3',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       100,
       2,
       'CLASS4',
       'S',
       'DCL4',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL4.CLASS4',
       'V',
       '',
       'F',
       'A',
       'F',
       '',
       'Cdigo da classe 4',
       'IPRO.CLASS4=DCL4.CODTAB (+)',
       'CLASS4',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       110,
       2,
       'CLSXYZ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'XYZ',
       'Classe XYZ',
       '',
       'CLSXYZ',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       1070,
       7,
       'CODCES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'CEST',
       'CEST',
       '',
       'CODCES',
       '' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       120,
       5,
       'CODCTR',
       'S',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       '',
       'N',
       'F',
       'Unidade de Negcios',
       'Unidade de Negcios',
       'DCTR.CODTAB = IPRO.CODCTR',
       'CODCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       130,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd. sistema~Origem',
       'Cdigo no sistema de Origem',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       140,
       20,
       'CODFAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do~fabricante',
       'Codigo do fabricante na tabela de parceiros',
       '',
       'CODFAB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       150,
       15,
       'CODFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo~Fiscal',
       'Cdigo Fiscal',
       '',
       'CODFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       160,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cd. Produto~Totali',
       'Cdigo do produto na Totali',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       170,
       20,
       'CODTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo de~Tributao',
       'Cdigo de Tributao',
       '',
       'CODTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       180,
       10,
       'CONAPL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Unidade Embalagem',
       'Converso para unidade de Embalagem',
       '',
       'CONAPL',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       190,
       1,
       'CONTRA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Produto  contrato?',
       'Determina se produto  do tipo contrato',
       '',
       'CONTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       200,
       1,
       'CONTRO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Controla Produtos?',
       'Produtos Controlados',
       '',
       'CONTRO',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       210,
       12,
       'CUSFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Custo Frete',
       'Custo Frete',
       '',
       'CUSFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       220,
       8,
       'CUSREP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Custo de Reposio',
       'Custo de reposio deste produto no estoque',
       '',
       'CUSREP',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       230,
       8,
       'DATCAD',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Incluso em',
       'Data do Cadastro',
       '',
       'DATCAD',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       240,
       8,
       'DATCOM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Ultima Compra',
       'Data da compra',
       '',
       'DATCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '06',
       250,
       7,
       'DATIMP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da~importao',
       'Data da importao',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       260,
       1,
       'DECIMA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Aceita~Decimais?',
       'Aceita casas decimais nas transaes (S/N)',
       '',
       'DECIMA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       270,
       2,
       'DEPART',
       'S',
       'DDEP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDEP.DESDEP',
       'V',
       '',
       'F',
       'A',
       'F',
       'Departamento',
       'Departamento do Produto',
       'PRO.DEPART=DDEP.CODTAB (+)',
       'DEPART',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       280,
       12,
       'DESCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Desconto',
       'Desconto',
       '',
       'DESCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       290,
       15,
       'DESECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Desc.~Resumida ECF',
       'Descrio Resumida p/ ECF',
       '',
       'DESECF',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       300,
       20,
       'DESGRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome da~Grade',
       'Nome da Grade',
       '',
       'DESGRA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       310,
       8,
       'DESIDE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Desconto Sugerido',
       'Desconto Sugerido',
       '',
       'DESIDE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       320,
       20,
       'DESINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo~Inatividade',
       'Motivo da Inatividade',
       '',
       'DESINA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       330,
       30,
       'DESMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Marca',
       'Marca',
       '',
       'DESMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       340,
       30,
       'DESMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Descrio',
       'Descrio do Produto',
       '',
       'DESMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       350,
       8,
       'DESMAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Desconto Mximo',
       'Desconto Mximo',
       '',
       'DESMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       360,
       1,
       'ENTREG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Entrega?',
       'Entrega?',
       '',
       'ENTREG',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       370,
       30,
       'ESPMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Especificao',
       'Especificao do Produto',
       '',
       'ESPMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       380,
       2,
       'ESTADO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF',
       'Unidade Federativa',
       '',
       'ESTADO',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '99',
       2020,
       1,
       'ESTCHE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Estoque Totali POS',
       'Controle de Estoque no Totali POS',
       '',
       'ESTCHE',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       390,
       2,
       'ETIQUE',
       'S',
       'DETI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DETI.DESETI',
       'V',
       '',
       'F',
       'A',
       'F',
       'Etiqueta',
       'Tipo de etiqueta',
       'IPRO.ETIQUE=DETI.CODTAB (+)',
       'ETIQUE',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       400,
       3,
       'FILMAT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial~Produto',
       'Filial onde foi cadastrado o produto',
       'IPRO.FILMAT = DFIL.CODFIL (+)',
       'FILMAT',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       410,
       1,
       'FORLIN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Fora de Linha?',
       'Fora de Linha',
       '',
       'FORLIN',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '01',
       2020,
       120,
       'GRA_DESGRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio da Grade',
       'Descrio da Grade',
       '',
       'GRA_DESGRA',
       '' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       420,
       12,
       'ICMCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'ICMS Compra',
       'ICMS Compra',
       '',
       'ICMCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       430,
       12,
       'ICMFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'ICMS Frete',
       'ICMS Frete',
       '',
       'ICMFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       440,
       1,
       'INSAGR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Insumo~Agrcola?',
       'Insumo Agrcola?',
       '',
       'INSAGR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       450,
       12,
       'IPICOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'IPI Compra',
       'IPI Compra',
       '',
       'IPICOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       460,
       20,
       'ITEDIV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Item de~Diviso',
       'Item de Diviso',
       '',
       'ITEDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       470,
       20,
       'ITESUB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Item de~Sub-Diviso',
       'Item de Sub-Diviso',
       '',
       'ITESUB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       2010,
       14,
       'ITESUB_FATCON',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Fator de Converso',
       'Fator de converso entre as divises',
       '',
       'ITESUB_FATCON',
       '' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       480,
       10,
       'LOCALI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Localizao',
       'Localizao',
       '',
       'LOCALI',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       490,
       5,
       'LUCSUB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Lucro~Substitudo',
       'Lucro Substitudo',
       '',
       'LUCSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       500,
       12,
       'MARKUP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Markup',
       'Markup',
       '',
       'MARKUP',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       1090,
       3,
       'MAXPAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Mximo de parcelas',
       'Nmero mximo de parcelas na venda',
       '',
       'MAXPAR',
       '' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       510,
       8,
       'MINQTD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Estoque Mnimo',
       'Estoque mnimo',
       '',
       'MINQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       520,
       1,
       'MONTAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo~Montagem',
       'Tipo Montagem',
       '',
       'MONTAR',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '06',
       530,
       255,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo da~Rejeio',
       'Motivo da Rejeio',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       1080,
       14,
       'MVAC04',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% MVA para Comp. 4%',
       '% MVA para Compra 4% (Margem de Valor Agregado ou Lucro Substitudo)',
       '',
       'MVAC04',
       '' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       540,
       20,
       'NOMDIV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Diviso',
       'Diviso',
       '',
       'NOMDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '99',
       1030,
       255,
       'NOMIMG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Imagem',
       'Imagem',
       '',
       'NOMIMG',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       560,
       20,
       'NOMSUB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub-Diviso',
       'Sub-Diviso',
       '',
       'NOMSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       2000,
       20,
       'NOMSUB_CODSAL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo Externo Saldo',
       'Cdigo Externo da Sub-Diviso do Saldo',
       '',
       'NOMSUB_CODSAL',
       '' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       570,
       0,
       'NUMEXT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Usa Nm. Externo?',
       'Nmero externo na Ordem de Servio',
       '',
       'NUMEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       580,
       2,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nm. Itens Kits',
       'Nmero de itens de um kit',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       590,
       10,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(IPRO.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       600,
       4000,
       'OBSGRA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao~da Grade',
       'Observao da Grade',
       '',
       'OBSGRA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       610,
       8,
       'PERCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Comissao',
       'Percentual de Comisso',
       '',
       'PERCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       620,
       8,
       'PERLUC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Lucro Bruto',
       'Lucro Bruto',
       '',
       'PERLUC',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       630,
       5,
       'PERSRV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '% Servio~R.E. 80/20',
       '% Servio R.E. 80/20',
       '',
       'PERSRV',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       640,
       14,
       'PESBRU',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Peso Bruto',
       'Peso bruto',
       '',
       'PESBRU',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       650,
       14,
       'PESLIQ',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Peso Lquido',
       'Peso lquido',
       '',
       'PESLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       660,
       8,
       'PRECOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Preo de Compra',
       'Preo de compra',
       '',
       'PRECOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '04',
       670,
       12,
       'PRECOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Preo~de Venda',
       'Preo de Venda',
       '',
       'PRECOV',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       680,
       1,
       'PREPSI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Preo Psicolgico?',
       'Preo Psicolgico',
       '',
       'PREPSI',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '99',
       2050,
       1,
       'PROCON',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Produto Controlado?',
       'Produto Controlado pela Polcia Federal',
       '',
       'PROCON',
       '' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       690,
       1,
       'PROMOC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Promocional?',
       'Indica se produto  promocional',
       '',
       'PROMOC',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       700,
       8,
       'PTOQTD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Ponto de Pedido',
       'Ponto de pedido',
       '',
       'PTOQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       710,
       12,
       'QTDCOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade Compra',
       'Quantidade Compra',
       '',
       'QTDCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       720,
       10,
       'QTDEMB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Contedo Embalagem',
       'Contedo da Embalagem',
       '',
       'QTDEMB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '99',
       2040,
       16,
       'QTDLIM_PF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Limite PF',
       'Quantidade Limite para Pessoa Fsica',
       '',
       'QTDLIM_PF',
       '' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '99',
       2030,
       16,
       'QTDLIM_PJ',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Limite PJ',
       'Quantidade Limite para Pessoa Jurdica',
       '',
       'QTDLIM_PJ',
       '' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       730,
       8,
       'QTDREP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Ideal de Reposio',
       'Quantidade ideal de reposiao',
       '',
       'QTDREP',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       740,
       5,
       'REDALI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base~Reduzida',
       'Base Reduzida',
       '',
       'REDALI',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       750,
       5,
       'REDESP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Alquota especial',
       'Alquota especial',
       '',
       'REDESP',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       760,
       5,
       'REDUC1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Reduo~7%',
       'Reduo para Estados com 7%',
       '',
       'REDUC1',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       770,
       5,
       'REDUC2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Reduo~12%',
       'Reduo para Estados com 12%',
       '',
       'REDUC2',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       780,
       5,
       'REDUME',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Reteno~Micro E.',
       '% Reteno Para Micro Empresa',
       '',
       'REDUME',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       790,
       15,
       'REFBAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Ref. Bsica',
       'Referncia Bsica do Produto',
       '',
       'REFBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       800,
       20,
       'REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Referncia',
       'Referncia do produto',
       '',
       'REFPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       810,
       1,
       'REGESP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       '9',
       'F',
       'Regime~Tributrio',
       'Regime Tributrio',
       '',
       'REGESP',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       820,
       5,
       'RESICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Alquota~de ICMS',
       'Alquota de ICMS',
       '',
       'RESICM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       830,
       5,
       'RESIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% IPI',
       '% IPI',
       '',
       'RESIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       840,
       5,
       'RESIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% IR',
       '% IR',
       '',
       'RESIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       850,
       1,
       'RETCOF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Reteno de~COFINS?',
       'Permite Reteno de COFINS?',
       '',
       'RETCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       860,
       20,
       'SAZONA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sazonalidade',
       'Sazonalidade',
       '',
       'SAZONA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       870,
       12,
       'SEGFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Seguro Frete',
       'Seguro Frete',
       '',
       'SEGFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '06',
       880,
       1,
       'STATUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Status da~importao',
       'Status da importao',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       890,
       12,
       'SUBCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Sub Diviso Compra',
       'Subdiviso Compra?',
       '',
       'SUBCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       1040,
       1,
       'SUBFED',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Subs.~Federal?',
       'Substituio Federal',
       '',
       'SUBFED',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       910,
       1,
       'SUBTRI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       '9',
       'F',
       'Subs.~Tributria',
       'Substituio Tributria',
       '',
       'SUBTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       920,
       12,
       'TAXCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Taxa Compra',
       'Taxa Compra',
       '',
       'TAXCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       930,
       2,
       'TEMREP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Tempo de Reposio',
       'Tempo de Reposio',
       '',
       'TEMREP',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '02',
       940,
       2,
       'TIPPRO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de~Produto',
       'Tipo de Produto',
       '',
       'TIPPRO',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       950,
       1,
       'TIPVAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'N',
       'F',
       'Expressa em',
       'Expressa em',
       '',
       'TIPVAL',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       960,
       5,
       'UNIAPL',
       'S',
       'DMED',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMED.UNIMED',
       'V',
       '',
       '',
       '9',
       'F',
       'Unidade Aplicao',
       'Unidade de Aplicao',
       'DMED.CODTAB(+) = IPRO.UNIAPL',
       'UNIAPL',
       'T' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       970,
       5,
       'UNIDAD',
       'S',
       'DMED',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMED.UNIMED',
       'V',
       '',
       'F',
       'N',
       'F',
       'Unidade de Venda',
       'Unidade de Venda',
       'DMED.CODTAB = IPRO.UNIDAD',
       'UNIDAD',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       980,
       5,
       'UNIEMB',
       'S',
       'DMED',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMED.UNIMED',
       'V',
       '',
       '',
       '0',
       'F',
       'Unidade Embalagem',
       'Unidade Embalagem',
       'DMED.CODTAB = IPRO.UNIEMB',
       'UNIEMB',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       990,
       5,
       'UNIFOR',
       'S',
       'DMED',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMED.UNIMED',
       'V',
       '',
       'F',
       'N',
       'F',
       'Unidade Compra',
       'Unidade Compra',
       'DMED.CODTAB = IPRO.UNIFOR',
       'UNIFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       1000,
       12,
       'VALCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Fator Converso',
       'Fator Converso',
       '',
       'VALCON',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       1010,
       5,
       'VALIDA',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Garantia~Validade',
       'Garantia/Validade',
       '',
       'VALIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       1060,
       15,
       'VLRCOF',
       'F',
       '',
       5,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Alq. COFINS por vlr',
       'Alquota de COFINS por valor',
       '',
       'VLRCOF',
       '' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '05',
       1050,
       15,
       'VLRPIS',
       'F',
       '',
       5,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Alq. de PIS por vlr',
       'Alquota de PIS por valor',
       '',
       'VLRPIS',
       '' FROM DUAL
UNION ALL
SELECT 'IPRO',
       '03',
       1020,
       1,
       'VOLUNI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Volume nico?',
       'Volume nico?',
       '',
       'VOLUNI',
       'F' FROM DUAL
);

/*-- SEQ 8325 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IPRO',
       'BRINDE',
       2,
       '-',
       ' Brinde',
       194,
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'BRINDE',
       1,
       '-',
       'Pode ser Brinde',
       193,
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'BRINDE',
       0,
       '-',
       'Nao  Brinde',
       192,
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'CALSUB',
       0,
       'D',
       'Destaca ICMS no clculo Subs.T',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'CALSUB',
       0,
       'R',
       'Retm ICMS no clculo Subs.Tri',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'CLSXYZ',
       2,
       '-',
       'Z',
       191,
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'CLSXYZ',
       1,
       '-',
       'Y',
       190,
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'CLSXYZ',
       0,
       '-',
       'X',
       189,
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'ESTCHE',
       0,
       ' ',
       'S on-line',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'ESTCHE',
       1,
       ' ',
       'Replicado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'ESTCHE',
       9,
       ' ',
       'No controla',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'MONTAR',
       0,
       'F',
       'Sem Montagem',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'MONTAR',
       0,
       'I',
       'Montagem Interna',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'MONTAR',
       0,
       'T',
       'Montagem na Entrega',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'REGESP',
       0,
       ' ',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'REGESP',
       1,
       ' ',
       'Especial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'SUBTRI',
       0,
       ' ',
       'Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'SUBTRI',
       1,
       ' ',
       'No tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'SUBTRI',
       2,
       ' ',
       'Isento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'SUBTRI',
       3,
       ' ',
       'Substitudo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'SUBTRI',
       4,
       ' ',
       'Isento no Estado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'TIPPRO',
       2,
       ' ',
       'Terceirizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'TIPPRO',
       0,
       ' ',
       'Material',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'TIPPRO',
       1,
       ' ',
       'Servio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'TIPVAL',
       0,
       ' ',
       'No Controla',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'TIPVAL',
       1,
       ' ',
       'Dias',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'TIPVAL',
       2,
       ' ',
       'Meses',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IPRO',
       'TIPVAL',
       3,
       ' ',
       'Anos',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8326 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IPT ',
       TO_NUMBER(null),
       'IPT ',
       'Item Prot. ou Conv. ',
       'TT_IPT',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'PTC.ID, IPT.NUMITE',
       '' FROM DUAL
);

/*-- SEQ 8327 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IPT ','--','' FROM DUAL
UNION ALL
SELECT 'IPT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IPT ','99','Outros' FROM DUAL
);

/*-- SEQ 8328 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20248,
       'PTC ',
       'IPT ',
       '1',
       'N',
       '',
       '',
       'IPT.CODFIL = PTC.CODFIL AND 
IPT.SEQUEN = PTC.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 8329 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IPT ',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'IPT ',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'IPT.CODFIL = DFIL.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'IPT ',
       '--',
       30,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'IPT ',
       '--',
       40,
       40,
       'DESIPT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio do Item',
       'Descrio do Item',
       '',
       'DESIPT',
       'F' FROM DUAL
UNION ALL
SELECT 'IPT ',
       '--',
       50,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero do item',
       'Nmero do item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IPT ',
       '--',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8330 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IQU ',
       TO_NUMBER(null),
       'IQU ',
       'Itens Questionrio',
       'TT_IQU',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'IQU.FILQUE,IQU.CODQUE,IQU.NUMIQV
QUE.ID,IQU.NUMIQV',
       '' FROM DUAL
);

/*-- SEQ 8331 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IQU ','--','' FROM DUAL
);

/*-- SEQ 8332 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5721,
       'PER ',
       'IQU ',
       '1 ',
       'N ',
       '',
       '',
       'PER.FILPER = IQU.FILPER and
PER.CODPER = IQU.CODPER',
       '' FROM DUAL
);

/*-- SEQ 8333 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IQU ',
       '--',
       4,
       5,
       'CODPER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo da Pergunta',
       'Cdigo da pergunta',
       '',
       'CODPER',
       'F' FROM DUAL
UNION ALL
SELECT 'IQU ',
       '--',
       2,
       5,
       'CODQUE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Questionrio',
       'Cdigo do questionrio',
       '',
       'CODQUE',
       'F' FROM DUAL
UNION ALL
SELECT 'IQU ',
       '--',
       5,
       3,
       'FILPER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial origem da pergunta',
       '',
       'FILPER',
       'F' FROM DUAL
UNION ALL
SELECT 'IQU ',
       '--',
       1,
       3,
       'FILQUE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do questionrio',
       'DFIL.CODFIL = IQU.FILQUE',
       'FILQUE',
       'F' FROM DUAL
UNION ALL
SELECT 'IQU ',
       '--',
       3,
       3,
       'NUMIQV',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nmero',
       'Nmero do Item',
       '',
       'NUMIQV',
       'F' FROM DUAL
);

/*-- SEQ 8334 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IRC ',
       TO_NUMBER(null),
       'IRC ',
       'Itens de Recepo',
       'TT_IRC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'IRC.CODFIL,IRC.SEQUEN,IRC.NUMITE
RCP.ID,IRC.NUMITE',
       '' FROM DUAL
);

/*-- SEQ 8335 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IRC ','--','' FROM DUAL
);

/*-- SEQ 8336 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5726,
       'GRA ',
       'IRC ',
       '1 ',
       'N ',
       '',
       '',
       'IRC.FILMAT = GRA.FILMAT and
IRC.CODMAT = GRA.CODMAT and
IRC.CODCOR = GRA.CODCOR and
IRC.CODTAM = GRA.CODTAM',
       '' FROM DUAL
UNION ALL
SELECT 5727,
       'RCP ',
       'IRC ',
       '1 ',
       'N ',
       '',
       '',
       'RCP.CODFIL = IRC.CODFIL and
RCP.SEQUEN = IRC.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8337 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IRC ',
       '--',
       9,
       20,
       'CODBUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cdigo de Busca',
       'Cdigo de Busca',
       '',
       'CODBUS',
       'F' FROM DUAL
UNION ALL
SELECT 'IRC ',
       '--',
       4,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Diviso',
       'IRC.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'IRC ',
       '--',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial ',
       'DFIL.CODFIL(+) = IRC.CODFIL',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'IRC ',
       '--',
       7,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Cdigo do Produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IRC ',
       '--',
       8,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso',
       'IRC.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'IRC ',
       '--',
       6,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial do produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IRC ',
       '--',
       3,
       5,
       'NUMITE',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nro do Item',
       'Nro do Item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IRC ',
       '--',
       5,
       12,
       'QTDITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtdade',
       'Qtdade',
       '',
       'QTDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IRC ',
       '--',
       10,
       12,
       'QTDITE_CON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtdade~Conv.',
       'Qtdade Convertida',
       '',
       'QTDCONVERTIDA(IRC.CODTAM,IRC.QTDITE)',
       'F' FROM DUAL
UNION ALL
SELECT 'IRC ',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8338 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IREC',
       TO_NUMBER(null),
       'IREC',
       'Importa. Recebimento',
       'TI_REC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8339 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IREC','--','' FROM DUAL
UNION ALL
SELECT 'IREC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IREC','02','Dados das parcelas a Receber' FROM DUAL
UNION ALL
SELECT 'IREC','99','Outros' FROM DUAL
);

/*-- SEQ 8340 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IREC',
       '02',
       10,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Data da ltima atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '99',
       20,
       5,
       'CARTAO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Carto',
       'Carto',
       '',
       'CARTAO',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '99',
       30,
       5,
       'CODAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo~da Agncia',
       'Cdigo da Agncia',
       '',
       'CODAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '99',
       40,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'T',
       'A',
       'F',
       'Cdigo~do Banco',
       'Cdigo do Banco',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '99',
       50,
       15,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Alternativo',
       'Cdigo Alternativo nico',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '02',
       60,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '02',
       70,
       2,
       'CODMOE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Moeda',
       'Cdigo da moeda',
       '',
       'CODMOE',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '02',
       80,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie da~Nota Fiscal',
       'Srie da Nota Fiscal',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '02',
       90,
       20,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo~Usurio',
       'Cdigo do Usurio',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '02',
       100,
       8,
       'CUPFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cupom Fiscal',
       'Cupom fiscal',
       '',
       'CUPFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '99',
       110,
       7,
       'DATFIS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fiscal',
       'Data Fiscal',
       '',
       'DATFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '02',
       120,
       7,
       'DATIMP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Importao',
       'Data da Importao',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '02',
       130,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '02',
       140,
       8,
       'DATVEN',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Vencimento',
       'Data de vencimento',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '02',
       150,
       3,
       'ECFREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero~ECF PGTO',
       'Nmero do ECF onde foi efetuado o pagamento',
       '',
       'ECFREC',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '02',
       160,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Filial Recebimento',
       'Cdigo da filial do recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '02',
       170,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'IREC',
       '02',
       180,
       255,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo da~Rejeio',
       'Motivo da Rejeio',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '99',
       190,
       6,
       'NUMCHE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero~do Cheque',
       'Nmero do Cheque',
       '',
       'NUMCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '99',
       200,
       10,
       'NUMCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero~C.Corrente',
       'Nmero da Conta Corrente',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '02',
       210,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       'ECF',
       'Nmero do ECF que recebeu a parcela',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '02',
       220,
       6,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero~Nota Fiscal',
       'Nmero da Nota Fiscal',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '02',
       230,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero~Parcela',
       'Nmero da Parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '02',
       240,
       8,
       'PAGAME',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data de Pagamento',
       'Data e hora de Pagamento',
       '',
       'PAGAME',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '02',
       250,
       2,
       'PORTAD',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'I',
       '',
       'F',
       '',
       'F',
       'Portador',
       'Cdigo do portador',
       'IREC.PORTAD=DCOB.CODTAB (+)',
       'PORTAD',
       'T' FROM DUAL
UNION ALL
SELECT 'IREC',
       '99',
       260,
       2,
       'RENEGO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Renegociao',
       'Renegociao',
       '',
       'RENEGO',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '99',
       270,
       2,
       'RENORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Origem Renegociao',
       'Origem Renegociao',
       '',
       'RENORI',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '02',
       280,
       1,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status da~importao',
       'Status da importao',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '02',
       290,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Sub-Parcela',
       'Nmero da sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '99',
       300,
       5,
       'TIPCCC',
       'S',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'I',
       '',
       '',
       '',
       'F',
       'Tipo Conta Corrente',
       'Tipo Conta Corrente',
       'DCCC.CODTAB(+) = REC.TIPCCC',
       'TIPCCC',
       'T' FROM DUAL
UNION ALL
SELECT 'IREC',
       '02',
       310,
       12,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr. Desconto',
       'Vlr. Desconto',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '02',
       320,
       12,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr. Parcela',
       'Valor da parcela',
       '',
       'VLRPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'IREC',
       '02',
       330,
       12,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr. Pago',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 8341 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IREC',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IREC',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IREC',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IREC',
       'FLGEST',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8342 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IRO ',
       TO_NUMBER(null),
       'IRO ',
       'Itens de Romaneio',
       'TT_IRO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'IRO.CODFIL,IRO.SEQUEN,IRO.FILVEN,IRO.SEQVEN,IRO.SEQCAN',
       '' FROM DUAL
);

/*-- SEQ 8343 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IRO ','--','' FROM DUAL
UNION ALL
SELECT 'IRO ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IRO ','99','Outros' FROM DUAL
);

/*-- SEQ 8344 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 52459,
       'VEN ',
       'IRO ',
       '1 ',
       '01',
       '',
       '',
       'IRO.FILVEN = VEN.CODFIL AND IRO.SEQVEN = VEN.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 8345 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IRO ',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'IRO ',
       '--',
       20,
       3,
       'CODALT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Alterao',
       'Cdigo Alterao',
       '',
       'CODALT',
       'F' FROM DUAL
UNION ALL
SELECT 'IRO ',
       '--',
       150,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'IRO ',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Codigo da filial',
       'IRO.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'IRO ',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'IRO.FILUSU = USU.FILUSU(+)  AND IRO.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'IRO ',
       '--',
       160,
       7,
       'DATENT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Entrega',
       'Data de Entrega',
       '',
       'DATENT',
       'F' FROM DUAL
UNION ALL
SELECT 'IRO ',
       '--',
       170,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Operao',
       'Data de Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'IRO ',
       '--',
       140,
       1,
       'ENTREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Entrega',
       'Entrega',
       '',
       'ENTREG',
       'T' FROM DUAL
UNION ALL
SELECT 'IRO ',
       '--',
       60,
       3,
       'FILALT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Alterao',
       'Filial Alterao',
       '',
       'FILALT',
       'F' FROM DUAL
UNION ALL
SELECT 'IRO ',
       '--',
       180,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'IRO ',
       '--',
       70,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'IRO ',
       '--',
       80,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Vendas',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IRO ',
       '--',
       90,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'IRO ',
       '--',
       100,
       255,
       'OBSERV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'IRO ',
       '--',
       110,
       10,
       'SEQCAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador de Cancelamento',
       '',
       'SEQCAN',
       'F' FROM DUAL
UNION ALL
SELECT 'IRO ',
       '--',
       120,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IRO ',
       '--',
       130,
       10,
       'SEQVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador de Venda',
       '',
       'SEQVEN',
       'F' FROM DUAL
);

/*-- SEQ 8346 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IRO ',
       'ENTREG',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IRO ',
       'ENTREG',
       0,
       'E',
       'Entregue',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IRO ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IRO ',
       'FLGEST',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8347 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ISAL',
       TO_NUMBER(null),
       'ISAL',
       'Imp.Saldo de Estoque',
       'TI_SAL',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8348 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ISAL','--','' FROM DUAL
UNION ALL
SELECT 'ISAL','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ISAL','02','Dados' FROM DUAL
UNION ALL
SELECT 'ISAL','03','Controle' FROM DUAL
UNION ALL
SELECT 'ISAL','99','Outros' FROM DUAL
);

/*-- SEQ 8349 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ISAL',
       '02',
       10,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd.Produto~Original',
       'Cdigo do produto no sistema original',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'ISAL',
       '02',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial do~saldo',
       'Filial do saldo',
       'DFIL.CODFIL = ISAL.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ISAL',
       '03',
       30,
       7,
       'DATIMP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da~importao',
       'Data da importao',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'ISAL',
       '02',
       40,
       30,
       'DESEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Estoque',
       'Descrio de qual estoque refere-se o saldo',
       '',
       'DESEST',
       'F' FROM DUAL
UNION ALL
SELECT 'ISAL',
       '02',
       50,
       7,
       'INI_CM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ini~Custo Mdio',
       'Data Ini.Custo Mdio',
       '',
       'INI_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'ISAL',
       '03',
       60,
       255,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo da~Rejeio',
       'Motivo da Rejeio',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'ISAL',
       '02',
       70,
       13,
       'PTOPED',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Ponto de~pedido',
       'Ponto de pedido',
       '',
       'PTOPED',
       'F' FROM DUAL
UNION ALL
SELECT 'ISAL',
       '02',
       80,
       13,
       'QTDEST',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde~Estoque',
       'Quantidade Estoque',
       '',
       'QTDEST',
       'F' FROM DUAL
UNION ALL
SELECT 'ISAL',
       '02',
       90,
       13,
       'QTDMIN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Quantidade~mnima',
       'Quantidade mnima',
       '',
       'QTDMIN',
       'F' FROM DUAL
UNION ALL
SELECT 'ISAL',
       '02',
       100,
       13,
       'QTDREP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Ideal de~Reposio',
       'Ideal de Reposio',
       '',
       'QTDREP',
       'F' FROM DUAL
UNION ALL
SELECT 'ISAL',
       '02',
       110,
       13,
       'QTD_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde Custo~Mdio',
       'Quantidade de Custo Mdio',
       '',
       'QTD_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'ISAL',
       '03',
       120,
       1,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status da~importao',
       'Status da~importao',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'ISAL',
       '02',
       130,
       16,
       'VLR_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr. Custo~M. Total',
       'Valor do custo mdio (total)',
       '',
       'VLR_CM',
       'F' FROM DUAL
);

/*-- SEQ 8350 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ISL ',
       TO_NUMBER(null),
       'ISL ',
       'Itens List.Presentes',
       'TT_ISL',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'ISL.CODFIL, ISL.SEQUEN, ISL.NUMITE',
       '' FROM DUAL
);

/*-- SEQ 8351 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ISL ','--','' FROM DUAL
UNION ALL
SELECT 'ISL ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ISL ','99','Outros' FROM DUAL
);

/*-- SEQ 8352 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 28987,
       'GRA ',
       'ISL ',
       '1',
       'N',
       '',
       '',
       'GRA.FILMAT = ISL.FILMAT and
GRA.CODMAT = ISL.CODMAT and
GRA.CODCOR = ISL.CODCOR and
GRA.CODTAM = ISL.CODTAM ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 28988,
       'SLI ',
       'ISL ',
       '1',
       'N',
       '',
       '',
       'SLI.CODFIL = ISL.CODFIL and
SLI.SEQUEN = ISL.SEQUEN
',
       '',
       '' FROM DUAL
);

/*-- SEQ 8353 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ISL ',
       '99',
       10,
       5,
       'CODCOR',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Diviso',
       'Diviso',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'ISL ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '9',
       'F',
       'Filial',
       'Filial',
       'ISL.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'ISL ',
       '99',
       30,
       5,
       'CODMAT',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Produto',
       'Cdigo do Produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ISL ',
       '99',
       40,
       5,
       'CODTAM',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Subdiviso',
       'Subdiviso',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'ISL ',
       '99',
       50,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Filial do Produto',
       'Filial do Produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ISL ',
       '01',
       60,
       5,
       'NUMITE',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Item',
       'Item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'ISL ',
       '01',
       70,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8354 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ITF ',
       TO_NUMBER(null),
       'ITF ',
       'Item carto',
       'TT_ITF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'ITF.CODFIL,ITF.SEQUEN,ITF.NUMITE',
       '' FROM DUAL
);

/*-- SEQ 8355 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ITF ','--','' FROM DUAL
UNION ALL
SELECT 'ITF ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ITF ','99','Outros' FROM DUAL
);

/*-- SEQ 8356 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 28198,
       'USU ',
       'ITF ',
       '1',
       'N',
       '',
       '',
       'USU.FILUSU = ITF.FILUSU and USU.CODUSU = ITF.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 8357 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ITF ',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Atualizao',
       'Atualizado em',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'ITF ',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Cdigo',
       'Cdigo',
       'DFIL.CODFIL = ITF.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ITF ',
       '--',
       30,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'ITF ',
       '--',
       40,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data pagamento',
       'Data do pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'ITF ',
       '--',
       50,
       7,
       'DATVEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data vencimento',
       'Data do vencimento',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'ITF ',
       '--',
       60,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'ITF ',
       '--',
       70,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'ITF ',
       '--',
       80,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Item',
       'Nmero do item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'ITF ',
       '--',
       90,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'ITF ',
       '--',
       120,
       1,
       'STATUS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Conciliado',
       'Conciliado',
       '',
       'CASE WHEN (SELECT COUNT(*) 
             FROM TI_ITF IITF
             WHERE ITF.CODFIL = IITF.FILTEF
               AND ITF.SEQUEN = IITF.SEQTEF
               AND IITF.STATUS = 1
          )>0 THEN ''T''
     ELSE ''F''
END',
       '' FROM DUAL
UNION ALL
SELECT 'ITF ',
       '--',
       100,
       14,
       'VLRITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor do item',
       'Valor do item',
       '',
       'VLRITE',
       'F' FROM DUAL
UNION ALL
SELECT 'ITF ',
       '--',
       110,
       14,
       'VLRTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor da taxa',
       'Valor da taxa',
       '',
       'VLRTAX',
       'F' FROM DUAL
);

/*-- SEQ 8358 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ITF ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ITF ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ITF ',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8359 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ITI ',
       TO_NUMBER(null),
       'ITI ',
       'Item de Tinta',
       'TT_ITI',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8360 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ITI ','--','' FROM DUAL
UNION ALL
SELECT 'ITI ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ITI ','99','Outros' FROM DUAL
);

/*-- SEQ 8361 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22181,
       'TIN ',
       'ITI ',
       'N',
       '1',
       '',
       '',
       'TIN.CODFIL = ITI.CODFIL AND
TIN.SEQUEN = ITI.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22182,
       'GXSC',
       'ITI ',
       '1',
       '0N',
       '',
       '',
       'GXSC.CODFIL = ITI.FILCXS AND
GXSC.ID = ITI.ID_CXS',
       '',
       '' FROM DUAL
);

/*-- SEQ 8362 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ITI ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = ITI.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'ITI ',
       '99',
       20,
       3,
       'FILCXS',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Fil. GradeXSelfColor',
       'Filial Grade X SelfColor',
       'DFIL.CODFIL = ITI.FILCXS',
       'FILCXS',
       'F' FROM DUAL
UNION ALL
SELECT 'ITI ',
       '99',
       80,
       1,
       'FLGATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Ativo?',
       '',
       'FLGATI',
       '' FROM DUAL
UNION ALL
SELECT 'ITI ',
       '99',
       50,
       10,
       'ID_CXS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Seq. GradeXSelfColor',
       'Sequenciador Grade X SelfColor',
       '',
       'ID_CXS',
       'F' FROM DUAL
UNION ALL
SELECT 'ITI ',
       '01',
       30,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero do Item',
       'Nmero do Item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'ITI ',
       '99',
       40,
       16,
       'QTDITE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Quantidade',
       'Quantidade',
       '',
       'QTDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'ITI ',
       '01',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'ITI ',
       '99',
       70,
       1,
       'TIPITI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Item Tinta',
       'Tipo Item Tinta',
       '',
       'TIPITI',
       'T' FROM DUAL
);

/*-- SEQ 8363 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ITI ',
       'TIPITI',
       0,
       'B',
       'Base',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ITI ',
       'TIPITI',
       0,
       'C',
       'Colorante',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8364 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ITP ',
       TO_NUMBER(null),
       'ITP ',
       'ndice Tc. Produo',
       'TT_ITP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'ITP.CODFIL, ITP.SEQUEN, ITP.FILMAT, ITP.CODMAT, ITP.CODCOR, ITP.CODTAM',
       '' FROM DUAL
);

/*-- SEQ 8365 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ITP ','--','' FROM DUAL
UNION ALL
SELECT 'ITP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ITP ','99','Outros' FROM DUAL
);

/*-- SEQ 8366 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20266,
       'VIPR',
       'ITP ',
       '1',
       '01',
       '',
       '',
       'ITP.FILMAT = VIPR.FILMAT AND 
ITP.CODMAT = VIPR.CODMAT AND 
ITP.CODCOR = VIPR.CODCOR AND 
ITP.CODTAM = VIPR.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20267,
       'GRA ',
       'ITP ',
       '1',
       '0N',
       '',
       '',
       'ITP.FILINS = GRA.FILMAT AND
ITP.CODINS = GRA.CODMAT AND
ITP.CORINS = GRA.CODCOR AND
ITP.TAMINS = GRA.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 8367 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'ITP ',
       '--',
       20,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'ITP ',
       '--',
       30,
       5,
       'CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Div. Produto Prprio',
       'Diviso do Produto Prprio',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'ITP ',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'ITP ',
       '--',
       40,
       5,
       'CODINS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Insumo',
       'Cdigo do Insumo',
       '',
       'CODINS',
       'F' FROM DUAL
UNION ALL
SELECT 'ITP ',
       '--',
       50,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cd. Produto Prprio',
       'Cdigo do Produto Prprio',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ITP ',
       '--',
       60,
       5,
       'CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Sub. Produto Prprio',
       'Sub-Diviso do Produto Prprio',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'ITP ',
       '--',
       70,
       5,
       'CORINS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Diviso do Insumo',
       'Diviso do Insumo',
       '',
       'CORINS',
       'F' FROM DUAL
UNION ALL
SELECT 'ITP ',
       '--',
       80,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'ITP ',
       '--',
       90,
       3,
       'FILINS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial do Insumo',
       'Filial do Insumo',
       '',
       'FILINS',
       'F' FROM DUAL
UNION ALL
SELECT 'ITP ',
       '--',
       100,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fil. Produto Prprio',
       'Filial do Produto Prprio',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'ITP ',
       '--',
       110,
       12,
       'QTDINS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Quantidade do Insumo',
       'Quantidade do Insumo',
       '',
       'QTDINS',
       'F' FROM DUAL
UNION ALL
SELECT 'ITP ',
       '--',
       120,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'ITP ',
       '--',
       130,
       5,
       'TAMINS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'SubDiviso do Insumo',
       'Sub-Diviso do Insumo',
       '',
       'TAMINS',
       'F' FROM DUAL
);

/*-- SEQ 8368 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IUF ',
       TO_NUMBER(null),
       'IUF ',
       'Impostos Estaduais',
       'TT_IUF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'IUF.FILMAT,IUF.CODMAT,IUF.ESTADO',
       '' FROM DUAL
);

/*-- SEQ 8369 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IUF ','--','' FROM DUAL
UNION ALL
SELECT 'IUF ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IUF ','99','Outros' FROM DUAL
);

/*-- SEQ 8370 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21536,
       'DICM',
       'IUF ',
       'N',
       '1',
       '',
       '',
       'DICM.CODTAB = IUF.RESICM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21537,
       'PRO ',
       'IUF ',
       '01',
       '01',
       '',
       '',
       'PRO.FILMAT = IUF.FILMAT AND
PRO.CODMAT = IUF.CODMAT',
       '',
       '' FROM DUAL
);

/*-- SEQ 8371 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'IUF ',
       '99',
       490,
       5,
       'ALIDIF',
       'G',
       'DICM',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TO_CHAR(DICM.RESICM)',
       'V',
       '',
       '',
       'N',
       '',
       '% Alq. Diferenciada',
       '% Alquota Interna Diferenciada',
       'DICM.CODTAB = IUF.ALIDIF',
       'ALIDIF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '--',
       260,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Assinatura para PAF-ECF',
       '',
       'ASSINA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       210,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Atualizao',
       'Data da Atualizao',
       '',
       'ATU_EM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '01',
       140,
       2,
       'CALSUB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Produto Substituio',
       'Produto com Substituio',
       '',
       'CALSUB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       370,
       10,
       'CODBEN_00',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd.Benef. Fiscal 00',
       'Cdigo de Benefcio Fiscal no CST 00',
       '',
       'CODBEN_00',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       380,
       10,
       'CODBEN_10',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd.Benef. Fiscal 10',
       'Cdigo de Benefcio Fiscal no CST 10',
       '',
       'CODBEN_10',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       390,
       10,
       'CODBEN_20',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd.Benef. Fiscal 20',
       'Cdigo de Benefcio Fiscal no CST 20',
       '',
       'CODBEN_20',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       400,
       10,
       'CODBEN_30',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd.Benef. Fiscal 30',
       'Cdigo de Benefcio Fiscal no CST 30',
       '',
       'CODBEN_30',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       410,
       10,
       'CODBEN_40',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd.Benef. Fiscal 40',
       'Cdigo de Benefcio Fiscal no CST 40',
       '',
       'CODBEN_40',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       420,
       10,
       'CODBEN_41',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd.Benef. Fiscal 41',
       'Cdigo de Benefcio Fiscal no CST 41',
       '',
       'CODBEN_41',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       430,
       10,
       'CODBEN_50',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd.Benef. Fiscal 50',
       'Cdigo de Benefcio Fiscal no CST 50',
       '',
       'CODBEN_50',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       440,
       10,
       'CODBEN_51',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd.Benef. Fiscal 51',
       'Cdigo de Benefcio Fiscal no CST 51',
       '',
       'CODBEN_51',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       450,
       10,
       'CODBEN_60',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd.Benef. Fiscal 60',
       'Cdigo de Benefcio Fiscal no CST 60',
       '',
       'CODBEN_60',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       460,
       10,
       'CODBEN_70',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd.Benef. Fiscal 70',
       'Cdigo de Benefcio Fiscal no CST 70',
       '',
       'CODBEN_70',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       470,
       10,
       'CODBEN_90',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd.Benef. Fiscal 90',
       'Cdigo de Benefcio Fiscal no CST 90',
       '',
       'CODBEN_90',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '01',
       220,
       5,
       'CODCFP',
       'S',
       'DCFP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCFP.DESCFP',
       'V',
       '',
       '',
       '0',
       'F',
       'Cdigo CFOP',
       'Cdigo CFOP',
       'DCFP.CODTAB(+) = IUF.CODCFP',
       'CODCFP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '01',
       10,
       5,
       'CODFIS',
       'S',
       'DFIS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIS.CODFIS',
       'V',
       '',
       '',
       'N',
       'F',
       'Codigo Fiscal',
       'Cdigo Fiscal',
       'DFIS.CODTAB = IUF.CODFIS',
       'CODFIS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '01',
       20,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo do Produto',
       'Cdigo do Produto',
       '',
       'CODMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '01',
       150,
       2,
       'CODTRI',
       'S',
       'DTRI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DTRI.CODTRI',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cd. Tributrio',
       'Cdigo de tributao',
       'DTRI.CODTAB(+) = IUF.CODTRI',
       'CODTRI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '--',
       270,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Identificao de Acesso',
       '',
       'CODUID',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '--',
       280,
       1,
       'DUMMY',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DUMMY',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '01',
       30,
       2,
       'ESTADO',
       'A',
       'DEST',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEST.ESTADO',
       'V',
       '',
       '',
       'A',
       'F',
       'UF',
       'Unidade Federativa',
       'DEST.ESTADO = IUF.ESTADO',
       'ESTADO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '01',
       40,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial do Produto',
       'Filial do Produto',
       '',
       'FILMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '--',
       310,
       1,
       'FLGRED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Regras para Reduo ',
       'Regras para Reduo de Alquota',
       '',
       'FLGRED',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '--',
       290,
       1,
       'ICMISE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Isento de ICMS?',
       'Isento de ICMS?',
       '',
       'ICMISE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       50,
       1,
       'INSAGR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Insumo~Agropecurio?',
       'Tem insumo agropecurio Deduzido?',
       '',
       'INSAGR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       60,
       5,
       'LUCSUB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Lucro~Substitudo',
       'Lucro Substituido',
       '',
       'LUCSUB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       360,
       14,
       'MVAC04',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       '',
       '% MVA para Comp. 4%',
       '% MVA para Compra 4% (Margem de Valor Agregado ou Lucro Substitudo)',
       '',
       'MVAC04',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       240,
       14,
       'MVAC07',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       '% MVA para Compra 7%',
       '% MVA para Compra 7% (Margem de Valor Agregado ou Lucro Substitudo)',
       '',
       'MVAC07',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       250,
       14,
       'MVAC12',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       '% MVA para Comp. 12%',
       '% MVA para Compra 12% (Margem de Valor Agregado ou Lucro Substitudo)',
       '',
       'MVAC12',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       230,
       14,
       'MVAVEN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       '% MVA para Venda',
       '% MVA para Venda (Margem de Valor Agregado ou Lucro Substitudo)',
       '',
       'MVAVEN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       480,
       7,
       'PERDIF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% ICMS Diferimento',
       '% ICMS Diferimento',
       '',
       'PERDIF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       350,
       5,
       'PERFCP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Fundo Comb Pobreza',
       '% do Fundo de Combate  Pobreza na UF',
       '',
       'PERFCP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       200,
       5,
       'PERSRV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Servio R.E. 80/20',
       '% Servio Regime Especial 80/20',
       '',
       'PERSRV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       70,
       5,
       'REDALI',
       'S',
       'DIRE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TO_CHAR(DIRE.ICMSRE)',
       'V',
       '',
       '',
       'N',
       'F',
       'Base~Reduzida',
       'Base Reduzida',
       'DIRE.CODTAB(+) = IUF.REDALI',
       'REDALI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       510,
       5,
       'REDDIFAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '% Reduo DIFAL',
       'Percentual de Reduo do DIFAL/Partilha',
       '',
       'REDDIFAL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       80,
       5,
       'REDESP',
       'S',
       'DIES',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TO_CHAR(DIES.ICMSES)',
       'V',
       '',
       '',
       'N',
       'F',
       'Aliquota~Especial',
       'Alquota especial',
       'DIES.CODTAB(+) = IUF.REDESP',
       'REDESP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '--',
       330,
       1,
       'REDICM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Red ICMS na ST?',
       'Reduz base de ICMS no clculo do valor de ICMS prprio?',
       '',
       'REDICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       340,
       5,
       'REDINT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Red. ICMS Interest',
       '% Reduo de ICMS para Operaes Interestaduais com este Destino',
       '',
       'REDINT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '--',
       300,
       6,
       'REDSIM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Red. p/ Base ST Simp',
       'Reduo para Base ST Simples',
       '',
       'REDSIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       90,
       5,
       'REDUC1',
       'S',
       'DIR1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TO_CHAR(DIR1.ICMSR1)',
       'V',
       '',
       '',
       'N',
       'F',
       'Red. 7%',
       'Reduo para Estados com 7%',
       'DIR1.CODTAB(+) = IUF.REDUC1',
       'REDUC1',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       100,
       5,
       'REDUC2',
       'S',
       'DIR2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TO_CHAR(DIR2.ICMSR2)',
       'V',
       '',
       '',
       'N',
       'F',
       'Red. 12%',
       'Reduo para Estados com 12%',
       'DIR2.CODTAB(+) = IUF.REDUC2',
       'REDUC2',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       110,
       5,
       'REDUME',
       'S',
       'DIME',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TO_CHAR(DIME.ICMSME)',
       'V',
       '',
       '',
       'N',
       'F',
       'Reteno ME',
       '% Retencao Para Micro Empresa',
       'DIME.CODTAB(+) = IUF.REDUME',
       'REDUME',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       500,
       1,
       'REGDIF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Regra p/ Alq. Dif',
       'Regra para Alquota Diferenciada',
       '',
       'REGDIF',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '01',
       180,
       1,
       'REGESP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Regime Tributrio',
       'Regime Tributrio',
       '',
       'REGESP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '--',
       320,
       1,
       'REGESPIMP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Reg Especial Imp?',
       'Regime Especial para Importao?',
       '',
       'REGESPIMP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       120,
       5,
       'RESICM',
       'S',
       'DICM',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TO_CHAR(DICM.RESICM)',
       'V',
       '',
       '',
       'N',
       'F',
       'ICMS',
       'Alquota ICMS',
       'DICM.CODTAB(+) = IUF.RESICM',
       'RESICM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IUF ',
       '99',
       130,
       1,
       'SUBTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Subst~Tributria',
       'Substituio Tributria',
       '',
       'COALESCE(IUF.SUBTRI,''@'')',
       'T',
       'D' FROM DUAL
);

/*-- SEQ 8372 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IUF ',
       'FLGRED',
       0,
       'C',
       'Reduo somente para contribui',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IUF ',
       'FLGRED',
       0,
       'E',
       'Red p/ jurdica exceto revenda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IUF ',
       'FLGRED',
       0,
       'J',
       'Reduo para pessoas jurdicas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IUF ',
       'FLGRED',
       0,
       'R',
       'Reduo somente para revendas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IUF ',
       'REGDIF',
       0,
       'C',
       'Para contribuintes (Ambos)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IUF ',
       'REGDIF',
       0,
       'J',
       'Para pessoas jurdicas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IUF ',
       'REGDIF',
       0,
       'N',
       'Para contribuintes (Normal)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IUF ',
       'REGDIF',
       0,
       'R',
       'Para revendas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IUF ',
       'REGESP',
       0,
       ' ',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IUF ',
       'REGESP',
       1,
       ' ',
       'Especial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IUF ',
       'SUBTRI',
       0,
       '0',
       'Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IUF ',
       'SUBTRI',
       0,
       '1',
       'Nao Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IUF ',
       'SUBTRI',
       0,
       '2',
       'Isento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IUF ',
       'SUBTRI',
       0,
       '3',
       'Substituido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IUF ',
       'SUBTRI',
       0,
       '4',
       'Isento no Estado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IUF ',
       'SUBTRI',
       0,
       '@',
       'Vazio',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8373 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IVE ',
       TO_NUMBER(null),
       'IVE ',
       'Itens de Venda',
       'TT_IVE',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'IVE.SEQUEN,IVE.CODFIL,IVE.NUMITE
VEN.ID,IVE.NUMITE
IVE.NUMEXT',
       '' FROM DUAL
);

/*-- SEQ 8374 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IVE ','--','' FROM DUAL
UNION ALL
SELECT 'IVE ','01','Identificacao' FROM DUAL
UNION ALL
SELECT 'IVE ','03','Produto' FROM DUAL
UNION ALL
SELECT 'IVE ','04','Dados' FROM DUAL
UNION ALL
SELECT 'IVE ','05','Datas' FROM DUAL
UNION ALL
SELECT 'IVE ','06','Valores' FROM DUAL
UNION ALL
SELECT 'IVE ','07','Naturezas' FROM DUAL
UNION ALL
SELECT 'IVE ','08','Farmcia' FROM DUAL
UNION ALL
SELECT 'IVE ','09','Parmetro Custo Reposio' FROM DUAL
UNION ALL
SELECT 'IVE ','40','Tributaes' FROM DUAL
UNION ALL
SELECT 'IVE ','41','Retenes em Servios' FROM DUAL
UNION ALL
SELECT 'IVE ','45','MP do BEM' FROM DUAL
UNION ALL
SELECT 'IVE ','99','Outros' FROM DUAL
);

/*-- SEQ 8375 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 36408,
       'DNAT',
       'IVE ',
       '01',
       '1',
       '',
       '',
       '(IVE.NATFIS = DNAT.NATFOR OR
IVE.NATFIS = DNAT.NATDEN)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36409,
       'MER ',
       'IVE ',
       '01',
       '0N',
       '',
       '',
       'IVE.FILOIP = MER.CODFIL(+) AND
IVE.SEQOIP = MER.SEQUEN(+) AND
IVE.NUMADI = MER.NUMITE(+) AND
IVE.SEQMER = MER.SEQMER(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36410,
       'CES ',
       'IVE ',
       '01',
       '0N',
       '',
       '',
       'CES.CODCES(+) = IVE.CODCES',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36411,
       'BSC ',
       'IVE ',
       '01',
       '0N',
       '',
       '',
       'IVE.FILBSC = BSC.CODFIL(+) AND
IVE.ID_BSC = BSC.ID(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36412,
       'CSC ',
       'IVE ',
       '01',
       '0N',
       '',
       '',
       'IVE.FILBSC = CSC.CODFIL(+) AND
IVE.ID_BSC = CSC.ID(+) AND
IVE.ITECSC = CSC.NUMITE(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36413,
       'LOT ',
       'IVE ',
       '0N',
       '01',
       '',
       '',
       'LOT.CODFIL(+) = IVE.FILLOT and
LOT.SEQUEN(+) = IVE.SEQLOT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36414,
       'DFIL',
       'IVE ',
       '1',
       'N',
       '',
       '',
       'DFIL.CODFIL = IVE.CODFIL',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36415,
       'DBIC',
       'IVE ',
       '1',
       'N',
       '',
       '',
       'IVE.FILBIC = DBIC.FILBIC AND
IVE.SEQFIL = DBIC.SEQFIL',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36416,
       'GRA ',
       'IVE ',
       '1',
       '0N',
       '',
       '',
       'GRA.FILMAT = IVE.FILMAT(+) and
GRA.CODMAT = IVE.CODMAT(+) and
GRA.CODCOR = IVE.CODCOR(+) and
GRA.CODTAM = IVE.CODTAM(+)
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36417,
       'IVI ',
       'IVE ',
       '01',
       '1',
       '',
       '',
       'IVE.CODFIL = IVI.FILORI(+) AND
IVE.SEQUEN = IVI.NUMORI(+) AND
IVE.NUMITE = IVI.ITEORI(+) AND
''C'' <> IVI.SITMOV (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36418,
       'TRA ',
       'IVE ',
       '1',
       'N',
       '',
       '',
       'TRA.FILIVE = IVE.CODFIL AND
TRA.SEQIVE = IVE.SEQUEN AND
TRA.NUMIVE = IVE.NUMITE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36419,
       'USU ',
       'IVE ',
       '1',
       'N',
       '',
       '',
       'USU.FILUSU = IVE.FILVDD AND
USU.CODUSU = IVE.CODVDD',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36420,
       'VIPR',
       'IVE ',
       '1',
       '1',
       '',
       '',
       'VIPR.FILMAT = IVE.FILMAT and
VIPR.CODMAT = IVE.CODMAT and
VIPR.CODCOR = IVE.CODCOR and
VIPR.CODTAM = IVE.CODTAM
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36421,
       'ICO ',
       'IVE ',
       '01',
       '1',
       '',
       '',
       'IVE.FILICOORI = ICO.CODFIL(+) AND
IVE.SEQICOORI = ICO.SEQUEN(+) AND
IVE.NUMICOORI = ICO.NUMITE(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36422,
       'IPRF',
       'IVE ',
       '1',
       '1',
       '',
       '',
       'IPRF.FILMAT = IVE.FILMAT and
IPRF.CODMAT = IVE.CODMAT and
IPRF.CODCOR = IVE.CODCOR and
IPRF.CODTAM = IVE.CODTAM
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36423,
       'IPR2',
       'IVE ',
       '1',
       '1',
       '',
       '',
       'IPR2.FILMAT = IVE.FILMAT and
IPR2.CODMAT = IVE.CODMAT and
IPR2.CODCOR = IVE.CODCOR and
IPR2.CODTAM = COALESCE(IVE.EMBORI,IVE.CODTAM)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36424,
       'VFAT',
       'IVE ',
       '01',
       '1',
       '',
       '',
       '(IVE.CODFIL = VFAT.DEVFILREM (+) AND
 IVE.SEQUEN = VFAT.DEVSEQREM (+) AND
 IVE.NUMITE = VFAT.DEVITEREM (+))
OR
(IVE.CODFIL = VFAT.DEVFILFAT (+) AND
 IVE.SEQUEN = VFAT.DEVSEQFAT (+) AND
 IVE.NUMITE = VFAT.DEVITEFAT (+))',
       '',
       '' FROM DUAL
UNION ALL
SELECT 37101,
       'CPM ',
       'IVE ',
       '0N',
       '01',
       '',
       '',
       'IVE.FILCPM = CPM.FILCPM(+) AND
IVE.SEQCPM = CPM.SEQUEN(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8376 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'IVE ',
       '09',
       11720,
       3,
       ':IVE.CODFIL_CUSREP',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Fil. Custo Reposio',
       'Filial para Custo de Reposio',
       'IVE.:IVE.CODFIL_CUSREP = DFIL.CODFIL',
       ':IVE.CODFIL_CUSREP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       1290,
       7,
       'ABASTE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Abastecimento',
       'Data do Abastecimento',
       '',
       'ABASTE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       1400,
       16,
       'ALICOFVLR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Alq. COFINS por Vlr',
       'Alquota de COFINS por Valor',
       '',
       'ALICOFVLR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       1360,
       16,
       'ALIPISVLR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Alq. de PIS por Vlr',
       'Alquota de PIS por Valor',
       '',
       'ALIPISVLR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       1160,
       7,
       'ALISIM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% ICMS Crdito Simpl',
       '% ICMS Crdito Simples',
       '',
       'ALISIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       1110,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Assinatura para PAF-ECF',
       '',
       'ASSINA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       1091,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN IVE.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '05',
       12210,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Atualizao',
       'Data Atualizao',
       '',
       'ATU_EM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       1040,
       12,
       'BASCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Base do Cofins',
       'Base do Cofins',
       '',
       'BASCOF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '41',
       12170,
       12,
       'BASCOFRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base PIS/COF/CSL ret',
       'Base de PIS/COFINS/CSLL retido',
       '',
       'BASCOFRET',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       560,
       12,
       'BASECALCULO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Base Clculo',
       'Base Clculo',
       '',
       '(CASE WHEN IVE.TIP001=''M'' AND IVE.TAX001<>0 THEN ive.VLRMOV + ROUND((IVE.VLRMOV * VEN.DESCON / 100),2) ELSE 0 END)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12320,
       12,
       'BASEFE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base Efetiva',
       'Valor da base de clculo efetiva',
       '',
       'BASEFE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12210,
       14,
       'BASFCP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base do FCP',
       'Valor da Base de Clculo do FCP',
       '',
       'BASFCP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12280,
       14,
       'BASFCP_RET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base do FCP ST Ret',
       'Valor da Base de Clculo do FCP retido anteriormente por ST',
       '',
       'BASFCP_RET',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12250,
       14,
       'BASFCP_ST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base do FCP ST',
       'Valor da Base de Clculo do FCP retido por Substituio Tributria',
       '',
       'BASFCP_ST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       910,
       12,
       'BASICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base ICMS',
       'Base ICMS',
       '',
       'BASICM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       1390,
       12,
       'BASICMDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Base ICMS Destino',
       'Base de ICMS na UF de Destino (Valor Integral)',
       '',
       'BASICMDES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12430,
       16,
       'BASICM_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Base ICMS CM',
       'Base ICMS para Recalculo do Custo Mdio',
       '',
       'BASICM_CM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       940,
       12,
       'BASIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Base do IPI',
       'Base do IPI',
       '',
       'BASIPI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       11640,
       12,
       'BASIPICAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base IPI Calculado',
       'Base do IPI Calculado',
       '',
       'BASIPICAL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       12520,
       12,
       'BASIRR',
       'F',
       '',
       3,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Base IRRF',
       'Base IRRF',
       '',
       'BASIRR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       960,
       12,
       'BASISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Base do ISS',
       'Base do ISS',
       '',
       'BASISS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       1000,
       12,
       'BASPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Base do PIS',
       'Base do PIS',
       '',
       'BASPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12600,
       12,
       'BASSOC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base Contr. Social',
       'Base Contribuio Social',
       '',
       'BASSOC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       1250,
       12,
       'BASUBS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Vlr BC ICMS ST UF D.',
       'Valor da BC do ICMS ST da UF destino',
       '',
       'BASUBS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       11940,
       12,
       'BAS_II',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base II',
       'Valor da Base de Clculo do Imposto de Importao',
       '',
       'BAS_II',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12450,
       16,
       'BAS_ST_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Base ST CM',
       'Base ST para Recalculo do Custo Mdio',
       '',
       'BAS_ST_CM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       1170,
       14,
       'BAS_ST_COM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Vlr BC do ICMS Retid',
       'Valor da BC do ICMS Retido Anteriormente',
       '',
       'BAS_ST_COM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       690,
       1,
       'CALSUB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Produto Substitudo',
       'Produto Substitudo',
       '',
       'CALSUB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       1410,
       10,
       'CODABA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       '',
       'Cdigo Abastecimento',
       'Cdigo Abastecimento',
       '',
       'CODABA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12400,
       10,
       'CODBEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd Benefcio Fiscal',
       'Cdigo de Benefcio Fiscal',
       '',
       'CODBEN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       11870,
       7,
       'CODCES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'CEST',
       'CEST',
       '',
       'CODCES',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       1590,
       5,
       'CODCNC',
       'G',
       'DCNC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCNC.NOMCNC',
       'V',
       '',
       '',
       'N',
       '',
       'Concorrente',
       'Cdigo do Concorrente que motivou a Variao de Preos',
       'DCNC.CODTAB = IVE.CODCNC',
       'CODCNC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '03',
       240,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       'IVE ',
       30,
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       '9',
       'F',
       'Cor~Produto',
       'Codigo da cor (diviso)',
       'DIV.CODITE (+) = IVE.CODCOR',
       'CODCOR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       1100,
       3,
       'CODCST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'CST ICMS',
       'CST ICMS',
       '',
       'CODCST',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       1280,
       20,
       'CODEAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo EAN',
       'Cdigo EAN',
       '',
       'CODEAN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       11880,
       3,
       'CODENQ',
       'S',
       'ENQ ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'ENQ.DESENQ',
       'V',
       '',
       '',
       'N',
       'F',
       'Cd Enquad IPI',
       'Cdigo de Enquadramento Legal do IPI',
       'ENQ.CODENQ(+) = IVE.CODENQ',
       'CODENQ',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12130,
       36,
       'CODFCI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo FCI',
       'Cdigo FCI',
       '',
       'CODFCI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       110,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       'IVE ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'T',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL(+) = IVE.CODFIL',
       'CODFIL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12540,
       10,
       'CODIBG_INCIDENCIA',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Municpio Incidncia',
       'Municpio Incidncia',
       '',
       'CODIBG_INCIDENCIA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '03',
       11541,
       20,
       'CODIGO',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo Fiscal',
       'Cdigo Fiscal',
       '',
       'CAST(IVE.FILMAT || '' '' || IVE.CODMAT || ''-'' || IVE.CODCOR || ''-'' || IVE.CODTAM AS VARCHAR(20))',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '03',
       230,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IVE ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo~Produto',
       'Codigo do produto',
       '',
       'CODMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       1580,
       5,
       'CODMOT',
       'G',
       'DMVP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMVP.DESMOT',
       'V',
       '',
       '',
       'N',
       '',
       'Mot. Variao Preos',
       'Cdigo do Motivo da Variao de Preos',
       'DMVP.CODTAB = IVE.CODMOT',
       'CODMOT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       100,
       5,
       'CODMUL',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       'F',
       'Sub-Estoque',
       'Nome do Sub-Estoque',
       'DMUL.CODTAB = IVE.CODMUL',
       'CODMUL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       1190,
       1,
       'CODORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Origem da Mercadoria',
       'Origem da Mercadoria',
       '',
       'CODORI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '03',
       250,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       'IVE ',
       40,
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       '9',
       'F',
       'Tamanho~Produto',
       'Cdigo do tamanho (sub-diviso)',
       'SUB.CODITE (+) = IVE.CODTAM',
       'CODTAM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       1120,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Identificao de Acesso',
       '',
       'CODUID',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       430,
       3,
       'CODVDD',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Vendedor',
       'Cdigo Vendedor',
       'IVE.FILVDD = USU.FILUSU(+)  AND IVE.CODVDD = USU.CODUSU(+)',
       'CODVDD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       670,
       3,
       'CODVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo Vendedor',
       'Cdigo Vendedor (Item)',
       '',
       'COALESCE(CODVDD,(SELECT CODVEN FROM TT_VEN VEN WHERE VEN.CODFIL=IVE.CODFIL AND VEN.SEQUEN=IVE.SEQUEN))',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       11521,
       9,
       'COMIND',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Comisso Indicador',
       'Comisso para Indicador',
       '',
       'COMIND',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       170,
       9,
       'COMISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Comisso',
       'Comisso',
       '',
       'COMISS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       11800,
       12,
       'CUSMAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Custo Markup',
       'Custo Markup',
       '',
       'CUSMAR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       11690,
       14,
       'CUSMED_FIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Custo Mdio Fiscal',
       'Custo Mdio Fiscal',
       '',
       'CUSMED_FIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       11740,
       14,
       'CUSPRO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Custo Produto',
       'Custo Produto',
       '',
       'CUSPRO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '09',
       11710,
       14,
       'CUSREP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Custo Reposio',
       'Custo de Reposio',
       '',
       'CUSTOREPOSICAODATA(IVE.VEN_DATHOR, IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM, :IVE.CODFIL_CUSREP, IVE.CODMUL)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       11680,
       14,
       'CUSREP_FREFIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Custo lt. Entrada',
       'Custo da ltima Entrada',
       '',
       'CUSREP_FREFIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       11700,
       14,
       'CUSSIM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Custo Simulado',
       'Custo de Reposio Simulado',
       '',
       'CUSSIM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       253,
       12,
       'CUSTOMEDIO_TOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'C.Financ. Fiscal Tot',
       'Custo Financeiro Fiscal Total (Custo Mdio Fiscal x Qtde Fiscal)',
       '',
       '(CASE WHEN ((COALESCE(IVE.TOT_CM,0) = 0) AND (IVE.LANEST <> ''N'')) OR COALESCE(IVE.SAL_CM,0) = 0 THEN CUSTOMEDIO(IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,3,IVE.VEN_DATHOR) ELSE IVE.TOT_CM / IVE.SAL_CM END * IVE.QTDMOV)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       273,
       12,
       'CUSTOMEDIO_UNI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       '',
       'Custo Medio Fiscal',
       'Custo Mdio Fiscal Unitrio',
       '',
       '(CASE WHEN (COALESCE(IVE.TOT_CM,0)=0 AND (IVE.LANEST <> ''N'')) OR COALESCE(IVE.SAL_CM,0) = 0 THEN CUSTOMEDIO(IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,3,IVE.VEN_DATHOR) ELSE IVE.TOT_CM / IVE.SAL_CM END)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       403,
       12,
       'CUSTO_FGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'C.Financ. Geren. Tot',
       'Custo Financeiro Gerencial Total (Custo Mdio Gerencial x Qtde Fiscal)',
       '',
       '(CASE WHEN (COALESCE(IVE.TOTCMG,0)=0 AND (IVE.LANEST <> ''N'')) OR (COALESCE(IVE.SAL_CM,0) = 0) THEN CUSTOMEDIO(IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,5,IVE.VEN_DATHOR) ELSE IVE.TOTCMG / IVE.SAL_CM END * IVE.QTDMOV)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       404,
       12,
       'CUSTO_FGT_UNI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Custo Medio Gerenc.',
       'Custo Mdio Gerencial Unitrio',
       '',
       '(CASE WHEN (COALESCE(IVE.TOTCMG,0)=0 AND (IVE.LANEST <> ''N'')) OR COALESCE(IVE.SAL_CM,0) = 0 THEN CUSTOMEDIO(IVE.CODFIL,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,5,IVE.VEN_DATHOR) ELSE IVE.TOTCMG / IVE.SAL_CM END)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       12090,
       7,
       'DATCAN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Cancelamento',
       'Data/Hora do Cancelamento',
       '',
       'DATCAN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '05',
       570,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       1370,
       12,
       'DESICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Vlr iseno de ICMS',
       'Valor de iseno de ICMS',
       '',
       'DESICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       11550,
       30,
       'DESITE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio do Item',
       'Descrio do Item informado na nota (produto de uso interno)',
       '',
       'DESITE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       1300,
       12,
       'DESRAT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr do desconto rat',
       'Valor do desconto rateado',
       '',
       'DESRAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       700,
       1,
       'DEVVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Devolve vinculo',
       'Devolve vinculo',
       '',
       'DEVVIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       30,
       1,
       'DUMMY',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       '',
       'Controle Interno',
       '',
       'DUMMY',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '04',
       380,
       5,
       'EMBORI',
       'G',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       '9',
       'F',
       'Embalagem Original',
       'Embalagem Original',
       'IVE.EMBORI=SUB.CODITE(+)',
       'EMBORI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       370,
       12,
       'EMBQTD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Quantidade Original',
       'Quantidade Original',
       '',
       'EMBQTD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       1560,
       1,
       'ESTORN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Item estornado',
       'Item estornado',
       '',
       'ESTORN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       1100,
       12,
       'ESTPEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Estorno Qtd Pendente',
       'Estorno da Quantidade Pendente',
       '',
       'ESTPEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       11810,
       1,
       'EXPFIS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exportado Fiscal?',
       'Exportado Fiscal?',
       '',
       'EXPFIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       180,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exportar?',
       'Exportar',
       '',
       'EXPORT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       450,
       3,
       'FILBIC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Bico Comb.',
       '',
       'FILBIC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       1530,
       3,
       'FILBSC',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       '',
       'Filial da fabricao',
       'Filial em que foi registrada a fabricao',
       'DFIL.CODFIL(+) = IVE.FILBSC',
       'FILBSC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12620,
       3,
       'FILCPM',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Promoo',
       'Filial Promoo',
       'DFIL.CODFIL(+) = IVE.FILCPM',
       'FILCPM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       11680,
       3,
       'FILDEV',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial devoluo',
       'Filial em que foi feita a devoluo',
       'DFIL.CODFIL(+) = IVE.FILDEV',
       'FILDEV',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       710,
       3,
       'FILDOU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial do Mdico',
       'Filial do Mdico',
       '',
       'FILDOU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       1455,
       3,
       'FILICOORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Item Compra',
       'Filial Item Compra',
       '',
       'FILICOORI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       1490,
       3,
       'FILLOT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial Lote',
       'Filial do Lote',
       'DFIL.CODFIL(+) = IVE.FILLOT',
       'FILLOT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '03',
       220,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IVE ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial~Produto',
       'Filial de incluso do produto',
       '',
       'FILMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12050,
       3,
       'FILOIP',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial DI',
       'Filial da Declarao de Importao',
       'DFIL.CODFIL = IVE.FILOIP(+)',
       'FILOIP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '05',
       530,
       3,
       'FILORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial de Origem',
       '',
       'FILORI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       720,
       3,
       'FILRCT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Receita',
       'Filial Receita',
       '',
       'FILRCT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       11570,
       3,
       'FILRES',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial de Reserva',
       'Filial de Reserva',
       'DFIL.CODFIL(+) = IVE.FILRES',
       'FILRES',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       440,
       3,
       'FILVDD',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'A',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Vendedor',
       'IVE.FILVDD = USU.FILUSU(+) AND IVE.CODVDD = USU.CODUSU(+)',
       'FILVDD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       650,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Filial Vendedor',
       'Filial Vendedor (Item)',
       '',
       'COALESCE(FILVDD,(SELECT FILVEN FROM TT_VEN VEN WHERE VEN.CODFIL=IVE.CODFIL AND VEN.SEQUEN=IVE.SEQUEN))',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       510,
       3,
       'FIL_RESERVA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Filial de~Reserva',
       'Filial de Reserva',
       '',
       '(SELECT P.FILRES FROM TT_IOR P WHERE P.FILIVE = IVE.CODFIL AND P.SEQIVE = IVE.SEQUEN AND P.NUMIVE = IVE.NUMITE) ',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       810,
       1,
       'FLGFUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Est. Entrega Futura',
       'Estado Entrega Futura',
       '',
       'FLGFUT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       11820,
       1,
       'FRMPRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Formador de Preo',
       'Formador de Preo',
       '',
       'FRMPRE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '04',
       390,
       30,
       'GETORIGEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Origem',
       'Origem',
       '',
       'GETORIGEM(IVE.FILORI,IVE.NUMORI,IVE.ITEORI)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       1310,
       7,
       'ICMINT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'ICMS interno do dest',
       'ICMS interno do destino',
       '',
       'ICMINT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       11910,
       6,
       'ICMINTDES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Alquota Interna Des',
       'Alquota nas Operaes Internas na UF do Destinatrio para Partilha ICMS',
       '',
       'ICMINTDES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       20,
       1,
       'ICMTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       '9',
       'F',
       'Tipo Tributao',
       'Tipo de tributao do produto',
       '',
       'ICMTIP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       1540,
       10,
       'ID_BSC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'ID da fabricao',
       'Identificador nico com SQ no banco.',
       '',
       'ID_BSC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       900,
       1,
       'IMPKIT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Itens KIT Impressos',
       'Itens do KIT Impressos',
       '',
       'IMPKIT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       1200,
       1,
       'INDREP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Repasse ICMS ST Ret.',
       'Repasse ICMS ST Ret.?',
       '',
       'INDREP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       11670,
       5,
       'IPITRA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Frao IPI Transf',
       'Frao do IPI na Transferncia',
       '',
       'IPITRA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '04',
       870,
       12,
       'ISEICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Base ICMS Isento',
       'Base ICMS Isento',
       '',
       'ISEICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       1550,
       5,
       'ITECSC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Item da fabricao',
       'Item sequencial da colorao',
       '',
       'ITECSC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       1560,
       5,
       'ITEFIS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nmero item Fiscal',
       'Nmero do item Fiscal',
       '',
       'ITEFIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       160,
       2,
       'ITEORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'IVE ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Item de Origem',
       '',
       'ITEORI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       12420,
       10,
       'ITEPEDCOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'N Item Compra Cli.',
       'Item do Pedido de Compra do Cliente',
       '',
       'ITEPEDCOM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       500,
       20,
       'ITE_PEDIDO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Item de~Pedido',
       'Item de Pedido',
       '',
       '(SELECT P.CODFIL || ''-'' || P.NUMPED || '','' || LTRIM(TO_CHAR(P.NUMITE,''999'')) FROM TT_IOR P WHERE P.FILIVE = IVE.CODFIL AND P.SEQIVE = IVE.SEQUEN AND P.NUMIVE = IVE.NUMITE)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       1445,
       5,
       'KITORI',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'N',
       'F',
       'Item Header do Kit',
       'Item Header do Kit',
       '',
       'KITORI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '04',
       350,
       1,
       'LANEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'T',
       'Estoque',
       'Estoque',
       '',
       'LANEST',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '45',
       1420,
       12,
       'LUCROBRUTO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       '',
       'Lucro Bruto',
       'Lucro Bruto da MP do BEM',
       '',
       '(SELECT BI_LUCBRU(VEN.CODFIL,VEN.VLRLIQ,VEN.VLRNOT,IVE.VLRMOV,IVE.QTDMOV,IVE.QTDMPB,IVE.VLR001,IVE.TOT_CM,IVE.LANEST,IVE.SAL_CM,IVE.FILMAT,IVE.CODMAT,IVE.CODCOR,IVE.CODTAM,IVE.VEN_DATHOR,F.VENPIS,F.VENCOF) FROM TD_FIL F WHERE F.CODFIL=VEN.CODFIL)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12380,
       2,
       'MOTDESON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Mot desonerao ICMS',
       'Motivo da desonerao do ICMS',
       '',
       'MOTDESON',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       1071,
       14,
       'MVAORI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'MVA Original',
       'MVA Original',
       '',
       '(SELECT MVAIUF.MVAVEN FROM TT_IUF MVAIUF INNER JOIN TD_FIL MVAFIL ON MVAIUF.ESTADO = MVAFIL.UFLOJA AND MVAIUF.REGESP = MVAFIL.REGESP WHERE MVAIUF.FILMAT = IVE.FILMAT AND MVAIUF.CODMAT = IVE.CODMAT AND MVAFIL.CODFIL = IVE.CODFIL)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       1150,
       14,
       'MVAVEN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'MVA no Momento da Ve',
       'MVA no Momento da Venda',
       '',
       'MVAVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       1440,
       2,
       'NATBCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Nat. Crd. PIS/Cofin',
       'Cdigo da Base de Clculo de Crdito de PIS/Cofins',
       '',
       'NATBCC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '07',
       615,
       6,
       'NATFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Natureza Fiscal',
       'Natureza fiscal',
       '',
       'COALESCE(IVE.NATFIS,CAST((SELECT NaturezaVenda(VEN.UFLOJA,IVE.ICMTIP,NAT.NATDEN,NAT.NATFOR,VEN.SUBSTT)||''00'' FROM TT_VEN VEN INNER JOIN TD_NAT NAT ON NAT.CODTAB=VEN.CODNAT WHERE VEN.CODFIL=IVE.CODFIL AND VEN.SEQUEN=IVE.SEQUEN) AS CHAR(6)))',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '07',
       620,
       6,
       'NATFISDEN',
       'A',
       'DNAT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DNAT.NATURE',
       'V',
       '',
       '',
       'A',
       'F',
       'Nat.Fis~dentro do UF',
       'Natureza Fiscal',
       'DNAT.NATDEN(+) = IVE.NATFIS',
       'NATFIS',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '07',
       630,
       6,
       'NATFISFOR',
       'A',
       'DNAT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DNAT.NATURE',
       'V',
       '',
       '',
       'A',
       '',
       'Nat.Fis~fora do UF',
       'Nat.Fis~fora do UF',
       'DNAT.NATFOR(+) = IVE.NATFIS',
       'NATFIS',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '07',
       640,
       6,
       'NATFISORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Natureza Fiscal Orig',
       'Natureza Fiscal (sem subconsulta)',
       '',
       'NATFIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '04',
       385,
       4000,
       'NOTASVINCULADAS',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Notas Vinculadas',
       'Notas Vinculadas',
       '',
       'RTF2TXT(NOTASVINCULADAS(IVE.CODFIL,IVE.SEQUEN,IVE.NUMITE))',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12070,
       3,
       'NUMADI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nmero da Adio DI',
       'Nmero da Adio na Declarao de Importao',
       '',
       'NUMADI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       115,
       3,
       'NUMCODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       120,
       40,
       'NUMEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IVE ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'T',
       'Nm. Externo',
       'Nmero externo',
       '',
       'NUMEXT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       1140,
       20,
       'NUMEXT_DEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm Externo p/ depos',
       'Nmero Externo para Depsito',
       '',
       'NUMEXT_DEP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       1470,
       5,
       'NUMICOORI',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'N',
       'F',
       'Nm. Item Compra',
       'Nm. Item Compra',
       '',
       'NUMICOORI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       130,
       2,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'IVE ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'T',
       'Item',
       'Nmero do item',
       '',
       'NUMITE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       150,
       10,
       'NUMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IVE ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       '',
       'Nmero da Origem',
       '',
       'NUMORI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       12410,
       20,
       'NUMPEDCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'N Ped Compra Cli.',
       'Nmero do Pedido de Compra do Cliente',
       '',
       'NUMPEDCOM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12550,
       4000,
       'OBSERV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       400,
       10,
       'ORD_CM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Orden. Custo Mdio',
       'Ordenao Custo Mdio',
       '',
       'ORD_CM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '04',
       300,
       30,
       'ORIGEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Origem',
       'Venda Origem',
       '',
       'SUBSTR(GETORIGEM(IVE.CODFIL,IVE.NUMORI,IVE.ITEORI),1,30)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '04',
       880,
       12,
       'OUTICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Base ICMS Outros',
       'Base ICMS Outros',
       '',
       'OUTICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       1210,
       12,
       'OUTTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vlr Outras Desp Aces',
       'Valor de Outras Despesas Acessrias',
       '',
       'OUTTAX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       1080,
       1,
       'PENATU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Proc. Devol. Separ.',
       'Precisa processar devoluo de separao?',
       '',
       'PENATU',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       1030,
       7,
       'PERCOF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Percentual de Cofins',
       'Percentual de Cofins',
       '',
       'PERCOF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       11990,
       6,
       'PERCOFCRE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% COFINS Credit',
       '% COFINS Creditvel',
       '',
       'PERCOFCRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12240,
       6,
       'PERCON_ST',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Alquota Cons. Final',
       'Alquota suportada pelo Consumidor Final',
       '',
       'PERCON_ST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12560,
       5,
       'PERDEDISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Deduo Base ISS',
       '% Deduo Base ISS',
       '',
       'PERDEDISS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12110,
       7,
       'PERDIF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Diferimento',
       '% Diferimento de ICMS',
       '',
       'PERDIF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12330,
       6,
       'PEREFE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Alquota Efetiva',
       'Alquota do ICMS efetiva',
       '',
       'PEREFE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12220,
       6,
       'PERFCP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% FCP',
       '% do ICMS relativo ao Fundo de Combate  Pobreza (FCP)',
       '',
       'PERFCP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       11830,
       5,
       'PERFCPDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Fundo Pob. UF Dest',
       '% do Fundo de Pobreza na UF de Destino',
       '',
       'PERFCPDES',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12290,
       6,
       'PERFCP_RET',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% FCP ST Ret.',
       '% do FCP retido anteriormente por Substituio Tributria',
       '',
       'PERFCP_RET',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12260,
       6,
       'PERFCP_ST',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% FCP ST',
       '% do FCP retido por Substituio Tributria',
       '',
       'PERFCP_ST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       11790,
       10,
       'PERLUC',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Percentual de Lucro',
       'Percentual de Lucro',
       '',
       'PERLUC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       1220,
       5,
       'PEROPP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Percentual da BC Ope',
       'Percentual da BC Operao Prpria',
       '',
       'PEROPP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       1430,
       5,
       'PERPARICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% da Partilha ICMS',
       '% da Partilha de ICMS para UF de Destino',
       '',
       'PERPARICM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       990,
       7,
       'PERPIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Percentual de PIS',
       'Percentual de PIS',
       '',
       'PERPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       11970,
       6,
       'PERPISCRE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% PIS Credit',
       '% PIS Creditvel',
       '',
       'PERPISCRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12570,
       5,
       'PERREDISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Reduo Base ISS',
       '% Reduo Base ISS',
       '',
       'PERREDISS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12590,
       5,
       'PERSOC',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Contr. Social',
       '% Contribuio Social',
       '',
       'PERSOC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       840,
       10,
       'PRECOPROMOCIONALPORIVE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Preo Promocional',
       'Preo Promocional',
       '',
       'PRECOPROMOCIONALPORIVE(IVE.CODFIL, IVE.SEQUEN, IVE.FILMAT, IVE.CODMAT, IVE.CODCOR, IVE.CODTAM)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       1520,
       12,
       'PRECO_TOT_VENDA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Preo total venda',
       'Preco total da venda',
       '',
       '(SELECT CASE WHEN COALESCE(VIN.VLRNOT,0) = 0 THEN 0.000001 ELSE NVLZ(COALESCE( (IVE.VLRMOV-IVE.VLR002) * (VIN.VLRLIQ/NVLZ(VIN.VLRNOT,NULL)), 0),NULL) END FROM TT_VEN VIN WHERE IVE.CODFIL = VIN.CODFIL AND IVE.SEQUEN = VIN.SEQUEN)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       1130,
       14,
       'PREFIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       '',
       '',
       '',
       'PREFIS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       1090,
       14,
       'PREFIS ',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Preo Fiscal',
       'Preo Fiscal (Mximo, Sugesto ou Pauta)',
       '',
       'PREFIS ',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       11730,
       12,
       'PRESIM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Preo Sim. Compra',
       'Preo Simulado para Compra',
       '',
       '(SELECT F.PRESIM FROM TT_PXF F, TT_PRO P WHERE IVE.FILMAT=P.FILMAT AND IVE.CODMAT=P.CODMAT AND IVE.FILMAT=F.FILMAT AND IVE.CODMAT=F.CODMAT AND IVE.CODCOR=F.CODCOR AND IVE.CODTAM=F.CODTAM AND P.FILMAR=F.FILFOR AND P.CODMAR=F.CODFOR)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       890,
       1,
       'PROMOC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Promocional?',
       'Promocional?',
       '',
       'PROMOC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       11620,
       1,
       'PROSUG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Produto sugerido?',
       'Produto sugerido?',
       '',
       'PROSUG',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       310,
       8,
       'QTDDEVOLVIDA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Qtdade Devolvida',
       'Quantidade devolvida',
       '',
       'CASE WHEN IVE.QTDMOV = 0 THEN 0 ELSE QTDDEVOLVIDA(IVE.CODFIL,IVE.SEQUEN,IVE.NUMITE) END',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       290,
       8,
       'QTDENT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtdade Entregue',
       'Quantidade entregue',
       '',
       'CASE WHEN IVE.QTDMOV = 0 THEN 0 ELSE QTDENTREGUE(IVE.CODFIL,IVE.SEQUEN,IVE.NUMITE) END',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       820,
       12,
       'QTDFUT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtde Entrega Futura',
       'Quantidade Entrega Futura',
       '',
       'QTDFUT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       260,
       8,
       'QTDMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       'IVE ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'T',
       'Qtde',
       'Quantidade vendida',
       '',
       'QTDMOV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       270,
       8,
       'QTDMOV_CON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtde~Conv.',
       'Quantidade vendida Convertida',
       '',
       'QTDCONVERTIDA(IVE.CODTAM, IVE.QTDMOV)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '45',
       1380,
       12,
       'QTDMPB',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtde Ite Ise PisCof',
       'Quantidade de Itens Isentados de PIS/COFINS',
       '',
       'QTDMPB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       830,
       12,
       'QTDPEN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Quantidade Pendente',
       'Quantidade Pendente',
       '',
       'QTDPEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       730,
       14,
       'QTDPRE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Quantidade Pescrita',
       'Quantidade Pescrita',
       '',
       'QTDPRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       11560,
       12,
       'QTDSUG_ORC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Qtde. Sugerida Orc.',
       'Quantidade sugerida no oramento.',
       '',
       'COALESCE((SELECT COALESCE(CASE PROSUG WHEN ''T'' THEN QTDITE ELSE 0 END,0) FROM TT_IOR WHERE FILIVE = IVE.CODFIL AND SEQIVE = IVE.SEQUEN AND NUMIVE = IVE.NUMITE),0)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       410,
       12,
       'QTD_CM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde Custo Medio',
       'Quantidade Custo Mdio',
       '',
       'QTD_CM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12310,
       7,
       'REDEFE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Reduo Base Efetiva',
       'Percentual de reduo da base de clculo efetiva',
       '',
       'REDEFE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       10,
       7,
       'REDITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base reduzida ICMS',
       'Base reduzida de ICMS do item',
       '',
       'REDITE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       1320,
       7,
       'REDSUB',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% red base Subst ite',
       'Percentual de reduo de base de substituio do item',
       '',
       'REDSUB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12520,
       1,
       'RESTRI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Restrio Veculo',
       'Restrio do Veculo',
       '',
       'RESTRI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       740,
       16,
       'SAL_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Saldo',
       'Saldo',
       '',
       'SAL_CM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12510,
       16,
       'SAL_CMORI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Saldo CM Original',
       'Saldo Custo Mdio Original (antes do recalc)',
       '',
       'SAL_CMORI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12630,
       10,
       'SEQCPM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Seq. Promoo',
       'Sequncia Promoo',
       '',
       'SEQCPM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       750,
       10,
       'SEQDOU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. do Mdico',
       'Sequenciador do Mdico',
       '',
       'SEQDOU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       460,
       2,
       'SEQFIL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '',
       'Nmero sequencial do bico na filial',
       '',
       'SEQFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       1460,
       10,
       'SEQICOORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Seq. Item Compra',
       'Seq. Item Compra',
       '',
       'SEQICOORI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       1500,
       10,
       'SEQLOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq Lote',
       'Sequenciador do Lote',
       '',
       'SEQLOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12080,
       3,
       'SEQMER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Seq Mercadoria DI',
       'Nmero Sequencial da Mercadoria na Declarao de Importao',
       '',
       'SEQMER',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12060,
       10,
       'SEQOIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq DI',
       'Sequenciador da Declarao de Importao',
       '',
       'SEQOIP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       760,
       10,
       'SEQRCT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador Receita',
       'Sequenciador Receita',
       '',
       'SEQRCT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       50,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IVE ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       1090,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN IVE.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       1020,
       2,
       'SITCOF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Sit. Trib. Cofins',
       'Situao Tributria do Cofins',
       '',
       'SITCOF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       930,
       2,
       'SITIPI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Sit. Tributria IPI ',
       'Situao Tributria do IPI',
       '',
       'SITIPI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       1270,
       1,
       'SITISS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Cdigo de Tributao',
       'Cdigo de Tributao do ISSQN',
       '',
       'SITISS',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '04',
       320,
       1,
       'SITKIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IVE ',
       20,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'T',
       'Kit',
       'Situao de Kit',
       '',
       'SITKIT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '04',
       330,
       1,
       'SITMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IVE ',
       30,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'T',
       'Situao',
       'Normal ou Cancelado',
       '',
       'SITMOV',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       980,
       2,
       'SITPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Sit. Tributria PIS',
       'Situao Tributria do PIS',
       '',
       'SITPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       770,
       5,
       'SITTRI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SITTRI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       1510,
       5,
       'SUBFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '% Subsdo p/ Frete',
       '% Subsdo p/ Frete',
       '',
       'SUBFRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       1260,
       12,
       'SUBSTT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Vlr ICMS ST UF Dest.',
       'Valor do ICMS ST da UF destino',
       '',
       'SUBSTT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       1490,
       12,
       'SUBSTT_FUT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       '',
       'Valor de ST Embutido em Outras Taxas para Utilizao Vnc. Fut (Remessa)',
       '',
       'SUBSTT_FUT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       70,
       7,
       'TAX001',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '%ICMS ou %ISS',
       'ICMS(Qdo Mat.)a TAXA002=IPI e ISS(Qdo Serv.) a TAXA002=IRRF e/ou COFINS',
       '',
       'TAXICM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       80,
       7,
       'TAX002',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '%IPI ou %IRRF',
       'Aliquota ISS(A TAXA002 pode mudar conforme descrio da TAXA001',
       '',
       'TAX002',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '41',
       12190,
       4,
       'TAXCOFRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% de COFINS retido',
       'Alquota de COFINS retido',
       '',
       'TAXCOFRET',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       1060,
       7,
       'TAXICM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Taxa de ICMS',
       'Taxa de ICMS',
       '',
       'TAXICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       11930,
       6,
       'TAXICMDES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Alq. Interestadual',
       'Alquota Interestadual da Partilha de ICMS',
       '',
       'TAXICMDES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       1070,
       7,
       'TAXIPI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Taxa de IPI',
       'Taxa de IPI',
       '',
       'TAXIPI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       11630,
       6,
       'TAXIPICAL',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Taxa IPI Calculado',
       'Taxa de IPI Calculado',
       '',
       'TAXIPICAL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       640,
       4,
       'TAXIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       '%IRRF',
       '% IRRF',
       '',
       'TAXIRR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       650,
       7,
       'TAXISS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '%ISS',
       '%ISS',
       '',
       'TAXISS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '41',
       12180,
       4,
       'TAXPISRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% de PIS retido',
       'Alquota de PIS retido',
       '',
       'TAXPISRET',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '41',
       12200,
       4,
       'TAXSOCRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% de CSLL retido',
       'Alquota de CSLL retido',
       '',
       'TAXSOCRET',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12350,
       1,
       'TEMDES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Aceita Desconto?',
       'Aceita Desconto',
       '',
       'TEMDES',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       90,
       1,
       'TIP001',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tributado',
       'Tributado',
       '',
       'TIP001',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12530,
       1,
       'TIPOPE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Tipo Operao Veic.',
       'Tipo de Operao Vecular',
       '',
       'TIPOPE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '04',
       360,
       1,
       'TIPPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       60,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'T',
       'Tipo Produto',
       'Tipo Produto',
       '',
       'TIPPRO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       780,
       16,
       'TOTCMG',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Total CM ger',
       'Valor Total CM ger.',
       '',
       'TOTCMG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12500,
       16,
       'TOTCMGORI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Tot CMG Original',
       'Total Custo Mdio Geral Original (antes do recalc)',
       '',
       'TOTCMGORI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       790,
       16,
       'TOT_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Vlr.Total C.M.Fiscal',
       'Vlr.Total C.M.Fiscal',
       '',
       'TOT_CM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12490,
       16,
       'TOT_CMORI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Tot CM Original',
       'Total Custo Mdio Original (antes do recalc)',
       '',
       'TOT_CMORI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12040,
       1,
       'TRAIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Trnsito Importao',
       'Situao de Trnsito de Importao',
       '',
       'TRAIMP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '05',
       40,
       7,
       'VEN_DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data/Hora Venda',
       'Data/Hora Venda',
       '',
       'VEN_DATHOR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '01',
       190,
       1,
       'VINCUL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Vnculo',
       'Vnculo',
       '',
       'VINCUL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       200,
       9,
       'VLR001',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor ICMS / ISS',
       'Valor 001',
       '',
       'VLRICM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       210,
       9,
       'VLR002',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor IPI / IRRF',
       'Valor 002',
       '',
       'VLR002',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       1570,
       12,
       'VLRABA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr. Abatimento Lote',
       'Valor do Abatimento do Lote',
       '',
       'VLRABA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       11960,
       12,
       'VLRADU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vl. Desp. Aduaneiras',
       'Valor das Despesas Aduaneiras Tributveis',
       '',
       'VLRADU',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       12100,
       12,
       'VLRAFR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Out Despesas Aduanei',
       'Valor da AFRMM e Outras Despesas Aduaneiras',
       '',
       'VLRAFR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       12010,
       12,
       'VLRANT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Anti Dumping',
       'Valor Anti Dumping',
       '',
       'VLRANT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       12030,
       16,
       'VLRCMG',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr.C.MdioGerencial',
       'Valor para Custo Mdio Gerencial',
       '',
       'VLRCMG',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12480,
       16,
       'VLRCMGORI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor CMG Original',
       'Valor Custo Mdio Geral Original (antes do recalc)',
       '',
       'VLRCMGORI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       1050,
       12,
       'VLRCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Valor do cofins',
       'Valor do cofins',
       '',
       'VLRCOF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12000,
       12,
       'VLRCOFCRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vl COFINS Credit',
       'Valor COFINS Creditvel',
       '',
       'VLRCOFCRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '41',
       12150,
       12,
       'VLRCOFRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor de COF retido',
       'Valor de COFINS retido',
       '',
       'VLRCOFRET',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       11610,
       12,
       'VLRCOMSUG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Comisso Sugesto',
       'Valor de Comisso para Produtos Sugeridos',
       '',
       'VLRCOMSUG',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       1051,
       12,
       'VLRCSTVDA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       '',
       'Valor CST Venda',
       'Valor CST Venda',
       '',
       'VLRCSTVDA(IVE.SEQUEN, IVE.NUMITE, IVE.CODFIL)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12610,
       12,
       'VLRDEDISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Deduo ISS',
       'Valor Deduo ISS',
       '',
       'VLRDEDISS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       660,
       12,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Desconto',
       'Valor Desconto',
       '',
       'VLRDES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12390,
       15,
       'VLRDESON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr ICMS Desonerado',
       'Valor do ICMS desonerado',
       '',
       'VLRDESON',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12120,
       12,
       'VLRDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor ICMS Diferido',
       'Valor do ICMS Diferido',
       '',
       'VLRDIF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12340,
       12,
       'VLREFE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'ICMS Efetivo',
       'Valor do ICMS efetivo',
       '',
       'VLREFE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12230,
       14,
       'VLRFCP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor FCP',
       'Valor do ICMS relativo ao Fundo de Combate  Pobreza (FCP)',
       '',
       'VLRFCP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12300,
       14,
       'VLRFCP_RET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor FCP ST Ret.',
       'Valor do FCP retido anteriormente por Substituio Tributria',
       '',
       'VLRFCP_RET',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12270,
       14,
       'VLRFCP_ST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor FCP ST',
       'Valor do FCP retido por Substituio Tributria',
       '',
       'VLRFCP_ST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       11660,
       12,
       'VLRFILDES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Preo no Destino',
       'Preo na Filial de Destino (Usado na Base de IPI em Transferncias)',
       '',
       'VLRFILDES',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       11531,
       12,
       'VLRFLX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor juros FLEX',
       'Valor juros FLEX',
       '',
       'VLRFLX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       1330,
       12,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr do frete rateado',
       'Valor do frete rateado',
       '',
       'VLRFRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       1480,
       12,
       'VLRIBP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor do Imposto',
       'Valor do Imposto de Acordo com a Tabela do IBPT',
       '',
       'COALESCE(IVE.VLRIBP, COALESCE(IVE.VLRIBPFED,0)+COALESCE(IVE.VLRIBPEST,0)+COALESCE(IVE.VLRIBPMUN,0))',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       11590,
       12,
       'VLRIBPEST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Impostos Est',
       'Valor de Impostos Estaduais',
       '',
       'VLRIBPEST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       11580,
       12,
       'VLRIBPFED',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Impostos Fed',
       'Valor de Impostos Federais',
       '',
       'VLRIBPFED',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       11600,
       12,
       'VLRIBPMUN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Impostos Mun',
       'Valor de Impostos Municipais',
       '',
       'VLRIBPMUN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       970,
       12,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Valor do ICMS',
       'Valor do ICMS',
       '',
       'VLRICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       11850,
       12,
       'VLRICMDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor ICMS UF Dest',
       'Valor de ICMS para UF de Destino',
       '',
       'VLRICMDES',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       11840,
       12,
       'VLRICMFCP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vl ICMS Fun Pob Dest',
       'Valor de ICMS para Fundo de Pobreza na UF de Destino',
       '',
       'VLRICMFCP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       11860,
       12,
       'VLRICMORI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor ICMS UF Orig',
       'Valor de ICMS para UF de Origem',
       '',
       'VLRICMORI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12440,
       16,
       'VLRICM_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor de ICMS CM',
       'Valor de ICMS para Recalculo do Custo Mdio',
       '',
       'VLRICM_CM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12350,
       12,
       'VLRICM_COM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'ICMS Prprio Subst.',
       'Valor do ICMS Prprio do Substituto cobrado em operao anterior',
       '',
       'VLRICM_COM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12360,
       12,
       'VLRICM_CRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Crdito ICMS Transf.',
       'Valor do crdito de ICMS na nota de transferncia',
       '',
       'VLRICM_CRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       12370,
       12,
       'VLRICM_EST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Estorno ICMS Transf.',
       'Estorno do crdito de ICMS na nota de transferncia',
       '',
       'VLRICM_EST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       950,
       12,
       'VLRIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Valor do IPI',
       'Valor do IPI',
       '',
       'VLRIPI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       11650,
       12,
       'VLRIPICAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor IPI Calculado',
       'Valor do IPI Calculado',
       '',
       'VLRIPICAL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       670,
       9,
       'VLRIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor IRRF',
       'Valor IRRF',
       '',
       'VLRIRR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       680,
       9,
       'VLRISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor ISS',
       'Valor ISS',
       '',
       'VLRISS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12580,
       12,
       'VLRISSRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Retido ISS',
       'Valor Retido ISS',
       '',
       'VLRISSRET',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       60,
       20,
       'VLRLIQPROP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Liquido Propor',
       'Valor Liquido Proporcional (somente posto tulio)',
       '',
       'COALESCE(VEN.VLRLIQ,0) * (CASE  VEN.VLRNOT  WHEN 0 THEN  0 ELSE (IVE.VLRMOV+COALESCE(IVE.SUBSTT,0)) / (VEN.VLRNOT+COALESCE(VEN.SUBSTT,0)) END)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       1340,
       12,
       'VLRLIQRAT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr lquido rateado',
       'Valor lquido rateado',
       '',
       'VLRLIQRAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       61,
       20,
       'VLRLIQUNI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr Liq Propor Unit',
       'Valor Liquido Proporcional Unitario',
       '',
       'CASE WHEN IVE.QTDMOV = 0 THEN 0 ELSE COALESCE(VEN.VLRLIQ,0) * (CASE  VEN.VLRNOT  WHEN 0 THEN  0 ELSE  (IVE.VLRMOV+COALESCE(IVE.SUBSTT,0)) / (VEN.VLRNOT+COALESCE(VEN.SUBSTT,0)) /IVE.QTDMOV END) END',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       11780,
       12,
       'VLRLUC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Lucro',
       'Valor Lucro',
       '',
       'VLRLUC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       340,
       8,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       'IVE ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'T',
       'Valor Item',
       'Valor total do item',
       '',
       'VLRMOV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '45',
       1400,
       12,
       'VLRMPB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor MP do BEM',
       'Valor Isento no MP do BEM',
       '',
       '(SELECT BI_VLRMPB(VEN.CODFIL,VEN.VLRLIQ,VEN.VLRNOT,IVE.VLRMOV,IVE.QTDMOV,IVE.QTDMPB,TABFIL.VENPIS,TABFIL.VENCOF) FROM TD_FIL TABFIL WHERE TABFIL.CODFIL = VEN.CODFIL)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       800,
       12,
       'VLRNEG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Vlr Saldo Negativo',
       'Valor do saldo do produto quando negativo',
       '',
       '(CASE WHEN COALESCE(IVE.SAL_CM,0) < 0 THEN COALESCE(IVE.SAL_CM,0) ELSE 0 END)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       11760,
       12,
       'VLROPE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Desp. Operac.',
       'Valor Despesas Operacionais',
       '',
       'VLROPE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       11770,
       12,
       'VLROPEFIX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Desp. Op.Fixas',
       'Valor Despesas Operacionais Fixas',
       '',
       'VLROPEFIX',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       920,
       12,
       'VLRORI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Valor Original',
       'Valor Original',
       '',
       'VLRORI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       1010,
       12,
       'VLRPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Valor do PIS',
       'Valor do PIS',
       '',
       'VLRPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '45',
       1410,
       12,
       'VLRPISCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Pis/Cofins',
       'Valor do Pis/Cofins',
       '',
       '(SELECT BI_VLRPISCOF(VEN.CODFIL,VEN.VLRLIQ,VEN.VLRNOT,IVE.VLRMOV,TABFIL.VENPIS,TABFIL.VENCOF) FROM TD_FIL TABFIL WHERE TABFIL.CODFIL = VEN.CODFIL)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       11980,
       12,
       'VLRPISCRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vl PIS Credit',
       'Valor PIS Creditvel',
       '',
       'VLRPISCRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '41',
       12140,
       12,
       'VLRPISRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor de PIS retido',
       'Valor de PIS retido',
       '',
       'VLRPISRET',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       1350,
       12,
       'VLRSEG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr do seg. rateado',
       'Valor do seguro rateado',
       '',
       'VLRSEG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       1230,
       12,
       'VLRSIM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor ICMS Crdito S',
       'Valor ICMS Crdito Simples',
       '',
       'VLRSIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       11750,
       12,
       'VLRSOC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Contr. Social',
       'Valor Contribuio Social',
       '',
       'VLRSOC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '41',
       12160,
       12,
       'VLRSOCRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor de CSLL retido',
       'Valor de CSLL retido',
       '',
       'VLRSOCRET',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       810,
       12,
       'VLRUNI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Vlr Unitrio Lquido',
       'Valor unitrio lquido',
       '',
       'CASE WHEN IVE.QTDMOV = 0 THEN 0 ELSE ROUND(COALESCE(IVE.VLRUNI,COALESCE((IVE.VLRMOV / IVE.QTDMOV) + ((IVE.VLRMOV / IVE.QTDMOV) * VEN.DESCON / 100),0)),2) END',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       860,
       12,
       'VLRUNI2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Unitrio',
       'Valor Unitrio',
       '',
       'CASE WHEN IVE.QTDMOV = 0 THEN 0 ELSE ROUND(IVE.VLRMOV/IVE.QTDMOV,4) END',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       12020,
       16,
       'VLR_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Custo Mdio',
       'Valor para Custo Mdio Fiscal',
       '',
       'VLR_CM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12470,
       16,
       'VLR_CMORI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor CM Original',
       'Valor Custo Mdio Original (antes do recalc)',
       '',
       'VLR_CMORI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '40',
       11950,
       12,
       'VLR_II',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor II',
       'Valor do Imposto de Importao',
       '',
       'VLR_II',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '99',
       12460,
       16,
       'VLR_ST_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor ST CM',
       'Valor ST para Recalculo do Custo Mdio',
       '',
       'VLR_ST_CM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '--',
       1240,
       14,
       'VLR_ST_COM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Vlr ICMS Retido Ante',
       'Valor do ICMS Retido Anteriormente',
       '',
       'VLR_ST_COM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '06',
       11511,
       12,
       'VLR_SUBFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Frete sem % Subsdio',
       'Frete sem Percentual de Subsdio',
       '',
       'ROUND((IVE.VLRFRE * 100) / (100 - IVE.SUBFRE),2)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVE ',
       '04',
       12640,
       20,
       'REFKIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Referncia KIT',
       'Referncia do KIT',
       '',
       '(SELECT G.REFPRO FROM TT_GRA G WHERE (G.FILMAT, G.CODMAT, G.CODCOR, G.CODTAM) IN (SELECT I.FILMAT, I.CODMAT, I.CODCOR, I.CODTAM FROM TT_IVE I WHERE I.CODFIL = IVE.CODFIL AND I.SEQUEN = IVE.SEQUEN AND I.NUMITE = IVE.KITORI))',
       '',
       'D' FROM DUAL
);

/*-- SEQ 8377 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '000 - Tributada integralmente',
       TO_NUMBER(null),
       '000' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '010 - Trib e com substituio',
       TO_NUMBER(null),
       '010' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '020 - Com red. de base',
       TO_NUMBER(null),
       '020' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '030 - Isen./no trib. com subs',
       TO_NUMBER(null),
       '030' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '040 - Isenta',
       TO_NUMBER(null),
       '040' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '041 - No tributada',
       TO_NUMBER(null),
       '041' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '050 - Suspenso',
       TO_NUMBER(null),
       '050' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '051 - Diferimento',
       TO_NUMBER(null),
       '051' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '060 - ICMS cobrado ant por sub',
       TO_NUMBER(null),
       '060' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '070 - reduo de base por subs',
       TO_NUMBER(null),
       '070' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '090 - Outras',
       TO_NUMBER(null),
       '090' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '100 - Tributada integralmente',
       TO_NUMBER(null),
       '100' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '110 - Trib e com substituio',
       TO_NUMBER(null),
       '110' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '120 - Com red. de base',
       TO_NUMBER(null),
       '120' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '130 - Isen./no trib. com subs',
       TO_NUMBER(null),
       '130' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '140 - Isenta',
       TO_NUMBER(null),
       '140' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '141 - No tributada',
       TO_NUMBER(null),
       '141' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '150 - Suspenso',
       TO_NUMBER(null),
       '150' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '151 - Diferimento',
       TO_NUMBER(null),
       '151' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '160 - ICMS cobrado ant por sub',
       TO_NUMBER(null),
       '160' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '170 - reduo de base por subs',
       TO_NUMBER(null),
       '170' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '190 - Outras',
       TO_NUMBER(null),
       '190' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '200 - Tributada integralmente',
       TO_NUMBER(null),
       '200' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '210 - Trib e com substituio',
       TO_NUMBER(null),
       '210' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '220 - Com red. de base',
       TO_NUMBER(null),
       '220' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '230 - Isen./no trib. com subs',
       TO_NUMBER(null),
       '230' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '240 - Isenta',
       TO_NUMBER(null),
       '240' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '241 - No tributada',
       TO_NUMBER(null),
       '241' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '250 - Suspenso',
       TO_NUMBER(null),
       '250' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '251 - Diferimento',
       TO_NUMBER(null),
       '251' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '260 - ICMS cobrado ant por sub',
       TO_NUMBER(null),
       '260' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '270 - reduo de base por subs',
       TO_NUMBER(null),
       '270' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '290 - Outras',
       TO_NUMBER(null),
       '290' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '300 - Tributada integralmente',
       TO_NUMBER(null),
       '300' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '310 - Trib e com substituio',
       TO_NUMBER(null),
       '310' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '320 - Com red. de base',
       TO_NUMBER(null),
       '320' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '330 - Isen./no trib. com subs',
       TO_NUMBER(null),
       '330' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '340 - Isenta',
       TO_NUMBER(null),
       '340' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '341 - No tributada',
       TO_NUMBER(null),
       '341' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '350 - Suspenso',
       TO_NUMBER(null),
       '350' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '351 - Diferimento',
       TO_NUMBER(null),
       '351' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '360 - ICMS cobrado ant por sub',
       TO_NUMBER(null),
       '360' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '370 - reduo de base por subs',
       TO_NUMBER(null),
       '370' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '390 - Outras',
       TO_NUMBER(null),
       '390' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '400 - Tributada integralmente',
       TO_NUMBER(null),
       '400' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '410 - Trib e com substituio',
       TO_NUMBER(null),
       '410' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '420 - Com red. de base',
       TO_NUMBER(null),
       '420' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '430 - Isen./no trib. com subs',
       TO_NUMBER(null),
       '430' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '440 - Isenta',
       TO_NUMBER(null),
       '440' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '441 - No tributada',
       TO_NUMBER(null),
       '441' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '450 - Suspenso',
       TO_NUMBER(null),
       '450' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '451 - Diferimento',
       TO_NUMBER(null),
       '451' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '460 - ICMS cobrado ant por sub',
       TO_NUMBER(null),
       '460' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '470 - reduo de base por subs',
       TO_NUMBER(null),
       '470' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '490 - Outras',
       TO_NUMBER(null),
       '490' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '500 - Tributada integralmente',
       TO_NUMBER(null),
       '500' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '510 - Trib e com substituio',
       TO_NUMBER(null),
       '510' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '520 - Com red. de base',
       TO_NUMBER(null),
       '520' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '530 - Isen./no trib. com subs',
       TO_NUMBER(null),
       '530' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '540 - Isenta',
       TO_NUMBER(null),
       '540' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '541 - No tributada',
       TO_NUMBER(null),
       '541' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '550 - Suspenso',
       TO_NUMBER(null),
       '550' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '551 - Diferimento',
       TO_NUMBER(null),
       '551' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '560 - ICMS cobrado ant por sub',
       TO_NUMBER(null),
       '560' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '570 - reduo de base por subs',
       TO_NUMBER(null),
       '570' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '590 - Outras',
       TO_NUMBER(null),
       '590' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '600 - Tributada integralmente',
       TO_NUMBER(null),
       '600' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '610 - Trib e com substituio',
       TO_NUMBER(null),
       '610' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '620 - Com red. de base',
       TO_NUMBER(null),
       '620' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '630 - Isen./no trib. com subs',
       TO_NUMBER(null),
       '630' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '640 - Isenta',
       TO_NUMBER(null),
       '640' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '641 - No tributada',
       TO_NUMBER(null),
       '641' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '650 - Suspenso',
       TO_NUMBER(null),
       '650' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '651 - Diferimento',
       TO_NUMBER(null),
       '651' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '660 - ICMS cobrado ant por sub',
       TO_NUMBER(null),
       '660' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '670 - reduo de base por subs',
       TO_NUMBER(null),
       '670' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '690 - Outras',
       TO_NUMBER(null),
       '690' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '700 - Tributada integralmente',
       TO_NUMBER(null),
       '700' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '710 - Trib e com substituio',
       TO_NUMBER(null),
       '710' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '720 - Com red. de base',
       TO_NUMBER(null),
       '720' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '730 - Isen./no trib. c/ subs.',
       TO_NUMBER(null),
       '730' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '740 - Isenta',
       TO_NUMBER(null),
       '740' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '741 - No tributada',
       TO_NUMBER(null),
       '741' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '750 - Suspenso',
       TO_NUMBER(null),
       '750' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '751 - Diferimento',
       TO_NUMBER(null),
       '751' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '760 - ICMS cobrado ant por sub',
       TO_NUMBER(null),
       '760' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '770 - Reduo de base p/ subs.',
       TO_NUMBER(null),
       '770' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODCST',
       0,
       '',
       '790 - Outras',
       TO_NUMBER(null),
       '790' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODORI',
       3,
       '',
       'Nacional, Cont.Import.>40%<70%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODORI',
       4,
       '',
       'Nacional, Conf.Proc.Prod.Bs.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODORI',
       5,
       '',
       'Nacional, Cont.Import <= 40%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODORI',
       6,
       '',
       'Estrang., Import.Dir.CAMEX-GNL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODORI',
       7,
       '',
       'Estrang., Adq.Int. CAMEX-GNL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODORI',
       0,
       '',
       'Nacional, exceto cd.3,4,5,8',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODORI',
       1,
       '',
       'Estrang., Import.Dir., Exc.6',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODORI',
       2,
       '',
       'Estrang., Adq.Int., Exc.7',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'CODORI',
       8,
       '',
       'Nacional, Import. > a 70%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'FLGFUT',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'FLGFUT',
       0,
       'E',
       'Encomenda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'FLGFUT',
       0,
       'P',
       'Processado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'FRMPRE',
       0,
       '2',
       'Promoo Por Plano',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'FRMPRE',
       0,
       'A',
       'DAV',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'FRMPRE',
       0,
       'C',
       'Cmbio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'FRMPRE',
       0,
       'D',
       'Desconto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'FRMPRE',
       0,
       'F',
       'Promoo de Fechamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'FRMPRE',
       0,
       'I',
       'Informado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'FRMPRE',
       0,
       'K',
       'Kit',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'FRMPRE',
       0,
       'N',
       'NF',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'FRMPRE',
       0,
       'P',
       'Promoo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'FRMPRE',
       0,
       'S',
       'Frmula SQL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'FRMPRE',
       0,
       'T',
       'Tabela',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'ICMTIP',
       0,
       '0',
       'Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'ICMTIP',
       0,
       '1',
       'No tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'ICMTIP',
       0,
       '2',
       'Isento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'ICMTIP',
       0,
       '3',
       'Substitudo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'ICMTIP',
       0,
       '4',
       'Isento no estado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'LANEST',
       0,
       'C',
       'Confirma Reserva',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'LANEST',
       0,
       'N',
       'Nao (s Histrico)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'LANEST',
       0,
       'R',
       'Reserva',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'LANEST',
       0,
       'S',
       'Baixa Estoque',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'MOTDESON',
       1,
       '',
       'Txi',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'MOTDESON',
       2,
       '',
       'Deficiente Fsico (Descontinua',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'MOTDESON',
       3,
       '',
       'Produtor Agropecurio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'MOTDESON',
       4,
       '',
       'Frotista/Locadora',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'MOTDESON',
       5,
       '',
       'Diplomtico/Consular ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'MOTDESON',
       6,
       '',
       'Utilitrios/Motocicletas Amaz.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'MOTDESON',
       7,
       '',
       'SUFRAMA',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'MOTDESON',
       8,
       '',
       'Venda a rgo Pblico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'MOTDESON',
       9,
       '',
       'Outros. (NT 2011/004)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'MOTDESON',
       10,
       '',
       'Deficiente Condutor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'MOTDESON',
       11,
       '',
       'Deficiente No Condutor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'MOTDESON',
       12,
       '',
       'rgo de fomento e desenvolvim',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'NATBCC',
       0,
       '',
       'Estoque de abertura de bens',
       TO_NUMBER(null),
       '18' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'NATBCC',
       0,
       '',
       'Aquisio de bens para revenda',
       TO_NUMBER(null),
       '01' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'NATBCC',
       0,
       '',
       'Aquisio bens util. c/ insumo',
       TO_NUMBER(null),
       '02' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'NATBCC',
       0,
       '',
       'Aquisio serv. util. insumo',
       TO_NUMBER(null),
       '03' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'NATBCC',
       0,
       '',
       'Energia eltrica e trmica',
       TO_NUMBER(null),
       '04' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'NATBCC',
       0,
       '',
       'Aluguis de prdios',
       TO_NUMBER(null),
       '05' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'NATBCC',
       0,
       '',
       'Aluguis de mquinas e equip.',
       TO_NUMBER(null),
       '06' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'NATBCC',
       0,
       '',
       'Armazenagem mercadoria e frete',
       TO_NUMBER(null),
       '07' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'NATBCC',
       0,
       '',
       'Contraprestaes mercatil',
       TO_NUMBER(null),
       '08' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'NATBCC',
       0,
       '',
       'Crd. s/ encargos depreciao',
       TO_NUMBER(null),
       '09' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'NATBCC',
       0,
       '',
       'Crd. c/ base valor aquisio',
       TO_NUMBER(null),
       '10' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'NATBCC',
       0,
       '',
       'Amort. deprec. edific. imveis',
       TO_NUMBER(null),
       '11' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'NATBCC',
       0,
       '',
       'Dev. de vendas suj. Incidncia',
       TO_NUMBER(null),
       '12' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'NATBCC',
       0,
       '',
       'Outras Operaes direito crd.',
       TO_NUMBER(null),
       '13' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'NATBCC',
       0,
       '',
       'Atividade Transporte de Cargas',
       TO_NUMBER(null),
       '14' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'NATBCC',
       0,
       '',
       'Custo de Unidade Imobiliria',
       TO_NUMBER(null),
       '15' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'NATBCC',
       0,
       '',
       'Custo unidade no concluda',
       TO_NUMBER(null),
       '16' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'NATBCC',
       0,
       '',
       'Atividade de Prestao de Serv',
       TO_NUMBER(null),
       '17' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'PENATU',
       0,
       'P',
       'Processando',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'PENATU',
       0,
       'T',
       'A Processar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'RESTRI',
       0,
       ' ',
       'No h',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'RESTRI',
       1,
       ' ',
       'Alienao Fiduciria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'RESTRI',
       2,
       ' ',
       'Arrendamento Mercantil',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'RESTRI',
       3,
       ' ',
       'Reserva de Domnio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'RESTRI',
       4,
       ' ',
       'Penhor de Veculos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'RESTRI',
       9,
       ' ',
       'Outras',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITIPI',
       0,
       '',
       'Entrada com Recup. de Crdito',
       TO_NUMBER(null),
       '00' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITIPI',
       0,
       '',
       'Entrada Tributvel com Alq. 0',
       TO_NUMBER(null),
       '01' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITIPI',
       0,
       '',
       'Entrada Isenta',
       TO_NUMBER(null),
       '02' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITIPI',
       0,
       '',
       'Entrada No-Tributada',
       TO_NUMBER(null),
       '03' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITIPI',
       0,
       '',
       'Entrada Imune',
       TO_NUMBER(null),
       '04' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITIPI',
       0,
       '',
       'Entrada com Suspenso',
       TO_NUMBER(null),
       '05' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITIPI',
       0,
       '',
       'Outras Entradas',
       TO_NUMBER(null),
       '49' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITIPI',
       0,
       '',
       'Sada Tributada',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITIPI',
       0,
       '',
       'Sada Tributvel com Alq. 0',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITIPI',
       0,
       '',
       'Sada Isenta',
       TO_NUMBER(null),
       '52' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITIPI',
       0,
       '',
       'Sada No-Tributada',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITIPI',
       0,
       '',
       'Sada Imune',
       TO_NUMBER(null),
       '54' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITIPI',
       0,
       '',
       'Sada com Suspenso',
       TO_NUMBER(null),
       '55' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITIPI',
       0,
       '',
       'Outras Sadas',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITISS',
       0,
       'I',
       'ISENTA',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITISS',
       0,
       'N',
       'NORMAL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITISS',
       0,
       'R',
       'RETIDA',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITISS',
       0,
       'S',
       'SUBSTITUTA',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITKIT',
       0,
       '1',
       'Header',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITKIT',
       0,
       '2',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITKIT',
       0,
       '3',
       'Item Kit',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITMOV',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'SITMOV',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'TEMDES',
       0,
       'F',
       'No Aceita Desconto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'TEMDES',
       0,
       'T',
       'Aceita Desconto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'TEMDES',
       0,
       'X',
       'Conforme Configurao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'TIP001',
       0,
       'M',
       'Material',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'TIP001',
       0,
       'S',
       'Servios',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'TIPOPE',
       0,
       ' ',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'TIPOPE',
       1,
       ' ',
       'Venda concessionria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'TIPOPE',
       2,
       ' ',
       'Fat. direto consumidor final ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'TIPOPE',
       3,
       ' ',
       'Venda direta grande consumid.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'TIPPRO',
       0,
       '0',
       'Material',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'TIPPRO',
       1,
       '1',
       'Servio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'TRAIMP',
       0,
       '1',
       'Importao em trnsito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'TRAIMP',
       0,
       '2',
       'Importao Recebida',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'VINCUL',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'VINCUL',
       0,
       'C',
       'Completo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVE ',
       'VINCUL',
       0,
       'N',
       'No  vnculo',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8378 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IVEN',
       TO_NUMBER(null),
       'IVEN',
       'Importa. Venda',
       'TI_VEN',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8379 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IVEN','--','' FROM DUAL
UNION ALL
SELECT 'IVEN','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IVEN','99','Outros' FROM DUAL
);

/*-- SEQ 8380 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IVEN',
       '--',
       10,
       5,
       'ACRESC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Acrscimo',
       'Acrscimo',
       '',
       'ACRESC',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       631,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN IVEN.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       20,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       30,
       1,
       'AUTENT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Autenticada?',
       'Indica se a nota j foi autenticada',
       '',
       'AUTENT',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       40,
       12,
       'BASUBS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base Sub. Tributria',
       'Base da Substituio Tributria',
       '',
       'BASUBS',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       50,
       20,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       60,
       30,
       'CODCTR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Unidade~Negcios',
       'Unidade~Negcios',
       '',
       'CODCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       70,
       30,
       'CODDEV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo da Devoluo',
       'Motivo da Devoluo',
       '',
       'CODDEV',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       80,
       15,
       'CODEXT',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       90,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cdigo da filial',
       'Cdigo da filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       820,
       5,
       'CODFIN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Cod. da Financeira',
       'Cod. da Financeira',
       '',
       'CODFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       110,
       6,
       'CODGUI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cdigo~do Guia',
       'Cdigo do Guia',
       '',
       'CODGUI',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       800,
       6,
       'CODNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Natureza',
       'Natureza de operao',
       '',
       'CODNAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       130,
       3,
       'CODPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Plano de Pagamento',
       'Cdigo do plano de pagamento',
       '',
       'CODPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       140,
       30,
       'CODPRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Tab. de Preos',
       'Cdigo da tabela de preos',
       ' ',
       'CODPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       150,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'A',
       '',
       'F',
       'A',
       'F',
       'Srie',
       'Cdigo da srie',
       'IVEN.CODSER=DSER.CODSER (+)',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       160,
       6,
       'CODTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Transportadora',
       'Cdigo da Transportadora',
       '',
       'CODTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       170,
       20,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cdigo do~usurio',
       'Cdigo do usurio',
       'IVEN.FILUSU = USU.FILUSU(+)  AND IVEN.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       180,
       20,
       'CODVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo~Vendedor',
       'Cdigo Vendedor',
       '',
       'CODVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       190,
       1,
       'COMSOB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Comisso Sobre',
       'Comisso sobre (ver tela plano)',
       '',
       'COMSOB',
       'T' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       200,
       1,
       'CONSFI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Consumidor Final?',
       'Consumidor Final?',
       '',
       'CONSFI',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       210,
       7,
       'DATFIS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Fiscal',
       'Data~Fiscal',
       '',
       'DATFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       220,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data Incluso',
       'Data e hora da operao',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       230,
       7,
       'DATIMP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da~importao',
       'Data da importao',
       '',
       'DATIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       240,
       7,
       'DATSAI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Sada',
       'Data Sada',
       '',
       'DATSAI',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       250,
       5,
       'DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Desc/Acrscimo (%)',
       'Desconto / Acrscimo',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       260,
       1,
       'EMIDES',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Frete Dest./Terc.?',
       'Frete  por conta do Destinatrio ou de Terceiros?',
       '',
       'EMIDES',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       270,
       4,
       'ENDCOB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nmero End. Cobrana',
       'Nmero do endereo de cobrana',
       '',
       'ENDCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       280,
       4,
       'ENDENT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nmero End. Entrega',
       'Nmero do endereo de entrega',
       '',
       'ENDENT',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       290,
       4,
       'ENDFAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nmero End. Fatura',
       'Nmero de endereo de fatura',
       '',
       'ENDFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       300,
       5,
       'ESPECI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'V',
       '',
       'F',
       'A',
       'F',
       'Espcie de Volume',
       'Espcie do volume',
       '',
       'ESPECI',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       310,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exportada?',
       'Exportada?',
       '',
       'EXPORT',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       320,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       330,
       3,
       'FILCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do endereo de cobrana',
       '',
       'FILCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       340,
       3,
       'FILENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do endereo de entrega',
       '',
       'FILENT',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       350,
       3,
       'FILFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do endereo de fatura',
       '',
       'FILFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       360,
       3,
       'FILGUI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do guia',
       '',
       'FILGUI',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       370,
       3,
       'FILPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do plano de pagamento',
       '',
       'FILPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       380,
       3,
       'FILPRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial da tabela de preo',
       '',
       'FILPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       390,
       3,
       'FILTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial da Transportadora',
       '',
       'FILTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       400,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do vendedor',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       410,
       1,
       'FINANC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Gera Dados Financ.?',
       'Gera dados financeiros',
       '',
       'FINANC',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       420,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Estado (Cancelado/Quitado/Em aberto)',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       430,
       1,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Pessoa ',
       'Tipo de Pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       440,
       1,
       'LANVEN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Considera Venda?',
       'Considera Venda?',
       '',
       'LANVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       450,
       5,
       'MARCAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Marcas',
       'Marcas',
       '',
       'MARCAS',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       460,
       255,
       'MOTREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo da~Rejeio',
       'Motivo da Rejeio',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       470,
       5,
       'NROIMP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nm. Impresses',
       'Nmero de vezes que a nota foi impressa',
       '',
       'NROIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       480,
       10,
       'NUMCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Conhecimento',
       'Conhecimento de frete',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       490,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'ECF',
       'ECF',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       500,
       6,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nmero~Nota',
       'Nmero da nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       510,
       12,
       'NUMVOL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Num.Volumes',
       'Nmero de Volumes',
       '',
       'NUMVOL',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       520,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Observaes',
       'Observaes',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       530,
       12,
       'PERCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Comis. s/ Parcelas',
       'Valor da comisso sobre as parcelas (exceto entrada)',
       '',
       'PERCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       540,
       12,
       'PERENT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Comis. s/ Entrada',
       'Comisso (entrada)',
       '',
       'PERENT',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       550,
       14,
       'PESBRU',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Peso Bruto',
       'Peso lquido',
       '',
       'PESBRU',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       560,
       14,
       'PESLIQ',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Peso Lquido',
       'Peso bruto',
       '',
       'PESLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       570,
       7,
       'PLAFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Placa Frete',
       'Placa Frete',
       '',
       'PLAFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       580,
       5,
       'PRAMED',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Prazo Mdio',
       'Prazo mdio',
       '',
       'PRAMED',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       590,
       8,
       'PROPGT',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Prox. Vencimento',
       'Data prximo vencimento',
       '',
       'PROPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       600,
       2,
       'QTDREN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Qtde~Renegociaes',
       'Qtde~Renegociaes',
       '',
       'QTDREN',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       610,
       12,
       'RETIDO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Retido',
       'Retido',
       '',
       'RETIDO',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       620,
       10,
       'SEQFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Nmero sequencial interno da fatura',
       '',
       'SEQFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       630,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN IVEN.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       640,
       12,
       'SINAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Sinal Relacionado',
       'Valor de sinal relacionado',
       '',
       'SINAL',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       650,
       1,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status da~importao',
       'Status da importao',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       660,
       12,
       'SUBSTT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Subst. Tributria',
       'Subst. Tributria',
       '',
       'SUBSTT',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       670,
       1,
       'TIPNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Nota',
       'Tipo de Nota',
       '',
       'TIPNOT',
       'T' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       680,
       1,
       'TIPTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Tipo Trabalho',
       'Tipo Trabalho',
       '',
       'TIPTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       690,
       1,
       'TIPTRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Cheque Troco',
       'Tipo Conta Cheque Troco',
       '',
       'TIPTRO',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       700,
       1,
       'TRIBUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Tributada?',
       'Define se a venda  tributada',
       '',
       'TRIBUT',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       810,
       1,
       'UFLOJA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Dentro do Estado?',
       'Venda Dentro do Estado?',
       '',
       'UFLOJA',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       720,
       2,
       'UF_FRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF~Frete',
       'UF~Frete',
       '',
       'UF_FRE',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       730,
       1,
       'VINCUL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Vinculada?',
       'Vinculada',
       '',
       'VINCUL',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       740,
       12,
       'VLRCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vl Ret PIS+COF+CSLL',
       'Valor Retido de PIS+COFINS+CSLL',
       '',
       'VLRCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       750,
       12,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Frete',
       'Valor do Frete',
       '',
       'VLRFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       760,
       14,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Lquido',
       'Valor lquido da nota',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       770,
       14,
       'VLRNOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor dos Itens',
       'Valor da nota',
       '',
       'VLRNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'IVEN',
       '--',
       780,
       12,
       'VLRSEG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Seguro',
       'Valor do seguro do frete',
       '',
       'VLRSEG',
       'F' FROM DUAL
);

/*-- SEQ 8381 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IVEN',
       'COMSOB',
       7,
       ' ',
       'Comisso sobre markup',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'COMSOB',
       8,
       ' ',
       'Markup no momento da Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'COMSOB',
       0,
       '-',
       'Lquido ao Vender',
       241,
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'COMSOB',
       4,
       '-',
       'A receber no Recebimento',
       245,
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'COMSOB',
       1,
       '-',
       'Bruto ao Vender',
       242,
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'COMSOB',
       2,
       '-',
       'A receber no Vencimento',
       243,
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'COMSOB',
       3,
       '-',
       'Recebido no Recebimento',
       244,
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'COMSOB',
       5,
       '-',
       'Recebido na compensao',
       289,
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'COMSOB',
       6,
       '-',
       'A receber na compensao',
       290,
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'FLGEST',
       0,
       'A',
       'Em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'FLGEST',
       0,
       'I',
       'Incompleta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'FLGEST',
       0,
       'Q',
       'Quitado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'FLGTIP',
       0,
       '0',
       'Fsica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'FLGTIP',
       0,
       '1',
       'Jurdica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'FLGTIP',
       0,
       '2',
       'Entidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'FLGTIP',
       0,
       '3',
       'Especial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'FLGTIP',
       0,
       '4',
       'M.E.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'FLGTIP',
       0,
       '5',
       'Filial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'TIPNOT',
       0,
       'A',
       'N.F.F.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'TIPNOT',
       0,
       'F',
       'Fatura',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'TIPNOT',
       0,
       'N',
       'Nota fiscal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'TIPTRA',
       0,
       'R',
       'Reviso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'TIPTRA',
       0,
       'T',
       'Tarefa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'TIPTRO',
       0,
       '+',
       'Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'TIPTRO',
       0,
       '-',
       'Devoluo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'TIPTRO',
       0,
       '2',
       'Sntegra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'TIPTRO',
       0,
       '@',
       'Vazio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVEN',
       'TIPTRO',
       0,
       'A',
       'Ambos',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8382 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IXCS',
       TO_NUMBER(null),
       'IXCS',
       'Itens de Venda por C',
       'TT_IVEXCSG',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'IXCS.CODFIL, IXCS.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8383 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IXCS','--','' FROM DUAL
UNION ALL
SELECT 'IXCS','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IXCS','99','Outros' FROM DUAL
);

/*-- SEQ 8384 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23956,
       'IVE ',
       'IXCS',
       '1',
       '1',
       '',
       '',
       'IVE.CODFIL = IXCS.FILREM AND
IVE.SEQUEN = IXCS.SEQREM AND
IVE.NUMITE = IXCS.ITEREM',
       '',
       '' FROM DUAL
);

/*-- SEQ 8385 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IXCS',
       '--',
       30,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'IXCS',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'V',
       '',
       '',
       'A',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'IXCS',
       '--',
       40,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'IXCS',
       '--',
       50,
       3,
       'FILFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial da Fatura',
       'Filial da Fatura',
       '',
       'FILFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IXCS',
       '--',
       60,
       3,
       'FILREM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial da Remessa',
       'Filial da Remessa',
       '',
       'FILREM',
       'F' FROM DUAL
UNION ALL
SELECT 'IXCS',
       '--',
       70,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Situao da Consigna',
       'Situao da Consignao ',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'IXCS',
       '--',
       80,
       5,
       'ITEFAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Item da Fatura',
       'Item da Fatura',
       '',
       'ITEFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IXCS',
       '--',
       90,
       5,
       'ITEREM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Item da Remessa',
       'Item da Remessa',
       '',
       'ITEREM',
       'F' FROM DUAL
UNION ALL
SELECT 'IXCS',
       '--',
       100,
       1,
       'NF_DEV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Devoluo j Emitida',
       'Devoluo j Emitida?',
       '',
       'NF_DEV',
       'F' FROM DUAL
UNION ALL
SELECT 'IXCS',
       '--',
       110,
       12,
       'QTDDEV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Quantidade Devolvida',
       'Quantidade Devolvida',
       '',
       'QTDDEV',
       'F' FROM DUAL
UNION ALL
SELECT 'IXCS',
       '--',
       120,
       10,
       'SEQFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. da Fatura',
       'Seq. da Fatura',
       '',
       'SEQFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IXCS',
       '--',
       130,
       10,
       'SEQREM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. da Remessa ',
       'Seq. da Remessa',
       '',
       'SEQREM',
       'F' FROM DUAL
UNION ALL
SELECT 'IXCS',
       '--',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'IXCS',
       '--',
       140,
       12,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Desconto',
       'Desconto',
       '',
       'VLRDES',
       'F' FROM DUAL
);

/*-- SEQ 8386 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IXI ',
       TO_NUMBER(null),
       'IXI ',
       'Venda Sob Encomenda',
       'TT_IVEXIPE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8387 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IXI ','--','' FROM DUAL
UNION ALL
SELECT 'IXI ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IXI ','02','Valores' FROM DUAL
UNION ALL
SELECT 'IXI ','03','Oramento' FROM DUAL
UNION ALL
SELECT 'IXI ','99','Outros' FROM DUAL
);

/*-- SEQ 8388 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20242,
       'IOR ',
       'IXI ',
       '1',
       '01',
       '',
       '',
       'IXI.FILPED = IOR.CODFIL AND
IXI.TIPPED = IOR.TIPPED AND
IXI.NUMPED = IOR.NUMPED AND
IXI.NUMITE = IOR.NUMITE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20243,
       'VIPR',
       'IXI ',
       '1',
       'N',
       '',
       '',
       'VIPR.FILMAT = IXI.FILMAT and
VIPR.CODMAT = IXI.CODMAT and
VIPR.CODCOR = IXI.CODCOR and
VIPR.CODTAM = IXI.CODTAM
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20244,
       'IVE ',
       'IXI ',
       '1',
       'N',
       '',
       '',
       'IVE.SEQUEN = IXI.SEQIVE AND
IVE.CODFIL = IXI.FILIVE AND
IVE.NUMITE = IXI.NUMIVE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20245,
       'IPE ',
       'IXI ',
       '01',
       '01',
       '',
       '',
       'IXI.FILIPE = IPE.CODFIL (+) and
IXI.NUMIPE = IPE.NUMPED (+) and
IXI.ITEIPE = IPE.NUMITE (+) ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22191,
       'LOT ',
       'IXI ',
       '1',
       '01',
       '',
       '',
       'LOT.SEQUEN = IXI.SEQLOT AND
LOT.CODFIL = IXI.FILLOT
',
       '',
       '' FROM DUAL
);

/*-- SEQ 8389 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IXI ',
       '01',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '01',
       170,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       '',
       '9',
       'F',
       'Cor~Produto',
       'Codigo da cor (diviso)',
       'DIV.CODITE(+) = IXI.CODCOR',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = IXI.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '01',
       180,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo~Produto',
       'Codigo do produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '01',
       190,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       '',
       '9',
       'F',
       'Tamanho~Produto',
       'Cdigo do tamanho (sub-diviso)',
       'SUB.CODITE(+) = IXI.CODTAM',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '01',
       60,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '01',
       295,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Operao',
       'Data em que a encomenda foi criada',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '99',
       320,
       3,
       'FILICO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Compra',
       'Filial Compra',
       '',
       'FILICO',
       'F' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '01',
       200,
       3,
       'FILIPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       'Filial do Pedido',
       'Filial do Pedido',
       '',
       'FILIPE',
       'F' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '01',
       210,
       3,
       'FILIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial da Venda',
       'Filial da Venda',
       '',
       'FILIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '01',
       300,
       3,
       'FILLOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Filial do Lote',
       'Filial do Lote',
       '',
       'FILLOT',
       '' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '01',
       220,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial~Produto',
       'Filial de incluso do produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '03',
       270,
       3,
       'FILPED',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial do Oramento',
       'Filial do Oramento',
       'DFIL.CODFIL = IXI.FILPED(+)',
       'FILPED',
       'T' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '01',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '01',
       230,
       5,
       'ITEIPE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Item do Pedido',
       'Item do Pedido',
       '',
       'ITEIPE',
       'F' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '99',
       322,
       5,
       'NUMICO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Item Compra',
       'Item Compra',
       '',
       'NUMICO',
       'F' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '01',
       240,
       8,
       'NUMIPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Nro do Pedido',
       'Nro do Pedido',
       '',
       'NUMIPE',
       'F' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '03',
       285,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Item do Oramento',
       'Item do Oramento',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '01',
       250,
       5,
       'NUMIVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nro. Item da Venda',
       'Nro. Item da Venda',
       '',
       'NUMIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '03',
       280,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Nmero do Oramento',
       'Nmero do Oramento',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '02',
       140,
       14,
       'QTDENC',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Quantidade',
       'Quantidade',
       '',
       'QTDENC',
       'F' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '99',
       321,
       10,
       'SEQICO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Seq Compra',
       'Seq Compra',
       '',
       'SEQICO',
       'F' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '01',
       260,
       10,
       'SEQIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador Venda',
       'Sequenciador Venda',
       '',
       'SEQIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '01',
       310,
       10,
       'SEQLOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sequenciador do Lote',
       'Sequenciador do Lote',
       '',
       'SEQLOT',
       '' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '01',
       160,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IXI ',
       '03',
       275,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo do Oramento',
       'Tipo do Oramento',
       '',
       'TIPPED',
       'F' FROM DUAL
);

/*-- SEQ 8390 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IXI ',
       'FLGEST',
       0,
       'A',
       'A Encomendar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IXI ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IXI ',
       'FLGEST',
       0,
       'E',
       'Encomendado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IXI ',
       'FLGEST',
       0,
       'R',
       'Recebido',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8391 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IVI ',
       TO_NUMBER(null),
       'IVI ',
       'Itens Complementado',
       'TT_IVE',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'IVI.CODFIL,IVI.SEQUEN,IVI.NUMITE',
       '' FROM DUAL
);

/*-- SEQ 8392 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IVI ','--','' FROM DUAL
UNION ALL
SELECT 'IVI ','01','Identificacao' FROM DUAL
UNION ALL
SELECT 'IVI ','03','Produto' FROM DUAL
UNION ALL
SELECT 'IVI ','04','Dados' FROM DUAL
UNION ALL
SELECT 'IVI ','05','Valores' FROM DUAL
UNION ALL
SELECT 'IVI ','06','Datas' FROM DUAL
UNION ALL
SELECT 'IVI ','99','Outros' FROM DUAL
);

/*-- SEQ 8393 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23985,
       'CES ',
       'IVI ',
       '01',
       '0N',
       '',
       '',
       'CES.CODCES(+) = IVI.CODCES',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23986,
       'LOT ',
       'IVI ',
       '0N',
       '01',
       '',
       '',
       'LOT.CODFIL(+) = IVI.FILLOT and
LOT.SEQUEN(+) = IVI.SEQLOT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23987,
       'GRA ',
       'IVI ',
       '1',
       'N',
       '',
       '',
       'GRA.FILMAT = IVI.FILMAT and
GRA.CODMAT = IVI.CODMAT and
GRA.CODCOR = IVI.CODCOR and
GRA.CODTAM = IVI.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23988,
       'SUB ',
       'IVI ',
       '01',
       '01',
       '',
       '',
       'SUB.CODITE = IVE.EMBORI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23989,
       'IVO ',
       'IVI ',
       '1',
       'N',
       '',
       '',
       'IVO.FILIVE = IVI.CODFIL AND
IVO.SEQIVE = IVI.SEQUEN AND
IVO.NUMIVE = IVI.NUMITE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23990,
       'TRA ',
       'IVI ',
       '1',
       'N',
       '',
       '',
       'TRA.FILIVE = IVI.CODFIL AND
TRA.SEQIVE = IVI.SEQUEN AND
TRA.NUMIVE = IVI.NUMITE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23991,
       'VEN ',
       'IVI ',
       '1',
       '0N',
       '',
       '',
       'VEN.CODFIL = IVI.CODFIL AND
VEN.SEQUEN = IVI.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23992,
       'ICO ',
       'IVI ',
       '01',
       '1',
       '',
       '',
       'IVI.FILICOORI = ICO.CODFIL(+) AND
IVI.SEQICOORI = ICO.SEQUEN(+) AND
IVI.NUMICOORI = ICO.NUMITE(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23993,
       'MER ',
       'IVI ',
       '01',
       '0N',
       '',
       '',
       'IVI.FILOIP = MER.CODFIL(+) AND
IVI.SEQOIP = MER.SEQUEN(+) AND
IVI.NUMADI = MER.NUMITE(+) AND
IVI.SEQMER = MER.SEQMER(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8394 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IVI ',
       '06',
       1350,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Atualizao',
       'Data Atualizao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1320,
       12,
       'BASEFE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base Efetiva',
       'Valor da base de clculo efetiva',
       '',
       'BASEFE',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1210,
       14,
       'BASFCP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base do FCP',
       'Valor da Base de Clculo do FCP',
       '',
       'BASFCP',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1280,
       14,
       'BASFCP_RET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base do FCP ST Ret',
       'Valor da Base de Clculo do FCP retido anteriormente por ST',
       '',
       'BASFCP_RET',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1250,
       14,
       'BASFCP_ST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base do FCP ST',
       'Valor da Base de Clculo do FCP retido por Substituio Tributria',
       '',
       'BASFCP_ST',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       990,
       12,
       'BASICMDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Base ICMS Destino ',
       'Base de ICMS na UF de Destino (Valor Integral)',
       '',
       'BASICMDES',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       800,
       12,
       'BASIPICAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base IPI Calculado',
       'Base do IPI Calculado',
       '',
       'BASIPICAL',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1030,
       12,
       'BAS_II',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base II',
       'Valor da Base de Clculo do Imposto de Importao',
       '',
       'BAS_II',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       240,
       9,
       'CHAVEU',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Chave nica',
       'Chave nica',
       '',
       'CHAVEU',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       1400,
       10,
       'CODBEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd Benefcio Fiscal',
       'Cdigo de Benefcio Fiscal',
       '',
       'CODBEN',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       970,
       7,
       'CODCES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'CEST',
       'CEST',
       '',
       'CODCES',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '03',
       100,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       'IVI ',
       30,
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       '9',
       'F',
       'Cdigo da Cor',
       'Codigo da cor (diviso)',
       'DIV.CODITE (+) = IVI.CODCOR',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       980,
       3,
       'CODENQ',
       'S',
       'ENQ ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'ENQ.DESENQ',
       'V',
       '',
       '',
       'N',
       '',
       'Cd Enquad IPI',
       'Cdigo de Enquadramento Legal do IPI',
       'ENQ.CODENQ(+) = IVI.CODENQ',
       'CODENQ',
       'T' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       1200,
       36,
       'CODFCI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo FCI',
       'Cdigo FCI',
       '',
       'CODFCI',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       'IVI ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'T',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL(+) = IVI.CODFIL',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '03',
       90,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IVI ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Codigo do produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       270,
       5,
       'CODMUL',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       'F',
       'Sub-Estoque',
       'Nome do Sub-Estoque',
       'DMUL.CODTAB = IVI.CODMUL',
       'CODMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '03',
       110,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       'IVI ',
       40,
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Tamanho',
       'Cdigo do tamanho (sub-diviso)',
       'SUB.CODITE (+) = IVI.CODTAM',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       350,
       3,
       'CODVDD',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Vendedor',
       'Cdigo Vendedor',
       'IVI.FILVDD = USU.FILUSU(+)  AND IVI.CODVDD = USU.CODUSU(+)',
       'CODVDD',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       750,
       9,
       'COMIND',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Comisso Indicador',
       'Comisso para Indicador',
       '',
       'COMIND',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       280,
       9,
       'COMISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Comisso',
       'Comisso',
       '',
       'COMISS',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '04',
       180,
       1,
       'COM_COMPLENTO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Complementada?',
       'Complementada?',
       '',
       'CASE (COALESCE(IVI.NUMORI,0)) WHEN 0 THEN ''F'' ELSE ''T'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       900,
       12,
       'CUSMAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Custo Markup',
       'Custo Markup',
       '',
       'CUSMAR',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       840,
       14,
       'CUSPRO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Custo Produto',
       'Custo Produto',
       '',
       'CUSPRO',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '06',
       420,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '04',
       130,
       1,
       'DUMMY',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       '',
       'Controle Interno',
       '',
       'DUMMY',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       230,
       5,
       'EMBORI',
       'G',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       '9',
       'F',
       'Embalagem Original',
       'Embalagem Original',
       'IVI.EMBORI=SUB.CODITE(+)',
       'EMBORI',
       'T' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       220,
       12,
       'EMBQTD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Quantidade Original',
       'Quantidade Original',
       '',
       'EMBQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       910,
       1,
       'EXPFIS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exportado Fiscal?',
       'Exportado Fiscal?',
       '',
       'EXPFIS',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       330,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exportar?',
       'Exportar',
       '',
       'EXPORT',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       360,
       3,
       'FILBIC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Bico Comb.',
       '',
       'FILBIC',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       840,
       3,
       'FILDEV',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial devoluo',
       'Filial em que foi feita a devoluo',
       'DFIL.CODFIL(+) = IVI.FILDEV',
       'FILDEV',
       'T' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       520,
       3,
       'FILICOORI',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Filial Item Compra',
       'Filial Item Compra',
       '',
       'FILICOORI',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '03',
       80,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IVI ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial de incluso do produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       1140,
       3,
       'FILOIP',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial DI',
       'Filial da Declarao de Importao',
       'DFIL.CODFIL = IVI.FILOIP(+)',
       'FILOIP',
       'T' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '01',
       430,
       3,
       'FILORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial de Origem',
       '',
       'FILORI',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       770,
       3,
       'FILRES',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial de Reserva',
       'Filial de Reserva',
       'DFIL.CODFIL = IVI.FILRES',
       'FILRES',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       370,
       3,
       'FILVDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Vendedor',
       '',
       'FILVDD',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       920,
       1,
       'FRMPRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Formador de Preo',
       'Formador de Preo',
       '',
       'FRMPRE',
       'T' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       1010,
       6,
       'ICMINTDES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Alquota Interna Des',
       'Alquota nas Operaes Internas UF do Destinatrio para Partilha de ICMS',
       '',
       'ICMINTDES',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '04',
       120,
       1,
       'ICMTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       '9',
       'F',
       'Tipo Tributao',
       'Tipo de tributao do produto',
       '',
       'ICMTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       830,
       5,
       'IPITRA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Frao IPI Transf',
       'Frao do IPI na Transferncia',
       '',
       'IPITRA',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '01',
       60,
       2,
       'ITEORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'IVI ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Item de Origem',
       'Item de Origem',
       '',
       'ITEORI',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '04',
       160,
       1,
       'LANEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       30,
       '',
       '',
       'D',
       '',
       ' ',
       'A',
       'T',
       'Estoque',
       'Estoque',
       '',
       'LANEST',
       'T' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       1410,
       2,
       'MOTDESON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Mot desonerao ICMS',
       'Motivo da desonerao do ICMS',
       '',
       'MOTDESON',
       'T' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       380,
       6,
       'NATFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Natureza Fiscal',
       'Natureza Fiscal',
       '',
       'NATFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       1160,
       3,
       'NUMADI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nmero da Adio DI',
       'Nmero da Adio na Declarao de Importao',
       '',
       'NUMADI',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '01',
       20,
       40,
       'NUMEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IVI ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'T',
       'Nm. Externo',
       'Nmero externo',
       '',
       'NUMEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       540,
       5,
       'NUMICOORI',
       'G',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'N',
       '',
       'Num. Item Compra',
       'Num. Item Compra',
       '',
       'NUMICOORI',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '01',
       30,
       2,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'IVI ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'T',
       'Item',
       'Nmero do item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '01',
       50,
       10,
       'NUMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IVI ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Nmero de Origem',
       'Nmero da Origem',
       '',
       'NUMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       390,
       10,
       'ORD_CM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Orden. Custo Mdio',
       'Ordenao Custo Mdio',
       '',
       'ORD_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1040,
       6,
       'PERCOFCRE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% COFINS Credit',
       '% COFINS Creditvel',
       '',
       'PERCOFCRE',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1240,
       6,
       'PERCON_ST',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Alquota Cons. Final',
       'Alquota suportada pelo Consumidor Final',
       '',
       'PERCON_ST',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1180,
       7,
       'PERDIF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Diferimento',
       '% Diferimento de ICMS',
       '',
       'PERDIF',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1330,
       6,
       'PEREFE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Alquota Efetiva',
       'Alquota do ICMS efetiva',
       '',
       'PEREFE',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1220,
       6,
       'PERFCP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% FCP',
       '% do ICMS relativo ao Fundo de Combate  Pobreza (FCP)',
       '',
       'PERFCP',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       930,
       5,
       'PERFCPDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Fundo Pob. UF Dest',
       '% do Fundo de Pobreza na UF de Destino',
       '',
       'PERFCPDES',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1290,
       6,
       'PERFCP_RET',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% FCP ST Ret',
       '% do FCP retido anteriormente por Substituio Tributria',
       '',
       'PERFCP_RET',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1260,
       6,
       'PERFCP_ST',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% FCP ST',
       '% do FCP retido por Substituio Tributria',
       '',
       'PERFCP_ST',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       890,
       10,
       'PERLUC',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Percentual de Lucro',
       'Percentual de Lucro',
       '',
       'PERLUC',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       1000,
       5,
       'PERPARICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Partilha ICMS',
       '% da Partilha de ICMS para UF de Destino',
       '',
       'PERPARICM',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1050,
       6,
       'PERPISCRE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% PIS Credit',
       '% PIS Creditvel',
       '',
       'PERPISCRE',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       780,
       1,
       'PROSUG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Produto sugerido?',
       'Produto sugerido?',
       '',
       'PROSUG',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       200,
       8,
       'QTDMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       'IVI ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'T',
       'Qtde',
       'Quantidade vendida',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       760,
       12,
       'QTDSUG_ORC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Qtde. Sugerida Orc.',
       'Quantidade sugerida no oramento.',
       '',
       'COALESCE((SELECT COALESCE(CASE PROSUG WHEN ''T'' THEN QTDITE ELSE 0 END,0) FROM TT_IOR WHERE FILIVE = IVI.CODFIL AND SEQIVE = IVI.SEQUEN AND NUMIVE = IVI.NUMITE),0)',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       400,
       12,
       'QTD_CM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde Custo Mdio',
       'Quantidade Custo Mdio',
       '',
       'QTD_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1310,
       7,
       'REDEFE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Reduo Base Efetiva',
       'Percentual de reduo da base de clculo efetiva',
       '',
       'REDEFE',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       190,
       7,
       'REDITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Base reduzida ICMS',
       'Base reduzida de ICM do item',
       '',
       'REDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       410,
       2,
       'SEQFIL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '',
       'Nmero sequencial do bico na filial',
       '',
       'SEQFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       530,
       10,
       'SEQICOORI',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Seq. Item Compra',
       'Seq. Item Compra',
       '',
       'SEQICOORI',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       1170,
       3,
       'SEQMER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Seq Mercadoria DI',
       'Nmero Sequencial da Mercadoria na Declarao de Importao',
       '',
       'SEQMER',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       1150,
       10,
       'SEQOIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq DI',
       'Sequenciador da Declarao de Importao',
       '',
       'SEQOIP',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '01',
       70,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IVI ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '04',
       140,
       1,
       'SITKIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IVI ',
       20,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'T',
       'Kit',
       'Situao de Kit',
       '',
       'SITKIT',
       'T' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '04',
       150,
       1,
       'SITMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IVI ',
       30,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'T',
       'Situao',
       'Normal ou Cancelado',
       '',
       'SITMOV',
       'T' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       550,
       5,
       'SUBFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       '% Subsdo p/ Frete',
       '% Subsdo p/ Frete',
       '',
       'SUBFRE',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       250,
       7,
       'TAX001',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% ICMS',
       'Aliquota ICMS',
       '',
       'TAX001',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       260,
       7,
       'TAX002',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% ISS',
       'Aliquota ISS',
       '',
       'TAX002',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       1020,
       6,
       'TAXICMDES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Alq. Interestadual',
       'Alquota Interestadual da Partilha de ICMS',
       '',
       'TAXICMDES',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       790,
       6,
       'TAXIPICAL',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Taxa IPI Calculado',
       'Taxa de IPI Calculado',
       '',
       'TAXIPICAL',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       440,
       4,
       'TAXIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       '%IRRF',
       '% IRRF',
       '',
       'TAXIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       450,
       7,
       'TAXISS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '%ISS',
       '% ISS',
       '',
       'TAXISS',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       1360,
       1,
       'TEMDES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Aceita Desconto?',
       'Aceita Desconto',
       '',
       'TEMDES',
       'T' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       320,
       1,
       'TIP001',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tributado',
       'Tributado',
       '',
       'TIP001',
       'T' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '01',
       40,
       1,
       'TIPORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IVI ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Tipo de Origem',
       'Tipo de Origem',
       '',
       'TIPORI',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '04',
       170,
       1,
       'TIPPRO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       60,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'T',
       'Tipo Produto',
       'Tipo Produto',
       '',
       'TIPPRO',
       'T' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       1060,
       1,
       'TRAIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Trnsito Importao',
       'Situao de Trnsito de Importao',
       '',
       'TRAIMP',
       'T' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '06',
       310,
       7,
       'VEN_DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data/Hora Venda',
       'Data/Hora Venda',
       '',
       'VEN_DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       340,
       1,
       'VINCUL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Vnculo',
       'Vnculo',
       '',
       'VINCUL',
       'T' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       290,
       9,
       'VLR001',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor 001',
       'Valor 001',
       '',
       'VLR001',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       300,
       9,
       'VLR002',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor 002',
       'Valor 002',
       '',
       'VLR002',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1070,
       12,
       'VLRADU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vl. Desp. Aduaneiras',
       'Valor das Despesas Aduaneiras',
       '',
       'VLRADU',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1080,
       12,
       'VLRANT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Anti Dumping',
       'Valor Anti Dumping',
       '',
       'VLRANT',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       460,
       16,
       'VLRCMG',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vlr.C.MdioGerencial',
       'Valor para Custo Mdio Gerencial',
       '',
       'VLRCMG',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1100,
       12,
       'VLRCOFCRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vl COFINS Credit',
       'Valor COFINS Creditvel',
       '',
       'VLRCOFCRE',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       470,
       12,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Desconto',
       'Valor Desconto',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       1420,
       15,
       'VLRDESON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr ICMS Desonerado',
       'Valor do ICMS desonerado',
       '',
       'VLRDESON',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1190,
       12,
       'VLRDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor ICMS Diferido',
       'Valor do ICMS Diferido',
       '',
       'VLRDIF',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1340,
       12,
       'VLREFE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'ICMS Efetivo',
       'Valor do ICMS efetivo',
       '',
       'VLREFE',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1230,
       14,
       'VLRFCP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor FCP',
       'Valor do ICMS relativo ao Fundo de Combate  Pobreza (FCP)',
       '',
       'VLRFCP',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1300,
       14,
       'VLRFCP_RET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor FCP ST Ret.',
       'Valor do FCP retido anteriormente por Substituio Tributria',
       '',
       'VLRFCP_RET',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1270,
       14,
       'VLRFCP_ST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor FCP ST',
       'Valor do FCP retido por Substituio Tributria',
       '',
       'VLRFCP_ST',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       820,
       12,
       'VLRFILDES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Preo no Destino',
       'Preo na Filial de Destino (Usado na Base de IPI em Transferncias)',
       '',
       'VLRFILDES',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       950,
       12,
       'VLRICMDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor ICMS UF Dest',
       'Valor de ICMS para UF de Destino',
       '',
       'VLRICMDES',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       940,
       12,
       'VLRICMFCP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vl ICMS Fun Pob Dest',
       'Valor de ICMS para Fundo de Pobreza na UF de Destino',
       '',
       'VLRICMFCP',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       960,
       12,
       'VLRICMORI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor ICMS UF Orig',
       'Valor de ICMS para UF de Origem',
       '',
       'VLRICMORI',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1360,
       12,
       'VLRICM_COM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'ICMS Prprio Subst.',
       'Valor do ICMS Prprio do Substituto cobrado em operao anterior',
       '',
       'VLRICM_COM',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1370,
       12,
       'VLRICM_CRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Crdito ICMS Transf.',
       'Valor do crdito de ICMS na nota de transferncia',
       '',
       'VLRICM_CRE',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1380,
       12,
       'VLRICM_EST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Estorno ICMS Transf.',
       'Estorno do crdito de ICMS na nota de transferncia',
       '',
       'VLRICM_EST',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '99',
       810,
       12,
       'VLRIPICAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor IPI Calculado',
       'Valor do IPI Calculado',
       '',
       'VLRIPICAL',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       480,
       9,
       'VLRIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor IRRF',
       'Valor IRRF',
       '',
       'VLRIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       490,
       9,
       'VLRISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor ISS',
       'Valor ISS',
       '',
       'VLRISS',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       880,
       12,
       'VLRLUC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Lucro',
       'Valor Lucro',
       '',
       'VLRLUC',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       210,
       8,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       'IVI ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'T',
       'Valor Item',
       'Valor total do item',
       '',
       'VLRMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       860,
       12,
       'VLROPE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Desp. Operac.',
       'Valor Despesas Operacionais',
       '',
       'VLROPE',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       870,
       12,
       'VLROPEFIX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Desp. Op.Fixas',
       'Valor Despesas Operacionais Fixas',
       '',
       'VLROPEFIX',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1110,
       12,
       'VLRPISCRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vl PIS Credit',
       'Valor PIS Creditvel',
       '',
       'VLRPISCRE',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       850,
       12,
       'VLRSOC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Contr. Social',
       'Valor Contribuio Social',
       '',
       'VLRSOC',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       510,
       12,
       'VLRUNI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Vlt Unitrio Lquido',
       'Valor Unitrio Lquido',
       '',
       'CASE WHEN IVI.QTDMOV = 0 THEN 0 ELSE ROUND(COALESCE((IVI.VLRMOV / IVI.QTDMOV) + ((IVI.VLRMOV / IVI.QTDMOV) * VEN.DESCON / 100),0),2) END',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       500,
       16,
       'VLR_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Custo Mdio',
       'Valor para Custo Mdio Fiscal',
       '',
       'VLR_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '05',
       1130,
       12,
       'VLR_II',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor II',
       'Valor do Imposto de Importao',
       '',
       'VLR_II',
       '' FROM DUAL
UNION ALL
SELECT 'IVI ',
       '04',
       560,
       12,
       'VLR_SUBFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Frete sem % Subsdio',
       'Frete sem Percentual de Subsdio',
       '',
       'ROUND((IVI.VLRFRE * 100) / (100 - IVI.SUBFRE),2)',
       '' FROM DUAL
);

/*-- SEQ 8395 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IVI ',
       'FRMPRE',
       0,
       '2',
       'Promoo Por Plano',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'FRMPRE',
       0,
       'A',
       'DAV',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'FRMPRE',
       0,
       'C',
       'Cmbio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'FRMPRE',
       0,
       'D',
       'Desconto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'FRMPRE',
       0,
       'F',
       'Promoo de Fechamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'FRMPRE',
       0,
       'I',
       'Informado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'FRMPRE',
       0,
       'K',
       'Kit',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'FRMPRE',
       0,
       'N',
       'NF',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'FRMPRE',
       0,
       'P',
       'Promoo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'FRMPRE',
       0,
       'S',
       'Frmula SQL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'FRMPRE',
       0,
       'T',
       'Tabela',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'ICMTIP',
       0,
       '0',
       'Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'ICMTIP',
       0,
       '1',
       'No tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'ICMTIP',
       0,
       '2',
       'Isento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'ICMTIP',
       0,
       '3',
       'Substitudo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'ICMTIP',
       0,
       '4',
       'Isento no estado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'LANEST',
       0,
       'C',
       'Confirma Reserva',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'LANEST',
       0,
       'N',
       'Nao (s Histrico)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'LANEST',
       0,
       'R',
       'Reserva',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'LANEST',
       0,
       'S',
       'Baixa Estoque',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'MOTDESON',
       1,
       ' ',
       'Txi',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'MOTDESON',
       2,
       ' ',
       'Deficiente Fsico (Descontinua',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'MOTDESON',
       3,
       ' ',
       'Produtor Agropecurio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'MOTDESON',
       4,
       ' ',
       'Frotista/Locadora',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'MOTDESON',
       5,
       ' ',
       'Diplomtico/Consular ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'MOTDESON',
       6,
       ' ',
       'Utilitrios/Motocicletas Amaz.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'MOTDESON',
       7,
       ' ',
       'SUFRAMA',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'MOTDESON',
       8,
       ' ',
       'Venda a rgo Pblico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'MOTDESON',
       9,
       ' ',
       'Outros. (NT 2011/004)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'MOTDESON',
       10,
       ' ',
       'Deficiente Condutor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'MOTDESON',
       11,
       ' ',
       'Deficiente No Condutor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'MOTDESON',
       12,
       ' ',
       'rgo de fomento e desenvolvim',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'SITKIT',
       0,
       '1',
       'Header',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'SITKIT',
       0,
       '2',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'SITKIT',
       0,
       '3',
       'Item Kit',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'SITMOV',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'SITMOV',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'TEMDES',
       0,
       'F',
       'No Aceita Desconto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'TEMDES',
       0,
       'T',
       'Aceita Desconto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'TEMDES',
       0,
       'X',
       'Conforme Configurao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'TIP001',
       0,
       'M',
       'Mercadoria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'TIP001',
       0,
       'S',
       'Isento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'TIPPRO',
       0,
       '0',
       'Material',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'TIPPRO',
       1,
       '1',
       'Servio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'TIPPRO',
       2,
       '2',
       'Terceirizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'TRAIMP',
       0,
       '1',
       'Importao em trnsito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'TRAIMP',
       0,
       '2',
       'Importao Recebida',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'VINCUL',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'VINCUL',
       0,
       'C',
       'Completo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVI ',
       'VINCUL',
       0,
       'N',
       'No  Vnculo',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8396 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IVO ',
       TO_NUMBER(null),
       'IVO ',
       'Itens de Volumes',
       'TT_IVO',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'IVO.FILVOL,IVO.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8397 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IVO ','--','' FROM DUAL
);

/*-- SEQ 8398 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20301,
       'VOL ',
       'IVO ',
       'N',
       '1',
       '',
       '',
       'IVO.FILVOL = VOL.FILVOL AND
IVO.SEQVOL = VOL.SEQUEN ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20302,
       'IOR ',
       'IVO ',
       'N',
       '1',
       '',
       '',
       'IVO.FILPED = IOR.CODFIL AND
IVO.TIPPED = IOR.TIPPED AND
IVO.NUMPED = IOR.NUMPED AND
IVO.NUMITE = IOR.NUMITE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20303,
       'USU ',
       'IVO ',
       'N',
       '1',
       '',
       '',
       'USU.FILUSU = IVO.FILUSU AND
USU.CODUSU = IVO.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20304,
       'ROM ',
       'IVO ',
       'N',
       '1',
       '',
       '',
       'IVO.FILROM = ROM.CODFIL AND
IVO.SEQROM = ROM.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20305,
       'IVE ',
       'IVO ',
       'N',
       '1',
       '',
       '',
       'IVO.FILIVE = IVE.CODFIL AND
IVO.SEQIVE = IVE.SEQUEN AND
IVO.NUMIVE = IVE.NUMITE',
       '',
       '' FROM DUAL
);

/*-- SEQ 8399 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'IVO ',
       '--',
       180,
       1,
       'ACAOENTREGA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Ao para Entrega',
       'Ao para Entrega com Problema',
       '',
       'ACAOENTREGA',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       117,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN IVO.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       15,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Data da Atualizao',
       '',
       'ATU_EM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       13,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Usurio',
       'Cdigo Usurio',
       'IVO.FILUSU = USU.FILUSU(+) AND USU.CODUSU(+) = IVO.CODUSU',
       'CODUSU',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       11,
       12,
       'CONTEM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade Separada',
       'Quantidade Separada',
       '',
       'CONTEM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       14,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data e Hora',
       'Data e Hora',
       '',
       'DATHOR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       150,
       1,
       'ENTREGUE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       20,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Entregue',
       'Entregue ao cliente ou houve problemas na entrega',
       '',
       'ENTREGUE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       86,
       3,
       'FILIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial NF Romaneio',
       'Filial da NF de Romaneio',
       '',
       'FILIMP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       26,
       3,
       'FILIPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Filial do Pedido',
       '',
       'FILIPE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       8,
       3,
       'FILIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial da Venda',
       'Filial Inventrio',
       '',
       'FILIVE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       4,
       3,
       'FILPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Pedido/OS',
       'Filial do Pedido/OS',
       '',
       'FILPED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       66,
       3,
       'FILROM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do Romaneio',
       'Filial do Romaneio',
       '',
       'FILROM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       12,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial do Usurio',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       1,
       3,
       'FILVOL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial do Volume',
       'Filial do Volume',
       'DFIL.CODFIL = IVO.FILVOL',
       'FILVOL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       16,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Estado da separao',
       'Estado da separao',
       '',
       'FLGEST',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       146,
       1,
       'IMP_CF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Entrega com CF?',
       'Entrega com CF?',
       '',
       'IMP_CF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       36,
       5,
       'ITEIPE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Item do Pedido',
       '',
       'ITEIPE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       96,
       5,
       'NUMIMP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Item NF Romaneio',
       'Nmero do Item da NF de Romaneio',
       '',
       'NUMIMP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       46,
       8,
       'NUMIPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Nmero do Pedido',
       '',
       'NUMIPE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       7,
       2,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Item Pedido/OS',
       'Nmero do item do pedido/OS',
       '',
       'NUMITE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       10,
       5,
       'NUMIVE',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Item da Venda',
       'Nmero Inventrio',
       '',
       'NUMIVE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       6,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nmero Pedido/OS',
       'Nmero Pedido/OS',
       '',
       'NUMPED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       151,
       14,
       'QTDENTREGUE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Quantidade Entregue',
       'Quantidade Entregue',
       '',
       'QTDENTREGUE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       170,
       254,
       'OBSERVACAOENTREGA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Observao Entrega',
       'Observao da Entrega',
       '',
       'OBSERVACAOENTREGA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       160,
       14,
       'QTDENTREGUEPROBLEMA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Quant. Entreg. Prob.',
       'Quantidade de itens entregues com problema.',
       '',
       'QTDENTREGUEPROBLEMA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       56,
       12,
       'QTDFAL',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade Faltante',
       'Quantidade Faltante',
       '',
       'QTDFAL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       106,
       10,
       'SEQIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. NF Romaneio',
       'Sequenciador da NF de Romaneio',
       '',
       'SEQIMP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       9,
       10,
       'SEQIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequen. da Venda',
       'Sequenciador Inventrio',
       '',
       'SEQIVE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       76,
       10,
       'SEQROM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequncia Romaneio',
       'Sequncia do Romaneio',
       '',
       'SEQROM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       3,
       10,
       'SEQVOL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Volumes',
       '',
       'SEQVOL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       116,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN IVO.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'IVO ',
       '--',
       5,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Pedido/OS',
       'Tipo Pedido/OS',
       '',
       'TIPPED',
       'T',
       'D' FROM DUAL
);

/*-- SEQ 8400 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IVO ',
       'ENTREGUE',
       0,
       'E',
       'Produto Entregue',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVO ',
       'ENTREGUE',
       0,
       'N',
       'No Informado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVO ',
       'ENTREGUE',
       0,
       'P',
       'Problemas na Entrega',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVO ',
       'ACAOENTREGA',
       0,
       'D',
       'Devolver',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVO ',
       'ACAOENTREGA',
       0,
       'N',
       'No Informado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVO ',
       'ACAOENTREGA',
       0,
       'R',
       'Enviar Novamente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVO ',
       'ACAOENTREGA',
       0,
       'E',
       'Entregue',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVO ',
       'ACAOENTREGA',
       0,
       'V',
       'Devolvido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVO ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVO ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVO ',
       'FLGEST',
       0,
       'D',
       'Devolver',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVO ',
       'FLGEST',
       0,
       'E',
       'NF Emitida / Enviado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVO ',
       'FLGEST',
       0,
       'F',
       'Em Falta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVO ',
       'FLGEST',
       0,
       'N',
       'No Separar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVO ',
       'FLGEST',
       0,
       'O',
       'Encomendado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVO ',
       'FLGEST',
       0,
       'P',
       'Separado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IVO ',
       'TIPPED',
       0,
       'O',
       'Oramento',
       57,
       ' ' FROM DUAL
UNION ALL
SELECT 'IVO ',
       'TIPPED',
       0,
       'S',
       'O.S.',
       58,
       ' ' FROM DUAL
);

/*-- SEQ 8401 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IVXC',
       TO_NUMBER(null),
       'IVXC',
       'Itens Vend. X Campa.',
       'TT_IVEXCPR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'IVXC.ID_VXC',
       '' FROM DUAL
);

/*-- SEQ 8402 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IVXC','--','' FROM DUAL
UNION ALL
SELECT 'IVXC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IVXC','99','Outros' FROM DUAL
);

/*-- SEQ 8403 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 70768,
       'IVE',
       'IVXC',
       '1',
       'N',
       '',
       '',
       'IVXC.FILIVE = IVE.CODFIL AND
IVXC.SEQIVE = IVE.SEQUEN AND
IVXC.NUMIVE = IVE.NUMITE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 70769,
       'CUP',
       'IVXC',
       '01',
       '0N',
       '',
       '',
       'IVXC.FILCUP = CUP.CODFIL AND
IVXC.SEQCUP = CUP.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 70770,
       'CPR',
       'IVXC',
       '1',
       '0N',
       '',
       '',
       'IVXC.FILCPR = CPR.CODFIL AND
IVXC.SEQCPR = CPR.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 8404 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IVXC',
       '01',
       10,
       3,
       'FILCPR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial Campanha',
       'Filial da campanha',
       'DFIL.CODFIL = IVXC.FILCPR(+)',
       'FILCPR',
       'T' FROM DUAL
UNION ALL
SELECT 'IVXC',
       '01',
       80,
       3,
       'FILCUP',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Cupom',
       'Filial do Cupom',
       'DFIL.CODFIL = IVXC.FILCUP(+)',
       'FILCOP',
       'T' FROM DUAL
UNION ALL
SELECT 'IVXC',
       '01',
       20,
       3,
       'FILIVE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial Venda',
       'Filial da venda',
       'DFIL.CODFIL = IVXC.FILIVE(+)',
       'FILIVE',
       'T' FROM DUAL
UNION ALL
SELECT 'IVXC',
       '--',
       30,
       10,
       'ID_VXC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'ID_VXC',
       'F' FROM DUAL
UNION ALL
SELECT 'IVXC',
       '01',
       100,
       8,
       'NUMIVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nmero Item Venda',
       'Nmero Item Venda',
       '',
       'NUMIVE',
       '' FROM DUAL
UNION ALL
SELECT 'IVXC',
       '--',
       50,
       18,
       'QTDMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Qtde. Atendida',
       'Quantidade atendida',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'IVXC',
       '01',
       60,
       10,
       'SEQCPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. Campanha',
       'Sequenciador da campanha',
       '',
       'SEQCPR',
       'F' FROM DUAL
UNION ALL
SELECT 'IVXC',
       '01',
       90,
       10,
       'SEQCUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq. Cupom',
       'Sequenciador do Cupom',
       '',
       'SEQCUP',
       '' FROM DUAL
UNION ALL
SELECT 'IVXC',
       '01',
       70,
       10,
       'SEQIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. Venda',
       'Sequenciador venda',
       '',
       'SEQIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'IVXC',
       '--',
       40,
       18,
       'VLRMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor do Desconto',
       'Valor do Desconto',
       '',
       'VLRMOV',
       'F' FROM DUAL
);

/*-- SEQ 8405 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IXC ',
       TO_NUMBER(null),
       'IXC ',
       'Itens Conciliados',
       'TT_ITFXCTF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8406 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IXC ','--','' FROM DUAL
UNION ALL
SELECT 'IXC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IXC ','02','Data' FROM DUAL
UNION ALL
SELECT 'IXC ','03','Valor' FROM DUAL
UNION ALL
SELECT 'IXC ','99','Outros' FROM DUAL
);

/*-- SEQ 8407 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22309,
       'ITF ',
       'IXC ',
       '1',
       '0N',
       '',
       '',
       'IXC.FILITF = ITF.CODFIL AND
IXC.SEQITF = ITF.SEQUEN AND
IXC.ITEITF = ITF.NUMITE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22310,
       'CTF ',
       'IXC ',
       '1',
       '0N',
       '',
       '',
       'IXC.ID_CTF = CTF.ID_CTF',
       '',
       '' FROM DUAL
);

/*-- SEQ 8408 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IXC ',
       '02',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'IXC ',
       '02',
       20,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'IXC ',
       '02',
       30,
       7,
       'DATVEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data vencimento',
       'Data vencimento',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IXC ',
       '02',
       40,
       7,
       'DATVEN_ANT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data vencimeto ant.',
       'Data de Vencimento Anterior',
       '',
       'DATVEN_ANT',
       'F' FROM DUAL
UNION ALL
SELECT 'IXC ',
       '01',
       50,
       3,
       'FILITF',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial TEF',
       'Filial TEF',
       'DFIL.CODFIL = IXC.FILITF',
       'FILITF',
       'F' FROM DUAL
UNION ALL
SELECT 'IXC ',
       '01',
       60,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'IXC ',
       '01',
       70,
       1,
       'FLGEST_ANT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao anterior',
       'Situao anterior',
       '',
       'FLGEST_ANT',
       'T' FROM DUAL
UNION ALL
SELECT 'IXC ',
       '01',
       80,
       14,
       'ID_CTF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Chave da Conciliao',
       'Chave da Conciliao',
       '',
       'ID_CTF',
       'F' FROM DUAL
UNION ALL
SELECT 'IXC ',
       '01',
       90,
       14,
       'ID_ITFXCTF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Chave ID',
       'Chave ID',
       '',
       'ID_ITFXCTF',
       'F' FROM DUAL
UNION ALL
SELECT 'IXC ',
       '01',
       100,
       5,
       'ITEITF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Item TEF',
       'Item TEF',
       '',
       'ITEITF',
       'F' FROM DUAL
UNION ALL
SELECT 'IXC ',
       '01',
       110,
       10,
       'SEQITF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Sequencia TEF',
       'Sequencia TEF',
       '',
       'SEQITF',
       'F' FROM DUAL
UNION ALL
SELECT 'IXC ',
       '03',
       120,
       14,
       'VLRITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor do item',
       'Valor do item',
       '',
       'VLRITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IXC ',
       '03',
       130,
       14,
       'VLRITE_ANT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor ant. do item',
       'Valor anterior do item',
       '',
       'VLRITE_ANT',
       'F' FROM DUAL
UNION ALL
SELECT 'IXC ',
       '03',
       140,
       14,
       'VLRTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor da taxa',
       'Valor da taxa',
       '',
       'VLRTAX',
       'F' FROM DUAL
UNION ALL
SELECT 'IXC ',
       '03',
       150,
       14,
       'VLRTAX_ANT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor ant. da taxa',
       'Valor anterior da taxa',
       '',
       'VLRTAX_ANT',
       'F' FROM DUAL
);

/*-- SEQ 8409 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IXC ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IXC ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IXC ',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IXC ',
       'FLGEST_ANT',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IXC ',
       'FLGEST_ANT',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IXC ',
       'FLGEST_ANT',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8410 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IXD ',
       TO_NUMBER(null),
       'IXD ',
       'Relao I.Ven  I.Dav',
       'TT_IVEXIOR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'IXD.FILIVE,IXD.SEQIVE,IXD.NUMIVE',
       '' FROM DUAL
);

/*-- SEQ 8411 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IXD ','--','' FROM DUAL
UNION ALL
SELECT 'IXD ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IXD ','99','Outros' FROM DUAL
);

/*-- SEQ 8412 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21210,
       'IVE ',
       'IXD ',
       '1',
       '01',
       '',
       '',
       'IXD.FILIVE = IVE.CODFIL AND
IXD.SEQIVE = IVE.SEQUEN AND
IXD.NUMIVE = IVE.NUMITE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21211,
       'IOR ',
       'IXD ',
       '1',
       '0N',
       '',
       '',
       'IXD.FILPED = IOR.CODFIL AND
IXD.TIPPED = IOR.TIPPED AND
IXD.NUMPED = IOR.NUMPED AND
IXD.NUMITE = IOR.NUMITE',
       '',
       '' FROM DUAL
);

/*-- SEQ 8413 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IXD ',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'IXD ',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'IXD ',
       '--',
       30,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'IXD ',
       '--',
       40,
       3,
       'FILIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial da Venda',
       'Filial da Venda',
       '',
       'FILIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'IXD ',
       '--',
       50,
       3,
       'FILPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial do DAV',
       'Filial do DAV',
       '',
       'FILPED',
       'F' FROM DUAL
UNION ALL
SELECT 'IXD ',
       '--',
       60,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Item do DAV',
       'Item do DAV',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'IXD ',
       '--',
       70,
       5,
       'NUMIVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Item da Venda',
       'Item da Venda',
       '',
       'NUMIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'IXD ',
       '--',
       80,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero do DAV',
       'Nmero do DAV',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'IXD ',
       '--',
       90,
       10,
       'SEQIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Seq. da Venda',
       'Seq. da Venda',
       '',
       'SEQIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'IXD ',
       '--',
       100,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'IXD ',
       '--',
       110,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Tipo do DAV',
       'Tipo do DAV',
       '',
       'TIPPED',
       'F' FROM DUAL
);

/*-- SEQ 8414 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IXL ',
       TO_NUMBER(null),
       'IXL ',
       'Itens Compra x Lote',
       'TT_ICOXLOT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'IXL.CODFIL,IXL.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8415 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IXL ','--','' FROM DUAL
UNION ALL
SELECT 'IXL ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IXL ','02','Datas' FROM DUAL
UNION ALL
SELECT 'IXL ','03','Valores' FROM DUAL
UNION ALL
SELECT 'IXL ','99','Outros' FROM DUAL
);

/*-- SEQ 8416 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IXL ',
       '02',
       40,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'IXL ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL = IXL.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'IXL ',
       '02',
       30,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'IXL ',
       '01',
       100,
       3,
       'FILDEV',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Devoluo',
       'Filial Devoluo',
       'DFIL.CODFIL(+) = IXL.FILDEV',
       'FILDEV',
       'T' FROM DUAL
UNION ALL
SELECT 'IXL ',
       '01',
       50,
       3,
       'FILICO',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Compra',
       'Filial Compra',
       'DFIL.CODFIL = IXL.FILICO',
       'FILICO',
       'F' FROM DUAL
UNION ALL
SELECT 'IXL ',
       '01',
       80,
       3,
       'FILLOT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Lote',
       'Filial Lote',
       'DFIL.CODFIL = IXL.FILLOT',
       'FILLOT',
       'F' FROM DUAL
UNION ALL
SELECT 'IXL ',
       '01',
       120,
       5,
       'ITEDEV',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Item Devoluo',
       'Item Devoluo',
       '',
       'ITEDEV',
       '' FROM DUAL
UNION ALL
SELECT 'IXL ',
       '01',
       70,
       5,
       'NUMICO',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Item Compra',
       'Item Compra',
       '',
       'NUMICO',
       '' FROM DUAL
UNION ALL
SELECT 'IXL ',
       '03',
       130,
       14,
       'QTDMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Qtde. Movimentada',
       'Quantidade Movimentada',
       '',
       'QTDMOV',
       '' FROM DUAL
UNION ALL
SELECT 'IXL ',
       '01',
       110,
       10,
       'SEQDEV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sequen Devoluo',
       'Sequenciador Devoluo',
       '',
       'SEQDEV',
       '' FROM DUAL
UNION ALL
SELECT 'IXL ',
       '01',
       60,
       10,
       'SEQICO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sequenciador Compra',
       'Sequenciador Compra',
       '',
       'SEQICO',
       '' FROM DUAL
UNION ALL
SELECT 'IXL ',
       '01',
       90,
       10,
       'SEQLOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sequenciador Lote',
       'Sequenciador Lote',
       '',
       'SEQLOT',
       '' FROM DUAL
UNION ALL
SELECT 'IXL ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'IXL ',
       '01',
       140,
       1,
       'SITMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Situao',
       'Situao',
       '',
       'SITMOV',
       'T' FROM DUAL
);

/*-- SEQ 8417 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'IXL ',
       'SITMOV',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'IXL ',
       'SITMOV',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8418 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'IXT ',
       TO_NUMBER(null),
       'IXT ',
       'Instrues/Titulo',
       'TT_IXT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'IXT.CODFIL,IXT.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8419 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'IXT ','--','' FROM DUAL
UNION ALL
SELECT 'IXT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'IXT ','02','Datas' FROM DUAL
UNION ALL
SELECT 'IXT ','99','Outros' FROM DUAL
);

/*-- SEQ 8420 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 116380,
       'AQV ',
       'IXT ',
       '1',
       '01',
       '',
       '',
       'AQV.ID_AQV = IXT.ID_AQV(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 115772,
       'FIN ',
       'IXT ',
       '0N',
       '1',
       '',
       '',
       'FIN.CODFIL = IXT.FILFIN AND
FIN.SEQUEN = IXT.SEQFIN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 115773,
       'ENV ',
       'IXT ',
       '0N',
       '1',
       '',
       '',
       'ENV.CODFIL = IXT.FILENV AND
ENV.SEQUEN = IXT.SEQENV',
       '',
       '' FROM DUAL
UNION ALL
SELECT 115774,
       'TIT ',
       'IXT ',
       '0N',
       '1',
       '',
       ' ',
       'TIT.CODFIL(+) = IXT.CODFIL AND
TIT.SEQUEN(+) = IXT.SEQTIT',
       '',
       '' FROM DUAL
);

/*-- SEQ 8421 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'IXT ',
       '01',
       10,
       2,
       'CCBBCO',
       'S',
       'CCB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       'CCB.DESCCB',
       'V',
       '',
       '',
       'A',
       'F',
       'Carteira no Banco',
       'Codigo de carteira no banco TT_CCB',
       'CCB.CODCCB(+) = IXT.CCBBCO',
       'CCBBCO',
       'T' FROM DUAL
UNION ALL
SELECT 'IXT ',
       '01',
       120,
       5,
       'CODCCB',
       'S',
       'DCCB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCB.APECCB',
       'V',
       '',
       '',
       'A',
       'F',
       'Cod Carteira',
       'Codigo da carteira TD_CCB',
       'DCCB.CODTAB(+) = IXT.CODCCB',
       'CODCCB',
       'T' FROM DUAL
UNION ALL
SELECT 'IXT ',
       '01',
       130,
       5,
       'CODECB',
       'S',
       'DECB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DECB.DESECB',
       'V',
       '',
       '',
       'A',
       'F',
       'Espcie',
       'Codigo da especie TD_ECB',
       'DECB.CODTAB(+) = IXT.CODECB',
       'CODECB',
       'T' FROM DUAL
UNION ALL
SELECT 'IXT ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo filial',
       'DFIL.CODFIL = IXT.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'IXT ',
       '01',
       140,
       2,
       'CODMOE',
       'S',
       'DMOE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       '',
       'F',
       'A',
       'F',
       'Moeda',
       'Moeda do preo de venda',
       'IXT.CODMOE=DMOE.CODTAB (+)',
       'CODMOE',
       'T' FROM DUAL
UNION ALL
SELECT 'IXT ',
       '01',
       150,
       5,
       'CODREM',
       'S',
       'DREM',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DREM.DESREM',
       'V',
       '',
       '',
       'A',
       'F',
       'Remessa',
       'Codigo da remessa TD_REM',
       'DREM.CODTAB(+) = IXT.CODREM',
       'CODREM',
       'T' FROM DUAL
UNION ALL
SELECT 'IXT ',
       '02',
       30,
       7,
       'DATENV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Envio',
       'Data Envio',
       '',
       'DATENV',
       'F' FROM DUAL
UNION ALL
SELECT 'IXT ',
       '02',
       40,
       7,
       'DATSOL',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Solicitao',
       'Data de solicitacao',
       '',
       'DATSOL',
       'F' FROM DUAL
UNION ALL
SELECT 'IXT ',
       '01',
       50,
       2,
       'ECBBCO',
       'S',
       'ECB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'ECB.DESECB',
       'V',
       '',
       '',
       'N',
       'F',
       'Espcie no Banco',
       'Codigo de especie no banco TT_ECB',
       'ECB.ECBBCO(+) = IXT.ECBBCO',
       'ECBBCO',
       'T' FROM DUAL
UNION ALL
SELECT 'IXT ',
       '01',
       160,
       3,
       'FILENV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Envio',
       'Filial Envio',
       '',
       'FILENV',
       'F' FROM DUAL
UNION ALL
SELECT 'IXT ',
       '01',
       180,
       3,
       'FILFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial Financeiro',
       'Filial Financeiro',
       '',
       'FILFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'IXT ',
       '99',
       200,
       14,
       'ID_AQV',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'ID do Arquivo Rem.',
       'ID do Arquivo Remessa',
       '',
       'ID_AQV',
       '' FROM DUAL
UNION ALL
SELECT 'IXT ',
       '01',
       60,
       5,
       'INSTR1',
       'S',
       'DINS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DINS.DESINS',
       'V',
       '',
       '',
       'A',
       'F',
       'Instruco 1',
       'Codigo de instrucao 1 (TD_INS)',
       'DINS.CODTAB = IXT.INSTR1',
       'INSTR1',
       'T' FROM DUAL
UNION ALL
SELECT 'IXT ',
       '01',
       70,
       5,
       'INSTR2',
       'S',
       'DINS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DINS.DESINS',
       'V',
       '',
       '',
       'A',
       'F',
       'Instruco 2',
       'Codigo de instrucao 2 (TD_INS)',
       'DINS.CODTAB = IXT.INSTR2',
       'INSTR2',
       'T' FROM DUAL
UNION ALL
SELECT 'IXT ',
       '01',
       80,
       1,
       'MOEBCO',
       'S',
       'MOE ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'MOE.DESMOE',
       'V',
       '',
       '',
       'N',
       'F',
       'Moeda no Banco',
       'Codigo de moeda no banco TT_MOE',
       'MOE.MOEBCO(+) = IXT.MOEBCO',
       'MOEBCO',
       'T' FROM DUAL
UNION ALL
SELECT 'IXT ',
       '01',
       90,
       3,
       'REMBCO',
       'S',
       'REM ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'REM.DESREM',
       'V',
       '',
       '',
       'A',
       'F',
       'Remessa no Banco',
       'Codigo de remessa no banco (TT_REM)',
       'REM.CODREM = IXT.REMBCO',
       'REMBCO',
       'T' FROM DUAL
UNION ALL
SELECT 'IXT ',
       '01',
       170,
       10,
       'SEQENV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador de Envio',
       '',
       'SEQENV',
       'F' FROM DUAL
UNION ALL
SELECT 'IXT ',
       '01',
       190,
       10,
       'SEQFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Financeiro',
       '',
       'SEQFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'IXT ',
       '01',
       100,
       10,
       'SEQTIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador de titulo',
       '',
       'SEQTIT',
       'F' FROM DUAL
UNION ALL
SELECT 'IXT ',
       '01',
       110,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8422 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'JOB ',
       TO_NUMBER(null),
       'JOB ',
       'Trabalho(Job)',
       'TT_JOB',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8423 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'JOB ','--','' FROM DUAL
UNION ALL
SELECT 'JOB ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'JOB ','99','Outros' FROM DUAL
);

/*-- SEQ 8424 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23415,
       'TUID',
       'JOB ',
       '01',
       '0N',
       '',
       '',
       'JOB.CODUID = TUID.CODUID(+)',
       '',
       '' FROM DUAL
);
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'JOB ',
       '01',
       60,
       10,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ident. de Acesso',
       'Identificao de Acesso',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'JOB ',
       '01',
       10,
       50,
       'DESJOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio do Job',
       'Descrio do Job',
       '',
       'DESJOB',
       'F' FROM DUAL
UNION ALL
SELECT 'JOB ',
       '01',
       20,
       50,
       'NOMJOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Job',
       'Nome do Job',
       '',
       'NOMJOB',
       'F' FROM DUAL
UNION ALL
SELECT 'JOB ',
       '01',
       30,
       10,
       'QTDERR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade de Erros',
       'Quantidade de Erros',
       '',
       'QTDERR',
       'F' FROM DUAL
UNION ALL
SELECT 'JOB ',
       '01',
       40,
       255,
       'ULTERR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'ltimos Erros',
       'ltimos Erros',
       '',
       'ULTERR',
       'F' FROM DUAL
UNION ALL
SELECT 'JOB ',
       '01',
       50,
       7,
       'ULTEXE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data ltima Execuo',
       'Data ltima Execuo',
       '',
       'ULTEXE',
       'F' FROM DUAL
);

/*-- SEQ 8425 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'KIT ',
       0,
       'KIT ',
       'Kits',
       'TT_KIT',
       'T',
       '',
       'TOTALL',
       'Kits',
       '{CODMAT;CODCOR;CODTAM;CODITE}',
       '',
       '',
       'ProdutoKit',
       'T',
       '',
       'KIT.FILMAT,KIT.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8426 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'KIT ','--','' FROM DUAL
);

/*-- SEQ 8427 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23644,
       'GRA ',
       'KIT ',
       '1',
       'N',
       '',
       '',
       'GRA.FILMAT = KIT.FILITE and
GRA.CODMAT = KIT.CODITE and
GRA.CODCOR = KIT.CORITE and
GRA.CODTAM = KIT.TAMITE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23645,
       'PRO ',
       'KIT ',
       '1',
       'N',
       '',
       '',
       'PRO.FILMAT = KIT.FILMAT and
PRO.CODMAT = KIT.CODMAT',
       '',
       '' FROM DUAL
);

/*-- SEQ 8428 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'KIT ',
       '--',
       90,
       1,
       'BRINDE',
       'L',
       '',
       0,
       0,
       'KIT ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'KIT',
       'F',
       '',
       'T',
       'Brinde?',
       'Indica  ou no brinde',
       '',
       'BRINDE',
       'F' FROM DUAL
UNION ALL
SELECT 'KIT ',
       '--',
       110,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Diviso do produto',
       'DIV.CODITE(+) = KIT.CODCOR',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'KIT ',
       '--',
       40,
       5,
       'CODITE',
       'A',
       '',
       0,
       0,
       'KIT ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'KIT',
       'F',
       '9',
       'F',
       'Cd.Item do KIT',
       'Cdigo do item que compe o KIT',
       '',
       'CODITE',
       'F' FROM DUAL
UNION ALL
SELECT 'KIT ',
       '--',
       20,
       5,
       'CODMAT',
       'A',
       '',
       0,
       0,
       'KIT ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'KIT',
       'F',
       '9',
       'F',
       '',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'KIT ',
       '--',
       120,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'SUB.CODITE (+) = KIT.CODTAM',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'KIT ',
       '--',
       50,
       2,
       'CORITE',
       'S',
       'DIV ',
       0,
       0,
       'KIT ',
       50,
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       'KIT',
       'F',
       'A',
       'T',
       'Diviso',
       'Diviso do Produto',
       'KIT.CORITE=DIV.CODITE (+)',
       'CORITE',
       'T' FROM DUAL
UNION ALL
SELECT 'KIT ',
       '--',
       30,
       3,
       'FILITE',
       'A',
       '',
       0,
       0,
       'KIT ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'KIT',
       'F',
       'N',
       'F',
       'Filial do Item',
       'Filial do Item',
       '',
       'FILITE',
       'F' FROM DUAL
UNION ALL
SELECT 'KIT ',
       '--',
       10,
       3,
       'FILMAT',
       'A',
       '',
       0,
       0,
       'KIT ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'KIT',
       'F',
       'N',
       'F',
       '',
       'Filial do material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'KIT ',
       '--',
       80,
       1,
       'FLGIMP',
       'L',
       '',
       0,
       0,
       'KIT ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'KIT',
       'F',
       '',
       'T',
       'Imprime na N.F.?',
       'Imprime ou no na nota fiscal',
       '',
       'FLGIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'KIT ',
       '--',
       130,
       40,
       'NUMEXT_TINTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero externo tinta',
       'Nmero externo do sistema SelfColor que identifica a tinta',
       '',
       'NUMEXT_TINTA',
       'F' FROM DUAL
UNION ALL
SELECT 'KIT ',
       '--',
       70,
       12,
       'QTDITE',
       'F',
       '',
       4,
       0,
       'KIT ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'KIT',
       'T',
       'N',
       'T',
       'Qtde no KIT',
       'Quantidade do item no KIT',
       '',
       'QTDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'KIT ',
       '--',
       100,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'KIT ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'KIT ',
       '--',
       60,
       2,
       'TAMITE',
       'S',
       'SUB ',
       0,
       0,
       'KIT ',
       60,
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       'KIT',
       'F',
       'A',
       'T',
       'Sub-Diviso',
       'Sub-Diviso',
       'KIT.TAMITE=SUB.CODITE (+)',
       'TAMITE',
       'T' FROM DUAL
);

/*-- SEQ 8429 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LAC ',
       TO_NUMBER(null),
       'LAC ',
       'Manuteno de Lacres',
       'TT_LAC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       ':DBOM.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 8430 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LAC ','--','' FROM DUAL
UNION ALL
SELECT 'LAC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LAC ','99','Outros' FROM DUAL
);

/*-- SEQ 8431 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22098,
       'LAC ',
       'LAC ',
       '1',
       '1',
       '',
       '',
       'LAC.FILLAC = LAC.CODFIL AND
LAC.SEQLAC = LAC.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22099,
       'USU ',
       'LAC ',
       '1',
       '1',
       '',
       '',
       'LAC.FILUSU = USU.FILUSU AND
LAC.CODUSU = USU.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 8432 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LAC ',
       '--',
       70,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'LAC ',
       '--',
       80,
       14,
       'CNPRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'CNPJ Emp Responsavel',
       'CNPJ da Empresa Responsvel pela Manuteno Realizada',
       '',
       'CNPRES',
       'F' FROM DUAL
UNION ALL
SELECT 'LAC ',
       '--',
       90,
       11,
       'CODBIC',
       'A',
       'DBIC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DBIC.FILBIC||'' - ''||DBIC.SEQFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Bico',
       'Bico',
       'DBIC.CODTAB = LAC.CODBIC',
       'CODBIC',
       'T' FROM DUAL
UNION ALL
SELECT 'LAC ',
       '--',
       10,
       5,
       'CODBOM',
       'S',
       'DBOM',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TO_CHAR(DBOM.NUMBOM)',
       'V',
       '',
       '',
       'A',
       'F',
       'SF Cdigo da Bomba',
       'Sem Funo Cdigo da Bomba',
       'DBOM.CODTAB = LAC.CODBOM',
       'CODBOM',
       'T' FROM DUAL
UNION ALL
SELECT 'LAC ',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do Lacre',
       'Filial do Lacre',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'LAC ',
       '--',
       100,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'CodUsuReg Manuteno',
       'Cdigo do Usurio que Registrou a Manuteno',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LAC ',
       '--',
       110,
       11,
       'CPFTEC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'CPF Tc Resp Manut.',
       'CPF do Tcnico Responsvel pela Manuteno Realizada',
       '',
       'CPFTEC',
       'F' FROM DUAL
UNION ALL
SELECT 'LAC ',
       '--',
       30,
       7,
       'DATAPL',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de aplicao ',
       'Data de aplicao do Lacre',
       '',
       'DATAPL',
       'F' FROM DUAL
UNION ALL
SELECT 'LAC ',
       '--',
       120,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'LAC ',
       '--',
       130,
       10,
       'ENCFIM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'EncFinalProcedimento',
       'Encerrante no Final do Procedimento',
       '',
       'ENCFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'LAC ',
       '--',
       140,
       10,
       'ENCINI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Enc Ini Procedimento',
       'Encerrante no Inicio do Procedimento',
       '',
       'ENCINI',
       'F' FROM DUAL
UNION ALL
SELECT 'LAC ',
       '--',
       150,
       3,
       'FILLAC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Lacre Violado',
       'Filial do Lacre Violado',
       '',
       'FILLAC',
       'F' FROM DUAL
UNION ALL
SELECT 'LAC ',
       '--',
       160,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Fil Resp Manuteno',
       'Filial do Usurio que Registrou a Manuteno',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LAC ',
       '--',
       40,
       1,
       'LACATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'SF Ativo?',
       'Sem Funo  Ativo?',
       '',
       'LACATI',
       'F' FROM DUAL
UNION ALL
SELECT 'LAC ',
       '--',
       170,
       50,
       'MOTAPL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo da Manuteno',
       'Motivo da Manuteno Realizada',
       '',
       'MOTAPL',
       'F' FROM DUAL
UNION ALL
SELECT 'LAC ',
       '--',
       50,
       20,
       'NUMLAC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Lacre',
       'Nmero do Lacre Associado na Bomba',
       '',
       'NUMLAC',
       'F' FROM DUAL
UNION ALL
SELECT 'LAC ',
       '--',
       180,
       20,
       'NUMLAU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Num Laudo Manut.',
       'Nmero do Laudo da Manuteno Realizada',
       '',
       'NUMLAU',
       'F' FROM DUAL
UNION ALL
SELECT 'LAC ',
       '--',
       190,
       10,
       'SEQLAC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Seq do Lacre Violado',
       'Sequncia do Lacre Violado',
       '',
       'SEQLAC',
       'F' FROM DUAL
UNION ALL
SELECT 'LAC ',
       '--',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequncia do Lacre',
       'Sequncia do Lacre',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'LAC ',
       '--',
       200,
       1,
       'TIPMAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Manut Realizada',
       'Tipo da Manuteno Realizada',
       '',
       'TIPMAN',
       'T' FROM DUAL
);

/*-- SEQ 8433 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'LAC ',
       'TIPMAN',
       0,
       'O',
       'Outras',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAC ',
       'TIPMAN',
       0,
       'P',
       'Subst Placa Gerenc Bomba Combs',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8434 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LACR',
       TO_NUMBER(null),
       'LACR',
       'Log Anlise de Crd.',
       'TL_ACR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8435 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LACR','--','' FROM DUAL
UNION ALL
SELECT 'LACR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LACR','99','Outros' FROM DUAL
);

/*-- SEQ 8436 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20246,
       'ACR ',
       'LACR',
       '1',
       'N',
       '',
       '',
       'LACR.FILACR = ACR.CODFIL AND
LACR.SEQACR = ACR.SEQUEN
',
       '',
       '' FROM DUAL
);

/*-- SEQ 8437 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LACR',
       '--',
       10,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'LACR',
       '--',
       20,
       10,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Identificao do Log',
       'Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LACR',
       '--',
       30,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Usurio',
       'Cdigo do Usurio',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LACR',
       '--',
       40,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Operao',
       'Data da Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LACR',
       '--',
       50,
       3,
       'FILACR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Anlise Crd.',
       'Filial da Anlise de Crdito',
       '',
       'FILACR',
       'F' FROM DUAL
UNION ALL
SELECT 'LACR',
       '--',
       60,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do Usurio',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LACR',
       '--',
       70,
       4000,
       'MSGLOG',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem de LOG',
       'Mensagem de LOG',
       '',
       'MSGLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'LACR',
       '--',
       90,
       1,
       'ORIACR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Origem com Domnio',
       'Origem com Domnio',
       '',
       'ORIACR',
       'T' FROM DUAL
UNION ALL
SELECT 'LACR',
       '--',
       80,
       10,
       'SEQACR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Seque. Anlise Crd.',
       'Sequenciador da Anlise de Crdito',
       '',
       'SEQACR',
       'F' FROM DUAL
);

/*-- SEQ 8438 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'LACR',
       'ORIACR',
       0,
       'A',
       'Anlise de Crdito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LACR',
       'ORIACR',
       0,
       'C',
       'Commerce',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8439 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LAN ',
       TO_NUMBER(null),
       'LAN ',
       'Lanamentos Avulsos',
       'TT_LAN',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'LAN.CODFIL,LAN.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8440 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LAN ','--','' FROM DUAL
UNION ALL
SELECT 'LAN ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LAN ','02','Dados' FROM DUAL
UNION ALL
SELECT 'LAN ','03','Datas' FROM DUAL
UNION ALL
SELECT 'LAN ','04','Produo Prpria' FROM DUAL
UNION ALL
SELECT 'LAN ','05','Custo Mdio Gerencial' FROM DUAL
UNION ALL
SELECT 'LAN ','06','Custo Mdio Fiscal' FROM DUAL
UNION ALL
SELECT 'LAN ','99','Outros' FROM DUAL
);

/*-- SEQ 8441 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22839,
       'SUB ',
       'LAN ',
       '1',
       'N',
       '',
       '',
       'SUB.CODITE = LAN.EMBORI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22840,
       'USU ',
       'LAN ',
       '1',
       'N',
       '',
       '',
       'USU.FILUSU = LAN.FILUSU AND
USU.CODUSU = LAN.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22836,
       'LOT ',
       'LAN ',
       '0N',
       '01',
       '',
       '',
       'LOT.CODFIL(+) = LAN.FILLOT and
LOT.SEQUEN(+) = LAN.SEQLOT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22837,
       'PPR ',
       'LAN ',
       '01',
       'N',
       '',
       '',
       'PPR.CODFIL = LAN.FILPPR AND
PPR.SEQUEN = LAN.SEQPPR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22838,
       'GRA ',
       'LAN ',
       '1',
       'N',
       '',
       '',
       'GRA.FILMAT = LAN.FILMAT AND
GRA.CODMAT = LAN.CODMAT AND
GRA.CODCOR = LAN.CODCOR AND
GRA.CODTAM = LAN.CODTAM
',
       '',
       '' FROM DUAL
);

/*-- SEQ 8442 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LAN ',
       '06',
       400,
       8,
       ':LAN.DATACMFU',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Custo',
       'Data do Custo Mdio Fiscal Unitrio',
       '',
       ':LAN.DATACMFU',
       '' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '05',
       380,
       8,
       ':LAN.DATACMGU',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Custo',
       'Data do Custo Mdio Gerencial Unitrio',
       '',
       ':LAN.DATACMGU',
       '' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '03',
       15,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'LAN ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em',
       '',
       'TO_CHAR(LAN.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '03',
       65,
       4,
       'ANO_DATMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'LAN ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'T',
       'Ano de Data Movto',
       'Ano de Data Movto',
       '',
       'TO_CHAR(LAN.DATMOV,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '03',
       10,
       8,
       'ATU_EM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       'LAN ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '01',
       19,
       9,
       'CHAVEU',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Chave nica',
       'Chave nica',
       '',
       'CHAVEU',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '01',
       20,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       'LAN ',
       30,
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo Diviso',
       'Cdigo da Diviso',
       'DIV.CODITE (+) = CCC.CODCOR',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '01',
       200,
       3,
       'CODDES',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Usurio Resp. Dest.',
       'Usurio Responsvel Destino',
       'USU.FILUSU(+) = LAN.FILDES AND USU.CODUSU(+) = LAN.CODDES',
       'CODDES',
       'T' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '01',
       5,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       'LAN ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'T',
       'Filial',
       'Filial',
       'LAN.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '01',
       15,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'LAN ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Cdigo do produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '02',
       180,
       5,
       'CODMUL',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       'F',
       'Sub-Estoque',
       'Nome do Sub-Estoque',
       'DMUL.CODTAB = LAN.CODMUL',
       'CODMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '01',
       210,
       3,
       'CODORI',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Usurio Resp. Origem',
       'Usurio Responsvel Origem',
       'USU.FILUSU = LAN.FILORI(+) AND USU.CODUSU = LAN.CODORI(+)',
       'CODORI',
       'T' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '01',
       25,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       'LAN ',
       40,
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo Sub-Diviso',
       'Cdigo da sub-diviso',
       'SUB.CODITE (+) = LAN.CODTAM',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '02',
       50,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       'LAN ',
       10,
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'T',
       'Usurio',
       'Usurio',
       'USU.FILUSU = LAN.FILUSU(+) and USU.CODUSU = LAN.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '06',
       390,
       16,
       'CUSTOFISCAL_UNI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Custo Mdio Fiscal',
       'Custo Mdio Fiscal Unitrio',
       '',
       'COALESCE(TRUNC(CUSTOMEDIO(LAN.CODFIL,LAN.FILMAT,LAN.CODMAT,LAN.CODCOR,LAN.CODTAM,3,:LAN.DATACMFU),4),0)',
       '' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '05',
       370,
       16,
       'CUSTOGER_UNI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Custo Mdio Gerenc.',
       'Custo Mdio Gerencial Unitrio',
       '',
       'COALESCE(TRUNC(CUSTOMEDIO(LAN.CODFIL,LAN.FILMAT,LAN.CODMAT,LAN.CODCOR,LAN.CODTAM,5,:LAN.DATACMGU),4),0)',
       '' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '03',
       190,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '02',
       60,
       8,
       'DATMOV',
       'D',
       '',
       0,
       TO_NUMBER(null),
       'LAN ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'T',
       'Data Movto',
       'Data Movto',
       '',
       'DATMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '01',
       70,
       17,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'LAN ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '02',
       170,
       5,
       'EMBORI',
       'G',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       '9',
       'F',
       'Embalagem Original',
       'Embalagem Original',
       'LAN.EMBORI=SUB.CODITE(+)',
       'EMBORI',
       'T' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '02',
       160,
       12,
       'EMBQTD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Quantidade Original',
       'Quantidade Original',
       '',
       'EMBQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '--',
       220,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exportar?',
       'Exportar?',
       '',
       'EXPORT',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '01',
       230,
       3,
       'FILDES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Resp. Dest.',
       'Filial Responsvel Destino',
       '',
       'FILDES',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '--',
       240,
       3,
       'FILIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '01',
       350,
       3,
       'FILLOT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial Lote',
       'Filial do Lote',
       'DFIL.CODFIL(+) = LAN.FILLOT',
       'FILLOT',
       'T' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '01',
       10,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'LAN ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do produto',
       '',
       'FILMAT',
       'T' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '01',
       250,
       3,
       'FILORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Resp. Origem',
       'Filial Responsvel Origem',
       '',
       'FILORI',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '04',
       330,
       3,
       'FILPPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Seq. Produo Prp.',
       'Sequncia da Produo Prpria.',
       '',
       'FILPPR',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '01',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'LAN ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '03',
       13,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'LAN ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em',
       '',
       'TO_CHAR(LAN.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '03',
       63,
       2,
       'MES_DATMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'LAN ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'T',
       'Ms de Data Movto',
       'Ms de Data Movto',
       '',
       'TO_CHAR(LAN.DATMOV,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '01',
       100,
       20,
       'NUMEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'LAN ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'T',
       'Num. Externo',
       'Num. Externo',
       '',
       'NUMEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '--',
       260,
       5,
       'NUMIVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NUMIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '99',
       18,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(LAN.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '99',
       270,
       10,
       'ORD_CM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ordem Custo Medio',
       'Ordem Custo Medio',
       '',
       'ORD_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '02',
       110,
       8,
       'QTDMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       'LAN ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'T',
       'Qtde',
       'Qtde',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '02',
       115,
       8,
       'QTDMOV_CON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtde~Conv.',
       'Qtde Convertida',
       '',
       'QTDCONVERTIDA(LAN.CODTAM,LAN.QTDMOV)',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '99',
       280,
       12,
       'QTD_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Qtde Custo Medio',
       'Qtde Custo Medio',
       '',
       'QTD_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '99',
       290,
       16,
       'SAL_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Saldo CM',
       'Saldo CM no momento do lanamento',
       '',
       'SAL_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '--',
       300,
       10,
       'SEQIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '01',
       360,
       10,
       'SEQLOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq Lote',
       'Sequenciador do Lote',
       '',
       'SEQLOT',
       '' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '04',
       340,
       10,
       'SEQPPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Fil. Produo Prp.',
       'Filial da Produo Prpria.',
       '',
       'SEQPPR',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '01',
       120,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'LAN ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '02',
       130,
       1,
       'SITMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'LAN ',
       40,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'T',
       'Situao',
       'Situao',
       '',
       'SITMOV',
       'T' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '02',
       17,
       5,
       'TIPLAN',
       'G',
       'DLAN',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DLAN.DESLAN',
       'V',
       '',
       'F',
       '9',
       'F',
       'Motivo Lanamento',
       'Motivo do Lanamento',
       'LAN.TIPLAN = DLAN.CODTAB',
       'TIPLAN',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '01',
       140,
       1,
       'TIPMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'LAN ',
       50,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'T',
       'Tipo',
       'Tipo',
       '',
       'TIPMOV',
       'T' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '99',
       310,
       16,
       'TOTCMG',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Total CM ger.',
       'Valor Total CM gerencial no momento do lanamento',
       '',
       'TOTCMG',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '99',
       320,
       16,
       'TOT_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Total CM',
       'Valor Total CM no momento do lanamento',
       '',
       'TOT_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'LAN ',
       '02',
       150,
       8,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       'LAN ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'T',
       'Valor',
       'Valor',
       '',
       'VLRMOV',
       'F' FROM DUAL
);

/*-- SEQ 8443 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'LAN ',
       'SITMOV',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAN ',
       'SITMOV',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAN ',
       'TIPMOV',
       0,
       'A',
       'Ajuste',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAN ',
       'TIPMOV',
       0,
       'I',
       'Inicial',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8444 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LAY ',
       0,
       'LAY ',
       'BI_LayOut Tabelas',
       'TT_LAY',
       'T',
       '',
       'TOTALL',
       'Layout',
       '{ARQ;CODGRU;NRO_REG}',
       '',
       '',
       '',
       'F',
       '',
       'LAY.CODTAB,LAY.CODGRU,LAY.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8445 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LAY ','--','' FROM DUAL
);

/*-- SEQ 8446 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 25766,
       'GRU ',
       'LAY ',
       '1',
       '0N',
       '',
       '',
       'GRU.CODTAB = LAY.CODTAB AND
GRU.CODGRU = LAY.CODGRU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 25765,
       'ARQ ',
       'LAY ',
       '1',
       '0N',
       '',
       '',
       'LAY.CODTAB(+) = ARQ.CODTAB',
       '',
       '' FROM DUAL
);

/*-- SEQ 8447 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LAY ',
       '--',
       170,
       4,
       'ARQLIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'LAY ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Tabela de Dominio',
       'Apelido da tabela de domnio',
       '',
       'ARQLIS',
       'F' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       160,
       10,
       'CLAFIL',
       '4',
       '',
       0,
       0,
       'LAY ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'LAY',
       'F',
       'A',
       'F',
       'Observacao',
       'Observao',
       '',
       'RTF2TXT(CLAFIL)',
       'F' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       50,
       2,
       'CODGRU',
       'A',
       '',
       0,
       0,
       'LAY ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'LAY',
       'F',
       'A',
       'F',
       'Codigo do Usuario',
       'Cdigo do grupo',
       '',
       'CODGRU',
       'F' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       130,
       2,
       'CODIGO',
       'S',
       '',
       0,
       0,
       'LAY ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'LAY',
       'F',
       'N',
       'F',
       'Nr. do ID',
       'Contem o nmero identificador da funo utilizada no clculo do campo',
       '',
       'CODIGO',
       'F' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       180,
       100,
       'CODLIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'LAY ',
       150,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Regras~Relacionament',
       'Regras de relacionamento com o domnio',
       '',
       'CODLIS',
       'F' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       10,
       4,
       'CODTAB',
       'A',
       'DCUS',
       0,
       0,
       'LAY ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'LAY',
       'F',
       'A',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       'DCUS.CODTAB = CUS.CODTAB',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       110,
       72,
       'DESCPO',
       'A',
       '',
       0,
       0,
       'LAY ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'LAY',
       'F',
       'A',
       'F',
       'Explicacao do Campo',
       'Contem a explicao do que  o campo',
       '',
       'DESCPO',
       'F' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       190,
       30,
       'DESLIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'LAY ',
       160,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Itens Lista Variavel',
       'Itens que aparecem nas listas variaveis',
       '',
       'DESLIS',
       'F' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       23,
       200,
       'EXPRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Expressao',
       'Contem o nome fisico/expressao do campo',
       '',
       'EXPRES',
       'F' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       22,
       1,
       'NETDAT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa TotaliBI?',
       'Indica se o campo  usado ou nao pelo Totali BI',
       '',
       'NETDAT',
       'F' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       70,
       11,
       'NOMCPO',
       'A',
       '',
       0,
       0,
       'LAY ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'LAY',
       'F',
       'A',
       'F',
       'Nome do Campo',
       'Contem o nome do campo no Totali for Windows',
       '',
       'NOMCPO',
       'F' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       40,
       15,
       'NOMUSU',
       'A',
       '',
       0,
       0,
       'LAY ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'LAY',
       'F',
       'A',
       'F',
       'Nome de Uso',
       'Nome de Uso',
       '',
       'NOMUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       100,
       2,
       'NUMDEC',
       'S',
       '',
       0,
       0,
       'LAY ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'LAY',
       'F',
       'N',
       'F',
       'Casas Decimais',
       'Contem o nmero de casa decimal que o campo possue no Totali for Windows',
       '',
       'NUMDEC',
       'F' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       200,
       8,
       'NUMDOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       'LAY ',
       170,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'N',
       'F',
       'Tamanho do ~Dominio',
       'Tamanho Descritivo do Dominio',
       '',
       'NUMDOM',
       'F' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       210,
       8,
       'OLDSEQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       'LAY ',
       180,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'N',
       'F',
       'Sequenciador(Futuro)',
       'Uso futuro (Nao  mais usado)',
       '',
       'OLDSEQ',
       'F' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       220,
       4,
       'ORIGEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'LAY ',
       190,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Tabela de Origem',
       'Apelido da tabela origem',
       '',
       'ORIGEM',
       'F' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       241,
       1,
       'OUJOIN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Outer Join?',
       'Outer Join?',
       '',
       'OUJOIN',
       'F' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       60,
       2,
       'SEQUEN',
       'S',
       '',
       0,
       0,
       'LAY ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'LAY',
       'F',
       'N',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       90,
       2,
       'TAMCPO',
       'S',
       '',
       0,
       0,
       'LAY ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'LAY',
       'F',
       'N',
       'F',
       'Tamanho do Campo',
       'Contem o tamanho do campo no Totali for Windows',
       '',
       'TAMCPO',
       'F' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       80,
       1,
       'TIPCPO',
       'A',
       '',
       0,
       0,
       'LAY ',
       80,
       30,
       '',
       '',
       'D',
       'LAY',
       'F',
       'A',
       'F',
       'Tipo do Campo',
       'Contem o tipo do campo no Totali for Windows',
       '',
       'TIPCPO',
       'T' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       30,
       1,
       'TIPDAD',
       'A',
       '',
       0,
       0,
       'LAY ',
       30,
       30,
       '',
       '',
       'D',
       'LAY',
       'F',
       'A',
       'F',
       'Tipo do Dado',
       'Tipo de Dado',
       '',
       'TIPDAD',
       'T' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       20,
       1,
       'TIPFIL',
       'A',
       '',
       0,
       0,
       'LAY ',
       20,
       30,
       '',
       '',
       'D',
       'LAY',
       'F',
       'A',
       'F',
       'Tipo de Filtro',
       'Tipo de Filtro',
       '',
       'TIPFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       260,
       1,
       'TIP_LGPD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo de Dado LGPD',
       'Tipo de Dados LGPD?',
       '',
       'TIP_LGPD',
       'T' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       230,
       1,
       'TOTALIZADO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'LAY ',
       200,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Totalizavel?',
       'Coluna  totalizavel?',
       '',
       'TOTALIZADO',
       'F' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       251,
       1,
       'USOCPO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Uso do campo',
       'Uso do Campo',
       '',
       'USOCPO',
       'F' FROM DUAL
UNION ALL
SELECT 'LAY ',
       '--',
       240,
       4,
       'VELHO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'LAY ',
       210,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Uso Futuro',
       'Uso futuro',
       '',
       'VELHO',
       'F' FROM DUAL
);

/*-- SEQ 8448 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'LAY ',
       'TIPCPO',
       0,
       '4',
       'Varchar II(4000)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPCPO',
       0,
       '@',
       'Data + Hora',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPCPO',
       0,
       'A',
       'Caracter',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPCPO',
       0,
       'D',
       'Data',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPCPO',
       0,
       'F',
       'Real',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPCPO',
       0,
       'G',
       'Inteiro > 4',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPCPO',
       0,
       'L',
       'Logico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPCPO',
       0,
       'M',
       'Memo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPCPO',
       0,
       'N',
       'Inteiro > 8',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPCPO',
       0,
       'S',
       'Inteiro > 2',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPDAD',
       0,
       '0',
       'Num. Zeros a Esquerda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPDAD',
       0,
       '9',
       'Num. Espacos a Esquerda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPDAD',
       0,
       '@',
       'Data + Hora',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPDAD',
       0,
       'A',
       'Alfanumerico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPDAD',
       0,
       'B',
       'BMP (path ou direto)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPDAD',
       0,
       'D',
       'Datas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPDAD',
       0,
       'N',
       'Numerico a esquerda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPFIL',
       0,
       'A',
       'Alfanumerico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPFIL',
       0,
       'D',
       'Dominio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPFIL',
       0,
       'I',
       'Intervalo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPFIL',
       0,
       'L',
       'LookUp',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPFIL',
       0,
       'S',
       'LookUp c/ codigo significativo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPFIL',
       0,
       'U',
       'Unico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPFIL',
       0,
       'V',
       'Lista Variavel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIPFIL',
       0,
       'Y',
       'Yes/No (Logico)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIP_LGPD',
       0,
       'D',
       'Sem Controle',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIP_LGPD',
       0,
       'P',
       'Dado Pessoal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LAY ',
       'TIP_LGPD',
       0,
       'S',
       'Dado Sensvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8449 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LBRU',
       TO_NUMBER(null),
       'LBRU',
       'Log Rec. Bruta Ms',
       'TL_BRU',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8450 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LBRU','--','' FROM DUAL
UNION ALL
SELECT 'LBRU','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LBRU','99','Outros' FROM DUAL
);

/*-- SEQ 8451 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20286,
       'BRU ',
       'LBRU',
       '1',
       'N',
       '',
       '',
       'LBRU.FILBRU = BRU.CODFIL AND
LBRU.SEQBRU = BRU.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 8452 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LBRU',
       '--',
       20,
       10,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       '',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'LBRU',
       '--',
       30,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       '',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LBRU',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do usurio',
       'Cdigo do usurio',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LBRU',
       '--',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LBRU',
       '--',
       60,
       3,
       'FILBRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       '',
       'FILBRU',
       'F' FROM DUAL
UNION ALL
SELECT 'LBRU',
       '--',
       70,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Filial do usurio',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LBRU',
       '--',
       80,
       4000,
       'MSGLOG',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Log',
       'Log',
       '',
       'MSGLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'LBRU',
       '--',
       90,
       10,
       'SEQBRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQBRU',
       'F' FROM DUAL
);

/*-- SEQ 8453 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LCCB',
       TO_NUMBER(null),
       'LCCB',
       'Log Carteira Bancri',
       'TL_CCB',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'LCCB.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 8454 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LCCB','--','' FROM DUAL
UNION ALL
SELECT 'LCCB','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LCCB','99','Outros' FROM DUAL
);

/*-- SEQ 8455 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 24503,
       'USU ',
       'LCCB',
       '1',
       'N',
       '',
       '',
       'LCCB.FILUSU = USU.FILUSU AND 
LCCB.CODUSU = USU.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23931,
       'CCB ',
       'LCCB',
       '1',
       '0N',
       '',
       '',
       'CCB.CODBCO = LCCB.CODBCO(+) AND
CCB.CODCCB = LCCB.CODCCB(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8456 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LCCB',
       '01',
       10,
       3,
       'CODBCO',
       'A',
       'DBCO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DBCO.NBANCO',
       'V',
       '',
       '',
       'A',
       'F',
       'Cd. Banco',
       'Cdigo do Banco',
       'DBCO.CBANCO = LCCB.CODBCO',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'LCCB',
       '01',
       20,
       5,
       'CODCCB',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cd. Carteira',
       'Cdigo Carteira',
       '',
       'CODCCB',
       'F' FROM DUAL
UNION ALL
SELECT 'LCCB',
       '01',
       30,
       10,
       'CODTAB',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo',
       'Cdigo',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'LCCB',
       '99',
       40,
       12,
       'CODUID',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ident. de Acesso',
       'Identificao de acesso',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LCCB',
       '99',
       50,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       '9',
       'F',
       'Cdigo Usurio',
       'Cdigo Usurio',
       'LCCB.FILUSU = USU.FILUSU AND LCCB.CODUSU = USU.CODUSU',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LCCB',
       '99',
       60,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LCCB',
       '99',
       70,
       3,
       'FILUSU',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Usurio',
       'Filial Usurio',
       'DFIL.CODFIL = LCCB.FILUSU',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LCCB',
       '99',
       80,
       4000,
       'MSGLOG',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem de Log',
       'Mensagem de Log',
       '',
       'RTF2TXT(MSGLOG)',
       'F' FROM DUAL
);

/*-- SEQ 8457 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LCF ',
       TO_NUMBER(null),
       'LCF ',
       'Transaes Inv.',
       'TT_LCF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'LCF.CODFIL,LCF.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8458 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LCF ','--','' FROM DUAL
UNION ALL
SELECT 'LCF ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LCF ','02','Datas' FROM DUAL
UNION ALL
SELECT 'LCF ','03','Valores' FROM DUAL
UNION ALL
SELECT 'LCF ','99','Outros' FROM DUAL
);

/*-- SEQ 8459 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22868,
       'ORC ',
       'LCF ',
       '01',
       '01',
       '',
       '',
       'LCF.FILPED = ORC.CODFIL AND
LCF.TIPPED = ORC.TIPPED AND
LCF.NUMPED = ORC.NUMPED',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22869,
       'USU ',
       'LCF ',
       'N',
       '1',
       '',
       '',
       'USU.FILUSU = LCF.FILUSU AND
USU.CODUSU = LCF.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 8460 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LCF ',
       '02',
       15,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       275,
       8,
       'BUILD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Build do Subversion',
       'Build do Subversion',
       '',
       'BUILD',
       'F' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       4,
       5,
       'CODERR',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo do Erro',
       'Cdigo do Erro',
       '',
       'CODERR',
       'F' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       25,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = LCF.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       35,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       'F',
       'A',
       'F',
       'Srie',
       'Cdigo Servio',
       'LCF.CODSER=DSER.CODSER (+)',
       'CODSER',
       'T' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       45,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Usurio',
       'Cdigo do Usurio',
       'USU2.FILUSU(+) = LCF.CODUSU AND USU2.CODUSU(+) = LCF.CODUSU  ',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       235,
       6,
       'CONCCF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cont. Oper. Fiscais',
       'Contador Geral de Operaes Fiscais',
       '',
       'CONCCF',
       '' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       205,
       6,
       'CONCDC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cont Comprov Db/Cr',
       'Contador Geral de Comprovante de Dbito e Crdito',
       '',
       'CONCDC',
       'F' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       225,
       6,
       'CONCOO',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Contador Operaes',
       'Contador Geral de Operaes',
       '',
       'CONCOO',
       'F' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       185,
       6,
       'CONGNF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cont Oper no fiscal',
       'Contador Geral de Operaes No Fiscais',
       '',
       'CONGNF',
       'F' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       195,
       6,
       'CONGRG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cont Relat Gerencial',
       'Contador Geral Relatrio Gerencial',
       '',
       'CONGRG',
       'F' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       2,
       8,
       'CUPFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cupom Fiscal',
       'Cupom Fiscal',
       '',
       'CUPFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '02',
       295,
       8,
       'DATFIS',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Fiscal',
       'Data Fiscal',
       '',
       'DATFIS',
       '' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '02',
       1,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data e Hora',
       'Data e Hora',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '99',
       245,
       3,
       'FILPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Fil DAV/Pr-Ven Imp',
       'Filial do DAV/Pr-Venda Impresso.',
       '',
       'FILPED',
       'F' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       55,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '99',
       65,
       1,
       'FLGCAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Flag Cancelamento',
       'Flag Cancelamento',
       '',
       'FLGCAN',
       'T' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '99',
       75,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '99',
       85,
       1,
       'FLGEXE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Flag de Execuo',
       'Flag de Execuo',
       '',
       'FLGEXE',
       'T' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '99',
       95,
       1,
       'FLGHIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Flag Histrico ',
       'Flag Histrico dos Produtos',
       '',
       'FLGHIS',
       'T' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '99',
       105,
       1,
       'FLGPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Flag de Programar',
       'Flag de Programar',
       '',
       'FLGPRO',
       'T' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       5,
       4000,
       'MSGERR',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem de Erro',
       'Mensagem de Erro',
       '',
       'RTF2TXT(MSGERR)',
       'F' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       3,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       'Nmero ECF',
       'Nmero ECF',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '99',
       255,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'N DAV/Pr-Ven Imp',
       'Nmero do DAV/Pr-Venda Impresso.',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       165,
       5,
       'RELEAS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'release Checkout',
       'release Checkout',
       '',
       'RELEAS',
       'F' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       115,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       285,
       1,
       'SISORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Sistema',
       'Sistema que gravou a transao',
       '',
       'SISORI',
       'T' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       215,
       2,
       'TIPDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Denom docum fiscal',
       'Denominao do documento fiscal',
       '',
       'TIPDOC',
       'T' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       125,
       10,
       'TIPOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Operao',
       'Tipo Operao',
       '',
       'TIPOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '99',
       265,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo DAV/Pr-Ven Imp',
       'Tipo do DAV/Pr-Venda Impresso.',
       '',
       'TIPPED',
       'F' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       135,
       12,
       'TRN_ID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'ID Transacao',
       'ID Transacao',
       '',
       'TRN_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       175,
       5,
       'VERBAS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Verso Banco',
       'Verso Banco',
       '',
       'VERBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       155,
       5,
       'VERSAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Verso Checkout',
       'Verso Checkout',
       '',
       'VERSAO',
       'F' FROM DUAL
UNION ALL
SELECT 'LCF ',
       '01',
       145,
       16,
       'VLROPE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Operao',
       'Valor Operao',
       '',
       'VLROPE',
       'F' FROM DUAL
);

/*-- SEQ 8461 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'LCF ',
       'FLGCAN',
       0,
       'T',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LCF ',
       'FLGEST',
       0,
       'T',
       'No processado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LCF ',
       'FLGEXE',
       0,
       'T',
       'Processado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LCF ',
       'FLGHIS',
       0,
       'T',
       'Histrico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LCF ',
       'FLGPRO',
       0,
       'T',
       'Programar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LCF ',
       'SISORI',
       0,
       'C',
       'Checkout',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LCF ',
       'SISORI',
       0,
       'M',
       'Middleware',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LCF ',
       'TIPDOC',
       0,
       ' ',
       'Comprovante de Crd ou Dbito',
       TO_NUMBER(null),
       'CC' FROM DUAL
UNION ALL
SELECT 'LCF ',
       'TIPDOC',
       0,
       ' ',
       'Comprovante No-Fiscal',
       TO_NUMBER(null),
       'CN' FROM DUAL
UNION ALL
SELECT 'LCF ',
       'TIPDOC',
       0,
       ' ',
       'Comprov NoFiscal Cancelamento',
       TO_NUMBER(null),
       'NC' FROM DUAL
UNION ALL
SELECT 'LCF ',
       'TIPDOC',
       0,
       ' ',
       'Relatrio Gerencial',
       TO_NUMBER(null),
       'RG' FROM DUAL
UNION ALL
SELECT 'LCF ',
       'TIPDOC',
       0,
       ' ',
       'Conferncia de Mesa',
       TO_NUMBER(null),
       'CM' FROM DUAL
UNION ALL
SELECT 'LCF ',
       'TIPDOC',
       0,
       ' ',
       'Registro de Venda',
       TO_NUMBER(null),
       'RV' FROM DUAL
UNION ALL
SELECT 'LCF ',
       'TIPDOC',
       0,
       ' ',
       'Leitura X',
       TO_NUMBER(null),
       'LX' FROM DUAL
UNION ALL
SELECT 'LCF ',
       'TIPDOC',
       0,
       ' ',
       'Leitura Memria Fiscal',
       TO_NUMBER(null),
       'MF' FROM DUAL
UNION ALL
SELECT 'LCF ',
       'TIPDOC',
       0,
       ' ',
       'Reduo Z',
       TO_NUMBER(null),
       'RZ' FROM DUAL
);

/*-- SEQ 8462 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LCFG',
       TO_NUMBER(null),
       'LCFG',
       'Log de Configuraes',
       'TL_CFG',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8463 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LCFG','--','' FROM DUAL
UNION ALL
SELECT 'LCFG','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LCFG','99','Outros' FROM DUAL
);

/*-- SEQ 8464 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LCFG',
       '--',
       20,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo num. tabela',
       'Cdigo numrico da tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'LCFG',
       '--',
       90,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Identificao do log',
       'Identificao do log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LCFG',
       '--',
       50,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       '9',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'USU2.FILUSU(+) = LCFG.FILUSU AND USU2.CODUSU(+) = LCFG.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LCFG',
       '--',
       60,
       30,
       'COLUNA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Coluna alterada',
       'Coluna alterada no log',
       '',
       'COLUNA',
       'F' FROM DUAL
UNION ALL
SELECT 'LCFG',
       '--',
       30,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data operao',
       'Data da operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LCFG',
       '--',
       70,
       4000,
       'DE',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Alterao de',
       'Alterao de',
       '',
       'RTF2TXT(DE)',
       'F' FROM DUAL
UNION ALL
SELECT 'LCFG',
       '--',
       40,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Filial usurio',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LCFG',
       '--',
       100,
       1,
       'OPERAD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo alterao',
       'Tipo de alteraao',
       '',
       'OPERAD',
       'T' FROM DUAL
UNION ALL
SELECT 'LCFG',
       '--',
       80,
       4000,
       'PARA',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Alterao para',
       'Alterao para',
       '',
       'RTF2TXT(PARA)',
       'F' FROM DUAL
UNION ALL
SELECT 'LCFG',
       '--',
       10,
       12,
       'TABELA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo da tabela',
       'Cdigo fsico da tabela',
       '',
       'TABELA',
       'F' FROM DUAL
);

/*-- SEQ 8465 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'LCFG',
       'OPERAD',
       0,
       'A',
       'Alterao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LCFG',
       'OPERAD',
       0,
       'E',
       'Excluso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LCFG',
       'OPERAD',
       0,
       'I',
       'Incluso',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8466 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LCHR',
       TO_NUMBER(null),
       'LCHR',
       'Log de Cheques Receb',
       'TL_CHR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'lchr.codfil,lchr.seqche',
       '' FROM DUAL
);

/*-- SEQ 8467 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LCHR','--','' FROM DUAL
);

/*-- SEQ 8468 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 33932,
       'TUID',
       'LCHR',
       '01',
       '0N',
       '',
       '',
       'LCHR.CODUID = TUID.CODUID(+)',
       '' FROM DUAL
);

/*-- SEQ 8469 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LCHR',
       '--',
       45,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data',
       'Ano de Data da alterao',
       '',
       'TO_CHAR(LCHR.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'LCHR',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial onde foram feitas as alteraes',
       'DFIL.CODFIL = LCHR.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'LCHR',
       '--',
       70,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Identificao do Log',
       'Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LCHR',
       '--',
       30,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Usurio',
       'Usurio que fez as alteraes',
       'LCHR.FILUSU = USU.FILUSU(+) and LCHR.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LCHR',
       '--',
       40,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data',
       'Data da alterao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LCHR',
       '--',
       50,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LCHR',
       '--',
       43,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data',
       'Ms de Data da alterao',
       '',
       'TO_CHAR(LCHR.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'LCHR',
       '--',
       60,
       200,
       'MSGLOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Alteraes',
       'Mostra quais as alteraes foram realizadas',
       '',
       'MSGLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'LCHR',
       '--',
       20,
       10,
       'SEQCHE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Controle Interno',
       '',
       'SEQCHE',
       'F' FROM DUAL
);


/*-- SEQ 8470 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LCK ',
       TO_NUMBER(null),
       'LCK ',
       'Lock de Documentos',
       'TT_LCK',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8471 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LCK ','--','' FROM DUAL
UNION ALL
SELECT 'LCK ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LCK ','99','Outros' FROM DUAL
);

/*-- SEQ 8472 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LCK ',
       '99',
       10,
       7,
       'LCKDAT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data',
       'Data',
       '',
       'LCKDAT',
       'F' FROM DUAL
UNION ALL
SELECT 'LCK ',
       '01',
       20,
       20,
       'LCKDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'LCKDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'LCK ',
       '99',
       30,
       3,
       'LCKECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       'F',
       'Nmero do ECF',
       'Nmero do ECF',
       '',
       'LCKECF',
       'F' FROM DUAL
UNION ALL
SELECT 'LCK ',
       '99',
       40,
       3,
       'LCKFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = LCK.LCKFIL',
       'LCKFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'LCK ',
       '99',
       50,
       254,
       'LCKOBS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       'F',
       'Observao',
       '',
       '',
       'LCKOBS',
       'F' FROM DUAL
UNION ALL
SELECT 'LCK ',
       '99',
       60,
       12,
       'LCKTRN',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Transao',
       '',
       '',
       'LCKTRN',
       'F' FROM DUAL
UNION ALL
SELECT 'LCK ',
       '99',
       70,
       30,
       'LCKUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Usurio',
       'Usurio',
       '',
       'LCKUSU',
       'F' FROM DUAL
);

/*-- SEQ 8473 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LCLI',
       TO_NUMBER(null),
       'LCLI',
       'Log de Parceiros',
       'TL_CLI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'LCLI.FILCLI,LCLI,CODCLI',
       '' FROM DUAL
);

/*-- SEQ 8474 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LCLI','--','' FROM DUAL
);

/*-- SEQ 8475 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 33762,
       'CLI ',
       'LCLI',
       '1',
       'N',
       '',
       '',
       'LCLI.FILCLI = CLI.FILCLI and
LCLI.CODCLI = CLI.CODCLI
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 33933,
       'TUID',
       'LCLI',
       '01',
       '0N',
       '',
       '',
       'LCLI.CODUID = TUID.CODUID(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8476 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LCLI',
       '--',
       35,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data',
       'Ano de Data da alterao',
       '',
       'TO_CHAR(LCLI.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'LCLI',
       '--',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo do Parceiro',
       'Cdigo do Parceiro',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'LCLI',
       '--',
       70,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Identificao do Log',
       'Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LCLI',
       '--',
       20,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Usurio',
       'Usurio que fez as alteraes',
       'LCLI.FILUSU = USU.FILUSU(+) and LCLI.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LCLI',
       '--',
       30,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data',
       'Data da alterao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LCLI',
       '--',
       40,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial do parceiro',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'LCLI',
       '--',
       50,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LCLI',
       '--',
       33,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data',
       'Ms de Data da alterao',
       '',
       'TO_CHAR(LCLI.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'LCLI',
       '--',
       60,
       4000,
       'MSGLOG',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Alteraes',
       'Mostra quais as alteraes foram realizadas',
       '',
       'RTF2TXT(MSGLOG)',
       'F' FROM DUAL
);

/*-- SEQ 8477 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LCOM',
       TO_NUMBER(null),
       'LCOM',
       'Log de Compras',
       'TL_COM',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8478 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LCOM','--','' FROM DUAL
UNION ALL
SELECT 'LCOM','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LCOM','99','Outros' FROM DUAL
);

/*-- SEQ 8479 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 18295,
       'COM ',
       'LCOM',
       '1',
       'N',
       '',
       '',
       'LCOM.CODFIL(+) = COM.CODFIL AND
LCOM.SEQUEN(+) = COM.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 18296,
       'USU ',
       'LCOM',
       '1',
       '1',
       '',
       '',
       'LCOM.FILUSU = USU.FILUSU AND
LCOM.CODUSU = USU.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 17674,
       'TUID',
       'LCOM',
       '1',
       'N',
       '',
       '',
       'LCOM.CODUID = TUID.CODUID',
       '',
       '' FROM DUAL
);

/*-- SEQ 8480 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'LCOM',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.CODFIL||'' - ''||DFIL.NOMFIL',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODTAB(+) = LCOM.CODFIL',
       'CODFIL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'LCOM',
       '01',
       20,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cod. Ident. Usurio',
       'Cdigo Identificao de Usurio',
       '',
       'CODUID',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'LCOM',
       '01',
       30,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Usurio',
       'Cdigo do Usurio',
       '',
       'CODUSU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'LCOM',
       '01',
       40,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data da Operao',
       'Data da Operao',
       '',
       'DATOPE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'LCOM',
       '01',
       50,
       3,
       'FILUSU',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial do Usurio',
       'Filial do Usurio',
       'DFIL.CODFIL(+) = LCOM.FILUSU',
       'FILUSU',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'LCOM',
       '01',
       60,
       4000,
       'MSGLOG',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Alteraes',
       'Alteraes',
       '',
       'MSGLOG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'LCOM',
       '01',
       70,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F',
       'D' FROM DUAL
);

/*-- SEQ 8481 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LCPR',
       TO_NUMBER(null),
       'LCPR',
       'Logs da Campanha',
       'TL_CPR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8482 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LCPR','--','' FROM DUAL
UNION ALL
SELECT 'LCPR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LCPR','99','Outros' FROM DUAL
);

/*-- SEQ 8483 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 112060,
       'CPR ',
       'LCPR',
       '1',
       'N',
       '',
       '',
       'LCPR.FILCPR = CPR.CODFIL AND
LCPR.SEQCPR = CPR.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 112061,
       'USU ',
       'LCPR',
       '1',
       'N',
       '',
       '',
       'LCPR.FILUSU = USU.FILUSU AND
LCPR.CODUSU = USU.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 8484 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LCPR',
       '--',
       10,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Chave Registro',
       'Chave de registro',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LCPR',
       '--',
       20,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo Usurio',
       'Cdigo Usurio',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LCPR',
       '--',
       30,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data da Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LCPR',
       '--',
       40,
       3,
       'FILCPR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial Campanha',
       'Filial Campanha',
       'DFIL.CODFIL = LCPR.FILCPR(+)',
       'FILCPR',
       'T' FROM DUAL
UNION ALL
SELECT 'LCPR',
       '--',
       50,
       3,
       'FILUSU',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial Usurio',
       'Filial Usurio',
       'DFIL.CODFIL = LCPR.FILUSU(+)',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LCPR',
       '--',
       60,
       10,
       'ID_LCPR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'ID_LCPR',
       'F' FROM DUAL
UNION ALL
SELECT 'LCPR',
       '--',
       70,
       4000,
       'MSGLOG',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem Log',
       'Mensagem de log',
       '',
       'MSGLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'LCPR',
       '--',
       80,
       10,
       'SEQCPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. Campanha',
       'Sequenciador da campanha',
       '',
       'SEQCPR',
       'T' FROM DUAL
);

/*-- SEQ 8485 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LCTF',
       TO_NUMBER(null),
       'LCTF',
       'Log de CTF',
       'TL_CTF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8486 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LCTF','--','' FROM DUAL
UNION ALL
SELECT 'LCTF','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LCTF','02','Dados' FROM DUAL
UNION ALL
SELECT 'LCTF','80','WebService' FROM DUAL
UNION ALL
SELECT 'LCTF','99','Outros' FROM DUAL
);

/*-- SEQ 8487 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LCTF',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = LCTF.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'LCTF',
       '02',
       45,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       '9',
       'F',
       'Cdigo do Usurio',
       'Cdigo do Usurio',
       'LCTF.FILUSU = USU.FILUSU(+)  AND LCTF.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LCTF',
       '02',
       30,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'LCTF',
       '02',
       40,
       3,
       'FILUSU',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.CODFIL||'' - ''||DFIL.NOMFIL',
       'A',
       '',
       '',
       '0',
       'F',
       'Filial do Usurio',
       'Filial do Usurio',
       'DFIL.CODFIL = LCTF.FILUSU(+)',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LCTF',
       '01',
       15,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'LCTF',
       '80',
       70,
       5,
       'TEMPLA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Template Utilizado',
       'Template Utilizado',
       '',
       'TEMPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'LCTF',
       '80',
       50,
       10,
       'ULTPON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'ltimo Ponteiro',
       'Ponteiro para ltimo Abastecimento Requisitado',
       '',
       'ULTPON',
       'F' FROM DUAL
UNION ALL
SELECT 'LCTF',
       '80',
       80,
       4000,
       'XMLRET',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'XML Retornado',
       'XML Retornado',
       '',
       'XMLRET',
       'F' FROM DUAL
);

/*-- SEQ 8488 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LCTT',
       TO_NUMBER(null),
       'LCTT',
       'Log de Contratos',
       'TL_CTT',
       'T',
       '',
       'TOTALL',
       'Log de Contratos',
       '',
       '',
       '',
       '',
       'F',
       '',
       'LCTT.CODFIL,LCTT.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8489 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LCTT','--','' FROM DUAL
);

/*-- SEQ 8490 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 33934,
       'TUID',
       'LCTT',
       '01',
       '0N',
       '',
       '',
       'LCTT.CODUID = TUID.CODUID(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8491 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LCTT',
       '--',
       55,
       4,
       'ANO_DATALT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data Atualiza',
       'Ano de Data da ltima Atualizao',
       '',
       'TO_CHAR(LCTT.DATALT,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'LCTT',
       '--',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       '0',
       'F',
       'Filial',
       'Cdigo da Filial do Contrato',
       'DFIL.CODFIL = LCTT.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'LCTT',
       '--',
       70,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Identificao do Log',
       'Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LCTT',
       '--',
       4,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       40,
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Usurio',
       'Cdigo do Usurio que faz o Cadastramento do Contrato',
       'LCTT.FILUSU = USU.FILUSU(+)  AND LCTT.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LCTT',
       '--',
       50,
       8,
       'DATALT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data Atualizao',
       'Data da ltima Atualizao',
       '',
       'DATALT',
       'F' FROM DUAL
UNION ALL
SELECT 'LCTT',
       '--',
       3,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Usurio que faz o Cadastramento do Contrato',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LCTT',
       '--',
       51,
       2,
       'MES_DATALT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data Atualiza',
       'Ms de Data da ltima Atualizao',
       '',
       'TO_CHAR(LCTT.DATALT,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'LCTT',
       '--',
       60,
       4000,
       'MSGLOG',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       60,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Alterao',
       'Indica o que foi alterado',
       '',
       'RTF2TXT(MSGLOG)',
       'F' FROM DUAL
UNION ALL
SELECT 'LCTT',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8492 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LCUP',
       TO_NUMBER(null),
       'LCUP',
       'Logs do Cupom',
       'TL_CUP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8493 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LCUP','--','' FROM DUAL
UNION ALL
SELECT 'LCUP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LCUP','99','Outros' FROM DUAL
);

/*-- SEQ 8494 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 112064,
       'CUP ',
       'LCUP',
       '1',
       'N',
       '',
       '',
       'LCUP.FIlCUP = CUP.CODFIL AND
LCUP.SEQCUP = CUP.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 112065,
       'USU ',
       'LCUP',
       '01',
       'N',
       '',
       '',
       'LCUP.FILUSU = USU.FILUSU AND
LCUP.CODUSU = USU.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 8495 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LCUP',
       '--',
       10,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Chave Registro',
       'Chave de registro',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LCUP',
       '--',
       20,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo Usurio',
       'Cdigo usurio',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LCUP',
       '--',
       30,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LCUP',
       '--',
       40,
       3,
       'FILCUP',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Cupom',
       'Filial do cupom',
       'DFIL.CODFIL = LCUP.FILCUP(+)',
       'FILCUP',
       'T' FROM DUAL
UNION ALL
SELECT 'LCUP',
       '--',
       50,
       3,
       'FILUSU',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Usurio',
       'Filial do usurio',
       'DFIL.CODFIL = LCUP.FILUSU(+)',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LCUP',
       '--',
       60,
       10,
       'ID_LCUP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'ID_LCUP',
       'F' FROM DUAL
UNION ALL
SELECT 'LCUP',
       '--',
       70,
       4000,
       'MSGLOG',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem Log',
       'Mensagem de log',
       '',
       'MSGLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'LCUP',
       '--',
       80,
       10,
       'SEQCUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. Cupom',
       'Sequenciador do cupom',
       '',
       'SEQCUP',
       'T' FROM DUAL
);

/*-- SEQ 8496 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LDOM',
       TO_NUMBER(null),
       'LDOM',
       'Log de domnios',
       'TT_DOM_LOG',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8497 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LDOM','--','' FROM DUAL
UNION ALL
SELECT 'LDOM','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LDOM','99','Outros' FROM DUAL
);

/*-- SEQ 8498 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LDOM',
       '--',
       10,
       7,
       'DATA',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Modificao',
       'Data de Modificao',
       '',
       'DATA',
       'F' FROM DUAL
UNION ALL
SELECT 'LDOM',
       '--',
       20,
       50,
       'OPERACAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo de Operao',
       'Tipo de Operao',
       '',
       'OPERACAO',
       'F' FROM DUAL
UNION ALL
SELECT 'LDOM',
       '--',
       30,
       12,
       'QTDREG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Qtde Reg. Afetados',
       'Quantidade de Registros Afetados',
       '',
       'QTDREG',
       'F' FROM DUAL
UNION ALL
SELECT 'LDOM',
       '--',
       40,
       50,
       'USUARIO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Usurio',
       'Usurio',
       '',
       'USUARIO',
       'F' FROM DUAL
);

/*-- SEQ 8499 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LDOP',
       TO_NUMBER(null),
       'LDOP',
       'Log de Doc a Pagar',
       'TL_DOP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'LDOP.FILDOP,LDOP.SEQDOP',
       '' FROM DUAL
);

/*-- SEQ 8500 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LDOP','--','' FROM DUAL
);

/*-- SEQ 8501 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 33935,
       'TUID',
       'LDOP',
       '01',
       '0N',
       '',
       '',
       'LDOP.CODUID = TUID.CODUID(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8502 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LDOP',
       '--',
       35,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data Operao',
       'Ano de Data Operao',
       '',
       'TO_CHAR(LDOP.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'LDOP',
       '--',
       70,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Identificao do Log',
       'Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LDOP',
       '--',
       60,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Usurio',
       'Cdigo Usurio',
       'LDOP.FILUSU = USU2.FILUSU(+) AND USU2.CODUSU(+) = LDOP.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LDOP',
       '--',
       30,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data Operao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LDOP',
       '--',
       10,
       3,
       'FILDOP',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial Docs a Pagar',
       'Filial Documentos a Pagar',
       'DFIL.CODFIL = LDOP.FILDOP',
       'FILDOP',
       'F' FROM DUAL
UNION ALL
SELECT 'LDOP',
       '--',
       50,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LDOP',
       '--',
       33,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data Operao',
       'Ms de Data Operao',
       '',
       'TO_CHAR(LDOP.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'LDOP',
       '--',
       40,
       4000,
       'MSGLOG',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Mensagem de LOG',
       'Mensagens de Log',
       '',
       'RTF2TXT(MSGLOG)',
       'F' FROM DUAL
UNION ALL
SELECT 'LDOP',
       '--',
       20,
       10,
       'SEQDOP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador de Documentos a Pagar',
       '',
       'SEQDOP',
       'F' FROM DUAL
);

/*-- SEQ 8503 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LEQP',
       TO_NUMBER(null),
       'LEQP',
       'Log de Equipamentos',
       'TL_EQP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8504 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LEQP','--','' FROM DUAL
UNION ALL
SELECT 'LEQP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LEQP','99','Outros' FROM DUAL
);

/*-- SEQ 8505 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 36540,
       'EQP ',
       'LEQP',
       '1',
       'N',
       '',
       '',
       'LEQP.FILEQP = EQP.CODFIL AND
LEQP.SEQEQP = EQP.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 36541,
       'USU ',
       'LEQP',
       '1',
       'N',
       '',
       '',
       'LEQP.FILUSU = USU.FILUSU AND
LEQP.CODUSU = USU.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 8506 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LEQP',
       '--',
       10,
       3,
       'CODUSU',
       'A',
       'USU ',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo do Usurio',
       'Cdigo do Usurio',
       'LEQP.FILUSU = USU.FILUSU(+)  AND LEQP.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       '' FROM DUAL
UNION ALL
SELECT 'LEQP',
       '--',
       50,
       12,
       'DATOPE',
       '@',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data da Operao',
       'Data da Operao',
       '',
       'DATOPE',
       '' FROM DUAL
UNION ALL
SELECT 'LEQP',
       '--',
       30,
       3,
       'FILEQP',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Filial Equipamento',
       'Filial do Equipamento',
       '',
       'FILEQP',
       '' FROM DUAL
UNION ALL
SELECT 'LEQP',
       '--',
       20,
       3,
       'FILUSU',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Filial do Usurio',
       'Filial do Usurio',
       '',
       'FILUSU',
       '' FROM DUAL
UNION ALL
SELECT 'LEQP',
       '--',
       60,
       4000,
       'MSGLOG',
       '4',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Mensagem de Log',
       'Mensagem de Log',
       '',
       'RTF2TXT(MSGLOG)',
       '' FROM DUAL
UNION ALL
SELECT 'LEQP',
       '--',
       40,
       10,
       'SEQEQP',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq. do Equipamento',
       'Sequncia do Equipamento',
       '',
       'SEQEQP',
       '' FROM DUAL
);

/*-- SEQ 8507 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LEX ',
       TO_NUMBER(null),
       'LEX ',
       'Lanamento Extrato',
       'TT_LEX',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8508 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LEX ','--','' FROM DUAL
UNION ALL
SELECT 'LEX ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LEX ','99','Outros' FROM DUAL
);

/*-- SEQ 8509 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LEX ',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL=LEX.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'LEX ',
       '--',
       100,
       5,
       'NUMIEX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nm. Item',
       'Nm. Item',
       '',
       'NUMIEX',
       'F' FROM DUAL
UNION ALL
SELECT 'LEX ',
       '--',
       110,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero~Parcela',
       'Nmero da Parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'LEX ',
       '--',
       230,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'LEX ',
       '--',
       240,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Sub-Parcela',
       'Nmero da sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'LEX ',
       '--',
       250,
       16,
       'VLRLAN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Lanamento',
       'Valor Lanamento',
       '',
       'VLRLAN',
       'F' FROM DUAL
);

/*-- SEQ 8510 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LFIN',
       TO_NUMBER(null),
       'LFIN',
       'Log Financeiro',
       'TL_FIN',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8511 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LFIN','--','' FROM DUAL
UNION ALL
SELECT 'LFIN','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LFIN','99','Outros' FROM DUAL
);

/*-- SEQ 8512 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21634,
       'REC ',
       'LFIN',
       '1',
       '01',
       '',
       '',
       'LFIN.ORIGEM=''REC''
AND LFIN.FILORI=REC.CODFIL
AND LFIN.SEQORI=REC.SEQUEN
AND LFIN.PARORI=REC.NUMPAR
AND LFIN.SUBORI=REC.SUBPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21635,
       'CTA ',
       'LFIN',
       '1',
       '0N',
       '',
       '',
       'LFIN.FILCTA=CTA.CODFIL AND LFIN.SEQCTA=CTA.SEQUEN AND LFIN.TIPCTA=CTA.TIPCTA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21636,
       'FIN ',
       'LFIN',
       '1',
       '01',
       '',
       '',
       'LFIN.ORIGEM=''FIN''
AND LFIN.FILORI=FIN.CODFIL
AND LFIN.SEQORI=FIN.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21637,
       'CHR ',
       'LFIN',
       '1',
       '01',
       '',
       '',
       'LFIN.ORIGEM=''CHR''
AND LFIN.FILORI=CHR.CODFIL
AND LFIN.SEQORI=CHR.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21638,
       'CCC ',
       'LFIN',
       '1',
       '01',
       '',
       '',
       'LFIN.ORIGEM=''CCC''
AND LFIN.FILORI=CCC.CODFIL
AND LFIN.SEQORI=CCC.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21639,
       'PAG ',
       'LFIN',
       '1',
       '01',
       '',
       '',
       'LFIN.ORIGEM=''PAG''
AND LFIN.FILORI=PAG.CODFIL
AND LFIN.SEQORI=PAG.SEQUEN
AND LFIN.PARORI=PAG.NUMPAR
AND LFIN.SUBORI=PAG.SUBPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21640,
       'DOP ',
       'LFIN',
       '1',
       '01',
       '',
       '',
       'LFIN.ORIGEM=''DOP''
AND LFIN.FILORI=DOP.CODFIL
AND LFIN.SEQORI=DOP.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21641,
       'COM ',
       'LFIN',
       '1',
       '01',
       '',
       '',
       'LFIN.ORIGEM=''COM''
AND LFIN.FILORI=COM.CODFIL
AND LFIN.SEQORI=COM.SEQUEN ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21642,
       'TEF ',
       'LFIN',
       '1',
       '01',
       '',
       '',
       'LFIN.ORIGEM=''TEF''
AND LFIN.FILORI=TEF.CODFIL
AND LFIN.SEQORI=TEF.SEQUEN ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21643,
       'CLI ',
       'LFIN',
       '1',
       '0N',
       '',
       '',
       'CLI.FILCLI=LFIN.FILCLI and CLI.CODCLI=LFIN.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45924,
       'RECP',
       'LFIN',
       '1',
       '01',
       '',
       '',
       'LFIN.ORIGEM=''''REC''''
AND LFIN.FILORI=RECP.ORI_CODFIL
AND LFIN.SEQORI=RECP.ORI_SEQUEN
AND LFIN.PARORI=RECP.ORI_NUMPAR
AND LFIN.SUBORI=RECP.ORI_SUBPAR',
       '',
       '' FROM DUAL
);

/*-- SEQ 8513 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LFIN',
       '--',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'LFIN',
       '--',
       20,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'LFIN',
       '--',
       30,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       '',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'LFIN',
       '--',
       40,
       3,
       'DESTIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       'A',
       'F',
       'Destino',
       '',
       '',
       'DESTIN',
       'F' FROM DUAL
UNION ALL
SELECT 'LFIN',
       '--',
       50,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'LFIN',
       '--',
       60,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       '',
       '',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'LFIN',
       '--',
       70,
       3,
       'FILORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILORI',
       'F' FROM DUAL
UNION ALL
SELECT 'LFIN',
       '--',
       80,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'LFIN',
       '--',
       90,
       1,
       'MOTINC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Motivo Inconsist.',
       'Motivo da Inconsistncia',
       '',
       'MOTINC',
       'T' FROM DUAL
UNION ALL
SELECT 'LFIN',
       '--',
       100,
       3,
       'ORIGEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       'A',
       'F',
       'Origem',
       'Origem',
       '',
       'ORIGEM',
       'F' FROM DUAL
UNION ALL
SELECT 'LFIN',
       '--',
       110,
       2,
       'PARORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'N parcela',
       'N parcela',
       '',
       'PARORI',
       'F' FROM DUAL
UNION ALL
SELECT 'LFIN',
       '--',
       120,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'LFIN',
       '--',
       130,
       10,
       'SEQORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQORI',
       'F' FROM DUAL
UNION ALL
SELECT 'LFIN',
       '--',
       140,
       2,
       'SUBORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Sub parcela',
       'Sub parcela',
       '',
       'SUBORI',
       'F' FROM DUAL
UNION ALL
SELECT 'LFIN',
       '--',
       150,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo de conta',
       'Tipo de conta',
       '',
       'TIPCTA',
       'F' FROM DUAL
);

/*-- SEQ 8514 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'LFIN',
       'FLGEST',
       0,
       'I',
       'Inconsistente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LFIN',
       'FLGEST',
       0,
       'N',
       'No Processado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LFIN',
       'FLGEST',
       0,
       'P',
       'Em processamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LFIN',
       'MOTINC',
       0,
       '+',
       'Validao de Contas de Mov',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LFIN',
       'MOTINC',
       0,
       'C',
       'Falta conta de contrapartida',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LFIN',
       'MOTINC',
       0,
       'D',
       'Dif. entre numerria e gerenc.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LFIN',
       'MOTINC',
       0,
       'F',
       'Faltando informaes obrig.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LFIN',
       'MOTINC',
       0,
       'L',
       'Valor Lanament e contra Lanc',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LFIN',
       'MOTINC',
       0,
       'V',
       'Lanamento fora de validade',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8515 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LFRO',
       TO_NUMBER(null),
       'LFRO',
       'log fr. p/ FRO',
       'TL_FRO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8516 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LFRO','--','' FROM DUAL
UNION ALL
SELECT 'LFRO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LFRO','99','Outros' FROM DUAL
);

/*-- SEQ 8517 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LFRO',
       '--',
       10,
       5,
       'CODFRO',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Cdigo da Frmula',
       'Cdigo da Frmula',
       '',
       'CODFRO',
       'F' FROM DUAL
UNION ALL
SELECT 'LFRO',
       '--',
       20,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Identificao do Log',
       'Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LFRO',
       '--',
       30,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Usurio',
       'Cdigo do Usurio',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LFRO',
       '--',
       40,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Incluso',
       'Data de Incluso',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LFRO',
       '--',
       50,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Filial do Usurio',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LFRO',
       '--',
       60,
       4000,
       'MSGLOG',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem de Log',
       'Mensagem de Log',
       '',
       'RTF2TXT(MSGLOG)',
       'F' FROM DUAL
);

/*-- SEQ 8518 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LGAB',
       TO_NUMBER(null),
       'LGAB',
       'Log para Gabaritos',
       'TL_GAB',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8519 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LGAB','--','' FROM DUAL
UNION ALL
SELECT 'LGAB','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LGAB','99','Outros' FROM DUAL
);

/*-- SEQ 8520 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22299,
       'GAB ',
       'LGAB',
       '1',
       'N',
       '',
       '',
       'LGAB.FILGAB = GAB.CODFIL AND
LGAB.SEQGAB = GAB.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 8521 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LGAB',
       '01',
       10,
       10,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Chave',
       'Chave',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'LGAB',
       '99',
       20,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Acesso',
       'Cdigo Acesso',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LGAB',
       '99',
       30,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Cdigo Usurio',
       'Cdigo Usurio',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LGAB',
       '99',
       40,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LGAB',
       '99',
       50,
       3,
       'FILGAB',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Gabarito',
       'Filial Gabarito',
       'DFIL.CODFIL = LGAB.FILGAB',
       'FILGAB',
       'F' FROM DUAL
UNION ALL
SELECT 'LGAB',
       '99',
       60,
       3,
       'FILUSU',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Usurio',
       'Filial Usurio',
       'DFIL.CODFIL = LGAB.FILUSU',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LGAB',
       '99',
       70,
       4000,
       'MSGLOG',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Modificaes',
       'Modificaes',
       '',
       'MSGLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'LGAB',
       '99',
       80,
       10,
       'SEQGAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Seq. Gabarito',
       'Seq. Gabarito',
       '',
       'SEQGAB',
       'F' FROM DUAL
);

/*-- SEQ 8522 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LGPD',
       TO_NUMBER(null),
       'LGPD',
       'Log ',
       'TL_LAYXLGPD',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'LGPD.ID_LLAYXLGPD',
       '' FROM DUAL
);

/*-- SEQ 8523 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LGPD','--','' FROM DUAL
UNION ALL
SELECT 'LGPD','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LGPD','99','Outros' FROM DUAL
);

/*-- SEQ 8524 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 115127,
       'GPD ',
       'LGPD',
       '1',
       'N',
       '',
       '',
       'LGPD.ID_LAYXLGPD = GPD.ID_LAYXLGPD',
       '',
       '' FROM DUAL
);

/*-- SEQ 8525 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LGPD',
       '--',
       70,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Chave Registro',
       'Chave de Registro',
       '',
       'CODUID',
       '' FROM DUAL
UNION ALL
SELECT 'LGPD',
       '--',
       50,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Cdigo do Usurio',
       'Cdigo do Usurio',
       '',
       'CODUSU',
       '' FROM DUAL
UNION ALL
SELECT 'LGPD',
       '--',
       30,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       '',
       'Data da Operao',
       'Data da Operao',
       '',
       'DATOPE',
       '' FROM DUAL
UNION ALL
SELECT 'LGPD',
       '--',
       40,
       3,
       'FILUSU',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial do Usurio',
       'Filial do Usurio',
       'DFIL.CODFIL = LGPD.FILUSU(+)',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LGPD',
       '--',
       20,
       10,
       'ID_LAYXLGPD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Seq. Viso LGPD',
       'Sequenciador para tabela Viso Cliente LGPD',
       '',
       'ID_LAYXLGPD',
       '' FROM DUAL
UNION ALL
SELECT 'LGPD',
       '--',
       10,
       10,
       'ID_LLAYXLGPD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Sequenciador',
       'Sequenciador',
       '',
       'ID_LLAYXLGPD',
       '' FROM DUAL
UNION ALL
SELECT 'LGPD',
       '--',
       60,
       4000,
       'MSGLOG',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Mensagem LOG',
       'Mensagem de LOG',
       '',
       'MSGLOG',
       '' FROM DUAL
);

/*-- SEQ 8526 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LGRA',
       TO_NUMBER(null),
       'LGRA',
       'Log da Grade',
       'TL_GRA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'LGRA.FILMAT,LGRA.CODMAT,LGRA.CODCOR,LGRA.CODTAM',
       '' FROM DUAL
);

/*-- SEQ 8527 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LGRA','--','' FROM DUAL
);

/*-- SEQ 8528 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 33924,
       'TUID',
       'LGRA',
       '01',
       '0N',
       '',
       '',
       'LGRA.CODUID = TUID.CODUID(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8529 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LGRA',
       '--',
       3,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Diviso do produto',
       'LGRA.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'LGRA',
       '--',
       2,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'LGRA',
       '--',
       4,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'LGRA.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'LGRA',
       '--',
       18,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Identificao do Log',
       'Cdigo de Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LGRA',
       '--',
       6,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Usurio',
       'Cdigo Usurio',
       'LGRA.FILUSU = USU2.FILUSU(+) AND USU2.CODUSU(+) = LGRA.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LGRA',
       '--',
       8,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data Operao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LGRA',
       '--',
       1,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'LGRA',
       '--',
       5,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LGRA',
       '--',
       7,
       4000,
       'MSGLOG',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Mensagem de LOG',
       'Mensagens de Log',
       '',
       'RTF2TXT(MSGLOG)',
       'F' FROM DUAL
);

/*-- SEQ 8530 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LIB ',
       TO_NUMBER(null),
       'LIB ',
       'Liberaes',
       'TT_LIB',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'LIB.CODFIL,LIB.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8531 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LIB ','--','' FROM DUAL
);

/*-- SEQ 8532 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5792,
       'REG ',
       'LIB ',
       'N ',
       '1 ',
       '',
       '',
       'REG.CODFIL = LIB.CODFIL AND
REG.SEQUEN = LIB.SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 5793,
       'USU ',
       'LIB ',
       'N ',
       '1 ',
       '',
       '',
       'USU.FILUSU = LIB.FILUSU AND
USU.CODUSU = LIB.CODUSU',
       '' FROM DUAL
);

/*-- SEQ 8533 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LIB ',
       '--',
       16,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = LIB.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'LIB ',
       '--',
       26,
       5,
       'CODLIB',
       'S',
       'DLIB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DLIB.DESLIB',
       'V',
       '',
       '',
       'A',
       'F',
       'Tipo Liberao',
       'Tipo Liberao',
       'DLIB.CODTAB = LIB.CODLIB',
       'CODLIB',
       'F' FROM DUAL
UNION ALL
SELECT 'LIB ',
       '--',
       6,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo Usurio',
       'LIB.FILUSU = USU.FILUSU(+) AND LIB.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LIB ',
       '--',
       36,
       7,
       'EXPMOD',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Exp. Mod.',
       'Data Exp. Mod.',
       '',
       'EXPMOD',
       'F' FROM DUAL
UNION ALL
SELECT 'LIB ',
       '--',
       46,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LIB ',
       '--',
       56,
       10,
       'HOMMOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mod. Homologao',
       'Mod. Homologao',
       '',
       'HOMMOD',
       'F' FROM DUAL
UNION ALL
SELECT 'LIB ',
       '--',
       66,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero de Itens',
       'Nmero de Itens',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'LIB ',
       '--',
       76,
       10,
       'NUMLIB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero Liberaes',
       'Nmero Liberaes',
       '',
       'NUMLIB',
       'F' FROM DUAL
UNION ALL
SELECT 'LIB ',
       '--',
       86,
       5,
       'QTDMOD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Qtde Modificaes',
       'Quantidade de Modificaes',
       '',
       'QTDMOD',
       'F' FROM DUAL
UNION ALL
SELECT 'LIB ',
       '--',
       96,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'LIB ',
       '--',
       106,
       3,
       'VERSAO',
       'F',
       '',
       1,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Verso',
       'Verso',
       '',
       'VERSAO',
       '' FROM DUAL
);

/*-- SEQ 8534 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LID ',
       TO_NUMBER(null),
       'LID ',
       'Log ID Transaes',
       'TT_LID',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'LID.CODFIL,LID.NUMECF,LID.TRN_ID',
       '' FROM DUAL
);

/*-- SEQ 8535 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LID ','--','' FROM DUAL
UNION ALL
SELECT 'LID ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LID ','99','Outros' FROM DUAL
);

/*-- SEQ 8536 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22892,
       'ORC ',
       'LID ',
       '01',
       '01',
       '',
       '',
       'LID.FILPED = ORC.CODFIL AND
LID.TIPPED = ORC.TIPPED AND
LID.NUMPED = ORC.NUMPED',
       '',
       '' FROM DUAL
);

/*-- SEQ 8537 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LID ',
       '--',
       310,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Assinatura para PAF-ECF',
       '',
       'ASSINA',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       330,
       8,
       'BUILD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Build do Subversion',
       'Build do Subversion',
       '',
       'BUILD',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       350,
       10,
       'C4G_ID',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'ID trans. Checkout4G',
       'ID da transao no CheckOut4G',
       '',
       'C4G_ID',
       '' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       360,
       10,
       'CAI_ID',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo caixa (CK4G)',
       'Cdigo interno do caixa no Checkout 4G',
       '',
       'CAI_ID',
       '' FROM DUAL
UNION ALL
SELECT 'LID ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Codigo da Filial',
       'DFIL.CODFIL(+) = LID.CODFIL',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       20,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Codigo da Serie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       320,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Identificao de Acesso',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       210,
       6,
       'CONCCF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cont. Oper. Fiscais',
       'Contador Geral de Operaes Fiscais',
       '',
       'CONCCF',
       '' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       90,
       6,
       'CONCDC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cont Comprov Db/Cr',
       'Contador Geral de Comprovante de Dbito e Crdito',
       '',
       'CONCDC',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       270,
       6,
       'CONCOO',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Contador Operaes',
       'Contador Geral de Operaes',
       '',
       'CONCOO',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       100,
       6,
       'CONGNF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cont Oper no fiscal',
       'Contador Geral de Operaes No Fiscais',
       '',
       'CONGNF',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       110,
       6,
       'CONGRG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cont Relat Gerencial',
       'Contador Geral Relatrio Gerencial',
       '',
       'CONGRG',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       30,
       6,
       'CUPFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Numero Cupom',
       'Numero Cupom Fiscal',
       '',
       'CUPFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       220,
       7,
       'DATEXE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Execuo no BD',
       'Data de Execuo no Banco de Dados',
       '',
       'DATEXE',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       370,
       8,
       'DATFIS',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Fiscal',
       'Data Fiscal',
       '',
       'DATFIS',
       '' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       40,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Transacao',
       'Data Transacao',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       230,
       3,
       'ECFORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       '',
       '',
       '',
       'ECFORI',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       240,
       3,
       'FILORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'FILORI',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       280,
       3,
       'FILPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Fil DAV/Pr-Ven Imp',
       'Filial do DAV/Pr-Venda Impresso',
       '',
       'FILPED',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       250,
       12,
       'ID_ORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       '',
       '',
       'ID_ORI',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       340,
       5,
       'INSTAL',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nm. instalao ECF',
       'Nmero da instalao atual do ECF',
       '',
       'INSTAL',
       '' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       260,
       1,
       'LIDPOS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'LIDPOS',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '01',
       50,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'ECF',
       'Numero ECF',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       290,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'N DAV/Pr-Venda Imp',
       'Nmero do DAV/Pr-Venda Impresso.',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       170,
       5,
       'RELEAS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'release Checkout',
       'release Checkout',
       '',
       'RELEAS',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       180,
       2,
       'TIPDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Denom docum fiscal',
       'Denominao do documento fiscal',
       '',
       'TIPDOC',
       'T' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       60,
       10,
       'TIPOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Operao',
       'Tipo Operao',
       '',
       'TIPOPE',
       'T' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       300,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo DAV/Pr-Ven Imp',
       'Tipo do DAV/Pr-Venda Impresso.',
       '',
       'TIPPED',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '01',
       70,
       12,
       'TRN_ID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'ID Transao',
       'ID Transao',
       '',
       'TRN_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       190,
       5,
       'VERBAS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Verso Banco',
       'Verso Banco',
       '',
       'VERBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       200,
       5,
       'VERSAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Verso Checkout',
       'Verso Checkout',
       '',
       'VERSAO',
       'F' FROM DUAL
UNION ALL
SELECT 'LID ',
       '--',
       80,
       16,
       'VLROPE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Operao',
       'Valor Operao',
       '',
       'VLROPE',
       'F' FROM DUAL
);

/*-- SEQ 8538 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'LID ',
       'TIPDOC',
       0,
       ' ',
       'Conferncia de Mesa',
       TO_NUMBER(null),
       'CM' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPDOC',
       0,
       ' ',
       'Registro de Venda',
       TO_NUMBER(null),
       'RV' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPDOC',
       0,
       ' ',
       'Comprovante de Crd ou Dbito',
       TO_NUMBER(null),
       'CC' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPDOC',
       0,
       ' ',
       'Comprovante No-Fiscal',
       TO_NUMBER(null),
       'CN' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPDOC',
       0,
       ' ',
       'Comprov NoFiscal Cancelamento',
       TO_NUMBER(null),
       'NC' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPDOC',
       0,
       ' ',
       'Relatrio Gerencial',
       TO_NUMBER(null),
       'RG' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPDOC',
       0,
       ' ',
       'Leitura X',
       TO_NUMBER(null),
       'LX' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPDOC',
       0,
       ' ',
       'Leitura Memria Fiscal',
       TO_NUMBER(null),
       'MF' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPDOC',
       0,
       ' ',
       'Reduo Z',
       TO_NUMBER(null),
       'RZ' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Solicitao de Crdito',
       TO_NUMBER(null),
       'SOLIC_CRED' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Servios adicionais',
       TO_NUMBER(null),
       'SAD' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Cpia de itens de venda',
       TO_NUMBER(null),
       'VEN_COPIA' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Extrato de conta corrente',
       TO_NUMBER(null),
       'EXTRATOCC' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Recebimento de pendncias',
       TO_NUMBER(null),
       'RECPEND' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Menu Fiscal (PAF-ECF)',
       TO_NUMBER(null),
       'MENUFISCAL' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Mescla de DAVs',
       TO_NUMBER(null),
       'DAVMESCLA' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Impresso de DAV',
       TO_NUMBER(null),
       'DAVIMP' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Troca de senha',
       TO_NUMBER(null),
       'SENHA' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Pendncias de TEF',
       TO_NUMBER(null),
       'TEFPEND' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Opes administrativas de TEF',
       TO_NUMBER(null),
       'TEFADM' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Lanamento de estoque',
       TO_NUMBER(null),
       'ESTOQUE' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Carga tabelas PinPad (forada)',
       TO_NUMBER(null),
       'PINPADCARF' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Alertas do sistema (Shift F4)',
       TO_NUMBER(null),
       'ALERTAS' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Status comunicao Sefaz',
       TO_NUMBER(null),
       'STAT_SEFAZ' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Status comunicao Servidor',
       TO_NUMBER(null),
       'STAT_SRV' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Status comunicao TEF',
       TO_NUMBER(null),
       'STAT_TEF' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Controle de transmisso',
       TO_NUMBER(null),
       'CTRLTRANS' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Configuraes de ambiente',
       TO_NUMBER(null),
       'CFGAMB' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Relatrio de configurao',
       TO_NUMBER(null),
       'CFGREL' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Envio de e-mail da NFC-e',
       TO_NUMBER(null),
       'EMAILNFCE' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Carga tabelas PinPad',
       TO_NUMBER(null),
       'PINPADCARG' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Recarga de celular',
       TO_NUMBER(null),
       'RECARGACEL' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Ativao de Vale Presente',
       TO_NUMBER(null),
       'VALEPRE' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Recarga de Vale Presente',
       TO_NUMBER(null),
       'VALEPRE_R' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Consulta de Vale Presente',
       TO_NUMBER(null),
       'VALEPRE_C' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Vale Gs',
       TO_NUMBER(null),
       'VALEGAS' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Ressarcimento de Vale Compra',
       TO_NUMBER(null),
       'VC_RESSARC' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Manuteno e suporte',
       TO_NUMBER(null),
       'MAN_SUP' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Carga',
       TO_NUMBER(null),
       'CARGA' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Vazia',
       TO_NUMBER(null),
       'VAZIA' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Pr-venda',
       TO_NUMBER(null),
       'PREVENDA' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Abertura de dia',
       TO_NUMBER(null),
       'ABREECF' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Bloqueio de caixa (Shift F10)',
       TO_NUMBER(null),
       'CXBLOQ' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Propaganda no caixa',
       TO_NUMBER(null),
       'PROPAGANDA' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Abertura de gaveta',
       TO_NUMBER(null),
       'GAVETAABRE' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Reimpresso de caixa',
       TO_NUMBER(null),
       'CXREIMP' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Cancelamento',
       TO_NUMBER(null),
       'CAN' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Cadastro de Cliente',
       TO_NUMBER(null),
       'CLIENTE' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Compra',
       TO_NUMBER(null),
       'COM' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Abertura de Caixa',
       TO_NUMBER(null),
       'CXABRE' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Cad.Frmula Crdito Fornecedor',
       TO_NUMBER(null),
       'ECFFORMULA_FR' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Erro',
       TO_NUMBER(null),
       'ERR' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Estorno',
       TO_NUMBER(null),
       'ESTORNO' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'No Definido',
       TO_NUMBER(null),
       'EXTRAS' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Fechamento Caixa',
       TO_NUMBER(null),
       'FECHACX' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Fechamento ECF',
       TO_NUMBER(null),
       'FECHAECF' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Grava Cobrana',
       TO_NUMBER(null),
       'GRAVACOBRA' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Grava Configurao',
       TO_NUMBER(null),
       'GRAVACONFI' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Grava Enquete',
       TO_NUMBER(null),
       'GRAVAENQ' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Grava Retirada de Cheque',
       TO_NUMBER(null),
       'GRAVARETCH' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Grava Srie',
       TO_NUMBER(null),
       'GRAVASERIE' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Grava Saldo Conta Corrente',
       TO_NUMBER(null),
       'GRAVASLDCC' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Transferncia Automtica',
       TO_NUMBER(null),
       'IMPTRANSF' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Lanamento de Reforo/Sangria',
       TO_NUMBER(null),
       'LAN_REFSAN' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Recebimento de Dbito',
       TO_NUMBER(null),
       'RECDEBITO' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Recebimento',
       TO_NUMBER(null),
       'RECEBE' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Venda',
       TO_NUMBER(null),
       'VEN' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Carga inicial',
       TO_NUMBER(null),
       'CARGA_INI' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Cliente via pr-venda',
       TO_NUMBER(null),
       'PREVEN_CLI' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Cancela pr-venda',
       TO_NUMBER(null),
       'PREVEN_CAN' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Frmula do Totali PoS',
       TO_NUMBER(null),
       'FORMULA' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Exportao cadastral',
       TO_NUMBER(null),
       'EXP_CADAST' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Extrao de consignao',
       TO_NUMBER(null),
       'EXTRATOCON' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Extrato de bnus',
       TO_NUMBER(null),
       'EXTRATOBON' FROM DUAL
UNION ALL
SELECT 'LID ',
       'TIPOPE',
       0,
       ' ',
       'Resgate de bnus',
       TO_NUMBER(null),
       'RESGATEBON' FROM DUAL
);

/*-- SEQ 8539 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LIM ',
       TO_NUMBER(null),
       'LIM ',
       'Limite C/C',
       'TT_LIM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'LIM.FILCLI,LIM.CODCLI,LIM.TIPCCC',
       '' FROM DUAL
);

/*-- SEQ 8540 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LIM ','--','' FROM DUAL
UNION ALL
SELECT 'LIM ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LIM ','02','Datas' FROM DUAL
UNION ALL
SELECT 'LIM ','03','Valores' FROM DUAL
UNION ALL
SELECT 'LIM ','04','Saldo CC Ate' FROM DUAL
UNION ALL
SELECT 'LIM ','99','Outros' FROM DUAL
);

/*-- SEQ 8541 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 54240,
       'FXC ',
       'LIM ',
       '1',
       'N',
       '',
       '',
       'FXC.FILCLI = LIM.FILCLI AND
FXC.CODCLI = LIM.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 54241,
       'EDE ',
       'LIM ',
       '1',
       '0N',
       '',
       '',
       'EDE.FILCLI = LIM.FILCLI AND
EDE.CODCLI = LIM.CODCLI AND
EDE.CODFIL = LIM.FILCOB AND
EDE.NUMEND = LIM.ENDCOB
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 54242,
       'CLI ',
       'LIM ',
       '1',
       '1',
       '',
       '',
       'lim.filcli = cli.filcli and
lim.codcli = cli.codcli',
       '',
       '' FROM DUAL
UNION ALL
SELECT 54243,
       'PLA ',
       'LIM ',
       '1',
       'N',
       '',
       '',
       'PLA.CODPGT = LIM.CODPGT AND
PLA.FILPGT = LIM.FILPGT',
       '',
       '' FROM DUAL
);

/*-- SEQ 8542 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'LIM ',
       '04',
       152,
       8,
       ':LIM.DATSALCCC',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Saldo CC At',
       'Data do Saldo Conta Corrente Ate',
       '',
       ':LIM.DATSALCCC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LIM ',
       '03',
       10,
       3,
       'CARENC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Carcia',
       'Carncia',
       '',
       'CARENC',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'LIM ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'LIM ',
       '01',
       30,
       5,
       'CODCOB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Cobrana',
       'Cdigo Cobrana',
       '',
       'CODCOB',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'LIM ',
       '01',
       40,
       3,
       'CODPGT',
       'A',
       'PLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       '',
       '',
       'A',
       'F',
       'Plano Pagamento',
       'Cdigo Plano Pagamento',
       'PLA.FILPGT = LIM.FILPGT AND PLA.CODPGT = LIM.CODPGT',
       'CODPGT',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'LIM ',
       '03',
       50,
       6,
       'DESCON',
       'F',
       '',
       3,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Desconto',
       'Desconto',
       '',
       'DESCON',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'LIM ',
       '03',
       150,
       2,
       'DIAFIX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dia Fixo Vencimento',
       'Dia Fixo do Vencimento',
       '',
       'DIAFIX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'LIM ',
       '99',
       160,
       1,
       'DUMMY',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Dummy',
       '',
       'DUMMY',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'LIM ',
       '01',
       60,
       5,
       'ENDCOB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Endereo de Cobrana',
       'Endereo de Cobrana',
       '',
       'ENDCOB',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'LIM ',
       '--',
       180,
       1,
       'FATEND',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Fatura por endereo',
       'Faturamento por endereo',
       '',
       'FATEND',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'LIM ',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'LIM ',
       '01',
       80,
       3,
       'FILCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial de Cobrana',
       '',
       'FILCOB',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'LIM ',
       '01',
       90,
       3,
       'FILPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Plano Pagamento',
       '',
       'FILPGT',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'LIM ',
       '03',
       100,
       12,
       'LIMCCC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Limite C/C',
       'Limite Conta Corrente',
       '',
       'LIMCCC',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'LIM ',
       '99',
       110,
       256,
       'OBSERV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'LIM ',
       '04',
       151,
       12,
       'SALCCC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Saldo CC At',
       'Saldo at a data',
       '',
       'SaldoContaCorrente(:LIM.DATSALCCC, LIM.FILCLI, LIM.CODCLI, LIM.TIPCCC)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LIM ',
       '01',
       120,
       5,
       'TIPCCC',
       'S',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       'A',
       'F',
       'Tipo C/C',
       'Tipo Conta Corrente',
       'DCCC.CODTAB = LIM.TIPCCC',
       'TIPCCC',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'LIM ',
       '01',
       130,
       1,
       'TIPCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Cobrana',
       'Tipo Cobrana',
       '',
       'TIPCOB',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'LIM ',
       '03',
       140,
       12,
       'VSALDO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Saldo',
       'Saldo',
       '',
       'VSALDO',
       'F',
       'P' FROM DUAL
);

/*-- SEQ 8543 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'LIM ',
       'TIPCOB',
       0,
       'A',
       'A Depositar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LIM ',
       'TIPCOB',
       0,
       'B',
       'Cobrado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LIM ',
       'TIPCOB',
       0,
       'C',
       'Compensado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LIM ',
       'TIPCOB',
       0,
       'D',
       'Depositado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LIM ',
       'TIPCOB',
       0,
       'P',
       'Pr-Descontado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LIM ',
       'TIPCOB',
       0,
       'U',
       'Custodiado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LIM ',
       'TIPCOB',
       0,
       'V',
       'Devolvido',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8544 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LINV',
       TO_NUMBER(null),
       'LINV',
       'Log para  Inventrio',
       'TL_INV',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'LINV.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 8545 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LINV','--','' FROM DUAL
UNION ALL
SELECT 'LINV','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LINV','99','Outros' FROM DUAL
);

/*-- SEQ 8546 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 24882,
       'USU ',
       'LINV',
       '01',
       '0N',
       '',
       '',
       'USU.FILUSU(+) = LINV.FILUSU AND
USU.CODUSU(+) = LINV.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 8547 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LINV',
       '--',
       10,
       10,
       'CODTAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Chave',
       'Chave',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'LINV',
       '--',
       80,
       12,
       'CODUID',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo Acesso',
       'Cdigo Acesso',
       '',
       'CODUID',
       'T' FROM DUAL
UNION ALL
SELECT 'LINV',
       '--',
       70,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       '0',
       '',
       'Cdigo Usurio',
       'Cdigo Usurio',
       'LINV.FILUSU = USU.FILUSU(+)  AND LINV.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       '' FROM DUAL
UNION ALL
SELECT 'LINV',
       '--',
       50,
       8,
       'DATOPE',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATOPE',
       '' FROM DUAL
UNION ALL
SELECT 'LINV',
       '--',
       20,
       3,
       'FILINV',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial do Inventrio',
       'Filial do Inventrio',
       'LINV.FILINV = DFIL.CODFIL (+)',
       'FILINV',
       '' FROM DUAL
UNION ALL
SELECT 'LINV',
       '--',
       60,
       3,
       'FILUSU',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial Usurio',
       'Filial Usurio',
       'LINV.FILUSU = DFIL.CODFIL (+)',
       'FILUSU',
       '' FROM DUAL
UNION ALL
SELECT 'LINV',
       '--',
       40,
       4000,
       'MSGLOG',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Modificaes',
       'Modificaes',
       '',
       'RTF2TXT(MSGLOG)',
       '' FROM DUAL
UNION ALL
SELECT 'LINV',
       '--',
       30,
       10,
       'SEQINV',
       'A',
       'INV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'INV.TITINV',
       'I',
       '',
       '',
       '9',
       '',
       'Sequencial Invent.',
       'Sequencial do Inventrio',
       'LINV.FILINV = INV.CODFIL(+)  AND LINV.SEQINV = INV.SEQUEN(+)',
       'SEQINV',
       '' FROM DUAL
);

/*-- SEQ 8548 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LIOP',
       TO_NUMBER(null),
       'LIOP',
       'Log Alterao DAV',
       'TL_IOR_PAF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8549 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LIOP','--','' FROM DUAL
UNION ALL
SELECT 'LIOP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LIOP','02','Valores' FROM DUAL
UNION ALL
SELECT 'LIOP','03','Quantidade' FROM DUAL
UNION ALL
SELECT 'LIOP','04','Percentual' FROM DUAL
UNION ALL
SELECT 'LIOP','99','Outros' FROM DUAL
);

/*-- SEQ 8550 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22898,
       'GRA ',
       'LIOP',
       '1',
       'N',
       '',
       '',
       'GRA.FILMAT = LIOP.FILMAT and
GRA.CODMAT = LIOP.CODMAT and
GRA.CODCOR = LIOP.CODCOR and
GRA.CODTAM = LIOP.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22899,
       'ORC ',
       'LIOP',
       '1',
       'N',
       '',
       '',
       'ORC.CODFIL = LIOP.CODFIL AND
ORC.TIPPED = LIOP.TIPPED AND
ORC.NUMPED = LIOP.NUMPED',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22900,
       'USU ',
       'LIOP',
       '1',
       'N',
       '',
       '',
       'USU.FILUSU = LIOP.FILUSU AND
USU.CODUSU = LIOP.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 8551 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LIOP',
       '99',
       200,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Assinatura PAF-ECF',
       'Assinatura para PAF-ECF',
       '',
       'ASSINA',
       'F' FROM DUAL
UNION ALL
SELECT 'LIOP',
       '99',
       10,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       '',
       'N',
       'F',
       'Diviso do produto',
       'Diviso do produto',
       'DIV.CODITE = LIOP.CODCOR',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'LIOP',
       '99',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = LIOP.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'LIOP',
       '99',
       30,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '.',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do produto',
       'Cdigo do produto',
       '. = LIOP.CODMAT',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'LIOP',
       '01',
       40,
       10,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Chave',
       'Chave',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'LIOP',
       '99',
       50,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       '',
       'N',
       'F',
       'Sub-diviso produto',
       'Sub-diviso do produto',
       'SUB.CODITE = LIOP.CODTAM',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'LIOP',
       '99',
       60,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Acesso',
       'Cdigo Acesso',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LIOP',
       '99',
       70,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Cdigo Usurio',
       'Cdigo Usurio',
       'LIOP.FILUSU = USU.FILUSU  AND LIOP.CODUSU = USU.CODUSU',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LIOP',
       '99',
       80,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LIOP',
       '04',
       90,
       12,
       'DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Desconto/Acrscimo',
       'Desconto/Acrscimo',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'LIOP',
       '99',
       100,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial do produto ',
       'Filial do produto ',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'LIOP',
       '99',
       110,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial Usurio',
       'Filial Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LIOP',
       '99',
       120,
       1,
       'INDCAN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Cancelado?',
       'Indicador de cancelamento',
       '',
       'INDCAN',
       'F' FROM DUAL
UNION ALL
SELECT 'LIOP',
       '99',
       210,
       9,
       'NUMCRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       'F',
       'Contador RE',
       'Contador de Requisio Externa',
       '',
       'NUMCRE',
       'F' FROM DUAL
UNION ALL
SELECT 'LIOP',
       '99',
       130,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero do item',
       'Nmero do item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'LIOP',
       '99',
       140,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Nmero do pedido',
       'Nmero do pedido',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'LIOP',
       '99',
       220,
       1,
       'ORICRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem RE',
       'Origem da Requisio Externa',
       '',
       'ORICRE',
       'T' FROM DUAL
UNION ALL
SELECT 'LIOP',
       '03',
       150,
       12,
       'QTDITE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade',
       'Quantidade',
       '',
       'QTDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'LIOP',
       '99',
       160,
       1,
       'TIPLOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de log ',
       'Tipo de log ',
       '',
       'TIPLOG',
       'T' FROM DUAL
UNION ALL
SELECT 'LIOP',
       '99',
       170,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo do pedido',
       'Tipo do pedido',
       '',
       'TIPPED',
       'F' FROM DUAL
UNION ALL
SELECT 'LIOP',
       '02',
       180,
       14,
       'VLRITE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor unitrio',
       'Valor unitrio',
       '',
       'VLRITE',
       'F' FROM DUAL
UNION ALL
SELECT 'LIOP',
       '02',
       190,
       12,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor total',
       'Valor total',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 8552 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'LIOP',
       'ORICRE',
       0,
       'I',
       'Internet',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LIOP',
       'ORICRE',
       0,
       'M',
       'Mobile',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LIOP',
       'ORICRE',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LIOP',
       'TIPLOG',
       0,
       'A',
       'Alterao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LIOP',
       'TIPLOG',
       0,
       'E',
       'Excluso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LIOP',
       'TIPLOG',
       0,
       'I',
       'Incluso',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8553 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LIRO',
       TO_NUMBER(null),
       'LIRO',
       'Log Itens Romaneio',
       'TL_IRO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8554 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LIRO','--','' FROM DUAL
UNION ALL
SELECT 'LIRO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LIRO','99','Outros' FROM DUAL
);

/*-- SEQ 8555 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 33925,
       'TUID',
       'LIRO',
       '01',
       '0N',
       '',
       '',
       'LIRO.CODUID = TUID.CODUID(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8556 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LIRO',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'LIRO',
       '01',
       100,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Identificao do Log',
       'Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LIRO',
       '01',
       20,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Usurio',
       'Usurio',
       'LIRO.FILUSU = USU.FILUSU(+) and LIRO.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LIRO',
       '01',
       30,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Alterao',
       'Data da alterao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LIRO',
       '01',
       40,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LIRO',
       '01',
       50,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Venda',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'LIRO',
       '01',
       60,
       4000,
       'MSGLOG',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Alteraes',
       'Mostra quais as alteraes foram realizadas',
       '',
       'RTF2TXT(MSGLOG)',
       'F' FROM DUAL
UNION ALL
SELECT 'LIRO',
       '01',
       70,
       10,
       'SEQCAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Cancelamento',
       '',
       'SEQCAN',
       'F' FROM DUAL
UNION ALL
SELECT 'LIRO',
       '01',
       80,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'LIRO',
       '01',
       90,
       10,
       'SEQVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Venda',
       '',
       'SEQVEN',
       'F' FROM DUAL
);

/*-- SEQ 8557 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LIS ',
       TO_NUMBER(null),
       'LIS ',
       'Lista Pres.Cliente',
       'TT_LIS',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'LIS.CODFIL, LIS.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8558 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LIS ','--','' FROM DUAL
UNION ALL
SELECT 'LIS ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LIS ','02','Datas' FROM DUAL
UNION ALL
SELECT 'LIS ','99','Outros' FROM DUAL
);

/*-- SEQ 8559 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 29076,
       'CLI ',
       'LIS ',
       '1',
       '0N',
       '',
       '',
       'CLI.FILCLI = LIS.FILCLI AND
CLI.CODCLI = LIS.CODCLI
',
       '',
       '' FROM DUAL
);

/*-- SEQ 8560 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LIS ',
       '02',
       10,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'LIS ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'LIS ',
       '01',
       30,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'LIS ',
       '01',
       40,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL(+) = LIS.CODFIL',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'LIS ',
       '02',
       50,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'LIS ',
       '02',
       60,
       8,
       'DATVAL',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Validade',
       'Data Validade',
       '',
       'DATVAL',
       'F' FROM DUAL
UNION ALL
SELECT 'LIS ',
       '99',
       70,
       40,
       'DESLIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Descrio da Lista',
       'Descrio da Lista',
       '',
       'DESLIS',
       'F' FROM DUAL
UNION ALL
SELECT 'LIS ',
       '01',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Filial Cliente',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'LIS ',
       '99',
       90,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'LIS ',
       '01',
       100,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8561 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'LIS ',
       'FLGEST',
       0,
       'A',
       'Aberta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LIS ',
       'FLGEST',
       0,
       'C',
       'Cancelada',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8562 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LIVO',
       TO_NUMBER(null),
       'LIVO',
       'Log Itens de Volume',
       'TL_IVO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8563 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LIVO','--','' FROM DUAL
UNION ALL
SELECT 'LIVO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LIVO','99','Outros' FROM DUAL
);

/*-- SEQ 8564 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 51818,
       'IVO ',
       'LIVO',
       '1',
       'N',
       '',
       '',
       'LIVO.FILIVO = IVO.FILVOL AND
LIVO.SEQIVO = IVO.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 51819,
       'TUID',
       'LIVO',
       '1',
       '0N',
       '',
       '',
       'LCLI.CODUID = TUID.CODUID(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8565 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LIVO',
       '01',
       10,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Identificao do Log',
       'Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LIVO',
       '01',
       20,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Cdigo Usurio',
       'Cdigo Usurio',
       'LIVO.FILUSU = USU.FILUSU(+)  AND LIVO.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LIVO',
       '01',
       30,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data de Operao',
       'Data de Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LIVO',
       '01',
       40,
       3,
       'FILIVO',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial Item Volume',
       'Filial Item Volume',
       'DFIL.CODFIL = LIVO.FILIVO(+)',
       'FILIVO',
       'T' FROM DUAL
UNION ALL
SELECT 'LIVO',
       '01',
       50,
       3,
       'FILUSU',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial do Usurio',
       'Filial do Usurio',
       'DFIL.CODFIL = LIVO.FILUSU(+)',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LIVO',
       '01',
       60,
       4000,
       'MSGLOG',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'D',
       'F',
       'Mensagem de Log',
       'Mensagem de Log',
       '',
       'MSGLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'LIVO',
       '01',
       70,
       10,
       'SEQIVO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Seq. Item Volume',
       'Seq. Item Volume',
       '',
       'SEQIVO',
       'F' FROM DUAL
);

/*-- SEQ 8566 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LLAC',
       TO_NUMBER(null),
       'LLAC',
       'Log de Lacres',
       'TL_LAC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8567 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LLAC','--','' FROM DUAL
UNION ALL
SELECT 'LLAC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LLAC','99','Outros' FROM DUAL
);

/*-- SEQ 8568 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LLAC',
       '--',
       10,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Identificao do Log',
       'Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LLAC',
       '--',
       20,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Usurio',
       'Cdigo do Usurio',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LLAC',
       '--',
       30,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LLAC',
       '--',
       40,
       3,
       'FILLAC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'FILLAC',
       'F' FROM DUAL
UNION ALL
SELECT 'LLAC',
       '--',
       50,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do Usurio',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LLAC',
       '--',
       60,
       4000,
       'MSGLOG',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Alteraes ',
       'Alteraes ',
       '',
       'MSGLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'LLAC',
       '--',
       70,
       10,
       'SEQLAC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQLAC',
       'F' FROM DUAL
);

/*-- SEQ 8569 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LLCF',
       TO_NUMBER(null),
       'LLCF',
       'Log CF/Alteraes',
       'TL_LCF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'LLCF.CODFIL,LLCF.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8570 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LLCF','--','' FROM DUAL
UNION ALL
SELECT 'LLCF','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LLCF','99','Outros' FROM DUAL
);

/*-- SEQ 8571 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 33325,
       'LCF ',
       'LLCF',
       '01',
       '1',
       '',
       '',
       'LCF.CODFIL(+) = LLCF.CODFIL AND
LCF.SEQUEN(+) = LLCF.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 33926,
       'TUID',
       'LLCF',
       '01',
       '0N',
       '',
       '',
       'LLCF.CODUID = TUID.CODUID(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8572 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LLCF',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Codigo Filial',
       'DFIL.CODFIL = LLCF.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'LLCF',
       '--',
       70,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Identificao do Log',
       'Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LLCF',
       '--',
       20,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Usurio',
       'Codigo Usuario',
       'USU2.FILUSU(+) = LLCF.FILUSU AND USU2.CODUSU(+) = LLCF.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LLCF',
       '--',
       30,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data operacao',
       'Data Operacao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LLCF',
       '--',
       40,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LLCF',
       '--',
       50,
       0,
       'MSGLOG',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Log',
       'Log Mensagens',
       '',
       'RTF2TXT(MSGLOG)',
       'F' FROM DUAL
UNION ALL
SELECT 'LLCF',
       '--',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8573 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LLOT',
       TO_NUMBER(null),
       'LLOT',
       'Log para Lotes',
       'TL_LOT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8574 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LLOT','--','' FROM DUAL
UNION ALL
SELECT 'LLOT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LLOT','99','Outros' FROM DUAL
);

/*-- SEQ 8575 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 24085,
       'LOT ',
       'LLOT',
       '0N',
       '1',
       '',
       '',
       'LOT.CODFIL(+) = LLOT.FILLOT AND
LOT.SEQUEN(+) = LLOT.SEQLOT
',
       '',
       '' FROM DUAL
);

/*-- SEQ 8576 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LLOT',
       '--',
       10,
       10,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Chave',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'LLOT',
       '--',
       20,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       '',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LLOT',
       '--',
       30,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Usurio',
       'Cdigo Usurio',
       'LLOT.FILUSU = USU.FILUSU(+)  AND LLOT.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LLOT',
       '--',
       40,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LLOT',
       '--',
       50,
       3,
       'FILLOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'FILLOT',
       'F' FROM DUAL
UNION ALL
SELECT 'LLOT',
       '--',
       60,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       '',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LLOT',
       '--',
       80,
       4000,
       'MSGLOG',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem de Log',
       'Mensagem de Log',
       '',
       'MSGLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'LLOT',
       '--',
       70,
       10,
       'SEQLOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       '',
       '',
       'SEQLOT',
       'F' FROM DUAL
);

/*-- SEQ 8577 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LMC ',
       TO_NUMBER(null),
       'LMC ',
       'Controle Emisso LMC',
       'TT_LMC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8578 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LMC ','--','' FROM DUAL
UNION ALL
SELECT 'LMC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LMC ','99','Outros' FROM DUAL
);

/*-- SEQ 8579 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5807,
       'GRA ',
       'LMC ',
       '0N',
       '1 ',
       '',
       '',
       'GRA.FILMAT = LMC.FILMAT(+) AND
GRA.CODMAT = LMC.CODMAT(+) AND
GRA.CODCOR = LMC.CODCOR(+) AND
GRA.CODTAM = LMC.CODTAM(+)',
       '' FROM DUAL
);

/*-- SEQ 8580 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LMC ',
       '01',
       120,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Atualizado em',
       'Atualizado em',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'LMC ',
       '01',
       10,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Diviso do produto',
       'DIV.CODITE = LMC.CODCOR(+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'LMC ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = LMC.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'LMC ',
       '01',
       30,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo~Material',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'LMC ',
       '01',
       40,
       3,
       'CODREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd. Usu. Registro',
       'Cdigo Usurio Registro',
       '',
       'CODREG',
       'F' FROM DUAL
UNION ALL
SELECT 'LMC ',
       '01',
       50,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'SUB.CODITE = LMC.CODTAM(+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'LMC ',
       '01',
       130,
       7,
       'DATINI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incio',
       'Data Incio',
       '',
       'DATINI',
       'F' FROM DUAL
UNION ALL
SELECT 'LMC ',
       '01',
       80,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial Material',
       'Filial do material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'LMC ',
       '01',
       90,
       3,
       'FILREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Usu. Registro',
       'Filial Usurio Registro',
       '',
       'FILREG',
       'F' FROM DUAL
UNION ALL
SELECT 'LMC ',
       '01',
       100,
       9,
       'NUMFOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero do~Formurio',
       'Nmero do Formurio',
       '',
       'NUMFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'LMC ',
       '01',
       140,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8581 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LMDT',
       TO_NUMBER(null),
       'LMDT',
       'LMC c/final Tanque',
       'TV_LMC_MDT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8582 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LMDT','--','' FROM DUAL
UNION ALL
SELECT 'LMDT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LMDT','99','Outros' FROM DUAL
);

/*-- SEQ 8583 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LMDT',
       '01',
       10,
       10,
       'APELEI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Apelido Usu.Leitura',
       'Apelido Usurio que fez a Leitura',
       '',
       'APELEI',
       'F' FROM DUAL
UNION ALL
SELECT 'LMDT',
       '01',
       20,
       10,
       'APEREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Apelido Usu.Registro',
       'Apelido Usurio que fez o Registro',
       '',
       'APEREG',
       'F' FROM DUAL
UNION ALL
SELECT 'LMDT',
       '01',
       30,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Diviso do produto',
       'DIV.CODITE = LMDT.CODCOR(+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'LMDT',
       '01',
       40,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = LMDT.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'LMDT',
       '01',
       50,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo~Material',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'LMDT',
       '01',
       60,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'SUB.CODITE = LMDT.CODTAM(+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'LMDT',
       '01',
       70,
       7,
       'DATLEI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Leitura',
       'Data Leitura',
       '',
       'DATLEI',
       'F' FROM DUAL
UNION ALL
SELECT 'LMDT',
       '01',
       80,
       7,
       'DATMED',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Medio',
       'Data Medio',
       '',
       'DATMED',
       'F' FROM DUAL
UNION ALL
SELECT 'LMDT',
       '01',
       90,
       7,
       'DATREG',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Registro',
       'Data Registro',
       '',
       'DATREG',
       'F' FROM DUAL
UNION ALL
SELECT 'LMDT',
       '01',
       100,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial Material',
       'Filial do material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'LMDT',
       '01',
       110,
       3,
       'FILTAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Usu. Registro',
       'Filial Usurio Registro',
       '',
       'FILTAN',
       'F' FROM DUAL
UNION ALL
SELECT 'LMDT',
       '01',
       120,
       30,
       'NOMLEI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Usurio Leitura',
       'Usurio Leitura',
       '',
       'NOMLEI',
       'F' FROM DUAL
UNION ALL
SELECT 'LMDT',
       '01',
       130,
       30,
       'NOMREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Usurio Registro',
       'Usurio Registro',
       '',
       'NOMREG',
       'F' FROM DUAL
UNION ALL
SELECT 'LMDT',
       '01',
       140,
       10,
       'QTDLTS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Quantidade~Litros',
       'Quantidade Litros',
       '',
       'QTDLTS',
       'F' FROM DUAL
UNION ALL
SELECT 'LMDT',
       '01',
       150,
       2,
       'TANQUE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero do tanque',
       'Nmero do tanque',
       '',
       'TANQUE',
       'F' FROM DUAL
);

/*-- SEQ 8584 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LMON',
       TO_NUMBER(null),
       'LMON',
       'Log Montagem',
       'TL_MON',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8585 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LMON','--','' FROM DUAL
UNION ALL
SELECT 'LMON','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LMON','99','Outros' FROM DUAL
);

/*-- SEQ 8586 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 33927,
       'TUID',
       'LMON',
       '01',
       '0N',
       '',
       '',
       'LMON.CODUID = TUID.CODUID(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8587 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LMON',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'LMON',
       '01',
       70,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Identificao do Log',
       'Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LMON',
       '01',
       20,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Usurio',
       'Usurio',
       'LMON.FILUSU = USU.FILUSU(+) and LMON.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LMON',
       '01',
       30,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Alterao',
       'Data da alterao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LMON',
       '01',
       40,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LMON',
       '01',
       50,
       4000,
       'MSGLOG',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Alteraes',
       'Mostra quais as alteraes foram realizadas',
       '',
       'RTF2TXT(MSGLOG)',
       'F' FROM DUAL
UNION ALL
SELECT 'LMON',
       '01',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8588 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LMPR',
       TO_NUMBER(null),
       'LMPR',
       'Log de Mapa Resumo',
       'TL_MPR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8589 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LMPR','--','' FROM DUAL
UNION ALL
SELECT 'LMPR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LMPR','99','Outros' FROM DUAL
);

/*-- SEQ 8590 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20300,
       'MPR ',
       'LMPR',
       '1',
       'N',
       '',
       '',
       'LMPR.FILMPR = MPR.CODFIL AND
LMPR.DATMPR = MPR.DATOPE',
       '',
       '' FROM DUAL
);

/*-- SEQ 8591 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LMPR',
       '--',
       10,
       10,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da tabela',
       'Cdigo da tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'LMPR',
       '--',
       20,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Identificao do Log',
       'Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LMPR',
       '--',
       30,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo usurio',
       'Cdigo usurio',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LMPR',
       '--',
       40,
       7,
       'DATMPR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data de operao',
       'Data de operao',
       '',
       'DATMPR',
       'F' FROM DUAL
UNION ALL
SELECT 'LMPR',
       '--',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data de incluso',
       'Data de incluso',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LMPR',
       '--',
       60,
       3,
       'FILMPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       '',
       'FILMPR',
       'F' FROM DUAL
UNION ALL
SELECT 'LMPR',
       '--',
       70,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Filial do usurio',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LMPR',
       '--',
       80,
       4000,
       'MSGLOG',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem de Log',
       'Mensagem de Log',
       '',
       'MSGLOG',
       'F' FROM DUAL
);

/*-- SEQ 8592 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LOBS',
       TO_NUMBER(null),
       'LOBS',
       'Log  de Obs. Fiscais',
       'TL_OBS',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8593 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LOBS','--','' FROM DUAL
UNION ALL
SELECT 'LOBS','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LOBS','99','Outros' FROM DUAL
);

/*-- SEQ 8594 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LOBS',
       '--',
       10,
       5,
       'CODOBS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Obs.',
       'Cdigo da Observao',
       '',
       'CODOBS',
       'F' FROM DUAL
UNION ALL
SELECT 'LOBS',
       '--',
       20,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Identificao do Log',
       'Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LOBS',
       '--',
       30,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Usurio',
       'Cdigo do Usurio',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LOBS',
       '--',
       40,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Operao',
       'Data da Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LOBS',
       '--',
       50,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do Usurio',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LOBS',
       '--',
       60,
       4000,
       'MSGLOG',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem de LOG',
       'Mensagem de LOG ',
       '',
       'RTF2TXT(MSGLOG)',
       'F' FROM DUAL
);

/*-- SEQ 8595 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LOG ',
       TO_NUMBER(null),
       'LOG ',
       'Logradouros',
       'TT_LOG',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8596 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LOG ','--','' FROM DUAL
UNION ALL
SELECT 'LOG ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LOG ','99','Outros' FROM DUAL
);

/*-- SEQ 8597 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5816,
       'BAI ',
       'LOG ',
       'N ',
       '1 ',
       '',
       '',
       'BAI.CODBAI = LOG.CODBAI',
       '' FROM DUAL
);

/*-- SEQ 8598 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LOG ',
       '01',
       10,
       5,
       'CODBAI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo do Bairro',
       'Cdigo do Bairro',
       '',
       'CODBAI',
       'F' FROM DUAL
UNION ALL
SELECT 'LOG ',
       '01',
       20,
       8,
       'CODCEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Cep',
       'Cdigo do Cep',
       '',
       'CODCEP',
       'F' FROM DUAL
UNION ALL
SELECT 'LOG ',
       '01',
       30,
       255,
       'COMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Complemento',
       'Complemento',
       '',
       'COMPLE',
       'F' FROM DUAL
UNION ALL
SELECT 'LOG ',
       '01',
       40,
       55,
       'NOMLOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Logradouro',
       'Nome Logradouro',
       '',
       'NOMLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'LOG ',
       '01',
       50,
       5,
       'TIPLOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Logradouro',
       'Tipo Logradouro',
       '',
       'TIPLOG',
       'F' FROM DUAL
);

/*-- SEQ 8599 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LOI ',
       TO_NUMBER(null),
       'LOI ',
       'Listas de DI',
       'TT_LOI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'LOI.CODFIL, LOI.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8600 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LOI ','--','' FROM DUAL
UNION ALL
SELECT 'LOI ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LOI ','99','Outros' FROM DUAL
);

/*-- SEQ 8601 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LOI ',
       '99',
       40,
       254,
       'ARQXML',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Arquivo XML',
       'Nome Arquivo XML',
       '',
       'ARQXML',
       'F' FROM DUAL
UNION ALL
SELECT 'LOI ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = LOI.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'LOI ',
       '99',
       50,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'LOI ',
       '01',
       30,
       32,
       'MD5XML',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'MD5 do XML',
       'MD5 do XML',
       '',
       'MD5XML',
       'F' FROM DUAL
UNION ALL
SELECT 'LOI ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'LOI ',
       '99',
       60,
       0,
       'XMLDOC',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'XML do DI',
       'XML do DI',
       '',
       'XMLDOC',
       'F' FROM DUAL
);

/*-- SEQ 8602 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LOT',
       TO_NUMBER(null),
       'LOT',
       'Lote',
       'TT_LOT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'LOT.CODFIL, LOT.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8603 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LOT','--','' FROM DUAL
UNION ALL
SELECT 'LOT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LOT','05','Datas' FROM DUAL
UNION ALL
SELECT 'LOT','99','Outros' FROM DUAL
);

/*-- SEQ 8604 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21468,
       'GRA ',
       'LOT ',
       '1',
       '0N',
       '',
       '',
       'GRA.FILMAT = LOT.FILMAT(+) AND
GRA.CODMAT = LOT.CODMAT(+) AND
GRA.CODCOR = LOT.CODCOR(+) AND
GRA.CODTAM = LOT.CODTAM(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21469,
       'CLI ',
       'LOT ',
       '01',
       'N',
       '',
       '',
       'CLI.FILCLI = LOT.FILFOR AND
CLI.CODCLI = LOT.CODFOR',
       '',
       '' FROM DUAL
);

/*-- SEQ 8605 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'LOT ',
       '99',
       220,
       4,
       'ANOFAB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Ano Fabricao Veic.',
       'Ano de Fabricao do Veculo',
       '',
       'ANOFAB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '99',
       260,
       4,
       'ANOMOD',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Ano Modelo Veculo',
       'Ano do Modelo de Fabricao Veculo',
       '',
       'ANOMOD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '05',
       30,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Atualizao',
       'Data da Atualizao',
       '',
       'ATU_EM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '99',
       240,
       17,
       'CHASSI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Chassi do Veculo',
       'Chassi do Veculo',
       '',
       'CHASSI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '01',
       220,
       40,
       'CODALT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo alternativo',
       'Cdigo alternativo',
       '',
       'CODALT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '--',
       70,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       '',
       '9',
       '',
       'Cor~Produto',
       'Cdigo da cor (diviso)',
       'DIV.CODITE (+) = LOT.CODCOR',
       'CODCOR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '99',
       290,
       5,
       'CODCORVEI',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cod Cor do Veculo',
       'Cdigo da Cor do Veculo',
       '',
       'CODCORVEI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '01',
       190,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL(+) = LOT.CODFIL',
       'CODFIL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '01',
       110,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo~Fornecedor',
       'Cdigo do Fornecedor',
       '',
       'CODFOR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '--',
       60,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo~Produto',
       'Cdigo do Produto',
       '',
       'CODMAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '--',
       80,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       '',
       '9',
       '',
       'Tamanho~Produto',
       'Cdigo do tamanho (sub-diviso)',
       'SUB.CODITE (+) = LOT.CODTAM',
       'CODTAM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '99',
       250,
       1,
       'CONVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Condio do Veculo',
       'Condio do Veculo',
       '',
       'CONVIN',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '05',
       40,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Incluso',
       'Data da Incluso',
       '',
       'DATINC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '05',
       140,
       8,
       'DATVAL',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data~Validade',
       'Data de validade',
       '',
       'DATVAL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '01',
       100,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Filial~Fornecedor',
       'Filial do Fornecedor',
       '',
       'FILFOR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '--',
       50,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Filial~Produto',
       'Filial do Produto',
       '',
       'FILMAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '99',
       180,
       1,
       'FLGPON',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       ' Ponta de estoque?',
       ' Ponta de estoque?',
       '',
       'FLGPON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '99',
       210,
       1,
       'LOTATI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Lote Ativo?',
       'Lote Ativo?',
       '',
       'LOTATI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '--',
       90,
       40,
       'NUMLOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nmero Lote',
       'Nmero do Lote',
       '',
       'NUMLOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '99',
       280,
       21,
       'NUMMOT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nmero do Motor',
       'Nmero do Motor do Veculo',
       '',
       'NUMMOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '99',
       200,
       5,
       'PERABA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Abatimento',
       '% Abatimento',
       '',
       'PERABA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '99',
       160,
       12,
       'QTDCOM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Qtd. Total Comprada',
       'Quantidade total comprada (Desativado)',
       '',
       'QTDCOM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '99',
       170,
       12,
       'QTDEST',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Saldo Lote',
       'Saldo do Lote',
       '',
       'QTDEST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '99',
       150,
       12,
       'QTDINI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Qtd. Estoque Inicial',
       'Quantidade em estoque inicial',
       '',
       'QTDINI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '99',
       270,
       9,
       'SERIAL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Serial do Veculo',
       'Serial do Veculo',
       '',
       'SERIAL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '99',
       130,
       20,
       'TAMANH',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Tamanho',
       'Tamanho',
       '',
       'TAMANH',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '99',
       230,
       1,
       'TIPPIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo Pintura Veic.',
       'Tipo de Pintura do Veculo',
       '',
       'TIPPIN',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'LOT ',
       '99',
       120,
       20,
       'TONALI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Tonalidade',
       'Tonalidade',
       '',
       'TONALI',
       '',
       'D' FROM DUAL
);

/*-- SEQ 8606 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'LOT ',
       'CONVIN',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LOT ',
       'CONVIN',
       0,
       'R',
       'Remarcado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LOT ',
       'TIPPIN',
       0,
       'C',
       'Candy',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LOT ',
       'TIPPIN',
       0,
       'F',
       'Flake',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LOT ',
       'TIPPIN',
       0,
       'M',
       'Metlica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LOT ',
       'TIPPIN',
       0,
       'P',
       'Perolizada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LOT ',
       'TIPPIN',
       0,
       'S',
       'Slida',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8607 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LPED',
       TO_NUMBER(null),
       'LPED',
       'Log de Pedidos',
       'TL_PED',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'LPED.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 8608 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LPED','--','' FROM DUAL
UNION ALL
SELECT 'LPED','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LPED','99','Outros' FROM DUAL
);

/*-- SEQ 8609 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 30849,
       'PED ',
       'LPED',
       '1',
       'N',
       '',
       '',
       'LPED.FILPED = PED.CODFIL AND
LPED.NUMPED = PED.NUMPED',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30850,
       'TUID',
       'LPED',
       '1',
       'N',
       '',
       '',
       'LPED.CODUID = TUID.CODUID',
       '',
       '' FROM DUAL
);

/*-- SEQ 8610 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LPED',
       '--',
       10,
       10,
       'CODTAB',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Cdigo',
       'Cdigo',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'LPED',
       '--',
       80,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cod. Ident. Usurio',
       'Cdigo Identificao de Usurio',
       '',
       'CODUID',
       '' FROM DUAL
UNION ALL
SELECT 'LPED',
       '--',
       60,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       '9',
       '',
       'Nome do Usurio',
       'Cdigo do Usurio',
       'USU.FILUSU(+) = LPED.FILUSU AND USU.CODUSU(+) = LPED.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LPED',
       '--',
       40,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       '',
       'Data',
       'Data',
       '',
       'DATOPE',
       '' FROM DUAL
UNION ALL
SELECT 'LPED',
       '--',
       20,
       3,
       'FILPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       '',
       'Filial do Pedido',
       'Filial do Pedido',
       '',
       'FILPED',
       '' FROM DUAL
UNION ALL
SELECT 'LPED',
       '--',
       50,
       3,
       'FILUSU',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial do Usurio',
       'Filial do Usurio',
       'DFIL.CODFIL(+) = LPED.FILUSU',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LPED',
       '--',
       70,
       4000,
       'MSGLOG',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Log',
       'Log',
       '',
       'RTF2TXT(MSGLOG)',
       '' FROM DUAL
UNION ALL
SELECT 'LPED',
       '--',
       30,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Nmero do Pedido',
       'Nmero do Pedido',
       '',
       'NUMPED',
       '' FROM DUAL
);

/*-- SEQ 8611 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LPLA',
       TO_NUMBER(null),
       'LPLA',
       'Log dos planos',
       'TL_PLA',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8612 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LPLA','--','' FROM DUAL
UNION ALL
SELECT 'LPLA','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LPLA','99','Outros' FROM DUAL
);

/*-- SEQ 8613 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 129003,
       'USU ',
       'LPLA',
       '1',
       'N',
       '',
       '',
       'LPLA.FILUSU = USU.FILUSU AND
LPLA.CODUSU = USU.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 129002,
       'PLA ',
       'LPLA',
       '1',
       'N',
       '',
       '',
       'LPLA.FILPLA = PLA.FILPGT AND
LPLA.CODPLA = PLA.CODPGT',
       '',
       '' FROM DUAL
);

/*-- SEQ 8614 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LPLA',
       '01',
       30,
       3,
       'CODPLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo plano',
       'Cdigo plano',
       '',
       'CODPLA',
       '' FROM DUAL
UNION ALL
SELECT 'LPLA',
       '01',
       10,
       10,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Id',
       'Cdigo Id',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'LPLA',
       '01',
       80,
       10,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Id Sesso',
       'Id Sesso',
       '',
       'CODUID',
       '' FROM DUAL
UNION ALL
SELECT 'LPLA',
       '01',
       60,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo usurio',
       'Cdigo usurio',
       '',
       'CODUSU',
       '' FROM DUAL
UNION ALL
SELECT 'LPLA',
       '01',
       40,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       '',
       'Data incluso',
       'Data incluso',
       '',
       'DATOPE',
       '' FROM DUAL
UNION ALL
SELECT 'LPLA',
       '01',
       20,
       3,
       'FILPLA',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial plano ',
       'Filial plano',
       'DFIL.CODFIL = LPLA.FILPLA',
       'FILPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'LPLA',
       '01',
       50,
       3,
       'FILUSU',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial usurio',
       'Filial usurio',
       'DFIL.CODFIL = LPLA.FILUSU',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LPLA',
       '01',
       70,
       4000,
       'MSGLOG',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Log',
       'Log',
       '',
       'MSGLOG',
       '' FROM DUAL
);

/*-- SEQ 8615 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LPRE',
       TO_NUMBER(null),
       'LPRE',
       'Log de Preos',
       'TL_PRE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'LPRE.FILPRE,LPRE.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8616 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LPRE','--','' FROM DUAL
);

/*-- SEQ 8617 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23833,
       'PRE ',
       'LPRE',
       '1',
       '0N',
       '',
       '',
       'LPRE.FILPRE(+) = PRE.FILPRE and
LPRE.SEQPRE(+) = PRE.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23834,
       'TUID',
       'LPRE',
       '01',
       '0N',
       '',
       '',
       'LPRE.CODUID = TUID.CODUID(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8618 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LPRE',
       '--',
       20,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data',
       'Ano de Data da alterao',
       '',
       'TO_CHAR(LPRE.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'LPRE',
       '--',
       120,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Identificao do Log',
       'Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LPRE',
       '--',
       10,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Usurio',
       'Cdigo do Usurio que fez as alteraes',
       'LPRE.FILUSU = USU.FILUSU(+) and LPRE.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LPRE',
       '--',
       130,
       12,
       'CUSANT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Custo de Reposio',
       'Custo de Reposio Anterior do Preo',
       '',
       'CUSANT',
       '' FROM DUAL
UNION ALL
SELECT 'LPRE',
       '--',
       140,
       12,
       'CUSVENANT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cus Tot Venda Ant',
       'Custo Total de Venda do Preo Anterior',
       '',
       'CUSVENANT',
       '' FROM DUAL
UNION ALL
SELECT 'LPRE',
       '--',
       23,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data',
       'Data da alterao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LPRE',
       '--',
       150,
       12,
       'DESFIXANT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Desp Oper Fixa Ant',
       'Despesa Operacional Fixa do Preo Anterior',
       '',
       'DESFIXANT',
       '' FROM DUAL
UNION ALL
SELECT 'LPRE',
       '--',
       100,
       3,
       'FILPRE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       '',
       'Filial dos Preos',
       'DFIL.CODFIL = LPRE.FILPRE',
       'FILPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'LPRE',
       '--',
       50,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do usurio que fez as alteraes',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LPRE',
       '--',
       160,
       12,
       'LUCPRJANT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Lucro Proj Ant',
       'Lucro Projetado do Preo Anterior',
       '',
       'LUCPRJANT',
       '' FROM DUAL
UNION ALL
SELECT 'LPRE',
       '--',
       25,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data',
       'Ms de Data da alterao',
       '',
       'TO_CHAR(LPRE.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'LPRE',
       '--',
       60,
       200,
       'MSGLOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Alteraes',
       'Mostra quais as alteraes foram efetuadas',
       '',
       'MSGLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'LPRE',
       '--',
       110,
       12,
       'PREANT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Preo Anterior',
       'Preo Anterior',
       '',
       'PREANT',
       'F' FROM DUAL
UNION ALL
SELECT 'LPRE',
       '--',
       40,
       10,
       'SEQPRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Controle interno',
       '',
       'SEQPRE',
       'F' FROM DUAL
);

/*-- SEQ 8619 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LPRJ',
       TO_NUMBER(null),
       'LPRJ',
       'Log Itens do Projeto',
       'TL_PRJ',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'LPRJ.CODFIL,LPRJ.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8620 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LPRJ','--','' FROM DUAL
UNION ALL
SELECT 'LPRJ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LPRJ','99','Outros' FROM DUAL
);

/*-- SEQ 8621 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 33928,
       'TUID',
       'LPRJ',
       '01',
       '0N',
       '',
       '',
       'LPRJ.CODUID = TUID.CODUID(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8622 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LPRJ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial',
       'Cdigo Filial ',
       'DFIL.CODFIL = LPRJ.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'LPRJ',
       '01',
       70,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Identificao do Log',
       'Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LPRJ',
       '01',
       20,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Usurio',
       'Cdigo Usurio',
       'USU2.FILUSU(+) = LPRJ.FILUSU AND USU2.CODUSU(+) = LPRJ.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LPRJ',
       '01',
       30,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data e Hora',
       'Data e Hora',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'LPRJ',
       '01',
       40,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LPRJ',
       '01',
       50,
       4000,
       'MSGLOG',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem de Log',
       'Mensagem de Log',
       '',
       'MSGLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'LPRJ',
       '01',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8623 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LPRO',
       TO_NUMBER(null),
       'LPRO',
       'Log de Produtos',
       'TL_PRO',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8624 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LPRO','--','' FROM DUAL
);

/*-- SEQ 8625 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 33929,
       'TUID',
       'LPRO',
       '01',
       '0N',
       '',
       '',
       'LPRO.CODUID = TUID.CODUID(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23270,
       'PRO ',
       'LPRO',
       '01',
       '0N',
       '',
       '',
       'LPRO.FILMAT(+) = PRO.FILMAT AND
LPRO.CODMAT(+) = PRO.CODMAT',
       '',
       '' FROM DUAL
);

/*-- SEQ 8626 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LPRO',
       '--',
       2,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'LPRO',
       '--',
       16,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Identificao do Log',
       'Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LPRO',
       '--',
       4,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'N',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'LPRO.FILUSU = USU.FILUSU(+)  AND LPRO.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LPRO',
       '--',
       6,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da  Operao',
       'Data da  Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LPRO',
       '--',
       1,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'LPRO',
       '--',
       3,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LPRO',
       '--',
       5,
       4000,
       'MSGLOG',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem de Log',
       'Mensagem de Log',
       '',
       'RTF2TXT(MSGLOG)',
       'F' FROM DUAL
);

/*-- SEQ 8627 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LPTC',
       TO_NUMBER(null),
       'LPTC',
       'Log de Protoc. e Con',
       'TL_PTC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8628 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LPTC','--','' FROM DUAL
UNION ALL
SELECT 'LPTC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LPTC','99','Outros' FROM DUAL
);

/*-- SEQ 8629 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LPTC',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'LPTC',
       '--',
       20,
       10,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'LPTC',
       '--',
       30,
       22,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Identificao do Log',
       'Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LPTC',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Usurio',
       'Cdigo do Usurio',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LPTC',
       '--',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LPTC',
       '--',
       60,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do Usurio',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LPTC',
       '--',
       70,
       4000,
       'MSGLOG',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem de LOG',
       'Mensagem de LOG',
       '',
       'MSGLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'LPTC',
       '--',
       80,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8630 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LRCP',
       TO_NUMBER(null),
       'LRCP',
       'Log de Recepo',
       'TL_RCP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'LRCP.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 8631 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LRCP','--','' FROM DUAL
);

/*-- SEQ 8632 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 29263,
       'REL ',
       'LRCP',
       '01',
       '0N',
       '',
       '',
       'REL.FILPAR = LRCP.FILFOR AND
REL.CODPAR = LRCP.CODFOR AND
REL.TIPPAR = LRCP.TIPFOR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29264,
       'TUID',
       'LRCP',
       '01',
       '0N',
       '',
       '',
       'LRCP.CODUID = TUID.CODUID(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8633 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LRCP',
       '--',
       110,
       4,
       'ANO_DATHOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data',
       'Ano de Data em que as alteraes foram feitas',
       '',
       'TO_CHAR(LRCP.DATHOR,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'LRCP',
       '--',
       35,
       4,
       'ANO_DATRCP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data recpo',
       'Ano de Data da recepo',
       '',
       'TO_CHAR(LRCP.DATRCP,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'LRCP',
       '--',
       10,
       3,
       'CODCAN',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Cancelado por:',
       'Usurio que cancelou',
       'LRCP.FILCAN = USU.FILUSU(+) and LRCP.CODCAN = USU.CODUSU(+)',
       'CODCAN',
       'T' FROM DUAL
UNION ALL
SELECT 'LRCP',
       '--',
       120,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = LRCP.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'LRCP',
       '--',
       130,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo do fornecedor',
       'Cdigo do fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'LRCP',
       '--',
       140,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       'F',
       'A',
       'F',
       'Srie',
       'Srie',
       'LRCPCODSER=DSER.CODSER (+)',
       'CODSER',
       'T' FROM DUAL
UNION ALL
SELECT 'LRCP',
       '--',
       150,
       3,
       'CODSUP',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Responsvel',
       'Responsvel',
       'LRCP.FILSUP = USU.FILUSU(+) and LRCP.CODSUP = USU.CODUSU(+)',
       'CODSUP',
       'T' FROM DUAL
UNION ALL
SELECT 'LRCP',
       '--',
       180,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Identificao do Log',
       'Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LRCP',
       '--',
       20,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Usurio',
       'Usurio que fez as alteraes',
       'LRCP.FILUSU = USU.FILUSU(+) and LRCP.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LRCP',
       '--',
       100,
       8,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data',
       'Data em que as alteraes foram feitas',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'LRCP',
       '--',
       30,
       8,
       'DATRCP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data recpo',
       'Data da recepo',
       '',
       'DATRCP',
       'F' FROM DUAL
UNION ALL
SELECT 'LRCP',
       '--',
       60,
       3,
       'FILCAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial Cancelamento',
       'Filial do usurio que cancelou',
       '',
       'FILCAN',
       'F' FROM DUAL
UNION ALL
SELECT 'LRCP',
       '--',
       40,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'LRCP',
       '--',
       160,
       3,
       'FILSUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo do supervisor',
       '',
       'FILSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'LRCP',
       '--',
       50,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LRCP',
       '--',
       95,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'LRCP',
       '--',
       105,
       2,
       'MES_DATHOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data',
       'Ms de Data em que as alteraes foram feitas',
       '',
       'TO_CHAR(LRCP.DATHOR,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'LRCP',
       '--',
       33,
       2,
       'MES_DATRCP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data recpo',
       'Ms de Data da recepo',
       '',
       'TO_CHAR(LRCP.DATRCP,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'LRCP',
       '--',
       90,
       9,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nmero da Nota',
       'Nro da Nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'LRCP',
       '--',
       170,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Alteraes',
       'Mastra as alteraes realizadas',
       '',
       'RTF2TXT(LRCP.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'LRCP',
       '--',
       80,
       3,
       'SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Sub-Srie',
       'Sub-Srie',
       '',
       'SUBSER',
       'F' FROM DUAL
UNION ALL
SELECT 'LRCP',
       '--',
       70,
       1,
       'TIPFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Cliente',
       'Tipo de parceiro',
       '',
       'TIPFOR',
       'T' FROM DUAL
);

/*-- SEQ 8634 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'LRCP',
       'FLGEST',
       0,
       'A',
       'Aberta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LRCP',
       'FLGEST',
       0,
       'E',
       'Entregue',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LRCP',
       'TIPFOR',
       0,
       'F',
       'Fornecedor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LRCP',
       'TIPFOR',
       0,
       'T',
       'Transportadora',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8635 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LRDV',
       TO_NUMBER(null),
       'LRDV',
       'Log de Rec. de DAVs',
       'TL_RDV',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8636 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LRDV','--','' FROM DUAL
UNION ALL
SELECT 'LRDV','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LRDV','99','Outros' FROM DUAL
);

/*-- SEQ 8637 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20299,
       'RDV ',
       'LRDV',
       '1',
       'N',
       '',
       '',
       'LRDV.FILRDV = RDV.CODFIL AND
LRDV.SEQRDV = RDV.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 8638 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LRDV',
       '--',
       244,
       10,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Chave Primria',
       'Chave Primria',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'LRDV',
       '--',
       254,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Sesso',
       'Cdigo da Sesso',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LRDV',
       '--',
       264,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo do Usurio',
       'Cdigo do Usurio',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LRDV',
       '--',
       274,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LRDV',
       '--',
       284,
       3,
       'FILRDV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'FILRDV',
       'F' FROM DUAL
UNION ALL
SELECT 'LRDV',
       '--',
       294,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Filial do Usurio',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LRDV',
       '--',
       304,
       4000,
       'MSGLOG',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem',
       '',
       'MSGLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'LRDV',
       '--',
       314,
       10,
       'SEQRDV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQRDV',
       'F' FROM DUAL
);

/*-- SEQ 8639 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LREG',
       TO_NUMBER(null),
       'LREG',
       'Log de Registro',
       'TL_REG',
       'T',
       '',
       'TOTALL',
       'Log de Registro',
       '',
       '',
       '',
       '',
       'F',
       '',
       'LREG.CODFIL,LREG.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8640 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LREG','--','' FROM DUAL
);

/*-- SEQ 8641 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 33769,
       'USU ',
       'LREG',
       '0N',
       '01',
       '',
       '',
       'USU.FILUSU = LREG.FILUSU AND
USU.CODUSU = LREG.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 33938,
       'TUID',
       'LREG',
       '01',
       '0N',
       '',
       '',
       'LREG.CODUID = TUID.CODUID(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8642 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LREG',
       '--',
       35,
       4,
       'ANO_DATALT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data Altera',
       'Ano de Data da Alterao',
       '',
       'TO_CHAR(LREG.DATALT,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'LREG',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       '0',
       'F',
       'Filial',
       'Cdigo da Filial de Origem do Registro',
       'DFIL.CODFIL = LREG.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'LREG',
       '--',
       70,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Identificao do Log',
       'Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LREG',
       '--',
       50,
       3,
       'CODUSU',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       '9',
       'F',
       'Cdigo do Usurio',
       'Cdigo do Usurio que fez a Alterao',
       'DFIL.CODFIL = LREG.CODUSU',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LREG',
       '--',
       30,
       8,
       'DATALT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data Alterao',
       'Data da Alterao',
       '',
       'DATALT',
       'F' FROM DUAL
UNION ALL
SELECT 'LREG',
       '--',
       40,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Usurio que fez a Alterao',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LREG',
       '--',
       33,
       2,
       'MES_DATALT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data Altera',
       'Ms de Data da Alterao',
       '',
       'TO_CHAR(LREG.DATALT,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'LREG',
       '--',
       60,
       4000,
       'MSGLOG',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       60,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Alterao',
       'Indica o que foi alterado',
       '',
       'RTF2TXT(MSGLOG)',
       'F' FROM DUAL
UNION ALL
SELECT 'LREG',
       '--',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8643 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LRPS',
       TO_NUMBER(null),
       'LRPS',
       'Log Rec Prov Servio',
       'TL_RPS',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8644 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LRPS','--','' FROM DUAL
UNION ALL
SELECT 'LRPS','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LRPS','99','Outros' FROM DUAL
);

/*-- SEQ 8645 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23056,
       'RPS ',
       'LRPS',
       '1',
       'N',
       '',
       '',
       'LRPS.FILRPS = RPS.CODFIL AND
LRPS.SEQRPS = RPS.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 8646 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LRPS',
       '--',
       10,
       10,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       '',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'LRPS',
       '--',
       20,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       '',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LRPS',
       '--',
       30,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do usurio',
       'Cdigo do usurio',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LRPS',
       '--',
       40,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LRPS',
       '--',
       50,
       3,
       'FILRPS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'FILRPS',
       'F' FROM DUAL
UNION ALL
SELECT 'LRPS',
       '--',
       60,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Filial do usurio',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LRPS',
       '--',
       70,
       4000,
       'MSGLOG',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Log',
       'Log',
       '',
       'MSGLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'LRPS',
       '--',
       80,
       10,
       'SEQRPS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQRPS',
       'F' FROM DUAL
);

/*-- SEQ 8647 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LRTT',
       TO_NUMBER(null),
       'LRTT',
       'Log Receb Tit Tercei',
       'TL_RTT',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8648 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LRTT','--','' FROM DUAL
UNION ALL
SELECT 'LRTT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LRTT','99','Outros' FROM DUAL
);

/*-- SEQ 8649 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LRTT',
       '--',
       10,
       10,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo de Identifica',
       'Cdigo de Identificao',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'LRTT',
       '--',
       20,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Identificao do Log',
       'Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LRTT',
       '--',
       30,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Usurio',
       'Cdigo do Usurio',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LRTT',
       '--',
       40,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LRTT',
       '--',
       50,
       3,
       'FILRTT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'FILRTT',
       'F' FROM DUAL
UNION ALL
SELECT 'LRTT',
       '--',
       60,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do Usurio',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LRTT',
       '--',
       70,
       4000,
       'MSGLOG',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Log',
       'Log',
       '',
       'MSGLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'LRTT',
       '--',
       80,
       10,
       'SEQRTT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQRTT',
       'F' FROM DUAL
);

/*-- SEQ 8650 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LSAV',
       TO_NUMBER(null),
       'LSAV',
       'Alteraoes Serv Adi',
       'TL_SAV',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'LSAV.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 8651 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LSAV','--','' FROM DUAL
UNION ALL
SELECT 'LSAV','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LSAV','99','Outros' FROM DUAL
);

/*-- SEQ 8652 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LSAV',
       '--',
       10,
       10,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo',
       'Cdigo',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'LSAV',
       '--',
       20,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificador Acesso',
       'Identificador Acesso',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LSAV',
       '--',
       30,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Usurio',
       'Cdigo do Usurio',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LSAV',
       '--',
       40,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LSAV',
       '--',
       50,
       3,
       'FILSAV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial do Servio',
       'Filial do Servio',
       '',
       'FILSAV',
       'F' FROM DUAL
UNION ALL
SELECT 'LSAV',
       '--',
       60,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial do Usurio',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LSAV',
       '--',
       70,
       4000,
       'MSGLOG',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mudana',
       'Mudana',
       '',
       'MSGLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'LSAV',
       '--',
       80,
       10,
       'SEQSAV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Seq. Servio',
       'Sequenciador Servio',
       '',
       'SEQSAV',
       'F' FROM DUAL
);

/*-- SEQ 8653 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LSPE',
       TO_NUMBER(null),
       'LSPE',
       'Log Produto SPED',
       'TL_PRO_SPED',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8654 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LSPE','--','' FROM DUAL
UNION ALL
SELECT 'LSPE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LSPE','99','Outros' FROM DUAL
);

/*-- SEQ 8655 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 129007,
       'PRO ',
       'LSPE',
       '01',
       '0N',
       '',
       '',
       'PRO.FILMAT(+) = LSPE.FILMAT and
PRO.CODMAT(+) = LSPE.CODMAT',
       '',
       '' FROM DUAL
);

/*-- SEQ 8656 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'LSPE',
       '01',
       60,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       '',
       'N',
       '',
       'Diviso',
       'Diviso do Produto',
       'LSPE.CODCOR = DIV.CODITE(+)',
       'CODCOR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'LSPE',
       '01',
       120,
       60,
       'CODFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo Fiscal',
       'Cdigo Fiscal',
       '',
       'CODFIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LSPE',
       '01',
       50,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo do Material',
       'Cdigo do Material',
       '',
       'CODMAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LSPE',
       '01',
       10,
       10,
       'CODTAB',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo',
       'Cdigo',
       '',
       'CODTAB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LSPE',
       '01',
       70,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       '',
       'N',
       '',
       'Subdiviso',
       'Subdiviso do Produto',
       'LSPE.CODTAM = SUB.CODITE(+)',
       'CODTAM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'LSPE',
       '01',
       20,
       10,
       'DATANT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Anterior',
       'Data Anterior da Vigncia',
       '',
       'DATANT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LSPE',
       '01',
       30,
       10,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Incluso',
       'Data da Incluso do Log',
       '',
       'DATOPE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LSPE',
       '01',
       80,
       15,
       'DESECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio do ECF',
       'Descrio do ECF',
       '',
       'DESECF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LSPE',
       '01',
       110,
       120,
       'DESGRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio Grade',
       'Descrio da Grade',
       '',
       'DESGRA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LSPE',
       '01',
       90,
       30,
       'DESMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio Material',
       'Descrio do Material',
       '',
       'DESMAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LSPE',
       '01',
       100,
       30,
       'ESPMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Especifica Mat.',
       'Especificao do Material',
       '',
       'ESPMAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LSPE',
       '01',
       40,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Filial do Material',
       'Filal do Material',
       '',
       'FILMAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LSPE',
       '01',
       220,
       14,
       'MVAVEN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% MVA',
       '% MVA para Venda',
       '',
       'MVAVEN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LSPE',
       '01',
       230,
       5,
       'PERFCP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% FCP',
       '% do Fundo de Combate  Pobreza na UF',
       '',
       'PERFCP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LSPE',
       '01',
       180,
       5,
       'REDALI',
       'A',
       'DIRE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TO_CHAR(DIRE.ICMSRE)',
       'V',
       '',
       '',
       'A',
       '',
       'Base Reduzida',
       'Base Reduzida',
       'LSPE.REDALI = DIRE.CODTAB(+)',
       'REDALI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'LSPE',
       '01',
       190,
       1,
       'REDICM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Reduz Base?',
       'Reduz Base de ICMS no valor do ICMS prprio?',
       '',
       'REDICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LSPE',
       '01',
       200,
       5,
       'REDINT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Red. ICMS',
       '% Reduo de ICMS para Operaes Interestaduais com este Destino',
       '',
       'REDINT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LSPE',
       '01',
       210,
       6,
       'REDSIM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Reduo Base ST',
       'Reduo para Base ST Simples',
       '',
       'REDSIM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LSPE',
       '01',
       150,
       1,
       'REGESP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Regime Especial',
       'Indicador do Regime Especial',
       '',
       'REGESP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LSPE',
       '01',
       170,
       5,
       'RESICM',
       'A',
       'DICM',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TO_CHAR(DICM.RESICM)',
       'V',
       '',
       '',
       'A',
       '',
       'Alquota ICMS',
       'Alquota do ICMS',
       'LSPE.RESICM = DICM.CODTAB(+)',
       'RESICM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'LSPE',
       '01',
       140,
       2,
       'SIGLAUF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Sigla da UF',
       'Sigla da UF da Alterao',
       '',
       'SIGLAUF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LSPE',
       '01',
       160,
       1,
       'SUBTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Situao Tributria',
       'Situao Tributria',
       '',
       'SUBTRI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'LSPE',
       '01',
       130,
       1,
       'TIPLOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo de Log',
       'Tipo de LOG',
       '',
       'TIPLOG',
       'T',
       'D' FROM DUAL
);

/*-- SEQ 8657 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'LSPE',
       'TIPLOG',
       0,
       'C',
       'Alteraes Cadastrais',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LSPE',
       'TIPLOG',
       0,
       'I',
       'Alteraes Tributveis',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8658 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LSUP',
       TO_NUMBER(null),
       'LSUP',
       'LogAlterao Suporte',
       'TL_SUP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'LSUP.CODFIL,LSUP.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8659 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LSUP','--','' FROM DUAL
UNION ALL
SELECT 'LSUP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LSUP','99','Outros' FROM DUAL
);

/*-- SEQ 8660 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 33930,
       'TUID',
       'LSUP',
       '01',
       '0N',
       '',
       '',
       'LSUP.CODUID = TUID.CODUID(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8661 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LSUP',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       '0',
       'F',
       'Filial',
       'Codigo da filial',
       'DFIL.CODFIL = LSUP.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'LSUP',
       '--',
       80,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Identificao do Log',
       'Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LSUP',
       '--',
       20,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Codigo do Usuario',
       'LSUP.FILUSU = USU.FILUSU(+)  AND LSUP.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LSUP',
       '--',
       30,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Modificacao',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'LSUP',
       '--',
       40,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Usuario',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LSUP',
       '--',
       50,
       1,
       'FLGMUD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Alteracao',
       'Alteracao',
       '',
       'FLGMUD',
       'T' FROM DUAL
UNION ALL
SELECT 'LSUP',
       '--',
       60,
       4000,
       'MSGLOG',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Mensagem',
       'Mensagem',
       '',
       'RTF2TXT(MSGLOG)',
       'F' FROM DUAL
UNION ALL
SELECT 'LSUP',
       '--',
       70,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8662 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'LSUP',
       'FLGMUD',
       0,
       'A',
       'Anexos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LSUP',
       'FLGMUD',
       0,
       'O',
       'Atributos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LSUP',
       'FLGMUD',
       0,
       'T',
       'Texto',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8663 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LSVM',
       TO_NUMBER(null),
       'LSVM',
       'Log.Serv. Middleware',
       'TL_SRV_MID',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8664 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LSVM','--','' FROM DUAL
UNION ALL
SELECT 'LSVM','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LSVM','99','Outros' FROM DUAL
);

/*-- SEQ 8665 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LSVM',
       '01',
       10,
       10,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Cdigo de Identificao',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'LSVM',
       '01',
       20,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'LSVM',
       '99',
       30,
       4000,
       'MSGLOG',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem de Log',
       '',
       'MSGLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'LSVM',
       '99',
       40,
       4,
       'NIVLOG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nvel',
       'Nvel do Log',
       '',
       'NIVLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'LSVM',
       '01',
       50,
       1,
       'ORILOG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Origem',
       'Origem do Log',
       '',
       'ORILOG',
       'T' FROM DUAL
UNION ALL
SELECT 'LSVM',
       '01',
       60,
       1,
       'TIPLOG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Tipo',
       'Tipo de Log',
       '',
       'TIPLOG',
       'T' FROM DUAL
);

/*-- SEQ 8666 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'LSVM',
       'ORILOG',
       0,
       ' ',
       'Middleware',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LSVM',
       'ORILOG',
       1,
       ' ',
       'Integrao EME4',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LSVM',
       'ORILOG',
       2,
       ' ',
       'Integrao Mercos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LSVM',
       'TIPLOG',
       0,
       ' ',
       'Operao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LSVM',
       'TIPLOG',
       1,
       ' ',
       'Aviso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LSVM',
       'TIPLOG',
       2,
       ' ',
       'Erro',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8667 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LTB ',
       TO_NUMBER(null),
       'LTB ',
       'Trailers Arquivos',
       'TT_LTB',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'LTB.CODFIL,LTB.SEQARQ,LTB.CODLOT',
       '' FROM DUAL
);

/*-- SEQ 8668 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LTB ','--','' FROM DUAL
UNION ALL
SELECT 'LTB ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LTB ','02','Datas' FROM DUAL
UNION ALL
SELECT 'LTB ','03','Valores' FROM DUAL
UNION ALL
SELECT 'LTB ','99','Outros' FROM DUAL
);

/*-- SEQ 8669 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5836,
       'HTB ',
       'LTB ',
       'N ',
       '1 ',
       '',
       '',
       'HTB.CODFIL = LTB.CODFIL AND
HTB.SEQUEN = LTB.SEQARQ',
       '' FROM DUAL
);

/*-- SEQ 8670 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LTB ',
       '01',
       10,
       1,
       'CBANCO',
       'A',
       'DBCO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DBCO.NBANCO',
       'V',
       '',
       'F',
       'N',
       'F',
       'Cdigo do Banco',
       'Cdigo do Banco',
       'DBCO.CBANCO = LTB.CBANCO',
       'CBANCO',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '01',
       20,
       5,
       'CODAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Agncia',
       'Cdigo da agncia',
       '',
       'CODAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = LTB.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '01',
       40,
       4,
       'CODLOT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo do Lote',
       'Cdigo do Lote',
       '',
       'CODLOT',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '01',
       50,
       12,
       'COD_CC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Conta C.',
       'Cdigo Conta Corrente',
       '',
       'COD_CC',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '01',
       60,
       20,
       'CONVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd. Convnio Banco',
       'Cdigo do Convnio no Banco',
       '',
       'CONVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '02',
       70,
       7,
       'DATCRE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data do Crdito',
       'Data do Crdito',
       '',
       'DATCRE',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '02',
       80,
       7,
       'DATGRA',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Gravao',
       'Data de Gravao Remessa/Retorno',
       '',
       'DATGRA',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '01',
       90,
       2,
       'DIGAGE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dgito da Agncia',
       'Dgito da Agncia',
       '',
       'DIGAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '01',
       100,
       1,
       'DIGA_C',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dgito Agncia Conta',
       'Dgito Agncia Conta',
       '',
       'DIGA_C',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '01',
       110,
       1,
       'DIG_CC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dgito Conta C.',
       'Dgito Conta Corrente',
       '',
       'DIG_CC',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '01',
       120,
       15,
       'DOCEMP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nm. Inscrio Emp.',
       'Nmero Inscrio da Empresa',
       '',
       'DOCEMP',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '99',
       130,
       40,
       'INFOR1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem 1',
       'Mensagem 1',
       '',
       'INFOR1',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '99',
       140,
       40,
       'INFOR2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem 2',
       'Mensagem 2',
       '',
       'INFOR2',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '01',
       150,
       3,
       'LAYLOT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nm.Verso Layout L.',
       'N da Verso do Layout do Lote',
       '',
       'LAYLOT',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '01',
       160,
       30,
       'NOMEMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome da Empresa',
       'Nome da Empresa',
       '',
       'NOMEMP',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '01',
       170,
       8,
       'NUMAVI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nm.Aviso Lanamento',
       'Nmero do Aviso de Lanamento',
       '',
       'NUMAVI',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '03',
       180,
       6,
       'QTDREG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Qtde de Registros',
       'Quantidade de Registros',
       '',
       'QTDREG',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '03',
       190,
       6,
       'QTDTCA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Qtde Tt.Carteira C.',
       'Quantidade de Ttulos em Carteiras Caucionada',
       '',
       'QTDTCA',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '03',
       200,
       6,
       'QTDTCD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Qtde Tt.Cob.Descon.',
       'Quantidade de Ttulos em Cobrana Descontada',
       '',
       'QTDTCD',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '03',
       210,
       6,
       'QTDTCO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Qtde Tt.Cob.Caucio.',
       'Quantidade de Ttulos em Cobrana Caucionada',
       '',
       'QTDTCO',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '03',
       220,
       6,
       'QTDTCS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Qtde Tt.Cob.Simples',
       'Quantidade de Ttulos em Cobrana Simples',
       '',
       'QTDTCS',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '03',
       230,
       6,
       'QTDTCV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Qtde Tt.Cob.Vincul.',
       'Quantidade de Ttulos em Cobrana Vinculada',
       '',
       'QTDTCV',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '99',
       240,
       10,
       'SEQARQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Arquivo',
       '',
       'SEQARQ',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '99',
       250,
       8,
       'SEQRET',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '',
       'Sequenciador do Retorno',
       '',
       'SEQRET',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '99',
       260,
       1,
       'TIPDOC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tipo Documento',
       'Tipo Documento',
       '',
       'TIPDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '03',
       270,
       15,
       'VLRTCD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Val.Tot.Tt.Carteira',
       'Valor Total dosTtulos em Carteiras',
       '',
       'VLRTCD',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '03',
       280,
       15,
       'VLRTCS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Val.Tot.Carteira S.',
       'Valor Total dosTtulos em Carteiras Simples',
       '',
       'VLRTCS',
       'F' FROM DUAL
UNION ALL
SELECT 'LTB ',
       '03',
       290,
       15,
       'VLRTCV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Val.Tot.Carteira V.',
       'Valor Total dos Ttulos em Carteiras Vinculada',
       '',
       'VLRTCV',
       'F' FROM DUAL
);

/*-- SEQ 8671 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LVEN',
       TO_NUMBER(null),
       'LVEN',
       'Log de Vendas',
       'TL_VEN',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'LVEN.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 8672 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LVEN','--','' FROM DUAL
UNION ALL
SELECT 'LVEN','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LVEN','99','Outros' FROM DUAL
);

/*-- SEQ 8673 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 30173,
       'VEN ',
       'LVEN',
       '1',
       'N',
       '',
       '',
       'LVEN.FILVEN = VEN.CODFIL AND
LVEN.SEQVEN = VEN.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 8674 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LVEN',
       '01',
       70,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Ident. de Acesso',
       'Identificao de acesso',
       '',
       'CODUID',
       '' FROM DUAL
UNION ALL
SELECT 'LVEN',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo Usurio',
       'Cdigo Usurio',
       '',
       'CODUSU',
       '' FROM DUAL
UNION ALL
SELECT 'LVEN',
       '01',
       50,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Operao',
       'Data de operao',
       '',
       'DATOPE',
       '' FROM DUAL
UNION ALL
SELECT 'LVEN',
       '01',
       30,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Filial Usuario',
       'Filial Usuario',
       '',
       'FILUSU',
       '' FROM DUAL
UNION ALL
SELECT 'LVEN',
       '01',
       10,
       3,
       'FILVEN',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial de Venda',
       'Filial de venda',
       'DFIL.CODFIL(+)  = LVEN.FILVEN',
       'FILVEN',
       'T' FROM DUAL
UNION ALL
SELECT 'LVEN',
       '01',
       60,
       4000,
       'MSGLOG',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Mensagem de Log',
       'Mensagem de Log',
       '',
       'RTF2TXT(MSGLOG)',
       '' FROM DUAL
UNION ALL
SELECT 'LVEN',
       '01',
       20,
       10,
       'SEQVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sequencia de Venda',
       'Sequencial da venda',
       '',
       'SEQVEN',
       '' FROM DUAL
);

/*-- SEQ 8675 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LWOR',
       TO_NUMBER(null),
       'LWOR',
       'Log Work Flow',
       'TL_WOR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'LWOR.CODFIL,LWOR.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8676 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LWOR','--','' FROM DUAL
);

/*-- SEQ 8677 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 33931,
       'TUID',
       'LWOR',
       '01',
       '0N',
       '',
       '',
       'LWOR.CODUID = TUID.CODUID(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8678 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LWOR',
       '--',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       '0',
       'F',
       'Filial',
       'Cdigo da Filial de Origem do Registro',
       'DFIL.CODFIL = LWOR.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'LWOR',
       '--',
       17,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Identificao do Log',
       'Identificao do Log',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'LWOR',
       '--',
       5,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo usurio',
       'LWOR.FILUSU = USU2.FILUSU(+) AND LWOR.CODUSU= USU2.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'LWOR',
       '--',
       3,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data',
       'Data/Hora',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'LWOR',
       '--',
       4,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Usurio que fez a Alterao',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'LWOR',
       '--',
       6,
       1,
       'FLGMUD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Flag de Mudana',
       'Flag de Mudana',
       '',
       'FLGMUD',
       'T' FROM DUAL
UNION ALL
SELECT 'LWOR',
       '--',
       7,
       4000,
       'MSGLOG',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Mensagem',
       'Indica o que foi alterado',
       '',
       'RTF2TXT(MSGLOG)',
       'F' FROM DUAL
UNION ALL
SELECT 'LWOR',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8679 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'LWOR',
       'FLGMUD',
       0,
       'A',
       'Atributos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LWOR',
       'FLGMUD',
       0,
       'D',
       'Documentao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LWOR',
       'FLGMUD',
       0,
       'R',
       'Reviso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LWOR',
       'FLGMUD',
       0,
       'T',
       'Tarefa',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8680 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LXF ',
       TO_NUMBER(null),
       'LXF ',
       'Limite por Filial',
       'TT_LIMXFIL',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8681 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LXF ','--','' FROM DUAL
UNION ALL
SELECT 'LXF ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LXF ','99','Outros' FROM DUAL
);

/*-- SEQ 8682 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 16043,
       'LIM ',
       'LXF ',
       '0N',
       '0N',
       '',
       '',
       'LXF.FILCLI = LIM.FILCLI and LXF.CODCLI = LIM.CODCLI and LXF.TIPCCC = LIM.TIPCCC',
       '',
       '' FROM DUAL
UNION ALL
SELECT 16044,
       'DCOB',
       'LXF ',
       '0N',
       '0N',
       '',
       '',
       'DCOB.CODTAB = LXF.CODCOB',
       '',
       '' FROM DUAL
);

/*-- SEQ 8683 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'LXF ',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'LXF ',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'LXF ',
       '--',
       30,
       5,
       'CODCOB',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       '',
       'N',
       'F',
       'Portador',
       'Portador',
       'DCOB.CODTAB = LXF.CODCOB',
       'CODCOB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'LXF ',
       '--',
       40,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'LXF ',
       '--',
       50,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'LXF ',
       '--',
       60,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Cliente',
       'Filial Cliente',
       '',
       'FILCLI',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'LXF ',
       '--',
       70,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'LXF ',
       '--',
       80,
       5,
       'TIPCCC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Conta Corrente',
       'Tipo Conta Corrente',
       '',
       'TIPCCC',
       'F',
       'P' FROM DUAL
);

/*-- SEQ 8684 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MABA',
       TO_NUMBER(null),
       'MABA',
       'Mov de Abastecimento',
       'TM_ABA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'MABA.CODFIL,MABA.CODABA    ',
       '' FROM DUAL
);

/*-- SEQ 8685 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MABA','--','' FROM DUAL
UNION ALL
SELECT 'MABA','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MABA','99','Outros' FROM DUAL
);

/*-- SEQ 8686 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 30172,
       'DFIL',
       'MABA',
       '01',
       'N',
       '',
       '',
       'DFIL.CODFIL = MABA.CODFIL',
       '',
       '' FROM DUAL
);

/*-- SEQ 8687 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MABA',
       '01',
       20,
       10,
       'CODABA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Seq. Abastec',
       'Seq. do Abastecimento ',
       '',
       'CODABA',
       '' FROM DUAL
UNION ALL
SELECT 'MABA',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL(+) = MABA.CODFIL',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'MABA',
       '01',
       30,
       1,
       'FLGNEW',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Nova Sit. do Abastec',
       'Nova Sit. do Abastec.',
       '',
       'FLGNEW',
       'T' FROM DUAL
);

/*-- SEQ 8688 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'MABA',
       'FLGNEW',
       0,
       'A',
       'Aferio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MABA',
       'FLGNEW',
       0,
       'B',
       'Bloqueado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MABA',
       'FLGNEW',
       0,
       'C',
       'Emitido CF',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MABA',
       'FLGNEW',
       0,
       'N',
       'Emitida NF',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MABA',
       'FLGNEW',
       0,
       'P',
       'Pendente',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8689 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MAI ',
       TO_NUMBER(null),
       'MAI ',
       'E-mails',
       'TT_MAI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'MAI.CODFIL,MAI.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8690 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MAI ','--','' FROM DUAL
UNION ALL
SELECT 'MAI ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MAI ','99','Outros' FROM DUAL
);

/*-- SEQ 8691 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 5492,
       'CLI ',
       'MAI ',
       '1',
       '0N',
       '',
       '',
       'CLI.FILCLI = MAI.FILCLI AND
CLI.CODCLI = MAI.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 5493,
       'USU ',
       'MAI ',
       '1',
       '0N',
       '',
       '',
       'USU.FILUSU = MAI.FILUSU AND
USU.CODUSU = MAI.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 8692 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MAI ',
       '01',
       10,
       4000,
       'ANEXOS',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Anexo',
       'Anexo',
       '',
       'RTF2TXT(ANEXOS)',
       'F' FROM DUAL
UNION ALL
SELECT 'MAI ',
       '01',
       20,
       300,
       'ASSUNT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Assunto',
       'Assunto do email',
       '',
       'ASSUNT',
       'F' FROM DUAL
UNION ALL
SELECT 'MAI ',
       '01',
       130,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'MAI ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Codigo da filial',
       'DFIL.CODFIL = MAI.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MAI ',
       '01',
       140,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Usurio',
       'Cdigo Usurio',
       'USU2.FILUSU(+) = MAI.FILUSU AND USU2.CODUSU(+) = MAI.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'MAI ',
       '01',
       40,
       7,
       'DATENV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Envio',
       'Data de envio',
       '',
       'DATENV',
       'F' FROM DUAL
UNION ALL
SELECT 'MAI ',
       '01',
       50,
       7,
       'DATSOL',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Soluo',
       'Data da soluo',
       '',
       'DATSOL',
       'F' FROM DUAL
UNION ALL
SELECT 'MAI ',
       '01',
       60,
       1,
       'EXCLUI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Excludo?',
       'Excludo?',
       '',
       'EXCLUI',
       'F' FROM DUAL
UNION ALL
SELECT 'MAI ',
       '01',
       150,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'MAI ',
       '01',
       160,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'MAI ',
       '01',
       70,
       4000,
       'MAI_CB',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Copia Carbono',
       'Mail Copy Carbon',
       '',
       'RTF2TXT(MAI_CB)',
       'F' FROM DUAL
UNION ALL
SELECT 'MAI ',
       '01',
       80,
       4000,
       'MAI_CC',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Copia',
       'Mail Copy',
       '',
       'RTF2TXT(MAI_CC)',
       'F' FROM DUAL
UNION ALL
SELECT 'MAI ',
       '01',
       90,
       4000,
       'MAI_FR',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Para',
       'Mail From',
       '',
       'RTF2TXT(MAI_FR)',
       'F' FROM DUAL
UNION ALL
SELECT 'MAI ',
       '01',
       100,
       4000,
       'MAI_TO',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'De',
       'E-Mail Para',
       '',
       'RTF2TXT(MAI_TO)',
       'F' FROM DUAL
UNION ALL
SELECT 'MAI ',
       '01',
       110,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'MAI ',
       '01',
       120,
       4000,
       'TEXTOS',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Corpo Email',
       'Corpo do email',
       '',
       'RTF2TXT(TEXTOS)',
       'F' FROM DUAL
UNION ALL
SELECT 'MAI ',
       '01',
       170,
       1,
       'TIPMSG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Mensagem',
       'Tipo Mensagem',
       '',
       'TIPMSG',
       'T' FROM DUAL
);

/*-- SEQ 8693 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'MAI ',
       'TIPMSG',
       0,
       'R',
       'RTF',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MAI ',
       'TIPMSG',
       0,
       'T',
       'Texto',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8694 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MAR ',
       0,
       'MAR ',
       'Produtores',
       'TV_MAR',
       'T',
       '',
       'TOTALL',
       'Marcas',
       '',
       '',
       '',
       '',
       'F',
       '',
       'MAR.FILCLI,MAR.CODCLI
MAR.NOMCLI,MAR.ULTNOM
MAR.NUMDOC
',
       '' FROM DUAL
);

/*-- SEQ 8695 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MAR ','--','' FROM DUAL
UNION ALL
SELECT 'MAR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MAR ','02','Endereo' FROM DUAL
UNION ALL
SELECT 'MAR ','03','Documentao' FROM DUAL
UNION ALL
SELECT 'MAR ','04','Dados Financeiros' FROM DUAL
UNION ALL
SELECT 'MAR ','99','Outros' FROM DUAL
);

/*-- SEQ 8696 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21688,
       'EDE ',
       'MAR ',
       'N',
       '1',
       '',
       '',
       'EDE.FILCLI = MAR.FILCLI AND
EDE.CODCLI = MAR.CODCLI
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21689,
       'CON ',
       'MAR ',
       '0N',
       '01',
       '',
       '',
       'CON.FILCLI = MAR.FILCLI (+) and
CON.CODCLI = MAR.CODCLI (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21690,
       'SPC ',
       'MAR ',
       '01',
       '01',
       '',
       'MAR.FLGTIP = 1',
       'SPC.FILCLI = MAR.FILCLI (+) and
SPC.CODCLI = MAR.CODCLI (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21691,
       'REL ',
       'MAR ',
       'N',
       '1',
       '',
       '',
       'REL.FILPAR = MAR.FILPAR AND
REL.CODPAR = MAR.CODPAR AND
REL.TIPPAR = MAR.TIPPAR',
       '',
       '' FROM DUAL
);

/*-- SEQ 8697 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MAR ',
       '01',
       250,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'MAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(MAR.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '99',
       450,
       4,
       'ANO_DATA01',
       'A',
       '',
       0,
       0,
       'MAR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 1',
       '',
       'TO_CHAR(MAR.DATA01,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '99',
       480,
       4,
       'ANO_DATA02',
       'A',
       '',
       0,
       0,
       'MAR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 2',
       '',
       'TO_CHAR(MAR.DATA02,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '99',
       510,
       4,
       'ANO_DATA03',
       'A',
       '',
       0,
       0,
       'MAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 3',
       '',
       'TO_CHAR(MAR.DATA03,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       280,
       4,
       'ANO_DATNAS',
       'A',
       '',
       0,
       0,
       'MAR ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       '',
       'N',
       'T',
       'Ano de Nascimento/Fu',
       'Ano de Data de nascimento ou fundao',
       '',
       'TO_CHAR(MAR.DATNAS,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       310,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       0,
       'MAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       '',
       'N',
       'T',
       'Ano de Data Incluso',
       'Ano de Data de operao (cadastramento)',
       '',
       'TO_CHAR(MAR.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '04',
       390,
       4,
       'ANO_ULTCOM',
       'A',
       '',
       0,
       0,
       'MAR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       '',
       'N',
       'T',
       'Ano de ltima Compra',
       'Ano de Data da ltima compra',
       '',
       'TO_CHAR(MAR.ULTCOM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '99',
       541,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN MAR.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       230,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'MAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '99',
       400,
       2,
       'CATEG1',
       'S',
       'DCT1',
       0,
       20,
       'MAR ',
       10,
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'V',
       'MAR',
       'F',
       'A',
       'T',
       '',
       'Categoria - 1',
       'MAR.CATEG1=DCT1.CODTAB (+)',
       'CATEG1',
       'T' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '99',
       410,
       2,
       'CATEG2',
       'S',
       'DCT2',
       0,
       21,
       'MAR ',
       20,
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'V',
       'MAR',
       'F',
       'A',
       'T',
       '',
       'Categoria - 2',
       'MAR.CATEG2=DCT2.CODTAB (+)',
       'CATEG2',
       'T' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '99',
       420,
       2,
       'CATEG3',
       'S',
       'DCT3',
       0,
       22,
       'MAR ',
       30,
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'V',
       'MAR',
       'F',
       'A',
       'T',
       'TIPO',
       'Categoria - 3',
       'MAR.CATEG3=DCT3.CODTAB (+)',
       'CATEG3',
       'T' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       200,
       9,
       'CHAVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Marca',
       'Cdigo da Marca',
       '',
       'FILCLI||MAR.CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       190,
       6,
       'CODCLI',
       'A',
       '',
       0,
       0,
       'MAR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       'F',
       '9',
       'T',
       'Cdigo',
       'Cdigo da marca',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       20,
       6,
       'CODPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Parceiro',
       'Cdigo do Parceiro',
       '',
       'CODPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       110,
       3,
       'CODPLA',
       'A',
       'PLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Plano padro',
       'Cdigo do plano padro',
       'MAR.FILPLA=PLA.FILPGT (+) AND MAR.CODPLA=PLA.CODPGT (+)',
       'CODPLA',
       'T' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       60,
       2,
       'CODSEX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Sexo',
       'Cdigo de Sexo do parceiro',
       '',
       'CODSEX',
       'T' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       170,
       3,
       'CODVEN',
       'A',
       'VDD ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'VDD.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Vendedor Padro',
       'Vendedor Padro',
       'MAR.FILVEN = VDD.FILUSU (+)  AND MAR.CODVEN = VDD.CODUSU (+)',
       'CODVEN',
       'T' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       130,
       44,
       'CONJUG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cnjuge ou Contato',
       'Nome do Cnjuge ou do Contato principal',
       '',
       'CONJUG',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '99',
       430,
       8,
       'DATA01',
       'D',
       '',
       0,
       0,
       'MAR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       'F',
       'D',
       'T',
       '',
       'Data livre - 1',
       '',
       'DATA01',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '99',
       460,
       8,
       'DATA02',
       'D',
       '',
       0,
       0,
       'MAR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       'F',
       'D',
       'T',
       '',
       'Data livre - 2',
       '',
       'DATA02',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '99',
       490,
       8,
       'DATA03',
       'D',
       '',
       0,
       0,
       'MAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       'F',
       'D',
       'T',
       '',
       'Data livre - 3',
       '',
       'DATA03',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       260,
       8,
       'DATNAS',
       'D',
       '',
       0,
       0,
       'MAR ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       'F',
       'D',
       'T',
       'Nascimento/Fundao',
       'Data de nascimento ou fundao',
       '',
       'DATNAS',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       290,
       8,
       'DATOPE',
       'D',
       '',
       0,
       0,
       'MAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       'F',
       'D',
       'T',
       'Data Incluso',
       'Data de operao (cadastramento)',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       40,
       15,
       'DOCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Doc. Cnjuge/Contato',
       'Doc. Cnjuge/Contato',
       '',
       'DOCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       50,
       2,
       'ESTCIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Estado Civil',
       'Estado Civil',
       '',
       'ESTCIV',
       'T' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       180,
       3,
       'FILCLI',
       'A',
       '',
       0,
       0,
       'MAR ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       'F',
       'N',
       'T',
       '',
       'Filial onde foi cadastrado a marca',
       '',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       10,
       3,
       'FILPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Parceiro',
       '',
       'FILPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       100,
       3,
       'FILPLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial do Plano',
       'Filial do Plano',
       '',
       'FILPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       160,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Vendedor',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '03',
       340,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       0,
       'MAR ',
       20,
       30,
       '',
       '',
       'D',
       'MAR',
       'F',
       'A',
       'T',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '02',
       320,
       40,
       'HOMPGE',
       'A',
       '',
       0,
       0,
       'MAR ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'MAR',
       'F',
       'A',
       'T',
       'Home Page',
       'Home Page da marca',
       '',
       'HOMPGE',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '99',
       520,
       2,
       'IMPRIM',
       'S',
       '',
       0,
       0,
       'MAR ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       'F',
       '',
       'F',
       'Nm. Impresses',
       'Nm. Impresses',
       '',
       'IMPRIM',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '03',
       350,
       15,
       'INSEST',
       'A',
       '',
       0,
       4,
       'MAR ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'MAR',
       'F',
       'A',
       'T',
       '2 Documento',
       'Inscrio Estadual ou Identidade',
       '',
       'INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       90,
       2,
       'MAIATR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Maior atraso',
       'Maior atraso registrado',
       '',
       'MAIATR',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       240,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'MAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(MAR.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '99',
       440,
       2,
       'MES_DATA01',
       'A',
       '',
       0,
       0,
       'MAR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 1',
       '',
       'TO_CHAR(MAR.DATA01,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '99',
       470,
       2,
       'MES_DATA02',
       'A',
       '',
       0,
       0,
       'MAR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 2',
       '',
       'TO_CHAR(MAR.DATA02,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '99',
       500,
       2,
       'MES_DATA03',
       'A',
       '',
       0,
       0,
       'MAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 3',
       '',
       'TO_CHAR(MAR.DATA03,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       270,
       2,
       'MES_DATNAS',
       'A',
       '',
       0,
       0,
       'MAR ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       '',
       'N',
       'T',
       'Ms de Nascimento/Fu',
       'Ms de Data de nascimento ou fundao',
       '',
       'TO_CHAR(MAR.DATNAS,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       300,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       0,
       'MAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       '',
       'N',
       'T',
       'Ms de Data Incluso',
       'Ms de Data de operao (cadastramento)',
       '',
       'TO_CHAR(MAR.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '04',
       380,
       2,
       'MES_ULTCOM',
       'A',
       '',
       0,
       0,
       'MAR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       '',
       'N',
       'T',
       'Ms de ltima Compra',
       'Ms de Data da ltima compra',
       '',
       'TO_CHAR(MAR.ULTCOM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       140,
       7,
       'NASCON',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Nascimento do Cnjug',
       'Nascimento do Cnjuge',
       '',
       'NASCON',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       210,
       44,
       'NOMCLI',
       'A',
       '',
       0,
       0,
       'MAR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'MAR',
       'F',
       'A',
       'T',
       'Razo Social',
       'Razo social da Marca',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '03',
       330,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       3,
       'MAR ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'MAR',
       'F',
       'A',
       'T',
       'Documento',
       'Nmero do Documento: CGC ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '99',
       530,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'MAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'MAR',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(MAR.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       120,
       2,
       'PORPAD',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       'F',
       'A',
       'F',
       'Portador Padro',
       'Portador padro',
       'MAR.PORPAD=DCOB.CODTAB (+)',
       'PORPAD',
       'T' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '99',
       550,
       1,
       'PP_FLG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag Prospeco',
       'Flag de Prospeco sim ou no',
       '',
       'PP_FLG',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       150,
       2,
       'SEXCON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Sexo do Contato',
       'Sexo',
       '',
       'SEXCON',
       'T' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '99',
       540,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'MAR ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'MAR',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN MAR.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       30,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Parceiro',
       'Tipo de Parceiro',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       70,
       4,
       'TOTATR',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Total Atrasos',
       'Total de atrasos na vida do parceiro',
       '',
       'TOTATR',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       80,
       4,
       'TOTPAR',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Total de Parcelas',
       'Total de parcelas na vida do parceiro',
       '',
       'TOTPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '04',
       370,
       8,
       'ULTCOM',
       'D',
       '',
       0,
       0,
       'MAR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       'F',
       'D',
       'T',
       'ltima Compra',
       'Data da ltima compra',
       '',
       'ULTCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '01',
       220,
       20,
       'ULTNOM',
       'A',
       '',
       0,
       0,
       'MAR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'MAR',
       'F',
       'A',
       'T',
       'Fantasia',
       'Nome Fantasia da marca',
       '',
       'ULTNOM',
       'F' FROM DUAL
UNION ALL
SELECT 'MAR ',
       '04',
       360,
       8,
       'VALOR1',
       'F',
       '',
       2,
       0,
       'MAR ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MAR',
       'T',
       '',
       'T',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'VALOR1',
       'F' FROM DUAL
);

/*-- SEQ 8698 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'MAR ',
       'CODSEX',
       1,
       '-',
       'Masculino',
       145,
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'CODSEX',
       2,
       '-',
       'Feminino',
       146,
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'CODSEX',
       0,
       '-',
       'Nao conhecido',
       144,
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'ESTCIV',
       3,
       '-',
       'Vivo',
       150,
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'ESTCIV',
       5,
       '-',
       'Unio Estvel',
       152,
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'ESTCIV',
       6,
       '-',
       'Separado',
       153,
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'ESTCIV',
       0,
       '-',
       'Indefinido',
       147,
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'ESTCIV',
       4,
       '-',
       'Divorciado',
       151,
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'ESTCIV',
       1,
       '-',
       'Solteiro',
       148,
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'ESTCIV',
       2,
       '-',
       'Casado',
       149,
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'FLGTIP',
       5,
       ' ',
       'Filial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'FLGTIP',
       0,
       ' ',
       'Fsica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'FLGTIP',
       1,
       ' ',
       'Jurdica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'FLGTIP',
       2,
       ' ',
       'Entidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'FLGTIP',
       3,
       ' ',
       'Especial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'FLGTIP',
       4,
       ' ',
       'M.E.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'SEXCON',
       0,
       '-',
       'Masculino',
       131,
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'SEXCON',
       1,
       '-',
       'Feminino',
       132,
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'TIPPAR',
       0,
       'A',
       'Cliente Transportadora',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'TIPPAR',
       0,
       'C',
       'Cartes',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'TIPPAR',
       0,
       'F',
       'Fornecedor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'TIPPAR',
       0,
       'I',
       'Indicador Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'TIPPAR',
       0,
       'M',
       'Marca',
       267,
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'TIPPAR',
       0,
       'N',
       'Tec. Interno',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'TIPPAR',
       0,
       'O',
       'Motorista',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'TIPPAR',
       0,
       'R',
       'Representante',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'TIPPAR',
       0,
       'T',
       'Transportador',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MAR ',
       'TIPPAR',
       0,
       'X',
       'Tcnico Externo',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8699 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MASS',
       TO_NUMBER(null),
       'MASS',
       'AssinaturasPendentes',
       'TM_ASS',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8700 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MASS','--','' FROM DUAL
UNION ALL
SELECT 'MASS','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MASS','99','Outros' FROM DUAL
);

/*-- SEQ 8701 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MASS',
       '--',
       51,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Assinatura do PAF-ECF',
       '',
       'ASSINA',
       'F' FROM DUAL
UNION ALL
SELECT 'MASS',
       '--',
       41,
       12,
       'CODUID',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Cdigo do Acesso',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'MASS',
       '--',
       30,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'MASS',
       '--',
       11,
       10,
       'MASSID',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Identificador nico',
       'Identificador nico',
       '',
       'MASSID',
       'F' FROM DUAL
UNION ALL
SELECT 'MASS',
       '--',
       21,
       6,
       'TABELA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tabela',
       'Tabela',
       '',
       'TABELA',
       'F' FROM DUAL
);

/*-- SEQ 8702 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'MASS',
       'FLGEST',
       0,
       'N',
       'No processado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MASS',
       'FLGEST',
       0,
       'P',
       'Em Processamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8703 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MATU',
       TO_NUMBER(null),
       'MATU',
       'Atu. Reg. Principal',
       'TM_ATU',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8704 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MATU','--','' FROM DUAL
UNION ALL
SELECT 'MATU','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MATU','99','Outros' FROM DUAL
);

/*-- SEQ 8705 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MATU',
       '99',
       10,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'MATU',
       '01',
       20,
       4000,
       'FILTRO',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filtro',
       'Filtro a ser aplicado na atualizao da Tabela',
       '',
       'FILTRO',
       'F' FROM DUAL
UNION ALL
SELECT 'MATU',
       '99',
       30,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'MATU',
       '01',
       40,
       10,
       'ID',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Chave',
       'Chave',
       '',
       'ID',
       'F' FROM DUAL
UNION ALL
SELECT 'MATU',
       '01',
       50,
       30,
       'NOMTAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tabela de Destino',
       'Nome da Tabela de Destino',
       '',
       'NOMTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'MATU',
       '99',
       60,
       30,
       'ORITAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Tabela de Origem',
       'Nome da Tabela de Origem',
       '',
       'ORITAB',
       '' FROM DUAL
UNION ALL
SELECT 'MATU',
       '99',
       70,
       10,
       'USERID',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Identificao de Acesso',
       '',
       'USERID',
       'F' FROM DUAL
);

/*-- SEQ 8706 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'MATU',
       'FLGEST',
       0,
       'N',
       'No Processado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MATU',
       'FLGEST',
       0,
       'P',
       'Em Processamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8707 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MCF ',
       TO_NUMBER(null),
       'MCF ',
       'MFD CF reg tipo E14',
       'TT_MCF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'MCF.CODFIL, MCF.NUMECF, MCF.NUMCOO, MCF.DATEMI',
       '' FROM DUAL
);

/*-- SEQ 8708 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MCF ','--','' FROM DUAL
UNION ALL
SELECT 'MCF ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MCF ','99','Outros' FROM DUAL
);

/*-- SEQ 8709 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MCF ',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = MCF.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MCF ',
       '--',
       20,
       7,
       'DATEMI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Emisso',
       'Data de incio da emisso',
       '',
       'DATEMI',
       'F' FROM DUAL
UNION ALL
SELECT 'MCF ',
       '--',
       30,
       1,
       'FLGACR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Acrscimo',
       'Indicador do tipo de acrscimo sobre subtotal Informar "V" para valor mo',
       '',
       'FLGACR',
       'T' FROM DUAL
UNION ALL
SELECT 'MCF ',
       '--',
       40,
       1,
       'FLGCAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Cancelado',
       'Indicador de cancelamento Informar "S" ou "N", conforme tenha ocorrido o',
       '',
       'FLGCAN',
       'F' FROM DUAL
UNION ALL
SELECT 'MCF ',
       '--',
       50,
       1,
       'FLGDES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Desconto',
       'Indicador do tipo de desconto sobre subtotal Informar "V" para valor mon',
       '',
       'FLGDES',
       'T' FROM DUAL
UNION ALL
SELECT 'MCF ',
       '--',
       170,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'MCF ',
       '--',
       180,
       4000,
       'MSGLOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Log. Operao',
       'Informaes detalhadas do fechamento da venda',
       '',
       'MSGLOG',
       '' FROM DUAL
UNION ALL
SELECT 'MCF ',
       '--',
       60,
       40,
       'NOMECLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cliente',
       'Nome do adquirente das mercadorias ou servios (consumidor).',
       '',
       'NOMECLI',
       'F' FROM DUAL
UNION ALL
SELECT 'MCF ',
       '--',
       70,
       6,
       'NUMCCF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'CCF/CVC/CBP',
       'CCF, CVC ou CBP, conforme o documento emitido',
       '',
       'NUMCCF',
       'F' FROM DUAL
UNION ALL
SELECT 'MCF ',
       '--',
       80,
       6,
       'NUMCOO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'COO',
       'COO (Contador de Ordem de Operao)',
       '',
       'NUMCOO',
       'F' FROM DUAL
UNION ALL
SELECT 'MCF ',
       '--',
       90,
       14,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'CPF/CNPJ',
       'CPF ou CNPJ do adquirente das mercadorias ou servios (consumidor) (some',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'MCF ',
       '--',
       100,
       3,
       'NUMECF',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       'F',
       'Nmero do ECF',
       'Nmero do ECF',
       'DECF.FILECF = MCF.CODFIL AND DECF.NUMECF = MCF.NUMECF',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'MCF ',
       '--',
       110,
       1,
       'ORDDESACR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Ordem Aplic. Desc.',
       'Indicador de ordem de aplicao de desconto e acrscimo em subtotal.',
       '',
       'ORDDESACR',
       'T' FROM DUAL
UNION ALL
SELECT 'MCF ',
       '--',
       120,
       13,
       'VLRACR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Acrscimo',
       'Valor do acrscimo ou percentual aplicado sobre o valor do subtotal do d',
       '',
       'VLRACR',
       'F' FROM DUAL
UNION ALL
SELECT 'MCF ',
       '--',
       130,
       13,
       'VLRCANACR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Cancelamento Acresc.',
       'Valor do cancelamento de acrscimo no subtotal',
       '',
       'VLRCANACR',
       'F' FROM DUAL
UNION ALL
SELECT 'MCF ',
       '--',
       140,
       13,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Desconto',
       'Valor do desconto ou percentual aplicado sobre o valor do subtotal do do',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'MCF ',
       '--',
       150,
       14,
       'VLRSUBTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Subtotal',
       'Subtotal do documento',
       '',
       'VLRSUBTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'MCF ',
       '--',
       160,
       14,
       'VLRTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Total',
       'Valor total do Cupom Fiscal aps desconto/acrscimo.',
       '',
       'VLRTOT',
       'F' FROM DUAL
);

/*-- SEQ 8710 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'MCF ',
       'FLGACR',
       0,
       'P',
       'Percentual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MCF ',
       'FLGACR',
       0,
       'V',
       'Valor Monetrio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MCF ',
       'FLGDES',
       0,
       'P',
       'Percentual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MCF ',
       'FLGDES',
       0,
       'V',
       'Valor Monetrio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MCF ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MCF ',
       'FLGEST',
       0,
       'C',
       'Processado com Correes',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MCF ',
       'FLGEST',
       0,
       'I',
       'Inconsistente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MCF ',
       'FLGEST',
       0,
       'P',
       'Processado sem Correes',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MCF ',
       'ORDDESACR',
       0,
       'A',
       'Acrscimo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MCF ',
       'ORDDESACR',
       0,
       'D',
       'Desconto',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8711 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MCLI',
       TO_NUMBER(null),
       'MCLI',
       'Movimentao Cliente',
       'TM_CLI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'MCLI.CODFIL,MCLI.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8712 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MCLI','--','' FROM DUAL
);

/*-- SEQ 8713 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5653,
       'USU ',
       'MCLI',
       '1 ',
       '0N',
       '',
       '',
       'USU.FILUSU = MCLI.FILUSU AND
USU.CODUSU = MCLI.CODUSU',
       '' FROM DUAL
);

/*-- SEQ 8714 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MCLI',
       '--',
       8,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'MCLI',
       '--',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       '0',
       'F',
       'Filial',
       'Cdigo da Filial de Origem do Registro',
       'DFIL.CODFIL = MCLI.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MCLI',
       '--',
       4,
       6,
       'CODOLD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Antigo',
       'Cdigo Antigo',
       '',
       'CODOLD',
       'F' FROM DUAL
UNION ALL
SELECT 'MCLI',
       '--',
       13,
       3,
       'CODOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da operao',
       'Cdigo da operao',
       '',
       'CODOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'MCLI',
       '--',
       10,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'MCLI.FILUSU = USU.FILUSU(+)  AND MCLI.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'MCLI',
       '--',
       11,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data e Hora',
       'Data e Hora',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'MCLI',
       '--',
       14,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Operao',
       'Data de Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'MCLI',
       '--',
       7,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'MCLI',
       '--',
       3,
       3,
       'FILOLD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Antiga',
       '',
       'FILOLD',
       'F' FROM DUAL
UNION ALL
SELECT 'MCLI',
       '--',
       12,
       3,
       'FILOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Operao',
       'Filial Operao',
       '',
       'FILOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'MCLI',
       '--',
       9,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Usurio que fez a Alterao',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'MCLI',
       '--',
       15,
       2000,
       'MSGERR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem de erro',
       'Mensagem de erro',
       '',
       'MSGERR',
       'F' FROM DUAL
UNION ALL
SELECT 'MCLI',
       '--',
       5,
       64,
       'NOMOLD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Antiga',
       'Filial Antiga',
       '',
       'NOMOLD',
       'F' FROM DUAL
UNION ALL
SELECT 'MCLI',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'MCLI',
       '--',
       6,
       30,
       'ULTOLD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sobrenome Antigo',
       'Sobrenome Antigo',
       '',
       'ULTOLD',
       'F' FROM DUAL
);

/*-- SEQ 8715 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MDT ',
       TO_NUMBER(null),
       'MDT ',
       'Medio de Tanque',
       'TT_MDT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8716 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MDT ','--','' FROM DUAL
UNION ALL
SELECT 'MDT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MDT ','99','Outros' FROM DUAL
);

/*-- SEQ 8717 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MDT ',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'ltima~Atualizao',
       'ltima Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'MDT ',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = MDT.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'MDT ',
       '--',
       30,
       3,
       'CODLEI',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Usurio~Leitura',
       'Cdigo Usurio da Leitura',
       'MDT.FILLEI = USU.FILUSU(+)  AND MDT.CODLEI = USU.CODUSU(+)',
       'CODLEI',
       'T' FROM DUAL
UNION ALL
SELECT 'MDT ',
       '--',
       40,
       3,
       'CODREG',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Usurio~Registro',
       'Cdigo Usurio do Registro',
       'MDT.FILREG = USU.FILUSU(+)  AND MDT.CODREG = USU.CODUSU(+)',
       'CODREG',
       'F' FROM DUAL
UNION ALL
SELECT 'MDT ',
       '--',
       50,
       7,
       'DATLEI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Leitura',
       'Data Leitura',
       '',
       'DATLEI',
       'F' FROM DUAL
UNION ALL
SELECT 'MDT ',
       '--',
       60,
       7,
       'DATMED',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Medio',
       'Data Medio',
       '',
       'DATMED',
       'F' FROM DUAL
UNION ALL
SELECT 'MDT ',
       '--',
       70,
       7,
       'DATREG',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Registro',
       'Data Registro',
       '',
       'DATREG',
       'F' FROM DUAL
UNION ALL
SELECT 'MDT ',
       '--',
       80,
       3,
       'FILLEI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial~Leitura',
       'Filial Usurio da Leitura',
       '',
       'FILLEI',
       'F' FROM DUAL
UNION ALL
SELECT 'MDT ',
       '--',
       90,
       3,
       'FILREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial~Registro',
       'Filial Usurio do Registro',
       '',
       'FILREG',
       'F' FROM DUAL
UNION ALL
SELECT 'MDT ',
       '--',
       100,
       5,
       'NUMTAN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero~Tanque',
       'Nmero Tanque',
       '',
       'NUMTAN',
       'F' FROM DUAL
UNION ALL
SELECT 'MDT ',
       '--',
       120,
       14,
       'PREBOM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Preo~Bomba',
       'Preo na Bomba',
       '',
       'PREBOM',
       'F' FROM DUAL
UNION ALL
SELECT 'MDT ',
       '--',
       110,
       10,
       'QTDLTS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade~Litros',
       'Quantidade Litros',
       '',
       'QTDLTS',
       'F' FROM DUAL
);

/*-- SEQ 8718 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MEND',
       TO_NUMBER(null),
       'MEND',
       'Mov. Endereo',
       'TM_END',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'MEND.CODFIL,MEND.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8719 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MEND','--','' FROM DUAL
);

/*-- SEQ 8720 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MEND',
       '--',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = MEDE.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MEND',
       '--',
       5,
       3,
       'FILEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Endereo',
       '',
       'FILEND',
       'F' FROM DUAL
UNION ALL
SELECT 'MEND',
       '--',
       3,
       3,
       'FILOLD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Antiga',
       '',
       'FILOLD',
       'F' FROM DUAL
UNION ALL
SELECT 'MEND',
       '--',
       6,
       4,
       'NUMEND',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero Endereo',
       'Nmero Endereo',
       '',
       'NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT 'MEND',
       '--',
       4,
       4,
       'NUMOLD',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero End. Antigo',
       'Nmero Endereo Antigo',
       '',
       'NUMOLD',
       'F' FROM DUAL
UNION ALL
SELECT 'MEND',
       '--',
       7,
       512,
       'RESUMO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Resumo',
       'Resumo',
       '',
       'RESUMO',
       'F' FROM DUAL
UNION ALL
SELECT 'MEND',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8721 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MER ',
       TO_NUMBER(null),
       'MER ',
       'Merc. em Adies DI',
       'TT_MER',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8722 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MER ','--','' FROM DUAL
UNION ALL
SELECT 'MER ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MER ','99','Outros' FROM DUAL
);

/*-- SEQ 8723 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 24498,
       'ADI ',
       'MER ',
       '1',
       '0N',
       '',
       '',
       'ADI.CODFIL = MER.CODFIL(+) AND
ADI.SEQUEN = MER.SEQUEN(+) AND
ADI.NUMITE = MER.NUMITE(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 24502,
       'GRA ',
       'MER ',
       '01',
       '0N',
       '',
       '',
       'GRA.FILMAT = MER.FILMAT(+) AND
GRA.CODMAT = MER.CODMAT(+) AND
GRA.CODCOR = MER.CODCOR(+) AND
GRA.CODTAM = MER.CODTAM(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8724 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MER ',
       '99',
       110,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       '',
       'N',
       'F',
       'Diviso',
       'Diviso do material',
       'DIV.CODITE = MER.CODCOR(+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'MER ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = MER.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MER ',
       '99',
       100,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do material',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'MER ',
       '99',
       120,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       '',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do material',
       'SUB.CODITE = MER.CODTAM(+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'MER ',
       '99',
       20,
       4000,
       'DESMER',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'DESMER',
       'F' FROM DUAL
UNION ALL
SELECT 'MER ',
       '99',
       90,
       3,
       'FILMAT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial do material',
       'Filial do material',
       'DFIL.CODFIL = MER.FILMAT(+)',
       'FILMAT',
       'T' FROM DUAL
UNION ALL
SELECT 'MER ',
       '01',
       30,
       3,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Item da Adio',
       'Item da Adio',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'MER ',
       '99',
       150,
       12,
       'PESLIQ',
       'F',
       '',
       3,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Peso Lquido',
       'Peso Lquido',
       '',
       'PESLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'MER ',
       '99',
       40,
       12,
       'QTDMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade',
       'Quantidade',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'MER ',
       '99',
       130,
       12,
       'QTDORI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade DI',
       'Quantidade Original na DI',
       '',
       'QTDORI',
       'F' FROM DUAL
UNION ALL
SELECT 'MER ',
       '01',
       50,
       3,
       'SEQMER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Nmero Sequencial',
       'Nmero Sequencial',
       '',
       'SEQMER',
       'F' FROM DUAL
UNION ALL
SELECT 'MER ',
       '01',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'MER ',
       '99',
       70,
       20,
       'UNIDAD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Unidade',
       'Descrio da Unidade de Medida',
       '',
       'UNIDAD',
       'F' FROM DUAL
UNION ALL
SELECT 'MER ',
       '99',
       140,
       12,
       'VLRANT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Anti dumping BRL',
       'Valor Anti dumping em Reais',
       '',
       'VLRANT',
       'F' FROM DUAL
UNION ALL
SELECT 'MER ',
       '99',
       80,
       12,
       'VLRUNI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Unitrio USD',
       'Valor Unitrio em Dlares',
       '',
       'VLRUNI',
       'F' FROM DUAL
);

/*-- SEQ 8725 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MES ',
       TO_NUMBER(null),
       'MES ',
       'Mesorregio IBGE',
       'TT_MES',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8726 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MES ','--','' FROM DUAL
UNION ALL
SELECT 'MES ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MES ','99','Outros' FROM DUAL
);

/*-- SEQ 8727 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MES ',
       '01',
       10,
       10,
       'CODMES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo Mesorregio',
       'Cdigo da Mesorregio',
       '',
       'CODMES',
       '' FROM DUAL
UNION ALL
SELECT 'MES ',
       '01',
       20,
       50,
       'NOMMES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nome Mesorregio',
       'Nome da Mesorregio',
       '',
       'NOMMES',
       'F' FROM DUAL
UNION ALL
SELECT 'MES ',
       '01',
       30,
       2,
       'SIGEST',
       'A',
       'DEST',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEST.ESTADO',
       'V',
       '',
       '',
       'A',
       'F',
       'Estado Mesorregio',
       'Estado da Mesorregio',
       'DEST.ESTADO = MES.SIGEST',
       'SIGEST',
       'F' FROM DUAL
);

/*-- SEQ 8728 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MET ',
       TO_NUMBER(null),
       'MET ',
       'Meta de Vendas',
       'TT_MET',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'MET.CODFIL,MET.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8729 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MET ','--','' FROM DUAL
);

/*-- SEQ 8730 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5655,
       'USU ',
       'MET ',
       '01',
       '0N',
       '',
       '',
       'USU.FILUSU = MET.FILUSU AND
USU.CODUSU = MET.CODUSU',
       '' FROM DUAL
);

/*-- SEQ 8731 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MET ',
       '--',
       1,
       4,
       'ANOREF',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Ano',
       'Ano',
       '',
       'ANOREF',
       'F' FROM DUAL
UNION ALL
SELECT 'MET ',
       '--',
       2,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Vendedor',
       'Vendedor',
       'MET.FILUSU = USU.FILUSU(+) AND MET.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'MET ',
       '--',
       3,
       12,
       'COMIS1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '1 Prmio',
       '1 Prmio',
       '',
       'COMIS1',
       'F' FROM DUAL
UNION ALL
SELECT 'MET ',
       '--',
       4,
       12,
       'COMIS2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '2 Prmio',
       '2 Prmio',
       '',
       'COMIS2',
       'F' FROM DUAL
UNION ALL
SELECT 'MET ',
       '--',
       5,
       12,
       'COMIS3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '3 Prmio',
       '3 Prmio',
       '',
       'COMIS3',
       'F' FROM DUAL
UNION ALL
SELECT 'MET ',
       '--',
       6,
       12,
       'COMIS4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '4 Prmio',
       '4 Prmio',
       '',
       'COMIS4',
       'F' FROM DUAL
UNION ALL
SELECT 'MET ',
       '--',
       7,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial~Vendedor',
       'Filial Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'MET ',
       '--',
       8,
       2,
       'MESREF',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Ms',
       'Ms',
       '',
       'MESREF',
       'F' FROM DUAL
UNION ALL
SELECT 'MET ',
       '--',
       9,
       12,
       'VALOR1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '1 Meta',
       '1 Meta',
       '',
       'VALOR1',
       'F' FROM DUAL
UNION ALL
SELECT 'MET ',
       '--',
       10,
       12,
       'VALOR2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '2 Meta',
       '2 Meta',
       '',
       'VALOR2',
       'F' FROM DUAL
UNION ALL
SELECT 'MET ',
       '--',
       11,
       12,
       'VALOR3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '3 Meta',
       '3 Meta',
       '',
       'VALOR3',
       'F' FROM DUAL
UNION ALL
SELECT 'MET ',
       '--',
       12,
       12,
       'VALOR4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '4 Meta',
       '4 Meta',
       '',
       'VALOR4',
       'F' FROM DUAL
);

/*-- SEQ 8732 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MFEC',
       TO_NUMBER(null),
       'MFEC',
       'Diferenas Reduco Z',
       'TM_FEC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8733 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MFEC','--','' FROM DUAL
UNION ALL
SELECT 'MFEC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MFEC','99','Outros' FROM DUAL
);

/*-- SEQ 8734 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MFEC',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL=MFEC.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MFEC',
       '--',
       20,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data da Operao',
       'Data da Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'MFEC',
       '--',
       30,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'MFEC',
       '--',
       40,
       3,
       'NUMECF',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       'F',
       'Nmero do ECF',
       'Nmero do ECF',
       'DECF.FILECF = MFEC.CODFIL AND DECF.NUMECF = MFEC.NUMECF',
       'NUMECF',
       'F' FROM DUAL
);

/*-- SEQ 8735 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'MFEC',
       'FLGEST',
       0,
       'A',
       'Aguardando',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MFEC',
       'FLGEST',
       0,
       'G',
       'Gerado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MFEC',
       'FLGEST',
       0,
       'N',
       'No Computado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MFEC',
       'FLGEST',
       0,
       'P',
       'Processado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8736 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MGRA',
       TO_NUMBER(null),
       'MGRA',
       'Movimentao Produto',
       'TM_GRA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'MGRA.CODFIL,MGRA.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8737 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MGRA','--','' FROM DUAL
);

/*-- SEQ 8738 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5656,
       'USU ',
       'MGRA',
       '1 ',
       '0N',
       '',
       '',
       'USU.FILUSU = MGRA.FILUSU AND
USU.CODUSU = MGRA.CODUSU',
       '' FROM DUAL
);

/*-- SEQ 8739 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MGRA',
       '--',
       12,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Diviso do produto',
       'MGRA.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'MGRA',
       '--',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       '0',
       'F',
       'Filial',
       'Cdigo da Filial de Origem do Registro',
       'DFIL.CODFIL = MGRA.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MGRA',
       '--',
       11,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'MGRA',
       '--',
       5,
       6,
       'CODOLD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Antigo',
       'Cdigo Antigo',
       '',
       'CODOLD',
       'F' FROM DUAL
UNION ALL
SELECT 'MGRA',
       '--',
       18,
       3,
       'CODOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Usurio',
       'Cdigo do usurio',
       '',
       'CODOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'MGRA',
       '--',
       13,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'MGRA.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'MGRA',
       '--',
       15,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Usurio',
       'Cdigo Usurio',
       'MGRA.FILUSU = USU.FILUSU(+) AND MGRA.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'MGRA',
       '--',
       6,
       5,
       'COROLD',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Diviso do produto',
       'MGRA.CODCOR=DIV.CODITE (+)',
       'COROLD',
       'T' FROM DUAL
UNION ALL
SELECT 'MGRA',
       '--',
       16,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data e Hora',
       'Data e Hora',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'MGRA',
       '--',
       19,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Operao',
       'Data de Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'MGRA',
       '--',
       8,
       30,
       'DESOLD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Antiga',
       'Descrio Antiga',
       '',
       'DESOLD',
       'F' FROM DUAL
UNION ALL
SELECT 'MGRA',
       '--',
       9,
       30,
       'ESPOLD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Especialidade Antiga',
       'Especialidade Antiga',
       '',
       'ESPOLD',
       'F' FROM DUAL
UNION ALL
SELECT 'MGRA',
       '--',
       10,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'MGRA',
       '--',
       4,
       3,
       'FILOLD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Antiga',
       '',
       'FILOLD',
       'F' FROM DUAL
UNION ALL
SELECT 'MGRA',
       '--',
       17,
       3,
       'FILOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Operao',
       'Filial Operao',
       '',
       'FILOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'MGRA',
       '--',
       14,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'MGRA',
       '--',
       20,
       2000,
       'MSGERR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem de erro',
       'Mensagem de erro',
       '',
       'MSGERR',
       'F' FROM DUAL
UNION ALL
SELECT 'MGRA',
       '--',
       21,
       20,
       'REFDES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Refern',
       'Descrio da Referncia',
       '',
       'REFDES',
       'F' FROM DUAL
UNION ALL
SELECT 'MGRA',
       '--',
       3,
       20,
       'REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Referncia do Produt',
       'Referncia do Produto',
       '',
       'REFPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'MGRA',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'MGRA',
       '--',
       7,
       5,
       'TAMOLD',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'MGRA.CODTAM=SUB.CODITE (+)',
       'TAMOLD',
       'T' FROM DUAL
);

/*-- SEQ 8740 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MIC ',
       TO_NUMBER(null),
       'MIC ',
       'Microrregio IBGE',
       'TT_MIC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8741 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MIC ','--','' FROM DUAL
UNION ALL
SELECT 'MIC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MIC ','99','Outros' FROM DUAL
);

/*-- SEQ 8742 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 24512,
       'MES ',
       'MIC ',
       '0N',
       '0N',
       '',
       '',
       'MES.CODMES = MIC.CODMES',
       '',
       '' FROM DUAL
);

/*-- SEQ 8743 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MIC ',
       '01',
       20,
       10,
       'CODMES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Mesorregio',
       'Cdigo Mesorregio',
       '',
       'CODMES',
       'F' FROM DUAL
UNION ALL
SELECT 'MIC ',
       '01',
       10,
       10,
       'CODMIC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cd Microrreg IBGE',
       'Cdigo Microrregio IBGE',
       '',
       'CODMIC',
       '' FROM DUAL
UNION ALL
SELECT 'MIC ',
       '01',
       30,
       50,
       'NOMMIC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Microrreg. IBGE',
       'Nome Microrregio IBGE',
       '',
       'NOMMIC',
       'F' FROM DUAL
);

/*-- SEQ 8744 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MIFC',
       TO_NUMBER(null),
       'MIFC',
       'Pend. Imp.Forn.Calc.',
       'TM_IFC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8745 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MIFC','--','' FROM DUAL
UNION ALL
SELECT 'MIFC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MIFC','99','Outros' FROM DUAL
);

/*-- SEQ 8746 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MIFC',
       '99',
       10,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data da Incluso',
       'Data da Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'MIFC',
       '99',
       20,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'MIFC',
       '01',
       30,
       10,
       'ID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Identificador',
       'Identificador',
       '',
       'ID',
       'F' FROM DUAL
UNION ALL
SELECT 'MIFC',
       '99',
       40,
       4,
       'ORIGEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Origem',
       'Origem',
       '',
       'ORIGEM',
       'F' FROM DUAL
UNION ALL
SELECT 'MIFC',
       '99',
       50,
       40,
       'REGIST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Reg.a ser Processado',
       'Registro a ser Processado',
       '',
       'REGIST',
       'F' FROM DUAL
UNION ALL
SELECT 'MIFC',
       '99',
       60,
       10,
       'USERID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'ID da Sesso',
       'ID da Sesso ao Processar ',
       '',
       'USERID',
       'F' FROM DUAL
);

/*-- SEQ 8747 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MIOR',
       TO_NUMBER(null),
       'MIOR',
       'Item Ven sem Orc Ins',
       'TM_IORXIVE',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8748 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MIOR','--','' FROM DUAL
UNION ALL
SELECT 'MIOR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MIOR','99','Outros' FROM DUAL
);

/*-- SEQ 8749 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20620,
       'IVE ',
       'MIOR',
       '1 ',
       '1 ',
       '',
       '',
       'IVE.CODFIL = MIOR.FILIVE AND
IVE.SEQUEN = MIOR.SEQIVE AND
IVE.NUMITE = MIOR.NUMITE',
       '',
       '' FROM DUAL
);

/*-- SEQ 8750 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MIOR',
       '99',
       8,
       8,
       'DATINC ',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '@',
       '',
       'Data incluso',
       'Data incluso',
       '',
       'DATINC ',
       '' FROM DUAL
UNION ALL
SELECT 'MIOR',
       '99',
       4,
       3,
       'FILIOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd. da Filial Orc',
       'Cdigo da Filial Oramento',
       '',
       'FILIOR',
       '' FROM DUAL
UNION ALL
SELECT 'MIOR',
       '01',
       1,
       3,
       'FILIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Cd. da Filial Venda',
       'Cdigo da Filial Venda',
       '',
       'FILIVE',
       '' FROM DUAL
UNION ALL
SELECT 'MIOR',
       '99',
       7,
       5,
       'NUMITE ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Item do Oramento',
       'Item do Oramento',
       '',
       'NUMITE ',
       '' FROM DUAL
UNION ALL
SELECT 'MIOR',
       '01',
       3,
       5,
       'NUMIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       ' Item Venda',
       'Item Venda',
       '',
       'NUMIVE',
       '' FROM DUAL
UNION ALL
SELECT 'MIOR',
       '99',
       6,
       10,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nmero do oramento',
       'Nmero do oramento',
       '',
       'NUMPED',
       '' FROM DUAL
UNION ALL
SELECT 'MIOR',
       '01',
       2,
       10,
       'SEQIVE ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sequenciador Venda',
       'Sequenciador Venda',
       '',
       'SEQIVE ',
       '' FROM DUAL
UNION ALL
SELECT 'MIOR',
       '99',
       5,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Tipo do Oramento',
       'Tipo do Oramento',
       '',
       'TIPPED',
       '' FROM DUAL
);

/*-- SEQ 8751 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MOE ',
       TO_NUMBER(null),
       'MOE ',
       'Moeda Bancria',
       'TT_MOE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'MOE.CODBCO,MOE.CODMOE',
       '' FROM DUAL
);

/*-- SEQ 8752 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MOE ','--','' FROM DUAL
UNION ALL
SELECT 'MOE ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MOE ','99','Outros' FROM DUAL
);

/*-- SEQ 8753 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5660,
       'DBCO',
       'MOE ',
       '0N',
       '1 ',
       '',
       '',
       'DBCO.CBANCO(+) = MOE.CODBCO',
       '' FROM DUAL
UNION ALL
SELECT 5661,
       'DMOE',
       'MOE ',
       '01',
       '1 ',
       '',
       '',
       'DMOE.CODTAB(+) = MOE.CODMOE',
       '' FROM DUAL
);

/*-- SEQ 8754 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MOE ',
       '01',
       10,
       3,
       'CODBCO',
       'A',
       'DBCO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DBCO.NBANCO',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo do Banco',
       'Cdigo Banco',
       'DBCO.CBANCO(+) = MOE.CODBCO',
       'CODBCO',
       'T' FROM DUAL
UNION ALL
SELECT 'MOE ',
       '01',
       20,
       5,
       'CODMOE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Moeda',
       'Cdigo Moeda',
       '',
       'CODMOE',
       'F' FROM DUAL
UNION ALL
SELECT 'MOE ',
       '01',
       30,
       30,
       'DESMOE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Moeda',
       'Descrio da Moeda',
       '',
       'DESMOE',
       'F' FROM DUAL
UNION ALL
SELECT 'MOE ',
       '01',
       40,
       1,
       'MOEBCO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Moeda Banco',
       'Cdigo da Moeda no Banco',
       '',
       'MOEBCO',
       'F' FROM DUAL
);

/*-- SEQ 8755 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MON ',
       TO_NUMBER(null),
       'MON ',
       'Montagens',
       'TT_MON',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'MON.CODFIL,MON.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8756 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MON ','--','' FROM DUAL
UNION ALL
SELECT 'MON ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MON ','99','Outros' FROM DUAL
);

/*-- SEQ 8757 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5662,
       'CLI ',
       'MON ',
       'N ',
       '1 ',
       '',
       '',
       'CLI.FILCLI = MON.FILCLI and
CLI.CODCLI = MON.CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 5663,
       'GRA ',
       'MON ',
       'N ',
       '1 ',
       '',
       '',
       'GRA.FILMAT = MON.FILMAT and
GRA.CODMAT = MON.CODMAT and
GRA.CODCOR = MON.CODCOR and
GRA.CODTAM = MON.CODTAM ',
       '' FROM DUAL
UNION ALL
SELECT 5664,
       'IVE ',
       'MON ',
       'N ',
       '1 ',
       '',
       '',
       'IVE.SEQUEN = MON.SEQIVE AND
IVE.CODFIL = MON.FILIVE AND
IVE.NUMITE = MON.ITEIVE',
       '' FROM DUAL
UNION ALL
SELECT 5665,
       'USU ',
       'MON ',
       'N ',
       '1 ',
       '',
       '',
       'USU.FILUSU = MON.FILUSU AND
USU.CODUSU = MON.CODUSU',
       '' FROM DUAL
);

/*-- SEQ 8758 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MON ',
       '01',
       10,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'MON ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'MON ',
       '01',
       30,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Diviso do produto',
       'DIV.CODITE (+) = MON.CODCOR',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'MON ',
       '01',
       40,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MON ',
       '01',
       50,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'MON ',
       '01',
       60,
       3,
       'CODRES',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Responsvel',
       'Responsvel',
       'USU.FILUSU(+) = MON.FILRES  AND USU.CODUSU(+) = MON.CODRES',
       'CODRES',
       'T' FROM DUAL
UNION ALL
SELECT 'MON ',
       '01',
       70,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'SUB.CODITE (+) = MON.CODTAM',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'MON ',
       '01',
       80,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'USU.FILUSU(+) = MON.FILUSU  AND USU.CODUSU(+) = MON.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'MON ',
       '01',
       90,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data e Hora',
       'Data e Hora',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'MON ',
       '01',
       100,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'MON ',
       '01',
       110,
       3,
       'FILIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial de Inventrio',
       '',
       'FILIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'MON ',
       '01',
       120,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'MON ',
       '01',
       130,
       3,
       'FILRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial Responsvel',
       '',
       'FILRES',
       'F' FROM DUAL
UNION ALL
SELECT 'MON ',
       '01',
       140,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'MON ',
       '01',
       150,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'MON ',
       '01',
       160,
       5,
       'ITEIVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Itens de Inventrio',
       'Itens de Inventrio',
       '',
       'ITEIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'MON ',
       '01',
       170,
       1,
       'LOCALI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Localizao',
       'Localizao',
       '',
       'LOCALI',
       'F' FROM DUAL
UNION ALL
SELECT 'MON ',
       '01',
       180,
       254,
       'OBSERV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'MON ',
       '01',
       190,
       10,
       'SEQIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador de Inventrio',
       '',
       'SEQIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'MON ',
       '01',
       200,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'MON ',
       '01',
       210,
       1,
       'TIPMON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Montagem',
       'Tipo de Montagem',
       '',
       'TIPMON',
       'F' FROM DUAL
);

/*-- SEQ 8759 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'MON ',
       'FLGEST',
       0,
       'A',
       'Em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MON ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MON ',
       'FLGEST',
       0,
       'E',
       'Entregue',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MON ',
       'LOCALI',
       0,
       'E',
       'Dentro da Empresa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MON ',
       'LOCALI',
       0,
       'I',
       'Interurbana',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MON ',
       'LOCALI',
       0,
       'U',
       'Urbana',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MON ',
       'TIPMON',
       0,
       'C',
       'MontagemCorretiva(assistncia)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MON ',
       'TIPMON',
       0,
       'E',
       'Montagem Dentro da Empresa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MON ',
       'TIPMON',
       0,
       'I',
       'Montagem Interurbana',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MON ',
       'TIPMON',
       0,
       'U',
       'Montagem Urbana',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8760 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MOT ',
       0,
       'MOT ',
       'Motorista',
       'TT_CLI',
       'T',
       '',
       'TOTALL',
       'Clientes',
       '{FILCLI;CODCLI};ATU_EM;NOMCLI;ULTNOM;DOCUME;DOCCON',
       'NUMDOC',
       'NOMCLI',
       'Cliente',
       'T',
       '',
       'MOT.FILCLI,MOT.CODCLI
MOT.NOMCLI,MOT.ULTNOM
MOT.NUMDOC',
       '' FROM DUAL
);

/*-- SEQ 8761 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MOT ','--','' FROM DUAL
UNION ALL
SELECT 'MOT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MOT ','02','Endereo' FROM DUAL
UNION ALL
SELECT 'MOT ','03','Documentao' FROM DUAL
UNION ALL
SELECT 'MOT ','04','Juros x Descontos' FROM DUAL
UNION ALL
SELECT 'MOT ','05','Parametros para Postos de Combustivel (1)' FROM DUAL
UNION ALL
SELECT 'MOT ','06','Parametros para Postos de Combustivel (2)' FROM DUAL
UNION ALL
SELECT 'MOT ','07','Parametros para Postos de Combustivel (3)' FROM DUAL
UNION ALL
SELECT 'MOT ','08','Parametros para Postos de Combustivel (4)' FROM DUAL
UNION ALL
SELECT 'MOT ','09','Parametros para Postos de Combustivel (5)' FROM DUAL
UNION ALL
SELECT 'MOT ','10','Parametros para Postos de Combustivel (6)' FROM DUAL
UNION ALL
SELECT 'MOT ','11','Parametros para Postos de Combustivel (7)' FROM DUAL
UNION ALL
SELECT 'MOT ','13','Parametros Valor Venda Cliente' FROM DUAL
UNION ALL
SELECT 'MOT ','99','Outros' FROM DUAL
);

/*-- SEQ 8762 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21703,
       'SPC ',
       'MOT ',
       '01',
       '1',
       '',
       '',
       'SPC.FILCLI(+) = MOT.FILCLI and
SPC.CODCLI(+) = MOT.CODCLI ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21704,
       'IND ',
       'MOT ',
       '01',
       'N',
       '',
       '',
       'MOT.FILGUI = IND.FILCLI(+) AND
MOT.CODGUI = IND.CODCLI(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21705,
       'CON ',
       'MOT ',
       '0N',
       '01',
       '',
       '',
       'CON.FILCLI(+) = MOT.FILCLI AND
CON.CODCLI(+) = MOT.CODCLI ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21706,
       'VINC',
       'MOT ',
       '01',
       '1',
       '',
       '',
       'vinc.FILVIN(+) = MOT.FILCLI AND
vinc.CODVIN(+) = MOT.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21707,
       'FAT ',
       'MOT ',
       'N',
       '1',
       '',
       '',
       'FAT.FILCLI = MOT.FILCLI AND
FAT.CODCLI = MOT.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21708,
       'CFG ',
       'MOT ',
       '1',
       '1',
       '',
       '',
       'CFG.VC_FILCLI = MOT.FILCLI AND
CFG.VC_CODCLI = MOT.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21709,
       'COM ',
       'MOT ',
       'N',
       '1',
       '',
       '',
       'COM.FILFOR = MOT.FILCLI AND
COM.CODFOR = MOT.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21710,
       'REG ',
       'MOT ',
       'N',
       '1',
       '',
       '',
       'MOT.FILCLI = REG.FILCLI AND
MOT.CODCLI = REG.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21711,
       'FCM ',
       'MOT ',
       'N',
       '1',
       '',
       '',
       'MOT.FILCLI = FCM.FILFOR AND MOT.CODCLI = FCM.CODFOR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21712,
       'USU ',
       'MOT ',
       '01',
       '1',
       '',
       '',
       'USU.FILCLI = MOT.FILCLI(+) AND
USU.CODCLI = MOT.CODCLI(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21713,
       'EDE ',
       'MOT ',
       'N',
       '1',
       '',
       '',
       'EDE.FILCLI = MOT.FILCLI AND
EDE.CODCLI = MOT.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21714,
       'VRES',
       'MOT ',
       '01',
       'N',
       '',
       '',
       'VRES.NUMDOC = MOT.NUMDOC',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21715,
       'REL ',
       'MOT ',
       'N',
       '1',
       '',
       '',
       'MOT.FILCLI = REL.FILPAR AND
MOT.CODCLI = REL.CODPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21716,
       'ROM ',
       'MOT ',
       'N',
       '01',
       '',
       '',
       'ROM.FILMOT = MOT.FILCLI AND
ROM.CODMOT = MOT.CODCLI',
       '',
       '' FROM DUAL
);

/*-- SEQ 8763 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MOT ',
       '05',
       630,
       8,
       ':CLI.CB1_DATINI,CLI.CB1_DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data (1)',
       'Data (1)',
       '',
       ':MOT.CB1_DATINI,MOT.CB1_DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '06',
       650,
       8,
       ':CLI.CB2_DATINI,CLI.CB2_DATFIM',
       'D',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data (2)',
       'Data (2)',
       '',
       ':MOT.CB2_DATINI,MOT.CB2_DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '07',
       730,
       15,
       ':CLI.CB3_CODFIL',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Fil Combustivel (1)',
       'Fil Combustivel (1)',
       'MOT.:MOT.CB3_CODFIL = DFIL.CODFIL',
       ':MOT.CB3_CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '07',
       720,
       8,
       ':CLI.CB3_DATINI,CLI.CB3_DATFIM',
       'D',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Filial 1',
       'Data Filial 1',
       '',
       ':MOT.CB3_DATINI,MOT.CB3_DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '08',
       760,
       15,
       ':CLI.CB4_CODFIL',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Fil Combustivel (2)',
       'Fil Combustivel (2)',
       'MOT.:MOT.CB4_CODFIL = DFIL.CODFIL',
       ':MOT.CB4_CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '08',
       750,
       8,
       ':CLI.CB4_DATINI,CLI.CB4_DATFIM',
       'D',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Filial 2',
       'Data Filial 2',
       '',
       ':MOT.CB4_DATINI,MOT.CB4_DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '09',
       790,
       15,
       ':CLI.CB5_CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Fil Combustivel (3)',
       'Fil Combustivel (3)',
       'MOT.:MOT.CB5_CODFIL = DFIL.CODFIL',
       ':MOT.COMB5_CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '09',
       780,
       8,
       ':CLI.CB5_DATINI,CLI.CB5_DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Filial 3',
       'Data Filial 3',
       '',
       ':MOT.CB5_DATINI,MOT.CB5_DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '10',
       820,
       15,
       ':CLI.CB6_CODFIL',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Fil Combustivel (4)',
       'Fil Combustivel (4)',
       'MOT.:MOT.CB6_CODFIL = DFIL.CODFIL',
       ':MOT.CB6_CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '10',
       810,
       8,
       ':CLI.CB6_DATINI,CLI.CB6_DATFIM',
       'D',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Filial 4',
       'Data Filial 4',
       '',
       ':MOT.CB6_DATINI,MOT.CB6_DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '11',
       850,
       15,
       ':CLI.CB7_CODFIL',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Fil Combustivel (5)',
       'Fil Combustivel (5)',
       'MOT.:MOT.CB7_CODFIL = DFIL.CODFIL',
       ':MOT.CB7_CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '11',
       840,
       8,
       ':CLI.CB7_DATINI,CLI.CB7_DATFIM',
       'D',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Filial 5',
       'Data Filial 5',
       '',
       ':MOT.CB7_DATINI,MOT.CB7_DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '13',
       1163,
       8,
       ':CLI.DFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Final',
       'Data Final',
       '',
       ':MOT.DFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '13',
       1162,
       8,
       ':CLI.DINI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Inicial',
       'Data Inicial',
       '',
       ':MOT.DINI',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       300,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'CLI ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(MOT.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       920,
       4,
       'ANO_DATA01',
       'A',
       '',
       0,
       0,
       'CLI ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 1',
       '',
       'TO_CHAR(MOT.DATA01,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       950,
       4,
       'ANO_DATA02',
       'A',
       '',
       0,
       0,
       'CLI ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 2',
       '',
       'TO_CHAR(MOT.DATA02,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       1000,
       4,
       'ANO_DATA03',
       'A',
       '',
       0,
       0,
       'CLI ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 3',
       '',
       'TO_CHAR(MOT.DATA03,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       330,
       4,
       'ANO_DATNAS',
       'A',
       '',
       0,
       0,
       'CLI ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ano Nascto/Fundao',
       'Ano de Data de nascimento',
       '',
       'TO_CHAR(MOT.DATNAS,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       360,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       0,
       'CLI ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ano de Data Incluso',
       'Ano de Data de operao (cadastramento)',
       '',
       'TO_CHAR(MOT.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       410,
       4,
       'ANO_NASCON',
       'A',
       '',
       0,
       0,
       'CLI ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ano de Nascto Cnj./',
       'Ano de Data de nascimento do cnjuge ou contato principal',
       '',
       'TO_CHAR(MOT.NASCON,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '04',
       590,
       4,
       'ANO_ULTCOM',
       'A',
       '',
       0,
       0,
       'CLI ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ano de ltima Compra',
       'Ano de Data da ltima compra',
       '',
       'TO_CHAR(MOT.ULTCOM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '04',
       1510,
       12,
       'ATRASOEMABERTO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Atraso em Aberto',
       'Atraso em Aberto',
       '',
       '(SELECT SUM(TRUNC(AGORA())-R.DATVEN) FROM TT_VEN V INNER JOIN TT_REC R ON V.CODFIL=R.CODFIL AND V.SEQUEN=R.SEQUEN WHERE V.FILCLI=MOT.FILCLI AND V.CODCLI=MOT.CODCLI AND R.CARTAO IS NULL AND V.FLGEST=''A'' AND R.SEQCHE IS NULL AND R.DATVEN<AGORA())',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '02',
       1150,
       1,
       'ATUCUS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Atualiza Custos?',
       'Atualiza  Custos?',
       '',
       'ATUCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       280,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'CLI ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       90,
       1,
       'CALL_C',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Aceita Contato?',
       'Aceita Contato Telefnico',
       '',
       'CALL_C',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       870,
       2,
       'CATEG1',
       'S',
       'DCT1',
       0,
       20,
       'CLI ',
       10,
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'V',
       'CLI',
       'F',
       'A',
       'T',
       'Profisso/Ramo',
       'Categoria - 1',
       'MOT.CATEG1=DCT1.CODTAB (+)',
       'CATEG1',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       880,
       2,
       'CATEG2',
       'S',
       'DCT2',
       0,
       21,
       'CLI ',
       20,
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'V',
       'CLI',
       'F',
       'A',
       'T',
       'Salrio/Faturam',
       'Categoria - 2',
       'MOT.CATEG2=DCT2.CODTAB (+)',
       'CATEG2',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       890,
       2,
       'CATEG3',
       'S',
       'DCT3',
       0,
       22,
       'CLI ',
       30,
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'V',
       'CLI',
       'F',
       'A',
       'T',
       'Categoria - 3',
       'Categoria - 3',
       'MOT.CATEG3=DCT3.CODTAB (+)',
       'CATEG3',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       1200,
       2,
       'CCCPRE',
       'S',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       'A',
       '',
       'Conta Cliente',
       'Conta corrente Cliente',
       'DCCC.CODTAB = MOT.CCCPRE (+)',
       'CCCPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       170,
       8,
       'CELCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Celular Cnjuge',
       'Celular Cnjuge',
       '',
       'CELCON',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '--',
       1520,
       5,
       'CENCUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CENCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       250,
       9,
       'CHAVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'T',
       'Filial+Cdigo',
       'Filial+Cdigo do cliente',
       '',
       '(MOT.FILCLI||MOT.CODCLI)',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       1200,
       10,
       'CLIENTEPROJETO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cliente~do Projeto',
       'Projeto do Cliente',
       '',
       'PROJETOCLIENTE(MOT.FILCLI,MOT.CODCLI)',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       0,
       'CLI ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '02',
       1160,
       6,
       'CODCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Codigo Reg.Cnjuge',
       'Codigo do registro do conjuge',
       '',
       'CODCON',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '--',
       1570,
       5,
       'CODCUS',
       'S',
       'DCUS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCUS.CENCUS',
       'V',
       '',
       '',
       'N',
       'F',
       'Centro de Custos',
       'Centro de Custos',
       'DCUS.CODTAB = MOT.CODCUS',
       'CODCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       20,
       10,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Externo',
       'Cdigo Alternativo nico',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       100,
       5,
       'CODFID',
       'S',
       'DFID',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFID.DESFID',
       'V',
       '',
       '',
       'A',
       'F',
       'Fidelizao',
       'Fidelizao',
       'DFID.CODTAB = MOT.CODFID',
       'CODFID',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       1110,
       5,
       'CODINA',
       'S',
       'DINA',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DINA.DESINA',
       'V',
       '',
       '',
       'N',
       'F',
       'Motivo Inatividade',
       'Cdigo da Inatividade',
       'DINA.CODTAB = MOT.CODINA',
       'CODINA',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '04',
       550,
       3,
       'CODPLA',
       'A',
       'PLA ',
       0,
       24,
       'CLI ',
       60,
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       'CLI',
       'F',
       'A',
       'T',
       'Plano Pagamento',
       'Cdigo do plano padro',
       'MOT.FILPLA=PLA.FILPGT(+)  AND MOT.CODPLA=PLA.CODPGT(+)',
       'CODPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       370,
       2,
       'CODSEX',
       'S',
       '',
       0,
       19,
       'CLI ',
       90,
       30,
       '',
       '',
       'D',
       'CLI',
       'F',
       'A',
       'T',
       'Sexo',
       'Cdigo de Sexo do Cliente',
       '',
       'CODSEX',
       'T' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '04',
       610,
       3,
       'CODVEN',
       'A',
       'USU ',
       0,
       0,
       'CLI ',
       120,
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       'CLI',
       'F',
       'A',
       'T',
       'Vendedor Padro',
       'Vendedor Padro',
       'MOT.FILVEN=USU.FILUSU(+) and MOT.CODVEN=USU.CODUSU(+)',
       'CODVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       40,
       6,
       'CODVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo Vnculo',
       'Cdigo do Vnculo',
       '',
       'CODVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '05',
       620,
       10,
       'COMBU1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Combustivel (1)',
       'Combustivel (1)',
       '',
       'COMBUSTIVEIS_CLIENTE(MOT.FILCLI,MOT.CODCLI, :MOT.CB1_DATINI, :MOT.CB1_DATFIM,NULL)',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '06',
       640,
       10,
       'COMBU2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Combustivel (2)',
       'Combustivel (2)',
       '',
       'COMBUSTIVEIS_CLIENTE(MOT.FILCLI,MOT.CODCLI, :MOT.CB2_DATINI, :MOT.CB2_DATFIM,NULL)',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '07',
       710,
       8,
       'COMBUSFIL1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Combustivel Filial 1',
       'Combustivel Filial 1',
       '',
       'COMBUSTIVEIS_CLIENTE(MOT.FILCLI,MOT.CODCLI, :MOT.CB3_DATINI, :MOT.CB3_DATFIM,:MOT.CB3_CODFIL)',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '08',
       740,
       8,
       'COMBUSFIL2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Combustivel Filial 2',
       'Combustivel Filial 2',
       '',
       'COMBUSTIVEIS_CLIENTE(MOT.FILCLI,MOT.CODCLI, :MOT.CB4_DATINI, :MOT.CB4_DATFIM,:MOT.CB4_CODFIL)',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '09',
       770,
       8,
       'COMBUSFIL3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Combustivel Filial 3',
       'Combustivel Filial 3',
       '',
       'COMBUSTIVEIS_CLIENTE(MOT.FILCLI,MOT.CODCLI, :MOT.CB5_DATINI, :MOT.CB5_DATFIM,:MOT.CB5_CODFIL)',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '10',
       800,
       8,
       'COMBUSFIL4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Combustivel Filial 4',
       'Combustivel Filial 4',
       '',
       'COMBUSTIVEIS_CLIENTE(MOT.FILCLI,MOT.CODCLI, :MOT.CB6_DATINI, :MOT.CB6_DATFIM,:MOT.CB6_CODFIL)',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '11',
       830,
       8,
       'COMBUSFIL5',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Combustivel Filial 5',
       'Combustivel Filial 5',
       '',
       'COMBUSTIVEIS_CLIENTE(MOT.FILCLI,MOT.CODCLI, :MOT.CB7_DATINI, :MOT.CB7_DATFIM,:MOT.CB7_CODFIL)',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '03',
       110,
       5,
       'CONBOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Boleto',
       'Boleto',
       '',
       'CONBOL',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       380,
       44,
       'CONJUG',
       'A',
       '',
       0,
       0,
       'CLI ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CLI',
       'F',
       'A',
       'T',
       'Cnjuge ou Contato',
       'Nome do Cnjuge ou do  Contato principal',
       '',
       'CONJUG',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       900,
       8,
       'DATA01',
       'D',
       '',
       0,
       0,
       'CLI ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'D',
       'T',
       'Data livre - 1',
       'Data livre - 1',
       '',
       'DATA01',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       930,
       8,
       'DATA02',
       'D',
       '',
       0,
       0,
       'CLI ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'D',
       'T',
       'Data livre - 2',
       'Data livre - 2',
       '',
       'DATA02',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       960,
       8,
       'DATA03',
       'D',
       '',
       0,
       0,
       'CLI ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'D',
       'T',
       'Data livre - 3',
       'Data livre - 3',
       '',
       'DATA03',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       310,
       8,
       'DATNAS',
       'D',
       '',
       0,
       0,
       'CLI ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'D',
       'T',
       'Nascto/Fundao',
       'Data de nascimento',
       '',
       'DATNAS',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       340,
       8,
       'DATOPE',
       'D',
       '',
       0,
       0,
       'CLI ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'D',
       'T',
       'Data Incluso',
       'Data de operao (cadastramento)',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       180,
       4,
       'DDCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DDD Celular Cnjuge',
       'DDD Celular Cnjuge',
       '',
       'DDCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       210,
       4,
       'DDTCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'DDD Telefone Cnjuge',
       'DDD Telefone Cnjuge',
       '',
       'DDTCON',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       335,
       2,
       'DIA_DATNAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Dia Data Nascimento',
       'Dia Data de Nascimento',
       '',
       'TO_CHAR(MOT.DATNAS,''DD'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '04',
       1200,
       12,
       'DIVIDA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo~Dvida',
       'Saldo Dvida',
       '',
       'DIVIDA(MOT.FILCLI,MOT.CODCLI)',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '03',
       490,
       15,
       'DOCCON',
       'A',
       '',
       0,
       0,
       'CLI ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CLI',
       'F',
       'A',
       'T',
       'Doc. Cnjuge/Contato',
       'Doc. Cnjuge/Contato',
       '',
       'DOCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       860,
       4000,
       'DOENCA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Doenas',
       'Doenas',
       '',
       'TRAZDOENCAS(MOT.FILCLI,MOT.CODCLI)',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       1140,
       1,
       'DUMMY',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       '',
       'Dummy',
       '',
       'DUMMY',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       1040,
       1,
       'EDICRE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Credito manualmente?',
       'Credito definido manualmente(pode editar o limite de credito pode editar',
       '',
       'EDICRE',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '03',
       460,
       2,
       'ESTCIV',
       'S',
       '',
       0,
       18,
       'CLI ',
       20,
       30,
       '',
       '',
       'D',
       'CLI',
       'F',
       'A',
       'T',
       'Estado Civil',
       'Estado Civil',
       '',
       'ESTCIV',
       'T' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '--',
       1530,
       1,
       'ESTRAN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Estrangeiro?',
       'Estrangeiro?',
       '',
       'ESTRAN',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       220,
       40,
       'E_MCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail',
       'E-mail',
       '',
       'E_MCON',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       240,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       0,
       'CLI ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'CLI',
       'F',
       'N',
       'T',
       'Filial Cliente',
       'Filial onde foi cadastrado o cliente',
       'MOT.FILCLI = DFIL.CODFIL (+)',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '02',
       1170,
       3,
       'FILCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Reg.Cnjuge',
       'Filial do registro do conjuge',
       '',
       'FILCON',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '04',
       540,
       3,
       'FILPLA',
       'A',
       '',
       0,
       0,
       'CLI ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'N',
       'F',
       'Filial Plano Padro',
       'Filial Plano Padro',
       '',
       'FILPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '04',
       600,
       3,
       'FILVEN',
       'A',
       '',
       0,
       0,
       'CLI ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'N',
       'F',
       '',
       'Filial do Vendedor',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       30,
       3,
       'FILVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       30,
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Vnculo',
       '',
       'FILVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '03',
       470,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       0,
       'CLI ',
       30,
       30,
       '',
       '',
       'D',
       'CLI',
       'F',
       'A',
       'T',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '02',
       440,
       20,
       'FONE_ENDERE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       'SELECT FILCLI, CODCLI, NOMCLI,
       SUBSTR((SELECT MIN(LPAD(CODFIL,3)||LPAD(TO_CHAR(NUMEND),4)||DECODE(CODDDD,NULL,NULL,''''(''''||CODDDD||'''')'''')||NUMFON)
                 FROM TT_END
                WHERE FILCLI = CLI.FILCLI
                  AND CODCLI = CLI.CODCLI
                  AND NUMFON IS NOT NULL), 8)
  FROM TT_CLI CLI
',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Telefone',
       'Telefone',
       '',
       'SUBSTR((SELECT MIN(LPAD(CODFIL,3)||LPAD(TO_CHAR(NUMEND),4)||(CASE WHEN CODDDD = NULL THEN NULL ELSE''(''||CODDDD||'')'' END)||NUMFON) FROM TT_END WHERE FILCLI = MOT.FILCLI AND CODCLI = MOT.CODCLI AND NUMFON IS NOT NULL), 8)',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       1050,
       1,
       'GLOBAL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Faturamento Global',
       'Faturamento Global',
       '',
       'GLOBAL',
       'T' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '02',
       430,
       40,
       'HOMPGE',
       'A',
       '',
       0,
       0,
       'CLI ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CLI',
       'F',
       'A',
       'T',
       'Home Page',
       'Home Page do Cliente',
       '',
       'HOMPGE',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       120,
       1,
       'ICM_CF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'ICM_CF  Nota Fiscal?',
       'ICM_CF  Nota Fiscal',
       '',
       'ICM_CF',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       660,
       7,
       'ID_DAT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data RG',
       'Data RG',
       '',
       'ID_DAT',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       670,
       2,
       'ID_EST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF do RG',
       'UF do RG',
       '',
       'ID_EST',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       680,
       6,
       'ID_ORG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'rgo Expeditor',
       'rgo Expeditor',
       '',
       'ID_ORG',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       1010,
       2,
       'IMPRIM',
       'S',
       '',
       0,
       0,
       'CLI ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'N',
       'F',
       'Class. Interna',
       'Livre para customizao',
       '',
       'IMPRIM',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '03',
       480,
       15,
       'INSEST',
       'A',
       '',
       0,
       4,
       'CLI ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'CLI',
       'F',
       'A',
       'T',
       '2 Documento',
       'Inscrio Estadual ou Identidade',
       '',
       'INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       70,
       6,
       'ISENHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Senha',
       'Senha',
       '',
       'ISENHA',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       690,
       3,
       'LIMPAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Limpar',
       'Limpar',
       '',
       'LIMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '04',
       530,
       2,
       'MAIATR',
       'S',
       '',
       0,
       0,
       'CLI ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       '9',
       'T',
       'Maior atraso',
       'Maior atraso registrado',
       '',
       'MAIATR',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '04',
       1500,
       12,
       'MEDIAATRASO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Mdia Atraso',
       'Mdia Atraso',
       '',
       '(CASE WHEN MOT.TOTPAR = 0.00 THEN 0 ELSE TRUNC(MOT.TOTATR/MOT.TOTPAR,2) END)',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       290,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'CLI ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(MOT.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       910,
       2,
       'MES_DATA01',
       'A',
       '',
       0,
       0,
       'CLI ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 1',
       '',
       'TO_CHAR(MOT.DATA01,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       940,
       2,
       'MES_DATA02',
       'A',
       '',
       0,
       0,
       'CLI ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 2',
       '',
       'TO_CHAR(MOT.DATA02,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       970,
       2,
       'MES_DATA03',
       'A',
       '',
       0,
       0,
       'CLI ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 3',
       '',
       'TO_CHAR(MOT.DATA03,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       320,
       2,
       'MES_DATNAS',
       'A',
       '',
       0,
       0,
       'CLI ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ms Nascto/Fundao',
       'Ms de Data de nascimento',
       '',
       'TO_CHAR(MOT.DATNAS,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       350,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       0,
       'CLI ',
       80,
       30,
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ms de Data Incluso',
       'Ms de Data de operao (cadastramento)',
       '',
       'TO_CHAR(MOT.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       400,
       2,
       'MES_NASCON',
       'A',
       '',
       0,
       0,
       'CLI ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ms de Nascto Cnj./',
       'Ms de Data de nascimento do cnjuge ou contato principal',
       '',
       'TO_CHAR(MOT.NASCON,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '04',
       580,
       2,
       'MES_ULTCOM',
       'A',
       '',
       0,
       0,
       'CLI ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ms de ltima Compra',
       'Ms de Data da ltima compra',
       '',
       'TO_CHAR(MOT.ULTCOM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       1130,
       1,
       'NAOSPC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'No no SPC?',
       'No no SPC?',
       '',
       'NAOSPC',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       390,
       8,
       'NASCON',
       'D',
       '',
       0,
       0,
       'CLI ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'D',
       'T',
       'Nascto Cnj./Contato',
       'Data de nascimento do cnjuge ou contato principal',
       '',
       'NASCON',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       260,
       44,
       'NOMCLI',
       'A',
       '',
       0,
       0,
       'CLI ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CLI',
       'F',
       'A',
       'T',
       'Nome/Razo Social',
       'Nome do Cliente',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       275,
       65,
       'NOME_COMPLETO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome Completo',
       'Nome Completo',
       '',
       '(CASE WHEN MOT.FLGTIP = 0 THEN (MOT.NOMCLI || '' '' || COALESCE(MOT.ULTNOM,'''')) ELSE MOT.NOMCLI END)',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       60,
       255,
       'NOMIMG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Imagem',
       'Nome Imagem',
       '',
       'NOMIMG',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       700,
       20,
       'NOMTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Apelido',
       'Apelido',
       '',
       'NOMTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '03',
       450,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       3,
       'CLI ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CLI',
       'F',
       'A',
       'T',
       'Documento (CPF/CNPJ)',
       'Nmero do Documento: CNPJ ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       1020,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'CLI ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CLI',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(MOT.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       130,
       254,
       'OBSOUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'OBS. CheckOut',
       'Obervao para CheckOut',
       '',
       'OBSOUT',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '--',
       1540,
       1,
       'PEDELE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Pedido Eletrnico?',
       'Pedido Eletrnico?',
       '',
       'PEDELE',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       1180,
       1,
       'POREMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Porte da Empresa',
       'Porte da Empresa',
       '',
       'POREMP',
       'T' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '04',
       560,
       2,
       'PORPAD',
       'S',
       'DCOB',
       0,
       16,
       'CLI ',
       70,
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       'CLI',
       'F',
       'A',
       'T',
       'Portador Padro',
       'Portador padro',
       'MOT.PORPAD=DCOB.CODTAB (+)',
       'PORPAD',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       1060,
       3,
       'PP_COD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cd.Usu. Prospeco',
       'Cdigo do usurio que est prospectando
Cdigo do usurio que est pros',
       '',
       'PP_COD',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       1070,
       3,
       'PP_FIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial de Prospeco',
       'Filial do usurio que est prospectando
Filial do usurio que est pros',
       '',
       'PP_FIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       1080,
       7,
       'PP_FIM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fim prospeco',
       'Data Final de prospeco',
       '',
       'PP_FIM',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       1090,
       1,
       'PP_FLG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag de Prospeco?',
       'Flag de Prospeco ',
       '',
       'PP_FLG',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       1100,
       7,
       'PP_INI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data ini. prospeco',
       'Data de inicio de prospeso',
       '',
       'PP_INI',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       1210,
       1,
       'REGESP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Regime Especial?',
       ' Fornecedor possui Regime Especial?',
       '',
       'REGESP',
       '' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '--',
       1550,
       1,
       'REPASE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Repasse',
       'Repasse ser antes ou depois do valor do item',
       '',
       'REPASE',
       'T' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '04',
       140,
       12,
       'SALBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Bnus',
       'Bnus',
       '',
       'SALBON',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       420,
       2,
       'SEXCON',
       'S',
       '',
       0,
       0,
       'CLI ',
       120,
       30,
       '',
       '',
       'D',
       'CLI',
       'F',
       'A',
       'T',
       'Sexo do Cnjuge',
       'Sexo do cnjuge',
       '',
       'SEXCON',
       'T' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       1030,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'CLI ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CLI',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN MOT.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       1031,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN MOT.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       1120,
       1,
       'SIMPLE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Optante pelo Simples',
       'Optante pelo Simples?',
       '',
       'SIMPLE',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '02',
       230,
       8,
       'TELCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Telefone do Cnjuge',
       'Telefone do Cnjuge',
       '',
       'TELCON',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '04',
       150,
       1,
       'TIPCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Cobrana',
       'Tipo Cobrana',
       '',
       'TIPCOB',
       'T' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '03',
       50,
       2,
       'TIPDOC',
       'A',
       'DDOC',
       0,
       TO_NUMBER(null),
       '',
       40,
       TO_NUMBER(null),
       '',
       'DDOC.DESDOC',
       'V',
       '',
       'F',
       'A',
       'F',
       'Tipo Documento',
       'Tipo de Documento',
       'DDOC.TIPDOC(+) = MOT.TIPDOC',
       'TIPDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       1190,
       1,
       'TIPEMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo da Empresa',
       'Tipo da Empresa',
       '',
       'TIPEMP',
       'T' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '04',
       510,
       4,
       'TOTATR',
       'G',
       '',
       0,
       0,
       'CLI ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       '9',
       'F',
       'Total de Atrasos',
       'Total de atrasos na vida do cliente',
       '',
       'TOTATR',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '04',
       520,
       4,
       'TOTPAR',
       'G',
       '',
       0,
       0,
       'CLI ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       '9',
       'F',
       'Total Geral Parcelas',
       'Total de parcelas na vida do cliente',
       '',
       'TOTPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       80,
       250,
       'TRACO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Espao para Anotao',
       'Espao para Anotao',
       '',
       'LPAD(''_'',50,''_'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '04',
       570,
       8,
       'ULTCOM',
       'D',
       '',
       0,
       0,
       'CLI ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'D',
       'T',
       'ltima Compra',
       'Data da ltima compra',
       '',
       'ULTCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '01',
       270,
       20,
       'ULTNOM',
       'A',
       '',
       0,
       0,
       'CLI ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CLI',
       'F',
       'A',
       'T',
       'Sobrenome/Fantasia',
       'Sobrenome ou fantasia',
       '',
       'ULTNOM',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '--',
       1560,
       1,
       'USAREF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa referncia?',
       'Usa referncia?',
       '',
       'USAREF',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '04',
       500,
       8,
       'VALOR1',
       'F',
       '',
       2,
       0,
       'CLI ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'T',
       '9',
       'T',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'VALOR1',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '99',
       1160,
       1,
       'VERIFICANULL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Possui Campos Nulos',
       'Verifica existncia de campos nulos no cadastro de clientes',
       '',
       'VERIFICANULL(FILCLI, CODCLI)',
       'F' FROM DUAL
UNION ALL
SELECT 'MOT ',
       '13',
       1161,
       12,
       'VLRVENCLI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Valor Vendas',
       'Valor Vendas',
       '',
       '(SELECT SUM(VEN.VLRNOT) FROM TT_VEN VEN WHERE (VEN.FLGEST<>''C'') AND (VEN.DATHOR BETWEEN :MOT.DINI AND :MOT.DFIM) AND MOT.FILCLI=VEN.FILCLI AND MOT.CODCLI=VEN.CODCLI GROUP BY MOT.FILCLI, MOT.CODCLI)',
       'F' FROM DUAL
);

/*-- SEQ 8764 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'MOT ',
       'CODSEX',
       0,
       '-',
       'Nao conhecido',
       144,
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'CODSEX',
       2,
       '-',
       'Feminino',
       146,
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'CODSEX',
       1,
       '-',
       'Masculino',
       145,
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'ESTCIV',
       6,
       ' ',
       'Separado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'ESTCIV',
       5,
       ' ',
       'Unio Estvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'ESTCIV',
       0,
       ' ',
       'Indefinido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'ESTCIV',
       4,
       ' ',
       'Divorciado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'ESTCIV',
       1,
       ' ',
       'Solteiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'ESTCIV',
       2,
       ' ',
       'Casado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'ESTCIV',
       3,
       ' ',
       'Viuvo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'FLGTIP',
       0,
       ' ',
       'Fisica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'FLGTIP',
       1,
       ' ',
       'Juridica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'FLGTIP',
       2,
       ' ',
       'Entidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'FLGTIP',
       3,
       ' ',
       'Especial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'FLGTIP',
       4,
       ' ',
       'M.E.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'FLGTIP',
       5,
       ' ',
       'Filial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'GLOBAL',
       0,
       'G',
       'Faturamento Global',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'GLOBAL',
       0,
       'I',
       'No faz Faturamento Global',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'POREMP',
       0,
       'M',
       'Micro-empresa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'POREMP',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'POREMP',
       0,
       'P',
       'Pequeno Porte',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'REPASE',
       0,
       '0',
       'Sem Repasse',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'REPASE',
       0,
       '1',
       'Antes',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'REPASE',
       0,
       '2',
       'Depois',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'SEXCON',
       0,
       ' ',
       'Nao Conhecido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'SEXCON',
       1,
       ' ',
       'Masculino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'SEXCON',
       2,
       ' ',
       'Feminino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'TIPCOB',
       0,
       'B',
       'Bancria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'TIPCOB',
       0,
       'P',
       'Padro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'TIPEMP',
       0,
       'L',
       'Limitada (LTDA)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'TIPEMP',
       0,
       'R',
       'Registro de Empresrio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOT ',
       'TIPEMP',
       0,
       'S',
       'Sociedade Annima (S.A.)',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8765 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MOV ',
       0,
       'MOV ',
       'Lanamento Estoque',
       'TV_MOV',
       'T',
       '',
       'TOTALL',
       'Lanamento de Estoque',
       '{CODFIL;CMPCHV;CODSER;NUMNOT;NUMITE};CODMAT;FILMAT;CODCOR;CODTAM;DATMOV;ATU_EM',
       '',
       '',
       'LanamentoEstoque',
       'T',
       '',
       'MOV.CODFIL,MOV.DOCUME',
       '' FROM DUAL
);

/*-- SEQ 8766 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MOV ','--','' FROM DUAL
UNION ALL
SELECT 'MOV ','01','Dados' FROM DUAL
);

/*-- SEQ 8767 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 25251,
       'GRA ',
       'MOV ',
       '1',
       'N',
       '',
       '',
       'GRA.FILMAT = MOV.FILMAT and
GRA.CODMAT = MOV.CODMAT and
GRA.CODCOR = MOV.CODCOR and
GRA.CODTAM = MOV.CODTAM
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 25252,
       'ICO ',
       'MOV ',
       '1',
       '1',
       '',
       '',
       'ICO.CODFIL(+) = MOV.CODFIL and
ICO.SEQUEN(+) = MOV.SEQUEN and
ICO.NUMITE(+) = MOV.NUMITE and
MOV.TIPMOV = case WHEN ICO.SEQUEN IS NOT NULL THEN ''C''
                                              ELSE MOV.TIPMOV
             END',
       '',
       '' FROM DUAL
UNION ALL
SELECT 25253,
       'IVE ',
       'MOV ',
       '1',
       '1',
       '',
       '',
       'IVE.CODFIL(+) = MOV.CODFIL and
IVE.SEQUEN(+) = MOV.SEQUEN and
IVE.NUMITE(+) = MOV.NUMITE and
MOV.TIPMOV = case WHEN IVE.SEQUEN IS NOT NULL THEN ''V''
                                              ELSE MOV.TIPMOV
             END',
       '',
       '' FROM DUAL
UNION ALL
SELECT 25254,
       'LAN ',
       'MOV ',
       '1',
       '1',
       '',
       '',
       'LAN.CODFIL(+) = MOV.CODFIL and
LAN.SEQUEN(+) = MOV.SEQUEN and
MOV.NUMITE = case WHEN LAN.SEQUEN IS NOT NULL THEN ''C''
                                              ELSE MOV.NUMITE
             END
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 25255,
       'SAL ',
       'MOV ',
       '1',
       'N',
       '',
       '',
       'SAL.CODFIL = MOV.CODFIL and
SAL.CODMUL = MOV.CODMUL and
SAL.FILMAT = MOV.FILMAT and
SAL.CODMAT = MOV.CODMAT and
SAL.CODCOR = MOV.CODCOR and
SAL.CODTAM = MOV.CODTAM
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 25256,
       'VSLE',
       'MOV ',
       '1',
       'N',
       '',
       '',
       'VSLE.CODFIL = MOV.CODFIL and
VSLE.CODMUL = MOV.CODMUL and
VSLE.FILMAT = MOV.FILMAT and
VSLE.CODMAT = MOV.CODMAT and
VSLE.CODCOR = MOV.CODCOR and
VSLE.CODTAM = MOV.CODTAM
',
       '',
       '' FROM DUAL
);

/*-- SEQ 8768 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MOV ',
       '01',
       155,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'MOV ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MOV',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(MOV.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       145,
       4,
       'ANO_DATMOV',
       'A',
       '',
       0,
       0,
       'MOV ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MOV',
       '',
       'N',
       'T',
       'Ano Data Mov.',
       'Ano de Data do movimento',
       '',
       'TO_CHAR(MOV.DATMOV,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       150,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'MOV ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MOV',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       330,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       120,
       2,
       'CODCOR',
       'S',
       'DIV ',
       0,
       0,
       'MOV ',
       80,
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       'MOV',
       'F',
       'A',
       'F',
       'Diviso do Produto',
       'Diviso do Produto',
       'MOV.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       0,
       'MOV ',
       30,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'MOV',
       'F',
       'A',
       'T',
       'Filial',
       'Cdigo da filial de origem',
       'MOV.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       110,
       5,
       'CODMAT',
       'A',
       '',
       0,
       0,
       'MOV ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MOV',
       'F',
       '9',
       'F',
       '',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       280,
       5,
       'CODMUL',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       'F',
       'Sub-Estoque',
       'Nome do Sub-Estoque',
       'DMUL.CODTAB = MOV.CODMUL',
       'CODMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       130,
       2,
       'CODTAM',
       'S',
       'SUB ',
       0,
       0,
       'MOV ',
       90,
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       'MOV',
       'F',
       'A',
       'F',
       'Sub-Diviso Produto',
       'Sub-Diviso do produto',
       'MOV.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       190,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       0,
       'MOV ',
       150,
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       'MOV',
       'F',
       'A',
       'T',
       'Usurio',
       'Cdigo do usurio',
       'MOV.FILUSU = USU.FILUSU(+)  and MOV.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       360,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       140,
       8,
       'DATMOV',
       'D',
       '',
       0,
       0,
       'MOV ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MOV',
       'F',
       'D',
       'T',
       'Data',
       'Data do movimento',
       '',
       'TRUNC(MOV.DATMOV)',
       'F' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       80,
       17,
       'DOCUME',
       'A',
       '',
       0,
       0,
       'MOV ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'MOV',
       'F',
       'A',
       'T',
       'Documento',
       'Nmero do documento',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       210,
       5,
       'EMBORI',
       'G',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       '9',
       'F',
       'Embalagem Original',
       'Embalagem Original',
       'MOV.EMBORI=SUB.CODITE(+)',
       'EMBORI',
       'T' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       200,
       12,
       'EMBQTD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Quantidade Original',
       'Quantidade Original',
       '',
       'EMBQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       340,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       100,
       3,
       'FILMAT',
       'A',
       '',
       0,
       0,
       'MOV ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MOV',
       'F',
       'N',
       'F',
       '',
       'Filial do material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       180,
       3,
       'FILUSU',
       'A',
       '',
       0,
       0,
       'MOV ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MOV',
       'F',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       310,
       12,
       'FIS_CM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       '',
       'Custo Financ. Fiscal',
       'Custo Mdio Fiscal * Quantidade contabilizada',
       '',
       'FIS_CM',
       '' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       320,
       12,
       'GER_CM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       '',
       'Custo Financ. Geren.',
       'Custo Mdio Gerencial * Quantidade contabilizada',
       '',
       'GER_CM',
       '' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       290,
       1,
       'LANEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       ' ',
       'A',
       'F',
       'Estoque',
       'Estoque',
       '',
       'LANEST',
       'T' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       153,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'MOV ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MOV',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(MOV.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       143,
       2,
       'MES_DATMOV',
       'A',
       '',
       0,
       0,
       'MOV ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MOV',
       '',
       'N',
       'T',
       'Ms Data Mov.',
       'Ms de Data do movimento',
       '',
       'TO_CHAR(MOV.DATMOV,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       17,
       12,
       'NATURE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       '9',
       'F',
       'Natureza',
       'Natureza da Operao',
       '',
       'NATURE',
       'F' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       270,
       20,
       'NUMEXT',
       'A',
       '',
       0,
       0,
       'MOV ',
       160,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'MOV',
       'F',
       'A',
       'T',
       'Nmero Externo',
       'Nmero externo',
       '',
       'NUMEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       90,
       2,
       'NUMITE',
       'S',
       '',
       0,
       0,
       'MOV ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MOV',
       'F',
       '9',
       'T',
       'Item',
       'Nmero do Item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       160,
       12,
       'QTDMOV',
       'F',
       '',
       2,
       0,
       'MOV ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MOV',
       'T',
       '9',
       'T',
       'Quantidade',
       'Quantidade movimentada',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       165,
       12,
       'QTDMOV_CON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtde~Convertida',
       'Quantidade movimentada Convertida',
       '',
       'QTDCONVERTIDA(MOV.CODTAM,MOV.QTDMOV)',
       'F' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       300,
       12,
       'QTD_CM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       '',
       'Qtd. p/ Custo Mdio',
       'Quantidade contabilizada para Custo mdio',
       '',
       'QTD_CM',
       '' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       350,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       20,
       1,
       'SITMOV',
       'A',
       '',
       0,
       0,
       'MOV ',
       20,
       30,
       '',
       '',
       'D',
       'MOV',
       'F',
       'A',
       'T',
       'Situao',
       'Tipo de movimento',
       '',
       'SITMOV',
       'T' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       10,
       1,
       'TIPMOV',
       'A',
       '',
       0,
       0,
       'MOV ',
       10,
       30,
       '',
       '',
       'D',
       'MOV',
       'F',
       'A',
       'T',
       'Tipo',
       'Tipo de movimentao',
       '',
       'TIPMOV',
       'T' FROM DUAL
UNION ALL
SELECT 'MOV ',
       '01',
       170,
       8,
       'VLRMOV',
       'F',
       '',
       2,
       0,
       'MOV ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MOV',
       'T',
       '9',
       'T',
       'Valor',
       'Valor movimentado',
       '',
       'VLRMOV',
       'F' FROM DUAL
);

/*-- SEQ 8769 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'MOV ',
       'LANEST',
       0,
       'C',
       'Confirma Reserva',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOV ',
       'LANEST',
       0,
       'N',
       'Nao (s Histrico)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOV ',
       'LANEST',
       0,
       'R',
       'Reserva',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOV ',
       'LANEST',
       0,
       'S',
       'Movimentao Estoque',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MOV ',
       'SITMOV',
       0,
       'C',
       'Cancelado',
       66,
       ' ' FROM DUAL
UNION ALL
SELECT 'MOV ',
       'SITMOV',
       0,
       'N',
       'Normal',
       67,
       ' ' FROM DUAL
UNION ALL
SELECT 'MOV ',
       'TIPMOV',
       0,
       'A',
       'Ajuste',
       75,
       ' ' FROM DUAL
UNION ALL
SELECT 'MOV ',
       'TIPMOV',
       0,
       'C',
       'Compra',
       74,
       ' ' FROM DUAL
UNION ALL
SELECT 'MOV ',
       'TIPMOV',
       0,
       'I',
       'Inicial',
       76,
       ' ' FROM DUAL
UNION ALL
SELECT 'MOV ',
       'TIPMOV',
       0,
       'V',
       'N.F. Emitidas e C.F.',
       73,
       ' ' FROM DUAL
);

/*-- SEQ 8770 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MOVD',
       TO_NUMBER(null),
       'MOVD',
       'R Mov. Estoque Dia',
       'TV_RMOV_DIA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8771 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MOVD','--','' FROM DUAL
UNION ALL
SELECT 'MOVD','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MOVD','02','Valores' FROM DUAL
UNION ALL
SELECT 'MOVD','99','Outros' FROM DUAL
);

/*-- SEQ 8772 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 12097,
       'PRO ',
       'MOVD',
       'N',
       'N',
       '',
       '',
       'MOVD.FILMAT = PRO.FILMAT AND
MOVD.CODMAT = PRO.CODMAT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 12098,
       'GRA ',
       'MOVD',
       'N',
       'N',
       '',
       '',
       'MOVD.FILMAT = GRA.FILMAT AND
MOVD.CODMAT = GRA.CODMAT AND
MOVD.CODCOR = GRA.CODCOR AND
MOVD.CODTAM = GRA.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 8773 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MOVD',
       '01',
       4,
       12,
       'CODCOR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Diviso ',
       'Diviso',
       '',
       'CODCOR',
       '' FROM DUAL
UNION ALL
SELECT 'MOVD',
       '01',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL = MOVD.CODFIL',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'MOVD',
       '01',
       3,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo do Material',
       'Cdigo do Material',
       '',
       'CODMAT',
       '' FROM DUAL
UNION ALL
SELECT 'MOVD',
       '01',
       6,
       5,
       'CODMUL',
       'A',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       '',
       'Sub-Estoque ',
       'Sub-Estoque',
       'DMUL.CODTAB = MOVD.CODMUL',
       'CODMUL',
       '' FROM DUAL
UNION ALL
SELECT 'MOVD',
       '01',
       5,
       12,
       'CODTAM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Sub-Diviso ',
       'Sub-Diviso ',
       '',
       'CODTAM',
       '' FROM DUAL
UNION ALL
SELECT 'MOVD',
       '99',
       30,
       8,
       'DATMOV',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data',
       'Data',
       '',
       'DATMOV',
       '' FROM DUAL
UNION ALL
SELECT 'MOVD',
       '01',
       2,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       '',
       'Filial do Material',
       'Filial do Material',
       '',
       'FILMAT',
       '' FROM DUAL
UNION ALL
SELECT 'MOVD',
       '02',
       9,
       10,
       'QTDCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Qtd. Compras',
       'Quantidade de Compras',
       '',
       'QTDCOM',
       '' FROM DUAL
UNION ALL
SELECT 'MOVD',
       '02',
       8,
       10,
       'QTDFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Qtd. Lanc. Avulsos',
       'Quantidade de Lanamentos Avulsos',
       '',
       'QTDFIS',
       '' FROM DUAL
UNION ALL
SELECT 'MOVD',
       '02',
       20,
       10,
       'QTDOUT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Qtd. Outros',
       'Qtd. Outros',
       '',
       'QTDOUT',
       '' FROM DUAL
UNION ALL
SELECT 'MOVD',
       '02',
       7,
       12,
       'QTDVEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Qtd. Vendas',
       'Quantidade de Vendas',
       '',
       'QTDVEN',
       '' FROM DUAL
UNION ALL
SELECT 'MOVD',
       '02',
       10,
       12,
       'SALDO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'T',
       'A',
       '',
       'Saldo de Estoque',
       'Saldo de Estoque',
       '',
       'SALDO',
       '' FROM DUAL
);

/*-- SEQ 8774 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MOVM',
       TO_NUMBER(null),
       'MOVM',
       'R Mov. Estoque Mes',
       'TV_RMOV_MES',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8775 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MOVM','--','' FROM DUAL
UNION ALL
SELECT 'MOVM','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MOVM','02','Valores' FROM DUAL
UNION ALL
SELECT 'MOVM','99','Outros' FROM DUAL
);

/*-- SEQ 8776 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 12099,
       'PRO ',
       'MOVM',
       'N',
       'N',
       '',
       '',
       'MOVM.FILMAT = PRO.FILMAT AND
MOVM.CODMAT = PRO.CODMAT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 12100,
       'GRA ',
       'MOVM',
       'N',
       'N',
       '',
       '',
       'MOVM.FILMAT = GRA.FILMAT AND
MOVM.CODMAT = GRA.CODMAT AND
MOVM.CODCOR = GRA.CODCOR AND
MOVM.CODTAM = GRA.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 8777 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MOVM',
       '01',
       4,
       12,
       'CODCOR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Diviso ',
       'Diviso',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'MOVM',
       '01',
       1,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       '',
       'Cdigo',
       'Cdigo',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MOVM',
       '01',
       3,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo do Material',
       'Cdigo do Material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'MOVM',
       '01',
       6,
       5,
       'CODMUL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Sub-Estoque ',
       'Sub-Estoque',
       '',
       'CODMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'MOVM',
       '01',
       5,
       12,
       'CODTAM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Sub-Diviso ',
       'Sub-Diviso ',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'MOVM',
       '99',
       30,
       8,
       'DATMOV',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data',
       'Data',
       '',
       'DATMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'MOVM',
       '01',
       2,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       '',
       'Filial do Material',
       'Filial do Material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'MOVM',
       '02',
       9,
       10,
       'QTDCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Qtd. Compras',
       'Quantidade de Compras',
       '',
       'QTDCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'MOVM',
       '02',
       8,
       10,
       'QTDFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Qtd. Lanc. Avulsos',
       'Quantidade de Lanamentos Avulsos',
       '',
       'QTDFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'MOVM',
       '02',
       20,
       10,
       'QTDOUT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Qtd. Outros',
       'Qtd. Outros',
       '',
       'QTDOUT',
       'F' FROM DUAL
UNION ALL
SELECT 'MOVM',
       '02',
       7,
       12,
       'QTDVEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Qtd. Vendas',
       'Quantidade de Vendas',
       '',
       'QTDVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'MOVM',
       '02',
       10,
       12,
       'SALDO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'T',
       'A',
       '',
       'Saldo de Estoque',
       'Saldo de Estoque',
       '',
       'SALDO',
       'F' FROM DUAL
);

/*-- SEQ 8778 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MPB ',
       TO_NUMBER(null),
       'MPB ',
       'MP do bem',
       'TT_MPB',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8779 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MPB ','--','' FROM DUAL
UNION ALL
SELECT 'MPB ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MPB ','99','Outros' FROM DUAL
);

/*-- SEQ 8780 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 55186,
       'IVE ',
       'MPB ',
       '1',
       'N',
       '',
       '',
       'IVE.CODFIL = MPB.FILVEN AND 
IVE.SEQUEN = MPB.SEQVEN AND 
(IVE.NUMITE = MPB.ITECPU OR 
 IVE.NUMITE = MPB.ITETEC OR 
 IVE.NUMITE = MPB.ITEMOU OR 
 IVE.NUMITE = MPB.ITEMON)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 55185,
       'DMPB',
       'MPB ',
       '1',
       '1',
       '',
       '',
       'MPB.TIPCONJ = DMPB.CODTAB
',
       '',
       '' FROM DUAL
);

/*-- SEQ 8781 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MPB ',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd Fil. do conjunto',
       'Cdigo da Filial do Conjunto',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MPB ',
       '--',
       20,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd Filial da Venda',
       'Cdigo da Filial da Venda',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'MPB ',
       '--',
       30,
       5,
       'ITECPU',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Item CPU/Notebook',
       'Item CPU/Notebook',
       '',
       'ITECPU',
       'F' FROM DUAL
UNION ALL
SELECT 'MPB ',
       '--',
       40,
       5,
       'ITEMON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Item Monitor',
       'Item Monitor',
       '',
       'ITEMON',
       'F' FROM DUAL
UNION ALL
SELECT 'MPB ',
       '--',
       50,
       5,
       'ITEMOU',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Item Mouse',
       'Item Mouse',
       '',
       'ITEMOU',
       'F' FROM DUAL
UNION ALL
SELECT 'MPB ',
       '--',
       60,
       5,
       'ITETEC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Item Teclado',
       'Item Teclado',
       '',
       'ITETEC',
       'F' FROM DUAL
UNION ALL
SELECT 'MPB ',
       '--',
       70,
       5,
       'QTDITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quant. Conj Formados',
       'Quantidade de Conjuntos Formados',
       '',
       'QTDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'MPB ',
       '--',
       80,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Seq do Conjunto',
       'Sequenciador do Conjunto',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'MPB ',
       '--',
       90,
       10,
       'SEQVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Seq da Venda',
       'Sequenciador da Venda',
       '',
       'SEQVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'MPB ',
       '--',
       100,
       5,
       'TIPCONJ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Conjunto',
       'Tipo de Conjunto',
       '',
       'TIPCONJ',
       'T' FROM DUAL
UNION ALL
SELECT 'MPB ',
       '--',
       110,
       14,
       'VLRLIQRAT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Lquido',
       'Valor Lquido Proporcional',
       '',
       '(VMPB.VLRLIQRAT / VMPB.QTDMOV) * MPB.QTDITE',
       '' FROM DUAL
);

/*-- SEQ 8782 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'MPB ',
       'TIPCONJ',
       6,
       ' ',
       'Conjunto Tipo Inciso VI',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MPB ',
       'TIPCONJ',
       7,
       ' ',
       'Conjunto Tipo Inciso VII',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MPB ',
       'TIPCONJ',
       8,
       ' ',
       'Conjunto Tipo Inciso VIII',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MPB ',
       'TIPCONJ',
       5,
       ' ',
       'Conjunto Tipo Inciso V',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MPB ',
       'TIPCONJ',
       1,
       ' ',
       'Conjunto Tipo Inciso I ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MPB ',
       'TIPCONJ',
       2,
       ' ',
       'Conjunto Tipo Inciso II',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MPB ',
       'TIPCONJ',
       3,
       ' ',
       'Conjunto Tipo Inciso III',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MPB ',
       'TIPCONJ',
       4,
       ' ',
       'Conjunto Tipo Inciso IV',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8783 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MPD ',
       TO_NUMBER(null),
       'MPD ',
       'Metas dirias',
       'TT_MPD',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'MPD.CODFIL, MPD.CODCTR, MPD.ANOREF, MPD.MESRE, MPD.DIAREF',
       '' FROM DUAL
);

/*-- SEQ 8784 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MPD ','--','' FROM DUAL
UNION ALL
SELECT 'MPD ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MPD ','99','Outros' FROM DUAL
);

/*-- SEQ 8785 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MPD ',
       '01',
       10,
       4,
       'ANOREF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Ano',
       'Ano',
       '',
       'ANOREF',
       'F' FROM DUAL
UNION ALL
SELECT 'MPD ',
       '01',
       20,
       5,
       'CODCTR',
       'S',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       '',
       'A',
       'F',
       'Unidade de Negcios',
       'Unidade de Negcios',
       'DCTR.CODTAB = MPD.CODCTR',
       'CODCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'MPD ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MPD ',
       '01',
       40,
       2,
       'DIAREF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Dia ',
       'Dia',
       '',
       'DIAREF',
       'F' FROM DUAL
UNION ALL
SELECT 'MPD ',
       '01',
       50,
       2,
       'MESREF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Ms',
       'Ms',
       '',
       'MESREF',
       'F' FROM DUAL
UNION ALL
SELECT 'MPD ',
       '99',
       60,
       12,
       'VALOR1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '1 Meta',
       '1 Meta',
       '',
       'VALOR1',
       'F' FROM DUAL
UNION ALL
SELECT 'MPD ',
       '99',
       70,
       12,
       'VALOR2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '2 Meta',
       '2 Meta',
       '',
       'VALOR2',
       'F' FROM DUAL
UNION ALL
SELECT 'MPD ',
       '99',
       80,
       12,
       'VALOR3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '3 Meta',
       '3 Meta',
       '',
       'VALOR3',
       'F' FROM DUAL
UNION ALL
SELECT 'MPD ',
       '99',
       90,
       12,
       'VALOR4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '4 Meta',
       '4 Meta',
       '',
       'VALOR4',
       'F' FROM DUAL
);

/*-- SEQ 8786 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MPF ',
       TO_NUMBER(null),
       'MPF ',
       'Metas p/Filial',
       'TT_MPF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'MPF.ANOREF,MPF.MESREF,MPF.CODFIL,MPF.CODCTR',
       '' FROM DUAL
);

/*-- SEQ 8787 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MPF ','--','' FROM DUAL
UNION ALL
SELECT 'MPF ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MPF ','02','Datas' FROM DUAL
UNION ALL
SELECT 'MPF ','03','Valores' FROM DUAL
);

/*-- SEQ 8788 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MPF ',
       '03',
       1,
       4,
       'ANOREF',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Ano Referncia',
       'Ano Referncia',
       '',
       'ANOREF',
       'F' FROM DUAL
UNION ALL
SELECT 'MPF ',
       '01',
       21,
       5,
       'CODCTR',
       'S',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       '',
       'N',
       'F',
       'Unidade de Negcios',
       'Unidade de Negcios',
       'DCTR.CODTAB = MPF.CODCTR',
       'CODCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'MPF ',
       '01',
       3,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = MPF.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MPF ',
       '03',
       4,
       12,
       'COMIS1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Comisso 1',
       'Comisso 1',
       '',
       'COMIS1',
       'F' FROM DUAL
UNION ALL
SELECT 'MPF ',
       '03',
       5,
       12,
       'COMIS2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Comisso 2',
       'Comisso 2',
       '',
       'COMIS2',
       'F' FROM DUAL
UNION ALL
SELECT 'MPF ',
       '03',
       6,
       12,
       'COMIS3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Comisso 3',
       'Comisso 3',
       '',
       'COMIS3',
       'F' FROM DUAL
UNION ALL
SELECT 'MPF ',
       '03',
       7,
       12,
       'COMIS4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Comisso 4',
       'Comisso 4',
       '',
       'COMIS4',
       'F' FROM DUAL
UNION ALL
SELECT 'MPF ',
       '03',
       2,
       2,
       'MESREF',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Ms Referncia',
       'Ms Referncia',
       '',
       'MESREF',
       'F' FROM DUAL
UNION ALL
SELECT 'MPF ',
       '01',
       30,
       3,
       'NUMCODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'NUMCODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MPF ',
       '03',
       8,
       12,
       'VALOR1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor 1',
       'Valor 1',
       '',
       'VALOR1',
       'F' FROM DUAL
UNION ALL
SELECT 'MPF ',
       '03',
       9,
       12,
       'VALOR2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor 2',
       'Valor 2',
       '',
       'VALOR2',
       'F' FROM DUAL
UNION ALL
SELECT 'MPF ',
       '03',
       10,
       12,
       'VALOR3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor 3',
       'Valor 3',
       '',
       'VALOR3',
       'F' FROM DUAL
UNION ALL
SELECT 'MPF ',
       '03',
       11,
       12,
       'VALOR4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor 4',
       'Valor 4',
       '',
       'VALOR4',
       'F' FROM DUAL
);

/*-- SEQ 8789 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MPR ',
       TO_NUMBER(null),
       'MPR ',
       'Mapa de Resumo (ECF)',
       'TT_MPR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'MPR.CODFIL, MPR.DATOPE',
       '' FROM DUAL
);

/*-- SEQ 8790 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MPR ','--','' FROM DUAL
UNION ALL
SELECT 'MPR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MPR ','99','Outros' FROM DUAL
);

/*-- SEQ 8791 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MPR ',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial do Mapa Resumo',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MPR ',
       '--',
       20,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data da Operao',
       'Data da Movimentao do Mapa Resumo (Leitura Z)',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'MPR ',
       '--',
       30,
       5,
       'NUMERO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero do Mapa',
       'Nmero do Mapa Resumo',
       '',
       'NUMERO',
       'F' FROM DUAL
);

/*-- SEQ 8792 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MRD ',
       TO_NUMBER(null),
       'MRD ',
       'Mapa Resumo Dirio',
       'TT_MRD',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'MRD.CODFIL,MRD.DATOPE',
       '' FROM DUAL
);

/*-- SEQ 8793 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MRD ','--','' FROM DUAL
UNION ALL
SELECT 'MRD ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MRD ','99','Outros' FROM DUAL
);

/*-- SEQ 8794 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 5673,
       'USU ',
       'MRD ',
       '01',
       '0N',
       '',
       '',
       'USU.FILUSU = MRD.FILUSU AND
USU.CODUSU = MRD.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 8795 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MRD ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = MRD.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MRD ',
       '01',
       20,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Usurio',
       'Cdigo Usurio',
       'USU2.FILUSU(+) = MRD.FILUSU AND USU2.CODUSU(+) = MRD.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'MRD ',
       '01',
       30,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Operao',
       'Data da Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'MRD ',
       '01',
       40,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'MRD ',
       '01',
       50,
       6,
       'NUMERO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero',
       'Nmero',
       '',
       'NUMERO',
       'F' FROM DUAL
UNION ALL
SELECT 'MRD ',
       '01',
       60,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
);

/*-- SEQ 8796 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MREC',
       TO_NUMBER(null),
       'MREC',
       'Movimentao Receb.',
       'TM_REC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'MREC.CODFIL,MREC.SEQUEN,MREC.NUMPAR,MREC.SUBPAR
',
       '' FROM DUAL
);

/*-- SEQ 8797 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MREC','--','' FROM DUAL
UNION ALL
SELECT 'MREC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MREC','99','Outros' FROM DUAL
);

/*-- SEQ 8798 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MREC',
       '--',
       10,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       20,
       5,
       'CARTAO',
       'S',
       'DCAR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCAR.DESOUT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Carto',
       'Carto de Crdito',
       'DCAR.CODTAB(+) = MREC.CARTAO',
       'CARTAO',
       'T' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       30,
       15,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Alternativo',
       'Cdigo Alternativo nico',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       40,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'MREC.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       50,
       2,
       'CODMOE',
       'S',
       'DMOE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       '',
       'F',
       'A',
       'F',
       'Moeda',
       'Cdigo da moeda',
       'MREC.CODMOE=DMOE.CODTAB (+)',
       'CODMOE',
       'T' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       60,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial do Usurio',
       'Filial do Usurio',
       'MREC.FILUSU = USU.FILUSU(+)  AND MREC.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       70,
       8,
       'CUPFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cupom Fiscal',
       'Cupom fiscal',
       '',
       'CUPFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       80,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Operao',
       'Data de Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       90,
       8,
       'DATVEN',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Vencimento',
       'Data de vencimento',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       100,
       1,
       'DUMMY',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       '',
       'Cdigo da filial do recebimento',
       '',
       'DUMMY',
       'F' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       110,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial Recebimento',
       'Cdigo da filial do recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       120,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       130,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       140,
       1,
       'FLGREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Flag',
       'Flag',
       '',
       'FLGREC',
       'F' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       150,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       'ECF',
       'Nmero do ECF que recebeu a parcela',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       160,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Parcela',
       'Nmero da parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       170,
       254,
       'OBSERV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       180,
       8,
       'PAGAME',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data de Pagamento',
       'Data e hora de Pagamento',
       '',
       'PAGAME',
       'F' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       190,
       2,
       'PORTAD',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       'F',
       'A',
       'F',
       'Portador',
       'Cdigo do portador',
       'MREC.PORTAD=DCOB.CODTAB (+)',
       'PORTAD',
       'T' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       200,
       2,
       'RENEGO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Renegociao',
       'Renegociao',
       '',
       'RENEGO',
       'F' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       210,
       2,
       'RENORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Renegociao Origem',
       'Renegociao Origem',
       '',
       'RENORI',
       'F' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       220,
       10,
       'SEQCHE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Chave Cheque',
       '',
       'SEQCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       230,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       240,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN MREC.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       241,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN MREC.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       250,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Sub-Parcela',
       'Nmero da sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       260,
       5,
       'TIPCCC',
       'S',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       'A',
       'F',
       'Tipo Conta Correte',
       'Tipo Conta Corrente',
       'DCCC.CODTAB(+) = MREC.TIPCCC',
       'TIPCCC',
       'T' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       270,
       12,
       'VLRDES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Desconto',
       'Valor Desconto',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       280,
       8,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr. Parcela',
       'Valor da parcela',
       '',
       'VLRPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'MREC',
       '--',
       290,
       8,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr. Pago',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 8799 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'MREC',
       'FLGEST',
       0,
       'A',
       'Em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MREC',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MREC',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MREC',
       'FLGEST',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8800 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MSG ',
       TO_NUMBER(null),
       'MSG ',
       'Mensagens',
       'TT_MSG',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'MSG.CODFIL,MSG.SEQUEN,MSG.SEQMSG',
       '' FROM DUAL
);

/*-- SEQ 8801 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MSG ','--','' FROM DUAL
UNION ALL
SELECT 'MSG ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MSG ','02','Datas' FROM DUAL
UNION ALL
SELECT 'MSG ','03','Valores' FROM DUAL
UNION ALL
SELECT 'MSG ','99','Outros' FROM DUAL
);

/*-- SEQ 8802 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 5674,
       'CON ',
       'MSG ',
       '1',
       '0N',
       '',
       '',
       'CON.FILCLI = MSG.FILCLI AND
CON.CODCLI = MSG.CODCLI AND
CON.NUMCON = MSG.NUMCON',
       '',
       '' FROM DUAL
UNION ALL
SELECT 5675,
       'PSU ',
       'MSG ',
       '1',
       '0N',
       '',
       '',
       'MSG.CODFIL(+) = PSU.CODFIL and
MSG.SEQUEN(+) = PSU.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 5676,
       'SPT ',
       'MSG ',
       '1',
       '0N',
       '',
       '',
       'MSG.CODFIL(+) = SPT.CODFIL and
MSG.SEQUEN(+) = SPT.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 5677,
       'SUP ',
       'MSG ',
       '1',
       '0N',
       '',
       '',
       'MSG.CODFIL(+) = SUP.CODFIL and
MSG.SEQUEN(+) = SUP.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 5678,
       'USU ',
       'MSG ',
       '01',
       '0N',
       '',
       '',
       'USU.FILUSU = MSG.FILUSU AND
USU.CODUSU = MSG.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 8803 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MSG ',
       '99',
       90,
       4000,
       'ANEXOS',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Anexos',
       'Anexos',
       '',
       'RTF2TXT(ANEXOS)',
       'F' FROM DUAL
UNION ALL
SELECT 'MSG ',
       '02',
       67,
       4,
       'ANO_DATMSG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data Mensagem',
       'Ano de Data Mensagem',
       '',
       'TO_CHAR(MSG.DATMSG,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MSG ',
       '01',
       110,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'MSG ',
       '01',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial do SAC',
       'Filial do SAC',
       'DFIL.CODFIL = MSG.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MSG ',
       '01',
       5,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Registrado por:',
       'Registrado por:',
       'MSG.FILUSU = USU.FILUSU(+) AND MSG.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'MSG ',
       '02',
       60,
       8,
       'DATMSG',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Mensagem',
       'Data Mensagem',
       '',
       'DATMSG',
       'F' FROM DUAL
UNION ALL
SELECT 'MSG ',
       '01',
       70,
       40,
       'DESMSG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'L',
       '',
       'F',
       'A',
       'F',
       'Descrio Mensagem',
       'Descrio Mensagem',
       '',
       'DESMSG',
       'F' FROM DUAL
UNION ALL
SELECT 'MSG ',
       '01',
       120,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'MSG ',
       '01',
       4,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do registrante',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'MSG ',
       '02',
       65,
       2,
       'MES_DATMSG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data Mensagem',
       'Ms de Data Mensagem',
       '',
       'TO_CHAR(MSG.DATMSG,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'MSG ',
       '01',
       80,
       4000,
       'MSGSUP',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Detalhe Mensagem',
       'Detalhe Mensagem',
       '',
       'RTF2TXT(MSGSUP)',
       'F' FROM DUAL
UNION ALL
SELECT 'MSG ',
       '01',
       130,
       8,
       'NUMCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Conhecimento',
       'Conhecimento de frete',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'MSG ',
       '99',
       100,
       1,
       'RESPOS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Enviada?',
       'Enviada?',
       '',
       'COALESCE(RESPOS,'' '')',
       'T' FROM DUAL
UNION ALL
SELECT 'MSG ',
       '01',
       3,
       5,
       'SEQMSG',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       '',
       'Sequenciador interno',
       '',
       'SEQMSG',
       'F' FROM DUAL
UNION ALL
SELECT 'MSG ',
       '01',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8804 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'MSG ',
       'RESPOS',
       0,
       ' ',
       'Nao enviado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MSG ',
       'RESPOS',
       0,
       'A',
       'Nao Enviado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MSG ',
       'RESPOS',
       0,
       'M',
       'Enviado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MSG ',
       'RESPOS',
       0,
       'R',
       'Recebido',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8805 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MTA ',
       TO_NUMBER(null),
       'MTA ',
       'Metas Alcanadas',
       'TV_MET',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'MTA.FILUSU,MTA.CODUSU,MTA.ANOREF,MTA.MESREF',
       '' FROM DUAL
);

/*-- SEQ 8806 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MTA ','--','' FROM DUAL
UNION ALL
SELECT 'MTA ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MTA ','02','Valores' FROM DUAL
UNION ALL
SELECT 'MTA ','03','Datas' FROM DUAL
);

/*-- SEQ 8807 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 32751,
       'USU ',
       'MTA ',
       '01',
       '0N',
       '',
       '',
       'USU.FILUSU = MTA.FILUSU AND
USU.CODUSU = MTA.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 8808 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MTA ',
       '03',
       30,
       4,
       'ANOREF',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Ano',
       'Ano Referncia',
       '',
       'ANOREF',
       'F' FROM DUAL
UNION ALL
SELECT 'MTA ',
       '02',
       140,
       12,
       'CNTVEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtdade de Vendas',
       'Quantidade Vendas',
       '',
       'CNTVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'MTA ',
       '01',
       20,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Vendedor',
       'Cdigo Usurio',
       'MTA.FILUSU = USU.FILUSU(+) AND MTA.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'MTA ',
       '02',
       90,
       12,
       'COMIS1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '1 Prmio',
       '1 Prmio',
       '',
       'COMIS1',
       'F' FROM DUAL
UNION ALL
SELECT 'MTA ',
       '02',
       100,
       12,
       'COMIS2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '2 Prmio',
       '2 Prmio',
       '',
       'COMIS2',
       'F' FROM DUAL
UNION ALL
SELECT 'MTA ',
       '02',
       110,
       12,
       'COMIS3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '3 Prmio',
       '3 Prmio',
       '',
       'COMIS3',
       'F' FROM DUAL
UNION ALL
SELECT 'MTA ',
       '02',
       120,
       12,
       'COMIS4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '4 Prmio',
       '4 Prmio',
       '',
       'COMIS4',
       'F' FROM DUAL
UNION ALL
SELECT 'MTA ',
       '03',
       210,
       8,
       'DATREF',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Meta',
       'Data Referncia',
       '',
       '(TO_DATE(''01'' || TO_CHAR(MESREF,''FM09'') || TO_CHAR(ANOREF,''FM0999''),''DDMMYYYY''))',
       '' FROM DUAL
UNION ALL
SELECT 'MTA ',
       '01',
       10,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       'Filial~Usurio',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'MTA ',
       '03',
       40,
       2,
       'MESREF',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Ms',
       'Ms Referncia',
       '',
       'MESREF',
       'F' FROM DUAL
UNION ALL
SELECT 'MTA ',
       '02',
       170,
       12,
       'PREMI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Prmio atingido',
       'Prmio atingido',
       '',
       'PREMI',
       'F' FROM DUAL
UNION ALL
SELECT 'MTA ',
       '02',
       150,
       12,
       'VALALC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Meta atindida',
       'Valor da meta atingida',
       '',
       'VALALC',
       'F' FROM DUAL
UNION ALL
SELECT 'MTA ',
       '02',
       50,
       12,
       'VALOR1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '1 Meta',
       '1 Meta',
       '',
       'VALOR1',
       'F' FROM DUAL
UNION ALL
SELECT 'MTA ',
       '02',
       60,
       12,
       'VALOR2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '2 Meta',
       '2 Meta',
       '',
       'VALOR2',
       'F' FROM DUAL
UNION ALL
SELECT 'MTA ',
       '02',
       70,
       12,
       'VALOR3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '3 Meta',
       '3 Meta',
       '',
       'VALOR3',
       'F' FROM DUAL
UNION ALL
SELECT 'MTA ',
       '02',
       80,
       12,
       'VALOR4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '4 Meta',
       '4 Meta',
       '',
       'VALOR4',
       'F' FROM DUAL
UNION ALL
SELECT 'MTA ',
       '02',
       130,
       12,
       'VLRREA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vendas lquidas',
       'Somatrio do total lquido das vendas',
       '',
       'VLRREA',
       'F' FROM DUAL
);

/*-- SEQ 8809 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MTAC',
       TO_NUMBER(null),
       'MTAC',
       'Metas Alc. Por Categ',
       'TV_MET_IVE2',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'MTAC.FILUSU,MTAC.CODUSU,MTAC.ANOREF,MTAC.MESREF',
       '' FROM DUAL
);

/*-- SEQ 8810 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MTAC','--','' FROM DUAL
UNION ALL
SELECT 'MTAC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MTAC','02','Valores' FROM DUAL
UNION ALL
SELECT 'MTAC','03','Datas' FROM DUAL
);

/*-- SEQ 8811 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 28809,
       'USU ',
       'MTAC',
       '01',
       '0N',
       '',
       '',
       'USU.FILUSU = MTAC.FILUSU AND
USU.CODUSU = MTAC.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 8812 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MTAC',
       '03',
       30,
       4,
       'ANOREF',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Ano',
       'Ano Referncia',
       '',
       'ANOREF',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAC',
       '--',
       220,
       5,
       'CATEG1',
       'S',
       'DCT1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'V',
       '',
       '',
       'A',
       '',
       'Categoria 1',
       'Categoria 1',
       'DCT1.CODTAB = MTAC.CATEG1',
       'CATEG1',
       '' FROM DUAL
UNION ALL
SELECT 'MTAC',
       '02',
       140,
       12,
       'CNTVEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtdade de Vendas',
       'Quantidade Vendas',
       '',
       'CNTVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAC',
       '01',
       20,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Vendedor',
       'Cdigo Usurio',
       'MTAC.FILUSU = USU.FILUSU(+) AND MTAC.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'MTAC',
       '02',
       90,
       12,
       'COMIS1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '1 Prmio',
       '1 Prmio',
       '',
       'COMIS1',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAC',
       '02',
       100,
       12,
       'COMIS2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '2 Prmio',
       '2 Prmio',
       '',
       'COMIS2',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAC',
       '02',
       110,
       12,
       'COMIS3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '3 Prmio',
       '3 Prmio',
       '',
       'COMIS3',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAC',
       '02',
       120,
       12,
       'COMIS4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '4 Prmio',
       '4 Prmio',
       '',
       'COMIS4',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAC',
       '03',
       210,
       8,
       'DATREF',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Meta',
       'Data Referncia',
       '',
       '(TO_DATE(''01'' || TO_CHAR(MESREF,''FM09'') || TO_CHAR
(ANOREF,''FM0999''),''DDMMYYYY''))',
       '' FROM DUAL
UNION ALL
SELECT 'MTAC',
       '01',
       10,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       'Filial Usurio',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAC',
       '03',
       40,
       2,
       'MESREF',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Ms',
       'Ms Referncia',
       '',
       'MESREF',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAC',
       '02',
       170,
       12,
       'PREMI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Prmio atingido',
       'Prmio atingido',
       '',
       'PREMI',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAC',
       '02',
       180,
       12,
       'SUBSTT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Subst. Tribut.',
       'Valor de subistituio tributria',
       '',
       'SUBSTT',
       '' FROM DUAL
UNION ALL
SELECT 'MTAC',
       '02',
       150,
       12,
       'VALALC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Meta atindida',
       'Valor da meta atingida',
       '',
       'VALALC',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAC',
       '02',
       50,
       12,
       'VALOR1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '1 Meta',
       '1 Meta',
       '',
       'VALOR1',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAC',
       '02',
       60,
       12,
       'VALOR2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '2 Meta',
       '2 Meta',
       '',
       'VALOR2',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAC',
       '02',
       70,
       12,
       'VALOR3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '3 Meta',
       '3 Meta',
       '',
       'VALOR3',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAC',
       '02',
       80,
       12,
       'VALOR4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '4 Meta',
       '4 Meta',
       '',
       'VALOR4',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAC',
       '02',
       190,
       12,
       'VLRIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor do IPI ',
       'Valor do IPI',
       '',
       'VLRIPI',
       '' FROM DUAL
UNION ALL
SELECT 'MTAC',
       '02',
       200,
       12,
       'VLRPROPOR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Lquido Propo',
       'Valor Lquido Proporcional',
       '',
       'VLRPROPOR',
       '' FROM DUAL
UNION ALL
SELECT 'MTAC',
       '02',
       130,
       12,
       'VLRREA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vendas lquidas',
       'Somatrio do total lquido das vendas',
       '',
       'VLRREA',
       'F' FROM DUAL
);

/*-- SEQ 8813 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MTAI',
       TO_NUMBER(null),
       'MTAI',
       'Metas Alcanadas Proporcionais',
       'TV_MET_IVE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'MTAI.FILUSU,MTAI.CODUSU,MTAI.ANOREF,MTAI.MESREF',
       '' FROM DUAL
);

/*-- SEQ 8814 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MTAI','--','' FROM DUAL
UNION ALL
SELECT 'MTAI','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MTAI','02','Valores' FROM DUAL
UNION ALL
SELECT 'MTAI','03','Datas' FROM DUAL
);

/*-- SEQ 8815 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 32751,
       'USU ',
       'MTAI',
       '01',
       '0N',
       '',
       '',
       'USU.FILUSU = MTAI.FILUSU AND
USU.CODUSU = MTAI.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 8816 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MTAI',
       '03',
       30,
       4,
       'ANOREF',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Ano',
       'Ano Referncia',
       '',
       'ANOREF',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAI',
       '02',
       140,
       12,
       'CNTVEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtdade de Vendas',
       'Quantidade Vendas',
       '',
       'CNTVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAI',
       '01',
       20,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Vendedor',
       'Cdigo Usurio',
       'MTAI.FILUSU = USU.FILUSU(+) AND MTAI.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'MTAI',
       '02',
       90,
       12,
       'COMIS1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '1 Prmio',
       '1 Prmio',
       '',
       'COMIS1',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAI',
       '02',
       100,
       12,
       'COMIS2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '2 Prmio',
       '2 Prmio',
       '',
       'COMIS2',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAI',
       '02',
       110,
       12,
       'COMIS3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '3 Prmio',
       '3 Prmio',
       '',
       'COMIS3',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAI',
       '02',
       120,
       12,
       'COMIS4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '4 Prmio',
       '4 Prmio',
       '',
       'COMIS4',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAI',
       '03',
       210,
       8,
       'DATREF',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Meta',
       'Data Referncia',
       '',
       '(TO_DATE(''01'' || TO_CHAR(MESREF,''FM09'') || TO_CHAR(ANOREF,''FM0999''),''DDMMYYYY''))',
       '' FROM DUAL
UNION ALL
SELECT 'MTAI',
       '01',
       10,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       'Filial~Usurio',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAI',
       '03',
       40,
       2,
       'MESREF',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Ms',
       'Ms Referncia',
       '',
       'MESREF',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAI',
       '02',
       170,
       12,
       'PREMI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Prmio atingido',
       'Prmio atingido',
       '',
       'PREMI',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAI',
       '02',
       180,
       12,
       'SUBSTT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Subst. Tribut.',
       'Valor de subistituio tributria',
       '',
       'SUBSTT',
       '' FROM DUAL
UNION ALL
SELECT 'MTAI',
       '02',
       150,
       12,
       'VALALC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Meta atindida',
       'Valor da meta atingida',
       '',
       'VALALC',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAI',
       '02',
       50,
       12,
       'VALOR1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '1 Meta',
       '1 Meta',
       '',
       'VALOR1',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAI',
       '02',
       60,
       12,
       'VALOR2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '2 Meta',
       '2 Meta',
       '',
       'VALOR2',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAI',
       '02',
       70,
       12,
       'VALOR3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '3 Meta',
       '3 Meta',
       '',
       'VALOR3',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAI',
       '02',
       80,
       12,
       'VALOR4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '4 Meta',
       '4 Meta',
       '',
       'VALOR4',
       'F' FROM DUAL
UNION ALL
SELECT 'MTAI',
       '02',
       190,
       12,
       'VLRIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor do IPI ',
       'Valor do IPI',
       '',
       'VLRIPI',
       '' FROM DUAL
UNION ALL
SELECT 'MTAI',
       '02',
       200,
       12,
       'VLRPROPOR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Lquido Propor',
       'Valor Lquido Proporcional',
       '',
       'VLRPROPOR',
       '' FROM DUAL
UNION ALL
SELECT 'MTAI',
       '02',
       130,
       12,
       'VLRREA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vendas lquidas',
       'Somatrio do total lquido das vendas',
       '',
       'VLRREA',
       'F' FROM DUAL
);

/*-- SEQ 8817 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MUN ',
       0,
       'MUN ',
       'Municpios',
       'TT_MUN',
       'T',
       '',
       'TOTALL',
       'Municpios',
       'CODCEP',
       'NOMCID',
       'NOMCID',
       'Municpio',
       'T',
       '',
       'MUN.CODIGO
MUN.NOMCID,MUN.SIGEST
MUN.CODCEP
MUN.CEPINI',
       '' FROM DUAL
);

/*-- SEQ 8818 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MUN ','--','' FROM DUAL
);

/*-- SEQ 8819 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MUN ',
       '--',
       30,
       5,
       'CEPINI',
       'A',
       '',
       0,
       0,
       'MUN ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MUN',
       'F',
       '0',
       'T',
       'Cep Inicial',
       'CEP inicial',
       '',
       'CEPINI',
       'F' FROM DUAL
UNION ALL
SELECT 'MUN ',
       '--',
       20,
       5,
       'CODCEP',
       'A',
       '',
       0,
       0,
       'MUN ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MUN',
       'F',
       '0',
       'T',
       'Cep Final',
       'CEP final',
       '',
       'CODCEP',
       'F' FROM DUAL
UNION ALL
SELECT 'MUN ',
       '--',
       70,
       10,
       'CODIBG',
       'S',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cod. Municpio IBGE',
       'Cdigo Municpio IBGE',
       '',
       'CODIBG',
       '' FROM DUAL
UNION ALL
SELECT 'MUN ',
       '--',
       10,
       5,
       'CODIGO',
       'A',
       '',
       0,
       0,
       'MUN ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'MUN',
       'F',
       '9',
       'T',
       'Cdigo',
       'Cdigo da Cidade',
       '',
       'CODIGO',
       'F' FROM DUAL
UNION ALL
SELECT 'MUN ',
       '--',
       40,
       26,
       'NOMCID',
       'A',
       '',
       0,
       0,
       'MUN ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'MUN',
       'F',
       'A',
       'T',
       'Nome do Municpio',
       'Nome do municpio',
       '',
       'NOMCID',
       'F' FROM DUAL
UNION ALL
SELECT 'MUN ',
       '--',
       50,
       2,
       'SIGEST',
       'A',
       'DEST',
       0,
       0,
       'MUN ',
       50,
       TO_NUMBER(null),
       '',
       'DEST.ESTADO',
       'V',
       'MUN',
       'F',
       'A',
       'T',
       'U.F.',
       'Sigla do estado',
       'DEST.ESTADO(+) = MUN.SIGEST',
       'SIGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'MUN ',
       '--',
       61,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN MUN.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'MUN ',
       '--',
       60,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'MUN ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'MUN',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN MUN.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
);

/*-- SEQ 8820 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MVA ',
       TO_NUMBER(null),
       'MVA ',
       'Margem Vlr. Agregado',
       'TT_MVA',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8821 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MVA ','--','' FROM DUAL
UNION ALL
SELECT 'MVA ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MVA ','99','Outros' FROM DUAL
);

/*-- SEQ 8822 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20259,
       'IPT ',
       'MVA ',
       '1',
       'N',
       '',
       '',
       'MVA.CODFIL = IPT.CODFIL AND 
MVA.SEQUEN = IPT.SEQUEN AND 
MVA.NUMITE = IPT.NUMITE',
       '',
       '' FROM DUAL
);

/*-- SEQ 8823 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'MVA ',
       '--',
       10,
       5,
       'ALIEST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Aliqu. Interestadual',
       'Aliquota Interestadual',
       '',
       'ALIEST',
       'F' FROM DUAL
UNION ALL
SELECT 'MVA ',
       '--',
       20,
       5,
       'ALIINT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Aliquota Interna',
       'Aliquota Interna',
       '',
       'ALIINT',
       'F' FROM DUAL
UNION ALL
SELECT 'MVA ',
       '--',
       30,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'MVA ',
       '--',
       40,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'MVA ',
       '--',
       50,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'MVA ',
       '--',
       60,
       5,
       'ITEMVA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero item exceo',
       'Nmero do item da exceo - ( o maior nmero + 1)',
       '',
       'ITEMVA',
       'F' FROM DUAL
UNION ALL
SELECT 'MVA ',
       '--',
       70,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero do item',
       'Nmero do item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'MVA ',
       '--',
       80,
       5,
       'PERMVA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Margem Vlr. Agregado',
       'Margem de Valor Agregado',
       '',
       'PERMVA',
       'F' FROM DUAL
UNION ALL
SELECT 'MVA ',
       '--',
       90,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'MVA ',
       '--',
       100,
       1,
       'TIPOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Operao',
       'Tipo de Operao (I-Interna/E-Estadual/A-Ambos)',
       '',
       'TIPOPE',
       'T' FROM DUAL
);

/*-- SEQ 8824 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'MVA ',
       'TIPOPE',
       0,
       'A',
       'Ambos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MVA ',
       'TIPOPE',
       0,
       'E',
       'Estadual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'MVA ',
       'TIPOPE',
       0,
       'I',
       'Interna',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8825 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'MXCO',
       TO_NUMBER(null),
       'MXCO',
       'Rel. Cor e Veculo',
       'TT_DMTDXDCORVEI',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8826 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'MXCO','--','' FROM DUAL
UNION ALL
SELECT 'MXCO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'MXCO','99','Outros' FROM DUAL
);

/*-- SEQ 8827 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22041,
       'DCVE',
       'MXCO',
       '1',
       '1',
       '',
       '',
       'DCVE.CODTAB = MXCO.CODCORVEI(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22042,
       'DMTD',
       'MXCO',
       '1',
       '1',
       '',
       '',
       'DMTD.CODTAB = MXCO.CODMTD(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8828 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'MXCO',
       '01',
       50,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'MXCO',
       '01',
       30,
       5,
       'CODCORVEI',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo Cor Veculo',
       'Cdigo da Cor do Veculo',
       '',
       'CODCORVEI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'MXCO',
       '01',
       10,
       4,
       'CODIGO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo da Cor',
       'Cdigo da Cor',
       '',
       'CODIGO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'MXCO',
       '01',
       20,
       5,
       'CODMTD',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo da Montadora',
       'Cdigo da Montadora',
       '',
       'CODMTD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'MXCO',
       '01',
       40,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       '',
       'D' FROM DUAL
);

/*-- SEQ 8829 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'NAE ',
       TO_NUMBER(null),
       'NAE ',
       'Classificao Nacional de Atividades Econmicas',
       'TT_NAE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'NAE.CODNAE',
       '' FROM DUAL
);

/*-- SEQ 8830 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'NAE ','--','' FROM DUAL
UNION ALL
SELECT 'NAE ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'NAE ','99','Outros' FROM DUAL
);

/*-- SEQ 8831 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'NAE ',
       '--',
       10,
       7,
       'CODNAE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       'F',
       'Cdigo CNAE',
       'Cdigo CNAE',
       '',
       'CODNAE',
       'F' FROM DUAL
UNION ALL
SELECT 'NAE ',
       '--',
       20,
       1,
       'NIVNAE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Nvel',
       'Nvel',
       '',
       'NIVNAE',
       'F' FROM DUAL
UNION ALL
SELECT 'NAE ',
       '--',
       30,
       200,
       'NOMNAE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Denominao',
       'Denominao',
       '',
       'NOMNAE',
       'F' FROM DUAL
UNION ALL
SELECT 'NAE ',
       '--',
       40,
       1,
       'SECNAE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Seo',
       'Seo',
       '',
       'SECNAE',
       'F' FROM DUAL
);

/*-- SEQ 8832 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'NAE ',
       'NIVNAE',
       1,
       ' ',
       'Diviso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'NIVNAE',
       2,
       ' ',
       'Grupo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'NIVNAE',
       3,
       ' ',
       'Classe',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'NIVNAE',
       4,
       ' ',
       'Subclasse',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'SECNAE',
       0,
       'A',
       'AGRICULTURA, PECURIA, PRODU.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'SECNAE',
       0,
       'B',
       'INDSTRIAS EXTRATIVAS',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'SECNAE',
       0,
       'C',
       'INDSTRIAS DE TRANSFORMAO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'SECNAE',
       0,
       'D',
       'ELETRICIDADE E GS',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'SECNAE',
       0,
       'E',
       'GUA, ESGOTO,  GEST. RESDUOS',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'SECNAE',
       0,
       'F',
       'CONSTRUO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'SECNAE',
       0,
       'G',
       'COMRCIO; REPARAO DE VECULO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'SECNAE',
       0,
       'H',
       'TRANSPORTE, ARMAZEN. E CORREIO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'SECNAE',
       0,
       'I',
       'ALOJAMENTO E ALIMENTAO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'SECNAE',
       0,
       'J',
       'INFORMAO E COMUNICAO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'SECNAE',
       0,
       'K',
       'ATIVIDADES FINANCEIRAS, SEGURO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'SECNAE',
       0,
       'L',
       'ATIVIDADES IMOBILIRIAS',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'SECNAE',
       0,
       'M',
       'ATIVIDADES PROF., CIEN. E TC.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'SECNAE',
       0,
       'N',
       'ATIVIDADES ADM. SERVIOS COMP.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'SECNAE',
       0,
       'O',
       'ADM. PBLICA, DEFESA E SEGURID',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'SECNAE',
       0,
       'P',
       'EDUCAO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'SECNAE',
       0,
       'Q',
       'SADE HUMANA E SERVIOS SOCIA.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'SECNAE',
       0,
       'R',
       'ARTES, CULTURA, ESPORTE E REC.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'SECNAE',
       0,
       'S',
       'OUTRAS ATIVIDADES DE SERVIOS',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'SECNAE',
       0,
       'T',
       'SERVIOS DOMSTICOS',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NAE ',
       'SECNAE',
       0,
       'U',
       'ORGANISMOS INTERNACIONAIS E IE',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8833 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'NCM ',
       TO_NUMBER(null),
       'NCM ',
       'Nomenclatura Comum do Mercosul',
       'TT_NCM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'NCM.CODNCM,
NCM.NOMNCM',
       '' FROM DUAL
);

/*-- SEQ 8834 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'NCM ','--','' FROM DUAL
UNION ALL
SELECT 'NCM ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'NCM ','99','Outros' FROM DUAL
);

/*-- SEQ 8835 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'NCM ',
       '--',
       90,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Atualizao',
       'Data da Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'NCM ',
       '--',
       80,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       '' FROM DUAL
UNION ALL
SELECT 'NCM ',
       '--',
       70,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo do Produto',
       'Cdigo do Produto',
       '',
       'CODMAT',
       '' FROM DUAL
UNION ALL
SELECT 'NCM ',
       '--',
       10,
       8,
       'CODNCM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo NCM',
       'Cdigo NCM',
       '',
       'CODNCM',
       'F' FROM DUAL
UNION ALL
SELECT 'NCM ',
       '--',
       100,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Incluso',
       'Data da Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'NCM ',
       '--',
       60,
       3,
       'FILMAT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial do Produto',
       'Filial do Produto',
       'DFIL.CODFIL = NCM.FILMAT',
       'FILMAT',
       '' FROM DUAL
UNION ALL
SELECT 'NCM ',
       '--',
       20,
       1,
       'FLGATI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'FLGATI',
       'F' FROM DUAL
UNION ALL
SELECT 'NCM ',
       '--',
       30,
       1,
       'NIVNCM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Nvel',
       'Nvel',
       '',
       'NIVNCM',
       'F' FROM DUAL
UNION ALL
SELECT 'NCM ',
       '--',
       40,
       4000,
       'NOMNCM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio NCM',
       'Descrio NCM',
       '',
       'NOMNCM',
       'F' FROM DUAL
UNION ALL
SELECT 'NCM ',
       '--',
       120,
       16,
       'QTDLIM_PF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Limite PF',
       'Quantidade Limite para Pessoa Fsica',
       '',
       'QTDLIM_PF',
       '' FROM DUAL
UNION ALL
SELECT 'NCM ',
       '--',
       110,
       16,
       'QTDLIM_PJ',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Limite PJ',
       'Quantidade Limite para Pessoa Jurdica',
       '',
       'QTDLIM_PJ',
       '' FROM DUAL
UNION ALL
SELECT 'NCM ',
       '--',
       50,
       2,
       'SECNCM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       '#Seo',
       'Seo (descontinuado)',
       '',
       'SECNCM',
       'T' FROM DUAL
);

/*-- SEQ 8836 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'NCM ',
       'SECNCM',
       9,
       ' ',
       'Madeira, carvo vegetal, etc',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NCM ',
       'SECNCM',
       10,
       ' ',
       'Madeira ou fibras celulsicas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NCM ',
       'SECNCM',
       11,
       ' ',
       'Matrias txteis e suas obras',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NCM ',
       'SECNCM',
       12,
       ' ',
       'Calados, chapus e artefatos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NCM ',
       'SECNCM',
       13,
       ' ',
       'Obras de pedra, gesso, cimento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NCM ',
       'SECNCM',
       14,
       ' ',
       'Prola nat./cultiv. Pedras pr.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NCM ',
       'SECNCM',
       15,
       ' ',
       'Metais comuns e suas obras',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NCM ',
       'SECNCM',
       16,
       ' ',
       'Mq. e aparelhos, mat. Elet.pt',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NCM ',
       'SECNCM',
       17,
       ' ',
       'Material de transporte',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NCM ',
       'SECNCM',
       18,
       ' ',
       'Instr. apar. ptica, fotograf.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NCM ',
       'SECNCM',
       19,
       ' ',
       'Armas e munies; suas partes',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NCM ',
       'SECNCM',
       20,
       ' ',
       'Mercadorias e produtos divers.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NCM ',
       'SECNCM',
       21,
       ' ',
       'Objetos de artes, de coleo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NCM ',
       'SECNCM',
       2,
       ' ',
       'Produtos do reino vegetal ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NCM ',
       'SECNCM',
       3,
       ' ',
       'Gorduras e leos anim. ou veg.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NCM ',
       'SECNCM',
       4,
       ' ',
       'Produtos das ind. alimentares',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NCM ',
       'SECNCM',
       5,
       ' ',
       'Produtos minerais',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NCM ',
       'SECNCM',
       6,
       ' ',
       'Produtos das ind. qumicas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NCM ',
       'SECNCM',
       7,
       ' ',
       'Plsticos e borrachas (obras)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NCM ',
       'SECNCM',
       8,
       ' ',
       'Peles, couros, peleteria, etc',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NCM ',
       'SECNCM',
       1,
       ' ',
       'Animais vivos e prod. r. anim.',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8837 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'NMF ',
       TO_NUMBER(null),
       'NMF ',
       'Nota Mult. Filiais',
       'TT_NMF',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8838 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'NMF ','--','' FROM DUAL
UNION ALL
SELECT 'NMF ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'NMF ','99','Outros' FROM DUAL
);

/*-- SEQ 8839 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'NMF ',
       '01',
       70,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data de Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'NMF ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Codigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'NMF ',
       '01',
       50,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo do Usurio',
       'Cdigo do Usurio',
       '',
       'CODUSU',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'NMF ',
       '01',
       60,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data de Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'NMF ',
       '01',
       40,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Filial do Usurio',
       'Filial do Usurio',
       '',
       'FILUSU',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'NMF ',
       '01',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Situao',
       'Situao do Envio',
       '',
       'FLGEST',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'NMF ',
       '01',
       10,
       12,
       'ID_TAB',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Ident. da Tabela',
       'Identificador da Tabela',
       '',
       'ID_TAB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'NMF ',
       '01',
       90,
       4000,
       'MSGRET',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Mensagem de Retorno',
       'Mensagem de Retorno',
       '',
       'MSGRET',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'NMF ',
       '01',
       30,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nmero ECF',
       'Nmero ECF',
       '',
       'NUMECF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'NMF ',
       '01',
       80,
       0,
       'XMLDOC',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'XML do Documento',
       'XML do Documento de Origem',
       '',
       'XMLDOC',
       '',
       'D' FROM DUAL
);

/*-- SEQ 8840 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'NMF ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NMF ',
       'FLGEST',
       0,
       'F',
       'Finalizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'NMF ',
       'FLGEST',
       0,
       'P',
       'Pendente',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8841 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'NUT ',
       TO_NUMBER(null),
       'NUT ',
       'Inf. Nutricionais',
       'TT_NUT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'NUT.FILMAT, NUT.CODMAT, NUT.CODCOR, NUT.CODTAM',
       '' FROM DUAL
);

/*-- SEQ 8842 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'NUT ','--','' FROM DUAL
UNION ALL
SELECT 'NUT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'NUT ','99','Outros' FROM DUAL
);

/*-- SEQ 8843 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 17844,
       'GRA ',
       'NUT ',
       '1',
       '1',
       '',
       '',
       'GRA.FILMAT = NUT.FILMAT AND
GRA.CODMAT = NUT.CODMAT AND
GRA.CODCOR = NUT.CODCOR AND
GRA.CODTAM = NUT.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 8844 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'NUT ',
       '99',
       290,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data da Atualizao',
       'Data da ltima Atualizao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '01',
       30,
       5,
       'CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Diviso do Produto',
       'Diviso do Produto',
       '',
       'CODCOR',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '01',
       20,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo do Material',
       'Cdigo do Material',
       '',
       'CODMAT',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '01',
       40,
       5,
       'CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Sub-Diviso Produto',
       'Sub-Diviso do Produto',
       '',
       'CODTAM',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '99',
       280,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data de Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '99',
       270,
       20,
       'FIGURA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Figura',
       'Figura',
       '',
       'FIGURA',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '01',
       10,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Filial do Material',
       'Filial do Material',
       '',
       'FILMAT',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '--',
       80,
       4,
       'PERCAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '% Valor Calrico -VD',
       '% do Valor Calrico (VD)',
       '',
       'PERCAL',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '--',
       100,
       4,
       'PERCAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '% Carboidratos (VD)',
       '% de Carboidratos (VD)',
       '',
       'PERCAR',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '--',
       220,
       4,
       'PERCIO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '% de Clcio (VD)',
       '% de Clcio (VD)',
       '',
       'PERCIO',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '--',
       180,
       4,
       'PERCOL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '% do Colesterol (VD)',
       '% do Colesterol (VD)',
       '',
       'PERCOL',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '--',
       240,
       4,
       'PERFER',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '% de Ferro (VD)',
       '% de Ferro (VD)',
       '',
       'PERFER',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '--',
       200,
       4,
       'PERFIB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '% de Fibra Alimentar',
       '% de Fibra Alimentar (VD)',
       '',
       'PERFIB',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '--',
       140,
       4,
       'PERGOR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '% Gorduras Totais VD',
       '% de Gorduras Totais (VD)',
       '',
       'PERGOR',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '--',
       120,
       4,
       'PERPRO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '% das Protenas (VD)',
       '% das Protenas (VD)',
       '',
       'PERPRO',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '--',
       160,
       4,
       'PERSAT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '% Gorduras Sat. (VD)',
       '% de Gorduras Saturadas (VD)',
       '',
       'PERSAT',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '--',
       260,
       4,
       'PERSOD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '% de Sdio (VD)',
       '% de Sdio (VD)',
       '',
       'PERSOD',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '--',
       60,
       35,
       'PORCAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Poro Ref. Inf. Nut',
       'Poro Referente s Informaes Nutricionais',
       '',
       'PORCAO',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '--',
       50,
       4000,
       'RECEIT',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Receita',
       'Receita',
       '',
       'RTF2TXT(RECEIT)',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '--',
       70,
       5,
       'VALCAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Valor Calrico -kcal',
       'Valor Calrico (kcal)',
       '',
       'VALCAL',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '--',
       90,
       5,
       'VALCAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Qtd Carboidratos (g)',
       'Quantidade de Carboidratos (g)',
       '',
       'VALCAR',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '--',
       210,
       5,
       'VALCIO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Qtd de Clcio (mg)',
       'Quantidade de Clcio (mg)',
       '',
       'VALCIO',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '--',
       170,
       5,
       'VALCOL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Qtd Colesterol (m)',
       'Quantidade de Colesterol (mg)',
       '',
       'VALCOL',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '--',
       230,
       5,
       'VALFER',
       'F',
       '',
       1,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Qtd de Ferro (mg)',
       'Quantidade de Ferro (mg)',
       '',
       'VALFER',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '--',
       190,
       5,
       'VALFIB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Qtd Fibra Alimentar',
       'Quantidade de Fibra Alimentar (g)',
       '',
       'VALFIB',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '--',
       130,
       5,
       'VALGOR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Qtd Gorduras Totais',
       'Quantidade de Gorduras Totais (g)',
       '',
       'VALGOR',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '--',
       110,
       5,
       'VALPRO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Qtd de Protenas (g)',
       'Quantidade de Protenas (g)',
       '',
       'VALPRO',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '--',
       150,
       5,
       'VALSAT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Qtd Gorduras Sat.',
       'Quantidade de Gorduras Saturadas (g)',
       '',
       'VALSAT',
       '' FROM DUAL
UNION ALL
SELECT 'NUT ',
       '--',
       250,
       5,
       'VALSOD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Qtd de Sdio (mg) ',
       'Quantidade de Sdio (mg)',
       '',
       'VALSOD',
       '' FROM DUAL
);

/*-- SEQ 8845 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'OBS ',
       TO_NUMBER(null),
       'OBS ',
       'Observaes Fiscais',
       'TT_OBS',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'OBS.CODOBS',
       '' FROM DUAL
);

/*-- SEQ 8846 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'OBS ','--','' FROM DUAL
UNION ALL
SELECT 'OBS ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'OBS ','99','Outros' FROM DUAL
);

/*-- SEQ 8847 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'OBS ',
       '--',
       10,
       5,
       'CODINT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cd. Interno da Obs',
       'Cdigo Interno da Observao na Totali',
       '',
       'CODINT',
       'F' FROM DUAL
UNION ALL
SELECT 'OBS ',
       '--',
       20,
       5,
       'CODOBS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Observao',
       'Cdigo da Observao',
       '',
       'CODOBS',
       'F' FROM DUAL
UNION ALL
SELECT 'OBS ',
       '--',
       30,
       4000,
       'DESOBS',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(DESOBS)',
       'F' FROM DUAL
);

/*-- SEQ 8848 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'OIP ',
       TO_NUMBER(null),
       'OIP ',
       'Operaes de Imp.',
       'TT_OIP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'OIP.CODFIL, OIP.SEQUEN, OIP.DOCIMP, OIP.DATOPE',
       '' FROM DUAL
);

/*-- SEQ 8849 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'OIP ','--','' FROM DUAL
UNION ALL
SELECT 'OIP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'OIP ','02','Datas' FROM DUAL
UNION ALL
SELECT 'OIP ','03','Valores' FROM DUAL
UNION ALL
SELECT 'OIP ','04','Frete' FROM DUAL
UNION ALL
SELECT 'OIP ','99','Outros' FROM DUAL
);

/*-- SEQ 8850 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 24497,
       'LOI ',
       'OIP ',
       '01',
       '0N',
       '',
       '',
       'LOI.CODFIL = OIP.FILLOI(+) AND
LOI.SEQUEN = OIP.SEQLOI(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 24500,
       'CLI ',
       'OIP ',
       '01',
       '0N',
       '',
       '',
       'CLI.FILCLI = OIP.FILTRA(+) AND
CLI.CODCLI = OIP.CODTRA(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8851 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'OIP ',
       '02',
       50,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '99',
       90,
       60,
       'CLIEXP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Cd. do Exportador',
       'Cdigo do Exportador (descontinuado)',
       '',
       'CLIEXP',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = OIP.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '04',
       210,
       6,
       'CODTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Transp.',
       'Cdigo Transportadora',
       '',
       'CODTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '99',
       100,
       8,
       'DATDES',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Desemb',
       'Data do Desembarao Aduaneiro',
       '',
       'DATDES',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '02',
       60,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '99',
       110,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Registro',
       'Data de Registro do documento',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '99',
       300,
       12,
       'DA_OUT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Outras Desp Adua BRL',
       'Outras Despesas Aduaneiras em Reais',
       '',
       'DA_OUT',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '99',
       310,
       12,
       'DA_TRI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Desp Adua Tribut BRL',
       'Despesas Aduaneiras Tributveis em Reais',
       '',
       'DA_TRI',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '04',
       220,
       100,
       'DESTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Transp. DI',
       'Descrio da Transportadora na DI',
       '',
       'DESTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '99',
       120,
       14,
       'DOCADQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#CNPJ Adquirente',
       'CNPJ do adquirente ou do encomendante (descontinuado)',
       '',
       'DOCADQ',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '01',
       30,
       12,
       'DOCIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm. Doc. Imp. ',
       'Nmero do Documento de Importao',
       '',
       'DOCIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '99',
       330,
       12,
       'DOLFIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Dlar Fiscal',
       'Taxa de Cmbio do Dlar Fiscal',
       '',
       'DOLFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '99',
       340,
       12,
       'DOLFOR',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Dlar Fornecedor',
       'Taxa de Cmbio do Dlar Fornecedor',
       '',
       'DOLFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '99',
       350,
       12,
       'DOLFRE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Dlar Frete',
       'Taxa de Cmbio do Dlar Frete',
       '',
       'DOLFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '99',
       360,
       12,
       'DOLSEG',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Dlar Seguro',
       'Taxa de Cmbio do Dlar Seguro',
       '',
       'DOLSEG',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '99',
       190,
       3,
       'FILLOI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial do Lote de DI',
       'Filial do Lote de DI',
       'DFIL.CODFIL = OIP.FILLOI(+)',
       'FILLOI',
       'T' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '04',
       230,
       3,
       'FILTRA',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Transp.',
       'Filial Transportadora',
       'DFIL.CODFIL = OIP.FILTRA(+)',
       'FILTRA',
       'T' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '99',
       280,
       1,
       'FLGCAD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao do Cadastro',
       'Situao do Cadastro',
       '',
       'FLGCAD',
       'T' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '99',
       290,
       1,
       'FLGEMI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'NF Emitida?',
       'NF Emitida?',
       '',
       'FLGEMI',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '99',
       130,
       1,
       'INTERM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Intermediao',
       'Forma de importao quanto a intermediao',
       '',
       'INTERM',
       'T' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '99',
       140,
       60,
       'LOCDES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Local Desemb',
       'Local de desembarao',
       '',
       'LOCDES',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '04',
       240,
       12,
       'PESBRU',
       'F',
       '',
       3,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Peso Bruto (em kg)',
       'Peso Bruto (em kg)',
       '',
       'PESBRU',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '04',
       250,
       12,
       'PESLIQ',
       'F',
       '',
       3,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Peso Lquido (em kg)',
       'Peso Lquido (em kg)',
       '',
       'PESLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '99',
       200,
       10,
       'SEQLOI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       'F',
       'Seq. do Lote de DI',
       'Seq. do Lote de DI',
       '',
       'SEQLOI',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '01',
       40,
       1,
       'TIPDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Tipo Documento Imp.',
       'Tipo de Documento de Importao',
       '',
       'TIPDOC',
       'T' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '04',
       260,
       1,
       'TIPFRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'T',
       'N',
       'F',
       'Tipo do Frete',
       'Tipo do Frete',
       '',
       'TIPFRE',
       'T' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '99',
       160,
       2,
       'UF_ADQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#UF Adquirente',
       'Sigla da UF do adquirente ou do encomendante (descontinuado)',
       '',
       'UF_ADQ',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '99',
       150,
       2,
       'UF_DES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF Desemb',
       'Sigla da UF onde ocorreu o Desembarao Aduaneiro',
       '',
       'UF_DES',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '99',
       170,
       2,
       'VIATRA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Via Transporte',
       'Via de transporte internacional informada na Declarao de Importao DI',
       '',
       'VIATRA',
       'T' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '03',
       270,
       12,
       'VLRADU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '#Despesas Aduaneiras',
       'Valor das Despesas Aduaneiras (descontinuado)',
       '',
       'VLRADU',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '99',
       180,
       13,
       'VLRAFR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor da AFRMM',
       'Valor da AFRMM - Adicional ao Frete para Renovao da Marinha Mercante',
       '',
       'VLRAFR',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '03',
       70,
       12,
       'VLRCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor COFINS ',
       'Valor Pago de COFINS na Importao',
       '',
       'VLRCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'OIP ',
       '03',
       80,
       12,
       'VLRPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor PIS',
       'Valor Pago de PIS na Importao',
       '',
       'VLRPIS',
       'F' FROM DUAL
);

/*-- SEQ 8852 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'OIP ',
       'FLGCAD',
       0,
       'C',
       'Completo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'FLGCAD',
       0,
       'I',
       'Incompleto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'INTERM',
       0,
       ' ',
       'No informada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'INTERM',
       1,
       ' ',
       'Importao por conta prpria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'INTERM',
       2,
       ' ',
       'Importao por conta e ordem',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'INTERM',
       3,
       ' ',
       'Importao por encomenda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'TIPDOC',
       0,
       '0',
       'Declarao de Importao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'TIPDOC',
       0,
       '1',
       'Declarao Simplificada de Imp',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'TIPFRE',
       1,
       ' ',
       'Por conta destinatrio/remeten',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'TIPFRE',
       0,
       ' ',
       'Por conta do emitente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'TIPFRE',
       2,
       ' ',
       'Por conta de terceiros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'TIPFRE',
       9,
       ' ',
       'Sem frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'VIATRA',
       1,
       ' ',
       'Martima',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'VIATRA',
       2,
       ' ',
       'Fluvial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'VIATRA',
       3,
       ' ',
       'Lacustre',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'VIATRA',
       4,
       ' ',
       'Area',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'VIATRA',
       5,
       ' ',
       'Postal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'VIATRA',
       6,
       ' ',
       'Ferroviria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'VIATRA',
       7,
       ' ',
       'Rodoviria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'VIATRA',
       8,
       ' ',
       'Conduto / Rede Transmisso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'VIATRA',
       9,
       ' ',
       'Meios Prprios',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'VIATRA',
       10,
       ' ',
       'Entrada / Sada ficta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'VIATRA',
       11,
       ' ',
       'Courier',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OIP ',
       'VIATRA',
       12,
       ' ',
       'Handcarry',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8853 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'OPC ',
       TO_NUMBER(null),
       'OPC ',
       'Opo de Resposta',
       'TT_OPC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'OPC.FILPER,OPC.CODPER,OPC.CODOPC
PER.ID,OPC.CODOPC',
       '' FROM DUAL
);

/*-- SEQ 8854 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'OPC ','--','' FROM DUAL
);

/*-- SEQ 8855 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5688,
       'PER ',
       'OPC ',
       '1 ',
       'N ',
       '',
       '',
       'OPC.FILPER = PER.FILPER and
OPC.CODPER = PER.CODPER',
       '' FROM DUAL
UNION ALL
SELECT 5689,
       'USU ',
       'OPC ',
       '1 ',
       'N ',
       '',
       '',
       'USU.FILUSU = OPC.FILUSU AND
USU.CODUSU = OPC.CODUSU',
       '' FROM DUAL
);

/*-- SEQ 8856 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'OPC ',
       '--',
       3,
       3,
       'CODOPC',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo',
       'Cdigo',
       '',
       'CODOPC',
       'F' FROM DUAL
UNION ALL
SELECT 'OPC ',
       '--',
       2,
       5,
       'CODPER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       'Cdigo da Pergunta',
       'Cdigo da pergunta',
       '',
       'CODPER',
       'F' FROM DUAL
UNION ALL
SELECT 'OPC ',
       '--',
       15,
       3,
       'CODRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Responsvel',
       'Cdigo Responsvel',
       '',
       'CODRES',
       'F' FROM DUAL
UNION ALL
SELECT 'OPC ',
       '--',
       5,
       1,
       'COMENT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'N',
       'F',
       'Comentrio',
       'Comentrio',
       '',
       'COMENT',
       'T' FROM DUAL
UNION ALL
SELECT 'OPC ',
       '--',
       1,
       3,
       'FILPER',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial da pergunta',
       'DFIL.CODFIL = OPC.FILPER',
       'FILPER',
       'F' FROM DUAL
UNION ALL
SELECT 'OPC ',
       '--',
       25,
       3,
       'FILRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Responsvel',
       '',
       'FILRES',
       'F' FROM DUAL
UNION ALL
SELECT 'OPC ',
       '--',
       35,
       5,
       'MODULO',
       'S',
       'DMOD',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOD.MODULO',
       'V',
       '',
       '',
       'A',
       'F',
       'Mdulo',
       'Mdulo',
       'DMOD.CODTAB = OPC.MODULO',
       'MODULO',
       'F' FROM DUAL
UNION ALL
SELECT 'OPC ',
       '--',
       4,
       20,
       'NOMOPC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'NOMOPC',
       'F' FROM DUAL
UNION ALL
SELECT 'OPC ',
       '--',
       45,
       1,
       'PRIORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Cdigo da Prioridade',
       'Cdigo Prioridade',
       '',
       'PRIORI',
       'F' FROM DUAL
);

/*-- SEQ 8857 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'OPC ',
       'COMENT',
       2,
       ' ',
       'Exige',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OPC ',
       'COMENT',
       1,
       ' ',
       'Nao aceita',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OPC ',
       'COMENT',
       0,
       ' ',
       'Aceita',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8858 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'OPE ',
       TO_NUMBER(null),
       'OPE ',
       'Operaes de Caixa',
       'TT_OPE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'OPE.CODFIL,OPE.NUMECF,OPE.TRN_ID,OPE.NUMITE',
       '' FROM DUAL
);

/*-- SEQ 8859 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'OPE ','--','' FROM DUAL
UNION ALL
SELECT 'OPE ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'OPE ','02','Datas' FROM DUAL
UNION ALL
SELECT 'OPE ','03','Valores' FROM DUAL
UNION ALL
SELECT 'OPE ','99','Outros' FROM DUAL
);

/*-- SEQ 8860 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23424,
       'SAV ',
       'OPE ',
       '01',
       '1',
       '',
       '',
       'OPE.FILSAV = SAV.CODFIL(+) AND
OPE.SEQSAV = SAV.SEQUEN(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22967,
       'CHR ',
       'OPE ',
       '1',
       '1',
       '',
       '',
       'CHR.CODFIL = OPE.FILCHR AND
CHR.SEQUEN = OPE.SEQCHR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22968,
       'LID ',
       'OPE ',
       '1',
       '1',
       '',
       '',
       'LID.CODFIL = OPE.CODFIL AND
LID.NUMECF = OPE.NUMECF AND
LID.TRN_ID = OPE.TRN_ID',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22969,
       'FIN ',
       'OPE ',
       '1',
       '1',
       '',
       '',
       'FIN.CODFIL = OPE.FILFIN AND
FIN.SEQUEN = OPE.SEQFIN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22970,
       'CCC ',
       'OPE ',
       '1',
       '1',
       '',
       '',
       'CCC.CODFIL = OPE.FILCCC AND
CCC.SEQUEN = OPE.SEQCCC ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22971,
       'REC ',
       'OPE ',
       '1',
       '1',
       '',
       '',
       'REC.CODFIL = OPE.FILREC AND
REC.SEQUEN = OPE.SEQREC AND
REC.NUMPAR = OPE.NUMPAR AND
REC.SUBPAR = OPE.SUBPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22972,
       'RTT ',
       'OPE ',
       '01',
       '1',
       '',
       '',
       'OPE.FILRTT = RTT.CODFIL(+) AND
OPE.SEQRTT = RTT.SEQUEN(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45925,
       'RECP',
       'OPE ',
       '1',
       '1',
       '',
       '',
       'RECP.CODFIL = OPE.FILREC AND
RECP.SEQUEN = OPE.SEQREC AND
RECP.NUMPAR = OPE.NUMPAR AND
RECP.SUBPAR = OPE.SUBPAR',
       '',
       '' FROM DUAL
);

/*-- SEQ 8861 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'OPE ',
       '99',
       10,
       5,
       'CAMBIO',
       'S',
       'DMOE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       '',
       '',
       'A',
       'F',
       'Moeda',
       'Moeda',
       'DMOE.CODTAB = OPE.CAMBIO',
       'CAMBIO',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '01',
       20,
       5,
       'CARTAO',
       'S',
       'DCAR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCAR.DESOUT',
       'V',
       '',
       '',
       'A',
       'F',
       'Carto',
       'Carto',
       'DCAR.CODTAB = OPE.CARTAO',
       'CARTAO',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '01',
       30,
       5,
       'CODCAI',
       'S',
       'DCAI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCAI.CX_DES',
       'V',
       '',
       '',
       'A',
       'F',
       'Cdigo~Caixa',
       'Cdigo~Caixa',
       'DCAI.CODTAB = OPE.CODCAI',
       'CODCAI',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '01',
       40,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = OPE.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '01',
       50,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Usurio',
       'Usuro',
       'OPE.FILUSU = USU.FILUSU(+)  AND OPE.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '01',
       60,
       6,
       'CUPFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cupom~Fiscal',
       'Cupom Fiscal',
       '',
       'CUPFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '02',
       70,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Operao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '99',
       250,
       30,
       'DOCTRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DOCTRO',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '01',
       80,
       3,
       'FILCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'FILCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '01',
       90,
       3,
       'FILCHR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'FILCHR',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '99',
       260,
       3,
       'FILDOP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILDOP',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '01',
       100,
       3,
       'FILFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'FILFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '01',
       110,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '99',
       310,
       3,
       'FILRTT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Fil Recebimento Tit',
       'Filial Recebimento de Ttulos',
       '',
       'FILRTT',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '99',
       330,
       3,
       'FILSAV',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Servio Adic.',
       'Filial do Servio Adicional',
       'DFIL.CODFIL(+) = OPE.FILSAV',
       'FILSAV',
       'T' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '99',
       270,
       3,
       'FILTEF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILTEF',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '01',
       55,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial~Usurio',
       'Filial Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '99',
       280,
       1,
       'MEIPGT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Meio de Pagamento?',
       'Meio de Pagamento?',
       '',
       'MEIPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '01',
       130,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'ECF',
       'Nmero ECF',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '01',
       140,
       3,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero~ Itens',
       'Nmero Itens',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '01',
       150,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Parcela',
       'Parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '01',
       160,
       5,
       'OUTROS',
       'S',
       'DOUT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DOUT.DESCAR',
       'V',
       '',
       '',
       'A',
       'F',
       'Outros',
       'Outros',
       'DOUT.CODTAB = OPE.OUTROS',
       'OUTROS',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '99',
       170,
       10,
       'SEQCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'SEQCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '99',
       180,
       10,
       'SEQCHR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'SEQCHR',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '99',
       290,
       10,
       'SEQDOP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQDOP',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '99',
       190,
       10,
       'SEQFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'SEQFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '99',
       200,
       10,
       'SEQREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'SEQREC',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '99',
       320,
       10,
       'SEQRTT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Seq Recebimento Tit',
       'Sequenciador Recebimento de Ttulos',
       '',
       'SEQRTT',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '99',
       340,
       10,
       'SEQSAV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Seq. Servio Adic.',
       'Sequencial do Servio Adicional',
       '',
       'SEQSAV',
       '' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '99',
       300,
       10,
       'SEQTEF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQTEF',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '01',
       210,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub-Parcela',
       'Sub-Parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '01',
       220,
       1,
       'TIPCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo~Carto',
       'Tipo Carto',
       '',
       'TIPCAR',
       'T' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '01',
       230,
       12,
       'TRN_ID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'ID~Transao',
       'ID Transao',
       '',
       'TRN_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'OPE ',
       '03',
       240,
       16,
       'VLROPE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor~Operao',
       'Valor Operao',
       '',
       'VLROPE',
       'F' FROM DUAL
);

/*-- SEQ 8862 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'OPE ',
       'TIPCAR',
       0,
       'C',
       'Crdito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'OPE ',
       'TIPCAR',
       0,
       'D',
       'Dbito',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8863 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ORC ',
       0,
       'ORC ',
       'Oramentos',
       'TT_ORC',
       'T',
       '',
       'TOTALL',
       'Oramentos/Pedidos de clientes',
       '{CODFIL;NUMPED};FILCLI;CODCLI;DATPED;DATENT;FLGEST;NUMECF;CUPFIS;ATU_EM',
       '',
       'NUMBLO',
       'PedidoVenda',
       'T',
       '{'||CHR(92)||'rtf1'||CHR(92)||'ansi'||CHR(92)||'deff0'||CHR(92)||'deftab720{'||CHR(92)||'fonttbl{'||CHR(92)||'f0'||CHR(92)||'fswiss MS Sans Serif;}{'||CHR(92)||'f1'||CHR(92)||'froman'||CHR(92)||'fcharset2 Symbol;}{'||CHR(92)||'f2'||CHR(92)||'fswiss'||CHR(92)||'fcharset1 MS Sans Serif;}}
{'||CHR(92)||'colortbl'||CHR(92)||'red0'||CHR(92)||'green0'||CHR(92)||'blue0;}
'||CHR(92)||'deflang1046'||CHR(92)||'pard'||CHR(92)||'plain'||CHR(92)||'f2'||CHR(92)||'fs16 OBS: A informa'||CHR(92)||'''e7'||CHR(92)||'''e3o de planos sugeridos n'||CHR(92)||'''e3o vai ser
'||CHR(92)||'par          gravada em cada plano, ser'||CHR(92)||'''e3o apenas
'||CHR(92)||'par         vari'||CHR(92)||'''e1veis p'||CHR(92)||'''fablicas (Pa*) usadas na impress'||CHR(92)||'''e3o
'||CHR(92)||'par }
',
       'ORC.CODFIL,ORC.TIPPED,ORC.NUMPED
ORC.CODFIL,ORC.NUMBLO
',
       '' FROM DUAL
);

/*-- SEQ 8864 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ORC ','--','' FROM DUAL
UNION ALL
SELECT 'ORC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ORC ','02','Dados de Transporte' FROM DUAL
UNION ALL
SELECT 'ORC ','03','Photo' FROM DUAL
UNION ALL
SELECT 'ORC ','04','Valores' FROM DUAL
UNION ALL
SELECT 'ORC ','05','Entrega' FROM DUAL
UNION ALL
SELECT 'ORC ','06','E-Commerce' FROM DUAL
UNION ALL
SELECT 'ORC ','99','Outros' FROM DUAL
);

/*-- SEQ 8865 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21561,
       'CUP ',
       'ORC ',
       '01',
       '01',
       '',
       '',
       'ORC.FILCUP = CUP.CODFIL(+) AND
ORC.SEQCUP = CUP.SEQUEN(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21562,
       'DNAT',
       'ORC ',
       'N',
       '1',
       '',
       '',
       'DNAT.CODTAB = VEN.CODNAT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21563,
       'CLI ',
       'ORC ',
       '1',
       'N',
       '',
       '',
       'CLI.FILCLI = ORC.FILCLI and
CLI.CODCLI = ORC.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21564,
       'ECOB',
       'ORC ',
       '1',
       'N',
       '',
       '',
       'ECOB.FILCLI = ORC.FILCLI AND
ECOB.CODCLI = ORC.CODCLI AND
ECOB.CODFIL = ORC.FILCOB AND
ECOB.NUMEND = ORC.NUMCOB
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21565,
       'EENT',
       'ORC ',
       '1',
       'N',
       '',
       '',
       'EENT.FILCLI = ORC.FILCLI AND
EENT.CODCLI = ORC.CODCLI AND
EENT.CODFIL = ORC.FILENT AND
EENT.NUMEND = ORC.NUMENT
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21566,
       'EFAT',
       'ORC ',
       '1',
       'N',
       '',
       '',
       'EFAT.FILCLI = ORC.FILCLI AND
EFAT.CODCLI = ORC.CODCLI AND
EFAT.CODFIL = ORC.FILFAT AND
EFAT.NUMEND = ORC.NUMFAT
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21567,
       'IOR ',
       'ORC ',
       'N',
       '1',
       '',
       '',
       'IOR.CODFIL = ORC.CODFIL and
IOR.TIPPED = ORC.TIPPED and
IOR.NUMPED = ORC.NUMPED',
       'IOR.VLRITE / ORC.VLRTOT',
       '' FROM DUAL
UNION ALL
SELECT 21568,
       'PLA ',
       'ORC ',
       '1',
       'N',
       '',
       '',
       'PLA.CODPGT = ORC.CODPGT AND
PLA.FILPGT = ORC.FILPGT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21569,
       'REG ',
       'ORC ',
       '1',
       'N',
       '',
       '',
       'REG.CODFIL = ORC.FILREG AND
REG.SEQUEN = ORC.CODREG',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21570,
       'TPR ',
       'ORC ',
       '1',
       'N',
       '',
       '',
       'TPR.CODFIL = ORC.FILPRE and
TPR.CODPRE = ORC.CODPRE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21571,
       'USU ',
       'ORC ',
       '1',
       'N',
       '',
       '',
       'USU.FILUSU = ORC.FILUSU AND
USU.CODUSU = ORC.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21572,
       'IND ',
       'ORC ',
       '01',
       'N',
       '',
       '',
       'ORC.FILGUI = IND.FILCLI(+) AND
ORC.CODGUI = IND.CODCLI(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21573,
       'CCC ',
       'ORC ',
       '0N',
       '1',
       '',
       '',
       'CCC.CODFIL = ORC.FILADI AND
CCC.SEQUEN = ORC.SEQADI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21574,
       'DVEI',
       'ORC ',
       '01',
       '0N',
       '',
       '',
       'ORC.CODVEI = DVEI.CODTAB(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21575,
       'TRA ',
       'ORC ',
       '01',
       '0N',
       '',
       '',
       'ORC.FILTRA = TRA.FILCLI(+) AND
ORC.CODTRA = TRA.CODCLI(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21576,
       'EQP ',
       'ORC ',
       '01',
       '0N',
       '',
       '',
       'ORC.FILEQP = EQP.CODFIL(+) AND
ORC.SEQEQP = EQP.SEQUEN(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21577,
       'WOR ',
       'ORC ',
       '01',
       '01',
       '',
       '',
       'ORC.FILWOR = WOR.CODFIL(+) AND
ORC.SEQWOR = WOR.SEQUEN(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8866 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'ORC ',
       '04',
       120,
       12,
       'ABATIM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Abatimento',
       'Abatimento',
       '',
       'ABATIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       200,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'ORC ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(ORC.ATU_EM,''YYYY'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       260,
       4,
       'ANO_DATENT',
       'A',
       '',
       0,
       0,
       'ORC ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       '',
       'N',
       'T',
       'Ano~Entrega',
       'Ano de Data da entrega (prevista)',
       '',
       'TO_CHAR(ORC.DATENT,''YYYY'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       450,
       4,
       'ANO_DATPRI',
       'A',
       '',
       0,
       0,
       'ORC ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       '',
       'N',
       'T',
       'Ano de 1 Parcela',
       'Ano de Data da 1 parcela',
       '',
       'TO_CHAR(ORC.DATPRI,''YYYY'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       300,
       4,
       'ANO_DATVAL',
       'A',
       '',
       0,
       0,
       'ORC ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       '',
       'N',
       'T',
       'Ano de Validade',
       'Ano de Data de validade do pedido',
       '',
       'TO_CHAR(ORC.DATVAL,''YYYY'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       230,
       4,
       'ANO_PED_EM',
       'A',
       '',
       0,
       0,
       'ORC ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       '',
       'N',
       'T',
       'Ano de Pedido em',
       'Ano de Data e hora do pedido',
       '',
       'TO_CHAR(ORC.PED_EM,''YYYY'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       840,
       1,
       'APRCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Aprovao Cliente',
       'Aprovao Cliente',
       '',
       'APRCLI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       810,
       1,
       'APROVA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Aprovao',
       'Tipo Aprovao',
       '',
       'APROVA',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '--',
       1080,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Assinatura para PAF-ECF',
       '',
       'ASSINA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       751,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN ORC.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       180,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'ORC ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       990,
       3,
       'CANPRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cancelou pre-venda  ',
       'ECF que cancelou a Pr-Venda',
       '',
       'CANPRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       820,
       5,
       'CHVAPR',
       'S',
       'DAPR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DAPR.DESAPR',
       'V',
       '',
       '',
       '9',
       'F',
       'Chave Aprovao',
       'Chave Aprovao',
       'DAPR.CODTAB = ORC.CODAPR(+)  AND DAPR.APROVA = ORC.APROVA(+)',
       'CHVAPR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       800,
       9,
       'CHVAPROVACODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       '',
       'Filial+Aprovao',
       'Filial+Cdigo do cliente',
       '',
       '(ORC.CODFIL||''-''||ORC.APROVA)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       830,
       3,
       'CODAPR',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Aprovao feita por',
       'Aprovao feita por',
       'USU.FILUSU(+) = ORC.FILAPR  AND USU.CODUSU(+) = ORC.CODAPR',
       'CODAPR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       1480,
       5,
       'CODCCC',
       'G',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       'A',
       '',
       'Conta Corrente',
       'Conta Corrente',
       'DCCC.CODTAB = ORC.CODCCC(+)',
       'CODCCC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       170,
       6,
       'CODCLI',
       'A',
       '',
       0,
       0,
       'ORC ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       900,
       5,
       'CODCTR',
       'S',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       'F',
       '9',
       'F',
       'Unidade de Negcio',
       'Unidade de Negcio',
       'DCTR.CODTAB = ORC.CODCTR(+)',
       'CODCTR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '--',
       1090,
       5,
       'CODEMP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '.',
       'U',
       '',
       '',
       'N',
       'F',
       'Empr. da Retaguarda',
       'Empresa da Retaguarda',
       '. = ORC.CODEMP',
       'CODEMP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       70,
       15,
       'CODEXT',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       130,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       0,
       'ORC ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'ORC',
       'F',
       'A',
       'T',
       'Filial',
       'Cdigo da filial de origem',
       'ORC.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       470,
       2,
       'CODFIN',
       'S',
       '',
       0,
       0,
       'ORC ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       '',
       'T',
       'Financeira',
       'Cdigo da financeira',
       '',
       'CODFIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       1220,
       5,
       'CODFRE',
       'S',
       'DFRE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFRE.DESFRE',
       'V',
       '',
       'F',
       'N',
       'F',
       'Poltica de Frete',
       'Poltica de Frete',
       'DFRE.CODTAB = ORC.CODFRE(+)',
       'CODFRE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '--',
       920,
       6,
       'CODGUI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Indicador',
       'Cdigo do Parceiro Indicador',
       '',
       'CODGUI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       1190,
       5,
       'CODNAT',
       'S',
       'DNAT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DNAT.NATURE',
       'V',
       '',
       '',
       'A',
       'F',
       'Cod. Natureza Oper.',
       'Cod. Natureza Oper.',
       'ORC.CODNAT = DNAT.CODTAB (+)',
       'CODNAT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       330,
       3,
       'CODPGT',
       'A',
       'PLA ',
       0,
       0,
       'ORC ',
       130,
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       'ORC',
       'F',
       'A',
       'T',
       'Plano',
       'Cdigo do plano',
       'ORC.FILPGT = PLA.FILPGT (+)  and ORC.CODPGT = PLA.CODPGT (+)',
       'CODPGT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       490,
       2,
       'CODPRE',
       'S',
       'TPR ',
       0,
       0,
       'ORC ',
       120,
       TO_NUMBER(null),
       '',
       'TPR.DESPRE',
       'V',
       'ORC',
       'F',
       'N',
       'T',
       'Tabela de Preos',
       'Cdigo Tabela de preos',
       'ORC.FILPRE=TPR.CODFIL (+) and ORC.CODPRE=TPR.CODPRE (+)',
       'CODPRE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '06',
       1130,
       20,
       'CODRAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cod. Rastreamento',
       'Cdigo do Rastreamento',
       '',
       'CODRAS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       110,
       10,
       'CODREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Registro',
       'Cdigo Registro',
       '',
       'CODREG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '--',
       930,
       12,
       'CODSEQ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cd. Sequen. NSU',
       'Cdigo sequencial NSU',
       '',
       'CODSEQ',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       960,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       'F',
       'Srie Padr. de Venda',
       'Srie Padro de Venda',
       'ORC.CODSER=DSER.CODSER (+)',
       'CODSER',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '06',
       1140,
       5,
       'CODSVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Cd Servio Correios',
       'Cdigo do Servio dos Correios',
       '',
       'CODSVE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       540,
       6,
       'CODTRA',
       'A',
       '',
       0,
       0,
       'ORC ',
       170,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       '9',
       'F',
       'Transportadora',
       'Cdigo da Transportadora',
       '',
       'CODTRA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '--',
       1100,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Identificao de Acesso',
       '',
       'CODUID',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       720,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       0,
       'ORC ',
       60,
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       'ORC',
       'F',
       'A',
       'T',
       'Usurio',
       'Cdigo do usurio',
       'ORC.FILUSU = USU.FILUSU(+)  and ORC.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       1210,
       5,
       'CODVEI',
       'S',
       'DVEI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DVEI.DESVEI',
       'V',
       '',
       '',
       'N',
       '',
       'Veculo',
       'Veculo usado como referncia para frete de oramento',
       'ORC.CODVEI = DVEI.CODTAB(+)',
       'CODVEI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       770,
       3,
       'CODVEN',
       'A',
       'USU2',
       0,
       0,
       'ORC ',
       110,
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       'ORC',
       'F',
       'A',
       'T',
       'Vendedor',
       'Vendedor',
       'ORC.FILVEN = USU2.FILUSU(+)  AND ORC.CODVEN = USU2.CODUSU(+)',
       'CODVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       850,
       5,
       'CODVPE',
       'S',
       'DVPE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DVPE.MOTVPE',
       'V',
       '',
       '',
       'A',
       'F',
       'Motivo Venda Perdida',
       'Cdigo Venda Perdida',
       'DVPE.CODTAB = ORC.CODVPE(+)',
       'CODVPE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       910,
       1,
       'COMAND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Comanda',
       'Comanda',
       '',
       'COMAND',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       1100,
       6,
       'COOORC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'COO da Impresso do ',
       'COO da Impresso do DAV',
       '',
       'COOORC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       350,
       8,
       'CUPFIS',
       'A',
       '',
       0,
       0,
       'ORC ',
       150,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       '9',
       'T',
       'Cupom Fiscal',
       'Nmero do cupom fiscal',
       '',
       'CUPFIS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       910,
       8,
       'DATAPR',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data de aprovao',
       'Data de Aprovao',
       '',
       'DATAPR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       240,
       8,
       'DATENT',
       'D',
       '',
       0,
       0,
       'ORC ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       'D',
       'T',
       'Entrega em',
       'Data da entrega (prevista)',
       '',
       'DATENT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '06',
       1150,
       8,
       'DATENV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Envio ao Client',
       'Data de Envio ao Cliente',
       '',
       'DATENV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       430,
       8,
       'DATPRI',
       'D',
       '',
       0,
       0,
       'ORC ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       'D',
       'T',
       '1 Parcela',
       'Data da 1 parcela',
       '',
       'DATPRI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       800,
       7,
       'DATSEG',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       '2 Parcela',
       'Data da 2 parcela',
       '',
       'DATSEG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       280,
       8,
       'DATVAL',
       'D',
       '',
       0,
       0,
       'ORC ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       'D',
       'T',
       'Validade',
       'Data de validade do pedido',
       '',
       'DATVAL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '03',
       1000,
       2,
       'DDDCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DDD Clien. no Reg.',
       'DDD do Cliente no Registrado',
       '',
       'DDDCLI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       390,
       1,
       'DESCLI',
       'L',
       '',
       0,
       0,
       'ORC ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'ORC',
       'F',
       '',
       'F',
       'Usu Interno?',
       'Desconto especial para cliente',
       '',
       'DESCLI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       1260,
       60,
       'DESVOL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Numerao Volumes',
       'Numerao dos Volumes',
       '',
       'DESVOL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       970,
       15,
       'DOCNFP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento p/ NFP',
       'Nmero do documento para Nota Fiscal Paulista',
       '',
       'DOCNFP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       1340,
       254,
       'EMAILC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail do Cliente',
       'E-mail do Cliente',
       '',
       'EMAILC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       510,
       1,
       'EMIDES',
       'L',
       '',
       0,
       0,
       'ORC ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'ORC',
       'F',
       '',
       'T',
       'Frete Dest./Terc.?',
       'Frete  por conta do Destinatrio ou de Terceiros?',
       '',
       'EMIDES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '06',
       1160,
       1,
       'ENVECO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Pend Envio p/ E-Comm',
       'Pendente de Envio para E-commerce',
       '',
       'ENVECO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       580,
       2,
       'ESPECI',
       'S',
       'DESP',
       0,
       0,
       'ORC ',
       210,
       TO_NUMBER(null),
       '',
       'DESP.ESPECI',
       'V',
       'ORC',
       'F',
       'N',
       'T',
       'Espcie Volume',
       'Espcie de Volume',
       'ORC.ESPECI=DESP.CODTAB (+)',
       'ESPECI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       1420,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exporta?',
       'Exporta?',
       '',
       'EXPORT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '--',
       1110,
       3,
       'FILADI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILADI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       100,
       3,
       'FILALC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial Alocada',
       'Filial Alocada',
       '',
       'FILALC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       680,
       3,
       'FILAPR',
       'A',
       '',
       0,
       0,
       'ORC ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       'N',
       'F',
       'Filial do Aprovador',
       'Filial do aprovador',
       '',
       'FILAPR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       160,
       3,
       'FILCLI',
       'A',
       '',
       0,
       0,
       'ORC ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       40,
       3,
       'FILCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Endereo de Cobrana',
       '',
       'FILCOB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       1490,
       3,
       'FILCUP',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial Cupom',
       'Filial do cupom',
       'DFIL.CODFIL = ORC.FILCUP(+)',
       'FILCUP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       10,
       3,
       'FILENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'ORC ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Endereo de Entrega',
       '',
       'FILENT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       1350,
       3,
       'FILEQP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Filial Equipamento',
       'Filial Equipamento',
       '',
       'FILEQP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       30,
       3,
       'FILFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Endereo de Fatura',
       '',
       'FILFAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '--',
       940,
       3,
       'FILGUI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Indicador',
       'Filial do Parceiro Indicador',
       '',
       'FILGUI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       320,
       3,
       'FILPGT',
       'A',
       '',
       0,
       0,
       'ORC ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       'N',
       'F',
       '',
       'Filial do plano',
       '',
       'FILPGT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       480,
       3,
       'FILPRE',
       'A',
       '',
       0,
       0,
       'ORC ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       'N',
       'F',
       '',
       'Filial de origem da Tabela de preos',
       '',
       'FILPRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       60,
       3,
       'FILREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial do Registro',
       'Cdigo da filial do registro',
       '',
       'FILREG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       1510,
       3,
       'FILRET',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial Retirada',
       'Filial de Retirada',
       'DFIL.CODFIL = ORC.FILRET(+)',
       'FILRET',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       530,
       3,
       'FILTRA',
       'A',
       '',
       0,
       0,
       'ORC ',
       160,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       'N',
       'F',
       '',
       'Filial da transportadora',
       '',
       'FILTRA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       710,
       3,
       'FILUSU',
       'A',
       '',
       0,
       0,
       'ORC ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       'N',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILUSU',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       760,
       3,
       'FILVEN',
       'A',
       '',
       0,
       0,
       'ORC ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       'N',
       'F',
       '',
       'Filial do Vendedor',
       '',
       'FILVEN',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       1370,
       3,
       'FILWOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Filial Tarefa',
       'Filial Tarefa',
       '',
       'FILWOR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       1250,
       1,
       'FLGBON',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'DAV bnus?',
       'DAV bnus?',
       '',
       'FLGBON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '06',
       1070,
       1,
       'FLGECO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Sit. DAV E-Commerce',
       'Situao da DAV no E-Commerce',
       '',
       'FLGECO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       270,
       1,
       'FLGEST',
       'A',
       '',
       0,
       0,
       'ORC ',
       90,
       30,
       '',
       '',
       'D',
       'ORC',
       'F',
       'A',
       'T',
       'Situao',
       'Estado do pedido (Entregue/Pendente/Cancelado)',
       '',
       'FLGEST',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '04',
       1240,
       12,
       'JURPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Juros Parcelas',
       'Juros das Parcelas',
       '',
       'JURPAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '03',
       600,
       3,
       'LABORI',
       'A',
       '',
       0,
       0,
       'ORC ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       'N',
       'F',
       'Laboratrio Origem',
       'Laboratrio de origem',
       '',
       'LABORI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '03',
       640,
       3,
       'LOJORI',
       'A',
       '',
       0,
       0,
       'ORC ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       'N',
       'F',
       'Loja Origem',
       'Loja de origem',
       '',
       'LOJORI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       500,
       5,
       'MARCAS',
       'A',
       '',
       0,
       0,
       'ORC ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       '9',
       'F',
       'Marcas',
       'Marcas',
       '',
       'MARCAS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       190,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'ORC ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(ORC.ATU_EM,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       250,
       2,
       'MES_DATENT',
       'A',
       '',
       0,
       0,
       'ORC ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       '',
       'N',
       'T',
       'Ms de Entrega em',
       'Ms de Data da entrega (prevista)',
       '',
       'TO_CHAR(ORC.DATENT,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       440,
       2,
       'MES_DATPRI',
       'A',
       '',
       0,
       0,
       'ORC ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       '',
       'N',
       'T',
       'Ms de 1 Parcela',
       'Ms de Data da 1 parcela',
       '',
       'TO_CHAR(ORC.DATPRI,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       290,
       2,
       'MES_DATVAL',
       'A',
       '',
       0,
       0,
       'ORC ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       '',
       'N',
       'T',
       'Ms de Validade',
       'Ms de Data de validade do pedido',
       '',
       'TO_CHAR(ORC.DATVAL,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       220,
       2,
       'MES_PED_EM',
       'A',
       '',
       0,
       0,
       'ORC ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       '',
       'N',
       'T',
       'Ms de Pedido em',
       'Ms de Data e hora do pedido',
       '',
       'TO_CHAR(ORC.PED_EM,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       1450,
       40,
       'METENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Mtodo de Entrega',
       'Mtodo de Entrega',
       '',
       'METENT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       860,
       4000,
       'MSGVPE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem Ven.Perdida',
       'Mensagem Ven.Perdida',
       '',
       'MSGVPE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       460,
       1,
       'NATURE',
       'A',
       '',
       0,
       0,
       'ORC ',
       90,
       30,
       '',
       '',
       'D',
       'ORC',
       'F',
       'A',
       'T',
       'Tipo de Pagto.',
       'Natureza do pagamento',
       '',
       'NATURE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '03',
       1020,
       64,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nom. Clien. no Reg.',
       'Nome do Cliente no Registrado',
       '',
       'NOMCLI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       780,
       10,
       'NUMAUT',
       'A',
       '',
       0,
       0,
       'ORC ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       '9',
       'T',
       'Num. Aprovao',
       'Num. Aprovao',
       '',
       'NUMAUT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       310,
       8,
       'NUMBLO',
       'A',
       '',
       0,
       0,
       'ORC ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       '9',
       'T',
       'Nmero do Bloco',
       'Nmero do Bloco',
       '',
       'NUMBLO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       90,
       4,
       'NUMCOB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nm. End Cobrana',
       'Nmero Endereo da Cobrana',
       '',
       'NUMCOB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       135,
       3,
       'NUMCODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       340,
       3,
       'NUMECF',
       'A',
       '',
       0,
       0,
       'ORC ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       '0',
       'T',
       'ECF',
       'Nmero do ECF',
       '',
       'NUMECF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       20,
       2,
       'NUMENT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'ORC ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nm. End. Entrega',
       'Nmero Endereo de Entrega',
       '',
       'NUMENT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       80,
       4,
       'NUMFAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nm. End. Fatura',
       'Nmero Endereo da Fatura',
       '',
       'NUMFAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '03',
       610,
       4,
       'NUMLOR',
       'G',
       '',
       0,
       0,
       'ORC ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       '',
       'F',
       'Usu Interno',
       'Nmero do lote de retorno',
       '',
       'NUMLOR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '03',
       630,
       4,
       'NUMLOT',
       'G',
       '',
       0,
       0,
       'ORC ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       '',
       'F',
       'Nmero do Lote',
       'Nmero do lote',
       '',
       'NUMLOT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '03',
       620,
       8,
       'NUMNOT',
       'A',
       '',
       0,
       0,
       'ORC ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       '9',
       'F',
       'Nmero da Nota',
       'Nota do fornecedor terceirizado',
       '',
       'NUMNOT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '03',
       650,
       8,
       'NUMORI',
       'A',
       '',
       0,
       0,
       'ORC ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       '9',
       'F',
       'Nmero da Origem',
       'Nmero da loja de origem',
       '',
       'NUMORI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       150,
       8,
       'NUMPED',
       'A',
       '',
       0,
       0,
       'ORC ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       '9',
       'T',
       'Nmero',
       'Nmero do pedido',
       '',
       'NUMPED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '06',
       1520,
       20,
       'NUMPEDCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'N Ped Compra Cli.',
       'Nmero do Pedido de Compra do Cliente',
       '',
       'NUMPEDCOM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '--',
       1060,
       10,
       'NUMPED_PAF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Nmero do Pedido para PAF-ECF',
       '',
       'NUMPED_PAF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       1400,
       8,
       'NUMPED_RE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Nmero do Pedido RE',
       'Nmero do Pedido da Requisio Externa',
       '',
       'NUMPED_RE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       700,
       10,
       'NUMRES',
       'A',
       '',
       0,
       0,
       'ORC ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       '9',
       'T',
       'Nm. da Reserva',
       'Nmero de reserva',
       '',
       'NUMRES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       50,
       30,
       'NUMSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Nmero de Srie',
       'Nmero de Srie',
       '',
       'NUMSER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       590,
       4,
       'NUMVOL',
       'G',
       '',
       0,
       0,
       'ORC ',
       220,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       '',
       'T',
       'Quantidade Volumes',
       'Quantidade de Volumes',
       '',
       'NUMVOL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       730,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'ORC ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'ORC',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(ORC.OBSERV)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       790,
       4000,
       'OBSORC',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao Oramento',
       'Observao do Oramento',
       '',
       'OBSORC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       1180,
       2,
       'ORCIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Oramento Impresso?',
       'Oramento Impresso?',
       '',
       'ORCIMP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       1530,
       1,
       'SISORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Sistema de Origem',
       'Sistema de Origem',
       '',
       'SISORI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       210,
       8,
       'PED_EM',
       '@',
       '',
       0,
       0,
       'ORC ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       '@',
       'T',
       'Pedido em',
       'Data e hora do pedido',
       '',
       'PED_EM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '04',
       1320,
       10,
       'PERLUCTOT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Lucro Orc',
       '% Lucro no Oramento',
       '',
       'PERLUCTOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '04',
       1300,
       7,
       'PERMCOTOT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Contribuio Orc',
       '% Margem de Contribuio no Oramento',
       '',
       'PERMCOTOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '04',
       1280,
       12,
       'PERMCPTOT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Contribuio Pro',
       '% Margem de Contribuio do Produto',
       '',
       'PERMCPTOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       560,
       14,
       'PESBRU',
       'F',
       '',
       4,
       0,
       'ORC ',
       190,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'T',
       '',
       'T',
       'Peso Bruto',
       'Peso Bruto',
       '',
       'PESBRU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '05',
       1230,
       14,
       'PESBRU_ENT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Peso Bruto p/ Entreg',
       'Peso Bruto Total dos Itens para Entrega',
       '',
       'PESBRU_ENT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       570,
       14,
       'PESLIQ',
       'F',
       '',
       4,
       0,
       'ORC ',
       200,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'T',
       '',
       'T',
       'Peso Lquido',
       'Peso Lquido',
       '',
       'PESLIQ',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       870,
       7,
       'PLACAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Placa Veculo',
       'Placa do Veculo',
       '',
       'PLACAS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       1270,
       7,
       'PLACAT',
       'A',
       'VEI ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       'VEI.',
       'A',
       '',
       '',
       'A',
       '',
       'Placa Transportadora',
       'Placa do Veculo da Transportadora',
       'VEI.PLACAS = ORC.PLACAT',
       'PLACAT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       980,
       1,
       'PREDAV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Pr-venda/DAV',
       'Pr-venda/DAV',
       '',
       'PREDAV',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       1170,
       3,
       'PRZENT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nm Dias p/ entrega',
       'Nmero do Dias para Entrega',
       '',
       'PRZENT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       410,
       2,
       'QTDPAR',
       'S',
       '',
       0,
       0,
       'ORC ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'F',
       '',
       'T',
       'Qtd. de Parcelas',
       'Quantidade de parcelas',
       '',
       'QTDPAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       880,
       7,
       'QTD_KM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde KM',
       'Qtde KM',
       '',
       'QTD_KM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       740,
       1,
       'RESERV',
       'L',
       '',
       0,
       0,
       'ORC ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'ORC',
       'F',
       '',
       'T',
       'Reserva?',
       'Reserva o estoque (Verdadeiro/Falso)',
       '',
       'RESERV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       890,
       1,
       'SEPARA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Necessita Separao?',
       'Necessita Separao?',
       '',
       'SEPARA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '--',
       1120,
       10,
       'SEQADI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQADI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       1500,
       10,
       'SEQCUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '.',
       'I',
       '',
       '',
       '9',
       '',
       'Seq. Cupom',
       'Sequencial do cupom',
       '. = ORC.SEQCUP',
       'SEQCUP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       1360,
       10,
       'SEQEQP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Seq Equipamento',
       'Seq Equipamento',
       '',
       'SEQEQP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       1380,
       10,
       'SEQWOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Seq Tarefa',
       'Seq Tarefa',
       '',
       'SEQWOR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       750,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'ORC ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'ORC',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN ORC.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       380,
       12,
       'SINAL',
       'F',
       '',
       2,
       0,
       'ORC ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'T',
       '',
       'T',
       'Sinal ou Entrada',
       'Sinal ou entrada',
       '',
       'SINAL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       370,
       12,
       'SINALP',
       'F',
       '',
       2,
       0,
       'ORC ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'T',
       '',
       'T',
       'Sinal Apropriado',
       'Sinal pago ou valor dos itens',
       '',
       'SINALP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '03',
       1040,
       10,
       'TELCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Tel. Clien. no Reg.',
       'Telefone do Cliente no Registrado',
       '',
       'TELCLI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '--',
       950,
       1,
       'TELEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Por Televendas',
       'Oramento por Televendas (no envia para Checkout)',
       '',
       'TELEVE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '05',
       660,
       1,
       'TIPENT',
       'A',
       '',
       0,
       0,
       'ORC ',
       10,
       30,
       '',
       '',
       'D',
       'ORC',
       'F',
       'A',
       'T',
       'Tipo de Entrega',
       'Tipo de entrega',
       '',
       'TIPENT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       1520,
       10,
       'TIPINT',
       'N',
       'DTXI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DTXI.CODTAB',
       'V',
       '',
       '',
       'A',
       '',
       'Tipo Intermediao',
       'Tipo da Intermediao',
       'DTXI.CODTAB(+) = ORC.TIPINT(+)',
       'TIPINT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       670,
       2,
       'TIPOBS',
       'S',
       'DOBS',
       0,
       0,
       'ORC ',
       10,
       TO_NUMBER(null),
       '',
       'DOBS.DESOBS',
       'V',
       'ORC',
       'F',
       'N',
       'T',
       'Observao Padro',
       'Observao padro',
       'ORC.TIPOBS=DOBS.CODTAB (+)',
       'TIPOBS',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       1470,
       1,
       'TIPPAG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo de Pagamento',
       'Tipo de Pagamento',
       '',
       'TIPPAG',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '01',
       140,
       1,
       'TIPPED',
       'A',
       '',
       0,
       0,
       'ORC ',
       20,
       30,
       '',
       '',
       'D',
       'ORC',
       'F',
       'A',
       'T',
       'Tipo de Pedido/OS',
       'Tipo de pedido',
       '',
       'TIPPED',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       1390,
       3,
       'TRNECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'ECF do ID Transao',
       'ECF do ID da Transao',
       '',
       'TRNECF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       1400,
       12,
       'TRN_ID',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'ID da Transao',
       'ID da Transao',
       '',
       'TRN_ID',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '99',
       1460,
       200,
       'URLENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'URL de Entrega',
       'URL de Entrega',
       '',
       'URLENT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '04',
       990,
       12,
       'VLRADI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Valor Adiantamento',
       'Valor do Adiantamento',
       '',
       'VLRADI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       420,
       12,
       'VLRDES',
       'F',
       '',
       2,
       0,
       'ORC ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'T',
       '',
       'T',
       'Valor do Desconto',
       'Valor do desconto',
       '',
       'VLRDES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       520,
       12,
       'VLRFRE',
       'F',
       '',
       2,
       0,
       'ORC ',
       150,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'T',
       '',
       'T',
       'Valor do Frete',
       'Valor do Frete',
       '',
       'VLRFRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '04',
       1330,
       14,
       'VLRLUCTOT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vl Lucro Orc',
       'Valor Lucro no Oramento',
       '',
       'VLRLUCTOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '04',
       1310,
       14,
       'VLRMCOTOT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vl Contribuio Orc',
       'Valor Margem de Contribuio no Oramento',
       '',
       'VLRMCOTOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '04',
       1290,
       14,
       'VLRMCPTOT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vl Contribuio Pro',
       'Valor Margem de Contribuio do Produto',
       '',
       'VLRMCPTOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       400,
       12,
       'VLRPAR',
       'F',
       '',
       2,
       0,
       'ORC ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'T',
       '',
       'T',
       'Valor da Parcela',
       'Valor da parcela',
       '',
       'VLRPAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '04',
       1200,
       12,
       'VLRSAD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Vlr Serv Adicional ',
       'Valor de Servios Adicionais Total',
       '',
       'VLRSAD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       550,
       12,
       'VLRSEG',
       'F',
       '',
       2,
       0,
       'ORC ',
       180,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'T',
       '',
       'T',
       'Valor do Seguro',
       'Valor do Seguro',
       '',
       'VLRSEG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ORC ',
       '02',
       360,
       12,
       'VLRTOT',
       'F',
       '',
       2,
       0,
       'ORC ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'ORC',
       'T',
       '',
       'T',
       'Valor Total',
       'Valor total do pedido',
       '',
       'VLRTOT',
       'F',
       'D' FROM DUAL
);

/*-- SEQ 8867 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ORC ',
       'APRCLI',
       0,
       '1',
       'Aprovado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'APRCLI',
       0,
       '2',
       'Reprovado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'APRCLI',
       0,
       'A',
       'Em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'APROVA',
       0,
       'A',
       'Aprovado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'APROVA',
       0,
       'E',
       'Em Aprovao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'APROVA',
       0,
       'R',
       'Reprovado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'CODSVE',
       41106,
       ' ',
       'FRETE PAC',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'CODSVE',
       40010,
       ' ',
       'FRETE SEDEX',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'CODSVE',
       40215,
       ' ',
       'FRETE SEDEX 10',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'CODSVE',
       40290,
       ' ',
       'FRETE SEDEX HOJE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'CODSVE',
       81019,
       ' ',
       'FRETE E-SEDEX',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'CODSVE',
       44105,
       ' ',
       'FRETE MALOTE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'CODSVE',
       41017,
       ' ',
       'FRETE NORMAL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'CODSVE',
       40045,
       ' ',
       'SEDEX A COBRAR',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'COMAND',
       0,
       'E',
       ' comanda entregue',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'COMAND',
       0,
       'F',
       'No  comanda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'COMAND',
       0,
       'T',
       ' comanda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'FLGECO',
       0,
       'O',
       'Problema na Entrega/Retirada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'FLGECO',
       0,
       'N',
       'Produto entregue',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'FLGECO',
       0,
       'C',
       'Pagamento cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'FLGECO',
       0,
       'V',
       'Faturado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'FLGECO',
       0,
       '2',
       'Retirado pelo cliente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'FLGECO',
       0,
       '1',
       'Pronto para retirada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'FLGECO',
       0,
       '0',
       'Rejeitado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'FLGECO',
       0,
       'E',
       'Produto Enviado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'FLGECO',
       0,
       'F',
       'Pagamento efetivado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'FLGECO',
       0,
       'P',
       'Pagamento aprovado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'FLGECO',
       0,
       'R',
       'Pendente de pagamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'FLGECO',
       0,
       'T',
       'Pagamento em anlise',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'FLGEST',
       0,
       'A',
       'Em aberto',
       79,
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       80,
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'FLGEST',
       0,
       'E',
       'Vendido',
       78,
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'FLGEST',
       0,
       'O',
       'Concludo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'NATURE',
       0,
       '0',
       'A vista',
       81,
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'NATURE',
       0,
       '1',
       'Credirio',
       82,
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'NATURE',
       0,
       '2',
       'Cheques',
       83,
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'NATURE',
       0,
       '3',
       'Financeira',
       84,
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'SISORI',
       0,
       'A',
       'App',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'SISORI',
       0,
       'H',
       'Home',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'SISORI',
       0,
       'S',
       'Site',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'PREDAV',
       0,
       'D',
       'DAV',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'PREDAV',
       0,
       'P',
       'Pr Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'TIPENT',
       0,
       '0',
       'Cliente Leva',
       86,
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'TIPENT',
       0,
       '1',
       'Entrega Direta',
       87,
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'TIPENT',
       0,
       '2',
       'Loja Entrega',
       88,
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'TIPENT',
       0,
       '3',
       'Retira no Depsito',
       89,
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'TIPENT',
       0,
       '4',
       'Em Outra Loja',
       90,
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'TIPENT',
       0,
       '5',
       'Entrega Futura',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'TIPENT',
       0,
       '6',
       'Apenas Oramento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'TIPENT',
       0,
       '7',
       'Venda sob Encomenda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'TIPPAG',
       0,
       'B',
       'Boleto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'TIPPAG',
       0,
       'C',
       'Conta Corrente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'TIPPAG',
       0,
       'P',
       'Parcela em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'TIPPED',
       0,
       'O',
       'DAV',
       71,
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'TIPPED',
       0,
       'P',
       'Pr-Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORC ',
       'TIPPED',
       0,
       'S',
       'DAV-OS',
       72,
       ' ' FROM DUAL
);

/*-- SEQ 8868 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ORCE',
       TO_NUMBER(null),
       'ORCE',
       'Log Status Ecommerce',
       'TT_ORC_ECO',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'ORCECO_ID',
       '' FROM DUAL
);

/*-- SEQ 8869 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ORCE','--','' FROM DUAL
UNION ALL
SELECT 'ORCE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ORCE','99','Outros' FROM DUAL
);

/*-- SEQ 8870 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 136820,
       'ORC',
       'ORCE',
       '0N',
       '1',
       '',
       '',
       'ORC.CODFIL = ORCE.FILORC AND ORC.TIPPED=ORCE.TIPORC AND ORC.NUMPED=ORCE.NUMORC',
       '',
       '' FROM DUAL
);

/*-- SEQ 8871 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'ORCE',
       '--',
       10.00,
       10.00,
       'ORCECO_ID',
       'S',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'N',
       '',
       'ID',
       '',
       '',
       'ORCECO_ID',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORCE',
       '--',
       20.00,
       3.00,
       'FILORC',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       '',
       'Filial Oramento',
       '',
       '',
       'FILORC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORCE',
       '--',
       30.00,
       1.00,
       'TIPORC',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30.00,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo do oramento',
       '',
       '',
       'TIPORC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORCE',
       '--',
       40.00,
       8.00,
       'NUMORC',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Nmero do Oramento',
       '',
       '',
       'NUMORC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORCE',
       '--',
       50.00,
       1.00,
       'FLGECO',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30.00,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Status',
       '',
       '',
       'FLGECO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ORCE',
       '--',
       60.00,
       8.00,
       'DATOPE',
       '@',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Operao',
       '',
       '',
       'DATOPE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORCE',
       '--',
       70.00,
       1.00,
       'EXPORT',
       'L',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exportado?',
       '',
       '',
       'EXPORT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORCE',
       '--',
       80.00,
       8.00,
       'DATINC',
       '@',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data De Incluso',
       '',
       '',
       'DATINC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ORCE',
       '--',
       90.00,
       -1.00,
       'OBSERV',
       'M',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Observao',
       '',
       '',
       'OBSERV',
       '',
       'D' FROM DUAL
);

/*-- SEQ 8872 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ORCE',
       'FLGECO',
       0.00,
       'O',
       'Problema na Entrega/Retirada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORCE',
       'FLGECO',
       0.00,
       'T',
       'Pagamento Em Anlise',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORCE',
       'FLGECO',
       0.00,
       'R',
       'Pendente Pagamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORCE',
       'FLGECO',
       0.00,
       'P',
       'Pagamento Aprovado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORCE',
       'FLGECO',
       0.00,
       'F',
       'Pagamento Efetivado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORCE',
       'FLGECO',
       0.00,
       'E',
       'Produto Enviado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORCE',
       'FLGECO',
       0.00,
       'N',
       'Produto Entregue',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORCE',
       'FLGECO',
       0.00,
       'C',
       'Pagamento Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORCE',
       'FLGECO',
       0.00,
       'V',
       'Faturado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORCE',
       'FLGECO',
       0.00,
       '2',
       'Retirado pelo cliente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORCE',
       'FLGECO',
       0.00,
       '1',
       'Pronto para retirada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORCE',
       'FLGECO',
       0.00,
       '0',
       'Rejeitado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORCE',
       'TIPORC',
       0.00,
       'O',
       'DAV',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORCE',
       'TIPORC',
       0.00,
       'P',
       'Pr-Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ORCE',
       'TIPORC',
       0.00,
       'S',
       'DAV-OS',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8873 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'OUT ',
       TO_NUMBER(null),
       'OUT ',
       'Exportao Checkout',
       'TT_OUT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'OUT.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 8874 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'OUT ','--','' FROM DUAL
);

/*-- SEQ 8875 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'OUT ',
       '--',
       12,
       5,
       'CODEXP',
       'S',
       'DEXP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEXP.DESEXP',
       'V',
       '',
       '',
       'A',
       'F',
       'Tipo Exportao',
       'Tipo Exportao',
       'DEXP.CODTAB = OUT.CODEXP',
       'CODEXP',
       'F' FROM DUAL
UNION ALL
SELECT 'OUT ',
       '--',
       1,
       4,
       'CODTAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'OUT ',
       '--',
       2,
       4000,
       'SQLOUT',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'SQL',
       'SQL',
       '',
       'RTF2TXT(SQLOUT)',
       'F' FROM DUAL
UNION ALL
SELECT 'OUT ',
       '--',
       22,
       30,
       'TITOUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo~Exportao',
       'Ttulo do que se deseja exportar',
       '',
       'TITOUT',
       'F' FROM DUAL
);

/*-- SEQ 8876 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PAG ',
       TO_NUMBER(null),
       'PAG ',
       'Pagamentos',
       'TV_PGT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'PAG.CODFIL,PAG.SEQUEN,PAG.NUMPAR,PAG.SUBPAR',
       '' FROM DUAL
);

/*-- SEQ 8877 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PAG ','--','' FROM DUAL
UNION ALL
SELECT 'PAG ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PAG ','02','Datas' FROM DUAL
UNION ALL
SELECT 'PAG ','03','Valores' FROM DUAL
UNION ALL
SELECT 'PAG ','99','Outros' FROM DUAL
);

/*-- SEQ 8878 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21757,
       'COM ',
       'PAG ',
       '1',
       'N',
       '',
       '',
       'PAG.CODFIL(+) = COM.CODFIL AND
PAG.SEQUEN(+) = COM.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21758,
       'DOP ',
       'PAG ',
       '1',
       'N',
       '',
       '',
       'PAG.FILDOP = DOP.CODFIL AND
PAG.SEQDOP = DOP.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21759,
       'FCM ',
       'PAG ',
       '1',
       'N',
       '',
       '',
       'PAG.CODFIL = FCM.CODFIL and PAG.SEQUEN = FCM.SEQUEN',
       'PAG.VLRPAR / FCM.VLRTOT',
       '' FROM DUAL
UNION ALL
SELECT 21760,
       'USU ',
       'PAG ',
       'N',
       '1',
       '',
       '',
       'USU.FILUSU = PAG.FILUSU AND USU.CODUSU = PAG.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21761,
       'FRE ',
       'PAG ',
       '1',
       'N',
       '',
       '',
       'PAG.CODFIL(+) = FRE.CODFIL AND
PAG.SEQUEN(+) = FRE.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 8879 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PAG ',
       '02',
       125,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'PAG ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAG',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(PAG.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '02',
       35,
       4,
       'ANO_DATPGT',
       'A',
       '',
       0,
       0,
       'PAG ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAG',
       '',
       'N',
       'T',
       'Ano de Pagamento',
       'Ano de Data de pagamento',
       '',
       'TO_CHAR(PAG.DATPGT,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '02',
       25,
       4,
       'ANO_DATVEN',
       'A',
       '',
       0,
       0,
       'PAG ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAG',
       '',
       'N',
       'T',
       'Ano de Vencimento',
       'Ano de Data de vencimento',
       '',
       'TO_CHAR(PAG.DATVEN,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '02',
       10,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '99',
       330,
       200,
       'AUTBAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cod autenticacao Ban',
       'Cdigo completo da autenticao bancria',
       '',
       'AUTBAN',
       '' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '01',
       20,
       3,
       'CODAUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Autorizao',
       'Cdigo Autorizao',
       '',
       'CODAUT',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '01',
       30,
       3,
       'CODBCO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Banco',
       'Cdigo do Banco',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '01',
       40,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'PAG.CODFIL = DFIL.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '01',
       50,
       3,
       'CODPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Cdigo do Produto',
       '',
       'CODPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '01',
       60,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'PAG.FILUSU = USU.FILUSU(+)  and PAG.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '01',
       70,
       5,
       'CONPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Conta Pagto.',
       'Conta para lanamento no OF-CASH',
       '',
       'CONPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '02',
       130,
       12,
       'CalcPagAtu',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr. corrigido',
       'Valor corrigido da parcela',
       '',
       'CalcPagAtu(PAG.CODFIL,PAG.SEQUEN,PAG.NUMPAR,PAG.SUBPAR,0)',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '02',
       270,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '02',
       80,
       8,
       'DATPGT',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Pagamento',
       'Data de pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '02',
       220,
       8,
       'DATPRJ',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Projetada',
       'Data Projetada',
       '',
       '(CASE WHEN PAG.FLGEST = ''A'' THEN PAG.DATVEN WHEN PAG.FLGEST IN (''1'',''2'',''P'') AND PAG.DATPGT IS NOT NULL THEN PAG.DATPGT WHEN PAG.FLGEST IN (''1'',''2'') AND PAG.DATPGT IS NULL THEN PAG.DATVEN WHEN PAG.FLGEST IN (''C'',''X'') THEN PAG.DATVEN END)',
       '' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '02',
       90,
       7,
       'DATPRX',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Prximo Vencto',
       'Data do Prximo Vencimento',
       '',
       'DATPRX',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '02',
       100,
       8,
       'DATVEN',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data de Vencimento',
       'Data de Vencimento',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '01',
       110,
       8,
       'DOCPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento Pagamento',
       'Documento Pagamento',
       '',
       'DOCPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '99',
       120,
       1,
       'DUMMY',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       '',
       'Dummy',
       '',
       'DUMMY',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '01',
       130,
       3,
       'FILAUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Autoriazao',
       'Filial Autorizao',
       '',
       'FILAUT',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '01',
       140,
       3,
       'FILDOP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Doc. PGTO',
       'Filial Documento Pagamento',
       '',
       'FILDOP',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '01',
       150,
       3,
       'FILPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Produto',
       '',
       'FILPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '01',
       160,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '99',
       170,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Estado',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '02',
       123,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'PAG ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAG',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(PAG.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '02',
       33,
       2,
       'MES_DATPGT',
       'A',
       '',
       0,
       0,
       'PAG ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAG',
       '',
       'N',
       'T',
       'Ms de Pagamento',
       'Ms de Data de pagamento',
       '',
       'TO_CHAR(PAG.DATPGT,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '02',
       23,
       2,
       'MES_DATVEN',
       'A',
       '',
       0,
       0,
       'PAG ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAG',
       '',
       'N',
       'T',
       'Ms de Vencimento',
       'Ms de Data de vencimento',
       '',
       'TO_CHAR(PAG.DATVEN,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '01',
       45,
       3,
       'NUMCODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '01',
       180,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Parcela',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '03',
       265,
       12,
       'PARCELA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       '',
       'Parcela',
       'Parcela',
       '',
       'COALESCE((PAG.NUMPAR|| CASE WHEN PAG.SUBPAR = '' 0'' THEN '''' ELSE ''-'' || Trim(PAG.SUBPAR) END), '''')',
       '' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '99',
       280,
       2,
       'RENEGO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Num. renegociao',
       'Nmero da renegociao',
       '',
       'RENEGO',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '99',
       290,
       2,
       'RENORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Reneg. Original',
       'Renegociao Original',
       '',
       'RENORI',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '99',
       190,
       10,
       'SEQDOP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Documento Pagamento',
       '',
       'SEQDOP',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '99',
       200,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '99',
       210,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN PAG.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '99',
       211,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN PAG.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '--',
       300,
       2,
       'SUBORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SUBORI',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '01',
       220,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Sub-Parcela',
       'Sub Parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '01',
       320,
       2,
       'TOTPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Total Parcela',
       'Total Parcela',
       '',
       '(SELECT MAX(TPAR.NUMPAR) AS TOTPAR
   FROM TV_PGT TPAR
  WHERE TPAR.CODFIL = PAG.CODFIL
    AND TPAR.SEQUEN = PAG.SEQUEN)',
       '' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '02',
       140,
       250,
       'TRACO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Espao para Anotao',
       'Espao para Anotao',
       '',
       'LPAD(''_'',50,''_'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '03',
       350,
       12,
       'VALORIGEM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Valor Origem',
       'Valor Dif Origem',
       '',
       'DIFERENCA_SUBPAR_ORIGEM(PAG.CODFIL,PAG.SEQUEN,PAG.NUMPAR,PAG.SUBORI)',
       '' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '--',
       310,
       12,
       'VE_PAGTO_FUN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VE_PAGTO_FUN',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '03',
       230,
       12,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Desconto',
       'Valor Desconto',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '03',
       240,
       12,
       'VLRDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Saldo',
       'Saldo',
       '',
       'VLRDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '99',
       340,
       12,
       'VLRJUR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Juros Financiamentos',
       'Valor de Juros para Financiamento',
       '',
       'VLRJUR',
       '' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '03',
       250,
       12,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Parcela',
       'Valor Parcela',
       '',
       'VLRPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'PAG ',
       '03',
       260,
       12,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Pagamento',
       'Valor Pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 8880 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'PAG ',
       'FLGEST',
       0,
       '1',
       'Programado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PAG ',
       'FLGEST',
       0,
       '2',
       'Autorizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PAG ',
       'FLGEST',
       0,
       'A',
       'A Pagar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PAG ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PAG ',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PAG ',
       'FLGEST',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8881 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PAP ',
       TO_NUMBER(null),
       'PAP ',
       'Prev.Contas a Pagar',
       'TV_PAP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'pap.codfil',
       '' FROM DUAL
);

/*-- SEQ 8882 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PAP ','--','' FROM DUAL
);

/*-- SEQ 8883 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5710,
       'PVD ',
       'PAP ',
       '1 ',
       'N ',
       '',
       '',
       'PVD.FILPAR = PAP.FILFOR and
PVD.CODPAR = PAP.CODFOR and
PVD.TIPPAR = PAP.TIPPAR',
       '' FROM DUAL
);

/*-- SEQ 8884 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PAP ',
       '--',
       105,
       4,
       'ANO_COMPET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data Compra',
       'Ano de Data Compra',
       '',
       'TO_CHAR(PAP.COMPET,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       55,
       4,
       'ANO_DATVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Vencimento',
       'Ano de Vencimento',
       '',
       'TO_CHAR(PAP.DATVEN,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial origem',
       'PAP.CODFIL = DFIL.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       120,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo do Fornecedor',
       'Cdigo do fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       80,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Srie',
       'Srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       100,
       8,
       'COMPET',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Compra',
       'Data Compra',
       '',
       'COMPET',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       200,
       7,
       'DATPRE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       50,
       8,
       'DATVEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Vencimento',
       'Vencimento',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       70,
       21,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Doc. Parcela',
       'Parcela+Sub-Parcela',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       210,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       110,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial do fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       220,
       1,
       'FLGFLU',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FLGFLU',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       150,
       1,
       'INCOJU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Correo',
       'Indicador do tipo de correo de juros',
       '',
       'INCOJU',
       'T' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       160,
       1,
       'INTPJU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Juros',
       'Indicador do tipo de juros',
       '',
       'INTPJU',
       'T' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       170,
       1,
       'INTPMU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Multa',
       'Indicador do tipo de multa',
       '',
       'INTPMU',
       'T' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       103,
       2,
       'MES_COMPET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data Compra',
       'Ms de Data Compra',
       '',
       'TO_CHAR(PAP.COMPET,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       53,
       2,
       'MES_DATVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Vencimento',
       'Ms de Vencimento',
       '',
       'TO_CHAR(PAP.DATVEN,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       20,
       8,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nro da Nota',
       'Nro da Nota',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       30,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       'Parcela',
       'Parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       230,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       240,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       250,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       180,
       1,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'STATUS',
       'T' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       40,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       'Sub-Parcela',
       'Sub-Parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       90,
       3,
       'SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Sub-Srie',
       'Sub-Srie',
       '',
       'SUBSER',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       260,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       270,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       190,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Parceiro',
       'Tipo de parceiro',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       280,
       12,
       'VLRCAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VLRCAL',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       60,
       12,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Parcela',
       'Valor Parcela',
       '',
       'VLRPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       290,
       12,
       'VLRPRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VLRPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       130,
       12,
       'VLTXJU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Juros',
       'Juros ou taxa de juros',
       '',
       'VLTXJU',
       'F' FROM DUAL
UNION ALL
SELECT 'PAP ',
       '--',
       140,
       12,
       'VLTXMU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Multa',
       'Multa ou taxa de multa',
       '',
       'VLTXMU',
       'F' FROM DUAL
);

/*-- SEQ 8885 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'PAP ',
       'INCOJU',
       0,
       '$',
       'Moeda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PAP ',
       'INCOJU',
       0,
       '0',
       'Nao h',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PAP ',
       'INCOJU',
       0,
       'A',
       'Anual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PAP ',
       'INCOJU',
       0,
       'D',
       'Dirio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PAP ',
       'INCOJU',
       0,
       'M',
       'Mensal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PAP ',
       'INTPJU',
       0,
       'C',
       'Composto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PAP ',
       'INTPJU',
       0,
       'F',
       'Fixo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PAP ',
       'INTPJU',
       0,
       'S',
       'Simples',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PAP ',
       'INTPMU',
       0,
       '#',
       'Percentual Corrigido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PAP ',
       'INTPMU',
       0,
       '$',
       'Valor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PAP ',
       'INTPMU',
       0,
       '%',
       'Percentual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PAP ',
       'INTPMU',
       0,
       '@',
       'Valor Corrigido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PAP ',
       'STATUS',
       0,
       'E',
       'Efetivo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PAP ',
       'STATUS',
       0,
       'P',
       'Previso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PAP ',
       'TIPPAR',
       0,
       'F',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PAP ',
       'TIPPAR',
       0,
       'T',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8886 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PAR ',
       0,
       'PAR ',
       'Parceiros',
       'TV_PAR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'PAR.FILCLI,PAR.CODCLI
PAR.NOMCLI,PAR.ULTNOM
PAR.NUMDOC
',
       '' FROM DUAL
);

/*-- SEQ 8887 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PAR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PAR ','02','Endereo' FROM DUAL
UNION ALL
SELECT 'PAR ','03','Documentao' FROM DUAL
UNION ALL
SELECT 'PAR ','04','Dados Financeiros' FROM DUAL
UNION ALL
SELECT 'PAR ','99','Outros' FROM DUAL
);

/*-- SEQ 8888 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21763,
       'EDE ',
       'PAR ',
       'N',
       '1',
       '',
       '',
       'EDE.FILCLI = PAR.FILCLI AND
EDE.CODCLI = PAR.CODCLI
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21764,
       'REL ',
       'PAR ',
       'N',
       '1',
       '',
       '',
       'PAR.FILCLI = REL.FILPAR AND
PAR.CODCLI = REL.CODPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21765,
       'SPC ',
       'PAR ',
       '01',
       '01',
       '',
       'PAR.FLGTIP = 1',
       'SPC.FILCLI = PAR.FILCLI (+) and
SPC.CODCLI = PAR.CODCLI (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21766,
       'CON ',
       'PAR ',
       '0N',
       '01',
       '',
       '',
       'CON.FILCLI = PAR.FILCLI (+) and
CON.CODCLI = PAR.CODCLI (+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 8889 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PAR ',
       '01',
       55,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'PAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(PAR.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '99',
       55,
       4,
       'ANO_DATA01',
       'A',
       '',
       0,
       0,
       'PAR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 1',
       '',
       'TO_CHAR(PAR.DATA01,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '99',
       65,
       4,
       'ANO_DATA02',
       'A',
       '',
       0,
       0,
       'PAR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 2',
       '',
       'TO_CHAR(PAR.DATA02,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '99',
       75,
       4,
       'ANO_DATA03',
       'A',
       '',
       0,
       0,
       'PAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 3',
       '',
       'TO_CHAR(PAR.DATA03,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '01',
       65,
       4,
       'ANO_DATNAS',
       'A',
       '',
       0,
       0,
       'PAR ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ano de Nascto/Funda',
       'Ano de Data de nascimento ou fundao',
       '',
       'TO_CHAR(PAR.DATNAS,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '01',
       75,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       0,
       'PAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ano de Data Incluso',
       'Ano de Data de operao (cadastramento)',
       '',
       'TO_CHAR(PAR.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '01',
       115,
       4,
       'ANO_NASCON',
       'A',
       '',
       0,
       0,
       'PAR ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ano de Nascto Cnj./',
       'Ano de Data de nascimento do cnjuge ou contato principal',
       '',
       'TO_CHAR(PAR.NASCON,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '04',
       85,
       4,
       'ANO_ULTCOM',
       'A',
       '',
       0,
       0,
       'PAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ano de ltima Compra',
       'Ano de Data da ltima compra',
       '',
       'TO_CHAR(PAR.ULTCOM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '01',
       50,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'PAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '99',
       20,
       2,
       'CATEG1',
       'S',
       'DCT1',
       0,
       20,
       'PAR ',
       10,
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'V',
       'PAR',
       'F',
       'A',
       'T',
       '',
       'Categoria - 1',
       'PAR.CATEG1=DCT1.CODTAB (+)',
       'CATEG1',
       'T' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '99',
       30,
       2,
       'CATEG2',
       'S',
       'DCT2',
       0,
       21,
       'PAR ',
       20,
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'V',
       'PAR',
       'F',
       'A',
       'T',
       '',
       'Categoria - 2',
       'PAR.CATEG2=DCT2.CODTAB (+)',
       'CATEG2',
       'T' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '99',
       40,
       2,
       'CATEG3',
       'S',
       'DCT3',
       0,
       22,
       'PAR ',
       30,
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'V',
       'PAR',
       'F',
       'A',
       'T',
       'TIPO',
       'Categoria - 3',
       'PAR.CATEG3=DCT3.CODTAB (+)',
       'CATEG3',
       'T' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '01',
       25,
       9,
       'CHAVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Parceiro',
       'Cdigo do Parceiro',
       '',
       'FILCLI||PAR.CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       0,
       'PAR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       '9',
       'T',
       'Cdigo',
       'Cdigo do parceiro',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '04',
       60,
       3,
       'CODPLA',
       'A',
       'PLA ',
       0,
       24,
       'PAR ',
       60,
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       'PAR',
       'F',
       'A',
       'T',
       'Plano padro',
       'Cdigo do plano padro',
       'PAR.FILPLA=PLA.FILPGT (+) and PAR.CODPLA=PLA.CODPGT (+)',
       'CODPLA',
       'T' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '01',
       90,
       2,
       'CODSEX',
       'S',
       '',
       0,
       19,
       'PAR ',
       90,
       30,
       '',
       '',
       'D',
       'PAR',
       'F',
       'A',
       'T',
       'Sexo',
       'Cdigo de Sexo do parceiro',
       '',
       'CODSEX',
       'T' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '04',
       120,
       3,
       'CODVEN',
       'A',
       'USU ',
       0,
       0,
       'PAR ',
       120,
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       'PAR',
       'F',
       'A',
       'T',
       'Vendedor Padro',
       'Vendedor Padro',
       'PAR.FILVEN=USU.FILUSU(+) and PAR.CODVEN=USU.CODUSU(+)',
       'CODVEN',
       'T' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '01',
       100,
       44,
       'CONJUG',
       'A',
       '',
       0,
       0,
       'PAR ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PAR',
       'F',
       'A',
       'T',
       'Cnjuge ou Contato',
       'Nome do Cnjuge ou do Contato principal',
       '',
       'CONJUG',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '99',
       50,
       8,
       'DATA01',
       'D',
       '',
       0,
       0,
       'PAR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'D',
       'T',
       '',
       'Data livre - 1',
       '',
       'DATA01',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '99',
       60,
       8,
       'DATA02',
       'D',
       '',
       0,
       0,
       'PAR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'D',
       'T',
       '',
       'Data livre - 2',
       '',
       'DATA02',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '99',
       70,
       8,
       'DATA03',
       'D',
       '',
       0,
       0,
       'PAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'D',
       'T',
       '',
       'Data livre - 3',
       '',
       'DATA03',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '01',
       60,
       8,
       'DATNAS',
       'D',
       '',
       0,
       0,
       'PAR ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'D',
       'T',
       'Nascto/Fundao',
       'Data de nascimento ou fundao',
       '',
       'DATNAS',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '01',
       70,
       8,
       'DATOPE',
       'D',
       '',
       0,
       0,
       'PAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'D',
       'T',
       'Data Incluso',
       'Data de operao (cadastramento)',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '03',
       50,
       15,
       'DOCCON',
       'A',
       '',
       0,
       0,
       'PAR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PAR',
       'F',
       'A',
       'T',
       'Doc. Cnjuge/Contato',
       'Doc. Cnjuge/Contato',
       '',
       'DOCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '01',
       130,
       15,
       'DOCVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Documento Vnculo',
       'Documento Vnculo',
       '',
       'DOCVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '03',
       10,
       2,
       'ESTCIV',
       'S',
       '',
       0,
       18,
       'PAR ',
       10,
       30,
       '',
       '',
       'D',
       'PAR',
       'F',
       'A',
       'T',
       'Estado Civil',
       'Estado Civil',
       '',
       'ESTCIV',
       'T' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '01',
       10,
       3,
       'FILCLI',
       'A',
       '',
       0,
       0,
       'PAR ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'N',
       'T',
       '',
       'Filial onde foi cadastrado o parceiro',
       '',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '04',
       50,
       3,
       'FILPLA',
       'A',
       '',
       0,
       0,
       'PAR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'N',
       'F',
       'Filial do Plano',
       'Filial do Plano',
       '',
       'FILPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '04',
       110,
       3,
       'FILVEN',
       'A',
       '',
       0,
       0,
       'PAR ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'N',
       'F',
       '',
       'Filial do Vendedor',
       '',
       'FILVEN',
       'T' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '03',
       30,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       0,
       'PAR ',
       30,
       30,
       '',
       '',
       'D',
       'PAR',
       'F',
       'A',
       'T',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '02',
       80,
       40,
       'HOMPGE',
       'A',
       '',
       0,
       0,
       'PAR ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PAR',
       'F',
       'A',
       'T',
       'Home Page',
       'Home Page do parceiro',
       '',
       'HOMPGE',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '99',
       80,
       2,
       'IMPRIM',
       'S',
       '',
       0,
       0,
       'PAR ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       '',
       'F',
       'Livre Customizao',
       'Livre para customizao',
       '',
       'IMPRIM',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '03',
       40,
       15,
       'INSEST',
       'A',
       '',
       0,
       4,
       'PAR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PAR',
       'F',
       'A',
       'T',
       '2 Documento',
       'Inscrio Estadual ou Identidade',
       '',
       'INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '04',
       40,
       2,
       'MAIATR',
       'S',
       '',
       0,
       0,
       'PAR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       '9',
       'T',
       'Maior atraso',
       'Maior atraso registrado',
       '',
       'MAIATR',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '01',
       53,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'PAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(PAR.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '99',
       53,
       2,
       'MES_DATA01',
       'A',
       '',
       0,
       0,
       'PAR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 1',
       '',
       'TO_CHAR(PAR.DATA01,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '99',
       63,
       2,
       'MES_DATA02',
       'A',
       '',
       0,
       0,
       'PAR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 2',
       '',
       'TO_CHAR(PAR.DATA02,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '99',
       73,
       2,
       'MES_DATA03',
       'A',
       '',
       0,
       0,
       'PAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 3',
       '',
       'TO_CHAR(PAR.DATA03,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '01',
       63,
       2,
       'MES_DATNAS',
       'A',
       '',
       0,
       0,
       'PAR ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ms de Nascto/Funda',
       'Ms de Data de nascimento ou fundao',
       '',
       'TO_CHAR(PAR.DATNAS,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '01',
       73,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       0,
       'PAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ms de Data Incluso',
       'Ms de Data de operao (cadastramento)',
       '',
       'TO_CHAR(PAR.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '01',
       113,
       2,
       'MES_NASCON',
       'A',
       '',
       0,
       0,
       'PAR ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ms de Nascto Cnj./',
       'Ms de Data de nascimento do cnjuge ou contato principal',
       '',
       'TO_CHAR(PAR.NASCON,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '04',
       83,
       2,
       'MES_ULTCOM',
       'A',
       '',
       0,
       0,
       'PAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ms de ltima Compra',
       'Ms de Data da ltima compra',
       '',
       'TO_CHAR(PAR.ULTCOM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '01',
       110,
       8,
       'NASCON',
       'D',
       '',
       0,
       0,
       'PAR ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'D',
       'T',
       'Nascto Cnj./Contato',
       'Data de nascimento do cnjuge ou contato principal',
       '',
       'NASCON',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '01',
       30,
       44,
       'NOMCLI',
       'A',
       '',
       0,
       0,
       'PAR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PAR',
       'F',
       'A',
       'T',
       'Nome do parceiro',
       'Nome do parceiro',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '01',
       140,
       20,
       'NOMTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Tratamento',
       'Nome de Tratamento(Apelido)',
       '',
       'NOMTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '03',
       20,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       3,
       'PAR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PAR',
       'F',
       'A',
       'T',
       'Documento',
       'Nmero do Documento: CGC ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '99',
       90,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'PAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PAR',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(PAR.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '04',
       70,
       2,
       'PORPAD',
       'S',
       'DCOB',
       0,
       16,
       'PAR ',
       70,
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       'PAR',
       'F',
       'A',
       'T',
       'Portador Padro',
       'Portador padro',
       'PAR.PORPAD=DCOB.CODTAB (+)',
       'PORPAD',
       'T' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '99',
       150,
       1,
       'PP_FLG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag Prospeco',
       'Flag de Prospeco sim ou no',
       '',
       'PP_FLG',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '01',
       120,
       2,
       'SEXCON',
       'S',
       '',
       0,
       0,
       'PAR ',
       120,
       30,
       '',
       '',
       'D',
       'PAR',
       'F',
       'A',
       'T',
       'Sexo do Cnjuge',
       'Sexo do cnjuge',
       '',
       'SEXCON',
       'T' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '99',
       110,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'PAR ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PAR',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN PAR.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '99',
       111,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN PAR.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '01',
       160,
       1,
       'SIMPLE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Optante pelo Simples',
       'Optante pelo Simples',
       '',
       'SIMPLE',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '03',
       170,
       9,
       'SUFRAM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'SUFRAMA',
       'SUFRAMA',
       '',
       'SUFRAM',
       '' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '04',
       20,
       4,
       'TOTATR',
       'G',
       '',
       0,
       0,
       'PAR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'N',
       'F',
       'Total Atrasos',
       'Total de atrasos na vida do parceiro',
       '',
       'TOTATR',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '04',
       30,
       4,
       'TOTPAR',
       'G',
       '',
       0,
       0,
       'PAR ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'N',
       'F',
       'Total de Parcelas',
       'Total de parcelas na vida do parceiro',
       '',
       'TOTPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '04',
       80,
       8,
       'ULTCOM',
       'D',
       '',
       0,
       0,
       'PAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'D',
       'T',
       'ltima Compra',
       'Data da ltima compra',
       '',
       'ULTCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '01',
       40,
       20,
       'ULTNOM',
       'A',
       '',
       0,
       0,
       'PAR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PAR',
       'F',
       'A',
       'T',
       'Sobrenome',
       'Sobrenome ou fantasia',
       '',
       'ULTNOM',
       'F' FROM DUAL
UNION ALL
SELECT 'PAR ',
       '04',
       10,
       8,
       'VALOR1',
       'F',
       '',
       2,
       0,
       'PAR ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'T',
       'N',
       'F',
       'Valor',
       'Armazena um valor qualquer',
       '',
       'VALOR1',
       'F' FROM DUAL
);

/*-- SEQ 8890 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'PAR ',
       'CODSEX',
       0,
       '-',
       'Nao conhecido',
       144,
       ' ' FROM DUAL
UNION ALL
SELECT 'PAR ',
       'CODSEX',
       1,
       '-',
       'Masculino',
       145,
       ' ' FROM DUAL
UNION ALL
SELECT 'PAR ',
       'CODSEX',
       2,
       '-',
       'Feminino',
       146,
       ' ' FROM DUAL
UNION ALL
SELECT 'PAR ',
       'ESTCIV',
       4,
       '-',
       'Divorciado',
       151,
       ' ' FROM DUAL
UNION ALL
SELECT 'PAR ',
       'ESTCIV',
       0,
       '-',
       'Indefinido',
       147,
       ' ' FROM DUAL
UNION ALL
SELECT 'PAR ',
       'ESTCIV',
       1,
       '-',
       'Solteiro',
       148,
       ' ' FROM DUAL
UNION ALL
SELECT 'PAR ',
       'ESTCIV',
       3,
       '-',
       'Vivo',
       150,
       ' ' FROM DUAL
UNION ALL
SELECT 'PAR ',
       'ESTCIV',
       5,
       '-',
       'Unio Estvel',
       152,
       ' ' FROM DUAL
UNION ALL
SELECT 'PAR ',
       'ESTCIV',
       6,
       '-',
       'Separado',
       153,
       ' ' FROM DUAL
UNION ALL
SELECT 'PAR ',
       'ESTCIV',
       2,
       '-',
       'Casado',
       149,
       ' ' FROM DUAL
UNION ALL
SELECT 'PAR ',
       'FLGTIP',
       2,
       '-',
       'Entidade',
       156,
       ' ' FROM DUAL
UNION ALL
SELECT 'PAR ',
       'FLGTIP',
       3,
       '-',
       'Especial',
       157,
       ' ' FROM DUAL
UNION ALL
SELECT 'PAR ',
       'FLGTIP',
       5,
       '-',
       'Filial',
       159,
       ' ' FROM DUAL
UNION ALL
SELECT 'PAR ',
       'FLGTIP',
       1,
       '-',
       'Jurdica',
       155,
       ' ' FROM DUAL
UNION ALL
SELECT 'PAR ',
       'FLGTIP',
       0,
       '-',
       'Fsica',
       154,
       ' ' FROM DUAL
UNION ALL
SELECT 'PAR ',
       'FLGTIP',
       4,
       '-',
       'M.E.',
       158,
       ' ' FROM DUAL
UNION ALL
SELECT 'PAR ',
       'SEXCON',
       0,
       '-',
       'Nao conhecido',
       160,
       ' ' FROM DUAL
UNION ALL
SELECT 'PAR ',
       'SEXCON',
       1,
       '-',
       'Masculino',
       161,
       ' ' FROM DUAL
UNION ALL
SELECT 'PAR ',
       'SEXCON',
       2,
       '-',
       'Feminino',
       162,
       ' ' FROM DUAL
);

/*-- SEQ 8891 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PCLI',
       TO_NUMBER(null),
       'PCLI',
       'Cliente Personal.',
       'TP_CLI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'PCLI.FILCLI,PCLI.CODCLI',
       '' FROM DUAL
);

/*-- SEQ 8892 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PCLI','--','' FROM DUAL
UNION ALL
SELECT 'PCLI','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PCLI','99','Outros' FROM DUAL
);

/*-- SEQ 8893 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 40020,
       'CLI ',
       'PCLI',
       '1 ',
       '01',
       '',
       '',
       'CLI.FILCLI = PCLI.FILCLI(+) and
CLI.CODCLI = PCLI.CODCLI(+)',
       '' FROM DUAL
);

/*-- SEQ 8894 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PCLI',
       '01',
       1,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'PCLI',
       '01',
       2,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '0',
       'F',
       'Filial Cliente',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
);

/*-- SEQ 8895 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PCR ',
       TO_NUMBER(null),
       'PCR ',
       'Conferncia  Compra',
       'TV_PCR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8896 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PCR ','--','' FROM DUAL
UNION ALL
SELECT 'PCR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PCR ','02','Datas' FROM DUAL
UNION ALL
SELECT 'PCR ','03','Valores' FROM DUAL
UNION ALL
SELECT 'PCR ','99','Outros' FROM DUAL
);

/*-- SEQ 8897 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5719,
       'GRA ',
       'PCR ',
       '1 ',
       'N ',
       '',
       '',
       'GRA.FILMAT = PCR.FILMAT and
GRA.CODMAT = PCR.CODMAT and
GRA.CODCOR = PCR.CODCOR and
GRA.CODTAM = PCR.CODTAM',
       '' FROM DUAL
UNION ALL
SELECT 5720,
       'VFOR',
       'PCR ',
       '1 ',
       'N ',
       '',
       '',
       'VFOR.FILPAR = PCR.FILFOR and VFOR.CODPAR = PCR.CODFOR and VFOR.TIPPAR = PCR.TIPPAR',
       '' FROM DUAL
);

/*-- SEQ 8898 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PCR ',
       '02',
       55,
       4,
       'ANO_DATENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data Entrada',
       'Ano de Data Entrada',
       '',
       'TO_CHAR(PCR.DATENT,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '02',
       75,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data Operao',
       'Ano de Data Operao',
       '',
       'TO_CHAR(PCR.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '02',
       65,
       4,
       'ANO_DATRCP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data Recepo',
       'Ano de Data Recepo',
       '',
       'TO_CHAR(PCR.DATRCP,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       30,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Cdigo da Diviso',
       'PCR.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       260,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       '9',
       'F',
       'Filial pedido',
       'Filial do item do pedido',
       'DFIL.CODFIL = PCR.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       210,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo do fornecedor',
       'Cdigo do fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       20,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Cdigo do produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       220,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Srie da Compra',
       'Srie da Compra',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       40,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Cdigo da sub-diviso',
       'PCR.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       140,
       3,
       'CODUSUCOM',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'N',
       'F',
       'Usurio Compra',
       'Usurio que cadastrou a compra',
       'PCR.FILUSUCOM=USU.FILUSU(+) and PCR.CODUSUCOM=USU.CODUSU(+)',
       'CODUSUCOM',
       'T' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       330,
       3,
       'CODUSUPED',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Usurio Pedido',
       'Usurio que cadastrou o pedido',
       'PCR.FILUSUPED = USU.FILUSU(+) and PCR.CODUSUPED = USU.CODUSU(+)',
       'CODUSUPED',
       'T' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       160,
       3,
       'CODUSURCP',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Usurio Recepo',
       'Usurio que cadastrou a recepo',
       'PCR.FILUSURCP = USU.FILUSU(+) and PCR.CODUSURCP=USU.CODUSU(+)',
       'CODUSURCP',
       'T' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '02',
       50,
       8,
       'DATENT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Entrada',
       'Data Entrada',
       '',
       'DATENT',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '02',
       70,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Operao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '02',
       60,
       8,
       'DATRCP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Recepo',
       'Data Recepo',
       '',
       'DATRCP',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       120,
       26,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Documento',
       'Documento (Fornecedor,Srie,Sub-Srie,Nota)',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       200,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial origem do fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       310,
       3,
       'FILFORPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial for. Pedido',
       'Filial do fornecedor pedido',
       '',
       'FILFORPED',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       10,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial do produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       130,
       3,
       'FILUSUCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial do usurio que cadastrou a compra',
       '',
       'FILUSUCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       320,
       3,
       'FILUSUPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial origem de quem cadastrou o pedido',
       '',
       'FILUSUPED',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       150,
       3,
       'FILUSURCP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial do usurio que cadastrou a recepo',
       '',
       'FILUSURCP',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       170,
       3,
       'ICOCODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial Origem Compra',
       'Cdigo da filial origem da compra',
       '',
       'ICOCODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '03',
       190,
       12,
       'ICONUMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Item compra',
       'Nmero do item de compra',
       '',
       'ICONUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       180,
       10,
       'ICOSEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Seq.Item Compra',
       'Sequenciador do item de compra',
       '',
       'ICOSEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '02',
       53,
       2,
       'MES_DATENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data Entrada',
       'Ms de Data Entrada',
       '',
       'TO_CHAR(PCR.DATENT,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '02',
       73,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data Operao',
       'Ms de Data Operao',
       '',
       'TO_CHAR(PCR.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '02',
       63,
       2,
       'MES_DATRCP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data Recepo',
       'Ms de Data Recepo',
       '',
       'TO_CHAR(PCR.DATRCP,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '03',
       280,
       12,
       'NUMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Nro Item Pedido',
       'Nro Item Pedido',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       240,
       9,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nro Nota',
       'Nro Nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       270,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nro Pedido',
       'Nro Pedido',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '99',
       360,
       1,
       'QQ_DIV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Divergncia?',
       'Aponta quando houver divergncia de qualquer tipo',
       '',
       'QQ_DIV',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '03',
       363,
       12,
       'QTDCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Quantidade Compra',
       'Quantidade (lanamento de compra)',
       '',
       'QTDCOM',
       '' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '99',
       340,
       1,
       'QTDDIV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Divergncia Qtde?',
       'Divergencia entre quantidades pedidas/faturadas/entregues',
       '',
       'QTDDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '99',
       345,
       1,
       'QTDDIV_CON',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Divergncia Qtd~Conv',
       'Divergencia entre quantidades pedidas/faturadas/entregues Convertida',
       '',
       'QTDCONVERTIDA(PCR.CODTAM,PCR.QTDDIV)',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '03',
       90,
       12,
       'QTDFAT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtdade Item',
       'Qtdade Item',
       '',
       'QTDFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '03',
       95,
       12,
       'QTDFAT_CON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtdade Item~Conv',
       'Qtdade Item~Conv',
       '',
       'QTDCONV(PCR.CODTAM,PCR.QTDFAT)',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '03',
       290,
       12,
       'QTDPED',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtdade pedido',
       'Qtdade pedido',
       '',
       'QTDPED',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '03',
       295,
       12,
       'QTDPED_CON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtdade pedido~Conv.',
       'Qtdade pedido~Conv.',
       '',
       'QTDCONVERTIDA(PCR.CODTAM,PCR.QTDPED)',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '03',
       250,
       12,
       'QTDREC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtdade Recepo',
       'Qtdade Recepo',
       '',
       'QTDREC',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '03',
       255,
       12,
       'QTDREC_CON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtdade Recepo Con.',
       'Qtdade Recepo Con.',
       '',
       'QTDREC(PCR.CODTAM,PCR.QTDREC)',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       100,
       3,
       'RCPCODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial Recepo',
       'Cdigo Filial da Recepo',
       '',
       'RCPCODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       110,
       10,
       'RCPSEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Seq. recepo',
       'Sequenciador da recepo',
       '',
       'RCPSEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       230,
       3,
       'SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Sub-Srie da compra',
       'Sub-Srie da compra',
       '',
       'SUBSER',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '01',
       13,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Parceiro',
       'Tipo de Parceiro',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '99',
       350,
       1,
       'VLRDIV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'T',
       '',
       'F',
       'Divergncia Valor?',
       'Divergncia entre valor do pedido x valor faturado',
       '',
       'VLRDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '03',
       80,
       12,
       'VLRFAT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Item',
       'Valor total do item',
       '',
       'VLRFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '03',
       300,
       12,
       'VLRPED',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor pedido',
       'Valor pedido',
       '',
       'VLRPED',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '03',
       361,
       12,
       'VOLCOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Nro Volumes Compra',
       'Nro Volumes Compra',
       '',
       'VOLCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'PCR ',
       '03',
       362,
       12,
       'VOLRCP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Nro Volumes da Venda',
       'Nro Volumes da Venda',
       '',
       'VOLRCP',
       'F' FROM DUAL
);

/*-- SEQ 8899 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'PCR ',
       'TIPPAR',
       0,
       'F',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PCR ',
       'TIPPAR',
       0,
       'T',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8900 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PCS ',
       TO_NUMBER(null),
       'PCS ',
       'Param Config Sistema',
       'TT_PCS',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'PCD.ID_PCS',
       '' FROM DUAL
);

/*-- SEQ 8901 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PCS ','--','' FROM DUAL
UNION ALL
SELECT 'PCS ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PCS ','02','Datas' FROM DUAL
UNION ALL
SELECT 'PCS ','99','Outros' FROM DUAL
);

/*-- SEQ 8902 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PCS ',
       '02',
       30,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'PCS ',
       '02',
       20,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'PCS ',
       '01',
       60,
       100,
       'DESPCS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio Parmetro',
       'Descrio Parmetro',
       '',
       'DESPCS',
       '' FROM DUAL
UNION ALL
SELECT 'PCS ',
       '01',
       10,
       14,
       'ID_PCS',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Chave ID',
       'Chave ID',
       '',
       'ID_PCS',
       '' FROM DUAL
UNION ALL
SELECT 'PCS ',
       '01',
       50,
       20,
       'NOMPCS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome Parmetro',
       'Nome Parmetro',
       '',
       'NOMPCS',
       '' FROM DUAL
UNION ALL
SELECT 'PCS ',
       '01',
       40,
       1,
       'PCSATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Ativo?',
       '',
       'PCSATI',
       '' FROM DUAL
UNION ALL
SELECT 'PCS ',
       '01',
       100,
       1,
       'PCSECF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'ECF?',
       'ECF?',
       '',
       'PCSECF',
       '' FROM DUAL
UNION ALL
SELECT 'PCS ',
       '01',
       90,
       1,
       'PCSFIL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Filial?',
       'Filial?',
       '',
       'PCSFIL',
       '' FROM DUAL
UNION ALL
SELECT 'PCS ',
       '01',
       80,
       1,
       'PCSGER',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Geral?',
       'Geral?',
       '',
       'PCSGER',
       '' FROM DUAL
UNION ALL
SELECT 'PCS ',
       '01',
       110,
       1,
       'PCSSER',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Srie?',
       'Srie?',
       '',
       'PCSSER',
       '' FROM DUAL
UNION ALL
SELECT 'PCS ',
       '01',
       70,
       1,
       'TIPPCS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo do Parmetro',
       'Tipo do Parmetro',
       '',
       'TIPPCS',
       'T' FROM DUAL
);

/*-- SEQ 8903 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'PCS ',
       'TIPPCS',
       0,
       'B',
       'Boolean',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PCS ',
       'TIPPCS',
       0,
       'D',
       'Data/Hora',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PCS ',
       'TIPPCS',
       0,
       'I',
       'Inteiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PCS ',
       'TIPPCS',
       0,
       'N',
       'Numrico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PCS ',
       'TIPPCS',
       0,
       'T',
       'Texto',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8904 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PCXE',
       TO_NUMBER(null),
       'PCXE',
       'Estados Signatrios',
       'TT_IPTXEST',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8905 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PCXE','--','' FROM DUAL
UNION ALL
SELECT 'PCXE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PCXE','99','Outros' FROM DUAL
);

/*-- SEQ 8906 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20258,
       'IPT ',
       'PCXE',
       '1',
       'N',
       '',
       '',
       'PCXE.CODFIL = IPT.CODFIL AND 
PCXE.SEQUEN = IPT.SEQUEN AND
PCXE.NUMITE = IPT.NUMITE',
       '',
       '' FROM DUAL
);

/*-- SEQ 8907 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PCXE',
       '--',
       10,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'PCXE',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PCXE',
       '--',
       30,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'PCXE',
       '--',
       40,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero do item',
       'Nmero do item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'PCXE',
       '--',
       50,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'PCXE',
       '--',
       60,
       2,
       'SIGEST',
       'A',
       'DEST',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEST.ESTADO',
       'V',
       '',
       '',
       'A',
       'F',
       'Estado Signatrio',
       'Estado Signatrio',
       'PCXE.SIGEST = DEST.ESTADO ',
       'SIGEST',
       'F' FROM DUAL
);

/*-- SEQ 8908 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PCXN',
       TO_NUMBER(null),
       'PCXN',
       'NCM Protocolo/Conve.',
       'TT_IPTXNCM',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8909 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PCXN','--','' FROM DUAL
UNION ALL
SELECT 'PCXN','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PCXN','99','Outros' FROM DUAL
);

/*-- SEQ 8910 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20249,
       'IPT ',
       'PCXN',
       '1',
       'N',
       '',
       '',
       'PCXN.CODFIL = IPT.CODFIL AND PCXN.SEQUEN = IPT.SEQUEN AND 
PCXN.NUMITE = IPT.NUMITE',
       '',
       '' FROM DUAL
);

/*-- SEQ 8911 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PCXN',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'PCXN',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PCXN',
       '--',
       30,
       8,
       'CODNCM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd. Nomenclatura',
       'Cdigo da Nomenclatura Comum do Mercosul',
       '',
       'CODNCM',
       'F' FROM DUAL
UNION ALL
SELECT 'PCXN',
       '--',
       40,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'PCXN',
       '--',
       50,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero do item',
       'Nmero do item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'PCXN',
       '--',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8912 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PCXP',
       TO_NUMBER(null),
       'PCXP',
       'Prod. do Protocolo',
       'TT_IPTXPRO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8913 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PCXP','--','' FROM DUAL
UNION ALL
SELECT 'PCXP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PCXP','99','Outros' FROM DUAL
);

/*-- SEQ 8914 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20247,
       'PRO ',
       'PCXP',
       '1',
       'N',
       '',
       '',
       'PCXP.FILMAT = PRO.FILMAT AND 
PCXP.CODMAT = PRO.CODMAT',
       '',
       '' FROM DUAL
);

/*-- SEQ 8915 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PCXP',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'PCXP',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PCXP',
       '--',
       30,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Produto',
       'Cdigo Produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'PCXP',
       '--',
       40,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'PCXP',
       '--',
       50,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Produto',
       'Filial Produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'PCXP',
       '--',
       60,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero do item',
       'Nmero do item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'PCXP',
       '--',
       70,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8916 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PDR ',
       0,
       'PDR ',
       'Pedidos de Reposio',
       'TT_PED',
       'T',
       'PDR.CODFOR = ''     0''',
       'TOTALL',
       'Pedidos a fornecedores',
       '{CODFIL;FILFOR;CODFOR;NUMPED};DATPED;FLGEST;ATU_EM',
       '',
       '',
       'PedidoCompra',
       'T',
       '',
       'PDR.CODFIL,PDR.NUMPED',
       '' FROM DUAL
);

/*-- SEQ 8917 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PDR ','--','' FROM DUAL
UNION ALL
SELECT 'PDR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PDR ','02','Outros' FROM DUAL
UNION ALL
SELECT 'PDR ','03','Datas' FROM DUAL
UNION ALL
SELECT 'PDR ','04','Valores' FROM DUAL
);

/*-- SEQ 8918 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21773,
       'PVD ',
       'PDR ',
       '1',
       'N',
       '',
       '',
       'PVD.FILPAR = PDR.FILFOR and
PVD.CODPAR = PDR.CODFOR and
PVD.TIPPAR = PDR.TIPFOR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21774,
       'REL ',
       'PDR ',
       '1',
       'N',
       '',
       '',
       'REL.FILPAR = PDR.FILFOR AND
REL.CODPAR = PDR.CODFOR AND
REL.TIPPAR = PDR.TIPFOR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21775,
       'USU ',
       'PDR ',
       '1',
       'N',
       '',
       '',
       'USU.FILUSU = PDR.FILUSU AND
USU.CODUSU = PDR.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21776,
       'IPE ',
       'PDR ',
       'N',
       '1',
       '',
       '',
       'IPE.CODFIL = PDR.CODFIL and
IPE.NUMPED = PDR.NUMPED',
       'IPE.VLRITE / PDR.VLRTOT',
       '' FROM DUAL
);

/*-- SEQ 8919 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PDR ',
       '03',
       280,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'PED ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizao',
       '',
       'TO_CHAR(PDR.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '03',
       230,
       4,
       'ANO_DATENT',
       'A',
       '',
       0,
       0,
       'PED ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       '',
       'N',
       'T',
       'Ano de Entrega p/',
       'Ano de Data prevista para a entrega',
       '',
       'TO_CHAR(PDR.DATENT,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '03',
       250,
       4,
       'ANO_DATPED',
       'A',
       '',
       0,
       0,
       'PED ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       '',
       'N',
       'T',
       'Ano de Data',
       'Ano de Data do pedido',
       '',
       'TO_CHAR(PDR.DATPED,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '03',
       260,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'PED ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '02',
       90,
       3,
       'CODAPR',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Aprovador',
       'Aprovador',
       'PDR.FILAPR = USU.FILUSU(+)  and PDR.CODAPR = USU.CODUSU(+)',
       'CODAPR',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '--',
       330,
       1,
       'CODCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Codcon',
       '',
       '',
       'CODCON',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       0,
       'PED ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'PED',
       'F',
       'A',
       'T',
       'Filial',
       'Cdigo da Filial',
       'PDR.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '01',
       30,
       6,
       'CODFOR',
       'A',
       'COM ',
       0,
       0,
       'PED ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'F',
       '9',
       'F',
       'Cdigo do Fornecedor',
       'Cdigo do fornecedor',
       'COM.FILFOR = PDR.CODFOR',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '02',
       130,
       2,
       'CODMOE',
       'S',
       'DMOE',
       0,
       0,
       'PED ',
       100,
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       'PED',
       'F',
       'A',
       'T',
       'Moeda',
       'Cdigo da moeda utilizada no pedido',
       'PDR.CODMOE=DMOE.CODTAB (+)',
       'CODMOE',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '02',
       110,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       0,
       'PED ',
       80,
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       'PED',
       'F',
       'A',
       'T',
       'Usurio',
       'Cdigo do usurio que efetuou o pedido',
       'PDR.FILUSU = USU.FILUSU(+)  AND PDR.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '02',
       160,
       10,
       'CONPGT',
       'A',
       '',
       0,
       0,
       'PED ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PED',
       'F',
       'A',
       'T',
       'Cond. Pagto.',
       'Condio de pagamento',
       '',
       'CONPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '--',
       340,
       20,
       'CONVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo da Promoo',
       'Cdigo da tabela de promoes do fornecedor de pedido eletrnico',
       '',
       'CONVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '03',
       210,
       8,
       'DATENT',
       'D',
       '',
       0,
       0,
       'PED ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'F',
       'D',
       'T',
       'Entrega p/',
       'Data prevista para a entrega',
       '',
       'DATENT',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '--',
       350,
       7,
       'DATENV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data de envio',
       'Data do envio do pedido eletrnico',
       '',
       'DATENV',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '03',
       200,
       8,
       'DATPED',
       'D',
       '',
       0,
       0,
       'PED ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'F',
       'D',
       'T',
       'Data',
       'Data do pedido',
       '',
       'DATPED',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '04',
       310,
       8,
       'DESCON',
       'F',
       '',
       2,
       0,
       'PED ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'T',
       '9',
       'T',
       'Desconto/Acrscimos',
       'Desconto/Acrscimo concedido no pedido',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '02',
       170,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exportar?',
       'Exportar',
       '',
       'EXPORT',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '02',
       80,
       3,
       'FILAPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cd.Filial Aprovador',
       'Cdigo da filial do aprovador',
       '',
       'FILAPR',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '--',
       360,
       3,
       'FILEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial do endereo',
       'Filial do endereo',
       '',
       'FILEND',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '01',
       20,
       3,
       'FILFOR',
       'A',
       '',
       0,
       0,
       'PED ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'F',
       'N',
       'F',
       'Filial do fornecedor',
       'Filial do fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '02',
       120,
       3,
       'FILUSU',
       'A',
       '',
       0,
       0,
       'PED ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'F',
       'N',
       'F',
       'Filial do usurio',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '02',
       70,
       1,
       'FLGEST',
       'A',
       '',
       0,
       0,
       'PED ',
       60,
       30,
       '',
       '',
       'D',
       'PED',
       'F',
       'A',
       'T',
       'Situao',
       'Situao (Em aberto/Entregue/Cancelado)',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '03',
       270,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'PED ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizao',
       '',
       'TO_CHAR(PDR.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '03',
       220,
       2,
       'MES_DATENT',
       'A',
       '',
       0,
       0,
       'PED ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       '',
       'N',
       'T',
       'Ms de Entrega p/',
       'Ms de Data prevista para a entrega',
       '',
       'TO_CHAR(PDR.DATENT,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '03',
       240,
       2,
       'MES_DATPED',
       'A',
       '',
       0,
       0,
       'PED ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       '',
       'N',
       'T',
       'Ms de Data',
       'Ms de Data do pedido',
       '',
       'TO_CHAR(PDR.DATPED,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '--',
       370,
       20,
       'NOMARQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Arquivo',
       'Nome do arquivo que o pedido ser exportado',
       '',
       'NOMARQ',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '--',
       380,
       4,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero do endereo',
       'Nmero do endereo',
       '',
       'NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '01',
       50,
       8,
       'NUMPED',
       'A',
       '',
       0,
       0,
       'PED ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'F',
       '9',
       'T',
       'Nmero do Pedido',
       'Nmero do pedido',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '02',
       140,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'PED ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PED',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(PDR.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '02',
       100,
       8,
       'OUTTAX',
       'F',
       '',
       2,
       0,
       'PED ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'T',
       '9',
       'T',
       'Outras Taxas',
       'Outras taxas no pedido',
       '',
       'OUTTAX',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '--',
       390,
       20,
       'PEDEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Pedido Externo',
       'Cdigo externo para pedido eletrnico',
       '',
       'PEDEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '02',
       180,
       15,
       'PEDFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Pedido Fornecedor',
       'Pedido Fornecedor',
       '',
       'PEDFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '--',
       400,
       4,
       'PROMOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Promoo',
       '',
       '',
       'PROMOC',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '04',
       290,
       8,
       'QTDTOT',
       'F',
       '',
       2,
       0,
       'PED ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'T',
       '9',
       'T',
       'Qtd.Total',
       'Quantidade total do pedido',
       '',
       'QTDTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '02',
       150,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'PED ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PED',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN PDR.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '02',
       151,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN PDR.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '01',
       40,
       1,
       'TIPFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'PED ',
       10,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Cliente',
       'Tipo de Cliente',
       '',
       'TIPFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '02',
       190,
       1,
       'VENENT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Entrega?',
       'Entrega',
       '',
       'VENENT',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '04',
       200,
       14,
       'VLRBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Bnus',
       'Valor Bnus',
       '',
       'VLRBON',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '04',
       320,
       8,
       'VLRLIQ',
       'F',
       '',
       2,
       0,
       'PED ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'T',
       '9',
       'T',
       'Valor Final',
       'Valor lquido do pedido',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'PDR ',
       '04',
       300,
       8,
       'VLRTOT',
       'F',
       '',
       2,
       0,
       'PED ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'T',
       '9',
       'T',
       'Vlr. Total do Pedido',
       'Valor total do pedido',
       '',
       'VLRTOT',
       'F' FROM DUAL
);

/*-- SEQ 8920 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'PDR ',
       'CODCON',
       0,
       'N',
       'Negociado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PDR ',
       'CODCON',
       0,
       'P',
       'A Prazo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PDR ',
       'CODCON',
       0,
       'V',
       'A Vista',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PDR ',
       'FLGEST',
       0,
       '0',
       'Reprovado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PDR ',
       'FLGEST',
       0,
       '2',
       'Autorizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PDR ',
       'FLGEST',
       0,
       'A',
       'Em aberto',
       94,
       ' ' FROM DUAL
UNION ALL
SELECT 'PDR ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       96,
       ' ' FROM DUAL
UNION ALL
SELECT 'PDR ',
       'FLGEST',
       0,
       'E',
       'Entregue',
       95,
       ' ' FROM DUAL
UNION ALL
SELECT 'PDR ',
       'TIPFOR',
       0,
       'F',
       'Fornecedor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PDR ',
       'TIPFOR',
       0,
       'T',
       'Transportadora',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8921 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PEC ',
       0,
       'PEC ',
       'Peas de Oramento',
       'TT_IOR',
       'T',
       '',
       'TOTALL',
       'Itens do Oramento/Pedido Venda',
       '{CODFIL;TIPPED;NUMPED;NUMITE};FILMAT;CODMAT;CODCOR;CODTAM;FLGEST;ATU_EM',
       '',
       '',
       'PedidoVendaItem',
       'T',
       '',
       'PEC.CODFIL,PEC.TIPPED,PEC.NUMPED,PEC.NUMITE
ORC.ID,PEC.NUMITE',
       '' FROM DUAL
);

/*-- SEQ 8922 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PEC ','--','' FROM DUAL
UNION ALL
SELECT 'PEC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PEC ','02','Qtdes e Valores' FROM DUAL
UNION ALL
SELECT 'PEC ','03','Outros' FROM DUAL
UNION ALL
SELECT 'PEC ','04','Photo' FROM DUAL
UNION ALL
SELECT 'PEC ','05','Equipamento' FROM DUAL
UNION ALL
SELECT 'PEC ','06','Recursividade' FROM DUAL
UNION ALL
SELECT 'PEC ','07','Lista Presente' FROM DUAL
);

/*-- SEQ 8923 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 24610,
       'CPM ',
       'PEC ',
       '01',
       '0N',
       '',
       '',
       'PEC.FILCPM = CPM.FILCPM(+) AND
PEC.SEQCPM = CPM.SEQUEN(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 24191,
       'EQP ',
       'PEC ',
       '1',
       'N',
       '',
       '',
       'EQP.FILEQP = PEC.FILEQP AND
EQP.SEQEQP = PEC.SEQEQP',
       '',
       '' FROM DUAL
UNION ALL
SELECT 24192,
       'DOU ',
       'PEC ',
       '1',
       'N',
       '',
       '',
       'DOU.CODCRM = PEC.CODCRM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 24193,
       'IVE ',
       'PEC ',
       '1',
       'N',
       '',
       '',
       'IVE.SEQUEN = PEC.SEQIVE AND
IVE.CODFIL = PEC.FILIVE AND
IVE.NUMITE = PEC.NUMIVE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 24194,
       'REL ',
       'PEC ',
       '1',
       'N',
       '',
       '',
       'REL.FILPAR = PEC.FILPAR AND
REL.CODPAR = PEC.CODPAR AND
REL.TIPPAR = PEC.TIPPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 24195,
       'USU ',
       'PEC ',
       '1',
       'N',
       '',
       '',
       'USU.FILUSU = PEC.FILUSU AND
USU.CODUSU = PEC.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 8924 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PEC ',
       '03',
       410,
       2,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'IOR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(PEC.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '03',
       440,
       2,
       'ANO_ENTREG',
       'A',
       '',
       0,
       0,
       'IOR ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       '',
       'N',
       'T',
       'Ano~Entrega',
       'Ano de Data e hora da entrega',
       '',
       'TO_CHAR(PEC.ENTREG,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       110,
       10,
       'APLICA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtd. a aplicar',
       'Quantidade a aplicar (ex.10 gotas)',
       '',
       'APLICA',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '03',
       390,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'IOR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       530,
       5,
       'CODAMB',
       'S',
       'DAMB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DAMB.DESAMB',
       'V',
       '',
       '',
       'A',
       'F',
       'Ambiente',
       'Ambiente',
       'DAMB.CODTAB = PEC.CODAMB(+)',
       'CODAMB',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       240,
       2,
       'CODCOR',
       'S',
       'DIV ',
       0,
       0,
       'IOR ',
       70,
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       'IOR',
       'F',
       'A',
       'T',
       'Diviso',
       'Diviso do Produto',
       'PEC.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       120,
       6,
       'CODCRM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo CRM',
       'Cdigo CRM',
       '',
       'CODCRM',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       180,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       0,
       'IOR ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'IOR',
       'F',
       'N',
       'F',
       'Filial',
       'Cdigo da filial',
       'PEC.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       270,
       6,
       'CODFOR',
       'A',
       '',
       0,
       0,
       'IOR ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'F',
       '9',
       'F',
       'Cdigo do Fornecedor',
       'Cdigo do Fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       230,
       5,
       'CODMAT',
       'A',
       '',
       0,
       0,
       'IOR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'F',
       '9',
       'F',
       '',
       'Cdigo do Produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       170,
       5,
       'CODMUL',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       'F',
       'Sub-Estoque',
       'Nome do Sub-Estoque',
       'DMUL.CODTAB = PEC.CODMUL(+)',
       'CODMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       50,
       6,
       'CODPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo do Tcnico',
       'Cdigo do Tcnico',
       '',
       'CODPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       250,
       2,
       'CODTAM',
       'S',
       'SUB ',
       0,
       0,
       'IOR ',
       80,
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       'IOR',
       'F',
       'A',
       'T',
       'Sub-Diviso ',
       'Sub-Diviso do produto',
       'PEC.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       80,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do Usurio',
       'PEC.FILUSU = USU.FILUSU(+)  and PEC.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       130,
       3,
       'DIADUR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Durao',
       'Durao',
       '',
       'DIADUR',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '03',
       420,
       8,
       'ENTREG',
       '@',
       '',
       0,
       0,
       'IOR ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'F',
       '@',
       'T',
       'Data~Entrega',
       'Data e hora da entrega',
       '',
       'ENTREG',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       630,
       3,
       'FILCPM',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Promoo',
       'Filial Promoo',
       'DFIL.CODFIL = PEC.FILCPM(+)',
       'FILCPM',
       'T' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '05',
       550,
       3,
       'FILEQP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Filial Equipamento',
       'Filial do Equipamento',
       '',
       'FILEQP',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       260,
       3,
       'FILFOR',
       'A',
       '',
       0,
       0,
       'IOR ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'F',
       'N',
       'F',
       '',
       'Filial do fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       90,
       3,
       'FILIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial Item de Venda',
       '',
       'FILIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       220,
       3,
       'FILMAT',
       'A',
       '',
       0,
       0,
       'IOR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'F',
       'N',
       'F',
       '',
       'Filial do Produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '06',
       570,
       3,
       'FILORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Filial da Pea',
       'Filial da Pea',
       '',
       'FILORI',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       40,
       3,
       'FILPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Tecnico',
       '',
       'FILPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       10,
       3,
       'FILRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial da Reserva',
       '',
       'FILRES',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       70,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '03',
       380,
       1,
       'FLGEST',
       'A',
       '',
       0,
       0,
       'IOR ',
       10,
       30,
       '',
       '',
       'D',
       'IOR',
       'F',
       'A',
       'T',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '06',
       600,
       5,
       'ITEORI',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Item da Pea',
       'Item da Pea',
       '',
       'ITEORI',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '03',
       400,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'IOR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(PEC.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '03',
       430,
       2,
       'MES_ENTREG',
       'A',
       '',
       0,
       0,
       'IOR ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       '',
       'N',
       'T',
       'Ms de Entregue em',
       'Ms de Data e hora da entrega',
       '',
       'TO_CHAR(PEC.ENTREG,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '03',
       470,
       1,
       'MONTAR',
       'A',
       '',
       0,
       0,
       'IOR ',
       60,
       30,
       '',
       '',
       'D',
       'IOR',
       'F',
       'A',
       'T',
       'Montargem',
       'Montagem',
       '',
       'MONTAR',
       'T' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '03',
       610,
       9,
       'NUMCRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       '',
       'Contador RE',
       'Contador de Requisio Externa',
       '',
       'NUMCRE',
       '' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '03',
       460,
       20,
       'NUMFOR',
       'A',
       '',
       0,
       0,
       'IOR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'F',
       '9',
       'T',
       'Nmero Externo',
       'Nmero Externo',
       '',
       'NUMFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       210,
       2,
       'NUMITE',
       'S',
       '',
       0,
       0,
       'IOR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'F',
       '9',
       'T',
       'Item',
       'Nmero do item do pedido',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       30,
       5,
       'NUMIVE',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Item de Venda',
       'Item de Venda',
       '',
       'NUMIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '06',
       590,
       8,
       'NUMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Nmero da Pea',
       'Nmero da Pea',
       '',
       'NUMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       200,
       8,
       'NUMPED',
       'A',
       '',
       0,
       0,
       'IOR ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'F',
       '9',
       'F',
       'Nmero Pedido/OS',
       'Nmero Pedido/OS',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '03',
       555,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(PEC.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       140,
       3,
       'ORDITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ordem de Itens',
       'Ordem de Itens',
       '',
       'ORDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '03',
       620,
       1,
       'ORICRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Origem RE',
       'Origem da Requisio Externa',
       '',
       'ORICRE',
       'T' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       150,
       1,
       'PERIOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Perodo da aplicao',
       'Perodo da aplicao',
       '',
       'PERIOD',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '04',
       500,
       2,
       'PHOISO',
       'S',
       'DISO',
       0,
       0,
       'IOR ',
       30,
       TO_NUMBER(null),
       '',
       'DISO.PHOISO',
       'V',
       'IOR',
       'F',
       'A',
       'T',
       'ISO',
       'ISO do filme',
       'PEC.PHOISO=DISO.CODTAB (+)',
       'PHOISO',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '04',
       480,
       2,
       'PHOMAR',
       'S',
       'DMAR',
       0,
       0,
       'IOR ',
       10,
       TO_NUMBER(null),
       '',
       'DMAR.PHOMAR',
       'V',
       'IOR',
       'F',
       'A',
       'T',
       'Marca do Filme',
       'Marca do Filme',
       'PEC.PHOMAR=DMAR.CODTAB (+)',
       'PHOMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '04',
       510,
       2,
       'PHOOUT',
       'S',
       'DPHO',
       0,
       0,
       'IOR ',
       40,
       TO_NUMBER(null),
       '',
       'DPHO.PHOOUT',
       'V',
       'IOR',
       'F',
       'A',
       'T',
       'Outros',
       'Outra classificao do filme',
       'PEC.PHOOUT=DPHO.CODTAB (+)',
       'PHOOUT',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '04',
       490,
       2,
       'PHOTIP',
       'S',
       'DTIP',
       0,
       0,
       'IOR ',
       20,
       TO_NUMBER(null),
       '',
       'DTIP.PHOTIP',
       'V',
       'IOR',
       'F',
       'A',
       'T',
       'Tipo de Filme',
       'Tipo de Filme',
       'PEC.PHOTIP=DTIP.CODTAB (+)',
       'PHOTIP',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '02',
       340,
       8,
       'PREUNI',
       'F',
       '',
       2,
       0,
       'IOR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'T',
       '9',
       'T',
       'Preo Unitrio',
       'Preo Unitrio',
       '',
       'PREUNI',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '03',
       520,
       1,
       'PROMOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Promoo',
       'Promoo',
       '',
       'PROMOC',
       'T' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '02',
       320,
       8,
       'QTDENT',
       'F',
       '',
       2,
       0,
       'IOR ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'T',
       '9',
       'T',
       'Qtd. Entregue',
       'Quantidade entregue',
       '',
       'QTDENT',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '02',
       330,
       8,
       'QTDENT_CON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtd. Entregue~Conv',
       'Quantidade entregue Convertida',
       '',
       'QTDCONVERTIDA(PEC.CODTAM,PEC.QTDENT)',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '02',
       290,
       8,
       'QTDITE',
       'F',
       '',
       2,
       0,
       'IOR ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'T',
       '9',
       'T',
       'Qtd. Pedida/OS',
       'Quantidade de determinado item',
       '',
       'QTDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '02',
       300,
       8,
       'QTDITE_CON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtd. Pedida/OS~Conv',
       'Quantidade de determinado item Convertida',
       '',
       'QTDCONVERTIDA(PEC.CODTAM,PEC.QTDITE)',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       160,
       2,
       'REPETE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'N vezes a aplicar',
       'Nmero de vezes a aplicar (ex. 2 vezes ao dia)',
       '',
       'REPETE',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '03',
       450,
       2,
       'RESULT',
       'S',
       'DROS',
       0,
       0,
       'IOR ',
       40,
       TO_NUMBER(null),
       '',
       'DROS.RESULT',
       'V',
       'IOR',
       'F',
       'A',
       'T',
       'Resultado',
       'Resultado',
       'PEC.RESULT=DROS.CODTAB (+)',
       'RESULT',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       640,
       10,
       'SEQCPM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       '',
       'Sequncia Promoo',
       'Sequncia Promoo',
       '',
       'SEQCPM',
       '' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '05',
       560,
       10,
       'SEQEQP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq. Equipamento',
       'Sequncia do Equipamento',
       '',
       'SEQEQP',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       20,
       10,
       'SEQIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       'F',
       '9',
       'F',
       '',
       'Numero Item de Venda',
       '',
       'SEQIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '03',
       550,
       5,
       'SERITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Rel. Serv./Produtos',
       'Permite auto relacionamento entre os servios e os produtos',
       '',
       'SERITE',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '06',
       580,
       1,
       'TIPORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Tipo da Pea',
       'Tipo da Pea',
       '',
       'TIPORI',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       60,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Tcnico',
       'Tipo de Tcnico',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       190,
       1,
       'TIPPED',
       'A',
       '',
       0,
       0,
       'IOR ',
       20,
       30,
       '',
       '',
       'D',
       'IOR',
       'F',
       'A',
       'F',
       'Tipo Pedido/OS',
       'Tipo Pedido/OS',
       '',
       'TIPPED',
       'T' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '01',
       280,
       8,
       'VENCIMENTO',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Medicamento Acabando',
       'Medicamento Acabando',
       '',
       '(SELECT ADD_DAY(DATENT,COALESCE(PEC.DIADUR,0)) FROM TT_ORC WHERE CODFIL = PEC.CODFIL AND TIPPED = PEC.TIPPED AND NUMPED = PEC.NUMPED)',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '02',
       360,
       8,
       'VLRCUS',
       'F',
       '',
       2,
       0,
       'IOR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'T',
       '9',
       'T',
       'Vlr. Custo',
       'Valor de custo de servios terceirizados',
       '',
       'VLRCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '02',
       350,
       8,
       'VLRENT',
       'F',
       '',
       2,
       0,
       'IOR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'T',
       '9',
       'T',
       'Vlr. Entregue',
       'Valor entregue',
       '',
       'VLRENT',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '02',
       310,
       8,
       'VLRITE',
       'F',
       '',
       2,
       0,
       'IOR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'T',
       '9',
       'T',
       'Vlr. Pedido/OS',
       'Valor deste item',
       '',
       'VLRITE',
       'F' FROM DUAL
UNION ALL
SELECT 'PEC ',
       '02',
       370,
       8,
       'VLRPGT',
       'F',
       '',
       2,
       0,
       'IOR ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'IOR',
       'T',
       '9',
       'T',
       'Vlr. Pago',
       'Valor pago ao fornecedor de servio terceirizado',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 8925 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'PEC ',
       'FLGEST',
       0,
       'A',
       'Em aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PEC ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PEC ',
       'FLGEST',
       0,
       'E',
       'Faturado/Entregue',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PEC ',
       'FLGEST',
       0,
       'O',
       'Concludo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PEC ',
       'FLGEST',
       0,
       'R',
       'Reservado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PEC ',
       'FLGEST',
       0,
       'T',
       'Em andamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PEC ',
       'MONTAR',
       0,
       'F',
       'Sem Montagem',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PEC ',
       'MONTAR',
       0,
       'I',
       'Montagem Interna ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PEC ',
       'MONTAR',
       0,
       'T',
       'Montagem na entrega',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PEC ',
       'ORICRE',
       0,
       'I',
       'Internet',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PEC ',
       'ORICRE',
       0,
       'M',
       'Mobile',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PEC ',
       'ORICRE',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PEC ',
       'PROMOC',
       0,
       'E',
       'Promocional no Plano',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PEC ',
       'PROMOC',
       0,
       'N',
       'No Promocional no Plano',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PEC ',
       'PROMOC',
       0,
       'Q',
       'Qualquer Plano',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PEC ',
       'TIPPAR',
       0,
       'F',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PEC ',
       'TIPPAR',
       0,
       'T',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PEC ',
       'TIPPED',
       0,
       'O',
       'DAV',
       57,
       ' ' FROM DUAL
UNION ALL
SELECT 'PEC ',
       'TIPPED',
       0,
       'P',
       'Pr-Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PEC ',
       'TIPPED',
       0,
       'S',
       'DAV-OS',
       58,
       ' ' FROM DUAL
);

/*-- SEQ 8926 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PED ',
       0,
       'PED ',
       'Pedidos de Compra',
       'TT_PED',
       'T',
       '',
       'TOTALL',
       'Pedidos a fornecedores',
       '{CODFIL;FILFOR;CODFOR;NUMPED};DATPED;FLGEST;ATU_EM',
       '',
       '',
       'PedidoCompra',
       'T',
       '',
       'PED.CODFIL,PED.NUMPED',
       '' FROM DUAL
);

/*-- SEQ 8927 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PED ','--','' FROM DUAL
UNION ALL
SELECT 'PED ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PED ','02','Outros' FROM DUAL
UNION ALL
SELECT 'PED ','03','Datas' FROM DUAL
UNION ALL
SELECT 'PED ','04','Valores' FROM DUAL
);

/*-- SEQ 8928 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 31231,
       'PVD ',
       'PED ',
       '1',
       'N',
       '',
       '',
       'PVD.FILPAR = PED.FILFOR and
PVD.CODPAR = PED.CODFOR and
PVD.TIPPAR = PED.TIPFOR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31232,
       'REL ',
       'PED ',
       '1',
       'N',
       '',
       '',
       'REL.FILPAR = PED.FILFOR AND
REL.CODPAR = PED.CODFOR AND
REL.TIPPAR = PED.TIPFOR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31233,
       'USU ',
       'PED ',
       '1',
       'N',
       '',
       '',
       'USU.FILUSU = PED.FILUSU AND
USU.CODUSU = PED.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 31234,
       'IPE ',
       'PED ',
       'N',
       '1',
       '',
       '',
       'IPE.CODFIL = PED.CODFIL and
IPE.NUMPED = PED.NUMPED',
       'IPE.VLRITE / PED.VLRTOT',
       '' FROM DUAL
);

/*-- SEQ 8929 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PED ',
       '03',
       280,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'PED ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizao',
       '',
       'TO_CHAR(PED.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '03',
       230,
       4,
       'ANO_DATENT',
       'A',
       '',
       0,
       0,
       'PED ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       '',
       'N',
       'T',
       'Ano de Entrega p/',
       'Ano de Data prevista para a entrega',
       '',
       'TO_CHAR(PED.DATENT,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '03',
       250,
       4,
       'ANO_DATPED',
       'A',
       '',
       0,
       0,
       'PED ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       '',
       'N',
       'T',
       'Ano de Data',
       'Ano de Data do pedido',
       '',
       'TO_CHAR(PED.DATPED,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '02',
       151,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN PED.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'PED ',
       '--',
       420,
       1,
       'ATUPED',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Atu dados form preo',
       'Atualiza dados para a formao de preo?',
       '',
       'ATUPED',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '03',
       260,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'PED ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '02',
       90,
       3,
       'CODAPR',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Aprovador',
       'Aprovador',
       'PED.FILAPR = USU.FILUSU(+)  and PED.CODAPR = USU.CODUSU(+)',
       'CODAPR',
       'T' FROM DUAL
UNION ALL
SELECT 'PED ',
       '--',
       330,
       1,
       'CODCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Codcon',
       '',
       '',
       'CODCON',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '--',
       430,
       5,
       'CODDOP',
       'S',
       'DDOP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDOP.DESDOP',
       'V',
       '',
       '',
       'N',
       'F',
       'Tipo Documento',
       'Tipo Documento ',
       'DDOP.CODTAB = PED.CODDOP(+)',
       'CODDOP',
       'T' FROM DUAL
UNION ALL
SELECT 'PED ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       0,
       'PED ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'PED',
       'F',
       'A',
       'T',
       'Filial',
       'Cdigo da Filial',
       'PED.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'PED ',
       '01',
       30,
       6,
       'CODFOR',
       'A',
       'COM ',
       0,
       0,
       'PED ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'F',
       'A',
       'F',
       'Cdigo do Fornecedor',
       'Cdigo do fornecedor',
       'COM.FILFOR = PED.CODFOR',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '02',
       130,
       2,
       'CODMOE',
       'S',
       'DMOE',
       0,
       0,
       'PED ',
       100,
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       'PED',
       'F',
       'A',
       'T',
       'Moeda',
       'Cdigo da moeda utilizada no pedido',
       'PED.CODMOE=DMOE.CODTAB (+)',
       'CODMOE',
       'T' FROM DUAL
UNION ALL
SELECT 'PED ',
       '02',
       110,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       0,
       'PED ',
       80,
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       'PED',
       'F',
       'A',
       'T',
       'Usurio',
       'Cdigo do usurio que efetuou o pedido',
       'PED.FILUSU = USU.FILUSU(+)  AND PED.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'PED ',
       '02',
       160,
       10,
       'CONPGT',
       'A',
       '',
       0,
       0,
       'PED ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PED',
       'F',
       'A',
       'T',
       'Cond. Pagto.',
       'Condio de pagamento',
       '',
       'CONPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '--',
       340,
       20,
       'CONVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo da Promoo',
       'Cdigo da tabela de promoes do fornecedor de pedido eletrnico',
       '',
       'CONVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '03',
       210,
       8,
       'DATENT',
       'D',
       '',
       0,
       0,
       'PED ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'F',
       'D',
       'T',
       'Entrega p/',
       'Data prevista para a entrega',
       '',
       'DATENT',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '--',
       350,
       7,
       'DATENV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data de envio',
       'Data do envio do pedido eletrnico',
       '',
       'DATENV',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '03',
       200,
       8,
       'DATPED',
       'D',
       '',
       0,
       0,
       'PED ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'F',
       'D',
       'T',
       'Data',
       'Data do pedido',
       '',
       'DATPED',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '04',
       310,
       8,
       'DESCON',
       'F',
       '',
       2,
       0,
       'PED ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'T',
       '9',
       'T',
       'Desconto/Acrscimos',
       'Desconto/Acrscimo concedido no pedido',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '04',
       440,
       5,
       'DESESP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Des/Acr~Espec.',
       '% Desconto/Acrscimo Financeiro Especial',
       '',
       'DESESP',
       '' FROM DUAL
UNION ALL
SELECT 'PED ',
       '02',
       170,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exportar?',
       'Exportar',
       '',
       'EXPORT',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '02',
       80,
       3,
       'FILAPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cd.Filial Aprovador',
       'Cdigo da filial do aprovador',
       '',
       'FILAPR',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '--',
       360,
       3,
       'FILEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial do endereo',
       'Filial do endereo',
       '',
       'FILEND',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '01',
       20,
       3,
       'FILFOR',
       'A',
       '',
       0,
       0,
       'PED ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'F',
       'N',
       'F',
       'Filial do fornecedor',
       'Filial do fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '02',
       120,
       3,
       'FILUSU',
       'A',
       '',
       0,
       0,
       'PED ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'F',
       'N',
       'F',
       'Filial do usurio',
       'Filial do usurio',
       '',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'PED ',
       '02',
       70,
       1,
       'FLGEST',
       'A',
       '',
       0,
       0,
       'PED ',
       60,
       30,
       '',
       '',
       'D',
       'PED',
       'F',
       'A',
       'T',
       'Situao',
       'Situao (Em aberto/Entregue/Cancelado)',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'PED ',
       '--',
       460,
       1,
       'FREORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Origem do Frete',
       'Origem do Clculo do Frete',
       '',
       'FREORI',
       'T' FROM DUAL
UNION ALL
SELECT 'PED ',
       '03',
       270,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'PED ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizao',
       '',
       'TO_CHAR(PED.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '03',
       220,
       2,
       'MES_DATENT',
       'A',
       '',
       0,
       0,
       'PED ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       '',
       'N',
       'T',
       'Ms de Entrega p/',
       'Ms de Data prevista para a entrega',
       '',
       'TO_CHAR(PED.DATENT,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '03',
       240,
       2,
       'MES_DATPED',
       'A',
       '',
       0,
       0,
       'PED ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       '',
       'N',
       'T',
       'Ms de Data',
       'Ms de Data do pedido',
       '',
       'TO_CHAR(PED.DATPED,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '--',
       370,
       20,
       'NOMARQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Arquivo',
       'Nome do arquivo que o pedido ser exportado',
       '',
       'NOMARQ',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '--',
       380,
       4,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero do endereo',
       'Nmero do endereo',
       '',
       'NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '01',
       50,
       8,
       'NUMPED',
       'A',
       '',
       0,
       0,
       'PED ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'F',
       '9',
       'T',
       'Nmero do Pedido',
       'Nmero do pedido',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '02',
       140,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'PED ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PED',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(PED.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '02',
       141,
       4000,
       'OBSERV2',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Observaes(1 linha)',
       'Observaes sem Quebra de Linha',
       '',
       'REPLACE(REPLACE(RTF2TXT(PED.OBSERV),CHR(13),''''),CHR(10),'''')',
       '' FROM DUAL
UNION ALL
SELECT 'PED ',
       '02',
       100,
       8,
       'OUTTAX',
       'F',
       '',
       2,
       0,
       'PED ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'T',
       '9',
       'T',
       'Outras Taxas',
       'Outras taxas no pedido',
       '',
       'OUTTAX',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '--',
       390,
       20,
       'PEDEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Pedido Externo',
       'Cdigo externo para pedido eletrnico',
       '',
       'PEDEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '02',
       180,
       15,
       'PEDFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Pedido Fornecedor',
       'Pedido Fornecedor',
       '',
       'PEDFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '--',
       400,
       4,
       'PROMOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Promoo',
       '',
       '',
       'PROMOC',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '04',
       290,
       8,
       'QTDTOT',
       'F',
       '',
       2,
       0,
       'PED ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'T',
       '9',
       'T',
       'Qtd.Total',
       'Quantidade total do pedido',
       '',
       'QTDTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '04',
       330,
       8,
       'SALLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       '',
       'Saldo Lquido',
       'Saldo Lquido',
       '',
       'CASE WHEN IPE.FLGEST = ''E'' THEN IPE.VLRITE + (IPE.VLRITE * PED.DESCON / PED.VLRTOT) ELSE 0 END',
       '' FROM DUAL
UNION ALL
SELECT 'PED ',
       '02',
       150,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'PED ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PED',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN PED.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '01',
       40,
       1,
       'TIPFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'PED ',
       10,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Cliente',
       'Tipo de Cliente',
       '',
       'TIPFOR',
       'T' FROM DUAL
UNION ALL
SELECT 'PED ',
       '02',
       470,
       1,
       'TRAAUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Tranf. Automtica?',
       'Tranferncia Automtica?',
       '',
       'TRAAUT',
       '' FROM DUAL
UNION ALL
SELECT 'PED ',
       '02',
       190,
       1,
       'VENENT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Entrega?',
       'Entrega',
       '',
       'VENENT',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '04',
       200,
       14,
       'VLRBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Bnus',
       'Valor Bnus',
       '',
       'VLRBON',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '04',
       500,
       12,
       'VLRBONFUT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr Bonificao Fut.',
       'Valor Bonificao Futura',
       '',
       'VLRBONFUT',
       '' FROM DUAL
UNION ALL
SELECT 'PED ',
       '04',
       490,
       12,
       'VLREMB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor da Embalagem',
       'Valor da Embalagem',
       '',
       'VLREMB',
       '' FROM DUAL
UNION ALL
SELECT 'PED ',
       '04',
       450,
       12,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor do Frete',
       'Valor do Frete',
       '',
       'VLRFRE',
       '' FROM DUAL
UNION ALL
SELECT 'PED ',
       '04',
       480,
       12,
       'VLRIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor do IPI',
       'Valor do IPI',
       '',
       'VLRIPI',
       '' FROM DUAL
UNION ALL
SELECT 'PED ',
       '04',
       320,
       8,
       'VLRLIQ',
       'F',
       '',
       2,
       0,
       'PED ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'T',
       '9',
       'T',
       'Valor Final',
       'Valor lquido do pedido',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '04',
       410,
       12,
       'VLRPEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Valor Pendente',
       'Valor pendente do pedido',
       '',
       '(SELECT COALESCE(SUM(VLRITE),0) FROM TT_IPE WHERE CODFIL = PED.CODFIL AND NUMPED = PED.NUMPED AND FLGEST = ''A'')',
       '' FROM DUAL
UNION ALL
SELECT 'PED ',
       '04',
       300,
       8,
       'VLRTOT',
       'F',
       '',
       2,
       0,
       'PED ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'T',
       '9',
       'T',
       'Vlr. Total do Pedido',
       'Valor total do pedido',
       '',
       'VLRTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'PED ',
       '03',
       510,
       8,
       'DATAPR',
       '@',
       '',
       0,
       0,
       'PED ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PED',
       'F',
       '@',
       'T',
       'Data~Aprovao',
       'Data de Aprovao',
       '',
       'DATAPR',
       'F' FROM DUAL
);

/*-- SEQ 8930 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'PED ',
       'CODCON',
       0,
       'N',
       'Negociado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PED ',
       'CODCON',
       0,
       'P',
       'A Prazo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PED ',
       'CODCON',
       0,
       'V',
       'A Vista',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PED ',
       'FLGEST',
       0,
       '0',
       'Reprovado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PED ',
       'FLGEST',
       0,
       '2',
       'Autorizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PED ',
       'FLGEST',
       0,
       'A',
       'Em aberto',
       94,
       ' ' FROM DUAL
UNION ALL
SELECT 'PED ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       96,
       ' ' FROM DUAL
UNION ALL
SELECT 'PED ',
       'FLGEST',
       0,
       'E',
       'Entregue',
       95,
       ' ' FROM DUAL
UNION ALL
SELECT 'PED ',
       'FREORI',
       0,
       'E',
       'Encomenda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PED ',
       'FREORI',
       0,
       'P',
       'Padro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PED ',
       'TIPFOR',
       0,
       'F',
       'Fornecedor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PED ',
       'TIPFOR',
       0,
       'T',
       'Transportadora',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8931 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PEND',
       TO_NUMBER(null),
       'PEND',
       'Endereo Personal.',
       'TP_END',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'PEND.FILCLI,PEND.CODCLI,PEND.CODFIL,PEND.NUMEND',
       '' FROM DUAL
);

/*-- SEQ 8932 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PEND','--','' FROM DUAL
UNION ALL
SELECT 'PEND','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PEND','99','Outros' FROM DUAL
);

/*-- SEQ 8933 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 32693,
       'EDE ',
       'PEND',
       '1 ',
       '01',
       '',
       '',
       'EDE.FILCLI = PEND.FILCLI(+) and
EDE.CODCLI = PEND.CODCLI(+) and
EDE.CODFIL = PEND.CODFIL(+) and
EDE.NUMEND = PEND.NUMEND(+)',
       '' FROM DUAL
);

/*-- SEQ 8934 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PEND',
       '01',
       3,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'PEND',
       '01',
       1,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '0',
       'F',
       'Filial Endereo',
       'Filial Endereo',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PEND',
       '01',
       2,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '0',
       'F',
       'Filial Cliente',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'PEND',
       '01',
       4,
       4,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'N',
       'F',
       'Nmero Endereo',
       'Nmero Endereo',
       '',
       'NUMEND',
       'F' FROM DUAL
);

/*-- SEQ 8935 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PER ',
       TO_NUMBER(null),
       'PER ',
       'Perguntas',
       'TT_PER',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'PER.FILPER,PER.CODPER',
       '' FROM DUAL
);

/*-- SEQ 8936 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PER ','--','' FROM DUAL
UNION ALL
SELECT 'PER ','01','Repeties' FROM DUAL
UNION ALL
SELECT 'PER ','02','Prioridade' FROM DUAL
UNION ALL
SELECT 'PER ','03','Respostas' FROM DUAL
);

/*-- SEQ 8937 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PER ',
       '--',
       35,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano~Atualizao',
       'Ano de Data da ltima atualizao',
       '',
       'TO_CHAR(PER.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PER ',
       '--',
       30,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data~Atualizao',
       'Data da ltima atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'PER ',
       '--',
       2,
       5,
       'CODPER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo',
       'Cdigo da pergunta',
       '',
       'CODPER',
       'F' FROM DUAL
UNION ALL
SELECT 'PER ',
       '--',
       1,
       3,
       'FILPER',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial de origem',
       'PER.FILPER = DFIL.CODFIL(+)',
       'FILPER',
       'T' FROM DUAL
UNION ALL
SELECT 'PER ',
       '02',
       20,
       1,
       'FORREP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Indondicional?',
       'A prioridade independe de condies',
       '',
       'FORREP',
       'F' FROM DUAL
UNION ALL
SELECT 'PER ',
       '--',
       33,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms~Atualizao',
       'Ms de Data da ltima atualizao',
       '',
       'TO_CHAR(PER.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PER ',
       '--',
       70,
       2000,
       'MSGPER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Pergunta',
       'Descrio da pergunta',
       '',
       'MSGPER',
       'F' FROM DUAL
UNION ALL
SELECT 'PER ',
       '03',
       10,
       1,
       'MULESC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Mltipla Escolha?',
       'Respostas com mltipla escolha',
       '',
       'MULESC',
       'F' FROM DUAL
UNION ALL
SELECT 'PER ',
       '--',
       120,
       2000,
       'OBSPER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Comentrio',
       'Comentrio',
       '',
       'OBSPER',
       'F' FROM DUAL
UNION ALL
SELECT 'PER ',
       '01',
       20,
       1,
       'PERIOD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       '9',
       'F',
       'Periodicidade',
       'Periodicidade das repeties',
       '',
       'PERIOD',
       'T' FROM DUAL
UNION ALL
SELECT 'PER ',
       '02',
       10,
       1,
       'PRIPER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nvel',
       'Nvel de prioridade da pergunta (de 0  9)',
       '',
       'PRIPER',
       'F' FROM DUAL
UNION ALL
SELECT 'PER ',
       '01',
       10,
       1,
       'REPETE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       '9',
       'F',
       'Permite',
       'Permite repeties',
       '',
       'REPETE',
       'T' FROM DUAL
UNION ALL
SELECT 'PER ',
       '--',
       50,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN PER.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'PER ',
       '--',
       51,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN PER.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'PER ',
       '--',
       40,
       30,
       'TITPER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'L',
       '',
       'F',
       'A',
       'F',
       'Ttulo',
       'Ttulo da pergunta',
       '',
       'TITPER',
       'F' FROM DUAL
);

/*-- SEQ 8938 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'PER ',
       'PERIOD',
       0,
       ' ',
       'Semanal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PER ',
       'PERIOD',
       1,
       ' ',
       'Quinsenal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PER ',
       'PERIOD',
       2,
       ' ',
       'Mensal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PER ',
       'PERIOD',
       3,
       ' ',
       'Bimestral',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PER ',
       'PERIOD',
       4,
       ' ',
       'Trimestral',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PER ',
       'PERIOD',
       5,
       ' ',
       'Semestral',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PER ',
       'PERIOD',
       6,
       ' ',
       'Anual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PER ',
       'REPETE',
       1,
       ' ',
       'Nao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PER ',
       'REPETE',
       2,
       ' ',
       'Peridicas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PER ',
       'REPETE',
       0,
       ' ',
       'Sim',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8939 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PGRA',
       TO_NUMBER(null),
       'PGRA',
       'SubProduto Personal.',
       'TP_GRA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'PGRA.FILMAT,PGRA.CODMAT,PGRA.CODCOR,PGRA.CODTAM',
       '' FROM DUAL
);

/*-- SEQ 8940 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PGRA','--','' FROM DUAL
UNION ALL
SELECT 'PGRA','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PGRA','99','Outros' FROM DUAL
);

/*-- SEQ 8941 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 32694,
       'GRA ',
       'PGRA',
       '1 ',
       '01',
       '',
       '',
       'GRA.FILMAT = PGRA.FILMAT(+) and
GRA.CODMAT = PGRA.CODMAT(+) and
GRA.CODCOR = PGRA.CODCOR(+) and
GRA.CODTAM = PGRA.CODTAM(+)
',
       '' FROM DUAL
);

/*-- SEQ 8942 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PGRA',
       '01',
       3,
       5,
       'CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'N',
       'F',
       'Diviso',
       'Diviso',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PGRA',
       '01',
       2,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '9',
       'F',
       'Cdigo Material',
       'Cdigo Material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'PGRA',
       '01',
       4,
       5,
       'CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'PGRA',
       '01',
       1,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '0',
       'F',
       'Filial Material',
       'Filial Material',
       '',
       'FILMAT',
       'F' FROM DUAL
);

/*-- SEQ 8943 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PHO ',
       TO_NUMBER(null),
       'PHO ',
       'Fotos',
       'TT_PHO',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'PHO.CODFIL,PHO.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8944 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PHO ','--','' FROM DUAL
UNION ALL
SELECT 'PHO ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PHO ','99','Outros' FROM DUAL
);

/*-- SEQ 8945 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5730,
       'SUB ',
       'PHO ',
       '1 ',
       'N ',
       '',
       '',
       'SUB.CODITE = PHO.CODEXP',
       '' FROM DUAL
);

/*-- SEQ 8946 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PHO ',
       '01',
       20,
       15,
       'CODBAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo de Barra',
       'Cdigo de Barra',
       '',
       'CODBAR',
       'F' FROM DUAL
UNION ALL
SELECT 'PHO ',
       '01',
       30,
       5,
       'CODDUP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Item',
       'Cdigo Item',
       '',
       'CODDUP',
       'F' FROM DUAL
UNION ALL
SELECT 'PHO ',
       '01',
       100,
       5,
       'CODEXP',
       'S',
       'DAMP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DAMP.PHOCOM',
       'V',
       '',
       '',
       '9',
       'F',
       'Cdigo Exposies',
       'Cdigo Exposies',
       'DAMP.CODTAB = PHO.CODEXP',
       'CODEXP',
       'F' FROM DUAL
UNION ALL
SELECT 'PHO ',
       '01',
       40,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '9',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = PHO.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PHO ',
       '01',
       50,
       5,
       'CODISO',
       'S',
       'DISO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DISO.PHOISO',
       'V',
       '',
       '',
       '9',
       'F',
       'Cdigo ISO',
       'Cdigo ISO do Filme',
       'DISO.CODTAB = PHO.CODISO',
       'CODISO',
       'F' FROM DUAL
UNION ALL
SELECT 'PHO ',
       '01',
       60,
       5,
       'CODMAR',
       'S',
       'DMAR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMAR.PHOMAR',
       'V',
       '',
       '',
       '9',
       'F',
       'Cdigo Marca',
       'Cdigo Marca',
       'DMAR.CODTAB = PHO.CODMAR',
       'CODMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'PHO ',
       '01',
       70,
       5,
       'CODPHO',
       'S',
       'DPHO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DPHO.PHOOUT',
       'V',
       '',
       '',
       '9',
       'F',
       'Cdigo Foto',
       'Cdigo Foto',
       'DPHO.CODTAB = PHO.CODPHO',
       'CODPHO',
       'F' FROM DUAL
UNION ALL
SELECT 'PHO ',
       '01',
       80,
       5,
       'CODTIP',
       'S',
       'DTIP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DTIP.PHOTIP',
       'V',
       '',
       '',
       '9',
       'F',
       'Cdigo Tipo',
       'Cdigo Tipo',
       'DTIP.CODTAB = PHO.CODTIP',
       'CODTIP',
       'F' FROM DUAL
UNION ALL
SELECT 'PHO ',
       '01',
       90,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8947 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PIV ',
       TO_NUMBER(null),
       'PIV ',
       'Prod.Indispon.p/Ven.',
       'TT_PIV',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'PIV.CODFIL,PIV,SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8948 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PIV ','--','' FROM DUAL
UNION ALL
SELECT 'PIV ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PIV ','99','Outros' FROM DUAL
);

/*-- SEQ 8949 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PIV ',
       '01',
       10,
       5,
       'CODCL1',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Cliente 1',
       'Cdigo Cliente 1',
       '',
       'CODCL1',
       'F' FROM DUAL
UNION ALL
SELECT 'PIV ',
       '01',
       20,
       5,
       'CODCL2',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Cliente 2',
       'Cdigo Cliente 2',
       '',
       'CODCL2',
       'F' FROM DUAL
UNION ALL
SELECT 'PIV ',
       '01',
       30,
       5,
       'CODCL3',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Cliente 3',
       'Cdigo Cliente 3',
       '',
       'CODCL3',
       'F' FROM DUAL
UNION ALL
SELECT 'PIV ',
       '01',
       40,
       5,
       'CODCL4',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Cliente 4',
       'Cdigo Cliente 4',
       '',
       'CODCL4',
       'F' FROM DUAL
UNION ALL
SELECT 'PIV ',
       '01',
       50,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = PIV.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PIV ',
       '01',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8950 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PLA ',
       0,
       'PLA ',
       'Planos',
       'TT_PLA',
       'T',
       '',
       'TOTALL',
       'Planos',
       '{CODPGT;FILPGT;ATU_EM}',
       '',
       'APEPGT',
       'Plano',
       'T',
       '',
       'PLA.FILPGT,PLA.CODPGT
PLA.APEPGT
PLA.DESPGT',
       '' FROM DUAL
);

/*-- SEQ 8951 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PLA ','--','' FROM DUAL
UNION ALL
SELECT 'PLA ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PLA ','02','Valores' FROM DUAL
UNION ALL
SELECT 'PLA ','03','Datas' FROM DUAL
UNION ALL
SELECT 'PLA ','04','Negociao' FROM DUAL
UNION ALL
SELECT 'PLA ','99','Outros' FROM DUAL
);

/*-- SEQ 8952 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'PLA ',
       '02',
       190,
       8,
       'ABAMAX',
       'F',
       '',
       2,
       0,
       'PLA ',
       200,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'T',
       '9',
       'T',
       'Arredondamento (max)',
       'Arredondamento (mximo)',
       '',
       'ABAMAX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       180,
       8,
       'ABAMIN',
       'F',
       '',
       2,
       0,
       'PLA ',
       190,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'T',
       '9',
       'T',
       'Arredondamento (min)',
       'Arredondamento (mnimo)',
       '',
       'ABAMIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       960,
       14,
       'ACRBOL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Acrs. venda boleto',
       'Valor de acrscimo para venda com boleto',
       '',
       'ACRBOL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       311,
       8,
       'ACRDIA',
       'F',
       '',
       2,
       0,
       'PLA ',
       310,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'T',
       '9',
       'T',
       'Acrscimo ao Dia',
       'Acrscimo ao Dia',
       '',
       'ACRDIA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '03',
       570,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'PLA ',
       570,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizao',
       '',
       'TO_CHAR(PLA.ATU_EM,''YYYY'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '03',
       270,
       4,
       'ANO_DATMAX',
       'A',
       '',
       0,
       0,
       'PLA ',
       270,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       '',
       'N',
       'T',
       'Ano de Validade (fin',
       'Ano de Data de validade (final)',
       '',
       'TO_CHAR(PLA.DATMAX,''YYYY'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '03',
       265,
       4,
       'ANO_DATMIN',
       'A',
       '',
       0,
       0,
       'PLA ',
       260,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       '',
       'N',
       'T',
       'Ano de Validade (ini',
       'Ano de Data de validade (inicial)',
       '',
       'TO_CHAR(PLA.DATMIN,''YYYY'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '01',
       50,
       10,
       'APEPGT',
       'A',
       '',
       0,
       0,
       'PLA ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PLA',
       'F',
       'A',
       'T',
       'Apelido',
       'Apelido do plano de pagamento',
       '',
       'APEPGT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '01',
       61,
       1,
       'APLICA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'N',
       'F',
       'Aplica Plano Vlido',
       'Indica para quais mdulos o plano  vlido',
       '',
       'APLICA',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       582,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN PLA.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       291,
       2,
       'ATRMAX',
       'S',
       '',
       0,
       0,
       'PLA ',
       290,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       '9',
       'T',
       'Tolera atraso at',
       'Maior atraso tolerado',
       '',
       'ATRMAX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '03',
       571,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'PLA ',
       570,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '01',
       864,
       6,
       'BONPGT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Bnus Pgt. Antec.',
       'Bnus Pgt. Antec.',
       '',
       'BONPGT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '--',
       914,
       3,
       'CARFAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Carncia Fat. dias',
       'Carncia Faturamento (dias)',
       '',
       'CARFAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       321,
       2,
       'CARMAX',
       'S',
       '',
       0,
       0,
       'PLA ',
       320,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       '9',
       'T',
       'Carncia Mxima',
       'Nmero de dias de carncia',
       '',
       'CARMAX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       601,
       1,
       'CARONL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       'PLA ',
       600,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'F',
       'Impr. Carn OnLine?',
       'Impr. Carn OnLine',
       '',
       'CARONL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '--',
       884,
       5,
       'CATEG1',
       'S',
       'DCT1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       'DCT1.NOMCT1',
       'V',
       '',
       '',
       'N',
       'F',
       'Profisso/Ramo',
       'Categoria 1',
       'DCT1.CODTAB(+) = PLA.CATEG1',
       'CATEG1',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '--',
       894,
       5,
       'CATEG2',
       'S',
       'DCT2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'V',
       '',
       '',
       'N',
       'F',
       'Salrio/Faturam',
       'Categoria 2',
       'DCT2.CODTAB(+) = PLA.CATEG2',
       'CATEG2',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '--',
       904,
       5,
       'CATEG3',
       'S',
       'DCT3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'V',
       '',
       '',
       'N',
       'F',
       '3',
       'Categoria 3',
       'DCT3.CODTAB(+) = PLA.CATEG3',
       'CATEG3',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '01',
       25,
       6,
       'CHAVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'T',
       'Plano',
       'Cdigo do Plano',
       '',
       'FILPGT||PLA.CODPGT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '03',
       614,
       3,
       'CHRREC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'N Mx. Dias Cheque/',
       'N Mx. Dias Cheque/Parcela',
       '',
       'CHRREC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '01',
       531,
       2,
       'CLASS1',
       'S',
       'DCL1',
       0,
       6,
       'PLA ',
       530,
       TO_NUMBER(null),
       '',
       'DCL1.CLASS1',
       'V',
       'PLA',
       'F',
       'A',
       'F',
       'Catergoria',
       '1 Classe do Produto para limitao de Plano a Produto',
       'PLA.CLASS1 = DCL1.CODTAB (+)',
       'CLASS1',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       541,
       2,
       'CLASS2',
       'S',
       'DCL2',
       0,
       7,
       'PLA ',
       540,
       TO_NUMBER(null),
       '',
       'DCL2.CLASS2',
       'V',
       'PLA',
       'F',
       'A',
       'F',
       'SubCategoria',
       '2 Classe do Produto para limitao de Plano a Produto',
       'PLA.CLASS2=DCL2.CODTAB (+)',
       'CLASS2',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       551,
       2,
       'CLASS3',
       'S',
       'DCL3',
       0,
       8,
       'PLA ',
       550,
       TO_NUMBER(null),
       '',
       'DCL3.CLASS3',
       'V',
       'PLA',
       'F',
       'A',
       'F',
       'Familia',
       '3 Classe do Produto para limitao de Plano a Produto',
       'PLA.CLASS3=DCL3.CODTAB (+)',
       'CLASS3',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       561,
       2,
       'CLASS4',
       'S',
       'DCL4',
       0,
       9,
       'PLA ',
       560,
       TO_NUMBER(null),
       '',
       'DCL4.CLASS4',
       'V',
       'PLA',
       'F',
       'A',
       'F',
       'SubFamilia',
       '4 Classe do Produto para limitao de Plano a Produto',
       'PLA.CLASS4=DCL4.CODTAB (+)',
       'CLASS4',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '01',
       624,
       1,
       'CODBAI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Instruo de Baixa',
       'Instruo de Baixa',
       '',
       'CODBAI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       381,
       2,
       'CODCOB',
       'S',
       'DCOB',
       0,
       33,
       'PLA ',
       380,
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       'PLA',
       'F',
       'A',
       'T',
       'Cobrana',
       'Cdigo da Cobrana',
       'PLA.CODCOB=DCOB.CODTAB (+)',
       'CODCOB',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       602,
       10,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Codigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       980,
       5,
       'CODFIN',
       'G',
       'DFIN',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIN.DESFIN',
       'V',
       '',
       '',
       'N',
       '',
       'Financeira',
       'Financeira',
       'DFIN.CODTAB(+) = PLA.CODFIN',
       'CODFIN',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       451,
       2,
       'CODMOE',
       'S',
       'DMOE',
       0,
       55,
       'PLA ',
       450,
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       'PLA',
       'F',
       'A',
       'T',
       'Moeda',
       'Moeda do plano',
       'PLA.CODMOE=DMOE.CODTAB (+)',
       'CODMOE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '01',
       603,
       2,
       'CODNAT',
       'S',
       'DNAT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DNAT.NATURE',
       'V',
       '',
       'F',
       'A',
       'F',
       'Natureza',
       'Natureza de operao',
       'PLA.CODNAT = DNAT.CODTAB (+)',
       'CODNAT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '01',
       20,
       3,
       'CODPGT',
       'A',
       '',
       0,
       0,
       'PLA ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       '9',
       'T',
       'Cdigo',
       'Cdigo do plano de pagamento',
       '',
       'CODPGT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '01',
       634,
       1,
       'CODPRT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Instruo Protesto',
       'Instruo de Protesto',
       '',
       'CODPRT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       371,
       2,
       'COMSOB',
       'S',
       '',
       0,
       32,
       'PLA ',
       370,
       30,
       '',
       '',
       'D',
       'PLA',
       'F',
       'A',
       'T',
       'Comisso Sobre',
       'Comisso sobre ... (ver tela do plano)',
       '',
       'COMSOB',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '03',
       271,
       8,
       'DATMAX',
       'D',
       '',
       0,
       0,
       'PLA ',
       270,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       'D',
       'T',
       'Validade (final)',
       'Data de validade (final)',
       '',
       'DATMAX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '03',
       261,
       8,
       'DATMIN',
       'D',
       '',
       0,
       0,
       'PLA ',
       260,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       'D',
       'T',
       'Validade (inicial)',
       'Data de validade (inicial)',
       '',
       'DATMIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '03',
       281,
       8,
       'DATPRE',
       'D',
       '',
       0,
       0,
       'PLA ',
       280,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       'D',
       'F',
       'Data Pre-Datamento',
       'Data de pre-datamento TEF',
       '',
       'DATPRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       170,
       8,
       'DE1IDE',
       'F',
       '',
       2,
       0,
       'PLA ',
       180,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'T',
       '9',
       'T',
       '% Desc./Acres. (ide)',
       'Porcentagem Desconto/Acrscimo (ideal)',
       '',
       'DE1IDE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       160,
       8,
       'DE1MAX',
       'F',
       '',
       2,
       0,
       'PLA ',
       170,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'T',
       '9',
       'T',
       '% Desc./Acres. (max)',
       'Porcentagem Desconto/Acrscimo (mximo)',
       '',
       'DE1MAX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       150,
       8,
       'DE1MIN',
       'F',
       '',
       2,
       0,
       'PLA ',
       160,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'T',
       'N',
       'T',
       '% Desc./Acres. (min)',
       'Porcentagem Desconto/Acrscimo (mnimo)',
       '',
       'DE1MIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       511,
       8,
       'DESANT',
       'F',
       '',
       2,
       0,
       'PLA ',
       510,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'T',
       '',
       'T',
       '% Desc. Antecipado',
       'Percentual de desconto antecipado',
       '',
       'DESANT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       1020,
       6,
       'DESESP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Desconto Especial',
       'Desconto Especial',
       '',
       'DESESP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       814,
       6,
       'DESJUR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Desc. sobre Juros ',
       '% Desconto sobre os juros',
       '',
       'DESJUR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '01',
       40,
       35,
       'DESPGT',
       'A',
       '',
       0,
       0,
       'PLA ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PLA',
       'F',
       'A',
       'T',
       'Descrio',
       'Descrio do plano de pagamento',
       '',
       'DESPGT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       644,
       1,
       'DESREC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Desconto Antecipado?',
       'Desconto Antecipado Automtico',
       '',
       'DESREC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '03',
       521,
       2,
       'DIAANT',
       'S',
       '',
       0,
       0,
       'PLA ',
       520,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       '9',
       'T',
       'Dias p/ Desc. Antec.',
       'Nmero de dias para desconto antecipado',
       '',
       'DIAANT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       944,
       5,
       'DIAFLX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias flexveis',
       'Dias flexveis para prorrogao ou antecipao das parcelas',
       '',
       'DIAFLX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '01',
       824,
       5,
       'DIATIT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias para Ttulos',
       'Dias para Ttulos',
       '',
       'DIATIT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       591,
       1,
       'ENTVLR',
       'L',
       '',
       0,
       0,
       'PLA ',
       590,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'PLA',
       'F',
       '',
       'T',
       'Valor Fixo na Entr.?',
       'Indica se a entrada  percentual ou valor',
       '',
       'ENTVLR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       604,
       1,
       'FATURA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Formato Imp. Fatura?',
       'Formato de impresso de faturas',
       '',
       'FATURA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '01',
       10,
       3,
       'FILPGT',
       'A',
       '',
       0,
       0,
       'PLA ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       'N',
       'T',
       'Filial de Origem',
       'Filial onde foi cadastrado o Plano',
       '',
       'FILPGT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '01',
       70,
       1,
       'FLGESP',
       'L',
       '',
       0,
       14,
       'PLA ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'PLA',
       'F',
       '',
       'T',
       'Parcelas Livres?',
       'Flag para parcelas livres (S/N)',
       '',
       'FLGESP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       80,
       2,
       'FLGJUR',
       'S',
       '',
       0,
       30,
       'PLA ',
       90,
       30,
       '',
       '',
       'D',
       'PLA',
       'F',
       'A',
       'T',
       'Tipo de Juros',
       'Tipo de Juros',
       '',
       'FLGJUR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       351,
       2,
       'FORMUL',
       'S',
       '',
       0,
       31,
       'PLA ',
       350,
       30,
       '',
       '',
       'D',
       'PLA',
       'F',
       'A',
       'T',
       'Frmula Comisso',
       'Frmula para clculo da comisso',
       '',
       'FORMUL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       1010,
       7,
       'INDDES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'ndice Desconto (%)',
       'ndice do Desconto (%)',
       '',
       'INDDES',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '01',
       834,
       1,
       'INTPMU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Multa',
       'Indicador do tipo de multa',
       '',
       'INTPMU',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       934,
       6,
       'JURFLX',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Juros FLEX',
       'Juros FLEX ao dia',
       '',
       'JURFLX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '04',
       784,
       6,
       'JURREN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Juros Renegociao',
       'Juros de Renegociao',
       '',
       'JURREN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       391,
       1,
       'JURTOT',
       'L',
       '',
       0,
       34,
       'PLA ',
       390,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'PLA',
       'F',
       '',
       'T',
       'Juros Sobre?',
       'Juros sobre o total da nota (S/N)',
       '',
       'JURTOT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       301,
       2,
       'MEDMAX',
       'S',
       '',
       0,
       0,
       'PLA ',
       300,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       '9',
       'T',
       'Maior Mdia Atraso',
       'Maior mdia de atrasos tolerada',
       '',
       'MEDMAX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '03',
       572,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'PLA ',
       570,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizao ...',
       '',
       'TO_CHAR(PLA.ATU_EM,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '03',
       272,
       2,
       'MES_DATMAX',
       'A',
       '',
       0,
       0,
       'PLA ',
       270,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       '',
       'N',
       'T',
       'Ms de Validade (fin',
       'Ms de Data de validade (final)',
       '',
       'TO_CHAR(PLA.DATMAX,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '03',
       263,
       2,
       'MES_DATMIN',
       'A',
       '',
       0,
       0,
       'PLA ',
       260,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       '',
       'N',
       'T',
       'Ms de Validade (ini',
       'Ms de Data de validade (inicial)',
       '',
       'TO_CHAR(PLA.DATMIN,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       1000,
       12,
       'MINPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor mnimo parcela',
       'Valor mnimo de parcela',
       '',
       'MINPAR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       481,
       2,
       'MOECOR',
       'S',
       'DMOE',
       0,
       56,
       'PLA ',
       480,
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       'PLA',
       'F',
       'N',
       'F',
       'Moeda Correo',
       'Moeda de correo (quando Contrato)',
       'PLA.MOECOR = DMOE.CODTAB (+)',
       'MOECOR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '01',
       60,
       2,
       'NIVUSU',
       'S',
       '',
       0,
       15,
       'PLA ',
       70,
       30,
       '',
       '',
       'D',
       'PLA',
       'F',
       'A',
       'T',
       'Nvel Autorizado',
       'Nvel do usurio autorizado a operar este plano',
       '',
       'NIVUSU',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '03',
       491,
       2,
       'NROMES',
       'S',
       '',
       0,
       0,
       'PLA ',
       490,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       '',
       'F',
       'Nmero de Meses',
       'Nmero de meses para refaturamento (quando Contrado)',
       '',
       'NROMES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       231,
       2,
       'PARIDE',
       'S',
       '',
       0,
       0,
       'PLA ',
       230,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       '9',
       'T',
       'Nm Parcelas (ide)',
       'Nmero de parcelas (ideal)',
       '',
       'PARIDE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       210,
       2,
       'PARMAX',
       'S',
       '',
       0,
       0,
       'PLA ',
       220,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       '9',
       'T',
       'Nm. Parcelas (max)',
       'Nmero de parcelas (mximo)',
       '',
       'PARMAX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       200,
       2,
       'PARMIN',
       'S',
       '',
       0,
       0,
       'PLA ',
       210,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       '9',
       'T',
       'Nm. Parcelas (min)',
       'Nmero de parcelas (mnimo)',
       '',
       'PARMIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       501,
       2,
       'PARVEN',
       'S',
       '',
       0,
       0,
       'PLA ',
       500,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       '',
       'F',
       'Nmero de Parcelas',
       'Nmero de parcelas recebidas na venda (Caixa)',
       '',
       'PARVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       331,
       8,
       'PERCOM',
       'F',
       '',
       2,
       0,
       'PLA ',
       330,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'T',
       '',
       'T',
       '% Comisso Parcelas',
       'Percentual de comisso no geral',
       '',
       'PERCOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       341,
       8,
       'PERENT',
       'F',
       '',
       2,
       0,
       'PLA ',
       340,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'T',
       '',
       'T',
       '% Comisso Entrada',
       'Percentual de comisso na entrada',
       '',
       'PERENT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       361,
       2,
       'PERIOD',
       'S',
       '',
       0,
       0,
       'PLA ',
       360,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       '9',
       'T',
       'Intervalo Parcelas',
       'Intervalo',
       '',
       'PERIOD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       1030,
       1,
       'PERMITE_ENTREGA_PGT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Permite Entrega Pgt',
       'Permitir definir item como entregue apenas com todas as parcelas pagas',
       '',
       'PERMITE_ENTREGA_PGT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       954,
       5,
       'PLAOUT',
       'G',
       'DOUT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       'DOUT.DESCAR',
       'V',
       '',
       '',
       'N',
       '',
       'Tipo Outros',
       'Tipo Outros',
       'PLA.PLAOUT=DOUT.CODTAB (+)',
       'PLAOUT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       441,
       2,
       'PORDEM',
       'S',
       'DCOB',
       0,
       17,
       'PLA ',
       440,
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       'PLA',
       'F',
       'A',
       'T',
       'Portador das Parcela',
       'Portador das demais parcelas',
       'PLA.PORDEM=DCOB.CODTAB (+)',
       'PORDEM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       431,
       2,
       'PORENT',
       'S',
       'DCOB',
       0,
       16,
       'PLA ',
       430,
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       'PLA',
       'F',
       'A',
       'T',
       'Portador da Entrada',
       'Portador da entrada',
       'PLA.PORENT=DCOB.CODTAB (+)',
       'PORENT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       110,
       2,
       'PRAIDE',
       'S',
       '',
       0,
       0,
       'PLA ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       'N',
       'T',
       '1 Recebimento (ide)',
       'Dias de prazo para o 1 recebimento (ideal)',
       '',
       'PRAIDE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       100,
       2,
       'PRAMAX',
       'S',
       '',
       0,
       0,
       'PLA ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       'N',
       'T',
       '1 Recebimento (max)',
       'Dias de prazo para o 1 recebimento (mximo)',
       '',
       'PRAMAX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       90,
       2,
       'PRAMIN',
       'S',
       '',
       0,
       0,
       'PLA ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       'N',
       'T',
       '1 Recebimento (min)',
       'Dias de prazo para o 1 recebimento (mnimo)',
       '',
       'PRAMIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '01',
       41,
       1,
       'PREINF',
       'L',
       '',
       0,
       29,
       'PLA ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'PLA',
       'F',
       '',
       'T',
       'Preo Informado?',
       'Permite preo informado',
       '',
       'PREINF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       140,
       2,
       'PRIIDE',
       'S',
       '',
       0,
       0,
       'PLA ',
       150,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       'N',
       'T',
       '% 1 Recto. (ideal)',
       'Porcentagem no 1 recebimento (ideal)',
       '',
       'PRIIDE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       130,
       2,
       'PRIMAX',
       'S',
       '',
       0,
       0,
       'PLA ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       'N',
       'T',
       '% 1 Recto. (max)',
       'Porcentagem no 1 recebimento (mximo)',
       '',
       'PRIMAX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       120,
       2,
       'PRIMIN',
       'S',
       '',
       0,
       0,
       'PLA ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       'N',
       'T',
       '% 1 Recto (min)',
       'Porcentagem no 1 recebimento (mnimo)',
       '',
       'PRIMIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       654,
       1,
       'PROPOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Proporo?',
       'Proporo',
       '',
       'PROPOR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '03',
       664,
       2,
       'PRZBAI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Prazo dias de Baixa',
       'Prazo dias de Baixa',
       '',
       'PRZBAI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '03',
       674,
       2,
       'PRZPRT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Prazo de Protesto',
       'Prazo dias de Protesto',
       '',
       'PRZPRT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       421,
       2,
       'PZOIDE',
       'S',
       '',
       0,
       0,
       'PLA ',
       420,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       '9',
       'T',
       'Prazo Mdio (ide)',
       'Prazo mdio (ideal)',
       '',
       'PZOIDE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       411,
       2,
       'PZOMAX',
       'S',
       '',
       0,
       0,
       'PLA ',
       410,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       '9',
       'T',
       'Prazo Mdio (max)',
       'Prazo mdio (mximo)',
       '',
       'PZOMAX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       401,
       2,
       'PZOMIN',
       'S',
       '',
       0,
       0,
       'PLA ',
       400,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       '9',
       'T',
       'Prazo Mdio (min)',
       'Prazo mdio (mnimo)',
       '',
       'PZOMIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '04',
       794,
       1,
       'RENEGO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Renegociao?',
       'Renegociao',
       '',
       'RENEGO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '04',
       804,
       1,
       'RENSOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Calculado Sobre',
       'Renogociao Calculada Sobre',
       '',
       'RENSOB',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       581,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'PLA ',
       580,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PLA',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN PLA.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '04',
       990,
       1,
       'SOBNEG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Sob negociao',
       'Plano visvel somente sob negociao',
       '',
       'SOBNEG',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '--',
       924,
       5,
       'TIPCCC',
       'S',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       'A',
       'F',
       'Tipo Conta Corrente',
       'Tipo Conta Corrente',
       'DCCC.CODTAB(+) = PLA.TIPCCC',
       'TIPCCC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       684,
       1,
       'TIPCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Cobrana',
       'Tipo Cobrana',
       '',
       'TIPCOB',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '01',
       471,
       2,
       'TIPPLA',
       'S',
       '',
       0,
       36,
       'PLA ',
       470,
       30,
       '',
       '',
       'D',
       'PLA',
       'F',
       'A',
       'T',
       'Tipo de Plano',
       'Tipo de plano (Venda/Contrado)',
       '',
       'TIPPLA',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       461,
       2,
       'TOTLIM',
       'S',
       '',
       0,
       0,
       'PLA ',
       460,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       '',
       'F',
       'Total Limitao',
       'Total de itens da limitao de planos a produtos',
       '',
       'TOTLIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       714,
       1,
       'USACAM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Cmbio?',
       'Usa Cmbio(Moeda Estrangeira)?',
       '',
       'USACAM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       724,
       1,
       'USACHE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Cheque?',
       'Usa Cheque?',
       '',
       'USACHE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '04',
       854,
       1,
       'USACPP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Carto Prprio Parc?',
       'Carto Prprio Parcelado?',
       '',
       'USACPP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       734,
       1,
       'USACRE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Carto Crdito?',
       'Usa Carto de Crdito?',
       '',
       'USACRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       744,
       1,
       'USAC_C',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Conta Corrente?',
       'Usa Conta Corrente?',
       '',
       'USAC_C',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       970,
       1,
       'USADEB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Usa dbito em C/C',
       'Usa dbito direto em conta corrente bancria',
       '',
       'USADEB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       754,
       1,
       'USADIN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Dinheiro?',
       'Usa Dinheiro(Moeda Nacional)?',
       '',
       'USADIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       764,
       1,
       'USAOUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Outros?',
       'Usa Outros?',
       '',
       'USAOUT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '99',
       774,
       1,
       'USATEF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa T.E.F.?',
       'Usa T.E.F.?',
       '',
       'USATEF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       240,
       8,
       'VLRMAX',
       'F',
       '',
       2,
       0,
       'PLA ',
       250,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'T',
       '9',
       'T',
       'Valor Compra (max)',
       'Valor da compra (mximo)',
       '',
       'VLRMAX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '02',
       241,
       8,
       'VLRMIN',
       'F',
       '',
       2,
       0,
       'PLA ',
       240,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'T',
       '9',
       'T',
       'Valor Compra (min)',
       'Valor da compra (mnimo)',
       '',
       'VLRMIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PLA ',
       '01',
       844,
       12,
       'VLTXMU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Total x Multa',
       'Valor Total x Multa',
       '',
       'VLTXMU',
       'F',
       'D' FROM DUAL
);

/*-- SEQ 8953 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'PLA ',
       'APLICA',
       0,
       ' ',
       'Qualquer',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'APLICA',
       1,
       ' ',
       'Vendas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'APLICA',
       2,
       ' ',
       'Ordens de Servio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'APLICA',
       3,
       ' ',
       'Ttulo Avulso a Receber',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'APLICA',
       4,
       ' ',
       'Faturamento Parcelado ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'APLICA',
       5,
       ' ',
       'E-Commerce',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'APLICA',
       6,
       ' ',
       'Mltiplos Planos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'APLICA',
       7,
       ' ',
       'Auto Service',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'CODBAI',
       0,
       ' ',
       'Sem Instruo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'CODBAI',
       1,
       ' ',
       'Baixar (Dias a Partir do Venc)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'CODBAI',
       2,
       ' ',
       'No Baixar / No Devolver',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'CODPRT',
       0,
       ' ',
       'Sem Instrues',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'CODPRT',
       1,
       ' ',
       'Protestar (Dias Corridos)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'CODPRT',
       2,
       ' ',
       'Protestar (Dias teis)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'CODPRT',
       3,
       ' ',
       'No Protestar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'COMSOB',
       7,
       ' ',
       'Comisso sobre markup',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'COMSOB',
       8,
       ' ',
       'Markup no momento da Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'COMSOB',
       4,
       '-',
       'A receber no Recebimento',
       182,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'COMSOB',
       0,
       '-',
       'Lquido ao Vender',
       178,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'COMSOB',
       1,
       '-',
       'Bruto ao Vender',
       179,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'COMSOB',
       2,
       '-',
       'A receber no Vencimento',
       180,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'COMSOB',
       3,
       '-',
       'Recebido no Recebimento',
       181,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'COMSOB',
       5,
       '-',
       'Recebido na compensao',
       287,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'COMSOB',
       6,
       '-',
       'A receber na compensao',
       288,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'FLGJUR',
       1,
       '-',
       'Composto',
       168,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'FLGJUR',
       0,
       '-',
       'Simples',
       167,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'FORMUL',
       3,
       '-',
       '%Vend.+%Plano',
       171,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'FORMUL',
       6,
       '-',
       '%Vend.+%Plano+%Prod.',
       175,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'FORMUL',
       4,
       '-',
       '%Vend.+%Prod.',
       172,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'FORMUL',
       5,
       '-',
       '%Plano+%Prod.',
       173,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'FORMUL',
       0,
       '-',
       '%Vendedor',
       169,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'FORMUL',
       1,
       '-',
       '%Plano',
       170,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'FORMUL',
       2,
       '-',
       '%Produto',
       176,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'INTPMU',
       0,
       '#',
       'Percentual Corrigido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'INTPMU',
       0,
       '$',
       'Valor',
       23,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'INTPMU',
       0,
       '%',
       'Percentual',
       22,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'INTPMU',
       0,
       '@',
       'Valor Corrigido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'NIVUSU',
       0,
       '-',
       'Administrador',
       163,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'NIVUSU',
       1,
       '-',
       'Operador',
       164,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'NIVUSU',
       2,
       '-',
       'Vendedor',
       165,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'NIVUSU',
       3,
       '-',
       'Guia',
       166,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'RENSOB',
       0,
       'J',
       'Valor com Juros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'RENSOB',
       0,
       'O',
       'Valor Original',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'TIPCOB',
       0,
       'B',
       'Bancria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'TIPCOB',
       0,
       'P',
       'Padro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'TIPPLA',
       0,
       '-',
       'Venda',
       183,
       ' ' FROM DUAL
UNION ALL
SELECT 'PLA ',
       'TIPPLA',
       1,
       '-',
       'Contrato',
       184,
       ' ' FROM DUAL
);

/*-- SEQ 8954 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PLA2',
       0,
       'PLA2',
       'Planos',
       'TT_PLA',
       'F',
       '',
       'TOTALL',
       'Planos',
       '{CODPGT;FILPGT;ATU_EM}',
       '',
       'APEPGT',
       'Plano',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8955 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PLA2','--','' FROM DUAL
UNION ALL
SELECT 'PLA2','01','Identificao' FROM DUAL
);

/*-- SEQ 8956 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PLA2',
       '01',
       20,
       3,
       'CODPGT',
       'A',
       '',
       0,
       0,
       'PLA ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       '9',
       'T',
       'Cdigo',
       'Cdigo do plano de pagamento',
       '',
       'CODPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'PLA2',
       '01',
       40,
       35,
       'DESPGT',
       'A',
       '',
       0,
       0,
       'PLA ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PLA',
       'F',
       'A',
       'T',
       'Descrio',
       'Descrio do plano de pagamento',
       '',
       'DESPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'PLA2',
       '01',
       10,
       3,
       'FILPGT',
       'A',
       '',
       0,
       0,
       'PLA ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PLA',
       'F',
       'N',
       'T',
       'Filial de Origem',
       'Filial onde foi cadastrado o Plano',
       '',
       'FILPGT',
       'F' FROM DUAL
);

/*-- SEQ 8957 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PLAY',
       TO_NUMBER(null),
       'PLAY',
       'Layout Personalizado',
       'TP_LAY',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'PLAY.CODTAB,PLAY.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8958 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PLAY','--','' FROM DUAL
UNION ALL
SELECT 'PLAY','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PLAY','99','Outros' FROM DUAL
);

/*-- SEQ 8959 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5740,
       'ARQ ',
       'PLAY',
       'N ',
       '1 ',
       '',
       '',
       'ARQ.CODTAB = PLAY.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 8960 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PLAY',
       '01',
       10,
       2,
       'CODGRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Codigo do Usuario',
       'Cdigo do grupo',
       '',
       'CODGRU',
       'F' FROM DUAL
UNION ALL
SELECT 'PLAY',
       '01',
       20,
       4,
       'CODTAB',
       'A',
       'DCUS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       'DCUS.CODTAB = CUS.CODTAB',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'PLAY',
       '01',
       30,
       72,
       'DESCPO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Explicacao do Campo',
       'Contem a explicao do que  o campo',
       '',
       'DESCPO',
       'F' FROM DUAL
UNION ALL
SELECT 'PLAY',
       '01',
       40,
       11,
       'NOMCPO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Nome do Campo',
       'Contem o nome do campo no Totali for Windows',
       '',
       'NOMCPO',
       'F' FROM DUAL
UNION ALL
SELECT 'PLAY',
       '01',
       50,
       15,
       'NOMUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Nome de Uso',
       'Nome de usurio',
       '',
       'NOMUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'PLAY',
       '01',
       60,
       2,
       'NUMDEC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'N',
       'F',
       'Casas Decimais',
       'Contem o nmero de casa decimal que o campo possue no Totali for Windows',
       '',
       'NUMDEC',
       'F' FROM DUAL
UNION ALL
SELECT 'PLAY',
       '01',
       70,
       1,
       'PODNUL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Pode Nulo?',
       'Pode Nulo?',
       '',
       'PODNUL',
       'F' FROM DUAL
UNION ALL
SELECT 'PLAY',
       '01',
       80,
       2,
       'SEQUEN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'PLAY',
       '01',
       100,
       1,
       'TIPCPO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Tipo do Campo',
       'Contem o tipo do campo no Totali for Windows',
       '',
       'TIPCPO',
       'T' FROM DUAL
UNION ALL
SELECT 'PLAY',
       '01',
       110,
       1,
       'TIPDAD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Tipo do Dado',
       'Tipo de Dado',
       '',
       'TIPDAD',
       'T' FROM DUAL
UNION ALL
SELECT 'PLAY',
       '01',
       120,
       1,
       'TIPFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Tipo de Filtro',
       'Tipo de Filtro',
       '',
       'TIPFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'PLAY',
       '01',
       130,
       1,
       'TOTALI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Total Alquota?',
       'Total Alquota?',
       '',
       'TOTALI',
       'F' FROM DUAL
);

/*-- SEQ 8961 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'POR ',
       TO_NUMBER(null),
       'POR ',
       'Parcela de Oramento',
       'TT_POR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 8962 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'POR ','--','' FROM DUAL
UNION ALL
SELECT 'POR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'POR ','02','REAL' FROM DUAL
UNION ALL
SELECT 'POR ','03','Data' FROM DUAL
UNION ALL
SELECT 'POR ','99','Outros' FROM DUAL
);

/*-- SEQ 8963 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'POR ',
       '99',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       'POR.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'POR ',
       '03',
       20,
       7,
       'DATORI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data de Origem',
       'Data de Origem',
       '',
       'DATORI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'POR ',
       '03',
       30,
       7,
       'DATVEN',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data de Vencimento',
       'Data de Vencimento',
       '',
       'DATVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'POR ',
       '02',
       40,
       12,
       'JURPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Juros da Parcela',
       'Juros da Parcela',
       '',
       'JURPAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'POR ',
       '99',
       50,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Parcela',
       'Parcela',
       '',
       'NUMPAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'POR ',
       '99',
       60,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero Pedido/OS',
       'Nmero Pedido/OS',
       '',
       'NUMPED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'POR ',
       '99',
       80,
       1,
       'TIPMEI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Tipo do Meio',
       'Tipo do Meio de Pagamento',
       '',
       'TIPMEI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'POR ',
       '99',
       70,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Pedido/OS',
       'Tipo Pedido/OS',
       '',
       'TIPPED',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'POR ',
       '02',
       80,
       12,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Valor da Parcela',
       'Valor da Parcela',
       '',
       'VLRPAR',
       'F',
       'D' FROM DUAL
);

/*-- SEQ 8964 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'POR ',
       'TIPPED',
       0,
       'O',
       'DAV',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'POR ',
       'TIPPED',
       0,
       'P',
       'Pr-Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'POR ',
       'TIPPED',
       0,
       'S',
       'DAV-OS',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8965 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PORC',
       TO_NUMBER(null),
       'PORC',
       'Oramento Personal.',
       'TP_ORC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'PORC.CODFIL,PORC.TIPPED,PORC.NUMPED',
       '' FROM DUAL
);

/*-- SEQ 8966 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PORC','--','' FROM DUAL
UNION ALL
SELECT 'PORC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PORC','99','Outros' FROM DUAL
);

/*-- SEQ 8967 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 32697,
       'ORC ',
       'PORC',
       '1 ',
       '01',
       '',
       '',
       'ORC.CODFIL = PORC.CODFIL(+) and
ORC.TIPPED = PORC.TIPPED(+) and
ORC.NUMPED = PORC.NUMPED(+)',
       '' FROM DUAL
);

/*-- SEQ 8968 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PORC',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Filial do Oramento',
       'Filial do Oramento',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PORC',
       '01',
       20,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Nmero do Oramento',
       'Nmero do Oramento',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'PORC',
       '01',
       30,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Tipo do Oramento',
       'Tipo do Oramento',
       '',
       'TIPPED',
       'F' FROM DUAL
);

/*-- SEQ 8969 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PPR ',
       TO_NUMBER(null),
       'PPR ',
       'Produo Prpria',
       'TT_PPR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'CODFIL, SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8970 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PPR ','--','' FROM DUAL
UNION ALL
SELECT 'PPR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PPR ','99','Outros' FROM DUAL
);

/*-- SEQ 8971 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22848,
       'USU ',
       'PPR ',
       '1',
       '0N',
       '',
       '',
       'PPR.FILUSU = USU.FILUSU AND
PPR.CODUSU = USU.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22849,
       'VIPR',
       'PPR ',
       '1',
       '0N',
       '',
       '',
       'PPR.FILMAT = VIPR.FILMAT AND
PPR.CODMAT = VIPR.CODMAT AND
PPR.CODCOR = VIPR.CODCOR AND
PPR.CODTAM = VIPR.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 8972 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'PPR ',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PPR ',
       '--',
       30,
       5,
       'CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Div. Pro. Produzido',
       'Diviso do Produto Produzido.',
       '',
       'CODCOR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PPR ',
       '--',
       40,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PPR ',
       '--',
       50,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cd. Pro.Produzido',
       'Cdigo do Produto Produzido.',
       '',
       'CODMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PPR ',
       '--',
       60,
       5,
       'CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Sub. Pro. Produzido',
       'Sub-Diviso do Produto Produzido.',
       '',
       'CODTAM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PPR ',
       '--',
       70,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cd. Usu. Produziu',
       'Cdigo do Usurio que Produziu.',
       '',
       'CODUSU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PPR ',
       '--',
       130,
       7,
       'DATFIM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Final da Produo',
       'Data Final da Produo',
       '',
       'DATFIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PPR ',
       '--',
       80,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PPR ',
       '--',
       140,
       7,
       'DATINI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Incio da Produo',
       'Data de Incio da Produo',
       '',
       'DATINI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PPR ',
       '--',
       90,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fil. Prod. Produzido',
       'Filial do Produto Produzido.',
       '',
       'FILMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PPR ',
       '--',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fil. Usu. Produziu',
       'Filial do Usurio que Produziu.',
       '',
       'FILUSU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PPR ',
       '--',
       110,
       12,
       'QTDPRD',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Quantidade Produzida',
       'Quantidade Produzida.',
       '',
       'QTDPRD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PPR ',
       '--',
       120,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PPR ',
       '--',
       150,
       7,
       'ULTPPR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'lt. Data Produzida',
       'ltima Data Produzida na Produo Prpria',
       '',
       'UltimaDataProduzida(PPR.FILMAT, PPR.CODMAT, PPR.CODCOR, PPR.CODTAM)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PPR ',
       '--',
       160,
       12,
       'ULTQTDPPR',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'lt. Qtd. Produzida',
       'ltima Quantidade Produzida na Produo Prpria',
       '',
       'UltimaQuantidadeProduzida(PPR.FILMAT, PPR.CODMAT, PPR.CODCOR, PPR.CODTAM)',
       'F',
       'D' FROM DUAL
);

/*-- SEQ 8973 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PPRO',
       TO_NUMBER(null),
       'PPRO',
       'Produto Personal.',
       'TP_PRO',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'PPRO.FILMAT,PPRO.CODMAT',
       '' FROM DUAL
);

/*-- SEQ 8974 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PPRO','--','' FROM DUAL
UNION ALL
SELECT 'PPRO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PPRO','99','Outros' FROM DUAL
);

/*-- SEQ 8975 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 32698,
       'PRO ',
       'PPRO',
       '1 ',
       '01',
       '',
       '',
       'PRO.FILMAT = PPRO.FILMAT(+) and
PRO.CODMAT = PPRO.CODMAT(+)
',
       '' FROM DUAL
);

/*-- SEQ 8976 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PPRO',
       '01',
       2,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '9',
       'F',
       'Cdigo Material',
       'Cdigo Material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'PPRO',
       '01',
       1,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '0',
       'F',
       'Filial Material',
       'Filial Material',
       '',
       'FILMAT',
       'F' FROM DUAL
);

/*-- SEQ 8977 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PPSU',
       TO_NUMBER(null),
       'PPSU',
       'Publicar Problema',
       'TT_PSU',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'PPSU.CODFIL,PPSU.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8978 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PPSU','--','' FROM DUAL
UNION ALL
SELECT 'PPSU','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PPSU','99','Outros' FROM DUAL
);

/*-- SEQ 8979 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5755,
       'PSU ',
       'PPSU',
       'N ',
       '1 ',
       '',
       '',
       'PSU.CODFIL(+) = PPSU.CODFIL AND
PSU.SEQUEN(+) = PPSU.SEQUEN AND
PSU.MSGPRO(+) = PPSU.MSGPRO AND
PSU.MSGSOL(+) = PPSU.MSGSOL',
       '' FROM DUAL
);

/*-- SEQ 8980 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PPSU',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Codigo da Filial',
       'DFIL.CODFIL = PPSU.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PPSU',
       '01',
       20,
       5,
       'MSGPRO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Mensagem Problema',
       'Mensagem Problema',
       '',
       'MSGPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'PPSU',
       '01',
       30,
       5,
       'MSGSOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Mensagem Soluo',
       'Mensagem Soluo',
       '',
       'MSGSOL',
       'F' FROM DUAL
UNION ALL
SELECT 'PPSU',
       '01',
       40,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 8981 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PRE ',
       0,
       'PRE ',
       'Preos',
       'TT_PRE',
       'T',
       '',
       'TOTALL',
       'Preos',
       '{CODPRE}',
       '',
       '',
       'ProdutoPreos',
       'T',
       '',
       'PRE.FILPRE,PRE.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8982 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PRE ','--','' FROM DUAL
UNION ALL
SELECT 'PRE ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PRE ','02','Datas' FROM DUAL
UNION ALL
SELECT 'PRE ','03','Valores' FROM DUAL
UNION ALL
SELECT 'PRE ','50','Custos Totais (FPV)' FROM DUAL
UNION ALL
SELECT 'PRE ','60','Preos Promocional' FROM DUAL
UNION ALL
SELECT 'PRE ','70','Elasticidade' FROM DUAL
UNION ALL
SELECT 'PRE ','90','Preo Anterior' FROM DUAL
UNION ALL
SELECT 'PRE ','99','Outros' FROM DUAL
);

/*-- SEQ 8983 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 25115,
       'DFIL',
       'PRE ',
       '1',
       'N',
       '',
       '',
       'DFIL.CODFIL = PRE.FILPRE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 25116,
       'TPR ',
       'PRE ',
       '1',
       'N',
       '',
       '',
       'TPR.CODFIL(+) = PRE.FILPRE AND
TPR.CODPRE(+) = PRE.CODPRE',
       '',
       '' FROM DUAL
);

/*-- SEQ 8984 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PRE ',
       '60',
       140,
       3,
       ':CODPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo do Plano',
       'Cdigo do Plano',
       '',
       ':CODPGT',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '90',
       91,
       10,
       ':DATA_PRECO',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Preo Anterior',
       'Data para Preo Anterior',
       '',
       ':DATA_PRECO',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '60',
       150,
       10,
       ':DATA_PROMO',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'D',
       '',
       'Data de Operao',
       'Data de Operao',
       '',
       ':DATA_PROMO',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '60',
       130,
       3,
       ':FILPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       '',
       'Filial do Plano',
       'Filial do Plano',
       '',
       ':FILPGT',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '--',
       160,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Assinatura para PAF-ECF',
       '',
       'ASSINA',
       'F' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '--',
       170,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '01',
       40,
       2,
       'CODCOR',
       'S',
       'DIV ',
       0,
       0,
       'PRE ',
       40,
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       'PRE',
       'F',
       'A',
       'T',
       'Diviso',
       'Diviso do Produto',
       'PRE.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '01',
       30,
       5,
       'CODMAT',
       'A',
       '',
       0,
       0,
       'PRE ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PRE',
       'F',
       '9',
       'F',
       '',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '01',
       60,
       5,
       'CODMOE',
       'S',
       'DMOE',
       0,
       0,
       'PRE ',
       60,
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       'PRE',
       'F',
       'A',
       'T',
       'Moeda',
       'Moeda',
       'PRE.CODMOE = DMOE.CODTAB (+)',
       'CODMOE',
       'T' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '01',
       10,
       2,
       'CODPRE',
       'S',
       'TPR ',
       0,
       0,
       'PRE ',
       10,
       TO_NUMBER(null),
       '',
       'TPR.DESPRE',
       'V',
       'PRE',
       'F',
       'A',
       'T',
       'Tabela de Preos',
       'Cdigo da tabela de preos',
       'TPR.CODFIL = PRE.FILPRE and TPR.CODPRE = PRE.CODPRE',
       'CODPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '01',
       50,
       2,
       'CODTAM',
       'S',
       'SUB ',
       0,
       0,
       'PRE ',
       50,
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       'PRE',
       'F',
       'A',
       'T',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'PRE.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '--',
       180,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Identificao de Acesso',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '99',
       240,
       12,
       'CUSFIN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       '',
       'Custo Final',
       'Custo Final',
       '',
       'COALESCE(PRE.CUSREP,0)+COALESCE(PRE.CUSVEN,0)+COALESCE(PRE.DESFIX,0)',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '50',
       200,
       12,
       'CUSREP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Custo de Reposio',
       'Custo de Reposio na FPV',
       '',
       'CUSREP',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '50',
       210,
       12,
       'CUSVEN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Custo Total de Venda',
       'Custo Total de Venda',
       '',
       'CUSVEN',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '70',
       280,
       10,
       'DATANTELA',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Mudana Preo',
       'Data da Mudana do Preo',
       '',
       'to_date(split_part_null(CALCELASTPRE(PRE.FILPRE, PRE.SEQUEN, PRE.DATINC, PRE.PRECOV, PRE.ULTELA, PRE.DIAELA), '';'', 4), ''DD/MM/YYYY'')',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '02',
       150,
       10,
       'DATINC',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data da Incluso',
       'Data da Incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '50',
       220,
       12,
       'DESFIX',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Despesa Oper Fixa',
       'Despesa Operacional Fixa',
       '',
       'DESFIX',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '03',
       310,
       6,
       'DESIDE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Desconto Ideal',
       '% Desconto Ideal',
       '',
       'DESIDE',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '03',
       12,
       12,
       'DESMAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       '% Desconto Mximo',
       '% Desconto Mximo',
       '',
       'DESMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '70',
       260,
       15,
       'DESULTELA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descr. Elasticidade',
       'Descrio da Elasticidade da ltima Mudana de Preo',
       '',
       '(CASE WHEN PRE.ULTELA = 1 THEN ''Unitria'' WHEN PRE.ULTELA > 1 THEN ''Elstica'' WHEN PRE.ULTELA < 1 THEN ''Inelstica'' ELSE null END)',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '70',
       140,
       4,
       'DIAELA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nm Dias Elastici',
       'Nmero de Dias Considerados na Elasticidade da ltima Mudana de Preo',
       '',
       'DIAELA',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '01',
       20,
       3,
       'FILMAT',
       'A',
       '',
       0,
       0,
       'PRE ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PRE',
       'F',
       'N',
       'F',
       '',
       'Filial do material',
       '',
       'FILMAT',
       'T' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '01',
       90,
       3,
       'FILPRE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       'PRE ',
       90,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'T',
       '',
       'Filial da origem Preo',
       'DFIL.CODFIL = PRE.FILPRE',
       'FILPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '99',
       80,
       1,
       'FLGEST',
       'L',
       '',
       0,
       0,
       'PRE ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'PRE',
       'F',
       '',
       'T',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '50',
       230,
       12,
       'LUCPRJ',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Lucro Projetado',
       'Lucro Projetado',
       '',
       'LUCPRJ',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '99',
       120,
       14,
       'MARKUP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Markup',
       'Markup',
       '',
       'MARKUP',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '03',
       13,
       6,
       'MULTIP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Fator Multiplicao',
       'Fator de multiplicao perante a tabela de varejo',
       '',
       'MULTIP',
       'F' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '03',
       190,
       7,
       'PERLUC',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '% Lucro',
       '% Lucro',
       '',
       'PERLUC',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '50',
       320,
       7,
       'PERLUCPRJ',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Lucro FPV',
       '% Lucro FPV',
       '',
       'PERLUCPRJ',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '50',
       310,
       7,
       'PEROPEFIX',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Desp. Oper. Fix',
       '% Despesas Operacionais Fixas',
       '',
       'PEROPEFIX',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '90',
       90,
       8,
       'PREANT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '',
       '',
       'Preo Anterior',
       'Preo Anterior',
       '',
       'PrecoDia(PRE.FILMAT,PRE.CODMAT,PRE.CODCOR,PRE.CODTAM,:DATA_PRECO,PRE.FILPRE,PRE.CODPRE)',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '70',
       270,
       12,
       'PREANTELA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Preo Anterior',
       'Preo Anterior (para elasticidade)',
       '',
       'Split_Part_Number(CALCELASTPRE(PRE.FILPRE, PRE.SEQUEN, PRE.DATINC, PRE.PRECOV, PRE.ULTELA, PRE.DIAELA), '';'', 3)',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '60',
       120,
       10,
       'PRECOPROMOCIONAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Preo Promocional',
       'Preo Promocional',
       '',
       'PRECOPROMOCIONAL(PRE.FILMAT,PRE.CODMAT,PRE.CODCOR,PRE.CODTAM,:FILPGT,:CODPGT,PRE.FILPRE,PRE.SEQUEN)',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '03',
       70,
       8,
       'PRECOV',
       'F',
       '',
       2,
       0,
       'PRE ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PRE',
       'T',
       'N',
       'T',
       'Preo de Venda',
       'Preo de venda',
       '',
       'PRECOV',
       'F' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '99',
       250,
       12,
       'PREVEN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       '',
       'Preo Venda Calc.',
       'Preo de Venda Calculado',
       '',
       'COALESCE(PRE.CUSREP,0)+COALESCE(PRE.CUSVEN,0)+COALESCE(PRE.DESFIX,0)+COALESCE(PRE.LUCPRJ,0)',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '70',
       300,
       6,
       'QTDVENANT',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Qtd.Vend.Preo Ant.',
       'Quantidade Vendida no Preo Anterior',
       '',
       'Split_Part_Number(CALCELASTPRE(PRE.FILPRE, PRE.SEQUEN, PRE.DATINC, PRE.PRECOV, PRE.ULTELA, PRE.DIAELA), '';'', 6)',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '70',
       290,
       6,
       'QTDVENATU',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Qtd.Vend.Preo Atu.',
       'Quantidade Vendida no Preo Atual',
       '',
       'Split_Part_Number(CALCELASTPRE(PRE.FILPRE, PRE.SEQUEN, PRE.DATINC, PRE.PRECOV, PRE.ULTELA, PRE.DIAELA), '';'', 5)',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '99',
       100,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'PRE ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '70',
       130,
       12,
       'ULTELA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Elasticidade',
       'Elasticidade da ltima Mudana de Preo',
       '',
       'ULTELA',
       '' FROM DUAL
UNION ALL
SELECT 'PRE ',
       '02',
       110,
       8,
       'ULTREA',
       'D',
       '',
       0,
       TO_NUMBER(null),
       'PRE ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'ltimo Reajuste',
       'ltmo Reajuste ',
       '',
       'ULTREA',
       'F' FROM DUAL
);

/*-- SEQ 8985 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PREG',
       TO_NUMBER(null),
       'PREG',
       'Registro Personaliza',
       'TP_REG',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'PREG.CODFIL,PREG.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8986 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PREG','--','' FROM DUAL
UNION ALL
SELECT 'PREG','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PREG','02','Valores' FROM DUAL
UNION ALL
SELECT 'PREG','03','Datas' FROM DUAL
UNION ALL
SELECT 'PREG','99','Outros' FROM DUAL
);

/*-- SEQ 8987 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5760,
       'REG ',
       'PREG',
       '1 ',
       '01',
       '',
       '',
       'REG.CODFIL = PREG.CODFIL(+) and
REG.SEQUEN = PREG.SEQUEN(+)',
       '' FROM DUAL
);

/*-- SEQ 8988 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PREG',
       '--',
       2977,
       2,
       'BASINS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Verso de instalao',
       'Verso da base quando houve(r) a instalao',
       '',
       'BASINS',
       'F' FROM DUAL
UNION ALL
SELECT 'PREG',
       '--',
       2971,
       45,
       'COMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Complemento',
       'Complemento do endereo do cliente',
       '',
       'COMPLE',
       'F' FROM DUAL
UNION ALL
SELECT 'PREG',
       '--',
       2970,
       45,
       'ENDERE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Endereo do Cliente',
       'Endereo do Cliente',
       '',
       'ENDERE',
       'F' FROM DUAL
UNION ALL
SELECT 'PREG',
       '--',
       2955,
       3,
       'FILEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Filial do Cliente',
       'Cdigo da filial na base de dados do cliente',
       '',
       'FILEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'PREG',
       '--',
       2975,
       10,
       'HOMFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Homologao',
       'Homologao da filial do cliente',
       '',
       'HOMFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PREG',
       '--',
       2974,
       10,
       'HOMVER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Upgrade',
       'Chave de upgrade',
       '',
       'HOMVER',
       'F' FROM DUAL
UNION ALL
SELECT 'PREG',
       '--',
       2978,
       7,
       'INICIO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Incio das atividade',
       'Data de incio das atividades do sistema',
       '',
       'INICIO',
       'F' FROM DUAL
UNION ALL
SELECT 'PREG',
       '--',
       2972,
       7,
       'INSTAL',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'F',
       '@',
       'F',
       'Instalao',
       'Data de instalao do sistema',
       '',
       'INSTAL',
       'F' FROM DUAL
UNION ALL
SELECT 'PREG',
       '--',
       2979,
       15,
       'NOMFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Nome da filial',
       'Nome da filial do cliente',
       '',
       'NOMFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PREG',
       '--',
       2968,
       45,
       'RAZSOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Razo Social',
       'Razo Social do cliente',
       '',
       'RAZSOC',
       'F' FROM DUAL
UNION ALL
SELECT 'PREG',
       '--',
       2976,
       2,
       'VERBAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Verso da base',
       'Verso atual da base na filial do cliente',
       '',
       'VERBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'PREG',
       '--',
       2973,
       3,
       'VERSAO',
       'F',
       '',
       1,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'F',
       '9',
       'F',
       'Verso',
       'Verso do sistema adquirido',
       '',
       'VERSAO',
       'F' FROM DUAL
);

/*-- SEQ 8989 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PRJ ',
       TO_NUMBER(null),
       'PRJ ',
       'Projetos (Todos)',
       'TT_PRJ',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'PRJ.CODFIL,PRJ.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 8990 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PRJ ','--','' FROM DUAL
UNION ALL
SELECT 'PRJ ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PRJ ','02','Datas' FROM DUAL
UNION ALL
SELECT 'PRJ ','03','Valores' FROM DUAL
UNION ALL
SELECT 'PRJ ','99','Outros' FROM DUAL
);

/*-- SEQ 8991 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 51008,
       'CLI ',
       'PRJ ',
       '1',
       'N',
       '',
       '',
       'CLI.FILCLI = PRJ.FILCLI AND
CLI.CODCLI = PRJ.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 51009,
       'CON ',
       'PRJ ',
       '1',
       '0N',
       '',
       '',
       'CON.FILCLI = PRJ.FILACT(+) AND CON.CODCLI = PRJ.CODACT(+) AND CON.NUMCON = PRJ.NUMACT(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 51010,
       'WOR ',
       'PRJ ',
       'N',
       '1',
       '',
       '',
       'WOR.FILPRJ = PRJ.CODFIL AND
WOR.SEQPRJ = PRJ.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 51011,
       'USU ',
       'PRJ ',
       '1',
       '0N',
       '',
       '',
       'USU.FILUSU = PRJ.FILUSU AND
USU.CODUSU = PRJ.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 8992 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PRJ ',
       '99',
       120,
       4000,
       'ANEXOS',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Anexos',
       'Anexos',
       '',
       'ANEXOS',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '02',
       70,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '99',
       130,
       4000,
       'AVIEXT',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Aviso Externo',
       'Aviso Externo',
       '',
       'AVIEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '99',
       140,
       4000,
       'AVIINT',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Aviso Interno',
       'Aviso Interno',
       '',
       'AVIINT',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '99',
       150,
       13,
       'CHVPAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave Pai',
       'Chave Pai',
       '',
       'CHVPAI',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '99',
       160,
       13,
       'CHVPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave Projeto',
       'Chave Projeto',
       '',
       'CHVPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       170,
       7,
       'COBRAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cobrana',
       'Cobrana',
       '',
       'COBRAR',
       'T' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       180,
       6,
       'CODACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Contato',
       'Cdigo Contato',
       '',
       'CODACT',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       110,
       3,
       'CODATU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Atualizador',
       'Cdigo de Atualizao',
       'PRJ.FILATU = USU2.FILUSU(+)  AND USU2.CODUSU(+) = PRJ.CODATU',
       'CODATU',
       'T' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       190,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = PRJ.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       90,
       3,
       'CODREG',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo Registro',
       'Cdigo Registro',
       'PRJ.FILREG = USU2.FILUSU AND USU2.CODUSU = PRJ.CODREG',
       'CODREG',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       200,
       3,
       'CODRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Responsvel',
       'Cdigo Responsvel',
       '',
       'CODRES',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       210,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo do Usurio',
       'Cdigo de Usurio',
       'USU2.FILUSU(+) = PRJ.FILUSU AND USU2.CODUSU(+) = PRJ.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '02',
       220,
       7,
       'DATACT',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Aceite',
       'Data Aceite',
       '',
       'DATACT',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '02',
       230,
       7,
       'DATPRO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Projeto',
       'Data Projeto',
       '',
       'DATPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '02',
       60,
       7,
       'DATREG',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Registro',
       'Data Registro',
       '',
       'DATREG',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '02',
       240,
       7,
       'DATSOL',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Solicitao',
       'Data Solicitao',
       '',
       'DATSOL',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       250,
       4000,
       'DOCUME',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       260,
       3,
       'FILACT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial Contato',
       'Filial Contato',
       'DFIL.CODFIL = PRJ.FILACT',
       'FILACT',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       100,
       3,
       'FILATU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Atualizao',
       'Filial de Atualizao',
       '',
       'FILATU',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       270,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       30,
       3,
       'FILPAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Pai',
       '',
       'FILPAI',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       80,
       3,
       'FILREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Registro',
       'Filial Registro',
       '',
       'FILREG',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       280,
       3,
       'FILRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Responsvel',
       '',
       'FILRES',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       290,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '02',
       300,
       7,
       'FIMPRJ',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Fim do Projeto',
       'Fim do Projeto',
       '',
       'FIMPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '99',
       310,
       1,
       'FLGACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Flag do Contato?',
       'Flag do Contato',
       '',
       'FLGACT',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       25,
       4000,
       'HIERARQUIAPROJETO',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Hierarquia Projeto',
       'Hierarquia do Projeto',
       '',
       'RTF2TXT(HIERARQUIAPROJETO(PRJ.CODFIL,PRJ.SEQUEN))',
       '' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       175,
       12,
       'HORASCOBRADASPROJETO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Horas~Cobradas Prj.',
       'Horas~Cobradas Projeto',
       '',
       '(HORASCOBRADASPROJETO(PRJ.CODFIL,PRJ.SEQUEN)/60)',
       '' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '99',
       320,
       10,
       'HORFAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Horas Faltantes',
       'Horas Faltantes',
       '',
       'HORFAL',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '99',
       330,
       10,
       'HORREA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Horas Realizadas',
       'Horas Realizadas',
       '',
       'HORREA',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '02',
       340,
       7,
       'INIPRJ',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Incio do Projeto',
       'Incio do Projeto',
       '',
       'INIPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '99',
       350,
       4000,
       'MSGREQ',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem Requisitos',
       'Mensagem Requisitos',
       '',
       'MSGREQ',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       50,
       25,
       'NOMPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Projeto',
       'Nome do Projeto',
       '',
       'NOMPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '99',
       590,
       1,
       'NOTIFI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Notificar',
       'Notificar por e-mail',
       '',
       'NOTIFI',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       360,
       4,
       'NUMACT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero Contato',
       'Nmero Contato',
       '',
       'NUMACT',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '02',
       580,
       255,
       'PATDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Caminho p/Documentos',
       'Caminho p/Documentos',
       '',
       'PATDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       370,
       1,
       'PRICLI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Prioridade Cliente',
       'Prioridade do Cliente',
       '',
       'PRICLI',
       'T' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       380,
       1,
       'PRIORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Prioridade',
       'Prioridade',
       '',
       'PRIORI',
       'T' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       390,
       1,
       'RESERV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Reservado?',
       'Reservado',
       '',
       'RESERV',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       400,
       1,
       'RESPON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Responsvel',
       'Responsvel',
       '',
       'RESPON',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       410,
       4000,
       'REVISA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Reviso',
       'Reviso',
       '',
       'REVISA',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       40,
       10,
       'SEQPAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Sequenciador Pai',
       '',
       'SEQPAI',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '99',
       550,
       1,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao das Tarefas',
       'Situao das Tarefas',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '03',
       420,
       12,
       'SUBVAZ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Sub vazo',
       'Sub Vazo',
       '',
       'SUBVAZ',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       430,
       1,
       'TIPACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Aceito via:',
       'Tipo de Contato',
       '',
       'TIPACT',
       'T' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '02',
       570,
       3,
       'TIPFUN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Funcionalidade',
       'Tipo Funcionalidade',
       '',
       'TIPFUN',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       440,
       10,
       'TOTA_F',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Em Esperar Cliente',
       'Em Espera pelo Cliente',
       '',
       'TOTA_F',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       450,
       10,
       'TOTA_N',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'No Aceito Cliente',
       'No Aceito pelo Cliente',
       '',
       'TOTA_N',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       460,
       10,
       'TOTA_T',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Aceito pelo Cliente',
       'Aceito pelo Cliente',
       '',
       'TOTA_T',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       470,
       10,
       'TOTW_1',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Revisado e Aprovado',
       'Revisado e Aprovado',
       '',
       'TOTW_1',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       480,
       10,
       'TOTW_2',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Revisado com Erros',
       'Revisado com Erros',
       '',
       'TOTW_2',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       490,
       10,
       'TOTW_A',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Aberto',
       'WorkFlow Aberto',
       '',
       'TOTW_A',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       500,
       10,
       'TOTW_C',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cancelado',
       'WorkFlow Cancelar',
       '',
       'TOTW_C',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       510,
       10,
       'TOTW_E',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Em Espera',
       'WorkFlow Em Espera',
       '',
       'TOTW_E',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       520,
       10,
       'TOTW_I',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'A Integrar',
       'WorkFlow A Integrar',
       '',
       'TOTW_I',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       530,
       10,
       'TOTW_S',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Suspenso',
       'WorkFlow Suspenso',
       '',
       'TOTW_S',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '01',
       540,
       10,
       'TOTW_X',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Executado',
       'WorkFlow Executado',
       '',
       'TOTW_X',
       'F' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       '03',
       560,
       14,
       'VLRCLI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor do Cliente',
       'Valor do Cliente',
       '',
       'VLRCLI',
       'F' FROM DUAL
);

/*-- SEQ 8993 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'PRJ ',
       'FLGACT',
       0,
       'F',
       'Rejeitado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       'FLGACT',
       0,
       'T',
       'Aprovado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       'PRICLI',
       1,
       ' ',
       'Alta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       'PRICLI',
       3,
       ' ',
       'Baixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       'PRICLI',
       0,
       ' ',
       'Imediato',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       'PRICLI',
       2,
       ' ',
       'Mdia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       'PRIORI',
       0,
       ' ',
       'Imediato',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       'PRIORI',
       1,
       ' ',
       'Alta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       'PRIORI',
       2,
       ' ',
       'Mdia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       'PRIORI',
       3,
       ' ',
       'Baixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       'STATUS',
       0,
       'A',
       'A projetar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       'STATUS',
       0,
       'F',
       'Finalizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       'STATUS',
       0,
       'L',
       'Planejado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       'STATUS',
       0,
       'P',
       'Pr-Projeto ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       'TIPACT',
       0,
       'C',
       'Carta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       'TIPACT',
       0,
       'E',
       'E-Mail',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       'TIPACT',
       0,
       'F',
       'Fax',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       'TIPACT',
       0,
       'M',
       'Mensagem Instantneas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       'TIPACT',
       0,
       'S',
       'Site',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       'TIPACT',
       0,
       'T',
       'Telefnico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRJ ',
       'TIPACT',
       0,
       'V',
       'Verbal',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8994 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PRO ',
       0,
       'PRO ',
       'Produtos',
       'TT_PRO',
       'T',
       '',
       'TOTALL',
       'Produtos',
       '{CODMAT};FILMAT;ATU_EM',
       '',
       'DESMAT;ESPMAT',
       'Produto',
       'T',
       '',
       'PRO.FILMAT,PRO.CODMAT
PRO.DESMAT,PRO.ESPMAT
PRO.DESECF
PRO.REFBAS',
       '' FROM DUAL
);

/*-- SEQ 8995 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PRO ','--','' FROM DUAL
UNION ALL
SELECT 'PRO ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PRO ','02','Caracteristcas' FROM DUAL
UNION ALL
SELECT 'PRO ','03','Complementos' FROM DUAL
UNION ALL
SELECT 'PRO ','04','Valores' FROM DUAL
UNION ALL
SELECT 'PRO ','99','Outros' FROM DUAL
);

/*-- SEQ 8996 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21625,
       'CTA ',
       'PRO ',
       '01',
       'N',
       '',
       '',
       'CTA.CODFIL = PRO.FILCTA_COMEST AND
CTA.SEQUEN = PRO.SEQCTA_COMEST AND
CTA.TIPCTA = PRO.TIPCTA_COMEST',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21626,
       'MAR ',
       'PRO ',
       '01',
       'N',
       '',
       '',
       'MAR.FILPAR(+) = PRO.FILMAR and
MAR.CODPAR(+) = PRO.CODMAR
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21627,
       'DNIV',
       'PRO ',
       '01',
       'N',
       '',
       '',
       'PRO.CODNIV = DNIV.CODTAB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21628,
       'PVD ',
       'PRO ',
       'N',
       'N',
       'PXF ',
       '',
       'PVD.FILCLI = PXF.FILFOR and
PVD.CODCLI = PXF.CODFOR and
PXF.FILMAT = PRO.FILMAT and
PXF.CODMAT = PRO.CODMAT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21629,
       'REL ',
       'PRO ',
       '01',
       'N',
       '',
       '',
       'REL.FILPAR(+) = PRO.FILMAR and
REL.CODPAR(+) = PRO.CODMAR and
REL.TIPPAR(+) = PRO.TIPMAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21630,
       'DMON',
       'PRO ',
       '1',
       'N',
       '',
       '',
       'PRO.CODMON = DMON.CODTAB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21631,
       'ANP ',
       'PRO ',
       '1',
       'N',
       '',
       '',
       'PRO.CODANP = ANP.CODANP',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21632,
       'TMAR',
       'PRO ',
       '01',
       'N',
       '',
       '',
       'TMAR.FILMAR(+) = PRO.FILMAR and
TMAR.CODMAR(+) = PRO.CODMAR and
TMAR.ITEMAR(+) = PRO.ITEMAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21633,
       'DRGC',
       'PRO ',
       '1',
       'N',
       '',
       '',
       'PRO.CODRGC = DRGC.CODTAB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21634,
       'CES ',
       'PRO ',
       '01',
       '0N',
       '',
       '',
       'CES.CODCES(+) = PRO.CODCES',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22043,
       'DMDV',
       'PRO ',
       '01',
       'N',
       '',
       '',
       'DMDV.CODTAB(+) = PRO.CODMDV',
       '',
       '' FROM DUAL
);

/*-- SEQ 8997 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'PRO ',
       '99',
       10,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'PRO ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PRO',
       '',
       'N',
       'T',
       'Ano Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(PRO.ATU_EM,''YYYY'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       20,
       4,
       'ANO_DATCAD',
       'A',
       '',
       0,
       0,
       'PRO ',
       150,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PRO',
       '',
       'N',
       'T',
       'Ano de Incluso',
       'Ano de Data do Cadastro',
       '',
       'TO_CHAR(PRO.DATCAD,''YYYY'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '02',
       630,
       1,
       'ARRTRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Arrentonda ou Trunca',
       'Arrentonda ou Trunca?',
       '',
       'ARRTRU',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '--',
       740,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Assinatura para PAF-ECF',
       '',
       'ASSINA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       391,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN PRO.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       30,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'PRO ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PRO',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '--',
       520,
       1,
       'BALSIM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usa Balana?',
       'Usa Balana?',
       '',
       'BALSIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       40,
       2,
       'BRINDE',
       'S',
       '',
       0,
       0,
       'PRO ',
       50,
       30,
       '',
       '',
       'D',
       'PRO',
       'F',
       'A',
       'T',
       'Brinde',
       'Brinde',
       '',
       'BRINDE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '01',
       50,
       8,
       'CHAVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'T',
       'Produto',
       'Filial + Cdigo Interno do Produto',
       '',
       '(PRO.FILMAT||PRO.CODMAT)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '02',
       60,
       2,
       'CLASS1',
       'S',
       'DCL1',
       0,
       6,
       'PRO ',
       20,
       TO_NUMBER(null),
       '',
       'DCL1.CLASS1',
       'V',
       'PRO',
       'F',
       'A',
       'T',
       'Catergoria',
       'Cdigo da classe 1',
       'PRO.CLASS1=DCL1.CODTAB (+)',
       'CLASS1',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '02',
       70,
       2,
       'CLASS2',
       'S',
       'DCL2',
       0,
       7,
       'PRO ',
       30,
       TO_NUMBER(null),
       '',
       'DCL2.CLASS2',
       'V',
       'PRO',
       'F',
       'A',
       'T',
       'SubCategoria',
       'Cdigo da classe 2',
       'PRO.CLASS2=DCL2.CODTAB (+)',
       'CLASS2',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '02',
       80,
       2,
       'CLASS3',
       'S',
       'DCL3',
       0,
       8,
       'PRO ',
       40,
       TO_NUMBER(null),
       '',
       'DCL3.CLASS3',
       'V',
       'PRO',
       'F',
       'A',
       'T',
       'Familia',
       'Cdigo da classe 3',
       'PRO.CLASS3=DCL3.CODTAB (+)',
       'CLASS3',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '02',
       90,
       2,
       'CLASS4',
       'S',
       'DCL4',
       0,
       9,
       'PRO ',
       50,
       TO_NUMBER(null),
       '',
       'DCL4.CLASS4',
       'V',
       'PRO',
       'F',
       'A',
       'T',
       'SubFamilia',
       'Cdigo da classe 4',
       'PRO.CLASS4=DCL4.CODTAB (+)',
       'CLASS4',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       101,
       5,
       'CLSABC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'ABC',
       'Classe ABC',
       '',
       'CLSABC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       100,
       5,
       'CLSXYZ',
       'S',
       '',
       0,
       0,
       'PRO ',
       140,
       30,
       '',
       '',
       'D',
       'PRO',
       'F',
       'A',
       'T',
       'XYZ',
       'Classe XYZ',
       '',
       'CLSXYZ',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       650,
       9,
       'CODANP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Cdigo na ANP',
       'Cdigo na ANP',
       '',
       'CODANP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '--',
       530,
       5,
       'CODCDS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODCDS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       1240,
       7,
       'CODCES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'CEST',
       'CEST',
       '',
       'CODCES',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '01',
       110,
       5,
       'CODCTR',
       'S',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       '',
       'N',
       'F',
       'Unidade de Negcios',
       'Unidade de Negcios',
       'DCTR.CODTAB = PRO.CODCTR',
       'CODCTR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       1250,
       3,
       'CODENQ',
       'S',
       'ENQ ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'ENQ.DESENQ',
       'V',
       '',
       '',
       'N',
       'F',
       'Cd Enquad IPI',
       'Cdigo de Enquadramento Legal do IPI',
       'ENQ.CODENQ(+) = PRO.CODENQ',
       'CODENQ',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '01',
       720,
       2,
       'CODFPS',
       'A',
       'DFPS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFPS.DESFPS',
       'V',
       '',
       '',
       'A',
       '',
       'Finalidade',
       'Finalidade',
       'DFPS.CODFPS=PRO.CODFPS(+)',
       'CODFPS',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       120,
       2,
       'CODGRA',
       'S',
       'DGRA',
       0,
       12,
       'PRO ',
       20,
       TO_NUMBER(null),
       '',
       'DGRA.NOMGRA',
       'V',
       'PRO',
       'F',
       'A',
       'T',
       'Tipo de Grade',
       'Cdigo da grade',
       'PRO.CODGRA=DGRA.CODTAB (+)',
       'CODGRA',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       1200,
       5,
       'CODIMG',
       'G',
       'DIMG',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIMG.DESIMG',
       'V',
       '',
       '',
       'N',
       '',
       'Cdigo imagem grupo',
       'Cdigo da imagem do grupo',
       'DIMG.CODTAB = PRO.CODIMG',
       'CODIMG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '01',
       480,
       5,
       'CODINA',
       'S',
       'DINA',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DINA.DESINA',
       'V',
       '',
       '',
       'N',
       'F',
       'Motivo Inatividade',
       'Cdigo Inatividade',
       'DINA.CODTAB = PRO.CODINA',
       'CODINA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '--',
       540,
       5,
       'CODLPC',
       'S',
       'DLPC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DLPC.DESLPC',
       'V',
       '',
       '',
       'N',
       'F',
       'Lista de Controlados',
       'Lista de Produto Controlado a qual o produto pertence',
       'DLPC.CODTAB = PRO.CODLPC',
       'CODLPC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       130,
       6,
       'CODMAR',
       'A',
       '',
       0,
       11,
       'PRO ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PRO',
       'F',
       'N',
       'F',
       'Cdigo da Marca',
       'Cdigo da Marca deste produto',
       '',
       'CODMAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '01',
       140,
       5,
       'CODMAT',
       'A',
       '',
       0,
       0,
       'PRO ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PRO',
       'F',
       '9',
       'T',
       'Cd.Interno',
       'Cdigo interno do produto',
       '',
       'CODMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       1310,
       5,
       'CODMDV',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cd. Modelo Veic.',
       'Cdigo do Modelo do Vecullo',
       '',
       'CODMDV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '01',
       460,
       5,
       'CODMON',
       'S',
       'DMON',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMON.DESMON',
       'V',
       '',
       '',
       'A',
       'F',
       'Montagem',
       'Cdigo da Montagem',
       'DMON.CODTAB(+) = PRO.CODMON',
       'CODMON',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       1080,
       8,
       'CODNCM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo NCM',
       'Cdigo NCM',
       '',
       'CODNCM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       1180,
       5,
       'CODNIV',
       'S',
       'DNIV',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       'DNIV.DESNIV',
       'V',
       '',
       '',
       'N',
       '',
       'Nvel do Servio',
       'Nvel do Servio',
       'DNIV.CODTAB = PRO.CODNIV',
       'CODNIV',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       970,
       5,
       'CODRGC',
       'S',
       'DRGC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DRGC.DESRGC',
       'V',
       '',
       '',
       'N',
       '',
       'Comercializao',
       'Regras para comercializao',
       'PRO.CODRGC = DRGC.CODTAB',
       'CODRGC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       150,
       2,
       'CODSAZ',
       'S',
       'DSAZ',
       0,
       52,
       'PRO ',
       130,
       TO_NUMBER(null),
       '',
       'DSAZ.DESSAZ',
       'V',
       'PRO',
       'F',
       'A',
       'T',
       'Sazonalidade',
       'Cdigo da sazonalidade',
       'PRO.CODSAZ=DSAZ.CODTAB (+)',
       'CODSAZ',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       671,
       2,
       'CODSITCOF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd. Sit. Trib. COF',
       'Cdigo de Situao Tributria do COFINS',
       '',
       'SITCOF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       691,
       1,
       'CODSITIPI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd. Sit. Trib. IPI',
       'Cdigo Situao Tributria do IPI',
       '',
       'SITIPI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       681,
       2,
       'CODSITPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd. Sit. Trib. PIS',
       'Cdigo de Situao Tributria do PIS',
       '',
       'SITPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '01',
       710,
       4,
       'CODSRV',
       'S',
       'SRV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SRV.DESSRV',
       'V',
       '',
       '',
       'N',
       '',
       'Descrio do Servio',
       'Descrio do Servio',
       'SRV.CODSRV = PRO.CODSRV',
       'CODSRV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '04',
       160,
       2,
       'CODTRI',
       'S',
       'DTRI',
       0,
       50,
       'PRO ',
       60,
       TO_NUMBER(null),
       '',
       'DTRI.CODTRI',
       'V',
       'PRO',
       'F',
       'A',
       'T',
       'Cd. Tributrio',
       'Cdigo de tributao',
       'PRO.CODTRI=DTRI.CODTAB (+)',
       'CODTRI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '--',
       750,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Identificao de Acesso',
       '',
       'CODUID',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       660,
       3,
       'COD_EX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cd. de Exceo IPI',
       'Cdigo de Exceo do IPI',
       '',
       'COD_EX',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       1220,
       1,
       'CONFER',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Conferir na venda?',
       'Conferir na venda?',
       '',
       'CONFER',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '01',
       170,
       1,
       'CONTRA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Produto  contrato?',
       'Determina se produto  do tipo contrato',
       '',
       'CONTRA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '01',
       180,
       1,
       'CONTRO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Controla Produtos?',
       'Produtos Controlados',
       '',
       'CONTRO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       190,
       8,
       'DATCAD',
       'D',
       '',
       0,
       0,
       'PRO ',
       150,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PRO',
       'F',
       'D',
       'T',
       'Incluso em',
       'Data do Cadastro',
       '',
       'DATCAD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       200,
       1,
       'DECIMA',
       'L',
       '',
       0,
       38,
       'PRO ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'PRO',
       'F',
       '',
       'T',
       'Aceita Decimais?',
       'Aceita casas decimais nas transaes (S/N)',
       '',
       'DECIMA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '02',
       210,
       2,
       'DEPART',
       'S',
       'DDEP',
       0,
       11,
       'PRO ',
       90,
       TO_NUMBER(null),
       '',
       'DDEP.DESDEP',
       'V',
       'PRO',
       'F',
       'A',
       'T',
       'Departamento',
       'Departamento do Produto',
       'PRO.DEPART=DDEP.CODTAB (+)',
       'DEPART',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '01',
       1240,
       40,
       'DESCLA',
       'A',
       'CLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'CLA.DESCLA',
       'V',
       '',
       '',
       'A',
       '',
       'Classificao',
       'Descrio da classificao',
       'PRO.FILCLA = CLA.CODFIL(+) AND PRO.SEQCLA = CLA.SEQUEN(+)',
       'DESCLA',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '02',
       760,
       4000,
       'DESDET',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Desc. Detalhe HTML',
       'Descrio Detalhe (em HTML)',
       '',
       'DESDET',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '01',
       220,
       30,
       'DESECF',
       'A',
       '',
       0,
       0,
       'PRO ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PRO',
       'F',
       'A',
       'T',
       'Desc. p/ ECF',
       'Descrio resumida para ECF',
       '',
       'DESECF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '04',
       770,
       5,
       'DESECO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Desconto e-Commerce',
       'Desconto para e-Commerce (%)',
       '',
       'DESECO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '04',
       980,
       5,
       'DESFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Des/Acr Frete Or',
       '% Desc/Acrsc. do Frete para Oramento',
       '',
       'DESFRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '01',
       230,
       30,
       'DESMAT',
       'A',
       '',
       0,
       0,
       'PRO ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PRO',
       'F',
       'A',
       'T',
       'Descrio',
       'Descrio do material',
       '',
       'DESMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '01',
       1090,
       254,
       'DESWEB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio e-Commerce',
       'Descrio para e-Commerce',
       '',
       'DESWEB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '01',
       450,
       1,
       'ENTREG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Entrega?',
       'Entrega?',
       '',
       'ENTREG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '01',
       240,
       30,
       'ESPMAT',
       'A',
       '',
       0,
       0,
       'PRO ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PRO',
       'F',
       'A',
       'T',
       'Especificao',
       'Especificao do material',
       '',
       'ESPMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       1230,
       1,
       'ESTCHE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Estoque no CK4G ',
       'Controle de Estoque no Checkout 4G',
       '',
       'ESTCHE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       250,
       2,
       'ETIQUE',
       'S',
       'DETI',
       0,
       44,
       'PRO ',
       110,
       TO_NUMBER(null),
       '',
       'DETI.DESETI',
       'V',
       'PRO',
       'F',
       'A',
       'T',
       'Etiqueta',
       'Tipo de etiqueta',
       'PRO.ETIQUE=DETI.CODTAB (+)',
       'ETIQUE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '--',
       550,
       3,
       'FILCLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILCLA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '--',
       1100,
       3,
       'FILCTA_COMEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILCTA_COMEST',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '--',
       1110,
       3,
       'FILCTA_VENEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILCTA_VENEST',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       1320,
       3,
       'FILFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Filial de Fat.',
       'Filial de Faturamento para Vendas Conjuntas',
       '',
       'FILFAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '01',
       1160,
       3,
       'FILIFO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       '',
       'Filial Imp. Fornec. Padro (No Utilizada)',
       '',
       'FILIFO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       260,
       3,
       'FILMAR',
       'A',
       '',
       0,
       0,
       'PRO ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PRO',
       'F',
       'N',
       'F',
       '',
       'Filial da Marca do material',
       '',
       'FILMAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '01',
       270,
       3,
       'FILMAT',
       'A',
       'DFIL',
       0,
       0,
       'PRO ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'PRO',
       'F',
       'N',
       'T',
       'Filial',
       'Filial onde foi cadastrado o material',
       'PRO.FILMAT = DFIL.CODFIL (+)',
       'FILMAT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       570,
       1,
       'FLGSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Servio',
       'Tipo de Servio',
       '',
       'FLGSER',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       1290,
       1,
       'FOR060',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'CST60 emp substituta',
       'Forar substitudo (60) mesmo para empresa substituta',
       '',
       'FOR060',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       620,
       1,
       'ICMFED',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'ICMS Subst. no Pas?',
       'ICMS Substitudo em todo o pas?',
       '',
       'ICMFED',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '02',
       640,
       1,
       'IIPTPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Produo Prp ou Ter',
       'Produo Prpria ou de Terceiro?',
       '',
       'IIPTPR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       700,
       1,
       'IMPKIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Imp. Itens Kit NF?',
       'Imprimir Itens de Kit na NF/CF?',
       '',
       'IMPKIT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       610,
       1,
       'ISEPIS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Isento de Pis/Cofins',
       'Isento de Pis/Cofins',
       '',
       'ISEPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '01',
       280,
       4,
       'ITEMAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Item da Marca(Seq.)',
       'Item da Marca(Sequenciador)',
       '',
       'ITEMAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       1190,
       1,
       'LOTONL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Lote DNA',
       'Lote Individualizado (DNA)',
       '',
       'LOTONL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       290,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'PRO ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PRO',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(PRO.ATU_EM,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       300,
       2,
       'MES_DATCAD',
       'A',
       '',
       0,
       0,
       'PRO ',
       150,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PRO',
       '',
       'N',
       'T',
       'Ms de Incluso em',
       'Ms de Data do Cadastro',
       '',
       'TO_CHAR(PRO.DATCAD,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       310,
       1,
       'MONTAR',
       'A',
       '',
       0,
       0,
       'PRO ',
       40,
       30,
       '',
       '',
       'D',
       'PRO',
       'F',
       'A',
       'T',
       'Tipo~Montagem',
       'Tipo Montagem',
       '',
       'MONTAR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       830,
       2,
       'NATBCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       '',
       '(Coluna no mais utilizada)',
       '',
       'NATBCC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '02',
       320,
       255,
       'NOMIMG',
       'A',
       '',
       0,
       0,
       'PRO ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PRO',
       'F',
       'A',
       'T',
       'Imagem',
       'Imagem do produto',
       '',
       'NOMIMG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       330,
       0,
       'NUMEXT',
       'L',
       '',
       0,
       0,
       'PRO ',
       160,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'PRO',
       'F',
       '',
       'T',
       'Usa Nm. Externo?',
       'Nmero externo na Ordem de Servio',
       '',
       'NUMEXT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       340,
       2,
       'NUMITE',
       'S',
       '',
       0,
       0,
       'PRO ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PRO',
       'F',
       '',
       'F',
       'Nm. Itens Kits',
       'Nmero de itens de um kit',
       '',
       'NUMITE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       1210,
       1,
       'OBIMEI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Obriga IMEI?',
       'Obriga IMEI no Servio Adicional?',
       '',
       'OBIMEI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       350,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'PRO ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PRO',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(PRO.OBSERV)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       960,
       254,
       'OBSMPB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Obs. p/ MP do BEM',
       'Observao Legal para MP do BEM',
       '',
       'OBSMPB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '--',
       730,
       1,
       'ORIPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem do Produto',
       'Origem do Produto',
       '',
       'ORIPRO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '04',
       500,
       5,
       'PERSER',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% sobre~Preo Venda',
       'Percentual sobre o preo de venda do produto a ser montado',
       '',
       'PERSER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       1280,
       5,
       'PER_II',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Imposto Importao',
       '% de Imposto sobre Importao',
       '',
       'PER_II',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       1300,
       1,
       'PROCON',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Produto Controlado?',
       'Produto Controlado pela Polcia Federal',
       '',
       'PROCON',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '01',
       360,
       15,
       'REFBAS',
       'A',
       '',
       0,
       0,
       'PRO ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PRO',
       'F',
       'A',
       'T',
       'Ref. Bsica',
       'Referncia Bsica do Produto',
       '',
       'REFBAS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       370,
       2,
       'RESIPI',
       'S',
       'DIPI',
       0,
       40,
       'PRO ',
       80,
       TO_NUMBER(null),
       '',
       'TO_CHAR(DIPI.RESIPI)',
       'V',
       'PRO',
       'F',
       '9',
       'T',
       '% IPI',
       'Alquota do IPI',
       'PRO.RESIPI = DIPI.CODTAB (+)',
       'RESIPI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       380,
       2,
       'RESIRR',
       'S',
       'DIRR',
       0,
       42,
       'PRO ',
       100,
       TO_NUMBER(null),
       '',
       'TO_CHAR(DIRR.RESIRR)',
       'V',
       'PRO',
       'F',
       '9',
       'T',
       '% IR',
       'Alquota do Imposto de Renda',
       'PRO.RESIRR = DIRR.CODTAB (+)',
       'RESIRR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       470,
       1,
       'RETCOF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Reteno de COFINS?',
       'Permite Reteno de COFINS?',
       '',
       'RETCOF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '--',
       560,
       10,
       'SEQCLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQCLA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '--',
       1120,
       10,
       'SEQCTA_COMEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQCTA_COMEST',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '--',
       1130,
       10,
       'SEQCTA_VENEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQCTA_VENEST',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '01',
       1170,
       10,
       'SEQIFO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       '',
       'Seq Imp. Fornec. Padro (No Utilizada)',
       '',
       'SEQIFO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       390,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'PRO ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PRO',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN PRO.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       670,
       2,
       'SITCOF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       '',
       'Sit. Trib. COF',
       'Situao Tributria do COFINS',
       '',
       'SITCOF',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       1140,
       2,
       'SITCOFCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'CST COFINS Compra',
       'Cdigo de Situao Tributria do COFINS para Compra',
       '',
       'SITCOFCOM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       690,
       1,
       'SITIPI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Sit. Trib. IPI',
       'Situao Tributria do IPI',
       '',
       'SITIPI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       680,
       2,
       'SITPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Sit. Trib. PIS',
       'Situao Tributria do PIS',
       '',
       'SITPIS',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       1150,
       2,
       'SITPISCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'CST PIS para Compra',
       'Cdigo de Situao Tributria do PIS para Compra',
       '',
       'SITPISCOM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       490,
       1,
       'SUBFED',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Substitudo Federal',
       'Substitudo Federal',
       '',
       'SUBFED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '04',
       990,
       5,
       'SUBFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Subsdio p/ Frete',
       '% Subsdio para Frete',
       '',
       'SUBFRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       510,
       1,
       'SUGSER',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Sugere~na montagem?',
       'Sugerido na montagem de um produto?',
       '',
       'SUGSER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '--',
       580,
       254,
       'TERASS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Termos Associados',
       'Termos Associados',
       '',
       'TERASS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '--',
       1160,
       1,
       'TIPCTA_COMEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPCTA_COMEST',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '--',
       1170,
       1,
       'TIPCTA_VENEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPCTA_VENEST',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       600,
       1,
       'TIPDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo de Documento',
       'Tipo de Documento',
       '',
       'TIPDOC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '01',
       400,
       1,
       'TIPMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'PRO ',
       10,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Marca',
       'Tipo Marca',
       '',
       'TIPMAR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       910,
       1,
       'TIPMPB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo para MPB',
       'Tipo para Tratamento em MP do Bem',
       '',
       'TIPMPB',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '02',
       410,
       2,
       'TIPPRO',
       'S',
       '',
       0,
       43,
       'PRO ',
       10,
       30,
       '',
       '',
       'D',
       'PRO',
       'F',
       'A',
       'T',
       'Tipo de Produto',
       'Tipo de Produto',
       '',
       'TIPPRO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       420,
       2,
       'UNIDAD',
       'S',
       'DMED',
       0,
       0,
       'PRO ',
       10,
       TO_NUMBER(null),
       '',
       'DMED.UNIMED',
       'V',
       'PRO',
       'F',
       'A',
       'T',
       'Unidade Venda',
       'Unidade Venda (medida utilizada  - Kg, l, m, etc.)',
       'PRO.UNIDAD=DMED.CODTAB (+)',
       'UNIDAD',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       430,
       2,
       'UNIFOR',
       'S',
       'DMED',
       0,
       0,
       'PRO ',
       20,
       TO_NUMBER(null),
       '',
       'DMED.UNIMED',
       'V',
       'PRO',
       'F',
       'A',
       'T',
       'Unidade Compra',
       'Unidade Compra (medida utilizada pelo fornecedor)',
       'PRO.UNIFOR=DMED.CODTAB (+)',
       'UNIFOR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '02',
       1070,
       1,
       'USALOT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Usa lote?',
       'Usa lote?',
       '',
       'USALOT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '03',
       440,
       8,
       'VALCON',
       'F',
       '',
       2,
       0,
       'PRO ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PRO',
       'T',
       '',
       'T',
       'Converso Unidades',
       'Valor de converso entre as unidades de Venda/Compra',
       '',
       'VALCON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '01',
       590,
       1,
       'VALEST',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Valida Estoque?',
       'Valida Estoque?',
       '',
       'VALEST',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '04',
       930,
       6,
       'VENCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '% de COFINS Venda',
       '% de COFINS para Venda',
       '',
       'VENCOF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       1270,
       6,
       'VENCOFIMP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% COFINS Importao',
       '% COFINS na Importao',
       '',
       'VENCOFIMP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '04',
       920,
       6,
       'VENPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '% de PIS Venda',
       '% de PIS para Venda',
       '',
       'VENPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '99',
       1260,
       6,
       'VENPISIMP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% PIS Importao',
       '% PIS na Importao',
       '',
       'VENPISIMP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '04',
       810,
       15,
       'VLRCOF',
       'F',
       '',
       5,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Alq. COFINS por vlr',
       'Alquota de COFINS por valor',
       '',
       'VLRCOF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'PRO ',
       '04',
       820,
       15,
       'VLRPIS',
       'F',
       '',
       5,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Alq. de PIS por vlr',
       'Alquota de PIS por valor',
       '',
       'VLRPIS',
       'F',
       'D' FROM DUAL
);

/*-- SEQ 8998 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'PRO ',
       'ARRTRU',
       0,
       'A',
       'Arredondamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'ARRTRU',
       0,
       'T',
       'Truncamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'BRINDE',
       1,
       '-',
       'Pode ser Brinde',
       193,
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'BRINDE',
       0,
       '-',
       'Nao  Brinde',
       192,
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'BRINDE',
       2,
       '-',
       ' Brinde',
       194,
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'CLSABC',
       0,
       ' ',
       'A',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'CLSABC',
       1,
       ' ',
       'B',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'CLSABC',
       2,
       ' ',
       'C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'CLSXYZ',
       2,
       '-',
       'Z',
       191,
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'CLSXYZ',
       1,
       '-',
       'Y',
       190,
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'CLSXYZ',
       0,
       '-',
       'X',
       189,
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'ESTCHE',
       0,
       ' ',
       'S on-line',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'ESTCHE',
       1,
       ' ',
       'Replicado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'ESTCHE',
       9,
       ' ',
       'No controla',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'FLGSER',
       0,
       'B',
       'Cobertura',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'FLGSER',
       0,
       'C',
       'Contrato',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'FLGSER',
       0,
       'E',
       'Equipamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'IIPTPR',
       0,
       'P',
       'p/ merc manufat pelo prop cont',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'IIPTPR',
       0,
       'T',
       'p/ merc manufat de terceiros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'MONTAR',
       0,
       'F',
       'Sem Montagem',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'MONTAR',
       0,
       'I',
       'Montagem Interna',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'MONTAR',
       0,
       'T',
       'Montagem na Entrega',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'NATBCC',
       0,
       ' ',
       'Aquisio de bens para revenda',
       TO_NUMBER(null),
       '01' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'NATBCC',
       0,
       ' ',
       'Aquisio bens util. c/ insumo',
       TO_NUMBER(null),
       '02' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'NATBCC',
       0,
       ' ',
       'Aquisio serv. util. insumo',
       TO_NUMBER(null),
       '03' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'NATBCC',
       0,
       ' ',
       'Energia eltrica e trmica',
       TO_NUMBER(null),
       '04' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'NATBCC',
       0,
       ' ',
       'Aluguis de prdios',
       TO_NUMBER(null),
       '05' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'NATBCC',
       0,
       ' ',
       'Aluguis de mquinas e equip.',
       TO_NUMBER(null),
       '06' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'NATBCC',
       0,
       ' ',
       'Armazenagem mercadoria e frete',
       TO_NUMBER(null),
       '07' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'NATBCC',
       0,
       ' ',
       'Contraprestaes mercatil',
       TO_NUMBER(null),
       '08' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'NATBCC',
       0,
       ' ',
       'Crd. s/ encargos depreciao',
       TO_NUMBER(null),
       '09' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'NATBCC',
       0,
       ' ',
       'Crd. c/ base valor aquisio',
       TO_NUMBER(null),
       '10' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'NATBCC',
       0,
       ' ',
       'Amort. deprec. edific. imveis',
       TO_NUMBER(null),
       '11' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'NATBCC',
       0,
       ' ',
       'Dev. de vendas suj. Incidncia',
       TO_NUMBER(null),
       '12' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'NATBCC',
       0,
       ' ',
       'Outras Operaes direito crd.',
       TO_NUMBER(null),
       '13' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'NATBCC',
       0,
       ' ',
       'Atividade Transporte de Cargas',
       TO_NUMBER(null),
       '14' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'NATBCC',
       0,
       ' ',
       'Custo de Unidade Imobiliria',
       TO_NUMBER(null),
       '15' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'NATBCC',
       0,
       ' ',
       'Custo unidade no concluda',
       TO_NUMBER(null),
       '16' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'NATBCC',
       0,
       ' ',
       'Atividade de Prestao de Serv',
       TO_NUMBER(null),
       '17' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'NATBCC',
       0,
       ' ',
       'Estoque de abertura de bens',
       TO_NUMBER(null),
       '18' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'ORIPRO',
       0,
       '0',
       'Nacional, exceto cd.3,4,5,8',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'ORIPRO',
       0,
       '1',
       'Estrang., Import.Dir., Exc.6',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'ORIPRO',
       0,
       '2',
       'Estrang., Adq.Int., Exc.7',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'ORIPRO',
       0,
       '3',
       'Nacional, Cont.Import.>40%<70%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'ORIPRO',
       0,
       '4',
       'Nacional, Conf.Proc.Prod.Bs.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'ORIPRO',
       0,
       '5',
       'Nacional, Cont.Import <= 40%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'ORIPRO',
       0,
       '6',
       'Estrang., Import.Dir.CAMEX-GNL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'ORIPRO',
       0,
       '7',
       'Estrang., Adq.Int. CAMEX-GNL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'ORIPRO',
       0,
       '8',
       'Nacional, Import. > a 70%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOF',
       0,
       ' ',
       'Tributvel (base de clculo)',
       TO_NUMBER(null),
       '01' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOF',
       0,
       ' ',
       'Ope. Trib. Alq. Diferenciada',
       TO_NUMBER(null),
       '02' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOF',
       0,
       ' ',
       'Ope. Trib. Alq Und Med.Pro',
       TO_NUMBER(null),
       '03' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOF',
       0,
       ' ',
       'Ope. Trib. Monofsica Rev.Alq',
       TO_NUMBER(null),
       '04' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOF',
       0,
       ' ',
       'Ope. Trib. Substituio Trib.',
       TO_NUMBER(null),
       '05' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOF',
       0,
       ' ',
       'Tributvel (alquota zero) ',
       TO_NUMBER(null),
       '06' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOF',
       0,
       ' ',
       'Isenta da Contribuio',
       TO_NUMBER(null),
       '07' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOF',
       0,
       ' ',
       'Sem Incidncia da Contribuio',
       TO_NUMBER(null),
       '08' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOF',
       0,
       ' ',
       'Com Suspenso da Contribuio',
       TO_NUMBER(null),
       '09' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOF',
       0,
       ' ',
       'Outras Operaes de Sada',
       TO_NUMBER(null),
       '49' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOF',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Trib Export',
       TO_NUMBER(null),
       '64' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis NTrib Export',
       TO_NUMBER(null),
       '65' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Trib NTrib Exp',
       TO_NUMBER(null),
       '66' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Outras Operaes',
       TO_NUMBER(null),
       '67' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio sem Dir Crdito',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio com Iseno',
       TO_NUMBER(null),
       '71' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio com Suspenso',
       TO_NUMBER(null),
       '72' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio a Alquota Zero',
       TO_NUMBER(null),
       '73' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio sem Inc Contrib',
       TO_NUMBER(null),
       '74' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio por ST',
       TO_NUMBER(null),
       '75' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Outras Operaes de Entrada',
       TO_NUMBER(null),
       '98' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Tributada',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-No Tributada',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Exportao',
       TO_NUMBER(null),
       '52' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Vinc Trib Export',
       TO_NUMBER(null),
       '54' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Vinc NTrib Export',
       TO_NUMBER(null),
       '55' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib Exp',
       TO_NUMBER(null),
       '56' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Exc Trib',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Exc NTrib',
       TO_NUMBER(null),
       '61' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Exc Export',
       TO_NUMBER(null),
       '62' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Trib NTrib',
       TO_NUMBER(null),
       '63' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITIPI',
       0,
       '0',
       'Tributada',
       TO_NUMBER(null),
       '0' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITIPI',
       0,
       '1',
       'Tributada com alquota zero',
       TO_NUMBER(null),
       '1' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITIPI',
       0,
       '2',
       'Isenta',
       TO_NUMBER(null),
       '2' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITIPI',
       0,
       '3',
       'No-tributada',
       TO_NUMBER(null),
       '3' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITIPI',
       0,
       '4',
       'Imune',
       TO_NUMBER(null),
       '4' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITIPI',
       0,
       '5',
       'Com suspenso',
       TO_NUMBER(null),
       '5' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITIPI',
       0,
       '9',
       'Outras',
       TO_NUMBER(null),
       '9' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPIS',
       0,
       ' ',
       'Tributvel (base de clculo)',
       TO_NUMBER(null),
       '01' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPIS',
       0,
       ' ',
       'Ope. Trib. Alq. Diferenciada',
       TO_NUMBER(null),
       '02' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPIS',
       0,
       ' ',
       'Ope. Trib. Alq Und Med.Pro',
       TO_NUMBER(null),
       '03' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPIS',
       0,
       ' ',
       'Ope. Trib. Monofsica Rev.Alq',
       TO_NUMBER(null),
       '04' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPIS',
       0,
       ' ',
       'Ope. Trib. Substituio Trib.',
       TO_NUMBER(null),
       '05' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPIS',
       0,
       ' ',
       'Tributvel (alquota zero)',
       TO_NUMBER(null),
       '06' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPIS',
       0,
       ' ',
       'Isenta da Contribuio ',
       TO_NUMBER(null),
       '07' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPIS',
       0,
       ' ',
       'Sem Incidncia da Contribuio',
       TO_NUMBER(null),
       '08' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPIS',
       0,
       ' ',
       'Com Suspenso da Contribuio ',
       TO_NUMBER(null),
       '09' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPIS',
       0,
       ' ',
       'Outras Operaes de Sada',
       TO_NUMBER(null),
       '49' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPIS',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Trib Export',
       TO_NUMBER(null),
       '64' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis NTrib Export',
       TO_NUMBER(null),
       '65' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Trib NTrib Exp',
       TO_NUMBER(null),
       '66' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Outras Operaes',
       TO_NUMBER(null),
       '67' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio sem Dir Crdito',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio com Iseno',
       TO_NUMBER(null),
       '71' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio com Suspenso',
       TO_NUMBER(null),
       '72' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio a Alquota Zero',
       TO_NUMBER(null),
       '73' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio sem Inc Contrib',
       TO_NUMBER(null),
       '74' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio por ST',
       TO_NUMBER(null),
       '75' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Outras Operaes de Entrada',
       TO_NUMBER(null),
       '98' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Tributada',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-No Tributada',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Exportao',
       TO_NUMBER(null),
       '52' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Vinc Trib Export',
       TO_NUMBER(null),
       '54' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Vinc NTrib Export',
       TO_NUMBER(null),
       '55' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib Exp',
       TO_NUMBER(null),
       '56' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Exc Trib',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Exc NTrib',
       TO_NUMBER(null),
       '61' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Exc Export',
       TO_NUMBER(null),
       '62' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Trib NTrib',
       TO_NUMBER(null),
       '63' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'TIPDOC',
       0,
       'A',
       'CF e NF',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'TIPDOC',
       0,
       'C',
       'CF',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'TIPDOC',
       0,
       'F',
       'NF',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'TIPDOC',
       0,
       'N',
       'No Informado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'TIPMAR',
       0,
       'M',
       'Marca',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'TIPMPB',
       0,
       'A',
       'All in One',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'TIPMPB',
       0,
       'C',
       'Conj. CPU, Monitor e Mouse',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'TIPMPB',
       0,
       'D',
       'Modem',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'TIPMPB',
       0,
       'E',
       'Teclado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'TIPMPB',
       0,
       'M',
       'Monitor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'TIPMPB',
       0,
       'N',
       'Notebooks',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'TIPMPB',
       0,
       'O',
       'Mouse',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'TIPMPB',
       0,
       'R',
       'Roteadores',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'TIPMPB',
       0,
       'S',
       'Smartphones',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'TIPMPB',
       0,
       'T',
       'Tablet',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'TIPMPB',
       0,
       'U',
       'CPU',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'TIPPRO',
       2,
       ' ',
       'Terceirizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'TIPPRO',
       0,
       ' ',
       'Material',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PRO ',
       'TIPPRO',
       1,
       ' ',
       'Servio',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 8999 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PSU ',
       TO_NUMBER(null),
       'PSU ',
       'Publicar Suporte',
       'TT_PSU',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'PSU.CODFIL,PSU.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9000 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PSU ','--','' FROM DUAL
UNION ALL
SELECT 'PSU ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PSU ','99','Outros' FROM DUAL
);

/*-- SEQ 9001 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PSU ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Codigo da Filial',
       'DFIL.CODFIL = PSU.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PSU ',
       '01',
       50,
       5,
       'MSGPRO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Mensagem Problema',
       'Mensagem Problema',
       '',
       'MSGPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'PSU ',
       '01',
       30,
       5,
       'MSGSOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Mensagem Soluo',
       'Mensagem Soluo',
       '',
       'MSGSOL',
       'F' FROM DUAL
UNION ALL
SELECT 'PSU ',
       '01',
       40,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 9002 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PSUP',
       TO_NUMBER(null),
       'PSUP',
       'Suporte Personaliza.',
       'TP_SUP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'PSUP.CODFIL,PSUP.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9003 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PSUP','--','' FROM DUAL
UNION ALL
SELECT 'PSUP','01','Identificao' FROM DUAL
);

/*-- SEQ 9004 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 32713,
       'SUP ',
       'PSUP',
       '1 ',
       'N ',
       '',
       '',
       'SUP.CODFIL = PSUP.CODFIL AND
SUP.SEQUEN = PSUP.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9005 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PSUP',
       '--',
       2943,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '0',
       'F',
       'Filial Suporte',
       'Filial Suporte',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PSUP',
       '--',
       2953,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '9',
       'F',
       'Cdigo Suporte',
       'Cdigo Suporte',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 9006 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PTC ',
       TO_NUMBER(null),
       'PTC ',
       'Prot. Convnio(ICMS)',
       'TT_PTC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'PTC.CODFIL,
PTC.SEQUEN, 
PTC.DESPTC',
       '' FROM DUAL
);

/*-- SEQ 9007 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PTC ','--','' FROM DUAL
UNION ALL
SELECT 'PTC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PTC ','99','Outros' FROM DUAL
);

/*-- SEQ 9008 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PTC ',
       '--',
       10,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Data~Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'PTC ',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'PTC.CODFIL = DFIL.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PTC ',
       '--',
       30,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'PTC ',
       '--',
       40,
       40,
       'DESPTC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Desc. Prot. e Conv. ',
       'Descrio da tabela de Protocolos e Convnios',
       '',
       'DESPTC',
       'F' FROM DUAL
UNION ALL
SELECT 'PTC ',
       '--',
       50,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'PTC ',
       '--',
       60,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN PTC.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'PTC ',
       '--',
       61,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN PTC.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'PTC ',
       '--',
       70,
       1,
       'TIPPTC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo (P-Potocolo / C-Convnio / O-Outros)',
       '',
       'TIPPTC',
       'T' FROM DUAL
);

/*-- SEQ 9009 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'PTC ',
       'TIPPTC',
       0,
       'C',
       'Convnio ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PTC ',
       'TIPPTC',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PTC ',
       'TIPPTC',
       0,
       'P',
       'Protocolo',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9010 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PTR ',
       TO_NUMBER(null),
       'PTR ',
       '_Parcela Tt. Recebe',
       'TT_PTR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'PTR.CODFIL,PTR.SEQUEN,PTR.NUMPAR,PTR.SUPPAR',
       '' FROM DUAL
);

/*-- SEQ 9011 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PTR ','--','' FROM DUAL
UNION ALL
SELECT 'PTR ','80','Data Valor Corrigido' FROM DUAL
);

/*-- SEQ 9012 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 30073,
       'USU ',
       'PTR ',
       'N',
       '1',
       '',
       '',
       'USU.FILUSU = PTR.FILUSU AND
USU.CODUSU = PTR.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30074,
       'TRC ',
       'PTR ',
       'N',
       '1',
       '',
       '',
       'PTR.CODFIL = TRC.CODFIL AND
PTR.SEQUEN = TRC.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30075,
       'CTA ',
       'PTR ',
       'N',
       '1',
       '',
       '',
       'CTA.CODFIL = PTR.FILCTA AND
CTA.SEQUEN = PTR.SEQCTA AND
CTA.TIPCTA = PTR.TIPCTA',
       '',
       '' FROM DUAL
);

/*-- SEQ 9013 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PTR ',
       '80',
       22,
       8,
       ':VLRCOR_DATINI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Inicial',
       '',
       '',
       ':VLRCOR_DATINI',
       '' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '--',
       23,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN PTR.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '--',
       8,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '--',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = PTR.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '--',
       12,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo Usurio',
       'PTR.FILUSU = USU.FILUSU(+)  AND USU.CODUSU(+) = PTR.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '--',
       24,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '--',
       7,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '--',
       16,
       7,
       'DATPRX',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Prximo Vencto',
       'Data do Prximo Vencimento',
       '',
       'DATPRX',
       'F' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '--',
       6,
       8,
       'DATVEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Vencimento',
       'Data de Vencimento',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '--',
       20,
       1,
       'DUMMY',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       '',
       'Dummy',
       '',
       'DUMMY',
       'F' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '--',
       17,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '--',
       11,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '--',
       5,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '--',
       3,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Parcela',
       'Nmero da parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '--',
       18,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Chave de Contas',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '--',
       14,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN PTR.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '--',
       4,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Sub-Parcela',
       'Nmero da sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '--',
       19,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '80',
       21,
       12,
       'VLRCOR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Corrigido',
       'Valor Corrigido',
       '',
       'CALCPTRATU(PTR.CODFIL,PTR.SEQUEN,PTR.NUMPAR,PTR.SUBPAR,0,:VLRCOR_DATINI)',
       '' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '--',
       13,
       10,
       'VLRDES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr Desconto',
       'Valor Desconto',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '--',
       15,
       10,
       'VLRDIF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr Diferena',
       'Valor Diferena',
       '',
       'VLRDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '--',
       10,
       10,
       'VLRPAR',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr Parcela',
       'Valor da Parcel',
       '',
       'VLRPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'PTR ',
       '--',
       9,
       10,
       'VLRPGT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr Pago',
       'Valor Pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9014 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'PTR ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PTR ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PTR ',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PTR ',
       'FLGEST',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PTR ',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PTR ',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PTR ',
       'TIPCTA',
       0,
       'N',
       'Destopia',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9015 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PVD ',
       0,
       'PVD ',
       'Parceiros Especiais',
       'TV_PVD',
       'T',
       '',
       'TOTALL',
       'Provedores',
       '',
       '',
       '',
       '',
       'F',
       '',
       'PVD.FILCLI,PVD.CODCLI
PVD.NOMCLI,PVD.ULTNOM
PVD.NUMDOC
',
       '' FROM DUAL
);

/*-- SEQ 9016 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PVD ','--','' FROM DUAL
UNION ALL
SELECT 'PVD ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PVD ','02','Endereo' FROM DUAL
UNION ALL
SELECT 'PVD ','03','Documentao' FROM DUAL
UNION ALL
SELECT 'PVD ','04','Dados Financeiros' FROM DUAL
UNION ALL
SELECT 'PVD ','99','Outros' FROM DUAL
);

/*-- SEQ 9017 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 32471,
       'SPC ',
       'PVD ',
       '01',
       '01',
       '',
       'PVD.FLGTIP = 1',
       'SPC.FILCLI = PVD.FILCLI (+) and
SPC.CODCLI = PVD.CODCLI (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 32472,
       'EDE ',
       'PVD ',
       'N',
       '1',
       '',
       '',
       'EDE.FILCLI = PVD.FILCLI AND
EDE.CODCLI = PVD.CODCLI
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 32473,
       'PXF ',
       'PVD ',
       '0N',
       '1',
       '',
       '',
       'PVD.FILPAR = PXF.FILFOR AND
PVD.CODPAR = PXF.CODFOR AND
PVD.TIPPAR = PXF.TIPFOR
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 32474,
       'CON ',
       'PVD ',
       '0N',
       '01',
       '',
       '',
       'CON.FILCLI = PVD.FILCLI (+)  and
CON.CODCLI = PVD.CODCLI (+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 9018 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PVD ',
       '01',
       230,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(PVD.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '99',
       450,
       4,
       'ANO_DATA01',
       'A',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 1',
       '',
       'TO_CHAR(PVD.DATA01,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '99',
       480,
       4,
       'ANO_DATA02',
       'A',
       '',
       0,
       0,
       'PVD ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 2',
       '',
       'TO_CHAR(PVD.DATA02,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '99',
       510,
       4,
       'ANO_DATA03',
       'A',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 3',
       '',
       'TO_CHAR(PVD.DATA03,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       260,
       4,
       'ANO_DATNAS',
       'A',
       '',
       0,
       0,
       'PVD ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ano de Nascto/Funda',
       'Ano de Data de nascimento',
       '',
       'TO_CHAR(PVD.DATNAS,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       290,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       0,
       'PVD ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ano de Data Incluso',
       'Ano de Data de operao (cadastramento)',
       '',
       'TO_CHAR(PVD.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '99',
       541,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN PVD.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       210,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '99',
       390,
       2,
       'CATEG1',
       'S',
       'DCT1',
       0,
       20,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'V',
       'PVD',
       'F',
       'A',
       'T',
       'Bonus/Dest Icms',
       'Categoria - 1',
       'PVD.CATEG1=DCT1.CODTAB (+)',
       'CATEG1',
       'T' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '99',
       400,
       2,
       'CATEG2',
       'S',
       'DCT2',
       0,
       21,
       'PVD ',
       20,
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'V',
       'PVD',
       'F',
       'A',
       'T',
       'Ramo Atividade',
       'Categoria - 2',
       'PVD.CATEG2=DCT2.CODTAB (+)',
       'CATEG2',
       'T' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '99',
       420,
       2,
       'CATEG3',
       'S',
       'DCT3',
       0,
       22,
       'PVD ',
       30,
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'V',
       'PVD',
       'F',
       'A',
       'T',
       'Categoria',
       'Categoria - 3',
       'PVD.CATEG3=DCT3.CODTAB (+)',
       'CATEG3',
       'T' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       180,
       9,
       'CHAVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Fil.+Cd. Par.Esp.',
       'Cdigo do fornecedor',
       '',
       'FILCLI||PVD.CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       170,
       6,
       'CODCLI',
       'A',
       '',
       0,
       0,
       'PVD ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '9',
       'T',
       'Cdigo Par.Especial',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       20,
       6,
       'CODPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo~Rel.Parceiro',
       'Cdigo Parceiro',
       '',
       'CODPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       70,
       3,
       'CODPLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Plano',
       'Cdigo do Plano',
       '',
       'CODPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       50,
       5,
       'CODSEX',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       13,
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Sexo',
       'Cdigo Sexo',
       '',
       'CODSEX',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       120,
       3,
       'CODVEN',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Vendedor Padro',
       'Cdigo Vendedor',
       'PVD.FILVEN=USU.FILUSU(+) AND PVD.CODVEN=USU.CODUSU(+)',
       'CODVEN',
       'T' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       130,
       6,
       'CODVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Vnculo',
       'Cdigo Vnculo',
       '',
       'CODVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       90,
       44,
       'CONJUG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cnjuge',
       'Cnjuge',
       '',
       'CONJUG',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '99',
       430,
       8,
       'DATA01',
       'D',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       '',
       'Data livre - 1',
       '',
       'DATA01',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '99',
       460,
       8,
       'DATA02',
       'D',
       '',
       0,
       0,
       'PVD ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       '',
       'Data livre - 2',
       '',
       'DATA02',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '99',
       490,
       8,
       'DATA03',
       'D',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       '',
       'Data livre - 3',
       '',
       'DATA03',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       240,
       8,
       'DATNAS',
       'D',
       '',
       0,
       0,
       'PVD ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       'Nascto/Fundao',
       'Data de nascimento',
       '',
       'DATNAS',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       270,
       8,
       'DATOPE',
       'D',
       '',
       0,
       0,
       'PVD ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       'Data Incluso',
       'Data de operao (cadastramento)',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       30,
       15,
       'DOCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Documento Cnguge',
       'Documento Cnjuge',
       '',
       'DOCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       40,
       5,
       'ESTCIV',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       10,
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Estado Civil',
       'Estado Civil',
       '',
       'ESTCIV',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       160,
       3,
       'FILCLI',
       'A',
       '',
       0,
       0,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'N',
       'T',
       'Filial Cliente',
       'Filial onde foi cadastrado o fornecedor',
       '',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       10,
       3,
       'FILPAR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial~Rel.Parceiro',
       'Filial Parceiro',
       'DFIL.CODFIL = PVD.FILPAR',
       'FILPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       60,
       3,
       'FILPLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Plano',
       'Filial Plano',
       '',
       'FILPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       110,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Vendedor',
       'Filial da Venda',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       140,
       3,
       'FILVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Vnculo',
       'Filial Vnculo',
       '',
       'FILVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '03',
       320,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       0,
       'PVD ',
       20,
       30,
       '',
       '',
       'D',
       'PVD',
       'F',
       'A',
       'T',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '02',
       300,
       40,
       'HOMPGE',
       'A',
       '',
       0,
       0,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PVD',
       'F',
       'A',
       'T',
       'Home Page',
       'Home Page do Fornecedor',
       '',
       'HOMPGE',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '99',
       520,
       2,
       'IMPRIM',
       'S',
       '',
       0,
       0,
       'PVD ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '',
       'F',
       'Livre p/Customizao',
       'Livre para customizao',
       '',
       'IMPRIM',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '03',
       330,
       15,
       'INSEST',
       'A',
       '',
       0,
       4,
       'PVD ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PVD',
       'F',
       'A',
       'T',
       '2 Documento',
       'Inscrio Estadual ou Identidade',
       '',
       'INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '04',
       370,
       2,
       'MAIATR',
       'S',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '9',
       'T',
       'Atraso Max. ao Pagar',
       'Maior atraso registrado',
       '',
       'MAIATR',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       220,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(PVD.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '99',
       440,
       2,
       'MES_DATA01',
       'A',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 1',
       '',
       'TO_CHAR(PVD.DATA01,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '99',
       470,
       2,
       'MES_DATA02',
       'A',
       '',
       0,
       0,
       'PVD ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 2',
       '',
       'TO_CHAR(PVD.DATA02,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '99',
       500,
       2,
       'MES_DATA03',
       'A',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 3',
       '',
       'TO_CHAR(PVD.DATA03,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       250,
       2,
       'MES_DATNAS',
       'A',
       '',
       0,
       0,
       'PVD ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ms de Nascto/Funda',
       'Ms de Data de nascimento',
       '',
       'TO_CHAR(PVD.DATNAS,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       280,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       0,
       'PVD ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ms de Data Incluso',
       'Ms de Data de operao (cadastramento)',
       '',
       'TO_CHAR(PVD.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       100,
       7,
       'NASCON',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Nascimento Cnjuge',
       'Nascimento do Cnjuge',
       '',
       'NASCON',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       190,
       44,
       'NOMCLI',
       'A',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PVD',
       'F',
       'A',
       'T',
       'Nome/Razo Social',
       'Nome Parceiro Especial',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       205,
       65,
       'NOME_COMPLETO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome Completo',
       'Nome Completo',
       '',
       '(CASE WHEN PVD.FLGTIP = 0 THEN (PVD.NOMCLI || '' '' || COALESCE(PVD.ULTNOM,'''')) ELSE PVD.NOMCLI END)',
       '' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '03',
       310,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       3,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PVD',
       'F',
       'A',
       'T',
       'Documento (CPF/CGC)',
       'Nmero do Documento: CGC ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '99',
       530,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'PVD ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PVD',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(PVD.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       80,
       2,
       'PORPAD',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       'F',
       'A',
       'F',
       'Portador Padro',
       'Portador padro',
       'PVD.PORPAD=DCOB.CODTAB (+)',
       'PORPAD',
       'T' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '04',
       550,
       1,
       'PP_FLG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag Prospeco',
       'Flag de Prospeco sim ou no',
       '',
       'PP_FLG',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       150,
       5,
       'SEXCON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Sexo Cnjuge',
       'Sexo do Cnjuge',
       '',
       'SEXCON',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '99',
       540,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'PVD ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PVD',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN PVD.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '99',
       380,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Parceiro',
       'Tipo de Parceiro',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '04',
       350,
       4,
       'TOTATR',
       'G',
       '',
       0,
       0,
       'PVD ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '',
       'F',
       'Total Atrasos',
       'Total de atrasos na vida do Fornecedor como cliente',
       '',
       'TOTATR',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '04',
       360,
       4,
       'TOTPAR',
       'G',
       '',
       0,
       0,
       'PVD ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '',
       'F',
       'Total Parcelas',
       'Total de parcelas na vida do Fornecedor como cliente',
       '',
       'TOTPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '99',
       410,
       7,
       'ULTCOM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'ltima Compra',
       'ltima Compra',
       '',
       'ULTCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '01',
       200,
       20,
       'ULTNOM',
       'A',
       '',
       0,
       0,
       'PVD ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PVD',
       'F',
       'A',
       'T',
       'Sobrenome/Fantasia',
       'Sobrenome ou fantasia',
       '',
       'ULTNOM',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '04',
       340,
       8,
       'VALOR1',
       'F',
       '',
       2,
       0,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'T',
       '',
       'T',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'VALOR1',
       'F' FROM DUAL
UNION ALL
SELECT 'PVD ',
       '99',
       550,
       14,
       'VLRMIN_PEDCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Vlr Mn. Pedido',
       'Valor Mnimo para Pedido de Compra',
       '',
       'VLRMIN_PEDCOM',
       '' FROM DUAL
);

/*-- SEQ 9019 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'PVD ',
       'CODSEX',
       2,
       '-',
       'Feminino',
       197,
       ' ' FROM DUAL
UNION ALL
SELECT 'PVD ',
       'CODSEX',
       0,
       '-',
       'Nao conhecido',
       195,
       ' ' FROM DUAL
UNION ALL
SELECT 'PVD ',
       'CODSEX',
       1,
       '-',
       'Masculino',
       196,
       ' ' FROM DUAL
UNION ALL
SELECT 'PVD ',
       'ESTCIV',
       6,
       '-',
       'Separado',
       204,
       ' ' FROM DUAL
UNION ALL
SELECT 'PVD ',
       'ESTCIV',
       0,
       '-',
       'Indefinido',
       198,
       ' ' FROM DUAL
UNION ALL
SELECT 'PVD ',
       'ESTCIV',
       1,
       '-',
       'Solteiro',
       199,
       ' ' FROM DUAL
UNION ALL
SELECT 'PVD ',
       'ESTCIV',
       2,
       '-',
       'Casado',
       200,
       ' ' FROM DUAL
UNION ALL
SELECT 'PVD ',
       'ESTCIV',
       3,
       '-',
       'Vivo',
       201,
       ' ' FROM DUAL
UNION ALL
SELECT 'PVD ',
       'ESTCIV',
       4,
       '-',
       'Divorciado',
       202,
       ' ' FROM DUAL
UNION ALL
SELECT 'PVD ',
       'ESTCIV',
       5,
       '-',
       'Unio Estvel',
       203,
       ' ' FROM DUAL
UNION ALL
SELECT 'PVD ',
       'FLGTIP',
       0,
       '-',
       'Fsica',
       205,
       ' ' FROM DUAL
UNION ALL
SELECT 'PVD ',
       'FLGTIP',
       1,
       '-',
       'Jurdica',
       206,
       ' ' FROM DUAL
UNION ALL
SELECT 'PVD ',
       'FLGTIP',
       2,
       '-',
       'Entidade',
       207,
       ' ' FROM DUAL
UNION ALL
SELECT 'PVD ',
       'FLGTIP',
       3,
       '-',
       'Especial',
       208,
       ' ' FROM DUAL
UNION ALL
SELECT 'PVD ',
       'FLGTIP',
       4,
       '-',
       'M.E.',
       209,
       ' ' FROM DUAL
UNION ALL
SELECT 'PVD ',
       'FLGTIP',
       5,
       '-',
       'Filial',
       210,
       ' ' FROM DUAL
UNION ALL
SELECT 'PVD ',
       'TIPPAR',
       0,
       'F',
       'Fornecedor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PVD ',
       'TIPPAR',
       0,
       'M',
       'Marca',
       267,
       ' ' FROM DUAL
UNION ALL
SELECT 'PVD ',
       'TIPPAR',
       0,
       'T',
       'Transportador',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9020 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PVEN',
       TO_NUMBER(null),
       'PVEN',
       'Venda Personalizada',
       'TP_VEN',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'PVEN.CODFIL,PVEN.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9021 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PVEN','--','' FROM DUAL
UNION ALL
SELECT 'PVEN','01','Identificao' FROM DUAL
);

/*-- SEQ 9022 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5789,
       'VEN ',
       'PVEN',
       '1 ',
       '01',
       '',
       '',
       'VEN.CODFIL = PVEN.CODFIL(+) and
VEN.SEQUEN = PVEN.SEQUEN(+)',
       '' FROM DUAL
);

/*-- SEQ 9023 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PWOR',
       TO_NUMBER(null),
       'PWOR',
       'WorkFlow Personal.',
       'TP_WOR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'PWOR.CODFIL,PWOR.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9024 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PWOR','--','' FROM DUAL
UNION ALL
SELECT 'PWOR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PWOR','99','Outros' FROM DUAL
);

/*-- SEQ 9025 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 32722,
       'WOR ',
       'PWOR',
       '1 ',
       '01',
       '',
       '',
       'WOR.CODFIL = PWOR.CODFIL AND
WOR.SEQUEN = PWOR.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9026 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PWOR',
       '01',
       1,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '0',
       'F',
       'Filial Workflow',
       'Filial Workflow',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PWOR',
       '01',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '9',
       'F',
       'Cdigo Workflow',
       'Cdigo Workflow',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 9027 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PXC ',
       TO_NUMBER(null),
       'PXC ',
       'Plano x Carto',
       'TT_PLAXCAR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9028 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PXC ','--','' FROM DUAL
UNION ALL
SELECT 'PXC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PXC ','99','Outros' FROM DUAL
);

/*-- SEQ 9029 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 61713,
       'PLA ',
       'PXC ',
       '1 ',
       'N ',
       '',
       '',
       'PLA.FILPGT = PXC.FILPGT AND
PLA.CODPGT = PXC.CODPGT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 61714,
       'DCAR',
       'PXC ',
       '1 ',
       'N ',
       '',
       '',
       'DCAR.CODTAB = PXC.CARTAO',
       '',
       '' FROM DUAL
);

/*-- SEQ 9030 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PXC ',
       '01',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'PXC ',
       '01',
       50,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'PXC ',
       '01',
       70,
       1,
       'FLGCRE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Crdito?',
       'Crdito?',
       '',
       'FLGCRE',
       'F' FROM DUAL
UNION ALL
SELECT 'PXC ',
       '01',
       80,
       1,
       'FLGDEB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Dbito?',
       'Dbito?',
       '',
       'FLGDEB',
       'F' FROM DUAL
);

/*-- SEQ 9031 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PXD ',
       TO_NUMBER(null),
       'PXD ',
       'Pedido x Descontos',
       'TT_PEDXDDES',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'PXD.CODFIL.PXD.NUMDES,PXD.NUMPED',
       '' FROM DUAL
);

/*-- SEQ 9032 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PXD ','--','' FROM DUAL
UNION ALL
SELECT 'PXD ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PXD ','99','Outros' FROM DUAL
);

/*-- SEQ 9033 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5791,
       'PED ',
       'PXD ',
       '1 ',
       '01',
       '',
       '',
       'PED.CODFIL = PXD.CODFIL AND
PED.NUMPED = PXD.NUMPED',
       '' FROM DUAL
);

/*-- SEQ 9034 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PXD ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = PXD.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PXD ',
       '01',
       20,
       4,
       'DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Descontos',
       'Descontos',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'PXD ',
       '01',
       30,
       2,
       'NUMDES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero de Descontos',
       'Nmero de Descontos',
       '',
       'NUMDES',
       'F' FROM DUAL
UNION ALL
SELECT 'PXD ',
       '01',
       40,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero do Pedido',
       'Nmero do Pedido',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'PXD ',
       '01',
       50,
       5,
       'TIPDES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tipo de Descontos',
       'Tipo de Descontos',
       '',
       'TIPDES',
       'F' FROM DUAL
);

/*-- SEQ 9035 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PXEN',
       TO_NUMBER(null),
       'PXEN',
       'Est. no Signatrios',
       'TT_IPTXEXC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9036 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PXEN','--','' FROM DUAL
UNION ALL
SELECT 'PXEN','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PXEN','99','Outros' FROM DUAL
);

/*-- SEQ 9037 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20250,
       'IPT ',
       'PXEN',
       '1',
       'N',
       '',
       '',
       'PXEN.CODFIL = IPT.CODFIL AND 
PXEN.SEQUEN = IPT.SEQUEN AND 
PXEN.NUMITE = IPT.NUMITE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20260,
       'NCM ',
       'PXEN',
       '01',
       'N',
       '',
       '',
       'PXEN.CODNCM = NCM.CODNCM',
       '',
       '' FROM DUAL
);

/*-- SEQ 9038 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PXEN',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'PXEN',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PXEN',
       '--',
       30,
       8,
       'CODNCM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome. Com. Mercosul',
       'Nomenclatura Comum do Mercosu',
       '',
       'CODNCM',
       'F' FROM DUAL
UNION ALL
SELECT 'PXEN',
       '--',
       40,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'PXEN',
       '--',
       50,
       5,
       'ITEEXC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nm. item da exce.',
       'Nmero do item da exceo',
       '',
       'ITEEXC',
       'F' FROM DUAL
UNION ALL
SELECT 'PXEN',
       '--',
       60,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       'N',
       'F',
       'Nmero do item',
       'Nmero do item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'PXEN',
       '--',
       70,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'PXEN',
       '--',
       80,
       2,
       'SIGEST',
       'A',
       'DEST',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEST.ESTADO',
       'V',
       '',
       '',
       'A',
       'F',
       'Estado',
       'Estado',
       'DEST.ESTADO = PXEN.SIGEST',
       'SIGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'PXEN',
       '--',
       90,
       1,
       'TIPEXC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Excluso',
       'Tipo Excluso',
       '',
       'TIPEXC',
       'T' FROM DUAL
);

/*-- SEQ 9039 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'PXEN',
       'TIPEXC',
       0,
       '0',
       'Excl. na Origem e no Destino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PXEN',
       'TIPEXC',
       0,
       '1',
       'Excludo somente na Origem',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PXEN',
       'TIPEXC',
       0,
       '2',
       'Excludo somente no Destino',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9040 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PXF ',
       0,
       'PXF ',
       'Produto x Fornecedor',
       'TT_PXF',
       'T',
       '',
       'TOTALL',
       'Produto X Fornecedor',
       '{FILMAT;CODMAT;FILFOR;CODFOR}',
       '',
       '',
       '',
       'F',
       '',
       'PXF.FILMAT,PXF.CODMAT,PXF.CODCOR,PXF.CODTAM,PXF.FILFOR,PXF.CODFOR',
       '' FROM DUAL
);

/*-- SEQ 9041 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PXF ','--','' FROM DUAL
);

/*-- SEQ 9042 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 27175,
       'PRO ',
       'PXF ',
       '1',
       'N',
       '',
       '',
       'PXF.FILMAT = PRO.FILMAT and PXF.CODMAT = PRO.CODMAT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 27176,
       'REL ',
       'PXF ',
       '1',
       '01',
       '',
       '',
       'REL.FILPAR = PXF.FILFOR AND
REL.CODPAR = PXF.CODFOR AND
REL.TIPPAR = PXF.TIPFOR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 27177,
       'GRA ',
       'PXF ',
       '1',
       '0N',
       '',
       '',
       'GRA.FILMAT = PXF.FILMAT AND
GRA.CODMAT = PXF.CODMAT AND
GRA.CODCOR = PXF.CODCOR AND
GRA.CODTAM = PXF.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 9043 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PXF ',
       '--',
       112,
       5,
       'AFICUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '% Acrs Financeiro',
       '% Acrscimo Financeiro',
       '',
       'AFICUS',
       'F' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       272,
       5,
       'ALIFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '% ICMS do Frete',
       '% ICMS do Frete',
       '',
       'ALIFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       222,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Ultima atualizao',
       'Ultima atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       62,
       12,
       'BASICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% Base ICMS',
       '% Base ICMS',
       '',
       'BASICM',
       'F' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       232,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       '',
       '9',
       'F',
       'Diviso',
       'Diviso do produto',
       'PXF.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       40,
       6,
       'CODFOR',
       'A',
       '',
       0,
       0,
       'PXF ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PXF',
       'F',
       '9',
       'F',
       'Cdigo do Fornecedor',
       'Cdigo do fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       20,
       5,
       'CODMAT',
       'A',
       '',
       0,
       0,
       'PXF ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PXF',
       'F',
       '9',
       'F',
       'Cdigo do material',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       242,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       '',
       '9',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'PXF.CODTAM=SUB.CODITE (+) ',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       300,
       14,
       'CUSFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Custo do Frete',
       'Custo do Frete',
       '',
       'CUSFRE',
       '' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       122,
       5,
       'DACCUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '% Desc/Acrscimo',
       '% de Desconto/Acrscimo',
       '',
       'DACCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       310,
       5,
       'DACSIM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Simulao Compra',
       '% de Desconto/Acrscimo para Simulao de Compra',
       '',
       'DACSIM',
       '' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       331,
       8,
       'DP_ENT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Desv Padro Rec Ped',
       'Desvio Padro dos Dias para Recebimento dos Pedidos',
       '',
       'DP_ENT',
       '' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       30,
       3,
       'FILFOR',
       'A',
       'DFIL',
       0,
       0,
       'PXF ',
       30,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'PXF',
       'F',
       'N',
       'F',
       'Filial do Fornecedor',
       'Filial do fornecedor',
       'PXF.FILFOR = DFIL.CODFIL (+)',
       'FILFOR',
       'T' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       10,
       3,
       'FILMAT',
       'A',
       '',
       0,
       0,
       'PXF ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PXF',
       'F',
       'N',
       'F',
       'Filial do Material',
       'Filial do material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       341,
       12,
       'FRESIM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Frete Simul. Compra',
       'Custo do Frete Unitrio para Preo Simulado de Compra',
       '',
       'FRESIM',
       '' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       252,
       14,
       'ICMCUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '% ICMS Custos',
       '% ICMS Custos',
       '',
       'ICMCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       132,
       12,
       'ICMFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'ICMS do Frete',
       'Valor do ICMS do Frete',
       '',
       'ICMFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       142,
       1,
       'ICMTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Tributao',
       'Tipo de Tributao',
       '',
       'ICMTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       262,
       14,
       'IPICUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '% IPI Custos',
       '% IPI Custos',
       '',
       'IPICUS',
       'F' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       282,
       12,
       'IPIFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor IPI do Frete',
       'Valor IPI do Frete',
       '',
       'IPIFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       321,
       8,
       'MEDENT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Mdia Rec Pedidos',
       'Mdia de Dias para Recebimento dos Pedidos',
       '',
       'MEDENT',
       '' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       350,
       14,
       'MVACOM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% MVA Compra',
       '% MVA de Compra',
       '',
       'MVACOM',
       '' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       290,
       64,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome Fornecedor',
       'Nome do Fornecedor',
       '',
       '(SELECT VFOR.NOMCLI FROM TV_FOR VFOR WHERE VFOR.FILPAR = PXF.FILFOR AND VFOR.CODPAR = PXF.CODFOR) ',
       '' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       82,
       5,
       'ORDPED',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Ordem',
       'Ordem',
       '',
       'ORDPED',
       'F' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       152,
       1,
       'ORICUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem dos Custos',
       'Origem dos Custos',
       '',
       'ORICUS',
       'T' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       162,
       12,
       'OUTCUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Outros Custos',
       'Outros Custos',
       '',
       'OUTCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       172,
       5,
       'PERFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '% do Frete',
       '% do Frete',
       '',
       'PERFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       51,
       5,
       'PERICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '% ICMS padro compra',
       '% ICMS padro para compra',
       '',
       'PERICM',
       'F' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       52,
       5,
       'PERIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '% IPI padro compra',
       '% IPI padro para compra',
       '',
       'PERIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       182,
       12,
       'PRECOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Preo de Compra',
       'Preo de Compra',
       '',
       'PRECOM',
       'F' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       320,
       12,
       'PRESIM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Preo Sim. Compra',
       'Preo Simulado para Compra',
       '',
       'PRESIM',
       '' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       92,
       1,
       'REPASE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Repasse',
       'Produto tem ou no repasse',
       '',
       'REPASE',
       'F' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       72,
       1,
       'TIPFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Parceiro',
       'Tipo Parceiro',
       '',
       'TIPFOR',
       'T' FROM DUAL
UNION ALL
SELECT 'PXF ',
       '--',
       102,
       12,
       'ULTBAS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '% ltima Reduo ',
       'ltima Reduo Percentual',
       '',
       'ULTBAS',
       'F' FROM DUAL
);

/*-- SEQ 9044 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'PXF ',
       'ICMTIP',
       0,
       '0',
       'Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PXF ',
       'ICMTIP',
       0,
       '1',
       'No-Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PXF ',
       'ICMTIP',
       0,
       '2',
       'Isento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PXF ',
       'ICMTIP',
       0,
       '3',
       'Substitudo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PXF ',
       'ICMTIP',
       0,
       '4',
       'Isento no Estado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PXF ',
       'ORICUS',
       0,
       'C',
       'Compras',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PXF ',
       'ORICUS',
       0,
       'M',
       'Manual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PXF ',
       'ORICUS',
       0,
       'P',
       'Pedido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PXF ',
       'TIPFOR',
       0,
       'F',
       'Fornecedor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PXF ',
       'TIPFOR',
       0,
       'T',
       'Transportadora',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9045 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PXP ',
       TO_NUMBER(null),
       'PXP ',
       'Projetos x Papis',
       'TT_PRJXPAP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'PXP.FILPRJ,PXP.SEQPRJ,PXP.FILPAP,PXP.SEQPAP',
       '' FROM DUAL
);

/*-- SEQ 9046 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PXP ','--','' FROM DUAL
UNION ALL
SELECT 'PXP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PXP ','99','Outros' FROM DUAL
);

/*-- SEQ 9047 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5797,
       'PAP ',
       'PXP ',
       '1 ',
       '01',
       '',
       '',
       'PAP.CODFIL = PXP.FILPAP AND
PAP.SEQUEN = PXP.SEQPAP',
       '' FROM DUAL
UNION ALL
SELECT 5798,
       'PRJ ',
       'PXP ',
       '1 ',
       '01',
       '',
       '',
       'PAP.CODFIL = PXP.FILPRJ AND
PAP.SEQUEN = PXP.SEQPRJ',
       '' FROM DUAL
);

/*-- SEQ 9048 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PXP ',
       '01',
       90,
       1,
       'EXCWOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Excluso~Projeto?',
       'Excluso Projeto?',
       '',
       'EXCWOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PXP ',
       '01',
       10,
       3,
       'FILPAP',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial Papel',
       'Filial Papel',
       'DFIL.CODFIL = PXP.FILPAP',
       'FILPAP',
       'F' FROM DUAL
UNION ALL
SELECT 'PXP ',
       '01',
       20,
       3,
       'FILPRJ',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial Projeto',
       'Filial Projeto',
       'DFIL.CODFIL = PXP.FILPRJ',
       'FILPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'PXP ',
       '01',
       100,
       1,
       'GERWOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Gerencia~Projeto?',
       'Gerencia Projeto?',
       '',
       'GERWOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PXP ',
       '01',
       30,
       1,
       'LERPRJ',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ler Projeto?',
       'Ler Projeto?',
       '',
       'LERPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'PXP ',
       '01',
       110,
       1,
       'PLAWOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Planejar~Projeto?',
       'Planejar Projeto?',
       '',
       'PLAWOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PXP ',
       '01',
       120,
       1,
       'PROWOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Projetar~Projeto?',
       'Projetar~Projeto?',
       '',
       'PROWOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PXP ',
       '01',
       40,
       1,
       'REGWOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Registra no WorkFlow',
       'Registrar no WorkFlow?',
       '',
       'REGWOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PXP ',
       '01',
       50,
       1,
       'RESWOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Reponsvel Workflow?',
       'Responsvel no WorkFlow?',
       '',
       'RESWOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PXP ',
       '01',
       60,
       10,
       'SEQPAP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador Papel',
       'Sequenciador Papel',
       '',
       'SEQPAP',
       'F' FROM DUAL
UNION ALL
SELECT 'PXP ',
       '01',
       70,
       10,
       'SEQPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador Papel',
       'Sequenciador Projetos',
       '',
       'SEQPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'PXP ',
       '01',
       80,
       1,
       'TSTWOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Testa no WorkFlow?',
       'Testa no WorkFlow?',
       '',
       'TSTWOR',
       'F' FROM DUAL
UNION ALL
SELECT 'PXP ',
       '01',
       130,
       1,
       'VALRAT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Validar~RAT?',
       'Validar RAT?',
       '',
       'VALRAT',
       'F' FROM DUAL
);

/*-- SEQ 9049 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PXR ',
       TO_NUMBER(null),
       'PXR ',
       'Prioridade X Release',
       'TT_PXR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'PXR.CODFIL, PXR.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9050 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PXR ','--','' FROM DUAL
);

/*-- SEQ 9051 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 6031,
       'SPT ',
       'PXR ',
       'N ',
       '1 ',
       '',
       '',
       'TT_SPT.CODPRI = TT_PXR.CODPRI',
       '' FROM DUAL
UNION ALL
SELECT 6032,
       'DPRI',
       'PXR ',
       'N ',
       '1 ',
       '',
       '',
       'TD_PRI.CODTAB = TT_PXR.CODPRI',
       '' FROM DUAL
);

/*-- SEQ 9052 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PXR ',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'V',
       '',
       '',
       'A',
       'F',
       'Cdigo Filial',
       'Cdigo Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'PXR ',
       '--',
       20,
       5,
       'CODPRI',
       'S',
       'DPRI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DPRI.DESPRI',
       'V',
       '',
       '',
       '9',
       'F',
       'Cdigo Prioridade',
       'Cdigo Prioridade',
       'DPRI.CODTAB = PXR.CODPRI',
       'CODPRI',
       'F' FROM DUAL
UNION ALL
SELECT 'PXR ',
       '--',
       30,
       2,
       'DIAMES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Dia do ms',
       'Dia do ms',
       '',
       'DIAMES',
       'F' FROM DUAL
UNION ALL
SELECT 'PXR ',
       '--',
       40,
       1,
       'DIASEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       '0',
       'F',
       'Dia da semana',
       'Dia da semana',
       '',
       'DIASEM',
       'F' FROM DUAL
UNION ALL
SELECT 'PXR ',
       '--',
       50,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Sequncia',
       'Sequncia',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 9053 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'PXR ',
       'DIASEM',
       0,
       '1',
       'Domingo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PXR ',
       'DIASEM',
       0,
       '2',
       'Segunda-Feira',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PXR ',
       'DIASEM',
       0,
       '3',
       'Tera-Feira',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PXR ',
       'DIASEM',
       0,
       '4',
       'Quarta-Feira',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PXR ',
       'DIASEM',
       0,
       '5',
       'Quinta-Feira',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PXR ',
       'DIASEM',
       0,
       '6',
       'Sexta-Feira',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'PXR ',
       'DIASEM',
       0,
       '7',
       'Sbado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9054 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'PXU ',
       TO_NUMBER(null),
       'PXU ',
       'Papis x Usurios',
       'TT_PAPXUSU',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'PXU.FILPAP,PXU.SEQPAP,PXU.FILUSU,PXU.CODUSU',
       '' FROM DUAL
);

/*-- SEQ 9055 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'PXU ','--','' FROM DUAL
UNION ALL
SELECT 'PXU ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'PXU ','99','Outros' FROM DUAL
);

/*-- SEQ 9056 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21890,
       'USU ',
       'PXU ',
       '1',
       '01',
       '',
       '',
       'USU.FILUSU = PXU.FILUSU AND
USU.CODUSU = PXU.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21891,
       'TPAP',
       'PXU ',
       '1',
       '01',
       '',
       '',
       'TPAP.CODFIL = PXU.FILPAP AND
TPAP.SEQUEN = PXU.SEQPAP',
       '',
       '' FROM DUAL
);

/*-- SEQ 9057 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'PXU ',
       '01',
       10,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Usurio',
       'Cdigo Usurio',
       'USU2.FILUSU(+) = PXU.FILUSU AND USU2.CODUSU(+) = PXU.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'PXU ',
       '01',
       20,
       3,
       'FILPAP',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Previso de Contas a Pagar',
       'DFIL.CODFIL = PXU.FILPAP',
       'FILPAP',
       'F' FROM DUAL
UNION ALL
SELECT 'PXU ',
       '01',
       30,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'PXU ',
       '01',
       40,
       10,
       'SEQPAP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Previso de Contas a Pagar',
       '',
       'SEQPAP',
       'F' FROM DUAL
);

/*-- SEQ 9058 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'QRY ',
       TO_NUMBER(null),
       'QRY ',
       'Consultas Dinmicas',
       'TT_QRY',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9059 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'QRY ','--','' FROM DUAL
UNION ALL
SELECT 'QRY ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'QRY ','99','Outros' FROM DUAL
);

/*-- SEQ 9060 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'QRY ',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'QRY ',
       '--',
       20,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'QRY ',
       '--',
       30,
       14,
       'ID_QRY',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Chave ID',
       'Chave ID',
       '',
       'ID_QRY',
       'F' FROM DUAL
UNION ALL
SELECT 'QRY ',
       '--',
       40,
       1,
       'QRYATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'QRYATI',
       'F' FROM DUAL
UNION ALL
SELECT 'QRY ',
       '--',
       50,
       20,
       'QRYCHV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'QRYCHV',
       'T' FROM DUAL
UNION ALL
SELECT 'QRY ',
       '--',
       60,
       40,
       'QRYDES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio',
       '',
       'QRYDES',
       'F' FROM DUAL
UNION ALL
SELECT 'QRY ',
       '--',
       70,
       0,
       'QRYEXP',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Frmula SQL',
       'Frmula SQL',
       '',
       'QRYEXP',
       'F' FROM DUAL
);

/*-- SEQ 9061 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'QRY ',
       'QRYCHV',
       0,
       ' ',
       'Desconto no Item',
       TO_NUMBER(null),
       'DESCONTO_ITEM' FROM DUAL
UNION ALL
SELECT 'QRY ',
       'QRYCHV',
       0,
       ' ',
       'Desconto na Venda',
       TO_NUMBER(null),
       'DESCONTO_VENDA' FROM DUAL
UNION ALL
SELECT 'QRY ',
       'QRYCHV',
       0,
       ' ',
       'Preo do Item',
       TO_NUMBER(null),
       'PRECO_ITEM' FROM DUAL
UNION ALL
SELECT 'QRY ',
       'QRYCHV',
       0,
       ' ',
       'Rodap do Cupom',
       TO_NUMBER(null),
       'RODAPE_CUPOM' FROM DUAL
UNION ALL
SELECT 'QRY ',
       'QRYCHV',
       0,
       ' ',
       'Bnus',
       TO_NUMBER(null),
       'BONUS' FROM DUAL
);

/*-- SEQ 9062 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'QUE ',
       TO_NUMBER(null),
       'QUE ',
       'Questionrios',
       'TT_QUE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'QUE.FILQUE,QUE.CODQUE',
       '' FROM DUAL
);

/*-- SEQ 9063 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'QUE ','--','' FROM DUAL
UNION ALL
SELECT 'QUE ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'QUE ','02','Datas' FROM DUAL
UNION ALL
SELECT 'QUE ','03','Valores' FROM DUAL
UNION ALL
SELECT 'QUE ','99','Outros' FROM DUAL
);

/*-- SEQ 9064 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21832,
       'IQU ',
       'QUE ',
       'N',
       '1',
       '',
       '',
       'IQU.FILQUE = QUE.FILQUE AND
IQU.CODQUE = QUE.CODQUE',
       '',
       '' FROM DUAL
);

/*-- SEQ 9065 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'QUE ',
       '02',
       15,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano~Atualizao',
       'Ano de Data da ltima atualizao',
       '',
       'TO_CHAR(QUE.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '02',
       55,
       4,
       'ANO_DATFIM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data Final',
       'Ano de Data Final',
       '',
       'TO_CHAR(QUE.DATFIM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '02',
       65,
       4,
       'ANO_DATINI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data Inicial',
       'Ano de Data Inicial',
       '',
       'TO_CHAR(QUE.DATINI,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '02',
       10,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data~Atualizao',
       'Data da ltima atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '99',
       20,
       1,
       'AVISTA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Ao Consumidor?',
       'Indica se  aplicado s vendas ao consumidor',
       '',
       'AVISTA',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '01',
       30,
       5,
       'CODPRI',
       'S',
       'DPRI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DPRI.DESPRI',
       'V',
       '',
       '',
       '',
       'F',
       'Cdigo Severidade',
       'Cdigo Severidade',
       'DPRI.CODTAB = QUE.CODPRI',
       'CODPRI',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '01',
       40,
       5,
       'CODQUE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Questionrio',
       'Cdigo Questionrio',
       '',
       'CODQUE',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '02',
       50,
       8,
       'DATFIM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Final',
       'Data Final',
       '',
       'DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '02',
       60,
       8,
       'DATINI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Inicial',
       'Data Inicial',
       '',
       'DATINI',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '01',
       70,
       3,
       'FILQUE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial',
       'QUE.FILQUE = DFIL.CODFIL(+)',
       'FILQUE',
       'T' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '02',
       35,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms~Atualizao',
       'Ms de Data da ltima atualizao',
       '',
       'TO_CHAR(QUE.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '02',
       57,
       2,
       'MES_DATFIM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data Final',
       'Ms de Data Final',
       '',
       'TO_CHAR
(QUE.DATFIM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '02',
       67,
       2,
       'MES_DATINI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data Inicial',
       'Ms de Data Inicial',
       '',
       'TO_CHAR(QUE.DATINI,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '99',
       80,
       1,
       'POSENT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Aplica aps Ent.Mer.',
       'Aplica aps o registro de entrega de mercadoria',
       '',
       'POSENT',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '99',
       90,
       1,
       'POSMON',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Aplica aps Montagem',
       'Aplica aps a montagem da mercadoria',
       '',
       'POSMON',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '99',
       100,
       1,
       'POSREM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Aplica aps Nota Rem',
       'Aplica aps a emisso da nota de remessa de mercadoria',
       '',
       'POSREM',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '99',
       110,
       1,
       'POSVEN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Aplica aps Venda?',
       'Aplica aps a venda, se o cliente leva a mercadoria',
       '',
       'POSVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '01',
       120,
       1,
       'PRIPER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Prioridade',
       'Nvel de Prioridade da pergunta (0  9)',
       '',
       'PRIPER',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '01',
       130,
       3,
       'QTDDIA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade de Dias',
       'Nmero de dias a aplicar aps o evento',
       '',
       'QTDDIA',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '99',
       140,
       1,
       'REGCLI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Registra Cliente?',
       'Registra Cliente?',
       '',
       'REGCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '99',
       150,
       1,
       'REGMKT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Aplica Reg.Marketing',
       'Aplica Registro Marketing',
       '',
       'REGMKT',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '99',
       160,
       1,
       'REGPRE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Aplica Reg.Pr-Venda',
       'Aplica no registro de pr-venda',
       '',
       'REGPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '99',
       170,
       1,
       'REGSAC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Registra no SAC?',
       'Registra no SAC?',
       '',
       'REGSAC',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '99',
       180,
       1,
       'REGVEN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Registra da Venda?',
       'Registra Vendas?',
       '',
       ' REGVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '01',
       230,
       1,
       'REGWOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Registra no WorkFlow',
       'Registrar no WorkFlow?',
       '',
       'REGWOR',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '99',
       190,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN QUE.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '99',
       191,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN QUE.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '01',
       220,
       30,
       'TITQUE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo Questionrio',
       'Ttulo Questionrio',
       '',
       'TITQUE',
       'F' FROM DUAL
UNION ALL
SELECT 'QUE ',
       '01',
       210,
       1,
       'VENDAS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Vendas?',
       'Indica se  aplicado s vendas',
       '',
       'VENDAS',
       'F' FROM DUAL
);

/*-- SEQ 9066 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'R14G',
       TO_NUMBER(null),
       'R14G',
       'Restries 001 CK 4G',
       'TV_RES_001_CK4G',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9067 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'R14G','--','' FROM DUAL
UNION ALL
SELECT 'R14G','01','Identificao' FROM DUAL
UNION ALL
SELECT 'R14G','99','Outros' FROM DUAL
);

/*-- SEQ 9068 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23376,
       'CLI ',
       'R14G',
       '1',
       '0N',
       '',
       '',
       'R14G.FILCLI = CLI.FILCLI(+) AND
R14G.CODCLI = CLI.CODCLI(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 9069 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'R14G',
       '01',
       90,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 'R14G',
       '01',
       10,
       12,
       'DIVIDA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Dvida',
       'Dvida',
       '',
       'DIVIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'R14G',
       '01',
       80,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Cliente',
       'Filial onde foi cadastrado o cliente',
       'DFIL.CODFIL = R14G.FILCLI (+)',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'R14G',
       '01',
       20,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'R14G',
       '01',
       30,
       12,
       'LIMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'LIMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'R14G',
       '01',
       40,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'R14G',
       '01',
       50,
       12,
       'OCORRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ocorrncia',
       'Ocorrncia',
       '',
       'OCORRE',
       'F' FROM DUAL
UNION ALL
SELECT 'R14G',
       '01',
       60,
       17,
       'RESTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Restrio',
       'Restrio',
       '',
       'RESTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'R14G',
       '01',
       70,
       1,
       'TIPRES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Tipo de Restrio',
       '',
       'TIPRES',
       'F' FROM DUAL
);

/*-- SEQ 9070 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'R14G',
       'FLGTIP',
       0,
       '-',
       'Fsica',
       154,
       ' ' FROM DUAL
UNION ALL
SELECT 'R14G',
       'FLGTIP',
       1,
       '-',
       'Jurdica',
       155,
       ' ' FROM DUAL
UNION ALL
SELECT 'R14G',
       'FLGTIP',
       2,
       '-',
       'Entidade',
       156,
       ' ' FROM DUAL
UNION ALL
SELECT 'R14G',
       'FLGTIP',
       3,
       '-',
       'Especial',
       157,
       ' ' FROM DUAL
UNION ALL
SELECT 'R14G',
       'FLGTIP',
       4,
       '-',
       'M.E.',
       158,
       ' ' FROM DUAL
UNION ALL
SELECT 'R14G',
       'FLGTIP',
       5,
       '-',
       'Filial',
       159,
       ' ' FROM DUAL
);

/*-- SEQ 9071 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'R24G',
       TO_NUMBER(null),
       'R24G',
       'Restries 002 CK 4G',
       'TV_RES_002_CK4G',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9072 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'R24G','--','' FROM DUAL
UNION ALL
SELECT 'R24G','01','Identificao' FROM DUAL
UNION ALL
SELECT 'R24G','99','Outros' FROM DUAL
);

/*-- SEQ 9073 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23377,
       'CLI ',
       'R24G',
       '1',
       '0N',
       '',
       '',
       'R24G.FILCLI = CLI.FILCLI(+) AND
R24G.CODCLI = CLI.CODCLI(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 9074 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'R24G',
       '01',
       90,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       '',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 'R24G',
       '01',
       10,
       12,
       'DIVIDA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Dvida',
       'Dvida',
       '',
       'DIVIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'R24G',
       '01',
       80,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       '',
       'Filial onde foi cadastrado o cliente',
       'DFIL.CODFIL = R24G.FILCLI (+)',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'R24G',
       '01',
       20,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'R24G',
       '01',
       30,
       12,
       'LIMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'LIMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'R24G',
       '01',
       40,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'R24G',
       '01',
       50,
       12,
       'OCORRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ocorrncia',
       'Ocorrncia',
       '',
       'OCORRE',
       'F' FROM DUAL
UNION ALL
SELECT 'R24G',
       '01',
       60,
       17,
       'RESTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Restrio',
       'Restrio',
       '',
       'RESTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'R24G',
       '01',
       70,
       1,
       'TIPRES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Tipo de Restrio',
       '',
       'TIPRES',
       'F' FROM DUAL
);

/*-- SEQ 9075 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'R24G',
       'FLGTIP',
       2,
       '-',
       'Entidade',
       156,
       ' ' FROM DUAL
UNION ALL
SELECT 'R24G',
       'FLGTIP',
       3,
       '-',
       'Especial',
       157,
       ' ' FROM DUAL
UNION ALL
SELECT 'R24G',
       'FLGTIP',
       4,
       '-',
       'M.E.',
       158,
       ' ' FROM DUAL
UNION ALL
SELECT 'R24G',
       'FLGTIP',
       5,
       '-',
       'Filial',
       159,
       ' ' FROM DUAL
UNION ALL
SELECT 'R24G',
       'FLGTIP',
       0,
       '-',
       'Fsica',
       154,
       ' ' FROM DUAL
UNION ALL
SELECT 'R24G',
       'FLGTIP',
       1,
       '-',
       'Jurdica',
       155,
       ' ' FROM DUAL
);

/*-- SEQ 9076 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'R34G',
       TO_NUMBER(null),
       'R34G',
       'Restries 003 CK 4G',
       'TV_RES_003_CK4G',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9077 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'R34G','--','' FROM DUAL
UNION ALL
SELECT 'R34G','01','Identificao' FROM DUAL
UNION ALL
SELECT 'R34G','99','Outros' FROM DUAL
);

/*-- SEQ 9078 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23378,
       'CLI ',
       'R34G',
       '1',
       '0N',
       '',
       '',
       'R34G.FILCLI = CLI.FILCLI(+) AND
R34G.CODCLI = CLI.CODCLI(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 9079 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'R34G',
       '01',
       90,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 'R34G',
       '01',
       10,
       12,
       'DIVIDA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Dvida',
       'Dvida',
       '',
       'DIVIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'R34G',
       '01',
       80,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Cliente',
       'Filial onde foi cadastrado o cliente',
       'DFIL.CODFIL = R34G.FILCLI (+)',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'R34G',
       '01',
       20,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'R34G',
       '01',
       30,
       12,
       'LIMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'LIMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'R34G',
       '01',
       40,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'R34G',
       '01',
       50,
       12,
       'OCORRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ocorrncia',
       'Ocorrncia',
       '',
       'OCORRE',
       'F' FROM DUAL
UNION ALL
SELECT 'R34G',
       '01',
       60,
       17,
       'RESTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Restrio',
       'Restrio',
       '',
       'RESTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'R34G',
       '01',
       70,
       1,
       'TIPRES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Tipo de Restrio',
       '',
       'TIPRES',
       'F' FROM DUAL
);

/*-- SEQ 9080 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'R34G',
       'FLGTIP',
       0,
       '-',
       'Fsica',
       154,
       ' ' FROM DUAL
UNION ALL
SELECT 'R34G',
       'FLGTIP',
       1,
       '-',
       'Jurdica',
       155,
       ' ' FROM DUAL
UNION ALL
SELECT 'R34G',
       'FLGTIP',
       2,
       '-',
       'Entidade',
       156,
       ' ' FROM DUAL
UNION ALL
SELECT 'R34G',
       'FLGTIP',
       3,
       '-',
       'Especial',
       157,
       ' ' FROM DUAL
UNION ALL
SELECT 'R34G',
       'FLGTIP',
       4,
       '-',
       'M.E.',
       158,
       ' ' FROM DUAL
UNION ALL
SELECT 'R34G',
       'FLGTIP',
       5,
       '-',
       'Filial',
       159,
       ' ' FROM DUAL
);

/*-- SEQ 9081 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'R44G',
       TO_NUMBER(null),
       'R44G',
       'Restries 004 CK 4G',
       'TV_RES_004_CK4G',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9082 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'R44G','--','' FROM DUAL
UNION ALL
SELECT 'R44G','01','Identificao' FROM DUAL
UNION ALL
SELECT 'R44G','99','Outros' FROM DUAL
);

/*-- SEQ 9083 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23379,
       'CLI ',
       'R44G',
       '1',
       '0N',
       '',
       '',
       'R44G.FILCLI = CLI.FILCLI(+) AND
R44G.CODCLI = CLI.CODCLI(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 9084 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'R44G',
       '01',
       90,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 'R44G',
       '01',
       10,
       12,
       'DIVIDA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Dvida',
       'Dvida',
       '',
       'DIVIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'R44G',
       '01',
       80,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Cliente',
       'Filial onde foi cadastrado o cliente',
       'DFIL.CODFIL = R44G.FILCLI (+)',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'R44G',
       '01',
       20,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'R44G',
       '01',
       30,
       12,
       'LIMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'LIMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'R44G',
       '01',
       40,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'R44G',
       '01',
       50,
       12,
       'OCORRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ocorrncia',
       'Ocorrncia',
       '',
       'OCORRE',
       'F' FROM DUAL
UNION ALL
SELECT 'R44G',
       '01',
       60,
       17,
       'RESTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Restrio',
       'Restrio',
       '',
       'RESTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'R44G',
       '01',
       70,
       1,
       'TIPRES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Tipo de Restrio',
       '',
       'TIPRES',
       'F' FROM DUAL
);

/*-- SEQ 9085 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'R44G',
       'FLGTIP',
       0,
       '-',
       'Fsica',
       154,
       ' ' FROM DUAL
UNION ALL
SELECT 'R44G',
       'FLGTIP',
       1,
       '-',
       'Jurdica',
       155,
       ' ' FROM DUAL
UNION ALL
SELECT 'R44G',
       'FLGTIP',
       2,
       '-',
       'Entidade',
       156,
       ' ' FROM DUAL
UNION ALL
SELECT 'R44G',
       'FLGTIP',
       3,
       '-',
       'Especial',
       157,
       ' ' FROM DUAL
UNION ALL
SELECT 'R44G',
       'FLGTIP',
       4,
       '-',
       'M.E.',
       158,
       ' ' FROM DUAL
UNION ALL
SELECT 'R44G',
       'FLGTIP',
       5,
       '-',
       'Filial',
       159,
       ' ' FROM DUAL
);

/*-- SEQ 9086 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'R4G ',
       TO_NUMBER(null),
       'R4G ',
       'Restries Cli. CK4G',
       'TV_RES_CK4G',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9087 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'R4G ','--','' FROM DUAL
UNION ALL
SELECT 'R4G ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'R4G ','99','Outros' FROM DUAL
);

/*-- SEQ 9088 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'R4G ',
       '01',
       10,
       12,
       'DIVIDA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Dvida',
       'Dvida',
       '',
       'DIVIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'R4G ',
       '01',
       20,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       '9',
       'F',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'R4G ',
       '01',
       30,
       12,
       'LIMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'LIMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'R4G ',
       '01',
       40,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'R4G ',
       '01',
       50,
       12,
       'OCORRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ocorrncia',
       'Ocorrncia',
       '',
       'OCORRE',
       'F' FROM DUAL
UNION ALL
SELECT 'R4G ',
       '01',
       60,
       17,
       'RESTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Restrio',
       'Restrio',
       '',
       'RESTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'R4G ',
       '01',
       70,
       1,
       'TIPRES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'N',
       'F',
       'Tipo de Restrio',
       'Tipo de Restrio',
       '',
       'TIPRES',
       'T' FROM DUAL
);

/*-- SEQ 9089 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'R4G ',
       'FLGTIP',
       0,
       '-',
       'Fsica',
       154,
       ' ' FROM DUAL
UNION ALL
SELECT 'R4G ',
       'FLGTIP',
       1,
       '-',
       'Jurdica',
       155,
       ' ' FROM DUAL
UNION ALL
SELECT 'R4G ',
       'FLGTIP',
       2,
       '-',
       'Entidade',
       156,
       ' ' FROM DUAL
UNION ALL
SELECT 'R4G ',
       'FLGTIP',
       3,
       '-',
       'Especial',
       157,
       ' ' FROM DUAL
UNION ALL
SELECT 'R4G ',
       'FLGTIP',
       4,
       '-',
       'M.E.',
       158,
       ' ' FROM DUAL
UNION ALL
SELECT 'R4G ',
       'FLGTIP',
       5,
       '-',
       'Filial',
       159,
       ' ' FROM DUAL
UNION ALL
SELECT 'R4G ',
       'TIPRES',
       4,
       ' ',
       'CHEQUES TERCEIROS DEVOLVIDOS',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'R4G ',
       'TIPRES',
       6,
       ' ',
       'CONSTA NO SPC',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'R4G ',
       'TIPRES',
       5,
       ' ',
       'CLIENTE REGISTRADO NO SPC',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'R4G ',
       'TIPRES',
       7,
       ' ',
       'TITULOS EM ATRASO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'R4G ',
       'TIPRES',
       3,
       ' ',
       'CLIENTE COM PARCELAS EM ATRASO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'R4G ',
       'TIPRES',
       1,
       ' ',
       'LIMITE DE CRDITO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'R4G ',
       'TIPRES',
       2,
       ' ',
       'CNPJ/CPF TEM CHEQUE DEVOLVIDOS',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9090 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'R54G',
       TO_NUMBER(null),
       'R54G',
       'Restries 005 CK 4G',
       'TV_RES_005_CK4G',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9091 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'R54G','--','' FROM DUAL
UNION ALL
SELECT 'R54G','01','Identificao' FROM DUAL
UNION ALL
SELECT 'R54G','99','Outros' FROM DUAL
);

/*-- SEQ 9092 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23380,
       'CLI ',
       'R54G',
       '1',
       '0N',
       '',
       '',
       'R54G.FILCLI = CLI.FILCLI(+) AND
R54G.CODCLI = CLI.CODCLI(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 9093 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'R54G',
       '01',
       90,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 'R54G',
       '01',
       10,
       12,
       'DIVIDA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Dvida',
       'Dvida',
       '',
       'DIVIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'R54G',
       '01',
       80,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Cliente',
       'Filial onde foi cadastrado o cliente',
       'DFIL.CODFIL = R54G.FILCLI (+)',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'R54G',
       '01',
       20,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       '9',
       'F',
       'Tipo Flag.',
       'Flag',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'R54G',
       '01',
       30,
       12,
       'LIMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Limite Crdito',
       'Limite Crdito',
       '',
       'LIMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'R54G',
       '01',
       40,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Documento',
       'Nmero Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'R54G',
       '01',
       50,
       12,
       'OCORRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero Ocorrncias',
       'Nmero de Ocorrncias',
       '',
       'OCORRE',
       'F' FROM DUAL
UNION ALL
SELECT 'R54G',
       '01',
       60,
       31,
       'RESTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Restries',
       'Restries',
       '',
       'RESTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'R54G',
       '01',
       70,
       12,
       'TIPRES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Tipo Restries',
       '',
       'TIPRES',
       'F' FROM DUAL
);

/*-- SEQ 9094 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'R54G',
       'FLGTIP',
       0,
       '-',
       'Fsica',
       154,
       ' ' FROM DUAL
UNION ALL
SELECT 'R54G',
       'FLGTIP',
       1,
       '-',
       'Jurdica',
       155,
       ' ' FROM DUAL
UNION ALL
SELECT 'R54G',
       'FLGTIP',
       2,
       '-',
       'Entidade',
       156,
       ' ' FROM DUAL
UNION ALL
SELECT 'R54G',
       'FLGTIP',
       3,
       '-',
       'Especial',
       157,
       ' ' FROM DUAL
UNION ALL
SELECT 'R54G',
       'FLGTIP',
       4,
       '-',
       'M.E.',
       158,
       ' ' FROM DUAL
UNION ALL
SELECT 'R54G',
       'FLGTIP',
       5,
       '-',
       'Filial',
       159,
       ' ' FROM DUAL
);

/*-- SEQ 9095 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'R64G',
       TO_NUMBER(null),
       'R64G',
       'Restries 006 CK 4G',
       'TV_RES_006_CK4G',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9096 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'R64G','--','' FROM DUAL
UNION ALL
SELECT 'R64G','01','Identificao' FROM DUAL
UNION ALL
SELECT 'R64G','99','Outros' FROM DUAL
);

/*-- SEQ 9097 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23381,
       'CLI ',
       'R64G',
       '1',
       '0N',
       '',
       '',
       'R64G.FILCLI = CLI.FILCLI(+) AND
R64G.CODCLI = CLI.CODCLI(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 9098 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'R64G',
       '01',
       90,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 'R64G',
       '01',
       10,
       12,
       'DIVIDA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Dvida',
       'Dvida',
       '',
       'DIVIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'R64G',
       '01',
       80,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Cliente',
       'Filial onde foi cadastrado o cliente',
       'DFIL.CODFIL = R64G.FILCLI (+)',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'R64G',
       '01',
       20,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       '9',
       'F',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'R64G',
       '01',
       30,
       12,
       'LIMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'LIMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'R64G',
       '01',
       40,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'R64G',
       '01',
       50,
       12,
       'OCORRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ocorrncia',
       'Ocorrncia',
       '',
       'OCORRE',
       'F' FROM DUAL
UNION ALL
SELECT 'R64G',
       '01',
       60,
       17,
       'RESTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Restrio',
       'Restrio',
       '',
       'RESTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'R64G',
       '01',
       70,
       1,
       'TIPRES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Tipo de Restrio',
       '',
       'TIPRES',
       'F' FROM DUAL
);

/*-- SEQ 9099 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'R64G',
       'FLGTIP',
       0,
       '-',
       'Fsica',
       154,
       ' ' FROM DUAL
UNION ALL
SELECT 'R64G',
       'FLGTIP',
       1,
       '-',
       'Jurdica',
       155,
       ' ' FROM DUAL
UNION ALL
SELECT 'R64G',
       'FLGTIP',
       2,
       '-',
       'Entidade',
       156,
       ' ' FROM DUAL
UNION ALL
SELECT 'R64G',
       'FLGTIP',
       3,
       '-',
       'Especial',
       157,
       ' ' FROM DUAL
UNION ALL
SELECT 'R64G',
       'FLGTIP',
       4,
       '-',
       'M.E.',
       158,
       ' ' FROM DUAL
UNION ALL
SELECT 'R64G',
       'FLGTIP',
       5,
       '-',
       'Filial',
       159,
       ' ' FROM DUAL
);

/*-- SEQ 9100 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RAT ',
       TO_NUMBER(null),
       'RAT ',
       'RAT(Rel. Ativ. Tc.)',
       'TT_RAT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'RAT.CODFIL,RAT.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9101 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RAT ','--','' FROM DUAL
UNION ALL
SELECT 'RAT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RAT ','99','Outros' FROM DUAL
);

/*-- SEQ 9102 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 16050,
       'CLI ',
       'RAT ',
       'N ',
       '1 ',
       '',
       '',
       'RAT.FILCLI = CLI.FILCLI AND
RAT.CODCLI = CLI.CODCLI  ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 16051,
       'PRJ ',
       'RAT ',
       'N ',
       '1 ',
       '',
       '',
       'PRJ.CODFIL = RAT.FILPRJ AND
PRJ.SEQUEN = RAT.SEQPRJ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 16052,
       'REL ',
       'RAT ',
       'N ',
       '1 ',
       '',
       '',
       'REL.FILPAR = RAT.FILPAR AND
REL.CODPAR = RAT.FILPAR AND
REL.TIPPAR = RAT.TIPPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 16053,
       'CON ',
       'RAT ',
       'N ',
       '1 ',
       '',
       '',
       'CON.FILCLI = RAT.FILCLI AND
CON.CODCLI = RAT.CODCLI AND
CON.NUMCON = RAT.NUMCON',
       '',
       '' FROM DUAL
);

/*-- SEQ 9103 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RAT ',
       '01',
       130,
       3,
       'CODAPR',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Aprovao feita por',
       'Aprovao feita por',
       'USU.FILUSU(+) = RAT.FILAPR  AND USU.CODUSU(+) = RAT.CODAPR',
       'CODAPR',
       'T' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo~Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       200,
       6,
       'CODCRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd.Par.~Criao RAT',
       'Cdigo Parceiro que criou RAT',
       '',
       'CODCRI',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = RAT.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       210,
       6,
       'CODPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo~Parceiro',
       'Cdigo Parceiro',
       '',
       'CODPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       30,
       3,
       'CODRES',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Responsvel',
       'Cdigo Responsvel',
       'USU.FILUSU(+) = RAT.FILRES AND USU.CODUSU(+) = RAT.CODRES',
       'CODRES',
       'T' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       100,
       6,
       'CODREV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo da Revenda',
       'Cdigo da Revenda',
       '',
       'CODREV',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       140,
       4000,
       'COMENT',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cometrios',
       'Cometrios',
       '',
       'COMENT',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       40,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       150,
       3,
       'FILAPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial',
       'Filial do aprovador',
       '',
       'FILAPR',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       50,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       220,
       3,
       'FILCRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial~criao RAT',
       'Filial criao da RAT',
       '',
       'FILCRI',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       230,
       3,
       'FILPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       180,
       3,
       'FILPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Cdigo Filial do Projeto',
       '',
       'FILPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       60,
       3,
       'FILRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Responsvel',
       '',
       'FILRES',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       110,
       3,
       'FILREV',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Revenda',
       'DFIL.CODFIL = RAT.FILREV',
       'FILREV',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       70,
       4,
       'NUMCON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero Contato',
       'Nmero Contato',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       240,
       6,
       'NUMCRI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero~Criao RAT',
       '',
       '',
       'NUMCRI',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       120,
       4,
       'NUMREV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero da Revenda',
       'Nmero da Revenda',
       '',
       'NUMREV',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       190,
       10,
       'SEQPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador do Projeto',
       '',
       'SEQPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       80,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero RAT',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       160,
       1,
       'SITFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao Fat.',
       'Situao Faturamento',
       '',
       'SITFAT',
       'T' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       170,
       1,
       'SITPAG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao PGTO',
       'Situao PGTO',
       '',
       'SITPAG',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       90,
       1,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       250,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Tipo de Parceiro',
       'Tipo de Parceiro',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       270,
       12,
       'VLRCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor para Consultor',
       'Valor para Consultor',
       '',
       'VLRCON',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       280,
       12,
       'VLRCONCAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor para Consultor',
       'Valor calculado para consultor',
       '',
       'VLRCONCAL',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       260,
       14,
       'VLRHOR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Hora',
       'Valor Hora',
       '',
       'VLRHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       290,
       12,
       'VLRTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor para Cliente',
       'Valor total calculado para cliente',
       '',
       'VLRTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'RAT ',
       '01',
       300,
       12,
       'VLRTOTCAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Total para Cliente',
       'Valor total para cliente',
       '',
       'VLRTOTCAL',
       'F' FROM DUAL
);

/*-- SEQ 9104 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'RAT ',
       'SITFAT',
       0,
       '1',
       'Faturado Recebimento Cliente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RAT ',
       'SITFAT',
       0,
       '2',
       'Reprovada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RAT ',
       'SITFAT',
       0,
       'A',
       'Em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RAT ',
       'SITFAT',
       0,
       'C',
       'Faturado Pagamento Consultor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RAT ',
       'SITFAT',
       0,
       'F',
       'Autorizar Recebimento Cliente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RAT ',
       'SITFAT',
       0,
       'Z',
       'Autorizar Pagamento Consultor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RAT ',
       'SITPAG',
       0,
       '1',
       'Paga',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RAT ',
       'SITPAG',
       0,
       '2',
       'Reprovada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RAT ',
       'SITPAG',
       0,
       'A',
       'Em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RAT ',
       'SITPAG',
       0,
       'P',
       ' Pagar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RAT ',
       'STATUS',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RAT ',
       'STATUS',
       0,
       'C',
       'Concludo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RAT ',
       'STATUS',
       0,
       'R',
       'Com Restries',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9105 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RCAI',
       TO_NUMBER(null),
       'RCAI',
       'Resumo de Caixa',
       'TR_CAI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'RCAI.CODFIL,RCAI.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9106 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RCAI','--','' FROM DUAL
UNION ALL
SELECT 'RCAI','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RCAI','02','Datas' FROM DUAL
UNION ALL
SELECT 'RCAI','03','Valores' FROM DUAL
UNION ALL
SELECT 'RCAI','99','Outros' FROM DUAL
);

/*-- SEQ 9107 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 24118,
       'OPE ',
       'RCAI',
       'N',
       '1',
       '',
       '',
       'RCAI.CODFIL=OPE.CODFIL AND RCAI.NUMECF=OPE.NUMECF AND OPE.TRN_ID BETWEEN RCAI.ID_INI AND RCAI.ID_FIM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 24119,
       'VCAI',
       'RCAI',
       '1',
       '1',
       '',
       '',
       'rcai.codfil = vcai.codfil and
rcai.sequen = vcai.sequen',
       '',
       '' FROM DUAL
UNION ALL
SELECT 24447,
       'LID ',
       'RCAI',
       'N',
       '1',
       '',
       '',
       'RCAI.CODFIL=LID.CODFIL AND 
RCAI.NUMECF=LID.NUMECF AND 
LID.TRN_ID BETWEEN RCAI.ID_INI AND RCAI.ID_FIM',
       '',
       '' FROM DUAL
);

/*-- SEQ 9108 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RCAI',
       '01',
       10,
       6,
       'ARQCAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Arquivo Caixa',
       'Arquivo Caixa',
       '',
       'ARQCAI',
       'F' FROM DUAL
UNION ALL
SELECT 'RCAI',
       '01',
       20,
       254,
       'ARQXLS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Arquivo Caixa EXCEL',
       'Arquivo Caixa Excel',
       '',
       'ARQXLS',
       'F' FROM DUAL
UNION ALL
SELECT 'RCAI',
       '--',
       190,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Assinatura para PAF-ECF',
       '',
       'ASSINA',
       'F' FROM DUAL
UNION ALL
SELECT 'RCAI',
       '01',
       180,
       10,
       'CAI_ID',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo caixa (CK4G)',
       'Cdigo interno do caixa no Checkout 4G',
       '',
       'CAI_ID',
       '' FROM DUAL
UNION ALL
SELECT 'RCAI',
       '01',
       170,
       5,
       'CNT_RO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cont. Reinicio Oper.',
       'Contador de Reinicio de Operao',
       '',
       'CNT_RO',
       'F' FROM DUAL
UNION ALL
SELECT 'RCAI',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = RCAI.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'RCAI',
       '--',
       200,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Identificao de Acesso',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'RCAI',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'RCAI.FILUSU = USU.FILUSU(+)  AND RCAI.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'RCAI',
       '03',
       50,
       6,
       'CUPFIM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cupom~Final',
       'Cupom Final',
       '',
       'CUPFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'RCAI',
       '03',
       60,
       6,
       'CUPINI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cupom~Inicial',
       'Cupom Inicial',
       '',
       'CUPINI',
       'F' FROM DUAL
UNION ALL
SELECT 'RCAI',
       '02',
       70,
       7,
       'DATABE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Abertura',
       'Data Abertura',
       '',
       'DATABE',
       'F' FROM DUAL
UNION ALL
SELECT 'RCAI',
       '02',
       80,
       7,
       'DATFEC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fechamento',
       'Data Fechamento',
       '',
       'DATFEC',
       'F' FROM DUAL
UNION ALL
SELECT 'RCAI',
       '02',
       90,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operacao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'RCAI',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'RCAI',
       '01',
       150,
       12,
       'ID_FIM',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'ID Fim',
       'ID Fim',
       '',
       'ID_FIM',
       'F' FROM DUAL
UNION ALL
SELECT 'RCAI',
       '01',
       160,
       12,
       'ID_INI',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'ID Ini',
       'ID Ini',
       '',
       'ID_INI',
       'F' FROM DUAL
UNION ALL
SELECT 'RCAI',
       '01',
       110,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'ECF',
       'Nmero do ECF',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'RCAI',
       '99',
       120,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'RCAI',
       '03',
       130,
       12,
       'VLRDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Diferenca',
       'Valor Diferena',
       '',
       'VLRDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'RCAI',
       '03',
       140,
       12,
       'VLRFEC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Fechamento',
       'Valor Fechamento',
       '',
       'VLRFEC',
       'F' FROM DUAL
);

/*-- SEQ 9109 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RCP ',
       TO_NUMBER(null),
       'RCP ',
       'Recepo de Produtos',
       'TT_RCP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'RCP.FILFOR,RCP.CODFOR,RCP.CODSER,RCP.SUBSER,RCP.NUMNOT',
       '' FROM DUAL
);

/*-- SEQ 9110 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RCP ','--','' FROM DUAL
);

/*-- SEQ 9111 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 5813,
       'PVD ',
       'RCP ',
       '1',
       'N',
       '',
       '',
       'PVD.FILPAR = RCP.FILFOR and
PVD.CODPAR = RCP.CODFOR and
PVD.TIPPAR = RCP.TIPFOR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 5814,
       'REL ',
       'RCP ',
       '1',
       'N',
       '',
       '',
       'REL.FILPAR = RCP.FILFOR AND
REL.CODPAR = RCP.CODFOR AND
REL.TIPPAR = RCP.TIPFOR
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 5815,
       'USU ',
       'RCP ',
       '1',
       'N',
       '',
       '',
       'USU.FILUSU = RCP.FILUSU AND
USU.CODUSU = RCP.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 9112 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RCP ',
       '--',
       35,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano~Atualizao',
       'Ano de Data da ltima atualizao',
       '',
       'TO_CHAR(RCP.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'RCP ',
       '--',
       105,
       4,
       'ANO_DATRCP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data Recepo',
       'Ano de Data Recepo',
       '',
       'TO_CHAR(RCP.DATRCP,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'RCP ',
       '--',
       30,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Data da ltima atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'RCP ',
       '--',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'RCP.CODFIL = DFIL.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'RCP ',
       '--',
       110,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo do Fornecedor',
       'Cdigo do Fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'RCP ',
       '--',
       130,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Srie',
       'Srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'RCP ',
       '--',
       140,
       3,
       'CODSUP',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Responsvel',
       'Responsvel pela autorizao',
       'RCP.FILUSU = USU.FILUSU(+) and RCP.CODUSU = USU.CODUSU(+)',
       'CODSUP',
       'T' FROM DUAL
UNION ALL
SELECT 'RCP ',
       '--',
       120,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Usurio',
       'Usurio',
       'RCP.FILUSU = USU.FILUSU(+) and RCP.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'RCP ',
       '--',
       100,
       8,
       'DATRCP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Recepo',
       'Data Recepo',
       '',
       'DATRCP',
       'F' FROM DUAL
UNION ALL
SELECT 'RCP ',
       '--',
       40,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial do fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'RCP ',
       '--',
       150,
       3,
       'FILSUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do responsvel pela autorizao',
       '',
       'FILSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'RCP ',
       '--',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'RCP ',
       '--',
       50,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'RCP ',
       '--',
       33,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms~Atualizao',
       'Ms de Data da ltima atualizao',
       '',
       'TO_CHAR(RCP.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'RCP ',
       '--',
       103,
       2,
       'MES_DATRCP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data Recepo',
       'Ms de Data Recepo',
       '',
       'TO_CHAR(RCP.DATRCP,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'RCP ',
       '--',
       80,
       9,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nro da Nota',
       'Nro da Nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'RCP ',
       '--',
       161,
       5,
       'NUMVOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nro de Volumes',
       '',
       '',
       'NUMVOL',
       'F' FROM DUAL
UNION ALL
SELECT 'RCP ',
       '--',
       160,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(RCP.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'RCP ',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'RCP ',
       '--',
       70,
       3,
       'SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Sub-Srie',
       'Sub-Srie',
       '',
       'SUBSER',
       'F' FROM DUAL
UNION ALL
SELECT 'RCP ',
       '--',
       60,
       1,
       'TIPFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de parceiro',
       'Tipo de parceiro',
       '',
       'TIPFOR',
       'T' FROM DUAL
);

/*-- SEQ 9113 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'RCP ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RCP ',
       'FLGEST',
       0,
       'E',
       'Entregue',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RCP ',
       'TIPFOR',
       0,
       'F',
       'Fornecedor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RCP ',
       'TIPFOR',
       0,
       'T',
       'Transportadora',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9114 --*/
INSERT INTO TT_ARQ(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,
       DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
       VALUES('RCT ',
              null,
              'RCT ',
              'Receitas',
              'TT_RCT',
              'F',
              '',
              'TOTALL',
              '',
              '',
              '',
              '',
              '',
              'T',
              '',
              '',
              '');
/*-- SEQ 9115 --*/
INSERT INTO TT_GRU ( CODTAB, CODGRU, DESGRU)
       VALUES ('RCT ','--','');
/*-- SEQ 9116 --*/
INSERT INTO TT_GRU ( CODTAB, CODGRU, DESGRU)
       VALUES ('RCT ','01','Identificao');
/*-- SEQ 9117 --*/
INSERT INTO TT_GRU ( CODTAB, CODGRU, DESGRU)
       VALUES ('RCT ','99','Outros');
/*-- SEQ 9118 --*/
INSERT INTO TT_SQL (NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)                                                                                             
       VALUES (15162,'IVE ','RCT ',                                   
               '0N','01','','',
               'IVE.FILRCT = RCT.CODFIL and IVE.SEQRCT = RCT.SEQUEN','');
/*-- SEQ 9119 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('RCT ',
              '--',
              10,
              3,
              'CODFIL',
              'A',
              'DFIL',
              0,
              null,
              '',
              null,
              30,
              '',
              'DFIL.NOMFIL',
              'V',
              '',
              'F',
              'A',
              'F',
              'Filial',
              'Filial',
              'DFIL.CODFIL = RCT.CODFIL(+)',
              'CODFIL',
              'T');
/*-- SEQ 9120 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('RCT ',
              '--',
              20,
              7,
              'DATRCT',
              '@',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'I',
              '',
              '',
              'D',
              'F',
              'Data Receita',
              'Data Receita',
              '',
              'DATRCT',
              'F');
/*-- SEQ 9121 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('RCT ',
              '--',
              30,
              40,
              'NOMPAC',
              'A',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'A',
              '',
              '',
              'A',
              'F',
              'Nome Paciente',
              'Nome Paciente',
              '',
              'NOMPAC',
              'F');
/*-- SEQ 9122 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('RCT ',
              '--',
              40,
              20,
              'NUMRCT',
              'A',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'I',
              '',
              '',
              '9',
              'F',
              'Nmero Receita',
              'Nmero Receita',
              '',
              'NUMRCT',
              'F');
/*-- SEQ 9123 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('RCT ',
              '--',
              50,
              15,
              'RG_PAC',
              'A',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              'A',
              '',
              '',
              'A',
              'F',
              'RG Paciente',
              'RG Paciente',
              '',
              'RG_PAC',
              'F');
/*-- SEQ 9124 --*/
INSERT INTO TT_LAY(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,
       ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,
       VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
       VALUES('RCT ',
              '--',
              60,
              10,
              'SEQUEN',
              'A',
              '',
              0,
              null,
              '',
              null,
              null,
              '',
              '',
              '',
              '',
              '',
              '',
              'F',
              '',
              '',
              '',
              'SEQUEN',
              'F');

/*-- SEQ 9125 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RCXG',
       TO_NUMBER(null),
       'RCXG',
       'Resumo Sug. Venda',
       'TR_CXG',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'RCXG.FILMAT,RCXG.CODMAT,RCXG.CODCOR,RCXG.CODTAM',
       '' FROM DUAL
);

/*-- SEQ 9126 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RCXG','--','' FROM DUAL
UNION ALL
SELECT 'RCXG','10','Produto' FROM DUAL
UNION ALL
SELECT 'RCXG','20','Sugestao' FROM DUAL
);

/*-- SEQ 9127 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RCXG',
       '10',
       10,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Diviso do produto',
       'RCXG.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'RCXG',
       '20',
       20,
       5,
       'CODCXG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Sugesto',
       'Cdigo Sugesto',
       '',
       'CODCXG',
       'F' FROM DUAL
UNION ALL
SELECT 'RCXG',
       '10',
       30,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'RCXG',
       '10',
       40,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'RCXG.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'RCXG',
       '20',
       50,
       5,
       'CORCXG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Diviso Sugesto',
       'Diviso Sugesto',
       '',
       'CORCXG',
       'F' FROM DUAL
UNION ALL
SELECT 'RCXG',
       '20',
       60,
       3,
       'FILCXG',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial Sugesto',
       'Filial Sugesto',
       'DFIL.CODFIL = RCXG.FILCXG',
       'FILCXG',
       'F' FROM DUAL
UNION ALL
SELECT 'RCXG',
       '10',
       70,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'RCXG',
       '20',
       80,
       5,
       'TAMCXG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Sub-Diviso Sugesto',
       'Sub-Diviso Sugesto',
       '',
       'TAMCXG',
       'F' FROM DUAL
);

/*-- SEQ 9128 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RDP ',
       TO_NUMBER(null),
       'RDP ',
       'Romaneio Documentos',
       'TT_RDP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'RDP.CODFIL,RDP.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9129 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RDP ','--','' FROM DUAL
UNION ALL
SELECT 'RDP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RDP ','99','Outros' FROM DUAL
);

/*-- SEQ 9130 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5818,
       'USU ',
       'RDP ',
       '1 ',
       'N ',
       '',
       '',
       'USU.CODUSU = RDP.CODUSU AND
USU.FILUSU = RDP.FILUSU',
       '' FROM DUAL
);

/*-- SEQ 9131 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RDP ',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial ',
       'Codigo da Filial',
       'DFIL.CODFIL = RDP.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'RDP ',
       '--',
       20,
       3,
       'CODREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Recebimento',
       'Cdigo do Recebimento',
       '',
       'CODREC',
       'F' FROM DUAL
UNION ALL
SELECT 'RDP ',
       '--',
       30,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Codigo do Usuario',
       'RDP.FILUSU = USU.FILUSU(+)  AND RDP.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'RDP ',
       '--',
       40,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Hora',
       'Data Hora',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'RDP ',
       '--',
       50,
       7,
       'DATREC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Recebimento',
       'Data Recebimento',
       '',
       'DATREC',
       'F' FROM DUAL
UNION ALL
SELECT 'RDP ',
       '--',
       60,
       3,
       'FILDES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Destino',
       'Filial Destino',
       '',
       'FILDES',
       'F' FROM DUAL
UNION ALL
SELECT 'RDP ',
       '--',
       70,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'RDP ',
       '--',
       80,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial Usuario',
       '',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'RDP ',
       '--',
       90,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'RDP ',
       '--',
       100,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 9132 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'RDP ',
       'FLGEST',
       0,
       'C',
       'C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RDP ',
       'FLGEST',
       0,
       'G',
       'G',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RDP ',
       'FLGEST',
       0,
       'R',
       'R',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9133 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RDV ',
       TO_NUMBER(null),
       'RDV ',
       'Recebimento de DAVs',
       'TT_RDV',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'RDV.CODFIL, RDV.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9134 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RDV ','--','' FROM DUAL
UNION ALL
SELECT 'RDV ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RDV ','99','Outros' FROM DUAL
);

/*-- SEQ 9135 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20285,
       'ORC ',
       'RDV ',
       '1',
       '01',
       '',
       '',
       'RDV.CODFIL = ORC.CODFIL AND
RDV.TIPPED = ORC.TIPPED AND
RDV.NUMPED = ORC.NUMPED',
       '',
       '' FROM DUAL
);

/*-- SEQ 9136 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RDV ',
       '--',
       11,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       21,
       4,
       'BANEMI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cd. Banco Emissor',
       'Cdigo do Banco Emissor',
       '',
       'BANEMI',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       31,
       9,
       'CEPTIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'CEP do Titular',
       'CEP do Titular',
       '',
       'CEPTIT',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       41,
       20,
       'CIDTIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cidade do Titular',
       'Cidade do Titular',
       '',
       'CIDTIT',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       51,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       61,
       3,
       'CODNAC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd Naciona. Emissor',
       'Cdigo da Nacionalidade do Emissor',
       '',
       'CODNAC',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       71,
       7,
       'DATEMI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data e Hora Emissor',
       'Data e Hora da Emisso',
       '',
       'DATEMI',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       81,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       91,
       7,
       'DATPAG',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Hora Pagamento',
       'Data e Hora do Pagamento',
       '',
       'DATPAG',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       101,
       7,
       'DATVEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data do Vencimento',
       'Data do Vencimento',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       111,
       20,
       'ENDTIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Endereo do Titular',
       'Endereo do Titular',
       '',
       'ENDTIT',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       121,
       5,
       'ESTTIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Estado do Titular',
       'Estado do Titular',
       '',
       'ESTTIT',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       261,
       20,
       'EXTCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd. Externo Carto',
       'Cdigo Externo da Bandeira do Carto',
       '',
       'EXTCAR',
       '' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       131,
       20,
       'ID_TRN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm. Seq. nico',
       'Nmero Sequencial nico / Cdigo de identificao da Transao',
       '',
       'ID_TRN',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       141,
       4,
       'LOGREF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'LogRef',
       'LogRef',
       '',
       'LOGREF',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       271,
       20,
       'NOSNUM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nosso Nmero',
       'Nosso nmero',
       '',
       'NOSNUM',
       '' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       151,
       20,
       'NUMAUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Autorizao',
       'Autorizao',
       '',
       'NUMAUT',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       161,
       30,
       'NUMCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Carto',
       'Nmero do Carto',
       '',
       'NUMCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       171,
       9,
       'NUMCPV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nm Comprovante Vend',
       'Nmero do Comprovante de Venda',
       '',
       'NUMCPV',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       181,
       40,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       1,
       8,
       'NUMPED',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nmero',
       'Nmero',
       '',
       'NUMPED',
       '' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       191,
       27,
       'NUMTRN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Autenticao',
       'Nmero da Autenticao / TID / Nmero da Transao',
       '',
       'NUMTRN',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       201,
       2,
       'QTDPAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'QTDPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       211,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       221,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo',
       '',
       'TIPPED',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       231,
       1,
       'TIPRDV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Recebimento',
       'Tipo de Recebimento',
       '',
       'TIPRDV',
       'T' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       281,
       4,
       'VLDCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Validade Carto',
       'Ms e Ano de Validade Carto',
       '',
       'VLDCAR',
       '' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       241,
       10,
       'VLRDOC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Valor do Documento',
       'Valor do Documento',
       '',
       'VLRDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'RDV ',
       '--',
       251,
       10,
       'VLRJUR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Juros',
       'Juros',
       '',
       'VLRJUR',
       'T' FROM DUAL
);

/*-- SEQ 9137 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'RDV ',
       'TIPRDV',
       0,
       '1',
       'Banco Brasil',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RDV ',
       'TIPRDV',
       0,
       '2',
       'Bradesco',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RDV ',
       'TIPRDV',
       0,
       '3',
       'Banrisul',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RDV ',
       'TIPRDV',
       0,
       '4',
       'HSBC',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RDV ',
       'TIPRDV',
       0,
       '5',
       'Itau',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RDV ',
       'TIPRDV',
       0,
       '9',
       'Pagamento Digital',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RDV ',
       'TIPRDV',
       0,
       'A',
       'Amex',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RDV ',
       'TIPRDV',
       0,
       'B',
       'Boleto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RDV ',
       'TIPRDV',
       0,
       'C',
       'PagSeguro Carto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RDV ',
       'TIPRDV',
       0,
       'D',
       'Dinners',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RDV ',
       'TIPRDV',
       0,
       'E',
       'Elo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RDV ',
       'TIPRDV',
       0,
       'H',
       'HiperCard',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RDV ',
       'TIPRDV',
       0,
       'M',
       'MasterCard',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RDV ',
       'TIPRDV',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RDV ',
       'TIPRDV',
       0,
       'P',
       'PagSeguro Boleto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RDV ',
       'TIPRDV',
       0,
       'S',
       'PagSeguro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RDV ',
       'TIPRDV',
       0,
       'U',
       'Aura',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RDV ',
       'TIPRDV',
       0,
       'V',
       'Visa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RDV ',
       'TIPRDV',
       0,
       'X',
       'Oramento',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9138 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'REC ',
       0,
       'REC ',
       'Recebimentos',
       'TT_REC',
       'T',
       '',
       'TOTALL',
       'Parcelas da Venda',
       '{CODFIL;NUMECF;CODSER;NUMNOT;NUMPAR;SUBPAR};FLGEST;DATPGT;DATVEN;ATU_EM',
       '',
       '',
       'VendaParcela',
       'T',
       '',
       'REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR
',
       '' FROM DUAL
);

/*-- SEQ 9139 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'REC ','--','' FROM DUAL
UNION ALL
SELECT 'REC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'REC ','02','Dados Gerais' FROM DUAL
UNION ALL
SELECT 'REC ','03','Funes' FROM DUAL
UNION ALL
SELECT 'REC ','04','Renegociao' FROM DUAL
UNION ALL
SELECT 'REC ','05','Parmetos Meio de Pagamento' FROM DUAL
UNION ALL
SELECT 'REC ','06','Valor Carteira' FROM DUAL
UNION ALL
SELECT 'REC ','07','A Receber' FROM DUAL
UNION ALL
SELECT 'REC ','08','Operao Caixa' FROM DUAL
);

/*-- SEQ 9140 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 26673,
       'PLA ',
       'REC ',
       '0N',
       '01',
       '',
       '',
       'PLA.FILPGT = REC.FILPGT(+) AND 
PLA.CODPGT = REC.CODPGT(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26674,
       'CHR ',
       'REC ',
       '1',
       'N',
       '',
       '',
       'rec.codfil = chr.codfil and
rec.seqche = chr.sequen
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26675,
       'CTM ',
       'REC ',
       'N',
       '1',
       '',
       '',
       'CTM.CODFIL = REC.CODFIL AND
CTM.SEQUEN = REC.SEQUEN AND
CTM.NUMPAR = REC.NUMPAR AND
CTM.SUBPAR = REC.SUBPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26676,
       'CTA ',
       'REC ',
       'N',
       '01',
       '',
       '',
       'REC.FILCTA = CTA.CODFIL AND REC.SEQCTA = CTA.SEQUEN AND REC.TIPCTA = CTA.TIPCTA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26677,
       'ITF ',
       'REC ',
       '01',
       '1',
       '',
       '',
       'REC.FILITF = ITF.CODFIL AND
REC.SEQITF = ITF.SEQUEN AND
REC.ITEITF = ITF.NUMITE',
       '',
       '' FROM DUAL
);

/*-- SEQ 9141 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'REC ',
       '06',
       410,
       8,
       ':REC.DATA_CARTEIRA',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data da Carteira',
       'Data da carteira',
       '',
       ':REC.DATA_CARTEIRA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '05',
       330,
       1,
       ':REC.FORMA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Forma',
       'Forma',
       '',
       ':REC.FORMA',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '07',
       430,
       8,
       ':REC.PR_DATA',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'A Receber em',
       'A Receber em',
       '',
       ':REC.PR_DATA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '07',
       440,
       6,
       ':REC.PR_DIAS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Dias Atraso > que',
       'Dias de atraso maior que',
       '',
       ':REC.PR_DIAS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5481,
       10,
       'APEPGT',
       'A',
       'PLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       '',
       '',
       'A',
       '',
       'Plano de Pagamento',
       'Plano de Pagamento',
       'REC.FILPGT = PLA.FILPGT(+) AND REC.CODPGT = PLA.CODPGT(+)',
       'APEPGT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '07',
       420,
       1,
       'ARECEBER_RETROATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'A Receber~Retroativo',
       'A Receber Retroativo',
       '',
       '(CASE WHEN(TRUNC(REC.DATINC) < :REC.PR_DATA AND (REC.DATVEN <= ADD_DAY(:REC.PR_DATA,:REC.PR_DIAS * -1)) )AND ((REC.FLGEST = ''A'' AND REC.CARTAO IS NULL AND REC.SEQCHE IS NULL) OR (TRUNC(REC.PAGAME) > :REC.PR_DATA)) THEN ''T'' ELSE ''F'' END)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       91,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN REC.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       230,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'REC ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'REC',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5460,
       1,
       'AVISTA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Paga  Vista?',
       'Parcela Paga  Vista?',
       '',
       'AVISTA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       20,
       5,
       'CARTAO',
       'S',
       'DCAR',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       'DCAR.DESOUT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Carto',
       'Carto de Crdito',
       'DCAR.CODTAB(+) = REC.CARTAO',
       'CARTAO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       290,
       15,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Alternativo',
       'Cdigo Alternativo nico',
       '',
       'CODEXT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       80,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       0,
       'REC ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'REC',
       'F',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'REC.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       220,
       2,
       'CODMOE',
       'S',
       'DMOE',
       0,
       0,
       'REC ',
       90,
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       'REC',
       'F',
       'A',
       'T',
       'Moeda',
       'Cdigo da moeda',
       'REC.CODMOE=DMOE.CODTAB (+)',
       'CODMOE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5264,
       5,
       'CODOUT',
       'S',
       'DOUT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DOUT.DESCAR',
       'V',
       '',
       '',
       'A',
       '',
       'Outros Meios Pag.',
       'Outros Meios de Pagamento',
       'DOUT.CODTAB = REC.CODOUT',
       'CODOUT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5480,
       3,
       'CODPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Cdigo do Plano',
       'Cdigo do Plano de Pagamento',
       '',
       'CODPGT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       150,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Usurio',
       'REC.FILUSU = USU.FILUSU(+)  AND REC.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       140,
       8,
       'CUPFIS',
       'A',
       '',
       0,
       0,
       'REC ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'REC',
       'F',
       '9',
       'T',
       'Cupom Fiscal',
       'Cupom fiscal',
       '',
       'CUPFIS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5410,
       1,
       'CUPFISNUMNOT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Nota?',
       'Cupom Rec = Nota?',
       '',
       '(SELECT CASE WHEN ISDIGIT(trim(REC.CUPFIS))<=0 OR ISDIGIT(trim(VEN.NUMNOT))=-1 THEN ''F'' WHEN TO_NUMBER(trim(REC.CUPFIS))=TO_NUMBER(trim(VEN.NUMNOT)) THEN ''T'' ELSE ''F'' END FROM TT_VEN VEN WHERE REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '03',
       250,
       12,
       'CalcRecAtu',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr. Corrigido',
       'Valor Corrigido da Parcela',
       '',
       'CALCRECATU(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR,0,REC.PAGAME)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       820,
       8,
       'DATAFATURAMENTOCARTAO',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Faturam. Carto',
       'Data Faturamento Carto',
       '',
       'DATAFATURAMENTOCARTAO(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       825,
       8,
       'DATA_PROMESSA',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Promessa',
       'Data Promessa',
       '',
       'TRAZ_DATPRO(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       845,
       7,
       'DATFIS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Fiscal',
       'Data Fiscal',
       '',
       'DATFIS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       340,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '--',
       5274,
       7,
       'DATPRE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Data prevista',
       'Data prevista',
       '',
       'DATPRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       180,
       8,
       'DATVEN',
       'D',
       '',
       0,
       0,
       'REC ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'REC',
       'F',
       'D',
       'T',
       'Vencimento',
       'Data de vencimento',
       '',
       'DATVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5202,
       4,
       'DIASATRASO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       '',
       'Dias em Atraso',
       'Dias em Atraso',
       '',
       'TRUNC(AGORA())-TRUNC(REC.DATVEN)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       840,
       2,
       'DIASFAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       '',
       'Dias Vencimento',
       'Dias Vencimento',
       '',
       'TRUNC(REC.DATVEN)-TRUNC(AGORA())',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       835,
       12,
       'DIFPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Diferena Pagamento',
       'Diferena Pagamento',
       '',
       'CALCDIFPAG(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       40,
       1,
       'DUMMY',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       '',
       'Dummy?',
       '',
       'DUMMY',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       176,
       8,
       'ESTCAN',
       'D',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Cancela/Estorno',
       'Data de Cancelamento/Estorno',
       '',
       'ESTCAN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5284,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Filial da Conta',
       'Filial da Conta',
       '',
       'FILCTA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5370,
       3,
       'FILITF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Filial Item Carto',
       'Filial Item Carto',
       '',
       'FILITF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5470,
       3,
       'FILPGT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial do Plano',
       'Filial do Plano de Pagamento',
       'DFIL.CODFIL(+) = REC.FILPGT',
       'FILPGT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       10,
       3,
       'FILREC',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       'REC ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial Recebimento',
       'Cdigo da filial do recebimento',
       'DFIL.CODFIL(+) = REC.FILREC',
       'FILREC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '04',
       5354,
       3,
       'FILREN',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial Venda Reneg.',
       'Filial Venda Renegociada',
       'DFIL.CODFIL(+) = REC.FILREN',
       'FILREN',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       160,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       130,
       1,
       'FLGEST',
       'A',
       '',
       0,
       0,
       'REC ',
       50,
       30,
       '',
       '',
       'D',
       'REC',
       'F',
       'A',
       'T',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       5450,
       1,
       'FLGESTITF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Situao venda',
       'Situao do pagamento Considerando carto de crdito',
       '',
       '(coalesce((SELECT ITF.FLGEST FROM TT_ITF ITF WHERE ITF.CODFIL = REC.FILITF AND ITF.SEQUEN = REC.SEQITF AND ITF.NUMITE = REC.ITEITF ),rec.flgest))',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '--',
       5294,
       1,
       'FLGFLU',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Proce p/ flux Finan?',
       'Processado pelo fluxo financeiro?',
       '',
       'FLGFLU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5390,
       5,
       'ITEITF',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Item Carto',
       'Item Carto',
       '',
       'ITEITF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '03',
       280,
       12,
       'JUROS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr. Juros',
       'Vlr. Juros',
       '',
       '(CASE WHEN COALESCE(REC.VLRJUROS,0) > 0 THEN ABS(REC.VLRJUROS) ELSE (CASE WHEN COALESCE(REC.VLRDES,0) > 0 AND REC.CARTAO IS NULL THEN ABS(REC.VLRDES) ELSE 0 END )END)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '03',
       245,
       12,
       'JUROSDESCONTOS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Juros~Descontos',
       'Exibe Descontos',
       '',
       'DESCONTOPARCELA(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) ',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       800,
       50,
       'MEIODEPAGAMDET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Pagamento',
       'Pagamento',
       '',
       'SUBSTR( CASE WHEN REC.SEQCHE IS NULL AND REC.CARTAO IS NULL AND REC.FLGEST IN (''A'',''X'',''C'') THEN NULL ELSE MEIODEPAGAMENTO( REC.CODFIL,REC.SEQUEN, REC.NUMPAR, REC.SUBPAR,0) END ,1,50)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '05',
       320,
       250,
       'MEIODEPAGAMENTO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Meio de Pagamento',
       'Meio de Pagamento',
       '',
       'RTRIM(SUBSTR(MEIODEPAGAMENTO(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR,:REC.FORMA),1,250))',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       345,
       250,
       'MEIO_DETALHADO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Meio PGTO(Detalhado)',
       'Meio PGTO(Detalhado)',
       '',
       'RTRIM(SUBSTR(MEIODEPAGAMENTO(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR,0),1,250))',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       840,
       20,
       'NOSNUM',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nosso nmero',
       'Nosso nmero',
       '',
       'RTF2TXT(CAST(TRAZNOSNUM(REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR) AS VARCHAR(20)))',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       5490,
       20,
       'NOSNUM_LOCAL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nosso Nmero local',
       'Nosso Nmero local (gravado no prprio recebimento)',
       '',
       'NOSNUM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       75,
       3,
       'NUMCODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo~da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       120,
       3,
       'NUMECF',
       'A',
       '',
       0,
       0,
       'REC ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'REC',
       'F',
       '0',
       'T',
       'ECF',
       'Nmero do ECF que recebeu a parcela',
       '',
       'NUMECF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       12,
       3,
       'NUMFILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo Filial Receb.',
       'Cdigo Filial Receb.',
       '',
       'FILREC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       810,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero~Parcela',
       'Nmero da Parcela',
       '',
       'NUMPAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       113,
       2,
       'NUMSUBPAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Sub-Parcela(Nmero)',
       'Sub-Parcela no formato numrico',
       '',
       'TO_NUMBER(REC.SUBPAR)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5400,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Observao de Baixa',
       'Observao de Baixa',
       '',
       'RTF2TXT(REC.OBSERV)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '08',
       830,
       4000,
       'OPERACAOCAIXA',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Operao Caixa',
       'Operao Caixa',
       '',
       'RTF2TXT(RTRIM(SUBSTR(OPERACAOCAIXA(''REC'',REC.CODFIL,REC.SEQUEN,REC.NUMPAR,REC.SUBPAR),1,50)))',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '--',
       5304,
       1,
       'ORIREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Origem Recebimento',
       'Origem Recebimento',
       '',
       'ORIREC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       170,
       8,
       'PAGAME',
       '@',
       '',
       0,
       0,
       'REC ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'REC',
       'F',
       '@',
       'T',
       'Data de Pagamento',
       'Data e hora de Pagamento',
       '',
       'PAGAME',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5440,
       8,
       'PAGAMECAR',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data pagamento',
       'Data do Pagamento Considerando carto de crdito',
       '',
       '(coalesce((SELECT ITF.datpgt FROM TT_ITF ITF WHERE ITF.CODFIL = REC.FILITF AND ITF.SEQUEN = REC.SEQITF AND ITF.NUMITE = REC.ITEITF ),rec.pagame))',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5204,
       8,
       'PAGAME_PERDAS',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       '',
       'Data Pagam. Perdas',
       'Data Pagamento para perda contabil (se aberto considera hoje)',
       '',
       'COALESCE(REC.PAGAME,AGORA())',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       105,
       5,
       'PARCELA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       '',
       'Parcela',
       'Parcela/Sub-Parcela',
       '',
       '(REC.NUMPAR || (CASE WHEN REC.SUBPAR = '' 0'' THEN '' '' ELSE ''-'' || LTRIM(REC.SUBPAR) END))',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       5440,
       1,
       'PARCELAQUITADA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Parcela Quitada?',
       'Parcela Quitada?',
       '',
       'CAST((SELECT CASE WHEN COUNT(*)>0 THEN ''F'' ELSE ''T'' END FROM TT_REC SUB WHERE SUB.CODFIL=REC.CODFIL AND SUB.SEQUEN=REC.SEQUEN AND SUB.NUMPAR=REC.NUMPAR AND SUB.FLGEST=''A'') AS CHAR(1))',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       5430,
       1,
       'PGTOVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Origem do Pagamento',
       'Saber se o Recebimento foi na venda ou de pagamento',
       '',
       '(SELECT CASE WHEN REC.PAGAME between ADD_SECOND(VEN.DATHOR,-1800) and ADD_second(VEN.DATHOR,1800) and rec.numecf=ven.numecf and datven = trunc(pagame) THEN ''T'' ELSE ''F'' END FROM TT_VEN VEN WHERE REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN)',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       210,
       2,
       'PORTAD',
       'S',
       'DCOB',
       0,
       0,
       'REC ',
       80,
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       'REC',
       'F',
       'A',
       'T',
       'Portador',
       'Cdigo do portador',
       'REC.PORTAD=DCOB.CODTAB (+)',
       'PORTAD',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '05',
       865,
       1,
       'PROCES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Processados',
       'Processados',
       '',
       'PROCES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       300,
       2,
       'RENEGO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Renegociao',
       'Renegociao',
       '',
       'RENEGO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       310,
       2,
       'RENORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Origem Renegociao',
       'Origem Renegociao',
       '',
       'RENORI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '03',
       60,
       10,
       'SEQCHE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave Cheque',
       'Chave Cheque',
       '',
       'SEQCHE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5314,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Sequncia da Conta',
       'Sequncia da Conta',
       '',
       'SEQCTA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5380,
       10,
       'SEQITF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Sequen. Item Carto',
       'Sequen. Item Carto',
       '',
       'SEQITF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '04',
       5364,
       10,
       'SEQREN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. Venda Reneg.',
       'Sequncia da  Venda Renegociada',
       '',
       'SEQREN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       70,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       90,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN REC.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '--',
       5324,
       2,
       'SUBORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Origem sub parcela',
       'Origem sub parcela',
       '',
       'SUBORI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       110,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       0,
       'REC ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'REC',
       'F',
       '9',
       'T',
       'Sub-Parcela',
       'Nmero da sub-parcela',
       '',
       'SUBPAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       30,
       5,
       'TIPCCC',
       'S',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       'A',
       'F',
       'Tipo Conta Corrente',
       'Tipo Conta Corrente',
       'DCCC.CODTAB(+) = REC.TIPCCC',
       'TIPCCC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5334,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo da Conta',
       'Tipo da Conta',
       '',
       'TIPCTA',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '--',
       831,
       150,
       'TITCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Conta Financeira',
       'Conta Financeira',
       '',
       '(SELECT CTA.TITCTA FROM TD_COB COB, TT_CTA CTA WHERE REC.PORTAD = COB.CODTAB AND COB.FILCTA = CTA.CODFIL AND COB.SEQCTA = CTA.SEQUEN AND COB.TIPCTA = CTA.TIPCTA)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5203,
       2,
       'VENCIDADIAS',
       'S',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vencidas(dias)',
       'Vencida a dias',
       '',
       'TRUNC(COALESCE(REC.PAGAME, AGORA())) - TRUNC(REC.DATVEN)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '01',
       830,
       1,
       'VERIFICADATA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Data Pgto~= a Venda?',
       'Data Pgto igual a Venda?',
       '',
       'CAST((SELECT CASE WHEN TRUNC(REC.PAGAME)=TRUNC(VEN.DATHOR) THEN ''T'' ELSE ''F'' END FROM TT_VEN VEN WHERE REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN) AS CHAR(1))',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5503,
       12,
       'VLRABATIMENTO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Abatimento Pagamento',
       'Valor de abatimento no pagamento',
       '',
       'VLRABATIMENTO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5502,
       12,
       'VLRACRES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Acrscimo Pagamento',
       'Valor de acrscimo no pagamento',
       '',
       'VLRACRES',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5340,
       12,
       'VLRAJUSTADO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Ajustado',
       'Valor Ajustado da Parcela',
       '',
       'CASE REC.FLGEST WHEN ''A'' THEN REC.VLRPAR WHEN ''P'' THEN REC.VLRPGT-COALESCE(REC.VLRDES,0)+COALESCE(REC.VLRTAX,0) WHEN ''C'' THEN COALESCE(REC.VLRDES,0)*-1 END',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '03',
       240,
       8,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       'REC ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'T',
       'Vlr. Desconto',
       'Vlr. Desconto',
       '',
       '(CASE WHEN COALESCE(REC.VLRDES,0) < 0 AND REC.CARTAO IS NULL THEN ABS(REC.VLRDES) ELSE 0 END)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5501,
       12,
       'VLRDESPAG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Desconto Pagamento',
       'Valor de desconto no pagamento',
       '',
       'VLRDESPAG',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5500,
       12,
       'VLRMULTA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Multa por atraso',
       'Valor de multa por atrazo no pagamento',
       '',
       'VLRMULTA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       200,
       8,
       'VLRPAR',
       'F',
       '',
       2,
       0,
       'REC ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'REC',
       'T',
       '9',
       'T',
       'Vlr. Parcela',
       'Valor da parcela',
       '',
       'VLRPAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       190,
       8,
       'VLRPGT',
       'F',
       '',
       2,
       0,
       'REC ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'REC',
       'T',
       '9',
       'T',
       'Vlr. Pago',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '--',
       5344,
       12,
       'VLRPRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor previsto',
       'Valor previsto',
       '',
       'VLRPRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       175,
       14,
       'VLRTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       '',
       'Vlr. Taxas',
       'Valor de Taxas',
       '',
       'VLRTAX',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5201,
       1,
       'VPARCIAL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Parcial?',
       'Parcial?',
       '',
       '(SELECT CASE WHEN COUNT(*)>0 AND REC.FLGEST=''P'' THEN ''T'' ELSE ''F'' END FROM TT_REC SUB WHERE SUB.CODFIL=REC.CODFIL AND SUB.SEQUEN=REC.SEQUEN AND SUB.NUMPAR=REC.NUMPAR AND SUB.SUBORI=REC.SUBPAR)',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'REC ',
       '02',
       5420,
       12,
       'VPGTPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       '',
       'Valor Pago Parcial',
       'Valor Pago Parcial',
       '',
       '(SELECT CASE WHEN COUNT(*)>0 AND REC.FLGEST=''P'' THEN REC.VLRPGT ELSE REC.VLRPAR END FROM TT_REC SUB WHERE SUB.CODFIL=REC.CODFIL AND SUB.SEQUEN=REC.SEQUEN AND SUB.NUMPAR=REC.NUMPAR AND SUB.SUBORI=REC.SUBPAR)',
       '',
       'D' FROM DUAL
);

/*-- SEQ 9142 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'REC ',
       ':REC.FORMA',
       0,
       '0',
       'DETALHADO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REC ',
       ':REC.FORMA',
       0,
       '1',
       'RESUMIDO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REC ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REC ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REC ',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REC ',
       'FLGEST',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REC ',
       'FLGESTITF',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REC ',
       'FLGESTITF',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REC ',
       'FLGESTITF',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REC ',
       'FLGESTITF',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REC ',
       'PGTOVEN',
       0,
       'F',
       'Recebimento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REC ',
       'PGTOVEN',
       0,
       'T',
       'Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REC ',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REC ',
       'VERIFICADATA',
       0,
       'F',
       'No',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REC ',
       'VERIFICADATA',
       0,
       'T',
       'Sim',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REC ',
       'VPARCIAL',
       0,
       'F',
       'No',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REC ',
       'VPARCIAL',
       0,
       'T',
       'Sim',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9143 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RECF',
       TO_NUMBER(null),
       'RECF',
       'Leitura Z',
       'TR_ECF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'RECF.CODFIL,RECF.NUMECF,RECF.DATOPE',
       '' FROM DUAL
);

/*-- SEQ 9144 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RECF','--','' FROM DUAL
UNION ALL
SELECT 'RECF','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RECF','99','Outros' FROM DUAL
);

/*-- SEQ 9145 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 30121,
       'RCAI',
       'RECF',
       'N',
       '1',
       '',
       '',
       'rcai.codfil = recf.codfil and
rcai.numecf = recf.numecf and
rcai.datope = recf.datope',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30122,
       'VEN ',
       'RECF',
       'N',
       '1',
       '',
       '',
       'VEN.CODFIL = RECF.CODFIL and
VEN.CODSER = (CASE WHEN SUBSTR(RECF.NUMECF,1,1) = ''1'' THEN ''TK'' ELSE ''CF'' END) and
VEN.NUMECF = RECF.NUMECF and
VEN.NUMNOT BETWEEN RECF.CUPINI AND RECF.CUPFIM
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30123,
       'VLUC',
       'RECF',
       'N',
       '1',
       '',
       '',
       'Vluc.CODFIL = RECF.CODFIL and
Vluc.CODSER = (CASE WHEN SUBSTR(RECF.NUMECF,1,1) = ''1'' THEN ''TK'' ELSE ''CF'' END) and
Vluc.NUMECF = RECF.NUMECF and
Vluc.NUMNOT BETWEEN RECF.CUPINI AND RECF.CUPFIM',
       '(case when vluc.vlrmov = 0  then 0 else (vluc.vlrmov /(recf.GT_FIM - recf.GT_INI)) end)',
       '' FROM DUAL
);

/*-- SEQ 9146 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RECF',
       '--',
       330,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Assinatura para PAF-ECF',
       '',
       'ASSINA',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '--',
       390,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data atualizao',
       'Data da ltima atualizao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'RECF',
       '01',
       280,
       5,
       'CNT_RO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cont. Reinicio Oper.',
       'Contador de Reinicio de Operao',
       '',
       'CNT_RO',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '99',
       10,
       4,
       'CNT_RZ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Contador Reduo Z',
       'Contador Reduo Z',
       '',
       'CNT_RZ',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = RECF.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '01',
       260,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '--',
       340,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Identificao de Acesso',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '01',
       30,
       6,
       'CUPFIM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'CF Final',
       'CF Final',
       '',
       'CUPFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '01',
       40,
       6,
       'CUPINI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'CF Inicial',
       'CF Inicial',
       '',
       'CUPINI',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '99',
       50,
       7,
       'DATFEC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fechamento',
       'Data Fechamento',
       '',
       'DATFEC',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '--',
       380,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '99',
       60,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Reduo Z',
       'Data da Reduo Z',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '--',
       320,
       7,
       'DATOPE_PAF',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       '',
       'Data de Operao para PAF-ECF',
       '',
       'DATOPE_PAF',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '99',
       70,
       1,
       'DIAFEC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Fechou Caixa',
       'Fechou Caixa',
       '',
       'COALESCE(RECF.DIAFEC,''@'')',
       'T' FROM DUAL
UNION ALL
SELECT 'RECF',
       '99',
       370,
       1,
       'EXPFIS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exportado Fiscal?',
       'Exportado Fiscal?',
       '',
       'EXPFIS',
       '' FROM DUAL
UNION ALL
SELECT 'RECF',
       '99',
       240,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Exporta?',
       'Exporta?',
       '',
       'EXPORT',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '99',
       80,
       16,
       'GT_FIM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Grande Total Final',
       'Grande Total Final',
       '',
       'GT_FIM',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '99',
       90,
       16,
       'GT_INI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Grande Total Inicial',
       'Grande Total Inicial',
       '',
       'GT_INI',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '--',
       290,
       4,
       'INTERV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'CRO',
       'Contador de reincio de operao',
       '',
       'INTERV',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '99',
       310,
       1,
       'MANUAL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Incluso manual',
       'Incluso manual',
       '',
       'MANUAL',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '01',
       100,
       3,
       'NUMECF',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       'F',
       'Nmero do ECF',
       'Nmero do ECF',
       'DECF.FILECF = RECF.CODFIL AND DECF.NUMECF = RECF.NUMECF',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '01',
       300,
       255,
       'OBSERV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '99',
       360,
       1,
       'PELAFD',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Corrigido pela F.D. ',
       'Corrigido pela Fita Detalhe',
       '',
       'PELAFD',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '99',
       110,
       6,
       'QTD_NF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Qtde NF Emitidas',
       'Qtde NF Emitidas',
       '',
       'QTD_NF',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '01',
       250,
       10,
       'SEQCRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       '(SELECT VEN.CODSER || ''/'' || VEN.NUMECF || ''-'' || VEN.NUMNOT FROM TT_VEN VEN WHERE VEN.CODFIL=RECF.CODFIL AND VEN.SEQUEN = RECF.SEQCRE)',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '99',
       180,
       12,
       'VLRBASICMS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Base ICMS',
       'Base ICMS',
       '',
       '(SELECT SUM(VLRBAS) FROM TT_ECF ECF WHERE ECF.CODFIL = RECF.CODFIL AND ECF.NUMECF = RECF.NUMECF AND ECF.DATOPE = RECF.DATOPE AND ECF.CNT_RO = RECF.CNT_RO AND ECF.TOTALI NOT IN (''0300'',''0500'',''CANC'',''DESC'',''SUBS'',''I_NT''))',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '99',
       190,
       12,
       'VLRBASISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Base ISS',
       'Base ISS',
       '',
       '(SELECT SUM(VLRBAS) FROM TT_ECF ECF WHERE ECF.CODFIL = RECF.CODFIL AND ECF.NUMECF = RECF.NUMECF AND ECF.DATOPE = RECF.DATOPE AND ECF.CNT_RO = RECF.CNT_RO AND ECF.TOTALI IN (''0300'',''0500''))',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '99',
       120,
       12,
       'VLRCAN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Cancelamento',
       'Cancelamento',
       '',
       '(SELECT VLRTOT FROM TT_ECF ECF WHERE ECF.CODFIL = RECF.CODFIL AND ECF.NUMECF = RECF.NUMECF AND ECF.DATOPE = RECF.DATOPE AND ECF.CNT_RO = RECF.CNT_RO AND ECF.TOTALI = ''CANC'')',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '99',
       130,
       12,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Descontos',
       'Descontos',
       '',
       '(SELECT VLRTOT FROM TT_ECF ECF WHERE ECF.CODFIL = RECF.CODFIL AND ECF.NUMECF = RECF.NUMECF AND ECF.DATOPE = RECF.DATOPE AND ECF.CNT_RO = RECF.CNT_RO AND ECF.TOTALI = ''DESC'')',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '99',
       170,
       12,
       'VLRICMS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'ICMS',
       'ICMS',
       '',
       '(SELECT SUM(VLRTOT) FROM TT_ECF ECF WHERE ECF.CODFIL = RECF.CODFIL AND ECF.NUMECF = RECF.NUMECF AND ECF.DATOPE = RECF.DATOPE AND ECF.CNT_RO = RECF.CNT_RO AND ECF.TOTALI NOT IN (''0300'',''0500'',''CANC'',''DESC'',''SUBS'',''I_NT''))',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '99',
       160,
       12,
       'VLRISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'ISS',
       'ISS',
       '',
       '(SELECT SUM(VLRTOT) FROM TT_ECF ECF WHERE ECF.CODFIL = RECF.CODFIL AND ECF.NUMECF = RECF.NUMECF AND ECF.DATOPE = RECF.DATOPE AND ECF.CNT_RO = RECF.CNT_RO AND ECF.TOTALI IN (''0300'',''0500''))',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '99',
       150,
       12,
       'VLRI_NT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Isento',
       'Isento',
       '',
       '(SELECT VLRTOT FROM TT_ECF ECF WHERE ECF.CODFIL = RECF.CODFIL AND ECF.NUMECF = RECF.NUMECF AND ECF.DATOPE = RECF.DATOPE AND ECF.CNT_RO = RECF.CNT_RO AND ECF.TOTALI = ''I_NT'')',
       'F' FROM DUAL
UNION ALL
SELECT 'RECF',
       '99',
       270,
       12,
       'VLRLIQSIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vendas Gravadas',
       'Vendas Gravadas',
       '',
       '(SELECT SUM(VLRLIQ) FROM TT_VEN WHERE CODFIL=RECF.CODFIL AND NUMECF=RECF.NUMECF AND TO_NUMBER(REPLACE(NUMNOT,''#'','' '')) BETWEEN RECF.CUPINI AND RECF.CUPFIM AND VLRLIQ>0 AND CODSER=''CF'' AND FLGEST<>''C'' GROUP BY CODFIL,NUMECF)',
       '' FROM DUAL
UNION ALL
SELECT 'RECF',
       '99',
       140,
       12,
       'VLRSUBS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Substituio',
       'Substituio',
       '',
       '(SELECT VLRTOT FROM TT_ECF ECF WHERE ECF.CODFIL = RECF.CODFIL AND ECF.NUMECF = RECF.NUMECF AND ECF.DATOPE = RECF.DATOPE AND ECF.CNT_RO = RECF.CNT_RO AND ECF.TOTALI = ''SUBS'')',
       'F' FROM DUAL
);

/*-- SEQ 9147 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'RECF',
       'DIAFEC',
       0,
       '@',
       'Abertos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RECF',
       'DIAFEC',
       0,
       'F',
       'Fechado Forado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RECF',
       'DIAFEC',
       0,
       'N',
       'Errados',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RECF',
       'DIAFEC',
       0,
       'S',
       'Fechados',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9148 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RECP',
       0,
       'RECP',
       'Recebimento c/ Pend.',
       'TV_REC_RECPEND',
       'T',
       '',
       'TOTALL',
       'Parcelas da Venda',
       '{CODFIL;NUMECF;CODSER;NUMNOT;NUMPAR;SUBPAR};FLGEST;DATPGT;DATVEN;ATU_EM',
       '',
       '',
       'VendaParcela',
       'T',
       '',
       'RECP.CODFIL,RECP.SEQUEN,RECP.NUMPAR,RECP.SUBPAR
',
       '' FROM DUAL
);

/*-- SEQ 9149 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RECP','--','' FROM DUAL
UNION ALL
SELECT 'RECP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RECP','02','Dados Gerais' FROM DUAL
UNION ALL
SELECT 'RECP','03','Funes' FROM DUAL
UNION ALL
SELECT 'RECP','04','Renegociao' FROM DUAL
UNION ALL
SELECT 'RECP','05','Parmetos Meio de Pagamento' FROM DUAL
UNION ALL
SELECT 'RECP','06','Valor Carteira' FROM DUAL
UNION ALL
SELECT 'RECP','07','A Receber' FROM DUAL
UNION ALL
SELECT 'RECP','08','Operao Caixa' FROM DUAL
);

/*-- SEQ 9150 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 45906,
       'CHR ',
       'RECP',
       '1',
       'N',
       '',
       '',
       'RECP.codfil = chr.codfil and
RECP.seqche = chr.sequen
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45907,
       'CTM ',
       'RECP',
       'N',
       '1',
       '',
       '',
       'CTM.CODFIL = RECP.CODFIL AND
CTM.SEQUEN = RECP.SEQUEN AND
CTM.NUMPAR = RECP.NUMPAR AND
CTM.SUBPAR = RECP.SUBPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45908,
       'CTA ',
       'RECP',
       'N',
       '01',
       '',
       '',
       'RECP.FILCTA = CTA.CODFIL AND RECP.SEQCTA = CTA.SEQUEN AND RECP.TIPCTA = CTA.TIPCTA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45905,
       'PLA ',
       'RECP',
       '0N',
       '01',
       '',
       '',
       'PLA.FILPGT = RECP.FILPGT(+) AND
PLA.CODPGT = RECP.CODPGT(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45909,
       'ITF ',
       'RECP',
       '01',
       '1',
       '',
       '',
       'RECP.FILITF = ITF.CODFIL AND
RECP.SEQITF = ITF.SEQUEN AND
RECP.ITEITF = ITF.NUMITE',
       '',
       '' FROM DUAL
);

/*-- SEQ 9151 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RECP',
       '06',
       410,
       8,
       ':RECP.DATA_CARTEIRA',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data da Carteira',
       'Data da carteira',
       '',
       ':RECP.DATA_CARTEIRA',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '05',
       330,
       1,
       ':RECP.FORMA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Forma',
       'Forma',
       '',
       ':RECP.FORMA',
       'T' FROM DUAL
UNION ALL
SELECT 'RECP',
       '07',
       430,
       8,
       ':RECP.PR_DATA',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'A Receber em',
       'A Receber em',
       '',
       ':RECP.PR_DATA',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '07',
       440,
       6,
       ':RECP.PR_DIAS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Dias Atraso > que',
       'Dias de atraso maior que',
       '',
       ':RECP.PR_DIAS',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       5481,
       10,
       'APEPGT',
       'A',
       'PLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       '',
       '',
       'A',
       '',
       'Plano de Pagamento',
       'Plano de Pagamento',
       'RECP.FILPGT = PLA.FILPGT(+) AND RECP.CODPGT = PLA.CODPGT(+)',
       'APEPGT',
       'T' FROM DUAL
UNION ALL
SELECT 'RECP',
       '07',
       420,
       1,
       'ARECEBER_RETROATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'A Receber~Retroativo',
       'A Receber Retroativo',
       '',
       '(CASE WHEN(TRUNC(RECP.DATINC) < :RECP.PR_DATA AND (RECP.DATVEN <= ADD_DAY(:RECP.PR_DATA,:RECP.PR_DIAS * -1)) )AND ((RECP.FLGEST = ''A'' AND RECP.CARTAO IS NULL AND RECP.SEQCHE IS NULL) OR (TRUNC(RECP.PAGAME) > :RECP.PR_DATA)) THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       91,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN RECP.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       230,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'RECP',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'REC',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       5460,
       1,
       'AVISTA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Paga  Vista?',
       'Parcela Paga  Vista?',
       '',
       'AVISTA',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       20,
       5,
       'CARTAO',
       'S',
       'DCAR',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       'DCAR.DESOUT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Carto',
       'Carto de Crdito',
       'DCAR.CODTAB(+) = RECP.CARTAO',
       'CARTAO',
       'T' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       290,
       15,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Alternativo',
       'Cdigo Alternativo nico',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       80,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       0,
       'RECP',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'REC',
       'F',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'RECP.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       220,
       2,
       'CODMOE',
       'S',
       'DMOE',
       0,
       0,
       'RECP',
       90,
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       'REC',
       'F',
       'A',
       'T',
       'Moeda',
       'Cdigo da moeda',
       'RECP.CODMOE=DMOE.CODTAB (+)',
       'CODMOE',
       'T' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       5264,
       5,
       'CODOUT',
       'S',
       'DOUT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DOUT.DESCAR',
       'V',
       '',
       '',
       'A',
       '',
       'Outros Meios Pag.',
       'Outros Meios de Pagamento',
       'DOUT.CODTAB = RECP.CODOUT',
       'CODOUT',
       'T' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       5480,
       3,
       'CODPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Cdigo do Plano',
       'Cdigo do Plano de Pagamento',
       '',
       'CODPGT',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       150,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Usurio',
       'RECP.FILUSU = USU.FILUSU(+)  AND RECP.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       140,
       8,
       'CUPFIS',
       'A',
       '',
       0,
       0,
       'RECP',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'REC',
       'F',
       '9',
       'T',
       'Cupom Fiscal',
       'Cupom fiscal',
       '',
       'CUPFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       5410,
       1,
       'CUPFISNUMNOT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Nota?',
       'Cupom Rec = Nota?',
       '',
       '(SELECT CASE WHEN ISDIGIT(trim(RECP.CUPFIS))<=0 OR ISDIGIT(trim(VEN.NUMNOT))=-1 THEN ''F'' WHEN TO_NUMBER(trim(RECP.CUPFIS))=TO_NUMBER(trim(VEN.NUMNOT)) THEN ''T'' ELSE ''F'' END FROM TT_VEN VEN WHERE RECP.CODFIL = VEN.CODFIL AND RECP.SEQUEN = VEN.SEQUEN)',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '03',
       250,
       12,
       'CalcRecAtu',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr. Corrigido',
       'Valor Corrigido da Parcela',
       '',
       'CALCRECATU(RECP.CODFIL,RECP.SEQUEN,RECP.NUMPAR,RECP.SUBPAR,0,RECP.PAGAME)',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       820,
       8,
       'DATAFATURAMENTOCARTAO',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Faturam. Carto',
       'Data Faturamento Carto',
       '',
       'DATAFATURAMENTOCARTAO(RECP.CODFIL,RECP.SEQUEN,RECP.NUMPAR,RECP.SUBPAR)',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       825,
       8,
       'DATA_PROMESSA',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Promessa',
       'Data Promessa',
       '',
       'TRAZ_DATPRO(RECP.CODFIL,RECP.SEQUEN,RECP.NUMPAR,RECP.SUBPAR)',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       845,
       7,
       'DATFIS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Fiscal',
       'Data Fiscal',
       '',
       'DATFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       340,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '--',
       5274,
       7,
       'DATPRE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Data prevista',
       'Data prevista',
       '',
       'DATPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       180,
       8,
       'DATVEN',
       'D',
       '',
       0,
       0,
       'RECP',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'REC',
       'F',
       'D',
       'T',
       'Vencimento',
       'Data de vencimento',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       5202,
       4,
       'DIASATRASO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       '',
       'Dias em Atraso',
       'Dias em Atraso',
       '',
       'TRUNC(AGORA())-TRUNC(RECP.DATVEN)',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       840,
       2,
       'DIASFAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       '',
       'Dias Vencimento',
       'Dias Vencimento',
       '',
       'TRUNC(RECP.DATVEN)-TRUNC(AGORA())',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       835,
       12,
       'DIFPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Diferena Pagamento',
       'Diferena Pagamento',
       '',
       'CALCDIFPAG(RECP.CODFIL,RECP.SEQUEN,RECP.NUMPAR,RECP.SUBPAR)',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       40,
       1,
       'DUMMY',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       '',
       'Dummy?',
       '',
       'DUMMY',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       176,
       8,
       'ESTCAN',
       'D',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Cancela/Estorno',
       'Data de Cancelamento/Estorno',
       '',
       'ESTCAN',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       5284,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Filial da Conta',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       5370,
       3,
       'FILITF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Filial Item Carto',
       'Filial Item Carto',
       '',
       'FILITF',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       5470,
       3,
       'FILPGT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial do Plano',
       'Filial do Plano de Pagamento',
       'DFIL.CODFIL(+) = RECP.FILPGT',
       'FILPGT',
       'T' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       10,
       3,
       'FILREC',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       'RECP',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial Recebimento',
       'Cdigo da filial do recebimento',
       'DFIL.CODFIL(+) = RECP.FILREC',
       'FILREC',
       'T' FROM DUAL
UNION ALL
SELECT 'RECP',
       '04',
       5354,
       3,
       'FILREN',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial Venda Reneg.',
       'Filial Venda Renegociada',
       'DFIL.CODFIL(+) = RECP.FILREN',
       'FILREN',
       'T' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       160,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       130,
       1,
       'FLGEST',
       'A',
       '',
       0,
       0,
       'RECP',
       50,
       30,
       '',
       '',
       'D',
       'REC',
       'F',
       'A',
       'T',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       5450,
       1,
       'FLGESTITF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Situao venda',
       'Situao do pagamento Considerando carto de crdito',
       '',
       '(coalesce((SELECT ITF.FLGEST FROM TT_ITF ITF WHERE ITF.CODFIL = RECP.FILITF AND ITF.SEQUEN = RECP.SEQITF AND ITF.NUMITE = RECP.ITEITF ),RECP.flgest))',
       'T' FROM DUAL
UNION ALL
SELECT 'RECP',
       '--',
       5294,
       1,
       'FLGFLU',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Proce p/ flux Finan?',
       'Processado pelo fluxo financeiro?',
       '',
       'FLGFLU',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       5390,
       5,
       'ITEITF',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Item Carto',
       'Item Carto',
       '',
       'ITEITF',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '03',
       280,
       12,
       'JUROS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr. Juros',
       'Vlr. Juros',
       '',
       '(CASE WHEN COALESCE(RECP.VLRDES,0) > 0 AND RECP.CARTAO IS NULL THEN ABS(RECP.VLRDES) ELSE 0 END)',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '03',
       245,
       12,
       'JUROSDESCONTOS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Juros~Descontos',
       'Exibe Descontos',
       '',
       'DESCONTOPARCELA(RECP.CODFIL,RECP.SEQUEN,RECP.NUMPAR,RECP.SUBPAR) ',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       800,
       50,
       'MEIODEPAGAMDET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Pagamento',
       'Pagamento',
       '',
       'SUBSTR( CASE WHEN RECP.SEQCHE IS NULL AND RECP.CARTAO IS NULL AND RECP.FLGEST IN (''A'',''X'',''C'') THEN NULL ELSE MEIODEPAGAMENTO( RECP.CODFIL,RECP.SEQUEN, RECP.NUMPAR, RECP.SUBPAR,0) END ,1,50)',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '05',
       320,
       250,
       'MEIODEPAGAMENTO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Meio de Pagamento',
       'Meio de Pagamento',
       '',
       'RTRIM(SUBSTR(MEIODEPAGAMENTO(RECP.CODFIL,RECP.SEQUEN,RECP.NUMPAR,RECP.SUBPAR,:RECP.FORMA),1,250))',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       345,
       250,
       'MEIO_DETALHADO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Meio PGTO(Detalhado)',
       'Meio PGTO(Detalhado)',
       '',
       'RTRIM(SUBSTR(MEIODEPAGAMENTO(RECP.CODFIL,RECP.SEQUEN,RECP.NUMPAR,RECP.SUBPAR,0),1,250))',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       840,
       20,
       'NOSNUM',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nosso nmero',
       'Nosso nmero',
       '',
       'RTF2TXT(CAST(TRAZNOSNUM(RECP.CODFIL,RECP.SEQUEN,RECP.NUMPAR,RECP.SUBPAR) AS VARCHAR(20)))',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       5490,
       20,
       'NOSNUM_LOCAL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nosso Nmero local',
       'Nosso Nmero local (gravado no prprio recebimento)',
       '',
       'NOSNUM',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       75,
       3,
       'NUMCODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo~da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       120,
       3,
       'NUMECF',
       'A',
       '',
       0,
       0,
       'RECP',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'REC',
       'F',
       '0',
       'T',
       'ECF',
       'Nmero do ECF que recebeu a parcela',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       12,
       3,
       'NUMFILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo Filial Receb.',
       'Cdigo Filial Receb.',
       '',
       'FILREC',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       810,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero~Parcela',
       'Nmero da Parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       113,
       2,
       'NUMSUBPAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Sub-Parcela(Nmero)',
       'Sub-Parcela no formato numrico',
       '',
       'TO_NUMBER(RECP.SUBPAR)',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       5400,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Observao de Baixa',
       'Observao de Baixa',
       '',
       'RTF2TXT(RECP.OBSERV)',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '08',
       830,
       4000,
       'OPERACAOCAIXA',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Operao Caixa',
       'Operao Caixa',
       '',
       'RTF2TXT(RTRIM(SUBSTR(OPERACAOCAIXA(''REC'',RECP.CODFIL,RECP.SEQUEN,RECP.NUMPAR,RECP.SUBPAR),1,50)))',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '--',
       5304,
       1,
       'ORIREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Origem Recebimento',
       'Origem Recebimento',
       '',
       'ORIREC',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       170,
       8,
       'PAGAME',
       '@',
       '',
       0,
       0,
       'RECP',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'REC',
       'F',
       '@',
       'T',
       'Data de Pagamento',
       'Data e hora de Pagamento',
       '',
       'PAGAME',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       5440,
       8,
       'PAGAMECAR',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data pagamento',
       'Data do Pagamento Considerando carto de crdito',
       '',
       '(coalesce((SELECT ITF.datpgt FROM TT_ITF ITF WHERE ITF.CODFIL = RECP.FILITF AND ITF.SEQUEN = RECP.SEQITF AND ITF.NUMITE = RECP.ITEITF ),RECP.pagame))',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       5204,
       8,
       'PAGAME_PERDAS',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       '',
       'Data Pagam. Perdas',
       'Data Pagamento para perda contabil (se aberto considera hoje)',
       '',
       'COALESCE(RECP.PAGAME,AGORA())',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       105,
       5,
       'PARCELA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       '',
       'Parcela',
       'Parcela/Sub-Parcela',
       '',
       '(RECP.NUMPAR || (CASE WHEN RECP.SUBPAR = '' 0'' THEN '' '' ELSE ''-'' || LTRIM(RECP.SUBPAR) END))',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       5440,
       1,
       'PARCELAQUITADA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Parcela Quitada?',
       'Parcela Quitada?',
       '',
       'CAST((SELECT CASE WHEN COUNT(*)>0 THEN ''F'' ELSE ''T'' END FROM TT_REC SUB WHERE SUB.CODFIL=RECP.CODFIL AND SUB.SEQUEN=RECP.SEQUEN AND SUB.NUMPAR=RECP.NUMPAR AND SUB.FLGEST=''A'') AS CHAR(1))',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       5430,
       1,
       'PGTOVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Origem do Pagamento',
       'Saber se o Recebimento foi na venda ou de pagamento',
       '',
       '(SELECT CASE WHEN RECP.PAGAME between ADD_SECOND(VEN.DATHOR,-1800) and ADD_second(VEN.DATHOR,1800) and RECP.numecf=ven.numecf and datven = trunc(pagame) THEN ''T'' ELSE ''F'' END FROM TT_VEN VEN WHERE RECP.CODFIL = VEN.CODFIL AND RECP.SEQUEN = VEN.SEQUEN)',
       'T' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       210,
       2,
       'PORTAD',
       'S',
       'DCOB',
       0,
       0,
       'RECP',
       80,
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       'REC',
       'F',
       'A',
       'T',
       'Portador',
       'Cdigo do portador',
       'RECP.PORTAD=DCOB.CODTAB (+)',
       'PORTAD',
       'T' FROM DUAL
UNION ALL
SELECT 'RECP',
       '05',
       865,
       1,
       'PROCES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Processados',
       'Processados',
       '',
       'PROCES',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       300,
       2,
       'RENEGO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Renegociao',
       'Renegociao',
       '',
       'RENEGO',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       310,
       2,
       'RENORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Origem Renegociao',
       'Origem Renegociao',
       '',
       'RENORI',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '03',
       60,
       10,
       'SEQCHE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave Cheque',
       'Chave Cheque',
       '',
       'SEQCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       5314,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Sequncia da Conta',
       'Sequncia da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       5380,
       10,
       'SEQITF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Sequen. Item Carto',
       'Sequen. Item Carto',
       '',
       'SEQITF',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '04',
       5364,
       10,
       'SEQREN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. Venda Reneg.',
       'Sequncia da  Venda Renegociada',
       '',
       'SEQREN',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       70,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       90,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN RECP.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '--',
       5324,
       2,
       'SUBORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Origem sub parcela',
       'Origem sub parcela',
       '',
       'SUBORI',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       110,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       0,
       'RECP',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'REC',
       'F',
       '9',
       'T',
       'Sub-Parcela',
       'Nmero da sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       30,
       5,
       'TIPCCC',
       'S',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       'A',
       'F',
       'Tipo Conta Corrente',
       'Tipo Conta Corrente',
       'DCCC.CODTAB(+) = RECP.TIPCCC',
       'TIPCCC',
       'T' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       5334,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo da Conta',
       'Tipo da Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       5203,
       2,
       'VENCIDADIAS',
       'S',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vencidas(dias)',
       'Vencida a dias',
       '',
       'TRUNC(COALESCE(RECP.PAGAME, AGORA())) - TRUNC(RECP.DATVEN)',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '01',
       830,
       1,
       'VERIFICADATA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Data Pgto~= a Venda?',
       'Data Pgto igual a Venda?',
       '',
       'CAST((SELECT CASE WHEN TRUNC(RECP.PAGAME)=TRUNC(VEN.DATHOR) THEN ''T'' ELSE ''F'' END FROM TT_VEN VEN WHERE RECP.CODFIL = VEN.CODFIL AND RECP.SEQUEN = VEN.SEQUEN) AS CHAR(1))',
       'T' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       5340,
       12,
       'VLRAJUSTADO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Ajustado',
       'Valor Ajustado da Parcela',
       '',
       'CASE RECP.FLGEST WHEN ''A'' THEN RECP.VLRPAR WHEN ''P'' THEN RECP.VLRPGT-COALESCE(RECP.VLRDES,0)+COALESCE(RECP.VLRTAX,0) WHEN ''C'' THEN COALESCE(RECP.VLRDES,0)*-1 END',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '03',
       240,
       8,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       'RECP',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'T',
       'Vlr. Desconto',
       'Vlr. Desconto',
       '',
       '(CASE WHEN COALESCE(RECP.VLRDES,0) < 0 AND RECP.CARTAO IS NULL THEN ABS(RECP.VLRDES) ELSE 0 END)',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       200,
       8,
       'VLRPAR',
       'F',
       '',
       2,
       0,
       'RECP',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'REC',
       'T',
       '9',
       'T',
       'Vlr. Parcela',
       'Valor da parcela',
       '',
       'VLRPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       190,
       8,
       'VLRPGT',
       'F',
       '',
       2,
       0,
       'RECP',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'REC',
       'T',
       '9',
       'T',
       'Vlr. Pago',
       'Valor do pagamento',
       '',
       'COALESCE( (SELECT ITF.VLRITE - ABS(ITF.VLRTAX) FROM TT_ITF ITF WHERE ITF.CODFIL = RECP.FILITF AND ITF.SEQUEN = RECP.SEQITF AND ITF.NUMITE = RECP.ITEITF ),COALESCE(RECP.VLRPGT,0))',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '--',
       5344,
       12,
       'VLRPRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor previsto',
       'Valor previsto',
       '',
       'VLRPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       175,
       14,
       'VLRTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       '',
       'Vlr. Taxas',
       'Valor de Taxas',
       '',
       'VLRTAX',
       '' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       5201,
       1,
       'VPARCIAL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Parcial?',
       'Parcial?',
       '',
       '(SELECT CASE WHEN COUNT(*)>0 AND RECP.FLGEST=''P'' THEN ''T'' ELSE ''F'' END FROM TT_REC SUB WHERE SUB.CODFIL=RECP.CODFIL AND SUB.SEQUEN=RECP.SEQUEN AND SUB.NUMPAR=RECP.NUMPAR AND SUB.SUBORI=RECP.SUBPAR)',
       'T' FROM DUAL
UNION ALL
SELECT 'RECP',
       '02',
       5420,
       12,
       'VPGTPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       '',
       'Valor Pago Parcial',
       'Valor Pago Parcial',
       '',
       '(SELECT CASE WHEN COUNT(*)>0 AND RECP.FLGEST=''P'' THEN RECP.VLRPGT ELSE RECP.VLRPAR END FROM TT_REC SUB WHERE SUB.CODFIL=RECP.CODFIL AND SUB.SEQUEN=RECP.SEQUEN AND SUB.NUMPAR=RECP.NUMPAR AND SUB.SUBORI=RECP.SUBPAR)',
       '' FROM DUAL
);

/*-- SEQ 9152 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'RECP',
       ':RECP.FORMA',
       0,
       '0',
       'DETALHADO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RECP',
       ':RECP.FORMA',
       0,
       '1',
       'RESUMIDO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RECP',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RECP',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RECP',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RECP',
       'FLGEST',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RECP',
       'FLGESTITF',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RECP',
       'FLGESTITF',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RECP',
       'FLGESTITF',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RECP',
       'FLGESTITF',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RECP',
       'PGTOVEN',
       0,
       'F',
       'Recebimento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RECP',
       'PGTOVEN',
       0,
       'T',
       'Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RECP',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RECP',
       'VERIFICADATA',
       0,
       'F',
       'No',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RECP',
       'VERIFICADATA',
       0,
       'T',
       'Sim',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RECP',
       'VPARCIAL',
       0,
       'F',
       'No',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RECP',
       'VPARCIAL',
       0,
       'T',
       'Sim',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9153 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RED ',
       0,
       'RED ',
       'Reduo ICMS',
       'TT_RED',
       'T',
       '',
       'TOTALL',
       'Redues',
       '{MESANO}',
       '',
       '',
       '',
       'F',
       '',
       'RED.MESANO',
       '' FROM DUAL
);

/*-- SEQ 9154 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RED ','--','' FROM DUAL
);

/*-- SEQ 9155 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RED ',
       '--',
       40,
       8,
       'ACRPRE',
       'F',
       '',
       2,
       0,
       'RED ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'RED',
       'T',
       '',
       'F',
       'Acrscimo Prestao',
       'Acrscimo por prestao',
       '',
       'ACRPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'RED ',
       '--',
       10,
       6,
       'MESANO',
       'A',
       '',
       0,
       0,
       'RED ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'RED',
       'F',
       'A',
       'F',
       'Ms e Ano Base',
       'Ms e Ano base',
       '',
       'MESANO',
       'F' FROM DUAL
UNION ALL
SELECT 'RED ',
       '--',
       20,
       2,
       'NROPRE',
       'S',
       '',
       0,
       0,
       'RED ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'RED',
       'F',
       '',
       'F',
       'Nmero Prestaes',
       'Nmero de prestaes',
       '',
       'NROPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'RED ',
       '--',
       30,
       6,
       'PRZMED',
       'A',
       '',
       0,
       0,
       'RED ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'RED',
       'F',
       'N',
       'F',
       'Prazo Mdio',
       'Prazo mdio',
       '',
       'PRZMED',
       'F' FROM DUAL
);

/*-- SEQ 9156 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'REF ',
       0,
       'REF ',
       'Referncias Compra',
       'TT_REF',
       'T',
       '',
       'TOTALL',
       'Referncias dos fornecedores',
       '{FILMAT;CODMAT;CODCOR;CODTAM;FILFOR;CODFOR}',
       '',
       '',
       '',
       'F',
       '',
       'REF.FILMAT,REF.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9157 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'REF ','--','' FROM DUAL
UNION ALL
SELECT 'REF ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'REF ','02','Outros' FROM DUAL
);

/*-- SEQ 9158 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21976,
       'GRA ',
       'REF ',
       '1',
       'N',
       '',
       '',
       'GRA.FILMAT = REF.FILMAT and
GRA.CODMAT = REF.CODMAT and
GRA.CODCOR = REF.CODCOR and
GRA.CODTAM = REF.CODTAM
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21977,
       'PVD ',
       'REF ',
       '1',
       'N',
       '',
       '',
       'PVD.FILPAR = REF.FILFOR and
PVD.CODPAR = REF.CODFOR and
PVD.TIPPAR = REF.TIPFOR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21978,
       'PXF ',
       'REF ',
       '1',
       '0N',
       '',
       '',
       'PXF.FILMAT = REF.FILMAT AND
PXF.CODMAT = REF.CODMAT AND
PXF.CODCOR = REF.CODCOR AND
PXF.CODTAM = REF.CODTAM AND
PXF.FILFOR = REF.FILFOR AND
PXF.CODFOR = REF.CODFOR
',
       '',
       '' FROM DUAL
);

/*-- SEQ 9159 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'REF ',
       '01',
       50,
       2,
       'CODCOR',
       'S',
       'DIV ',
       0,
       0,
       'REF ',
       30,
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       'REF',
       'F',
       'N',
       'F',
       'Diviso',
       'Diviso do Produto',
       'REF.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'REF ',
       '01',
       80,
       6,
       'CODFOR',
       'A',
       '',
       0,
       0,
       'REF ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'REF',
       'F',
       '9',
       'F',
       'Cdigo Fornecedor',
       'Cdigo do fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'REF ',
       '01',
       40,
       5,
       'CODMAT',
       'A',
       '',
       0,
       0,
       'REF ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'REF',
       'F',
       '9',
       'F',
       '',
       'Cdigo do produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'REF ',
       '01',
       60,
       2,
       'CODTAM',
       'A',
       'SUB ',
       0,
       0,
       'REF ',
       40,
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       'REF',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'REF.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'REF ',
       '01',
       70,
       3,
       'FILFOR',
       'A',
       'DFIL',
       0,
       0,
       'REF ',
       50,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'REF',
       'F',
       'N',
       'F',
       '',
       'Filial do fornecedor',
       'REF.FILFOR = DFIL.CODFIL (+)',
       'FILFOR',
       'T' FROM DUAL
UNION ALL
SELECT 'REF ',
       '01',
       30,
       3,
       'FILMAT',
       'A',
       '',
       0,
       0,
       'REF ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'REF',
       'F',
       'N',
       'F',
       '',
       'Filial do produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'REF ',
       '02',
       90,
       20,
       'REFFOR',
       'A',
       '',
       0,
       0,
       'REF ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'REF',
       'F',
       'A',
       'T',
       'Referncia',
       'Referncia deste produto para o fornecedor',
       '',
       'REFFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'REF ',
       '01',
       10,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'REF ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'REF ',
       '01',
       20,
       1,
       'TIPFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'REF ',
       20,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Cliente',
       'Tipo de cliente',
       '',
       'TIPFOR',
       'T' FROM DUAL
);

/*-- SEQ 9160 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'REF ',
       'TIPFOR',
       0,
       'F',
       'Fornecedor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REF ',
       'TIPFOR',
       0,
       'T',
       'Transportadora',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9161 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'REG ',
       TO_NUMBER(null),
       'REG ',
       'Registro do Cliente',
       'TT_REG',
       'T',
       '',
       'TOTALL',
       'Registro do Cliente',
       '',
       '',
       '',
       '',
       'F',
       '',
       'REG.CODFIL,REG.SEQUEN
REG.NUMSER
REG.NUMREG',
       '' FROM DUAL
);

/*-- SEQ 9162 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'REG ','--','' FROM DUAL
UNION ALL
SELECT 'REG ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'REG ','99','Outros' FROM DUAL
);

/*-- SEQ 9163 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5834,
       'EDE ',
       'REG ',
       '1 ',
       'N ',
       '',
       '',
       'REG.FILCLI = EDE.FILCLI AND
REG.CODCLI = EDE.CODCLI AND
REG.FILEND = EDE.CODFIL AND
REG.NUMEND = EDE.NUMEND
',
       '' FROM DUAL
UNION ALL
SELECT 5835,
       'LREG',
       'REG ',
       'N ',
       '1 ',
       '',
       '',
       'LREG.CODFIL = REG.CODFIL AND
LREG.SEQUEN = REG.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9164 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'REG ',
       '99',
       100,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano~Atualizao',
       'Ano de Data da ltima Atualizao',
       '',
       'TO_CHAR(REG.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'REG ',
       '99',
       95,
       4,
       'ANO_DATCAD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano~Data Cadastro',
       'Ano de Data que foi cadastrada',
       '',
       'TO_CHAR(REG.DATCAD,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'REG ',
       '99',
       105,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Data da ltima Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'REG ',
       '01',
       5,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'REG ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       '0',
       'F',
       'Filial',
       'Cdigo da Filial de Origem',
       'REG.CODFIL=DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'REG ',
       '01',
       115,
       2,
       'CODHOM',
       'A',
       'DHOM',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DHOM.DESHOM',
       'V',
       '',
       '',
       'A',
       'F',
       'Homologacao',
       '',
       'DHOM.CODHOM = REG.CODHOM',
       'CODHOM',
       'F' FROM DUAL
UNION ALL
SELECT 'REG ',
       '99',
       90,
       8,
       'DATCAD',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Incluso',
       'Data que foi cadastrada',
       '',
       'DATCAD',
       'F' FROM DUAL
UNION ALL
SELECT 'REG ',
       '01',
       4,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'REG ',
       '01',
       6,
       3,
       'FILEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Endereo',
       '',
       'FILEND',
       'F' FROM DUAL
UNION ALL
SELECT 'REG ',
       '99',
       103,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms~Atualizao',
       'Ms de Data da ltima Atualizao',
       '',
       'TO_CHAR(REG.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'REG ',
       '99',
       93,
       2,
       'MES_DATCAD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms~Incluso',
       'Ms de Data que foi cadastrada',
       '',
       'TO_CHAR(REG.DATCAD,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'REG ',
       '01',
       7,
       5,
       'NUMEND',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nmero do Endereo',
       'Nmero do Endereo',
       '',
       'NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT 'REG ',
       '01',
       20,
       10,
       'NUMREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nmero do Registro',
       'Nmero do Registro',
       '',
       'NUMREG',
       'F' FROM DUAL
UNION ALL
SELECT 'REG ',
       '01',
       30,
       30,
       'NUMSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nmero de Srie',
       'Nmero de Srie',
       '',
       'NUMSER',
       'F' FROM DUAL
UNION ALL
SELECT 'REG ',
       '99',
       80,
       1,
       'REGATV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Registro Ativo?',
       'Indica se Registro est Ativo ou no',
       '',
       'REGATV',
       'F' FROM DUAL
UNION ALL
SELECT 'REG ',
       '01',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 9165 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'REJ ',
       TO_NUMBER(null),
       'REJ ',
       'Motivo Rejeio CNA',
       'TD_REJ',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9166 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'REJ ','--','' FROM DUAL
UNION ALL
SELECT 'REJ ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'REJ ','99','Outros' FROM DUAL
);

/*-- SEQ 9167 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'REJ ',
       '01',
       30,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cod. Banco',
       'Cdigo do Banco',
       '',
       'CODBCO',
       '' FROM DUAL
UNION ALL
SELECT 'REJ ',
       '01',
       40,
       2,
       'CODREJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cod Rejeio',
       'Cdigo da Rejeio',
       '',
       'CODREJ',
       '' FROM DUAL
UNION ALL
SELECT 'REJ ',
       '01',
       10,
       5,
       'CODTAB',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       '',
       'Cod. Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'REJ ',
       '01',
       50,
       40,
       'DESREJ',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Des. Rejeio',
       'Descrio da Rejeio',
       '',
       'RTF2TXT(DESREJ)',
       '' FROM DUAL
UNION ALL
SELECT 'REJ ',
       '01',
       20,
       1,
       'REJATI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Rej. Ativa',
       'Rejeio ativa / no ativa',
       '',
       'REJATI',
       '' FROM DUAL
);

/*-- SEQ 9168 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'REL ',
       0,
       'REL ',
       'Relao c/ Parceiros',
       'TT_REL',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'REL.FILPAR,REL.CODPAR,REL.TIPPAR',
       '' FROM DUAL
);

/*-- SEQ 9169 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'REL ','--','' FROM DUAL
UNION ALL
SELECT 'REL ','01','Identificao' FROM DUAL
);

/*-- SEQ 9170 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5837,
       'CLI ',
       'REL ',
       '1 ',
       'N ',
       '',
       '',
       'CLI.FILCLI = REL.FILPAR(+) AND
CLI.CODCLI = REL.CODPAR(+)',
       '' FROM DUAL
);

/*-- SEQ 9171 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'REL ',
       '01',
       20,
       3,
       'CODPAR',
       'A',
       '',
       0,
       0,
       'REL ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'REL',
       'F',
       'A',
       'F',
       'Cdigo Parceiro',
       'Cdigo do parceiro',
       '',
       'CODPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'REL ',
       '01',
       10,
       3,
       'FILPAR',
       'A',
       'DFIL',
       0,
       0,
       'REL ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'REL',
       'F',
       'N',
       'F',
       '',
       'Filial do parceiro',
       'REL.FILPAR = DFIL.CODFIL (+)',
       'FILPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'REL ',
       '01',
       30,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       0,
       'REL ',
       30,
       30,
       '',
       '',
       'D',
       'REL',
       'F',
       'A',
       'F',
       'Tipo Parceiro',
       'Tipo de parceiro',
       '',
       'TIPPAR',
       'T' FROM DUAL
);

/*-- SEQ 9172 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'REL ',
       'TIPPAR',
       0,
       'A',
       'Cliente Transportadora',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REL ',
       'TIPPAR',
       0,
       'C',
       'Cartes',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REL ',
       'TIPPAR',
       0,
       'F',
       'Fornecedor',
       269,
       ' ' FROM DUAL
UNION ALL
SELECT 'REL ',
       'TIPPAR',
       0,
       'I',
       'Indicador Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REL ',
       'TIPPAR',
       0,
       'M',
       'Marca',
       267,
       ' ' FROM DUAL
UNION ALL
SELECT 'REL ',
       'TIPPAR',
       0,
       'N',
       'Tec. Interno',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REL ',
       'TIPPAR',
       0,
       'O',
       'Motorista',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REL ',
       'TIPPAR',
       0,
       'R',
       'Representante',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REL ',
       'TIPPAR',
       0,
       'T',
       'Transportador',
       268,
       ' ' FROM DUAL
UNION ALL
SELECT 'REL ',
       'TIPPAR',
       0,
       'X',
       'Tcnico Externo',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9173 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'REM ',
       TO_NUMBER(null),
       'REM ',
       'Remessa Bancria',
       'TT_REM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'REM.CODBCO,REM.CODREM',
       '' FROM DUAL
);

/*-- SEQ 9174 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'REM ','--','' FROM DUAL
UNION ALL
SELECT 'REM ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'REM ','99','Outros' FROM DUAL
);

/*-- SEQ 9175 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'REM ',
       '01',
       10,
       5,
       'CCBVEN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Carteira',
       'Carteira',
       '',
       'CCBVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'REM ',
       '01',
       20,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Banco',
       'Codigo Banco',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'REM ',
       '01',
       30,
       5,
       'CODREM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Remessa',
       'Codigo Remessa',
       '',
       'CODREM',
       'F' FROM DUAL
UNION ALL
SELECT 'REM ',
       '01',
       40,
       30,
       'DESREM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Remessa',
       'Descricao Remessa',
       '',
       'DESREM',
       'F' FROM DUAL
UNION ALL
SELECT 'REM ',
       '01',
       50,
       5,
       'ECBVEN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Espcie',
       'Especie',
       '',
       'ECBVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'REM ',
       '01',
       60,
       5,
       'INSTR1',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Instruo 1',
       'Instrucao 1',
       '',
       'INSTR1',
       'F' FROM DUAL
UNION ALL
SELECT 'REM ',
       '01',
       70,
       5,
       'INSTR2',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Instruo 2',
       'Instrucao 2',
       '',
       'INSTR2',
       'F' FROM DUAL
UNION ALL
SELECT 'REM ',
       '01',
       80,
       3,
       'OCOBCO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Remessa no Banco',
       'Remessa no Banco',
       '',
       'OCOBCO',
       'F' FROM DUAL
);

/*-- SEQ 9176 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'REN ',
       TO_NUMBER(null),
       'REN ',
       'Renegociao',
       'TT_REN',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9177 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'REN ','--','' FROM DUAL
UNION ALL
SELECT 'REN ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'REN ','02','Datas' FROM DUAL
UNION ALL
SELECT 'REN ','03','Valores' FROM DUAL
UNION ALL
SELECT 'REN ','99','Outros' FROM DUAL
);

/*-- SEQ 9178 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5840,
       'CLI ',
       'REN ',
       '1 ',
       'N ',
       '',
       '',
       'CLI.FILCLI = REN.FILCLI AND
CLI.CODCLI = REN.CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 5841,
       'PLA ',
       'REN ',
       '1 ',
       'N ',
       '',
       '',
       'PLA.CODPGT = REN.CODPGT AND
PLA.FILPGT = REN.FILPGT',
       '' FROM DUAL
UNION ALL
SELECT 5842,
       'USU ',
       'REN ',
       '1 ',
       'N ',
       '',
       '',
       'USU.FILUSU = REN.FILUSU AND
USU.CODUSU = REN.CODUSU',
       '' FROM DUAL
);

/*-- SEQ 9179 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'REN ',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'REN ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = REN.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'REN ',
       '01',
       30,
       3,
       'CODPGT',
       'A',
       'PLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Plano',
       'Cdigo do plano de pagamento',
       'PLA.FILPGT= REN.FILPGT and  PLA.CODPGT = REN.CODPGT',
       'CODPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'REN ',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'USU.FILUSU(+) = REN.FILUSU and USU.CODUSU(+) = REN.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'REN ',
       '02',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Renegociao',
       'Data de Renegociao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'REN ',
       '02',
       60,
       7,
       'DATPRI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data 1 Parcela',
       'Data 1 Parcela',
       '',
       'DATPRI',
       'F' FROM DUAL
UNION ALL
SELECT 'REN ',
       '02',
       70,
       7,
       'DATSEQ',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data 2 Parcela',
       'Data 2 Parcela',
       '',
       'DATSEQ',
       'F' FROM DUAL
UNION ALL
SELECT 'REN ',
       '01',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Cdi. Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'REN ',
       '01',
       90,
       3,
       'FILPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Cdigo Filial PGTO',
       '',
       'FILPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'REN ',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Cd. Filial Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'REN ',
       '03',
       110,
       3,
       'QTDPAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Quantidade Parcelas',
       'Quantidade Parcelas',
       '',
       'QTDPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'REN ',
       '01',
       120,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'REN ',
       '03',
       130,
       14,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor das Parcelas',
       'Valor das demais parcelas',
       '',
       'VLRPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'REN ',
       '03',
       140,
       14,
       'VLRPRI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor da 1 Parcela',
       'Valor da 1 parcela (ou entrada)',
       '',
       'VLRPRI',
       'F' FROM DUAL
);

/*-- SEQ 9180 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'REP ',
       TO_NUMBER(null),
       'REP ',
       'Representantes',
       'TV_REP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'REP.FILPAR,REP.CODPAR
REP.NOMCLI,REP.ULTNOM
REP.NUMDOC
',
       '' FROM DUAL
);

/*-- SEQ 9181 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'REP ','--','' FROM DUAL
UNION ALL
SELECT 'REP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'REP ','02','Financeiros' FROM DUAL
);

/*-- SEQ 9182 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21861,
       'CON ',
       'REP ',
       '0N',
       '01',
       '',
       '',
       'CON.FILCLI = REP.FILPAR (+) and
CON.CODCLI = REP.CODPAR (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21862,
       'FAT ',
       'REP ',
       'N',
       '1',
       '',
       '',
       'FAT.FILCLI = REP.FILPAR and
FAT.CODCLI = REP.CODPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21863,
       'EDE ',
       'REP ',
       'N',
       '1',
       '',
       '',
       'EDE.FILCLI = REP.FILPAR AND
EDE.CODCLI = REP.CODPAR',
       '',
       '' FROM DUAL
);

/*-- SEQ 9183 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'REP ',
       '01',
       60,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       0,
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano~Atualizao',
       'Ano de Atualizao',
       '',
       'TO_CHAR(REP.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       330,
       4,
       'ANO_DATA01',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       0,
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       ' (ano)',
       'Ano de Data livre - 1',
       '',
       'TO_CHAR(REP.DATA01,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       360,
       4,
       'ANO_DATA02',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       0,
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       ' (ano)',
       'Ano de Data livre - 2',
       '',
       'TO_CHAR(REP.DATA02,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       390,
       4,
       'ANO_DATA03',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       0,
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       ' (ano)',
       'Ano de Data livre - 3',
       '',
       'TO_CHAR(REP.DATA03,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       220,
       4,
       'ANO_DATNAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Nascto/Funda',
       'Ano de Data de nascimento ou fundao',
       '',
       'TO_CHAR(REP.DATNAS,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       90,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       0,
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano Data Operao',
       'Ano Data Operao',
       '',
       'TO_CHAR(REP.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       430,
       4,
       'ANO_NASCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Nascto Cnj./',
       'Ano de Data de nascimento do cnjuge ou contato principal',
       '',
       'TO_CHAR(REP.NASCON,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '02',
       540,
       4,
       'ANO_ULTCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       0,
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano ltima Compra',
       'Ano ltima Compra',
       '',
       'TO_CHAR(REP.ULTCOM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       40,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       0,
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data~Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       280,
       2,
       'CATEG1',
       'S',
       'DCT1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'V',
       '',
       'F',
       'A',
       'F',
       '',
       'Categoria - 1',
       'REP.CATEG1=DCT1.CODTAB (+)',
       'CATEG1',
       'T' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       290,
       2,
       'CATEG2',
       'S',
       'DCT2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'V',
       '',
       'F',
       'A',
       'F',
       '',
       'Categoria - 2',
       'REP.CATEG2=DCT2.CODTAB (+)',
       'CATEG2',
       'T' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       300,
       2,
       'CATEG3',
       'S',
       'DCT3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'V',
       '',
       'F',
       'A',
       'F',
       'TIPO',
       'Categoria - 3',
       'REP.CATEG3=DCT3.CODTAB (+)',
       'CATEG3',
       'T' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       30,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       0,
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       150,
       6,
       'CODPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       0,
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo do Parceiro',
       'Cdigo do Parceiro',
       '',
       'CODPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '02',
       500,
       3,
       'CODPLA',
       'A',
       'PLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Plano padro',
       'Cdigo do plano padro',
       'REP.FILPLA=PLA.FILPGT (+) AND REP.CODPLA=PLA.CODPGT (+)',
       'CODPLA',
       'T' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       270,
       2,
       'CODSEX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Sexo',
       'Cdigo de Sexo do parceiro',
       '',
       'CODSEX',
       'T' FROM DUAL
UNION ALL
SELECT 'REP ',
       '02',
       550,
       3,
       'CODVEN',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Vendedor Padro',
       'Vendedor Padro',
       'REP.FILVEN=USU.FILUSU(+) AND REP.CODVEN=USU.CODUSU(+)',
       'CODVEN',
       'T' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       400,
       44,
       'CONJUG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cnjuge ou Contato',
       'Nome do cnjuge ou do contato principal',
       '',
       'CONJUG',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       310,
       8,
       'DATA01',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       '',
       'Data livre - 1',
       '',
       'DATA01',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       340,
       8,
       'DATA02',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       '',
       'Data livre - 2',
       '',
       'DATA02',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       370,
       8,
       'DATA03',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       '',
       'Data livre - 3',
       '',
       'DATA03',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       200,
       8,
       'DATNAS',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Nascto/Fundao',
       'Data de nascimento ou fundao',
       '',
       'DATNAS',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       70,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       0,
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data de Operao',
       'Data de Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       190,
       15,
       'DOCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Doc. Cnjuge/Contato',
       'Doc. Cnjuge/Contato',
       '',
       'DOCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       230,
       2,
       'ESTCIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Estado Civil',
       'Estado Civil',
       '',
       'ESTCIV',
       'T' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       20,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       0,
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       140,
       3,
       'FILPAR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       0,
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial origem',
       'DFIL.CODFIL = REP.FILPAR',
       'FILPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       110,
       3,
       'FILPLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       0,
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial Origem Plano',
       'Cdigo da Filial Origem do Plano Padro',
       '',
       'FILPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       130,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       0,
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do vendedor',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       250,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       240,
       40,
       'HOMPGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Home Page',
       'Home Page do parceiro',
       '',
       'HOMPGE',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       100,
       2,
       'IMPRIM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Livre Customizao',
       'Livre para customizao',
       '',
       'IMPRIM',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       260,
       15,
       'INSEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '2 Documento',
       'Inscrio Estadual ou Identidade',
       '',
       'INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '02',
       480,
       2,
       'MAIATR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Maior atraso',
       'Maior atraso registrado',
       '',
       'MAIATR',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       50,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       0,
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms~Atualizao',
       'Ms de Atualizao',
       '',
       'TO_CHAR(REP.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       320,
       2,
       'MES_DATA01',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       ' (ms)',
       'Ms de Data livre - 1',
       '',
       'TO_CHAR(REP.DATA01,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       350,
       2,
       'MES_DATA02',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       ' (ms)',
       'Ms de Data livre - 2',
       '',
       'TO_CHAR(REP.DATA02,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       380,
       2,
       'MES_DATA03',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       ' (ms)',
       'Ms de Data livre - 3',
       '',
       'TO_CHAR(REP.DATA03,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       210,
       2,
       'MES_DATNAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Nascto/Funda',
       'Ms de Data de nascimento ou fundao',
       '',
       'TO_CHAR(REP.DATNAS,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       80,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       0,
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms Data Operao',
       'Ms Data Operao',
       '',
       'TO_CHAR(REP.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       420,
       2,
       'MES_NASCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Nascto Cnj./',
       'Ms de Data de nascimento do cnjuge ou contato principal',
       '',
       'TO_CHAR(REP.NASCON,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '02',
       530,
       2,
       'MES_ULTCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de ltima Compra',
       'Ms ltima Compra',
       '',
       'TO_CHAR(REP.ULTCOM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       410,
       8,
       'NASCON',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Nascto Cnj./Contato',
       'Data de nascimento do cnjuge ou contato principal',
       '',
       'NASCON',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       160,
       64,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       0,
       '',
       '',
       'L',
       '',
       'F',
       'A',
       'F',
       'Nome do Cliente',
       'Nome do Cliente',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       180,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'L',
       '',
       'F',
       'A',
       'F',
       'Documento',
       'Nmero do Documento: CGC ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '02',
       490,
       10,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(REP.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '02',
       510,
       2,
       'PORPAD',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       'F',
       'A',
       'F',
       'Portador Padro',
       'Portador padro',
       'REP.PORPAD=DCOB.CODTAB (+)',
       'PORPAD',
       'T' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       440,
       2,
       'SEXCON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Sexo do Cnjuge',
       'Sexo do cnjuge',
       '',
       'SEXCON',
       'T' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       120,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       0,
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN REP.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       121,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN REP.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       10,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Parceiro',
       'Tipo de parceiro',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'REP ',
       '02',
       460,
       4,
       'TOTATR',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Total Atrasos',
       'Total de atrasos na vida do parceiro',
       '',
       'TOTATR',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '02',
       470,
       4,
       'TOTPAR',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Total de Parcelas',
       'Total de parcelas na vida do parceiro',
       '',
       'TOTPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '02',
       520,
       8,
       'ULTCOM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'ltima Compra',
       'Data da ltima compra',
       '',
       'ULTCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '01',
       170,
       20,
       'ULTNOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'L',
       '',
       'F',
       'A',
       'F',
       'Sobrenome',
       'Sobrenome ou fantasia',
       '',
       'ULTNOM',
       'F' FROM DUAL
UNION ALL
SELECT 'REP ',
       '02',
       450,
       8,
       'VALOR1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor',
       'Armazena um valor qualquer',
       '',
       'VALOR1',
       'F' FROM DUAL
);

/*-- SEQ 9184 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'REP ',
       'CODSEX',
       2,
       ' ',
       'Feminino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'CODSEX',
       0,
       ' ',
       'Nao conhecido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'CODSEX',
       1,
       ' ',
       'Masculino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'CODSEX',
       2,
       '-',
       'Feminino',
       146,
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'CODSEX',
       0,
       '-',
       'Nao conhecido',
       144,
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'CODSEX',
       1,
       '-',
       'Masculino',
       145,
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'ESTCIV',
       0,
       ' ',
       'Indefinido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'ESTCIV',
       1,
       ' ',
       'Solteiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'ESTCIV',
       2,
       ' ',
       'Casado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'ESTCIV',
       3,
       ' ',
       'Vivo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'ESTCIV',
       4,
       ' ',
       'Divorciado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'ESTCIV',
       5,
       ' ',
       'Unio Estvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'ESTCIV',
       6,
       ' ',
       'Separado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'ESTCIV',
       3,
       '-',
       'Vivo',
       150,
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'ESTCIV',
       5,
       '-',
       'Unio Estvel',
       152,
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'ESTCIV',
       6,
       '-',
       'Separado',
       153,
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'ESTCIV',
       0,
       '-',
       'Indefinido',
       147,
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'ESTCIV',
       4,
       '-',
       'Divorciado',
       151,
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'ESTCIV',
       1,
       '-',
       'Solteiro',
       148,
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'ESTCIV',
       2,
       '-',
       'Casado',
       149,
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'FLGTIP',
       3,
       ' ',
       'Especial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'FLGTIP',
       4,
       ' ',
       'M.E.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'FLGTIP',
       5,
       ' ',
       'Filial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'FLGTIP',
       0,
       ' ',
       'Fsica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'FLGTIP',
       1,
       ' ',
       'Jurdica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'FLGTIP',
       2,
       ' ',
       'Entidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'FLGTIP',
       1,
       '-',
       'Jurdica',
       155,
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'FLGTIP',
       2,
       '-',
       'Entidade',
       156,
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'FLGTIP',
       3,
       '-',
       'Especial',
       157,
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'FLGTIP',
       4,
       '-',
       'M.E.',
       158,
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'FLGTIP',
       0,
       '-',
       'Fsica',
       154,
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'FLGTIP',
       5,
       '-',
       'Filial',
       159,
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'SEXCON',
       0,
       '-',
       'Nao conhecido',
       160,
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'SEXCON',
       1,
       '-',
       'Masculino',
       161,
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'SEXCON',
       2,
       '-',
       'Feminino',
       162,
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'TIPPAR',
       0,
       'F',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REP ',
       'TIPPAR',
       0,
       'T',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9185 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'REQ ',
       TO_NUMBER(null),
       'REQ ',
       'Requisitos Sistema',
       'TT_REQ',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9186 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'REQ ','--','' FROM DUAL
UNION ALL
SELECT 'REQ ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'REQ ','99','Outros' FROM DUAL
);

/*-- SEQ 9187 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20158,
       'USU ',
       'REQ ',
       'N',
       'N',
       '',
       '',
       'USU.FILUSU = REQ.FILUSU AND
USU.CODUSU = REQ.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20159,
       'WOR ',
       'REQ ',
       '1',
       'N',
       '',
       '',
       'WOR.CODFIL = REQ.FILWOR AND
WOR.SEQUEN = REQ.SEQWOR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20160,
       'PRJ ',
       'REQ ',
       '1',
       'N',
       '',
       '',
       'PRJ.CODFIL = REQ.FILPRJ AND
PRJ.SEQUEN = REQ.SEQPRJ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20161,
       'DREQ',
       'REQ ',
       '1',
       'N',
       '',
       '',
       'REQ.TIPREQ = DREQ.CODTAB AND
REQ.CLAREQ = DREQ.CLAREQ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20162,
       'DSTR',
       'REQ ',
       'N',
       '1',
       '',
       '',
       'DSTR.CODTAB = REQ.FLGREQ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20163,
       'CON ',
       'REQ ',
       'N',
       '01',
       '',
       '',
       'CON.FILCLI = REQ.FILCLI AND
CON.CODCLI = REQ.CODCLI AND 
CON.NUMCON = REQ.NUMCON',
       '',
       '' FROM DUAL
);

/*-- SEQ 9188 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'REQ ',
       '--',
       130,
       5,
       'ARTEFA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Nmero de Artefatos',
       'Nmero de Artefatos',
       '',
       'ARTEFA',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '01',
       80,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '01',
       170,
       1,
       'CLAREQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Classificao ',
       'Classificao ',
       '',
       'CLAREQ',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '01',
       270,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Con. solicit. alter.',
       'Contato Que solicitou alterao',
       '',
       'CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '--',
       60,
       5,
       'CODREQ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo do Requisito',
       'Cdigo do Requisito',
       '',
       'CODREQ',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '01',
       150,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Autor',
       'Autor',
       '',
       'CODUSU',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '01',
       100,
       1,
       'COMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Complexidade',
       'Complexidade',
       '',
       'COMPLE',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '01',
       70,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '01',
       190,
       4000,
       'DESCRI',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio',
       'Descrio',
       '',
       'RTF2TXT(DESCRI)',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '01',
       260,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Con. solicit. alter.',
       'Contato Que solicitou alterao',
       '',
       'FILCLI',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '01',
       200,
       3,
       'FILPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Filial do projeto',
       'Filial do projeto',
       '',
       'FILPRJ',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '01',
       140,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Autor',
       'Autor',
       '',
       'FILUSU',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '01',
       220,
       3,
       'FILWOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Filial tarefa prop. ',
       'Filial da tarefa de proposta',
       '',
       'FILWOR',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '--',
       90,
       5,
       'FLGREQ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Situao',
       'Situao',
       '',
       'FLGREQ',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '--',
       250,
       7,
       'HORCOB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Hrs cobradas p/ req',
       'Horas cobradas para o requisito',
       '',
       'HORCOB',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '--',
       240,
       7,
       'HORPRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Hrs previstas p/ req',
       'Horas previstas para o requisito',
       '',
       'HORPRE',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '01',
       290,
       254,
       'MOTALT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Motivo da alterao',
       'Motivo da alterao',
       '',
       'MOTALT',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '--',
       280,
       5,
       'NUMCON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Con. solicit. alter.',
       'Contato Que solicitou alterao',
       '',
       'NUMCON',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '--',
       180,
       2,
       'NUMFAS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Fase',
       'Fase',
       '',
       'NUMFAS',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '01',
       110,
       1,
       'PRIORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Prioridade',
       'Prioridade',
       '',
       'PRIORI',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '01',
       120,
       1,
       'RISREQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Risco',
       'Risco',
       '',
       'RISREQ',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '01',
       210,
       10,
       'SEQPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sequen do projeto',
       'Sequenciador do projeto',
       '',
       'SEQPRJ',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '01',
       230,
       10,
       'SEQWOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seqquen tarefa prop.',
       'Sequenciador da tarefa de proposta',
       '',
       'SEQWOR',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '--',
       160,
       5,
       'TIPREQ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Tipo',
       'Autor',
       '',
       'TIPREQ',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '01',
       50,
       100,
       'TITREQ',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Ttulo',
       'Ttulo',
       '',
       'RTF2TXT(TITREQ)',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '--',
       40,
       5,
       'VERMAX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Verso Mxima',
       'Verso Mxima',
       '',
       'VERMAX',
       '' FROM DUAL
UNION ALL
SELECT 'REQ ',
       '--',
       30,
       5,
       'VERMIN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Verso Mnima',
       'Verso Mnima',
       '',
       'VERMIN',
       '' FROM DUAL
);

/*-- SEQ 9189 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'REQ ',
       'COMPLE',
       0,
       '1',
       'Simples',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REQ ',
       'COMPLE',
       0,
       '2',
       'Mdio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REQ ',
       'COMPLE',
       0,
       '3',
       'Complexo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REQ ',
       'RISREQ',
       0,
       '1',
       'Baixo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REQ ',
       'RISREQ',
       0,
       '2',
       'Mdio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'REQ ',
       'RISREQ',
       0,
       '3',
       'Alto',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9190 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RES ',
       TO_NUMBER(null),
       'RES ',
       'RespostaQuestionrio',
       'TT_RES',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'RES.CODFIL,RES.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9191 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RES ','--','' FROM DUAL
UNION ALL
SELECT 'RES ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RES ','02','Datas' FROM DUAL
UNION ALL
SELECT 'RES ','99','Outros' FROM DUAL
);

/*-- SEQ 9192 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5846,
       'CLI ',
       'RES ',
       '1 ',
       '0N',
       '',
       '',
       'CLI.FILCLI = RES.FILCLI(+) and
CLI.CODCLI = RES.CODCLI(+)',
       '' FROM DUAL
UNION ALL
SELECT 5847,
       'IQU ',
       'RES ',
       '1 ',
       'N ',
       '',
       '',
       'RES.NUMIQU = IQU.NUMIQV and
RES.FILQUE = IQU.FILQUE and
RES.CODQUE = IQU.CODQUE',
       '' FROM DUAL
UNION ALL
SELECT 5848,
       'OPC ',
       'RES ',
       '1 ',
       'N ',
       '',
       '',
       'OPC.FILPER = RES.FILPER and
OPC.CODPER = RES.CODPER and
OPC.CODOPC = RES.CODOPC',
       '' FROM DUAL
);

/*-- SEQ 9193 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RES ',
       '02',
       35,
       4,
       'ANO_DATHOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data',
       'Ano de Data',
       '',
       'TO_CHAR(RES.DATHOR,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'RES ',
       '01',
       1,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'RES ',
       '01',
       110,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = RES.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'RES ',
       '01',
       2,
       3,
       'CODOPC',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Cdigo Opo',
       'Cdigo da opo',
       '',
       'CODOPC',
       'F' FROM DUAL
UNION ALL
SELECT 'RES ',
       '01',
       80,
       5,
       'CODPER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo Pergunta',
       'Cdigo da pergunta',
       '',
       'CODPER',
       'F' FROM DUAL
UNION ALL
SELECT 'RES ',
       '01',
       90,
       5,
       'CODQUE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo Questionrio',
       'Cdigo do questionrio',
       '',
       'CODQUE',
       'F' FROM DUAL
UNION ALL
SELECT 'RES ',
       '99',
       100,
       255,
       'COMENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Comentrio',
       'Comentrio sobre a resposta',
       '',
       'COMENT',
       'F' FROM DUAL
UNION ALL
SELECT 'RES ',
       '02',
       30,
       8,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data',
       'Data',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'RES ',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial origem  do cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'RES ',
       '01',
       40,
       3,
       'FILPER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial da pergunta',
       '',
       'FILPER',
       'F' FROM DUAL
UNION ALL
SELECT 'RES ',
       '01',
       60,
       3,
       'FILQUE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial origem do questionrio',
       '',
       'FILQUE',
       'F' FROM DUAL
UNION ALL
SELECT 'RES ',
       '02',
       33,
       2,
       'MES_DATHOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data',
       'Ms de Data',
       '',
       'TO_CHAR(RES.DATHOR,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'RES ',
       '01',
       50,
       3,
       'NUMIQU',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nm. Item Quest.',
       'Nmero do item de questionrio',
       '',
       'NUMIQU',
       'F' FROM DUAL
UNION ALL
SELECT 'RES ',
       '01',
       120,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 9194 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RES5',
       TO_NUMBER(null),
       'RES5',
       'Restries 005',
       'TV_RES_005',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9195 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RES5','--','' FROM DUAL
UNION ALL
SELECT 'RES5','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RES5','99','Outros' FROM DUAL
);

/*-- SEQ 9196 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RES5',
       '--',
       10,
       12,
       'DIVIDA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dvida',
       'Dvida',
       '',
       'DIVIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'RES5',
       '--',
       20,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       '9',
       'F',
       'Tipo Flag.',
       'Flag',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'RES5',
       '--',
       30,
       12,
       'LIMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Limite Crdito',
       'Limite Crdito',
       '',
       'LIMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'RES5',
       '--',
       40,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Documento',
       'Nmero Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'RES5',
       '--',
       50,
       12,
       'OCORRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero Ocorrncias',
       'Nmero de Ocorrncias',
       '',
       'OCORRE',
       'F' FROM DUAL
UNION ALL
SELECT 'RES5',
       '--',
       60,
       31,
       'RESTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Restries',
       'Restries',
       '',
       'RESTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'RES5',
       '--',
       70,
       12,
       'TIPRES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tipo Restries',
       'Tipo Restries',
       '',
       'TIPRES',
       'F' FROM DUAL
);

/*-- SEQ 9197 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'RES5',
       'FLGTIP',
       0,
       '-',
       'Fsica',
       154,
       ' ' FROM DUAL
UNION ALL
SELECT 'RES5',
       'FLGTIP',
       1,
       '-',
       'Jurdica',
       155,
       ' ' FROM DUAL
UNION ALL
SELECT 'RES5',
       'FLGTIP',
       2,
       '-',
       'Entidade',
       156,
       ' ' FROM DUAL
UNION ALL
SELECT 'RES5',
       'FLGTIP',
       3,
       '-',
       'Especial',
       157,
       ' ' FROM DUAL
UNION ALL
SELECT 'RES5',
       'FLGTIP',
       4,
       '-',
       'M.E.',
       158,
       ' ' FROM DUAL
UNION ALL
SELECT 'RES5',
       'FLGTIP',
       5,
       '-',
       'Filial',
       159,
       ' ' FROM DUAL
);

/*-- SEQ 9198 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RES6',
       TO_NUMBER(null),
       'RES6',
       'Restries 006',
       'TV_RES_006',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9199 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RES6','--','' FROM DUAL
UNION ALL
SELECT 'RES6','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RES6','99','Outros' FROM DUAL
);

/*-- SEQ 9200 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RES6',
       '--',
       10,
       12,
       'DIVIDA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dvida',
       'Dvida',
       '',
       'DIVIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'RES6',
       '--',
       20,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       '9',
       'F',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'RES6',
       '--',
       30,
       12,
       'LIMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'LIMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'RES6',
       '--',
       40,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'RES6',
       '--',
       50,
       12,
       'OCORRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ocorrncia',
       'Ocorrncia',
       '',
       'OCORRE',
       'F' FROM DUAL
UNION ALL
SELECT 'RES6',
       '--',
       60,
       17,
       'RESTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Restrio',
       'Restrio',
       '',
       'RESTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'RES6',
       '--',
       70,
       1,
       'TIPRES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Tipo de Restrio',
       'Tipo de Restrio',
       '',
       'TIPRES',
       'T' FROM DUAL
);

/*-- SEQ 9201 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'RES6',
       'FLGTIP',
       0,
       '-',
       'Fsica',
       154,
       ' ' FROM DUAL
UNION ALL
SELECT 'RES6',
       'FLGTIP',
       1,
       '-',
       'Jurdica',
       155,
       ' ' FROM DUAL
UNION ALL
SELECT 'RES6',
       'FLGTIP',
       2,
       '-',
       'Entidade',
       156,
       ' ' FROM DUAL
UNION ALL
SELECT 'RES6',
       'FLGTIP',
       3,
       '-',
       'Especial',
       157,
       ' ' FROM DUAL
UNION ALL
SELECT 'RES6',
       'FLGTIP',
       4,
       '-',
       'M.E.',
       158,
       ' ' FROM DUAL
UNION ALL
SELECT 'RES6',
       'FLGTIP',
       5,
       '-',
       'Filial',
       159,
       ' ' FROM DUAL
);

/*-- SEQ 9202 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RES7',
       TO_NUMBER(null),
       'RES7',
       'Restries 007',
       'TV_RES_007',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9203 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RES7','--','' FROM DUAL
UNION ALL
SELECT 'RES7','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RES7','99','Outros' FROM DUAL
);

/*-- SEQ 9204 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RES7',
       '01',
       10,
       12,
       'DIVIDA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dvida',
       'Dvida',
       '',
       'DIVIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'RES7',
       '01',
       20,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       '9',
       'F',
       'Flag',
       'Flag',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'RES7',
       '01',
       30,
       12,
       'LIMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'LIMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'RES7',
       '01',
       40,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'RES7',
       '01',
       50,
       12,
       'OCORRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ocorrncia',
       'Ocorrncia',
       '',
       'OCORRE',
       'F' FROM DUAL
UNION ALL
SELECT 'RES7',
       '01',
       60,
       17,
       'RESTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Restrio',
       'Restrio',
       '',
       'RESTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'RES7',
       '01',
       70,
       1,
       'TIPRES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Tipo de Restrio',
       'Tipo de Restrio',
       '',
       'TIPRES',
       'T' FROM DUAL
);

/*-- SEQ 9205 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'RES7',
       'FLGTIP',
       0,
       '-',
       'Fsica',
       154,
       ' ' FROM DUAL
UNION ALL
SELECT 'RES7',
       'FLGTIP',
       1,
       '-',
       'Jurdica',
       155,
       ' ' FROM DUAL
UNION ALL
SELECT 'RES7',
       'FLGTIP',
       2,
       '-',
       'Entidade',
       156,
       ' ' FROM DUAL
UNION ALL
SELECT 'RES7',
       'FLGTIP',
       3,
       '-',
       'Especial',
       157,
       ' ' FROM DUAL
UNION ALL
SELECT 'RES7',
       'FLGTIP',
       4,
       '-',
       'M.E.',
       158,
       ' ' FROM DUAL
UNION ALL
SELECT 'RES7',
       'FLGTIP',
       5,
       '-',
       'Filial',
       159,
       ' ' FROM DUAL
);

/*-- SEQ 9206 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RET ',
       TO_NUMBER(null),
       'RET ',
       'Ret. Cobrana Banco',
       'TT_RET',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'RET.CODBCO,RET.CODRET',
       '' FROM DUAL
);

/*-- SEQ 9207 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RET ','--','' FROM DUAL
UNION ALL
SELECT 'RET ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RET ','99','Outros' FROM DUAL
);

/*-- SEQ 9208 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RET ',
       '01',
       10,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Codigo do Banco',
       'Codigo do Banco (TD_BCO)',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'RET ',
       '01',
       20,
       5,
       'CODRET',
       'S',
       'DRET',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DRET.DESRET',
       'V',
       '',
       '',
       'N',
       'F',
       'Codigo do Retorno',
       'Codigo do Retorno (TD_RET)',
       'DRET.CODTAB(+) = RET.CODRET',
       'CODRET',
       'T' FROM DUAL
UNION ALL
SELECT 'RET ',
       '01',
       30,
       30,
       'DESRET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Desc Ret Bancar',
       'Descricao do Retorno Bancario',
       '',
       'DESRET',
       'F' FROM DUAL
UNION ALL
SELECT 'RET ',
       '01',
       40,
       2,
       'RETBCO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Num Ret para o Banco',
       'Numero do Retorno para o Banco',
       '',
       'RETBCO',
       'F' FROM DUAL
);

/*-- SEQ 9209 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RFC ',
       TO_NUMBER(null),
       'RFC ',
       'Resumo Fin. Cliente',
       'TV_RFC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'RFC.FILCLI,RFC.CODCLI',
       '' FROM DUAL
);

/*-- SEQ 9210 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RFC ','--','' FROM DUAL
UNION ALL
SELECT 'RFC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RFC ','99','Outros' FROM DUAL
);

/*-- SEQ 9211 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21916,
       'CLI ',
       'RFC ',
       '01',
       'N',
       '',
       '',
       'CLI.FILCLI(+) = RFC.FILCLI AND
CLI.CODCLI(+) = RFC.CODCLI
',
       '',
       '' FROM DUAL
);

/*-- SEQ 9212 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RFC ',
       '01',
       60,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'RFC ',
       '01',
       50,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial do Cliente',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'RFC ',
       '99',
       100,
       4000,
       'OBSERV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Observaes',
       'Observaes por Referncia de Cliente',
       '',
       'OBSERV',
       '' FROM DUAL
UNION ALL
SELECT 'RFC ',
       '01',
       20,
       8,
       'VLRAVE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor a vencer',
       'Valor a vencer',
       '',
       'VLRAVE',
       'F' FROM DUAL
UNION ALL
SELECT 'RFC ',
       '01',
       70,
       12,
       'VLRCAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Carto',
       'Valor Carto',
       '',
       'VLRCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'RFC ',
       '01',
       40,
       8,
       'VLRCCC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Saldo conta corrente',
       'Saldo conta corrente',
       '',
       'VLRCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'RFC ',
       '01',
       80,
       12,
       'VLRCCH',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Carto Cheque',
       'Valor Carto  e Cheque',
       '',
       'VLRCCH',
       'F' FROM DUAL
UNION ALL
SELECT 'RFC ',
       '01',
       90,
       12,
       'VLRCHE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Cheques',
       'Valor Cheques',
       '',
       'VLRCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'RFC ',
       '01',
       30,
       8,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor recebido',
       'Valor pago pelo cliente',
       '',
       'VLRPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'RFC ',
       '01',
       10,
       8,
       'VLRVEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor vencido ',
       'Valor vencido e no recebido',
       '',
       'VLRVEN',
       'F' FROM DUAL
);

/*-- SEQ 9213 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RFF ',
       TO_NUMBER(null),
       'RFF ',
       'ResumoFin.Fornecedor',
       'TV_RFF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'RFF.FILCLI,RFF.CODCLI',
       '' FROM DUAL
);

/*-- SEQ 9214 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RFF ','--','' FROM DUAL
);

/*-- SEQ 9215 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 35123,
       'PVD ',
       'RFF ',
       '1 ',
       '1 ',
       '',
       '',
       'PVD.FILCLI(+) = RFF.FILCLI AND
PVD.CODCLI(+) = RFF.CODCLI
',
       '' FROM DUAL
);

/*-- SEQ 9216 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RFF ',
       '--',
       50,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo do Fornecedor',
       'Cdigo do Fornecedor',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'RFF ',
       '--',
       40,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Fornecedor',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'RFF ',
       '--',
       20,
       8,
       'VLRAVE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor a vencer',
       'Valor a vencer',
       '',
       'VLRAVE',
       'F' FROM DUAL
UNION ALL
SELECT 'RFF ',
       '--',
       30,
       8,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor pago',
       'Valor pago ao fornecedor',
       '',
       'VLRPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'RFF ',
       '--',
       10,
       8,
       'VLRVEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor vencido',
       'Valor vencido e no pago',
       '',
       'VLRVEN',
       'F' FROM DUAL
);

/*-- SEQ 9217 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RFIN',
       TO_NUMBER(null),
       'RFIN',
       'Mov. Financeiras',
       'TV_REL_FIN',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9218 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RFIN','--','' FROM DUAL
UNION ALL
SELECT 'RFIN','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RFIN','99','Outros' FROM DUAL
);

/*-- SEQ 9219 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RFIN',
       '--',
       10,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data da Movimentao',
       'Data da
Movimentao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'RFIN',
       '--',
       20,
       250,
       'GRUCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Grupo Cta Contbil',
       '',
       '',
       'GRUCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'RFIN',
       '--',
       30,
       250,
       'NOMCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Cta Contabil',
       '',
       '',
       'NOMCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'RFIN',
       '--',
       70,
       1,
       'ORDEM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ordenao',
       '',
       '',
       'ORDEM',
       'F' FROM DUAL
UNION ALL
SELECT 'RFIN',
       '--',
       40,
       250,
       'SUBGRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub-Grupo Cta Contab',
       '',
       '',
       'SUBGRU',
       'F' FROM DUAL
UNION ALL
SELECT 'RFIN',
       '--',
       50,
       12,
       'TOTACU',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Total Acumulado',
       '',
       '',
       'TOTACU',
       'F' FROM DUAL
UNION ALL
SELECT 'RFIN',
       '--',
       60,
       12,
       'TOTDIA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Total do Dia',
       '',
       '',
       'TOTDIA',
       'F' FROM DUAL
);

/*-- SEQ 9220 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RFIS',
       TO_NUMBER(null),
       'RFIS',
       'Receb. Supersimples',
       'TV_RECFIS',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9221 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RFIS','--','' FROM DUAL
UNION ALL
SELECT 'RFIS','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RFIS','99','Outros' FROM DUAL
);

/*-- SEQ 9222 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23419,
       'VEN ',
       'RFIS',
       '1 ',
       '1 ',
       '',
       '',
       'VEN.CODFIL = RFIS.CODFIL AND
VEN.SEQUEN = RFIS.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 9223 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RFIS',
       '--',
       130,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'RFIS',
       '--',
       20,
       7,
       'DATAOPERACAO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Operao',
       'Data da Operao',
       '',
       'DATAOPERACAO',
       'F' FROM DUAL
UNION ALL
SELECT 'RFIS',
       '--',
       30,
       7,
       'DATARECEBIMENTO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Recebimento',
       'Data de Recebimento',
       '',
       'DATARECEBIMENTO',
       'F' FROM DUAL
UNION ALL
SELECT 'RFIS',
       '--',
       40,
       7,
       'DATAVENCIMENTO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Vencimento',
       'Data de Vencimento',
       '',
       'DATAVENCIMENTO',
       'F' FROM DUAL
UNION ALL
SELECT 'RFIS',
       '--',
       150,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial de Receb.',
       'Filial de Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'RFIS',
       '--',
       50,
       1,
       'MATERIAL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Material?',
       'Algum Item da Venda  Material?',
       '',
       'MATERIAL',
       'F' FROM DUAL
UNION ALL
SELECT 'RFIS',
       '--',
       10,
       13,
       'NUMDOCUMENTO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Documento',
       'Nmero do Documento',
       '',
       'NUMDOCUMENTO',
       '' FROM DUAL
UNION ALL
SELECT 'RFIS',
       '--',
       60,
       2,
       'NUMPARCELA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Parcela',
       'Nmero da Parcela',
       '',
       'NUMPARCELA',
       'F' FROM DUAL
UNION ALL
SELECT 'RFIS',
       '--',
       70,
       2,
       'QTDPARCELAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Qtd. Parcelas',
       'Quantidade de Parcelas',
       '',
       'QTDPARCELAS',
       'F' FROM DUAL
UNION ALL
SELECT 'RFIS',
       '--',
       80,
       12,
       'SALDO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Saldo',
       'Saldo',
       '',
       'SALDO',
       'F' FROM DUAL
UNION ALL
SELECT 'RFIS',
       '--',
       140,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'RFIS',
       '--',
       90,
       1,
       'SERVICO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Servio?',
       'Algum Item da Venda  Servio?',
       '',
       'SERVICO',
       'F' FROM DUAL
UNION ALL
SELECT 'RFIS',
       '--',
       100,
       12,
       'VALORPAGO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Pago',
       'Valor Pago',
       '',
       'VALORPAGO',
       'F' FROM DUAL
UNION ALL
SELECT 'RFIS',
       '--',
       110,
       12,
       'VALORPARCELA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor da Parcela',
       'Valor da Parcela',
       '',
       'VALORPARCELA',
       'F' FROM DUAL
UNION ALL
SELECT 'RFIS',
       '--',
       120,
       12,
       'VALORTOTAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Total',
       'Valor Total',
       '',
       'VALORTOTAL',
       'F' FROM DUAL
);

/*-- SEQ 9224 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RLAP',
       TO_NUMBER(null),
       'RLAP',
       'Anlise de preos',
       'TV_REL_ANA_PRE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9225 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RLAP','--','' FROM DUAL
UNION ALL
SELECT 'RLAP','01','Classificao' FROM DUAL
UNION ALL
SELECT 'RLAP','99','Outros' FROM DUAL
);

/*-- SEQ 9226 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RLAP',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       '',
       'DFIL.CODFIL = RLAP.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'RLAP',
       '--',
       20,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data',
       '',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'RLAP',
       '--',
       30,
       83,
       'GRUPO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'F',
       '',
       'F',
       'Grupo',
       '',
       '',
       'GRUPO',
       'F' FROM DUAL
UNION ALL
SELECT 'RLAP',
       '--',
       40,
       12,
       'QTDCOMANO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       'Qtdade Compra Ano',
       '',
       '',
       'QTDCOMANO',
       'F' FROM DUAL
UNION ALL
SELECT 'RLAP',
       '--',
       50,
       12,
       'QTDCOMDIA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       'Qtdade Compra Dia',
       '',
       '',
       'QTDCOMDIA',
       'F' FROM DUAL
UNION ALL
SELECT 'RLAP',
       '--',
       60,
       12,
       'QTDCOMMES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       'Qtdade Compra Ms',
       '',
       '',
       'QTDCOMMES',
       'F' FROM DUAL
UNION ALL
SELECT 'RLAP',
       '--',
       70,
       12,
       'QTDVENANO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       'Qtdade Venda Ano',
       '',
       '',
       'QTDVENANO',
       'F' FROM DUAL
UNION ALL
SELECT 'RLAP',
       '--',
       80,
       12,
       'QTDVENDIA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       'Qtdade Venda Dia',
       '',
       '',
       'QTDVENDIA',
       'F' FROM DUAL
UNION ALL
SELECT 'RLAP',
       '--',
       90,
       12,
       'QTDVENMES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       'Qtdade Venda Ms',
       '',
       '',
       'QTDVENMES',
       'F' FROM DUAL
UNION ALL
SELECT 'RLAP',
       '01',
       100,
       12,
       'TIPO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Tipo',
       '',
       '',
       'TIPO',
       'F' FROM DUAL
UNION ALL
SELECT 'RLAP',
       '--',
       110,
       12,
       'VLRCOMANO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       'Valor Compra Ano',
       '',
       '',
       'VLRCOMANO',
       'F' FROM DUAL
UNION ALL
SELECT 'RLAP',
       '--',
       120,
       12,
       'VLRCOMDIA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       'Valor Compra Dia',
       '',
       '',
       'VLRCOMDIA',
       'F' FROM DUAL
UNION ALL
SELECT 'RLAP',
       '--',
       130,
       12,
       'VLRCOMMES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       'Valor Compra Ms',
       '',
       '',
       'VLRCOMMES',
       'F' FROM DUAL
UNION ALL
SELECT 'RLAP',
       '--',
       140,
       12,
       'VLRVENANO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       'Valor Venda Ano',
       '',
       '',
       'VLRVENANO',
       'F' FROM DUAL
UNION ALL
SELECT 'RLAP',
       '--',
       150,
       12,
       'VLRVENDIA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       'Valor Venda Dia',
       '',
       '',
       'VLRVENDIA',
       'F' FROM DUAL
UNION ALL
SELECT 'RLAP',
       '--',
       160,
       12,
       'VLRVENMES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       'Valor Venda Ms',
       '',
       '',
       'VLRVENMES',
       'F' FROM DUAL
);

/*-- SEQ 9227 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RLEE',
       TO_NUMBER(null),
       'RLEE',
       'Resumos de Estoque',
       'TV_REL_RES_EST',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9228 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RLEE','--','' FROM DUAL
UNION ALL
SELECT 'RLEE','01','Classificao' FROM DUAL
UNION ALL
SELECT 'RLEE','99','Outros' FROM DUAL
);

/*-- SEQ 9229 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RLEE',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       '',
       'DFIL.CODFIL = RLEE.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'RLEE',
       '01',
       20,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data',
       '',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'RLEE',
       '01',
       30,
       83,
       'GRUPO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Grupo',
       '',
       '',
       'GRUPO',
       'F' FROM DUAL
UNION ALL
SELECT 'RLEE',
       '--',
       40,
       12,
       'TOTANO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       'Total do Ano',
       '',
       '',
       'TOTANO',
       'F' FROM DUAL
UNION ALL
SELECT 'RLEE',
       '--',
       20,
       12,
       'TOTDIA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       'Total do Dia',
       '',
       '',
       'TOTDIA',
       'F' FROM DUAL
UNION ALL
SELECT 'RLEE',
       '--',
       30,
       12,
       'TOTMES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       'Total do Ms',
       '',
       '',
       'TOTMES',
       'F' FROM DUAL
UNION ALL
SELECT 'RLEE',
       '01',
       70,
       19,
       'UNIDADE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Unidade',
       '',
       '',
       'UNIDADE',
       'F' FROM DUAL
);

/*-- SEQ 9230 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RLFI',
       TO_NUMBER(null),
       'RLFI',
       'Moviment. Financeira',
       'TV_REL_FIN',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9231 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RLFI','--','' FROM DUAL
UNION ALL
SELECT 'RLFI','01','Classificao' FROM DUAL
UNION ALL
SELECT 'RLFI','99','Outros' FROM DUAL
);

/*-- SEQ 9232 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RLFI',
       '--',
       10,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Operao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'RLFI',
       '--',
       20,
       250,
       'GRUCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Grupo Contas',
       'Grupo Contas',
       '',
       'GRUCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'RLFI',
       '--',
       30,
       250,
       'NOMCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Conta',
       'Conta',
       '',
       'NOMCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'RLFI',
       '--',
       40,
       12,
       'ORDEM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ordem',
       'Ordem',
       '',
       'ORDEM',
       'F' FROM DUAL
UNION ALL
SELECT 'RLFI',
       '--',
       50,
       250,
       'SUBGRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub Grupo',
       'Sub Grupo',
       '',
       'SUBGRU',
       'F' FROM DUAL
UNION ALL
SELECT 'RLFI',
       '--',
       60,
       12,
       'TOTACU',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Total Acumulado',
       'Total Acumulado',
       '',
       'TOTACU',
       'F' FROM DUAL
UNION ALL
SELECT 'RLFI',
       '--',
       70,
       12,
       'TOTDIA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Total do dia',
       'Total do dia',
       '',
       'TOTDIA',
       'F' FROM DUAL
);

/*-- SEQ 9233 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RLRV',
       TO_NUMBER(null),
       'RLRV',
       'Resumo de Vendas',
       'TV_REL_RES_VEN',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9234 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RLRV','--','' FROM DUAL
UNION ALL
SELECT 'RLRV','01','Classificao' FROM DUAL
UNION ALL
SELECT 'RLRV','99','Outros' FROM DUAL
);

/*-- SEQ 9235 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RLRV',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       '',
       'DFIL.CODFIL = RLRV.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'RLRV',
       '--',
       20,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data',
       '',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'RLRV',
       '--',
       30,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'RLRV',
       '01',
       40,
       4000,
       'MEIOPAGAMENTO',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Modalidade de Vendas',
       '',
       '',
       'MEIOPAGAMENTO',
       'F' FROM DUAL
UNION ALL
SELECT 'RLRV',
       '--',
       50,
       12,
       'TOTANO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       'Total Ano',
       '',
       '',
       'TOTANO',
       'F' FROM DUAL
UNION ALL
SELECT 'RLRV',
       '--',
       60,
       12,
       'TOTDIA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       'Total Dia',
       '',
       '',
       'TOTDIA',
       'F' FROM DUAL
UNION ALL
SELECT 'RLRV',
       '--',
       70,
       12,
       'TOTMES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       'Total Mes',
       '',
       '',
       'TOTMES',
       'F' FROM DUAL
);

/*-- SEQ 9236 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'RLRV',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RLRV',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RLRV',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RLRV',
       'FLGEST',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9237 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RMOV',
       TO_NUMBER(null),
       'RMOV',
       'Resumo de Movimento',
       'TR_MOV',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'RMOV.CODFIL,RMOV.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9238 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RMOV','--','' FROM DUAL
UNION ALL
SELECT 'RMOV','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RMOV','02','Valores' FROM DUAL
UNION ALL
SELECT 'RMOV','03','Datas' FROM DUAL
UNION ALL
SELECT 'RMOV','04','ltima Compra' FROM DUAL
UNION ALL
SELECT 'RMOV','05','Saldo da Filial' FROM DUAL
UNION ALL
SELECT 'RMOV','99','Outros' FROM DUAL
);

/*-- SEQ 9239 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23147,
       'GRA ',
       'RMOV',
       '1',
       'N',
       '',
       '',
       'RMOV.FILMAT = GRA.FILMAT AND
RMOV.CODMAT = GRA.CODMAT AND
RMOV.CODCOR = GRA.CODCOR AND
RMOV.CODTAM = GRA.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23148,
       'VIPR',
       'RMOV',
       '1',
       'N',
       '',
       '',
       'RMOV.FILMAT = VIPR.FILMAT AND
RMOV.CODMAT = VIPR.CODMAT AND
RMOV.CODCOR = VIPR.CODCOR AND
RMOV.CODTAM = VIPR.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23149,
       'ICO ',
       'RMOV',
       '1',
       'N',
       '',
       '',
       'RMOV.FILICO = ICO.CODFIL AND
RMOV.SEQICO = ICO.SEQUEN AND
RMOV.NUMICO = ICO.NUMITE',
       '',
       '' FROM DUAL
);

/*-- SEQ 9240 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RMOV',
       '05',
       291,
       8,
       ':RMOV.DATREFSAL',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data',
       'Data',
       '',
       ':RMOV.DATREFSAL',
       '' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '03',
       65,
       4,
       'ANO_DATMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data Movto',
       'Ano de Data da movimentao',
       '',
       'TO_CHAR(RMOV.DATMOV,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '99',
       340,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Assinatura do PAF-ECF',
       '',
       'ASSINA',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '01',
       3,
       12,
       'CODCOR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Diviso',
       'Diviso',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '01',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Filial',
       'RMOV.CODFIL = DFIL.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '01',
       4,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo do produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '02',
       180,
       12,
       'CODMUL',
       'F',
       'DMUL',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       'F',
       'Sub-Estoque',
       'Nome do Sub-Estoque',
       'DMUL.CODTAB = RMOV.CODMUL',
       'CODMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '01',
       5,
       12,
       'CODTAM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Sub-Diviso',
       'Sub-Diviso',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '99',
       330,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Cdigo da Tabela de Acesso',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '02',
       190,
       12,
       'CUSFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Custo Frete',
       'Custo Frete',
       '',
       '(SELECT ICO.CUSFRE FROM TT_ICO ICO WHERE ICO.CODFIL = RMOV.FILFRE AND ICO.SEQUEN = RMOV.SEQFRE AND ICO.NUMITE = RMOV.NUMFRE)',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '02',
       200,
       12,
       'CUSREP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Custo Representante',
       'Custo Representante',
       '',
       '(SELECT ICO.CUSREP FROM TT_ICO ICO WHERE ICO.CODFIL = RMOV.FILICO AND ICO.SEQUEN = RMOV.SEQICO AND ICO.NUMITE = RMOV.NUMICO)',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '03',
       60,
       8,
       'DATMOV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data Movto',
       'Data da movimentao',
       '',
       'DATMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '02',
       250,
       12,
       'DESCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Desconto na compra',
       'Valor de Desconto da compra',
       '',
       'DESCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '04',
       280,
       3,
       'FILFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Filial Custo Frete',
       'Filial da ltima Compra com Custo de Frete',
       '',
       'FILFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '04',
       270,
       3,
       'FILICO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Filial Atual. Custo',
       'Filial da ltima Compra que Atualiza Custo',
       '',
       'FILICO',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '01',
       70,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial do produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '03',
       63,
       2,
       'MES_DATMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data Movto',
       'Ms de Data da movimentao',
       '',
       'TO_CHAR(RMOV.DATMOV,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '04',
       281,
       5,
       'NUMFRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero Custo Frete',
       'Nmero da ltima Compra com Custo de Frete',
       '',
       'NUMFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '04',
       271,
       5,
       'NUMICO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero Atual. Custo',
       'Nmero da ltima Compra que Atualiza Custo',
       '',
       'NUMICO',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '02',
       321,
       9,
       'NUMVEN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '#Nmero de Vendas',
       'Nmero de Doc Fiscais de Sada com o Produto (descontinuado)',
       '',
       'NUMVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '02',
       210,
       12,
       'PRECOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Preo Compra',
       'Preo Compra',
       '',
       '(SELECT ICO.VLRMOV / CASE WHEN ICO.QTDMOV=0 THEN 1 ELSE ICO.QTDMOV END FROM TT_ICO ICO WHERE ICO.CODFIL = RMOV.FILICO AND ICO.SEQUEN = RMOV.SEQICO AND ICO.NUMITE = RMOV.NUMICO)',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '99',
       300,
       1,
       'PROMOC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Dia com promoo?',
       'Dia com promoo?',
       '',
       'PROMOC',
       '' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '02',
       80,
       12,
       'QTDCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtdade compra',
       'Quantidade (lanamento de compra)',
       '',
       'QTDCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '02',
       140,
       12,
       'QTDOUT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtdade outros',
       'Qtdade outros',
       '',
       'QTDOUT',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '02',
       145,
       12,
       'QTDOUT_CON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtd outros~Conv.',
       'Qtdade outros(Conv)',
       '',
       'QTDCONVERTIDA(RMOV.CODTAM,RMOV.QTDOUT)',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '02',
       150,
       12,
       'QTDVEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtdade vendas',
       'Qtdade vendas',
       '',
       'QTDVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '02',
       155,
       12,
       'QTDVEN_CON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtd vendas~Conv.',
       'Qtdade vendas(Conv)',
       '',
       'QTDCONVERTIDA(RMOV.CODTAM,RMOV.QTDVEN)',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '02',
       170,
       12,
       'SALANT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Saldo Anterior',
       'Saldo Anterior',
       '',
       'SALANT',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '02',
       230,
       16,
       'SAL_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Saldo Custo Mdio',
       'Saldo Custo Mdio',
       '',
       'SAL_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '04',
       282,
       10,
       'SEQFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Seq. Custo Frete',
       'Sequncia da ltima Compra com Custo de Frete',
       '',
       'SEQFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '04',
       272,
       10,
       'SEQICO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '.',
       'I',
       '',
       '',
       'N',
       'F',
       'Seq. Atual. Custo',
       'Sequncia da ltima Compra que Atualiza Custo',
       '. = RMOV.SEQICO',
       'SEQICO',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '01',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '05',
       290,
       8,
       'SaldoDaFilial',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo~Filial',
       'Saldo da Filial',
       '',
       'SaldoDaFilial(:RMOV.DATREFSAL,RMOV.FILMAT,RMOV.CODMAT,RMOV.CODCOR,RMOV.CODTAM,RMOV.CODFIL,RMOV.CODMUL)',
       '' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '02',
       160,
       12,
       'VENFIN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Movimentado',
       'Valor movimentado mas no vendido',
       '',
       'VENFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '02',
       130,
       14,
       'VENFIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtdade Movimentada',
       'Qtdade Movimentada mas no vendida',
       '',
       'VENFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '02',
       240,
       16,
       'VLRCMG',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vlr.C.MdioGerencial',
       'Vlr. Custo Mdio Gerencial',
       '',
       'VLRCMG',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '02',
       120,
       12,
       'VLRCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr Compra',
       'Valor (para lanamento de compra)',
       '',
       'VLRCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '02',
       100,
       12,
       'VLROUT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr Outros',
       'Valor (para outros lanamentos)',
       '',
       'VLROUT',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '02',
       110,
       12,
       'VLRVEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr Venda',
       'Valor (lanamento de venda)',
       '',
       'VLRVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'RMOV',
       '02',
       220,
       16,
       'VLR_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Comisso',
       'Valor Comisso',
       '',
       'VLR_CM',
       'F' FROM DUAL
);

/*-- SEQ 9241 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RMPG',
       TO_NUMBER(null),
       'RMPG',
       'Recebimentos/Meios',
       'TV_REC_MEIODEPAGAMENTO',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'RMPG.CODFIL,RMPG.SEQUEN,RMPG.NUMPAR,RMPG.SUBPAR',
       '' FROM DUAL
);

/*-- SEQ 9242 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RMPG','--','' FROM DUAL
UNION ALL
SELECT 'RMPG','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RMPG','02','Dados Gerais' FROM DUAL
UNION ALL
SELECT 'RMPG','03','Valores' FROM DUAL
UNION ALL
SELECT 'RMPG','99','Outros' FROM DUAL
);

/*-- SEQ 9243 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 25732,
       'CTM ',
       'RMPG',
       'N',
       '1',
       '',
       '',
       'CTM.CODFIL = RMPG.CODFIL AND
CTM.SEQUEN = RMPG.SEQUEN AND
CTM.NUMPAR = RMPG.NUMPAR AND
CTM.SUBPAR = RMPG.SUBPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 25733,
       'CTA ',
       'RMPG',
       'N',
       '01',
       '',
       '',
       'RMPG.FILCTA = CTA.CODFIL AND 
RMPG.SEQCTA = CTA.SEQUEN AND 
RMPG.TIPCTA = CTA.TIPCTA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 25734,
       'ITF ',
       'RMPG',
       '01',
       '1',
       '',
       '',
       'RMPG.FILITF = ITF.CODFIL AND
RMPG.SEQITF = ITF.SEQUEN AND
RMPG.ITEITF = ITF.NUMITE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 25730,
       'PLA ',
       'RMPG',
       '0N',
       '01',
       '',
       '',
       'PLA.FILPGT = RMPG.FILPGT(+) AND
PLA.CODPGT = RMPG.CODPGT(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 25731,
       'CHR ',
       'RMPG',
       '1',
       'N',
       '',
       '',
       'RMPG.CODFIL = CHR.CODFIL AND
RMPG.SEQCHE = CHR.SEQUEN
',
       '',
       '' FROM DUAL
);

/*-- SEQ 9244 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RMPG',
       '02',
       220,
       10,
       'APEPGT',
       'A',
       'PLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       '',
       '',
       'A',
       '',
       'Plano de Pagamento',
       'Plano de Pagamento',
       'RMPG.FILPGT=PLA.FILPGT(+)  AND RMPG.CODPGT=PLA.CODPGT(+)',
       'APEPGT',
       'T' FROM DUAL
UNION ALL
SELECT 'RMPG',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = RMPG.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'RMPG',
       '02',
       20,
       3,
       'CODPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Cdigo do Plano',
       'Cdigo do Plano de Pagamento',
       '',
       'CODPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'RMPG',
       '02',
       30,
       30,
       'DESCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Portador',
       'Descrio do Portador',
       '',
       'DESCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'RMPG',
       '02',
       40,
       3,
       'FILITF',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Item Carto',
       'Filial Item Carto',
       'DFIL.CODFIL(+) = RMPG.FILITF',
       'FILITF',
       'T' FROM DUAL
UNION ALL
SELECT 'RMPG',
       '02',
       50,
       3,
       'FILPGT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial do Plano',
       'Filial do Plano de Pagamento',
       'DFIL.CODFIL(+) = RMPG.FILPGT',
       'FILPGT',
       'T' FROM DUAL
UNION ALL
SELECT 'RMPG',
       '02',
       60,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'RMPG',
       '02',
       70,
       5,
       'ITEITF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Item Carto',
       'Item Carto',
       '',
       'ITEITF',
       'F' FROM DUAL
UNION ALL
SELECT 'RMPG',
       '02',
       80,
       250,
       'MEIODEPAGAMENTO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Meio',
       'Descrio Meio de Pagamento',
       '',
       'MEIODEPAGAMENTO',
       'F' FROM DUAL
UNION ALL
SELECT 'RMPG',
       '02',
       90,
       250,
       'MEIPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Meio de Pagamento',
       'Meio de Pagamento',
       '',
       'MEIPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'RMPG',
       '02',
       100,
       250,
       'MEIPOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Meio/Portador',
       'Meio de Pagamento/Portador',
       '',
       'MEIPOR',
       'F' FROM DUAL
UNION ALL
SELECT 'RMPG',
       '01',
       110,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero~Parcela',
       'Nmero da Parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'RMPG',
       '02',
       120,
       5,
       'PORTAD',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       '',
       'A',
       'F',
       'Portador',
       'Portador',
       'RMPG.PORTAD=DCOB.CODTAB (+)',
       'PORTAD',
       'T' FROM DUAL
UNION ALL
SELECT 'RMPG',
       '03',
       130,
       12,
       'REC_VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '',
       'Valor do pagamento',
       '',
       'REC_VLRPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'RMPG',
       '02',
       140,
       2,
       'RENEGO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Renegociao',
       'Renegociao',
       '',
       'RENEGO',
       'F' FROM DUAL
UNION ALL
SELECT 'RMPG',
       '02',
       150,
       10,
       'SEQITF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequen. Item Carto',
       'Sequen. Item Carto',
       '',
       'SEQITF',
       'F' FROM DUAL
UNION ALL
SELECT 'RMPG',
       '01',
       160,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'RMPG',
       '01',
       170,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Nmero da sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'RMPG',
       '03',
       180,
       12,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vlr. Desconto',
       'Vlr. Desconto',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'RMPG',
       '03',
       190,
       12,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vlr. Parcela',
       'Valor da parcela',
       '',
       'VLRPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'RMPG',
       '03',
       200,
       12,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vlr. Pago',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'RMPG',
       '03',
       210,
       14,
       'VLRTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vlr. Taxas',
       'Valor de Taxas',
       '',
       'VLRTAX',
       'F' FROM DUAL
);

/*-- SEQ 9245 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'RMPG',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RMPG',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RMPG',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RMPG',
       'FLGEST',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9246 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'ROM ',
       TO_NUMBER(null),
       'ROM ',
       'Romaneio de Carga',
       'TT_ROM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'ROM.CODFIL,ROM.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9247 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'ROM ','--','' FROM DUAL
UNION ALL
SELECT 'ROM ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'ROM ','02','Datas' FROM DUAL
UNION ALL
SELECT 'ROM ','03','Valores' FROM DUAL
UNION ALL
SELECT 'ROM ','99','Outros' FROM DUAL
);

/*-- SEQ 9248 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20644,
       'IRO ',
       'ROM ',
       'N',
       '01',
       '',
       '',
       'ROM.CODFIL = IRO.CODFIL AND ROM.SEQUEN = IRO.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20645,
       'VEI ',
       'ROM ',
       '1',
       '1',
       '',
       '',
       'VEI.PLACAS = ROM.PLACAS',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20646,
       'USU ',
       'ROM ',
       '1',
       '1',
       '',
       '',
       'ROM.FILUSU = USU.FILUSU AND
ROM.CODUSU = USU.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 9249 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'ROM ',
       '02',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ROM ',
       '01',
       190,
       40,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ROM ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Codigo da filial',
       'ROM.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ROM ',
       '01',
       160,
       6,
       'CODMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Motorista',
       'Cdigo do Motorista',
       '',
       'CODMOT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ROM ',
       '01',
       40,
       6,
       'CODTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Transportador',
       'Codigo da Transportadora',
       '',
       'CODTRA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ROM ',
       '01',
       50,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'ROM.FILUSU = USU.FILUSU(+)  AND ROM.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ROM ',
       '02',
       60,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Operao',
       'Data da Operao',
       '',
       'DATOPE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ROM ',
       '01',
       70,
       3,
       'FILMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Motivo',
       '',
       'FILMOT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ROM ',
       '01',
       80,
       3,
       'FILTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial da Transportadora',
       '',
       'FILTRA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ROM ',
       '01',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ROM ',
       '99',
       170,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Estado da separao',
       'Estado da separao',
       '',
       'FLGEST',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'ROM ',
       '99',
       200,
       12,
       'KM_FINAL',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'KM Final',
       'KM Final do Veculo',
       '',
       'KM_FINAL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ROM ',
       '99',
       190,
       12,
       'KM_INICIAL',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'KM Inicial',
       'KM Inicial do Veculo',
       '',
       'KM_INICIAL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'ROM ',
       '99',
       100,
       255,
       'OBSERV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ROM ',
       '01',
       110,
       7,
       'PLACAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Placa',
       'Placa veiculo',
       '',
       'PLACAS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ROM ',
       '99',
       120,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ROM ',
       '99',
       180,
       5,
       'SIGNAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Controle alterao',
       'Controle de alterao',
       '',
       'SIGNAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ROM ',
       '01',
       130,
       1,
       'TIPMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Motorista',
       'Indica se parceiro  motorista de uma transportadora',
       '',
       'TIPMOT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ROM ',
       '01',
       140,
       1,
       'TIPTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Tipo Transportadora',
       'Indica se o parceiro  transportadora',
       '',
       'TIPTRA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'ROM ',
       '03',
       150,
       14,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor do Frete',
       'Valor do Frete',
       '',
       'VLRFRE',
       'F',
       'D' FROM DUAL
);

/*-- SEQ 9250 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'ROM ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ROM ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ROM ',
       'FLGEST',
       0,
       'E',
       'NF Emitida / Enviado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'ROM ',
       'FLGEST',
       0,
       'F',
       'Fechado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9251 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RPP ',
       TO_NUMBER(null),
       'RPP ',
       'Receitas Produzidas',
       'TT_RPP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'RPP.CODFIL, RPP.CODRPP',
       '' FROM DUAL
);

/*-- SEQ 9252 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RPP ','--','' FROM DUAL
UNION ALL
SELECT 'RPP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RPP ','99','Outros' FROM DUAL
);

/*-- SEQ 9253 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21889,
       'IOR ',
       'RPP ',
       '01',
       '01',
       '',
       '',
       'IOR.CODFIL(+) = RPP.FILPED AND
IOR.TIPPED(+) = RPP.TIPPED AND
IOR.NUMPED(+) = RPP.NUMPED AND
IOR.ITEPED(+) = RPP.NUMITE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21890,
       'IVE ',
       'RPP ',
       '01',
       '01',
       '',
       '',
       'RPP.FILIVE = IVE.CODFIL(+) AND
RPP.SEQIVE = IVE.SEQUEN(+) AND
RPP.NUMIVE = IVE.NUMITE(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 9254 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RPP ',
       '01',
       10,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'RPP ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = RPP.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'RPP ',
       '01',
       30,
       10,
       'CODRPP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo',
       'Cdigo',
       '',
       'CODRPP',
       'F' FROM DUAL
UNION ALL
SELECT 'RPP ',
       '99',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       '9',
       'F',
       'Cod Usurio Registro',
       'Cdigo Usurio Registrou',
       'RPP.FILUSU = USU.FILUSU(+)  AND RPP.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'RPP ',
       '01',
       50,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'RPP ',
       '99',
       60,
       200,
       'DESRPP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Receita',
       'Descrio da Receita',
       '',
       'DESRPP',
       'F' FROM DUAL
UNION ALL
SELECT 'RPP ',
       '99',
       70,
       3,
       'FILIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '0',
       'F',
       'Filial Venda',
       'Filial Venda',
       '',
       'FILIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'RPP ',
       '99',
       80,
       3,
       'FILPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '0',
       'F',
       'Filial Pr-Venda',
       'Filial Pr-Venda',
       '',
       'FILPED',
       'F' FROM DUAL
UNION ALL
SELECT 'RPP ',
       '99',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '0',
       'F',
       'Fil Usurio Registro',
       'Filial Usurio Registrou',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'RPP ',
       '99',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'RPP ',
       '99',
       110,
       5,
       'ITEPED',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Item Pr-Venda',
       'Item Pr-Venda',
       '',
       'ITEPED',
       'F' FROM DUAL
UNION ALL
SELECT 'RPP ',
       '99',
       120,
       5,
       'NUMIVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Item Venda',
       'Item Venda',
       '',
       'NUMIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'RPP ',
       '99',
       130,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Nmero Pr-Venda',
       'Nmero Pr-Venda',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'RPP ',
       '99',
       140,
       1,
       'PROAUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Produo Automtica?',
       'Produo Automtica?',
       '',
       'PROAUT',
       'F' FROM DUAL
UNION ALL
SELECT 'RPP ',
       '99',
       150,
       10,
       'SEQIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador Venda',
       'Sequenciador Venda',
       '',
       'SEQIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'RPP ',
       '99',
       160,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Pr-Venda',
       'Tipo Pr-Venda',
       '',
       'TIPPED',
       'F' FROM DUAL
);

/*-- SEQ 9255 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RPS ',
       TO_NUMBER(null),
       'RPS ',
       'Rec. Provisrios Ser',
       'TT_RPS',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'RPS.CODFIL, RPS.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9256 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RPS ','--','' FROM DUAL
UNION ALL
SELECT 'RPS ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RPS ','99','Outros' FROM DUAL
);

/*-- SEQ 9257 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23055,
       'VEN ',
       'RPS ',
       '01',
       '01',
       '',
       '',
       'RPS.CODFIL(+) = VEN.CODFIL AND
RPS.SEQUEN(+) = VEN.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 9258 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RPS ',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'RPS ',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'RPS ',
       '--',
       30,
       8,
       'CODNFS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd Verificao NFEs',
       'Cdigo de Verificao da NFE-s',
       '',
       'CODNFS',
       'F' FROM DUAL
UNION ALL
SELECT 'RPS ',
       '--',
       40,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'RPS ',
       '--',
       50,
       7,
       'DATNFS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data/Hora Emiss NFEs',
       'Data e Hora da Emisso da NFE-s',
       '',
       'DATNFS',
       'F' FROM DUAL
UNION ALL
SELECT 'RPS ',
       '--',
       60,
       7,
       'DATRPS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Emisso RPS',
       'Data de Emisso do RPS',
       '',
       'DATRPS',
       'F' FROM DUAL
UNION ALL
SELECT 'RPS ',
       '--',
       70,
       15,
       'DOCRPS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'CPF/CNPJ Prestador',
       'CPF ou CNPJ do Prestador',
       '',
       'DOCRPS',
       'F' FROM DUAL
UNION ALL
SELECT 'RPS ',
       '--',
       80,
       15,
       'IM_RPS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Insc Mun Prestador',
       'Inscrio Municipal do Prestador',
       '',
       'IM_RPS',
       'F' FROM DUAL
UNION ALL
SELECT 'RPS ',
       '--',
       90,
       15,
       'NUMNFS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero da NFE-s',
       'Nmero da NFE-s',
       '',
       'NUMNFS',
       'F' FROM DUAL
UNION ALL
SELECT 'RPS ',
       '--',
       100,
       6,
       'NUMRPS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do RPS',
       'Nmero do RPS',
       '',
       'NUMRPS',
       'F' FROM DUAL
UNION ALL
SELECT 'RPS ',
       '--',
       110,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'RPS ',
       '--',
       120,
       3,
       'SERRPS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie do RPS',
       'Srie do RPS',
       '',
       'SERRPS',
       'F' FROM DUAL
UNION ALL
SELECT 'RPS ',
       '--',
       130,
       1,
       'SITNFS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao da NFE-s',
       'Situao da NFE-s',
       '',
       'SITNFS',
       'T' FROM DUAL
UNION ALL
SELECT 'RPS ',
       '--',
       140,
       1,
       'SITRPS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao do RPS',
       'Situao do RPS',
       '',
       'SITRPS',
       'T' FROM DUAL
UNION ALL
SELECT 'RPS ',
       '--',
       150,
       1,
       'TIPRPS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Tipo de RPS',
       'Tipo de RPS',
       '',
       'TIPRPS',
       'T' FROM DUAL
);

/*-- SEQ 9259 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'RPS ',
       'SITNFS',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RPS ',
       'SITNFS',
       0,
       'E',
       'Extraviado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RPS ',
       'SITNFS',
       0,
       'F',
       'Ope. isen/noTribu. Outro Mun.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RPS ',
       'SITNFS',
       0,
       'I',
       'Operao isenta/no tributvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RPS ',
       'SITNFS',
       0,
       'J',
       'ISS Suspenso por Deciso Judic',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RPS ',
       'SITNFS',
       0,
       'T',
       'Operao normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RPS ',
       'SITRPS',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RPS ',
       'SITRPS',
       0,
       'E',
       'Extraviado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RPS ',
       'SITRPS',
       0,
       'F',
       'Ope. isen/noTribu. Outro Mun.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RPS ',
       'SITRPS',
       0,
       'I',
       'Operao isenta/no tributvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RPS ',
       'SITRPS',
       0,
       'J',
       'ISS Suspenso por Deciso Judic',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RPS ',
       'SITRPS',
       0,
       'T',
       'Operao normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RPS ',
       'TIPRPS',
       0,
       ' ',
       'Recibo Provisrio de Servios ',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9260 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RSUG',
       TO_NUMBER(null),
       'RSUG',
       'Res. Sugesto Comp',
       'TR_SUG',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'RSUG.CODFIL, RSUG.FILMAT, RSUG.CODMAT, RSUG.CODCOR, RSUG.CODTAM, RSUG.ANO_MES',
       '' FROM DUAL
);

/*-- SEQ 9261 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RSUG','--','' FROM DUAL
UNION ALL
SELECT 'RSUG','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RSUG','02','Datas' FROM DUAL
UNION ALL
SELECT 'RSUG','03','Valores' FROM DUAL
UNION ALL
SELECT 'RSUG','99','Outros' FROM DUAL
);

/*-- SEQ 9262 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 26167,
       'GRA ',
       'RSUG',
       '1',
       'N',
       '',
       '',
       'GRA.FILMAT = RSUG.FILMAT AND
GRA.CODMAT = RSUG.CODMAT AND
GRA.CODCOR = RSUG.CODCOR AND
GRA.CODTAM = RSUG.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 9263 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RSUG',
       '01',
       60,
       7,
       'ANO_MES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Ano-Ms (AAAA-MM)',
       'Ano-Ms no Fomato (AAAA-MM)',
       '',
       'ANO_MES',
       '' FROM DUAL
UNION ALL
SELECT 'RSUG',
       '02',
       140,
       10,
       'ATU_EM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'RSUG',
       '01',
       40,
       5,
       'CODCOR',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Diviso',
       'Diviso',
       '',
       'CODCOR',
       '' FROM DUAL
UNION ALL
SELECT 'RSUG',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'V',
       '',
       '',
       'N',
       '',
       'Filial',
       'Filial',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'RSUG',
       '01',
       30,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo do Produto',
       'Cdigo do Produto',
       '',
       'CODMAT',
       '' FROM DUAL
UNION ALL
SELECT 'RSUG',
       '01',
       50,
       5,
       'CODTAM',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Subdiviso',
       'Subdiviso',
       '',
       'CODTAM',
       '' FROM DUAL
UNION ALL
SELECT 'RSUG',
       '02',
       130,
       10,
       'DATINC',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'RSUG',
       '01',
       20,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'V',
       '',
       '',
       'N',
       '',
       'Filial do Produto',
       'Filial do Produto',
       '',
       'FILMAT',
       '' FROM DUAL
UNION ALL
SELECT 'RSUG',
       '99',
       70,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'RSUG',
       '99',
       110,
       1,
       'GRAABC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'ABC na Previso',
       'Classificao ABC na poca da Previso',
       '',
       'GRAABC',
       '' FROM DUAL
UNION ALL
SELECT 'RSUG',
       '99',
       120,
       1,
       'GRAXYZ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'XYZ na Previso',
       'Classificao XYZ na poca da Previso',
       '',
       'GRAXYZ',
       '' FROM DUAL
UNION ALL
SELECT 'RSUG',
       '03',
       80,
       12,
       'QTDPRE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       '',
       'Previso de Vendas',
       'Previso de Vendas',
       '',
       'QTDPRE',
       '' FROM DUAL
UNION ALL
SELECT 'RSUG',
       '03',
       90,
       12,
       'QTDVEN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       '',
       'Vendas Realizadas',
       'Vendas Realizadas',
       '',
       'QTDVEN',
       '' FROM DUAL
UNION ALL
SELECT 'RSUG',
       '03',
       100,
       12,
       'TRASIG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Tracking Signal',
       'Tracking Signal',
       '',
       'TRASIG',
       'T' FROM DUAL
);

/*-- SEQ 9264 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'RSUG',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RSUG',
       'FLGEST',
       0,
       'F',
       'Fechado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9265 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RTB ',
       TO_NUMBER(null),
       'RTB ',
       'Arquivo TXT do Banco',
       'TT_RTB',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'RTB.CODFIL,RTB.SEQARQ,RTB.CODLOT,RTB.SEQREG',
       '' FROM DUAL
);

/*-- SEQ 9266 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RTB ','--','' FROM DUAL
UNION ALL
SELECT 'RTB ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RTB ','02','Data' FROM DUAL
UNION ALL
SELECT 'RTB ','03','Valor' FROM DUAL
UNION ALL
SELECT 'RTB ','99','Outros' FROM DUAL
);

/*-- SEQ 9267 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5863,
       'LTB ',
       'RTB ',
       '1 ',
       'N ',
       '',
       '',
       'LTB.CODFIL = RTB.CODFIL AND
LTB.SEQARQ = RTB.SEQARQ AND
LTB.CODLOT = RTB.CODLOT',
       '' FROM DUAL
);

/*-- SEQ 9268 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RTB ',
       '03',
       10,
       15,
       'ACRESC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Acrscimo',
       'Acrscimo',
       '',
       'ACRESC',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '01',
       20,
       5,
       'AGECOB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Agncia Cobradora',
       'Agencia Cobradora (Somente para retorno)',
       '',
       'AGECOB',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '01',
       30,
       3,
       'BCOCOB',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       '',
       'N',
       'F',
       'Banco de Cobrana',
       'Banco de Cobrana',
       'DCOB.CODTAB= RTB.BCOCOB',
       'BCOCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '01',
       40,
       3,
       'BCOCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Banco Cor',
       'Banco Cor',
       '',
       'BCOCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '01',
       50,
       1,
       'CARTEI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Carteira',
       'Carteira',
       '',
       'CARTEI',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '01',
       60,
       1,
       'CBANCO',
       'A',
       'DBCO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DBCO.NBANCO',
       'V',
       '',
       'F',
       'N',
       'F',
       'Cdigo do Banco',
       'Cdigo do Banco',
       'DBCO.CBANCO = RTB.CBANCO',
       'CBANCO',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '01',
       70,
       5,
       'CODAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Agncia',
       'Cdigo da agncia',
       '',
       'CODAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '99',
       80,
       2,
       'CODERR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Erros detectados',
       'Erros detectados',
       '',
       'CODERR',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '01',
       90,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = RTB.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '01',
       100,
       4,
       'CODLOT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo do Lote',
       'Cdigo do Lote',
       '',
       'CODLOT',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '01',
       110,
       2,
       'CODMOE',
       'S',
       'DMOE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       '',
       'F',
       'N',
       'F',
       'Moeda',
       'Moeda do plano',
       'RTB.CODMOE=DMOE.CODTAB (+)',
       'CODMOE',
       'T' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '01',
       120,
       2,
       'CODMOV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Movimentao',
       'Cdigo Movimentao',
       '',
       'CODMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '01',
       130,
       4,
       'CODO_S',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo da Ocorrncia',
       'Cdigo da Ocorrncia',
       '',
       'CODO_S',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '01',
       140,
       12,
       'COD_CC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Conta C.',
       'Cdigo Conta Corrente',
       '',
       'COD_CC',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '99',
       150,
       30,
       'COMO_S',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Complem. Ocorrncia',
       'Complemento da Ocorrncia',
       '',
       'COMO_S',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '02',
       160,
       7,
       'DATCRE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data do Crdito',
       'Data do Crdito',
       '',
       'DATCRE',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '02',
       170,
       7,
       'DATOCO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data do Retorno',
       'Data do Retorno',
       '',
       'DATOCO',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '02',
       180,
       8,
       'DATO_S',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data da Ocorrncia',
       'Data da Ocorrncia',
       '',
       'DATO_S',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '02',
       190,
       7,
       'DATVEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Venda',
       'Data da Venda',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '01',
       200,
       1,
       'DIGACC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dgito Agncia CC',
       'Dgito Agncia Conta Corrente',
       '',
       'DIGACC',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '01',
       210,
       2,
       'DIGAGE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dgito da Agncia',
       'Dgito da Agncia',
       '',
       'DIGAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '01',
       220,
       1,
       'DIGA_C',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dgito Agncia Conta',
       'Dgito Agncia Conta',
       '',
       'DIGA_C',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '01',
       230,
       1,
       'DIG_CC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dgito Conta C.',
       'Dgito Conta Corrente',
       '',
       'DIG_CC',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '01',
       240,
       15,
       'DOCCLI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Documento Cliente',
       'Documento do Cliente',
       '',
       'DOCCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '99',
       250,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '01',
       260,
       25,
       'IDEEMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificado Empresa',
       'Identificador da Empresa',
       '',
       'IDEEMP',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '99',
       270,
       10,
       'MOTOCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo do Retorno',
       'Motivo do Retorno',
       '',
       'MOTOCO',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '01',
       280,
       40,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Cliente',
       'Nome do Cliente',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '01',
       290,
       20,
       'NOSNUM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nosso Numero',
       'Nosso Numero',
       '',
       'NOSNUM',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '01',
       300,
       10,
       'NUMCON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero de Consultas',
       'Nmero de Consultas',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '99',
       310,
       20,
       'NUMCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero da Cor',
       'Nmero da Cor',
       '',
       'NUMCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '01',
       320,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Documento (CPF/CGC)',
       'Nmero do Documento: CGC ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '99',
       330,
       10,
       'SEQARQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Arquivo',
       '',
       'SEQARQ',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '99',
       340,
       5,
       'SEQREG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '',
       'Sequncia Registro',
       '',
       'SEQREG',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '99',
       350,
       1,
       'TIPDOC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tipo Documento',
       'Tipo Documento',
       '',
       'TIPDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '03',
       360,
       15,
       'VLRABT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor do Abatimento',
       'Valor do Abatimento',
       '',
       'VLRABT',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '03',
       370,
       15,
       'VLRCRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Creditado',
       'Valor Creditado',
       '',
       'VLRCRE',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '03',
       380,
       15,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor do Desconto',
       'Valor do Desconto',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '03',
       390,
       15,
       'VLRIOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Val. do IOF(Retorno)',
       'Valor do IOF (Somente para retorno)
Valor do IOF (Somente para retorno)',
       '',
       'VLRIOF',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '03',
       400,
       15,
       'VLRO_C',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Val. Outros Crditos',
       'Valor Outros Crditos',
       '',
       'VLRO_C',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '03',
       410,
       15,
       'VLRO_D',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Outras Despesa',
       'Valor Outras Despesas',
       '',
       'VLRO_D',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '03',
       420,
       15,
       'VLRO_S',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Ocorrncia',
       'Valor Ocorrncia',
       '',
       'VLRO_S',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '03',
       430,
       15,
       'VLRPAG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Pago',
       'Valor Pago',
       '',
       'VLRPAG',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '03',
       440,
       15,
       'VLRTAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor das Tarifas',
       'Valor das Tarifas',
       '',
       'VLRTAR',
       'F' FROM DUAL
UNION ALL
SELECT 'RTB ',
       '03',
       450,
       15,
       'VLRTIT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor do Ttulo',
       'Valor do Ttulo',
       '',
       'VLRTIT',
       'F' FROM DUAL
);

/*-- SEQ 9269 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'RTB ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RTB ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RTB ',
       'FLGEST',
       0,
       'I',
       'Inconsistente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RTB ',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RTB ',
       'FLGEST',
       0,
       'T',
       'Protestado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9270 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RTT ',
       TO_NUMBER(null),
       'RTT ',
       'Recebim Ttu Terceir',
       'TT_RTT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'RTT.CODFIL, RTT.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9271 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RTT ','--','' FROM DUAL
UNION ALL
SELECT 'RTT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RTT ','99','Outros' FROM DUAL
);

/*-- SEQ 9272 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 24168,
       'CTA ',
       'RTT ',
       '1',
       '0N',
       '',
       '',
       'RTT.FILCTA = CTA.CODFIL AND
RTT.SEQCTA = CTA.SEQUEN AND
RTT.TIPCTA = CTA.TIPCTA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 24169,
       'USU ',
       'RTT ',
       '1',
       '0N',
       '',
       '',
       'RTT.FILUSU = USU.FILUSU AND
RTT.CODUSU = USU.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 24449,
       'LID ',
       'RTT ',
       '01',
       '0N',
       '',
       '',
       'RTT.CODFIL (+) = LID.CODFIL AND
RTT.NUMECF (+) = LID.NUMECF AND
RTT.TRN_ID (+) = LID.TRN_ID',
       '',
       '' FROM DUAL
UNION ALL
SELECT 112922,
       'DRTT',
       'RTT ',
       '1',
       'N',
       '',
       '',
       'RTT.TIPRTT = DRTT.CODTAB',
       '',
       '' FROM DUAL
);

/*-- SEQ 9273 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RTT ',
       '--',
       10,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       20,
       10,
       'AUTORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero de Autoriza',
       'Nmero de Autorizao',
       '',
       'AUTORI',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       30,
       20,
       'CODAVU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd Avulso Nm Docum',
       'Cdigo Avulso (Nmero do Documento)',
       '',
       'CODAVU',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       40,
       48,
       'CODBAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo de Barras',
       'Cdigo de Barras ou Linha Digitvel',
       '',
       'CODBAR',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       50,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Banco',
       'Cdigo do Banco',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       60,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       70,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Usurio',
       'Cdigo do Usurio que Recebeu',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       280,
       3,
       'CODUSU_EST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cd. Usu. Estorno',
       'Cdigo do Usurio do Estorno',
       '',
       'CODUSU_EST',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       80,
       13,
       'CONTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Contrato',
       'Nmero do Contrato',
       '',
       'CONTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       90,
       6,
       'CUPFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm do Cupom Fiscal',
       'Nmero do Cupom Fiscal',
       '',
       'CUPFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       290,
       7,
       'DATEST',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATEST',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       100,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       110,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data e Hora da Trans',
       'Data e Hora da Transao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       120,
       8,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data do Pagamento',
       'Data do Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       130,
       8,
       'DATVEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data do Vencimento',
       'Data do Vencimento',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       300,
       3,
       'ECFEST',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       'F',
       'Nm. ECF do Estorno',
       'Nmero do ECF do Estorno',
       'DECF.FILECF = RTT.CODFIL(+) AND DECF.NUMECF = RTT.ECFEST(+)',
       'ECFEST',
       'T' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       150,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do Usurio ',
       'Filial do Usurio que Recebeu',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       310,
       3,
       'FILUSU_EST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Fil. Usu. do Estorno',
       'Filial do Usurio do Estorno',
       '',
       'FILUSU_EST',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       160,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Estado do Recebiment',
       'Estado do Recebimento',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       170,
       14,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       180,
       3,
       'NUMECF',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       'F',
       'Nmero ECF',
       'Nmero do ECF',
       'DECF.FILECF = RTT.CODFIL AND DECF.NUMECF = RTT.NUMECF',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       190,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero da Parcela',
       'Nmero da Parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       330,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(OBSERV)',
       '' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       210,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       230,
       5,
       'TIPRTT',
       'S',
       'DRTT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DRTT.DESRTT',
       'V',
       '',
       '',
       '9',
       'F',
       'Convnios de Recebim',
       'Convnios de Recebimentos de Ttulos de Terceiros',
       'RTT.TIPRTT = DRTT.CODTAB',
       'TIPRTT',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       320,
       12,
       'TRN_ID',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'ID Transao',
       'ID Transao',
       '',
       'TRN_ID',
       '' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       240,
       12,
       'VLRACR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor de Acrscimo',
       'Valor de Acrscimo',
       '',
       'VLRACR',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       250,
       12,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor de Desconto',
       'Valor de Desconto',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       260,
       12,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor da Parcela',
       'Valor da Parcela',
       '',
       'VLRPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'RTT ',
       '--',
       270,
       12,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor do Pagamento',
       'Valor do Pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9274 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'RTT ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RTT ',
       'FLGEST',
       0,
       'E',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RTT ',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'RTT ',
       'FLGEST',
       0,
       'S',
       'A Estornar',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9275 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RXF ',
       TO_NUMBER(null),
       'RXF ',
       'Filiais x Regras Com',
       'TT_RXF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'RXF.CODRGC,RXF.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 9276 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RXF ','--','' FROM DUAL
UNION ALL
SELECT 'RXF ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RXF ','99','Outros' FROM DUAL
);

/*-- SEQ 9277 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 34660,
       'DRGC',
       'RXF ',
       '1',
       'N',
       '',
       '',
       'DRGC.CODTAB = RXF.CODRGC',
       '',
       '' FROM DUAL
UNION ALL
SELECT 34661,
       'DFIL',
       'RXF ',
       '1',
       'N',
       '',
       '',
       'DFIL.CODFIL = RXF.CODFIL',
       '',
       '' FROM DUAL
);

/*-- SEQ 9278 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RXF ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL = RXF.CODFIL',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'RXF ',
       '01',
       10,
       5,
       'CODRGC',
       'S',
       'DRGC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DRGC.DESRGC',
       'V',
       '',
       '',
       'N',
       '',
       'Regra~Comerc.',
       'Regra para comercializao',
       'DRGC.CODTAB = RXF.CODRGC',
       'CODRGC',
       'T' FROM DUAL
UNION ALL
SELECT 'RXF ',
       '01',
       30,
       1,
       'RESERV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Reserva?',
       'Reserva?',
       '',
       'RESERV',
       '' FROM DUAL
);

/*-- SEQ 9279 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RXP ',
       TO_NUMBER(null),
       'RXP ',
       'Recepo de Pedidos',
       'TT_IRCXIPE',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'RXP.FILIRC, RXP.SEQIRC, RXP.ITEIRC, RXP.FILIPE, RXP.SEQIPE, RXP.ITEIPE',
       '' FROM DUAL
);

/*-- SEQ 9280 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RXP ','--','' FROM DUAL
UNION ALL
SELECT 'RXP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RXP ','99','Outros' FROM DUAL
);

/*-- SEQ 9281 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21895,
       'IRC ',
       'RXP ',
       '0N',
       '1',
       '',
       '',
       'RXP.FILIRC = IRC.CODFIL(+) AND
RXP.SEQIRC = IRC.SEQUEN(+) AND
RXP.ITEIRC = IRC.NUMITE(+) ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21896,
       'IPE ',
       'RXP ',
       '1',
       '01',
       '',
       '',
       'RXP.FILIPE = IRC.CODFIL AND
RXP.SEQIPE = IRC.NUMPED AND
RXP.ITEIPE = IRC.NUMITE ',
       '',
       '' FROM DUAL
);

/*-- SEQ 9282 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RXP ',
       '--',
       120,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data alterao',
       'Data alterao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'RXP ',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Cdigo filial',
       'Cdigo filial',
       'DFIL.CODFIL = RXP.CODFIL',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'RXP ',
       '--',
       110,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data incluso',
       'Data incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'RXP ',
       '--',
       60,
       3,
       'FILIPE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       '0',
       '',
       'Filial pedido',
       'Filial pedido',
       'DFIL.CODFIL = RXP.FILIPE',
       'FILIPE',
       '' FROM DUAL
UNION ALL
SELECT 'RXP ',
       '--',
       30,
       3,
       'FILIRC',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial recepo',
       'Filial recepo',
       'DFIL.CODFIL = RXP.FILICO',
       'FILIRC',
       '' FROM DUAL
UNION ALL
SELECT 'RXP ',
       '--',
       90,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       '' FROM DUAL
UNION ALL
SELECT 'RXP ',
       '--',
       80,
       5,
       'ITEIPE',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       '',
       '',
       'ITEIPE',
       '' FROM DUAL
UNION ALL
SELECT 'RXP ',
       '--',
       50,
       5,
       'ITEIRC',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       '',
       '',
       'ITEIRC',
       '' FROM DUAL
UNION ALL
SELECT 'RXP ',
       '--',
       100,
       14,
       'QTDENT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Quantidade recebida',
       'Quantidade recebida',
       '',
       'QTDENT',
       '' FROM DUAL
UNION ALL
SELECT 'RXP ',
       '--',
       70,
       10,
       'SEQIPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       '',
       '',
       '',
       'SEQIPE',
       '' FROM DUAL
UNION ALL
SELECT 'RXP ',
       '--',
       40,
       10,
       'SEQIRC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       '',
       '',
       '',
       'SEQIRC',
       '' FROM DUAL
UNION ALL
SELECT 'RXP ',
       '--',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       '',
       '',
       '',
       'SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9283 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RXR ',
       TO_NUMBER(null),
       'RXR ',
       'Vinculo Requisitos',
       'TT_REQXREQ',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9284 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RXR ','--','' FROM DUAL
UNION ALL
SELECT 'RXR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RXR ','99','Outros' FROM DUAL
);

/*-- SEQ 9285 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 11872,
       'REQ ',
       'RXR ',
       '1',
       'N',
       '',
       '',
       'REQ.CODFIL = RXR.FILREQ AND
REQ.SEQUEN = RXR.SEQREQ AND
REQ.CLAREQ = RXR.CLAREQ',
       '',
       '' FROM DUAL
);

/*-- SEQ 9286 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RXR ',
       '99',
       20,
       8,
       'ATU_EM ',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'RXR ',
       '01',
       5,
       1,
       'CLAREQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       '',
       'Class. do Requisitos',
       'Classificao do Requisito',
       '',
       'CLAREQ',
       '' FROM DUAL
UNION ALL
SELECT 'RXR ',
       '01',
       8,
       1,
       'CLAVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Classifi Req Vinc.',
       'Classificao do Requisito Vinculado',
       '',
       'CLAVIN',
       '' FROM DUAL
UNION ALL
SELECT 'RXR ',
       '01',
       1,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'RXR ',
       '99',
       10,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'RXR ',
       '01',
       3,
       3,
       'FILREQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Filial de Requisitos',
       'Cdigo da Filial Requisito',
       '',
       'FILREQ',
       '' FROM DUAL
UNION ALL
SELECT 'RXR ',
       '01',
       6,
       3,
       'FILVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       '',
       'Cdigo da Filial do Req. Vinculado',
       '',
       'FILVIN',
       '' FROM DUAL
UNION ALL
SELECT 'RXR ',
       '01',
       4,
       10,
       'SEQREQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq. Requisitos',
       'Sequenciador Requisito',
       '',
       'SEQREQ',
       '' FROM DUAL
UNION ALL
SELECT 'RXR ',
       '01',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'RXR ',
       '01',
       7,
       10,
       'SEQVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       '',
       'Sequenciador do Req Vinculado',
       '',
       'SEQVIN',
       '' FROM DUAL
UNION ALL
SELECT 'RXR ',
       '01',
       9,
       5,
       'VERSAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Verso vnc. aplica',
       'Verso que o vnculo se aplica',
       '',
       'VERSAO',
       '' FROM DUAL
);

/*-- SEQ 9287 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RXRV',
       TO_NUMBER(null),
       'RXRV',
       'Vinculo Requisitos R',
       'TT_REQXREQ',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9288 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RXRV','--','' FROM DUAL
UNION ALL
SELECT 'RXRV','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RXRV','99','Outros' FROM DUAL
);

/*-- SEQ 9289 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 11873,
       'REQ ',
       'RXRV',
       '1',
       'N',
       '',
       '',
       'REQ.CODFIL = RXRV.FILVIN AND
REQ.SEQUEN = RXRV.SEQVIN AND
REQ.CLAREQ = RXRV.CLAVIN',
       '',
       '' FROM DUAL
);

/*-- SEQ 9290 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RXRV',
       '99',
       20,
       8,
       'ATU_EM ',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'RXRV',
       '01',
       5,
       1,
       'CLAREQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       '',
       'Class. do Requisitos',
       'Classificao do Requisito',
       '',
       'CLAREQ',
       'F' FROM DUAL
UNION ALL
SELECT 'RXRV',
       '01',
       8,
       1,
       'CLAVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Classific Req. Vinc.',
       'Classificao do Requisito Vinculado',
       '',
       'CLAVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'RXRV',
       '01',
       1,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'RXRV',
       '99',
       10,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'RXRV',
       '01',
       3,
       3,
       'FILREQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Filial de Requisitos',
       'Cdigo da Filial Requisito',
       '',
       'FILREQ',
       'F' FROM DUAL
UNION ALL
SELECT 'RXRV',
       '01',
       6,
       3,
       'FILVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       '',
       'Cdigo da Filial do Req. Vinculado',
       '',
       'FILVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'RXRV',
       '01',
       4,
       10,
       'SEQREQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq. Requisitos',
       'Sequenciador Requisito',
       '',
       'SEQREQ',
       'F' FROM DUAL
UNION ALL
SELECT 'RXRV',
       '01',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'RXRV',
       '01',
       7,
       10,
       'SEQVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       '',
       'Sequenciador do Req Vinculado',
       '',
       'SEQVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'RXRV',
       '01',
       9,
       5,
       'VERSAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Verso vnc. aplica',
       'Verso que o vnculo se aplica',
       '',
       'VERSAO',
       'F' FROM DUAL
);

/*-- SEQ 9291 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RXW ',
       TO_NUMBER(null),
       'RXW ',
       'Vinculo  Requistos',
       'TT_REQXWOR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9292 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RXW ','--','' FROM DUAL
UNION ALL
SELECT 'RXW ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RXW ','99','Outros' FROM DUAL
);

/*-- SEQ 9293 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 16869,
       'REQ ',
       'RXW ',
       'N ',
       '1 ',
       '',
       '',
       'req.codfil = rxw.filreq and
req.sequen = rxw.seqreq and
req.clareq = rxw.clareq
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 16870,
       'WOR ',
       'RXW ',
       'N ',
       '1 ',
       '',
       '',
       'wor.codfil = rxw.filwor and
wor.sequen = rxw.seqwor',
       '',
       '' FROM DUAL
);

/*-- SEQ 9294 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RXW ',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'RXW ',
       '--',
       20,
       1,
       'CLAREQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Classificao do Req',
       'Classificao do Requisito',
       '',
       'CLAREQ',
       'F' FROM DUAL
UNION ALL
SELECT 'RXW ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'RXW ',
       '--',
       40,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'RXW ',
       '01',
       50,
       3,
       'FILREQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Cdigo da Filial Req',
       'Cdigo da Filial Requisito',
       '',
       'FILREQ',
       'F' FROM DUAL
UNION ALL
SELECT 'RXW ',
       '--',
       60,
       3,
       'FILWOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Tarefa de proposta',
       'Tarefa de proposta',
       '',
       'FILWOR',
       'F' FROM DUAL
UNION ALL
SELECT 'RXW ',
       '--',
       70,
       10,
       'SEQREQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Sequenciador Req',
       'Sequenciador Requisito',
       '',
       'SEQREQ',
       'F' FROM DUAL
UNION ALL
SELECT 'RXW ',
       '01',
       80,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'RXW ',
       '--',
       90,
       10,
       'SEQWOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Sequenciador Propost',
       'Sequenciador de Proposta',
       '',
       'SEQWOR',
       'F' FROM DUAL
);

/*-- SEQ 9295 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'RZR ',
       TO_NUMBER(null),
       'RZR ',
       'TT_RZR',
       'TT_RZR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9296 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'RZR ','--','' FROM DUAL
UNION ALL
SELECT 'RZR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'RZR ','99','Outros' FROM DUAL
);

/*-- SEQ 9297 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'RZR ',
       '--',
       10,
       5,
       'CODCAR',
       'S',
       'DCAR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCAR.DESOUT',
       'V',
       '',
       '',
       'A',
       'F',
       'Carto',
       'Carto',
       'DCAR.CODTAB = RZR.CODCAR(+)',
       'CODCAR',
       'T' FROM DUAL
UNION ALL
SELECT 'RZR ',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo~Cliente',
       'Cdigo~Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'RZR ',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = RZR.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'RZR ',
       '--',
       40,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'RZR ',
       '--',
       50,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'RZR ',
       '--',
       60,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data PGTO',
       'Data PGTO',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'RZR ',
       '--',
       70,
       7,
       'DATVEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Venda',
       'Data Venda',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'RZR ',
       '--',
       80,
       12,
       'DESACR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Desconto/Acrescimo',
       'Desconto/Acrescimo',
       '',
       'DESACR',
       'F' FROM DUAL
UNION ALL
SELECT 'RZR ',
       '--',
       90,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Cliente',
       '',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'RZR ',
       '--',
       100,
       6,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm. Nota',
       'Nm. Nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'RZR ',
       '--',
       110,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'RZR ',
       '--',
       120,
       12,
       'VLRLAN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Lanamento',
       'Valor Lanamento',
       '',
       'VLRLAN',
       'F' FROM DUAL
UNION ALL
SELECT 'RZR ',
       '--',
       130,
       14,
       'VLRSAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Saldo',
       'Valor Saldo',
       '',
       'VLRSAL',
       'F' FROM DUAL
);

/*-- SEQ 9298 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'SAD ',
       TO_NUMBER(null),
       'SAD ',
       'Servios Adicionais',
       'TT_SAD',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'SAD.CODFIL, SAD.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9299 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'SAD ','--','' FROM DUAL
UNION ALL
SELECT 'SAD ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'SAD ','99','Outros' FROM DUAL
);

/*-- SEQ 9300 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 24072,
       'GRA ',
       'SAD ',
       '1',
       '0N',
       '',
       '',
       'GRA.FILMAT = SAD.FILMAT AND
GRA.CODMAT = SAD.CODMAT AND
GRA.CODCOR = SAD.CODCOR AND
GRA.CODTAM = SAD.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 34975,
       'DSAD',
       'SAD ',
       'N',
       '1',
       '',
       '',
       'SAD.CODSAD = DSAD.CODTAB',
       '',
       '' FROM DUAL
);

/*-- SEQ 9301 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'SAD ',
       '01',
       10,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Atualizao',
       'Data da Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'SAD ',
       '99',
       20,
       5,
       'CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '0',
       'F',
       'Diviso',
       'Diviso',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'SAD ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'SAD ',
       '99',
       40,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Cdigo do Produto',
       'Cdigo do Produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'SAD ',
       '99',
       50,
       5,
       'CODSAD',
       'S',
       'DSAD',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSAD.DESSAD',
       'V',
       '',
       '',
       'A',
       'F',
       'Tipo Serv Adicional',
       'Tipo de Servio Adicional',
       'DSAD.CODTAB = SAD.CODSAD',
       'CODSAD',
       'F' FROM DUAL
UNION ALL
SELECT 'SAD ',
       '99',
       120,
       25,
       'CODSEG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo na Seguradora',
       'Cdigo na Seguradora',
       '',
       'CODSEG',
       'F' FROM DUAL
UNION ALL
SELECT 'SAD ',
       '99',
       60,
       5,
       'CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Subdiviso',
       'Subdiviso',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'SAD ',
       '01',
       70,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Incluso',
       'Data da Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'SAD ',
       '99',
       80,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial do Produto',
       'Filial do Produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'SAD ',
       '99',
       90,
       5,
       'PERSAD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '% sobre Preo Produt',
       '% sobre Preo do Produto',
       '',
       'PERSAD',
       'F' FROM DUAL
UNION ALL
SELECT 'SAD ',
       '01',
       100,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'SAD ',
       '99',
       130,
       5,
       'SIGNAT',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '#Ativo?',
       'Ativo? (descontinuado)',
       '',
       'SIGNAT',
       '' FROM DUAL
UNION ALL
SELECT 'SAD ',
       '99',
       131,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN SAD.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'SAD ',
       '99',
       110,
       12,
       'VALSAD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Valor do Servio ',
       'Valor do Servio (em R$)',
       '',
       'VALSAD',
       'F' FROM DUAL
);

/*-- SEQ 9302 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'SADC',
       TO_NUMBER(null),
       'SADC',
       'Frmula Canc Servio',
       'TD_SAD_CAN',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'SADC.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 9303 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'SADC','--','' FROM DUAL
UNION ALL
SELECT 'SADC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'SADC','99','Outros' FROM DUAL
);

/*-- SEQ 9304 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'SADC',
       '01',
       10,
       5,
       'CODTAB',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo Servio',
       'Cdigo do Servio Adicional',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'SADC',
       '01',
       20,
       4000,
       'FORCAN',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Frmula cancelamento',
       'Frmula para impresso de cancelamento',
       '',
       'RTF2TXT(FORCAN)',
       '' FROM DUAL
);

/*-- SEQ 9305 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'SAL ',
       0,
       'SAL ',
       'Saldos de Estoque',
       'TT_SAL',
       'T',
       '',
       'TOTALL',
       'Saldos de estoque',
       '{FILMAT;CODMAT;CODCOR;CODTAM;CODFIL}',
       '',
       '',
       'ProdutoSaldos',
       'T',
       '',
       'SAL.CODFIL,SAL.SEQUEN
GRA.ID',
       '' FROM DUAL
);

/*-- SEQ 9306 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'SAL ','--','' FROM DUAL
UNION ALL
SELECT 'SAL ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'SAL ','02','Sugesto de Compra' FROM DUAL
UNION ALL
SELECT 'SAL ','03','Saldo da Filial' FROM DUAL
UNION ALL
SELECT 'SAL ','04','Total de Vendas' FROM DUAL
UNION ALL
SELECT 'SAL ','05','Valor Vendido na filial' FROM DUAL
UNION ALL
SELECT 'SAL ','06','Datas' FROM DUAL
UNION ALL
SELECT 'SAL ','07','Total De Devoluo' FROM DUAL
UNION ALL
SELECT 'SAL ','08','Data de Reposio' FROM DUAL
UNION ALL
SELECT 'SAL ','09','Quantidade Convertida' FROM DUAL
UNION ALL
SELECT 'SAL ','10','Valores' FROM DUAL
UNION ALL
SELECT 'SAL ','11','Custo Financeiro FiscalTotal' FROM DUAL
UNION ALL
SELECT 'SAL ','12','Custo Mdio Fiscal' FROM DUAL
UNION ALL
SELECT 'SAL ','13','Dias Sem Estoque' FROM DUAL
UNION ALL
SELECT 'SAL ','14','Dias Com Estoque' FROM DUAL
UNION ALL
SELECT 'SAL ','15','Parmetros Dias Estoque Negativo' FROM DUAL
UNION ALL
SELECT 'SAL ','16','Giro de Estoque' FROM DUAL
UNION ALL
SELECT 'SAL ','17','Saldo no Periodo' FROM DUAL
UNION ALL
SELECT 'SAL ','18','Custo Financeiro Gerencial Total' FROM DUAL
UNION ALL
SELECT 'SAL ','19','Quantidade Fiscal' FROM DUAL
UNION ALL
SELECT 'SAL ','20','Custo Mdio Gerencial' FROM DUAL
UNION ALL
SELECT 'SAL ','21','Saldo Ativo' FROM DUAL
UNION ALL
SELECT 'SAL ','22','Saldo em Transito' FROM DUAL
UNION ALL
SELECT 'SAL ','23','Notas Pendentes' FROM DUAL
UNION ALL
SELECT 'SAL ','24','Mdia Vendas Produtos' FROM DUAL
UNION ALL
SELECT 'SAL ','25','Ultima compra' FROM DUAL
UNION ALL
SELECT 'SAL ','26','Pedido Pendente' FROM DUAL
UNION ALL
SELECT 'SAL ','27','Pedido Pendente por Tipo' FROM DUAL
UNION ALL
SELECT 'SAL ','28','Produo de Estoque' FROM DUAL
);

/*-- SEQ 9307 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 119947,
       'IVE ',
       'SAL ',
       '1',
       'N',
       '',
       '',
       'SAL.FILMAT = IVE.FILMAT AND
SAL.CODMAT = IVE.CODMAT AND
SAL.CODCOR = IVE.CODCOR AND
SAL.CODTAM = IVE.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 119948,
       'GRA ',
       'SAL ',
       '1',
       'N',
       '',
       '',
       'SAL.FILMAT = GRA.FILMAT AND
SAL.CODMAT = GRA.CODMAT AND
SAL.CODCOR = GRA.CODCOR AND
SAL.CODTAM = GRA.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 119949,
       'VIPR',
       'SAL ',
       '1',
       '1',
       '',
       '',
       'SAL.FILMAT = VIPR.FILMAT AND
SAL.CODMAT = VIPR.CODMAT AND
SAL.CODCOR = VIPR.CODCOR AND
SAL.CODTAM = VIPR.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 119950,
       'DFIL',
       'SAL ',
       '1',
       'N',
       '',
       '',
       'DFIL.CODFIL = SAL.CODFIL',
       '',
       '' FROM DUAL
UNION ALL
SELECT 119951,
       'PXF ',
       'SAL ',
       'N',
       '1',
       '',
       '',
       'PXF.FILMAT = SAL.FILMAT AND
PXF.CODMAT = SAL.CODMAT AND
PXF.CODCOR = SAL.CODCOR AND
PXF.CODTAM = SAL.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 119952,
       'IPRF',
       'SAL ',
       '1',
       '1',
       '',
       '',
       'SAL.FILMAT = IPRF.FILMAT AND
SAL.CODMAT = IPRF.CODMAT AND
SAL.CODCOR = IPRF.CODCOR AND
SAL.CODTAM = IPRF.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 9308 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'SAL ',
       '27',
       910,
       1,
       ':P_TIPO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo Pedido Pendente',
       'Tipo Pedido Pendente',
       '',
       ':P_TIPO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '14',
       320,
       8,
       ':SAL.COM_DATINI,SAL.COM_DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Perodo c/ Estoque',
       'Datas com Estoque',
       '',
       ':SAL.COM_DATINI,SAL.COM_DATFIM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '02',
       110,
       8,
       ':SAL.DAT01,SAL.DAT02',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Perodo',
       'Perodo',
       '',
       ':SAL.DAT01,SAL.DAT02',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '11',
       260,
       8,
       ':SAL.DATACMT',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Custo',
       'Data do Custo Financeiro Fiscal Total (Custo Mdio Fiscal x Qtde Fiscal)',
       '',
       ':SAL.DATACMT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '12',
       280,
       8,
       ':SAL.DATACMU',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Custo',
       'Data do Custo Mdio Fiscal Unitrio',
       '',
       ':SAL.DATACMU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '21',
       244,
       8,
       ':SAL.DATASALDOATIVO',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data~Saldo Ativo',
       'Data Saldo Ativo',
       '',
       ':SAL.DATASALDOATIVO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '02',
       120,
       8,
       ':SAL.DATATE',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Manter Estoque At',
       'Manter estoque at',
       '',
       ':SAL.DATATE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '18',
       410,
       8,
       ':SAL.DATA_CFGT',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Custo',
       'Data do Custo Finaceiro Gerencial Total',
       '',
       ':SAL.DATA_CFGT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '19',
       420,
       8,
       ':SAL.DATA_QTD_FISCAL',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Qtd Fiscal',
       'Data de referncia da Quantidade Fiscal',
       '',
       ':SAL.DATA_QTD_FISCAL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '07',
       940,
       8,
       ':SAL.DATFIMTTD',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'D',
       '',
       'Data Final',
       'Data Final',
       '',
       ':SAL.DATFIMTTD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '16',
       360,
       8,
       ':SAL.DATINI,SAL.DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       '',
       'Perodo do Giro',
       'Data',
       '',
       ':SAL.DATINI,SAL.DATFIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '07',
       930,
       8,
       ':SAL.DATINITTD',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '@',
       '',
       'Data Inicial',
       'Data Inicial',
       '',
       ':SAL.DATINITTD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '04',
       160,
       8,
       ':SAL.DATINITTV,SAL.DATFIMTTV',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Perodo',
       'Perodo',
       '',
       ':SAL.DATINITTV,SAL.DATFIMTTV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '08',
       200,
       8,
       ':SAL.DATREFCRD',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Referncia',
       'Data de Referncia',
       '',
       ':SAL.DATREFCRD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '23',
       500,
       8,
       ':SAL.DATREFNOT',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data~Referncia',
       'Data Referncia',
       '',
       ':SAL.DATREFNOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '22',
       249,
       8,
       ':SAL.DATREFSAL',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data~Referncia',
       'Data Referncia',
       '',
       ':SAL.DATREFSAL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '03',
       140,
       8,
       ':SAL.DATREFSDF',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data',
       'Data',
       '',
       ':SAL.DATREFSDF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '24',
       540,
       8,
       ':SAL.MEDIA_DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Final',
       'Data final do Perodo',
       '',
       ':SAL.MEDIA_DATFIM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '24',
       530,
       8,
       ':SAL.MEDIA_DATINI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Inicial',
       'Data Inicial do Perodo',
       '',
       ':SAL.MEDIA_DATINI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '24',
       550,
       1,
       ':SAL.MEDIA_PERIOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Periodicidade',
       'Periodicidade da Mdia',
       '',
       ':SAL.MEDIA_PERIOD',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '15',
       340,
       8,
       ':SAL.NEG_DATINI,SAL.NEG_DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Perodo Estoq.Negat.',
       'Datas Estoque Neg.',
       '',
       ':SAL.NEG_DATINI,SAL.NEG_DATFIM
',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '17',
       400,
       8,
       ':SAL.PER_DATINI,SAL.PER_DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Perodo',
       'Periodo',
       '',
       ':SAL.PER_DATINI,SAL.PER_DATFIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '13',
       300,
       8,
       ':SAL.SEM_DATINI,SAL.SEM_DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Perodo s/ Estoque',
       'Data sem Estoque',
       '',
       ':SAL.SEM_DATINI,SAL.SEM_DATFIM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '16',
       351,
       1,
       ':SAL.TIPODIA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo Dia',
       'Tipo de Dia no Giro',
       '',
       ':SAL.TIPODIA',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '16',
       352,
       1,
       ':SAL.TIPOGIRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo Giro',
       'Tipo de Giro',
       '',
       ':SAL.TIPOGIRO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '02',
       100,
       1,
       ':SAL.TIPPRJ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'N',
       'F',
       'Tipo de Projeo',
       'Tipo de Projeo',
       '',
       ':SAL.TIPPRJ',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '05',
       30,
       8,
       ':SAL.VLRVENDATINI,SAL.VLRVENDA',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Periodo',
       'Periodo',
       '',
       ':SAL.VLRVENDATINI,SAL.VLRVENDATFIM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '--',
       710,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       'Assinatura para PAF-ECF',
       '',
       'ASSINA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '06',
       430,
       1,
       'ATU_CM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Atualiza Custo Mdio',
       'Atualiza Custo Mdio?',
       '',
       'ATU_CM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '06',
       11,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Data da ltima atualizao',
       '',
       'ATU_EM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '06',
       180,
       7,
       'CAL_CM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Clculo Custo M',
       'Data Cculo Custo Mdio',
       '',
       'CAL_CM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '01',
       30,
       2,
       'CODCOR',
       'S',
       'DIV ',
       0,
       0,
       'SAL ',
       30,
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       'SAL',
       'F',
       'N',
       'F',
       'Diviso do Produto',
       'Diviso do Produto',
       'SAL.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '01',
       50,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       0,
       'SAL ',
       50,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'SAL',
       'F',
       'A',
       'T',
       'Filial',
       'Cdigo da filial',
       'SAL.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '01',
       20,
       5,
       'CODMAT',
       'A',
       '',
       0,
       0,
       'SAL ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'SAL',
       'F',
       '9',
       'F',
       '',
       'Cdigo do material',
       '',
       'CODMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '01',
       170,
       5,
       'CODMUL',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       '9',
       'F',
       'Sub-Estoque',
       'Nome do Sub-Estoque',
       'DMUL.CODTAB = SAL.CODMUL',
       'CODMUL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '01',
       40,
       2,
       'CODTAM',
       'S',
       'SUB ',
       0,
       0,
       'SAL ',
       40,
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       'SAL',
       'F',
       'N',
       'F',
       'Sub-Diviso Produto',
       'Sub-Diviso do produto',
       'SAL.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '--',
       720,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Identificao de Acesso',
       '',
       'CODUID',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '11',
       250,
       12,
       'CUSTOMEDIO_TOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Custo Financ. Fiscal',
       'Custo Financeiro Fiscal Total (Custo Mdio Fiscal x Qtde Fiscal)',
       '',
       'COALESCE(trunc(CUSTOMEDIO(SAL.CODFIL,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,2,:SAL.DATACMT),2),0)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '12',
       270,
       12,
       'CUSTOMEDIO_UNI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       '',
       'Custo Mdio Fiscal',
       'Custo Mdio Fiscal Unitrio',
       '',
       'COALESCE(trunc(CUSTOMEDIO(SAL.CODFIL,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,3,:SAL.DATACMU),4),0)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '08',
       190,
       12,
       'CUSTOREPOSICAODATA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Custo Reposio/Data',
       'Gera Custo de Reposio a partir de Data Informada. Retorna Saldo.',
       '',
       'CUSTOREPOSICAODATA(:SAL.DATREFCRD,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,SAL.CODFIL,SAL.CODMUL)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '18',
       400,
       12,
       'CUSTO_FGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Custo Financ. Geren.',
       'Custo Financeiro Gerencial Total (Custo Mdio Gerencial x Qtde Fiscal)',
       '',
       'COALESCE(trunc(CUSTOMEDIO(SAL.CODFIL,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,4,:SAL.DATACMT),2),0)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '18',
       401,
       12,
       'CUSTO_FGT_UNI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Custo Mdio Gerenc.',
       'Custo Mdio Gerencial Unitrio',
       '',
       'COALESCE(trunc(CUSTOMEDIO(SAL.CODFIL,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,5,:SAL.DATA_CFGT),4),0)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '25',
       730,
       7,
       'DATCMP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data ultima compra',
       'Data ultima compra',
       '',
       'DATCMP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '25',
       740,
       14,
       'DESCMP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Desc. ultima compra',
       'Desc. ultima compra',
       '',
       'DESCMP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '14',
       310,
       12,
       'DIASDEESTOQUE_COM_ESTOQUE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Dias com Estoque',
       'Dias com Estoque',
       '',
       'DIASDEESTOQUE(''C'', :SAL.COM_DATINI, :SAL.COM_DATFIM, SAL.FILMAT,SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, SAL.CODFIL, 0)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '15',
       330,
       12,
       'DIASDEESTOQUE_NEGATIVO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Dias Estoq. Negativo',
       'Dias Estoque Negativo',
       '',
       'DIASDEESTOQUE(''-'', :SAL.NEG_DATINI, :SAL.NEG_DATFIM, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, SAL.CODFIL, 0)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '13',
       290,
       12,
       'DIASDEESTOQUE_SEM_ESTOQUE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Dias Sem Estoque',
       'Dias Sem Estoque',
       '',
       'DIASDEESTOQUE(''S'', :SAL.SEM_DATINI, :SAL.SEM_DATFIM, SAL.FILMAT,SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, SAL.CODFIL, 0)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '--',
       860,
       12,
       'DIASSEMVENDAS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       '',
       'Dias Sem Venda',
       'Dias Sem Venda',
       '',
       'DIASSEMVENDA(SAL.CODFIL, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, SAL.CODMUL)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '03',
       850,
       1,
       'DISMINZER',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Dist. Qtd.Mn. Zero?',
       'Distribuio quando quantidade mnima Zero',
       '',
       'DISMINZER',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '01',
       12,
       1,
       'DUMMY',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       '',
       'Controle interno',
       '',
       'DUMMY',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '10',
       440,
       14,
       'EST_CM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Saldo Custo Mdio',
       'Saldo Custo Mdio',
       '',
       'EST_CM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '01',
       630,
       1,
       'FAZCMP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Permite Com. Filial',
       'Permite Fazer Compra na Filial',
       '',
       'FAZCMP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '01',
       10,
       3,
       'FILMAT',
       'A',
       '',
       0,
       0,
       'SAL ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'SAL',
       'F',
       'N',
       'F',
       '',
       'Filial do material',
       '',
       'FILMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '01',
       870,
       1,
       'FLGATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Ativo na Filial?',
       '',
       'FLGATI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '25',
       750,
       16,
       'FRECMP',
       'F',
       '',
       6,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Frete ultima compra',
       'Frete ultima compra',
       '',
       'FRECMP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '16',
       350,
       12,
       'GiroEstoque',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       '',
       'Giro de Estoque',
       'Giro de Estoque',
       '',
       'GiroEstoque(:SAL.DATINI,:SAL.DATFIM,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,SAL.CODFIL, :SAL.TIPODIA, ''T'', :SAL.TIPOGIRO)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '25',
       760,
       14,
       'ICMCMP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'ICMS ultima compra',
       'ICMS ultima compra',
       '',
       'ICMCMP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '01',
       210,
       7,
       'INI_CM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ini.Custo Mdio',
       'Data Ini.Custo Mdio',
       '',
       'INI_CM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '04',
       880,
       5,
       'INTERVALOTOTALVENDA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Intervalo',
       'Intervalo Total Venda',
       '',
       'INTERVALODIAS(:SAL.DATFIMTTV,:SAL.DATINITTV)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '25',
       770,
       14,
       'IPICMP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'IPI ultima compra',
       'IPI ultima compra',
       '',
       'IPICMP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '25',
       780,
       5,
       'ITECMP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'N item ult. compra',
       'N item ult. compra',
       '',
       'ITECMP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '10',
       470,
       10,
       'LOCAL1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Localizao I',
       'Localizao I',
       '',
       'LOCAL1',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '10',
       480,
       10,
       'LOCAL2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Localizao II',
       'Localizao II',
       '',
       'LOCAL2',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '10',
       490,
       10,
       'LOCAL3',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Localizao III',
       'Localizao III',
       '',
       'LOCAL3',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '24',
       520,
       12,
       'MEDIA_VENDAS_PRODUTO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       '',
       'Mdia Vend. Produtos',
       'Quantidade Mdia de Vendas do Produto',
       '',
       'MEDIA_VENDAS_PRODUTO (SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,SAL.CODFIL,SAL.CODMUL,:SAL.MEDIA_DATINI,:SAL.MEDIA_DATFIM,:SAL.MEDIA_PERIOD)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '01',
       700,
       254,
       'MOT_CM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Custo mdio inicial',
       'Motivo para custo mdio inicial',
       '',
       'MOT_CM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '--',
       620,
       1,
       'MOVEST',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Movimentar estoque ?',
       'Movimentar estoque ?',
       '',
       'MOVEST',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '25',
       970,
       50,
       'NOMULTFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Fornec. ltima Com',
       'Nome do ltimo Fornecedor',
       '',
       'SELECT (CASE WHEN FLGTIP=0 THEN (NOMCLI||'' ''||COALESCE(ULTNOM,'''')) ELSE NOMCLI END) FROM TT_CLI CLI WHERE (FILCLI, CODCLI) IN (SELECT FILFOR, CODFOR FROM TT_COM WHERE CODFIL = SAL.CODFIL AND SEQUEN = SAL.SEQCMP)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '26',
       370,
       12,
       'PEDIDOPENDENTE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Pedidos Pendentes',
       'Traz a quantidade pendente de pedidos nao recebidos',
       '',
       'PEDIDOPENDENTE(SAL.CODFIL,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '27',
       900,
       12,
       'PEDPENDENTETIPO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Pedido Pend por Tipo',
       'Quantidade pendente de pedidos por Tipo',
       '',
       'PEDIDOPENDENTE(SAL.CODFIL,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM, :P_TIPO)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '25',
       790,
       14,
       'PRECMP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Preo ultima compra',
       'Preo ultima compra',
       '',
       'PRECMP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '01',
       13,
       13,
       'PTOPED',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Ponto de pedido',
       'Ponto de pedido',
       '',
       'PTOPED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '01',
       800,
       12,
       'QTDCMP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Qtd. ultima compra',
       'Qtd. ultima compra',
       '',
       'QTDCMP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '01',
       60,
       12,
       'QTDEST',
       'F',
       '',
       4,
       0,
       'SAL ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'SAL',
       'T',
       'N',
       'T',
       'Qtd.Estoque',
       'Quantidade em estoque',
       '',
       'QTDEST',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '01',
       65,
       8,
       'QTDEST_CON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtd.Estoque~Conv.',
       'Quantidade em estoque Convertida',
       '',
       'QTDCONVERTIDA(SAL.CODTAM,SAL.QTDEST)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '10',
       840,
       13,
       'QTDMAX',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Estoque de Gndola',
       'Estoque de Gndola',
       '',
       'QTDMAX',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '01',
       14,
       13,
       'QTDMIN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade mnima',
       'Quantidade mnima',
       '',
       'QTDMIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '01',
       15,
       13,
       'QTDMIN_CON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtd Mn~Conv.',
       'Quantidade mnima Convertida',
       '',
       'QTDCONVERTIDA(SAL.CODTAM,SAL.QTDMIN)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '01',
       130,
       12,
       'QTDREP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Ideal de Reposio',
       'Quantidade ideal de reposiao',
       '',
       'QTDREP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '10',
       135,
       12,
       'QTDREP_CON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde Reposio Conv.',
       'Quantidade Reposio Convertida',
       '',
       'QTDCONVERTIDA(SAL.CODTAM,SAL.QTDREP)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '10',
       220,
       14,
       'QTD_CM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde Ini. Custo M.',
       'Quantidade Inicial do Custo Mdio',
       '',
       'QTD_CM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '19',
       410,
       12,
       'QTD_FISCAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Qtd. Fiscal',
       'Quantidade Fiscal (no considera lanamentos avulsos no estoque)',
       '',
       'COALESCE(CUSTOMEDIO(SAL.CODFIL,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,1,:SAL.DATA_QTD_FISCAL),0)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '25',
       810,
       14,
       'REPCMP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Custo rep. ult. comp',
       'Custo rep. ult. comp',
       '',
       'REPCMP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '01',
       70,
       12,
       'RESERV',
       'F',
       '',
       4,
       0,
       'SAL ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'SAL',
       'T',
       'N',
       'T',
       'Qtd.Reserva',
       'Quantidade de reserva',
       '',
       'RESERV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '21',
       243,
       1,
       'SALDOATIVO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       '',
       'Saldo~Ativo',
       'Produto com saldo ativo no dia para a filial',
       '',
       'SALDOATIVO(SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,SAL.CODMUL,SAL.CODFIL,:SAL.DATASALDOATIVO)',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '22',
       245,
       12,
       'SALDOEMTRANSITO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo em Transito',
       'Saldo em Transito',
       '',
       'SALDOEMTRANSITO(SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,SAL.CODMUL,SAL.CODFIL,:SAL.DATREFSAL)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '17',
       390,
       12,
       'SALDOPERIODO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo no Perodo',
       'Saldo no Periodo',
       '',
       'SALDOPERIODO(SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,:SAL.PER_DATINI,:SAL.PER_DATFIM)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '23',
       248,
       16,
       'SALDOVINCULO',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Notas~Pendentes',
       'Quantidade em notas emitidas para vinculo futuro pendente',
       '',
       'SALDOVINCULOFUTURO(SAL.CODFIL,NULL,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,SAL.CODMUL,:SAL.DATREFSAL)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '--',
       820,
       10,
       'SEQCMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Cdigo ultima compra',
       'Cdigo ultima compra',
       '',
       'SEQCMP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '01',
       80,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'SAL ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '03',
       130,
       8,
       'SaldoDaFilial',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Saldo~Filial',
       'Saldo da Filial',
       '',
       'SaldoDaFilial(:SAL.DATREFSDF,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,SAL.CODFIL,SAL.CODMUL)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '02',
       90,
       12,
       'SugestaoCompra',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Sugesto~de compra',
       'Sugesto de Compra',
       '',
       'SugestaoCompra(:SAL.TIPPRJ,:SAL.DAT01,:SAL.DAT02,:SAL.DATATE,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,SAL.CODFIL)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '25',
       830,
       14,
       'TAXCMP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Taxa ultima compra',
       'Taxa ultima compra',
       '',
       'TAXCMP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '10',
       450,
       14,
       'TOTCMG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Vlr.Total C.M.Gerenc',
       'Valor total de custo mdio gerencial',
       '',
       'TOTCMG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '10',
       460,
       14,
       'TOT_CM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr.Total C.M.Fiscal',
       'Valor total de custo mdio fiscal ',
       '',
       'TOT_CM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '07',
       920,
       18,
       'TotalDevolucao',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Total de~Devoluo',
       'Total Quantidade Devolvida',
       '',
       'TotalDevolvida(:SAL.DATINITTD,:SAL.DATFIMTTD, SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,SAL.CODFIL,SAL.CODMUL)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '04',
       150,
       8,
       'TotalVenda',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Total de~Vendas',
       'Total de  venda',
       '',
       'TotalVenda(:SAL.DATINITTV,:SAL.DATFIMTTV,SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,SAL.CODFIL,SAL.CODMUL)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '28',
       950,
       7,
       'ULTPPR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'lt. Data Produzida',
       'ltima Data Produzida na Produo Prpria',
       '',
       'UltimaDataProduzida(SAL.CODFIL, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '28',
       960,
       12,
       'ULTQTDPPR',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'lt. Qtd. Produzida',
       'ltima Quantidade Produzida na Produo Prpria',
       '',
       'UltimaQuantidadeProduzida(SAL.CODFIL, SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '05',
       10,
       12,
       'VALORVENDIDOFILIAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Vendido Filial',
       'Valor Vendido na filial',
       '',
       'VALORVENDAPRODUTO(:SAL.VLRVENDATINI,:SAL.VLRVENDATFIM,SAL.FILMAT, SAL.CODMAT, SAL.CODCOR, SAL.CODTAM, SAL.CODFIL)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '10',
       240,
       16,
       'VLRCMG',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr Ini Cust Md Ger',
       'Valor Inicial do Custo Mdio Gerencial',
       '',
       'VLRCMG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '17',
       990,
       12,
       'SALDOKIT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Saldo Kit',
       'Saldo Kit Header',
       '',
       'SALDOKIT(AGORA(),SAL.FILMAT,SAL.CODMAT,SAL.CODCOR,SAL.CODTAM,SAL.CODFIL,SAL.CODMUL)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'SAL ',
       '10',
       230,
       16,
       'VLR_CM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr Ini Cust Med Fis',
       'Valor Inicial do Custo Mdio Fiscal',
       '',
       'VLR_CM',
       'F',
       'D' FROM DUAL
);

/*-- SEQ 9309 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'SAL ',
       ':P_TIPO',
       0,
       'C',
       'Pedido de Compra aos Fornecedo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SAL ',
       ':P_TIPO',
       0,
       'R',
       'Reposio entre Filiais',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SAL ',
       ':P_TIPO',
       0,
       'T',
       'Todos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SAL ',
       ':SAL.MEDIA_PERIOD',
       0,
       'A',
       'Anual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SAL ',
       ':SAL.MEDIA_PERIOD',
       0,
       'D',
       'Diria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SAL ',
       ':SAL.MEDIA_PERIOD',
       0,
       'M',
       'Mensal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SAL ',
       ':SAL.TIPODIA',
       0,
       'A',
       'Dias Uteis',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SAL ',
       ':SAL.TIPODIA',
       0,
       'C',
       'Dias Corridos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SAL ',
       ':SAL.TIPOGIRO',
       0,
       'E',
       'Estoque',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SAL ',
       ':SAL.TIPOGIRO',
       0,
       'G',
       'Custo Mdio Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SAL ',
       ':SAL.TIPOGIRO',
       0,
       'S',
       'Saldo de Custo Mdio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SAL ',
       ':SAL.TIPOGIRO',
       0,
       'V',
       'Valor de Custo Mdio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SAL ',
       ':SAL.TIPPRJ',
       0,
       ' ',
       'Estoque mnimo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SAL ',
       ':SAL.TIPPRJ',
       1,
       ' ',
       'Ponto de pedido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SAL ',
       ':SAL.TIPPRJ',
       2,
       ' ',
       'Mdia de vendas no perodo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SAL ',
       ':SAL.TIPPRJ',
       3,
       ' ',
       'Mesmo perodo do ano anterior',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SAL ',
       ':SAL.TIPPRJ',4,
       ' ',
       'Sazonalidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SAL ',
       'SALDOATIVO',
       0,
       '0',
       'Desativado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SAL ',
       'SALDOATIVO',
       0,
       '1',
       'Ativo',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9310 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'SAV ',
       TO_NUMBER(null),
       'SAV ',
       'Serv Adicionais Ven',
       'TT_SAV',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'SAV.CODFIL, SAV.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9311 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'SAV ','--','' FROM DUAL
UNION ALL
SELECT 'SAV ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'SAV ','99','Outros' FROM DUAL
);

/*-- SEQ 9312 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 26304,
       'SAD ',
       'SAV ',
       'N',
       '1',
       '',
       '',
       'SAD.CODFIL = SAV.FILSAD AND
SAD.SEQUEN = SAV.SEQSAD',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26305,
       'DSAD',
       'SAV ',
       'N',
       '1',
       '',
       '',
       'SAV.CODSAD = DSAD.CODTAB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26306,
       'ORC ',
       'SAV ',
       '01',
       '0N',
       '',
       '',
       'ORC.CODFIL(+) = SAV.FILPED AND
ORC.TIPPED(+) = SAV.TIPPED AND
ORC.NUMPED(+) = SAV.NUMPED',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26307,
       'IOR ',
       'SAV ',
       '01',
       '01',
       '',
       '',
       'IOR.CODFIL(+) = SAV.FILPED AND
IOR.TIPPED(+) = SAV.TIPPED AND
IOR.NUMPED(+) = SAV.NUMPED AND
IOR.NUMITE(+) = SAV.NUMITE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26308,
       'VEN ',
       'SAV ',
       '01',
       '0N',
       '',
       '',
       'VEN.CODFIL(+) = SAV.FILVEN AND
VEN.SEQUEN(+) = SAV.SEQVEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26309,
       'IVE ',
       'SAV ',
       '01',
       '01',
       '',
       '',
       'IVE.CODFIL(+) = SAV.FILVEN AND
IVE.SEQUEN(+) = SAV.SEQVEN AND
IVE.NUMIVE(+) = SAV.NUMIVE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26310,
       'RTT ',
       'SAV ',
       '01',
       '01',
       '',
       '',
       'RTT.CODFIL(+) = SAV.FILRTT AND
RTT.SEQUEN(+) = SAV.SEQRTT',
       '',
       '' FROM DUAL
);

/*-- SEQ 9313 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'SAV ',
       '01',
       10,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Atualizao',
       'Data da Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       390,
       20,
       'CDIMEI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo IMEI',
       'Cdigo IMEI',
       '',
       'CDIMEI',
       '' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '01',
       20,
       20,
       'CODAVU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cod Avulso Antes Fat',
       'Cod avulso antes faturamento para serv adicional avulso',
       '',
       'CODAVU',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '01',
       280,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       240,
       5,
       'CODSAD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Tipo de Servio',
       'Tipo de Servio',
       '',
       'CODSAD',
       '' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '01',
       400,
       25,
       'CODSEG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd. Seguradora',
       'Cdigo Seguradora',
       '',
       'CODSEG',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       370,
       8,
       'DATCAN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data do cancelamento',
       'Data do cancelamento do servio',
       '',
       'DATCAN',
       '' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       40,
       8,
       'DATFIM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fim Cobertura',
       'Data de Fim da Cobertura do Servio',
       '',
       'DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       50,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       60,
       8,
       'DATINI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ini Cobertura',
       'Data de Incio da Cobertura do Servio',
       '',
       'DATINI',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       350,
       1,
       'EXPCAN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exportado Cancelado',
       'Exportado como Cancelado',
       '',
       'EXPCAN',
       '' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       340,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exportado',
       'Exportado',
       '',
       'EXPORT',
       '' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '01',
       290,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do Cliente',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       70,
       3,
       'FILPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial do Oramento',
       'Filial do Oramento',
       '',
       'FILPED',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       80,
       3,
       'FILRTT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial Rec Terceiros',
       'Filial do Recebimento de Terceiros',
       '',
       'FILRTT',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '01',
       320,
       3,
       'FILSAD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Filial Servio Adi',
       'Filial Servio Adicional',
       '',
       'FILSAD',
       '' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       90,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial da Venda',
       'Filial da Venda',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao Servio',
       'Situao do Servio Adquirido',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       110,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Num Item Oramento',
       'Nmero do Item do Oramento',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       120,
       5,
       'NUMIVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Num Item da Venda',
       'Nmero do Item da Venda',
       '',
       'NUMIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       130,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Nmero do Oramento',
       'Nmero do Oramento',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       140,
       10,
       'NUMSEQ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Nmero Seq Contrato',
       'Nmero Sequencial do Contrato',
       '',
       'NUMSEQ',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       150,
       20,
       'NUMSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie Prod Vinculado',
       'Nmero de Srie do Produto Vinculado',
       '',
       'NUMSER',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       160,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       300,
       5,
       'PERIOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% de IOF',
       '% de IOF',
       '',
       'PERIOF',
       '' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       250,
       5,
       'PERSADORI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% Orig. Preo',
       '% Original sobre Preo Total',
       '',
       'PERSADORI',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       170,
       10,
       'SEQRTT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador Rec Ter',
       'Sequenciador do Recebimento de Terceiros',
       '',
       'SEQRTT',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '01',
       330,
       10,
       'SEQSAD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Seq Servio Adi',
       'Seq Servio Adicional',
       '',
       'SEQSAD',
       '' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '01',
       180,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       190,
       10,
       'SEQVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador Venda',
       'Sequenciador da Venda',
       '',
       'SEQVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       270,
       1,
       'SOMTOT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Soma nos Totais',
       'Soma nos Totais (abertos e vendidos)',
       '',
       'SOMTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       200,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo do Oramento',
       'Tipo do Oramento',
       '',
       'TIPPED',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       210,
       1,
       'TIPVAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Tempo Validade ',
       'Tipo do Tempo de Validade do Servio',
       '',
       'TIPVAL',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       220,
       2,
       'VALIDA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Garantia/Validade',
       'Garantia/Validade',
       '',
       'VALIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       230,
       12,
       'VALSAD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Valor do Seguro (R$)',
       'Valor do Seguro (em R$)',
       '',
       'VALSAD',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       260,
       12,
       'VALSADORI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Val. Serv. Original',
       'Valor do Servio Original (em R$)',
       '',
       'VALSADORI',
       'F' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       380,
       12,
       'VLRCAN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor cancelamento',
       'Valor do cancelamento do servio',
       '',
       'VLRCAN',
       '' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       360,
       14,
       'VLRCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor de Comisso',
       'Valor de Comisso',
       '',
       'VLRCOM',
       '' FROM DUAL
UNION ALL
SELECT 'SAV ',
       '99',
       310,
       12,
       'VLRIOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor do IOF',
       'Valor do IOF',
       '',
       'VLRIOF',
       '' FROM DUAL
);

/*-- SEQ 9314 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'SAV ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SAV ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SAV ',
       'FLGEST',
       0,
       'D',
       'Devolvido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SAV ',
       'FLGEST',
       0,
       'F',
       'Vendido',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9315 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'SEP ',
       TO_NUMBER(null),
       'SEP ',
       'Separao Mercadoria',
       'TV_IVO',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'SEP.FILVOL, SEP.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9316 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'SEP ','--','' FROM DUAL
UNION ALL
SELECT 'SEP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'SEP ','99','Outros' FROM DUAL
);

/*-- SEQ 9317 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 29508,
       'IVE ',
       'SEP ',
       '01',
       '1',
       '',
       '',
       'SEP.FILIVE = IVE.CODFIL AND
SEP.SEQIVE = IVE.SEQUEN AND
SEP.NUMIVE = IVE.NUMITE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29509,
       'IOR ',
       'SEP ',
       'N',
       '1',
       '',
       '',
       'SEP.FILPED = IOR.CODFIL AND
SEP.TIPPED = IOR.TIPPED AND
SEP.NUMPED = IOR.NUMPED AND
SEP.NUMITE = IOR.NUMITE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29510,
       'IVO ',
       'SEP ',
       '1',
       '1',
       '',
       '',
       'SEP.FILVOL=IVO.FILVOL AND
SEP.SEQUEN=IVO.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29511,
       'IPE ',
       'SEP ',
       'N',
       '1',
       '',
       '',
       'SEP.FILIPE = IPE.CODFIL AND
SEP.NUMIPE = IPE.NUMPED AND
SEP.ITEIPE = IPE.NUMITE
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29512,
       'CLI ',
       'SEP ',
       'N',
       '1',
       '',
       '',
       'SEP.FILCLI=CLI.FILCLI AND
SEP.CODCLI=CLI.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29507,
       'LOT ',
       'SEP ',
       '0N',
       '01',
       '',
       '',
       'SEP.FILLOT = LOT.CODFIL(+) AND
SEP.SEQLOT = LOT.SEQUEN(+)
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29764,
       'GRA ',
       'SEP ',
       'N',
       '1',
       '',
       '',
       'GRA.FILMAT = SEP.GRA_FILMAT AND
GRA.CODMAT = SEP.GRA_CODMAT AND
GRA.CODCOR = SEP.GRA_CODCOR AND
GRA.CODTAM = SEP.GRA_CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 9318 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'SEP ',
       '--',
       10,
       40,
       'BAIRRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       '',
       'Bairro',
       'Bairro',
       '',
       'BAIRRO',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd. Cliente Ttulo',
       'Cd. Cliente Ttulo',
       '',
       'CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       40,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Filial Ttulo',
       'Filial Ttulo',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       50,
       3,
       'CODFIL2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Filial Romaneio',
       'Filial Romaneio',
       '',
       'CODFIL2',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       670,
       6,
       'CODMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo Motorista',
       'Cdigo Motorista',
       '',
       'CODMOT',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       60,
       12,
       'CODNAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Natureza',
       'Natureza',
       '',
       'CODNAT',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       70,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Srie',
       'Srie',
       '',
       'CODSER',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       80,
       6,
       'CODTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd. Transportador',
       'Cd. Transportador',
       '',
       'CODTRA',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       90,
       3,
       'CODVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd. Vendedor',
       'Cd. Vendedor',
       '',
       'CODVEN',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       100,
       12,
       'CONTEM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'T',
       'N',
       '',
       'Contm',
       'Contm',
       '',
       'CONTEM',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       110,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data',
       'Data',
       '',
       'DATHOR',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       120,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Operao',
       'Data Operao',
       '',
       'DATOPE',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       740,
       2,
       'DEPART',
       'S',
       'DDEP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDEP.DESDEP',
       'V',
       '',
       '',
       'A',
       '',
       'Departamento',
       'Departamento do Produto',
       'SEP.DEPART = DDEP.CODTAB',
       'DEPART',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       490,
       30,
       'DESMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio Produto',
       'Descrio Produto',
       '',
       'DESMAT',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       130,
       54,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Identificao Ttulo',
       'Identificao Ttulo',
       '',
       'DOCUME',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '01',
       520,
       6,
       'EDE_CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'EDE_CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '01',
       530,
       3,
       'EDE_CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'EDE_CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '01',
       540,
       3,
       'EDE_FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'EDE_FILCLI',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '01',
       550,
       4,
       'EDE_NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'EDE_NUMEND',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       150,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Filial Cliente Tt.',
       'Filial Cliente de Ttulo',
       '',
       'FILCLI',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       370,
       3,
       'FILIPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Fil. Ped. Compra',
       'Fil. Ped. Compra',
       '',
       'FILIPE',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       380,
       3,
       'FILIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Fil. Itens Complem.',
       'Fil. Itens Complementados',
       '',
       'FILIVE',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       710,
       3,
       'FILLOT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial Lote',
       'Filial do Lote',
       'DFIL.CODFIL(+) = SEP.FILLOT',
       'FILLOT',
       'T' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       680,
       3,
       'FILMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Filial Motorista',
       'Filial Motorista',
       '',
       'FILMOT',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       390,
       3,
       'FILPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Fil. Pedido',
       'Fil. Pedido',
       '',
       'FILPED',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       170,
       3,
       'FILTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Filial Transportador',
       'Filial Transportador',
       '',
       'FILTRA',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       180,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Filial Vendedor',
       'Filial Vendedor',
       '',
       'FILVEN',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       400,
       3,
       'FILVOL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Fil. Volume',
       'Fil. Volume',
       '',
       'FILVOL',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       190,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Estado da Separao',
       'Estado da Separao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       690,
       1,
       'FLGROM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Estado Romaneio',
       'Estado Romaneio',
       '',
       'FLGROM',
       'T' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '01',
       560,
       5,
       'GRA_CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'GRA_CODCOR',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '01',
       570,
       5,
       'GRA_CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'GRA_CODMAT',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '01',
       580,
       5,
       'GRA_CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'GRA_CODTAM',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '01',
       590,
       3,
       'GRA_FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'GRA_FILMAT',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       510,
       5,
       'ITEDOC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Item',
       'Item',
       '',
       'ITEDOC',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       410,
       5,
       'ITEIPE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Item Ped. Compra',
       'Item Ped. Compra',
       '',
       'ITEIPE',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       200,
       64,
       'MOTORA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Motorista',
       'Motorista',
       '',
       'MOTORA',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       210,
       35,
       'NOMCID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cidade',
       'Cidade',
       '',
       'NOMCID',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       220,
       14,
       'NUMCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Ident. de Romaneio',
       'Identificao de Romaneio',
       '',
       'NUMCAR',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       230,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Ecf',
       'Ecf',
       '',
       'NUMECF',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       420,
       8,
       'NUMIPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Pedido Ped. Compra',
       'Pedido Ped. Compra',
       '',
       'NUMIPE',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       430,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Item Pedido / OS',
       'Item Pedido / OS',
       '',
       'NUMITE',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       440,
       5,
       'NUMIVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Item da Venda',
       'Item da Venda',
       '',
       'NUMIVE',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       240,
       8,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nr. Nota',
       'Nr. Nota',
       '',
       'NUMNOT',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       250,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nr. Pedido',
       'Nr. Pedido',
       '',
       'NUMPED',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       660,
       1,
       'ORIGEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Origem',
       'Origem',
       '',
       'ORIGEM',
       'T' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       260,
       12,
       'PESCAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'T',
       'N',
       '',
       'Peso Bruto',
       'Peso Bruto',
       '',
       'PESCAR',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       270,
       7,
       'PLACAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Placa',
       'Placa',
       '',
       'PLACAS',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '01',
       600,
       5,
       'PRO_CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'PRO_CODMAT',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '01',
       610,
       3,
       'PRO_FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'PRO_FILMAT',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       280,
       12,
       'QTDFAL',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Quantidade Faltante',
       'Quantidade Faltante',
       '',
       'QTDFAL',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       620,
       12,
       'QTDITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Quantidade',
       'Quantidade',
       '',
       'QTDITE',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       630,
       12,
       'QTDSEP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Qtd a Separar',
       'Quantidade a Separar',
       '',
       'QTDSEP',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       500,
       20,
       'REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Referncia de Grade',
       'Referncia de Grade',
       '',
       'REFPRO',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       290,
       5,
       'REGIAO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Regio',
       'Regio',
       '',
       'REGIAO',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '01',
       640,
       3,
       'ROM_CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'ROM_CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '01',
       650,
       10,
       'ROM_SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'ROM_SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       460,
       10,
       'SEQIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Sequen. da Venda',
       'Sequen. da Venda',
       '',
       'SEQIVE',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       720,
       10,
       'SEQLOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq Lote',
       'Sequenciador do Lote',
       '',
       'SEQLOT',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       300,
       10,
       'SEQROM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Seq. Romaneio',
       'Seq. Romaneio',
       '',
       'SEQROM',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       310,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Seq. Item Volume',
       'Seq. Item Volume',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       730,
       1,
       'TIPENT',
       'A',
       'DENT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DENT.DESENT',
       'V',
       '',
       '',
       'A',
       '',
       'Tipo de Entrega',
       'Tipo de Entrega',
       'DENT.CODTAB = TO_NUMBER(SEP.TIPENT)',
       'TIPENT',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       320,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo de Pedido / OS',
       'Tipo de Pedido / OS',
       '',
       'TIPPED',
       'T' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       700,
       14,
       'VLRITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Item',
       'Valor Item',
       '',
       'VLRITE',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       350,
       14,
       'VLRNOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'T',
       'N',
       '',
       ' Valor Total Itens',
       'Valor Total dos Itens',
       '',
       'VLRNOT',
       '' FROM DUAL
UNION ALL
SELECT 'SEP ',
       '--',
       360,
       12,
       'VOLCAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'T',
       'N',
       '',
       'Volume m3',
       'Volume m3',
       '',
       'VOLCAR',
       '' FROM DUAL
);

/*-- SEQ 9319 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'SEP ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SEP ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SEP ',
       'FLGEST',
       0,
       'D',
       'Devolver',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SEP ',
       'FLGEST',
       0,
       'E',
       'Entregue',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SEP ',
       'FLGEST',
       0,
       'F',
       'Em Falta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SEP ',
       'FLGEST',
       0,
       'N',
       'No Separar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SEP ',
       'FLGEST',
       0,
       'O',
       'Encomendado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SEP ',
       'FLGEST',
       0,
       'P',
       'Separado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SEP ',
       'FLGROM',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SEP ',
       'FLGROM',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SEP ',
       'FLGROM',
       0,
       'E',
       'Entregue',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SEP ',
       'FLGROM',
       0,
       'F',
       'Fechado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SEP ',
       'ORIGEM',
       0,
       'O',
       'Oramento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SEP ',
       'ORIGEM',
       0,
       'P',
       'Pedido de Reposio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SEP ',
       'ORIGEM',
       0,
       'V',
       'Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SEP ',
       'TIPPED',
       0,
       'O',
       'DAV',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SEP ',
       'TIPPED',
       0,
       'P',
       'Pr-Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SEP ',
       'TIPPED',
       0,
       'S',
       'DAV-OS',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9320 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'SER2',
       0,
       'SER2',
       'Dom. Sries',
       'TD_SER',
       'F',
       '',
       'TOTALL',
       'Sries',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9321 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'SER2','--','' FROM DUAL
UNION ALL
SELECT 'SER2','01','Identificao' FROM DUAL
);

/*-- SEQ 9322 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'SER2',
       '01',
       20,
       2,
       'CODSER',
       'A',
       '',
       0,
       0,
       'DSER',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TAB',
       'F',
       'A',
       'T',
       'Srie',
       'Cdigo da srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'SER2',
       '01',
       150,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'DSER',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'T',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
);

/*-- SEQ 9323 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'SIM ',
       TO_NUMBER(null),
       'SIM ',
       'Produtos Similares',
       'TT_SIM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'SIM.CODFIL,SIM.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9324 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'SIM ','--','' FROM DUAL
UNION ALL
SELECT 'SIM ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'SIM ','99','Outros' FROM DUAL
);

/*-- SEQ 9325 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5867,
       'GRA ',
       'SIM ',
       '1 ',
       '1 ',
       '',
       '',
       'SIM.FILMAT = GRA.FILMAT AND
SIM.CODMAT = GRA.CODMAT AND
SIM.CODCOR = GRA.CODCOR AND
SIM.CODTAM = GRA.CODTAM',
       '' FROM DUAL
);

/*-- SEQ 9326 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'SIM ',
       '01',
       10,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Diviso do produto',
       'SIM.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'SIM ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = SIM.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'SIM ',
       '01',
       30,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'SIM ',
       '01',
       40,
       5,
       'CODSIM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cd.Material Similar',
       'Cdigo Material Similar',
       '',
       'CODSIM',
       'F' FROM DUAL
UNION ALL
SELECT 'SIM ',
       '01',
       110,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'SIM.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'SIM ',
       '01',
       60,
       5,
       'CORSIM',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       '',
       'N',
       'F',
       'Cor Similar',
       'Cor Similar',
       'SIM.CORSIM=DIV.CODITE (+)',
       'CORSIM',
       'T' FROM DUAL
UNION ALL
SELECT 'SIM ',
       '01',
       70,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'SIM ',
       '01',
       80,
       3,
       'FILSIM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Produto Similar',
       '',
       'FILSIM',
       'F' FROM DUAL
UNION ALL
SELECT 'SIM ',
       '01',
       90,
       10,
       'SEQUEN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'SIM ',
       '01',
       100,
       5,
       'TAMSIM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tamanho Similar',
       'Tamanho Similar',
       '',
       'TAMSIM',
       'F' FROM DUAL
);

/*-- SEQ 9327 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'SLI ',
       TO_NUMBER(null),
       'SLI ',
       'Sug.Lista Presentes',
       'TT_SLI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'SLI.CODFIL, SLI.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9328 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'SLI ','--','' FROM DUAL
UNION ALL
SELECT 'SLI ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'SLI ','99','Outros' FROM DUAL
);

/*-- SEQ 9329 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'SLI ',
       '99',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'SLI ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'SLI ',
       '01',
       30,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'SLI ',
       '99',
       40,
       40,
       'DESLPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Descrio da Lista',
       'Descrio da Lista',
       '',
       'DESLPR',
       'F' FROM DUAL
UNION ALL
SELECT 'SLI ',
       '01',
       50,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'SLI ',
       '01',
       51,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN SLI.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'SLI ',
       '99',
       60,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
);

/*-- SEQ 9330 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'SLT ',
       TO_NUMBER(null),
       'SLT ',
       'Saldo Lote',
       'TT_SLT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'SLT.CODFIL,SLT.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9331 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'SLT ','--','' FROM DUAL
UNION ALL
SELECT 'SLT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'SLT ','02','Valores' FROM DUAL
UNION ALL
SELECT 'SLT ','99','Outros' FROM DUAL
);

/*-- SEQ 9332 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 24295,
       'LOT ',
       'SLT ',
       '1',
       '0N',
       '',
       '',
       'LOT.CODFIL = SLT.FILLOT(+) AND
LOT.SEQUEN = SLT.SEQLOT(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 9333 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'SLT ',
       '--',
       80,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Atualizao',
       'Data Atualizao',
       '',
       'ATU_EM',
       '' FROM DUAL
UNION ALL
SELECT 'SLT ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL(+) = SLT.CODFIL',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'SLT ',
       '01',
       30,
       5,
       'CODMUL',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'N',
       '',
       'Subestoque',
       'Subestoque do lote',
       'DMUL.CODTAB(+) = SLT.CODMUL',
       'CODMUL',
       'T' FROM DUAL
UNION ALL
SELECT 'SLT ',
       '01',
       40,
       3,
       'FILLOT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial Lote',
       'Filial do lote',
       'DFIL.CODFIL(+) = SLT.FILLOT',
       'FILLOT',
       'T' FROM DUAL
UNION ALL
SELECT 'SLT ',
       '99',
       90,
       1,
       'MOVSLT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Movimentou estoque?',
       'Movimentou estoque?',
       '',
       'MOVSLT',
       '' FROM DUAL
UNION ALL
SELECT 'SLT ',
       '02',
       60,
       12,
       'QTDEST',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Saldo Lote',
       'Saldo do lote',
       '',
       'QTDEST',
       '' FROM DUAL
UNION ALL
SELECT 'SLT ',
       '02',
       70,
       12,
       'RESERV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Qtd.Reserva',
       'Quantidade de reserva do lote',
       '',
       'RESERV',
       '' FROM DUAL
UNION ALL
SELECT 'SLT ',
       '01',
       50,
       10,
       'SEQLOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq Lote',
       'Sequenciador do lote',
       '',
       'SEQLOT',
       '' FROM DUAL
UNION ALL
SELECT 'SLT ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9334 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'SPC ',
       0,
       'SPC ',
       'Pessoa Fsica',
       'TT_SPC',
       'T',
       '',
       'TOTALL',
       'Pessoas Fsicas (SPC)',
       '{FILCLI;CODCLI}',
       '',
       '',
       'ClienteFsicos',
       'T',
       '',
       'SPC.FILCLI,SPC.CODCLI',
       '' FROM DUAL
);

/*-- SEQ 9335 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'SPC ','--','' FROM DUAL
UNION ALL
SELECT 'SPC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'SPC ','02','Dados do Cnjuge' FROM DUAL
UNION ALL
SELECT 'SPC ','03','Local de Trabalho' FROM DUAL
UNION ALL
SELECT 'SPC ','04','Lojas onde compra a crdito' FROM DUAL
UNION ALL
SELECT 'SPC ','05','Confirmaes' FROM DUAL
UNION ALL
SELECT 'SPC ','06','Residncia' FROM DUAL
UNION ALL
SELECT 'SPC ','99','Outros' FROM DUAL
);

/*-- SEQ 9336 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 30171,
       'DOCU',
       'SPC ',
       '01',
       '0N',
       '',
       '',
       'DOCU.CODTAB(+) = SPC.CONOCU',
       '',
       '' FROM DUAL
);

/*-- SEQ 9337 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'SPC ',
       '06',
       20,
       12,
       'ALUFIN',
       'F',
       '',
       2,
       0,
       'SPC ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'SPC',
       'T',
       'N',
       'T',
       'Vlr. Aluguel/Financ.',
       'Valor do aluguel / financiamento',
       '',
       'ALUFIN',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '02',
       130,
       5,
       'ANTMES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'SPC ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Tempo de Servio',
       'Tempo de servio do parceiro  no emprego anterior',
       '',
       'ANTMES',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '03',
       90,
       5,
       'ATUMES',
       'S',
       '',
       0,
       0,
       'SPC ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'SPC',
       'F',
       'N',
       'T',
       'Meses de Trabalho',
       'Tempo de servio do parceiro no emprego atual (meses)',
       '',
       'ATUMES',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '02',
       60,
       5,
       'CANMES',
       'S',
       '',
       0,
       0,
       'SPC ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'SPC',
       'F',
       'N',
       'T',
       'Meses Serv. Cnjuge',
       'Tempo de servio do cnjuge (meses)',
       '',
       'CANMES',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '99',
       140,
       1,
       'CARLOJ',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Tem Carto Loja?',
       'Tem carto da Loja?',
       '',
       'CARLOJ',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '02',
       90,
       6,
       'CARPRC',
       'A',
       '',
       0,
       0,
       'SPC ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'CTPS do Cnjuge',
       'Nmero da Carteira de trabalho (CTPS) do cnjuge',
       '',
       'CARPRC',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '03',
       100,
       6,
       'CARPRO',
       'A',
       '',
       0,
       0,
       'SPC ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'CTPS',
       'Nmero da carteira de trabalho (CTPS) do cliente',
       '',
       'CARPRO',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '02',
       220,
       5,
       'CASMES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Tempo Casamento',
       'Tempo de Casamento',
       '',
       'CASMES',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '01',
       40,
       35,
       'CIDNAS',
       'A',
       '',
       0,
       0,
       'SPC ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'Cidade de Nascimento',
       'Cidade de nascimento do cliente',
       '',
       'CIDNAS',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       0,
       'SPC ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'SPC',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '99',
       240,
       5,
       'CODOCU',
       'S',
       'DOCU',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DOCU.DESOCU',
       'V',
       '',
       '',
       'N',
       'F',
       'Cargo Cliente',
       'Cargo do Cliente',
       'DOCU.CODTAB(+) = SPC.CODOCU',
       'CODOCU',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '99',
       150,
       40,
       'COMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Compl. End. Trabalho',
       'Complemento Endereo Trabalho',
       '',
       'COMPLE',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '01',
       250,
       5,
       'CONOCU',
       'S',
       'DOCU',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DOCU.DESOCU',
       'V',
       '',
       '',
       'N',
       'F',
       'Cargo Cnjuge',
       'Cargo do Cnjuge',
       'DOCU.CODTAB(+) = SPC.CONOCU',
       'CONOCU',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '05',
       20,
       1,
       'CONSPC',
       'L',
       '',
       0,
       0,
       'SPC ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'SPC',
       'F',
       'A',
       'T',
       'SPC OK?',
       'Confirmao consulta SPC',
       '',
       'CONSPC',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '05',
       40,
       1,
       'CON_LR',
       'L',
       '',
       0,
       0,
       'SPC ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'SPC',
       'F',
       'A',
       'T',
       'Local Residncia OK?',
       'Confirmao local de resid.',
       '',
       'CON_LR',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '05',
       30,
       1,
       'CON_LT',
       'L',
       '',
       0,
       0,
       'SPC ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'SPC',
       'F',
       'A',
       'T',
       'Local Trabalho OK?',
       'Confirmao local de trab.',
       '',
       'CON_LT',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '05',
       10,
       1,
       'CON_TC',
       'L',
       '',
       0,
       0,
       'SPC ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'SPC',
       'F',
       'A',
       'T',
       'Talo Cheques OK?',
       'Confirmao talo cheques',
       '',
       'CON_TC',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '99',
       230,
       2,
       'DDDCEL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'DDD Celular',
       'DDD Celular',
       '',
       'DDDCEL',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '02',
       40,
       50,
       'ENDCO1',
       'A',
       '',
       0,
       0,
       'SPC ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'End. Trab. Cnjuge ',
       'Endereo Trabalho do Cnjuge',
       '',
       'ENDCO1',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '02',
       50,
       20,
       'ENDCO2',
       'A',
       '',
       0,
       0,
       'SPC ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'End.Compl.do Cnjuge',
       'Complemento endereo do cnjuge',
       '',
       'ENDCO2',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '03',
       50,
       42,
       'ENDERE',
       'A',
       '',
       0,
       0,
       'SPC ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'Endereo Trabalho',
       'Endereo de Trabalho',
       '',
       'ENDERE',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '04',
       20,
       34,
       'ENDLO1',
       'A',
       '',
       0,
       0,
       'SPC ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'End. Ref. Coml. 1',
       'Endereo da referncia comercial 1',
       '',
       'ENDLO1',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '04',
       40,
       34,
       'ENDLO2',
       'A',
       '',
       0,
       0,
       'SPC ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'End. Ref. Coml. 2',
       'Endereo da referncia comercial (loja) 2',
       '',
       'ENDLO2',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '02',
       110,
       254,
       'E_MAIL',
       'A',
       '',
       0,
       0,
       'SPC ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'E-mail',
       'E-Mail',
       '',
       'E_MAIL',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '01',
       10,
       3,
       'FILCLI',
       'A',
       '',
       0,
       0,
       'SPC ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'SPC',
       'F',
       'N',
       'F',
       'Filial Cliente',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '03',
       80,
       40,
       'FIRANT',
       'A',
       '',
       0,
       0,
       'SPC ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'Empresa Anterior',
       'Nome da firma anterior do cliente',
       '',
       'FIRANT',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '03',
       10,
       40,
       'FIRATU',
       'A',
       '',
       0,
       0,
       'SPC ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'Local de Trabalho',
       'Firma atual do cliente',
       '',
       'FIRATU',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '02',
       20,
       50,
       'FIRCON',
       'A',
       '',
       0,
       0,
       'SPC ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'Trabalho do Cnjuge',
       'Nome da firma do cnjuge',
       '',
       'FIRCON',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '06',
       30,
       5,
       'MORMES',
       'S',
       '',
       0,
       0,
       'SPC ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'SPC',
       'F',
       'N',
       'T',
       'Meses de Moradia',
       'Tempo de moradia (meses)',
       '',
       'MORMES',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '01',
       30,
       17,
       'NACION',
       'A',
       '',
       0,
       0,
       'SPC ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'Nacionalidade',
       'Nacionalidade do cliente',
       '',
       'NACION',
       'F',
       'S' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '01',
       260,
       44,
       'NOMEMAE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome da Me',
       'Nome da Me',
       '',
       '(SELECT MIN(CON.CONTAT) FROM TT_CON CON INNER JOIN TD_CON DCON ON DCON.CODTAB = CON.CODREL WHERE CON.FILCLI = SPC.FILCLI AND CON.CODCLI = SPC.CODCLI AND (UPPER(DCON.DESCON) LIKE ''%ME%'' OR UPPER(DCON.DESCON) LIKE ''%MAE%''))',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '01',
       270,
       44,
       'NOMEPAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome do Pai',
       'Nome do Pai',
       '',
       '(SELECT MIN(CON.CONTAT) FROM TT_CON CON INNER JOIN TD_CON DCON ON DCON.CODTAB = CON.CODREL WHERE CON.FILCLI = SPC.FILCLI AND CON.CODCLI = SPC.CODCLI AND (UPPER(DCON.DESCON) LIKE ''%PAI%''))',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '04',
       10,
       40,
       'NOMLO1',
       'A',
       '',
       0,
       0,
       'SPC ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'Ref. Comercial 1',
       'Nome da referncia comercial (loja) 1',
       '',
       'NOMLO1',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '04',
       30,
       40,
       'NOMLO2',
       'A',
       '',
       0,
       0,
       'SPC ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'Ref. Comercial 2',
       'Nome da referncia comercial (loja) 2',
       '',
       'NOMLO2',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '03',
       40,
       50,
       'NOMSUP',
       'A',
       '',
       0,
       0,
       'SPC ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'Nome do Superior',
       'Nome do superior imediato do cliente',
       '',
       'NOMSUP',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '01',
       50,
       10,
       'NUMCEL',
       'A',
       '',
       0,
       0,
       'SPC ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'Celular',
       'Celular',
       '',
       'NUMCEL',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '02',
       10,
       2,
       'NUMCOC',
       'A',
       '',
       0,
       0,
       'SPC ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'DDD Cnjuge (coml)',
       'DDD telefone do cnjuge',
       '',
       'NUMCOC',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '03',
       20,
       2,
       'NUMCOD',
       'A',
       '',
       0,
       0,
       'SPC ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'DDD (coml)',
       'Nmero do DDD da firma',
       '',
       'NUMCOD',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '99',
       160,
       3,
       'NUMDEP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero de Dependente',
       'Nmero de Dependentes',
       '',
       'NUMDEP',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '03',
       30,
       10,
       'NUMTEL',
       'A',
       '',
       0,
       0,
       'SPC ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'Fone (coml)',
       'Nmero do telefone da firma',
       '',
       'NUMTEL',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '99',
       170,
       30,
       'ORIRED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Origem da Renda',
       'Origem da Renda',
       '',
       'ORIRED',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '02',
       120,
       15,
       'RGCONJ',
       'A',
       '',
       0,
       0,
       'SPC ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'Identidade Cnjuge',
       'Nmero da Identidade do cnjuge',
       '',
       'RGCONJ',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '02',
       70,
       12,
       'SALBAC',
       'F',
       '',
       2,
       0,
       'SPC ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'SPC',
       'T',
       'N',
       'T',
       'Salrio do Cnjuge',
       'Salrio base do cnjuge',
       '',
       'SALBAC',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '03',
       60,
       12,
       'SALBAS',
       'F',
       '',
       2,
       0,
       'SPC ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'SPC',
       'T',
       'N',
       'T',
       'Salrio',
       'Salrio base do cliente',
       '',
       'SALBAS',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '02',
       100,
       6,
       'SERCAC',
       'A',
       '',
       0,
       0,
       'SPC ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'Srie da CTPS (Cnj)',
       'Srie da carteira de trabalho do cnjuge',
       '',
       'SERCAC',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '03',
       110,
       6,
       'SERCAR',
       'A',
       '',
       0,
       0,
       'SPC ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'Srie da CTPS',
       'Nmero da srie da carteira de trabalho',
       '',
       'SERCAR',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '02',
       30,
       10,
       'TELCON',
       'A',
       '',
       0,
       0,
       'SPC ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SPC',
       'F',
       'A',
       'T',
       'Fone Cnjuge (coml)',
       'Nmero telefone do cnjuge',
       '',
       'TELCON',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '99',
       180,
       1,
       'TEMAUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Tem automvel?',
       'Tem Automvel?',
       '',
       'TEMAUT',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '99',
       190,
       1,
       'TEM_CC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Tem Carto Crdito?',
       'Tem Carto de Crdito?',
       '',
       'TEM_CC',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '99',
       200,
       1,
       'TEM_TC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Tem Talo de Cheques',
       'Tem Talo de Cheques?',
       '',
       'TEM_TC',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '06',
       10,
       5,
       'TIPRES',
       'S',
       '',
       0,
       0,
       'SPC ',
       10,
       30,
       '',
       '',
       'D',
       'SPC',
       'F',
       'N',
       'T',
       'Tipo de Residncia',
       'Tipo de residncia',
       '',
       'TIPRES',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'SPC ',
       '99',
       210,
       12,
       'VLRRED',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor da Renda',
       'Valor da Renda',
       '',
       'VLRRED',
       'F',
       'P' FROM DUAL
);

/*-- SEQ 9338 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'SPC ',
       'TIPRES',
       3,
       ' ',
       'Mora com os Parentes',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPC ',
       'TIPRES',
       4,
       ' ',
       'Mora no Trabalho',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPC ',
       'TIPRES',
       5,
       ' ',
       'No Informada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPC ',
       'TIPRES',
       0,
       'A',
       'Alugada',
       105,
       ' ' FROM DUAL
UNION ALL
SELECT 'SPC ',
       'TIPRES',
       1,
       'F',
       'Financiada',
       106,
       ' ' FROM DUAL
UNION ALL
SELECT 'SPC ',
       'TIPRES',
       2,
       'P',
       'Prpria',
       104,
       ' ' FROM DUAL
);

/*-- SEQ 9339 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'SPSU',
       TO_NUMBER(null),
       'SPSU',
       'Publicar Prob. Sup.',
       'TT_PSU',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9340 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'SPSU','--','' FROM DUAL
UNION ALL
SELECT 'SPSU','01','Identificao' FROM DUAL
UNION ALL
SELECT 'SPSU','99','Outros' FROM DUAL
);

/*-- SEQ 9341 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5871,
       'MSG ',
       'SPSU',
       'N ',
       '1 ',
       '',
       '',
       'MSG.CODFIL(+) = SPSU.CODFIL AND
MSG.SEQUEN(+) = SPSU.SEQUEN AND
MSG.SEQMSG(+) = SPSU.MSGPRO AND
MSG.SEQMSG(+) = SPSU.MSGSOL
',
       '' FROM DUAL
);

/*-- SEQ 9342 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'SPSU',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Codigo da Filial',
       'DFIL.CODFIL = SPSU.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'SPSU',
       '01',
       20,
       5,
       'MSGPRO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Mensagem Problema',
       'Mensagem Problema',
       '',
       'MSGPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'SPSU',
       '01',
       30,
       5,
       'MSGSOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Mensagem Solucao',
       'Mensagem solucao',
       '',
       'MSGSOL',
       'F' FROM DUAL
UNION ALL
SELECT 'SPSU',
       '01',
       40,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 9343 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'SPT ',
       TO_NUMBER(null),
       'SPT ',
       'Suporte',
       'TT_SUP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'SPT.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9344 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'SPT ','--','' FROM DUAL
UNION ALL
SELECT 'SPT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'SPT ','02','Valores' FROM DUAL
UNION ALL
SELECT 'SPT ','03','Datas' FROM DUAL
UNION ALL
SELECT 'SPT ','04','Informaes sobre Chamados' FROM DUAL
UNION ALL
SELECT 'SPT ','05','Informaes Sobre tarefas' FROM DUAL
UNION ALL
SELECT 'SPT ','99','Outros' FROM DUAL
);

/*-- SEQ 9345 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21946,
       'CLI ',
       'SPT ',
       '1',
       'N',
       '',
       '',
       'CLI.FILCLI = SPT.FILCLI AND
CLI.CODCLI = SPT.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21947,
       'EDE ',
       'SPT ',
       '01',
       'N',
       '',
       '',
       'EDE.FILCLI(+) = SPT.FILCLI and
EDE.CODCLI(+) = SPT.CODCLI and
EDE.CODFIL(+) = SPT.FILEND and
EDE.NUMEND(+) = SPT.NUMEND',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21948,
       'DMOD',
       'SPT ',
       'N',
       '1',
       '',
       '',
       'DMOD.CODTAB = SPT.MODULO',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21949,
       'WOR ',
       'SPT ',
       '0N',
       '0N',
       'SXW ',
       '',
       'WOR.CODFIL(+)=SXW.FILWOR AND WOR.SEQUEN(+)=SXW.SEQWOR AND 
SPT.CODFIL=SXW.FILSUP(+) AND SPT.SEQUEN=SXW.SEQSUP(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 9346 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'SPT ',
       '03',
       75,
       4,
       'ANO_DATREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data',
       'Ano de Data',
       '',
       'TO_CHAR(SPT.DATREG,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '03',
       210,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Data~Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '02',
       300,
       4,
       'CNTTRANKING',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Contador',
       'Contador',
       '',
       '(1)',
       '' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '99',
       220,
       6,
       'CODACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Contrato',
       'Cdigo Contrato',
       '',
       'CODACT',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '01',
       4,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '01',
       400,
       3,
       'CODCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Cobrana',
       'Cdigo da Cobrana',
       '',
       'CODCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '01',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Filial',
       'SPT.CODFIL = DFIL.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '99',
       230,
       5,
       'CODFUN',
       'S',
       'DFUN',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFUN.DESFUN',
       'V',
       '',
       '',
       'A',
       'F',
       'Funcionalidade',
       'Funcionalidade',
       'DFUN.CODTAB = SPT.CODFUN',
       'CODFUN',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '99',
       240,
       5,
       'CODPRI',
       'S',
       'DPRI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DPRI.DESPRI',
       'V',
       '',
       '',
       'A',
       'F',
       'Prioridade',
       'Prioridade',
       'DPRI.CODTAB = SPT.CODPRI',
       'CODPRI',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '01',
       130,
       3,
       'CODRES',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Responsvel',
       'Responsvel',
       'SPT.FILRES = USU.FILUSU(+)  AND SPT.CODRES = USU.CODUSU(+)',
       'CODRES',
       'T' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '99',
       250,
       254,
       'COMJUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Comple Justificativa',
       'Complemento de Justificativa',
       '',
       'COMJUS',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '01',
       500,
       77,
       'CONTATO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Aceito por',
       'Aceito Por',
       '',
       '(SELECT VPC.CONTAT FROM TV_PRJ_CON VPC WHERE SPT.FILCLI = VPC.FILCLI AND SPT.CODCLI = VPC.CODCLI AND SPT.NUMACT = VPC.NUMCON)',
       '' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '03',
       260,
       7,
       'DATABE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Abertura',
       'Data Abertura',
       '',
       'DATABE',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '03',
       270,
       7,
       'DATACT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Aceito em',
       'Aceito Em',
       '',
       'DATACT',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '02',
       445,
       7,
       'DATCOB',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Designado~Cob. em',
       'Designado Cobrador em',
       '',
       'DATCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '03',
       280,
       7,
       'DATFEC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fechamento',
       'Data Fechamento',
       '',
       'DATFEC',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '03',
       290,
       7,
       'DATPRO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Prometida',
       'Data Prometida',
       '',
       'DATPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '03',
       70,
       8,
       'DATREG',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data',
       'Data',
       '',
       'DATREG',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '99',
       140,
       40,
       'DESSUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'L',
       '',
       'F',
       'A',
       'F',
       'Assunto',
       'Assunto',
       '',
       'DESSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '99',
       180,
       100,
       'E_MAIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'L',
       '',
       'F',
       'A',
       'F',
       'E-mail',
       'E-mail',
       '',
       'E_MAIL',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '01',
       430,
       30,
       'FECHACHAMADO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Prazo',
       'Prazo',
       '',
       'SUBSTR(FECHACHAMADO(SPT.CODFIL,SPT.SEQUEN,''F''),1,23)',
       '' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '01',
       300,
       3,
       'FILACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Contrato',
       'Filial Contrato',
       '',
       'FILACT',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '01',
       3,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial Cliente',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '01',
       410,
       3,
       'FILCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial de Cobrana',
       '',
       'FILCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '01',
       5,
       3,
       'FILEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial Endereo',
       '',
       'FILEND',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '01',
       120,
       3,
       'FILRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial Responsvel',
       '',
       'FILRES',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '01',
       370,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filila Venda',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '99',
       310,
       1,
       'FLGACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'FLGACT',
       'T' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '99',
       10,
       1,
       'FLGCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo',
       'Tipo de cobrana',
       '',
       'FLGCOB',
       'T' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '02',
       400,
       4,
       'HORTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Soma/Horas Minutos',
       'Soma/Horas Minutos',
       '',
       '(SELECT SUM(HORTRA) FROM TT_HOR WHERE FILSUP=SPT.CODFIL AND SEQSUP=SPT.SEQUEN)',
       '' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '99',
       200,
       2,
       'JUSTIF',
       'S',
       'DJUS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DJUS.DESJUS',
       'V',
       '',
       '',
       'A',
       'F',
       'Justificativa',
       'Justificativa',
       'DJUS.CODTAB = SPT.JUSTIF',
       'JUSTIF',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '03',
       73,
       2,
       'MES_DATREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms de Data',
       'Ms de Data',
       '',
       'TO_CHAR(SPT.DATREG,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '99',
       80,
       5,
       'MODULO',
       'S',
       'DMOD',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOD.MODULO',
       'V',
       '',
       'F',
       '9',
       'F',
       'Mdulo',
       'Mdulo',
       'SPT.MODULO = DMOD.CODTAB',
       'MODULO',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '01',
       320,
       4,
       'NUMACT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero Contrato',
       'Nmero Contrato',
       '',
       'NUMACT',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '01',
       6,
       5,
       'NUMEND',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nmero Endereos',
       'Nmero de Endereos',
       '',
       'NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '99',
       380,
       1,
       'PERFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Perfil',
       'Perfil',
       '',
       'PERFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '--',
       550,
       1,
       'PRICLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Prioridade do Client',
       'Prioridade do Cliente',
       '',
       'PRICLI',
       'T' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '99',
       100,
       1,
       'PRIORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Cdigo da Prioridade',
       'Cdigo Prioridade',
       '',
       'PRIORI',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '99',
       510,
       7,
       'PROXIMA_RELEASE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Prxima Release',
       'Prxima Release',
       '',
       'TO_DATE(PROXIMARELEASE(SPT.DATABE,SPT.CODPRI,SPT.CODFIL),''DD/MM/YYYY HH24:MI:SS'')',
       '' FROM DUAL
UNION ALL       
SELECT 'SPT ',
       '99',
       520,
       8,
       'TEMPOABERTO',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Tempo Aberto em Dias',
       'Tempo Aberto em Dias',
       '',
       'trunc(coalesce(spt.datfec,agora()))-trunc(spt.databe)',
       '' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '04',
       400,
       5,
       'QTDABE',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Chamados~Abertos',
       'Chamados em Aberto',
       '',
       'TRAZ_QTDSUP(SPT.FILCLI,SPT.CODCLI,''A'')',
       '' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '04',
       430,
       5,
       'QTDAPR',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Chamados~Aprovados',
       'Chamados Aprovados',
       '',
       'TRAZ_QTDFLGACT(SPT.FILCLI,SPT.CODCLI,''R'',NULL)',
       '' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '04',
       410,
       5,
       'QTDCAN',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Chamados~Cancelados',
       'Chamados Cancelados',
       '',
       'TRAZ_QTDSUP(SPT.FILCLI,SPT.CODCLI,''C'')',
       '' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '04',
       415,
       5,
       'QTDESP',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Chamados~Em Espera',
       'Chamados em Espera',
       '',
       'TRAZ_QTDSUP(SPT.FILCLI,SPT.CODCLI,''E'')',
       '' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '02',
       200,
       5,
       'QTDFAT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Minutos Trabalhados',
       'Minutos Trabalhados',
       '',
       'QTDFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '04',
       405,
       5,
       'QTDNLI',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Chamados~No Lidos',
       'Chamados no Lidos',
       '',
       'TRAZ_QTDSUP(SPT.FILCLI,SPT.CODCLI,''N'')',
       '' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '01',
       420,
       4,
       'QTDPRO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade Produtos',
       'Quantidade de Produtos',
       '',
       'QTDPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '04',
       425,
       5,
       'QTDREP',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Chamados~Reprovados',
       'Chamados Reprovados',
       '',
       'TRAZ_QTDFLGACT(SPT.FILCLI,SPT.CODCLI,''R'',''F'')',
       '' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '04',
       420,
       5,
       'QTDRES',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Chamados~Resolvidos',
       'Chamados Resolvidos',
       '',
       'TRAZ_QTDSUP(SPT.FILCLI,SPT.CODCLI,''R'')',
       '' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '04',
       435,
       5,
       'QTD_OK',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Chamados~OK',
       'Chamados OK',
       '',
       'TRAZ_QTDFLGACT(SPT.FILCLI,SPT.CODCLI,''R'',''T'')',
       '' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '99',
       150,
       4,
       'RELEASE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Release',
       'Release',
       '',
       'RELEASE',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '01',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SPT.CODFIL||''-''||LTRIM(SPT.SEQUEN)',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '99',
       390,
       10,
       'SEQVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador de Venda',
       '',
       'SEQVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '99',
       110,
       1,
       'SITUAC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'SITUAC',
       'T' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '05',
       10,
       255,
       'SIT_WORDES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Sit. Tarefas Desenv.',
       'Situao das Tarefas Desenvolvimento',
       '',
       'SituacaoTarefas(spt.codfil,spt.sequen,1)',
       '' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '05',
       20,
       255,
       'SIT_WORSUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Sit. Tarefas Sup.',
       'Situao das Tarefas Suporte',
       '',
       'SituacaoTarefas(spt.codfil,spt.sequen,2)',
       '' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '99',
       330,
       1,
       'TIPACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Aceito via',
       'Aceito Via',
       '',
       'TIPACT',
       'T' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '99',
       340,
       1,
       'TIPCWS',
       'A',
       'DCWS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCWS.DESCWS',
       'A',
       '',
       'F',
       'A',
       'F',
       'WorkFlow Suporte',
       'WorkFlow Suporte',
       'DCWS.TIPCWS = SPT.TIPCWS',
       'TIPCWS',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '99',
       350,
       1,
       'TIPREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Forma Registro',
       'Forma Registro',
       '',
       'TIPREG',
       'T' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '99',
       360,
       5,
       'TIPSUP',
       'S',
       'DCWS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCWS.DESCWS',
       'V',
       '',
       '',
       'A',
       'F',
       'Tipo Suporte',
       'Tipo Suporte',
       'SPT.TIPSUP = DCWS.CODTAB AND SPT.TIPCWS = DCWS.TIPCWS',
       'TIPSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '99',
       90,
       4,
       'VERSAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Verso',
       'Verso',
       '',
       'VERSAO',
       'F' FROM DUAL
UNION ALL
SELECT 'SPT ',
       '05',
       30,
       30,
       'VER_WORCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Verso Tarefas',
       'Verso das Tarefas',
       '',
       'SituacaoTarefas(spt.codfil,spt.sequen,3)',
       '' FROM DUAL
);

/*-- SEQ 9347 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'SPT ',
       'FLGACT',
       0,
       'F',
       'Rejeitado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'FLGACT',
       0,
       'T',
       'Aprovado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'FLGCOB',
       0,
       'A',
       'Faturar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'FLGCOB',
       0,
       'C',
       'Contrato',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'FLGCOB',
       0,
       'F',
       'Faturado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'FLGCOB',
       0,
       'G',
       'Garantia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'FLGCOB',
       0,
       'S',
       'Cortesia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'PERFIL',
       0,
       'C',
       'Cobrana',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'PERFIL',
       0,
       'E',
       'Entrega de Mercadoria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'PERFIL',
       0,
       'M',
       'Montagem de Mercadoria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'PERFIL',
       0,
       'P',
       'Ps-venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'PERFIL',
       0,
       'R',
       'Remessa de Mercadoria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'PERFIL',
       0,
       'V',
       'Venda. Cliente Leva Mercadoria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'PERFIL',
       0,
       'X',
       'Prospeco',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'PRICLI',
       0,
       '0',
       'Urgente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'PRICLI',
       0,
       '1',
       'Alta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'PRICLI',
       0,
       '2',
       'Mdia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'PRICLI',
       0,
       '3',
       'Baixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'SITUAC',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'SITUAC',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'SITUAC',
       0,
       'E',
       'Espera',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'SITUAC',
       0,
       'N',
       'Nao Lido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'SITUAC',
       0,
       'R',
       'Resolvido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'TIPACT',
       0,
       'A',
       'Automtico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'TIPACT',
       0,
       'C',
       'Carta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'TIPACT',
       0,
       'E',
       'Email',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'TIPACT',
       0,
       'F',
       'Fax',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'TIPACT',
       0,
       'M',
       'Mensagem instantanea',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'TIPACT',
       0,
       'S',
       'Site',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'TIPACT',
       0,
       'T',
       'Telefone',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'TIPACT',
       0,
       'V',
       'Verbal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'TIPREG',
       0,
       'C',
       'Carta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'TIPREG',
       0,
       'E',
       'Email',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'TIPREG',
       0,
       'F',
       'Fax',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'TIPREG',
       0,
       'M',
       'Mensagem Instantneas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'TIPREG',
       0,
       'S',
       'Site',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'TIPREG',
       0,
       'T',
       'Telefone',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SPT ',
       'TIPREG',
       0,
       'V',
       'Verbal',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9348 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'SQL ',
       TO_NUMBER(null),
       'SQL ',
       'BI_SQL(Estrutura)',
       'TT_SQL',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'SQL.NUMSEQ',
       '' FROM DUAL
);

/*-- SEQ 9349 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'SQL ','--','' FROM DUAL
);

/*-- SEQ 9350 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5875,
       'ARQ ',
       'SQL ',
       'N ',
       '1 ',
       '',
       '',
       'ARQ.CODTAB = SQL.CODDES AND
ARQ.CODTAB = SQL.CODORI',
       '' FROM DUAL
);

/*-- SEQ 9351 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'SQL ',
       '--',
       4,
       4,
       'CODDES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       'Cdigo Destino',
       'Cdigo Destino',
       '',
       'CODDES',
       'F' FROM DUAL
UNION ALL
SELECT 'SQL ',
       '--',
       2,
       4,
       'CODORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Origem',
       'Cdigo Origem',
       '',
       'CODORI',
       'F' FROM DUAL
UNION ALL
SELECT 'SQL ',
       '--',
       8,
       255,
       'FILTRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Filtro',
       '',
       'FILTRO',
       'F' FROM DUAL
UNION ALL
SELECT 'SQL ',
       '--',
       1,
       10,
       'NUMSEQ',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero Sequenciador',
       'Nmero Sequenciador',
       '',
       'NUMSEQ',
       'F' FROM DUAL
UNION ALL
SELECT 'SQL ',
       '--',
       9,
       255,
       'PROPOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Proporo',
       'Proporo',
       '',
       'PROPOR',
       'F' FROM DUAL
UNION ALL
SELECT 'SQL ',
       '--',
       5,
       2,
       'RELDES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Relao Destino',
       'Relao Destino',
       '',
       'RELDES',
       'F' FROM DUAL
UNION ALL
SELECT 'SQL ',
       '--',
       6,
       4,
       'RELNXN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Relao N x N',
       'Relao N x N',
       '',
       'RELNXN',
       'F' FROM DUAL
UNION ALL
SELECT 'SQL ',
       '--',
       3,
       2,
       'RELORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Relao Origem',
       'Relao Origem',
       '',
       'RELORI',
       'F' FROM DUAL
UNION ALL
SELECT 'SQL ',
       '--',
       19,
       4000,
       'REL_ON',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Relao o x N',
       'Relao 0 x N',
       '',
       'REL_ON',
       'F' FROM DUAL
UNION ALL
SELECT 'SQL ',
       '--',
       39,
       4000,
       'SQLOUT2',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'SQL2',
       'SQL2',
       '',
       'SQLOUT2',
       'F' FROM DUAL
);

/*-- SEQ 9352 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'SRV ',
       TO_NUMBER(null),
       'SRV ',
       'Lista de Servios',
       'TT_SRV',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'SRV.CODSRV',
       '' FROM DUAL
);

/*-- SEQ 9353 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'SRV ','--','' FROM DUAL
UNION ALL
SELECT 'SRV ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'SRV ','99','Outros' FROM DUAL
);

/*-- SEQ 9354 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'SRV ',
       '--',
       10,
       4,
       'CODSRV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo',
       'Cdigo do Servio',
       '',
       'CODSRV',
       'F' FROM DUAL
UNION ALL
SELECT 'SRV ',
       '--',
       20,
       4000,
       'DESSRV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio do Servio',
       '',
       'RTF2TXT(DESSRV)',
       'F' FROM DUAL
UNION ALL
SELECT 'SRV ',
       '--',
       30,
       1,
       'NIVSRV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nvel',
       'Nvel do Servio',
       '',
       'NIVSRV',
       'F' FROM DUAL
UNION ALL
SELECT 'SRV ',
       '--',
       40,
       1,
       'SRVATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Ativo?',
       'Ativo?',
       '',
       'SRVATI',
       'F' FROM DUAL
);

/*-- SEQ 9355 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'STO ',
       TO_NUMBER(null),
       'STO ',
       'Storage',
       'TT_STO',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'STO.NOMOBJ',
       '' FROM DUAL
);

/*-- SEQ 9356 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'STO ','--','' FROM DUAL
UNION ALL
SELECT 'STO ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'STO ','99','Outros' FROM DUAL
);

/*-- SEQ 9357 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'STO ',
       '01',
       10,
       14,
       'AVGLIN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Mdia de Linha',
       'Mdia de Linha',
       '',
       'AVGLIN',
       'F' FROM DUAL
UNION ALL
SELECT 'STO ',
       '01',
       20,
       1,
       'CACHE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Cache?',
       'Cache?',
       '',
       'CACHE',
       'F' FROM DUAL
UNION ALL
SELECT 'STO ',
       '01',
       30,
       10,
       'LINCAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Linha Calculada',
       'Linha Calculada',
       '',
       'LINCAL',
       'F' FROM DUAL
UNION ALL
SELECT 'STO ',
       '01',
       40,
       1,
       'NIVOBJ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nvel do Objeto',
       'Nvel do Objeto',
       '',
       'NIVOBJ',
       'F' FROM DUAL
UNION ALL
SELECT 'STO ',
       '01',
       50,
       20,
       'NOMOBJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Objeto',
       'Nome Objeto',
       '',
       'NOMOBJ',
       'F' FROM DUAL
UNION ALL
SELECT 'STO ',
       '01',
       60,
       20,
       'OBJPAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Objeto Pai',
       'Objeto Pai',
       '',
       'OBJPAI',
       'F' FROM DUAL
UNION ALL
SELECT 'STO ',
       '01',
       70,
       20,
       'OBJSEC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Objeto Secundrio',
       'Objeto Secundrio',
       '',
       'OBJSEC',
       'F' FROM DUAL
UNION ALL
SELECT 'STO ',
       '01',
       80,
       12,
       'QTDLIN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade Linha',
       'Quantidade Linha',
       '',
       'QTDLIN',
       'F' FROM DUAL
UNION ALL
SELECT 'STO ',
       '01',
       90,
       15,
       'QTDTAM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Quantidade Tamanho',
       'Quantidade Tamanho',
       '',
       'QTDTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'STO ',
       '01',
       100,
       10,
       'RELPAI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Relatrio Pai',
       'Relatrio Pai',
       '',
       'RELPAI',
       'F' FROM DUAL
UNION ALL
SELECT 'STO ',
       '01',
       110,
       10,
       'RELSEC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Relatrio Secundrio',
       'Relatrio Secundrio',
       '',
       'RELSEC',
       'F' FROM DUAL
);

/*-- SEQ 9358 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'SUB ',
       0,
       'SUB ',
       'Sub-Diviso',
       'TT_SUB',
       'T',
       '',
       'TOTALL',
       'TOTALLW = 7.2 / LITE = 3.2 / T2000 = 0.02',
       '{ARQ}',
       '',
       '',
       '',
       'F',
       '',
       'SUB.CODITE',
       '' FROM DUAL
);

/*-- SEQ 9359 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'SUB ','--','' FROM DUAL
UNION ALL
SELECT 'SUB ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'SUB ','99','Outras' FROM DUAL
);

/*-- SEQ 9360 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'SUB ',
       '01',
       5,
       2,
       'CODITE',
       'S',
       '',
       0,
       0,
       'SUB ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'SUB',
       'F',
       '',
       'F',
       'Cd. Item Sub-Div.',
       'Cdigo deste item da sub-diviso',
       '',
       'CODITE',
       'F' FROM DUAL
UNION ALL
SELECT 'SUB ',
       '01',
       10,
       2,
       'CODSUB',
       'S',
       'DSUB',
       0,
       0,
       'SUB ',
       20,
       TO_NUMBER(null),
       '',
       'DSUB.NOMSUB',
       'V',
       'SUB',
       'F',
       'A',
       'F',
       'Cd. Sub-Diviso',
       'Cdigo da Sub-Diviso',
       'SUB.CODSUB = DSUB.CODTAB (+)',
       'CODSUB',
       'T' FROM DUAL
UNION ALL
SELECT 'SUB ',
       '01',
       40,
       14,
       'FATCON',
       'F',
       '',
       4,
       0,
       'SUB ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'SUB',
       'T',
       '',
       'F',
       'Fator Converso',
       'Fator de converso entre as divises',
       '',
       'FATCON',
       'F' FROM DUAL
UNION ALL
SELECT 'SUB ',
       '01',
       6,
       20,
       'NOMEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Externo',
       'Nome Externo',
       '',
       'NOMEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'SUB ',
       '01',
       30,
       10,
       'NOMITE',
       'A',
       '',
       0,
       0,
       'SUB ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SUB',
       'F',
       'A',
       'F',
       'Nome do Item',
       'Nome do item',
       '',
       'NOMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'SUB ',
       '01',
       50,
       2,
       'ORDSUB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'SUB ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Ordem Aprese.Sub.Div',
       'Ordem de apresentao das sub-divises',
       '',
       'ORDSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'SUB ',
       '01',
       70,
       2,
       'QTDPHO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'QTDE Fotos',
       'Quantidade de Fotos',
       '',
       'QTDPHO',
       'F' FROM DUAL
UNION ALL
SELECT 'SUB ',
       '01',
       60,
       2,
       'TAMPHO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tamanho da Foto',
       'Tamanho da Foto',
       '',
       'TAMPHO',
       'F' FROM DUAL
);

/*-- SEQ 9361 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'SUP ',
       0,
       'SUP ',
       'Superior',
       'TT_USU',
       'T',
       '',
       'TOTALL',
       'Superiores',
       '',
       '',
       '',
       '',
       'F',
       '',
       'SUP.FILUSU,SUP.CODUSU
SUP.CODEXT
SUP.NUMUSU
SUP.APEUSU',
       '' FROM DUAL
);

/*-- SEQ 9362 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'SUP ','--','' FROM DUAL
UNION ALL
SELECT 'SUP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'SUP ','02','Datas' FROM DUAL
UNION ALL
SELECT 'SUP ','03','Valores' FROM DUAL
UNION ALL
SELECT 'SUP ','99','Outros' FROM DUAL
);

/*-- SEQ 9363 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 30207,
       'ORC ',
       'SUP ',
       '1',
       '1',
       '',
       '',
       'SUP.FILORC = ORC.CODFIL AND
SUP.TIPORC = ORC.TIPPED AND
SUP.NUMORC = ORC.NUMPED',
       '',
       '' FROM DUAL
);

/*-- SEQ 9364 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'SUP ',
       '99',
       90,
       1,
       'AGENDB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Acesso ao Agendador?',
       'Acesso ao Agendador?',
       '',
       'AGENDB',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       60,
       10,
       'APEUSU',
       'A',
       '',
       0,
       0,
       'SUP ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'SUP',
       'F',
       'A',
       'T',
       'Apelido',
       'Apelido do Superior',
       '',
       'APEUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       361,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN SUP.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '02',
       100,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       480,
       1,
       'CFGINI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Configura INI?',
       'Configura INI?',
       '',
       'CFGINI',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       25,
       6,
       'CHAVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Superior',
       'Cdigo do Superior',
       '',
       'FILUSU||SUP.CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       110,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '03',
       120,
       5,
       'CODCTR',
       'S',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       'F',
       'N',
       'F',
       'Unidade de Negcios',
       'Unidade de Negcios',
       'DCTR.CODTAB = SUP.CODCTR',
       'CODCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       30,
       10,
       'CODEXT',
       'A',
       '',
       0,
       0,
       'SUP ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'SUP',
       'F',
       'A',
       'T',
       'Cdigo Externo',
       'Cdigo externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       490,
       3,
       'CODINI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo INI',
       'Cdigo INI',
       '',
       'CODINI',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       600,
       40,
       'CODPOS_USU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo POS CONTROLE',
       'Cdigo POS CONTROLE',
       '',
       'CODPOS_USU',
       '' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       430,
       5,
       'CODSET',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Setor',
       'Cdigo Setor',
       '',
       'CODSET',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       130,
       3,
       'CODSUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo Usu.Superior',
       'Cdigo usurio superior',
       '',
       'CODSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       20,
       3,
       'CODUSU',
       'A',
       '',
       0,
       0,
       'SUP ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'SUP',
       'F',
       '9',
       'T',
       'Cdigo',
       'Cdigo do Superior',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       500,
       1,
       'COMIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Comunica.~Impressora',
       'Comunicao com impressora ',
       '',
       'COMIMP',
       'T' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '02',
       560,
       19,
       'DATLIM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       '',
       'Prazo Limite Chamado',
       'Prazo Limite Fechamento',
       '',
       'DATAFECHAMENTOCHAMADO(CODFIL,SEQUEN,CODPRI,CODFIL)',
       '' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       140,
       1,
       'EDINDB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Editar Formatos?',
       'Editar Formatos?',
       '',
       'EDINDB',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       150,
       40,
       'E_MAIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail',
       'E-mail',
       '',
       'E_MAIL',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       450,
       1,
       'FAZENQ',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Faz Enquete?',
       'Faz Enquete?',
       '',
       'FAZENQ',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       460,
       1,
       'FAZMON',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Faz Montagem?',
       'Faz Montagem?',
       '',
       'FAZMON',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       40,
       3,
       'FILATV',
       'A',
       '',
       0,
       0,
       'SUP ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'SUP',
       'F',
       'N',
       'T',
       'Alocado em',
       'Filial onde est alocado',
       '',
       'FILATV',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       160,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial de origem do usurio como parceiro',
       '',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       510,
       3,
       'FILINI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial INI',
       'Filial INI',
       '',
       'FILINI',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       440,
       3,
       'FILORC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Filial do Pedido',
       'Filial do Pedido',
       '',
       'FILORC',
       '' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       170,
       3,
       'FILSUP',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial Usu.Superior',
       'Filial usurio superior',
       'SUP.FILSUP = DFIL.CODFIL (+)',
       'FILSUP',
       'T' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       10,
       3,
       'FILUSU',
       'A',
       '',
       0,
       0,
       'SUP ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'SUP',
       'F',
       'N',
       'T',
       '',
       'Filial do Superior',
       '',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       470,
       30,
       'FUNCAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Funo',
       'Funo',
       '',
       'FUNCAO',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       180,
       4000,
       'GRUPOS',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Grupos(Uso futuro)',
       'Grupos(Uso futuro)',
       '',
       'RTF2TXT(GRUPOS)',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       190,
       4,
       'HORDOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horrio Domingo',
       'Horrio Domingo',
       '',
       'HORDOM',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       200,
       4,
       'HORQUA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horrio Quarta',
       'Horrio Quarta',
       '',
       'HORQUA',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       210,
       4,
       'HORQUI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horrio Quinta',
       'Horrio Quinta',
       '',
       'HORQUI',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       220,
       4,
       'HORSAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horrio Sbado',
       'Horrio Sbado',
       '',
       'HORSAB',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       230,
       4,
       'HORSEG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horrio Segunda',
       'Horrio Segunda',
       '',
       'HORSEG',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       240,
       4,
       'HORSEX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horrio Sexta',
       'Horrio Sexta',
       '',
       'HORSEX',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       250,
       4,
       'HORTER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horrio Tera',
       'Horrio Tera',
       '',
       'HORTER',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '03',
       440,
       6,
       'INDPRO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'ndice Produtividade',
       'ndice Produtividade',
       '',
       'INDPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '03',
       260,
       14,
       'LIMCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Limite de Compras',
       'Limite de Compras',
       '',
       'LIMCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '02',
       270,
       2,
       'MAIDAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Maior Dia/Data',
       'Maior data possvel de uso em relao ao dia de hoje',
       '',
       'MAIDAT',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '02',
       280,
       5,
       'MAXDAT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Mx.dias aps venc.',
       'Mx. dias p/ aceitar baixa parcelas/lanamentos avulsos aps vencimento',
       '',
       'MAXDAT',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '02',
       290,
       2,
       'MENDAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Menor Dia/Data',
       'Menor data possvel de uso em relao ao dia de hoje',
       '',
       'MENDAT',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '02',
       300,
       5,
       'MINDAT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Min.dias antes venc.',
       'Min. dias p/ aceitar baixa parcelas/lanamentos avulsos aps vencimento',
       '',
       'MINDAT',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       70,
       2,
       'NIVUSU',
       'S',
       '',
       0,
       15,
       'SUP ',
       80,
       30,
       '',
       '',
       'D',
       'SUP',
       'F',
       'A',
       'T',
       'Nvel',
       'Nvel do Superior',
       '',
       'NIVUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       50,
       30,
       'NOMUSU',
       'A',
       '',
       0,
       0,
       'SUP ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'SUP',
       'F',
       'A',
       'T',
       'Nome',
       'Nome do Superior',
       '',
       'NOMUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       460,
       8,
       'NUMORC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       '',
       'Nmero do Pedido',
       'Nmero do Pedido',
       '',
       'NUMORC',
       '' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       520,
       3,
       'NUMPAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero do Palm',
       'Nmero do Palm',
       '',
       'NUMPAL',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       310,
       255,
       'PATNDB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path Consultas',
       'Path Consultas NetData',
       '',
       'PATNDB',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '03',
       80,
       8,
       'PERCOM',
       'F',
       '',
       2,
       0,
       'SUP ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'SUP',
       'T',
       '9',
       'T',
       '% Comisso',
       'Percentagem de comisso do Superior',
       '',
       'PERCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       320,
       1000,
       'PERMIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Lista de Permisses',
       'Lista das permisses',
       '',
       'PERMISSOESUSUARIO(FILUSU,CODUSU)',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '03',
       330,
       5,
       'PESO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Peso',
       'Peso',
       '',
       'PESO',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       590,
       6,
       'PRZPAG_MAX',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Prazo mdio mx. pag',
       'Prazo mdio mximo a pagar',
       '',
       'PRZPAG_MAX',
       '' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       580,
       6,
       'PRZPAG_MIN',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Prazo mdio mn. pag',
       'Prazo mdio mnimo a pagar',
       '',
       'PRZPAG_MIN',
       '' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       340,
       20,
       'SENHA1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Senha usu cripto 1',
       'Senha do usurio - criptografia 1',
       '',
       'SENHA1',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       350,
       20,
       'SENHA2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Senha usu cripto 2',
       'Senha do usurio - criptografia 2',
       '',
       'SENHA2',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       360,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN SUP.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       570,
       8,
       'SUPMAX',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Desc Max Superv',
       '% Desconto Mximo Permitido para Supervisor',
       '',
       'SUPMAX',
       '' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       370,
       15,
       'TABATU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Tabela Atual',
       'Tabela Atual',
       '',
       'TABATU',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       450,
       1,
       'TIPORC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Tipo do Pedido',
       'Tipo do Pedido',
       '',
       'TIPORC',
       '' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       380,
       1,
       'USANDB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'UsarTotaliBI Browser',
       'Usar Totali BI Browser?',
       '',
       'USANDB',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       390,
       1,
       'USANDC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'UsarTotaliBI Config?',
       'Usar Totali BI Config?',
       '',
       'USANDC',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       530,
       1,
       'USUCOB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usurio~Cobrador?',
       'Usurio~Cobrador?',
       '',
       'USUCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       540,
       7,
       'VALSEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Validade da senha',
       'Validade da senha',
       '',
       'VALSEN',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       400,
       100,
       'VISPER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Viso da Permisso',
       'Viso da Permisso',
       '',
       'VISPER',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       410,
       9,
       'VISSE1',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Senha1(Lite)',
       'Senha1(Lite)',
       '',
       'VISSE1',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '99',
       420,
       9,
       'VISSE2',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Senha2(Lite)',
       'Senha2(Lite)',
       '',
       'VISSE2',
       'F' FROM DUAL
UNION ALL
SELECT 'SUP ',
       '01',
       550,
       1,
       'VISWOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'ltima~Visualizao',
       'ltima~Visualizao',
       '',
       'VISWOR',
       'T' FROM DUAL
);

/*-- SEQ 9365 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'SUP ',
       'COMIMP',
       0,
       '0',
       'No Tem',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SUP ',
       'COMIMP',
       0,
       '1',
       'InfraVermelho',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SUP ',
       'COMIMP',
       0,
       '2',
       'Serial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SUP ',
       'NIVUSU',
       0,
       '-',
       'Administrador',
       214,
       ' ' FROM DUAL
UNION ALL
SELECT 'SUP ',
       'NIVUSU',
       1,
       '-',
       'Operador',
       215,
       ' ' FROM DUAL
UNION ALL
SELECT 'SUP ',
       'NIVUSU',
       2,
       '-',
       'Vendedor',
       216,
       ' ' FROM DUAL
UNION ALL
SELECT 'SUP ',
       'NIVUSU',
       3,
       '-',
       'Guia',
       217,
       ' ' FROM DUAL
UNION ALL
SELECT 'SUP ',
       'VISWOR',
       0,
       'D',
       'Desenvolvimento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'SUP ',
       'VISWOR',
       0,
       'I',
       'Implantao',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9366 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'SXW ',
       TO_NUMBER(null),
       'SXW ',
       'Suporte x WorkFlow',
       'TT_SUPXWOR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'SXW.FILSUP,SXW.SEQSUP,SXW.FILWOR,SXW.SEQWOR',
       '' FROM DUAL
);

/*-- SEQ 9367 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'SXW ','--','' FROM DUAL
UNION ALL
SELECT 'SXW ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'SXW ','99','Outros' FROM DUAL
);

/*-- SEQ 9368 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'SXW ',
       '01',
       10,
       3,
       'FILSUP',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Suporte',
       'DFIL.CODFIL = SXW.FILSUP',
       'FILSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'SXW ',
       '01',
       20,
       3,
       'FILWOR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Work Flow',
       'DFIL.CODFIL = SXW.FILWOR',
       'FILWOR',
       'F' FROM DUAL
UNION ALL
SELECT 'SXW ',
       '01',
       30,
       10,
       'SEQSUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Suporte',
       '',
       'SEQSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'SXW ',
       '01',
       40,
       10,
       'SEQWOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Seq. WorkFlow',
       '',
       'SEQWOR',
       'F' FROM DUAL
);

/*-- SEQ 9369 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TAR ',
       TO_NUMBER(null),
       'TAR ',
       'BI_Agenda',
       'TT_TAR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'TAR.CODFIL,TAR.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9370 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TAR ','--','' FROM DUAL
UNION ALL
SELECT 'TAR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TAR ','02','Datas' FROM DUAL
UNION ALL
SELECT 'TAR ','03','Valores' FROM DUAL
UNION ALL
SELECT 'TAR ','99','Outros' FROM DUAL
);

/*-- SEQ 9371 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 5881,
       'USU ',
       'TAR ',
       '1',
       '1',
       '',
       '',
       'USU.FILUSU = TAR.FILUSU AND
USU.CODUSU = TAR.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 9372 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TAR ',
       '03',
       6,
       1,
       'AGENDA',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Agenda',
       'Agenda',
       '',
       'AGENDA',
       'T' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '01',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = TAR.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '01',
       48,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Usurio',
       'Cdigo Usurio',
       'USU2.FILUSU(+) = TAR.FILUSU AND USU2.CODUSU(+) = TAR.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '99',
       58,
       1,
       'CONSUL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Consulta?',
       'Consulta',
       '',
       'CONSUL',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       9,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data/Hora',
       'Data/Hora',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       8,
       7,
       'DATMAX',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Mxima',
       'Data Mxima',
       '',
       'DATMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '99',
       68,
       1,
       'DECISO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Deciso do Cubo?',
       'Deciso do Cubo',
       '',
       'DECISO',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       18,
       2,
       'DIAMES',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dia do Ms',
       'Dia do Ms',
       '',
       'DIAMES',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       20,
       1,
       'DIASEM',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dia da Semana',
       'Dia da Semana',
       '',
       'DIASEM',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       17,
       1,
       'DOMFEI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Domingo?',
       'Domingo?',
       '',
       'DOMFEI',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '99',
       78,
       40,
       'EMAERR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail do Erro',
       'E-mail do Erro',
       '',
       'EMAERR',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '99',
       88,
       1,
       'EXPSAC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Exportao SAC?',
       'Exportao SAC',
       '',
       'EXPSAC',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '01',
       37,
       4000,
       'E_MAIL',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail',
       'E-mail',
       '',
       'RTF2TXT(E_MAIL)',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '01',
       98,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '03',
       10,
       1,
       'FLGEST',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '99',
       3,
       1,
       'FORMAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Formato do E-mail',
       'Formato do E-mail',
       '',
       'FORMAI',
       'T' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '99',
       4,
       1,
       'FORSAL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Salvar no Formato',
       'Salvar no Formato',
       '',
       'FORSAL',
       'T' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '99',
       118,
       255,
       'IMPRIM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Impresso',
       'Impresso',
       '',
       'IMPRIM',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '01',
       128,
       1,
       'LNKANX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Link Anexo',
       'Link Anexo',
       '',
       'LNKANX',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       24,
       1,
       'MESABR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ms de Abril?',
       'Ms de Abril',
       '',
       'MESABR',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       28,
       1,
       'MESAGO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ms de Agosto?',
       'Ms de Agosto',
       '',
       'MESAGO',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       32,
       1,
       'MESDEZ',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ms de Dezembro?',
       'Ms de Dezembro',
       '',
       'MESDEZ',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       22,
       1,
       'MESFEV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ms de Fevereiro?',
       'Ms de Fevereiro',
       '',
       'MESFEV',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       21,
       1,
       'MESJAN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ms de Janeiro?',
       'Ms de Janeiro',
       '',
       'MESJAN',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       27,
       1,
       'MESJUL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ms de Julho?',
       'Ms de Julho',
       '',
       'MESJUL',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       26,
       1,
       'MESJUN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ms de Junho?',
       'Ms de Junho',
       '',
       'MESJUN',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       25,
       1,
       'MESMAI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ms de Maio?',
       'Ms de Maio',
       '',
       'MESMAI',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       23,
       1,
       'MESMAR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ms de Maro?',
       'Ms de Maro',
       '',
       'MESMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       31,
       1,
       'MESNOV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ms de Novembro?',
       'Ms de Novembro',
       '',
       'MESNOV',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       30,
       1,
       'MESOUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ms de Outubro?',
       'Ms de Outubro',
       '',
       'MESOUT',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       29,
       1,
       'MESSET',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ms de Setembro?',
       'Ms de Setembro',
       '',
       'MESSET',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '01',
       34,
       255,
       'NOMCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Consulta',
       'Nome Consulta',
       '',
       'NOMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '03',
       5,
       3,
       'NUMCOP',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero de Cpias',
       'Nmero de Cpias',
       '',
       'NUMCOP',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       13,
       1,
       'QUAFEI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Quarta-Feira?',
       'Quarta-Feira',
       '',
       'QUAFEI',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       14,
       1,
       'QUIFEI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Quinta-Feira?',
       'Quinta-Feira',
       '',
       'QUIFEI',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '03',
       7,
       3,
       'REPETE',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Repete',
       'Repete',
       '',
       'REPETE',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       16,
       1,
       'SABFEI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Sbado?',
       'Sbado',
       '',
       'SABFEI',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '99',
       35,
       255,
       'SALVAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Salvar Em',
       'Salvar Em',
       '',
       'SALVAR',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       11,
       1,
       'SEGFEI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Segunda-Feira?',
       'Segunda-Feira',
       '',
       'SEGFEI',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       19,
       1,
       'SEMANA',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Semana',
       'Semana',
       '',
       'SEMANA',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '01',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       15,
       1,
       'SEXFEI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Sexta-Feira?',
       'Sexta-Feira',
       '',
       'SEXFEI',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       12,
       1,
       'TERFEI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tera-Feira?',
       'Tera-Feira',
       '',
       'TERFEI',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '02',
       38,
       1,
       'TIPMES',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tipo do Ms',
       'Tipo do Ms',
       '',
       'TIPMES',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '01',
       33,
       255,
       'TITTAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo da Tarefa',
       'Ttulo da Tarefa',
       '',
       'TITTAR',
       'F' FROM DUAL
UNION ALL
SELECT 'TAR ',
       '99',
       108,
       4000,
       'TXTMAI',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Texto do E-mail',
       'Texto do E-mail',
       '',
       'TXTMAI',
       'F' FROM DUAL
);

/*-- SEQ 9373 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'TAR ',
       'AGENDA',
       0,
       ' ',
       'Ficha Diria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'AGENDA',
       1,
       ' ',
       'Ficha Semanal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'AGENDA',
       2,
       ' ',
       'Ficha Mensal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FLGEST',
       0,
       ' ',
       'Ativa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FLGEST',
       1,
       ' ',
       'Suspensa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORMAI',
       0,
       '1',
       'Enhanced Metafile (*.EMF)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORMAI',
       0,
       '2',
       'Windows Metafile (*.WMF)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORMAI',
       0,
       'A',
       'Acrobat (*.PDF)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORMAI',
       0,
       'B',
       'Windows Bitmap (*.BMP)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORMAI',
       0,
       'D',
       'Dbase (*.DBF)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORMAI',
       0,
       'E',
       'Excel (*.XLS)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORMAI',
       0,
       'G',
       'Gif Image File (*.GIF)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORMAI',
       0,
       'J',
       'JPEG (*.JPEG)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORMAI',
       0,
       'N',
       'NetData Viewer (*.NDD)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORMAI',
       0,
       'P',
       'Paradox (*.DB)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORMAI',
       0,
       'R',
       'Rich Text (*.RTF)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORMAI',
       0,
       'T',
       'Texto (*.TXT)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORMAI',
       0,
       'W',
       'Pagina Web (*.HTM)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORSAL',
       0,
       '1',
       'Enhanced Metafile (*.EMF)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORSAL',
       0,
       '2',
       'Windows Metafile (*.WMF)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORSAL',
       0,
       'A',
       'Acrobat (*.PDF)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORSAL',
       0,
       'B',
       'Windows Bitmap (*.BMP)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORSAL',
       0,
       'D',
       'Dbase (*.DBF)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORSAL',
       0,
       'E',
       'Excel (*.XLS)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORSAL',
       0,
       'G',
       'Gif Image File (*.GIF)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORSAL',
       0,
       'J',
       'JPEG (*.JPEG)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORSAL',
       0,
       'N',
       'NetData Viewer (*.NDD)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORSAL',
       0,
       'P',
       'Paradox (*.DB)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORSAL',
       0,
       'R',
       'Rich Text (*.RTF)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORSAL',
       0,
       'T',
       'Texto (*.TXT)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TAR ',
       'FORSAL',
       0,
       'W',
       'Pagina Web (*.HTM)',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9374 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TAXU',
       TO_NUMBER(null),
       'TAXU',
       'Agenda x Usurios',
       'TT_AGEXUSU',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'TAXU.CODFIL,TAXU.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9375 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TAXU','--','' FROM DUAL
UNION ALL
SELECT 'TAXU','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TAXU','99','Outros' FROM DUAL
);

/*-- SEQ 9376 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5883,
       'AGE ',
       'TAXU',
       '1 ',
       'N ',
       '',
       '',
       'AGE.CODFIL = TAXU.FILAGE AND
AGE.SEQUEN = TAXU.SEQAGE',
       '' FROM DUAL
UNION ALL
SELECT 5884,
       'PAP ',
       'TAXU',
       '1 ',
       'N ',
       '',
       '',
       'PAP.CODFIL = TAXU.FILPAP AND
PAP.SEQUEN = TAXU.SEQPAP',
       '' FROM DUAL
UNION ALL
SELECT 5885,
       'USU ',
       'TAXU',
       '1 ',
       'N ',
       '',
       '',
       'USU.FILUSU = TAXU.FILUSU AND
USU.CODUSU = TAXU.CODUSU',
       '' FROM DUAL
);

/*-- SEQ 9377 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TAXU',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = TAXU.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'TAXU',
       '--',
       20,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'TAXU.FILUSU = USU.FILUSU(+)  AND TAXU.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'TAXU',
       '--',
       30,
       3,
       'FILAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Agenda',
       'Filial Agenda',
       '',
       'FILAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'TAXU',
       '--',
       40,
       3,
       'FILPAP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Contas a Pagar',
       '',
       'FILPAP',
       'F' FROM DUAL
UNION ALL
SELECT 'TAXU',
       '--',
       50,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'TAXU',
       '--',
       60,
       10,
       'SEQAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Agenda',
       '',
       'SEQAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'TAXU',
       '--',
       70,
       10,
       'SEQPAP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Contas a Pagar',
       '',
       'SEQPAP',
       'F' FROM DUAL
UNION ALL
SELECT 'TAXU',
       '--',
       80,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 9378 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TCID',
       TO_NUMBER(null),
       'TCID',
       'Doenas Existentes',
       'TT_CID',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'TCID.CODCID',
       '' FROM DUAL
);

/*-- SEQ 9379 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TCID','--','' FROM DUAL
UNION ALL
SELECT 'TCID','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TCID','99','Outros' FROM DUAL
);

/*-- SEQ 9380 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TCID',
       '--',
       10,
       8,
       'CODCID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'CID(Cd.Int.Doena)',
       'Codigo Internacional de Doenas',
       '',
       'CODCID',
       'F' FROM DUAL
UNION ALL
SELECT 'TCID',
       '--',
       20,
       300,
       'DESCID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Doena',
       'Descrio da doena',
       '',
       'DESCID',
       'F' FROM DUAL
);

/*-- SEQ 9381 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TCMS',
       TO_NUMBER(null),
       'TCMS',
       'Comisses por Pedido',
       'TT_CMS',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'TCMS.CODFIL,TCMS.TIPPED,TCMS.NUMPED',
       '' FROM DUAL
);

/*-- SEQ 9382 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TCMS','--','' FROM DUAL
UNION ALL
SELECT 'TCMS','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TCMS','99','Outros' FROM DUAL
);

/*-- SEQ 9383 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5889,
       'USU ',
       'TCMS',
       '1 ',
       '1 ',
       '',
       '',
       'USU.FILUSU = TCMS.FILVDD AND
USU.CODUSU = TCMS.CODVDD',
       '' FROM DUAL
);

/*-- SEQ 9384 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TCMS',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'TCMS.CODFIL = DFIL.CODFIL(+)',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'TCMS',
       '01',
       20,
       3,
       'CODVDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Vendas',
       'Cdigo Vendas Identificadas',
       '',
       'CODVDD',
       'F' FROM DUAL
UNION ALL
SELECT 'TCMS',
       '01',
       30,
       3,
       'FILVDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Vendas Identificadas',
       '',
       'FILVDD',
       'F' FROM DUAL
UNION ALL
SELECT 'TCMS',
       '01',
       40,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero do Pedido',
       'Nmero do Pedido',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'TCMS',
       '01',
       50,
       3,
       'PERCEN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Percentual Comisso',
       'Percentual Comisso',
       '',
       'PERCEN',
       'F' FROM DUAL
UNION ALL
SELECT 'TCMS',
       '01',
       60,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Pedido',
       'Tipo de Pedido',
       '',
       'TIPPED',
       'T' FROM DUAL
);

/*-- SEQ 9385 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'TCMS',
       'TIPPED',
       0,
       'C',
       'Com Filial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TCMS',
       'TIPPED',
       0,
       'T',
       'No Filial',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9386 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TCP ',
       TO_NUMBER(null),
       'TCP ',
       'Taxa Carto Prazo',
       'TT_TCP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9387 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TCP ','--','' FROM DUAL
UNION ALL
SELECT 'TCP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TCP ','99','Outros' FROM DUAL
);

/*-- SEQ 9388 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TCP ',
       '--',
       40,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Atualizao',
       'Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'TCP ',
       '--',
       10,
       5,
       'CARTAO',
       'S',
       'DCAR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCAR.DESOUT',
       'V',
       '',
       '',
       'A',
       'F',
       'Carto',
       'Carto',
       'DCAR.CODTAB = TCP.CARTAO(+)',
       'CARTAO',
       'T' FROM DUAL
UNION ALL
SELECT 'TCP ',
       '--',
       50,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'TCP ',
       '--',
       20,
       2,
       'NUMPAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nm. Parcela',
       'Nm. Parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'TCP ',
       '--',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'TCP ',
       '--',
       80,
       1,
       'SOBTOD',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       '',
       'Tax. sobre parcelas?',
       'Taxa sobre todas as parcelas?',
       '',
       'SOBTOD',
       '' FROM DUAL
UNION ALL
SELECT 'TCP ',
       '--',
       30,
       12,
       'TAXCAR',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Taxa Carto Crdito',
       'Taxa Carto Crdito',
       '',
       'TAXCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'TCP ',
       '--',
       70,
       12,
       'TAXDEB',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'TaxaCarto Dbito',
       'Taxa Carto Dbito',
       '',
       'TAXDEB',
       'F' FROM DUAL
);

/*-- SEQ 9389 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TCXC',
       TO_NUMBER(null),
       'TCXC',
       'Corresp. X Cobranas',
       'TT_CORXCOB',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9390 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TCXC','--','' FROM DUAL
UNION ALL
SELECT 'TCXC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TCXC','99','Outros' FROM DUAL
);

/*-- SEQ 9391 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 45652,
       'CHR ',
       'TCXC',
       '1',
       'N',
       '',
       '',
       'CHR.CODFIL = TCXC.FILCHR AND
CHR.SEQUEN = TCXC.SEQCHR
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45653,
       'COR ',
       'TCXC',
       '1',
       'N',
       '',
       '',
       'COR.CODFIL = TCXC.FILCOR AND
COR.SEQUEN = TCXC.SEQCOR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45654,
       'REC ',
       'TCXC',
       '1',
       'N',
       '',
       '',
       'REC.SEQUEN = TCXC.SEQREC AND
REC.CODFIL = TCXC.FILREC AND
REC.NUMPAR = TCXC.NUMPAR AND
REC.SUBPAR = TCXC.SUBPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45926,
       'RECP',
       'TCXC',
       '1',
       'N',
       '',
       '',
       'RECP.SEQUEN = TCXC.SEQREC AND
RECP.CODFIL = TCXC.FILREC AND
RECP.NUMPAR = TCXC.NUMPAR AND
RECP.SUBPAR = TCXC.SUBPAR',
       '',
       '' FROM DUAL
);

/*-- SEQ 9392 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TCXC',
       '01',
       10,
       3,
       'FILCHR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Cheques Receb',
       'Filial Cheques Recebidos',
       '',
       'FILCHR',
       'F' FROM DUAL
UNION ALL
SELECT 'TCXC',
       '01',
       20,
       3,
       'FILCOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Correspondnc',
       'Filial Correspondncia',
       '',
       'FILCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'TCXC',
       '01',
       30,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'TCXC',
       '01',
       40,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'TCXC',
       '01',
       50,
       10,
       'SEQCHR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Seq. Cheques a Receber',
       '',
       'SEQCHR',
       'F' FROM DUAL
UNION ALL
SELECT 'TCXC',
       '01',
       60,
       10,
       'SEQCOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Seq. Correspondncia',
       '',
       'SEQCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'TCXC',
       '01',
       70,
       10,
       'SEQREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Seq. Recebimento',
       '',
       'SEQREC',
       'F' FROM DUAL
UNION ALL
SELECT 'TCXC',
       '01',
       80,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       'Sub-Parc.',
       'Nmero da sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
);

/*-- SEQ 9393 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TEC ',
       TO_NUMBER(null),
       'TEC ',
       'Teclas para Terminal',
       'TT_TEC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'TEC.CODFIL,TEC.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9394 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TEC ','--','' FROM DUAL
UNION ALL
SELECT 'TEC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TEC ','99','Outros' FROM DUAL
);

/*-- SEQ 9395 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TEC ',
       '--',
       10,
       3,
       'CARACT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Caracter',
       'Caracter',
       '',
       'CARACT',
       'F' FROM DUAL
UNION ALL
SELECT 'TEC ',
       '--',
       60,
       12,
       'CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cod Cor',
       'Cdigo da Cor',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'TEC ',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'TEC ',
       '--',
       70,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cod Material',
       'Cdigo do Produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'TEC ',
       '--',
       80,
       12,
       'CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cod Tamanho',
       'Cdigo do Tamanho',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'TEC ',
       '--',
       40,
       5,
       'CODTER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Codigo do Terminal',
       'Codigo do Terminal',
       '',
       'CODTER',
       'F' FROM DUAL
UNION ALL
SELECT 'TEC ',
       '--',
       90,
       5,
       'CTRTEC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Unidade de Negocio',
       'Unidade de Negcio',
       '',
       'CTRTEC',
       'F' FROM DUAL
UNION ALL
SELECT 'TEC ',
       '--',
       100,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Produto',
       'Filial do Produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'TEC ',
       '--',
       110,
       3,
       'FILTEC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Teclado',
       'Filial do Teclado',
       '',
       'FILTEC',
       'F' FROM DUAL
UNION ALL
SELECT 'TEC ',
       '--',
       50,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 9396 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TEF ',
       TO_NUMBER(null),
       'TEF ',
       'Carto',
       'TT_TEF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'TEF.CODFIL,TEF.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9397 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TEF ','--','' FROM DUAL
);

/*-- SEQ 9398 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 30216,
       'LID ',
       'TEF ',
       '1',
       'N',
       '',
       '',
       'TEF.CODFIL=LID.CODFIL AND TEF.NUMECF=LID.NUMECF AND TEF.TRN_ID=LID.TRN_ID',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30217,
       'CLI ',
       'TEF ',
       'N',
       '1',
       '',
       '',
       'CLI.FILCLI = TEF.FILCLI and
CLI.CODCLI = TEF.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30218,
       'ITF ',
       'TEF ',
       'N',
       '1',
       '',
       '',
       'TEF.CODFIL = ITF.CODFIL AND
TEF.SEQUEN = ITF.SEQUEN',
       '(case when TEF.VLROPE = 0 then 0 else ITF.VLRITE / TEF.VLROPE end)',
       '' FROM DUAL
);

/*-- SEQ 9399 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TEF ',
       '--',
       57,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '@',
       'F',
       'Atualizado em',
       'Atualizado em',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       77,
       5,
       'CARTAO',
       'S',
       'DCAR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCAR.DESOUT',
       'V',
       '',
       '',
       'A',
       'F',
       'Carto',
       'Carto',
       'DCAR.CODTAB = TEF.CARTAO',
       'CARTAO',
       'F' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       230,
       5,
       'CODBAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cd. Bandeira Padro',
       'Cdigo da Bandeira Padro do SITEF',
       '',
       'CODBAN',
       '' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       87,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = TEF.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       250,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       17,
       7,
       'DATTRN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Transacao',
       'Data Transao',
       '',
       'DATTRN',
       'F' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       198,
       30,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Documento',
       'Referente ao Documento',
       '',
       'CAST(COMPLEMENTODADOSFINANCEIROS(''TEF'',TEF.CODFIL,TEF.SEQUEN,''--'',''--'',3) AS VARCHAR(30))',
       '' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       97,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       117,
       1,
       'MANUAL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Manual?',
       'Carto Manual?',
       '',
       'MANUAL',
       'F' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       220,
       5,
       'MAXITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       '',
       'Num Max Item',
       'Num Max Item',
       '',
       '(SELECT MAX(ITF.NUMITE) FROM TT_ITF ITF WHERE ITF.CODFIL = TEF.CODFIL AND ITF.SEQUEN = TEF.SEQUEN)',
       '' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       200,
       64,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome do Cliente',
       'Nome do Cliente',
       '',
       '(SELECT NOMCLI FROM TT_CLI CLI WHERE CLI.FILCLI = TEF.FILCLI AND CLI.CODCLI = TEF.CODCLI)',
       '' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       37,
       18,
       'NSUTRN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nr. Transao',
       'Nr. Transao',
       '',
       'NSUTRN',
       'F' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       7,
       20,
       'NUMAUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Autorizao',
       'Autorizao',
       '',
       'NUMAUT',
       'F' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       5,
       16,
       'NUMCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Carto',
       'Nmero Carto',
       '',
       'NUMCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       127,
       3,
       'NUMECF',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       'F',
       'Nmero do ECF',
       'Nmero do ECF',
       'DECF.FILECF = TEF.CODFIL AND DECF.NUMECF = TEF.NUMECF',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       137,
       5,
       'PORORI',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       '',
       'A',
       'F',
       'Portador Original',
       'Portador Original',
       'DCOB.CODTAB = TEF.PORORI',
       'PORORI',
       'F' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       177,
       1,
       'TIPCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       47,
       1,
       'TIPOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Operao',
       'Tipo Operao',
       '',
       'TIPOPE',
       'T' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       187,
       12,
       'TRN_ID',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'F',
       'N',
       'F',
       'ID da Transao',
       'ID da Transao',
       '',
       'TRN_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       210,
       30,
       'ULTNOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Sobrenome/Fantasia',
       'Sobrenome/Fantasia',
       '',
       '(SELECT ULTNOM FROM TT_CLI CLI WHERE CLI.FILCLI = TEF.FILCLI AND CLI.CODCLI = TEF.CODCLI)',
       '' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       6,
       4,
       'VLDCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Validade',
       'Validade',
       '',
       'VLDCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'TEF ',
       '--',
       197,
       12,
       'VLROPE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor da Operao ',
       'Valor da Operao',
       '',
       'VLROPE',
       'F' FROM DUAL
);

/*-- SEQ 9400 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'TEF ',
       'TIPOPE',
       0,
       'C',
       'Crdito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TEF ',
       'TIPOPE',
       0,
       'D',
       'Dbito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TEF ',
       'TIPOPE',
       0,
       'P',
       'Vale Presente',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9401 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TEQ ',
       TO_NUMBER(null),
       'TEQ ',
       'Tipo de Equipamento',
       'TT_TEQ',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9402 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TEQ ','--','' FROM DUAL
UNION ALL
SELECT 'TEQ ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TEQ ','99','Outros' FROM DUAL
);

/*-- SEQ 9403 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 36551,
       'CLI ',
       'TEQ ',
       '1 ',
       'N ',
       '',
       '',
       'TEQ.FILCLI = CLI.FILCLI AND
TEQ.CODCLI = CLI.CODCLI',
       '' FROM DUAL
);

/*-- SEQ 9404 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TEQ ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Tipo Equip.',
       'Filial do Tipo de Equipamento',
       'DFIL.CODFIL = TEQ.CODFIL',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'TEQ ',
       '99',
       70,
       3,
       'CODUSU',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Cdigo do Usurio',
       'Cdigo do Usurio',
       '',
       'CODUSU',
       '' FROM DUAL
UNION ALL
SELECT 'TEQ ',
       '99',
       80,
       15,
       'DESTIP',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Desc. Tipo Equip.',
       'Descrio do Tipo de Equipamento',
       '',
       'DESTIP',
       '' FROM DUAL
UNION ALL
SELECT 'TEQ ',
       '99',
       30,
       3,
       'FILTEQ',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Filial Tipo Comp.',
       'Filial do Tipo de Componente',
       '',
       'FILTEQ',
       '' FROM DUAL
UNION ALL
SELECT 'TEQ ',
       '99',
       60,
       3,
       'FILUSU',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       '',
       'Filial do Usurio',
       'Filial do Usurio',
       '',
       'FILUSU',
       '' FROM DUAL
UNION ALL
SELECT 'TEQ ',
       '99',
       90,
       5,
       'IMGEQP',
       'G',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Imagem Tipo Equip.',
       'Imagem do Tipo de Equipamento',
       '',
       'IMGEQP',
       '' FROM DUAL
UNION ALL
SELECT 'TEQ ',
       '99',
       40,
       10,
       'SEQTEQ',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo Tipo Comp.',
       'Cdigo do Tipo de Componente',
       '',
       'SEQTEQ',
       '' FROM DUAL
UNION ALL
SELECT 'TEQ ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo Tipo Equip.',
       'Cdigo do Tipo de Equipamento',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'TEQ ',
       '99',
       50,
       1,
       'TIPATI',
       'L',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Ativo?',
       'Ativo?',
       '',
       'TIPATI',
       '' FROM DUAL
);

/*-- SEQ 9405 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TFXC',
       TO_NUMBER(null),
       'TFXC',
       'Frete X Compra',
       'TT_FREXCOM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'TFXC.FILCOM, TFXC.SEQCOM, TFXC.FILFRE, TFXC.SEQFRE',
       '' FROM DUAL
);

/*-- SEQ 9406 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TFXC','--','' FROM DUAL
UNION ALL
SELECT 'TFXC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TFXC','99','Outros' FROM DUAL
);

/*-- SEQ 9407 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23457,
       'COM ',
       'TFXC',
       '0N',
       '1',
       '',
       '',
       'TFXC.FILCOM = COM.CODFIL (+) AND
TFXC.SEQCOM = COM.SEQUEN (+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 9408 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TFXC',
       '99',
       10,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'TFXC',
       '01',
       20,
       3,
       'FILCOM',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Compra',
       'Filial Compra',
       'DFIL.CODFIL = TFXC.FILCOM',
       'FILCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'TFXC',
       '01',
       30,
       3,
       'FILFRE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Frete',
       'Filial Frete',
       'DFIL.CODFIL = TFXC.FILFRE',
       'FILFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'TFXC',
       '01',
       40,
       14,
       'ID_FREXCOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Chave ID',
       'Chave ID',
       '',
       'ID_FREXCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'TFXC',
       '01',
       50,
       10,
       'SEQCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Sequncia Compra',
       'Sequncia Compra',
       '',
       'SEQCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'TFXC',
       '01',
       60,
       10,
       'SEQFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Sequncia Frete',
       'Sequncia Frete',
       '',
       'SEQFRE',
       'F' FROM DUAL
);

/*-- SEQ 9409 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TIN ',
       TO_NUMBER(null),
       'TIN ',
       'Tintas',
       'TT_TIN',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9410 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TIN ','--','' FROM DUAL
UNION ALL
SELECT 'TIN ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TIN ','02','Descrio' FROM DUAL
UNION ALL
SELECT 'TIN ','99','Outros' FROM DUAL
);

/*-- SEQ 9411 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TIN ',
       '99',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'TIN ',
       '01',
       20,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'TIN ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = TIN.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'TIN ',
       '99',
       40,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'TIN ',
       '02',
       50,
       100,
       'DESBAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Base',
       'Descrio da Base',
       '',
       'DESBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'TIN ',
       '02',
       60,
       100,
       'DESCOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cor',
       'Descrio da Cor',
       '',
       'DESCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'TIN ',
       '02',
       70,
       100,
       'DESCRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tinta',
       'Descrio da Tinta',
       '',
       'DESCRI',
       'F' FROM DUAL
UNION ALL
SELECT 'TIN ',
       '02',
       80,
       100,
       'DESEMB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Embalagem',
       'Descrio da Embalagem',
       '',
       'DESEMB',
       'F' FROM DUAL
UNION ALL
SELECT 'TIN ',
       '02',
       90,
       100,
       'DESGRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Grupo',
       'Descrio do Grupo',
       '',
       'DESGRU',
       'F' FROM DUAL
UNION ALL
SELECT 'TIN ',
       '02',
       100,
       30,
       'DESMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Material',
       'Descrio do Material',
       '',
       'DESMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'TIN ',
       '99',
       110,
       30,
       'ESPMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Especificao do Mat',
       'Especificao do Material',
       '',
       'ESPMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'TIN ',
       '99',
       120,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'TIN ',
       '99',
       130,
       100,
       'NOMCOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome da Cor',
       'Nome da Cor',
       '',
       'NOMCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'TIN ',
       '01',
       140,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'TIN ',
       '01',
       150,
       1,
       'SISTIN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Sistema Tintomtrico',
       'Sistema Tintomtrico',
       '',
       'SISTIN',
       'T' FROM DUAL
);

/*-- SEQ 9412 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'TIN ',
       'FLGEST',
       0,
       'A',
       'Ativo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIN ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIN ',
       'SISTIN',
       0,
       ' ',
       'SelfColor',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIN ',
       'SISTIN',
       1,
       ' ',
       'ShotColor',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9413 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TIND',
       TO_NUMBER(null),
       'TIND',
       'Indicadores',
       'TT_IND',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'TIND.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9414 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TIND','--','' FROM DUAL
UNION ALL
SELECT 'TIND','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TIND','99','Outros' FROM DUAL
);

/*-- SEQ 9415 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TIND',
       '--',
       10,
       254,
       'COMENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Comentrio',
       'Comentrio',
       '',
       'COMENT',
       'F' FROM DUAL
UNION ALL
SELECT 'TIND',
       '--',
       20,
       4000,
       'FORIND',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da frmula',
       'Descrio da frmula',
       '',
       'FORIND',
       'F' FROM DUAL
UNION ALL
SELECT 'TIND',
       '--',
       30,
       4000,
       'FORSQL',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Frmula do indicador',
       'Frmula do indicador',
       '',
       'FORSQL',
       'F' FROM DUAL
UNION ALL
SELECT 'TIND',
       '--',
       40,
       50,
       'NOMIND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome',
       'Nome do indicador',
       '',
       'NOMIND',
       'F' FROM DUAL
UNION ALL
SELECT 'TIND',
       '--',
       50,
       5,
       'SEQUEN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'TIND',
       '--',
       60,
       16,
       'VLRMAX',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Mximo',
       'Valor Mximo',
       '',
       'VLRMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'TIND',
       '--',
       70,
       16,
       'VLRMIN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Mnimo',
       'Valor Mnimo',
       '',
       'VLRMIN',
       'F' FROM DUAL
);

/*-- SEQ 9416 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TIT ',
       TO_NUMBER(null),
       'TIT ',
       'Ttulos Bancrios',
       'TT_TIT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'TIT.CODFIL,TIT.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9417 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TIT ','--','' FROM DUAL
UNION ALL
SELECT 'TIT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TIT ','02','Datas' FROM DUAL
UNION ALL
SELECT 'TIT ','03','Valores' FROM DUAL
UNION ALL
SELECT 'TIT ','04','Traz Perc Desconto ' FROM DUAL
UNION ALL
SELECT 'TIT ','05','Traz Data Desconto' FROM DUAL
UNION ALL
SELECT 'TIT ','06','Desconto' FROM DUAL
UNION ALL
SELECT 'TIT ','99','Outros' FROM DUAL
);

/*-- SEQ 9418 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 5893,
       'REC ',
       'TIT ',
       '1',
       '1',
       '',
       '',
       'REC.CODFIL = TIT.FILREC AND
REC.SEQUEN = TIT.SEQREC AND
REC.NUMPAR = TIT.PARREC AND
REC.SUBPAR = TIT.SUBREC',
       '',
       '' FROM DUAL
UNION ALL
SELECT 5894,
       'CTB ',
       'TIT ',
       '1',
       '1',
       '',
       '',
       'TIT.CODBCO(+) = CTB.CODBCO  AND
TIT.NUMAGE(+) = CTB.NUMAGE  AND
TIT.CTACRR(+) = CTB.CTACRR ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45927,
       'RECP',
       'TIT ',
       '1',
       '1',
       '',
       '',
       'RECP.CODFIL = TIT.FILREC AND
RECP.SEQUEN = TIT.SEQREC AND
RECP.NUMPAR = TIT.PARREC AND
RECP.SUBPAR = TIT.SUBREC',
       '',
       '' FROM DUAL
);

/*-- SEQ 9419 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TIT ',
       '05',
       380,
       12,
       ':TIT.NUMERO_DATA_DESCONTO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       '',
       '',
       'Nmero Data Desconto',
       'Nmero Data Desconto',
       '',
       ':TIT.NUMERO_DATA_DESCONTO',
       '' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '04',
       360,
       12,
       ':TIT.NUMERO_PERC_DESCONTO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       '',
       '',
       'Nmero % Desconto',
       'Nmero % Desconto',
       '',
       ':TIT.NUMERO_PERC_DESCONTO',
       '' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       260,
       1,
       'ACEITE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Aceitar?',
       'Aceitar',
       '',
       'ACEITE',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       270,
       5,
       'AGECOB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Agncia Cobrana',
       'Agncia de Cobrana',
       '',
       'AGECOB',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       10,
       1,
       'CODBAI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Baixa',
       'Codigo para o tipo de baixa',
       '',
       'CODBAI',
       'T' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       20,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Banco',
       'Codigo do banco',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       30,
       5,
       'CODCCB',
       'S',
       'DCCB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCB.APECCB',
       'V',
       '',
       '',
       'A',
       'F',
       'Carteira',
       'Codigo da carteira TD_CCB',
       'DCCB.CODTAB(+) = TIT.CODCCB',
       'CODCCB',
       'T' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       40,
       1,
       'CODDES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Desoncto',
       'Codigo tipo do desconto',
       '',
       'CODDES',
       'T' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       50,
       5,
       'CODECB',
       'S',
       'DECB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DECB.DESECB',
       'V',
       '',
       '',
       'A',
       'F',
       'Especie',
       'Codigo da especie TD_ECB',
       'DECB.CODTAB(+) = TIT.CODECB',
       'CODECB',
       'T' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       280,
       1,
       'CODERR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Erro',
       'Cdigo do Erro',
       '',
       'CODERR',
       'T' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       60,
       3,
       'CODFIL',
       'A',
       'FIL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'FIL2.CODFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Codigo da Filial',
       'FIL2.CODFIL = TIT.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       70,
       1,
       'CODMOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Juros de Mor',
       'Codigo de juros de mora ',
       '',
       'CODMOR',
       'T' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       80,
       1,
       'CODPRT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Protesto',
       'Codigo do tipo do protesto',
       '',
       'CODPRT',
       'T' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       90,
       5,
       'CODREM',
       'S',
       'DREM',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DREM.DESREM',
       'V',
       '',
       '',
       'A',
       'F',
       'Remessa',
       'Codigo da remessa TD_REM',
       'DREM.CODTAB(+) = TIT.CODREM',
       'CODREM',
       'T' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       100,
       10,
       'CTACRR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Conta Corrente N.',
       'Numero da conta corrente',
       '',
       'CTACRR',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '02',
       110,
       7,
       'DATDES',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Desconto',
       'Data do desconto',
       '',
       'DATDES',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '02',
       120,
       7,
       'DATMOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Juros',
       'Data do juros de mora',
       '',
       'DATMOR',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       300,
       1,
       'DIGCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Dgito da agncia ',
       'Dgito da agncia cobradora',
       '',
       'DIGCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       310,
       1,
       'DUMMY',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       '',
       'Dummy',
       '',
       'DUMMY',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       130,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Parcela',
       'Filial Parcela',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       140,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situacao',
       'Estado do Titulo',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '03',
       150,
       15,
       'JURDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Desconto~Cedido',
       'Desconto cedido',
       '',
       'JURDES',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '03',
       160,
       15,
       'JURMOR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Juros de Mora',
       'Juros de mora',
       '',
       'JURMOR',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       5,
       4000,
       'MENSAGENSTITULO',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagens de Ttulos',
       'Mensagens de Ttulos',
       '',
       'RTF2TXT(MENSAGENSTITULO(TIT.CODFIL,TIT.SEQUEN))',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       170,
       20,
       'NOSNUM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nosso Numero',
       'Nosso Numero',
       '',
       'NOSNUM',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       180,
       5,
       'NUMAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Numero da~Agencia',
       'Numero da agencia',
       '',
       'NUMAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       190,
       2,
       'PARREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Numero da~Parcela',
       'Numero da parcela',
       '',
       'PARREC',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       200,
       2,
       'PRZBAI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Prazo para Baixa',
       'Prazo para a baixa',
       '',
       'PRZBAI',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       210,
       2,
       'PRZPRT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Prazo para Protesto',
       'Prazo para o protesto',
       '',
       'PRZPRT',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       220,
       10,
       'SEQCAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador de cancelamento',
       '',
       'SEQCAN',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       230,
       10,
       'SEQREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da parcela',
       '',
       'SEQREC',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       240,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '01',
       250,
       2,
       'SUBREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub Parcela',
       'Numero da sub parcela',
       '',
       'SUBREC',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '05',
       370,
       8,
       'TRAZ_DATA_DESCONTO',
       'D',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Traz Data Desconto',
       'Traz Data Desconto',
       '',
       'TRAZ_DATA_DESCONTO(TIT.CODFIL,TIT.SEQUEN,:TIT.NUMERO_DATA_DESCONTO)',
       '' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '06',
       390,
       8,
       'TRAZ_DATA_DESCONTO_1',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       '1 Data~Desconto',
       '1 Data~Desconto',
       '',
       'TRAZ_DATA_DESCONTO(TIT.CODFIL,TIT.SEQUEN,1)',
       '' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '06',
       400,
       8,
       'TRAZ_DATA_DESCONTO_2',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       '2 Data~Desconto',
       '2 Data~Desconto',
       '',
       'TRAZ_DATA_DESCONTO(TIT.CODFIL,TIT.SEQUEN,2)',
       '' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '06',
       410,
       8,
       'TRAZ_DATA_DESCONTO_3',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       '3 Data~Desconto',
       '3 Data~Desconto',
       '',
       'TRAZ_DATA_DESCONTO(TIT.CODFIL,TIT.SEQUEN,3)',
       '' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '06',
       415,
       8,
       'TRAZ_DATA_DESCONTO_4',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       '4 Data~Desconto',
       '4 Data~Desconto',
       '',
       'TRAZ_DATA_DESCONTO(TIT.CODFIL,TIT.SEQUEN,4)',
       '' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '04',
       350,
       12,
       'TRAZ_PERC_DESCONTO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Traz % Desconto ',
       'Traz % Desconto ',
       '',
       'TRAZ_PERC_DESCONTO(TIT.CODFIL,TIT.SEQUEN,:TIT.NUMERO_PERC_DESCONTO)',
       '' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '06',
       420,
       12,
       'TRAZ_PERC_DESCONTO_1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       '1 %~Desconto ',
       '1 %~Desconto ',
       '',
       'TRAZ_PERC_DESCONTO(TIT.CODFIL,TIT.SEQUEN,1)',
       '' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '06',
       430,
       12,
       'TRAZ_PERC_DESCONTO_2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       '2 %~Desconto ',
       '2 %~Desconto ',
       '',
       'TRAZ_PERC_DESCONTO(TIT.CODFIL,TIT.SEQUEN,2)',
       '' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '06',
       440,
       12,
       'TRAZ_PERC_DESCONTO_3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       '3 %~Desconto ',
       '3 %~Desconto ',
       '',
       'TRAZ_PERC_DESCONTO(TIT.CODFIL,TIT.SEQUEN,3)',
       '' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '06',
       450,
       12,
       'TRAZ_PERC_DESCONTO_4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       '4 %~Desconto ',
       '4 %~Desconto ',
       '',
       'TRAZ_PERC_DESCONTO(TIT.CODFIL,TIT.SEQUEN,4)',
       '' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '03',
       320,
       12,
       'VLRABT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor do Abatimento',
       'Valor do Abatimento',
       '',
       'VLRABT',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '03',
       330,
       12,
       'VLRIOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor IOF',
       'Valor do IOF (Somente para retorno)
Valor do IOF (Somente para retorno)',
       '',
       'VLRIOF',
       'F' FROM DUAL
UNION ALL
SELECT 'TIT ',
       '03',
       340,
       12,
       'VLRORI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Origem',
       'Valor Origem',
       '',
       'VLRORI',
       'F' FROM DUAL
);

/*-- SEQ 9420 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'TIT ',
       'CODBAI',
       0,
       ' ',
       'Sem instruo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODBAI',
       1,
       ' ',
       'Baixar / Devolver',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODBAI',
       2,
       ' ',
       'No baixar / No devolver',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODDES',
       1,
       ' ',
       'valor fixo at data informada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODDES',
       2,
       ' ',
       'percentual at data informada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODDES',
       3,
       ' ',
       'valor antecipacao dia corrido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODDES',
       4,
       ' ',
       'valor antecipacao dia util',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODDES',
       5,
       ' ',
       '% sobre vlr nominal dia corrid',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODDES',
       6,
       ' ',
       '% sobre vlr nominal dia util',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODDES',
       7,
       ' ',
       'cancelamento do desconto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODERR',
       0,
       ' ',
       'Correto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODERR',
       0,
       'A',
       'CNPJ da filial nula',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODERR',
       0,
       'B',
       'Conta bancria invlida',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODERR',
       0,
       'C',
       'Banco invlido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODERR',
       0,
       'D',
       'Carteira inexistente/invlida',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODERR',
       0,
       'E',
       'Espcie inexistente/invlida',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODERR',
       0,
       'F',
       'Moeda inexistente/invlida',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODERR',
       0,
       'G',
       'Remessa invlida/ cadastrada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODERR',
       0,
       'H',
       'Retornos com erro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODERR',
       0,
       'I',
       'Nosso nmero em branco',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODERR',
       0,
       'J',
       'Instruo Cancel.Tt.em branco',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODERR',
       0,
       'K',
       'Instruo Alter.Data em branco',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODERR',
       0,
       'L',
       'Instruo Altera.Outros branco',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODERR',
       0,
       'M',
       'Instruo PGTO carteira branco',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODERR',
       0,
       'N',
       'Instruo Incluso Tt. branco',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODERR',
       0,
       'O',
       'InstruoConcesso Desc.branco',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODERR',
       0,
       'P',
       'Instruo Cancel. Desc.branco',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODERR',
       0,
       'Q',
       'Instruo Protesto Tt. branco',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODERR',
       0,
       'R',
       'Instruo Sustar/baixar branco',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODERR',
       0,
       'S',
       'Instruo Sustar/Manter branco',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODMOR',
       3,
       ' ',
       'isento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODMOR',
       2,
       ' ',
       'taxa mensal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODMOR',
       1,
       ' ',
       'valor por dia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODPRT',
       2,
       ' ',
       'Protestar dias uteis',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODPRT',
       3,
       ' ',
       'Nao protestar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODPRT',
       0,
       ' ',
       'Sem instruo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'CODPRT',
       1,
       ' ',
       'Protestar dias corridos',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'FLGEST',
       0,
       'I',
       'Inconsistente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TIT ',
       'FLGEST',
       0,
       'T',
       'Protestado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9421 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TMAR',
       TO_NUMBER(null),
       'TMAR',
       'Marcas(Tab.)',
       'TT_MAR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'TMAR.FILMAR,TMAR.CODMAR,TMAR.ITEMAR
TMAR.DESMAR',
       '' FROM DUAL
);

/*-- SEQ 9422 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TMAR','--','' FROM DUAL
UNION ALL
SELECT 'TMAR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TMAR','99','Outros' FROM DUAL
);

/*-- SEQ 9423 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21995,
       'REL ',
       'TMAR',
       'N',
       '1',
       '',
       '',
       'REL.FILPAR = TMAR.FILMAR AND
REL.CODPAR = TMAR.CODMAR AND
REL.TIPPAR = TMAR.TIPMAR',
       '',
       '' FROM DUAL
);

/*-- SEQ 9424 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TMAR',
       '01',
       10,
       6,
       'CODMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo da Marca',
       'Cdigo da Marca',
       '',
       'CODMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'TMAR',
       '01',
       20,
       30,
       'DESMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Marca',
       'Descrio da Marca',
       '',
       'DESMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'TMAR',
       '01',
       30,
       3,
       'FILMAR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial da Marca do material',
       'TMAR.FILMAR = DFIL.CODFIL (+)',
       'FILMAR',
       'T' FROM DUAL
UNION ALL
SELECT 'TMAR',
       '01',
       40,
       4,
       'ITEMAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Item da Marca(Seq.)',
       'Item da Marca(Sequenciador)',
       '',
       'ITEMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'TMAR',
       '01',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'TMAR',
       '01',
       50,
       1,
       'TIPMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Marca',
       'Tipo Marca',
       '',
       'TIPMAR',
       'T' FROM DUAL
);

/*-- SEQ 9425 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'TMAR',
       'TIPMAR',
       0,
       'M',
       'Marca',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9426 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TPAP',
       TO_NUMBER(null),
       'TPAP',
       'Papis',
       'TT_PAP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'TPAP.CODFIL,TPAP.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9427 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TPAP','--','' FROM DUAL
UNION ALL
SELECT 'TPAP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TPAP','99','Outros' FROM DUAL
);

/*-- SEQ 9428 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TPAP',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = TPAP.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'TPAP',
       '01',
       20,
       30,
       'DESPAP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Papel',
       'Descrio Papel',
       '',
       'DESPAP',
       'F' FROM DUAL
UNION ALL
SELECT 'TPAP',
       '99',
       40,
       1000,
       'PERAUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Permisso Automtica',
       'Permisso Automtica',
       '',
       'PERAUT',
       'F' FROM DUAL
UNION ALL
SELECT 'TPAP',
       '99',
       50,
       1000,
       'PERMIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Permisses',
       'Permisses',
       '',
       'PERMIS',
       'F' FROM DUAL
UNION ALL
SELECT 'TPAP',
       '01',
       30,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 9429 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TPF ',
       TO_NUMBER(null),
       'TPF ',
       'Preos Fornecedores',
       'TT_TPF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'TPF.ID_TPF',
       '' FROM DUAL
);

/*-- SEQ 9430 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TPF ','--','' FROM DUAL
UNION ALL
SELECT 'TPF ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TPF ','02','Valores' FROM DUAL
UNION ALL
SELECT 'TPF ','03','Datas' FROM DUAL
UNION ALL
SELECT 'TPF ','99','Outros' FROM DUAL
);

/*-- SEQ 9431 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 29291,
       'CLI ',
       'TPF ',
       '1',
       'N',
       '',
       '',
       'CLI.FILCLI = TPF.FILFOR and
CLI.CODCLI = TPF.CODFOR',
       '',
       '' FROM DUAL
);

/*-- SEQ 9432 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TPF ',
       '01',
       30,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo Fornecedor',
       'Cdigo Fornecedor',
       '',
       'CODFOR',
       '' FROM DUAL
UNION ALL
SELECT 'TPF ',
       '03',
       150,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data de Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'TPF ',
       '03',
       140,
       8,
       'DATVAL',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Validade Tabela',
       'Data de Validade da Tabela',
       '',
       'DATVAL',
       '' FROM DUAL
UNION ALL
SELECT 'TPF ',
       '01',
       20,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Filial Fornecedor',
       'Filial Fornecedor',
       '',
       'FILFOR',
       '' FROM DUAL
UNION ALL
SELECT 'TPF ',
       '01',
       10,
       14,
       'ID_TPF',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Chave ID',
       'Chave ID',
       '',
       'ID_TPF',
       '' FROM DUAL
UNION ALL
SELECT 'TPF ',
       '99',
       40,
       1,
       'TIPFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo de Frete',
       'Tipo de Frete',
       '',
       'TIPFRE',
       'T' FROM DUAL
UNION ALL
SELECT 'TPF ',
       '99',
       50,
       1,
       'TPFATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Tabela Ativa?',
       'Tabela Ativa?',
       '',
       'TPFATI',
       '' FROM DUAL
UNION ALL
SELECT 'TPF ',
       '02',
       120,
       7,
       'VLRACR_01',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Acrscimo 1',
       'Valor Acrscimo 1',
       '',
       'VLRACR_01',
       '' FROM DUAL
UNION ALL
SELECT 'TPF ',
       '02',
       130,
       7,
       'VLRACR_02',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Acrscimo 2',
       'Valor Acrscimo 2',
       '',
       'VLRACR_02',
       '' FROM DUAL
UNION ALL
SELECT 'TPF ',
       '02',
       60,
       6,
       'VLRDES_01',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Desconto 1',
       'Valor Desconto 1',
       '',
       'VLRDES_01',
       '' FROM DUAL
UNION ALL
SELECT 'TPF ',
       '02',
       70,
       6,
       'VLRDES_02',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Desconto 2',
       'Valor Desconto 2',
       '',
       'VLRDES_02',
       '' FROM DUAL
UNION ALL
SELECT 'TPF ',
       '02',
       80,
       6,
       'VLRDES_03',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Desconto 3',
       'Valor Desconto 3',
       '',
       'VLRDES_03',
       '' FROM DUAL
UNION ALL
SELECT 'TPF ',
       '02',
       90,
       6,
       'VLRDES_04',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Desconto 4',
       'Valor Desconto 4',
       '',
       'VLRDES_04',
       '' FROM DUAL
UNION ALL
SELECT 'TPF ',
       '02',
       100,
       6,
       'VLRDES_05',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Desconto 5',
       'Valor Desconto 5',
       '',
       'VLRDES_05',
       '' FROM DUAL
UNION ALL
SELECT 'TPF ',
       '02',
       110,
       6,
       'VLRDES_06',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Desconto 6',
       'Valor Desconto 6',
       '',
       'VLRDES_06',
       '' FROM DUAL
UNION ALL
SELECT 'TPF ',
       '02',
       160,
       6,
       'VLRDES_CALC',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Vlr Desc. Calculado',
       'Valor Desconto Calculado',
       '',
       'VLRDES_CALC',
       '' FROM DUAL
);

/*-- SEQ 9433 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'TPF ',
       'TIPFRE',
       0,
       'C',
       'CIF',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TPF ',
       'TIPFRE',
       0,
       'F',
       'FOB',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9434 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TPR ',
       0,
       'TPR ',
       'Tabela de Preos',
       'TT_TPR',
       'T',
       '',
       'TOTALL',
       'Tabela de Preos',
       '{CODPRE}',
       '',
       'DESPRE',
       '',
       'F',
       '',
       'TPR.CODFIL,TPR.CODPRE',
       '' FROM DUAL
);

/*-- SEQ 9435 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TPR ','--','' FROM DUAL
UNION ALL
SELECT 'TPR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TPR ','02','Datas' FROM DUAL
UNION ALL
SELECT 'TPR ','99','Outros' FROM DUAL
);

/*-- SEQ 9436 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TPR ',
       '02',
       35,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'TPR ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TPR',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(TPR.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '02',
       65,
       4,
       'ANO_DATMAX',
       'A',
       '',
       0,
       0,
       'TPR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TPR',
       '',
       'N',
       'T',
       'Ano de Vlida At',
       'Ano de Data mxima',
       '',
       'TO_CHAR(TPR.DATMAX,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '02',
       55,
       4,
       'ANO_DATMIN',
       'A',
       '',
       0,
       0,
       'TPR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TPR',
       '',
       'N',
       'T',
       'Ano de Vlida Desde',
       'Ano de Data minima',
       '',
       'TO_CHAR(TPR.DATMIN,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '99',
       131,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN TPR.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '02',
       30,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'TPR ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TPR',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '99',
       100,
       2,
       'CATEG1',
       'S',
       'DCT1',
       0,
       0,
       'TPR ',
       100,
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'V',
       'TPR',
       'F',
       'A',
       'F',
       'Bonus/Dest Icms',
       'Categoria de cliente 1',
       'TPR.CATEG1 = DCT1.CODTAB (+)',
       'CATEG1',
       'T' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '99',
       110,
       2,
       'CATEG2',
       'S',
       'DCT2',
       0,
       0,
       'TPR ',
       110,
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'V',
       'TPR',
       'F',
       'A',
       'F',
       'Ramo Atividade',
       'Categoria de cliente 2',
       'TPR.CATEG2 = DCT2.CODTAB (+)',
       'CATEG2',
       'T' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '99',
       120,
       2,
       'CATEG3',
       'S',
       'DCT3',
       0,
       0,
       'TPR ',
       120,
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'V',
       'TPR',
       'F',
       'A',
       'F',
       'Categoria',
       'Categoria de cliente 3',
       'TPR.CATEG3 = DCT3.CODTAB (+)',
       'CATEG3',
       'T' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '99',
       160,
       5,
       'CODCTR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Unidades de Negcios',
       'Unidades de Negcios',
       '',
       'CODCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '99',
       190,
       50,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       0,
       'TPR ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'TPR',
       'F',
       'A',
       'T',
       'Filial',
       'Filial de Origem da Tabela',
       'TPR.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '01',
       80,
       3,
       'CODPGT',
       'A',
       'PLA ',
       0,
       0,
       'TPR ',
       80,
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       'TPR',
       'F',
       'A',
       'F',
       'Cdigo do Plano',
       'Cdigo do plano PGTO',
       'TPR.FILPGT = PLA.FILPGT AND TPR.CODPGT = PLA.CODPGT',
       'CODPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '01',
       20,
       2,
       'CODPRE',
       'S',
       '',
       0,
       0,
       'TPR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TPR',
       'F',
       '9',
       'T',
       'Cdigo',
       'Cdigo tabela de preos',
       '',
       'CODPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '02',
       60,
       8,
       'DATMAX',
       'D',
       '',
       0,
       0,
       'TPR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TPR',
       'F',
       'D',
       'T',
       'Vlida At',
       'Data mxima',
       '',
       'DATMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '02',
       50,
       8,
       'DATMIN',
       'D',
       '',
       0,
       0,
       'TPR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TPR',
       'F',
       'D',
       'T',
       'Vlida Desde',
       'Data minima',
       '',
       'DATMIN',
       'F' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '01',
       40,
       30,
       'DESPRE',
       'A',
       '',
       0,
       0,
       'TPR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'TPR',
       'F',
       'A',
       'T',
       'Descrio',
       'Descrio da tabela de preos',
       '',
       'DESPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '01',
       140,
       2,
       'ESTADO',
       'A',
       'DEST',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEST.ESTADO',
       'V',
       '',
       '',
       'A',
       'F',
       'UF',
       'Unidade Federativa',
       'DEST.ESTADO = TPR.ESTADO',
       'ESTADO',
       'T' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '01',
       150,
       3,
       'FILDES',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial Destino',
       'Filial Destino',
       'TPR.FILDES = DFIL.CODFIL (+)',
       'FILDES',
       'T' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '01',
       70,
       3,
       'FILPGT',
       'A',
       '',
       0,
       0,
       'TPR ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TPR',
       'F',
       'N',
       'F',
       '',
       'Filial do plano',
       '',
       'FILPGT',
       'T' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '99',
       180,
       3,
       'FIL_CK',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial exc. Venda',
       'Filial Exclusiva para Venda',
       'TPR.FIL_CK = DFIL.CODFIL (+)',
       'FIL_CK',
       'T' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '02',
       33,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'TPR ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TPR',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(TPR.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '02',
       63,
       2,
       'MES_DATMAX',
       'A',
       '',
       0,
       0,
       'TPR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TPR',
       '',
       'N',
       'T',
       'Ms de Vlida At',
       'Ms de Data mxima',
       '',
       'TO_CHAR(TPR.DATMAX,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '02',
       53,
       2,
       'MES_DATMIN',
       'A',
       '',
       0,
       0,
       'TPR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TPR',
       '',
       'N',
       'T',
       'Ms de Vlida Desde',
       'Ms de Data minima',
       '',
       'TO_CHAR(TPR.DATMIN,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '01',
       14,
       6,
       'MULTIP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Fator Multiplicao',
       'Fator de multiplicao perante a tabela de varejo',
       '',
       'MULTIP',
       'F' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '99',
       170,
       5,
       'PERLUC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Lucro',
       '% Lucro',
       '',
       'PERLUC',
       '' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '99',
       130,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'TPR ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN TPR.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '01',
       160,
       1,
       'TOTQTD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Totaliza quantidade ',
       'Totaliza quantidade de itens?',
       '',
       'TOTQTD',
       '' FROM DUAL
UNION ALL
SELECT 'TPR ',
       '01',
       90,
       1,
       'VAREJO',
       'S',
       '',
       0,
       0,
       'TPR ',
       90,
       30,
       '',
       '',
       'D',
       'TPR',
       'F',
       'A',
       'T',
       'Varejo',
       'Aplicvel a varejo',
       '',
       'VAREJO',
       'T' FROM DUAL
);

/*-- SEQ 9437 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'TPR ',
       'VAREJO',
       3,
       ' ',
       'Revenda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TPR ',
       'VAREJO',
       1,
       ' ',
       'Atacado Corporativo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TPR ',
       'VAREJO',
       2,
       ' ',
       'Qualquer',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TPR ',
       'VAREJO',
       0,
       ' ',
       'Varejo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TPR ',
       'VAREJO',
       4,
       ' ',
       'Atacado Loja',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9438 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TPXF',
       TO_NUMBER(null),
       'TPXF',
       'Preo Excl. Filial',
       'TT_TPRXFIL',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'TPXF.CODFIL, TPXF.FILPRE, TPXF.CODPRE',
       '' FROM DUAL
);

/*-- SEQ 9439 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TPXF','--','' FROM DUAL
UNION ALL
SELECT 'TPXF','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TPXF','99','Outros' FROM DUAL
);

/*-- SEQ 9440 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 29181,
       'TPR ',
       'TPXF',
       '0N',
       '01',
       '',
       '',
       'TPXF.FILPRE = TPR.CODFIL (+) AND
TPXF.CODPRE = TPR.CODPRE (+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 9441 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TPXF',
       '99',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'TPXF',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = TPXF.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'TPXF',
       '01',
       30,
       5,
       'CODPRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Cdigo Preo',
       'Cdigo Preo',
       '',
       'CODPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'TPXF',
       '99',
       40,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'TPXF',
       '01',
       50,
       3,
       'FILPRE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial Preo',
       'Filial Preo',
       'DFIL.CODFIL = TPXF.FILPRE',
       'FILPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'TPXF',
       '01',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Sequnciador',
       'Sequnciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 9442 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TPXP',
       TO_NUMBER(null),
       'TPXP',
       'PRJ X PRJ',
       'TT_PRJXPRJ',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'TPXP.CODFIL,TPXP.SEQUEN,TPXP.FILPRJ,TPXP.SEQPRJ',
       '' FROM DUAL
);

/*-- SEQ 9443 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TPXP','--','' FROM DUAL
UNION ALL
SELECT 'TPXP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TPXP','99','Outros' FROM DUAL
);

/*-- SEQ 9444 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5897,
       'PRJ ',
       'TPXP',
       '1 ',
       'N ',
       '',
       '',
       'PRJ.CODFIL = TPXP.CODFIL AND
PRJ.SEQUEN = TPXP.SEQUEN AND
PRJ.CODFIL = TPXP.FILPRJ AND
PRJ.SEQUEN = TPXP.SEQPRJ',
       '' FROM DUAL
);

/*-- SEQ 9445 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TPXP',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = TPXP.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'TPXP',
       '01',
       20,
       3,
       'CONCLU',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Concluido',
       'Concluido',
       '',
       'CONCLU',
       'F' FROM DUAL
UNION ALL
SELECT 'TPXP',
       '01',
       30,
       3,
       'FILPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Projeto',
       '',
       'FILPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'TPXP',
       '01',
       40,
       3,
       'SEQPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Projeto',
       '',
       'SEQPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'TPXP',
       '01',
       50,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 9446 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TPXU',
       TO_NUMBER(null),
       'TPXU',
       'Valor Prj. por Usu.',
       'TT_PRJXUSU',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'TPXU.CODUSU,TPXU.FILUSU,TPXU.FILPRJ,TPXU.SEQPRJ',
       '' FROM DUAL
);

/*-- SEQ 9447 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TPXU','--','' FROM DUAL
UNION ALL
SELECT 'TPXU','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TPXU','99','Outros' FROM DUAL
);

/*-- SEQ 9448 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5901,
       'PRJ ',
       'TPXU',
       '1 ',
       'N ',
       '',
       '',
       'PRJ.CODFIL = TPXU.FILPRJ AND
PRJ.SEQUEN = TPXU.SEQPRJ',
       '' FROM DUAL
UNION ALL
SELECT 5902,
       'USU ',
       'TPXU',
       '1 ',
       'N ',
       '',
       '',
       'USU.FILUSU = TPXU.FILUSU AND
USU.CODUSU = TPXU.CODUSU',
       '' FROM DUAL
);

/*-- SEQ 9449 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TPXU',
       '--',
       10,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'TPXU.FILUSU = USU.FILUSU(+)  AND TPXU.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'TPXU',
       '--',
       20,
       3,
       'FILPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Projeto',
       '',
       'FILPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'TPXU',
       '--',
       30,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'TPXU',
       '--',
       40,
       10,
       'SEQPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Projeto',
       '',
       'SEQPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'TPXU',
       '--',
       50,
       14,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Deslocamento',
       'Valor Deslocamento',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'TPXU',
       '--',
       60,
       14,
       'VLREXT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Extra',
       'Valor Extra',
       '',
       'VLREXT',
       'F' FROM DUAL
UNION ALL
SELECT 'TPXU',
       '--',
       70,
       14,
       'VLRNOR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Normal',
       'Valor Normal',
       '',
       'VLRNOR',
       'F' FROM DUAL
);

/*-- SEQ 9450 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TRA ',
       0,
       'TRA ',
       'Transportador',
       'TT_CLI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'TRA.FILCLI,TRA.CODCLI
TRA.NOMCLI,TRA.ULTNOM
TRA.NUMDOC
',
       '' FROM DUAL
);

/*-- SEQ 9451 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TRA ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TRA ','02','Endereo' FROM DUAL
UNION ALL
SELECT 'TRA ','03','Documentao' FROM DUAL
UNION ALL
SELECT 'TRA ','04','Dados Financeiros' FROM DUAL
UNION ALL
SELECT 'TRA ','99','Outros' FROM DUAL
);

/*-- SEQ 9452 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21919,
       'EDE ',
       'TRA ',
       'N',
       '1',
       '',
       '',
       'EDE.FILCLI = TRA.FILCLI AND
EDE.CODCLI = TRA.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21920,
       'CON ',
       'TRA ',
       '0N',
       '01',
       '',
       '',
       'CON.FILCLI = TRA.FILCLI (+) and
CON.CODCLI = TRA.CODCLI (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21921,
       'SPC ',
       'TRA ',
       '01',
       '01',
       '',
       'TRA.FLGTIP = 1',
       'SPC.FILCLI = TRA.FILCLI (+) and
SPC.CODCLI = TRA.CODCLI (+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 9453 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TRA ',
       '01',
       55,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'TRA ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(TRA.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '99',
       55,
       4,
       'ANO_DATA01',
       'A',
       '',
       0,
       0,
       'TRA ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 1',
       '',
       'TO_CHAR(TRA.DATA01,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '99',
       65,
       4,
       'ANO_DATA02',
       'A',
       '',
       0,
       0,
       'TRA ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 2',
       '',
       'TO_CHAR(TRA.DATA02,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '99',
       75,
       4,
       'ANO_DATA03',
       'A',
       '',
       0,
       0,
       'TRA ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 3',
       '',
       'TO_CHAR(TRA.DATA03,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '01',
       65,
       4,
       'ANO_DATNAS',
       'A',
       '',
       0,
       0,
       'TRA ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       '',
       'N',
       'T',
       'Ano de Nascto/Funda',
       'Ano de Data de nascimento ou fundao',
       '',
       'TO_CHAR(TRA.DATNAS,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '01',
       75,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       0,
       'TRA ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       '',
       'N',
       'T',
       'Ano de Data Incluso',
       'Ano de Data de operao (cadastramento)',
       '',
       'TO_CHAR(TRA.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '04',
       55,
       4,
       'ANO_ULTCOM',
       'A',
       '',
       0,
       0,
       'TRA ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       '',
       'N',
       'T',
       'Ano de ltima Compra',
       'Ano de Data da ltima compra',
       '',
       'TO_CHAR(TRA.ULTCOM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '01',
       50,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'TRA ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '99',
       20,
       2,
       'CATEG1',
       'S',
       'DCT1',
       0,
       20,
       'TRA ',
       10,
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'V',
       'TRA',
       'F',
       'A',
       'T',
       'Profisso/Ramo',
       'Categoria - 1',
       'TRA.CATEG1=DCT1.CODTAB (+)',
       'CATEG1',
       'T' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '99',
       30,
       2,
       'CATEG2',
       'S',
       'DCT2',
       0,
       21,
       'TRA ',
       20,
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'V',
       'TRA',
       'F',
       'A',
       'T',
       'Salrio/Faturam',
       'Categoria - 2',
       'TRA.CATEG2=DCT2.CODTAB (+)',
       'CATEG2',
       'T' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '99',
       40,
       2,
       'CATEG3',
       'S',
       'DCT3',
       0,
       22,
       'TRA ',
       30,
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'V',
       'TRA',
       'F',
       'A',
       'T',
       '',
       'Categoria - 3',
       'TRA.CATEG3=DCT3.CODTAB (+)',
       'CATEG3',
       'T' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '01',
       25,
       9,
       'CHAVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Transp.',
       'Cdigo do transportador',
       '',
       'FILCLI||TRA.CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       0,
       'TRA ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       'F',
       '9',
       'T',
       'Cdigo',
       'Cdigo do transportador',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '99',
       50,
       8,
       'DATA01',
       'D',
       '',
       0,
       0,
       'TRA ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       'F',
       'D',
       'T',
       'Data livre - 1',
       'Data livre - 1',
       '',
       'DATA01',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '99',
       60,
       8,
       'DATA02',
       'D',
       '',
       0,
       0,
       'TRA ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       'F',
       'D',
       'T',
       'Data livre - 2',
       'Data livre - 2',
       '',
       'DATA02',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '99',
       70,
       8,
       'DATA03',
       'D',
       '',
       0,
       0,
       'TRA ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       'F',
       'D',
       'T',
       'Data livre - 3',
       'Data livre - 3',
       '',
       'DATA03',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '01',
       60,
       8,
       'DATNAS',
       'D',
       '',
       0,
       0,
       'TRA ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       'F',
       'D',
       'T',
       'Nascto/Fundao',
       'Data de nascimento ou fundao',
       '',
       'DATNAS',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '01',
       70,
       8,
       'DATOPE',
       'D',
       '',
       0,
       0,
       'TRA ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       'F',
       'D',
       'T',
       'Data Incluso',
       'Data de operao (cadastramento)',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '01',
       10,
       3,
       'FILCLI',
       'A',
       '',
       0,
       0,
       'TRA ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       'F',
       'N',
       'T',
       '',
       'Filial onde foi cadastrado o transportador',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '03',
       20,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       0,
       'TRA ',
       20,
       30,
       '',
       '',
       'D',
       'TRA',
       'F',
       'A',
       'T',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '02',
       80,
       40,
       'HOMPGE',
       'A',
       '',
       0,
       0,
       'TRA ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TRA',
       'F',
       'A',
       'T',
       'Home Page',
       'Home Page do transportador',
       '',
       'HOMPGE',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '99',
       80,
       2,
       'IMPRIM',
       'S',
       '',
       0,
       0,
       'TRA ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       'F',
       '',
       'F',
       'Livre p/Customizao',
       'Livre para customizao',
       '',
       'IMPRIM',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '03',
       30,
       15,
       'INSEST',
       'A',
       '',
       0,
       4,
       'TRA ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TRA',
       'F',
       'A',
       'T',
       '2 Documento',
       'Inscrio Estadual ou Identidade',
       '',
       'INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '04',
       40,
       2,
       'MAIATR',
       'S',
       '',
       0,
       0,
       'TRA ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       'F',
       '9',
       'T',
       'Atraso Max. ao Pagar',
       'Maior atraso registrado',
       '',
       'MAIATR',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '01',
       53,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'TRA ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(TRA.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '99',
       53,
       2,
       'MES_DATA01',
       'A',
       '',
       0,
       0,
       'TRA ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 1',
       '',
       'TO_CHAR(TRA.DATA01,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '99',
       63,
       2,
       'MES_DATA02',
       'A',
       '',
       0,
       0,
       'TRA ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 2',
       '',
       'TO_CHAR(TRA.DATA02,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '99',
       73,
       2,
       'MES_DATA03',
       'A',
       '',
       0,
       0,
       'TRA ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 3',
       '',
       'TO_CHAR(TRA.DATA03,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '01',
       63,
       2,
       'MES_DATNAS',
       'A',
       '',
       0,
       0,
       'TRA ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       '',
       'N',
       'T',
       'Ms de Nascto/Funda',
       'Ms de Data de nascimento ou fundao',
       '',
       'TO_CHAR(TRA.DATNAS,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '01',
       73,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       0,
       'TRA ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       '',
       'N',
       'T',
       'Ms de Data Incluso',
       'Ms de Data de operao (cadastramento)',
       '',
       'TO_CHAR(TRA.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '04',
       53,
       2,
       'MES_ULTCOM',
       'A',
       '',
       0,
       0,
       'TRA ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       '',
       'N',
       'T',
       'Ms de ltima Compra',
       'Ms de Data da ltima compra',
       '',
       'TO_CHAR(TRA.ULTCOM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '01',
       30,
       44,
       'NOMCLI',
       'A',
       '',
       0,
       0,
       'TRA ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'TRA',
       'F',
       'A',
       'T',
       'Nome do transp.',
       'Nome do transportador',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '03',
       10,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       3,
       'TRA ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'TRA',
       'F',
       'A',
       'T',
       'Documento',
       'Nmero do Documento: CGC ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '99',
       90,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'TRA ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TRA',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(TRA.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '99',
       120,
       1,
       'REGESP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Regime Especial?',
       'Fornecedor possui Regime Especial?',
       '',
       'REGESP',
       '' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '99',
       110,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'TRA ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'TRA',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN TRA.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '99',
       111,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN TRA.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '04',
       20,
       4,
       'TOTATR',
       'G',
       '',
       0,
       0,
       'TRA ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       'F',
       '',
       'F',
       'Total Atrasos',
       'Total de atrasos na vida do transportador como cliente',
       '',
       'TOTATR',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '04',
       30,
       4,
       'TOTPAR',
       'G',
       '',
       0,
       0,
       'TRA ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       'F',
       '',
       'F',
       'Total Parcelas',
       'Total de parcelas na vida do transportador como cliente',
       '',
       'TOTPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '04',
       50,
       8,
       'ULTCOM',
       'D',
       '',
       0,
       0,
       'TRA ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       'F',
       'D',
       'T',
       'ltima Compra',
       'Data da ltima compra',
       '',
       'ULTCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '01',
       40,
       20,
       'ULTNOM',
       'A',
       '',
       0,
       0,
       'TRA ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'TRA',
       'F',
       'A',
       'T',
       'Nome Fantasia',
       'Nome fantasia',
       '',
       'ULTNOM',
       'F' FROM DUAL
UNION ALL
SELECT 'TRA ',
       '04',
       10,
       8,
       'VALOR1',
       'F',
       '',
       2,
       0,
       'TRA ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'TRA',
       'T',
       '',
       'T',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'VALOR1',
       'F' FROM DUAL
);

/*-- SEQ 9454 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'TRA ',
       'FLGTIP',
       0,
       '-',
       'Fsica',
       228,
       ' ' FROM DUAL
UNION ALL
SELECT 'TRA ',
       'FLGTIP',
       1,
       '-',
       'Jurdica',
       229,
       ' ' FROM DUAL
UNION ALL
SELECT 'TRA ',
       'FLGTIP',
       2,
       '-',
       'Entidade',
       230,
       ' ' FROM DUAL
UNION ALL
SELECT 'TRA ',
       'FLGTIP',
       3,
       '-',
       'Especial',
       231,
       ' ' FROM DUAL
UNION ALL
SELECT 'TRA ',
       'FLGTIP',
       4,
       '-',
       'M.E.',
       232,
       ' ' FROM DUAL
UNION ALL
SELECT 'TRA ',
       'FLGTIP',
       5,
       '-',
       'Filial',
       233,
       ' ' FROM DUAL
);

/*-- SEQ 9455 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TRC ',
       TO_NUMBER(null),
       'TRC ',
       '_Ttulos a receber',
       'TT_TRC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'TRC.CODFIL,TRC.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9456 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TRC ','--','' FROM DUAL
UNION ALL
SELECT 'TRC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TRC ','02','Datas' FROM DUAL
UNION ALL
SELECT 'TRC ','03','Valores' FROM DUAL
UNION ALL
SELECT 'TRC ','99','Outros' FROM DUAL
);

/*-- SEQ 9457 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21922,
       'CTA ',
       'TRC ',
       'N',
       '1',
       '',
       '',
       'TRC.FILCTA = CTA.CODFIL AND
TRC.SEQCTA = CTA.SEQUEN AND
TRC.TIPCTA = CTA.TIPCTA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21923,
       'CLI ',
       'TRC ',
       'N',
       '1',
       '',
       '',
       'CLI.FILCLI = TRC.FILPAR AND
CLI.CODCLI = TRC.CODPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21924,
       'USU ',
       'TRC ',
       'N',
       '1',
       '',
       '',
       'USU.FILUSU = TRC.FILUSU AND
USU.CODUSU = TRC.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21925,
       'CDEB',
       'TRC ',
       'N',
       '1',
       '',
       '',
       'CDEB.CODFIL = TRC.FILPAG AND
CDEB.SEQUEN = TRC.SEQPAG AND
CDEB.TIPCTA = TRC.TIPPAG',
       '',
       '' FROM DUAL
);

/*-- SEQ 9458 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TRC ',
       '02',
       9,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '01',
       28,
       5,
       'CODCTR',
       'G',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       'F',
       'A',
       'F',
       'Unidade de Negcios',
       'Unidade de Negcios',
       'TRC.CODCTR = DCTR.CODTAB',
       'CODCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '01',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = TRC.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '03',
       16,
       1,
       'CODMOE',
       'F',
       'DMOE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       '',
       'F',
       'A',
       'F',
       'Moeda',
       'Moeda',
       'DMOE.CODTAB = TRC.CODMOE',
       'CODMOE',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '01',
       4,
       6,
       'CODPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Parceiro',
       'Cdigo do Parceiro',
       '',
       'CODPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '01',
       5,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '01',
       15,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Usurio',
       'TRC.FILUSU = USU2.FILUSU(+) AND USU2.CODUSU(+) = TRC.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '02',
       7,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '03',
       12,
       12,
       'DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Desc/Acrscimo(%)',
       'Desc/Acrscimo(%)',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '01',
       29,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '01',
       3,
       3,
       'FILPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Parceiro',
       '',
       'FILPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '01',
       14,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '99',
       8,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '03',
       19,
       1,
       'INCOJU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Correo',
       'Correo',
       '',
       'INCOJU',
       'T' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '03',
       20,
       1,
       'INTPJU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Juros',
       'Tipo Juros',
       '',
       'INTPJU',
       'T' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '03',
       22,
       1,
       'INTPMU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Multa',
       'Tipo Multa',
       '',
       'INTPMU',
       'T' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '03',
       24,
       1,
       'MOEJUR',
       'S',
       'DMOE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       '',
       '',
       'N',
       'F',
       'Moeda Correo',
       'Moeda Correo',
       'DMOE.CODTAB = TRC.MOEJUR',
       'MOEJUR',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '01',
       6,
       8,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero',
       'Nmero da Nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '99',
       17,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(TRC.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '03',
       11,
       12,
       'OUTTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Outras Taxas',
       'Outras Taxas',
       '',
       'OUTTAX',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '99',
       26,
       10,
       'SEQCAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Seq. Cancelamento',
       '',
       'SEQCAN',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '99',
       30,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Seq. Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '99',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '99',
       23,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN TRC.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '99',
       51,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN TRC.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '01',
       27,
       3,
       'SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub-Srie',
       'Sub-Srie',
       '',
       'SUBSER',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '01',
       31,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '01',
       25,
       1,
       'TIPNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Nota',
       'Tipo de Nota',
       '',
       'TIPNOT',
       'T' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '01',
       41,
       12,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Lquido',
       'Valor Lquido',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '03',
       10,
       12,
       'VLRTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Total',
       'Valor Total',
       '',
       'VLRTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '03',
       18,
       12,
       'VLTXJU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Juros',
       'Juros',
       '',
       'VLTXJU',
       'F' FROM DUAL
UNION ALL
SELECT 'TRC ',
       '03',
       21,
       12,
       'VLTXMU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Multa',
       'Multa',
       '',
       'VLTXMU',
       'F' FROM DUAL
);

/*-- SEQ 9459 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'TRC ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRC ',
       'FLGEST',
       0,
       'Q',
       'Quitado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRC ',
       'FLGEST',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRC ',
       'INCOJU',
       0,
       '0',
       'SEM',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRC ',
       'INCOJU',
       0,
       '1',
       'Moeda 1',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRC ',
       'INCOJU',
       0,
       '2',
       'Moeda 2',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRC ',
       'INCOJU',
       0,
       '3',
       'Moeda 4',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRC ',
       'INCOJU',
       0,
       'A',
       'Anual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRC ',
       'INCOJU',
       0,
       'D',
       'Diria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRC ',
       'INCOJU',
       0,
       'M',
       'Mensal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRC ',
       'INTPJU',
       0,
       'C',
       'Composto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRC ',
       'INTPJU',
       0,
       'F',
       'Fixo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRC ',
       'INTPJU',
       0,
       'S',
       'Simples',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRC ',
       'INTPMU',
       0,
       '#',
       'Perc. Corrigido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRC ',
       'INTPMU',
       0,
       '$',
       'Valor Fixo ($)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRC ',
       'INTPMU',
       0,
       '%',
       'Percentual (%)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRC ',
       'INTPMU',
       0,
       '@',
       'Valor Corrigido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRC ',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRC ',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRC ',
       'TIPCTA',
       0,
       'N',
       'Destopia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRC ',
       'TIPNOT',
       0,
       'A',
       'NFF',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRC ',
       'TIPNOT',
       0,
       'F',
       'Fatura',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRC ',
       'TIPNOT',
       0,
       'N',
       'NF',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9460 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TRFC',
       TO_NUMBER(null),
       'TRFC',
       'Referncias Crdito',
       'TT_RFC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'TRFC.FILCLI, TRFC.CODCLI, TRFC.NUMRFC',
       '' FROM DUAL
);

/*-- SEQ 9461 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TRFC','--','' FROM DUAL
UNION ALL
SELECT 'TRFC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TRFC','99','Outros' FROM DUAL
);

/*-- SEQ 9462 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 24137,
       'CLI ',
       'TRFC',
       '1',
       'N',
       '',
       '',
       'CLI.FILCLI = TRFC.FILCLI AND
CLI.CODCLI = TRFC.CODCLI',
       '',
       '' FROM DUAL
);

/*-- SEQ 9463 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'TRFC',
       '99',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'TRFC',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       'F',
       'Cdigo do Parceiro',
       'Cdigo do Parceiro',
       '',
       'CODCLI',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'TRFC',
       '99',
       30,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'TRFC',
       '01',
       40,
       2,
       'DDDFON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'DDD',
       'DDD',
       '',
       'DDDFON',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'TRFC',
       '01',
       50,
       34,
       'ENDERE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Endereo',
       'Endereo',
       '',
       'ENDERE',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'TRFC',
       '01',
       60,
       254,
       'E_MAIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail',
       'E-mail',
       '',
       'E_MAIL',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'TRFC',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial do Parceiro',
       'Filial do Parceiro',
       'DFIL.CODFIL = TRFC.FILCLI',
       'FILCLI',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'TRFC',
       '01',
       80,
       40,
       'NOMRFC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome',
       'Nome',
       '',
       'NOMRFC',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'TRFC',
       '01',
       90,
       10,
       'NUMFON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Telefone',
       'Telefone',
       '',
       'NUMFON',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'TRFC',
       '01',
       100,
       4,
       'NUMRFC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero da Referncia',
       'Nmero da Referncia',
       '',
       'NUMRFC',
       'F',
       'P' FROM DUAL
);

/*-- SEQ 9464 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TRN ',
       TO_NUMBER(null),
       'TRN ',
       'Transaces Registrad',
       'TT_TRN',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'TRN.CODFIL, TRN.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9465 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TRN ','--','' FROM DUAL
UNION ALL
SELECT 'TRN ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TRN ','99','Outros' FROM DUAL
);

/*-- SEQ 9466 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TRN ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL(+) = TRN.CODFIL',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'TRN ',
       '99',
       50,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Srie',
       'Srie',
       '',
       'CODSER',
       '' FROM DUAL
UNION ALL
SELECT 'TRN ',
       '99',
       60,
       6,
       'CUPFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Nmero Cupom',
       'Nmero Cupom',
       '',
       'CUPFIS',
       '' FROM DUAL
UNION ALL
SELECT 'TRN ',
       '99',
       100,
       8,
       'DATINC',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       '' FROM DUAL
UNION ALL
SELECT 'TRN ',
       '99',
       90,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Status',
       'Status',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'TRN ',
       '99',
       80,
       10,
       'MSGERR',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Mensagem Erro',
       'Mensagem Erro',
       '',
       'RTF2TXT(MSGERR)',
       '' FROM DUAL
UNION ALL
SELECT 'TRN ',
       '99',
       30,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Nmerop ECF',
       'Nmerop ECF',
       '',
       'NUMECF',
       '' FROM DUAL
UNION ALL
SELECT 'TRN ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'TRN ',
       '99',
       40,
       12,
       'TRN_ID',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'ID da Transacao',
       'ID da Transacao',
       '',
       'TRN_ID',
       '' FROM DUAL
UNION ALL
SELECT 'TRN ',
       '99',
       70,
       0,
       'TXTTRN',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Contedo Transao',
       'Contedo Transao',
       '',
       'TXTTRN',
       '' FROM DUAL
);

/*-- SEQ 9467 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'TRN ',
       'FLGEST',
       0,
       '1',
       'OK',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRN ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'TRN ',
       'FLGEST',
       0,
       'P',
       'Pendenete',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9468 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TSF ',
       TO_NUMBER(null),
       'TSF ',
       'Subsdios de Frete',
       'TT_TSF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9469 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TSF ','--','' FROM DUAL
UNION ALL
SELECT 'TSF ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TSF ','99','Outros' FROM DUAL
);

/*-- SEQ 9470 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TSF ',
       '99',
       10,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'TSF ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL (+) = TSF.CODFIL',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'TSF ',
       '99',
       30,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo na Tabela',
       'Cdigo na Tabela (Cdigo da Categoria, Departamento ou Classe)',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'TSF ',
       '99',
       40,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'TSF ',
       '99',
       80,
       40,
       'DESTAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio Tabela',
       'Descrio na Tabela (Cdigo da Categoria, Departamento ou Classe)',
       '',
       'DescricaoSubsidioFrete(TSF.TABELA, TSF.CODTAB)',
       '' FROM DUAL
UNION ALL
SELECT 'TSF ',
       '99',
       50,
       5,
       'PERSUB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% de Subsdio',
       '% de Subsdio',
       '',
       'PERSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'TSF ',
       '01',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'TSF ',
       '99',
       70,
       12,
       'TABELA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tabela',
       'Tabela (Tabela de Categoria, Departamento ou Classe)',
       '',
       'TABELA',
       'T' FROM DUAL
);

/*-- SEQ 9471 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'TSF ',
       'TABELA',
       0,
       ' ',
       'Categoria 1',
       TO_NUMBER(null),
       'TD_CT1' FROM DUAL
UNION ALL
SELECT 'TSF ',
       'TABELA',
       0,
       ' ',
       'Categoria 2',
       TO_NUMBER(null),
       'TD_CT2' FROM DUAL
UNION ALL
SELECT 'TSF ',
       'TABELA',
       0,
       ' ',
       'Categoria 3',
       TO_NUMBER(null),
       'TD_CT3' FROM DUAL
UNION ALL
SELECT 'TSF ',
       'TABELA',
       0,
       ' ',
       'Classe 1',
       TO_NUMBER(null),
       'TD_CL1' FROM DUAL
UNION ALL
SELECT 'TSF ',
       'TABELA',
       0,
       ' ',
       'Classe 2',
       TO_NUMBER(null),
       'TD_CL2' FROM DUAL
UNION ALL
SELECT 'TSF ',
       'TABELA',
       0,
       ' ',
       'Classe 3',
       TO_NUMBER(null),
       'TD_CL3' FROM DUAL
UNION ALL
SELECT 'TSF ',
       'TABELA',
       0,
       ' ',
       'Classe 4',
       TO_NUMBER(null),
       'TD_CL4' FROM DUAL
UNION ALL
SELECT 'TSF ',
       'TABELA',
       0,
       ' ',
       'Departamento',
       TO_NUMBER(null),
       'TD_DEP' FROM DUAL
);

/*-- SEQ 9472 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TTRA',
       TO_NUMBER(null),
       'TTRA',
       'Transferncias',
       'TT_TRA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'TTRA.FILIVE,TTRA.SEQIVE,TTRA.NUMIVE',
       '' FROM DUAL
);

/*-- SEQ 9473 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TTRA','--','' FROM DUAL
UNION ALL
SELECT 'TTRA','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TTRA','99','Outros' FROM DUAL
);

/*-- SEQ 9474 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5925,
       'GRA ',
       'TTRA',
       '1 ',
       'N ',
       '',
       '',
       'GRA.FILMAT = TTRA.FILMAT and
GRA.CODMAT = TTRA.CODMAT and
GRA.CODCOR = TTRA.CODCOR and
GRA.CODTAM = TTRA.CODTAM',
       '' FROM DUAL
UNION ALL
SELECT 5926,
       'ICO ',
       'TTRA',
       '01',
       '1 ',
       '',
       '',
       'TTRA.FILICO = ICO.CODFIL (+) and
TTRA.SEQICO = ICO.SEQUEN (+) and
TTRA.NUMICO = ICO.NUMITE (+) ',
       '' FROM DUAL
UNION ALL
SELECT 5927,
       'IVE ',
       'TTRA',
       'N ',
       '1 ',
       '',
       '',
       'IVE.SEQUEN = TTRA.SEQIVE AND
IVE.CODFIL = TTRA.FILIVE AND
IVE.NUMITE = TTRA.NUMIVE',
       '' FROM DUAL
);

/*-- SEQ 9475 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TTRA',
       '01',
       10,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Diviso',
       'Diviso do produto',
       'DIV.CODITE (+) = TTRA.CODCOR',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'TTRA',
       '01',
       20,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo do Material',
       'Cdigo interno do produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'TTRA',
       '01',
       30,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'SUB.CODITE (+) = TTRA.CODTAM',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'TTRA',
       '01',
       40,
       3,
       'FILICO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Itens de Compra',
       '',
       'FILICO',
       'F' FROM DUAL
UNION ALL
SELECT 'TTRA',
       '01',
       50,
       3,
       'FILIVE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = TTRA.FILIVE',
       'FILIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'TTRA',
       '01',
       60,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'TTRA',
       '01',
       70,
       5,
       'NUMICO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Item~Transferncia',
       'Item de Transferncia',
       '',
       'NUMICO',
       'F' FROM DUAL
UNION ALL
SELECT 'TTRA',
       '01',
       80,
       5,
       'NUMIVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Item~Venda',
       'Item de Venda',
       '',
       'NUMIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'TTRA',
       '01',
       90,
       10,
       'SEQICO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Itens de Compras',
       '',
       'SEQICO',
       'F' FROM DUAL
UNION ALL
SELECT 'TTRA',
       '01',
       100,
       10,
       'SEQIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQIVE',
       'F' FROM DUAL
);

/*-- SEQ 9476 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'TUID',
       TO_NUMBER(null),
       'TUID',
       'Identificao do Log',
       'TT_UID',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9477 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'TUID','--','' FROM DUAL
UNION ALL
SELECT 'TUID','01','Identificao' FROM DUAL
UNION ALL
SELECT 'TUID','99','Outros' FROM DUAL
);

/*-- SEQ 9478 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'TUID',
       '--',
       90,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Assinatura para PAF-ECF',
       '',
       'ASSINA',
       'F' FROM DUAL
UNION ALL
SELECT 'TUID',
       '--',
       120,
       1,
       'ASSINS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       '',
       'Assina registros do PAF-ECF no insert?',
       '',
       'ASSINS',
       'F' FROM DUAL
UNION ALL
SELECT 'TUID',
       '--',
       110,
       5,
       'CODEMP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'U',
       '',
       '',
       'N',
       'F',
       'Cdigo da Empresa',
       'Cdigo da Empresa da Retaguarda',
       '',
       'CODEMP',
       'T' FROM DUAL
UNION ALL
SELECT 'TUID',
       '--',
       10,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Identificao do Log',
       'Identificao de Acesso',
       '',
       'CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'TUID',
       '--',
       20,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data',
       'Data',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'TUID',
       '--',
       30,
       30,
       'NOMMAQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Estao',
       'Estao',
       '',
       'NOMMAQ',
       'F' FROM DUAL
UNION ALL
SELECT 'TUID',
       '--',
       40,
       30,
       'NOMSIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mdulo',
       'Mdulo',
       '',
       'NOMSIS',
       'F' FROM DUAL
UNION ALL
SELECT 'TUID',
       '--',
       100,
       10,
       'SESSION_ID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Identificao da Sesso do Banco de Dados',
       '',
       'SESSION_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'TUID',
       '--',
       130,
       1,
       'TERMIN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       '',
       'Sesso de banco finalizada?',
       '',
       'TERMIN',
       'F' FROM DUAL
UNION ALL
SELECT 'TUID',
       '--',
       60,
       30,
       'USEROS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Usurio do SO',
       'Usurio do SO',
       '',
       'USEROS',
       'F' FROM DUAL
UNION ALL
SELECT 'TUID',
       '--',
       70,
       12,
       'VERBAS',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Verso da Base',
       'Verso da Base',
       '',
       'VERBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'TUID',
       '--',
       80,
       10,
       'VERSIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Verso do Sistema',
       'Verso do Sistema',
       '',
       'VERSIS',
       'F' FROM DUAL
);

/*-- SEQ 9479 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'USU ',
       0,
       'USU ',
       'Usurios',
       'TT_USU',
       'T',
       '',
       'TOTALL',
       'Usurios',
       '{FILUSU;CODUSU};ATU_EM',
       'CODSUP - CODEXT',
       'APEUSU',
       'Usurio',
       'T',
       '',
       'USU.FILUSU,USU.CODUSU
USU.APEUSU
USU.NOMUSU
USU.CODEXT',
       '' FROM DUAL
);

/*-- SEQ 9480 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'USU ','--','' FROM DUAL
UNION ALL
SELECT 'USU ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'USU ','02','Datas' FROM DUAL
UNION ALL
SELECT 'USU ','03','Valores' FROM DUAL
UNION ALL
SELECT 'USU ','04','Identificadoras do uso de PDA' FROM DUAL
UNION ALL
SELECT 'USU ','05','Financeiro' FROM DUAL
UNION ALL
SELECT 'USU ','06','Cobrana' FROM DUAL
UNION ALL
SELECT 'USU ','99','Outros' FROM DUAL
);

/*-- SEQ 9481 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 30240,
       'SUP ',
       'USU ',
       '1',
       'N',
       '',
       '',
       'SUP.FILUSU = USU.FILSUP and
SUP.CODUSU = USU.CODSUP',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30241,
       'PAR ',
       'USU ',
       '1',
       '1',
       '',
       '',
       'PAR.FILCLI = USU.FILCLI and
PAR.CODCLI = USU.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30242,
       'RCAI',
       'USU ',
       'N',
       '01',
       '',
       '',
       'usu.filusu(+) = rcai.filusu and
usu.codusu(+) = rcai.codusu',
       '',
       '' FROM DUAL
);

/*-- SEQ 9482 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'USU ',
       '99',
       290,
       1,
       'AGENDB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Acesso ao Agendador?',
       'Acesso ao Agendador?',
       '',
       'AGENDB',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '02',
       165,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'USU ',
       170,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'USU',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(USU.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '01',
       60,
       10,
       'APEUSU',
       'A',
       '',
       0,
       0,
       'USU ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'USU',
       'F',
       'A',
       'T',
       'Apelido Usurio',
       'Apelido do usurio',
       '',
       'APEUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       171,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN USU.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'USU ',
       '02',
       160,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'USU ',
       170,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'USU',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '01',
       510,
       1,
       'CFGINI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Grava Config. Tela?',
       'Se grava ou no as alteraes da formatao de telas',
       '',
       'CFGINI',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '01',
       25,
       6,
       'CHAVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'T',
       'Usurio(chave)',
       'Cdigo do Usurio(Chave)',
       '',
       'FILUSU||USU.CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       660,
       15,
       'CHVMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Cdigo de Matrcula',
       'Cdigo de Matrcula',
       '',
       'CHVMAT',
       '' FROM DUAL
UNION ALL
SELECT 'USU ',
       '01',
       190,
       6,
       'CODCLI',
       'A',
       '',
       0,
       0,
       'USU ',
       200,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'USU',
       'F',
       'A',
       'F',
       'Cdio~Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '03',
       230,
       5,
       'CODCTR',
       'S',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       'F',
       'N',
       'F',
       'Unidade de Negcios',
       'Unidade de Negcios',
       'DCTR.CODTAB = USU.CODCTR',
       'CODCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '01',
       30,
       10,
       'CODEXT',
       'A',
       '',
       0,
       0,
       'USU ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'USU',
       'F',
       'A',
       'T',
       'Cdigo Externo',
       'Cdigo externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '01',
       520,
       3,
       'CODINI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Format.Telas',
       'Cdigo do usurio de que se assume a formatao de telas',
       '',
       'CODINI',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       700,
       40,
       'CODPOS_USU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo POS CONTROLE',
       'Cdigo POS CONTROLE',
       '',
       'CODPOS_USU',
       '' FROM DUAL
UNION ALL
SELECT 'USU ',
       '01',
       300,
       5,
       'CODSET',
       'S',
       'DSET',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSET.DESSET',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Setor',
       'Cdigo Setor',
       'DSET.CODTAB = USU.CODSET',
       'CODSET',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '01',
       140,
       3,
       'CODSUP',
       'A',
       '',
       0,
       54,
       'USU ',
       150,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'USU',
       'F',
       'N',
       'F',
       'Cdigo Usu.Superior',
       'Cdigo usurio superior',
       '',
       'CODSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '01',
       20,
       3,
       'CODUSU',
       'A',
       '',
       0,
       0,
       'USU ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'USU',
       'F',
       '9',
       'T',
       'Cdigo Usurio',
       'Cdigo do Usurio',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '04',
       480,
       1,
       'COMIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Comunica. Impressora',
       'Comunicao com impressora ',
       '',
       'COMIMP',
       'T' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       550,
       32,
       'CSENHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Senha',
       'Senha',
       '',
       'CSENHA',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       310,
       1,
       'EDINDB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Editar Formatos?',
       'Editar Formatos?',
       '',
       'EDINDB',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       320,
       40,
       'E_MAIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail',
       'E-mail',
       '',
       'E_MAIL',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       440,
       1,
       'FAZENQ',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Faz Enquete?',
       'Faz Enquete?',
       '',
       'FAZENQ',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '01',
       460,
       1,
       'FAZMON',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Faz Montagem?',
       'Faz Montagem?',
       '',
       'FAZMON',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '01',
       40,
       3,
       'FILATV',
       'A',
       '',
       0,
       0,
       'USU ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'USU',
       'F',
       'N',
       'T',
       'Filial Locado',
       'Filial onde est alocado',
       '',
       'FILATV',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '01',
       180,
       3,
       'FILCLI',
       'A',
       '',
       0,
       0,
       'USU ',
       190,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'USU',
       'F',
       'A',
       'F',
       'Filial~Cliente',
       'Filial de origem do usurio como parceiro',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '05',
       560,
       3,
       'FILDIF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '05',
       570,
       3,
       'FILECT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILECT',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '--',
       560,
       3,
       'FILGER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'FILGER',
       '' FROM DUAL
UNION ALL
SELECT 'USU ',
       '01',
       530,
       3,
       'FILINI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Fillial Format.Telas',
       'Filial do usurio de que se assume a formatao de telas',
       '',
       'FILINI',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '01',
       130,
       3,
       'FILSUP',
       'A',
       '',
       0,
       0,
       'USU ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'USU',
       'F',
       'N',
       'F',
       '',
       'Filial usurio superior',
       '',
       'FILSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '01',
       10,
       3,
       'FILUSU',
       'A',
       'DFIL',
       0,
       0,
       'USU ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'USU',
       'F',
       'N',
       'T',
       'Filial de Origem',
       'Filial do Usurio',
       'USU.FILUSU = DFIL.CODFIL (+)',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       450,
       30,
       'FUNCAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Funo',
       'Funo',
       '',
       'FUNCAO',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       21,
       4000,
       'GRUPOS',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Grupos(Uso futuro)',
       'Grupos(Uso futuro)',
       '',
       'RTF2TXT(GRUPOS)',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       330,
       4,
       'HORDOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horrio Domingo',
       'Horrio Domingo',
       '',
       'HORDOM',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       340,
       4,
       'HORQUA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horrio Quarta',
       'Horrio Quarta',
       '',
       'HORQUA',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       350,
       4,
       'HORQUI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horrio Quinta',
       'Horrio Quinta',
       '',
       'HORQUI',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '06',
       580,
       12,
       'HORRATCOR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Hora Cortesia',
       'Valor pago por hora cortesia',
       '',
       'HORRATCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       360,
       4,
       'HORSAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horrio Sbado',
       'Horrio Sbado',
       '',
       'HORSAB',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       370,
       4,
       'HORSEG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horrio Segunda',
       'Horrio Segunda',
       '',
       'HORSEG',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       380,
       4,
       'HORSEX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horrio Sexta',
       'Horrio Sexta',
       '',
       'HORSEX',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       390,
       4,
       'HORTER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horrio Tera',
       'Horrio Tera',
       '',
       'HORTER',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       400,
       6,
       'INDPRO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'ndice Produtividade',
       'ndice Produtividade',
       '',
       'INDPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '03',
       220,
       14,
       'LIMCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Limite de Compras',
       'Limite de Compras',
       '',
       'LIMCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '03',
       650,
       12,
       'LIMCRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Limite crdito',
       'Limite de crdito para liberao',
       '',
       'LIMCRE',
       '' FROM DUAL
UNION ALL
SELECT 'USU ',
       '02',
       110,
       2,
       'MAIDAT',
       'S',
       '',
       0,
       0,
       'USU ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'USU',
       'F',
       'N',
       'F',
       'Maior Dia/Data',
       'Maior data possvel de uso em relao ao dia de hoje',
       '',
       'MAIDAT',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '02',
       250,
       5,
       'MAXDAT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Mx.dias aps venc.',
       'Mx. dias p/ aceitar baixa parcelas/lanamentos avulsos aps vencimento',
       '',
       'MAXDAT',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '02',
       131,
       2,
       'MENDAT',
       'S',
       '',
       0,
       0,
       'USU ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'USU',
       'F',
       'N',
       'F',
       'Menor Dia/Data',
       'Menor data possvel de uso em relao ao dia de hoje',
       '',
       'MENDAT',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '02',
       163,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'USU ',
       170,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'USU',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(USU.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '02',
       240,
       5,
       'MINDAT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Min.dias antes venc.',
       'Min. dias p/ aceitar baixa parcelas/lanamentos avulsos aps vencimento',
       '',
       'MINDAT',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '06',
       590,
       12,
       'MINRATCOB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% Hora Cobrada',
       'Percentual sobre hora cobrada',
       '',
       'MINRATCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '01',
       70,
       2,
       'NIVUSU',
       'S',
       '',
       0,
       15,
       'USU ',
       80,
       30,
       '',
       '',
       'D',
       'USU',
       'F',
       'A',
       'T',
       'Nvel',
       'Nvel do Usurio',
       '',
       'NIVUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'USU ',
       '01',
       50,
       30,
       'NOMUSU',
       'A',
       '',
       0,
       0,
       'USU ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'USU',
       'F',
       'A',
       'T',
       'Nome Usurio',
       'Nome do usurio',
       '',
       'NOMUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '04',
       490,
       3,
       'NUMPAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero do Palm',
       'Nmero do Palm',
       '',
       'NUMPAL',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       410,
       255,
       'PATNDB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path Consultas',
       'Path Consultas NetData',
       '',
       'PATNDB',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '02',
       80,
       8,
       'PERCOM',
       'F',
       '',
       2,
       0,
       'USU ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'USU',
       'T',
       '9',
       'T',
       '% Comisso',
       'Percentagem de comisso do usurio',
       '',
       'PERCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       150,
       1000,
       'PERMIS',
       'A',
       '',
       0,
       0,
       'USU ',
       160,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'USU',
       'F',
       'A',
       'F',
       'Lista de Permisses',
       'Lista das permisses',
       '',
       'PERMISSOESUSUARIO(FILUSU,CODUSU)',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '06',
       600,
       5,
       'PERRATCOB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Mnimo Hora Cobrada',
       'Valor mnimo sobre hora cobrada',
       '',
       'PERRATCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       690,
       6,
       'PRZPAG_MAX',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Prazo mdio mx. pag',
       'Prazo mdio mximo a pagar',
       '',
       'PRZPAG_MAX',
       '' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       680,
       6,
       'PRZPAG_MIN',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Prazo mdio mn. pag',
       'Prazo mdio mnimo a pagar',
       '',
       'PRZPAG_MIN',
       '' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       90,
       20,
       'SENHA1',
       'A',
       '',
       0,
       0,
       'USU ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'USU',
       'F',
       'A',
       'F',
       'Senha usu cripto. 1',
       'Senha do usurio - criptografia 1',
       '',
       'SENHA1',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       100,
       20,
       'SENHA2',
       'A',
       '',
       0,
       0,
       'USU ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'USU',
       'F',
       'A',
       'F',
       'Senha usu cripto. 2',
       'Senha do usurio - criptografia 2',
       '',
       'SENHA2',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '05',
       610,
       10,
       'SEQDIF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '05',
       620,
       10,
       'SEQECT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQECT',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '--',
       570,
       10,
       'SEQGER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       '',
       '',
       '',
       'SEQGER',
       '' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       170,
       2,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'USU ',
       180,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'USU',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN USU.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       640,
       255,
       'SNHPOP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Senha do Email',
       'Senha do Email',
       '',
       'SNHPOP',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       670,
       8,
       'SUPMAX',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Desc Max Superv',
       '% Desconto Mximo Permitido para Supervisor',
       '',
       'SUPMAX',
       '' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       22,
       15,
       'TABATU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Tabela Atual',
       'Tabela Atual',
       '',
       'TABATU',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '05',
       630,
       1,
       'TIPDIF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. Tipo Conta',
       'Ref. Tipo Conta',
       '',
       'TIPDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '--',
       580,
       1,
       'TIPGER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo Conta Gerencial',
       'Tipo Conta Gerencial',
       '',
       'TIPGER',
       'T' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       420,
       1,
       'USANDB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'UsarTOTALIBI Browser',
       'Usar TOTALI BI Browser?',
       '',
       'USANDB',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       430,
       1,
       'USANDC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'UsarTOTALIBI Config?',
       'Usar TOTALI BI Config?',
       '',
       'USANDC',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '01',
       470,
       1,
       'USUCOB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Usurio de Cobrana?',
       'Usurio de Cobrana?',
       '',
       'USUCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '04',
       500,
       7,
       'VALSEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Validade Senha',
       'Validade Senha',
       '',
       'VALSEN',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       280,
       100,
       'VISPER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Viso da Permisso',
       'Viso da Permisso',
       '',
       'VISPER',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       260,
       9,
       'VISSE1',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Senha1(Lite)',
       'Senha1(Lite)',
       '',
       'VISSE1',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '99',
       270,
       9,
       'VISSE2',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Senha2(Lite)',
       'Senha2(Lite)',
       '',
       'VISSE2',
       'F' FROM DUAL
UNION ALL
SELECT 'USU ',
       '01',
       540,
       1,
       'VISWOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'ltima~Visualizao',
       'ltima~Visualizao',
       '',
       'VISWOR',
       'T' FROM DUAL
);

/*-- SEQ 9483 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'USU ',
       'COMIMP',
       0,
       '0',
       'No Tem',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'USU ',
       'COMIMP',
       0,
       '1',
       'Infra Vermelho',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'USU ',
       'COMIMP',
       0,
       '2',
       'Serial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'USU ',
       'NIVUSU',
       0,
       '-',
       'Administrador',
       163,
       ' ' FROM DUAL
UNION ALL
SELECT 'USU ',
       'NIVUSU',
       1,
       '-',
       'Operador',
       164,
       ' ' FROM DUAL
UNION ALL
SELECT 'USU ',
       'NIVUSU',
       2,
       '-',
       'Vendedor',
       165,
       ' ' FROM DUAL
UNION ALL
SELECT 'USU ',
       'NIVUSU',
       3,
       '-',
       'Guia',
       166,
       ' ' FROM DUAL
UNION ALL
SELECT 'USU ',
       'VISWOR',
       0,
       'D',
       'Desenvolvimento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'USU ',
       'VISWOR',
       0,
       'I',
       'Implantao',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9484 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'USU2',
       0,
       'USU2',
       'Usurios',
       'TT_USU',
       'F',
       '',
       'TOTALL',
       'Usurios',
       '{FILUSU;CODUSU};ATU_EM',
       'CODSUP - CODEXT',
       'APEUSU',
       'Usurio',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9485 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'USU2','--','' FROM DUAL
UNION ALL
SELECT 'USU2','01','Identificao' FROM DUAL
);

/*-- SEQ 9486 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'USU2',
       '01',
       20,
       3,
       'CODUSU',
       'A',
       '',
       0,
       0,
       'USU ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'USU',
       'F',
       '9',
       'T',
       'Cdigo Usurio',
       'Cdigo do Usurio',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'USU2',
       '01',
       10,
       3,
       'FILUSU',
       'A',
       'DFIL',
       0,
       0,
       'USU ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'USU',
       'F',
       'N',
       'T',
       'Filial de Origem',
       'Filial do Usurio',
       'USU2.FILUSU = DFIL.CODFIL (+)',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'USU2',
       '01',
       50,
       30,
       'NOMUSU',
       'A',
       '',
       0,
       0,
       'USU ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'USU',
       'F',
       'A',
       'T',
       'Nome Usurio',
       'Nome do usurio',
       '',
       'NOMUSU',
       'F' FROM DUAL
);

/*-- SEQ 9487 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'UTL ',
       TO_NUMBER(null),
       'UTL ',
       'Dias teis por Filia',
       'TT_UTL',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'UTL.DATOPE, UTL.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 9488 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'UTL ','--','' FROM DUAL
UNION ALL
SELECT 'UTL ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'UTL ','99','Outros' FROM DUAL
);

/*-- SEQ 9489 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'UTL ',
       '01',
       2,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL = UTL.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'UTL ',
       '01',
       1,
       8,
       'DATOPE',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data',
       'Data',
       '',
       'DATOPE',
       '' FROM DUAL
UNION ALL
SELECT 'UTL ',
       '01',
       3,
       1,
       'FERABE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Feriado Loja Aberta?',
       'Feriado com Loja Aberta? ',
       '',
       'FERABE',
       '' FROM DUAL
);

/*-- SEQ 9490 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'V50C',
       TO_NUMBER(null),
       'V50C',
       'Fis. 50c',
       'TV_FIS_50C',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'V50C.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 9491 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'V50C','--','' FROM DUAL
UNION ALL
SELECT 'V50C','01','Identificao' FROM DUAL
UNION ALL
SELECT 'V50C','99','Outros' FROM DUAL
);

/*-- SEQ 9492 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'V50C',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = V50C.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'V50C',
       '01',
       20,
       7,
       'DATAOK',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data OK',
       'Data OK',
       '',
       'DATAOK',
       'F' FROM DUAL
UNION ALL
SELECT 'V50C',
       '01',
       30,
       126,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
);

/*-- SEQ 9493 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'V50V',
       TO_NUMBER(null),
       'V50V',
       'Fis. x 50v',
       'TV_FIS_50V',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'V50V.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 9494 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'V50V','--','' FROM DUAL
UNION ALL
SELECT 'V50V','01','Identificao' FROM DUAL
UNION ALL
SELECT 'V50V','99','Outros' FROM DUAL
);

/*-- SEQ 9495 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'V50V',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = V50V.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'V50V',
       '01',
       20,
       7,
       'DATAOK',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ok',
       'Data OK',
       '',
       'DATAOK',
       'F' FROM DUAL
UNION ALL
SELECT 'V50V',
       '01',
       30,
       126,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
);

/*-- SEQ 9496 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'V51C',
       TO_NUMBER(null),
       'V51C',
       'Fis. x 51c',
       'TV_FIS_51C',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'V51V.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 9497 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'V51C','--','' FROM DUAL
UNION ALL
SELECT 'V51C','01','Identificao' FROM DUAL
UNION ALL
SELECT 'V51C','99','Outros' FROM DUAL
);

/*-- SEQ 9498 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'V51C',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = V51C.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'V51C',
       '01',
       20,
       7,
       'DATAOK',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data OK',
       'Data OK',
       '',
       'DATAOK',
       'F' FROM DUAL
UNION ALL
SELECT 'V51C',
       '01',
       30,
       126,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
);

/*-- SEQ 9499 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'V51V',
       TO_NUMBER(null),
       'V51V',
       'Fis. x 51v',
       'TV_FIS_51V',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'V51V.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 9500 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'V51V','--','' FROM DUAL
UNION ALL
SELECT 'V51V','01','Identificao' FROM DUAL
UNION ALL
SELECT 'V51V','99','Outros' FROM DUAL
);

/*-- SEQ 9501 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'V51V',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = V51V.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'V51V',
       '01',
       20,
       7,
       'DATAOK',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ok',
       'Data OK',
       '',
       'DATAOK',
       'F' FROM DUAL
UNION ALL
SELECT 'V51V',
       '01',
       30,
       126,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
);

/*-- SEQ 9502 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'V53V',
       TO_NUMBER(null),
       'V53V',
       'Fis. x 53v',
       'TV_FIS_53V',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'V53V.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 9503 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'V53V','--','' FROM DUAL
UNION ALL
SELECT 'V53V','01','Identificao' FROM DUAL
UNION ALL
SELECT 'V53V','99','Outros' FROM DUAL
);

/*-- SEQ 9504 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'V53V',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = V53V.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'V53V',
       '01',
       20,
       7,
       'DATAOK',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ok',
       'Data OK',
       '',
       'DATAOK',
       'F' FROM DUAL
UNION ALL
SELECT 'V53V',
       '01',
       30,
       126,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
);

/*-- SEQ 9505 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'V54C',
       TO_NUMBER(null),
       'V54C',
       'Fis. x 54c',
       'TV_FIS_54C',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'V54C.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 9506 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'V54C','--','' FROM DUAL
UNION ALL
SELECT 'V54C','01','Identificao' FROM DUAL
UNION ALL
SELECT 'V54C','99','Outros' FROM DUAL
);

/*-- SEQ 9507 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'V54C',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = V54C.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'V54C',
       '01',
       20,
       7,
       'DATAOK',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ok',
       'Data OK',
       '',
       'DATAOK',
       'F' FROM DUAL
UNION ALL
SELECT 'V54C',
       '01',
       30,
       126,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
);

/*-- SEQ 9508 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'V54V',
       TO_NUMBER(null),
       'V54V',
       'Fis. x 54c',
       'TV_FIS_54V',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'V54V.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 9509 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'V54V','--','' FROM DUAL
UNION ALL
SELECT 'V54V','01','Identificao' FROM DUAL
UNION ALL
SELECT 'V54V','99','Outros' FROM DUAL
);

/*-- SEQ 9510 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'V54V',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = V54V.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'V54V',
       '01',
       20,
       7,
       'DATAOK',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ok',
       'Data OK',
       '',
       'DATAOK',
       'F' FROM DUAL
UNION ALL
SELECT 'V54V',
       '01',
       30,
       126,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
);

/*-- SEQ 9511 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'V60A',
       TO_NUMBER(null),
       'V60A',
       'Fis. x 60a',
       'TV_FIS_60A',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'V60A.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 9512 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'V60A','--','' FROM DUAL
UNION ALL
SELECT 'V60A','01','Identificao' FROM DUAL
UNION ALL
SELECT 'V60A','99','Outros' FROM DUAL
);

/*-- SEQ 9513 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'V60A',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = V60A.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'V60A',
       '01',
       20,
       7,
       'DATAOK',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ok',
       'Data OK',
       '',
       'DATAOK',
       'F' FROM DUAL
UNION ALL
SELECT 'V60A',
       '01',
       30,
       126,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'V60A',
       '01',
       40,
       37,
       'ORDEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ordem',
       'Ordem',
       '',
       'ORDEM',
       'F' FROM DUAL
);

/*-- SEQ 9514 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'V60D',
       TO_NUMBER(null),
       'V60D',
       'Fis. x 60D',
       'TV_FIS_60D',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'V60D.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 9515 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'V60D','--','' FROM DUAL
UNION ALL
SELECT 'V60D','01','Identificao' FROM DUAL
UNION ALL
SELECT 'V60D','99','Outros' FROM DUAL
);

/*-- SEQ 9516 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'V60D',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = V60D.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'V60D',
       '--',
       20,
       7,
       'DATAOK',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ok',
       'Data OK',
       '',
       'DATAOK',
       'F' FROM DUAL
UNION ALL
SELECT 'V60D',
       '--',
       30,
       126,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'V60D',
       '--',
       40,
       37,
       'ORDEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ordem',
       'Ordem',
       '',
       'ORDEM',
       'F' FROM DUAL
);

/*-- SEQ 9517 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'V60I',
       TO_NUMBER(null),
       'V60I',
       'Fis. x 60i',
       'TV_FIS_60I',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'V60I.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 9518 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'V60I','--','' FROM DUAL
UNION ALL
SELECT 'V60I','01','Identificao' FROM DUAL
UNION ALL
SELECT 'V60I','99','Outros' FROM DUAL
);

/*-- SEQ 9519 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'V60I',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = V60I.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'V60I',
       '01',
       20,
       7,
       'DATAOK',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ok',
       'Data OK',
       '',
       'DATAOK',
       'F' FROM DUAL
UNION ALL
SELECT 'V60I',
       '01',
       30,
       126,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'V60I',
       '01',
       40,
       37,
       'ORDEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ordem',
       'Ordem',
       '',
       'ORDEM',
       'F' FROM DUAL
);

/*-- SEQ 9520 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'V60M',
       TO_NUMBER(null),
       'V60M',
       'Fis. x 60m',
       'TV_FIS_60M',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'V60M.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 9521 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'V60M','--','' FROM DUAL
UNION ALL
SELECT 'V60M','01','Identificao' FROM DUAL
UNION ALL
SELECT 'V60M','99','Outros' FROM DUAL
);

/*-- SEQ 9522 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'V60M',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = V60M.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'V60M',
       '01',
       20,
       7,
       'DATAOK',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ok',
       'Data OK',
       '',
       'DATAOK',
       'F' FROM DUAL
UNION ALL
SELECT 'V60M',
       '01',
       30,
       126,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'V60M',
       '01',
       40,
       37,
       'ORDEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ordem',
       'Ordem',
       '',
       'ORDEM',
       'F' FROM DUAL
);

/*-- SEQ 9523 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'V60R',
       TO_NUMBER(null),
       'V60R',
       'Fis. x 60r',
       'TV_FIS_60R',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'V60R.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 9524 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'V60R','--','' FROM DUAL
UNION ALL
SELECT 'V60R','01','Identificao' FROM DUAL
UNION ALL
SELECT 'V60R','99','Outros' FROM DUAL
);

/*-- SEQ 9525 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'V60R',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = V60R.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'V60R',
       '01',
       20,
       7,
       'DATAOK',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ok',
       'Data OK',
       '',
       'DATAOK',
       'F' FROM DUAL
UNION ALL
SELECT 'V60R',
       '01',
       30,
       126,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'V60R',
       '01',
       40,
       37,
       'ORDEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ordem',
       'Ordem',
       '',
       'ORDEM',
       'F' FROM DUAL
);

/*-- SEQ 9526 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'V70C',
       TO_NUMBER(null),
       'V70C',
       'Fis. x 70C',
       'TV_FIS_70C',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'V70C.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 9527 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'V70C','--','' FROM DUAL
UNION ALL
SELECT 'V70C','01','Identificao' FROM DUAL
UNION ALL
SELECT 'V70C','99','Outros' FROM DUAL
);

/*-- SEQ 9528 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'V70C',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = V70C.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'V70C',
       '01',
       20,
       7,
       'DATAOK',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ok',
       'Data OK',
       '',
       'DATAOK',
       'F' FROM DUAL
UNION ALL
SELECT 'V70C',
       '01',
       30,
       126,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
);

/*-- SEQ 9529 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'V74C',
       TO_NUMBER(null),
       'V74C',
       'Fis.74 Cus.Rep.',
       'TV_FIS_74_CUSREP',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'v74c.codfil',
       '' FROM DUAL
);

/*-- SEQ 9530 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'V74C','--','' FROM DUAL
UNION ALL
SELECT 'V74C','01','Identificao' FROM DUAL
UNION ALL
SELECT 'V74C','99','Outros' FROM DUAL
);

/*-- SEQ 9531 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'V74C',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = V74C.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'V74C',
       '01',
       20,
       126,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
);

/*-- SEQ 9532 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'V74P',
       TO_NUMBER(null),
       'V74P',
       'Fis.74 Preo M.',
       'TV_FIS_74_PRECOM',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'V74P.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 9533 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'V74P','--','' FROM DUAL
UNION ALL
SELECT 'V74P','01','Identificao' FROM DUAL
UNION ALL
SELECT 'V74P','99','Outros' FROM DUAL
);

/*-- SEQ 9534 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'V74P',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = V74P.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'V74P',
       '01',
       20,
       126,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
);

/*-- SEQ 9535 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VAE1',
       TO_NUMBER(null),
       'VAE1',
       'Relao Pedido BASF',
       'TV_PED_BASF_AE1',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9536 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VAE1','--','' FROM DUAL
UNION ALL
SELECT 'VAE1','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VAE1','99','Outros' FROM DUAL
);

/*-- SEQ 9537 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VAE1',
       '99',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'V',
       '',
       '',
       '0',
       'F',
       'Cdigo Filial ',
       'Cdigo Filial ',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE1',
       '99',
       20,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '9',
       'F',
       'Cdigo Fornecedor',
       'Cdigo Fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE1',
       '99',
       30,
       7,
       'DATENV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data/Hora de Envio',
       'Data/Hora de Envio',
       '',
       'DATENV',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE1',
       '99',
       40,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '0',
       'F',
       'Filial Fornecedor',
       'Filial Fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE1',
       '99',
       50,
       247,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Layout de Exportao',
       'Linha do Layout de Exportao',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE1',
       '99',
       60,
       12,
       'NUMITE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'N Item',
       'Nmero do Item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE1',
       '99',
       70,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'N Pedido',
       'Nmero do Pedido de Compra',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE1',
       '99',
       80,
       1,
       'REFFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. Fornecedor',
       'Cdigo de Referncia do Produto no Fornecedor',
       '',
       'REFFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE1',
       '99',
       90,
       1,
       'TIPFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Fornecedor',
       'Tipo Fornecedor',
       '',
       'TIPFOR',
       'F' FROM DUAL
);

/*-- SEQ 9538 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VAE2',
       TO_NUMBER(null),
       'VAE2',
       'Itens Pedido BASF',
       'TV_PED_BASF_AE2',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9539 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VAE2','--','' FROM DUAL
UNION ALL
SELECT 'VAE2','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VAE2','99','Outros' FROM DUAL
);

/*-- SEQ 9540 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VAE2',
       '99',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'V',
       '',
       '',
       '0',
       'F',
       'Cdigo Filial ',
       'Cdigo Filial ',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE2',
       '99',
       20,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '9',
       'F',
       'Cdigo Fornecedor',
       'Cdigo Fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE2',
       '99',
       30,
       7,
       'DATENV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data/Hora de Envio',
       'Data/Hora de Envio',
       '',
       'DATENV',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE2',
       '99',
       40,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '0',
       'F',
       'Filial Fornecedor',
       'Filial Fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE2',
       '99',
       50,
       247,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Layout de Exportao',
       'Linha do Layout de Exportao',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE2',
       '99',
       60,
       12,
       'NUMITE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'N Item',
       'Nmero do Item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE2',
       '99',
       70,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'N Pedido',
       'Nmero do Pedido de Compra',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE2',
       '99',
       80,
       1,
       'REFFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. Fornecedor',
       'Cdigo de Referncia do Produto no Fornecedor',
       '',
       'REFFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE2',
       '99',
       90,
       1,
       'TIPFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Fornecedor',
       'Tipo Fornecedor',
       '',
       'TIPFOR',
       'F' FROM DUAL
);

/*-- SEQ 9541 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VAE3',
       TO_NUMBER(null),
       'VAE3',
       'Entregas Pedido BASF',
       'TV_PED_BASF_AE3',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9542 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VAE3','--','' FROM DUAL
UNION ALL
SELECT 'VAE3','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VAE3','99','Outros' FROM DUAL
);

/*-- SEQ 9543 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VAE3',
       '99',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'V',
       '',
       '',
       '0',
       'F',
       'Cdigo Filial ',
       'Cdigo Filial ',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE3',
       '99',
       20,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '9',
       'F',
       'Cdigo Fornecedor',
       'Cdigo Fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE3',
       '99',
       30,
       7,
       'DATENV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data/Hora de Envio',
       'Data/Hora de Envio',
       '',
       'DATENV',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE3',
       '99',
       40,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '0',
       'F',
       'Filial Fornecedor',
       'Filial Fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE3',
       '99',
       50,
       247,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Layout de Exportao',
       'Linha do Layout de Exportao',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE3',
       '99',
       60,
       12,
       'NUMITE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'N Item',
       'Nmero do Item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE3',
       '99',
       70,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'N Pedido',
       'Nmero do Pedido de Compra',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE3',
       '99',
       80,
       1,
       'REFFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. Fornecedor',
       'Cdigo de Referncia do Produto no Fornecedor',
       '',
       'REFFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE3',
       '99',
       90,
       1,
       'TIPFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Fornecedor',
       'Tipo Fornecedor',
       '',
       'TIPFOR',
       'F' FROM DUAL
);

/*-- SEQ 9544 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VAE4',
       TO_NUMBER(null),
       'VAE4',
       'Item Entrega BASF',
       'TV_PED_BASF_AE2_AE3',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9545 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VAE4','--','' FROM DUAL
UNION ALL
SELECT 'VAE4','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VAE4','99','Outros' FROM DUAL
);

/*-- SEQ 9546 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VAE4',
       '99',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'V',
       '',
       '',
       '0',
       'F',
       'Cdigo Filial ',
       'Cdigo Filial ',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE4',
       '99',
       20,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '9',
       'F',
       'Cdigo Fornecedor',
       'Cdigo Fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE4',
       '99',
       30,
       7,
       'DATENV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data/Hora de Envio',
       'Data/Hora de Envio',
       '',
       'DATENV',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE4',
       '99',
       40,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '0',
       'F',
       'Filial Fornecedor',
       'Filial Fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE4',
       '99',
       50,
       247,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Layout de Exportao',
       'Linha do Layout de Exportao',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE4',
       '99',
       60,
       12,
       'NUMITE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'N Item',
       'Nmero do Item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE4',
       '99',
       70,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'N Pedido',
       'Nmero do Pedido de Compra',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE4',
       '99',
       80,
       1,
       'REFFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. Fornecedor',
       'Cdigo de Referncia do Produto no Fornecedor',
       '',
       'REFFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VAE4',
       '99',
       90,
       1,
       'TIPFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Fornecedor',
       'Tipo Fornecedor',
       '',
       'TIPFOR',
       'F' FROM DUAL
);

/*-- SEQ 9547 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VAEU',
       TO_NUMBER(null),
       'VAEU',
       'Aux. Estrutura Uso',
       'TV_AUX_ECT_USO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9548 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VAEU','--','' FROM DUAL
UNION ALL
SELECT 'VAEU','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VAEU','99','Outros' FROM DUAL
);

/*-- SEQ 9549 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VAEU',
       '01',
       10,
       14,
       'CHVPAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave Pai',
       'Chave Pai',
       '',
       'CHVPAI',
       'F' FROM DUAL
UNION ALL
SELECT 'VAEU',
       '01',
       20,
       14,
       'CHVPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave Projeto',
       'Chave Projeto',
       '',
       'CHVPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'VAEU',
       '01',
       30,
       250,
       'TITECT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tt.Estrutura Contas',
       'Tt.Estrutura Contas',
       '',
       'TITECT',
       'F' FROM DUAL
);

/*-- SEQ 9550 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VARE',
       TO_NUMBER(null),
       'VARE',
       'A Receber',
       'TV_ARE',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9551 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VARE','--','' FROM DUAL
UNION ALL
SELECT 'VARE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VARE','02','Datas' FROM DUAL
UNION ALL
SELECT 'VARE','03','Valores' FROM DUAL
UNION ALL
SELECT 'VARE','99','Outros' FROM DUAL
);

/*-- SEQ 9552 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 38651,
       'CLI ',
       'VARE',
       '1 ',
       '0N',
       '',
       '',
       'CLI.FILCLI = VARE.FILCLI(+) AND
CLI.CODCLI = VARE.CODCLI(+) ',
       '' FROM DUAL
UNION ALL
SELECT 38780,
       'CTA ',
       'VARE',
       '1 ',
       '0N',
       '',
       '',
       'VARE.FILCTA=CTA.FILCTA(+) AND 
VARE.SEQCTA=CTA.SEQCTA(+)
',
       '' FROM DUAL
);

/*-- SEQ 9553 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VARE',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VARE',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VARE.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VARE',
       '02',
       90,
       7,
       'COMPET',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Competncia',
       'Data de Competcia',
       '',
       'COMPET',
       'F' FROM DUAL
UNION ALL
SELECT 'VARE',
       '02',
       100,
       7,
       'DATPRE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Prevista',
       'Data Prevista',
       '',
       'DATPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VARE',
       '02',
       30,
       7,
       'DATVEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Vencimento',
       'Data Vencimento',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VARE',
       '01',
       110,
       27,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VARE',
       '01',
       40,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VARE',
       '01',
       120,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VARE',
       '01',
       50,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'U',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Cdigo da Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VARE',
       '01',
       130,
       1,
       'FLGFLU',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FLGFLU',
       'F' FROM DUAL
UNION ALL
SELECT 'VARE',
       '01',
       140,
       12,
       'MEDATR',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Mdia de Atraso',
       'Mdia de Atraso',
       '',
       'MEDATR',
       'F' FROM DUAL
UNION ALL
SELECT 'VARE',
       '01',
       25,
       3,
       'NUMCODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'VARE',
       '01',
       150,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Parcela',
       'Nmero Parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VARE',
       '01',
       160,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VARE',
       '01',
       170,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VARE',
       '01',
       60,
       1,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VARE',
       '01',
       180,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Subparcela',
       'Subparcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VARE',
       '01',
       190,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem',
       'Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VARE',
       '01',
       200,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VARE',
       '01',
       70,
       34,
       'TIPREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Recebimento',
       'Tipo Recebimento',
       '',
       'TIPREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VARE',
       '03',
       80,
       12,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Parcela',
       'Valor Parcela',
       '',
       'VLRPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VARE',
       '03',
       210,
       12,
       'VLRPRE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Previsto',
       'Valor Previsto',
       '',
       'VLRPRE',
       'F' FROM DUAL
);

/*-- SEQ 9554 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VARE',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VARE',
       'FLGEST',
       0,
       'R',
       'Realizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VARE',
       'STATUS',
       0,
       'A',
       'A Vencer',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VARE',
       'STATUS',
       0,
       'V',
       'Vencidas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VARE',
       'TABORI',
       0,
       ' ',
       'Contrato',
       TO_NUMBER(null),
       'CTT' FROM DUAL
UNION ALL
SELECT 'VARE',
       'TABORI',
       0,
       ' ',
       'Conta Corrente',
       TO_NUMBER(null),
       'CCC' FROM DUAL
UNION ALL
SELECT 'VARE',
       'TABORI',
       0,
       ' ',
       'Parcela',
       TO_NUMBER(null),
       'REC' FROM DUAL
UNION ALL
SELECT 'VARE',
       'TABORI',
       0,
       ' ',
       'Cheque',
       TO_NUMBER(null),
       'CHR' FROM DUAL
UNION ALL
SELECT 'VARE',
       'TABORI',
       0,
       ' ',
       'Ttulo Avulso',
       TO_NUMBER(null),
       'PTR' FROM DUAL
UNION ALL
SELECT 'VARE',
       'TABORI',
       0,
       ' ',
       'Carto',
       TO_NUMBER(null),
       'TEF' FROM DUAL
);

/*-- SEQ 9555 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VAT ',
       TO_NUMBER(null),
       'VAT ',
       'Verses  Atualizao',
       'TT_VAT',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VAT.CODTAB',
       '' FROM DUAL
);

/*-- SEQ 9556 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VAT ','--','' FROM DUAL
UNION ALL
SELECT 'VAT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VAT ','99','Outros' FROM DUAL
);

/*-- SEQ 9557 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VAT ',
       '--',
       10,
       10,
       'CODTAB',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Sequenciador',
       'Sequenciador',
       '',
       'CODTAB',
       '' FROM DUAL
UNION ALL
SELECT 'VAT ',
       '--',
       40,
       1,
       'DETVER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Letra da Verso',
       'Letra da Verso',
       '',
       'DETVER',
       '' FROM DUAL
UNION ALL
SELECT 'VAT ',
       '--',
       20,
       2,
       'MODULO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Mdulo',
       'Mdulo',
       '',
       'MODULO',
       'T' FROM DUAL
UNION ALL
SELECT 'VAT ',
       '--',
       50,
       2,
       'RELEAS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Release',
       'Release',
       '',
       'RELEAS',
       '' FROM DUAL
UNION ALL
SELECT 'VAT ',
       '--',
       30,
       4,
       'VERSAO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Verso',
       'Verso',
       '',
       'VERSAO',
       '' FROM DUAL
);

/*-- SEQ 9558 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VAT ',
       'MODULO',
       1,
       ' ',
       'Checkout 4G',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9559 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VAV ',
       TO_NUMBER(null),
       'VAV ',
       'Parcelas a Receber',
       'TV_VAV',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9560 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VAV ','--','' FROM DUAL
UNION ALL
SELECT 'VAV ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VAV ','02','Valores' FROM DUAL
);

/*-- SEQ 9561 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VAV ',
       '02',
       8,
       12,
       'AVEATE030',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vencer at 30 dias',
       'Vencer de hoje at 30 dias',
       '',
       'AVEATE030',
       'F' FROM DUAL
UNION ALL
SELECT 'VAV ',
       '02',
       9,
       12,
       'AVEATE060',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vencer at 60 dias',
       'Vencer de 31 at 60 dias',
       '',
       'AVEATE060',
       'F' FROM DUAL
UNION ALL
SELECT 'VAV ',
       '02',
       10,
       12,
       'AVEATE090',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vencer at 90 dias',
       'Vencer de 61 at 90 dias',
       '',
       'AVEATE090',
       'F' FROM DUAL
UNION ALL
SELECT 'VAV ',
       '02',
       11,
       12,
       'AVEATE120',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vencer at 120 dias',
       'Vencer de 91 at 120 dias',
       '',
       'AVEATE120',
       'F' FROM DUAL
UNION ALL
SELECT 'VAV ',
       '02',
       12,
       12,
       'AVEMAI120',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vencer aps 120 dias',
       'Vencer aps 120 dias',
       '',
       'AVEMAI120',
       'F' FROM DUAL
UNION ALL
SELECT 'VAV ',
       '01',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'VAV.CODFIL = DFIL.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'VAV ',
       '01',
       22,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VAV ',
       '01',
       2,
       5,
       'PORTAD',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       'F',
       '9',
       'F',
       'Portador',
       'Portador',
       'VAV.PORTAD=DCOB.CODTAB(+)',
       'PORTAD',
       'T' FROM DUAL
UNION ALL
SELECT 'VAV ',
       '01',
       32,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VAV ',
       '01',
       42,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VAV ',
       '02',
       7,
       12,
       'VENATE030',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Venc. hoje',
       'Vencidas de hoje at 30 dias',
       '',
       'VENATE030',
       'F' FROM DUAL
UNION ALL
SELECT 'VAV ',
       '02',
       6,
       12,
       'VENATE060',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Venc. aps 31 dias',
       'Vencidas entre 31 a 60 dias',
       '',
       'VENATE060',
       'F' FROM DUAL
UNION ALL
SELECT 'VAV ',
       '02',
       5,
       12,
       'VENATE090',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Venc. aps 61 dias',
       'Vencidas entre 61 a 90 dias',
       '',
       'VENATE090',
       'F' FROM DUAL
UNION ALL
SELECT 'VAV ',
       '02',
       4,
       12,
       'VENATE120',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Venc. aps 91 dias',
       'Vencidas entre 91 a 120 dias',
       '',
       'VENATE120',
       'F' FROM DUAL
UNION ALL
SELECT 'VAV ',
       '02',
       3,
       12,
       'VENMAI120',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Venc. aps 120 dias',
       'Vencidas aps 120 dias',
       '',
       'VENMAI120',
       'F' FROM DUAL
);

/*-- SEQ 9562 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VAV ',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VAV ',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VAV ',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9563 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VAVA',
       TO_NUMBER(null),
       'VAVA',
       'Tabela de Avaliaes',
       'TV_AVA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9564 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VAVA','--','' FROM DUAL
UNION ALL
SELECT 'VAVA','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VAVA','99','Outros' FROM DUAL
);

/*-- SEQ 9565 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VAVA',
       '--',
       10,
       3,
       'CODADO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Cdigo do Avaliado',
       'Cdigo do Avaliado',
       '',
       'CODADO',
       'F' FROM DUAL
UNION ALL
SELECT 'VAVA',
       '--',
       20,
       3,
       'FILADO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Filial do Avaliado',
       'Filial do Avaliado',
       '',
       'FILADO',
       'F' FROM DUAL
UNION ALL
SELECT 'VAVA',
       '--',
       30,
       30,
       'NOMUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Nome do Avaliado',
       'Nome do Avaliado',
       '',
       'NOMUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VAVA',
       '--',
       40,
       2,
       'NOTAVA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Nota da Avaliao',
       'Nota da Avaliao',
       '',
       'NOTAVA',
       'F' FROM DUAL
);

/*-- SEQ 9566 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VAVI',
       TO_NUMBER(null),
       'VAVI',
       'Avisos a motoristas',
       'TV_AVI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VAVI.CODFIL,VAVI.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9567 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VAVI','--','' FROM DUAL
UNION ALL
SELECT 'VAVI','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VAVI','99','Outros' FROM DUAL
);

/*-- SEQ 9568 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VAVI',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VAVI',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Codigo da filial',
       'DFIL.CODFIL = VAVI.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VAVI',
       '01',
       30,
       7,
       'DATENT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Entrega da Mensagem',
       'Data entrega da mensagem',
       '',
       'DATENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VAVI',
       '01',
       40,
       7,
       'DATEXP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Expira em:',
       'Data de Expirao',
       '',
       'DATEXP',
       'F' FROM DUAL
UNION ALL
SELECT 'VAVI',
       '01',
       50,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Incluso Msg',
       'Data incluso da mensagem',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'VAVI',
       '01',
       60,
       17,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VAVI',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VAVI',
       '01',
       80,
       4000,
       'MENSAG',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem',
       'Mensagem',
       '',
       'RTF2TXT(MENSAG)',
       'F' FROM DUAL
UNION ALL
SELECT 'VAVI',
       '01',
       90,
       15,
       'NOMFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Filial',
       'Nome Filial',
       '',
       'NOMFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VAVI',
       '01',
       100,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Documento',
       'Nmero do Documento: CGC ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VAVI',
       '01',
       110,
       7,
       'PLACAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Placa Veiculo',
       'Placa do veiculo',
       '',
       'PLACAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VAVI',
       '01',
       120,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 9569 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VBAS',
       TO_NUMBER(null),
       'VBAS',
       'Pedido BASF',
       'TV_PED_BASF',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9570 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VBAS','--','' FROM DUAL
UNION ALL
SELECT 'VBAS','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VBAS','99','Outros' FROM DUAL
);

/*-- SEQ 9571 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VBAS',
       '99',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'V',
       '',
       '',
       '0',
       'F',
       'Cdigo Filial ',
       'Cdigo Filial ',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VBAS',
       '99',
       20,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '9',
       'F',
       'Cdigo Fornecedor',
       'Cdigo Fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VBAS',
       '99',
       30,
       7,
       'DATENV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data/Hora de Envio',
       'Data/Hora de Envio',
       '',
       'DATENV',
       'F' FROM DUAL
UNION ALL
SELECT 'VBAS',
       '99',
       40,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '0',
       'F',
       'Filial Fornecedor',
       'Filial Fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VBAS',
       '99',
       50,
       247,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Layout de Exportao',
       'Linha do Layout de Exportao',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'VBAS',
       '99',
       60,
       12,
       'NUMITE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'N Item',
       'Nmero do Item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VBAS',
       '99',
       70,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'N Pedido',
       'Nmero do Pedido de Compra',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'VBAS',
       '99',
       80,
       1,
       'REFFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. Fornecedor',
       'Cdigo de Referncia do Produto no Fornecedor',
       '',
       'REFFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VBAS',
       '99',
       90,
       1,
       'TIPFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Fornecedor',
       'Tipo Fornecedor',
       '',
       'TIPFOR',
       'F' FROM DUAL
);

/*-- SEQ 9572 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCAI',
       TO_NUMBER(null),
       'VCAI',
       'Complemento Caixa',
       'TV_CAI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'vcai.codfil,vcai.sequen',
       '' FROM DUAL
);

/*-- SEQ 9573 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCAI','--','' FROM DUAL
UNION ALL
SELECT 'VCAI','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCAI','99','Outros' FROM DUAL
);

/*-- SEQ 9574 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCAI',
       '01',
       10,
       5,
       'CODCAI',
       'S',
       'DCAI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCAI.CX_DES',
       'V',
       '',
       '',
       'N',
       'F',
       'Descrio do Caixa',
       'Descrio do Caixa',
       'DCAI.CODTAB(+) = VCAI.CODCAI',
       'CODCAI',
       'T' FROM DUAL
UNION ALL
SELECT 'VCAI',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = VCAI.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCAI',
       '01',
       30,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       'F',
       'Serie',
       'Serie',
       'DSER.CODSER(+) = VCAI.CODSER',
       'CODSER',
       'T' FROM DUAL
UNION ALL
SELECT 'VCAI',
       '01',
       40,
       30,
       'MEIO_P',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Meio de Pagamento',
       'Meio de Pagamento',
       '',
       'MEIO_P',
       'F' FROM DUAL
UNION ALL
SELECT 'VCAI',
       '01',
       41,
       16,
       'MEIO_P_REDUZ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Abrev. Meio Pgto',
       'Abreviatura do Meio de Pagamento',
       '',
       'MEIO_P_REDUZ',
       'F' FROM DUAL
UNION ALL
SELECT 'VCAI',
       '01',
       50,
       1,
       'ORIGEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem',
       'Origem',
       '',
       'ORIGEM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCAI',
       '01',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCAI',
       '01',
       70,
       12,
       'VLRLAN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor',
       '',
       'VLRLAN',
       'F' FROM DUAL
);

/*-- SEQ 9575 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VCAI',
       'ORIGEM',
       0,
       '1',
       'Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCAI',
       'ORIGEM',
       0,
       '2',
       'Recebimento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCAI',
       'ORIGEM',
       0,
       '3',
       'Sangria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCAI',
       'ORIGEM',
       0,
       '4',
       'Reforo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCAI',
       'ORIGEM',
       0,
       '5',
       'Depsito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCAI',
       'ORIGEM',
       0,
       '6',
       'Retirada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCAI',
       'ORIGEM',
       0,
       '7',
       'Recebimento de devoluo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCAI',
       'ORIGEM',
       0,
       '8',
       'Devoluo de Vendas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCAI',
       'ORIGEM',
       0,
       '9',
       'Diferena',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCAI',
       'ORIGEM',
       0,
       'T',
       'Recebimento de terceiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9576 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCCS',
       TO_NUMBER(null),
       'VCCS',
       'Saldos CCs',
       'TV_CCC_SAL',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9577 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCCS','--','' FROM DUAL
UNION ALL
SELECT 'VCCS','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCCS','99','Outros' FROM DUAL
);

/*-- SEQ 9578 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20786,
       'CLI ',
       'VCCS',
       '1',
       '1',
       '',
       '',
       'VCCS.FILCLI = CLI.FILCLI AND
VCCS.CODCLI = CLI.CODCLI',
       '',
       '' FROM DUAL
);

/*-- SEQ 9579 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'VCCS',
       '01',
       110,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo',
       'Ativo?',
       '',
       'ATIVO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VCCS',
       '01',
       30,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VCCS',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VCCS',
       '01',
       15,
       3,
       'CODFILNOM',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Cod. Nome Filial',
       'Cdigo do Nome da Filial',
       'DFIL.CODFIL(+) = VCCS.CODFIL',
       'NOMFIL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VCCS',
       '99',
       50,
       12,
       'CREDITO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Crdito~Perodo',
       'Crdito Perodo',
       '',
       'CREDITO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VCCS',
       '01',
       100,
       8,
       'DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Final',
       'Data Final',
       '',
       'DATFIM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VCCS',
       '01',
       90,
       8,
       'DATINI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Inicial',
       'Data Inicial',
       '',
       'DATINI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VCCS',
       '99',
       60,
       12,
       'DEBITO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Dbito~Perodo',
       'Dbito Perodo',
       '',
       'DEBITO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VCCS',
       '01',
       20,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Filial do Cliente',
       'Filial do Cliente',
       '',
       'FILCLI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VCCS',
       '99',
       70,
       12,
       'SALDO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Saldo~Perodo',
       'Saldo Perodo',
       '',
       'SALDO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VCCS',
       '01',
       40,
       5,
       'TIPCCC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Tipo de CC',
       'Tipo de Conta Corrente',
       '',
       'TIPCCC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VCCS',
       '01',
       45,
       5,
       'TIPCCCDES',
       'S',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       'A',
       '',
       'Descrio Tipo CC',
       'Descrio do Tipo de Conta Corrente',
       'DCCC.CODTAB(+) = VCCS.TIPCCC',
       'DESCCC',
       'T',
       'D' FROM DUAL
);

/*-- SEQ 9580 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCD ',
       TO_NUMBER(null),
       'VCD ',
       'Cheques Devolvidos',
       'TV_CHR_DEV',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9581 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCD ','--','' FROM DUAL
UNION ALL
SELECT 'VCD ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCD ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VCD ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VCD ','99','Outros' FROM DUAL
);

/*-- SEQ 9582 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCD ',
       '01',
       10,
       2,
       'ALINEA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Alnea',
       'Alnea',
       '',
       'ALINEA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCD ',
       '01',
       20,
       27,
       'CHEQUE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cheque',
       'Cheque',
       '',
       'CHEQUE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCD ',
       '02',
       30,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCD ',
       '02',
       40,
       7,
       'DATVEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Venda',
       'Data de Venda',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCD ',
       '01',
       50,
       15,
       'FILIAL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       '',
       'FILIAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCD ',
       '01',
       60,
       14,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VCD ',
       '01',
       70,
       1,
       'NUMDEP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero Dependentes',
       'Nmero de Dependentes',
       '',
       'NUMDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'VCD ',
       '01',
       80,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Documento (CPF/CGC)',
       'Nmero do Documento: CGC ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VCD ',
       '01',
       90,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero ECF',
       'Nmero ECF',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'VCD ',
       '02',
       100,
       7,
       'PAGAME',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Pagamento',
       'Data de Pagamento',
       '',
       'PAGAME',
       'F' FROM DUAL
UNION ALL
SELECT 'VCD ',
       '01',
       110,
       30,
       'PORTAD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Portador',
       'Portador',
       '',
       'PORTAD',
       'F' FROM DUAL
UNION ALL
SELECT 'VCD ',
       '03',
       120,
       9,
       'VLRCHE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor do Cheque',
       'Valor do Cheque',
       '',
       'VLRCHE',
       'F' FROM DUAL
);

/*-- SEQ 9583 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCDF',
       TO_NUMBER(null),
       'VCDF',
       'Dv. Cliente Filial',
       'TV_CLI_DIV_FIL',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9584 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCDF','--','' FROM DUAL
UNION ALL
SELECT 'VCDF','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCDF','99','Outros' FROM DUAL
);

/*-- SEQ 9585 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 41788,
       'CLI ',
       'VCDF',
       '1 ',
       'N ',
       '',
       '',
       'CLI.CODCLI = VCDF.CODCLI AND CLI.FILCLI = VCDF.FILCLI',
       '' FROM DUAL
);

/*-- SEQ 9586 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCDF',
       '01',
       10,
       12,
       'CHEDEV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cheques Devolvidos',
       'Cheques Devolvidos',
       '',
       'CHEDEV',
       'F' FROM DUAL
UNION ALL
SELECT 'VCDF',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCDF',
       '01',
       110,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VCDF.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCDF',
       '01',
       30,
       49,
       'DESDIV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Dvida',
       'Descrio Dvida',
       '',
       'DESDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'VCDF',
       '01',
       40,
       12,
       'DIVIDA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Dvida',
       'Dvida',
       '',
       'DIVIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCDF',
       '01',
       120,
       27,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VCDF',
       '01',
       50,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial do cliente',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'VCDF',
       '01',
       60,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'VCDF',
       '01',
       70,
       12,
       'LIMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Limite',
       'Limite',
       '',
       'LIMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCDF',
       '01',
       80,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Documento',
       'Nmero Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VCDF',
       '01',
       90,
       12,
       'OCORRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero Ocorrncias',
       'Nmero Ocorrncias',
       '',
       'OCORRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCDF',
       '01',
       100,
       12,
       'TIPDIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Tipo da Dvida',
       'Tipo da Dvida',
       '',
       'TIPDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'VCDF',
       '01',
       130,
       8,
       'VENCIMENTO',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Vencimento',
       'Vencimento',
       '',
       'VENCIMENTO',
       'F' FROM DUAL
);

/*-- SEQ 9587 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VCDF',
       'FLGTIP',
       0,
       ' ',
       'Fisica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCDF',
       'FLGTIP',
       1,
       ' ',
       'Juridica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCDF',
       'FLGTIP',
       2,
       ' ',
       'Entidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCDF',
       'FLGTIP',
       3,
       ' ',
       'Especial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCDF',
       'FLGTIP',
       4,
       ' ',
       'M.E.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCDF',
       'FLGTIP',
       5,
       ' ',
       'Filial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCDF',
       'TIPDIV',
       1,
       ' ',
       'Parcelas em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCDF',
       'TIPDIV',
       2,
       ' ',
       'Cheque A Depositar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCDF',
       'TIPDIV',
       3,
       ' ',
       'C/C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCDF',
       'TIPDIV',
       4,
       ' ',
       'Cheque de Terceiro A Depositar',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9588 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCE ',
       TO_NUMBER(null),
       'VCE ',
       'Cliente Externo',
       'TV_CLI_EXT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9589 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCE ','--','' FROM DUAL
UNION ALL
SELECT 'VCE ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCE ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VCE ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VCE ','99','Outros' FROM DUAL
);

/*-- SEQ 9590 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCE ',
       '02',
       20,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       30,
       40,
       'BAIRRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Bairro',
       'Bairro',
       '',
       'BAIRRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '03',
       40,
       2,
       'CATEG1',
       'S',
       'DCT1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'V',
       '',
       'F',
       'A',
       'F',
       '',
       'Categoria - 1',
       'VCE.CATEG1=DCT1.CODTAB (+)',
       'CATEG1',
       'T' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '03',
       50,
       2,
       'CATEG2',
       'S',
       'DCT2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'V',
       '',
       'F',
       'A',
       'F',
       '',
       'Categoria - 2',
       'VCE.CATEG2=DCT2.CODTAB (+)',
       'CATEG2',
       'T' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '03',
       60,
       2,
       'CATEG3',
       'S',
       'DCT3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'V',
       '',
       'F',
       'A',
       'F',
       'TIPO',
       'Categoria - 3',
       'VCE.CATEG3=DCT3.CODTAB (+)',
       'CATEG3',
       'T' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       70,
       5,
       'CODCEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'CEP',
       'CEP do endereo',
       '',
       'CODCEP',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       80,
       5,
       'CODCID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo da Cidade',
       'Cdigo da Cidade',
       '',
       'CODCID',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       90,
       4,
       'CODDDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'DDD Telefone',
       'DDD Telefone',
       '',
       'CODDDD',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       100,
       10,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Externo',
       'Cdigo Alternativo nico',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       110,
       3,
       'CODLOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Logradouro',
       'Logradouro do endereo',
       '',
       'CODLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       120,
       3,
       'CODPLA',
       'A',
       'PLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Plano padro',
       'Cdigo do plano padro',
       'VCE.FILPLA=PLA.FILPGT (+) AND  VCE.CODPLA=PLA.CODPGT  (+)',
       'CODPLA',
       'T' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '99',
       130,
       2,
       'CODSEX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Sexo',
       'Cdigo de Sexo do Cliente',
       '',
       'CODSEX',
       'T' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       140,
       3,
       'CODVEN',
       'A',
       'VDD ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'VDD.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Vendedor Padro',
       'Vendedor Padro',
       'VCE.FILVEN = VDD.FILUSU (+)  AND VCE.CODVEN = VDD.CODUSU (+)',
       'CODVEN',
       'T' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       150,
       6,
       'CODVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo Vnculo',
       'Cdigo do Vnculo',
       '',
       'CODVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       160,
       40,
       'COMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Complemento',
       'Complemento do endereo',
       '',
       'COMPLE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       170,
       44,
       'CONJUG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cnjuge',
       'Cnjuge',
       '',
       'CONJUG',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       180,
       44,
       'CONTAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Contato',
       'Contato',
       '',
       'CONTAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '02',
       190,
       8,
       'DATA01',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       '',
       'Data livre - 1',
       '',
       'DATA01',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '02',
       200,
       8,
       'DATA02',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       '',
       'Data livre - 2',
       '',
       'DATA02',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '02',
       210,
       8,
       'DATA03',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       '',
       'Data livre - 3',
       '',
       'DATA03',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '02',
       220,
       8,
       'DATNAS',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Nascto/Fundao',
       'Data de nascimento',
       '',
       'DATNAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '02',
       230,
       8,
       'DATOPE',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Incluso',
       'Data de operao (cadastramento)',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       630,
       20,
       'DESEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Endereo',
       'Descrio Endereo',
       '',
       'DESEND',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '99',
       240,
       4,
       'DOCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DDD Celular Cnjuge',
       'DDD Celular Cnjuge',
       '',
       'DOCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       250,
       15,
       'DOCEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento Endereo',
       'Documento de Endereo',
       '',
       'DOCEND',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '99',
       260,
       1,
       'ENDCOB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'F',
       'Cobrana?',
       'Cobrana',
       '',
       'ENDCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '99',
       270,
       1,
       'ENDCOR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'F',
       'Correspondncia?',
       'Correspondncia',
       '',
       'ENDCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       280,
       40,
       'ENDERE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Endereo',
       'Endereo',
       '',
       'ENDERE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       290,
       2,
       'ESTCIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Estado Civil',
       'Estado Civil',
       '',
       'ESTCIV',
       'T' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       300,
       40,
       'ESTRAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Endereo Estrangeiro',
       'Endereo estrangeiro',
       '',
       'ESTRAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       310,
       3,
       'FILPLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial do Plano',
       'Filial do Plano',
       '',
       'FILPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       320,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Vendedor',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       330,
       3,
       'FILVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Vnculo',
       '',
       'FILVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '99',
       340,
       1,
       'FLGNAC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'F',
       'Nacional?',
       'Nacionalidade',
       '',
       'FLGNAC',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '99',
       350,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '99',
       360,
       40,
       'HOMPGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Home Page',
       'Home Page do Cliente',
       '',
       'HOMPGE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       370,
       1,
       'ICM_CF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'ICM_CF  Nota Fiscal',
       'ICM_CF  Nota Fiscal',
       '',
       'ICM_CF',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       380,
       2,
       'IMPRIM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Class. Interna',
       'Livre para customizao',
       '',
       'IMPRIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       390,
       15,
       'INSEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Insero Endereos',
       'Insero de Endereos',
       '',
       'INSEND',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       400,
       15,
       'INSEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '2 Documento',
       'Inscrio Estadual ou Identidade',
       '',
       'INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       410,
       6,
       'ISENHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Senha',
       '',
       'ISENHA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       420,
       47,
       'LOCTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Proximidade',
       'Local prximo ao endereo',
       '',
       'LOCTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       430,
       2,
       'MAIATR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Maior atraso',
       'Maior atraso registrado',
       '',
       'MAIATR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '02',
       440,
       7,
       'NASCON',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Nascimento Cnjuge',
       'Nascimento do cnjuge',
       '',
       'NASCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       450,
       44,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Nome/Razo Social',
       'Nome do Cliente',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       460,
       255,
       'NOMIMG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Imagem',
       'Nome Imagem',
       '',
       'NOMIMG',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       470,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Documento (CPF/CGC)',
       'Nmero do Documento: CGC ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       480,
       15,
       'NUMERO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero',
       'Nmero',
       '',
       'NUMERO',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       490,
       8,
       'NUMFAX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'FAX',
       'Nmero do fax',
       '',
       'NUMFAX',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       500,
       20,
       'NUMFON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Telefone',
       'Nmero do telefone',
       '',
       'NUMFON',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       510,
       10,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(VCE.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       520,
       2,
       'PORPAD',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       'F',
       'A',
       'F',
       'Portador Padro',
       'Portador padro',
       'VCE.PORPAD=DCOB.CODTAB (+)',
       'PORPAD',
       'T' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       530,
       2,
       'REGIAO',
       'S',
       'DREG',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DREG.REGIAO',
       'V',
       '',
       'F',
       'A',
       'F',
       'Regio',
       'Regio do endereo',
       'DREG.CODTAB(+)=VCE.REGIAO',
       'REGIAO',
       'T' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       540,
       12,
       'SALBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Bnus',
       'Bnus',
       '',
       'SALBON',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       550,
       2,
       'SEXCON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Sexo do Cnjuge',
       'Sexo do cnjuge',
       '',
       'SEXCON',
       'T' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       560,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN VCE.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       561,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN VCE.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '99',
       570,
       2,
       'TIPDOC',
       'A',
       'DDOC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDOC.DESDOC',
       'V',
       '',
       'F',
       'A',
       'F',
       'Tipo Documento',
       'Tipo de Documento',
       'DDOC.TIPDOC(+) = VCE.TIPDOC',
       'TIPDOC',
       'T' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       640,
       5,
       'TIPEND',
       'S',
       'DEND',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEND.DESEND',
       'V',
       '',
       '',
       'N',
       'F',
       'Tipo Endereo',
       'Tipo Endereo',
       'DEND.CODTAB = VCE.TIPEND',
       'TIPEND',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '99',
       580,
       4,
       'TOTATR',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Total de Atrasos',
       'Total de atrasos na vida do cliente',
       '',
       'TOTATR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '99',
       590,
       4,
       'TOTPAR',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Total Geral Parcelas',
       'Total de parcelas na vida do cliente',
       '',
       'TOTPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '99',
       600,
       8,
       'ULTCOM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'ltima Compra',
       'Data da ltima compra',
       '',
       'ULTCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '01',
       610,
       20,
       'ULTNOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Sobrenome/Fantasia',
       'Sobrenome ou fantasia',
       '',
       'ULTNOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCE ',
       '03',
       620,
       8,
       'VALOR1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'VALOR1',
       'F' FROM DUAL
);

/*-- SEQ 9591 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VCE ',
       'CODSEX',
       2,
       ' ',
       'Feminino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCE ',
       'CODSEX',
       0,
       ' ',
       'Nao conhecido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCE ',
       'CODSEX',
       1,
       ' ',
       'Masculino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCE ',
       'ESTCIV',
       4,
       ' ',
       'Divorciado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCE ',
       'ESTCIV',
       1,
       ' ',
       'Solteiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCE ',
       'ESTCIV',
       2,
       ' ',
       'Casado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCE ',
       'ESTCIV',
       3,
       ' ',
       'Viuvo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCE ',
       'ESTCIV',
       6,
       ' ',
       'Separado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCE ',
       'ESTCIV',
       5,
       ' ',
       'Unio Estvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCE ',
       'ESTCIV',
       0,
       ' ',
       'Indefinido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCE ',
       'FLGTIP',
       0,
       ' ',
       'Fisica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCE ',
       'FLGTIP',
       1,
       ' ',
       'Juridica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCE ',
       'FLGTIP',
       2,
       ' ',
       'Entidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCE ',
       'FLGTIP',
       3,
       ' ',
       'Especial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCE ',
       'FLGTIP',
       4,
       ' ',
       'M.E.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCE ',
       'FLGTIP',
       5,
       ' ',
       'Filial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCE ',
       'SEXCON',
       0,
       ' ',
       'Nao Conhecido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCE ',
       'SEXCON',
       1,
       ' ',
       'Masculino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCE ',
       'SEXCON',
       2,
       ' ',
       'Feminino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCE ',
       'SIGNAT',
       0,
       ' ',
       'Nao Conhecido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCE ',
       'SIGNAT',
       1,
       ' ',
       'Masculino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCE ',
       'SIGNAT',
       2,
       ' ',
       'Feminino',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9592 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCFI',
       TO_NUMBER(null),
       'VCFI',
       'Contatos Financeiros',
       'TV_CFI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'VCFI.FILCLI,VCFI.CODCLI',
       '' FROM DUAL
);

/*-- SEQ 9593 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCFI','--','' FROM DUAL
UNION ALL
SELECT 'VCFI','01','Identificao' FROM DUAL
);

/*-- SEQ 9594 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 33846,
       'VEN ',
       'VCFI',
       'N ',
       '01',
       '',
       '',
       'VEN.FILCLI = VCFI.FILCLI(+) and
VEN.CODCLI = VCFI.CODCLI(+)',
       '' FROM DUAL
);

/*-- SEQ 9595 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCFI',
       '01',
       55,
       4,
       'ANO_DATNAS',
       'A',
       '',
       0,
       0,
       'VCFI',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CON',
       '',
       'N',
       'T',
       'Ano de Nascimento',
       'Ano de Data de nascimento',
       '',
       'TO_CHAR(VCFI.DATNAS,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VCFI',
       '01',
       100,
       8,
       'CELCON',
       'A',
       '',
       0,
       0,
       'VCFI',
       100,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CON',
       'F',
       'N',
       'T',
       'Celular',
       'Celular',
       '',
       'CELCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VCFI',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       0,
       'VCFI',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CON',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCFI',
       '01',
       120,
       5,
       'CODREL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Relacionament',
       'Cdigo Relacionamento',
       '',
       'CODREL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCFI',
       '01',
       40,
       44,
       'CONTAT',
       'A',
       '',
       0,
       0,
       'VCFI',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CON',
       'F',
       'A',
       'T',
       'Nome',
       'Nome do contato/Parente',
       '',
       'CONTAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCFI',
       '01',
       50,
       8,
       'DATNAS',
       'D',
       '',
       0,
       0,
       'VCFI',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CON',
       'F',
       'D',
       'T',
       'Nascimento',
       'Data de nascimento',
       '',
       'DATNAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCFI',
       '01',
       80,
       4,
       'DDDCON',
       'A',
       '',
       0,
       0,
       'VCFI',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CON',
       'F',
       'N',
       'T',
       'DDD',
       'DDD',
       '',
       'DDDCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VCFI',
       '01',
       110,
       40,
       'E_MAIL',
       'A',
       '',
       0,
       0,
       'VCFI',
       110,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CON',
       'F',
       'A',
       'T',
       'E-mail',
       'E-mail',
       '',
       'E_MAIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCFI',
       '01',
       10,
       3,
       'FILCLI',
       'A',
       '',
       0,
       0,
       'VCFI',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CON',
       'F',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCFI',
       '01',
       53,
       2,
       'MES_DATNAS',
       'A',
       '',
       0,
       0,
       'VCFI',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CON',
       '',
       'N',
       'T',
       'Ms de Nascimento',
       'Ms de Data de nascimento',
       '',
       'TO_CHAR(VCFI.DATNAS,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VCFI',
       '01',
       30,
       2,
       'NUMCON',
       'S',
       '',
       0,
       0,
       'VCFI',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CON',
       'F',
       '',
       'F',
       'Nmero Contato',
       'Nmero do contato (apenas para ordenao)',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VCFI',
       '01',
       60,
       2,
       'SEXCON',
       'S',
       '',
       0,
       0,
       'VCFI',
       60,
       30,
       '',
       '',
       'D',
       'CON',
       'F',
       'A',
       'T',
       'Sexo',
       'Sexo',
       '',
       'SEXCON',
       'T' FROM DUAL
UNION ALL
SELECT 'VCFI',
       '01',
       90,
       8,
       'TELCON',
       'A',
       '',
       0,
       0,
       'VCFI',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CON',
       'F',
       'N',
       'T',
       'Fone',
       'Telefone',
       '',
       'TELCON',
       'F' FROM DUAL
);

/*-- SEQ 9596 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VCFI',
       'SEXCON',
       0,
       '-',
       'Masculino',
       131,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCFI',
       'SEXCON',
       1,
       '-',
       'Feminino',
       132,
       ' ' FROM DUAL
);

/*-- SEQ 9597 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCFO',
       TO_NUMBER(null),
       'VCFO',
       'Lista de CFOPs',
       'TV_CFO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9598 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCFO','--','' FROM DUAL
UNION ALL
SELECT 'VCFO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCFO','99','Outros' FROM DUAL
);

/*-- SEQ 9599 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCFO',
       '--',
       30,
       56,
       'DESNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Natureza',
       'Descrio da Natureza',
       '',
       'DESNAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCFO',
       '--',
       10,
       6,
       'NATDEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat. Op. Dentro Est.',
       'Natureza para Operaes Dentro do Estado',
       '',
       'NATDEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCFO',
       '--',
       20,
       6,
       'NATFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat. Op. Fora Est',
       'Natureza para Operaes Fora do Estado',
       '',
       'NATFOR',
       'F' FROM DUAL
);

/*-- SEQ 9600 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCH ',
       TO_NUMBER(null),
       'VCH ',
       'Cheq.Rec.XHeaderArq.',
       'TV_CHR_HAQ',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VCH.CODFIL,VCH.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9601 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCH ','--','' FROM DUAL
UNION ALL
SELECT 'VCH ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCH ','99','Outros' FROM DUAL
);

/*-- SEQ 9602 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCH ',
       '01',
       10,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Banco',
       'Cdigo do Banco',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'VCH ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VCH.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCH ',
       '01',
       30,
       10,
       'CTACRR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm. Conta Corrente',
       'Nmero da Conta Corrente',
       '',
       'CTACRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCH ',
       '01',
       40,
       4000,
       'LINHA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCH ',
       '01',
       50,
       5,
       'NUMAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Numero Agencia',
       'Numero da Agncia',
       '',
       'NUMAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCH ',
       '01',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCH ',
       '01',
       70,
       1,
       'TIPDEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Dep.',
       'Tipo Dep.',
       '',
       'TIPDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'VCH ',
       '01',
       80,
       1,
       'TIPREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Registro',
       'Tipo Registro: Verbal,Telefone,Fax,E-mail,Carta,Site e Mensagem ',
       '',
       'TIPREG',
       'T' FROM DUAL
UNION ALL
SELECT 'VCH ',
       '01',
       90,
       12,
       'VLRREG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Registro',
       'Valor Registro',
       '',
       'VLRREG',
       'F' FROM DUAL
);

/*-- SEQ 9603 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VCH ',
       'TIPREG',
       0,
       'C',
       'Carta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCH ',
       'TIPREG',
       0,
       'E',
       'E-mail',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCH ',
       'TIPREG',
       0,
       'F',
       'Fax',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCH ',
       'TIPREG',
       0,
       'M',
       'Mensagem Instantnea',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCH ',
       'TIPREG',
       0,
       'S',
       'Site',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCH ',
       'TIPREG',
       0,
       'T',
       'Telefone',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCH ',
       'TIPREG',
       0,
       'V',
       'Verbal',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9604 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCHL',
       TO_NUMBER(null),
       'VCHL',
       'Cheques Rec. X HLT',
       'TV_CHR_HLT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'vchl.codfil,vchl.sequen',
       '' FROM DUAL
);

/*-- SEQ 9605 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCHL','--','' FROM DUAL
UNION ALL
SELECT 'VCHL','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCHL','99','Outros' FROM DUAL
);

/*-- SEQ 9606 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCHL',
       '01',
       10,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Banco',
       'Cdigo do Banco',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHL',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VCHL.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHL',
       '01',
       30,
       10,
       'CTACRR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm. Conta Corrente',
       'Nmero da Conta Corrente',
       '',
       'CTACRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHL',
       '01',
       40,
       4000,
       'LINHA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHL',
       '01',
       50,
       5,
       'NUMAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Numero Agencia',
       'Numero da Agncia',
       '',
       'NUMAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHL',
       '01',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHL',
       '01',
       70,
       1,
       'TIPDEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Dep.',
       'Tipo Dep.',
       '',
       'TIPDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHL',
       '01',
       80,
       1,
       'TIPREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Registro',
       'Tipo Registro: Verbal,Telefone,Fax,E-mail,Carta,Site e Mensagem ',
       '',
       'TIPREG',
       'T' FROM DUAL
UNION ALL
SELECT 'VCHL',
       '01',
       90,
       12,
       'VLRREG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Registro',
       'Valor Registro',
       '',
       'VLRREG',
       'F' FROM DUAL
);

/*-- SEQ 9607 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VCHL',
       'TIPREG',
       0,
       'C',
       'Carta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCHL',
       'TIPREG',
       0,
       'E',
       'E-mail',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCHL',
       'TIPREG',
       0,
       'F',
       'Fax',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCHL',
       'TIPREG',
       0,
       'M',
       'Mensagem Instantnea',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCHL',
       'TIPREG',
       0,
       'S',
       'Site',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCHL',
       'TIPREG',
       0,
       'T',
       'Telefone',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCHL',
       'TIPREG',
       0,
       'V',
       'Verbal',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9608 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCHR',
       TO_NUMBER(null),
       'VCHR',
       'Exportao de Cheque',
       'TV_ECHR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9609 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCHR','--','' FROM DUAL
UNION ALL
SELECT 'VCHR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCHR','99','Outros' FROM DUAL
);

/*-- SEQ 9610 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCHR',
       '--',
       10,
       2,
       'ALINEA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Alnea',
       'Alnea',
       '',
       'ALINEA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       20,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Data de Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       30,
       40,
       'AUTORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Autorizao',
       'Autorizao',
       '',
       'AUTORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       40,
       30,
       'CDCMC7',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo CMC7 cheque',
       'Cdigo CMC7 cheque',
       '',
       'CDCMC7',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       50,
       5,
       'CODAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Agncia',
       'Agncia',
       '',
       'CODAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       60,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Banco',
       'Banco',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       70,
       20,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       80,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       90,
       10,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Usurio',
       'Usurio',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       100,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Data da Operao',
       'Data da Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       110,
       7,
       'DATVEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Data da Venda',
       'Data da Venda',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       120,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       130,
       6,
       'NUMCHE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero',
       'Nmero',
       '',
       'NUMCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       140,
       10,
       'NUMCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Conta',
       'Conta',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       150,
       1,
       'NUMDEP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'N Depsito',
       'N Depsito',
       '',
       'NUMDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       160,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       170,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Numero ECF',
       'Numero ECF',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       180,
       254,
       'OBSLOG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observaes Log.',
       'Observaes Log.',
       '',
       'OBSLOG',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       190,
       7,
       'PAGAME',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Data pagto',
       'Data pagto',
       '',
       'PAGAME',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       200,
       7,
       'PLACAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Placa',
       'Placa',
       '',
       'PLACAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       210,
       5,
       'PORTAD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Portador',
       'Portador',
       '',
       'PORTAD',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       220,
       3,
       'SERCHE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie do Cheque',
       'Srie do Cheque',
       '',
       'SERCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       230,
       1,
       'TIPCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Cobrana',
       'Tipo Cobrana',
       '',
       'TIPCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       240,
       9,
       'VLRCHE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Cheque',
       'Valor Cheque',
       '',
       'VLRCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       250,
       9,
       'VLRDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor diferena',
       'Valor diferena',
       '',
       'VLRDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'VCHR',
       '--',
       260,
       9,
       'VLRORI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Origem',
       'Valor Origem',
       '',
       'VLRORI',
       'F' FROM DUAL
);

/*-- SEQ 9611 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCID',
       TO_NUMBER(null),
       'VCID',
       'Doenas',
       'TV_CID',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9612 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCID','--','' FROM DUAL
UNION ALL
SELECT 'VCID','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCID','99','Outros' FROM DUAL
);

/*-- SEQ 9613 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCID',
       '01',
       10,
       8,
       'CODCID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo da Doena',
       'Cdigo da Doena',
       '',
       'CODCID',
       'F' FROM DUAL
UNION ALL
SELECT 'VCID',
       '01',
       20,
       300,
       'DESCID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Doena',
       'Descrio da Doena',
       '',
       'DESCID',
       'F' FROM DUAL
);

/*-- SEQ 9614 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCM ',
       TO_NUMBER(null),
       'VCM ',
       'Custo Mdio',
       'TV_CUSMED',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9615 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCM ','--','' FROM DUAL
UNION ALL
SELECT 'VCM ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCM ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VCM ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VCM ','99','Outros' FROM DUAL
);

/*-- SEQ 9616 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCM ',
       '01',
       10,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Diviso do produto',
       'VCM.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'VCM ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Filial',
       'Cdigo Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCM ',
       '01',
       30,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCM ',
       '01',
       40,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'VCM.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'VCM ',
       '02',
       50,
       7,
       'DATMOV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Movimentao',
       'Data Movimentao',
       '',
       'DATMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VCM ',
       '01',
       60,
       22,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VCM ',
       '01',
       70,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCM ',
       '01',
       80,
       12,
       'FIS_CUSTO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Fis. Custo',
       'Fis. Custo',
       '',
       'FIS_CUSTO',
       'F' FROM DUAL
UNION ALL
SELECT 'VCM ',
       '01',
       90,
       12,
       'GER_CUSTO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ger. Custo',
       'Ger. Custo',
       '',
       'GER_CUSTO',
       'F' FROM DUAL
UNION ALL
SELECT 'VCM ',
       '01',
       100,
       40,
       'NATURE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Natureza',
       'Natureza',
       '',
       'NATURE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCM ',
       '01',
       110,
       10,
       'ORD_CM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ordena Custo Mdio',
       'Ordenao Custo Mdio',
       '',
       'ORD_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCM ',
       '01',
       120,
       12,
       'QTDMOV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Qtde Movimentao',
       'Qtde Movimentao',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VCM ',
       '01',
       130,
       1,
       'TIPMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo',
       'Tipo de movimentao',
       '',
       'TIPMOV',
       'T' FROM DUAL
UNION ALL
SELECT 'VCM ',
       '03',
       140,
       12,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Movimentao',
       'Valor Movimentao',
       '',
       'VLRMOV',
       'F' FROM DUAL
);

/*-- SEQ 9617 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VCM ',
       'TIPMOV',
       0,
       'A',
       'Ajuste',
       75,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCM ',
       'TIPMOV',
       0,
       'C',
       'Compra',
       74,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCM ',
       'TIPMOV',
       0,
       'I',
       'Inicial',
       76,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCM ',
       'TIPMOV',
       0,
       'N',
       'Nota Complmentar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCM ',
       'TIPMOV',
       0,
       'V',
       'Venda',
       73,
       ' ' FROM DUAL
);

/*-- SEQ 9618 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCMP',
       TO_NUMBER(null),
       'VCMP',
       'Compras x PGTO',
       'TV_CMP',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9619 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCMP','--','' FROM DUAL
UNION ALL
SELECT 'VCMP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCMP','02','Datas' FROM DUAL
UNION ALL
SELECT 'VCMP','03','Valores' FROM DUAL
UNION ALL
SELECT 'VCMP','99','Outros' FROM DUAL
);

/*-- SEQ 9620 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCMP',
       '01',
       381,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN VCMP.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       520,
       1,
       'ATUCUS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Atualiza Custos?',
       'Atualiza Custos?',
       '',
       'ATUCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '02',
       10,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       550,
       12,
       'BASFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       ' Base de ICM Frete',
       ' Base de ICM do Frete',
       '',
       'BASFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       1350,
       12,
       'BASICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'BASICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       1360,
       12,
       'BASRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'BASRET',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       770,
       12,
       'BASSUB',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Base de Substituio',
       'Base de Substituio',
       '',
       'BASSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       1370,
       14,
       'BSTFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'BSTFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       1030,
       44,
       'CHAVEA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Chave acesso da NF-e',
       'Chave de acesso da NF-e',
       '',
       'CHAVEA',
       '' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       890,
       20,
       'CODAVU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Avulso',
       'Cdigo Avulso',
       '',
       'CODAVU',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       20,
       5,
       'CODCFO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cd. CFOP de Compra',
       'Cdigo CFOP de compras,',
       '',
       'CODCFO',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '99',
       1330,
       1,
       'CODDAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Cod Mod Doc Arrecada',
       'Cdigo do modelo do documento de arrecadao',
       '',
       'CODDAR',
       'T' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       1380,
       5,
       'CODDOP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODDOP',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '99',
       540,
       2,
       'CODFCE',
       'A',
       'DFCE',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFCE.DESFCE',
       'V',
       '',
       '',
       'A',
       '',
       'Consumo Energia Elet',
       'Classe de Consumo de Energia Eltrica',
       'VCMP.CODFCE=DFCE.CODFCE',
       'CODFCE',
       '' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da Filial de Origem',
       'TCOM.CODFIL=DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       40,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Fornecedor',
       'Cdigo do fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '99',
       1210,
       2,
       'CODFPS',
       'A',
       'DFPS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFPS.DESFPS',
       'V',
       '',
       '',
       'A',
       'F',
       'Finalidade Com/ Fret',
       'Finalidade do Compromisso/Frete',
       'DFPS.CODFPS = VCMP.CODFPS',
       'CODFPS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '99',
       1580,
       10,
       'CODIBG',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo IBGE Origem',
       'Cdigo IBGE da Cidade de Origem',
       '',
       'CODIBG',
       '' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       50,
       2,
       'CODMOE',
       'S',
       'DMOE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       '',
       'F',
       'A',
       'F',
       'Moeda',
       'Cdigo da moeda',
       'VCMP.CODMOE=DMOE.CODTAB (+)',
       'CODMOE',
       'T' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       60,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Srie',
       'Cdigo da srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       70,
       5,
       'CODSET',
       'N',
       'DSET',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSET.DESSET',
       'V',
       '',
       'F',
       'N',
       'F',
       'Setor',
       'Setor',
       'DSET.CODTAB(+) = VCMP.CODSET',
       'CODSET',
       'T' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '99',
       1570,
       4,
       'CODSRV',
       'S',
       'SRV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SRV.DESSRV',
       'V',
       '',
       '',
       'N',
       '',
       'Descrio do Servio',
       'Descrio do Servio',
       'SRV.CODSRV = VCMP.CODSRV(+)',
       'CODSRV',
       'T' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       1040,
       5,
       'CODTRI',
       'S',
       'DTRI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DTRI.CODTRI',
       'V',
       '',
       '',
       'N',
       'F',
       'CST',
       'Cdigo da Situao Tributria',
       'DTRI.CODTAB = COM.CODTRI',
       'CODTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       80,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'VCMP.FILUSU = USU.FILUSU(+)  AND VCMP.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       90,
       10,
       'CONPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cond. Pagto.',
       'Condio de Pagamento',
       '',
       'CONPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '02',
       100,
       8,
       'DATCMP',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Compra',
       'Data da compra',
       '',
       'DATCMP',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '02',
       110,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data Lanto',
       'Data da operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       120,
       8,
       'DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Desconto',
       'Desconto',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       1390,
       12,
       'DESPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       130,
       3,
       'ESPDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Espcie Docto',
       'Espcie de Documento',
       '',
       'ESPDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '99',
       1550,
       1,
       'EXPFIS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exportado Fiscal?',
       'Exportado Fiscal?',
       '',
       'EXPFIS',
       '' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '99',
       530,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exporta?',
       'Exporta?',
       '',
       'EXPORT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '99',
       1540,
       1,
       'EXPORT_CAN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exportado Cancelado?',
       'Exportado Cancelado?',
       '',
       'EXPORT_CAN',
       '' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       1400,
       3,
       'FILAGC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILAGC',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       140,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       740,
       3,
       'FILCTA_COMFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Filial da Conta',
       'Filial da Fatura da Conta',
       '',
       '(SELECT INT.FILCTA
         FROM TV_CMP INT
        WHERE COM.CODFIL=INT.CODFIL
          AND COM.SEQUEN=INT.SEQFAT
        GROUP BY INT.FILCTA,INT.SEQCTA,INT.TIPCTA
       HAVING COUNT(*) = 1)',
       '' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       150,
       3,
       'FILEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial endereo',
       '',
       'FILEND',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       160,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       780,
       3,
       'FILFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       170,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '99',
       1530,
       1,
       'FINNFE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Finalidade da NF-e',
       'Finalidade da NF-e',
       '',
       'FINNFE',
       'T' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       590,
       1,
       'FLGCOF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Inside COFINS?',
       'H insidncia de COFINS?',
       '',
       'FLGCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       600,
       1,
       'FLGCSS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Inside Contr.Social?',
       'H insidncia de contribuio social?',
       '',
       'FLGCSS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       180,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Situao (Devolvida/Quitada/Em aberto)',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       1410,
       1,
       'FLGICM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FLGICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       610,
       1,
       'FLGINS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Inside INSS?',
       'H insidncia de INSS?',
       '',
       'FLGINS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       1420,
       1,
       'FLGISS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FLGISS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       620,
       1,
       'FLGPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Inside PIS?',
       'H insidncia de PIS?',
       '',
       'FLGPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       190,
       12,
       'ICMFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'ICMS Frete',
       'ICMS Frete',
       '',
       'ICMFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       200,
       1,
       'INCOJU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Correo',
       'Indicador do tipo de correo de juros',
       '',
       'INCOJU',
       'T' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       210,
       1,
       'INTPJU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Juros',
       'Indicador do tipo de juros',
       '',
       'INTPJU',
       'T' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       220,
       1,
       'INTPMU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Multa',
       'Indicador do tipo de multa',
       '',
       'INTPMU',
       'T' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       790,
       12,
       'ISEICM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ISEICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       230,
       2,
       'MOEJUR',
       'S',
       'DMOE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       '',
       'F',
       'A',
       'F',
       'Moeda Correo',
       'Moeda da Correo',
       'VCMP.MOEJUR=DMOE.CODTAB (+)',
       'MOEJUR',
       'T' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       1430,
       4000,
       'MOTREJ',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MOTREJ',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       1440,
       2,
       'NATBCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATBCC',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '99',
       1310,
       1,
       'NATFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Natureza do Frete',
       'Natureza do Frete Contratado',
       '',
       'NATFRE',
       'T' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       540,
       30,
       'NATURE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Natureza',
       'Natureza',
       '',
       'NATURE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       240,
       0,
       'NOTESP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Nota Especial?',
       'Nota Especial',
       '',
       'NOTESP',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       250,
       4,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero de Endereos',
       'Nmero de Endereos',
       '',
       'NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       260,
       9,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nmero',
       'Nmero da nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       270,
       5,
       'NUMVOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero de Volumes',
       'Nmero de Volumes',
       '',
       'NUMVOL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       280,
       4000,
       'OBSERV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Observaes',
       'Observaes',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       290,
       255,
       'OBSFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao Fatura',
       'Observao Fatura',
       '',
       'OBSFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       1450,
       12,
       'OUTDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'OUTDES',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       800,
       12,
       'OUTICM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'OUTICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       300,
       8,
       'OUTTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Outras Taxas',
       'Outras taxas',
       '',
       'OUTTAX',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       630,
       12,
       'PERCSS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '%Contribuio~Social',
       '%Contribuio Social',
       '',
       'PERCSS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       560,
       5,
       'PERFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% de ICM do frete',
       '% de ICM do frete',
       '',
       'PERFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       640,
       12,
       'PERICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% ICMS',
       '% ICMS',
       '',
       'PERICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       650,
       12,
       'PERINS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% INSS',
       '% INSS',
       '',
       'PERINS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       660,
       12,
       'PERIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% IRRF',
       '% IRRF',
       '',
       'PERIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       670,
       12,
       'PERISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% ISS',
       '% ISS',
       '',
       'PERISS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       810,
       1,
       'POREMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'POREMP',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       310,
       8,
       'QTDTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtd. Total',
       'Quantidade total',
       '',
       'QTDTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       1460,
       1,
       'RATEIO_FRETE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'RATEIO_FRETE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       320,
       12,
       'RETCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Reteno de COFINS',
       'Reteno de COFINS',
       '',
       'RETCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       820,
       1,
       'RETCSS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Retm Cont. Social',
       'Retm Contribuio Social',
       '',
       'RETCSS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       830,
       1,
       'RETIRR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Retm Imp. de Renda',
       'Retm Imposto de Renda',
       '',
       'RETIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       1470,
       10,
       'SEQAGC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQAGC',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       330,
       10,
       'SEQCAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador de cancelamentos',
       '',
       'SEQCAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       340,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Contato',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       750,
       10,
       'SEQCTA_COMFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq. da Conta',
       'Sequncia da Fatura da Conta',
       '',
       '(SELECT INT.SEQCTA
         FROM TV_CMP INT
        WHERE COM.CODFIL=INT.CODFIL
          AND COM.SEQUEN=INT.SEQFAT
        GROUP BY INT.FILCTA,INT.SEQCTA,INT.TIPCTA
       HAVING COUNT(*) = 1)',
       '' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       350,
       10,
       'SEQFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequncia NF Fatura',
       '',
       'SEQFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       360,
       10,
       'SEQFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequncia Frete',
       '',
       'SEQFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       370,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       380,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN VCMP.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '99',
       1160,
       2,
       'SITCOF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'CST Cofins',
       'CST Cofins',
       '',
       'SITCOF',
       'T' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '99',
       1150,
       2,
       'SITPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'CST PIS',
       'CST PIS',
       '',
       'SITPIS',
       'T' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       1480,
       14,
       'ST_FRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ST_FRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       390,
       3,
       'SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Sub-Srie',
       'Sub-Srie de compra',
       '',
       'SUBSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       840,
       3,
       'SUBSER_FIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SUBSER_FIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       400,
       12,
       'SUBSTT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Substit. Tributria',
       'Substit. Tributria',
       '',
       'SUBSTT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       410,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       760,
       1,
       'TIPCTA_COMFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'Tipo da Conta',
       'Tipo da Fatura da Conta',
       '',
       '(SELECT INT.TIPCTA
         FROM TV_CMP INT
        WHERE COM.CODFIL=INT.CODFIL
          AND COM.SEQUEN=INT.SEQFAT
        GROUP BY INT.FILCTA,INT.SEQCTA,INT.TIPCTA
       HAVING COUNT(*) = 1)',
       '' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       850,
       1,
       'TIPEMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPEMP',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       1490,
       1,
       'TIPFRE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       420,
       1,
       'TIPNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Documento',
       'Tipo de Documento',
       '',
       'TIPNOT',
       'T' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       430,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Parceiro',
       'Tipo de Parceiro',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       440,
       1,
       'TIPTRP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Transp. Frete',
       'Tipo de Transporte no Registro de Frete',
       '',
       'TIPTRP',
       'T' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       1340,
       250,
       'TITCTA',
       'A',
       'DCTA',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTA.DESCTA',
       'V',
       '',
       '',
       'A',
       '',
       'Conta Contbil',
       'Conta Contbil',
       'VCMP.FILCTA = DCTA.FILCTA AND VCMP.SEQCTA = DCTA.SEQCTA AND VCMP.TIPCTA = DCTA.TIPCTA',
       'TITCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       1341,
       250,
       'TITCTA_CTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Conta Financeira',
       'Conta Financeira',
       '',
       '(SELECT CTA.TITCTA FROM TT_CTA CTA WHERE CTA.CODFIL=COM.FILCTA  AND CTA.SEQUEN=COM.SEQCTA  AND CTA.TIPCTA=COM.TIPCTA)',
       '' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       1500,
       12,
       'TOTPAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TOTPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       450,
       2,
       'UFNOTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF da Nota',
       'UF da Nota',
       '',
       'UFNOTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       860,
       12,
       'VE_PAGTO_FUN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VE_PAGTO_FUN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       460,
       14,
       'VLRBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Bonificao',
       'Valor Bonificao',
       '',
       'VLRBON',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       1510,
       12,
       'VLRCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VLRCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       690,
       12,
       'VLRCSS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Contr.Social',
       'Valor Contribuio Social',
       '',
       'VLRCSS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '01',
       570,
       12,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor de ICM Frete',
       'Valor de ICM do frete',
       '',
       'VLRFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       700,
       12,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor ICMS',
       'Valor ICMS',
       '',
       'VLRICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       710,
       12,
       'VLRINS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor INSS',
       'Valor INSS',
       '',
       'VLRINS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       870,
       12,
       'VLRIPI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor do IPI',
       'Valor do IPI',
       '',
       'VLRIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       720,
       12,
       'VLRIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor IRRF',
       'Valor IRRF',
       '',
       'VLRIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       730,
       12,
       'VLRISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor ISS',
       'Valor ISS',
       '',
       'VLRISS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       470,
       8,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Lquido',
       'Valor lquido',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       880,
       12,
       'VLRNOT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VLRNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '--',
       1520,
       12,
       'VLRPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VLRPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       480,
       12,
       'VLRRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Reteno',
       'Valor Reteno',
       '',
       'VLRRET',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       1320,
       12,
       'VLRSRV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor do Servio',
       'Valor do Servio',
       '',
       'VLRSRV',
       '' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       490,
       8,
       'VLRTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Total',
       'Valor total',
       '',
       'VLRTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       500,
       8,
       'VLTXJU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Juros',
       'Valor ou taxa de juros',
       '',
       'VLTXJU',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '03',
       510,
       8,
       'VLTXMU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Multa',
       'Valor ou taxa de multa',
       '',
       'VLTXMU',
       'F' FROM DUAL
UNION ALL
SELECT 'VCMP',
       '99',
       1560,
       4000,
       'XMLNFE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'XML da NFE',
       'XML da NFE',
       '',
       'XMLNFE',
       '' FROM DUAL
);

/*-- SEQ 9621 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VCMP',
       'CODDAR',
       0,
       '0',
       'documento estadual arrecadao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'CODDAR',
       0,
       '1',
       'GNRE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'FINNFE',
       0,
       '1',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'FINNFE',
       0,
       '2',
       'Complementar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'FINNFE',
       0,
       '3',
       'Ajuste',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'FINNFE',
       0,
       '4',
       'Devoluo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'FLGEST',
       0,
       'A',
       'Em aberto',
       12,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'FLGEST',
       0,
       'D',
       'Devolvida',
       10,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'FLGEST',
       0,
       'Q',
       'Quitada',
       11,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'INCOJU',
       0,
       '$',
       'Moeda',
       16,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'INCOJU',
       0,
       '0',
       'Nao h',
       18,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'INCOJU',
       0,
       'A',
       'Anual',
       15,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'INCOJU',
       0,
       'D',
       'Diria',
       13,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'INCOJU',
       0,
       'M',
       'Mensal',
       14,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'INTPJU',
       0,
       'C',
       'Composto',
       20,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'INTPJU',
       0,
       'F',
       'Fixo',
       21,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'INTPJU',
       0,
       'S',
       'Simples',
       19,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'INTPMU',
       0,
       '#',
       'Percentual Corrigido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'INTPMU',
       0,
       '$',
       'Valor',
       23,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'INTPMU',
       0,
       '%',
       'Percentual',
       22,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'INTPMU',
       0,
       '@',
       'Valor Corrigido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'NATFRE',
       0,
       '2',
       'Compra (Gera Crdito)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'NATFRE',
       0,
       '3',
       'Compra (No Gera Crdito)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'NATFRE',
       0,
       '9',
       'Outras',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Crdito-Tributada',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Crdito-Vinc Trib Export',
       TO_NUMBER(null),
       '54' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Crdito-Vinc NTrib Export',
       TO_NUMBER(null),
       '55' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib Exp',
       TO_NUMBER(null),
       '56' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Exc Trib',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Exc NTrib',
       TO_NUMBER(null),
       '61' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Exc Export',
       TO_NUMBER(null),
       '62' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Trib NTrib',
       TO_NUMBER(null),
       '63' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Trib Export',
       TO_NUMBER(null),
       '64' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis NTrib Export',
       TO_NUMBER(null),
       '65' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Trib NTrib Exp
',
       TO_NUMBER(null),
       '66' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Presum-Outras Operaes
',
       TO_NUMBER(null),
       '67' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Aquisio sem Dir Crdito',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Aquisio com Iseno',
       TO_NUMBER(null),
       '71' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Aquisio com Suspenso',
       TO_NUMBER(null),
       '72' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Aquisio a Alquota Zero',
       TO_NUMBER(null),
       '73' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Aquisio sem Inc Contrib',
       TO_NUMBER(null),
       '74' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Aquisio por ST
',
       TO_NUMBER(null),
       '75' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Outras Operaes de Entrada',
       TO_NUMBER(null),
       '98' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Crdito-No Tributada',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITCOF',
       0,
       ' ',
       'Crdito-Exportao',
       TO_NUMBER(null),
       '52' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Crdito-Tributada',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Crdito-No Tributada',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Crdito-Exportao',
       TO_NUMBER(null),
       '52' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib
',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Crdito-Vinc Trib Export',
       TO_NUMBER(null),
       '54' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Crdito-Vinc NTrib Export',
       TO_NUMBER(null),
       '55' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib Exp',
       TO_NUMBER(null),
       '56' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Exc Trib
',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Exc NTrib
',
       TO_NUMBER(null),
       '61' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Exc Export',
       TO_NUMBER(null),
       '62' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Trib NTrib',
       TO_NUMBER(null),
       '63' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Trib Export',
       TO_NUMBER(null),
       '64' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis NTrib Export',
       TO_NUMBER(null),
       '65' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Trib NTrib Exp',
       TO_NUMBER(null),
       '66' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Presum-Outras Operaes',
       TO_NUMBER(null),
       '67' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Aquisio sem Dir Crdito',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Aquisio com Iseno',
       TO_NUMBER(null),
       '71' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Aquisio com Suspenso',
       TO_NUMBER(null),
       '72' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Aquisio a Alquota Zero',
       TO_NUMBER(null),
       '73' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Aquisio sem Inc Contrib',
       TO_NUMBER(null),
       '74' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Aquisio por ST
',
       TO_NUMBER(null),
       '75' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Outras Operaes de Entrada',
       TO_NUMBER(null),
       '98' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'SITPIS',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'TIPNOT',
       0,
       'A',
       'N.F.F.',
       276,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'TIPNOT',
       0,
       'F',
       'Fatura',
       274,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'TIPNOT',
       0,
       'N',
       'Nota Fiscal',
       275,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'TIPPAR',
       0,
       'F',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'TIPPAR',
       0,
       'T',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'TIPTRP',
       0,
       '0',
       'Rodovirio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'TIPTRP',
       0,
       '1',
       'Aquavirio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'TIPTRP',
       0,
       '2',
       'Areo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCMP',
       'TIPTRP',
       0,
       '3',
       'Ferrovirio',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9622 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCOM',
       0,
       'VCOM',
       'Compras',
       'TV_COM',
       'T',
       '',
       'TOTALL',
       'Compras',
       '{CODFIL;FILFOR;CODFOR;CODSER;NUMNOT};DATOPE;FLGEST;NUMFAT;ATU_EM',
       '',
       '',
       'Compra',
       'T',
       '',
       'PDV.ID,VCOM.CODFIL,VCOM.CODSER,VCOM.NUMNOT
',
       '' FROM DUAL
);

/*-- SEQ 9623 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCOM','--','' FROM DUAL
UNION ALL
SELECT 'VCOM','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCOM','03','Valores' FROM DUAL
UNION ALL
SELECT 'VCOM','05','Juros e Multas' FROM DUAL
UNION ALL
SELECT 'VCOM','06','Transporte' FROM DUAL
UNION ALL
SELECT 'VCOM','99','Outros' FROM DUAL
);

/*-- SEQ 9624 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 28970,
       'CTA ',
       'VCOM',
       '1',
       'N',
       '',
       '',
       'CTA.CODFIL = VCOM.FILCTA AND
CTA.SEQUEN = VCOM.SEQCTA AND
CTA.TIPCTA = VCOM.TIPCTA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 28971,
       'FCM ',
       'VCOM',
       '1',
       'N',
       '',
       '',
       'FCM.CODFIL = VCOM.CODFIL and
FCM.SEQUEN = VCOM.SEQFAT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 28972,
       'PVD ',
       'VCOM',
       '1',
       'N',
       '',
       '',
       'PVD.FILPAR = VCOM.FILFOR and
PVD.CODPAR = VCOM.CODFOR and
PVD.TIPPAR = VCOM.TIPPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 28973,
       'USU ',
       'VCOM',
       '1',
       'N',
       '',
       '',
       'USU.FILUSU = VCOM.FILUSU and
USU.CODUSU = VCOM.CODUSU
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 28974,
       'ICO ',
       'VCOM',
       'N',
       '01',
       '',
       '',
       'ICO.CODFIL = VCOM.CODFIL (+) and
ICO.SEQUEN = VCOM.SEQUEN (+) ',
       '(CASE WHEN VCOM.VLRTOT = 0 THEN 0 ELSE ((ICO.VLRMOV*(1+COALESCE(ICO.IPIITE,0)/100)) / VCOM.VLRTOT) END)',
       '' FROM DUAL
UNION ALL
SELECT 28975,
       'FRE ',
       'VCOM',
       '01',
       '01',
       '',
       '',
       'FRE.CODFIL = VCOM.CODFIL (+) and
FRE.SEQUEN = VCOM.SEQFRE (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 28976,
       'CLI ',
       'VCOM',
       '1',
       'N',
       '',
       '',
       'CLI.FILCLI = VCOM.FILFOR and
CLI.CODCLI = VCOM.CODFOR',
       '',
       '' FROM DUAL
);

/*-- SEQ 9625 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCOM',
       '01',
       290,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'COM ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(VCOM.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       240,
       4,
       'ANO_DATCMP',
       'A',
       '',
       0,
       0,
       'COM ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       '',
       'N',
       'T',
       'Ano de Data Compra',
       'Ano de Data da compra',
       '',
       'TO_CHAR(VCOM.DATCMP,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       210,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       0,
       'COM ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       '',
       'N',
       'T',
       'Ano de Data Lanto',
       'Ano de Data da operao',
       '',
       'TO_CHAR(VCOM.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '99',
       501,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN VCOM.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       530,
       1,
       'ATUCUS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Atualiza Custos?',
       'Atualiza Custos?',
       '',
       'ATUCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       270,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'COM ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '--',
       580,
       14,
       'BSTFRE ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base de Substituio',
       'Base de Substituio',
       '',
       'BSTFRE ',
       '' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       521,
       5,
       'CODCFO',
       'S',
       'DCFO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCFO.DESCFO',
       'V',
       '',
       '',
       'A',
       'F',
       'Descrio CFOP',
       'Descrio CFOP de compra',
       'DCFO.CODTAB(+) = VCOM.CODCFO',
       'CODCFO',
       'T' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       523,
       5,
       'CODCFOP',
       'S',
       'CFOP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'CFOP.CODCFO',
       'V',
       '',
       '',
       'A',
       '',
       'CFOP de Compra',
       'Cdigo CFOP de compra',
       'CFOP.CODTAB(+) = VCOM.CODCFO',
       'CODCFO',
       'T' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       120,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       0,
       'COM ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'COM',
       'F',
       'A',
       'T',
       'Filial',
       'Cdigo da Filial de Origem',
       'DFIL.CODFIL = VCOM.CODFIL',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       140,
       6,
       'CODFOR',
       'A',
       '',
       0,
       0,
       'COM ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       'F',
       '9',
       'F',
       'Fornecedor',
       'Cdigo do fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '99',
       1210,
       2,
       'CODFPS',
       'A',
       'DFPS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFPS.DESFPS',
       'V',
       '',
       '',
       'A',
       'F',
       'Finalidade Com/ Fret',
       'Finalidade do Compromisso/Frete',
       'DFPS.CODFPS = VCOM.CODFPS',
       'CODFPS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '99',
       1340,
       10,
       'CODIBG',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo IBGE Origem',
       'Cdigo IBGE da Cidade de Origem',
       '',
       'CODIBG',
       '' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '03',
       350,
       2,
       'CODMOE',
       'S',
       'DMOE',
       0,
       0,
       'COM ',
       60,
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       'COM',
       'F',
       'A',
       'T',
       'Moeda',
       'Cdigo da moeda',
       'DMOE.CODTAB = VCOM.CODMOE(+)',
       'CODMOE',
       'T' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       150,
       2,
       'CODSER',
       'A',
       '',
       0,
       0,
       'COM ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'COM',
       'F',
       'A',
       'T',
       'Srie',
       'Cdigo da srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '99',
       510,
       5,
       'CODSET',
       'N',
       'DSET',
       0,
       TO_NUMBER(null),
       '',
       90,
       TO_NUMBER(null),
       '',
       'DSET.DESSET',
       'V',
       '',
       'F',
       'N',
       'T',
       'Setor',
       'Setor',
       'DSET.CODTAB = VCOM.CODSET(+) ',
       'CODSET',
       'T' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '99',
       1330,
       4,
       'CODSRV',
       'S',
       'SRV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SRV.DESSRV',
       'V',
       '',
       '',
       'N',
       '',
       'Descrio do Servio',
       'Descrio do Servio',
       'SRV.CODSRV = VCOM.CODSRV(+)',
       'CODSRV',
       'T' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '99',
       450,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       0,
       'COM ',
       20,
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       'COM',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'VCOM.FILUSU = USU.FILUSU(+)  and VCOM.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '03',
       360,
       10,
       'CONPGT',
       'A',
       '',
       0,
       0,
       'COM ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'COM',
       'F',
       'A',
       'T',
       'Cond. Pagto.',
       'Condio de Pagamento',
       '',
       'CONPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       220,
       8,
       'DATCMP',
       'D',
       '',
       0,
       0,
       'COM ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       'F',
       'D',
       'T',
       'Data Compra',
       'Data da compra',
       '',
       'DATCMP',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       190,
       8,
       'DATOPE',
       '@',
       '',
       0,
       0,
       'COM ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       'F',
       '@',
       'T',
       'Data Lanto',
       'Data da operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '03',
       330,
       8,
       'DESCON',
       'F',
       '',
       2,
       0,
       'COM ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       'T',
       '9',
       'T',
       'Desconto',
       'Desconto',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       180,
       13,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       70,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Documento',
       'Documento (Srie + Sub-Srie + Nmero )',
       '',
       '(TRIM(VCOM.CODSER) ||''/''|| CASE WHEN VCOM.SUBSER IS NULL THEN '''' ELSE TRIM(VCOM.SUBSER)||''-'' END || TRIM(VCOM.NUMNOT))',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '99',
       480,
       3,
       'ESPDOC',
       'A',
       '',
       0,
       0,
       'COM ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'COM',
       'F',
       'A',
       'T',
       'Espcie Docto',
       'Espcie de Documento',
       '',
       'ESPDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       10,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da conta gerencial da compra',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       100,
       3,
       'FILEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Endereo',
       '',
       'FILEND',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       130,
       3,
       'FILFOR',
       'A',
       '',
       0,
       0,
       'COM ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       'F',
       'N',
       'F',
       '',
       'Filial do fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '99',
       440,
       3,
       'FILUSU',
       'A',
       '',
       0,
       0,
       'COM ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       'F',
       'N',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '99',
       1310,
       1,
       'FINNFE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Finalidade da NF-e',
       'Finalidade da NF-e',
       '',
       'FINNFE',
       'T' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       260,
       1,
       'FLGEST',
       'A',
       '',
       0,
       0,
       'COM ',
       110,
       30,
       '',
       '',
       'D',
       'COM',
       'F',
       'A',
       'T',
       'Situao',
       'Situao (Devolvida/Quitada/Em aberto)',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '05',
       400,
       1,
       'INCOJU',
       'A',
       '',
       0,
       0,
       'COM ',
       30,
       30,
       '',
       '',
       'D',
       'COM',
       'F',
       'A',
       'T',
       'Correo',
       'Indicador do tipo de correo de juros',
       '',
       'INCOJU',
       'T' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '05',
       410,
       1,
       'INTPJU',
       'A',
       '',
       0,
       0,
       'COM ',
       40,
       30,
       '',
       '',
       'D',
       'COM',
       'F',
       'A',
       'T',
       'Tipo Juros',
       'Indicador do tipo de juros',
       '',
       'INTPJU',
       'T' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '05',
       430,
       1,
       'INTPMU',
       'A',
       '',
       0,
       0,
       'COM ',
       60,
       30,
       '',
       '',
       'D',
       'COM',
       'F',
       'A',
       'T',
       'Tipo Multa',
       'Indicador do tipo de multa',
       '',
       'INTPMU',
       'T' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       280,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'COM ',
       120,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       '',
       'A',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(VCOM.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       230,
       2,
       'MES_DATCMP',
       'A',
       '',
       0,
       0,
       'COM ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       '',
       'N',
       'T',
       'Ms de Data Compra',
       'Ms de Data da compra',
       '',
       'TO_CHAR(VCOM.DATCMP,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       200,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       0,
       'COM ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       '',
       'N',
       'T',
       'Ms de Data Lanto',
       'Ms de Data da operao',
       '',
       'TO_CHAR(VCOM.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '05',
       390,
       2,
       'MOEJUR',
       'S',
       'DMOE',
       0,
       0,
       'COM ',
       20,
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       'COM',
       'F',
       'A',
       'T',
       'Moeda Correo',
       'Moeda da Correo',
       'DMOE.CODTAB = VCOM.MOEJUR(+)',
       'MOEJUR',
       'T' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '99',
       1290,
       1,
       'NATFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Natureza do Frete',
       'Natureza do Frete Contratado',
       '',
       'NATFRE',
       'T' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       520,
       6,
       'NATURE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Natureza',
       'Natureza',
       '',
       '(CASE WHEN VCOM.NATURE IS NULL THEN ''TRANSFERENCIA'' ELSE VCOM.NATURE END)',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       250,
       0,
       'NOTESP',
       'L',
       '',
       0,
       0,
       'COM ',
       100,
       TO_NUMBER(null),
       'Sera verdadeiro quando TIPNOT = ''''A'''' ou ''''F''''
e sera falso quando TIPNOT = ''''N''''
Quando for verdadeiro nao gera compromisso financeiro e nao do contrario',
       '',
       'Y',
       'COM',
       'F',
       'A',
       'T',
       'Nota Especial?',
       'Nota Especial',
       '',
       'NOTESP',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       125,
       3,
       'NUMCODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       110,
       2,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Nmero de Endereos',
       'Nmero de Endereos',
       '',
       'NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       170,
       9,
       'NUMNOT',
       'A',
       '',
       0,
       0,
       'COM ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       'F',
       '9',
       'T',
       'Nmero',
       'Nmero da nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       90,
       5,
       'NUMVOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nro de Volumes',
       'Numero Volumes',
       '',
       'NUMVOL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '99',
       460,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'COM ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'COM',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(VCOM.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '99',
       550,
       255,
       'OBSFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao Fatura',
       'Observao Fatura',
       '',
       'OBSFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '03',
       320,
       8,
       'OUTTAX',
       'F',
       '',
       2,
       0,
       'COM ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       'T',
       '9',
       'T',
       'Outras Taxas',
       'Outras taxas',
       '',
       'OUTTAX',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '03',
       300,
       8,
       'QTDTOT',
       'F',
       '',
       2,
       0,
       'COM ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       'T',
       '9',
       'T',
       'Qtd. Total',
       'Quantidade total',
       '',
       'QTDTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       80,
       10,
       'SEQCAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador de cancelamentos',
       '',
       'SEQCAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       20,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Squenciador da conta gerencial da Compra ',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       40,
       10,
       'SEQFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'COM ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequencia NF Fatura',
       '',
       'SEQFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       50,
       10,
       'SEQFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'COM ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequencia Frete',
       '',
       'SEQFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'COM ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '99',
       500,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'COM ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'COM',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN VCOM.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '99',
       1160,
       2,
       'SITCOF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'CST Cofins',
       'CST Cofins',
       '',
       'SITCOF',
       'T' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '99',
       1150,
       2,
       'SITPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'CST PIS',
       'CST PIS',
       '',
       'SITPIS',
       'T' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '--',
       590,
       14,
       'ST_FRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr. de Substituio',
       'Valor de Substituio',
       '',
       'ST_FRE',
       '' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       160,
       3,
       'SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Sub-Srie',
       'Sub-Srie de compra',
       '',
       'SUBSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '03',
       370,
       12,
       'SUBSTT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Substit. Tributria',
       'Substit. Tributria',
       '',
       'SUBSTT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       30,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo da conta gerencial da compra',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '99',
       490,
       1,
       'TIPNOT',
       'A',
       '',
       0,
       0,
       'COM ',
       60,
       30,
       '(A e F) Gera um compromisso financeiro
(N) Nao gera compromisso financeiro',
       '',
       'D',
       'COM',
       'F',
       'A',
       'T',
       'Tipo de Docto',
       'Tipo de Documento',
       '',
       'TIPNOT',
       'T' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       70,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'COM ',
       40,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Parceiro',
       'Tipo de Parceiro',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '01',
       560,
       2,
       'UFNOTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF da Nota',
       'UF da Nota',
       '',
       'UFNOTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '03',
       570,
       14,
       'VLRBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Bonificao',
       'Valor Bonificao',
       '',
       'VLRBON',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '03',
       340,
       8,
       'VLRLIQ',
       'F',
       '',
       2,
       0,
       'COM ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       'T',
       '9',
       'T',
       'Valor Lquido',
       'Valor lquido',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '03',
       580,
       12,
       'VLRRET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Reteno',
       'Valor Reteno',
       '',
       'VLRRET',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '03',
       1300,
       12,
       'VLRSRV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor do Servio',
       'Valor do Servio',
       '',
       'VLRSRV',
       '' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '03',
       310,
       12,
       'VLRTOT',
       'F',
       '',
       2,
       0,
       'COM ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       'T',
       '',
       'T',
       'Valor Total',
       'Valor total',
       '',
       'VLRTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '05',
       380,
       8,
       'VLTXJU',
       'F',
       '',
       2,
       0,
       'COM ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       'T',
       '9',
       'T',
       'Juros',
       'Valor ou taxa de juros',
       '',
       'VLTXJU',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '05',
       420,
       8,
       'VLTXMU',
       'F',
       '',
       2,
       0,
       'COM ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'COM',
       'T',
       '9',
       'T',
       'Multa',
       'Valor ou taxa de multa',
       '',
       'VLTXMU',
       'F' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '03',
       1301,
       12,
       'VVLRICMS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor ICMS',
       'Valor ICMS',
       '',
       '(SELECT SUM(ICO.VLRICM) FROM TT_ICO ICO WHERE ICO.CODFIL = VCOM.CODFIL AND ICO.SEQUEN = VCOM.SEQUEN)',
       '' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '03',
       1302,
       12,
       'VVLRIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor IPI',
       'Valor IPI',
       '',
       '(SELECT SUM(ICO.VLRIPI) FROM TT_ICO ICO WHERE ICO.CODFIL = VCOM.CODFIL AND ICO.SEQUEN = VCOM.SEQUEN)',
       '' FROM DUAL
UNION ALL
SELECT 'VCOM',
       '99',
       1320,
       4000,
       'XMLNFE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'XML da NFE',
       'XML da NFE',
       '',
       'XMLNFE',
       '' FROM DUAL
);

/*-- SEQ 9626 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VCOM',
       'FINNFE',
       0,
       '1',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'FINNFE',
       0,
       '2',
       'Complementar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'FINNFE',
       0,
       '3',
       'Ajuste',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'FINNFE',
       0,
       '4',
       'Devoluo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'FLGEST',
       0,
       'A',
       'Em aberto',
       12,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'FLGEST',
       0,
       'D',
       'Devolvida',
       10,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'FLGEST',
       0,
       'Q',
       'Quitada',
       11,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'INCOJU',
       0,
       '$',
       'Moeda',
       16,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'INCOJU',
       0,
       '0',
       'Nao h',
       18,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'INCOJU',
       0,
       'A',
       'Anual',
       15,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'INCOJU',
       0,
       'D',
       'Diria',
       13,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'INCOJU',
       0,
       'M',
       'Mensal',
       14,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'INTPJU',
       0,
       'C',
       'Composto',
       20,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'INTPJU',
       0,
       'F',
       'Fixo',
       21,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'INTPJU',
       0,
       'S',
       'Simples',
       19,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'INTPMU',
       0,
       '#',
       'Percentual Corrigido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'INTPMU',
       0,
       '$',
       'Valor',
       23,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'INTPMU',
       0,
       '%',
       'Percentual',
       22,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'INTPMU',
       0,
       '@',
       'Valor Corrigido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'NATFRE',
       0,
       '2',
       'Compra (Gera Crdito)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'NATFRE',
       0,
       '3',
       'Compra (No Gera Crdito)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'NATFRE',
       0,
       '9',
       'Outras',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Crdito-Tributada',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Crdito-No Tributada',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Crdito-Exportao',
       TO_NUMBER(null),
       '52' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Crdito-Vinc Trib Export',
       TO_NUMBER(null),
       '54' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Crdito-Vinc NTrib Export',
       TO_NUMBER(null),
       '55' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib Exp',
       TO_NUMBER(null),
       '56' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Exc Trib',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Exc NTrib',
       TO_NUMBER(null),
       '61' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Exc Export',
       TO_NUMBER(null),
       '62' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Trib NTrib',
       TO_NUMBER(null),
       '63' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Trib Export',
       TO_NUMBER(null),
       '64' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis NTrib Export',
       TO_NUMBER(null),
       '65' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Presum-Aquis Trib NTrib Exp
',
       TO_NUMBER(null),
       '66' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Presum-Outras Operaes
',
       TO_NUMBER(null),
       '67' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Aquisio sem Dir Crdito',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Aquisio com Iseno',
       TO_NUMBER(null),
       '71' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Aquisio com Suspenso',
       TO_NUMBER(null),
       '72' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Aquisio a Alquota Zero',
       TO_NUMBER(null),
       '73' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Aquisio sem Inc Contrib',
       TO_NUMBER(null),
       '74' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Aquisio por ST
',
       TO_NUMBER(null),
       '75' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Outras Operaes de Entrada',
       TO_NUMBER(null),
       '98' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITCOF',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Crdito-Tributada',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Crdito-No Tributada',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Crdito-Exportao',
       TO_NUMBER(null),
       '52' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib
',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Crdito-Vinc Trib Export',
       TO_NUMBER(null),
       '54' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Crdito-Vinc NTrib Export',
       TO_NUMBER(null),
       '55' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib Exp',
       TO_NUMBER(null),
       '56' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Exc Trib
',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Exc NTrib
',
       TO_NUMBER(null),
       '61' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Exc Export',
       TO_NUMBER(null),
       '62' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Trib NTrib',
       TO_NUMBER(null),
       '63' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Trib Export',
       TO_NUMBER(null),
       '64' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis NTrib Export',
       TO_NUMBER(null),
       '65' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Presum-Aquis Trib NTrib Exp',
       TO_NUMBER(null),
       '66' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Presum-Outras Operaes',
       TO_NUMBER(null),
       '67' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Aquisio sem Dir Crdito',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Aquisio com Iseno',
       TO_NUMBER(null),
       '71' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Aquisio com Suspenso',
       TO_NUMBER(null),
       '72' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Aquisio a Alquota Zero',
       TO_NUMBER(null),
       '73' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Aquisio sem Inc Contrib',
       TO_NUMBER(null),
       '74' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Aquisio por ST
',
       TO_NUMBER(null),
       '75' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Outras Operaes de Entrada',
       TO_NUMBER(null),
       '98' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'SITPIS',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'TIPNOT',
       0,
       'A',
       'N.F.F.',
       276,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'TIPNOT',
       0,
       'F',
       'Fatura',
       274,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'TIPNOT',
       0,
       'N',
       'Nota Fiscal',
       275,
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'TIPPAR',
       0,
       'F',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCOM',
       'TIPPAR',
       0,
       'T',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9627 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCP ',
       TO_NUMBER(null),
       'VCP ',
       'Pontos de Crditos',
       'TV_CRE_PON',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'vcp.filcli,vcp.codcli',
       '' FROM DUAL
);

/*-- SEQ 9628 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCP ','--','' FROM DUAL
UNION ALL
SELECT 'VCP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCP ','99','Outros' FROM DUAL
);

/*-- SEQ 9629 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCP ',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCP ',
       '--',
       60,
       6,
       'COLUNA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Coluna',
       'Coluna',
       '',
       'COLUNA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCP ',
       '01',
       20,
       40,
       'DESCRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Pontos',
       'Descrio dos Pontos de Crdito',
       '',
       'DESCRI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCP ',
       '01',
       30,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCP ',
       '01',
       40,
       12,
       'NIVEL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nvel de Pontuao',
       'Nvel de Pontuao',
       '',
       'NIVEL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCP ',
       '01',
       50,
       12,
       'PONTOS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Pontos',
       'Pontos',
       '',
       'PONTOS',
       'F' FROM DUAL
);

/*-- SEQ 9630 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCPE',
       TO_NUMBER(null),
       'VCPE',
       'Cheques Rec.Penden.',
       'TV_CHR_PEN',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9631 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCPE','--','' FROM DUAL
UNION ALL
SELECT 'VCPE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCPE','99','Outros' FROM DUAL
);

/*-- SEQ 9632 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCPE',
       '01',
       10,
       2,
       'ALINEA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Alnea',
       'Alnea',
       '',
       'ALINEA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPE',
       '01',
       20,
       27,
       'CHEQUE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cheque',
       'Cheque',
       '',
       'CHEQUE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPE',
       '01',
       130,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Filial',
       'Cdigo Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPE',
       '01',
       30,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPE',
       '01',
       40,
       7,
       'DATVEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Venda',
       'Data Venda',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPE',
       '01',
       50,
       15,
       'FILIAL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       '',
       'FILIAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPE',
       '01',
       60,
       28,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPE',
       '01',
       70,
       1,
       'NUMDEP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero Dependentes',
       'Nmero Dependentes',
       '',
       'NUMDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPE',
       '01',
       80,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Documento',
       'Nmero Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPE',
       '01',
       90,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero ECF',
       'Nmero ECF',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPE',
       '01',
       100,
       7,
       'PAGAME',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'PAGAME',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPE',
       '01',
       110,
       30,
       'PORTAD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Portador',
       'Portador',
       '',
       'PORTAD',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPE',
       '01',
       140,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPE',
       '01',
       120,
       9,
       'VLRCHE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Cheque',
       'Valor Cheque',
       '',
       'VLRCHE',
       'F' FROM DUAL
);

/*-- SEQ 9633 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCPM',
       TO_NUMBER(null),
       'VCPM',
       'Preos Promoc. val.',
       'TT_CPM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Preos promocionais atualmente vlidos',
       'VCPM.FILCPM,VCPM.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9634 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCPM','--','' FROM DUAL
);

/*-- SEQ 9635 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 11929,
       'PLA ',
       'VCPM',
       'N',
       '1',
       '',
       '',
       'PLA.CODPGT = VCPM.CODPGT AND
PLA.FILPGT = VCPM.FILPGT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 11930,
       'PRE ',
       'VCPM',
       'N',
       '01',
       '',
       '',
       'PRE.FILPRE = VCPM.FILPRE AND
PRE.SEQUEN = VCPM.SEQPRE and
TRUNC(AGORA()) BETWEEN VCPM.DATINI AND VCPM.DATVAL',
       '',
       '' FROM DUAL
UNION ALL
SELECT 11931,
       'USU ',
       'VCPM',
       'N',
       '1',
       '',
       '',
       'USU.FILUSU = VCPM.FILUSU AND
USU.FILUSU = VCPM.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 9636 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCPM',
       '--',
       20,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'ltima atualizao',
       'ltima atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPM',
       '--',
       100,
       1,
       'CLILEV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Promoo Cliente Lev',
       'Promoo somente quando o cliente leva',
       '',
       'CLILEV',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPM',
       '--',
       6,
       3,
       'CODPGT',
       'A',
       'PLA2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'PLA2.DESPGT',
       'V',
       '',
       'F',
       '9',
       'F',
       'Pagamento',
       'Cdigo do Pagamento',
       'PLA2.CODPGT = VCPM.CODPGT AND PLA2.FILPGT = VCPM.FILPGT',
       'CODPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPM',
       '--',
       10,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do Usurio',
       'VCPM.FILUSU = USU2.FILUSU(+) AND USU2.CODUSU(+) = VCPM.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VCPM',
       '--',
       70,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data da incluso',
       'Data da incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPM',
       '--',
       30,
       7,
       'DATINI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Incio da promoo',
       'Incio da promoo',
       '',
       'DATINI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPM',
       '--',
       8,
       7,
       'DATVAL',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Validade',
       'Data de Validade',
       '',
       'DATVAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPM',
       '--',
       1,
       3,
       'FILCPM',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial Preos Prom.',
       'Filial Preos Promocionais',
       'DFIL.CODFIL = VCPM.FILCPM(+)',
       'FILCPM',
       'T' FROM DUAL
UNION ALL
SELECT 'VCPM',
       '--',
       50,
       3,
       'FILLOT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial Lote',
       'Filial do Lote',
       'DFIL.CODFIL = VCPM.FILLOT',
       'FILLOT',
       'T' FROM DUAL
UNION ALL
SELECT 'VCPM',
       '--',
       5,
       3,
       'FILPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Plano de Pagamento',
       '',
       'FILPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPM',
       '--',
       3,
       3,
       'FILPRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial dos Preos',
       '',
       'FILPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPM',
       '--',
       40,
       3,
       'FILPRO',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial da promoo',
       'Filial da promoo',
       'DFIL.CODFIL(+) = VCPM.FILPRO',
       'FILPRO',
       'T' FROM DUAL
UNION ALL
SELECT 'VCPM',
       '--',
       9,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPM',
       '--',
       7,
       10,
       'PRECOP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Preo Promocional',
       'Preo Promocional',
       '',
       'PRECOP',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPM',
       '--',
       80,
       12,
       'QTDCPM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Quantidade Disp.',
       'Quantidade disponvel para promoo',
       '',
       'QTDCPM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPM',
       '--',
       90,
       12,
       'QTDMIN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Quantidade Mnima',
       'Quantidade Mnima',
       '',
       'QTDMIN',
       '' FROM DUAL
UNION ALL
SELECT 'VCPM',
       '--',
       60,
       10,
       'SEQLOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Seq Lote',
       'Sequenciador do Lote',
       '',
       'SEQLOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPM',
       '--',
       4,
       10,
       'SEQPRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador de Preos',
       '',
       'SEQPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPM',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCPM',
       '--',
       110,
       1,
       'TEMDES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Aceita Desconto?',
       'Aceita Desconto',
       '',
       'TEMDES',
       'T' FROM DUAL
);


/*-- SEQ 9637 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VCPM',
       'TEMDES',
       0,
       'F',
       'No Aceita Desconto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCPM',
       'TEMDES',
       0,
       'T',
       'Aceita Desconto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCPM',
       'TEMDES',
       0,
       'X',
       'Conforme Configurao',
       TO_NUMBER(null),
       ' ' FROM DUAL
);
/*-- SEQ 9638 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VPCO',
       TO_NUMBER(null),
       'VPCO',
       'Produto controlado',
       'TV_PRO_CONTROLADO',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9639 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VPCO','--','' FROM DUAL
UNION ALL
SELECT 'VPCO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VPCO','02','Datas' FROM DUAL
UNION ALL
SELECT 'VPCO','03','Valores' FROM DUAL
UNION ALL
SELECT 'VPCO','99','Outros' FROM DUAL
);

/*-- SEQ 9640 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VPCO',
       '02',
       10,
       7,
       'DATFIS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da venda',
       'Data da venda.',
       '',
       'DATFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VPCO',
       '01',
       20,
       30,
       'DESMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio do produto',
       'Descrio do produto.',
       '',
       'DESMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPCO',
       '01',
       30,
       6,
       'NOTIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nota de reimpresso',
       'Nmero da nota de reimpresso.',
       '',
       'NOTIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'VPCO',
       '01',
       40,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'CPF/CNPJ do cliente',
       'CPF/CNPJ do cliente.',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VPCO',
       '01',
       50,
       6,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do cupom',
       'Nmero do cupom fiscal.',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPCO',
       '03',
       60,
       12,
       'PREUNI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Preo unitrio',
       'Preo unitrio.',
       '',
       'PREUNI',
       'F' FROM DUAL
UNION ALL
SELECT 'VPCO',
       '03',
       70,
       12,
       'QTDMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade',
       'Quantidade vendida.',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VPCO',
       '01',
       80,
       15,
       'REFBAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Referncia basica',
       'Referncia basica do produto.',
       '',
       'REFBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VPCO',
       '01',
       90,
       20,
       'REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Referncia de grade',
       'Referncia da grade do produto.',
       '',
       'REFPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VPCO',
       '03',
       100,
       14,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor liqudo',
       'Valor lquido de venda.',
       '',
       'VLRMOV',
       'F' FROM DUAL
);

/*-- SEQ 9641 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCRC',
       TO_NUMBER(null),
       'VCRC',
       'Caracterizao x Cli',
       'TV_CRTXCLI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9642 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCRC','01','Identificao' FROM DUAL
);

/*-- SEQ 9643 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCRC',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCRC',
       '01',
       10,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Cliente',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCRC',
       '01',
       30,
       1,
       'USODET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Uso',
       'Uso',
       '',
       'USODET',
       'F' FROM DUAL
);

/*-- SEQ 9644 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCRE',
       TO_NUMBER(null),
       'VCRE',
       'Caracterizao End.',
       'TV_CRTXEND',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9645 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCRE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCRE','53','Sede' FROM DUAL
UNION ALL
SELECT 'VCRE','62','teste' FROM DUAL
);

/*-- SEQ 9646 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCRE',
       '53',
       600,
       254,
       'CAMPO207',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Local',
       'Local',
       '',
       'VALORCRT_STRING(''E'',207,FILCLI,CODCLI)',
       'F' FROM DUAL
UNION ALL
SELECT 'VCRE',
       '53',
       700,
       14,
       'CAMPO208',
       'F',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'T',
       'Sede 1',
       'Sede 1',
       '',
       'VALORCRT_NUMBER(''E'',208,FILCLI,CODCLI)',
       'F' FROM DUAL
UNION ALL
SELECT 'VCRE',
       '53',
       800,
       14,
       'CAMPO211',
       'F',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'T',
       'tes',
       'tes',
       '',
       'VALORCRT_NUMBER(''E'',211,FILCLI,CODCLI)',
       'F' FROM DUAL
UNION ALL
SELECT 'VCRE',
       '53',
       900,
       14,
       'CAMPO212',
       'F',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'T',
       'tes2',
       'tes2',
       '',
       'VALORCRT_NUMBER(''E'',212,FILCLI,CODCLI)',
       'F' FROM DUAL
UNION ALL
SELECT 'VCRE',
       '53',
       1000,
       254,
       'CAMPO214',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       254,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'T',
       't33',
       't33',
       '',
       'VALORCRT_STRING(''E'',214,FILCLI,CODCLI)',
       'T' FROM DUAL
UNION ALL
SELECT 'VCRE',
       '62',
       1600,
       14,
       'CAMPO231',
       'F',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'T',
       'teste',
       'teste',
       '',
       'VALORCRT_NUMBER(''E'',231,FILCLI,CODCLI)',
       'F' FROM DUAL
UNION ALL
SELECT 'VCRE',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCRE',
       '01',
       10,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Cliente',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCRE',
       '01',
       30,
       3,
       'FILEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Endereo',
       'Filial Endereo',
       '',
       'FILEND',
       'F' FROM DUAL
UNION ALL
SELECT 'VCRE',
       '01',
       40,
       4,
       'NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero Endereo',
       'Nmero Endereo',
       '',
       'NUMEND',
       'F' FROM DUAL
);

/*-- SEQ 9647 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VCRE',
       'CAMPO214',
       0,
       ' ',
       'combo 1',
       10,
       'combo 1' FROM DUAL
);

/*-- SEQ 9648 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCRG',
       TO_NUMBER(null),
       'VCRG',
       'Caracterizao Grade',
       'TV_CRTXGRA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9649 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCRG','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCRG','1 ','Casa Carneiro' FROM DUAL
);

/*-- SEQ 9650 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22198,
       'GRA ',
       'VCRG',
       '1',
       '1',
       '',
       '',
       'GRA.FILMAT = VCRG.FILMAT and 
GRA.CODMAT = VCRG.CODMAT and 
GRA.CODCOR = VCRG.CODCOR and 
GRA.CODTAM = VCRG.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 9651 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCRG',
       '1 ',
       100,
       14,
       'CAMPO1',
       'F',
       '',
       6,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Litro',
       'Litro',
       '',
       'VALORCRT_NUMBER(''G'',1,VCRG.FILMAT,VCRG.CODMAT,to_char(VCRG.CODCOR),to_char(VCRG.CODTAM))',
       '' FROM DUAL
UNION ALL
SELECT 'VCRG',
       '01',
       30,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Diviso do produto',
       'DIV.CODITE (+) = VCRG.CODCOR',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'VCRG',
       '01',
       20,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Material',
       'Cdigo Material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCRG',
       '01',
       40,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'SUB.CODITE (+) = VCRG.CODTAM',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'VCRG',
       '01',
       10,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Material',
       'Filial Material',
       '',
       'FILMAT',
       'F' FROM DUAL
);

/*-- SEQ 9652 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCRP',
       TO_NUMBER(null),
       'VCRP',
       'Caracterizao Prod.',
       'TV_CRTXPRO',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9653 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCRP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCRP','52','prod1' FROM DUAL
UNION ALL
SELECT 'VCRP','88','Banco de Dados' FROM DUAL
);

/*-- SEQ 9654 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCRP',
       '01',
       20,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Material',
       'Cdigo Material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCRP',
       '01',
       10,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Material',
       'Filial Material',
       '',
       'FILMAT',
       'F' FROM DUAL
);

/*-- SEQ 9655 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCS ',
       TO_NUMBER(null),
       'VCS ',
       'Cheques Rec X SGD',
       'TV_CHR_SGD',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'vcs.codfil,vcs.sequen',
       '' FROM DUAL
);

/*-- SEQ 9656 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCS ','--','' FROM DUAL
UNION ALL
SELECT 'VCS ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCS ','99','Outros' FROM DUAL
);

/*-- SEQ 9657 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCS ',
       '01',
       10,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Banco',
       'Cdigo do Banco',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'VCS ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VCS.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCS ',
       '01',
       30,
       10,
       'CTACRR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm. Conta Corrente',
       'Nmero da Conta Corrente',
       '',
       'CTACRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCS ',
       '01',
       40,
       4000,
       'LINHA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCS ',
       '01',
       50,
       5,
       'NUMAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Numero Agencia',
       'Numero da Agncia',
       '',
       'NUMAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCS ',
       '01',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCS ',
       '01',
       70,
       1,
       'TIPDEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Dep.',
       'Tipo Dep.',
       '',
       'TIPDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'VCS ',
       '01',
       80,
       1,
       'TIPREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Registro',
       'Tipo Registro: Verbal,Telefone,Fax,E-mail,Carta,Site e Mensagem ',
       '',
       'TIPREG',
       'T' FROM DUAL
UNION ALL
SELECT 'VCS ',
       '01',
       90,
       12,
       'VLRREG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Registro',
       'Valor Registro',
       '',
       'VLRREG',
       'F' FROM DUAL
);

/*-- SEQ 9658 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VCS ',
       'TIPREG',
       0,
       'C',
       'Carta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCS ',
       'TIPREG',
       0,
       'E',
       'E-mail',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCS ',
       'TIPREG',
       0,
       'F',
       'Fax',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCS ',
       'TIPREG',
       0,
       'M',
       'Mensagem Instantnea',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCS ',
       'TIPREG',
       0,
       'S',
       'Site',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCS ',
       'TIPREG',
       0,
       'T',
       'Telefone',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCS ',
       'TIPREG',
       0,
       'V',
       'Verbal',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9659 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCSP',
       TO_NUMBER(null),
       'VCSP',
       'Rat.Custo p/ Parcela',
       'TV_CUSPAR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9660 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCSP','--','' FROM DUAL
UNION ALL
SELECT 'VCSP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCSP','99','Outros' FROM DUAL
);

/*-- SEQ 9661 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21945,
       'PAG ',
       'VCSP',
       '1',
       '1',
       '',
       '',
       'PAG.CODFIL = VCSP.CODFIL AND
PAG.SEQUEN = VCSP.SEQUEN AND
PAG.NUMPAR = VCSP.NUMPAR AND
PAG.SUBPAR = VCSP.SUBPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21946,
       'VPGT',
       'VCSP',
       '1',
       '1',
       '',
       '',
       'VPGT.CODFIL = VCSP.CODFIL AND
VPGT.SEQUEN = VCSP.SEQUEN AND
VPGT.NUMPAR = VCSP.NUMPAR AND
VPGT.SUBPAR = VCSP.SUBPAR',
       '',
       '' FROM DUAL
);

/*-- SEQ 9662 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCSP',
       '99',
       10,
       5,
       'CODCUS',
       'S',
       'DCUS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCUS.CENCUS',
       'V',
       '',
       '',
       'N',
       'F',
       'Centro de Custo',
       'Centro de Custo',
       'DCUS.CODTAB = VCSP.CODCUS',
       'CODCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCSP',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VCSP.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCSP',
       '99',
       30,
       12,
       'CUSPAR',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Custo da Parcela',
       'Custo Proporcional a Parcela',
       '',
       'CUSPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCSP',
       '01',
       40,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Parcela',
       'Parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCSP',
       '01',
       25,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCSP',
       '01',
       60,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCSP',
       '01',
       70,
       1,
       'TIPNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Nota',
       'Tipo de Nota',
       '',
       'TIPNOT',
       'F' FROM DUAL
);

/*-- SEQ 9663 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VCSP',
       'TIPNOT',
       0,
       'A',
       'Ambas (N.F.F.)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCSP',
       'TIPNOT',
       0,
       'F',
       'Fatura',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCSP',
       'TIPNOT',
       0,
       'N',
       'Nota Fiscal',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9664 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCT ',
       TO_NUMBER(null),
       'VCT ',
       'Cheq.Rec X TAQ',
       'TV_CHR_TAQ',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VCT.CODFIL,VCT.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9665 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCT ','--','' FROM DUAL
UNION ALL
SELECT 'VCT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCT ','99','Outros' FROM DUAL
);

/*-- SEQ 9666 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCT ',
       '01',
       10,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Banco',
       'Cdigo do Banco',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'VCT ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VCT.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCT ',
       '01',
       30,
       10,
       'CTACRR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm. Conta Corrente',
       'Nmero da Conta Corrente',
       '',
       'CTACRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCT ',
       '01',
       40,
       4000,
       'LINHA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCT ',
       '01',
       50,
       5,
       'NUMAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Numero Agencia',
       'Numero da Agncia',
       '',
       'NUMAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCT ',
       '01',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCT ',
       '01',
       70,
       1,
       'TIPDEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Dep.',
       'Tipo Dep.',
       '',
       'TIPDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'VCT ',
       '01',
       80,
       1,
       'TIPREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Registro',
       'Tipo Registro: Verbal,Telefone,Fax,E-mail,Carta,Site e Mensagem ',
       '',
       'TIPREG',
       'T' FROM DUAL
UNION ALL
SELECT 'VCT ',
       '01',
       90,
       12,
       'VLRREG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Registro',
       'Valor Registro',
       '',
       'VLRREG',
       'F' FROM DUAL
);

/*-- SEQ 9667 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VCT ',
       'TIPREG',
       0,
       'C',
       'Carta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCT ',
       'TIPREG',
       0,
       'E',
       'E-mail',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCT ',
       'TIPREG',
       0,
       'F',
       'Fax',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCT ',
       'TIPREG',
       0,
       'M',
       'Mensagem Instantnea',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCT ',
       'TIPREG',
       0,
       'S',
       'Site',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCT ',
       'TIPREG',
       0,
       'T',
       'Telefone',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCT ',
       'TIPREG',
       0,
       'V',
       'Verbal',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9668 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCTB',
       TO_NUMBER(null),
       'VCTB',
       'Contribuies',
       'TV_CONTRIBUICOES',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VCTB.DOC_CODFIL, VCTB.DOC_SEQUEN, 
VCTB.DOC_NUMITE, VCTB.DOC_TIPDOC',
       '' FROM DUAL
);

/*-- SEQ 9669 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCTB','--','' FROM DUAL
UNION ALL
SELECT 'VCTB','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCTB','02','Datas' FROM DUAL
UNION ALL
SELECT 'VCTB','03','Valores' FROM DUAL
UNION ALL
SELECT 'VCTB','99','Outros' FROM DUAL
);

/*-- SEQ 9670 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21196,
       'PRO ',
       'VCTB',
       '1',
       'N',
       '',
       '',
       'PRO.FILMAT = VCTB.FILMAT(+) and
PRO.CODMAT = VCTB.CODMAT(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21195,
       'VIPR',
       'VCTB',
       '1',
       'N',
       '',
       '',
       'VIPR.FILMAT = VCTB.FILMAT(+) and
VIPR.CODMAT = VCTB.CODMAT(+) and
VIPR.CODCOR = VCTB.CODCOR(+) and
VIPR.CODTAM = VCTB.CODTAM(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 9671 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCTB',
       '--',
       250,
       2,
       'CLASS1',
       'S',
       'DCL1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL1.CLASS1',
       'V',
       '',
       '',
       'A',
       'F',
       'Catergoria',
       'Cdigo da classe 1',
       'VCTB.CLASS1=DCL1.CODTAB (+)',
       'CLASS1',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       260,
       2,
       'CLASS2',
       'S',
       'DCL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL2.CLASS2',
       'V',
       '',
       '',
       'A',
       'F',
       'SubCategoria',
       'Cdigo da classe 2',
       'VCTB.CLASS2=DCL2.CODTAB (+)',
       'CLASS2',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       10,
       5,
       'CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       20,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       30,
       5,
       'CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       270,
       30,
       'DESMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'L',
       '',
       '',
       'A',
       'F',
       'Descrio',
       'Descrio do material',
       '',
       'DESMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       40,
       3,
       'DOC_CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do documento',
       'Filial do documento',
       '',
       'DOC_CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       210,
       6,
       'DOC_CODNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo da Natureza',
       'Cdigo da Natureza',
       '',
       'DOC_CODNAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '02',
       50,
       7,
       'DOC_DATDOC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data do documento',
       'Data do documento',
       '',
       'DOC_DATDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '02',
       60,
       7,
       'DOC_DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data da operao',
       'Data da operao',
       '',
       'DOC_DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       70,
       8,
       'DOC_NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do documento',
       'Nmero do documento',
       '',
       'DOC_NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       80,
       10,
       'DOC_SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'DOC_SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       220,
       1,
       'DOC_TIPDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo do documento',
       'Tipo do documento',
       '',
       'DOC_TIPDOC',
       'T' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       90,
       12,
       'DOC_VLRCOF_RET',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '0',
       'F',
       'Vlr de Cofins retido',
       'Vlr de Cofins retido',
       '',
       'DOC_VLRCOF_RET',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       100,
       12,
       'DOC_VLRLIQ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor liquido',
       'Valor liquido',
       '',
       'DOC_VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       110,
       12,
       'DOC_VLRPIS_RET',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vlr de PIS retido',
       'Vlr de PIS retido',
       '',
       'DOC_VLRPIS_RET',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       120,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       130,
       12,
       'ITE_BASCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base de Cofins',
       'Base de Cofins',
       '',
       'ITE_BASCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       140,
       12,
       'ITE_BASPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base de PIS',
       'Base de PIS',
       '',
       'ITE_BASPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       230,
       5,
       'ITE_NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero do item',
       'Nmero do item',
       '',
       'ITE_NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       150,
       6,
       'ITE_PERCOF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '% de Cofins',
       '% de Cofins',
       '',
       'ITE_PERCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       160,
       6,
       'ITE_PERPIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '% de PIS',
       '% de PIS',
       '',
       'ITE_PERPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '03',
       200,
       12,
       'ITE_QTDMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtd movimentada',
       'Qtd movimentada',
       '',
       'ITE_QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       170,
       2,
       'ITE_SITCOF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao Cofins',
       '',
       '',
       'ITE_SITCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       240,
       1,
       'ITE_SITMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Situao do item',
       'Situao do item',
       '',
       'ITE_SITMOV',
       'T' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       180,
       2,
       'ITE_SITPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao PIS',
       'Situao PIS',
       '',
       'ITE_SITPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '03',
       190,
       12,
       'ITE_VLRMOV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor do item',
       'Valor do item',
       '',
       'ITE_VLRMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTB',
       '--',
       280,
       15,
       'REFBAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. Bsica',
       'Referncia Bsica do Produto',
       '',
       'REFBAS',
       'F' FROM DUAL
);

/*-- SEQ 9672 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VCTB',
       'DOC_TIPDOC',
       0,
       'E',
       'Emitidas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCTB',
       'DOC_TIPDOC',
       0,
       'R',
       'Recebidas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCTB',
       'ITE_SITMOV',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCTB',
       'ITE_SITMOV',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9673 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCTL',
       TO_NUMBER(null),
       'VCTL',
       'Cheq.Rec X TLT',
       'TV_CHR_TLT',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VCTL.CODFIL,VCTL.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9674 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCTL','--','' FROM DUAL
UNION ALL
SELECT 'VCTL','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCTL','99','Outros' FROM DUAL
);

/*-- SEQ 9675 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCTL',
       '01',
       10,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Banco',
       'Cdigo do Banco',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTL',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VCTL.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTL',
       '01',
       30,
       10,
       'CTACRR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm. Conta Corrente',
       'Nmero da Conta Corrente',
       '',
       'CTACRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTL',
       '01',
       40,
       4000,
       'LINHA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTL',
       '01',
       50,
       5,
       'NUMAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Numero Agencia',
       'Numero da Agncia',
       '',
       'NUMAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTL',
       '01',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTL',
       '01',
       70,
       1,
       'TIPDEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Dep.',
       'Tipo Dep.',
       '',
       'TIPDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTL',
       '01',
       80,
       1,
       'TIPREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Registro',
       'Tipo Registro: Verbal,Telefone,Fax,E-mail,Carta,Site e Mensagem ',
       '',
       'TIPREG',
       'T' FROM DUAL
UNION ALL
SELECT 'VCTL',
       '01',
       90,
       12,
       'VLRREG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Registro',
       'Valor Registro',
       '',
       'VLRREG',
       'F' FROM DUAL
);

/*-- SEQ 9676 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VCTL',
       'TIPREG',
       0,
       'C',
       'Carta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCTL',
       'TIPREG',
       0,
       'E',
       'E-mail',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCTL',
       'TIPREG',
       0,
       'F',
       'Fax',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCTL',
       'TIPREG',
       0,
       'M',
       'Mensagem Instantnea',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCTL',
       'TIPREG',
       0,
       'S',
       'Site',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCTL',
       'TIPREG',
       0,
       'T',
       'Telefone',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCTL',
       'TIPREG',
       0,
       'V',
       'Verbal',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9677 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCTR',
       TO_NUMBER(null),
       'VCTR',
       'Unidade Negcio',
       'TV_CTR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VCTR.CODFIL,VCTR.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9678 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCTR','--','' FROM DUAL
UNION ALL
SELECT 'VCTR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCTR','02','Datas' FROM DUAL
UNION ALL
SELECT 'VCTR','03','Valores' FROM DUAL
UNION ALL
SELECT 'VCTR','99','Outros' FROM DUAL
);

/*-- SEQ 9679 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 60525,
       'CTA ',
       'VCTR',
       '1 ',
       'N ',
       '',
       '',
       'VCTR.FILCTA = CTA.CODFIL AND
VCTR.SEQCTA = CTA.SEQUEN AND
VCTR.TIPCTA = CTA.TIPCTA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 60526,
       'USU ',
       'VCTR',
       '01',
       '0N',
       '',
       '',
       'usu.filusu = vfin.filusu and
usu.codusu = vfin.codusu',
       '',
       '' FROM DUAL
UNION ALL
SELECT 60527,
       'CLI ',
       'VCTR',
       '01',
       '0N',
       '',
       '',
       'CLI.FILCLI = VCTR.FILCLI AND
CLI.CODCLI = VCTR.CODCLI',
       '',
       '' FROM DUAL
);

/*-- SEQ 9680 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCTR',
       '02',
       230,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Atualizao',
       'Data da Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '01',
       10,
       49,
       'CHVCTR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '--',
       300,
       13,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '--',
       310,
       5,
       'CODCTR',
       'S',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       '',
       'N',
       'F',
       'Unidade de Negcios',
       'Unidade de Negcios',
       'DCTR.CODTAB = VCTR.CODCTR(+)',
       'CODCTR',
       'T' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = VCTR.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'N',
       'F',
       'Usurio',
       'Cdigo Usurio',
       'USU.FILUSU(+) = VCTR.FILUSU AND USU.CODUSU(+) = VCTR.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '01',
       220,
       255,
       'COMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Complemento',
       'Complemento',
       '',
       'COMPLE',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '02',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data Operao',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '01',
       60,
       27,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '01',
       240,
       3,
       'FILCRT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Contrapartida',
       '',
       'FILCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Conta Corrente',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '01',
       90,
       3,
       'FILREC',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial Recebimento',
       'DFIL.CODFIL = VCTR.FILREC',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '99',
       110,
       30,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '99',
       120,
       1,
       'FLGFLX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Status Fluxo',
       'Status Fluxo',
       '',
       'FLGFLX',
       'T' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '99',
       250,
       64,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Cliente',
       'Nome do Cliente',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '99',
       130,
       21,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Origem',
       'Nome Tabela de Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '01',
       140,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Parcela',
       'Numero Parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '99',
       150,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '01',
       260,
       10,
       'SEQCRT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Sequenciador Contrapartida',
       '',
       'SEQCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '01',
       160,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Sequenciador Conta Corrente',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '01',
       170,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '03',
       180,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub-Parcela',
       'Sub Parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '99',
       190,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Tabela de Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '01',
       270,
       1,
       'TIPCRT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Tipo Contrapartida',
       '',
       'TIPCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '99',
       200,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta Corrrente',
       'Tipo Conta Corrente',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '01',
       280,
       3,
       'TIPLAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo de Lanamento',
       'Tipo de Lanamento',
       '',
       'TIPLAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '99',
       290,
       30,
       'ULTNOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sobrenome/Fantasia',
       'Sobrenome/Fantasia',
       '',
       'ULTNOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '03',
       210,
       12,
       'VLRPGT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       '',
       '',
       '',
       'VLRPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTR',
       '--',
       320,
       12,
       'VLRRAT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Operao',
       'Valor Operaco',
       '',
       'VLRRAT',
       'F' FROM DUAL
);

/*-- SEQ 9681 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VCTR',
       'FLGFLX',
       0,
       'A',
       'A Realizar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCTR',
       'FLGFLX',
       0,
       'R',
       'Realizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCTR',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCTR',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCTR',
       'TIPCTA',
       0,
       'N',
       'Destopia',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9682 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCTU',
       TO_NUMBER(null),
       'VCTU',
       'Contas de Uso',
       'TV_CTA_USO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9683 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCTU','--','' FROM DUAL
UNION ALL
SELECT 'VCTU','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCTU','99','Outros' FROM DUAL
);

/*-- SEQ 9684 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCTU',
       '01',
       10,
       21,
       'CONFIG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Configuraes',
       'Configuraes',
       '',
       'CONFIG',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTU',
       '01',
       20,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial
Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTU',
       '01',
       30,
       30,
       'NOME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome',
       'Nome
',
       '',
       'NOME',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTU',
       '01',
       40,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCTU',
       '01',
       50,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo da Conta',
       'Tipo da Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VCTU',
       '01',
       60,
       18,
       'USO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Uso',
       'Uso',
       '',
       'USO',
       'F' FROM DUAL
);

/*-- SEQ 9685 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VCTU',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCTU',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCTU',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9686 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCUS',
       TO_NUMBER(null),
       'VCUS',
       'Lantos em Cent.Cust',
       'TV_CUS',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VCUS.CODFIL,VCUS.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9687 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCUS','--','' FROM DUAL
UNION ALL
SELECT 'VCUS','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCUS','99','Outros' FROM DUAL
);

/*-- SEQ 9688 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 35122,
       'CTA ',
       'VCUS',
       '1 ',
       'N ',
       '',
       '',
       'VCUS.FILCTA = CTA.CODFIL AND
VCUS.TIPCTA = CTA.TIPCTA AND
VCUS.SEQCTA = CTA.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9689 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCUS',
       '01',
       10,
       5,
       'CODCUS',
       'A',
       'DCUS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCUS.CENCUS',
       'V',
       '',
       'F',
       'A',
       'F',
       'Centro de Custos',
       'Cdigo Unidade de Negcios',
       'DCUS.CODTAB = VCUS.CODCUS',
       'CODCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCUS',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = VCUS.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCUS',
       '01',
       30,
       6,
       'CODFOR',
       'A',
       'COM ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Fornecedor',
       'Cdigo do fornecedor',
       'COM.FILFOR = PED.CODFOR',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCUS',
       '--',
       130,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VCUS',
       '01',
       40,
       8,
       'DATCMP',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data da Compra',
       'Data da compra',
       '',
       'DATCMP',
       'F' FROM DUAL
UNION ALL
SELECT 'VCUS',
       '01',
       50,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCUS',
       '01',
       60,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCUS',
       '--',
       140,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VCUS',
       '01',
       70,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VCUS',
       '01',
       80,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VCUS',
       '01',
       90,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCUS',
       '01',
       100,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCUS',
       '01',
       110,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VCUS',
       '01',
       150,
       1,
       'TIPLAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo',
       '',
       '',
       'TIPLAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VCUS',
       '01',
       120,
       12,
       'VLRRAT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Rateio',
       'Valor Rateio',
       '',
       'VLRRAT',
       'F' FROM DUAL
);

/*-- SEQ 9690 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VCUS',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCUS',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCUS',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCUS',
       'TIPLAN',
       0,
       'C',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCUS',
       'TIPLAN',
       0,
       'V',
       'Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9691 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCVU',
       TO_NUMBER(null),
       'VCVU',
       'Compras, Vendas Unif',
       'TV_COM_VEN_UNI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9692 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCVU','--','' FROM DUAL
UNION ALL
SELECT 'VCVU','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCVU','02','Classificao' FROM DUAL
UNION ALL
SELECT 'VCVU','03','Valores Vendas' FROM DUAL
UNION ALL
SELECT 'VCVU','04','Valores Compras' FROM DUAL
UNION ALL
SELECT 'VCVU','05','Custos' FROM DUAL
UNION ALL
SELECT 'VCVU','99','Outros' FROM DUAL
);

/*-- SEQ 9693 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22222,
       'GRA ',
       'VCVU',
       '1',
       '0N',
       '',
       '',
       'gra.filmat = vcvu.filmat and gra.codmat = vcvu.codmat and gra.codcor = vcvu.codcor and gra.codtam = vcvu.codtam',
       '',
       '' FROM DUAL
);

/*-- SEQ 9694 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCVU',
       '02',
       10,
       5,
       'CLASS1',
       'S',
       'DCL1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL1.CLASS1',
       'V',
       '',
       '',
       'A',
       'F',
       'Classe 1',
       'Classe 1',
       'PRO.CLASS1=DCL1.CODTAB (+)',
       'CLASS1',
       'T' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '02',
       20,
       5,
       'CLASS2',
       'S',
       'DCL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL2.CLASS2',
       'V',
       '',
       '',
       'A',
       'F',
       'Classe 2',
       'Classe 2',
       'PRO.CLASS2=DCL2.CODTAB (+)',
       'CLASS2',
       'T' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '02',
       30,
       5,
       'CLASS3',
       'S',
       'DCL3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL3.CLASS3',
       'V',
       '',
       '',
       'A',
       'F',
       'Classe 3',
       'Classe 3',
       'PRO.CLASS3=DCL3.CODTAB (+)',
       'CLASS3',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '02',
       40,
       5,
       'CLASS4',
       'S',
       'DCL4',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL4.CLASS4',
       'V',
       '',
       '',
       'A',
       'F',
       'Classe 4',
       'Classe 4',
       'PRO.CLASS4=DCL4.CODTAB (+)',
       'CLASS4',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '01',
       50,
       5,
       'CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Diviso',
       'Diviso',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '01',
       60,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Filial',
       'Cdigo Filial',
       'VCVU.CODFIL = DFIL.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '01',
       70,
       3,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Cdigo Material',
       'Cdigo Material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '01',
       80,
       5,
       'CODMUL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cd.Mltiplo Estoque',
       'Cdigo Mltiplo Estoque',
       '',
       'CODMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '01',
       90,
       5,
       'CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Sub-Diviso',
       'Sub-Diviso',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '05',
       100,
       14,
       'COMPRASOBCMV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       '% Compras~sobre CMV',
       'Percentual de Compra Sobre CMV',
       '',
       'COMPRASOBCMV',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '01',
       120,
       8,
       'DATAFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Final',
       'Data Final',
       '',
       'DATAFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '01',
       110,
       8,
       'DATAINI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Inicial',
       'Data Inicial',
       '',
       'DATAINI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '02',
       130,
       40,
       'DESDEP',
       'A',
       'DDEP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDEP.DESDEP',
       'V',
       '',
       '',
       'A',
       'F',
       'Departamento',
       'Departamento',
       'PRO.DEPART=DDEP.CODTAB (+)',
       'DESDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '01',
       140,
       3,
       'FILMAT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial Matrial',
       'Filial Matrial',
       'VCVU.FILMAT = DFIL.CODFIL(+)',
       'FILMAT',
       'T' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '05',
       150,
       14,
       'GIROFINANC',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Giro Fin.~Estoques',
       'Giro Financeiro',
       '',
       'GIROFINANC',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '01',
       160,
       5,
       'INTERVALO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Intervalo',
       'Intervalo',
       '',
       'INTERVALO',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '05',
       170,
       14,
       'MARGEMCONTRIB',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       '% Marg~Contribuio',
       'Percentual de Margem de Contribuicao',
       '',
       'MARGEMCONTRIB',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '05',
       180,
       14,
       'PRAZOMEDIO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Prazo~Estocagem',
       'Prazo Estocagem',
       '',
       'PRAZOMEDIO',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '05',
       190,
       14,
       'QTDCUSTOFIM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Qtd.~Estoque Fim',
       'Quantidade Estoque Fim',
       '',
       'QTDCUSTOFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '05',
       200,
       14,
       'QTDCUSTOMED',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Qtd.~Estoque Md',
       'Quantidade Estoque Mdio',
       '',
       'QTDCUSTOMED',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '03',
       210,
       14,
       'QTDVENDA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Qtd.~Vendas',
       'Quantidade Vendida',
       '',
       'QTDVENDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '01',
       220,
       15,
       'REFBAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Referencia Bsica',
       'Referencia Bsica',
       '',
       'REFBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '01',
       221,
       20,
       'REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Referencia',
       'Referencia',
       '',
       'REFPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '05',
       230,
       14,
       'RETORNOCUSTOMEDIO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Retorno~Estoque Md.',
       'Retorno Custo Mdio',
       '',
       'RETORNOCUSTOMEDIO',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '03',
       322,
       14,
       'Salcminicial',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Saldo Inicial',
       'Saldo Inicial',
       '',
       'Salcminicial',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '05',
       240,
       14,
       'VLRCMV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Vlr~CMV',
       'Valor CMV',
       '',
       'VLRCMV',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '04',
       250,
       14,
       'VLRCOMPRA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Vlr~Compras',
       'Valor Comprado no Perodo',
       '',
       'VLRCOMPRA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '05',
       260,
       14,
       'VLRCONTRIBUCAO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Vlr~Contribuio',
       'Valor Contribuio',
       '',
       'VLRCONTRIBUCAO',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '03',
       270,
       14,
       'VLRCSTVDA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Vlr~Impostos',
       'Valor Impostos sobre Vendas',
       '',
       'VLRCSTVDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '05',
       280,
       14,
       'VLRCUSTOMEDIO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Est.~Md. Per',
       'Valor Custo Mdio',
       '',
       'VLRCUSTOMEDIO',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '05',
       290,
       14,
       'VLRCUSTOTOTFIM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Vlr Estoq~Fim',
       'Valor Custo Mdio Fim',
       '',
       'VLRCUSTOTOTFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '05',
       300,
       14,
       'VLRCUSTOUNI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Vlr Estoq~Md Un',
       'Valor Custo Mdio Unitrio',
       '',
       'VLRCUSTOUNI',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '05',
       310,
       14,
       'VLRCUSTOUNIFIM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Vlr Estoq~Un Fim',
       'Valor Custo Mdio Unitrio Fim',
       '',
       'VLRCUSTOUNIFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '03',
       320,
       14,
       'VLRVENDA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '0',
       'F',
       'Vlr~Vendas',
       'Valor Vendido no Perodo',
       '',
       'VLRVENDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VCVU',
       '03',
       321,
       14,
       'Vlrcminicial',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '0',
       'F',
       'Vlr Custo Inicial',
       'Valor Custo Inicial',
       '',
       'Vlrcminicial',
       'F' FROM DUAL
);

/*-- SEQ 9695 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCXD',
       TO_NUMBER(null),
       'VCXD',
       'Clientes x Dvida',
       'TV_CLI_DIV',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9696 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCXD','--','' FROM DUAL
UNION ALL
SELECT 'VCXD','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCXD','99','Outros' FROM DUAL
);

/*-- SEQ 9697 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 52655,
       'CLI ',
       'VCXD',
       '1 ',
       'N ',
       '',
       '',
       'CLI.CODCLI = VCXD.CODCLI AND CLI.FILCLI = VCXD.FILCLI',
       '',
       '' FROM DUAL
);

/*-- SEQ 9698 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'VCXD',
       '01',
       10,
       12,
       'CHEDEV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cheques Devolvidos',
       'Cheques Devolvidos',
       '',
       'CHEDEV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VCXD',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VCXD',
       '01',
       110,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VCXD.CODFIL',
       'CODFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VCXD',
       '01',
       30,
       49,
       'DESDIV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Dvida',
       'Descrio Dvida',
       '',
       'DESDIV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VCXD',
       '99',
       160,
       5,
       'DIAVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Dias Vencido',
       'Nmero de Dias Vencido',
       '',
       'TRUNC(VENCIMENTO) - TRUNC(AGORA())',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VCXD',
       '01',
       40,
       12,
       'DIVIDA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Dvida',
       'Dvida',
       '',
       'DIVIDA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VCXD',
       '01',
       150,
       12,
       'DIVIDACOR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Divida Corrigida',
       'Divida corrigida com juros',
       '',
       'DIVIDACOR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VCXD',
       '01',
       120,
       27,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VCXD',
       '01',
       50,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial do cliente',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VCXD',
       '01',
       60,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VCXD',
       '01',
       70,
       12,
       'LIMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Limite',
       'Limite',
       '',
       'LIMITE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VCXD',
       '01',
       80,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Documento',
       'Nmero Documento',
       '',
       'NUMDOC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VCXD',
       '01',
       90,
       12,
       'OCORRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero Ocorrncias',
       'Nmero Ocorrncias',
       '',
       'OCORRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VCXD',
       '01',
       140,
       30,
       'PORTAD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Portador',
       'Portador',
       '',
       'PORTAD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VCXD',
       '01',
       100,
       12,
       'TIPDIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Tipo da Dvida',
       'Tipo da Dvida',
       '',
       'TIPDIV',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VCXD',
       '01',
       155,
       12,
       'TOTDIV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr Dvida Total',
       'Soma da Dvida + Cheque Devolvido',
       '',
       '(CHEDEV + DIVIDA)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VCXD',
       '01',
       130,
       8,
       'VENCIMENTO',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Vencimento',
       'Vencimento',
       '',
       'VENCIMENTO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VCXD',
       '99',
       170.00,
       8.00,
       'EMISSAO',
       '@',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Emisso',
       'Data da Emisso da Venda',
       '',
       'EMISSAO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VCXD',
       '99',
       180.00,
       35.00,
       'PLANO',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Plano~Pagamento',
       'Plano de Pagamento',
       '',
       'PLANO',
       '',
       'D' FROM DUAL         
);

/*-- SEQ 9699 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VCXD',
       'FLGTIP',
       0,
       ' ',
       'Fisica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCXD',
       'FLGTIP',
       1,
       ' ',
       'Juridica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCXD',
       'FLGTIP',
       2,
       ' ',
       'Entidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCXD',
       'FLGTIP',
       3,
       ' ',
       'Especial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCXD',
       'FLGTIP',
       4,
       ' ',
       'M.E.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCXD',
       'FLGTIP',
       5,
       ' ',
       'Filial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCXD',
       'TIPDIV',
       5,
       ' ',
       'Cheque Devolvido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCXD',
       'TIPDIV',
       1,
       ' ',
       'Parcelas em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCXD',
       'TIPDIV',
       2,
       ' ',
       'Cheque A Depositar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCXD',
       'TIPDIV',
       3,
       ' ',
       'C/C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VCXD',
       'TIPDIV',
       4,
       ' ',
       'Cheque de Terceiro A Depositar',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9700 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VCXG',
       TO_NUMBER(null),
       'VCXG',
       'Sugerir ao Vender',
       'TV_CXG',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VCXG.FILMAT,VCXG.CODMAT,VCXG.CODCOR,VCXG.CODTAM',
       '' FROM DUAL
);

/*-- SEQ 9701 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VCXG','--','' FROM DUAL
UNION ALL
SELECT 'VCXG','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VCXG','99','Outros' FROM DUAL
);

/*-- SEQ 9702 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VCXG',
       '01',
       10,
       5,
       'CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cd.Diviso Produto',
       'Divisao Produto',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VCXG',
       '01',
       20,
       5,
       'CODCXG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cd.Produto Sugerir',
       'Cdigo do Produto para Sugerir',
       '',
       'CODCXG',
       'F' FROM DUAL
UNION ALL
SELECT 'VCXG',
       '01',
       30,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Codigo produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCXG',
       '01',
       40,
       5,
       'CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cd.Subdiviso Prod.',
       'Sub-Divisao Produto',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'VCXG',
       '01',
       50,
       5,
       'CORCXG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cd.Diviso Sugerir',
       'Diviso Produto para sugerir',
       '',
       'CORCXG',
       'F' FROM DUAL
UNION ALL
SELECT 'VCXG',
       '01',
       60,
       3,
       'FILCXG',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Fil.Produto Sugerir',
       'Filial Produto para sugerir',
       '',
       'FILCXG',
       'F' FROM DUAL
UNION ALL
SELECT 'VCXG',
       '01',
       70,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VCXG',
       '01',
       80,
       5,
       'TAMCXG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tam. Prod. Sugesto',
       'Sub-Diviso do produto para sugerir',
       '',
       'TAMCXG',
       'F' FROM DUAL
);

/*-- SEQ 9703 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VDC ',
       TO_NUMBER(null),
       'VDC ',
       'Dbito ContaCorrente',
       'TV_DEB_CCC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VDC.FILCLI,VDC.CODCLI',
       '' FROM DUAL
);

/*-- SEQ 9704 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VDC ','--','' FROM DUAL
UNION ALL
SELECT 'VDC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VDC ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VDC ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VDC ','99','Outros' FROM DUAL
);

/*-- SEQ 9705 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VDC ',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VDC ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VDC.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VDC ',
       '01',
       30,
       100,
       'COMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Complemento',
       'Complemento',
       '',
       'COMPLE',
       'F' FROM DUAL
UNION ALL
SELECT 'VDC ',
       '01',
       40,
       13,
       'CUPFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cupom Fiscal',
       'Cupom Fiscal',
       '',
       'CUPFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VDC ',
       '02',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Operao',
       'Data da Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VDC ',
       '01',
       60,
       30,
       'DESTIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Destino',
       'Destino',
       '',
       'DESTIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VDC ',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VDC ',
       '01',
       80,
       3,
       'FILFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Fatura',
       '',
       'FILFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VDC ',
       '01',
       90,
       15,
       'NOMFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome da Filial',
       'Nome da Filial ',
       '',
       'NOMFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VDC ',
       '01',
       100,
       64,
       'NOMMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Motivo',
       'Nome do Motivo',
       '',
       'NOMMOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VDC ',
       '01',
       110,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VDC ',
       '01',
       120,
       6,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero da Nota',
       'Nmero da Nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VDC ',
       '01',
       130,
       30,
       'ORIGEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Origem',
       'Origem',
       '',
       'ORIGEM',
       'F' FROM DUAL
UNION ALL
SELECT 'VDC ',
       '01',
       140,
       7,
       'PLACAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Placa do Veculo',
       'Placa do Veculo',
       '',
       'PLACAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VDC ',
       '02',
       150,
       7,
       'PRXFAT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Prxima Fatura',
       'Data Prxima Fatura',
       '',
       'PRXFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VDC ',
       '01',
       160,
       12,
       'QTDLIT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade de Lit.',
       'Quantidade de Lit.',
       '',
       'QTDLIT',
       'F' FROM DUAL
UNION ALL
SELECT 'VDC ',
       '01',
       170,
       12,
       'QTD_KM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade de KM',
       'Quantidade de KM',
       '',
       'QTD_KM',
       'F' FROM DUAL
UNION ALL
SELECT 'VDC ',
       '01',
       180,
       10,
       'SEQFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Fatura',
       '',
       'SEQFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VDC ',
       '01',
       190,
       6,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'STATUS',
       'T' FROM DUAL
UNION ALL
SELECT 'VDC ',
       '01',
       200,
       5,
       'TIPCCC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tipo Conta Corrente',
       'Tipo Conta Corrente',
       '',
       'TIPCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'VDC ',
       '01',
       210,
       30,
       'TIPDEB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo de Dbito',
       'Tipo de Dbito',
       '',
       'TIPDEB',
       'F' FROM DUAL
UNION ALL
SELECT 'VDC ',
       '03',
       220,
       12,
       'VLRLAN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Lanamento',
       'Valor Lanamento',
       '',
       'VLRLAN',
       'F' FROM DUAL
);

/*-- SEQ 9706 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VDC ',
       'STATUS',
       0,
       ' ',
       'Aberto',
       TO_NUMBER(null),
       'Aberto' FROM DUAL
UNION ALL
SELECT 'VDC ',
       'STATUS',
       0,
       ' ',
       'Cancelado',
       TO_NUMBER(null),
       'Cancel' FROM DUAL
UNION ALL
SELECT 'VDC ',
       'STATUS',
       0,
       ' ',
       'Pago',
       TO_NUMBER(null),
       'Pago' FROM DUAL
);

/*-- SEQ 9707 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VDD ',
       0,
       'VDD ',
       'Vendedores',
       'TT_USU',
       'T',
       '',
       'TOTALL',
       'Vendedores',
       '',
       '',
       '',
       '',
       'F',
       '',
       'VDD.FILUSU,VDD.CODUSU
VDD.APEUSU
VDD.NOMUSU
VDD.CODEXT',
       '' FROM DUAL
);

/*-- SEQ 9708 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VDD ','--','' FROM DUAL
UNION ALL
SELECT 'VDD ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VDD ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VDD ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VDD ','99','Outros' FROM DUAL
);

/*-- SEQ 9709 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 30268,
       'CLI ',
       'VDD ',
       'N',
       '1',
       '',
       '',
       'CLI.FILCLI = VDD.FILCLI AND
CLI.CODCLI = VDD.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30269,
       'USU ',
       'VDD ',
       'N',
       '1',
       '',
       '',
       'USU.FILUSU = VDD.FILSUP AND
USU.CODUSU = VDD.CODSUP',
       '',
       '' FROM DUAL
);

/*-- SEQ 9710 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VDD ',
       '01',
       100,
       1,
       'AGENDB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Acesso ao Agendador?',
       'Acesso ao Agendador?',
       '',
       'AGENDB',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '01',
       60,
       10,
       'APEUSU',
       'A',
       '',
       0,
       0,
       'VDD ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'VDD',
       'F',
       'A',
       'T',
       'Apelido',
       'Apelido do vendedor',
       '',
       'APEUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '99',
       391,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN VDD.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '02',
       110,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em:',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '01',
       25,
       6,
       'CHAVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Filial/Cdigo',
       'Filial e Cdigo do Vendedor',
       '',
       'FILUSU||VDD.CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '01',
       120,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '01',
       130,
       5,
       'CODCTR',
       'S',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       '',
       'N',
       'F',
       'Unidade de Negcios',
       'Unidade de Negcios',
       'DCTR.CODTAB = VDD.CODCTR',
       'CODCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '01',
       30,
       10,
       'CODEXT',
       'A',
       '',
       0,
       0,
       'VDD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'VDD',
       'F',
       'A',
       'T',
       'Cdigo Externo',
       'Cdigo externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '01',
       23,
       3,
       'CODIGO_VENDEDOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo do Vendedor',
       'Cdigo do Vendedor',
       '',
       'CODUSU',
       '' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '99',
       490,
       40,
       'CODPOS_USU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo POS CONTROLE',
       'Cdigo POS CONTROLE',
       '',
       'CODPOS_USU',
       '' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '01',
       140,
       5,
       'CODSET',
       'N',
       'DSET',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSET.DESSET',
       'V',
       '',
       'F',
       'N',
       'F',
       'Setor',
       'Setor',
       'DSET.CODTAB(+) = VDD.CODSET',
       'CODSET',
       'T' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '01',
       90,
       3,
       'CODSUP',
       'A',
       'USU ',
       0,
       54,
       'VDD ',
       100,
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       'VDD',
       'F',
       'A',
       'F',
       'Vendedor Superior',
       'Cdigo Superior do vendedor',
       'VDD.FILUSU = USU.FILUSU(+)  AND VDD.CODUSU = USU.CODUSU(+)',
       'CODSUP',
       'T' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '01',
       20,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       0,
       'VDD ',
       20,
       30,
       '',
       'USU2.NOMUSU',
       'V',
       'VDD',
       'F',
       'N',
       'T',
       'Vendedor',
       'Nome do Vendedor',
       'VDD.FILUSU = USU2.FILUSU(+)  AND VDD.CODUSU = USU2.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '01',
       150,
       1,
       'EDINDB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Editar Formatos?',
       'Editar Formatos?',
       '',
       'EDINDB',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '01',
       160,
       40,
       'E_MAIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail',
       'E-mail',
       '',
       'E_MAIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '01',
       170,
       1,
       'FAZENQ',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Faz Enquete?',
       'Faz Enquete',
       '',
       'FAZENQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '01',
       40,
       3,
       'FILATV',
       'A',
       '',
       0,
       0,
       'VDD ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VDD',
       'F',
       'N',
       'T',
       'Alocado em',
       'Filial onde est alocado',
       '',
       'FILATV',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '01',
       180,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '01',
       80,
       3,
       'FILSUP',
       'A',
       '',
       0,
       0,
       'VDD ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'U',
       'VDD',
       'F',
       'N',
       'F',
       '',
       'Filial do superior do vendedor',
       '',
       'FILSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '01',
       10,
       3,
       'FILUSU',
       'A',
       '',
       0,
       0,
       'VDD ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VDD',
       'F',
       'N',
       'T',
       '',
       'Filial do Vendedor',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '01',
       190,
       30,
       'FUNCAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Funo',
       'Funo',
       '',
       'FUNCAO',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '01',
       200,
       4000,
       'GRUPOS',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Grupos',
       'Grupos',
       '',
       'GRUPOS',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '01',
       210,
       4,
       'HORDOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horas Domingo',
       'Horas Domingo',
       '',
       'HORDOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '99',
       220,
       4,
       'HORQUA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horas Quarta',
       'Horas Quarta',
       '',
       'HORQUA',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '99',
       230,
       4,
       'HORQUI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horas Quinta',
       'Horas Quinta',
       '',
       'HORQUI',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '99',
       240,
       4,
       'HORSAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horas Sbado',
       'Horas Sbado',
       '',
       'HORSAB',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '99',
       250,
       4,
       'HORSEG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horas Segunda',
       'Horas Segunda',
       '',
       'HORSEG',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '99',
       260,
       4,
       'HORSEX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horas Sexta',
       'Horas Sexta',
       '',
       'HORSEX',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '99',
       270,
       4,
       'HORTER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horas Tera',
       'Horas Tera',
       '',
       'HORTER',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '03',
       280,
       6,
       'INDPRO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'ndice Produtividade',
       'ndice Produtividade',
       '',
       'INDPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '03',
       290,
       14,
       'LIMCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Limite de Compras',
       'Limite de Compras',
       '',
       'LIMCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '02',
       300,
       2,
       'MAIDAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Maior Dia/Data',
       'Maior data possvel de uso em relao ao dia de hoje',
       '',
       'MAIDAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '03',
       310,
       5,
       'MAXDAT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Mx.dias aps venc.',
       'Mx. dias p/ aceitar baixa parcelas/lanamentos avulsos aps vencimento',
       '',
       'MAXDAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '02',
       320,
       2,
       'MENDAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Menor Dia/Data',
       'Menor data possvel de uso em relao ao dia de hoje',
       '',
       'MENDAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '03',
       330,
       5,
       'MINDAT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Min.dias antes venc.',
       'Min. dias p/ aceitar baixa parcelas/lanamentos avulsos aps vencimento',
       '',
       'MINDAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '01',
       340,
       2,
       'NIVUSU',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Nvel',
       'Nvel do Usurio',
       '',
       'NIVUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '01',
       50,
       30,
       'NOMUSU',
       'A',
       '',
       0,
       0,
       'VDD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'VDD',
       'F',
       'A',
       'T',
       'Nome Vendedor',
       'Nome do vendedor',
       '',
       'NOMUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '99',
       350,
       255,
       'PATNDB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path Consultas',
       'Path Consultas TotaliBI',
       '',
       'PATNDB',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '03',
       70,
       8,
       'PERCOM',
       'F',
       '',
       2,
       0,
       'VDD ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VDD',
       'T',
       '9',
       'T',
       '% Comisso',
       'Percentagem de comisso do vendedor',
       '',
       'PERCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '99',
       360,
       1000,
       'PERMIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Permisso',
       'Permisso',
       '',
       'PERMISSOESUSUARIO(FILUSU,CODUSU)',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '99',
       480,
       6,
       'PRZPAG_MAX',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Prazo mdio mx. pag',
       'Prazo mdio mximo a pagar',
       '',
       'PRZPAG_MAX',
       '' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '99',
       470,
       6,
       'PRZPAG_MIN',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Prazo mdio mn. pag',
       'Prazo mdio mnimo a pagar',
       '',
       'PRZPAG_MIN',
       '' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '99',
       370,
       20,
       'SENHA1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Senha 1',
       'Senha 1',
       '',
       'SENHA1',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '99',
       380,
       20,
       'SENHA2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Senha 2',
       'Senha 2',
       '',
       'SENHA2',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '99',
       390,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN VDD.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '99',
       460,
       8,
       'SUPMAX',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Desc Max Superv',
       '% Desconto Mximo Permitido para Supervisor',
       '',
       'SUPMAX',
       '' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '99',
       400,
       15,
       'TABATU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Tabela Atual',
       'Tabela Atual',
       '',
       'TABATU',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '99',
       410,
       1,
       'USANDB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'UsarTotaliBI Browser',
       'Usar Totali BI Browser?',
       '',
       'USANDB',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '99',
       420,
       1,
       'USANDC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'UsarTotaliBI Config?',
       'Usar Totali BI Config?',
       '',
       'USANDC',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '99',
       430,
       100,
       'VISPER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Viso da Permisso',
       'Viso da Permisso',
       '',
       'VISPER',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '99',
       440,
       9,
       'VISSE1',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Senha1(Lite)',
       'Senha1(Lite)',
       '',
       'VISSE1',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD ',
       '99',
       450,
       9,
       'VISSE2',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Senha2(Lite)',
       'Senha2(Lite)',
       '',
       'VISSE2',
       'F' FROM DUAL
);

/*-- SEQ 9711 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VDD ',
       'NIVUSU',
       0,
       '-',
       'Administrador',
       163,
       ' ' FROM DUAL
UNION ALL
SELECT 'VDD ',
       'NIVUSU',
       1,
       '-',
       'Operador',
       164,
       ' ' FROM DUAL
UNION ALL
SELECT 'VDD ',
       'NIVUSU',
       2,
       '-',
       'Vendedor',
       165,
       ' ' FROM DUAL
UNION ALL
SELECT 'VDD ',
       'NIVUSU',
       3,
       '-',
       'Guia',
       166,
       ' ' FROM DUAL
);

/*-- SEQ 9712 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VDD2',
       TO_NUMBER(null),
       'VDD2',
       'Vendedores',
       'TT_VDD',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VDD.CODFIL,VDD.SEQUEN
',
       '' FROM DUAL
);

/*-- SEQ 9713 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VDD2','--','' FROM DUAL
UNION ALL
SELECT 'VDD2','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VDD2','99','Outros' FROM DUAL
);

/*-- SEQ 9714 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 13656,
       'ORC ',
       'VDD2',
       '0N',
       '0N',
       '',
       '',
       'VDD2.FILPED = ORC.CODFIL AND
VDD2.TIPPED = ORC.TIPPED AND
VDD2.NUMPED = ORC.NUMPED',
       '',
       '' FROM DUAL
UNION ALL
SELECT 13657,
       'VEN ',
       'VDD2',
       '0N',
       '0N',
       '',
       '',
       'VDD2.FILVEN = VEN.CODFIL AND
VDD2.SEQVEN = VEN.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 13658,
       'USU ',
       'VDD2',
       '0N',
       '0N',
       '',
       '',
       'VDD2.FILVDD = USU.FILUSU AND
VDD2.CODVDD = USU.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 9715 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VDD2',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Alterao',
       'Data Alterao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD2',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD2',
       '--',
       30,
       3,
       'CODVDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Vendedor',
       'Cdigo Vendedor',
       '',
       'CODVDD',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD2',
       '--',
       40,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD2',
       '--',
       50,
       3,
       'FILPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Oramento',
       'Filial Oramento',
       '',
       'FILPED',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD2',
       '--',
       60,
       3,
       'FILVDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Vendedor',
       'Filial Vendedor',
       '',
       'FILVDD',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD2',
       '--',
       70,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Venda',
       'Filial Venda',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD2',
       '--',
       80,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Oramento',
       'Nmero Oramento',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD2',
       '--',
       90,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD2',
       '--',
       100,
       10,
       'SEQVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Sequenciador Venda',
       'Sequenciador Venda',
       '',
       'SEQVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VDD2',
       '--',
       110,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Oramento',
       'Tipo Oramento',
       '',
       'TIPPED',
       'T' FROM DUAL
UNION ALL
SELECT 'VDD2',
       '--',
       120,
       14,
       'VLRBAS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base Comisso',
       'Valor Base da Comisso',
       '',
       'VLRBAS',
       '' FROM DUAL
);

/*-- SEQ 9716 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VDD2',
       'TIPPED',
       0,
       'O',
       'DAV',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VDD2',
       'TIPPED',
       0,
       'P',
       'Pr-Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VDD2',
       'TIPPED',
       0,
       'S',
       'DAV-OS',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9717 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VDES',
       TO_NUMBER(null),
       'VDES',
       'Descontos',
       'TV_CLI_DES',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9718 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VDES','--','' FROM DUAL
UNION ALL
SELECT 'VDES','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VDES','99','Outros' FROM DUAL
);

/*-- SEQ 9719 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 171579,
       'REC',
       'VDES',
       '1',
       '1',
       '',
       '',
       'VDES.FILIAL = REC.CODFIL AND
VDES.SEQUEN = REC.SEQUEN AND
VDES.NUMPAR = REC.NUMPAR AND
VDES.SUBPAR = REC.SUBPAR',
       '',
       '' FROM DUAL
);

/*-- SEQ 9720 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VDES',
       '--',
       160,
       5,
       'CODCTR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       'Cdigo Unidade de Negcios',
       '',
       'CODCTR',
       '' FROM DUAL
UNION ALL
SELECT 'VDES',
       '--',
       10,
       6,
       'CODIGO_CLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Cdigo cliente',
       'Cdigo cliente',
       '',
       'CODIGO_CLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VDES',
       '--',
       20,
       15,
       'CPF_CNPJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento (CPF/CNPJ)',
       'Nmero do Documento: CNPJ ou CPF',
       '',
       'CPF_CNPJ',
       'F' FROM DUAL
UNION ALL
SELECT 'VDES',
       '--',
       170,
       30,
       'DESCTR',
       'A',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       '',
       'A',
       '',
       'Unidade de Negcios',
       'Unidade de Negcios',
       'DCTR.CODTAB = VDES.CODCTR',
       'DESCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'VDES',
       '--',
       30,
       13,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento (Srie + Ecf + Nmero da Nota )',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VDES',
       '--',
       40,
       3,
       'FILIAL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VDES.FILIAL',
       'FILIAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VDES',
       '--',
       50,
       3,
       'FILIAL_CLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Cliente',
       'Filial Cliente',
       '',
       'FILIAL_CLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VDES',
       '--',
       60,
       95,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome/Razo Social',
       'Nome do Cliente',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VDES',
       '--',
       70,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero Parcela',
       'Nmero da Parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VDES',
       '--',
       80,
       7,
       'PAGAMENTO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'PAGAMENTO',
       'F' FROM DUAL
UNION ALL
SELECT 'VDES',
       '--',
       90,
       5,
       'PARCELA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Parcela',
       'Parcela (Nmero da Parcela + Sub-parcela)',
       '',
       'PARCELA',
       'F' FROM DUAL
UNION ALL
SELECT 'VDES',
       '--',
       100,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VDES',
       '--',
       110,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Nmero da sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VDES',
       '--',
       120,
       7,
       'VENCIMENTO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Vencimento',
       'Data de vencimento',
       '',
       'VENCIMENTO',
       'F' FROM DUAL
UNION ALL
SELECT 'VDES',
       '--',
       130,
       14,
       'VLR_DESCONTO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Valor Desconto',
       'Valor Desconto',
       '',
       'VLR_DESCONTO',
       'F' FROM DUAL
UNION ALL
SELECT 'VDES',
       '--',
       140,
       12,
       'VLR_PARCELA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Vlr. Parcela',
       'Valor da parcela',
       '',
       'VLR_PARCELA',
       'F' FROM DUAL
UNION ALL
SELECT 'VDES',
       '--',
       150,
       12,
       'VLR_RECEBIDO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Valor recebido',
       'Valor recebido (Valor da Parcela + Valor do Juros)',
       '',
       'VLR_RECEBIDO',
       'F' FROM DUAL
);

/*-- SEQ 9721 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VDEV',
       TO_NUMBER(null),
       'VDEV',
       'Devoluo ST.',
       'TV_DEV_ST',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VDEV.CODFIL, VDEV.SEQUEN, VDEV.NUMITE',
       '' FROM DUAL
);

/*-- SEQ 9722 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VDEV','--','' FROM DUAL
UNION ALL
SELECT 'VDEV','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VDEV','02','Valores' FROM DUAL
UNION ALL
SELECT 'VDEV','03','Datas' FROM DUAL
UNION ALL
SELECT 'VDEV','99','Outros' FROM DUAL
);

/*-- SEQ 9723 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23998,
       'IVE ',
       'VDEV',
       'N',
       '1',
       '',
       '',
       'IVE.SEQUEN = VDEV.SEQUEN AND
IVE.CODFIL = VDEV.CODFIL',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23999,
       'CLI ',
       'VDEV',
       '1',
       'N',
       '',
       '',
       'CLI.FILCLI = VDEV.FILCLI AND
CLI.CODCLI = VDEV.CODCLI',
       '',
       '' FROM DUAL
);

/*-- SEQ 9724 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VDEV',
       '--',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VDEV',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = VDEV.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VDEV',
       '03',
       30,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da emisso',
       'Data da emisso',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VDEV',
       '03',
       40,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de lanamento',
       'Data de lanamento',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VDEV',
       '--',
       50,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VDEV',
       '01',
       60,
       254,
       'NOMPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Produto',
       'Produto',
       '',
       'NOMPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VDEV',
       '01',
       70,
       8,
       'NOTORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'NF Origem',
       'NF Origem',
       '',
       'NOTORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VDEV',
       '--',
       80,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VDEV',
       '01',
       90,
       6,
       'NUMNOT_DEV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'NF DEV',
       'NF DEV',
       '',
       'NUMNOT_DEV',
       'F' FROM DUAL
UNION ALL
SELECT 'VDEV',
       '02',
       100,
       12,
       'QTDDEV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade devolvida',
       'Quantidade devolvida',
       '',
       'QTDDEV',
       'F' FROM DUAL
UNION ALL
SELECT 'VDEV',
       '01',
       110,
       20,
       'REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Referncia',
       'Referncia do Produto',
       '',
       'REFPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VDEV',
       '02',
       120,
       12,
       'RET_ST',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'ICMS-ST Retido',
       'ICMS-ST Retido',
       '',
       'RET_ST',
       'F' FROM DUAL
UNION ALL
SELECT 'VDEV',
       '--',
       130,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VDEV',
       '02',
       140,
       12,
       'VLRICM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'ICMS Destacado',
       'ICMS Destacado',
       '',
       'VLRICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VDEV',
       '02',
       150,
       12,
       'VLR_ST',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'ICMS-ST Destacado',
       'ICMS-ST Destacado',
       '',
       'VLR_ST',
       'F' FROM DUAL
);

/*-- SEQ 9725 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VDF ',
       TO_NUMBER(null),
       'VDF ',
       'Dbito Fatura',
       'TV_DEB_FAT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VDF.CODFIL,VDF.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9726 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VDF ','--','' FROM DUAL
UNION ALL
SELECT 'VDF ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VDF ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VDF ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VDF ','99','Outros' FROM DUAL
);

/*-- SEQ 9727 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VDF ',
       '01',
       170,
       10,
       'APEUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Apelido do Usurio',
       'Apelido do Usurio',
       '',
       'APEUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VDF ',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VDF ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Filial',
       'VDF.CODFIL = DFIL.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VDF ',
       '02',
       30,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data e Hora',
       'Data e Hora',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VDF ',
       '02',
       40,
       7,
       'DATVEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Venda',
       'Data da Venda',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VDF ',
       '01',
       160,
       15,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VDF ',
       '01',
       60,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VDF ',
       '99',
       70,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'VDF ',
       '99',
       80,
       4000,
       'MEIOPG',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Meio de Pagamento',
       'Meio de Pagamento',
       '',
       'MEIOPG',
       'F' FROM DUAL
UNION ALL
SELECT 'VDF ',
       '01',
       90,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Documento (CPF/CGC)',
       'Nmero do Documento: CGC ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VDF ',
       '02',
       100,
       7,
       'PAGAME',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Pagamento',
       'Data de Pagamento',
       '',
       'PAGAME',
       'F' FROM DUAL
UNION ALL
SELECT 'VDF ',
       '99',
       110,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VDF ',
       '99',
       120,
       6,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'STATUS',
       'T' FROM DUAL
UNION ALL
SELECT 'VDF ',
       '01',
       130,
       30,
       'TIPO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Dbito Fatura',
       'Tipo Dbito Fatura',
       '',
       'TIPO',
       'F' FROM DUAL
UNION ALL
SELECT 'VDF ',
       '03',
       140,
       12,
       'VLRFAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor da Fatura',
       'Valor da Fatura',
       '',
       'VLRFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VDF ',
       '03',
       150,
       12,
       'VLRLAN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Lanamento',
       'Valor Lanamento',
       '',
       'VLRLAN',
       'F' FROM DUAL
);

/*-- SEQ 9728 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VDF ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VDF ',
       'FLGEST',
       0,
       'Q',
       'Quitado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VDF ',
       'STATUS',
       0,
       ' ',
       'Aberto',
       TO_NUMBER(null),
       'Aberto' FROM DUAL
UNION ALL
SELECT 'VDF ',
       'STATUS',
       0,
       ' ',
       'Pago',
       TO_NUMBER(null),
       'Pago' FROM DUAL
);

/*-- SEQ 9729 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VDIA',
       TO_NUMBER(null),
       'VDIA',
       'Diagnstico',
       'TV_DIA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VDIA.FILUSU,VDIA.CODUSU,VDIA.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 9730 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VDIA','--','' FROM DUAL
UNION ALL
SELECT 'VDIA','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VDIA','99','Outros' FROM DUAL
);

/*-- SEQ 9731 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 5882,
       'USU ',
       'VDIA',
       'N',
       '1',
       '',
       '',
       'vdia.filusu = usu.filusu and
vdia.codusu = usu.codusu',
       '',
       '' FROM DUAL
);

/*-- SEQ 9732 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VDIA',
       '01',
       100,
       10,
       'APEUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Apelido do Usurio',
       'Apelido do Usurio',
       '',
       'APEUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VDIA',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = VDIA.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VDIA',
       '01',
       20,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Usurio',
       'Cdigo do Usurio',
       'USU2.FILUSU(+) = VDIA.FILUSU AND USU2.CODUSU(+) = VDIA.CODUSU',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VDIA',
       '01',
       30,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operacao',
       'Data Operacao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VDIA',
       '01',
       40,
       10,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VDIA',
       '01',
       50,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VDIA',
       '01',
       60,
       0,
       'MSGERR',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem Erro',
       'Mensagem Erro',
       '',
       'MSGERR',
       'F' FROM DUAL
UNION ALL
SELECT 'VDIA',
       '01',
       70,
       3,
       'NUMECF',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       'F',
       'Numero ECF',
       'Numero ECF',
       'DECF.FILECF = VDIA.CODFIL(+) AND DECF.NUMECF = VDIA.NUMECF(+)',
       'NUMECF',
       'T' FROM DUAL
UNION ALL
SELECT 'VDIA',
       '01',
       80,
       2,
       'TIPDIA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Diagnostico',
       'Tipo Diagnostico',
       '',
       'TIPDIA',
       'T' FROM DUAL
UNION ALL
SELECT 'VDIA',
       '01',
       90,
       40,
       'TIPERR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Erro',
       'Tipo Erro',
       '',
       'TIPERR',
       'F' FROM DUAL
);

/*-- SEQ 9733 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VDIA',
       'TIPDIA',
       0,
       ' ',
       'NF-e no autorizada',
       TO_NUMBER(null),
       '14' FROM DUAL
UNION ALL
SELECT 'VDIA',
       'TIPDIA',
       0,
       ' ',
       'Dados da IBPT no atualizados',
       TO_NUMBER(null),
       '15' FROM DUAL
UNION ALL
SELECT 'VDIA',
       'TIPDIA',
       0,
       ' ',
       'CF-e sem chave de acesso',
       TO_NUMBER(null),
       '16' FROM DUAL
UNION ALL
SELECT 'VDIA',
       'TIPDIA',
       0,
       ' ',
       'NFC-e no confirmada',
       TO_NUMBER(null),
       '17' FROM DUAL
UNION ALL
SELECT 'VDIA',
       'TIPDIA',
       0,
       ' ',
       'NFCe cancelada sem confirmao',
       TO_NUMBER(null),
       '18' FROM DUAL
UNION ALL
SELECT 'VDIA',
       'TIPDIA',
       0,
       ' ',
       'SAT cancelado sem confirmao',
       TO_NUMBER(null),
       '19' FROM DUAL
UNION ALL
SELECT 'VDIA',
       'TIPDIA',
       0,
       ' ',
       'SAT no confirmado',
       TO_NUMBER(null),
       '20' FROM DUAL
UNION ALL
SELECT 'VDIA',
       'TIPDIA',
       0,
       ' ',
       'RPS no gerou XML',
       TO_NUMBER(null),
       '21' FROM DUAL
UNION ALL
SELECT 'VDIA',
       'TIPDIA',
       0,
       ' ',
       'RPS no transmitido',
       TO_NUMBER(null),
       '22' FROM DUAL
UNION ALL
SELECT 'VDIA',
       'TIPDIA',
       0,
       ' ',
       'RPS cancelado no transmitido',
       TO_NUMBER(null),
       '23' FROM DUAL
UNION ALL
SELECT 'VDIA',
       'TIPDIA',
       0,
       ' ',
       'Transao invlida',
       TO_NUMBER(null),
       '01' FROM DUAL
UNION ALL
SELECT 'VDIA',
       'TIPDIA',
       0,
       ' ',
       'Dia Aberto',
       TO_NUMBER(null),
       '02' FROM DUAL
UNION ALL
SELECT 'VDIA',
       'TIPDIA',
       0,
       ' ',
       'Erro executar JOB/JOB Parado',
       TO_NUMBER(null),
       '03' FROM DUAL
UNION ALL
SELECT 'VDIA',
       'TIPDIA',
       0,
       ' ',
       'Pedido No separado',
       TO_NUMBER(null),
       '04' FROM DUAL
UNION ALL
SELECT 'VDIA',
       'TIPDIA',
       0,
       ' ',
       'Produtos com estoque negativo',
       TO_NUMBER(null),
       '05' FROM DUAL
UNION ALL
SELECT 'VDIA',
       'TIPDIA',
       0,
       ' ',
       'Existem e-mails nao enviados',
       TO_NUMBER(null),
       '06' FROM DUAL
UNION ALL
SELECT 'VDIA',
       'TIPDIA',
       0,
       ' ',
       'Fechamento de pista',
       TO_NUMBER(null),
       '07' FROM DUAL
UNION ALL
SELECT 'VDIA',
       'TIPDIA',
       0,
       ' ',
       'Lanamentos inconsistentes',
       TO_NUMBER(null),
       '09' FROM DUAL
UNION ALL
SELECT 'VDIA',
       'TIPDIA',
       0,
       ' ',
       'Reduo Z',
       TO_NUMBER(null),
       '10' FROM DUAL
UNION ALL
SELECT 'VDIA',
       'TIPDIA',
       0,
       ' ',
       'Problemas com NF-e',
       TO_NUMBER(null),
       '11' FROM DUAL
UNION ALL
SELECT 'VDIA',
       'TIPDIA',
       0,
       ' ',
       'Receita Bruta no foi aprovada',
       TO_NUMBER(null),
       '12' FROM DUAL
UNION ALL
SELECT 'VDIA',
       'TIPDIA',
       0,
       ' ',
       'Retornos NF-e no processados',
       TO_NUMBER(null),
       '13' FROM DUAL
);

/*-- SEQ 9734 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VDIE',
       TO_NUMBER(null),
       'VDIE',
       'Abastecimentos',
       'TV_DIE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9735 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VDIE','--','' FROM DUAL
UNION ALL
SELECT 'VDIE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VDIE','99','Outros' FROM DUAL
);

/*-- SEQ 9736 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VDIE',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VDIE',
       '--',
       20,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data operao',
       'Data operao',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VDIE',
       '--',
       30,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do ECF',
       'Nmero do ECF',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'VDIE',
       '--',
       40,
       6,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Nmero da nota',
       'Nmero da nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VDIE',
       '--',
       50,
       7,
       'PLACAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Placa',
       'Placa',
       '',
       'PLACAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VDIE',
       '--',
       60,
       12,
       'QTDMOV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade',
       'Quantidade',
       '',
       'QTDMOV',
       'F' FROM DUAL
);

/*-- SEQ 9737 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VDOP',
       TO_NUMBER(null),
       'VDOP',
       'Docs PGTO x C.Banco',
       'TV_DOP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'VDOP.CODFIL,VDO.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9738 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VDOP','--','' FROM DUAL
UNION ALL
SELECT 'VDOP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VDOP','02','Datas' FROM DUAL
UNION ALL
SELECT 'VDOP','03','Valores' FROM DUAL
UNION ALL
SELECT 'VDOP','99','Outros' FROM DUAL
);

/*-- SEQ 9739 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 29588,
       'CTA ',
       'VDOP',
       '1',
       'N',
       '',
       '',
       'CTA.CODFIL = VDOP.FILCTA AND
CTA.SEQUEN = VDOP.SEQCTA AND
CTA.TIPCTA = VDOP.TIPCTA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29589,
       'CLI ',
       'VDOP',
       '01',
       '01',
       '',
       '',
       'vdop.filcli = cli.filcli(+) and
vdop.codcli = cli.codcli(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29590,
       'CTB ',
       'VDOP',
       '1',
       '1',
       '',
       '',
       'vdop.filcta = ctb.filcta and
vdop.seqcta = ctb.seqcta and
vdop.tipcta = ctb.tipcta',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29759,
       'CCC ',
       'VDOP',
       '01',
       '1',
       '',
       '',
       'VDOP.CODFIL = CCC.FILDOP(+) AND
VDOP.SEQUEN = CCC.SEQDOP(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 9740 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VDOP',
       '--',
       30,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       205,
       20,
       'CHEQUECOMQUEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cheque est c/Quem?',
       'Cheque est c/Quem?',
       '',
       '(CASE WHEN VDOP.FILDES IS NULL THEN ''CHEQUE C/ CLIENTE'' ELSE ''CHEQUE C/ LOJA'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       170,
       1,
       'CHETRO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Cheque Troco?',
       ' cheque troco?',
       '',
       'CHETRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       240,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Banco',
       'Codigo Banco',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       180,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo origem da filial.',
       'VDOP.CODFIL = DFIL.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       90,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Usurio',
       'Cdigo Usurio',
       'VDOP.FILUSU = USU2.FILUSU(+)  AND VDOP.CODUSU = USU2.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       250,
       10,
       'CTACRR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm. Conta Corrente',
       'Nmero da Conta Corrente',
       '',
       'CTACRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       280,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Incluso',
       'Data de incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       140,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       50,
       5,
       'DOMDOP',
       'A',
       'DDOP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDOP.DESDOP',
       'V',
       '',
       'F',
       'A',
       'F',
       'Tipo de Documento',
       'Tipo de Documento',
       'DDOP.CODTAB = VDOP.DOMDOP',
       'DOMDOP',
       'F' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       190,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       100,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       200,
       3,
       'FILDES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Entregue na Filial',
       'Filial Destino',
       '',
       'FILDES',
       'F' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       210,
       3,
       'FILRDP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial RDP',
       '',
       'FILRDP',
       'F' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       80,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       40,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       260,
       5,
       'NUMAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Numero Agencia',
       'Numero da Agncia',
       '',
       'NUMAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       150,
       25,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'NDocumento',
       'Nmero Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       160,
       1,
       'NUMIMP',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nm. Impresses',
       'Nmero de Impresses',
       '',
       'NUMIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       130,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(VDOP.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       220,
       4000,
       'OBSINT',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observaes Internas',
       'Observaes Internas',
       '',
       'OBSINT',
       'F' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       110,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Contato',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       230,
       10,
       'SEQRDP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador RDP',
       '',
       'SEQRDP',
       'F' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       60,
       5,
       'STDDOP',
       'F',
       'DSTD',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSTD.DESSTD',
       'V',
       '',
       'F',
       'A',
       'F',
       'Situao Documento',
       'Situao Documento',
       'DSTD.CODTAB = VDOP.STDDOP',
       'STDDOP',
       'F' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       120,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '03',
       290,
       12,
       'VLRCCC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor pago com C/C',
       'Valor Pago em Conta Corrente',
       '',
       '(SELECT VLRCCC FROM TV_DOP_CCC
 WHERE NUMDOC = VDOP.NUMDOC)',
       '' FROM DUAL
UNION ALL
SELECT 'VDOP',
       '--',
       70,
       12,
       'VLRDOC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor do Documento',
       'Valor do Documento',
       '',
       'VLRDOC',
       'F' FROM DUAL
);

/*-- SEQ 9741 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VDOP',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VDOP',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VDOP',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VDOP',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VDOP',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9742 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VDOU',
       TO_NUMBER(null),
       'VDOU',
       'Mdicos(Tab.Externa)',
       'TV_DOU',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'vdou.codcrm,vdou.nomdou',
       '' FROM DUAL
);

/*-- SEQ 9743 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VDOU','--','' FROM DUAL
UNION ALL
SELECT 'VDOU','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VDOU','99','Outros' FROM DUAL
);

/*-- SEQ 9744 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VDOU',
       '--',
       10,
       6,
       'CODCRM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'CRM',
       'CRM do Medico',
       '',
       'CODCRM',
       'F' FROM DUAL
UNION ALL
SELECT 'VDOU',
       '--',
       20,
       45,
       'NOMDOU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Medico',
       'Nome do Medico',
       '',
       'NOMDOU',
       'F' FROM DUAL
);

/*-- SEQ 9745 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VDPG',
       TO_NUMBER(null),
       'VDPG',
       'Docs. Pagamento',
       'TV_DPG',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9746 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VDPG','--','' FROM DUAL
UNION ALL
SELECT 'VDPG','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VDPG','99','Outros' FROM DUAL
);

/*-- SEQ 9747 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VDPG',
       '01',
       10,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       20,
       1,
       'CHETRO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Cheque Troco?',
       ' cheque troco?',
       '',
       'CHETRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       30,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       240,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       '' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       40,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       50,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'VDPG.FILUSU = USU.FILUSU(+) AND VDPG.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       60,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data de Pagamento',
       'Data de Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       70,
       5,
       'DOMDOP',
       'A',
       'DDOP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDOP.DESDOP',
       'V',
       '',
       'F',
       'A',
       'F',
       'Tipo de Documento',
       'Tipo de Documento',
       'DDOP.CODTAB = DDPG.DOMDOP',
       'DOMDOP',
       'F' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       90,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial
Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       100,
       3,
       'FILDES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Entregue na Filial',
       'Filial Destino',
       '',
       'FILDES',
       'F' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       110,
       3,
       'FILRDP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial RDP',
       '',
       'FILRDP',
       'F' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       120,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       130,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       140,
       25,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'N Documento',
       'N Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       150,
       1,
       'NUMIMP',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nm. Impresses',
       'Nmero de Impresses',
       '',
       'NUMIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       160,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(VDPG.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       170,
       4000,
       'OBSINT',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Obsrvaes Internas',
       'Observaes Internas',
       '',
       'OBSINT',
       'F' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       180,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       190,
       10,
       'SEQRDP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador RDP',
       '',
       'SEQRDP',
       'F' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       200,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       210,
       5,
       'STDDOP',
       'F',
       'DSTD',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSTD.DESSTD',
       'V',
       '',
       'F',
       'A',
       'F',
       'Situao Documento',
       'Situao Documento',
       'DSTD.CODTAB = VDPG.STDDOP',
       'STDDOP',
       'F' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       220,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo da Conta',
       'Tipo da Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VDPG',
       '01',
       230,
       12,
       'VLRDOC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor do Documento',
       'Valor do Documento',
       '',
       'VLRDOC',
       'F' FROM DUAL
);

/*-- SEQ 9748 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VDPG',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VDPG',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VDPG',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VDPG',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VDPG',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9749 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VDRO',
       TO_NUMBER(null),
       'VDRO',
       'Drogas/Medicamento',
       'TV_DRO',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VDRO.CODDRO,VDRO.DESDRO',
       '' FROM DUAL
);

/*-- SEQ 9750 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VDRO','--','' FROM DUAL
UNION ALL
SELECT 'VDRO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VDRO','99','Outros' FROM DUAL
);

/*-- SEQ 9751 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VDRO',
       '01',
       10,
       8,
       'CODDRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo',
       'Codigo Medicamento',
       '',
       'CODDRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VDRO',
       '01',
       20,
       300,
       'DESDRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Medicamento',
       'Descricao Medicamento',
       '',
       'DESDRO',
       'F' FROM DUAL
);

/*-- SEQ 9752 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VECB',
       TO_NUMBER(null),
       'VECB',
       'Eventos de Cobrana',
       'TV_EVE_COB',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9753 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VECB','--','' FROM DUAL
UNION ALL
SELECT 'VECB','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VECB','99','Outros' FROM DUAL
);

/*-- SEQ 9754 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VECB',
       '01',
       10,
       10,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Chave Evento',
       'Chave Evento',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VECB',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VECB',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VECB',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'VECB.FILUSU = USU.FILUSU(+) AND VECB.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VECB',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'F',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VECB',
       '01',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VECB',
       '01',
       60,
       15,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio do Evento',
       'Descrio do Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VECB',
       '01',
       70,
       27,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificador Evento',
       'Identificador Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'VECB',
       '01',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VECB',
       '01',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VECB',
       '01',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VECB',
       '01',
       110,
       1,
       'MSGEVE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Mensagem de Evento?',
       'Mensagem de Evento?',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VECB',
       '01',
       120,
       30,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao do Evento',
       'Situao do Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VECB',
       '01',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Evento',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VECB',
       '01',
       140,
       12,
       'VLREVE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Evento',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 9755 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VECB',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VECB',
       'FLGEST',
       0,
       'N',
       'No Lido',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9756 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VECC',
       TO_NUMBER(null),
       'VECC',
       'Ev. Contas Rec. (CC)',
       'TV_EVO_CON_REC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9757 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VECC','--','' FROM DUAL
UNION ALL
SELECT 'VECC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VECC','02','Filtros' FROM DUAL
UNION ALL
SELECT 'VECC','99','Outros' FROM DUAL
);

/*-- SEQ 9758 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VECC',
       '02',
       20,
       7,
       'DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Final',
       '',
       '',
       'DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VECC',
       '02',
       10,
       7,
       'DATINI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Inicial',
       '',
       '',
       'DATINI',
       'F' FROM DUAL
UNION ALL
SELECT 'VECC',
       '99',
       30,
       12,
       'PAGO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Pago',
       '',
       '',
       'PAGO',
       'F' FROM DUAL
UNION ALL
SELECT 'VECC',
       '99',
       50,
       12,
       'SALDO_FINAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Saldo Final',
       '',
       '',
       'SALDO_FINAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VECC',
       '99',
       40,
       12,
       'SALDO_INICIAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Saldo Inicial',
       '',
       '',
       'SALDO_INICIAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VECC',
       '99',
       60,
       12,
       'VALOR_CC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Valor Conta Corrente',
       '',
       '',
       'VALOR_CC',
       'F' FROM DUAL
);

/*-- SEQ 9759 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VECP',
       TO_NUMBER(null),
       'VECP',
       'Evol. Contas Pagar',
       'TV_ECP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9760 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VECP','--','' FROM DUAL
UNION ALL
SELECT 'VECP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VECP','99','Outros' FROM DUAL
);

/*-- SEQ 9761 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5895,
       'COM ',
       'VECP',
       '1 ',
       '1 ',
       '',
       '',
       'COM.CODFIL = VECP.CODFIL AND COM.SEQUEN = VECP.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9762 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VECP',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = VECP.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VECP',
       '01',
       20,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VECP',
       '01',
       30,
       12,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Referncia',
       'Data Referncia',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VECP',
       '01',
       40,
       12,
       'DIVIDA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Saldo~Devedor',
       'Saldo Devedor',
       '',
       'DIVIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VECP',
       '01',
       50,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VECP',
       '01',
       60,
       12,
       'JURDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Juros e Descontos',
       'Juros e Descontos',
       '',
       'JURDES',
       'F' FROM DUAL
UNION ALL
SELECT 'VECP',
       '01',
       70,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VECP',
       '01',
       80,
       12,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor~Liquido',
       'Valor Liquido',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VECP',
       '01',
       90,
       12,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor~Pago',
       'Valor Pago',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9763 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VECR',
       TO_NUMBER(null),
       'VECR',
       'Eventos Correspon.',
       'TV_EVE_COR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9764 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VECR','--','' FROM DUAL
UNION ALL
SELECT 'VECR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VECR','99','Outros' FROM DUAL
);

/*-- SEQ 9765 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VECR',
       '01',
       10,
       10,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Chave Evento',
       'Chave Evento',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VECR',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VECR',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VECR',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'VECR.FILUSU = USU.FILUSU(+) AND VECR.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VECR',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VECR',
       '01',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VECR',
       '01',
       60,
       15,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio do Evento',
       'Descrio do Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VECR',
       '01',
       70,
       27,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificador Evento',
       'Identificador Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'VECR',
       '01',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VECR',
       '01',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VECR',
       '01',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VECR',
       '01',
       110,
       1,
       'MSGEVE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Mensagem de Evento?',
       'Mensagem de Evento?',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VECR',
       '01',
       120,
       30,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao Evento',
       'Situao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VECR',
       '01',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Evento',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VECR',
       '01',
       140,
       12,
       'VLREVE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Evento',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 9766 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VECR',
       'FLGEST',
       0,
       '1',
       '1 Cobrana',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VECR',
       'FLGEST',
       0,
       '2',
       '2 Cobrana',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VECR',
       'FLGEST',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9767 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VECT',
       TO_NUMBER(null),
       'VECT',
       'Ctas Tit,Ger,Num.',
       'TV_ECT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VECT.CHVPAI,VECT.CHV_ID',
       '' FROM DUAL
);

/*-- SEQ 9768 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VECT','--','' FROM DUAL
UNION ALL
SELECT 'VECT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VECT','05','Estrutura da Conta' FROM DUAL
UNION ALL
SELECT 'VECT','99','Outros' FROM DUAL
);

/*-- SEQ 9769 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VECT',
       '01',
       10,
       13,
       'CHVPAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Chave Pai',
       'Chave Pai',
       '',
       'CHVPAI',
       'F' FROM DUAL
UNION ALL
SELECT 'VECT',
       '01',
       20,
       14,
       'CHV_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Identificador Chave',
       'Identificador da Chave',
       '',
       'CHV_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'VECT',
       '05',
       80,
       255,
       'EstruturaDeContas',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Estrutura da Conta',
       '',
       '',
       'SUBSTR(EstruturaDeContas(VECT.FILCTA,VECT.SEQCTA),1,100)',
       '' FROM DUAL
UNION ALL
SELECT 'VECT',
       '01',
       30,
       3,
       'FILCTA',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       'DFIL.CODFIL = VECT.FILCTA',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VECT',
       '01',
       40,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VECT',
       '01',
       50,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo da Conta',
       'Tipo da Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VECT',
       '01',
       60,
       250,
       'TITCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo da Conta',
       'Ttulo da Conta',
       '',
       'TITCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VECT',
       '01',
       70,
       255,
       'USERID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'User ID',
       'Usuario',
       '',
       'USERID',
       'F' FROM DUAL
);

/*-- SEQ 9770 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VECT',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VECT',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VECT',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9771 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VED ',
       TO_NUMBER(null),
       'VED ',
       'Eventos Devedores',
       'TV_EVE_DEV',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9772 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VED ','--','' FROM DUAL
UNION ALL
SELECT 'VED ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VED ','99','Outros' FROM DUAL
);

/*-- SEQ 9773 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VED ',
       '01',
       10,
       10,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Chave Evento',
       'Chave Evento',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VED ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VED ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VED ',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'VED.FILUSU = USU.FILUSU(+) AND VED.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VED ',
       '--',
       160,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VED ',
       '01',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VED ',
       '01',
       60,
       15,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio do Evento',
       'Descrio do Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VED ',
       '01',
       70,
       27,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificador Evento',
       'Identificador Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'VED ',
       '01',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VED ',
       '01',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VED ',
       '01',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VED ',
       '01',
       110,
       1,
       'MSGEVE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Mensagem de Evento?',
       'Mensagem de Evento?',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VED ',
       '01',
       120,
       12,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao Evento',
       'Situao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VED ',
       '01',
       150,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Evento',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VED ',
       '01',
       140,
       12,
       'VLREVE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Evento',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 9774 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VED ',
       'FLGEST',
       0,
       'N',
       'NO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VED ',
       'FLGEST',
       0,
       'S',
       'SIM',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9775 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VEHP',
       TO_NUMBER(null),
       'VEHP',
       'Inventario HP<>012 ',
       'TV_PCIA_INV_HP_013_015',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9776 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VEHP','--','' FROM DUAL
UNION ALL
SELECT 'VEHP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VEHP','99','Outros' FROM DUAL
);

/*-- SEQ 9777 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VEHP',
       '--',
       90,
       5,
       'CLASS2',
       'S',
       'DCL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL2.CLASS2',
       'V',
       '',
       '',
       'A',
       'F',
       'FAMILIA',
       '',
       'DCL2.CODTAB = VEHP.CLASS2',
       'CLASS2',
       'F' FROM DUAL
UNION ALL
SELECT 'VEHP',
       '--',
       100,
       5,
       'CLASS3',
       'S',
       'DCL3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL3.CLASS3',
       'V',
       '',
       '',
       'A',
       'F',
       'GRUPO',
       '',
       'DCL3.CODTAB = VEHP.CLASS3',
       'CLASS3',
       'F' FROM DUAL
UNION ALL
SELECT 'VEHP',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Codigo Filial',
       '',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VEHP',
       '--',
       110,
       10,
       'CODIGO_ORIGEM',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.',
       'A',
       '',
       '',
       'A',
       'F',
       'Codigo Origem ',
       '',
       'DFIL.CODFIL = VEHP.CODFIL',
       'CODIGO_ORIGEM',
       'F' FROM DUAL
UNION ALL
SELECT 'VEHP',
       '--',
       20,
       9,
       'CODIGO_REVENDA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Codigo Revenda',
       '',
       '',
       'CODIGO_REVENDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VEHP',
       '--',
       30,
       7,
       'DATA_IVENTARIO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Iventario',
       '',
       '',
       'DATA_IVENTARIO',
       'T' FROM DUAL
UNION ALL
SELECT 'VEHP',
       '--',
       120,
       30,
       'MARCA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Marca',
       '',
       '',
       'MARCA',
       'F' FROM DUAL
UNION ALL
SELECT 'VEHP',
       '--',
       40,
       6,
       'PAIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Pai',
       '',
       '',
       'PAIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VEHP',
       '--',
       50,
       20,
       'PART_NUMBER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Part Number',
       '',
       '',
       'PART_NUMBER',
       'F' FROM DUAL
UNION ALL
SELECT 'VEHP',
       '--',
       60,
       12,
       'PEDIDO_PENDENTE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Pedido Pendente',
       '',
       '',
       'PEDIDO_PENDENTE',
       'F' FROM DUAL
UNION ALL
SELECT 'VEHP',
       '--',
       70,
       12,
       'SALDO_FILIAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Quantidade estoque',
       '',
       '',
       'SALDO_FILIAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VEHP',
       '--',
       80,
       12,
       'TOTAL_INVENTARIO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Total Inventario',
       '',
       '',
       'TOTAL_INVENTARIO',
       'F' FROM DUAL
);
/*-- SEQ 9778 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VEI ',
       TO_NUMBER(null),
       'VEI ',
       'Veiculos',
       'TT_VEI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VEI.PLACAS',
       '' FROM DUAL
);

/*-- SEQ 9779 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VEI ','--','' FROM DUAL
UNION ALL
SELECT 'VEI ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VEI ','99','Outros' FROM DUAL
);

/*-- SEQ 9780 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22049,
       'TRA ',
       'VEI ',
       '0N',
       '1',
       '',
       '',
       'TRA.FILCLI(+) = VEI.FILCLI AND
TRA.CODCLI(+) = VEI.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22050,
       'CLI ',
       'VEI ',
       '0N',
       '1',
       '',
       '',
       'CLI.FILCLI = VEI.FILCLI AND
CLI.CODCLI = VEI.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22051,
       'VXP ',
       'VEI ',
       '0N',
       '1',
       '',
       '',
       'VXP.PLACAS(+) = VEI.PLACAS',
       '',
       '' FROM DUAL
);

/*-- SEQ 9781 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'VEI ',
       '01',
       10,
       4,
       'ANOVEI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Ano',
       'Ano do veiculo',
       '',
       'ANOVEI',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'VEI ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Codigo cliente',
       '',
       'CODCLI',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'VEI ',
       '01',
       30,
       5,
       'CODCOR',
       'S',
       'DVCR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DVCR.DESCOR',
       'V',
       '',
       '',
       'N',
       'F',
       'Cor do~Veculo',
       'Cor do veiculo',
       'DVCR.CODTAB(+) = VEI.CODCOR',
       'CODCOR',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'VEI ',
       '01',
       40,
       5,
       'CODTIP',
       'S',
       'DVTP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DVTP.DESVTP',
       'V',
       '',
       '',
       'N',
       'F',
       'Tipo do~Veculo',
       'Tipo do Veiculo',
       'DVTP.CODTAB(+) = VEI.CODTIP',
       'CODTIP',
       'T',
       'P' FROM DUAL
UNION ALL
SELECT 'VEI ',
       '01',
       50,
       3,
       'FILCCC',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Fil. Conta Corrente',
       'Filial conta corrente',
       'DFIL.CODFIL = VEI.FILCCC',
       'FILCCC',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'VEI ',
       '01',
       60,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do cliente',
       '',
       'FILCLI',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'VEI ',
       '01',
       70,
       30,
       'MARVEI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Marca',
       'Marca do veiculo',
       '',
       'MARVEI',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'VEI ',
       '01',
       80,
       30,
       'MODVEI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Modelo',
       'Modelo do Veiculo',
       '',
       'MODVEI',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'VEI ',
       '01',
       90,
       1,
       'NACION',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nacional~Importado?',
       'Nacional ou importado',
       '',
       'NACION',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'VEI ',
       '01',
       100,
       7,
       'PLACAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Placa',
       'Placa do veiculo',
       '',
       'PLACAS',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'VEI ',
       '01',
       110,
       10,
       'SEQCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador conta corrente',
       '',
       'SEQCCC',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'VEI ',
       '01',
       150,
       2,
       'SIGEST',
       'A',
       'DEST',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEST.ESTADO',
       'V',
       '',
       '',
       'A',
       '',
       'Sigla UF',
       'Sigla UF',
       'DEST.ESTADO(+) = VEI.SIGEST',
       'SIGEST',
       '',
       'P' FROM DUAL
UNION ALL
SELECT 'VEI ',
       '01',
       120,
       1,
       'TRAFEG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Trafego~Controlado?',
       'Controla trafego do veiculo?',
       '',
       'TRAFEG',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'VEI ',
       '01',
       140,
       1,
       'VEIATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Veculo Ativo?',
       'Veculo Ativo?',
       '',
       'VEIATI',
       'F',
       'P' FROM DUAL
UNION ALL
SELECT 'VEI ',
       '01',
       130,
       14,
       'VLRCCC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor conta corrente',
       'Valor conta corrente',
       '',
       'VLRCCC',
       'F',
       'P' FROM DUAL
);

/*-- SEQ 9782 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VEM ',
       TO_NUMBER(null),
       'VEM ',
       'Eventos X E-mail',
       'TV_EVE_MAI',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9783 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VEM ','--','' FROM DUAL
UNION ALL
SELECT 'VEM ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VEM ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VEM ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VEM ','99','Outros' FROM DUAL
);

/*-- SEQ 9784 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VEM ',
       '99',
       10,
       10,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave Evento',
       'Chave Evento',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VEM ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VEM ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Filial',
       'VEM.CODFIL = DFIL.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'VEM ',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Usurio',
       'Usurio',
       'VEM.FILUSU = USU.FILUSU(+)  AND VEM.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VEM ',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VEM ',
       '02',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Operao',
       'Data de Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VEM ',
       '01',
       60,
       6,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Evento',
       'Descrio Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VEM ',
       '01',
       70,
       14,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificador Evento',
       'Identificador do Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'VEM ',
       '01',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VEM ',
       '01',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VEM ',
       '99',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'VEM ',
       '99',
       110,
       300,
       'MSGEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem Evento',
       'Mensagem Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VEM ',
       '99',
       120,
       8,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao do Evento',
       'Situao do Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VEM ',
       '99',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Evento',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VEM ',
       '03',
       140,
       12,
       'VLREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Evento',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 9785 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VEM ',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEM ',
       'FLGEST',
       0,
       'E',
       'Entregue',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9786 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VEN ',
       0,
       'VEN ',
       'Vendas',
       'TV_VEN',
       'T',
       '',
       'TOTALL',
       'Vendas',
       '{CODFIL;NUMECF;CODSER;NUMNOT};FILCLI;CODCLI;DATHOR;FLGEST;ATU_EM;CONTRA',
       '',
       'CONTRA',
       'Venda',
       'T',
       '',
       'VEN.CODFIL,VEN.NUMECF,VEN.CODSER,VEN.NUMNOT
VEN.CODFIL,VEN.DOCUME',
       '' FROM DUAL
);

/*-- SEQ 9787 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VEN ','--','' FROM DUAL
UNION ALL
SELECT 'VEN ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VEN ','02','Valores' FROM DUAL
UNION ALL
SELECT 'VEN ','03','Dados de Transporte' FROM DUAL
UNION ALL
SELECT 'VEN ','05','Datas' FROM DUAL
UNION ALL
SELECT 'VEN ','20','Combustiveis' FROM DUAL
UNION ALL
SELECT 'VEN ','30','Impostos' FROM DUAL
UNION ALL
SELECT 'VEN ','40','Tributaes' FROM DUAL
UNION ALL
SELECT 'VEN ','50','Ttulo Avulso' FROM DUAL
UNION ALL
SELECT 'VEN ','51','Campanhas' FROM DUAL
UNION ALL
SELECT 'VEN ','99','Outros' FROM DUAL
);

/*-- SEQ 9788 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 118812,
       'PVD ',
       'VEN ',
       '1',
       'N',
       '',
       '',
       'PVD.FILCLI = VEN.FILCLI and
PVD.CODCLI = VEN.CODCLI
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118813,
       'REC ',
       'VEN ',
       '0N',
       '1',
       '',
       '',
       'REC.CODFIL = VEN.CODFIL AND
REC.SEQUEN = VEN.SEQUEN
',
       '(case when VEN.VLRLIQ = 0 then 0 else COALESCE(REC.VLRPAR / VEN.VLRLIQ, 1) end)',
       '' FROM DUAL
UNION ALL
SELECT 118814,
       'REL ',
       'VEN ',
       '1',
       'N',
       '',
       '',
       'REL.FILPAR = VEN.FILTRA AND
REL.CODPAR = VEN.CODTRA AND
REL.TIPPAR = VEN.TIPTRA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118815,
       'TRA ',
       'VEN ',
       '1',
       'N',
       '',
       '',
       'TRA.FILCLI = VEN.FILTRA and
TRA.CODCLI = VEN.CODTRA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118816,
       'USU ',
       'VEN ',
       '01',
       '0N',
       '',
       '',
       'USU.FILUSU(+) = VEN.FILUSU AND
USU.CODUSU(+) = VEN.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118817,
       'VDD ',
       'VEN ',
       '1',
       'N',
       '',
       '',
       'VDD.FILUSU = VEN.FILVEN and
VDD.CODUSU = VEN.CODVEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118818,
       'DNAT',
       'VEN ',
       'N',
       '1',
       '',
       '',
       'DNAT.CODTAB = VEN.CODNAT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118819,
       'CTA ',
       'VEN ',
       'N',
       '01',
       '',
       '',
       'VEN.FILCTA = CTA.CODFIL AND VEN.SEQCTA = CTA.SEQUEN AND VEN.TIPCTA = CTA.TIPCTA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118820,
       'AGC ',
       'VEN ',
       '1',
       'N',
       '',
       '',
       'VEN.FILAGC = AGC.CODFIL AND
VEN.SEQAGC = AGC.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118821,
       'CMSR',
       'VEN ',
       'N',
       '1',
       '',
       '',
       'VEN.CODFIL = CMSR.FILREC AND
VEN.SEQUEN = CMSR.SEQREC',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118822,
       'ECOB',
       'VEN ',
       '01',
       'N',
       '',
       '',
       'ECOB.FILCLI(+) = VEN.FILCLI AND
ECOB.CODCLI(+) = VEN.CODCLI AND
ECOB.CODFIL(+) = VEN.FILCOB AND
ECOB.NUMEND(+) = VEN.ENDCOB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118823,
       'CLI ',
       'VEN ',
       '1',
       'N',
       '',
       '',
       'CLI.FILCLI = VEN.FILCLI and
CLI.CODCLI = VEN.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118824,
       'EENT',
       'VEN ',
       '01',
       'N',
       '',
       '',
       'EENT.FILCLI(+) = VEN.FILCLI AND
EENT.CODCLI(+) = VEN.CODCLI AND
EENT.CODFIL(+) = VEN.FILENT AND
EENT.NUMEND(+) = VEN.ENDENT
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118825,
       'EFAT',
       'VEN ',
       '01',
       'N',
       '',
       '',
       'EFAT.FILCLI(+) = VEN.FILCLI AND
EFAT.CODCLI(+) = VEN.CODCLI AND
EFAT.CODFIL(+) = VEN.FILFAT AND
EFAT.NUMEND(+) = VEN.ENDFAT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118826,
       'FAT ',
       'VEN ',
       'N',
       '1',
       '',
       '',
       'FAT.CODFIL = VEN.CODFIL and
FAT.SEQUEN = VEN.SEQFAT',
       '(case when FAT.VLRNOT = 0 then 0 else VEN.VLRLIQ / FAT.VLRNOT end)',
       '' FROM DUAL
UNION ALL
SELECT 118827,
       'IND ',
       'VEN ',
       '01',
       'N',
       '',
       '',
       'VEN.FILGUI = IND.FILCLI(+) AND
VEN.CODGUI = IND.CODCLI(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118828,
       'INDV',
       'VEN ',
       '01',
       'N',
       '',
       '',
       'VEN.FILVEN = INDV.FILVEN AND
VEN.CODVEN = INDV.CODVEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118829,
       'IVE ',
       'VEN ',
       'N',
       '1',
       '',
       '',
       'IVE.SEQUEN = VEN.SEQUEN and
IVE.CODFIL = VEN.CODFIL',
       '(case when VEN.VLRNOT = 0 then 0 else IVE.VLRMOV / VEN.VLRNOT end)',
       '' FROM DUAL
UNION ALL
SELECT 118830,
       'PLA ',
       'VEN ',
       '1',
       'N',
       '',
       '',
       'PLA.FILPGT = VEN.FILPGT AND
PLA.CODPGT = VEN.CODPGT
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118831,
       'LID ',
       'VEN ',
       '01',
       '0N',
       '',
       '',
       'VEN.CODFIL (+) = LID.CODFIL AND
VEN.NUMECF (+) = LID.NUMECF AND
VEN.TRN_ID (+) = LID.TRN_ID',
       '',
       '' FROM DUAL
UNION ALL
SELECT 118832,
       'RMPG',
       'VEN ',
       '0N',
       '1',
       '',
       '',
       'RMPG.CODFIL = VEN.CODFIL AND
RMPG.SEQUEN = VEN.SEQUEN',
       '(CASE WHEN VEN.VLRLIQ = 0 THEN 0 ELSE COALESCE(RMPG.VLRPAR / VEN.VLRLIQ, 1) END)',
       '' FROM DUAL
UNION ALL
SELECT 118833,
       'RECP',
       'VEN ',
       '0N',
       '1',
       '',
       '',
       'RECP.ORI_CODFIL = VEN.CODFIL AND
RECP.ORI_SEQUEN = VEN.SEQUEN',
       '(case when VEN.VLRLIQ = 0 then 0 else COALESCE(RECP.VLRPAR / VEN.VLRLIQ, 1) end)',
       '' FROM DUAL
);

/*-- SEQ 9789 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'VEN ',
       '99',
       760,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'VEN ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(VEN.ATU_EM,''YYYY'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       300,
       4,
       'ANO_DATHOR',
       'A',
       '',
       0,
       0,
       'VEN ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       '',
       'N',
       'T',
       'Ano Incluso',
       'Ano de Data e hora da operao',
       '',
       'TO_CHAR(VEN.DATHOR,''YYYY'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '05',
       570,
       4,
       'ANO_DATSAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'T',
       'Ano de Data Sada',
       'Ano de Data Sada',
       '',
       'TO_CHAR(VEN.DATSAI,''YYYY'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       790,
       4,
       'ANO_PROPGT',
       'A',
       '',
       0,
       0,
       'VEN ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       '',
       'N',
       'T',
       'Ano de Prox. Pagamen',
       'Ano de Data prximo pagamento ou data do cancelamento',
       '',
       'TO_CHAR(VEN.PROPGT,''YYYY'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       711,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN VEN.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       740,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'VEN ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '30',
       610,
       1,
       'AUTENT',
       'L',
       '',
       0,
       0,
       'VEN ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'VEN',
       'F',
       '',
       'T',
       'Autenticada?',
       'Indica se a nota j foi autenticada',
       '',
       'AUTENT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       930,
       1,
       'AVISTA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'A vista?',
       'Venda realizada a vista?',
       '',
       'AVISTA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '40',
       1250,
       12,
       'BASICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Base de Clculo ICMS',
       'Base de Clculo de ICMS',
       '',
       'BASICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '40',
       1310,
       12,
       'BASIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Base de Clculo IRRF',
       'Base de Clculo de IRRF',
       '',
       'BASIRR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '40',
       1280,
       12,
       'BASISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Base de Clculo ISS',
       'Base de Clculo de ISS',
       '',
       'BASISS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '02',
       70,
       12,
       'BASUBS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base Sub. Tributria',
       'Base da Substituio Tributria',
       '',
       'BASUBS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '--',
       1350,
       14,
       'BAS_ST_COM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base se ST da compra',
       'Base se ST da compra',
       '',
       'BAS_ST_COM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       1710,
       44,
       'CHAVEA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Chave de Acesso NF-e',
       'Chave de Acesso NF-e',
       '',
       'CHAVEA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1790,
       44,
       'CHVCAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave Cancelamento',
       'Chave de Autorizao do Cancelamento',
       '',
       'CHVCAN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1600,
       6,
       'CHVIBP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Chave do IBPT',
       'Chave do IBPT',
       '',
       'CHVIBP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       265,
       9,
       'CLIENTEFILIAL_CODIGO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cliente Filial+Cd',
       'Cliente Filial + Cdigo',
       '',
       '(VEN.FILCLI|| ''-'' ||VEN.CODCLI)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1220,
       14,
       'CMSIND',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Comisso indicador',
       'Comisso para indicador',
       '',
       'CMSIND',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '50',
       1170,
       20,
       'CODAVU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Ttulo Avulso',
       'Cdigo para Ttulo Avulso',
       '',
       'CODAVU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '40',
       1410,
       6,
       'CODCFO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'CFOP',
       'CFOP da Venda',
       '',
       'CODCFO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       270,
       6,
       'CODCLI',
       'A',
       '',
       0,
       0,
       'VEN ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '9',
       'F',
       'Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '--',
       1400,
       1,
       'CODCRT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Cd do Regime Tribut',
       'Cdigo do Regime Tributrio',
       '',
       'CODCRT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       860,
       5,
       'CODCTR',
       'S',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       '',
       'N',
       'F',
       'Unidade de Negcios',
       'Unidade de Negcios',
       'DCTR.CODTAB = VEN.CODCTR(+)',
       'CODCTR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '02',
       140,
       15,
       'CODEXT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       210,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       0,
       'VEN ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'VEN',
       'F',
       'A',
       'T',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = VEN.CODFIL',
       'CODFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '02',
       80,
       5,
       'CODFIN',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Cod. da Financeira',
       'Cod. da Financeira',
       '',
       'CODFIN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '03',
       1440,
       5,
       'CODFRE',
       'S',
       'DFRE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFRE.DESFRE',
       'V',
       '',
       '',
       'N',
       'F',
       'Poltica de Frete',
       'Poltica de Frete',
       'DFRE.CODTAB = VEN.CODFRE(+)',
       'CODFRE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       700,
       6,
       'CODGUI',
       'A',
       '',
       0,
       0,
       'VEN ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '9',
       'F',
       'Guia',
       'Cdigo do Guia',
       '',
       'CODGUI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1890,
       6,
       'CODINT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cd. Parc. Intermed.',
       'Cdigo do Parceiro Intermediador',
       '',
       'CODINT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '30',
       590,
       2,
       'CODNAT',
       'S',
       'DNAT',
       0,
       0,
       'VEN ',
       10,
       TO_NUMBER(null),
       '',
       'DNAT.NATURE',
       'V',
       'VEN',
       'F',
       'A',
       'T',
       'Natureza',
       'Natureza de operao',
       'VEN.CODNAT = DNAT.CODTAB (+)',
       'CODNAT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '30',
       595,
       2,
       'CODNATURE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Cdigo~Natureza',
       'Cdigo Natureza',
       '',
       'CODNAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       1120,
       12,
       'CODNSU',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo NSU',
       'Cdigo NSU',
       '',
       'CODNSU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       670,
       3,
       'CODPGT',
       'A',
       'PLA ',
       0,
       0,
       'VEN ',
       60,
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       'VEN',
       'F',
       'A',
       'T',
       'Plano de Pagamento',
       'Cdigo do plano de pagamento',
       'VEN.FILPGT = PLA.FILPGT(+) AND VEN.CODPGT = PLA.CODPGT(+)',
       'CODPGT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       730,
       2,
       'CODPRE',
       'S',
       'TPR ',
       0,
       0,
       'VEN ',
       120,
       TO_NUMBER(null),
       '',
       'TPR.DESPRE',
       'V',
       'VEN',
       'F',
       'A',
       'T',
       'Tab. de Preos',
       'Cdigo da tabela de preos',
       'VEN.FILPRE=TPR.CODFIL (+) and VEN.CODPRE=TPR.CODPRE (+)',
       'CODPRE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       731,
       2,
       'CODPRE1',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Codigo Tabela Preco',
       'Codigo Tabela Preco',
       '',
       'CODPRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       230,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       0,
       'VEN ',
       30,
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       'VEN',
       'F',
       'A',
       'T',
       'Srie',
       'Cdigo da srie',
       'VEN.CODSER=DSER.CODSER (+)',
       'CODSER',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '03',
       460,
       6,
       'CODTRA',
       'A',
       '',
       0,
       0,
       'VEN ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '9',
       'F',
       'Transportadora',
       'Cdigo da Transportadora',
       '',
       'CODTRA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '--',
       1390,
       12,
       'CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       'Identificao de Acesso',
       '',
       'CODUID',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       630,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       0,
       'VEN ',
       20,
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       'VEN',
       'F',
       'A',
       'T',
       'Usurio',
       'Cdigo do usurio',
       'VEN.FILUSU = USU.FILUSU(+)  and VEN.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '--',
       1370,
       3,
       'CODVDP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODVDP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       650,
       3,
       'CODVEN',
       'A',
       'VDD ',
       0,
       0,
       'VEN ',
       40,
       TO_NUMBER(null),
       '',
       'VDD.APEUSU',
       'V',
       'VEN',
       'F',
       'A',
       'T',
       'Vendedor',
       'Cdigo do vendedor',
       'VEN.FILVEN = VDD.FILUSU (+)  and VEN.CODVEN = VDD.CODUSU (+)',
       'CODVEN',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '20',
       580,
       10,
       'COMBUSTIVEIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Combustiveis',
       'Combustiveis',
       '',
       'COMBUSTIVEIS(VEN.CODFIL,VEN.SEQUEN)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '02',
       420,
       2,
       'COMSOB',
       'S',
       '',
       0,
       0,
       'VEN ',
       70,
       30,
       '',
       '',
       'D',
       'VEN',
       'F',
       'A',
       'T',
       'Comisso Sobre',
       'Comisso sobre (ver tela plano)',
       '',
       'COMSOB',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       60,
       1,
       'CONSFI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Consumidor Final?',
       'Consumidor Final?',
       '',
       'CONSFI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '--',
       1740,
       7,
       'DATAUT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Autorizao',
       'Data e Hora de Autorizao',
       '',
       'DATAUT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '--',
       1750,
       7,
       'DATCAN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Canc/Inut',
       'Data e Hora de Cancelamento/Inutilizao',
       '',
       'DATCAN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '05',
       580,
       7,
       'DATFIS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Fiscal',
       'Data Fiscal',
       '',
       'DATFIS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       280,
       16,
       'DATHOR',
       '@',
       '',
       0,
       0,
       'VEN ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '@',
       'T',
       'Data Incluso',
       'Data e hora da operao',
       '',
       'DATHOR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       1980,
       19,
       'DATHOR_FORMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Data Hora Formatado',
       'Data e Hora da operao (Formatado)',
       '',
       'CAST(TO_CHAR(VEN.DATHOR, ''dd/mm/yyyy HH24:MI:SS'') AS VARCHAR(19))',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '05',
       1860,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '05',
       10,
       8,
       'DATSAI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'T',
       'Data Sada',
       'Data Sada',
       '',
       'DATSAI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '05',
       771,
       8,
       'DAT_QUITACAO',
       'D',
       '',
       0,
       0,
       'VEN ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'T',
       'Data~Quitao',
       'Data da quitao da venda/fatura',
       '',
       '(SELECT MAX(REC.PAGAME) FROM TT_REC REC WHERE REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       1100,
       10,
       'DENFORUF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Dentro/Fora UF',
       'Dentro ou fora do Estado',
       '',
       '(CASE WHEN VEN.UFLOJA=''T'' THEN ''DENTRO UF'' ELSE ''FORA UF'' END)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '02',
       440,
       8,
       'DESCON',
       'F',
       '',
       2,
       0,
       'VEN ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '9',
       'T',
       'Desc/Acrscimo (%)',
       'Desconto / Acrscimo',
       '',
       'DESCON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '02',
       1850,
       12,
       'DESESP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Desconto Especial',
       'Desconto Especial',
       '',
       'DESESP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1940,
       12,
       'DESFID',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Desc. Fidelidade',
       'Valor de Desconto de Fidelidade',
       '',
       'DESFID',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '02',
       441,
       12,
       'DESRAT',
       'F',
       '',
       2,
       0,
       'VEN ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       '9',
       'T',
       'Desc/Acrscimo',
       'Desconto / Acrscimo',
       '',
       'DESRAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '--',
       1460,
       12,
       'DIACORR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DIACORR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '--',
       1470,
       12,
       'DIAUTIL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DIAUTIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1690,
       12,
       'DOCIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '#N Doc. Importao',
       'Nmero do Documento de Importao (descontinuado)',
       '',
       'DOCIMP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       1160,
       15,
       'DOCNFP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento p/ NFP',
       'Nmero do CPF/CNPJ para Nota Fiscal Paulista',
       '',
       'DOCNFP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       250,
       13,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Documento',
       'Documento (Srie + Sub-Srie + Nmero )',
       '',
       'DOCUME',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1520,
       3,
       'ECFEST',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       '',
       'Nm. ECF do Estorno',
       'Nmero do ECF do Estorno',
       'DECF.FILECF = VEN.FILEST(+) AND DECF.NUMECF = VEN.ECFEST(+)',
       'ECFEST',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       1660,
       254,
       'EMAILC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail do Cliente',
       'E-mail do Cliente',
       '',
       'EMAILC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '03',
       540,
       1,
       'EMIDES',
       'L',
       '',
       0,
       0,
       'VEN ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'VEN',
       'F',
       '',
       'T',
       'Frete Dest./Terc.?',
       'Frete  por conta do Destinatrio ou de Terceiros?',
       '',
       'EMIDES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       30,
       2,
       'ENDCOB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nmero End. Cobrana',
       'Nmero do endereo de cobrana',
       '',
       'ENDCOB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       50,
       2,
       'ENDENT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nmero End. Entrega',
       'Nmero do endereo de entrega',
       '',
       'ENDENT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       90,
       2,
       'ENDFAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nmero End. Fatura',
       'Nmero de endereo de fatura',
       '',
       'ENDFAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '03',
       550,
       2,
       'ESPECI',
       'S',
       'DESP',
       0,
       0,
       'VEN ',
       110,
       TO_NUMBER(null),
       '',
       'DESP.ESPECI',
       'V',
       'VEN',
       'F',
       'A',
       'F',
       'Espcie de Volume',
       'Espcie do volume',
       'VEN.ESPECI = DESP.CODTAB (+)',
       'ESPECI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '51',
       1930,
       1,
       'EXICPR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Existe Campanha?',
       'Existe Campanha?',
       '',
       'EXISTECAMPANHA(VEN.CODFIL, VEN.SEQUEN)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1860,
       1,
       'EXPEM4',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exportado EME4?',
       'Exportado EME4?',
       '',
       'EXPEM4',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1630,
       1,
       'EXPFIS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exportado Fiscal?',
       'Exportado Fiscal?',
       '',
       'EXPFIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       820,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exportada?',
       'Exportada?',
       '',
       'EXPORT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       830,
       10,
       'EXTNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cod Ext Natureza',
       'Codigo externo da natureza ',
       '',
       'EXTNAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       840,
       10,
       'EXTPLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cod Ext Plano',
       'Codigo externo de plano ',
       '',
       'EXTPLA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1850,
       1,
       'EXT_EC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exportado E-Commerce',
       'Exportado E-Commerce?',
       '',
       'EXT_EC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1950,
       12,
       'FATFID',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Fator Conv. Fid.',
       'Valor de Fator de Converso do Desconto de Fidelidade',
       '',
       'FATFID',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       260,
       3,
       'FILCLI',
       'A',
       '',
       0,
       0,
       'VEN ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       100,
       3,
       'FILCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do endereo de cobrana',
       '',
       'FILCOB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1830,
       3,
       'FILCRE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       '0',
       '',
       'Filial NF cred ICMS',
       'Filial da Nota de Transferncia de saldo credor de ICMS',
       'DFIL.CODFIL(+) = VEN.FILCRE',
       'FILCRE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '50',
       1180,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Filial da Conta',
       'Filial da Conta',
       '',
       'FILCTA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       110,
       3,
       'FILENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do endereo de entrega',
       '',
       'FILENT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1490,
       3,
       'FILEST',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial nota estorno',
       'Filial da nota de estorno ',
       'DFIL.CODFIL(+) = VEN.FILEST',
       'FILEST',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       160,
       3,
       'FILFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do endereo de fatura',
       '',
       'FILFAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       690,
       3,
       'FILGUI',
       'A',
       '',
       0,
       0,
       'VEN ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       '',
       'Filial do guia',
       '',
       'FILGUI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1880,
       3,
       'FILINT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Fil. Parc. Intermed.',
       'Filial do Parceiro Intermediador',
       'DFIL.CODFIL(+) = VEN.FILINT',
       'FILINT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1550,
       3,
       'FILORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Filial nota origem',
       'Filial da nota origem',
       '',
       'FILORI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       660,
       3,
       'FILPGT',
       'A',
       '',
       0,
       0,
       'VEN ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       '',
       'Filial do plano de pagamento',
       '',
       'FILPGT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       720,
       3,
       'FILPRE',
       'A',
       '',
       0,
       0,
       'VEN ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       '',
       'Filial da tabela de preo',
       '',
       'FILPRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '03',
       450,
       3,
       'FILTRA',
       'A',
       '',
       0,
       0,
       'VEN ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       '',
       'Filial da Transportadora',
       '',
       'FILTRA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       620,
       3,
       'FILUSU',
       'A',
       '',
       0,
       0,
       'VEN ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILUSU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '--',
       1380,
       3,
       'FILVDP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILVDP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       640,
       3,
       'FILVEN',
       'A',
       '',
       0,
       0,
       'VEN ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       '',
       'Filial do vendedor',
       '',
       'FILVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '02',
       400,
       1,
       'FINANC',
       'L',
       '',
       0,
       0,
       'VEN ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'VEN',
       'F',
       '',
       'F',
       'Gera Dados Financ.?',
       'Gera dados financeiros',
       '',
       'FINANC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       320,
       1,
       'FLGEST',
       'A',
       '',
       0,
       0,
       'VEN ',
       90,
       30,
       '',
       '',
       'D',
       'VEN',
       'F',
       'A',
       'T',
       'Situao',
       'Estado (Cancelado/Quitado/Em aberto)',
       '',
       'FLGEST',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1450,
       1,
       'FLGEXT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'NF Externa?',
       'NF Externa?',
       '',
       'FLGEXT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1230,
       1,
       'FLGNFE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'NF-e',
       'NF-e',
       '',
       'FLGNFE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       20,
       1,
       'FLGTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Pessoa ',
       'Tipo de Pessoa',
       '',
       'FLGTIP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1610,
       34,
       'FONIBP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Fonte IBPT',
       'Fonte IBPT (Fonte Usada no Clculo do Imposto)',
       '',
       'FONIBP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '02',
       1140,
       12,
       'FUNRUR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Fundo Rural Retido',
       'Fundo Rural Retido',
       '',
       'FUNRUR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       305,
       2,
       'HORA_DATHOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Hora da Venda',
       'Hora da Venda',
       '',
       'TO_CHAR(DATHOR,''HH'')',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       306,
       5,
       'HORA_VENDA24H',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Hora da Venda(HH:MM)',
       'Horrio da venda no formato HH:MM, Exemplo: 09:15',
       '',
       'CAST(TO_CHAR(DATHOR,''HH24:MI'') as VARCHAR(5))
',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       330,
       5,
       'HORDATHOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Horas',
       'Horas',
       '',
       '(SUBSTR(TO_CHAR(VEN.DATHOR,''HH24'')||''-''||(1+TO_NUMBER(TO_CHAR(VEN.DATHOR,''HH24'')) ),1,5))',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1900,
       100,
       'ID_INT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo ID Intermed',
       'Cdigo de Identificao do Intermediador',
       '',
       'ID_INT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1510,
       1,
       'IMPEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Sit. impres. estorno',
       'Situao da impresso do estorno ',
       '',
       'IMPEST',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       120,
       1,
       'LANVEN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Considera Venda?',
       'Considera Venda?',
       '',
       'LANVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '03',
       490,
       5,
       'MARCAS',
       'A',
       '',
       0,
       0,
       'VEN ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'VEN',
       'F',
       'A',
       'T',
       'Marcas',
       'Marcas',
       '',
       'MARCAS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       750,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'VEN ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(VEN.ATU_EM,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       290,
       2,
       'MES_DATHOR',
       'A',
       '',
       0,
       0,
       'VEN ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       '',
       'N',
       'T',
       'Ms Incluso',
       'Ms de Data e hora da operao',
       '',
       'TO_CHAR(VEN.DATHOR,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '05',
       560,
       2,
       'MES_DATSAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'T',
       'Ms de Data Sada',
       'Ms de Data Sada',
       '',
       'TO_CHAR(VEN.DATSAI,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       780,
       2,
       'MES_PROPGT',
       'A',
       '',
       0,
       0,
       'VEN ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       '',
       'N',
       'T',
       'Ms de Prox. Pagamen',
       'Ms de Data prximo pagamento ou data do cancelamento',
       '',
       'TO_CHAR(VEN.PROPGT,''MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '--',
       1620,
       2,
       'MODNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Modelo Fiscal',
       'Modelo Fiscal',
       '',
       'MODNOT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1540,
       10,
       'MOTCAN',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Motivo cancelamento',
       'Motivo do Cancelamento',
       '',
       'RTF2TXT(MOTCAN)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1130,
       0,
       'MOTREI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo do Reinicio',
       'Motivo do Reinicio do Cdigo NSU',
       '',
       'MOTREI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1970,
       4000,
       'MPGTOAGRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Meio Pgto Agrupado',
       'Meio de Pagamento Agrupado',
       '',
       '((select replace(agregatxt(distinct meiodepagamento(rec.codfil,rec.sequen,rec.numpar,rec.subpar,1)), chr(13) || chr(10), chr(32) || chr(43) || chr(32)) from tt_rec rec where rec.codfil = ven.codfil and rec.sequen = ven.sequen))',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1730,
       1,
       'NFRECI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'NF sobre Recibo Prov',
       'NF sobre Recibo Provisrio?',
       '',
       'NFRECI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '50',
       1209,
       250,
       'NOMCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Ttulo da Conta',
       'Ttulo da Conta Financeira',
       '',
       '(SELECT CT1.TITCTA FROM TT_CTA CT1 WHERE VEN.FILCTA = CT1.CODFIL AND VEN.SEQCTA = CT1.SEQUEN AND VEN.TIPCTA = CT1.TIPCTA)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1910,
       60,
       'NOMIND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Indicador da Venda',
       'Filial + Cdigo + Nome do Indicador',
       '',
       '(SELECT IN1.FILCLI||IN1.CODCLI||'' - ''||IN1.NOMCLI||'' ''||IN1.ULTNOM FROM TT_CLI IN1 WHERE VEN.FILGUI = IN1.FILCLI AND VEN.CODGUI = IN1.CODCLI)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       870,
       13,
       'NOTFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       '',
       'Nota Fiscal',
       'Nota Fiscal (Srie + Ecf + Nmero)',
       '',
       '(SELECT DOCUME FROM TV_VEN NEV WHERE NEV.CODFIL = VEN.CODFIL AND NEV.SEQUEN = VEN.SEQFAT)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1480,
       9,
       'NOTMAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Nmero Nota Manual',
       'Nmero da Nota Manual',
       '',
       'NOTMAN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '30',
       600,
       2,
       'NROIMP',
       'S',
       '',
       0,
       0,
       'VEN ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '9',
       'T',
       'Nm. Impresses',
       'Nmero de vezes que a nota foi impressa',
       '',
       'NROIMP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       212,
       3,
       'NUMCODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '03',
       470,
       8,
       'NUMCON',
       'A',
       '',
       0,
       0,
       'VEN ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '9',
       'T',
       'Conhecimento',
       'Conhecimento de frete',
       '',
       'NUMCON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       220,
       3,
       'NUMECF',
       'A',
       'DECF',
       0,
       0,
       'VEN ',
       20,
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       'VEN',
       'F',
       '0',
       'T',
       'Nmero do ECF',
       'Nmero do ECF',
       'DECF.FILECF = VEN.CODFIL AND DECF.NUMECF = VEN.NUMECF',
       'NUMECF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '--',
       1780,
       20,
       'NUMNFS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero NFSe',
       'Nmero NFSe',
       '',
       'NUMNFS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1441,
       15,
       'NUMNFSFAT',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'NF-e Servio Fatura',
       'NF-e de Servio Vinculada a Fatura',
       '',
       '(SELECT R.NUMNFS FROM TT_RPS R WHERE R.CODFIL = VEN.CODFIL AND R.SEQUEN = VEN.SEQFAT)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       240,
       6,
       'NUMNOT',
       'A',
       '',
       0,
       0,
       'VEN ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '9',
       'T',
       'Nmero',
       'Nmero da nota',
       '',
       'NUMNOT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '03',
       480,
       4,
       'NUMVOL',
       'G',
       '',
       0,
       0,
       'VEN ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '9',
       'T',
       'Num.Volumes',
       'Nmero de Volumes',
       '',
       'NUMVOL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       680,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'VEN ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'VEN',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(VEN.OBSERV)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '40',
       1330,
       4000,
       'OBSFIS',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Obs Fis Complemetar',
       'Observaes Fiscais Complementares',
       '',
       'RTF2TXT(OBSFIS)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '02',
       1150,
       12,
       'OUTTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Outras Taxas',
       'Outras Taxas',
       '',
       'OUTTAX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '02',
       370,
       8,
       'PERCOM',
       'F',
       '',
       2,
       0,
       'VEN ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       '9',
       'T',
       'Comis. s/ Parcelas',
       'Valor da comisso sobre as parcelas (exceto entrada)',
       '',
       'PERCOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '02',
       410,
       8,
       'PERENT',
       'F',
       '',
       2,
       0,
       'VEN ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       '9',
       'T',
       'Comis. s/ Entrada',
       'Comisso (entrada)',
       '',
       'PERENT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '03',
       520,
       14,
       'PESBRU',
       'F',
       '',
       4,
       0,
       'VEN ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       'N',
       'T',
       'Peso Bruto',
       'Peso lquido',
       '',
       'PESBRU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '03',
       530,
       14,
       'PESLIQ',
       'F',
       '',
       4,
       0,
       'VEN ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       'N',
       'T',
       'Peso Lquido',
       'Peso bruto',
       '',
       'PESLIQ',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1960,
       12,
       'PONFID',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Pontos de Fid.',
       'Valor dos Pontos de Desnconto de Fidelidade ps converso',
       '',
       'PONFID',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '02',
       430,
       4,
       'PRAMED',
       'S',
       '',
       0,
       0,
       'VEN ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '9',
       'T',
       'Prazo Mdio',
       'Prazo mdio',
       '',
       'PRAMED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '--',
       1760,
       50,
       'PROAUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Protoc Autorizao',
       'Protocolo de Autorizao',
       '',
       'PROAUT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '--',
       1770,
       50,
       'PROCAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Protoc Canc/Inut',
       'Protocolo de Cancelamento/Inutilizao',
       '',
       'PROCAN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '05',
       770,
       8,
       'PROPGT',
       'D',
       '',
       0,
       0,
       'VEN ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'D',
       'T',
       'Prox. Vencimento',
       'Data prximo vencimento',
       '',
       '(SELECT MIN(REC.DATVEN) FROM TT_REC REC WHERE REC.CODFIL = VEN.CODFIL AND REC.SEQUEN = VEN.SEQUEN AND FLGEST = ''A'' AND SEQCHE IS NULL AND CARTAO IS NULL)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1140,
       12,
       'QTDITE_DIF',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       '',
       'Qtd Itens Diferentes',
       'Quantidade de itens com produtos diferentes.',
       '',
       'QuantidadeItensDiferentesVenda(ven.codfil, ven.sequen)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1720,
       1,
       'RECIBO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Recibo Provisrio?',
       'Recibo Provisrio?',
       '',
       'RECIBO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '02',
       390,
       12,
       'RETIDO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Imposto retido',
       'Valor do Importo Retido',
       '',
       'RETIDO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1800,
       6,
       'SATCAN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nm Cancelamento SAT',
       'Nmero do CF-e de Cancelamento no SAT',
       '',
       'SATCAN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       1640,
       6,
       'SATCFE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Nmero do CF-e',
       'Nmero do CF-e',
       '',
       'SATCFE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       1650,
       9,
       'SATSER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Nmero de Srie do S',
       'Nmero de Srie do SAT (Srie SAT)',
       '',
       'SATSER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '40',
       1820,
       12,
       'SEGRUR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Seguro Rural',
       'Valor Seguro Rural',
       '',
       'SEGRUR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       310,
       10,
       'SEMANAVENDA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Semana~Incluso',
       'Semana Incluso',
       '',
       'TO_CHAR( ADD_DAY(VEN.DATHOR,1 - TO_NUMBER(TO_CHAR(VEN.DATHOR,''D''))) ,''DD/MM'')||'' A ''||TO_CHAR( ADD_DAY(VEN.DATHOR,7 - TO_NUMBER(TO_CHAR(VEN.DATHOR,''D''))),''DD/MM'')',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '02',
       1810,
       12,
       'SENAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor SENAR',
       'Valor Servio Nacional de Aprendizagem Rural',
       '',
       'SENAR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1840,
       10,
       'SEQCRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       '',
       'Seq. NF cred ICMS',
       'Sequenciador da Nota de Transferncia de saldo credor de ICMS',
       '',
       'SEQCRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '50',
       1190,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequncia da Conta',
       'Sequncia da Conta',
       '',
       'SEQCTA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1500,
       10,
       'SEQEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Seq. nota de estorno',
       'Sequenciador da nota de estorno ',
       '',
       'SEQEST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       170,
       10,
       'SEQFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Nmero sequencial interno da fatura',
       '',
       'SEQFAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1560,
       10,
       'SEQORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq. nota de origem',
       'Sequenciador da nota de origem',
       '',
       'SEQORI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       180,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       1240,
       3,
       'SEREXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Serie Fis. Exportada',
       'Srie Fiscal Exportada',
       '',
       'SEREXT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       710,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'VEN ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'VEN',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN VEN.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '02',
       340,
       8,
       'SINAL',
       'F',
       '',
       2,
       0,
       'VEN ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       '9',
       'T',
       'Sinal Relacionado',
       'Valor de sinal relacionado',
       '',
       'SINAL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '02',
       380,
       12,
       'SUBSTT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Subst. Tributria',
       'Subst. Tributria',
       '',
       'SUBSTT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '--',
       1110,
       4,
       'TIPCCC',
       'S',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       'A',
       'F',
       'Tipo Conta Corrente',
       'Tipo Conta Corrente',
       'VEN.TIPCCC = DCCC.CODTAB(+)',
       'TIPCCC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '50',
       1200,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo da Conta',
       'Tipo da Conta',
       '',
       'TIPCTA',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1530,
       1,
       'TIPESP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo de NF especial',
       'Tipo de NF especial',
       '',
       'TIPESP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1700,
       1,
       'TIPIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       '#Tipo Doc. Importa',
       'Tipo de Documento de Importao (descontinuado)',
       '',
       'TIPIMP',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1870,
       10,
       'TIPINT',
       'N',
       'DTXI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DTXI.DESTIPXINT',
       'V',
       '',
       '',
       'N',
       '',
       'Tipo Intermediao',
       'Tipo da Intermediao',
       'DTXI.CODTAB(+) = VEN.TIPINT',
       'TIPINT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       810,
       1,
       'TIPNOT',
       'A',
       '',
       0,
       0,
       'VEN ',
       160,
       30,
       '',
       '',
       'D',
       'VEN',
       'F',
       'A',
       'F',
       'Tipo de Nota',
       'Tipo de Nota',
       '',
       'TIPNOT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       925,
       1,
       'TIPO_LAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       'Tipo Lan',
       '',
       '(CASE WHEN VLRLIQ<0 THEN ''D'' WHEN COALESCE(PRAMED,0)=0  THEN ''V'' WHEN TRUNC(DATHOR)=TRUNC(R.PAGAME) AND TRUNC(DATHOR)=TRUNC(R.DATVEN)AND(R.FLGEST=''P'' OR R.CARTAO IS NOT NULL OR R.SEQCHE IS NOT NULL) THEN ''E'' ELSE '' '' END END END FROM TT_REC R)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       190,
       1,
       'TIPTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       100,
       30,
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Tipo Transportadora',
       'Tipo Transportadora',
       '',
       'TIPTRA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       850,
       1,
       'TIPTRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Cheque Troco',
       'Tipo Conta Cheque Troco',
       '',
       'COALESCE(VEN.TIPTRO,''@'')',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '50',
       1210,
       1,
       'TITAVU',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Ttulo Avulso?',
       'Ttulo Avulso?',
       '',
       'TITAVU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1380,
       12,
       'TOTQTD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Qtd. Total',
       'Qtd. Total',
       '',
       '(select sum(IIVE.qtdmov) from TT_IVE IIVE where IIVE.CODFIL = VEN.CODFIL AND IIVE.SEQUEN = VEN.SEQUEN)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1370,
       12,
       'TOTQTDDEV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Qtd. Total Devolvida',
       'Qtd. Total Devolvida',
       '',
       '(select COALESCE(sum(ABS(I.qtdmov)),0) from TT_IVE I INNER JOIN TT_VEN D ON D.CODFIL = I.CODFIL AND D.SEQUEN = I.SEQUEN INNER JOIN TD_NAT N ON D.CODNAT = N.CODTAB where I.FILORI = VEN.CODFIL AND I.NUMORI = VEN.SEQUEN AND N.TIPNAT = ''D'' AND I.QTDMOV < 0)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       800,
       1,
       'TRIBUT',
       'L',
       '',
       0,
       0,
       'VEN ',
       150,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'VEN',
       'F',
       '',
       'T',
       'Tributada?',
       'Define se a venda  tributada',
       '',
       'TRIBUT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       1670,
       12,
       'TRN_ID',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'ID Transao',
       'ID Transao',
       '',
       'TRN_ID',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       40,
       1,
       'UFLOJA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'F',
       'Dentro do Estado?',
       'Venda Dentro do Estado?',
       '',
       'UFLOJA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '01',
       1000,
       100,
       'UNEPLACAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Placas do Cliente',
       'Placas do Cliente',
       '',
       'UNEPLACAS(VEN.CODFIL,VEN.SEQUEN)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       200,
       1,
       'VENCON',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Venda Consumidor?',
       'Venda Consumidor',
       '',
       'VENCON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       130,
       1,
       'VINCUL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Vinculada?',
       'Vinculada',
       '',
       'VINCUL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '40',
       1680,
       12,
       'VLRADU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       '#Vl. Desp. Aduaneira',
       'Valor das Despesas Aduaneiras (descontinuado)',
       '',
       'VLRADU',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '40',
       1340,
       12,
       'VLRCFI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Valor Retido COFINS',
       'Valor Retido de COFINS',
       '',
       'VLRCFI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '40',
       1300,
       12,
       'VLRCSL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Vlr Contribuio Soc',
       'Valor Total de Contribuio Social',
       '',
       'VLRCSL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '02',
       1480,
       12,
       'VLRFLX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor juros FLEX',
       'Valor juros FLEX',
       '',
       'VLRFLX',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '03',
       510,
       8,
       'VLRFRE',
       'F',
       '',
       2,
       0,
       'VEN ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       '9',
       'T',
       'Frete',
       'Valor do Frete',
       '',
       'VLRFRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1430,
       12,
       'VLRIBP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor do Imposto',
       'Valor do Imposto de Acordo com a Tabela do IBPT',
       '',
       'COALESCE(VEN.VLRIBP, COALESCE(VEN.VLRIBPFED,0)+COALESCE(VEN.VLRIBPEST,0)+COALESCE(VEN.VLRIBPMUN,0))',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1580,
       12,
       'VLRIBPEST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Impostos Est',
       'Valor de Impostos Estaduais',
       '',
       'VLRIBPEST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1570,
       12,
       'VLRIBPFED',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Impostos Fed',
       'Valor de Impostos Federais',
       '',
       'VLRIBPFED',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1590,
       12,
       'VLRIBPMUN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Impostos Mun',
       'Valor de Impostos Municipais',
       '',
       'VLRIBPMUN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '40',
       1260,
       12,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Valor Total de ICMS',
       'Valor Total de ICMS',
       '',
       'VLRICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '99',
       1920,
       12,
       'VLRICMDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Difal Destino',
       'Valor Difal Destino',
       '',
       '(SELECT SUM(VLRICMDES) FROM TT_IVE IV1 WHERE IV1.CODFIL = VEN.CODFIL AND IV1.SEQUEN = VEN.SEQUEN AND IV1.SITMOV = ''N'')',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '40',
       1320,
       12,
       'VLRIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Valor Total de IRRF',
       'Valor Total de IRR',
       '',
       'VLRIRR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '40',
       1290,
       12,
       'VLRISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Valor Total de ISS',
       'Valor Total de ISS',
       '',
       'VLRISS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '02',
       360,
       8,
       'VLRLIQ',
       'F',
       '',
       2,
       0,
       'VEN ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       '9',
       'T',
       'Valor Lquido',
       'Valor lquido da nota',
       '',
       'VLRLIQ',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '02',
       350,
       8,
       'VLRNOT',
       'F',
       '',
       2,
       0,
       'VEN ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       '9',
       'T',
       'Valor dos Itens',
       'Valor da nota',
       '',
       'VLRNOT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '40',
       1270,
       12,
       'VLRPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Valor Retido PIS',
       'Valor Retido de PIS',
       '',
       'VLRPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '02',
       1420,
       12,
       'VLRSAD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Vlr Serv Adicional ',
       'Valor de Servios Adicionais Total',
       '',
       'VLRSAD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '02',
       1620,
       12,
       'VLRSADCAN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor servio canc.',
       'Valor do servio adicional cancelado',
       '',
       'VLRSADCAN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '03',
       500,
       8,
       'VLRSEG',
       'F',
       '',
       2,
       0,
       'VEN ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       '9',
       'T',
       'Seguro',
       'Valor do seguro do frete',
       '',
       'VLRSEG',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VEN ',
       '--',
       1360,
       14,
       'VLR_ST_COM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr. se ST da compra',
       'Valor se ST da compra',
       '',
       'VLR_ST_COM',
       '',
       'D' FROM DUAL
);

/*-- SEQ 9790 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VEN ',
       'CODCRT',
       1,
       ' ',
       'Simples Nacional',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'CODCRT',
       2,
       ' ',
       'Simples Nac - excesso de subli',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'CODCRT',
       3,
       ' ',
       'Regime Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'COMSOB',
       7,
       ' ',
       'Comisso sobre Markup',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'COMSOB',
       8,
       ' ',
       'Markup no momento da Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'COMSOB',
       0,
       '-',
       'Lquido ao Vender',
       241,
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'COMSOB',
       1,
       '-',
       'Bruto ao Vender',
       242,
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'COMSOB',
       2,
       '-',
       'A receber no Vencimento',
       243,
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'COMSOB',
       3,
       '-',
       'Recebido no Recebimento',
       244,
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'COMSOB',
       4,
       '-',
       'A receber no Recebimento',
       245,
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'COMSOB',
       5,
       '-',
       'Recebido na compensao',
       289,
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'COMSOB',
       6,
       '-',
       'A receber na compensao',
       290,
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'FLGEST',
       0,
       'A',
       'Em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'FLGEST',
       0,
       'I',
       'Incompleta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'FLGEST',
       0,
       'Q',
       'Quitado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'FLGNFE',
       0,
       '0',
       'No enviado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'FLGNFE',
       0,
       '1',
       'Autorizada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'FLGNFE',
       0,
       '2',
       'Rejeitada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'FLGNFE',
       0,
       '3',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'FLGNFE',
       0,
       '4',
       'Inutilizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'FLGNFE',
       0,
       '5',
       'Enviando ao Sefaz',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'FLGNFE',
       0,
       '6',
       'Denegada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'FLGNFE',
       0,
       '8',
       'Erro de Importao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'FLGTIP',
       0,
       '0',
       'Fsica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'FLGTIP',
       0,
       '1',
       'Jurdica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'FLGTIP',
       0,
       '2',
       'Entidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'FLGTIP',
       0,
       '3',
       'Especial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'FLGTIP',
       0,
       '4',
       'M.E.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'FLGTIP',
       0,
       '5',
       'Filial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'IMPEST',
       0,
       'I',
       'Impressa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'IMPEST',
       0,
       'P',
       'Pendente para Impresso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'TIPESP',
       0,
       'A',
       'Avulsa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'TIPESP',
       0,
       'I',
       'Importada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'TIPIMP',
       0,
       '0',
       'Declarao de Importao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'TIPIMP',
       0,
       '1',
       'Declarao Simplificada de Imp',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'TIPNOT',
       0,
       'A',
       'N.F.F.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'TIPNOT',
       0,
       'F',
       'Fatura',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'TIPNOT',
       0,
       'N',
       'Nota fiscal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'TIPTRA',
       0,
       'R',
       'Reviso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'TIPTRA',
       0,
       'T',
       'Tarefa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'TIPTRO',
       0,
       '+',
       'Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'TIPTRO',
       0,
       '-',
       'Devoluo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'TIPTRO',
       0,
       '2',
       'Troca',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'TIPTRO',
       0,
       '@',
       'Vazio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VEN ',
       'TIPTRO',
       0,
       'A',
       'Ambos',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9791 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VENC',
       TO_NUMBER(null),
       'VENC',
       'Ctr. Encerrantes NSU',
       'TV_ENC_NSU',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9792 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VENC','--','' FROM DUAL
UNION ALL
SELECT 'VENC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VENC','02','Valores' FROM DUAL
UNION ALL
SELECT 'VENC','99','Outros' FROM DUAL
);

/*-- SEQ 9793 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 27868,
       'VIPR',
       'VENC',
       '1',
       'N',
       '',
       '',
       'VIPR.FILMAT = VENC.FILMAT and
VIPR.CODMAT = VENC.CODMAT and
VIPR.CODCOR = VENC.CODCOR and
VIPR.CODTAM = VENC.CODTAM
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 27869,
       'DFIL',
       'VENC',
       '1',
       'N',
       '',
       '',
       'DFIL.CODFIL = VENC.CODFIL',
       '',
       '' FROM DUAL
UNION ALL
SELECT 27870,
       'IVE ',
       'VENC',
       'N',
       '1',
       '',
       '',
       'IVE.SEQUEN = VENC.IVE_SEQUEN AND
IVE.CODFIL = VENC.IVE_CODFIL AND
IVE.NUMITE = VENC.IVE_NUMITE',
       '',
       '' FROM DUAL
);

/*-- SEQ 9794 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VENC',
       '01',
       10,
       2,
       'BICO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo do Bico',
       'Cdigo do Bico',
       '',
       'BICO',
       'F' FROM DUAL
UNION ALL
SELECT 'VENC',
       '01',
       20,
       2,
       'BOMBA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Bomba',
       'Bomba',
       '',
       'BOMBA',
       'F' FROM DUAL
UNION ALL
SELECT 'VENC',
       '01',
       30,
       11,
       'CODBIC',
       'A',
       'DBIC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DBIC.FILBIC||'' - ''||DBIC.SEQFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Bico',
       'Bico',
       'DBIC.CODTAB = VENC.CODBIC',
       'CODBIC',
       'F' FROM DUAL
UNION ALL
SELECT 'VENC',
       '01',
       40,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       '',
       'N',
       'F',
       'Diviso',
       'Diviso do Produto',
       'VENC.CODCOR = DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'VENC',
       '01',
       50,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial de Medio',
       'Filial de Medio',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VENC',
       '01',
       60,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Produto',
       'Cdigo do Produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VENC',
       '01',
       70,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       '',
       'N',
       'F',
       'Sub-diviso',
       'Sub-diviso do Produto',
       'VENC.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'VENC',
       '01',
       180,
       5,
       'CODTAN',
       'S',
       'DTAN',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TO_CHAR(DTAN.TANQUE)',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo do Tanque',
       'Cdigo do Tanque',
       'DTAN.CODTAB = VENC.CODTAN',
       'CODTAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VENC',
       '01',
       80,
       7,
       'DATMED',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data da Medio',
       'Data da Medio',
       '',
       'DATMED',
       'F' FROM DUAL
UNION ALL
SELECT 'VENC',
       '02',
       90,
       12,
       'ENCABE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Vlr. Abe. Encerrante',
       'Valor de Abertura do Encerrante',
       '',
       'ENCABE',
       'F' FROM DUAL
UNION ALL
SELECT 'VENC',
       '02',
       100,
       12,
       'ENCFEC',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Vlr. Fec. Encerrante',
       'Valor de Fechamento do Encerrante',
       '',
       'ENCFEC',
       'F' FROM DUAL
UNION ALL
SELECT 'VENC',
       '01',
       110,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial do Produto',
       'Filial do Produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VENC',
       '01',
       120,
       3,
       'FILTAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial do Tanque',
       'Filial do Tanque',
       '',
       'FILTAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VENC',
       '--',
       190,
       3,
       'IVE_CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'IVE_CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VENC',
       '--',
       200,
       5,
       'IVE_NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'IVE_NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VENC',
       '--',
       210,
       10,
       'IVE_SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'IVE_SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 9795 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VER ',
       TO_NUMBER(null),
       'VER ',
       'Plano Oramentrio',
       'TT_VER',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VER.FILCTA,VER.SEQCTA,VER.ANOVER,VER.MESVER',
       '' FROM DUAL
);

/*-- SEQ 9796 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VER ','--','' FROM DUAL
UNION ALL
SELECT 'VER ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VER ','99','Outros' FROM DUAL
);

/*-- SEQ 9797 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22459,
       'CTA ',
       'VER ',
       '1 ',
       'N ',
       '',
       '',
       'CTA.CODFIL = VER.FILCTA AND
CTA.SEQUEN = VER.SEQCTA',
       '',
       '' FROM DUAL
);

/*-- SEQ 9798 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VER ',
       '01',
       10,
       4,
       'ANOVER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ano',
       'Ano',
       '',
       'ANOVER',
       'F' FROM DUAL
UNION ALL
SELECT 'VER ',
       '01',
       20,
       3,
       'FILCTA',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       'DFIL.CODFIL = VER.FILCTA',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VER ',
       '01',
       30,
       2,
       'MESVER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ms',
       'Ms',
       '',
       'MESVER',
       'F' FROM DUAL
UNION ALL
SELECT 'VER ',
       '01',
       40,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VER ',
       '01',
       60,
       14,
       'VLRREA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Realizado',
       'Valor Realizado',
       '',
       '(select sum(coalesce(rcti.totcre,0)-coalesce(rcti.totdeb,0)) 
from tr_cta rcti 
where rcti.filcta=ver.filcta
and rcti.seqcta=ver.seqcta
and rcti.flgflx=''R''
and to_char(rcti.datlan,''YYYYMM'')=anover||lpad(ver.mesver,2,''0'')
)',
       '' FROM DUAL
UNION ALL
SELECT 'VER ',
       '01',
       50,
       14,
       'VLRVER',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Previsto',
       'Valor Previsto',
       '',
       'VLRVER',
       'F' FROM DUAL
);

/*-- SEQ 9799 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VERE',
       TO_NUMBER(null),
       'VERE',
       'Min. Meio Pagt. ECF',
       'TV_EREC_NUMECF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9800 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VERE','--','' FROM DUAL
UNION ALL
SELECT 'VERE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VERE','99','Outros' FROM DUAL
);

/*-- SEQ 9801 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VERE',
       '01',
       60,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VERE.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VERE',
       '01',
       70,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       '',
       'Srie',
       'Cdigo da srie',
       'DSER.CODSER(+) = VERE.CODSER',
       'CODSER',
       'T' FROM DUAL
UNION ALL
SELECT 'VERE',
       '01',
       10,
       8,
       'DATOPE',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data da Operao',
       'Data da Operao',
       '',
       'DATOPE',
       '' FROM DUAL
UNION ALL
SELECT 'VERE',
       '01',
       20,
       50,
       'DESOUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Meio de Pagamento',
       'Meio de Pagamento',
       '',
       'DESOUT',
       '' FROM DUAL
UNION ALL
SELECT 'VERE',
       '01',
       50,
       3,
       'NUMECF',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       '',
       'Nmero do ECF',
       'Nmero do ECF',
       'DECF.FILECF = VERE.CODFIL AND DECF.NUMECF = VERE.NUMECF',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'VERE',
       '01',
       30,
       10,
       'NUMEXT',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nmero Externo',
       'Nmero Externo',
       '',
       'NUMEXT',
       '' FROM DUAL
UNION ALL
SELECT 'VERE',
       '99',
       90,
       1,
       'REC_EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Parcela Exportada?',
       'Parcela Exportada?',
       '',
       'REC_EXPORT',
       '' FROM DUAL
UNION ALL
SELECT 'VERE',
       '01',
       40,
       12,
       'VALPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor',
       'Valor',
       '',
       'VALPAR',
       '' FROM DUAL
UNION ALL
SELECT 'VERE',
       '99',
       80,
       1,
       'VEN_EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Venda Exportada?',
       'Venda Exportada?',
       '',
       'VEN_EXPORT',
       '' FROM DUAL
);

/*-- SEQ 9802 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VERM',
       TO_NUMBER(null),
       'VERM',
       'Min. Meios Pagamento',
       'TV_EREC_DESOUT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9803 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VERM','--','' FROM DUAL
UNION ALL
SELECT 'VERM','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VERM','99','Outros' FROM DUAL
);

/*-- SEQ 9804 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VERM',
       '01',
       10,
       8,
       'DATOPE',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data da Operao',
       'Data da Operao',
       '',
       'DESOUT',
       '' FROM DUAL
UNION ALL
SELECT 'VERM',
       '01',
       20,
       50,
       'DESOUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Meio de Pagamento',
       'Meio de Pagamento',
       '',
       'DESOUT',
       '' FROM DUAL
UNION ALL
SELECT 'VERM',
       '01',
       30,
       10,
       'NUMEXT',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nmero Externo',
       'Nmero Externo',
       '',
       'NUMEXT',
       '' FROM DUAL
UNION ALL
SELECT 'VERM',
       '01',
       40,
       12,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor',
       'Valor',
       '',
       'VLRPAR',
       '' FROM DUAL
);

/*-- SEQ 9805 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VEU ',
       TO_NUMBER(null),
       'VEU ',
       'Estrutura Contas Uso',
       'TV_ECT_USO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9806 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VEU ','--','' FROM DUAL
UNION ALL
SELECT 'VEU ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VEU ','99','Outros' FROM DUAL
);

/*-- SEQ 9807 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VEU ',
       '01',
       10,
       150,
       'LOCAL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Localizao',
       'Localizao
',
       '',
       'LOCAL',
       'F' FROM DUAL
);

/*-- SEQ 9808 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VEVR',
       TO_NUMBER(null),
       'VEVR',
       'Eventos Renegociao',
       'TV_EVE_REN',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9809 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VEVR','--','' FROM DUAL
UNION ALL
SELECT 'VEVR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VEVR','02','Datas' FROM DUAL
UNION ALL
SELECT 'VEVR','03','Valores' FROM DUAL
UNION ALL
SELECT 'VEVR','99','Outros' FROM DUAL
);

/*-- SEQ 9810 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VEVR',
       '01',
       10,
       10,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Chave Evento',
       'Chave Evento',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VEVR',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VEVR',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VEVR',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'USU.FILUSU(+) = VEVR.FILUSU and USU.CODUSU(+) = VEVR.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VEVR',
       '01',
       50,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VEVR',
       '02',
       60,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VEVR',
       '01',
       70,
       12,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Evento',
       'Descrio Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VEVR',
       '01',
       80,
       10,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Identificador Evento',
       'Identificador Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'VEVR',
       '01',
       90,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Cd. Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VEVR',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Cd. Filial Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VEVR',
       '01',
       110,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VEVR',
       '01',
       120,
       1,
       'MSGEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem Evento',
       'Mensagem Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VEVR',
       '01',
       130,
       1,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao Evento',
       'Situao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VEVR',
       '01',
       140,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo do Evento',
       'Tipo do Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VEVR',
       '03',
       150,
       14,
       'VLREVE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor das Parcelas',
       'Valor das Parcelas',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 9811 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VEXC',
       TO_NUMBER(null),
       'VEXC',
       'Estrutura e Conta',
       'TV_EXP',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9812 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VEXC','--','' FROM DUAL
UNION ALL
SELECT 'VEXC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VEXC','99','Outros' FROM DUAL
);

/*-- SEQ 9813 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5931,
       'CTA ',
       'VEXC',
       'N ',
       'N ',
       'VEXC',
       '',
       'VEXC.FILCTA = CTA.CODFIL
AND VEXC.SEQCTA = CTA.SEQUEN
AND VEXC.TIPCTA = CTA.TIPCTA',
       '' FROM DUAL
UNION ALL
SELECT 5932,
       'VECT',
       'VEXC',
       'N ',
       'N ',
       'VEXC',
       '',
       'VEXC.FILCTA = VECT.FILCTA
AND VEXC.SEQCTA = VECT.SEQCTA
AND VEXC.TIPCTA = VECT.TIPCTA',
       '' FROM DUAL
);

/*-- SEQ 9814 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VEXC',
       '01',
       2,
       80,
       'ESTRUTURA_E_CONTA',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Estrutura e Conta',
       'Estrutura e Conta',
       '',
       'ESTRUTURA_E_CONTA',
       '' FROM DUAL
UNION ALL
SELECT 'VEXC',
       '01',
       4,
       3,
       'FILCTA',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial da Conta',
       'Filial da Conta',
       'DFIL.CODFIL = VEXC.FILCTA',
       'FILCTA',
       '' FROM DUAL
UNION ALL
SELECT 'VEXC',
       '01',
       1,
       10,
       'NIVEL',
       'S',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Nvel',
       'Nvel',
       '',
       'NIVEL',
       '' FROM DUAL
UNION ALL
SELECT 'VEXC',
       '01',
       5,
       10,
       'SEQCTA',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Sequncia da Conta',
       'Sequncia da Conta',
       '',
       'SEQCTA',
       '' FROM DUAL
UNION ALL
SELECT 'VEXC',
       '01',
       6,
       1,
       'TIPCTA',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Tipo da Conta',
       'Tipo da Conta',
       '',
       'TIPCTA',
       '' FROM DUAL
UNION ALL
SELECT 'VEXC',
       '01',
       3,
       20,
       'TIPO',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Tipo',
       'Tipo',
       '',
       'TIPO',
       '' FROM DUAL
);

/*-- SEQ 9815 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VF60',
       TO_NUMBER(null),
       'VF60',
       'Fis. x 60',
       'TV_FIS_60',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VF60.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 9816 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VF60','--','' FROM DUAL
UNION ALL
SELECT 'VF60','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VF60','99','Outros' FROM DUAL
);

/*-- SEQ 9817 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VF60',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = VF60.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VF60',
       '01',
       20,
       7,
       'DATAOK',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ok',
       'Data OK',
       '',
       'DATAOK',
       'F' FROM DUAL
UNION ALL
SELECT 'VF60',
       '01',
       30,
       126,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
);

/*-- SEQ 9818 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VF74',
       TO_NUMBER(null),
       'VF74',
       'Fis. 74',
       'TV_FIS_74',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9819 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VF74','--','' FROM DUAL
UNION ALL
SELECT 'VF74','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VF74','99','Outros' FROM DUAL
);

/*-- SEQ 9820 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VF74',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VF74.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VF74',
       '01',
       20,
       126,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
);

/*-- SEQ 9821 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VF75',
       TO_NUMBER(null),
       'VF75',
       'Fis. 75',
       'TV_FIS_75',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VF75.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 9822 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VF75','--','' FROM DUAL
UNION ALL
SELECT 'VF75','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VF75','99','Outros' FROM DUAL
);

/*-- SEQ 9823 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VF75',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = VF75.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VF75',
       '01',
       20,
       7,
       'DATAOK',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ok',
       'Data OK',
       '',
       'DATAOK',
       'F' FROM DUAL
UNION ALL
SELECT 'VF75',
       '01',
       30,
       126,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
);

/*-- SEQ 9824 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFAT',
       TO_NUMBER(null),
       'VFAT',
       'Fat. Rem Dev. Fat',
       'TV_FAT_REM_DEVFAT_DAVREM',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9825 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFAT','--','' FROM DUAL
UNION ALL
SELECT 'VFAT','01','Identificação' FROM DUAL
UNION ALL
SELECT 'VFAT','99','Outros' FROM DUAL
);

/*-- SEQ 9826 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFAT',
       '01',
       10,
       3,
       'FILFAT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Faturamento',
       'Filial de Faturamento',
       'DFIL.FILFAT = VFAT.FILFAT',
       'FILFAT',
       '' FROM DUAL
);

/*-- SEQ 9827 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFAV',
       TO_NUMBER(null),
       'VFAV',
       'Favorecido',
       'TV_FAV',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VFAV.FILCLI, VFAV.CODCLI',
       '' FROM DUAL
);

/*-- SEQ 9828 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFAV','--','' FROM DUAL
UNION ALL
SELECT 'VFAV','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFAV','02','Vendedor'||CHR(92)||'Indicador' FROM DUAL
UNION ALL
SELECT 'VFAV','99','Outros' FROM DUAL
);

/*-- SEQ 9829 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 21031,
       'CMSR',
       'VFAV',
       'N',
       '1',
       '',
       '',
       'CMSR.FILCLI = VFAV.FILCLI AND
CMSR.CODCLI = VFAV.CODCLI',
       '',
       '' FROM DUAL
);

/*-- SEQ 9830 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFAV',
       '01',
       40,
       50,
       'APEUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'A',
       '',
       'Vendedor',
       'Vendedor',
       'VFAV.FILUSU = USU.FILUSU AND VFAV.CODUSU = USU.CODUSU',
       'APEUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VFAV',
       '02',
       70,
       15,
       'CHVMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Cdigo de Matrcula',
       'Cdigo de Matrcula',
       '',
       'CHVMAT',
       '' FROM DUAL
UNION ALL
SELECT 'VFAV',
       '02',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo',
       'Cdigo do Favorecido',
       '',
       'CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 'VFAV',
       '--',
       20,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       'Filial do Favorecido',
       '',
       'FILCLI',
       '' FROM DUAL
UNION ALL
SELECT 'VFAV',
       '02',
       50,
       50,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome Favorecido',
       'Nome do Favorecido',
       '',
       'NOMCLI',
       '' FROM DUAL
UNION ALL
SELECT 'VFAV',
       '01',
       30,
       1,
       'TIPFAV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo do Favorecido',
       'Tipo do Favorecido',
       '',
       'TIPFAV',
       'T' FROM DUAL
UNION ALL
SELECT 'VFAV',
       '01',
       60,
       30,
       'ULTNOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Sobrenome/Fantasia',
       'Sobrenome ou fantasia',
       '',
       'ULTNOM',
       '' FROM DUAL
);

/*-- SEQ 9831 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFAV',
       'TIPFAV',
       0,
       'C',
       'Vendedor/Indicador',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFAV',
       'TIPFAV',
       0,
       'I',
       'Indicador',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFAV',
       'TIPFAV',
       0,
       'V',
       'Vendedor',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9832 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFC ',
       TO_NUMBER(null),
       'VFC ',
       'Finan.Conta Corrente',
       'TV_FIN_CCC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VFC.CODFIL,VFC.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9833 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFC ','--','' FROM DUAL
UNION ALL
SELECT 'VFC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFC ','99','Outros' FROM DUAL
);

/*-- SEQ 9834 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFC ',
       '01',
       10,
       49,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFC ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFC ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VFC.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFC ',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Usurio',
       'Usurio que alterou o registro.',
       'VFC.FILUSU = USU.FILUSU(+)  AND VFC.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFC ',
       '01',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFC ',
       '01',
       60,
       1,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VFC ',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFC ',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFC ',
       '01',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFC ',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFC ',
       '01',
       110,
       5,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFC ',
       '01',
       230,
       1,
       'FLGFLX',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag de Fluxo?',
       'Flag de Fluxo',
       '',
       'FLGFLX',
       'F' FROM DUAL
UNION ALL
SELECT 'VFC ',
       '01',
       130,
       30,
       'MEIO_P',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Meio de Pagamento',
       'Meio de Pagamento',
       '',
       'MEIO_P',
       'F' FROM DUAL
UNION ALL
SELECT 'VFC ',
       '01',
       140,
       13,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Origem',
       'Nome de Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFC ',
       '01',
       150,
       1,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFC ',
       '01',
       160,
       100,
       'OBSERV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VFC ',
       '01',
       170,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFC ',
       '01',
       180,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFC ',
       '01',
       190,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFC ',
       '01',
       200,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Tabela de   Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFC ',
       '01',
       210,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFC ',
       '01',
       220,
       8,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Pagamento',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9835 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFC ',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFC ',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFC ',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9836 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFCH',
       TO_NUMBER(null),
       'VFCH',
       'Fin. X Cheq.Rec',
       'TV_FIN_CHR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VFCH.CODFIL,VFCH.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9837 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFCH','--','' FROM DUAL
UNION ALL
SELECT 'VFCH','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFCH','02','Datas' FROM DUAL
UNION ALL
SELECT 'VFCH','03','Valores' FROM DUAL
UNION ALL
SELECT 'VFCH','99','Outros' FROM DUAL
);

/*-- SEQ 9838 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFCH',
       '01',
       10,
       49,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCH',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCH',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VFCH.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCH',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Usurio',
       'Usurio que alterou o registro.',
       'VFCH.FILUSU = USU.FILUSU(+)  AND VFCH.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFCH',
       '02',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCH',
       '01',
       60,
       1,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCH',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCH',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCH',
       '01',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCH',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCH',
       '01',
       110,
       5,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCH',
       '01',
       120,
       1,
       'FLGFLX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Flag Fluxo',
       'Flag Fluxo',
       '',
       'FLGFLX',
       'T' FROM DUAL
UNION ALL
SELECT 'VFCH',
       '01',
       130,
       30,
       'MEIO_P',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Meio de Pagamento',
       'Meio de Pagamento',
       '',
       'MEIO_P',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCH',
       '01',
       140,
       13,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Origem',
       'Nome de Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCH',
       '01',
       150,
       1,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCH',
       '99',
       160,
       1,
       'OBSERV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCH',
       '99',
       170,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCH',
       '99',
       180,
       1,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCH',
       '01',
       190,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCH',
       '01',
       200,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Tabela de   Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCH',
       '01',
       210,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFCH',
       '03',
       220,
       8,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Pagamento',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9839 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFCH',
       'FLGFLX',
       0,
       'A',
       'Ativo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFCH',
       'FLGFLX',
       0,
       'D',
       'Desabilitado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFCH',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFCH',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFCH',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9840 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFCM',
       TO_NUMBER(null),
       'VFCM',
       'Finan./Compras',
       'TV_FIN_COM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'vfcm.codfil,vfcm.sequen',
       '' FROM DUAL
);

/*-- SEQ 9841 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFCM','--','' FROM DUAL
UNION ALL
SELECT 'VFCM','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFCM','02','Datas' FROM DUAL
UNION ALL
SELECT 'VFCM','03','Valores' FROM DUAL
UNION ALL
SELECT 'VFCM','99','Outros' FROM DUAL
);

/*-- SEQ 9842 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFCM',
       '01',
       10,
       13,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCM',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCM',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VFCM.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCM',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Usurio',
       'Usurio que alterou o registro.',
       'VFCM.FILUSU = USU.FILUSU(+)  AND VFCM.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFCM',
       '02',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCM',
       '01',
       220,
       15,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCM',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCM',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCM',
       '01',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCM',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCM',
       '99',
       110,
       10,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCM',
       '99',
       120,
       1,
       'FLGFLX',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag de Fluxo?',
       'Flag de Fluxo',
       '',
       'FLGFLX',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCM',
       '01',
       130,
       7,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Origem',
       'Nome de Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCM',
       '01',
       140,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCM',
       '99',
       230,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCM',
       '99',
       160,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCM',
       '99',
       170,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCM',
       '01',
       180,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCM',
       '01',
       190,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Tabela de   Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCM',
       '01',
       200,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFCM',
       '03',
       210,
       8,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Pagamento',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9843 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFCM',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFCM',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFCM',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9844 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFCP',
       TO_NUMBER(null),
       'VFCP',
       'LMC principal',
       'TV_LMC_FCP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9845 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFCP','--','' FROM DUAL
UNION ALL
SELECT 'VFCP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFCP','99','Outros' FROM DUAL
);

/*-- SEQ 9846 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFCP',
       '--',
       10,
       10,
       'APELEI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Apelido Usu.Leitura',
       'Apelido Usurio que fez a Leitura',
       '',
       'APELEI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCP',
       '--',
       20,
       10,
       'APEREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Apelido Usu.Registro',
       'Apelido Usurio que fez o Registro',
       '',
       'APEREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCP',
       '--',
       30,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Diviso do produto',
       'DIV.CODITE = VFCP.CODCOR(+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'VFCP',
       '--',
       40,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = VFCP.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'VFCP',
       '--',
       50,
       3,
       'CODLEI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Usu. Leitura',
       'Cdigo Usu. Leitura',
       '',
       'CODLEI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCP',
       '--',
       60,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo~Material',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCP',
       '--',
       70,
       3,
       'CODREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd. Usu. Registro',
       'Cdigo Usurio Registro',
       '',
       'CODREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCP',
       '--',
       80,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'SUB.CODITE = VFCP.CODTAM(+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'VFCP',
       '--',
       90,
       7,
       'DATFEC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fechamento',
       'Data Fechamento',
       '',
       'DATFEC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCP',
       '--',
       100,
       7,
       'DATMED',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Medio',
       'Data Medio',
       '',
       'DATMED',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCP',
       '--',
       110,
       7,
       'DATREG',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Registro',
       'Data Registro',
       '',
       'DATREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCP',
       '--',
       120,
       3,
       'FILLEI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial~Leitura',
       'Filial Usurio da Leitura',
       '',
       'FILLEI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCP',
       '--',
       130,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial Material',
       'Filial do material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCP',
       '--',
       140,
       3,
       'FILREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Usu. Registro',
       'Filial Usurio Registro',
       '',
       'FILREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCP',
       '--',
       150,
       3,
       'FILTAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Med.Tanque',
       'Filial Med.Tanque',
       '',
       'FILTAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCP',
       '--',
       160,
       30,
       'NOMLEI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Usurio Leitura',
       'Usurio Leitura',
       '',
       'NOMLEI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCP',
       '--',
       170,
       30,
       'NOMREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Usurio Registro',
       'Usurio Registro',
       '',
       'NOMREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCP',
       '--',
       180,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCP',
       '--',
       190,
       2,
       'TANQUE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero do tanque',
       'Nmero do tanque',
       '',
       'TANQUE',
       'F' FROM DUAL
UNION ALL
SELECT 'VFCP',
       '--',
       200,
       10,
       'VLRENC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Encerrante',
       'Valor Encerrante',
       '',
       'VLRENC',
       'F' FROM DUAL
);

/*-- SEQ 9847 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFD ',
       TO_NUMBER(null),
       'VFD ',
       'Fin. X Doc PGTO',
       'TV_FIN_DOP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VFD.CODFIL,VFD.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9848 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFD ','--','' FROM DUAL
UNION ALL
SELECT 'VFD ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFD ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VFD ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VFD ','99','Outros' FROM DUAL
);

/*-- SEQ 9849 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFD ',
       '99',
       10,
       49,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFD ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFD ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VFD.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFD ',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Usurio',
       'Usurio que alterou o registro.',
       'VFD.FILUSU = USU.FILUSU(+)  AND VFD.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFD ',
       '02',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFD ',
       '01',
       60,
       1,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VFD ',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFD ',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFD ',
       '01',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFD ',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VFD ',
       '99',
       110,
       5,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFD ',
       '99',
       120,
       1,
       'FLGFLX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Flag Fluxo',
       'Flag Fluxo',
       '',
       'FLGFLX',
       'T' FROM DUAL
UNION ALL
SELECT 'VFD ',
       '01',
       130,
       13,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Origem',
       'Nome de Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFD ',
       '01',
       140,
       1,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFD ',
       '99',
       150,
       1,
       'OBSERV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VFD ',
       '99',
       160,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFD ',
       '99',
       170,
       1,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFD ',
       '01',
       180,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFD ',
       '01',
       190,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Tabela de   Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFD ',
       '01',
       200,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tabela de   Origem',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFD ',
       '03',
       210,
       8,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Pagamento',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9850 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFD ',
       'FLGFLX',
       0,
       'A',
       'Ativo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFD ',
       'FLGFLX',
       0,
       'D',
       'Desabilitado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFD ',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFD ',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFD ',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9851 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFFG',
       TO_NUMBER(null),
       'VFFG',
       'Fin. x F.G.',
       'TV_FIN_F_G',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VFFG.CODFIL,VFFG.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9852 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFFG','--','' FROM DUAL
UNION ALL
SELECT 'VFFG','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFFG','02','Datas' FROM DUAL
UNION ALL
SELECT 'VFFG','03','Valores' FROM DUAL
UNION ALL
SELECT 'VFFG','99','Outros' FROM DUAL
);

/*-- SEQ 9853 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFFG',
       '01',
       10,
       13,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFG',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFG',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VFFG.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFG',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Usurio',
       'Usurio que alterou o registro.',
       'VFFG.FILUSU = USU.FILUSU(+)  AND VFFG.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFFG',
       '02',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFG',
       '01',
       60,
       20,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFG',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFG',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFG',
       '01',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFG',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFG',
       '01',
       110,
       4,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFG',
       '99',
       220,
       1,
       'FLGFLX',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag de Fluxo?',
       'Flag de Fluxo',
       '',
       'FLGFLX',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFG',
       '01',
       130,
       20,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Origem',
       'Nome de Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFG',
       '01',
       140,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFG',
       '99',
       150,
       1,
       'OBSERV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Observao?',
       'Observao?',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFG',
       '99',
       160,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFG',
       '99',
       170,
       1,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFG',
       '01',
       180,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFG',
       '01',
       190,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Tabela de   Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFG',
       '01',
       200,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFFG',
       '03',
       210,
       8,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Pagamento',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9854 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFFG',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFFG',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFFG',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9855 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFFN',
       TO_NUMBER(null),
       'VFFN',
       'Fin. x  F. N.',
       'TV_FIN_F_N',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VFFN.CODFIL,VFFN.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9856 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFFN','--','' FROM DUAL
UNION ALL
SELECT 'VFFN','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFFN','99','Outros' FROM DUAL
);

/*-- SEQ 9857 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFFN',
       '--',
       10,
       13,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFN',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFN',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VFFN.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFN',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Usurio',
       'Usurio que alterou o registro.',
       'VFFN.FILUSU = USU.FILUSU(+)  AND VFFN.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFFN',
       '--',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFN',
       '--',
       60,
       20,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFN',
       '--',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFN',
       '--',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFN',
       '--',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFN',
       '--',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFN',
       '--',
       110,
       4,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFN',
       '--',
       120,
       1,
       'FLGFLX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Flag Fluxo',
       'Flag Fluxo',
       '',
       'FLGFLX',
       'T' FROM DUAL
UNION ALL
SELECT 'VFFN',
       '--',
       130,
       20,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Origem',
       'Nome de Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFN',
       '--',
       140,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFN',
       '--',
       150,
       255,
       'OBSERV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFN',
       '--',
       160,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFN',
       '--',
       220,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFN',
       '--',
       180,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFN',
       '--',
       190,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Tabela de   Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFFN',
       '--',
       200,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFFN',
       '--',
       210,
       8,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Pagamento',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9858 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFFN',
       'FLGFLX',
       0,
       'A',
       'Em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFFN',
       'FLGFLX',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFFN',
       'FLGFLX',
       0,
       'R',
       'Realizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFFN',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFFN',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFFN',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9859 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFG ',
       TO_NUMBER(null),
       'VFG ',
       'Fin. x Ger.',
       'TV_FIN_GER',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VFG.CODFIL,VFG.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9860 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFG ','--','' FROM DUAL
UNION ALL
SELECT 'VFG ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFG ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VFG ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VFG ','99','Outros' FROM DUAL
);

/*-- SEQ 9861 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5933,
       'CTA ',
       'VFG ',
       '1 ',
       'N ',
       '',
       '',
       'VFG.FILCTA = CTA.CODFIL AND
VFG.SEQCTA = CTA.SEQUEN AND
VFG.TIPCTA = CTA.TIPCTA',
       '' FROM DUAL
UNION ALL
SELECT 5934,
       'CLI ',
       'VFG ',
       '01',
       '1 ',
       '',
       '',
       'VFG.FILCLI = CLI.FILCLI(+) AND VFG.CODCLI = CLI.CODCLI(+)',
       '' FROM DUAL
);

/*-- SEQ 9862 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFG ',
       '01',
       10,
       17,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFG ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFG ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VFG.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFG ',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Usurio que alterou o registro.',
       'VFG.FILUSU = USU.FILUSU(+)  AND VFG.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFG ',
       '01',
       230,
       255,
       'COMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Complemento',
       'Complemento',
       '',
       'COMPLE',
       'F' FROM DUAL
UNION ALL
SELECT 'VFG ',
       '02',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFG ',
       '01',
       60,
       20,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VFG ',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFG ',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFG ',
       '01',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial~Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFG ',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VFG ',
       '01',
       240,
       14,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao Lanamento',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFG ',
       '99',
       120,
       1,
       'FLGFLX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Estado ',
       'Estado ',
       '',
       'FLGFLX',
       'T' FROM DUAL
UNION ALL
SELECT 'VFG ',
       '01',
       130,
       20,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Origem',
       'Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFG ',
       '01',
       140,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFG ',
       '99',
       150,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VFG ',
       '99',
       160,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFG ',
       '01',
       220,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFG ',
       '01',
       180,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFG ',
       '01',
       190,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Tabela de   Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFG ',
       '01',
       200,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFG ',
       '03',
       210,
       12,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr. Pagamento',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9863 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFG ',
       'FLGFLX',
       0,
       'A',
       'A Realizar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFG ',
       'FLGFLX',
       0,
       'R',
       'Realizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFG ',
       'NOMORI',
       0,
       ' ',
       'Cheques',
       TO_NUMBER(null),
       'Cheques ' FROM DUAL
UNION ALL
SELECT 'VFG ',
       'NOMORI',
       0,
       ' ',
       'Compras',
       TO_NUMBER(null),
       'Compras ' FROM DUAL
UNION ALL
SELECT 'VFG ',
       'NOMORI',
       0,
       ' ',
       'Conta Corrente',
       TO_NUMBER(null),
       'Conta Corrente' FROM DUAL
UNION ALL
SELECT 'VFG ',
       'NOMORI',
       0,
       ' ',
       'Doc. de Pagamento',
       TO_NUMBER(null),
       'Doc. de Pagamento ' FROM DUAL
UNION ALL
SELECT 'VFG ',
       'NOMORI',
       0,
       ' ',
       'Limite de C/C',
       TO_NUMBER(null),
       'Limite de C/C' FROM DUAL
UNION ALL
SELECT 'VFG ',
       'NOMORI',
       0,
       ' ',
       'Parc. Ttulos Receber',
       TO_NUMBER(null),
       'Parc. Ttulos Receber' FROM DUAL
UNION ALL
SELECT 'VFG ',
       'NOMORI',
       0,
       ' ',
       'Recebimentos',
       TO_NUMBER(null),
       'Recebimentos' FROM DUAL
UNION ALL
SELECT 'VFG ',
       'NOMORI',
       0,
       ' ',
       'Ttulos a Receber',
       TO_NUMBER(null),
       'Ttulos a Receber' FROM DUAL
UNION ALL
SELECT 'VFG ',
       'NOMORI',
       0,
       ' ',
       'Vendas',
       TO_NUMBER(null),
       'Vendas' FROM DUAL
UNION ALL
SELECT 'VFG ',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFG ',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFG ',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9864 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFID',
       TO_NUMBER(null),
       'VFID',
       'Falha de IDs',
       'TV_FID',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'vfid.codfil,vfid.numecf',
       '' FROM DUAL
);

/*-- SEQ 9865 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFID','--','' FROM DUAL
UNION ALL
SELECT 'VFID','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFID','99','Outros' FROM DUAL
);

/*-- SEQ 9866 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFID',
       '01',
       10,
       12,
       'ATE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'At',
       'At',
       '',
       'ATE',
       'F' FROM DUAL
UNION ALL
SELECT 'VFID',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Codigo da Filial',
       'DFIL.CODFIL (+) = VFID.CODFIL',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'VFID',
       '01',
       30,
       12,
       'DE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'De',
       'De',
       '',
       'DE',
       'F' FROM DUAL
UNION ALL
SELECT 'VFID',
       '01',
       40,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'ECF',
       'Nmero do ECF',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'VFID',
       '01',
       50,
       7,
       'ULTTRN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Ultima Transao',
       'Ultima Transao',
       '',
       'ULTTRN',
       'F' FROM DUAL
);

/*-- SEQ 9867 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFIN',
       TO_NUMBER(null),
       'VFIN',
       'Lanamen Financeiros',
       'TV_FIN',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VFIN.CODFIL,VFIN.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9868 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFIN','--','' FROM DUAL
UNION ALL
SELECT 'VFIN','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFIN','02','Datas' FROM DUAL
UNION ALL
SELECT 'VFIN','03','Valores' FROM DUAL
UNION ALL
SELECT 'VFIN','99','Outros' FROM DUAL
);

/*-- SEQ 9869 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22303,
       'ARQ ',
       'VFIN',
       '01',
       '1',
       '',
       '',
       'VFIN.TABORI=ARQ.CODTAB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21173,
       'CTA ',
       'VFIN',
       '1',
       'N',
       '',
       '',
       'VFIN.FILCTA = CTA.CODFIL AND
VFIN.SEQCTA = CTA.SEQUEN AND
VFIN.TIPCTA = CTA.TIPCTA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21174,
       'USU ',
       'VFIN',
       '01',
       '0N',
       '',
       '',
       'usu.filusu = vfin.filusu and
usu.codusu = vfin.codusu',
       '',
       '' FROM DUAL
UNION ALL
SELECT 21175,
       'CLI ',
       'VFIN',
       '01',
       '0N',
       '',
       '',
       'CLI.FILCLI = VFIN.FILCLI AND
CLI.CODCLI = VFIN.CODCLI',
       '',
       '' FROM DUAL
);

/*-- SEQ 9870 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFIN',
       '02',
       230,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Atualizao',
       'Data da Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '01',
       10,
       49,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = VFIN.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'N',
       'F',
       'Usurio',
       'Cdigo Usurio',
       'USU.FILUSU(+) = VFIN.FILUSU AND USU.CODUSU(+) = VFIN.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '01',
       220,
       255,
       'COMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Complemento',
       'Complemento',
       '',
       'COMPLE',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '02',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data Operao',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '01',
       60,
       27,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '99',
       300,
       1,
       'ESTORN',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       '',
       'Estorno?',
       '',
       'ESTORN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '01',
       240,
       3,
       'FILCRT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Contrapartida',
       '',
       'FILCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Conta Corrente',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '01',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '99',
       110,
       30,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '99',
       120,
       1,
       'FLGFLX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Status Fluxo',
       'Status Fluxo',
       '',
       'FLGFLX',
       'T' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '01',
       310,
       1,
       'ID_OPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       '',
       'Id da Operao',
       '',
       'ID_OPE',
       'T' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '99',
       250,
       64,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Cliente',
       'Nome do Cliente',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '99',
       130,
       21,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Origem',
       'Nome Tabela de Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '01',
       140,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Parcela',
       'Numero Parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '99',
       150,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '01',
       320,
       10,
       'RFIN_CODTAB',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Cdigo do Lanamento',
       '',
       'RFIN_CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '01',
       260,
       10,
       'SEQCRT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Sequenciador Contrapartida',
       '',
       'SEQCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '01',
       160,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Sequenciador Conta Corrente',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '01',
       170,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '03',
       180,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub-Parcela',
       'Sub Parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '99',
       190,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Tabela de Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '01',
       270,
       1,
       'TIPCRT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Tipo Contrapartida',
       '',
       'TIPCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '99',
       200,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta Corrrente',
       'Tipo Conta Corrente',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '01',
       280,
       3,
       'TIPLAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo de Lanamento',
       'Tipo de Lanamento',
       '',
       'TIPLAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '01',
       330,
       1,
       'TIPOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo da Operao',
       'Tipo da Operao',
       '',
       'TIPOPE',
       'T' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '01',
       350,
       250,
       'TITCRT',
       'A',
       'CTA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'CTA.TITCTA',
       'V',
       '',
       '',
       'A',
       '',
       'Contrapartida',
       'Conta Contrapartida',
       'CTA.CODFIL = VFIN.FILCRT AND CTA.SEQUEN = VFIN.SEQCRT AND CTA.TIPCTA = VFIN.TIPCRT',
       'TITCRT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '01',
       340,
       250,
       'TITCTA',
       'A',
       'CTA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'CTA.TITCTA',
       'V',
       '',
       '',
       'A',
       '',
       'Conta',
       'Conta',
       'CTA.CODFIL = VFIN.FILCTA AND CTA.SEQUEN = VFIN.SEQCTA AND CTA.TIPCTA = VFIN.TIPCTA',
       'TITCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '99',
       290,
       30,
       'ULTNOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sobrenome/Fantasia',
       'Sobrenome/Fantasia',
       '',
       'ULTNOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIN',
       '03',
       210,
       12,
       'VLRPGT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Operao',
       'Valor Operaco',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9871 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFIN',
       'FLGFLX',
       0,
       'A',
       'A Realizar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFIN',
       'FLGFLX',
       0,
       'R',
       'Realizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFIN',
       'ID_OPE',
       0,
       'C',
       'Contra-lanamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFIN',
       'ID_OPE',
       0,
       'L',
       'Lanamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFIN',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFIN',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFIN',
       'TIPCTA',
       0,
       'N',
       'Destopia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFIN',
       'TIPOPE',
       0,
       'C',
       'Crdito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFIN',
       'TIPOPE',
       0,
       'D',
       'Dbito',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9872 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFIS',
       TO_NUMBER(null),
       'VFIS',
       'Tabela Fiscal Serie',
       'TV_FIS_CODSER',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'FIS.ORIGEM,FIS.CODSER,FIS.SUBSER',
       '' FROM DUAL
);

/*-- SEQ 9873 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFIS','--','' FROM DUAL
UNION ALL
SELECT 'VFIS','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFIS','99','Outros' FROM DUAL
);

/*-- SEQ 9874 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFIS',
       '01',
       10,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Srie',
       'Cdigo Srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIS',
       '--',
       30,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exportar?',
       'Exportar?',
       '',
       'EXPORT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIS',
       '01',
       30,
       2,
       'MODNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mod.~Nota',
       'Mod.~Nota',
       '',
       'MODNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIS',
       '01',
       40,
       25,
       'NOMSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Srie',
       'Descrio Srie',
       '',
       'NOMSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIS',
       '01',
       50,
       30,
       'ORIGEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Origem',
       'Origem',
       '',
       'ORIGEM',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIS',
       '01',
       90,
       1,
       'SERATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Srie Ativa?',
       'Srie Ativa?',
       '',
       'SERATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIS',
       '01',
       60,
       3,
       'SEREXP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie~como',
       'Srie~como',
       '',
       'SEREXP',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIS',
       '01',
       70,
       2,
       'SUBEXP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'SubSrie~como',
       'SubSrie~como',
       '',
       'SUBEXP',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIS',
       '01',
       80,
       3,
       'SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Sub-Srie',
       'Sub-Srie de compra',
       '',
       'SUBSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VFIS',
       '01',
       20,
       3,
       'SUBSER_FIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SUBSER_FIS',
       'F' FROM DUAL
);

/*-- SEQ 9875 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFJ ',
       TO_NUMBER(null),
       'VFJ ',
       'Fin. x JDF',
       'TV_FIN_JDP',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VFJ.CODFIL,VFJ.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9876 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFJ ','--','' FROM DUAL
UNION ALL
SELECT 'VFJ ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFJ ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VFJ ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VFJ ','99','Outros' FROM DUAL
);

/*-- SEQ 9877 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFJ ',
       '01',
       10,
       13,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJ ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJ ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VFJ.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJ ',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Usurio',
       'Usurio que alterou o registro.',
       'VFJ.FILUSU = USU.FILUSU(+)  AND VFJ.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFJ ',
       '02',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJ ',
       '01',
       60,
       15,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJ ',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJ ',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJ ',
       '01',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJ ',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJ ',
       '01',
       220,
       10,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJ ',
       '99',
       120,
       1,
       'FLGFLX',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag de Fluxo?',
       'Flag de Fluxo',
       '',
       'FLGFLX',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJ ',
       '01',
       130,
       15,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Origem',
       'Nome de Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJ ',
       '01',
       140,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJ ',
       '99',
       150,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJ ',
       '99',
       160,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJ ',
       '99',
       170,
       1,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJ ',
       '01',
       180,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJ ',
       '01',
       190,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Tabela de   Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJ ',
       '01',
       200,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFJ ',
       '03',
       210,
       12,
       'VLRPGT',
       'S',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Pagamento',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9878 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFJ ',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFJ ',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFJ ',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9879 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFJD',
       TO_NUMBER(null),
       'VFJD',
       'Fin. x JDR',
       'TV_FIN_JDR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VFJD.CODFIL,VFJD.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9880 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFJD','--','' FROM DUAL
UNION ALL
SELECT 'VFJD','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFJD','02','Datas' FROM DUAL
UNION ALL
SELECT 'VFJD','03','Valores' FROM DUAL
UNION ALL
SELECT 'VFJD','99','Outros' FROM DUAL
);

/*-- SEQ 9881 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFJD',
       '01',
       10,
       13,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJD',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJD',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VFJD.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJD',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Usurio',
       'Usurio que alterou o registro.',
       'VFJD.FILUSU = USU.FILUSU(+)  AND VFJD.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFJD',
       '02',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJD',
       '01',
       60,
       20,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJD',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJD',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJD',
       '01',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJD',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJD',
       '99',
       110,
       10,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJD',
       '99',
       120,
       1,
       'FLGFLX',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag Fluxo?',
       'Flag Fluxo',
       '',
       'FLGFLX',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJD',
       '01',
       130,
       16,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Origem',
       'Nome de Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJD',
       '01',
       140,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJD',
       '99',
       150,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJD',
       '99',
       160,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJD',
       '99',
       170,
       1,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJD',
       '01',
       180,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJD',
       '01',
       190,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Tabela de   Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJD',
       '01',
       200,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFJD',
       '03',
       210,
       12,
       'VLRPGT',
       'S',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Pagamento',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9882 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFJD',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFJD',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFJD',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9883 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFJT',
       TO_NUMBER(null),
       'VFJT',
       'Fin. x JDT',
       'TV_FIN_JDT',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VFJT.CODFIL,VFJT.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9884 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFJT','--','' FROM DUAL
UNION ALL
SELECT 'VFJT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFJT','02','Datas' FROM DUAL
UNION ALL
SELECT 'VFJT','03','Valores' FROM DUAL
UNION ALL
SELECT 'VFJT','99','Outros' FROM DUAL
);

/*-- SEQ 9885 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFJT',
       '01',
       10,
       13,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJT',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJT',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VFJT.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJT',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Usurio',
       'Usurio que alterou o registro.',
       'VFJT.FILUSU = USU.FILUSU(+)  AND VFJT.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFJT',
       '02',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJT',
       '01',
       60,
       11,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJT',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJT',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJT',
       '01',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJT',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJT',
       '99',
       110,
       4,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJT',
       '99',
       220,
       1,
       'FLGFLX',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag Fluxo?',
       'Flag Fluxo?',
       '',
       'FLGFLX',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJT',
       '01',
       130,
       16,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Origem',
       'Nome de Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJT',
       '01',
       140,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJT',
       '99',
       150,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJT',
       '99',
       160,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJT',
       '99',
       170,
       1,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJT',
       '01',
       180,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJT',
       '01',
       190,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Tabela de   Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFJT',
       '01',
       200,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFJT',
       '03',
       210,
       12,
       'VLRPGT',
       'S',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Pagamento',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9886 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFJT',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFJT',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFJT',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9887 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFL ',
       TO_NUMBER(null),
       'VFL ',
       'Limite Financeiro',
       'TV_FIN_LIM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VFL.CODFIL,VFL.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9888 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFL ','--','' FROM DUAL
UNION ALL
SELECT 'VFL ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFL ','99','Outros' FROM DUAL
);

/*-- SEQ 9889 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFL ',
       '01',
       10,
       49,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFL ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFL ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VFL.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFL ',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Usurio',
       'Usurio que alterou o registro.',
       'VFL.FILUSU = USU.FILUSU(+)  AND VFL.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFL ',
       '01',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFL ',
       '01',
       60,
       1,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VFL ',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFL ',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFL ',
       '01',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFL ',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VFL ',
       '01',
       110,
       5,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFL ',
       '01',
       120,
       1,
       'FLGFLX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Flag Fluxo',
       'Flag Fluxo',
       '',
       'FLGFLX',
       'T' FROM DUAL
UNION ALL
SELECT 'VFL ',
       '01',
       130,
       30,
       'MEIO_P',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Meio de Pagamento',
       'Meio de Pagamento',
       '',
       'MEIO_P',
       'F' FROM DUAL
UNION ALL
SELECT 'VFL ',
       '01',
       140,
       13,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Origem',
       'Nome de Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFL ',
       '01',
       150,
       1,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFL ',
       '01',
       160,
       1,
       'OBSERV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VFL ',
       '01',
       170,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFL ',
       '01',
       180,
       1,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFL ',
       '01',
       190,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFL ',
       '01',
       200,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Tabela de   Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFL ',
       '01',
       210,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFL ',
       '01',
       220,
       8,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Pagamento',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9890 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFL ',
       'FLGFLX',
       0,
       'A',
       'Ativo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFL ',
       'FLGFLX',
       0,
       'D',
       'Desabilitado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFL ',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFL ',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFL ',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9891 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFN ',
       TO_NUMBER(null),
       'VFN ',
       'Fin. x Num.',
       'TV_FIN_NUM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VFIN.CODFIL,VFIN.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9892 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFN ','--','' FROM DUAL
UNION ALL
SELECT 'VFN ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFN ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VFN ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VFN ','99','Outros' FROM DUAL
);

/*-- SEQ 9893 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFN ',
       '01',
       10,
       49,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFN ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFN ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VFN.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFN ',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Usurio',
       'Usurio que alterou o registro.',
       'VFN.FILUSU = USU.FILUSU(+)  AND VFN.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFN ',
       '02',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFN ',
       '01',
       60,
       27,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VFN ',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFN ',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFN ',
       '01',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFN ',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VFN ',
       '99',
       220,
       30,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFN ',
       '99',
       120,
       1,
       'FLGFLX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Flag Fluxo',
       'Flag Fluxo',
       '',
       'FLGFLX',
       'T' FROM DUAL
UNION ALL
SELECT 'VFN ',
       '01',
       130,
       21,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Origem',
       'Nome de Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFN ',
       '01',
       140,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFN ',
       '99',
       150,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VFN ',
       '99',
       160,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFN ',
       '99',
       170,
       1,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFN ',
       '01',
       180,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFN ',
       '01',
       190,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Tabela de   Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFN ',
       '01',
       200,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFN ',
       '03',
       210,
       12,
       'VLRPGT',
       'S',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Pagamento',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9894 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFN ',
       'FLGFLX',
       0,
       'A',
       'Em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFN ',
       'FLGFLX',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFN ',
       'FLGFLX',
       0,
       'R',
       'Realizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFN ',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFN ',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFN ',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9895 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFOR',
       0,
       'VFOR',
       'Fornecedores',
       'TV_FOR',
       'T',
       '',
       'TOTALL',
       'Provedores',
       '',
       '',
       '',
       '',
       'F',
       '',
       'VFOR.FILCLI,VFOR.CODCLI
VFOR.NOMCLI,VFOR.ULTNOM
VFOR.NUMDOC
',
       '' FROM DUAL
);

/*-- SEQ 9896 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFOR','--','' FROM DUAL
UNION ALL
SELECT 'VFOR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFOR','02','Endereo' FROM DUAL
UNION ALL
SELECT 'VFOR','03','Documentao' FROM DUAL
UNION ALL
SELECT 'VFOR','04','Dados Financeiros' FROM DUAL
UNION ALL
SELECT 'VFOR','99','Outros' FROM DUAL
);

/*-- SEQ 9897 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 32722,
       'EDE ',
       'VFOR',
       'N',
       '1',
       '',
       '',
       'EDE.FILCLI = VFOR.FILCLI AND
EDE.CODCLI = VFOR.CODCLI
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 32723,
       'PXF ',
       'VFOR',
       '0N',
       '1',
       '',
       '',
       'VFOR.FILPAR = PXF.FILFOR AND
VFOR.CODPAR = PXF.CODFOR AND
VFOR.TIPPAR = PXF.TIPFOR
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 32724,
       'COM ',
       'VFOR',
       'N',
       '1',
       '',
       '',
       'COM.FILFOR = VFOR.FILCLI AND
COM.CODFOR = VFOR.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 32725,
       'SPC ',
       'VFOR',
       '01',
       '01',
       '',
       'VFOR.FLGTIP = 1',
       'SPC.FILCLI = VFOR.FILCLI (+) and
SPC.CODCLI = VFOR.CODCLI (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 32726,
       'VCOM',
       'VFOR',
       'N',
       '1',
       '',
       '',
       'VCOM.FILFOR = VFOR.FILCLI AND
VCOM.CODFOR = VFOR.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 32721,
       'CON ',
       'VFOR',
       '0N',
       '01',
       '',
       '',
       'CON.FILCLI = VFOR.FILCLI (+)  and
CON.CODCLI = VFOR.CODCLI (+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 9898 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFOR',
       '01',
       230,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(VFOR.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '99',
       430,
       4,
       'ANO_DATA01',
       'A',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 1',
       '',
       'TO_CHAR(VFOR.DATA01,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '99',
       460,
       4,
       'ANO_DATA02',
       'A',
       '',
       0,
       0,
       'PVD ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 2',
       '',
       'TO_CHAR(VFOR.DATA02,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '99',
       490,
       4,
       'ANO_DATA03',
       'A',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 3',
       '',
       'TO_CHAR(VFOR.DATA03,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       260,
       4,
       'ANO_DATNAS',
       'A',
       '',
       0,
       0,
       'PVD ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ano de Nascto/Funda',
       'Ano de Data de nascimento',
       '',
       'TO_CHAR(VFOR.DATNAS,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       290,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       0,
       'PVD ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ano de Data Incluso',
       'Ano de Data de operao (cadastramento)',
       '',
       'TO_CHAR(VFOR.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '99',
       521,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN VFOR.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       540,
       1,
       'ATUCUS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Atualiza Custos?',
       'Atualiza Custos?',
       '',
       'ATUCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       210,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '99',
       380,
       2,
       'CATEG1',
       'S',
       'DCT1',
       0,
       20,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'V',
       'PVD',
       'F',
       'A',
       'T',
       '',
       'Categoria - 1',
       'VFOR.CATEG1=DCT1.CODTAB (+)',
       'CATEG1',
       'T' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '99',
       390,
       2,
       'CATEG2',
       'S',
       'DCT2',
       0,
       21,
       'PVD ',
       20,
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'V',
       'PVD',
       'F',
       'A',
       'T',
       '',
       'Categoria - 2',
       'VFOR.CATEG2=DCT2.CODTAB (+)',
       'CATEG2',
       'T' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '99',
       400,
       2,
       'CATEG3',
       'S',
       'DCT3',
       0,
       22,
       'PVD ',
       30,
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'V',
       'PVD',
       'F',
       'A',
       'T',
       'TIPO',
       'Categoria - 3',
       'VFOR.CATEG3=DCT3.CODTAB (+)',
       'CATEG3',
       'T' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       180,
       9,
       'CHAVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Fil.+Cod.~Fornecedor',
       'Cdigo do fornecedor',
       '',
       'FILCLI||VFOR.CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       170,
       6,
       'CODCLI',
       'A',
       '',
       0,
       0,
       'PVD ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'T',
       '9',
       'T',
       'Cdigo',
       'Cdigo do fornecedor',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       20,
       6,
       'CODPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Parceiro',
       'Cdigo Parceiro',
       '',
       'CODPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       80,
       3,
       'CODPLA',
       'A',
       'PLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Plano padro',
       'Cdigo do plano padro',
       'VFOR.FILPLA=PLA.FILPGT (+) AND  VFOR.CODPLA=PLA.CODPGT  (+)',
       'CODPLA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       60,
       2,
       'CODSEX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Sexo',
       'Cdigo de Sexo do Cliente',
       '',
       'CODSEX',
       'T' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       150,
       3,
       'CODVEN',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Vendedor Padro',
       'Vendedor Padro',
       'VFOR.FILVEN=USU.FILUSU(+) AND VFOR.CODVEN=USU.CODUSU(+)',
       'CODVEN',
       'T' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       110,
       44,
       'CONJUG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cnjuge ou Contato',
       'Nome do Cnjuge ou do  Contato principal',
       '',
       'CONJUG',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '99',
       410,
       8,
       'DATA01',
       'D',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       '',
       'Data livre - 1',
       '',
       'DATA01',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '99',
       440,
       8,
       'DATA02',
       'D',
       '',
       0,
       0,
       'PVD ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       '',
       'Data livre - 2',
       '',
       'DATA02',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '99',
       470,
       8,
       'DATA03',
       'D',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       '',
       'Data livre - 3',
       '',
       'DATA03',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       240,
       8,
       'DATNAS',
       'D',
       '',
       0,
       0,
       'PVD ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       'Nascto/Fundao',
       'Data de nascimento',
       '',
       'DATNAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       270,
       8,
       'DATOPE',
       'D',
       '',
       0,
       0,
       'PVD ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       'Data Incluso',
       'Data de operao (cadastramento)',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '03',
       40,
       15,
       'DOCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Doc. Cnjuge/Contato',
       'Doc. Cnjuge/Contato',
       '',
       'DOCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       50,
       2,
       'ESTCIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Estado Civil',
       'Estado Civil',
       '',
       'ESTCIV',
       'T' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       160,
       3,
       'FILCLI',
       'A',
       '',
       0,
       0,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'N',
       'T',
       'Filial do Fornecedor',
       'Filial onde foi cadastrado o fornecedor',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       10,
       3,
       'FILPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Rel.Parceiro',
       'Filial relao com Parceiro',
       '',
       'FILPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       70,
       3,
       'FILPLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial Plano Padro',
       'Filial Plano Padro',
       '',
       'FILPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       140,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial Vendedor',
       'Filial do Vendedor',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '03',
       320,
       1,
       'FLGTIP',
       'A',
       '',
       0,
       0,
       'PVD ',
       20,
       30,
       '',
       '',
       'D',
       'PVD',
       'F',
       'A',
       'T',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '02',
       300,
       40,
       'HOMPGE',
       'A',
       '',
       0,
       0,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PVD',
       'F',
       'A',
       'T',
       'Home Page',
       'Home Page do Fornecedor',
       '',
       'HOMPGE',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '99',
       500,
       2,
       'IMPRIM',
       'S',
       '',
       0,
       0,
       'PVD ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'U',
       'PVD',
       'F',
       '',
       'F',
       'Livre p/Customizao',
       'Livre para customizao',
       '',
       'IMPRIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '03',
       330,
       15,
       'INSEST',
       'A',
       '',
       0,
       4,
       'PVD ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PVD',
       'F',
       'A',
       'T',
       '2 Documento',
       'Inscrio Estadual ou Identidade',
       '',
       'INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '04',
       370,
       2,
       'MAIATR',
       'S',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '9',
       'T',
       'Atraso Max. ao Pagar',
       'Maior atraso registrado',
       '',
       'MAIATR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       220,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(VFOR.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '99',
       420,
       2,
       'MES_DATA01',
       'A',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 1',
       '',
       'TO_CHAR(VFOR.DATA01,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '99',
       450,
       2,
       'MES_DATA02',
       'A',
       '',
       0,
       0,
       'PVD ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 2',
       '',
       'TO_CHAR(VFOR.DATA02,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '99',
       480,
       2,
       'MES_DATA03',
       'A',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 3',
       '',
       'TO_CHAR(VFOR.DATA03,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       250,
       2,
       'MES_DATNAS',
       'A',
       '',
       0,
       0,
       'PVD ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ms de Nascto/Funda',
       'Ms de Data de nascimento',
       '',
       'TO_CHAR(VFOR.DATNAS,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       280,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       0,
       'PVD ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ms de Data Incluso',
       'Ms de Data de operao (cadastramento)',
       '',
       'TO_CHAR(VFOR.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       120,
       8,
       'NASCON',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Nascto Cnj./Contato',
       'Data de nascimento do cnjuge ou contato principal',
       '',
       'NASCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       190,
       44,
       'NOMCLI',
       'A',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PVD',
       'F',
       'A',
       'T',
       'Nome/Razo Social',
       'Nome do fornecedor',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '03',
       310,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       3,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PVD',
       'F',
       'A',
       'T',
       'Documento (CPF/CGC)',
       'Nmero do Documento: CGC ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '99',
       510,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'PVD ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PVD',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(VFOR.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '99',
       550,
       4000,
       'OBSFOR',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Obs. Fornecedor',
       'Observao de Fornecedor',
       '',
       'RTF2TXT(OBSFOR)',
       '' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       90,
       2,
       'PORPAD',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       'F',
       'A',
       'F',
       'Portador Padro',
       'Portador padro',
       'VFOR.PORPAD=DCOB.CODTAB (+)',
       'PORPAD',
       'T' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       530,
       1,
       'PP_FLG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag Prospeco',
       'Flag de Prospeco sim ou no',
       '',
       'PP_FLG',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       130,
       2,
       'SEXCON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Sexo do Cnjuge',
       'Sexo do cnjuge',
       '',
       'SEXCON',
       'T' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '99',
       520,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'PVD ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PVD',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN VFOR.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       30,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Parceiro',
       'Tipo de Parceiro',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '04',
       350,
       4,
       'TOTATR',
       'G',
       '',
       0,
       0,
       'PVD ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '',
       'F',
       'Total Atrasos',
       'Total de atrasos na vida do Fornecedor como cliente',
       '',
       'TOTATR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '04',
       360,
       4,
       'TOTPAR',
       'G',
       '',
       0,
       0,
       'PVD ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '',
       'F',
       'Total Parcelas',
       'Total de parcelas na vida do Fornecedor como cliente',
       '',
       'TOTPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       100,
       8,
       'ULTCOM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'ltima Compra',
       'Data da ltima compra',
       '',
       'ULTCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '01',
       200,
       20,
       'ULTNOM',
       'A',
       '',
       0,
       0,
       'PVD ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PVD',
       'F',
       'A',
       'T',
       'Sobrenome/Fantasia',
       'Sobrenome ou fantasia',
       '',
       'ULTNOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '04',
       340,
       8,
       'VALOR1',
       'F',
       '',
       2,
       0,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'T',
       '',
       'T',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'VALOR1',
       'F' FROM DUAL
UNION ALL
SELECT 'VFOR',
       '04',
       560,
       14,
       'VLRMIN_PEDCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Vlr Mn. Pedido',
       'Valor Mnimo para Pedido de Compra',
       '',
       'VLRMIN_PEDCOM',
       '' FROM DUAL
);

/*-- SEQ 9899 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFOR',
       'CODSEX',
       1,
       '-',
       'Masculino',
       196,
       ' ' FROM DUAL
UNION ALL
SELECT 'VFOR',
       'CODSEX',
       2,
       '-',
       'Feminino',
       197,
       ' ' FROM DUAL
UNION ALL
SELECT 'VFOR',
       'CODSEX',
       0,
       '-',
       'Nao conhecido',
       195,
       ' ' FROM DUAL
UNION ALL
SELECT 'VFOR',
       'ESTCIV',
       0,
       '-',
       'Indefinido',
       198,
       ' ' FROM DUAL
UNION ALL
SELECT 'VFOR',
       'ESTCIV',
       3,
       '-',
       'Vivo',
       201,
       ' ' FROM DUAL
UNION ALL
SELECT 'VFOR',
       'ESTCIV',
       4,
       '-',
       'Divorciado',
       202,
       ' ' FROM DUAL
UNION ALL
SELECT 'VFOR',
       'ESTCIV',
       5,
       '-',
       'Unio Estvel',
       203,
       ' ' FROM DUAL
UNION ALL
SELECT 'VFOR',
       'ESTCIV',
       6,
       '-',
       'Separado',
       204,
       ' ' FROM DUAL
UNION ALL
SELECT 'VFOR',
       'ESTCIV',
       1,
       '-',
       'Solteiro',
       199,
       ' ' FROM DUAL
UNION ALL
SELECT 'VFOR',
       'ESTCIV',
       2,
       '-',
       'Casado',
       200,
       ' ' FROM DUAL
UNION ALL
SELECT 'VFOR',
       'FLGTIP',
       0,
       '0',
       'Fsica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFOR',
       'FLGTIP',
       0,
       '1',
       'Jurdica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFOR',
       'FLGTIP',
       0,
       '2',
       'Entidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFOR',
       'FLGTIP',
       0,
       '3',
       'Especial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFOR',
       'FLGTIP',
       0,
       '4',
       'M.E.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFOR',
       'FLGTIP',
       0,
       '5',
       'Filial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFOR',
       'SEXCON',
       2,
       '-',
       'Feminino',
       213,
       ' ' FROM DUAL
UNION ALL
SELECT 'VFOR',
       'SEXCON',
       1,
       '-',
       'Masculino',
       212,
       ' ' FROM DUAL
UNION ALL
SELECT 'VFOR',
       'SEXCON',
       0,
       '-',
       'Nao conhecido',
       211,
       ' ' FROM DUAL
UNION ALL
SELECT 'VFOR',
       'TIPPAR',
       0,
       'F',
       'Fornecedor',
       269,
       ' ' FROM DUAL
);

/*-- SEQ 9900 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFP ',
       TO_NUMBER(null),
       'VFP ',
       'A Pagar Fornecedores',
       'TV_FIN_PAGFOR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VFP.CODFIL,VFP.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9901 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFP ','--','' FROM DUAL
UNION ALL
SELECT 'VFP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFP ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VFP ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VFP ','99','Outros' FROM DUAL
);

/*-- SEQ 9902 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5944,
       'PVD ',
       'VFP ',
       '1 ',
       '1 ',
       '',
       '',
       'PVD.FILCLI = VFP.FILCLI AND
PVD.CODCLI = VFP.CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 5945,
       'CTA ',
       'VFP ',
       '1 ',
       '1 ',
       '',
       '',
       'VFP.FILCTA = CTA.CODFIL AND
VFP.SEQCTA = CTA.SEQUEN AND
VFP.TIPCTA = CTA.TIPCTA',
       '' FROM DUAL
);

/*-- SEQ 9903 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFP ',
       '01',
       10,
       13,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFP ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo~Parceiro',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFP ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VFP.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFP ',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Usurio que alterou o registro.',
       'VFP.FILUSU = USU.FILUSU(+)  AND VFP.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFP ',
       '02',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFP ',
       '01',
       60,
       15,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VFP ',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFP ',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFP ',
       '01',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFP ',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VFP ',
       '99',
       110,
       9,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFP ',
       '99',
       120,
       1,
       'FLGFLX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Flag Fluxo',
       'Flag Fluxo',
       '',
       'FLGFLX',
       'F' FROM DUAL
UNION ALL
SELECT 'VFP ',
       '01',
       130,
       13,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome~Origem',
       'Nome de Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFP ',
       '01',
       140,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Parcela',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFP ',
       '99',
       150,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VFP ',
       '99',
       160,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFP ',
       '99',
       170,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFP ',
       '01',
       180,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFP ',
       '01',
       190,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Tabela~Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFP ',
       '01',
       200,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFP ',
       '03',
       210,
       12,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr. Pagamento',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9904 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFP ',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFP ',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFP ',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9905 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFPA',
       TO_NUMBER(null),
       'VFPA',
       'Fin. x Pag.Fre.',
       'TV_FIN_PAGFRE',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VFPA.CODFIL,VFPA.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9906 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFPA','--','' FROM DUAL
UNION ALL
SELECT 'VFPA','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFPA','02','Datas' FROM DUAL
UNION ALL
SELECT 'VFPA','03','Valores' FROM DUAL
UNION ALL
SELECT 'VFPA','99','Outros' FROM DUAL
);

/*-- SEQ 9907 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFPA',
       '01',
       220,
       13,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPA',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPA',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VFPA.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPA',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Usurio',
       'Usurio que alterou o registro.',
       'VFPA.FILUSU = USU.FILUSU(+)  AND VFPA.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFPA',
       '02',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPA',
       '01',
       60,
       15,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPA',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPA',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPA',
       '01',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPA',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPA',
       '99',
       110,
       10,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPA',
       '99',
       120,
       1,
       'FLGFLX',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag Fluxo?',
       'Flag Fluxo?',
       '',
       'FLGFLX',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPA',
       '01',
       230,
       12,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Origem',
       'Nome de Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPA',
       '01',
       140,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPA',
       '99',
       150,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPA',
       '99',
       160,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPA',
       '99',
       170,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPA',
       '01',
       180,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPA',
       '01',
       190,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Tabela de   Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPA',
       '01',
       240,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFPA',
       '03',
       210,
       12,
       'VLRPGT',
       'S',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Pagamento',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9908 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFPA',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFPA',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFPA',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9909 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFPR',
       TO_NUMBER(null),
       'VFPR',
       'Fin. x PTR',
       'TV_FIN_PTR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VFPR.CODFIL,VFPR.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9910 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFPR','--','' FROM DUAL
UNION ALL
SELECT 'VFPR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFPR','02','Datas' FROM DUAL
UNION ALL
SELECT 'VFPR','03','Valores' FROM DUAL
UNION ALL
SELECT 'VFPR','99','Outros' FROM DUAL
);

/*-- SEQ 9911 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFPR',
       '01',
       10,
       17,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPR',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPR',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VFPR.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPR',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Usurio',
       'Usurio que alterou o registro.',
       'VFPR.FILUSU = USU.FILUSU(+)  AND VFPR.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFPR',
       '02',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPR',
       '01',
       60,
       17,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPR',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPR',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPR',
       '01',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPR',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPR',
       '99',
       110,
       9,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPR',
       '99',
       120,
       1,
       'FLGFLX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Flag Fluxo',
       'Falg Fluxo',
       '',
       'FLGFLX',
       'T' FROM DUAL
UNION ALL
SELECT 'VFPR',
       '01',
       130,
       21,
       'MEIO_P',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Meio de Pagamento',
       'Meio de Pagamento',
       '',
       'MEIO_P',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPR',
       '01',
       140,
       21,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Origem',
       'Nome de Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPR',
       '01',
       150,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPR',
       '99',
       160,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPR',
       '99',
       170,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPR',
       '99',
       180,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPR',
       '01',
       190,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPR',
       '01',
       200,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Tabela de   Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPR',
       '01',
       210,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFPR',
       '03',
       220,
       12,
       'VLRPGT',
       'S',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Pagamento',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9912 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFPR',
       'FLGFLX',
       0,
       'A',
       'Ativo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFPR',
       'FLGFLX',
       0,
       'D',
       'Desabilitado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFPR',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFPR',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFPR',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9913 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFPT',
       TO_NUMBER(null),
       'VFPT',
       'Fin. x Pag.Tt.',
       'TV_FIN_PAGTIT',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'vfpt.codfil,vfpt.sequen',
       '' FROM DUAL
);

/*-- SEQ 9914 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFPT','--','' FROM DUAL
UNION ALL
SELECT 'VFPT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFPT','02','Datas' FROM DUAL
UNION ALL
SELECT 'VFPT','03','Valores' FROM DUAL
UNION ALL
SELECT 'VFPT','99','Outros' FROM DUAL
);

/*-- SEQ 9915 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFPT',
       '01',
       10,
       13,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPT',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPT',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VFPT.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPT',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Usurio',
       'Usurio que alterou o registro.',
       'VFPT.FILUSU = USU.FILUSU(+)  AND VFPT.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFPT',
       '02',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPT',
       '01',
       60,
       15,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPT',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPT',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPT',
       '01',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPT',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPT',
       '99',
       220,
       9,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPT',
       '99',
       120,
       1,
       'FLGFLX',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag Fluxo?',
       'Flag Fluxo?',
       '',
       'FLGFLX',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPT',
       '01',
       130,
       13,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Origem',
       'Nome de Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPT',
       '01',
       140,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPT',
       '99',
       150,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPT',
       '99',
       160,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPT',
       '99',
       170,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPT',
       '01',
       180,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPT',
       '01',
       190,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Tabela de   Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFPT',
       '01',
       200,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFPT',
       '03',
       210,
       12,
       'VLRPGT',
       'S',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Pagamento',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9916 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFPT',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFPT',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFPT',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9917 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFR ',
       TO_NUMBER(null),
       'VFR ',
       'Finan./Receb.',
       'TV_FIN_REC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VFR.CODFIL,VFR.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9918 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFR ','--','' FROM DUAL
UNION ALL
SELECT 'VFR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFR ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VFR ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VFR ','99','Outros' FROM DUAL
);

/*-- SEQ 9919 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFR ',
       '01',
       10,
       17,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFR ',
       '01',
       230,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFR ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VFR.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFR ',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Usurio',
       'Usurio que alterou o registro.',
       'VFR.FILUSU = USU.FILUSU(+)  AND VFR.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFR ',
       '02',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFR ',
       '01',
       240,
       19,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VFR ',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFR ',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFR ',
       '01',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFR ',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VFR ',
       '99',
       110,
       10,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFR ',
       '99',
       120,
       1,
       'FLGFLX',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag Fluxo?',
       'Flag Fluxo',
       '',
       'FLGFLX',
       'F' FROM DUAL
UNION ALL
SELECT 'VFR ',
       '01',
       130,
       30,
       'MEIO_P',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Meio de Pagamento',
       'Meio de Pagamento',
       '',
       'MEIO_P',
       'F' FROM DUAL
UNION ALL
SELECT 'VFR ',
       '01',
       140,
       12,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Origem',
       'Nome de Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFR ',
       '01',
       150,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFR ',
       '99',
       160,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VFR ',
       '99',
       170,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFR ',
       '99',
       180,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFR ',
       '01',
       190,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFR ',
       '01',
       200,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Tabela de   Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFR ',
       '01',
       210,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFR ',
       '03',
       220,
       8,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Pagamento',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9920 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFR ',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFR ',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFR ',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9921 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFRD',
       TO_NUMBER(null),
       'VFRD',
       'Fat. / Rem. / Dev.',
       'TV_FATURA_REMESSA_DEVOLUCOES',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9922 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFRD','--','' FROM DUAL
UNION ALL
SELECT 'VFRD','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFRD','02','Valores' FROM DUAL
UNION ALL
SELECT 'VFRD','03','Datas' FROM DUAL
UNION ALL
SELECT 'VFRD','99','Outros' FROM DUAL
);

/*-- SEQ 9923 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22146,
       'CLI ',
       'VFRD',
       '1',
       '1',
       '',
       '',
       'VFRD.FILCLI = CLI.FILCLI AND
VFRD.CODCLI = CLI.CODCLI',
       '',
       '' FROM DUAL
);

/*-- SEQ 9924 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFRD',
       '01',
       5,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Fatura',
       'Filial da Fatura',
       'DFIL.CODFIL = VFRD.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFRD',
       '03',
       170,
       12,
       'DATDEVFAT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Dev Faturamento',
       'Data da Devoluo do Faturamento',
       '',
       'DATDEVFAT',
       '' FROM DUAL
UNION ALL
SELECT 'VFRD',
       '03',
       150,
       12,
       'DATFAT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Faturamento',
       'Data do Faturamento',
       '',
       'DATFAT',
       '' FROM DUAL
UNION ALL
SELECT 'VFRD',
       '03',
       180,
       12,
       'DATIDR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Dev Remessa',
       'Data de Devoluo da Remessa',
       '',
       'DATIDR',
       '' FROM DUAL
UNION ALL
SELECT 'VFRD',
       '03',
       160,
       12,
       'DATREM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       '',
       'Data Remessa',
       'Data da Remessa',
       '',
       'DATREM',
       '' FROM DUAL
UNION ALL
SELECT 'VFRD',
       '01',
       20,
       35,
       'DEVFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Devoluo Fatura',
       'Devoluo da Fatura',
       '',
       'DEVFAT',
       '' FROM DUAL
UNION ALL
SELECT 'VFRD',
       '99',
       190,
       1,
       'DEVFATSEMREM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Dev Fat Sem Rem',
       'Devoluo de Fatura sem Remessa',
       '',
       '(CASE WHEN VFRD.DEVFAT IS NULL THEN ''F'' ELSE CASE WHEN VFRD.REMESSA IS NULL THEN ''T'' ELSE CASE WHEN VFRD.DATDEVFAT < VFRD.DATREM THEN ''T'' ELSE ''F'' END END END)',
       '' FROM DUAL
UNION ALL
SELECT 'VFRD',
       '01',
       40,
       35,
       'DEVREM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Devoluo Remessa',
       'Devoluo da Remessa',
       '',
       'DEVREM',
       '' FROM DUAL
UNION ALL
SELECT 'VFRD',
       '01',
       10,
       35,
       'FATURA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Fatura',
       'Nmero da Fatura',
       '',
       'FATURA',
       '' FROM DUAL
UNION ALL
SELECT 'VFRD',
       '02',
       80,
       12,
       'QTDDEVFAT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Qtd. Dev. Fatura',
       'Quantidade Devolvida da Fatura',
       '',
       'QTDDEVFAT',
       '' FROM DUAL
UNION ALL
SELECT 'VFRD',
       '02',
       100,
       12,
       'QTDDEVREM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Qtd. Dev. Remessa',
       'Quantidade Devolvida da Remessa',
       '',
       'QTDDEVREM',
       '' FROM DUAL
UNION ALL
SELECT 'VFRD',
       '02',
       50,
       12,
       'QTDFAT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Quantidade Fatura',
       'Quantidade da Fatura',
       '',
       'QTDFAT',
       '' FROM DUAL
UNION ALL
SELECT 'VFRD',
       '02',
       60,
       14,
       'QTDPEN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Quantidade Pendente',
       'Quantidade Pendente',
       '',
       'QTDPEN',
       '' FROM DUAL
UNION ALL
SELECT 'VFRD',
       '02',
       90,
       12,
       'QTDREM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Quantidade Remessa',
       'Quantidade da Remessa',
       '',
       'QTDREM',
       '' FROM DUAL
UNION ALL
SELECT 'VFRD',
       '02',
       70,
       14,
       'QTDRES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Quantidade Reservada',
       'Quantidade Reservada',
       '',
       'QTDRES',
       '' FROM DUAL
UNION ALL
SELECT 'VFRD',
       '01',
       30,
       35,
       'REMESSA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Remessa',
       'Nmero da Remessa',
       '',
       'REMESSA',
       '' FROM DUAL
UNION ALL
SELECT 'VFRD',
       '02',
       110,
       12,
       'VLRLIQRAT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '0',
       '',
       'Vlr. Liq. Rat. Fatu',
       'Valor Lquido Rateado da Fatura',
       '',
       'VLRLIQRAT',
       '' FROM DUAL
UNION ALL
SELECT 'VFRD',
       '02',
       130,
       12,
       'VLRLIQRAT_IDE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '0',
       '',
       'Vlr. Liq Rat Dev Fat',
       'Valor Lquido Rateado da Devoluo da Fatura',
       '',
       'VLRLIQRAT_IDE',
       '' FROM DUAL
UNION ALL
SELECT 'VFRD',
       '02',
       140,
       12,
       'VLRLIQRAT_IDR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '0',
       '',
       'Vlr. Liq Rat Dev Rem',
       'Valor Lquido Rateado da Devoluo da Remessa',
       '',
       'VLRLIQRAT_IDR',
       '' FROM DUAL
UNION ALL
SELECT 'VFRD',
       '02',
       120,
       12,
       'VLRLIQRAT_IRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '0',
       '',
       'Vlr. Liq. Rat. Rem',
       'Valor Lquido Rateado da Remessa',
       '',
       'VLRLIQRAT_IRE',
       '' FROM DUAL
);

/*-- SEQ 9925 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFT ',
       TO_NUMBER(null),
       'VFT ',
       'Fin. x TRC',
       'TV_FIN_TRC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VFT.CODFIL,VFT.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9926 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFT ','--','' FROM DUAL
UNION ALL
SELECT 'VFT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFT ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VFT ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VFT ','99','Outros' FROM DUAL
);

/*-- SEQ 9927 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFT ',
       '01',
       10,
       13,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFT ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFT ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VFT.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFT ',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Usurio',
       'Usurio que alterou o registro.',
       'VFT.FILUSU = USU.FILUSU(+)  AND VFT.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFT ',
       '02',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFT ',
       '01',
       60,
       15,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VFT ',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFT ',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFT ',
       '01',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFT ',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VFT ',
       '99',
       220,
       10,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFT ',
       '99',
       120,
       1,
       'FLGFLX',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag Fluxo?',
       'Flag Fluxo?',
       '',
       'FLGFLX',
       'F' FROM DUAL
UNION ALL
SELECT 'VFT ',
       '01',
       130,
       18,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Origem',
       'Nome de Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFT ',
       '01',
       140,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFT ',
       '99',
       150,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VFT ',
       '99',
       160,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFT ',
       '99',
       170,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFT ',
       '01',
       180,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFT ',
       '01',
       190,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Tabela de   Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFT ',
       '01',
       200,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFT ',
       '03',
       210,
       12,
       'VLRPGT',
       'S',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Pagamento',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9928 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFT ',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFT ',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFT ',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9929 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFTP',
       TO_NUMBER(null),
       'VFTP',
       'Fin. x TXP',
       'TV_FIN_TXP',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VFTP.CODFIL,VFTP.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9930 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFTP','--','' FROM DUAL
UNION ALL
SELECT 'VFTP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFTP','02','Datas' FROM DUAL
UNION ALL
SELECT 'VFTP','03','Valores' FROM DUAL
UNION ALL
SELECT 'VFTP','99','Outros' FROM DUAL
);

/*-- SEQ 9931 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFTP',
       '01',
       10,
       13,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTP',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTP',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VFTP.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTP',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Usurio',
       'Usurio que alterou o registro.',
       'VFTP.FILUSU = USU.FILUSU(+)  AND VFTP.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFTP',
       '02',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTP',
       '01',
       60,
       15,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTP',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTP',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTP',
       '01',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTP',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTP',
       '99',
       110,
       14,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTP',
       '99',
       120,
       1,
       'FLGFLX',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag Fluxo?',
       'Flag Fluxo?',
       '',
       'FLGFLX',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTP',
       '01',
       220,
       20,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Origem',
       'Nome de Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTP',
       '01',
       140,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTP',
       '99',
       150,
       1,
       'OBSERV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Observao?',
       'Observao?',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTP',
       '99',
       160,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTP',
       '99',
       170,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTP',
       '01',
       180,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTP',
       '01',
       190,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Tabela de   Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTP',
       '01',
       200,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFTP',
       '03',
       210,
       12,
       'VLRPGT',
       'S',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Pagamento',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9932 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFTP',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFTP',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFTP',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9933 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFTX',
       TO_NUMBER(null),
       'VFTX',
       'Fin. x TXC',
       'TV_FIN_TXC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VFTX.CODFIL,VFTX.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9934 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFTX','--','' FROM DUAL
UNION ALL
SELECT 'VFTX','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFTX','02','Datas' FROM DUAL
UNION ALL
SELECT 'VFTX','03','Valores' FROM DUAL
UNION ALL
SELECT 'VFTX','99','Outros' FROM DUAL
);

/*-- SEQ 9935 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFTX',
       '01',
       10,
       17,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTX',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTX',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VFTX.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTX',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Usurio',
       'Usurio que alterou o registro.',
       'VFTX.FILUSU = USU.FILUSU(+)  AND VFTX.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFTX',
       '02',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTX',
       '01',
       60,
       5,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTX',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTX',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTX',
       '01',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTX',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTX',
       '99',
       110,
       10,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTX',
       '01',
       220,
       4,
       'FLGFLX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Flag Fluxo',
       'Flag Fluxo',
       '',
       'FLGFLX',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTX',
       '01',
       130,
       17,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Origem',
       'Nome de Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTX',
       '01',
       140,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTX',
       '99',
       150,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTX',
       '99',
       160,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTX',
       '99',
       170,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTX',
       '01',
       180,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTX',
       '01',
       190,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Tabela de   Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFTX',
       '01',
       200,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFTX',
       '03',
       210,
       12,
       'VLRPGT',
       'S',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Pagamento',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9936 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFTX',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFTX',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFTX',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9937 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VFV ',
       TO_NUMBER(null),
       'VFV ',
       'Finan/Vendas',
       'TV_FIN_VEN',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VFV.CODFIL,VFV.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9938 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VFV ','--','' FROM DUAL
UNION ALL
SELECT 'VFV ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VFV ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VFV ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VFV ','99','Outros' FROM DUAL
);

/*-- SEQ 9939 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VFV ',
       '01',
       10,
       13,
       'CHVFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'CHVFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFV ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFV ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VFV.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VFV ',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo do Usurio',
       'Usurio que alterou o registro.',
       'VFV.FILUSU = USU.FILUSU(+)  AND VFV.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VFV ',
       '02',
       50,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VFV ',
       '01',
       60,
       13,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VFV ',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFV ',
       '01',
       80,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFV ',
       '01',
       90,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Filial do Recebimento',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VFV ',
       '01',
       100,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VFV ',
       '--',
       220,
       9,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VFV ',
       '99',
       120,
       1,
       'FLGFLX',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag de Fluxo?',
       'Flag de Fluxo',
       '',
       'FLGFLX',
       'F' FROM DUAL
UNION ALL
SELECT 'VFV ',
       '01',
       130,
       7,
       'NOMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Origem',
       'Nome de Origem',
       '',
       'NOMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFV ',
       '01',
       140,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFV ',
       '99',
       150,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VFV ',
       '99',
       160,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VFV ',
       '99',
       170,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VFV ',
       '01',
       180,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VFV ',
       '01',
       190,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Tabela de   Origem',
       'Tabela de Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VFV ',
       '01',
       200,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Conta',
       'Tipo Conta',
       '',
       'TIPCTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VFV ',
       '03',
       210,
       8,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Pagamento',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 9940 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VFV ',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFV ',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VFV ',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9941 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VGDT',
       TO_NUMBER(null),
       'VGDT',
       'Detalhe da Grade',
       'TV_GRA_DET',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VGDT.FILMAT, VGDT.CODMAT, VGDT.CODCOR, VGDT.CODTAM, VGDT.CODFIL, VGDT.CODMUL',
       '' FROM DUAL
);

/*-- SEQ 9942 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VGDT','--','' FROM DUAL
UNION ALL
SELECT 'VGDT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VGDT','99','Outros' FROM DUAL
);

/*-- SEQ 9943 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VGDT',
       '01',
       20,
       5,
       'CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Diviso do Produto',
       'Diviso do Produto',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VGDT',
       '01',
       1,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VGDT',
       '01',
       15,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Cdigo do Produto',
       'Cdigo do Produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VGDT',
       '01',
       30,
       5,
       'CODMUL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Sub-estoque',
       'Sub-estoque',
       '',
       'CODMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'VGDT',
       '01',
       25,
       5,
       'CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Sub-diviso Produto',
       'Sub-diviso Produto',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'VGDT',
       '99',
       70,
       7,
       'DATCOM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data ltima Compra',
       'Data da ltima Compra',
       '',
       'DATCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VGDT',
       '99',
       80,
       4000,
       'DOCPAG',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Lista Doc. Pagamento',
       'Lista de Documentos de Pagamento',
       '',
       'DOCPAG',
       'F' FROM DUAL
UNION ALL
SELECT 'VGDT',
       '99',
       90,
       15,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Doc. ltima Compra',
       'Documento da ltima Compra',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VGDT',
       '01',
       10,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Filial do Produto',
       'Filial do Produto',
       '',
       'FILMAT',
       '' FROM DUAL
UNION ALL
SELECT 'VGDT',
       '99',
       100,
       64,
       'NOMFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Fornecedor',
       'Fornecedor',
       '',
       'NOMFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VGDT',
       '99',
       110,
       4000,
       'OLDNUMPED',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'ltimo Pedido',
       'ltimo Pedido',
       '',
       'OLDNUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'VGDT',
       '99',
       120,
       12,
       'OLDQTDCOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'ltima Qtd. Comprada',
       'ltima Qtd. Comprada',
       '',
       'OLDQTDCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VGDT',
       '99',
       130,
       4000,
       'PAGAMENTOS',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Lista de Pagamentos',
       'Lista de Pagamentos',
       '',
       'PAGAMENTOS',
       'F' FROM DUAL
UNION ALL
SELECT 'VGDT',
       '99',
       140,
       12,
       'PRECOM',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'ltimo Preo Compra',
       'ltimo Preo de Compra',
       '',
       'PRECOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VGDT',
       '99',
       150,
       12,
       'QTDEST',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtd. em Estoque',
       'Quantidade em Estoque',
       '',
       'QTDEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VGDT',
       '99',
       160,
       20,
       'REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Referncia Produto',
       'Referncia do Produto',
       '',
       'REFPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VGDT',
       '99',
       170,
       12,
       'RESERV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Reserva Atual',
       'Reserva Atual',
       '',
       'RESERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VGDT',
       '99',
       180,
       12,
       'SALREA',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Saldo Real',
       'Saldo Real',
       '',
       'SALREA',
       'F' FROM DUAL
);

/*-- SEQ 9944 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VGRF',
       TO_NUMBER(null),
       'VGRF',
       'Grfico Financeiro',
       'TV_GRAF_FINA',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9945 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VGRF','--','' FROM DUAL
UNION ALL
SELECT 'VGRF','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VGRF','99','Outros' FROM DUAL
);

/*-- SEQ 9946 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 19391,
       'CLI ',
       'VGRF',
       '1',
       'N',
       '',
       '',
       'CLI.FILCLI = VGRF.FILCLI AND
CLI.CODCLI = VGRF.CODCLI',
       '',
       '' FROM DUAL
);

/*-- SEQ 9947 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VGRF',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VGRF',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = VGRF.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VGRF',
       '--',
       40,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data',
       'Data',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VGRF',
       '--',
       50,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Filial do Cliente',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VGRF',
       '--',
       60,
       9,
       'MESANO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ms e Ano',
       'Ms e Ano',
       '',
       'MESANO',
       'F' FROM DUAL
UNION ALL
SELECT 'VGRF',
       '--',
       70,
       1,
       'TIPO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo',
       'Tipo',
       '',
       'TIPO',
       'T' FROM DUAL
UNION ALL
SELECT 'VGRF',
       '--',
       80,
       12,
       'VALOR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor',
       'Valor',
       '',
       'VALOR',
       'F' FROM DUAL
);

/*-- SEQ 9948 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VGRF',
       'TIPO',
       0,
       'C',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VGRF',
       'TIPO',
       0,
       'V',
       'Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9949 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VIC ',
       TO_NUMBER(null),
       'VIC ',
       'Indicadores Clientes',
       'TV_IND_CLI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9950 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VIC ','--','' FROM DUAL
UNION ALL
SELECT 'VIC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VIC ','99','Outros' FROM DUAL
);

/*-- SEQ 9951 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VIC ',
       '01',
       10,
       17,
       'ABER_A',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Abertas em Atraso',
       'Abertas em Atraso',
       '',
       'ABER_A',
       'F' FROM DUAL
UNION ALL
SELECT 'VIC ',
       '01',
       20,
       6,
       'ABER_F',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Abertas Futuro',
       'Abertas Futuro',
       '',
       'ABER_F',
       'F' FROM DUAL
UNION ALL
SELECT 'VIC ',
       '01',
       30,
       6,
       'ABER_P',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Abertas Pontual',
       'Abertas Pontual',
       '',
       'ABER_P',
       'F' FROM DUAL
UNION ALL
SELECT 'VIC ',
       '01',
       40,
       17,
       'ABER_S',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Abertas atrasadas se',
       'Abertas atrasadas sem pagamento',
       '',
       'ABER_S',
       'F' FROM DUAL
UNION ALL
SELECT 'VIC ',
       '01',
       50,
       6,
       'AVISTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       ' Vista',
       ' Vista',
       '',
       'AVISTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIC ',
       '01',
       60,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo',
       'Cdigo do parceiro',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIC ',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIC ',
       '01',
       80,
       12,
       'MAIATR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Maior Atraso',
       'Maior Atraso',
       '',
       'MAIATR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIC ',
       '01',
       90,
       12,
       'MEDATR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Mdia de Atrasos',
       'Mdia de Atrasos',
       '',
       'MEDATR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIC ',
       '01',
       100,
       20,
       'QUIT_A',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Quitada com atrasos',
       'Quitada com atrasos',
       '',
       'QUIT_A',
       'F' FROM DUAL
UNION ALL
SELECT 'VIC ',
       '01',
       110,
       20,
       'QUIT_P',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Quitada Pontual',
       'Quitada Pontual',
       '',
       'QUIT_P',
       'F' FROM DUAL
UNION ALL
SELECT 'VIC ',
       '01',
       120,
       12,
       'RENEGO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Renegociaes',
       'Renegociaes',
       '',
       'RENEGO',
       'F' FROM DUAL
UNION ALL
SELECT 'VIC ',
       '01',
       130,
       7,
       'ULTATR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data ltimo Atraso',
       'Data ltimo Atraso',
       '',
       'ULTATR',
       'F' FROM DUAL
);

/*-- SEQ 9952 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VICO',
       TO_NUMBER(null),
       'VICO',
       'Tab. Itens com. Esp',
       'TV_ICO_ESP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9953 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VICO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VICO','02','Valores' FROM DUAL
UNION ALL
SELECT 'VICO','99','Outros' FROM DUAL
);

/*-- SEQ 9954 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'VICO',
       '01',
       50,
       6,
       'CODCFO',
       'A',
       'CFOP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'CFOP.DESCFO',
       'V',
       '',
       '',
       'A',
       '',
       'CFOP',
       'Cdigo CFOP',
       'CFOP.CODTAB(+) = VICO.CODCFO',
       'CODCFO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VICO',
       '01',
       10,
       15,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL = VICO.CODFIL',
       'CODFIL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VICO',
       '99',
       20,
       30,
       'COM_DATOPE',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Entrada',
       'Data da entrada',
       '',
       'COM_DATOPE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VICO',
       '02',
       220,
       12,
       'CUSAQS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Custo de Aquisio',
       'Custo de Aquisio ',
       '',
       'CUSAQS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VICO',
       '02',
       110,
       12,
       'CUSCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Custo Rep. Unitrio',
       'Custo de Reposio Unitrio',
       '',
       'CUSCOM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VICO',
       '02',
       160,
       12,
       'CUSFIN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Custo Final',
       'Custo Final antes do Lucro projetado',
       '',
       'CUSFIN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VICO',
       '01',
       60,
       30,
       'DESMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio',
       'Descrio do Material',
       '',
       'DESMAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VICO',
       '01',
       70,
       30,
       'ESPMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Especificao',
       'Especificao do Material',
       '',
       'ESPMAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VICO',
       '01',
       150,
       60,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Fornecedor',
       'Nome Fornecedor',
       '',
       'NOMCLI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VICO',
       '01',
       140,
       8,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Numero da nota',
       'Numero da nota de Compra',
       '',
       'NUMNOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VICO',
       '01',
       145,
       8,
       'NUMNOT_PESQ',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Pesq Nmero Nota',
       'Nmero da nota Utilizado somente para Pesquisa em Relatrios',
       '',
       'NUMNOT_PESQ',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VICO',
       '02',
       170,
       12,
       'PRECAL',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Preo Venda Calculad',
       'Preo de venda Calculado',
       '',
       'PRECAL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VICO',
       '02',
       180,
       12,
       'PRECOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Preo Venda Atual',
       'Preo de venda Atual',
       '',
       'PRECOV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VICO',
       '02',
       80,
       12,
       'QTDMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Qtd Movimentada',
       'Quantidade Movimentada',
       '',
       'QTDMOV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VICO',
       '01',
       30,
       15,
       'REFBAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Referencia Bsica',
       'Referencia Bsica do Produto',
       '',
       'REFBAS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VICO',
       '01',
       40,
       30,
       'REFFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Ref. do Fornecedor',
       'Referencia do Fornecedor',
       '',
       'REFFOR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VICO',
       '01',
       210,
       20,
       'REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Referncia',
       'Referncia do produto',
       '',
       'REFPRO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VICO',
       '02',
       190,
       12,
       'ST_FRE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor ST Frete',
       'Valor de ST do frete',
       '',
       'ST_FRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VICO',
       '02',
       200,
       12,
       'TOT_CUSFRE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Frete',
       'Valor do frete sem ST',
       '',
       'TOT_CUSFRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VICO',
       '02',
       120,
       12,
       'ULTCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Custo Rep. Anterior',
       'Custo de Reposio Anterior',
       '',
       'ULTCOM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VICO',
       '01',
       90,
       2,
       'UNIMED',
       'A',
       'DMED',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMED.',
       'A',
       '',
       '',
       'A',
       '',
       'Unidade de Medida',
       'Unidade de Medida',
       'DMED. = VICO.UNIMED',
       'UNIMED',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VICO',
       '02',
       130,
       12,
       'VLRLUC',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Margem Liquida',
       'Margem Liquida',
       '',
       'VLRLUC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VICO',
       '02',
       100,
       12,
       'VLRMOV_UNI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Compra Uni.',
       'Valor unitrio de Compra',
       '',
       'VLRMOV_UNI',
       '',
       'D' FROM DUAL
);

/*-- SEQ 9955 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VICU',
       TO_NUMBER(null),
       'VICU',
       'Cus Compra Anterior',
       'TV_ICO_CUS',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9956 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VICU','--','' FROM DUAL
UNION ALL
SELECT 'VICU','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VICU','99','Outros' FROM DUAL
);

/*-- SEQ 9957 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 29243,
       'VFOR',
       'VICU',
       '1',
       'N',
       '',
       '',
       'VFOR.FILPAR = VICU.FILFOR AND
VFOR.CODPAR = VICU.CODFOR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29244,
       'GRA ',
       'VICU',
       '1',
       'N',
       '',
       '',
       'GRA.FILMAT = VICU.FILMAT and
GRA.CODMAT = VICU.CODMAT and
GRA.CODCOR = VICU.CODCOR and
GRA.CODTAM = VICU.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 9958 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VICU',
       '--',
       110,
       5,
       'CODCFO',
       'G',
       'DCFO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCFO.CODCFO || '' - '' || DCFO.DESCFO',
       'V',
       '',
       '',
       'N',
       '',
       'CFOP',
       'CFOP',
       'DCFO.CODTAB(+) = VICU.CODNAT',
       'CODCFO',
       'T' FROM DUAL
UNION ALL
SELECT 'VICU',
       '--',
       50,
       5,
       'CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'CODCOR',
       '' FROM DUAL
UNION ALL
SELECT 'VICU',
       '--',
       80,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'CODFOR',
       '' FROM DUAL
UNION ALL
SELECT 'VICU',
       '--',
       40,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'CODMAT',
       '' FROM DUAL
UNION ALL
SELECT 'VICU',
       '--',
       90,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Srie',
       'Srie',
       '',
       'CODSER',
       '' FROM DUAL
UNION ALL
SELECT 'VICU',
       '--',
       60,
       5,
       'CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'CODTAM',
       '' FROM DUAL
UNION ALL
SELECT 'VICU',
       '--',
       20,
       8,
       'COM_DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data~Movimento',
       'Data Movimento',
       '',
       'COM_DATOPE',
       '' FROM DUAL
UNION ALL
SELECT 'VICU',
       '--',
       140,
       12,
       'CUSCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Custo~Atual',
       'Custo Atual',
       '',
       'CUSCOM',
       '' FROM DUAL
UNION ALL
SELECT 'VICU',
       '--',
       70,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'FILFOR',
       '' FROM DUAL
UNION ALL
SELECT 'VICU',
       '--',
       30,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'FILMAT',
       '' FROM DUAL
UNION ALL
SELECT 'VICU',
       '--',
       10,
       3,
       'NOMFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL = VICU.CODFIL',
       'NOMFIL',
       '' FROM DUAL
UNION ALL
SELECT 'VICU',
       '--',
       100,
       9,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Nmero Nota Fiscal',
       'Nmero da Nota Fiscal',
       '',
       'NUMNOT',
       '' FROM DUAL
UNION ALL
SELECT 'VICU',
       '--',
       130,
       12,
       'QTDMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Qtdade~Movimento',
       'Quantidade Movimentada',
       '',
       'QTDMOV',
       '' FROM DUAL
UNION ALL
SELECT 'VICU',
       '--',
       150,
       12,
       'ULTCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Custo~Anterior',
       'Custo Anterior',
       '',
       'ULTCOM',
       '' FROM DUAL
UNION ALL
SELECT 'VICU',
       '--',
       120,
       5,
       'UNIMED',
       'G',
       'DMED',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMED.UNIMED',
       'V',
       '',
       '',
       'N',
       '',
       'Unidade',
       'Unidade de Compra',
       'DMED.CODTAB = VICU.UNICOM',
       'UNIMED',
       'F' FROM DUAL
UNION ALL
SELECT 'VICU',
       '--',
       135,
       12,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor~Movimento',
       'Valor Movimento',
       '',
       'VLRMOV',
       '' FROM DUAL
);

/*-- SEQ 9959 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VIDA',
       TO_NUMBER(null),
       'VIDA',
       'Ida e volta',
       'TV_IDA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VIDA.CODFIL,VIDA.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9960 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VIDA','--','' FROM DUAL
UNION ALL
SELECT 'VIDA','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VIDA','99','Outros' FROM DUAL
);

/*-- SEQ 9961 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5955,
       'CLI ',
       'VIDA',
       '1 ',
       'N ',
       '',
       '',
       'VIDA.FILCLI = CLI.FILCLI AND
VIDA.CODCLI = CLI.CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 5956,
       'VMOT',
       'VIDA',
       '1 ',
       'N ',
       '',
       '',
       'VMOT.FILCLI = VIDA.FILMOT AND
VMOT.CODCLI = VIDA.CODMOT',
       '' FROM DUAL
);

/*-- SEQ 9962 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VIDA',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIDA',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = VIDA.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIDA',
       '01',
       30,
       6,
       'CODMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Motivo',
       'Cdigo Motivo',
       '',
       'CODMOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIDA',
       '01',
       40,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIDA',
       '01',
       50,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIDA',
       '01',
       60,
       3,
       'FILMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Motivo',
       '',
       'FILMOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIDA',
       '01',
       70,
       8,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Nmero Documento',
       'Nmero Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VIDA',
       '01',
       80,
       7,
       'PLACAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Placas',
       'Placas',
       '',
       'PLACAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIDA',
       '01',
       90,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 9963 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VIEV',
       TO_NUMBER(null),
       'VIEV',
       'Itens Evento Venda',
       'TV_ITE_EVE_VEN',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9964 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VIEV','--','' FROM DUAL
UNION ALL
SELECT 'VIEV','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VIEV','99','Outros' FROM DUAL
);

/*-- SEQ 9965 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VIEV',
       '--',
       20,
       10,
       'APEUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Vendedor',
       'Vendedor',
       '',
       'APEUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       30,
       12,
       'BASCAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base Clculo',
       'Base Clculo',
       '',
       'BASCAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       40,
       12,
       'BASCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base do Cofins',
       'Base do Cofins',
       '',
       'BASCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       50,
       12,
       'BASICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base ICMS',
       'Base ICMS',
       '',
       'BASICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       60,
       12,
       'BASIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base do IPI',
       'Base do IPI',
       '',
       'BASIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       70,
       12,
       'BASISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base do ISS',
       'Base do ISS',
       '',
       'BASISS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       80,
       12,
       'BASPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base do PIS',
       'Base do PIS',
       '',
       'BASPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       90,
       1,
       'CALSUB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Produto Substitudo',
       'Produto Substitudo',
       '',
       'CALSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       100,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       110,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo~Produto',
       'Cdigo do Produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       120,
       3,
       'CODVDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Vendedor',
       'Cdigo do Vendedor',
       '',
       'CODVDD',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       130,
       9,
       'COMISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Comisso',
       'Comisso',
       '',
       'COMISS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       140,
       12,
       'CUSFINFISTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'C.Financ. Fiscal Tot',
       'C.Financ. Fiscal Tot',
       '',
       'CUSFINFISTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       150,
       12,
       'CUSFINGERTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'C.Financ. Geren. Tot',
       'C.Financ. Geren. Tot',
       '',
       'CUSFINGERTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       160,
       12,
       'CUSMEDFIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Custo Mdio Fiscal',
       'Custo Mdio Fiscal',
       '',
       'CUSMEDFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       170,
       12,
       'CUSMEDGER',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Custo Mdio Gerenc.',
       'Custo Mdio Gerenc.',
       '',
       'CUSMEDGER',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       180,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       190,
       30,
       'DESMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio~Material',
       'Descrio Material',
       '',
       'DESMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       200,
       30,
       'DESMUL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub-Estoque',
       'Sub-Estoque',
       '',
       'DESMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       210,
       1,
       'DEVVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Devolve vnculo',
       'Devolve vnculo',
       '',
       'DEVVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       220,
       12,
       'EMBQTD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Quantidade Original',
       'Quantidade Original',
       '',
       'EMBQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       230,
       30,
       'ESPMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Especificao',
       'Especificao Material',
       '',
       'ESPMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       240,
       12,
       'ESTPEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Estorno Qtd Pendente',
       'Estorno da Quantidade Pendente',
       '',
       'ESTPEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       250,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exportar?',
       'Exportar',
       '',
       'EXPORT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       260,
       3,
       'FILDOU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial do Mdico',
       'Filial do Mdico',
       '',
       'FILDOU',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       270,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial~Produto',
       'Filial de incluso do produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       280,
       3,
       'FILRCT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial Receita',
       'Filial Receita',
       '',
       'FILRCT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       290,
       3,
       'FILRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial de~Reserva',
       'Filial de Reserva',
       '',
       'FILRES',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       300,
       3,
       'FILVDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial Vendedor',
       'Filial do Vendedor',
       '',
       'FILVDD',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       310,
       30,
       'FLGFUT_DOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Est. Entrega Futura',
       'Est. Entrega Futura',
       '',
       'FLGFUT_DOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       320,
       30,
       'ICMTIP_DOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Tributao',
       'Tipo Tributao',
       '',
       'ICMTIP_DOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       330,
       1,
       'IMPKIT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Itens KIT Impressos',
       'Itens do KIT Impressos',
       '',
       'IMPKIT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       340,
       4,
       'ISEICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base ICMS Isento',
       'Base ICMS Isento',
       '',
       'ISEICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       350,
       10,
       'ITEDIV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Diviso',
       'Diviso',
       '',
       'ITEDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       360,
       17,
       'ITEPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Item de~Pedido',
       'Item de Pedido',
       '',
       'ITEPED',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       370,
       10,
       'ITESUB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Subdiviso',
       'Subdiviso',
       '',
       'ITESUB',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       380,
       30,
       'LANEST_DOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Estoque',
       'Estoque',
       '',
       'LANEST_DOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       390,
       40,
       'NATDENEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat.Fis~dentro do UF',
       'Nat.Fis~dentro do UF',
       '',
       'NATDENEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       400,
       6,
       'NATFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Natureza Fiscal',
       'Natureza Fiscal',
       '',
       'NATFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       410,
       40,
       'NATFOREST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nat.Fis~fora do UF',
       'Nat.Fis~fora do UF',
       '',
       'NATFOREST',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       420,
       10,
       'NOMITE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Embalagem Original',
       'Embalagem Original',
       '',
       'NOMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       430,
       4000,
       'NOTVIN',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Notas Vinculadas',
       'Notas Vinculadas',
       '',
       'RTF2TXT(NOTVIN)',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       440,
       20,
       'NUMEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm. Externo',
       'Nmero externo',
       '',
       'NUMEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       450,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Item',
       'Nmero do item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       460,
       10,
       'ORD_CM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Orden. Custo Mdio',
       'Ordenao Custo Mdio',
       '',
       'ORD_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       470,
       30,
       'ORIGEM1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Origem 1',
       'Venda Origem 1',
       '',
       'ORIGEM1',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       480,
       30,
       'ORIGEM2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Origem 2',
       'Venda Origem 2',
       '',
       'ORIGEM2',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       490,
       4,
       'OUTICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base ICMS Outros',
       'Base ICMS Outros',
       '',
       'OUTICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       500,
       30,
       'PENATU_DOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Proc. Devol. Separ.',
       'Proc. Devol. Separ.',
       '',
       'PENATU_DOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       510,
       6,
       'PERCOF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       'F',
       'Percentual de Cofins',
       'Percentual de Cofins',
       '',
       'PERCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       520,
       6,
       'PERPIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       'F',
       'Percentual de PIS',
       'Percentual de PIS',
       '',
       'PERPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       530,
       10,
       'PREPROMO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Preo Promocional',
       'Preo Promocional',
       '',
       'PREPROMO',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       540,
       1,
       'PROMOC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Promocional?',
       'Promocional?',
       '',
       'PROMOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       550,
       8,
       'QTDCONV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtde~Conv.',
       'Quantidade vendida Convertida',
       '',
       'QTDCONV',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       560,
       8,
       'QTDDEV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtdade Devolvida',
       'Quantidade devolvida',
       '',
       'QTDDEV',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       570,
       8,
       'QTDENT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtdade Entregue',
       'Quantidade entregue',
       '',
       'QTDENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       580,
       12,
       'QTDFUT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtde Entrega Futura',
       'Quantidade Entrega Futura',
       '',
       'QTDFUT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       590,
       8,
       'QTDMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Qtde',
       'Quantidade vendida',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       600,
       12,
       'QTDPEN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Quantidade Pendente',
       'Quantidade Pendente',
       '',
       'QTDPEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       610,
       14,
       'QTDPRE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Quantidade Pescrita',
       'Quantidade Pescrita',
       '',
       'QTDPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       620,
       12,
       'QTD_CM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde Custo Medio',
       'Quantidade Custo Mdio',
       '',
       'QTD_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       630,
       7,
       'REDITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base reduzida ICMS',
       'Base reduzida de ICMS do item',
       '',
       'REDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       640,
       20,
       'REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. Produto',
       'Referncia do Produto',
       '',
       'REFPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       650,
       12,
       'SALNEG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Vlr Saldo Negativo',
       'Valor do saldo do produto quando negativo',
       '',
       'SALNEG',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       660,
       16,
       'SAL_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Saldo',
       'Saldo',
       '',
       'SAL_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       670,
       10,
       'SEQDOU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. do Mdico',
       'Sequenciador do Mdico',
       '',
       'SEQDOU',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       680,
       10,
       'SEQRCT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador Receita',
       'Sequenciador Receita',
       '',
       'SEQRCT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       1010,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       690,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN VIEV.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       691,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN VIEV.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       700,
       2,
       'SITCOF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sit. Trib. Cofins',
       'Situao Tributria do Cofins',
       '',
       'SITCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       710,
       2,
       'SITIPI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sit. Tributria IPI ',
       'Situao Tributria do IPI',
       '',
       'SITIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       720,
       30,
       'SITKIT_DOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Kit',
       'Kit',
       '',
       'SITKIT_DOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       730,
       30,
       'SITMOV_DOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'SITMOV_DOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       740,
       2,
       'SITPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sit. Tributria PIS',
       'Situao Tributria do PIS',
       '',
       'SITPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       750,
       4,
       'TAX001',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '%ICMS ou %ISS',
       'ICMS(Qdo Mat.)a TAXA002=IPI e ISS(Qdo Serv.) a TAXA002=IRRF e/ou COFINS',
       '',
       'TAX001',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       760,
       4,
       'TAX002',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '%IPI ou %IRRF',
       'Aliquota ISS(A TAXA002 pode mudar conforme descrio da TAXA001',
       '',
       'TAX002',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       770,
       6,
       'TAXICM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       'F',
       'Taxa de ICMS',
       'Taxa de ICMS',
       '',
       'TAXICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       780,
       6,
       'TAXIPI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       'F',
       'Taxa de IPI',
       'Taxa de IPI',
       '',
       'TAXIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       790,
       4,
       'TAXIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '%IRRF',
       '% IRRF',
       '',
       'TAXIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       800,
       4,
       'TAXISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '%ISS',
       '%ISS',
       '',
       'TAXISS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       810,
       30,
       'TIP001_DOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tributado',
       'Tributado',
       '',
       'TIP001_DOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       820,
       30,
       'TIPPRO_DOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Produto',
       'Tipo Produto',
       '',
       'TIPPRO_DOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       830,
       16,
       'TOTCMG',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Total CM ger',
       'Valor Total CM ger.',
       '',
       'TOTCMG',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       840,
       16,
       'TOT_CM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Vlr.Total C.M.Fiscal',
       'Vlr.Total C.M.Fiscal',
       '',
       'TOT_CM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       850,
       7,
       'VEN_DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data/Hora Venda',
       'Data/Hora Venda',
       '',
       'VEN_DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       860,
       30,
       'VINCUL_DOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Vnculo',
       'Vnculo',
       '',
       'VINCUL_DOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       870,
       9,
       'VLR001',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor ICMS / ISS',
       'Valor ICMS / ISS',
       '',
       'VLR001',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       880,
       9,
       'VLR002',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor IPI / IRRF',
       'Valor IPI / IRRF',
       '',
       'VLR002',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       890,
       12,
       'VLRCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor do cofins',
       'Valor do cofins',
       '',
       'VLRCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       900,
       12,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Desconto',
       'Valor Desconto',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       910,
       12,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor do ICMS',
       'Valor do ICMS',
       '',
       'VLRICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       920,
       12,
       'VLRIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor do IPI',
       'Valor do IPI',
       '',
       'VLRIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       930,
       9,
       'VLRIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor IRRF',
       'Valor IRRF',
       '',
       'VLRIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       940,
       9,
       'VLRISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor ISS',
       'Valor ISS',
       '',
       'VLRISS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       950,
       12,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr Unitrio Lquido',
       'Vlr Unitrio Lquido',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       960,
       12,
       'VLRLIQPROPOR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Liquido Propor',
       'Valor Liquido Propor',
       '',
       'VLRLIQPROPOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       970,
       14,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Item',
       'Valor Item',
       '',
       'VLRMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       980,
       12,
       'VLRORI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Original',
       'Valor Original',
       '',
       'VLRORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       990,
       12,
       'VLRPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor do PIS',
       'Valor do PIS',
       '',
       'VLRPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIEV',
       '--',
       1000,
       12,
       'VLRUNI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Unitrio',
       'Valor Unitrio',
       '',
       'VLRUNI',
       'F' FROM DUAL
);

/*-- SEQ 9966 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VIF ',
       TO_NUMBER(null),
       'VIF ',
       'Ive. x Fis.',
       'TV_IVE_FIS',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VIF.CODFIL,VIF.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 9967 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VIF ','--','' FROM DUAL
UNION ALL
SELECT 'VIF ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VIF ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VIF ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VIF ','99','Outros' FROM DUAL
);

/*-- SEQ 9968 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VIF ',
       '99',
       380,
       5,
       'CODCNC',
       'G',
       'DCNC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCNC.NOMCNC',
       'V',
       '',
       '',
       'N',
       '',
       'Concorrente',
       'Cdigo do Concorrente que motivou a Variao de Preos',
       'DCNC.CODTAB = VIF.CODCNC',
       'CODCNC',
       '' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '01',
       10,
       12,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       '9',
       'F',
       'Cdigo da Cor',
       'Codigo da cor (diviso)',
       'DIV.CODITE (+) = VIF.CODCOR',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL(+) = VIF.CODFIL',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '01',
       30,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Codigo do produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '99',
       370,
       5,
       'CODMOT',
       'G',
       'DMVP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMVP.DESMOT',
       'V',
       '',
       '',
       'N',
       '',
       'Mot.Variao Preos',
       'Motivo da Variao de Preos',
       'DMVP.CODMOT = VIF.CODMOT',
       'CODMOT',
       'T' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '01',
       40,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       'F',
       'A',
       'F',
       'Srie',
       'Cdigo da srie',
       'VIF.CODSER=DSER.CODSER (+)',
       'CODSER',
       'T' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '01',
       50,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       '9',
       'F',
       'Cdigo do Tamanho',
       'Cdigo do tamanho (sub-diviso)',
       'SUB.CODITE (+) = VIF.CODTAM',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '03',
       60,
       9,
       'COMISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Comisso',
       'Comisso',
       '',
       'COMISS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '99',
       70,
       1,
       'DUMMY',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'F',
       '',
       'Controle Interno',
       '',
       'DUMMY',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '03',
       80,
       12,
       'EMBORI',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       '9',
       'F',
       'Embalagem Original',
       'Embalagem Original',
       'VIF.EMBORI=SUB.CODITE(+)',
       'EMBORI',
       'T' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '03',
       90,
       12,
       'EMBQTD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Quantidade Original',
       'Quantidade Original',
       '',
       'EMBQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '99',
       100,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Exportar?',
       'Exportar',
       '',
       'EXPORT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '01',
       110,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial de incluso do produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '--',
       360,
       3,
       'FILORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Origem',
       '',
       'FILORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '01',
       120,
       1,
       'ICMTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       '9',
       'F',
       'Tipo Tributao',
       'Tipo de tributao do produto',
       '',
       'ICMTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '03',
       130,
       12,
       'ITELIQ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Valor Item Lquido',
       'Valor Item Lquido',
       '',
       'ITELIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '03',
       140,
       12,
       'ITEORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Item de Origem',
       'Item de Origem',
       '',
       'ITEORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '01',
       150,
       1,
       'LANEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       ' ',
       'A',
       'F',
       'Estoque',
       'Estoque',
       '',
       'LANEST',
       'T' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '01',
       350,
       6,
       'NATFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Natureza Fiscal',
       'Natureza Fiscal',
       '',
       'NATFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '01',
       160,
       20,
       'NUMEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Nm. Externo',
       'Nmero externo',
       '',
       'NUMEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '03',
       170,
       12,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Item',
       'Nmero do item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '01',
       180,
       12,
       'NUMNOT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero da Nota',
       'Nmero da Nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '01',
       190,
       10,
       'NUMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Nmero de Origem',
       'Nmero da Origem',
       '',
       'NUMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '03',
       200,
       12,
       'QTDMOV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Qtde',
       'Quantidade vendida',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '03',
       210,
       7,
       'REDITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base reduzida ICMS',
       'Base reduzida de ICMS do item',
       '',
       'REDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '03',
       220,
       12,
       'REDVLR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Valor Reduzido',
       'Valor Reduzido',
       '',
       'REDVLR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '01',
       230,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '01',
       240,
       1,
       'SITKIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Kit',
       'Situao de Kit',
       '',
       'SITKIT',
       'T' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '01',
       250,
       1,
       'SITMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Normal ou Cancelado',
       '',
       'SITMOV',
       'T' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '03',
       260,
       4,
       'TAX001',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% ICMS',
       'ICMS(Quando Material) a TAXA002=IPI e ISS(Quando Servio) a TAXA002=IRRF',
       '',
       'TAX001',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '03',
       270,
       4,
       'TAX002',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% ISS',
       'Aliquota ISS(A TAXA002 pode mudar conforme descrio da TAXA001',
       '',
       'TAX002',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '01',
       280,
       1,
       'TIP001',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tributado',
       'Tributado',
       '',
       'TIP001',
       'T' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '01',
       290,
       1,
       'TIPPRO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Produto',
       'Tipo Produto',
       '',
       'TIPPRO',
       'T' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '02',
       300,
       7,
       'VEN_DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data/Hora Venda',
       'Data/Hora Venda',
       '',
       'VEN_DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '01',
       310,
       1,
       'VINCUL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Vnculo',
       'Vnculo',
       '',
       'VINCUL',
       'T' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '03',
       320,
       9,
       'VLR001',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor 001',
       'Valor 001',
       '',
       'VLR001',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '03',
       330,
       9,
       'VLR002',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor 002',
       'Valor 002',
       '',
       'VLR002',
       'F' FROM DUAL
UNION ALL
SELECT 'VIF ',
       '03',
       340,
       8,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Item',
       'Valor total do item',
       '',
       'VLRMOV',
       'F' FROM DUAL
);

/*-- SEQ 9969 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VIF ',
       'ICMTIP',
       0,
       '0',
       'Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIF ',
       'ICMTIP',
       0,
       '1',
       'No tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIF ',
       'ICMTIP',
       0,
       '2',
       'Isento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIF ',
       'ICMTIP',
       0,
       '3',
       'Substitudo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIF ',
       'ICMTIP',
       0,
       '4',
       'Isento no estado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIF ',
       'LANEST',
       0,
       'C',
       'Confirma Reserva',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIF ',
       'LANEST',
       0,
       'N',
       'Nao (s Histrico)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIF ',
       'LANEST',
       0,
       'R',
       'Reserva',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIF ',
       'LANEST',
       0,
       'S',
       'Baixa Estoque',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIF ',
       'SITKIT',
       0,
       '1',
       'Header',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIF ',
       'SITKIT',
       0,
       '2',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIF ',
       'SITKIT',
       0,
       '3',
       'Item Kit',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIF ',
       'SITMOV',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIF ',
       'SITMOV',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIF ',
       'TIP001',
       0,
       'M',
       'Material',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIF ',
       'TIP001',
       0,
       'S',
       'Servios',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIF ',
       'TIPPRO',
       0,
       ' ',
       'Material',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIF ',
       'TIPPRO',
       1,
       ' ',
       'Servio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIF ',
       'VINCUL',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIF ',
       'VINCUL',
       0,
       'C',
       'Completo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIF ',
       'VINCUL',
       0,
       'N',
       'No  vnculo',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9970 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VIH ',
       TO_NUMBER(null),
       'VIH ',
       'IXT x HAQ',
       'TV_IXT_HAQ',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VIH.CODFIL,VIH.CODBCO',
       '' FROM DUAL
);

/*-- SEQ 9971 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VIH ','--','' FROM DUAL
UNION ALL
SELECT 'VIH ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VIH ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VIH ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VIH ','99','Outros' FROM DUAL
);

/*-- SEQ 9972 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VIH ',
       '01',
       10,
       3,
       'CODBCO',
       'A',
       'DBCO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DBCO.NBANCO',
       'V',
       '',
       '',
       'N',
       'F',
       'Banco',
       'Cdigo do Banco',
       'DBCO.CBANCO(+) = VIH.CODBCO',
       'CODBCO',
       'T' FROM DUAL
UNION ALL
SELECT 'VIH ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = VIH.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIH ',
       '01',
       30,
       10,
       'CTACRR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm. Conta Corrente',
       'Nmero da Conta Corrente',
       '',
       'CTACRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIH ',
       '01',
       40,
       5,
       'INSTR1',
       'S',
       'DINS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DINS.DESINS',
       'V',
       '',
       '',
       'A',
       'F',
       'Instruco 1',
       'Codigo de instrucao 1 (TD_INS)',
       'DINS.CODTAB = VIH.INSTR1',
       'INSTR1',
       'T' FROM DUAL
UNION ALL
SELECT 'VIH ',
       '01',
       50,
       5,
       'INSTR2',
       'S',
       'DINS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DINS.DESINS',
       'V',
       '',
       '',
       'A',
       'F',
       'Instruco 2',
       'Codigo de instrucao 2 (TD_INS)',
       'DINS.CODTAB = VIH.INSTR2',
       'INSTR2',
       'T' FROM DUAL
UNION ALL
SELECT 'VIH ',
       '01',
       60,
       4000,
       'LINHA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIH ',
       '01',
       70,
       5,
       'NUMAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero da Agncia',
       'Nmero da Agncia',
       '',
       'NUMAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIH ',
       '99',
       80,
       1,
       'NUMREG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Nmero Registro?',
       'Nmero Registro?',
       '',
       'NUMREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VIH ',
       '99',
       90,
       1,
       'REGIST',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Registra Instruo?',
       'Registra Instruo?',
       '',
       'REGIST',
       'F' FROM DUAL
UNION ALL
SELECT 'VIH ',
       '01',
       100,
       12,
       'REMBCO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Remessa Banco',
       'Remessa Banco',
       '',
       'REMBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'VIH ',
       '99',
       110,
       1,
       'SEGREG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Seg. Registro?',
       'Seg. Registro?',
       '',
       'SEGREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VIH ',
       '99',
       120,
       1,
       'TIPREG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tipo Registro? ',
       'Tipo Registro?',
       '',
       'TIPREG',
       'F' FROM DUAL
);

/*-- SEQ 9973 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VIHL',
       TO_NUMBER(null),
       'VIHL',
       'IXT x HLT',
       'TV_IXT_HLT',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VIHL.CODFIL,VHIL.CODBCO',
       '' FROM DUAL
);

/*-- SEQ 9974 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VIHL','--','' FROM DUAL
UNION ALL
SELECT 'VIHL','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VIHL','02','Datas' FROM DUAL
UNION ALL
SELECT 'VIHL','03','Valores' FROM DUAL
UNION ALL
SELECT 'VIHL','99','Outros' FROM DUAL
);

/*-- SEQ 9975 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VIHL',
       '01',
       10,
       3,
       'CODBCO',
       'A',
       'DBCO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DBCO.NBANCO',
       'V',
       '',
       '',
       'N',
       'F',
       'Banco',
       'Cdigo do Banco',
       'DBCO.CBANCO(+) = VIHL.CODBCO',
       'CODBCO',
       'T' FROM DUAL
UNION ALL
SELECT 'VIHL',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = VIHL.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHL',
       '01',
       30,
       10,
       'CTACRR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm. Conta Corrente',
       'Nmero da Conta Corrente',
       '',
       'CTACRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHL',
       '01',
       40,
       5,
       'INSTR1',
       'S',
       'DINS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DINS.DESINS',
       'V',
       '',
       '',
       'A',
       'F',
       'Instruco 1',
       'Codigo de instrucao 1 (TD_INS)',
       'DINS.CODTAB = VIHL.INSTR1',
       'INSTR1',
       'T' FROM DUAL
UNION ALL
SELECT 'VIHL',
       '01',
       50,
       5,
       'INSTR2',
       'S',
       'DINS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DINS.DESINS',
       'V',
       '',
       '',
       'A',
       'F',
       'Instruco 2',
       'Codigo de instrucao 2 (TD_INS)',
       'DINS.CODTAB = VIHL.INSTR2',
       'INSTR2',
       'T' FROM DUAL
UNION ALL
SELECT 'VIHL',
       '99',
       60,
       4000,
       'LINHA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHL',
       '01',
       70,
       5,
       'NUMAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero da Agncia',
       'Nmero da Agncia',
       '',
       'NUMAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHL',
       '99',
       80,
       1,
       'NUMREG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Nmero Registro?',
       'Nmero Registro?',
       '',
       'NUMREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHL',
       '99',
       90,
       1,
       'REGIST',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Registra Instruo?',
       'Registra Instruo?',
       '',
       'REGIST',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHL',
       '03',
       100,
       12,
       'REMBCO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Remessa Banco',
       'Remessa Banco',
       '',
       'REMBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHL',
       '99',
       110,
       1,
       'SEGREG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Seg. Registro?',
       'Seg. Registro?',
       '',
       'SEGREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHL',
       '99',
       120,
       1,
       'TIPREG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tipo Registro? ',
       'Tipo Registro?',
       '',
       'TIPREG',
       'F' FROM DUAL
);

/*-- SEQ 9976 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VIHP',
       TO_NUMBER(null),
       'VIHP',
       'PCIA - Inventrio HP',
       'TV_PCIA_INV_HP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 9977 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VIHP','--','' FROM DUAL
UNION ALL
SELECT 'VIHP','01','Filtros' FROM DUAL
UNION ALL
SELECT 'VIHP','05','Campo da HP' FROM DUAL
UNION ALL
SELECT 'VIHP','99','Outros' FROM DUAL
);

/*-- SEQ 9978 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VIHP',
       '--',
       140,
       5,
       'CLASS2',
       'S',
       'DCL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL2.CLASS2',
       'V',
       '',
       '',
       'A',
       'F',
       'FAMILIA',
       '',
       'DCL2.CODTAB = VIHP.CLASS2',
       'CLASS2',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHP',
       '--',
       150,
       5,
       'CLASS3',
       'S',
       'DCL3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL3.CLASS3',
       'V',
       '',
       '',
       'A',
       'F',
       'GRUPO',
       '',
       'DCL3.CODTAB = VIHP.CLASS3',
       'CLASS3',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHP',
       '--',
       160,
       10,
       'CODIGO_ORIGEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Codigo Origem',
       '',
       '',
       'CODIGO_ORIGEM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHP',
       '--',
       170,
       9,
       'CODIGO_REVENDA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Codigo Revenda',
       '',
       '',
       'CODIGO_REVENDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHP',
       '05',
       30,
       2,
       'COUNTRY_CODE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'COUNTRY_CODE',
       '',
       '',
       'COUNTRY_CODE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHP',
       '--',
       200,
       7,
       'DATA_IVENTARIO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Inventario',
       '',
       '',
       'DATA_IVENTARIO',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHP',
       '01',
       130,
       7,
       'DATOPE',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data do Inventrio',
       '',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHP',
       '05',
       70,
       1,
       'HP_PRODUCT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'HP_PRODUCT',
       '',
       '',
       'HP_PRODUCT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHP',
       '05',
       50,
       20,
       'HP_PRODUCT_NUMBER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'HP_PRODUCT_NUMBER',
       '',
       '',
       'HP_PRODUCT_NUMBER',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHP',
       '05',
       40,
       10,
       'INVENTORY_DATE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'INVENTORY_DATE',
       '',
       '',
       'INVENTORY_DATE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHP',
       '05',
       90,
       12,
       'IN_TRANSIT_UNITS',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'IN_TRANSIT_UNITS',
       '',
       '',
       'IN_TRANSIT_UNITS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHP',
       '--',
       190,
       30,
       'MARCA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Marca',
       '',
       '',
       'MARCA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHP',
       '05',
       80,
       12,
       'ON_HAND_UNITS',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'ON_HAND_UNITS',
       '',
       '',
       'ON_HAND_UNITS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHP',
       '--',
       210,
       10,
       'PAIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Pais',
       '',
       '',
       'PAIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHP',
       '--',
       220,
       20,
       'PART_NUMBER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Part_Number',
       '',
       '',
       'PART_NUMBER',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHP',
       '05',
       10,
       9,
       'PATNER_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'PATNER_ID',
       '',
       '',
       'PATNER_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHP',
       '--',
       230,
       12,
       'SALDO_FISICO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Saldo Fisico',
       '',
       '',
       'SALDO_FISICO',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHP',
       '--',
       240,
       12,
       'SALDO_REAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Saldo Real',
       '',
       '',
       'SALDO_REAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHP',
       '--',
       250,
       12,
       'SALDO_TRANSITO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Saldo Transito',
       '',
       '',
       'SALDO_TRANSITO',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHP',
       '05',
       20,
       28,
       'STORE_NAME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'STORE_NAME',
       '',
       '',
       'STORE_NAME',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHP',
       '05',
       100,
       12,
       'TOTAL_INVENTORY',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'TOTAL_INVENTORY',
       '',
       '',
       'TOTAL_INVENTORY',
       'F' FROM DUAL
UNION ALL
SELECT 'VIHP',
       '05',
       60,
       20,
       'UCP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UCP',
       '',
       '',
       'UCP',
       'F' FROM DUAL
);

/*-- SEQ 9979 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VIN ',
       TO_NUMBER(null),
       'VIN ',
       'Vendas(Nota Complem)',
       'TT_VEN',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'VIN.CODFIL,VIN.NUMECF,VIN.CODSER,VIN.NUMNOT',
       '' FROM DUAL
);

/*-- SEQ 9980 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VIN ','--','' FROM DUAL
UNION ALL
SELECT 'VIN ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VIN ','02','Valores' FROM DUAL
UNION ALL
SELECT 'VIN ','03','Dados de Transporte' FROM DUAL
UNION ALL
SELECT 'VIN ','04','Datas' FROM DUAL
UNION ALL
SELECT 'VIN ','05','Parmetro Data Retroativa' FROM DUAL
UNION ALL
SELECT 'VIN ','30','Impostos' FROM DUAL
UNION ALL
SELECT 'VIN ','40','Tributaes' FROM DUAL
UNION ALL
SELECT 'VIN ','99','Outros' FROM DUAL
);

/*-- SEQ 9981 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 30332,
       'DSER',
       'VIN ',
       '1',
       'N',
       '',
       '',
       'DSER.CODSER = VIN.CODSER AND
DSER.TITAVU = VIN.TITAVU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30333,
       'CLI ',
       'VIN ',
       '1',
       'N',
       '',
       '',
       'CLI.FILCLI = VIN.FILCLI AND
CLI.CODCLI = VIN.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30334,
       'ECOB',
       'VIN ',
       '01',
       'N',
       '',
       '',
       'ECOB.FILCLI(+) = VIN.FILCLI AND
ECOB.CODCLI(+) = VIN.CODCLI AND
ECOB.CODFIL(+) = VIN.FILCOB AND
ECOB.NUMEND(+) = VIN.ENDCOB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30335,
       'EENT',
       'VIN ',
       '01',
       'N',
       '',
       '',
       'EENT.FILCLI(+) = VIN.FILCLI AND
EENT.CODCLI(+) = VIN.CODCLI AND
EENT.CODFIL(+) = VIN.FILENT AND
EENT.NUMEND(+) = VIN.ENDENT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30336,
       'EFAT',
       'VIN ',
       '01',
       'N',
       '',
       '',
       'EFAT.FILCLI(+) = VIN.FILCLI AND
EFAT.CODCLI(+) = VIN.CODCLI AND
EFAT.CODFIL(+) = VIN.FILFAT AND
EFAT.NUMEND(+) = VIN.ENDFAT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30337,
       'IND ',
       'VIN ',
       '01',
       'N',
       '',
       '',
       'IND.FILCLI(+) = VIN.FILGUI AND
IND.CODCLI(+) = VIN.CODGUI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30338,
       'REL ',
       'VIN ',
       '1',
       'N',
       '',
       '',
       'REL.FILPAR = VIN.FILTRA AND
REL.CODPAR = VIN.CODTRA AND
REL.TIPPAR = VIN.TIPTRA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30339,
       'TPR ',
       'VIN ',
       '1',
       'N',
       '',
       '',
       'TPR.CODFIL = VIN.FILPRE AND
TPR.CODPRE = VIN.CODPRE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30340,
       'TRA ',
       'VIN ',
       '1',
       'N',
       '',
       '',
       'TRA.FILCLI = VIN.FILTRA AND
TRA.CODCLI = VIN.CODTRA
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30341,
       'USU ',
       'VIN ',
       '1',
       'N',
       '',
       '',
       'USU.FILUSU = VIN.FILUSU AND
USU.CODUSU = VIN.CODUSU
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30342,
       'VDD ',
       'VIN ',
       '1',
       'N',
       '',
       '',
       'VDD.FILUSU = VIN.FILVEN AND
VDD.CODUSU = VIN.CODVEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30343,
       'FAT ',
       'VIN ',
       'N',
       '1',
       '',
       '',
       'FAT.CODFIL = VIN.CODFIL AND
FAT.SEQUEN = VIN.SEQFAT
',
       '(CASE WHEN FAT.VLRNOT = 0 THEN 0 ELSE VIN.VLRLIQ/FAT.VLRNOT END)',
       '' FROM DUAL
UNION ALL
SELECT 30344,
       'REC ',
       'VIN ',
       'N',
       '1',
       '',
       '',
       'REC.CODFIL = VIN.CODFIL AND
REC.SEQUEN = VIN.SEQUEN',
       '(case when VIN.VLRLIQ = 0 then 0 else REC.VLRPAR / VIN.VLRLIQ end)',
       '' FROM DUAL
UNION ALL
SELECT 30345,
       'IVE ',
       'VIN ',
       'N',
       '1',
       '',
       '',
       'IVE.SEQUEN = VIN.SEQUEN AND
IVE.CODFIL = VIN.CODFIL
',
       '(CASE WHEN VIN.VLRNOT = 0 THEN 0 ELSE IVE.VLRMOV/VIN.VLRNOT END)',
       '' FROM DUAL
UNION ALL
SELECT 30346,
       'IVI ',
       'VIN ',
       'N',
       '01',
       '',
       '',
       'IVI.CODFIL = VIN.CODFIL(+) AND
IVI.SEQUEN = VIN.SEQUEN(+)
',
       '(CASE WHEN VIN.VLRNOT = 0 THEN 0 ELSE IVI.VLRMOV/VIN.VLRNOT END)',
       '' FROM DUAL
UNION ALL
SELECT 30347,
       'PLA ',
       'VIN ',
       'N',
       '1',
       '',
       '',
       'PLA.FILPGT = VIN.FILPGT AND
PLA.CODPGT = VIN.CODPGT
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45928,
       'RECP',
       'VIN ',
       'N',
       '1',
       '',
       '',
       'RECP.ORI_CODFIL = VIN.CODFIL AND
RECP.ORI_SEQUEN = VIN.SEQUEN',
       '(case when VIN.VLRLIQ = 0 then 0 else RECP.VLRPAR / VIN.VLRLIQ end)',
       '' FROM DUAL
);

/*-- SEQ 9982 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VIN ',
       '05',
       2270,
       8,
       ':VIN.PR_DATA',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Retroativa',
       'Data Retroativa',
       '',
       ':VIN.PR_DATA',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '04',
       740,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'VIN ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(VIN.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       350,
       4,
       'ANO_DATHOR',
       'A',
       '',
       0,
       0,
       'VIN ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       '',
       'N',
       'T',
       'Ano~Incluso',
       'Ano de Data e hora da operao',
       '',
       'TO_CHAR(VIN.DATHOR,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       30,
       4,
       'ANO_DATSAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VIN ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'T',
       'Ano de Data Sada',
       'Ano de Data Sada',
       '',
       'TO_CHAR(VIN.DATSAI,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       770,
       4,
       'ANO_PROPGT',
       'A',
       '',
       0,
       0,
       'VIN ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       '',
       'N',
       'T',
       'Ano de Prox. Pagamen',
       'Ano de Data prximo pagamento ou data do cancelamento',
       '',
       'TO_CHAR(VIN.PROPGT,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '--',
       1420,
       256,
       'ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Assinatura para PAF-ECF',
       '',
       'ASSINA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       691,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN VIN.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '04',
       720,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'VIN ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '30',
       590,
       1,
       'AUTENT',
       'L',
       '',
       0,
       0,
       'VIN ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'VEN',
       'F',
       'A',
       'T',
       'Autenticada?',
       'Indica se a nota j foi autenticada',
       '',
       'AUTENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '40',
       1310,
       12,
       'BASICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Base de Clculo ICMS',
       'Base de Clculo de ICMS',
       '',
       'BASICM',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '40',
       1320,
       12,
       'BASIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Base de Clculo IRRF',
       'Base de Clculo de IRRF',
       '',
       'BASIRR',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '40',
       1330,
       12,
       'BASISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Base de Clculo ISS',
       'Base de Clculo de ISS',
       '',
       'BASISS',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '02',
       90,
       12,
       'BASUBS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base Sub. Tributria',
       'Base da Substituio Tributria',
       '',
       'BASUBS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       1820,
       44,
       'CHAVEA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave de Acesso NF-e',
       'Chave de Acesso da NF-e',
       '',
       'CHAVEA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2330,
       44,
       'CHVCAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Chave Cancelamento',
       'Chave de Autorizao do Cancelamento',
       '',
       'CHVCAN',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2240,
       6,
       'CHVIBP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Chave do IBPT',
       'Chave do IBPT',
       '',
       'CHVIBP',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       1090,
       5,
       'CNT_RO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cont. Reinicio Oper.',
       'Contador de Reinicio de Operao',
       '',
       'CNT_RO',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       320,
       6,
       'CODCLI',
       'A',
       '',
       0,
       0,
       'VIN ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '9',
       'F',
       'Cdigo cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '02',
       190,
       5,
       'CODCTR',
       'F',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       'F',
       '9',
       'F',
       'Unidade de Negcios',
       'Unidade de Negcios',
       'VIN.CODCTR = DCTR.CODTAB(+)',
       'CODCTR',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       800,
       5,
       'CODDEV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo da Devoluo',
       'Cdigo da Devoluo',
       '',
       'CODDEV',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       180,
       15,
       'CODEXT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       260,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       0,
       'VIN ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'VEN',
       'F',
       'A',
       'T',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL(+) = VIN.CODFIL',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '02',
       100,
       5,
       'CODFIN',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Cod. da Financeira',
       'Cod. da Financeira',
       '',
       'CODFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       680,
       3,
       'CODGUI',
       'A',
       '',
       0,
       0,
       'VIN ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       'Cdigo do Guia',
       'Cdigo do Guia',
       '',
       'CODGUI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2410,
       6,
       'CODINT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cd. Parc. Intermed.',
       'Cdigo do Parceiro Intermediador',
       '',
       'CODINT',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '30',
       570,
       2,
       'CODNAT',
       'S',
       'DNAT',
       0,
       0,
       'VIN ',
       10,
       TO_NUMBER(null),
       '',
       'DNAT.NATURE',
       'V',
       'VEN',
       'F',
       'A',
       'T',
       'Natureza',
       'Natureza de operao',
       'VIN.CODNAT = DNAT.CODTAB (+)',
       'CODNAT',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       1060,
       38,
       'CODNSU',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo NSU',
       'Cdigo NSU (Nmero Sequencial nico)',
       '',
       'CODNSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       650,
       3,
       'CODPGT',
       'A',
       'PLA ',
       0,
       0,
       'VIN ',
       60,
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       'VEN',
       'F',
       'A',
       'T',
       'Plano',
       'Cdigo do plano de pagamento',
       'VIN.FILPGT = PLA.FILPGT(+) and VIN.CODPGT = PLA.CODPGT(+)',
       'CODPGT',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       710,
       2,
       'CODPRE',
       'S',
       'TPR ',
       0,
       0,
       'VIN ',
       120,
       TO_NUMBER(null),
       '',
       'TPR.DESPRE',
       'V',
       'VEN',
       'F',
       'A',
       'T',
       'Tab. de Preos',
       'Cdigo da tabela de preos',
       'VIN.FILPRE=TPR.CODFIL (+) and VIN.CODPRE=TPR.CODPRE (+)',
       'CODPRE',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       280,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       0,
       'VIN ',
       30,
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       'VEN',
       'F',
       'A',
       'T',
       'Srie',
       'Cdigo da srie',
       'VIN.CODSER=DSER.CODSER (+)',
       'CODSER',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '03',
       470,
       6,
       'CODTRA',
       'A',
       '',
       0,
       0,
       'VIN ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       'Cdigo Tranportadora',
       'Cdigo da Transportadora',
       '',
       'CODTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       610,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       0,
       'VIN ',
       20,
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       'VEN',
       'F',
       'A',
       'T',
       'Usurio',
       'Cdigo do usurio',
       'VIN.FILUSU = USU.FILUSU(+)  and VIN.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       1250,
       3,
       'CODVDP',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Vendedor Principal',
       'Vendedor Principal',
       'VIN.FILVDP = USU.FILUSU(+)  AND VIN.CODVDP = USU.CODUSU(+)',
       'CODVDP',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       630,
       3,
       'CODVEN',
       'A',
       'VDD ',
       0,
       0,
       'VIN ',
       40,
       TO_NUMBER(null),
       '',
       'VDD.APEUSU',
       'V',
       'VEN',
       'F',
       'A',
       'T',
       'Vendedor',
       'Cdigo do vendedor',
       'VIN.FILVEN = VDD.FILUSU (+)  and VIN.CODVEN = VDD.CODUSU (+)',
       'CODVEN',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '02',
       830,
       12,
       'COFINS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'COFINS',
       'COFINS',
       '',
       'COFINS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '02',
       430,
       2,
       'COMSOB',
       'S',
       '',
       0,
       0,
       'VIN ',
       70,
       30,
       '',
       '',
       'D',
       'VEN',
       'F',
       'A',
       'T',
       'Comisso Sobre',
       'Comisso sobre (ver tela plano)',
       '',
       'COMSOB',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       80,
       1,
       'CONSFI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'F',
       'Consumidor Final?',
       'Consumidor Final?',
       '',
       'CONSFI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '04',
       1010,
       7,
       'DATFIS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Fiscal',
       'Data Fiscal',
       '',
       'DATFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '04',
       330,
       8,
       'DATHOR',
       '@',
       '',
       0,
       0,
       'VIN ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '@',
       'T',
       'Data~Incluso',
       'Data e hora da operao',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '04',
       2380,
       8,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '04',
       10,
       8,
       'DATSAI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       'VIN ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'T',
       'Data Sada',
       'Data Sada',
       '',
       'DATSAI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '02',
       450,
       8,
       'DESCON',
       'F',
       '',
       2,
       0,
       'VIN ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '9',
       'T',
       'Desc/Acrscimo (%)',
       'Desconto / Acrscimo',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       1780,
       12,
       'DESICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Vlr iseno de ICMS',
       'Valor de iseno de ICMS',
       '',
       'DESICM',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '02',
       1770,
       12,
       'DESRAT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr total do descoto',
       'Valor total do desconto
',
       '',
       'DESRAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       1660,
       1,
       'DETTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Det.Tipo de Parceiro',
       'Detalhe do Tipo de Parceiro',
       '',
       'DETTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2290,
       12,
       'DOCIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '#N Doc. Importao',
       'Nmero do Documento de Importao (descontinuado)',
       '',
       'DOCIMP',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       1210,
       15,
       'DOCNFP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento p/ NFP',
       'Nmero do documento para Nota Fiscal Paulista',
       '',
       'DOCNFP',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       300,
       13,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Documento',
       'Documento (Srie + Sub-Srie + Nmero )',
       '',
       '(CASE COALESCE(VIN.NUMNOT,''0'') WHEN ''0'' THEN NULL ELSE VIN.CODSER||''/''||LTRIM(VIN.NUMECF)||''-''||LTRIM(VIN.NUMNOT) END)',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '03',
       550,
       1,
       'EMIDES',
       'L',
       '',
       0,
       0,
       'VIN ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'VEN',
       'F',
       'A',
       'T',
       'Frete Dest./Terc.?',
       'Frete  por conta do Destinatrio ou de Terceiros?',
       '',
       'EMIDES',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       50,
       2,
       'ENDCOB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'VIN ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nm. end. Cobrana',
       'Nmero do endereo de cobrana',
       '',
       'ENDCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       70,
       2,
       'ENDENT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'VIN ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nm. End. Entrega',
       'Nmero do endereo de entrega',
       '',
       'ENDENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       110,
       2,
       'ENDFAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'VIN ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nmero End. Fat.',
       'Nmero de endereo de fatura',
       '',
       'ENDFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '05',
       2260,
       1,
       'ENTREGUE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ent Fut Retroativa?',
       'Entrega Futura Retroativa?',
       '',
       '(CASE WHEN VIN.DATFIS IS NULL THEN ''T'' ELSE CASE WHEN (TRUNC(VIN.DATFIS) < :VIN.PR_DATA AND TRUNC(VEN.DATFIS) < :VIN.PR_DATA) THEN ''T'' ELSE ''F'' END END)',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '03',
       560,
       2,
       'ESPECI',
       'S',
       'DESP',
       0,
       0,
       'VIN ',
       110,
       TO_NUMBER(null),
       '',
       'DESP.ESPECI',
       'V',
       'VEN',
       'F',
       'A',
       'F',
       'Espcie do Volume',
       'Espcie do volume',
       'VEN.ESPECI = DESP.CODTAB (+)',
       'ESPECI',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2270,
       1,
       'EXPFIS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Exportado Fiscal?',
       'Exportado Fiscal?',
       '',
       'EXPFIS',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       240,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Exportar?',
       'Exportar?',
       '',
       'EXPORT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       310,
       3,
       'FILCLI',
       'A',
       '',
       0,
       0,
       'VIN ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       140,
       3,
       'FILCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VIN ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do endereo de cobrana',
       '',
       'FILCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2360,
       3,
       'FILCRE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial NF cred ICMS',
       'Filial da Nota de Transferncia de saldo credor de ICMS',
       'DFIL.CODFIL(+) = VIN.FILCRE',
       'FILCRE',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       150,
       3,
       'FILENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VIN ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do endereo de entrega',
       '',
       'FILENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       200,
       3,
       'FILFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VIN ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do endereo de fatura',
       '',
       'FILFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       670,
       3,
       'FILGUI',
       'A',
       '',
       0,
       0,
       'VIN ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       '',
       'Filial do guia',
       '',
       'FILGUI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2400,
       3,
       'FILINT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Fil. Parc. Intermed.',
       'Filial do Parceiro Intermediador',
       'DFIL.CODFIL(+) = VIN.FILINT',
       'FILINT',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2190,
       3,
       'FILORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Filial nota origem',
       'Filial da nota de origem',
       '',
       'FILORI',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       640,
       3,
       'FILPGT',
       'A',
       '',
       0,
       0,
       'VIN ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       '',
       'Filial do plano de pagamento',
       '',
       'FILPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       700,
       3,
       'FILPRE',
       'A',
       '',
       0,
       0,
       'VIN ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       '',
       'Filial da tabela de preo',
       '',
       'FILPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '03',
       460,
       3,
       'FILTRA',
       'A',
       '',
       0,
       0,
       'VIN ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       '',
       'Filial da Transportadora',
       '',
       'FILTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       600,
       3,
       'FILUSU',
       'A',
       '',
       0,
       0,
       'VIN ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       1290,
       3,
       'FILVDP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Vendedor Principal',
       '',
       'FILVDP',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       620,
       3,
       'FILVEN',
       'A',
       '',
       0,
       0,
       'VIN ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       '',
       'Filial do vendedor',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '02',
       410,
       1,
       'FINANC',
       'L',
       '',
       0,
       0,
       'VIN ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'VEN',
       'F',
       'A',
       'F',
       'Gera Dados Financ.?',
       'Gera dados financeiros',
       '',
       'FINANC',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2040,
       1,
       'FINNFE',
       'S',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Finalidade da NF-e',
       'Finalidade da NFe',
       '',
       'FINNFE ',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       360,
       1,
       'FLGEST',
       'A',
       '',
       0,
       0,
       'VIN ',
       90,
       30,
       '',
       '',
       'D',
       'VEN',
       'F',
       'A',
       'T',
       'Situao',
       'Estado (Cancelado/Quitado/Em aberto)',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       1300,
       1,
       'FLGNFE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'NF-e',
       'NF-e',
       '',
       'FLGNFE',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       40,
       1,
       'FLGTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Pessoa',
       'Tipo de Pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2250,
       34,
       'FONIBP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Fonte IBPT',
       'Fonte IBPT (Fonte Usada no Clculo do Imposto)',
       '',
       'FONIBP',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '02',
       1130,
       12,
       'FUNRUR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Fundo Rural Retido',
       'Fundo Rural Retido',
       '',
       'FUNRUR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2420,
       100,
       'ID_INT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo ID Intermed',
       'Cdigo de Identificao do Intermediador',
       '',
       'ID_INT',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       1030,
       1,
       'IMPRIM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Fica p/  impresso?',
       'Disponvel para Impresso',
       '',
       'IMPRIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '--',
       1930,
       1,
       'INDFRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Indicador Tipo Frete',
       'Indicador de Tipo de Frete',
       '',
       'INDFRE',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       160,
       1,
       'LANVEN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'F',
       'Considera Venda?',
       'Considera Venda?',
       '',
       'LANVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '03',
       500,
       5,
       'MARCAS',
       'A',
       '',
       0,
       0,
       'VIN ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'VEN',
       'F',
       'A',
       'T',
       'Marcas',
       'Marcas',
       '',
       'MARCAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '04',
       730,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'VIN ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(VIN.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       340,
       2,
       'MES_DATHOR',
       'A',
       '',
       0,
       0,
       'VIN ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       '',
       'N',
       'T',
       'Ms~Incluso',
       'Ms de Data e hora da operao',
       '',
       'TO_CHAR(VIN.DATHOR,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '04',
       20,
       2,
       'MES_DATSAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VIN ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'T',
       'Ms de Data Sada',
       'Ms de Data Sada',
       '',
       'TO_CHAR(VIN.DATSAI,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       760,
       2,
       'MES_PROPGT',
       'A',
       '',
       0,
       0,
       'VIN ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       '',
       'N',
       'T',
       'Ms de Prox. Pagamen',
       'Ms de Data prximo pagamento ou data do cancelamento',
       '',
       'TO_CHAR(VIN.PROPGT,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '--',
       2260,
       2,
       'MODNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Modelo Fiscal',
       'Modelo Fiscal',
       '',
       'MODNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2180,
       10,
       'MOTCAN',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Motivo cancelamento',
       'Motivo do Cancelamento',
       '',
       'RTF2TXT(MOTCAN)',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2320,
       1,
       'NFRECI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'NF sobre Recibo Prov',
       'NF sobre Recibo Provisrio?',
       '',
       'NFRECI',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '30',
       580,
       2,
       'NROIMP',
       'S',
       '',
       0,
       0,
       'VIN ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '9',
       'T',
       'Nm. Impresses',
       'Nmero de vezes que a nota foi impressa',
       '',
       'NROIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       265,
       3,
       'NUMCODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '03',
       480,
       8,
       'NUMCON',
       'A',
       '',
       0,
       0,
       'VIN ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '9',
       'T',
       'Conhecimento',
       'Conhecimento de frete',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       270,
       3,
       'NUMECF',
       'A',
       'DECF',
       0,
       0,
       'VIN ',
       20,
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       'VEN',
       'F',
       '0',
       'T',
       'Nmero do ECF',
       'Nmero do ECF',
       'DECF.FILECF = VIN.CODFIL AND DECF.NUMECF = VIN.NUMECF',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       290,
       6,
       'NUMNOT',
       'A',
       '',
       0,
       0,
       'VIN ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '9',
       'T',
       'Nmero',
       'Nmero da Nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '03',
       490,
       4,
       'NUMVOL',
       'G',
       '',
       0,
       0,
       'VIN ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '9',
       'T',
       'Num.Volumes',
       'Nmero de Volumes',
       '',
       'NUMVOL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       660,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'VIN ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'VEN',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(VIN.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       1340,
       4000,
       'OBSFIS',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Obs Fis Complemetar',
       'Observaes Fiscais Complementares',
       '',
       'RTF2TXT(OBSFIS)',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2150,
       1,
       'ORICAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem Cancelamento',
       'Origem do Cancelamento',
       '',
       'ORICAN',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '02',
       1180,
       12,
       'OUTTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Outras Taxas',
       'Outras Taxas',
       '',
       'OUTTAX',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '02',
       400,
       8,
       'PERCOM',
       'F',
       '',
       2,
       0,
       'VIN ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       '9',
       'T',
       'Comis. s/ Parcelas',
       'Valor da comisso sobre as parcelas (exceto entrada)',
       '',
       'PERCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '02',
       420,
       8,
       'PERENT',
       'F',
       '',
       2,
       0,
       'VIN ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       '9',
       'T',
       'Comis. s/ Entrada',
       'Comisso (entrada)',
       '',
       'PERENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '03',
       530,
       14,
       'PESBRU',
       'F',
       '',
       4,
       0,
       'VIN ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       'N',
       'T',
       'Peso Bruto',
       'Peso lquido',
       '',
       'PESBRU',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '03',
       540,
       14,
       'PESLIQ',
       'F',
       '',
       4,
       0,
       'VIN ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       'N',
       'T',
       'Peso Lquido',
       'Peso bruto',
       '',
       'PESLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       840,
       7,
       'PLAFRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Placa Frete',
       'Placa Frete',
       '',
       'PLAFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '02',
       440,
       4,
       'PRAMED',
       'S',
       '',
       0,
       0,
       'VIN ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '9',
       'T',
       'Prazo Mdio',
       'Prazo mdio',
       '',
       'PRAMED',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '04',
       750,
       8,
       'PROPGT',
       'D',
       '',
       0,
       0,
       'VIN ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'D',
       'T',
       'Prox. Vencimento',
       'Data prximo Vencimento',
       '',
       '(SELECT MIN(REC.DATVEN) FROM TT_REC REC WHERE REC.CODFIL = VIN.CODFIL AND REC.SEQUEN = VIN.SEQUEN AND FLGEST = ''A'' AND SEQCHE IS NULL AND CARTAO IS NULL)',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '02',
       820,
       2,
       'QTDREN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Qtde Renegociada',
       'Qtde Renegociada',
       '',
       'QTDREN',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       1430,
       10,
       'QTDVENDIDA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       'N',
       '',
       'Qtd. Vendida',
       'Quantidade Vendida',
       '',
       '(SELECT SUM(QTDMOV) FROM TT_IVE WHERE VIN.CODFIL = CODFIL AND VIN.SEQUEN = SEQUEN AND SITMOV = ''N'' GROUP BY CODFIL, SEQUEN)',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2310,
       1,
       'RECIBO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Recibo Provisrio?',
       'Recibo Provisrio?',
       '',
       'RECIBO',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '02',
       130,
       12,
       'RETIDO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Imposto retido',
       'Valor do Importo Retido',
       '',
       'RETIDO',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2340,
       6,
       'SATCAN',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nm Cancelament SAT',
       'Nmero do CF-e de Cancelamento no SAT',
       '',
       'SATCAN',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '40',
       2350,
       12,
       'SEGRUR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Seguro Rural',
       'Valor Seguro Rural',
       '',
       'SEGRUR',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2370,
       10,
       'SEQCRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq. NF cred ICMS',
       'Sequenciador da Nota de Transferncia de saldo credor de ICMS',
       '',
       'SEQCRE',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       210,
       10,
       'SEQFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VIN ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Nmero sequencial interno da fatura',
       '',
       'SEQFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2200,
       10,
       'SEQORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq. nota de origem',
       'Sequenciador da nota de origem',
       '',
       'SEQORI',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       220,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VIN ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       1350,
       3,
       'SEREXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Serie Fis. Exportada',
       'Srie Fiscal Exportada',
       '',
       'SEREXT',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       690,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'VIN ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'VEN',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN VIN.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '02',
       370,
       8,
       'SINAL',
       'F',
       '',
       2,
       0,
       'VIN ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       '9',
       'T',
       'Sinal Relacionado',
       'Valor de sinal relacionado',
       '',
       'SINAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '02',
       120,
       12,
       'SUBSTT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Subst. Tributria',
       'Subst. Tributria',
       '',
       'SUBSTT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2170,
       1,
       'TIPESP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo de NF especial',
       'Tipo de NF especial',
       '',
       'TIPESP',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2300,
       1,
       'TIPIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       '#Tipo Doc. Importa',
       'Tipo de Documento de Importao (descontinuado)',
       '',
       'TIPIMP',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2390,
       10,
       'TIPINT',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'V',
       '',
       '',
       'N',
       '',
       'Tipo Intermediao',
       'Tipo da Intermediao',
       '',
       'TIPINT',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       790,
       1,
       'TIPNOT',
       'A',
       '',
       0,
       0,
       'VIN ',
       160,
       30,
       '',
       '',
       'D',
       'VEN',
       'F',
       'A',
       'F',
       'Tipo de Nota',
       'Tipo de Nota',
       '',
       'TIPNOT',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       230,
       1,
       'TIPTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VIN ',
       100,
       30,
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Tipo Transportadora',
       'Tipo Transportadora',
       '',
       'TIPTRA',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       250,
       1,
       'TIPTRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Venda',
       'Tipo Venda',
       '',
       'TIPTRO',
       'T' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       780,
       1,
       'TRIBUT',
       'L',
       '',
       0,
       0,
       'VIN ',
       150,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'VEN',
       'F',
       'A',
       'T',
       'Tributada?',
       'Define se a venda  tributada',
       '',
       'TRIBUT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       60,
       1,
       'UFLOJA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'F',
       'Dentro do Estado?',
       'Venda Dentro do Estado?',
       '',
       'UFLOJA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       850,
       2,
       'UF_FRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF Frete',
       'UF Frete',
       '',
       'UF_FRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '01',
       1000,
       100,
       'UNEPLACAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Placas do Cliente',
       'Placas do Cliente',
       '',
       'UNEPLACAS(VIN.CODFIL,VIN.SEQUEN)',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '--',
       1580,
       5,
       'VERNFE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Verso do Schema',
       'Verso do Schema',
       '',
       'VERNFE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       170,
       1,
       'VINCUL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'F',
       'Vinculada?',
       'Vinculada?',
       '',
       'VINCUL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '40',
       2280,
       12,
       'VLRADU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       '#Vl. Desp. Aduaneira',
       'Valor das Despesas Aduaneiras (descontinuado)',
       '',
       'VLRADU',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '40',
       1410,
       12,
       'VLRCFI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Valor Retido COFINS',
       'Valor Retido de COFINS',
       '',
       'VLRCFI',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '04',
       810,
       12,
       'VLRCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Vlr Ret PIS+COF+CSLL',
       'Valor Retido de PIS+COFINS+CSLL',
       '',
       'VLRCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '40',
       1360,
       12,
       'VLRCSL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Vlr Ret Contribuio',
       'Vlr Ret Contribuio Soc',
       '',
       'VLRCSL',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '03',
       520,
       8,
       'VLRFRE',
       'F',
       '',
       2,
       0,
       'VIN ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       '9',
       'T',
       'Frete',
       'Valor do Frete',
       '',
       'VLRFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2160,
       12,
       'VLRIBP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor do Imposto',
       'Valor do Imposto de Acordo com a Tabela do IBPT',
       '',
       'COALESCE(VIN.VLRIBP, COALESCE(VIN.VLRIBPFED,0)+COALESCE(VIN.VLRIBPEST,0)+COALESCE(VIN.VLRIBPMUN,0))',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2220,
       12,
       'VLRIBPEST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Impostos Est',
       'Valor de Impostos Estaduais',
       '',
       'VLRIBPEST',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2210,
       12,
       'VLRIBPFED',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Impostos Fed',
       'Valor de Impostos Federais',
       '',
       'VLRIBPFED',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '99',
       2230,
       12,
       'VLRIBPMUN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Impostos Mun',
       'Valor de Impostos Municipais',
       '',
       'VLRIBPMUN',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '40',
       1370,
       12,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Valor Total de ICMS',
       'Valor Total de ICMS',
       '',
       'VLRICM',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '40',
       1380,
       12,
       'VLRIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Valor Total de IRRF',
       'Valor Total de IRR',
       '',
       'VLRIRR',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '40',
       1390,
       12,
       'VLRISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Valor Total de ISS',
       'Valor Total de ISS',
       '',
       'VLRISS',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '02',
       390,
       8,
       'VLRLIQ',
       'F',
       '',
       2,
       0,
       'VIN ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       '9',
       'T',
       'Valor Lquido',
       'Valor lquido da nota',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '02',
       380,
       8,
       'VLRNOT',
       'F',
       '',
       2,
       0,
       'VIN ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       '9',
       'T',
       'Valor dos Itens',
       'Valor da nota',
       '',
       'VLRNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '40',
       1400,
       12,
       'VLRPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Valor Retido PIS',
       'Valor Retido de PIS',
       '',
       'VLRPIS',
       '' FROM DUAL
UNION ALL
SELECT 'VIN ',
       '03',
       510,
       8,
       'VLRSEG',
       'F',
       '',
       2,
       0,
       'VIN ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       '9',
       'T',
       'Seguro',
       'Valor do seguro do frete',
       '',
       'VLRSEG',
       'F' FROM DUAL
);

/*-- SEQ 9983 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VIN ',
       'COMSOB',
       5,
       ' ',
       'Recebido na compensao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'COMSOB',
       6,
       ' ',
       'A receber na compensao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'COMSOB',
       7,
       ' ',
       'Comisso sobre markup',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'COMSOB',
       8,
       ' ',
       'Markup no momento da Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'COMSOB',
       0,
       '0',
       'Lquido ao Vender',
       241,
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'COMSOB',
       1,
       '1',
       'Bruto ao Vender',
       242,
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'COMSOB',
       2,
       '2',
       'A receber no Vencimento',
       243,
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'COMSOB',
       3,
       '3',
       'Recebido no Recebimento',
       244,
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'COMSOB',
       4,
       '4',
       'A receber no Recebimento',
       245,
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'DETTIP',
       0,
       'E',
       'Governo Estadual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'DETTIP',
       0,
       'F',
       'Governo Federal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'DETTIP',
       0,
       'M',
       'Governo Municipal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'DETTIP',
       0,
       'O',
       'Outros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'FINNFE',
       4,
       ' ',
       'Devoluo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'FINNFE',
       1,
       ' ',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'FINNFE',
       2,
       ' ',
       'Complementar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'FINNFE',
       3,
       ' ',
       'Ajuste',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'FLGEST',
       0,
       'A',
       'Em Aberta',
       102,
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'FLGEST',
       0,
       'C',
       'Cancelada',
       100,
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'FLGEST',
       0,
       'Q',
       'Quitada',
       101,
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'FLGNFE',
       0,
       '0',
       'No enviado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'FLGNFE',
       0,
       '1',
       'Autorizada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'FLGNFE',
       0,
       '2',
       'Rejeitada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'FLGNFE',
       0,
       '3',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'FLGNFE',
       0,
       '4',
       'Inutilizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'FLGNFE',
       0,
       '5',
       'Enviando ao Sefaz',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'FLGNFE',
       0,
       '6',
       'Denegada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'FLGNFE',
       0,
       '8',
       'Erro de Importao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'FLGTIP',
       0,
       '0',
       'Fsica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'FLGTIP',
       0,
       '1',
       'Jurdica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'FLGTIP',
       0,
       '2',
       'Entidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'FLGTIP',
       0,
       '3',
       'Especial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'FLGTIP',
       0,
       '4',
       'M.E.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'FLGTIP',
       0,
       '5',
       'Filial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'INDFRE',
       3,
       ' ',
       'Prprio por conta do Remetente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'INDFRE',
       4,
       ' ',
       'Prprio por conta Destinatrio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'INDFRE',
       9,
       ' ',
       'Sem ocorrncia de Transporte',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'INDFRE',
       0,
       ' ',
       'Por conta do Remetente(CIF)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'INDFRE',
       1,
       ' ',
       'Por conta do Destinatrio(FOB)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'INDFRE',
       2,
       ' ',
       'Por conta de Terceiros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'ORICAN',
       0,
       '1',
       'Checkout',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'ORICAN',
       0,
       '2',
       'Backoffice',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'TIPESP',
       0,
       'A',
       'Avulsa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'TIPESP',
       0,
       'I',
       'Importada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'TIPIMP',
       0,
       '0',
       'Declarao de Importao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'TIPIMP',
       0,
       '1',
       'Declarao Simplificada de Imp',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'TIPNOT',
       0,
       'A',
       'Ambas (NFF)',
       279,
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'TIPNOT',
       0,
       'F',
       'Fatura',
       277,
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'TIPNOT',
       0,
       'N',
       'Nota Fiscal',
       278,
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'TIPTRO',
       0,
       '+',
       'Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'TIPTRO',
       0,
       '-',
       'Devoluo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIN ',
       'TIPTRO',
       0,
       'A',
       'Ambas',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9984 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VINC',
       0,
       'VINC',
       'Vinculos do Parceiro',
       'TT_CLI',
       'T',
       '',
       'TOTALL',
       'Clientes',
       '{FILCLI;CODCLI};ATU_EM;NOMCLI;ULTNOM;DOCUME;DOCCON',
       'NUMDOC',
       'NOMCLI',
       'Cliente',
       'T',
       '',
       'VINC.FILCLI,VINC.CODCLI
VINC.NOMCLI,VINC.ULTNOM
VINC.NUMDOC
',
       '' FROM DUAL
);

/*-- SEQ 9985 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VINC','--','' FROM DUAL
UNION ALL
SELECT 'VINC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VINC','02','Endereo' FROM DUAL
UNION ALL
SELECT 'VINC','03','Documentao' FROM DUAL
UNION ALL
SELECT 'VINC','04','Dados Financeiros' FROM DUAL
UNION ALL
SELECT 'VINC','05','Parametros para Postos de Combustivel (1)' FROM DUAL
UNION ALL
SELECT 'VINC','06','Parametros para Postos de Combustivel (2)' FROM DUAL
UNION ALL
SELECT 'VINC','07','Parametros para Postos de Combustivel (3)' FROM DUAL
UNION ALL
SELECT 'VINC','08','Parametros para Postos de Combustivel (4)' FROM DUAL
UNION ALL
SELECT 'VINC','09','Parametros para Postos de Combustivel (5)' FROM DUAL
UNION ALL
SELECT 'VINC','10','Parametros para Postos de Combustivel (6)' FROM DUAL
UNION ALL
SELECT 'VINC','11','Parametros para Postos de Combustivel (7)' FROM DUAL
UNION ALL
SELECT 'VINC','12','Doenas' FROM DUAL
UNION ALL
SELECT 'VINC','99','Outros' FROM DUAL
);

/*-- SEQ 9986 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VINC',
       '05',
       20,
       8,
       ':CLI.COMB1_DATINI,CLI.COMB1_DA',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data (1)',
       'Data (1)',
       '',
       ':VINC.COMB1_DATINI,VINC.COMB1_DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '06',
       40,
       8,
       ':CLI.COMB2_DATINI,CLI.COMB2_DA',
       'D',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data (2)',
       'Data (2)',
       '',
       ':VINC.COMB2_DATINI,VINC.COMB2_DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '07',
       90,
       15,
       ':CLI.COMB3_CODFIL',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Fil Combustivel (1)',
       'Fil Combustivel (1)',
       'VINC.:VINC.COMB3_CODFIL = DFIL.CODFIL',
       ':VINC.COMB3_CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '07',
       60,
       8,
       ':CLI.COMB3_DATINI,CLI.COMB3_DA',
       'D',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Filial 1',
       'Data Filial 1',
       '',
       ':VINC.COMB3_DATINI,VINC.COMB3_DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '08',
       100,
       15,
       ':CLI.COMB4_CODFIL',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Fil Combustivel (2)',
       'Fil Combustivel (2)',
       'VINC.:VINC.COMB4_CODFIL = DFIL.CODFIL',
       ':VINC.COMB4_CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '08',
       80,
       8,
       ':CLI.COMB4_DATINI,CLI.COMB4_DA',
       'D',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Filial 2',
       'Data Filial 2',
       '',
       ':VINC.COMB4_DATINI,VINC.COMB4_DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '09',
       12,
       15,
       ':CLI.COMB5_CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Fil Combustivel (3)',
       'Fil Combustivel (3)',
       'VINC.:VINC.COMB5_CODFIL = DFIL.CODFIL',
       ':VINC.COMB5_CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '09',
       11,
       8,
       ':CLI.COMB5_DATINI,CLI.COMB5_DA',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Filial 3',
       'Data Filial 3',
       '',
       ':VINC.COMB5_DATINI,VINC.COMB5_DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '10',
       12,
       15,
       ':CLI.COMB6_CODFIL',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Fil Combustivel (4)',
       'Fil Combustivel (4)',
       'VINC.:VINC.COMB6_CODFIL = DFIL.CODFIL',
       ':VINC.COMB6_CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '10',
       11,
       8,
       ':CLI.COMB6_DATINI,CLI.COMB6_DA',
       'D',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Filial 4',
       'Data Filial 4',
       '',
       ':VINC.COMB6_DATINI,VINC.COMB6_DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '11',
       12,
       15,
       ':CLI.COMB7_CODFIL',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Fil Combustivel (5)',
       'Fil Combustivel (5)',
       'VINC.:VINC.COMB7_CODFIL = DFIL.CODFIL',
       ':VINC.COMB7_CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '11',
       11,
       8,
       ':CLI.COMB7_DATINI,CLI.COMB7_DA',
       'D',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Filial 5',
       'Data Filial 5',
       '',
       ':VINC.COMB7_DATINI,VINC.COMB7_DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '01',
       55,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'CLI ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(VINC.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '99',
       55,
       4,
       'ANO_DATA01',
       'A',
       '',
       0,
       0,
       'CLI ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 1',
       '',
       'TO_CHAR(VINC.DATA01,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '99',
       65,
       4,
       'ANO_DATA02',
       'A',
       '',
       0,
       0,
       'CLI ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 2',
       '',
       'TO_CHAR(VINC.DATA02,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '99',
       75,
       4,
       'ANO_DATA03',
       'A',
       '',
       0,
       0,
       'CLI ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 3',
       '',
       'TO_CHAR(VINC.DATA03,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '01',
       65,
       4,
       'ANO_DATNAS',
       'A',
       '',
       0,
       0,
       'CLI ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ano de Nascto/Funda',
       'Ano de Data de nascimento',
       '',
       'TO_CHAR(VINC.DATNAS,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '01',
       75,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       0,
       'CLI ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ano de Data Incluso',
       'Ano de Data de operao (cadastramento)',
       '',
       'TO_CHAR(VINC.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '01',
       115,
       4,
       'ANO_NASCON',
       'A',
       '',
       0,
       0,
       'CLI ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ano de Nascto Cnj./',
       'Ano de Data de nascimento do cnjuge ou contato principal',
       '',
       'TO_CHAR(VINC.NASCON,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '04',
       85,
       4,
       'ANO_ULTCOM',
       'A',
       '',
       0,
       0,
       'CLI ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ano de ltima Compra',
       'Ano de Data da ltima compra',
       '',
       'TO_CHAR(VINC.ULTCOM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '01',
       50,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'CLI ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       130,
       1,
       'CALL_C',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Aceita Contato?',
       'Aceita Contato Telefnico',
       '',
       'CALL_C',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '99',
       20,
       2,
       'CATEG1',
       'S',
       'DCT1',
       0,
       20,
       'CLI ',
       10,
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'V',
       'CLI',
       'F',
       'A',
       'T',
       'Profisso/Ramo',
       'Categoria - 1',
       'VINC.CATEG1=DCT1.CODTAB (+)',
       'CATEG1',
       'T' FROM DUAL
UNION ALL
SELECT 'VINC',
       '99',
       30,
       2,
       'CATEG2',
       'S',
       'DCT2',
       0,
       21,
       'CLI ',
       20,
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'V',
       'CLI',
       'F',
       'A',
       'T',
       'Salrio/Faturam',
       'Categoria - 2',
       'VINC.CATEG2=DCT2.CODTAB (+)',
       'CATEG2',
       'T' FROM DUAL
UNION ALL
SELECT 'VINC',
       '99',
       40,
       2,
       'CATEG3',
       'S',
       'DCT3',
       0,
       22,
       'CLI ',
       30,
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'V',
       'CLI',
       'F',
       'A',
       'T',
       'Categoria - 3',
       'Categoria - 3',
       'VINC.CATEG3=DCT3.CODTAB (+)',
       'CATEG3',
       'T' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       210,
       8,
       'CELCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Celular do Cnjuge',
       'Celular do Cnjuge',
       '',
       'CELCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '01',
       25,
       9,
       'CHAVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'T',
       'Filial+Cdigo',
       'Filial+Cdigo do cliente',
       '',
       '(VINC.FILCLI||VINC.CODCLI)',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       0,
       'CLI ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       39,
       10,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Externo',
       'Cdigo Alternativo nico',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       140,
       5,
       'CODFID',
       'S',
       'DFID',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFID.DESFID',
       'V',
       '',
       '',
       'A',
       'F',
       'Fidelizacao',
       'Fidelizacao',
       'DFID.CODTAB = VINC.CODFID',
       'CODFID',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '04',
       60,
       3,
       'CODPLA',
       'A',
       'PLA ',
       0,
       24,
       'CLI ',
       60,
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       'CLI',
       'F',
       'A',
       'T',
       'Plano padro',
       'Cdigo do plano padro',
       'VINC.FILPLA=PLA.FILPGT (+) and  VINC.CODPLA=PLA.CODPGT  (+)',
       'CODPLA',
       'T' FROM DUAL
UNION ALL
SELECT 'VINC',
       '01',
       90,
       2,
       'CODSEX',
       'S',
       '',
       0,
       19,
       'CLI ',
       90,
       30,
       '',
       '',
       'D',
       'CLI',
       'F',
       'A',
       'T',
       'Sexo',
       'Cdigo de Sexo do Cliente',
       '',
       'CODSEX',
       'T' FROM DUAL
UNION ALL
SELECT 'VINC',
       '04',
       120,
       3,
       'CODVEN',
       'A',
       'USU ',
       0,
       0,
       'CLI ',
       120,
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       'CLI',
       'F',
       'A',
       'T',
       'Vendedor Padro',
       'Vendedor Padro',
       'VINC.FILVEN=USU.FILUSU(+) and VINC.CODVEN=USU.CODUSU(+)',
       'CODVEN',
       'T' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       41,
       6,
       'CODVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo do Vnculo',
       'Cdigo do Vnculo',
       '',
       'CODVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       200,
       3,
       'COD_FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Cdigo Filial',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '05',
       10,
       10,
       'COMBU1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Combustivel (1)',
       'Combustivel (1)',
       '',
       'COMBUSTIVEIS_CLIENTE(VINC.FILCLI,VINC.CODCLI, :VINC.COMB1_DATINI, :VINC.COMB1_DATFIM,NULL)',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '06',
       30,
       10,
       'COMBU2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Combustivel (2)',
       'Combustivel (2)',
       '',
       'COMBUSTIVEIS_CLIENTE(VINC.FILCLI,VINC.CODCLI, :VINC.COMB2_DATINI, :VINC.COMB2_DATFIM,NULL)',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '07',
       50,
       8,
       'COMBUSFIL1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Combustivel Filial 1',
       'Combustivel Filial 1',
       '',
       'COMBUSTIVEIS_CLIENTE(VINC.FILCLI,VINC.CODCLI, :VINC.COMB3_DATINI, :VINC.COMB3_DATFIM,:VINC.COMB3_CODFIL)',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '08',
       70,
       8,
       'COMBUSFIL2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Combustivel Filial 2',
       'Combustivel Filial 2',
       '',
       'COMBUSTIVEIS_CLIENTE(VINC.FILCLI,VINC.CODCLI, :VINC.COMB4_DATINI, :VINC.COMB4_DATFIM,:VINC.COMB4_CODFIL)',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '09',
       10,
       8,
       'COMBUSFIL3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Combustivel Filial 3',
       'Combustivel Filial 3',
       '',
       'COMBUSTIVEIS_CLIENTE(VINC.FILCLI,VINC.CODCLI, :VINC.COMB5_DATINI, :VINC.COMB5_DATFIM,:VINC.COMB5_CODFIL)',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '10',
       10,
       8,
       'COMBUSFIL4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Combustivel Filial 4',
       'Combustivel Filial 4',
       '',
       'COMBUSTIVEIS_CLIENTE(VINC.FILCLI,VINC.CODCLI, :VINC.COMB6_DATINI, :VINC.COMB6_DATFIM,:VINC.COMB6_CODFIL)',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '11',
       10,
       8,
       'COMBUSFIL5',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Combustivel Filial 5',
       'Combustivel Filial 5',
       '',
       'COMBUSTIVEIS_CLIENTE(VINC.FILCLI,VINC.CODCLI, :VINC.COMB7_DATINI, :VINC.COMB7_DATFIM,:VINC.COMB7_CODFIL)',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       280,
       5,
       'CONBOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Boleto',
       'Boleto',
       '',
       'CONBOL',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '01',
       100,
       44,
       'CONJUG',
       'A',
       '',
       0,
       0,
       'CLI ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CLI',
       'F',
       'A',
       'T',
       'Cnjuge ou Contato',
       'Nome do Cnjuge ou do  Contato principal',
       '',
       'CONJUG',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '99',
       50,
       8,
       'DATA01',
       'D',
       '',
       0,
       0,
       'CLI ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'D',
       'T',
       'Data livre - 1',
       'Data livre - 1',
       '',
       'DATA01',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '99',
       60,
       8,
       'DATA02',
       'D',
       '',
       0,
       0,
       'CLI ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'D',
       'T',
       'Data livre - 2',
       'Data livre - 2',
       '',
       'DATA02',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '99',
       70,
       8,
       'DATA03',
       'D',
       '',
       0,
       0,
       'CLI ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'D',
       'T',
       'Data livre - 3',
       'Data livre - 3',
       '',
       'DATA03',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '01',
       60,
       8,
       'DATNAS',
       'D',
       '',
       0,
       0,
       'CLI ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'D',
       'T',
       'Nascto/Fundao',
       'Data de nascimento',
       '',
       'DATNAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '01',
       70,
       8,
       'DATOPE',
       'D',
       '',
       0,
       0,
       'CLI ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'D',
       'T',
       'Data Incluso',
       'Data de operao (cadastramento)',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       220,
       4,
       'DDCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DDD Celular Cnjuge',
       'DDD Celular Cnjuge',
       '',
       'DDCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       230,
       4,
       'DDDCEL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'DDD Celular',
       'DDD Celular',
       '',
       'DDDCEL',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       240,
       4,
       'DDDFAX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'DDD Fax',
       'DDD FAX',
       '',
       'DDDFAX',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       250,
       4,
       'DDTCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'DDD Telefone Cnjuge',
       'DDD Telefone Cnjuge',
       '',
       'DDTCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '03',
       51,
       15,
       'DOCCON',
       'A',
       '',
       0,
       0,
       'CLI ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CLI',
       'F',
       'A',
       'T',
       'Doc. Cnjuge/Contato',
       'Doc. Cnjuge/Contato',
       '',
       'DOCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '12',
       10,
       4000,
       'DOENCA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Doenas',
       'Doenas',
       '',
       'TRAZDOENCAS(VINC.FILCLI,VINC.CODCLI)',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       290,
       1,
       'EDICRE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Crdito Manualmente?',
       'Credito definido Manualmente',
       '',
       'EDICRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '03',
       25,
       2,
       'ESTCIV',
       'S',
       '',
       0,
       18,
       'CLI ',
       20,
       30,
       '',
       '',
       'D',
       'CLI',
       'F',
       'A',
       'T',
       'Estado Civil',
       'Estado Civil',
       '',
       'ESTCIV',
       'T' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       260,
       40,
       'E_MCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail',
       'E-mail',
       '',
       'E_MCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '01',
       10,
       3,
       'FILCLI',
       'A',
       '',
       0,
       0,
       'CLI ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'N',
       'T',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '04',
       50,
       3,
       'FILPLA',
       'A',
       '',
       0,
       0,
       'CLI ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'N',
       'F',
       'Filial Plano Padro',
       'Filial Plano Padro',
       '',
       'FILPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '04',
       110,
       3,
       'FILVEN',
       'A',
       '',
       0,
       0,
       'CLI ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'N',
       'F',
       '',
       'Filial do Vendedor',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       40,
       3,
       'FILVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Vnculo',
       '',
       'FILVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '03',
       30,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       0,
       'CLI ',
       30,
       30,
       '',
       '',
       'D',
       'CLI',
       'F',
       'A',
       'T',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'VINC',
       '02',
       20,
       20,
       'FONE_ENDERE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       'SELECT FILCLI, CODCLI, NOMCLI,
       SUBSTR((SELECT MIN(LPAD(CODFIL,3)||LPAD(TO_CHAR(NUMEND),4)||DECODE(CODDDD,NULL,NULL,''''(''''||CODDDD||'''')'''')||NUMFON)
                 FROM TT_END
                WHERE FILCLI = CLI.FILCLI
                  AND CODCLI = CLI.CODCLI
                  AND NUMFON IS NOT NULL), 8)
  FROM TT_CLI CLI
',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Fone',
       '',
       '',
       'SUBSTR((SELECT MIN(LPAD(CODFIL,3)||LPAD(TO_CHAR(NUMEND),4)||CASE CODDDD WHEN NULL THEN NULL ELSE ''(''||CODDDD||'')'')||NUMFON) FROM TT_END WHERE FILCLI = VINC.FILCLI AND CODCLI = VINC.CODCLI AND NUMFON IS NOT NULL) END, 8)',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '02',
       10,
       40,
       'HOMPGE',
       'A',
       '',
       0,
       0,
       'CLI ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CLI',
       'F',
       'A',
       'T',
       'Home Page',
       'Home Page do Cliente',
       '',
       'HOMPGE',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       160,
       1,
       'ICM_CF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'ICM_CF  Nota Fiscal?',
       'ICM_CF  Nota Fiscal',
       '',
       'ICM_CF',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       300,
       7,
       'ID_DAT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data RG',
       'Data RG',
       '',
       'ID_DAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       310,
       2,
       'ID_EST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF do RG',
       'UF do RG',
       '',
       'ID_EST',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       320,
       6,
       'ID_ORG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'rgo Expeditor',
       'rgo Expeditor',
       '',
       'ID_ORG',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '99',
       80,
       2,
       'IMPRIM',
       'S',
       '',
       0,
       0,
       'CLI ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       '',
       'F',
       'Class. Interna',
       'Livre para customizao',
       '',
       'IMPRIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '03',
       40,
       15,
       'INSEST',
       'A',
       '',
       0,
       4,
       'CLI ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CLI',
       'F',
       'A',
       'T',
       '2 Documento',
       'Inscrio Estadual ou Identidade',
       '',
       'INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       44,
       6,
       'ISENHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Senha',
       'Senha',
       '',
       'ISENHA',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       330,
       3,
       'LIMPAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Limpar',
       'Limpar',
       '',
       'LIMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '04',
       40,
       2,
       'MAIATR',
       'S',
       '',
       0,
       0,
       'CLI ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       '9',
       'T',
       'Maior atraso',
       'Maior atraso registrado',
       '',
       'MAIATR',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '01',
       53,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'CLI ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(VINC.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '99',
       53,
       2,
       'MES_DATA01',
       'A',
       '',
       0,
       0,
       'CLI ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 1',
       '',
       'TO_CHAR(VINC.DATA01,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '99',
       63,
       2,
       'MES_DATA02',
       'A',
       '',
       0,
       0,
       'CLI ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 2',
       '',
       'TO_CHAR(VINC.DATA02,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '99',
       73,
       2,
       'MES_DATA03',
       'A',
       '',
       0,
       0,
       'CLI ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 3',
       '',
       'TO_CHAR(VINC.DATA03,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '01',
       63,
       2,
       'MES_DATNAS',
       'A',
       '',
       0,
       0,
       'CLI ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ms de Nascto/Funda',
       'Ms de Data de nascimento',
       '',
       'TO_CHAR(VINC.DATNAS,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '01',
       73,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       0,
       'CLI ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ms de Data Incluso',
       'Ms de Data de operao (cadastramento)',
       '',
       'TO_CHAR(VINC.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '01',
       113,
       2,
       'MES_NASCON',
       'A',
       '',
       0,
       0,
       'CLI ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ms de Nascto Cnj./',
       'Ms de Data de nascimento do cnjuge ou contato principal',
       '',
       'TO_CHAR(VINC.NASCON,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '04',
       83,
       2,
       'MES_ULTCOM',
       'A',
       '',
       0,
       0,
       'CLI ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       '',
       'N',
       'T',
       'Ms de ltima Compra',
       'Ms de Data da ltima compra',
       '',
       'TO_CHAR(VINC.ULTCOM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '01',
       110,
       8,
       'NASCON',
       'D',
       '',
       0,
       0,
       'CLI ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'D',
       'T',
       'Nascto Cnj./Contato',
       'Data de nascimento do cnjuge ou contato principal',
       '',
       'NASCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '01',
       30,
       44,
       'NOMCLI',
       'A',
       '',
       0,
       0,
       'CLI ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'CLI',
       'F',
       'A',
       'T',
       'Nome/Razo Social',
       'Nome do Cliente',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       43,
       255,
       'NOMIMG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Imagem',
       'Nome Imagem',
       '',
       'NOMIMG',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       340,
       20,
       'NOMTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Apelido',
       'Apelido',
       '',
       'NOMTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '03',
       20,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       3,
       'CLI ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'CLI',
       'F',
       'A',
       'T',
       'Documento (CPF/CGC)',
       'Nmero do Documento: CGC ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '99',
       90,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'CLI ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CLI',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(VINC.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       170,
       254,
       'OBSOUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'OBS. CheckOut',
       'Obervao para CheckOut',
       '',
       'OBSOUT',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '04',
       70,
       2,
       'PORPAD',
       'S',
       'DCOB',
       0,
       16,
       'CLI ',
       70,
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       'CLI',
       'F',
       'A',
       'T',
       'Portador Padro',
       'Portador padro',
       'VINC.PORPAD=DCOB.CODTAB (+)',
       'PORPAD',
       'T' FROM DUAL
UNION ALL
SELECT 'VINC',
       '99',
       110,
       1,
       'REGESP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Regime Especial?',
       'Fornecedor possui Regime Especial?',
       '',
       'REGESP',
       '' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       180,
       12,
       'SALBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Bnus',
       'Bnus',
       '',
       'SALBON',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '01',
       120,
       2,
       'SEXCON',
       'S',
       '',
       0,
       0,
       'CLI ',
       120,
       30,
       '',
       '',
       'D',
       'CLI',
       'F',
       'A',
       'T',
       'Sexo do Cnjuge',
       'Sexo do cnjuge',
       '',
       'SEXCON',
       'T' FROM DUAL
UNION ALL
SELECT 'VINC',
       '99',
       100,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'CLI ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'CLI',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN VINC.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '99',
       101,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN VINC.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       270,
       8,
       'TELCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Telefone do Cnjuge',
       'Telefone do Cnjuge',
       '',
       'TELCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       190,
       1,
       'TIPCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Cobrana',
       'Tipo Cobrana',
       '',
       'TIPCOB',
       'T' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       42,
       2,
       'TIPDOC',
       'A',
       'DDOC',
       0,
       TO_NUMBER(null),
       '',
       40,
       TO_NUMBER(null),
       '',
       'DDOC.DESDOC',
       'V',
       '',
       'F',
       'A',
       'F',
       'Tipo Documento',
       'Tipo de Documento',
       'DDOC.TIPDOC(+) = VINC.TIPDOC',
       'TIPDOC',
       'T' FROM DUAL
UNION ALL
SELECT 'VINC',
       '04',
       20,
       4,
       'TOTATR',
       'G',
       '',
       0,
       0,
       'CLI ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       '',
       'F',
       'Total de Atrasos',
       'Total de atrasos na vida do cliente',
       '',
       'TOTATR',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '04',
       30,
       4,
       'TOTPAR',
       'G',
       '',
       0,
       0,
       'CLI ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       '',
       'F',
       'Total Geral Parcelas',
       'Total de parcelas na vida do cliente',
       '',
       'TOTPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '--',
       50,
       250,
       'TRACO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Espao para Anotao',
       'Espao para Anotao',
       '',
       'LPAD(''_'',50,''_'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '04',
       80,
       8,
       'ULTCOM',
       'D',
       '',
       0,
       0,
       'CLI ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'F',
       'D',
       'T',
       'ltima Compra',
       'Data da ltima compra',
       '',
       'ULTCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '01',
       40,
       20,
       'ULTNOM',
       'A',
       '',
       0,
       0,
       'CLI ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'CLI',
       'F',
       'A',
       'T',
       'Sobrenome/Fantasia',
       'Sobrenome ou fantasia',
       '',
       'ULTNOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VINC',
       '04',
       10,
       8,
       'VALOR1',
       'F',
       '',
       2,
       0,
       'CLI ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'CLI',
       'T',
       '9',
       'T',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'VALOR1',
       'F' FROM DUAL
);

/*-- SEQ 9987 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VINC',
       'CODSEX',
       0,
       ' ',
       'Nao conhecido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINC',
       'CODSEX',
       1,
       ' ',
       'Masculino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINC',
       'CODSEX',
       2,
       ' ',
       'Feminino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINC',
       'ESTCIV',
       6,
       ' ',
       'Separado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINC',
       'ESTCIV',
       5,
       ' ',
       'Unio Estvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINC',
       'ESTCIV',
       0,
       ' ',
       'Indefinido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINC',
       'ESTCIV',
       4,
       ' ',
       'Divorciado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINC',
       'ESTCIV',
       1,
       ' ',
       'Solteiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINC',
       'ESTCIV',
       2,
       ' ',
       'Casado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINC',
       'ESTCIV',
       3,
       ' ',
       'Viuvo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINC',
       'FLGTIP',
       0,
       ' ',
       'Fisica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINC',
       'FLGTIP',
       1,
       ' ',
       'Juridica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINC',
       'FLGTIP',
       2,
       ' ',
       'Entidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINC',
       'FLGTIP',
       3,
       ' ',
       'Especial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINC',
       'FLGTIP',
       4,
       ' ',
       'M.E.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINC',
       'FLGTIP',
       5,
       ' ',
       'Filial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINC',
       'SEXCON',
       2,
       ' ',
       'Feminino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINC',
       'SEXCON',
       0,
       ' ',
       'Nao Conhecido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINC',
       'SEXCON',
       1,
       ' ',
       'Masculino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINC',
       'TIPCOB',
       0,
       'B',
       'Bancria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINC',
       'TIPCOB',
       0,
       'P',
       'Padro',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9988 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VINP',
       TO_NUMBER(null),
       'VINP',
       'Parceiro Vinculado',
       'TT_CLI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VINP.FILCLI,VINP.CODCLI, 
VINP.NOMCLI,VINP.ULTNOM, 
VINP.NUMDOC',
       '' FROM DUAL
);

/*-- SEQ 9989 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VINP','--','' FROM DUAL
UNION ALL
SELECT 'VINP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VINP','99','Outros' FROM DUAL
);

/*-- SEQ 9990 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22115,
       'CLI ',
       'VINP',
       '1',
       '01',
       '',
       '',
       'CLI.FILVIN = VINP.FILCLI(+) AND CLI.CODVIN = VINP.CODCLI(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 9991 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VINP',
       '--',
       10,
       1,
       'ATUCUS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Atraso em Aberto',
       'Atraso em Aberto',
       '',
       'ATUCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       20,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       30,
       1,
       'CALL_C',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Aceita Contato?',
       'Aceita Contato Telefnico',
       '',
       'CALL_C',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       40,
       2,
       'CATEG1',
       'S',
       'DCT1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'V',
       '',
       'F',
       'A',
       'F',
       'Profisso/Ramo',
       'Categoria - 1',
       'CLI.CATEG1=DCT1.CODTAB (+)',
       'CATEG1',
       'T' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       50,
       2,
       'CATEG2',
       'S',
       'DCT2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'V',
       '',
       'F',
       'A',
       'F',
       'Salrio/Faturam',
       'Categoria - 2',
       'CLI.CATEG2=DCT2.CODTAB (+)',
       'CATEG2',
       'T' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       60,
       2,
       'CATEG3',
       'S',
       'DCT3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'V',
       '',
       'F',
       'A',
       'F',
       '3',
       'Categoria - 3',
       'CLI.CATEG3=DCT3.CODTAB (+)',
       'CATEG3',
       'T' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       70,
       2,
       'CCCPRE',
       'S',
       'DCCC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       'DCCC.DESCCC',
       'V',
       '',
       '',
       'A',
       'F',
       'Conta Cliente',
       'Conta corrente Cliente',
       'DCCC.CODTAB = CLI.CCCPRE (+)',
       'CCCPRE',
       '' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       80,
       8,
       'CELCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Celular Cnjuge',
       'Celular Cnjuge',
       '',
       'CELCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       90,
       5,
       'CENCUS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CENCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       100,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       110,
       6,
       'CODCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Codigo Reg.Cnjuge',
       'Codigo do registro do conjuge',
       '',
       'CODCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       120,
       5,
       'CODCUS',
       'S',
       'DCUS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCUS.CENCUS',
       'V',
       '',
       '',
       'N',
       'F',
       'Centro de Custos',
       'Centro de Custos',
       'DCUS.CODTAB = CLI.CODCUS',
       'CODCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       130,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Alternativo nico',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       140,
       5,
       'CODFID',
       'S',
       'DFID',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFID.DESFID',
       'V',
       '',
       '',
       'A',
       'F',
       'Fidelizao',
       'Fidelizao',
       'DFID.CODTAB = CLI.CODFID',
       'CODFID',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       150,
       6,
       'CODGUI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODGUI',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       160,
       5,
       'CODINA',
       'S',
       'DINA',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DINA.DESINA',
       'V',
       '',
       '',
       'N',
       'F',
       'Motivo Inatividade',
       'Cdigo da Inatividade',
       'DINA.CODTAB = CLI.CODINA',
       'CODINA',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       170,
       3,
       'CODPLA',
       'A',
       'PLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Plano Pagamento',
       'Cdigo do plano padro',
       'CLI.FILPLA=PLA.FILPGT(+)  AND CLI.CODPLA=PLA.CODPGT(+)',
       'CODPLA',
       'T' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       180,
       2,
       'CODSEX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Sexo',
       'Cdigo de Sexo do Cliente',
       '',
       'CODSEX',
       'T' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       190,
       3,
       'CODVEN',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Vendedor Padro',
       'Vendedor Padro',
       'CLI.FILVEN=USU.FILUSU(+) and CLI.CODVEN=USU.CODUSU(+)',
       'CODVEN',
       'T' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       200,
       6,
       'CODVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo Vnculo',
       'Cdigo do Vnculo',
       '',
       'CODVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       210,
       5,
       'CONBOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Boleto',
       'Boleto',
       '',
       'CONBOL',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       220,
       44,
       'CONJUG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cnjuge ou Contato',
       'Nome do Cnjuge ou do  Contato principal',
       '',
       'CONJUG',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       230,
       8,
       'DATA01',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       '',
       'Data livre - 1',
       '',
       'DATA01',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       240,
       8,
       'DATA02',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       '',
       'Data livre - 2',
       '',
       'DATA02',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       250,
       8,
       'DATA03',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       '',
       'Data livre - 3',
       '',
       'DATA03',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       260,
       8,
       'DATNAS',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Nascto/Fundao',
       'Data de nascimento',
       '',
       'DATNAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       270,
       8,
       'DATOPE',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Incluso',
       'Data de operao (cadastramento)',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       280,
       4,
       'DDCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'DDD Celular Cnjuge',
       'DDD Celular Cnjuge',
       '',
       'DDCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       290,
       4,
       'DDTCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'DDD Telefone Cnjuge',
       'DDD Telefone Cnjuge',
       '',
       'DDTCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       300,
       15,
       'DOCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Doc. Cnjuge/Contato',
       'Doc. Cnjuge/Contato',
       '',
       'DOCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       310,
       1,
       'DUMMY',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       '',
       'Dummy',
       '',
       'DUMMY',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       320,
       1,
       'EDICRE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Credito manualmente?',
       'Credito definido manualmente(pode editar o limite de credito pode editar',
       '',
       'EDICRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       330,
       2,
       'ESTCIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Estado Civil',
       'Estado Civil',
       '',
       'ESTCIV',
       'T' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       340,
       1,
       'ESTRAN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Estrangeiro?',
       'Estrangeiro?',
       '',
       'ESTRAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       350,
       40,
       'E_MCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail',
       'E-mail',
       '',
       'E_MCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       360,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial Cliente',
       'Filial onde foi cadastrado o cliente',
       'CLI.FILCLI = DFIL.CODFIL (+)',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       370,
       3,
       'FILCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Reg.Cnjuge',
       'Filial do registro do conjuge',
       '',
       'FILCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       380,
       3,
       'FILGUI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILGUI',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       390,
       3,
       'FILPLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial Plano Padro',
       'Filial Plano Padro',
       '',
       'FILPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       400,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Vendedor',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       410,
       3,
       'FILVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Vnculo',
       '',
       'FILVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       420,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       430,
       1,
       'GLOBAL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Faturamento Global',
       'Faturamento Global',
       '',
       'GLOBAL',
       'T' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       440,
       40,
       'HOMPGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Home Page',
       'Home Page do Cliente',
       '',
       'HOMPGE',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       450,
       1,
       'ICM_CF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'ICM_CF  Nota Fiscal?',
       'ICM_CF  Nota Fiscal',
       '',
       'ICM_CF',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       460,
       7,
       'ID_DAT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data RG',
       'Data RG',
       '',
       'ID_DAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       470,
       2,
       'ID_EST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF do RG',
       'UF do RG',
       '',
       'ID_EST',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       480,
       6,
       'ID_ORG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'rgo Expeditor',
       'rgo Expeditor',
       '',
       'ID_ORG',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       490,
       2,
       'IMPRIM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Class. Interna',
       'Livre para customizao',
       '',
       'IMPRIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       500,
       15,
       'INSEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'L',
       '',
       'F',
       'A',
       'F',
       '2 Documento',
       'Inscrio Estadual ou Identidade',
       '',
       'INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       510,
       6,
       'ISENHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Senha',
       'Senha',
       '',
       'ISENHA',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       520,
       1,
       'ISENTO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Revenda/Consumidor',
       'Revenda/Consumidor Final',
       '',
       'ISENTO',
       'T' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       530,
       3,
       'LIMPAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Limpar',
       'Limpar',
       '',
       'LIMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       540,
       2,
       'MAIATR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Maior atraso',
       'Maior atraso registrado',
       '',
       'MAIATR',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       550,
       12,
       'NAODIV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Mdia Atraso',
       'Mdia Atraso',
       '',
       'NAODIV',
       '' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       560,
       1,
       'NAOSPC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Ms~Atualizao',
       'No no SPC?',
       '',
       'NAOSPC',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       570,
       8,
       'NASCON',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Nascto Cnj./Contato',
       'Data de nascimento do cnjuge ou contato principal',
       '',
       'NASCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       580,
       44,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Nome/Razo Social',
       'Nome do Cliente',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       590,
       255,
       'NOMIMG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Imagem',
       'Nome Imagem',
       '',
       'NOMIMG',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       600,
       20,
       'NOMTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Apelido',
       'Apelido',
       '',
       'NOMTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       610,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Documento (CPF/CNPJ)',
       'Nmero do Documento: CNPJ ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       620,
       10,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(VINP.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       630,
       254,
       'OBSOUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'OBS. CheckOut',
       'Obervao para CheckOut',
       '',
       'OBSOUT',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       640,
       1,
       'PEDELE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Pedido Eletrnico',
       'Pedido Eletrnico',
       '',
       'PEDELE',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       650,
       1,
       'POREMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Porte da Empresa',
       'Porte da Empresa',
       '',
       'POREMP',
       'T' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       660,
       2,
       'PORPAD',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       'F',
       'A',
       'F',
       'Portador Padro',
       'Portador padro',
       'CLI.PORPAD=DCOB.CODTAB (+)',
       'PORPAD',
       'T' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       670,
       3,
       'PP_COD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cd.Usu. Prospeco',
       'Cdigo do usurio que est prospectando
Cdigo do usurio que est pros',
       '',
       'PP_COD',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       680,
       3,
       'PP_FIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial de Prospeco',
       'Filial do usurio que est prospectando
Filial do usurio que est pros',
       '',
       'PP_FIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       690,
       7,
       'PP_FIM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fim prospeco',
       'Data Final de prospeco',
       '',
       'PP_FIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       700,
       1,
       'PP_FLG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag de Prospeco?',
       'Flag de Prospeco ',
       '',
       'PP_FLG',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       710,
       7,
       'PP_INI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data ini. prospeco',
       'Data de inicio de prospeso',
       '',
       'PP_INI',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       870,
       1,
       'REGESP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Regime Especial?',
       'Fornecedor possui Regime Especial?',
       '',
       'REGESP',
       '' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       720,
       1,
       'REPASE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Repasse',
       'Repasse ser antes ou depois do valor do item',
       '',
       'REPASE',
       'T' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       730,
       12,
       'SALBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Bnus',
       'Bnus',
       '',
       'SALBON',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       740,
       2,
       'SEXCON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Sexo do Cnjuge',
       'Sexo do cnjuge',
       '',
       'SEXCON',
       'T' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       750,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN VINP.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       751,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN VINP.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       760,
       1,
       'SIMPLE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Optante pelo Simples',
       'Optante pelo Simples?',
       '',
       'SIMPLE',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       770,
       8,
       'TELCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Telefone do Cnjuge',
       'Telefone do Cnjuge',
       '',
       'TELCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       780,
       1,
       'TIPCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Cobrana',
       'Tipo Cobrana',
       '',
       'TIPCOB',
       'T' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       790,
       2,
       'TIPDOC',
       'A',
       'DDOC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDOC.DESDOC',
       'V',
       '',
       'F',
       'A',
       'F',
       'Tipo Documento',
       'Tipo de Documento',
       'DDOC.TIPDOC(+) = CLI.TIPDOC',
       'TIPDOC',
       'T' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       800,
       1,
       'TIPEMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo da Empresa',
       'Tipo da Empresa',
       '',
       'TIPEMP',
       'T' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       810,
       4,
       'TOTATR',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Total de Atrasos',
       'Total de atrasos na vida do cliente',
       '',
       'TOTATR',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       820,
       4,
       'TOTPAR',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Total Geral Parcelas',
       'Total de parcelas na vida do cliente',
       '',
       'TOTPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       830,
       8,
       'ULTCOM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'ltima Compra',
       'Data da ltima compra',
       '',
       'ULTCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       840,
       20,
       'ULTNOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Sobrenome/Fantasia',
       'Sobrenome ou fantasia',
       '',
       'ULTNOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       850,
       1,
       'USAREF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Usa ref. Fornecedor?',
       'Usa referncia do fornecedor?',
       '',
       'USAREF',
       'F' FROM DUAL
UNION ALL
SELECT 'VINP',
       '--',
       860,
       8,
       'VALOR1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'VALOR1',
       'F' FROM DUAL
);

/*-- SEQ 9992 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VINP',
       'CODSEX',
       0,
       '-',
       'Nao conhecido',
       144,
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'CODSEX',
       2,
       '-',
       'Feminino',
       146,
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'CODSEX',
       1,
       '-',
       'Masculino',
       145,
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'ESTCIV',
       6,
       ' ',
       'Separado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'ESTCIV',
       5,
       ' ',
       'Unio Estvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'ESTCIV',
       0,
       ' ',
       'Indefinido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'ESTCIV',
       4,
       ' ',
       'Divorciado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'ESTCIV',
       1,
       ' ',
       'Solteiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'ESTCIV',
       2,
       ' ',
       'Casado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'ESTCIV',
       3,
       ' ',
       'Viuvo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'FLGTIP',
       0,
       ' ',
       'Fisica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'FLGTIP',
       1,
       ' ',
       'Juridica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'FLGTIP',
       2,
       ' ',
       'Entidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'FLGTIP',
       3,
       ' ',
       'Especial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'FLGTIP',
       4,
       ' ',
       'M.E.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'FLGTIP',
       5,
       ' ',
       'Filial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'GLOBAL',
       0,
       'G',
       'Faturamento Global',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'GLOBAL',
       0,
       'I',
       'No faz Faturamento Global',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'ISENTO',
       0,
       'F',
       'Revenda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'ISENTO',
       0,
       'T',
       'Consumidor Final',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'POREMP',
       0,
       'M',
       'Micro-empresa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'POREMP',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'POREMP',
       0,
       'P',
       'Pequeno Porte',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'REPASE',
       0,
       '0',
       'Sem Repasse',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'REPASE',
       0,
       '1',
       'Antes',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'REPASE',
       0,
       '2',
       'Depois',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'SEXCON',
       0,
       ' ',
       'Nao Conhecido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'SEXCON',
       1,
       ' ',
       'Masculino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'SEXCON',
       2,
       ' ',
       'Feminino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'TIPCOB',
       0,
       'B',
       'Bancria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VINP',
       'TIPCOB',
       0,
       'P',
       'Padro',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 9993 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VINT',
       TO_NUMBER(null),
       'VINT',
       'Usurios Internet',
       'TV_INT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VINT.FILCLI,VINT.CODCLI',
       '' FROM DUAL
);

/*-- SEQ 9994 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VINT','--','' FROM DUAL
UNION ALL
SELECT 'VINT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VINT','99','Outros' FROM DUAL
);

/*-- SEQ 9995 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VINT',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VINT',
       '01',
       20,
       44,
       'CONTAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Contato',
       'Contato',
       '',
       'CONTAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VINT',
       '01',
       30,
       32,
       'CSENHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Senha',
       '',
       'CSENHA',
       'F' FROM DUAL
UNION ALL
SELECT 'VINT',
       '01',
       40,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VINT',
       '01',
       50,
       64,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Cliente',
       'Nome do Cliente',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VINT',
       '01',
       60,
       4,
       'NUMCON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero Consulta',
       'Nmero Consulta',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VINT',
       '01',
       70,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm. Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
);

/*-- SEQ 9996 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VIPR',
       TO_NUMBER(null),
       'VIPR',
       'Itens de Produtos',
       'TV_IPR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VIPR.FILMAT,VIPR.CODMAT,VIPR.CODCOR,VIPR.CODTAM',
       '' FROM DUAL
);

/*-- SEQ 9997 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VIPR','--','' FROM DUAL
UNION ALL
SELECT 'VIPR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VIPR','02','Valores' FROM DUAL
UNION ALL
SELECT 'VIPR','03','Datas' FROM DUAL
UNION ALL
SELECT 'VIPR','04','Sugesto de Compra' FROM DUAL
UNION ALL
SELECT 'VIPR','05','Saldo da Filial' FROM DUAL
UNION ALL
SELECT 'VIPR','06','Valor Total de Compra' FROM DUAL
UNION ALL
SELECT 'VIPR','07','Valor Total de Reposio' FROM DUAL
UNION ALL
SELECT 'VIPR','08','Pedido Pendente' FROM DUAL
UNION ALL
SELECT 'VIPR','09','Saldo no Periodo' FROM DUAL
UNION ALL
SELECT 'VIPR','10','Valor de Venda do Produto' FROM DUAL
UNION ALL
SELECT 'VIPR','11','Data Custo Reposio' FROM DUAL
UNION ALL
SELECT 'VIPR','12','Giro de Estoque' FROM DUAL
UNION ALL
SELECT 'VIPR','13','Dias Sem Estoque' FROM DUAL
UNION ALL
SELECT 'VIPR','14','Dias Com Estoque' FROM DUAL
UNION ALL
SELECT 'VIPR','15','Dias Estoque Negativo' FROM DUAL
UNION ALL
SELECT 'VIPR','16','Saldo 2 da Filial' FROM DUAL
UNION ALL
SELECT 'VIPR','17','Saldo 3 da Filial' FROM DUAL
UNION ALL
SELECT 'VIPR','18','Saldo 4 da Filial' FROM DUAL
UNION ALL
SELECT 'VIPR','19','Status KIT' FROM DUAL
UNION ALL
SELECT 'VIPR','99','Outros' FROM DUAL
);

/*-- SEQ 9998 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23351,
       'CES ',
       'VIPR',
       '01',
       '0N',
       '',
       '',
       'CES.CODCES(+) = VIPR.CODCES',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23352,
       'ANP ',
       'VIPR',
       '1',
       'N',
       '',
       '',
       'ANP.CODANP = VIPR.CODANP',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23353,
       'NCM ',
       'VIPR',
       '1',
       'N',
       '',
       '',
       'NCM.CODNCM = VIPR.CODNCM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23354,
       'CUS ',
       'VIPR',
       '01',
       '01',
       '',
       '',
       'CUS.CODFIL = VIPR.FILMAT AND
CUS.SEQUEN = VIPR.SEQUEN ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23355,
       'MAR ',
       'VIPR',
       '01',
       'N',
       '',
       '',
       'MAR.FILPAR(+) = VIPR.FILMAR and
MAR.CODPAR(+) = VIPR.CODMAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23356,
       'GRA ',
       'VIPR',
       '1',
       'N',
       '',
       '',
       'GRA.FILMAT = VIPR.FILMAT AND
GRA.CODMAT = VIPR.CODMAT AND
GRA.CODCOR = VIPR.CODCOR AND
GRA.CODTAM = VIPR.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23357,
       'TMAR',
       'VIPR',
       '01',
       'N',
       '',
       '',
       'TMAR.FILMAR(+) = VIPR.FILMAR and
TMAR.CODMAR(+) = VIPR.CODMAR and
TMAR.ITEMAR(+) = VIPR.ITEMAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23358,
       'PXF ',
       'VIPR',
       'N',
       '1',
       '',
       '',
       'PXF.FILMAT = VIPR.FILMAT and
PXF.CODMAT = VIPR.CODMAT and
PXF.CODCOR = VIPR.CODCOR and
PXF.CODTAM = VIPR.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 23359,
       'PRE ',
       'VIPR',
       'N',
       'N',
       '',
       '',
       'PRE.FILMAT = VIPR.FILMAT and
PRE.CODMAT = VIPR.CODMAT and
PRE.CODCOR = VIPR.CODCOR and
PRE.CODTAM = VIPR.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30897,
       'VCRG',
       'VIPR',
       '1',
       '1',
       '',
       '',
       'VCRG.FILMAT = VIPR.FILMAT AND
VCRG.CODMAT = VIPR.CODMAT AND
VCRG.CODCOR = VIPR.CODCOR AND
VCRG.CODTAM = VIPR.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 30898,
       'VMIV',
       'VIPR',
       '01',
       '1',
       '',
       '',
       'VIPR.FILMAT = VMIV.FILMAT AND
VIPR.CODMAT = VMIV.CODMAT AND
VIPR.CODCOR = VMIV.CODCOR AND
VIPR.CODTAM = VMIV.CODTAM
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 37724,
       'EAN ',
       'VIPR',
       '0N',
       '1',
       '',
       '',
       'EAN.FILMAT(+) = VIPR.FILMAT AND
EAN.CODMAT(+) = VIPR.CODMAT AND
EAN.CODCOR(+) = VIPR.CODCOR AND
EAN.CODTAM(+) = VIPR.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 9999 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VIPR',
       '09',
       2220,
       8,
       ':GRA.SALDOPERIODO_DATINI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Perodo',
       'Perodo',
       '',
       ':VIPR.SALDOPERIODO_DATINI,VIPR.SALDOPERIODO.DATFIM',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '11',
       2270,
       3,
       ':VIPR.CODFILCRD',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'VIPR.:VIPR.CODFILCRD=DFIL.CODFIL',
       ':VIPR.CODFILCRD',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '12',
       2310,
       3,
       ':VIPR.CODFILGIR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial Giro',
       'Filial Giro',
       ':VIPR.CODFIL = DFIL.CODFIL(+)',
       ':VIPR.CODFILGIR',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '04',
       2070,
       3,
       ':VIPR.CODFILLOC',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial Locao',
       'Filial Locao',
       ':VIPR.CODFILLOC = DFIL.CODFIL(+)',
       ':VIPR.CODFILLOC',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '08',
       2190,
       3,
       ':VIPR.CODFILPP',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial PP',
       'Filial PP',
       'VIPR.:VIPR.CODFILPP = DFIL.CODFIL',
       ':VIPR.CODFILPP',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '05',
       2110,
       3,
       ':VIPR.CODFILSDF',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial SDF',
       'Filial SDF',
       'VIPR.:VIPR.CODFILSDF = DFIL.CODFIL(+)',
       ':VIPR.CODFILSDF',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '16',
       3222,
       3,
       ':VIPR.CODFILSDF2',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial SDF',
       'Filial SDF',
       'VIPR.:VIPR.CODFILSDF = DFIL.CODFIL(+)',
       ':VIPR.CODFILSDF',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '17',
       3232,
       3,
       ':VIPR.CODFILSDF3',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial SDF',
       'Filial SDF',
       'VIPR.:VIPR.CODFILSDF = DFIL.CODFIL(+)',
       ':VIPR.CODFILSDF',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '18',
       3242,
       3,
       ':VIPR.CODFILSDF4',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial SDF',
       'Filial SDF',
       'VIPR.:VIPR.CODFILSDF = DFIL.CODFIL(+)',
       ':VIPR.CODFILSDF',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '06',
       2140,
       3,
       ':VIPR.CODFILVTC',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial VTC',
       'Filial VTC',
       'VIPR.:VIPR.CODFILVTC = DFIL.CODFIL(+)',
       ':VIPR.CODFILVTC',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '07',
       2170,
       3,
       ':VIPR.CODFILVTR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial VTR',
       'Filial VTR',
       'VIPR.:VIPR.CODFILVTR = DFIL.CODFIL(+)',
       ':VIPR.CODFILVTR',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '16',
       3223,
       30,
       ':VIPR.CODMUL2',
       'A',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       '',
       'Mltiplo Estoque',
       'Mltiplo Estoque',
       'VIPR.:VIPR.CODMUL2 = DMUL.CODTAB(+)',
       ':VIPR.CODMUL2',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '17',
       3233,
       30,
       ':VIPR.CODMUL3',
       'A',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       '',
       'Mltiplo Estoque',
       'Mltiplo Estoque',
       'VIPR.:VIPR.CODMUL2 = DMUL.CODTAB(+)',
       ':VIPR.CODMUL3',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '18',
       3243,
       30,
       ':VIPR.CODMUL4',
       'A',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       '',
       'Mltiplo Estoque',
       'Mltiplo Estoque',
       'VIPR.:VIPR.CODMUL2 = DMUL.CODTAB(+)',
       ':VIPR.CODMUL4',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '11',
       2280,
       5,
       ':VIPR.CODMULCRD',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       '9',
       '',
       'Cd.Mltiplo Estoque',
       'Cdigo Mltiplo Estoque',
       'VIPR.:VIPR.CODMULCRD = DMUL.CODTAB',
       ':VIPR.CODMULCRD',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '14',
       2360,
       8,
       ':VIPR.COM_DATINI,VIPR.COM_DATF',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Datas com Estoque',
       'Datas com Estoque',
       '',
       ':VIPR.COM_DATINI,VIPR.COM_DATFIM',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '04',
       2050,
       8,
       ':VIPR.DAT01,VIPR.DAT02',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data',
       'Data',
       '',
       ':VIPR.DAT01,VIPR.DAT02',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '04',
       2060,
       8,
       ':VIPR.DATATE',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Manter At',
       'Manter At',
       '',
       ':VIPR.DATATE',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '12',
       2300,
       8,
       ':VIPR.DATINI,VIPR.DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data',
       'Data',
       '',
       ':VIPR.DATINI,VIPR.DATFIM',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '11',
       2260,
       8,
       ':VIPR.DATREFCRD',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Referncia',
       'Data Referncia',
       '',
       ':VIPR.DATREFCRD',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '05',
       2100,
       8,
       ':VIPR.DATREFSDF',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Referncia',
       'Data Referncia',
       '',
       ':VIPR.DATREFSDF',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '16',
       3221,
       8,
       ':VIPR.DATREFSDF2',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Referncia',
       'Data Referncia',
       '',
       ':VIPR.DATREFSDF',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '17',
       3231,
       8,
       ':VIPR.DATREFSDF3',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Referncia',
       'Data Referncia',
       '',
       ':VIPR.DATREFSDF',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '18',
       3241,
       8,
       ':VIPR.DATREFSDF4',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Referncia',
       'Data Referncia',
       '',
       ':VIPR.DATREFSDF',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '06',
       2130,
       8,
       ':VIPR.DATREFVTC',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Referncia',
       'Data Referncia',
       '',
       ':VIPR.DATREFVTC',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '07',
       2160,
       8,
       ':VIPR.DATREFVTR',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data VTR',
       'Data VTR',
       '',
       ':VIPR.DATREFVTR',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '14',
       2370,
       3,
       ':VIPR.FILIAL_COM_ESTOQUE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial com Estoque',
       'Filial com Estoque',
       ':VIPR.FILIAL_COM_ESTOQUE = DFIL.CODFIL(+)',
       ':VIPR.FILIAL_COM_ESTOQUE',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '15',
       3000,
       3,
       ':VIPR.FILIAL_NEG_ESTOQUE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial Estoque Neg.',
       'Filial Estoque Negativo',
       'VIPR.:VIPR.FILIAL_NEG_ESTOQUE = DFIL.CODFIL(+)',
       ':VIPR.FILIAL_NEG_ESTOQUE',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '13',
       2340,
       3,
       ':VIPR.FILIAL_SEM_ESTOQUE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial Sem Estoque',
       'Filial Sem Estoque',
       ':VIPR.FILIAL_SEM_ESTOQUE = DFIL.CODFIL(+)',
       ':VIPR.FILIAL_SEM_ESTOQUE',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '15',
       2390,
       8,
       ':VIPR.NEG_DATINI,VIPR.NEG_DATF',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Datas Estoque Neg.',
       'Datas Estoque Negativo',
       '',
       ':VIPR.NEG_DATINI,VIPR.NEG_DATFIM',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '13',
       2330,
       8,
       ':VIPR.SEM_DATINI,VIPR.SEM_DATF',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Sem Estoque',
       'Data Sem Estoque',
       '',
       ':VIPR.SEM_DATINI,VIPR.SEM_DATFIM',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '04',
       2040,
       1,
       ':VIPR.TIPPRJ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Tipo de Projeo',
       'Tipo de Projeo',
       '',
       ':VIPR.TIPPRJ',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '10',
       2240,
       8,
       ':VIPR.VLRVENDATINI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Perodo',
       'Perodo',
       '',
       ':VIPR.VLRVENDATINI,VIPR.VLRVENDATFIM',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       940,
       5,
       'AFICUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Acrscimo Financeiro',
       'Acrscimo Financeiro para Formao do Preo de venda',
       '',
       'AFICUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       3010,
       1,
       'ARRTRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Arrentonda ou Trunca',
       'Arrentonda ou Trunca?',
       '',
       'ARRTRU',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       681,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN VIPR.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '03',
       950,
       7,
       'ATUGRA',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Atu. da Grade',
       'Data de Atualizao do Item de Grade',
       '',
       'ATUGRA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '03',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       870,
       1,
       'BALSIM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Utiliza Balana?',
       'Utiliza Balana?',
       '',
       'BALSIM',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       20,
       2,
       'BRINDE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Brinde',
       'Brinde',
       '',
       'BRINDE',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       30,
       2,
       'CLASS1',
       'S',
       'DCL1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL1.CLASS1',
       'V',
       '',
       'F',
       'A',
       'F',
       'Catergoria',
       'Classificao 1',
       'VIPR.CLASS1=DCL1.CODTAB (+)',
       'CLASS1',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       40,
       2,
       'CLASS2',
       'S',
       'DCL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL2.CLASS2',
       'V',
       '',
       'F',
       'A',
       'F',
       'SubCategoria',
       'Classificao 2',
       'VIPR.CLASS2=DCL2.CODTAB (+)',
       'CLASS2',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       50,
       2,
       'CLASS3',
       'S',
       'DCL3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL3.CLASS3',
       'V',
       '',
       'F',
       'A',
       'F',
       'Familia',
       'Classificao 3',
       'VIPR.CLASS3=DCL3.CODTAB (+)',
       'CLASS3',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       60,
       2,
       'CLASS4',
       'S',
       'DCL4',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL4.CLASS4',
       'V',
       '',
       'F',
       'A',
       'F',
       'SubFamilia',
       'Classificao 4',
       'VIPR.CLASS4=DCL4.CODTAB (+)',
       'CLASS4',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       71,
       5,
       'CLSABC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Classe ABC',
       'Classe ABC',
       '',
       'CLSABC',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       70,
       5,
       'CLSXYZ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Classe XYZ',
       'Classe XYZ',
       '',
       'CLSXYZ',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       3080,
       9,
       'CODANP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Cdigo na ANP',
       'Cdigo na ANP',
       '',
       'CODANP',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       4360,
       7,
       'CODCES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'CEST',
       'CEST',
       '',
       'CODCES',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       80,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Divisao Material',
       'VIPR.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       1060,
       5,
       'CODCTR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       '',
       '',
       '',
       'CODCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       90,
       5,
       'CODDIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Diviso',
       'Cdigo Diviso',
       '',
       'CODDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       4370,
       3,
       'CODENQ',
       'S',
       'ENQ ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'ENQ.DESENQ',
       'V',
       '',
       '',
       'A',
       '',
       'Cd Enquad IPI',
       'Cdigo de Enquadramento Legal do IPI',
       'ENQ.CODENQ(+) = VIPR.CODENQ',
       'CODENQ',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       880,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Externo',
       'Cdigo Externo do Produto',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       4260,
       60,
       'CODFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Codigo Fiscal',
       'Cdigo Fiscal',
       '',
       'CODFIS',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       3910,
       2,
       'CODFPS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODFPS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       3260,
       2,
       'CODFPS ',
       'A',
       'DFPS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFPS.DESFPS',
       'V',
       '',
       '',
       'A',
       '',
       'Finalidade',
       'Finalidade',
       'DFPS.CODFPS=VIPR.CODFPS(+) ',
       'CODFPS ',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       100,
       2,
       'CODGRA',
       'S',
       'DGRA',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DGRA.NOMGRA',
       'V',
       '',
       'F',
       'A',
       'F',
       'Tipo Grade',
       'Cdigo da grade',
       'VIPR.CODGRA=DGRA.CODTAB (+)',
       'CODGRA',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       4280,
       5,
       'CODIMG',
       'G',
       'DIMG',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIMG.DESIMG',
       'V',
       '',
       '',
       'N',
       '',
       'Cdigo imagem grupo',
       'Cdigo da imagem do grupo',
       'DIMG.CODTAB = VIPR.CODIMG',
       'CODIMG',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       890,
       5,
       'CODLPC',
       'S',
       'DLPC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DLPC.DESLPC',
       'V',
       '',
       '',
       'N',
       'F',
       'Lista de Controlados',
       'Lista de Produto Controlado a qual o produto pertence',
       'DLPC.CODTAB = PRO.CODLPC',
       'CODLPC',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       110,
       6,
       'CODMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo da marca',
       'Cdigo da Marca deste produto',
       '',
       'CODMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       120,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '.',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo material',
       'Cdigo material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       3110,
       8,
       'CODNCM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo NCM',
       'Cdigo NCM',
       '',
       'CODNCM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       4450,
       40,
       'CODPOS_GRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo POS CONTROLE',
       'Cdigo POS CONTROLE',
       '',
       'CODPOS_GRA',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       3920,
       5,
       'CODRGC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODRGC',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       130,
       5,
       'CODSAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cd. Saldo Unificado',
       'Cdigo Saldo Unificado no item',
       '',
       'CODSAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       140,
       2,
       'CODSAZ',
       'S',
       'DSAZ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSAZ.DESSAZ',
       'V',
       '',
       'F',
       'A',
       'F',
       'Sazonalidade',
       'Cdigo da sazonalidade',
       'VIPR.CODSAZ=DSAZ.CODTAB (+)',
       'CODSAZ',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       3930,
       4,
       'CODSRV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODSRV',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       150,
       5,
       'CODSUB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Sub-Diviso',
       'Cdigo Sub-Diviso',
       '',
       'CODSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       160,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso Material',
       'VIPR.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       170,
       2,
       'CODTRI',
       'S',
       'DTRI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DTRI.CODTRI',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo~Tributao',
       'Cdigo de tributao',
       'VIPR.CODTRI=DTRI.CODTAB (+)',
       'CODTRI',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       3090,
       3,
       'COD_EX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cd. de Exceo IPI',
       'Cdigo de Exceo do IPI',
       '',
       'COD_EX',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       180,
       10,
       'CONAPL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Conv. Emb. Aplicao',
       'Converso Aplicao e Embalagem',
       '',
       'CONAPL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       4330,
       1,
       'CONFER',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Conferir na venda?',
       'Conferir na venda?',
       '',
       'CONFER',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       190,
       1,
       'CONTRA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Produto Contratado?',
       'Determina se produto  do tipo contrato',
       '',
       'CONTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       200,
       1,
       'CONTRO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Produto Controlado?',
       'Produtos Controlados',
       '',
       'CONTRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       210,
       16,
       'CUSFRE',
       'F',
       '',
       6,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Custo Frete',
       'Custo Frete',
       '',
       'CUSFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       220,
       14,
       'CUSREP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Custo Reposio',
       'Custo Reposicao',
       '',
       'CUSREP',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '11',
       2250,
       12,
       'CUSTOREPOSICAODATA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Custo Reposio/Data',
       'Custo Reposio/Data',
       '',
       'CUSTOREPOSICAODATA(:VIPR.DATREFCRD,VIPR.FILMAT,VIPR.CODMAT,VIPR.CODCOR,VIPR.CODTAM,:VIPR.CODFILCRD,:VIPR.CODMULCRD)',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       960,
       5,
       'DACCUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Desc/Acrscimo',
       'Desconto/Acrscimo para a Formao do Preo de Venda',
       '',
       'DACCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '03',
       230,
       7,
       'DATCAD',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Cadastro',
       'Data Cadastro',
       '',
       'DATCAD',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '03',
       240,
       7,
       'DATCOM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Compra',
       'Data Compra',
       '',
       'DATCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       250,
       1,
       'DECIMA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Usa Decimais?',
       'Usa Decimais?',
       '',
       'DECIMA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       810,
       5,
       'DEPART',
       'S',
       'DDEP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDEP.DESDEP',
       'V',
       '',
       '',
       'A',
       'F',
       'Departamento',
       'Departamento',
       'DDEP.CODTAB(+) = VIPR.DEPART',
       'DEPART',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       4250,
       40,
       'DESCLA',
       'A',
       'CLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'CLA.DESCLA',
       'V',
       '',
       '',
       'A',
       '',
       'Classificao',
       'Descrio da classificao',
       'VIPR.FILCLA = CLA.CODFIL(+) AND VIPR.SEQCLA = CLA.SEQUEN(+)',
       'DESCLA',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       4470,
       4000,
       'DESDET',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Desc. Detalhe HTML',
       'Descrio Detalhe (em HTML)',
       '',
       'DESDET',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       270,
       15,
       'DESECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descricao ECF',
       'Descrio ECF',
       '',
       'DESECF',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       3940,
       5,
       'DESFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       311,
       120,
       'DESGRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio da Grade',
       'Descrio da Grade',
       '',
       'DESGRA',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       280,
       12,
       'DESIDE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Desconto~Sugerido',
       'Desconto Sugerido',
       '',
       'DESIDE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       290,
       30,
       'DESMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio~Material',
       'Descrio Material',
       '',
       'DESMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       300,
       12,
       'DESMAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Desconto~Mximo',
       'Desconto Maximo',
       '',
       'DESMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       1090,
       20,
       'DESMED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio da Medida',
       'Descrio da Medida',
       '',
       'DESMED',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       3950,
       20,
       'DESMEDAPL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESMEDAPL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       3960,
       20,
       'DESMEDEMB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESMEDEMB',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       3970,
       20,
       'DESMEDFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESMEDFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       3980,
       20,
       'DESMEDUNI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESMEDUNI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       4460,
       254,
       'DESWEB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio e-Commerce',
       'Descrio para e-Commerce',
       '',
       'DESWEB',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '14',
       2350,
       12,
       'DIASDEESTOQUE_COM_ESTOQUE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Dias com Estoque',
       'Dias com Estoque',
       '',
       'DIASDEESTOQUE(''C'', :VIPR.COM_DATINI, :VIPR.COM_DATFIM, VIPR.FILMAT, VIPR.CODMAT, VIPR.CODCOR, VIPR.CODTAM, :VIPR.FILIAL_COM_ESTOQUE, 0)',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '15',
       2380,
       12,
       'DIASDEESTOQUE_NEGATIVO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'DiasEstoque Negativo',
       'Dias Estoque Negativo',
       '',
       'DIASDEESTOQUE(''-'', :VIPR.NEG_DATINI, :VIPR.NEG_DATFIM, VIPR.FILMAT, VIPR.CODMAT, VIPR.CODCOR, VIPR.CODTAM, :VIPR.FILIAL_NEG_ESTOQUE, 0)',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '13',
       2320,
       12,
       'DIASDEESTOQUE_SEM_ESTOQUE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Dias Sem Estoque',
       'Dias Sem Estoque',
       '',
       'DIASDEESTOQUE(''S'', :VIPR.SEM_DATINI, :VIPR.SEM_DATFIM, VIPR.FILMAT, VIPR.CODMAT, VIPR.CODCOR, VIPR.CODTAM, :VIPR.FILIAL_SEM_ESTOQUE, 0)',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       310,
       30,
       'ESPMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Especificao',
       'Especificao Material',
       '',
       'ESPMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       4350,
       1,
       'ESTCHE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Estoque no CK4G',
       'Controle de Estoque no Checkout 4G',
       '',
       'ESTCHE',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       3210,
       2,
       'ETIQUE',
       'S',
       'DETI',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DETI.DESETI',
       'V',
       '',
       '',
       'A',
       '',
       'Etiqueta',
       'Tipo de etiqueta',
       'VIPR.ETIQUE=DETI.CODTAB (+)',
       'ETIQUE',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       330,
       14,
       'FATCON',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Fator Converso',
       'Fator de converso entre as divises',
       '',
       'FATCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       900,
       3,
       'FILCLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILCLA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       3990,
       3,
       'FILCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       340,
       3,
       'FILMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial da Marca do material',
       '',
       'FILMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       350,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       4000,
       3,
       'FILRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial de reserva',
       'Filial de reserva padro para o produto',
       '',
       'FILRES',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       970,
       1,
       'FLGSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FLGSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       4410,
       1,
       'FOR060',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'CST60 emp substituta',
       'Forar substitudo (60) mesmo para empresa substituta',
       '',
       'FOR060',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       770,
       1,
       'FORLIN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Fora de Linha?',
       'Fora de Linha',
       '',
       'FORLIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       4280,
       1,
       'GRAABC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'ABC Calculado',
       'ABC Calculado na Grade',
       '',
       'GRAABC',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       980,
       1,
       'GRAATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'F',
       'Ativo',
       'Item de Grade Ativo?',
       '',
       'GRAATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       4290,
       1,
       'GRAXYZ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'XYZ Calculado',
       'XYZ Calculado na Grade',
       '',
       'GRAXYZ',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       4010,
       256,
       'GRA_ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'GRA_ASSINA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       4300,
       12,
       'GRA_CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'GRA_CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '12',
       2290,
       12,
       'GiroEstoque',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       '',
       'Giro de Estoque',
       'Giro de Estoque',
       '',
       'GiroEstoque(:VIPR.DATINI,:VIPR.DATFIM,VIPR.FILMAT,VIPR.CODMAT,VIPR.CODCOR,VIPR.CODTAM,:VIPR.CODFILGIR)',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       830,
       14,
       'ICMCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'ICMS Compra',
       'ICMS Compra',
       '',
       'ICMCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       990,
       14,
       'ICMCUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '% ICMS p/ Preo',
       '% de ICMS para Formao do Preo de Venda',
       '',
       'ICMCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       4030,
       1,
       'ICMFED',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ICMFED',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       1000,
       1,
       'ICMTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Tributao',
       'Tipo de Tributao para Formao do Preo de Venda',
       '',
       'ICMTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       3070,
       1,
       'IIPTPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Produo Prp ou Ter',
       'Produo Prpria ou de Terceiro?',
       '',
       'IIPTPR',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       4300,
       255,
       'IMGGRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome da imagem',
       'Nome da imagem',
       '',
       'IMGGRU',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       3250,
       1,
       'IMPKIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Imp. Itens Kit NF?',
       'Imprimir Itens de Kit na NF/CF?',
       '',
       'IMPKIT',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       840,
       14,
       'IPICOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'IPI Compra',
       'IPI Compra',
       '',
       'IPICOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       1010,
       14,
       'IPICUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '% IPI Compra',
       '% IPI da Compra',
       '',
       'IPICUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       4040,
       1,
       'ISEPIS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ISEPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       850,
       5,
       'ITECOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Item Compra',
       '',
       '',
       'ITECOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       360,
       10,
       'ITEDIV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Item Diviso',
       'Item Diviso',
       '',
       'ITEDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       800,
       4,
       'ITEMAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Itens de Marca',
       'Itens de Marca',
       '',
       'ITEMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       370,
       10,
       'ITESUB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Item SubDiviso',
       'Item SubDiviso',
       '',
       'ITESUB',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       380,
       10,
       'LOCALI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Localizao',
       'Localizacao',
       '',
       'LOCALI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       3480,
       30,
       'MARCA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Marca',
       'Descrio da Marca',
       '',
       'MARCA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       4440,
       3,
       'MAXPAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Mximo de parcelas',
       'Nmero mximo de parcelas na venda',
       '',
       'MAXPAR',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       390,
       2,
       'MEDAPL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Medida Aplicao',
       'Medida Aplicao',
       '',
       'MEDAPL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       400,
       2,
       'MEDEMB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Medida Embalagem',
       'Medida Embalagem',
       '',
       'MEDEMB',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       410,
       2,
       'MEDFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Medida Fornecedor',
       'Medida Fornecedor',
       '',
       'MEDFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       420,
       2,
       'MEDUNI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Medida Unidade',
       'Medida Unidade',
       '',
       'MEDUNI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       430,
       12,
       'MINQTD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Estoque ~Mnimo',
       'Estoque Minimo',
       '',
       'MINQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       440,
       1,
       'MONTAR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Montagem?',
       'Aceita montagem',
       '',
       'MONTAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       4270,
       14,
       'MVACOM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% MVA',
       '% MVA',
       '',
       'MVACOM',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       4050,
       2,
       'NATBCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATBCC',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       450,
       20,
       'NOMDIV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Diviso',
       'Nome Diviso',
       '',
       'NOMDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       460,
       255,
       'NOMIMG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Arquivo Imagem',
       'Nome Arquivo de Imagem',
       '',
       'NOMIMG',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       3180,
       4000,
       'NOMNCM',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio NCM',
       'Descrio NCM',
       '',
       'RTF2TXT(NOMNCM)',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       470,
       83,
       'NOMPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Produto',
       'Nome Produto',
       '',
       'NOMPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       480,
       20,
       'NOMSUB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Subdiviso',
       'Nome Subdiviso',
       '',
       'NOMSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       490,
       1,
       'NUMEXT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Numero Externo?',
       'Nmero externo na Ordem de Servio',
       '',
       'NUMEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       500,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Num. Itens do Kit',
       'Nmero de itens de um kit',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       4320,
       1,
       'OBIMEI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Obriga IMEI?',
       'Obriga IMEI no Servio Adicional?',
       '',
       'OBIMEI',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       510,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(VIPR.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       4060,
       4000,
       'OBSGRA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'OBSGRA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       4070,
       254,
       'OBSMPB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'OBSMPB',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       520,
       5,
       'ORDDIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ordem Diviso',
       'Ordem Diviso',
       '',
       'ORDDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       530,
       5,
       'ORDSUB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ordem Sub-Diviso',
       'Ordem Sub-Diviso',
       '',
       'ORDSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       1020,
       1,
       'ORICUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem dos Custos',
       'Origem da Atualizao dos Custos',
       '',
       'ORICUS',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       3350,
       1,
       'ORIPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem do Produto',
       'Origem do Produto',
       '',
       'ORIPRO',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       1030,
       12,
       'OUTCUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Outros Custos',
       'Outros Custos',
       '',
       'OUTCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '08',
       2180,
       12,
       'PEDIDOPENDENTE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Pedidos Pendentes',
       'Traz a quantidade pendente de pedidos nao recebidos',
       '',
       'PEDIDOPENDENTE(:VIPR.CODFILPP,VIPR.FILMAT,VIPR.CODMAT,VIPR.CODCOR,VIPR.CODTAM)',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       540,
       12,
       'PERCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Comisso',
       'Percentual Comisso',
       '',
       'PERCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       3900,
       5,
       'PERIND',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '% Comisso Indicador',
       '% Comisso para Indicador',
       '',
       'PERIND',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       4420,
       8,
       'PERIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% IPI',
       'Alquota do IPI',
       '',
       'PERIPI',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       4430,
       8,
       'PERIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% IRR',
       'Alquota do Imposto de Renda',
       '',
       'PERIRR',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       550,
       12,
       'PERLUC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% de Lucro',
       '% de Lucro',
       '',
       'PERLUC',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       910,
       5,
       'PERSER',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PERSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       4400,
       5,
       'PER_II',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Imposto Importao',
       '% de Imposto sobre Importao',
       '',
       'PER_II',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       560,
       14,
       'PESBRU',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Peso~Bruto',
       'Peso Bruto',
       '',
       'PESBRU',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       570,
       14,
       'PESLIQ',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Peso~Lquido',
       'Peso Liquido',
       '',
       'PESLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       580,
       12,
       'PRECOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Preco~Compra',
       'Preo Compra',
       '',
       'PRECOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       780,
       8,
       'PRECOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Preo de venda',
       'Preo de venda',
       '',
       'PRECOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       3370,
       14,
       'PREFIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Preo Fiscal',
       'Preo Fiscal (Mximo, Sugesto ou Pauta)',
       '',
       'PREFIS',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       1040,
       1,
       'PREPSI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PREPSI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       590,
       1,
       'PROMOC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Promoo?',
       'Indica se produto  promocional',
       '',
       'PROMOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       4080,
       256,
       'PRO_ASSINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRO_ASSINA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       4310,
       12,
       'PRO_CODUID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRO_CODUID',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       600,
       12,
       'PTOQTD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Pto. Pedido',
       'Ponto de pedido',
       '',
       'PTOQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       4100,
       12,
       'QTDBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'QTDBON',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       790,
       12,
       'QTDCOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Quantidade Compra',
       'Quantidade Compra',
       '',
       'QTDCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       610,
       10,
       'QTDEMB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Contedo Embalagem',
       'Contedo da Embalagem',
       '',
       'QTDEMB',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       4110,
       7,
       'QTDMUL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'QTDMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       620,
       12,
       'QTDREP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtde Reposico',
       'Quantidade ideal de reposiao',
       '',
       'QTDREP',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       630,
       15,
       'REFBAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. Bsica',
       'Referncia Bsica',
       '',
       'REFBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       640,
       20,
       'REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. Produto',
       'Referncia do Produto',
       '',
       'REFPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       1100,
       20,
       'REFVEN_EAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Referencia de Venda',
       'Referencia de Venda',
       '',
       '(SELECT min(IEAN.CODEAN) FROM TT_EAN IEAN WHERE IEAN.FILMAT=VIPR.FILMAT AND IEAN.CODMAT=VIPR.CODMAT AND IEAN.CODCOR=VIPR.CODCOR AND IEAN.CODTAM=VIPR.CODTAM)',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       650,
       5,
       'RESIPI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'IPI',
       'Cdigo do IPI',
       '',
       'RESIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       660,
       5,
       'RESIRR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'IRR',
       'Cdigo do Imposto de Renda',
       '',
       'RESIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       820,
       1,
       'RETCOF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Reteno de COFINS?',
       'Permite Reteno de COFINS?',
       '',
       'RETCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '16',
       3220,
       8,
       'SALDO2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo 2 da Filial',
       'Saldo 2 da Filial',
       '',
       'SaldoDaFilial(:VIPR.DATREFSDF,VIPR.FILMAT,VIPR.CODMAT,VIPR.CODCOR,VIPR.CODTAM,:VIPR.CODFILSDF,:VIPR.CODMUL2)',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '17',
       3230,
       8,
       'SALDO3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo 3 da Filial',
       'Saldo 3 da Filial',
       '',
       'SaldoDaFilial(:VIPR.DATREFSDF,VIPR.FILMAT,VIPR.CODMAT,VIPR.CODCOR,VIPR.CODTAM,:VIPR.CODFILSDF,:VIPR.CODMUL3)',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '18',
       3240,
       8,
       'SALDO4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo 4 da Filial',
       'Saldo 4 da Filial',
       '',
       'SaldoDaFilial(:VIPR.DATREFSDF,VIPR.FILMAT,VIPR.CODMAT,VIPR.CODCOR,VIPR.CODTAM,:VIPR.CODFILSDF,:VIPR.CODMUL4)',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '19',
       4480,
       20,
       'STATUSKIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Status KIT',
       'Status KIT',
       '',
       'VERIFICASTATUSKIT(IPRF.FILMAT,IPRF.CODMAT,IPRF.CODCOR,IPRF.CODTAM)',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '19',
       4490,
       20,
       'REFKIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Referncia KIT',
       'Referncia Venda KIT',
       '',
       'REFERENCIAGRADEHEADERKIT(IPRF.FILMAT,IPRF.CODMAT,IPRF.CODCOR,IPRF.CODTAM)',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       2020,
       12,
       'SALDOEMTRANSITO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo em Transito',
       'Saldo em Transito',
       '',
       'SALDOEMTRANSITO(VIPR.FILMAT, VIPR.CODMAT, VIPR.CODCOR,VIPR.CODTAM)',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '09',
       2200,
       12,
       'SALDOPERIODO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       'Saldo no Perodo',
       'Saldo no Perodo',
       '',
       'SALDOPERIODO(VIPR.FILMAT,VIPR.CODMAT,VIPR.CODCOR,VIPR.CODTAM,:VIPR.SALDOPERIODO_DATINI,:VIPR.SALDOPERIODO.DATFIM)',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '05',
       2080,
       20,
       'SALDO_FILIAL_STRING',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Saldo Filial String',
       'Saldo Filial String',
       '',
       'TO_CHAR(SALDODAFILIAL(:VIPR.DATREFSDF,VIPR.FILMAT,VIPR.CODMAT,VIPR.CODCOR,VIPR.CODTAM,:VIPR.CODFILSDF))',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '09',
       2210,
       20,
       'SALDO_PERIODO_STRING',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Saldo Periodo String',
       'Saldo Periodo String',
       '',
       'TO_CHAR(SALDOPERIODO(VIPR.FILMAT,VIPR.CODMAT,VIPR.CODCOR,VIPR.CODTAM,:VIPR.SALDOPERIODO_DATINI,:VIPR.SALDOPERIODO.DATFIM))',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       920,
       10,
       'SEQCLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQCLA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       860,
       10,
       'SEQCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       670,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       680,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN VIPR.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       3100,
       2,
       'SITCOF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Cd. Sit. Trib. COF',
       'Cdigo de Situao Tributria do COFINS',
       '',
       'SITCOF',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       4230,
       2,
       'SITCOFCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'CST COFINS Compra',
       'Cdigo de Situao Tributria do COFINS para Compra',
       '',
       'SITCOFCOM',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       3200,
       1,
       'SITIPI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Cd. Sit. Trib. IPI',
       'Cdigo de Situao Tributria do IPI',
       '',
       'SITIPI',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       3190,
       2,
       'SITPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Cd. Sit. Trib. PIS',
       'Cdigo de Situao Tributria do PIS',
       '',
       'SITPIS',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       4240,
       2,
       'SITPISCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'CST PIS para Compra',
       'Cdigo de Situao Tributria do PIS para Compra',
       '',
       'SITPISCOM',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       4340,
       1,
       'SUBFED',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Substitudo Federal',
       'Substitudo Federal',
       '',
       'SUBFED',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       4120,
       5,
       'SUBFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SUBFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       930,
       1,
       'SUGSER',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SUGSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '05',
       2090,
       8,
       'SaldoDaFilial',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Saldo da Filial',
       'Saldo da Filial',
       '',
       'SaldoDaFilial(:VIPR.DATREFSDF,VIPR.FILMAT,VIPR.CODMAT,VIPR.CODCOR,VIPR.CODTAM,:VIPR.CODFILSDF)',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '04',
       2030,
       12,
       'SugestaoCompra',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Sugesto Compra',
       'Sugesto Compra',
       '',
       'SugestaoCompra(:VIPR.TIPPRJ,:VIPR.DAT01,:VIPR.DAT02,:VIPR.DATATE,VIPR.FILMAT,VIPR.CODMAT,VIPR.CODCOR,VIPR.CODTAM,:VIPR.CODFILLOC)',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       690,
       5,
       'TEMREP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tempo p/~Reposio',
       'Tempo de Reposio',
       '',
       'TEMREP',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       1050,
       254,
       'TERASS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TERASS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       4130,
       1,
       'TIPDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       700,
       1,
       'TIPMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Marca',
       'Tipo Marca',
       '',
       'TIPMAR',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       3500,
       1,
       'TIPMPB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo para MPB',
       'Tipo para Tratamento em MP do Bem',
       '',
       'TIPMPB',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       710,
       2,
       'TIPPRO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Produto',
       'Tipo de produto',
       '',
       'TIPPRO',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       4140,
       1,
       'TIPVAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPVAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       2010,
       12,
       'ULTIMO_ICMS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '% ICMS',
       '% ICMS',
       '',
       'RETORNAICMS(VIPR.FILMAT,VIPR.CODMAT,VIPR.CODCOR,VIPR.CODTAM)',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       720,
       5,
       'UNIAPL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Unidade Aplicao',
       'Unidade de Aplicao',
       '',
       'UNIAPL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       730,
       5,
       'UNIDAD',
       'S',
       'DMED',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMED.UNIMED',
       'V',
       '',
       '',
       'A',
       'F',
       'Unidade Venda',
       'Unidade Venda (medida utilizada  - Kg, l, m, etc.)',
       'DMED.CODTAB = VIPR.UNIDAD',
       'UNIDAD',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       740,
       5,
       'UNIEMB',
       'S',
       'DMED',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMED.UNIMED',
       'V',
       '',
       '',
       'A',
       'F',
       'Uni.Medida Embalagem',
       'Unidade de medida utilizada na embalagem',
       'DMED.CODTAB = VIPR.UNIEMB (+)',
       'UNIEMB',
       'T' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       750,
       5,
       'UNIFOR',
       'S',
       'DMED',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMED.UNIMED',
       'V',
       '',
       '',
       'A',
       'F',
       'Unidade Compra',
       'Unidade Compra (medida utilizada pelo fornecedor)',
       'DMED.CODTAB = VIPR.UNIFOR',
       'UNIFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       4150,
       1,
       'USABON',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'USABON',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       3730,
       1,
       'USALOT',
       'L',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Usa lote',
       'Usa lote?',
       '',
       'USALOT',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       2000,
       1,
       'UsaCodSal',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Controla~Estoque',
       'Controla Estoque',
       '',
       'UsaCodSal(VIPR.CODTAM)',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       760,
       12,
       'VALCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Val Conv. Ven/Com',
       'Valor de converso entre as unidades de Venda/Compra',
       '',
       'VALCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '01',
       1080,
       1,
       'VALEST',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Valida Estoque?',
       'Valida Estoque?',
       '',
       'VALEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       4160,
       5,
       'VALIDA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VALIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '10',
       2230,
       12,
       'VALORVENDIDO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Valor Vendido',
       'Valor Vendido',
       '',
       'VALORVENDAPRODUTO(:VIPR.VLRVENDATINI,:VIPR.VLRVENDATFIM,VIPR.FILMAT, VIPR.CODMAT, VIPR.CODCOR, VIPR.CODTAM, :VIPR.FILIALVV)',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       4170,
       6,
       'VENCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VENCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       4390,
       6,
       'VENCOFIMP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% COFINS Importao',
       '% COFINS na Importao',
       '',
       'VENCOFIMP',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       4180,
       6,
       'VENPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VENPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       4380,
       6,
       'VENPISIMP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% PIS Importao',
       '% PIS na Importao',
       '',
       'VENPISIMP',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       4190,
       16,
       'VLRCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VLRCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '--',
       4200,
       16,
       'VLRPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VLRPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '06',
       2120,
       8,
       'VLRTOTCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Valor total Compra',
       'Valor Total da Compra',
       '',
       'SaldoDaFilial(:VIPR.DATREFVTC,VIPR.FILMAT,VIPR.CODMAT,VIPR.CODCOR,VIPR.CODTAM,:VIPR.CODFILVTC)*PRECOM',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '07',
       2150,
       8,
       'VLRTOTREP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Vlr Total Reposio',
       'Valor Total Reposio',
       '',
       'SaldoDaFilial(:VIPR.DATREFVTR,VIPR.FILMAT,VIPR.CODMAT,VIPR.CODCOR,VIPR.CODTAM,:VIPR.CODFILVTR)*CUSREP',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '02',
       1070,
       15,
       'VOLUME',
       'F',
       '',
       5,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Volume m3',
       'Volume m3',
       '',
       'VOLUME',
       'F' FROM DUAL	   
UNION ALL
SELECT 'VIPR',
       '99',
       1071,
       1,
       'ENVECO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Envia p/ E-commerce?',
       'Envia para E-commerce?',
       '',
       'ENVECO',
       '' FROM DUAL
UNION ALL
SELECT 'VIPR',
       '99',
       1072,
       1,
       'SKYHUB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Envia p/ Skyhub?',
       'Envia para Skyhub?',
       '',
       'SKYHUB',
       '' FROM DUAL	
);

/*-- SEQ 10000 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VIPR',
       'ARRTRU',
       0,
       'A',
       'Arredondamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'ARRTRU',
       0,
       'T',
       'Truncamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'BRINDE',
       2,
       '-',
       ' Brinde',
       194,
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'BRINDE',
       1,
       '-',
       'Pode ser Brinde',
       193,
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'BRINDE',
       0,
       '-',
       'Nao  Brinde',
       192,
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'CLSABC',
       1,
       ' ',
       'B',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'CLSABC',
       2,
       ' ',
       'C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'CLSABC',
       0,
       ' ',
       'A',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'CLSXYZ',
       2,
       '-',
       'Z',
       191,
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'CLSXYZ',
       1,
       '-',
       'Y',
       190,
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'CLSXYZ',
       0,
       '-',
       'X',
       189,
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'ESTCHE',
       0,
       ' ',
       'S on-line',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'ESTCHE',
       1,
       ' ',
       'Replicado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'ESTCHE',
       9,
       ' ',
       'No controla',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'GRAABC',
       0,
       'A',
       'A',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'GRAABC',
       0,
       'B',
       'B',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'GRAABC',
       0,
       'C',
       'C',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'GRAXYZ',
       0,
       'X',
       'X',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'GRAXYZ',
       0,
       'Y',
       'Y',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'GRAXYZ',
       0,
       'Z',
       'Z',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'ICMTIP',
       0,
       '0',
       'Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'ICMTIP',
       0,
       '1',
       'No-Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'ICMTIP',
       0,
       '2',
       'Isento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'ICMTIP',
       0,
       '3',
       'Substitudo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'ICMTIP',
       0,
       '4',
       'Isento no Estado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'IIPTPR',
       0,
       'P',
       'p/ merc manufat pelo prop cont',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'IIPTPR',
       0,
       'T',
       'p/ merc manufat de terceiros',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'ORICUS',
       0,
       'C',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'ORICUS',
       0,
       'M',
       'Manual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'ORICUS',
       0,
       'P',
       'Pedido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'ORIPRO',
       0,
       '0',
       'Nacional, exceto cd.3,4,5,8',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'ORIPRO',
       0,
       '1',
       'Estrang., Import.Dir., Exc.6',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'ORIPRO',
       0,
       '2',
       'Estrang., Adq.Int., Exc.7',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'ORIPRO',
       0,
       '3',
       'Nacional, Cont.Import.>40%<70%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'ORIPRO',
       0,
       '4',
       'Nacional, Conf.Proc.Prod.Bs.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'ORIPRO',
       0,
       '5',
       'Nacional, Cont.Import <= 40%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'ORIPRO',
       0,
       '6',
       'Estrang., Import.Dir.CAMEX-GNL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'ORIPRO',
       0,
       '7',
       'Estrang., Adq.Int. CAMEX-GNL',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'ORIPRO',
       0,
       '8',
       'Nacional, Import. > a 70%',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOF',
       0,
       ' ',
       'Tributvel (base de clculo)',
       TO_NUMBER(null),
       '01' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOF',
       0,
       ' ',
       'Ope. Trib. Alq. Diferenciada',
       TO_NUMBER(null),
       '02' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOF',
       0,
       ' ',
       'Ope. Trib. Alq Und Med.Pro',
       TO_NUMBER(null),
       '03' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOF',
       0,
       ' ',
       'Ope. Trib. Monofsica Rev.Alq',
       TO_NUMBER(null),
       '04' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOF',
       0,
       ' ',
       'Ope. Trib. Substituio Trib.',
       TO_NUMBER(null),
       '05' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOF',
       0,
       ' ',
       'Tributvel (alquota zero)',
       TO_NUMBER(null),
       '06' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOF',
       0,
       ' ',
       'Isenta da Contribuio',
       TO_NUMBER(null),
       '07' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOF',
       0,
       ' ',
       'Sem Incidncia da Contribuio',
       TO_NUMBER(null),
       '08' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOF',
       0,
       ' ',
       'Com Suspenso da Contribuio ',
       TO_NUMBER(null),
       '09' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOF',
       0,
       ' ',
       'Outras Operaes de Sada',
       TO_NUMBER(null),
       '49' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOF',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Trib Export',
       TO_NUMBER(null),
       '64' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis NTrib Export',
       TO_NUMBER(null),
       '65' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Trib NTrib Exp',
       TO_NUMBER(null),
       '66' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Outras Operaes',
       TO_NUMBER(null),
       '67' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio sem Dir Crdito',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio com Iseno',
       TO_NUMBER(null),
       '71' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio com Suspenso',
       TO_NUMBER(null),
       '72' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio a Alquota Zero',
       TO_NUMBER(null),
       '73' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio sem Inc Contrib',
       TO_NUMBER(null),
       '74' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Aquisio por ST',
       TO_NUMBER(null),
       '75' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Outras Operaes de Entrada',
       TO_NUMBER(null),
       '98' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Tributada',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-No Tributada',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Exportao',
       TO_NUMBER(null),
       '52' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Vinc Trib Export',
       TO_NUMBER(null),
       '54' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Vinc NTrib Export',
       TO_NUMBER(null),
       '55' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib Exp',
       TO_NUMBER(null),
       '56' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Exc Trib',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Exc NTrib',
       TO_NUMBER(null),
       '61' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Exc Export',
       TO_NUMBER(null),
       '62' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITCOFCOM',
       0,
       ' ',
       'Presum-Aquis Trib NTrib',
       TO_NUMBER(null),
       '63' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITIPI',
       0,
       '0',
       'Tributada',
       TO_NUMBER(null),
       '0' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITIPI',
       0,
       '1',
       'Tributada com alquota zero',
       TO_NUMBER(null),
       '1' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITIPI',
       0,
       '2',
       'Isenta',
       TO_NUMBER(null),
       '2' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITIPI',
       0,
       '3',
       'No-tributada',
       TO_NUMBER(null),
       '3' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITIPI',
       0,
       '4',
       'Imune',
       TO_NUMBER(null),
       '4' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITIPI',
       0,
       '5',
       'Com suspenso',
       TO_NUMBER(null),
       '5' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITIPI',
       0,
       '9',
       'Outras',
       TO_NUMBER(null),
       '9' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPIS',
       0,
       ' ',
       'Tributvel (base de clculo)',
       TO_NUMBER(null),
       '01' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPIS',
       0,
       ' ',
       'Ope. Trib. Alq. Diferenciada',
       TO_NUMBER(null),
       '02' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPIS',
       0,
       ' ',
       'Ope. Trib. Alq Und Med.Pro',
       TO_NUMBER(null),
       '03' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPIS',
       0,
       ' ',
       'Ope. Trib. Monofsica Rev.Alq',
       TO_NUMBER(null),
       '04' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPIS',
       0,
       ' ',
       'Ope. Trib. Substituio Trib.',
       TO_NUMBER(null),
       '05' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPIS',
       0,
       ' ',
       'Tributvel (alquota zero) ',
       TO_NUMBER(null),
       '06' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPIS',
       0,
       ' ',
       'Isenta da Contribuio ',
       TO_NUMBER(null),
       '07' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPIS',
       0,
       ' ',
       'Sem Incidncia da Contribuio',
       TO_NUMBER(null),
       '08' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPIS',
       0,
       ' ',
       'Com Suspenso da Contribuio ',
       TO_NUMBER(null),
       '09' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPIS',
       0,
       ' ',
       'Outras Operaes de Sada',
       TO_NUMBER(null),
       '49' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPIS',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Trib Export',
       TO_NUMBER(null),
       '64' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis NTrib Export',
       TO_NUMBER(null),
       '65' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Trib NTrib Exp',
       TO_NUMBER(null),
       '66' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Outras Operaes',
       TO_NUMBER(null),
       '67' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio sem Dir Crdito',
       TO_NUMBER(null),
       '70' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio com Iseno',
       TO_NUMBER(null),
       '71' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio com Suspenso',
       TO_NUMBER(null),
       '72' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio a Alquota Zero',
       TO_NUMBER(null),
       '73' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio sem Inc Contrib',
       TO_NUMBER(null),
       '74' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Aquisio por ST',
       TO_NUMBER(null),
       '75' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Outras Operaes de Entrada',
       TO_NUMBER(null),
       '98' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Outras Operaes',
       TO_NUMBER(null),
       '99' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Tributada',
       TO_NUMBER(null),
       '50' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-No Tributada',
       TO_NUMBER(null),
       '51' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Exportao',
       TO_NUMBER(null),
       '52' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib',
       TO_NUMBER(null),
       '53' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Vinc Trib Export',
       TO_NUMBER(null),
       '54' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Vinc NTrib Export',
       TO_NUMBER(null),
       '55' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Crdito-Vinc Trib NTrib Exp',
       TO_NUMBER(null),
       '56' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Exc Trib',
       TO_NUMBER(null),
       '60' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Exc NTrib',
       TO_NUMBER(null),
       '61' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Exc Export',
       TO_NUMBER(null),
       '62' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'SITPISCOM',
       0,
       ' ',
       'Presum-Aquis Trib NTrib',
       TO_NUMBER(null),
       '63' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'TIPMAR',
       0,
       'M',
       'Marca',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'TIPMPB',
       0,
       'C',
       'Conj. CPU, Monitor e Mouse',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'TIPMPB',
       0,
       'T',
       'Tablet',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'TIPPRO',
       2,
       ' ',
       'Terceirizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'TIPPRO',
       0,
       ' ',
       'Material',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'TIPPRO',
       1,
       ' ',
       'Servio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'STATUSKIT',
       0,
       '',
       'KIT',
       TO_NUMBER(null),
       '1' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'STATUSKIT',
       0,
       '',
       'Normal',
       TO_NUMBER(null),
       '2' FROM DUAL
UNION ALL
SELECT 'VIPR',
       'STATUSKIT',
       0,
       '',
       'Item de KIT',
       TO_NUMBER(null),
       '3' FROM DUAL
);

/*-- SEQ 10001 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VIRO',
       TO_NUMBER(null),
       'VIRO',
       'Evento Item Romaneio',
       'TV_EVE_IRO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VIRO.CHVEVE,VIRO.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 10002 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VIRO','--','' FROM DUAL
UNION ALL
SELECT 'VIRO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VIRO','99','Outros' FROM DUAL
);

/*-- SEQ 10003 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VIRO',
       '01',
       10,
       10,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Chave do Evento',
       'Chave do Evento',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIRO',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIRO',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIRO',
       '01',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'USU.FILUSU(+) = VIRO.FILUSU  AND = USU.CODUSU(+) = VIRO.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VIRO',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIRO',
       '01',
       50,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Operao',
       'Data de Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIRO',
       '01',
       60,
       5,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Evento',
       'Descrio Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIRO',
       '01',
       70,
       13,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificador Evento',
       'Identificador de Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'VIRO',
       '01',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIRO',
       '01',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VIRO',
       '01',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VIRO',
       '01',
       110,
       254,
       'MSGEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem do Evento',
       'Mensagem do Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIRO',
       '01',
       120,
       10,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao do Evento',
       'Situao do Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIRO',
       '01',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo de Eventos',
       'Tipo de Eventos',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIRO',
       '01',
       140,
       12,
       'VLREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Evento',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 10004 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VIRO',
       'FLGEST',
       0,
       'A',
       'A Entregar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIRO',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10005 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VISP',
       TO_NUMBER(null),
       'VISP',
       'Instruo x SGP',
       'TV_IXT_SGP',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VISP.CODFIL,VISP.CODBCO',
       '' FROM DUAL
);

/*-- SEQ 10006 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VISP','--','' FROM DUAL
UNION ALL
SELECT 'VISP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VISP','02','Datas' FROM DUAL
UNION ALL
SELECT 'VISP','03','Valores' FROM DUAL
UNION ALL
SELECT 'VISP','99','Outros' FROM DUAL
);

/*-- SEQ 10007 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VISP',
       '01',
       10,
       3,
       'CODBCO',
       'A',
       'DBCO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DBCO.NBANCO',
       'V',
       '',
       '',
       'N',
       'F',
       'Banco',
       'Cdigo do Banco',
       'DBCO.CBANCO(+) = VISP.CODBCO',
       'CODBCO',
       'T' FROM DUAL
UNION ALL
SELECT 'VISP',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = VISP.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VISP',
       '01',
       30,
       10,
       'CTACRR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm. Conta Corrente',
       'Nmero da Conta Corrente',
       '',
       'CTACRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VISP',
       '01',
       40,
       5,
       'INSTR1',
       'S',
       'DINS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DINS.DESINS',
       'V',
       '',
       '',
       'A',
       'F',
       'Instruco 1',
       'Codigo de instrucao 1 (TD_INS)',
       'DINS.CODTAB = VISP.INSTR1',
       'INSTR1',
       'T' FROM DUAL
UNION ALL
SELECT 'VISP',
       '01',
       50,
       5,
       'INSTR2',
       'S',
       'DINS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DINS.DESINS',
       'V',
       '',
       '',
       'A',
       'F',
       'Instruco 2',
       'Codigo de instrucao 2 (TD_INS)',
       'DINS.CODTAB = VISP.INSTR2',
       'INSTR2',
       'T' FROM DUAL
UNION ALL
SELECT 'VISP',
       '99',
       60,
       4000,
       'LINHA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'VISP',
       '01',
       70,
       5,
       'NUMAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero da Agncia',
       'Nmero da Agncia',
       '',
       'NUMAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'VISP',
       '99',
       80,
       1,
       'NUMREG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Nmero Registro?',
       'Nmero Registro?',
       '',
       'NUMREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VISP',
       '99',
       90,
       1,
       'REGIST',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Registra Instruo?',
       'Registra Instruo?',
       '',
       'REGIST',
       'F' FROM DUAL
UNION ALL
SELECT 'VISP',
       '03',
       100,
       12,
       'REMBCO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Remessa Banco',
       'Remessa Banco',
       '',
       'REMBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'VISP',
       '99',
       110,
       1,
       'SEGREG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Seg. Registro?',
       'Seg. Registro?',
       '',
       'SEGREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VISP',
       '99',
       120,
       1,
       'TIPREG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tipo Registro? ',
       'Tipo Registro?',
       '',
       'TIPREG',
       'F' FROM DUAL
);

/*-- SEQ 10008 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VISQ',
       TO_NUMBER(null),
       'VISQ',
       'IXT x SGQ',
       'TV_IXT_SGQ',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VISQ.CODFIL,VISQ.CODBCO',
       '' FROM DUAL
);

/*-- SEQ 10009 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VISQ','--','' FROM DUAL
UNION ALL
SELECT 'VISQ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VISQ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VISQ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VISQ','99','Outros' FROM DUAL
);

/*-- SEQ 10010 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VISQ',
       '01',
       10,
       3,
       'CODBCO',
       'A',
       'DBCO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DBCO.NBANCO',
       'V',
       '',
       '',
       'N',
       'F',
       'Banco',
       'Cdigo do Banco',
       'DBCO.CBANCO(+) = VISQ.CODBCO',
       'CODBCO',
       'T' FROM DUAL
UNION ALL
SELECT 'VISQ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = VISQ.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VISQ',
       '01',
       30,
       10,
       'CTACRR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm. Conta Corrente',
       'Nmero da Conta Corrente',
       '',
       'CTACRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VISQ',
       '01',
       40,
       5,
       'INSTR1',
       'S',
       'DINS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DINS.DESINS',
       'V',
       '',
       '',
       'A',
       'F',
       'Instruco 1',
       'Codigo de instrucao 1 (TD_INS)',
       'DINS.CODTAB = VISQ.INSTR1',
       'INSTR1',
       'T' FROM DUAL
UNION ALL
SELECT 'VISQ',
       '01',
       50,
       5,
       'INSTR2',
       'S',
       'DINS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DINS.DESINS',
       'V',
       '',
       '',
       'A',
       'F',
       'Instruco 2',
       'Codigo de instrucao 2 (TD_INS)',
       'DINS.CODTAB = VISQ.INSTR2',
       'INSTR2',
       'T' FROM DUAL
UNION ALL
SELECT 'VISQ',
       '99',
       60,
       4000,
       'LINHA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'VISQ',
       '01',
       70,
       5,
       'NUMAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero da Agncia',
       'Nmero da Agncia',
       '',
       'NUMAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'VISQ',
       '99',
       80,
       1,
       'NUMREG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Nmero Registro?',
       'Nmero Registro?',
       '',
       'NUMREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VISQ',
       '99',
       90,
       1,
       'REGIST',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Registra Instruo?',
       'Registra Instruo?',
       '',
       'REGIST',
       'F' FROM DUAL
UNION ALL
SELECT 'VISQ',
       '03',
       100,
       12,
       'REMBCO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Remessa Banco',
       'Remessa Banco',
       '',
       'REMBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'VISQ',
       '99',
       110,
       1,
       'SEGREG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Seg. Registro?',
       'Seg. Registro?',
       '',
       'SEGREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VISQ',
       '99',
       120,
       1,
       'TIPREG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tipo Registro? ',
       'Tipo Registro?',
       '',
       'TIPREG',
       'F' FROM DUAL
);

/*-- SEQ 10011 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VIT ',
       TO_NUMBER(null),
       'VIT ',
       'Instruo x TAQ',
       'TV_IXT_TAQ',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VIT.CODFIL,VIT.CODBCO',
       '' FROM DUAL
);

/*-- SEQ 10012 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VIT ','--','' FROM DUAL
UNION ALL
SELECT 'VIT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VIT ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VIT ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VIT ','99','Outros' FROM DUAL
);

/*-- SEQ 10013 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VIT ',
       '01',
       10,
       3,
       'CODBCO',
       'A',
       'DBCO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DBCO.NBANCO',
       'V',
       '',
       '',
       'N',
       'F',
       'Banco',
       'Cdigo do Banco',
       'DBCO.CBANCO(+) = VIT.CODBCO',
       'CODBCO',
       'T' FROM DUAL
UNION ALL
SELECT 'VIT ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = VIT.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIT ',
       '01',
       30,
       10,
       'CTACRR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm. Conta Corrente',
       'Nmero da Conta Corrente',
       '',
       'CTACRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIT ',
       '01',
       40,
       5,
       'INSTR1',
       'S',
       'DINS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DINS.DESINS',
       'V',
       '',
       '',
       'A',
       'F',
       'Instruco 1',
       'Codigo de instrucao 1 (TD_INS)',
       'DINS.CODTAB = VIT.INSTR1',
       'INSTR1',
       'T' FROM DUAL
UNION ALL
SELECT 'VIT ',
       '01',
       50,
       5,
       'INSTR2',
       'S',
       'DINS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DINS.DESINS',
       'V',
       '',
       '',
       'A',
       'F',
       'Instruco 2',
       'Codigo de instrucao 2 (TD_INS)',
       'DINS.CODTAB = VIT.INSTR2',
       'INSTR2',
       'T' FROM DUAL
UNION ALL
SELECT 'VIT ',
       '99',
       60,
       4000,
       'LINHA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIT ',
       '01',
       70,
       5,
       'NUMAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero da Agncia',
       'Nmero da Agncia',
       '',
       'NUMAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIT ',
       '99',
       80,
       1,
       'NUMREG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Nmero Registro?',
       'Nmero Registro?',
       '',
       'NUMREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VIT ',
       '99',
       90,
       1,
       'REGIST',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Registra Instruo?',
       'Registra Instruo?',
       '',
       'REGIST',
       'F' FROM DUAL
UNION ALL
SELECT 'VIT ',
       '03',
       100,
       12,
       'REMBCO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Remessa Banco',
       'Remessa Banco',
       '',
       'REMBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'VIT ',
       '99',
       110,
       1,
       'SEGREG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Seg. Registro?',
       'Seg. Registro?',
       '',
       'SEGREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VIT ',
       '99',
       120,
       1,
       'TIPREG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tipo Registro? ',
       'Tipo Registro?',
       '',
       'TIPREG',
       'F' FROM DUAL
);

/*-- SEQ 10014 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VITL',
       TO_NUMBER(null),
       'VITL',
       'Instruo x TLT',
       'TV_IXT_TLT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VITL.CODFIL,VITL.CODBCO',
       '' FROM DUAL
);

/*-- SEQ 10015 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VITL','--','' FROM DUAL
UNION ALL
SELECT 'VITL','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VITL','02','Datas' FROM DUAL
UNION ALL
SELECT 'VITL','03','Valores' FROM DUAL
UNION ALL
SELECT 'VITL','99','Outros' FROM DUAL
);

/*-- SEQ 10016 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VITL',
       '01',
       10,
       3,
       'CODBCO',
       'A',
       'DBCO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DBCO.NBANCO',
       'V',
       '',
       '',
       'N',
       'F',
       'Banco',
       'Cdigo do Banco',
       'DBCO.CBANCO(+) = VITL.CODBCO',
       'CODBCO',
       'T' FROM DUAL
UNION ALL
SELECT 'VITL',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = VITL.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VITL',
       '01',
       30,
       10,
       'CTACRR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm. Conta Corrente',
       'Nmero da Conta Corrente',
       '',
       'CTACRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VITL',
       '01',
       40,
       5,
       'INSTR1',
       'S',
       'DINS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DINS.DESINS',
       'V',
       '',
       '',
       'A',
       'F',
       'Instruco 1',
       'Codigo de instrucao 1 (TD_INS)',
       'DINS.CODTAB = VITL.INSTR1',
       'INSTR1',
       'T' FROM DUAL
UNION ALL
SELECT 'VITL',
       '01',
       50,
       5,
       'INSTR2',
       'S',
       'DINS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DINS.DESINS',
       'V',
       '',
       '',
       'A',
       'F',
       'Instruco 2',
       'Codigo de instrucao 2 (TD_INS)',
       'DINS.CODTAB = VITL.INSTR2',
       'INSTR2',
       'T' FROM DUAL
UNION ALL
SELECT 'VITL',
       '01',
       60,
       4000,
       'LINHA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'VITL',
       '01',
       70,
       5,
       'NUMAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero da Agncia',
       'Nmero da Agncia',
       '',
       'NUMAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'VITL',
       '99',
       80,
       1,
       'NUMREG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Nmero Registro?',
       'Nmero Registro?',
       '',
       'NUMREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VITL',
       '99',
       90,
       1,
       'REGIST',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Registra Instruo?',
       'Registra Instruo?',
       '',
       'REGIST',
       'F' FROM DUAL
UNION ALL
SELECT 'VITL',
       '03',
       100,
       12,
       'REMBCO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Remessa Banco',
       'Remessa Banco',
       '',
       'REMBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'VITL',
       '99',
       110,
       1,
       'SEGREG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Seg. Registro?',
       'Seg. Registro?',
       '',
       'SEGREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VITL',
       '99',
       120,
       1,
       'TIPREG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Tipo Registro? ',
       'Tipo Registro?',
       '',
       'TIPREG',
       'F' FROM DUAL
);

/*-- SEQ 10017 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VITP',
       TO_NUMBER(null),
       'VITP',
       'Ped. BASF Cabealho',
       'TV_PED_BASF_ITP',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10018 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VITP','--','' FROM DUAL
UNION ALL
SELECT 'VITP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VITP','99','Outros' FROM DUAL
);

/*-- SEQ 10019 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VITP',
       '99',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'V',
       '',
       '',
       '0',
       'F',
       'Cdigo Filial ',
       'Cdigo Filial ',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VITP',
       '99',
       20,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '9',
       'F',
       'Cdigo Fornecedor',
       'Cdigo Fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VITP',
       '99',
       30,
       7,
       'DATENV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data/Hora de Envio',
       'Data/Hora de Envio',
       '',
       'DATENV',
       'F' FROM DUAL
UNION ALL
SELECT 'VITP',
       '99',
       40,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       '0',
       'F',
       'Filial Fornecedor',
       'Filial Fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VITP',
       '99',
       50,
       247,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Layout de Exportao',
       'Linha do Layout de Exportao',
       '',
       'LINHA',
       'F' FROM DUAL
UNION ALL
SELECT 'VITP',
       '99',
       60,
       12,
       'NUMITE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'N Item',
       'Nmero do Item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VITP',
       '99',
       70,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'N Pedido',
       'Nmero do Pedido de Compra',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'VITP',
       '99',
       80,
       1,
       'REFFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ref. Fornecedor',
       'Cdigo de Referncia do Produto no Fornecedor',
       '',
       'REFFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VITP',
       '99',
       90,
       1,
       'TIPFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Fornecedor',
       'Tipo Fornecedor',
       '',
       'TIPFOR',
       'F' FROM DUAL
);

/*-- SEQ 10020 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VIVO',
       TO_NUMBER(null),
       'VIVO',
       'Separao Mercadoria',
       'TV_IVO',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VIVO.FILVOL,VIVO.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 10021 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VIVO','--','' FROM DUAL
UNION ALL
SELECT 'VIVO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VIVO','99','Outros' FROM DUAL
);

/*-- SEQ 10022 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22178,
       'LOT ',
       'VIVO',
       '0N',
       '01',
       '',
       '',
       'VIVO.FILLOT = LOT.CODFIL(+) AND
VIVO.SEQLOT = LOT.SEQUEN(+)
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22179,
       'IVE ',
       'VIVO',
       'N',
       '1',
       '',
       '',
       'VIVO.FILIVE = IVE.CODFIL AND
VIVO.SEQIVE = IVE.SEQUEN AND
VIVO.NUMIVE = IVE.NUMITE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22180,
       'IOR ',
       'VIVO',
       'N',
       '1',
       '',
       '',
       'VIVO.FILPED = IOR.CODFIL AND
VIVO.TIPPED = IOR.TIPPED AND
VIVO.NUMPED = IOR.NUMPED AND
VIVO.NUMITE = IOR.NUMITE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22181,
       'IVO ',
       'VIVO',
       '1',
       '1',
       '',
       '',
       'VIVO.FILVOL=IVO.FILVOL AND
VIVO.SEQUEN=IVO.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22182,
       'IPE ',
       'VIVO',
       'N',
       '1',
       '',
       '',
       'VIVO.FILIPE = IPE.CODFIL AND
VIVO.NUMIPE = IPE.NUMPED AND
VIVO.ITEIPE = IPE.NUMITE
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22183,
       'CLI ',
       'VIVO',
       'N',
       '1',
       '',
       '',
       'VIVO.FILCLI=CLI.FILCLI AND
VIVO.CODCLI=CLI.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22184,
       'GRA ',
       'VIVO',
       'N',
       '1',
       '',
       '',
       'GRA.FILMAT = VIVO.GRA_FILMAT AND
GRA.CODMAT = VIVO.GRA_CODMAT AND
GRA.CODCOR = VIVO.GRA_CODCOR AND
GRA.CODTAM = VIVO.GRA_CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 10023 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VIVO',
       '--',
       10,
       40,
       'BAIRRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Bairro',
       'Bairro',
       '',
       'BAIRRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd. Cliente Ttulo',
       'Cd. Cliente Ttulo',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       40,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Filial Ttulo',
       'Filial Ttulo',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       50,
       3,
       'CODFIL2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Romaneio',
       'Filial Romaneio',
       '',
       'CODFIL2',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       670,
       6,
       'CODMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cdigo Motorista',
       'Cdigo Motorista',
       '',
       'CODMOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       60,
       12,
       'CODNAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Natureza',
       'Natureza',
       '',
       'CODNAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       70,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       80,
       6,
       'CODTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd. Transportador',
       'Cd. Transportador',
       '',
       'CODTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       90,
       3,
       'CODVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cd. Vendedor',
       'Cd. Vendedor',
       '',
       'CODVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       100,
       12,
       'CONTEM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'T',
       'N',
       'F',
       'Contm',
       'Contm',
       '',
       'CONTEM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       110,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data',
       'Data',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       120,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Operao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       740,
       2,
       'DEPART',
       'S',
       'DDEP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDEP.DESDEP',
       'V',
       '',
       '',
       'A',
       '',
       'Departamento',
       'Departamento do Produto',
       'VIVO.DEPART = DDEP.CODTAB',
       'DEPART',
       '' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       490,
       30,
       'DESMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Produto',
       'Descrio Produto',
       '',
       'DESMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       130,
       54,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificao Ttulo',
       'Identificao Ttulo',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '01',
       520,
       6,
       'EDE_CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'EDE_CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '01',
       530,
       3,
       'EDE_CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'EDE_CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '01',
       540,
       3,
       'EDE_FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'EDE_FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '01',
       550,
       4,
       'EDE_NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'EDE_NUMEND',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       150,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Filial Cliente Tt.',
       'Filial Cliente de Ttulo',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       370,
       3,
       'FILIPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Fil. Ped. Compra',
       'Fil. Ped. Compra',
       '',
       'FILIPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       380,
       3,
       'FILIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Fil. Itens Complem.',
       'Fil. Itens Complementados',
       '',
       'FILIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       710,
       3,
       'FILLOT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial Lote',
       'Filial do Lote',
       'DFIL.CODFIL(+) = VIVO.FILLOT',
       'FILLOT',
       'T' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       680,
       3,
       'FILMOT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial Motorista',
       'Filial Motorista',
       'DFIL.CODFIL(+) = VIVO.FILMOT',
       'FILMOT',
       'T' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       390,
       3,
       'FILPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Fil. Pedido',
       'Fil. Pedido',
       '',
       'FILPED',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       170,
       3,
       'FILTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Transportador',
       'Filial Transportador',
       '',
       'FILTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       180,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Vendedor',
       'Filial Vendedor',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       400,
       3,
       'FILVOL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Fil. Volume',
       'Fil. Volume',
       '',
       'FILVOL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       190,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Estado da Separao',
       'Estado da Separao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       690,
       1,
       'FLGROM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Estado Romaneio',
       'Estado Romaneio',
       '',
       'FLGROM',
       'T' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '01',
       560,
       5,
       'GRA_CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'GRA_CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '01',
       570,
       5,
       'GRA_CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'GRA_CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '01',
       580,
       5,
       'GRA_CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'GRA_CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '01',
       590,
       3,
       'GRA_FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'GRA_FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       510,
       5,
       'ITEDOC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Item',
       'Item',
       '',
       'ITEDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       410,
       5,
       'ITEIPE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Item Ped. Compra',
       'Item Ped. Compra',
       '',
       'ITEIPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       200,
       64,
       'MOTORA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motorista',
       'Motorista',
       '',
       'MOTORA',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       210,
       35,
       'NOMCID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cidade',
       'Cidade',
       '',
       'NOMCID',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       220,
       14,
       'NUMCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ident. de Romaneio',
       'Identificao de Romaneio',
       '',
       'NUMCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       230,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ecf',
       'Ecf',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       420,
       8,
       'NUMIPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Pedido Ped. Compra',
       'Pedido Ped. Compra',
       '',
       'NUMIPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       430,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Item Pedido / OS',
       'Item Pedido / OS',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       440,
       5,
       'NUMIVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Item da Venda',
       'Item da Venda',
       '',
       'NUMIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       240,
       8,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nr. Nota',
       'Nr. Nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       250,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nr. Pedido',
       'Nr. Pedido',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       660,
       1,
       'ORIGEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem',
       'Origem',
       '',
       'ORIGEM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       260,
       12,
       'PESCAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'T',
       'N',
       'F',
       'Peso Bruto',
       'Peso Bruto',
       '',
       'PESCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       270,
       7,
       'PLACAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Placa',
       'Placa',
       '',
       'PLACAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '01',
       600,
       5,
       'PRO_CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRO_CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '01',
       610,
       3,
       'PRO_FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRO_FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       280,
       12,
       'QTDFAL',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade Faltante',
       'Quantidade Faltante',
       '',
       'QTDFAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       620,
       12,
       'QTDITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade',
       'Quantidade',
       '',
       'QTDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       630,
       12,
       'QTDSEP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtd a Separar',
       'Quantidade a Separar',
       '',
       'QTDSEP',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       500,
       20,
       'REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Referncia de Grade',
       'Referncia de Grade',
       '',
       'REFPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       290,
       5,
       'REGIAO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Regio',
       'Regio',
       '',
       'REGIAO',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '01',
       640,
       3,
       'ROM_CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ROM_CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '01',
       650,
       10,
       'ROM_SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ROM_SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       460,
       10,
       'SEQIVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequen. da Venda',
       'Sequen. da Venda',
       '',
       'SEQIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       720,
       10,
       'SEQLOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq Lote',
       'Sequenciador do Lote',
       '',
       'SEQLOT',
       '' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       300,
       10,
       'SEQROM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Seq. Romaneio',
       'Seq. Romaneio',
       '',
       'SEQROM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       310,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Seq. Item Volume',
       'Seq. Item Volume',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       730,
       1,
       'TIPENT',
       'A',
       'DENT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DENT.DESENT',
       'V',
       '',
       '',
       'A',
       '',
       'Tipo de Entrega',
       'Tipo de Entrega',
       'DENT.CODTAB = TO_NUMBER(VIVO.TIPENT)',
       'TIPENT',
       '' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       320,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Pedido / OS',
       'Tipo de Pedido / OS',
       '',
       'TIPPED',
       'T' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       750,
       12,
       'VLRBRU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Total~Sem Desc',
       'Valor Total do Item Sem Desconto',
       '',
       'VLRBRU',
       '' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       700,
       14,
       'VLRITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Item',
       'Valor Item',
       '',
       'VLRITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       350,
       14,
       'VLRNOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'T',
       'N',
       'F',
       ' Valor Total Itens',
       'Valor Total dos Itens',
       '',
       'VLRNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIVO',
       '--',
       360,
       12,
       'VOLCAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'T',
       'N',
       'F',
       'Volume m3',
       'Volume m3',
       '',
       'VOLCAR',
       'F' FROM DUAL
);

/*-- SEQ 10024 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VIVO',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIVO',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIVO',
       'FLGEST',
       0,
       'D',
       'Devolver',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIVO',
       'FLGEST',
       0,
       'E',
       'Entregue',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIVO',
       'FLGEST',
       0,
       'F',
       'Em Falta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIVO',
       'FLGEST',
       0,
       'N',
       'No Separar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIVO',
       'FLGEST',
       0,
       'O',
       'Encomendado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIVO',
       'FLGEST',
       0,
       'P',
       'Separado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIVO',
       'FLGROM',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIVO',
       'FLGROM',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIVO',
       'FLGROM',
       0,
       'E',
       'Entregue',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIVO',
       'FLGROM',
       0,
       'F',
       'Fechado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIVO',
       'ORIGEM',
       0,
       'O',
       'Oramento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIVO',
       'ORIGEM',
       0,
       'P',
       'Pedido de Reposio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIVO',
       'ORIGEM',
       0,
       'V',
       'Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIVO',
       'TIPPED',
       0,
       'O',
       'DAV',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIVO',
       'TIPPED',
       0,
       'P',
       'Pr-Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIVO',
       'TIPPED',
       0,
       'S',
       'DAV-OS',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10025 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VIXI',
       TO_NUMBER(null),
       'VIXI',
       'Encomendas Recebidas',
       'TV_IVEXIPE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10026 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VIXI','--','' FROM DUAL
UNION ALL
SELECT 'VIXI','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VIXI','99','Outros' FROM DUAL
);

/*-- SEQ 10027 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 29762,
       'GRA ',
       'VIXI',
       '1',
       'N',
       '',
       '',
       'GRA.FILMAT = VIXI.FILMAT AND
GRA.CODMAT = VIXI.CODMAT AND
GRA.CODCOR = VIXI.CODCOR AND
GRA.CODTAM = VIXI.CODTAM
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 29761,
       'CLI ',
       'VIXI',
       '1',
       'N',
       '',
       '',
       'CLI.FILCLI = VIXI.FILCLI AND
CLI.CODCLI = VIXI.CODCLI',
       '',
       '' FROM DUAL
);

/*-- SEQ 10028 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VIXI',
       '01',
       130,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Cdigo Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 'VIXI',
       '01',
       170,
       1,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       '',
       'N',
       '',
       'Cdigo Diviso',
       'Cdigo Diviso',
       'DIV.CODITE = VIXI.CODCOR',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIXI',
       '01',
       10,
       3,
       'CODFIL_VEN',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Cdigo Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = VIXI.CODFIL_VEN',
       'CODFIL_VEN',
       '' FROM DUAL
UNION ALL
SELECT 'VIXI',
       '01',
       160,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Cdigo Material',
       'Cdigo Material',
       '',
       'CODMAT',
       '' FROM DUAL
UNION ALL
SELECT 'VIXI',
       '01',
       110,
       1,
       'CODMUL',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'N',
       '',
       'Cdigo Mul-Estoque',
       'Cdigo Mul-Estoque',
       'DMUL.CODTAB = VIXI.CODMUL',
       'CODMUL',
       '' FROM DUAL
UNION ALL
SELECT 'VIXI',
       '01',
       70,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       '',
       'Cdigo Srie',
       'Cdigo Srie',
       'DSER.CODSER = VIXI.CODSER',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VIXI',
       '01',
       180,
       1,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       '',
       'N',
       '',
       'Cdigo Sub-Diviso',
       'Cdigo Sub-Diviso',
       'SUB.CODITE = VIXI.CODTAM',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'VIXI',
       '01',
       30,
       3,
       'CODVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Cdigo Vendedor',
       'Cdigo Vendedor',
       '',
       'CODVEN',
       '' FROM DUAL
UNION ALL
SELECT 'VIXI',
       '01',
       100,
       8,
       'DATOPE',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Operao',
       'Data Operao',
       '',
       'DATOPE',
       '' FROM DUAL
UNION ALL
SELECT 'VIXI',
       '01',
       120,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Cliente',
       'Filial Cliente',
       'DFIL.CODFIL = VIXI.FILCLI',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VIXI',
       '01',
       40,
       3,
       'FILIOR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Item Pedido',
       'Filial Item Pedido',
       'DFIL.CODFIL = VIXI.FILIOR',
       'FILIOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VIXI',
       '01',
       150,
       3,
       'FILMAT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Material',
       'Filial Material',
       'DFIL.CODFIL = VIXI.FILMAT',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VIXI',
       '01',
       20,
       3,
       'FILVEN',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Venda',
       'Filial Venda',
       'DFIL.CODFIL = VIXI.FILVEN',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VIXI',
       '01',
       140,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'VIXI',
       '01',
       31,
       3,
       'NOMVEN',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'A',
       '',
       'Vendedor',
       'Vendedor',
       'VIXI.FILVDD = USU.FILUSU(+) AND VIXI.CODVDD = USU.CODUSU(+)',
       'NOMVEN',
       'T' FROM DUAL
UNION ALL
SELECT 'VIXI',
       '01',
       80,
       3,
       'NUMECF',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       '',
       'Nmero ECF',
       'Nmero ECF',
       'DECF.FILECF = VIXI.CODFIL_VEN AND DECF.NUMECF = VIXI.NUMECF',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'VIXI',
       '01',
       90,
       6,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Nmero Nota Fiscal',
       'Nmero Nota Fiscal',
       '',
       'NUMNOT',
       '' FROM DUAL
UNION ALL
SELECT 'VIXI',
       '01',
       50,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       '',
       'Nmero Pedido',
       'Nmero Pedido',
       '',
       'NUMPED',
       '' FROM DUAL
UNION ALL
SELECT 'VIXI',
       '01',
       190,
       10,
       'QTDENC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Quantidade Encomenda',
       'Quantidade Encomenda',
       '',
       'QTDENC',
       '' FROM DUAL
UNION ALL
SELECT 'VIXI',
       '01',
       60,
       1,
       'TIPENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo Entrega',
       'Tipo Entrega',
       '',
       'TIPENT',
       'T' FROM DUAL
);

/*-- SEQ 10029 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VIXI',
       'FLGEST',
       0,
       'A',
       'A encomendar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIXI',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIXI',
       'FLGEST',
       0,
       'E',
       'Encomendado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIXI',
       'FLGEST',
       0,
       'R',
       'Recebido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIXI',
       'TIPENT',
       0,
       '0',
       'Cliente Leva',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIXI',
       'TIPENT',
       0,
       '3',
       'Retira no Depsito',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIXI',
       'TIPENT',
       0,
       '4',
       'Em Outra Loja',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIXI',
       'TIPENT',
       0,
       '5',
       'Entrega Futura',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIXI',
       'TIPENT',
       0,
       '6',
       'Apenas Oramento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VIXI',
       'TIPENT',
       0,
       '7',
       'Venda sob Encomenda',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10030 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VJUR',
       TO_NUMBER(null),
       'VJUR',
       'Juros',
       'TV_CLI_JUR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10031 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VJUR','--','' FROM DUAL
UNION ALL
SELECT 'VJUR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VJUR','99','Outros' FROM DUAL
);

/*-- SEQ 10032 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VJUR',
       '--',
       160,
       5,
       'CODCTR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       'Cdigo Unidade de Negcios',
       '',
       'CODCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'VJUR',
       '--',
       10,
       6,
       'CODIGO_CLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo cliente',
       'Cdigo cliente',
       '',
       'CODIGO_CLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VJUR',
       '--',
       20,
       15,
       'CPF_CNPJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento (CPF/CNPJ)',
       'Nmero do Documento: CNPJ ou CPF',
       '',
       'CPF_CNPJ',
       'F' FROM DUAL
UNION ALL
SELECT 'VJUR',
       '--',
       170,
       30,
       'DESCTR',
       'A',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       '',
       'A',
       '',
       'Unidade de Negcios',
       'Unidade de Negcios',
       'DCTR.CODTAB = VJUR.CODCTR',
       'DESCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'VJUR',
       '--',
       30,
       13,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento (Srie + Ecf + Nmero da Nota )',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VJUR',
       '--',
       40,
       3,
       'FILIAL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = VJUR.FILIAL',
       'FILIAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VJUR',
       '--',
       50,
       3,
       'FILIAL_CLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Cliente',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILIAL_CLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VJUR',
       '--',
       60,
       95,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome/Razo Social',
       'Nome do Cliente',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VJUR',
       '--',
       70,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero Parcela',
       'Nmero da Parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VJUR',
       '--',
       80,
       7,
       'PAGAMENTO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'PAGAMENTO',
       'F' FROM DUAL
UNION ALL
SELECT 'VJUR',
       '--',
       90,
       5,
       'PARCELA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Parcela',
       'Parcela (Nmero da Parcela + Sub-parcela)',
       '',
       'PARCELA',
       'F' FROM DUAL
UNION ALL
SELECT 'VJUR',
       '--',
       100,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VJUR',
       '--',
       110,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Nmero da sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VJUR',
       '--',
       120,
       7,
       'VENCIMENTO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Vencimento',
       'Data de vencimento',
       '',
       'VENCIMENTO',
       'F' FROM DUAL
UNION ALL
SELECT 'VJUR',
       '--',
       130,
       14,
       'VLR_JUROS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Valor Juros',
       'Valor do Juros',
       '',
       'VLR_JUROS',
       'F' FROM DUAL
UNION ALL
SELECT 'VJUR',
       '--',
       140,
       12,
       'VLR_PARCELA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Vlr. Parcela',
       'Valor da parcela',
       '',
       'VLR_PARCELA',
       'F' FROM DUAL
UNION ALL
SELECT 'VJUR',
       '--',
       150,
       12,
       'VLR_RECEBIDO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Valor recebido',
       'Valor recebido (Valor da Parcela + Valor do Juros)',
       '',
       'VLR_RECEBIDO',
       'F' FROM DUAL
);

/*-- SEQ 10033 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VLC ',
       TO_NUMBER(null),
       'VLC ',
       'Lim. x Cli.',
       'TV_LIM_CLI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VLC.FILCLI,VLC.CODCLI',
       '' FROM DUAL
);

/*-- SEQ 10034 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VLC ','--','' FROM DUAL
UNION ALL
SELECT 'VLC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VLC ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VLC ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VLC ','99','Outros' FROM DUAL
);

/*-- SEQ 10035 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VLC ',
       '03',
       10,
       3,
       'CARENC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Carncia',
       'Carncia',
       '',
       'CARENC',
       'F' FROM DUAL
UNION ALL
SELECT 'VLC ',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VLC ',
       '01',
       30,
       30,
       'DESCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Conta C.',
       'Descrio Conta Corrente',
       '',
       'DESCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'VLC ',
       '03',
       40,
       6,
       'DESCON',
       'F',
       '',
       3,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Descontos',
       'Descontos',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VLC ',
       '01',
       50,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VLC ',
       '03',
       60,
       12,
       'LIMCCC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Limite Conta C.',
       'Limite Conta Corrente',
       '',
       'LIMCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'VLC ',
       '01',
       70,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VLC ',
       '99',
       80,
       256,
       'OBSERV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VLC ',
       '01',
       90,
       10,
       'PLANO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Plano',
       'Plano',
       '',
       'PLANO',
       'F' FROM DUAL
UNION ALL
SELECT 'VLC ',
       '01',
       100,
       30,
       'PORTAD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Portador',
       'Portador',
       '',
       'PORTAD',
       'F' FROM DUAL
UNION ALL
SELECT 'VLC ',
       '02',
       110,
       7,
       'PROFAT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fat. Pro.',
       'Data da Fatura dos Produtos',
       '',
       'PROFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLC ',
       '03',
       120,
       12,
       'VSALDO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Valor do Saldo',
       'Valor do Saldo',
       '',
       'VSALDO',
       'F' FROM DUAL
);

/*-- SEQ 10036 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VLCO',
       TO_NUMBER(null),
       'VLCO',
       'LMC com as compras',
       'TV_LMC_COM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10037 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VLCO','--','' FROM DUAL
UNION ALL
SELECT 'VLCO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VLCO','99','Outros' FROM DUAL
);

/*-- SEQ 10038 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VLCO',
       '--',
       10,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Diviso do produto',
       'DIV.CODITE = VLCO.CODCOR(+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'VLCO',
       '--',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = VLCO.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'VLCO',
       '--',
       30,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo~Fornecedor',
       'Cdigo do fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VLCO',
       '--',
       40,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo~Material',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLCO',
       '--',
       50,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'SUB.CODITE = VLCO.CODTAM(+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'VLCO',
       '--',
       60,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data Lanto',
       'Data da operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VLCO',
       '--',
       70,
       19,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VLCO',
       '--',
       80,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial do Fornecedor',
       'Filial do fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VLCO',
       '--',
       90,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial Material',
       'Filial do material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLCO',
       '--',
       100,
       5,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero Itens',
       'Nmero Itens',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VLCO',
       '--',
       110,
       8,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Nota',
       'Nmero Nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLCO',
       '--',
       120,
       9,
       'QTDLTS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Qtde Litros',
       'Qtde Litros',
       '',
       'QTDLTS',
       'F' FROM DUAL
UNION ALL
SELECT 'VLCO',
       '--',
       130,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VLCO',
       '--',
       140,
       2,
       'TANQUE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero do tanque',
       'Nmero do tanque',
       '',
       'TANQUE',
       'F' FROM DUAL
);

/*-- SEQ 10039 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VLIQ',
       TO_NUMBER(null),
       'VLIQ',
       'Venda Total Liquida',
       'TV_TOTVENLIQ',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10040 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VLIQ','--','' FROM DUAL
UNION ALL
SELECT 'VLIQ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VLIQ','02','Valores' FROM DUAL
UNION ALL
SELECT 'VLIQ','03','Quantidades' FROM DUAL
UNION ALL
SELECT 'VLIQ','99','Outros' FROM DUAL
);

/*-- SEQ 10041 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 24344,
       'USU ',
       'VLIQ',
       '1',
       'N',
       '',
       '',
       'USU.FILUSU = VLIQ.FILVDD AND
USU.CODUSU = VLIQ.CODVDD',
       '',
       '' FROM DUAL
);

/*-- SEQ 10042 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VLIQ',
       '--',
       10,
       12,
       'ACRESC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Acrscimo',
       'Acrscimo',
       '',
       'ACRESC',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '--',
       250,
       5,
       'CLASS1',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Setor',
       'Setor',
       '',
       'CLASS1',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Filial',
       'Cdigo Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '01',
       230,
       3,
       'CODVDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo Vendedor',
       'Cdigo Vendedor',
       '',
       'CODVDD',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '02',
       60,
       12,
       'CUSMED',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Custo Mdio',
       'Custo Mdio',
       '',
       'CUSMED',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '--',
       260,
       5,
       'DEPART',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Departamento',
       'Departamento',
       '',
       'DEPART',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '02',
       70,
       12,
       'DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Desconto',
       'Desconto',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '--',
       270,
       15,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '01',
       240,
       3,
       'FILVDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Vendedor',
       'Filial Vendedor',
       '',
       'FILVDD',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '02',
       90,
       12,
       'ICMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'ICMS Item',
       'ICMS Item',
       '',
       'ICMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '01',
       222,
       5,
       'NOMCL1',
       'S',
       'DCL1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL1.CLASS1',
       'V',
       '',
       '',
       'A',
       '',
       'Nome Setor',
       'Nome Setor',
       'DCL1.CODTAB = VLIQ.CLASS1',
       'NOMCL1',
       '' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '01',
       221,
       5,
       'NOMDEP',
       'S',
       'DDEP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDEP.DESDEP',
       'V',
       '',
       '',
       'A',
       '',
       'Nome Departamento',
       'Nome Departamento',
       'DDEP.CODTAB = VLIQ.DEPART',
       'NOMDEP',
       '' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '01',
       31,
       3,
       'NOMFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Nome da Filial',
       'Nome da Filial',
       'DFIL.CODFIL = VLIQ.CODFIL',
       'NOMFIL',
       '' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '02',
       100,
       12,
       'PERIR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'IR Item',
       'IR Item',
       '',
       'PERIR',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '02',
       110,
       12,
       'PEROPE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Desp. Ope',
       'Valor Despesa Operacional',
       '',
       'PEROPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '02',
       120,
       12,
       'PERSOC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor ContSocial',
       'Valor Contribuio Social',
       '',
       'PERSOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '--',
       280,
       12,
       'QTDITEMED',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Qtd. Item Mdio',
       'Quantidade Item Mdio',
       '',
       'QTDITEMED',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '03',
       130,
       12,
       'QTDMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtd. Vendida',
       'Quantidade Vendida',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '--',
       290,
       12,
       'QTDPARMED',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Qtd. Parcela Mdia',
       'Quantidade Parcela Mdia',
       '',
       'QTDPARMED',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '03',
       140,
       12,
       'QTDVEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtd. Vendas',
       'Quantidade Vendas',
       '',
       'QTDVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '02',
       150,
       12,
       'VENCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor COFINS',
       'Valor COFINS',
       '',
       'VENCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '02',
       160,
       12,
       'VENPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor PIS',
       'Valor PIS',
       '',
       'VENPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '01',
       170,
       7,
       'VEN_DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Venda',
       'Data Venda',
       '',
       'VEN_DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '02',
       180,
       12,
       'VLRCONT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Contribuio',
       'Valor Contribuio',
       '',
       'VLRCONT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '02',
       190,
       12,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Frete',
       'Valor Frete',
       '',
       'VLRFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '02',
       200,
       12,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Item',
       'Valor Item',
       '',
       'VLRMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '02',
       210,
       12,
       'VLRMOVORI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Item Original',
       'Valor Item Original',
       '',
       'VLRMOVORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIQ',
       '02',
       220,
       12,
       'VLRUNI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Item Unitrio',
       'Valor Item Unitrio',
       '',
       'VLRUNI',
       'F' FROM DUAL
);

/*-- SEQ 10043 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VLIT',
       TO_NUMBER(null),
       'VLIT',
       'Litros Vendidos',
       'TV_LIT',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VLIT.FILCLI,VLIT.CODCLI',
       '' FROM DUAL
);

/*-- SEQ 10044 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VLIT','--','' FROM DUAL
UNION ALL
SELECT 'VLIT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VLIT','99','Outros' FROM DUAL
);

/*-- SEQ 10045 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VLIT',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIT',
       '01',
       20,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data e Hora',
       'Data e Hora',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIT',
       '01',
       30,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIT',
       '01',
       40,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Documento (CPF/CGC)',
       'Nmero do Documento: CGC ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VLIT',
       '01',
       50,
       12,
       'QTDLIT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade Lit.',
       'Quantidade Lit.',
       '',
       'QTDLIT',
       'F' FROM DUAL
);

/*-- SEQ 10046 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VLOG',
       TO_NUMBER(null),
       'VLOG',
       'Usurio Logado',
       'TV_LOG',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10047 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VLOG','--','' FROM DUAL
UNION ALL
SELECT 'VLOG','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VLOG','99','Outros' FROM DUAL
);

/*-- SEQ 10048 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 11139,
       'CMS ',
       'VLOG',
       'N ',
       '1 ',
       '',
       '',
       'CMS.FILVEN = VLOG.FILUSU AND CMS.CODVEN = VLOG.CODUSU',
       '',
       '' FROM DUAL
UNION ALL
SELECT 11207,
       'VEN ',
       'VLOG',
       'N ',
       '1 ',
       '',
       '',
       'VLOG.FILUSU = VEN.FILVEN AND VLOG.CODUSU = VEN.CODVEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 10049 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VLOG',
       '--',
       1,
       10,
       'APEUSU',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'F',
       'A',
       '',
       'Apelido Usurio',
       'Apelido do Usurio',
       '',
       'APEUSU',
       '' FROM DUAL
);

/*-- SEQ 10050 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'LSD ',
       TO_NUMBER(null),
       'LSD ',
       'Saldo Lista Presente',
       'TV_LIS_SAL',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10051 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'LSD ','--','' FROM DUAL
UNION ALL
SELECT 'LSD ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'LSD ','99','Outros' FROM DUAL
);

/*-- SEQ 10052 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'LSD ',
       '01',
       40,
       5,
       'CODCOR',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Diviso',
       'Diviso',
       '',
       'CODCOR',
       '' FROM DUAL
UNION ALL
SELECT 'LSD ',
       '99',
       130,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       '',
       'Cdigo Externo',
       'Cdigo Externo da Lista',
       '',
       'CODEXT',
       '' FROM DUAL
UNION ALL
SELECT 'LSD ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'V',
       '',
       '',
       'A',
       '',
       'Filial~Lista',
       'Filial da Lista',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'LSD ',
       '01',
       30,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo~Produto',
       'Cdigo do Produto',
       '',
       'CODMAT',
       '' FROM DUAL
UNION ALL
SELECT 'LSD ',
       '01',
       50,
       5,
       'CODTAM',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Subdiviso',
       'Subdiviso',
       '',
       'CODTAM',
       '' FROM DUAL
UNION ALL
SELECT 'LSD ',
       '01',
       15,
       3,
       'FILMAT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial~Produto',
       'Filial do Produto',
       'DFIL.CODFIL = LSD.FILMAT',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'LSD ',
       '99',
       70,
       12,
       'QTDITE',
       'F',
       '',
       3,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Qtde Lista',
       'Qtde Lista',
       '',
       'QTDITE',
       '' FROM DUAL
UNION ALL
SELECT 'LSD ',
       '99',
       90,
       12,
       'QTDITE_IOR',
       'F',
       '',
       3,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Qtde em Oramento',
       'Qtde em Oramento',
       '',
       'QTDITE_IOR',
       '' FROM DUAL
UNION ALL
SELECT 'LSD ',
       '99',
       110,
       12,
       'QTDMOV_DEVOLVIDA',
       'F',
       '',
       3,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Qtde Devolvida ',
       'Qtde Devolvida ',
       '',
       'QTDMOV_DEVOLVIDA',
       '' FROM DUAL
UNION ALL
SELECT 'LSD ',
       '99',
       100,
       12,
       'QTDMOV_VENDIDA',
       'F',
       '',
       3,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Qtde Vendida',
       'Qtde Vendida',
       '',
       'QTDMOV_VENDIDA',
       '' FROM DUAL
UNION ALL
SELECT 'LSD ',
       '99',
       80,
       12,
       'QTDRES',
       'F',
       '',
       3,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Qtde Reservada',
       'Qtde Reservada',
       '',
       'QTDRES',
       '' FROM DUAL
UNION ALL
SELECT 'LSD ',
       '99',
       120,
       12,
       'SALDO',
       'F',
       '',
       3,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Saldo Final',
       'Saldo Final',
       '',
       'SALDO',
       '' FROM DUAL
UNION ALL
SELECT 'LSD ',
       '--',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'LSD ',
       '99',
       140,
       1,
       'SITMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Situao',
       'Situao da Lista',
       '',
       'SITMOV',
       'T' FROM DUAL
);

/*-- SEQ 10053 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'LSD ',
       'SITMOV',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'LSD ',
       'SITMOV',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10054 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VLUC',
       TO_NUMBER(null),
       'VLUC',
       'Lucratividade',
       'TV_LUC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'VLUC.SEQUEN,VLUC.CODFIL,VLUC.NUMITE
VEN.ID,VLUC.NUMITE
VLUC.NUMEXT',
       '' FROM DUAL
);

/*-- SEQ 10055 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VLUC','--','' FROM DUAL
UNION ALL
SELECT 'VLUC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VLUC','02','Valores' FROM DUAL
UNION ALL
SELECT 'VLUC','03','Dados de Transporte' FROM DUAL
UNION ALL
SELECT 'VLUC','04','Resultados' FROM DUAL
UNION ALL
SELECT 'VLUC','05','Custos' FROM DUAL
UNION ALL
SELECT 'VLUC','06','Datas' FROM DUAL
UNION ALL
SELECT 'VLUC','30','Impostos' FROM DUAL
UNION ALL
SELECT 'VLUC','31','Produto' FROM DUAL
UNION ALL
SELECT 'VLUC','32','Lucratividade Total' FROM DUAL
UNION ALL
SELECT 'VLUC','99','Outros' FROM DUAL
);

/*-- SEQ 10056 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 45929,
       'RECP',
       'VLUC',
       'N',
       '1',
       '',
       '',
       'RECP.ORI_CODFIL = VLUC.CODFIL AND
RECP.ORI_SEQUEN = VLUC.SEQUEN
',
       '(case when VLUC.VLRLIQ = 0 then 0 else RECP.VLRPAR / VLUC.VLRLIQ end)',
       '' FROM DUAL
UNION ALL
SELECT 45812,
       'CLI ',
       'VLUC',
       '1',
       'N',
       '',
       '',
       'CLI.FILCLI = VLUC.FILCLI and
CLI.CODCLI = VLUC.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 27946,
       'DFIL',
       'VLUC',
       '1',
       'N',
       '',
       '',
       'DFIL.CODFIL = VLUC.CODFIL',
       '',
       '' FROM DUAL
UNION ALL
SELECT 27947,
       'ECOB',
       'VLUC',
       '01',
       'N',
       '',
       '',
       'ECOB.FILCLI(+) = VLUC.FILCLI AND
ECOB.CODCLI(+) = VLUC.CODCLI AND
ECOB.CODFIL(+) = VLUC.FILCOB AND
ECOB.NUMEND(+) = VLUC.ENDCOB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 27948,
       'EDE ',
       'VLUC',
       '01',
       'N',
       '',
       '',
       'EDE.FILCLI(+) = VLUC.FILCLI AND
EDE.CODCLI(+) = VLUC.CODCLI AND
EDE.CODFIL(+) = VLUC.CODFIL ',
       '',
       '' FROM DUAL
UNION ALL
SELECT 27949,
       'EENT',
       'VLUC',
       '01',
       'N',
       '',
       '',
       'EENT.FILCLI(+) = VLUC.FILCLI AND
EENT.CODCLI(+) = VLUC.CODCLI AND
EENT.CODFIL(+) = VLUC.FILENT AND
EENT.NUMEND(+) = VLUC.ENDENT
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 27950,
       'EFAT',
       'VLUC',
       '01',
       'N',
       '',
       '',
       'EFAT.FILCLI(+) = VLUC.FILCLI AND
EFAT.CODCLI(+) = VLUC.CODCLI AND
EFAT.CODFIL(+) = VLUC.FILFAT AND
EFAT.NUMEND(+) = VLUC.ENDFAT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 27951,
       'FAT ',
       'VLUC',
       '1',
       'N',
       '',
       '',
       'FAT.CODFIL = VLUC.CODFIL and
FAT.SEQUEN = VLUC.SEQFAT',
       '(case when FAT.VLRNOT = 0 then 0 else VLUC.VLRLIQ / FAT.VLRNOT end)',
       '' FROM DUAL
UNION ALL
SELECT 27952,
       'GRA ',
       'VLUC',
       '1',
       'N',
       '',
       '',
       'GRA.FILMAT = VLUC.FILMAT and
GRA.CODMAT = VLUC.CODMAT and
GRA.CODCOR = VLUC.CODCOR and
GRA.CODTAM = VLUC.CODTAM
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 27953,
       'IND ',
       'VLUC',
       '01',
       'N',
       '',
       '',
       'VLUC.FILGUI = IND.FILCLI(+) AND
VLUC.CODGUI = IND.CODCLI(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 27954,
       'PLA ',
       'VLUC',
       '1',
       'N',
       '',
       '',
       'VLUC.FILPGT = PLA.FILPGT AND
VLUC.CODPGT = PLA.CODPGT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 27955,
       'TRA ',
       'VLUC',
       '1',
       'N',
       '',
       '',
       'TRA.FILCLI = VLUC.FILTRA and
TRA.CODCLI = VLUC.CODTRA',
       '',
       '' FROM DUAL
UNION ALL
SELECT 27956,
       'VDD ',
       'VLUC',
       '1',
       'N',
       '',
       '',
       'VDD.FILUSU = VLUC.FILVEN and
VDD.CODUSU = VLUC.CODVEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 27957,
       'VEN ',
       'VLUC',
       '1',
       'N',
       '',
       '',
       'VLUC.CODFIL = VEN.CODFIL AND
VLUC.SEQUEN = VEN.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 27958,
       'VIN ',
       'VLUC',
       '1',
       'N',
       '',
       '',
       'VLUC.CODFIL = VIN.CODFIL AND
VLUC.SEQUEN = VIN.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 27959,
       'IOR ',
       'VLUC',
       '01',
       '1',
       '',
       '',
       'IOR.FILIVE(+) = VLUC.CODFIL and
IOR.SEQIVE(+) = VLUC.SEQUEN and
IOR.NUMIVE(+) = VLUC.NUMITE
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 27960,
       'IVI ',
       'VLUC',
       '01',
       '1',
       '',
       '',
       'VLUC.CODFIL = IVI.CODFIL(+) AND
VLUC.SEQUEN = IVI.NUMORI(+) AND
VLUC.NUMITE = IVI.ITEORI(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 27961,
       'REC ',
       'VLUC',
       'N',
       '1',
       '',
       '',
       'REC.CODFIL = VLUC.CODFIL AND
REC.SEQUEN = VLUC.SEQUEN
',
       '(case when VLUC.VLRLIQ = 0 then 0 else REC.VLRPAR / VLUC.VLRLIQ end)',
       '' FROM DUAL
);

/*-- SEQ 10057 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VLUC',
       '99',
       1350,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'VEN ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(VLUC.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       650,
       4,
       'ANO_DATHOR',
       'A',
       '',
       0,
       0,
       'VEN ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       '',
       'N',
       'T',
       'Ano~Incluso',
       'Ano de Data e hora da operao',
       '',
       'TO_CHAR(VLUC.DATHOR,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       30,
       4,
       'ANO_DATSAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'T',
       'Ano de Data Sada',
       'Ano de Data Sada',
       '',
       'TO_CHAR(VLUC.DATSAI,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       1380,
       4,
       'ANO_PROPGT',
       'A',
       '',
       0,
       0,
       'VEN ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       '',
       'N',
       'T',
       'Ano de Prox. Pagamen',
       'Ano de Data prximo pagamento ou data do cancelamento',
       '',
       'TO_CHAR(VLUC.PROPGT,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       1301,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN VLUC.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       1330,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'VEN ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '30',
       1040,
       1,
       'AUTENT',
       'L',
       '',
       0,
       0,
       'VEN ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'VEN',
       'F',
       '',
       'T',
       'Autenticada?',
       'Indica se a nota j foi autenticada',
       '',
       'AUTENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       90,
       12,
       'BASUBS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base Sub. Tributria',
       'Base da Substituio Tributria',
       '',
       'BASUBS',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       1661,
       5,
       'CNT_RO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'N',
       'F',
       'Contador RO',
       'Contador de Reincio de Operao',
       '',
       'CNT_RO',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       620,
       6,
       'CODCLI',
       'A',
       '',
       0,
       0,
       'VEN ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '31',
       1160,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       'IVE ',
       30,
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Diviso',
       'Codigo da cor (diviso)',
       'VLUC.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       180,
       5,
       'CODCTR',
       'F',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       'F',
       '9',
       'F',
       'Unidade de Negcios',
       'Unidade de Negcios',
       'VLUC.CODCTR = DCTR.CODTAB(+)',
       'CODCTR',
       'T' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       170,
       15,
       'CODEXT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       570,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       0,
       'VEN ',
       10,
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       'VEN',
       'F',
       'A',
       'T',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = VLUC.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       100,
       5,
       'CODFIN',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Cod. da Financeira',
       'Cod. da Financeira',
       '',
       'CODFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       1280,
       3,
       'CODGUI',
       'A',
       '',
       0,
       0,
       'VEN ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       'Cdigo do Guia',
       'Cdigo do Guia',
       '',
       'CODGUI',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '31',
       1150,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IVE ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Codigo do produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       440,
       5,
       'CODMUL',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       'F',
       'Sub-Estoque',
       'Nome do Sub-Estoque',
       'DMUL.CODTAB = VLUC.CODMUL',
       'CODMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '30',
       1020,
       2,
       'CODNAT',
       'S',
       'DNAT',
       0,
       0,
       'VEN ',
       10,
       TO_NUMBER(null),
       '',
       'DNAT.NATURE',
       'V',
       'VEN',
       'F',
       'A',
       'T',
       'Natureza',
       'Natureza de operao',
       'VLUC.CODNAT = DNAT.CODTAB (+)',
       'CODNAT',
       'T' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       1250,
       3,
       'CODPGT',
       'A',
       'PLA ',
       0,
       0,
       'VEN ',
       60,
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       'VEN',
       'F',
       'A',
       'T',
       'Plano',
       'Cdigo do plano de pagamento',
       'VLUC.FILPGT = PLA.FILPGT and VLUC.CODPGT = PLA.CODPGT',
       'CODPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       1320,
       2,
       'CODPRE',
       'S',
       'TPR ',
       0,
       0,
       'VEN ',
       120,
       TO_NUMBER(null),
       '',
       'TPR.DESPRE',
       'V',
       'VEN',
       'F',
       'A',
       'T',
       'Tab. de Preos',
       'Cdigo da tabela de preos',
       'VLUC.FILPRE=TPR.CODFIL (+) and VLUC.CODPRE=TPR.CODPRE (+)',
       'CODPRE',
       'T' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       590,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       0,
       'VEN ',
       30,
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       'VEN',
       'F',
       'A',
       'T',
       'Srie',
       'Cdigo da srie',
       'VLUC.CODSER=DSER.CODSER (+)',
       'CODSER',
       'T' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '31',
       1170,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       'IVE ',
       40,
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Sub-Diviso',
       'Cdigo do tamanho (sub-diviso)',
       'VLUC.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '03',
       850,
       6,
       'CODTRA',
       'A',
       '',
       0,
       0,
       'VEN ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '9',
       'F',
       'Transportadora',
       'Cdigo da Transportadora',
       '',
       'CODTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       1210,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       0,
       'VEN ',
       20,
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       'VEN',
       'F',
       'A',
       'T',
       'Usurio',
       'Cdigo do usurio',
       'VLUC.FILUSU = USU.FILUSU(+)  and VLUC.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       1230,
       3,
       'CODVEN',
       'A',
       'VDD ',
       0,
       0,
       'VEN ',
       40,
       TO_NUMBER(null),
       '',
       'VDD.APEUSU',
       'V',
       'VEN',
       'F',
       'N',
       'T',
       'Vendedor',
       'Cdigo do vendedor',
       'VLUC.FILVEN = VDD.FILUSU (+)  and VLUC.CODVEN = VDD.CODUSU (+)',
       'CODVEN',
       'T' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       340,
       12,
       'COMENT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Comiss. Vlr Entrada',
       'Comisso sobre o valor de entrada',
       '',
       'COMENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       1510,
       9,
       'COMISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Comisso',
       'Comisso',
       '',
       'COMISS',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '05',
       970,
       12,
       'COMISSOES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Comisso venda',
       'Comissao total paga pela venda do produto',
       '',
       'COMISSOES',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       780,
       2,
       'COMSOB',
       'S',
       '',
       0,
       0,
       'VEN ',
       70,
       30,
       '',
       '',
       'D',
       'VEN',
       'F',
       'A',
       'T',
       'Comisso Sobre',
       'Comisso sobre (ver tela plano)',
       '',
       'COMSOB',
       'T' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       80,
       1,
       'CONSFI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'F',
       'Consumidor Final?',
       'Consumidor Final?',
       '',
       'CONSFI',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       450,
       16,
       'CUSFRE',
       'F',
       '',
       6,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Custo Frete',
       'Custo do Frete',
       '',
       'CUSFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       1540,
       12,
       'CUSFRE_ATU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Custo Frete Atu.',
       'Custo Frete Atu.',
       '',
       'CUSFRE_ATU',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       470,
       14,
       'CUSREP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Custo Rep.',
       'Custo de reposio',
       '',
       'CUSREP',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       1550,
       12,
       'CUSREP_ATU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Custo Rep. Atu.',
       'Custo Rep. Atu.',
       '',
       'CUSREP_ATU',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '05',
       253,
       12,
       'CUSTOMEDIO_TOT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'C.Financ. Fiscal Tot',
       'Custo Financeiro Fiscal Total (Custo Mdio Fiscal x Qtde Fiscal)',
       '',
       'CUSTOMEDIO_TOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '05',
       273,
       12,
       'CUSTOMEDIO_UNI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Custo Mdio Fiscal',
       'Custo Mdio Fiscal Unitrio',
       '',
       'CUSTOMEDIO_UNI',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       1410,
       12,
       'CUSTOS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Custo Rep.+Frete',
       'Custo Reposio + Custo Frete',
       '',
       '((VLUC.CUSREP+VLUC.CUSFRE)*VLUC.QTDMOV)',
       '' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '05',
       980,
       12,
       'CUSTO_AQUISICAO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Custo aquisio',
       'Custo final de aquisiao do produto ',
       '',
       'CUSTO_AQUISICAO',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       1560,
       12,
       'CUSTO_AQUISICAO_ATU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Custo Aquisio Atu.',
       'Custo Aquisio Atu.',
       '',
       'CUSTO_AQUISICAO_ATU',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '05',
       981,
       12,
       'CUSTO_AQUISICAO_TOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Custo Aqusio Tot.',
       'Custo de Aquisio Total',
       '',
       'CUSTO_AQUISICAO_TOT',
       '' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '05',
       403,
       12,
       'CUSTO_FGT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'C.Financ. Geren. Tot',
       'Custo Financeiro Gerencial Total (Custo Mdio Gerencial x Qtde Fiscal)',
       '',
       'CUSTO_FGT',
       '' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '05',
       404,
       12,
       'CUSTO_FGT_UNI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Custo Mdio Gerenc.',
       'Custo Mdio Gerencial Unitrio',
       '',
       'CUSTO_FGT_UNI',
       '' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '05',
       990,
       12,
       'CUSTO_FINANCEIRO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Custo financeiro',
       'Custo financeiro da venda',
       '',
       'CUSTO_FINANCEIRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       630,
       8,
       'DATHOR',
       '@',
       '',
       0,
       0,
       'VEN ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '@',
       'T',
       'Data~Incluso',
       'Data e hora da operao',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       10,
       8,
       'DATSAI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'T',
       'Data Sada',
       'Data Sada',
       '',
       'DATSAI',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       800,
       8,
       'DESCON',
       'F',
       '',
       2,
       0,
       'VEN ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       '9',
       'T',
       'Desconto / Acrscimo',
       'Desconto / Acrscimo',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       1420,
       12,
       'DESC_ACRES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Desc/Acrs',
       'Desconto/Acrscimo',
       '',
       'CASE WHEN VLUC.VLRNOT=0 THEN 0 ELSE VLUC.VLRMOV*((VLUC.VLRLIQ/VLUC.VLRNOT)-1) END',
       '' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '05',
       1600,
       12,
       'DESP_OPERACIONAIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Desp. Operacionais',
       'Despesas Operacionais',
       '',
       'DESP_OPERACIONAIS',
       '' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       1671,
       55,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento da Venda',
       'Documento da Venda',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       330,
       5,
       'EMBORI',
       'G',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       '9',
       'F',
       'Embalagem Original',
       'Embalagem Original',
       'VLUC.EMBORI=SUB.CODITE(+)',
       'EMBORI',
       'T' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       320,
       12,
       'EMBQTD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Quantidade Original',
       'Quantidade Original',
       '',
       'EMBQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '03',
       930,
       1,
       'EMIDES',
       'L',
       '',
       0,
       0,
       'VEN ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'VEN',
       'F',
       '',
       'T',
       'Frete Dest./Terc.?',
       'Frete  por conta do Destinatrio ou de Terceiros?',
       '',
       'EMIDES',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       50,
       2,
       'ENDCOB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       '',
       'Nmero do endereo de cobrana',
       '',
       'ENDCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       70,
       2,
       'ENDENT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       '',
       'Nmero do endereo de entrega',
       '',
       'ENDENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       110,
       2,
       'ENDFAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       '',
       'Nmero de endereo de fatura',
       '',
       'ENDFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '03',
       940,
       2,
       'ESPECI',
       'S',
       'DESP',
       0,
       0,
       'VEN ',
       110,
       TO_NUMBER(null),
       '',
       'DESP.ESPECI',
       'V',
       'VEN',
       'F',
       'A',
       'F',
       'Espcie do Volume',
       'Espcie do volume',
       'VLUC.ESPECI = DESP.CODTAB (+)',
       'ESPECI',
       'T' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       610,
       3,
       'FILCLI',
       'A',
       '',
       0,
       0,
       'VEN ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       130,
       3,
       'FILCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do endereo de cobrana',
       '',
       'FILCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       140,
       3,
       'FILENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do endereo de entrega',
       '',
       'FILENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       190,
       3,
       'FILFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do endereo de fatura',
       '',
       'FILFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       1270,
       3,
       'FILGUI',
       'A',
       '',
       0,
       0,
       'VEN ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       '',
       'Filial do guia',
       '',
       'FILGUI',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '31',
       1140,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IVE ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial de incluso do produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '31',
       1610,
       3,
       'FILORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial de Origem',
       '',
       'FILORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       1240,
       3,
       'FILPGT',
       'A',
       '',
       0,
       0,
       'VEN ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       '',
       'Filial do plano de pagamento',
       '',
       'FILPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       1310,
       3,
       'FILPRE',
       'A',
       '',
       0,
       0,
       'VEN ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       '',
       'Filial da tabela de preo',
       '',
       'FILPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '03',
       840,
       3,
       'FILTRA',
       'A',
       '',
       0,
       0,
       'VEN ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       '',
       'Filial da Transportadora',
       '',
       'FILTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       1200,
       3,
       'FILUSU',
       'A',
       '',
       0,
       0,
       'VEN ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       1220,
       3,
       'FILVEN',
       'A',
       '',
       0,
       0,
       'VEN ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'F',
       '',
       'Filial do vendedor',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       760,
       1,
       'FINANC',
       'L',
       '',
       0,
       0,
       'VEN ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'VEN',
       'F',
       '',
       'F',
       'Gera Dados Financ.?',
       'Gera dados financeiros',
       '',
       'FINANC',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       660,
       1,
       'FLGEST',
       'A',
       '',
       0,
       0,
       'VEN ',
       90,
       30,
       '',
       '',
       'D',
       'VEN',
       'F',
       'A',
       'T',
       'Situao',
       'Estado (Cancelado/Quitado/Em aberto)',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       40,
       1,
       'FLGTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Pessoa ',
       'Tipo de Pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '31',
       1681,
       12,
       'GRA_CUSFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Custo do Frete Grade',
       'Custo do Frete da Grade',
       '',
       'GRA_CUSFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '31',
       1691,
       12,
       'GRA_CUSREP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Custo de Rep. Grade',
       'Custo de Reposio da Grade',
       '',
       'GRA_CUSREP',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '31',
       1620,
       14,
       'GRA_PRECOM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Preo Compra Grade',
       'Preo de Compra da Grade',
       '',
       'GRA_PRECOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '30',
       1060,
       12,
       'ICMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'ICMS',
       'ICMS',
       '',
       'ICMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       380,
       1,
       'ICMTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       '9',
       'F',
       'Tipo tributao',
       'Tipo de tributao do produto',
       '',
       'ICMTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '05',
       1000,
       12,
       'ICM_RETIDO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'ICMS retido',
       'ICMS RETIDO NA FONTE Proporcional',
       '',
       'ICM_RETIDO',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '05',
       1010,
       12,
       'IMPOSTOS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Imp. s/Vendas',
       'Soma os Impostos da venda',
       '',
       'IMPOSTOS',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '30',
       1130,
       12,
       'IMPSOBREVENDA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Imp. Fed.',
       'Impostos Federais',
       '',
       'IMPSOBREVENDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '30',
       1070,
       12,
       'IPIITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'IPI',
       'IPI',
       '',
       'IPIITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '30',
       1080,
       12,
       'ISSITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'ISS',
       'ISS',
       '',
       'ISSITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       710,
       2,
       'ITEORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'IVE ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Item de Origem',
       'Item de Origem',
       '',
       'ITEORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '31',
       1410,
       1,
       'LANEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       ' ',
       'A',
       'F',
       'Lanamento Estoque',
       'Lanamento no Estoque',
       '',
       'LANEST',
       'T' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       150,
       1,
       'LANVEN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       ' Venda?',
       'Considera Venda?',
       '',
       'LANVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '04',
       950,
       12,
       'LUCRO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Lucro',
       'Lucro',
       '',
       'LUCRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       1570,
       12,
       'LUCRO_CUSTO_ATU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Lucro Custo Atu.',
       'Lucro Custo Atu.',
       '',
       'LUCRO_CUSTO_ATU',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '31',
       1190,
       12,
       'LUCRO_UNI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Lucro Unitrio',
       'Lucro Unitrio',
       '',
       'LUCRO_UNI',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       1580,
       12,
       'LUCRO_UNI_CUSTO_ATU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Lucro Uni.Custo Atu.',
       'Lucro Uni.Custo Atu.',
       '',
       'LUCRO_UNI_CUSTO_ATU',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '03',
       880,
       5,
       'MARCAS',
       'A',
       '',
       0,
       0,
       'VEN ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '9',
       'T',
       'Marcas',
       'Marcas',
       '',
       'MARCAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       1430,
       12,
       'MARGEM_CR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Margem CR R$',
       'Margem CR R$',
       '',
       'CASE VLUC.VLRNOT WHEN 0 THEN 0 ELSE VLUC.VLRMOV+(VLUC.VLRMOV*((VLUC.VLRLIQ/VLUC.VLRNOT)-1))+((VLUC.CUSREP+VLUC.CUSFRE)*VLUC.QTDMOV) END',
       '' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       1440,
       12,
       'MARGEM_PERC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       '% Margem',
       '% Margem',
       '',
       '(CASE WHEN ((VLUC.CUSREP+VLUC.CUSFRE)*VLUC.QTDMOV) <> 0 AND VLUC.VLRNOT<>0 THEN (((VLUC.VLRMOV+(VLUC.VLRMOV*((VLUC.VLRLIQ/VLUC.VLRNOT)-1)))/(((VLUC.CUSREP+VLUC.CUSFRE)*VLUC.QTDMOV))-1))/100 ELSE 0 END)',
       '' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '32',
       1651,
       12,
       'MARPRECOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Margem Total',
       'Margem Total',
       '',
       'CASE WHEN nvlz(VLUC.QTDMOV*VLUC.GRA_PRECOM,VLUC.QTDMOV*VLUC.PRECOM)=0 THEN 0 ELSE ((((VLUC.VLRMOV*(VLUC.VLRLIQ/VLUC.VLRNOT)) / nvlz(VLUC.QTDMOV*VLUC.GRA_PRECOM,VLUC.QTDMOV*VLUC.PRECOM)) * 100) - 100) END',
       '' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       1340,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'VEN ',
       130,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(VLUC.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       640,
       2,
       'MES_DATHOR',
       'A',
       '',
       0,
       0,
       'VEN ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       '',
       'N',
       'T',
       'Ms~Incluso',
       'Ms de Data e hora da operao',
       '',
       'TO_CHAR(VLUC.DATHOR,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       20,
       2,
       'MES_DATSAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'T',
       'Ms de Data Sada',
       'Ms de Data Sada',
       '',
       'TO_CHAR(VLUC.DATSAI,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       1370,
       2,
       'MES_PROPGT',
       'A',
       '',
       0,
       0,
       'VEN ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       '',
       'N',
       'T',
       'Ms de Prox. Pagamen',
       'Ms de Data prximo pagamento ou data do cancelamento',
       '',
       'TO_CHAR(VLUC.PROPGT,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       820,
       12,
       'MONTCUSITEM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Custo Aquis.',
       'Montante Custo Aquisicao Item',
       '',
       '(VLUC.QTDMOV*VLUC.CUSTO_AQUISICAO)',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       810,
       12,
       'MONTLIQITEM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Venda',
       'Montante Liquido Item',
       '',
       '(VLUC.QTDMOV*VLUC.PRECO_VENDA)',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '30',
       1030,
       2,
       'NROIMP',
       'S',
       '',
       0,
       0,
       'VEN ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'N',
       'T',
       'Nm. Impresses',
       'Nmero de vezes que a nota foi impressa',
       '',
       'NROIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       575,
       3,
       'NUMCODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '03',
       860,
       8,
       'NUMCON',
       'A',
       '',
       0,
       0,
       'VEN ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '9',
       'T',
       'Conhecimento',
       'Conhecimento de frete',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       580,
       3,
       'NUMECF',
       'A',
       '',
       0,
       0,
       'VEN ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '0',
       'T',
       'ECF',
       'Nmero do ECF',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       670,
       20,
       'NUMEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IVE ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'T',
       'Nm. Externo',
       'Nmero externo',
       '',
       'NUMEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       680,
       2,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'IVE ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'T',
       'Item',
       'Nmero do item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       600,
       6,
       'NUMNOT',
       'A',
       '',
       0,
       0,
       'VEN ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '9',
       'T',
       'Nmero',
       'Nmero da nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       700,
       10,
       'NUMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IVE ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Nmero de Origem',
       'Nmero da Origem',
       '',
       'NUMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '03',
       870,
       4,
       'NUMVOL',
       'G',
       '',
       0,
       0,
       'VEN ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '',
       'T',
       'Num.Volumes',
       'Nmero de Volumes',
       '',
       'NUMVOL',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       1260,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'VEN ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'VEN',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(VLUC.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       480,
       8,
       'PERCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% de Confins',
       '% de Confins',
       '',
       'PERCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       1520,
       12,
       'PERCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Comisso',
       '% Comisso',
       '',
       'PERCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       770,
       8,
       'PERENT',
       'F',
       '',
       2,
       0,
       'VEN ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       '9',
       'T',
       'Comis. s/ Entrada',
       'Comisso (entrada)',
       '',
       'PERENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '30',
       1120,
       4,
       'PERICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% ICMS',
       '% ICMS',
       '',
       'CASE  WHEN VLUC.TIP001 = ''M''  THEN  VLUC.TAX001 = 0 END',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '30',
       1100,
       4,
       'PERIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% IPI',
       '% IPI',
       '',
       'CASE  WHEN VLUC.TIP001 = ''M''  THEN  VLUC.TAX002 = 0 END',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       490,
       6,
       'PERIR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Imposto de Renda',
       'Percentual Imposto de Renda',
       '',
       'PERIR',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '30',
       1110,
       4,
       'PERIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% IRR',
       '% IRR',
       '',
       'CASE  WHEN VLUC.TIP001 = ''S''  THEN  VLUC.TAX002 = 0 END',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '30',
       1090,
       4,
       'PERISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% ISS',
       '% ISS',
       '',
       'CASE  WHEN VLUC.TIP001 = ''S''  THEN  VLUC.TAX001 = 0 END',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       500,
       8,
       'PERLUC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% de Lucro~da Venda',
       'Percentual de lucro na venda deste produto',
       '',
       'PERLUC',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       1590,
       12,
       'PERLUC_CUSTO_ATU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Lucro Custo Atu.',
       '% Lucro Custo Atu.',
       '',
       'PERLUC_CUSTO_ATU',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       510,
       8,
       'PEROPE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% Desp. Operacional',
       'Percentual de despesas operacionais',
       '',
       'PEROPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       520,
       8,
       'PERPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% do PIS',
       '% do PIS',
       '',
       'PERPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       530,
       8,
       'PERSOC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% Contr. Social',
       '% Contr. Social',
       '',
       'PERSOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '03',
       910,
       14,
       'PESBRU',
       'F',
       '',
       4,
       0,
       'VEN ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       'N',
       'T',
       'Peso Bruto',
       'Peso lquido',
       '',
       'PESBRU',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '03',
       920,
       14,
       'PESLIQ',
       'F',
       '',
       4,
       0,
       'VEN ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       'N',
       'T',
       'Peso Lquido',
       'Peso bruto',
       '',
       'PESLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       390,
       12,
       'PRAFIN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Prazo div. Taxa',
       'Prazo divisor da Taxa Financeira ',
       '',
       'PRAFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       790,
       2,
       'PRAMED',
       'S',
       '',
       0,
       0,
       'VEN ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       '9',
       'T',
       'Prazo Mdio',
       'Prazo mdio',
       '',
       'PRAMED',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       540,
       12,
       'PRECOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Preo de Compra',
       'Preo de Compra',
       '',
       'PRECOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       1600,
       12,
       'PRECOM_ATU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Preo Compra Atu.',
       '',
       '',
       'PRECOM_ATU',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '31',
       1420,
       12,
       'PRECO_TOT_VENDA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Preo Total da Venda',
       'Preo Total da Venda',
       '',
       'PRECO_TOT_VENDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '04',
       960,
       12,
       'PRECO_VENDA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Preo Venda',
       'Preo de Venda',
       '',
       'PRECO_VENDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       1360,
       8,
       'PROPGT',
       'D',
       '',
       0,
       0,
       'VEN ',
       140,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'F',
       'D',
       'T',
       'Prox. Pagamento',
       'Data prximo pagamento ou data do cancelamento',
       '',
       'PROPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       1500,
       12,
       'QTDDEVOLVIDA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Qtd. Devolvida',
       'Quantidade devolvida em outras notas referente este item de venda',
       '',
       'QTDDEVOLVIDA(VLUC.CODFIL,VLUC.SEQUEN,VLUC.NUMITE)',
       '' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       260,
       8,
       'QTDMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       'IVE ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'T',
       'Qtde',
       'Quantidade vendida',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       400,
       7,
       'REDITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Reduo do Item',
       'Reduo do Item',
       '',
       'REDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '30',
       1050,
       12,
       'RETIDO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Imposto retido',
       'Valor do Importo Retido',
       '',
       'RETIDO',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       200,
       10,
       'SEQFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Nmero sequencial interno da fatura',
       '',
       'SEQFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       210,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       1300,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'VEN ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'VEN',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN VLUC.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '06',
       1530,
       12,
       'SINAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       '',
       'Sinal',
       '',
       'SINAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       270,
       1,
       'SITKIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IVE ',
       20,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'T',
       'Kit',
       'Situao de Kit',
       '',
       'SITKIT',
       'T' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       280,
       1,
       'SITMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IVE ',
       30,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'T',
       'Situao',
       'Normal ou Cancelado',
       '',
       'SITMOV',
       'T' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       120,
       12,
       'SUBSTT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Subst. Tributria',
       'Subst. Tributria',
       '',
       'SUBSTT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       230,
       4,
       'TAX001',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '',
       'ICMS(Quando Material) a TAXA002=IPI e ISS(Quando Servio) a TAXA002=IRRF',
       '',
       'TAX001',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       240,
       4,
       'TAX002',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '',
       'Aliquota ISS(A TAXA002 pode mudar conforme descrio da TAXA001',
       '',
       'TAX002',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       410,
       12,
       'TAXFIN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Taxa financeira',
       'Taxa Financeira',
       '',
       'TAXFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       250,
       1,
       'TIP001',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tributado',
       'Tributado',
       '',
       'TIP001',
       'T' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       1400,
       1,
       'TIPNOT',
       'A',
       '',
       0,
       0,
       'VEN ',
       160,
       30,
       '',
       '',
       'D',
       'VEN',
       'F',
       'A',
       'F',
       'Tipo de Nota',
       'Tipo de Nota',
       '',
       'TIPNOT',
       'T' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       690,
       1,
       'TIPORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'IVE ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Tipo de Origem',
       'Tipo de Origem',
       '',
       'TIPORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       310,
       1,
       'TIPPRO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       60,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'N',
       'T',
       'Tipo Produto',
       'Tipo Produto',
       '',
       'TIPPRO',
       'T' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '01',
       220,
       1,
       'TIPTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VEN ',
       100,
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       '',
       'Tipo de Parceiro',
       '',
       'TIPTRA',
       'T' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '32',
       1650,
       14,
       'TOTPRECOM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Preo Compra Total',
       'Preo de Compra Total',
       '',
       '(CASE WHEN VLUC.QTDMOV*VLUC.GRA_PRECOM > 0 THEN VLUC.QTDMOV*VLUC.GRA_PRECOM ELSE VLUC.QTDMOV*VLUC.PRECOM END)',
       '' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       1390,
       1,
       'TRIBUT',
       'L',
       '',
       0,
       0,
       'VEN ',
       150,
       TO_NUMBER(null),
       '',
       '',
       'Y',
       'VEN',
       'F',
       '',
       'T',
       'Tributada?',
       'Define se a venda  tributada',
       '',
       'TRIBUT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       60,
       1,
       'UFLOJA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'F',
       'Dentro do Estado?',
       'Venda Dentro do Estado?',
       '',
       'UFLOJA',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       825,
       12,
       'ULTCUSTAQUIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Ult Custo Aquis.Atu.',
       'timo Custo de Aquisio Atual',
       '',
       '(VLUC.QTDMOV*VLUC.CUSTO_AQUISICAO_ATU)',
       '' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       560,
       8,
       'VALCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Converso Unidades',
       'Valor de converso entre as unidades de Venda/Compra',
       '',
       'VALCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '31',
       1180,
       7,
       'VEN_DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data/Hora Venda',
       'Data e Hora da Venda',
       '',
       'VEN_DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '99',
       160,
       1,
       'VINCUL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       ' Vinculado?',
       ' Vinculado?',
       '',
       'VINCUL',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       420,
       9,
       'VLR001',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'ICMS ou ISS',
       'Valor 001',
       '',
       'VLR001',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       430,
       9,
       'VLR002',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'IPI ou IRRF',
       'Valor 002',
       '',
       'VLR002',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '03',
       900,
       8,
       'VLRFRE',
       'F',
       '',
       2,
       0,
       'VEN ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       '9',
       'T',
       'Frete',
       'Valor do Frete',
       '',
       'VLRFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       740,
       8,
       'VLRLIQ',
       'F',
       '',
       2,
       0,
       'VEN ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       '9',
       'T',
       'Valor Lquido',
       'Valor lquido da nota',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       830,
       14,
       'VLRLIQ_IVE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr. Liquido Item',
       'Valor Liquido do Item',
       '',
       'VLUC.VLRMOV*(VLUC.VLRLIQ/VLUC.VLRNOT)',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       290,
       8,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       'IVE ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'T',
       'Valor do Item',
       'Valor do item',
       '',
       'VLRMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '02',
       730,
       8,
       'VLRNOT',
       'F',
       '',
       2,
       0,
       'VEN ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       '9',
       'T',
       'Valor dos Itens',
       'Valor da nota',
       '',
       'VLRNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLUC',
       '03',
       890,
       8,
       'VLRSEG',
       'F',
       '',
       2,
       0,
       'VEN ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VEN',
       'T',
       '9',
       'T',
       'Seguro',
       'Valor do seguro do frete',
       '',
       'VLRSEG',
       'F' FROM DUAL
);

/*-- SEQ 10058 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VLUC',
       'COMSOB',
       5,
       ' ',
       'Recebido na compensao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'COMSOB',
       6,
       ' ',
       'A receber na compensao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'COMSOB',
       7,
       ' ',
       'Comisso sobre markup',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'COMSOB',
       8,
       ' ',
       'Markup no momento da Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'COMSOB',
       3,
       '-',
       'Recebido no Recebimento',
       244,
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'COMSOB',
       4,
       '-',
       'A receber no Recebimento',
       245,
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'COMSOB',
       1,
       '-',
       'Bruto ao Vender',
       242,
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'COMSOB',
       0,
       '-',
       'Lquido ao Vender',
       241,
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'COMSOB',
       2,
       '-',
       'A receber no Vencimento',
       243,
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'FLGEST',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'FLGEST',
       0,
       'Q',
       'Quitado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'FLGTIP',
       0,
       '0',
       'Fsica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'FLGTIP',
       0,
       '1',
       'Jurdica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'FLGTIP',
       0,
       '2',
       'Entidade',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'FLGTIP',
       0,
       '3',
       'Especial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'FLGTIP',
       0,
       '4',
       'M.E.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'FLGTIP',
       0,
       '5',
       'Filial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'ICMTIP',
       0,
       '0',
       'Tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'ICMTIP',
       0,
       '1',
       'No tributado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'ICMTIP',
       0,
       '2',
       'Isento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'ICMTIP',
       0,
       '3',
       'Substitudo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'ICMTIP',
       0,
       '4',
       'Isento no estado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'LANEST',
       0,
       'C',
       'Confirma Reserva',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'LANEST',
       0,
       'N',
       'Nao (s Histrico)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'LANEST',
       0,
       'R',
       'Reserva',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'LANEST',
       0,
       'S',
       'Baixa Estoque',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'SITKIT',
       0,
       '1',
       'Header',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'SITKIT',
       0,
       '2',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'SITKIT',
       0,
       '3',
       'Item Kit',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'SITMOV',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'SITMOV',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'TIP001',
       0,
       'M',
       'Material',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'TIP001',
       0,
       'S',
       'Servios',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'TIPNOT',
       0,
       'A',
       'Ambas (NFF)',
       279,
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'TIPNOT',
       0,
       'F',
       'Fatura',
       277,
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'TIPNOT',
       0,
       'N',
       'Nota Fiscal',
       278,
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'TIPPRO',
       0,
       '0',
       'Material',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'TIPPRO',
       1,
       '1',
       'Servio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'TIPPRO',
       2,
       '2',
       'Terceirizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VLUC',
       'TIPTRA',
       0,
       'S',
       'SAC',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10059 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VLVE',
       TO_NUMBER(null),
       'VLVE',
       'LMC com Fechamento',
       'TV_LMC_VEN',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10060 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VLVE','--','' FROM DUAL
UNION ALL
SELECT 'VLVE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VLVE','99','Outros' FROM DUAL
);

/*-- SEQ 10061 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 57334,
       'GRA ',
       'VLVE',
       'N',
       '1',
       '',
       '',
       'GRA.FILMAT = VLVE.FILMAT AND
GRA.CODMAT = VLVE.CODMAT AND
GRA.CODCOR = VLVE.CODCOR AND
GRA.CODTAM = VLVE.CODTAM
',
       '',
       '' FROM DUAL
);

/*-- SEQ 10062 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VLVE',
       '--',
       10,
       2,
       'BICO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo do Bico',
       'Cdigo do Bico',
       '',
       'BICO',
       'F' FROM DUAL
UNION ALL
SELECT 'VLVE',
       '--',
       20,
       2,
       'BOMBA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Bomba',
       'Bomba',
       '',
       'BOMBA',
       'F' FROM DUAL
UNION ALL
SELECT 'VLVE',
       '--',
       30,
       11,
       'CODBIC',
       'A',
       'DBIC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DBIC.FILBIC||'' - ''||DBIC.SEQFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Bico',
       'Bico',
       'DBIC.CODTAB = VLVE.CODBIC',
       'CODBIC',
       'F' FROM DUAL
UNION ALL
SELECT 'VLVE',
       '--',
       40,
       5,
       'CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Diviso',
       'Cdigo Diviso',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VLVE',
       '--',
       50,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo Filial',
       'Cdigo Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VLVE',
       '--',
       60,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Material',
       'Cdigo Material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLVE',
       '--',
       70,
       5,
       'CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Sub-diviso',
       'Cdigo Sub-diviso',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'VLVE',
       '--',
       80,
       7,
       'DATMED',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Medio',
       'Data Medio',
       '',
       'DATMED',
       'F' FROM DUAL
UNION ALL
SELECT 'VLVE',
       '--',
       90,
       12,
       'ENCABE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Encerrante Abertura',
       'Encerrante Abertura',
       '',
       'ENCABE',
       'F' FROM DUAL
UNION ALL
SELECT 'VLVE',
       '--',
       100,
       12,
       'ENCFEC',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Encerrante Fech.',
       'Encerrante Fechamento',
       '',
       'ENCFEC',
       'F' FROM DUAL
UNION ALL
SELECT 'VLVE',
       '--',
       110,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       'F',
       'Filial do Material',
       'Filial do Material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VLVE',
       '--',
       120,
       3,
       'FILTAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       'F',
       'Filial do Tanque',
       'Filial do Tanque',
       '',
       'FILTAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VLVE',
       '--',
       130,
       5,
       'NUMTAN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero do Tanque',
       'Nmero do Tanque',
       '',
       'NUMTAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VLVE',
       '--',
       140,
       12,
       'QTDMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade Movimenta',
       'Quantidade Movimentada',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VLVE',
       '--',
       150,
       2,
       'TANQUE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Tanque',
       'Tanque',
       '',
       'TANQUE',
       'F' FROM DUAL
UNION ALL
SELECT 'VLVE',
       '--',
       160,
       12,
       'VLRMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Movimentado',
       'Valor Movimentado',
       '',
       'VLRMOV',
       'F' FROM DUAL
);

/*-- SEQ 10063 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VMIN',
       TO_NUMBER(null),
       'VMIN',
       'Quantidade Minima',
       'TV_QDADEMINIMA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10064 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VMIN','--','' FROM DUAL
UNION ALL
SELECT 'VMIN','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VMIN','99','Outros' FROM DUAL
);

/*-- SEQ 10065 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 28084,
       'PXF ',
       'VMIN',
       'N',
       '1',
       '',
       '',
       'PXF.FILMAT = VMIN.FILMAT AND
PXF.CODMAT = VMIN.CODMAT AND
PXF.CODCOR = VMIN.CODCOR AND
PXF.CODTAM = VMIN.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 28085,
       'GRA ',
       'VMIN',
       '1',
       '0N',
       '',
       '',
       'GRA.FILMAT = VMIN.FILMAT(+) and
GRA.CODMAT = VMIN.CODMAT(+) and
GRA.CODCOR = VMIN.CODCOR(+) and
GRA.CODTAM = VMIN.CODTAM(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 10066 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VMIN',
       '--',
       40,
       5,
       'CODCOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'CODCOR',
       '' FROM DUAL
UNION ALL
SELECT 'VMIN',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'VMIN',
       '--',
       30,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'CODMAT',
       '' FROM DUAL
UNION ALL
SELECT 'VMIN',
       '--',
       60,
       5,
       'CODMUL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'CODMUL',
       '' FROM DUAL
UNION ALL
SELECT 'VMIN',
       '--',
       50,
       5,
       'CODTAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'CODTAM',
       '' FROM DUAL
UNION ALL
SELECT 'VMIN',
       '--',
       70,
       8,
       'DATINI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data~Inicial',
       'Data Inicial',
       '',
       'DATINI',
       '' FROM DUAL
UNION ALL
SELECT 'VMIN',
       '--',
       20,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'FILMAT',
       '' FROM DUAL
UNION ALL
SELECT 'VMIN',
       '--',
       130,
       12,
       'MEDIA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       '',
       'Mdia~Vendida',
       'Mdia',
       '',
       'MEDIA',
       '' FROM DUAL
UNION ALL
SELECT 'VMIN',
       '--',
       80,
       12,
       'MES1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       '',
       'Ms 1',
       'Ms 1',
       '',
       'MES1',
       '' FROM DUAL
UNION ALL
SELECT 'VMIN',
       '--',
       90,
       12,
       'MES2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       '',
       'Ms 2',
       'Ms 2',
       '',
       'MES2',
       '' FROM DUAL
UNION ALL
SELECT 'VMIN',
       '--',
       100,
       12,
       'MES3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       '',
       'Ms 3',
       'Ms 3',
       '',
       'MES3',
       '' FROM DUAL
UNION ALL
SELECT 'VMIN',
       '--',
       11,
       3,
       'NOMFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL = VMIN.CODFIL',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'VMIN',
       '--',
       140,
       12,
       'PERCENTUAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Percentual',
       'Percentual',
       '',
       'PERCENTUAL',
       '' FROM DUAL
UNION ALL
SELECT 'VMIN',
       '--',
       110,
       12,
       'QTDMIN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       '',
       'Qtdade~Mnima',
       'Quantidade Mnima',
       '',
       'QTDMIN',
       '' FROM DUAL
UNION ALL
SELECT 'VMIN',
       '--',
       120,
       12,
       'TOTAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       '',
       'Total~Vendido',
       'Total Vendido',
       '',
       'TOTAL',
       '' FROM DUAL
);

/*-- SEQ 10067 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VMIV',
       TO_NUMBER(null),
       'VMIV',
       'ltima Venda Item',
       'TV_MAX_IVE',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10068 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VMIV','--','' FROM DUAL
UNION ALL
SELECT 'VMIV','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VMIV','99','Outros' FROM DUAL
);

/*-- SEQ 10069 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VMIV',
       '01',
       10,
       30,
       'ULTVEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'ltima Venda',
       'Data da ltima Venda',
       '',
       'ULTVEN',
       'F' FROM DUAL
);

/*-- SEQ 10070 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VMMA',
       TO_NUMBER(null),
       'VMMA',
       'Movimento por Marca',
       'TV_MOV_MARCA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10071 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VMMA','--','' FROM DUAL
UNION ALL
SELECT 'VMMA','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VMMA','99','Outros' FROM DUAL
);

/*-- SEQ 10072 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22307,
       'PRO ',
       'VMMA',
       '01',
       '0N',
       '',
       '',
       'PRO.FILMAT(+) = VMMA.FILMAT and
PRO.CODMAT(+) = VMMA.CODMAT',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22308,
       'TMAR',
       'VMMA',
       '01',
       'N',
       '',
       '',
       'TMAR.FILMAR(+) = VMMA.FILMAR and
TMAR.CODMAR(+) = VMMA.CODMAR and
TMAR.ITEMAR(+) = VMMA.ITEMAR',
       '',
       '' FROM DUAL
);

/*-- SEQ 10073 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VMMA',
       '--',
       70,
       5,
       'CLASS1',
       'S',
       'DCL1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL1.CLASS1',
       'V',
       '',
       '',
       'A',
       '',
       'Gnero',
       'Gnero',
       'DCL1.CLASS1(+) = VMMA.CLASS1',
       'CLASS1',
       'T' FROM DUAL
UNION ALL
SELECT 'VMMA',
       '--',
       80,
       5,
       'CLASS2',
       'S',
       'DCL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL2.CLASS2',
       'V',
       '',
       '',
       'A',
       '',
       'Produto',
       'Produto',
       'DCL2.CLASS2(+) = VMMA.CLASS2',
       'CLASS2',
       'T' FROM DUAL
UNION ALL
SELECT 'VMMA',
       '--',
       90,
       5,
       'CLASS3',
       'S',
       'DCL3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL3.CLASS3',
       'V',
       '',
       '',
       'A',
       '',
       'Web',
       'Web',
       'DCL3.CLASS3(+) = VMMA.CLASS3',
       'CLASS3',
       'T' FROM DUAL
UNION ALL
SELECT 'VMMA',
       '--',
       100,
       5,
       'CLASS4',
       'S',
       'DCL4',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL4.CLASS4',
       'V',
       '',
       '',
       'A',
       '',
       'Estao',
       'Estao',
       'DCL4.CLASS4(+) = VMMA.CLASS4',
       'CLASS4',
       'T' FROM DUAL
UNION ALL
SELECT 'VMMA',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       '',
       'Codigo Filial',
       'Codigo Filial',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'VMMA',
       '--',
       120,
       3,
       'CODMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo da Marca',
       'Cdigo da Marca',
       '',
       'CODMAR',
       '' FROM DUAL
UNION ALL
SELECT 'VMMA',
       '--',
       30,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo do Produto',
       'Cdigo do Produto',
       '',
       'CODMAT',
       '' FROM DUAL
UNION ALL
SELECT 'VMMA',
       '--',
       60,
       5,
       'CODMUL',
       'G',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'A',
       '',
       '',
       'A',
       '',
       'Sub-Estoque',
       'Nome do Sub-Estoque',
       'DMUL.CODTAB = VMMA.CODMUL',
       'CODMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'VMMA',
       '--',
       50,
       8,
       'DATFIM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Final',
       'Data Final',
       '',
       'DATFIM',
       '' FROM DUAL
UNION ALL
SELECT 'VMMA',
       '--',
       40,
       8,
       'DATINI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Inicial',
       'Data Inicial',
       '',
       'DATINI',
       '' FROM DUAL
UNION ALL
SELECT 'VMMA',
       '--',
       61,
       0,
       'DESMUL',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'N',
       '',
       'Multiplo Estoque',
       'Descrio Multplo Estoque',
       'DMUL.CODTAB = VMMA.CODMUL',
       'DESMUL',
       '' FROM DUAL
UNION ALL
SELECT 'VMMA',
       '--',
       110,
       3,
       'FILMAR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Fillial da Marca',
       'Fillial da Marca',
       'DFIL.CODFIL(+) = VMMA.FILMAR',
       'FILMAR',
       'T' FROM DUAL
UNION ALL
SELECT 'VMMA',
       '--',
       20,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       '',
       'Filial do Produto',
       'Filial do Produto',
       '',
       'FILMAT',
       '' FROM DUAL
UNION ALL
SELECT 'VMMA',
       '--',
       130,
       3,
       'ITEMAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Item da Marca',
       'Item da Marca',
       '',
       'ITEMAR',
       '' FROM DUAL
UNION ALL
SELECT 'VMMA',
       '--',
       11,
       3,
       'NOMFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial',
       'Nome Filial',
       'DFIL.CODFIL = VMMA.CODFIL',
       'NOMFIL',
       '' FROM DUAL
UNION ALL
SELECT 'VMMA',
       '--',
       160,
       0,
       'QTDCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Qtd Compra',
       'Qtd Compra',
       '',
       'QTDCOM',
       '' FROM DUAL
UNION ALL
SELECT 'VMMA',
       '--',
       170,
       0,
       'QTDVEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Qtd Venda',
       'Qtd Venda',
       '',
       'QTDVEN',
       '' FROM DUAL
UNION ALL
SELECT 'VMMA',
       '--',
       200,
       0,
       'SALFIL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Saldo Final',
       'Saldo Final',
       '',
       'SALFIL',
       '' FROM DUAL
UNION ALL
SELECT 'VMMA',
       '--',
       150,
       0,
       'SALINI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Saldo Inicial',
       'Saldo Inicial',
       '',
       'SALINI',
       '' FROM DUAL
UNION ALL
SELECT 'VMMA',
       '--',
       140,
       1,
       'TIPMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo da Marca',
       'Tipo da Marca',
       '',
       'TIPMAR',
       'T' FROM DUAL
UNION ALL
SELECT 'VMMA',
       '--',
       180,
       0,
       'VLRCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr Compra',
       'Vlr Compra',
       '',
       'VLRCOM',
       '' FROM DUAL
UNION ALL
SELECT 'VMMA',
       '--',
       190,
       0,
       'VLRVEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr Venda',
       'Vlr Venda',
       '',
       'VLRVEN',
       '' FROM DUAL
);

/*-- SEQ 10074 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VMMA',
       'TIPMAR',
       0,
       'M',
       'Marca',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10075 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VMON',
       TO_NUMBER(null),
       'VMON',
       'Eventos Montagem',
       'TV_EVE_MON',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10076 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VMON','--','' FROM DUAL
UNION ALL
SELECT 'VMON','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VMON','99','Outros' FROM DUAL
);

/*-- SEQ 10077 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VMON',
       '--',
       10,
       10,
       'CHVEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Chave do Evento',
       'Chave do Evento',
       '',
       'CHVEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VMON',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VMON',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VMON',
       '--',
       40,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'USU.FILUSU(+) = MON.FILUSU  AND USU.CODUSU(+) = MON.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VMON',
       '--',
       150,
       12,
       'COREVE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Uso Interno',
       '',
       'COREVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VMON',
       '--',
       50,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data e Hora',
       'Data e Hora',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VMON',
       '--',
       160,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VMON',
       '--',
       60,
       5,
       'DESEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio do Evento',
       'Descrio do Evento',
       '',
       'DESEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VMON',
       '--',
       70,
       19,
       'EVE_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Identificao Evento',
       'Identificao do Evento',
       '',
       'EVE_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'VMON',
       '--',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VMON',
       '--',
       90,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VMON',
       '--',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VMON',
       '--',
       110,
       254,
       'MSGEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mendagem Evento',
       'Mensagem do Evento',
       '',
       'MSGEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VMON',
       '--',
       120,
       10,
       'SITEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao Evento',
       'Situao Evento',
       '',
       'SITEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VMON',
       '--',
       130,
       3,
       'TIPEVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Evento',
       'Tipo Evento',
       '',
       'TIPEVE',
       'F' FROM DUAL
UNION ALL
SELECT 'VMON',
       '--',
       140,
       14,
       'VLREVE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Evento',
       'Valor Evento',
       '',
       'VLREVE',
       'F' FROM DUAL
);

/*-- SEQ 10078 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VMON',
       'FLGEST',
       0,
       'A',
       'Em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VMON',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VMON',
       'FLGEST',
       0,
       'E',
       'Entregue',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10079 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VMOT',
       0,
       'VMOT',
       'Motivos',
       'TV_MOT',
       'T',
       '',
       'TOTALL',
       'Provedores',
       '',
       '',
       '',
       '',
       'F',
       '',
       'VMOT.FILCLI,VMOT.CODCLI
VMOT.NOMCLI,VMOT.ULTNOM
VMOT.NUMDOC
',
       '' FROM DUAL
);

/*-- SEQ 10080 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VMOT','--','' FROM DUAL
UNION ALL
SELECT 'VMOT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VMOT','02','Endereo' FROM DUAL
UNION ALL
SELECT 'VMOT','03','Documentao' FROM DUAL
UNION ALL
SELECT 'VMOT','04','Dados Financeiros' FROM DUAL
UNION ALL
SELECT 'VMOT','99','Outros' FROM DUAL
);

/*-- SEQ 10081 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22055,
       'EDE ',
       'VMOT',
       'N',
       '1',
       '',
       '',
       'EDE.FILCLI = VMOT.FILCLI AND
EDE.CODCLI = VMOT.CODCLI
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22056,
       'CON ',
       'VMOT',
       '0N',
       '01',
       '',
       '',
       'CON.FILCLI = VMOT.FILCLI (+)  and
CON.CODCLI = VMOT.CODCLI (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22057,
       'SPC ',
       'VMOT',
       '01',
       '01',
       '',
       'VMOT.FLGTIP = 1',
       'SPC.FILCLI = VMOT.FILCLI (+) and
SPC.CODCLI = VMOT.CODCLI (+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 10082 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VMOT',
       '01',
       280,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(VMOT.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '99',
       480,
       4,
       'ANO_DATA01',
       'A',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 1',
       '',
       'TO_CHAR(VMOT.DATA01,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '99',
       510,
       4,
       'ANO_DATA02',
       'A',
       '',
       0,
       0,
       'PVD ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 2',
       '',
       'TO_CHAR(VMOT.DATA02,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '99',
       540,
       4,
       'ANO_DATA03',
       'A',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 3',
       '',
       'TO_CHAR(VMOT.DATA03,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       310,
       4,
       'ANO_DATNAS',
       'A',
       '',
       0,
       0,
       'PVD ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ano de Nascto/Funda',
       'Ano de Data de nascimento',
       '',
       'TO_CHAR(VMOT.DATNAS,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       340,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       0,
       'PVD ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ano de Data Incluso',
       'Ano de Data de operao (cadastramento)',
       '',
       'TO_CHAR(VMOT.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       260,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '99',
       430,
       2,
       'CATEG1',
       'S',
       'DCT1',
       0,
       20,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'V',
       'PVD',
       'F',
       'A',
       'T',
       '',
       'Categoria - 1',
       'VMOT.CATEG1=DCT1.CODTAB (+)',
       'CATEG1',
       'T' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '99',
       440,
       2,
       'CATEG2',
       'S',
       'DCT2',
       0,
       21,
       'PVD ',
       20,
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'V',
       'PVD',
       'F',
       'A',
       'T',
       '',
       'Categoria - 2',
       'VMOT.CATEG2=DCT2.CODTAB (+)',
       'CATEG2',
       'T' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '99',
       450,
       2,
       'CATEG3',
       'S',
       'DCT3',
       0,
       22,
       'PVD ',
       30,
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'V',
       'PVD',
       'F',
       'A',
       'T',
       'TIPO',
       'Categoria - 3',
       'VMOT.CATEG3=DCT3.CODTAB (+)',
       'CATEG3',
       'T' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       230,
       9,
       'CHAVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'T',
       'Motorista',
       'Cdigo do motorista',
       '',
       'FILCLI||VMOT.CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       220,
       6,
       'CODCLI',
       'A',
       '',
       0,
       0,
       'PVD ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '9',
       'T',
       'Cdigo',
       'Cdigo do motorista',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       160,
       6,
       'CODMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Motivo',
       'Cdigo Motivo',
       '',
       'CODMOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       20,
       6,
       'CODPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo do Parceiro',
       'Cdigo do Parceiro',
       '',
       'CODPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       80,
       3,
       'CODPLA',
       'A',
       'PLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo Plano',
       'Cdigo Plano',
       'VMOT.FILPLA=PLA.FILPGT (+) AND  VMOT.CODPLA=PLA.CODPGT  (+)',
       'CODPLA',
       'T' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       60,
       5,
       'CODSEX',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       13,
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Sexo',
       'Cdigo Sexo',
       '',
       'CODSEX',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       170,
       6,
       'CODTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Transportador',
       'Cdigo Transportadora',
       '',
       'CODTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       150,
       3,
       'CODVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Cdigo Vendedor',
       'Cdigo Vendedor',
       '',
       'CODVEN',
       'T' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       110,
       44,
       'CONJUG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cnjuge',
       'Cnjuge',
       '',
       'CONJUG',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '99',
       460,
       8,
       'DATA01',
       'D',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       '',
       'Data livre - 1',
       '',
       'DATA01',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '99',
       490,
       8,
       'DATA02',
       'D',
       '',
       0,
       0,
       'PVD ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       '',
       'Data livre - 2',
       '',
       'DATA02',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '99',
       520,
       8,
       'DATA03',
       'D',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       '',
       'Data livre - 3',
       '',
       'DATA03',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       290,
       8,
       'DATNAS',
       'D',
       '',
       0,
       0,
       'PVD ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       'Nascto/Fundao',
       'Data de nascimento',
       '',
       'DATNAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       320,
       8,
       'DATOPE',
       'D',
       '',
       0,
       0,
       'PVD ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'D',
       'T',
       'Data Incluso',
       'Data de operao (cadastramento)',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       40,
       15,
       'DOCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento Cnjuge',
       'Documento Cnjuge',
       '',
       'DOCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       50,
       2,
       'ESTCIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Estado Civil',
       'Estado Civil',
       '',
       'ESTCIV',
       'T' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       210,
       3,
       'FILCLI',
       'A',
       '',
       0,
       0,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       'N',
       'T',
       '',
       'Filial onde foi cadastrado o motorista',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       180,
       3,
       'FILMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Motivo',
       '',
       'FILMOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       70,
       3,
       'FILPLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Plano',
       'Filial do Plano',
       '',
       'FILPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       190,
       3,
       'FILTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Transportadora',
       '',
       'FILTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       140,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Vendedor',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '03',
       370,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       0,
       'PVD ',
       20,
       30,
       '',
       '',
       'I',
       'PVD',
       'F',
       '',
       'T',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '02',
       350,
       40,
       'HOMPGE',
       'A',
       '',
       0,
       0,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PVD',
       'F',
       'A',
       'T',
       'Home Page',
       'Home Page do Fornecedor',
       '',
       'HOMPGE',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '99',
       550,
       2,
       'IMPRIM',
       'S',
       '',
       0,
       0,
       'PVD ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '',
       'F',
       'Livre p/Customizao',
       'Livre para customizao',
       '',
       'IMPRIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '03',
       380,
       15,
       'INSEST',
       'A',
       '',
       0,
       4,
       'PVD ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PVD',
       'F',
       'A',
       'T',
       '2 Documento',
       'Inscrio Estadual ou Identidade',
       '',
       'INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '04',
       420,
       2,
       'MAIATR',
       'S',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '9',
       'T',
       'Atraso Max. ao Pagar',
       'Maior atraso registrado',
       '',
       'MAIATR',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       270,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(VMOT.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '99',
       470,
       2,
       'MES_DATA01',
       'A',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 1',
       '',
       'TO_CHAR(VMOT.DATA01,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '99',
       500,
       2,
       'MES_DATA02',
       'A',
       '',
       0,
       0,
       'PVD ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 2',
       '',
       'TO_CHAR(VMOT.DATA02,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '99',
       530,
       2,
       'MES_DATA03',
       'A',
       '',
       0,
       0,
       'PVD ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 3',
       '',
       'TO_CHAR(VMOT.DATA03,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       300,
       2,
       'MES_DATNAS',
       'A',
       '',
       0,
       0,
       'PVD ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ms de Nascto/Funda',
       'Ms de Data de nascimento',
       '',
       'TO_CHAR(VMOT.DATNAS,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       330,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       0,
       'PVD ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       '',
       'N',
       'T',
       'Ms de Data Incluso',
       'Ms de Data de operao (cadastramento)',
       '',
       'TO_CHAR(VMOT.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       120,
       7,
       'NASCON',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Nascimento Cnjuge',
       'Nascimento do Cnjuge',
       '',
       'NASCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       240,
       44,
       'NOMCLI',
       'A',
       '',
       0,
       0,
       'PVD ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PVD',
       'F',
       'A',
       'T',
       'Nome/Razo Social',
       'Nome do motorista',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       200,
       64,
       'NOMMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Motivo',
       'Nome Motivo',
       '',
       'NOMMOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '03',
       360,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       3,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PVD',
       'F',
       'A',
       'T',
       'Documento (CPF/CGC)',
       'Nmero do Documento: CGC ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '99',
       560,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'PVD ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PVD',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(VMOT.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       90,
       2,
       'PORPAD',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       'F',
       'A',
       'F',
       'Portador Padro',
       'Portador padro',
       'VMOT.PORPAD=DCOB.CODTAB (+)',
       'PORPAD',
       'T' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       580,
       1,
       'PP_FLG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Flag Prospeco',
       'Flag de Prospeco sim ou no',
       '',
       'PP_FLG',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       130,
       5,
       'SEXCON',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       13,
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Sexo Cnjuge',
       'Sexo Cnjuge',
       '',
       'SEXCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '99',
       570,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'PVD ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PVD',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN VMOT.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '99',
       571,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN VMOT.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       30,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Parceiro',
       'Tipo Parceiro',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '04',
       400,
       4,
       'TOTATR',
       'G',
       '',
       0,
       0,
       'PVD ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '',
       'F',
       'Total Atrasos',
       'Total de atrasos na vida do motorista como cliente',
       '',
       'TOTATR',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '04',
       410,
       4,
       'TOTPAR',
       'G',
       '',
       0,
       0,
       'PVD ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'F',
       '',
       'F',
       'Total Parcelas',
       'Total de parcelas na vida do motorista como cliente',
       '',
       'TOTPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       100,
       7,
       'ULTCOM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'ltima Compra',
       'ltima Compra',
       '',
       'ULTCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '01',
       250,
       20,
       'ULTNOM',
       'A',
       '',
       0,
       0,
       'PVD ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PVD',
       'F',
       'A',
       'T',
       'Sobrenome/Fantasia',
       'Sobrenome ou fantasia',
       '',
       'ULTNOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VMOT',
       '04',
       390,
       8,
       'VALOR1',
       'F',
       '',
       2,
       0,
       'PVD ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PVD',
       'T',
       '',
       'T',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'VALOR1',
       'F' FROM DUAL
);

/*-- SEQ 10083 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VMOT',
       'ESTCIV',
       6,
       ' ',
       'Separado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VMOT',
       'ESTCIV',
       5,
       ' ',
       'Unio Estvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VMOT',
       'ESTCIV',
       0,
       ' ',
       'Indefinido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VMOT',
       'ESTCIV',
       4,
       ' ',
       'Divorciado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VMOT',
       'ESTCIV',
       1,
       ' ',
       'Solteiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VMOT',
       'ESTCIV',
       2,
       ' ',
       'Casado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VMOT',
       'ESTCIV',
       3,
       ' ',
       'Viuvo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VMOT',
       'TIPPAR',
       0,
       'F',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VMOT',
       'TIPPAR',
       0,
       'T',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10084 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VMPB',
       TO_NUMBER(null),
       'VMPB',
       'Isenes de MPB',
       'TV_MPB',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10085 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VMPB','--','' FROM DUAL
UNION ALL
SELECT 'VMPB','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VMPB','02','Produto' FROM DUAL
UNION ALL
SELECT 'VMPB','03','Apurao' FROM DUAL
UNION ALL
SELECT 'VMPB','99','Outros' FROM DUAL
);

/*-- SEQ 10086 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 57159,
       'MPB ',
       'VMPB',
       'N',
       '1',
       '',
       '',
       'VMPB.CODFIL=MPB.FILVEN AND
VMPB.SEQUEN=MPB.SEQVEN AND
(VMPB.NUMITE = MPB.ITECPU OR
 VMPB.NUMITE = MPB.ITETEC OR
 VMPB.NUMITE = MPB.ITEMOU OR
 VMPB.NUMITE = MPB.ITEMON)',
       'MPB.QTDITE / VMPB.QTDMOV',
       '' FROM DUAL
UNION ALL
SELECT 57215,
       'DNAT',
       'VMPB',
       '1',
       'N',
       '',
       '',
       'DNAT.CODTAB = VMPB.CODNAT',
       '',
       '' FROM DUAL
);

/*-- SEQ 10087 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VMPB',
       '03',
       40,
       12,
       'BASCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base de COFINS',
       'Base de COFINS',
       '',
       'BASCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '03',
       41,
       12,
       'BASPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base de PIS',
       'Base de PIS',
       '',
       'BASPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '01',
       6,
       5,
       'CNT_RO',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'N',
       'F',
       'CRO',
       'CRO',
       '',
       'CNT_RO',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '01',
       900,
       5,
       'CODCTR',
       'G',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       '',
       'N',
       '',
       'Unidade de Negcio',
       'Cdigo da Unidade de Negcio',
       'DCTR.CODTAB = VMPB.CODCTR',
       'CODCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '01',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = VMPB.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '03',
       930,
       5,
       'CODNAT',
       'S',
       'DNAT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DNAT.NATURE',
       'V',
       '',
       '',
       'N',
       '',
       'Natureza',
       'Natureza de Operao',
       'VMPB.CODNAT = DNAT.CODTAB(+)',
       'CODNAT',
       'T' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '02',
       12,
       8,
       'CODNCM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'NCM',
       'NCM',
       '',
       'CODNCM',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '02',
       11,
       21,
       'CODPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Produto',
       'Cdigo do Produto',
       '',
       'CODPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '01',
       3,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie',
       'Srie',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '01',
       80,
       7,
       'DATFIS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Fiscal',
       'Data Fiscal',
       '',
       'DATFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '01',
       90,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Emisso',
       'Data e Hora Emisso',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '01',
       100,
       20,
       'DOCUME',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       '' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '02',
       13,
       2,
       'GENNCM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Gnero do NCM',
       'Gnero do NCM',
       '',
       'GENNCM',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '02',
       15,
       256,
       'NOMPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Produto',
       'Nome do Produto',
       '',
       'NOMPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '01',
       2,
       3,
       'NUMECF',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       'F',
       'Nmero do ECF',
       'Nmero do ECF',
       'DECF.FILECF = VMPB.CODFIL AND DECF.NUMECF = VMPB.NUMECF',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '01',
       8,
       5,
       'NUMITE',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero do Item',
       'Nmero do Item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '01',
       5,
       6,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero do Documento',
       'Nmero do Documento (NF/CF)',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '03',
       42,
       6,
       'PERCOF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% de COFINS',
       '% de COFINS',
       '',
       'PERCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '03',
       43,
       6,
       'PERPIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% de PIS',
       '% de PIS',
       '',
       'PERPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '03',
       30,
       12,
       'QTDMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade Vendida',
       'Quantidade Vendida',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '03',
       31,
       12,
       'QTDMPB',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade Isentada',
       'Quantidade Isentada pela MPB',
       '',
       'QTDMPB',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '02',
       14,
       20,
       'REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Referncia Produto',
       'Referncia de Grade do Produto',
       '',
       'REFPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '01',
       7,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Seq. Documento',
       'Sequenciador do Documento',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '01',
       4,
       3,
       'SEREXP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie (Exportada)',
       'Srie (Exportada)',
       '',
       'SEREXP',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '03',
       44,
       2,
       'SITCOF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       'F',
       'CST de COFINS',
       'CST de COFINS',
       '',
       'SITCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '03',
       45,
       2,
       'SITPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       'F',
       'CST de PIS',
       'CST de PIS',
       '',
       'SITPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '03',
       46,
       12,
       'TOTCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Total de COFINS',
       'Valor Total de COFINS',
       '',
       'TOTCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '03',
       47,
       12,
       'TOTPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Total de PIS',
       'Valor Total de PIS',
       '',
       'TOTPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '03',
       34,
       12,
       'VALOR_MERC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Total no SPED',
       'Valor Total do Item no SPED',
       '',
       'VALOR_MERC',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '03',
       48,
       12,
       'VLRCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Pago de COFINS',
       'Valor Pago de COFINS',
       '',
       'VLRCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '03',
       50,
       12,
       'VLRCOF_ISENTO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Isento COFINS',
       'Valor Isento de COFINS',
       '',
       'VLRCOF_ISENTO',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '03',
       32,
       12,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Lquido Doc.',
       'Valor Lquido do Documento',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '03',
       33,
       12,
       'VLRLIQRAT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Lquido Item',
       'Valor Lquido do Item',
       '',
       'VLRLIQRAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '03',
       920,
       12,
       'VLRLIQRATISE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Lquido Isento',
       'Valor Lquido Relativo ao Isentado pelo MPB',
       '',
       '(VMPB.VLRLIQRAT / VMPB.QTDMOV) * VMPB.QTDMPB',
       '' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '03',
       36,
       14,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Vendido Item',
       'Valor Vendido Item',
       '',
       'VLRMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '03',
       35,
       12,
       'VLRNOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Vendido Doc.',
       'Valor Vendido Doc.',
       '',
       'VLRNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '03',
       49,
       12,
       'VLRPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Pago de PIS',
       'Valor Pago de PIS',
       '',
       'VLRPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPB',
       '03',
       51,
       12,
       'VLRPIS_ISENTO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Isento PIS',
       'Valor Isento de PIS',
       '',
       'VLRPIS_ISENTO',
       'F' FROM DUAL
);

/*-- SEQ 10088 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VMPF',
       TO_NUMBER(null),
       'VMPF',
       'Metas p/ Filial',
       'TV_MPF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VMPF.ANOREF,VMPF.MESREF,VMPF.CODFIL,VMPF.CODCTR',
       '' FROM DUAL
);

/*-- SEQ 10089 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VMPF','--','' FROM DUAL
UNION ALL
SELECT 'VMPF','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VMPF','02','Datas' FROM DUAL
UNION ALL
SELECT 'VMPF','03','Valores' FROM DUAL
UNION ALL
SELECT 'VMPF','99','Outros' FROM DUAL
);

/*-- SEQ 10090 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 6001,
       'DFIL',
       'VMPF',
       '1 ',
       'N ',
       '',
       '',
       'DFIL.CODFIL = VMPF.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 10091 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VMPF',
       '02',
       10,
       4,
       'ANOREF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Ano Referncia',
       'Ano Referncia',
       '',
       'ANOREF',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       160,
       12,
       'AVISTA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Receb.  Vista',
       'Valor a Vista',
       '',
       'AVISTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '01',
       20,
       12,
       'CNTVEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Quantidade de vendas',
       'Vendas Acumuladas',
       '',
       'CNTVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '01',
       300,
       5,
       'CODCTR',
       'S',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       '',
       'N',
       'F',
       'Unidade de Negcios',
       'Unidade de Negcios',
       'DCTR.CODTAB = VMPF.CODCTR',
       'CODCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '01',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VMPF.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       40,
       12,
       'COMIS1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Comisso 1',
       'Comisso 1',
       '',
       'COMIS1',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       50,
       12,
       'COMIS2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Comisso 2',
       'Comisso 2',
       '',
       'COMIS2',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       60,
       12,
       'COMIS3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Comisso 3',
       'Comisso 3',
       '',
       'COMIS3',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       70,
       12,
       'COMIS4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Comisso 4',
       'Comisso 4',
       '',
       'COMIS4',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       310,
       12,
       'DEVAVI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Dev. de~A Vista',
       'Dev. de A Vista',
       '',
       'DEVAVI',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       320,
       12,
       'DEVENT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Dev. de~Entrada',
       'Dev. de Entrada',
       '',
       'DEVENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       330,
       12,
       'DEVPRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Dev. de~Prestaes',
       'Dev. de Prestaes',
       '',
       'DEVPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       240,
       4,
       'DIAS_FALTANTES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       '',
       'Dias Faltantes',
       'Dias Faltantes',
       '',
       '(CASE WHEN TO_NUMBER(TO_CHAR(AGORA(),''YYYYMM'')) > (VMPF.ANOREF*100)+VMPF.MESREF THEN 0 ELSE DIASUTEIS( VMPF.CODFIL, TRUNC(AGORA()), LAST_DAY(TO_DATE(''01''||SUBSTR(TO_CHAR((VMPF.MESREF*10000)+(VMPF.ANOREF),''000009''),2),''DDMMYYYY''))) END )',
       '' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       235,
       4,
       'DIAS_UTEIS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Dias teis',
       'Dias teis',
       '',
       'DIASUTEIS( VMPF.CODFIL, TO_DATE(''01''|| SUBSTR(TO_CHAR((VMPF.MESREF*10000)+(VMPF.ANOREF),''000009''),2),''DDMMYYYY''), LAST_DAY(TO_DATE(''01''||SUBSTR(TO_CHAR((VMPF.MESREF*10000)+(VMPF.ANOREF),''000009''),2),''DDMMYYYY'')))',
       '' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       251,
       12,
       'FALTA_META1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Falta p/ 1 Meta',
       'Falta para alcanar a primeira Meta de Vendas',
       '',
       'ROUND((VMPF.VALOR1-VMPF.VLRREA),2)',
       '' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       252,
       12,
       'FALTA_META2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Falta p/ 2 Meta',
       'Falta para alcanar a segunda Meta de Vendas',
       '',
       'ROUND((VMPF.VALOR2-VMPF.VLRREA),2)',
       '' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       253,
       12,
       'FALTA_META3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Falta p/ 3 Meta',
       'Falta para alcanar a terceira Meta de Vendas',
       '',
       'ROUND((VMPF.VALOR3-VMPF.VLRREA),2)',
       '' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       254,
       12,
       'FALTA_META4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Falta p/ 4 Meta',
       'Falta para alcanar a quarta Meta de Vendas',
       '',
       'ROUND((VMPF.VALOR4-VMPF.VLRREA),2)',
       '' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '02',
       80,
       2,
       'MESREF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Ms Referncia',
       'Ms Referncia',
       '',
       'MESREF',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '01',
       35,
       3,
       'NUMCODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       271,
       12,
       'PERC_ENTRADA1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '%1Meta~X Entr+Avist',
       '% Alcanado da primeira Meta em relao as entradas mais vendas a vista',
       '',
       'ROUND((CASE WHEN COALESCE(VMPF.VALOR1,0) > 0 THEN (VMPF.VLRENT+VMPF.AVISTA)*100/VMPF.VALOR1 ELSE 0 END),2)',
       '' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       272,
       12,
       'PERC_ENTRADA2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '%2Meta~X Entr+Avist',
       '% Alcanado da segunda Meta em relao as entradas mais vendas a vista',
       '',
       'ROUND((CASE WHEN COALESCE(VMPF.VALOR2,0) > 0 THEN (VMPF.VLRENT+VMPF.AVISTA)*100/VMPF.VALOR1 ELSE 0 END),2)',
       '' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       273,
       12,
       'PERC_ENTRADA3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '%3Meta~X Entr+Avist',
       '% Alcanado da terceira Meta em relao as entradas mais vendas a vista',
       '',
       'ROUND((CASE WHEN COALESCE(VMPF.VALOR3,0) > 0 THEN (VMPF.VLRENT+VMPF.AVISTA)*100/VMPF.VALOR1 ELSE 0 END),2)',
       '' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       274,
       12,
       'PERC_ENTRADA4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '%4Meta~X Entr+Avist',
       '% Alcanado da quarta Meta em relao as entradas mais vendas a vista',
       '',
       'ROUND((CASE WHEN COALESCE(VMPF.VALOR4,0) > 0 THEN (VMPF.VLRENT+VMPF.AVISTA)*100/VMPF.VALOR1 ELSE 0 END),2)',
       '' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       261,
       12,
       'PERC_META1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       '',
       '% Atigindo da 1Meta',
       '% Alcanado em relao a primeira meta de Venda',
       '',
       'ROUND((CASE WHEN COALESCE(VMPF.VALOR1,0) > 0 THEN VMPF.VLRREA*100/VMPF.VALOR1 ELSE 0 END),2)',
       '' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       262,
       12,
       'PERC_META2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '% Atigindo da 2Meta',
       '% Alcanado em relao a segunda meta de Venda',
       '',
       'ROUND((CASE WHEN COALESCE(VMPF.VALOR2,0) > 0 THEN VMPF.VLRREA*100/VMPF.VALOR2 ELSE 0 END),2)',
       '' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       263,
       12,
       'PERC_META3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '% Atigindo da 3Meta',
       '% Alcanado em relao a terceira meta de Venda',
       '',
       'ROUND((CASE WHEN COALESCE(VMPF.VALOR3,0) > 0 THEN VMPF.VLRREA*100/VMPF.VALOR3 ELSE 0 END),2)',
       '' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       264,
       12,
       'PERC_META4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       '',
       '% Atigindo da 4Meta',
       '% Alcanado em relao a quarta meta de Venda',
       '',
       'ROUND((CASE WHEN COALESCE(VMPF.VALOR4,0) > 0 THEN VMPF.VLRREA*100/VMPF.VALOR4 ELSE 0 END),2)',
       '' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       90,
       12,
       'PREMIO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Prmio',
       'Prmio',
       '',
       'PREMIO',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       100,
       12,
       'VALALC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Meta Alcanada',
       'Valor da venda Alcanada',
       '',
       'VALALC',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       110,
       12,
       'VALOR1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Meta 1',
       'Meta1',
       '',
       'VALOR1',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       120,
       12,
       'VALOR2',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Meta 2',
       'Meta2',
       '',
       'VALOR2',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       130,
       12,
       'VALOR3',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Meta 3',
       'Meta3',
       '',
       'VALOR3',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       140,
       12,
       'VALOR4',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Meta 4',
       'Meta4',
       '',
       'VALOR4',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       180,
       12,
       'VLRCAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Cartes',
       'Valor Cartes',
       '',
       'VLRCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       190,
       12,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Descontos s/Parcelas',
       'Valor Descontos',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       200,
       12,
       'VLRDEV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Devolues',
       'Valor Devolues',
       '',
       'VLRDEV',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       210,
       12,
       'VLRENT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Receb. Entradas',
       'Valor Entrada',
       '',
       'VLRENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       220,
       12,
       'VLRJUR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Juros s/Parcelas',
       'Valor Juros',
       '',
       'VLRJUR',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       230,
       12,
       'VLRPRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Receb. Prestaes',
       'Valor das Prestaes',
       '',
       'VLRPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPF',
       '03',
       150,
       12,
       'VLRREA',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vendas',
       'Valor Realizvel',
       '',
       'VLRREA',
       'F' FROM DUAL
);

/*-- SEQ 10092 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VMPT',
       TO_NUMBER(null),
       'VMPT',
       'Rel Vendas Meio Pgt',
       'TV_REC_MEIPGT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10093 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VMPT','--','' FROM DUAL
UNION ALL
SELECT 'VMPT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VMPT','99','Outros' FROM DUAL
);

/*-- SEQ 10094 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 24466,
       'VEN ',
       'VMPT',
       '0N',
       '1',
       '',
       '',
       'VMPT.CODFIL = VEN.CODFIL and VMPT.SEQUEN = VEN.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 10095 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VMPT',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL = VMPT.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VMPT',
       '01',
       30,
       254,
       'MEIPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Meio de Pagamento',
       'Meio de Pagamento',
       '',
       'MEIPGT',
       '' FROM DUAL
UNION ALL
SELECT 'VMPT',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 10096 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VMVC',
       TO_NUMBER(null),
       'VMVC',
       'ltima Venda Cliente',
       'TV_MAX_VEN_CLI',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10097 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VMVC','--','' FROM DUAL
UNION ALL
SELECT 'VMVC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VMVC','99','Outros' FROM DUAL
);

/*-- SEQ 10098 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 28808,
       'CLI ',
       'VMVC',
       'N',
       '1',
       '',
       '',
       'CLI.FILCLI = VMVC.FILCLI AND CLI.CODCLI = VMVC.CODCLI',
       '',
       '' FROM DUAL
);

/*-- SEQ 10099 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VMVC',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Cdigo Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 'VMVC',
       '01',
       40,
       8,
       'DATHOR',
       '@',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Venda',
       'Data venda',
       '',
       'DATHOR',
       '' FROM DUAL
UNION ALL
SELECT 'VMVC',
       '01',
       10,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'A',
       '',
       '',
       '0',
       '',
       'Filial Cliente',
       'Filial Cliente',
       'DFIL.CODFIL = VMVC.FILCLI',
       'FILCLI',
       '' FROM DUAL
UNION ALL
SELECT 'VMVC',
       '99',
       60,
       1,
       'FINANC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Gera Dados Financ.?',
       'Gera dados financeiros',
       '',
       'FINANC',
       '' FROM DUAL
UNION ALL
SELECT 'VMVC',
       '99',
       50,
       1,
       'LANVEN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Lana Como Venda',
       'Lana como Venda',
       '',
       'LANVEN',
       'T' FROM DUAL
UNION ALL
SELECT 'VMVC',
       '01',
       30,
       8,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor liquido',
       'Valor liquido',
       '',
       'VLRLIQ',
       '' FROM DUAL
);

/*-- SEQ 10100 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VNCC',
       TO_NUMBER(null),
       'VNCC',
       'No CCC',
       'TV_NAO_CCC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VNCC.FILCLI,VNCC.CODCLI',
       '' FROM DUAL
);

/*-- SEQ 10101 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VNCC','--','' FROM DUAL
UNION ALL
SELECT 'VNCC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VNCC','02','Datas' FROM DUAL
UNION ALL
SELECT 'VNCC','03','Valores' FROM DUAL
UNION ALL
SELECT 'VNCC','99','Outros' FROM DUAL
);

/*-- SEQ 10102 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VNCC',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VNCC',
       '01',
       20,
       13,
       'CUPFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cupom Fiscal',
       'Nmero do cupom fiscal',
       '',
       'CUPFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VNCC',
       '02',
       30,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data e Hora',
       'Data e Hora',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VNCC',
       '01',
       40,
       30,
       'DESTIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Destino',
       'Destino',
       '',
       'DESTIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VNCC',
       '01',
       50,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VNCC',
       '01',
       60,
       4000,
       'MEIOPG',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Meio de Pagamento',
       'Meio de Pagamento',
       '',
       'MEIOPG',
       'F' FROM DUAL
UNION ALL
SELECT 'VNCC',
       '01',
       70,
       15,
       'NOMFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome da Filial',
       'Nome da Filial ',
       '',
       'NOMFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VNCC',
       '01',
       80,
       64,
       'NOMMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Motivo',
       'Nome do Motivo',
       '',
       'NOMMOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VNCC',
       '01',
       90,
       30,
       'ORIGEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Origem',
       'Origem',
       '',
       'ORIGEM',
       'F' FROM DUAL
UNION ALL
SELECT 'VNCC',
       '01',
       100,
       7,
       'PLACAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Placa do Veculo',
       'Placa do Veculo',
       '',
       'PLACAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VNCC',
       '03',
       110,
       12,
       'QTDLIT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade de Lit.',
       'Quantidade de Lit.',
       '',
       'QTDLIT',
       'F' FROM DUAL
UNION ALL
SELECT 'VNCC',
       '03',
       120,
       12,
       'QTD_KM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade de KM',
       'Quantidade de KM',
       '',
       'QTD_KM',
       'F' FROM DUAL
UNION ALL
SELECT 'VNCC',
       '01',
       130,
       6,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'STATUS',
       'T' FROM DUAL
UNION ALL
SELECT 'VNCC',
       '03',
       140,
       12,
       'VLRLAN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Lanamento',
       'Valor Lanamento',
       '',
       'VLRLAN',
       'F' FROM DUAL
);

/*-- SEQ 10103 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VNCC',
       'STATUS',
       0,
       ' ',
       'Aberto',
       TO_NUMBER(null),
       'Aberto' FROM DUAL
UNION ALL
SELECT 'VNCC',
       'STATUS',
       0,
       ' ',
       'Cancelada',
       TO_NUMBER(null),
       'Cancelada' FROM DUAL
UNION ALL
SELECT 'VNCC',
       'STATUS',
       0,
       ' ',
       'Quitada',
       TO_NUMBER(null),
       'Quitada' FROM DUAL
);

/*-- SEQ 10104 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VOFR',
       TO_NUMBER(null),
       'VOFR',
       'Valor Original Frete',
       'TV_FRETE_ORIGEM',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10105 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VOFR','--','' FROM DUAL
UNION ALL
SELECT 'VOFR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VOFR','99','Outros' FROM DUAL
);

/*-- SEQ 10106 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VOFR',
       '--',
       10,
       40,
       'BAIRRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Bairro',
       'Bairro',
       '',
       'BAIRRO',
       '' FROM DUAL
UNION ALL
SELECT 'VOFR',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo do cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 'VOFR',
       '--',
       30,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL = VOFR.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VOFR',
       '--',
       40,
       6,
       'CODMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo do Motorista',
       'Cdigo do Motorista',
       '',
       'CODMOT',
       '' FROM DUAL
UNION ALL
SELECT 'VOFR',
       '--',
       50,
       8,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data',
       'Data',
       '',
       'DATHOR',
       '' FROM DUAL
UNION ALL
SELECT 'VOFR',
       '--',
       60,
       15,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       '' FROM DUAL
UNION ALL
SELECT 'VOFR',
       '--',
       70,
       60,
       'ENDERE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Endereo',
       'Endereo',
       '',
       'ENDERE',
       '' FROM DUAL
UNION ALL
SELECT 'VOFR',
       '--',
       170,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial do Cliente',
       'Filial do Cliente',
       'DFIL.CODFIL = VOFR.FILCLI',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VOFR',
       '--',
       80,
       3,
       'FILMOT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial do Motorista',
       'Filial do Motorista',
       'DFIL.CODFIL = VOFR.FILMOT',
       'FILMOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VOFR',
       '--',
       90,
       6,
       'NATFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Natureza Operao',
       'Natureza de Operao',
       '',
       'NATFIS',
       '' FROM DUAL
UNION ALL
SELECT 'VOFR',
       '--',
       100,
       35,
       'NOMCID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome da Cidade',
       'Nome da Cidade',
       '',
       'NOMCID',
       '' FROM DUAL
UNION ALL
SELECT 'VOFR',
       '--',
       110,
       100,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome do Cliente',
       'Nome do Cliente',
       '',
       'NOMCLI',
       '' FROM DUAL
UNION ALL
SELECT 'VOFR',
       '--',
       120,
       100,
       'NOMMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome do Motorista',
       'Nome do Motorista',
       '',
       'NOMMOT',
       '' FROM DUAL
UNION ALL
SELECT 'VOFR',
       '--',
       130,
       15,
       'NUMERO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nmero do Endereo',
       'Nmero do Endereo',
       '',
       'NUMERO',
       '' FROM DUAL
UNION ALL
SELECT 'VOFR',
       '--',
       190,
       14,
       'PESBRU',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Peso Bruto',
       'Peso Bruto',
       '',
       'PESBRU',
       '' FROM DUAL
UNION ALL
SELECT 'VOFR',
       '--',
       200,
       14,
       'PESLIQ',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Peso Lquido',
       'Peso Lquido',
       '',
       'PESLIQ',
       '' FROM DUAL
UNION ALL
SELECT 'VOFR',
       '--',
       140,
       15,
       'REGIAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Regio do Cliente',
       'Regio do Cliente',
       '',
       'REGIAO',
       '' FROM DUAL
UNION ALL
SELECT 'VOFR',
       '--',
       180,
       12,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor do Frete',
       'Valor do Frete',
       '',
       'VLRFRE',
       '' FROM DUAL
UNION ALL
SELECT 'VOFR',
       '--',
       150,
       12,
       'VLRFREORI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Original Frete',
       'Valor Original do Frete',
       '',
       'VLRFREORI',
       '' FROM DUAL
UNION ALL
SELECT 'VOFR',
       '--',
       160,
       12,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Lquido',
       'Valor Lquido',
       '',
       'VLRLIQ',
       '' FROM DUAL
);

/*-- SEQ 10107 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VOL ',
       TO_NUMBER(null),
       'VOL ',
       'Volumes',
       'TT_VOL',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'VOL.FILVOL,VOL.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 10108 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VOL ','--','' FROM DUAL
);

/*-- SEQ 10109 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 6002,
       'USU ',
       'VOL ',
       '1',
       '1',
       '',
       '',
       'USU.FILUSU = VOL.FILUSU AND
USU.CODUSU = VOL.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 10110 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VOL ',
       '--',
       7,
       3,
       'CODUSU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo Usurio',
       'VOL.FILUSU = USU2.FILUSU(+)  AND VOL.CODUSU = USU2.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VOL ',
       '--',
       5,
       7,
       'DATVOL',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Volume',
       'Data Volume',
       '',
       'DATVOL',
       'F' FROM DUAL
UNION ALL
SELECT 'VOL ',
       '--',
       3,
       3,
       'FILCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Carto',
       'Filial Carto',
       '',
       'FILCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VOL ',
       '--',
       6,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VOL ',
       '--',
       1,
       3,
       'FILVOL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial do Volume',
       'Filial do Volume',
       'DFIL.CODFIL = VOL.FILVOL',
       'FILVOL',
       'F' FROM DUAL
UNION ALL
SELECT 'VOL ',
       '--',
       4,
       10,
       'SEQCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Carto',
       '',
       'SEQCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VOL ',
       '--',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 10111 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VOPE',
       TO_NUMBER(null),
       'VOPE',
       'Operaes de Caixa',
       'TV_OPE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10112 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VOPE','--','' FROM DUAL
UNION ALL
SELECT 'VOPE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VOPE','99','Outros' FROM DUAL
);

/*-- SEQ 10113 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 45930,
       'RECP',
       'VOPE',
       '1',
       '1',
       '',
       '',
       'RECP.CODFIL = VOPE.FILREC AND
RECP.SEQUEN = VOPE.SEQREC AND
RECP.NUMPAR = VOPE.NUMPAR AND
RECP.SUBPAR = VOPE.SUBPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45843,
       'CHR ',
       'VOPE',
       '1',
       '1',
       '',
       '',
       'CHR.CODFIL = VOPE.FILCHR AND
CHR.SEQUEN = VOPE.SEQCHR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45844,
       'FIN ',
       'VOPE',
       '1',
       '1',
       '',
       '',
       'FIN.CODFIL = VOPE.FILFIN AND
FIN.SEQUEN = VOPE.SEQFIN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45845,
       'CCC ',
       'VOPE',
       '1',
       '1',
       '',
       '',
       'CCC.CODFIL = VOPE.FILCCC AND
CCC.SEQUEN = VOPE.SEQCCC
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45846,
       'REC ',
       'VOPE',
       '1',
       '1',
       '',
       '',
       'REC.CODFIL = VOPE.FILREC AND
REC.SEQUEN = VOPE.SEQREC AND
REC.NUMPAR = VOPE.NUMPAR AND
REC.SUBPAR = VOPE.SUBPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45847,
       'LID ',
       'VOPE',
       '1',
       '1',
       '',
       '',
       'LID.CODFIL = VOPE.CODFIL AND
LID.NUMECF = VOPE.NUMECF AND
LID.TRN_ID = VOPE.TRN_ID',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45848,
       'DCAI',
       'VOPE',
       '01',
       '0N',
       '',
       '',
       'VOPE.CODCAI = DCAI.CODTAB',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45849,
       'CLI ',
       'VOPE',
       '1',
       'N',
       '',
       '',
       'VOPE.FILCLI = CLI.FILCLI AND
VOPE.CODCLI = CLI.CODCLI ',
       '',
       '' FROM DUAL
);

/*-- SEQ 10114 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VOPE',
       '--',
       10,
       5,
       'CAMBIO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cmbio',
       'Cmbio',
       '',
       'CAMBIO',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       20,
       5,
       'CARTAO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Carto',
       'Carto',
       '',
       'CARTAO',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       30,
       5,
       'CODCAI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo Resumo Caixa',
       'Cdigo resumo de Caixa',
       '',
       'CODCAI',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '99',
       430,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       40,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = VOPE.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       50,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'VOPE.FILUSU = USU.FILUSU(+)  AND VOPE.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       60,
       6,
       'CUPFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cupom Fiscal',
       'Cupom Fiscal',
       '',
       'CUPFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       70,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       80,
       30,
       'DOCTRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Doc. Cheque Troco',
       'Doc. Cheque Troco',
       '',
       'DOCTRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       320,
       46,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       330,
       3,
       'FILCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       340,
       3,
       'FILCHR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILCHR',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '99',
       440,
       3,
       'FILCLI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Cliente',
       'Filial Cliente',
       'CLI.FILCLI = DFIL.CODFIL (+)',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       350,
       3,
       'FILDOP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILDOP',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       360,
       3,
       'FILFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       370,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       150,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       160,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'ECF',
       'Nmero Emissor Cupom Fiscal',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       170,
       3,
       'NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Item',
       'Nmero do item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       180,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero~Parcela',
       'Nmero da Parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       190,
       5,
       'OUTROS',
       'S',
       'DOUT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DOUT.DESCAR',
       'V',
       '',
       '',
       'A',
       'F',
       'Outros',
       'Outros',
       'DOUT.CODTAB(+) = VOPE.OUTROS',
       'OUTROS',
       'T' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       380,
       10,
       'SEQCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       390,
       10,
       'SEQCHR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQCHR',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       400,
       10,
       'SEQDOP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQDOP',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       410,
       10,
       'SEQFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       420,
       10,
       'SEQREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       250,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Sub-Parcela',
       'Nmero da sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       260,
       1,
       'TIPCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Carto',
       'Tipo Carto',
       '',
       '(CASE TIPCAR WHEN ''C'' THEN ''CRDITO'' WHEN ''D'' THEN ''DBITO'' ELSE '''' END)',
       'T' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       270,
       30,
       'TIPOPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Operao',
       'Tipo Operao',
       '',
       'TIPOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       280,
       12,
       'TRN_ID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'ID~Transao',
       'ID Transao',
       '',
       'TRN_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       290,
       12,
       'VLRCRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Valor Crdito',
       'Valor Crdito',
       '',
       'VLRCRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       300,
       12,
       'VLRDEB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Valor Dbito',
       'Valor Dbito',
       '',
       'VLRDEB',
       'F' FROM DUAL
UNION ALL
SELECT 'VOPE',
       '--',
       310,
       16,
       'VLROPE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Valor da Operao',
       'Valor da Operao',
       '',
       'VLROPE',
       'F' FROM DUAL
);

/*-- SEQ 10115 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VOT ',
       TO_NUMBER(null),
       'VOT ',
       'Volumes Transportado',
       'TT_VOT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10116 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VOT ','--','' FROM DUAL
UNION ALL
SELECT 'VOT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VOT ','99','Outros' FROM DUAL
);

/*-- SEQ 10117 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 24499,
       'OIP ',
       'VOT ',
       '1',
       '0N',
       '',
       '',
       'OIP.CODFIL = VOT.FILOIP(+) AND
OIP.SEQUEN = VOT.SEQOIP(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 10118 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VOT ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = VOT.CODFIL(+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'VOT ',
       '99',
       60,
       60,
       'ESPECI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Espcie',
       'Espcie',
       '',
       'ESPECI',
       'F' FROM DUAL
UNION ALL
SELECT 'VOT ',
       '01',
       30,
       3,
       'FILOIP',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       'F',
       'Filial da DI',
       'Filial da DI',
       'DFIL.CODFIL = VOT.FILOIP(+)',
       'FILOIP',
       'T' FROM DUAL
UNION ALL
SELECT 'VOT ',
       '99',
       50,
       12,
       'QTDVOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Quantidade',
       'Quantidade',
       '',
       'QTDVOL',
       'F' FROM DUAL
UNION ALL
SELECT 'VOT ',
       '01',
       40,
       10,
       'SEQOIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. da DI',
       'Seq. da DI',
       '',
       'SEQOIP',
       'F' FROM DUAL
UNION ALL
SELECT 'VOT ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 10119 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VPA ',
       TO_NUMBER(null),
       'VPA ',
       'Projetos Avulsos',
       'TV_PRJ_AVU',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10120 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VPA ','--','' FROM DUAL
UNION ALL
SELECT 'VPA ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VPA ','99','Outros' FROM DUAL
);

/*-- SEQ 10121 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VPA ',
       '01',
       10,
       12,
       'COBRAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade a Cobrar',
       'Quantidade a Cobrar',
       '',
       'COBRAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPA ',
       '01',
       20,
       8,
       'DATREG',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Registro',
       'Data de Registro',
       '',
       'DATREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VPA ',
       '01',
       30,
       12,
       'QTDABE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade em Aberto',
       'Quantidade em Aberto',
       '',
       'QTDABE',
       'F' FROM DUAL
UNION ALL
SELECT 'VPA ',
       '01',
       40,
       12,
       'QTDAPR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade Aprovada',
       'Quantidade Aprovada',
       '',
       'QTDAPR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPA ',
       '01',
       50,
       12,
       'QTDCAN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Qtde Cancelamentos',
       'Quantidade de Cancelamentos',
       '',
       'QTDCAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VPA ',
       '01',
       60,
       12,
       'QTDESP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade Especial',
       'Quantidade Especial',
       '',
       'QTDESP',
       'F' FROM DUAL
UNION ALL
SELECT 'VPA ',
       '01',
       70,
       12,
       'QTDREP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade de Reposi',
       'Quantidade de Reposies',
       '',
       'QTDREP',
       'F' FROM DUAL
UNION ALL
SELECT 'VPA ',
       '01',
       80,
       12,
       'QTD_OK',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade OK',
       'Quantidade OK',
       '',
       'QTD_OK',
       'F' FROM DUAL
);

/*-- SEQ 10122 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VPC ',
       TO_NUMBER(null),
       'VPC ',
       'Projetos x Contato',
       'TV_PRJ_CON',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VPC.FILCLI,VPC.CODCLI',
       '' FROM DUAL
);

/*-- SEQ 10123 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VPC ','--','' FROM DUAL
UNION ALL
SELECT 'VPC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VPC ','99','Outros' FROM DUAL
);

/*-- SEQ 10124 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VPC ',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VPC ',
       '01',
       20,
       77,
       'CONTAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Contato',
       'Contato',
       '',
       'CONTAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPC ',
       '01',
       30,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VPC ',
       '01',
       40,
       4,
       'NUMCON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero Contato',
       'Nmero Contato',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VPC ',
       '01',
       50,
       10,
       'ROWCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha do Contato',
       'Linha do Contato',
       '',
       'ROWCON',
       'F' FROM DUAL
);

/*-- SEQ 10125 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VPE ',
       TO_NUMBER(null),
       'VPE ',
       'Vendas Perdidas',
       'TT_VPE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VPE.CODFIL,VPE.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 10126 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VPE ','--','' FROM DUAL
UNION ALL
SELECT 'VPE ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VPE ','99','Outros' FROM DUAL
);

/*-- SEQ 10127 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 13761,
       'GRA ',
       'VPE ',
       '01',
       'N',
       '',
       '',
       'GRA.FILMAT(+)=VPE.FILMAT AND
GRA.CODMAT(+)=VPE.CODMAT AND
GRA.CODCOR(+)=VPE.CODCOR AND
GRA.CODTAM(+)=VPE.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 13762,
       'USU ',
       'VPE ',
       'N',
       '1',
       '',
       '',
       'USU.FILUSU = VPE.FILVDD AND
USU.CODUSU = VPE.CODVDD',
       '',
       '' FROM DUAL
UNION ALL
SELECT 13763,
       'CLI ',
       'VPE ',
       'N',
       '1',
       '',
       '',
       'CLI.FILCLI = VPE.FILCLI and
CLI.CODCLI = VPE.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 13764,
       'VIPR',
       'VPE ',
       '01',
       'N',
       '',
       '',
       'VPE.FILMAT = VIPR.FILMAT(+) AND VPE.CODMAT = VIPR.CODMAT(+) AND VPE.CODCOR = VIPR.CODCOR(+) AND VPE.CODTAM = VIPR.CODTAM(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 10128 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VPE ',
       '01',
       1,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Cliente',
       'Codigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VPE ',
       '01',
       2,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Diviso do produto',
       'VPE.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'VPE ',
       '01',
       65,
       5,
       'CODCTR',
       'S',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       '',
       'A',
       '',
       'Unidade de Negcio',
       'Unidade de Negcio',
       'DCTR.CODTAB = VPE.CODCTR',
       'CODCTR',
       '' FROM DUAL
UNION ALL
SELECT 'VPE ',
       '01',
       3,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Codigo da Filial',
       'DFIL.CODFIL = VPE.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VPE ',
       '01',
       4,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sub-Diviso do produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPE ',
       '01',
       5,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Codigo do material',
       'VPE.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'VPE ',
       '01',
       6,
       3,
       'CODVDD',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Vendedor',
       'Codigo do Usuario',
       'VPE.FILVDD = USU.FILUSU(+)  AND VPE.CODVDD = USU.CODUSU(+)',
       'CODVDD',
       'T' FROM DUAL
UNION ALL
SELECT 'VPE ',
       '01',
       7,
       5,
       'CODVPE',
       'S',
       'DVPE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DVPE.MOTVPE',
       'V',
       '',
       '',
       'N',
       'F',
       'Motivo',
       'Codigo do motivo da venda perdida',
       'VPE.CODVPE = DVPE.CODTAB(+)',
       'CODVPE',
       'T' FROM DUAL
UNION ALL
SELECT 'VPE ',
       '01',
       8,
       60,
       'COMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Complemento',
       'Nome do produto que no foi vendido (por no existir)',
       '',
       'COMPLE',
       'F' FROM DUAL
UNION ALL
SELECT 'VPE ',
       '01',
       9,
       7,
       'DATVPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data',
       'Data da venda perdida',
       '',
       'DATVPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VPE ',
       '01',
       10,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VPE ',
       '01',
       11,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPE ',
       '01',
       25,
       3,
       'FILPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Pedido',
       '',
       'FILPED',
       'F' FROM DUAL
UNION ALL
SELECT 'VPE ',
       '01',
       12,
       3,
       'FILVDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Vendedor',
       '',
       'FILVDD',
       'F' FROM DUAL
UNION ALL
SELECT 'VPE ',
       '01',
       35,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Pedido',
       'Nmero do Pedido',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'VPE ',
       '01',
       13,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(VPE.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'VPE ',
       '01',
       14,
       12,
       'QTDPER',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Quantidade',
       'Quantidade Perdida',
       '',
       'QTDPER',
       'F' FROM DUAL
UNION ALL
SELECT 'VPE ',
       '01',
       15,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VPE ',
       '01',
       45,
       1,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VPE ',
       '01',
       55,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Pedido',
       'Tipo Pedido',
       '',
       'TIPPED',
       'T' FROM DUAL
);

/*-- SEQ 10129 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VPE ',
       'STATUS',
       0,
       'P',
       'Perdida',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPE ',
       'STATUS',
       0,
       'R',
       'Recuperada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPE ',
       'TIPPED',
       0,
       'O',
       'DAV',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPE ',
       'TIPPED',
       0,
       'P',
       'Pr-Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPE ',
       'TIPPED',
       0,
       'S',
       'DAV-OS',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10130 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VPER',
       TO_NUMBER(null),
       'VPER',
       'Perda',
       'TV_CLI_PER',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VPER.PLANO',
       '' FROM DUAL
);

/*-- SEQ 10131 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VPER','--','' FROM DUAL
UNION ALL
SELECT 'VPER','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VPER','99','Outros' FROM DUAL
);

/*-- SEQ 10132 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 56126,
       'CLI ',
       'VPER',
       '1',
       'N',
       '',
       '',
       'VPER.FILIAL_CLI = CLI.FILCLI AND
VPER.CODIGO_CLI = CLI.CODCLI',
       '',
       '' FROM DUAL
);

/*-- SEQ 10133 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VPER',
       '--',
       190,
       1,
       'ABERTA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Parcela em Aberto?',
       'Parcela em Aberto ou Paga Depois do Perodo',
       '',
       'ABERTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VPER',
       '--',
       180,
       5,
       'CODCTR',
       'S',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       '',
       'N',
       'F',
       'Unidade Negocio',
       'Unidade Negocio',
       'DCTR.CODTAB = VPER.CODCTR',
       'CODCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPER',
       '--',
       10,
       6,
       'CODIGO_CLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Codigo do Cliente',
       'Codigo do Cliente',
       '',
       'CODIGO_CLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VPER',
       '--',
       20,
       15,
       'CPF_CNPJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento (CPF/CNPJ)',
       'Nmero do Documento: CNPJ ou CPF',
       '',
       'CPF_CNPJ',
       'F' FROM DUAL
UNION ALL
SELECT 'VPER',
       '--',
       160,
       7,
       'DATA_FILTRO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Filtro',
       'Data para Filtro',
       '',
       'DATA_FILTRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VPER',
       '--',
       30,
       12,
       'DESCONTOS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Valor Desconto',
       'Valor Desconto',
       '',
       'DESCONTOS',
       'F' FROM DUAL
UNION ALL
SELECT 'VPER',
       '--',
       40,
       13,
       'DOCUMENTO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento (Srie + Ecf + Nmero da Nota )',
       '',
       'DOCUMENTO',
       'F' FROM DUAL
UNION ALL
SELECT 'VPER',
       '--',
       50,
       3,
       'FILIAL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.CODFIL',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VPER.FILIAL',
       'FILIAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VPER',
       '--',
       170,
       3,
       'FILIAL_CLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Cliente',
       'Filial do Cliente',
       '',
       'FILIAL_CLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VPER',
       '--',
       200,
       1,
       'FORNEC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Fornecedor?',
       'Indica se Cliente Tambm  Fornecedor',
       '',
       'FORNEC',
       'F' FROM DUAL
UNION ALL
SELECT 'VPER',
       '--',
       60,
       12,
       'JUROS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Valor Juros',
       'Juros',
       '',
       'JUROS',
       'F' FROM DUAL
UNION ALL
SELECT 'VPER',
       '--',
       70,
       5,
       'NATUREZA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Natureza',
       'Descriao Natureza',
       '',
       'NATUREZA',
       'F' FROM DUAL
UNION ALL
SELECT 'VPER',
       '--',
       80,
       95,
       'NOME_CLIENTE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome/Razo Social',
       'Nome do Cliente',
       '',
       'NOME_CLIENTE',
       'F' FROM DUAL
UNION ALL
SELECT 'VPER',
       '--',
       210,
       7,
       'PAGAME',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Pagamento',
       'Data do Pagamento',
       '',
       'PAGAME',
       'F' FROM DUAL
UNION ALL
SELECT 'VPER',
       '--',
       90,
       12,
       'PAGO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Recebimento
',
       'Recebimento',
       '',
       'PAGO',
       'F' FROM DUAL
UNION ALL
SELECT 'VPER',
       '--',
       100,
       6,
       'PERDA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Perda',
       'Perda',
       '',
       'PERDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VPER',
       '--',
       110,
       10,
       'PLANO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'L',
       '',
       '',
       'A',
       'F',
       'Apelido',
       'Apelido do plano de pagamento',
       '',
       'PLANO',
       'F' FROM DUAL
UNION ALL
SELECT 'VPER',
       '--',
       120,
       2,
       'PR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero Parcela',
       'Nmero Parcela
Nmero Parcela',
       '',
       'PR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPER',
       '--',
       130,
       7,
       'VENCIMENTO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Vencimento',
       'Data Vencimento',
       '',
       'VENCIMENTO',
       'F' FROM DUAL
UNION ALL
SELECT 'VPER',
       '--',
       140,
       12,
       'VENDA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Valor da Venda',
       'Valor da Venda',
       '',
       'VENDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VPER',
       '--',
       150,
       12,
       'VLR PERDA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor da Perda',
       'Valor da Perda',
       '',
       'VENDA-(PAGO-JUROS-DESCONTOS)',
       'F' FROM DUAL
);

/*-- SEQ 10134 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VPES',
       TO_NUMBER(null),
       'VPES',
       'Pessoas',
       'TV_PES',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VPES.FILCLI,VPES.CODCLI',
       '' FROM DUAL
);

/*-- SEQ 10135 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VPES','--','' FROM DUAL
UNION ALL
SELECT 'VPES','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VPES','99','Outros' FROM DUAL
);

/*-- SEQ 10136 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VPES',
       '01',
       10,
       64,
       'BUSCA1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '1 Busca',
       '1 Busca',
       '',
       'BUSCA1',
       'F' FROM DUAL
UNION ALL
SELECT 'VPES',
       '01',
       20,
       30,
       'BUSCA2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '2 Busca',
       '2 Busca',
       '',
       'BUSCA2',
       'F' FROM DUAL
UNION ALL
SELECT 'VPES',
       '01',
       90,
       20,
       'BUSCA3',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '3 Busca',
       '3 Busca',
       '',
       'BUSCA3',
       'F' FROM DUAL
UNION ALL
SELECT 'VPES',
       '01',
       30,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VPES',
       '01',
       40,
       7,
       'DATNAS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Nascimento',
       'Data de Nascimento',
       '',
       'DATNAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VPES',
       '01',
       50,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VPES',
       '01',
       60,
       123,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Cliente',
       'Nome do Cliente',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VPES',
       '01',
       100,
       20,
       'NOMTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome de Tratamento',
       'Nome de Tratamento(Apelido)',
       '',
       'NOMTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'VPES',
       '01',
       70,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Documento (CPF/CGC)',
       'Nmero do Documento: CGC ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VPES',
       '01',
       110,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN VPES.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'VPES',
       '01',
       111,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN VPES.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'VPES',
       '01',
       80,
       30,
       'ULTNOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'timo Nome',
       'ltimo Nome',
       '',
       'ULTNOM',
       'F' FROM DUAL
);

/*-- SEQ 10137 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VPEV',
       TO_NUMBER(null),
       'VPEV',
       'Parcela Evento Venda',
       'TV_PAR_EVE_VEN',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10138 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VPEV','--','' FROM DUAL
UNION ALL
SELECT 'VPEV','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VPEV','02','Dados Gerais' FROM DUAL
UNION ALL
SELECT 'VPEV','03','Funes' FROM DUAL
UNION ALL
SELECT 'VPEV','04','Renegociao' FROM DUAL
UNION ALL
SELECT 'VPEV','05','Parmetos Meio de Pagamento' FROM DUAL
UNION ALL
SELECT 'VPEV','06','Valor Carteira' FROM DUAL
UNION ALL
SELECT 'VPEV','07','A Receber' FROM DUAL
UNION ALL
SELECT 'VPEV','08','Operao Caixa' FROM DUAL
UNION ALL
SELECT 'VPEV','99','Outros' FROM DUAL
);

/*-- SEQ 10139 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VPEV',
       '--',
       20,
       10,
       'APEUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Usurio',
       'Usurio',
       '',
       'APEUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       30,
       1,
       'ATIVO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Ativo?',
       'Ativo(T) se SIGNAT >=0 e Desativo(F) se SIGNAT < 0',
       '',
       'ATIVO',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '02',
       40,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       50,
       15,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Alternativo',
       'Cdigo Alternativo nico',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       60,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL (+) = VPEV.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       70,
       8,
       'CUPFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cupom Fiscal',
       'Cupom fiscal',
       '',
       'CUPFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       80,
       8,
       'DATFATCAR',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Faturam. Carto',
       'Data Faturamento Carto',
       '',
       'DATFATCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '02',
       90,
       7,
       'DATFIS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Fiscal',
       'Data Fiscal',
       '',
       'DATFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       100,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incluso',
       'Data Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '02',
       110,
       8,
       'DATPAGPER',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Pagam. Perdas',
       'Data Pagamento para perda contabil (se aberto considera hoje)',
       '',
       'DATPAGPER',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       120,
       1,
       'DATPAGVEN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Data Pgto~= a Venda?',
       'Data Pgto igual a Venda?',
       '',
       'DATPAGVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '--',
       130,
       7,
       'DATPRE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '@',
       'F',
       'Data prevista',
       'Data prevista',
       '',
       'DATPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       140,
       8,
       'DATPRO',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Promessa',
       'Data Promessa',
       '',
       'DATPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '02',
       150,
       8,
       'DATVEN',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Vencimento',
       'Data de vencimento',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       160,
       20,
       'DESCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Outros Meios Pag.',
       'Outros Meios Pag.',
       '',
       'DESCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       170,
       30,
       'DESCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Conta Corrente',
       'Tipo Conta Corrente',
       '',
       'DESCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       180,
       30,
       'DESCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Portador',
       'Portador',
       '',
       'DESCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       190,
       5,
       'DESMOE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Moeda',
       'Moeda',
       '',
       'DESMOE',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       200,
       20,
       'DESOUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Carto',
       'Carto',
       '',
       'DESOUT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       210,
       35,
       'DESPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Plano',
       'Plano',
       '',
       'DESPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '02',
       220,
       4,
       'DIASATR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Dias em Atraso',
       'Dias em Atraso',
       '',
       'DIASATR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '02',
       230,
       2,
       'DIAS_VENC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Dias Vencimento',
       'Dias Vencimento',
       '',
       'DIAS_VENC',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       240,
       12,
       'DIFPAG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Diferena Pagamento',
       'Diferena Pagamento',
       '',
       'DIFPAG',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '02',
       250,
       8,
       'ESTCAN',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Cancela/Estorno',
       'Data de Cancelamento/Estorno',
       '',
       'ESTCAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '02',
       260,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Filial da Conta',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '--',
       270,
       15,
       'FILIAL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       '',
       'FILIAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '--',
       280,
       15,
       'FILIAL_RECEBIMENTO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Recebimento',
       'Filial Recebimento',
       '',
       'FILIAL_RECEBIMENTO',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '02',
       290,
       3,
       'FILITF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial Item Carto',
       'Filial Item Carto',
       '',
       'FILITF',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       300,
       3,
       'FILREC',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial Recebimento',
       'Cdigo da filial do recebimento',
       'DFIL.CODFIL(+) = VPEV.FILREC',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '--',
       310,
       15,
       'FIL_VENDA_RENEG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Venda Reneg.',
       'Filial Venda Reneg.',
       '',
       'FIL_VENDA_RENEG',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       320,
       30,
       'FLGEST_DOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST_DOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '--',
       330,
       1,
       'FLGFLU',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Proce p/ flux Finan?',
       'Processado pelo fluxo financeiro?',
       '',
       'FLGFLU',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '02',
       340,
       5,
       'ITEITF',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Item Carto',
       'Item Carto',
       '',
       'ITEITF',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '03',
       350,
       12,
       'JURDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Juros~Descontos',
       'Exibe Descontos',
       '',
       'JURDES',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       360,
       250,
       'MEIPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Meio PGTO(Detalhado)',
       'Meio PGTO(Detalhado)',
       '',
       'MEIPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       370,
       20,
       'NOSNUM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nosso nmero',
       'Nosso nmero',
       '',
       'NOSNUM',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       380,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'ECF',
       'Nmero do ECF que recebeu a parcela',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       390,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero~Parcela',
       'Nmero da Parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '08',
       400,
       50,
       'OPER_CAIX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Operao Caixa',
       'Operao Caixa',
       '',
       'OPER_CAIX',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '--',
       410,
       1,
       'ORIREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Origem Recebimento',
       'Origem Recebimento',
       '',
       'ORIREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '02',
       420,
       8,
       'PAGAME',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Pagamento',
       'Data e hora de Pagamento',
       '',
       'PAGAME',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       430,
       50,
       'PAGAMENTO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Pagamento',
       'Pagamento',
       '',
       'PAGAMENTO',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       440,
       5,
       'PARCELA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Parcela',
       'Parcela/Sub-Parcela',
       '',
       'PARCELA',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '02',
       450,
       1,
       'PARCIAL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Parcial?',
       'Parcial?',
       '',
       'PARCIAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '05',
       460,
       1,
       'PROCES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Processados',
       'Processados',
       '',
       'PROCES',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '02',
       470,
       2,
       'RENEGO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Renegociao',
       'Renegociao',
       '',
       'RENEGO',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '02',
       480,
       2,
       'RENORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Origem Renegociao',
       'Origem Renegociao',
       '',
       'RENORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '03',
       490,
       10,
       'SEQCHE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave Cheque',
       'Chave Cheque',
       '',
       'SEQCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '02',
       500,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Sequncia da Conta',
       'Sequncia da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '02',
       510,
       10,
       'SEQITF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Sequen. Item Carto',
       'Sequen. Item Carto',
       '',
       'SEQITF',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '04',
       520,
       10,
       'SEQREN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq. Venda Reneg.',
       'Sequncia da  Venda Renegociada',
       '',
       'SEQREN',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '--',
       530,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '--',
       540,
       2,
       'SUBORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Origem sub parcela',
       'Origem sub parcela',
       '',
       'SUBORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       550,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sub-Parcela',
       'Nmero da sub-parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '01',
       560,
       2,
       'SUBPAR_NUM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Sub-Parcela(Nmero)',
       'Sub-Parcela no formato numrico',
       '',
       'SUBPAR_NUM',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '02',
       570,
       30,
       'TIPCTA_DOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo da Conta',
       'Tipo da Conta',
       '',
       'TIPCTA_DOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '02',
       580,
       2,
       'VENC_DIAS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Vencidas(dias)',
       'Vencida a dias',
       '',
       'VENC_DIAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '02',
       590,
       12,
       'VLRAJU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Ajustado',
       'Valor Ajustado da Parcela',
       '',
       'VLRAJU',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '03',
       600,
       12,
       'VLRCOR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr. Corrigido',
       'Valor Corrigido da Parcela',
       '',
       'VLRCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '03',
       610,
       8,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr. Desconto',
       'Vlr. Desconto',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '03',
       620,
       12,
       'VLRJUR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr. Juros',
       'Vlr. Juros',
       '',
       'VLRJUR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '02',
       630,
       8,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr. Parcela',
       'Valor da parcela',
       '',
       'VLRPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '02',
       640,
       8,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr. Pago',
       'Valor do pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '--',
       650,
       12,
       'VLRPRE',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor previsto',
       'Valor previsto',
       '',
       'VLRPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VPEV',
       '02',
       660,
       14,
       'VLRTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr. Taxas',
       'Valor de Taxas',
       '',
       'VLRTAX',
       'F' FROM DUAL
);

/*-- SEQ 10140 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VPGT',
       TO_NUMBER(null),
       'VPGT',
       'Pagamentos(Todos)',
       'TV_PGT',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VPGT.CODFIL,VPGT.SEQUEN,VPGT.NUMPAR,VPGT.SUBPAR',
       '' FROM DUAL
);

/*-- SEQ 10141 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VPGT','--','' FROM DUAL
UNION ALL
SELECT 'VPGT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VPGT','02','Datas' FROM DUAL
UNION ALL
SELECT 'VPGT','03','Valores' FROM DUAL
UNION ALL
SELECT 'VPGT','99','Outros' FROM DUAL
);

/*-- SEQ 10142 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22072,
       'COM ',
       'VPGT',
       '1',
       'N',
       '',
       '',
       'VPGT.CODFIL = COM.CODFIL(+) AND
VPGT.SEQUEN = COM.SEQUEN(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22073,
       'FCM ',
       'VPGT',
       '1',
       'N',
       '',
       '',
       'VPGT.CODFIL = FCM.CODFIL and VPGT.SEQUEN = FCM.SEQUEN',
       'VPGT.VLRPAR / FCM.VLRTOT',
       '' FROM DUAL
UNION ALL
SELECT 22074,
       'USU ',
       'VPGT',
       'N',
       '1',
       '',
       '',
       'USU.FILUSU = VPGT.FILUSU AND USU.CODUSU = VPGT.CODUSU',
       '',
       '' FROM DUAL
);

/*-- SEQ 10143 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VPGT',
       '02',
       125,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'VPGT',
       120,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VPGT',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(VPGT.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '02',
       35,
       4,
       'ANO_DATPGT',
       'A',
       '',
       0,
       0,
       'VPGT',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VPGT',
       '',
       'N',
       'T',
       'Ano de Pagamento',
       'Ano de Data de pagamento',
       '',
       'TO_CHAR(VPGT.DATPGT,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '02',
       25,
       4,
       'ANO_DATVEN',
       'A',
       '',
       0,
       0,
       'VPGT',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VPGT',
       '',
       'N',
       'T',
       'Ano de Vencimento',
       'Ano de Data de vencimento',
       '',
       'TO_CHAR(VPGT.DATVEN,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '02',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '99',
       280,
       200,
       'AUTBAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cod autenticacao ban',
       'Cdigo completo da autenticao bancria',
       '',
       'AUTBAN',
       '' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '01',
       20,
       3,
       'CODAUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Autorizao',
       'Cdigo Autorizao',
       '',
       'CODAUT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '01',
       30,
       3,
       'CODBCO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cdigo do Banco',
       'Cdigo do Banco',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '01',
       40,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '01',
       50,
       3,
       'CODPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Cdigo do Produto',
       '',
       'CODPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '01',
       60,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'VPGT.FILUSU = USU.FILUSU(+)  AND VPGT.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '01',
       70,
       5,
       'CONPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Conta Pagto.',
       'Conta para lanamento no OF-CASH',
       '',
       'CONPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '02',
       130,
       12,
       'CalcPagAtu',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr. corrigido',
       'Valor corrigido da parcela',
       '',
       'CalcPagAtu(VPGT.CODFIL,VPGT.SEQUEN,VPGT.NUMPAR,VPGT.SUBPAR,0)',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '02',
       270,
       7,
       'DATINC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '02',
       80,
       7,
       'DATPGT',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Pagamento',
       'Data de pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '02',
       90,
       7,
       'DATPRX',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Prximo Vencto',
       'Data do Prximo Vencimento',
       '',
       'DATPRX',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '02',
       100,
       8,
       'DATVEN',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data de Vencimento',
       'Data de Vencimento',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '01',
       110,
       8,
       'DOCPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento Pagamento',
       'Documento Pagamento',
       '',
       'DOCPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '99',
       120,
       1,
       'DUMMY',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       '',
       'Dummy',
       '',
       'DUMMY',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '01',
       130,
       3,
       'FILAUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Autoriazao',
       'Filial Autorizao',
       '',
       'FILAUT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '01',
       140,
       3,
       'FILDOP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Doc. PGTO',
       'Filial Documento Pagamento',
       '',
       'FILDOP',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '01',
       150,
       3,
       'FILPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Produto',
       '',
       'FILPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '01',
       160,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '01',
       170,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Situao(Flag)',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '02',
       123,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'VPGT',
       120,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VPGT',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(VPGT.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '02',
       33,
       2,
       'MES_DATPGT',
       'A',
       '',
       0,
       0,
       'VPGT',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VPGT',
       '',
       'N',
       'T',
       'Ms de Pagamento',
       'Ms de Data de pagamento',
       '',
       'TO_CHAR(VPGT.DATPGT,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '02',
       23,
       2,
       'MES_DATVEN',
       'A',
       '',
       0,
       0,
       'VPGT',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'VPGT',
       '',
       'N',
       'T',
       'Ms de Vencimento',
       'Ms de Data de vencimento',
       '',
       'TO_CHAR(VPGT.DATVEN,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '01',
       45,
       3,
       'NUMCODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '01',
       180,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero de Parcelas',
       'Nmero de Parcelas',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '03',
       265,
       12,
       'PARCELA',
       'A',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Valor Parcela',
       'Parcela',
       '',
       '(VPGT.NUMPAR|| CASE WHEN VPGT.SUBPAR = '' 0'' THEN '''' ELSE ''-'' || TRIM(VPGT.SUBPAR) END) ',
       '' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '01',
       190,
       10,
       'SEQDOP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Documento Pagamento',
       '',
       'SEQDOP',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '01',
       200,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '01',
       210,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN VPGT.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '01',
       211,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN VPGT.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '01',
       220,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Sub Parcela',
       'Sub Parcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '02',
       140,
       250,
       'TRACO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Espao para Anotao',
       'Espao para Anotao',
       '',
       'LPAD(''_'',50,''_'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '03',
       230,
       12,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Desconto',
       'Valor Desconto',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '03',
       240,
       12,
       'VLRDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Saldo',
       'Saldo',
       '',
       'VLRDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '99',
       290,
       12,
       'VLRJUR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Juros Financiamentos',
       'Valor de Juros para Financiamento',
       '',
       'VLRJUR',
       '' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '03',
       250,
       12,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Parcela',
       'Valor Parcela',
       '',
       'VLRPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPGT',
       '03',
       260,
       12,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Pagamento',
       'Valor Pagamento',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 10144 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VPGT',
       'FLGEST',
       0,
       '1',
       'Programado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPGT',
       'FLGEST',
       0,
       '2',
       'Autorizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPGT',
       'FLGEST',
       0,
       'A',
       ' Pagar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPGT',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPGT',
       'FLGEST',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPGT',
       'FLGEST',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10145 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VPP ',
       TO_NUMBER(null),
       'VPP ',
       'Proj. x Proj.',
       'TV_PRJ_PRJ',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VPP.CODFIL,VPP.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 10146 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VPP ','--','' FROM DUAL
UNION ALL
SELECT 'VPP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VPP ','99','Outros' FROM DUAL
);

/*-- SEQ 10147 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VPP ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VPP.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VPP ',
       '01',
       60,
       7,
       'FIMTAR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Fim da Tarefa',
       'Fim da Tarefa',
       '',
       'FIMTAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPP ',
       '01',
       70,
       7,
       'INITAR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       '',
       'Incio da Tarefa',
       '',
       'INITAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPP ',
       '01',
       20,
       12,
       'NIVEL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nvel',
       'Nvel',
       '',
       'NIVEL',
       'F' FROM DUAL
UNION ALL
SELECT 'VPP ',
       '01',
       30,
       25,
       'NOMPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Projeto',
       'Nome do Projeto',
       '',
       'NOMPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'VPP ',
       '01',
       40,
       12,
       'ORDEM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ordem',
       'Ordem',
       '',
       'ORDEM',
       'F' FROM DUAL
UNION ALL
SELECT 'VPP ',
       '01',
       50,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 10148 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VPPC',
       TO_NUMBER(null),
       'VPPC',
       'PRJ x PRJ x CRO',
       'TV_PRJ_PRJ_CRO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10149 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VPPC','--','' FROM DUAL
UNION ALL
SELECT 'VPPC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VPPC','99','Outros' FROM DUAL
);

/*-- SEQ 10150 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VPPC',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VPPC',
       '01',
       70,
       7,
       'FIMTAR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Fim da Tarefa',
       'Fim da Tarefa',
       '',
       'FIMTAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPPC',
       '01',
       80,
       7,
       'INITAR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Incio da Tarefa',
       'Incio da Tarefa',
       '',
       'INITAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPPC',
       '01',
       20,
       12,
       'NIVEL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nvel',
       'Nvel',
       '',
       'NIVEL',
       'F' FROM DUAL
UNION ALL
SELECT 'VPPC',
       '01',
       30,
       25,
       'NOMPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Projeto',
       'Nome do Projeto',
       '',
       'NOMPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'VPPC',
       '01',
       40,
       12,
       'ORDEM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ordem',
       'Ordem',
       '',
       'ORDEM',
       'F' FROM DUAL
UNION ALL
SELECT 'VPPC',
       '01',
       50,
       10,
       'ORIGEM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Origem',
       'Origem',
       '',
       'ORIGEM',
       'F' FROM DUAL
UNION ALL
SELECT 'VPPC',
       '01',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 10151 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VPRC',
       TO_NUMBER(null),
       'VPRC',
       'Preo por Compra',
       'TV_PXC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10152 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VPRC','--','' FROM DUAL
UNION ALL
SELECT 'VPRC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VPRC','02','Valores' FROM DUAL
UNION ALL
SELECT 'VPRC','99','Outros' FROM DUAL
);

/*-- SEQ 10153 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 53102,
       'PRE ',
       'VPRC',
       'N ',
       '1 ',
       '',
       '',
       'PRE.FILPRE = VPRC.FILPRE AND
PRE.SEQUEN = VPRC.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 53103,
       'ICO ',
       'VPRC',
       '1 ',
       '1 ',
       '',
       '',
       'ICO.CODFIL = VPRC.FILICO AND
ICO.SEQUEN = VPRC.SEQICO AND
ICO.NUMITE = VPRC.NUMICO',
       '',
       '' FROM DUAL
);

/*-- SEQ 10154 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VPRC',
       '01',
       10,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       '',
       'N',
       'F',
       'Diviso',
       'Cdigo da diviso',
       'DIV.CODITE (+) = VPRC.CODCOR',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'VPRC',
       '01',
       20,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Material',
       'Cdigo do Material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRC',
       '01',
       30,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       '',
       'N',
       'F',
       'Sub-diviso',
       'Cdigo da Sub-diviso',
       'SUB.CODITE (+) = VPRC.CODTAM',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'VPRC',
       '--',
       70,
       3,
       'FILICO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILICO',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRC',
       '01',
       40,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial do Material',
       'Filial do Material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRC',
       '--',
       80,
       3,
       'FILPRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRC',
       '--',
       90,
       5,
       'NUMICO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NUMICO',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRC',
       '02',
       50,
       12,
       'PREANT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Preo Anterior',
       'Preo de venda anterior ',
       '',
       'PREANT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRC',
       '02',
       60,
       12,
       'PRECOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Preo de Venda',
       'Preo de venda',
       '',
       'PRECOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRC',
       '--',
       100,
       10,
       'SEQICO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQICO',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRC',
       '--',
       110,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 10155 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VPRJ',
       TO_NUMBER(null),
       'VPRJ',
       'Meus Projetos',
       'TV_PRJ',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VPRJ.CODFIL,VPRJ.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 10156 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VPRJ','--','' FROM DUAL
UNION ALL
SELECT 'VPRJ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VPRJ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VPRJ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VPRJ','99','Outros' FROM DUAL
);

/*-- SEQ 10157 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VPRJ',
       '99',
       10,
       4000,
       'ANEXOS',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Anexos',
       'Anexos',
       '',
       'ANEXOS',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '02',
       20,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '99',
       30,
       4000,
       'AVIEXT',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Aviso Externo',
       'Aviso Externo',
       '',
       'AVIEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '99',
       40,
       4000,
       'AVIINT',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Aviso Interno',
       'Aviso Interno',
       '',
       'AVIINT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '99',
       50,
       13,
       'CHVPAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave Pai',
       'Chave Pai',
       '',
       'CHVPAI',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '99',
       60,
       13,
       'CHVPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave Projeto',
       'Chave Projeto',
       '',
       'CHVPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       70,
       7,
       'COBRAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       '9',
       'F',
       'Cobrana',
       'Cobrana',
       '',
       'COBRAR',
       'T' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       80,
       6,
       'CODACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Contato',
       'Cdigo Contato',
       '',
       'CODACT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       90,
       3,
       'CODATU',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Atualizador',
       'Cdigo de Atualizao',
       'VPRJ.FILATU = USU2.FILUSU(+)  AND USU2.CODUSU(+) = VPRJ.CODATU',
       'CODATU',
       'T' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       100,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       110,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       120,
       3,
       'CODREG',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Cdigo Registro',
       'Cdigo Registro',
       'VPRJ.FILREG = USU2.FILUSU(+) AND USU2.CODUSU(+) = VPRJ.CODREG',
       'CODREG',
       'T' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       130,
       3,
       'CODRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Responsvel',
       'Cdigo Responsvel',
       '',
       'CODRES',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       140,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Usurio',
       'Cdigo de Usurio',
       'USU.FILUSU(+) = VPRJ.FILUSU AND USU.CODUSU(+) = VPRJ.CODUSU',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '02',
       150,
       7,
       'DATACT',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Contato',
       'Data Contato',
       '',
       'DATACT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '02',
       160,
       7,
       'DATPRO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Projeto',
       'Data Projeto',
       '',
       'DATPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '02',
       170,
       7,
       'DATREG',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Registro',
       'Data Registro',
       '',
       'DATREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '02',
       180,
       7,
       'DATSOL',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Solicitao',
       'Data Solicitao',
       '',
       'DATSOL',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       190,
       4000,
       'DOCUME',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '99',
       200,
       3,
       'FILACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Contato',
       'Filial Contato',
       '',
       'FILACT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       210,
       3,
       'FILATU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Atualizao',
       'Filial de Atualizao',
       '',
       'FILATU',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       220,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       230,
       3,
       'FILPAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Pai',
       '',
       'FILPAI',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       240,
       3,
       'FILREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Registro',
       'Filial Registro',
       '',
       'FILREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       250,
       3,
       'FILRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Responsvel',
       '',
       'FILRES',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       260,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '02',
       270,
       7,
       'FIMPRJ',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Fim do Projeto',
       'Fim do Projeto',
       '',
       'FIMPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '99',
       280,
       1,
       'FLGACT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag do Contato?',
       'Flag do Contato',
       '',
       'FLGACT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       290,
       10,
       'HORFAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Horas Faltantes',
       'Horas Faltantes',
       '',
       'HORFAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       300,
       10,
       'HORREA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Horas Realizadas',
       'Horas Realizadas',
       '',
       'HORREA',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '02',
       310,
       7,
       'INIPRJ',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Incio do Projeto',
       'Incio do Projeto',
       '',
       'INIPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       320,
       4000,
       'MSGREQ',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem Requisitos',
       'Mensagem Requisitos',
       '',
       'MSGREQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       330,
       25,
       'NOMPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Projeto',
       'Nome do Projeto',
       '',
       'NOMPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       340,
       4,
       'NUMACT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero Contato',
       'Nmero Contato',
       '',
       'NUMACT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       580,
       255,
       'PATDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Caminho Doc.',
       'Caminho Doc.',
       '',
       'PATDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       350,
       1,
       'PRICLI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       '9',
       'F',
       'Prioridade Cliente',
       'Prioridade do Cliente',
       '',
       'PRICLI',
       'T' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       360,
       1,
       'PRIORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       '9',
       'F',
       'Prioridade',
       'Prioridade',
       '',
       'PRIORI',
       'T' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       370,
       1,
       'RESERV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Reservado?',
       'Reservado',
       '',
       'RESERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       380,
       1,
       'RESPON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Responsvel',
       'Responsvel',
       '',
       'RESPON',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       390,
       4000,
       'REVISA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Reviso',
       'Reviso',
       '',
       'REVISA',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       400,
       10,
       'SEQPAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Sequenciador Pai',
       '',
       'SEQPAI',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       410,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '99',
       550,
       1,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao das Tarefas',
       'Situao das Tarefas',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '03',
       420,
       12,
       'SUBVAZ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Sub vazo',
       'Sub Vazo',
       '',
       'SUBVAZ',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       430,
       1,
       'TIPACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Contato',
       'Tipo de Contato',
       '',
       'TIPACT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       570,
       3,
       'TIPFUN',
       'A',
       'DFUN',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFUN.DESFUN',
       'V',
       '',
       '',
       'A',
       'F',
       'Tipo Funcionalidade',
       'Tipo Funcionalidade',
       'DFUN.CODFUN = VPRJ.TIPFUN',
       'TIPFUN',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       440,
       10,
       'TOTA_F',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Em Esperar Cliente',
       'Em Espera pelo Cliente',
       '',
       'TOTA_F',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       450,
       10,
       'TOTA_N',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'No Aceito Cliente',
       'No Aceito pelo Cliente',
       '',
       'TOTA_N',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       460,
       10,
       'TOTA_T',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Aceito pelo Cliente',
       'Aceito pelo Cliente',
       '',
       'TOTA_T',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       470,
       10,
       'TOTW_1',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Revisado e Aprovado',
       'Revisado e Aprovado',
       '',
       'TOTW_1',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       480,
       10,
       'TOTW_2',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Revisado com Erros',
       'Revisado com Erros',
       '',
       'TOTW_2',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       490,
       10,
       'TOTW_A',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Aberto',
       'WorkFlow Aberto',
       '',
       'TOTW_A',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       500,
       10,
       'TOTW_C',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cancelado',
       'WorkFlow Cancelar',
       '',
       'TOTW_C',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       510,
       10,
       'TOTW_E',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Em Espera',
       'WorkFlow Em Espera',
       '',
       'TOTW_E',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       520,
       10,
       'TOTW_I',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'A Integrar',
       'WorkFlow A Integrar',
       '',
       'TOTW_I',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       530,
       10,
       'TOTW_S',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Suspenso',
       'WorkFlow Suspenso',
       '',
       'TOTW_S',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '01',
       540,
       10,
       'TOTW_X',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Executado',
       'WorkFlow Executado',
       '',
       'TOTW_X',
       'F' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       '03',
       560,
       14,
       'VLRCLI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor do Cliente',
       'Valor do Cliente',
       '',
       'VLRCLI',
       'F' FROM DUAL
);

/*-- SEQ 10158 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VPRJ',
       'COBRAR',
       1,
       ' ',
       'A Faturar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       'COBRAR',
       0,
       ' ',
       'A Definir',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       'COBRAR',
       2,
       ' ',
       'Contrato',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       'COBRAR',
       3,
       ' ',
       'Cortesia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       'COBRAR',
       4,
       ' ',
       'Faturado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       'PRICLI',
       3,
       ' ',
       'Baixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       'PRICLI',
       0,
       ' ',
       'Imediato',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       'PRICLI',
       1,
       ' ',
       'Alta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       'PRICLI',
       2,
       ' ',
       'Mdia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       'PRIORI',
       0,
       ' ',
       'Imediato',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       'PRIORI',
       1,
       ' ',
       'Alta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       'PRIORI',
       2,
       ' ',
       'Mdia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       'PRIORI',
       3,
       ' ',
       'Baixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       'STATUS',
       0,
       'A',
       'A projetar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       'STATUS',
       0,
       'F',
       'Finalizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       'STATUS',
       0,
       'L',
       'Planejado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPRJ',
       'STATUS',
       0,
       'P',
       'Pr-Projeto ',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10159 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VPW ',
       TO_NUMBER(null),
       'VPW ',
       'Proj.com WorkF.',
       'TV_PRJ_WOR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VPW.CODFIL,VPW.SEQPRJ',
       '' FROM DUAL
);

/*-- SEQ 10160 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VPW ','--','' FROM DUAL
UNION ALL
SELECT 'VPW ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VPW ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VPW ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VPW ','99','Outros' FROM DUAL
);

/*-- SEQ 10161 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VPW ',
       '01',
       10,
       10,
       'APEUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Apelido Usurio',
       'Apelido Usurio',
       '',
       'APEUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '99',
       20,
       44,
       'APRCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Aprovao Contato',
       'Aprovao Contato',
       '',
       'APRCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '01',
       30,
       7,
       'COBRAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       '9',
       'F',
       'Cobrana',
       'Cobrana',
       '',
       'COBRAR',
       'T' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '01',
       40,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VPW.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '01',
       50,
       3,
       'CODRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Responsvel',
       'Cdigo Responsvel',
       '',
       'CODRES',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '01',
       60,
       6,
       'CODREV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Revisor',
       'Cdigo Revisor',
       '',
       'CODREV',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '01',
       70,
       44,
       'CONTAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Contato',
       'Contato',
       '',
       'CONTAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '02',
       80,
       7,
       'DATACT',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Contato',
       'Data Contato',
       '',
       'DATACT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '02',
       90,
       8,
       'DATREG',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Registro',
       'Data Registro',
       '',
       'DATREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '02',
       100,
       7,
       'DATSOL',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Solicitao',
       'Data Solicitao',
       '',
       'DATSOL',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '01',
       110,
       30,
       'DESJUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Justif.',
       'Descrio Justificativa',
       '',
       'DESJUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '01',
       340,
       255,
       'DESORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio de Origem',
       'Descrio de Origem',
       '',
       'DESORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '01',
       130,
       255,
       'DESTAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo Tarefa',
       'Ttulo da Tarefa',
       '',
       'DESTAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '99',
       140,
       4000,
       'DOCUME',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '01',
       150,
       1,
       'FATURA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Cobrana',
       'Fatura',
       '',
       'FATURA',
       'T' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '01',
       160,
       3,
       'FILPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Projeto',
       '',
       'FILPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '01',
       170,
       3,
       'FILRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Responsvel',
       '',
       'FILRES',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '01',
       180,
       3,
       'FILREV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Revisor',
       '',
       'FILREV',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '02',
       190,
       7,
       'FIMTAR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data fim tarefa',
       'Data Fim Tarefa',
       '',
       'FIMTAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '99',
       200,
       1,
       'FLGACT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag do Contato?',
       'Flag do Contato',
       '',
       'FLGACT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '01',
       210,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '99',
       220,
       255,
       'HIEPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Hierarquia Projeto',
       'Hierarquia do Projeto',
       '',
       'HIEPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '02',
       230,
       7,
       'INITAR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data incio tarefa',
       'Data Incio da Tarefa',
       '',
       'INITAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '01',
       240,
       5,
       'MODULO',
       'N',
       'DMOD',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOD.MODULO',
       'V',
       '',
       'F',
       'N',
       'F',
       'Mdulo',
       'Listagem de mdulos ',
       'DMOD.CODTAB = VPW.MODULO',
       'MODULO',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '01',
       250,
       4,
       'NUMREV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero de Revises',
       'Nmero de Revises',
       '',
       'NUMREV',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '01',
       260,
       4000,
       'REVISA',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Reviso',
       'Descrio da Reviso',
       '',
       'RTF2TXT(REVISA)',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '99',
       270,
       10,
       'SEQPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador do Projeto',
       '',
       'SEQPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '01',
       280,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '01',
       290,
       4000,
       'TAREFA',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Tarefa',
       'Descrio da Tarefa',
       '',
       'RTF2TXT(TAREFA)',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '03',
       300,
       7,
       'TARREA',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horas realizadas',
       'Horas realizadas na tarefa',
       '',
       'TARREA',
       'F' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '01',
       310,
       1,
       'TIPACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo confirmao',
       'Tipo Confirmao',
       '',
       'TIPACT',
       'T' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '01',
       320,
       5,
       'TIPTAR',
       'G',
       'DCWS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       'DCWS.DESCWS',
       'V',
       '',
       'F',
       'A',
       'F',
       'Tipo Tarefa',
       'TIPOS DE TAREFA',
       'VPW.TIPTAR = DCWS.CODTAB AND VPW.TIPCWS = DCWS.TIPCWS',
       'TIPTAR',
       'T' FROM DUAL
UNION ALL
SELECT 'VPW ',
       '01',
       330,
       4,
       'VERATU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Verso Atual',
       'Verso Atual',
       '',
       'VERATU',
       'F' FROM DUAL
);

/*-- SEQ 10162 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VPW ',
       'COBRAR',
       2,
       ' ',
       'Contrato',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'COBRAR',
       3,
       ' ',
       'Cortesia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'COBRAR',
       4,
       ' ',
       'Faturado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'COBRAR',
       0,
       ' ',
       'A Definir',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'COBRAR',
       1,
       ' ',
       'A Faturar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'FATURA',
       0,
       'A',
       'A Faturar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'FATURA',
       0,
       'C',
       'Contrato',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'FATURA',
       0,
       'D',
       'A Definir',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'FATURA',
       0,
       'F',
       'Faturado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'FATURA',
       0,
       'R',
       'Revenda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'FATURA',
       0,
       'S',
       'Cortesia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'FLGEST',
       0,
       'A',
       'Em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'FLGEST',
       0,
       'E',
       'Entregue',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'FLGEST',
       0,
       'I',
       'Inconsistente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'FLGEST',
       0,
       'S',
       'Substitudo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'FLGEST',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'TIPACT',
       0,
       'C',
       'Carta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'TIPACT',
       0,
       'E',
       'E-Mail',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'TIPACT',
       0,
       'F',
       'Fax',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'TIPACT',
       0,
       'M',
       'Mensagem Instantneas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'TIPACT',
       0,
       'S',
       'Site',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'TIPACT',
       0,
       'T',
       'Telefnico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPW ',
       'TIPACT',
       0,
       'V',
       'Verbal',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10163 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VPXC',
       TO_NUMBER(null),
       'VPXC',
       'Projetos X Clientes',
       'TV_PRJ_CLI',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10164 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VPXC','--','' FROM DUAL
UNION ALL
SELECT 'VPXC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VPXC','02','Datas' FROM DUAL
UNION ALL
SELECT 'VPXC','99','Outros' FROM DUAL
);

/*-- SEQ 10165 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VPXC',
       '01',
       10,
       4000,
       'ANEXOS',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Anexos',
       'Anexos',
       '',
       'ANEXOS',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '01',
       20,
       10,
       'APERES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Apelido Responsvel',
       'Apelido Responsvel',
       '',
       'APERES',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '01',
       30,
       7,
       'COBRAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       '9',
       'F',
       'Cobrana',
       'Cobrana',
       '',
       'COBRAR',
       'T' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '01',
       40,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VPXC.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '01',
       50,
       3,
       'CODRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Responsvel',
       'Cdigo Responsvel',
       '',
       'CODRES',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '01',
       60,
       44,
       'CONTAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Contato',
       'Contato',
       '',
       'CONTAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '02',
       70,
       7,
       'DATACT',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Contato',
       'Data Contato',
       '',
       'DATACT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '02',
       80,
       7,
       'DATSOL',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Solicitao',
       'Data Solicitao',
       '',
       'DATSOL',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '01',
       90,
       4000,
       'DOCUME',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '01',
       100,
       3,
       'FILRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Responsvel',
       '',
       'FILRES',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '02',
       110,
       7,
       'FIMPRJ',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Fim do Projeto',
       'Fim do Projeto',
       '',
       'FIMPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '02',
       120,
       7,
       'FIMTAR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data fim tarefa',
       'Data Fim Tarefa',
       '',
       'FIMTAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '99',
       130,
       1,
       'FLGACT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag do Contato?',
       'Flag do Contato',
       '',
       'FLGACT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '01',
       140,
       4000,
       'HIEPRJ',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Hierarquia Projeto',
       'Hierarquia do Projeto',
       '',
       'RTF2TXT(HIEPRJ)',
       '' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '02',
       150,
       7,
       'INIPRJ',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Incio do Projeto',
       'Incio do Projeto',
       '',
       'INIPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '02',
       160,
       7,
       'INITAR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data incio tarefa',
       'Data Incio da Tarefa',
       '',
       'INITAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '01',
       170,
       4000,
       'MSGREQ',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem Requisitos',
       'Mensagem Requisitos',
       '',
       'MSGREQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '01',
       180,
       12,
       'NIVEL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nvel',
       'Nvel',
       '',
       'NIVEL',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '01',
       190,
       25,
       'NOMPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Projeto',
       'Nome do Projeto',
       '',
       'NOMPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '01',
       200,
       12,
       'ORDEM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ordem',
       'Ordem',
       '',
       'ORDEM',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '01',
       210,
       1,
       'PRICLI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Prioridade Cliente',
       'Prioridade do Cliente',
       '',
       'PRICLI',
       'T' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '01',
       220,
       1,
       'RESPON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Responsvel',
       'Responsvel',
       '',
       'RESPON',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '01',
       230,
       4000,
       'REVISA',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Reviso',
       'Descrio da Reviso',
       '',
       'RTF2TXT(REVISA)',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '01',
       240,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '99',
       250,
       1,
       'STATUS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Status?',
       'Status?',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXC',
       '01',
       260,
       1,
       'TIPACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo confirmao',
       'Tipo de Contato',
       '',
       'TIPACT',
       'T' FROM DUAL
);

/*-- SEQ 10166 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VPXC',
       'COBRAR',
       2,
       ' ',
       'Contrato',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXC',
       'COBRAR',
       3,
       ' ',
       'Cortesia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXC',
       'COBRAR',
       4,
       ' ',
       'Faturado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXC',
       'COBRAR',
       0,
       ' ',
       'A Definir',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXC',
       'COBRAR',
       1,
       ' ',
       'A Faturar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXC',
       'PRICLI',
       3,
       ' ',
       'Baixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXC',
       'PRICLI',
       0,
       ' ',
       'Imediato',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXC',
       'PRICLI',
       1,
       ' ',
       'Alta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXC',
       'PRICLI',
       2,
       ' ',
       'Mdia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXC',
       'TIPACT',
       0,
       'C',
       'Carta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXC',
       'TIPACT',
       0,
       'E',
       'E-Mail',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXC',
       'TIPACT',
       0,
       'F',
       'Fax',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXC',
       'TIPACT',
       0,
       'M',
       'Mensagem Instantneas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXC',
       'TIPACT',
       0,
       'S',
       'Site',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXC',
       'TIPACT',
       0,
       'T',
       'Telefnico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXC',
       'TIPACT',
       0,
       'V',
       'Verbal',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10167 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VPXW',
       TO_NUMBER(null),
       'VPXW',
       'Proj. x WorkF.',
       'TV_PRJXWOR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VPXW.CODFIL,VPXW.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 10168 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VPXW','--','' FROM DUAL
UNION ALL
SELECT 'VPXW','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VPXW','02','Datas' FROM DUAL
UNION ALL
SELECT 'VPXW','03','Valores' FROM DUAL
UNION ALL
SELECT 'VPXW','99','Outros' FROM DUAL
);

/*-- SEQ 10169 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VPXW',
       '99',
       10,
       4000,
       'ANEXOS',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Anexos',
       'Anexos',
       '',
       'ANEXOS',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '03',
       20,
       7,
       'COBRAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       '9',
       'F',
       'Cobrana',
       'Cobrana',
       '',
       'COBRAR',
       'T' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '01',
       30,
       6,
       'CODACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Contato',
       'Cdigo Contato',
       '',
       'CODACT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '01',
       40,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VPXW.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '01',
       50,
       44,
       'CONTAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Contato',
       'Contato',
       '',
       'CONTAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '02',
       60,
       7,
       'DATACT',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Contato',
       'Data Contato',
       '',
       'DATACT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '02',
       70,
       7,
       'DATSOL',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Solicitao',
       'Data Solicitao',
       '',
       'DATSOL',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '99',
       80,
       4000,
       'DOCUME',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '01',
       90,
       3,
       'FILACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Contato',
       'Filial Contato',
       '',
       'FILACT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '01',
       100,
       3,
       'FILPAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Pai',
       '',
       'FILPAI',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '02',
       110,
       7,
       'FIMTAR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data fim tarefa',
       'Data Fim Tarefa',
       '',
       'FIMTAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '99',
       120,
       1,
       'FLGACT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag do Contato?',
       'Flag do Contato',
       '',
       'FLGACT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '02',
       130,
       7,
       'INITAR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data incio tarefa',
       'Data Incio da Tarefa',
       '',
       'INITAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '99',
       140,
       4000,
       'MSGREQ',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem Requisitos',
       'Mensagem Requisitos',
       '',
       'MSGREQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '01',
       150,
       25,
       'NOMPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do Projeto',
       'Nome do Projeto',
       '',
       'NOMPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '01',
       160,
       4,
       'NUMACT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero Contato',
       'Nmero Contato',
       '',
       'NUMACT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '01',
       170,
       1,
       'PRICLI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Prioridade Cliente',
       'Prioridade do Cliente',
       '',
       'PRICLI',
       'T' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '99',
       180,
       1,
       'RESERV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Reservado?',
       'Reservado',
       '',
       'RESERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '01',
       190,
       1,
       'RESPON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Responsvel',
       'Responsvel',
       '',
       'RESPON',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '99',
       200,
       4000,
       'REVISA',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Reviso',
       'Reviso',
       '',
       'REVISA',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '99',
       210,
       10,
       'SEQPAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Sequenciador Pai',
       '',
       'SEQPAI',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '99',
       220,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '01',
       230,
       12,
       'SITUAC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'SITUAC',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '99',
       240,
       117,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'STATUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '01',
       250,
       1,
       'TIPACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Contato',
       'Tipo de Contato',
       '',
       'TIPACT',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '03',
       260,
       12,
       'TMPEXE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tempo Realizao',
       'Tempo efetivamente realizado',
       '',
       'TMPEXE',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '03',
       270,
       12,
       'TMPPRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tempo Previsto',
       'Tempo previsto originalmente',
       '',
       'TMPPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VPXW',
       '03',
       280,
       12,
       'TMPREV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tempo Prev.Corrigido',
       'Tempo previsto corrigido (nova projecao) ',
       '',
       'TMPREV',
       'F' FROM DUAL
);

/*-- SEQ 10170 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VPXW',
       'COBRAR',
       1,
       ' ',
       'A Faturar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXW',
       'COBRAR',
       0,
       ' ',
       'A Definir',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXW',
       'COBRAR',
       2,
       ' ',
       'Contrato',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXW',
       'COBRAR',
       3,
       ' ',
       'Cortesia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXW',
       'COBRAR',
       4,
       ' ',
       'Faturado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXW',
       'PRICLI',
       0,
       ' ',
       'Imediato',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXW',
       'PRICLI',
       2,
       ' ',
       'Mdia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXW',
       'PRICLI',
       3,
       ' ',
       'Baixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VPXW',
       'PRICLI',
       1,
       ' ',
       'Alta',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10171 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VR1 ',
       TO_NUMBER(null),
       'VR1 ',
       'Restries 001',
       'TV_RES_001',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10172 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VR1 ','--','' FROM DUAL
UNION ALL
SELECT 'VR1 ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VR1 ','99','Outros' FROM DUAL
);

/*-- SEQ 10173 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VR1 ',
       '01',
       10,
       12,
       'DIVIDA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dvida',
       'Dvida',
       '',
       'DIVIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VR1 ',
       '01',
       20,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'VR1 ',
       '01',
       30,
       12,
       'LIMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'LIMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VR1 ',
       '01',
       40,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VR1 ',
       '01',
       50,
       12,
       'OCORRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ocorrncia',
       'Ocorrncia',
       '',
       'OCORRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VR1 ',
       '01',
       60,
       17,
       'RESTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Restrio',
       'Restrio',
       '',
       'RESTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'VR1 ',
       '01',
       70,
       1,
       'TIPRES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Tipo de Restrio',
       'Tipo de Restrio',
       '',
       'TIPRES',
       'T' FROM DUAL
);

/*-- SEQ 10174 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VR1 ',
       'FLGTIP',
       0,
       '-',
       'Fsica',
       154,
       ' ' FROM DUAL
UNION ALL
SELECT 'VR1 ',
       'FLGTIP',
       1,
       '-',
       'Jurdica',
       155,
       ' ' FROM DUAL
UNION ALL
SELECT 'VR1 ',
       'FLGTIP',
       2,
       '-',
       'Entidade',
       156,
       ' ' FROM DUAL
UNION ALL
SELECT 'VR1 ',
       'FLGTIP',
       3,
       '-',
       'Especial',
       157,
       ' ' FROM DUAL
UNION ALL
SELECT 'VR1 ',
       'FLGTIP',
       4,
       '-',
       'M.E.',
       158,
       ' ' FROM DUAL
UNION ALL
SELECT 'VR1 ',
       'FLGTIP',
       5,
       '-',
       'Filial',
       159,
       ' ' FROM DUAL
);

/*-- SEQ 10175 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VR2 ',
       TO_NUMBER(null),
       'VR2 ',
       'Restries 002',
       'TV_RES_002',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10176 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VR2 ','--','' FROM DUAL
UNION ALL
SELECT 'VR2 ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VR2 ','99','Outros' FROM DUAL
);

/*-- SEQ 10177 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VR2 ',
       '01',
       10,
       12,
       'DIVIDA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dvida',
       'Dvida',
       '',
       'DIVIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VR2 ',
       '01',
       20,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'VR2 ',
       '01',
       30,
       12,
       'LIMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'LIMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VR2 ',
       '01',
       40,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VR2 ',
       '01',
       50,
       12,
       'OCORRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ocorrncia',
       'Ocorrncia',
       '',
       'OCORRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VR2 ',
       '01',
       60,
       17,
       'RESTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Restrio',
       'Restrio',
       '',
       'RESTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'VR2 ',
       '01',
       70,
       1,
       'TIPRES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Tipo de Restrio',
       'Tipo de Restrio',
       '',
       'TIPRES',
       'T' FROM DUAL
);

/*-- SEQ 10178 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VR2 ',
       'FLGTIP',
       0,
       '-',
       'Fsica',
       154,
       ' ' FROM DUAL
UNION ALL
SELECT 'VR2 ',
       'FLGTIP',
       1,
       '-',
       'Jurdica',
       155,
       ' ' FROM DUAL
UNION ALL
SELECT 'VR2 ',
       'FLGTIP',
       2,
       '-',
       'Entidade',
       156,
       ' ' FROM DUAL
UNION ALL
SELECT 'VR2 ',
       'FLGTIP',
       3,
       '-',
       'Especial',
       157,
       ' ' FROM DUAL
UNION ALL
SELECT 'VR2 ',
       'FLGTIP',
       4,
       '-',
       'M.E.',
       158,
       ' ' FROM DUAL
UNION ALL
SELECT 'VR2 ',
       'FLGTIP',
       5,
       '-',
       'Filial',
       159,
       ' ' FROM DUAL
);

/*-- SEQ 10179 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VR3 ',
       TO_NUMBER(null),
       'VR3 ',
       'Restries 003',
       'TV_RES_003',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10180 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VR3 ','--','' FROM DUAL
UNION ALL
SELECT 'VR3 ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VR3 ','99','Outros' FROM DUAL
);

/*-- SEQ 10181 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VR3 ',
       '01',
       10,
       12,
       'DIVIDA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dvida',
       'Dvida',
       '',
       'DIVIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VR3 ',
       '01',
       20,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'VR3 ',
       '01',
       30,
       12,
       'LIMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'LIMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VR3 ',
       '01',
       40,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VR3 ',
       '01',
       50,
       12,
       'OCORRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ocorrncia',
       'Ocorrncia',
       '',
       'OCORRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VR3 ',
       '01',
       60,
       17,
       'RESTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Restrio',
       'Restrio',
       '',
       'RESTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'VR3 ',
       '01',
       70,
       1,
       'TIPRES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Tipo de Restrio',
       'Tipo de Restrio',
       '',
       'TIPRES',
       'T' FROM DUAL
);

/*-- SEQ 10182 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VR3 ',
       'FLGTIP',
       0,
       '-',
       'Fsica',
       154,
       ' ' FROM DUAL
UNION ALL
SELECT 'VR3 ',
       'FLGTIP',
       1,
       '-',
       'Jurdica',
       155,
       ' ' FROM DUAL
UNION ALL
SELECT 'VR3 ',
       'FLGTIP',
       2,
       '-',
       'Entidade',
       156,
       ' ' FROM DUAL
UNION ALL
SELECT 'VR3 ',
       'FLGTIP',
       3,
       '-',
       'Especial',
       157,
       ' ' FROM DUAL
UNION ALL
SELECT 'VR3 ',
       'FLGTIP',
       4,
       '-',
       'M.E.',
       158,
       ' ' FROM DUAL
UNION ALL
SELECT 'VR3 ',
       'FLGTIP',
       5,
       '-',
       'Filial',
       159,
       ' ' FROM DUAL
);

/*-- SEQ 10183 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VR4 ',
       TO_NUMBER(null),
       'VR4 ',
       'Restries 004',
       'TV_RES_004',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10184 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VR4 ','--','' FROM DUAL
UNION ALL
SELECT 'VR4 ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VR4 ','99','Outros' FROM DUAL
);

/*-- SEQ 10185 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VR4 ',
       '01',
       10,
       12,
       'DIVIDA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dvida',
       'Dvida',
       '',
       'DIVIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VR4 ',
       '01',
       20,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'VR4 ',
       '01',
       30,
       12,
       'LIMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'LIMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VR4 ',
       '01',
       40,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VR4 ',
       '01',
       50,
       12,
       'OCORRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ocorrncia',
       'Ocorrncia',
       '',
       'OCORRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VR4 ',
       '01',
       60,
       17,
       'RESTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Restrio',
       'Restrio',
       '',
       'RESTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'VR4 ',
       '01',
       70,
       1,
       'TIPRES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Tipo de Restrio',
       'Tipo de Restrio',
       '',
       'TIPRES',
       'T' FROM DUAL
);

/*-- SEQ 10186 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VR4 ',
       'FLGTIP',
       0,
       '-',
       'Fsica',
       154,
       ' ' FROM DUAL
UNION ALL
SELECT 'VR4 ',
       'FLGTIP',
       1,
       '-',
       'Jurdica',
       155,
       ' ' FROM DUAL
UNION ALL
SELECT 'VR4 ',
       'FLGTIP',
       2,
       '-',
       'Entidade',
       156,
       ' ' FROM DUAL
UNION ALL
SELECT 'VR4 ',
       'FLGTIP',
       3,
       '-',
       'Especial',
       157,
       ' ' FROM DUAL
UNION ALL
SELECT 'VR4 ',
       'FLGTIP',
       4,
       '-',
       'M.E.',
       158,
       ' ' FROM DUAL
UNION ALL
SELECT 'VR4 ',
       'FLGTIP',
       5,
       '-',
       'Filial',
       159,
       ' ' FROM DUAL
);

/*-- SEQ 10187 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VRC ',
       TO_NUMBER(null),
       'VRC ',
       'Res. x Cai.',
       'TV_RES_CAI',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VRC.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 10188 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VRC ','--','' FROM DUAL
UNION ALL
SELECT 'VRC ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VRC ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VRC ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VRC ','99','Outros' FROM DUAL
);

/*-- SEQ 10189 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VRC ',
       '01',
       10,
       10,
       'APEUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Apelido Usurio',
       'Apelido Usurio',
       '',
       'APEUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VRC ',
       '01',
       20,
       6,
       'ARQCAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Arquivo Caixa',
       'Arquivo Caixa',
       '',
       'ARQCAI',
       'F' FROM DUAL
UNION ALL
SELECT 'VRC ',
       '01',
       30,
       254,
       'ARQXLS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Arquivo Caixa EXCEL',
       'Arquivo Caixa Excel',
       '',
       'ARQXLS',
       'F' FROM DUAL
UNION ALL
SELECT 'VRC ',
       '01',
       40,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = VRC.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VRC ',
       '01',
       50,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'VRC.FILUSU = USU.FILUSU(+)  AND VRC.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VRC ',
       '03',
       60,
       6,
       'CUPFIM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cupom~Final',
       'Cupom Final',
       '',
       'CUPFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VRC ',
       '03',
       70,
       6,
       'CUPINI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cupom~Inicial',
       'Cupom Inicial',
       '',
       'CUPINI',
       'F' FROM DUAL
UNION ALL
SELECT 'VRC ',
       '02',
       80,
       7,
       'DATABE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Abertura',
       'Data Abertura',
       '',
       'DATABE',
       'F' FROM DUAL
UNION ALL
SELECT 'VRC ',
       '02',
       90,
       7,
       'DATFEC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fechamento',
       'Data Fechamento',
       '',
       'DATFEC',
       'F' FROM DUAL
UNION ALL
SELECT 'VRC ',
       '02',
       100,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operacao',
       'Data Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VRC ',
       '02',
       110,
       10,
       'DATREL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Data Relatrio',
       'Data Relatrio',
       '',
       'DATREL',
       'F' FROM DUAL
UNION ALL
SELECT 'VRC ',
       '99',
       120,
       1,
       'EXPAND',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Expande?',
       'Expande?',
       '',
       'EXPAND',
       'F' FROM DUAL
UNION ALL
SELECT 'VRC ',
       '01',
       130,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VRC ',
       '01',
       140,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'ECF',
       'Nmero do ECF',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'VRC ',
       '01',
       150,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VRC ',
       '03',
       160,
       12,
       'VLRDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Diferenca',
       'Valor Diferena',
       '',
       'VLRDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'VRC ',
       '03',
       170,
       12,
       'VLRFEC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Fechamento',
       'Valor Fechamento',
       '',
       'VLRFEC',
       'F' FROM DUAL
);

/*-- SEQ 10190 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VRCL',
       TO_NUMBER(null),
       'VRCL',
       'RAD. CLI.',
       'TV_RAD_CLI',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10191 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VRCL','--','' FROM DUAL
UNION ALL
SELECT 'VRCL','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VRCL','99','Outros' FROM DUAL
);

/*-- SEQ 10192 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VRCL',
       '--',
       10,
       249,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
);

/*-- SEQ 10193 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VRCO',
       TO_NUMBER(null),
       'VRCO',
       'RAD. COM.',
       'TV_RAD_COM',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10194 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VRCO','--','' FROM DUAL
UNION ALL
SELECT 'VRCO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VRCO','03','Valores' FROM DUAL
UNION ALL
SELECT 'VRCO','99','Outros' FROM DUAL
);

/*-- SEQ 10195 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VRCO',
       '03',
       10,
       12,
       'BASICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base de ICMS',
       'Base de ICMS',
       '',
       'BASICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '03',
       20,
       12,
       'BASINT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base Int.',
       'Base Int.',
       '',
       'BASINT',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '03',
       30,
       12,
       'BASIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Base IPI',
       'Base IPI',
       '',
       'BASIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '01',
       40,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '01',
       50,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Fornecedor',
       'Cdigo Fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '01',
       60,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       'F',
       'A',
       'F',
       'Srie',
       'Cdigo da srie',
       'VRCO.CODSER=DSER.CODSER (+)',
       'CODSER',
       'T' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '01',
       70,
       7,
       'DATAOK',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data OK',
       'Data OK',
       '',
       'DATAOK',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '03',
       80,
       12,
       'DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Desconto',
       'Desconto',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '01',
       90,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '01',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '03',
       110,
       12,
       'ICMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% ICMS',
       'ICMS por Item',
       '',
       'ICMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '03',
       120,
       12,
       'IPIITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% IPI',
       'IPI por Item',
       '',
       'IPIITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '03',
       130,
       12,
       'ISEIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Iseno de IPI',
       'Iseno de IPI',
       '',
       'ISEIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '01',
       140,
       2,
       'MODNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mod.~Nota',
       'Mod.~Nota',
       '',
       'MODNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '01',
       150,
       12,
       'NATURE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Natureza',
       'Natureza',
       '',
       'NATURE',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '01',
       160,
       8,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero da Nota',
       'Nmero da Nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '03',
       170,
       12,
       'OUTIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Sada de IPI',
       'Sada de IPI',
       '',
       'OUTIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '03',
       180,
       12,
       'OUTRAS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Outras',
       'Outras',
       '',
       'OUTRAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '01',
       190,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '01',
       200,
       3,
       'SEREXP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie~como',
       'Srie~como',
       '',
       'SEREXP',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '01',
       210,
       2,
       'SUBEXP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'SubSrie~como',
       'SubSrie~como',
       '',
       'SUBEXP',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '01',
       220,
       3,
       'SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Sub-Srie',
       'Sub-Srie de compra',
       '',
       'SUBSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '01',
       230,
       1,
       'TIPNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Documento',
       'Tipo de Documento',
       '',
       'TIPNOT',
       'T' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '01',
       240,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Parceiro',
       'Tipo de Parceiro',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '01',
       250,
       2,
       'UFNOTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF da Nota',
       'UF da Nota',
       '',
       'UFNOTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '03',
       260,
       8,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'ICMS do Item',
       'Valor do ICMS do item da compra',
       '',
       'VLRICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '03',
       270,
       12,
       'VLRIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor IPI',
       'Valor IPI',
       '',
       'VLRIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '03',
       280,
       12,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Lquido',
       'Valor Lquido',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '03',
       290,
       12,
       'VLRSUB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Sub Srie',
       'Valor Sub Srie',
       '',
       'VLRSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCO',
       '03',
       300,
       12,
       'VLRTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Total',
       'Valor Total
',
       '',
       'VLRTOT',
       'F' FROM DUAL
);

/*-- SEQ 10196 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VRCO',
       'TIPNOT',
       0,
       'A',
       'N.F.F.',
       276,
       ' ' FROM DUAL
UNION ALL
SELECT 'VRCO',
       'TIPNOT',
       0,
       'F',
       'Fatura',
       274,
       ' ' FROM DUAL
UNION ALL
SELECT 'VRCO',
       'TIPNOT',
       0,
       'N',
       'Nota Fiscal',
       275,
       ' ' FROM DUAL
UNION ALL
SELECT 'VRCO',
       'TIPPAR',
       0,
       'F',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRCO',
       'TIPPAR',
       0,
       'T',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10197 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VRCP',
       TO_NUMBER(null),
       'VRCP',
       'Recuperao',
       'TV_CLI_REC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10198 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VRCP','--','' FROM DUAL
UNION ALL
SELECT 'VRCP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VRCP','99','Outros' FROM DUAL
);

/*-- SEQ 10199 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23245,
       'CLI ',
       'VRCP',
       '1',
       'N',
       '',
       '',
       'VRCP.FILIAL = CLI.FILCLI AND
VRCP.CODIGO_CLI = CLI.CODCLI',
       '',
       '' FROM DUAL
);

/*-- SEQ 10200 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VRCP',
       '--',
       10,
       15,
       'CGC_CNPJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento (CGC/CNPJ)',
       'Nmero do Documento: CNPJ ou CGC',
       '',
       'CGC_CNPJ',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCP',
       '--',
       160,
       5,
       'CODCTR',
       'S',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       '',
       'N',
       '',
       'Unidade de Negcios',
       'Unidade de Negcios',
       'DCTR.CODTAB = VRCP.CODCTR',
       'CODCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCP',
       '--',
       140,
       6,
       'CODIGO_CLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Codigo do Cliente',
       'Codigo do Cliente',
       '',
       'CODIGO_CLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCP',
       '--',
       150,
       7,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Filtro',
       'Data para Filtro',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCP',
       '--',
       20,
       12,
       'DESCONTOS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Valor Desconto',
       'Descontos',
       '',
       'DESCONTOS',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCP',
       '--',
       170,
       30,
       'DESCTR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Desc. Unid. Negcio',
       'Descrio da Unidade de Negcios',
       '',
       'DESCTR',
       '' FROM DUAL
UNION ALL
SELECT 'VRCP',
       '--',
       30,
       13,
       'DOCUMENTO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento (Srie + Ecf + Nmero da Nota )',
       '',
       'DOCUMENTO',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCP',
       '--',
       40,
       3,
       'FILIAL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.CODFIL',
       'I',
       '',
       '',
       'A',
       'F',
       'Cdigo da Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VRCP.FILIAL',
       'FILIAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCP',
       '--',
       50,
       12,
       'JUROS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Valor Juros',
       'Juros',
       '',
       'JUROS',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCP',
       '--',
       180,
       1,
       'LANVEN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Considera Venda?',
       'Considera Venda?',
       '',
       'LANVEN',
       '' FROM DUAL
UNION ALL
SELECT 'VRCP',
       '--',
       60,
       95,
       'NOME_CLIENTE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome/Razo Social',
       'Nome do Cliente',
       '',
       'NOME_CLIENTE',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCP',
       '--',
       70,
       7,
       'PAGAMENTO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'PAGAMENTO',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCP',
       '--',
       80,
       12,
       'PAGO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Recebimento',
       'Recebimento',
       '',
       'PAGO',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCP',
       '--',
       90,
       2,
       'PR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero Parcela',
       'Nmero Parcela',
       '',
       'PR',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCP',
       '--',
       100,
       12,
       'RECUPERAVEL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Recupervel',
       'Recupervel',
       '',
       'RECUPERAVEL',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCP',
       '--',
       91,
       2,
       'SP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Nmero Subparcela',
       'Nmero Subparcela',
       '',
       'SP',
       '' FROM DUAL
UNION ALL
SELECT 'VRCP',
       '--',
       110,
       6,
       'TRIM_PERDA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Perda',
       'Perda',
       '',
       'TRIM_PERDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCP',
       '--',
       120,
       6,
       'TRIM_RECUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Recuperao',
       'Recuperao',
       '',
       'TRIM_RECUP',
       'F' FROM DUAL
UNION ALL
SELECT 'VRCP',
       '--',
       130,
       7,
       'VENCIMENTO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Vencimento',
       'Data Vencimento',
       '',
       'VENCIMENTO',
       'F' FROM DUAL
);

/*-- SEQ 10201 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VRE ',
       TO_NUMBER(null),
       'VRE ',
       'Res. Ext.',
       'TV_RES_EXT',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VRE.CODEXT',
       '' FROM DUAL
);

/*-- SEQ 10202 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VRE ','--','' FROM DUAL
UNION ALL
SELECT 'VRE ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VRE ','99','Outros' FROM DUAL
);

/*-- SEQ 10203 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VRE ',
       '01',
       10,
       20,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'VRE ',
       '01',
       20,
       30,
       'MOTIVO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Motivo',
       'Motivo',
       '',
       'MOTIVO',
       'F' FROM DUAL
UNION ALL
SELECT 'VRE ',
       '01',
       30,
       1,
       'STATUS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Status?',
       'Status(Ativo ou Desativo)',
       '',
       'STATUS',
       'F' FROM DUAL
);

/*-- SEQ 10204 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VREC',
       TO_NUMBER(null),
       'VREC',
       'Consol. Recebimentos',
       'TV_CONREC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10205 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VREC','--','' FROM DUAL
UNION ALL
SELECT 'VREC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VREC','02','Datas' FROM DUAL
UNION ALL
SELECT 'VREC','03','Valores' FROM DUAL
UNION ALL
SELECT 'VREC','99','Outros' FROM DUAL
);

/*-- SEQ 10206 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 38801,
       'CLI ',
       'VREC',
       '1 ',
       'N ',
       '',
       '',
       'CLI.FILCLI = VREC.FILCLI AND
CLI.CODCLI = VREC.CODCLI',
       '' FROM DUAL
UNION ALL
SELECT 38802,
       'CCRE',
       'VREC',
       '1 ',
       'N ',
       '',
       '',
       'VREC.FILGER = CCRE.CODFIL AND 
VREC.SEQGER = CCRE.SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 38803,
       'CDEB',
       'VREC',
       '1 ',
       'N ',
       '',
       '',
       'VREC.FILNUM = CDEB.CODFIL AND 
VREC.SEQNUM = CDEB.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 10207 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VREC',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VREC',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Cdigo da Filial',
       '',
       'DFIL.CODFIL =  VREC.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VREC',
       '02',
       30,
       7,
       'COMPET',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Competncia',
       'Data Competncia',
       '',
       'COMPET',
       'F' FROM DUAL
UNION ALL
SELECT 'VREC',
       '02',
       40,
       7,
       'DATPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Pagamento',
       'Data Pagamento',
       '',
       'DATPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VREC',
       '02',
       50,
       7,
       'DATVEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Vencimento',
       'Data Vencimento',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VREC',
       '01',
       60,
       27,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VREC',
       '01',
       70,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VREC',
       '01',
       80,
       3,
       'FILGER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILGER',
       'F' FROM DUAL
UNION ALL
SELECT 'VREC',
       '01',
       90,
       3,
       'FILNUM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILNUM',
       'F' FROM DUAL
UNION ALL
SELECT 'VREC',
       '01',
       100,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Cdigo da Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VREC',
       '01',
       110,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Parcela',
       'Nmero Parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VREC',
       '01',
       120,
       10,
       'SEQGER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQGER',
       'F' FROM DUAL
UNION ALL
SELECT 'VREC',
       '01',
       130,
       10,
       'SEQNUM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQNUM',
       'F' FROM DUAL
UNION ALL
SELECT 'VREC',
       '01',
       140,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VREC',
       '01',
       150,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Subparcela',
       'Subparcela',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VREC',
       '01',
       160,
       3,
       'TABORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Origem',
       'Origem',
       '',
       'TABORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VREC',
       '01',
       170,
       1,
       'TIPGER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPGER',
       'F' FROM DUAL
UNION ALL
SELECT 'VREC',
       '01',
       180,
       1,
       'TIPNUM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPNUM',
       'F' FROM DUAL
UNION ALL
SELECT 'VREC',
       '01',
       190,
       25,
       'TIPREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VREC',
       '03',
       220,
       12,
       'VLRDES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Valor Desconto',
       'Valor Desconto',
       '',
       'VLRDES',
       '' FROM DUAL
UNION ALL
SELECT 'VREC',
       '03',
       210,
       12,
       'VLRPGT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Pago',
       'Valor Pago',
       '',
       'VLRPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VREC',
       '03',
       230,
       12,
       'VLRTAX',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       '',
       'Valor Taxa',
       'Valor Taxa',
       '',
       'VLRTAX',
       '' FROM DUAL
);

/*-- SEQ 10208 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VREC',
       'TABORI',
       0,
       ' ',
       'Carto',
       TO_NUMBER(null),
       'TEF' FROM DUAL
UNION ALL
SELECT 'VREC',
       'TABORI',
       0,
       ' ',
       'Cheque',
       TO_NUMBER(null),
       'CHR' FROM DUAL
UNION ALL
SELECT 'VREC',
       'TABORI',
       0,
       ' ',
       'Ttulos Recebidos',
       TO_NUMBER(null),
       'PTR' FROM DUAL
UNION ALL
SELECT 'VREC',
       'TABORI',
       0,
       ' ',
       'Parcela',
       TO_NUMBER(null),
       'REC' FROM DUAL
);

/*-- SEQ 10209 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VREF',
       TO_NUMBER(null),
       'VREF',
       'Resumo Financeiro',
       'TV_RESU_FINA',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10210 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VREF','--','' FROM DUAL
UNION ALL
SELECT 'VREF','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VREF','99','Outros' FROM DUAL
);

/*-- SEQ 10211 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 118829,
       'CLI ',
       'VREF',
       '1',
       'N',
       '',
       '',
       'CLI.FILCLI = VREF.FILCLI AND
CLI.CODCLI = VREF.CODCLI',
       '',
       '' FROM DUAL
);

/*-- SEQ 10212 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'VREF',
       '--',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       260,
       20,
       'DATCRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Analise de Crdito',
       'Data da ltima Analise de Crdito',
       '',
       'DATCRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       30,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial do Cliente',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       220,
       8,
       'LIMCHE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Limite de Cheque',
       'Limite de Cheque',
       '',
       'LIMCHE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       40,
       4,
       'MAIATR',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Maior atraso',
       'Maior atraso registrado',
       '',
       'MAIATR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       50,
       4,
       'MEDATR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Atraso Mdio',
       'Atraso Mdio',
       '',
       'MEDATR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       60,
       8,
       'RFC_VLRAVE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor a vencer',
       'Valor a vencer',
       '',
       'RFC_VLRAVE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       70,
       8,
       'RFC_VLRCAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Rec. Carto a baixar',
       'Valor Carto',
       '',
       'RFC_VLRCAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       80,
       8,
       'RFC_VLRCCC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Saldo Conta Corrente',
       'Saldo Conta Corrente',
       '',
       'RFC_VLRCCC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       90,
       8,
       'RFC_VLRCCH',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Rec. Carto e Cheque',
       'Valor Carto e Cheques',
       '',
       'RFC_VLRCCH',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       100,
       8,
       'RFC_VLRCHE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Rec. Cheque a comp.',
       'Valor Cheques',
       '',
       'RFC_VLRCHE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       110,
       8,
       'RFC_VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor recebido',
       'Valor pago pelo fornecedor',
       '',
       'RFC_VLRPGT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       120,
       8,
       'RFC_VLRVEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor vencido',
       'Valor vencido no recebido',
       '',
       'RFC_VLRVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       130,
       8,
       'RFF_VLRAVE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor a vencer',
       'Valor a vencer',
       '',
       'RFF_VLRAVE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       140,
       8,
       'RFF_VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor pago',
       'Valor pago ao fornecedor',
       '',
       'RFF_VLRPGT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       150,
       8,
       'RFF_VLRVEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor vencido',
       'Valor vencido e no pago',
       '',
       'RFF_VLRVEN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       160,
       4,
       'TOTATR',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Total de Atrasos',
       'Total de atrasos na vida do cliente',
       '',
       'TOTATR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       170,
       4,
       'TOTPAR',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Total Geral Parcelas',
       'Total de parcelas na vida do cliente',
       '',
       'TOTPAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       180,
       8,
       'ULTCOM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'ltima Compra',
       'Data da ltima compra',
       '',
       'ULTCOM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       190,
       10,
       'ULTCOMFORMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'ltima Compra Carac.',
       'Data da ltima compra como Caractere',
       '',
       'ULTCOMFORMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       250,
       10,
       'VALLIM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Val. Limite Crdito',
       'Validade do Limite de Crdito',
       '',
       'VALLIM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       200,
       8,
       'VALOR1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'VALOR1',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       210,
       8,
       'VLRSAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Total Geral',
       'Total Geral',
       '',
       'VLRSAL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       230,
       8,
       'VLRSALLIM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Saldo Lim. Crdito',
       'Saldo do Limite de Crdito',
       '',
       'VLRSALLIM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VREF',
       '--',
       240,
       8,
       'VLRSALLIMCHE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Saldo Lim. Cheque',
       'Saldo do Limite de Cheque',
       '',
       'VLRSALLIMCHE',
       '',
       'D' FROM DUAL
);

/*-- SEQ 10213 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VREG',
       TO_NUMBER(null),
       'VREG',
       'Origem Renegociao',
       'TV_VEN_ORI_RENEGOCIACAO',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10214 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VREG','--','' FROM DUAL
UNION ALL
SELECT 'VREG','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VREG','02','Renegociao' FROM DUAL
UNION ALL
SELECT 'VREG','03','Origem' FROM DUAL
UNION ALL
SELECT 'VREG','99','Outros' FROM DUAL
);

/*-- SEQ 10215 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 90200,
       'CLI ',
       'VREG',
       '0N',
       '1',
       '',
       '',
       'VREG.FILCLI_REN = CLI.FILCLI AND
VREG.CODCLI_REN = CLI.CODCLI',
       '',
       '' FROM DUAL
);

/*-- SEQ 10216 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VREG',
       '--',
       221,
       6,
       'CODCLI_REN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI_REN',
       '' FROM DUAL
UNION ALL
SELECT 'VREG',
       '03',
       71,
       3,
       'CODFIL_ORI',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Venda Origem',
       'FIlial da Venda Original',
       'DFIL.CODFIL = VREG.CODFIL_ORI',
       'CODFIL_ORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VREG',
       '02',
       11,
       3,
       'CODFIL_REN',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       '0',
       '',
       'Filial Renegociao',
       'Filial da Renegociao',
       'DFIL.CODFIL = VREG.CODFIL_REN',
       'CODFIL_REN',
       'F' FROM DUAL
UNION ALL
SELECT 'VREG',
       '03',
       131,
       2,
       'CODSER_ORI',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       '',
       'Srie Venda Origem',
       'Srie da Venda Original',
       'DSER.CODSER = VREG.CODSER_ORI',
       'CODSER_ORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VREG',
       '02',
       40,
       2,
       'CODSER_REN',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       '',
       'A',
       '',
       'Srie Renegociao',
       'Srie da Renegociao',
       'DSER.CODSER = VREG.CODSER_REN',
       'CODSER_REN',
       'F' FROM DUAL
UNION ALL
SELECT 'VREG',
       '03',
       181,
       10,
       'CODVEN_ORI',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'A',
       '',
       'Vendedor Origem',
       'Vendedor Original',
       'VREG.FILVEN_ORI = USU.FILUSU(+)  AND VREG.CODVEN_ORI = USU.CODUSU(+)',
       'CODVEN_ORI',
       'T' FROM DUAL
UNION ALL
SELECT 'VREG',
       '02',
       81,
       3,
       'CODVEN_REN',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       '',
       'A',
       '',
       'Vendedor Reneg.',
       'Vendedor da Renegociao',
       'VREG.FILVEN_REN = USU.FILUSU(+)  AND VREG.CODVEN_REN = USU.CODUSU(+)',
       'CODVEN_REN',
       'T' FROM DUAL
UNION ALL
SELECT 'VREG',
       '03',
       120,
       8,
       'DATHOR_ORI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Venda Origem',
       'Data da Venda Original',
       '',
       'DATHOR_ORI',
       '' FROM DUAL
UNION ALL
SELECT 'VREG',
       '02',
       30,
       8,
       'DATHOR_REN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Renegociao',
       'Data da Renegociao',
       '',
       'DATHOR_REN',
       '' FROM DUAL
UNION ALL
SELECT 'VREG',
       '03',
       151,
       20,
       'DOCUME_ORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Doc. Venda Origem',
       'Documento da Venda Original',
       '',
       '(CASE COALESCE(VREG.NUMNOT_ORI,''0'') WHEN ''0'' THEN NULL ELSE VREG.CODSER_ORI||''/''||LTRIM(VREG.NUMECF_ORI)||''-''||LTRIM(VREG.NUMNOT_ORI) END)',
       '' FROM DUAL
UNION ALL
SELECT 'VREG',
       '02',
       61,
       20,
       'DOCUME_REN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Doc. Renegociao',
       'Documento da Renegociao',
       '',
       '(CASE COALESCE(VREG.NUMNOT_REN,''0'') WHEN ''0'' THEN NULL ELSE VREG.CODSER_REN||''/''||LTRIM(VREG.NUMECF_REN)||''-''||LTRIM(VREG.NUMNOT_REN) END)',
       '' FROM DUAL
UNION ALL
SELECT 'VREG',
       '--',
       211,
       3,
       'FILCLI_REN',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial do Cliente',
       'Filial do Cliente',
       'DFIL.CODFIL = VREG.FILCLI_REN',
       'FILCLI_REN',
       'F' FROM DUAL
UNION ALL
SELECT 'VREG',
       '03',
       240,
       1,
       'FLGEST_ORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Sit. Parcela Origem',
       'Situao da Parcela da Venda Original',
       '',
       'FLGEST_ORI',
       'T' FROM DUAL
UNION ALL
SELECT 'VREG',
       '03',
       270,
       100,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome Cliente',
       'Nome Cliente',
       '',
       'NOMCLI',
       '' FROM DUAL
UNION ALL
SELECT 'VREG',
       '03',
       140,
       3,
       'NUMECF_ORI',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       '',
       'ECF Venda Origem',
       'ECF da Venda Original',
       'DECF.FILECF = VREG.CODFIL_ORI AND DECF.NUMECF = VREG.NUMECF_ORI',
       'NUMECF_ORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VREG',
       '02',
       50,
       3,
       'NUMECF_REN',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       '',
       'ECF Renegociao',
       'ECF da Renegociao',
       'DECF.FILECF = VREG.CODFIL_REN AND DECF.NUMECF = VREG.NUMECF_REN',
       'NUMECF_REN',
       'F' FROM DUAL
UNION ALL
SELECT 'VREG',
       '03',
       150,
       6,
       'NUMNOT_ORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Nmero Venda Origem',
       'Nmero da Venda Original',
       '',
       'NUMNOT_ORI',
       '' FROM DUAL
UNION ALL
SELECT 'VREG',
       '02',
       60,
       6,
       'NUMNOT_REN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Nmero Renegociao',
       'Nmero da Nota da Renegociao',
       '',
       'NUMNOT_REN',
       '' FROM DUAL
UNION ALL
SELECT 'VREG',
       '03',
       230,
       2,
       'NUMPAR_ORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Nm. Parcela Origem',
       'Nmero da Parcela da Venda Original',
       '',
       'NUMPAR_ORI',
       '' FROM DUAL
UNION ALL
SELECT 'VREG',
       '03',
       110,
       10,
       'SEQUEN_ORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq. Venda Origem',
       'Sequenciador da Venda Original',
       '',
       'SEQUEN_ORI',
       '' FROM DUAL
UNION ALL
SELECT 'VREG',
       '02',
       20,
       10,
       'SEQUEN_REN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Seq. Renegociao',
       'Sequenciador da Renegociao',
       '',
       'SEQUEN_REN',
       '' FROM DUAL
UNION ALL
SELECT 'VREG',
       '03',
       180,
       12,
       'VLRLIQ_ORI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Venda Origem',
       'Valor da Venda Original',
       '',
       'VLRLIQ_ORI',
       '' FROM DUAL
UNION ALL
SELECT 'VREG',
       '02',
       90,
       12,
       'VLRLIQ_REN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Renegociao',
       'Valor Renegociao',
       '',
       'VLRLIQ_REN',
       '' FROM DUAL
UNION ALL
SELECT 'VREG',
       '03',
       250,
       12,
       'VLRPAR_ORI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Parcela Origem',
       'Valor da Parcela da Venda Original',
       '',
       'VLRPAR_ORI',
       '' FROM DUAL
UNION ALL
SELECT 'VREG',
       '03',
       260,
       12,
       'VLRPGT_ORI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Pago Origem',
       'Valor Pago da Parcela da Venda Original',
       '',
       'VLRPGT_ORI',
       '' FROM DUAL
);

/*-- SEQ 10217 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VREG',
       'FLGEST_ORI',
       0,
       'A',
       'Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VREG',
       'FLGEST_ORI',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VREG',
       'FLGEST_ORI',
       0,
       'P',
       'Pago',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VREG',
       'FLGEST_ORI',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10218 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VREN',
       TO_NUMBER(null),
       'VREN',
       'Parcela Renegociada',
       'TV_REN',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10219 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VREN','--','' FROM DUAL
UNION ALL
SELECT 'VREN','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VREN','02','Datas' FROM DUAL
UNION ALL
SELECT 'VREN','03','Valores' FROM DUAL
UNION ALL
SELECT 'VREN','99','Outros' FROM DUAL
);

/*-- SEQ 10220 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 43387,
       'VEN ',
       'VREN',
       '1 ',
       'N ',
       '',
       '',
       'VREN.CODFIL = VEN.CODFIL AND VREN.SEQUEN = VEN.SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 43390,
       'CLI ',
       'VREN',
       '1 ',
       '1 ',
       '',
       '',
       'VREN.FILCLI = CLI.FILCLI AND VREN.CODCLI = CLI.CODCLI',
       '' FROM DUAL
);

/*-- SEQ 10221 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VREN',
       '01',
       10,
       12,
       'A_VENC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Parcelas a Vencer',
       'Parcelas a Vencer',
       '',
       'A_VENC',
       'F' FROM DUAL
UNION ALL
SELECT 'VREN',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VREN.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VREN',
       '01',
       30,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'VREN.FILUSU = USU.FILUSU(+)  and VREN.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VREN',
       '01',
       40,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VREN',
       '02',
       50,
       7,
       'PAGAME',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Renegociao',
       'Renegociao',
       '',
       'PAGAME',
       'F' FROM DUAL
UNION ALL
SELECT 'VREN',
       '01',
       60,
       10,
       'PRZFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Novo Prazo',
       'Novo Prazo',
       '',
       'PRZFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VREN',
       '01',
       70,
       2,
       'RENEGO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Nmero',
       'Nmero',
       '',
       'RENEGO',
       'F' FROM DUAL
UNION ALL
SELECT 'VREN',
       '01',
       80,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VREN',
       '01',
       90,
       12,
       'TOTATR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Dias em Atraso',
       'Dias em Atraso',
       '',
       'TOTATR',
       'F' FROM DUAL
UNION ALL
SELECT 'VREN',
       '01',
       100,
       12,
       'TOTFIM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Novo Nm.Parcelas',
       'Novo Nmero de Parcelas',
       '',
       'TOTFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VREN',
       '01',
       110,
       12,
       'VENCID',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Parcelas Vencidas',
       'Parcelas Vencidas',
       '',
       'VENCID',
       'F' FROM DUAL
UNION ALL
SELECT 'VREN',
       '03',
       120,
       12,
       'VLRENT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor de Entrada',
       'Valor de Entrada',
       '',
       'VLRENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VREN',
       '03',
       130,
       12,
       'VLRFIM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Novo Valor',
       'Novo Valor',
       '',
       'VLRFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VREN',
       '03',
       140,
       12,
       'VLRREG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Renegociado',
       'Valor Renegociado',
       '',
       'VLRREG',
       'F' FROM DUAL
);

/*-- SEQ 10222 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VRES',
       TO_NUMBER(null),
       'VRES',
       'Restries Clientes',
       'TV_RES',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10223 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VRES','--','' FROM DUAL
UNION ALL
SELECT 'VRES','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VRES','99','Outros' FROM DUAL
);

/*-- SEQ 10224 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VRES',
       '01',
       10,
       12,
       'DIVIDA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dvida',
       'Dvida',
       '',
       'DIVIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VRES',
       '01',
       20,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       '9',
       'F',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'VRES',
       '01',
       30,
       12,
       'LIMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'LIMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VRES',
       '01',
       40,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VRES',
       '01',
       50,
       12,
       'OCORRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ocorrncia',
       'Ocorrncia',
       '',
       'OCORRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VRES',
       '01',
       60,
       17,
       'RESTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Restrio',
       'Restrio',
       '',
       'RESTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'VRES',
       '01',
       70,
       1,
       'TIPRES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'N',
       'F',
       'Tipo de Restrio',
       'Tipo de Restrio',
       '',
       'TIPRES',
       'T' FROM DUAL
);

/*-- SEQ 10225 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VRES',
       'FLGTIP',
       0,
       '-',
       'Fsica',
       154,
       ' ' FROM DUAL
UNION ALL
SELECT 'VRES',
       'FLGTIP',
       1,
       '-',
       'Jurdica',
       155,
       ' ' FROM DUAL
UNION ALL
SELECT 'VRES',
       'FLGTIP',
       2,
       '-',
       'Entidade',
       156,
       ' ' FROM DUAL
UNION ALL
SELECT 'VRES',
       'FLGTIP',
       3,
       '-',
       'Especial',
       157,
       ' ' FROM DUAL
UNION ALL
SELECT 'VRES',
       'FLGTIP',
       4,
       '-',
       'M.E.',
       158,
       ' ' FROM DUAL
UNION ALL
SELECT 'VRES',
       'FLGTIP',
       5,
       '-',
       'Filial',
       159,
       ' ' FROM DUAL
UNION ALL
SELECT 'VRES',
       'TIPRES',
       4,
       ' ',
       'CHEQUES TERCEIROS DEVOLVIDOS',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRES',
       'TIPRES',
       6,
       ' ',
       'CONSTA NO SPC',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRES',
       'TIPRES',
       5,
       ' ',
       'CLIENTE REGISTRADO NO SPC',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRES',
       'TIPRES',
       7,
       ' ',
       'TITULOS EM ATRASO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRES',
       'TIPRES',
       3,
       ' ',
       'CLIENTE COM PARCELAS EM ATRASO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRES',
       'TIPRES',
       1,
       ' ',
       'LIMITE DE CRDITO',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRES',
       'TIPRES',
       2,
       ' ',
       'CNPJ/CPF TEM CHEQUE DEVOLVIDOS',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10226 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VRFO',
       TO_NUMBER(null),
       'VRFO',
       'RAD. FOR.',
       'TV_RAD_FOR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10227 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VRFO','--','' FROM DUAL
UNION ALL
SELECT 'VRFO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VRFO','99','Outros' FROM DUAL
);

/*-- SEQ 10228 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VRFO',
       '--',
       10,
       269,
       'LINHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Linha',
       'Linha',
       '',
       'LINHA',
       'F' FROM DUAL
);

/*-- SEQ 10229 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VRSV',
       TO_NUMBER(null),
       'VRSV',
       'Itens em Reserva',
       'TV_RESERVA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10230 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VRSV','--','' FROM DUAL
UNION ALL
SELECT 'VRSV','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VRSV','99','Outros' FROM DUAL
);

/*-- SEQ 10231 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 29755,
       'VIPR',
       'VRSV',
       '1',
       '1',
       '',
       '',
       'VRSV.FILMAT = VIPR.FILMAT AND
VRSV.CODMAT = VIPR.CODMAT AND
VRSV.CODCOR = VIPR.CODCOR AND
VRSV.CODTAM = VIPR.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 10232 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VRSV',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL = VRSV.CODFIL',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'VRSV',
       '99',
       60,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data',
       'Data da Venda/Oramento',
       '',
       'DATOPE',
       '' FROM DUAL
UNION ALL
SELECT 'VRSV',
       '01',
       30,
       40,
       'DESTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Tipo de Reserva',
       'Descrio do tipo de lanamento',
       '',
       'DESTIP',
       '' FROM DUAL
UNION ALL
SELECT 'VRSV',
       '01',
       40,
       94,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome Cliente',
       'Nome cliente',
       '',
       'NOMCLI',
       '' FROM DUAL
UNION ALL
SELECT 'VRSV',
       '01',
       20,
       13,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Documento',
       'Nmero do Documento(venda ou oramento)',
       '',
       'NUMDOC',
       '' FROM DUAL
UNION ALL
SELECT 'VRSV',
       '--',
       50,
       12,
       'QTDITE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Quantidade',
       'Quantidade Reservada',
       '',
       'QTDITE',
       '' FROM DUAL
);

/*-- SEQ 10233 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VRT ',
       TO_NUMBER(null),
       'VRT ',
       'Retorno NFe',
       'TT_VRT',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VRT.CODFIL,
VRT.SEQUEN
',
       '' FROM DUAL
);

/*-- SEQ 10234 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VRT ','--','' FROM DUAL
UNION ALL
SELECT 'VRT ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VRT ','02','Status' FROM DUAL
UNION ALL
SELECT 'VRT ','03','Venda' FROM DUAL
UNION ALL
SELECT 'VRT ','99','Outros' FROM DUAL
);

/*-- SEQ 10235 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VRT ',
       '99',
       140,
       44,
       'CHAVEA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Chv. acesso da NF-e',
       'Chave de acesso da NF-e',
       '',
       'CHAVEA',
       '' FROM DUAL
UNION ALL
SELECT 'VRT ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '0',
       '',
       'Filial ',
       'Filial ',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'VRT ',
       '99',
       90,
       10,
       'CODINU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cod. de Inutilizao',
       'Cdigo de Inutilizao',
       '',
       'CODINU',
       '' FROM DUAL
UNION ALL
SELECT 'VRT ',
       '03',
       160,
       5,
       'CROVEN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Contador da Operao',
       'Contador de Reincio de Operao',
       '',
       'CROVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VRT ',
       '99',
       120,
       10,
       'DATRET',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'D',
       '',
       'Data do Retorno',
       'Data do Retorno',
       '',
       'DATRET',
       '' FROM DUAL
UNION ALL
SELECT 'VRT ',
       '03',
       170,
       3,
       'ECFVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'ECF da Venda',
       'ECF da Venda',
       '',
       'ECFVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VRT ',
       '03',
       180,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial da Venda',
       'Filial da Venda',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VRT ',
       '02',
       60,
       1,
       'FLGCAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Status Cancelamento',
       'Status de Cancelamento',
       '',
       'FLGCAN',
       'T' FROM DUAL
UNION ALL
SELECT 'VRT ',
       '02',
       50,
       1,
       'FLGENV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Status de Envio',
       'Status de Envio',
       '',
       'FLGENV',
       'T' FROM DUAL
UNION ALL
SELECT 'VRT ',
       '02',
       80,
       1,
       'FLGIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Status de Impresso',
       'Status de Impresso',
       '',
       'FLGIMP',
       'T' FROM DUAL
UNION ALL
SELECT 'VRT ',
       '02',
       70,
       1,
       'FLGINU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Status Inutilizao',
       'Status de Inutilizao',
       '',
       'FLGINU',
       'T' FROM DUAL
UNION ALL
SELECT 'VRT ',
       '02',
       85,
       1,
       'FLGSTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Status Verif. Status',
       'Status de Verificao de Status',
       '',
       'FLGSTA',
       'T' FROM DUAL
UNION ALL
SELECT 'VRT ',
       '99',
       40,
       1,
       'FLGTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo de Retorno',
       'Tipo de Retorno',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'VRT ',
       '02',
       150,
       4000,
       'MOTRET',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       '',
       'Motivo do Status',
       'Motivo do Status',
       '',
       'RTF2TXT(MOTRET)',
       '' FROM DUAL
UNION ALL
SELECT 'VRT ',
       '03',
       190,
       6,
       'NOTVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nm. Nota da Venda',
       'Nmero da Nota da Venda',
       '',
       'NOTVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VRT ',
       '99',
       110,
       9,
       'NUMIMP',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Num. de Contigncia',
       'Nmero de Contigncia',
       '',
       'NUMIMP',
       '' FROM DUAL
UNION ALL
SELECT 'VRT ',
       '99',
       130,
       15,
       'PROTOC',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Num Protocolo SEFAZ',
       'Nmero do protocolo emitido pela SEFAZ',
       '',
       'PROTOC',
       '' FROM DUAL
UNION ALL
SELECT 'VRT ',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'VRT ',
       '99',
       100,
       3,
       'SERIMP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Srie de Contigncia',
       'Srie de Contigncia',
       '',
       'SERIMP',
       '' FROM DUAL
UNION ALL
SELECT 'VRT ',
       '03',
       200,
       2,
       'SERVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie da Venda',
       'Srie da Venda',
       '',
       'SERVEN',
       'F' FROM DUAL
);

/*-- SEQ 10236 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VRT ',
       'FLGCAN',
       0,
       '2',
       'Cancelamento Rejeitado ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGCAN',
       0,
       '3',
       'NF-e Cancelada ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGCAN',
       0,
       '5',
       'Solicitao no env. p/ SEFAZ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGCAN',
       0,
       '8',
       'Erro de importao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGCAN',
       0,
       '9',
       'No processado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGENV',
       0,
       '1',
       'NF-e Autorizada ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGENV',
       0,
       '2',
       'NF-e Rejeitada ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGENV',
       0,
       '5',
       'Solicitao no env. p/ SEFAZ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGENV',
       0,
       '6',
       'NF-e Denegada ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGENV',
       0,
       '7',
       'NF-e em processamento na SEFAZ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGENV',
       0,
       '8',
       'Erro de importao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGIMP',
       0,
       '0',
       'No impresso ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGIMP',
       0,
       '1',
       'Impresso normal ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGIMP',
       0,
       '2',
       'Impresso em contingncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGIMP',
       0,
       '9',
       'No processado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGINU',
       0,
       '2',
       'Inutilizao Rejeitada ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGINU',
       0,
       '4',
       'Faixa de Numerao Inutilizada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGINU',
       0,
       '5',
       'Solicitao no env. p/ SEFAZ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGINU',
       0,
       '8',
       'Erro de importao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGINU',
       0,
       '9',
       'No processado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGSTA',
       0,
       '1',
       'NF-e Autorizada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGSTA',
       0,
       '2',
       'NF-e Rejeitada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGSTA',
       0,
       '3',
       'NF-e Cancelada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGSTA',
       0,
       '5',
       'Solicitao no env. p/ SEFAZ',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGSTA',
       0,
       '6',
       'NF-e Denegada',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGSTA',
       0,
       '8',
       'Erro de importao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGSTA',
       0,
       '9',
       'NF-e aguardando verif. status',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGTIP',
       0,
       'C',
       'Cancelamento',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGTIP',
       0,
       'E',
       'Envio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGTIP',
       0,
       'I',
       'Inutilizao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGTIP',
       0,
       'P',
       'Impresso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRT ',
       'FLGTIP',
       0,
       'S',
       'Status',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10237 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VRV ',
       TO_NUMBER(null),
       'VRV ',
       'RAD. x VEN.',
       'TV_RAD_VEN',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'vrv.codfil,vrv.sequen',
       '' FROM DUAL
);

/*-- SEQ 10238 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VRV ','--','' FROM DUAL
UNION ALL
SELECT 'VRV ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VRV ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VRV ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VRV ','99','Outros' FROM DUAL
);

/*-- SEQ 10239 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VRV ',
       '03',
       10,
       12,
       'BASICM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Base de ICMS',
       'Base de ICMS',
       '',
       'BASICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '03',
       20,
       12,
       'BASINT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Base Int.',
       'Base Int.',
       '',
       'BASINT',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '03',
       30,
       4,
       'CNT_RZ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nm. Oper. Reduo Z',
       'Nmero Operao Reduo Z',
       '',
       'CNT_RZ',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '01',
       40,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '01',
       50,
       3,
       'CODECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do ECF',
       'Filial do ECF',
       '',
       'CODECF',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '01',
       60,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '01',
       70,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       'F',
       'A',
       'F',
       'Srie',
       'Cdigo da srie',
       'VRV.CODSER=DSER.CODSER (+)',
       'CODSER',
       'T' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '01',
       80,
       6,
       'CUPFIM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cupom~Final',
       'Cupom Final',
       '',
       'CUPFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '01',
       90,
       6,
       'CUPINI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cupom~Inicial',
       'Cupom Inicial',
       '',
       'CUPINI',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '02',
       100,
       7,
       'DATAOK',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data OK',
       'Data OK',
       '',
       'DATAOK',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '02',
       110,
       7,
       'DATECF',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Emisso C.F.',
       'Data Emisso C.F.',
       '',
       'DATECF',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '01',
       120,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'T' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '99',
       130,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '03',
       140,
       16,
       'GT_FIM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Grande Total Final',
       'Grande Total Final',
       '',
       'GT_FIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '03',
       150,
       16,
       'GT_INI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Grande Total Inicial',
       'Grande Total Inicial',
       '',
       'GT_INI',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '01',
       160,
       2,
       'MODNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mod.~Nota',
       'Mod.~Nota',
       '',
       'MODNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '01',
       170,
       3,
       'NATDEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo no estado',
       'Natureza quando dentro do estado',
       '',
       'NATDEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '01',
       180,
       3,
       'NATFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo fora do est.',
       'Natureza quando fora do estado',
       '',
       'NATFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '01',
       190,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero do Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '01',
       200,
       3,
       'NUMECF',
       'A',
       'DECF',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '''ECF '' || DECF.NUMECF || '' (FILIAL '' || DECF.FILECF || '')''',
       'V',
       '',
       '',
       '0',
       'F',
       'Nmero do ECF',
       'Nmero do ECF',
       'DECF.FILECF = VRV.CODFIL AND DECF.NUMECF = VRV.NUMECF',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '01',
       210,
       12,
       'NUMNOT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero da Nota',
       'Nmero da Nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '99',
       220,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '03',
       230,
       12,
       'OUTRAS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Outras Rendas',
       'Outras Rendas',
       '',
       'OUTRAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '03',
       240,
       12,
       'PERICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% de ICMS',
       '% de ICMS',
       '',
       'PERICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '02',
       250,
       8,
       'PROPGT',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Prox. Pagamento',
       'Data prximo pagamento ou data do cancelamento',
       '',
       'PROPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '99',
       260,
       3,
       'RECECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Rec. ECF',
       'Rec. ECF',
       '',
       'RECECF',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '03',
       270,
       12,
       'REDTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Reduo Total',
       'Reduo Total
',
       '',
       'REDTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '99',
       280,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '01',
       290,
       3,
       'SEREXP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Srie~como',
       'Srie~como',
       '',
       'SEREXP',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '01',
       300,
       2,
       'SIGEST',
       'A',
       'DEST',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DEST.ESTADO',
       'V',
       '',
       '',
       'A',
       'F',
       'UF',
       'UF',
       'DEST.ESTADO = VRV.SIGEST',
       'SIGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '01',
       310,
       2,
       'TIPPRO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Produto',
       'Tipo de Produto',
       '',
       'TIPPRO',
       'T' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '01',
       320,
       2,
       'UFFILIAL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF da Filial',
       'UF da Filial',
       '',
       'UFFILIAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '99',
       330,
       1,
       'UFLOJA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'F',
       'Dentro do Estado?',
       'Venda Dentro do Estado?',
       '',
       'UFLOJA',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '03',
       340,
       12,
       'VLRCAN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Cancelamento',
       'Valor Cancelamento',
       '',
       'VLRCAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '03',
       350,
       12,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Desconto',
       'Valor Desconto',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '03',
       360,
       8,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'ICMS do Item',
       'Valor do ICMS do item da compra',
       '',
       'VLRICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '03',
       370,
       12,
       'VLRISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor ISS',
       'Valor ISS',
       '',
       'VLRISS',
       'F' FROM DUAL
UNION ALL
SELECT 'VRV ',
       '03',
       380,
       12,
       'VLRNOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor da Nota',
       'Valor da Nota',
       '',
       'VLRNOT',
       'F' FROM DUAL
);

/*-- SEQ 10240 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VRV ',
       'TIPPRO',
       0,
       ' ',
       'Material',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRV ',
       'TIPPRO',
       1,
       ' ',
       'Servio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VRV ',
       'TIPPRO',
       2,
       ' ',
       'Terceirizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10241 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VRXP',
       TO_NUMBER(null),
       'VRXP',
       'Receb. por Produto',
       'TV_RECXPRO',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10242 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VRXP','--','' FROM DUAL
UNION ALL
SELECT 'VRXP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VRXP','99','Outros' FROM DUAL
);

/*-- SEQ 10243 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 45932,
       'RECP',
       'VRXP',
       '1',
       '1',
       '',
       '',
       'VRXP.CODFIL = RECP.CODFIL AND
VRXP.SEQUEN = RECP.SEQUEN AND
VRXP.NUMPAR = RECP.NUMPAR AND
VRXP.SUBPAR = RECP.SUBPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45870,
       'VIPR',
       'VRXP',
       '1',
       'N',
       'VRXP',
       '',
       'VRXP.FILMAT = VIPR.FILMAT AND
VRXP.CODMAT = VIPR.CODMAT AND
VRXP.CODCOR = VIPR.CODCOR AND
VRXP.CODTAM = VIPR.CODTAM',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22188,
       'IVE ',
       'VRXP',
       '1',
       '1',
       'VRXP',
       '',
       'VRXP.CODFIL = IVE.CODFIL AND
VRXP.SEQUEN = IVE.SEQUEN AND
VRXP.NUMITE = IVE.NUMITE',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22189,
       'REC ',
       'VRXP',
       '1',
       '1',
       'VRXP',
       '',
       'VRXP.CODFIL = REC.CODFIL AND
VRXP.SEQUEN = REC.SEQUEN AND
VRXP.NUMPAR = REC.NUMPAR AND
VRXP.SUBPAR = REC.SUBPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22190,
       'VEN ',
       'VRXP',
       '1',
       'N',
       'VRXP',
       '',
       'VRXP.CODFIL = VEN.CODFIL AND
VRXP.SEQUEN = VEN.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 10244 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VRXP',
       '01',
       9,
       5,
       'CODCOR',
       'G',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Diviso',
       'Diviso',
       '',
       'CODCOR',
       '' FROM DUAL
UNION ALL
SELECT 'VRXP',
       '01',
       1,
       3,
       'CODFIL',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL = VRXP.CODFIL',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'VRXP',
       '01',
       8,
       5,
       'CODMAT',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Cdigo do Produto',
       'Cdigo do Produto',
       '',
       'CODMAT',
       '' FROM DUAL
UNION ALL
SELECT 'VRXP',
       '01',
       11,
       5,
       'CODMUL',
       'G',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sub-Estoque',
       'Sub-Estoque',
       '',
       'CODMUL',
       '' FROM DUAL
UNION ALL
SELECT 'VRXP',
       '01',
       10,
       5,
       'CODTAM',
       'G',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sub-Diviso',
       'Sub-Diviso',
       '',
       'CODTAM',
       '' FROM DUAL
UNION ALL
SELECT 'VRXP',
       '01',
       33,
       12,
       'DESRAT_PRO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Acrs./Desc.',
       'Valor Acrscimo/Desconto Proporcional',
       '',
       'DESRAT_PRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VRXP',
       '01',
       7,
       3,
       'FILMAT',
       'A',
       'DFIL',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       '',
       'Filial do Produto',
       'Filial do Produto',
       'DFIL.CODFIL = VRXP.FILMAT',
       'FILMAT',
       '' FROM DUAL
UNION ALL
SELECT 'VRXP',
       '01',
       6,
       1,
       'FLGEST',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       '' FROM DUAL
UNION ALL
SELECT 'VRXP',
       '01',
       3,
       10,
       'NUMITE',
       'N',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Nmero do Item',
       'Nmero do Item',
       '',
       'NUMITE',
       '' FROM DUAL
UNION ALL
SELECT 'VRXP',
       '01',
       4,
       2,
       'NUMPAR',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nmero da Parcela',
       'Nmero da Parcela',
       '',
       'NUMPAR',
       '' FROM DUAL
UNION ALL
SELECT 'VRXP',
       '01',
       23,
       7,
       'PAGAME',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data pagamento',
       'Data Pagamento',
       '',
       'PAGAME',
       'F' FROM DUAL
UNION ALL
SELECT 'VRXP',
       '01',
       2,
       10,
       'SEQUEN',
       'S',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       'Sequncia',
       'Sequncia',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'VRXP',
       '01',
       5,
       2,
       'SUBPAR',
       'A',
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Sub-Parcela',
       'Sub-Parcela',
       '',
       'SUBPAR',
       '' FROM DUAL
UNION ALL
SELECT 'VRXP',
       '01',
       53,
       12,
       'VLRDES_PRO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Desc Rateado',
       'Valor de desconto no recebimento ratedo por item',
       '',
       'VLRDES_PRO',
       '' FROM DUAL
UNION ALL
SELECT 'VRXP',
       '01',
       43,
       12,
       'VLRFRE_PRO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Frete',
       'Valor Frete Proporcional',
       '',
       'VLRFRE_PRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VRXP',
       '01',
       12,
       12,
       'VLRPAR_PRO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Parcela',
       'Valor Parcela Proporcional',
       '',
       'VLRPAR_PRO',
       '' FROM DUAL
UNION ALL
SELECT 'VRXP',
       '01',
       13,
       12,
       'VLRPGT_PRO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Pagamento',
       'Valor Pagamento Proporcional',
       '',
       'VLRPGT_PRO',
       '' FROM DUAL
);

/*-- SEQ 10245 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VSBT',
       TO_NUMBER(null),
       'VSBT',
       'Subst. Tributria',
       'TV_SBT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'VSBT.ESTADO',
       '' FROM DUAL
);

/*-- SEQ 10246 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VSBT','--','' FROM DUAL
);

/*-- SEQ 10247 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VSBT',
       '--',
       20,
       2,
       'CODMAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       'VSBT',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Cdigo Margem Lucro',
       'Cdigo da margem de lucro',
       '',
       'CODMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VSBT',
       '--',
       10,
       2,
       'ESTADO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       'VSBT',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Estado',
       'Estado',
       '',
       'ESTADO',
       'F' FROM DUAL
UNION ALL
SELECT 'VSBT',
       '--',
       30,
       8,
       'MARGEM',
       'F',
       '',
       0,
       TO_NUMBER(null),
       'VSBT',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Margem de lucro',
       'Margem de lucro',
       '',
       'MARGEM',
       'F' FROM DUAL
);

/*-- SEQ 10248 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VSE ',
       TO_NUMBER(null),
       'VSE ',
       'Saldo EstoqueExterno',
       'TV_SLE_EXT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VSE.FILMAT,VSE.CODMAT,VSE.CODCOR,VSE.CODTAM',
       '' FROM DUAL
);

/*-- SEQ 10249 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VSE ','--','' FROM DUAL
UNION ALL
SELECT 'VSE ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VSE ','99','Outros' FROM DUAL
);

/*-- SEQ 10250 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VSE ',
       '01',
       10,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Diviso do produto',
       'VSE.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'VSE ',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = VSE.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VSE ',
       '01',
       30,
       4,
       'CODLOT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo do Lote',
       'Cdigo do Lote',
       '',
       'CODLOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VSE ',
       '01',
       40,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VSE ',
       '01',
       50,
       0,
       'CODMUL',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       'F',
       'Sub-Estoque',
       'Nome do Sub-Estoque',
       'DMUL.CODTAB = VSE.CODMUL',
       'CODMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'VSE ',
       '01',
       60,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'VSE.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'VSE ',
       '01',
       70,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VSE ',
       '01',
       80,
       20,
       'REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Referncia',
       'Referncia do produto',
       '',
       'REFPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VSE ',
       '01',
       90,
       12,
       'SALREA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Saldo Real',
       'Saldo Real',
       '',
       'SALREA',
       'F' FROM DUAL
UNION ALL
SELECT 'VSE ',
       '01',
       100,
       5,
       'TAMORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tamanho Origem',
       'Tamanho Origem',
       '',
       'TAMORI',
       'F' FROM DUAL
);

/*-- SEQ 10251 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VSIM',
       TO_NUMBER(null),
       'VSIM',
       'Apurao do Simples',
       'TV_SIM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10252 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VSIM','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VSIM','02','Datas' FROM DUAL
UNION ALL
SELECT 'VSIM','99','Outros' FROM DUAL
);

/*-- SEQ 10253 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VSIM',
       '01',
       160,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VSIM.CODFIL (+)',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VSIM',
       '02',
       15,
       7,
       'DATMAX',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Considera Receb. At',
       'Considerar Recebimentos At',
       '',
       'DATMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'VSIM',
       '02',
       10,
       8,
       'DATOPE',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Oper.',
       'Data da Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VSIM',
       '02',
       100,
       7,
       'DATREC',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Receb.',
       'Data do Recebimento',
       '',
       'DATREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VSIM',
       '02',
       90,
       7,
       'DATVEN',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       'D',
       'F',
       'Data Venc.',
       'Data do Vencimento',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VSIM',
       '99',
       140,
       1,
       'IBCANC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Canc.',
       'Nota Fiscal Cancelada',
       '',
       'IBCANC',
       'F' FROM DUAL
UNION ALL
SELECT 'VSIM',
       '99',
       150,
       1,
       'IBDEVL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Devl.',
       'Nota Fiscal de Produto ou Devoluo',
       '',
       'IBDEVL',
       'F' FROM DUAL
UNION ALL
SELECT 'VSIM',
       '99',
       30,
       1,
       'IBLICE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Lice.',
       'Nota Fiscal de Licena(s)',
       '',
       'IBLICE',
       'F' FROM DUAL
UNION ALL
SELECT 'VSIM',
       '99',
       20,
       1,
       'IBSERV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Serv.',
       'Nota Fiscal de Servio(s)',
       '',
       'IBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VSIM',
       '01',
       40,
       8,
       'NUMENF',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'N NF',
       'Nmero da Nota Fiscal',
       '',
       'NUMENF',
       'F' FROM DUAL
UNION ALL
SELECT 'VSIM',
       '01',
       180,
       15,
       'NUMNFES',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'NFES',
       'Nmero da NF-e de Servio',
       '',
       'NUMNFES',
       '' FROM DUAL
UNION ALL
SELECT 'VSIM',
       '99',
       70,
       4,
       'NUMPAR',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'N Parc.',
       'Nmero da Parcela',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VSIM',
       '01',
       170,
       30,
       'PORTAD',
       'A',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       '',
       'A',
       'F',
       'Portador',
       'Portador',
       'DCOB.CODTAB = VSIM.PORTAD',
       'PORTAD',
       'T' FROM DUAL
UNION ALL
SELECT 'VSIM',
       '99',
       60,
       4,
       'QTDPAR',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Qt. Parc.',
       'Quantidade de Parcelas',
       '',
       'QTDPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VSIM',
       '99',
       130,
       12,
       'VINCOB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Vlr. Cons. Incob.',
       'Valor Considerado Incobrvel',
       '',
       'VINCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'VSIM',
       '99',
       110,
       12,
       'VLRPAG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       'Vlr. Pago',
       'Valor Pago',
       '',
       'VLRPAG',
       'F' FROM DUAL
UNION ALL
SELECT 'VSIM',
       '99',
       80,
       12,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Vlr. Parc.',
       'Valor da Parcela',
       '',
       'VLRPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VSIM',
       '99',
       50,
       12,
       'VLRTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       'Vlr. Total',
       'Valor Total da Nota Fiscal',
       '',
       'VLRTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VSIM',
       '99',
       120,
       12,
       'VSALDO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Saldo a Rec.',
       'Valor do Saldo a Receber',
       '',
       'VSALDO',
       'F' FROM DUAL
);

/*-- SEQ 10254 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VSLE',
       TO_NUMBER(null),
       'VSLE',
       'Saldos p/Embalagens',
       'TV_SLE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VSLE.FILMAT,VSLE.CODMAT,VSLE.CODCOR,VSLE.CODTAM',
       '' FROM DUAL
);

/*-- SEQ 10255 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VSLE','--','' FROM DUAL
UNION ALL
SELECT 'VSLE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VSLE','02','Datas' FROM DUAL
UNION ALL
SELECT 'VSLE','03','Valores' FROM DUAL
UNION ALL
SELECT 'VSLE','99','Outros' FROM DUAL
);

/*-- SEQ 10256 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 6019,
       'DFIL',
       'VSLE',
       '1 ',
       'N ',
       '',
       '',
       'VSLE.CODFIL = DFIL.CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 6020,
       'GRA ',
       'VSLE',
       '1 ',
       'N ',
       '',
       '',
       'VSLE.FILMAT = GRA.FILMAT AND
VSLE.CODMAT = GRA.CODMAT AND
VSLE.CODCOR = GRA.CODCOR AND
VSLE.CODTAM = GRA.CODTAM',
       '' FROM DUAL
UNION ALL
SELECT 6021,
       'VIPR',
       'VSLE',
       '1 ',
       'N ',
       '',
       '',
       'VSLE.FILMAT = VIPR.FILMAT AND
VSLE.CODMAT = VIPR.CODMAT AND
VSLE.CODCOR = VIPR.CODCOR AND
VSLE.CODTAM = VIPR.CODTAM',
       '' FROM DUAL
);

/*-- SEQ 10257 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VSLE',
       '01',
       200,
       5,
       'CLASS1',
       'S',
       'DCL1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL1.CLASS1',
       'V',
       '',
       'F',
       'A',
       'F',
       '',
       'Cdigo da classe 1',
       'DCL1.CODTAB = VSLE.CLASS1(+)',
       'CLASS1',
       'T' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '01',
       210,
       5,
       'CLASS2',
       'S',
       'DCL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL2.CLASS2',
       'V',
       '',
       'F',
       'A',
       'F',
       '',
       'Cdigo da classe 2',
       'DCL2.CODTAB = VSLE.CLASS2 (+)',
       'CLASS2',
       'T' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '01',
       220,
       5,
       'CLASS3',
       'S',
       'DCL3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL3.CLASS3',
       'V',
       '',
       'F',
       'A',
       'F',
       '',
       'Cdigo da classe 3',
       'DCL3.CODTAB = PRO.CLASS3 (+)',
       'CLASS3',
       'T' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '01',
       230,
       5,
       'CLASS4',
       'S',
       'DCL4',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL4.CLASS4',
       'V',
       '',
       'F',
       'A',
       'F',
       '',
       'Cdigo da classe 4',
       'DCL4.CODTAB = VSLE.CLASS4(+)',
       'CLASS4',
       'T' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '01',
       10,
       2,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso do Produto',
       'Diviso do Produto',
       'VSLE.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'VSLE.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '01',
       260,
       6,
       'CODMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo da Marca',
       'Cdigo da Marca deste produto',
       '',
       'CODMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '01',
       30,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '01',
       40,
       5,
       'CODMUL',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       '9',
       'F',
       'Sub-Estoque',
       'Nome do Sub-Estoque',
       'DMUL.CODTAB = VSLE.CODMUL(+)',
       'CODMUL',
       'T' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '01',
       50,
       2,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso Produto',
       'Sub-Diviso do produto',
       'VSLE.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '01',
       250,
       5,
       'DEPART',
       'S',
       'DDEP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDEP.DESDEP',
       'V',
       '',
       'F',
       'A',
       'F',
       'Departamento',
       'Departamento do Produto',
       'DDEP.CODTAB = VSLE.DEPART(+)',
       'DEPART',
       'T' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '01',
       60,
       5,
       'EMBORI',
       'G',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       '9',
       'F',
       'Embalagem Original',
       'Embalagem Original',
       'VSLE.EMBORI=SUB.CODITE(+)',
       'EMBORI',
       'T' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '03',
       70,
       12,
       'EMBQTD',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Quantidade Original',
       'Quantidade Original',
       '',
       'EMBQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '01',
       80,
       12,
       'EMBRES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Embalagem Res.',
       'Embalagem Res.',
       '',
       'EMBRES',
       'F' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '01',
       90,
       1,
       'EMBTEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tem Embalagem',
       'Tem Embalagem',
       '',
       'EMBTEM',
       'T' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '01',
       270,
       3,
       'FILMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial da Marca do material',
       '',
       'FILMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '01',
       100,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '99',
       110,
       1,
       'INVENT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Inventrio?',
       'Inventrio?',
       '',
       'INVENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '03',
       120,
       13,
       'PTOPED',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Ponto de pedido',
       'Ponto de pedido',
       '',
       'PTOPED',
       'F' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '03',
       130,
       8,
       'QTDEST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtd.Estoque',
       'Quantidade em estoque',
       '',
       'QTDEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '03',
       140,
       13,
       'QTDMIN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Quantidade mnima',
       'Quantidade mnima',
       '',
       'QTDMIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '01',
       150,
       20,
       'REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Referncia',
       'Referncia do produto',
       '',
       'REFPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '03',
       160,
       8,
       'RESERV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Qtd.Reserva',
       'Quantidade de reserva',
       '',
       'RESERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '03',
       170,
       12,
       'SALREA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Saldo Real',
       'Saldo Real',
       '',
       'SALREA',
       'F' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '99',
       180,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VSLE',
       '01',
       190,
       5,
       'TAMORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tamanho Origem',
       'Tamanho Origem',
       '',
       'TAMORI',
       'F' FROM DUAL
);

/*-- SEQ 10258 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VSLE',
       'EMBTEM',
       0,
       'F',
       'Falso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VSLE',
       'EMBTEM',
       0,
       'T',
       'Verdadeiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10259 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VSLT',
       TO_NUMBER(null),
       'VSLT',
       'Saldo Lote Inicial',
       'TV_SLT',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VSLT.CODFIL,VSLT.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 10260 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VSLT','--','' FROM DUAL
UNION ALL
SELECT 'VSLT','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VSLT','02','Valores' FROM DUAL
UNION ALL
SELECT 'VSLT','99','Outros' FROM DUAL
);

/*-- SEQ 10261 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 23083,
       'LOT ',
       'VSLT',
       '1',
       '0N',
       '',
       '',
       'LOT.CODFIL = VSLT.FILLOT(+) AND
LOT.SEQUEN = VSLT.SEQLOT(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 10262 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VSLT',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL(+) = VSLT.CODFIL',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'VSLT',
       '01',
       20,
       5,
       'CODMUL',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'N',
       'F',
       'Subestoque',
       'Subestoque do lote',
       'DMUL.CODTAB(+) = VSLT.CODMUL',
       'CODMUL',
       'T' FROM DUAL
UNION ALL
SELECT 'VSLT',
       '01',
       30,
       3,
       'FILLOT',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial Lote',
       'Filial do lote',
       'DFIL.CODFIL(+) = VSLT.FILLOT',
       'FILLOT',
       'T' FROM DUAL
UNION ALL
SELECT 'VSLT',
       '02',
       40,
       12,
       'QTDEST',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Saldo Lote Inicial',
       'Saldo Lote Inicial',
       '',
       'QTDEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VSLT',
       '02',
       50,
       12,
       'QTDINI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtd. Inicial',
       'Quantidade Inicial',
       '',
       'QTDINI',
       'F' FROM DUAL
UNION ALL
SELECT 'VSLT',
       '02',
       60,
       12,
       'RESERV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Qtd. Reserva',
       'Quantidade Reserva',
       '',
       'RESERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VSLT',
       '01',
       70,
       10,
       'SEQLOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq Lote',
       'Sequenciador de Lote',
       '',
       'SEQLOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VSLT',
       '01',
       80,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 10263 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VSM ',
       TO_NUMBER(null),
       'VSM ',
       'Sup. x Msg.',
       'TV_SUP_MSG',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VSM.CODFIL,VSM.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 10264 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VSM ','--','' FROM DUAL
UNION ALL
SELECT 'VSM ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VSM ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VSM ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VSM ','99','Outros' FROM DUAL
);

/*-- SEQ 10265 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VSM ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = VSM.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VSM ',
       '02',
       20,
       7,
       'DATMSG',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Mensagem',
       'Data da Mensagem',
       '',
       'DATMSG',
       'F' FROM DUAL
UNION ALL
SELECT 'VSM ',
       '01',
       30,
       40,
       'DESMSG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Mensagem',
       'Descrio da Mensagem',
       '',
       'DESMSG',
       'F' FROM DUAL
UNION ALL
SELECT 'VSM ',
       '01',
       40,
       4000,
       'MSGSUP',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem Suporte',
       'Mensagem Suporte',
       '',
       'MSGSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'VSM ',
       '01',
       50,
       44,
       'PESSOA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Pessoa',
       'Pessoa',
       '',
       'PESSOA',
       'F' FROM DUAL
UNION ALL
SELECT 'VSM ',
       '01',
       60,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 10266 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VSPE',
       TO_NUMBER(null),
       'VSPE',
       'Reg. Sped Entrada',
       'TV_SPED_ENTRADA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10267 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VSPE','--','' FROM DUAL
UNION ALL
SELECT 'VSPE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VSPE','99','Outros' FROM DUAL
UNION ALL
SELECT 'VSPE','02','Codigo' FROM DUAL
UNION ALL
SELECT 'VSPE','03','Produto' FROM DUAL
UNION ALL
SELECT 'VSPE','04','Fiscal' FROM DUAL
UNION ALL
SELECT 'VSPE','05','Conta' FROM DUAL
UNION ALL
SELECT 'VSPE','06','Filial' FROM DUAL
UNION ALL
SELECT 'VSPE','07','Endereos' FROM DUAL
UNION ALL
SELECT 'VSPE','08','Itens Compra' FROM DUAL
UNION ALL
SELECT 'VSPE','09','Municipio' FROM DUAL
UNION ALL
SELECT 'VSPE','10','Medidas' FROM DUAL
UNION ALL
SELECT 'VSPE','11','Itrens' FROM DUAL
UNION ALL
SELECT 'VSPE','12','Parceiro' FROM DUAL
UNION ALL
SELECT 'VSPE','13','Compra' FROM DUAL
UNION ALL
SELECT 'VSPE','14','Config' FROM DUAL
UNION ALL
SELECT 'VSPE','15','Documento' FROM DUAL
UNION ALL
SELECT 'VSPE','16','Natureza' FROM DUAL
UNION ALL
SELECT 'VSPE','17','Tributao' FROM DUAL
);

/*-- SEQ 10268 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'VSPE',
       '--',
       12900.00,
       5.00,
       'SPE_CODCST',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Codigo CST',
       'Codigo CST',
       '',
       'SPE_CODCST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '--',
       12910.00,
       12.00,
       'SPE_DESRATNOTA',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Desconto Rat Nota',
       'Desconto Rat Nota',
       '',
       'SPE_DESRATNOTA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '--',
       12920.00,
       12.00,
       'SPE_VLROPE',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Operao',
       'Valor Operao',
       '',
       'SPE_VLROPE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '--',
       12950.00,
       12.00,
       'SPE_TAXICM',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Taxa ICMS',
       'Taxa ICMS',
       '',
       'SPE_TAXICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '--',
       12960.00,
       12.00,
       'SPE_BASICM',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base ICMS',
       'Base ICMS',
       '',
       'SPE_BASICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '--',
       12970.00,
       12.00,
       'SPE_VLRICM',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor ICMS',
       'Valor ICMS',
       '',
       'SPE_VLRICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '--',
       12980.00,
       12.00,
       'SPE_BASSUB',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base ST',
       'Base ST',
       '',
       'SPE_BASSUB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '--',
       12990.00,
       12.00,
       'SPE_VLRSUB',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor ST',
       'Valor ST',
       '',
       'SPE_VLRSUB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '--',
       13000.00,
       14.00,
       'SUBORI_FATCON',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       '',
       '',
       '',
       'SUBORI_FATCON',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '--',
       13010.00,
       20.00,
       'TRI_CODTRI',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'TRI_CODTRI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '--',
       13020.00,
       6.00,
       'FIL_PERPIS',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       '',
       '',
       '',
       'FIL_PERPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '--',
       13030.00,
       6.00,
       'FIL_PERCOF',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       '',
       '',
       '',
       'FIL_PERCOF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '--',
       13040.00,
       1.00,
       'FIL_TIPLUC',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'FIL_TIPLUC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '--',
       13050.00,
       4.00,
       'FIL_REGTRI',
       'G',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       '',
       '',
       'FIL_REGTRI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '02',
       20.00,
       10.00,
       'CODNAT',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Codigo CFOP',
       'Codigo CFOP',
       '',
       'CODNAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '03',
       1080.00,
       60.00,
       'PRO_CODIGO',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Codigo Produto',
       'Codigo Produto',
       '',
       'PRO_CODIGO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '03',
       1090.00,
       20.00,
       'PRO_REFPRO',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Referencia Produto',
       'Referencia Produto',
       '',
       'PRO_REFPRO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '03',
       1100.00,
       15.00,
       'PRO_REFBAS',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Refrencia Basica',
       'Refrencia Basica',
       '',
       'PRO_REFBAS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '03',
       1110.00,
       120.00,
       'PRO_NOMPRO',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome Produto',
       'Nome Produto',
       '',
       'PRO_NOMPRO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '03',
       1120.00,
       30.00,
       'PRO_CODEAN',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Codigo EAN Produto',
       'Codigo EAN Produto',
       '',
       'PRO_CODEAN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '03',
       1130.00,
       2.00,
       'PRO_CODFPS',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Codigo FPS Pro',
       'Codigo FPS Pro',
       '',
       'PRO_CODFPS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '03',
       1140.00,
       8.00,
       'PRO_CODNCM',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'NCM Produto',
       'NCM Produto',
       '',
       'PRO_CODNCM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '03',
       1150.00,
       3.00,
       'PRO_COD_EX',
       'S',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Codigo Externo',
       'Codigo Externo',
       '',
       'PRO_COD_EX',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '03',
       1160.00,
       5.00,
       'PRO_GENNCM',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Gen NCM',
       'Gen NCM',
       '',
       'PRO_GENNCM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '03',
       1170.00,
       5.00,
       'PRO_CODSRV',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Codigo Servio',
       'Codigo Servio',
       '',
       'PRO_CODSRV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '03',
       1180.00,
       12.00,
       'PRO_PERICM',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Perc ICM PRO',
       'Perc ICM PRO',
       '',
       'PRO_PERICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '03',
       1190.00,
       9.00,
       'PRO_CODANP',
       'S',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Codigo ANP PRO',
       'Codigo ANP PRO',
       '',
       'PRO_CODANP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '03',
       1200.00,
       20.00,
       'PRO_CODEXT',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Codigo EXT Pro',
       'Codigo EXT Pro',
       '',
       'PRO_CODEXT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '03',
       1210.00,
       5.00,
       'PRO_NATBCC',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Finalidade',
       'Finalidade',
       '',
       'PRO_NATBCC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '03',
       1220.00,
       1.00,
       'PRO_IIPTPR',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'PRO_IIPTPR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '03',
       1870.00,
       7.00,
       'PRO_CODCES',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cest PRO',
       'Cest PRO',
       '',
       'PRO_CODCES',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '04',
       620.00,
       2.00,
       'FIS_MODNOT',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Modelo FIS',
       'Modelo FIS',
       '',
       'FIS_MODNOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '04',
       630.00,
       5.00,
       'FIS_CODSER',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Serie FIS',
       'Serie FIS',
       '',
       'FIS_CODSER',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '04',
       640.00,
       5.00,
       'FIS_SUBSER',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Sub-Serie FIS',
       'Sub-Serie FIS',
       '',
       'FIS_SUBSER',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '05',
       170.00,
       30.00,
       'CTADOC_CODEXT',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'CTADOC_CODEXT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '08',
       1040.00,
       12.00,
       'ICO_VLRMOV',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr Movimento ICO',
       'Vlr Movimento ICO',
       '',
       'ICO_VLRMOV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '08',
       1050.00,
       5.00,
       'ICO_VALCON',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Conversao ICO',
       'Conversao ICO',
       '',
       'ICO_VALCON',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '08',
       1070.00,
       12.00,
       'ICO_VLRITE',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr Item ICO',
       'Vlr Item ICO',
       '',
       'ICO_VLRITE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '08',
       1270.00,
       5.00,
       'ICO_UNICOM',
       'S',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       '',
       '',
       'ICO_UNICOM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '08',
       1280.00,
       5.00,
       'ICO_UNIVEN',
       'S',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       '',
       '',
       'ICO_UNIVEN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '08',
       1290.00,
       12.00,
       'ICO_QTDCOM',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       '',
       '',
       'ICO_QTDCOM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '09',
       1420.00,
       10.00,
       'MUN_CODIBG',
       'S',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       '',
       '',
       'MUN_CODIBG',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '09',
       1430.00,
       2.00,
       'MUN_SIGEST',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'MUN_SIGEST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '10',
       1230.00,
       5.00,
       'MED_CODTAB',
       'S',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       '',
       '',
       'MED_CODTAB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '10',
       1240.00,
       1.00,
       'MED_MEDATI',
       'L',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'MED_MEDATI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '10',
       1250.00,
       2.00,
       'MED_UNIMED',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Unidade Medida',
       'Unidade Medida',
       '',
       'MED_UNIMED',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '10',
       1260.00,
       20.00,
       'MED_DESMED',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'MED_DESMED',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '10',
       1300.00,
       1.00,
       'MEDFAT_MEDATI',
       'L',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'MEDFAT_MEDATI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '10',
       1310.00,
       20.00,
       'MEDFAT_DESMED',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'MEDFAT_DESMED',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '10',
       1320.00,
       5.00,
       'MEDFAT_UNIMED',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'MEDFAT_UNIMED',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '10',
       1560.00,
       5.00,
       'MEDEMB_CODTAB',
       'S',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       '',
       '',
       'MEDEMB_CODTAB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '10',
       1570.00,
       1.00,
       'MEDEMB_MEDATI',
       'L',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'MEDEMB_MEDATI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '10',
       1580.00,
       10.00,
       'MEDEMB_UNIMED',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'MEDEMB_UNIMED',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '10',
       1590.00,
       20.00,
       'MEDEMB_DESMED',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'MEDEMB_DESMED',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       650.00,
       30.00,
       'ITE_CODIGO',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Codigo ITE',
       'Codigo ITE',
       '',
       'ITE_CODIGO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       660.00,
       10.00,
       'ITE_NATFIS',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'CFOP ITE',
       'CFOP ITE',
       '',
       'ITE_NATFIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       670.00,
       5.00,
       'ITE_CODCST',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'CST ITE',
       'CST ITE',
       '',
       'ITE_CODCST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       680.00,
       1.00,
       'ITE_CODORI',
       'S',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       '',
       '',
       'ITE_CODORI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       690.00,
       3.00,
       'ITE_CODFIL',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Filial Item',
       'Filial Item',
       '',
       'ITE_CODFIL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       700.00,
       5.00,
       'ITE_NUMITE',
       'S',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nmero ITE',
       'Nmero ITE',
       '',
       'ITE_NUMITE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       710.00,
       12.00,
       'ITE_QTDMOV',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Qtade ITE',
       'Qtade ITE',
       '',
       'ITE_QTDMOV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       720.00,
       12.00,
       'ITE_EMBQTD',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Embalagem ITE',
       'Embalagem ITE',
       '',
       'ITE_EMBQTD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       730.00,
       12.00,
       'ITE_VLRDES',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr Desconto ITE',
       'Vlr Desconto ITE',
       '',
       'ITE_VLRDES',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       740.00,
       12.00,
       'ITE_VLRMOV',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr Movimento ITE',
       'Vlr Movimento ITE',
       '',
       'ITE_VLRMOV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       750.00,
       1.00,
       'ITE_TIPPRO',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Tipo Produto ITE',
       'Tipo Produto ITE',
       '',
       'ITE_TIPPRO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       760.00,
       1.00,
       'ITE_ICMTIP',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Tipo ICMS ITE',
       'Tipo ICMS ITE',
       '',
       'ITE_ICMTIP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       770.00,
       12.00,
       'ITE_REDITE',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Reduo ITE',
       'Reduo ITE',
       '',
       'ITE_REDITE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       780.00,
       12.00,
       'ITE_BASICM',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base ICMS ITE',
       'Base ICMS ITE',
       '',
       'ITE_BASICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       790.00,
       12.00,
       'ITE_VLRICM',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr ICMS ITE',
       'Vlr ICMS ITE',
       '',
       'ITE_VLRICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       800.00,
       4.00,
       'ITE_CALSUB',
       'G',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cal sub ITE',
       'Cal sub ITE',
       '',
       'ITE_CALSUB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       810.00,
       4.00,
       'ITE_RATEIO_PROMOCAO',
       'G',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Rateio Promo ITE',
       'Rateio Promo ITE',
       '',
       'ITE_RATEIO_PROMOCAO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       820.00,
       12.00,
       'ITE_TAXICM',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Taxa ICMS ITE',
       'Taxa ICMS ITE',
       '',
       'ITE_TAXICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       830.00,
       14.00,
       'ITE_VLRIPI',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr IPI ITE',
       'Vlr IPI ITE',
       '',
       'ITE_VLRIPI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       840.00,
       14.00,
       'ITE_ISEICM',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr ICM Isento ITE',
       'Vlr ICM Isento ITE',
       '',
       'ITE_ISEICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       850.00,
       1.00,
       'ITE_LANEST',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Lan Estoque ITE',
       'Lan Estoque ITE',
       '',
       'ITE_LANEST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       860.00,
       12.00,
       'ITE_VLRPIS',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr PIS ITE',
       'Vlr PIS ITE',
       '',
       'ITE_VLRPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       870.00,
       12.00,
       'ITE_VLRCOF',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr Cofins ITE',
       'Vlr Cofins ITE',
       '',
       'ITE_VLRCOF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       880.00,
       12.00,
       'ITE_BASIPI',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base IPI ITE',
       'Base IPI ITE',
       '',
       'ITE_BASIPI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       890.00,
       12.00,
       'ITE_TAXIPI',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Taxa IPI ITE',
       'Taxa IPI ITE',
       '',
       'ITE_TAXIPI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       900.00,
       2.00,
       'ITE_SITPIS',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Situao PIS ITE',
       'Situao PIS ITE',
       '',
       'ITE_SITPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       910.00,
       12.00,
       'ITE_BASPIS',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base PIS ITE',
       'Base PIS ITE',
       '',
       'ITE_BASPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       920.00,
       6.00,
       'ITE_PERPIS',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Perc PIS ITE',
       'Perc PIS ITE',
       '',
       'ITE_PERPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       930.00,
       2.00,
       'ITE_SITCOF',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Situao Cofins ITE',
       'Situao Cofins ITE',
       '',
       'ITE_SITCOF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       940.00,
       12.00,
       'ITE_BASCOF',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base Cofins ITE',
       'Base Cofins ITE',
       '',
       'ITE_BASCOF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       950.00,
       6.00,
       'ITE_PERCOF',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Perc Confis ITE',
       'Perc Confis ITE',
       '',
       'ITE_PERCOF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       960.00,
       14.00,
       'ITE_BASSUB',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base ST ITE',
       'Base ST ITE',
       '',
       'ITE_BASSUB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       970.00,
       14.00,
       'ITE_VLR_ST',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr ST ITE',
       'Vlr ST ITE',
       '',
       'ITE_VLR_ST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       980.00,
       6.00,
       'ITE_ICMVEN',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Vlr ICM Ven ITE',
       'Vlr ICM Ven ITE',
       '',
       'ITE_ICMVEN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       990.00,
       7.00,
       'ITE_RED_ST',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Reduo ST ITE',
       'Reduo ST ITE',
       '',
       'ITE_RED_ST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       1000.00,
       1.00,
       'ITE_SITMOV',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Situao Item ITE',
       'Situao Item ITE',
       '',
       'ITE_SITMOV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       1010.00,
       12.00,
       'ITE_IPIFRE',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'IPI Frete ITE',
       'IPI Frete ITE',
       '',
       'ITE_IPIFRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       1020.00,
       12.00,
       'ITE_VLRFRE',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr Frete ITE',
       'Vlr Frete ITE',
       '',
       'ITE_VLRFRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       1030.00,
       12.00,
       'ITE_VLRUNI',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Vlr Unit ITE',
       'Vlr Unit ITE',
       '',
       'ITE_VLRUNI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       1060.00,
       5.00,
       'ITE_SITIPI',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Situao IPI ITE',
       'Situao IPI ITE',
       '',
       'ITE_SITIPI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       1630.00,
       10.00,
       'ITE_CODNAT',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'CFOP Item ITE',
       'CFOP Item ITE',
       '',
       'ITE_CODNAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       1640.00,
       40.00,
       'ITE_DESNAT',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'CFOP Descrio ITEM',
       'CFOP Descrio ITEM',
       '',
       'ITE_DESNAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       1670.00,
       3.00,
       'TRA_FILITE',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'TRA_FILITE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       1680.00,
       4.00,
       'ITE_VLRLIQ',
       'G',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Vlr Liquido Ite',
       'Vlr Liquido Ite',
       '',
       'ITE_VLRLIQ',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       1690.00,
       4.00,
       'ITE_DESRAT',
       'G',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Desconro Rateio Ite',
       'Desconro Rateio Ite',
       '',
       'ITE_DESRAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       1700.00,
       4.00,
       'ITE_ACR_ORIGINAL',
       'G',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Acrec Original Item',
       'Acrec Original Item',
       '',
       'ITE_ACR_ORIGINAL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       1770.00,
       4.00,
       'ITE_VALOR_FCP',
       'G',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Vlr FCP ITE',
       'Vlr FCP ITE',
       '',
       'ITE_VALOR_FCP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       1780.00,
       4.00,
       'ITE_VALOR_PARTILHA_DESTINO',
       'G',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Vlr Partilha Destino',
       'Vlr Partilha Destino',
       '',
       'ITE_VALOR_PARTILHA_DESTINO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       1790.00,
       4.00,
       'ITE_VALOR_PARTILHA_REMETENTE',
       'G',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Vlr Partilha Remet.',
       'Vlr Partilha Remet.',
       '',
       'ITE_VALOR_PARTILHA_REMETENTE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '11',
       1800.00,
       12.00,
       'ITE_OUTTAX',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Outras Taxas ITE',
       'Outras Taxas ITE',
       '',
       'ITE_OUTTAX',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '12',
       1330.00,
       20.00,
       'PAR_CODIGO',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'PAR_CODIGO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '12',
       1340.00,
       3.00,
       'PAR_FILCLI',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'PAR_FILCLI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '12',
       1350.00,
       6.00,
       'PAR_CODCLI',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'PAR_CODCLI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '12',
       1360.00,
       64.00,
       'PAR_NOMCLI',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome Parceiro',
       'Nome Parceiro',
       '',
       'PAR_NOMCLI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '12',
       1370.00,
       5.00,
       'PAR_CODPAI',
       'S',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       '',
       '',
       'PAR_CODPAI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '12',
       1380.00,
       15.00,
       'PAR_NUMDOC',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Documento Parceiro',
       'Documento Parceiro',
       '',
       'PAR_NUMDOC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '12',
       1390.00,
       20.00,
       'PAR_INSEST',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Inscrio Parceiro',
       'Inscrio Parceiro',
       '',
       'PAR_INSEST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '12',
       1400.00,
       9.00,
       'PAR_SUFRAM',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'PAR_SUFRAM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '12',
       1410.00,
       5.00,
       'PAR_FLGTIP',
       'S',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Tipo Parceiro',
       'Tipo Parceiro',
       '',
       'PAR_FLGTIP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '12',
       1440.00,
       80.00,
       'ENC_ENDERE',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Endereo Parceiro',
       'Endereo Parceiro',
       '',
       'ENC_ENDERE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '12',
       1450.00,
       80.00,
       'ENC_ENDERE_ESTRAN',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'ENC_ENDERE_ESTRAN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '12',
       1460.00,
       15.00,
       'ENC_NUMERO',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nmero',
       'Nmero',
       '',
       'ENC_NUMERO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '12',
       1470.00,
       80.00,
       'ENC_COMPLE',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Complemento',
       'Complemento',
       '',
       'ENC_COMPLE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '12',
       1480.00,
       40.00,
       'ENC_BAIRRO',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Bairro',
       'Bairro',
       '',
       'ENC_BAIRRO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '12',
       1490.00,
       5.00,
       'ENC_CODPAI',
       'S',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       '',
       '',
       'ENC_CODPAI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '12',
       1500.00,
       2.00,
       'ENC_SIGEST',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Estado',
       'Estado',
       '',
       'ENC_SIGEST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '12',
       1510.00,
       15.00,
       'ENC_NUMDOC',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'ENC_NUMDOC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '12',
       1520.00,
       15.00,
       'ENC_INSMUN',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'ENC_INSMUN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '12',
       1530.00,
       20.00,
       'ENC_INSEST',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'ENC_INSEST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '12',
       1540.00,
       50.00,
       'ENC_CODIGO',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'ENC_CODIGO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '12',
       1720.00,
       1.00,
       'PAR_SIMPLE',
       'L',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'PAR_SIMPLE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '12',
       1840.00,
       1.00,
       'PAR_REGESP',
       'L',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'PAR_REGESP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '13',
       240.00,
       12.00,
       'COM_VLRFRE',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Frete DOC',
       'Valor Frete DOC',
       '',
       'COM_VLRFRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '13',
       350.00,
       12.00,
       'COM_SUBSTT',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor ST COM',
       'Valor ST COM',
       '',
       'COM_SUBSTT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '13',
       390.00,
       5.00,
       'COM_PERFRE',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Perc Frete COM',
       'Perc Frete COM',
       '',
       'COM_PERFRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '13',
       400.00,
       2.00,
       'COM_CODFCE',
       'S',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cod CFE COM',
       'Cod CFE COM',
       '',
       'COM_CODFCE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '13',
       420.00,
       1.00,
       'COM_TIPPAR',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Tipo Parcela COM',
       'Tipo Parcela COM',
       '',
       'COM_TIPPAR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '13',
       490.00,
       12.00,
       'COM_BASFRE',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base Frete COM',
       'Base Frete COM',
       '',
       'COM_BASFRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '13',
       500.00,
       12.00,
       'COM_ICMFRE',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'ICMS Frete COM',
       'ICMS Frete COM',
       '',
       'COM_ICMFRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '13',
       580.00,
       1.00,
       'COM_NATFRE',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Natureza Frete COM',
       'Natureza Frete COM',
       '',
       'COM_NATFRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '14',
       1650.00,
       3.00,
       'CFG_VC_FILCLI',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'CFG_VC_FILCLI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '14',
       1660.00,
       6.00,
       'CFG_VC_CODCLI',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'CFG_VC_CODCLI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       100.00,
       30.00,
       'DOC_CODIGO',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Documento Codigo',
       'Documento Codigo',
       '',
       'DOC_CODIGO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       110.00,
       3.00,
       'DOC_CODFIL',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'FIlial',
       'FIlial',
       '',
       'DOC_CODFIL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       120.00,
       10.00,
       'DOC_SEQUEN',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'DOC_SEQUEN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       130.00,
       9.00,
       'DOC_NUMNOT',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nmero Documento',
       'Nmero Documento',
       '',
       'DOC_NUMNOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       140.00,
       8.00,
       'DOC_DATDOC',
       '@',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Documento',
       'Data Documento',
       '',
       'DOC_DATDOC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       150.00,
       8.00,
       'DOC_DATOPE',
       '@',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Operao',
       'Data Operao',
       '',
       'DOC_DATOPE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       160.00,
       30.00,
       'DOC_DOCNFP',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'DOC_DOCNFP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       180.00,
       12.00,
       'DOC_VLRLIQ',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Liq. Documento',
       'Valor Liq. Documento',
       '',
       'DOC_VLRLIQ',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       190.00,
       12.00,
       'DOC_DESCON',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Desconto Documento',
       'Desconto Documento',
       '',
       'DOC_DESCON',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       200.00,
       12.00,
       'DOC_VLRTOT',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Tot Documento',
       'Valor Tot Documento',
       '',
       'DOC_VLRTOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       210.00,
       10.00,
       'DOC_FLGEST',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Situao Documento',
       'Situao Documento',
       '',
       'DOC_FLGEST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       220.00,
       12.00,
       'DOC_BASICM',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base ICMS DOC',
       'Base ICMS DOC',
       '',
       'DOC_BASICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       230.00,
       12.00,
       'DOC_VLRICM',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor ICMS DOC',
       'Valor ICMS DOC',
       '',
       'DOC_VLRICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       250.00,
       12.00,
       'DOC_ISEICM',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor ICM Isento DOC',
       'Valor ICM Isento DOC',
       '',
       'DOC_ISEICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       260.00,
       12.00,
       'DOC_VLRIPI',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor IPI DOC',
       'Valor IPI DOC',
       '',
       'DOC_VLRIPI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       270.00,
       50.00,
       'DOC_CHAVEA',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Chave NFE',
       'Chave NFE',
       '',
       'DOC_CHAVEA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       280.00,
       12.00,
       'DOC_VLRFRE',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Frete DOC',
       'Valor Frete DOC',
       '',
       'DOC_VLRFRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       290.00,
       4.00,
       'DOC_VLRSEG',
       'G',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Seguro DOC',
       'Valor Seguro DOC',
       '',
       'DOC_VLRSEG',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       300.00,
       12.00,
       'DOC_OUTTAX',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Outra TAXA DOC',
       'Valor Outra TAXA DOC',
       '',
       'DOC_OUTTAX',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       310.00,
       12.00,
       'DOC_VLRPIS',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor PIS DOC',
       'Valor PIS DOC',
       '',
       'DOC_VLRPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       320.00,
       12.00,
       'DOC_VLRCOF',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Cofins DOC',
       'Valor Cofins DOC',
       '',
       'DOC_VLRCOF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       330.00,
       12.00,
       'DOC_BASSUB',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base ST DOC',
       'Base ST DOC',
       '',
       'DOC_BASSUB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       340.00,
       12.00,
       'DOC_SUBSTT',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor ST DOC',
       'Valor ST DOC',
       '',
       'DOC_SUBSTT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       360.00,
       1.00,
       'DOC_TIPNOT',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Tipo Nota DOC',
       'Tipo Nota DOC',
       '',
       'DOC_TIPNOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       370.00,
       250.00,
       'DOC_OBSFIS',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Observ DOC',
       'Observ DOC',
       '',
       'DOC_OBSFIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       380.00,
       5.00,
       'DOC_PERICM',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Perc ICMS DOC',
       'Perc ICMS DOC',
       '',
       'DOC_PERICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       410.00,
       1.00,
       'DOC_TIPFRE',
       'L',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Tipo Frete DOC',
       'Tipo Frete DOC',
       '',
       'DOC_TIPFRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       430.00,
       4.00,
       'DOC_BASISS',
       'G',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Base ISS DOC',
       'Base ISS DOC',
       '',
       'DOC_BASISS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       440.00,
       12.00,
       'DOC_VLRISS',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor ISS DOC',
       'Valor ISS DOC',
       '',
       'DOC_VLRISS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       450.00,
       5.00,
       'DOC_PERISS',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Perc ISS DOC',
       'Perc ISS DOC',
       '',
       'DOC_PERISS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       460.00,
       4.00,
       'DOC_BASIRR',
       'G',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Base IRR DOC',
       'Base IRR DOC',
       '',
       'DOC_BASIRR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       470.00,
       12.00,
       'DOC_VLRIRR',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor IRR DOC',
       'Valor IRR DOC',
       '',
       'DOC_VLRIRR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       480.00,
       5.00,
       'DOC_PERIRR',
       'F',
       '',
       2.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Perc IRR DOC',
       'Perc IRR DOC',
       '',
       'DOC_PERIRR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       510.00,
       3.00,
       'DOC_FILORI',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'DOC_FILORI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       520.00,
       10.00,
       'DOC_SEQORI',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'DOC_SEQORI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       530.00,
       12.00,
       'DOC_BSTFRE',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Base Frete DOC',
       'Base Frete DOC',
       '',
       'DOC_BSTFRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       540.00,
       12.00,
       'DOC_ST_FRE',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'ST Frete DOC',
       'ST Frete DOC',
       '',
       'DOC_ST_FRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       550.00,
       2.00,
       'DOC_CODFPS',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Codigo FPS DOC',
       'Codigo FPS DOC',
       '',
       'DOC_CODFPS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       560.00,
       2.00,
       'DOC_SITPIS',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Situao PIS DOC',
       'Situao PIS DOC',
       '',
       'DOC_SITPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       570.00,
       2.00,
       'DOC_SITCOF',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Situao Cofins DOC',
       'Situao Cofins DOC',
       '',
       'DOC_SITCOF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       590.00,
       4.00,
       'DOC_VLRPIS_RET',
       'G',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Vlr PIS Ret DOC',
       'Vlr PIS Ret DOC',
       '',
       'DOC_VLRPIS_RET',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       600.00,
       4.00,
       'DOC_VLRCOF_RET',
       'G',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Vlr Cof Ret DOC',
       'Vlr Cof Ret DOC',
       '',
       'DOC_VLRCOF_RET',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       610.00,
       10.00,
       'DOC_FLGNFE',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Situao NFE DOC',
       'Situao NFE DOC',
       '',
       'DOC_FLGNFE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       1610.00,
       10.00,
       'DOC_CODNAT',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'CFOP DOC',
       'CFOP DOC',
       '',
       'DOC_CODNAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       1620.00,
       40.00,
       'DOC_DESNAT',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'CFOP Descrio DOC',
       'CFOP Descrio DOC',
       '',
       'DOC_DESNAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       1710.00,
       4.00,
       'DOC_VLRIPI_DEVOLVIDO',
       'G',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       '',
       '',
       'DOC_VLRIPI_DEVOLVIDO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       1810.00,
       2.00,
       'DOC_NATBCC',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Finalidade DOC',
       'Finalidade DOC',
       '',
       'DOC_NATBCC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       1820.00,
       1.00,
       'DOC_CODDAR',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'DOC_CODDAR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       1830.00,
       1.00,
       'DOC_FINNFE',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'DOC_FINNFE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       1860.00,
       1.00,
       'DOC_ITENS_PROMOCAO',
       'L',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'DOC_ITENS_PROMOCAO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '15',
       1880.00,
       10.00,
       'DOC_MUN_DESTINO',
       'S',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       '',
       '',
       'DOC_MUN_DESTINO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPE',
       '16',
       1850.00,
       10.00,
       'NAT_TIPNAT',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'NAT_TIPNAT',
       '',
       'D' FROM DUAL
);

/*-- SEQ 10269 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VSPS',
       TO_NUMBER(null),
       'VSPS',
       'Registro Sped Saida',
       'TV_SPED_SAIDA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10270 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VSPS','--','' FROM DUAL
UNION ALL
SELECT 'VSPS','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VSPS','02','Documento' FROM DUAL
UNION ALL
SELECT 'VSPS','03','Venda' FROM DUAL
UNION ALL
SELECT 'VSPS','04','Item' FROM DUAL
UNION ALL
SELECT 'VSPS','05','Parceiro' FROM DUAL
UNION ALL
SELECT 'VSPS','06','Produto' FROM DUAL
UNION ALL
SELECT 'VSPS','07','Fiscal' FROM DUAL
UNION ALL
SELECT 'VSPS','99','Outros' FROM DUAL
);

/*-- SEQ 10271 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'VSPS',
       '--',
       12790,
       11,
       'ADI_NUMDRA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'ADI_NUMDRA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12570,
       6,
       'CFG_VC_CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'CFG_VC_CODCLI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12560,
       3,
       'CFG_VC_FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'CFG_VC_FILCLI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       540,
       20,
       'CTADOC_CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'CTADOC_CODEXT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       150,
       4,
       'DOC_BASICM',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc Base Icms',
       'Doc Base Icms',
       '',
       'DOC_BASICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       330,
       12,
       'DOC_BASIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc Base IRR',
       'Doc Base IRR',
       '',
       'DOC_BASIRR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       300,
       12,
       'DOC_BASISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc Base ISS',
       'Doc Base ISS',
       '',
       'DOC_BASISS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       250,
       12,
       'DOC_BASSUB',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc Base ST',
       'Doc Base ST',
       '',
       'DOC_BASSUB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       390,
       4,
       'DOC_BSTFRE',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc Base Frete',
       'Doc Base Frete',
       '',
       'DOC_BSTFRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       210,
       50,
       'DOC_CHAVEA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Doc Chave',
       'Doc Chave',
       '',
       'DOC_CHAVEA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       20,
       3,
       'DOC_CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Documento Filial',
       'Documento Filial',
       'DFIL.CODFIL(+) = VSPS.DOC_CODFIL',
       'DOC_CODFIL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       10,
       50,
       'DOC_CODIGO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Documento Codigo',
       'Documento Codigo',
       '',
       'DOC_CODIGO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       1610,
       6,
       'DOC_CODNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Doc Natureza',
       'Doc Natureza',
       '',
       'DOC_CODNAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       50,
       8,
       'DOC_DATDOC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Documento',
       'Data Documento',
       '',
       'DOC_DATDOC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       60,
       8,
       'DOC_DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Data Operao',
       'Data Operao',
       '',
       'DOC_DATOPE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       100,
       4,
       'DOC_DESCON',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Desconto Doc.',
       'Desconto Documento',
       '',
       'DOC_DESCON',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       1620,
       40,
       'DOC_DESNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Doc Descrio Nat.',
       'Doc Descrio Nature',
       '',
       'DOC_DESNAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       80,
       20,
       'DOC_DOCNFP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Documento Cupom',
       'Documento Cupom',
       '',
       'DOC_DOCNFP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12540,
       30,
       'DOC_FILORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'DOC_FILORI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12650,
       2,
       'DOC_FINNFE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'DOC_FINNFE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       140,
       2,
       'DOC_FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       '',
       'Doc Situao',
       'Doc Situao',
       '',
       'DOC_FLGEST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       380,
       1,
       'DOC_FLGNFE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Doc Situao Nfe',
       'Doc Situao Nfe',
       '',
       'DOC_FLGNFE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       180,
       4,
       'DOC_ISEICM',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc Seguro Frete',
       'Doc Seguro Frete',
       '',
       'DOC_ISEICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       700,
       1,
       'DOC_ITENS_PROMOCAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Item Promo',
       'Item Promo',
       '',
       'DOC_ITENS_PROMOCAO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12880,
       10,
       'DOC_MUN_DESTINO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'DOC_MUN_DESTINO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12640,
       2,
       'DOC_NATBCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'DOC_NATBCC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       40,
       6,
       'DOC_NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Numero Documento',
       'Numero Documento',
       '',
       'DOC_NUMNOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       280,
       250,
       'DOC_OBSFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Doc Observ Fiscal',
       'Doc Observ Fiscal',
       '',
       'DOC_OBSFIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       240,
       12,
       'DOC_OUTTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc Outras Taxas',
       'Doc Outras Taxas',
       '',
       'DOC_OUTTAX',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       290,
       4,
       'DOC_PERICM',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc Perc ICMS',
       'Doc Perc ICMS',
       '',
       'DOC_PERICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       350,
       4,
       'DOC_PERIRR',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc Perc IRR',
       'Doc Perc IRR',
       '',
       'DOC_PERIRR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       320,
       4,
       'DOC_PERISS',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc Perc Isso',
       'Doc Perc Isso',
       '',
       'DOC_PERISS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12550,
       10,
       'DOC_SEQORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'DOC_SEQORI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       30,
       10,
       'DOC_SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Documento Sequen.',
       'Documento Sequencia',
       '',
       'DOC_SEQUEN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       400,
       4,
       'DOC_ST_FRE',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc ST Frete',
       'Doc ST Frete',
       '',
       'DOC_ST_FRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       260,
       12,
       'DOC_SUBSTT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc Valor ST',
       'Doc Valor ST',
       '',
       'DOC_SUBSTT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       170,
       4,
       'DOC_TIPFRE',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc Tipo Frete',
       'Doc Tipo Frete',
       '',
       'DOC_TIPFRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       270,
       1,
       'DOC_TIPNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Doc Tipo Nota',
       'Doc Tipo Nota',
       '',
       'DOC_TIPNOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       120,
       4,
       'DOC_VLRCOF',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc Valor Cofins',
       'Doc Valor Cofins',
       '',
       'DOC_VLRCOF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       370,
       12,
       'DOC_VLRCOF_RET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc Vlr Cofins Ret',
       'Doc Vlr Cofins Ret',
       '',
       'DOC_VLRCOF_RET',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       220,
       12,
       'DOC_VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       '',
       'Doc Valor Frete',
       'Doc Valor Frete',
       '',
       'DOC_VLRFRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       160,
       4,
       'DOC_VLRICM',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc Valor Icms',
       'Doc Valor Icms',
       '',
       'DOC_VLRICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       190,
       4,
       'DOC_VLRIPI',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc Valor IPI',
       'Doc Valor IPI',
       '',
       'DOC_VLRIPI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12600,
       12,
       'DOC_VLRIPI_DEVOLVIDO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'DOC_VLRIPI_DEVOLVIDO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       200,
       4,
       'DOC_VLRIPI_TRA',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc Valor IPI TRA',
       'Doc Valor IPI TRA',
       '',
       'DOC_VLRIPI_TRA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       340,
       12,
       'DOC_VLRIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc Base IRR',
       'Doc Base IRR',
       '',
       'DOC_VLRIRR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       310,
       12,
       'DOC_VLRISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'DOc Valor ISS',
       'DOc Valor ISS',
       '',
       'DOC_VLRISS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       90,
       12,
       'DOC_VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Liquido',
       'Valor Liquido',
       '',
       'DOC_VLRLIQ',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       110,
       4,
       'DOC_VLRPIS',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc Valor Pis',
       'Doc Valor Pis',
       '',
       'DOC_VLRPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       360,
       12,
       'DOC_VLRPIS_RET',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc Vlr Pis Ret',
       'Doc Vlr Pis Ret',
       '',
       'DOC_VLRPIS_RET',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       230,
       12,
       'DOC_VLRSEG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc Volor Seguro',
       'Doc Volor Seguro',
       '',
       'DOC_VLRSEG',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '02',
       130,
       12,
       'DOC_VLRTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Doc Valor Total',
       'Doc Valor Total',
       '',
       'DOC_VLRTOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12610,
       20,
       'ECF_MARECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'ECF_MARECF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1390,
       40,
       'ENC_BAIRRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Bairro Cobrana',
       'Bairro Cobrana',
       '',
       'ENC_BAIRRO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1340,
       6,
       'ENC_CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'ENC_CODCLI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1320,
       30,
       'ENC_CODIGO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'ENC_CODIGO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1400,
       5,
       'ENC_CODPAI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       '',
       '',
       'ENC_CODPAI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1380,
       80,
       'ENC_COMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Complemento Cob.',
       'Complemento Cobrana',
       '',
       'ENC_COMPLE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1350,
       50,
       'ENC_ENDERE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Endereo Cobrana',
       'Endereo Cobrana',
       '',
       'ENC_ENDERE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1360,
       50,
       'ENC_ENDERE_ESTRAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'ENC_ENDERE_ESTRAN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1330,
       3,
       'ENC_FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'ENC_FILCLI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1440,
       50,
       'ENC_INSEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'ENC_INSEST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1430,
       15,
       'ENC_INSMUN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'ENC_INSMUN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1420,
       15,
       'ENC_NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'ENC_NUMDOC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1370,
       15,
       'ENC_NUMERO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Numero Cobrana',
       'Numero Cobrana',
       '',
       'ENC_NUMERO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1410,
       2,
       'ENC_SIGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Estado Cobrana',
       'Estado Cobrana',
       '',
       'ENC_SIGEST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1480,
       6,
       'ENE_CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'ENE_CODCLI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1490,
       3,
       'ENE_CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'ENE_CODFIL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1460,
       50,
       'ENE_CODIGO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'ENE_CODIGO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12440,
       5,
       'ENE_CODPAI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'ENE_CODPAI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1470,
       3,
       'ENE_FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'ENE_FILCLI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12430,
       30,
       'ENE_INSEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'ENE_INSEST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1510,
       15,
       'ENE_NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'ENE_NUMDOC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1500,
       4,
       'ENE_NUMEND',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       '',
       '',
       'ENE_NUMEND',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12450,
       2,
       'ENE_SIGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'ENE_SIGEST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12740,
       3,
       'EST_CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'EST_CODFIL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12750,
       10,
       'EST_SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'EST_SEQUEN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12760,
       1,
       'EST_TIPNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'EST_TIPNAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12670,
       4,
       'FIL_PERCOF',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'FIL_PERCOF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12660,
       4,
       'FIL_PERPIS',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'FIL_PERPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12690,
       12,
       'FIL_REGTRI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'FIL_REGTRI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12680,
       1,
       'FIL_TIPLUC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'FIL_TIPLUC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '07',
       560,
       2,
       'FIS_CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Fis Serie',
       'Fis Serie',
       '',
       'FIS_CODSER',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '07',
       550,
       2,
       'FIS_MODNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Fis Modelo',
       'Fis Modelo',
       '',
       'FIS_MODNOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '07',
       570,
       5,
       'FIS_SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Fis Sub Serir',
       'Fis Sub Serir',
       '',
       'FIS_SUBSER',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       1730,
       12,
       'ITE_ACR_ORIGINAL',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Item ACR Original',
       'Item ACR Original',
       '',
       'ITE_ACR_ORIGINAL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       870,
       12,
       'ITE_BASCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Base Cofins',
       'Base Cofins',
       '',
       'ITE_BASCOF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       740,
       12,
       'ITE_BASICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Base ICMS',
       'Base ICMS',
       '',
       'ITE_BASICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       810,
       12,
       'ITE_BASIPI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Base IPI',
       'Base IPI',
       '',
       'ITE_BASIPI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       840,
       12,
       'ITE_BASPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Base PIS',
       'Base PIS',
       '',
       'ITE_BASPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       720,
       12,
       'ITE_BASSUB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Base ST',
       'Base ST',
       '',
       'ITE_BASSUB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       680,
       1,
       'ITE_CALSUB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Calulo Sub',
       'Calulo Sub',
       '',
       'ITE_CALSUB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       950,
       5,
       'ITE_CODCST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Codigo CST Item',
       'Codigo CST Item',
       '',
       'ITE_CODCST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       590,
       3,
       'ITE_CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Filial Item',
       'Filial Item',
       '',
       'ITE_CODFIL',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       580,
       50,
       'ITE_CODIGO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Item Codigo',
       'Item Codigo',
       '',
       'ITE_CODIGO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       1640,
       6,
       'ITE_CODNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Natureza Item',
       'Natureza Item',
       '',
       'substr(ITE_CODNAT,1,4)',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       2050,
       6,
       'ITE_CODNATORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Natureza Fiscal',
       'Natureza Fiscal (CFOP)',
       '',
       'ITE_CODNAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       960,
       1,
       'ITE_CODORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Codigo Origem',
       'Codigo Origem',
       '',
       'ITE_CODORI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12530,
       40,
       'ITE_DESNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'ITE_DESNAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       1720,
       12,
       'ITE_DESRAT',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Item Desconto RAT',
       'Item Desconto RAT',
       '',
       'ITE_DESRAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       620,
       12,
       'ITE_EMBQTD',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Embalagem Item',
       'Embalagem Item',
       '',
       'ITE_EMBQTD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       660,
       1,
       'ITE_ICMTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'ICMS Tipo',
       'ICMS Tipo',
       '',
       'ITE_ICMTIP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       920,
       12,
       'ITE_ICMVEN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'ICMS Venda',
       'ICMS Venda',
       '',
       'ITE_ICMVEN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       890,
       4,
       'ITE_IPIFRE',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'IPI Frete',
       'IPI Frete',
       '',
       'ITE_IPIFRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       770,
       12,
       'ITE_ISEICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Isento ICMS',
       'Valor Isento ICMS',
       '',
       'ITE_ISEICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       780,
       1,
       'ITE_LANEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Lana Estoque',
       'Lana Estoque',
       '',
       'ITE_LANEST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       600,
       5,
       'ITE_NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Numero Item',
       'Numero Item',
       '',
       'ITE_NUMITE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       1870,
       4,
       'ITE_OUTTAX',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Item Outras Taxas',
       'Item Outras Taxas',
       '',
       'ITE_OUTTAX',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       880,
       7,
       'ITE_PERCOF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Percentual Cofins',
       'Percentual Cofins',
       '',
       'ITE_PERCOF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       850,
       7,
       'ITE_PERPIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Percentual PIS',
       'Percentual PIS',
       '',
       'ITE_PERPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       610,
       12,
       'ITE_QTDMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Quadade Item',
       'Quadade Item',
       '',
       'ITE_QTDMOV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       690,
       12,
       'ITE_RATEIO_PROMOCAO',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Rateio Promo',
       'Rateio Promo',
       '',
       'ITE_RATEIO_PROMOCAO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       670,
       7,
       'ITE_REDITE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Reduo Item',
       'Reduo Item',
       '',
       'ITE_REDITE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       910,
       4,
       'ITE_RED_ST',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Reduo ST',
       'Reduo ST',
       '',
       'ITE_RED_ST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       860,
       2,
       'ITE_SITCOF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Situao Cofins',
       'Situao Cofins',
       '',
       'ITE_SITCOF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       1140,
       5,
       'ITE_SITIPI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Situao IPI',
       'Situao IPI',
       '',
       'ITE_SITIPI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       940,
       1,
       'ITE_SITMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Situao Item',
       'Situao Item',
       '',
       'ITE_SITMOV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       830,
       2,
       'ITE_SITPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Situao PIS',
       'Situao PIS',
       '',
       'ITE_SITPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       730,
       12,
       'ITE_TAXICM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Taxa ICMS',
       'Taxa ICMS',
       '',
       'ITE_TAXICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       820,
       7,
       'ITE_TAXIPI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Taxa IPI',
       'Taxa IPI',
       '',
       'ITE_TAXIPI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       650,
       1,
       'ITE_TIPPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Tipo Produto',
       'Tipo Produto',
       '',
       'ITE_TIPPRO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       1840,
       12,
       'ITE_VALOR_FCP',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Item Valor FCP',
       'Item Valor FCP',
       '',
       'ITE_VALOR_FCP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12700,
       12,
       'ITE_VALOR_PARTILHA_DESTINO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'ITE_VALOR_PARTILHA_DESTINO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12710,
       12,
       'ITE_VALOR_PARTILHA_REMETENTE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'ITE_VALOR_PARTILHA_REMETENTE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       800,
       12,
       'ITE_VLRCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Cofins',
       'Valor Cofins',
       '',
       'ITE_VLRCOF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       640,
       12,
       'ITE_VLRDES',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Desconto',
       'Valor Desconto',
       '',
       'ITE_VLRDES',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       900,
       4,
       'ITE_VLRFRE',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Frete',
       'Valor Frete',
       '',
       'ITE_VLRFRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       750,
       12,
       'ITE_VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor ICMS',
       'Valor ICMS',
       '',
       'ITE_VLRICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       760,
       12,
       'ITE_VLRIPI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor IPI',
       'Valor IPI',
       '',
       'ITE_VLRIPI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       630,
       14,
       'ITE_VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Movimento',
       'Valor Movimento',
       '',
       'ITE_VLRMOV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       790,
       12,
       'ITE_VLRPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor PIS',
       'Valor PIS',
       '',
       'ITE_VLRPIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       930,
       12,
       'ITE_VLRUNI',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Unitario',
       'Valor Unitario',
       '',
       'ITE_VLRUNI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       710,
       12,
       'ITE_VLR_ST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor ST',
       'Valor ST',
       '',
       'ITE_VLR_ST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       970,
       12,
       'IVE_BASISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Base ISS',
       'Base ISS',
       '',
       'IVE_BASISS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12810,
       12,
       'IVE_BAS_II',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'IVE_BAS_II',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12730,
       1,
       'IVE_ESTORN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'IVE_ESTORN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12860,
       6,
       'IVE_PERCOFCRE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'IVE_PERCOFCRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12840,
       6,
       'IVE_PERPISCRE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'IVE_PERPISCRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       980,
       7,
       'IVE_TAXISS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Taxa ISS',
       'Taxa ISS',
       '',
       'IVE_TAXISS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12800,
       12,
       'IVE_VLRADU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'IVE_VLRADU',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12830,
       12,
       'IVE_VLRANT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'IVE_VLRANT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12870,
       12,
       'IVE_VLRCOFCRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'IVE_VLRCOFCRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       990,
       9,
       'IVE_VLRISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor ISS',
       'Valor ISS',
       '',
       'IVE_VLRISS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       1000,
       12,
       'IVE_VLRLIQ',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Liquido Item',
       'Valor Liquido Item',
       '',
       'IVE_VLRLIQ',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12850,
       12,
       'IVE_VLRPISCRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'IVE_VLRPISCRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12820,
       12,
       'IVE_VLR_II',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'IVE_VLR_II',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12590,
       12,
       'LID_CONCCF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'LID_CONCCF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12480,
       5,
       'MEDEMB_CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'MEDEMB_CODTAB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12510,
       20,
       'MEDEMB_DESMED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'MEDEMB_DESMED',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12490,
       1,
       'MEDEMB_MEDATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'MEDEMB_MEDATI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12500,
       20,
       'MEDEMB_UNIMED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'MEDEMB_UNIMED',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '06',
       1170,
       5,
       'MED_CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       '',
       '',
       'MED_CODTAB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '06',
       1200,
       20,
       'MED_DESMED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'MED_DESMED',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '06',
       1180,
       1,
       'MED_MEDATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       '',
       '',
       'MED_MEDATI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '06',
       1190,
       2,
       'MED_UNIMED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Unidade Medida',
       'Unidade Medida',
       '',
       'MED_UNIMED',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1450,
       10,
       'MUE_CODIBG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       '',
       '',
       'MUE_CODIBG',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12460,
       10,
       'MUF_CODIBG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'MUF_CODIBG',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1300,
       10,
       'MUN_CODIBG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'IBGE Municipio',
       'IBGE Municipio',
       '',
       'MUN_CODIBG',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1310,
       2,
       'MUN_SIGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Estado Municipio',
       'Estado Municipio',
       '',
       'MUN_SIGEST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12520,
       1,
       'NAT_TIPNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'NAT_TIPNAT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12770,
       12,
       'OIP_DOCIMP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'OIP_DOCIMP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12780,
       1,
       'OIP_TIPDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'OIP_TIPDOC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1230,
       6,
       'PAR_CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'PAR_CODCLI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1210,
       15,
       'PAR_CODIGO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Parceiro Codigo',
       'Parceiro Codigo',
       '',
       'PAR_CODIGO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1250,
       5,
       'PAR_CODPAI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '',
       '',
       '',
       'PAR_CODPAI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1220,
       3,
       'PAR_FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'PAR_FILCLI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1290,
       5,
       'PAR_FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Tipo Parceiro',
       'Tipo Parceiro',
       '',
       'PAR_FLGTIP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1270,
       30,
       'PAR_INSEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Inscrio Estad',
       'Inscrio Estadual',
       '',
       'PAR_INSEST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1240,
       64,
       'PAR_NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome Paceiro',
       'Nome Paceiro',
       '',
       'PAR_NOMCLI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1260,
       15,
       'PAR_NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Documento Parceiro',
       'Documento Parceiro',
       '',
       'PAR_NUMDOC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12620,
       1,
       'PAR_REGESP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'PAR_REGESP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12630,
       1,
       'PAR_SIMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'PAR_SIMPLE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '05',
       1280,
       9,
       'PAR_SUFRAM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Suframa',
       'Suframa',
       '',
       'PAR_SUFRAM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '06',
       1120,
       9,
       'PRO_CODANP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Codigo ANP',
       'Codigo ANP',
       '',
       'PRO_CODANP',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '06',
       2040,
       7,
       'PRO_CODCES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cest',
       'Cest',
       '',
       'PRO_CODCES',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '06',
       1050,
       20,
       'PRO_CODEAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Codigo de Barras',
       'Codigo de Barras',
       '',
       'PRO_CODEAN',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '06',
       1150,
       20,
       'PRO_CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Codigo Externo Pro',
       'Codigo Externo Pro',
       '',
       'PRO_CODEXT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '06',
       1060,
       2,
       'PRO_CODFPS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Codigo FPS',
       'Codigo FPS',
       '',
       'PRO_CODFPS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '06',
       1010,
       60,
       'PRO_CODIGO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Codigo Produto',
       'Codigo Produto',
       '',
       'PRO_CODIGO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '06',
       1070,
       8,
       'PRO_CODNCM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Codigo NCM',
       'Codigo NCM',
       '',
       'PRO_CODNCM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '06',
       1100,
       5,
       'PRO_CODSRV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Codigo SRV',
       'Codigo SRV',
       '',
       'PRO_CODSRV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '06',
       1080,
       3,
       'PRO_COD_EX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Codigo Externo',
       'Codigo Externo',
       '',
       'PRO_COD_EX',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '06',
       1090,
       10,
       'PRO_GENNCM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Gen NCM',
       'Gen NCM',
       '',
       'PRO_GENNCM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '06',
       1160,
       1,
       'PRO_IIPTPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       '',
       '',
       '',
       'PRO_IIPTPR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '06',
       1130,
       5,
       'PRO_NATBCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Origem',
       'Origem',
       '',
       'PRO_NATBCC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '06',
       1040,
       120,
       'PRO_NOMPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nome Produto',
       'Nome Produto',
       '',
       'PRO_NOMPRO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '06',
       1110,
       12,
       'PRO_PERICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Produto Perc ICMS',
       'Produto Perc ICMS',
       '',
       'PRO_PERICM',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '06',
       1030,
       15,
       'PRO_REFBAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Referencia Basica',
       'Referencia Basica',
       '',
       'PRO_REFBAS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '06',
       1020,
       20,
       'PRO_REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Referencia Produto',
       'Referencia Produto',
       '',
       'PRO_REFPRO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12470,
       12,
       'SUBORI_FATCON',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'SUBORI_FATCON',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12580,
       3,
       'TRA_FILITE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'TRA_FILITE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '03',
       450,
       1,
       'VEN_AVISTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Ven Avista',
       'Ven Avista',
       '',
       'VEN_AVISTA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '03',
       520,
       44,
       'VEN_CHVCAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Ven Chave Cancl',
       'Ven Chave Cancl',
       '',
       'VEN_CHVCAN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '03',
       420,
       5,
       'VEN_CNT_RO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Ven CntRO',
       'Ven CntRO',
       '',
       'VEN_CNT_RO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '03',
       430,
       8,
       'VEN_DATFIS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       '',
       'Ven Data Fiscal',
       'Ven Data Fiscal',
       '',
       'VEN_DATFIS',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '03',
       440,
       1,
       'VEN_EMIDES',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Ven Emisso',
       'Ven Emisso',
       '',
       'VEN_EMIDES',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '03',
       460,
       1,
       'VEN_FINANC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Ven Gerou Fin',
       'Ven Gerou Fin',
       '',
       'VEN_FINANC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '03',
       480,
       1,
       'VEN_FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Situao Venda',
       'Estado (Cancelado/Quitado/Em aberto)',
       '',
       'VEN_FLGEST',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '--',
       12720,
       1,
       'VEN_IMPEST',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'VEN_IMPEST',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '03',
       490,
       1,
       'VEN_INDFRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Ven Indificaa Fret',
       'Ven Indificaa Fret',
       '',
       'VEN_INDFRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '03',
       410,
       3,
       'VEN_NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Ven Numero ECF',
       'Ven Numero ECF',
       '',
       'VEN_NUMECF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '03',
       530,
       12,
       'VEN_SATCAN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Ven Sat Cancl',
       'Ven Sat Cancl',
       '',
       'VEN_SATCAN',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '03',
       510,
       6,
       'VEN_SATCFE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Ven Numero SAT',
       'Ven Numero SAT',
       '',
       'VEN_SATCFE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '03',
       500,
       9,
       'VEN_SATSER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Ven Serie SAT',
       'Ven Serie SAT',
       '',
       'VEN_SATSER',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '03',
       470,
       1,
       'VEN_TITAVU',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Ven Titulo Avulso',
       'Ven Titulo Avulso',
       '',
       'VEN_TITAVU',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSPS',
       '04',
       70,
       12,
       'VLROPE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Valor Operao',
       'Valor Operao',
       '',
       'VLROPE',
       '',
       'D' FROM DUAL
);
/*-- SEQ 10272 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VSPS',
       'VEN_FLGEST',
       0,
       'A',
       'Em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VSPS',
       'VEN_FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VSPS',
       'VEN_FLGEST',
       0,
       'I',
       'Incompleta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VSPS',
       'VEN_FLGEST',
       0,
       'Q',
       'Quitado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10273 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VSRB',
       TO_NUMBER(null),
       'VSRB',
       'San/Ref Cd.Barras',
       'TV_SANREF_BARRAS',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VSRB.CODFIL,VSRB.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 10274 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VSRB','--','' FROM DUAL
UNION ALL
SELECT 'VSRB','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VSRB','02','Valores' FROM DUAL
UNION ALL
SELECT 'VSRB','99','Outros' FROM DUAL
);

/*-- SEQ 10275 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VSRB',
       '01',
       60,
       30,
       'CODBAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cdigo de Barras',
       'Cdigo de Barras',
       '',
       'CODBAR',
       '' FROM DUAL
UNION ALL
SELECT 'VSRB',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL = VSRB.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VSRB',
       '01',
       40,
       20,
       'DOC_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'ID Documento',
       'Identificador do Documento',
       '',
       'DOC_ID',
       '' FROM DUAL
UNION ALL
SELECT 'VSRB',
       '99',
       30,
       1,
       'FLGFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Situao',
       'Situao',
       '',
       'FLGFIN',
       'T' FROM DUAL
UNION ALL
SELECT 'VSRB',
       '01',
       20,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       '',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       '' FROM DUAL
UNION ALL
SELECT 'VSRB',
       '02',
       50,
       12,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Movimentao',
       'Valor da Movimentao',
       '',
       'VLRMOV',
       '' FROM DUAL
);

/*-- SEQ 10276 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VSRB',
       'FLGFIN',
       0,
       'A',
       'Reforo em Aberto (Positivo)',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VSRB',
       'FLGFIN',
       0,
       'R',
       'Reforo Confirmado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10277 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VSTO',
       TO_NUMBER(null),
       'VSTO',
       'Salto Numerao',
       'TV_SALTONUMERACAO',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10278 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VSTO','--','' FROM DUAL
UNION ALL
SELECT 'VSTO','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VSTO','99','Outros' FROM DUAL
);

/*-- SEQ 10279 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'VSTO',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL(+) = VSTO.CODFIL',
       'CODFIL',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VSTO',
       '--',
       20,
       3,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Srie',
       'Srie',
       '',
       'CODSER',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSTO',
       '--',
       70,
       8,
       'MAXNOT',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Intervalo Mximo',
       'Intervalo Mximo Numerao',
       '',
       'MAXNOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSTO',
       '--',
       60,
       8,
       'MINNOT',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Intervalo Mnimo',
       'Intervalo Mnimo Numerao',
       '',
       'MINNOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSTO',
       '--',
       30,
       2,
       'MODNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Modelo da Nota',
       'Modelo da Nota',
       '',
       'MODNOT',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSTO',
       '--',
       80,
       8,
       'NUMERO',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nmero da Nota',
       'Nmero da Nota',
       '',
       'NUMERO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSTO',
       '--',
       40,
       3,
       'SERECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nmero ECF',
       'Nmero ECF',
       '',
       'SERECF',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VSTO',
       '--',
       50,
       3,
       'SERIE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Srie Fis. Exportada',
       'Srie Fiscal Exportada',
       '',
       'SERIE',
       '',
       'D' FROM DUAL
);

/*-- SEQ 10280 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VSTS',
       TO_NUMBER(null),
       'VSTS',
       'Sit. Trib. Caract.',
       'TV_STS_SINUELO',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10281 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VSTS','--','' FROM DUAL
UNION ALL
SELECT 'VSTS','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VSTS','70','Nota' FROM DUAL
UNION ALL
SELECT 'VSTS','80','Item' FROM DUAL
UNION ALL
SELECT 'VSTS','90','Conta' FROM DUAL
UNION ALL
SELECT 'VSTS','99','Outros' FROM DUAL
);

/*-- SEQ 10282 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VSTS',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       '',
       'Filial',
       'Filial',
       'DFIL.CODFIL(+) = VSTS.CODFIL',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'VSTS',
       '70',
       40,
       7,
       'DATFIS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fiscal',
       'Data Fiscal',
       '',
       'DATFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VSTS',
       '70',
       50,
       7,
       'DATMOV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data do Movimento',
       'Data do Movimento',
       '',
       'DATMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VSTS',
       '01',
       15,
       15,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento/ECF',
       'Documento/ECF',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VSTS',
       '90',
       90,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial da Conta',
       'Filial da Conta',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VSTS',
       '70',
       20,
       50,
       'NATURE',
       'A',
       'VCFO',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'VCFO.DESNAT',
       'V',
       '',
       '',
       'A',
       'F',
       'Natureza',
       'Natureza',
       'VCFO.NATDEN(+) = VSTS.NATURE OR VCFO.NATFOR(+) = VSTS.NATURE',
       'NATURE',
       'T' FROM DUAL
UNION ALL
SELECT 'VSTS',
       '90',
       91,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Seq. da Conta',
       'Seq. da Conta',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VSTS',
       '80',
       150,
       1,
       'SITMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao do Item',
       'Situao do Item',
       '',
       'SITMOV',
       'T' FROM DUAL
UNION ALL
SELECT 'VSTS',
       '70',
       180,
       50,
       'SITTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao Tributria',
       'Situao Tributria',
       '',
       'SITTRI',
       'T' FROM DUAL
UNION ALL
SELECT 'VSTS',
       '90',
       92,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo da Conta',
       'Tipo da Conta',
       '',
       'TIPCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VSTS',
       '01',
       5,
       3,
       'TIPREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Registro',
       'Tipo de Registro',
       '',
       'TIPREG',
       'T' FROM DUAL
UNION ALL
SELECT 'VSTS',
       '90',
       100,
       250,
       'TITCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo da Conta',
       'Ttulo da Conta',
       '',
       'TITCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VSTS',
       '70',
       190,
       12,
       'VLRBON',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor de Bonificao',
       'Valor de Bonificao',
       '',
       'VLRBON',
       'F' FROM DUAL
UNION ALL
SELECT 'VSTS',
       '80',
       200,
       12,
       'VLRBON_ITEM',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor de Bonif. Item',
       'Valor de Bonificao no Item',
       '',
       'VLRBON_ITEM',
       'F' FROM DUAL
UNION ALL
SELECT 'VSTS',
       '70',
       80,
       12,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Lquido',
       'Valor Lquido',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VSTS',
       '80',
       160,
       12,
       'VLRLIQ_ITEM',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Lquido Item',
       'Valor Lquido Item',
       '',
       'VLRLIQ_ITEM',
       'F' FROM DUAL
UNION ALL
SELECT 'VSTS',
       '80',
       170,
       12,
       'VLRMOV',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor do Item',
       'Valor do Item',
       '',
       'VLRMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VSTS',
       '70',
       210,
       12,
       'VLRTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Total',
       'Valor Total',
       '',
       'VLRTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VSTS',
       '80',
       220,
       12,
       'VLRTOT_ITEM',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Total do Item',
       'Valor Total do Item',
       '',
       'VLRTOT_ITEM',
       'F' FROM DUAL
);

/*-- SEQ 10283 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VSTS',
       'SITMOV',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VSTS',
       'SITMOV',
       0,
       'N',
       'Normal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VSTS',
       'SITTRI',
       0,
       ' ',
       'Alquota 0',
       TO_NUMBER(null),
       'Alquota 0' FROM DUAL
UNION ALL
SELECT 'VSTS',
       'SITTRI',
       0,
       ' ',
       'Monofsico',
       TO_NUMBER(null),
       'Monofsico' FROM DUAL
UNION ALL
SELECT 'VSTS',
       'SITTRI',
       0,
       ' ',
       'Substituto',
       TO_NUMBER(null),
       'Substituto' FROM DUAL
UNION ALL
SELECT 'VSTS',
       'SITTRI',
       0,
       ' ',
       'Tributado',
       TO_NUMBER(null),
       'Tributado' FROM DUAL
UNION ALL
SELECT 'VSTS',
       'TIPREG',
       0,
       ' ',
       'Compra',
       TO_NUMBER(null),
       'COM' FROM DUAL
UNION ALL
SELECT 'VSTS',
       'TIPREG',
       0,
       ' ',
       'Venda',
       TO_NUMBER(null),
       'VEN' FROM DUAL
);

/*-- SEQ 10284 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VT1 ',
       TO_NUMBER(null),
       'VT1 ',
       'Tab. 001',
       'TV_TAB_001',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VT1.CODFIL',
       '' FROM DUAL
);

/*-- SEQ 10285 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VT1 ','--','' FROM DUAL
UNION ALL
SELECT 'VT1 ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VT1 ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VT1 ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VT1 ','99','Outros' FROM DUAL
);

/*-- SEQ 10286 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'VT1 ',
       '99',
       10,
       50,
       'ACEFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Acesscios da Filial',
       'Acessrios da filial',
       '',
       'ACEFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       20,
       15,
       'BAIRRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Bairro',
       'Bairro',
       '',
       'BAIRRO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1770,
       3,
       'CAPMAX',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Capacidade Max Veic.',
       'Capacidade Mxima do Veculo',
       '',
       'CAPMAX',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       30,
       0,
       'CARATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Carto Ativo?',
       'Carto Ativo?',
       '',
       'CARATI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       40,
       30,
       'CCBTIT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo Carteira Bco',
       'Ttulo da Carteira Bancria',
       '',
       'CCBTIT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       50,
       15,
       'CGCFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'CNPJ',
       'CNPJ da filial',
       '',
       'CGCFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1810,
       4,
       'CILIND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cilindrada do Motor',
       'Cilindrada do Motor',
       '',
       'CILIND',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       60,
       64,
       'CLIADM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Cliente Admin.',
       'Cliente Adminsitrativo',
       '',
       'CLIADM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1560,
       1,
       'COBATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Cobrana Ativa?',
       'Cobrana Ativa?',
       '',
       'COBATI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       80,
       1,
       'COBCAR',
       'A',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       '',
       'A',
       'F',
       'Cobrana Carto',
       'Cobrana Carto',
       'DCOB.TIPCOB = VT1.COBCAR',
       'COBCAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       90,
       1,
       'COBECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Cobrana ECF',
       'Cobrana ECF',
       '',
       'COBECF',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       100,
       6,
       'CODADM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Admin.',
       'Cdigo Administrativo',
       '',
       'CODADM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       110,
       5,
       'CODCCB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cod Carteira',
       'Codigo Carteira',
       '',
       'CODCCB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       120,
       8,
       'CODCEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Cep',
       'Cdigo Cep',
       '',
       'CODCEP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       130,
       5,
       'CODCID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cidade',
       'Cdigo da Cidade',
       '',
       'CODCID',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       140,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Diviso do produto',
       'VT1.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1910,
       2,
       'CODCORDEN',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Cod Cor Denatran',
       'Cdigo da Cor no Denatran',
       '',
       'CODCORDEN',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       150,
       3,
       'CODDEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial depsito',
       'Cdigo da filial para depsito',
       '',
       'CODDEP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       160,
       10,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo externo',
       'Cdigo externo',
       '',
       'CODEXT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       170,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = VT1.CODFIL',
       'CODFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       1590,
       3,
       'CODGER',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Gerente',
       'Cdigo do Gerente',
       'USU2.FILUSU(+) = VT1.FILGER  AND USU2.CODUSU(+) = VT1.CODGER',
       'CODGER',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       180,
       5,
       'CODGRU',
       'F',
       'DGRU',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DGRU.DESGRU',
       'V',
       '',
       'F',
       '0',
       'F',
       'Grupo',
       'Cdigo do Grupo da Filial',
       'DGRU.CODTAB = VT1.CODGRU',
       'CODGRU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       190,
       3,
       'CODINT',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Codigo Integrador',
       'Cdigo Integrador',
       'USU2.FILUSU(+) = VT1.FILINT AND USU2.CODUSU(+) = VT1.CODINT',
       'CODINT',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       200,
       5,
       'CODLIB',
       'S',
       'DLIB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DLIB.DESLIB',
       'V',
       '',
       '',
       'A',
       'F',
       'Tipo Liberao',
       'Tipo Liberao',
       'DLIB.CODTAB = VT1.CODLIB',
       'CODLIB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1870,
       6,
       'CODMAR',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo da Marca Mod.',
       'Cdigo da Marca Modelo',
       '',
       'CODMAR',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       210,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Cdigo do material',
       '',
       'CODMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1730,
       5,
       'CODMTD',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo da Montadora',
       'Cdigo da Montadora',
       '',
       'CODMTD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       220,
       5,
       'CODMUL',
       'S',
       'DMUL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMUL.DESMUL',
       'V',
       '',
       '',
       'A',
       'F',
       'Sub-Estoque',
       'Nome do Sub-Estoque',
       'DMUL.CODTAB = VT1.CODMUL',
       'CODMUL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       230,
       3,
       'CODORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Origem',
       'Cdigo Origem',
       '',
       'CODORI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       240,
       3,
       'CODSAC',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Codigo Atendente',
       'Cdigo Atendente',
       'USU2.FILUSU(+) = VT1.FILSAC AND USU2.CODUSU(+) = VT1.CODSAC',
       'CODSAC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       250,
       2,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       260,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'VT1.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       270,
       3,
       'CODTST',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Revisor',
       'Cdigo Teste(Revisor)',
       'USU.FILUSU(+) = VT1.FILTST AND USU.CODUSU(+) = VT1.CODTST',
       'CODTST',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1840,
       5,
       'CODVEI',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Cdigo do Veculo',
       'Cdigo do Veculo',
       '',
       'CODVEI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       280,
       3,
       'CODWOR',
       'A',
       'USU2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU2.NOMUSU',
       'V',
       '',
       '',
       'A',
       'F',
       'Desenvolvedor',
       'Cdigo Desenvolvedor',
       'USU2.FILUSU(+) = VT1.FILWOR AND USU2.CODUSU(+) = VT1.CODWOR',
       'CODWOR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       290,
       45,
       'COMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Complemento',
       'Complemento',
       '',
       'COMPLE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       300,
       28,
       'CONTAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Contato',
       'Contato',
       '',
       'CONTAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1760,
       1,
       'CONVEI',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Condio do Veculo',
       'Condio do Veculo',
       '',
       'CONVEI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       310,
       1,
       'CONVER',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Convertido?',
       'Convertido?',
       '',
       'CONVER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1900,
       1,
       'CORVEIATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Cor do Vec. Ativa?',
       'Cor do veculo ativa?',
       '',
       'CORVEIATI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       320,
       1,
       'CTAABE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Conta Abertura',
       'Conta Abertura',
       '',
       'CTAABE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       330,
       1,
       'CTACAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Conta Caixa',
       'Conta Caixa',
       '',
       'CTACAI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       340,
       1,
       'CTACAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Conta do Cartao',
       'Conta do Cartao',
       '',
       'CTACAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       350,
       1,
       'CTADIF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Conta Diferena ECF',
       'Conta Diferena ECF',
       '',
       'CTADIF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       360,
       1,
       'CTAFEC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Conta Fechamento',
       'Conta Fechamento',
       '',
       'CTAFEC',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       370,
       1,
       'CTATRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Conta Cheque Troco',
       'Conta Cheque Troco',
       '',
       'CTATRO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       380,
       1,
       'CTRATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Contrato Ativo?',
       'Contrato Ativo?',
       '',
       'CTRATI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       390,
       3,
       'CTRFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial do Contrato',
       'Filial do Contrato',
       '',
       'CTRFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       400,
       10,
       'CTRSEQ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Seq, de Contrato',
       'Sequenciador de Contrato',
       '',
       'CTRSEQ',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       410,
       1,
       'CTRTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Plano de Contas',
       'Tipo Plano de contas',
       '',
       'CTRTIP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       420,
       1,
       'CTRUSO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Contrato de Uso',
       'Contrato de Uso',
       '',
       'CTRUSO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       430,
       1,
       'CX_ATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Caixa Ativo?',
       'Caixa Ativo?',
       '',
       'CX_ATI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       440,
       3,
       'CX_COD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Cdigo Lanam. Caixa',
       'Cdigo de lanamento caixa',
       '',
       'CX_COD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       450,
       30,
       'CX_DES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Descrio Lanam. C.',
       'Descrio de lanamento caixa',
       '',
       'CX_DES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       460,
       1,
       'CX_HIS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Pede Histrico?',
       'Lanamento pede histrico?',
       '',
       'CX_HIS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       470,
       2,
       'CX_USU',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Uso do Caixa',
       'Uso do lanamento caixa',
       '',
       'CX_USU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       480,
       4,
       'DDDFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'DDD Filial',
       'DDD Filial',
       '',
       'DDDFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1790,
       100,
       'DESCMO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Desc. Motor Veic.',
       'Descrio do Motor do Veculo',
       '',
       'DESCMO',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       490,
       30,
       'DESCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Descrio Cobrana',
       'Descrio da cobrana',
       '',
       'DESCOB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1890,
       100,
       'DESCORVEI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Descrio Cor Vec.',
       'Descrio da Cor do Veculo',
       '',
       'DESCORVEI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       500,
       30,
       'DESCTR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Descrio Contrato',
       'Descrio Contrato',
       '',
       'DESCTR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       510,
       30,
       'DESDOP_STD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Documento',
       'Descrio Documento',
       '',
       'DESDOP_STD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       520,
       30,
       'DESLIB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Liberao',
       'Descrio Liberao',
       '',
       'DESLIB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       530,
       30,
       'DESMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Material',
       'Descrio do Material',
       '',
       'DESMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1850,
       100,
       'DESMDV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Desc. do Modelo',
       'Descrio do Modelo',
       '',
       'DESMDV',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1710,
       100,
       'DESMTD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Desc. Montadora',
       'Descrio da Montadora',
       '',
       'DESMTD',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       540,
       20,
       'DESOUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Sada',
       'Descrio Sada',
       '',
       'DESOUT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       550,
       30,
       'DESSTD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Dsc. Situao Doc.',
       'Descrio Situao Tipo Documento',
       '',
       'DESSTD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '03',
       560,
       3,
       'DIACAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias de Carncia',
       'Dias de Carncia',
       '',
       'DIACAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '03',
       570,
       3,
       'DIADEB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Dias de Dbito',
       'Dias de Dbito',
       '',
       'DIADEB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1860,
       4,
       'DISEXI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Distncia dos Eixos',
       'Distncia entre os eixos',
       '',
       'DISEXI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '03',
       580,
       5,
       'DOMDOP',
       'F',
       'DDOP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDOP.DESDOP',
       'I',
       '',
       'T',
       '',
       'F',
       'Documento Pagamento',
       'Documento Pagamento',
       'DDOP. = DSTD.DOMDOP',
       'DOMDOP',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       590,
       1,
       'ECFATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'ECF Ativo?',
       'ECF Ativo',
       '',
       'ECFATI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       600,
       45,
       'ENDERE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Endereo',
       'Endereo',
       '',
       'ENDERE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1750,
       1,
       'ESPVEI',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Espcie do Veculo',
       'Espcie de Veculo',
       '',
       'ESPVEI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1690,
       10,
       'EXTCRE',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nm Externo Crdito',
       'Nmero Externo de Crdito',
       '',
       'EXTCRE',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1700,
       10,
       'EXTDEB',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Nm Externo Dbito',
       'Nmero Externo de Dbito',
       '',
       'EXTDEB',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       610,
       40,
       'E_MAIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E-mail',
       'E-mail',
       '',
       'E_MAIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       620,
       8,
       'FAXFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Fax Filial',
       'Fax Filial',
       '',
       'FAXFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       630,
       3,
       'FILABE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Abertura',
       'Filial Abertura',
       '',
       'FILABE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       640,
       3,
       'FILADM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Admin.',
       'Filial Administrativa',
       '',
       'FILADM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       650,
       1,
       'FILATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Filial Ativa?',
       'Filial Ativa?',
       '',
       'FILATI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       660,
       3,
       'FILCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Carto',
       'Filial Carto',
       '',
       'FILCAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       670,
       3,
       'FILCRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Crdito',
       'Filial Crdito',
       '',
       'FILCRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       680,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Conta ',
       '',
       'FILCTA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       690,
       3,
       'FILDEB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Dbito',
       'Filial Dbito',
       '',
       'FILDEB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       700,
       3,
       'FILDIF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Dif. Caixa',
       'Filial Diferencial de Caixa',
       '',
       'FILDIF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       710,
       3,
       'FILECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial ECF',
       'Filial Emissor Cupom Fiscal',
       '',
       'FILECF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       720,
       3,
       'FILFEC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Fecha. Caixa',
       'Filial Fechamento Caixa',
       '',
       'FILFEC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       1600,
       3,
       'FILGER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Gerente',
       '',
       'FILGER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       730,
       3,
       'FILINT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Integrador',
       'Filial Integrador',
       '',
       'FILINT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       740,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Material',
       '',
       'FILMAT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       750,
       3,
       'FILSAC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial SAC',
       '',
       'FILSAC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       760,
       3,
       'FILTES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Contas Tesouraria',
       '',
       'FILTES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       770,
       3,
       'FILTRN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial de Transferncia',
       '',
       'FILTRN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       780,
       3,
       'FILTRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Conta Cheque Troco',
       '',
       'FILTRO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       790,
       3,
       'FILTST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Revisor',
       '',
       'FILTST',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       800,
       3,
       'FILWOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Desenvolvedor(WorkFlow)',
       '',
       'FILWOR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       810,
       1,
       'FLGFLX',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Flag Fluxo',
       'Flag Fluxo',
       '',
       'FLGFLX',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       820,
       8,
       'FONFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Telefone Filial ',
       'Telefone Filial',
       '',
       'FONFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       830,
       1,
       'GERTIT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Gera Ttulos?',
       'Gera Ttulos?',
       '',
       'GERTIT',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1580,
       20,
       'GRUMOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Grupo dos Mdulos',
       'Grupo dos Mdulos',
       '',
       'GRUMOD',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       840,
       10,
       'HOMOL1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Homologao 1',
       'Homologao 1',
       '',
       'HOMOL1',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       850,
       10,
       'HOMOL2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Homologao 2',
       'Homologao 2',
       '',
       'HOMOL2',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       860,
       40,
       'HOMPGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Home Page',
       'Home Page',
       '',
       'HOMPGE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       1640,
       15,
       'IE_FIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Insc.Estadual Filial',
       'Inscrio Estadual da Filial',
       '',
       'IE_FIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       870,
       255,
       'IMGFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Imagem Filial',
       'Imagem Filial',
       '',
       'IMGFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '02',
       1570,
       7,
       'INIFIL',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Incio Filial',
       'Data Incio Filial',
       '',
       'INIFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '02',
       890,
       7,
       'INSTAL',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Instalao',
       'Data de Instalao',
       '',
       'INSTAL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       900,
       10,
       'INTUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Usurio Integrador',
       'Usurio Integrador',
       '',
       'INTUSU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '03',
       910,
       2,
       'LARUNI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Extenso',
       'Extenso',
       '',
       'LARUNI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       920,
       1,
       'LIBATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Liberao Ativa?',
       'Liberao Ativa?',
       '',
       'LIBATI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '03',
       1660,
       12,
       'LIMCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Limite Cofins',
       'Limite Cofins',
       '',
       'LIMCOF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       1650,
       200,
       'MAQECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Mquina ECF',
       'Nome Mquina ECF',
       '',
       'MAQECF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1780,
       13,
       'MAXTRA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Mxima Trao Veic.',
       'Trao Mxima do Veculo',
       '',
       'MAXTRA',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1880,
       1,
       'MDVATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Modelo Ativo?',
       'Modelo Ativo?',
       '',
       'MDVATI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       930,
       1,
       'MODATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Mdulo Ativo?',
       'Mdulo Ativo?',
       '',
       'MODATI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       940,
       5,
       'MODULO',
       'N',
       'DMOD',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOD.MODULO',
       'V',
       '',
       'F',
       'N',
       'F',
       'Mdulo',
       'Listagem de mdulos ',
       'DMOD.CODTAB = VT1.MODULO',
       'MODULO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1720,
       1,
       'MTDATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Montadora Ativa?',
       'Montadora Ativa?',
       '',
       'MTDATI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1830,
       1,
       'MTOATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       '',
       'Motor Ativo?',
       'Motor Ativo?',
       '',
       'MTOATI',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       950,
       15,
       'NOMFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Filial',
       'Nome Filial',
       '',
       'NOMFIL',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       960,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero ECF',
       'Nmero ECF',
       '',
       'NUMECF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       970,
       5,
       'NUMERO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero',
       'Nmero',
       '',
       'NUMERO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       980,
       12,
       'NUMFON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Telefone',
       'Nmero Telefone',
       '',
       'NUMFON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       990,
       10,
       'NUMSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nmero Srie',
       'Nmero Srie',
       '',
       'NUMSER',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1000,
       255,
       'PATCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path Carga Checout',
       'Path de carga dos CheckOuts',
       '',
       'PATCAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1010,
       255,
       'PATPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path Busca Pedidos',
       'Path de busca dos pedidos para os CheckOuts',
       '',
       'PATPED',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1020,
       255,
       'PATTKE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path Importa Arquivo',
       'Path de importao dos arquivos',
       '',
       'PATTKE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1030,
       255,
       'PAT_AA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Path Requisio ',
       'Path para requisies dos CheckOuts ao Totali CheckOut Server',
       '',
       'PAT_AA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '03',
       1610,
       6,
       'PERCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% COFINS',
       '% COFINS',
       '',
       'PERCOF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '03',
       1620,
       6,
       'PERPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% PIS',
       '% PIS',
       '',
       'PERPIS',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '03',
       1630,
       6,
       'PERSOC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '%Contribuio Social',
       '%Contribuio Social',
       '',
       'PERSOC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       1040,
       5,
       'PORCAR',
       'S',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       '',
       'A',
       'F',
       'Portador do Cartao',
       'Portador do Cartao',
       'DCOB.CODTAB = VT1.PORCAR',
       'PORCAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '03',
       1050,
       5,
       'PORECF',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'ECF do portador',
       'ECF do portador',
       '',
       'PORECF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1820,
       4,
       'POTENC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Potencia do Motor',
       'Potencia do Motor',
       '',
       'POTENC',
       '',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1060,
       1,
       'PROCAR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Carto Prprio?',
       'Carto Prprio?',
       '',
       'PROCAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       1070,
       45,
       'RAZSOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Razo Social',
       'Razo Social',
       '',
       'RAZSOC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       1080,
       45,
       'RESPON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Responsvel',
       'Responsvel',
       '',
       'RESPON',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       1090,
       10,
       'SACUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Usurio do SAC',
       'Usurio do SAC',
       '',
       'SACUSU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1100,
       200,
       'SAICAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sada da Carga',
       'Sada da Carga',
       '',
       'SAICAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1110,
       254,
       'SAIENV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sada de Envio',
       'Sada de Envio',
       '',
       'SAIENV',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1120,
       10,
       'SEQABE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Abertura',
       '',
       'SEQABE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1130,
       10,
       'SEQCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Carga',
       '',
       'SEQCAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1140,
       10,
       'SEQCRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Crdito',
       '',
       'SEQCRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1150,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Conta',
       '',
       'SEQCTA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1160,
       10,
       'SEQDEB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Dbito',
       '',
       'SEQDEB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1170,
       10,
       'SEQDIF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Diferencial de Caixa',
       '',
       'SEQDIF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1180,
       10,
       'SEQFEC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Fechamento',
       '',
       'SEQFEC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1190,
       10,
       'SEQTES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Contas Tesouraria',
       '',
       'SEQTES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1200,
       10,
       'SEQTRN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Transferncia',
       '',
       'SEQTRN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1210,
       10,
       'SEQTRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Conta Cheque Troco',
       '',
       'SEQTRO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1220,
       20,
       'SERECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nr Srie',
       'Nmero de Srie ECF',
       '',
       'SERECF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1230,
       1,
       'STDATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Sit. Doc. Ativo?',
       'Situao do Documento Ativo?',
       '',
       'STDATI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '03',
       1240,
       12,
       'TAXCAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Taxa Carncia',
       'Taxa Carncia',
       '',
       'TAXCAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '03',
       1250,
       12,
       'TAXDEB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Taxa Dbito',
       'Taxa Dbito',
       '',
       'TAXDEB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       1670,
       1,
       'TCMIPI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'CM c/IPI inc.PIS/COF',
       'Custo Mdio com IPI incluso na base de PIS/Cofins.',
       '',
       'TCMIPI',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1260,
       1,
       'TIPABE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo de Abertura',
       'Tipo de Abertura',
       '',
       'TIPABE',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1270,
       1,
       'TIPADM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Adminsitrativo',
       'Tipo Adminsitrativo',
       '',
       'TIPADM',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1680,
       1,
       'TIPBOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Bomba',
       'Tipo Bomba',
       '',
       'TIPBOM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1280,
       1,
       'TIPCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Carga',
       'Tipo Carga',
       '',
       'TIPCAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1290,
       1,
       'TIPCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Cobrana',
       'Tipo Cobrana',
       '',
       'TIPCOB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1800,
       2,
       'TIPCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo de Combustvel',
       'Tipo de Combustvel',
       '',
       'TIPCOM',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1300,
       1,
       'TIPCRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Credito',
       'Tipo Credito',
       '',
       'TIPCRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1310,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo da Conta',
       'Tipo da Conta',
       '',
       'TIPCTA',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1320,
       1,
       'TIPCTB',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       ' Conta Corrente?',
       ' Conta Corrente?',
       '',
       'TIPCTB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1330,
       1,
       'TIPDEB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Debito',
       'Tipo Debito',
       '',
       'TIPDEB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1340,
       1,
       'TIPDIF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Dif. Caixa',
       'Tipo Diferencial de Caixa',
       '',
       'TIPDIF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1350,
       1,
       'TIPFEC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Fechamento',
       'Tipo Fechamento',
       '',
       'TIPFEC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1360,
       1,
       'TIPTRN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Transferncia',
       'Tipo Transferncia',
       '',
       'TIPTRN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1370,
       1,
       'TIPTRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Cheque Troco',
       'Tipo Conta Cheque Troco',
       '',
       'TIPTRO',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1740,
       2,
       'TIPVEI',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       '',
       'Tipo de Veculo',
       'Tipo de Veculo',
       '',
       'TIPVEI',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1380,
       250,
       'TITABE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo Abertura',
       'Ttulo Abertura',
       '',
       'TITABE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1390,
       250,
       'TITCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo Carga',
       'Ttulo Carga',
       '',
       'TITCAR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1400,
       250,
       'TITCRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo Crdito',
       'Ttulo Crdito',
       '',
       'TITCRE',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1410,
       250,
       'TITCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo Conta',
       'Ttulo Conta',
       '',
       'TITCTA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1420,
       250,
       'TITCTR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo Contrato',
       'Ttulo Contrato',
       '',
       'TITCTR',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1430,
       250,
       'TITDEB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo Dbito',
       'Ttulo Dbito',
       '',
       'TITDEB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1440,
       250,
       'TITDIF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo Dif. Caixa',
       'Ttulo Diferencial de Caixa',
       '',
       'TITDIF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1450,
       250,
       'TITFEC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo Fechamento',
       'Ttulo Fechamento',
       '',
       'TITFEC',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1460,
       250,
       'TITTES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo da Tesouraria',
       'Ttulo da Tesouraria',
       '',
       'TITTES',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1470,
       250,
       'TITTRN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo Transferncia',
       'Ttulo Transferncia',
       '',
       'TITTRN',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1480,
       250,
       'TITTRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo Cheque Troco',
       'Ttulo Cheque Troco',
       '',
       'TITTRO',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1490,
       1,
       'TRANSF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Transferncia?',
       'Transferncia?',
       '',
       'TRANSF',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1500,
       10,
       'TSTUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Usurio Revisor',
       'Usurio Revisor',
       '',
       'TSTUSU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1510,
       4000,
       'TXTCOB',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Texto de Cobrana',
       'Texto de Cobrana',
       '',
       'TXTCOB',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       1520,
       2,
       'UFLOJA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'UF da Loja',
       'UF da Loja',
       '',
       'UFLOJA',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1530,
       1,
       'USOSTD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao Documentos',
       'Usa situao de Documentos',
       '',
       'USOSTD',
       'T',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '99',
       1540,
       4,
       'VERATU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Verso Atual',
       'Verso Atual',
       '',
       'VERATU',
       'F',
       'D' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       '01',
       1550,
       10,
       'WORUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Usurio do WorkFlow',
       'Usurio do WorkFlow',
       '',
       'WORUSU',
       'F',
       'D' FROM DUAL
);

/*-- SEQ 10287 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VT1 ',
       'COBECF',
       0,
       'E',
       'E',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'CODCORDEN',
       1,
       ' ',
       'Amarelo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'CODCORDEN',
       2,
       ' ',
       'Azul',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'CODCORDEN',
       3,
       ' ',
       'Bege',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'CODCORDEN',
       4,
       ' ',
       'Branca',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'CODCORDEN',
       5,
       ' ',
       'Cinza',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'CODCORDEN',
       6,
       ' ',
       'Dourado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'CODCORDEN',
       7,
       ' ',
       'Gren',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'CODCORDEN',
       8,
       ' ',
       'Laranja',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'CODCORDEN',
       9,
       ' ',
       'Marrom',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'CODCORDEN',
       10,
       ' ',
       'Prata',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'CODCORDEN',
       11,
       ' ',
       'Preta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'CODCORDEN',
       12,
       ' ',
       'Rosa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'CODCORDEN',
       13,
       ' ',
       'Roxa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'CODCORDEN',
       14,
       ' ',
       'Verde',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'CODCORDEN',
       15,
       ' ',
       'Vermelha',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'CODCORDEN',
       16,
       ' ',
       'Fantasia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'CONVEI',
       3,
       ' ',
       'Semiacabado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'CONVEI',
       1,
       ' ',
       'Acabado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'CONVEI',
       2,
       ' ',
       'Inacabado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'CTAFEC',
       0,
       'E',
       'E',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'CTATRO',
       0,
       'E',
       'E',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'CTRUSO',
       0,
       '0',
       'No Classificado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'ESPVEI',
       1,
       ' ',
       'Passageiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'ESPVEI',
       2,
       ' ',
       'Carga',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'ESPVEI',
       3,
       ' ',
       'Misto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'ESPVEI',
       4,
       ' ',
       'Corrida',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'ESPVEI',
       5,
       ' ',
       'Trao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'ESPVEI',
       6,
       ' ',
       'Especial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'FLGFLX',
       0,
       'A',
       'Em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'FLGFLX',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'FLGFLX',
       0,
       'R',
       'Realizado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPABE',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPABE',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPABE',
       0,
       'N',
       'Numrica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPBOM',
       0,
       '0',
       'No Usa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPBOM',
       0,
       '1',
       'TKE',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPBOM',
       0,
       '2',
       'Logitron',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPBOM',
       0,
       '9',
       'Manual',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPCOM',
       0,
       ' ',
       'lcool',
       TO_NUMBER(null),
       '01' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPCOM',
       0,
       ' ',
       'Gasolina',
       TO_NUMBER(null),
       '02' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPCOM',
       0,
       ' ',
       'Diesel',
       TO_NUMBER(null),
       '03' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPCOM',
       0,
       ' ',
       'Gasognio',
       TO_NUMBER(null),
       '04' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPCOM',
       0,
       ' ',
       'Gs Metano',
       TO_NUMBER(null),
       '05' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPCOM',
       0,
       ' ',
       'Eltrico/Fonte Interna',
       TO_NUMBER(null),
       '06' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPCOM',
       0,
       ' ',
       'Eltrico/Fonte Externa',
       TO_NUMBER(null),
       '07' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPCOM',
       0,
       ' ',
       'Gasolina/Gs Naturla Com.',
       TO_NUMBER(null),
       '08' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPCOM',
       0,
       ' ',
       'lcool/Gs Natural Combustvel',
       TO_NUMBER(null),
       '09' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPCOM',
       0,
       ' ',
       'Diesel/Gs Natural Combustvel',
       TO_NUMBER(null),
       '10' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPCOM',
       0,
       ' ',
       'Vide/Campo/Observao',
       TO_NUMBER(null),
       '11' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPCOM',
       0,
       ' ',
       'lcool/Gs Natural Veicular',
       TO_NUMBER(null),
       '12' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPCOM',
       0,
       ' ',
       'Gasolina/Gs Natural Veicular',
       TO_NUMBER(null),
       '13' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPCOM',
       0,
       ' ',
       'Diesel/Gs Natural Veicular',
       TO_NUMBER(null),
       '14' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPCOM',
       0,
       ' ',
       'Gs Natural Veicular',
       TO_NUMBER(null),
       '15' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPCOM',
       0,
       ' ',
       'lcool/Gasolina',
       TO_NUMBER(null),
       '16' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPCOM',
       0,
       ' ',
       'Gasolina/lcool/Gs Nat. Veic.',
       TO_NUMBER(null),
       '17' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPCOM',
       0,
       ' ',
       'Gasolina/Eltrico',
       TO_NUMBER(null),
       '18' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPCTA',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPCTA',
       0,
       'M',
       'Transferncia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPCTA',
       0,
       'N',
       'Numerria',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPTRO',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPTRO',
       0,
       'N',
       'Numrica',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPVEI',
       2,
       ' ',
       'Ciclomoto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPVEI',
       3,
       ' ',
       'Motoneta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPVEI',
       4,
       ' ',
       'Motociclo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPVEI',
       5,
       ' ',
       'Triciclo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPVEI',
       6,
       ' ',
       'Automvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPVEI',
       7,
       ' ',
       'Micro-nibus',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPVEI',
       8,
       ' ',
       'nibus',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPVEI',
       10,
       ' ',
       'Reboque',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPVEI',
       11,
       ' ',
       'Semirreboque',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPVEI',
       13,
       ' ',
       'Camioneta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPVEI',
       14,
       ' ',
       'Caminho',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPVEI',
       17,
       ' ',
       'Caminho Trator',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPVEI',
       18,
       ' ',
       'Trator Rodas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPVEI',
       19,
       ' ',
       'Trator Esteiras',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPVEI',
       20,
       ' ',
       'Trator Misto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPVEI',
       21,
       ' ',
       'Quadriciclo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPVEI',
       22,
       ' ',
       'ESP/nibus',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPVEI',
       23,
       ' ',
       'Caminhonete',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPVEI',
       24,
       ' ',
       'Carga/Cam',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPVEI',
       25,
       ' ',
       'Utilitrio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'TIPVEI',
       26,
       ' ',
       'Motor-Casa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'USOSTD',
       0,
       'A',
       'Ativo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VT1 ',
       'USOSTD',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10288 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VT2 ',
       TO_NUMBER(null),
       'VT2 ',
       'Tab. 002',
       'TV_TAB_002',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10289 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VT2 ','--','' FROM DUAL
UNION ALL
SELECT 'VT2 ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VT2 ','99','Outros' FROM DUAL
);

/*-- SEQ 10290 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VT2 ',
       '--',
       10,
       10,
       'ABANCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ABANCO',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       20,
       1,
       'ALIINT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ALIINT',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       30,
       1,
       'AMPATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'AMPATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       40,
       10,
       'APECCB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'APECCB',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3190,
       10,
       'APEPRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'APEPRI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3450,
       1,
       'APRATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'APRATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3460,
       1,
       'APROVA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'APROVA',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3240,
       1,
       'ARCATV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ARCATV',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       50,
       254,
       'ASSCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ASSCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       60,
       1,
       'ATIHOM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ATIHOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3200,
       1,
       'AVIJUS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'AVIJUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3110,
       12,
       'BASOCU',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'BASOCU',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       70,
       1,
       'BCOATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'BCOATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3490,
       1,
       'BICATV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'BICATV',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       80,
       4000,
       'CABCOM',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CABCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       90,
       4000,
       'CABPRE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CABPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       100,
       3,
       'CBANCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CBANCO',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       110,
       1,
       'CCBATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CCBATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       120,
       1,
       'CCCATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CCCATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       130,
       20,
       'CENCUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CENCUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3350,
       1,
       'CFOATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CFOATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       140,
       1,
       'CL1ATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CL1ATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       150,
       1,
       'CL2ATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CL2ATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       160,
       1,
       'CL3ATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CL3ATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       170,
       1,
       'CL4ATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CL4ATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       180,
       1,
       'CLACON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CLACON',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       190,
       40,
       'CLASS1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CLASS1',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       200,
       40,
       'CLASS2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CLASS2',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       210,
       40,
       'CLASS3',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CLASS3',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       220,
       40,
       'CLASS4',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CLASS4',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3390,
       1,
       'CLIDEV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CLIDEV',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       230,
       1,
       'CLILIV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CLILIV',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       240,
       1,
       'CLTATV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CLTATV',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       250,
       1,
       'CNCATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CNCATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3360,
       6,
       'CODCFO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODCFO',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3320,
       2,
       'CODDFC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODDFC',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       260,
       5,
       'CODDIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       270,
       20,
       'CODEX1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODEX1',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       280,
       20,
       'CODEX2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODEX2',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       290,
       20,
       'CODEX3',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODEX3',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       300,
       20,
       'CODEX4',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODEX4',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       310,
       20,
       'CODFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3480,
       3,
       'CODFUN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODFUN',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       320,
       2,
       'CODHOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODHOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       330,
       5,
       'CODSAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODSAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       340,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       350,
       5,
       'CODSUB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       360,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3500,
       5,
       'CODTAN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODTAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       370,
       20,
       'CODTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       380,
       1,
       'COLATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'COLATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       390,
       2,
       'COLQTD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'COLQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       400,
       2,
       'COLREF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'COLREF',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       410,
       1,
       'COMATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'COMATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       420,
       1,
       'COMCCC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'COMCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       430,
       80,
       'COMENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'COMENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       440,
       25,
       'COMJUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'COMJUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       450,
       1,
       'CONATI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CONATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3650,
       1,
       'CONSFI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CONSFI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       460,
       15,
       'CONTAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CONTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       470,
       1,
       'CORATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CORATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3250,
       1,
       'CORATV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CORATV',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3260,
       30,
       'COR_DESCOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'COR_DESCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       480,
       1,
       'CT1ATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CT1ATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       490,
       1,
       'CT2ATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CT2ATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       500,
       1,
       'CT3ATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CT3ATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       510,
       1,
       'CTACCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CTACCC',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       520,
       1,
       'CUSATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CUSATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       530,
       1,
       'CWSATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CWSATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       540,
       1,
       'DADREC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DADREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       550,
       3,
       'DELIMI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DELIMI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       560,
       1,
       'DEPATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DEPATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3470,
       20,
       'DESAPR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESAPR',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3270,
       30,
       'DESARC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESARC',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       570,
       1,
       'DESATV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESATV',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       580,
       20,
       'DESCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       590,
       30,
       'DESCCB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESCCB',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       600,
       30,
       'DESCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3370,
       30,
       'DESCFO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESCFO',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       610,
       25,
       'DESCLT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESCLT',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       620,
       30,
       'DESCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       630,
       15,
       'DESCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3310,
       30,
       'DESCOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       650,
       100,
       'DESCWS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESCWS',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       660,
       40,
       'DESDEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       670,
       30,
       'DESDEV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESDEV',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3330,
       30,
       'DESDFC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESDFC',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       680,
       30,
       'DESDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       690,
       30,
       'DESDOP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESDOP',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       700,
       10,
       'DESEAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESEAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       710,
       30,
       'DESECB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESECB',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3420,
       20,
       'DESEND',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESEND',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       720,
       20,
       'DESETI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESETI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       730,
       15,
       'DESFIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       740,
       100,
       'DESFUN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESFUN',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       750,
       30,
       'DESGRU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESGRU',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       760,
       20,
       'DESHOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESHOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3210,
       20,
       'DESINA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESINA',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       770,
       30,
       'DESINS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESINS',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       780,
       30,
       'DESJUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESJUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       790,
       30,
       'DESLAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESLAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       800,
       5,
       'DESMOE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESMOE',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3130,
       30,
       'DESMON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESMON',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       810,
       30,
       'DESMUL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       820,
       30,
       'DESMULDEV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESMULDEV',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3400,
       30,
       'DESMULNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESMULNAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       830,
       30,
       'DESOBS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESOBS',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3120,
       30,
       'DESOCU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESOCU',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       840,
       30,
       'DESPRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       850,
       100,
       'DESPRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESPRI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       860,
       30,
       'DESREM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESREM',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       870,
       30,
       'DESRET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESRET',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       880,
       20,
       'DESSAZ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESSAZ',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       890,
       25,
       'DESSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       900,
       15,
       'DESSET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESSET',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       910,
       30,
       'DESVEI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESVEI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       920,
       30,
       'DESVTP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESVTP',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       930,
       4,
       'DEVATE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DEVATE',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       940,
       1,
       'DEVATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DEVATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       950,
       4,
       'DEVCOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DEVCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       960,
       4,
       'DEVICM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DEVICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       970,
       4,
       'DEVMON',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DEVMON',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3340,
       1,
       'DFCATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DFCATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       980,
       2,
       'DIARET',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DIARET',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       990,
       200,
       'DISSAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DISSAI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1000,
       1,
       'DIVATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DIVATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1010,
       1,
       'DIVTRO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DIVTRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1020,
       1,
       'DOCATV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DOCATV',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1030,
       1,
       'DOPATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DOPATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3430,
       1,
       'DUPEND',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DUPEND',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1040,
       1,
       'EANATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'EANATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1050,
       6,
       'EANCOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'EANCOD',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1060,
       3,
       'EANFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'EANFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1070,
       1,
       'ECBATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ECBATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3440,
       1,
       'ENDATV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ENDATV',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1080,
       1,
       'ENVREM',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ENVREM',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1090,
       1,
       'ESPATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ESPATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1100,
       20,
       'ESPECI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ESPECI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1110,
       2,
       'ESTADO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ESTADO',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1120,
       1,
       'ESTATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ESTATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1130,
       1,
       'ES_ATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ES_ATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1140,
       1,
       'ETIATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ETIATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3380,
       10,
       'EXTCFO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'EXTCFO',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1150,
       10,
       'EXTDEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'EXTDEM',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1160,
       10,
       'EXTFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'EXTFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1170,
       5,
       'EXTNOT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'EXTNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1180,
       4000,
       'FBANCO',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FBANCO',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3510,
       3,
       'FILBIC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILBIC',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1190,
       3,
       'FILCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1200,
       3,
       'FILSET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILSET',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3520,
       3,
       'FILTAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILTAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1210,
       3,
       'FIMQTD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FIMQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1220,
       3,
       'FIMREF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FIMREF',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1230,
       1,
       'FINANC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FINANC',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1240,
       1,
       'FINATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FINATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1250,
       1,
       'FISATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FISATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1260,
       1,
       'FLGNEW',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FLGNEW',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1270,
       1,
       'FOOTER',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FOOTER',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1280,
       1,
       'FUNATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FUNATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1290,
       1,
       'GRAATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'GRAATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3530,
       5,
       'GRACOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'GRACOD',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3540,
       5,
       'GRACOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'GRACOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3550,
       3,
       'GRAFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'GRAFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3560,
       5,
       'GRATAM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'GRATAM',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1300,
       1,
       'GRUATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'GRUATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1310,
       1,
       'HEADER',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'HEADER',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1320,
       15,
       'HORCWS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'HORCWS',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1330,
       7,
       'HORPAD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'HORPAD',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1340,
       7,
       'HORTRN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'HORTRN',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1350,
       1,
       'ICMATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ICMATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1360,
       1,
       'ICMCID',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ICMCID',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1370,
       12,
       'ICMSES',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ICMSES',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1380,
       12,
       'ICMSME',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ICMSME',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1390,
       12,
       'ICMSR1',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ICMSR1',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1400,
       12,
       'ICMSR2',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ICMSR2',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1410,
       12,
       'ICMSRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ICMSRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1420,
       255,
       'IMGDEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'IMGDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1430,
       1,
       'IMPNOT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'IMPNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3220,
       1,
       'INAATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'INAATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1440,
       3,
       'INIQTD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'INIQTD',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1450,
       3,
       'INIREF',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'INIREF',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1460,
       1,
       'INSATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'INSATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1470,
       15,
       'INSCST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'INSCST',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1480,
       1,
       'IPIATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'IPIATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1490,
       1,
       'IRRATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'IRRATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1500,
       1,
       'ISOATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ISOATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1510,
       1,
       'ISSATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ISSATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1520,
       4000,
       'ITECOM',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ITECOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1530,
       4000,
       'ITEPRE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ITEPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1540,
       1,
       'JUSATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'JUSATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1550,
       1,
       'LANATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'LANATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1560,
       1,
       'LANEDI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'LANEDI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1570,
       5,
       'LANNAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'LANNAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1580,
       1,
       'LANVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'LANVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1590,
       1,
       'LANVLR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'LANVLR',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1600,
       5,
       'LIMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'LIMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1610,
       30,
       'LIVRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'LIVRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1620,
       1,
       'MARATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1630,
       12,
       'MARG00',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARG00',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1640,
       12,
       'MARG01',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARG01',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1650,
       12,
       'MARG02',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARG02',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1660,
       12,
       'MARG03',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARG03',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1670,
       12,
       'MARG04',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARG04',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1680,
       12,
       'MARG05',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARG05',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1690,
       12,
       'MARG06',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARG06',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1700,
       12,
       'MARG07',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARG07',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1710,
       12,
       'MARG08',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARG08',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1720,
       12,
       'MARG09',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARG09',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3570,
       3,
       'MAXCHE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MAXCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1730,
       1,
       'MEDATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MEDATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1740,
       1,
       'ME_ATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ME_ATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1750,
       2,
       'MODNOT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MODNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1760,
       1,
       'MOEATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MOEATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3140,
       1,
       'MONATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MONATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3150,
       12,
       'MONCOR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MONCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3160,
       12,
       'MONDEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MONDEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3170,
       12,
       'MONINT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MONINT',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3180,
       12,
       'MONURB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MONURB',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1770,
       20,
       'MOTVPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MOTVPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1780,
       1,
       'MOVEST',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MOVEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1790,
       1,
       'MULATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MULATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1800,
       5,
       'MULDEV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MULDEV',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1810,
       1,
       'NATATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1820,
       6,
       'NATDEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATDEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1830,
       6,
       'NATFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1840,
       6,
       'NATFUD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATFUD',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1850,
       6,
       'NATFUF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATFUF',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3410,
       5,
       'NATMUL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1860,
       1,
       'NATOLN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATOLN',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1870,
       6,
       'NATRED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATRED',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1880,
       6,
       'NATREF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATREF',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1890,
       40,
       'NATURE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATURE',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1900,
       30,
       'NBANCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NBANCO',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3580,
       1,
       'NIVPRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NIVPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1910,
       30,
       'NOMCNC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NOMCNC',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1920,
       30,
       'NOMCOL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NOMCOL',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1930,
       40,
       'NOMCT1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NOMCT1',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1940,
       40,
       'NOMCT2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NOMCT2',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1950,
       40,
       'NOMCT3',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NOMCT3',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1960,
       20,
       'NOMDIV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NOMDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1970,
       28,
       'NOMEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NOMEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1980,
       20,
       'NOMGRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NOMGRA',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       1990,
       20,
       'NOMSUB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NOMSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2000,
       1,
       'NORINT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NORINT',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3590,
       2,
       'NUMBOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NUMBOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2010,
       5,
       'NUMCOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NUMCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2020,
       5,
       'NUMPRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NUMPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2030,
       1,
       'OBSATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'OBSATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2040,
       3,
       'OBSCOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'OBSCOL',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2050,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2060,
       3,
       'OBSLIN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'OBSLIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2070,
       4000,
       'OBSPRI',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'OBSPRI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2080,
       1,
       'ONDCAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ONDCAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2090,
       5,
       'ORDDIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ORDDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2100,
       5,
       'ORDSUB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ORDSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2110,
       1,
       'OUTATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'OUTATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2120,
       1,
       'PEDAUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PEDAUT',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2130,
       12,
       'PERICM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PERICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2140,
       7,
       'PESMAX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PESMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2150,
       5,
       'PESPRI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PESPRI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2160,
       12,
       'PHOALT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PHOALT',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2170,
       1,
       'PHOATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PHOATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2180,
       15,
       'PHOCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PHOCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2190,
       15,
       'PHOISO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PHOISO',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2200,
       12,
       'PHOLAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PHOLAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2210,
       15,
       'PHOMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PHOMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2220,
       15,
       'PHOOUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PHOOUT',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2230,
       15,
       'PHOTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PHOTIP',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2240,
       8,
       'PLACAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PLACAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2250,
       1,
       'PREATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PREATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2260,
       1,
       'PRIATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRIATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2270,
       10,
       'PRJSET',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRJSET',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2280,
       1,
       'QTDDEC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'QTDDEC',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2290,
       2,
       'QTDDIA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'QTDDIA',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3600,
       2,
       'QTDENC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'QTDENC',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2300,
       5,
       'QTDITP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'QTDITP',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2310,
       5,
       'QTDITS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'QTDITS',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2320,
       1,
       'R1_ATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'R1_ATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2330,
       1,
       'R2_ATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'R2_ATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2340,
       255,
       'RBFILE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'RBFILE',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3280,
       254,
       'RB_COR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'RB_COR',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2350,
       1,
       'REGATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'REGATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2360,
       15,
       'REGCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'REGCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2370,
       15,
       'REGIAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'REGIAO',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2380,
       1,
       'REMATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'REMATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2390,
       12,
       'RESICM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'RESICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2400,
       12,
       'RESIPI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'RESIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2410,
       12,
       'RESIRR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'RESIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2420,
       12,
       'RESISS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'RESISS',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2430,
       1,
       'RESTRI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'RESTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2440,
       15,
       'RESULT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'RESULT',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2450,
       1,
       'RETATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'RETATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2460,
       1,
       'RE_ATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'RE_ATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2470,
       4000,
       'RODCOM',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'RODCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2480,
       4000,
       'RODPRE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'RODPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2490,
       1,
       'ROSATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ROSATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2500,
       12,
       'SAZ001',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SAZ001',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2510,
       12,
       'SAZ002',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SAZ002',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2520,
       12,
       'SAZ003',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SAZ003',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2530,
       12,
       'SAZ004',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SAZ004',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2540,
       12,
       'SAZ005',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SAZ005',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2550,
       12,
       'SAZ006',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SAZ006',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2560,
       12,
       'SAZ007',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SAZ007',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2570,
       12,
       'SAZ008',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SAZ008',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2580,
       12,
       'SAZ009',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SAZ009',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2590,
       12,
       'SAZ010',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SAZ010',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2600,
       12,
       'SAZ011',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SAZ011',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2610,
       12,
       'SAZ012',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SAZ012',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2620,
       1,
       'SAZATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SAZATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2630,
       1,
       'SEPDEC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEPDEC',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3610,
       2,
       'SEQBOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQBOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3620,
       2,
       'SEQFIL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2640,
       1,
       'SERATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SERATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2650,
       6,
       'SERFIM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SERFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2660,
       6,
       'SERINI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SERINI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2670,
       1,
       'SERMAN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SERMAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2680,
       2,
       'SERVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SERVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2690,
       1,
       'SETATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SETATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2700,
       1,
       'SINLAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SINLAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2710,
       1,
       'SOMBAS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SOMBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2720,
       1,
       'SUBATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SUBATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3630,
       1,
       'TANATV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TANATV',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3640,
       2,
       'TANQUE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TANQUE',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2730,
       1,
       'TCCATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TCCATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2740,
       1,
       'TCDATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TCDATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2750,
       1,
       'TEFENT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TEFENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2760,
       12,
       'TEFJRC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TEFJRC',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2770,
       12,
       'TEFJRD',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TEFJRD',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2780,
       10,
       'TEFPRC',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TEFPRC',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2790,
       10,
       'TEFPRO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TEFPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3290,
       1,
       'TIPARC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPARC',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2800,
       1,
       'TIPATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2810,
       1,
       'TIPCCB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPCCB',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2820,
       1,
       'TIPCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2830,
       1,
       'TIPCWS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPCWS',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2840,
       20,
       'TIPDES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPDES',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2850,
       2,
       'TIPDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2860,
       1,
       'TIPHOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2870,
       1,
       'TIPJUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPJUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2880,
       1,
       'TIPNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPNAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3300,
       30,
       'TITCOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TITCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2890,
       1,
       'TRIATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TRIATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2900,
       1,
       'TRIBUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TRIBUT',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2910,
       4000,
       'TXTCCC',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TXTCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2920,
       4000,
       'TXTENT',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TXTENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2930,
       4000,
       'TXTFIM',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TXTFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2940,
       4000,
       'TXTINI',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TXTINI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2950,
       4000,
       'TXTITE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TXTITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2960,
       4000,
       'TXTOBS',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TXTOBS',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2970,
       4000,
       'TXTSER',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TXTSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2980,
       2,
       'UNIMED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'UNIMED',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       2990,
       1,
       'USACUS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'USACUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3000,
       5,
       'USAICM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'USAICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3010,
       5,
       'USAIPI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'USAIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3020,
       1,
       'USAVEN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'USAVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3030,
       1,
       'USODEV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'USODEV',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3230,
       1,
       'USOINA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'USOINA',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3040,
       5,
       'USOPRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'USOPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3050,
       10,
       'USUOBS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'USUOBS',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3060,
       1,
       'VEIATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VEIATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3070,
       1,
       'VLRDEV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       '',
       '',
       '',
       'VLRDEV',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3080,
       7,
       'VOLMAX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VOLMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3090,
       1,
       'VPEATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VPEATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VT2 ',
       '--',
       3100,
       1,
       'VTPATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VTPATI',
       'F' FROM DUAL
);

/*-- SEQ 10291 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VTEC',
       0,
       'VTEC',
       'Tcnicos',
       'TV_TEC',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'VTEC.FILCLI,VTEC.CODCLI
VTEC.NOMCLI,VTEC.ULTNOM
VTEC.NUMDOC
',
       '' FROM DUAL
);

/*-- SEQ 10292 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VTEC','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VTEC','02','Endereo' FROM DUAL
UNION ALL
SELECT 'VTEC','03','Documentao' FROM DUAL
UNION ALL
SELECT 'VTEC','04','Dados Financeiros' FROM DUAL
UNION ALL
SELECT 'VTEC','99','Outros' FROM DUAL
);

/*-- SEQ 10293 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22091,
       'REL ',
       'VTEC',
       'N',
       '1',
       '',
       '',
       'VTEC.FILCLI = REL.FILPAR AND VTEC.CODCLI = REL.CODPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22092,
       'SPC ',
       'VTEC',
       '01',
       '01',
       '',
       'VTEC.FLGTIP = 1',
       'SPC.FILCLI = VTEC.FILCLI (+) and
SPC.CODCLI = VTEC.CODCLI (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22093,
       'EDE ',
       'VTEC',
       'N',
       '1',
       '',
       '',
       'EDE.FILCLI = VTEC.FILCLI AND
EDE.CODCLI = VTEC.CODCLI
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22094,
       'CON ',
       'VTEC',
       '0N',
       '01',
       '',
       '',
       'CON.FILCLI = VTEC.FILCLI (+) and
CON.CODCLI = VTEC.CODCLI (+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 10294 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VTEC',
       '01',
       55,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'PAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(VTEC.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '99',
       55,
       4,
       'ANO_DATA01',
       'A',
       '',
       0,
       0,
       'PAR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 1',
       '',
       'TO_CHAR(VTEC.DATA01,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '99',
       65,
       4,
       'ANO_DATA02',
       'A',
       '',
       0,
       0,
       'PAR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 2',
       '',
       'TO_CHAR(VTEC.DATA02,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '99',
       75,
       4,
       'ANO_DATA03',
       'A',
       '',
       0,
       0,
       'PAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 3',
       '',
       'TO_CHAR(VTEC.DATA03,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '01',
       65,
       4,
       'ANO_DATNAS',
       'A',
       '',
       0,
       0,
       'PAR ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ano de Nascto/Funda',
       'Ano de Data de nascimento ou fundao',
       '',
       'TO_CHAR(VTEC.DATNAS,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '01',
       75,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       0,
       'PAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ano de Data Incluso',
       'Ano de Data de operao (cadastramento)',
       '',
       'TO_CHAR(VTEC.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '01',
       115,
       4,
       'ANO_NASCON',
       'A',
       '',
       0,
       0,
       'PAR ',
       110,
       30,
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ano de Nascto Cnj./',
       'Ano de Data de nascimento do cnjuge ou contato principal',
       '',
       'TO_CHAR(VTEC.NASCON,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       85,
       4,
       'ANO_ULTCOM',
       'A',
       '',
       0,
       0,
       'PAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ano de ltima Compra',
       'Ano de Data da ltima compra',
       '',
       'TO_CHAR(VTEC.ULTCOM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '01',
       50,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'PAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       130,
       1,
       'CALL_C',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Aceita Contato?',
       'Aceita Contato Telefnico',
       '',
       'CALL_C',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '99',
       20,
       2,
       'CATEG1',
       'S',
       'DCT1',
       0,
       20,
       'PAR ',
       10,
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'V',
       'PAR',
       'F',
       'A',
       'T',
       '',
       'Categoria - 1',
       'VTEC.CATEG1=DCT1.CODTAB (+)',
       'CATEG1',
       'T' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '99',
       30,
       2,
       'CATEG2',
       'S',
       'DCT2',
       0,
       21,
       'PAR ',
       20,
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'V',
       'PAR',
       'F',
       'A',
       'T',
       '',
       'Categoria - 2',
       'VTEC.CATEG2=DCT2.CODTAB (+)',
       'CATEG2',
       'T' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '99',
       40,
       2,
       'CATEG3',
       'S',
       'DCT3',
       0,
       22,
       'PAR ',
       30,
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'V',
       'PAR',
       'F',
       'A',
       'T',
       'TIPO',
       'Categoria - 3',
       'VTEC.CATEG3=DCT3.CODTAB (+)',
       'CATEG3',
       'T' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '01',
       25,
       9,
       'CHAVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Parceiro',
       'Cdigo do Parceiro',
       '',
       'FILCLI||VTEC.CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       0,
       'PAR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       '9',
       'T',
       'Cdigo',
       'Cdigo do parceiro',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       140,
       10,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Externo',
       'Cdigo Alternativo nico',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       150,
       6,
       'CODPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo Parceiro',
       'Cdigo Parceiro',
       '',
       'CODPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       60,
       3,
       'CODPLA',
       'A',
       'PLA ',
       0,
       24,
       'PAR ',
       60,
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       'PAR',
       'F',
       'A',
       'T',
       'Plano padro',
       'Cdigo do plano padro',
       'VTEC.FILPLA=PLA.FILPGT (+) and VTEC.CODPLA=PLA.CODPGT (+)',
       'CODPLA',
       'T' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '01',
       90,
       2,
       'CODSEX',
       'S',
       '',
       0,
       19,
       'PAR ',
       90,
       30,
       '',
       '',
       'D',
       'PAR',
       'F',
       'A',
       'T',
       'Sexo',
       'Cdigo de Sexo do parceiro',
       '',
       'CODSEX',
       'T' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       120,
       3,
       'CODVEN',
       'A',
       'USU ',
       0,
       0,
       'PAR ',
       120,
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       'PAR',
       'F',
       'A',
       'T',
       'Vendedor Padro',
       'Vendedor Padro',
       'VTEC.FILVEN=USU.FILUSU(+) and VTEC.CODVEN=USU.CODUSU(+)',
       'CODVEN',
       'T' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       160,
       6,
       'CODVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo Vnculo',
       'Cdigo do Vnculo',
       '',
       'CODVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '01',
       100,
       44,
       'CONJUG',
       'A',
       '',
       0,
       0,
       'PAR ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PAR',
       'F',
       'A',
       'T',
       'Cnjuge ou Contato',
       'Nome do Cnjuge ou do Contato principal',
       '',
       'CONJUG',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '99',
       50,
       8,
       'DATA01',
       'D',
       '',
       0,
       0,
       'PAR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'D',
       'T',
       '',
       'Data livre - 1',
       '',
       'DATA01',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '99',
       60,
       8,
       'DATA02',
       'D',
       '',
       0,
       0,
       'PAR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'D',
       'T',
       '',
       'Data livre - 2',
       '',
       'DATA02',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '99',
       70,
       8,
       'DATA03',
       'D',
       '',
       0,
       0,
       'PAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'D',
       'T',
       '',
       'Data livre - 3',
       '',
       'DATA03',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '01',
       60,
       8,
       'DATNAS',
       'D',
       '',
       0,
       0,
       'PAR ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'D',
       'T',
       'Nascto/Fundao',
       'Data de nascimento ou fundao',
       '',
       'DATNAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '01',
       70,
       8,
       'DATOPE',
       'D',
       '',
       0,
       0,
       'PAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'D',
       'T',
       'Data Incluso',
       'Data de operao (cadastramento)',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '03',
       50,
       15,
       'DOCCON',
       'A',
       '',
       0,
       0,
       'PAR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PAR',
       'F',
       'A',
       'T',
       'Doc. Cnjuge/Contato',
       'Doc. Cnjuge/Contato',
       '',
       'DOCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '03',
       10,
       2,
       'ESTCIV',
       'S',
       '',
       0,
       18,
       'PAR ',
       10,
       30,
       '',
       '',
       'D',
       'PAR',
       'F',
       'A',
       'T',
       'Estado Civil',
       'Estado Civil',
       '',
       'ESTCIV',
       'T' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '01',
       10,
       3,
       'FILCLI',
       'A',
       '',
       0,
       0,
       'PAR ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'N',
       'T',
       '',
       'Filial onde foi cadastrado o parceiro',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       170,
       3,
       'FILPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Parceiro',
       '',
       'FILPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       50,
       3,
       'FILPLA',
       'A',
       '',
       0,
       0,
       'PAR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'N',
       'F',
       'Filial do Plano',
       'Filial do Plano',
       '',
       'FILPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       110,
       3,
       'FILVEN',
       'A',
       '',
       0,
       0,
       'PAR ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'N',
       'F',
       '',
       'Filial do Vendedor',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       180,
       3,
       'FILVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do Vnculo',
       '',
       'FILVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '03',
       30,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       0,
       'PAR ',
       30,
       30,
       '',
       '',
       'D',
       'PAR',
       'F',
       'A',
       'T',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '02',
       80,
       40,
       'HOMPGE',
       'A',
       '',
       0,
       0,
       'PAR ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PAR',
       'F',
       'A',
       'T',
       'Home Page',
       'Home Page do parceiro',
       '',
       'HOMPGE',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       190,
       1,
       'ICM_CF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'ICM_CF  Nota Fiscal?',
       'ICM_CF  Nota Fiscal',
       '',
       'ICM_CF',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '99',
       80,
       2,
       'IMPRIM',
       'S',
       '',
       0,
       0,
       'PAR ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       '',
       'F',
       'Livre Customizao',
       'Livre para customizao',
       '',
       'IMPRIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '03',
       40,
       15,
       'INSEST',
       'A',
       '',
       0,
       4,
       'PAR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PAR',
       'F',
       'A',
       'T',
       '2 Documento',
       'Inscrio Estadual ou Identidade',
       '',
       'INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       200,
       6,
       'ISENHA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Senha',
       '',
       'ISENHA',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       40,
       2,
       'MAIATR',
       'S',
       '',
       0,
       0,
       'PAR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       '9',
       'T',
       'Maior atraso',
       'Maior atraso registrado',
       '',
       'MAIATR',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '01',
       53,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'PAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(VTEC.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '99',
       53,
       2,
       'MES_DATA01',
       'A',
       '',
       0,
       0,
       'PAR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 1',
       '',
       'TO_CHAR(VTEC.DATA01,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '99',
       63,
       2,
       'MES_DATA02',
       'A',
       '',
       0,
       0,
       'PAR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 2',
       '',
       'TO_CHAR(VTEC.DATA02,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '99',
       73,
       2,
       'MES_DATA03',
       'A',
       '',
       0,
       0,
       'PAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 3',
       '',
       'TO_CHAR(VTEC.DATA03,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '01',
       63,
       2,
       'MES_DATNAS',
       'A',
       '',
       0,
       0,
       'PAR ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ms de Nascto/Funda',
       'Ms de Data de nascimento ou fundao',
       '',
       'TO_CHAR(VTEC.DATNAS,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '01',
       73,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       0,
       'PAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ms de Data Incluso',
       'Ms de Data de operao (cadastramento)',
       '',
       'TO_CHAR(VTEC.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '01',
       113,
       2,
       'MES_NASCON',
       'A',
       '',
       0,
       0,
       'PAR ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ms de Nascto Cnj./',
       'Ms de Data de nascimento do cnjuge ou contato principal',
       '',
       'TO_CHAR(VTEC.NASCON,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       83,
       2,
       'MES_ULTCOM',
       'A',
       '',
       0,
       0,
       'PAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ms de ltima Compra',
       'Ms de Data da ltima compra',
       '',
       'TO_CHAR(VTEC.ULTCOM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '01',
       110,
       8,
       'NASCON',
       'D',
       '',
       0,
       0,
       'PAR ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'D',
       'T',
       'Nascto Cnj./Contato',
       'Data de nascimento do cnjuge ou contato principal',
       '',
       'NASCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '01',
       30,
       44,
       'NOMCLI',
       'A',
       '',
       0,
       0,
       'PAR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PAR',
       'F',
       'A',
       'T',
       'Nome do Tecnico',
       'Nome do Tecnico',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       210,
       255,
       'NOMIMG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Imagem',
       'Nome Imagem',
       '',
       'NOMIMG',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '03',
       20,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       3,
       'PAR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PAR',
       'F',
       'A',
       'T',
       'Documento',
       'Nmero do Documento: CGC ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '99',
       90,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'PAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PAR',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(VTEC.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       70,
       2,
       'PORPAD',
       'S',
       'DCOB',
       0,
       16,
       'PAR ',
       70,
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       'PAR',
       'F',
       'A',
       'T',
       'Portador Padro',
       'Portador padro',
       'VTEC.PORPAD=DCOB.CODTAB (+)',
       'PORPAD',
       'T' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       260,
       1,
       'PP_FLG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag Prospeco',
       'Flag de Prospeco sim ou no',
       '',
       'PP_FLG',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       220,
       12,
       'SALBON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Bnus',
       'Bnus',
       '',
       'SALBON',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '01',
       120,
       2,
       'SEXCON',
       'S',
       '',
       0,
       0,
       'PAR ',
       120,
       30,
       '',
       '',
       'D',
       'PAR',
       'F',
       'A',
       'T',
       'Sexo do Cnjuge',
       'Sexo do cnjuge',
       '',
       'SEXCON',
       'T' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '99',
       110,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'PAR ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PAR',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN VTEC.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '99',
       111,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN VTEC.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       230,
       1,
       'TIPCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Cobrana',
       'Tipo Cobrana',
       '',
       'TIPCOB',
       'T' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       240,
       2,
       'TIPDOC',
       'A',
       'DDOC',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DDOC.DESDOC',
       'V',
       '',
       'F',
       'A',
       'F',
       'Tipo Documento',
       'Tipo de Documento',
       'DDOC.TIPDOC(+) =VTEC.TIPDOC',
       'TIPDOC',
       'T' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       250,
       4,
       'TIPPAR',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Total de Parcelas',
       'Total de parcelas na vida do parceiro',
       '',
       'TIPPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       20,
       4,
       'TOTATR',
       'G',
       '',
       0,
       0,
       'PAR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'N',
       'F',
       'Total Atrasos',
       'Total de atrasos na vida do parceiro',
       '',
       'TOTATR',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       30,
       4,
       'TOTPAR',
       'G',
       '',
       0,
       0,
       'PAR ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'N',
       'F',
       'Total de Parcelas',
       'Total de parcelas na vida do parceiro',
       '',
       'TOTPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       80,
       8,
       'ULTCOM',
       'D',
       '',
       0,
       0,
       'PAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'D',
       'T',
       'ltima Compra',
       'Data da ltima compra',
       '',
       'ULTCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '01',
       40,
       20,
       'ULTNOM',
       'A',
       '',
       0,
       0,
       'PAR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PAR',
       'F',
       'A',
       'T',
       'Sobrenome',
       'Sobrenome ou fantasia',
       '',
       'ULTNOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEC',
       '04',
       10,
       8,
       'VALOR1',
       'F',
       '',
       2,
       0,
       'PAR ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'T',
       'N',
       'F',
       'Valor',
       'Armazena um valor qualquer',
       '',
       'VALOR1',
       'F' FROM DUAL
);

/*-- SEQ 10295 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VTEC',
       'CODSEX',
       0,
       '-',
       'Nao conhecido',
       144,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'CODSEX',
       1,
       '-',
       'Masculino',
       145,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'CODSEX',
       2,
       '-',
       'Feminino',
       146,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'ESTCIV',
       2,
       '-',
       'Casado',
       149,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'ESTCIV',
       3,
       '-',
       'Vivo',
       150,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'ESTCIV',
       4,
       '-',
       'Divorciado',
       151,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'ESTCIV',
       5,
       '-',
       'Unio Estvel',
       152,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'ESTCIV',
       6,
       '-',
       'Separado',
       153,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'ESTCIV',
       0,
       '-',
       'Indefinido',
       147,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'ESTCIV',
       1,
       '-',
       'Solteiro',
       148,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'FLGTIP',
       0,
       '-',
       'Fsica',
       154,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'FLGTIP',
       1,
       '-',
       'Jurdica',
       155,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'FLGTIP',
       2,
       '-',
       'Entidade',
       156,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'FLGTIP',
       3,
       '-',
       'Especial',
       157,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'FLGTIP',
       4,
       '-',
       'M.E.',
       158,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'FLGTIP',
       5,
       '-',
       'Filial',
       159,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'SEXCON',
       1,
       '-',
       'Masculino',
       161,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'SEXCON',
       2,
       '-',
       'Feminino',
       162,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'SEXCON',
       0,
       '-',
       'Nao conhecido',
       160,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'TIPCOB',
       0,
       'A',
       'A Depositar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'TIPCOB',
       0,
       'B',
       'Cobrado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'TIPCOB',
       0,
       'C',
       'Compensado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'TIPCOB',
       0,
       'D',
       'Depositado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'TIPCOB',
       0,
       'P',
       'Pr-Descontado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'TIPCOB',
       0,
       'U',
       'Custodiado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VTEC',
       'TIPCOB',
       0,
       'V',
       'Devolvido',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10296 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VTEL',
       TO_NUMBER(null),
       'VTEL',
       'Telefones',
       'TV_TEL',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VTEL.FILCLI,VTEL.CODCLI',
       '' FROM DUAL
);

/*-- SEQ 10297 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VTEL','--','' FROM DUAL
UNION ALL
SELECT 'VTEL','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VTEL','99','Outros' FROM DUAL
);

/*-- SEQ 10298 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VTEL',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEL',
       '01',
       20,
       2,
       'DDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'DDD',
       'DDD',
       '',
       'DDD',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEL',
       '01',
       80,
       162,
       'EXPRESSAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Expresso',
       'Expresso',
       '',
       'EXPRESSAO',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEL',
       '01',
       30,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEL',
       '01',
       40,
       10,
       'FONE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Telefone',
       'Telefone',
       '',
       'FONE',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEL',
       '01',
       50,
       97,
       'NOME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome',
       'Nome',
       '',
       'NOME',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEL',
       '01',
       60,
       12,
       'ORDEM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Ordem',
       'Ordem',
       '',
       'ORDEM',
       'F' FROM DUAL
UNION ALL
SELECT 'VTEL',
       '01',
       70,
       26,
       'TIPO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Telefone',
       'Tipo Telefone',
       '',
       'TIPO',
       'F' FROM DUAL
);

/*-- SEQ 10299 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VTHP',
       TO_NUMBER(null),
       'VTHP',
       'Transferencia HP',
       'TV_PCIA_TRANS_HP',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10300 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VTHP','--','' FROM DUAL
UNION ALL
SELECT 'VTHP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VTHP','99','Outros' FROM DUAL
);

/*-- SEQ 10301 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VTHP',
       '--',
       80,
       5,
       'CLASS2',
       'S',
       'DCL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL2.CLASS2',
       'V',
       '',
       '',
       'A',
       'F',
       'FAMILIA',
       '',
       'DCL2.CODTAB = VTHP.CLASS2',
       'CLASS2',
       'F' FROM DUAL
UNION ALL
SELECT 'VTHP',
       '--',
       90,
       5,
       'CLASS3',
       'S',
       'DCL3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL3.CLASS3',
       'V',
       '',
       '',
       'A',
       'F',
       'GRUPO',
       '',
       'DCL3.CODTAB = VTHP.CLASS3',
       'CLASS3',
       'F' FROM DUAL
UNION ALL
SELECT 'VTHP',
       '--',
       60,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Codigo Filial',
       '',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VTHP',
       '--',
       100,
       10,
       'CODIGO_DESTINO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Codigo Destino',
       '',
       '',
       'CODIGO_DESTINO',
       'F' FROM DUAL
UNION ALL
SELECT 'VTHP',
       '--',
       110,
       10,
       'CODIGO_ORIGEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Codigo Origem',
       '',
       '',
       'CODIGO_ORIGEM',
       'F' FROM DUAL
UNION ALL
SELECT 'VTHP',
       '--',
       10,
       9,
       'CODIGO_REVENDA_DESTINO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Revenda Destino',
       '',
       '',
       'CODIGO_REVENDA_DESTINO',
       'F' FROM DUAL
UNION ALL
SELECT 'VTHP',
       '--',
       20,
       9,
       'CODIGO_REVENDA_ORIGEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Revenda Origem',
       '',
       '',
       'CODIGO_REVENDA_ORIGEM',
       'F' FROM DUAL
UNION ALL
SELECT 'VTHP',
       '--',
       30,
       8,
       'DATA_TRANSFERENCIA',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data',
       '',
       '',
       'DATA_TRANSFERENCIA',
       'F' FROM DUAL
UNION ALL
SELECT 'VTHP',
       '--',
       120,
       30,
       'MARCA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Marca',
       '',
       '',
       'MARCA',
       'F' FROM DUAL
UNION ALL
SELECT 'VTHP',
       '--',
       70,
       6,
       'NUMERO_NOTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Numero Nota',
       '',
       '',
       'NUMERO_NOTA',
       'F' FROM DUAL
UNION ALL
SELECT 'VTHP',
       '--',
       40,
       20,
       'PART_NUMBER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Part Number',
       '',
       '',
       'PART_NUMBER',
       'F' FROM DUAL
UNION ALL
SELECT 'VTHP',
       '--',
       50,
       12,
       'QUANTIDADE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       'F',
       'Qtde Transferida',
       '',
       '',
       'QUANTIDADE',
       'F' FROM DUAL
);
/*-- SEQ 10302 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VTO ',
       TO_NUMBER(null),
       'VTO ',
       'Tab. x Out',
       'TV_TAB_OUT',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10303 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VTO ','--','' FROM DUAL
UNION ALL
SELECT 'VTO ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VTO ','99','Outros' FROM DUAL
);

/*-- SEQ 10304 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VTO ',
       '--',
       10,
       1,
       'ALIINT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ALIINT',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       20,
       1,
       'BAIEST',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'BAIEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       30,
       40,
       'CATEG1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Categoria 1',
       '',
       'CATEG1',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       40,
       40,
       'CLASS1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '',
       'Cdigo da classe 1',
       '',
       'CLASS1',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       50,
       40,
       'CLASS2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '',
       'Cdigo da classe 2',
       '',
       'CLASS2',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       60,
       40,
       'CLASS3',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '',
       'Cdigo da classe 3',
       '',
       'CLASS3',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       70,
       40,
       'CLASS4',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '',
       'Cdigo da classe 4',
       '',
       'CLASS4',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       1080,
       1,
       'CLIDEV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CLIDEV',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       80,
       1,
       'CLILIV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Cli diferente Venda?',
       'Cliente diferente da venda?',
       '',
       'CLILIV',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       90,
       1,
       'COBCAR',
       'A',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       '',
       'A',
       'F',
       'Cobranca Cartao',
       'Cobranca Cartao',
       'DCOB.TIPCOB = VTO.COBCAR',
       'COBCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       100,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       'F',
       'A',
       'F',
       'Srie',
       'Cdigo da srie',
       'VTO.CODSER=DSER.CODSER (+)',
       'CODSER',
       'T' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       110,
       5,
       'CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       120,
       1,
       'COMCCC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'COMCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       1110,
       1,
       'CONSFI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CONSFI',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       130,
       3,
       'CORAMP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CORAMP',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       140,
       14,
       'CTACRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CTACRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       150,
       14,
       'CTADEB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CTADEB',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       160,
       3,
       'CX_COD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CX_COD',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       170,
       30,
       'CX_DES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CX_DES',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       180,
       1,
       'CX_HIS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CX_HIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       190,
       10,
       'CX_USO',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CX_USO',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       200,
       1,
       'DADREC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DADREC',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       210,
       20,
       'DESCAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       220,
       30,
       'DESCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       230,
       30,
       'DESCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       240,
       30,
       'DESDEV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESDEV',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       250,
       5,
       'DESMOE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESMOE',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       260,
       30,
       'DESMUL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       270,
       30,
       'DESOBS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESOBS',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       280,
       20,
       'DESOUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESOUT',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       290,
       25,
       'DESSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       300,
       4,
       'DEVATE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DEVATE',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       310,
       4,
       'DEVCOM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DEVCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       320,
       4,
       'DEVICM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DEVICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       330,
       3,
       'DIACAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DIACAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       340,
       3,
       'DIADEB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DIADEB',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       350,
       200,
       'DISSAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DISSAI',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       360,
       1,
       'DIVTRO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DIVTRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       370,
       5,
       'EXTNOT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'EXTNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       380,
       1,
       'FINANC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FINANC',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       390,
       1,
       'GERTIT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'GERTIT',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       400,
       1,
       'ICMCID',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ICMCID',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       410,
       1,
       'IMPNOT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'IMPNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       420,
       15,
       'INSEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       430,
       1,
       'LANVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'LANVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       440,
       5,
       'LARUNI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'LARUNI',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       450,
       12,
       'MARG01',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARG01',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       460,
       12,
       'MARG02',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARG02',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       470,
       12,
       'MARG03',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARG03',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       480,
       12,
       'MARG04',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARG04',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       490,
       12,
       'MARG05',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARG05',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       500,
       12,
       'MARG06',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARG06',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       510,
       12,
       'MARG07',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARG07',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       520,
       12,
       'MARG08',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARG08',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       530,
       12,
       'MARG09',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARG09',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       540,
       12,
       'MARG10',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARG10',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       550,
       5,
       'MULDEV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MULDEV',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       560,
       6,
       'NATDEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATDEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       570,
       40,
       'NATDES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATDES',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       580,
       6,
       'NATFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       590,
       6,
       'NATFUD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATFUD',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       600,
       6,
       'NATFUF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATFUF',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       1090,
       5,
       'NATMUL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       610,
       1,
       'NATONL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATONL',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       620,
       6,
       'NATRED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATRED',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       630,
       6,
       'NATREF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATREF',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       640,
       28,
       'NOMEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NOMEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       650,
       1,
       'NORINT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NORINT',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       660,
       3,
       'OBSCOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'OBSCOL',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       670,
       3,
       'OBSLIN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'OBSLIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       680,
       1,
       'ONDCAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ONDCAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       690,
       12,
       'PERICM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PERICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       700,
       12,
       'PHOALT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PHOALT',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       710,
       15,
       'PHOCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PHOCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       720,
       15,
       'PHOISO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PHOISO',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       730,
       12,
       'PHOLAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PHOLAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       740,
       15,
       'PHOMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PHOMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       750,
       15,
       'PHOOUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PHOOUT',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       760,
       15,
       'PHOTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PHOTIP',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       770,
       5,
       'PORCAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PORCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       780,
       1,
       'PROCAR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PROCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       790,
       5,
       'QTDITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'QTDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       800,
       5,
       'QTDSER',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'QTDSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       810,
       15,
       'REGCCC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'REGCCC',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       820,
       1,
       'RESTRI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'RESTRI',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       830,
       15,
       'RESULT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'RESULT',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       840,
       200,
       'SAICAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SAICAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       850,
       254,
       'SAIENV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SAIENV',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       860,
       6,
       'SERFIM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SERFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       870,
       6,
       'SERINI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SERINI',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       880,
       1,
       'SERMAN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SERMAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       890,
       2,
       'SERVIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SERVIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       900,
       2,
       'SIGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SIGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       910,
       1,
       'SOMBAS',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SOMBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       920,
       12,
       'TAXCAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TAXCAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       930,
       12,
       'TAXDEB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TAXDEB',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       940,
       40,
       'TIPCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       950,
       1,
       'TRANSF',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TRANSF',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       960,
       1,
       'TRIBUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TRIBUT',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       970,
       4000,
       'TXTCOB',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TXTCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       980,
       4000,
       'TXTENT',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TXTENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       990,
       4000,
       'TXTFIM',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TXTFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       1000,
       4000,
       'TXTINI',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TXTINI',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       1010,
       4000,
       'TXTITE',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TXTITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       1020,
       4000,
       'TXTOBS',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TXTOBS',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       1030,
       4000,
       'TXTSER',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TXTSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       1100,
       1,
       'USAMUL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'USAMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       1040,
       1,
       'USODEV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'USODEV',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       1050,
       1,
       'USOSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'USOSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       1060,
       10,
       'USUOBS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'USUOBS',
       'F' FROM DUAL
UNION ALL
SELECT 'VTO ',
       '--',
       1070,
       1,
       'VLRDEV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       '',
       '',
       '',
       'VLRDEV',
       'F' FROM DUAL
);

/*-- SEQ 10305 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VTRA',
       0,
       'VTRA',
       'Transportadora',
       'TV_TRA',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'VTRA.FILCLI,VTRA.CODCLI
VTRA.NOMCLI,VTRA.ULTNOM
VTRA.NUMDOC
',
       '' FROM DUAL
);

/*-- SEQ 10306 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VTRA','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VTRA','02','Endereo' FROM DUAL
UNION ALL
SELECT 'VTRA','03','Documentao' FROM DUAL
UNION ALL
SELECT 'VTRA','04','Dados Financeiros' FROM DUAL
UNION ALL
SELECT 'VTRA','99','Outros' FROM DUAL
);

/*-- SEQ 10307 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22095,
       'EDE ',
       'VTRA',
       'N',
       '1',
       '',
       '',
       'EDE.FILCLI = VTRA.FILCLI AND
EDE.CODCLI = VTRA.CODCLI
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22096,
       'REL ',
       'VTRA',
       'N',
       '1',
       '',
       '',
       'VTRA.FILCLI = REL.FILPAR AND VTRA.CODCLI = REL.CODPAR',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22097,
       'CON ',
       'VTRA',
       '0N',
       '01',
       '',
       '',
       'CON.FILCLI = VTRA.FILCLI (+) and
CON.CODCLI = VTRA.CODCLI (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22098,
       'SPC ',
       'VTRA',
       '01',
       '01',
       '',
       'VTRA.FLGTIP = 1',
       'SPC.FILCLI = VTRA.FILCLI (+) and
SPC.CODCLI = VTRA.CODCLI (+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 10308 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VTRA',
       '01',
       55,
       4,
       'ANO_ATU_EM',
       'A',
       '',
       0,
       0,
       'PAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ano~Atualizao',
       'Ano de Atualizado em ...',
       '',
       'TO_CHAR(VTRA.ATU_EM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '99',
       55,
       4,
       'ANO_DATA01',
       'A',
       '',
       0,
       0,
       'PAR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 1',
       '',
       'TO_CHAR(VTRA.DATA01,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '99',
       65,
       4,
       'ANO_DATA02',
       'A',
       '',
       0,
       0,
       'PAR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 2',
       '',
       'TO_CHAR(VTRA.DATA02,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '99',
       75,
       4,
       'ANO_DATA03',
       'A',
       '',
       0,
       0,
       'PAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       ' (ano)',
       'Ano de Data livre - 3',
       '',
       'TO_CHAR(VTRA.DATA03,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '01',
       65,
       4,
       'ANO_DATNAS',
       'A',
       '',
       0,
       0,
       'PAR ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ano de Nascto/Funda',
       'Ano de Data de nascimento ou fundao',
       '',
       'TO_CHAR(VTRA.DATNAS,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '01',
       75,
       4,
       'ANO_DATOPE',
       'A',
       '',
       0,
       0,
       'PAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ano de Data Incluso',
       'Ano de Data de operao (cadastramento)',
       '',
       'TO_CHAR(VTRA.DATOPE,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '01',
       115,
       4,
       'ANO_NASCON',
       'A',
       '',
       0,
       0,
       'PAR ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ano de Nascto Cnj./',
       'Ano de Data de nascimento do cnjuge ou contato principal',
       '',
       'TO_CHAR(VTRA.NASCON,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '04',
       85,
       4,
       'ANO_ULTCOM',
       'A',
       '',
       0,
       0,
       'PAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ano de ltima Compra',
       'Ano de Data da ltima compra',
       '',
       'TO_CHAR(VTRA.ULTCOM,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '01',
       50,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       0,
       'PAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       '@',
       'T',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '99',
       20,
       2,
       'CATEG1',
       'S',
       'DCT1',
       0,
       20,
       'PAR ',
       10,
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'V',
       'PAR',
       'F',
       'A',
       'T',
       '',
       'Categoria - 1',
       'VTRA.CATEG1=DCT1.CODTAB (+)',
       'CATEG1',
       'T' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '99',
       30,
       2,
       'CATEG2',
       'S',
       'DCT2',
       0,
       21,
       'PAR ',
       20,
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'V',
       'PAR',
       'F',
       'A',
       'T',
       '',
       'Categoria - 2',
       'VTRA.CATEG2=DCT2.CODTAB (+)',
       'CATEG2',
       'T' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '99',
       40,
       2,
       'CATEG3',
       'S',
       'DCT3',
       0,
       22,
       'PAR ',
       30,
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'V',
       'PAR',
       'F',
       'A',
       'T',
       'TIPO',
       'Categoria - 3',
       'VTRA.CATEG3=DCT3.CODTAB (+)',
       'CATEG3',
       'T' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '01',
       25,
       9,
       'CHAVE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       30,
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'T',
       'Parceiro',
       'Cdigo do Parceiro',
       '',
       'FILCLI||VTRA.CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '01',
       20,
       6,
       'CODCLI',
       'A',
       '',
       0,
       0,
       'PAR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       '9',
       'T',
       'Cdigo',
       'Cdigo do parceiro',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '04',
       130,
       6,
       'CODPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Parceiro',
       'Cdigo do Parceiro',
       '',
       'CODPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '04',
       60,
       3,
       'CODPLA',
       'A',
       'PLA ',
       0,
       24,
       'PAR ',
       60,
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       'PAR',
       'F',
       'A',
       'T',
       'Plano padro',
       'Cdigo do plano padro',
       'VTRA.FILPLA=PLA.FILPGT (+) and VTRA.CODPLA=PLA.CODPGT (+)',
       'CODPLA',
       'T' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '01',
       90,
       2,
       'CODSEX',
       'S',
       '',
       0,
       19,
       'PAR ',
       90,
       30,
       '',
       '',
       'D',
       'PAR',
       'F',
       'A',
       'T',
       'Sexo',
       'Cdigo de Sexo do parceiro',
       '',
       'CODSEX',
       'T' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '04',
       120,
       3,
       'CODVEN',
       'A',
       'USU ',
       0,
       0,
       'PAR ',
       120,
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       'PAR',
       'F',
       'A',
       'T',
       'Vendedor Padro',
       'Vendedor Padro',
       'VTRA.FILVEN=USU.FILUSU(+) and VTRA.CODVEN=USU.CODUSU(+)',
       'CODVEN',
       'T' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '01',
       100,
       44,
       'CONJUG',
       'A',
       '',
       0,
       0,
       'PAR ',
       100,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PAR',
       'F',
       'A',
       'T',
       'Cnjuge ou Contato',
       'Nome do Cnjuge ou do Contato principal',
       '',
       'CONJUG',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '99',
       50,
       8,
       'DATA01',
       'D',
       '',
       0,
       0,
       'PAR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'D',
       'T',
       '',
       'Data livre - 1',
       '',
       'DATA01',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '99',
       60,
       8,
       'DATA02',
       'D',
       '',
       0,
       0,
       'PAR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'D',
       'T',
       '',
       'Data livre - 2',
       '',
       'DATA02',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '99',
       70,
       8,
       'DATA03',
       'D',
       '',
       0,
       0,
       'PAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'D',
       'T',
       '',
       'Data livre - 3',
       '',
       'DATA03',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '01',
       60,
       8,
       'DATNAS',
       'D',
       '',
       0,
       0,
       'PAR ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'D',
       'T',
       'Nascto/Fundao',
       'Data de nascimento ou fundao',
       '',
       'DATNAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '01',
       70,
       8,
       'DATOPE',
       'D',
       '',
       0,
       0,
       'PAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'D',
       'T',
       'Data Incluso',
       'Data de operao (cadastramento)',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '03',
       50,
       15,
       'DOCCON',
       'A',
       '',
       0,
       0,
       'PAR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PAR',
       'F',
       'A',
       'T',
       'Doc. Cnjuge/Contato',
       'Doc. Cnjuge/Contato',
       '',
       'DOCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '03',
       10,
       2,
       'ESTCIV',
       'S',
       '',
       0,
       18,
       'PAR ',
       10,
       30,
       '',
       '',
       'D',
       'PAR',
       'F',
       'A',
       'T',
       'Estado Civil',
       'Estado Civil',
       '',
       'ESTCIV',
       'T' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '01',
       10,
       3,
       'FILCLI',
       'A',
       '',
       0,
       0,
       'PAR ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'N',
       'T',
       '',
       'Filial onde foi cadastrado o parceiro',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '04',
       140,
       3,
       'FILPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Parceiro',
       '',
       'FILPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '04',
       50,
       3,
       'FILPLA',
       'A',
       '',
       0,
       0,
       'PAR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'N',
       'F',
       'Filial Plano Padro',
       'Filial do Plano',
       '',
       'FILPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '04',
       110,
       3,
       'FILVEN',
       'A',
       '',
       0,
       0,
       'PAR ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'N',
       'F',
       '',
       'Filial do Vendedor',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '03',
       30,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       0,
       'PAR ',
       30,
       30,
       '',
       '',
       'D',
       'PAR',
       'F',
       'A',
       'T',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '02',
       80,
       40,
       'HOMPGE',
       'A',
       '',
       0,
       0,
       'PAR ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PAR',
       'F',
       'A',
       'T',
       'Home Page',
       'Home Page do parceiro',
       '',
       'HOMPGE',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '99',
       80,
       2,
       'IMPRIM',
       'S',
       '',
       0,
       0,
       'PAR ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'N',
       'F',
       'Class. Interna',
       'Livre para customizao',
       '',
       'IMPRIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '03',
       40,
       15,
       'INSEST',
       'A',
       '',
       0,
       4,
       'PAR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PAR',
       'F',
       'A',
       'T',
       '2 Documento',
       'Inscrio Estadual ou Identidade',
       '',
       'INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '04',
       40,
       2,
       'MAIATR',
       'S',
       '',
       0,
       0,
       'PAR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       '9',
       'T',
       'Maior atraso',
       'Maior atraso registrado',
       '',
       'MAIATR',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '01',
       53,
       2,
       'MES_ATU_EM',
       'A',
       '',
       0,
       0,
       'PAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ms~Atualizao',
       'Ms de Atualizado em ...',
       '',
       'TO_CHAR(VTRA.ATU_EM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '99',
       53,
       2,
       'MES_DATA01',
       'A',
       '',
       0,
       0,
       'PAR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 1',
       '',
       'TO_CHAR(VTRA.DATA01,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '99',
       63,
       2,
       'MES_DATA02',
       'A',
       '',
       0,
       0,
       'PAR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 2',
       '',
       'TO_CHAR(VTRA.DATA02,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '99',
       73,
       2,
       'MES_DATA03',
       'A',
       '',
       0,
       0,
       'PAR ',
       60,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       ' (ms)',
       'Ms de Data livre - 3',
       '',
       'TO_CHAR(VTRA.DATA03,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '01',
       63,
       2,
       'MES_DATNAS',
       'A',
       '',
       0,
       0,
       'PAR ',
       70,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ms de Nascto/Funda',
       'Ms de Data de nascimento ou fundao',
       '',
       'TO_CHAR(VTRA.DATNAS,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '01',
       73,
       2,
       'MES_DATOPE',
       'A',
       '',
       0,
       0,
       'PAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ms de Data Incluso',
       'Ms de Data de operao (cadastramento)',
       '',
       'TO_CHAR(VTRA.DATOPE,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '01',
       113,
       2,
       'MES_NASCON',
       'A',
       '',
       0,
       0,
       'PAR ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ms de Nascto Cnj./',
       'Ms de Data de nascimento do cnjuge ou contato principal',
       '',
       'TO_CHAR(VTRA.NASCON,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '04',
       83,
       2,
       'MES_ULTCOM',
       'A',
       '',
       0,
       0,
       'PAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       '',
       'N',
       'T',
       'Ms de ltima Compra',
       'Ms de Data da ltima compra',
       '',
       'TO_CHAR(VTRA.ULTCOM,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '01',
       110,
       8,
       'NASCON',
       'D',
       '',
       0,
       0,
       'PAR ',
       110,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'D',
       'T',
       'Nascto Cnj./Contato',
       'Data de nascimento do cnjuge ou contato principal',
       '',
       'NASCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '01',
       30,
       44,
       'NOMCLI',
       'A',
       '',
       0,
       0,
       'PAR ',
       40,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PAR',
       'F',
       'A',
       'T',
       'Nome da Trasnportado',
       'Nome da Transportadora',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '03',
       20,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       3,
       'PAR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PAR',
       'F',
       'A',
       'T',
       'Documento',
       'Nmero do Documento: CGC ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '99',
       90,
       10,
       'OBSERV',
       '4',
       '',
       0,
       0,
       'PAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PAR',
       'F',
       'A',
       'T',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(VTRA.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '04',
       70,
       2,
       'PORPAD',
       'S',
       'DCOB',
       0,
       16,
       'PAR ',
       70,
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       'PAR',
       'F',
       'A',
       'T',
       'Portador Padro',
       'Portador padro',
       'VTRA.PORPAD=DCOB.CODTAB (+)',
       'PORPAD',
       'T' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '02',
       160,
       1,
       'PP_FLG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag Prospeco',
       'Flag de Prospeco sim ou no',
       '',
       'PP_FLG',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '01',
       120,
       2,
       'SEXCON',
       'S',
       '',
       0,
       0,
       'PAR ',
       120,
       30,
       '',
       '',
       'D',
       'PAR',
       'F',
       'A',
       'T',
       'Sexo do Cnjuge',
       'Sexo do cnjuge',
       '',
       'SEXCON',
       'T' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '99',
       110,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       0,
       'PAR ',
       90,
       TO_NUMBER(null),
       '',
       '',
       'A',
       'PAR',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN VTRA.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '99',
       111,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN VTRA.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '04',
       150,
       1,
       'TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Parceiro',
       'Tipo de Parceiro',
       '',
       'TIPPAR',
       'T' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '04',
       20,
       4,
       'TOTATR',
       'G',
       '',
       0,
       0,
       'PAR ',
       20,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       '9',
       'F',
       'Total de Atrasos',
       'Total de atrasos na vida do parceiro',
       '',
       'TOTATR',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '04',
       30,
       4,
       'TOTPAR',
       'G',
       '',
       0,
       0,
       'PAR ',
       30,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       '9',
       'F',
       'Total Geral Parcelas',
       'Total de parcelas na vida do parceiro',
       '',
       'TOTPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '04',
       80,
       8,
       'ULTCOM',
       'D',
       '',
       0,
       0,
       'PAR ',
       80,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'F',
       'D',
       'T',
       'ltima Compra',
       'Data da ltima compra',
       '',
       'ULTCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '01',
       40,
       20,
       'ULTNOM',
       'A',
       '',
       0,
       0,
       'PAR ',
       50,
       TO_NUMBER(null),
       '',
       '',
       'L',
       'PAR',
       'F',
       'A',
       'T',
       'Nome Fantasia',
       'Fantasia',
       '',
       'ULTNOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VTRA',
       '04',
       10,
       8,
       'VALOR1',
       'F',
       '',
       2,
       0,
       'PAR ',
       10,
       TO_NUMBER(null),
       '',
       '',
       'I',
       'PAR',
       'T',
       '9',
       'F',
       'Limite de Crdito',
       'Armazena um valor qualquer',
       '',
       'VALOR1',
       'F' FROM DUAL
);

/*-- SEQ 10309 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VTRA',
       'CODSEX',
       0,
       '-',
       'Nao conhecido',
       144,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTRA',
       'CODSEX',
       1,
       '-',
       'Masculino',
       145,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTRA',
       'CODSEX',
       2,
       '-',
       'Feminino',
       146,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTRA',
       'ESTCIV',
       3,
       '-',
       'Vivo',
       150,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTRA',
       'ESTCIV',
       5,
       '-',
       'Unio Estvel',
       152,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTRA',
       'ESTCIV',
       6,
       '-',
       'Separado',
       153,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTRA',
       'ESTCIV',
       4,
       '-',
       'Divorciado',
       151,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTRA',
       'ESTCIV',
       0,
       '-',
       'Indefinido',
       147,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTRA',
       'ESTCIV',
       1,
       '-',
       'Solteiro',
       148,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTRA',
       'ESTCIV',
       2,
       '-',
       'Casado',
       149,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTRA',
       'FLGTIP',
       0,
       '-',
       'Fsica',
       154,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTRA',
       'FLGTIP',
       1,
       '-',
       'Jurdica',
       155,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTRA',
       'FLGTIP',
       2,
       '-',
       'Entidade',
       156,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTRA',
       'FLGTIP',
       3,
       '-',
       'Especial',
       157,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTRA',
       'FLGTIP',
       4,
       '-',
       'M.E.',
       158,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTRA',
       'FLGTIP',
       5,
       '-',
       'Filial',
       159,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTRA',
       'SEXCON',
       0,
       '-',
       'Nao conhecido',
       160,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTRA',
       'SEXCON',
       1,
       '-',
       'Masculino',
       161,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTRA',
       'SEXCON',
       2,
       '-',
       'Feminino',
       162,
       ' ' FROM DUAL
UNION ALL
SELECT 'VTRA',
       'TIPPAR',
       0,
       'F',
       'Compra',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VTRA',
       'TIPPAR',
       0,
       'T',
       'Frete',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10310 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VUNF',
       TO_NUMBER(null),
       'VUNF',
       'Registro Entrada',
       'TV_UNF',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10311 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VUNF','--','' FROM DUAL
UNION ALL
SELECT 'VUNF','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VUNF','02','Compras' FROM DUAL
UNION ALL
SELECT 'VUNF','03','Documento' FROM DUAL
UNION ALL
SELECT 'VUNF','04','Endereco' FROM DUAL
UNION ALL
SELECT 'VUNF','05','Fiscal' FROM DUAL
UNION ALL
SELECT 'VUNF','06','Item Compra' FROM DUAL
UNION ALL
SELECT 'VUNF','07','Parceiro' FROM DUAL
UNION ALL
SELECT 'VUNF','08','Produto' FROM DUAL
UNION ALL
SELECT 'VUNF','99','Outros' FROM DUAL
);

/*-- SEQ 10312 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VUNF',
       '99',
       10,
       6,
       'CFG_VC_CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Cdigo Cliente',
       'Cdigo Cliente',
       '',
       'CFG_VC_CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '99',
       20,
       3,
       'CFG_VC_FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Filial Cliente',
       'Filial Cliente',
       '',
       'CFG_VC_FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '02',
       30,
       12,
       'COM_BASFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base Frete',
       'Base Frete',
       '',
       'COM_BASFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '02',
       40,
       2,
       'COM_CODFCE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       '',
       '',
       'COM_CODFCE',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '02',
       50,
       12,
       'COM_ICMFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'ICMS Frete',
       'ICMS Frete',
       '',
       'COM_ICMFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '02',
       60,
       5,
       'COM_PERFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       '',
       '',
       '',
       'COM_PERFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '02',
       70,
       1,
       'COM_TIPPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'COM_TIPPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '02',
       80,
       12,
       'COM_VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Frete',
       'Valor Frete',
       '',
       'COM_VLRFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '99',
       90,
       0,
       'CTADOC_CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CTADOC_CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       100,
       12,
       'DOC_BASICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base ICMS',
       'Base ICMS',
       '',
       'DOC_BASICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       110,
       12,
       'DOC_BASIRR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base IRR',
       'Base IRR',
       '',
       'DOC_BASIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       120,
       12,
       'DOC_BASISS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base ISS',
       'Base ISS',
       '',
       'DOC_BASISS',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       130,
       12,
       'DOC_BASSUB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base Substituicao',
       'Base Substituicao',
       '',
       'DOC_BASSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       140,
       44,
       'DOC_CHAVEA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave',
       'Chave',
       '',
       'DOC_CHAVEA',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       150,
       3,
       'DOC_CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = VUNF.DOC_CODFIL',
       'DOC_CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       160,
       14,
       'DOC_CODIGO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DOC_CODIGO',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       170,
       6,
       'DOC_CODNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Codigo CFOP',
       'Codigo CFOP',
       '',
       'DOC_CODNAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       180,
       7,
       'DOC_DATDOC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Documento',
       'Data Documento',
       '',
       'DOC_DATDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       190,
       7,
       'DOC_DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Operacao',
       'Data Operacao',
       '',
       'DOC_DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       200,
       12,
       'DOC_DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Desconto',
       'Valor Desconto',
       '',
       'DOC_DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       210,
       30,
       'DOC_DESNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Natureza',
       'Natureza',
       '',
       'DOC_DESNAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       220,
       0,
       'DOC_DOCNFP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DOC_DOCNFP',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       230,
       3,
       'DOC_FILORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Origem',
       'Filial Origem',
       '',
       'DOC_FILORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       240,
       2,
       'DOC_FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DOC_FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       250,
       12,
       'DOC_ISEICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Isento ICMS',
       'Isento ICMS',
       '',
       'DOC_ISEICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       260,
       9,
       'DOC_NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Numero',
       'Numero Nota',
       '',
       'DOC_NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       270,
       4000,
       'DOC_OBSFIS',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DOC_OBSFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       280,
       12,
       'DOC_OUTTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Outras Taxas ',
       'Outras Taxas',
       '',
       'DOC_OUTTAX',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       290,
       5,
       'DOC_PERICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '% ICMS',
       'Percentual ICMS',
       '',
       'DOC_PERICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       300,
       5,
       'DOC_PERIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '% IRR',
       'Percentual IRR',
       '',
       'DOC_PERIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       310,
       5,
       'DOC_PERISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '% ISS',
       'Percentual ISS',
       '',
       'DOC_PERISS',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       320,
       10,
       'DOC_SEQORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DOC_SEQORI',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       330,
       10,
       'DOC_SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DOC_SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       340,
       12,
       'DOC_SUBSTT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Substituicao',
       'Valor Substituicao',
       '',
       'DOC_SUBSTT',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       350,
       1,
       'DOC_TIPFRE',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Tipo Frete',
       'Tipo Frete',
       '',
       'DOC_TIPFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       360,
       1,
       'DOC_TIPNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Nota',
       'Tipo Nota',
       '',
       'DOC_TIPNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       370,
       1,
       'DOC_UFLOJA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Dento Estado?',
       'Dento Estado?',
       '',
       'DOC_UFLOJA',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       380,
       12,
       'DOC_VLRCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Confins',
       'Valor Confins',
       '',
       'DOC_VLRCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       390,
       12,
       'DOC_VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Frete',
       'Valor Frete',
       '',
       'DOC_VLRFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       400,
       12,
       'DOC_VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor ICMS',
       'Valor ICMS',
       '',
       'DOC_VLRICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       410,
       12,
       'DOC_VLRIPI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '0',
       'F',
       'Valor IPI',
       'Valor IPI',
       '',
       'DOC_VLRIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       420,
       12,
       'DOC_VLRIRR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor IRR',
       'Valor IRR',
       '',
       'DOC_VLRIRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       430,
       12,
       'DOC_VLRISS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor ISS',
       'Valor ISS',
       '',
       'DOC_VLRISS',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       440,
       12,
       'DOC_VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Liquido',
       'Valor Liquido',
       '',
       'DOC_VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       450,
       12,
       'DOC_VLRPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Pis',
       'Valor Pis',
       '',
       'DOC_VLRPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       460,
       12,
       'DOC_VLRSEG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Seguro',
       'Valor Seguro',
       '',
       'DOC_VLRSEG',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '03',
       470,
       12,
       'DOC_VLRTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Nota',
       'Valor Nota',
       '',
       'DOC_VLRTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '04',
       480,
       40,
       'ENC_BAIRRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Bairro',
       'Bairro',
       '',
       'ENC_BAIRRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '04',
       490,
       16,
       'ENC_CODIGO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ENC_CODIGO',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '04',
       500,
       5,
       'ENC_CODPAI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ENC_CODPAI',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '04',
       510,
       40,
       'ENC_COMPLE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Complemento',
       'Complemento',
       '',
       'ENC_COMPLE',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '04',
       520,
       60,
       'ENC_ENDERE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Endereco',
       'Endereco',
       '',
       'ENC_ENDERE',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '04',
       530,
       160,
       'ENC_ENDERE_ESTRAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'ENC_ENDERE_ESTRAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '04',
       540,
       15,
       'ENC_INSEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Inscricao Estadual',
       'Inscricao Estadual',
       '',
       'ENC_INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '04',
       550,
       15,
       'ENC_NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'CPF/CNPJ',
       'CPF/CNPJ',
       '',
       'ENC_NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '04',
       560,
       15,
       'ENC_NUMERO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nuemro Endereco',
       'Numero Endereco',
       '',
       'ENC_NUMERO',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '04',
       570,
       2,
       'ENC_SIGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Estado',
       'Estado',
       '',
       'ENC_SIGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '05',
       580,
       3,
       'FIS_CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Serie',
       'Serie',
       '',
       'FIS_CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '05',
       590,
       2,
       'FIS_MODNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Modelo Nota',
       'Modelo Nota',
       '',
       'FIS_MODNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '05',
       600,
       2,
       'FIS_SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sub Serie',
       'Sub Serie',
       '',
       'FIS_SUBSER',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       610,
       12,
       'ICO_VLRITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Item',
       'Valor Item',
       '',
       'ICO_VLRITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       620,
       12,
       'ICO_VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Movimento',
       'Valor Movimento',
       '',
       'ICO_VLRMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       630,
       12,
       'ITE_BASCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base Confins',
       'Base Confins',
       '',
       'ITE_BASCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       640,
       14,
       'ITE_BASICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base ICMS',
       'Base ICMS',
       '',
       'ITE_BASICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       650,
       12,
       'ITE_BASIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base IPI ',
       'Base IPI',
       '',
       'ITE_BASIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       660,
       12,
       'ITE_BASPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'BAse PIS',
       'Base PIS',
       '',
       'ITE_BASPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       670,
       14,
       'ITE_BASSUB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Base Substituicao',
       'Base Substituicao',
       '',
       'ITE_BASSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       680,
       12,
       'ITE_CALSUB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ITE_CALSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       690,
       42,
       'ITE_CODCST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Codigo CTS',
       'Codigo CTS',
       '',
       'ITE_CODCST',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       700,
       3,
       'ITE_CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Item ',
       'Filial Item',
       '',
       'ITE_CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       710,
       19,
       'ITE_CODIGO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '',
       '',
       'ITE_CODIGO',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       720,
       6,
       'ITE_CODNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Item CFOP',
       'Item CFOP',
       '',
       'ITE_CODNAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       730,
       30,
       'ITE_DESNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Item Natura',
       'Item Natureza',
       '',
       'ITE_DESNAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       740,
       1,
       'ITE_ICMTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo ICMS',
       'Tipo ICMS',
       '',
       'ITE_ICMTIP',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       750,
       6,
       'ITE_ICMVEN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'ICMS Venda',
       'ICMS Venda',
       '',
       'ITE_ICMVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       760,
       12,
       'ITE_IPIFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'IPI Frete',
       'IPI Frete',
       '',
       'ITE_IPIFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       770,
       14,
       'ITE_ISEICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Item Isento ICMS',
       'Item Isento ICMS',
       '',
       'ITE_ISEICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       780,
       1,
       'ITE_LANEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Lancamento Estoque',
       'Lancamento Estoque',
       '',
       'ITE_LANEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       790,
       0,
       'ITE_NATFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ITE_NATFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       800,
       5,
       'ITE_NUMITE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Numero Item',
       'Numero Item',
       '',
       'ITE_NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       810,
       6,
       'ITE_PERCOF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '% Confins',
       '% Confins',
       '',
       'ITE_PERCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       820,
       6,
       'ITE_PERPIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '% PIS',
       '% PIS',
       '',
       'ITE_PERPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       830,
       12,
       'ITE_QTDMOV',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Quantidade',
       'Quantidade',
       '',
       'ITE_QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       840,
       7,
       'ITE_REDITE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Reducao Item',
       'Reducao Item',
       '',
       'ITE_REDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       850,
       7,
       'ITE_RED_ST',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Reducao Substt',
       'Reducao Substt',
       '',
       'ITE_RED_ST',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       860,
       2,
       'ITE_SITCOF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao Confins',
       'Situao Confins',
       '',
       'ITE_SITCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       870,
       1,
       'ITE_SITMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao Movimento',
       'Situao Movimento',
       '',
       'ITE_SITMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       880,
       2,
       'ITE_SITPIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Situao PIS',
       'Situao PIS',
       '',
       'ITE_SITPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       890,
       14,
       'ITE_TAXICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Taxa ICMS',
       'Taxa ICMS',
       '',
       'ITE_TAXICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       900,
       12,
       'ITE_TAXIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Taxa IPI',
       'Taxa IPI',
       '',
       'ITE_TAXIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       910,
       1,
       'ITE_TIPPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Produto',
       'Tipo Produto',
       '',
       'ITE_TIPPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       920,
       12,
       'ITE_VLRCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Confis Item',
       'Valor Confis Item',
       '',
       'ITE_VLRCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       930,
       12,
       'ITE_VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Desconto Item',
       'Valor Desconto Item ',
       '',
       'ITE_VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       940,
       12,
       'ITE_VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Frete Item ',
       'Valor Frete Item',
       '',
       'ITE_VLRFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       950,
       14,
       'ITE_VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor ICMS Item',
       'Valor ICMS Item',
       '',
       'ITE_VLRICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       960,
       12,
       'ITE_VLRIPI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor IPI Item',
       'Valor IPI Item',
       '',
       'ITE_VLRIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       970,
       12,
       'ITE_VLRLIQ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor liquido item ',
       'Valor liquido item ',
       '',
       'ITE_VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       980,
       12,
       'ITE_VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Movimento Item',
       'Valor Movimento Item',
       '',
       'ITE_VLRMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       990,
       12,
       'ITE_VLRPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor PIS Item',
       'Valor PIS Item',
       '',
       'ITE_VLRPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       1000,
       12,
       'ITE_VLRUNI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor Unitario Item',
       'Valor Unitario Item',
       '',
       'ITE_VLRUNI',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '06',
       1010,
       14,
       'ITE_VLR_ST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Valor ST Item',
       'Valor ST Item',
       '',
       'ITE_VLR_ST',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '99',
       1020,
       5,
       'MEDEMB_CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MEDEMB_CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '99',
       1030,
       20,
       'MEDEMB_DESMED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Unidade Medida',
       'Unidade Medida',
       '',
       'MEDEMB_DESMED',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '99',
       1040,
       1,
       'MEDEMB_MEDATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MEDEMB_MEDATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '99',
       1050,
       2,
       'MEDEMB_UNIMED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MEDEMB_UNIMED',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '99',
       1060,
       5,
       'MED_CODTAB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MED_CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '99',
       1070,
       20,
       'MED_DESMED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MED_DESMED',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '99',
       1080,
       1,
       'MED_MEDATI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MED_MEDATI',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '99',
       1090,
       2,
       'MED_UNIMED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MED_UNIMED',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '99',
       1100,
       10,
       'MUN_CODIBG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Codigo IBGE',
       'Codigo IBGE',
       '',
       'MUN_CODIBG',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '07',
       1110,
       6,
       'PAR_CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Codigo Cliente ',
       'Codigo Cliente',
       '',
       'PAR_CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '07',
       1120,
       9,
       'PAR_CODIGO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PAR_CODIGO',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '07',
       1130,
       5,
       'PAR_CODPAI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PAR_CODPAI',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '07',
       1140,
       3,
       'PAR_FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial Cliente',
       'Filial Cliente',
       '',
       'PAR_FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '07',
       1150,
       5,
       'PAR_FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Tipo Cliente ',
       'Tipo Cliente',
       '',
       'PAR_FLGTIP',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '07',
       1160,
       15,
       'PAR_INSEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Inscricao Eatadual',
       '',
       '',
       'PAR_INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '07',
       1170,
       64,
       'PAR_NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Cliente ',
       'Nome Cliente',
       '',
       'PAR_NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '07',
       1180,
       15,
       'PAR_NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'CPF/CPNJ Cliente',
       'CPF/CPNJ Cliente ',
       '',
       'PAR_NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '07',
       1190,
       9,
       'PAR_SUFRAM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PAR_SUFRAM',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '08',
       1200,
       9,
       'PRO_CODANP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRO_CODANP',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '08',
       1210,
       20,
       'PRO_CODEAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRO_CODEAN',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '08',
       1220,
       20,
       'PRO_CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRO_CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '08',
       1230,
       2,
       'PRO_CODFPS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRO_CODFPS',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '08',
       1240,
       13,
       'PRO_CODIGO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRO_CODIGO',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '08',
       1250,
       8,
       'PRO_CODNCM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRO_CODNCM',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '08',
       1260,
       4,
       'PRO_CODSRV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRO_CODSRV',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '08',
       1270,
       3,
       'PRO_COD_EX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRO_COD_EX',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '08',
       1280,
       2,
       'PRO_GENNCM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRO_GENNCM',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '08',
       1290,
       4000,
       'PRO_NOMPRO',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRO_NOMPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '08',
       1300,
       12,
       'PRO_PERICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRO_PERICM',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '08',
       1310,
       20,
       'PRO_REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRO_REFPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '08',
       1320,
       1,
       'PRO_SITIPI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRO_SITIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '99',
       1330,
       14,
       'SUBORI_FATCON',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SUBORI_FATCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '99',
       1340,
       3,
       'TRA_FILITE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TRA_FILITE',
       'F' FROM DUAL
UNION ALL
SELECT 'VUNF',
       '99',
       1350,
       20,
       'TRI_CODTRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TRI_CODTRI',
       'F' FROM DUAL
);

/*-- SEQ 10313 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VVAR',
       TO_NUMBER(null),
       'VVAR',
       'Preos no Varejo',
       'TV_VAR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VVAR.FILMAT,VVAR.CODMAT,VVAR.CODCOR,VVAR.CODTAM',
       '' FROM DUAL
);

/*-- SEQ 10314 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VVAR','--','' FROM DUAL
UNION ALL
SELECT 'VVAR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VVAR','99','Outros' FROM DUAL
);

/*-- SEQ 10315 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 5954,
       'GRA ',
       'VVAR',
       '1',
       '1',
       '',
       '',
       'GRA.FILMAT = VVAR.FILMAT AND
GRA.CODMAT = VVAR.CODMAT AND
GRA.CODCOR = VVAR.CODCOR AND
GRA.CODTAM = VVAR.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 10316 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VVAR',
       '01',
       10,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Diviso do produto',
       'VVAR.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'VVAR',
       '01',
       20,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Cdigo do material',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVAR',
       '01',
       30,
       2,
       'CODMOE',
       'S',
       'DMOE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       '',
       'F',
       'A',
       'F',
       'Moeda',
       'Moeda do plano',
       'VVAR.CODMOE=DMOE.CODTAB (+)',
       'CODMOE',
       'T' FROM DUAL
UNION ALL
SELECT 'VVAR',
       '01',
       40,
       5,
       'CODPRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo dos Preos',
       'Cdigo dos Preos',
       '',
       'CODPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VVAR',
       '01',
       50,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Sub-Diviso do produto',
       'VVAR.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'VVAR',
       '01',
       140,
       6,
       'DESIDE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Desconto Ideal',
       '% Desconto Ideal',
       '',
       'DESIDE',
       '' FROM DUAL
UNION ALL
SELECT 'VVAR',
       '01',
       60,
       12,
       'DESMAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Desconto Mximo',
       'Desconto Mximo',
       '',
       'DESMAX',
       'F' FROM DUAL
UNION ALL
SELECT 'VVAR',
       '01',
       70,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do material',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVAR',
       '01',
       80,
       3,
       'FILPRE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       '',
       'Filial dos Preos',
       'DFIL.CODFIL = VVAR.FILPRE',
       'FILPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VVAR',
       '01',
       90,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'VVAR',
       '01',
       130,
       7,
       'PERLUC',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% do Lucro',
       '% do Lucro',
       '',
       'PERLUC',
       '' FROM DUAL
UNION ALL
SELECT 'VVAR',
       '01',
       100,
       12,
       'PRECOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Preo de Venda',
       'Preo de Venda',
       '',
       'PRECOV',
       'F' FROM DUAL
UNION ALL
SELECT 'VVAR',
       '01',
       110,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VVAR',
       '01',
       120,
       7,
       'ULTREA',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'ltima Realizao',
       'Data ltima Realizao',
       '',
       'ULTREA',
       'F' FROM DUAL
);

/*-- SEQ 10317 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VVAR',
       'FLGEST',
       0,
       'F',
       'Falso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VVAR',
       'FLGEST',
       0,
       'T',
       'Verdadeiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10318 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VVEI',
       TO_NUMBER(null),
       'VVEI',
       'Veculos do Cliente',
       'TV_VEI',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'vvei.filcli,vvei.codcli',
       '' FROM DUAL
);

/*-- SEQ 10319 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VVEI','--','' FROM DUAL
UNION ALL
SELECT 'VVEI','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VVEI','99','Outros' FROM DUAL
);

/*-- SEQ 10320 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VVEI',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Codigo cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VVEI',
       '01',
       20,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VVEI',
       '01',
       30,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento (CPF/CGC)',
       'Nmero do Documento: CGC ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VVEI',
       '01',
       40,
       7,
       'PLACAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Placa',
       'Placa do veiculo',
       '',
       'PLACAS',
       'F' FROM DUAL
);

/*-- SEQ 10321 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VVF ',
       TO_NUMBER(null),
       'VVF ',
       'Ven. x Fis.',
       'TV_VEN_FIS',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VVF.CODFIL,VVF.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 10322 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VVF ','--','' FROM DUAL
UNION ALL
SELECT 'VVF ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VVF ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VVF ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VVF ','99','Outros' FROM DUAL
);

/*-- SEQ 10323 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VVF ',
       '99',
       591,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN VVF.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '02',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '99',
       20,
       1,
       'AUTENT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Autenticada?',
       'Indica se a nota j foi autenticada',
       '',
       'AUTENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '03',
       720,
       12,
       'BASUBS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Base Sub. Tributria',
       'Base da Substituio Tributria',
       '',
       'BASUBS',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       780,
       44,
       'CHAVEA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Chave de Acesso NF-e',
       'Chave de Acesso NF-e',
       '',
       'CHAVEA',
       '' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       40,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '03',
       50,
       5,
       'CODCTR',
       'F',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       'F',
       '9',
       'F',
       'Unidade de Negcios',
       'Unidade de Negcios',
       'VVF.CODCTR = DCTR.CODTAB(+)',
       'CODCTR',
       'T' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '99',
       60,
       12,
       'CODEXT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Cdigo Externo',
       'Cdigo Externo',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       70,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Cdigo da filial',
       'DFIL.CODFIL = VVF.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       730,
       12,
       'CODFIN',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Cod. da Financeira',
       'Cod. da Financeira',
       '',
       'CODFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       90,
       3,
       'CODGUI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Guia',
       'Cdigo do Guia',
       '',
       'CODGUI',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       740,
       12,
       'CODNAT',
       'S',
       'DNAT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DNAT.NATURE',
       'V',
       '',
       'F',
       'A',
       'F',
       'Natureza',
       'Natureza de operao',
       'VVF.CODNAT = DNAT.CODTAB (+)',
       'CODNAT',
       'T' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       110,
       3,
       'CODPGT',
       'A',
       'PLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Plano',
       'Cdigo do plano de pagamento',
       'VVF.FILPGT = PLA.FILPGT AND VVF.CODPGT = PLA.CODPGT',
       'CODPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '03',
       120,
       12,
       'CODPRE',
       'S',
       'TPR ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'TPR.DESPRE',
       'V',
       '',
       'F',
       'A',
       'F',
       'Tab. de Preos',
       'Cdigo da tabela de preos',
       'VVF.FILPRE=TPR.CODFIL (+) AND VVF.CODPRE=TPR.CODPRE (+)',
       'CODPRE',
       'T' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       130,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       'F',
       'A',
       'F',
       'Srie',
       'Cdigo da srie',
       'VVF.CODSER=DSER.CODSER (+)',
       'CODSER',
       'T' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       140,
       6,
       'CODTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Transportadora',
       'Cdigo da Transportadora',
       '',
       'CODTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       150,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Usurio',
       'Cdigo do usurio',
       'VVF.FILUSU = USU.FILUSU(+)  AND VVF.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       160,
       3,
       'CODVEN',
       'A',
       'VDD ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'VDD.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Vendedor',
       'Cdigo do vendedor',
       'VVF.FILVEN = VDD.FILUSU (+)  AND VVF.CODVEN = VDD.CODUSU (+)',
       'CODVEN',
       'T' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       170,
       2,
       'COMSOB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Comisso Sobre',
       'Comisso sobre (ver tela plano)',
       '',
       'COMSOB',
       'T' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '99',
       180,
       1,
       'CONSFI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Consumidor Final?',
       'Consumidor Final?',
       '',
       'CONSFI',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '02',
       190,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data Incluso',
       'Data e hora da operao',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '02',
       200,
       7,
       'DATSAI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data Sada',
       'Data Sada',
       '',
       'DATSAI',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '03',
       210,
       8,
       'DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Desc/Acrscimo (%)',
       'Desconto / Acrscimo',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '99',
       220,
       1,
       'EMIDES',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Frete Dest./Terc.?',
       'Frete  por conta do Destinatrio ou de Terceiros?',
       '',
       'EMIDES',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       750,
       12,
       'ENDCOB',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nmero End. Cobrana',
       'Nmero do endereo de cobrana',
       '',
       'ENDCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       240,
       12,
       'ENDENT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nmero End. Entrega',
       'Nmero do endereo de entrega',
       '',
       'ENDENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       250,
       12,
       'ENDFAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nmero End. Fatura',
       'Nmero de endereo de fatura',
       '',
       'ENDFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       260,
       12,
       'ESPECI',
       'S',
       'DESP',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DESP.ESPECI',
       'V',
       '',
       'F',
       'A',
       'F',
       'Espcie de Volume',
       'Espcie do volume',
       'VEN.ESPECI = DESP.CODTAB (+)',
       'ESPECI',
       'T' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '99',
       270,
       1,
       'EXPORT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Exportada?',
       'Exportada?',
       '',
       'EXPORT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       280,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       290,
       3,
       'FILCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do endereo de cobrana',
       '',
       'FILCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       300,
       3,
       'FILENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do endereo de entrega',
       '',
       'FILENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       310,
       3,
       'FILFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do endereo de fatura',
       '',
       'FILFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       320,
       3,
       'FILGUI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do guia',
       '',
       'FILGUI',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       330,
       3,
       'FILPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do plano de pagamento',
       '',
       'FILPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       340,
       3,
       'FILPRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial da tabela de preo',
       '',
       'FILPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       350,
       3,
       'FILTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial da Transportadora',
       '',
       'FILTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       360,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       370,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial do vendedor',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '99',
       380,
       1,
       'FINANC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Gera Dados Financ.?',
       'Gera dados financeiros',
       '',
       'FINANC',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '99',
       390,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Situao',
       'Estado (Cancelado/Quitado/Em aberto)',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       400,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Pessoa ',
       'Tipo de Pessoa',
       '',
       'FLGTIP',
       'T' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '99',
       410,
       1,
       'LANVEN',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Implementao Futura',
       'Implementao futura',
       '',
       'LANVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       420,
       5,
       'MARCAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Marcas',
       'Marcas',
       '',
       'MARCAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       430,
       2,
       'NROIMP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nm. Impresses',
       'Nmero de vezes que a nota foi impressa',
       '',
       'NROIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       440,
       8,
       'NUMCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Conhecimento',
       'Conhecimento de frete',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       450,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '0',
       'F',
       'ECF',
       'Nmero do ECF',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       760,
       6,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nmero',
       'Nmero da nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '03',
       470,
       4,
       'NUMVOL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Num.Volumes',
       'Nmero de Volumes',
       '',
       'NUMVOL',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '99',
       480,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Observaes',
       'Observaes',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '03',
       490,
       8,
       'PERCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Comis. s/ Parcelas',
       'Valor da comisso sobre as parcelas (exceto entrada)',
       '',
       'PERCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '03',
       500,
       8,
       'PERENT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Comis. s/ Entrada',
       'Comisso (entrada)',
       '',
       'PERENT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '03',
       510,
       14,
       'PESBRU',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Peso Bruto',
       'Peso lquido',
       '',
       'PESBRU',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '03',
       520,
       14,
       'PESLIQ',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Peso Lquido',
       'Peso bruto',
       '',
       'PESLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '03',
       530,
       2,
       'PRAMED',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Prazo Mdio',
       'Prazo mdio',
       '',
       'PRAMED',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '02',
       540,
       8,
       'PROPGT',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Prox. Pagamento',
       'Data prximo pagamento ou data do cancelamento',
       '',
       'PROPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '03',
       550,
       12,
       'REDTOT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Reduo Total',
       'Reduo Total',
       '',
       'REDTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '03',
       560,
       12,
       'RETIDO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Imposto retido',
       'Valor do Importo Retido',
       '',
       'RETIDO',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '03',
       770,
       12,
       'SEGRUR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       '',
       'Valor Seguro Rural',
       'Valor Seguro Rural',
       '',
       'SEGRUR',
       '' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '99',
       570,
       10,
       'SEQFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Nmero sequencial interno da fatura',
       '',
       'SEQFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '99',
       580,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '99',
       590,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN VVF.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '03',
       600,
       8,
       'SINAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Sinal Relacionado',
       'Valor de sinal relacionado',
       '',
       'SINAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '03',
       610,
       12,
       'SUBSTT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Subst. Tributria',
       'Subst. Tributria',
       '',
       'SUBSTT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       620,
       1,
       'TIPNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo de Nota',
       'Tipo de Nota',
       '',
       'TIPNOT',
       'T' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       630,
       1,
       'TIPTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Tipo Trabalho',
       'Tipo Trabalho',
       '',
       'TIPTRA',
       'T' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '01',
       640,
       1,
       'TIPTRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo Cheque Troco',
       'Tipo Conta Cheque Troco',
       '',
       'TIPTRO',
       'T' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '99',
       650,
       1,
       'TRIBUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Tributada?',
       'Define se a venda  tributada',
       '',
       'TRIBUT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '99',
       660,
       1,
       'UFLOJA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       'A',
       'F',
       'Dentro do Estado?',
       'Venda Dentro do Estado?',
       '',
       'UFLOJA',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '99',
       670,
       1,
       'VINCUL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       'F',
       '',
       'F',
       'Vinculada?',
       'Vinculada?',
       '',
       'VINCUL',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '03',
       680,
       8,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Frete',
       'Valor do Frete',
       '',
       'VLRFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '03',
       690,
       8,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Lquido',
       'Valor lquido da nota',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '03',
       700,
       8,
       'VLRNOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor dos Itens',
       'Valor da nota',
       '',
       'VLRNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVF ',
       '03',
       710,
       8,
       'VLRSEG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Seguro',
       'Valor do seguro do frete',
       '',
       'VLRSEG',
       'F' FROM DUAL
);

/*-- SEQ 10324 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VVF ',
       'COMSOB',
       5,
       ' ',
       'Recebido na compensao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'COMSOB',
       6,
       ' ',
       'A receber na compensao',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'COMSOB',
       7,
       ' ',
       'Comisso sobre markup',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'COMSOB',
       8,
       ' ',
       'Markup no momento da Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'COMSOB',
       0,
       '-',
       'Lquido ao Vender',
       241,
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'COMSOB',
       1,
       '-',
       'Bruto ao Vender',
       242,
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'COMSOB',
       2,
       '-',
       'A receber no Vencimento',
       243,
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'COMSOB',
       4,
       '-',
       'A receber no Recebimento',
       245,
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'COMSOB',
       3,
       '-',
       'Recebido no Recebimento',
       244,
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'FLGEST',
       0,
       'A',
       'Em Aberta',
       102,
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'FLGEST',
       0,
       'C',
       'Cancelada',
       100,
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'FLGEST',
       0,
       'Q',
       'Quitada',
       101,
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'FLGTIP',
       1,
       '-',
       'Jurdica',
       155,
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'FLGTIP',
       2,
       '-',
       'Entidade',
       156,
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'FLGTIP',
       3,
       '-',
       'Especial',
       157,
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'FLGTIP',
       4,
       '-',
       'M.E.',
       158,
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'FLGTIP',
       0,
       '-',
       'Fsica',
       154,
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'FLGTIP',
       5,
       '-',
       'Filial',
       159,
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'TIPNOT',
       0,
       'A',
       'N.F.F.',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'TIPNOT',
       0,
       'F',
       'Fatura',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'TIPNOT',
       0,
       'N',
       'Nota fiscal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'TIPTRA',
       0,
       'R',
       'Reviso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'TIPTRA',
       0,
       'T',
       'Tarefa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'TIPTRO',
       0,
       'G',
       'Gerencial',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VVF ',
       'TIPTRO',
       0,
       'N',
       'Numrica',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10325 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VVHP',
       TO_NUMBER(null),
       'VVHP',
       'PCIA - Vendas HP',
       'TV_PCIA_VEN_HP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10326 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VVHP','--','' FROM DUAL
UNION ALL
SELECT 'VVHP','01','Filtros' FROM DUAL
UNION ALL
SELECT 'VVHP','05','HP' FROM DUAL
UNION ALL
SELECT 'VVHP','99','Outros' FROM DUAL
);

/*-- SEQ 10327 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VVHP',
       '--',
       190,
       5,
       'CLASS2',
       'S',
       'DCL2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL2.CLASS2',
       'V',
       '',
       '',
       'A',
       'F',
       'FAMILIA',
       '',
       'DCL2.CODTAB = VVHP.CLASS2',
       'CLASS2',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '--',
       200,
       5,
       'CLASS3',
       'S',
       'DCL3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCL3.CLASS3',
       'V',
       '',
       '',
       'A',
       'F',
       'GRUPO',
       '',
       'DCL3.CODTAB = VVHP.CLASS3',
       'CLASS3',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '--',
       210,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Codigo Filial',
       '',
       'DFIL.CODFIL = VVHP.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '--',
       220,
       10,
       'CODIGO_ORIGEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Codigo Origem',
       '',
       '',
       'CODIGO_ORIGEM',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '--',
       230,
       9,
       'CODIGO_REVENDA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Codigo Revenda',
       '',
       '',
       'CODIGO_REVENDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '--',
       240,
       5,
       'CODNAT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Natureza',
       '',
       '',
       'CODNAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '05',
       30,
       2,
       'COUNTRY_CODE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'COUNTRY_CODE',
       '',
       '',
       'COUNTRY_CODE',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '--',
       250,
       18,
       'CPF_CNPJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'CPF_CNPJ',
       '',
       '',
       'CPF_CNPJ',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '--',
       260,
       8,
       'DATA_VENDA',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Venda',
       '',
       '',
       'DATA_VENDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '01',
       180,
       7,
       'DATFIM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Final',
       '',
       '',
       'DATFIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '01',
       170,
       7,
       'DATINI',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Inicial',
       '',
       '',
       'DATINI',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '05',
       150,
       40,
       'END_USER_EMAIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'END_USER_EMAIL',
       '',
       '',
       'END_USER_EMAIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '05',
       140,
       14,
       'END_USER_FONE_NUMBER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'END_USER_FONE_NUMBER',
       '',
       '',
       'END_USER_FONE_NUMBER',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '05',
       120,
       64,
       'END_USER_FULL_NAME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'END_USER_FULL_NAME',
       '',
       '',
       'END_USER_FULL_NAME',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '05',
       130,
       15,
       'END_USER_GOVLD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'END_USER_GOVLD',
       '',
       '',
       'END_USER_GOVLD',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '--',
       390,
       40,
       'E_MAIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'E_mail',
       '',
       '',
       'E_MAIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '05',
       50,
       0,
       'FINAL_SALES_DAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'FINAL_SALES_DAT',
       '',
       '',
       'FINAL_SALES_DAT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '--',
       400,
       35,
       'FORMA_DE_PAGAMENTO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Forma Pagamento',
       '',
       '',
       'FORMA_DE_PAGAMENTO',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '05',
       80,
       20,
       'HP_PRODUCT_SERIAL_NUMBER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'HP_PRODUCT_SERIAL_NU',
       '',
       '',
       'HP_PRODUCT_SERIAL_NUMBER',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '05',
       90,
       1,
       'HP_PRODUT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'HP_PRODUT',
       '',
       '',
       'HP_PRODUT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '--',
       410,
       7,
       'INICIO_SEMANA_VENDAS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Inicio Semana venda',
       '',
       '',
       'INICIO_SEMANA_VENDAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '05',
       40,
       0,
       'INITIAL_SALES_DATA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'INITIAL_SALES_DATA',
       '',
       '',
       'INITIAL_SALES_DATA',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '05',
       60,
       10,
       'INVOICE_DATE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'INVOICE_DATE',
       '',
       '',
       'INVOICE_DATE',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '05',
       70,
       55,
       'INVOICE_NUMBER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'INVOICE_NUMBER',
       '',
       '',
       'INVOICE_NUMBER',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '--',
       300,
       30,
       'MARCA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'MARCA',
       '',
       '',
       'MARCA',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '--',
       420,
       64,
       'NOME_CONSUMIDOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Consumidor',
       '',
       '',
       'NOME_CONSUMIDOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '--',
       430,
       6,
       'NUMERO_NOTA_FISCAL_VENDA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Numero Nota Fiscal',
       '',
       '',
       'NUMERO_NOTA_FISCAL_VENDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '--',
       440,
       6,
       'PAIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Pais',
       '',
       '',
       'PAIS',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '--',
       450,
       20,
       'PARTE_NUMBER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Parte_Number',
       '',
       '',
       'PARTE_NUMBER',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '05',
       10,
       9,
       'PATNER_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'PATNER_ID',
       '',
       '',
       'PATNER_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '05',
       110,
       1,
       'PROGRAM_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'PROGRAM_ID',
       '',
       '',
       'PROGRAM_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '05',
       160,
       10,
       'PURCHE_TYPE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'PURCHE_TYPE',
       '',
       '',
       'PURCHE_TYPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '--',
       460,
       12,
       'QUANTIDADE_VENDIDA',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Quantidade Vendida',
       '',
       '',
       'QUANTIDADE_VENDIDA',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '05',
       100,
       12,
       'SOLID_UNITS',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'SOLID_UNITS',
       '',
       '',
       'SOLID_UNITS',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '05',
       20,
       28,
       'STORE_NAME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'STORE_NAME',
       '',
       '',
       'STORE_NAME',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '--',
       360,
       16,
       'TELEFONE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Telefone',
       '',
       '',
       'TELEFONE',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '--',
       370,
       7,
       'TERMINO_SEMANA_VENDAS',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Termino Semana Venda',
       '',
       '',
       'TERMINO_SEMANA_VENDAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VVHP',
       '--',
       380,
       12,
       'VALOR_DA_VENDA',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor Venda',
       '',
       '',
       'VALOR_DA_VENDA',
       'F' FROM DUAL
);

/*-- SEQ 10328 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VVND',
       TO_NUMBER(null),
       'VVND',
       'Vended. e Indicad.',
       'TV_VND',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VVND.FILCLI,VVND.CODCLI
VVND.NOMCLI,VVND.ULTNOM
VVND.NUMDOC',
       '' FROM DUAL
);

/*-- SEQ 10329 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VVND','--','' FROM DUAL
UNION ALL
SELECT 'VVND','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VVND','02','Endereo' FROM DUAL
UNION ALL
SELECT 'VVND','03','Documentao' FROM DUAL
UNION ALL
SELECT 'VVND','04','Dados Financeiros' FROM DUAL
UNION ALL
SELECT 'VVND','99','Outros' FROM DUAL
);

/*-- SEQ 10330 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22100,
       'EDE ',
       'VVND',
       'N',
       '1',
       '',
       '',
       'EDE.FILCLI = VVND.FILCLI AND
EDE.CODCLI = VVND.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22101,
       'CON ',
       'VVND',
       '0N',
       '01',
       '',
       '',
       'CON.FILCLI = VVND.FILCLI (+) AND
CON.CODCLI = VVND.CODCLI (+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22102,
       'SPC ',
       'VVND',
       '01',
       '01',
       '',
       '',
       'SPC.FILCLI = VVND.FILCLI (+) AND
SPC.CODCLI = VVND.CODCLI (+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 10331 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VVND',
       '01',
       20,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '99',
       30,
       2,
       'CATEG1',
       'S',
       'DCT1',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT1.NOMCT1',
       'V',
       '',
       '',
       'A',
       'F',
       'Profisso/Ramo',
       'Categoria - 1',
       'VVND.CATEG1=DCT1.CODTAB (+)',
       'CATEG1',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '99',
       40,
       2,
       'CATEG2',
       'S',
       'DCT2',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT2.NOMCT2',
       'V',
       '',
       '',
       'A',
       'F',
       'Salrio/Faturam',
       'Categoria - 2',
       'VVND.CATEG2=DCT2.CODTAB (+)',
       'CATEG2',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '99',
       50,
       2,
       'CATEG3',
       'S',
       'DCT3',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCT3.NOMCT3',
       'V',
       '',
       '',
       'A',
       'F',
       '3',
       'Categoria - 3',
       'VVND.CATEG3=DCT3.CODTAB (+)',
       'CATEG3',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '01',
       60,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo',
       'Cdigo do fornecedor',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '01',
       70,
       3,
       'CODPLA',
       'A',
       'PLA ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'PLA.APEPGT',
       'V',
       '',
       '',
       'A',
       'F',
       'Plano padro',
       'Cdigo do plano padro',
       'VVND.FILPLA=PLA.FILPGT(+)  AND VVND.CODPLA=PLA.CODPGT(+)',
       'CODPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '01',
       80,
       2,
       'CODSEX',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Sexo',
       'Cdigo de Sexo do parceiro',
       '',
       'CODSEX',
       'T' FROM DUAL
UNION ALL
SELECT 'VVND',
       '01',
       90,
       3,
       'CODVEN',
       'A',
       'VDD ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'VDD.APEUSU',
       'V',
       '',
       '',
       'N',
       'F',
       'Vendedor',
       'Cdigo do Vendedor',
       'VVND.FILVEN = VDD.FILUSU (+) = CMS.FILVEN AND VVND.CODVEN = VDD.CODUSU (+)',
       'CODVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '01',
       100,
       44,
       'CONJUG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Cnjuge ou Contato',
       'Nome do Cnjuge ou do Contato principal',
       '',
       'CONJUG',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '99',
       110,
       8,
       'DATA01',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       '',
       'Data livre - 1',
       '',
       'DATA01',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '99',
       120,
       8,
       'DATA02',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       '',
       'Data livre - 2',
       '',
       'DATA02',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '99',
       130,
       8,
       'DATA03',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       '',
       'Data livre - 3',
       '',
       'DATA03',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '01',
       140,
       8,
       'DATNAS',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Nascto/Fundao',
       'Data de nascimento',
       '',
       'DATNAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '01',
       150,
       8,
       'DATOPE',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data Incluso',
       'Data de operao (cadastramento)',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '04',
       160,
       15,
       'DOCCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Doc. Cnjuge/Contato',
       'Doc. Cnjuge/Contato',
       '',
       'DOCCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '04',
       170,
       2,
       'ESTCIV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Estado Civil',
       'Estado Civil',
       '',
       'ESTCIV',
       'T' FROM DUAL
UNION ALL
SELECT 'VVND',
       '01',
       180,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial onde foi cadastrado o fornecedor',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '01',
       190,
       3,
       'FILPLA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial do plano',
       'Filial do plano',
       '',
       'FILPLA',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '01',
       200,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Vendedor',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '03',
       210,
       2,
       'FLGTIP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tipo de Pessoa',
       'Flag de tipo de pessoa',
       '',
       'FLGTIP',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '02',
       220,
       40,
       'HOMPGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Home Page',
       'Home Page do Fornecedor',
       '',
       'HOMPGE',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '99',
       230,
       2,
       'IMPRIM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Livre p/Customizao',
       'Livre para customizao',
       '',
       'IMPRIM',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '03',
       240,
       15,
       'INSEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '2 Documento',
       'Inscrio Estadual ou Identidade',
       '',
       'INSEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '04',
       250,
       2,
       'MAIATR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Atraso Max. ao Pagar',
       'Maior atraso registrado',
       '',
       'MAIATR',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '01',
       260,
       8,
       'NASCON',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Nascto Cnj./Contato',
       'Data de nascimento do cnjuge ou contato principal',
       '',
       'NASCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '01',
       270,
       44,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome/Razo Social',
       'Nome do Cliente',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '03',
       280,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'L',
       '',
       '',
       'A',
       'F',
       'Documento (CPF/CNPJ)',
       'Nmero do Documento: CNPJ ou CPF',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '99',
       290,
       10,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observaes',
       'Observaes',
       '',
       'RTF2TXT(VVND.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '01',
       300,
       5,
       'PORPAD',
       'F',
       'DCOB',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCOB.DESCOB',
       'V',
       '',
       '',
       'A',
       'F',
       'Portador Padro',
       'Portador padro',
       'VVND.PORPAD=DCOB.CODTAB (+)',
       'PORPAD',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '01',
       310,
       5,
       'SEXCON',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Sexo do Cnjuge',
       'Sexo do Cnjuge',
       '',
       'SEXCON',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '99',
       320,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN VVND.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '99',
       321,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN VVND.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'VVND',
       '04',
       330,
       4,
       'TOTATR',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tot.Atrasos ForXCli',
       'Total de atrasos na vida do Fornecedor como cliente',
       '',
       'TOTATR',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '04',
       340,
       4,
       'TOTPAR',
       'G',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Tot.Parcelas ForXCli',
       'Total de parcelas na vida do Fornecedor como Cliente',
       '',
       'TOTPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '01',
       350,
       8,
       'ULTCOM',
       'D',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'ltima Compra',
       'Data da ltima compra',
       '',
       'ULTCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '01',
       360,
       20,
       'ULTNOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'L',
       '',
       '',
       'A',
       'F',
       'Sobrenome/Fantasia',
       'Sobrenome ou fantasia',
       '',
       'ULTNOM',
       'F' FROM DUAL
UNION ALL
SELECT 'VVND',
       '04',
       370,
       8,
       'VALOR1',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Limite de Crdito',
       'Limite de Crdito',
       '',
       'VALOR1',
       'F' FROM DUAL
);

/*-- SEQ 10332 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VVND',
       'CODSEX',
       0,
       ' ',
       'No conhecido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VVND',
       'CODSEX',
       1,
       ' ',
       'Masculino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VVND',
       'CODSEX',
       2,
       ' ',
       'Feminino',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VVND',
       'ESTCIV',
       3,
       ' ',
       'Viuvo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VVND',
       'ESTCIV',
       1,
       ' ',
       'Solteiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VVND',
       'ESTCIV',
       2,
       ' ',
       'Casado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VVND',
       'ESTCIV',
       6,
       ' ',
       'Separado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VVND',
       'ESTCIV',
       5,
       ' ',
       'Unio Estvel',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VVND',
       'ESTCIV',
       0,
       ' ',
       'Indefinido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VVND',
       'ESTCIV',
       4,
       ' ',
       'Divorciado',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10333 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VVPE',
       TO_NUMBER(null),
       'VVPE',
       'Ven. Perd. Agrupadas',
       'TV_VPE_CP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10334 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VVPE','--','' FROM DUAL
UNION ALL
SELECT 'VVPE','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VVPE','99','Outros' FROM DUAL
);

/*-- SEQ 10335 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 26044,
       'CLI ',
       'VVPE',
       '0N',
       '1',
       '',
       '',
       'CLI.FILCLI = VPE.FILCLI and
CLI.CODCLI = VPE.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 26045,
       'USU ',
       'VVPE',
       '0N',
       '1',
       '',
       '',
       'USU.FILUSU = VVPE.FILVDD AND
USU.CODUSU = VVPE.CODVDD',
       '',
       '' FROM DUAL
);

/*-- SEQ 10336 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VVPE',
       '--',
       65,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VVPE',
       '--',
       20,
       5,
       'CODCTR',
       'S',
       'DCTR',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCTR.DESCTR',
       'V',
       '',
       '',
       'N',
       'F',
       'Unidade de Negcio',
       'Unidade de negcio',
       'DCTR.CODTAB = VVPE.CODCTR',
       'CODCTR',
       'F' FROM DUAL
UNION ALL
SELECT 'VVPE',
       '--',
       5,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       'DFIL.CODFIL = VVPE.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VVPE',
       '--',
       75,
       3,
       'CODVDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       'F',
       'Cdigo do Vendedor',
       'Cdigo do Vendedor',
       '',
       'CODVDD',
       'F' FROM DUAL
UNION ALL
SELECT 'VVPE',
       '--',
       50,
       7,
       'DATVPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'D',
       'F',
       'Data',
       'Data',
       '',
       'DATVPE',
       'F' FROM DUAL
UNION ALL
SELECT 'VVPE',
       '--',
       60,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do Cliente',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VVPE',
       '--',
       70,
       3,
       'FILVDD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial do Vendedor',
       'Filial do Vendedor',
       '',
       'FILVDD',
       'F' FROM DUAL
UNION ALL
SELECT 'VVPE',
       '--',
       80,
       1,
       'STATUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Status',
       'Status',
       '',
       'STATUS',
       'T' FROM DUAL
);

/*-- SEQ 10337 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VVPE',
       'STATUS',
       0,
       'P',
       'Perdida',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VVPE',
       'STATUS',
       0,
       'R',
       'Recuperada',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10338 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VRM ',
       TO_NUMBER(null),
       'VRM ',
       'Vendas x Romaneio',
       'TV_VEN_ROM',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10339 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VRM ','--','' FROM DUAL
UNION ALL
SELECT 'VRM ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VRM ','99','Outros' FROM DUAL
);

/*-- SEQ 10340 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 45931,
       'RECP',
       'VRM ',
       '01',
       'N',
       '',
       '',
       'VRM.CODFIL = RECP.ORI_CODFIL(+) AND
VRM.SEQUEN = RECP.ORI_SEQUEN(+) AND
VRM.NUMPAR = RECP.ORI_NUMPAR(+) AND
VRM.SUBPAR = RECP.ORI_SUBPAR(+)',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45892,
       'VEN ',
       'VRM ',
       '1',
       'N',
       '',
       '',
       'VEN.CODFIL = VRM.CODFIL AND VEN.SEQUEN = VRM.SEQUEN',
       '',
       '' FROM DUAL
UNION ALL
SELECT 45893,
       'REC ',
       'VRM ',
       '01',
       'N',
       '',
       '',
       'VRM.CODFIL = REC.CODFIL(+) AND
VRM.SEQUEN = REC.SEQUEN(+) AND
VRM.NUMPAR = REC.NUMPAR(+) AND
VRM.SUBPAR = REC.SUBPAR(+)',
       '',
       '' FROM DUAL
);

/*-- SEQ 10341 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VRM ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial da Venda',
       'Filial da Venda',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VRM ',
       '01',
       30,
       3,
       'FILIRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial do Romaneio',
       'Filial do Romaneio',
       '',
       'FILIRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VRM ',
       '01',
       40,
       3,
       'FILROM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       '',
       '',
       'FILROM',
       'F' FROM DUAL
UNION ALL
SELECT 'VRM ',
       '01',
       50,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       '',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VRM ',
       '01',
       80,
       10,
       'SEQIRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       '',
       '',
       'SEQIRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VRM ',
       '01',
       90,
       10,
       'SEQROM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       '',
       '',
       'SEQROM',
       'F' FROM DUAL
UNION ALL
SELECT 'VRM ',
       '01',
       100,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequen. da Vend',
       'Sequenciador da Venda',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VRM ',
       '01',
       110,
       10,
       'SEQVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Sequen. do Romaneio',
       'Sequenciador do Romaneio',
       '',
       'SEQVEN',
       'F' FROM DUAL
);


/*-- SEQ 10342 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VVXP',
       TO_NUMBER(null),
       'VVXP',
       'Trfego de Veculos',
       'TV_VXP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VVXP.FILCLI,VVXP.CODCLI',
       '' FROM DUAL
);

/*-- SEQ 10343 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VVXP','--','' FROM DUAL
UNION ALL
SELECT 'VVXP','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VVXP','02','Datas' FROM DUAL
UNION ALL
SELECT 'VVXP','03','Valores' FROM DUAL
UNION ALL
SELECT 'VVXP','99','Outros' FROM DUAL
);

/*-- SEQ 10344 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VVXP',
       '01',
       10,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo do cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VVXP',
       '01',
       20,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Codigo da filial',
       'VVXP.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'VVXP',
       '01',
       30,
       6,
       'CODMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo do Morista',
       'Codigo do Motorista',
       '',
       'CODMOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVXP',
       '01',
       40,
       2,
       'CODSER',
       'A',
       'DSER',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSER.DESSER',
       'V',
       '',
       'F',
       'A',
       'F',
       'Srie',
       'Cdigo da srie',
       'VVXP.CODSER=DSER.CODSER (+)',
       'CODSER',
       'T' FROM DUAL
UNION ALL
SELECT 'VVXP',
       '02',
       50,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data/Hora',
       'Data/Hora',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VVXP',
       '01',
       60,
       30,
       'DESTIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Destino',
       'Para onde o veiculo vai',
       '',
       'DESTIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VVXP',
       '01',
       70,
       13,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documento',
       'Documento',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VVXP',
       '01',
       80,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VVXP',
       '01',
       90,
       15,
       'FILIAL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial',
       'Filial',
       '',
       'FILIAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VVXP',
       '01',
       100,
       3,
       'FILMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Motorista',
       '',
       'FILMOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVXP',
       '01',
       110,
       64,
       'NOMMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome Motivo',
       'Nome Motivo',
       '',
       'NOMMOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVXP',
       '01',
       120,
       15,
       'NUMDOC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero Documento',
       'Nmero do Documento',
       '',
       'NUMDOC',
       'F' FROM DUAL
UNION ALL
SELECT 'VVXP',
       '01',
       130,
       6,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Nmero da Nota',
       'Nmero da Nota',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVXP',
       '99',
       140,
       255,
       'OBSERV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observacao',
       'Observacao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VVXP',
       '01',
       150,
       30,
       'ORIGEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Origem do Veculo',
       'Da onde o veiculo veio',
       '',
       'ORIGEM',
       'F' FROM DUAL
UNION ALL
SELECT 'VVXP',
       '01',
       160,
       7,
       'PLACAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Placa',
       'Placa veiculo',
       '',
       'PLACAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VVXP',
       '03',
       170,
       12,
       'QTDLIT',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade Lit.',
       'Quantidade Lit.',
       '',
       'QTDLIT',
       'F' FROM DUAL
UNION ALL
SELECT 'VVXP',
       '03',
       180,
       7,
       'QTD_KM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'KM''s na Data',
       'Quilometragem atual do veiculo',
       '',
       'QTD_KM',
       'F' FROM DUAL
UNION ALL
SELECT 'VVXP',
       '03',
       190,
       12,
       'VLRLIQ',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Lquido',
       'Valor Lquido',
       '',
       'VLRLIQ',
       'F' FROM DUAL
);

/*-- SEQ 10345 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VWEB',
       TO_NUMBER(null),
       'VWEB',
       'Web',
       'TV_WEB',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10346 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VWEB','--','' FROM DUAL
UNION ALL
SELECT 'VWEB','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VWEB','99','Outros' FROM DUAL
);

/*-- SEQ 10347 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VWEB',
       '01',
       10,
       40,
       'CLASS1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '1 Classificao',
       '',
       'CLASS1',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       20,
       40,
       'CLASS2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '2 Classificao',
       '',
       'CLASS2',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       30,
       40,
       'CLASS3',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '3 Classificao',
       '',
       'CLASS3',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       40,
       40,
       'CLASS4',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       '4 Classificao',
       '',
       'CLASS4',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       50,
       5,
       'CODCL1',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cd. Classificao 1',
       'Cd. Classificao 1',
       '',
       'CODCL1',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       60,
       5,
       'CODCL2',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cd. Classificao 2',
       'Cd. Classificao 2',
       '',
       'CODCL2',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       70,
       5,
       'CODCL3',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cd. Classificao 3',
       'Cd. Classificao 3',
       '',
       'CODCL3',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       80,
       5,
       'CODCL4',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cd. Classificao 4',
       'Cd. Classificao 4',
       '',
       'CODCL4',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       90,
       5,
       'CODDEP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Cdigo departamento',
       'cdigo do departamento',
       '',
       'CODDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       100,
       40,
       'DESDEP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Depto',
       'Descrio Departamento',
       '',
       'DESDEP',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       110,
       5,
       'DESMOE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo de moeda',
       'Tipo de Moeda',
       '',
       'DESMOE',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       120,
       83,
       'DESPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio do produto',
       'Descrio do produto',
       '',
       'DESPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       130,
       4000,
       'DETPRO',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Detalhes do produto',
       'Detalhes do produto',
       '',
       'DETPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       270,
       10,
       'ITEDIV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Item de~Diviso',
       'Item de~Diviso',
       '',
       'ITEDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       280,
       10,
       'ITESUB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Item de~Subdiviso',
       'Item de Subdiviso',
       '',
       'ITESUB',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       290,
       30,
       'MARCA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '',
       'Marca',
       '',
       'MARCA',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       140,
       15,
       'NOMCL1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '1 Nome Classificao',
       '1 Nome da Classificaco',
       '',
       'NOMCL1',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       150,
       15,
       'NOMCL2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '2 Nome Classificao',
       '2 Nome da Classificaco',
       '',
       'NOMCL2',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       160,
       15,
       'NOMCL3',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '3 Nome Classificao',
       '3 Nome da Classificaco',
       '',
       'NOMCL3',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       170,
       15,
       'NOMCL4',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '4 Nome Classificao',
       '3 Nome da Classificaco',
       '',
       'NOMCL4',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       300,
       10,
       'NOMDIV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Diviso',
       'Diviso',
       '',
       'NOMDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       180,
       255,
       'NOMIMG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome IMG. Produto',
       'Imagem relacionada ao produto',
       '',
       'NOMIMG',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       190,
       30,
       'NOMPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Nome do produto',
       'Nome do produto',
       '',
       'NOMPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       310,
       10,
       'NOMSUB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Subdiviso',
       'Subdiviso',
       '',
       'NOMSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       200,
       14,
       'PESBRU',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Peso Bruto',
       'Peso Bruto',
       '',
       'PESBRU',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       210,
       14,
       'PESLIQ',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Peso Lquido',
       'Peso Lquido',
       '',
       'PESLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       220,
       12,
       'PREPMC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Preo promocional',
       'Preo promocional',
       '',
       'PREPMC',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       230,
       12,
       'PREVEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Preo Venda',
       'Preo Venda',
       '',
       'PREVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       240,
       12,
       'QTDEST',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Quantidade Estoque',
       'Quantidade em estoque',
       '',
       'QTDEST',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       250,
       20,
       'REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Referncia',
       'Referncia do produto',
       '',
       'REFPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VWEB',
       '01',
       260,
       7,
       'VENPMC',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Vencimento promoo',
       'Vencimento da promoo',
       '',
       'VENPMC',
       'F' FROM DUAL
);

/*-- SEQ 10348 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VWM ',
       TO_NUMBER(null),
       'VWM ',
       'WorkF. x MSG',
       'TV_WOR_MSG',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VWM.CODFIL,VWM.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 10349 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VWM ','--','' FROM DUAL
UNION ALL
SELECT 'VWM ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VWM ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VWM ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VWM ','99','Outros' FROM DUAL
);

/*-- SEQ 10350 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VWM ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = VWM.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VWM ',
       '02',
       20,
       7,
       'DATMSG',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da Mensagem',
       'Data da Mensagem',
       '',
       'DATMSG',
       'F' FROM DUAL
UNION ALL
SELECT 'VWM ',
       '01',
       30,
       40,
       'DESMSG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Mensagem',
       'Descrio da Mesnagem',
       '',
       'DESMSG',
       'F' FROM DUAL
UNION ALL
SELECT 'VWM ',
       '01',
       40,
       3,
       'FILSUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Suporte',
       '',
       'FILSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'VWM ',
       '01',
       50,
       4000,
       'MSGSUP',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Mensagem Suporte',
       'Mensagem Suporte',
       '',
       'MSGSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'VWM ',
       '01',
       60,
       44,
       'PESSOA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Pessoa',
       'Pessoa',
       '',
       'PESSOA',
       'F' FROM DUAL
UNION ALL
SELECT 'VWM ',
       '01',
       70,
       10,
       'SEQSUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Suporte',
       '',
       'SEQSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'VWM ',
       '01',
       80,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
);

/*-- SEQ 10351 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VWOR',
       TO_NUMBER(null),
       'VWOR',
       'WorkFlow do Projeto',
       'TV_WOR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VWOR.CODFIL,VWOR.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 10352 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VWOR','--','' FROM DUAL
UNION ALL
SELECT 'VWOR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VWOR','02','Datas' FROM DUAL
UNION ALL
SELECT 'VWOR','03','Valores' FROM DUAL
UNION ALL
SELECT 'VWOR','99','Outros' FROM DUAL
);

/*-- SEQ 10353 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VWOR',
       '02',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '99',
       20,
       1,
       'AVISAR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Avisar?',
       'Avisar?',
       '',
       'AVISAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '03',
       30,
       5,
       'CLATAR',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Classf. da tarefa',
       'Classificao da Tarefa',
       '',
       'CLATAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '03',
       40,
       7,
       'COBRAR',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horas cobradas',
       'Horas Cobradas',
       '',
       'COBRAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       50,
       6,
       'CODACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Aceito',
       'Cdigo Aceito',
       '',
       'CODACT',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       60,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       70,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL = VWOR.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       80,
       1,
       'CODFPA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Complexidade',
       'Complexidade',
       '',
       'CODFPA',
       'T' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       720,
       5,
       'CODFUN',
       'S',
       'DFUN',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFUN.DESFUN',
       'V',
       '',
       '',
       'A',
       'F',
       'Funcionalidade',
       'Funcionalidade',
       'DFUN.CODTAB = VWOR.CODFUN',
       'CODFUN',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       90,
       3,
       'CODREG',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Registrado por',
       'Cdigo Registro',
       'USU.FILUSU(+) = VWOR.FILREG AND USU.CODUSU(+) = VWOR.CODREG',
       'CODREG',
       'T' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       100,
       3,
       'CODRES',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Responsvel',
       'Cdigo Responsvel',
       'USU.FILUSU(+) = VWOR.FILRES AND USU.CODUSU(+) = VWOR.CODRES',
       'CODRES',
       'T' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       110,
       6,
       'CODREV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Revisor',
       'Cdigo Revisor',
       '',
       'CODREV',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       120,
       6,
       'CODSOL',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Solicitante',
       'Cdigo Solicitante',
       'USU.FILUSU = VWOR.FILSOL(+) AND USU.CODUSU = VWOR.CODSOL(+)',
       'CODSOL',
       'T' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       130,
       3,
       'CODTST',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Revisor',
       'Cdigo Teste(Revisor)',
       'USU.FILUSU(+) = VWOR.FILTST AND USU.CODUSU(+) = VWOR.CODTST',
       'CODTST',
       'T' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       140,
       254,
       'COMJUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Comple Justificativa',
       'Complemento de Justificativa',
       '',
       'COMJUS',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '03',
       150,
       3,
       'CONCLU',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       '% de Concluso',
       '% de Concluso',
       '',
       'CONCLU',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '02',
       160,
       7,
       'DATACT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da confirmao',
       'Data Confirmao',
       '',
       'DATACT',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '99',
       170,
       1,
       'DATFIX',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Data Fixa?',
       'Data Fixa?',
       '',
       'DATFIX',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '02',
       180,
       7,
       'DATPRO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Prometida',
       'Data Prometida',
       '',
       'DATPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '02',
       190,
       7,
       'DATREG',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Registro',
       'Data Registro',
       '',
       'DATREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '02',
       200,
       7,
       'DATSOL',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data solicitao',
       'Data Solicitao',
       '',
       'DATSOL',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       210,
       255,
       'DESTAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo Tarefa',
       'Ttulo da Tarefa',
       '',
       'DESTAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       220,
       4000,
       'DOCUME',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       230,
       1,
       'FATURA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Cobrana',
       'Fatura',
       '',
       'FATURA',
       'T' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       240,
       3,
       'FILACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Contato',
       'Filial do usurio que confirmou a realizao da tarefa',
       '',
       'FILACT',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       250,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       260,
       3,
       'FILPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Projeto',
       '',
       'FILPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       270,
       3,
       'FILREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Registro',
       'Filial Registro',
       '',
       'FILREG',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       280,
       3,
       'FILRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Responsvel',
       '',
       'FILRES',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       290,
       3,
       'FILREV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Revisor',
       '',
       'FILREV',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       300,
       3,
       'FILSOL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Solicitao',
       '',
       'FILSOL',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       310,
       3,
       'FILTST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Revisor',
       '',
       'FILTST',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '02',
       320,
       7,
       'FIMPLR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fim Plan. Rev.',
       'Data de Fim Planejada para a Reviso',
       '',
       'FIMPLR',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '02',
       330,
       7,
       'FIMPLT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fim Plan.Tarefa',
       'Data de Fim Planejada para Tarefa',
       '',
       'FIMPLT',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '02',
       340,
       7,
       'FIMPRR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fim Proj. Rev.',
       'Data de Fim Projetada para a Reviso',
       '',
       'FIMPRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '02',
       350,
       7,
       'FIMPRT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fim Proj.Tarefa',
       'Data de Fim Projetada para a Tarefa',
       '',
       'FIMPRT',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '02',
       360,
       7,
       'FIMTAR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data fim tarefa',
       'Data Fim Tarefa',
       '',
       'FIMTAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '02',
       370,
       7,
       'FIMTST',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data fim teste',
       'Data Fim Teste',
       '',
       'FIMTST',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '99',
       380,
       1,
       'FLGACT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag Aceita?',
       'Flag Aceita?',
       '',
       'FLGACT',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       390,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       400,
       4,
       'HORERR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horas de Erro',
       'Horas de Erro',
       '',
       'HORERR',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '02',
       410,
       7,
       'INIPLR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ini.Plan. Rev.',
       'Data de Incio Planejada para a Reviso',
       '',
       'INIPLR',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '02',
       420,
       7,
       'INIPLT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ini.Plan.Tarefa',
       'Data de Incio Planejada para a Tarefa',
       '',
       'INIPLT',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '02',
       430,
       7,
       'INIPRR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ini. Proj. Rev.',
       'Data de Incio Projetada para a Reviso',
       '',
       'INIPRR',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '02',
       440,
       7,
       'INIPRT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ini.Proj.Tarefa',
       'Data de Incio Projetada para a Tarefa',
       '',
       'INIPRT',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '02',
       450,
       7,
       'INITAR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data incio tarefa',
       'Data Incio da Tarefa',
       '',
       'INITAR',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '02',
       460,
       7,
       'INITST',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data inicio Teste',
       'Data Incio Teste',
       '',
       'INITST',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       470,
       5,
       'JUSATR',
       'S',
       'DJUS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DJUS.DESJUS',
       'V',
       '',
       '',
       'N',
       'F',
       'Justificativa Atraso',
       'Justificativa de Atraso',
       'DJUS.CODTAB = VWOR.JUSATR',
       'JUSATR',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       480,
       12,
       'MARERR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Margem de Erro',
       'Margem de Erro',
       '',
       'MARERR',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '02',
       800,
       7,
       'MAXPRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Previso Mxima',
       'Previso Mxima',
       '',
       'MAXPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '02',
       810,
       7,
       'MINPRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Previso Mnima',
       'Previso Mnima',
       '',
       'MINPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       490,
       5,
       'MODULO',
       'N',
       'DMOD',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOD.MODULO',
       'V',
       '',
       'F',
       'N',
       'F',
       'Mdulo',
       'Mdulo',
       'DMOD.CODTAB = WOR.MODULO',
       'MODULO',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '03',
       500,
       4,
       'NUMACT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Numero do aceito',
       'Nmero do Aceito',
       '',
       'NUMACT',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       510,
       4,
       'NUMREV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero de Revises',
       'Nmero de Revises',
       '',
       'NUMREV',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '03',
       520,
       4,
       'NUMSOL',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'N solcicitante',
       'N Solicitante',
       '',
       'NUMSOL',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       750,
       12,
       'PERMIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Permisses',
       'Permisses',
       '',
       'PERMISSOESUSUARIO(FILUSU,CODUSU)',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       530,
       1,
       'PRICLI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Prioridade Cliente',
       'Prioridade do Cliente',
       '',
       'PRICLI',
       'T' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       540,
       1,
       'PRIORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Prioridade',
       'Prioridade',
       '',
       'PRIORI',
       'T' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       550,
       3,
       'QTDERR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Quantidade de Erros',
       'Quantidade de Erros',
       '',
       'QTDERR',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       560,
       1,
       'RESERV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Reservado?',
       'Reservado?',
       '',
       'RESERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       570,
       4000,
       'REVISA',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Reviso',
       'Descrio da Reviso',
       '',
       'RTF2TXT(REVISA)',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       580,
       10,
       'SEQPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador do Projeto',
       '',
       'SEQPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       590,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       600,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN VWOR.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       601,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN VWOR.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       730,
       1,
       'SPLITW',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Dividida em Etapas?',
       'Tarefa pode ser dividida em Etapas?',
       '',
       'SPLITW',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       610,
       4000,
       'TAREFA',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Tarefa',
       'Descrio da Tarefa',
       '',
       'RTF2TXT(TAREFA)',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       620,
       6,
       'TARFAL',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'H.Faltantes p/Tarefa',
       'Horas Faltantes para Tarefa',
       '',
       'TARFAL',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '03',
       630,
       7,
       'TARPRE',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'H. previstas Tarefa',
       'Horas pevistas para realizao da tarefa',
       '',
       'TARPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '03',
       640,
       7,
       'TARREA',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Horas realizadas',
       'Horas realizadas na tarefa',
       '',
       'TARREA',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       650,
       1,
       'TIPACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo confirmao',
       'Tipo Confirmao',
       '',
       'TIPACT',
       'T' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       660,
       1,
       'TIPCWS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo C. WorkF/Supor.',
       'Tipo C. WorFlow/suporte',
       '',
       'TIPCWS',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       670,
       1,
       'TIPMAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Mo de Obra',
       'Mo de Obra',
       '',
       'TIPMAO',
       'T' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       680,
       5,
       'TIPTAR',
       'G',
       'DCWS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       'DCWS.DESCWS',
       'V',
       '',
       'F',
       'A',
       'F',
       'Tipo Tarefa',
       'TIPOS DE TAREFA',
       'VWOR.TIPTAR = DCWS.CODTAB AND VWOR.TIPCWS = DCWS.TIPCWS',
       'TIPTAR',
       'T' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '03',
       690,
       7,
       'TSTPRE',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'H. previstas teste',
       'Horas Previstas teste',
       '',
       'TSTPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '03',
       700,
       7,
       'TSTREA',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'H. realizadas testes',
       'Horas Realizadas Testes',
       '',
       'TSTREA',
       'F' FROM DUAL
UNION ALL
SELECT 'VWOR',
       '01',
       710,
       4,
       'VERSAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Verso do Sistema',
       'Verso',
       '',
       'VERSAO',
       'F' FROM DUAL
);

/*-- SEQ 10354 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'VWOR',
       'CODFPA',
       0,
       ' ',
       'Indefinido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'CODFPA',
       0,
       '1',
       'Simples',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'CODFPA',
       0,
       '2',
       'Mdio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'CODFPA',
       0,
       '3',
       'Complexo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'FATURA',
       0,
       'A',
       'A Faturar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'FATURA',
       0,
       'C',
       'Contrato',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'FATURA',
       0,
       'D',
       'A Definir',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'FATURA',
       0,
       'F',
       'Faturado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'FATURA',
       0,
       'R',
       'Revenda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'FATURA',
       0,
       'S',
       'Cortesia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'FLGEST',
       0,
       'A',
       'Em Aberto',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'FLGEST',
       0,
       'C',
       'Cancelado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'FLGEST',
       0,
       'E',
       'Entregue',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'FLGEST',
       0,
       'I',
       'Inconsistente',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'FLGEST',
       0,
       'S',
       'Substitudo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'FLGEST',
       0,
       'X',
       'Estornado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'PRICLI',
       2,
       ' ',
       'Mdia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'PRICLI',
       3,
       ' ',
       'Baixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'PRICLI',
       0,
       ' ',
       'Imediato',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'PRICLI',
       1,
       ' ',
       'Alta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'PRIORI',
       0,
       ' ',
       'Imediato',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'PRIORI',
       1,
       ' ',
       'Alta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'PRIORI',
       2,
       ' ',
       'Mdia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'PRIORI',
       3,
       ' ',
       'Baixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'TIPACT',
       0,
       'C',
       'Carta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'TIPACT',
       0,
       'E',
       'E-Mail',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'TIPACT',
       0,
       'F',
       'Fax',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'TIPACT',
       0,
       'M',
       'Mensagem Instantneas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'TIPACT',
       0,
       'S',
       'Site',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'TIPACT',
       0,
       'T',
       'Telefnico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'TIPACT',
       0,
       'V',
       'Verbal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'TIPMAO',
       0,
       'H',
       'Horas Extras',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'TIPMAO',
       0,
       'I',
       'Interna',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'VWOR',
       'TIPMAO',
       0,
       'T',
       'Terceirizada',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10355 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VXO ',
       TO_NUMBER(null),
       'VXO ',
       'Vendas Obs. Fiscais ',
       'TT_VENXOBS',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'VXO.FILVEN
VXO.SEQVEN
VXO.CODOBS',
       '' FROM DUAL
);

/*-- SEQ 10356 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VXO ','--','' FROM DUAL
UNION ALL
SELECT 'VXO ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VXO ','99','Outros' FROM DUAL
);

/*-- SEQ 10357 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20242,
       'OBS ',
       'VXO ',
       '1',
       '0N',
       '',
       '',
       'OBS.CODOBS = VXO.CODOBS
',
       '',
       '' FROM DUAL
UNION ALL
SELECT 20243,
       'VEN ',
       'VXO ',
       '1',
       '0N',
       '',
       '',
       'VEN.CODFIL = VXO.FILVEN AND
VEN.SEQUEN = VXO.SEQVEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 10358 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VXO ',
       '--',
       10,
       5,
       'CODOBS',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo da Observao',
       'Cdigo da Observao',
       '',
       'CODOBS',
       'F' FROM DUAL
UNION ALL
SELECT 'VXO ',
       '--',
       20,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Filial da Venda',
       'Filial da Venda',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VXO ',
       '--',
       30,
       10,
       'SEQVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Sequncia da Venda',
       'Sequncia da Venda',
       '',
       'SEQVEN',
       'F' FROM DUAL
);

/*-- SEQ 10359 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'VXP ',
       TO_NUMBER(null),
       'VXP ',
       'Trfego Veiculos',
       'TT_VXP',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'vxp.codfil,vxp.sequen',
       '' FROM DUAL
);

/*-- SEQ 10360 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'VXP ','--','' FROM DUAL
UNION ALL
SELECT 'VXP ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'VXP ','02','Datas' FROM DUAL
UNION ALL
SELECT 'VXP ','03','Valores' FROM DUAL
UNION ALL
SELECT 'VXP ','99','Outros' FROM DUAL
);

/*-- SEQ 10361 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR)
(
SELECT 5957,
       'REL ',
       'VXP ',
       '01',
       'N ',
       '',
       '',
       'REL.FILPAR(+) = VXP.FILMOT AND
REL.CODPAR(+) = VXP.CODMOT AND
REL.TIPPAR(+) = VXP.TIPMOT AND
REL.FILPAR(+) = VXP.FILTRA AND
REL.CODPAR(+) = VXP.CODTRA AND
REL.TIPPAR(+) = VXP.TIPTRA',
       '' FROM DUAL
UNION ALL
SELECT 5958,
       'VEN ',
       'VXP ',
       '1',
       '1',
       '',
       '',
       'VEN.CODFIL = VXP.CODFIL AND
VEN.SEQUEN = VXP.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 10362 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'VXP ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'A',
       'F',
       'Filial',
       'Codigo da filial',
       'VXD.CODFIL = DFIL.CODFIL (+)',
       'CODFIL',
       'T' FROM DUAL
UNION ALL
SELECT 'VXP ',
       '01',
       20,
       6,
       'CODMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo do Morista',
       'Codigo do Motorista',
       '',
       'CODMOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VXP ',
       '01',
       30,
       6,
       'CODTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Transportador',
       'Codigo da Transportadora',
       '',
       'CODTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'VXP ',
       '02',
       40,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data/Hora',
       'Data/Hora',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'VXP ',
       '01',
       50,
       30,
       'DESTIN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Destino',
       'Para onde o veiculo vai',
       '',
       'DESTIN',
       'F' FROM DUAL
UNION ALL
SELECT 'VXP ',
       '01',
       60,
       3,
       'FILMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Motorista',
       '',
       'FILMOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VXP ',
       '01',
       70,
       3,
       'FILTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial da Transportadora',
       '',
       'FILTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'VXP ',
       '99',
       80,
       255,
       'OBSERV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Observacao',
       'Observacao',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'VXP ',
       '01',
       90,
       30,
       'ORIGEM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Origem do Veculo',
       'Da onde o veiculo veio',
       '',
       'ORIGEM',
       'F' FROM DUAL
UNION ALL
SELECT 'VXP ',
       '01',
       100,
       7,
       'PLACAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Placa',
       'Placa veiculo',
       '',
       'PLACAS',
       'F' FROM DUAL
UNION ALL
SELECT 'VXP ',
       '01',
       110,
       7,
       'QTD_KM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'KM''s na Data',
       'Quilometragem atual do veiculo',
       '',
       'QTD_KM',
       'F' FROM DUAL
UNION ALL
SELECT 'VXP ',
       '99',
       120,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'VXP ',
       '01',
       130,
       1,
       'TIPMOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo Motorista',
       'Indica se parceiro  motorista de uma transportadora',
       '',
       'TIPMOT',
       'F' FROM DUAL
UNION ALL
SELECT 'VXP ',
       '01',
       140,
       1,
       'TIPTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Tipo Transportadora',
       'Indica se o parceiro  transportadora',
       '',
       'TIPTRA',
       'F' FROM DUAL
);

/*-- SEQ 10363 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'WARQ',
       TO_NUMBER(null),
       'WARQ',
       'Arquivos(Temp.)',
       'TW_ARQ',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10364 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'WARQ','--','' FROM DUAL
UNION ALL
SELECT 'WARQ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'WARQ','99','Outros' FROM DUAL
);

/*-- SEQ 10365 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'WARQ',
       '--',
       10,
       254,
       'APELID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'APELID',
       'F' FROM DUAL
UNION ALL
SELECT 'WARQ',
       '--',
       20,
       4,
       'CODFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'WARQ',
       '--',
       30,
       4,
       'CODTAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Cdigo da Tabela',
       'Cdigo da Tabela',
       '',
       'CODTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'WARQ',
       '--',
       40,
       72,
       'DESCRI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESCRI',
       'F' FROM DUAL
UNION ALL
SELECT 'WARQ',
       '--',
       50,
       254,
       'FILBAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILBAS',
       'F' FROM DUAL
UNION ALL
SELECT 'WARQ',
       '--',
       60,
       1,
       'FORMUL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FORMUL',
       'F' FROM DUAL
UNION ALL
SELECT 'WARQ',
       '--',
       70,
       1,
       'GERAL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'GERAL',
       'F' FROM DUAL
UNION ALL
SELECT 'WARQ',
       '--',
       80,
       254,
       'ID_UNI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ID_UNI',
       'F' FROM DUAL
UNION ALL
SELECT 'WARQ',
       '--',
       90,
       20,
       'NOMTAB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NOMTAB',
       'F' FROM DUAL
UNION ALL
SELECT 'WARQ',
       '--',
       100,
       4000,
       'OBSERV',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'OBSERV',
       'F' FROM DUAL
UNION ALL
SELECT 'WARQ',
       '--',
       110,
       20,
       'PALETA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PALETA',
       'F' FROM DUAL
UNION ALL
SELECT 'WARQ',
       '--',
       120,
       4000,
       'PARAME',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PARAME',
       'F' FROM DUAL
UNION ALL
SELECT 'WARQ',
       '--',
       130,
       254,
       'PATH',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PATH',
       'F' FROM DUAL
UNION ALL
SELECT 'WARQ',
       '--',
       140,
       1,
       'PERSON',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PERSON',
       'F' FROM DUAL
UNION ALL
SELECT 'WARQ',
       '--',
       150,
       80,
       'PRIMAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRIMAR',
       'F' FROM DUAL
UNION ALL
SELECT 'WARQ',
       '--',
       160,
       20,
       'SECUN1',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SECUN1',
       'F' FROM DUAL
UNION ALL
SELECT 'WARQ',
       '--',
       170,
       20,
       'SECUN2',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SECUN2',
       'F' FROM DUAL
UNION ALL
SELECT 'WARQ',
       '--',
       180,
       4000,
       'SUBSQL',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SUBSQL',
       'F' FROM DUAL
UNION ALL
SELECT 'WARQ',
       '--',
       190,
       12,
       'UNICO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'UNICO',
       'F' FROM DUAL
);

/*-- SEQ 10366 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'WCHR',
       TO_NUMBER(null),
       'WCHR',
       'Cheques a Receber',
       'TW_CHR',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10367 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'WCHR','--','' FROM DUAL
);

/*-- SEQ 10368 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'WCHR',
       '--',
       2,
       5,
       'CODAGE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODAGE',
       'F' FROM DUAL
UNION ALL
SELECT 'WCHR',
       '--',
       1,
       3,
       'CODBCO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODBCO',
       'F' FROM DUAL
UNION ALL
SELECT 'WCHR',
       '--',
       10,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'WCHR',
       '--',
       9,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'WCHR',
       '--',
       6,
       7,
       'DATVEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'WCHR',
       '--',
       8,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'WCHR',
       '--',
       5,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'WCHR',
       '--',
       4,
       6,
       'NUMCHE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NUMCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'WCHR',
       '--',
       3,
       10,
       'NUMCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'WCHR',
       '--',
       12,
       5,
       'PORTAD',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PORTAD',
       'F' FROM DUAL
UNION ALL
SELECT 'WCHR',
       '--',
       11,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'WCHR',
       '--',
       7,
       12,
       'VLRCHE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       '',
       '',
       '',
       'VLRCHE',
       'F' FROM DUAL
);

/*-- SEQ 10369 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'WDIV',
       TO_NUMBER(null),
       'WDIV',
       'Diviso(Temp.)',
       'TW_DIV',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10370 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'WDIV','--','' FROM DUAL
);

/*-- SEQ 10371 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'WDIV',
       '--',
       2,
       5,
       'CODDIV',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'WDIV',
       '--',
       1,
       5,
       'CODITE',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODITE',
       'F' FROM DUAL
UNION ALL
SELECT 'WDIV',
       '--',
       3,
       10,
       'NOMITE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NOMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'WDIV',
       '--',
       4,
       5,
       'ORDDIV',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ORDDIV',
       'F' FROM DUAL
);

/*-- SEQ 10372 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'WECT',
       TO_NUMBER(null),
       'WECT',
       'Estrutura de Contas',
       'TW_ECT',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10373 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'WECT','--','' FROM DUAL
);

/*-- SEQ 10374 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'WECT',
       '--',
       3,
       14,
       'CHVPAI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CHVPAI',
       'F' FROM DUAL
UNION ALL
SELECT 'WECT',
       '--',
       2,
       14,
       'CHV_ID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CHV_ID',
       'F' FROM DUAL
UNION ALL
SELECT 'WECT',
       '--',
       4,
       3,
       'FILCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'WECT',
       '--',
       5,
       10,
       'SEQCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'WECT',
       '--',
       6,
       1,
       'TIPCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'WECT',
       '--',
       7,
       250,
       'TITCTA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TITCTA',
       'F' FROM DUAL
UNION ALL
SELECT 'WECT',
       '--',
       1,
       12,
       'USERID',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'USERID',
       'F' FROM DUAL
);

/*-- SEQ 10375 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'WFPV',
       TO_NUMBER(null),
       'WFPV',
       'Formao FPV',
       'TW_FPV',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10376 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'WFPV','--','' FROM DUAL
UNION ALL
SELECT 'WFPV','01','Identificao' FROM DUAL
UNION ALL
SELECT 'WFPV','99','Outros' FROM DUAL
);

/*-- SEQ 10377 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'WFPV',
       '--',
       10,
       1,
       'ACASUG',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Acatar~Sugesto?',
       'Acatar~Sugesto?',
       '',
       'ACASUG',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       1100,
       12,
       'ACRFIN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Acrscimo Financeiro',
       'Acrscimo Financeiro',
       '',
       'ACRFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       1110,
       5,
       'AFICUS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% Acrsc. Financeiro',
       '% de Acrscimo Financeiro',
       '',
       'AFICUS',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       1120,
       5,
       'ALIFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% Aliq. Frete',
       '% da Alquota de Frete',
       '',
       'ALIFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       20,
       1,
       'ALTERADO',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Alterado?',
       'Alterado?',
       '',
       'ALTERADO',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       30,
       8,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'Data~Atualizao',
       'Atualizado em ...',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       40,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Diviso',
       'Cdigo da diviso',
       'WFPV.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       50,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       'Filial Compra',
       'Filial da compra',
       'DFIL.CODFIL = WFPV.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       60,
       6,
       'CODFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cdigo do Fornecedor',
       'Cdigo do fornecedor',
       '',
       'CODFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       70,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo do produto',
       'Cdigo do produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       80,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Srie',
       'Nmero da srie da compra',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       90,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'A',
       'F',
       'Sub-Diviso',
       'Cdigo da sub-diviso',
       'WFPV.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       100,
       6,
       'COMCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% COFINS para Compra',
       'Aliquota de COFINS para compra',
       '',
       'COMCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       110,
       6,
       'COMPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% PIS para Compra',
       'Alquota de PIS para compra',
       '',
       'COMPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       120,
       8,
       'CUSAQS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Custo Aquis.',
       'Custo unitrio da aquisio',
       '',
       'CUSAQS',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       130,
       8,
       'CUSFIN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Custo final s/ lucro',
       'Custo final sem o lucro aplicado',
       '',
       'CUSFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       140,
       12,
       'CUSREP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Custo Reposio',
       'Custo Reposio',
       '',
       'CUSREP',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       150,
       8,
       'DATCMP',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data da Compra',
       'Data da Compra',
       '',
       'DATCMP',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       160,
       8,
       'DATOPE',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'D',
       'F',
       'Data da Operao',
       'Data da Operao',
       '',
       'DATOPE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       170,
       8,
       'DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Desconto',
       'Desconto da compra',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       180,
       8,
       'DESITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Des/Acr do Item',
       'Desconto/Acrscimo unitrio',
       '',
       'DESITE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       190,
       30,
       'DESMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Descrio Produto',
       'Descrio Produto',
       '',
       'DESMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       200,
       8,
       'DIFPRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Dif. Preo Venda',
       'Diferencial Preo de Venda',
       '',
       'DIFPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       210,
       19,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Documento',
       'Documento (Srie + Sub-Srie + Nmero)',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       220,
       12,
       'EDPERLUC',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Ed. % de Lucro',
       'Ed. % de Lucro',
       '',
       'EDPERLUC',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       230,
       12,
       'EDPRECAL',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Ed. % Calculado',
       '',
       '',
       'EDPRECAL',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       240,
       30,
       'ESPMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Especificao',
       'Especificao do material',
       '',
       'ESPMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       250,
       3,
       'FILFOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Cd. Filial~Fornec.',
       'Cdigo da filial origem do fornecedor',
       '',
       'FILFOR',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       260,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       'Filial~Produto',
       'Cdigo da filial origem do produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       270,
       8,
       'FREITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr Unitario Frete',
       'Valor unitrio proporcional do frete',
       '',
       'FREITE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       280,
       8,
       'ICMCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'ICMS da compra',
       'Total de ICMS da compra',
       '',
       'ICMCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       1130,
       12,
       'ICMFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor ICM do Frete',
       'Valor do ICM do Frete',
       '',
       'ICMFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       290,
       8,
       'ICMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% de ICMS',
       'ICMS por Item',
       '',
       'ICMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       1140,
       12,
       'ICMSRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Valor ICMS do Frete',
       'Valor do ICMS do Frete',
       '',
       'ICMSRE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       300,
       8,
       'IPICOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'IPI da compra',
       'Total de IPI da compra',
       '',
       'IPICOM',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       310,
       8,
       'IPIITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% de IPI',
       'IPI do Item',
       '',
       'IPIITE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       320,
       10,
       'ITEDIV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Diviso',
       'Diviso',
       '',
       'ITEDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       330,
       10,
       'ITESUB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Sub-Diviso',
       'Sub-Diviso',
       '',
       'ITESUB',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       340,
       8,
       'LUCATU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% Lucro Atual',
       'Lucro Atual',
       '',
       'LUCATU',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       350,
       12,
       'MARKUP',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Markup',
       'Markup',
       '',
       'MARKUP',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       360,
       12,
       'MARKUPCAL',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Markup Calculado',
       'Markup Calculado',
       '',
       'MARKUPCAL',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       370,
       44,
       'NOMCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Nome/Razo Social',
       'Nome do Cliente',
       '',
       'NOMCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       380,
       8,
       'NUMITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nro Item',
       'Nro Item',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       390,
       8,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Nro Nota',
       'Nro da nota da compra',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       400,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Observao',
       'Observao',
       '',
       'RTF2TXT(WFPV.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       410,
       8,
       'ORDDIV',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Ordem Diviso',
       'Ordem Diviso - Controle interno',
       '',
       'ORDDIV',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       420,
       8,
       'ORDSUB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Ordem Sub-Diviso',
       'Ordem Sub-Diviso Controle interno',
       '',
       'ORDSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       430,
       8,
       'OUTTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Outras Taxas',
       'Outras taxas da compra',
       '',
       'OUTTAX',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       440,
       8,
       'PARAQS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Aquisio',
       'Participao da Aquisio em Relao ao Custo Final',
       '',
       'PARAQS',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       450,
       8,
       'PARCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Comisso',
       'Participao da comisso em relao ao custo final',
       '',
       'PARCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       460,
       8,
       'PARCTS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Contribuiao Social',
       'Participao da contribuio social em relao ao custo final',
       '',
       'PARCTS',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       470,
       8,
       'PARDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Des/Acr',
       'Des/Acr em relao ao custo final',
       '',
       'PARDES',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       480,
       8,
       'PARFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Frete',
       'Participao do frete em relao ao custo final',
       '',
       'PARFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       490,
       8,
       'PARICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'ICMS',
       'Participao do ICMS em relao ao custo final',
       '',
       'PARICM',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       500,
       8,
       'PARIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'IPI',
       'Participao do IPI em relao ao custo final',
       '',
       'PARIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       510,
       12,
       'PARIRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Part. Imposto Renda',
       'Part. Imposto de Renda',
       '',
       'PARIRE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       520,
       8,
       'PARIVE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'ICMS Venda',
       'Participao do ICMS de venda em relao ao custo final',
       '',
       'PARIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       530,
       8,
       'PAROPE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Desp. Operacional',
       'Participao da despesa operacional em relao ao custo final',
       '',
       'PAROPE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       540,
       8,
       'PARSEG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Seguro',
       'Participao do seguro em relao ao custo final',
       '',
       'PARSEG',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       550,
       8,
       'PARSUB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Subst. Tributria',
       'Participao da substituio tributria em relao ao custo final',
       '',
       'PARSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       560,
       8,
       'PARTAX',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Outras taxas',
       'Participao de outras taxas em relao ao custo final',
       '',
       'PARTAX',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       570,
       8,
       'PARVLR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr Unitrio',
       'Valor unitrio em relao ao custo final',
       '',
       'PARVLR',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       580,
       12,
       'PAR_COMCOF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% COFINS Compra',
       '% COFINS Compra',
       '',
       'PAR_COMCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       590,
       12,
       'PAR_COMPIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '%.PIS Compra',
       '% PIS Compra',
       '',
       'PAR_COMPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       600,
       12,
       'PAR_PISCOF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% PIS/COFINS',
       '% PIS/COFINS',
       '',
       'PAR_PISCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       610,
       12,
       'PAR_VENCOF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% COFINS Venda',
       '% COFINS Venda',
       '',
       'PAR_VENCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       620,
       12,
       'PAR_VENPIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% PIS Venda',
       '% PIS Venda',
       '',
       'PAR_VENPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       630,
       8,
       'PERCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% de Comisso',
       '% de Comisso',
       '',
       'PERCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       640,
       8,
       'PERDIF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% diferena',
       'Percentual da diferena entre o preo atual e calculado',
       '',
       'PERDIF',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       650,
       12,
       'PERENC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Encargos',
       'Percentual de Encargos',
       '',
       'PERENC',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       660,
       12,
       'PERIRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% Imposto de Renda',
       'Percentual Imposto de Renda',
       '',
       'PERIRE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       670,
       8,
       'PERIVE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% de ICMS Venda',
       '% de ICMS Venda',
       '',
       'PERIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       680,
       8,
       'PERLUC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% de Lucro',
       'Percentual de lucro cadastrado no produto',
       '',
       'PERLUC',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       690,
       8,
       'PEROPE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% Desp. Operacional',
       'Percentual de despesas operacionais',
       '',
       'PEROPE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       700,
       8,
       'PERSOC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       '% Contr. Social',
       '% Contr. Social',
       '',
       'PERSOC',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       710,
       8,
       'PERTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Percentual Total',
       'Percentual Total',
       '',
       'PERTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       1150,
       12,
       'PICFRE',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '% do ICM do Frete',
       '% do ICM do Frete',
       '',
       'PICFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       720,
       12,
       'PISCOFINS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'PIS/COFINS',
       'PIS/COFINS',
       '',
       'PISCOFINS',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       730,
       8,
       'PREATU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Preo Venda atual',
       'Preo de Venda Atual',
       '',
       'PREATU',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       740,
       8,
       'PRECAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Pr.Venda Final',
       'Preo de venda calculado',
       '',
       'PRECAL',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       750,
       1,
       'PREPSI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Preo Psicolgico?',
       'Preo Psicolgico',
       '',
       'PREPSI',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       760,
       12,
       'PRESUG',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Sugesto~Preo',
       'Sugesto~Preo',
       '',
       'PRESUG',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       770,
       8,
       'QTDMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Quantidade Item',
       'Quantidade Item',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       780,
       20,
       'REFPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Referncia',
       'Referncia do produto',
       '',
       'REFPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       1160,
       12,
       'RESICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Alquota do ICMS',
       'Alquota do ICMS',
       '',
       'RESICM',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       790,
       12,
       'ROW_NUM',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Nmero~de Linhas',
       'Nmero de Linhas',
       '',
       'ROW_NUM',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       800,
       8,
       'SEGITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Vlr Unitario Seguro',
       'Valor unitrio proporcional do seguro ',
       '',
       'SEGITE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       810,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       1170,
       1,
       'SUBFED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       'F',
       'Substitudo Federal',
       'Substitudo Federal',
       '',
       'SUBFED',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       820,
       8,
       'SUBITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Subt. Tribut. Item',
       'Valor da substituio tributria do item',
       '',
       'SUBITE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       830,
       3,
       'SUBSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'A',
       'F',
       'Sub-Srie',
       'Nmero da sub-srie da compra',
       '',
       'SUBSER',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       840,
       8,
       'TAXITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Outras taxas do Item',
       'Outras taxas unitrias',
       '',
       'TAXITE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       850,
       20,
       'ULTNOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Sobrenome/Fantasia',
       'Sobrenome ou fantasia',
       '',
       'ULTNOM',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       860,
       6,
       'VENCOF',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% COFINS para Venda',
       'Aliquota de COFINS para venda',
       '',
       'VENCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       870,
       6,
       'VENPIS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% PIS para Venda',
       'Alquota de PIS para venda',
       '',
       'VENPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       880,
       8,
       'VLRCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Comisso do Item',
       'Valor unitrio da comisso em relao ao preo de vendas',
       '',
       'VLRCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       890,
       8,
       'VLRENC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Preo custo c/ encar',
       'Preo de custo mais encargos financeiros embutidos',
       '',
       'VLRENC',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       900,
       8,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor frete',
       'Valor total do frete',
       '',
       'VLRFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       910,
       8,
       'VLRICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'ICMS do Item',
       'Valor do ICMS do item da compra',
       '',
       'VLRICM',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       920,
       8,
       'VLRIPI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'IPI do Item',
       'Valor do IPI do item da compra',
       '',
       'VLRIPI',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       930,
       12,
       'VLRIRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Imposto Renda',
       'Valor Imposto de Renda',
       '',
       'VLRIRE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       940,
       8,
       'VLRIVE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'ICMS do Item',
       'Valor unitrio do ICMS em relao ao preo de venda',
       '',
       'VLRIVE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       950,
       8,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Lquido',
       'Valor Lquido da compra',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       960,
       8,
       'VLRLUC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Lucro do Item',
       'Valor unitrio do lucro em relao ao preos de vendas',
       '',
       'VLRLUC',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       970,
       8,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Item',
       'Valor Item',
       '',
       'VLRMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       980,
       12,
       'VLRMRK',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Markup',
       'Valor Markup',
       '',
       'VLRMRK',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       990,
       8,
       'VLROPE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Desp. Operc. Item',
       'Valor unitrio da despesa operacional relativo ao preo de venda',
       '',
       'VLROPE',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       1000,
       8,
       'VLRSEG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor seguro',
       'Valor do seguro do frete',
       '',
       'VLRSEG',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       1010,
       8,
       'VLRSOC',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Contr. do Item',
       'Valor unitrio de contribuio em relao ao preo de venda',
       '',
       'VLRSOC',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       1020,
       8,
       'VLRSUB',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Subt. Tribut. Compra',
       'Valor total da substituio tributria da compra',
       '',
       'VLRSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       1030,
       8,
       'VLRTOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Total',
       'Valor total da compra',
       '',
       'VLRTOT',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       1040,
       8,
       'VLRUNI',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '9',
       'F',
       'Valor Unit.',
       'Valor Unitrio',
       '',
       'VLRUNI',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       1050,
       12,
       'VLR_COMCOF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr. COFINS Compra',
       'Vlr. COFINS Compra',
       '',
       'VLR_COMCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       1060,
       12,
       'VLR_COMPIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr. PIS Compra',
       'Vlr. PIS Compra',
       '',
       'VLR_COMPIS',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       1070,
       12,
       'VLR_PISCOF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr. PIS/COFINS',
       'Vlr. PIS/COFINS',
       '',
       'VLR_PISCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       1080,
       12,
       'VLR_VENCOF',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr. COFINS Venda',
       'Vlr. COFINS Venda',
       '',
       'VLR_VENCOF',
       'F' FROM DUAL
UNION ALL
SELECT 'WFPV',
       '--',
       1090,
       12,
       'VLR_VENPIS',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Vlr. PIS Venda',
       'Vlr. PIS Venda',
       '',
       'VLR_VENPIS',
       'F' FROM DUAL
);

/*-- SEQ 10378 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'WICM',
       TO_NUMBER(null),
       'WICM',
       'ICM/Cidade',
       'TW_ICM',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10379 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'WICM','--','' FROM DUAL
);

/*-- SEQ 10380 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'WICM',
       '--',
       1,
       5,
       'CODCID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODCID',
       'F' FROM DUAL
UNION ALL
SELECT 'WICM',
       '--',
       3,
       30,
       'NOMCID',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NOMCID',
       'F' FROM DUAL
UNION ALL
SELECT 'WICM',
       '--',
       2,
       12,
       'PERICM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PERICM',
       'F' FROM DUAL
UNION ALL
SELECT 'WICM',
       '--',
       4,
       2,
       'SIGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SIGEST',
       'F' FROM DUAL
);

/*-- SEQ 10381 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'WIOR',
       TO_NUMBER(null),
       'WIOR',
       'Vnculo IOR e IVE',
       'TW_IORXIVE',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10382 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'WIOR','--','' FROM DUAL
UNION ALL
SELECT 'WIOR','01','Identificao' FROM DUAL
UNION ALL
SELECT 'WIOR','99','Outros' FROM DUAL
);

/*-- SEQ 10383 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 169037,
       'IVE',
       'WIOR',
       '1',
       '1',
       '',
       '',
       'WIOR.FILIVE = IVE.CODFIL AND
WIOR.SEQIVE = IVE.SEQUEN AND
WIOR.NUMIVE = IVE.NUMITE',
       '',
       '' FROM DUAL
);

/*-- SEQ 10384 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN,TIP_LGPD)
(
SELECT 'WIOR',
       '01',
       10.00,
       10.00,
       'CODTAB',
       'N',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'Cdigo',
       'Cdigo',
       '',
       'CODTAB',
       '',
       'S' FROM DUAL
UNION ALL
SELECT 'WIOR',
       '01',
       20.00,
       3.00,
       'FILIVE',
       'A',
       'DFIL',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30.00,
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial Item Venda',
       'Filial do Item de Venda',
       'DFIL.CODFIL = WIOR.FILIVE',
       'FILIVE',
       'T',
       'S' FROM DUAL
UNION ALL
SELECT 'WIOR',
       '01',
       30.00,
       10.00,
       'SEQIVE',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       '9',
       '',
       'Sequen Item Venda',
       'Sequenciador  do Item de Venda',
       '',
       'SEQIVE',
       '',
       'S' FROM DUAL
UNION ALL
SELECT 'WIOR',
       '01',
       40.00,
       5.00,
       'NUMIVE',
       'G',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'nm. Item Venda',
       'Nmero  do Item de Venda',
       '',
       'NUMIVE',
       '',
       'S' FROM DUAL
UNION ALL
SELECT 'WIOR',
       '01',
       50.00,
       6.00,
       'VENCOO',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'COO da Venda',
       'COO da Venda',
       '',
       'VENCOO',
       '',
       'S' FROM DUAL
UNION ALL
SELECT 'WIOR',
       '01',
       60.00,
       3.00,
       'VENECF',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'ECF da Venda',
       'ECF da Venda',
       '',
       'VENECF',
       '',
       'S' FROM DUAL
UNION ALL
SELECT 'WIOR',
       '01',
       70.00,
       3.00,
       'FILORI',
       'A',
       'DFIL',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial do Pedido',
       'Filial do Pedido',
       'DFIL.CODFIL = WIOR.FILORI',
       'FILORI',
       'T',
       'S' FROM DUAL
UNION ALL
SELECT 'WIOR',
       '01',
       80.00,
       1.00,
       'TIPORI',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30.00,
       '',
       '',
       'D',
       '',
       '',
       'A',
       '',
       'Tipo do Pedido',
       'Tipo do Pedido',
       '',
       'TIPORI',
       'T',
       'S' FROM DUAL
UNION ALL
SELECT 'WIOR',
       '01',
       90.00,
       8.00,
       'NUMORI',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Nmero do Pedido',
       'Nmero do Pedido',
       '',
       'NUMORI',
       '',
       'S' FROM DUAL
UNION ALL
SELECT 'WIOR',
       '01',
       100.00,
       4.00,
       'ITEORI',
       'A',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'N',
       '',
       'nm. Item Oramento',
       'Nmero do Item de Oramento',
       '',
       'ITEORI',
       '',
       'S' FROM DUAL
UNION ALL
SELECT 'WIOR',
       '01',
       110.00,
       12.00,
       'QTDENT',
       'F',
       '',
       4.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'A',
       '',
       'Qtd Entregue',
       'Quantidade Entregue',
       '',
       'QTDENT',
       '',
       'S' FROM DUAL
UNION ALL
SELECT 'WIOR',
       '01',
       120.00,
       8.00,
       'DATINC',
       '@',
       '',
       0.00,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Incluso',
       'Data de Incluso',
       '',
       'DATINC',
       '',
       'S' FROM DUAL
);

/*-- SEQ 10385 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'WIOR',
       'TIPORI',
       0.00,
       'S',
       'DAV-OS',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WIOR',
       'TIPORI',
       0.00,
       'P',
       'Pr-Venda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WIOR',
       'TIPORI',
       0.00,
       'O',
       'DAV',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10386 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'WIVE',
       TO_NUMBER(null),
       'WIVE',
       'Itens Venda(Temp.)',
       'TW_IVE',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10387 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'WIVE','--','' FROM DUAL
);

/*-- SEQ 10388 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'WIVE',
       '--',
       6,
       5,
       'CODCOR',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'WIVE',
       '--',
       2,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'WIVE',
       '--',
       5,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'WIVE',
       '--',
       7,
       5,
       'CODTAM',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'WIVE',
       '--',
       4,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'WIVE',
       '--',
       19,
       1,
       'ICMTIP',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ICMTIP',
       'F' FROM DUAL
UNION ALL
SELECT 'WIVE',
       '--',
       13,
       5,
       'ITEORI',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ITEORI',
       'F' FROM DUAL
UNION ALL
SELECT 'WIVE',
       '--',
       16,
       1,
       'LANEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'LANEST',
       'F' FROM DUAL
UNION ALL
SELECT 'WIVE',
       '--',
       14,
       20,
       'NUMEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NUMEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'WIVE',
       '--',
       3,
       5,
       'NUMITE',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'WIVE',
       '--',
       12,
       10,
       'NUMORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NUMORI',
       'F' FROM DUAL
UNION ALL
SELECT 'WIVE',
       '--',
       8,
       12,
       'QTDMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'WIVE',
       '--',
       20,
       12,
       'QTDPEN',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'QTDPEN',
       'F' FROM DUAL
UNION ALL
SELECT 'WIVE',
       '--',
       18,
       7,
       'REDITE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'REDITE',
       'F' FROM DUAL
UNION ALL
SELECT 'WIVE',
       '--',
       21,
       5,
       'SEQPEN',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQPEN',
       'F' FROM DUAL
UNION ALL
SELECT 'WIVE',
       '--',
       1,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'WIVE',
       '--',
       10,
       1,
       'SITKIT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SITKIT',
       'F' FROM DUAL
UNION ALL
SELECT 'WIVE',
       '--',
       15,
       1,
       'SITMOV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SITMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'WIVE',
       '--',
       11,
       1,
       'TIPORI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPORI',
       'F' FROM DUAL
UNION ALL
SELECT 'WIVE',
       '--',
       17,
       1,
       'TIPPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'WIVE',
       '--',
       9,
       12,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       '',
       '',
       '',
       'VLRMOV',
       'F' FROM DUAL
);

/*-- SEQ 10389 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'WKEY',
       TO_NUMBER(null),
       'WKEY',
       'Autorizao de Chave',
       'TW_KEY',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'SEQKEY',
       '' FROM DUAL
);

/*-- SEQ 10390 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'WKEY','--','' FROM DUAL
UNION ALL
SELECT 'WKEY','01','Identificao' FROM DUAL
UNION ALL
SELECT 'WKEY','99','Outros' FROM DUAL
);

/*-- SEQ 10391 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'WKEY',
       '--',
       40,
       7,
       'DATREG',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Hora Registro',
       'Data e Hora do Registro',
       '',
       'DATREG',
       'F' FROM DUAL
UNION ALL
SELECT 'WKEY',
       '--',
       30,
       32,
       'SEQKEY',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Chave de Autorizao',
       'Chave de Autorizao',
       '',
       'SEQKEY',
       'F' FROM DUAL
);

/*-- SEQ 10392 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'WMOD',
       TO_NUMBER(null),
       'WMOD',
       'Tarefa Modelo',
       'TT_WOR',
       'F',
       'WMOD.MODELO=''T''',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10393 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'WMOD','--','' FROM DUAL
UNION ALL
SELECT 'WMOD','01','Identificao' FROM DUAL
UNION ALL
SELECT 'WMOD','99','Outros' FROM DUAL
);

/*-- SEQ 10394 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 20152,
       'WOR ',
       'WMOD',
       'N ',
       '1 ',
       '',
       '',
       'WOR.FILMOD = WMOD.CODFIL AND  
WOR.SEQMOD = WMOD.SEQUEN',
       '',
       '' FROM DUAL
);

/*-- SEQ 10395 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'WMOD',
       '99',
       2,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Codigo da filial',
       'Codigo da Filial',
       '',
       'CODFIL',
       '' FROM DUAL
UNION ALL
SELECT 'WMOD',
       '01',
       3,
       255,
       'DESTAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Ttulo da Tarefa',
       'Ttulo da Tarefa',
       '',
       'DESTAR',
       '' FROM DUAL
UNION ALL
SELECT 'WMOD',
       '99',
       1,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'U',
       '',
       '',
       'A',
       '',
       'Sequenciador',
       'Sequenciador',
       '',
       'SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 10396 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'WMOV',
       TO_NUMBER(null),
       'WMOV',
       'Movimentao(Temp.)',
       'TW_MOV',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10397 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'WMOV','--','' FROM DUAL
);

/*-- SEQ 10398 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'WMOV',
       '--',
       10,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Data~Atualizao',
       '',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'WMOV',
       '--',
       4,
       5,
       'CODCOR',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODCOR',
       'F' FROM DUAL
UNION ALL
SELECT 'WMOV',
       '--',
       8,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'WMOV',
       '--',
       3,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'WMOV',
       '--',
       5,
       5,
       'CODTAM',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODTAM',
       'F' FROM DUAL
UNION ALL
SELECT 'WMOV',
       '--',
       14,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'WMOV',
       '--',
       1,
       5,
       'CONECT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CONECT',
       'F' FROM DUAL
UNION ALL
SELECT 'WMOV',
       '--',
       6,
       7,
       'DATMOV',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'WMOV',
       '--',
       7,
       17,
       'DOCUME',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'WMOV',
       '--',
       2,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'WMOV',
       '--',
       13,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'WMOV',
       '--',
       18,
       40,
       'NATURE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATURE',
       'F' FROM DUAL
UNION ALL
SELECT 'WMOV',
       '--',
       16,
       20,
       'NUMEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NUMEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'WMOV',
       '--',
       9,
       5,
       'NUMITE',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NUMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'WMOV',
       '--',
       11,
       12,
       'QTDMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'QTDMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'WMOV',
       '--',
       17,
       1,
       'SITMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SITMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'WMOV',
       '--',
       15,
       1,
       'TIPMOV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPMOV',
       'F' FROM DUAL
UNION ALL
SELECT 'WMOV',
       '--',
       12,
       12,
       'VLRMOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       '',
       '',
       '',
       'VLRMOV',
       'F' FROM DUAL
);

/*-- SEQ 10399 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'WOR ',
       TO_NUMBER(null),
       'WOR ',
       'WorkFlow',
       'TT_WOR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'WOR.CODFIL,WOR.SEQUEN',
       '' FROM DUAL
);

/*-- SEQ 10400 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'WOR ','--','' FROM DUAL
UNION ALL
SELECT 'WOR ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'WOR ','02','Datas' FROM DUAL
UNION ALL
SELECT 'WOR ','03','Valores' FROM DUAL
UNION ALL
SELECT 'WOR ','04','Dados Financeiros' FROM DUAL
UNION ALL
SELECT 'WOR ','99','Outros' FROM DUAL
);

/*-- SEQ 10401 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 22110,
       'CLI ',
       'WOR ',
       '1',
       'N',
       '',
       '',
       'WOR.FILCLI = CLI.FILCLI AND
WOR.CODCLI = CLI.CODCLI',
       '',
       '' FROM DUAL
UNION ALL
SELECT 22111,
       'IOR ',
       'WOR ',
       '1',
       '1',
       '',
       '',
       'WOR.FILPED = IOR.CODFIL AND
WOR.TIPPED = IOR.TIPPED AND
WOR.NUMPED = IOR.NUMPED AND
WOR.ITEPED = IOR.NUMITE',
       '',
       '' FROM DUAL
);

/*-- SEQ 10402 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'WOR ',
       '99',
       860,
       1,
       ' MODELO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Tarefa Modelo?',
       'Tarefa Modelo?',
       '',
       ' MODELO',
       '' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       290,
       4,
       'ANO_DATACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano da confirmao',
       'Ano da Confirmao',
       '',
       'TO_CHAR(WOR.DATACT,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       165,
       4,
       'ANO_DATPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano Data Prometida',
       'Ano Data Prometida',
       '',
       'TO_CHAR(WOR.DATPRO,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       355,
       4,
       'ANO_DATREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano Registro',
       'Ano Registro',
       '',
       'TO_CHAR(WOR.DATREG,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       475,
       4,
       'ANO_DATSOL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data solicita',
       'Ano de ',
       '',
       'TO_CHAR(WOR.DATSOL,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       185,
       4,
       'ANO_FIMTAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano de Data fim tare',
       'Ano de ',
       '',
       'TO_CHAR(WOR.FIMTAR,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       205,
       4,
       'ANO_FIMTST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano Fim Teste',
       'Ano Fim Teste',
       '',
       'TO_CHAR(WOR.FIMTST,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       175,
       4,
       'ANO_INITAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano Incio Tarefa',
       'Ano Incio Tarefa',
       '',
       'TO_CHAR(WOR.INITAR,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       195,
       4,
       'ANO_INITST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ano Inicio Teste',
       'Ano Incio Teste',
       '',
       'TO_CHAR(WOR.INITST,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '99',
       870,
       5,
       'ARTEFA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Nmero de Artefatos',
       'Nmero de Artefatos',
       '',
       'ARTEFA',
       '' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       340,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data~Atualizao',
       'Data de Atualizao',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '99',
       500,
       1,
       'AVISAR',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Avisar?',
       'Avisar?',
       '',
       'AVISAR',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       790,
       5,
       'CLATAR',
       'S',
       'DCLT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DCLT.DESCLT',
       'V',
       '',
       '',
       'A',
       'F',
       'Classificao Tarefa',
       'Classificao da Tarefa',
       'DCLT.CODTAB = WOR.CLATAR',
       'CLATAR',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       800,
       255,
       'CLIENTETAREFA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       '',
       'Cliente~da Tarefa',
       'Cliente da Tarefa',
       '',
       '(SUBSTR(CLIENTETAREFA(WOR.CODFIL,WOR.SEQUEN),0,64))',
       '' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       250,
       7,
       'COBRAR',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Horas cobradas',
       'Horas Cobradas',
       '',
       'COBRAR',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       270,
       6,
       'CODACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Cdigo Aceito',
       'Cdigo Aceito',
       '',
       'CODACT',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       430,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       'Cdigo do Cliente',
       'Cdigo Cliente',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       490,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       'DFIL.CODFIL(+) = WOR.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       650,
       1,
       'CODFPA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Complexidade',
       'Complexidade',
       '',
       'CODFPA',
       'T' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '03',
       760,
       5,
       'CODFUN',
       'S',
       'DFUN',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFUN.DESFUN',
       'V',
       '',
       '',
       'A',
       'F',
       'Funcionalidade',
       'Funcionalidade',
       'DFUN.CODTAB = WOR.CODFUN',
       'CODFUN',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       10,
       3,
       'CODREG',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Registrado por',
       'Cdigo Registro',
       'USU.FILUSU(+) = WOR.FILREG AND USU.CODUSU(+) = WOR.CODREG',
       'CODREG',
       'T' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       8,
       3,
       'CODRES',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Responsvel',
       'Cdigo Responsvel',
       'USU.FILUSU(+) = WOR.FILRES AND USU.CODUSU(+) = WOR.CODRES',
       'CODRES',
       'T' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       660,
       6,
       'CODREV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Cdigo Revisor',
       'Cdigo Revisor',
       '',
       'CODREV',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       450,
       6,
       'CODSOL',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Solicitante',
       'Cdigo Solicitante',
       'USU.FILUSU = WOR.FILSOL(+) and USU.CODUSU = WOR.CODSOL(+)',
       'CODSOL',
       'T' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       12,
       3,
       'CODTST',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       'A',
       'F',
       'Revisor',
       'Cdigo Revisor',
       'USU.FILUSU(+) = WOR.FILTST AND USU.CODUSU(+) = WOR.CODTST',
       'CODTST',
       'T' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       670,
       254,
       'COMJUS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Comple Justificativa',
       'Complemento de Justificativa',
       '',
       'COMJUS',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '03',
       360,
       3,
       'CONCLU',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       '% de Concluso',
       '% de Concluso',
       '',
       'CONCLU',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       295,
       7,
       'DATACT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data da confirmao',
       'Data Confirmao',
       '',
       'DATACT',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       730,
       7,
       'DATAPLAN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       '',
       'Data Plan.',
       'Data inicio planejada',
       '',
       'TRUNC(WOR.INIPLT)',
       '' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '99',
       680,
       1,
       'DATFIX',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Data Fixa?',
       'Data Fixa?',
       '',
       'DATFIX',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       160,
       7,
       'DATPRO',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Prometida',
       'Data Prometida',
       '',
       'DATPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       350,
       7,
       'DATREG',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data de Registro',
       'Data Registro',
       '',
       'DATREG',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       470,
       7,
       'DATSOL',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data solicitao',
       'Data Solicitao',
       '',
       'DATSOL',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       13,
       255,
       'DESTAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Ttulo Tarefa',
       'Ttulo da Tarefa',
       '',
       'DESTAR',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       510,
       4000,
       'DOCUME',
       'M',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Documentao',
       'Documentao',
       '',
       'DOCUME',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       6,
       1,
       'FATURA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       'F',
       'A',
       'F',
       'Cobrana',
       'Fatura',
       '',
       'FATURA',
       'T' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       260,
       3,
       'FILACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Filial Contato',
       'Filial do usurio que confirmou a realizao da tarefa',
       '',
       'FILACT',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       420,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Cliente',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '99',
       890,
       3,
       'FILMOD',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       '',
       'Filial do Modelo',
       '',
       'FILMOD',
       '' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '99',
       810,
       3,
       'FILPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Filial do Item',
       'Filial do Item de Pedido',
       '',
       'FILPED',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '99',
       1110,
       3,
       'FILPOS',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       '0',
       '',
       'Filial no Totali PoS',
       'Filial no Totali PoS',
       'DFIL.CODFIL(+) = WOR.FILPOS',
       'FILPOS',
       'T' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       320,
       3,
       'FILPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial do Projeto',
       '',
       'FILPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       9,
       3,
       'FILREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial Registro',
       'Filial Registro',
       '',
       'FILREG',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       7,
       3,
       'FILRES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Responsvel',
       '',
       'FILRES',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       690,
       3,
       'FILREV',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Revisor',
       '',
       'FILREV',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       440,
       3,
       'FILSOL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Solicitao',
       '',
       'FILSOL',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       380,
       3,
       'FILSUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Suporte',
       '',
       'FILSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       11,
       3,
       'FILTST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       'Filial Revisor',
       '',
       'FILTST',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       520,
       7,
       'FIMPLR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fim Plan. Rev.',
       'Data de Fim Planejada para a Reviso',
       '',
       'FIMPLR',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       530,
       7,
       'FIMPLT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fim Plan.Tarefa',
       'Data de Fim Planejada para Tarefa',
       '',
       'FIMPLT',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       540,
       7,
       'FIMPRR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fim Proj. Rev.',
       'Data de Fim Projetada para a Reviso',
       '',
       'FIMPRR',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       550,
       7,
       'FIMPRT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Fim Prev.Tarefa',
       'Data Final de Previso da Tarefa',
       '',
       'FIMPRT',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       180,
       7,
       'FIMTAR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data fim tarefa',
       'Data Fim Tarefa',
       '',
       'FIMTAR',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       200,
       7,
       'FIMTST',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data fim teste',
       'Data Fim Teste',
       '',
       'FIMTST',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       560,
       1,
       'FLGACT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Flag Aceita?',
       'Flag Aceita?',
       '',
       'FLGACT',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       683,
       5,
       'FLGSIT',
       'G',
       'DSIT',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DSIT.DESSIT',
       'V',
       '',
       '',
       '9',
       '',
       'Situao',
       'Situao',
       'DSIT.CODTAB = WOR.FLGSIT',
       'FLGSIT',
       'T' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       750,
       8,
       'HORAFIMPLAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'Hora Fim. Plan.',
       'Hora fim planejada para tarefa',
       '',
       'TO_CHAR(WOR.FIMPLT, ''HH24:MI:SS'')',
       '' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       740,
       8,
       'HORAINIPLAN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       '',
       'Hora Ini. Plan.',
       'Hora inicio planejada para tarefa',
       '',
       'TO_CHAR(WOR.INIPLT, ''HH24:MI:SS'')',
       '' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '03',
       700,
       4,
       'HORERR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Horas de Erro',
       'Horas de Erro',
       '',
       'HORERR',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '99',
       1120,
       10,
       'ID_POS',
       'N',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'ID no Totali PoS',
       'ID do registro no Totali PoS',
       '',
       'ID_POS',
       '' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       570,
       7,
       'INIPLR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ini.Plan. Rev.',
       'Data de Incio Planejada para a Reviso',
       '',
       'INIPLR',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       580,
       7,
       'INIPLT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ini.Plan.Tarefa',
       'Data de Incio Planejada para a Tarefa',
       '',
       'INIPLT',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       590,
       7,
       'INIPRR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ini. Proj. Rev.',
       'Data de Incio Projetada para a Reviso',
       '',
       'INIPRR',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       600,
       7,
       'INIPRT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data Ini.Proj.Tarefa',
       'Data de Incio Projetada para a Tarefa',
       '',
       'INIPRT',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       170,
       7,
       'INITAR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data incio tarefa',
       'Data Incio da Tarefa',
       '',
       'INITAR',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       190,
       7,
       'INITST',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '@',
       'F',
       'Data inicio Teste',
       'Data Incio Teste',
       '',
       'INITST',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '99',
       820,
       5,
       'ITEPED',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero do Item',
       'Nmero do Item de Pedido',
       '',
       'ITEPED',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       750,
       5,
       'JUSATR',
       'S',
       'DJUS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DJUS.DESJUS',
       'V',
       '',
       '',
       'N',
       'F',
       'Justificativa Atraso',
       'Justificativa de Atraso',
       'DJUS.CODTAB(+) = WOR.JUSATR',
       'JUSATR',
       'T' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '04',
       950,
       12,
       'LIQPRO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor prop c/ descon',
       'Valor da proposta com desconto',
       '',
       'LIQPRO',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       1090,
       7,
       'MAXPRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Previso Mxima',
       'Previso Mxima',
       '',
       'MAXPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       293,
       2,
       'MES_DATACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       'F',
       'Ms Confirmao',
       'Ms Confirmao',
       '',
       'TO_CHAR(WOR.DATACT,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       163,
       2,
       'MES_DATPRO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms Data Prometida',
       'Ms Data Prometida',
       '',
       'TO_CHAR(WOR.DATPRO,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       353,
       2,
       'MES_DATREG',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms Data Registro',
       'Ms Data Registro',
       '',
       'TO_CHAR(WOR.DATREG,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       473,
       2,
       'MES_DATSOL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms Solicitao',
       'Ms Solicitao',
       '',
       'TO_CHAR(WOR.DATSOL,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       183,
       2,
       'MES_FIMTAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms Fim Tarefa',
       'Ms Fim Tarefa',
       '',
       'TO_CHAR(WOR.FIMTAR,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       203,
       2,
       'MES_FIMTST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms Fim Teste',
       'Ms Fim Teste',
       '',
       'TO_CHAR(WOR.FIMTST,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       173,
       2,
       'MES_INITAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       'N',
       'F',
       'Ms Incio Tarefa',
       'Ms Incio da Tarefa',
       '',
       'TO_CHAR(WOR.INITAR,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       193,
       2,
       'MES_INITST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Ms Inicio Teste',
       'Ms Incio Teste',
       '',
       'TO_CHAR(WOR.INITST,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       1100,
       7,
       'MINPRE',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Previso Mnima',
       'Previso Mnima',
       '',
       'MINPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '99',
       930,
       7,
       'MODCOM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Cobradas complexas',
       'Horas cobradas para tarefas complexas',
       '',
       'MODCOM',
       '' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '99',
       920,
       7,
       'MODMED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Cobradas Mdias',
       'Horas cobradas para tarefas mdias',
       '',
       'MODMED',
       '' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '99',
       910,
       7,
       'MODSIM',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Cobradas simples',
       'Horas cobradas para tarefas simples',
       '',
       'MODSIM',
       '' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       3,
       5,
       'MODULO',
       'N',
       'DMOD',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOD.MODULO',
       'V',
       '',
       'F',
       'N',
       'F',
       'Mdulo',
       'Mdulo',
       'DMOD.CODTAB(+) = WOR.MODULO',
       'MODULO',
       'T' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '03',
       688,
       2,
       'NOTAVA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Nota da tarefa',
       'Nota da tarefa',
       '',
       'NOTAVA',
       '' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '04',
       970,
       2,
       'NROPAR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Nmero Parcelas',
       'Nmero Parcelas',
       '',
       'NROPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '03',
       280,
       4,
       'NUMACT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Numero do aceito',
       'Nmero do Aceito',
       '',
       'NUMACT',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '99',
       830,
       8,
       'NUMPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '0',
       'F',
       'Nmero do Pedido',
       'Nmero do Pedido',
       '',
       'NUMPED',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '03',
       710,
       4,
       'NUMREV',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Nmero de Revises',
       'Nmero de Revises',
       '',
       'NUMREV',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '03',
       460,
       4,
       'NUMSOL',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'N solcicitante',
       'N Solicitante',
       '',
       'NUMSOL',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       610,
       255,
       'OLDDES',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio Antiga',
       'Descrio Antiga',
       '',
       'OLDDES',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       620,
       10,
       'ORIGEM',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Origem',
       'Origem',
       '',
       'ORIGEM',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '99',
       880,
       5,
       'PERART',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       '',
       '% Hora Artefato',
       '% sobre as horas por Artefato',
       '',
       'PERART',
       '' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '04',
       980,
       7,
       'PERETG',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       '% Valor na entrega',
       '% Valor na entrega',
       '',
       'PERETG',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       630,
       1,
       'PRICLI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'N',
       'F',
       'Prioridade Cliente',
       'Prioridade do Cliente',
       '',
       'PRICLI',
       'T' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       310,
       1,
       'PRIORI',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Prioridade',
       'Prioridade',
       '',
       'PRIORI',
       'T' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '04',
       1000,
       7,
       'PROAPR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       ' Data Aprovao Prop',
       ' Data de Aprovao da Proposta',
       '',
       'PROAPR',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '04',
       1010,
       5,
       'PRZNOR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'N Semanas Ent. Prop',
       'Nmero de semanas para entrega da proposta',
       '',
       'PRZNOR',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '04',
       1020,
       5,
       'PRZURG',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Nmero Dias Urgncia',
       'Nmero de dias teis para entrega da proposta em regime de urgncia',
       '',
       'PRZURG',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '03',
       720,
       3,
       'QTDERR',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Quantidade de Erros',
       'Quantidade de Erros',
       '',
       'QTDERR',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '99',
       1070,
       5,
       'RELEAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Release',
       'Release',
       '',
       'RELEAS',
       '' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '03',
       636,
       5,
       'RELWOR',
       'G',
       'DREL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DREL.DESREL',
       'V',
       '',
       '',
       'N',
       '',
       'Release',
       'Release',
       'DREL.CODTAB = WOR.RELWOR',
       'RELWOR',
       'T' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '99',
       640,
       1,
       'RESERV',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Reservado?',
       'Reservado?',
       '',
       'RESERV',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       15,
       4000,
       'REVISA',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Reviso',
       'Descrio da Reviso',
       '',
       'RTF2TXT(REVISA)',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '99',
       900,
       10,
       'SEQMOD',
       'A',
       'WMOD',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'WMOD.DESTAR',
       'V',
       '',
       '',
       'A',
       '',
       'Tarefa Modelo',
       'Tarefa Modelo',
       'WMOD.SEQUEN = WOR.SEQMOD AND WMOD.CODFIL = WOR.FILMOD AND WMOD.MODELO=''T''',
       'SEQMOD',
       'T' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       330,
       10,
       'SEQPRJ',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador do Projeto',
       '',
       'SEQPRJ',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       390,
       10,
       'SEQSUP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador Suporte',
       '',
       'SEQSUP',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       2,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Nmero~Tarefa',
       'Nmero da Tarefa(Sequenciador)',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '03',
       400,
       1,
       'SIGNAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       '#Ativo?',
       'Ativo se SIGNAT >=0 ou Inativo se SIGNAT < 0 (descontinuado)',
       '',
       '(CASE WHEN WOR.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '03',
       401,
       1,
       'ATIVO',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       'A',
       '',
       'Ativo?',
       'Registro Ativo?',
       '',
       '(CASE WHEN WOR.SIGNAT>=0 THEN ''T'' ELSE ''F'' END)',
       '' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       770,
       1,
       'SPLITW',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Dividida em Etapas?',
       'Tarefa pode ser dividida em Etapas?',
       '',
       'SPLITW',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       14,
       4000,
       'TAREFA',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Descrio da Tarefa',
       'Descrio da Tarefa',
       '',
       'RTF2TXT(TAREFA)',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       210,
       7,
       'TARPRE',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'H. previstas Tarefa',
       'Horas pevistas para realizao da tarefa',
       '',
       'TARPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       220,
       7,
       'TARREA',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Horas realizadas',
       'Horas realizadas na tarefa',
       '',
       'TARREA',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       300,
       1,
       'TIPACT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Tipo confirmao',
       'Tipo Confirmao',
       '',
       'TIPACT',
       'T' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       730,
       1,
       'TIPCWS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo C. WorkF/Supor.',
       'Tipo C. WorFlow/suporte',
       '',
       'TIPCWS',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       740,
       1,
       'TIPMAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Mo de Obra',
       'Mo de Obra',
       '',
       'TIPMAO',
       'T' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '99',
       850,
       1,
       'TIPPED',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       '',
       'A',
       'F',
       'Tipo do Item',
       'Tipo do Item de Pedido',
       '',
       'TIPPED',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       5,
       5,
       'TIPTAR',
       'G',
       'DCWS',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       'DCWS.DESCWS',
       'V',
       '',
       'F',
       'A',
       'F',
       'Tipo Tarefa',
       'TIPOS DE TAREFA',
       'WOR.TIPTAR = DCWS.CODTAB',
       'TIPTAR',
       'T' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       230,
       7,
       'TSTPRE',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'H. previstas teste',
       'Horas Previstas teste',
       '',
       'TSTPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '02',
       240,
       7,
       'TSTREA',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'H. realizadas testes',
       'Horas Realizadas Testes',
       '',
       'TSTREA',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '99',
       940,
       5,
       'VERPROP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'A',
       '',
       'Verso da proposta',
       'Verso da proposta',
       '',
       'VERPROP',
       '' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '01',
       4,
       4,
       'VERSAO',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'A',
       '',
       'F',
       'A',
       'F',
       'Verso do Sistema',
       'Verso',
       '',
       'VERSAO',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '04',
       1030,
       12,
       'VLRENT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Entrada',
       'Valor Entrada',
       '',
       'VLRENT',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '04',
       1040,
       12,
       'VLRETG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Valor na Entrega',
       'Valor na Entrega',
       '',
       'VLRETG',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '04',
       1050,
       12,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Valor Parcelas',
       'Valor Parcelas',
       '',
       'VLRPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'WOR ',
       '04',
       1060,
       12,
       'VLRPRO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'T',
       '',
       'F',
       'Valor Total',
       'Valor Total',
       '',
       'VLRPRO',
       'F' FROM DUAL
);

/*-- SEQ 10403 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'WOR ',
       'CODFPA',
       0,
       ' ',
       'Indefinido',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'CODFPA',
       0,
       '1',
       'Simples',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'CODFPA',
       0,
       '2',
       'Mdio',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'CODFPA',
       0,
       '3',
       'Complexo',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'FATURA',
       0,
       'A',
       'A Faturar',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'FATURA',
       0,
       'C',
       'Contrato',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'FATURA',
       0,
       'D',
       'A Definir',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'FATURA',
       0,
       'F',
       'Faturado',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'FATURA',
       0,
       'R',
       'Revenda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'FATURA',
       0,
       'S',
       'Cortesia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'FATURA',
       0,
       'V',
       'Faturado contra a Revenda',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'PRICLI',
       3,
       ' ',
       'Baixa',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'PRICLI',
       0,
       ' ',
       'Imediato',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'PRICLI',
       1,
       ' ',
       'Alta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'PRICLI',
       2,
       ' ',
       'Mdia',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'TIPACT',
       0,
       'C',
       'Carta',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'TIPACT',
       0,
       'E',
       'E-Mail',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'TIPACT',
       0,
       'F',
       'Fax',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'TIPACT',
       0,
       'M',
       'Mensagem Instantneas',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'TIPACT',
       0,
       'S',
       'Site',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'TIPACT',
       0,
       'T',
       'Telefnico',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'TIPACT',
       0,
       'V',
       'Verbal',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'TIPMAO',
       0,
       'H',
       'Horas Extras',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'TIPMAO',
       0,
       'I',
       'Interna',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WOR ',
       'TIPMAO',
       0,
       'T',
       'Terceirizada',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10404 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'WPRE',
       TO_NUMBER(null),
       'WPRE',
       'Preos a Aplicar',
       'TW_PRE',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'WPRE.FILPRE,WPRE.CODPRE,WPRE.FILMAT,WPRE.CODMAT,WPRE.CODCOR,WPRE.CODTAM',
       '' FROM DUAL
);

/*-- SEQ 10405 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'WPRE','--','' FROM DUAL
UNION ALL
SELECT 'WPRE','50','Custos Totais (FPV)' FROM DUAL
);

/*-- SEQ 10406 --*/
INSERT INTO TT_SQL
(NUMSEQ,CODDES,CODORI,RELDES,RELORI,RELNXN,FILTRO,REL_ON,PROPOR,RELON_DES)
(
SELECT 25482,
       'PRE ',
       'WPRE',
       '1',
       'N',
       '',
       '',
       'WPRE.FILPRE = PRE.FILPRE and
WPRE.CODPRE = PRE.CODPRE and
WPRE.FILMAT = PRE.FILMAT and
WPRE.CODMAT = PRE.CODMAT and
WPRE.CODCOR = PRE.CODCOR and
WPRE.CODTAM = PRE.CODTAM',
       '',
       '' FROM DUAL
);

/*-- SEQ 10407 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'WPRE',
       '--',
       115,
       4,
       'ANO_ULTREA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Ano de ltimo Reajus',
       'Ano de ltimo Reajuste',
       '',
       'TO_CHAR(WPRE.ULTREA,''YYYY'')',
       'F' FROM DUAL
UNION ALL
SELECT 'WPRE',
       '--',
       5,
       5,
       'CODCOR',
       'S',
       'DIV ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DIV.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Diviso',
       'Cdigo da Diviso',
       'WPRE.CODCOR=DIV.CODITE (+)',
       'CODCOR',
       'T' FROM DUAL
UNION ALL
SELECT 'WPRE',
       '--',
       130,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo da Filial',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'WPRE',
       '--',
       4,
       5,
       'CODMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       '',
       'Cdigo do Produto',
       '',
       'CODMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'WPRE',
       '--',
       9,
       5,
       'CODMOE',
       'F',
       'DMOE',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DMOE.DESMOE',
       'V',
       '',
       'F',
       'A',
       'F',
       'Moeda',
       'Cdigo da Moeda',
       'WPRE.CODMOE = DMOE.CODTAB(+)',
       'CODMOE',
       'T' FROM DUAL
UNION ALL
SELECT 'WPRE',
       '--',
       2,
       5,
       'CODPRE',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '',
       'F',
       'Cdigo Tab. Preos',
       'Cdigo da Tabela de preos',
       '',
       'CODPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'WPRE',
       '--',
       6,
       5,
       'CODTAM',
       'S',
       'SUB ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'SUB.NOMEXT',
       'V',
       '',
       'F',
       'N',
       'F',
       'Sub-Diviso',
       'Cdigo da Sub-Diviso',
       'WPRE.CODTAM=SUB.CODITE (+)',
       'CODTAM',
       'T' FROM DUAL
UNION ALL
SELECT 'WPRE',
       '--',
       8,
       3,
       'CODUSU',
       'A',
       'USU ',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'USU.APEUSU',
       'V',
       '',
       'F',
       '9',
       'F',
       'Usurio',
       'Cdigo do Usurio',
       'WPRE.FILUSU = USU.FILUSU(+) AND WPRE.CODUSU = USU.CODUSU(+)',
       'CODUSU',
       'T' FROM DUAL
UNION ALL
SELECT 'WPRE',
       '50',
       160,
       12,
       'CUSREP',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Custo de Reposio',
       'Custo de Reposio na FPV',
       '',
       'CUSREP',
       '' FROM DUAL
UNION ALL
SELECT 'WPRE',
       '50',
       170,
       12,
       'CUSVEN',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Custo Total de Venda',
       'Custo Total de Venda',
       '',
       'CUSVEN',
       '' FROM DUAL
UNION ALL
SELECT 'WPRE',
       '50',
       180,
       12,
       'DESFIX',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Despesa Oper Fixa',
       'Despesa Oper Fixa',
       '',
       'DESFIX',
       '' FROM DUAL
UNION ALL
SELECT 'WPRE',
       '--',
       3,
       3,
       'FILMAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da Filial Origem do produto',
       '',
       'FILMAT',
       'F' FROM DUAL
UNION ALL
SELECT 'WPRE',
       '--',
       1,
       3,
       'FILPRE',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       'F',
       'N',
       'F',
       '',
       'Filial da Tabela de preo',
       'DFIL.CODFIL = WPRE.FILPRE',
       'FILPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'WPRE',
       '--',
       7,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       'N',
       'F',
       '',
       'Cdigo da filial origem do usurio',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'WPRE',
       '--',
       120,
       1,
       'FLGAPL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'Y',
       '',
       '',
       '',
       'F',
       'Aplica Preos?',
       'Aplica Preos?',
       '',
       'FLGAPL',
       'F' FROM DUAL
UNION ALL
SELECT 'WPRE',
       '--',
       150,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       30,
       '',
       '',
       'D',
       '',
       '',
       'A',
       'F',
       'Situao',
       'Situao',
       '',
       'FLGEST',
       'T' FROM DUAL
UNION ALL
SELECT 'WPRE',
       '50',
       190,
       12,
       'LUCPRJ',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       'Lucro Projetado',
       'Lucro Projetado',
       '',
       'LUCPRJ',
       '' FROM DUAL
UNION ALL
SELECT 'WPRE',
       '--',
       113,
       2,
       'MES_ULTREA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Ms de ltimo Reajus',
       'Ms de ltimo Reajuste',
       '',
       'TO_CHAR(WPRE.ULTREA,''MM'')',
       'F' FROM DUAL
UNION ALL
SELECT 'WPRE',
       '50',
       210,
       7,
       'PERLUCPRJ',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Lucro FPV',
       '% Lucro FPV',
       '',
       'PERLUCPRJ',
       '' FROM DUAL
UNION ALL
SELECT 'WPRE',
       '50',
       200,
       7,
       'PEROPEFIX',
       'F',
       '',
       4,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       '',
       '% Desp. Oper. Fix ',
       '% Despesas Operacionais Fixas',
       '',
       'PEROPEFIX',
       '' FROM DUAL
UNION ALL
SELECT 'WPRE',
       '--',
       10,
       10,
       'PRECOV',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '9',
       'F',
       'Preo de Venda',
       'Preo de Venda',
       '',
       'PRECOV',
       'F' FROM DUAL
UNION ALL
SELECT 'WPRE',
       '--',
       140,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'WPRE',
       '--',
       110,
       8,
       'ULTREA',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       'F',
       '@',
       'F',
       'ltimo Reajuste',
       'ltimo Reajuste',
       '',
       'ULTREA',
       'F' FROM DUAL
);

/*-- SEQ 10408 --*/
INSERT INTO TT_DOM
(CODARQ, NOMCPO, CODINT, CODCHR, DESDOM, SEQUEN, CODSTR)
(
SELECT 'WPRE',
       'FLGEST',
       0,
       'F',
       'Falso',
       TO_NUMBER(null),
       ' ' FROM DUAL
UNION ALL
SELECT 'WPRE',
       'FLGEST',
       0,
       'T',
       'Verdadeiro',
       TO_NUMBER(null),
       ' ' FROM DUAL
);

/*-- SEQ 10409 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'WREC',
       TO_NUMBER(null),
       'WREC',
       'Recebimento(Temp.)',
       'TW_REC',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10410 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'WREC','--','' FROM DUAL
);

/*-- SEQ 10411 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'WREC',
       '--',
       8,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Data~Atualizao',
       '',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'WREC',
       '--',
       20,
       13,
       'CHVVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CHVVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'WREC',
       '--',
       2,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'WREC',
       '--',
       15,
       2,
       'CODMOE',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODMOE',
       'F' FROM DUAL
UNION ALL
SELECT 'WREC',
       '--',
       13,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'WREC',
       '--',
       9,
       8,
       'CUPFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CUPFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'WREC',
       '--',
       7,
       7,
       'DATVEN',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'WREC',
       '--',
       18,
       3,
       'FILREC',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILREC',
       'F' FROM DUAL
UNION ALL
SELECT 'WREC',
       '--',
       12,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'WREC',
       '--',
       5,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'WREC',
       '--',
       17,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'WREC',
       '--',
       3,
       2,
       'NUMPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NUMPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'WREC',
       '--',
       6,
       7,
       'PAGAME',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PAGAME',
       'F' FROM DUAL
UNION ALL
SELECT 'WREC',
       '--',
       14,
       5,
       'PORTAD',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PORTAD',
       'F' FROM DUAL
UNION ALL
SELECT 'WREC',
       '--',
       19,
       10,
       'SEQCHE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SEQCHE',
       'F' FROM DUAL
UNION ALL
SELECT 'WREC',
       '--',
       1,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'WREC',
       '--',
       4,
       2,
       'SUBPAR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SUBPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'WREC',
       '--',
       16,
       12,
       'VLRDES',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       '',
       '',
       '',
       'VLRDES',
       'F' FROM DUAL
UNION ALL
SELECT 'WREC',
       '--',
       11,
       12,
       'VLRPAR',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       '',
       '',
       '',
       'VLRPAR',
       'F' FROM DUAL
UNION ALL
SELECT 'WREC',
       '--',
       10,
       12,
       'VLRPGT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       '',
       '',
       '',
       'VLRPGT',
       'F' FROM DUAL
);

/*-- SEQ 10412 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'WSUB',
       TO_NUMBER(null),
       'WSUB',
       'Work Sub Diviso',
       'TW_SUB',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10413 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'WSUB','--','' FROM DUAL
);

/*-- SEQ 10414 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'WSUB',
       '--',
       1,
       5,
       'CODITE',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODITE',
       'F' FROM DUAL
UNION ALL
SELECT 'WSUB',
       '--',
       6,
       5,
       'CODSAL',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODSAL',
       'F' FROM DUAL
UNION ALL
SELECT 'WSUB',
       '--',
       2,
       5,
       'CODSUB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODSUB',
       'F' FROM DUAL
UNION ALL
SELECT 'WSUB',
       '--',
       4,
       12,
       'FATCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FATCON',
       'F' FROM DUAL
UNION ALL
SELECT 'WSUB',
       '--',
       3,
       10,
       'NOMITE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NOMITE',
       'F' FROM DUAL
UNION ALL
SELECT 'WSUB',
       '--',
       5,
       5,
       'ORDSUB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ORDSUB',
       'F' FROM DUAL
);

/*-- SEQ 10415 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'WUSU',
       TO_NUMBER(null),
       'WUSU',
       'Usurios(Temp.)',
       'TW_USU',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10416 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'WUSU','--','' FROM DUAL
);

/*-- SEQ 10417 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'WUSU',
       '--',
       5,
       10,
       'APEUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'APEUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'WUSU',
       '--',
       3,
       7,
       'ATU_EM',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       'Data~Atualizao',
       '',
       '',
       'ATU_EM',
       'F' FROM DUAL
UNION ALL
SELECT 'WUSU',
       '--',
       7,
       10,
       'CODEXT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODEXT',
       'F' FROM DUAL
UNION ALL
SELECT 'WUSU',
       '--',
       2,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'WUSU',
       '--',
       1,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'WUSU',
       '--',
       6,
       5,
       'NIVUSU',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NIVUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'WUSU',
       '--',
       4,
       30,
       'NOMUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NOMUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'WUSU',
       '--',
       8,
       12,
       'PERCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PERCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'WUSU',
       '--',
       11,
       100,
       'VISPER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VISPER',
       'F' FROM DUAL
UNION ALL
SELECT 'WUSU',
       '--',
       9,
       9,
       'VISSE1',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VISSE1',
       'F' FROM DUAL
UNION ALL
SELECT 'WUSU',
       '--',
       10,
       9,
       'VISSE2',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VISSE2',
       'F' FROM DUAL
);

/*-- SEQ 10418 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'WVEN',
       TO_NUMBER(null),
       'WVEN',
       'Vendas(Temp.)',
       'TW_VEN',
       'F',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '' FROM DUAL
);

/*-- SEQ 10419 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'WVEN','--','' FROM DUAL
);

/*-- SEQ 10420 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'WVEN',
       '--',
       25,
       1,
       'AUTENT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'AUTENT',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       55,
       12,
       'BASUBS',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'BASUBS',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       6,
       6,
       'CODCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       '',
       '',
       'CODCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       1,
       3,
       'CODFIL',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       54,
       5,
       'CODFIN',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODFIN',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       28,
       6,
       'CODGUI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODGUI',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       20,
       5,
       'CODNAT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODNAT',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       14,
       3,
       'CODPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       37,
       5,
       'CODPRE',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       3,
       2,
       'CODSER',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODSER',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       45,
       6,
       'CODTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       10,
       3,
       'CODUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       12,
       3,
       'CODVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CODVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       19,
       5,
       'COMSOB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'COMSOB',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       58,
       1,
       'CONSFI',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'CONSFI',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       7,
       7,
       'DATHOR',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATHOR',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       29,
       7,
       'DATSAI',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DATSAI',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       26,
       12,
       'DESCON',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'DESCON',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       43,
       1,
       'EMIDES',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'EMIDES',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       53,
       4,
       'ENDCOB',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ENDCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       51,
       4,
       'ENDENT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ENDENT',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       49,
       4,
       'ENDFAT',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ENDFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       22,
       5,
       'ESPECI',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'ESPECI',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       5,
       3,
       'FILCLI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       'N',
       'F',
       '',
       '',
       '',
       'FILCLI',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       52,
       3,
       'FILCOB',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILCOB',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       50,
       3,
       'FILENT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILENT',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       48,
       3,
       'FILFAT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILFAT',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       27,
       3,
       'FILGUI',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILGUI',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       13,
       3,
       'FILPGT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       41,
       3,
       'FILPRE',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILPRE',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       44,
       3,
       'FILTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       9,
       3,
       'FILUSU',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILUSU',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       11,
       3,
       'FILVEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FILVEN',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       39,
       1,
       'FINANC',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FINANC',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       8,
       1,
       'FLGEST',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FLGEST',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       62,
       1,
       'FLGTIP',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'FLGTIP',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       31,
       5,
       'MARCAS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'MARCAS',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       59,
       6,
       'NATFIS',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NATFIS',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       24,
       2,
       'NROIMP',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NROIMP',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       36,
       10,
       'NUMCON',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NUMCON',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       2,
       3,
       'NUMECF',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NUMECF',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       4,
       6,
       'NUMNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NUMNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       30,
       12,
       'NUMVOL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'NUMVOL',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       23,
       4000,
       'OBSERV',
       '4',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'RTF2TXT(WVEN.OBSERV)',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       17,
       12,
       'PERCOM',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PERCOM',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       18,
       12,
       'PERENT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PERENT',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       34,
       12,
       'PESBRU',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PESBRU',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       35,
       12,
       'PESLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PESLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       21,
       5,
       'PRAMED',
       'F',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PRAMED',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       42,
       7,
       'PROPGT',
       '@',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'PROPGT',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       57,
       12,
       'RETIDO',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'RETIDO',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       63,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       38,
       12,
       'SINAL',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SINAL',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       56,
       12,
       'SUBSTT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'SUBSTT',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       46,
       1,
       'TIPNOT',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       47,
       1,
       'TIPTRA',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TIPTRA',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       40,
       1,
       'TRIBUT',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'TRIBUT',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       61,
       1,
       'UFLOJA',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'UFLOJA',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       60,
       1,
       'VINCUL',
       'L',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       '',
       '',
       'F',
       '',
       '',
       '',
       'VINCUL',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       33,
       12,
       'VLRFRE',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       '',
       '',
       '',
       'VLRFRE',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       16,
       12,
       'VLRLIQ',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       '',
       '',
       '',
       'VLRLIQ',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       15,
       12,
       'VLRNOT',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       '',
       '',
       '',
       'VLRNOT',
       'F' FROM DUAL
UNION ALL
SELECT 'WVEN',
       '--',
       32,
       12,
       'VLRSEG',
       'F',
       '',
       2,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       '',
       '',
       'T',
       '',
       'F',
       '',
       '',
       '',
       'VLRSEG',
       'F' FROM DUAL
);

/*-- SEQ 10421 --*/
INSERT INTO TT_ARQ
(CODTAB,UNICO,CODFIS,NOMTAB,PATH,GERAL,FILBAS,APELID,DESCRI,PRIMAR,SECUN1,SECUN2,PALETA,FORMUL,OBSERV,ID_UNI,PARAME)
(
SELECT 'WXW ',
       TO_NUMBER(null),
       'WXW ',
       'WorkFlowXWorkFlow',
       'TT_WORXWOR',
       'T',
       '',
       'TOTALL',
       '',
       '',
       '',
       '',
       '',
       'T',
       '',
       'WXW.CODFIL,WXW.SEQUEN,WXW.FILWOR,WXW.SEQWOR',
       '' FROM DUAL
);

/*-- SEQ 10422 --*/
INSERT INTO TT_GRU
(CODTAB, CODGRU, DESGRU)
(
SELECT 'WXW ','--','' FROM DUAL
UNION ALL
SELECT 'WXW ','01','Identificao' FROM DUAL
UNION ALL
SELECT 'WXW ','99','Outros' FROM DUAL
);

/*-- SEQ 10423 --*/
INSERT INTO TT_LAY
(CODTAB,CODGRU,SEQUEN,TAMCPO,NOMCPO,TIPCPO,ARQLIS,NUMDEC,CODIGO,ORIGEM,OLDSEQ,NUMDOM,CLAFIL,DESLIS,TIPFIL,VELHO,TOTALIZADO,TIPDAD,NETDAT,NOMUSU,DESCPO,CODLIS,EXPRES,OUJOIN)
(
SELECT 'WXW ',
       '01',
       10,
       3,
       'CODFIL',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       'Filial',
       'Cdigo Filial',
       'DFIL.CODFIL = WXW.CODFIL',
       'CODFIL',
       'F' FROM DUAL
UNION ALL
SELECT 'WXW ',
       '01',
       20,
       3,
       'CONCLU',
       'S',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '',
       'F',
       'Concluso',
       'Concluso',
       '',
       'CONCLU',
       'F' FROM DUAL
UNION ALL
SELECT 'WXW ',
       '01',
       30,
       3,
       'FILWOR',
       'A',
       'DFIL',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       'DFIL.NOMFIL',
       'V',
       '',
       '',
       'N',
       'F',
       '',
       'Filial WorkFlow',
       'DFIL.CODFIL = WXW.FILWOR',
       'FILWOR',
       'F' FROM DUAL
UNION ALL
SELECT 'WXW ',
       '01',
       40,
       10,
       'SEQUEN',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador',
       '',
       'SEQUEN',
       'F' FROM DUAL
UNION ALL
SELECT 'WXW ',
       '01',
       50,
       10,
       'SEQWOR',
       'A',
       '',
       0,
       TO_NUMBER(null),
       '',
       TO_NUMBER(null),
       TO_NUMBER(null),
       '',
       '',
       'I',
       '',
       '',
       '9',
       'F',
       '',
       'Sequenciador WorkFlow',
       '',
       'SEQWOR',
       'F' FROM DUAL
);

/*-- SEQ 10424 --*/
ALTER TABLE tt_arq ADD CONSTRAINT fk_arq_arq FOREIGN KEY (codfis) REFERENCES tt_arq(codtab);

/*-- SEQ 10425 --*/
ALTER TABLE tt_lay ADD CONSTRAINT fk_lay_arq_origem FOREIGN KEY (origem) REFERENCES tt_arq(codtab);

/*-- SEQ 10426 --*/
ALTER TABLE tt_lay ADD CONSTRAINT fk_lay_arq_arqlis FOREIGN KEY (arqlis) REFERENCES tt_arq(codtab);

/*-- SEQ 10427 --*/
ALTER TABLE tt_sql ADD CONSTRAINT fk_sql_arq_coddes FOREIGN KEY (coddes) REFERENCES tt_arq(codtab) ON DELETE CASCADE;

/*-- SEQ 10428 --*/
ALTER TABLE tt_sql ADD CONSTRAINT fk_sql_arq_codori FOREIGN KEY (codori) REFERENCES tt_arq(codtab) ON DELETE CASCADE;

/*-- SEQ 10429 --*/
ALTER TABLE tp_lay ADD CONSTRAINT fk_play_arq FOREIGN KEY (codtab) REFERENCES tt_arq(codtab);

/*-- SEQ 10430 --*/
/*-- IGNORE ERRO --*/
DECLARE A VARCHAR(2); BEGIN A:=CARGAPERSONALIZADO; END; /

/*-- SEQ 10431 --*/
UPDATE TT_LAY SET NOMUSU = (SELECT CLASS1 FROM TT_CFG) WHERE NOMCPO = 'CLASS1' AND CODTAB <> 'CFG';

/*-- SEQ 10432 --*/
UPDATE TT_LAY SET NOMUSU = (SELECT CLASS2 FROM TT_CFG) WHERE NOMCPO = 'CLASS2' AND CODTAB <> 'CFG';

/*-- SEQ 10433 --*/
UPDATE TT_LAY SET NOMUSU = (SELECT CLASS3 FROM TT_CFG) WHERE NOMCPO = 'CLASS3' AND CODTAB <> 'CFG';

/*-- SEQ 10434 --*/
UPDATE TT_LAY SET NOMUSU = (SELECT CLASS4 FROM TT_CFG) WHERE NOMCPO = 'CLASS4' AND CODTAB <> 'CFG';

/*-- SEQ 10435 --*/
UPDATE TT_LAY SET NOMUSU = (SELECT CATEG1 FROM TT_CFG) WHERE NOMCPO = 'CATEG1' AND CODTAB <> 'CFG';

/*-- SEQ 10436 --*/
UPDATE TT_LAY SET NOMUSU = (SELECT CATEG2 FROM TT_CFG) WHERE NOMCPO = 'CATEG2' AND CODTAB <> 'CFG';

/*-- SEQ 10437 --*/
UPDATE TT_LAY SET NOMUSU = (SELECT CATEG3 FROM TT_CFG) WHERE NOMCPO = 'CATEG3' AND CODTAB <> 'CFG';

/*-- SEQ 10438 --*/
UPDATE TT_LAY SET NOMUSU = (SELECT DATA1 FROM TT_CFG) WHERE NOMCPO = 'DATA01' AND CODTAB <> 'CFG';

/*-- SEQ 10439 --*/
UPDATE TT_LAY SET NOMUSU = SUBSTR(TO_CHAR((SELECT DATA1 FROM TT_CFG)),0,14)||' (ms)' WHERE NOMCPO = 'MES_DATA01' AND CODTAB <> 'CFG';

/*-- SEQ 10440 --*/
UPDATE TT_LAY SET NOMUSU = SUBSTR(TO_CHAR((SELECT DATA1 FROM TT_CFG)),0,14)||' (ano)' WHERE NOMCPO = 'ANO_DATA01' AND CODTAB <> 'CFG';

/*-- SEQ 10441 --*/
UPDATE TT_LAY SET NOMUSU = (SELECT DATA2 FROM TT_CFG) WHERE NOMCPO = 'DATA02' AND CODTAB <> 'CFG';

/*-- SEQ 10442 --*/
UPDATE TT_LAY SET NOMUSU = SUBSTR(TO_CHAR((SELECT DATA2 FROM TT_CFG)),0,14)||' (ms)' WHERE NOMCPO = 'MES_DATA02' AND CODTAB <> 'CFG';

/*-- SEQ 10443 --*/
UPDATE TT_LAY SET NOMUSU = SUBSTR(TO_CHAR((SELECT DATA2 FROM TT_CFG)),0,14)||' (ano)' WHERE NOMCPO = 'ANO_DATA02' AND CODTAB <> 'CFG';

/*-- SEQ 10444 --*/
UPDATE TT_LAY SET NOMUSU = (SELECT DATA3 FROM TT_CFG) WHERE NOMCPO = 'DATA03' AND CODTAB <> 'CFG';

/*-- SEQ 10445 --*/
UPDATE TT_LAY SET NOMUSU = SUBSTR(TO_CHAR((SELECT DATA3 FROM TT_CFG)),0,14)||' (ms)' WHERE NOMCPO = 'MES_DATA03' AND CODTAB <> 'CFG';

/*-- SEQ 10446 --*/
UPDATE TT_LAY SET NOMUSU = SUBSTR(TO_CHAR((SELECT DATA3 FROM TT_CFG)),0,14)||' (ano)' WHERE NOMCPO = 'ANO_DATA03' AND CODTAB <> 'CFG';

/*-- SEQ 10447 --*/
/*-- IGNORE ERRO --*/
SELECT CARGAPERSONALIZADO() FROM DUAL;

/*-- SEQ 10448 --*/
UPDATE TT_IDF SET VERMET=TRUNC(VERMET)+1;
/*-- SEQ 10449 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_amb() CASCADE;

 /*-- SEQ 10450 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_amb() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_AMB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_AMB'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.ambati,NEW.ambati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_AMB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''AMBATI'', OLD.ambati, NEW.ambati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_AMB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desamb,NEW.desamb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_AMB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESAMB'', OLD.desamb, NEW.desamb, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10451 --*/
CREATE TRIGGER TG_LOG_td_amb
AFTER INSERT OR UPDATE OR DELETE ON td_amb
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_amb();

/*-- SEQ 10452 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_amp() CASCADE;

 /*-- SEQ 10453 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_amp() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_AMP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_AMP'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.ampati,NEW.ampati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_AMP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''AMPATI'', OLD.ampati, NEW.ampati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_AMP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.coramp,NEW.coramp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_AMP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CORAMP'', OLD.coramp, NEW.coramp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.divamp,NEW.divamp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_AMP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIVAMP'', OLD.divamp, NEW.divamp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.divtmp,NEW.divtmp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_AMP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIVTMP'', OLD.divtmp, NEW.divtmp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.phoalt,NEW.phoalt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_AMP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PHOALT'', OLD.phoalt, NEW.phoalt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.phocom,NEW.phocom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_AMP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PHOCOM'', OLD.phocom, NEW.phocom, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pholar,NEW.pholar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_AMP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PHOLAR'', OLD.pholar, NEW.pholar, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10454 --*/
CREATE TRIGGER TG_LOG_td_amp
AFTER INSERT OR UPDATE OR DELETE ON td_amp
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_amp();

/*-- SEQ 10455 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_apr() CASCADE;

 /*-- SEQ 10456 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_apr() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_APR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_APR'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.aprati,NEW.aprati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_APR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''APRATI'', OLD.aprati, NEW.aprati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.aprova,NEW.aprova) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_APR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''APROVA'', OLD.aprova, NEW.aprova, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_APR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desapr,NEW.desapr) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_APR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESAPR'', OLD.desapr, NEW.desapr, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10457 --*/
CREATE TRIGGER TG_LOG_td_apr
AFTER INSERT OR UPDATE OR DELETE ON td_apr
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_apr();

/*-- SEQ 10458 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_arc() CASCADE;

 /*-- SEQ 10459 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_arc() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_ARC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_ARC'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.arcatv,NEW.arcatv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ARC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ARCATV'', OLD.arcatv, NEW.arcatv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ARC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desarc,NEW.desarc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ARC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESARC'', OLD.desarc, NEW.desarc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tiparc,NEW.tiparc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ARC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPARC'', OLD.tiparc, NEW.tiparc, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10460 --*/
CREATE TRIGGER TG_LOG_td_arc
AFTER INSERT OR UPDATE OR DELETE ON td_arc
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_arc();

/*-- SEQ 10461 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_bco() CASCADE;

 /*-- SEQ 10462 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_bco() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_BCO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_BCO'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.abanco,NEW.abanco) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BCO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ABANCO'', OLD.abanco, NEW.abanco, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.bcoati,NEW.bcoati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BCO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''BCOATI'', OLD.bcoati, NEW.bcoati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cbanco,NEW.cbanco) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BCO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CBANCO'', OLD.cbanco, NEW.cbanco, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codbco,NEW.codbco) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BCO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODBCO'', OLD.codbco, NEW.codbco, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BCO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fbanco,NEW.fbanco) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BCO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FBANCO'', OLD.fbanco, NEW.fbanco, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filbco,NEW.filbco) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BCO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILBCO'', OLD.filbco, NEW.filbco, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nbanco,NEW.nbanco) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BCO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NBANCO'', OLD.nbanco, NEW.nbanco, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.prxrem,NEW.prxrem) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BCO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRXREM'', OLD.prxrem, NEW.prxrem, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vlrche,NEW.vlrche) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BCO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VLRCHE'', OLD.vlrche, NEW.vlrche, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10463 --*/
CREATE TRIGGER TG_LOG_td_bco
AFTER INSERT OR UPDATE OR DELETE ON td_bco
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_bco();

/*-- SEQ 10464 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_bic() CASCADE;

 /*-- SEQ 10465 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_bic() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_BIC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_BIC'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.assina,NEW.assina) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BIC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ASSINA'', OLD.assina, NEW.assina, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.bicatv,NEW.bicatv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BIC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''BICATV'', OLD.bicatv, NEW.bicatv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codbom,NEW.codbom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BIC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODBOM'', OLD.codbom, NEW.codbom, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BIC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtan,NEW.codtan) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BIC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAN'', OLD.codtan, NEW.codtan, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.coduid,NEW.coduid) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BIC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODUID'', OLD.coduid, NEW.coduid, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filbic,NEW.filbic) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BIC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILBIC'', OLD.filbic, NEW.filbic, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fillac,NEW.fillac) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BIC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILLAC'', OLD.fillac, NEW.fillac, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.maxche,NEW.maxche) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BIC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MAXCHE'', OLD.maxche, NEW.maxche, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nivpre,NEW.nivpre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BIC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NIVPRE'', OLD.nivpre, NEW.nivpre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.qtdenc,NEW.qtdenc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BIC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''QTDENC'', OLD.qtdenc, NEW.qtdenc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqbom,NEW.seqbom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BIC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQBOM'', OLD.seqbom, NEW.seqbom, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqfil,NEW.seqfil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BIC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQFIL'', OLD.seqfil, NEW.seqfil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqlac,NEW.seqlac) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BIC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQLAC'', OLD.seqlac, NEW.seqlac, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10466 --*/
CREATE TRIGGER TG_LOG_td_bic
AFTER INSERT OR UPDATE OR DELETE ON td_bic
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_bic();

/*-- SEQ 10467 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_bom() CASCADE;

 /*-- SEQ 10468 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_bom() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_BOM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_BOM'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.assina,NEW.assina) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BOM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ASSINA'', OLD.assina, NEW.assina, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.bomati,NEW.bomati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BOM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''BOMATI'', OLD.bomati, NEW.bomati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codfil,NEW.codfil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BOM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODFIL'', OLD.codfil, NEW.codfil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BOM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.coduid,NEW.coduid) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BOM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODUID'', OLD.coduid, NEW.coduid, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.modelo,NEW.modelo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BOM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MODELO'', OLD.modelo, NEW.modelo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nomfab,NEW.nomfab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BOM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NOMFAB'', OLD.nomfab, NEW.nomfab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nserie,NEW.nserie) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BOM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NSERIE'', OLD.nserie, NEW.nserie, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.numbom,NEW.numbom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BOM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NUMBOM'', OLD.numbom, NEW.numbom, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipmed,NEW.tipmed) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_BOM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPMED'', OLD.tipmed, NEW.tipmed, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10469 --*/
CREATE TRIGGER TG_LOG_td_bom
AFTER INSERT OR UPDATE OR DELETE ON td_bom
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_bom();

/*-- SEQ 10470 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_cai() CASCADE;

 /*-- SEQ 10471 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_cai() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CAI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CAI'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.caimen,NEW.caimen) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CAIMEN'', OLD.caimen, NEW.caimen, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ctacai,NEW.ctacai) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CTACAI'', OLD.ctacai, NEW.ctacai, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cx_ati,NEW.cx_ati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CX_ATI'', OLD.cx_ati, NEW.cx_ati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cx_cod,NEW.cx_cod) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CX_COD'', OLD.cx_cod, NEW.cx_cod, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cx_des,NEW.cx_des) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CX_DES'', OLD.cx_des, NEW.cx_des, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cx_his,NEW.cx_his) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CX_HIS'', OLD.cx_his, NEW.cx_his, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cx_max,NEW.cx_max) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CX_MAX'', OLD.cx_max, NEW.cx_max, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cx_usu,NEW.cx_usu) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CX_USU'', OLD.cx_usu, NEW.cx_usu, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filcai,NEW.filcai) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILCAI'', OLD.filcai, NEW.filcai, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqcai,NEW.seqcai) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQCAI'', OLD.seqcai, NEW.seqcai, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipcai,NEW.tipcai) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPCAI'', OLD.tipcai, NEW.tipcai, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.transf,NEW.transf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TRANSF'', OLD.transf, NEW.transf, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10472 --*/
CREATE TRIGGER TG_LOG_td_cai
AFTER INSERT OR UPDATE OR DELETE ON td_cai
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_cai();

/*-- SEQ 10473 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_car() CASCADE;

 /*-- SEQ 10474 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_car() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CAR'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.bancre,NEW.bancre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''BANCRE'', OLD.bancre, NEW.bancre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.bandeb,NEW.bandeb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''BANDEB'', OLD.bandeb, NEW.bandeb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.carati,NEW.carati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CARATI'', OLD.carati, NEW.carati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.carimg,NEW.carimg) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CARIMG'', OLD.carimg, NEW.carimg, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.carlet,NEW.carlet) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CARLET'', OLD.carlet, NEW.carlet, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.carlim,NEW.carlim) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CARLIM'', OLD.carlim, NEW.carlim, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.carniv,NEW.carniv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CARNIV'', OLD.carniv, NEW.carniv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cobcar,NEW.cobcar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COBCAR'', OLD.cobcar, NEW.cobcar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codadm,NEW.codadm) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODADM'', OLD.codadm, NEW.codadm, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codcre,NEW.codcre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODCRE'', OLD.codcre, NEW.codcre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ctacar,NEW.ctacar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CTACAR'', OLD.ctacar, NEW.ctacar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desout,NEW.desout) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESOUT'', OLD.desout, NEW.desout, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.diacar,NEW.diacar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIACAR'', OLD.diacar, NEW.diacar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.diadeb,NEW.diadeb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIADEB'', OLD.diadeb, NEW.diadeb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.extcre,NEW.extcre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXTCRE'', OLD.extcre, NEW.extcre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.extdeb,NEW.extdeb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXTDEB'', OLD.extdeb, NEW.extdeb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filadm,NEW.filadm) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILADM'', OLD.filadm, NEW.filadm, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filcar,NEW.filcar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILCAR'', OLD.filcar, NEW.filcar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.minaut,NEW.minaut) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MINAUT'', OLD.minaut, NEW.minaut, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.porcar,NEW.porcar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PORCAR'', OLD.porcar, NEW.porcar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.procar,NEW.procar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PROCAR'', OLD.procar, NEW.procar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.regcar,NEW.regcar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''REGCAR'', OLD.regcar, NEW.regcar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqcar,NEW.seqcar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQCAR'', OLD.seqcar, NEW.seqcar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.taxcar,NEW.taxcar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TAXCAR'', OLD.taxcar, NEW.taxcar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.taxdeb,NEW.taxdeb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TAXDEB'', OLD.taxdeb, NEW.taxdeb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipadm,NEW.tipadm) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPADM'', OLD.tipadm, NEW.tipadm, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipcar,NEW.tipcar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPCAR'', OLD.tipcar, NEW.tipcar, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10475 --*/
CREATE TRIGGER TG_LOG_td_car
AFTER INSERT OR UPDATE OR DELETE ON td_car
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_car();

/*-- SEQ 10476 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ccb() CASCADE;

 /*-- SEQ 10477 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ccb() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CCB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CCB'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.apeccb,NEW.apeccb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''APECCB'', OLD.apeccb, NEW.apeccb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ccbati,NEW.ccbati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CCBATI'', OLD.ccbati, NEW.ccbati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desccb,NEW.desccb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESCCB'', OLD.desccb, NEW.desccb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.envrem,NEW.envrem) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ENVREM'', OLD.envrem, NEW.envrem, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipccb,NEW.tipccb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPCCB'', OLD.tipccb, NEW.tipccb, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10478 --*/
CREATE TRIGGER TG_LOG_td_ccb
AFTER INSERT OR UPDATE OR DELETE ON td_ccb
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ccb();

/*-- SEQ 10479 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ccc() CASCADE;

 /*-- SEQ 10480 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ccc() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CCC'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.assccc,NEW.assccc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ASSCCC'', OLD.assccc, NEW.assccc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cccati,NEW.cccati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CCCATI'', OLD.cccati, NEW.cccati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ccccai,NEW.ccccai) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CCCCAI'', OLD.ccccai, NEW.ccccai, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cccimg,NEW.cccimg) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CCCIMG'', OLD.cccimg, NEW.cccimg, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ccclet,NEW.ccclet) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CCCLET'', OLD.ccclet, NEW.ccclet, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ccclim,NEW.ccclim) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CCCLIM'', OLD.ccclim, NEW.ccclim, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cccniv,NEW.cccniv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CCCNIV'', OLD.cccniv, NEW.cccniv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cliliv,NEW.cliliv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLILIV'', OLD.cliliv, NEW.cliliv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codext_dccc,NEW.codext_dccc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODEXT_DCCC'', OLD.codext_dccc, NEW.codext_dccc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.comccc,NEW.comccc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COMCCC'', OLD.comccc, NEW.comccc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ctaccc,NEW.ctaccc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CTACCC'', OLD.ctaccc, NEW.ctaccc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desccc,NEW.desccc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESCCC'', OLD.desccc, NEW.desccc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.diaret,NEW.diaret) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIARET'', OLD.diaret, NEW.diaret, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filccc,NEW.filccc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILCCC'', OLD.filccc, NEW.filccc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.regccc,NEW.regccc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''REGCCC'', OLD.regccc, NEW.regccc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqccc,NEW.seqccc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQCCC'', OLD.seqccc, NEW.seqccc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sqlccc,NEW.sqlccc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SQLCCC'', OLD.sqlccc, NEW.sqlccc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipccc,NEW.tipccc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPCCC'', OLD.tipccc, NEW.tipccc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.txtccc,NEW.txtccc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TXTCCC'', OLD.txtccc, NEW.txtccc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vlrbon,NEW.vlrbon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VLRBON'', OLD.vlrbon, NEW.vlrbon, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10481 --*/
CREATE TRIGGER TG_LOG_td_ccc
AFTER INSERT OR UPDATE OR DELETE ON td_ccc
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ccc();

/*-- SEQ 10482 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_cds() CASCADE;

 /*-- SEQ 10483 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_cds() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CDS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CDS'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.cdsati,NEW.cdsati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CDS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CDSATI'', OLD.cdsati, NEW.cdsati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codcds,NEW.codcds) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CDS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODCDS'', OLD.codcds, NEW.codcds, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CDS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.descds,NEW.descds) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CDS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESCDS'', OLD.descds, NEW.descds, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10484 --*/
CREATE TRIGGER TG_LOG_td_cds
AFTER INSERT OR UPDATE OR DELETE ON td_cds
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_cds();

/*-- SEQ 10485 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_cfo() CASCADE;

 /*-- SEQ 10486 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_cfo() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CFO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CFO'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.cfoati,NEW.cfoati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CFOATI'', OLD.cfoati, NEW.cfoati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cfocta_fil,NEW.cfocta_fil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CFOCTA_FIL'', OLD.cfocta_fil, NEW.cfocta_fil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cfocta_seq,NEW.cfocta_seq) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CFOCTA_SEQ'', OLD.cfocta_seq, NEW.cfocta_seq, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cfocta_tip,NEW.cfocta_tip) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CFOCTA_TIP'', OLD.cfocta_tip, NEW.cfocta_tip, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cfofor,NEW.cfofor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CFOFOR'', OLD.cfofor, NEW.cfofor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cfomod,NEW.cfomod) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CFOMOD'', OLD.cfomod, NEW.cfomod, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codcfo,NEW.codcfo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODCFO'', OLD.codcfo, NEW.codcfo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.descfo,NEW.descfo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESCFO'', OLD.descfo, NEW.descfo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.extcfo,NEW.extcfo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXTCFO'', OLD.extcfo, NEW.extcfo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.movest_dcfo,NEW.movest_dcfo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOVEST_DCFO'', OLD.movest_dcfo, NEW.movest_dcfo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipccm,NEW.tipccm) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPCCM'', OLD.tipccm, NEW.tipccm, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10487 --*/
CREATE TRIGGER TG_LOG_td_cfo
AFTER INSERT OR UPDATE OR DELETE ON td_cfo
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_cfo();

/*-- SEQ 10488 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_cfp() CASCADE;

 /*-- SEQ 10489 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_cfp() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CFP'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.cfpati,NEW.cfpati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CFPATI'', OLD.cfpati, NEW.cfpati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.comcon,NEW.comcon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COMCON'', OLD.comcon, NEW.comcon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.comcon_for,NEW.comcon_for) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COMCON_FOR'', OLD.comcon_for, NEW.comcon_for, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.comrev,NEW.comrev) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COMREV'', OLD.comrev, NEW.comrev, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.comrev_for,NEW.comrev_for) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COMREV_FOR'', OLD.comrev_for, NEW.comrev_for, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.descfp,NEW.descfp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESCFP'', OLD.descfp, NEW.descfp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.devcon,NEW.devcon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DEVCON'', OLD.devcon, NEW.devcon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.devcon_for,NEW.devcon_for) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DEVCON_FOR'', OLD.devcon_for, NEW.devcon_for, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.devrev,NEW.devrev) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DEVREV'', OLD.devrev, NEW.devrev, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.devrev_for,NEW.devrev_for) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DEVREV_FOR'', OLD.devrev_for, NEW.devrev_for, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dvccon,NEW.dvccon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DVCCON'', OLD.dvccon, NEW.dvccon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dvccon_for,NEW.dvccon_for) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DVCCON_FOR'', OLD.dvccon_for, NEW.dvccon_for, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dvcrev,NEW.dvcrev) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DVCREV'', OLD.dvcrev, NEW.dvcrev, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dvcrev_for,NEW.dvcrev_for) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DVCREV_FOR'', OLD.dvcrev_for, NEW.dvcrev_for, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.entcon,NEW.entcon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ENTCON'', OLD.entcon, NEW.entcon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.entcon_for,NEW.entcon_for) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ENTCON_FOR'', OLD.entcon_for, NEW.entcon_for, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.entrev,NEW.entrev) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ENTREV'', OLD.entrev, NEW.entrev, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.entrev_for,NEW.entrev_for) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ENTREV_FOR'', OLD.entrev_for, NEW.entrev_for, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.intcon,NEW.intcon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INTCON'', OLD.intcon, NEW.intcon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.intcon_for,NEW.intcon_for) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INTCON_FOR'', OLD.intcon_for, NEW.intcon_for, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.intrev,NEW.intrev) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INTREV'', OLD.intrev, NEW.intrev, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.intrev_for,NEW.intrev_for) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INTREV_FOR'', OLD.intrev_for, NEW.intrev_for, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.saicon,NEW.saicon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAICON'', OLD.saicon, NEW.saicon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.saicon_for,NEW.saicon_for) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAICON_FOR'', OLD.saicon_for, NEW.saicon_for, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sairev,NEW.sairev) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAIREV'', OLD.sairev, NEW.sairev, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sairev_for,NEW.sairev_for) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAIREV_FOR'', OLD.sairev_for, NEW.sairev_for, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vencon,NEW.vencon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VENCON'', OLD.vencon, NEW.vencon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vencon_for,NEW.vencon_for) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VENCON_FOR'', OLD.vencon_for, NEW.vencon_for, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.venrev,NEW.venrev) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VENREV'', OLD.venrev, NEW.venrev, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.venrev_for,NEW.venrev_for) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CFP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VENREV_FOR'', OLD.venrev_for, NEW.venrev_for, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10490 --*/
CREATE TRIGGER TG_LOG_td_cfp
AFTER INSERT OR UPDATE OR DELETE ON td_cfp
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_cfp();

/*-- SEQ 10491 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_cl1() CASCADE;

 /*-- SEQ 10492 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_cl1() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CL1'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CL1'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.cl1ati,NEW.cl1ati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CL1'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CL1ATI'', OLD.cl1ati, NEW.cl1ati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cl1web,NEW.cl1web) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CL1'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CL1WEB'', OLD.cl1web, NEW.cl1web, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.class1,NEW.class1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CL1'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLASS1'', OLD.class1, NEW.class1, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codex1,NEW.codex1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CL1'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODEX1'', OLD.codex1, NEW.codex1, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CL1'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.combus,NEW.combus) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CL1'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COMBUS'', OLD.combus, NEW.combus, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natcl1,NEW.natcl1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CL1'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATCL1'', OLD.natcl1, NEW.natcl1, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10493 --*/
CREATE TRIGGER TG_LOG_td_cl1
AFTER INSERT OR UPDATE OR DELETE ON td_cl1
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_cl1();

/*-- SEQ 10494 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_cl2() CASCADE;

 /*-- SEQ 10495 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_cl2() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CL2'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CL2'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.cl2ati,NEW.cl2ati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CL2'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CL2ATI'', OLD.cl2ati, NEW.cl2ati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cl2web,NEW.cl2web) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CL2'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CL2WEB'', OLD.cl2web, NEW.cl2web, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.class2,NEW.class2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CL2'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLASS2'', OLD.class2, NEW.class2, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codex2,NEW.codex2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CL2'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODEX2'', OLD.codex2, NEW.codex2, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CL2'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10496 --*/
CREATE TRIGGER TG_LOG_td_cl2
AFTER INSERT OR UPDATE OR DELETE ON td_cl2
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_cl2();

/*-- SEQ 10497 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_cl3() CASCADE;

 /*-- SEQ 10498 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_cl3() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CL3'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CL3'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.cl3ati,NEW.cl3ati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CL3'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CL3ATI'', OLD.cl3ati, NEW.cl3ati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cl3web,NEW.cl3web) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CL3'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CL3WEB'', OLD.cl3web, NEW.cl3web, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.class3,NEW.class3) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CL3'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLASS3'', OLD.class3, NEW.class3, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codex3,NEW.codex3) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CL3'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODEX3'', OLD.codex3, NEW.codex3, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CL3'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10499 --*/
CREATE TRIGGER TG_LOG_td_cl3
AFTER INSERT OR UPDATE OR DELETE ON td_cl3
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_cl3();

/*-- SEQ 10500 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_cl4() CASCADE;

 /*-- SEQ 10501 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_cl4() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CL4'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CL4'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.cl4ati,NEW.cl4ati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CL4'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CL4ATI'', OLD.cl4ati, NEW.cl4ati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cl4web,NEW.cl4web) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CL4'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CL4WEB'', OLD.cl4web, NEW.cl4web, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.class4,NEW.class4) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CL4'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLASS4'', OLD.class4, NEW.class4, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codex4,NEW.codex4) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CL4'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODEX4'', OLD.codex4, NEW.codex4, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CL4'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10502 --*/
CREATE TRIGGER TG_LOG_td_cl4
AFTER INSERT OR UPDATE OR DELETE ON td_cl4
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_cl4();

/*-- SEQ 10503 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_clt() CASCADE;

 /*-- SEQ 10504 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_clt() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CLT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CLT'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.cltatv,NEW.cltatv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CLT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLTATV'', OLD.cltatv, NEW.cltatv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CLT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desclt,NEW.desclt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CLT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESCLT'', OLD.desclt, NEW.desclt, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10505 --*/
CREATE TRIGGER TG_LOG_td_clt
AFTER INSERT OR UPDATE OR DELETE ON td_clt
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_clt();

/*-- SEQ 10506 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_cnc() CASCADE;

 /*-- SEQ 10507 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_cnc() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CNC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CNC'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.cncati,NEW.cncati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CNC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CNCATI'', OLD.cncati, NEW.cncati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CNC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nomcnc,NEW.nomcnc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CNC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NOMCNC'', OLD.nomcnc, NEW.nomcnc, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10508 --*/
CREATE TRIGGER TG_LOG_td_cnc
AFTER INSERT OR UPDATE OR DELETE ON td_cnc
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_cnc();

/*-- SEQ 10509 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_cob() CASCADE;

 /*-- SEQ 10510 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_cob() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_COB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_COB'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.cobati,NEW.cobati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COBATI'', OLD.cobati, NEW.cobati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cobimg,NEW.cobimg) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COBIMG'', OLD.cobimg, NEW.cobimg, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.coblet,NEW.coblet) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COBLET'', OLD.coblet, NEW.coblet, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cobniv,NEW.cobniv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COBNIV'', OLD.cobniv, NEW.cobniv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cobpad,NEW.cobpad) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COBPAD'', OLD.cobpad, NEW.cobpad, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codccb,NEW.codccb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODCCB'', OLD.codccb, NEW.codccb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codext_dcob,NEW.codext_dcob) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODEXT_DCOB'', OLD.codext_dcob, NEW.codext_dcob, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.descob,NEW.descob) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESCOB'', OLD.descob, NEW.descob, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filcta,NEW.filcta) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILCTA'', OLD.filcta, NEW.filcta, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.gertit,NEW.gertit) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''GERTIT'', OLD.gertit, NEW.gertit, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.laruni,NEW.laruni) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LARUNI'', OLD.laruni, NEW.laruni, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.saicar,NEW.saicar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAICAR'', OLD.saicar, NEW.saicar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqcta,NEW.seqcta) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQCTA'', OLD.seqcta, NEW.seqcta, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipcob,NEW.tipcob) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPCOB'', OLD.tipcob, NEW.tipcob, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipcta,NEW.tipcta) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPCTA'', OLD.tipcta, NEW.tipcta, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipctb,NEW.tipctb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPCTB'', OLD.tipctb, NEW.tipctb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.txtcob,NEW.txtcob) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TXTCOB'', OLD.txtcob, NEW.txtcob, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vlrabl,NEW.vlrabl) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VLRABL'', OLD.vlrabl, NEW.vlrabl, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vlrmbl,NEW.vlrmbl) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VLRMBL'', OLD.vlrmbl, NEW.vlrmbl, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10511 --*/
CREATE TRIGGER TG_LOG_td_cob
AFTER INSERT OR UPDATE OR DELETE ON td_cob
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_cob();

/*-- SEQ 10512 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_col() CASCADE;

 /*-- SEQ 10513 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_col() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_COL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_COL'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.colati,NEW.colati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COLATI'', OLD.colati, NEW.colati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.colqtd,NEW.colqtd) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COLQTD'', OLD.colqtd, NEW.colqtd, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.colref,NEW.colref) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COLREF'', OLD.colref, NEW.colref, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.delimi,NEW.delimi) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DELIMI'', OLD.delimi, NEW.delimi, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fimqtd,NEW.fimqtd) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FIMQTD'', OLD.fimqtd, NEW.fimqtd, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fimref,NEW.fimref) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FIMREF'', OLD.fimref, NEW.fimref, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.footer,NEW.footer) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FOOTER'', OLD.footer, NEW.footer, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.header,NEW.header) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HEADER'', OLD.header, NEW.header, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.iniqtd,NEW.iniqtd) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INIQTD'', OLD.iniqtd, NEW.iniqtd, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.iniref,NEW.iniref) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INIREF'', OLD.iniref, NEW.iniref, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nomcol,NEW.nomcol) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NOMCOL'', OLD.nomcol, NEW.nomcol, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.qtddec,NEW.qtddec) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''QTDDEC'', OLD.qtddec, NEW.qtddec, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sepdec,NEW.sepdec) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEPDEC'', OLD.sepdec, NEW.sepdec, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.zeresq,NEW.zeresq) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ZERESQ'', OLD.zeresq, NEW.zeresq, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10514 --*/
CREATE TRIGGER TG_LOG_td_col
AFTER INSERT OR UPDATE OR DELETE ON td_col
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_col();

/*-- SEQ 10515 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_com() CASCADE;

 /*-- SEQ 10516 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_com() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_COM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_COM'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.cabcom,NEW.cabcom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CABCOM'', OLD.cabcom, NEW.cabcom, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.comati,NEW.comati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COMATI'', OLD.comati, NEW.comati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.descom,NEW.descom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESCOM'', OLD.descom, NEW.descom, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.itecom,NEW.itecom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ITECOM'', OLD.itecom, NEW.itecom, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.numcom,NEW.numcom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NUMCOM'', OLD.numcom, NEW.numcom, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.rodcom,NEW.rodcom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RODCOM'', OLD.rodcom, NEW.rodcom, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10517 --*/
CREATE TRIGGER TG_LOG_td_com
AFTER INSERT OR UPDATE OR DELETE ON td_com
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_com();

/*-- SEQ 10518 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_con() CASCADE;

 /*-- SEQ 10519 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_con() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CON'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CON'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.clacon,NEW.clacon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CON'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLACON'', OLD.clacon, NEW.clacon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CON'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.conati,NEW.conati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CON'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CONATI'', OLD.conati, NEW.conati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.descon,NEW.descon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CON'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESCON'', OLD.descon, NEW.descon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipcon,NEW.tipcon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CON'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPCON'', OLD.tipcon, NEW.tipcon, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10520 --*/
CREATE TRIGGER TG_LOG_td_con
AFTER INSERT OR UPDATE OR DELETE ON td_con
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_con();

/*-- SEQ 10521 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_cor() CASCADE;

 /*-- SEQ 10522 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_cor() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_COR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_COR'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.coratv,NEW.coratv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CORATV'', OLD.coratv, NEW.coratv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.rb_cor,NEW.rb_cor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RB_COR'', OLD.rb_cor, NEW.rb_cor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.titcor,NEW.titcor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_COR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TITCOR'', OLD.titcor, NEW.titcor, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10523 --*/
CREATE TRIGGER TG_LOG_td_cor
AFTER INSERT OR UPDATE OR DELETE ON td_cor
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_cor();

/*-- SEQ 10524 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_corvei() CASCADE;

 /*-- SEQ 10525 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_corvei() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CORVEI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CORVEI'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codcorden,NEW.codcorden) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CORVEI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODCORDEN'', OLD.codcorden, NEW.codcorden, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CORVEI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.corveiati,NEW.corveiati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CORVEI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CORVEIATI'', OLD.corveiati, NEW.corveiati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.descorvei,NEW.descorvei) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CORVEI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESCORVEI'', OLD.descorvei, NEW.descorvei, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10526 --*/
CREATE TRIGGER TG_LOG_td_corvei
AFTER INSERT OR UPDATE OR DELETE ON td_corvei
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_corvei();

/*-- SEQ 10527 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_crt() CASCADE;

 /*-- SEQ 10528 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_crt() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CRT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CRT'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.coddet,NEW.coddet) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CRT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODDET'', OLD.coddet, NEW.coddet, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CRT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.deccrt,NEW.deccrt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CRT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DECCRT'', OLD.deccrt, NEW.deccrt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.descrt,NEW.descrt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CRT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESCRT'', OLD.descrt, NEW.descrt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.maxcrt,NEW.maxcrt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CRT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MAXCRT'', OLD.maxcrt, NEW.maxcrt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mincrt,NEW.mincrt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CRT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MINCRT'', OLD.mincrt, NEW.mincrt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nn_crt,NEW.nn_crt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CRT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NN_CRT'', OLD.nn_crt, NEW.nn_crt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ordcrt,NEW.ordcrt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CRT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ORDCRT'', OLD.ordcrt, NEW.ordcrt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipcrt,NEW.tipcrt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CRT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPCRT'', OLD.tipcrt, NEW.tipcrt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usodet,NEW.usodet) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CRT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USODET'', OLD.usodet, NEW.usodet, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10529 --*/
CREATE TRIGGER TG_LOG_td_crt
AFTER INSERT OR UPDATE OR DELETE ON td_crt
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_crt();

/*-- SEQ 10530 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ct1() CASCADE;

 /*-- SEQ 10531 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ct1() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CT1'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CT1'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codext_dct1,NEW.codext_dct1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CT1'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODEXT_DCT1'', OLD.codext_dct1, NEW.codext_dct1, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CT1'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ct1ati,NEW.ct1ati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CT1'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CT1ATI'', OLD.ct1ati, NEW.ct1ati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nomct1,NEW.nomct1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CT1'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NOMCT1'', OLD.nomct1, NEW.nomct1, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10532 --*/
CREATE TRIGGER TG_LOG_td_ct1
AFTER INSERT OR UPDATE OR DELETE ON td_ct1
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ct1();

/*-- SEQ 10533 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ct2() CASCADE;

 /*-- SEQ 10534 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ct2() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CT2'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CT2'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codext_dct2,NEW.codext_dct2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CT2'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODEXT_DCT2'', OLD.codext_dct2, NEW.codext_dct2, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CT2'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ct2ati,NEW.ct2ati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CT2'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CT2ATI'', OLD.ct2ati, NEW.ct2ati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nomct2,NEW.nomct2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CT2'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NOMCT2'', OLD.nomct2, NEW.nomct2, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10535 --*/
CREATE TRIGGER TG_LOG_td_ct2
AFTER INSERT OR UPDATE OR DELETE ON td_ct2
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ct2();

/*-- SEQ 10536 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ct3() CASCADE;

 /*-- SEQ 10537 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ct3() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CT3'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CT3'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codext_dct3,NEW.codext_dct3) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CT3'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODEXT_DCT3'', OLD.codext_dct3, NEW.codext_dct3, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CT3'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ct3ati,NEW.ct3ati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CT3'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CT3ATI'', OLD.ct3ati, NEW.ct3ati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nomct3,NEW.nomct3) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CT3'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NOMCT3'', OLD.nomct3, NEW.nomct3, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10538 --*/
CREATE TRIGGER TG_LOG_td_ct3
AFTER INSERT OR UPDATE OR DELETE ON td_ct3
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ct3();

/*-- SEQ 10539 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_cta() CASCADE;

 /*-- SEQ 10540 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_cta() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CTA'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CTA'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.cfgcol,NEW.cfgcol) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTA'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CFGCOL'', OLD.cfgcol, NEW.cfgcol, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTA'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.descta,NEW.descta) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTA'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESCTA'', OLD.descta, NEW.descta, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dummy,NEW.dummy) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTA'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DUMMY'', OLD.dummy, NEW.dummy, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filcta,NEW.filcta) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTA'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILCTA'', OLD.filcta, NEW.filcta, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqcta,NEW.seqcta) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTA'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQCTA'', OLD.seqcta, NEW.seqcta, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipcta,NEW.tipcta) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTA'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPCTA'', OLD.tipcta, NEW.tipcta, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usocta,NEW.usocta) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTA'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USOCTA'', OLD.usocta, NEW.usocta, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10541 --*/
CREATE TRIGGER TG_LOG_td_cta
AFTER INSERT OR UPDATE OR DELETE ON td_cta
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_cta();

/*-- SEQ 10542 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ctr() CASCADE;

 /*-- SEQ 10543 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ctr() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CTR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CTR'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codext,NEW.codext) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODEXT'', OLD.codext, NEW.codext, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ctrati,NEW.ctrati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CTRATI'', OLD.ctrati, NEW.ctrati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ctrest_fil,NEW.ctrest_fil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CTREST_FIL'', OLD.ctrest_fil, NEW.ctrest_fil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ctrest_seq,NEW.ctrest_seq) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CTREST_SEQ'', OLD.ctrest_seq, NEW.ctrest_seq, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ctrest_tip,NEW.ctrest_tip) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CTREST_TIP'', OLD.ctrest_tip, NEW.ctrest_tip, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ctrfil,NEW.ctrfil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CTRFIL'', OLD.ctrfil, NEW.ctrfil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ctrseq,NEW.ctrseq) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CTRSEQ'', OLD.ctrseq, NEW.ctrseq, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ctrtip,NEW.ctrtip) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CTRTIP'', OLD.ctrtip, NEW.ctrtip, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ctruso,NEW.ctruso) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CTRUSO'', OLD.ctruso, NEW.ctruso, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desctr,NEW.desctr) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESCTR'', OLD.desctr, NEW.desctr, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filpra,NEW.filpra) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILPRA'', OLD.filpra, NEW.filpra, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.patped,NEW.patped) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PATPED'', OLD.patped, NEW.patped, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqpra,NEW.seqpra) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQPRA'', OLD.seqpra, NEW.seqpra, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tippra,NEW.tippra) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CTR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPPRA'', OLD.tippra, NEW.tippra, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10544 --*/
CREATE TRIGGER TG_LOG_td_ctr
AFTER INSERT OR UPDATE OR DELETE ON td_ctr
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ctr();

/*-- SEQ 10545 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_cus() CASCADE;

 /*-- SEQ 10546 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_cus() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CUS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CUS'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.cencus,NEW.cencus) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CUS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CENCUS'', OLD.cencus, NEW.cencus, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CUS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cusati,NEW.cusati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CUS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CUSATI'', OLD.cusati, NEW.cusati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.extcus,NEW.extcus) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CUS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXTCUS'', OLD.extcus, NEW.extcus, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10547 --*/
CREATE TRIGGER TG_LOG_td_cus
AFTER INSERT OR UPDATE OR DELETE ON td_cus
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_cus();

/*-- SEQ 10548 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_cws() CASCADE;

 /*-- SEQ 10549 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_cws() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CWS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_CWS'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CWS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cwsati,NEW.cwsati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CWS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CWSATI'', OLD.cwsati, NEW.cwsati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.descws,NEW.descws) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CWS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESCWS'', OLD.descws, NEW.descws, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.horcws,NEW.horcws) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CWS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HORCWS'', OLD.horcws, NEW.horcws, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.oricws,NEW.oricws) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CWS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ORICWS'', OLD.oricws, NEW.oricws, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pedaut,NEW.pedaut) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CWS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PEDAUT'', OLD.pedaut, NEW.pedaut, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipcws,NEW.tipcws) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CWS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPCWS'', OLD.tipcws, NEW.tipcws, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipwor,NEW.tipwor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_CWS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPWOR'', OLD.tipwor, NEW.tipwor, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10550 --*/
CREATE TRIGGER TG_LOG_td_cws
AFTER INSERT OR UPDATE OR DELETE ON td_cws
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_cws();

/*-- SEQ 10551 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_dep() CASCADE;

 /*-- SEQ 10552 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_dep() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_DEP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_DEP'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codpos_ddep,NEW.codpos_ddep) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODPOS_DDEP'', OLD.codpos_ddep, NEW.codpos_ddep, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.contab,NEW.contab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CONTAB'', OLD.contab, NEW.contab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.depati,NEW.depati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DEPATI'', OLD.depati, NEW.depati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.depweb,NEW.depweb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DEPWEB'', OLD.depweb, NEW.depweb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desdep,NEW.desdep) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESDEP'', OLD.desdep, NEW.desdep, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.imgdep,NEW.imgdep) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IMGDEP'', OLD.imgdep, NEW.imgdep, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pesprefor,NEW.pesprefor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PESPREFOR'', OLD.pesprefor, NEW.pesprefor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pespreven,NEW.pespreven) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PESPREVEN'', OLD.pespreven, NEW.pespreven, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pesprzent,NEW.pesprzent) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PESPRZENT'', OLD.pesprzent, NEW.pesprzent, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.taxjurmes,NEW.taxjurmes) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TAXJURMES'', OLD.taxjurmes, NEW.taxjurmes, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10553 --*/
CREATE TRIGGER TG_LOG_td_dep
AFTER INSERT OR UPDATE OR DELETE ON td_dep
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_dep();

/*-- SEQ 10554 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_des() CASCADE;

 /*-- SEQ 10555 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_des() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_DES'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_DES'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DES'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desatv,NEW.desatv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DES'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESATV'', OLD.desatv, NEW.desatv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipdes,NEW.tipdes) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DES'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPDES'', OLD.tipdes, NEW.tipdes, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10556 --*/
CREATE TRIGGER TG_LOG_td_des
AFTER INSERT OR UPDATE OR DELETE ON td_des
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_des();

/*-- SEQ 10557 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_det() CASCADE;

 /*-- SEQ 10558 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_det() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_DET'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_DET'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DET'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desdet,NEW.desdet) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DET'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESDET'', OLD.desdet, NEW.desdet, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.orddet,NEW.orddet) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DET'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ORDDET'', OLD.orddet, NEW.orddet, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.paidet,NEW.paidet) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DET'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAIDET'', OLD.paidet, NEW.paidet, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usodet,NEW.usodet) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DET'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USODET'', OLD.usodet, NEW.usodet, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10559 --*/
CREATE TRIGGER TG_LOG_td_det
AFTER INSERT OR UPDATE OR DELETE ON td_det
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_det();

/*-- SEQ 10560 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_dev() CASCADE;

 /*-- SEQ 10561 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_dev() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_DEV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_DEV'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.clidev,NEW.clidev) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLIDEV'', OLD.clidev, NEW.clidev, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codext,NEW.codext) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODEXT'', OLD.codext, NEW.codext, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desdev,NEW.desdev) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESDEV'', OLD.desdev, NEW.desdev, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.devate,NEW.devate) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DEVATE'', OLD.devate, NEW.devate, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.devati,NEW.devati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DEVATI'', OLD.devati, NEW.devati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.devcom,NEW.devcom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DEVCOM'', OLD.devcom, NEW.devcom, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.devicm,NEW.devicm) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DEVICM'', OLD.devicm, NEW.devicm, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.devmon,NEW.devmon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DEVMON'', OLD.devmon, NEW.devmon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.muldev,NEW.muldev) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MULDEV'', OLD.muldev, NEW.muldev, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usodev,NEW.usodev) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USODEV'', OLD.usodev, NEW.usodev, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vlrdev,NEW.vlrdev) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DEV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VLRDEV'', OLD.vlrdev, NEW.vlrdev, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10562 --*/
CREATE TRIGGER TG_LOG_td_dev
AFTER INSERT OR UPDATE OR DELETE ON td_dev
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_dev();

/*-- SEQ 10563 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_dfc() CASCADE;

 /*-- SEQ 10564 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_dfc() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_DFC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_DFC'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.coddfc,NEW.coddfc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DFC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODDFC'', OLD.coddfc, NEW.coddfc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DFC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desdfc,NEW.desdfc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DFC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESDFC'', OLD.desdfc, NEW.desdfc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dfcati,NEW.dfcati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DFC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DFCATI'', OLD.dfcati, NEW.dfcati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10565 --*/
CREATE TRIGGER TG_LOG_td_dfc
AFTER INSERT OR UPDATE OR DELETE ON td_dfc
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_dfc();

/*-- SEQ 10566 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_div() CASCADE;

 /*-- SEQ 10567 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_div() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_DIV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_DIV'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codext,NEW.codext) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DIV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODEXT'', OLD.codext, NEW.codext, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DIV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.divati,NEW.divati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DIV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIVATI'', OLD.divati, NEW.divati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nomdiv,NEW.nomdiv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DIV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NOMDIV'', OLD.nomdiv, NEW.nomdiv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.orddiv,NEW.orddiv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DIV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ORDDIV'', OLD.orddiv, NEW.orddiv, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10568 --*/
CREATE TRIGGER TG_LOG_td_div
AFTER INSERT OR UPDATE OR DELETE ON td_div
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_div();

/*-- SEQ 10569 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_doc() CASCADE;

 /*-- SEQ 10570 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_doc() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_DOC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_DOC'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DOC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desdoc,NEW.desdoc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DOC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESDOC'', OLD.desdoc, NEW.desdoc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.docatv,NEW.docatv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DOC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DOCATV'', OLD.docatv, NEW.docatv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipdoc,NEW.tipdoc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DOC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPDOC'', OLD.tipdoc, NEW.tipdoc, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10571 --*/
CREATE TRIGGER TG_LOG_td_doc
AFTER INSERT OR UPDATE OR DELETE ON td_doc
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_doc();

/*-- SEQ 10572 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_dop() CASCADE;

 /*-- SEQ 10573 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_dop() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_DOP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_DOP'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DOP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desdop,NEW.desdop) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DOP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESDOP'', OLD.desdop, NEW.desdop, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dopati,NEW.dopati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DOP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DOPATI'', OLD.dopati, NEW.dopati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.modpgt,NEW.modpgt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DOP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MODPGT'', OLD.modpgt, NEW.modpgt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tiptit,NEW.tiptit) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DOP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPTIT'', OLD.tiptit, NEW.tiptit, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10574 --*/
CREATE TRIGGER TG_LOG_td_dop
AFTER INSERT OR UPDATE OR DELETE ON td_dop
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_dop();

/*-- SEQ 10575 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_dup() CASCADE;

 /*-- SEQ 10576 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_dup() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_DUP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_DUP'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_DUP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10577 --*/
CREATE TRIGGER TG_LOG_td_dup
AFTER INSERT OR UPDATE OR DELETE ON td_dup
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_dup();

/*-- SEQ 10578 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ean() CASCADE;

 /*-- SEQ 10579 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ean() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_EAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_EAN'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desean,NEW.desean) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESEAN'', OLD.desean, NEW.desean, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.eanati,NEW.eanati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EANATI'', OLD.eanati, NEW.eanati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.eancod,NEW.eancod) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EANCOD'', OLD.eancod, NEW.eancod, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.eanfil,NEW.eanfil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EANFIL'', OLD.eanfil, NEW.eanfil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usaven,NEW.usaven) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USAVEN'', OLD.usaven, NEW.usaven, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10580 --*/
CREATE TRIGGER TG_LOG_td_ean
AFTER INSERT OR UPDATE OR DELETE ON td_ean
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ean();

/*-- SEQ 10581 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ecb() CASCADE;

 /*-- SEQ 10582 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ecb() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_ECB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_ECB'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desecb,NEW.desecb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESECB'', OLD.desecb, NEW.desecb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ecbati,NEW.ecbati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ECBATI'', OLD.ecbati, NEW.ecbati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10583 --*/
CREATE TRIGGER TG_LOG_td_ecb
AFTER INSERT OR UPDATE OR DELETE ON td_ecb
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ecb();

/*-- SEQ 10584 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ecf() CASCADE;

 /*-- SEQ 10585 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ecf() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_ECF'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.arrtru,NEW.arrtru) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ARRTRU'', OLD.arrtru, NEW.arrtru, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.assina,NEW.assina) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ASSINA'', OLD.assina, NEW.assina, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_acaopadrao,NEW.ck4g_acaopadrao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_ACAOPADRAO'', OLD.ck4g_acaopadrao, NEW.ck4g_acaopadrao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_barrasaltura,NEW.ck4g_barrasaltura) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_BARRASALTURA'', OLD.ck4g_barrasaltura, NEW.ck4g_barrasaltura, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_barraslargura,NEW.ck4g_barraslargura) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_BARRASLARGURA'', OLD.ck4g_barraslargura, NEW.ck4g_barraslargura, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_barraspadrao,NEW.ck4g_barraspadrao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_BARRASPADRAO'', OLD.ck4g_barraspadrao, NEW.ck4g_barraspadrao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_detver,NEW.ck4g_detver) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_DETVER'', OLD.ck4g_detver, NEW.ck4g_detver, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_homol,NEW.ck4g_homol) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_HOMOL'', OLD.ck4g_homol, NEW.ck4g_homol, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_intervalocargadesaldos,NEW.ck4g_intervalocargadesaldos) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_INTERVALOCARGADESALDOS'', OLD.ck4g_intervalocargadesaldos, NEW.ck4g_intervalocargadesaldos, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_manlog_det,NEW.ck4g_manlog_det) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_MANLOG_DET'', OLD.ck4g_manlog_det, NEW.ck4g_manlog_det, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_manlog_ger,NEW.ck4g_manlog_ger) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_MANLOG_GER'', OLD.ck4g_manlog_ger, NEW.ck4g_manlog_ger, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_manmov,NEW.ck4g_manmov) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_MANMOV'', OLD.ck4g_manmov, NEW.ck4g_manmov, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_md5,NEW.ck4g_md5) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_MD5'', OLD.ck4g_md5, NEW.ck4g_md5, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_modfis_vc,NEW.ck4g_modfis_vc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_MODFIS_VC'', OLD.ck4g_modfis_vc, NEW.ck4g_modfis_vc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_modfis_vc_cont,NEW.ck4g_modfis_vc_cont) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_MODFIS_VC_CONT'', OLD.ck4g_modfis_vc_cont, NEW.ck4g_modfis_vc_cont, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_releas_homol,NEW.ck4g_releas_homol) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_RELEAS_HOMOL'', OLD.ck4g_releas_homol, NEW.ck4g_releas_homol, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_usa_cont_offline,NEW.ck4g_usa_cont_offline) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_USA_CONT_OFFLINE'', OLD.ck4g_usa_cont_offline, NEW.ck4g_usa_cont_offline, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_usafrete,NEW.ck4g_usafrete) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_USAFRETE'', OLD.ck4g_usafrete, NEW.ck4g_usafrete, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_validade,NEW.ck4g_validade) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_VALIDADE'', OLD.ck4g_validade, NEW.ck4g_validade, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_versao,NEW.ck4g_versao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_VERSAO'', OLD.ck4g_versao, NEW.ck4g_versao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_zsomenteapos24h,NEW.ck4g_zsomenteapos24h) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_ZSOMENTEAPOS24H'', OLD.ck4g_zsomenteapos24h, NEW.ck4g_zsomenteapos24h, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cobecf,NEW.cobecf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COBECF'', OLD.cobecf, NEW.cobecf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codctr,NEW.codctr) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODCTR'', OLD.codctr, NEW.codctr, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codext_decf,NEW.codext_decf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODEXT_DECF'', OLD.codext_decf, NEW.codext_decf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codfab,NEW.codfab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODFAB'', OLD.codfab, NEW.codfab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codmod,NEW.codmod) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODMOD'', OLD.codmod, NEW.codmod, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codmul,NEW.codmul) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODMUL'', OLD.codmul, NEW.codmul, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codori,NEW.codori) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODORI'', OLD.codori, NEW.codori, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.coduid,NEW.coduid) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODUID'', OLD.coduid, NEW.coduid, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.crzini,NEW.crzini) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CRZINI'', OLD.crzini, NEW.crzini, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ctaabe,NEW.ctaabe) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CTAABE'', OLD.ctaabe, NEW.ctaabe, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ctadif,NEW.ctadif) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CTADIF'', OLD.ctadif, NEW.ctadif, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ctafec,NEW.ctafec) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CTAFEC'', OLD.ctafec, NEW.ctafec, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ctatro,NEW.ctatro) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CTATRO'', OLD.ctatro, NEW.ctatro, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.decf_numext,NEW.decf_numext) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DECF_NUMEXT'', OLD.decf_numext, NEW.decf_numext, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dswecf,NEW.dswecf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DSWECF'', OLD.dswecf, NEW.dswecf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ecfati,NEW.ecfati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ECFATI'', OLD.ecfati, NEW.ecfati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ecfcol,NEW.ecfcol) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ECFCOL'', OLD.ecfcol, NEW.ecfcol, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ecfmfa,NEW.ecfmfa) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ECFMFA'', OLD.ecfmfa, NEW.ecfmfa, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ecftip,NEW.ecftip) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ECFTIP'', OLD.ecftip, NEW.ecftip, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ecfutl,NEW.ecfutl) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ECFUTL'', OLD.ecfutl, NEW.ecfutl, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filecf,NEW.filecf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILECF'', OLD.filecf, NEW.filecf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fitdet,NEW.fitdet) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FITDET'', OLD.fitdet, NEW.fitdet, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.flgcfe,NEW.flgcfe) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FLGCFE'', OLD.flgcfe, NEW.flgcfe, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.interv,NEW.interv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INTERV'', OLD.interv, NEW.interv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.maqecf,NEW.maqecf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MAQECF'', OLD.maqecf, NEW.maqecf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.marecf,NEW.marecf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MARECF'', OLD.marecf, NEW.marecf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.maxcai,NEW.maxcai) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MAXCAI'', OLD.maxcai, NEW.maxcai, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.modecf,NEW.modecf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MODECF'', OLD.modecf, NEW.modecf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nivlog,NEW.nivlog) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NIVLOG'', OLD.nivlog, NEW.nivlog, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.numecf,NEW.numecf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NUMECF'', OLD.numecf, NEW.numecf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.porecf,NEW.porecf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PORECF'', OLD.porecf, NEW.porecf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.saienv,NEW.saienv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAIENV'', OLD.saienv, NEW.saienv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sercon_decf,NEW.sercon_decf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERCON_DECF'', OLD.sercon_decf, NEW.sercon_decf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.serecf,NEW.serecf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERECF'', OLD.serecf, NEW.serecf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.status_dados,NEW.status_dados) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''STATUS_DADOS'', OLD.status_dados, NEW.status_dados, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.status_data,NEW.status_data) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''STATUS_DATA'', OLD.status_data, NEW.status_data, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tnciee,NEW.tnciee) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TNCIEE'', OLD.tnciee, NEW.tnciee, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vswecf,NEW.vswecf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ECF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VSWECF'', OLD.vswecf, NEW.vswecf, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10586 --*/
CREATE TRIGGER TG_LOG_td_ecf
AFTER INSERT OR UPDATE OR DELETE ON td_ecf
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ecf();

/*-- SEQ 10587 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_end() CASCADE;

 /*-- SEQ 10588 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_end() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_END'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_END'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_END'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desend,NEW.desend) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_END'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESEND'', OLD.desend, NEW.desend, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dupend,NEW.dupend) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_END'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DUPEND'', OLD.dupend, NEW.dupend, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.endatv,NEW.endatv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_END'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ENDATV'', OLD.endatv, NEW.endatv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usoend,NEW.usoend) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_END'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USOEND'', OLD.usoend, NEW.usoend, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10589 --*/
CREATE TRIGGER TG_LOG_td_end
AFTER INSERT OR UPDATE OR DELETE ON td_end
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_end();

/*-- SEQ 10590 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ent() CASCADE;

 /*-- SEQ 10591 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ent() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_ENT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_ENT'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ENT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desent,NEW.desent) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ENT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESENT'', OLD.desent, NEW.desent, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.entati,NEW.entati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ENT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ENTATI'', OLD.entati, NEW.entati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.entfil,NEW.entfil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ENT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ENTFIL'', OLD.entfil, NEW.entfil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.przent,NEW.przent) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ENT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRZENT'', OLD.przent, NEW.przent, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipent,NEW.tipent) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ENT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPENT'', OLD.tipent, NEW.tipent, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10592 --*/
CREATE TRIGGER TG_LOG_td_ent
AFTER INSERT OR UPDATE OR DELETE ON td_ent
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ent();

/*-- SEQ 10593 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_esp() CASCADE;

 /*-- SEQ 10594 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_esp() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_ESP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_ESP'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ESP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.espati,NEW.espati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ESP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ESPATI'', OLD.espati, NEW.espati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.especi,NEW.especi) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ESP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ESPECI'', OLD.especi, NEW.especi, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10595 --*/
CREATE TRIGGER TG_LOG_td_esp
AFTER INSERT OR UPDATE OR DELETE ON td_esp
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_esp();

/*-- SEQ 10596 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_est() CASCADE;

 /*-- SEQ 10597 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_est() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_EST'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.aliint,NEW.aliint) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ALIINT'', OLD.aliint, NEW.aliint, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.basmar,NEW.basmar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''BASMAR'', OLD.basmar, NEW.basmar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.estado,NEW.estado) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ESTADO'', OLD.estado, NEW.estado, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.estati,NEW.estati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ESTATI'', OLD.estati, NEW.estati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.estibg,NEW.estibg) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ESTIBG'', OLD.estibg, NEW.estibg, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.icmcid,NEW.icmcid) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ICMCID'', OLD.icmcid, NEW.icmcid, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.icmimp,NEW.icmimp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ICMIMP'', OLD.icmimp, NEW.icmimp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.icmint,NEW.icmint) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ICMINT'', OLD.icmint, NEW.icmint, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.inscst,NEW.inscst) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INSCST'', OLD.inscst, NEW.inscst, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.marg00,NEW.marg00) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MARG00'', OLD.marg00, NEW.marg00, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.marg01,NEW.marg01) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MARG01'', OLD.marg01, NEW.marg01, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.marg02,NEW.marg02) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MARG02'', OLD.marg02, NEW.marg02, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.marg03,NEW.marg03) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MARG03'', OLD.marg03, NEW.marg03, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.marg04,NEW.marg04) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MARG04'', OLD.marg04, NEW.marg04, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.marg05,NEW.marg05) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MARG05'', OLD.marg05, NEW.marg05, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.marg06,NEW.marg06) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MARG06'', OLD.marg06, NEW.marg06, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.marg07,NEW.marg07) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MARG07'', OLD.marg07, NEW.marg07, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.marg08,NEW.marg08) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MARG08'', OLD.marg08, NEW.marg08, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.marg09,NEW.marg09) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MARG09'', OLD.marg09, NEW.marg09, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.max_cf,NEW.max_cf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MAX_CF'', OLD.max_cf, NEW.max_cf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nomest,NEW.nomest) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NOMEST'', OLD.nomest, NEW.nomest, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.norint,NEW.norint) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NORINT'', OLD.norint, NEW.norint, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ondcal,NEW.ondcal) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ONDCAL'', OLD.ondcal, NEW.ondcal, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.perfcp,NEW.perfcp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERFCP'', OLD.perfcp, NEW.perfcp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pericm,NEW.pericm) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERICM'', OLD.pericm, NEW.pericm, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.perrep,NEW.perrep) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERREP'', OLD.perrep, NEW.perrep, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sombas,NEW.sombas) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SOMBAS'', OLD.sombas, NEW.sombas, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sublim,NEW.sublim) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EST'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SUBLIM'', OLD.sublim, NEW.sublim, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10598 --*/
CREATE TRIGGER TG_LOG_td_est
AFTER INSERT OR UPDATE OR DELETE ON td_est
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_est();

/*-- SEQ 10599 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_eti() CASCADE;

 /*-- SEQ 10600 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_eti() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_ETI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_ETI'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ETI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.deseti,NEW.deseti) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ETI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESETI'', OLD.deseti, NEW.deseti, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.etiati,NEW.etiati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ETI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ETIATI'', OLD.etiati, NEW.etiati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.rbfile,NEW.rbfile) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ETI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RBFILE'', OLD.rbfile, NEW.rbfile, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10601 --*/
CREATE TRIGGER TG_LOG_td_eti
AFTER INSERT OR UPDATE OR DELETE ON td_eti
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_eti();

/*-- SEQ 10602 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_exp() CASCADE;

 /*-- SEQ 10603 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_exp() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_EXP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_EXP'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.aliexp,NEW.aliexp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EXP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ALIEXP'', OLD.aliexp, NEW.aliexp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.atiexp,NEW.atiexp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EXP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ATIEXP'', OLD.atiexp, NEW.atiexp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EXP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.datfim,NEW.datfim) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EXP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DATFIM'', OLD.datfim, NEW.datfim, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.datini,NEW.datini) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EXP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DATINI'', OLD.datini, NEW.datini, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desexp,NEW.desexp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EXP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESEXP'', OLD.desexp, NEW.desexp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usoexc,NEW.usoexc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EXP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USOEXC'', OLD.usoexc, NEW.usoexc, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10604 --*/
CREATE TRIGGER TG_LOG_td_exp
AFTER INSERT OR UPDATE OR DELETE ON td_exp
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_exp();

/*-- SEQ 10605 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ext() CASCADE;

 /*-- SEQ 10606 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ext() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_EXT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_EXT'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EXT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desext,NEW.desext) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EXT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESEXT'', OLD.desext, NEW.desext, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.gerccc,NEW.gerccc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EXT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''GERCCC'', OLD.gerccc, NEW.gerccc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.gerfin,NEW.gerfin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EXT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''GERFIN'', OLD.gerfin, NEW.gerfin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.locccc,NEW.locccc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EXT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LOCCCC'', OLD.locccc, NEW.locccc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.locchr,NEW.locchr) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EXT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LOCCHR'', OLD.locchr, NEW.locchr, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.locdep,NEW.locdep) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EXT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LOCDEP'', OLD.locdep, NEW.locdep, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.locdop,NEW.locdop) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EXT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LOCDOP'', OLD.locdop, NEW.locdop, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.locfin,NEW.locfin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EXT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LOCFIN'', OLD.locfin, NEW.locfin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.locrec,NEW.locrec) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EXT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LOCREC'', OLD.locrec, NEW.locrec, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.loctit,NEW.loctit) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_EXT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LOCTIT'', OLD.loctit, NEW.loctit, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10607 --*/
CREATE TRIGGER TG_LOG_td_ext
AFTER INSERT OR UPDATE OR DELETE ON td_ext
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ext();

/*-- SEQ 10608 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_fcc() CASCADE;

 /*-- SEQ 10609 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_fcc() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_FCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_FCC'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fcc_codcor,NEW.fcc_codcor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FCC_CODCOR'', OLD.fcc_codcor, NEW.fcc_codcor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fcc_codmat,NEW.fcc_codmat) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FCC_CODMAT'', OLD.fcc_codmat, NEW.fcc_codmat, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fcc_codtam,NEW.fcc_codtam) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FCC_CODTAM'', OLD.fcc_codtam, NEW.fcc_codtam, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fcc_filmat,NEW.fcc_filmat) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FCC_FILMAT'', OLD.fcc_filmat, NEW.fcc_filmat, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fccati,NEW.fccati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FCCATI'', OLD.fccati, NEW.fccati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fccfil,NEW.fccfil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FCCFIL'', OLD.fccfil, NEW.fccfil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.perate,NEW.perate) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERATE'', OLD.perate, NEW.perate, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vlrtax,NEW.vlrtax) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VLRTAX'', OLD.vlrtax, NEW.vlrtax, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10610 --*/
CREATE TRIGGER TG_LOG_td_fcc
AFTER INSERT OR UPDATE OR DELETE ON td_fcc
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_fcc();

/*-- SEQ 10611 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_fid() CASCADE;

 /*-- SEQ 10612 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_fid() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_FID'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_FID'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.atifid,NEW.atifid) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FID'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ATIFID'', OLD.atifid, NEW.atifid, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.clafid,NEW.clafid) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FID'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLAFID'', OLD.clafid, NEW.clafid, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FID'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desfid,NEW.desfid) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FID'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESFID'', OLD.desfid, NEW.desfid, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.imgfid,NEW.imgfid) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FID'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IMGFID'', OLD.imgfid, NEW.imgfid, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.imgfud,NEW.imgfud) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FID'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IMGFUD'', OLD.imgfud, NEW.imgfud, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.perfid,NEW.perfid) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FID'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERFID'', OLD.perfid, NEW.perfid, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10613 --*/
CREATE TRIGGER TG_LOG_td_fid
AFTER INSERT OR UPDATE OR DELETE ON td_fid
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_fid();

/*-- SEQ 10614 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_fil() CASCADE;

 /*-- SEQ 10615 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_fil() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_FIL'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.acefil,NEW.acefil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ACEFIL'', OLD.acefil, NEW.acefil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.acr_cf,NEW.acr_cf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ACR_CF'', OLD.acr_cf, NEW.acr_cf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.alisim_icms,NEW.alisim_icms) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ALISIM_ICMS'', OLD.alisim_icms, NEW.alisim_icms, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.assina,NEW.assina) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ASSINA'', OLD.assina, NEW.assina, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.baifil,NEW.baifil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''BAIFIL'', OLD.baifil, NEW.baifil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.baiout,NEW.baiout) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''BAIOUT'', OLD.baiout, NEW.baiout, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.bairro,NEW.bairro) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''BAIRRO'', OLD.bairro, NEW.bairro, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.baispc,NEW.baispc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''BAISPC'', OLD.baispc, NEW.baispc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.basicm_maj,NEW.basicm_maj) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''BASICM_MAJ'', OLD.basicm_maj, NEW.basicm_maj, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cgcfil,NEW.cgcfil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CGCFIL'', OLD.cgcfil, NEW.cgcfil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.chehom,NEW.chehom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CHEHOM'', OLD.chehom, NEW.chehom, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_itememunicalinha,NEW.ck4g_itememunicalinha) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_ITEMEMUNICALINHA'', OLD.ck4g_itememunicalinha, NEW.ck4g_itememunicalinha, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_manlog_det,NEW.ck4g_manlog_det) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_MANLOG_DET'', OLD.ck4g_manlog_det, NEW.ck4g_manlog_det, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_manlog_ger,NEW.ck4g_manlog_ger) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_MANLOG_GER'', OLD.ck4g_manlog_ger, NEW.ck4g_manlog_ger, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_manmov,NEW.ck4g_manmov) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_MANMOV'', OLD.ck4g_manmov, NEW.ck4g_manmov, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_modfis_vc,NEW.ck4g_modfis_vc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_MODFIS_VC'', OLD.ck4g_modfis_vc, NEW.ck4g_modfis_vc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_modfis_vc_cont,NEW.ck4g_modfis_vc_cont) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_MODFIS_VC_CONT'', OLD.ck4g_modfis_vc_cont, NEW.ck4g_modfis_vc_cont, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_usa_cont_offline,NEW.ck4g_usa_cont_offline) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_USA_CONT_OFFLINE'', OLD.ck4g_usa_cont_offline, NEW.ck4g_usa_cont_offline, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck_ven_cmb_est_zer,NEW.ck_ven_cmb_est_zer) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK_VEN_CMB_EST_ZER'', OLD.ck_ven_cmb_est_zer, NEW.ck_ven_cmb_est_zer, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpacidche,NEW.ckpacidche) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPACIDCHE'', OLD.ckpacidche, NEW.ckpacidche, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpanomina,NEW.ckpanomina) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPANOMINA'', OLD.ckpanomina, NEW.ckpanomina, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codcep,NEW.codcep) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODCEP'', OLD.codcep, NEW.codcep, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codcid,NEW.codcid) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODCID'', OLD.codcid, NEW.codcid, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codclidoa,NEW.codclidoa) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODCLIDOA'', OLD.codclidoa, NEW.codclidoa, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codcnt,NEW.codcnt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODCNT'', OLD.codcnt, NEW.codcnt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codcom_pagfor,NEW.codcom_pagfor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODCOM_PAGFOR'', OLD.codcom_pagfor, NEW.codcom_pagfor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.coddep,NEW.coddep) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODDEP'', OLD.coddep, NEW.coddep, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codext,NEW.codext) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODEXT'', OLD.codext, NEW.codext, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codfil,NEW.codfil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODFIL'', OLD.codfil, NEW.codfil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codger,NEW.codger) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODGER'', OLD.codger, NEW.codger, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codgru,NEW.codgru) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODGRU'', OLD.codgru, NEW.codgru, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codibg,NEW.codibg) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODIBG'', OLD.codibg, NEW.codibg, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codstf,NEW.codstf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODSTF'', OLD.codstf, NEW.codstf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtef,NEW.codtef) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTEF'', OLD.codtef, NEW.codtef, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.coduid,NEW.coduid) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODUID'', OLD.coduid, NEW.coduid, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codven,NEW.codven) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODVEN'', OLD.codven, NEW.codven, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.comcof,NEW.comcof) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COMCOF'', OLD.comcof, NEW.comcof, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.comglo,NEW.comglo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COMGLO'', OLD.comglo, NEW.comglo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.comis1,NEW.comis1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COMIS1'', OLD.comis1, NEW.comis1, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.comis2,NEW.comis2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COMIS2'', OLD.comis2, NEW.comis2, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.comis3,NEW.comis3) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COMIS3'', OLD.comis3, NEW.comis3, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.comis4,NEW.comis4) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COMIS4'', OLD.comis4, NEW.comis4, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.compis,NEW.compis) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COMPIS'', OLD.compis, NEW.compis, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.comple,NEW.comple) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COMPLE'', OLD.comple, NEW.comple, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.contat,NEW.contat) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CONTAT'', OLD.contat, NEW.contat, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.conver,NEW.conver) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CONVER'', OLD.conver, NEW.conver, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.creddf,NEW.creddf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CREDDF'', OLD.creddf, NEW.creddf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.crffar,NEW.crffar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CRFFAR'', OLD.crffar, NEW.crffar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ctcpag,NEW.ctcpag) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CTCPAG'', OLD.ctcpag, NEW.ctcpag, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ctr_cc,NEW.ctr_cc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CTR_CC'', OLD.ctr_cc, NEW.ctr_cc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.datbas,NEW.datbas) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DATBAS'', OLD.datbas, NEW.datbas, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.datcre,NEW.datcre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DATCRE'', OLD.datcre, NEW.datcre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.datest,NEW.datest) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DATEST'', OLD.datest, NEW.datest, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.datfinest,NEW.datfinest) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DATFINEST'', OLD.datfinest, NEW.datfinest, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.datsim,NEW.datsim) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DATSIM'', OLD.datsim, NEW.datsim, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.davfis,NEW.davfis) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DAVFIS'', OLD.davfis, NEW.davfis, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.davnfs,NEW.davnfs) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DAVNFS'', OLD.davnfs, NEW.davnfs, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dddfil,NEW.dddfil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DDDFIL'', OLD.dddfil, NEW.dddfil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desipi,NEW.desipi) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESIPI'', OLD.desipi, NEW.desipi, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desipitra,NEW.desipitra) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESIPITRA'', OLD.desipitra, NEW.desipitra, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.digitacao_atacado,NEW.digitacao_atacado) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIGITACAO_ATACADO'', OLD.digitacao_atacado, NEW.digitacao_atacado, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.e_mail,NEW.e_mail) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''E_MAIL'', OLD.e_mail, NEW.e_mail, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ecfest,NEW.ecfest) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ECFEST'', OLD.ecfest, NEW.ecfest, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.endere,NEW.endere) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ENDERE'', OLD.endere, NEW.endere, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.exp_bo,NEW.exp_bo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXP_BO'', OLD.exp_bo, NEW.exp_bo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.exp_ca,NEW.exp_ca) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXP_CA'', OLD.exp_ca, NEW.exp_ca, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.exp_cf,NEW.exp_cf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXP_CF'', OLD.exp_cf, NEW.exp_cf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.exp_cg,NEW.exp_cg) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXP_CG'', OLD.exp_cg, NEW.exp_cg, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.exp_co,NEW.exp_co) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXP_CO'', OLD.exp_co, NEW.exp_co, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.exp_cs,NEW.exp_cs) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXP_CS'', OLD.exp_cs, NEW.exp_cs, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.exp_eb,NEW.exp_eb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXP_EB'', OLD.exp_eb, NEW.exp_eb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.exp_ec,NEW.exp_ec) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXP_EC'', OLD.exp_ec, NEW.exp_ec, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.exp_nb,NEW.exp_nb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXP_NB'', OLD.exp_nb, NEW.exp_nb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.exp_nc,NEW.exp_nc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXP_NC'', OLD.exp_nc, NEW.exp_nc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.exp_ns,NEW.exp_ns) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXP_NS'', OLD.exp_ns, NEW.exp_ns, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.exp_or,NEW.exp_or) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXP_OR'', OLD.exp_or, NEW.exp_or, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.exp_rb,NEW.exp_rb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXP_RB'', OLD.exp_rb, NEW.exp_rb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.exp_sd,NEW.exp_sd) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXP_SD'', OLD.exp_sd, NEW.exp_sd, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.exp_se,NEW.exp_se) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXP_SE'', OLD.exp_se, NEW.exp_se, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.exp_sw,NEW.exp_sw) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXP_SW'', OLD.exp_sw, NEW.exp_sw, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.exp_tm,NEW.exp_tm) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXP_TM'', OLD.exp_tm, NEW.exp_tm, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.exp_to,NEW.exp_to) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXP_TO'', OLD.exp_to, NEW.exp_to, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.faxfil,NEW.faxfil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FAXFIL'', OLD.faxfil, NEW.faxfil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fil_ct,NEW.fil_ct) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FIL_CT'', OLD.fil_ct, NEW.fil_ct, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filati,NEW.filati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILATI'', OLD.filati, NEW.filati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filclidoa,NEW.filclidoa) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILCLIDOA'', OLD.filclidoa, NEW.filclidoa, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filcnt,NEW.filcnt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILCNT'', OLD.filcnt, NEW.filcnt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filcpm,NEW.filcpm) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILCPM'', OLD.filcpm, NEW.filcpm, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filent_regesp,NEW.filent_regesp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILENT_REGESP'', OLD.filent_regesp, NEW.filent_regesp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filger,NEW.filger) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILGER'', OLD.filger, NEW.filger, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filjur,NEW.filjur) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILJUR'', OLD.filjur, NEW.filjur, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fillan,NEW.fillan) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILLAN'', OLD.fillan, NEW.fillan, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filout,NEW.filout) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILOUT'', OLD.filout, NEW.filout, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filpag,NEW.filpag) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILPAG'', OLD.filpag, NEW.filpag, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filtar,NEW.filtar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILTAR'', OLD.filtar, NEW.filtar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filtes,NEW.filtes) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILTES'', OLD.filtes, NEW.filtes, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filtrn,NEW.filtrn) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILTRN'', OLD.filtrn, NEW.filtrn, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filven,NEW.filven) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILVEN'', OLD.filven, NEW.filven, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filweb,NEW.filweb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILWEB'', OLD.filweb, NEW.filweb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.finmax,NEW.finmax) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FINMAX'', OLD.finmax, NEW.finmax, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.finmin,NEW.finmin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FINMIN'', OLD.finmin, NEW.finmin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fonfil,NEW.fonfil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FONFIL'', OLD.fonfil, NEW.fonfil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.frcont,NEW.frcont) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FRCONT'', OLD.frcont, NEW.frcont, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.frdent,NEW.frdent) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FRDENT'', OLD.frdent, NEW.frdent, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.frnaoc,NEW.frnaoc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FRNAOC'', OLD.frnaoc, NEW.frnaoc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.hom_bo,NEW.hom_bo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOM_BO'', OLD.hom_bo, NEW.hom_bo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.hom_ca,NEW.hom_ca) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOM_CA'', OLD.hom_ca, NEW.hom_ca, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.hom_cf,NEW.hom_cf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOM_CF'', OLD.hom_cf, NEW.hom_cf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.hom_cg,NEW.hom_cg) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOM_CG'', OLD.hom_cg, NEW.hom_cg, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.hom_co,NEW.hom_co) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOM_CO'', OLD.hom_co, NEW.hom_co, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.hom_cs,NEW.hom_cs) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOM_CS'', OLD.hom_cs, NEW.hom_cs, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.hom_eb,NEW.hom_eb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOM_EB'', OLD.hom_eb, NEW.hom_eb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.hom_ec,NEW.hom_ec) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOM_EC'', OLD.hom_ec, NEW.hom_ec, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.hom_nb,NEW.hom_nb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOM_NB'', OLD.hom_nb, NEW.hom_nb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.hom_nc,NEW.hom_nc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOM_NC'', OLD.hom_nc, NEW.hom_nc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.hom_ns,NEW.hom_ns) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOM_NS'', OLD.hom_ns, NEW.hom_ns, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.hom_or,NEW.hom_or) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOM_OR'', OLD.hom_or, NEW.hom_or, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.hom_rb,NEW.hom_rb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOM_RB'', OLD.hom_rb, NEW.hom_rb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.hom_sd,NEW.hom_sd) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOM_SD'', OLD.hom_sd, NEW.hom_sd, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.hom_se,NEW.hom_se) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOM_SE'', OLD.hom_se, NEW.hom_se, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.hom_sw,NEW.hom_sw) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOM_SW'', OLD.hom_sw, NEW.hom_sw, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.hom_tm,NEW.hom_tm) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOM_TM'', OLD.hom_tm, NEW.hom_tm, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.hom_to,NEW.hom_to) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOM_TO'', OLD.hom_to, NEW.hom_to, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.homol1,NEW.homol1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOMOL1'', OLD.homol1, NEW.homol1, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.homol2,NEW.homol2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOMOL2'', OLD.homol2, NEW.homol2, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.hompge,NEW.hompge) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOMPGE'', OLD.hompge, NEW.hompge, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.homver,NEW.homver) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOMVER'', OLD.homver, NEW.homver, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ie_fil,NEW.ie_fil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IE_FIL'', OLD.ie_fil, NEW.ie_fil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.imgfil,NEW.imgfil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IMGFIL'', OLD.imgfil, NEW.imgfil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.inifil,NEW.inifil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INIFIL'', OLD.inifil, NEW.inifil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.insmun,NEW.insmun) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INSMUN'', OLD.insmun, NEW.insmun, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.instal,NEW.instal) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INSTAL'', OLD.instal, NEW.instal, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.intsin,NEW.intsin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INTSIN'', OLD.intsin, NEW.intsin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ip_middle,NEW.ip_middle) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IP_MIDDLE'', OLD.ip_middle, NEW.ip_middle, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ip_orderlocal,NEW.ip_orderlocal) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IP_ORDERLOCAL'', OLD.ip_orderlocal, NEW.ip_orderlocal, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ip_sfc,NEW.ip_sfc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IP_SFC'', OLD.ip_sfc, NEW.ip_sfc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ip_tef,NEW.ip_tef) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IP_TEF'', OLD.ip_tef, NEW.ip_tef, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.licfar,NEW.licfar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LICFAR'', OLD.licfar, NEW.licfar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.limcof,NEW.limcof) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LIMCOF'', OLD.limcof, NEW.limcof, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.limcom,NEW.limcom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LIMCOM'', OLD.limcom, NEW.limcom, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mod_bo,NEW.mod_bo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOD_BO'', OLD.mod_bo, NEW.mod_bo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mod_ca,NEW.mod_ca) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOD_CA'', OLD.mod_ca, NEW.mod_ca, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mod_cf,NEW.mod_cf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOD_CF'', OLD.mod_cf, NEW.mod_cf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mod_cg,NEW.mod_cg) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOD_CG'', OLD.mod_cg, NEW.mod_cg, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mod_co,NEW.mod_co) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOD_CO'', OLD.mod_co, NEW.mod_co, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mod_cs,NEW.mod_cs) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOD_CS'', OLD.mod_cs, NEW.mod_cs, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mod_eb,NEW.mod_eb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOD_EB'', OLD.mod_eb, NEW.mod_eb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mod_ec,NEW.mod_ec) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOD_EC'', OLD.mod_ec, NEW.mod_ec, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mod_nb,NEW.mod_nb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOD_NB'', OLD.mod_nb, NEW.mod_nb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mod_nc,NEW.mod_nc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOD_NC'', OLD.mod_nc, NEW.mod_nc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mod_ns,NEW.mod_ns) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOD_NS'', OLD.mod_ns, NEW.mod_ns, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mod_or,NEW.mod_or) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOD_OR'', OLD.mod_or, NEW.mod_or, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mod_rb,NEW.mod_rb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOD_RB'', OLD.mod_rb, NEW.mod_rb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mod_sd,NEW.mod_sd) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOD_SD'', OLD.mod_sd, NEW.mod_sd, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mod_se,NEW.mod_se) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOD_SE'', OLD.mod_se, NEW.mod_se, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mod_sw,NEW.mod_sw) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOD_SW'', OLD.mod_sw, NEW.mod_sw, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mod_tm,NEW.mod_tm) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOD_TM'', OLD.mod_tm, NEW.mod_tm, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mod_to,NEW.mod_to) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOD_TO'', OLD.mod_to, NEW.mod_to, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mprini,NEW.mprini) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MPRINI'', OLD.mprini, NEW.mprini, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mul_tipent0,NEW.mul_tipent0) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MUL_TIPENT0'', OLD.mul_tipent0, NEW.mul_tipent0, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mul_tipent1,NEW.mul_tipent1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MUL_TIPENT1'', OLD.mul_tipent1, NEW.mul_tipent1, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mul_tipent2,NEW.mul_tipent2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MUL_TIPENT2'', OLD.mul_tipent2, NEW.mul_tipent2, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mul_tipent3,NEW.mul_tipent3) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MUL_TIPENT3'', OLD.mul_tipent3, NEW.mul_tipent3, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mul_tipent4,NEW.mul_tipent4) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MUL_TIPENT4'', OLD.mul_tipent4, NEW.mul_tipent4, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mul_tipent5,NEW.mul_tipent5) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MUL_TIPENT5'', OLD.mul_tipent5, NEW.mul_tipent5, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mul_tipent7,NEW.mul_tipent7) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MUL_TIPENT7'', OLD.mul_tipent7, NEW.mul_tipent7, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nf_con,NEW.nf_con) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NF_CON'', OLD.nf_con, NEW.nf_con, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nivcri,NEW.nivcri) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NIVCRI'', OLD.nivcri, NEW.nivcri, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nomfar,NEW.nomfar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NOMFAR'', OLD.nomfar, NEW.nomfar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nomfil,NEW.nomfil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NOMFIL'', OLD.nomfil, NEW.nomfil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.numero,NEW.numero) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NUMERO'', OLD.numero, NEW.numero, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.numfon,NEW.numfon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NUMFON'', OLD.numfon, NEW.numfon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nummrd,NEW.nummrd) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NUMMRD'', OLD.nummrd, NEW.nummrd, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.numser,NEW.numser) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NUMSER'', OLD.numser, NEW.numser, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.obs_des_st,NEW.obs_des_st) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OBS_DES_ST'', OLD.obs_des_st, NEW.obs_des_st, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.obs_perdas,NEW.obs_perdas) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OBS_PERDAS'', OLD.obs_perdas, NEW.obs_perdas, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.obs_st_dev,NEW.obs_st_dev) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OBS_ST_DEV'', OLD.obs_st_dev, NEW.obs_st_dev, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pafecf,NEW.pafecf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAFECF'', OLD.pafecf, NEW.pafecf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pat_aa,NEW.pat_aa) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAT_AA'', OLD.pat_aa, NEW.pat_aa, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.patcar,NEW.patcar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PATCAR'', OLD.patcar, NEW.patcar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.patcon,NEW.patcon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PATCON'', OLD.patcon, NEW.patcon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.patimgchr,NEW.patimgchr) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PATIMGCHR'', OLD.patimgchr, NEW.patimgchr, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.patnfe,NEW.patnfe) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PATNFE'', OLD.patnfe, NEW.patnfe, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.patnot,NEW.patnot) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PATNOT'', OLD.patnot, NEW.patnot, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.patped,NEW.patped) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PATPED'', OLD.patped, NEW.patped, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pattke,NEW.pattke) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PATTKE'', OLD.pattke, NEW.pattke, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.per_fis_rural,NEW.per_fis_rural) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PER_FIS_RURAL'', OLD.per_fis_rural, NEW.per_fis_rural, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.per_fis_senar,NEW.per_fis_senar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PER_FIS_SENAR'', OLD.per_fis_senar, NEW.per_fis_senar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.per_jur_rural,NEW.per_jur_rural) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PER_JUR_RURAL'', OLD.per_jur_rural, NEW.per_jur_rural, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.per_jur_senar,NEW.per_jur_senar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PER_JUR_SENAR'', OLD.per_jur_senar, NEW.per_jur_senar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.per_segrur,NEW.per_segrur) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PER_SEGRUR'', OLD.per_segrur, NEW.per_segrur, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.percof,NEW.percof) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERCOF'', OLD.percof, NEW.percof, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.percomsug,NEW.percomsug) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERCOMSUG'', OLD.percomsug, NEW.percomsug, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.percre,NEW.percre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERCRE'', OLD.percre, NEW.percre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.perfil,NEW.perfil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERFIL'', OLD.perfil, NEW.perfil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.perope,NEW.perope) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PEROPE'', OLD.perope, NEW.perope, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.peropefix,NEW.peropefix) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PEROPEFIX'', OLD.peropefix, NEW.peropefix, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.perpis,NEW.perpis) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERPIS'', OLD.perpis, NEW.perpis, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.persoc,NEW.persoc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERSOC'', OLD.persoc, NEW.persoc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pesprefor,NEW.pesprefor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PESPREFOR'', OLD.pesprefor, NEW.pesprefor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pespreven,NEW.pespreven) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PESPREVEN'', OLD.pespreven, NEW.pespreven, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pesprzent,NEW.pesprzent) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PESPRZENT'', OLD.pesprzent, NEW.pesprzent, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.poremp,NEW.poremp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''POREMP'', OLD.poremp, NEW.poremp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.porret,NEW.porret) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PORRET'', OLD.porret, NEW.porret, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.porta_db,NEW.porta_db) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PORTA_DB'', OLD.porta_db, NEW.porta_db, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.porta_middle,NEW.porta_middle) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PORTA_MIDDLE'', OLD.porta_middle, NEW.porta_middle, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.prazo_compra_xa,NEW.prazo_compra_xa) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRAZO_COMPRA_XA'', OLD.prazo_compra_xa, NEW.prazo_compra_xa, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.prazo_compra_xb,NEW.prazo_compra_xb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRAZO_COMPRA_XB'', OLD.prazo_compra_xb, NEW.prazo_compra_xb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.prazo_compra_xc,NEW.prazo_compra_xc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRAZO_COMPRA_XC'', OLD.prazo_compra_xc, NEW.prazo_compra_xc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.prazo_compra_ya,NEW.prazo_compra_ya) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRAZO_COMPRA_YA'', OLD.prazo_compra_ya, NEW.prazo_compra_ya, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.prazo_compra_yb,NEW.prazo_compra_yb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRAZO_COMPRA_YB'', OLD.prazo_compra_yb, NEW.prazo_compra_yb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.prazo_compra_yc,NEW.prazo_compra_yc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRAZO_COMPRA_YC'', OLD.prazo_compra_yc, NEW.prazo_compra_yc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.prazo_compra_za,NEW.prazo_compra_za) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRAZO_COMPRA_ZA'', OLD.prazo_compra_za, NEW.prazo_compra_za, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.prazo_compra_zb,NEW.prazo_compra_zb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRAZO_COMPRA_ZB'', OLD.prazo_compra_zb, NEW.prazo_compra_zb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.prazo_compra_zc,NEW.prazo_compra_zc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRAZO_COMPRA_ZC'', OLD.prazo_compra_zc, NEW.prazo_compra_zc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.preven,NEW.preven) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PREVEN'', OLD.preven, NEW.preven, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.qtd_m2,NEW.qtd_m2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''QTD_M2'', OLD.qtd_m2, NEW.qtd_m2, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.qtdabast,NEW.qtdabast) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''QTDABAST'', OLD.qtdabast, NEW.qtdabast, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.qtdfun,NEW.qtdfun) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''QTDFUN'', OLD.qtdfun, NEW.qtdfun, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ratipi_frete,NEW.ratipi_frete) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RATIPI_FRETE'', OLD.ratipi_frete, NEW.ratipi_frete, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.razsoc,NEW.razsoc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RAZSOC'', OLD.razsoc, NEW.razsoc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.re8020,NEW.re8020) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RE8020'', OLD.re8020, NEW.re8020, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.red_cf,NEW.red_cf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RED_CF'', OLD.red_cf, NEW.red_cf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.regesp,NEW.regesp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''REGESP'', OLD.regesp, NEW.regesp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.regtri,NEW.regtri) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''REGTRI'', OLD.regtri, NEW.regtri, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.replica_saldo,NEW.replica_saldo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''REPLICA_SALDO'', OLD.replica_saldo, NEW.replica_saldo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.resirr,NEW.resirr) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RESIRR'', OLD.resirr, NEW.resirr, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.respon,NEW.respon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RESPON'', OLD.respon, NEW.respon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.retsoc,NEW.retsoc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RETSOC'', OLD.retsoc, NEW.retsoc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.segmento,NEW.segmento) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEGMENTO'', OLD.segmento, NEW.segmento, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seq_ct,NEW.seq_ct) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQ_CT'', OLD.seq_ct, NEW.seq_ct, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqcpm,NEW.seqcpm) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQCPM'', OLD.seqcpm, NEW.seqcpm, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqjur,NEW.seqjur) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQJUR'', OLD.seqjur, NEW.seqjur, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqlan,NEW.seqlan) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQLAN'', OLD.seqlan, NEW.seqlan, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqout,NEW.seqout) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQOUT'', OLD.seqout, NEW.seqout, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqpag,NEW.seqpag) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQPAG'', OLD.seqpag, NEW.seqpag, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqtar,NEW.seqtar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQTAR'', OLD.seqtar, NEW.seqtar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqtes,NEW.seqtes) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQTES'', OLD.seqtes, NEW.seqtes, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqtrn,NEW.seqtrn) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQTRN'', OLD.seqtrn, NEW.seqtrn, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sercfe,NEW.sercfe) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERCFE'', OLD.sercfe, NEW.sercfe, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.serdev,NEW.serdev) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERDEV'', OLD.serdev, NEW.serdev, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.serimp,NEW.serimp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERIMP'', OLD.serimp, NEW.serimp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sernfreci,NEW.sernfreci) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERNFRECI'', OLD.sernfreci, NEW.sernfreci, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.serpad,NEW.serpad) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERPAD'', OLD.serpad, NEW.serpad, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.serrps,NEW.serrps) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERRPS'', OLD.serrps, NEW.serrps, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sersat,NEW.sersat) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERSAT'', OLD.sersat, NEW.sersat, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sertra,NEW.sertra) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERTRA'', OLD.sertra, NEW.sertra, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.servid,NEW.servid) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERVID'', OLD.servid, NEW.servid, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sisdfe,NEW.sisdfe) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SISDFE'', OLD.sisdfe, NEW.sisdfe, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.st_interestadual,NEW.st_interestadual) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ST_INTERESTADUAL'', OLD.st_interestadual, NEW.st_interestadual, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.substituta,NEW.substituta) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SUBSTITUTA'', OLD.substituta, NEW.substituta, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.taxjurmes,NEW.taxjurmes) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TAXJURMES'', OLD.taxjurmes, NEW.taxjurmes, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tcmipi,NEW.tcmipi) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TCMIPI'', OLD.tcmipi, NEW.tcmipi, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tef_adcionais,NEW.tef_adcionais) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TEF_ADCIONAIS'', OLD.tef_adcionais, NEW.tef_adcionais, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tef_aprazo,NEW.tef_aprazo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TEF_APRAZO'', OLD.tef_aprazo, NEW.tef_aprazo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tef_avista,NEW.tef_avista) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TEF_AVISTA'', OLD.tef_avista, NEW.tef_avista, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tef_codestaut,NEW.tef_codestaut) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TEF_CODESTAUT'', OLD.tef_codestaut, NEW.tef_codestaut, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tef_codlojaut,NEW.tef_codlojaut) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TEF_CODLOJAUT'', OLD.tef_codlojaut, NEW.tef_codlojaut, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tef_gppadrao,NEW.tef_gppadrao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TEF_GPPADRAO'', OLD.tef_gppadrao, NEW.tef_gppadrao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tef_parametros,NEW.tef_parametros) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TEF_PARAMETROS'', OLD.tef_parametros, NEW.tef_parametros, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tesfil,NEW.tesfil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TESFIL'', OLD.tesfil, NEW.tesfil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tesseq,NEW.tesseq) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TESSEQ'', OLD.tesseq, NEW.tesseq, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.testip,NEW.testip) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TESTIP'', OLD.testip, NEW.testip, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tip_ct,NEW.tip_ct) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIP_CT'', OLD.tip_ct, NEW.tip_ct, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipbom,NEW.tipbom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPBOM'', OLD.tipbom, NEW.tipbom, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipcobret,NEW.tipcobret) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPCOBRET'', OLD.tipcobret, NEW.tipcobret, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipcom,NEW.tipcom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPCOM'', OLD.tipcom, NEW.tipcom, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipcpm,NEW.tipcpm) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPCPM'', OLD.tipcpm, NEW.tipcpm, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipend,NEW.tipend) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPEND'', OLD.tipend, NEW.tipend, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipjur,NEW.tipjur) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPJUR'', OLD.tipjur, NEW.tipjur, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tiplan,NEW.tiplan) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPLAN'', OLD.tiplan, NEW.tiplan, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipluc,NEW.tipluc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPLUC'', OLD.tipluc, NEW.tipluc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipout,NEW.tipout) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPOUT'', OLD.tipout, NEW.tipout, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tippag,NEW.tippag) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPPAG'', OLD.tippag, NEW.tippag, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tiptar,NEW.tiptar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPTAR'', OLD.tiptar, NEW.tiptar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tiptrn,NEW.tiptrn) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPTRN'', OLD.tiptrn, NEW.tiptrn, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.traori,NEW.traori) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TRAORI'', OLD.traori, NEW.traori, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.trisim,NEW.trisim) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TRISIM'', OLD.trisim, NEW.trisim, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.trocotef,NEW.trocotef) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TROCOTEF'', OLD.trocotef, NEW.trocotef, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ufloja,NEW.ufloja) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''UFLOJA'', OLD.ufloja, NEW.ufloja, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ultnumven,NEW.ultnumven) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ULTNUMVEN'', OLD.ultnumven, NEW.ultnumven, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usaparicm,NEW.usaparicm) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USAPARICM'', OLD.usaparicm, NEW.usaparicm, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.valor1,NEW.valor1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VALOR1'', OLD.valor1, NEW.valor1, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.valor2,NEW.valor2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VALOR2'', OLD.valor2, NEW.valor2, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.valor3,NEW.valor3) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VALOR3'', OLD.valor3, NEW.valor3, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.valor4,NEW.valor4) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VALOR4'', OLD.valor4, NEW.valor4, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vencof,NEW.vencof) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VENCOF'', OLD.vencof, NEW.vencof, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.venpis,NEW.venpis) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VENPIS'', OLD.venpis, NEW.venpis, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.versao,NEW.versao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VERSAO'', OLD.versao, NEW.versao, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10616 --*/
CREATE TRIGGER TG_LOG_td_fil
AFTER INSERT OR UPDATE OR DELETE ON td_fil
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_fil();

/*-- SEQ 10617 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_fin() CASCADE;

 /*-- SEQ 10618 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_fin() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_FIN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_FIN'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.cartao,NEW.cartao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CARTAO'', OLD.cartao, NEW.cartao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desfin,NEW.desfin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESFIN'', OLD.desfin, NEW.desfin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.finati,NEW.finati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FINATI'', OLD.finati, NEW.finati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10619 --*/
CREATE TRIGGER TG_LOG_td_fin
AFTER INSERT OR UPDATE OR DELETE ON td_fin
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_fin();

/*-- SEQ 10620 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_fis() CASCADE;

 /*-- SEQ 10621 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_fis() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_FIS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_FIS'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codfis,NEW.codfis) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODFIS'', OLD.codfis, NEW.codfis, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fisati,NEW.fisati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FIS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FISATI'', OLD.fisati, NEW.fisati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10622 --*/
CREATE TRIGGER TG_LOG_td_fis
AFTER INSERT OR UPDATE OR DELETE ON td_fis
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_fis();

/*-- SEQ 10623 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_fre() CASCADE;

 /*-- SEQ 10624 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_fre() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_FRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_FRE'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desfre,NEW.desfre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESFRE'', OLD.desfre, NEW.desfre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dfre_fremin,NEW.dfre_fremin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DFRE_FREMIN'', OLD.dfre_fremin, NEW.dfre_fremin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dfre_mindes,NEW.dfre_mindes) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DFRE_MINDES'', OLD.dfre_mindes, NEW.dfre_mindes, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dfre_perdes,NEW.dfre_perdes) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DFRE_PERDES'', OLD.dfre_perdes, NEW.dfre_perdes, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dfre_perven,NEW.dfre_perven) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DFRE_PERVEN'', OLD.dfre_perven, NEW.dfre_perven, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dfre_tipcob,NEW.dfre_tipcob) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DFRE_TIPCOB'', OLD.dfre_tipcob, NEW.dfre_tipcob, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dfre_valent,NEW.dfre_valent) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DFRE_VALENT'', OLD.dfre_valent, NEW.dfre_valent, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dfre_valpes,NEW.dfre_valpes) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DFRE_VALPES'', OLD.dfre_valpes, NEW.dfre_valpes, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dfre_valqtd,NEW.dfre_valqtd) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DFRE_VALQTD'', OLD.dfre_valqtd, NEW.dfre_valqtd, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.freati,NEW.freati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FREATI'', OLD.freati, NEW.freati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10625 --*/
CREATE TRIGGER TG_LOG_td_fre
AFTER INSERT OR UPDATE OR DELETE ON td_fre
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_fre();

/*-- SEQ 10626 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_fun() CASCADE;

 /*-- SEQ 10627 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_fun() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_FUN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_FUN'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codfun,NEW.codfun) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FUN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODFUN'', OLD.codfun, NEW.codfun, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FUN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desfun,NEW.desfun) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FUN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESFUN'', OLD.desfun, NEW.desfun, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.funati,NEW.funati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FUN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FUNATI'', OLD.funati, NEW.funati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.funpai,NEW.funpai) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FUN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FUNPAI'', OLD.funpai, NEW.funpai, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipfun,NEW.tipfun) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_FUN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPFUN'', OLD.tipfun, NEW.tipfun, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10628 --*/
CREATE TRIGGER TG_LOG_td_fun
AFTER INSERT OR UPDATE OR DELETE ON td_fun
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_fun();

/*-- SEQ 10629 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_gra() CASCADE;

 /*-- SEQ 10630 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_gra() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_GRA'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_GRA'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.coddiv,NEW.coddiv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_GRA'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODDIV'', OLD.coddiv, NEW.coddiv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codext,NEW.codext) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_GRA'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODEXT'', OLD.codext, NEW.codext, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codsub,NEW.codsub) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_GRA'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODSUB'', OLD.codsub, NEW.codsub, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_GRA'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.graati,NEW.graati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_GRA'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''GRAATI'', OLD.graati, NEW.graati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nomgra,NEW.nomgra) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_GRA'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NOMGRA'', OLD.nomgra, NEW.nomgra, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10631 --*/
CREATE TRIGGER TG_LOG_td_gra
AFTER INSERT OR UPDATE OR DELETE ON td_gra
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_gra();

/*-- SEQ 10632 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_gru() CASCADE;

 /*-- SEQ 10633 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_gru() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_GRU'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_GRU'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_GRU'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desgru,NEW.desgru) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_GRU'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESGRU'', OLD.desgru, NEW.desgru, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.gruati,NEW.gruati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_GRU'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''GRUATI'', OLD.gruati, NEW.gruati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10634 --*/
CREATE TRIGGER TG_LOG_td_gru
AFTER INSERT OR UPDATE OR DELETE ON td_gru
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_gru();

/*-- SEQ 10635 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_hom() CASCADE;

 /*-- SEQ 10636 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_hom() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_HOM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_HOM'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.atihom,NEW.atihom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_HOM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ATIHOM'', OLD.atihom, NEW.atihom, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codhom,NEW.codhom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_HOM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODHOM'', OLD.codhom, NEW.codhom, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_HOM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.deshom,NEW.deshom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_HOM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESHOM'', OLD.deshom, NEW.deshom, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10637 --*/
CREATE TRIGGER TG_LOG_td_hom
AFTER INSERT OR UPDATE OR DELETE ON td_hom
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_hom();

/*-- SEQ 10638 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_icm() CASCADE;

 /*-- SEQ 10639 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_icm() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_ICM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_ICM'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.assina,NEW.assina) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ICM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ASSINA'', OLD.assina, NEW.assina, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ICM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.coduid,NEW.coduid) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ICM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODUID'', OLD.coduid, NEW.coduid, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.icmati,NEW.icmati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ICM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ICMATI'', OLD.icmati, NEW.icmati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.perespestcom,NEW.perespestcom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ICM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERESPESTCOM'', OLD.perespestcom, NEW.perespestcom, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.perespestven,NEW.perespestven) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ICM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERESPESTVEN'', OLD.perespestven, NEW.perespestven, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.perespintcom,NEW.perespintcom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ICM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERESPINTCOM'', OLD.perespintcom, NEW.perespintcom, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.perespintven,NEW.perespintven) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ICM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERESPINTVEN'', OLD.perespintven, NEW.perespintven, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.resicm,NEW.resicm) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ICM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RESICM'', OLD.resicm, NEW.resicm, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10640 --*/
CREATE TRIGGER TG_LOG_td_icm
AFTER INSERT OR UPDATE OR DELETE ON td_icm
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_icm();

/*-- SEQ 10641 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ies() CASCADE;

 /*-- SEQ 10642 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ies() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_IES'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_IES'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IES'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.es_ati,NEW.es_ati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IES'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ES_ATI'', OLD.es_ati, NEW.es_ati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.icmses,NEW.icmses) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IES'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ICMSES'', OLD.icmses, NEW.icmses, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10643 --*/
CREATE TRIGGER TG_LOG_td_ies
AFTER INSERT OR UPDATE OR DELETE ON td_ies
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ies();

/*-- SEQ 10644 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ime() CASCADE;

 /*-- SEQ 10645 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ime() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_IME'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_IME'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IME'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.icmsme,NEW.icmsme) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IME'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ICMSME'', OLD.icmsme, NEW.icmsme, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.me_ati,NEW.me_ati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IME'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ME_ATI'', OLD.me_ati, NEW.me_ati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10646 --*/
CREATE TRIGGER TG_LOG_td_ime
AFTER INSERT OR UPDATE OR DELETE ON td_ime
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ime();

/*-- SEQ 10647 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_img() CASCADE;

 /*-- SEQ 10648 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_img() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_IMG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_IMG'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IMG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desimg,NEW.desimg) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IMG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESIMG'', OLD.desimg, NEW.desimg, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.imgati,NEW.imgati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IMG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IMGATI'', OLD.imgati, NEW.imgati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.letimg,NEW.letimg) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IMG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LETIMG'', OLD.letimg, NEW.letimg, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nomimg,NEW.nomimg) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IMG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NOMIMG'', OLD.nomimg, NEW.nomimg, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10649 --*/
CREATE TRIGGER TG_LOG_td_img
AFTER INSERT OR UPDATE OR DELETE ON td_img
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_img();

/*-- SEQ 10650 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ina() CASCADE;

 /*-- SEQ 10651 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ina() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_INA'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_INA'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_INA'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desina,NEW.desina) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_INA'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESINA'', OLD.desina, NEW.desina, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.inaati,NEW.inaati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_INA'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INAATI'', OLD.inaati, NEW.inaati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usoina,NEW.usoina) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_INA'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USOINA'', OLD.usoina, NEW.usoina, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10652 --*/
CREATE TRIGGER TG_LOG_td_ina
AFTER INSERT OR UPDATE OR DELETE ON td_ina
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ina();

/*-- SEQ 10653 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ind() CASCADE;

 /*-- SEQ 10654 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ind() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_IND'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_IND'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IND'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10655 --*/
CREATE TRIGGER TG_LOG_td_ind
AFTER INSERT OR UPDATE OR DELETE ON td_ind
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ind();

/*-- SEQ 10656 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ins() CASCADE;

 /*-- SEQ 10657 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ins() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_INS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_INS'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_INS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desins,NEW.desins) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_INS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESINS'', OLD.desins, NEW.desins, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.insati,NEW.insati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_INS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INSATI'', OLD.insati, NEW.insati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.qtddia,NEW.qtddia) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_INS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''QTDDIA'', OLD.qtddia, NEW.qtddia, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10658 --*/
CREATE TRIGGER TG_LOG_td_ins
AFTER INSERT OR UPDATE OR DELETE ON td_ins
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ins();

/*-- SEQ 10659 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ipi() CASCADE;

 /*-- SEQ 10660 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ipi() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_IPI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_IPI'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IPI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ipiati,NEW.ipiati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IPI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IPIATI'', OLD.ipiati, NEW.ipiati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.resipi,NEW.resipi) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IPI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RESIPI'', OLD.resipi, NEW.resipi, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10661 --*/
CREATE TRIGGER TG_LOG_td_ipi
AFTER INSERT OR UPDATE OR DELETE ON td_ipi
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ipi();

/*-- SEQ 10662 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ir1() CASCADE;

 /*-- SEQ 10663 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ir1() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_IR1'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_IR1'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IR1'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.icmsr1,NEW.icmsr1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IR1'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ICMSR1'', OLD.icmsr1, NEW.icmsr1, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.r1_ati,NEW.r1_ati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IR1'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''R1_ATI'', OLD.r1_ati, NEW.r1_ati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10664 --*/
CREATE TRIGGER TG_LOG_td_ir1
AFTER INSERT OR UPDATE OR DELETE ON td_ir1
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ir1();

/*-- SEQ 10665 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ir2() CASCADE;

 /*-- SEQ 10666 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ir2() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_IR2'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_IR2'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IR2'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.icmsr2,NEW.icmsr2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IR2'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ICMSR2'', OLD.icmsr2, NEW.icmsr2, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.r2_ati,NEW.r2_ati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IR2'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''R2_ATI'', OLD.r2_ati, NEW.r2_ati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10667 --*/
CREATE TRIGGER TG_LOG_td_ir2
AFTER INSERT OR UPDATE OR DELETE ON td_ir2
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ir2();

/*-- SEQ 10668 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ire() CASCADE;

 /*-- SEQ 10669 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ire() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_IRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_IRE'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.aplcon,NEW.aplcon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''APLCON'', OLD.aplcon, NEW.aplcon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.icmsre,NEW.icmsre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ICMSRE'', OLD.icmsre, NEW.icmsre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.re_ati,NEW.re_ati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RE_ATI'', OLD.re_ati, NEW.re_ati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.redcon,NEW.redcon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''REDCON'', OLD.redcon, NEW.redcon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.redtra,NEW.redtra) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''REDTRA'', OLD.redtra, NEW.redtra, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10670 --*/
CREATE TRIGGER TG_LOG_td_ire
AFTER INSERT OR UPDATE OR DELETE ON td_ire
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ire();

/*-- SEQ 10671 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_irr() CASCADE;

 /*-- SEQ 10672 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_irr() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_IRR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_IRR'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IRR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.irrati,NEW.irrati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IRR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IRRATI'', OLD.irrati, NEW.irrati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.resirr,NEW.resirr) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_IRR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RESIRR'', OLD.resirr, NEW.resirr, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10673 --*/
CREATE TRIGGER TG_LOG_td_irr
AFTER INSERT OR UPDATE OR DELETE ON td_irr
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_irr();

/*-- SEQ 10674 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_iso() CASCADE;

 /*-- SEQ 10675 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_iso() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_ISO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_ISO'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ISO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.isoati,NEW.isoati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ISO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ISOATI'', OLD.isoati, NEW.isoati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.phoiso,NEW.phoiso) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ISO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PHOISO'', OLD.phoiso, NEW.phoiso, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10676 --*/
CREATE TRIGGER TG_LOG_td_iso
AFTER INSERT OR UPDATE OR DELETE ON td_iso
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_iso();

/*-- SEQ 10677 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_iss() CASCADE;

 /*-- SEQ 10678 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_iss() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_ISS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_ISS'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.assina,NEW.assina) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ISS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ASSINA'', OLD.assina, NEW.assina, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ISS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.coduid,NEW.coduid) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ISS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODUID'', OLD.coduid, NEW.coduid, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.issati,NEW.issati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ISS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ISSATI'', OLD.issati, NEW.issati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.resiss,NEW.resiss) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ISS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RESISS'', OLD.resiss, NEW.resiss, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10679 --*/
CREATE TRIGGER TG_LOG_td_iss
AFTER INSERT OR UPDATE OR DELETE ON td_iss
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_iss();

/*-- SEQ 10680 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_jus() CASCADE;

 /*-- SEQ 10681 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_jus() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_JUS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_JUS'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.avijus,NEW.avijus) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_JUS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''AVIJUS'', OLD.avijus, NEW.avijus, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_JUS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.comjus,NEW.comjus) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_JUS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COMJUS'', OLD.comjus, NEW.comjus, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desjus,NEW.desjus) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_JUS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESJUS'', OLD.desjus, NEW.desjus, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.jusati,NEW.jusati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_JUS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''JUSATI'', OLD.jusati, NEW.jusati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipjus,NEW.tipjus) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_JUS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPJUS'', OLD.tipjus, NEW.tipjus, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10682 --*/
CREATE TRIGGER TG_LOG_td_jus
AFTER INSERT OR UPDATE OR DELETE ON td_jus
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_jus();

/*-- SEQ 10683 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_lan() CASCADE;

 /*-- SEQ 10684 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_lan() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_LAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_LAN'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.deslan,NEW.deslan) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESLAN'', OLD.deslan, NEW.deslan, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fillan,NEW.fillan) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILLAN'', OLD.fillan, NEW.fillan, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.lanati,NEW.lanati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LANATI'', OLD.lanati, NEW.lanati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.lanedi,NEW.lanedi) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LANEDI'', OLD.lanedi, NEW.lanedi, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.lannat,NEW.lannat) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LANNAT'', OLD.lannat, NEW.lannat, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.lanvlr,NEW.lanvlr) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LANVLR'', OLD.lanvlr, NEW.lanvlr, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.movleg,NEW.movleg) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOVLEG'', OLD.movleg, NEW.movleg, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sinlan,NEW.sinlan) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SINLAN'', OLD.sinlan, NEW.sinlan, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10685 --*/
CREATE TRIGGER TG_LOG_td_lan
AFTER INSERT OR UPDATE OR DELETE ON td_lan
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_lan();

/*-- SEQ 10686 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_lcr() CASCADE;

 /*-- SEQ 10687 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_lcr() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_LCR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_LCR'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codcrt,NEW.codcrt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LCR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODCRT'', OLD.codcrt, NEW.codcrt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LCR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desles,NEW.desles) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LCR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESLES'', OLD.desles, NEW.desles, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ordlis,NEW.ordlis) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LCR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ORDLIS'', OLD.ordlis, NEW.ordlis, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10688 --*/
CREATE TRIGGER TG_LOG_td_lcr
AFTER INSERT OR UPDATE OR DELETE ON td_lcr
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_lcr();

/*-- SEQ 10689 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_lib() CASCADE;

 /*-- SEQ 10690 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_lib() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_LIB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_LIB'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codcor,NEW.codcor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LIB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODCOR'', OLD.codcor, NEW.codcor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codlib,NEW.codlib) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LIB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODLIB'', OLD.codlib, NEW.codlib, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codmat,NEW.codmat) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LIB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODMAT'', OLD.codmat, NEW.codmat, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LIB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtam,NEW.codtam) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LIB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAM'', OLD.codtam, NEW.codtam, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.deslib,NEW.deslib) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LIB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESLIB'', OLD.deslib, NEW.deslib, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filmat,NEW.filmat) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LIB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILMAT'', OLD.filmat, NEW.filmat, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.libati,NEW.libati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LIB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LIBATI'', OLD.libati, NEW.libati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10691 --*/
CREATE TRIGGER TG_LOG_td_lib
AFTER INSERT OR UPDATE OR DELETE ON td_lib
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_lib();

/*-- SEQ 10692 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_lpc() CASCADE;

 /*-- SEQ 10693 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_lpc() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_LPC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_LPC'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LPC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.deslpc,NEW.deslpc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LPC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESLPC'', OLD.deslpc, NEW.deslpc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.lpcati,NEW.lpcati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LPC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LPCATI'', OLD.lpcati, NEW.lpcati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.numext,NEW.numext) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LPC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NUMEXT'', OLD.numext, NEW.numext, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tiprce,NEW.tiprce) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_LPC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPRCE'', OLD.tiprce, NEW.tiprce, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10694 --*/
CREATE TRIGGER TG_LOG_td_lpc
AFTER INSERT OR UPDATE OR DELETE ON td_lpc
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_lpc();

/*-- SEQ 10695 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_maq() CASCADE;

 /*-- SEQ 10696 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_maq() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MAQ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MAQ'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MAQ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.maqatv,NEW.maqatv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MAQ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MAQATV'', OLD.maqatv, NEW.maqatv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nommaq,NEW.nommaq) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MAQ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NOMMAQ'', OLD.nommaq, NEW.nommaq, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10697 --*/
CREATE TRIGGER TG_LOG_td_maq
AFTER INSERT OR UPDATE OR DELETE ON td_maq
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_maq();

/*-- SEQ 10698 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_mar() CASCADE;

 /*-- SEQ 10699 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_mar() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MAR'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.marati,NEW.marati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MARATI'', OLD.marati, NEW.marati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.phomar,NEW.phomar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MAR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PHOMAR'', OLD.phomar, NEW.phomar, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10700 --*/
CREATE TRIGGER TG_LOG_td_mar
AFTER INSERT OR UPDATE OR DELETE ON td_mar
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_mar();

/*-- SEQ 10701 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_mdv() CASCADE;

 /*-- SEQ 10702 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_mdv() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MDV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MDV'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.anofimprod,NEW.anofimprod) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MDV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ANOFIMPROD'', OLD.anofimprod, NEW.anofimprod, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.anoiniprod,NEW.anoiniprod) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MDV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ANOINIPROD'', OLD.anoiniprod, NEW.anoiniprod, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codmar,NEW.codmar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MDV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODMAR'', OLD.codmar, NEW.codmar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MDV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codvei,NEW.codvei) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MDV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODVEI'', OLD.codvei, NEW.codvei, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desmdv,NEW.desmdv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MDV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESMDV'', OLD.desmdv, NEW.desmdv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.disexi,NEW.disexi) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MDV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DISEXI'', OLD.disexi, NEW.disexi, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mdvati,NEW.mdvati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MDV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MDVATI'', OLD.mdvati, NEW.mdvati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10703 --*/
CREATE TRIGGER TG_LOG_td_mdv
AFTER INSERT OR UPDATE OR DELETE ON td_mdv
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_mdv();

/*-- SEQ 10704 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_med() CASCADE;

 /*-- SEQ 10705 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_med() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MED'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MED'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.assina,NEW.assina) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MED'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ASSINA'', OLD.assina, NEW.assina, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codpos_dmed,NEW.codpos_dmed) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MED'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODPOS_DMED'', OLD.codpos_dmed, NEW.codpos_dmed, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MED'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.coduid,NEW.coduid) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MED'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODUID'', OLD.coduid, NEW.coduid, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desmed,NEW.desmed) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MED'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESMED'', OLD.desmed, NEW.desmed, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.medati,NEW.medati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MED'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MEDATI'', OLD.medati, NEW.medati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.unimed,NEW.unimed) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MED'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''UNIMED'', OLD.unimed, NEW.unimed, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10706 --*/
CREATE TRIGGER TG_LOG_td_med
AFTER INSERT OR UPDATE OR DELETE ON td_med
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_med();

/*-- SEQ 10707 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_mod() CASCADE;

 /*-- SEQ 10708 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_mod() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MOD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MOD'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codcom,NEW.codcom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODCOM'', OLD.codcom, NEW.codcom, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codint,NEW.codint) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODINT'', OLD.codint, NEW.codint, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codsac,NEW.codsac) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODSAC'', OLD.codsac, NEW.codsac, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtst,NEW.codtst) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTST'', OLD.codtst, NEW.codtst, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codwor,NEW.codwor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODWOR'', OLD.codwor, NEW.codwor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filcom,NEW.filcom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILCOM'', OLD.filcom, NEW.filcom, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filint,NEW.filint) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILINT'', OLD.filint, NEW.filint, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filsac,NEW.filsac) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILSAC'', OLD.filsac, NEW.filsac, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filtst,NEW.filtst) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILTST'', OLD.filtst, NEW.filtst, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filwor,NEW.filwor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILWOR'', OLD.filwor, NEW.filwor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.grumod,NEW.grumod) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''GRUMOD'', OLD.grumod, NEW.grumod, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.modati,NEW.modati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MODATI'', OLD.modati, NEW.modati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.modulo,NEW.modulo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MODULO'', OLD.modulo, NEW.modulo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.veratu,NEW.veratu) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VERATU'', OLD.veratu, NEW.veratu, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10709 --*/
CREATE TRIGGER TG_LOG_td_mod
AFTER INSERT OR UPDATE OR DELETE ON td_mod
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_mod();

/*-- SEQ 10710 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_moe() CASCADE;

 /*-- SEQ 10711 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_moe() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MOE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MOE'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desmoe,NEW.desmoe) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESMOE'', OLD.desmoe, NEW.desmoe, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.moeati,NEW.moeati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOEATI'', OLD.moeati, NEW.moeati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.moeimg,NEW.moeimg) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOEIMG'', OLD.moeimg, NEW.moeimg, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.moelet,NEW.moelet) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOELET'', OLD.moelet, NEW.moelet, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.moelim,NEW.moelim) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOELIM'', OLD.moelim, NEW.moelim, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.moeniv,NEW.moeniv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOENIV'', OLD.moeniv, NEW.moeniv, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10712 --*/
CREATE TRIGGER TG_LOG_td_moe
AFTER INSERT OR UPDATE OR DELETE ON td_moe
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_moe();

/*-- SEQ 10713 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_mon() CASCADE;

 /*-- SEQ 10714 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_mon() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MON'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MON'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MON'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desmon,NEW.desmon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MON'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESMON'', OLD.desmon, NEW.desmon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.monati,NEW.monati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MON'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MONATI'', OLD.monati, NEW.monati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.moncor,NEW.moncor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MON'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MONCOR'', OLD.moncor, NEW.moncor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.monden,NEW.monden) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MON'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MONDEN'', OLD.monden, NEW.monden, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.monint,NEW.monint) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MON'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MONINT'', OLD.monint, NEW.monint, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.monurb,NEW.monurb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MON'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MONURB'', OLD.monurb, NEW.monurb, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10715 --*/
CREATE TRIGGER TG_LOG_td_mon
AFTER INSERT OR UPDATE OR DELETE ON td_mon
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_mon();

/*-- SEQ 10716 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_mot() CASCADE;

 /*-- SEQ 10717 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_mot() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MOT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MOT'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.cilind,NEW.cilind) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CILIND'', OLD.cilind, NEW.cilind, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.descmo,NEW.descmo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESCMO'', OLD.descmo, NEW.descmo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mtoati,NEW.mtoati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MTOATI'', OLD.mtoati, NEW.mtoati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.potenc,NEW.potenc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''POTENC'', OLD.potenc, NEW.potenc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipcom,NEW.tipcom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MOT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPCOM'', OLD.tipcom, NEW.tipcom, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10718 --*/
CREATE TRIGGER TG_LOG_td_mot
AFTER INSERT OR UPDATE OR DELETE ON td_mot
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_mot();

/*-- SEQ 10719 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_mpb() CASCADE;

 /*-- SEQ 10720 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_mpb() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MPB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MPB'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MPB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desmpb,NEW.desmpb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MPB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESMPB'', OLD.desmpb, NEW.desmpb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mpbati,NEW.mpbati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MPB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MPBATI'', OLD.mpbati, NEW.mpbati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vlrmax,NEW.vlrmax) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MPB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VLRMAX'', OLD.vlrmax, NEW.vlrmax, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10721 --*/
CREATE TRIGGER TG_LOG_td_mpb
AFTER INSERT OR UPDATE OR DELETE ON td_mpb
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_mpb();

/*-- SEQ 10722 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_mtd() CASCADE;

 /*-- SEQ 10723 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_mtd() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MTD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MTD'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MTD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desmtd,NEW.desmtd) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MTD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESMTD'', OLD.desmtd, NEW.desmtd, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mtdati,NEW.mtdati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MTD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MTDATI'', OLD.mtdati, NEW.mtdati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10724 --*/
CREATE TRIGGER TG_LOG_td_mtd
AFTER INSERT OR UPDATE OR DELETE ON td_mtd
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_mtd();

/*-- SEQ 10725 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_mul() CASCADE;

 /*-- SEQ 10726 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_mul() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MUL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MUL'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codext_dmul,NEW.codext_dmul) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MUL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODEXT_DMUL'', OLD.codext_dmul, NEW.codext_dmul, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MUL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desmul,NEW.desmul) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MUL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESMUL'', OLD.desmul, NEW.desmul, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mulati,NEW.mulati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MUL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MULATI'', OLD.mulati, NEW.mulati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mulweb,NEW.mulweb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MUL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MULWEB'', OLD.mulweb, NEW.mulweb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sugest,NEW.sugest) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MUL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SUGEST'', OLD.sugest, NEW.sugest, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10727 --*/
CREATE TRIGGER TG_LOG_td_mul
AFTER INSERT OR UPDATE OR DELETE ON td_mul
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_mul();

/*-- SEQ 10728 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_mvp() CASCADE;

 /*-- SEQ 10729 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_mvp() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MVP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_MVP'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.acrmaxmot,NEW.acrmaxmot) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MVP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ACRMAXMOT'', OLD.acrmaxmot, NEW.acrmaxmot, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MVP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.conmot,NEW.conmot) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MVP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CONMOT'', OLD.conmot, NEW.conmot, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desmaxmot,NEW.desmaxmot) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MVP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESMAXMOT'', OLD.desmaxmot, NEW.desmaxmot, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desmot,NEW.desmot) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MVP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESMOT'', OLD.desmot, NEW.desmot, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.motati,NEW.motati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MVP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOTATI'', OLD.motati, NEW.motati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.permot,NEW.permot) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MVP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERMOT'', OLD.permot, NEW.permot, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipmot,NEW.tipmot) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MVP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPMOT'', OLD.tipmot, NEW.tipmot, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usomot,NEW.usomot) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_MVP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USOMOT'', OLD.usomot, NEW.usomot, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10730 --*/
CREATE TRIGGER TG_LOG_td_mvp
AFTER INSERT OR UPDATE OR DELETE ON td_mvp
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_mvp();

/*-- SEQ 10731 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_nat() CASCADE;

 /*-- SEQ 10732 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_nat() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_NAT'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.coment,NEW.coment) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COMENT'', OLD.coment, NEW.coment, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.conloc,NEW.conloc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CONLOC'', OLD.conloc, NEW.conloc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.consfi,NEW.consfi) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CONSFI'', OLD.consfi, NEW.consfi, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cst_st,NEW.cst_st) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CST_ST'', OLD.cst_st, NEW.cst_st, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cstnor,NEW.cstnor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CSTNOR'', OLD.cstnor, NEW.cstnor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.devvin,NEW.devvin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DEVVIN'', OLD.devvin, NEW.devvin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.extdem,NEW.extdem) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXTDEM'', OLD.extdem, NEW.extdem, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.extfor,NEW.extfor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXTFOR'', OLD.extfor, NEW.extfor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.financ,NEW.financ) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FINANC'', OLD.financ, NEW.financ, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.lanven,NEW.lanven) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LANVEN'', OLD.lanven, NEW.lanven, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.limite,NEW.limite) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LIMITE'', OLD.limite, NEW.limite, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.movest,NEW.movest) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOVEST'', OLD.movest, NEW.movest, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natati,NEW.natati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATATI'', OLD.natati, NEW.natati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natbcc,NEW.natbcc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATBCC'', OLD.natbcc, NEW.natbcc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natden,NEW.natden) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATDEN'', OLD.natden, NEW.natden, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natden_fil,NEW.natden_fil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATDEN_FIL'', OLD.natden_fil, NEW.natden_fil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natden_seq,NEW.natden_seq) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATDEN_SEQ'', OLD.natden_seq, NEW.natden_seq, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natden_tip,NEW.natden_tip) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATDEN_TIP'', OLD.natden_tip, NEW.natden_tip, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natesd,NEW.natesd) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATESD'', OLD.natesd, NEW.natesd, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natesf,NEW.natesf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATESF'', OLD.natesf, NEW.natesf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natest_fil,NEW.natest_fil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATEST_FIL'', OLD.natest_fil, NEW.natest_fil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natest_seq,NEW.natest_seq) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATEST_SEQ'', OLD.natest_seq, NEW.natest_seq, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natest_tip,NEW.natest_tip) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATEST_TIP'', OLD.natest_tip, NEW.natest_tip, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natfor,NEW.natfor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATFOR'', OLD.natfor, NEW.natfor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natfor_fil,NEW.natfor_fil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATFOR_FIL'', OLD.natfor_fil, NEW.natfor_fil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natfor_seq,NEW.natfor_seq) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATFOR_SEQ'', OLD.natfor_seq, NEW.natfor_seq, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natfor_tip,NEW.natfor_tip) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATFOR_TIP'', OLD.natfor_tip, NEW.natfor_tip, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natfud,NEW.natfud) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATFUD'', OLD.natfud, NEW.natfud, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natfuf,NEW.natfuf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATFUF'', OLD.natfuf, NEW.natfuf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natmen,NEW.natmen) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATMEN'', OLD.natmen, NEW.natmen, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natmod,NEW.natmod) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATMOD'', OLD.natmod, NEW.natmod, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natmul,NEW.natmul) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATMUL'', OLD.natmul, NEW.natmul, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natoln,NEW.natoln) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATOLN'', OLD.natoln, NEW.natoln, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natpre,NEW.natpre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATPRE'', OLD.natpre, NEW.natpre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natred,NEW.natred) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATRED'', OLD.natred, NEW.natred, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natred_st,NEW.natred_st) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATRED_ST'', OLD.natred_st, NEW.natred_st, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natref,NEW.natref) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATREF'', OLD.natref, NEW.natref, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natref_st,NEW.natref_st) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATREF_ST'', OLD.natref_st, NEW.natref_st, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nature,NEW.nature) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATURE'', OLD.nature, NEW.nature, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natutl,NEW.natutl) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATUTL'', OLD.natutl, NEW.natutl, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.observ,NEW.observ) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OBSERV'', OLD.observ, NEW.observ, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqexc,NEW.seqexc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQEXC'', OLD.seqexc, NEW.seqexc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.servin,NEW.servin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERVIN'', OLD.servin, NEW.servin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sitcof,NEW.sitcof) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SITCOF'', OLD.sitcof, NEW.sitcof, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sitpis,NEW.sitpis) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SITPIS'', OLD.sitpis, NEW.sitpis, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipnat,NEW.tipnat) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPNAT'', OLD.tipnat, NEW.tipnat, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tribut,NEW.tribut) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TRIBUT'', OLD.tribut, NEW.tribut, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usacus,NEW.usacus) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USACUS'', OLD.usacus, NEW.usacus, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usaicm,NEW.usaicm) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USAICM'', OLD.usaicm, NEW.usaicm, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usaipi,NEW.usaipi) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USAIPI'', OLD.usaipi, NEW.usaipi, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10733 --*/
CREATE TRIGGER TG_LOG_td_nat
AFTER INSERT OR UPDATE OR DELETE ON td_nat
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_nat();

/*-- SEQ 10734 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_niv() CASCADE;

 /*-- SEQ 10735 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_niv() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_NIV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_NIV'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NIV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desniv,NEW.desniv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NIV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESNIV'', OLD.desniv, NEW.desniv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fatniv,NEW.fatniv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NIV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FATNIV'', OLD.fatniv, NEW.fatniv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nivati,NEW.nivati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NIV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NIVATI'', OLD.nivati, NEW.nivati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.perniv,NEW.perniv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_NIV'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERNIV'', OLD.perniv, NEW.perniv, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10736 --*/
CREATE TRIGGER TG_LOG_td_niv
AFTER INSERT OR UPDATE OR DELETE ON td_niv
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_niv();

/*-- SEQ 10737 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_obs() CASCADE;

 /*-- SEQ 10738 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_obs() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_OBS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_OBS'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OBS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desobs,NEW.desobs) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OBS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESOBS'', OLD.desobs, NEW.desobs, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.obsati,NEW.obsati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OBS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OBSATI'', OLD.obsati, NEW.obsati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.txtobs,NEW.txtobs) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OBS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TXTOBS'', OLD.txtobs, NEW.txtobs, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usuobs,NEW.usuobs) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OBS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USUOBS'', OLD.usuobs, NEW.usuobs, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10739 --*/
CREATE TRIGGER TG_LOG_td_obs
AFTER INSERT OR UPDATE OR DELETE ON td_obs
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_obs();

/*-- SEQ 10740 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ocu() CASCADE;

 /*-- SEQ 10741 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ocu() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_OCU'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_OCU'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.basocu,NEW.basocu) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OCU'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''BASOCU'', OLD.basocu, NEW.basocu, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OCU'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desocu,NEW.desocu) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OCU'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESOCU'', OLD.desocu, NEW.desocu, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ocuati,NEW.ocuati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OCU'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OCUATI'', OLD.ocuati, NEW.ocuati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10742 --*/
CREATE TRIGGER TG_LOG_td_ocu
AFTER INSERT OR UPDATE OR DELETE ON td_ocu
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ocu();

/*-- SEQ 10743 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_omi() CASCADE;

 /*-- SEQ 10744 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_omi() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_OMI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_OMI'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OMI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desomi,NEW.desomi) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OMI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESOMI'', OLD.desomi, NEW.desomi, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.omiati,NEW.omiati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OMI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OMIATI'', OLD.omiati, NEW.omiati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.omicon,NEW.omicon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OMI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OMICON'', OLD.omicon, NEW.omicon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.omifil,NEW.omifil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OMI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OMIFIL'', OLD.omifil, NEW.omifil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.omilis,NEW.omilis) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OMI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OMILIS'', OLD.omilis, NEW.omilis, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.omires,NEW.omires) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OMI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OMIRES'', OLD.omires, NEW.omires, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10745 --*/
CREATE TRIGGER TG_LOG_td_omi
AFTER INSERT OR UPDATE OR DELETE ON td_omi
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_omi();

/*-- SEQ 10746 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_out() CASCADE;

 /*-- SEQ 10747 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_out() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_OUT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_OUT'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OUT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dadrec,NEW.dadrec) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OUT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DADREC'', OLD.dadrec, NEW.dadrec, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.descar,NEW.descar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OUT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESCAR'', OLD.descar, NEW.descar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.outati,NEW.outati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OUT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OUTATI'', OLD.outati, NEW.outati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.outimg,NEW.outimg) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OUT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OUTIMG'', OLD.outimg, NEW.outimg, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.outlet,NEW.outlet) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OUT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OUTLET'', OLD.outlet, NEW.outlet, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.outlim,NEW.outlim) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OUT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OUTLIM'', OLD.outlim, NEW.outlim, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.outniv,NEW.outniv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OUT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OUTNIV'', OLD.outniv, NEW.outniv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.regout,NEW.regout) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_OUT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''REGOUT'', OLD.regout, NEW.regout, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10748 --*/
CREATE TRIGGER TG_LOG_td_out
AFTER INSERT OR UPDATE OR DELETE ON td_out
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_out();

/*-- SEQ 10749 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_per() CASCADE;

 /*-- SEQ 10750 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_per() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_PER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_PER'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desper,NEW.desper) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESPER'', OLD.desper, NEW.desper, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.perati,NEW.perati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERATI'', OLD.perati, NEW.perati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.percod,NEW.percod) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERCOD'', OLD.percod, NEW.percod, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.perord,NEW.perord) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERORD'', OLD.perord, NEW.perord, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10751 --*/
CREATE TRIGGER TG_LOG_td_per
AFTER INSERT OR UPDATE OR DELETE ON td_per
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_per();

/*-- SEQ 10752 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_pes() CASCADE;

 /*-- SEQ 10753 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_pes() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_PES'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_PES'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PES'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.despes,NEW.despes) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PES'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESPES'', OLD.despes, NEW.despes, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pesati,NEW.pesati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PES'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PESATI'', OLD.pesati, NEW.pesati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pesfim,NEW.pesfim) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PES'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PESFIM'', OLD.pesfim, NEW.pesfim, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pesini,NEW.pesini) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PES'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PESINI'', OLD.pesini, NEW.pesini, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10754 --*/
CREATE TRIGGER TG_LOG_td_pes
AFTER INSERT OR UPDATE OR DELETE ON td_pes
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_pes();

/*-- SEQ 10755 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_pgf() CASCADE;

 /*-- SEQ 10756 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_pgf() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_PGF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_PGF'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codbco,NEW.codbco) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PGF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODBCO'', OLD.codbco, NEW.codbco, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codext,NEW.codext) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PGF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODEXT'', OLD.codext, NEW.codext, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PGF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.msgret,NEW.msgret) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PGF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MSGRET'', OLD.msgret, NEW.msgret, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pgfati,NEW.pgfati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PGF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PGFATI'', OLD.pgfati, NEW.pgfati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipreg,NEW.tipreg) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PGF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPREG'', OLD.tipreg, NEW.tipreg, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipret,NEW.tipret) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PGF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPRET'', OLD.tipret, NEW.tipret, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10757 --*/
CREATE TRIGGER TG_LOG_td_pgf
AFTER INSERT OR UPDATE OR DELETE ON td_pgf
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_pgf();

/*-- SEQ 10758 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_pho() CASCADE;

 /*-- SEQ 10759 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_pho() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_PHO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_PHO'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PHO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.phoati,NEW.phoati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PHO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PHOATI'', OLD.phoati, NEW.phoati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.phoout,NEW.phoout) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PHO'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PHOOUT'', OLD.phoout, NEW.phoout, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10760 --*/
CREATE TRIGGER TG_LOG_td_pho
AFTER INSERT OR UPDATE OR DELETE ON td_pho
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_pho();

/*-- SEQ 10761 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_pre() CASCADE;

 /*-- SEQ 10762 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_pre() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_PRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_PRE'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.cabpre,NEW.cabpre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CABPRE'', OLD.cabpre, NEW.cabpre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.despre,NEW.despre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESPRE'', OLD.despre, NEW.despre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.itepre,NEW.itepre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ITEPRE'', OLD.itepre, NEW.itepre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.numpre,NEW.numpre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NUMPRE'', OLD.numpre, NEW.numpre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.preati,NEW.preati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PREATI'', OLD.preati, NEW.preati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.rodpre,NEW.rodpre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RODPRE'', OLD.rodpre, NEW.rodpre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usopre,NEW.usopre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PRE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USOPRE'', OLD.usopre, NEW.usopre, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10763 --*/
CREATE TRIGGER TG_LOG_td_pre
AFTER INSERT OR UPDATE OR DELETE ON td_pre
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_pre();

/*-- SEQ 10764 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_pri() CASCADE;

 /*-- SEQ 10765 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_pri() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_PRI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_PRI'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.apepri,NEW.apepri) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PRI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''APEPRI'', OLD.apepri, NEW.apepri, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.carenc,NEW.carenc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PRI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CARENC'', OLD.carenc, NEW.carenc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PRI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.despri,NEW.despri) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PRI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESPRI'', OLD.despri, NEW.despri, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.horpad,NEW.horpad) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PRI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HORPAD'', OLD.horpad, NEW.horpad, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.hortrn,NEW.hortrn) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PRI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HORTRN'', OLD.hortrn, NEW.hortrn, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.obspri,NEW.obspri) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PRI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OBSPRI'', OLD.obspri, NEW.obspri, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pespri,NEW.pespri) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PRI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PESPRI'', OLD.pespri, NEW.pespri, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.priati,NEW.priati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PRI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRIATI'', OLD.priati, NEW.priati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.serevi,NEW.serevi) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PRI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEREVI'', OLD.serevi, NEW.serevi, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tiphor,NEW.tiphor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PRI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPHOR'', OLD.tiphor, NEW.tiphor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.worpri,NEW.worpri) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_PRI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''WORPRI'', OLD.worpri, NEW.worpri, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10766 --*/
CREATE TRIGGER TG_LOG_td_pri
AFTER INSERT OR UPDATE OR DELETE ON td_pri
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_pri();

/*-- SEQ 10767 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_reg() CASCADE;

 /*-- SEQ 10768 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_reg() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_REG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_REG'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.cepfim,NEW.cepfim) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CEPFIM'', OLD.cepfim, NEW.cepfim, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cepini,NEW.cepini) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CEPINI'', OLD.cepini, NEW.cepini, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.regati,NEW.regati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''REGATI'', OLD.regati, NEW.regati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.regiao,NEW.regiao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''REGIAO'', OLD.regiao, NEW.regiao, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10769 --*/
CREATE TRIGGER TG_LOG_td_reg
AFTER INSERT OR UPDATE OR DELETE ON td_reg
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_reg();

/*-- SEQ 10770 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_rej() CASCADE;

 /*-- SEQ 10771 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_rej() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_REJ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_REJ'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codbco,NEW.codbco) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REJ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODBCO'', OLD.codbco, NEW.codbco, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codrej,NEW.codrej) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REJ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODREJ'', OLD.codrej, NEW.codrej, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REJ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desrej,NEW.desrej) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REJ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESREJ'', OLD.desrej, NEW.desrej, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.rejati,NEW.rejati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REJ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''REJATI'', OLD.rejati, NEW.rejati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10772 --*/
CREATE TRIGGER TG_LOG_td_rej
AFTER INSERT OR UPDATE OR DELETE ON td_rej
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_rej();

/*-- SEQ 10773 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_rel() CASCADE;

 /*-- SEQ 10774 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_rel() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_REL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_REL'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desrel,NEW.desrel) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESREL'', OLD.desrel, NEW.desrel, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.primax,NEW.primax) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRIMAX'', OLD.primax, NEW.primax, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.primin,NEW.primin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRIMIN'', OLD.primin, NEW.primin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.relati,NEW.relati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REL'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RELATI'', OLD.relati, NEW.relati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10775 --*/
CREATE TRIGGER TG_LOG_td_rel
AFTER INSERT OR UPDATE OR DELETE ON td_rel
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_rel();

/*-- SEQ 10776 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_rem() CASCADE;

 /*-- SEQ 10777 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_rem() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_REM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_REM'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desrem,NEW.desrem) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESREM'', OLD.desrem, NEW.desrem, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.remati,NEW.remati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''REMATI'', OLD.remati, NEW.remati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10778 --*/
CREATE TRIGGER TG_LOG_td_rem
AFTER INSERT OR UPDATE OR DELETE ON td_rem
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_rem();

/*-- SEQ 10779 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_req() CASCADE;

 /*-- SEQ 10780 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_req() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_REQ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_REQ'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.abrreq,NEW.abrreq) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REQ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ABRREQ'', OLD.abrreq, NEW.abrreq, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.clareq,NEW.clareq) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REQ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLAREQ'', OLD.clareq, NEW.clareq, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REQ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desreq,NEW.desreq) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REQ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESREQ'', OLD.desreq, NEW.desreq, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.reqati,NEW.reqati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_REQ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''REQATI'', OLD.reqati, NEW.reqati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10781 --*/
CREATE TRIGGER TG_LOG_td_req
AFTER INSERT OR UPDATE OR DELETE ON td_req
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_req();

/*-- SEQ 10782 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ret() CASCADE;

 /*-- SEQ 10783 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ret() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_RET'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_RET'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RET'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desret,NEW.desret) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RET'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESRET'', OLD.desret, NEW.desret, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.flgnew,NEW.flgnew) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RET'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FLGNEW'', OLD.flgnew, NEW.flgnew, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.retati,NEW.retati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RET'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RETATI'', OLD.retati, NEW.retati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10784 --*/
CREATE TRIGGER TG_LOG_td_ret
AFTER INSERT OR UPDATE OR DELETE ON td_ret
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ret();

/*-- SEQ 10785 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_rgc() CASCADE;

 /*-- SEQ 10786 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_rgc() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_RGC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_RGC'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RGC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desrgc,NEW.desrgc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RGC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESRGC'', OLD.desrgc, NEW.desrgc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.flgdev,NEW.flgdev) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RGC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FLGDEV'', OLD.flgdev, NEW.flgdev, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.flgenc,NEW.flgenc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RGC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FLGENC'', OLD.flgenc, NEW.flgenc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.rgc_tipent,NEW.rgc_tipent) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RGC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RGC_TIPENT'', OLD.rgc_tipent, NEW.rgc_tipent, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.rgcati,NEW.rgcati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RGC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RGCATI'', OLD.rgcati, NEW.rgcati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10787 --*/
CREATE TRIGGER TG_LOG_td_rgc
AFTER INSERT OR UPDATE OR DELETE ON td_rgc
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_rgc();

/*-- SEQ 10788 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ros() CASCADE;

 /*-- SEQ 10789 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ros() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_ROS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_ROS'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ROS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.result,NEW.result) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ROS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RESULT'', OLD.result, NEW.result, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.rosati,NEW.rosati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_ROS'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ROSATI'', OLD.rosati, NEW.rosati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10790 --*/
CREATE TRIGGER TG_LOG_td_ros
AFTER INSERT OR UPDATE OR DELETE ON td_ros
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ros();

/*-- SEQ 10791 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_rtt() CASCADE;

 /*-- SEQ 10792 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_rtt() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_RTT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_RTT'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RTT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desrtt,NEW.desrtt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RTT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESRTT'', OLD.desrtt, NEW.desrtt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filcta_drtt,NEW.filcta_drtt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RTT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILCTA_DRTT'', OLD.filcta_drtt, NEW.filcta_drtt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filcta_est_drtt,NEW.filcta_est_drtt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RTT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILCTA_EST_DRTT'', OLD.filcta_est_drtt, NEW.filcta_est_drtt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.rttati,NEW.rttati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RTT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RTTATI'', OLD.rttati, NEW.rttati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.rttbar,NEW.rttbar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RTT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RTTBAR'', OLD.rttbar, NEW.rttbar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.rttdig,NEW.rttdig) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RTT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RTTDIG'', OLD.rttdig, NEW.rttdig, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.rttest,NEW.rttest) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RTT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RTTEST'', OLD.rttest, NEW.rttest, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.rtttef,NEW.rtttef) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RTT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RTTTEF'', OLD.rtttef, NEW.rtttef, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.rtttip,NEW.rtttip) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RTT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RTTTIP'', OLD.rtttip, NEW.rtttip, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqcta_drtt,NEW.seqcta_drtt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RTT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQCTA_DRTT'', OLD.seqcta_drtt, NEW.seqcta_drtt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqcta_est_drtt,NEW.seqcta_est_drtt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RTT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQCTA_EST_DRTT'', OLD.seqcta_est_drtt, NEW.seqcta_est_drtt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipcta_drtt,NEW.tipcta_drtt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RTT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPCTA_DRTT'', OLD.tipcta_drtt, NEW.tipcta_drtt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipcta_est_drtt,NEW.tipcta_est_drtt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_RTT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPCTA_EST_DRTT'', OLD.tipcta_est_drtt, NEW.tipcta_est_drtt, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10793 --*/
CREATE TRIGGER TG_LOG_td_rtt
AFTER INSERT OR UPDATE OR DELETE ON td_rtt
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_rtt();

/*-- SEQ 10794 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_sad() CASCADE;

 /*-- SEQ 10795 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_sad() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_SAD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_SAD'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.acrmax,NEW.acrmax) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ACRMAX'', OLD.acrmax, NEW.acrmax, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codrtt,NEW.codrtt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODRTT'', OLD.codrtt, NEW.codrtt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desmin,NEW.desmin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESMIN'', OLD.desmin, NEW.desmin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dessad,NEW.dessad) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESSAD'', OLD.dessad, NEW.dessad, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.diares,NEW.diares) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIARES'', OLD.diares, NEW.diares, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.flgpes,NEW.flgpes) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FLGPES'', OLD.flgpes, NEW.flgpes, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fornum_ck4g,NEW.fornum_ck4g) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FORNUM_CK4G'', OLD.fornum_ck4g, NEW.fornum_ck4g, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.impdoc,NEW.impdoc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IMPDOC'', OLD.impdoc, NEW.impdoc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.numini,NEW.numini) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NUMINI'', OLD.numini, NEW.numini, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.percom_dsad,NEW.percom_dsad) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERCOM_DSAD'', OLD.percom_dsad, NEW.percom_dsad, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.periof,NEW.periof) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERIOF'', OLD.periof, NEW.periof, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.persad,NEW.persad) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERSAD'', OLD.persad, NEW.persad, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.repsad,NEW.repsad) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''REPSAD'', OLD.repsad, NEW.repsad, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sadati,NEW.sadati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SADATI'', OLD.sadati, NEW.sadati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.somgar,NEW.somgar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SOMGAR'', OLD.somgar, NEW.somgar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sugorc,NEW.sugorc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SUGORC'', OLD.sugorc, NEW.sugorc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipval,NEW.tipval) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPVAL'', OLD.tipval, NEW.tipval, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.valida,NEW.valida) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VALIDA'', OLD.valida, NEW.valida, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.valsad,NEW.valsad) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VALSAD'', OLD.valsad, NEW.valsad, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.venavu,NEW.venavu) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VENAVU'', OLD.venavu, NEW.venavu, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10796 --*/
CREATE TRIGGER TG_LOG_td_sad
AFTER INSERT OR UPDATE OR DELETE ON td_sad
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_sad();

/*-- SEQ 10797 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_sad_can() CASCADE;

 /*-- SEQ 10798 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_sad_can() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_SAD_CAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_SAD_CAN'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAD_CAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10799 --*/
CREATE TRIGGER TG_LOG_td_sad_can
AFTER INSERT OR UPDATE OR DELETE ON td_sad_can
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_sad_can();

/*-- SEQ 10800 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_sat() CASCADE;

 /*-- SEQ 10801 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_sat() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_SAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_SAT'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dessat,NEW.dessat) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESSAT'', OLD.dessat, NEW.dessat, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sat_cnt_ro,NEW.sat_cnt_ro) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAT_CNT_RO'', OLD.sat_cnt_ro, NEW.sat_cnt_ro, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sat_codfil,NEW.sat_codfil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAT_CODFIL'', OLD.sat_codfil, NEW.sat_codfil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sat_codser,NEW.sat_codser) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAT_CODSER'', OLD.sat_codser, NEW.sat_codser, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sat_numser,NEW.sat_numser) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAT_NUMSER'', OLD.sat_numser, NEW.sat_numser, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.satati,NEW.satati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SATATI'', OLD.satati, NEW.satati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10802 --*/
CREATE TRIGGER TG_LOG_td_sat
AFTER INSERT OR UPDATE OR DELETE ON td_sat
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_sat();

/*-- SEQ 10803 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_saz() CASCADE;

 /*-- SEQ 10804 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_saz() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_SAZ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_SAZ'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAZ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dessaz,NEW.dessaz) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAZ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESSAZ'', OLD.dessaz, NEW.dessaz, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.saz001,NEW.saz001) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAZ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAZ001'', OLD.saz001, NEW.saz001, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.saz002,NEW.saz002) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAZ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAZ002'', OLD.saz002, NEW.saz002, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.saz003,NEW.saz003) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAZ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAZ003'', OLD.saz003, NEW.saz003, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.saz004,NEW.saz004) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAZ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAZ004'', OLD.saz004, NEW.saz004, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.saz005,NEW.saz005) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAZ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAZ005'', OLD.saz005, NEW.saz005, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.saz006,NEW.saz006) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAZ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAZ006'', OLD.saz006, NEW.saz006, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.saz007,NEW.saz007) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAZ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAZ007'', OLD.saz007, NEW.saz007, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.saz008,NEW.saz008) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAZ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAZ008'', OLD.saz008, NEW.saz008, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.saz009,NEW.saz009) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAZ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAZ009'', OLD.saz009, NEW.saz009, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.saz010,NEW.saz010) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAZ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAZ010'', OLD.saz010, NEW.saz010, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.saz011,NEW.saz011) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAZ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAZ011'', OLD.saz011, NEW.saz011, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.saz012,NEW.saz012) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAZ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAZ012'', OLD.saz012, NEW.saz012, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sazati,NEW.sazati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SAZ'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAZATI'', OLD.sazati, NEW.sazati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10805 --*/
CREATE TRIGGER TG_LOG_td_saz
AFTER INSERT OR UPDATE OR DELETE ON td_saz
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_saz();

/*-- SEQ 10806 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ser() CASCADE;

 /*-- SEQ 10807 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ser() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_SER'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codser,NEW.codser) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODSER'', OLD.codser, NEW.codser, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desser,NEW.desser) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESSER'', OLD.desser, NEW.desser, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dissai,NEW.dissai) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DISSAI'', OLD.dissai, NEW.dissai, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.divtro,NEW.divtro) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIVTRO'', OLD.divtro, NEW.divtro, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.envnfs,NEW.envnfs) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ENVNFS'', OLD.envnfs, NEW.envnfs, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.extnot,NEW.extnot) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXTNOT'', OLD.extnot, NEW.extnot, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.impnot,NEW.impnot) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IMPNOT'', OLD.impnot, NEW.impnot, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.modnot,NEW.modnot) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MODNOT'', OLD.modnot, NEW.modnot, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.obscol,NEW.obscol) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OBSCOL'', OLD.obscol, NEW.obscol, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.obslin,NEW.obslin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OBSLIN'', OLD.obslin, NEW.obslin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.qtditp,NEW.qtditp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''QTDITP'', OLD.qtditp, NEW.qtditp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.qtdits,NEW.qtdits) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''QTDITS'', OLD.qtdits, NEW.qtdits, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.recibo,NEW.recibo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RECIBO'', OLD.recibo, NEW.recibo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.restri,NEW.restri) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RESTRI'', OLD.restri, NEW.restri, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.serati,NEW.serati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERATI'', OLD.serati, NEW.serati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sercon,NEW.sercon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERCON'', OLD.sercon, NEW.sercon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.serdoc,NEW.serdoc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERDOC'', OLD.serdoc, NEW.serdoc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.serext,NEW.serext) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEREXT'', OLD.serext, NEW.serext, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.serfim,NEW.serfim) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERFIM'', OLD.serfim, NEW.serfim, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.serini,NEW.serini) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERINI'', OLD.serini, NEW.serini, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.serman,NEW.serman) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERMAN'', OLD.serman, NEW.serman, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.serord,NEW.serord) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERORD'', OLD.serord, NEW.serord, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.serrem,NEW.serrem) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERREM'', OLD.serrem, NEW.serrem, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.serutl,NEW.serutl) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERUTL'', OLD.serutl, NEW.serutl, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.titavu,NEW.titavu) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TITAVU'', OLD.titavu, NEW.titavu, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.txtent,NEW.txtent) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TXTENT'', OLD.txtent, NEW.txtent, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.txtfim,NEW.txtfim) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TXTFIM'', OLD.txtfim, NEW.txtfim, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.txtini,NEW.txtini) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TXTINI'', OLD.txtini, NEW.txtini, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.txtite,NEW.txtite) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TXTITE'', OLD.txtite, NEW.txtite, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.txtobs,NEW.txtobs) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TXTOBS'', OLD.txtobs, NEW.txtobs, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.txtser,NEW.txtser) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TXTSER'', OLD.txtser, NEW.txtser, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10808 --*/
CREATE TRIGGER TG_LOG_td_ser
AFTER INSERT OR UPDATE OR DELETE ON td_ser
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ser();

/*-- SEQ 10809 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_set() CASCADE;

 /*-- SEQ 10810 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_set() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_SET'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_SET'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SET'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desset,NEW.desset) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SET'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESSET'', OLD.desset, NEW.desset, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filset,NEW.filset) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SET'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILSET'', OLD.filset, NEW.filset, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.prjset,NEW.prjset) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SET'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRJSET'', OLD.prjset, NEW.prjset, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.setati,NEW.setati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SET'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SETATI'', OLD.setati, NEW.setati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10811 --*/
CREATE TRIGGER TG_LOG_td_set
AFTER INSERT OR UPDATE OR DELETE ON td_set
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_set();

/*-- SEQ 10812 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_sim() CASCADE;

 /*-- SEQ 10813 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_sim() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_SIM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_SIM'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SIM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pericm,NEW.pericm) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SIM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERICM'', OLD.pericm, NEW.pericm, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vlrfim,NEW.vlrfim) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SIM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VLRFIM'', OLD.vlrfim, NEW.vlrfim, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vlrini,NEW.vlrini) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SIM'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VLRINI'', OLD.vlrini, NEW.vlrini, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10814 --*/
CREATE TRIGGER TG_LOG_td_sim
AFTER INSERT OR UPDATE OR DELETE ON td_sim
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_sim();

/*-- SEQ 10815 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_sit() CASCADE;

 /*-- SEQ 10816 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_sit() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_SIT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_SIT'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SIT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dessit,NEW.dessit) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SIT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESSIT'', OLD.dessit, NEW.dessit, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.flgmod,NEW.flgmod) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SIT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FLGMOD'', OLD.flgmod, NEW.flgmod, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.flgreg,NEW.flgreg) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SIT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FLGREG'', OLD.flgreg, NEW.flgreg, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.flgres,NEW.flgres) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SIT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FLGRES'', OLD.flgres, NEW.flgres, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.flgrev,NEW.flgrev) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SIT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FLGREV'', OLD.flgrev, NEW.flgrev, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ger_cc,NEW.ger_cc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SIT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''GER_CC'', OLD.ger_cc, NEW.ger_cc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sitati,NEW.sitati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SIT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SITATI'', OLD.sitati, NEW.sitati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sitmai,NEW.sitmai) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SIT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SITMAI'', OLD.sitmai, NEW.sitmai, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipado,NEW.tipado) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SIT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPADO'', OLD.tipado, NEW.tipado, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipsit,NEW.tipsit) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SIT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPSIT'', OLD.tipsit, NEW.tipsit, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10817 --*/
CREATE TRIGGER TG_LOG_td_sit
AFTER INSERT OR UPDATE OR DELETE ON td_sit
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_sit();

/*-- SEQ 10818 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_std() CASCADE;

 /*-- SEQ 10819 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_std() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_STD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_STD'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desstd,NEW.desstd) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESSTD'', OLD.desstd, NEW.desstd, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.domdop,NEW.domdop) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DOMDOP'', OLD.domdop, NEW.domdop, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.flgflx,NEW.flgflx) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FLGFLX'', OLD.flgflx, NEW.flgflx, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.stdati,NEW.stdati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''STDATI'', OLD.stdati, NEW.stdati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usostd,NEW.usostd) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USOSTD'', OLD.usostd, NEW.usostd, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10820 --*/
CREATE TRIGGER TG_LOG_td_std
AFTER INSERT OR UPDATE OR DELETE ON td_std
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_std();

/*-- SEQ 10821 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_stf() CASCADE;

 /*-- SEQ 10822 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_stf() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_STF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_STF'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desstf,NEW.desstf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESSTF'', OLD.desstf, NEW.desstf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.stf_codcfo,NEW.stf_codcfo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''STF_CODCFO'', OLD.stf_codcfo, NEW.stf_codcfo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.stf_codctr,NEW.stf_codctr) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''STF_CODCTR'', OLD.stf_codctr, NEW.stf_codctr, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.stf_codcus,NEW.stf_codcus) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''STF_CODCUS'', OLD.stf_codcus, NEW.stf_codcus, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.stf_coddar,NEW.stf_coddar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''STF_CODDAR'', OLD.stf_coddar, NEW.stf_coddar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.stf_codfor,NEW.stf_codfor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''STF_CODFOR'', OLD.stf_codfor, NEW.stf_codfor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.stf_codfps,NEW.stf_codfps) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''STF_CODFPS'', OLD.stf_codfps, NEW.stf_codfps, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.stf_codser,NEW.stf_codser) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''STF_CODSER'', OLD.stf_codser, NEW.stf_codser, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.stf_codset,NEW.stf_codset) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''STF_CODSET'', OLD.stf_codset, NEW.stf_codset, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.stf_diaven,NEW.stf_diaven) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''STF_DIAVEN'', OLD.stf_diaven, NEW.stf_diaven, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.stf_filcta,NEW.stf_filcta) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''STF_FILCTA'', OLD.stf_filcta, NEW.stf_filcta, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.stf_filfor,NEW.stf_filfor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''STF_FILFOR'', OLD.stf_filfor, NEW.stf_filfor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.stf_seqcta,NEW.stf_seqcta) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''STF_SEQCTA'', OLD.stf_seqcta, NEW.stf_seqcta, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.stf_subser,NEW.stf_subser) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''STF_SUBSER'', OLD.stf_subser, NEW.stf_subser, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.stf_tipcta,NEW.stf_tipcta) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''STF_TIPCTA'', OLD.stf_tipcta, NEW.stf_tipcta, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.stfati,NEW.stfati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STF'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''STFATI'', OLD.stfati, NEW.stfati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10823 --*/
CREATE TRIGGER TG_LOG_td_stf
AFTER INSERT OR UPDATE OR DELETE ON td_stf
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_stf();

/*-- SEQ 10824 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_str() CASCADE;

 /*-- SEQ 10825 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_str() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_STR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_STR'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desstr,NEW.desstr) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESSTR'', OLD.desstr, NEW.desstr, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.flgstr,NEW.flgstr) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FLGSTR'', OLD.flgstr, NEW.flgstr, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.strati,NEW.strati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_STR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''STRATI'', OLD.strati, NEW.strati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10826 --*/
CREATE TRIGGER TG_LOG_td_str
AFTER INSERT OR UPDATE OR DELETE ON td_str
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_str();

/*-- SEQ 10827 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_sub() CASCADE;

 /*-- SEQ 10828 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_sub() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_SUB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_SUB'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codext,NEW.codext) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SUB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODEXT'', OLD.codext, NEW.codext, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codsal,NEW.codsal) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SUB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODSAL'', OLD.codsal, NEW.codsal, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SUB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nomsub,NEW.nomsub) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SUB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NOMSUB'', OLD.nomsub, NEW.nomsub, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ordsub,NEW.ordsub) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SUB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ORDSUB'', OLD.ordsub, NEW.ordsub, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.subati,NEW.subati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_SUB'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SUBATI'', OLD.subati, NEW.subati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10829 --*/
CREATE TRIGGER TG_LOG_td_sub
AFTER INSERT OR UPDATE OR DELETE ON td_sub
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_sub();

/*-- SEQ 10830 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_tan() CASCADE;

 /*-- SEQ 10831 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_tan() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_TAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_TAN'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.assina,NEW.assina) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ASSINA'', OLD.assina, NEW.assina, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.coduid,NEW.coduid) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODUID'', OLD.coduid, NEW.coduid, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filtan,NEW.filtan) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILTAN'', OLD.filtan, NEW.filtan, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.gracod,NEW.gracod) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''GRACOD'', OLD.gracod, NEW.gracod, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.gracor,NEW.gracor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''GRACOR'', OLD.gracor, NEW.gracor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.grafil,NEW.grafil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''GRAFIL'', OLD.grafil, NEW.grafil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.gratam,NEW.gratam) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''GRATAM'', OLD.gratam, NEW.gratam, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.precal,NEW.precal) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRECAL'', OLD.precal, NEW.precal, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.qtdlts,NEW.qtdlts) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''QTDLTS'', OLD.qtdlts, NEW.qtdlts, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tanatv,NEW.tanatv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TANATV'', OLD.tanatv, NEW.tanatv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tanque,NEW.tanque) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TAN'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TANQUE'', OLD.tanque, NEW.tanque, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10832 --*/
CREATE TRIGGER TG_LOG_td_tan
AFTER INSERT OR UPDATE OR DELETE ON td_tan
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_tan();

/*-- SEQ 10833 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_tcc() CASCADE;

 /*-- SEQ 10834 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_tcc() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_TCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_TCC'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tccati,NEW.tccati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TCCATI'', OLD.tccati, NEW.tccati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tefjrc,NEW.tefjrc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TEFJRC'', OLD.tefjrc, NEW.tefjrc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tefprc,NEW.tefprc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TCC'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TEFPRC'', OLD.tefprc, NEW.tefprc, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10835 --*/
CREATE TRIGGER TG_LOG_td_tcc
AFTER INSERT OR UPDATE OR DELETE ON td_tcc
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_tcc();

/*-- SEQ 10836 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_tcd() CASCADE;

 /*-- SEQ 10837 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_tcd() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_TCD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_TCD'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TCD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tcdati,NEW.tcdati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TCD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TCDATI'', OLD.tcdati, NEW.tcdati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tefent,NEW.tefent) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TCD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TEFENT'', OLD.tefent, NEW.tefent, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tefjrd,NEW.tefjrd) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TCD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TEFJRD'', OLD.tefjrd, NEW.tefjrd, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tefpro,NEW.tefpro) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TCD'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TEFPRO'', OLD.tefpro, NEW.tefpro, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10838 --*/
CREATE TRIGGER TG_LOG_td_tcd
AFTER INSERT OR UPDATE OR DELETE ON td_tcd
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_tcd();

/*-- SEQ 10839 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ted() CASCADE;

 /*-- SEQ 10840 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ted() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_TED'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_TED'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TED'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dested,NEW.dested) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TED'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESTED'', OLD.dested, NEW.dested, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tedati,NEW.tedati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TED'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TEDATI'', OLD.tedati, NEW.tedati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10841 --*/
CREATE TRIGGER TG_LOG_td_ted
AFTER INSERT OR UPDATE OR DELETE ON td_ted
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ted();

/*-- SEQ 10842 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_ter() CASCADE;

 /*-- SEQ 10843 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_ter() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_TER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_TER'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filter,NEW.filter) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILTER'', OLD.filter, NEW.filter, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ter_ip,NEW.ter_ip) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TER_IP'', OLD.ter_ip, NEW.ter_ip, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.terati,NEW.terati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TERATI'', OLD.terati, NEW.terati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.terctr,NEW.terctr) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TERCTR'', OLD.terctr, NEW.terctr, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.terven,NEW.terven) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TER'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TERVEN'', OLD.terven, NEW.terven, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10844 --*/
CREATE TRIGGER TG_LOG_td_ter
AFTER INSERT OR UPDATE OR DELETE ON td_ter
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_ter();

/*-- SEQ 10845 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_tip() CASCADE;

 /*-- SEQ 10846 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_tip() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_TIP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_TIP'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TIP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.photip,NEW.photip) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TIP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PHOTIP'', OLD.photip, NEW.photip, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipati,NEW.tipati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TIP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPATI'', OLD.tipati, NEW.tipati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10847 --*/
CREATE TRIGGER TG_LOG_td_tip
AFTER INSERT OR UPDATE OR DELETE ON td_tip
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_tip();

/*-- SEQ 10848 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_tipxint() CASCADE;

 /*-- SEQ 10849 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_tipxint() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_TIPXINT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_TIPXINT'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TIPXINT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.destipxint,NEW.destipxint) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TIPXINT'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESTIPXINT'', OLD.destipxint, NEW.destipxint, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10850 --*/
CREATE TRIGGER TG_LOG_td_tipxint
AFTER INSERT OR UPDATE OR DELETE ON td_tipxint
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_tipxint();

/*-- SEQ 10851 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_tri() CASCADE;

 /*-- SEQ 10852 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_tri() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_TRI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_TRI'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TRI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtri,NEW.codtri) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TRI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTRI'', OLD.codtri, NEW.codtri, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.triati,NEW.triati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_TRI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TRIATI'', OLD.triati, NEW.triati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10853 --*/
CREATE TRIGGER TG_LOG_td_tri
AFTER INSERT OR UPDATE OR DELETE ON td_tri
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_tri();

/*-- SEQ 10854 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_vcr() CASCADE;

 /*-- SEQ 10855 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_vcr() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_VCR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_VCR'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_VCR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.corati,NEW.corati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_VCR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CORATI'', OLD.corati, NEW.corati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.descor,NEW.descor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_VCR'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESCOR'', OLD.descor, NEW.descor, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10856 --*/
CREATE TRIGGER TG_LOG_td_vcr
AFTER INSERT OR UPDATE OR DELETE ON td_vcr
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_vcr();

/*-- SEQ 10857 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_vei() CASCADE;

 /*-- SEQ 10858 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_vei() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_VEI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_VEI'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.capmax,NEW.capmax) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_VEI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CAPMAX'', OLD.capmax, NEW.capmax, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codfre,NEW.codfre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_VEI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODFRE'', OLD.codfre, NEW.codfre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codmtd,NEW.codmtd) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_VEI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODMTD'', OLD.codmtd, NEW.codmtd, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_VEI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.convei,NEW.convei) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_VEI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CONVEI'', OLD.convei, NEW.convei, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desvei,NEW.desvei) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_VEI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESVEI'', OLD.desvei, NEW.desvei, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.espvei,NEW.espvei) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_VEI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ESPVEI'', OLD.espvei, NEW.espvei, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.maxtra,NEW.maxtra) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_VEI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MAXTRA'', OLD.maxtra, NEW.maxtra, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pesmax,NEW.pesmax) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_VEI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PESMAX'', OLD.pesmax, NEW.pesmax, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.placas,NEW.placas) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_VEI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PLACAS'', OLD.placas, NEW.placas, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipvei,NEW.tipvei) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_VEI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPVEI'', OLD.tipvei, NEW.tipvei, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.veiati,NEW.veiati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_VEI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VEIATI'', OLD.veiati, NEW.veiati, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.volmax,NEW.volmax) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_VEI'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VOLMAX'', OLD.volmax, NEW.volmax, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10859 --*/
CREATE TRIGGER TG_LOG_td_vei
AFTER INSERT OR UPDATE OR DELETE ON td_vei
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_vei();

/*-- SEQ 10860 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_vpe() CASCADE;

 /*-- SEQ 10861 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_vpe() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_VPE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_VPE'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_VPE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.motvpe,NEW.motvpe) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_VPE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOTVPE'', OLD.motvpe, NEW.motvpe, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vpeati,NEW.vpeati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_VPE'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VPEATI'', OLD.vpeati, NEW.vpeati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10862 --*/
CREATE TRIGGER TG_LOG_td_vpe
AFTER INSERT OR UPDATE OR DELETE ON td_vpe
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_vpe();

/*-- SEQ 10863 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_td_vtp() CASCADE;

 /*-- SEQ 10864 --*/
CREATE OR REPLACE FUNCTION TG_LOG_td_vtp() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_VTP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TD_VTP'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_VTP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desvtp,NEW.desvtp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_VTP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESVTP'', OLD.desvtp, NEW.desvtp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vtpati,NEW.vtpati) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TD_VTP'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VTPATI'', OLD.vtpati, NEW.vtpati, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10865 --*/
CREATE TRIGGER TG_LOG_td_vtp
AFTER INSERT OR UPDATE OR DELETE ON td_vtp
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_td_vtp();

/*-- SEQ 10866 --*/
/*--IGNORE ERRO--*/
DROP FUNCTION TG_LOG_tt_cfg() CASCADE;

 /*-- SEQ 10867 --*/
CREATE OR REPLACE FUNCTION TG_LOG_tt_cfg() RETURNS TRIGGER AS '
DECLARE
  vComplemento VARCHAR(100);
  cFilUsu CHAR(3);
  cCodUsu CHAR(3);
  QuemLogou TRetQuemLogou%ROWTYPE;
  wk_coduid tt_uid.coduid%type;
BEGIN

  WK_CODUID := GetCoduidAtual();
  Quemlogou := DadosLogon();
  IF (QuemLogou.Encontrou) THEN
    cFilUsu := QuemLogou.FILUSU;
    cCodUsu := QuemLogou.CODUSU;
  ELSE
    RAISE EXCEPTION ''PG-20039 Voc no  um usurio cadastrado no sistema. %'', vComplemento;
  END IF;

  IF (TG_OP = ''INSERT'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''I'');
  ELSIF (TG_OP = ''DELETE'') THEN
     INSERT INTO TL_CFG
     (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, CODUID, OPERAD)
     VALUES
     (''TT_CFG'',OLD.CODTAB, agora(), cFilUsu, cCodUsu, '''', WK_CODUID, ''E'');
  ELSIF (TG_OP = ''UPDATE'') THEN

    -- Tratamento de colunas

    IF Equal(OLD.abater_desconto_nf,NEW.abater_desconto_nf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ABATER_DESCONTO_NF'', OLD.abater_desconto_nf, NEW.abater_desconto_nf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.abcqa,NEW.abcqa) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ABCQA'', OLD.abcqa, NEW.abcqa, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.abcqb,NEW.abcqb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ABCQB'', OLD.abcqb, NEW.abcqb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.abcqc,NEW.abcqc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ABCQC'', OLD.abcqc, NEW.abcqc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.abcva,NEW.abcva) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ABCVA'', OLD.abcva, NEW.abcva, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.abcvb,NEW.abcvb) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ABCVB'', OLD.abcvb, NEW.abcvb, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.abcvc,NEW.abcvc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ABCVC'', OLD.abcvc, NEW.abcvc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.acao_devolucao,NEW.acao_devolucao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ACAO_DEVOLUCAO'', OLD.acao_devolucao, NEW.acao_devolucao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.agrupa_lctos_te_ccc,NEW.agrupa_lctos_te_ccc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''AGRUPA_LCTOS_TE_CCC'', OLD.agrupa_lctos_te_ccc, NEW.agrupa_lctos_te_ccc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.agrupador_itens_distr_est,NEW.agrupador_itens_distr_est) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''AGRUPADOR_ITENS_DISTR_EST'', OLD.agrupador_itens_distr_est, NEW.agrupador_itens_distr_est, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.altera_preco_orc_separado,NEW.altera_preco_orc_separado) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ALTERA_PRECO_ORC_SEPARADO'', OLD.altera_preco_orc_separado, NEW.altera_preco_orc_separado, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.areceber_passa_ecf,NEW.areceber_passa_ecf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ARECEBER_PASSA_ECF'', OLD.areceber_passa_ecf, NEW.areceber_passa_ecf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.arredondac,NEW.arredondac) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ARREDONDAC'', OLD.arredondac, NEW.arredondac, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.arredondam,NEW.arredondam) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ARREDONDAM'', OLD.arredondam, NEW.arredondam, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.arredonpar,NEW.arredonpar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ARREDONPAR'', OLD.arredonpar, NEW.arredonpar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.atuped,NEW.atuped) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ATUPED'', OLD.atuped, NEW.atuped, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.au_autent,NEW.au_autent) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''AU_AUTENT'', OLD.au_autent, NEW.au_autent, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.au_desaut,NEW.au_desaut) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''AU_DESAUT'', OLD.au_desaut, NEW.au_desaut, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.au_deslin,NEW.au_deslin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''AU_DESLIN'', OLD.au_deslin, NEW.au_deslin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.au_entrel,NEW.au_entrel) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''AU_ENTREL'', OLD.au_entrel, NEW.au_entrel, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.au_entrelc,NEW.au_entrelc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''AU_ENTRELC'', OLD.au_entrelc, NEW.au_entrelc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.au_hablin,NEW.au_hablin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''AU_HABLIN'', OLD.au_hablin, NEW.au_hablin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.au_impress,NEW.au_impress) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''AU_IMPRESS'', OLD.au_impress, NEW.au_impress, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.au_imprim,NEW.au_imprim) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''AU_IMPRIM'', OLD.au_imprim, NEW.au_imprim, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.au_inic,NEW.au_inic) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''AU_INIC'', OLD.au_inic, NEW.au_inic, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.au_lnfeed,NEW.au_lnfeed) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''AU_LNFEED'', OLD.au_lnfeed, NEW.au_lnfeed, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.au_tamvlr,NEW.au_tamvlr) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''AU_TAMVLR'', OLD.au_tamvlr, NEW.au_tamvlr, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.au_vezes,NEW.au_vezes) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''AU_VEZES'', OLD.au_vezes, NEW.au_vezes, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.avisa_estoque_neg,NEW.avisa_estoque_neg) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''AVISA_ESTOQUE_NEG'', OLD.avisa_estoque_neg, NEW.avisa_estoque_neg, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.baiped,NEW.baiped) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''BAIPED'', OLD.baiped, NEW.baiped, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.base_markup,NEW.base_markup) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''BASE_MARKUP'', OLD.base_markup, NEW.base_markup, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.blq_cf_retira_deposito,NEW.blq_cf_retira_deposito) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''BLQ_CF_RETIRA_DEPOSITO'', OLD.blq_cf_retira_deposito, NEW.blq_cf_retira_deposito, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.blq_sem_uid,NEW.blq_sem_uid) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''BLQ_SEM_UID'', OLD.blq_sem_uid, NEW.blq_sem_uid, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.boleto_email,NEW.boleto_email) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''BOLETO_EMAIL'', OLD.boleto_email, NEW.boleto_email, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.bonus_online,NEW.bonus_online) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''BONUS_ONLINE'', OLD.bonus_online, NEW.bonus_online, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.bru_aprovada,NEW.bru_aprovada) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''BRU_APROVADA'', OLD.bru_aprovada, NEW.bru_aprovada, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cabpre,NEW.cabpre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CABPRE'', OLD.cabpre, NEW.cabpre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cancela_reserva,NEW.cancela_reserva) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CANCELA_RESERVA'', OLD.cancela_reserva, NEW.cancela_reserva, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.carencia,NEW.carencia) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CARENCIA'', OLD.carencia, NEW.carencia, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.carencia_restri,NEW.carencia_restri) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CARENCIA_RESTRI'', OLD.carencia_restri, NEW.carencia_restri, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.carenciamedicamento,NEW.carenciamedicamento) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CARENCIAMEDICAMENTO'', OLD.carenciamedicamento, NEW.carenciamedicamento, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.categ1,NEW.categ1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CATEG1'', OLD.categ1, NEW.categ1, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.categ2,NEW.categ2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CATEG2'', OLD.categ2, NEW.categ2, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.categ3,NEW.categ3) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CATEG3'', OLD.categ3, NEW.categ3, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cc_cartafrete,NEW.cc_cartafrete) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CC_CARTAFRETE'', OLD.cc_cartafrete, NEW.cc_cartafrete, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cc_checkout,NEW.cc_checkout) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CC_CHECKOUT'', OLD.cc_checkout, NEW.cc_checkout, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cc_credfornecedor,NEW.cc_credfornecedor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CC_CREDFORNECEDOR'', OLD.cc_credfornecedor, NEW.cc_credfornecedor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cc_devolucao,NEW.cc_devolucao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CC_DEVOLUCAO'', OLD.cc_devolucao, NEW.cc_devolucao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cc_doacaotroco,NEW.cc_doacaotroco) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CC_DOACAOTROCO'', OLD.cc_doacaotroco, NEW.cc_doacaotroco, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cc_pendencia,NEW.cc_pendencia) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CC_PENDENCIA'', OLD.cc_pendencia, NEW.cc_pendencia, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cc_restsav,NEW.cc_restsav) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CC_RESTSAV'', OLD.cc_restsav, NEW.cc_restsav, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cc_vale_presente,NEW.cc_vale_presente) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CC_VALE_PRESENTE'', OLD.cc_vale_presente, NEW.cc_vale_presente, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cc_wor_prop,NEW.cc_wor_prop) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CC_WOR_PROP'', OLD.cc_wor_prop, NEW.cc_wor_prop, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cc_workflow,NEW.cc_workflow) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CC_WORKFLOW'', OLD.cc_workflow, NEW.cc_workflow, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cdco,NEW.cdco) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CDCO'', OLD.cdco, NEW.cdco, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cfcontripj,NEW.cfcontripj) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CFCONTRIPJ'', OLD.cfcontripj, NEW.cfcontripj, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cfg_limitesangriacheque,NEW.cfg_limitesangriacheque) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CFG_LIMITESANGRIACHEQUE'', OLD.cfg_limitesangriacheque, NEW.cfg_limitesangriacheque, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cfg_parceiro,NEW.cfg_parceiro) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CFG_PARCEIRO'', OLD.cfg_parceiro, NEW.cfg_parceiro, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cfg_reforcoabertura,NEW.cfg_reforcoabertura) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CFG_REFORCOABERTURA'', OLD.cfg_reforcoabertura, NEW.cfg_reforcoabertura, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cfg_sangriafechamento,NEW.cfg_sangriafechamento) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CFG_SANGRIAFECHAMENTO'', OLD.cfg_sangriafechamento, NEW.cfg_sangriafechamento, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cfg_tamanhomatricula,NEW.cfg_tamanhomatricula) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CFG_TAMANHOMATRICULA'', OLD.cfg_tamanhomatricula, NEW.cfg_tamanhomatricula, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cfop_com_ecf,NEW.cfop_com_ecf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CFOP_COM_ECF'', OLD.cfop_com_ecf, NEW.cfop_com_ecf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cfopperdas,NEW.cfopperdas) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CFOPPERDAS'', OLD.cfopperdas, NEW.cfopperdas, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.checkout_relmin,NEW.checkout_relmin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CHECKOUT_RELMIN'', OLD.checkout_relmin, NEW.checkout_relmin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.checkout_vermin,NEW.checkout_vermin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CHECKOUT_VERMIN'', OLD.checkout_vermin, NEW.checkout_vermin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cheque,NEW.cheque) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CHEQUE'', OLD.cheque, NEW.cheque, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.chequeminimo,NEW.chequeminimo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CHEQUEMINIMO'', OLD.chequeminimo, NEW.chequeminimo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.chestd,NEW.chestd) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CHESTD'', OLD.chestd, NEW.chestd, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.chetro,NEW.chetro) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CHETRO'', OLD.chetro, NEW.chetro, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.chrdev_cria_subpar,NEW.chrdev_cria_subpar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CHRDEV_CRIA_SUBPAR'', OLD.chrdev_cria_subpar, NEW.chrdev_cria_subpar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ciclopre,NEW.ciclopre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CICLOPRE'', OLD.ciclopre, NEW.ciclopre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_detver_homol,NEW.ck4g_detver_homol) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_DETVER_HOMOL'', OLD.ck4g_detver_homol, NEW.ck4g_detver_homol, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_detver_produ,NEW.ck4g_detver_produ) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_DETVER_PRODU'', OLD.ck4g_detver_produ, NEW.ck4g_detver_produ, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_regra_atualizacao,NEW.ck4g_regra_atualizacao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_REGRA_ATUALIZACAO'', OLD.ck4g_regra_atualizacao, NEW.ck4g_regra_atualizacao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_releas_homol,NEW.ck4g_releas_homol) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_RELEAS_HOMOL'', OLD.ck4g_releas_homol, NEW.ck4g_releas_homol, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_releas_produ,NEW.ck4g_releas_produ) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_RELEAS_PRODU'', OLD.ck4g_releas_produ, NEW.ck4g_releas_produ, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_versao_homol,NEW.ck4g_versao_homol) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_VERSAO_HOMOL'', OLD.ck4g_versao_homol, NEW.ck4g_versao_homol, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck4g_versao_produ,NEW.ck4g_versao_produ) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK4G_VERSAO_PRODU'', OLD.ck4g_versao_produ, NEW.ck4g_versao_produ, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ck_fecha_valor_contado,NEW.ck_fecha_valor_contado) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CK_FECHA_VALOR_CONTADO'', OLD.ck_fecha_valor_contado, NEW.ck_fecha_valor_contado, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckbemvindo,NEW.ckbemvindo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKBEMVINDO'', OLD.ckbemvindo, NEW.ckbemvindo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckbloqrefbas,NEW.ckbloqrefbas) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKBLOQREFBAS'', OLD.ckbloqrefbas, NEW.ckbloqrefbas, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckdescecf,NEW.ckdescecf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKDESCECF'', OLD.ckdescecf, NEW.ckdescecf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckforcomit,NEW.ckforcomit) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKFORCOMIT'', OLD.ckforcomit, NEW.ckforcomit, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckforcoms1,NEW.ckforcoms1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKFORCOMS1'', OLD.ckforcoms1, NEW.ckforcoms1, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckforcoms2,NEW.ckforcoms2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKFORCOMS2'', OLD.ckforcoms2, NEW.ckforcoms2, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckforcoms3,NEW.ckforcoms3) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKFORCOMS3'', OLD.ckforcoms3, NEW.ckforcoms3, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckforcoms4,NEW.ckforcoms4) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKFORCOMS4'', OLD.ckforcoms4, NEW.ckforcoms4, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckforcomv1,NEW.ckforcomv1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKFORCOMV1'', OLD.ckforcomv1, NEW.ckforcomv1, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckforcomv2,NEW.ckforcomv2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKFORCOMV2'', OLD.ckforcomv2, NEW.ckforcomv2, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckfordes,NEW.ckfordes) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKFORDES'', OLD.ckfordes, NEW.ckfordes, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckftxtsub1,NEW.ckftxtsub1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKFTXTSUB1'', OLD.ckftxtsub1, NEW.ckftxtsub1, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckftxtsub2,NEW.ckftxtsub2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKFTXTSUB2'', OLD.ckftxtsub2, NEW.ckftxtsub2, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckftxtsub3,NEW.ckftxtsub3) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKFTXTSUB3'', OLD.ckftxtsub3, NEW.ckftxtsub3, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckftxtsub4,NEW.ckftxtsub4) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKFTXTSUB4'', OLD.ckftxtsub4, NEW.ckftxtsub4, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckgradepesavel,NEW.ckgradepesavel) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKGRADEPESAVEL'', OLD.ckgradepesavel, NEW.ckgradepesavel, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cknegativo,NEW.cknegativo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKNEGATIVO'', OLD.cknegativo, NEW.cknegativo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cknomatend,NEW.cknomatend) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKNOMATEND'', OLD.cknomatend, NEW.cknomatend, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cknumextdp,NEW.cknumextdp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKNUMEXTDP'', OLD.cknumextdp, NEW.cknumextdp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpaagrupa,NEW.ckpaagrupa) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPAAGRUPA'', OLD.ckpaagrupa, NEW.ckpaagrupa, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpaaut_dev_frete,NEW.ckpaaut_dev_frete) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPAAUT_DEV_FRETE'', OLD.ckpaaut_dev_frete, NEW.ckpaaut_dev_frete, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpacanhotonfe,NEW.ckpacanhotonfe) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPACANHOTONFE'', OLD.ckpacanhotonfe, NEW.ckpacanhotonfe, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpacoml1,NEW.ckpacoml1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPACOML1'', OLD.ckpacoml1, NEW.ckpacoml1, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpacoml2,NEW.ckpacoml2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPACOML2'', OLD.ckpacoml2, NEW.ckpacoml2, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpacoml3,NEW.ckpacoml3) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPACOML3'', OLD.ckpacoml3, NEW.ckpacoml3, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpacoml4,NEW.ckpacoml4) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPACOML4'', OLD.ckpacoml4, NEW.ckpacoml4, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpaconfere_dav,NEW.ckpaconfere_dav) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPACONFERE_DAV'', OLD.ckpaconfere_dav, NEW.ckpaconfere_dav, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpaconsfi,NEW.ckpaconsfi) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPACONSFI'', OLD.ckpaconsfi, NEW.ckpaconsfi, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpadescit,NEW.ckpadescit) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPADESCIT'', OLD.ckpadescit, NEW.ckpadescit, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpadescto,NEW.ckpadescto) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPADESCTO'', OLD.ckpadescto, NEW.ckpadescto, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpadiasat,NEW.ckpadiasat) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPADIASAT'', OLD.ckpadiasat, NEW.ckpadiasat, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpadigche,NEW.ckpadigche) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPADIGCHE'', OLD.ckpadigche, NEW.ckpadigche, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpafildav,NEW.ckpafildav) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPAFILDAV'', OLD.ckpafildav, NEW.ckpafildav, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpamfimpp,NEW.ckpamfimpp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPAMFIMPP'', OLD.ckpamfimpp, NEW.ckpamfimpp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpamfl1,NEW.ckpamfl1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPAMFL1'', OLD.ckpamfl1, NEW.ckpamfl1, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpamfl2,NEW.ckpamfl2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPAMFL2'', OLD.ckpamfl2, NEW.ckpamfl2, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpamfl3,NEW.ckpamfl3) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPAMFL3'', OLD.ckpamfl3, NEW.ckpamfl3, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpamfl4,NEW.ckpamfl4) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPAMFL4'', OLD.ckpamfl4, NEW.ckpamfl4, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpanumext,NEW.ckpanumext) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPANUMEXT'', OLD.ckpanumext, NEW.ckpanumext, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpanumext_dep,NEW.ckpanumext_dep) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPANUMEXT_DEP'', OLD.ckpanumext_dep, NEW.ckpanumext_dep, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpanumext_nao_dav,NEW.ckpanumext_nao_dav) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPANUMEXT_NAO_DAV'', OLD.ckpanumext_nao_dav, NEW.ckpanumext_nao_dav, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpaobrven,NEW.ckpaobrven) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPAOBRVEN'', OLD.ckpaobrven, NEW.ckpaobrven, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpapagirr,NEW.ckpapagirr) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPAPAGIRR'', OLD.ckpapagirr, NEW.ckpapagirr, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpapesqident,NEW.ckpapesqident) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPAPESQIDENT'', OLD.ckpapesqident, NEW.ckpapesqident, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpapredec,NEW.ckpapredec) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPAPREDEC'', OLD.ckpapredec, NEW.ckpapredec, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpapredoc,NEW.ckpapredoc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPAPREDOC'', OLD.ckpapredoc, NEW.ckpapredoc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpaqtdaut,NEW.ckpaqtdaut) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPAQTDAUT'', OLD.ckpaqtdaut, NEW.ckpaqtdaut, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpaqtddec,NEW.ckpaqtddec) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPAQTDDEC'', OLD.ckpaqtddec, NEW.ckpaqtddec, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckparecfilial,NEW.ckparecfilial) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPARECFILIAL'', OLD.ckparecfilial, NEW.ckparecfilial, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpasaicai,NEW.ckpasaicai) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPASAICAI'', OLD.ckpasaicai, NEW.ckpasaicai, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpasaiche,NEW.ckpasaiche) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPASAICHE'', OLD.ckpasaiche, NEW.ckpasaiche, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpatotven,NEW.ckpatotven) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPATOTVEN'', OLD.ckpatotven, NEW.ckpatotven, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpatxtpre,NEW.ckpatxtpre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPATXTPRE'', OLD.ckpatxtpre, NEW.ckpatxtpre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpaunicai,NEW.ckpaunicai) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPAUNICAI'', OLD.ckpaunicai, NEW.ckpaunicai, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpavalabe,NEW.ckpavalabe) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPAVALABE'', OLD.ckpavalabe, NEW.ckpavalabe, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpavenite,NEW.ckpavenite) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPAVENITE'', OLD.ckpavenite, NEW.ckpavenite, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpavlrapr,NEW.ckpavlrapr) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPAVLRAPR'', OLD.ckpavlrapr, NEW.ckpavlrapr, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckpavlrirr,NEW.ckpavlrirr) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPAVLRIRR'', OLD.ckpavlrirr, NEW.ckpavlrirr, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckprecosub,NEW.ckprecosub) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKPRECOSUB'', OLD.ckprecosub, NEW.ckprecosub, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cksangrianegativa,NEW.cksangrianegativa) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKSANGRIANEGATIVA'', OLD.cksangrianegativa, NEW.cksangrianegativa, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cktrocachradepositar,NEW.cktrocachradepositar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKTROCACHRADEPOSITAR'', OLD.cktrocachradepositar, NEW.cktrocachradepositar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cktxtpromissoria,NEW.cktxtpromissoria) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKTXTPROMISSORIA'', OLD.cktxtpromissoria, NEW.cktxtpromissoria, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckusabalan,NEW.ckusabalan) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKUSABALAN'', OLD.ckusabalan, NEW.ckusabalan, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckusadebap,NEW.ckusadebap) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKUSADEBAP'', OLD.ckusadebap, NEW.ckusadebap, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ckvlrinfun,NEW.ckvlrinfun) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CKVLRINFUN'', OLD.ckvlrinfun, NEW.ckvlrinfun, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cl4web,NEW.cl4web) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CL4WEB'', OLD.cl4web, NEW.cl4web, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.class1,NEW.class1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLASS1'', OLD.class1, NEW.class1, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.class2,NEW.class2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLASS2'', OLD.class2, NEW.class2, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.class3,NEW.class3) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLASS3'', OLD.class3, NEW.class3, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.class4,NEW.class4) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLASS4'', OLD.class4, NEW.class4, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cli_bairro,NEW.cli_bairro) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLI_BAIRRO'', OLD.cli_bairro, NEW.cli_bairro, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cli_call_c,NEW.cli_call_c) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLI_CALL_C'', OLD.cli_call_c, NEW.cli_call_c, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cli_categ1,NEW.cli_categ1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLI_CATEG1'', OLD.cli_categ1, NEW.cli_categ1, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cli_categ2,NEW.cli_categ2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLI_CATEG2'', OLD.cli_categ2, NEW.cli_categ2, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cli_categ3,NEW.cli_categ3) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLI_CATEG3'', OLD.cli_categ3, NEW.cli_categ3, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cli_codcep,NEW.cli_codcep) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLI_CODCEP'', OLD.cli_codcep, NEW.cli_codcep, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cli_codsex,NEW.cli_codsex) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLI_CODSEX'', OLD.cli_codsex, NEW.cli_codsex, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cli_conjug,NEW.cli_conjug) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLI_CONJUG'', OLD.cli_conjug, NEW.cli_conjug, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cli_contat,NEW.cli_contat) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLI_CONTAT'', OLD.cli_contat, NEW.cli_contat, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cli_datnas,NEW.cli_datnas) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLI_DATNAS'', OLD.cli_datnas, NEW.cli_datnas, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cli_doccon,NEW.cli_doccon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLI_DOCCON'', OLD.cli_doccon, NEW.cli_doccon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cli_endere,NEW.cli_endere) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLI_ENDERE'', OLD.cli_endere, NEW.cli_endere, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cli_estciv,NEW.cli_estciv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLI_ESTCIV'', OLD.cli_estciv, NEW.cli_estciv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cli_insest,NEW.cli_insest) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLI_INSEST'', OLD.cli_insest, NEW.cli_insest, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cli_nascon,NEW.cli_nascon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLI_NASCON'', OLD.cli_nascon, NEW.cli_nascon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cli_nomcid,NEW.cli_nomcid) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLI_NOMCID'', OLD.cli_nomcid, NEW.cli_nomcid, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cli_numfon,NEW.cli_numfon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLI_NUMFON'', OLD.cli_numfon, NEW.cli_numfon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cli_qtdbon,NEW.cli_qtdbon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLI_QTDBON'', OLD.cli_qtdbon, NEW.cli_qtdbon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cli_regiao,NEW.cli_regiao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLI_REGIAO'', OLD.cli_regiao, NEW.cli_regiao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cli_vlrven_bon,NEW.cli_vlrven_bon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLI_VLRVEN_BON'', OLD.cli_vlrven_bon, NEW.cli_vlrven_bon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.clicodext,NEW.clicodext) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLICODEXT'', OLD.clicodext, NEW.clicodext, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cliente_por_doc,NEW.cliente_por_doc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLIENTE_POR_DOC'', OLD.cliente_por_doc, NEW.cliente_por_doc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.clirevsemie,NEW.clirevsemie) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CLIREVSEMIE'', OLD.clirevsemie, NEW.clirevsemie, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cob_cod_gerente,NEW.cob_cod_gerente) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COB_COD_GERENTE'', OLD.cob_cod_gerente, NEW.cob_cod_gerente, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cob_dias_carta1_chr,NEW.cob_dias_carta1_chr) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COB_DIAS_CARTA1_CHR'', OLD.cob_dias_carta1_chr, NEW.cob_dias_carta1_chr, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cob_dias_carta1_rec,NEW.cob_dias_carta1_rec) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COB_DIAS_CARTA1_REC'', OLD.cob_dias_carta1_rec, NEW.cob_dias_carta1_rec, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cob_dias_carta2_chr,NEW.cob_dias_carta2_chr) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COB_DIAS_CARTA2_CHR'', OLD.cob_dias_carta2_chr, NEW.cob_dias_carta2_chr, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cob_dias_carta2_rec,NEW.cob_dias_carta2_rec) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COB_DIAS_CARTA2_REC'', OLD.cob_dias_carta2_rec, NEW.cob_dias_carta2_rec, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cob_dias_devolucao1,NEW.cob_dias_devolucao1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COB_DIAS_DEVOLUCAO1'', OLD.cob_dias_devolucao1, NEW.cob_dias_devolucao1, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cob_dias_devolucao2,NEW.cob_dias_devolucao2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COB_DIAS_DEVOLUCAO2'', OLD.cob_dias_devolucao2, NEW.cob_dias_devolucao2, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cob_dias_spc_chr,NEW.cob_dias_spc_chr) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COB_DIAS_SPC_CHR'', OLD.cob_dias_spc_chr, NEW.cob_dias_spc_chr, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cob_dias_spc_rec,NEW.cob_dias_spc_rec) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COB_DIAS_SPC_REC'', OLD.cob_dias_spc_rec, NEW.cob_dias_spc_rec, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cob_dias_vencto,NEW.cob_dias_vencto) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COB_DIAS_VENCTO'', OLD.cob_dias_vencto, NEW.cob_dias_vencto, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cob_e_mail_cartas,NEW.cob_e_mail_cartas) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COB_E_MAIL_CARTAS'', OLD.cob_e_mail_cartas, NEW.cob_e_mail_cartas, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cob_e_mail_sac,NEW.cob_e_mail_sac) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COB_E_MAIL_SAC'', OLD.cob_e_mail_sac, NEW.cob_e_mail_sac, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cob_e_mail_spc,NEW.cob_e_mail_spc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COB_E_MAIL_SPC'', OLD.cob_e_mail_spc, NEW.cob_e_mail_spc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cob_fil_gerente,NEW.cob_fil_gerente) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COB_FIL_GERENTE'', OLD.cob_fil_gerente, NEW.cob_fil_gerente, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cob_forma_registro,NEW.cob_forma_registro) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COB_FORMA_REGISTRO'', OLD.cob_forma_registro, NEW.cob_forma_registro, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cob_mod_codcor1,NEW.cob_mod_codcor1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COB_MOD_CODCOR1'', OLD.cob_mod_codcor1, NEW.cob_mod_codcor1, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cob_mod_codcor2,NEW.cob_mod_codcor2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COB_MOD_CODCOR2'', OLD.cob_mod_codcor2, NEW.cob_mod_codcor2, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cob_outros_pagtos,NEW.cob_outros_pagtos) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COB_OUTROS_PAGTOS'', OLD.cob_outros_pagtos, NEW.cob_outros_pagtos, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cob_usa_sac,NEW.cob_usa_sac) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COB_USA_SAC'', OLD.cob_usa_sac, NEW.cob_usa_sac, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cod_basf,NEW.cod_basf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COD_BASF'', OLD.cod_basf, NEW.cod_basf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cod_dimed,NEW.cod_dimed) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COD_DIMED'', OLD.cod_dimed, NEW.cod_dimed, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cod_dimper,NEW.cod_dimper) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COD_DIMPER'', OLD.cod_dimper, NEW.cod_dimper, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cod_ecb_tit,NEW.cod_ecb_tit) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COD_ECB_TIT'', OLD.cod_ecb_tit, NEW.cod_ecb_tit, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cod_especial,NEW.cod_especial) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COD_ESPECIAL'', OLD.cod_especial, NEW.cod_especial, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cod_genesio,NEW.cod_genesio) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COD_GENESIO'', OLD.cod_genesio, NEW.cod_genesio, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cod_panarello,NEW.cod_panarello) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COD_PANARELLO'', OLD.cod_panarello, NEW.cod_panarello, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cod_profarma,NEW.cod_profarma) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COD_PROFARMA'', OLD.cod_profarma, NEW.cod_profarma, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.cod_santacruz,NEW.cod_santacruz) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COD_SANTACRUZ'', OLD.cod_santacruz, NEW.cod_santacruz, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codcor_aux,NEW.codcor_aux) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODCOR_AUX'', OLD.codcor_aux, NEW.codcor_aux, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codcor_rat,NEW.codcor_rat) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODCOR_RAT'', OLD.codcor_rat, NEW.codcor_rat, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codcor_tin,NEW.codcor_tin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODCOR_TIN'', OLD.codcor_tin, NEW.codcor_tin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codcor_tra,NEW.codcor_tra) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODCOR_TRA'', OLD.codcor_tra, NEW.codcor_tra, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codexp_coletor,NEW.codexp_coletor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODEXP_COLETOR'', OLD.codexp_coletor, NEW.codexp_coletor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codmat_aux,NEW.codmat_aux) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODMAT_AUX'', OLD.codmat_aux, NEW.codmat_aux, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codmat_rat,NEW.codmat_rat) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODMAT_RAT'', OLD.codmat_rat, NEW.codmat_rat, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codmat_tin,NEW.codmat_tin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODMAT_TIN'', OLD.codmat_tin, NEW.codmat_tin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codmat_tra,NEW.codmat_tra) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODMAT_TRA'', OLD.codmat_tra, NEW.codmat_tra, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codnat_reimp_cf,NEW.codnat_reimp_cf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODNAT_REIMP_CF'', OLD.codnat_reimp_cf, NEW.codnat_reimp_cf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codpgt_wor_prop,NEW.codpgt_wor_prop) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODPGT_WOR_PROP'', OLD.codpgt_wor_prop, NEW.codpgt_wor_prop, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codpre,NEW.codpre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODPRE'', OLD.codpre, NEW.codpre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codpre_atc,NEW.codpre_atc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODPRE_ATC'', OLD.codpre_atc, NEW.codpre_atc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codpre_rev,NEW.codpre_rev) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODPRE_REV'', OLD.codpre_rev, NEW.codpre_rev, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codsrv,NEW.codsrv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODSRV'', OLD.codsrv, NEW.codsrv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtab,NEW.codtab) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAB'', OLD.codtab, NEW.codtab, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtam_aux,NEW.codtam_aux) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAM_AUX'', OLD.codtam_aux, NEW.codtam_aux, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtam_rat,NEW.codtam_rat) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAM_RAT'', OLD.codtam_rat, NEW.codtam_rat, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtam_tin,NEW.codtam_tin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAM_TIN'', OLD.codtam_tin, NEW.codtam_tin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.codtam_tra,NEW.codtam_tra) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODTAM_TRA'', OLD.codtam_tra, NEW.codtam_tra, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.coduid,NEW.coduid) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CODUID'', OLD.coduid, NEW.coduid, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.compensacao_automatica,NEW.compensacao_automatica) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''COMPENSACAO_AUTOMATICA'', OLD.compensacao_automatica, NEW.compensacao_automatica, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.contato_financeiro,NEW.contato_financeiro) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CONTATO_FINANCEIRO'', OLD.contato_financeiro, NEW.contato_financeiro, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.credit_score,NEW.credit_score) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CREDIT_SCORE'', OLD.credit_score, NEW.credit_score, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.custo_ligacao,NEW.custo_ligacao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CUSTO_LIGACAO'', OLD.custo_ligacao, NEW.custo_ligacao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.custo_lucro_markup,NEW.custo_lucro_markup) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CUSTO_LUCRO_MARKUP'', OLD.custo_lucro_markup, NEW.custo_lucro_markup, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.custo_por_filial,NEW.custo_por_filial) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CUSTO_POR_FILIAL'', OLD.custo_por_filial, NEW.custo_por_filial, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.custofinmensal,NEW.custofinmensal) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''CUSTOFINMENSAL'', OLD.custofinmensal, NEW.custofinmensal, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dados_path_exporta,NEW.dados_path_exporta) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DADOS_PATH_EXPORTA'', OLD.dados_path_exporta, NEW.dados_path_exporta, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dados_path_importa,NEW.dados_path_importa) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DADOS_PATH_IMPORTA'', OLD.dados_path_importa, NEW.dados_path_importa, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dat_chrdep,NEW.dat_chrdep) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DAT_CHRDEP'', OLD.dat_chrdep, NEW.dat_chrdep, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dat_chrdes,NEW.dat_chrdes) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DAT_CHRDES'', OLD.dat_chrdes, NEW.dat_chrdes, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dat_chrdev1,NEW.dat_chrdev1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DAT_CHRDEV1'', OLD.dat_chrdev1, NEW.dat_chrdev1, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dat_chrdev2,NEW.dat_chrdev2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DAT_CHRDEV2'', OLD.dat_chrdev2, NEW.dat_chrdev2, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dat_chrpre,NEW.dat_chrpre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DAT_CHRPRE'', OLD.dat_chrpre, NEW.dat_chrpre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dat_reserv,NEW.dat_reserv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DAT_RESERV'', OLD.dat_reserv, NEW.dat_reserv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.data1,NEW.data1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DATA1'', OLD.data1, NEW.data1, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.data2,NEW.data2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DATA2'', OLD.data2, NEW.data2, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.data3,NEW.data3) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DATA3'', OLD.data3, NEW.data3, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.data_bonus,NEW.data_bonus) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DATA_BONUS'', OLD.data_bonus, NEW.data_bonus, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.datpaf,NEW.datpaf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DATPAF'', OLD.datpaf, NEW.datpaf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.deduztaxatitulo,NEW.deduztaxatitulo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DEDUZTAXATITULO'', OLD.deduztaxatitulo, NEW.deduztaxatitulo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.deposita_chetro,NEW.deposita_chetro) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DEPOSITA_CHETRO'', OLD.deposita_chetro, NEW.deposita_chetro, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.descpmord,NEW.descpmord) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESCPMORD'', OLD.descpmord, NEW.descpmord, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.despap_diretoria,NEW.despap_diretoria) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESPAP_DIRETORIA'', OLD.despap_diretoria, NEW.despap_diretoria, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dest_st_dev,NEW.dest_st_dev) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DEST_ST_DEV'', OLD.dest_st_dev, NEW.dest_st_dev, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dest_st_inffisco,NEW.dest_st_inffisco) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DEST_ST_INFFISCO'', OLD.dest_st_inffisco, NEW.dest_st_inffisco, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.desven,NEW.desven) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DESVEN'', OLD.desven, NEW.desven, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dev_fatvin,NEW.dev_fatvin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DEV_FATVIN'', OLD.dev_fatvin, NEW.dev_fatvin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.devcompranfeimposto,NEW.devcompranfeimposto) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DEVCOMPRANFEIMPOSTO'', OLD.devcompranfeimposto, NEW.devcompranfeimposto, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.devfil,NEW.devfil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DEVFIL'', OLD.devfil, NEW.devfil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.devtra_cfo,NEW.devtra_cfo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DEVTRA_CFO'', OLD.devtra_cfo, NEW.devtra_cfo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.devtra_nat,NEW.devtra_nat) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DEVTRA_NAT'', OLD.devtra_nat, NEW.devtra_nat, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.diacre_preatend,NEW.diacre_preatend) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIACRE_PREATEND'', OLD.diacre_preatend, NEW.diacre_preatend, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.diadeb_preatend,NEW.diadeb_preatend) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIADEB_PREATEND'', OLD.diadeb_preatend, NEW.diadeb_preatend, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dias_abc_xyz,NEW.dias_abc_xyz) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIAS_ABC_XYZ'', OLD.dias_abc_xyz, NEW.dias_abc_xyz, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dias_aceite_automatico,NEW.dias_aceite_automatico) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIAS_ACEITE_AUTOMATICO'', OLD.dias_aceite_automatico, NEW.dias_aceite_automatico, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dias_bonus,NEW.dias_bonus) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIAS_BONUS'', OLD.dias_bonus, NEW.dias_bonus, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dias_compensacao_automatica,NEW.dias_compensacao_automatica) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIAS_COMPENSACAO_AUTOMATICA'', OLD.dias_compensacao_automatica, NEW.dias_compensacao_automatica, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dias_expirar_pedido,NEW.dias_expirar_pedido) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIAS_EXPIRAR_PEDIDO'', OLD.dias_expirar_pedido, NEW.dias_expirar_pedido, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dias_numven,NEW.dias_numven) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIAS_NUMVEN'', OLD.dias_numven, NEW.dias_numven, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dias_rec_pedidos,NEW.dias_rec_pedidos) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIAS_REC_PEDIDOS'', OLD.dias_rec_pedidos, NEW.dias_rec_pedidos, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dias_tef_no_preco,NEW.dias_tef_no_preco) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIAS_TEF_NO_PRECO'', OLD.dias_tef_no_preco, NEW.dias_tef_no_preco, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dias_ultcom,NEW.dias_ultcom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIAS_ULTCOM'', OLD.dias_ultcom, NEW.dias_ultcom, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dias_varpre,NEW.dias_varpre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIAS_VARPRE'', OLD.dias_varpre, NEW.dias_varpre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.diaven,NEW.diaven) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIAVEN'', OLD.diaven, NEW.diaven, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dispor,NEW.dispor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DISPOR'', OLD.dispor, NEW.dispor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.divpath,NEW.divpath) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DIVPATH'', OLD.divpath, NEW.divpath, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dopccc,NEW.dopccc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DOPCCC'', OLD.dopccc, NEW.dopccc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.dser_nfcompl,NEW.dser_nfcompl) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''DSER_NFCOMPL'', OLD.dser_nfcompl, NEW.dser_nfcompl, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.e_mail_erro,NEW.e_mail_erro) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''E_MAIL_ERRO'', OLD.e_mail_erro, NEW.e_mail_erro, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.e_mail_estoque,NEW.e_mail_estoque) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''E_MAIL_ESTOQUE'', OLD.e_mail_estoque, NEW.e_mail_estoque, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.e_mail_financ,NEW.e_mail_financ) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''E_MAIL_FINANC'', OLD.e_mail_financ, NEW.e_mail_financ, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ecom_amex,NEW.ecom_amex) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ECOM_AMEX'', OLD.ecom_amex, NEW.ecom_amex, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ecom_master,NEW.ecom_master) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ECOM_MASTER'', OLD.ecom_master, NEW.ecom_master, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ecom_visa,NEW.ecom_visa) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ECOM_VISA'', OLD.ecom_visa, NEW.ecom_visa, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ent_codcli,NEW.ent_codcli) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ENT_CODCLI'', OLD.ent_codcli, NEW.ent_codcli, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ent_filcli,NEW.ent_filcli) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ENT_FILCLI'', OLD.ent_filcli, NEW.ent_filcli, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.entrega_cf,NEW.entrega_cf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ENTREGA_CF'', OLD.entrega_cf, NEW.entrega_cf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.enviadatfaturamento,NEW.enviadatfaturamento) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ENVIADATFATURAMENTO'', OLD.enviadatfaturamento, NEW.enviadatfaturamento, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.enviar_entrega,NEW.enviar_entrega) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ENVIAR_ENTREGA'', OLD.enviar_entrega, NEW.enviar_entrega, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.exp_rec_data_venda,NEW.exp_rec_data_venda) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXP_REC_DATA_VENDA'', OLD.exp_rec_data_venda, NEW.exp_rec_data_venda, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.expirar_senha,NEW.expirar_senha) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXPIRAR_SENHA'', OLD.expirar_senha, NEW.expirar_senha, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.exporta_escrita,NEW.exporta_escrita) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXPORTA_ESCRITA'', OLD.exporta_escrita, NEW.exporta_escrita, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.exporta_todos_clientes,NEW.exporta_todos_clientes) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXPORTA_TODOS_CLIENTES'', OLD.exporta_todos_clientes, NEW.exporta_todos_clientes, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.extensmala,NEW.extensmala) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''EXTENSMALA'', OLD.extensmala, NEW.extensmala, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fatura,NEW.fatura) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FATURA'', OLD.fatura, NEW.fatura, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fatura_cc_por_filial,NEW.fatura_cc_por_filial) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FATURA_CC_POR_FILIAL'', OLD.fatura_cc_por_filial, NEW.fatura_cc_por_filial, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fil_basf,NEW.fil_basf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FIL_BASF'', OLD.fil_basf, NEW.fil_basf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fil_dimed,NEW.fil_dimed) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FIL_DIMED'', OLD.fil_dimed, NEW.fil_dimed, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fil_dimper,NEW.fil_dimper) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FIL_DIMPER'', OLD.fil_dimper, NEW.fil_dimper, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fil_especial,NEW.fil_especial) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FIL_ESPECIAL'', OLD.fil_especial, NEW.fil_especial, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fil_genesio,NEW.fil_genesio) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FIL_GENESIO'', OLD.fil_genesio, NEW.fil_genesio, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fil_panarello,NEW.fil_panarello) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FIL_PANARELLO'', OLD.fil_panarello, NEW.fil_panarello, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fil_papel_todos,NEW.fil_papel_todos) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FIL_PAPEL_TODOS'', OLD.fil_papel_todos, NEW.fil_papel_todos, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fil_profarma,NEW.fil_profarma) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FIL_PROFARMA'', OLD.fil_profarma, NEW.fil_profarma, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fil_santacruz,NEW.fil_santacruz) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FIL_SANTACRUZ'', OLD.fil_santacruz, NEW.fil_santacruz, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filcmp,NEW.filcmp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILCMP'', OLD.filcmp, NEW.filcmp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filcob,NEW.filcob) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILCOB'', OLD.filcob, NEW.filcob, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filcta_trn,NEW.filcta_trn) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILCTA_TRN'', OLD.filcta_trn, NEW.filcta_trn, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filent,NEW.filent) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILENT'', OLD.filent, NEW.filent, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filial_contrato,NEW.filial_contrato) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILIAL_CONTRATO'', OLD.filial_contrato, NEW.filial_contrato, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filmat_aux,NEW.filmat_aux) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILMAT_AUX'', OLD.filmat_aux, NEW.filmat_aux, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filmat_rat,NEW.filmat_rat) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILMAT_RAT'', OLD.filmat_rat, NEW.filmat_rat, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filmat_tin,NEW.filmat_tin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILMAT_TIN'', OLD.filmat_tin, NEW.filmat_tin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filmat_tra,NEW.filmat_tra) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILMAT_TRA'', OLD.filmat_tra, NEW.filmat_tra, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filpap_diretoria,NEW.filpap_diretoria) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILPAP_DIRETORIA'', OLD.filpap_diretoria, NEW.filpap_diretoria, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filpgt_wor_prop,NEW.filpgt_wor_prop) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILPGT_WOR_PROP'', OLD.filpgt_wor_prop, NEW.filpgt_wor_prop, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filpre,NEW.filpre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILPRE'', OLD.filpre, NEW.filpre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filpre_atc,NEW.filpre_atc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILPRE_ATC'', OLD.filpre_atc, NEW.filpre_atc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filpre_rev,NEW.filpre_rev) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILPRE_REV'', OLD.filpre_rev, NEW.filpre_rev, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filprj,NEW.filprj) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILPRJ'', OLD.filprj, NEW.filprj, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filprj_pxd,NEW.filprj_pxd) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILPRJ_PXD'', OLD.filprj_pxd, NEW.filprj_pxd, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filsrv,NEW.filsrv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILSRV'', OLD.filsrv, NEW.filsrv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filteq,NEW.filteq) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILTEQ'', OLD.filteq, NEW.filteq, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.filtra_fornec_pedido,NEW.filtra_fornec_pedido) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FILTRA_FORNEC_PEDIDO'', OLD.filtra_fornec_pedido, NEW.filtra_fornec_pedido, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.financ_reimp_cf,NEW.financ_reimp_cf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FINANC_REIMP_CF'', OLD.financ_reimp_cf, NEW.financ_reimp_cf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fmtdoc,NEW.fmtdoc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FMTDOC'', OLD.fmtdoc, NEW.fmtdoc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fmtreq,NEW.fmtreq) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FMTREQ'', OLD.fmtreq, NEW.fmtreq, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.fpv_preco_simulado,NEW.fpv_preco_simulado) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''FPV_PRECO_SIMULADO'', OLD.fpv_preco_simulado, NEW.fpv_preco_simulado, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.gera_codext_integracao,NEW.gera_codext_integracao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''GERA_CODEXT_INTEGRACAO'', OLD.gera_codext_integracao, NEW.gera_codext_integracao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.giro_estoque,NEW.giro_estoque) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''GIRO_ESTOQUE'', OLD.giro_estoque, NEW.giro_estoque, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.gravalog,NEW.gravalog) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''GRAVALOG'', OLD.gravalog, NEW.gravalog, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.gx_simpan_ent,NEW.gx_simpan_ent) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''GX_SIMPAN_ENT'', OLD.gx_simpan_ent, NEW.gx_simpan_ent, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.gx_simpan_fil,NEW.gx_simpan_fil) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''GX_SIMPAN_FIL'', OLD.gx_simpan_fil, NEW.gx_simpan_fil, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.gx_simpan_per,NEW.gx_simpan_per) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''GX_SIMPAN_PER'', OLD.gx_simpan_per, NEW.gx_simpan_per, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.gx_simpan_sai,NEW.gx_simpan_sai) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''GX_SIMPAN_SAI'', OLD.gx_simpan_sai, NEW.gx_simpan_sai, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.hor_separa,NEW.hor_separa) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOR_SEPARA'', OLD.hor_separa, NEW.hor_separa, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.hor_serasa,NEW.hor_serasa) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HOR_SERASA'', OLD.hor_serasa, NEW.hor_serasa, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.horas_canc_comanda,NEW.horas_canc_comanda) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''HORAS_CANC_COMANDA'', OLD.horas_canc_comanda, NEW.horas_canc_comanda, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ignora_reserva,NEW.ignora_reserva) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IGNORA_RESERVA'', OLD.ignora_reserva, NEW.ignora_reserva, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ignora_vinculo,NEW.ignora_vinculo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IGNORA_VINCULO'', OLD.ignora_vinculo, NEW.ignora_vinculo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.imp_cf_nf,NEW.imp_cf_nf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IMP_CF_NF'', OLD.imp_cf_nf, NEW.imp_cf_nf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.impede_alteracao_pedido,NEW.impede_alteracao_pedido) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IMPEDE_ALTERACAO_PEDIDO'', OLD.impede_alteracao_pedido, NEW.impede_alteracao_pedido, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.impede_orc_maior_limite,NEW.impede_orc_maior_limite) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IMPEDE_ORC_MAIOR_LIMITE'', OLD.impede_orc_maior_limite, NEW.impede_orc_maior_limite, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.impprevent,NEW.impprevent) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IMPPREVENT'', OLD.impprevent, NEW.impprevent, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ind_ckpatotven,NEW.ind_ckpatotven) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IND_CKPATOTVEN'', OLD.ind_ckpatotven, NEW.ind_ckpatotven, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ind_ckpavenite,NEW.ind_ckpavenite) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IND_CKPAVENITE'', OLD.ind_ckpavenite, NEW.ind_ckpavenite, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ind_qtdbon,NEW.ind_qtdbon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IND_QTDBON'', OLD.ind_qtdbon, NEW.ind_qtdbon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ind_vlrven_bon,NEW.ind_vlrven_bon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''IND_VLRVEN_BON'', OLD.ind_vlrven_bon, NEW.ind_vlrven_bon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.int_alt_dat,NEW.int_alt_dat) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INT_ALT_DAT'', OLD.int_alt_dat, NEW.int_alt_dat, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.int_alt_vlr,NEW.int_alt_vlr) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INT_ALT_VLR'', OLD.int_alt_vlr, NEW.int_alt_vlr, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.int_can_des,NEW.int_can_des) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INT_CAN_DES'', OLD.int_can_des, NEW.int_can_des, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.int_can_tit,NEW.int_can_tit) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INT_CAN_TIT'', OLD.int_can_tit, NEW.int_can_tit, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.int_con_aba,NEW.int_con_aba) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INT_CON_ABA'', OLD.int_con_aba, NEW.int_con_aba, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.int_con_des,NEW.int_con_des) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INT_CON_DES'', OLD.int_con_des, NEW.int_con_des, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.int_inc_tit,NEW.int_inc_tit) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INT_INC_TIT'', OLD.int_inc_tit, NEW.int_inc_tit, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.int_pag_car,NEW.int_pag_car) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INT_PAG_CAR'', OLD.int_pag_car, NEW.int_pag_car, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.int_prt_tit,NEW.int_prt_tit) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INT_PRT_TIT'', OLD.int_prt_tit, NEW.int_prt_tit, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.int_s_b_prt,NEW.int_s_b_prt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INT_S_B_PRT'', OLD.int_s_b_prt, NEW.int_s_b_prt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.int_s_c_prt,NEW.int_s_c_prt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''INT_S_C_PRT'', OLD.int_s_c_prt, NEW.int_s_c_prt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.lanven_reimp_cf,NEW.lanven_reimp_cf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LANVEN_REIMP_CF'', OLD.lanven_reimp_cf, NEW.lanven_reimp_cf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.liberasessaomin,NEW.liberasessaomin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LIBERASESSAOMIN'', OLD.liberasessaomin, NEW.liberasessaomin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.lim_pertol,NEW.lim_pertol) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LIM_PERTOL'', OLD.lim_pertol, NEW.lim_pertol, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.lim_saque_cc,NEW.lim_saque_cc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LIM_SAQUE_CC'', OLD.lim_saque_cc, NEW.lim_saque_cc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.lim_tiptol,NEW.lim_tiptol) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LIM_TIPTOL'', OLD.lim_tiptol, NEW.lim_tiptol, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.lim_valtol,NEW.lim_valtol) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LIM_VALTOL'', OLD.lim_valtol, NEW.lim_valtol, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.limcredito_somalim,NEW.limcredito_somalim) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LIMCREDITO_SOMALIM'', OLD.limcredito_somalim, NEW.limcredito_somalim, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.limdia,NEW.limdia) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LIMDIA'', OLD.limdia, NEW.limdia, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.logoboleto,NEW.logoboleto) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LOGOBOLETO'', OLD.logoboleto, NEW.logoboleto, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.loja_fechada,NEW.loja_fechada) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''LOJA_FECHADA'', OLD.loja_fechada, NEW.loja_fechada, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mai_fr,NEW.mai_fr) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MAI_FR'', OLD.mai_fr, NEW.mai_fr, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mai_to,NEW.mai_to) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MAI_TO'', OLD.mai_to, NEW.mai_to, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mask_locali,NEW.mask_locali) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MASK_LOCALI'', OLD.mask_locali, NEW.mask_locali, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.max_dias_aguarda_frete,NEW.max_dias_aguarda_frete) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MAX_DIAS_AGUARDA_FRETE'', OLD.max_dias_aguarda_frete, NEW.max_dias_aguarda_frete, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.maxdiarec,NEW.maxdiarec) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MAXDIAREC'', OLD.maxdiarec, NEW.maxdiarec, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.maxper,NEW.maxper) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MAXPER'', OLD.maxper, NEW.maxper, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.meio_abatimento,NEW.meio_abatimento) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MEIO_ABATIMENTO'', OLD.meio_abatimento, NEW.meio_abatimento, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.meio_estac,NEW.meio_estac) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MEIO_ESTAC'', OLD.meio_estac, NEW.meio_estac, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.meio_taxaservico,NEW.meio_taxaservico) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MEIO_TAXASERVICO'', OLD.meio_taxaservico, NEW.meio_taxaservico, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.meses_carteira_max,NEW.meses_carteira_max) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MESES_CARTEIRA_MAX'', OLD.meses_carteira_max, NEW.meses_carteira_max, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.meses_carteira_min,NEW.meses_carteira_min) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MESES_CARTEIRA_MIN'', OLD.meses_carteira_min, NEW.meses_carteira_min, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.metcli,NEW.metcli) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''METCLI'', OLD.metcli, NEW.metcli, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.min_abastec_cheque,NEW.min_abastec_cheque) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MIN_ABASTEC_CHEQUE'', OLD.min_abastec_cheque, NEW.min_abastec_cheque, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mostra_repasse,NEW.mostra_repasse) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOSTRA_REPASSE'', OLD.mostra_repasse, NEW.mostra_repasse, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.movest_reimp_cf,NEW.movest_reimp_cf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MOVEST_REIMP_CF'', OLD.movest_reimp_cf, NEW.movest_reimp_cf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mpf_codcfg,NEW.mpf_codcfg) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MPF_CODCFG'', OLD.mpf_codcfg, NEW.mpf_codcfg, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mpi_ecfcri,NEW.mpi_ecfcri) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MPI_ECFCRI'', OLD.mpi_ecfcri, NEW.mpi_ecfcri, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mpi_ecfmet,NEW.mpi_ecfmet) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MPI_ECFMET'', OLD.mpi_ecfmet, NEW.mpi_ecfmet, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mpi_funcri,NEW.mpi_funcri) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MPI_FUNCRI'', OLD.mpi_funcri, NEW.mpi_funcri, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mpi_funmet,NEW.mpi_funmet) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MPI_FUNMET'', OLD.mpi_funmet, NEW.mpi_funmet, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mpi_itecri,NEW.mpi_itecri) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MPI_ITECRI'', OLD.mpi_itecri, NEW.mpi_itecri, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mpi_itemet,NEW.mpi_itemet) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MPI_ITEMET'', OLD.mpi_itemet, NEW.mpi_itemet, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mpi_m2_cri,NEW.mpi_m2_cri) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MPI_M2_CRI'', OLD.mpi_m2_cri, NEW.mpi_m2_cri, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mpi_m2_met,NEW.mpi_m2_met) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MPI_M2_MET'', OLD.mpi_m2_met, NEW.mpi_m2_met, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mpi_medcri,NEW.mpi_medcri) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MPI_MEDCRI'', OLD.mpi_medcri, NEW.mpi_medcri, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mpi_medmet,NEW.mpi_medmet) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MPI_MEDMET'', OLD.mpi_medmet, NEW.mpi_medmet, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.mult_vendedores,NEW.mult_vendedores) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''MULT_VENDEDORES'', OLD.mult_vendedores, NEW.mult_vendedores, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nat_consignacao,NEW.nat_consignacao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NAT_CONSIGNACAO'', OLD.nat_consignacao, NEW.nat_consignacao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nat_creicm,NEW.nat_creicm) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NAT_CREICM'', OLD.nat_creicm, NEW.nat_creicm, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nat_fat_cc,NEW.nat_fat_cc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NAT_FAT_CC'', OLD.nat_fat_cc, NEW.nat_fat_cc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natadjudicacaoicms,NEW.natadjudicacaoicms) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATADJUDICACAOICMS'', OLD.natadjudicacaoicms, NEW.natadjudicacaoicms, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natbon,NEW.natbon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATBON'', OLD.natbon, NEW.natbon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natdectra,NEW.natdectra) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATDECTRA'', OLD.natdectra, NEW.natdectra, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natdevcomp,NEW.natdevcomp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATDEVCOMP'', OLD.natdevcomp, NEW.natdevcomp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natfat,NEW.natfat) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATFAT'', OLD.natfat, NEW.natfat, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natimp,NEW.natimp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATIMP'', OLD.natimp, NEW.natimp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natnfreci,NEW.natnfreci) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATNFRECI'', OLD.natnfreci, NEW.natnfreci, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natrecibo,NEW.natrecibo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATRECIBO'', OLD.natrecibo, NEW.natrecibo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natressarcimentost,NEW.natressarcimentost) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATRESSARCIMENTOST'', OLD.natressarcimentost, NEW.natressarcimentost, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.natven,NEW.natven) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NATVEN'', OLD.natven, NEW.natven, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nf_apos_cf,NEW.nf_apos_cf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NF_APOS_CF'', OLD.nf_apos_cf, NEW.nf_apos_cf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nomcodsac,NEW.nomcodsac) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NOMCODSAC'', OLD.nomcodsac, NEW.nomcodsac, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nome_classificacao,NEW.nome_classificacao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NOME_CLASSIFICACAO'', OLD.nome_classificacao, NEW.nome_classificacao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nomemp,NEW.nomemp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NOMEMP'', OLD.nomemp, NEW.nomemp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nomlstsac,NEW.nomlstsac) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NOMLSTSAC'', OLD.nomlstsac, NEW.nomlstsac, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nomnumreg,NEW.nomnumreg) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NOMNUMREG'', OLD.nomnumreg, NEW.nomnumreg, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.nomnumser,NEW.nomnumser) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NOMNUMSER'', OLD.nomnumser, NEW.nomnumser, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.num_itens_distr_est,NEW.num_itens_distr_est) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NUM_ITENS_DISTR_EST'', OLD.num_itens_distr_est, NEW.num_itens_distr_est, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.numven,NEW.numven) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''NUMVEN'', OLD.numven, NEW.numven, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.obrig_icms_ped,NEW.obrig_icms_ped) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OBRIG_ICMS_PED'', OLD.obrig_icms_ped, NEW.obrig_icms_ped, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.obriga_codean,NEW.obriga_codean) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OBRIGA_CODEAN'', OLD.obriga_codean, NEW.obriga_codean, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.obrpeso,NEW.obrpeso) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OBRPESO'', OLD.obrpeso, NEW.obrpeso, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.obrvol,NEW.obrvol) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''OBRVOL'', OLD.obrvol, NEW.obrvol, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.oricre,NEW.oricre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ORICRE'', OLD.oricre, NEW.oricre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.padivampliacao,NEW.padivampliacao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PADIVAMPLIACAO'', OLD.padivampliacao, NEW.padivampliacao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.padrao_comissao,NEW.padrao_comissao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PADRAO_COMISSAO'', OLD.padrao_comissao, NEW.padrao_comissao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.paestoquevenda,NEW.paestoquevenda) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAESTOQUEVENDA'', OLD.paestoquevenda, NEW.paestoquevenda, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pafecf_assina,NEW.pafecf_assina) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAFECF_ASSINA'', OLD.pafecf_assina, NEW.pafecf_assina, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pafecf_cgctot,NEW.pafecf_cgctot) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAFECF_CGCTOT'', OLD.pafecf_cgctot, NEW.pafecf_cgctot, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pafecf_nomcom,NEW.pafecf_nomcom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAFECF_NOMCOM'', OLD.pafecf_nomcom, NEW.pafecf_nomcom, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pafecf_nompaf,NEW.pafecf_nompaf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAFECF_NOMPAF'', OLD.pafecf_nompaf, NEW.pafecf_nompaf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pafecf_nrolau,NEW.pafecf_nrolau) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAFECF_NROLAU'', OLD.pafecf_nrolau, NEW.pafecf_nrolau, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pafecf_outarq,NEW.pafecf_outarq) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAFECF_OUTARQ'', OLD.pafecf_outarq, NEW.pafecf_outarq, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pafecf_priarq,NEW.pafecf_priarq) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAFECF_PRIARQ'', OLD.pafecf_priarq, NEW.pafecf_priarq, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pafecf_priarq_md5,NEW.pafecf_priarq_md5) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAFECF_PRIARQ_MD5'', OLD.pafecf_priarq_md5, NEW.pafecf_priarq_md5, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.palistadebitos,NEW.palistadebitos) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PALISTADEBITOS'', OLD.palistadebitos, NEW.palistadebitos, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.paphoamplia,NEW.paphoamplia) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAPHOAMPLIA'', OLD.paphoamplia, NEW.paphoamplia, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.paphocodamplia,NEW.paphocodamplia) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAPHOCODAMPLIA'', OLD.paphocodamplia, NEW.paphocodamplia, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.paphocodrevamp,NEW.paphocodrevamp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAPHOCODREVAMP'', OLD.paphocodrevamp, NEW.paphocodrevamp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.paphocodrevela,NEW.paphocodrevela) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAPHOCODREVELA'', OLD.paphocodrevela, NEW.paphocodrevela, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.paphoduplo,NEW.paphoduplo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAPHODUPLO'', OLD.paphoduplo, NEW.paphoduplo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.paphoetiqueta,NEW.paphoetiqueta) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAPHOETIQUETA'', OLD.paphoetiqueta, NEW.paphoetiqueta, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.paphofilamplia,NEW.paphofilamplia) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAPHOFILAMPLIA'', OLD.paphofilamplia, NEW.paphofilamplia, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.paphofilrevamp,NEW.paphofilrevamp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAPHOFILREVAMP'', OLD.paphofilrevamp, NEW.paphofilrevamp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.paphofilrevela,NEW.paphofilrevela) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAPHOFILREVELA'', OLD.paphofilrevela, NEW.paphofilrevela, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.paphofor1,NEW.paphofor1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAPHOFOR1'', OLD.paphofor1, NEW.paphofor1, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.paphofors,NEW.paphofors) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAPHOFORS'', OLD.paphofors, NEW.paphofors, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.paphoobspadrao,NEW.paphoobspadrao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAPHOOBSPADRAO'', OLD.paphoobspadrao, NEW.paphoobspadrao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.paphotempo,NEW.paphotempo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAPHOTEMPO'', OLD.paphotempo, NEW.paphotempo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.paphotiplan,NEW.paphotiplan) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAPHOTIPLAN'', OLD.paphotiplan, NEW.paphotiplan, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.paphoto,NEW.paphoto) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAPHOTO'', OLD.paphoto, NEW.paphoto, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.paphovar1,NEW.paphovar1) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAPHOVAR1'', OLD.paphovar1, NEW.paphovar1, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.paphovar2,NEW.paphovar2) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAPHOVAR2'', OLD.paphovar2, NEW.paphovar2, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.paphovar3,NEW.paphovar3) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAPHOVAR3'', OLD.paphovar3, NEW.paphovar3, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.papredatarconsumidor,NEW.papredatarconsumidor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PAPREDATARCONSUMIDOR'', OLD.papredatarconsumidor, NEW.papredatarconsumidor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.parc_cartao,NEW.parc_cartao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PARC_CARTAO'', OLD.parc_cartao, NEW.parc_cartao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.parc_cliente_transp,NEW.parc_cliente_transp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PARC_CLIENTE_TRANSP'', OLD.parc_cliente_transp, NEW.parc_cliente_transp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.parc_fornecedor,NEW.parc_fornecedor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PARC_FORNECEDOR'', OLD.parc_fornecedor, NEW.parc_fornecedor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.parc_indica_venda,NEW.parc_indica_venda) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PARC_INDICA_VENDA'', OLD.parc_indica_venda, NEW.parc_indica_venda, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.parc_marca,NEW.parc_marca) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PARC_MARCA'', OLD.parc_marca, NEW.parc_marca, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.parc_motorista,NEW.parc_motorista) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PARC_MOTORISTA'', OLD.parc_motorista, NEW.parc_motorista, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.parc_pedido,NEW.parc_pedido) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PARC_PEDIDO'', OLD.parc_pedido, NEW.parc_pedido, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.parc_representante,NEW.parc_representante) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PARC_REPRESENTANTE'', OLD.parc_representante, NEW.parc_representante, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.parc_tec_interno,NEW.parc_tec_interno) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PARC_TEC_INTERNO'', OLD.parc_tec_interno, NEW.parc_tec_interno, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.parc_tecnico_externo,NEW.parc_tecnico_externo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PARC_TECNICO_EXTERNO'', OLD.parc_tecnico_externo, NEW.parc_tecnico_externo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.parc_transportador,NEW.parc_transportador) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PARC_TRANSPORTADOR'', OLD.parc_transportador, NEW.parc_transportador, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.parc_usuario,NEW.parc_usuario) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PARC_USUARIO'', OLD.parc_usuario, NEW.parc_usuario, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.path_anexos,NEW.path_anexos) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PATH_ANEXOS'', OLD.path_anexos, NEW.path_anexos, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.path_arquivos,NEW.path_arquivos) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PATH_ARQUIVOS'', OLD.path_arquivos, NEW.path_arquivos, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.path_base,NEW.path_base) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PATH_BASE'', OLD.path_base, NEW.path_base, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.path_projetos,NEW.path_projetos) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PATH_PROJETOS'', OLD.path_projetos, NEW.path_projetos, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.path_ttsegur,NEW.path_ttsegur) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PATH_TTSEGUR'', OLD.path_ttsegur, NEW.path_ttsegur, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.patipodesconto,NEW.patipodesconto) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PATIPODESCONTO'', OLD.patipodesconto, NEW.patipodesconto, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.patiporef,NEW.patiporef) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PATIPOREF'', OLD.patiporef, NEW.patiporef, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pcoonline,NEW.pcoonline) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PCOONLINE'', OLD.pcoonline, NEW.pcoonline, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pda_codpre,NEW.pda_codpre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PDA_CODPRE'', OLD.pda_codpre, NEW.pda_codpre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pda_filpre,NEW.pda_filpre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PDA_FILPRE'', OLD.pda_filpre, NEW.pda_filpre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pda_grupo,NEW.pda_grupo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PDA_GRUPO'', OLD.pda_grupo, NEW.pda_grupo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pda_integracao,NEW.pda_integracao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PDA_INTEGRACAO'', OLD.pda_integracao, NEW.pda_integracao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pda_path_exportacao,NEW.pda_path_exportacao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PDA_PATH_EXPORTACAO'', OLD.pda_path_exportacao, NEW.pda_path_exportacao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pda_path_importacao,NEW.pda_path_importacao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PDA_PATH_IMPORTACAO'', OLD.pda_path_importacao, NEW.pda_path_importacao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pda_subgrupo,NEW.pda_subgrupo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PDA_SUBGRUPO'', OLD.pda_subgrupo, NEW.pda_subgrupo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pda_ultexp,NEW.pda_ultexp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PDA_ULTEXP'', OLD.pda_ultexp, NEW.pda_ultexp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pda_ultexp_parcial,NEW.pda_ultexp_parcial) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PDA_ULTEXP_PARCIAL'', OLD.pda_ultexp_parcial, NEW.pda_ultexp_parcial, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pda_ultimp,NEW.pda_ultimp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PDA_ULTIMP'', OLD.pda_ultimp, NEW.pda_ultimp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pedcompate,NEW.pedcompate) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PEDCOMPATE'', OLD.pedcompate, NEW.pedcompate, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pedcompde,NEW.pedcompde) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PEDCOMPDE'', OLD.pedcompde, NEW.pedcompde, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.penaut,NEW.penaut) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PENAUT'', OLD.penaut, NEW.penaut, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.per_a,NEW.per_a) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PER_A'', OLD.per_a, NEW.per_a, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.per_b,NEW.per_b) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PER_B'', OLD.per_b, NEW.per_b, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.per_c,NEW.per_c) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PER_C'', OLD.per_c, NEW.per_c, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.per_cpmf,NEW.per_cpmf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PER_CPMF'', OLD.per_cpmf, NEW.per_cpmf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.per_troca_cheque,NEW.per_troca_cheque) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PER_TROCA_CHEQUE'', OLD.per_troca_cheque, NEW.per_troca_cheque, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.per_x,NEW.per_x) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PER_X'', OLD.per_x, NEW.per_x, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.per_y,NEW.per_y) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PER_Y'', OLD.per_y, NEW.per_y, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.per_z,NEW.per_z) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PER_Z'', OLD.per_z, NEW.per_z, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.percom,NEW.percom) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERCOM'', OLD.percom, NEW.percom, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.percom_fpv,NEW.percom_fpv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERCOM_FPV'', OLD.percom_fpv, NEW.percom_fpv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.peripiata,NEW.peripiata) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERIPIATA'', OLD.peripiata, NEW.peripiata, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.peripitra,NEW.peripitra) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERIPITRA'', OLD.peripitra, NEW.peripitra, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.perir,NEW.perir) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERIR'', OLD.perir, NEW.perir, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.perparicm,NEW.perparicm) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERPARICM'', OLD.perparicm, NEW.perparicm, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.perurg_prop,NEW.perurg_prop) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PERURG_PROP'', OLD.perurg_prop, NEW.perurg_prop, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.placaabertura,NEW.placaabertura) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PLACAABERTURA'', OLD.placaabertura, NEW.placaabertura, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.plano_pgt_wor_prop,NEW.plano_pgt_wor_prop) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PLANO_PGT_WOR_PROP'', OLD.plano_pgt_wor_prop, NEW.plano_pgt_wor_prop, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pluraldec,NEW.pluraldec) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PLURALDEC'', OLD.pluraldec, NEW.pluraldec, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pluralint,NEW.pluralint) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PLURALINT'', OLD.pluralint, NEW.pluralint, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.popula_tp_cli,NEW.popula_tp_cli) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''POPULA_TP_CLI'', OLD.popula_tp_cli, NEW.popula_tp_cli, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pormtv,NEW.pormtv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PORMTV'', OLD.pormtv, NEW.pormtv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.portke,NEW.portke) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PORTKE'', OLD.portke, NEW.portke, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.prafin,NEW.prafin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRAFIN'', OLD.prafin, NEW.prafin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.prazo_ent_pedido,NEW.prazo_ent_pedido) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRAZO_ENT_PEDIDO'', OLD.prazo_ent_pedido, NEW.prazo_ent_pedido, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pre_arr_100_reais,NEW.pre_arr_100_reais) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRE_ARR_100_REAIS'', OLD.pre_arr_100_reais, NEW.pre_arr_100_reais, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pre_arr_10_centavos,NEW.pre_arr_10_centavos) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRE_ARR_10_CENTAVOS'', OLD.pre_arr_10_centavos, NEW.pre_arr_10_centavos, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pre_arr_10_reais,NEW.pre_arr_10_reais) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRE_ARR_10_REAIS'', OLD.pre_arr_10_reais, NEW.pre_arr_10_reais, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pre_arr_1_centavo,NEW.pre_arr_1_centavo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRE_ARR_1_CENTAVO'', OLD.pre_arr_1_centavo, NEW.pre_arr_1_centavo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pre_arr_1_real,NEW.pre_arr_1_real) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRE_ARR_1_REAL'', OLD.pre_arr_1_real, NEW.pre_arr_1_real, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pre_psi_100_reais,NEW.pre_psi_100_reais) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRE_PSI_100_REAIS'', OLD.pre_psi_100_reais, NEW.pre_psi_100_reais, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pre_psi_10_centavos,NEW.pre_psi_10_centavos) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRE_PSI_10_CENTAVOS'', OLD.pre_psi_10_centavos, NEW.pre_psi_10_centavos, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pre_psi_10_reais,NEW.pre_psi_10_reais) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRE_PSI_10_REAIS'', OLD.pre_psi_10_reais, NEW.pre_psi_10_reais, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pre_psi_1_centavo,NEW.pre_psi_1_centavo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRE_PSI_1_CENTAVO'', OLD.pre_psi_1_centavo, NEW.pre_psi_1_centavo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pre_psi_1_real,NEW.pre_psi_1_real) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRE_PSI_1_REAL'', OLD.pre_psi_1_real, NEW.pre_psi_1_real, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pre_psi_digito,NEW.pre_psi_digito) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRE_PSI_DIGITO'', OLD.pre_psi_digito, NEW.pre_psi_digito, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pre_psi_percentual,NEW.pre_psi_percentual) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRE_PSI_PERCENTUAL'', OLD.pre_psi_percentual, NEW.pre_psi_percentual, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pre_psi_utiliza,NEW.pre_psi_utiliza) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRE_PSI_UTILIZA'', OLD.pre_psi_utiliza, NEW.pre_psi_utiliza, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.prezer,NEW.prezer) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PREZER'', OLD.prezer, NEW.prezer, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pro_codlpc,NEW.pro_codlpc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRO_CODLPC'', OLD.pro_codlpc, NEW.pro_codlpc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.pro_contro,NEW.pro_contro) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''PRO_CONTRO'', OLD.pro_contro, NEW.pro_contro, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.rateio_frete,NEW.rateio_frete) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RATEIO_FRETE'', OLD.rateio_frete, NEW.rateio_frete, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.rbpath,NEW.rbpath) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RBPATH'', OLD.rbpath, NEW.rbpath, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.recebe_cc_individual,NEW.recebe_cc_individual) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RECEBE_CC_INDIVIDUAL'', OLD.recebe_cc_individual, NEW.recebe_cc_individual, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.recpar_devolucao,NEW.recpar_devolucao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RECPAR_DEVOLUCAO'', OLD.recpar_devolucao, NEW.recpar_devolucao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.redicmfre,NEW.redicmfre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''REDICMFRE'', OLD.redicmfre, NEW.redicmfre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.regra_clsabc,NEW.regra_clsabc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''REGRA_CLSABC'', OLD.regra_clsabc, NEW.regra_clsabc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.regra_clsxyz,NEW.regra_clsxyz) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''REGRA_CLSXYZ'', OLD.regra_clsxyz, NEW.regra_clsxyz, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.regra_codfis,NEW.regra_codfis) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''REGRA_CODFIS'', OLD.regra_codfis, NEW.regra_codfis, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.regra_media_vendas,NEW.regra_media_vendas) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''REGRA_MEDIA_VENDAS'', OLD.regra_media_vendas, NEW.regra_media_vendas, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.reserva_ent_fut,NEW.reserva_ent_fut) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RESERVA_ENT_FUT'', OLD.reserva_ent_fut, NEW.reserva_ent_fut, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.reserva_venda,NEW.reserva_venda) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RESERVA_VENDA'', OLD.reserva_venda, NEW.reserva_venda, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.restricao_vinculo,NEW.restricao_vinculo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RESTRICAO_VINCULO'', OLD.restricao_vinculo, NEW.restricao_vinculo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.reutiliza_referencia,NEW.reutiliza_referencia) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''REUTILIZA_REFERENCIA'', OLD.reutiliza_referencia, NEW.reutiliza_referencia, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.rodpre,NEW.rodpre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''RODPRE'', OLD.rodpre, NEW.rodpre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.romaneio_filial,NEW.romaneio_filial) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ROMANEIO_FILIAL'', OLD.romaneio_filial, NEW.romaneio_filial, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sac_codfun,NEW.sac_codfun) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAC_CODFUN'', OLD.sac_codfun, NEW.sac_codfun, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sac_codpri,NEW.sac_codpri) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAC_CODPRI'', OLD.sac_codpri, NEW.sac_codpri, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sac_e_mail,NEW.sac_e_mail) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAC_E_MAIL'', OLD.sac_e_mail, NEW.sac_e_mail, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sac_exige_codcws,NEW.sac_exige_codcws) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAC_EXIGE_CODCWS'', OLD.sac_exige_codcws, NEW.sac_exige_codcws, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sac_exige_codfun,NEW.sac_exige_codfun) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAC_EXIGE_CODFUN'', OLD.sac_exige_codfun, NEW.sac_exige_codfun, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sac_exige_modulo,NEW.sac_exige_modulo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAC_EXIGE_MODULO'', OLD.sac_exige_modulo, NEW.sac_exige_modulo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sac_flgsit,NEW.sac_flgsit) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAC_FLGSIT'', OLD.sac_flgsit, NEW.sac_flgsit, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sac_home_page,NEW.sac_home_page) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAC_HOME_PAGE'', OLD.sac_home_page, NEW.sac_home_page, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sac_host,NEW.sac_host) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAC_HOST'', OLD.sac_host, NEW.sac_host, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sac_mail_codusu,NEW.sac_mail_codusu) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAC_MAIL_CODUSU'', OLD.sac_mail_codusu, NEW.sac_mail_codusu, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sac_mail_filusu,NEW.sac_mail_filusu) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAC_MAIL_FILUSU'', OLD.sac_mail_filusu, NEW.sac_mail_filusu, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sac_nome,NEW.sac_nome) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAC_NOME'', OLD.sac_nome, NEW.sac_nome, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sac_porta_pop3,NEW.sac_porta_pop3) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAC_PORTA_POP3'', OLD.sac_porta_pop3, NEW.sac_porta_pop3, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sac_porta_smtp,NEW.sac_porta_smtp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAC_PORTA_SMTP'', OLD.sac_porta_smtp, NEW.sac_porta_smtp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sac_pos_venda,NEW.sac_pos_venda) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAC_POS_VENDA'', OLD.sac_pos_venda, NEW.sac_pos_venda, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sac_resposta_erro,NEW.sac_resposta_erro) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAC_RESPOSTA_ERRO'', OLD.sac_resposta_erro, NEW.sac_resposta_erro, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sac_senha_pop3,NEW.sac_senha_pop3) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAC_SENHA_POP3'', OLD.sac_senha_pop3, NEW.sac_senha_pop3, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sac_texto_libera,NEW.sac_texto_libera) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAC_TEXTO_LIBERA'', OLD.sac_texto_libera, NEW.sac_texto_libera, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sac_tipreg,NEW.sac_tipreg) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAC_TIPREG'', OLD.sac_tipreg, NEW.sac_tipreg, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sac_tipsup,NEW.sac_tipsup) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAC_TIPSUP'', OLD.sac_tipsup, NEW.sac_tipsup, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sac_userid,NEW.sac_userid) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SAC_USERID'', OLD.sac_userid, NEW.sac_userid, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.semestlote,NEW.semestlote) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEMESTLOTE'', OLD.semestlote, NEW.semestlote, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sep_fat_retira_deposito,NEW.sep_fat_retira_deposito) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEP_FAT_RETIRA_DEPOSITO'', OLD.sep_fat_retira_deposito, NEW.sep_fat_retira_deposito, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.separar_entrega,NEW.separar_entrega) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEPARAR_ENTREGA'', OLD.separar_entrega, NEW.separar_entrega, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sepmaior,NEW.sepmaior) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEPMAIOR'', OLD.sepmaior, NEW.sepmaior, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seq_papel_todos,NEW.seq_papel_todos) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQ_PAPEL_TODOS'', OLD.seq_papel_todos, NEW.seq_papel_todos, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqcta_trn,NEW.seqcta_trn) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQCTA_TRN'', OLD.seqcta_trn, NEW.seqcta_trn, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqpap_diretoria,NEW.seqpap_diretoria) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQPAP_DIRETORIA'', OLD.seqpap_diretoria, NEW.seqpap_diretoria, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqprj,NEW.seqprj) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQPRJ'', OLD.seqprj, NEW.seqprj, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqprj_pxd,NEW.seqprj_pxd) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQPRJ_PXD'', OLD.seqprj_pxd, NEW.seqprj_pxd, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.seqteq,NEW.seqteq) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SEQTEQ'', OLD.seqteq, NEW.seqteq, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.serie_fat_cc,NEW.serie_fat_cc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERIE_FAT_CC'', OLD.serie_fat_cc, NEW.serie_fat_cc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sersat,NEW.sersat) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SERSAT'', OLD.sersat, NEW.sersat, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.singuldec,NEW.singuldec) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SINGULDEC'', OLD.singuldec, NEW.singuldec, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.singulint,NEW.singulint) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SINGULINT'', OLD.singulint, NEW.singulint, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sisdfe,NEW.sisdfe) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SISDFE'', OLD.sisdfe, NEW.sisdfe, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.solicita_end_cf,NEW.solicita_end_cf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SOLICITA_END_CF'', OLD.solicita_end_cf, NEW.solicita_end_cf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.spc_parcela,NEW.spc_parcela) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SPC_PARCELA'', OLD.spc_parcela, NEW.spc_parcela, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sql_cusrep,NEW.sql_cusrep) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SQL_CUSREP'', OLD.sql_cusrep, NEW.sql_cusrep, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.srvuni,NEW.srvuni) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SRVUNI'', OLD.srvuni, NEW.srvuni, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.st_no_frete,NEW.st_no_frete) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ST_NO_FRETE'', OLD.st_no_frete, NEW.st_no_frete, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.st_pripar,NEW.st_pripar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ST_PRIPAR'', OLD.st_pripar, NEW.st_pripar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.subcodsac,NEW.subcodsac) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SUBCODSAC'', OLD.subcodsac, NEW.subcodsac, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.substt_consfi,NEW.substt_consfi) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SUBSTT_CONSFI'', OLD.substt_consfi, NEW.substt_consfi, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sugere_servicos,NEW.sugere_servicos) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SUGERE_SERVICOS'', OLD.sugere_servicos, NEW.sugere_servicos, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.sup_aprova_restricao,NEW.sup_aprova_restricao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''SUP_APROVA_RESTRICAO'', OLD.sup_aprova_restricao, NEW.sup_aprova_restricao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tamanho_observacao,NEW.tamanho_observacao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TAMANHO_OBSERVACAO'', OLD.tamanho_observacao, NEW.tamanho_observacao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tamcodlote,NEW.tamcodlote) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TAMCODLOTE'', OLD.tamcodlote, NEW.tamcodlote, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.taxa_tef_no_preco,NEW.taxa_tef_no_preco) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TAXA_TEF_NO_PRECO'', OLD.taxa_tef_no_preco, NEW.taxa_tef_no_preco, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.taxcre_preatend,NEW.taxcre_preatend) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TAXCRE_PREATEND'', OLD.taxcre_preatend, NEW.taxcre_preatend, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.taxdeb_preatend,NEW.taxdeb_preatend) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TAXDEB_PREATEND'', OLD.taxdeb_preatend, NEW.taxdeb_preatend, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.taxfin,NEW.taxfin) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TAXFIN'', OLD.taxfin, NEW.taxfin, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.taxmes,NEW.taxmes) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TAXMES'', OLD.taxmes, NEW.taxmes, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipccc_pmi,NEW.tipccc_pmi) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPCCC_PMI'', OLD.tipccc_pmi, NEW.tipccc_pmi, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipccc_rat,NEW.tipccc_rat) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPCCC_RAT'', OLD.tipccc_rat, NEW.tipccc_rat, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipcta_ecf,NEW.tipcta_ecf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPCTA_ECF'', OLD.tipcta_ecf, NEW.tipcta_ecf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipcta_trn,NEW.tipcta_trn) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPCTA_TRN'', OLD.tipcta_trn, NEW.tipcta_trn, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipdia_elasticidade,NEW.tipdia_elasticidade) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPDIA_ELASTICIDADE'', OLD.tipdia_elasticidade, NEW.tipdia_elasticidade, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipdia_fluxo,NEW.tipdia_fluxo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPDIA_FLUXO'', OLD.tipdia_fluxo, NEW.tipdia_fluxo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipdia_vdu_pp,NEW.tipdia_vdu_pp) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPDIA_VDU_PP'', OLD.tipdia_vdu_pp, NEW.tipdia_vdu_pp, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipfar,NEW.tipfar) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPFAR'', OLD.tipfar, NEW.tipfar, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tiplan_ins,NEW.tiplan_ins) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPLAN_INS'', OLD.tiplan_ins, NEW.tiplan_ins, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tiplan_ppr,NEW.tiplan_ppr) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPLAN_PPR'', OLD.tiplan_ppr, NEW.tiplan_ppr, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipo_ctr_venda,NEW.tipo_ctr_venda) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPO_CTR_VENDA'', OLD.tipo_ctr_venda, NEW.tipo_ctr_venda, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tippos,NEW.tippos) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPPOS'', OLD.tippos, NEW.tippos, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tiprtt_agenc,NEW.tiprtt_agenc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPRTT_AGENC'', OLD.tiprtt_agenc, NEW.tiprtt_agenc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tiprtt_estac,NEW.tiprtt_estac) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPRTT_ESTAC'', OLD.tiprtt_estac, NEW.tiprtt_estac, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tiprtt_rcel,NEW.tiprtt_rcel) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPRTT_RCEL'', OLD.tiprtt_rcel, NEW.tiprtt_rcel, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tiprtt_vgas,NEW.tiprtt_vgas) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPRTT_VGAS'', OLD.tiprtt_vgas, NEW.tiprtt_vgas, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tiprtt_vpre,NEW.tiprtt_vpre) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPRTT_VPRE'', OLD.tiprtt_vpre, NEW.tiprtt_vpre, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipsoft,NEW.tipsoft) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPSOFT'', OLD.tipsoft, NEW.tipsoft, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipsrv,NEW.tipsrv) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPSRV'', OLD.tipsrv, NEW.tipsrv, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tipsugpro,NEW.tipsugpro) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TIPSUGPRO'', OLD.tipsugpro, NEW.tipsugpro, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.totallecbase,NEW.totallecbase) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TOTALLECBASE'', OLD.totallecbase, NEW.totallecbase, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.totallechost,NEW.totallechost) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TOTALLECHOST'', OLD.totallechost, NEW.totallechost, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.totallecport,NEW.totallecport) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TOTALLECPORT'', OLD.totallecport, NEW.totallecport, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.transfer_codcfo,NEW.transfer_codcfo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TRANSFER_CODCFO'', OLD.transfer_codcfo, NEW.transfer_codcfo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.transfer_icm_nat,NEW.transfer_icm_nat) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TRANSFER_ICM_NAT'', OLD.transfer_icm_nat, NEW.transfer_icm_nat, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.transfer_nat,NEW.transfer_nat) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TRANSFER_NAT'', OLD.transfer_nat, NEW.transfer_nat, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.transfer_natcol,NEW.transfer_natcol) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TRANSFER_NATCOL'', OLD.transfer_natcol, NEW.transfer_natcol, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.transfer_ser,NEW.transfer_ser) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TRANSFER_SER'', OLD.transfer_ser, NEW.transfer_ser, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.transfer_sercol,NEW.transfer_sercol) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TRANSFER_SERCOL'', OLD.transfer_sercol, NEW.transfer_sercol, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.transpicm,NEW.transpicm) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TRANSPICM'', OLD.transpicm, NEW.transpicm, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.tribut_reimp_cf,NEW.tribut_reimp_cf) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TRIBUT_REIMP_CF'', OLD.tribut_reimp_cf, NEW.tribut_reimp_cf, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.troco_tef,NEW.troco_tef) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''TROCO_TEF'', OLD.troco_tef, NEW.troco_tef, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ultsac_codusu,NEW.ultsac_codusu) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ULTSAC_CODUSU'', OLD.ultsac_codusu, NEW.ultsac_codusu, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.ultsac_filusu,NEW.ultsac_filusu) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''ULTSAC_FILUSU'', OLD.ultsac_filusu, NEW.ultsac_filusu, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.une_nome_sobrenome,NEW.une_nome_sobrenome) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''UNE_NOME_SOBRENOME'', OLD.une_nome_sobrenome, NEW.une_nome_sobrenome, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.unico,NEW.unico) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''UNICO'', OLD.unico, NEW.unico, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usa_cta_transito_transf_ident,NEW.usa_cta_transito_transf_ident) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USA_CTA_TRANSITO_TRANSF_IDENT'', OLD.usa_cta_transito_transf_ident, NEW.usa_cta_transito_transf_ident, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usa_dcai_0,NEW.usa_dcai_0) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USA_DCAI_0'', OLD.usa_dcai_0, NEW.usa_dcai_0, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usa_perc_horfal,NEW.usa_perc_horfal) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USA_PERC_HORFAL'', OLD.usa_perc_horfal, NEW.usa_perc_horfal, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usa_placa_orcamento,NEW.usa_placa_orcamento) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USA_PLACA_ORCAMENTO'', OLD.usa_placa_orcamento, NEW.usa_placa_orcamento, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usa_preatendimento,NEW.usa_preatendimento) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USA_PREATENDIMENTO'', OLD.usa_preatendimento, NEW.usa_preatendimento, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usa_renegociacao_sac,NEW.usa_renegociacao_sac) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USA_RENEGOCIACAO_SAC'', OLD.usa_renegociacao_sac, NEW.usa_renegociacao_sac, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usa_vm_decisor,NEW.usa_vm_decisor) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USA_VM_DECISOR'', OLD.usa_vm_decisor, NEW.usa_vm_decisor, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usadoc,NEW.usadoc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USADOC'', OLD.usadoc, NEW.usadoc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.usostd,NEW.usostd) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''USOSTD'', OLD.usostd, NEW.usostd, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.valida_estoque_order,NEW.valida_estoque_order) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VALIDA_ESTOQUE_ORDER'', OLD.valida_estoque_order, NEW.valida_estoque_order, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.valida_numdoc,NEW.valida_numdoc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VALIDA_NUMDOC'', OLD.valida_numdoc, NEW.valida_numdoc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.valida_parc_ck,NEW.valida_parc_ck) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VALIDA_PARC_CK'', OLD.valida_parc_ck, NEW.valida_parc_ck, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.valor_aquisicao,NEW.valor_aquisicao) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VALOR_AQUISICAO'', OLD.valor_aquisicao, NEW.valor_aquisicao, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.valor_bon,NEW.valor_bon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VALOR_BON'', OLD.valor_bon, NEW.valor_bon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.valortolerancia,NEW.valortolerancia) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VALORTOLERANCIA'', OLD.valortolerancia, NEW.valortolerancia, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.valortransferencia,NEW.valortransferencia) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VALORTRANSFERENCIA'', OLD.valortransferencia, NEW.valortransferencia, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.varcus,NEW.varcus) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VARCUS'', OLD.varcus, NEW.varcus, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.variacao_custo,NEW.variacao_custo) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VARIACAO_CUSTO'', OLD.variacao_custo, NEW.variacao_custo, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vc_cliente,NEW.vc_cliente) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VC_CLIENTE'', OLD.vc_cliente, NEW.vc_cliente, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vc_codcli,NEW.vc_codcli) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VC_CODCLI'', OLD.vc_codcli, NEW.vc_codcli, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vc_codpgt,NEW.vc_codpgt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VC_CODPGT'', OLD.vc_codpgt, NEW.vc_codpgt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vc_filcli,NEW.vc_filcli) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VC_FILCLI'', OLD.vc_filcli, NEW.vc_filcli, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vc_filpgt,NEW.vc_filpgt) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VC_FILPGT'', OLD.vc_filpgt, NEW.vc_filpgt, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vc_plano,NEW.vc_plano) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VC_PLANO'', OLD.vc_plano, NEW.vc_plano, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vc_serie,NEW.vc_serie) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VC_SERIE'', OLD.vc_serie, NEW.vc_serie, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vdd_ckpatotven,NEW.vdd_ckpatotven) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VDD_CKPATOTVEN'', OLD.vdd_ckpatotven, NEW.vdd_ckpatotven, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vdd_ckpavenite,NEW.vdd_ckpavenite) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VDD_CKPAVENITE'', OLD.vdd_ckpavenite, NEW.vdd_ckpavenite, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vdd_qtdbon,NEW.vdd_qtdbon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VDD_QTDBON'', OLD.vdd_qtdbon, NEW.vdd_qtdbon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vdd_vlrven_bon,NEW.vdd_vlrven_bon) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VDD_VLRVEN_BON'', OLD.vdd_vlrven_bon, NEW.vdd_vlrven_bon, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vei_orc,NEW.vei_orc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VEI_ORC'', OLD.vei_orc, NEW.vei_orc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.venda_cc_e_outros,NEW.venda_cc_e_outros) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VENDA_CC_E_OUTROS'', OLD.venda_cc_e_outros, NEW.venda_cc_e_outros, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.venda_estrangeiro,NEW.venda_estrangeiro) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VENDA_ESTRANGEIRO'', OLD.venda_estrangeiro, NEW.venda_estrangeiro, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vende_desativados,NEW.vende_desativados) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VENDE_DESATIVADOS'', OLD.vende_desativados, NEW.vende_desativados, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vinculo_placa_orcamento,NEW.vinculo_placa_orcamento) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VINCULO_PLACA_ORCAMENTO'', OLD.vinculo_placa_orcamento, NEW.vinculo_placa_orcamento, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vldcliext,NEW.vldcliext) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VLDCLIEXT'', OLD.vldcliext, NEW.vldcliext, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vldestext,NEW.vldestext) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VLDESTEXT'', OLD.vldestext, NEW.vldestext, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vldorc,NEW.vldorc) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VLDORC'', OLD.vldorc, NEW.vldorc, WK_CODUID, ''A'');
    END IF;

    IF Equal(OLD.vlrmin_wor_prop,NEW.vlrmin_wor_prop) <> 1 THEN
       INSERT INTO TL_CFG
       (TABELA, CODTAB, DATOPE, FILUSU, CODUSU, COLUNA, DE, PARA, CODUID, OPERAD)
       VALUES
       (''TT_CFG'',NEW.CODTAB, agora(), cFilUsu, cCodUsu, ''VLRMIN_WOR_PROP'', OLD.vlrmin_wor_prop, NEW.vlrmin_wor_prop, WK_CODUID, ''A'');
    END IF;

  END IF; 
  RETURN NULL; 
END;
' language 'plpgsql';

/*-- SEQ 10868 --*/
CREATE TRIGGER TG_LOG_tt_cfg
AFTER INSERT OR UPDATE OR DELETE ON tt_cfg
FOR EACH ROW EXECUTE PROCEDURE TG_LOG_tt_cfg();



/*-- SEQ 10869 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_imu() CASCADE;

/*-- SEQ 10870 --*/
CREATE OR REPLACE FUNCTION tg_ti_imu() RETURNS TRIGGER AS '
BEGIN
  NEW.codext:=CASE WHEN RTRIM(NEW.codext) = '''' THEN NULL ELSE RTRIM(NEW.codext) END;
  NEW.sittri:=CASE WHEN RTRIM(NEW.sittri) = '''' THEN NULL ELSE RTRIM(NEW.sittri) END;
  NEW.desrps:=CASE WHEN RTRIM(NEW.desrps) = '''' THEN NULL ELSE RTRIM(NEW.desrps) END;
  NEW.codsrv:=CASE WHEN RTRIM(NEW.codsrv) = '''' THEN NULL ELSE RTRIM(NEW.codsrv) END;
  NEW.dessrv:=CASE WHEN RTRIM(NEW.dessrv) = '''' THEN NULL ELSE RTRIM(NEW.dessrv) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10871 --*/
CREATE TRIGGER tg_ti_imu
BEFORE INSERT OR UPDATE ON ti_imu
FOR EACH ROW EXECUTE PROCEDURE tg_ti_imu();


/*-- SEQ 10872 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_lim() CASCADE;

/*-- SEQ 10873 --*/
CREATE OR REPLACE FUNCTION tg_ti_lim() RETURNS TRIGGER AS '
BEGIN
  NEW.codext:=CASE WHEN RTRIM(NEW.codext) = '''' THEN NULL ELSE RTRIM(NEW.codext) END;
  NEW.tipccc:=CASE WHEN RTRIM(NEW.tipccc) = '''' THEN NULL ELSE RTRIM(NEW.tipccc) END;
  NEW.observ:=CASE WHEN RTRIM(NEW.observ) = '''' THEN NULL ELSE RTRIM(NEW.observ) END;
  NEW.despgt:=CASE WHEN RTRIM(NEW.despgt) = '''' THEN NULL ELSE RTRIM(NEW.despgt) END;
  NEW.fatend:=CASE WHEN RTRIM(NEW.fatend) = '''' THEN NULL ELSE RTRIM(NEW.fatend) END;
  NEW.codccc:=CASE WHEN RTRIM(NEW.codccc) = '''' THEN NULL ELSE RTRIM(NEW.codccc) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10874 --*/
CREATE TRIGGER tg_ti_lim
BEFORE INSERT OR UPDATE ON ti_lim
FOR EACH ROW EXECUTE PROCEDURE tg_ti_lim();


/*-- SEQ 10875 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_pag() CASCADE;

/*-- SEQ 10876 --*/
CREATE OR REPLACE FUNCTION tg_ti_pag() RETURNS TRIGGER AS '
BEGIN
  NEW.numnot:=CASE WHEN RTRIM(NEW.numnot) = '''' THEN NULL ELSE RTRIM(NEW.numnot) END;
  NEW.codfor:=CASE WHEN RTRIM(NEW.codfor) = '''' THEN NULL ELSE RTRIM(NEW.codfor) END;
  NEW.conpgt:=CASE WHEN RTRIM(NEW.conpgt) = '''' THEN NULL ELSE RTRIM(NEW.conpgt) END;
  NEW.docpgt:=CASE WHEN RTRIM(NEW.docpgt) = '''' THEN NULL ELSE RTRIM(NEW.docpgt) END;
  NEW.flgflu:=CASE WHEN RTRIM(NEW.flgflu) = '''' THEN NULL ELSE RTRIM(NEW.flgflu) END;
  NEW.dop_codext:=CASE WHEN RTRIM(NEW.dop_codext) = '''' THEN NULL ELSE RTRIM(NEW.dop_codext) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10877 --*/
CREATE TRIGGER tg_ti_pag
BEFORE INSERT OR UPDATE ON ti_pag
FOR EACH ROW EXECUTE PROCEDURE tg_ti_pag();


/*-- SEQ 10878 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_ven() CASCADE;

/*-- SEQ 10879 --*/
CREATE OR REPLACE FUNCTION tg_ti_ven() RETURNS TRIGGER AS '
BEGIN
  NEW.codcli:=CASE WHEN RTRIM(NEW.codcli) = '''' THEN NULL ELSE RTRIM(NEW.codcli) END;
  NEW.codctr:=CASE WHEN RTRIM(NEW.codctr) = '''' THEN NULL ELSE RTRIM(NEW.codctr) END;
  NEW.autent:=CASE WHEN RTRIM(NEW.autent) = '''' THEN NULL ELSE RTRIM(NEW.autent) END;
  NEW.consfi:=CASE WHEN RTRIM(NEW.consfi) = '''' THEN NULL ELSE RTRIM(NEW.consfi) END;
  NEW.emides:=CASE WHEN RTRIM(NEW.emides) = '''' THEN NULL ELSE RTRIM(NEW.emides) END;
  NEW.financ:=CASE WHEN RTRIM(NEW.financ) = '''' THEN NULL ELSE RTRIM(NEW.financ) END;
  NEW.tribut:=CASE WHEN RTRIM(NEW.tribut) = '''' THEN NULL ELSE RTRIM(NEW.tribut) END;
  NEW.ufloja:=CASE WHEN RTRIM(NEW.ufloja) = '''' THEN NULL ELSE RTRIM(NEW.ufloja) END;
  NEW.codpre:=CASE WHEN RTRIM(NEW.codpre) = '''' THEN NULL ELSE RTRIM(NEW.codpre) END;
  NEW.coddev:=CASE WHEN RTRIM(NEW.coddev) = '''' THEN NULL ELSE RTRIM(NEW.coddev) END;
  NEW.observ:=CASE WHEN RTRIM(NEW.observ) = '''' THEN NULL ELSE RTRIM(NEW.observ) END;
  NEW.codpgt:=CASE WHEN RTRIM(NEW.codpgt) = '''' THEN NULL ELSE RTRIM(NEW.codpgt) END;
  NEW.codtra:=CASE WHEN RTRIM(NEW.codtra) = '''' THEN NULL ELSE RTRIM(NEW.codtra) END;
  NEW.vincul:=CASE WHEN RTRIM(NEW.vincul) = '''' THEN NULL ELSE RTRIM(NEW.vincul) END;
  NEW.marcas:=CASE WHEN RTRIM(NEW.marcas) = '''' THEN NULL ELSE RTRIM(NEW.marcas) END;
  NEW.export:=CASE WHEN RTRIM(NEW.export) = '''' THEN NULL ELSE RTRIM(NEW.export) END;
  NEW.natden:=CASE WHEN RTRIM(NEW.natden) = '''' THEN NULL ELSE RTRIM(NEW.natden) END;
  NEW.natfor:=CASE WHEN RTRIM(NEW.natfor) = '''' THEN NULL ELSE RTRIM(NEW.natfor) END;
  NEW.codser:=CASE WHEN RTRIM(NEW.codser) = '''' THEN NULL ELSE RTRIM(NEW.codser) END;
  NEW.codgui:=CASE WHEN RTRIM(NEW.codgui) = '''' THEN NULL ELSE RTRIM(NEW.codgui) END;
  NEW.imprim:=CASE WHEN RTRIM(NEW.imprim) = '''' THEN NULL ELSE RTRIM(NEW.imprim) END;
  NEW.autint:=CASE WHEN RTRIM(NEW.autint) = '''' THEN NULL ELSE RTRIM(NEW.autint) END;
  NEW.docnfp:=CASE WHEN RTRIM(NEW.docnfp) = '''' THEN NULL ELSE RTRIM(NEW.docnfp) END;
  NEW.chavea:=CASE WHEN RTRIM(NEW.chavea) = '''' THEN NULL ELSE RTRIM(NEW.chavea) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10880 --*/
CREATE TRIGGER tg_ti_ven
BEFORE INSERT OR UPDATE ON ti_ven
FOR EACH ROW EXECUTE PROCEDURE tg_ti_ven();


/*-- SEQ 10881 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_kit() CASCADE;

/*-- SEQ 10882 --*/
CREATE OR REPLACE FUNCTION tg_ti_kit() RETURNS TRIGGER AS '
BEGIN
  NEW.tipope:=CASE WHEN RTRIM(NEW.tipope) = '''' THEN NULL ELSE RTRIM(NEW.tipope) END;
  NEW.codpro:=CASE WHEN RTRIM(NEW.codpro) = '''' THEN NULL ELSE RTRIM(NEW.codpro) END;
  NEW.codite:=CASE WHEN RTRIM(NEW.codite) = '''' THEN NULL ELSE RTRIM(NEW.codite) END;
  NEW.brinde:=CASE WHEN RTRIM(NEW.brinde) = '''' THEN NULL ELSE RTRIM(NEW.brinde) END;
  NEW.flgimp:=CASE WHEN RTRIM(NEW.flgimp) = '''' THEN NULL ELSE RTRIM(NEW.flgimp) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10883 --*/
CREATE TRIGGER tg_ti_kit
BEFORE INSERT OR UPDATE ON ti_kit
FOR EACH ROW EXECUTE PROCEDURE tg_ti_kit();


/*-- SEQ 10884 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_rec() CASCADE;

/*-- SEQ 10885 --*/
CREATE OR REPLACE FUNCTION tg_ti_rec() RETURNS TRIGGER AS '
BEGIN
  NEW.codext:=CASE WHEN RTRIM(NEW.codext) = '''' THEN NULL ELSE RTRIM(NEW.codext) END;
  NEW.codbco:=CASE WHEN RTRIM(NEW.codbco) = '''' THEN NULL ELSE RTRIM(NEW.codbco) END;
  NEW.codage:=CASE WHEN RTRIM(NEW.codage) = '''' THEN NULL ELSE RTRIM(NEW.codage) END;
  NEW.numche:=CASE WHEN RTRIM(NEW.numche) = '''' THEN NULL ELSE RTRIM(NEW.numche) END;
  NEW.numcon:=CASE WHEN RTRIM(NEW.numcon) = '''' THEN NULL ELSE RTRIM(NEW.numcon) END;
  NEW.codmoe:=CASE WHEN RTRIM(NEW.codmoe) = '''' THEN NULL ELSE RTRIM(NEW.codmoe) END;
  NEW.flgflu:=CASE WHEN RTRIM(NEW.flgflu) = '''' THEN NULL ELSE RTRIM(NEW.flgflu) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10886 --*/
CREATE TRIGGER tg_ti_rec
BEFORE INSERT OR UPDATE ON ti_rec
FOR EACH ROW EXECUTE PROCEDURE tg_ti_rec();


/*-- SEQ 10887 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_ean() CASCADE;

/*-- SEQ 10888 --*/
CREATE OR REPLACE FUNCTION tg_ti_ean() RETURNS TRIGGER AS '
BEGIN
  NEW.codext:=CASE WHEN RTRIM(NEW.codext) = '''' THEN NULL ELSE RTRIM(NEW.codext) END;
  NEW.codean:=CASE WHEN RTRIM(NEW.codean) = '''' THEN NULL ELSE RTRIM(NEW.codean) END;
  NEW.refati:=CASE WHEN RTRIM(NEW.refati) = '''' THEN NULL ELSE RTRIM(NEW.refati) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10889 --*/
CREATE TRIGGER tg_ti_ean
BEFORE INSERT OR UPDATE ON ti_ean
FOR EACH ROW EXECUTE PROCEDURE tg_ti_ean();


/*-- SEQ 10890 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_iin() CASCADE;

/*-- SEQ 10891 --*/
CREATE OR REPLACE FUNCTION tg_ti_iin() RETURNS TRIGGER AS '
BEGIN
  NEW.inv_codext:=CASE WHEN RTRIM(NEW.inv_codext) = '''' THEN NULL ELSE RTRIM(NEW.inv_codext) END;
  NEW.gra_codext:=CASE WHEN RTRIM(NEW.gra_codext) = '''' THEN NULL ELSE RTRIM(NEW.gra_codext) END;
  NEW.gra_refuni:=CASE WHEN RTRIM(NEW.gra_refuni) = '''' THEN NULL ELSE RTRIM(NEW.gra_refuni) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10892 --*/
CREATE TRIGGER tg_ti_iin
BEFORE INSERT OR UPDATE ON ti_iin
FOR EACH ROW EXECUTE PROCEDURE tg_ti_iin();


/*-- SEQ 10893 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_inv() CASCADE;

/*-- SEQ 10894 --*/
CREATE OR REPLACE FUNCTION tg_ti_inv() RETURNS TRIGGER AS '
BEGIN
  NEW.codext:=CASE WHEN RTRIM(NEW.codext) = '''' THEN NULL ELSE RTRIM(NEW.codext) END;
  NEW.apeusu:=CASE WHEN RTRIM(NEW.apeusu) = '''' THEN NULL ELSE RTRIM(NEW.apeusu) END;
  NEW.desinv:=CASE WHEN RTRIM(NEW.desinv) = '''' THEN NULL ELSE RTRIM(NEW.desinv) END;
  NEW.desest:=CASE WHEN RTRIM(NEW.desest) = '''' THEN NULL ELSE RTRIM(NEW.desest) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10895 --*/
CREATE TRIGGER tg_ti_inv
BEFORE INSERT OR UPDATE ON ti_inv
FOR EACH ROW EXECUTE PROCEDURE tg_ti_inv();


/*-- SEQ 10896 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_cam() CASCADE;

/*-- SEQ 10897 --*/
CREATE OR REPLACE FUNCTION tg_ti_cam() RETURNS TRIGGER AS '
BEGIN
  NEW.desmoe:=CASE WHEN RTRIM(NEW.desmoe) = '''' THEN NULL ELSE RTRIM(NEW.desmoe) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10898 --*/
CREATE TRIGGER tg_ti_cam
BEFORE INSERT OR UPDATE ON ti_cam
FOR EACH ROW EXECUTE PROCEDURE tg_ti_cam();


/*-- SEQ 10899 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_cfp() CASCADE;

/*-- SEQ 10900 --*/
CREATE OR REPLACE FUNCTION tg_ti_cfp() RETURNS TRIGGER AS '
BEGIN
  NEW.cfpati:=CASE WHEN RTRIM(NEW.cfpati) = '''' THEN NULL ELSE RTRIM(NEW.cfpati) END;
  NEW.descfp:=CASE WHEN RTRIM(NEW.descfp) = '''' THEN NULL ELSE RTRIM(NEW.descfp) END;
  NEW.vencon:=CASE WHEN RTRIM(NEW.vencon) = '''' THEN NULL ELSE RTRIM(NEW.vencon) END;
  NEW.venrev:=CASE WHEN RTRIM(NEW.venrev) = '''' THEN NULL ELSE RTRIM(NEW.venrev) END;
  NEW.devcon:=CASE WHEN RTRIM(NEW.devcon) = '''' THEN NULL ELSE RTRIM(NEW.devcon) END;
  NEW.devrev:=CASE WHEN RTRIM(NEW.devrev) = '''' THEN NULL ELSE RTRIM(NEW.devrev) END;
  NEW.saicon:=CASE WHEN RTRIM(NEW.saicon) = '''' THEN NULL ELSE RTRIM(NEW.saicon) END;
  NEW.sairev:=CASE WHEN RTRIM(NEW.sairev) = '''' THEN NULL ELSE RTRIM(NEW.sairev) END;
  NEW.entcon:=CASE WHEN RTRIM(NEW.entcon) = '''' THEN NULL ELSE RTRIM(NEW.entcon) END;
  NEW.entrev:=CASE WHEN RTRIM(NEW.entrev) = '''' THEN NULL ELSE RTRIM(NEW.entrev) END;
  NEW.comcon:=CASE WHEN RTRIM(NEW.comcon) = '''' THEN NULL ELSE RTRIM(NEW.comcon) END;
  NEW.comrev:=CASE WHEN RTRIM(NEW.comrev) = '''' THEN NULL ELSE RTRIM(NEW.comrev) END;
  NEW.dvccon:=CASE WHEN RTRIM(NEW.dvccon) = '''' THEN NULL ELSE RTRIM(NEW.dvccon) END;
  NEW.dvcrev:=CASE WHEN RTRIM(NEW.dvcrev) = '''' THEN NULL ELSE RTRIM(NEW.dvcrev) END;
  NEW.intcon:=CASE WHEN RTRIM(NEW.intcon) = '''' THEN NULL ELSE RTRIM(NEW.intcon) END;
  NEW.intrev:=CASE WHEN RTRIM(NEW.intrev) = '''' THEN NULL ELSE RTRIM(NEW.intrev) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10901 --*/
CREATE TRIGGER tg_ti_cfp
BEFORE INSERT OR UPDATE ON ti_cfp
FOR EACH ROW EXECUTE PROCEDURE tg_ti_cfp();


/*-- SEQ 10902 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_chr() CASCADE;

/*-- SEQ 10903 --*/
CREATE OR REPLACE FUNCTION tg_ti_chr() RETURNS TRIGGER AS '
BEGIN
  NEW.codusu:=CASE WHEN RTRIM(NEW.codusu) = '''' THEN NULL ELSE RTRIM(NEW.codusu) END;
  NEW.autori:=CASE WHEN RTRIM(NEW.autori) = '''' THEN NULL ELSE RTRIM(NEW.autori) END;
  NEW.obslog:=CASE WHEN RTRIM(NEW.obslog) = '''' THEN NULL ELSE RTRIM(NEW.obslog) END;
  NEW.cdcmc7:=CASE WHEN RTRIM(NEW.cdcmc7) = '''' THEN NULL ELSE RTRIM(NEW.cdcmc7) END;
  NEW.codcli:=CASE WHEN RTRIM(NEW.codcli) = '''' THEN NULL ELSE RTRIM(NEW.codcli) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10904 --*/
CREATE TRIGGER tg_ti_chr
BEFORE INSERT OR UPDATE ON ti_chr
FOR EACH ROW EXECUTE PROCEDURE tg_ti_chr();


/*-- SEQ 10905 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_cli() CASCADE;

/*-- SEQ 10906 --*/
CREATE OR REPLACE FUNCTION tg_ti_cli() RETURNS TRIGGER AS '
BEGIN
  NEW.codext:=CASE WHEN RTRIM(NEW.codext) = '''' THEN NULL ELSE RTRIM(NEW.codext) END;
  NEW.nomcli:=CASE WHEN RTRIM(NEW.nomcli) = '''' THEN NULL ELSE RTRIM(NEW.nomcli) END;
  NEW.ultnom:=CASE WHEN RTRIM(NEW.ultnom) = '''' THEN NULL ELSE RTRIM(NEW.ultnom) END;
  NEW.dtipdoc:=CASE WHEN RTRIM(NEW.dtipdoc) = '''' THEN NULL ELSE RTRIM(NEW.dtipdoc) END;
  NEW.insest:=CASE WHEN RTRIM(NEW.insest) = '''' THEN NULL ELSE RTRIM(NEW.insest) END;
  NEW.numdoc:=CASE WHEN RTRIM(NEW.numdoc) = '''' THEN NULL ELSE RTRIM(NEW.numdoc) END;
  NEW.categ1:=CASE WHEN RTRIM(NEW.categ1) = '''' THEN NULL ELSE RTRIM(NEW.categ1) END;
  NEW.categ2:=CASE WHEN RTRIM(NEW.categ2) = '''' THEN NULL ELSE RTRIM(NEW.categ2) END;
  NEW.categ3:=CASE WHEN RTRIM(NEW.categ3) = '''' THEN NULL ELSE RTRIM(NEW.categ3) END;
  NEW.observ:=CASE WHEN RTRIM(NEW.observ) = '''' THEN NULL ELSE RTRIM(NEW.observ) END;
  NEW.desina:=CASE WHEN RTRIM(NEW.desina) = '''' THEN NULL ELSE RTRIM(NEW.desina) END;
  NEW.conjug:=CASE WHEN RTRIM(NEW.conjug) = '''' THEN NULL ELSE RTRIM(NEW.conjug) END;
  NEW.doccon:=CASE WHEN RTRIM(NEW.doccon) = '''' THEN NULL ELSE RTRIM(NEW.doccon) END;
  NEW.telcon:=CASE WHEN RTRIM(NEW.telcon) = '''' THEN NULL ELSE RTRIM(NEW.telcon) END;
  NEW.celuco:=CASE WHEN RTRIM(NEW.celuco) = '''' THEN NULL ELSE RTRIM(NEW.celuco) END;
  NEW.e_mcon:=CASE WHEN RTRIM(NEW.e_mcon) = '''' THEN NULL ELSE RTRIM(NEW.e_mcon) END;
  NEW.nomtra:=CASE WHEN RTRIM(NEW.nomtra) = '''' THEN NULL ELSE RTRIM(NEW.nomtra) END;
  NEW.apeven:=CASE WHEN RTRIM(NEW.apeven) = '''' THEN NULL ELSE RTRIM(NEW.apeven) END;
  NEW.codcon:=CASE WHEN RTRIM(NEW.codcon) = '''' THEN NULL ELSE RTRIM(NEW.codcon) END;
  NEW.obsout:=CASE WHEN RTRIM(NEW.obsout) = '''' THEN NULL ELSE RTRIM(NEW.obsout) END;
  NEW.hompge:=CASE WHEN RTRIM(NEW.hompge) = '''' THEN NULL ELSE RTRIM(NEW.hompge) END;
  NEW.nconta:=CASE WHEN RTRIM(NEW.nconta) = '''' THEN NULL ELSE RTRIM(NEW.nconta) END;
  NEW.tracon:=CASE WHEN RTRIM(NEW.tracon) = '''' THEN NULL ELSE RTRIM(NEW.tracon) END;
  NEW.tipcon:=CASE WHEN RTRIM(NEW.tipcon) = '''' THEN NULL ELSE RTRIM(NEW.tipcon) END;
  NEW.contel:=CASE WHEN RTRIM(NEW.contel) = '''' THEN NULL ELSE RTRIM(NEW.contel) END;
  NEW.celcon:=CASE WHEN RTRIM(NEW.celcon) = '''' THEN NULL ELSE RTRIM(NEW.celcon) END;
  NEW.e_mail:=CASE WHEN RTRIM(NEW.e_mail) = '''' THEN NULL ELSE RTRIM(NEW.e_mail) END;
  NEW.endere:=CASE WHEN RTRIM(NEW.endere) = '''' THEN NULL ELSE RTRIM(NEW.endere) END;
  NEW.contat:=CASE WHEN RTRIM(NEW.contat) = '''' THEN NULL ELSE RTRIM(NEW.contat) END;
  NEW.numero:=CASE WHEN RTRIM(NEW.numero) = '''' THEN NULL ELSE RTRIM(NEW.numero) END;
  NEW.bairro:=CASE WHEN RTRIM(NEW.bairro) = '''' THEN NULL ELSE RTRIM(NEW.bairro) END;
  NEW.nomcid:=CASE WHEN RTRIM(NEW.nomcid) = '''' THEN NULL ELSE RTRIM(NEW.nomcid) END;
  NEW.regiao:=CASE WHEN RTRIM(NEW.regiao) = '''' THEN NULL ELSE RTRIM(NEW.regiao) END;
  NEW.estran:=CASE WHEN RTRIM(NEW.estran) = '''' THEN NULL ELSE RTRIM(NEW.estran) END;
  NEW.tipend:=CASE WHEN RTRIM(NEW.tipend) = '''' THEN NULL ELSE RTRIM(NEW.tipend) END;
  NEW.comple:=CASE WHEN RTRIM(NEW.comple) = '''' THEN NULL ELSE RTRIM(NEW.comple) END;
  NEW.loctra:=CASE WHEN RTRIM(NEW.loctra) = '''' THEN NULL ELSE RTRIM(NEW.loctra) END;
  NEW.codddd:=CASE WHEN RTRIM(NEW.codddd) = '''' THEN NULL ELSE RTRIM(NEW.codddd) END;
  NEW.numfon:=CASE WHEN RTRIM(NEW.numfon) = '''' THEN NULL ELSE RTRIM(NEW.numfon) END;
  NEW.numfax:=CASE WHEN RTRIM(NEW.numfax) = '''' THEN NULL ELSE RTRIM(NEW.numfax) END;
  NEW.nacion:=CASE WHEN RTRIM(NEW.nacion) = '''' THEN NULL ELSE RTRIM(NEW.nacion) END;
  NEW.cidnas:=CASE WHEN RTRIM(NEW.cidnas) = '''' THEN NULL ELSE RTRIM(NEW.cidnas) END;
  NEW.celnum:=CASE WHEN RTRIM(NEW.celnum) = '''' THEN NULL ELSE RTRIM(NEW.celnum) END;
  NEW.maispc:=CASE WHEN RTRIM(NEW.maispc) = '''' THEN NULL ELSE RTRIM(NEW.maispc) END;
  NEW.firatu:=CASE WHEN RTRIM(NEW.firatu) = '''' THEN NULL ELSE RTRIM(NEW.firatu) END;
  NEW.numcod:=CASE WHEN RTRIM(NEW.numcod) = '''' THEN NULL ELSE RTRIM(NEW.numcod) END;
  NEW.numtel:=CASE WHEN RTRIM(NEW.numtel) = '''' THEN NULL ELSE RTRIM(NEW.numtel) END;
  NEW.nomsup:=CASE WHEN RTRIM(NEW.nomsup) = '''' THEN NULL ELSE RTRIM(NEW.nomsup) END;
  NEW.endspc:=CASE WHEN RTRIM(NEW.endspc) = '''' THEN NULL ELSE RTRIM(NEW.endspc) END;
  NEW.comspc:=CASE WHEN RTRIM(NEW.comspc) = '''' THEN NULL ELSE RTRIM(NEW.comspc) END;
  NEW.desocu:=CASE WHEN RTRIM(NEW.desocu) = '''' THEN NULL ELSE RTRIM(NEW.desocu) END;
  NEW.firant:=CASE WHEN RTRIM(NEW.firant) = '''' THEN NULL ELSE RTRIM(NEW.firant) END;
  NEW.nomlo1:=CASE WHEN RTRIM(NEW.nomlo1) = '''' THEN NULL ELSE RTRIM(NEW.nomlo1) END;
  NEW.endlo1:=CASE WHEN RTRIM(NEW.endlo1) = '''' THEN NULL ELSE RTRIM(NEW.endlo1) END;
  NEW.nomlo2:=CASE WHEN RTRIM(NEW.nomlo2) = '''' THEN NULL ELSE RTRIM(NEW.nomlo2) END;
  NEW.endlo2:=CASE WHEN RTRIM(NEW.endlo2) = '''' THEN NULL ELSE RTRIM(NEW.endlo2) END;
  NEW.orired:=CASE WHEN RTRIM(NEW.orired) = '''' THEN NULL ELSE RTRIM(NEW.orired) END;
  NEW.rgconj:=CASE WHEN RTRIM(NEW.rgconj) = '''' THEN NULL ELSE RTRIM(NEW.rgconj) END;
  NEW.fircon:=CASE WHEN RTRIM(NEW.fircon) = '''' THEN NULL ELSE RTRIM(NEW.fircon) END;
  NEW.endco1:=CASE WHEN RTRIM(NEW.endco1) = '''' THEN NULL ELSE RTRIM(NEW.endco1) END;
  NEW.endco2:=CASE WHEN RTRIM(NEW.endco2) = '''' THEN NULL ELSE RTRIM(NEW.endco2) END;
  NEW.codddi:=CASE WHEN RTRIM(NEW.codddi) = '''' THEN NULL ELSE RTRIM(NEW.codddi) END;
  NEW.ddicon:=CASE WHEN RTRIM(NEW.ddicon) = '''' THEN NULL ELSE RTRIM(NEW.ddicon) END;
  NEW.endati:=CASE WHEN RTRIM(NEW.endati) = '''' THEN NULL ELSE RTRIM(NEW.endati) END;
  NEW.isento:=CASE WHEN RTRIM(NEW.isento) = '''' THEN NULL ELSE RTRIM(NEW.isento) END;
  NEW.con_doccon:=CASE WHEN RTRIM(NEW.con_doccon) = '''' THEN NULL ELSE RTRIM(NEW.con_doccon) END;
  NEW.con_retpro:=CASE WHEN RTRIM(NEW.con_retpro) = '''' THEN NULL ELSE RTRIM(NEW.con_retpro) END;
  NEW.nomrec:=CASE WHEN RTRIM(NEW.nomrec) = '''' THEN NULL ELSE RTRIM(NEW.nomrec) END;
  NEW.codct1:=CASE WHEN RTRIM(NEW.codct1) = '''' THEN NULL ELSE RTRIM(NEW.codct1) END;
  NEW.codct2:=CASE WHEN RTRIM(NEW.codct2) = '''' THEN NULL ELSE RTRIM(NEW.codct2) END;
  NEW.codct3:=CASE WHEN RTRIM(NEW.codct3) = '''' THEN NULL ELSE RTRIM(NEW.codct3) END;
  NEW.e_mfin:=CASE WHEN RTRIM(NEW.e_mfin) = '''' THEN NULL ELSE RTRIM(NEW.e_mfin) END;
  NEW.end_codext:=CASE WHEN RTRIM(NEW.end_codext) = '''' THEN NULL ELSE RTRIM(NEW.end_codext) END;
  NEW.contribuinte:=CASE WHEN RTRIM(NEW.contribuinte) = '''' THEN NULL ELSE RTRIM(NEW.contribuinte) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10907 --*/
CREATE TRIGGER tg_ti_cli
BEFORE INSERT OR UPDATE ON ti_cli
FOR EACH ROW EXECUTE PROCEDURE tg_ti_cli();


/*-- SEQ 10908 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_com() CASCADE;

/*-- SEQ 10909 --*/
CREATE OR REPLACE FUNCTION tg_ti_com() RETURNS TRIGGER AS '
BEGIN
  NEW.codfor:=CASE WHEN RTRIM(NEW.codfor) = '''' THEN NULL ELSE RTRIM(NEW.codfor) END;
  NEW.numnot:=CASE WHEN RTRIM(NEW.numnot) = '''' THEN NULL ELSE RTRIM(NEW.numnot) END;
  NEW.codmoe:=CASE WHEN RTRIM(NEW.codmoe) = '''' THEN NULL ELSE RTRIM(NEW.codmoe) END;
  NEW.moejur:=CASE WHEN RTRIM(NEW.moejur) = '''' THEN NULL ELSE RTRIM(NEW.moejur) END;
  NEW.codset:=CASE WHEN RTRIM(NEW.codset) = '''' THEN NULL ELSE RTRIM(NEW.codset) END;
  NEW.notesp:=CASE WHEN RTRIM(NEW.notesp) = '''' THEN NULL ELSE RTRIM(NEW.notesp) END;
  NEW.forfre:=CASE WHEN RTRIM(NEW.forfre) = '''' THEN NULL ELSE RTRIM(NEW.forfre) END;
  NEW.forfat:=CASE WHEN RTRIM(NEW.forfat) = '''' THEN NULL ELSE RTRIM(NEW.forfat) END;
  NEW.espdoc:=CASE WHEN RTRIM(NEW.espdoc) = '''' THEN NULL ELSE RTRIM(NEW.espdoc) END;
  NEW.conpgt:=CASE WHEN RTRIM(NEW.conpgt) = '''' THEN NULL ELSE RTRIM(NEW.conpgt) END;
  NEW.observ:=CASE WHEN RTRIM(NEW.observ) = '''' THEN NULL ELSE RTRIM(NEW.observ) END;
  NEW.obsfat:=CASE WHEN RTRIM(NEW.obsfat) = '''' THEN NULL ELSE RTRIM(NEW.obsfat) END;
  NEW.atucus:=CASE WHEN RTRIM(NEW.atucus) = '''' THEN NULL ELSE RTRIM(NEW.atucus) END;
  NEW.export:=CASE WHEN RTRIM(NEW.export) = '''' THEN NULL ELSE RTRIM(NEW.export) END;
  NEW.titcta:=CASE WHEN RTRIM(NEW.titcta) = '''' THEN NULL ELSE RTRIM(NEW.titcta) END;
  NEW.descfo:=CASE WHEN RTRIM(NEW.descfo) = '''' THEN NULL ELSE RTRIM(NEW.descfo) END;
  NEW.retirr:=CASE WHEN RTRIM(NEW.retirr) = '''' THEN NULL ELSE RTRIM(NEW.retirr) END;
  NEW.retcss:=CASE WHEN RTRIM(NEW.retcss) = '''' THEN NULL ELSE RTRIM(NEW.retcss) END;
  NEW.chavea:=CASE WHEN RTRIM(NEW.chavea) = '''' THEN NULL ELSE RTRIM(NEW.chavea) END;
  NEW.codavu:=CASE WHEN RTRIM(NEW.codavu) = '''' THEN NULL ELSE RTRIM(NEW.codavu) END;
  NEW.coddar:=CASE WHEN RTRIM(NEW.coddar) = '''' THEN NULL ELSE RTRIM(NEW.coddar) END;
  NEW.codfps:=CASE WHEN RTRIM(NEW.codfps) = '''' THEN NULL ELSE RTRIM(NEW.codfps) END;
  NEW.datstr:=CASE WHEN RTRIM(NEW.datstr) = '''' THEN NULL ELSE RTRIM(NEW.datstr) END;
  NEW.filagc:=CASE WHEN RTRIM(NEW.filagc) = '''' THEN NULL ELSE RTRIM(NEW.filagc) END;
  NEW.finnfe:=CASE WHEN RTRIM(NEW.finnfe) = '''' THEN NULL ELSE RTRIM(NEW.finnfe) END;
  NEW.natbcc:=CASE WHEN RTRIM(NEW.natbcc) = '''' THEN NULL ELSE RTRIM(NEW.natbcc) END;
  NEW.natfre:=CASE WHEN RTRIM(NEW.natfre) = '''' THEN NULL ELSE RTRIM(NEW.natfre) END;
  NEW.rateio_frete:=CASE WHEN RTRIM(NEW.rateio_frete) = '''' THEN NULL ELSE RTRIM(NEW.rateio_frete) END;
  NEW.seqagc:=CASE WHEN RTRIM(NEW.seqagc) = '''' THEN NULL ELSE RTRIM(NEW.seqagc) END;
  NEW.sitcof:=CASE WHEN RTRIM(NEW.sitcof) = '''' THEN NULL ELSE RTRIM(NEW.sitcof) END;
  NEW.sitpis:=CASE WHEN RTRIM(NEW.sitpis) = '''' THEN NULL ELSE RTRIM(NEW.sitpis) END;
  NEW.tipfre:=CASE WHEN RTRIM(NEW.tipfre) = '''' THEN NULL ELSE RTRIM(NEW.tipfre) END;
  NEW.xmlnfe:=CASE WHEN RTRIM(NEW.xmlnfe) = '''' THEN NULL ELSE RTRIM(NEW.xmlnfe) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10910 --*/
CREATE TRIGGER tg_ti_com
BEFORE INSERT OR UPDATE ON ti_com
FOR EACH ROW EXECUTE PROCEDURE tg_ti_com();


/*-- SEQ 10911 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_des() CASCADE;

/*-- SEQ 10912 --*/
CREATE OR REPLACE FUNCTION tg_ti_des() RETURNS TRIGGER AS '
BEGIN
  NEW.numped:=CASE WHEN RTRIM(NEW.numped) = '''' THEN NULL ELSE RTRIM(NEW.numped) END;
  NEW.codpro:=CASE WHEN RTRIM(NEW.codpro) = '''' THEN NULL ELSE RTRIM(NEW.codpro) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10913 --*/
CREATE TRIGGER tg_ti_des
BEFORE INSERT OR UPDATE ON ti_des
FOR EACH ROW EXECUTE PROCEDURE tg_ti_des();


/*-- SEQ 10914 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_dop() CASCADE;

/*-- SEQ 10915 --*/
CREATE OR REPLACE FUNCTION tg_ti_dop() RETURNS TRIGGER AS '
BEGIN
  NEW.codusu:=CASE WHEN RTRIM(NEW.codusu) = '''' THEN NULL ELSE RTRIM(NEW.codusu) END;
  NEW.chetro:=CASE WHEN RTRIM(NEW.chetro) = '''' THEN NULL ELSE RTRIM(NEW.chetro) END;
  NEW.numdoc:=CASE WHEN RTRIM(NEW.numdoc) = '''' THEN NULL ELSE RTRIM(NEW.numdoc) END;
  NEW.observ:=CASE WHEN RTRIM(NEW.observ) = '''' THEN NULL ELSE RTRIM(NEW.observ) END;
  NEW.codcli:=CASE WHEN RTRIM(NEW.codcli) = '''' THEN NULL ELSE RTRIM(NEW.codcli) END;
  NEW.obsint:=CASE WHEN RTRIM(NEW.obsint) = '''' THEN NULL ELSE RTRIM(NEW.obsint) END;
  NEW.titcta:=CASE WHEN RTRIM(NEW.titcta) = '''' THEN NULL ELSE RTRIM(NEW.titcta) END;
  NEW.codext:=CASE WHEN RTRIM(NEW.codext) = '''' THEN NULL ELSE RTRIM(NEW.codext) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10916 --*/
CREATE TRIGGER tg_ti_dop
BEFORE INSERT OR UPDATE ON ti_dop
FOR EACH ROW EXECUTE PROCEDURE tg_ti_dop();


/*-- SEQ 10917 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_ico() CASCADE;

/*-- SEQ 10918 --*/
CREATE OR REPLACE FUNCTION tg_ti_ico() RETURNS TRIGGER AS '
BEGIN
  NEW.numnot:=CASE WHEN RTRIM(NEW.numnot) = '''' THEN NULL ELSE RTRIM(NEW.numnot) END;
  NEW.codser:=CASE WHEN RTRIM(NEW.codser) = '''' THEN NULL ELSE RTRIM(NEW.codser) END;
  NEW.codfor:=CASE WHEN RTRIM(NEW.codfor) = '''' THEN NULL ELSE RTRIM(NEW.codfor) END;
  NEW.codmat:=CASE WHEN RTRIM(NEW.codmat) = '''' THEN NULL ELSE RTRIM(NEW.codmat) END;
  NEW.unicom:=CASE WHEN RTRIM(NEW.unicom) = '''' THEN NULL ELSE RTRIM(NEW.unicom) END;
  NEW.univen:=CASE WHEN RTRIM(NEW.univen) = '''' THEN NULL ELSE RTRIM(NEW.univen) END;
  NEW.codbus:=CASE WHEN RTRIM(NEW.codbus) = '''' THEN NULL ELSE RTRIM(NEW.codbus) END;
  NEW.codmul:=CASE WHEN RTRIM(NEW.codmul) = '''' THEN NULL ELSE RTRIM(NEW.codmul) END;
  NEW.numped:=CASE WHEN RTRIM(NEW.numped) = '''' THEN NULL ELSE RTRIM(NEW.numped) END;
  NEW.codmoe:=CASE WHEN RTRIM(NEW.codmoe) = '''' THEN NULL ELSE RTRIM(NEW.codmoe) END;
  NEW.descfo:=CASE WHEN RTRIM(NEW.descfo) = '''' THEN NULL ELSE RTRIM(NEW.descfo) END;
  NEW.lot_codext:=CASE WHEN RTRIM(NEW.lot_codext) = '''' THEN NULL ELSE RTRIM(NEW.lot_codext) END;
  NEW.codcst:=CASE WHEN RTRIM(NEW.codcst) = '''' THEN NULL ELSE RTRIM(NEW.codcst) END;
  NEW.codben:=CASE WHEN RTRIM(NEW.codben) = '''' THEN NULL ELSE RTRIM(NEW.codben) END;
  NEW.codcstdif:=CASE WHEN RTRIM(NEW.codcstdif) = '''' THEN NULL ELSE RTRIM(NEW.codcstdif) END;
  NEW.codfci:=CASE WHEN RTRIM(NEW.codfci) = '''' THEN NULL ELSE RTRIM(NEW.codfci) END;
  NEW.cstxml:=CASE WHEN RTRIM(NEW.cstxml) = '''' THEN NULL ELSE RTRIM(NEW.cstxml) END;
  NEW.natbcc:=CASE WHEN RTRIM(NEW.natbcc) = '''' THEN NULL ELSE RTRIM(NEW.natbcc) END;
  NEW.retsub:=CASE WHEN RTRIM(NEW.retsub) = '''' THEN NULL ELSE RTRIM(NEW.retsub) END;
  NEW.sitcof:=CASE WHEN RTRIM(NEW.sitcof) = '''' THEN NULL ELSE RTRIM(NEW.sitcof) END;
  NEW.sitipi:=CASE WHEN RTRIM(NEW.sitipi) = '''' THEN NULL ELSE RTRIM(NEW.sitipi) END;
  NEW.sitpis:=CASE WHEN RTRIM(NEW.sitpis) = '''' THEN NULL ELSE RTRIM(NEW.sitpis) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10919 --*/
CREATE TRIGGER tg_ti_ico
BEFORE INSERT OR UPDATE ON ti_ico
FOR EACH ROW EXECUTE PROCEDURE tg_ti_ico();


/*-- SEQ 10920 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_ive() CASCADE;

/*-- SEQ 10921 --*/
CREATE OR REPLACE FUNCTION tg_ti_ive() RETURNS TRIGGER AS '
BEGIN
  NEW.codmat:=CASE WHEN RTRIM(NEW.codmat) = '''' THEN NULL ELSE RTRIM(NEW.codmat) END;
  NEW.numext:=CASE WHEN RTRIM(NEW.numext) = '''' THEN NULL ELSE RTRIM(NEW.numext) END;
  NEW.export:=CASE WHEN RTRIM(NEW.export) = '''' THEN NULL ELSE RTRIM(NEW.export) END;
  NEW.sittri:=CASE WHEN RTRIM(NEW.sittri) = '''' THEN NULL ELSE RTRIM(NEW.sittri) END;
  NEW.nomdou:=CASE WHEN RTRIM(NEW.nomdou) = '''' THEN NULL ELSE RTRIM(NEW.nomdou) END;
  NEW.numrct:=CASE WHEN RTRIM(NEW.numrct) = '''' THEN NULL ELSE RTRIM(NEW.numrct) END;
  NEW.nompac:=CASE WHEN RTRIM(NEW.nompac) = '''' THEN NULL ELSE RTRIM(NEW.nompac) END;
  NEW.rg_pac:=CASE WHEN RTRIM(NEW.rg_pac) = '''' THEN NULL ELSE RTRIM(NEW.rg_pac) END;
  NEW.lot_codext:=CASE WHEN RTRIM(NEW.lot_codext) = '''' THEN NULL ELSE RTRIM(NEW.lot_codext) END;
  NEW.codmul:=CASE WHEN RTRIM(NEW.codmul) = '''' THEN NULL ELSE RTRIM(NEW.codmul) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10922 --*/
CREATE TRIGGER tg_ti_ive
BEFORE INSERT OR UPDATE ON ti_ive
FOR EACH ROW EXECUTE PROCEDURE tg_ti_ive();


/*-- SEQ 10923 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_lan() CASCADE;

/*-- SEQ 10924 --*/
CREATE OR REPLACE FUNCTION tg_ti_lan() RETURNS TRIGGER AS '
BEGIN
  NEW.codext:=CASE WHEN RTRIM(NEW.codext) = '''' THEN NULL ELSE RTRIM(NEW.codext) END;
  NEW.desest:=CASE WHEN RTRIM(NEW.desest) = '''' THEN NULL ELSE RTRIM(NEW.desest) END;
  NEW.tiplan:=CASE WHEN RTRIM(NEW.tiplan) = '''' THEN NULL ELSE RTRIM(NEW.tiplan) END;
  NEW.observ:=CASE WHEN RTRIM(NEW.observ) = '''' THEN NULL ELSE RTRIM(NEW.observ) END;
  NEW.numext:=CASE WHEN RTRIM(NEW.numext) = '''' THEN NULL ELSE RTRIM(NEW.numext) END;
  NEW.export:=CASE WHEN RTRIM(NEW.export) = '''' THEN NULL ELSE RTRIM(NEW.export) END;
  NEW.lot_codext:=CASE WHEN RTRIM(NEW.lot_codext) = '''' THEN NULL ELSE RTRIM(NEW.lot_codext) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10925 --*/
CREATE TRIGGER tg_ti_lan
BEFORE INSERT OR UPDATE ON ti_lan
FOR EACH ROW EXECUTE PROCEDURE tg_ti_lan();


/*-- SEQ 10926 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_nat() CASCADE;

/*-- SEQ 10927 --*/
CREATE OR REPLACE FUNCTION tg_ti_nat() RETURNS TRIGGER AS '
BEGIN
  NEW.financ:=CASE WHEN RTRIM(NEW.financ) = '''' THEN NULL ELSE RTRIM(NEW.financ) END;
  NEW.movest:=CASE WHEN RTRIM(NEW.movest) = '''' THEN NULL ELSE RTRIM(NEW.movest) END;
  NEW.natati:=CASE WHEN RTRIM(NEW.natati) = '''' THEN NULL ELSE RTRIM(NEW.natati) END;
  NEW.tribut:=CASE WHEN RTRIM(NEW.tribut) = '''' THEN NULL ELSE RTRIM(NEW.tribut) END;
  NEW.usacus:=CASE WHEN RTRIM(NEW.usacus) = '''' THEN NULL ELSE RTRIM(NEW.usacus) END;
  NEW.natred:=CASE WHEN RTRIM(NEW.natred) = '''' THEN NULL ELSE RTRIM(NEW.natred) END;
  NEW.natref:=CASE WHEN RTRIM(NEW.natref) = '''' THEN NULL ELSE RTRIM(NEW.natref) END;
  NEW.servin:=CASE WHEN RTRIM(NEW.servin) = '''' THEN NULL ELSE RTRIM(NEW.servin) END;
  NEW.natden:=CASE WHEN RTRIM(NEW.natden) = '''' THEN NULL ELSE RTRIM(NEW.natden) END;
  NEW.natfor:=CASE WHEN RTRIM(NEW.natfor) = '''' THEN NULL ELSE RTRIM(NEW.natfor) END;
  NEW.natfud:=CASE WHEN RTRIM(NEW.natfud) = '''' THEN NULL ELSE RTRIM(NEW.natfud) END;
  NEW.natfuf:=CASE WHEN RTRIM(NEW.natfuf) = '''' THEN NULL ELSE RTRIM(NEW.natfuf) END;
  NEW.nature:=CASE WHEN RTRIM(NEW.nature) = '''' THEN NULL ELSE RTRIM(NEW.nature) END;
  NEW.coment:=CASE WHEN RTRIM(NEW.coment) = '''' THEN NULL ELSE RTRIM(NEW.coment) END;
  NEW.observ:=CASE WHEN RTRIM(NEW.observ) = '''' THEN NULL ELSE RTRIM(NEW.observ) END;
  NEW.extdem:=CASE WHEN RTRIM(NEW.extdem) = '''' THEN NULL ELSE RTRIM(NEW.extdem) END;
  NEW.extfor:=CASE WHEN RTRIM(NEW.extfor) = '''' THEN NULL ELSE RTRIM(NEW.extfor) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10928 --*/
CREATE TRIGGER tg_ti_nat
BEFORE INSERT OR UPDATE ON ti_nat
FOR EACH ROW EXECUTE PROCEDURE tg_ti_nat();


/*-- SEQ 10929 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_pla() CASCADE;

/*-- SEQ 10930 --*/
CREATE OR REPLACE FUNCTION tg_ti_pla() RETURNS TRIGGER AS '
BEGIN
  NEW.codmoe:=CASE WHEN RTRIM(NEW.codmoe) = '''' THEN NULL ELSE RTRIM(NEW.codmoe) END;
  NEW.moecor:=CASE WHEN RTRIM(NEW.moecor) = '''' THEN NULL ELSE RTRIM(NEW.moecor) END;
  NEW.caronl:=CASE WHEN RTRIM(NEW.caronl) = '''' THEN NULL ELSE RTRIM(NEW.caronl) END;
  NEW.entvlr:=CASE WHEN RTRIM(NEW.entvlr) = '''' THEN NULL ELSE RTRIM(NEW.entvlr) END;
  NEW.fatura:=CASE WHEN RTRIM(NEW.fatura) = '''' THEN NULL ELSE RTRIM(NEW.fatura) END;
  NEW.flgesp:=CASE WHEN RTRIM(NEW.flgesp) = '''' THEN NULL ELSE RTRIM(NEW.flgesp) END;
  NEW.jurtot:=CASE WHEN RTRIM(NEW.jurtot) = '''' THEN NULL ELSE RTRIM(NEW.jurtot) END;
  NEW.apepgt:=CASE WHEN RTRIM(NEW.apepgt) = '''' THEN NULL ELSE RTRIM(NEW.apepgt) END;
  NEW.despgt:=CASE WHEN RTRIM(NEW.despgt) = '''' THEN NULL ELSE RTRIM(NEW.despgt) END;
  NEW.class1:=CASE WHEN RTRIM(NEW.class1) = '''' THEN NULL ELSE RTRIM(NEW.class1) END;
  NEW.class2:=CASE WHEN RTRIM(NEW.class2) = '''' THEN NULL ELSE RTRIM(NEW.class2) END;
  NEW.class3:=CASE WHEN RTRIM(NEW.class3) = '''' THEN NULL ELSE RTRIM(NEW.class3) END;
  NEW.class4:=CASE WHEN RTRIM(NEW.class4) = '''' THEN NULL ELSE RTRIM(NEW.class4) END;
  NEW.codext:=CASE WHEN RTRIM(NEW.codext) = '''' THEN NULL ELSE RTRIM(NEW.codext) END;
  NEW.usacam:=CASE WHEN RTRIM(NEW.usacam) = '''' THEN NULL ELSE RTRIM(NEW.usacam) END;
  NEW.usacre:=CASE WHEN RTRIM(NEW.usacre) = '''' THEN NULL ELSE RTRIM(NEW.usacre) END;
  NEW.usaout:=CASE WHEN RTRIM(NEW.usaout) = '''' THEN NULL ELSE RTRIM(NEW.usaout) END;
  NEW.usache:=CASE WHEN RTRIM(NEW.usache) = '''' THEN NULL ELSE RTRIM(NEW.usache) END;
  NEW.usadin:=CASE WHEN RTRIM(NEW.usadin) = '''' THEN NULL ELSE RTRIM(NEW.usadin) END;
  NEW.usatef:=CASE WHEN RTRIM(NEW.usatef) = '''' THEN NULL ELSE RTRIM(NEW.usatef) END;
  NEW.usac_c:=CASE WHEN RTRIM(NEW.usac_c) = '''' THEN NULL ELSE RTRIM(NEW.usac_c) END;
  NEW.propor:=CASE WHEN RTRIM(NEW.propor) = '''' THEN NULL ELSE RTRIM(NEW.propor) END;
  NEW.desrec:=CASE WHEN RTRIM(NEW.desrec) = '''' THEN NULL ELSE RTRIM(NEW.desrec) END;
  NEW.renego:=CASE WHEN RTRIM(NEW.renego) = '''' THEN NULL ELSE RTRIM(NEW.renego) END;
  NEW.usacpp:=CASE WHEN RTRIM(NEW.usacpp) = '''' THEN NULL ELSE RTRIM(NEW.usacpp) END;
  NEW.categ1:=CASE WHEN RTRIM(NEW.categ1) = '''' THEN NULL ELSE RTRIM(NEW.categ1) END;
  NEW.categ2:=CASE WHEN RTRIM(NEW.categ2) = '''' THEN NULL ELSE RTRIM(NEW.categ2) END;
  NEW.categ3:=CASE WHEN RTRIM(NEW.categ3) = '''' THEN NULL ELSE RTRIM(NEW.categ3) END;
  NEW.tipccc:=CASE WHEN RTRIM(NEW.tipccc) = '''' THEN NULL ELSE RTRIM(NEW.tipccc) END;
  NEW.sobneg:=CASE WHEN RTRIM(NEW.sobneg) = '''' THEN NULL ELSE RTRIM(NEW.sobneg) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10931 --*/
CREATE TRIGGER tg_ti_pla
BEFORE INSERT OR UPDATE ON ti_pla
FOR EACH ROW EXECUTE PROCEDURE tg_ti_pla();


/*-- SEQ 10932 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_pre() CASCADE;

/*-- SEQ 10933 --*/
CREATE OR REPLACE FUNCTION tg_ti_pre() RETURNS TRIGGER AS '
BEGIN
  NEW.categ1:=CASE WHEN RTRIM(NEW.categ1) = '''' THEN NULL ELSE RTRIM(NEW.categ1) END;
  NEW.categ2:=CASE WHEN RTRIM(NEW.categ2) = '''' THEN NULL ELSE RTRIM(NEW.categ2) END;
  NEW.categ3:=CASE WHEN RTRIM(NEW.categ3) = '''' THEN NULL ELSE RTRIM(NEW.categ3) END;
  NEW.codext:=CASE WHEN RTRIM(NEW.codext) = '''' THEN NULL ELSE RTRIM(NEW.codext) END;
  NEW.codmoe:=CASE WHEN RTRIM(NEW.codmoe) = '''' THEN NULL ELSE RTRIM(NEW.codmoe) END;
  NEW.despre:=CASE WHEN RTRIM(NEW.despre) = '''' THEN NULL ELSE RTRIM(NEW.despre) END;
  NEW.flgest:=CASE WHEN RTRIM(NEW.flgest) = '''' THEN NULL ELSE RTRIM(NEW.flgest) END;
  NEW.despre_codext:=CASE WHEN RTRIM(NEW.despre_codext) = '''' THEN NULL ELSE RTRIM(NEW.despre_codext) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10934 --*/
CREATE TRIGGER tg_ti_pre
BEFORE INSERT OR UPDATE ON ti_pre
FOR EACH ROW EXECUTE PROCEDURE tg_ti_pre();


/*-- SEQ 10935 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_pro() CASCADE;

/*-- SEQ 10936 --*/
CREATE OR REPLACE FUNCTION tg_ti_pro() RETURNS TRIGGER AS '
BEGIN
  NEW.codext:=CASE WHEN RTRIM(NEW.codext) = '''' THEN NULL ELSE RTRIM(NEW.codext) END;
  NEW.refbas:=CASE WHEN RTRIM(NEW.refbas) = '''' THEN NULL ELSE RTRIM(NEW.refbas) END;
  NEW.desmat:=CASE WHEN RTRIM(NEW.desmat) = '''' THEN NULL ELSE RTRIM(NEW.desmat) END;
  NEW.espmat:=CASE WHEN RTRIM(NEW.espmat) = '''' THEN NULL ELSE RTRIM(NEW.espmat) END;
  NEW.desecf:=CASE WHEN RTRIM(NEW.desecf) = '''' THEN NULL ELSE RTRIM(NEW.desecf) END;
  NEW.desmar:=CASE WHEN RTRIM(NEW.desmar) = '''' THEN NULL ELSE RTRIM(NEW.desmar) END;
  NEW.desina:=CASE WHEN RTRIM(NEW.desina) = '''' THEN NULL ELSE RTRIM(NEW.desina) END;
  NEW.class1:=CASE WHEN RTRIM(NEW.class1) = '''' THEN NULL ELSE RTRIM(NEW.class1) END;
  NEW.class2:=CASE WHEN RTRIM(NEW.class2) = '''' THEN NULL ELSE RTRIM(NEW.class2) END;
  NEW.class3:=CASE WHEN RTRIM(NEW.class3) = '''' THEN NULL ELSE RTRIM(NEW.class3) END;
  NEW.class4:=CASE WHEN RTRIM(NEW.class4) = '''' THEN NULL ELSE RTRIM(NEW.class4) END;
  NEW.depart:=CASE WHEN RTRIM(NEW.depart) = '''' THEN NULL ELSE RTRIM(NEW.depart) END;
  NEW.sazona:=CASE WHEN RTRIM(NEW.sazona) = '''' THEN NULL ELSE RTRIM(NEW.sazona) END;
  NEW.etique:=CASE WHEN RTRIM(NEW.etique) = '''' THEN NULL ELSE RTRIM(NEW.etique) END;
  NEW.observ:=CASE WHEN RTRIM(NEW.observ) = '''' THEN NULL ELSE RTRIM(NEW.observ) END;
  NEW.desgra:=CASE WHEN RTRIM(NEW.desgra) = '''' THEN NULL ELSE RTRIM(NEW.desgra) END;
  NEW.nomdiv:=CASE WHEN RTRIM(NEW.nomdiv) = '''' THEN NULL ELSE RTRIM(NEW.nomdiv) END;
  NEW.nomsub:=CASE WHEN RTRIM(NEW.nomsub) = '''' THEN NULL ELSE RTRIM(NEW.nomsub) END;
  NEW.itediv:=CASE WHEN RTRIM(NEW.itediv) = '''' THEN NULL ELSE RTRIM(NEW.itediv) END;
  NEW.itesub:=CASE WHEN RTRIM(NEW.itesub) = '''' THEN NULL ELSE RTRIM(NEW.itesub) END;
  NEW.refpro:=CASE WHEN RTRIM(NEW.refpro) = '''' THEN NULL ELSE RTRIM(NEW.refpro) END;
  NEW.obsgra:=CASE WHEN RTRIM(NEW.obsgra) = '''' THEN NULL ELSE RTRIM(NEW.obsgra) END;
  NEW.codfis:=CASE WHEN RTRIM(NEW.codfis) = '''' THEN NULL ELSE RTRIM(NEW.codfis) END;
  NEW.codtri:=CASE WHEN RTRIM(NEW.codtri) = '''' THEN NULL ELSE RTRIM(NEW.codtri) END;
  NEW.nomimg:=CASE WHEN RTRIM(NEW.nomimg) = '''' THEN NULL ELSE RTRIM(NEW.nomimg) END;
  NEW.descfp:=CASE WHEN RTRIM(NEW.descfp) = '''' THEN NULL ELSE RTRIM(NEW.descfp) END;
  NEW.codmon:=CASE WHEN RTRIM(NEW.codmon) = '''' THEN NULL ELSE RTRIM(NEW.codmon) END;
  NEW.codlpc:=CASE WHEN RTRIM(NEW.codlpc) = '''' THEN NULL ELSE RTRIM(NEW.codlpc) END;
  NEW.tiprce:=CASE WHEN RTRIM(NEW.tiprce) = '''' THEN NULL ELSE RTRIM(NEW.tiprce) END;
  NEW.sugser:=CASE WHEN RTRIM(NEW.sugser) = '''' THEN NULL ELSE RTRIM(NEW.sugser) END;
  NEW.terass:=CASE WHEN RTRIM(NEW.terass) = '''' THEN NULL ELSE RTRIM(NEW.terass) END;
  NEW.valest:=CASE WHEN RTRIM(NEW.valest) = '''' THEN NULL ELSE RTRIM(NEW.valest) END;
  NEW.contro:=CASE WHEN RTRIM(NEW.contro) = '''' THEN NULL ELSE RTRIM(NEW.contro) END;
  NEW.codfab:=CASE WHEN RTRIM(NEW.codfab) = '''' THEN NULL ELSE RTRIM(NEW.codfab) END;
  NEW.entreg:=CASE WHEN RTRIM(NEW.entreg) = '''' THEN NULL ELSE RTRIM(NEW.entreg) END;
  NEW.decima:=CASE WHEN RTRIM(NEW.decima) = '''' THEN NULL ELSE RTRIM(NEW.decima) END;
  NEW.numext:=CASE WHEN RTRIM(NEW.numext) = '''' THEN NULL ELSE RTRIM(NEW.numext) END;
  NEW.montar:=CASE WHEN RTRIM(NEW.montar) = '''' THEN NULL ELSE RTRIM(NEW.montar) END;
  NEW.retcof:=CASE WHEN RTRIM(NEW.retcof) = '''' THEN NULL ELSE RTRIM(NEW.retcof) END;
  NEW.unidad:=CASE WHEN RTRIM(NEW.unidad) = '''' THEN NULL ELSE RTRIM(NEW.unidad) END;
  NEW.unifor:=CASE WHEN RTRIM(NEW.unifor) = '''' THEN NULL ELSE RTRIM(NEW.unifor) END;
  NEW.promoc:=CASE WHEN RTRIM(NEW.promoc) = '''' THEN NULL ELSE RTRIM(NEW.promoc) END;
  NEW.voluni:=CASE WHEN RTRIM(NEW.voluni) = '''' THEN NULL ELSE RTRIM(NEW.voluni) END;
  NEW.uniemb:=CASE WHEN RTRIM(NEW.uniemb) = '''' THEN NULL ELSE RTRIM(NEW.uniemb) END;
  NEW.uniapl:=CASE WHEN RTRIM(NEW.uniapl) = '''' THEN NULL ELSE RTRIM(NEW.uniapl) END;
  NEW.forlin:=CASE WHEN RTRIM(NEW.forlin) = '''' THEN NULL ELSE RTRIM(NEW.forlin) END;
  NEW.prepsi:=CASE WHEN RTRIM(NEW.prepsi) = '''' THEN NULL ELSE RTRIM(NEW.prepsi) END;
  NEW.sitcof:=CASE WHEN RTRIM(NEW.sitcof) = '''' THEN NULL ELSE RTRIM(NEW.sitcof) END;
  NEW.sitpis:=CASE WHEN RTRIM(NEW.sitpis) = '''' THEN NULL ELSE RTRIM(NEW.sitpis) END;
  NEW.codfps:=CASE WHEN RTRIM(NEW.codfps) = '''' THEN NULL ELSE RTRIM(NEW.codfps) END;
  NEW.sitipi:=CASE WHEN RTRIM(NEW.sitipi) = '''' THEN NULL ELSE RTRIM(NEW.sitipi) END;
  NEW.codncm:=CASE WHEN RTRIM(NEW.codncm) = '''' THEN NULL ELSE RTRIM(NEW.codncm) END;
  NEW.isepis:=CASE WHEN RTRIM(NEW.isepis) = '''' THEN NULL ELSE RTRIM(NEW.isepis) END;
  NEW.icmfed:=CASE WHEN RTRIM(NEW.icmfed) = '''' THEN NULL ELSE RTRIM(NEW.icmfed) END;
  NEW.impkit:=CASE WHEN RTRIM(NEW.impkit) = '''' THEN NULL ELSE RTRIM(NEW.impkit) END;
  NEW.desdet:=CASE WHEN RTRIM(NEW.desdet) = '''' THEN NULL ELSE RTRIM(NEW.desdet) END;
  NEW.icmise:=CASE WHEN RTRIM(NEW.icmise) = '''' THEN NULL ELSE RTRIM(NEW.icmise) END;
  NEW.desweb:=CASE WHEN RTRIM(NEW.desweb) = '''' THEN NULL ELSE RTRIM(NEW.desweb) END;
  NEW.nomdiv_codext:=CASE WHEN RTRIM(NEW.nomdiv_codext) = '''' THEN NULL ELSE RTRIM(NEW.nomdiv_codext) END;
  NEW.nomsub_codext:=CASE WHEN RTRIM(NEW.nomsub_codext) = '''' THEN NULL ELSE RTRIM(NEW.nomsub_codext) END;
  NEW.nomgra_codext:=CASE WHEN RTRIM(NEW.nomgra_codext) = '''' THEN NULL ELSE RTRIM(NEW.nomgra_codext) END;
  NEW.itediv_codext:=CASE WHEN RTRIM(NEW.itediv_codext) = '''' THEN NULL ELSE RTRIM(NEW.itediv_codext) END;
  NEW.itesub_codext:=CASE WHEN RTRIM(NEW.itesub_codext) = '''' THEN NULL ELSE RTRIM(NEW.itesub_codext) END;
  NEW.usalot:=CASE WHEN RTRIM(NEW.usalot) = '''' THEN NULL ELSE RTRIM(NEW.usalot) END;
  NEW.lotonl:=CASE WHEN RTRIM(NEW.lotonl) = '''' THEN NULL ELSE RTRIM(NEW.lotonl) END;
  NEW.codces:=CASE WHEN RTRIM(NEW.codces) = '''' THEN NULL ELSE RTRIM(NEW.codces) END;
  NEW.tipmpb:=CASE WHEN RTRIM(NEW.tipmpb) = '''' THEN NULL ELSE RTRIM(NEW.tipmpb) END;
  NEW.nomsub_codsal:=CASE WHEN RTRIM(NEW.nomsub_codsal) = '''' THEN NULL ELSE RTRIM(NEW.nomsub_codsal) END;
  NEW.gra_desgra:=CASE WHEN RTRIM(NEW.gra_desgra) = '''' THEN NULL ELSE RTRIM(NEW.gra_desgra) END;
  NEW.procon:=CASE WHEN RTRIM(NEW.procon) = '''' THEN NULL ELSE RTRIM(NEW.procon) END;
  NEW.codben_00:=CASE WHEN RTRIM(NEW.codben_00) = '''' THEN NULL ELSE RTRIM(NEW.codben_00) END;
  NEW.codben_10:=CASE WHEN RTRIM(NEW.codben_10) = '''' THEN NULL ELSE RTRIM(NEW.codben_10) END;
  NEW.codben_20:=CASE WHEN RTRIM(NEW.codben_20) = '''' THEN NULL ELSE RTRIM(NEW.codben_20) END;
  NEW.codben_30:=CASE WHEN RTRIM(NEW.codben_30) = '''' THEN NULL ELSE RTRIM(NEW.codben_30) END;
  NEW.codben_40:=CASE WHEN RTRIM(NEW.codben_40) = '''' THEN NULL ELSE RTRIM(NEW.codben_40) END;
  NEW.codben_41:=CASE WHEN RTRIM(NEW.codben_41) = '''' THEN NULL ELSE RTRIM(NEW.codben_41) END;
  NEW.codben_50:=CASE WHEN RTRIM(NEW.codben_50) = '''' THEN NULL ELSE RTRIM(NEW.codben_50) END;
  NEW.codben_51:=CASE WHEN RTRIM(NEW.codben_51) = '''' THEN NULL ELSE RTRIM(NEW.codben_51) END;
  NEW.codben_60:=CASE WHEN RTRIM(NEW.codben_60) = '''' THEN NULL ELSE RTRIM(NEW.codben_60) END;
  NEW.codben_70:=CASE WHEN RTRIM(NEW.codben_70) = '''' THEN NULL ELSE RTRIM(NEW.codben_70) END;
  NEW.codben_90:=CASE WHEN RTRIM(NEW.codben_90) = '''' THEN NULL ELSE RTRIM(NEW.codben_90) END;
  NEW.aplcon:=CASE WHEN RTRIM(NEW.aplcon) = '''' THEN NULL ELSE RTRIM(NEW.aplcon) END;
  NEW.desncm:=CASE WHEN RTRIM(NEW.desncm) = '''' THEN NULL ELSE RTRIM(NEW.desncm) END;
  NEW.desces:=CASE WHEN RTRIM(NEW.desces) = '''' THEN NULL ELSE RTRIM(NEW.desces) END;
  NEW.imggru:=CASE WHEN RTRIM(NEW.imggru) = '''' THEN NULL ELSE RTRIM(NEW.imggru) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10937 --*/
CREATE TRIGGER tg_ti_pro
BEFORE INSERT OR UPDATE ON ti_pro
FOR EACH ROW EXECUTE PROCEDURE tg_ti_pro();


/*-- SEQ 10938 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_itf_ro() CASCADE;

/*-- SEQ 10939 --*/
CREATE OR REPLACE FUNCTION tg_ti_itf_ro() RETURNS TRIGGER AS '
BEGIN
  NEW.obssta:=CASE WHEN RTRIM(NEW.obssta) = '''' THEN NULL ELSE RTRIM(NEW.obssta) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10940 --*/
CREATE TRIGGER tg_ti_itf_ro
BEFORE INSERT OR UPDATE ON ti_itf_ro
FOR EACH ROW EXECUTE PROCEDURE tg_ti_itf_ro();


/*-- SEQ 10941 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_slt() CASCADE;

/*-- SEQ 10942 --*/
CREATE OR REPLACE FUNCTION tg_ti_slt() RETURNS TRIGGER AS '
BEGIN
  NEW.codext:=CASE WHEN RTRIM(NEW.codext) = '''' THEN NULL ELSE RTRIM(NEW.codext) END;
  NEW.desest:=CASE WHEN RTRIM(NEW.desest) = '''' THEN NULL ELSE RTRIM(NEW.desest) END;
  NEW.lanent:=CASE WHEN RTRIM(NEW.lanent) = '''' THEN NULL ELSE RTRIM(NEW.lanent) END;
  NEW.lansai:=CASE WHEN RTRIM(NEW.lansai) = '''' THEN NULL ELSE RTRIM(NEW.lansai) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10943 --*/
CREATE TRIGGER tg_ti_slt
BEFORE INSERT OR UPDATE ON ti_slt
FOR EACH ROW EXECUTE PROCEDURE tg_ti_slt();


/*-- SEQ 10944 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_lot() CASCADE;

/*-- SEQ 10945 --*/
CREATE OR REPLACE FUNCTION tg_ti_lot() RETURNS TRIGGER AS '
BEGIN
  NEW.codext:=CASE WHEN RTRIM(NEW.codext) = '''' THEN NULL ELSE RTRIM(NEW.codext) END;
  NEW.gra_codext:=CASE WHEN RTRIM(NEW.gra_codext) = '''' THEN NULL ELSE RTRIM(NEW.gra_codext) END;
  NEW.for_codext:=CASE WHEN RTRIM(NEW.for_codext) = '''' THEN NULL ELSE RTRIM(NEW.for_codext) END;
  NEW.numlot:=CASE WHEN RTRIM(NEW.numlot) = '''' THEN NULL ELSE RTRIM(NEW.numlot) END;
  NEW.tonali:=CASE WHEN RTRIM(NEW.tonali) = '''' THEN NULL ELSE RTRIM(NEW.tonali) END;
  NEW.tamanh:=CASE WHEN RTRIM(NEW.tamanh) = '''' THEN NULL ELSE RTRIM(NEW.tamanh) END;
  NEW.flgpon:=CASE WHEN RTRIM(NEW.flgpon) = '''' THEN NULL ELSE RTRIM(NEW.flgpon) END;
  NEW.codalt:=CASE WHEN RTRIM(NEW.codalt) = '''' THEN NULL ELSE RTRIM(NEW.codalt) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10946 --*/
CREATE TRIGGER tg_ti_lot
BEFORE INSERT OR UPDATE ON ti_lot
FOR EACH ROW EXECUTE PROCEDURE tg_ti_lot();


/*-- SEQ 10947 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_sep() CASCADE;

/*-- SEQ 10948 --*/
CREATE OR REPLACE FUNCTION tg_ti_sep() RETURNS TRIGGER AS '
BEGIN
  NEW.rom_codext:=CASE WHEN RTRIM(NEW.rom_codext) = '''' THEN NULL ELSE RTRIM(NEW.rom_codext) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10949 --*/
CREATE TRIGGER tg_ti_sep
BEFORE INSERT OR UPDATE ON ti_sep
FOR EACH ROW EXECUTE PROCEDURE tg_ti_sep();


/*-- SEQ 10950 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_rom() CASCADE;

/*-- SEQ 10951 --*/
CREATE OR REPLACE FUNCTION tg_ti_rom() RETURNS TRIGGER AS '
BEGIN
  NEW.codext:=CASE WHEN RTRIM(NEW.codext) = '''' THEN NULL ELSE RTRIM(NEW.codext) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10952 --*/
CREATE TRIGGER tg_ti_rom
BEFORE INSERT OR UPDATE ON ti_rom
FOR EACH ROW EXECUTE PROCEDURE tg_ti_rom();


/*-- SEQ 10953 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_ccc() CASCADE;

/*-- SEQ 10954 --*/
CREATE OR REPLACE FUNCTION tg_ti_ccc() RETURNS TRIGGER AS '
BEGIN
  NEW.codcli:=CASE WHEN RTRIM(NEW.codcli) = '''' THEN NULL ELSE RTRIM(NEW.codcli) END;
  NEW.numdoc:=CASE WHEN RTRIM(NEW.numdoc) = '''' THEN NULL ELSE RTRIM(NEW.numdoc) END;
  NEW.comple:=CASE WHEN RTRIM(NEW.comple) = '''' THEN NULL ELSE RTRIM(NEW.comple) END;
  NEW.atulim:=CASE WHEN RTRIM(NEW.atulim) = '''' THEN NULL ELSE RTRIM(NEW.atulim) END;
  NEW.codccc:=CASE WHEN RTRIM(NEW.codccc) = '''' THEN NULL ELSE RTRIM(NEW.codccc) END;
  NEW.desccc:=CASE WHEN RTRIM(NEW.desccc) = '''' THEN NULL ELSE RTRIM(NEW.desccc) END;
  NEW.codcob:=CASE WHEN RTRIM(NEW.codcob) = '''' THEN NULL ELSE RTRIM(NEW.codcob) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10955 --*/
CREATE TRIGGER tg_ti_ccc
BEFORE INSERT OR UPDATE ON ti_ccc
FOR EACH ROW EXECUTE PROCEDURE tg_ti_ccc();


/*-- SEQ 10956 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_sal() CASCADE;

/*-- SEQ 10957 --*/
CREATE OR REPLACE FUNCTION tg_ti_sal() RETURNS TRIGGER AS '
BEGIN
  NEW.codext:=CASE WHEN RTRIM(NEW.codext) = '''' THEN NULL ELSE RTRIM(NEW.codext) END;
  NEW.tiplan:=CASE WHEN RTRIM(NEW.tiplan) = '''' THEN NULL ELSE RTRIM(NEW.tiplan) END;
  NEW.desest:=CASE WHEN RTRIM(NEW.desest) = '''' THEN NULL ELSE RTRIM(NEW.desest) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10958 --*/
CREATE TRIGGER tg_ti_sal
BEFORE INSERT OR UPDATE ON ti_sal
FOR EACH ROW EXECUTE PROCEDURE tg_ti_sal();


/*-- SEQ 10959 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_ser() CASCADE;

/*-- SEQ 10960 --*/
CREATE OR REPLACE FUNCTION tg_ti_ser() RETURNS TRIGGER AS '
BEGIN
  NEW.divtro:=CASE WHEN RTRIM(NEW.divtro) = '''' THEN NULL ELSE RTRIM(NEW.divtro) END;
  NEW.impnot:=CASE WHEN RTRIM(NEW.impnot) = '''' THEN NULL ELSE RTRIM(NEW.impnot) END;
  NEW.restri:=CASE WHEN RTRIM(NEW.restri) = '''' THEN NULL ELSE RTRIM(NEW.restri) END;
  NEW.serati:=CASE WHEN RTRIM(NEW.serati) = '''' THEN NULL ELSE RTRIM(NEW.serati) END;
  NEW.serman:=CASE WHEN RTRIM(NEW.serman) = '''' THEN NULL ELSE RTRIM(NEW.serman) END;
  NEW.desser:=CASE WHEN RTRIM(NEW.desser) = '''' THEN NULL ELSE RTRIM(NEW.desser) END;
  NEW.dissai:=CASE WHEN RTRIM(NEW.dissai) = '''' THEN NULL ELSE RTRIM(NEW.dissai) END;
  NEW.txtent:=CASE WHEN RTRIM(NEW.txtent) = '''' THEN NULL ELSE RTRIM(NEW.txtent) END;
  NEW.txtfim:=CASE WHEN RTRIM(NEW.txtfim) = '''' THEN NULL ELSE RTRIM(NEW.txtfim) END;
  NEW.txtini:=CASE WHEN RTRIM(NEW.txtini) = '''' THEN NULL ELSE RTRIM(NEW.txtini) END;
  NEW.txtite:=CASE WHEN RTRIM(NEW.txtite) = '''' THEN NULL ELSE RTRIM(NEW.txtite) END;
  NEW.txtser:=CASE WHEN RTRIM(NEW.txtser) = '''' THEN NULL ELSE RTRIM(NEW.txtser) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10961 --*/
CREATE TRIGGER tg_ti_ser
BEFORE INSERT OR UPDATE ON ti_ser
FOR EACH ROW EXECUTE PROCEDURE tg_ti_ser();


/*-- SEQ 10962 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_usu() CASCADE;

/*-- SEQ 10963 --*/
CREATE OR REPLACE FUNCTION tg_ti_usu() RETURNS TRIGGER AS '
BEGIN
  NEW.codcli:=CASE WHEN RTRIM(NEW.codcli) = '''' THEN NULL ELSE RTRIM(NEW.codcli) END;
  NEW.permis:=CASE WHEN RTRIM(NEW.permis) = '''' THEN NULL ELSE RTRIM(NEW.permis) END;
  NEW.codctr:=CASE WHEN RTRIM(NEW.codctr) = '''' THEN NULL ELSE RTRIM(NEW.codctr) END;
  NEW.agendb:=CASE WHEN RTRIM(NEW.agendb) = '''' THEN NULL ELSE RTRIM(NEW.agendb) END;
  NEW.edindb:=CASE WHEN RTRIM(NEW.edindb) = '''' THEN NULL ELSE RTRIM(NEW.edindb) END;
  NEW.usandb:=CASE WHEN RTRIM(NEW.usandb) = '''' THEN NULL ELSE RTRIM(NEW.usandb) END;
  NEW.usandc:=CASE WHEN RTRIM(NEW.usandc) = '''' THEN NULL ELSE RTRIM(NEW.usandc) END;
  NEW.apeusu:=CASE WHEN RTRIM(NEW.apeusu) = '''' THEN NULL ELSE RTRIM(NEW.apeusu) END;
  NEW.nomusu:=CASE WHEN RTRIM(NEW.nomusu) = '''' THEN NULL ELSE RTRIM(NEW.nomusu) END;
  NEW.e_mail:=CASE WHEN RTRIM(NEW.e_mail) = '''' THEN NULL ELSE RTRIM(NEW.e_mail) END;
  NEW.visper:=CASE WHEN RTRIM(NEW.visper) = '''' THEN NULL ELSE RTRIM(NEW.visper) END;
  NEW.patndb:=CASE WHEN RTRIM(NEW.patndb) = '''' THEN NULL ELSE RTRIM(NEW.patndb) END;
  NEW.grupos:=CASE WHEN RTRIM(NEW.grupos) = '''' THEN NULL ELSE RTRIM(NEW.grupos) END;
  NEW.codset:=CASE WHEN RTRIM(NEW.codset) = '''' THEN NULL ELSE RTRIM(NEW.codset) END;
  NEW.fazenq:=CASE WHEN RTRIM(NEW.fazenq) = '''' THEN NULL ELSE RTRIM(NEW.fazenq) END;
  NEW.funcao:=CASE WHEN RTRIM(NEW.funcao) = '''' THEN NULL ELSE RTRIM(NEW.funcao) END;
  NEW.fazmon:=CASE WHEN RTRIM(NEW.fazmon) = '''' THEN NULL ELSE RTRIM(NEW.fazmon) END;
  NEW.usucob:=CASE WHEN RTRIM(NEW.usucob) = '''' THEN NULL ELSE RTRIM(NEW.usucob) END;
  NEW.cfgini:=CASE WHEN RTRIM(NEW.cfgini) = '''' THEN NULL ELSE RTRIM(NEW.cfgini) END;
  NEW.csenha:=CASE WHEN RTRIM(NEW.csenha) = '''' THEN NULL ELSE RTRIM(NEW.csenha) END;
  NEW.tipope:=CASE WHEN RTRIM(NEW.tipope) = '''' THEN NULL ELSE RTRIM(NEW.tipope) END;
  NEW.docpar:=CASE WHEN RTRIM(NEW.docpar) = '''' THEN NULL ELSE RTRIM(NEW.docpar) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10964 --*/
CREATE TRIGGER tg_ti_usu
BEFORE INSERT OR UPDATE ON ti_usu
FOR EACH ROW EXECUTE PROCEDURE tg_ti_usu();


/*-- SEQ 10965 --*/
/*-- IGNORE ERRO --*/
DROP FUNCTION tg_ti_itf() CASCADE;

/*-- SEQ 10966 --*/
CREATE OR REPLACE FUNCTION tg_ti_itf() RETURNS TRIGGER AS '
BEGIN
  NEW.nsutrn:=CASE WHEN RTRIM(NEW.nsutrn) = '''' THEN NULL ELSE RTRIM(NEW.nsutrn) END;
  NEW.obssta:=CASE WHEN RTRIM(NEW.obssta) = '''' THEN NULL ELSE RTRIM(NEW.obssta) END;
  NEW.numaut:=CASE WHEN RTRIM(NEW.numaut) = '''' THEN NULL ELSE RTRIM(NEW.numaut) END;
  NEW.cnpj:=CASE WHEN RTRIM(NEW.cnpj) = '''' THEN NULL ELSE RTRIM(NEW.cnpj) END;
  NEW.bandeira:=CASE WHEN RTRIM(NEW.bandeira) = '''' THEN NULL ELSE RTRIM(NEW.bandeira) END;
  RETURN NEW;
END;
' language 'plpgsql';

/*-- SEQ 10967 --*/
CREATE TRIGGER tg_ti_itf
BEFORE INSERT OR UPDATE ON ti_itf
FOR EACH ROW EXECUTE PROCEDURE tg_ti_itf();


/*-- ROLES --*/               
/*-- SEQ 10968 --*/            
/*-- INCLUDE DROPS254.SQL --*/ 

/*-- GRANTS --*/              
/*-- SEQ 10969 --*/            
/*-- INCLUDE GRANTS254.SQL --*/ 

